         TITLE 'IGCH010D, HOLD RESOURCE COMMAND PROCESSOR              *
                        '
IGCH010D CSECT ,                                                01S0001
@PROLOG  BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
*                                   /*
IGCH010D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARM;                  /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ADDRESS 02S0337
*                                      VECTOR TABLE                  */
         LR    ROPCAVT,RPARM                                    02S0337
*   RFY                                                         02S0338
*     RPARM UNRSTD;                 /* RELEASE THE PARAMETER REGISTER
*                                      FOR USE BY THE COMPILER       */
*   REG10=ADDR(CMDTEXT)+CMDLNGTH;   /* SET THE BASE REGISTER TO BE
*                                      USED FOR ADDRESSING AUTOMATIC
*                                      DATA WITH THE POINTER TO THE
*                                      OPERATOR CONTROL RESIDENT WORK
*                                      AREA DISPLACED BY THE AREA
*                                      USED FOR THE HOLD COMMAND AND
*                                      ITS DATA                      */
         L     @09,OPCWORK(,ROPCAVT)                            02S0339
         LA    REG10,CMDTEXT(,@09)                              02S0339
         AH    REG10,CMDLNGTH(,@09)                             02S0339
*   GEN REFS(REG10) NOSETS;                                     02S0340
*                                   /*
         USING @DATD,REG10             INFORM THE ASSEMBLER OF THE
*                                      BASE REGISTER TO BE USED FOR
*                                      ADDRESSING AUTOMATIC DATA
*   RSAVE=ADDR(OPCSAVE);            /* SET THE SAVE AREA POINTER
*                                      REGISTER WITH THE POINTER TO
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVE,OPCSAVE(,ROPCAVT)                          02S0341
*                                                               02S0342
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0342
*                                                               03S0342
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0342
*   RAVT=OPCAVTPT;                  /* SET THE BASE POINTER FOR THE
*                                      TCAM ADDRESS VECTOR TABLE     */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0342
*   ROPCE=OPCCOPCE;                 /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ELEMENT      */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0343
*   IF OCOPTCDE=OCVARY THEN                                     03S0344
         CLI   OCOPTCDE(ROPCE),X'28'                            03S0344
         BNE   @RF00344                                         03S0344
*     REG10=ADDR(CMDTEXT);          /* ON A VARY COMMAND RESET REG10
*                                      TO EIGHT INTO THE OPCTL  03S0345
*                                      WORKAREA              @OY20230*/
         L     REG10,OPCWORK(,ROPCAVT)                          03S0345
         LA    REG10,CMDTEXT(,REG10)                            03S0345
*   RETCODE=0;                      /* INITIALIZE THE RETURN CODE TO
*                                      INDICATE SUCCESSFUL PROCESSING
*                                      OF THE HOLD COMMAND           */
@RF00344 SLR   RETCODE,RETCODE                                  03S0346
*   REG00=0;                        /* INITIALIZE REGISTER ZERO (0)
*                                      TO INDICATE THAT AN      03S0347
*                                      APPROPRIATE MESSAGE NUMBER HAS
*                                      NOT BEEN DETERMINED           */
         SLR   REG00,REG00                                      03S0347
*   IF OPCRSTRT=OFF                 /* RESTART IS NOT IN PROGRESS    */
*       &OCOPTCDE^=OCVARY           /* THE HOLD COMMAND WAS     02S0348
*                                      EXTERNALLY BUILT              */
*       &OCTOTE=OFF                 /* THE INPUT IS NOT FROM TOTE    */
*       &OCMPP=OFF                  /* THE INPUT IS NOT FROM AN 02S0348
*                                      APPLICATION PROGRAM           */
*     THEN                          /* PARSE THE REMAINING OPERANDS
*                                      THAT ARE IN THE OPERATOR 02S0348
*                                      CONTROL RESIDENT WORK AREA    */
         TM    OPCRSTRT(ROPCAVT),B'00100000'                    02S0348
         BNZ   @RF00348                                         02S0348
         CLI   OCOPTCDE(ROPCE),X'28'                            02S0348
         BE    @RF00348                                         02S0348
         TM    OCTOTE(ROPCE),B'01100000'                        02S0348
         BNZ   @RF00348                                         02S0348
*                                                               03S0349
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS.PARSE: THIS SEGMENT PARSES THE REMAINING OPERANDS   */
*     /* THAT ARE IN THE OPERATOR CONTROL RESIDENT WORK AREA.        */
*     /*                                                             */
*     /***************************************************************/
*                                                               03S0349
*     DO;                                                       03S0349
*       IF CMDTEXT(1:3)='TP='       /* THE INITIAL CHARACTERS ARE
*                                      CORRECT                       */
*           &CMDLNGTH>3             /* THERE ARE OTHER OPERANDS      */
*           &CMDLNGTH<=15           /* THE COMMAND IS NOT GREATER
*                                      THAN THE MAXIMUM COMMAND 03S0350
*                                      LENGTH                        */
*         THEN                      /* CONTINUE SCANNING THE COMMAND
*                                      TEXT FOR VALID OPERANDS       */
         L     @11,OPCWORK(,ROPCAVT)                            03S0350
         CLC   CMDTEXT(3,@11),@CC01842                          03S0350
         BNE   @RF00350                                         03S0350
         LA    @07,3                                            03S0350
         LH    @05,CMDLNGTH(,@11)                               03S0350
         CR    @05,@07                                          03S0350
         BNH   @RF00350                                         03S0350
         C     @05,@CF00104                                     03S0350
         BH    @RF00350                                         03S0350
*                                                               04S0351
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS.PARSE.OPERANDS: THIS SEGMENT CONTINUES SCANNING */
*         /* THE COMMAND FOR VALID OPERANDS.                         */
*         /*                                                         */
*         /***********************************************************/
*                                                               04S0351
*         DO;                                                   04S0351
*           PTRSTOP=ADDR(CMDTEXT)+CMDLNGTH-1;/* SET THE "STOP"  04S0352
*                                      POINTER FOR THE COMMAND TEXT
*                                      SCAN                          */
         L     @01,OPCWORK(,ROPCAVT)                            04S0352
         LA    @01,CMDTEXT(,@01)                                04S0352
         ALR   @05,@01                                          04S0352
         BCTR  @05,0                                            04S0352
         LR    PTRSTOP,@05                                      04S0352
*           DO PTRCHAR=ADDR(CMDTEXT)+3 TO PTRSTOP/* SCAN THE COMMAND
*                                      AFTER "TP="                   */
*                 WHILE(SCANCHAR^=',');/* A COMMA IS NOT ENCOUNTERED */
         ALR   @01,@07                                          04S0353
         LR    PTRCHAR,@01                                      04S0353
         B     @DE00353                                         04S0353
@DL00353 CLI   SCANCHAR(PTRCHAR),C','                           04S0353
         BE    @DC00353                                         04S0353
*           END;                                                04S0354
         AL    PTRCHAR,@CF00062                                 04S0354
@DE00353 CR    PTRCHAR,PTRSTOP                                  04S0354
         BNH   @DL00353                                         04S0354
@DC00353 DS    0H                                               04S0355
*           OCBACKUP=CMDTEXT(4:PTRCHAR-ADDR(CMDTEXT));/* SAVE THE
*                                      RESOURCE NAME OPERAND         */
         MVI   OCBACKUP+1(ROPCE),C' '                           04S0355
         MVC   OCBACKUP+2(6,ROPCE),OCBACKUP+1(ROPCE)            04S0355
         L     @11,OPCWORK(,ROPCAVT)                            04S0355
         LA    @07,CMDTEXT(,@11)                                04S0355
         LR    @01,PTRCHAR                                      04S0355
         SLR   @01,@07                                          04S0355
         SL    @01,@CF00256                                     04S0355
         EX    @01,@SM01894                                     04S0355
*           IF PTRCHAR=ADDR(CMDTEXT)+CMDLNGTH/* THERE IS NO RELATIVE
*                                      LINE NUMBER OPERAND           */
*               &CMDLNGTH<=11       /* THE LENGTH OF THE RESOURCE
*                                      OPERAND DOES NOT EXCEED THE
*                                      MAXIMUM LENGTH                */
*             THEN                  /* INDICATE THAT THE COMMAND IS
*                                      NOT FOR A LINK                */
         LH    @11,CMDLNGTH(,@11)                               04S0356
         ALR   @07,@11                                          04S0356
         CR    PTRCHAR,@07                                      04S0356
         BNE   @RF00356                                         04S0356
         C     @11,@CF01844                                     04S0356
         BH    @RF00356                                         04S0356
*             OCRLN=0;              /* SET THE RELATIVE LINE NUMBER
*                                      INPUT FIELD TO ZERO           */
         MVI   OCRLN(ROPCE),X'00'                               04S0357
*           ELSE                    /* CHECK FOR A CORRECT RELATIVE
*                                      LINE NUMBER OPERAND           */
*             IF SCANCHAR=','       /* THE SCAN STOPPED ON A COMMA   */
*                 &CMDLNGTH-EVAL(PTRCHAR-ADDR(CMDTEXT))-1>0/* THE
*                                      RELATIVE LINE NUMBER OPERAND
*                                      EXISTS                        */
*                 &CMDLNGTH-EVAL(PTRCHAR-ADDR(CMDTEXT))-1<=3/* THE
*                                      RELATIVE LINE NUMBER OPERAND
*                                      LENGTH DOES NOT EXCEED THE
*                                      MAXIMUM                       */
*               THEN                /* PROCESS THE RELATIVE LINE
*                                      NUMBER OPERAND                */
         B     @RC00356                                         04S0358
@RF00356 CLI   SCANCHAR(PTRCHAR),C','                           04S0358
         BNE   @RF00358                                         04S0358
         L     @11,OPCWORK(,ROPCAVT)                            04S0358
         LA    @07,CMDTEXT(,@11)                                04S0358
         LR    @01,PTRCHAR                                      04S0358
         SLR   @01,@07                                          04S0358
         LCR   @01,@01                                          04S0358
         AH    @01,CMDLNGTH(,@11)                               04S0358
         LR    @15,@01                                          04S0358
         BCTR  @15,0                                            04S0358
         LTR   @15,@15                                          04S0358
         BNP   @RF00358                                         04S0358
         LA    @14,3                                            04S0358
         CR    @15,@14                                          04S0358
         BH    @RF00358                                         04S0358
*                                                               05S0359
*               /*****************************************************/
*               /*                                                   */
*               /* PROCESS.PARSE.OPERANDS.RELATIVE: THIS SEGMENT     */
*               /* PROCESSES THE CHARACTER RELATIVE LINE NUMBER      */
*               /* OPERAND.                                          */
*               /*                                                   */
*               /*****************************************************/
*                                                               05S0359
*               DO;                                             05S0359
*                 CHARRLN='000';    /* SET THE CHARACTER FIELD FOR
*                                      THE RELATIVE LINE NUMBER TO
*                                      CHARACTER ZEROS               */
         MVC   CHARRLN(3),@CC01846                              05S0360
*                 CHARRLN(4-(CMDLNGTH-EVAL(PTRCHAR-ADDR(CMDTEXT))-1):3)
*                     =CMDTEXT(PTRCHAR-ADDR(CMDTEXT)+1:CMDLNGTH);/*
*                                      OBTAIN THE CHARACTER RELATIVE
*                                      LINE NUMBER                   */
         LCR   @01,@01                                          05S0361
         AL    @01,@CF00062                                     05S0361
         AL    @01,@CF00256                                     05S0361
         LA    @15,CHARRLN-1(@01)                               05S0361
         SLR   @14,@01                                          05S0361
         LCR   @07,@07                                          05S0361
         ALR   @07,PTRCHAR                                      05S0361
         ALR   @11,@07                                          05S0361
         EX    @14,@SM01896                                     05S0361
*                 DO PTRCHAR=ADDR(CHARRLN) TO ADDR(CHARRLN)+LENGTH(
*                       CHARRLN)    /* SCAN THE RELATIVE LINE NUMBER
*                                      OPERAND                       */
*                       WHILE(RETCODE=0);/* THE CHARACTERS ARE  05S0362
*                                      NUMERIC                       */
         LA    PTRCHAR,CHARRLN                                  05S0362
         B     @DE00362                                         05S0362
@DL00362 LTR   RETCODE,RETCODE                                  05S0362
         BNZ   @DC00362                                         05S0362
*                   IF SCANCHAR<'0'|SCANCHAR>'9'/* THE CHARACTER IS
*                                      NOT NUMERIC                   */
*                     THEN          /* INDICATE THAT AN INVALID 05S0363
*                                      OPERAND HAS BEEN ENCOUNTERED  */
         CLI   SCANCHAR(PTRCHAR),C'0'                           05S0363
         BL    @RT00363                                         05S0363
         CLI   SCANCHAR(PTRCHAR),C'9'                           05S0363
         BNH   @RF00363                                         05S0363
@RT00363 DS    0H                                               05S0364
*                     DO;                                       05S0364
*                       RETCODE=4;  /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        05S0365
*                       REG00=MSGINVOP;/* SET REGISTER ZERO (0) WITH
*                                      THE APPROPRIATE MESSAGE NUMBER*/
         LA    REG00,18                                         05S0366
*                     END;                                      05S0367
*                 END;                                          05S0368
@RF00363 AL    PTRCHAR,@CF00062                                 05S0368
@DE00362 LA    @11,CHARRLN                                      05S0368
         AL    @11,@CF00075                                     05S0368
         CR    PTRCHAR,@11                                      05S0368
         BNH   @DL00362                                         05S0368
@DC00362 DS    0H                                               05S0369
*                 IF RETCODE=0      /* THE RELATIVE LINE NUMBER IS
*                                      NUMERICS                      */
*                   THEN            /* CONVERT THE CHARACTER RELATIVE
*                                      LINE NUMBER                   */
         SLR   @11,@11                                          05S0369
         CR    RETCODE,@11                                      05S0369
         BNE   @RF00369                                         05S0369
*                                                               06S0370
*                   /*************************************************/
*                   /*                                               */
*                   /* PROCESS.PARSE.OPERANDS.RELATIVE.CONVERT: THIS */
*                   /* SEGMENT CONVERTS THE CHARACTER RELATIVE LINE  */
*                   /* NUMBER TO A POSITIVE BINARY INTEGER.          */
*                   /*                                               */
*                   /*************************************************/
*                                                               06S0370
*                   DO;                                         06S0370
*                     PACK(PACKRLN,CHARRLN);/* PACK THE RELATIVE LINE
*                                      NUMBER                        */
         PACK  PACKRLN(2),CHARRLN(3)                            06S0371
*                     CVB(FIXEDRLN,PACKRLN);/* CONVERT THE PACKED
*                                      RELATIVE LINE NUMBER TO A
*                                      BINARY FIXED-POINT INTEGER    */
         XC    @TS00001(8),@TS00001                             06S0372
         MVC   @TS00001+6(2),PACKRLN                            06S0372
         CVB   FIXEDRLN,@TS00001                                06S0372
*                     IF FIXEDRLN>0&FIXEDRLN<=255/* TEST FOR A  06S0373
*                                      RELATIVE LINE NUMBER THAT IS
*                                      IN RANGE                      */
*                       THEN        /* SET THE RELATIVE LINE NUMBER
*                                      INPUT FIELD                   */
         CR    FIXEDRLN,@11                                     06S0373
         BNH   @RF00373                                         06S0373
         C     FIXEDRLN,@CF01850                                06S0373
         BH    @RF00373                                         06S0373
*                       OCRLN=FIXEDRLN;                         06S0374
         STC   FIXEDRLN,OCRLN(,ROPCE)                           06S0374
*                     ELSE          /* INDICATE THAT AN INVALID 06S0375
*                                      OPERAND WAS ENCOUNTERED       */
*                       DO;                                     06S0375
         B     @RC00373                                         06S0375
@RF00373 DS    0H                                               06S0376
*                         RETCODE=4;/* SET THE RETURN CODE           */
         LA    RETCODE,4                                        06S0376
*                         REG00=MSGINVOP;/* SET REGISTER ZERO (0)
*                                      WITH THE APPROPRIATE MESSAGE
*                                      NUMBER                        */
         LA    REG00,18                                         06S0377
*                       END;                                    06S0378
*                   END;                                        06S0379
*               END;                                            05S0380
*             ELSE                  /* INDICATE THAT AN INVALID 04S0381
*                                      OPERAND WAS ENCOUNTERED       */
*               DO;                                             04S0381
         B     @RC00358                                         04S0381
@RF00358 DS    0H                                               04S0382
*                 RETCODE=4;        /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        04S0382
*                 REG00=MSGINVOP;   /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,18                                         04S0383
*               END;                                            04S0384
*         END;                                                  04S0385
*       ELSE                        /* INDICATE THAT AN ERROR HAS
*                                      BEEN DETECTED                 */
*         DO;                                                   03S0386
         B     @RC00350                                         03S0386
@RF00350 DS    0H                                               03S0387
*           RETCODE=4;              /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        03S0387
*           REG00=MSGINVOP;         /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,18                                         03S0388
*         END;                                                  03S0389
*     END;                                                      03S0390
@RC00350 DS    0H                                               03S0391
*   IF RETCODE=0                    /* NO ERRORS HAVE BEEN      02S0391
*                                      ENCOUNTERED                   */
*     THEN                          /* VERIFY THAT THE RESOURCE CAN
*                                      BE HELD AND CONTINUE     02S0391
*                                      PROCESSING                    */
@RF00348 LTR   RETCODE,RETCODE                                  02S0391
         BNZ   @RF00391                                         02S0391
*     DO;                                                       02S0392
*                                                               03S0393
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.VERIFY: THIS SEGMENT VERIFIES THAT THE OPERANDS   */
*       /* DESCRIBE A RESOURCE THAT IS KNOWN TO TCAM AND THAT THE    */
*       /* RESOURCE TYPE CAN BE HELD.                                */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0393
*       DO;                                                     03S0393
*         OPCDOUBL=OCBACKUP;        /* SET THE ARGUMENT FOR THE 03S0394
*                                      EXTERNAL ROUTINES THAT VERIFY
*                                      THE RESOURCE NAME             */
         MVC   OPCDOUBL(8,ROPCAVT),OCBACKUP(ROPCE)              03S0394
*                                                               04S0395
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS.VERIFY.NAME: THIS SEGMENT VERIFIES THAT THE     */
*         /* RESOURCE NAME IS KNOWN TO TCAM.                         */
*         /*                                                         */
*         /***********************************************************/
*                                                               04S0395
*         DO;                                                   04S0395
*           RFY                                                 04S0396
*             REG01 RSTD;           /* RESTRICT THE REGISTER THAT
*                                      WILL CONTAIN THE RESULT FROM
*                                      THE TRMOFLOC EXTERNAL ROUTINE */
*           CALL TRMOFLOC;          /* CHECK THE RESOURCE NAME       */
         L     @15,OPCTOFLK(,ROPCAVT)                           04S0397
         BALR  @14,@15                                          04S0397
*TRMOGOOD:                          /* (REG14+0)                     */
*           GO TO AFTERTRM;         /* CONTINUE THE VERIFICATION
*                                      PROCESSING                    */
         B     AFTERTRM                                         04S0398
*TRMOFBAD:                          /* (REG14+4)                     */
*           RETCODE=32;             /* SET THE RETURN CODE TO   04S0399
*                                      INDICATE THAT THE RESOURCE IS
*                                      UNKNOWN TO TCAM               */
TRMOFBAD LA    RETCODE,32                                       04S0399
*           REG00=16;               /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,16                                         04S0400
*                                                               05S0401
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.VERIFY.NAMERLN: THIS SEGMENT VERIFIES THAT THE*/
*           /* LINEGROUP NAME AND RELATIVE LINE NUMBER COMBINATION IS*/
*           /* KNOWN TO TCAM.                                        */
*           /*                                                       */
*           /*********************************************************/
*                                                               05S0401
*           DO;                                                 05S0401
*             RFY                                               05S0402
*               REG01 RSTD;         /* RESTRICT THE ARGUMENT REGISTER*/
*             REG01=OCRLN;          /* SET THE RELAIVE LINE NUMBER
*                                      ARGUMENT                      */
         SLR   REG01,REG01                                      05S0403
         IC    REG01,OCRLN(,ROPCE)                              05S0403
*             RFY                                               05S0404
*               REG00 RSTD;         /* RESTRICT THE REGISTER THAT
*                                      WILL CONTAIN THE RESULT FROM
*                                      THE DCBLOCAT EXTERNAL ROUTINE */
*             CALL DCBLOCAT;                                    05S0405
         L     @15,OPCDCBLK(,ROPCAVT)                           05S0405
         BALR  @14,@15                                          05S0405
*DCBLGOOD:                          /* (REG14+0)                     */
*             GO TO AFTERDCB;       /* CONTINUE THE VERIFICATION
*                                      PROCESSING                    */
         B     AFTERDCB                                         05S0406
*DCBLOBAD:                          /* (REG14+4)                     */
*             RETCODE=32;           /* SET THE RETURN CODE TO   05S0407
*                                      INDICATE THAT THE RESOURCE IS
*                                      NOT KNOWN TO TCAM             */
DCBLOBAD LA    RETCODE,32                                       05S0407
*             REG00=16;             /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,16                                         05S0408
*             GO TO ENDNAMER;                                   05S0409
         B     ENDNAMER                                         05S0409
*AFTERDCB:                                                      05S0410
*             RETCODE=0;            /* GOOD RETURN           @YM08564*/
AFTERDCB SLR   RETCODE,RETCODE                                  05S0410
*             RTRM=REG00;           /* SET THE BASE POINTER FOR THE
*                                      RESOURCE ENTRY STRUCTURE      */
         LR    RTRM,REG00                                       05S0411
*             REG00=0;              /* INDICATE THAT NO MESSAGE 05S0412
*                                      NUMBER HAS BEEN SET           */
         SLR   REG00,REG00                                      05S0412
*           END;                                                05S0413
*           GO TO ENDNAMER;         /*                       @YM08564*/
         B     ENDNAMER                                         04S0414
*AFTERTRM:                                                      04S0415
*           RTRM=REG01;             /* SET THE BASE POINTER FOR THE
*                                      RESOURCE ENTRY STRUCTURE      */
AFTERTRM LR    RTRM,REG01                                       04S0415
*           RFY                                                 04S0416
*             REG01 UNRSTD;         /* RELEASE THE RESULT REGISTER   */
*           REG00=0;                /* INDICATE THAT NO MESSAGE 04S0417
*                                      NUMBER HAS BEEN SET           */
         SLR   REG00,REG00                                      04S0417
*ENDNAMER:                          /*                       @YM08564*/
*         END;                                                  04S0418
ENDNAMER DS    0H                                               04S0419
*         IF RETCODE=0              /* NO ERRORS HAVE BEEN FOUND     */
*           THEN                    /* VERIFY THAT THE RESOURCE TYPE
*                                      CAN BE HELD AND CONTINUE 03S0419
*                                      PROCESSING                    */
         LTR   RETCODE,RETCODE                                  03S0419
         BNZ   @RF00419                                         03S0419
*                                                               04S0420
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.VERIFY.TYPE: THIS SEGMENT VERIFIES THAT THE   */
*           /* RESOURCE TYPE CAN BE HELD.                            */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0420
*           DO;                                                 04S0420
*             IF TRMLIST=ON         /* LIST ENTRY                    */
*                 |TRMPROC=ON       /* PROCESS ENTRY                 */
*                 |TRMPREF=ON&(TRMTYPE=TRMGRP|TRMTYPE=TRMLNCP|TRMTYPE=
*                 TRMSSCP|TRMTYPE=TRMNSDLC)/* IF TYRMTYPE IS GROUP,
*                                      NCP,SSCP,BSC LINE     @YM06873*/
*                 |AVTAS=0          /* HOLD PROCESSING IS NOT IN THE
*                                      SYSTEM                        */
*               THEN                /* INDICATE THAT AN ERROR HAS
*                                      BEEN DETECTED                 */
         TM    TRMLIST(RTRM),B'01100000'                        04S0421
         BNZ   @RT00421                                         04S0421
         TM    TRMPREF(RTRM),B'00010000'                        04S0421
         BNO   @GL00010                                         04S0421
         LR    @11,RTRM                                         04S0421
         SL    @11,@CF01880                                     04S0421
         CLI   TRMTYPE(@11),X'00'                               04S0421
         BE    @RT00421                                         04S0421
         CLI   TRMTYPE(@11),X'0F'                               04S0421
         BE    @RT00421                                         04S0421
         CLI   TRMTYPE(@11),X'FF'                               04S0421
         BE    @RT00421                                         04S0421
         CLI   TRMTYPE(@11),X'20'                               04S0421
         BE    @RT00421                                         04S0421
@GL00010 L     @11,AVTAS(,RAVT)                                 04S0421
         LTR   @11,@11                                          04S0421
         BNZ   @RF00421                                         04S0421
@RT00421 DS    0H                                               04S0422
*               DO;                                             04S0422
*                 RETCODE=4;        /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        04S0423
*                 REG00=60;         /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,60                                         04S0424
*               END;                                            04S0425
*             ELSE                  /* CONTINUE THE VERIFICATION     */
*               IF TRMPREF=OFF&DCTUMASK=ON/* GENERAL POLL            */
*                   |TRMPREF=ON&TRMTYPE=TRMCLUST/* CLUSTER           */
*                 THEN              /* INDICATE AN ERROR HAS BEEN
*                                      DETECTED                      */
         B     @RC00421                                         04S0426
@RF00421 TM    TRMPREF(RTRM),B'00010000'                        04S0426
         BNZ   @GL00016                                         04S0426
         SLR   @15,@15                                          04S0426
         IC    @15,TRMCHCIN(,RTRM)                              04S0426
         BCTR  @15,0                                            04S0426
         MH    @15,AVTDCTLN(,RAVT)                              04S0426
         AL    @15,AVTCSTCS(,RAVT)                              04S0426
         TM    DCTUMASK(@15),B'00000001'                        04S0426
         BO    @RT00426                                         04S0426
@GL00016 TM    TRMPREF(RTRM),B'00010000'                        04S0426
         BNO   @RF00426                                         04S0426
         LR    @11,RTRM                                         04S0426
         AL    @11,@CF01143                                     04S0426
         CLI   TRMTYPE-11(@11),X'40'                            04S0426
         BNE   @RF00426                                         04S0426
@RT00426 DS    0H                                               04S0427
*                 DO;                                           04S0427
*                   RETCODE=4;      /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        04S0428
*                   REG00=147;      /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,147                                        04S0429
*                 END;                                          04S0430
*           END;                                                04S0431
@RF00426 DS    0H                                               04S0431
@RC00421 DS    0H                                               04S0432
*       END;                                                    03S0432
@RF00419 DS    0H                                               03S0433
*       IF RETCODE=0                /* THE RESOURCE CAN BE HELD      */
*         THEN                      /* PROCESS THE HOLD REQUEST FOR
*                                      THE SPECIFIC TYPE OF RESOURCE */
         LTR   RETCODE,RETCODE                                  02S0433
         BNZ   @RF00433                                         02S0433
*                                                               03S0434
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS.HOLD: THIS SEGMENT DETERMINES IF MULTIPLE       */
*         /* FUNCTION PROCESSING IS REQUIRED FOR THE HOLD REQUEST AND*/
*         /* PROCESSES THE HOLD REQUEST ACCORDINGLY.                 */
*         /*                                                         */
*         /***********************************************************/
*                                                               03S0434
*         DO;                                                   03S0434
*           IF TRMPREF=ON           /* A COMMUNICATIONS CONTROLLER
*                                      RESOURCE                      */
*               &OCTOTE=ON          /* TOTE CONTROLS THE RESOURCE    */
*             THEN                  /* INDICATE THAT TOTE CONTROLS
*                                      THE RESOURCE                  */
         TM    TRMPREF(RTRM),B'00010000'                        03S0435
         BNO   @RF00435                                         03S0435
         TM    OCTOTE(ROPCE),B'01000000'                        03S0435
         BNO   @RF00435                                         03S0435
*             TRMSTOTE=ON;                                      03S0436
         LR    @11,RTRM                                         03S0436
         AL    @11,@CF01898                                     03S0436
         OI    TRMSTOTE-3(@11),B'00000001'                      03S0436
*           OCALSTAT=OCUNSET;       /* SET THE STATUS INDICATOR TO
*                                      THE UNSET STATE               */
@RF00435 MVI   OCALSTAT(ROPCE),X'00'                            03S0437
*           IF TRMPREF=OFF          /* AN EP TERMINAL                */
*               |TRMTYPE>=TRMLUNT&TRMTYPE<=TRMPSNA/* TERMINAL OR
*                                      LOGICAL UNIT          @YM06487*/
*             THEN                  /* PROCESS THE TERMINAL OR  03S0438
*                                      LOGICAL UNIT HOLD REQUEST     */
         TM    TRMPREF(RTRM),B'00010000'                        03S0438
         BZ    @RT00438                                         03S0438
         LR    @11,RTRM                                         03S0438
         SL    @11,@CF01880                                     03S0438
         CLI   TRMTYPE(@11),X'30'                               03S0438
         BL    @RF00438                                         03S0438
         CLI   TRMTYPE(@11),X'4F'                               03S0438
         BH    @RF00438                                         03S0438
@RT00438 DS    0H                                               03S0439
*             DO;                                               03S0439
*               CALL LOGICAL;                                   03S0440
         BAL   @14,LOGICAL                                      03S0440
*               IF RETCODE=0        /* NO ERRORS WERE ENCOUNTERED    */
*                 THEN              /* PREPARE FOR THE SUCCESSFUL
*                                      HOLD MESSAGE                  */
         LTR   RETCODE,RETCODE                                  03S0441
         BNZ   @RF00441                                         03S0441
*                 DO;                                           03S0442
*                   IF OCOPTCDE=OCVARY&OCPARM=26 THEN           03S0443
         CLI   OCOPTCDE(ROPCE),X'28'                            03S0443
         BNE   @RF00443                                         03S0443
         LA    @11,26                                           03S0443
         CH    @11,OCPARM(,ROPCE)                               03S0443
         BNE   @RF00443                                         03S0443
*                     REG00=26;     /* THE INPUT WAS THE RESULT OF A
*                                      VARY COMMAND          @OZ30332*/
         LR    REG00,@11                                        03S0444
*                   ELSE                                        03S0445
*                     DO;           /*                       @OZ30332*/
         B     @RC00443                                         03S0445
@RF00443 DS    0H                                               03S0446
*                       REG00=51;   /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,51                                         03S0446
*                       CVD(TRMOUTSQ,OPCDOUBL);/* CONVERT THE OUTPUT
*                                      SEQUENCE NUMBER TO DECIMAL    */
         LH    @11,TRMOUTSQ(,RTRM)                              03S0447
         N     @11,@CF01899                                     03S0447
         CVD   @11,OPCDOUBL(,ROPCAVT)                           03S0447
*                       UNPK(OPCDOUBL(1:5),OPCDOUBL(6:8));/* UNPACK
*                                      THE DECIMAL NUMBER            */
         UNPK  OPCDOUBL(5,ROPCAVT),OPCDOUBL+5(3,ROPCAVT)        03S0448
*                       OPCDOUBL(5:5)=OPCDOUBL(5:5)|SIGNMASK;/* 03S0449
*                                      CONVERT THE SIGN TO PRINTABLE
*                                      BITS                  @YM08392*/
         OI    OPCDOUBL+4(ROPCAVT),C'0'                         03S0449
*                       MVC(OCMODNME(1:4),OPCDOUBL(2:5));/* PLACE THE
*                                      SEQUENCE NUMBER IN THE   03S0450
*                                      OPERATOR CONTROL ELEMENT      */
         MVC   OCMODNME(4,ROPCE),OPCDOUBL+1(ROPCAVT)            03S0450
*                     END;          /*                       @OZ30332*/
*                 END;                                          03S0452
*             END;                                              03S0453
*           ELSE                    /* DO THE MULTIPLE FUNCTION 03S0454
*                                      PROCESSING                    */
*                                                               04S0454
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.HOLD.MULTIPLE: THIS SEGMENT PERFORMS THE    */
*             /* MULTIPLE FUNCTION HOLD PROCESSING.                  */
*             /*                                                     */
*             /*******************************************************/
*                                                               04S0454
*             DO;                                               04S0454
         B     @RC00438                                         04S0454
@RF00438 DS    0H                                               04S0455
*               IF TRMTYPE=TRMPUNT  /* PHYSICAL UNIT                 */
*                 THEN              /* PROCESS THE HOLD REQUEST FOR
*                                      THE PHYSICAL UNIT             */
         LR    @11,RTRM                                         04S0455
         AL    @11,@CF01143                                     04S0455
         CLI   TRMTYPE-11(@11),X'18'                            04S0455
         BNE   @RF00455                                         04S0455
*                 CALL PHYSICAL;                                04S0456
         BAL   @14,PHYSICAL                                     04S0456
*               ELSE                /* TEST FOR A LINK               */
*                 IF TRMPREF=ON&TRMTYPE=TRMSDLC/* LINK ENTRY         */
*                   THEN            /* PROCESS THE HOLD REQUEST FOR
*                                      THE LINK                      */
         B     @RC00455                                         04S0457
@RF00455 TM    TRMPREF(RTRM),B'00010000'                        04S0457
         BNO   @RF00457                                         04S0457
         LR    @11,RTRM                                         04S0457
         SL    @11,@CF01880                                     04S0457
         CLI   TRMTYPE(@11),X'21'                               04S0457
         BNE   @RF00457                                         04S0457
*                                                               05S0458
*                   /*************************************************/
*                   /*                                               */
*                   /* PROCESS.HOLD.MULTIPLE.LINK: THIS SEGMENT DOES */
*                   /* THE PROCESSING FOR A LINK HOLD REQUEST.       */
*                   /*                                               */
*                   /*************************************************/
*                                                               05S0458
*                   DO;                                         05S0458
*                     IF TRMSUBST^=0/* TEST FOR AN ATTACHED PHYSICAL
*                                      UNIT                          */
*                       THEN        /* PROCESS THE PHYSICAL UNIT(S)
*                                      ON THE LINK                   */
         LH    @11,TRMSUBST(,@11)                               05S0459
         N     @11,@CF01899                                     05S0459
         LTR   @11,@11                                          05S0459
         BZ    @RF00459                                         05S0459
*                       DO;                                     05S0460
*                         OCALLFLG=ON;/* INDICATE THAT MULTIPLE 05S0461
*                                      FUNCTION PROCESSING IS TO BE
*                                      PERFORMED FOR THIS HOLD  05S0461
*                                      COMMAND                       */
         OI    OCALLFLG(ROPCE),B'00000100'                      05S0461
*                         LNKTTCIN=OCTRMTBL;/* SAVE THE TTCIN FOR THE
*                                      LINK                          */
         LH    @09,OCTRMTBL(,ROPCE)                             05S0462
         N     @09,@CF01899                                     05S0462
         STH   @09,LNKTTCIN                                     05S0462
*                         RFY                                   05S0463
*                           RPARM RSTD;                         05S0463
*                         RPARM=TRMSUBST;/* GET THE FIRST PHYSICAL
*                                      UNIT TTCIN                    */
         LR    RPARM,@11                                        05S0464
*                         DO UNTIL(TRMCOHRT=0|LNKTTCIN=TRMCOHRT);/*
*                                      PROCESS UNTIL THERE ARE NO
*                                      MORE PHYSICAL UNITS ON THE
*                                      LINK TO BE PROCESSED          */
@DL00465 DS    0H                                               05S0466
*                           OCTRMTBL=RPARM;/* SAVE THE TTCIN FOR THE
*                                      PHYSICAL UNIT                 */
         STH   RPARM,OCTRMTBL(,ROPCE)                           05S0466
*                           CALL IEDQTNT;                       05S0467
         L     @15,AVTRNMPT(,RAVT)                              05S0467
         BALR  @14,@15                                          05S0467
*                           RTRM=RPARM;/* SET THE BASE POINTER FOR
*                                      THE RESOURCE ENTRY STRUCTURE  */
         LR    RTRM,RPARM                                       05S0468
*                           IF OCTOTE=ON THEN/* TOTE?                */
         TM    OCTOTE(ROPCE),B'01000000'                        05S0469
         BNO   @RF00469                                         05S0469
*                             TRMSTOTE=ON;/* SET TOTE OWN FLAG       */
         LR    @11,RTRM                                         05S0470
         AL    @11,@CF01898                                     05S0470
         OI    TRMSTOTE-3(@11),B'00000001'                      05S0470
*                           ELSE                                05S0471
*                             ;     /* NORMAL FALL THROUGH           */
@RF00469 DS    0H                                               05S0472
*                           CALL PHYSICAL;                      05S0472
         BAL   @14,PHYSICAL                                     05S0472
*                           RPARM=TRMCOHRT;/* GET THE TTCIN OF THE
*                                      NEXT PHYSICAL UNIT ON THE LINK*/
         LR    @11,RTRM                                         05S0473
         AL    @11,@CF01901                                     05S0473
         LH    RPARM,TRMCOHRT-4(,@11)                           05S0473
         N     RPARM,@CF01899                                   05S0473
*                         END;                                  05S0474
@DE00465 LR    @11,RTRM                                         05S0474
         SL    @11,@CF01880                                     05S0474
         LH    @07,TRMCOHRT(,@11)                               05S0474
         N     @07,@CF01899                                     05S0474
         LTR   @07,@07                                          05S0474
         BZ    @DC00465                                         05S0474
         CLC   LNKTTCIN(2),TRMCOHRT(@11)                        05S0474
         BNE   @DL00465                                         05S0474
@DC00465 DS    0H                                               05S0475
*                         RFY                                   05S0475
*                           RPARM UNRSTD;                       05S0475
*                         OCTRMTBL=LNKTTCIN;/* RESTORE OCTRMTBL WITH
*                                      THE TTCIN FOR THE LINK        */
         LH    @11,LNKTTCIN                                     05S0476
         N     @11,@CF01899                                     05S0476
         STH   @11,OCTRMTBL(,ROPCE)                             05S0476
*                       END;                                    05S0477
*                     ELSE          /* INDICATE THAT AN ERROR HAS
*                                      BEEN DETECTED                 */
*                       DO;                                     05S0478
         B     @RC00459                                         05S0478
@RF00459 DS    0H                                               05S0479
*                         RETCODE=4;/* SET THE RETURN CODE           */
         LA    RETCODE,4                                        05S0479
*                         REG00=60; /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,60                                         05S0480
*                       END;                                    05S0481
*                   END;                                        05S0482
*                 ELSE              /* INDICATE THAT AN ERROR HAS
*                                      BEEN ENCOUNTERED              */
*                   DO;                                         04S0483
         B     @RC00457                                         04S0483
@RF00457 DS    0H                                               04S0484
*                     RETCODE=4;    /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        04S0484
*                     REG00=MSGINVOP;/* SET REGISTER ZERO (0) WITH
*                                      THE APPROPRIATE MESSAGE NUMBER*/
         LA    REG00,18                                         04S0485
*                   END;                                        04S0486
*                                                               05S0487
*               /*****************************************************/
*               /*                                                   */
*               /* PROCESS.HOLD.MULTIPLE.MESSAGE: THIS SEGMENT       */
*               /* DETERMINES THE APPROPRIATE MESSAGE NUMBER FOR     */
*               /* MULTIPLE FUNCTION PROCESSING.                     */
*               /*                                                   */
*               /*****************************************************/
*                                                               05S0487
*               DO;                                             05S0487
@RC00457 DS    0H                                               05S0487
@RC00455 DS    0H                                               05S0488
*                 IF OCSOME=ON&OCNONE=ON/* THE STATUS INDICATOR IS
*                                      SET TO "ALL HELD"             */
*                   THEN            /* SET THE APPROPRIATE MESSAGE
*                                      NUMBER                        */
         TM    OCSOME(ROPCE),B'00000011'                        05S0488
         BNO   @RF00488                                         05S0488
*                   DO;                                         05S0489
*                     RETCODE=0;    /* SET THE RETURN CODE           */
         SLR   RETCODE,RETCODE                                  05S0490
*                     REG00=522;    /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,522                                        05S0491
*                   END;                                        05S0492
*                 ELSE              /* TEST FOR "SOME HELD"          */
*                   IF OCSOME=ON    /* THE STATUS INDICATOR IS SET TO
*                                      "SOME HELD"                   */
*                     THEN          /* SET THE APPROPRIATE MESSAGE
*                                      NUMBER                        */
         B     @RC00488                                         05S0493
@RF00488 TM    OCSOME(ROPCE),B'00000010'                        05S0493
         BNO   @RF00493                                         05S0493
*                     DO;                                       05S0494
*                       RETCODE=0;  /* SET THE RETURN CODE           */
         SLR   RETCODE,RETCODE                                  05S0495
*                       REG00=521;  /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,521                                        05S0496
*                     END;                                      05S0497
*                   ELSE            /* TEST FOR "NONE HELD"          */
*                     IF OCNONE=ON  /* THE STATUS INDICATOR IS SET TO
*                                      "NONE HELD"                   */
*                       THEN        /* SET THE APPROPRIATE MESSAGE
*                                      NUMBER                        */
         B     @RC00493                                         05S0498
@RF00493 TM    OCNONE(ROPCE),B'00000001'                        05S0498
         BNO   @RF00498                                         05S0498
*                       DO;                                     05S0499
*                         RETCODE=4;/* SET THE RETURN CODE           */
         LA    RETCODE,4                                        05S0500
*                         REG00=523;/* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,523                                        05S0501
*                       END;                                    05S0502
*               END;                                            05S0503
@RF00498 DS    0H                                               05S0503
@RC00493 DS    0H                                               05S0503
@RC00488 DS    0H                                               05S0504
*             END;                                              04S0504
*         END;                                                  03S0505
@RC00438 DS    0H                                               03S0506
*     END;                                                      02S0506
@RF00433 DS    0H                                               02S0507
*                                                               02S0507
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL SYSTEM    */
*   /* MACRO INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL */
*   /* TO THE NEXT MODULE THAT IS TO BE EXECUTED.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0507
*   IF OCOPTCDE=OCVARY              /* THE INPUT WAS A RESULT OF A
*                                      VARY COMMAND                  */
*       &(OCTOTE=ON&OCPARM=0|OCTOTE=OFF&OCPARM=26)/* THE VARY   02S0507
*                                      PROCESSING WAS SUCCESSFUL     */
*       &OCSWITCH=OCMIDMSG          /* THE RESOURCE IS TO BE REMOVED
*                                      FROM A "MIDDLE OF MESSAGE"
*                                      CONDITION                     */
*     THEN                          /* RETURN TO A VARY MODULE       */
@RF00391 CLI   OCOPTCDE(ROPCE),X'28'                            02S0507
         BNE   @RF00507                                         02S0507
         TM    OCTOTE(ROPCE),B'01000000'                        02S0507
         BNO   @GL00027                                         02S0507
         LH    @11,OCPARM(,ROPCE)                               02S0507
         LTR   @11,@11                                          02S0507
         BZ    @GL00025                                         02S0507
@GL00027 TM    OCTOTE(ROPCE),B'01000000'                        02S0507
         BNZ   @RF00507                                         02S0507
         CLC   OCPARM(2,ROPCE),@CH01864                         02S0507
         BNE   @RF00507                                         02S0507
@GL00025 CLI   OCSWITCH(ROPCE),X'20'                            02S0507
         BNE   @RF00507                                         02S0507
*     DO;                                                       02S0508
*       REG00=OCPARM;               /* SET REGISTER ZERO (0) WITH THE
*                                      MESSAGE NUMBER                */
         LH    REG00,OCPARM(,ROPCE)                             02S0509
*       OPCMODID='V7';              /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS                    */
         MVC   OPCMODID(2,ROPCAVT),@CC01873                     02S0510
*       OCWTG=''B;                  /* ZERO THE "WHERE TO GO" FIELD  */
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      02S0511
*     END;                                                      02S0512
*   ELSE                            /* DETERMINE WHICH MODULE IS TO
*                                      RECEIVE CONTROL               */
*     DO;                                                       02S0513
         B     @RC00507                                         02S0513
@RF00507 DS    0H                                               02S0514
*       IF OCOPTCDE=OCVARY          /* THE INPUT WAS A RESULT OF A
*                                      VARY COMMAND                  */
*           &^(OCTOTE=ON&OCPARM=0|OCTOTE=OFF&OCPARM=26)/* THE VARY
*                                      PROCESSING WAS NOT SUCCESSFUL */
*           &RETCODE^=0             /* THE HOLD PROCESSING WAS NOT
*                                      SUCCESSFUL                    */
*         THEN                      /* SET REGISTER ZERO (0) WITH THE
*                                      VARY COMMAND ERROR MESSAGE
*                                      NUMBER                        */
         CLI   OCOPTCDE(ROPCE),X'28'                            02S0514
         BNE   @RF00514                                         02S0514
         TM    OCTOTE(ROPCE),B'01000000'                        02S0514
         BNO   @GL00032                                         02S0514
         LH    @11,OCPARM(,ROPCE)                               02S0514
         LTR   @11,@11                                          02S0514
         BZ    @RF00514                                         02S0514
@GL00032 TM    OCTOTE(ROPCE),B'01000000'                        02S0514
         BNZ   @GL00030                                         02S0514
         CLC   OCPARM(2,ROPCE),@CH01864                         02S0514
         BE    @RF00514                                         02S0514
@GL00030 LTR   RETCODE,RETCODE                                  02S0514
         BZ    @RF00514                                         02S0514
*         REG00=OCPARM;             /* SET REGISTER ZERO (0) WITH THE
*                                      MESSAGE NUMBER FROM THE  02S0515
*                                      OPERATOR CONTROL ELEMENT      */
         LH    REG00,OCPARM(,ROPCE)                             02S0515
*       IF OCTOTE=ON                /* THE INPUT WAS FROM TOTE       */
*           |OCMPP=ON               /* THE INPUT WAS FROM AN    02S0516
*                                      APPLICATION PROGRAM           */
*         THEN                      /* PREPARE TO RETURN TO THE 02S0516
*                                      MESSAGE WRITING MODULE        */
@RF00514 TM    OCTOTE(ROPCE),B'01100000'                        02S0516
         BZ    @RF00516                                         02S0516
*         DO;                                                   02S0517
*           OCPARM=RETCODE;         /* PUT THE RETURN CODE IN THE
*                                      OPERATOR CONTROL ELEMENT      */
         STH   RETCODE,OCPARM(,ROPCE)                           02S0518
*           REG00=RETCODE;          /* SET REGISTER ZERO (0) WITH THE
*                                      RETURN CODE                   */
         LR    REG00,RETCODE                                    02S0519
*           OPCMODID='07';          /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS                    */
         MVC   OPCMODID(2,ROPCAVT),@CC01874                     02S0520
*         END;                                                  02S0521
*       ELSE                        /* DETERMINE THE NORMAL HOLD
*                                      COMMAND RETURN MODULE         */
*         DO;                                                   02S0522
         B     @RC00516                                         02S0522
@RF00516 DS    0H                                               02S0523
*           OCPARM=REG00;           /* PUT THE MESSAGE NUMBER IN THE
*                                      OPERATOR CONTROL ELEMENT      */
         STH   REG00,OCPARM(,ROPCE)                             02S0523
*           OPCMODID='09';          /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS                    */
         MVC   OPCMODID(2,ROPCAVT),@CC01875                     02S0524
*         END;                                                  02S0525
*       IF RETCODE=0                /* THE HOLD PROCESSING WAS  02S0526
*                                      SUCCESSFUL                    */
*           |OPCRSTRT=ON            /* RESTART IS IN PROGRESS        */
*         THEN                      /* PREPARE TO CHECKPOINT THE
*                                      SUCCESSFUL PROCESSING         */
@RC00516 LTR   RETCODE,RETCODE                                  02S0526
         BZ    @RT00526                                         02S0526
         TM    OPCRSTRT(ROPCAVT),B'00100000'                    02S0526
         BNO   @RF00526                                         02S0526
@RT00526 DS    0H                                               02S0527
*         DO;                                                   02S0527
*           OCWTG=OPCMODID;         /* SET THE "WHERE TO GO"    02S0528
*                                      CHARACTERS                    */
         MVC   OCWTG(2,ROPCE),OPCMODID(ROPCAVT)                 02S0528
*           OPCMODID='06';          /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS                    */
         MVC   OPCMODID(2,ROPCAVT),@CC01876                     02S0529
*         END;                                                  02S0530
*       ELSE                        /* ZERO THE "WHERE TO GO" FIELD  */
*         OCWTG=''B;                                            02S0531
         B     @RC00526                                         02S0531
@RF00526 XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      02S0531
*     END;                                                      02S0532
@RC00526 DS    0H                                               02S0533
*   RFY                                                         02S0533
*     REG01 RSTD;                   /* RESTRICT THE ARGUMENT REGISTER
*                                      TO BE USED TO CONTAIN THE
*                                      POINTER TO THE OPERATOR  02S0533
*                                      CONTROL ADDRESS VECTOR TABLE
*                                      FROM USE BY THE COMPILER      */
@RC00507 DS    0H                                               02S0534
*   REG01=ROPCAVT;                  /* SET THE ARGUMENT REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO THE NEXT MODULE    */
         LR    REG01,ROPCAVT                                    02S0534
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(REG15);       02S0535
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*                                                               02S0536
*   /*****************************************************************/
*   /*                                                               */
*   /* LOGICAL: THIS SEGMENT CONTAINS AN INTERNAL PROCEDURE WHICH    */
*   /* PROCESSES THE HOLD REQUEST FOR A LOGICAL UNIT.                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0536
*LOGICAL:                                                       02S0536
*   PROC OPTIONS(RETREG,SAVE(14));  /*                       @YM06487*/
LOGICAL  ST    @14,@SA00002                                     02S0536
*   RETCODE=0;                      /* INDICATE THAT NO ERROR HAS
*                                      BEEN DETECTED FOR MULTIPLE
*                                      FUNCTION PROCESSING           */
*                                                               02S0537
         SLR   RETCODE,RETCODE                                  02S0537
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT BUILDS A ELEMENT TO INTERFACE WITH IEDQAS TO HAVE*/
*   /* A DEVICE QUEUE RELEASED                               @0Z15629*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0538
*   OPCWRKSP(3)=REG00;              /* SAVE REG 0 FOR THE LOOP  02S0538
*                                                            @OZ15629*/
         ST    REG00,OPCWRKSP+8(,ROPCAVT)                       02S0538
*   IF OPCRSTRT=ON|OCTOTE=ON THEN                               02S0539
         TM    OPCRSTRT(ROPCAVT),B'00100000'                    02S0539
         BO    @RT00539                                         02S0539
         TM    OCTOTE(ROPCE),B'01000000'                        02S0539
         BNO   @RF00539                                         02S0539
@RT00539 DS    0H                                               02S0540
*     DO;                                                       02S0540
*     END;                          /* IF RESTART OR TOTE RESOUCE, DO
*                                      NOT POST BUFFER       @OZ15629*/
*   ELSE                                                        02S0542
*     DO;                                                       02S0542
         B     @RC00539                                         02S0542
@RF00539 DS    0H                                               02S0543
*       RPARM=ONE;                  /* INDICATE ONE BUFFER NEEDED
*                                                            @OZ15629*/
         LA    RPARM,1                                          02S0543
*       CALL ALLOCBUF;              /* GET A BUFFER          @OZ15629*/
         L     @15,OPCGETBF(,ROPCAVT)                           02S0544
         BALR  @14,@15                                          02S0544
*       RPRF=RPARM;                 /* EST. ADDRESSABILITY   @OZ15629*/
         LR    RPRF,RPARM                                       02S0545
*       REG00=OPCWRKSP(3);          /* RESTORE               @OZ15629*/
         L     REG00,OPCWRKSP+8(,ROPCAVT)                       02S0546
*       IF OCOPTCDE=OCVARY&OCSWITCH=OCMIDMSG THEN               02S0547
         CLI   OCOPTCDE(ROPCE),X'28'                            02S0547
         BNE   @RF00547                                         02S0547
         CLI   OCSWITCH(ROPCE),X'20'                            02S0547
         BNE   @RF00547                                         02S0547
*         PRFSTAT1=ONE;             /* IF INTERNAL VARY AND MID MSG
*                                      REQUIRED SET PRFSTAT1 @OZ15629*/
         MVI   PRFSTAT1(RPRF),B'00000001'                       02S0548
*       ELSE                                                    02S0549
*         ;                                                     02S0549
@RF00547 DS    0H                                               02S0550
*       PRFQCBA=AVTAS;              /* QAS QCB ADDR          @OZ15629*/
         MVC   PRFQCBA(3,RPRF),AVTAS+1(RAVT)                    02S0550
*       PRFPRI=PRIOPCTL;            /* PRIORITY              @ZM46691*/
         MVI   PRFPRI(RPRF),X'DC'                               02S0551
*       PRFTIC=INVALTIC;            /* INDICATE ONE BUFFER UNIT 02S0552
*                                                            @OZ15629*/
         MVC   PRFTIC(4,RPRF),@CB01379                          02S0552
*       PRFNBUNT=ONE;               /* ONE UNIT              @OZ15629*/
         MVI   PRFNBUNT(RPRF),X'01'                             02S0553
*       PRFDEST=OCTRMTBL;           /* TNT INDEX OF DEVICE   @OZ15629*/
         LH    @07,OCTRMTBL(,ROPCE)                             02S0554
         N     @07,@CF01899                                     02S0554
         STH   @07,PRFDEST(,RPRF)                               02S0554
*       OPCAQFST=RPRF;              /* BUILD AQCTL PARAMETER LIST
*                                                            @OZ15629*/
         STCM  RPRF,7,OPCAQFST(ROPCAVT)                         02S0555
*       OPCAQREQ=TPOST;             /* POST CODE             @OZ15629*/
         MVI   OPCAQREQ(ROPCAVT),X'0C'                          02S0556
*       OPCAQSEC=RPRF;              /* ONE ELEMENT TO POST   @OZ15629*/
         STCM  RPRF,7,OPCAQSEC(ROPCAVT)                         02S0557
*       OPCAQRQ2=ENDLIST;           /* END OF LIST CODE      @OZ15629*/
         MVI   OPCAQRQ2(ROPCAVT),X'80'                          02S0558
*       RPARM=ADDR(OPCAQCTL);       /* PARM LIST ADDRESS     @OZ15629*/
         LA    RPARM,OPCAQCTL(,ROPCAVT)                         02S0559
*       SVC(102);                   /* TCAM CROSS PARTITION     02S0560
*                                      COMMUNICATION ROUTINE @OZ15629*/
         SVC   102                                              02S0560
*     END;                          /*                       @OZ15629*/
*   IF TRMHELDN=OFF                 /* THE RESOURCE IS NOT IN HOLD
*                                      MODE                          */
*     THEN                          /* DO QCB CHECKING AND CONTINUE
*                                      PROCESSING                    */
@RC00539 TM    TRMHELDN(RTRM),B'00000100'                       02S0562
         BNZ   @RF00562                                         02S0562
*     IF QCBDRQQ=ON                 /* CONCENTRATOR                  */
*         |OCTOTE=ON                /* TOTE INPUT                    */
*         &TRMPREF=ON               /* RESOURCE IS A COMMUNICATIONS
*                                      CONTROLLER                    */
*         |(QCBNREUS=ON|QCBREUS=ON) /* THERE IS DISK QUEUEING        */
*       THEN                        /* DO CONCENTRATOR HOLD     02S0563
*                                      PROCESSING                    */
         L     @07,TRMDESTQ-1(,RTRM)                            02S0563
         TM    QCBDRQQ(@07),B'00000100'                         02S0563
         BO    @RT00563                                         02S0563
         TM    OCTOTE(ROPCE),B'01000000'                        02S0563
         BNO   @GL00038                                         02S0563
         TM    TRMPREF(RTRM),B'00010000'                        02S0563
         BO    @RT00563                                         02S0563
@GL00038 L     @07,TRMDESTQ-1(,RTRM)                            02S0563
         TM    QCBNREUS(@07),B'00110000'                        02S0563
         BZ    @RF00563                                         02S0563
@RT00563 DS    0H                                               02S0564
*                                                               03S0564
*       /*************************************************************/
*       /*                                                           */
*       /* LOGICAL.DCB: THIS SEGMENT CHECKS THE DATA CONTROL BLOCK   */
*       /* AND DOES THE CONCENTRATOR HOLD PROCESSING.                */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0564
*       DO;                                                     03S0564
*         IF DCBOFOPN=OFF           /* THE DCB IS NOT OPEN           */
*             &OPCRSTRT=ON          /* RESTART IS IN PROGRESS        */
*             |DCBDSGIS=ON          /* THIS IS AN LGB                */
*             |DCBOFOPN=ON          /* THE DCB IS OPEN               */
*             &DCBDSGIS=OFF         /* THIS IS NOT AN LGB            */
*             &QCBRELLN<=DEBNMEXT   /* THE RELATIVE LINE NUMBER IS
*                                      NOT EXCEEDED                  */
*             &DEBUCBAD(QCBRELLN)^=0/* THE DEB IS NOT OPENED "DUMMY"
*                                                            @YM08020*/
*           THEN                    /* SET THE HOLD STATE INDICATORS */
         L     @07,TRMDESTQ-1(,RTRM)                            03S0565
         L     @07,QCBDCBAD-1(,@07)                             03S0565
         TM    DCBOFOPN+40(@07),B'00010000'                     03S0565
         BNZ   @GL00042                                         03S0565
         TM    OPCRSTRT(ROPCAVT),B'00100000'                    03S0565
         BO    @RT00565                                         03S0565
@GL00042 L     @07,TRMDESTQ-1(,RTRM)                            03S0565
         LA    @07,0(,@07)                                      03S0565
         L     @05,QCBDCBAD-1(,@07)                             03S0565
         LA    @05,0(,@05)                                      03S0565
         LA    @15,20                                           03S0565
         ALR   @15,@05                                          03S0565
         TM    DCBDSGIS(@15),B'10000000'                        03S0565
         BO    @RT00565                                         03S0565
         AL    @05,@CF00042                                     03S0565
         TM    DCBOFOPN(@05),B'00010000'                        03S0565
         BNO   @RF00565                                         03S0565
         TM    DCBDSGIS(@15),B'10000000'                        03S0565
         BNZ   @RF00565                                         03S0565
         L     @05,DCBDEBAD(,@05)                               03S0565
         SL    @05,@CF00851                                     03S0565
         CLC   QCBRELLN(1,@07),DEBNMEXT(@05)                    03S0565
         BH    @RF00565                                         03S0565
         SLR   @15,@15                                          03S0565
         IC    @15,QCBRELLN(,@07)                               03S0565
         SLA   @15,2                                            03S0565
         L     @07,DEBUCBAD-5(@15,@05)                          03S0565
         LA    @07,0(,@07)                                      03S0565
         LTR   @07,@07                                          03S0565
         BZ    @RF00565                                         03S0565
@RT00565 DS    0H                                               03S0566
*           DO;                                                 03S0566
*             IF QCBTERMQ=ON        /* THERE IS QUEUEING BY TERMINAL */
*               THEN                /* SET THE HOLD INDICATOR        */
         L     @07,TRMDESTQ-1(,RTRM)                            03S0567
         LA    @07,0(,@07)                                      03S0567
         TM    QCBTERMQ(@07),B'00001000'                        03S0567
         BNO   @RF00567                                         03S0567
*               QCBTRMHO=ON;                                    03S0568
         OI    QCBTRMHO(@07),B'01000000'                        03S0568
*             TRMHELDN=ON;          /* SET THE RESOURCE FOR HOLD     */
@RF00567 OI    TRMHELDN(RTRM),B'00000100'                       03S0569
*           END;                                                03S0570
*         ELSE                      /* INDICATE THAT AN ERROR HAS
*                                      BEEN ENCOUNTERED              */
*           DO;                                                 03S0571
         B     @RC00565                                         03S0571
@RF00565 DS    0H                                               03S0572
*             RETCODE=1;            /* SET THE RETURN CODE           */
         LA    RETCODE,1                                        03S0572
*             REG00=60;             /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,60                                         03S0573
*           END;                                                03S0574
*       END;                                                    03S0575
*     ELSE                          /* INDICATE THAT AN ERROR HAS
*                                      BEEN ENCOUNTERED              */
*       DO;                                                     02S0576
         B     @RC00563                                         02S0576
@RF00563 DS    0H                                               02S0577
*         RETCODE=4;                /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        02S0577
*         REG00=60;                 /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,60                                         02S0578
*       END;                                                    02S0579
*   ELSE                            /* INDICATE THAT AN ERROR HAS
*                                      BEEN FOUND                    */
*     DO;                                                       02S0580
         B     @RC00562                                         02S0580
@RF00562 DS    0H                                               02S0581
*       RETCODE=8;                  /* SET THE RETURN CODE           */
         LA    RETCODE,8                                        02S0581
*       REG00=52;                   /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,52                                         02S0582
*     END;                                                      02S0583
*   END LOGICAL;                                                02S0584
@EL00002 DS    0H                                               02S0584
@EF00002 DS    0H                                               02S0584
@ER00002 L     @14,@SA00002                                     02S0584
         BR    @14                                              02S0584
*                                                               02S0585
*   /*****************************************************************/
*   /*                                                               */
*   /* PHYSICAL: THIS SEGMENT CONTAINS AN INTERNAL PROCEDURE WHICH   */
*   /* PROCESSES THE HOLD REQUEST FOR A PHYSICAL UNIT.               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0585
*PHYSICAL:                                                      02S0585
*   PROC OPTIONS(RETREG,SAVE(14));  /*                       @YM06487*/
PHYSICAL ST    @14,@SA00003                                     02S0585
*   RETCODE=0;                      /* INIDCATE THAT NO ERRORS HAVE
*                                      BEEN DETECTED FOR MULTIPLE
*                                      FUNCTION PROCESSING           */
         SLR   RETCODE,RETCODE                                  02S0586
*   IF TRMSUBST^=0                  /* LOGICAL UNITS ARE ATTACHED TO
*                                      THE PHYSICAL UNIT             */
*     THEN                          /* PROCESS TO HOLD THE LOGICAL
*                                      UNITS                         */
         LR    @11,RTRM                                         02S0587
         BCTR  @11,0                                            02S0587
         BCTR  @11,0                                            02S0587
         LH    @11,TRMSUBST-12(,@11)                            02S0587
         N     @11,@CF01899                                     02S0587
         LTR   @11,@11                                          02S0587
         BZ    @RF00587                                         02S0587
*     DO;                                                       02S0588
         ST    @11,@TF00001                                     02S0588
*       OCALLFLG=ON;                /* INDICATE THAT MULTIPLE   02S0589
*                                      FUNCTION PROCESSING IS TO BE
*                                      PERFORMED FOR THIS HOLD  02S0589
*                                      COMMAND                       */
         OI    OCALLFLG(ROPCE),B'00000100'                      02S0589
*       PHYTTCIN=OCTRMTBL;          /* SAVE OCTRMTBL                 */
         LH    PHYTTCIN,OCTRMTBL(,ROPCE)                        02S0590
         N     PHYTTCIN,@CF01899                                02S0590
*       RPARM=TRMSUBST;             /* SET THE PARAMETER REGISTER
*                                      WITH THE TTCIN OF THE FIRST
*                                      LOGICAL UNIT                  */
         L     RPARM,@TF00001                                   02S0591
*       DO UNTIL(TRMCOHRT=0|PHYTTCIN=TRMCOHRT);                 02S0592
@DL00592 DS    0H                                               02S0593
*         CALL IEDQTNT;                                         02S0593
         L     @15,AVTRNMPT(,RAVT)                              02S0593
         BALR  @14,@15                                          02S0593
*         RTRM=RPARM;               /* SET THE BASE POINTER FOR THE
*                                      RESOURCE ENTRY STRUCTURE      */
         LR    RTRM,RPARM                                       02S0594
*         IF OCTOTE=ON THEN         /* TOTE?                         */
         TM    OCTOTE(ROPCE),B'01000000'                        02S0595
         BNO   @RF00595                                         02S0595
*           TRMSTOTE=ON;            /* SET TOTE OWNED FLAG           */
         LR    @09,RTRM                                         02S0596
         AL    @09,@CF01898                                     02S0596
         OI    TRMSTOTE-3(@09),B'00000001'                      02S0596
*         ELSE                                                  02S0597
*           ;                       /* NORMAL FALL THROUGH           */
@RF00595 DS    0H                                               02S0598
*         CALL LOGICAL;                                         02S0598
         BAL   @14,LOGICAL                                      02S0598
*                                                               03S0599
*         /***********************************************************/
*         /*                                                         */
*         /* PHYSICAL.REMEMBER: THIS SEGMENT REMEMBERS THE RESULTS OF*/
*         /* PROCESSING A HOLD REQUEST FOR A LOGICAL UNIT.           */
*         /*                                                         */
*         /***********************************************************/
*                                                               03S0599
*         DO;                                                   03S0599
*           IF RETCODE=0            /* THE HOLD REQUEST PROCESSING
*                                      FOR THE LOGICAL UNIT WAS 03S0600
*                                      SUCCESSFUL                    */
*             THEN                  /* REMEMBER THE SUCCESS          */
         LTR   RETCODE,RETCODE                                  03S0600
         BNZ   @RF00600                                         03S0600
*             DO;                                               03S0601
*               IF OCSOME=OFF&OCNONE=OFF/* THE INDICATOR IS UNSET    */
*                 THEN              /* SET TO "ALL HELD"             */
         TM    OCSOME(ROPCE),B'00000011'                        03S0602
         BNZ   @RF00602                                         03S0602
*                 DO;                                           03S0603
*                   OCSOME=ON;                                  03S0604
*                   OCNONE=ON;                                  03S0605
         OI    OCSOME(ROPCE),B'00000011'                        03S0605
*                 END;                                          03S0606
*               ELSE                /* TEST THE INDICATOR FOR "NONE
*                                      HELD"                         */
*                 IF OCSOME=OFF&OCNONE=ON/* THE INDICATOR IS SET TO
*                                      "NONE HELD"                   */
*                   THEN            /* SET TO "SOME HELD"            */
         B     @RC00602                                         03S0607
@RF00602 TM    OCNONE(ROPCE),B'00000001'                        03S0607
         BNO   @RF00607                                         03S0607
         TM    OCSOME(ROPCE),B'00000010'                        03S0607
         BNZ   @RF00607                                         03S0607
*                   DO;                                         03S0608
*                     OCSOME=ON;                                03S0609
*                     OCNONE=OFF;                               03S0610
         OI    OCSOME(ROPCE),B'00000010'                        03S0610
         NI    OCNONE(ROPCE),B'11111110'                        03S0610
*                   END;                                        03S0611
*             END;                                              03S0612
*           ELSE                    /* REMEMBER THE FAILURE          */
*             DO;                                               03S0613
         B     @RC00600                                         03S0613
@RF00600 DS    0H                                               03S0614
*               IF OCSOME=OFF&OCNONE=OFF/* THE INDICATOR IS UNSET    */
*                 THEN              /* SET THE INDICATOR TO "NONE
*                                      HELD"                         */
         TM    OCSOME(ROPCE),B'00000011'                        03S0614
         BNZ   @RF00614                                         03S0614
*                 OCNONE=ON;                                    03S0615
         OI    OCNONE(ROPCE),B'00000001'                        03S0615
*               ELSE                /* TEST THE INDICATOR FOR "ALL
*                                      HELD"                         */
*                 IF OCSOME=ON&OCNONE=ON/* THE INDICATOR IS SET TO
*                                      "ALL HELD"                    */
*                   THEN            /* SET THE INDICATOR TO "SOME
*                                      HELD"                         */
         B     @RC00614                                         03S0616
@RF00614 TM    OCSOME(ROPCE),B'00000011'                        03S0616
         BNO   @RF00616                                         03S0616
*                   OCNONE=OFF;                                 03S0617
         NI    OCNONE(ROPCE),B'11111110'                        03S0617
*             END;                                              03S0618
@RF00616 DS    0H                                               03S0618
@RC00614 DS    0H                                               03S0619
*         END;                                                  03S0619
@RC00600 DS    0H                                               03S0620
*         RPARM=TRMCOHRT;           /* GET THE TTCIN OF THE NEXT
*                                      LOGICAL UNIT                  */
         LR    @07,RTRM                                         02S0620
         AL    @07,@CF01901                                     02S0620
         LH    RPARM,TRMCOHRT-4(,@07)                           02S0620
         N     RPARM,@CF01899                                   02S0620
*       END;                                                    02S0621
@DE00592 LR    @07,RTRM                                         02S0621
         AL    @07,@CF01901                                     02S0621
         LH    @07,TRMCOHRT-4(,@07)                             02S0621
         N     @07,@CF01899                                     02S0621
         LTR   @07,@07                                          02S0621
         BZ    @DC00592                                         02S0621
         CLR   PHYTTCIN,@07                                     02S0621
         BNE   @DL00592                                         02S0621
@DC00592 DS    0H                                               02S0622
*       OCTRMTBL=PHYTTCIN;          /* RESTORE THE TTCIN FOR THE
*                                      PHYSICAL UNIT                 */
         STH   PHYTTCIN,OCTRMTBL(,ROPCE)                        02S0622
*       RPARM=PHYTTCIN;             /* SET THE PARAMETER REGISTER
*                                      WITH PU TTCIN         @YM07279*/
         LR    RPARM,PHYTTCIN                                   02S0623
*       CALL IEDQTNT;               /*                       @YM07279*/
         L     @15,AVTRNMPT(,RAVT)                              02S0624
         BALR  @14,@15                                          02S0624
*       RTRM=RPARM;                 /*                       @YM07279*/
         LR    RTRM,RPARM                                       02S0625
*       REG00=0;                    /* RESET REGISTER ZERO (0)       */
         SLR   REG00,REG00                                      02S0626
*     END;                                                      02S0627
*   ELSE                            /* INDICATE THAT AN ERROR HAS
*                                      BEEN FOUND                    */
*     DO;                                                       02S0628
         B     @RC00587                                         02S0628
@RF00587 DS    0H                                               02S0629
*       RETCODE=4;                  /* SET THE RETURN CODE           */
         LA    RETCODE,4                                        02S0629
*       REG00=60;                   /* SET REGISTER ZERO (0) WITH THE
*                                      APPROPRIATE MESSAGE NUMBER    */
         LA    REG00,60                                         02S0630
*     END;                                                      02S0631
*   END PHYSICAL;                                               02S0632
@EL00003 DS    0H                                               02S0632
@EF00003 DS    0H                                               02S0632
@ER00003 L     @14,@SA00003                                     02S0632
         BR    @14                                              02S0632
*   END IGCH010D                                                01S0633
*                                                               01S0633
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (TDCTD   )                                       */
*/*%INCLUDE SYSLIB  (TDEBD   )                                       */
*/*%INCLUDE SYSLIB  (TMSGD   )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TPRFD   )                                       */
*/*%INCLUDE SYSLIB  (TPRIOR  )                                       */
*/*%INCLUDE SYSLIB  (TQCBD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (PARSE   )                                       */
*/*%INCLUDE SYSUT5  (OPERANDS)                                       */
*/*%INCLUDE SYSUT5  (RELATIVE)                                       */
*/*%INCLUDE SYSUT5  (CONVERT )                                       */
*/*%INCLUDE SYSUT5  (VERIFY  )                                       */
*/*%INCLUDE SYSUT5  (NAME    )                                       */
*/*%INCLUDE SYSUT5  (NAMERLN )                                       */
*/*%INCLUDE SYSUT5  (TYPE    )                                       */
*/*%INCLUDE SYSUT5  (HOLD    )                                       */
*/*%INCLUDE SYSUT5  (MULTIPLE)                                       */
*/*%INCLUDE SYSUT5  (LINK    )                                       */
*/*%INCLUDE SYSUT5  (MESSAGE )                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*/*%INCLUDE SYSUT5  (LOGICAL )                                       */
*/*%INCLUDE SYSUT5  (DCB     )                                       */
*/*%INCLUDE SYSUT5  (PHYSICAL)                                       */
*/*%INCLUDE SYSUT5  (REMEMBER)                                       */
*                                                               01S0633
*       ;                                                       01S0633
@DATA    DS    0H
@CH01864 DC    H'26'
@SM01894 MVC   OCBACKUP(0,ROPCE),CMDTEXT+3(@11)
@SM01896 MVC   0(0,@15),CMDTEXT(@11)
@DATD    DSECT
         DS    0F
@SA00002 DS    1F
@SA00003 DS    1F
@TF00001 DS    F
IGCH010D CSECT
         DS    0F
@CF00062 DC    F'1'
@CF00075 DC    F'3'
@CF00256 DC    F'4'
@CF01844 DC    F'11'
@CF01880 DC    F'14'
@CF00104 DC    F'15'
@CF00851 DC    F'36'
@CF00042 DC    F'40'
@CF01850 DC    F'255'
@CF01898 DC    F'-11'
@CF01901 DC    F'-10'
@CF01143 DC    F'-3'
@CF01899 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
REG15    DS    F
LNKTTCIN DS    H
         DS    0D
@TS00001 DS    CL8
CHARRLN  DS    CL3
PACKRLN  DS    CL2
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGCH010D CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01842 DC    C'TP='
@CC01846 DC    C'000'
@CC01873 DC    C'V7'
@CC01874 DC    C'07'
@CC01875 DC    C'09'
@CC01876 DC    C'06'
@CB01379 DC    X'08000002'
PATCH    DC    XL104'0'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PTRSTOP  EQU   @11
PTRCHAR  EQU   @05
RETCODE  EQU   @09
PHYTTCIN EQU   @11
FIXEDRLN EQU   @05
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RAVT     EQU   @04
RPRF     EQU   @06
RTRM     EQU   @08
REG00    EQU   @00
REG01    EQU   @01
RPARM    EQU   @01
REG10    EQU   @10
RSAVE    EQU   @13
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
AVTCSTCS EQU   IEDQAVTD+328
AVTREADD EQU   IEDQAVTD+380
AVTBUFSW EQU   IEDQAVTD+384
@NM00004 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00004
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTAS    EQU   IEDQAVTD+456
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTBFRFG EQU   IEDQAVTD+784
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTDCTLN EQU   IEDQAVTD+1072
AVTBIT4  EQU   IEDQAVTD+1136
@NM00086 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IHADCB   EQU   0
DCBPTR   EQU   0
IHADCS16 EQU   0
DCBMHA   EQU   IHADCS16
DCBBUFOU EQU   DCBMHA
DCBBUFIN EQU   DCBBUFOU
DCBPCI   EQU   IHADCS16+5
DCBDSORG EQU   IHADCS16+6
DCBDSRG1 EQU   DCBDSORG
DCBDSGIS EQU   DCBDSRG1
DCBDSRG2 EQU   DCBDSORG+1
IHADCS17 EQU   0
DCBCLPS  EQU   IHADCS17
DCBIOBAD EQU   IHADCS17+8
IHADCS18 EQU   0
DCBTRANA EQU   IHADCS18
IHADCS19 EQU   0
DCBLCBAD EQU   IHADCS19
DCBCPRI  EQU   DCBLCBAD
DCBEXLST EQU   IHADCS19+4
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS43 EQU   0
DCBSCTAB EQU   IHADCS43
IHADCS2A EQU   0
DCBRESER EQU   IHADCS2A
DCBINVLI EQU   IHADCS2A+4
DCBINVCI EQU   DCBINVLI
IEDDCT   EQU   0
DCTBYTE1 EQU   IEDDCT+1
DCTUMASK EQU   DCTBYTE1
DCTBYTE2 EQU   IEDDCT+2
DCTBYTE3 EQU   IEDDCT+3
DCTBYTE4 EQU   IEDDCT+4
DCTBYTE5 EQU   IEDDCT+5
IEDQDEB  EQU   0
DEBPRF   EQU   IEDQDEB
DEBAPVT  EQU   DEBPRF
DEBNMEXT EQU   IEDQDEB+52
DEBUCBS  EQU   IEDQDEB+68
IEDQDPTR EQU   0
IEDQOPCE EQU   0
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCTOTE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCRLN    EQU   IEDQOPCE+15
@NM00129 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00129
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCALLFLG EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCNONE   EQU   OCALSTAT
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCDOUBL EQU   IEDQOPCD
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCDCBLK EQU   IEDQOPCD+16
OPCTOFLK EQU   IEDQOPCD+24
OPCTRMWA EQU   IEDQOPCD+52
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCGETBF EQU   IEDQOPCD+276
OPCSPEC  EQU   IEDQOPCD+300
OPCRSTRT EQU   OPCSPEC
OPCWRKSP EQU   IEDQOPCD+320
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
IEDQPRF  EQU   0
PRFRCB   EQU   IEDQPRF
PRFKEY   EQU   PRFRCB
PRFQCBA  EQU   PRFRCB+1
PRFPRI   EQU   PRFRCB+4
PRFLINK  EQU   PRFRCB+5
PRFTIC   EQU   IEDQPRF+8
PRFTICC  EQU   PRFTIC
PRFNBUNT EQU   IEDQPRF+12
PRFSUNIT EQU   PRFNBUNT
PRFPLQCB EQU   PRFSUNIT
@NM00159 EQU   IEDQPRF+16
PRFSVFFO EQU   @NM00159
PRFSTAT1 EQU   IEDQPRF+20
PRFEOFN  EQU   PRFSTAT1
PRFCORE  EQU   IEDQPRF+21
PRFXTRA  EQU   PRFCORE
PRFSCAN  EQU   IEDQPRF+24
PRFTQBCK EQU   IEDQPRF+26
PRFNTXT  EQU   PRFTQBCK
PRFEOBOF EQU   PRFNTXT
PRFCHDR  EQU   IEDQPRF+32
PRFHQBCK EQU   IEDQPRF+35
PRFDEST  EQU   IEDQPRF+40
IEDQPPTR EQU   0
IEDPF1   EQU   0
PRF1FLG1 EQU   IEDPF1+3
PRF1WD2  EQU   IEDPF1+4
PRF1SEQP EQU   PRF1WD2
PRF1SQID EQU   PRF1SEQP
PRF1TAG1 EQU   PRF1SQID
IEDPF2   EQU   0
PRF2FLG2 EQU   IEDPF2
PRF2WD2  EQU   IEDPF2+4
IEDQQCB  EQU   0
QCBDSFLG EQU   IEDQQCB
QCBDISK  EQU   QCBDSFLG
QCBNREUS EQU   QCBDISK
QCBREUS  EQU   QCBDISK
QCBDRQQ  EQU   QCBDSFLG
QCBELCHN EQU   IEDQQCB+1
QCBEOLDT EQU   IEDQQCB+16
QCBBYTE1 EQU   QCBEOLDT+1
QCBLKRLN EQU   IEDQQCB+18
QCBRETCT EQU   QCBLKRLN
QCBSTAT  EQU   IEDQQCB+19
QCBTRMHO EQU   QCBSTAT
QCBINSRC EQU   IEDQQCB+21
@NM00169 EQU   QCBINSRC
QCBTSOF2 EQU   @NM00169+1
QCBTSOF1 EQU   @NM00169+2
QCBINTVL EQU   IEDQQCB+24
QCBPREN  EQU   IEDQQCB+28
QCBLKRRN EQU   QCBPREN+1
QCBRELLN EQU   IEDQQCB+32
QCBDCBAD EQU   IEDQQCB+33
QCBFLAG  EQU   IEDQQCB+36
QCBTERMQ EQU   QCBFLAG
IEDQQPTR EQU   0
IEDQPQCB EQU   0
QCBFHDLZ EQU   IEDQPQCB+3
QCBPFEFO EQU   QCBFHDLZ+1
QCBFHDTZ EQU   IEDQPQCB+6
QCBINTLF EQU   IEDQPQCB+12
IEDNQCB  EQU   0
QCBSTAT1 EQU   IEDNQCB+4
QCBPLCBA EQU   IEDNQCB+5
IEDQTRM  EQU   0
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMLIST  EQU   TRMLOG
TRMPROC  EQU   TRMLOG
TRMPREF  EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMDESTQ EQU   IEDQTRM+1
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMALTD  EQU   IEDQTRM+8
TRMDEVFL EQU   IEDQTRM+10
TRMSTAT  EQU   IEDQTRM+12
TRMCHCIN EQU   IEDQTRM+16
IEDQTPTR EQU   0
IEDNTRM  EQU   0
TRMBYTE4 EQU   IEDNTRM
TRMBYTE3 EQU   IEDNTRM+1
TRMBYTE2 EQU   IEDNTRM+2
TRMINPG  EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+3
TRMSCPRQ EQU   TRMBYTE1
TRMSTOTE EQU   TRMBYTE1
TRMCOHRT EQU   IEDNTRM+4
TRMBYTE0 EQU   IEDNTRM+6
TRMSIBPT EQU   IEDNTRM+7
TRMTYPE  EQU   IEDNTRM+11
TRMSUBST EQU   IEDNTRM+12
SCANCHAR EQU   0
ALLOCBUF EQU   0
DCBLOCAT EQU   0
IEDQTNT  EQU   0
TRMOFLOC EQU   0
IEDCMD   EQU   0
CMDDATA  EQU   IEDCMD
CMDLNGTH EQU   CMDDATA+2
CMDTEXT  EQU   IEDCMD+8
DEBSUBR  EQU   0
IEDQEPTR EQU   0
IEDQNPTR EQU   0
QCBLDCB  EQU   0
DEBUCB   EQU   DEBUCBS
DEBDVMOD EQU   DEBUCB
DEBUCBAD EQU   DEBUCB+1
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQREQ EQU   OPCAQWD1
OPCAQFST EQU   OPCAQWD1+1
OPCAQWD2 EQU   OPCAQWD+4
OPCAQRQ2 EQU   OPCAQWD2
OPCAQSEC EQU   OPCAQWD2+1
OPCAQWD3 EQU   OPCAQWD+8
TRMPRE1  EQU   TRMBYTE4
TRMNCP1  EQU   TRMBYTE4
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMLINK  EQU   TRMBYTE3
OCCIB    EQU   OCREQVAL
PRFSHDR  EQU   IEDQPRF+42
TRMOPT   EQU   IEDQTRM+20
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00179 EQU   TRMLINK
TRMLSTAT EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMLULOG EQU   TRMLU
TRMINERR EQU   TRMLU
TRMLUREQ EQU   TRMLU
TRMSESRQ EQU   TRMLU
TRMTDIFF EQU   TRMLU
TRMLUTM  EQU   TRMLU
TRMLUIT  EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
@NM00178 EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMIPLDM EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
@NM00177 EQU   TRMNCP1
TRMINOP  EQU   TRMNCP1
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OCICINAC EQU   OCICSW
@NM00134 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00133 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
@NM00181 EQU   CMDDATA+4
@NM00180 EQU   CMDDATA
TRMRLMCT EQU   IEDNTRM+10
TRMCOHTG EQU   TRMSIBPT+1
TRMGPCNT EQU   TRMSIBPT
TRMBUFRD EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
@NM00176 EQU   TRMBYTE0
TRMOUTPT EQU   TRMBYTE0
TRMINPUT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMREMB  EQU   TRMBYTE2
TRMRSACT EQU   TRMBYTE2
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMSIO   EQU   TRMSTAT
@NM00175 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
TRMNCPI  EQU   TRMDEVFL+1
TRMRNTRM EQU   TRMDEVFL+1
@NM00174 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMADDC  EQU   TRMDEVFL
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMPRILK EQU   TRMALTD
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TLISTCNT
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMLINE  EQU   TRMSTATE
QCBTTCIN EQU   QCBPLCBA+1
@NM00173 EQU   QCBPLCBA
@NM00172 EQU   QCBSTAT1
QCBFLUSH EQU   QCBSTAT1
QCBNDXRQ EQU   QCBSTAT1
QCBESIG  EQU   QCBSTAT1
QCBRCVRQ EQU   QCBSTAT1
QCBSNDRQ EQU   QCBSTAT1
QCBWAITC EQU   QCBSTAT1
QCBPLCBN EQU   QCBSTAT1
QCBCHAIN EQU   IEDNQCB
QCBPQBCK EQU   IEDQPQCB+25
QCBPRIPQ EQU   IEDQPQCB+24
QCBCFHDR EQU   IEDQPQCB+21
QCBLFEFO EQU   IEDQPQCB+18
QCBFFEFO EQU   IEDQPQCB+15
QCBPREVF EQU   QCBINTLF
QCBINTFF EQU   IEDQPQCB+9
QCBDATSQ EQU   QCBFHDTZ+1
@NM00171 EQU   QCBFHDTZ
@NM00170 EQU   QCBPFEFO
QCBDATFL EQU   QCBFHDLZ
QCBDNHDR EQU   IEDQPQCB
QCBQBACK EQU   IEDQQCB+37
QCBCKPT  EQU   QCBFLAG
QCBPROC  EQU   QCBFLAG
QCBSDFFO EQU   QCBFLAG
QCBRSRV  EQU   QCBFLAG
QCBREAD  EQU   QCBFLAG
QCBNOBRK EQU   QCBFLAG
QCBTSSES EQU   QCBFLAG
QCBLGBAD EQU   QCBDCBAD
QCBTJID  EQU   QCBLKRRN+1
QCBCARCT EQU   QCBLKRRN
QCBPRLVL EQU   QCBPREN
QCBMSGCT EQU   IEDQQCB+26
QCBEXTO  EQU   QCBINTVL
QCBDISC  EQU   QCBTSOF1
QCBDELAY EQU   QCBTSOF1
QCBPARTO EQU   QCBTSOF1
QCBSATRD EQU   QCBTSOF1
QCBNOBUF EQU   QCBTSOF1
QCBTPUT  EQU   QCBTSOF1
QCBTGET  EQU   QCBTSOF1
QCBWRBRK EQU   QCBTSOF1
QCBSATLC EQU   QCBTSOF2
QCBSATTI EQU   QCBTSOF2
QCBSATCH EQU   QCBTSOF2
QCBSIMRD EQU   QCBTSOF2
QCBDSSMI EQU   QCBTSOF2
QCBPOSTO EQU   QCBTSOF2
QCBBUFQ  EQU   QCBTSOF2
QCBINHBN EQU   QCBTSOF2
QCBSATCT EQU   @NM00169
QCBSCBOF EQU   IEDQQCB+20
QCBTIME  EQU   QCBSTAT
QCBCLOCK EQU   QCBSTAT
QCBSCHDL EQU   QCBSTAT
QCBSMODE EQU   QCBSTAT
QCBSEND  EQU   QCBSTAT
QCBBUFRD EQU   QCBSTAT
QCBEOM   EQU   QCBSTAT
QCBHUCT  EQU   QCBRETCT
QCBIEND  EQU   QCBRETCT
QCBEND   EQU   QCBRETCT
QCBNL    EQU   QCBRETCT
QCBLOGCT EQU   QCBRETCT
@NM00168 EQU   QCBBYTE1
QCBRITRM EQU   QCBBYTE1
@NM00167 EQU   QCBEOLDT
QCBSLINK EQU   IEDQQCB+13
QCBSTPRI EQU   IEDQQCB+12
QCBSTCHN EQU   IEDQQCB+9
QCBSTVTO EQU   IEDQQCB+8
QCBLINK  EQU   IEDQQCB+5
QCBPRI   EQU   IEDQQCB+4
QCBCNTEN EQU   QCBELCHN+2
@NM00166 EQU   QCBELCHN+2
@NM00165 EQU   QCBELCHN
QCBHELD  EQU   QCBDSFLG
QCBFQCB  EQU   QCBDSFLG
QCBALTMH EQU   QCBDSFLG
QCBCORE  EQU   QCBDSFLG
QCBTSQ   EQU   QCBDSFLG
PRF2SEQP EQU   PRF2WD2
@NM00164 EQU   IEDPF2+1
@NM00163 EQU   PRF2FLG2
PRF2TERM EQU   PRF2FLG2
PRF2SMI  EQU   PRF2FLG2
PRF2FORM EQU   PRF2FLG2
PRF2TNTI EQU   PRF2FLG2
PRF1RULN EQU   PRF1SEQP+2
PRF1TAG2 EQU   PRF1SQID+1
@NM00162 EQU   PRF1TAG1
PRF1TAGS EQU   PRF1TAG1
@NM00161 EQU   PRF1FLG1
PRF1LOGD EQU   PRF1FLG1
PRF1USS  EQU   PRF1FLG1
PRF1FORM EQU   PRF1FLG1
PRF1EXPI EQU   PRF1FLG1
PRF1FIDI EQU   PRF1FLG1
PRF1RH   EQU   IEDPF1
PRFISEQ  EQU   IEDQPRF+38
PRFSTXT  EQU   PRFHQBCK
PRFNHDR  EQU   PRFCHDR
PRFCRCD  EQU   IEDQPRF+29
PRFSVSEQ EQU   PRFNTXT+1
PRFSVPRI EQU   PRFEOBOF
PRFISIZE EQU   PRFSCAN+1
@NM00160 EQU   PRFSCAN
PRFEOB   EQU   PRFXTRA+1
PRFSTSO  EQU   PRFXTRA
PRFNHDRN EQU   PRFSTAT1
PRFNLSTN EQU   PRFSTAT1
PRFLOCK  EQU   PRFEOFN
PRFDUPLN EQU   PRFSTAT1
PRFTSMSG EQU   PRFSTAT1
PRFITCPN EQU   PRFSTAT1
PRFERMGN EQU   PRFSTAT1
PRFCNCLN EQU   PRFSTAT1
PRFSVFLG EQU   @NM00159+3
PRFSIZE  EQU   PRFSVFFO+2
PRFSRCE  EQU   PRFSVFFO
PRFLCB   EQU   IEDQPRF+13
PRFPIUO  EQU   PRFPLQCB
PRFTI0   EQU   PRFTIC+1
@NM00158 EQU   PRFTICC
@NM00157 EQU   PRFTICC
@NM00156 EQU   PRFTICC
PRFTICON EQU   PRFTICC
@NM00155 EQU   PRFTICC
@NM00154 EQU   PRFTICC
PRFBFMM  EQU   PRFTICC
PRFEOMSG EQU   PRFTICC
PRFCOUNT EQU   PRFLINK+1
@NM00153 EQU   PRFLINK
PRFFLAGS EQU   PRFPRI
PRFIOADR EQU   PRFQCBA
PRFOPCDE EQU   PRFKEY
OPCBOTTM EQU   IEDQOPCD+1188
OPCDSRWT EQU   IEDQOPCD+1184
@NM00152 EQU   IEDQOPCD+1100
@NM00151 EQU   IEDQOPCD+948
@NM00150 EQU   IEDQOPCD+940
@NM00149 EQU   IEDQOPCD+380
@NM00148 EQU   OPCPWCOB+9
@NM00147 EQU   OPCPWCOB+8
@NM00146 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00145 EQU   OPCSPEC
@NM00144 EQU   OPCSPEC
@NM00143 EQU   OPCSPEC
@NM00142 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00141 EQU   OPCLDNME+5
@NM00140 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00139 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCOPTLK EQU   IEDQOPCD+20
@NM00138 EQU   OCLDNME+4
@NM00137 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00136 EQU   OCREQFLG
@NM00135 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00132 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00131 EQU   OCRSID+1
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
OCDACTIP EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
OCWTGB   EQU   OCTIOT
@NM00130 EQU   @NM00129+2
OCCONID  EQU   OCDEST
OCRESP   EQU   OCFLAG
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00128 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00127 EQU   OCRUDEST+1
@NM00126 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
OCLINK   EQU   IEDQOPCE
DEBAPPAD EQU   IEDQDEB+65
DEBEXSCL EQU   IEDQDEB+64
DEBDCBAD EQU   IEDQDEB+61
DEBPROTG EQU   IEDQDEB+60
DEBECBAD EQU   IEDQDEB+57
DEBPRIOR EQU   IEDQDEB+56
DEBUSRPG EQU   IEDQDEB+53
DEBSYSPG EQU   IEDQDEB+49
DEBOPATB EQU   IEDQDEB+48
DEBIRBAD EQU   IEDQDEB+45
DEBOFLGS EQU   IEDQDEB+44
DEBDEBAD EQU   IEDQDEB+41
DEBAMLNG EQU   IEDQDEB+40
DEBTCBAD EQU   IEDQDEB+37
DEBNMSUB EQU   IEDQDEB+36
@NM00125 EQU   DEBPRF+33
DEBLNGTH EQU   DEBPRF+32
DEBDCBMK EQU   DEBPRF+28
DEBDSCBA EQU   DEBPRF+21
DEBWKARA EQU   DEBPRF+20
DEBXCEA  EQU   DEBAPVT+16
DEBCEA   EQU   DEBAPVT+12
DEBPCIA  EQU   DEBAPVT+8
DEBSIOA  EQU   DEBAPVT+4
DEBEOEA  EQU   DEBAPVT
@NM00124 EQU   DCTBYTE5
DCTL3270 EQU   DCTBYTE5
DCTSCS   EQU   DCTBYTE5
DCTTSPRF EQU   DCTBYTE4
DCTFMPRF EQU   DCTBYTE4
DCT2760  EQU   DCTBYTE3
DCTNOIDL EQU   DCTBYTE3
DCTCONTN EQU   DCTBYTE3
DCTBUFF  EQU   DCTBYTE3
DCTCHECK EQU   DCTBYTE3
DCTENCTL EQU   DCTBYTE3
DCTWTTA  EQU   DCTBYTE3
DCT1050  EQU   DCTBYTE3
DCTAUDIO EQU   DCTBYTE2
DCTLOCAL EQU   DCTBYTE2
DCTCONT  EQU   DCTBYTE2
DCTXMIT  EQU   DCTBYTE2
DCTSTCTL EQU   DCTBYTE2
DCTTWX   EQU   DCTBYTE2
DCTBRDST EQU   DCTBYTE2
DCTBISYN EQU   DCTBYTE2
DCTSADEV EQU   DCTBYTE1
DCT3270  EQU   DCTBYTE1
DCT2741  EQU   DCTBYTE1
DCT5041  EQU   DCTBYTE1
DCTATTEN EQU   DCTBYTE1
DCTBREAK EQU   DCTBYTE1
DCTINHIB EQU   DCTBYTE1
DCTBYTE0 EQU   IEDDCT
DCBINVLA EQU   DCBINVLI+1
@NM00123 EQU   DCBINVCI
DCBINVB2 EQU   DCBINVCI
@NM00122 EQU   DCBINVCI
DCBINVB1 EQU   DCBINVCI
@NM00121 EQU   DCBINVCI
@NM00120 EQU   DCBRESER+2
DCBRESB2 EQU   DCBRESER+1
DCBRESB1 EQU   DCBRESER
DCBBUFSI EQU   IHADCS43+6
DCBUNTCT EQU   IHADCS43+5
DCBILCT  EQU   IHADCS43+4
DCBSCTAD EQU   DCBSCTAB+1
@NM00119 EQU   DCBSCTAB
DCBDEBA  EQU   DCBDEBAD+1
@NM00118 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00117 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBEIOBX EQU   DCBEXLST
DCBLCBA  EQU   DCBLCBAD+1
DCBCPS   EQU   DCBCPRI
DCBCPE   EQU   DCBCPRI
DCBCPR   EQU   DCBCPRI
@NM00116 EQU   DCBCPRI
DCBTRANS EQU   DCBTRANA+1
@NM00115 EQU   DCBTRANA
DCBIOBAA EQU   DCBIOBAD+1
DCBDEVTP EQU   DCBIOBAD
@NM00114 EQU   IHADCS17+7
@NM00113 EQU   IHADCS17+6
@NM00112 EQU   IHADCS17+5
DCBINTVL EQU   IHADCS17+4
DCBCLPSA EQU   DCBCLPS+1
DCBBUFRQ EQU   DCBCLPS
DCBBUFMA EQU   IHADCS16+8
@NM00111 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00110 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
@NM00109 EQU   DCBDSRG1
@NM00108 EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGDA EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBPCIR2 EQU   DCBPCI
DCBPCIR1 EQU   DCBPCI
DCBPCIN2 EQU   DCBPCI
DCBPCIN1 EQU   DCBPCI
DCBPCIA2 EQU   DCBPCI
DCBPCIA1 EQU   DCBPCI
DCBPCIX2 EQU   DCBPCI
DCBPCIX1 EQU   DCBPCI
@NM00107 EQU   IHADCS16+4
DCBMH    EQU   DCBMHA+1
DCBBFOUT EQU   DCBBUFIN
DCBBFIN  EQU   DCBBUFIN
@NM00106 EQU   IHADCB
SAVTLLCB EQU   IEDNSVTD+316
SAVTBITN EQU   IEDNSVTD+312
@NM00105 EQU   SAVTCKQB+8
@NM00104 EQU   SAVTCKEC+1
@NM00103 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00102 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00101 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00100 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00099 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00098 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00097 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00096 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00095 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00094 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00093 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00092 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00091 EQU   IEDQAVTD+1242
@NM00090 EQU   IEDQAVTD+1241
@NM00089 EQU   IEDQAVTD+1240
@NM00088 EQU   IEDQAVTD+1237
@NM00087 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00086
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00085 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00084 EQU   IEDQAVTD+1140
@NM00083 EQU   IEDQAVTD+1137
@NM00082 EQU   AVTBIT4
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00075 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00074 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00073 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00072 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00071 EQU   AVTBIT2
@NM00070 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00069 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00068 EQU   IEDQAVTD+950
@NM00067 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00066 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00065 EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL1
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00053 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00052 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00051 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00050 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00049 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00048 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00047 EQU   AVTOPCQB+8
@NM00046 EQU   AVTOPCEC+1
@NM00045 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00044 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00043 EQU   AVTCKPEC+1
@NM00042 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00041 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00040 EQU   IEDQAVTD+788
AVTSELCH EQU   IEDQAVTD+785
AVTBFRTN EQU   AVTBFRFG
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00039 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00038 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00037 EQU   AVTSYSER
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00031 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00030 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00029 EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00023 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00022 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00021 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00020 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00019 EQU   AVTSAVTP+1
@NM00018 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00017 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00016 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00015 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00014 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00013 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00012 EQU   AVTPKF
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00009 EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00004+1
@NM00005 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
AVTBUENT EQU   IEDQAVTD+386
@NM00003 EQU   IEDQAVTD+385
AVTFULLT EQU   AVTBUFSW
AVTUNCON EQU   AVTBUFSW
@NM00002 EQU   AVTBUFSW
AVTBUFTR EQU   AVTREADD
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00358 EQU   @RC00350
@RC00356 EQU   @RC00350
TRMOGOOD EQU   AFTERTRM
DCBLGOOD EQU   AFTERDCB
@RF00441 EQU   @RC00438
@RC00443 EQU   @RC00438
@RC00459 EQU   @RC00457
@RC00562 EQU   @EL00002
@RF00607 EQU   @RC00600
@RC00602 EQU   @RC00600
@RC00587 EQU   @EL00003
@RF00369 EQU   @RC00358
@RC00373 EQU   @RC00358
@RC00563 EQU   @RC00562
@RC00565 EQU   @RC00563
@ENDDATA EQU   *
         END   IGCH010D,(C'PLS1610',0701,78090)
