         TITLE 'IGCV910D, 3705 START/STOP TERMINAL LOAD MODULE 1       *
                        '
IGCV910D CSECT ,                                                01S0001
@PROLOG  DS    0H                                               01S0002
         USING *,RBASE              EST. ADDRESSABILITY
         LR    RBASE,RLINK          EST. MODULE BASE
*                                   /*
IGCV910D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*                                                               02S0352
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0352
*                                                               03S0352
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0352
*   ROPCAVT=RPARM;                  /* EST. ADDRESSABILITY FOR OP
*                                      CNTL AVT                      */
         LR    ROPCAVT,RPARM                                    03S0352
*   RAVT=OPCAVTPT;                  /* SET THE BASE POINTER FOR THE
*                                      TCAM ADDRESS VECTOR TABLE     */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0353
*   ROPCE=OPCCOPCE;                 /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ELEMENT      */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0354
*   RSAVE=ADDR(OPCSAVE);            /* SET THE SAVE AREA POINTER
*                                      REGISTER WITH THE POINTER TO
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVE,OPCSAVE(,ROPCAVT)                          03S0355
*   RTRM=SAVEDTRM;                  /* SET TERMINAL ENTRY ADDRESS    */
         L     RTRM,SAVEDTRM(,ROPCE)                            03S0356
*   RTRM=RTRM-LENGTH(IEDNTRM);      /* ES. ADDRESSABILITY            */
         SH    RTRM,@CH00610                                    03S0357
*   SWITCHES=''B;                   /* INTIALIZE EXITS SWITCH   03S0358
*                                                            @YM06075*/
         LA    @09,147                                          03S0358
         ALR   @09,ROPCAVT                                      03S0358
         MVI   SWITCHES(@09),X'00'                              03S0358
*   IF TRMTYPE=TRMCLUST THEN        /* CLUSTER?                      */
         CLI   TRMTYPE(RTRM),X'40'                              02S0359
         BNE   @RF00359                                         02S0359
*     DO;                           /* YES                           */
*       ROPCE->OPREPRI=PRIMEDFG;    /* PRIORITY TO INTERFACE(VA)     */
         MVI   OPREPRI(ROPCE),X'DF'                             02S0361
*       ROPCE->OPREFLG1=OPRVAVF;    /* VA FLAG ROUTER                */
         MVI   OPREFLG1(ROPCE),X'0B'                            02S0362
*       EXITTIME=ON;                /* SET EXIT INDICATOR            */
         OI    EXITTIME(@09),B'10000000'                        02S0363
*       OPCMODID=IGCVA;             /* XCTL NEXT TO IGCVA10D         */
         MVC   OPCMODID(2,ROPCAVT),@CC01593                     02S0364
*     END;                          /* READY TO EXIT                 */
*   ELSE                            /* RESTART OR INITIAL            */
*     DO;                           /* ENTRY                         */
         B     @RC00359                                         02S0366
@RF00359 DS    0H                                               02S0367
*       IF OPCRSTRT=ON THEN         /* RESTART?                      */
         TM    OPCRSTRT(ROPCAVT),B'00100000'                    02S0367
         BNO   @RF00367                                         02S0367
*         CALL EXITVF;              /* READY TO EXIT TO VF           */
         BAL   @14,EXITVF                                       02S0368
*       ELSE                        /* INITIAL ENTRY                 */
*         DO;                       /* YES                           */
         B     @RC00367                                         02S0369
@RF00367 DS    0H                                               02S0370
*                                                               03S0370
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.VERIFY: THIS SUBROUTINE VERIFIES THE TYPE OF  */
*           /* RESOURCE IS VALID.                                    */
*           /*                                                       */
*           /*********************************************************/
*                                                               03S0370
*           DO;                                                 03S0370
*             OCUNIT=INVALTIC;      /* SET INVALID TIC               */
         MVC   OCUNIT(4,ROPCE),@CF01150                         03S0371
*             OCPARM=RETCODE4;      /* RETURN CODE                   */
         MVC   OCPARM(2,ROPCE),@CH00331                         03S0372
*             RZERO=MSG46;          /* OUTPUT ONLY                   */
         LA    RZERO,46                                         03S0373
*             IF TRMSNA=OFF&TRMINPUT=OFF THEN/* OUTPUT ONLY? @YM06084*/
         TM    TRMSNA(RTRM),B'01000010'                         03S0374
         BNZ   @RF00374                                         03S0374
*               CALL EXIT;          /* TO NOTIFY REQUESTOR           */
         BAL   @14,EXIT                                         03S0375
*             ELSE                  /* NOT OUTPUT ONLY               */
*               DO;                 /* SO DETERMINE VALID RESOURCE
*                                      TYPE                          */
         B     @RC00374                                         03S0376
@RF00374 DS    0H                                               03S0377
*                 RQCB=TRMDESTQ;    /* QCB ADDRESS                   */
         SLR   RQCB,RQCB                                        03S0377
         ICM   RQCB,7,TRMDESTQ(RTRM)                            03S0377
*                 RZERO=MSG12;      /* IN TSO SESSION                */
         LA    RZERO,12                                         03S0378
*                 IF QCBTSSES=ON THEN/* TSO SESSION?                 */
         TM    QCBTSSES(RQCB),B'10000000'                       03S0379
         BNO   @RF00379                                         03S0379
*                   CALL EXIT;      /* TO NOTIFY THE REQUESTOR       */
         BAL   @14,EXIT                                         03S0380
*                 ELSE              /* NON TSO               @ZM47552*/
*                   IF TRMSNA=OFF THEN/* PRESNA ?            @ZM47552*/
         B     @RC00379                                         03S0381
@RF00379 TM    TRMSNA(RTRM),B'00000010'                         03S0381
         BNZ   @RF00381                                         03S0381
*                     IF OCTOTE=OFF THEN/* TOTE REQ?                 */
         TM    OCTOTE(ROPCE),B'01000000'                        03S0382
         BNZ   @RF00382                                         03S0382
*                       DO;         /* NO                            */
*                         RZERO=MSG88;/* DIAL - CAN'T VARY           */
         LA    RZERO,88                                         03S0384
*                         IF TRMDIAL=ON THEN/* DIAL?                 */
         TM    TRMDIAL(RTRM),B'00001000'                        03S0385
         BNO   @RF00385                                         03S0385
*                           CALL EXIT;/* GET READY TO EXIT           */
         BAL   @14,EXIT                                         03S0386
*                         ELSE      /* NOT DIAL                      */
*                           DO;     /* TOTE THEN DO                  */
         B     @RC00385                                         03S0387
@RF00385 DS    0H                                               03S0388
*                             RZERO=MSG49;/* TOTE OWN                */
         LA    RZERO,49                                         03S0388
*                             IF TRMSTOTE=ON THEN/* TOTE OWNERSHIP?  */
         TM    TRMSTOTE(RTRM),B'00000001'                       03S0389
         BNO   @RF00389                                         03S0389
*                               CALL EXIT;/* GET READY TO EXIT       */
         BAL   @14,EXIT                                         03S0390
*                             ELSE                              03S0391
*                               ;   /* TOTE DOES NOT OWN             */
@RF00389 DS    0H                                               03S0392
*                           END;    /* PROCESSED TOTE REQUEST        */
*                       END;                                    03S0393
*                     ELSE                                      03S0394
*                       ;           /* TOTE                          */
@RF00382 DS    0H                                               03S0395
*                   ELSE                                        03S0395
*                     ;             /* SNA TERM              @ZM47552*/
@RF00381 DS    0H                                               03S0396
*               END;                                            03S0396
@RC00381 DS    0H                                               03S0396
@RC00379 DS    0H                                               03S0397
*           END;                                                03S0397
@RC00374 DS    0H                                               03S0398
*           IF EXITTIME=OFF THEN    /* VALID RESOURCE TYPE?          */
         TM    EXITTIME+147(ROPCAVT),B'10000000'                02S0398
         BNZ   @RF00398                                         02S0398
*             DO;                   /* YES                           */
*               OPCFLAG1=''B;       /* INITIALIZE THE MID MSG   02S0400
*                                      INDICATOR                     */
         MVI   OPCFLAG1(ROPCAVT),X'00'                          02S0400
*                                                               03S0401
*               /*****************************************************/
*               /*                                                   */
*               /* PROCESS.TESTTYPE: THIS SEGMENT DETERMINES THE TYPE*/
*               /* OF RESOURCE IN THE REQUEST.                       */
*               /*                                                   */
*               /*****************************************************/
*                                                               03S0401
*               DO;                                             03S0401
*                 IF TRMSNA=ON&TRMTYPE=TRMPUNT THEN/* SNA AND A PU?  */
         TM    TRMSNA(RTRM),B'00000010'                         03S0402
         BNO   @RF00402                                         03S0402
         CLI   TRMTYPE(RTRM),X'18'                              03S0402
         BNE   @RF00402                                         03S0402
*                                                               04S0403
*                   /*************************************************/
*                   /*                                               */
*                   /* PROCESS.TESTTYPE.PU: THIS SEGMENT PROCESSES A */
*                   /* VARY FOR PU.                                  */
*                   /*                                               */
*                   /*************************************************/
*                                                               04S0403
*                   DO;                                         04S0403
*                     IF OCSWITCH=OCOFTPEM|OCSWITCH=OCOFTPBM THEN/*
*                                      MIDMSG STOP?                  */
         CLI   OCSWITCH(ROPCE),X'25'                            04S0404
         BE    @RT00404                                         04S0404
         CLI   OCSWITCH(ROPCE),X'26'                            04S0404
         BNE   @RF00404                                         04S0404
@RT00404 DS    0H                                               04S0405
*                       DO;         /* YES                           */
*                         OPCFLAG1=MIDMSG;/* SAVE MIDMSG JUST IN CASE*/
         MVI   OPCFLAG1(ROPCAVT),X'20'                          04S0406
*                         OCSWITCH=OCSWITCH&MIDMSGMK;/* MAP          */
         NI    OCSWITCH(ROPCE),X'DF'                            04S0407
*                       END;                                    04S0408
*                     ELSE                                      04S0409
*                       ;           /* LEAVE AS INITIALIZED          */
@RF00404 DS    0H                                               04S0410
*                     RZERO=ZEROS;  /* RESET ALL INDICATORS          */
         SLR   RZERO,RZERO                                      04S0410
*                     OCALSTAT=''B;                             04S0411
         MVI   OCALSTAT(ROPCE),X'00'                            04S0411
*                     ERREXIT=OFF;                              04S0412
         NI    ERREXIT+147(ROPCAVT),B'10111111'                 04S0412
*                     IF TRMSUBST^=ZEROS THEN/* SUBSTRUCTURES?       */
         SLR   @09,@09                                          04S0413
         ICM   @09,3,TRMSUBST(RTRM)                             04S0413
         LTR   @09,@09                                          04S0413
         BZ    @RF00413                                         04S0413
*                       DO;         /* YES                           */
*                         RPARM=TRMSUBST;/* SETUP INTERFACE TO GETTRM*/
         LR    RPARM,@09                                        04S0415
*                         CALL GETTRM;/* GET TRM ENTRY               */
         BAL   @14,GETTRM                                       04S0416
*                         DO UNTIL(TRMTYPE=TRMPUNT|ERREXIT=ON); 04S0417
@DL00417 DS    0H                                               04S0418
*                                                               05S0418
*                           /*****************************************/
*                           /*                                       */
*                           /* PROCESS.TESTTYPE.PU.VARYLUPU: THIS    */
*                           /* SEGMENT DETERMINES BASED ON REQUEST   */
*                           /* TYPE WHICH SEGMENT SHOULD GET CONTROL.*/
*                           /*                                       */
*                           /*****************************************/
*                                                               05S0418
*                           DO;                                 05S0418
*                             IF OCSWITCH=OCONTPE THEN/* ENTERING?   */
         CLI   OCSWITCH(ROPCE),X'0A'                            05S0419
         BNE   @RF00419                                         05S0419
*                               DO; /* PROCESS TO ENTER              */
*                                                               06S0421
*                                 /***********************************/
*                                 /*                                 */
*                                 /* PROCESS.TESTTYPE.PU.VARYLUPU.ONT*/
*                                 /* PELU: THIS SEGMENT SETS LOGON   */
*                                 /* ARE ALLOWED INDICATOR.          */
*                                 /*                                 */
*                                 /***********************************/
*                                                               06S0421
*                                 DO;                           06S0421
*                                   IF TRMLULOG=ON THEN/* CAPABLE OF
*                                      LOGON                         */
         TM    TRMLULOG(RTRM),B'00000001'                       06S0422
         BNO   @RF00422                                         06S0422
*                                    RZERO=MSG19;/* ALREADY DONE     */
         LA    RZERO,19                                         06S0423
*                                   ELSE/* NO                        */
*                                    CALL SETLOGON;/* SET CAPABLE OF
*                                      LOGON                         */
         B     @RC00422                                         06S0424
@RF00422 BAL   @14,SETLOGON                                     06S0424
*                                 END;                          06S0425
@RC00422 DS    0H                                               06S0426
*                                 IF OCTOTE=ON THEN/* TOTE?          */
         TM    OCTOTE(ROPCE),B'01000000'                        05S0426
         BNO   @RF00426                                         05S0426
*                                   TRMSTOTE=OFF;/* RESET TOTE       */
         NI    TRMSTOTE(RTRM),B'11111110'                       05S0427
*                                 ELSE                          05S0428
*                                   ;/* NOT TOTE                     */
@RF00426 DS    0H                                               05S0429
*                               END;/* PROCESSED ONTPE               */
*                             ELSE  /* DETERMINE TYPE                */
*                               DO; /* ONTPB REQUEST?                */
         B     @RC00419                                         05S0430
@RF00419 DS    0H                                               05S0431
*                                 IF OCSWITCH=OCONTPB THEN/* BOTH
*                                      ALLOWED?                      */
         CLI   OCSWITCH(ROPCE),X'0B'                            05S0431
         BNE   @RF00431                                         05S0431
*                                   DO;/* YES                        */
*                                                               06S0433
*                                    /********************************/
*                                    /*                              */
*                                    /* PROCESS.TESTTYPE.PU.VARYLUPU.*/
*                                    /* ONTPBLU: THIS SEGMENT        */
*                                    /* INTIATES A RELEASE OF THE    */
*                                    /* QUEUE IF NECESSARY AND ALLOWS*/
*                                    /* LOGONS.                      */
*                                    /*                              */
*                                    /********************************/
*                                                               06S0433
*                                    DO;                        06S0433
*                                     IF TRMLULOG=ON&TRMHELDN=OFF THEN
         TM    TRMLULOG(RTRM),B'00000001'                       06S0434
         BNO   @RF00434                                         06S0434
         TM    TRMHELDN(RTRM),B'00000100'                       06S0434
         BNZ   @RF00434                                         06S0434
*                                      /* CAPABLE OF LOGON OR HELD   */
*                                      RZERO=MSG19;/* YES, AND NOT
*                                      HELD                          */
         LA    RZERO,19                                         06S0435
*                                     ELSE/* STILL CAPABLE OF LOGON  */
*                                      DO;/* SO                      */
         B     @RC00434                                         06S0436
@RF00434 DS    0H                                               06S0437
*                                       CALL SETLOGON;/* SET         */
         BAL   @14,SETLOGON                                     06S0437
*                                       IF TRMRSACT=ON&TRMHELDN=ON THEN
         TM    TRMRSACT(RTRM),B'10000000'                       06S0438
         BNO   @RF00438                                         06S0438
         TM    TRMHELDN(RTRM),B'00000100'                       06S0438
         BNO   @RF00438                                         06S0438
*                                        /* ACTLU'D AND HELD?        */
*                                        CALL BUILDREL;/* YES,  06S0439
*                                      REQUEST A RELEASE             */
         BAL   @14,BUILDREL                                     06S0439
*                                       ELSE/* NOT ACTLU'D OR HELD   */
*                                        DO;/* SO                    */
         B     @RC00438                                         06S0440
@RF00438 DS    0H                                               06S0441
*                                         TRMHELDN=OFF;/* RESET HELD */
         NI    TRMHELDN(RTRM),B'11111011'                       06S0441
*                                         QCBTRMHO=OFF;/* STATE      */
         NI    QCBTRMHO(RQCB),B'10111111'                       06S0442
*                                        END;                   06S0443
*                                      END;                     06S0444
@RC00438 DS    0H                                               06S0445
*                                    END;                       06S0445
@RC00434 DS    0H                                               06S0446
*                                    IF OCTOTE=ON THEN/* TOTE REQ?   */
         TM    OCTOTE(ROPCE),B'01000000'                        05S0446
         BNO   @RF00446                                         05S0446
*                                     TRMSTOTE=OFF;/* RESET TOTE
*                                      OWNERSHIP FLAG                */
         NI    TRMSTOTE(RTRM),B'11111110'                       05S0447
*                                    ELSE                       05S0448
*                                     ;/* NOT TOTE                   */
@RF00446 DS    0H                                               05S0449
*                                   END;/* PERFORM ONTPB FUNCTION    */
*                                 ELSE/* ... TYPE? ...               */
*                                   DO;/* PROCESS THE OTHER TYPE WHEN
*                                      FOUND                         */
         B     @RC00431                                         05S0450
@RF00431 DS    0H                                               05S0451
*                                    IF OCSWITCH=OCOFFTPE THEN/* STOP
*                                      ENTERING                      */
         CLI   OCSWITCH(ROPCE),X'05'                            05S0451
         BNE   @RF00451                                         05S0451
*                                     CALL OFFTPELU;/* YES           */
         BAL   @14,OFFTPELU                                     05S0452
*                                    ELSE/* ... TYPE? ...            */
*                                     IF OCSWITCH=OCOFFTPB THEN/*
*                                      STOP BOTH                     */
         B     @RC00451                                         05S0453
@RF00451 CLI   OCSWITCH(ROPCE),X'06'                            05S0453
         BNE   @RF00453                                         05S0453
*                                                               06S0454
*                                      /******************************/
*                                      /*                            */
*                                      /* PROCESS.TESTTYPE.PU.VARYLUP*/
*                                      /* U.OFFTPBLU: THIS SEGMENT   */
*                                      /* INTIATES HOLD OF THE LU'S  */
*                                      /* QUEUE AND SET NO LOGON     */
*                                      /* POSSIBLE AFTER LOGGING OFF.*/
*                                      /*                            */
*                                      /******************************/
*                                                               06S0454
*                                      DO;                      06S0454
*                                       IF AVTAS^=ZEROS THEN/* IEDQAS
*                                      IN SYSTEM?                    */
         ICM   @09,15,AVTAS(RAVT)                               06S0455
         BZ    @RF00455                                         06S0455
*                                        DO;/* YES                   */
*                                         RQCB=TRMDESTQ;/* QCB  06S0457
*                                      ADDRESS                       */
         SLR   RQCB,RQCB                                        06S0457
         ICM   RQCB,7,TRMDESTQ(RTRM)                            06S0457
*                                         IF QCBREUS=OFF&QCBNREUS=OFF&
*                                             OCTOTE=OFF THEN   06S0458
         TM    QCBREUS(RQCB),B'00110000'                        06S0458
         BNZ   @RF00458                                         06S0458
         TM    OCTOTE(ROPCE),B'01000000'                        06S0458
         BNZ   @RF00458                                         06S0458
*                                          DO;/* DISK QUEUEING OR
*                                      TOTE .... NO ....             */
*                                           CALL OFFTPELU;/* CALL
*                                      ENTERING              @YM07729*/
         BAL   @14,OFFTPELU                                     06S0460
*                                          END;                 06S0461
*                                         ELSE/* DISK QUEUEING / TOTE
*                                      FALL THRU                     */
*                                          DO;/* YES,CONTINUE        */
         B     @RC00458                                         06S0462
@RF00458 DS    0H                                               06S0463
*                                           IF TRMHELDN=ON THEN/*
*                                      HELD?                         */
         TM    TRMHELDN(RTRM),B'00000100'                       06S0463
         BNO   @RF00463                                         06S0463
*                                            CALL OFFTPELU;/* YES,
*                                      PERFORM VARYIE                */
         BAL   @14,OFFTPELU                                     06S0464
*                                           ELSE/* NOT HELD          */
*                                            DO;/* YES               */
         B     @RC00463                                         06S0465
@RF00463 DS    0H                                               06S0466
*                                             TRMHELDN=ON;/* SET     */
         OI    TRMHELDN(RTRM),B'00000100'                       06S0466
*                                             CALL BUILDREL;/* SEND
*                                      REQUEST TO REMOVE QCB FROM
*                                      TIME DELAY QUEUE FOR THE 06S0467
*                                      RESOURSE              @ZM46691*/
         BAL   @14,BUILDREL                                     06S0467
*                                             QCBTRMHO=ON;/* HELD
*                                      STATE                         */
         OI    QCBTRMHO(RQCB),B'01000000'                       06S0468
*                                             CALL SETLOGOF;/* RESET
*                                      LOGON CAPABILITY              */
         BAL   @14,SETLOGOF                                     06S0469
*                                            END;               06S0470
*                                          END;                 06S0471
*                                        END;                   06S0472
*                                       ELSE/* QAS IS NOT IN SYSTEM  */
*                                        DO;/* SO                    */
         B     @RC00455                                         06S0473
@RF00455 DS    0H                                               06S0474
*                                         CALL OFFTPELU;/* CALL 06S0474
*                                      ENTERING              @YM07729*/
         BAL   @14,OFFTPELU                                     06S0474
*                                        END;                   06S0475
*                                      END;                     06S0476
*                                     ELSE/* INVALID                 */
*                                      DO;/* REJECT                  */
         B     @RC00453                                         05S0477
@RF00453 DS    0H                                               05S0478
*                                       RZERO=MSG18;/* SETUP MSG
*                                      NUMBER                        */
         LA    RZERO,18                                         05S0478
*                                       CALL EXIT;/* GET READY TO
*                                      EXIT                          */
         BAL   @14,EXIT                                         05S0479
*                                      END;                     05S0480
*                                    IF OCTOTE=ON THEN/* TOTE?       */
@RC00453 DS    0H                                               05S0481
@RC00451 TM    OCTOTE(ROPCE),B'01000000'                        05S0481
         BNO   @RF00481                                         05S0481
*                                     TRMSTOTE=ON;/* SET TOTE   05S0482
*                                      OWNERSHIP                     */
         OI    TRMSTOTE(RTRM),B'00000001'                       05S0482
*                                    ELSE                       05S0483
*                                     ;/* NOT TOTE                   */
@RF00481 DS    0H                                               05S0484
*                                   END;/* COMPLETED REQUESTED  05S0484
*                                      FUNCTION                      */
*                               END;/* REQ TYPE ESTABLISHED          */
@RC00431 DS    0H                                               05S0486
*                           END;                                05S0486
@RC00419 DS    0H                                               05S0487
*                           IF RZERO^=ZEROS&(OCSOME=OFF&OCNONE=OFF)
*                             THEN                              04S0487
*                                                               04S0487
         LTR   RZERO,RZERO                                      04S0487
         BZ    @RF00487                                         04S0487
         TM    OCSOME(ROPCE),B'00000011'                        04S0487
         BNZ   @RF00487                                         04S0487
*                             /***************************************/
*                             /*                                     */
*                             /* MSG NUM AND STATE IS RESET  @YM06144*/
*                             /*                                     */
*                             /***************************************/
*                                                               04S0488
*                             OCNONE=ON;/* INDICATE NONE WERE VARIED */
         OI    OCNONE(ROPCE),B'00000001'                        04S0488
*                           ELSE    /* DETERMINE THE STATUS OF VARY  */
*                             DO;   /* ALL STATUS                    */
         B     @RC00487                                         04S0489
@RF00487 DS    0H                                               04S0490
*                               IF RZERO^=ZEROS&(OCSOME=ON&OCNONE=ON)
*                                 THEN                          04S0490
*                                                               04S0490
         LTR   RZERO,RZERO                                      04S0490
         BZ    @RF00490                                         04S0490
         TM    OCSOME(ROPCE),B'00000011'                        04S0490
         BNO   @RF00490                                         04S0490
*/* GOOD RESPONSE ALL DONE @YM06144                                  */
*                                                               04S0491
*                                 DO;                           04S0491
*                                   OCALSTAT=CLEAR;/* MAKE ONLY ONE
*                                      INDICATOR ON AT A TIME        */
         MVI   OCALSTAT(ROPCE),X'00'                            04S0492
*                                   OCSOME=ON;                  04S0493
         OI    OCSOME(ROPCE),B'00000010'                        04S0493
*                                 END;                          04S0494
*                               ELSE                            04S0495
*                                 DO;/* FIND OUT THE STATUS          */
         B     @RC00490                                         04S0495
@RF00490 DS    0H                                               04S0496
*                                   IF RZERO=ZEROS&(OCSOME=OFF&OCNONE=
*                                       OFF) THEN               04S0496
*                                                               04S0496
         LTR   RZERO,RZERO                                      04S0496
         BNZ   @RF00496                                         04S0496
         TM    OCSOME(ROPCE),B'00000011'                        04S0496
         BNZ   @RF00496                                         04S0496
*                                    /********************************/
*                                    /*                              */
*                                    /* NO MSG NUMBER AND STATUS IS  */
*                                    /* RESET                @YM06144*/
*                                    /*                              */
*                                    /********************************/
*                                                               04S0497
*                                    OCALSTAT=OCALL;/* SET ALL DONE  */
         MVI   OCALSTAT(ROPCE),X'03'                            04S0497
*                                   ELSE/* DETERMINE CURRENT STATE   */
*                                    DO;/* ELIMINATED ONE STATUS     */
         B     @RC00496                                         04S0498
@RF00496 DS    0H                                               04S0499
*                                     IF RZERO=ZEROS&(OCSOME=OFF&OCNONE
*                                         =ON) THEN             04S0499
*                                                               04S0499
         LTR   RZERO,RZERO                                      04S0499
         BNZ   @RF00499                                         04S0499
         TM    OCNONE(ROPCE),B'00000001'                        04S0499
         BNO   @RF00499                                         04S0499
         TM    OCSOME(ROPCE),B'00000010'                        04S0499
         BNZ   @RF00499                                         04S0499
*                                      /******************************/
*                                      /*                            */
*                                      /* NO MSG AND STATUS IS NONE  */
*                                      /*                    @YM06144*/
*                                      /*                            */
*                                      /******************************/
*                                                               04S0500
*                                      DO;/* YES                     */
*                                       OCNONE=OFF;/* RESET NONE
*                                      STATUS                        */
*                                       OCSOME=ON;/* SET SOME   04S0502
*                                      INDICATOR                     */
         OI    OCSOME(ROPCE),B'00000010'                        04S0502
         NI    OCNONE(ROPCE),B'11111110'                        04S0502
*                                      END;/* RESET AND SET STATUS   */
*                                     ELSE                      04S0504
*                                      ;/* LEAVE AS IS               */
@RF00499 DS    0H                                               04S0505
*                                    END;/* THE STATUS HAS BEEN 04S0505
*                                      UPDATED                       */
*                                 END;/* GOT THE STATUS              */
@RC00496 DS    0H                                               04S0507
*                             END;  /* SOME,ALL,NONE                 */
@RC00490 DS    0H                                               04S0508
*                           RPARM=TRMCOHRT;/* GET NEXT TNT INDEX     */
@RC00487 SLR   RPARM,RPARM                                      04S0508
         ICM   RPARM,3,TRMCOHRT(RTRM)                           04S0508
*                           CALL GETTRM;/* GET TRM ENTRY             */
         BAL   @14,GETTRM                                       04S0509
*                           RZERO=ZEROS;/* INTIALIZE FOR NEXT LU     */
         SLR   RZERO,RZERO                                      04S0510
*                         END;      /* END OF DO UNTIL               */
@DE00417 CLI   TRMTYPE(RTRM),X'18'                              04S0511
         BE    @DC00417                                         04S0511
         TM    ERREXIT+147(ROPCAVT),B'01000000'                 04S0511
         BNO   @DL00417                                         04S0511
@DC00417 DS    0H                                               04S0512
*                         IF ERREXIT=OFF THEN/* ERROR CONDITION?     */
         TM    ERREXIT+147(ROPCAVT),B'01000000'                 04S0512
         BNZ   @RF00512                                         04S0512
*                           CALL EXITVF;/* NORMAL EXIT TO VF         */
         BAL   @14,EXITVF                                       04S0513
*                         ELSE                                  04S0514
*                           ;       /* ERROR DO NO MORE              */
@RF00512 DS    0H                                               04S0515
*                       END;        /* SUBSTRUCTURE PROCESSED        */
*                     ELSE          /* NO SUBSTRUCTURES              */
*                       DO;         /* YES                           */
         B     @RC00413                                         04S0516
@RF00413 DS    0H                                               04S0517
*                         IF OCTOTE=ON THEN/* TOTE?                  */
         TM    OCTOTE(ROPCE),B'01000000'                        04S0517
         BNO   @RF00517                                         04S0517
*                           DO;     /* YES                           */
*                             OCPARM=RETCODE8;/* EIGHT AS RETURN CODE*/
         MVC   OCPARM(2,ROPCE),@CH00045                         04S0519
*                             CALL EXIT;/* GET READY TO EXIT         */
         BAL   @14,EXIT                                         04S0520
*                           END;    /* NOW                           */
*                         ELSE      /* NOT TOTE                      */
*                           DO;     /* SO                            */
         B     @RC00517                                         04S0522
@RF00517 DS    0H                                               04S0523
*                             RZERO=MSG561;/* INVALID COMMAND        */
         LA    RZERO,561                                        04S0523
*                             CALL EXIT;/* GET READY TO EXIT         */
         BAL   @14,EXIT                                         04S0524
*                           END;    /* TO NOTIFY THE USER            */
*                       END;        /* READY TO WARN THE USER        */
*                   END;                                        04S0527
*                 ELSE              /* EITHER A LU OR PRESNA DEVICE  */
*                                                               04S0528
*                   /*************************************************/
*                   /*                                               */
*                   /* PROCESS.TESTTYPE.SINGLTRM: THIS SEGMENT       */
*                   /* PROCESS THE START/STOP TERMINAL OPERATOR      */
*                   /* CONTROL COMMAND AGAINST A PRESNA DEVICE OR A  */
*                   /* LU.                                           */
*                   /*                                               */
*                   /*************************************************/
*                                                               04S0528
*                   DO;                                         04S0528
         B     @RC00402                                         04S0528
@RF00402 DS    0H                                               04S0529
*                     IF OCSWITCH=OCOFTPEM|OCSWITCH=OCOFTPBM THEN/*
*                                      MIDMSG STOP                   */
         CLI   OCSWITCH(ROPCE),X'25'                            04S0529
         BE    @RT00529                                         04S0529
         CLI   OCSWITCH(ROPCE),X'26'                            04S0529
         BNE   @RF00529                                         04S0529
@RT00529 DS    0H                                               04S0530
*                       DO;         /* YES                           */
*                         OPCFLAG1=MIDMSG;/* SET MIDMSG              */
         MVI   OPCFLAG1(ROPCAVT),X'20'                          04S0531
*                         OCSWITCH=OCSWITCH&MIDMSGMK;/* TURN OFF
*                                      MIDDLE MSG                    */
         NI    OCSWITCH(ROPCE),X'DF'                            04S0532
*                       END;                                    04S0533
*                     ELSE                                      04S0534
*                       ;           /* LEAVE AS INITIALIZED          */
@RF00529 DS    0H                                               04S0535
*                     IF OCSWITCH=OCONTPE THEN/* ENTERING REQ?       */
         CLI   OCSWITCH(ROPCE),X'0A'                            04S0535
         BNE   @RF00535                                         04S0535
*                       DO;         /* YES                           */
*                         IF TRMTYPE=TRMLUNT THEN/* LU?              */
         CLI   TRMTYPE(RTRM),X'30'                              04S0537
         BNE   @RF00537                                         04S0537
*                                                               05S0538
*                           /*****************************************/
*                           /*                                       */
*                           /* PROCESS.TESTTYPE.SINGLTRM.LUONTPE:    */
*                           /* THIS SEGMENT PERFORMS VARY,ONTPE FOR A*/
*                           /* LU..... ALLOW LOGONS.                 */
*                           /*                                       */
*                           /*****************************************/
*                                                               05S0538
*                           DO;                                 05S0538
*                             IF TRMLULOG=ON THEN/* LOGON ALLOWED?   */
         TM    TRMLULOG(RTRM),B'00000001'                       05S0539
         BNO   @RF00539                                         05S0539
*                               DO; /* YES                           */
*                                 RZERO=MSG19;/* WARN THE USER       */
         LA    RZERO,19                                         05S0541
*                                 CALL EXIT;/* GET READY TO EXIT     */
         BAL   @14,EXIT                                         05S0542
*                               END;/* DONE                          */
*                             ELSE  /* LOGONS NOT POSSIBLE           */
*                               DO; /* NO                            */
         B     @RC00539                                         05S0544
@RF00539 DS    0H                                               05S0545
*                                 CALL SETLOGON;/* MARK LOGON   05S0545
*                                      POSSIBLE                      */
         BAL   @14,SETLOGON                                     05S0545
*                                 CALL EXITVF;/* XCTL TO VF          */
         BAL   @14,EXITVF                                       05S0546
*                               END;                            05S0547
*                           END;                                05S0548
*                         ELSE      /* PRESNA                        */
*                           CALL ONTPE;/* YES, PROCESS IT            */
         B     @RC00537                                         04S0549
@RF00537 BAL   @14,ONTPE                                        04S0549
*                       END;        /* PROCESSED ONTPE               */
*                     ELSE          /* NO DETERMINE REQ TYPE         */
*                       DO;         /* WHICH TYPE                    */
         B     @RC00535                                         04S0551
@RF00535 DS    0H                                               04S0552
*                         IF OCSWITCH=OCONTPB THEN/* BOTH?           */
         CLI   OCSWITCH(ROPCE),X'0B'                            04S0552
         BNE   @RF00552                                         04S0552
*                           DO;     /* YES                           */
*                             IF TRMTYPE=TRMLUNT THEN/* LU?          */
         CLI   TRMTYPE(RTRM),X'30'                              04S0554
         BNE   @RF00554                                         04S0554
*                                                               05S0555
*                               /*************************************/
*                               /*                                   */
*                               /* PROCESS.TESTTYPE.SINGLTRM.LUONTPB:*/
*                               /* THIS SEGMENT INTIATES A RELEASE OF*/
*                               /* LU'S QUE AND ALLOWS LOGONS.       */
*                               /*                                   */
*                               /*************************************/
*                                                               05S0555
*                               DO;                             05S0555
*                                 IF TRMLULOG=ON&TRMHELDN=OFF THEN/*
*                                      LOGON ALLOWED AND QUE IS      */
         TM    TRMLULOG(RTRM),B'00000001'                       05S0556
         BNO   @RF00556                                         05S0556
         TM    TRMHELDN(RTRM),B'00000100'                       05S0556
         BNZ   @RF00556                                         05S0556
*                                   DO;/* NOT HELD THEN              */
*                                    RZERO=MSG19;/* MSG NUMBER       */
         LA    RZERO,19                                         05S0558
*                                    CALL EXIT;/* GET READY TO EXIT  */
         BAL   @14,EXIT                                         05S0559
*                                   END;                        05S0560
*                                 ELSE/* INCAPABLE OF LOGONS         */
*                                   DO;/* SO                         */
         B     @RC00556                                         05S0561
@RF00556 DS    0H                                               05S0562
*                                    CALL SETLOGON;/* NOW CAPABLE OF
*                                      LOGONS                        */
         BAL   @14,SETLOGON                                     05S0562
*                                    IF TRMRSACT=ON&TRMHELDN=ON THEN
         TM    TRMRSACT(RTRM),B'10000000'                       05S0563
         BNO   @RF00563                                         05S0563
         TM    TRMHELDN(RTRM),B'00000100'                       05S0563
         BNO   @RF00563                                         05S0563
*                                     /* ACTLU'D AND QUE HELD        */
*                                     DO;/* THEN                     */
*                                      IF AVTAS^=ZEROS THEN/* RELEASE
*                                      IN SYSTEM?                    */
         ICM   @09,15,AVTAS(RAVT)                               05S0565
         BZ    @RF00565                                         05S0565
*                                       DO;/* YES                    */
*                                        CALL BUILDREL;/* BUILD 05S0567
*                                      REQUEST ELEMENT               */
         BAL   @14,BUILDREL                                     05S0567
*                                        CALL EXITVF;/* XCTL TO VF   */
         BAL   @14,EXITVF                                       05S0568
*                                       END;                    05S0569
*                                      ELSE/* QAS NOT IN THE SYSTEM  */
*                                       DO;/* YES                    */
         B     @RC00565                                         05S0570
@RF00565 DS    0H                                               05S0571
*                                        RZERO=MSG60;/* MSG NUMBER   */
         LA    RZERO,60                                         05S0571
*                                        CALL EXIT;/* GET READY TO
*                                      EXIT                          */
         BAL   @14,EXIT                                         05S0572
*                                       END;                    05S0573
*                                     END;                      05S0574
*                                    ELSE/* INACTIVE                 */
*                                     DO;/* THEN                     */
         B     @RC00563                                         05S0575
@RF00563 DS    0H                                               05S0576
*                                      TRMHELDN=OFF;/* RESET HELD    */
         NI    TRMHELDN(RTRM),B'11111011'                       05S0576
*                                      QCBTRMHO=OFF;/* STATE         */
         NI    QCBTRMHO(RQCB),B'10111111'                       05S0577
*                                      CALL EXITVF;/* TIME TO EXIT   */
         BAL   @14,EXITVF                                       05S0578
*                                     END;                      05S0579
*                                   END;                        05S0580
*                               END;                            05S0581
*                             ELSE  /* PRESNA                        */
*                                                               05S0582
*                               /*************************************/
*                               /*                                   */
*                               /* PROCESS.TESTTYPE.ONTPB: THIS      */
*                               /* SEGMENT PROCESSES THE VARY,ONTPB  */
*                               /* FOR A PRESNA DEVICE.              */
*                               /*                                   */
*                               /*************************************/
*                                                               05S0582
*                               DO;                             05S0582
         B     @RC00554                                         05S0582
@RF00554 DS    0H                                               05S0583
*                                 CALL ONTPE;/* CALL ENTERING   05S0583
*                                                            @YM07729*/
         BAL   @14,ONTPE                                        05S0583
*                                 IF TRMHELDN=ON THEN/* HELD?        */
         TM    TRMHELDN(RTRM),B'00000100'                       05S0584
         BNO   @RF00584                                         05S0584
*                                   DO;/* YES                        */
*                                    IF TRMRSACT=OFF THEN/* INACTIVE?*/
         TM    TRMRSACT(RTRM),B'10000000'                       05S0586
         BNZ   @RF00586                                         05S0586
*                                     DO;/* YES                      */
*                                      IF TRMGP=ON&TRMGPACT=ON THEN/*
*                                      CAPABLE OF GP AND             */
         TM    TRMGP(RTRM),B'00000100'                          05S0588
         BNO   @RF00588                                         05S0588
         TM    TRMGPACT(RTRM),B'00001000'                       05S0588
         BNO   @RF00588                                         05S0588
*                                       DO;/* GP ACTIVE              */
*                                        NOTALLMG=ON;/* OMIT ALL IN
*                                      THE MSG               @YM06140*/
         OI    NOTALLMG(ROPCE),B'01000000'                      05S0590
*                                        EXITTIME=ON;/* SET EXIT
*                                      INDICATORS                    */
         OI    EXITTIME+147(ROPCAVT),B'10000000'                05S0591
*                                        OPCMODID=IGCR0;/* XCTL TO
*                                      RELEASE                       */
         MVC   OPCMODID(2,ROPCAVT),@CC01591                     05S0592
*                                       END;/* READY TO GIVE R0 05S0593
*                                      CONTROL                       */
*                                      ELSE/* NON-GP                 */
*                                       CALL BUILDREL;/* BUILD & POST
*                                      RELEASE REQ                   */
         B     @RC00588                                         05S0594
@RF00588 BAL   @14,BUILDREL                                     05S0594
*                                     END;/* DONE FINI WITH GP       */
*                                    ELSE/* ACTIVE                   */
*                                     DO;/* YES                      */
         B     @RC00586                                         05S0596
@RF00586 DS    0H                                               05S0597
*                                      NOTALLMG=ON;/* OMIT ALL IN THE
*                                      MSG                   @YM06140*/
         OI    NOTALLMG(ROPCE),B'01000000'                      05S0597
*                                      EXITTIME=ON;/* SER EXIT  05S0598
*                                      INDICATOR                     */
         OI    EXITTIME+147(ROPCAVT),B'10000000'                05S0598
*                                      OPCMODID=IGCR0;/* XCTL TO
*                                      RELEASE                       */
         MVC   OPCMODID(2,ROPCAVT),@CC01591                     05S0599
*                                     END;/* ACTIVE DONE...          */
*                                   END;/* HELD QUE                  */
*                                 ELSE                          05S0602
*                                   ;/* NOT HELD             @YM07729*/
@RF00584 DS    0H                                               05S0603
*                               END;                            05S0603
*                           END;    /* PORCESSED ONTPB               */
*                         ELSE      /* TYPE?                         */
*                           DO;     /* FIND OUT WHICH TYPE           */
         B     @RC00552                                         04S0605
@RF00552 DS    0H                                               04S0606
*                             IF OCSWITCH=OCOFFTPE THEN         04S0606
         CLI   OCSWITCH(ROPCE),X'05'                            04S0606
         BNE   @RF00606                                         04S0606
*                               DO; /* YES                           */
*                                 IF TRMTYPE=TRMLUNT THEN/* LU?      */
         CLI   TRMTYPE(RTRM),X'30'                              04S0608
         BNE   @RF00608                                         04S0608
*                                   CALL LUOFFTPE;/* PROCESS IT      */
         BAL   @14,LUOFFTPE                                     04S0609
*                                 ELSE/* PRESNA                      */
*                                                               05S0610
*                                   /*********************************/
*                                   /*                               */
*                                   /* PROCESS.TESTTYPE.OFFTPE: THIS */
*                                   /* SEGMENT PROCESSES A           */
*                                   /* VARY,OFFTPE COMMAND FOR A     */
*                                   /* PRESNA DEVICE.                */
*                                   /*                               */
*                                   /*********************************/
*                                                               05S0610
*                                   DO;                         05S0610
         B     @RC00608                                         05S0610
@RF00608 DS    0H                                               05S0611
*                                    IF TRMRSACT=OFF THEN/* ACTIVE   */
         TM    TRMRSACT(RTRM),B'10000000'                       05S0611
         BNZ   @RF00611                                         05S0611
*                                     DO;/* NO                       */
*                                      IF OCTOTE=ON THEN/* TOTE      */
         TM    OCTOTE(ROPCE),B'01000000'                        05S0613
         BNO   @RF00613                                         05S0613
*                                       DO;/* YES                    */
*                                        TRMSTOTE=ON;/* SET TOTE
*                                      OWNERSHIP                     */
         OI    TRMSTOTE(RTRM),B'00000001'                       05S0615
*                                        OCPARM=RETCODE8;/* BAD 05S0616
*                                      RETURN CODE                   */
         MVC   OCPARM(2,ROPCE),@CH00045                         05S0616
*                                       END;                    05S0617
*                                      ELSE/* ERROR WHEN THE    05S0618
*                                      REQUESTOR WAS NOT TOTE        */
*                                       RZERO=MSG25;/* ALREADY  05S0618
*                                      STOPPED                       */
         B     @RC00613                                         05S0618
@RF00613 LA    RZERO,25                                         05S0618
*                                      CALL EXIT;/* GET READY TO EXIT*/
@RC00613 BAL   @14,EXIT                                         05S0619
*                                     END;/* FINI WITH ERROR    05S0620
*                                      CONDITION                     */
*                                    ELSE                       05S0621
*                                     ;/* ACTIVE                     */
@RF00611 DS    0H                                               05S0622
*                                   END;                        05S0622
*                               END;/* PROCESSED OFFTPE              */
*                             ELSE  /* ... TYPE ...                  */
*                               DO; /* ...ELIMINATED ONE...          */
         B     @RC00606                                         04S0624
@RF00606 DS    0H                                               04S0625
*                                 IF OCSWITCH=OCOFFTPB THEN     04S0625
         CLI   OCSWITCH(ROPCE),X'06'                            04S0625
         BNE   @RF00625                                         04S0625
*                                   DO;/* YES                        */
*                                    IF TRMTYPE=TRMLUNT THEN/* LU?   */
         CLI   TRMTYPE(RTRM),X'30'                              04S0627
         BNE   @RF00627                                         04S0627
*                                                               05S0628
*                                     /*******************************/
*                                     /*                             */
*                                     /* PROCESS.TESTTYPE.SINGLTRM.LU*/
*                                     /* OFFTPB: THIS SEGMENT RESETS */
*                                     /* THE LU'S CAPABILITY TO LOGON*/
*                                     /* AND SET HOLD.               */
*                                     /*                             */
*                                     /*******************************/
*                                                               05S0628
*                                     DO;                       05S0628
*                                      IF AVTAS^=ZEROS THEN/* IEDQAS
*                                      IS IN SYSTEM?                 */
         ICM   @09,15,AVTAS(RAVT)                               05S0629
         BZ    @RF00629                                         05S0629
*                                       DO;/* YES                    */
*                                        RQCB=TRMDESTQ;/* GET QCB
*                                      ADDRESS                       */
         SLR   RQCB,RQCB                                        05S0631
         ICM   RQCB,7,TRMDESTQ(RTRM)                            05S0631
*                                        IF QCBREUS=OFF&QCBNREUS=OFF&
*                                            OCTOTE=OFF THEN    05S0632
         TM    QCBREUS(RQCB),B'00110000'                        05S0632
         BNZ   @RF00632                                         05S0632
         TM    OCTOTE(ROPCE),B'01000000'                        05S0632
         BNZ   @RF00632                                         05S0632
*                                         DO;/* DISK QUEUEING OR TOTE
*                                      ....NO....                    */
*                                          CALL LUOFFTPE;/* CALL
*                                      ENTERING              @YM07729*/
         BAL   @14,LUOFFTPE                                     05S0634
*                                         END;                  05S0635
*                                        ELSE/* DISK QUEUEING OR TOTE
*                                      FALL THRU                     */
*                                         DO;                   05S0636
         B     @RC00632                                         05S0636
@RF00632 DS    0H                                               05S0637
*                                          IF TRMHELDN=ON THEN/*
*                                      HELD?                         */
         TM    TRMHELDN(RTRM),B'00000100'                       05S0637
         BNO   @RF00637                                         05S0637
*                                           CALL LUOFFTPE;/* THEN
*                                      PERFORM VARY,OFFTPE           */
         BAL   @14,LUOFFTPE                                     05S0638
*                                          ELSE/* NO                 */
*                                           DO;/* THEN SET HELD      */
         B     @RC00637                                         05S0639
@RF00637 DS    0H                                               05S0640
*                                            TRMHELDN=ON;/* SET HELD */
         OI    TRMHELDN(RTRM),B'00000100'                       05S0640
*                                            CALL BUILDREL;/* SEND
*                                      REQUEST TO REMOVE QCB FROM
*                                      TIME DELAY QUEUE FOR RESOURCE
*                                                            @ZM46691*/
         BAL   @14,BUILDREL                                     05S0641
*                                            QCBTRMHO=ON;/* STATE    */
         OI    QCBTRMHO(RQCB),B'01000000'                       05S0642
*                                            CALL SETLOGOF;/* RESET
*                                      LOGON CAPABILITY              */
         BAL   @14,SETLOGOF                                     05S0643
*                                            CALL EXITVF;/* XCTL TO
*                                      VF                            */
         BAL   @14,EXITVF                                       05S0644
*                                           END;                05S0645
*                                         END;                  05S0646
*                                       END;                    05S0647
*                                      ELSE/* QAS IS NOT IN SYSTEM   */
*                                       CALL LUOFFTPE;/* CALL   05S0648
*                                      ENTERING              @YM07729*/
         B     @RC00629                                         05S0648
@RF00629 BAL   @14,LUOFFTPE                                     05S0648
*                                     END;                      05S0649
*                                    ELSE/* PRESNA                   */
*                                                               05S0650
*                                     /*******************************/
*                                     /*                             */
*                                     /* PROCESS.TESTTYPE.OFFTPB:    */
*                                     /* THIS SEGMENT PROCESSES A    */
*                                     /* VARY,OFFTPB COMMAND FOR A   */
*                                     /* PRESNA DEVICE.              */
*                                     /*                             */
*                                     /*******************************/
*                                                               05S0650
*                                     DO;                       05S0650
         B     @RC00627                                         05S0650
@RF00627 DS    0H                                               05S0651
*                                      RQCB=TRMDESTQ;/* GET QCB 05S0651
*                                      ADDRESS               @OY12258*/
         SLR   RQCB,RQCB                                        05S0651
         ICM   RQCB,7,TRMDESTQ(RTRM)                            05S0651
*                                      IF AVTAS^=ZEROS&/* RELEASE IN
*                                      SYSTEM?               @OY12258*/
*                                          (QCBREUS=ON|QCBNREUS=ON|
*                                          OCTOTE=ON) THEN/* DISK
*                                      QUEUES? AND NOT TOTE  @OY12258*/
         ICM   @09,15,AVTAS(RAVT)                               05S0652
         BZ    @RF00652                                         05S0652
         TM    QCBREUS(RQCB),B'00110000'                        05S0652
         BNZ   @RT00652                                         05S0652
         TM    OCTOTE(ROPCE),B'01000000'                        05S0652
         BNO   @RF00652                                         05S0652
@RT00652 DS    0H                                               05S0653
*                                       DO;/* RIGHT                  */
*                                        IF TRMHELDN=ON THEN/* HELD? */
         TM    TRMHELDN(RTRM),B'00000100'                       05S0654
         BNO   @RF00654                                         05S0654
*                                         DO;/* YES                  */
*                                          IF TRMRSACT=OFF THEN/*
*                                      INACTIVE?             @YM06094*/
         TM    TRMRSACT(RTRM),B'10000000'                       05S0656
         BNZ   @RF00656                                         05S0656
*                                           DO;/* YES        @YM06094*/
*                                            IF OCTOTE=ON THEN/*
*                                      TOTE?                         */
         TM    OCTOTE(ROPCE),B'01000000'                        05S0658
         BNO   @RF00658                                         05S0658
*                                             TRMSTOTE=ON;/* , OTE
*                                      OWNERSHIP                     */
         OI    TRMSTOTE(RTRM),B'00000001'                       05S0659
*                                            ELSE/* NOT TOTE         */
*                                             DO;/* SO DO            */
         B     @RC00658                                         05S0660
@RF00658 DS    0H                                               05S0661
*                                              RZERO=MSG25;/* MSG
*                                      NUMBER                        */
         LA    RZERO,25                                         05S0661
*                                              OPCMODID=IGC03;/* MSG
*                                      MOD ID                        */
         MVC   OPCMODID(2,ROPCAVT),@CC01599                     05S0662
*                                              NOTALLMG=ON;/* OMIT
*                                      ALL IN THE MSG        @YM06140*/
         OI    NOTALLMG(ROPCE),B'01000000'                      05S0663
*                                              EXITTIME=ON;/* SET
*                                      EXIT SWITCH                   */
         OI    EXITTIME+147(ROPCAVT),B'10000000'                05S0664
*                                             END;/* DONE            */
*                                           END;/*           @YM06094*/
*                                          ELSE                 05S0667
*                                           ;/* ACTIVE       @YM06094*/
@RF00656 DS    0H                                               05S0668
*                                         END;/* READY TO NOTIFY USER
*                                      OF ERROR                      */
*                                        ELSE/* NOT HELD             */
*                                         DO;/* INDICATE HELD STATE  */
         B     @RC00654                                         05S0669
@RF00654 DS    0H                                               05S0670
*                                          TRMHELDN=ON;/* SET HELD   */
         OI    TRMHELDN(RTRM),B'00000100'                       05S0670
*                                          CALL BUILDREL;/* BUILD
*                                      REQUEST TO REMOVE QCB FROM
*                                      TIME DELAY QUEUE FOR THE 05S0671
*                                      RESOURCE              @ZM46691*/
         BAL   @14,BUILDREL                                     05S0671
*                                          QCBTRMHO=ON;/* SET HELD IN
*                                      QCB                           */
         OI    QCBTRMHO(RQCB),B'01000000'                       05S0672
*                                         END;/* ....DONE...         */
*                                       END;                    05S0674
*                                      ELSE/* QAS NOT IN OR CANNOT BE
*                                      HELD                  @OY12258*/
*                                       DO;/* YES            @OY12258*/
         B     @RC00652                                         05S0675
@RF00652 DS    0H                                               05S0676
*                                        IF TRMRSACT=OFF THEN/* 05S0676
*                                      INACTIVE?             @OY12258*/
         TM    TRMRSACT(RTRM),B'10000000'                       05S0676
         BNZ   @RF00676                                         05S0676
*                                         DO;/* YES          @OY12258*/
*                                          IF OCTOTE=ON THEN/* TOTE?
*                                                            @OY12258*/
         TM    OCTOTE(ROPCE),B'01000000'                        05S0678
         BNO   @RF00678                                         05S0678
*                                           TRMSTOTE=ON;/* , OTE
*                                      OWNERSHIP             @OY12258*/
         OI    TRMSTOTE(RTRM),B'00000001'                       05S0679
*                                          ELSE/* NOT TOTE   @OY12258*/
*                                           DO;/* SO DO      @OY12258*/
         B     @RC00678                                         05S0680
@RF00678 DS    0H                                               05S0681
*                                            RZERO=MSG25;/* MSG 05S0681
*                                      NUMBER                @OY12258*/
         LA    RZERO,25                                         05S0681
*                                            OPCMODID=IGC03;/* MSG
*                                      MOD ID                @OY12258*/
         MVC   OPCMODID(2,ROPCAVT),@CC01599                     05S0682
*                                            NOTALLMG=ON;/* OMIT ALL
*                                      IN THE MSG            @OY12258*/
         OI    NOTALLMG(ROPCE),B'01000000'                      05S0683
*                                            EXITTIME=ON;/* SET EXIT
*                                      SWITCH                @OY12258*/
         OI    EXITTIME+147(ROPCAVT),B'10000000'                05S0684
*                                           END;/* DONE      @OY12258*/
*                                         END;/*             @OY12258*/
*                                        ELSE                   05S0687
*                                         ;/* ACTIVE         @OY12258*/
@RF00676 DS    0H                                               05S0688
*                                       END;/* READY TO NOTIFY USER
*                                      OF ERROR              @OY12258*/
*                                     END;                      05S0689
*                                   END;/* PROCESSED OFFTPB          */
*                                 ELSE/* INVALID REQ TYPE            */
*                                   DO;/* SET UP THE MSG             */
         B     @RC00625                                         04S0691
@RF00625 DS    0H                                               04S0692
*                                    RZERO=MSG18;/* INVALID MSG 04S0692
*                                      WARNING                       */
         LA    RZERO,18                                         04S0692
*                                    CALL EXIT;/* GET READY TO EXIT  */
         BAL   @14,EXIT                                         04S0693
*                                   END;/* ERROR                     */
*                               END;/* DETERMINED THE REQUEST TYPE   */
@RC00625 DS    0H                                               04S0696
*                           END;    /* FOUND OUT THE TYPE BASED ON
*                                      RESOURCE                      */
@RC00606 DS    0H                                               04S0697
*                       END;        /* OR EXIT WITH INVALID TYPE     */
@RC00552 DS    0H                                               04S0698
*                   END;                                        04S0698
@RC00535 DS    0H                                               04S0699
*               END;                                            03S0699
@RC00402 DS    0H                                               03S0700
*             END;                  /* OK TO PERFORM THE REQUEST     */
*           ELSE                                                02S0701
*             ;                     /* INVALID DEVICE TYPE FOR THE
*                                      REQUEST                       */
@RF00398 DS    0H                                               02S0702
*         END;                      /* PROCESSED INITIAL REQ         */
*     END;                          /* REQUEST FOR IGCV910D          */
@RC00367 DS    0H                                               02S0704
*   IF EXITTIME=OFF THEN            /* TIME TO EXIT                  */
@RC00359 TM    EXITTIME+147(ROPCAVT),B'10000000'                02S0704
         BNZ   @RF00704                                         02S0704
*     DO;                           /*                       @OZ15629*/
*                                                               03S0706
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.BUILDNSL: THIS SEGMENT BUILDS A REQUEST TO        */
*       /* INTERFACE WITH IEDNSL TO INITIATE STOPPING OF I/O FOR THIS*/
*       /* PRESNA RESOURCE.                                          */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0706
*       DO;                                                     03S0706
*         OPCWRKSP(5)=RZERO;        /* SAVE REG 0 FOR THE LOOP  03S0707
*                                                            @YM06121*/
         ST    RZERO,OPCWRKSP+16(,ROPCAVT)                      03S0707
*         RPARM=ONE;                /* ONE BUFFER REQUESTED          */
         LA    RPARM,1                                          03S0708
*         CALL ALLOCBUF;            /* GET THE BUFFER                */
         L     @15,OPCGETBF(,ROPCAVT)                           03S0709
         BALR  @14,@15                                          03S0709
*         RNSL=RPARM;               /* EST. ADDRESSABILITY           */
         LR    RNSL,RPARM                                       03S0710
*         OCUNIT=RPARM;             /* SAVE NSL BUFFER ADDRESS  03S0711
*                                                            @YA10019*/
         ST    RPARM,OCUNIT(,ROPCE)                             03S0711
*         RZERO=OPCWRKSP(5);        /* RESTORE               @YM06121*/
         L     RZERO,OPCWRKSP+16(,ROPCAVT)                      03S0712
*         IEDNSLD=''B;              /* CLEAR                         */
         XC    IEDNSLD(48,RNSL),IEDNSLD(RNSL)                   03S0713
*         NSLOPCEP=ROPCE;           /* SAVE OPCE@ FOR VF             */
         ST    ROPCE,NSLOPCEP(,RNSL)                            03S0714
*         NSLTTEPT=SAVEDTRM;        /* TERM ENTRY @                  */
         MVC   NSLTTEPT(4,RNSL),SAVEDTRM(ROPCE)                 03S0715
*         NSLTTCIN=OCTRMTBL;        /* TNT INDEX                     */
         MVC   NSLTTCIN(2,RNSL),OCTRMTBL(ROPCE)                 03S0716
*         IF OCSWITCH=OCONTPE|OCSWITCH=OCONTPB THEN/* START?         */
         CLI   OCSWITCH(ROPCE),X'0A'                            03S0717
         BE    @RT00717                                         03S0717
         CLI   OCSWITCH(ROPCE),X'0B'                            03S0717
         BNE   @RF00717                                         03S0717
@RT00717 DS    0H                                               03S0718
*           NSLREQTY=NSLSTRTR;      /* SET START                     */
         MVI   NSLREQTY(RNSL),X'03'                             03S0718
*         ELSE                      /* NO,STOP                       */
*           NSLREQTY=NSLSTPTR;      /* SET STOP                      */
         B     @RC00717                                         03S0719
@RF00717 MVI   NSLREQTY(RNSL),X'04'                             03S0719
*         IF OPCFLAG1^=CLEAR THEN   /* CLEAR?                        */
@RC00717 CLI   OPCFLAG1(ROPCAVT),X'00'                          03S0720
         BE    @RF00720                                         03S0720
*           NSLREQTY=NSLSTPTR+NSLSTMSG;/* NO, SET MIDDLE OF MSG      */
         MVI   NSLREQTY(RNSL),X'0C'                             03S0721
*         ELSE                                                  03S0722
*           ;                       /* CLEAR, DO NO MORE             */
@RF00720 DS    0H                                               03S0723
*         NSLPRIBK=PRIMEDFG;        /* PRIORITY TO RETURN TO OP 03S0723
*                                      CONTROL                       */
         MVI   NSLPRIBK(RNSL),X'DF'                             03S0723
*         NSLFLGBK=OPRVF;           /* FLAGS - ROUTER TO VF          */
         MVI   NSLFLGBK(RNSL),X'07'                             03S0724
*         RNSL->OPREQCB=SAVTSPLN;   /* NSL QCB                       */
         L     @09,AVTSAVTP(,RAVT)                              03S0725
         MVC   OPREQCB(3,RNSL),SAVTSPLN+1(@09)                  03S0725
*         RNSL->OPREPRI=PRIOPCTL;   /* PRIORITY                      */
         MVI   OPREPRI(RNSL),X'DC'                              03S0726
*         IF OCSWITCH=OCONTPB&TRMHELDN=ON THEN/* ONTPB AND HELD?     */
         CLI   OCSWITCH(ROPCE),X'0B'                            03S0727
         BNE   @RF00727                                         03S0727
         TM    TRMHELDN(RTRM),B'00000100'                       03S0727
         BNO   @RF00727                                         03S0727
*           NSLBUFFR=OPCWRKSP(6);   /* SAVE REL BUFFER TO BE POSTED
*                                      BY NSL                        */
         MVC   NSLBUFFR(3,RNSL),OPCWRKSP+21(ROPCAVT)            03S0728
*         ELSE                                                  03S0729
*           ;                       /* NOT ONTPB OR HELD             */
@RF00727 DS    0H                                               03S0730
*         OPCAQFST=RNSL;            /* BUILD PARAMETER LIST          */
         STCM  RNSL,7,OPCAQFST(ROPCAVT)                         03S0730
*         OPCAQREQ=TPOST;           /* POST CODE                     */
         MVI   OPCAQREQ(ROPCAVT),X'0C'                          03S0731
*         OPCAQSEC=RNSL;            /* ONE ELEMENT TO POST           */
         STCM  RNSL,7,OPCAQSEC(ROPCAVT)                         03S0732
*         OPCAQRQ2=ENDLIST;         /* END OF LIST CODE              */
         MVI   OPCAQRQ2(ROPCAVT),X'80'                          03S0733
*         RPARM=ADDR(OPCAQCTL);     /* PARAMETER LIST ADDRESS        */
         LA    RPARM,OPCAQCTL(,ROPCAVT)                         03S0734
*         SVC(102);                 /* SVC 102                       */
         SVC   102                                              03S0735
*         OCWTG=IGCVF;              /* VF TO GET CONTROL NEXT        */
         MVC   OCWTG(2,ROPCE),@CC01595                          03S0736
*         OCLINK=OPCWAITV;          /* LINK OPCE ON WAIT CHAIN       */
         MVC   OCLINK(4,ROPCE),OPCWAITV(ROPCAVT)                03S0737
*         OPCWAITV=ROPCE;           /* AT THE TOP                    */
         ST    ROPCE,OPCWAITV(,ROPCAVT)                         03S0738
*         OPCWAITV=OPCWAITV&MASKBYTE;/* CLEAR HIGH ORDER BYTE        */
         L     @09,OPCWAITV(,ROPCAVT)                           03S0739
         N     @09,@CF01617                                     03S0739
         ST    @09,OPCWAITV(,ROPCAVT)                           03S0739
*         OPCMODID=IGC00;           /* NEXT TO GET CONTROL           */
         MVC   OPCMODID(2,ROPCAVT),@CC01597                     03S0740
*         RZERO=CLEAR;              /* CLEAR AS INTERFACE TO 00      */
         SLR   RZERO,RZERO                                      03S0741
*       END;                                                    03S0742
*     END;                          /*                       @OZ15629*/
*   ELSE                                                        02S0744
*     ;                             /* READY TO EXIT                 */
@RF00704 DS    0H                                               02S0745
*                                                               02S0745
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL SYSTEM    */
*   /* MACRO INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL */
*   /* TO THE NEXT MODULE THAT IS TO BE EXECUTED.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0745
*   RPARM=ROPCAVT;                  /* SET THE ARGUMENT REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO THE NEXT MODULE    */
         LR    RPARM,ROPCAVT                                    02S0745
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(RLINK);       02S0746
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*                                                               02S0747
*   /*****************************************************************/
*   /*                                                               */
*   /* EXITVF: THIS SEGMENT CONTAINS THE EXIT CODE TO IGCVF10D WITH  */
*   /* AN OPCE.                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0747
*EXITVF:                                                        02S0747
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0747
EXITVF   DS    0H                                               02S0748
*   OPCWRKSP(5)=RRETURN;            /* SAVE THE RETURN ADDRESS       */
         ST    RRETURN,OPCWRKSP+16(,ROPCAVT)                    02S0748
*   EXITTIME=ON;                    /* TIME TO EXIT                  */
         OI    EXITTIME+147(ROPCAVT),B'10000000'                02S0749
*   OPCMODID=IGCVF;                 /* VF TO GET CONTROL NEXT        */
         MVC   OPCMODID(2,ROPCAVT),@CC01595                     02S0750
*   ROPCE->OPREPRI=PRIMEDFG;        /* PRIORITY                      */
         MVI   OPREPRI(ROPCE),X'DF'                             02S0751
*   ROPCE->OPREFLG1=OPRVAVF;        /* FLAG                          */
         MVI   OPREFLG1(ROPCE),X'0B'                            02S0752
*   RRETURN=OPCWRKSP(5);            /* RESTORE RETURN ADDRESS        */
         L     @09,OPCWRKSP+16(,ROPCAVT)                        02S0753
         LR    RRETURN,@09                                      02S0753
*   END EXITVF;                     /* EXIT NOW                      */
@EL00002 DS    0H                                               02S0754
@EF00002 DS    0H                                               02S0754
@ER00002 BR    @14                                              02S0754
*                                                               02S0755
*   /*****************************************************************/
*   /*                                                               */
*   /* ONTPE: THIS SEGMENT CONTAINS ONTPE INTERNAL PROCEDURE WHICH   */
*   /* PROCESSES THE VARY,ONTPE COMMAND FOR A PRESNA DEVICE.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0755
*ONTPE:                                                         02S0755
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0755
ONTPE    DS    0H                                               02S0756
*   OPCWRKSP(1)=RRETURN;            /* SAVE THE RETURN ADDRESS       */
         ST    RRETURN,OPCWRKSP(,ROPCAVT)                       02S0756
*   IF TRMRSACT=OFF THEN            /* INACTIVE                      */
         TM    TRMRSACT(RTRM),B'10000000'                       02S0757
         BNZ   @RF00757                                         02S0757
*     DO;                           /* YES                           */
*       IF TRMGP=ON&TRMGPACT=ON THEN/* CAPABLE OF GENERAL POLL AND GP
*                                      ACTIVE                        */
         TM    TRMGP(RTRM),B'00000100'                          02S0759
         BNO   @RF00759                                         02S0759
         TM    TRMGPACT(RTRM),B'00001000'                       02S0759
         BNO   @RF00759                                         02S0759
*         DO;                                                   02S0760
*           RZERO=MSG19;            /* ALREADY ACTIVE                */
         LA    RZERO,19                                         02S0761
*           CALL EXIT;              /* GET READY TO EXIT             */
         BAL   @14,EXIT                                         02S0762
*         END;                      /* FINI WITH GP                  */
*       ELSE                                                    02S0764
*         ;                         /* NOT GP                        */
@RF00759 DS    0H                                               02S0765
*     END;                          /* INACTIVE                      */
*   ELSE                            /* ACTIVE                        */
*     DO;                           /* SO DO                         */
         B     @RC00757                                         02S0766
@RF00757 DS    0H                                               02S0767
*       RZERO=MSG19;                /* ALREADY STARTED               */
         LA    RZERO,19                                         02S0767
*       CALL EXIT;                  /* GET READY TO EXIT             */
         BAL   @14,EXIT                                         02S0768
*     END;                          /* FINI WITH ACTIVE DEVICE       */
*   RRETURN=OPCWRKSP(1);            /* RESTORE THE RETURN ADDRESS    */
@RC00757 L     RRETURN,OPCWRKSP(,ROPCAVT)                       02S0770
*   END ONTPE;                      /* PERFORMED THE VARY,ONTPE 02S0771
*                                      COMMAND                       */
@EL00003 DS    0H                                               02S0771
@EF00003 DS    0H                                               02S0771
@ER00003 BR    @14                                              02S0771
*                                                               02S0772
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILDREL: THIS SEGMENT BUILDS A ELEMENT TO INTERFACE WITH     */
*   /* IEDQAS TO HAVE A DEVICE QUEUE RELEASED                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0772
*BUILDREL:                                                      02S0772
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0772
BUILDREL DS    0H                                               02S0773
*   OPCWRKSP(4)=RRETURN;            /* SAVE THE RETURN ADDRESS       */
         ST    RRETURN,OPCWRKSP+12(,ROPCAVT)                    02S0773
*   OPCWRKSP(3)=RZERO;              /* SAVE REG 0 FOR THE LOOP  02S0774
*                                                            @YM06121*/
         ST    RZERO,OPCWRKSP+8(,ROPCAVT)                       02S0774
*   RPARM=ONE;                      /* INDICATE ONE BUFFER NEEDED    */
         LA    RPARM,1                                          02S0775
*   CALL ALLOCBUF;                  /* GET A BUFFER                  */
         L     @15,OPCGETBF(,ROPCAVT)                           02S0776
         BALR  @14,@15                                          02S0776
*   RPRF=RPARM;                     /* EST. ADDRESSABILITY           */
         LR    RPRF,RPARM                                       02S0777
*   RZERO=OPCWRKSP(3);              /* RESTORE               @YM06121*/
         L     RZERO,OPCWRKSP+8(,ROPCAVT)                       02S0778
*   PRFQCBA=AVTAS;                  /* QAS QCB ADDR                  */
         MVC   PRFQCBA(3,RPRF),AVTAS+1(RAVT)                    02S0779
*   PRFPRI=PRIRELSE;                /* PRIORITY                      */
         MVI   PRFPRI(RPRF),X'E0'                               02S0780
*   IF OCSWITCH=OCOFFTPB THEN       /* IF SENDING REQUEST TO @ZM46691*/
         CLI   OCSWITCH(ROPCE),X'06'                            02S0781
         BNE   @RF00781                                         02S0781
*     DO;                           /* REMOVE QCB FROM TIME  @ZM46691*/
*       PRFPRI=PRIOPCTL;            /* QUEUE SET CORRECT     @ZM46691*/
         MVI   PRFPRI(RPRF),X'DC'                               02S0783
*     END;                          /* PRIORITY              @ZM46691*/
*   ELSE                                                        02S0785
*     ;                             /*                       @ZM46691*/
@RF00781 DS    0H                                               02S0786
*   PRFTIC=INVALTIC;                /* INDICATE ONE BUFFER UNIT      */
         MVC   PRFTIC(4,RPRF),@CB01150                          02S0786
*   IF OPCFLAG1=MIDMSG THEN         /* IF MID MESSAGE INDICATOR ON
*                                      SET PRFSTAT1          @OZ15629*/
         CLI   OPCFLAG1(ROPCAVT),X'20'                          02S0787
         BNE   @RF00787                                         02S0787
*     PRFSTAT1=ONE;                                             02S0788
         MVI   PRFSTAT1(RPRF),B'00000001'                       02S0788
*   ELSE                                                        02S0789
*     ;                                                         02S0789
@RF00787 DS    0H                                               02S0790
*   PRFNBUNT=ONE;                   /* ONE UNIT                      */
         MVI   PRFNBUNT(RPRF),X'01'                             02S0790
*   PRFDEST=OCTRMTBL;               /* TNT INDEX OF DEVICE           */
         MVC   PRFDEST(2,RPRF),OCTRMTBL(ROPCE)                  02S0791
*   IF OCSWITCH=OCONTPB&TRMSNA=OFF THEN/* ONTP COMMAND AND PRE-SNA?
*                                                            @OZ15629*/
         CLI   OCSWITCH(ROPCE),X'0B'                            02S0792
         BNE   @RF00792                                         02S0792
         TM    TRMSNA(RTRM),B'00000010'                         02S0792
         BNZ   @RF00792                                         02S0792
*     OPCWRKSP(6)=RPRF;             /* SAVE THE POINTER              */
         ST    RPRF,OPCWRKSP+20(,ROPCAVT)                       02S0793
*   ELSE                            /* SNA                           */
*     DO;                           /* GO AHEAD AND POST THE REQ NOW */
         B     @RC00792                                         02S0794
@RF00792 DS    0H                                               02S0795
*       OPCAQFST=RPRF;              /* BUILD AQCTL PARAMETER LIST    */
         STCM  RPRF,7,OPCAQFST(ROPCAVT)                         02S0795
*       OPCAQREQ=TPOST;             /* POST CODE                     */
         MVI   OPCAQREQ(ROPCAVT),X'0C'                          02S0796
*       OPCAQSEC=RPRF;              /* ONE ELEMENT TO POST           */
         STCM  RPRF,7,OPCAQSEC(ROPCAVT)                         02S0797
*       OPCAQRQ2=ENDLIST;           /* END OF LIST CODE              */
         MVI   OPCAQRQ2(ROPCAVT),X'80'                          02S0798
*       RPARM=ADDR(OPCAQCTL);       /* PARM LIST ADDRESS             */
         LA    RPARM,OPCAQCTL(,ROPCAVT)                         02S0799
*       SVC(102);                   /* TCAM CROSS PARTITION     02S0800
*                                      COMMUNICATION ROUTINE         */
         SVC   102                                              02S0800
*     END;                                                      02S0801
*   RRETURN=OPCWRKSP(4);            /* RESTORE THE RETURN ADDRESS    */
@RC00792 L     RRETURN,OPCWRKSP+12(,ROPCAVT)                    02S0802
*   END BUILDREL;                   /* BUILT THE ELEMENT AND PUT IT
*                                      ON READY QUEUE                */
@EL00004 DS    0H                                               02S0803
@EF00004 DS    0H                                               02S0803
@ER00004 BR    @14                                              02S0803
*                                                               02S0804
*   /*****************************************************************/
*   /*                                                               */
*   /* LUOFFTPE: THIS SEGMENT PROCESSES VARY,OFFTPE FOR LU THAT IS   */
*   /* DISALLOW ANY MORE LOGONS.                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0804
*LUOFFTPE:                                                      02S0804
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0804
LUOFFTPE DS    0H                                               02S0805
*   OPCWRKSP(2)=RRETURN;            /* SAVE RETURN ADDRESS           */
         ST    RRETURN,OPCWRKSP+4(,ROPCAVT)                     02S0805
*   IF TRMLULOG=ON THEN             /* LOGONS ALLOWED?               */
         TM    TRMLULOG(RTRM),B'00000001'                       02S0806
         BNO   @RF00806                                         02S0806
*     DO;                           /* YES                           */
*       CALL SETLOGOF;              /* RESET LOGON CAPABILITY        */
         BAL   @14,SETLOGOF                                     02S0808
*       CALL EXITVF;                /* XCTL TO VF                    */
         BAL   @14,EXITVF                                       02S0809
*     END;                          /* ...FINIS                      */
*   ELSE                            /* LOGON NOT ALLOWED             */
*     DO;                           /* SO                            */
         B     @RC00806                                         02S0811
@RF00806 DS    0H                                               02S0812
*       RZERO=MSG25;                /* SET ALREADY                   */
         LA    RZERO,25                                         02S0812
*       IF OCTOTE=ON THEN           /* TOTE?                         */
         TM    OCTOTE(ROPCE),B'01000000'                        02S0813
         BNO   @RF00813                                         02S0813
*         DO;                       /* YES                           */
*           TRMSTOTE=ON;            /* TOTE OWNS NOW                 */
         OI    TRMSTOTE(RTRM),B'00000001'                       02S0815
*           OCPARM=RETCODE8;        /* SET RETURN EODE               */
         MVC   OCPARM(2,ROPCE),@CH00045                         02S0816
*         END;                                                  02S0817
*       ELSE                                                    02S0818
*         ;                         /* NOT TOTE                      */
@RF00813 DS    0H                                               02S0819
*       CALL EXIT;                  /* GET READY TO EXIT             */
         BAL   @14,EXIT                                         02S0819
*     END;                                                      02S0820
*   RRETURN=OPCWRKSP(2);            /* RESTORE RETURN ADDRESS        */
@RC00806 L     RRETURN,OPCWRKSP+4(,ROPCAVT)                     02S0821
*   END LUOFFTPE;                                               02S0822
@EL00005 DS    0H                                               02S0822
@EF00005 DS    0H                                               02S0822
@ER00005 BR    @14                                              02S0822
*                                                               02S0823
*   /*****************************************************************/
*   /*                                                               */
*   /* OFFTPELU: THIS SEGMENT PROCESSES A VARY,OFFTPE FOR LU WHEN THE*/
*   /* INPUT RESOURCE WAS A PU.                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0823
*OFFTPELU:                                                      02S0823
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0823
OFFTPELU DS    0H                                               02S0824
*   OPCWRKSP(3)=RRETURN;                                        02S0824
         ST    RRETURN,OPCWRKSP+8(,ROPCAVT)                     02S0824
*   IF TRMLULOG=OFF THEN            /* CAPABLE OF LOGONS             */
         TM    TRMLULOG(RTRM),B'00000001'                       02S0825
         BNZ   @RF00825                                         02S0825
*     RZERO=MSG25;                  /* NO,                           */
         LA    RZERO,25                                         02S0826
*   ELSE                            /* YES                           */
*     CALL SETLOGOF;                /* RESET CAPABILITY              */
         B     @RC00825                                         02S0827
@RF00825 BAL   @14,SETLOGOF                                     02S0827
*   RRETURN=OPCWRKSP(3);            /* RESTORE RETURN ADDRESS        */
@RC00825 L     RRETURN,OPCWRKSP+8(,ROPCAVT)                     02S0828
*   END OFFTPELU;                                               02S0829
@EL00006 DS    0H                                               02S0829
@EF00006 DS    0H                                               02S0829
@ER00006 BR    @14                                              02S0829
*                                                               02S0830
*   /*****************************************************************/
*   /*                                                               */
*   /* GETTRM: THIS SEGMENT GET A TERMINAL ENTRY ADDRESS.            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0830
*GETTRM:                                                        02S0830
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0830
GETTRM   DS    0H                                               02S0831
*   OPCWRKSP(7)=RRETURN;            /* SAVE THE RETURN ADDRESS       */
         ST    RRETURN,OPCWRKSP+24(,ROPCAVT)                    02S0831
*   OCTRMTBL=RPARM;                 /* SET UP THIS RES TNT INDEX     */
         STH   RPARM,OCTRMTBL(,ROPCE)                           02S0832
*   OPCWRKSP(1)=RZERO;              /* SAVE REG 0            @YM06121*/
         ST    RZERO,OPCWRKSP(,ROPCAVT)                         02S0833
*   CALL IEDQTNT;                   /* GET TRM ENTRY ADDRESS         */
         L     @15,AVTRNMPT(,RAVT)                              02S0834
         BALR  @14,@15                                          02S0834
*   RTRM=RPARM-LENGTH(IEDNTRM);     /* BACKUP TO PREFIX              */
         LR    RTRM,RPARM                                       02S0835
         SH    RTRM,@CH00610                                    02S0835
*   RZERO=OPCWRKSP(1);              /* RESTORE REG 0         @YM06121*/
         L     RZERO,OPCWRKSP(,ROPCAVT)                         02S0836
*   RRETURN=OPCWRKSP(7);            /* RESTORE THE RETURN ADDRESS    */
         L     RRETURN,OPCWRKSP+24(,ROPCAVT)                    02S0837
*   END GETTRM;                                                 02S0838
@EL00007 DS    0H                                               02S0838
@EF00007 DS    0H                                               02S0838
@ER00007 BR    @14                                              02S0838
*                                                               02S0839
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT: THIS SEGMENT SETUP TO NOTIFY THE REQUESTOR.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0839
*EXIT:                                                          02S0839
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0839
EXIT     DS    0H                                               02S0840
*   IF OCTOTE=ON THEN               /* TOTE?                         */
         TM    OCTOTE(ROPCE),B'01000000'                        02S0840
         BNO   @RF00840                                         02S0840
*     DO;                           /* YES                           */
*       RZERO=OCPARM;               /* SETUP RETCODE INTERFACE WITH
*                                      07                            */
         LH    RZERO,OCPARM(,ROPCE)                             02S0842
*       OPCMODID=IGC07;             /* NOTIFY TOTE OF THE RESULTS    */
         MVC   OPCMODID(2,ROPCAVT),@CC01601                     02S0843
*     END;                          /* DONE...                       */
*   ELSE                            /* NORMAL FLOW                   */
*     DO;                           /* YES                           */
         B     @RC00840                                         02S0845
@RF00840 DS    0H                                               02S0846
*       NOTALLMG=ON;                /* OMIT ALL IN THE MSG   @YM06140*/
         OI    NOTALLMG(ROPCE),B'01000000'                      02S0846
*       OPCMODID=IGC03;             /* MSG MOD                       */
         MVC   OPCMODID(2,ROPCAVT),@CC01599                     02S0847
*     END;                                                      02S0848
*   EXITTIME=ON;                    /* SET EXIT SWITCH               */
@RC00840 OI    EXITTIME+147(ROPCAVT),B'10000000'                02S0849
*   END EXIT;                                                   02S0850
@EL00008 DS    0H                                               02S0850
@EF00008 DS    0H                                               02S0850
@ER00008 BR    @14                                              02S0850
*                                                               02S0851
*   /*****************************************************************/
*   /*                                                               */
*   /* SETLOGON: THIS SEGMENT SETS TRMLULOG ON.                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0851
*SETLOGON:                                                      02S0851
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0851
SETLOGON DS    0H                                               02S0852
*   TRMLULOG=ON;                    /* CAPABLE OF LOGON TO TCAM      */
         LA    @11,TRMLULOG(,RTRM)                              02S0852
         LR    @10,@11                                          02S0852
         LA    @09,3                                            02S0852
         NR    @10,@09                                          02S0852
         LCR   @10,@10                                          02S0852
         ALR   @11,@10                                          02S0852
         L     @09,0(,@11)                                      02S0852
@GL00022 LR    @05,@09                                          02S0852
         O     @05,@CB01682+3(@10)                              02S0852
         CS    @09,@05,0(@11)                                   02S0852
         BNE   @GL00022                                         02S0852
*   END SETLOGON;                                               02S0853
@EL00009 DS    0H                                               02S0853
@EF00009 DS    0H                                               02S0853
@ER00009 BR    @14                                              02S0853
*                                                               02S0854
*   /*****************************************************************/
*   /*                                                               */
*   /* SETLOGOF: THIS SEGMENT SETS TRMLULOG OFF.                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0854
*SETLOGOF:                                                      02S0854
*   PROC OPTIONS(RETREG,NOSAVE,NOSAVEAREA);                     02S0854
SETLOGOF DS    0H                                               02S0855
*   TRMLULOG=OFF;                   /* INCAPABLE OF LOGON TO TCAM
*                                      AFTER SESSION TERM            */
         LA    @11,TRMLULOG(,RTRM)                              02S0855
         LR    @10,@11                                          02S0855
         LA    @09,3                                            02S0855
         NR    @10,@09                                          02S0855
         LCR   @10,@10                                          02S0855
         ALR   @11,@10                                          02S0855
         L     @09,0(,@11)                                      02S0855
@GL00023 LR    @05,@09                                          02S0855
         N     @05,@CB01686+3(@10)                              02S0855
         CS    @09,@05,0(@11)                                   02S0855
         BNE   @GL00023                                         02S0855
*   END SETLOGOF;                                               02S0856
@EL00010 DS    0H                                               02S0856
@EF00010 DS    0H                                               02S0856
@ER00010 BR    @14                                              02S0856
*   END IGCV910D                                                01S0857
*                                                               01S0857
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TNSLD   )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TOPRED  )                                       */
*/*%INCLUDE SYSLIB  (TPRFD   )                                       */
*/*%INCLUDE SYSLIB  (TPRIOR  )                                       */
*/*%INCLUDE SYSLIB  (TQCBD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (VERIFY  )                                       */
*/*%INCLUDE SYSUT5  (TESTTYPE)                                       */
*/*%INCLUDE SYSUT5  (PU      )                                       */
*/*%INCLUDE SYSUT5  (VARYLUPU)                                       */
*/*%INCLUDE SYSUT5  (ONTPELU )                                       */
*/*%INCLUDE SYSUT5  (ONTPBLU )                                       */
*/*%INCLUDE SYSUT5  (OFFTPBLU)                                       */
*/*%INCLUDE SYSUT5  (SINGLTRM)                                       */
*/*%INCLUDE SYSUT5  (LUONTPE )                                       */
*/*%INCLUDE SYSUT5  (LUONTPB )                                       */
*/*%INCLUDE SYSUT5  (ONTPB   )                                       */
*/*%INCLUDE SYSUT5  (OFFTPE  )                                       */
*/*%INCLUDE SYSUT5  (LUOFFTPB)                                       */
*/*%INCLUDE SYSUT5  (OFFTPB  )                                       */
*/*%INCLUDE SYSUT5  (BUILDNSL)                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*/*%INCLUDE SYSUT5  (EXITVF  )                                       */
*/*%INCLUDE SYSUT5  (ONTPE   )                                       */
*/*%INCLUDE SYSUT5  (BUILDREL)                                       */
*/*%INCLUDE SYSUT5  (LUOFFTPE)                                       */
*/*%INCLUDE SYSUT5  (OFFTPELU)                                       */
*/*%INCLUDE SYSUT5  (GETTRM  )                                       */
*/*%INCLUDE SYSUT5  (EXIT    )                                       */
*/*%INCLUDE SYSUT5  (SETLOGON)                                       */
*/*%INCLUDE SYSUT5  (SETLOGOF)                                       */
*                                                               01S0857
*       ;                                                       01S0857
@DATA    DS    0H
@CH00331 DC    H'4'
@CH00045 DC    H'8'
@CH00610 DC    H'14'
@DATD    DSECT
         DS    0F
IGCV910D CSECT
         DS    0F
@CF01150 DC    XL4'08000002'
@CF01617 DC    XL4'00FFFFFF'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGCV910D CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01591 DC    C'R0'
@CC01593 DC    C'VA'
@CC01595 DC    C'VF'
@CC01597 DC    C'00'
@CC01599 DC    C'03'
@CC01601 DC    C'07'
@CB01150 DC    X'08000002'
@CB01682 DC    B'000000000000000000000000000000010000000000000000000000C
               00'
@CB01686 DC    B'111111111111111111111111111111101111111111111111111111C
               11'
PATCH    DC    XL10'0'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RTRM     EQU   @08
RAVT     EQU   @04
RPRF     EQU   @06
RQCB     EQU   @07
RNSL     EQU   @06
RZERO    EQU   @00
RPARM    EQU   @01
ROPRE    EQU   @03
RBASE    EQU   @12
RSAVE    EQU   @13
RRETURN  EQU   @14
RLINK    EQU   @15
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
@NM00003 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00003
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTAS    EQU   IEDQAVTD+456
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTBIT4  EQU   IEDQAVTD+1136
@NM00085 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTSPLN EQU   IEDNSVTD+224
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDNNSLD EQU   0
IEDNSLD  EQU   0
NSLPLCB  EQU   IEDNSLD+8
NSLGPCUS EQU   IEDNSLD+12
NSLTTCIN EQU   IEDNSLD+16
NSLPRIBK EQU   IEDNSLD+18
NSLFLGBK EQU   IEDNSLD+19
NSLERB   EQU   IEDNSLD+20
NSLESTAT EQU   NSLERB+8
NSLBUFFR EQU   NSLERB+9
NSLREQTY EQU   IEDNSLD+35
NSLGRPNM EQU   IEDNSLD+36
NSLOPCEP EQU   NSLGRPNM
NSLTTEPT EQU   IEDNSLD+44
IEDNSLP  EQU   0
IEDQOPCE EQU   0
OCLINK   EQU   IEDQOPCE
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCTOTE   EQU   OCFLAG
@NM00114 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00114
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCSOME   EQU   OCALSTAT
OCNONE   EQU   OCALSTAT
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCSAVE  EQU   IEDQOPCD+56
OPCFLAG1 EQU   IEDQOPCD+146
OPCFLAG2 EQU   IEDQOPCD+147
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCGETBF EQU   IEDQOPCD+276
OPCSPEC  EQU   IEDQOPCD+300
OPCRSTRT EQU   OPCSPEC
OPCWRKSP EQU   IEDQOPCD+320
OPCWAITV EQU   IEDQOPCD+364
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
IEDOPRED EQU   0
OPREQCB  EQU   IEDOPRED+1
OPREPRI  EQU   IEDOPRED+4
OPRESAVE EQU   IEDOPRED+8
OPREFLG1 EQU   IEDOPRED+12
OPREFLG3 EQU   IEDOPRED+14
IEDQPRF  EQU   0
PRFRCB   EQU   IEDQPRF
PRFKEY   EQU   PRFRCB
PRFQCBA  EQU   PRFRCB+1
PRFPRI   EQU   PRFRCB+4
PRFLINK  EQU   PRFRCB+5
PRFTIC   EQU   IEDQPRF+8
PRFTICC  EQU   PRFTIC
PRFNBUNT EQU   IEDQPRF+12
PRFSUNIT EQU   PRFNBUNT
PRFPLQCB EQU   PRFSUNIT
@NM00147 EQU   IEDQPRF+16
PRFSVFFO EQU   @NM00147
PRFSTAT1 EQU   IEDQPRF+20
PRFEOFN  EQU   PRFSTAT1
PRFCORE  EQU   IEDQPRF+21
PRFXTRA  EQU   PRFCORE
PRFSCAN  EQU   IEDQPRF+24
PRFTQBCK EQU   IEDQPRF+26
PRFNTXT  EQU   PRFTQBCK
PRFEOBOF EQU   PRFNTXT
PRFCHDR  EQU   IEDQPRF+32
PRFHQBCK EQU   IEDQPRF+35
PRFDEST  EQU   IEDQPRF+40
IEDQPPTR EQU   0
IEDPF1   EQU   0
PRF1FLG1 EQU   IEDPF1+3
PRF1WD2  EQU   IEDPF1+4
PRF1SEQP EQU   PRF1WD2
PRF1SQID EQU   PRF1SEQP
PRF1TAG1 EQU   PRF1SQID
IEDPF2   EQU   0
PRF2FLG2 EQU   IEDPF2
PRF2WD2  EQU   IEDPF2+4
IEDQQCB  EQU   0
QCBDSFLG EQU   IEDQQCB
QCBDISK  EQU   QCBDSFLG
QCBNREUS EQU   QCBDISK
QCBREUS  EQU   QCBDISK
QCBEOLDT EQU   IEDQQCB+16
QCBBYTE1 EQU   QCBEOLDT+1
QCBLKRLN EQU   IEDQQCB+18
QCBRETCT EQU   QCBLKRLN
QCBSTAT  EQU   IEDQQCB+19
QCBTRMHO EQU   QCBSTAT
QCBINSRC EQU   IEDQQCB+21
@NM00155 EQU   QCBINSRC
QCBTSOF2 EQU   @NM00155+1
QCBTSOF1 EQU   @NM00155+2
QCBINTVL EQU   IEDQQCB+24
QCBPREN  EQU   IEDQQCB+28
QCBLKRRN EQU   QCBPREN+1
QCBDCBAD EQU   IEDQQCB+33
QCBFLAG  EQU   IEDQQCB+36
QCBTSSES EQU   QCBFLAG
IEDQQPTR EQU   0
IEDQPQCB EQU   0
QCBFHDLZ EQU   IEDQPQCB+3
QCBPFEFO EQU   QCBFHDLZ+1
QCBFHDTZ EQU   IEDQPQCB+6
QCBINTLF EQU   IEDQPQCB+12
IEDNQCB  EQU   0
QCBSTAT1 EQU   IEDNQCB+4
QCBPLCBA EQU   IEDNQCB+5
IEDTRM   EQU   0
IEDNTRM  EQU   IEDTRM
TRMBYTE4 EQU   IEDNTRM
TRMBYTE3 EQU   IEDNTRM+1
TRMBYTE2 EQU   IEDNTRM+2
TRMRSACT EQU   TRMBYTE2
TRMINPG  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+3
TRMSCPRQ EQU   TRMBYTE1
TRMSTOTE EQU   TRMBYTE1
TRMCOHRT EQU   IEDNTRM+4
TRMBYTE0 EQU   IEDNTRM+6
TRMINPUT EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMSIBPT EQU   IEDNTRM+7
TRMTYPE  EQU   IEDNTRM+11
TRMSUBST EQU   IEDNTRM+12
IEDQTRM  EQU   IEDTRM+14
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMDESTQ EQU   IEDQTRM+1
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMALTD  EQU   IEDQTRM+8
TRMDEVFL EQU   IEDQTRM+10
TRMSTAT  EQU   IEDQTRM+12
ALLOCBUF EQU   0
IEDQTNT  EQU   0
SWITCHES EQU   0
EXITTIME EQU   SWITCHES
ERREXIT  EQU   SWITCHES
QCBLDCB  EQU   0
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQREQ EQU   OPCAQWD1
OPCAQFST EQU   OPCAQWD1+1
OPCAQWD2 EQU   OPCAQWD+4
OPCAQRQ2 EQU   OPCAQWD2
OPCAQSEC EQU   OPCAQWD2+1
OPCAQWD3 EQU   OPCAQWD+8
TRMPRE1  EQU   TRMBYTE4
TRMNCP1  EQU   TRMBYTE4
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMLULOG EQU   TRMLU
TRMLINK  EQU   TRMBYTE3
SAVEDTRM EQU   OCMODNME
SWITCH   EQU   OCSWITCH
NOTALLMG EQU   SWITCH
OCCIB    EQU   OCREQVAL
PRFSHDR  EQU   IEDQPRF+42
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00167 EQU   SWITCH
@NM00166 EQU   SWITCH
@NM00165 EQU   TRMLINK
TRMLSTAT EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMINERR EQU   TRMLU
TRMLUREQ EQU   TRMLU
TRMSESRQ EQU   TRMLU
TRMTDIFF EQU   TRMLU
TRMLUTM  EQU   TRMLU
TRMLUIT  EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
@NM00164 EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMIPLDM EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
@NM00163 EQU   TRMNCP1
TRMINOP  EQU   TRMNCP1
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OCICINAC EQU   OCICSW
@NM00120 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00119 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
@NM00168 EQU   SWITCHES
TRMOPT   EQU   IEDTRM+34
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMCHCIN EQU   IEDQTRM+16
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMSIO   EQU   TRMSTAT
@NM00162 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
TRMNCPI  EQU   TRMDEVFL+1
TRMRNTRM EQU   TRMDEVFL+1
@NM00161 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMADDC  EQU   TRMDEVFL
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMPRILK EQU   TRMALTD
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TLISTCNT
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMPREF  EQU   TRMSTATE
TRMPROC  EQU   TRMLOG
TRMLIST  EQU   TRMLOG
TRMLINE  EQU   TRMSTATE
TRMRLMCT EQU   IEDNTRM+10
TRMCOHTG EQU   TRMSIBPT+1
TRMGPCNT EQU   TRMSIBPT
TRMBUFRD EQU   TRMBYTE0
@NM00160 EQU   TRMBYTE0
TRMOUTPT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMREMB  EQU   TRMBYTE2
QCBTTCIN EQU   QCBPLCBA+1
@NM00159 EQU   QCBPLCBA
@NM00158 EQU   QCBSTAT1
QCBFLUSH EQU   QCBSTAT1
QCBNDXRQ EQU   QCBSTAT1
QCBESIG  EQU   QCBSTAT1
QCBRCVRQ EQU   QCBSTAT1
QCBSNDRQ EQU   QCBSTAT1
QCBWAITC EQU   QCBSTAT1
QCBPLCBN EQU   QCBSTAT1
QCBCHAIN EQU   IEDNQCB
QCBPQBCK EQU   IEDQPQCB+25
QCBPRIPQ EQU   IEDQPQCB+24
QCBCFHDR EQU   IEDQPQCB+21
QCBLFEFO EQU   IEDQPQCB+18
QCBFFEFO EQU   IEDQPQCB+15
QCBPREVF EQU   QCBINTLF
QCBINTFF EQU   IEDQPQCB+9
QCBDATSQ EQU   QCBFHDTZ+1
@NM00157 EQU   QCBFHDTZ
@NM00156 EQU   QCBPFEFO
QCBDATFL EQU   QCBFHDLZ
QCBDNHDR EQU   IEDQPQCB
QCBQBACK EQU   IEDQQCB+37
QCBCKPT  EQU   QCBFLAG
QCBPROC  EQU   QCBFLAG
QCBSDFFO EQU   QCBFLAG
QCBTERMQ EQU   QCBFLAG
QCBRSRV  EQU   QCBFLAG
QCBREAD  EQU   QCBFLAG
QCBNOBRK EQU   QCBFLAG
QCBLGBAD EQU   QCBDCBAD
QCBRELLN EQU   IEDQQCB+32
QCBTJID  EQU   QCBLKRRN+1
QCBCARCT EQU   QCBLKRRN
QCBPRLVL EQU   QCBPREN
QCBMSGCT EQU   IEDQQCB+26
QCBEXTO  EQU   QCBINTVL
QCBDISC  EQU   QCBTSOF1
QCBDELAY EQU   QCBTSOF1
QCBPARTO EQU   QCBTSOF1
QCBSATRD EQU   QCBTSOF1
QCBNOBUF EQU   QCBTSOF1
QCBTPUT  EQU   QCBTSOF1
QCBTGET  EQU   QCBTSOF1
QCBWRBRK EQU   QCBTSOF1
QCBSATLC EQU   QCBTSOF2
QCBSATTI EQU   QCBTSOF2
QCBSATCH EQU   QCBTSOF2
QCBSIMRD EQU   QCBTSOF2
QCBDSSMI EQU   QCBTSOF2
QCBPOSTO EQU   QCBTSOF2
QCBBUFQ  EQU   QCBTSOF2
QCBINHBN EQU   QCBTSOF2
QCBSATCT EQU   @NM00155
QCBSCBOF EQU   IEDQQCB+20
QCBTIME  EQU   QCBSTAT
QCBCLOCK EQU   QCBSTAT
QCBSCHDL EQU   QCBSTAT
QCBSMODE EQU   QCBSTAT
QCBSEND  EQU   QCBSTAT
QCBBUFRD EQU   QCBSTAT
QCBEOM   EQU   QCBSTAT
QCBHUCT  EQU   QCBRETCT
QCBIEND  EQU   QCBRETCT
QCBEND   EQU   QCBRETCT
QCBNL    EQU   QCBRETCT
QCBLOGCT EQU   QCBRETCT
@NM00154 EQU   QCBBYTE1
QCBRITRM EQU   QCBBYTE1
@NM00153 EQU   QCBEOLDT
QCBSLINK EQU   IEDQQCB+13
QCBSTPRI EQU   IEDQQCB+12
QCBSTCHN EQU   IEDQQCB+9
QCBSTVTO EQU   IEDQQCB+8
QCBLINK  EQU   IEDQQCB+5
QCBPRI   EQU   IEDQQCB+4
QCBELCHN EQU   IEDQQCB+1
QCBHELD  EQU   QCBDSFLG
QCBFQCB  EQU   QCBDSFLG
QCBDRQQ  EQU   QCBDSFLG
QCBALTMH EQU   QCBDSFLG
QCBCORE  EQU   QCBDSFLG
QCBTSQ   EQU   QCBDSFLG
PRF2SEQP EQU   PRF2WD2
@NM00152 EQU   IEDPF2+1
@NM00151 EQU   PRF2FLG2
PRF2TERM EQU   PRF2FLG2
PRF2SMI  EQU   PRF2FLG2
PRF2FORM EQU   PRF2FLG2
PRF2TNTI EQU   PRF2FLG2
PRF1RULN EQU   PRF1SEQP+2
PRF1TAG2 EQU   PRF1SQID+1
@NM00150 EQU   PRF1TAG1
PRF1TAGS EQU   PRF1TAG1
@NM00149 EQU   PRF1FLG1
PRF1LOGD EQU   PRF1FLG1
PRF1USS  EQU   PRF1FLG1
PRF1FORM EQU   PRF1FLG1
PRF1EXPI EQU   PRF1FLG1
PRF1FIDI EQU   PRF1FLG1
PRF1RH   EQU   IEDPF1
PRFISEQ  EQU   IEDQPRF+38
PRFSTXT  EQU   PRFHQBCK
PRFNHDR  EQU   PRFCHDR
PRFCRCD  EQU   IEDQPRF+29
PRFSVSEQ EQU   PRFNTXT+1
PRFSVPRI EQU   PRFEOBOF
PRFISIZE EQU   PRFSCAN+1
@NM00148 EQU   PRFSCAN
PRFEOB   EQU   PRFXTRA+1
PRFSTSO  EQU   PRFXTRA
PRFNHDRN EQU   PRFSTAT1
PRFNLSTN EQU   PRFSTAT1
PRFLOCK  EQU   PRFEOFN
PRFDUPLN EQU   PRFSTAT1
PRFTSMSG EQU   PRFSTAT1
PRFITCPN EQU   PRFSTAT1
PRFERMGN EQU   PRFSTAT1
PRFCNCLN EQU   PRFSTAT1
PRFSVFLG EQU   @NM00147+3
PRFSIZE  EQU   PRFSVFFO+2
PRFSRCE  EQU   PRFSVFFO
PRFLCB   EQU   IEDQPRF+13
PRFPIUO  EQU   PRFPLQCB
PRFTI0   EQU   PRFTIC+1
@NM00146 EQU   PRFTICC
@NM00145 EQU   PRFTICC
@NM00144 EQU   PRFTICC
PRFTICON EQU   PRFTICC
@NM00143 EQU   PRFTICC
@NM00142 EQU   PRFTICC
PRFBFMM  EQU   PRFTICC
PRFEOMSG EQU   PRFTICC
PRFCOUNT EQU   PRFLINK+1
@NM00141 EQU   PRFLINK
PRFFLAGS EQU   PRFPRI
PRFIOADR EQU   PRFQCBA
PRFOPCDE EQU   PRFKEY
@NM00140 EQU   OPREFLG3
OPREATCH EQU   OPREFLG3
@NM00139 EQU   OPREFLG3
OPREFLG2 EQU   IEDOPRED+13
OPRETIC  EQU   OPRESAVE
OPRELINK EQU   IEDOPRED+5
OPREKEY  EQU   IEDOPRED
OPCBOTTM EQU   IEDQOPCD+1184
@NM00138 EQU   IEDQOPCD+1100
@NM00137 EQU   IEDQOPCD+948
@NM00136 EQU   IEDQOPCD+940
@NM00135 EQU   IEDQOPCD+380
@NM00134 EQU   OPCPWCOB+9
@NM00133 EQU   OPCPWCOB+8
@NM00132 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00131 EQU   OPCSPEC
@NM00130 EQU   OPCSPEC
@NM00129 EQU   OPCSPEC
@NM00128 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00127 EQU   OPCLDNME+5
@NM00126 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCWRKSZ EQU   IEDQOPCD+144
OPCWORK  EQU   IEDQOPCD+140
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00125 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
OPCDOUBL EQU   IEDQOPCD
@NM00124 EQU   OCLDNME+4
@NM00123 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00122 EQU   OCREQFLG
@NM00121 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00118 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00117 EQU   OCRSID+1
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
@NM00116 EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
OCWTGB   EQU   OCTIOT
@NM00115 EQU   @NM00114+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCRESP   EQU   OCFLAG
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00113 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00112 EQU   OCRUDEST+1
@NM00111 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
@NM00110 EQU   NSLGRPNM+4
@NM00109 EQU   IEDNSLD+34
NSLUNCNT EQU   NSLERB+12
@NM00108 EQU   NSLESTAT
NSLMPPI  EQU   NSLESTAT
@NM00107 EQU   NSLESTAT
NSLELINK EQU   NSLERB+5
NSLERBPR EQU   NSLERB+4
NSLERQCB EQU   NSLERB
NSLCTTRM EQU   IEDNSLD+13
@NM00106 EQU   NSLGPCUS
NSLDRDRV EQU   NSLGPCUS
NSLSDIAL EQU   NSLGPCUS
NSLNGPSL EQU   NSLGPCUS
NSLGPTSP EQU   NSLGPCUS
NSLNGPST EQU   NSLGPCUS
NSLSAVE  EQU   IEDNSLD+9
@NM00105 EQU   NSLPLCB
NSLPLCBR EQU   NSLPLCB
NSLOPRE  EQU   IEDNSLD
NSLSAVE2 EQU   IEDNNSLD+4
NSLSAVE1 EQU   IEDNNSLD
SAVTBITN EQU   IEDNSVTD+312
@NM00104 EQU   SAVTCKQB+8
@NM00103 EQU   SAVTCKEC+1
@NM00102 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00101 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00100 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00099 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00098 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00097 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00096 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00095 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00094 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00093 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00092 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00091 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00090 EQU   IEDQAVTD+1242
@NM00089 EQU   IEDQAVTD+1241
@NM00088 EQU   IEDQAVTD+1240
@NM00087 EQU   IEDQAVTD+1237
@NM00086 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00085
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00084 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00083 EQU   IEDQAVTD+1140
@NM00082 EQU   IEDQAVTD+1137
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00074 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00073 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00072 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00071 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00070 EQU   AVTBIT2
@NM00069 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00068 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00067 EQU   IEDQAVTD+950
@NM00066 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00065 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00052 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00051 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00050 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00049 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00048 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00047 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00046 EQU   AVTOPCQB+8
@NM00045 EQU   AVTOPCEC+1
@NM00044 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00043 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00042 EQU   AVTCKPEC+1
@NM00041 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00040 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00039 EQU   IEDQAVTD+784
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00038 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00037 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00030 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00029 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00022 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00021 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00020 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00019 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00018 EQU   AVTSAVTP+1
@NM00017 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00016 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00015 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00014 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00013 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00012 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+384
AVTREADD EQU   IEDQAVTD+380
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00382 EQU   @RC00381
@RC00455 EQU   @RC00453
@RC00413 EQU   @RC00402
@RC00517 EQU   @RC00402
@RC00537 EQU   @RC00535
@RC00554 EQU   @RC00552
@RC00584 EQU   @RC00552
@RC00608 EQU   @RC00606
@RC00627 EQU   @RC00625
@RC00652 EQU   @RC00625
@RC00676 EQU   @RC00625
@RC00385 EQU   @RC00382
@RC00458 EQU   @RC00455
@RC00463 EQU   @RC00455
@RC00539 EQU   @RC00537
@RC00556 EQU   @RC00554
@RC00563 EQU   @RC00554
@RC00586 EQU   @RC00584
@RC00629 EQU   @RC00627
@RC00654 EQU   @RC00652
@RC00678 EQU   @RC00676
@RC00565 EQU   @RC00563
@RC00588 EQU   @RC00586
@RC00632 EQU   @RC00629
@RC00637 EQU   @RC00629
@RC00656 EQU   @RC00654
@RC00658 EQU   @RC00656
@ENDDATA EQU   *
         END   IGCV910D,(C'PLS1733',0701,77206)
