804H     TITLE 'IGE0804H BSC CHANNEL CHECK - CHANNEL DATA CHECK'
IGE0804H CSECT
*A-000000-999999                                               @Y02X6E0
*A237000,346000,364000,507000,510000,526000,552000-555000,886000 Y02027
*C144000,171000,225000,231000,360000,477000                      Y02027
*A237000,346000,364000,507000,510000,526000,552000-555000,886000 Y02027
*C144000,171000,225000,231000,360000,477000                      Y02027
*C072000,576000                                                @Z30AAEE
*D810000                                                       @Z30AAEE
*                                                                     *
***********************************************************************
*                                                                     *
*TITLE -- 'IGE0804H', BSC CHANNEL CHECK HANDLER                       *
*                                                                     *
*STATUS -- CHANGE LEVEL 8                                      @Z30AAEE
*                                                                     *
*FUNCTION -- TO ATTEMPT RECOVERY OF CHANNEL CONTROL CHECKS AND        *
*   INTERFACE CONTROL CHECKS.                                         *
*                                                                     *
*ENTRY POINTS -- FIRST EXECUTABLE INSTRUCTION.                        *
*                                                                     *
*INPUT --                                                             *
*   R1 - POINTER TO I/O SUPERVISOR BLOCK                         Y02027
*   R15 - ENTRY POINT ADDRESS                                         *
*                                                                     *
*OUTPUT -- R1 POINTS TO I/O SUPERVISOR BLOCK                     Y02027
*                                                                     *
*EXTERNAL ROUTINES -- NONE                                            *
*                                                                     *
*EXUTS-NORMAL -- NOT APPLICABLE                                       *
*                                                                     *
*EXITS-ERROR -- R1 POINTS TO I/O SUPERVISOR BLOCK                Y02027
*        SVC   15   'EXCEPTIONAL CONDITION(IOSEX)'. RETURN TO    Y02027
*                   LINE END APPENDAGE. ERROR PERMANENT.         Y02027
*        SVC   3                                                      *
*                                                                     *
*        L     13,DECIMAL VALUE OF NEXT LOAD                          *
*        L   14,X'10'    CVT ADDRESS                                  *
*        L     14,X'2C'(14)    ADDRESS OF XCTL ROUTINE                *
*        BR    14   EXIT TO XCTL                                      *
*                                                                     *
*   TO SCHEDULE ERROR POST                                            *
*                                                                     *
*TABLES/WORK AREAS --                                                 *
*   TLCBD                                                             *
*   TSCBD                                                             *
*   IECDIOSB                                                     Y02027
*                                                                     *
*ATTRIBUTES -- SERIALLY REUSABLE, REFRESHABLE, SUPERVISOR KEY,   Y02027
*              SUPERVISOR MODE, ENABLED                          Y02027
*                                                                     *
*NOTES -- THE OPERATION OF THIS MODULE DOES NOT DEPEND UPON A         *
*   PARTICUALR INTERNAL REPRESENTATION OF THE EXTERNAL CHARACTER      *
*   SET.                                                              *
*                                                                     *
*   R1 REMAINS TRANSPARENT TO ALL LOADS OF ERP.                       *
*                                                                     *
***********************************************************************
         EJECT
*
*        REGISTERS
*
RIOSB    EQU   1                        ADDR OF I/O SUPVR BLOCK  Y02027
RUCB     EQU   2                        UCB REGISTER
RLCB     EQU   3                        IOB REGISTER
R4       EQU   4                        WORK REGISTER
RTST     EQU   7                        ADDR OF REQUEST QUEUE    Y02027
*                                       ELEMENT                  Y02027
RLINK    EQU   13                       LINKAGE - NEXT LOAD
RXCTL    EQU   14                       XCTL REGISTER
RERPWA   EQU   14                       ADDR OF ERP WORK AREA    Y02027
RBASE    EQU   15                       BASE - ADDRESSABILITY
         EJECT
         USING *,RBASE
         USING IOSB,RIOSB                                        Y02027
         L     RTST,IOSUSE              PICKUP ADDR OF RQE       Y02027
         L     RLCB,IOBOFFST(,RTST)     LCB BASE
         USING LCBFLAG1,RLCB
         L     RUCB,IOSUCB              ADDRESS OF UCB         @Z30AAEE
         L     RXCTL,CVTPTR             CVT POINTER
         L     RLINK,LCBSCBA-1          SCB ADDRESS
         L     R4,IOSERP                ADDRESS OF ERP WORKAREA  Y02027
         USING EWA,R4
         XC    EWAERPIB,EWAERPIB        CLEAR ERPIB FOR SYSTEM   Y02027
         OI    SCBERR4-IEDQSCB(RLINK),SCBCHANN  SET CHANNEL ERROR
         MVI   LCBINCAM+1,POSNO         SET RETURN FOR ERROR POST
         LH    RLINK,POSTMOD            504G RETURN
         L     RXCTL,XCTLADD(,RXCTL)    XCTL ADDRESS
         BR    RXCTL                    NEXT MODULE
*
         EJECT
POSTMOD  DC    AL2(5047)                IGE0504G ID              Y02027
CVTPTR   EQU   16                       CVT ADDRESS LOCATION
PIBPTR   EQU   116                      POINTER TO ERPIB TABLE
IOBOFFST EQU   4                        IOB OFFSET IN RQE
XCTLADD  EQU   X'2C'                    XCTL ADDRESS OFFSET IN CVT
POSNO    EQU   16                       SHOLD NOT OCCUR ERROR
EIGHT    EQU   8                        OFFSET                   Y02027
TWO      EQU   2                        OFFSET VALUE             Y02027
         EJECT
         TLCBD
         TSCBD
         IECDIOSB                                                Y02027
         IECDERWA EWTC
         END
