         MACRO
         IGFERPIB &WORK
IGFERPIB DSECT
*
*
*        ERROR RECOVERY PROCEDURE INFORMATION BLOCK (ERPIB)
*        DEFINITION
*
*
IGUCB    DS    A .                 UCB FIELD
IGPRGFLG DS    CL1 .               PROGRAM FLAG BITS
IGBLAME  DS    CL1 .               PROBABLE SOURCE OF ERROR
IGVALIDB DS    CL1 .               VALIDITY INDICATOR BITS
IGTERMSQ DS    CL1 .               TERMINATION/SEQUENCE CODE BITS
         AIF   ('&WORK' EQ '1').A1
         MEXIT
.A1      ANOP
*
*        CCH WORK AREA AND INTERNAL SWITCHES
*        AREA IMMEDIATELY FOLLOWS THE WORK ERPIB
*
CCHSW1   DS    CL1 .               INTERNAL CCH SWITCH - BYTE 1
CCHSW2   DS    CL1 .               INTERNAL CCH SWITCH - BYTE 2
RECBYTE  DS    CL1 .               RECORD BYTE
*
*        ERPIB DEFINITION MASKS
*
         SPACE 2
*
*        PROGRAM FLAG BITS -- BYTE 4
*
CCHSIOB  EQU   X'80' .                  SIO BIT
CCHINTB  EQU   X'40' .                  INTERRUPT BIT
CCHTIOB  EQU   X'20' .                  TIO BIT
CCHHIOB  EQU   X'10' .                  HIO BIT
CCHSNSB  EQU   X'04' .                  SENSE DATA STORED BIT
CCHCNTB  EQU   X'02' .                  COUNT VALID BIT
CCHNRYB  EQU   X'01' .                  NO RETRY BIT
         SPACE 2
*
*        PROBABLE SOURCE OF ERROR BITS -- BYTE 5
*
CCHCPU   EQU   X'80' .             CPU IS SOURCE OF ERROR
CCHCHNL  EQU   X'40' .             CHANNEL IS SOURCE OF ERROR
CCHSCUB  EQU   X'20' .             STORAGE CONTROL UNIT SOURCE OF ERROR
CCHSTG   EQU   X'10' .             STORAGE IS SOURCE OF ERROR
CCHINTFC EQU   X'08' .             I/O INTERFACE IS SOURCE OF ERROR
         SPACE 2
*
*       VALIDITY BITS -- BYTE 6
*
CCHRCV   EQU   X'10' .                  RETRY CODE VALID
CCHUSV   EQU   X'08' .                  UNIT STATUS VALID
CCHCMDV  EQU   X'04' .                  COMMAND ADDRESS VALID
CCHCAV   EQU   X'02' .                  CHANNEL ADDRESS VALID
CCHDAV   EQU   X'01' .                  DEVICE ADDRESS VALID
         SPACE 2
*
*        TERMINATION CODE BITS -- BYTE 7
*
COMPSYS  EQU   X'C0' .                  SYSTEM RESET
COMPSEL  EQU   X'80' .                  SELECTIVE RESET
COMPFES  EQU   X'40' .                  FORCED ENDING SEQUENCE
COMPID   EQU   X'00' .                  INTERFACE DISCONNECT
CCHDI    EQU   X'08' .             * DISCONNECT IN
         SPACE 2
*
*        SEQUENCE CODE BITS -- BYTE 7
*
RTCODE0  EQU   X'00' .           *      RETRY
RTCODE1  EQU   X'01' .           *           CODE
RTCODE2  EQU   X'02' .           *               VALUES
RTCODE3  EQU   X'03' .           *                     FOR
RTCODE4  EQU   X'04' .           *                        ERPIB
RTCODE5  EQU   X'05' .           *
RTCODE6  EQU   X'06' .           *
RTCODE7  EQU   X'07' .           *
         SPACE 1
*
*******************      CCH INTERNAL SWITCHES     ***************
*              SWITCH BYTE 1
*
CCHCMDRG EQU   X'80' .                  COMMAND REG PARITY VALID
CCHNORE  EQU   X'40' .                  NO RECORD ENTRY AVAILABLE
CCHERFRE EQU   X'20' .               ERQIB FREED FROM ACTIVE LIST
CCHNOLST EQU   X'10' .               RECORD ONLY-NO ERPIB TO LIST
*                                  DEVICE END OR
CCHHAND  EQU   X'08' .               ATTENTION PRESENTED
CCHIBC   EQU   X'04' .               ERPIB ALREADY CREATED
UCBNVBIT EQU   X'02' .               UCB INVALID
*
*
*        SWITCH BYTE 2
*
SYSTERM  EQU   X'80' .               SIGNAL FOR SYSTEM TERMINATION
INTRN2   EQU   X'40' .               ALTERNATE RETURN SWITCH
NOMODEL  EQU   X'20' .               NO MODEL FOUND FOR LOGOUT
NOLOG    EQU   X'10' .                   MASK FOR NO CHANNEL LOGOUT
*
         MEND
