         TITLE 'IGFPMKTA - MACHINE CHECK CLOCK TIMER ANALYSIS          *
                        '
IGFPMKTA CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IGFPMKTA  78.089'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*/****************************************************************** */
*/****************************************************************** */
*/*      SET UP STANDARD LINKAGE AND SAVE LRB POINTER                */
*/****************************************************************** */
*                                                                  0067
*   FWDPTR=ADDR(PWASA2);            /* FORWARD CHAIN CALLERS SAVE    */
         L     @07,PCCAPTR                                         0067
         L     @07,PWAPTR(,@07)                                    0067
         LA    @15,PWASA2(,@07)                                    0067
         ST    @15,FWDPTR(,R13)                                    0067
*   ADDR(PWASA2)->BACKPTR=R13;      /* BACKWARD CHAIN THIS RTN       */
         ST    R13,BACKPTR+72(,@07)                                0068
*   R13=ADDR(PWASA2);               /* ADDRESS OF SAVE AREA          */
         LR    R13,@15                                             0069
*   LRBPTR=R1;                      /* ESTABLISH LRB POINTER         */
         LR    LRBPTR,R1                                           0070
*   R0=R1;                          /* SAVE LRB POINTER              */
         LR    R0,R1                                               0071
*/****************************************************************** */
*                                                                  0072
*   R1=ADDR(FRSADD);                /* FILL REG1 WITH ADDRESS OF PARM
*                                      LIST                          */
         LA    R1,FRSADD                                           0072
*   CALL RVTFRS;                    /* GO TO FRS TO ADJUST VECTOR    */
         L     @07,CVTPTR                                          0073
         L     @07,RVTPTR(,@07)                                    0073
         L     @15,RVTPMFRS(,@07)                                  0073
         BALR  @14,@15                                             0073
*   THAPLIST=THAPLIST&&THAPLIST;    /* INIT IGFPMTHA PARM LIST     0074
*                                                            @G55CP2P*/
         L     @07,PCCAPTR                                         0074
         L     @07,PWAPTR(,@07)                                    0074
         XC    THAPLIST+792(32,@07),THAPLIST+792(@07)              0074
*/****************************************************************** */
*/*  THE FOLLOWING CODE CHECKS THE LRB FOR CLOCK AND TIMER DAMAGE    */
*/*    CONDITIONS AND SETS APPROPRIATE BITS INDICATING ITS FINDINGS  */
*/****************************************************************** */
*                                                                  0075
*   IF LRBMFTD='1'B                 /* CHECK FOR INTERVAL TIMER ERROR*/
*     THEN                                                         0075
         TM    LRBMFTD(LRBPTR),B'00010000'                         0075
         BNO   @RF00075                                            0075
*     LRBMIL80='1'B;                /* YES - SET INDICATING BIT      */
         OI    LRBMIL80(LRBPTR),B'00000001'                        0076
*   ELSE                                                           0077
*     ;                                                            0077
*                                                                  0077
@RF00075 DS    0H                                                  0078
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SECTION OF CODE INTERROGATES THE CLOCK DAMAGE BITS AND   */
*   /* SETS PERTAINING BITS IN THE LRB. WE FIRST CHECK IF CLOCK      */
*   /* DAMAGE IS PRESENT. IF SO, WE CHECK THE CPU TIMER AND THE CLOCK*/
*   /* COMPARITOR VALITY BITS. IF THEY ARE VALID ( ONE INDICATES     */
*   /* VALIDITY) WE SET THE TIME OF DAY INVALID BIT AND RETURN TO THE*/
*   /* CALLER. IF INVALID WE SEEK THE INVALID ONE AND RECORD IT IN   */
*   /* THE LRB.                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0078
*/****************************************************************** */
*                                                                  0078
*   IF LRBMFCD='1'B                 /* CHECK CLOCK DAMAGE BIT        */
*     THEN                                                         0078
         TM    LRBMFCD(LRBPTR),B'00001000'                         0078
         BNO   @RF00078                                            0078
*     DO;                                                          0079
*       IF LRBMVPT='1'B&LRBMVCC='1'B/* ARE PROCESSOR TIMER AND CLOCK
*                                      COMPARATOR VALID              */
*         THEN                                                     0080
         TM    LRBMVPT(LRBPTR),B'00000011'                         0080
         BNO   @RF00080                                            0080
*         DO;                                                      0081
*           LRBMITOD='1'B;          /* YES - SET TIME OF DAY ERROR   */
         OI    LRBMITOD(LRBPTR),B'00001000'                        0082
*           THAPARM1=ADDR(PWATCTHB);/* SET PTR TO THB        @G55CP2P*/
         L     @07,PCCAPTR                                         0083
         L     @07,PWAPTR(,@07)                                    0083
         LA    @15,PWATCTHB(,@07)                                  0083
         ST    @15,THAPARM1+792(,@07)                              0083
*           GOTO RETRN;             /* RETURN TO THE CALLER          */
         B     RETRN                                               0084
*         END;                                                     0085
*       ELSE                                                       0086
*         ;                                                        0086
@RF00080 DS    0H                                                  0087
*       IF LRBMVPT='0'B             /* CHECK CPU TIMER               */
*         THEN                                                     0087
         TM    LRBMVPT(LRBPTR),B'00000010'                         0087
         BNZ   @RF00087                                            0087
*         DO;                       /* HERE IF INVALID       @G55CP2P*/
*           LRBMICTM='1'B;          /* INDICATE CPU TIMER DMG      0089
*                                                            @G55CP2P*/
         OI    LRBMICTM(LRBPTR),B'00000010'                        0089
*           THAPARM1=ADDR(PWAPTTHB);/* SET PTR TO THB        @G55CP2P*/
         L     @07,PCCAPTR                                         0090
         L     @07,PWAPTR(,@07)                                    0090
         LA    @15,PWAPTTHB(,@07)                                  0090
         ST    @15,THAPARM1+792(,@07)                              0090
*         END;                      /*                       @G55CP2P*/
*       ELSE                                                       0092
*         ;                                                        0092
@RF00087 DS    0H                                                  0093
*       IF LRBMVCC='0'B             /* CLOCK COMPARATOR DMG? @G55CP2P*/
*         THEN                                                     0093
         TM    LRBMVCC(LRBPTR),B'00000001'                         0093
         BNZ   @RF00093                                            0093
*         DO;                       /* YES - INDICATE DMG.   @G55CP2P*/
*           LRBMICKC='1'B;          /* SET CC DMG FLAG       @G55CP2P*/
         OI    LRBMICKC(LRBPTR),B'00000100'                        0095
*           THAPARM1=ADDR(PWACCTHB);/* SET POINTER TO THB    @G55CP2P*/
         L     @07,PCCAPTR                                         0096
         L     @07,PWAPTR(,@07)                                    0096
         LA    @15,PWACCTHB(,@07)                                  0096
         ST    @15,THAPARM1+792(,@07)                              0096
*         END;                      /*                       @G55CP2P*/
*       ELSE                                                       0098
*         ;                                                        0098
@RF00093 DS    0H                                                  0099
*     END;                                                         0099
*   ELSE                                                           0100
*     ;                                                            0100
@RF00078 DS    0H                                                  0101
*   R1=ADDR(FRSREP);                /* SET UP REG 1 FOR REPLACE      */
         LA    R1,FRSREP                                           0101
*   CALL RVTFRS;                    /* CALL FRS TO ADJUST VECTOR     */
         L     @07,CVTPTR                                          0102
         L     @07,RVTPTR(,@07)                                    0102
         L     @15,RVTPMFRS(,@07)                                  0102
         BALR  @14,@15                                             0102
*/****************************************************************** */
*/*  THIS ROUTINE IS USED AS COMMON CODE TO ISSUE A STORE CLOCK      */
*/*    AND CHECK ITS RESULTS BEFORE RETURNING TO THE CALLER          */
*/****************************************************************** */
*                                                                  0103
*IGFPMKE2:                                                         0103
*   ;                                                              0103
IGFPMKE2 DS    0H                                                  0104
*   GEN( STCK   LRBHDATE(LRBPTR));  /* TIME STAMP LOGREC RECORD      */
          STCK   LRBHDATE(LRBPTR)
*   BC(13,RETRN);                   /* IF NO ERROR RETURN TO CALLER  */
         BC    13,RETRN                                            0105
*   LRBMITOD='1'B;                  /* TIME OF DAY CLOCK ERROR       */
         OI    LRBMITOD(LRBPTR),B'00001000'                        0106
*   LRBHDATE=LRBHDATE&&LRBHDATE;    /* ZERO TIME STAMP               */
         XC    LRBHDATE(4,LRBPTR),LRBHDATE(LRBPTR)                 0107
*   LRBHTIME=LRBHTIME&&LRBHTIME;    /* ZERO TIME STAMP               */
         XC    LRBHTIME(4,LRBPTR),LRBHTIME(LRBPTR)                 0108
*/****************************************************************** */
*/*  THIS LABEL IS USED TO ADJUST THE FRS VECTOR, PERFORM THRESHOLD  */
*/*   ANALYSIS IF TIMING FACILITIES DAMAGE WAS FOUND,                */
*/*   AND RETURN TO THE CALLER IF THE TIME STAMP WAS SUCCESSFUL.     */
*/**********************************************************@G55CP2P */
*                                                                  0109
*RETRN:                                                            0109
*   ;                                                              0109
RETRN    DS    0H                                                  0110
*   IF LRBHTIME^=0                  /* CONVERT THE GMT TIME  @ZA30797*/
*     THEN                                                         0110
         L     @07,LRBHTIME(,LRBPTR)                               0110
         LTR   @07,@07                                             0110
         BZ    @RF00110                                            0110
*     LRBHTIME=LRBHTIME+CVTTZ;      /* TO LOCAL TIME         @ZA30797*/
         L     @15,CVTPTR                                          0111
         AL    @07,CVTTZ(,@15)                                     0111
         ST    @07,LRBHTIME(,LRBPTR)                               0111
*   IF THAPARM1^=0                  /* WAS DAMAGE FOUND      @G55CP2P*/
*     THEN                                                         0112
@RF00110 L     @07,PCCAPTR                                         0112
         L     @07,PWAPTR(,@07)                                    0112
         ICM   @15,15,THAPARM1+792(@07)                            0112
         BZ    @RF00112                                            0112
*     DO;                           /* YES, DO THRESHOLD ANALYSIS  0113
*                                                            @G55CP2P*/
*       R1=ADDR(FRSREP1);           /* SET UP TO REPLACE FRR @G55CP2P*/
         LA    R1,FRSREP1                                          0114
*       CALL RVTFRS;                /* CALL FRR STACKER      @G55CP2P*/
         L     @07,CVTPTR                                          0115
         L     @07,RVTPTR(,@07)                                    0115
         L     @15,RVTPMFRS(,@07)                                  0115
         BALR  @14,@15                                             0115
*       R1=ADDR(THAPLIST);          /* POINT TO THRESHOLD ANALYSIS 0116
*                                      PARM LIST             @G55CP2P*/
         LA    @07,792                                             0116
         L     @15,PCCAPTR                                         0116
         AL    @07,PWAPTR(,@15)                                    0116
         LR    R1,@07                                              0116
*       THAPARM2=ADDR(THAMSG);      /* POINT 2ND PARM TO DUMMY IGFMSG
*                                                            @G55CP2P*/
         LA    @15,THAMSG(,@07)                                    0117
         ST    @15,THAPARM2(,@07)                                  0117
*       CALL IGFPMTHA;              /* PERFORM THRESHOLD ANALYSIS  0118
*                                                            @G55CP2P*/
         L     @07,CVTPTR                                          0118
         L     @07,RVTPTR(,@07)                                    0118
         L     @15,RVTPMTHA(,@07)                                  0118
         BALR  @14,@15                                             0118
*     END;                                                         0119
*   R1=ADDR(FRSDEL);                /* SET UP REG1 FOR FRR STACK   0120
*                                      DELETION                      */
@RF00112 LA    R1,FRSDEL                                           0120
*   CALL RVTFRS;                    /* CALL FRS TO ADJUST VECTOR     */
         L     @07,CVTPTR                                          0121
         L     @07,RVTPTR(,@07)                                    0121
         L     @15,RVTPMFRS(,@07)                                  0121
         BALR  @14,@15                                             0121
*IGFPMKF5:                          /* RETURN POINT IF ERROR IN    0122
*                                      THRESHOLD ANALYSIS ROUTINE  0122
*                                                            @G55CP2P*/
*   R13=BACKPTR;                    /* RESTORE SAVE AREA PTR         */
IGFPMKF5 L     R13,BACKPTR(,R13)                                   0122
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 DS    0H                                                  0123
@EF00001 DS    0H                                                  0123
@ER00001 LM    @14,@12,12(@13)                                     0123
         BR    @14                                                 0123
*/****************************************************************** */
*/*  THIS ROUTINE IS ENTERED VIA THE FRS WHEN AN  ERROR (MACHINE     */
*/*  CHECK,PROGRAM CHECK OR RESTART INTERRUPT) OCCURS DURING         */
*/*   EXECUTION OF THE CLOCK AND TIMER DAMAGE INTERROGATION.         */
*/*   THIS ROUTINE RETURNS TO IGFPMKTA AT ENTRY IGFPMKE2.            */
*/*   BASE REGISTER IS RESTORED VIA PWAFRR STACK.                    */
*/****************************************************************** */
*                                                                  0124
*IGFPMKF1:                                                         0124
*   ;                                                              0124
IGFPMKF1 DS    0H                                                  0125
*   LRBPTR=R0;                      /* RESTORE LRB POINTER           */
         LR    LRBPTR,R0                                           0125
*   LRBMIL80='1'B;                  /* INTERVAL TIMER ERROR          */
*   LRBMICTM='1'B;                  /* CPU TIMER ERROR               */
*   LRBMICKC='1'B;                  /* CLOCK COMPARITOR ERROR        */
         OI    LRBMIL80(LRBPTR),B'00000111'                        0128
*   R1=ADDR(FRSADD2);               /* ADD TO FRS STACK              */
         LA    R1,FRSADD2                                          0129
*   CALL RVTFRS;                    /* GO ADJUST FRS VECTOR          */
         L     @07,CVTPTR                                          0130
         L     @07,RVTPTR(,@07)                                    0130
         L     @15,RVTPMFRS(,@07)                                  0130
         BALR  @14,@15                                             0130
*   GOTO IGFPMKE2;                  /* GO RE-ISSUE TIME STAMP        */
         B     IGFPMKE2                                            0131
*/****************************************************************** */
*/*   THIS ROUTINE IS ENTERED IF ERRORS OCCUR WHILE TIME STAMPING    */
*/*   THE LOGREC RECORD. IGFPMKF2 RETURNS TO IGFPMKTA AT ENTRY       */
*/*    IGFPMKE2.                                                     */
*/****************************************************************** */
*                                                                  0132
*IGFPMKF2:                                                         0132
*   ;                                                              0132
IGFPMKF2 DS    0H                                                  0133
*   LRBPTR=R0;                      /* RESTORE LRB POINTER           */
         LR    LRBPTR,R0                                           0133
*   R1=ADDR(FRSADD3);               /* ADD TO FRS STACK              */
         LA    R1,FRSADD3                                          0134
*   CALL RVTFRS;                    /* GO ADJUST FRS VECTOR          */
         L     @07,CVTPTR                                          0135
         L     @07,RVTPTR(,@07)                                    0135
         L     @15,RVTPMFRS(,@07)                                  0135
         BALR  @14,@15                                             0135
*   GOTO IGFPMKE2;                  /* GO RE-ISSUE TIME STAMP        */
         B     IGFPMKE2                                            0136
*/****************************************************************** */
*/*   THIS ROUTINE IS ENTERED IF AN ERROR OCCURS DURING THE RETRY    */
*/*   OF THE TIME STAMP.                                             */
*/****************************************************************** */
*                                                                  0137
*IGFPMKF3:                                                         0137
*   ;                                                              0137
IGFPMKF3 DS    0H                                                  0138
*   LRBPTR=R0;                      /* RESTORE LRB POINTER           */
         LR    LRBPTR,R0                                           0138
*   LRBMITOD='1'B;                  /* INDICATE TOD CLOCK ERROR      */
         OI    LRBMITOD(LRBPTR),B'00001000'                        0139
*   LRBHDATE=LRBHDATE&&LRBHDATE;    /* ZERO TIME STAMP               */
         XC    LRBHDATE(4,LRBPTR),LRBHDATE(LRBPTR)                 0140
*   LRBHTIME=LRBHTIME&&LRBHTIME;    /* ZERO TIME STAMP               */
         XC    LRBHTIME(4,LRBPTR),LRBHTIME(LRBPTR)                 0141
*   IF THAPARM1^=0                  /* WAS DAMAGE FOUND      @G55CP2P*/
*     THEN                                                         0142
         L     @07,PCCAPTR                                         0142
         L     @07,PWAPTR(,@07)                                    0142
         ICM   @15,15,THAPARM1+792(@07)                            0142
         BZ    @RF00142                                            0142
*     DO;                           /* YES, DO THRESHOLD ANALYSIS  0143
*                                                            @G55CP2P*/
*       R1=ADDR(FRSADD4);           /* FIRST GET FRR COVERAGE      0144
*                                                            @G55CP2P*/
         LA    R1,FRSADD4                                          0144
*       CALL RVTFRS;                /* CALL FRR STACKER      @G55CP2P*/
         L     @07,CVTPTR                                          0145
         L     @07,RVTPTR(,@07)                                    0145
         L     @15,RVTPMFRS(,@07)                                  0145
         BALR  @14,@15                                             0145
*       R1=ADDR(THAPLIST);          /* POINT TO THRESHOLD ANALYSIS 0146
*                                      PARM LIST             @G55CP2P*/
         LA    @07,792                                             0146
         L     @15,PCCAPTR                                         0146
         AL    @07,PWAPTR(,@15)                                    0146
         LR    R1,@07                                              0146
*       THAPARM2=ADDR(THAMSG);      /* POINT 2ND PARM TO DUMMY IGFMSG
*                                                            @G55CP2P*/
         LA    @15,THAMSG(,@07)                                    0147
         ST    @15,THAPARM2(,@07)                                  0147
*       CALL IGFPMTHA;              /* PERFORM THRESHOLD ANALYSIS  0148
*                                                            @G55CP2P*/
         L     @07,CVTPTR                                          0148
         L     @07,RVTPTR(,@07)                                    0148
         L     @15,RVTPMTHA(,@07)                                  0148
         BALR  @14,@15                                             0148
*       R1=ADDR(FRSDEL);            /* SET UP TO DELETE FRR  @G55CP2P*/
         LA    R1,FRSDEL                                           0149
*       CALL RVTFRS;                /* CALL FRS TO ADJUST VECTOR   0150
*                                                            @G55CP2P*/
         L     @07,CVTPTR                                          0150
         L     @07,RVTPTR(,@07)                                    0150
         L     @15,RVTPMFRS(,@07)                                  0150
         BALR  @14,@15                                             0150
*     END;                                                         0151
*IGFPMKF4:                          /* RETURN POINT IF ERROR IN    0152
*                                      THRESHOLD ANALYSIS ROUTINE  0152
*                                                            @G55CP2P*/
*   R13=BACKPTR;                    /* RESTORE SAVE AREA PTR         */
@RF00142 DS    0H                                                  0152
IGFPMKF4 L     R13,BACKPTR(,R13)                                   0152
*   RETURN;                                                        0153
         B     @EL00001                                            0153
*   END                                                            0154
*                                                                  0154
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHALRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARVT  )                                       */
*/*%INCLUDE SYSLIB  (IGFPWA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*                                                                  0154
*       ;                                                          0154
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IGFPMKTA CSECT
         DS    0F
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGFPMKTA CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
FRSDEL   DC    F'-1'
FRSADD   DS    CL8
         ORG   FRSADD
PARM1    DC    F'1'
PARM2    DC    AL4(IGFPMKF1)
         ORG   FRSADD+8
FRSADD2  DS    CL8
         ORG   FRSADD2
PARM3    DC    F'1'
PARM4    DC    AL4(IGFPMKF2)
         ORG   FRSADD2+8
FRSADD3  DS    CL8
         ORG   FRSADD3
PARM5    DC    F'1'
PARM6    DC    AL4(IGFPMKF3)
         ORG   FRSADD3+8
FRSADD4  DS    CL8
         ORG   FRSADD4
PARM7    DC    F'1'
PARM8    DC    AL4(IGFPMKF4)
         ORG   FRSADD4+8
FRSREP   DS    CL8
         ORG   FRSREP
PRM1     DC    F'0'
PRM2     DC    AL4(IGFPMKF2)
         ORG   FRSREP+8
FRSREP1  DS    CL8
         ORG   FRSREP1
PRM3     DC    F'0'
PRM4     DC    AL4(IGFPMKF5)
         ORG   FRSREP1+8
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LRBPTR   EQU   @06
R0       EQU   @00
R1       EQU   @01
R13      EQU   @13
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAPCCAR EQU   PSA+524
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
LRB      EQU   0
LRBHREL  EQU   LRB+1
LRBHSYS  EQU   LRBHREL
LRBHSW0  EQU   LRB+2
LRBHSW1  EQU   LRB+3
LRBHSW2  EQU   LRB+4
LRBMACT  EQU   LRBHSW2
LRBHSW3  EQU   LRB+5
LRBHDATE EQU   LRB+8
LRBHTIME EQU   LRB+12
LRBHCPID EQU   LRB+16
LRBBASE  EQU   LRB+24
LRBCVAR  EQU   0
LRBCMP   EQU   LRBCVAR+8
PCCA     EQU   0
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCAPWAR EQU   PCCA+156
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCAATTR EQU   PCCA+376
RVT      EQU   0
RVTPMFRS EQU   RVT+8
RVTPMTHA EQU   RVT+24
PWA      EQU   0
PWASA2   EQU   PWA+72
PWAFRR   EQU   PWA+384
PWAFLAGS EQU   PWA+778
PWAWRK   EQU   PWA+792
PWATCTHB EQU   PWA+960
PWAPTTHB EQU   PWA+976
PWACCTHB EQU   PWA+992
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTRMS   EQU   CVTMAP+224
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTTZ    EQU   CVTMAP+304
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
RVTFRS   EQU   0
IGFPMTHA EQU   0
SAVER    EQU   0
BACKPTR  EQU   SAVER+4
FWDPTR   EQU   SAVER+8
THAPLIST EQU   0
THAPARMS EQU   THAPLIST
THAPARM1 EQU   THAPARMS
THAPARM2 EQU   THAPARMS+4
THAMSG   EQU   THAPLIST+8
LRBHRSW1 EQU   LRBHSW1
LRBHCSW1 EQU   LRBHSW1
LRBHMSW1 EQU   LRBHSW1
LRBMMCH  EQU   LRBBASE
LRBMCEIA EQU   LRBMMCH+8
LRBMTERM EQU   LRBMCEIA
LRBMHARD EQU   LRBMCEIA+1
LRBMINTM EQU   LRBMCEIA+2
LRBMITOD EQU   LRBMINTM
LRBMICKC EQU   LRBMINTM
LRBMICTM EQU   LRBMINTM
LRBMIL80 EQU   LRBMINTM
LRBMSOFT EQU   LRBMCEIA+3
LRBMPDAR EQU   LRBMMCH+12
LRBMRSR1 EQU   LRBMMCH+13
LRBMRSR2 EQU   LRBMMCH+14
LRBMFLO  EQU   LRBMMCH+24
LRBMCIC  EQU   LRBMFLO
@NM00018 EQU   LRBMCIC
LRBMFTD  EQU   @NM00018
LRBMFCD  EQU   @NM00018
@NM00020 EQU   LRBMCIC+1
@NM00022 EQU   LRBMCIC+2
@NM00024 EQU   LRBMCIC+3
@NM00027 EQU   LRBMCIC+5
LRBMVPT  EQU   @NM00027
LRBMVCC  EQU   @NM00027
LRBRDDR  EQU   LRBBASE
LRBCCCH  EQU   LRBBASE
LRBCCUA  EQU   LRBCCCH+49
LRBDMDR  EQU   LRBBASE
LRBNMIH  EQU   LRBBASE
LRBTTER  EQU   LRBBASE
PCCAPTR  EQU   PSAPCCAR
PSARSVTE EQU   PSARSVT
RVTPTR   EQU   CVTRMS
PWAPTR   EQU   PCCAPWAR
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
LRBTUSR  EQU   LRBTTER+8
LRBTWSC  EQU   LRBTTER+4
LRBTLNH  EQU   LRBTTER
LRBNINT  EQU   LRBNMIH+24
LRBNDEVT EQU   LRBNMIH+20
LRBNVOL  EQU   LRBNMIH+14
LRBNCUA1 EQU   LRBNMIH+11
LRBNCUA2 EQU   LRBNMIH+8
LRBNJOB  EQU   LRBNMIH
LRBDSENS EQU   LRBDMDR+8
LRBDVOL  EQU   LRBDMDR+2
LRBDCUA1 EQU   LRBDMDR
LRBCCLOG EQU   LRBCCCH+56
LRBCLOGL EQU   LRBCCCH+54
LRBCHCUA EQU   LRBCCCH+52
LRBCCUA2 EQU   LRBCCUA+1
@NM00031 EQU   LRBCCUA
LRBCCHID EQU   LRBCCCH+48
LRBCDEVT EQU   LRBCCCH+44
LRBCECSW EQU   LRBCCCH+40
LRBCFCSW EQU   LRBCCCH+32
LRBCFCCW EQU   LRBCCCH+24
LRBCAIO  EQU   LRBCCCH+8
LRBCJOB  EQU   LRBCCCH
LRBRDEV2 EQU   LRBRDDR+32
LRBRCUA2 EQU   LRBRDDR+29
LRBRPH2  EQU   LRBRDDR+28
LRBRDEV1 EQU   LRBRDDR+24
LRBRCUA1 EQU   LRBRDDR+21
LRBRPH1  EQU   LRBRDDR+20
LRBRVOL2 EQU   LRBRDDR+14
LRBRVOL1 EQU   LRBRDDR+8
LRBRJOB  EQU   LRBRDDR
LRBMCEL  EQU   LRBMMCH+304
@NM00030 EQU   LRBMFLO+20
LRBMFSA  EQU   LRBMFLO+16
@NM00029 EQU   LRBMFLO+8
LRBMCELL EQU   LRBMCIC+6
@NM00028 EQU   @NM00027
@NM00026 EQU   LRBMCIC+4
LRBMVST  EQU   @NM00024
LRBMVLG  EQU   @NM00024
LRBMVCR  EQU   @NM00024
LRBMVGR  EQU   @NM00024
LRBMVFP  EQU   @NM00024
@NM00025 EQU   @NM00024
LRBMVRC  EQU   @NM00024
LRBMVFA  EQU   @NM00024
LRBMVIA  EQU   @NM00022
LRBMVPM  EQU   @NM00022
LRBMVMS  EQU   @NM00022
LRBMVWP  EQU   @NM00022
@NM00023 EQU   @NM00022
LRBMFKE  EQU   @NM00022
LRBMFSC  EQU   @NM00022
LRBMFSE  EQU   @NM00022
LRBMIDY  EQU   @NM00020
LRBMIBU  EQU   @NM00020
@NM00021 EQU   @NM00020
LRBMFWN  EQU   @NM00020
LRBMFDG  EQU   @NM00018
@NM00019 EQU   @NM00018
LRBMFED  EQU   @NM00018
LRBMFSR  EQU   @NM00018
LRBMFPD  EQU   @NM00018
LRBMFSD  EQU   @NM00018
LRBMMOSW EQU   LRBMMCH+16
LRBMPWL  EQU   LRBMMCH+15
LRBMVEQR EQU   LRBMRSR2
LRBMPGFX EQU   LRBMRSR2
LRBMLSQA EQU   LRBMRSR2
LRBMFSQA EQU   LRBMRSR2
LRBMNUCL EQU   LRBMRSR2
LRBMSPER EQU   LRBMRSR2
LRBMINTC EQU   LRBMRSR2
LRBMOFLN EQU   LRBMRSR2
LRBMCHNG EQU   LRBMRSR1
LRBMSER  EQU   LRBMRSR1
@NM00017 EQU   LRBMRSR1
@NM00016 EQU   LRBMPDAR
LRBMRSRF EQU   LRBMPDAR
LRBMRSRC EQU   LRBMPDAR
LRBMINVP EQU   LRBMPDAR
@NM00015 EQU   LRBMPDAR
LRBMSBUF EQU   LRBMSOFT
LRBMSHIR EQU   LRBMSOFT
LRBMSECC EQU   LRBMSOFT
LRBMSEXD EQU   LRBMSOFT
@NM00014 EQU   LRBMSOFT
LRBMSSFT EQU   LRBMSOFT
@NM00013 EQU   LRBMINTM
LRBMHIPD EQU   LRBMHARD
LRBMHSPF EQU   LRBMHARD
LRBMHSTO EQU   LRBMHARD
LRBMHINV EQU   LRBMHARD
LRBMHSD  EQU   LRBMHARD
@NM00012 EQU   LRBMHARD
LRBMHHRD EQU   LRBMHARD
LRBMTINV EQU   LRBMTERM
LRBMTDMG EQU   LRBMTERM
LRBMTWRN EQU   LRBMTERM
LRBMTCKS EQU   LRBMTERM
LRBMTSEC EQU   LRBMTERM
LRBMTTHR EQU   LRBMTERM
@NM00011 EQU   LRBMTERM
LRBMWSC  EQU   LRBMMCH+4
LRBMLNH  EQU   LRBMMCH
@NM00010 EQU   LRBHMSW1
LRBMSYST EQU   LRBHMSW1
@NM00009 EQU   LRBHMSW1
@NM00008 EQU   LRBHCSW1
LRBCERPP EQU   LRBHCSW1
LRBCDATA EQU   LRBHCSW1
LRBCICUA EQU   LRBHCSW1
LRBCNOSP EQU   LRBHCSW1
@NM00007 EQU   LRBHCSW1
LRBCINCO EQU   LRBHCSW1
LRBCMESG EQU   LRBHCSW1
@NM00006 EQU   LRBHRSW1
LRBRSYSI EQU   LRBHRSW1
LRBROPER EQU   LRBHRSW1
LRBRSEC  EQU   LRBHRSW1
LRBRPRIM EQU   LRBHRSW1
@NM00062 EQU   SAVER+12
@NM00061 EQU   SAVER
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00060 EQU   CVTFIX+248
@NM00059 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
PWAIVTHB EQU   PWA+944
PWASDTHB EQU   PWA+928
PWAPDTHB EQU   PWA+912
PWANRSRB EQU   PWA+868
PWACCSRB EQU   PWA+824
PWATEST  EQU   PWA+784
PWACPUAD EQU   PWA+782
@NM00058 EQU   PWA+781
PWACNTR  EQU   PWA+780
PWAEDSRB EQU   PWA+779
@NM00057 EQU   PWAFLAGS
PWAENABL EQU   PWAFLAGS
PWANRHED EQU   PWAFLAGS
PWACCHED EQU   PWAFLAGS
PWAREST  EQU   PWAFLAGS
PWAINIT  EQU   PWA+777
PWAMFAFL EQU   PWA+776
PWARPSW  EQU   PWA+768
PWARGPR  EQU   PWA+704
PWACR15  EQU   PWA+700
PWACR14  EQU   PWA+696
PWASFLC  EQU   PWA+464
PWAINTC  EQU   PWA+456
PWASOSW  EQU   PWA+448
PWAFRR00 EQU   PWAFRR+12
PWAFRR15 EQU   PWAFRR+8
PWAFRR13 EQU   PWAFRR+4
PWAFRR12 EQU   PWAFRR
PWAFRRCT EQU   PWA+380
PWAFRRCD EQU   PWA+376
PWADGTHB EQU   PWA+368
PWASRTHB EQU   PWA+360
PWAESA   EQU   PWA+288
PWASA4   EQU   PWA+216
PWASA3   EQU   PWA+144
PWASA1   EQU   PWA
RVTMIH2  EQU   RVT+108
RVTMIH   EQU   RVT+104
RVTCCHCR EQU   RVT+100
RVTCCHDA EQU   RVT+96
RVTMSGLN EQU   RVT+92
RVTMSGPT EQU   RVT+88
RVTLRBPT EQU   RVT+84
RVTRWAPT EQU   RVT+80
RVT01MMM EQU   RVT+76
RVT00MMM EQU   RVT+72
RVTPEXIT EQU   RVT+68
RVTPKREF EQU   RVT+64
RVTPBUCR EQU   RVT+60
RVTPXMFA EQU   RVT+56
RVTPTAIM EQU   RVT+52
RVTPTCON EQU   RVT+48
RVTPTREC EQU   RVT+44
RVTPTSIG EQU   RVT+40
RVTPTERM EQU   RVT+36
RVTPMKTA EQU   RVT+32
RVTPMMSG EQU   RVT+28
RVTPMPFX EQU   RVT+20
RVTPMSCA EQU   RVT+16
RVTPMHCA EQU   RVT+12
RVTPMRTM EQU   RVT+4
RVTPMCIH EQU   RVT
@NM00032 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCAR105 EQU   PCCAATTR
PCCAR104 EQU   PCCAATTR
PCCAR103 EQU   PCCAATTR
PCCAR102 EQU   PCCAATTR
PCCAR101 EQU   PCCAATTR
PCCAR100 EQU   PCCAATTR
PCCAIO   EQU   PCCAATTR
PCCACPUM EQU   PCCAATTR
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCACPID EQU   PCCA+4
PCCAPCCA EQU   PCCA
LRBCMPCS EQU   LRBCMP+2
LRBCMPPA EQU   LRBCMP
LRBCMPNO EQU   LRBCVAR+6
LRBCMPF2 EQU   LRBCVAR+5
LRBCMPF1 EQU   LRBCVAR+4
LRBCRESD EQU   LRBCVAR+2
LRBCFT   EQU   LRBCVAR
LRBHMCEL EQU   LRBHCPID+6
LRBHMDL  EQU   LRBHCPID+4
LRBHCSER EQU   LRBHCPID+1
@NM00005 EQU   LRBHCPID
@NM00004 EQU   LRB+7
LRBHCNT  EQU   LRB+6
LRBMCLB  EQU   LRBHSW3
LRBNDEM  EQU   LRBMACT
LRBNCEM  EQU   LRBMACT
@NM00003 EQU   LRBHSW0
LRBHTMC  EQU   LRBHSW0
@NM00002 EQU   LRBHSW0
LRBHNS   EQU   LRBHSW0
LRBHMORE EQU   LRBHSW0
@NM00001 EQU   LRBHSYS
LRBHSYSB EQU   LRBHSYS
LRBHTYPE EQU   LRB
@NM00056 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00055 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00054 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00053 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00052 EQU   FLCFSA
@NM00051 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00050 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00049 EQU   FLCIOA
@NM00048 EQU   FLCMCLA+15
@NM00047 EQU   FLCMCLA+14
@NM00046 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00045 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00044 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00043 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00042 EQU   FLCPER
@NM00041 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00040 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00039 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00038 EQU   FLCPIILC
@NM00037 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00036 EQU   FLCSVILC
@NM00035 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00034 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00033 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IGFPMKTA,(C'PLS1054',0701,78089)
