         TITLE 'IGFPMTHA - MACHINE CHECK THRESHOLD ANALYSIS            *
                        '
IGFPMTHA CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IGFPMTHA  78.053'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*                                                                  0075
*/************************************************************       */
*/*                   STANDARD  LINKAGE                              */
*/************************************************************       */
*                                                                  0075
*   FWDPTR=ADDR(PWASA3);            /* CHAIN FOWARD POINTER          */
         L     @07,PCCAPTR                                         0075
         L     @07,PWAPTR(,@07)                                    0075
         LA    @15,PWASA3(,@07)                                    0075
         ST    @15,FWDPTR(,R13)                                    0075
*   ADDR(PWASA3)->BACKPTR=R13;      /* CHAIN BACK PTR THIS RTN       */
         ST    R13,BACKPTR+144(,@07)                               0076
*   R13=ADDR(PWASA3);               /* LOAD SAVE AREA POINTER        */
         LR    R13,@15                                             0077
*/************************************************************       */
*/*     SAVE THB AND MSG POINTERS AND SET UP FRR VECTOR              */
*/************************************************************       */
*                                                                  0078
*   PRMREG6=R1;                     /* SAVE INPUT POINTERS           */
         LR    PRMREG6,R1                                          0078
*   R1=ADDR(FRSADD);                /* ADD TO FRS STACK              */
         LA    R1,FRSADD                                           0079
*   CALL RVTFRS;                    /* GO ADJUST VECTOR TABLE        */
         L     @07,CVTPTR                                          0080
         L     @07,RVTPTR(,@07)                                    0080
         L     @15,RVTPMFRS(,@07)                                  0080
         BALR  @14,@15                                             0080
*/************************************************************       */
*/*   THIS ROUTINE SAVES THE THRESHOLD BLOCK AND INTERROGATES        */
*/*   IT TO DETERMINE IF A MESSAGE IS TO BE WRITTEN OR NOT.          */
*/*   BITS ARE SET TO INDICATE A MESSAGE OR NOT.                     */
*/************************************************************       */
*                                                                  0081
*LOOP:                                                             0081
*   ;                                                              0081
LOOP     DS    0H                                                  0082
*   R2=THB(1:4);                    /* LOAD FIRST HALF OF THB IN REG */
         L     @07,THBPTR(,PRMREG6)                                0082
         ICM   R2,15,THB(@07)                                      0082
*   R3=THB(5:8);                    /* LOAD SECOND HALF OF THB IN REG*/
         ICM   R3,15,THB+4(@07)                                    0083
*   MSGVAR1(1:4)=THB(1:4);          /* SAVE THRESHOLD STATUS         */
         L     @15,MSGPTR(,PRMREG6)                                0084
         MVC   MSGVAR1(4,@15),THB(@07)                             0084
*   MSGVAR2(1:4)=THB(5:8);          /* SAVE THRESHOLD COUNT          */
         MVC   MSGVAR2(4,@15),THB+4(@07)                           0085
*/********************************************************************/
*/*                 INCREMENT THRESHOLD COUNTER                      */
*/*                                                                  */
*/*  FOR HARD MACHINE CHECKS, INCREMENT COUNTER                      */
*/*  IF TIMING INTERVAL HAS NOT ELAPSED OR TOD CLOCK WAS NO GOOD.    */
*/*  OTHERWISE RESET COUNTER TO ZERO BEFORE INCREMENTING,RESET       */
*/*  BEGINNING OF TIMING INTERVAL.                                   */
*/*                                                                  */
*/*  FOR SOFT ERRORS INCREMENT COUNTER.                              */
*/*                                                                  */
*/*********************************************************  @G55CP2P*/
*                                                                  0086
*   IF THBEXT='1'B                  /* HARD THRESHOLD BLOCK ?      0086
*                                                            @G55CP2P*/
*     THEN                                                         0086
         TM    THBEXT(@07),B'00010000'                             0086
         BNO   @RF00086                                            0086
*     IF(LRBHDATE-THBOTIME>         /* YES - SEE IF INTERVAL @G55CP2P*/
*         THBNTRVL)&                /* HAS ELAPSED AND       @G55CP2P*/
*         LRBHDATE^=0               /* TOD CLOCK GOOD        @G55CP2P*/
*       THEN                                                       0087
         L     @14,PCCAPTR                                         0087
         L     @14,LRBPTR(,@14)                                    0087
         L     @11,LRBHDATE(,@14)                                  0087
         LR    @00,@11                                             0087
         SL    @00,THBOTIME(,@07)                                  0087
         L     @10,THBNTRVL-1(,@07)                                0087
         LA    @10,0(,@10)                                         0087
         CLR   @00,@10                                             0087
         BNH   @RF00087                                            0087
         SLR   @10,@10                                             0087
         CLR   @11,@10                                             0087
         BE    @RF00087                                            0087
*       DO;                         /* YES - SET COUNT TO 0 RESET  0088
*                                      BEGINNING OF TIMING INTERVAL
*                                                            @G55CP2P*/
*         MSGVAR1(2:4)=0;           /*                       @G55CP2P*/
         STCM  @10,7,MSGVAR1+1(@15)                                0089
*         THBOTIME=LRBHDATE;        /*                       @G55CP2P*/
         MVC   THBOTIME(4,@07),LRBHDATE(@14)                       0090
*       END;                        /*                       @G55CP2P*/
*   MSGVAR1(2:4)=MSGVAR1(2:4)+1;    /* INCREMENT COUNTER     @G55CP2P*/
@RF00087 DS    0H                                                  0092
@RF00086 L     @07,MSGPTR(,PRMREG6)                                0092
         LA    @00,1                                               0092
         SLR   @15,@15                                             0092
         ICM   @15,7,MSGVAR1+1(@07)                                0092
         ALR   @00,@15                                             0092
         STCM  @00,7,MSGVAR1+1(@07)                                0092
*/************************************************************       */
*/*  DETERMINE IF A THRESHOLD OF DEGRADATION MACHINE CHECKS          */
*/*  HAS OCCURED, BASED ON BUFFER ENABLEMENT THRESHOLD. IF           */
*/*  SO, AND THE MODEL SUPPORTS BUFFER ENABLEMENT, THEN SET          */
*/*  BIT IN PWA TO REQUEST ENABLEMENT.                               */
*/************************************************************       */
*                                                                  0093
*   IF LRBMFDG='1'B THEN            /* CHECK FOR DEGRAD.MACH.CK.   0093
*                                                            @G556P2P*/
         L     @07,PCCAPTR                                         0093
         L     @15,LRBPTR(,@07)                                    0093
         TM    LRBMFDG(@15),B'00000001'                            0093
         BNO   @RF00093                                            0093
*     IF PCCACPID(9:12)=MOD165|     /* IF A 165 OR           @G556P2P*/
*         PCCACPID(9:12)=MOD168|    /* 168                   @G556P2P*/
*         PCCACPID(9:12)=M168AP|    /* OR 168AP              @G556P2P*/
*         PCCACPID(9:12)=M3032|     /* OR 3032               @ZA30079*/
*         PCCACPID(9:12)=M3033 THEN /* OR 3033 THEN          @ZM45593*/
         CLC   PCCACPID+8(4,@07),MOD165                            0094
         BE    @RT00094                                            0094
         CLC   PCCACPID+8(4,@07),MOD168                            0094
         BE    @RT00094                                            0094
         CLC   PCCACPID+8(4,@07),M168AP                            0094
         BE    @RT00094                                            0094
         CLC   PCCACPID+8(4,@07),M3032                             0094
         BE    @RT00094                                            0094
         CLC   PCCACPID+8(4,@07),M3033                             0094
         BNE   @RF00094                                            0094
@RT00094 DS    0H                                                  0095
*       IF THBENABL^=0 THEN         /* IF THRESHOLD DEFINED, @G55CP2P*/
         L     @07,THBPTR(,PRMREG6)                                0095
         CLI   THBENABL(@07),0                                     0095
         BE    @RF00095                                            0095
*         IF MSGVAR1(2:4)//THBENABL=0/* CHECK INTEGRAL MULTIPLE    0096
*                                      BUFFER THRESHOLD      @G556P2P*/
*           THEN                                                   0096
         L     @15,MSGPTR(,PRMREG6)                                0096
         SLR   @09,@09                                             0096
         ICM   @09,7,MSGVAR1+1(@15)                                0096
         SLR   @08,@08                                             0096
         SLR   @00,@00                                             0096
         IC    @00,THBENABL(,@07)                                  0096
         DR    @08,@00                                             0096
         LTR   @08,@08                                             0096
         BNZ   @RF00096                                            0096
*           PWAENABL='1'B;          /* YES, SET BIT FOR BUFFER/TLB 0097
*                                      ENABLE                @G556P2P*/
         L     @07,PCCAPTR                                         0097
         L     @07,PWAPTR(,@07)                                    0097
         OI    PWAENABL(@07),B'00010000'                           0097
*/************************************************************       */
*/*  DETERMINE IF A THRESHOLD OF MACHINE CHECKS HAS OCCURED          */
*/*  BASED ON RECORDING THRESHOLD. IF SO TAKE THE PROPER             */
*/*  ACTION, BASED ON THE TYPE OF MACHINE CHECK BEING                */
*/*  PROCESSED.                                                      */
*/************************************************************       */
*                                                                  0098
*   IF MSGVAR1(2:4)//THBTHR=0       /* CHECK INTEGRAL MULTIPLE       */
*     THEN                                                         0098
@RF00096 DS    0H                                                  0098
@RF00095 DS    0H                                                  0098
@RF00094 DS    0H                                                  0098
@RF00093 L     @07,MSGPTR(,PRMREG6)                                0098
         L     @15,THBPTR(,PRMREG6)                                0098
         SLR   @09,@09                                             0098
         ICM   @09,7,MSGVAR1+1(@07)                                0098
         SLR   @08,@08                                             0098
         L     @07,THBTHR-1(,@15)                                  0098
         LA    @07,0(,@07)                                         0098
         DR    @08,@07                                             0098
         LTR   @08,@08                                             0098
         BNZ   @RF00098                                            0098
*     DO;                           /*                       @G556P2P*/
*/********************************************************************/
*/*   THE FOLLOWING SECTION OF CODE PROCESSES HARD                   */
*/*   THRESHOLDS.                                                    */
*/*           - - - - - - - - - - - - - - - - - - - - - - -          */
*/*                                                                  */
*/*   SET BIT IN LRB (LRBMTTHR) TO TELL MAINLINE                     */
*/*   MCH TO CALL IGFPTERM TO TAKE THIS PROCESSOR OFFLINE            */
*/*   UNLESS RECORD MODE IS RECORD=ALL                               */
*/***********************************************************@G55CP2P*/
*                                                                  0100
*       IF THBEXT='1'B              /* Q. HARD THRESHOLD     @G55CP2P*/
*         THEN                                                     0100
         TM    THBEXT(@15),B'00010000'                             0100
         BNO   @RF00100                                            0100
*         IF THBREC='0'B            /* YES - SET TERM BIT IF RECORD
*                                      MODE NOT RECORD=ALL   @G55CP2P*/
*           THEN                                                   0101
         TM    THBREC(@15),B'01000000'                             0101
         BNZ   @RF00101                                            0101
*           LRBMTTHR='1'B;          /*                       @G55CP2P*/
         L     @07,PCCAPTR                                         0102
         L     @07,LRBPTR(,@07)                                    0102
         OI    LRBMTTHR(@07),B'00100000'                           0102
*         ELSE                                                     0103
*           ;                       /*                       @G55CP2P*/
@RF00101 DS    0H                                                  0104
*/***********************************************************@G55CP2P*/
*/* THIS SECTION OF CODE PROCESSES SOFT MACHINE CHECK THRESHOLDS     */
*/*    - - - - - - - - - - - - - - - - - - - - - - - - - - -         */
*/*                                                                  */
*/*IF SYSTEM RECOVERY OR DEGRADATION THRESHOLD, SET PROPER           */
*/*MODE AND SCHEDULE MESSAGE                                         */
*/***********************************************************@G55CP2P*/
*                                                                  0104
*       ELSE                                                       0104
*         DO;                       /*                       @G55CP2P*/
         B     @RC00100                                            0104
@RF00100 DS    0H                                                  0105
*           IF THBREC='1'B          /* CHECK IF RECORD=ALL           */
*             THEN                                                 0105
         L     @07,THBPTR(,PRMREG6)                                0105
         TM    THBREC(@07),B'01000000'                             0105
         BNO   @RF00105                                            0105
*             MSGTAB2='04'X;        /* YES - RECORD MODE             */
         L     @07,MSGPTR(,PRMREG6)                                0106
         MVI   MSGTAB2(@07),X'04'                                  0106
*           ELSE                                                   0107
*             DO;                                                  0107
         B     @RC00105                                            0107
@RF00105 DS    0H                                                  0108
*               MSGVAR1(1:1)='80'X; /* YES - SET QUIET MODE          */
         L     @07,MSGPTR(,PRMREG6)                                0108
         MVI   MSGVAR1(@07),X'80'                                  0108
*               MSGTAB2='03'X;      /* INDICATE QUIET MODE           */
         MVI   MSGTAB2(@07),X'03'                                  0109
*             END;                                                 0110
*         END;                      /*                       @G55CP2P*/
*     END;                                                         0112
*   ELSE                                                           0113
*     MSGNUM=0;                     /* INDICATE NO MESSAGE REQUIRED  */
         B     @RC00098                                            0113
@RF00098 L     @07,MSGPTR(,PRMREG6)                                0113
         MVI   MSGNUM(@07),X'00'                                   0113
*/************************************************************       */
*/*   THIS ROUTINE SETS UP A CDS(COMPARE AND SWAP) SO THAT           */
*/*   THE  MODIFIED THB CAN BE STORED IN THE PROPER PROCESSOR.       */
*/************************************************************       */
*                                                                  0114
*   R4=MSGVAR1;                     /* SET UP REGISTERS              */
@RC00098 L     @07,MSGPTR(,PRMREG6)                                0114
         ICM   R4,15,MSGVAR1(@07)                                  0114
*   R5=MSGVAR2;                     /* FOR CDS INSTRUCTION           */
         ICM   R5,15,MSGVAR2(@07)                                  0115
*   CDS(R2,R4,THBBASE);             /* EXECUTE COMPARE AND SWAP      */
         L     @07,THBPTR(,PRMREG6)                                0116
         CDS   R2,R4,THBBASE(@07)                                  0116
*   BC(7,LOOP);                     /* TRY AGAIN                     */
         BC    7,LOOP                                              0117
*/************************************************************       */
*/*   THIS ROUTINE CHECKS TO SEE IF A MESSAGE IS TO BE               */
*/*   WRITTEN.  IF A MESSAGE IS TO BE WRITTEN                        */
*/*   WE CALL THE MESSAGE ROUTINE TO WRITE THE MESSAGE.              */
*/*   MSGNUM WILL ALWAYS CONTAIN THE CORRECT MESSAGE NUMBER          */
*/*   WHEN THIS MODULE GETS CONTROL, IF A MESSAGE IS TO BE           */
*/*   WRITTEN.                                                       */
*/************************************************************       */
*                                                                  0118
*   IF MSGNUM^=0                    /* CHECK IF MESSAGE IS REQUIRED
*                                                            @G556P2P*/
*     THEN                                                         0118
         L     @07,MSGPTR(,PRMREG6)                                0118
         CLI   MSGNUM(@07),0                                       0118
         BE    @RF00118                                            0118
*     DO;                           /*                       @G556P2P*/
*       MSGVAR2=PCCACPUA;           /* YES - GET CPU NUMBER FROM PCCA*/
         L     @15,PCCAPTR                                         0120
         LH    @00,PCCACPUA(,@15)                                  0120
         STCM  @00,15,MSGVAR2(@07)                                 0120
*       MSGVAR1(1:1)='00'X;         /* ZERO FIRST BYTE OF MSG STATUS */
         MVI   MSGVAR1(@07),X'00'                                  0121
*       R1=MSGADR;                  /* LOAD REG1 WITH MESSAGE BUF  0122
*                                      ADDR                          */
         L     R1,MSGADR(,PRMREG6)                                 0122
*       CALL RVTMSG;                /* CALL MESSAGE ROUTINE          */
         L     @07,CVTPTR                                          0123
         L     @07,RVTPTR(,@07)                                    0123
         L     @15,RVTPMMSG(,@07)                                  0123
         BALR  @14,@15                                             0123
*/************************************************************       */
*/*  UPON RETURN FROM THE MESSAGE WRITER THE RETURN CODE IS          */
*/*  CHECKED. IF THE RETURN CODE IS NOT ZERO WE SET AN               */
*/*  INDICATOR IN THE RWA TO INDICATE AN ERROR.                      */
*/************************************************************       */
*                                                                  0124
*       IF R15^=0                   /* CHECK RETURN CODE FOR NONZERO
*                                                            @G556P2P*/
*         THEN                                                     0124
         LTR   R15,R15                                             0124
         BZ    @RF00124                                            0124
*         MESS31='1'B;              /* SET ERROR INDICATOR BIT       */
         L     @15,CVTPTR                                          0125
         L     @15,RVTPTR(,@15)                                    0125
         L     @15,RWAPTR(,@15)                                    0125
         L     @07,MESS31-3(,@15)                                  0125
@GL00006 LR    @00,@07                                             0125
         O     @00,@CF01716                                        0125
         CS    @07,@00,MESS31-3(@15)                               0125
         BNE   @GL00006                                            0125
*     END;                          /*                       @G556P2P*/
@RF00124 DS    0H                                                  0127
*/********************************************************************/
*/* ISSUE BUFFER RESTORE MESSAGE IF REQUIRED                 @G556P2P*/
*/********************************************************************/
*                                                                  0127
*   IF PWAENABL='1'B                /* IS BUFFER ENABLE MESSAGE REQD
*                                                            @G556P2P*/
*     THEN                                                         0127
@RF00118 L     @07,PCCAPTR                                         0127
         L     @15,PWAPTR(,@07)                                    0127
         TM    PWAENABL(@15),B'00010000'                           0127
         BNO   @RF00127                                            0127
*     DO;                           /* YES                   @G556P2P*/
*       MSG=MSG&&MSG;               /* CLEAR MESSAGE         @G556P2P*/
         L     @15,MSGPTR(,PRMREG6)                                0129
         XC    MSG(12,@15),MSG(@15)                                0129
*       MSGNUM=IGF956I;             /* BUILD MESSAGE         @G556P2P*/
         MVI   MSGNUM(@15),X'56'                                   0130
*       MSGVAR1=PCCACPUA;           /* BUFFER                @G556P2P*/
         LH    @07,PCCACPUA(,@07)                                  0131
         STCM  @07,15,MSGVAR1(@15)                                 0131
*       R1=MSGADR;                  /* LOAD REG1 WITH MESSAGE BUF  0132
*                                      ADDR                  @G556P2P*/
         L     R1,MSGADR(,PRMREG6)                                 0132
*       CALL RVTMSG;                /* LINK TO MESSAGE SCHEDULER   0133
*                                                            @G556P2P*/
         L     @07,CVTPTR                                          0133
         L     @07,RVTPTR(,@07)                                    0133
         L     @15,RVTPMMSG(,@07)                                  0133
         BALR  @14,@15                                             0133
*       IF R15^=0                   /* CHECK RETURN CODE FROM MESSAGE
*                                                            @G55CP2P*/
*         THEN                      /* SCHEDULER - IF NONZERO      0134
*                                                            @G556P2P*/
         LTR   R15,R15                                             0134
         BZ    @RF00134                                            0134
*         RWAMSG56='1'B;            /* SET MESSAGE LOST INDICATOR  0135
*                                                            @G556P2P*/
         L     @07,CVTPTR                                          0135
         L     @07,RVTPTR(,@07)                                    0135
         L     @07,RWAPTR(,@07)                                    0135
         OI    RWAMSG56(@07),B'00001000'                           0135
*     END;                          /*                       @G556P2P*/
@RF00134 DS    0H                                                  0137
*/********************************************************************/
*/*  THIS ROUTINE SETS UP                                            */
*/*  TO ADJUST THE FRR STACK AND RETURN TO THE CALLER.               */
*/********************************************************************/
*                                                                  0137
*MCEXIT:                                                           0137
*   ;                                                              0137
@RF00127 DS    0H                                                  0137
MCEXIT   DS    0H                                                  0138
*   R1=ADDR(FRSDEL);                /* SET UP TO DELETE FROM STACKER */
         LA    R1,FRSDEL                                           0138
*   CALL RVTFRS;                    /* GO ADJUST VECTOR TABLE        */
         L     @07,CVTPTR                                          0139
         L     @07,RVTPTR(,@07)                                    0139
         L     @15,RVTPMFRS(,@07)                                  0139
         BALR  @14,@15                                             0139
*   R13=BACKPTR;                    /* RESTORE REG 13 SAVE AREA      */
         L     R13,BACKPTR(,R13)                                   0140
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 DS    0H                                                  0141
@EF00001 DS    0H                                                  0141
@ER00001 LM    @14,@12,12(@13)                                     0141
         BR    @14                                                 0141
*/************************************************************       */
*/*   THIS IS THE FRR ROUTINE OF IGFPMTHA. THIS ROUTINE IS           */
*/*   ENTERED WHEN A PROGRAM CHECK OR A MACHINE CHECK OCCURS         */
*/*   WHILE IGFPMTHA IS IN PROCESS. IT MERELY SETS AN                */
*/*   INDICATOR BIT IN THE RWA AND RETURNS.                          */
*/************************************************************       */
*                                                                  0142
*IGFPMTFR:                                                         0142
*   ;                                                              0142
IGFPMTFR DS    0H                                                  0143
*   MESSXX='1'B;                    /* MC,PC OR LOOP SET ERROR     0143
*                                      INDICATOR                     */
         L     @15,CVTPTR                                          0143
         L     @15,RVTPTR(,@15)                                    0143
         L     @15,RWAPTR(,@15)                                    0143
         L     @07,MESSXX-3(,@15)                                  0143
@GL00007 LR    @00,@07                                             0143
         O     @00,@CF01720                                        0143
         CS    @07,@00,MESSXX-3(@15)                               0143
         BNE   @GL00007                                            0143
*   R13=BACKPTR;                    /* RESTORE REG 13 SAVE AREA      */
         L     R13,BACKPTR(,R13)                                   0144
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00001                                            0145
*   END IGFPMTHA                                                   0146
*                                                                  0146
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHALRB  )                                       */
*/*%INCLUDE SYSLIB  (IHACSD  )                                       */
*/*%INCLUDE SYSLIB  (IGFPWA  )                                       */
*/*%INCLUDE SYSLIB  (IGFTHB  )                                       */
*/*%INCLUDE SYSLIB  (IGFRWA  )                                       */
*/*%INCLUDE SYSLIB  (IGFMSG  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARVT  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCAT)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*                                                                  0146
*       ;                                                          0146
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IGFPMTHA CSECT
         DS    0F
@CF01716 DC    BL4'00000000000000000000000010000000'
@CF01720 DC    BL4'00000000000000000000000000010000'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGFPMTHA CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
FRSDEL   DC    F'-1'
FRSADD   DS    CL8
         ORG   FRSADD
PARM1    DC    F'1'
PARM2    DC    AL4(IGFPMTFR)
         ORG   FRSADD+8
MOD165   DC    CL4'0165'
MOD168   DC    CL4'0168'
M168AP   DC    CL4'3062'
M3032    DC    CL4'3032'
M3033    DC    CL4'3033'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
PRMREG6  EQU   @06
R13      EQU   @13
R15      EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAPCCAR EQU   PSA+524
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
LRB      EQU   0
LRBHREL  EQU   LRB+1
LRBHSYS  EQU   LRBHREL
LRBHSW0  EQU   LRB+2
LRBHSW1  EQU   LRB+3
LRBHSW2  EQU   LRB+4
LRBMACT  EQU   LRBHSW2
LRBHSW3  EQU   LRB+5
LRBHDATE EQU   LRB+8
LRBHCPID EQU   LRB+16
LRBBASE  EQU   LRB+24
LRBCVAR  EQU   0
LRBCMP   EQU   LRBCVAR+8
CSD      EQU   0
CSDCPUAL EQU   CSD+8
CSDSCWRD EQU   CSD+12
CSDSCFL1 EQU   CSDSCWRD
CSDSCFL2 EQU   CSDSCWRD+1
CSDSCFL3 EQU   CSDSCWRD+2
CSDSCFL4 EQU   CSDSCWRD+3
CSDFLAGS EQU   CSD+23
PWA      EQU   0
PWASA3   EQU   PWA+144
PWAFRR   EQU   PWA+384
PWAFLAGS EQU   PWA+778
PWAENABL EQU   PWAFLAGS
THB      EQU   0
THBBASE  EQU   THB
THBMODE  EQU   THBBASE
THBREC   EQU   THBMODE
THBEXT   EQU   THBMODE
THBENABL EQU   THBBASE+4
THBTHR   EQU   THBBASE+5
THBEXTND EQU   THB+8
THBOTIME EQU   THBEXTND
THBNTRVL EQU   THBEXTND+5
RWA      EQU   0
RWATERM  EQU   RWA
RWAMSGFL EQU   RWA+27
RWAMSG56 EQU   RWAMSGFL
RWAFLAGS EQU   RWA+28
MSG      EQU   0
MSGNUM   EQU   MSG+1
MSGTAB2  EQU   MSG+3
MSGCHAR  EQU   MSG+4
MSGVAR1  EQU   MSGCHAR
MSGVAR2  EQU   MSGCHAR+4
RVT      EQU   0
RVTPMFRS EQU   RVT+8
RVTPMMSG EQU   RVT+28
RVTRWAPT EQU   RVT+80
PCCA     EQU   0
PCCACPID EQU   PCCA+4
PCCACPUA EQU   PCCA+16
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCAPWAR EQU   PCCA+156
PCCALRBR EQU   PCCA+164
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCAATTR EQU   PCCA+376
PCCAVT   EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTRMS   EQU   CVTMAP+224
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
PARMLIST EQU   0
THBADR   EQU   PARMLIST
MSGADR   EQU   PARMLIST+4
SAVER    EQU   0
BACKPTR  EQU   SAVER+4
FWDPTR   EQU   SAVER+8
RVTMSG   EQU   0
RVTFRS   EQU   0
LRBPTR   EQU   PCCALRBR
LRBHRSW1 EQU   LRBHSW1
LRBHCSW1 EQU   LRBHSW1
LRBHMSW1 EQU   LRBHSW1
LRBMMCH  EQU   LRBBASE
LRBMCEIA EQU   LRBMMCH+8
LRBMTERM EQU   LRBMCEIA
LRBMTTHR EQU   LRBMTERM
LRBMHARD EQU   LRBMCEIA+1
LRBMINTM EQU   LRBMCEIA+2
LRBMSOFT EQU   LRBMCEIA+3
LRBMPDAR EQU   LRBMMCH+12
LRBMRSR1 EQU   LRBMMCH+13
LRBMRSR2 EQU   LRBMMCH+14
LRBMFLO  EQU   LRBMMCH+24
LRBMCIC  EQU   LRBMFLO
@NM00018 EQU   LRBMCIC
LRBMFDG  EQU   @NM00018
@NM00020 EQU   LRBMCIC+1
@NM00022 EQU   LRBMCIC+2
@NM00024 EQU   LRBMCIC+3
@NM00027 EQU   LRBMCIC+5
LRBRDDR  EQU   LRBBASE
LRBCCCH  EQU   LRBBASE
LRBCCUA  EQU   LRBCCCH+49
LRBDMDR  EQU   LRBBASE
LRBNMIH  EQU   LRBBASE
LRBTTER  EQU   LRBBASE
PWAPTR   EQU   PCCAPWAR
THBPTR   EQU   THBADR
RWAPTR   EQU   RVTRWAPT
MSGPTR   EQU   MSGADR
PSARSVTE EQU   PSARSVT
RVTPTR   EQU   CVTRMS
PCCAPTR  EQU   PSAPCCAR
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTCSD   EQU   CVTS01+312
CVTPCCAT EQU   CVTS01+416
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
MESSFLG  EQU   RWAMSGFL
MESS31   EQU   MESSFLG
MESSXX   EQU   MESSFLG
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00070 EQU   MESSFLG
@NM00069 EQU   MESSFLG
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
LRBTUSR  EQU   LRBTTER+8
LRBTWSC  EQU   LRBTTER+4
LRBTLNH  EQU   LRBTTER
LRBNINT  EQU   LRBNMIH+24
LRBNDEVT EQU   LRBNMIH+20
LRBNVOL  EQU   LRBNMIH+14
LRBNCUA1 EQU   LRBNMIH+11
LRBNCUA2 EQU   LRBNMIH+8
LRBNJOB  EQU   LRBNMIH
LRBDSENS EQU   LRBDMDR+8
LRBDVOL  EQU   LRBDMDR+2
LRBDCUA1 EQU   LRBDMDR
LRBCCLOG EQU   LRBCCCH+56
LRBCLOGL EQU   LRBCCCH+54
LRBCHCUA EQU   LRBCCCH+52
LRBCCUA2 EQU   LRBCCUA+1
@NM00031 EQU   LRBCCUA
LRBCCHID EQU   LRBCCCH+48
LRBCDEVT EQU   LRBCCCH+44
LRBCECSW EQU   LRBCCCH+40
LRBCFCSW EQU   LRBCCCH+32
LRBCFCCW EQU   LRBCCCH+24
LRBCAIO  EQU   LRBCCCH+8
LRBCJOB  EQU   LRBCCCH
LRBRDEV2 EQU   LRBRDDR+32
LRBRCUA2 EQU   LRBRDDR+29
LRBRPH2  EQU   LRBRDDR+28
LRBRDEV1 EQU   LRBRDDR+24
LRBRCUA1 EQU   LRBRDDR+21
LRBRPH1  EQU   LRBRDDR+20
LRBRVOL2 EQU   LRBRDDR+14
LRBRVOL1 EQU   LRBRDDR+8
LRBRJOB  EQU   LRBRDDR
LRBMCEL  EQU   LRBMMCH+304
@NM00030 EQU   LRBMFLO+20
LRBMFSA  EQU   LRBMFLO+16
@NM00029 EQU   LRBMFLO+8
LRBMCELL EQU   LRBMCIC+6
LRBMVCC  EQU   @NM00027
LRBMVPT  EQU   @NM00027
@NM00028 EQU   @NM00027
@NM00026 EQU   LRBMCIC+4
LRBMVST  EQU   @NM00024
LRBMVLG  EQU   @NM00024
LRBMVCR  EQU   @NM00024
LRBMVGR  EQU   @NM00024
LRBMVFP  EQU   @NM00024
@NM00025 EQU   @NM00024
LRBMVRC  EQU   @NM00024
LRBMVFA  EQU   @NM00024
LRBMVIA  EQU   @NM00022
LRBMVPM  EQU   @NM00022
LRBMVMS  EQU   @NM00022
LRBMVWP  EQU   @NM00022
@NM00023 EQU   @NM00022
LRBMFKE  EQU   @NM00022
LRBMFSC  EQU   @NM00022
LRBMFSE  EQU   @NM00022
LRBMIDY  EQU   @NM00020
LRBMIBU  EQU   @NM00020
@NM00021 EQU   @NM00020
LRBMFWN  EQU   @NM00020
@NM00019 EQU   @NM00018
LRBMFED  EQU   @NM00018
LRBMFCD  EQU   @NM00018
LRBMFTD  EQU   @NM00018
LRBMFSR  EQU   @NM00018
LRBMFPD  EQU   @NM00018
LRBMFSD  EQU   @NM00018
LRBMMOSW EQU   LRBMMCH+16
LRBMPWL  EQU   LRBMMCH+15
LRBMVEQR EQU   LRBMRSR2
LRBMPGFX EQU   LRBMRSR2
LRBMLSQA EQU   LRBMRSR2
LRBMFSQA EQU   LRBMRSR2
LRBMNUCL EQU   LRBMRSR2
LRBMSPER EQU   LRBMRSR2
LRBMINTC EQU   LRBMRSR2
LRBMOFLN EQU   LRBMRSR2
LRBMCHNG EQU   LRBMRSR1
LRBMSER  EQU   LRBMRSR1
@NM00017 EQU   LRBMRSR1
@NM00016 EQU   LRBMPDAR
LRBMRSRF EQU   LRBMPDAR
LRBMRSRC EQU   LRBMPDAR
LRBMINVP EQU   LRBMPDAR
@NM00015 EQU   LRBMPDAR
LRBMSBUF EQU   LRBMSOFT
LRBMSHIR EQU   LRBMSOFT
LRBMSECC EQU   LRBMSOFT
LRBMSEXD EQU   LRBMSOFT
@NM00014 EQU   LRBMSOFT
LRBMSSFT EQU   LRBMSOFT
LRBMIL80 EQU   LRBMINTM
LRBMICTM EQU   LRBMINTM
LRBMICKC EQU   LRBMINTM
LRBMITOD EQU   LRBMINTM
@NM00013 EQU   LRBMINTM
LRBMHIPD EQU   LRBMHARD
LRBMHSPF EQU   LRBMHARD
LRBMHSTO EQU   LRBMHARD
LRBMHINV EQU   LRBMHARD
LRBMHSD  EQU   LRBMHARD
@NM00012 EQU   LRBMHARD
LRBMHHRD EQU   LRBMHARD
LRBMTINV EQU   LRBMTERM
LRBMTDMG EQU   LRBMTERM
LRBMTWRN EQU   LRBMTERM
LRBMTCKS EQU   LRBMTERM
LRBMTSEC EQU   LRBMTERM
@NM00011 EQU   LRBMTERM
LRBMWSC  EQU   LRBMMCH+4
LRBMLNH  EQU   LRBMMCH
@NM00010 EQU   LRBHMSW1
LRBMSYST EQU   LRBHMSW1
@NM00009 EQU   LRBHMSW1
@NM00008 EQU   LRBHCSW1
LRBCERPP EQU   LRBHCSW1
LRBCDATA EQU   LRBHCSW1
LRBCICUA EQU   LRBHCSW1
LRBCNOSP EQU   LRBHCSW1
@NM00007 EQU   LRBHCSW1
LRBCINCO EQU   LRBHCSW1
LRBCMESG EQU   LRBHCSW1
@NM00006 EQU   LRBHRSW1
LRBRSYSI EQU   LRBHRSW1
LRBROPER EQU   LRBHRSW1
LRBRSEC  EQU   LRBHRSW1
LRBRPRIM EQU   LRBHRSW1
@NM00068 EQU   SAVER+12
@NM00067 EQU   SAVER
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00066 EQU   CVTFIX+248
@NM00065 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
PCCAT00P EQU   PCCAVT
@NM00064 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCAR105 EQU   PCCAATTR
PCCAR104 EQU   PCCAATTR
PCCAR103 EQU   PCCAATTR
PCCAR102 EQU   PCCAATTR
PCCAR101 EQU   PCCAATTR
PCCAR100 EQU   PCCAATTR
PCCAIO   EQU   PCCAATTR
PCCACPUM EQU   PCCAATTR
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBV EQU   PCCA+160
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCAPCCA EQU   PCCA
RVTMIH2  EQU   RVT+108
RVTMIH   EQU   RVT+104
RVTCCHCR EQU   RVT+100
RVTCCHDA EQU   RVT+96
RVTMSGLN EQU   RVT+92
RVTMSGPT EQU   RVT+88
RVTLRBPT EQU   RVT+84
RVT01MMM EQU   RVT+76
RVT00MMM EQU   RVT+72
RVTPEXIT EQU   RVT+68
RVTPKREF EQU   RVT+64
RVTPBUCR EQU   RVT+60
RVTPXMFA EQU   RVT+56
RVTPTAIM EQU   RVT+52
RVTPTCON EQU   RVT+48
RVTPTREC EQU   RVT+44
RVTPTSIG EQU   RVT+40
RVTPTERM EQU   RVT+36
RVTPMKTA EQU   RVT+32
RVTPMTHA EQU   RVT+24
RVTPMPFX EQU   RVT+20
RVTPMSCA EQU   RVT+16
RVTPMHCA EQU   RVT+12
RVTPMRTM EQU   RVT+4
RVTPMCIH EQU   RVT
MSGTAB1  EQU   MSG+2
MSGCTL   EQU   MSG
RWACCDF  EQU   RWA+128
RWAPTDF  EQU   RWA+112
RWATCDF  EQU   RWA+96
RWAIVDF  EQU   RWA+80
RWASDDF  EQU   RWA+64
RWAPDDF  EQU   RWA+48
RWAPCCAR EQU   RWA+40
RWATEST  EQU   RWA+32
@NM00039 EQU   RWA+29
@NM00038 EQU   RWAFLAGS
RWAWNGQI EQU   RWAFLAGS
@NM00037 EQU   RWAMSGFL
RWAMSG21 EQU   RWAMSGFL
RWAMSG72 EQU   RWAMSGFL
RWAMSG71 EQU   RWAMSGFL
RWAMSG31 EQU   RWAMSGFL
RWAFLCFL EQU   RWA+26
RWAEMRFL EQU   RWA+25
RWACWRFL EQU   RWA+24
RWADGDF  EQU   RWA+16
RWASRDF  EQU   RWA+8
RWATLRB  EQU   RWATERM+4
RWATWTO  EQU   RWATERM
@NM00036 EQU   THBEXTND+4
THBCNT   EQU   THBBASE+1
@NM00035 EQU   THBMODE
THBRCT   EQU   THBMODE
THBQUI   EQU   THBMODE
PWACCTHB EQU   PWA+992
PWAPTTHB EQU   PWA+976
PWATCTHB EQU   PWA+960
PWAIVTHB EQU   PWA+944
PWASDTHB EQU   PWA+928
PWAPDTHB EQU   PWA+912
PWANRSRB EQU   PWA+868
PWACCSRB EQU   PWA+824
PWAWRK   EQU   PWA+792
PWATEST  EQU   PWA+784
PWACPUAD EQU   PWA+782
@NM00034 EQU   PWA+781
PWACNTR  EQU   PWA+780
PWAEDSRB EQU   PWA+779
@NM00033 EQU   PWAFLAGS
PWANRHED EQU   PWAFLAGS
PWACCHED EQU   PWAFLAGS
PWAREST  EQU   PWAFLAGS
PWAINIT  EQU   PWA+777
PWAMFAFL EQU   PWA+776
PWARPSW  EQU   PWA+768
PWARGPR  EQU   PWA+704
PWACR15  EQU   PWA+700
PWACR14  EQU   PWA+696
PWASFLC  EQU   PWA+464
PWAINTC  EQU   PWA+456
PWASOSW  EQU   PWA+448
PWAFRR00 EQU   PWAFRR+12
PWAFRR15 EQU   PWAFRR+8
PWAFRR13 EQU   PWAFRR+4
PWAFRR12 EQU   PWAFRR
PWAFRRCT EQU   PWA+380
PWAFRRCD EQU   PWA+376
PWADGTHB EQU   PWA+368
PWASRTHB EQU   PWA+360
PWAESA   EQU   PWA+288
PWASA4   EQU   PWA+216
PWASA2   EQU   PWA+72
PWASA1   EQU   PWA
@NM00032 EQU   CSD+160
CSDMASK  EQU   CSD+128
CSDUCNT  EQU   CSD+124
CSDTCNT  EQU   CSD+120
CSDGDTOD EQU   CSD+116
CSDGDINT EQU   CSD+112
CSDGDCC  EQU   CSD+108
CSDDDRCT EQU   CSD+106
CSDRV044 EQU   CSD+104
CSDMAFF  EQU   CSD+24
CSDRV038 EQU   CSDFLAGS
CSDRV037 EQU   CSDFLAGS
CSDRV036 EQU   CSDFLAGS
CSDRV035 EQU   CSDFLAGS
CSDRV034 EQU   CSDFLAGS
CSDRV033 EQU   CSDFLAGS
CSDRV032 EQU   CSDFLAGS
CSDMP    EQU   CSDFLAGS
CSDACR   EQU   CSD+22
CSDMF1CP EQU   CSD+20
CSDRV043 EQU   CSD+16
CSDRV030 EQU   CSDSCFL4
CSDRV029 EQU   CSDSCFL4
CSDRV028 EQU   CSDSCFL4
CSDRV027 EQU   CSDSCFL4
CSDRV026 EQU   CSDSCFL4
CSDRV025 EQU   CSDSCFL4
CSDRV024 EQU   CSDSCFL4
CSDRV023 EQU   CSDSCFL4
CSDRV022 EQU   CSDSCFL3
CSDRV021 EQU   CSDSCFL3
CSDRV020 EQU   CSDSCFL3
CSDRV019 EQU   CSDSCFL3
CSDRV018 EQU   CSDSCFL3
CSDRV017 EQU   CSDSCFL3
CSDRV016 EQU   CSDSCFL3
CSDRV015 EQU   CSDSCFL3
CSDRV014 EQU   CSDSCFL2
CSDRV013 EQU   CSDSCFL2
CSDRV012 EQU   CSDSCFL2
CSDRV011 EQU   CSDSCFL2
CSDRV010 EQU   CSDSCFL2
CSDRV009 EQU   CSDSCFL2
CSDRV008 EQU   CSDSCFL2
CSDRV007 EQU   CSDSCFL2
CSDRV006 EQU   CSDSCFL1
CSDRV005 EQU   CSDSCFL1
CSDRV004 EQU   CSDSCFL1
CSDRV003 EQU   CSDSCFL1
CSDRV002 EQU   CSDSCFL1
CSDRV001 EQU   CSDSCFL1
CSDSYSND EQU   CSDSCFL1
CSDRV042 EQU   CSDSCFL1
CSDCPUOL EQU   CSD+10
CSDSAFF  EQU   CSDCPUAL
CSDCHAD  EQU   CSD+6
CSDCPUJS EQU   CSD+4
CSDCSD   EQU   CSD
LRBCMPCS EQU   LRBCMP+2
LRBCMPPA EQU   LRBCMP
LRBCMPNO EQU   LRBCVAR+6
LRBCMPF2 EQU   LRBCVAR+5
LRBCMPF1 EQU   LRBCVAR+4
LRBCRESD EQU   LRBCVAR+2
LRBCFT   EQU   LRBCVAR
LRBHMCEL EQU   LRBHCPID+6
LRBHMDL  EQU   LRBHCPID+4
LRBHCSER EQU   LRBHCPID+1
@NM00005 EQU   LRBHCPID
LRBHTIME EQU   LRB+12
@NM00004 EQU   LRB+7
LRBHCNT  EQU   LRB+6
LRBMCLB  EQU   LRBHSW3
LRBNDEM  EQU   LRBMACT
LRBNCEM  EQU   LRBMACT
@NM00003 EQU   LRBHSW0
LRBHTMC  EQU   LRBHSW0
@NM00002 EQU   LRBHSW0
LRBHNS   EQU   LRBHSW0
LRBHMORE EQU   LRBHSW0
@NM00001 EQU   LRBHSYS
LRBHSYSB EQU   LRBHSYS
LRBHTYPE EQU   LRB
@NM00063 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00062 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00061 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00060 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00059 EQU   FLCFSA
@NM00058 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00057 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00056 EQU   FLCIOA
@NM00055 EQU   FLCMCLA+15
@NM00054 EQU   FLCMCLA+14
@NM00053 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00052 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00051 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00050 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00049 EQU   FLCPER
@NM00048 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00047 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00046 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00045 EQU   FLCPIILC
@NM00044 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00043 EQU   FLCSVILC
@NM00042 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00041 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00040 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00100 EQU   @RC00098
@RC00105 EQU   @RC00098
@ENDDATA EQU   *
         END   IGFPMTHA,(C'PLS1907',0701,78053)
