         TITLE 'IGFPSAD0/IGFPSAE0'
*****************************************************************
*                                                               *
* MODULE NAME = IGFPSAD0                                        *
*                                                               *
* DESCRIPTIVE NAME = PSA AUTHORIZATION SUPPORT                  *
*                                                               *
* COPYRIGHT = NONE                                              *
*                                                               *
* STATUS = NEW IN VS/2 R3.7 SU51                               @G51GPLK
*                                                               *
* FUNCTION = OBTAINS AND RELEASES PSA UPDATE AUTHORIZATION      *
**                                                             **
* NOTES =                                                       *
*                                                               *
*    DEPENDENCIES = NONE                                        *
*                                                               *
*    RESTRICTIONS = NONE                                        *
*                                                               *
*    REGISTER CONVENTIONS = SEE EQUATES                         *
*                                                               *
*    PATCH LABEL = NONE                                         *
*                                                               *
* MODULE TYPE = CONTROL                                         *
*                                                               *
*    PROCESSOR = ASSEMBLER                                      *
*                                                               *
*    MODULE SIZE =                                              *
*                                                               *
*    ATTRIBUTES = FIXED, DISABLED, KEY 0, SUPERVISOR STATE,     *
*                 REENTRANT                                     *
*                                                               *
* ENTRY POINTS = IGFPSAD0                                       *
*                                                               *
*    PURPOSE = OBTAINS PSA UPDATE AUTHORIZATION                 *
*                                                               *
*    LINKAGE = REGISTER 15 -- ENTRY POINT ADDRESS               *
*              REGISTER 14 -- RETURN ADDRESS                    *
*                                                               *
*    INPUT = DISABLED, KEY 0, SUPERVISOR STATE PSW              *
*                                                               *
* ENTRY POINTS = IGFPSAE0                                       *
*                                                               *
*    PURPOSE = RELEASES PSA UPDATE AUTHORIZATION                *
*                                                               *
*    LINKAGE = REGISTER 15 -- ENTRY POINT ADDRESS               *
*              REGISTER 14 -- RETURN ADDRESS                    *
*                                                               *
*    INPUT = DISABLED, KEY 0, SUPERVISOR STATE PSW              *
*                                                               *
*    OUTPUT = NONE                                              *
*                                                               *
*    EXIT-NORMAL = RETURN TO ADDRESS IN REGISTER 14             *
*                                                               *
*    EXIT-ERROR = RETURN TO ADDRESS IN REGISTER 14              *
*                                                               *
* EXTERNAL REFERENCES = NONE                                    *
*                                                               *
*    ROUTINES = NONE                                            *
*                                                               *
*    DATA SETS = NONE                                           *
*                                                               *
*    DATA AREAS = NONE                                          *
*                                                               *
* TABLES = NONE                                                 *
*                                                               *
* MACROS = NONE                                                 *
*                                                               *
* CHANGE ACTIVITY = NONE                                        *
*****************************************************************
IGFPSAD0 CSECT                     OBTAIN AUTHORIZATION ENTRY
         ENTRY IGFPSAE0            RELEASE AUTHORIZATION ENTRY
         SPACE 2
RET      EQU   14                  RETURN ADDRESS
ENTRY    EQU   15                  ENTRY POINT ADDRESS
         SPACE 2
IGFPSAE0 EQU   *
         BR    RET                 RETURN
         END
