         TITLE 'IGFTMCHK- MVS MISSING INTERRUPT HANDLER                *
                        '
IGFTMCHK CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IGFTMCHK  77.313'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @08,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@08                                         0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @09,@01                                             0001
         USING @DATD,@09                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @00,@01,20(@13)                                     0001
         ST    @09,8(,@13)                                         0001
         LR    @13,@09                                             0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0198
*/********************************************************************/
*/*                                                                  */
*/*  INITIALIZATION: IGFTMCHK INITIALIZATION ROUTINE                 */
*/*                                                                  */
*/*  INPUT: NONE                                                     */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*           1.OBTAIN SQA FOR BUILDING TQE,DDRCOM,ECB AND SRB       */
*/*             FOR SCHEDULE IGFTMC01                                */
*/*           2.ISSUE ESTAE FOR ABNORMAL TERMINATION                 */
*/*           3.INITIALIZE DDRCOM                                    */
*/*           4.WRITE IPL RECORD TO SYS1.LOGREC                      */
*/*                                                                  */
*/*  OUTPUT: WORK AREA FOR TQE, DDRCOM,ECB AND SRB ARE OBTAINED      */
*/*          IPL RECORD ARE WRITTEN TO SYS1.LOGREC                   */
*/*          ESTABLISH ESTAE EXIT ROUTINE TO HANDLE ABNORMAL         */
*/*          TERMINATION                                             */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0198
*   TQELEN=(LENGTH(TQE)+SEVEN)/EIGHT*EIGHT;/* ROUND TQE TO DOUBLE  0198
*                                      WORD                          */
         LA    TQELEN,128                                          0198
*   DDRCMLEN=(LENGTH(DDRCOMWK)+SEVEN)/EIGHT*EIGHT;/* SETUP TOTAL   0199
*                                      DDRCOM AND MIH LOCAL WORK AREA*/
         LA    @12,224                                             0199
         ST    @12,DDRCMLEN                                        0199
*   SRBLEN=(LENGTH(SRB)+SEVEN)/EIGHT*EIGHT;/* ROUND SRB TO DOUBLE  0200
*                                      WORD                          */
         LA    SRBLEN,48                                           0200
*   SQASIZE=TQELEN+SRBLEN+DDRCMLEN+LENGTH(ECB)+LENGTH(PARMLIST);/* 0201
*                                      SET UP FOR GETMAIN            */
         LR    @03,TQELEN                                          0201
         ALR   @03,SRBLEN                                          0201
         ALR   @03,@12                                             0201
         AL    @03,@CF00790                                        0201
         ST    @03,SQASIZE                                         0201
*   RFY                                                            0202
*     RTNCODE RSTD;                 /* RESTRICT REG 15               */
*   DO;                             /* GETMAIN (RC) LV(SQASIZE)    0203
*                                      SP(245)                       */
*     RESPECIFY                                                    0204
*      (GPR01F,                                                    0204
*       GPR15F,                                                    0204
*       GPR00F) RESTRICTED;                                        0204
*     GPR01F=0;                     /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0205
*     GPR15F=0;                     /* RC-TYPE GETMAIN               */
         SLR   GPR15F,GPR15F                                       0206
*     GPR00F=SQASIZE;               /* LENGTH REQUESTED              */
         LR    GPR00F,@03                                          0207
*     GPR15F=GPR15F|((245)*256);    /* SP IN BYTE 2                  */
         O     GPR15F,@CF02958                                     0208
*     SVC(120);                     /* RC/RU-FORM OF GETMAIN         */
         SVC   120                                                 0209
*     RESPECIFY                                                    0210
*      (GPR01F,                                                    0210
*       GPR15F,                                                    0210
*       GPR00F) UNRESTRICTED;                                      0210
*   END;                            /* GETMAIN (RC) LV(SQASIZE)    0211
*                                      SP(245)                       */
*   RFY                                                            0212
*    (R0,                                                          0212
*     R1) RSTD;                     /* RESTRICT REG 0,1              */
*   IF RTNCODE^=ZERO THEN           /* GETMAIN SUCCESSFUL?           */
         LTR   RTNCODE,RTNCODE                                     0213
         BNZ   @RT00213                                            0213
*     GOTO MIHEXIT;                 /* TERMINATE MIH FOR GETMAIN   0214
*                                      FAILS                         */
*   TQEPTR=R1;                      /* GET PTR FOR TQE               */
         ST    R1,TQEPTR                                           0215
*   SRBPTR=TQEPTR+TQELEN;           /* GET PTR FOR SRB               */
         L     @14,TQEPTR                                          0216
         ALR   @14,TQELEN                                          0216
         LR    SRBPTR,@14                                          0216
*   DDRPTR=SRBPTR+SRBLEN;           /* SET UP PTR FOR DDRCOM         */
         LR    DDRPTR,SRBPTR                                       0217
         ALR   DDRPTR,SRBLEN                                       0217
*   ECBPTR=DDRPTR+DDRCMLEN;         /* GET PTR FOR ECB               */
         LR    @14,DDRPTR                                          0218
         AL    @14,DDRCMLEN                                        0218
         ST    @14,ECBPTR                                          0218
*   PARMPTR=ECBPTR+LENGTH(ECB);     /* GET PTR TO PARM LIST          */
         AL    @14,@CF00041                                        0219
         ST    @14,PARMPTR                                         0219
*   R0=R1;                          /* GET GETMAIN ADDRESS           */
         LR    R0,R1                                               0220
*   RFY                                                            0221
*     R14 RSTD;                     /* RESTRICT REG 14               */
*   R1=SQASIZE;                     /* GET GETMAIN LENGTH            */
         L     R1,SQASIZE                                          0222
*   MVCL(R0,R14);                   /* CLEAR GETMAIN AREA ZERO MVCL
*                                      BASED ON REG 15 ZERO          */
         MVCL  R0,R14                                              0223
*   RFY                                                            0224
*    (R0,                                                          0224
*     R1,                                                          0224
*     R14,                                                         0224
*     RTNCODE) UNRSTD;              /* RELEASE REG 0,1,14,15         */
*   DO;                             /* ?IGFDERR INIT                 */
*                                                                  0225
*     /***************************************************************/
*     /*                                                             */
*     /* IGFDERR - INITIALIZE RECOVERY ENVIRONMENT                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0226
*     DERPLIST=DERPLIST&&DERPLIST;  /* CLEAR PARAMETER LIST          */
         XC    DERPLIST(48),DERPLIST                               0226
*     DERFUNK=DERINIT;              /* INDICATE INIT FUNCTION        */
         MVI   DERFUNK,X'01'                                       0227
*     DERREC=ADDR(DERRECPM);        /* POINT TO REC PARMS            */
         LA    @12,DERRECPM                                        0228
         ST    @12,DERREC                                          0228
*     DERSPEC=ADDR(IGFTMCHS);       /* POINT TO SPECIAL EXIT         */
         LA    @12,IGFTMCHS                                        0229
         ST    @12,DERSPEC                                         0229
*     DERRETRY=ADDR(IGFTMCHR);      /* POINT TO RETRY ROUTINE        */
         LA    @12,IGFTMCHR                                        0230
         ST    @12,DERRETRY                                        0230
*     GEN SETS(DERDATD)(MVC DERDATD,@SIZDATD);/* SET UP SPN, SIZE    */
         MVC DERDATD,@SIZDATD
*     DERPFX=DERRMASK;              /* SET UP RUB MASK               */
         MVC   DERPFX(2),@CB02791                                  0232
*     DERRCODE=CODEBASE;            /* SAVE CODEREG                  */
         ST    CODEBASE,DERRCODE                                   0233
*     DERRDATA=DATABASE;            /* SAVE DATAREG                  */
         ST    DATABASE,DERRDATA                                   0234
*     DERRDDR=DDRPTR;               /* SAVE DDRCOM POINTER           */
         ST    DDRPTR,DERRDDR                                      0235
*     DERRSAVE=SAVEPTR;             /* SAVE REGISTER 13              */
         ST    SAVEPTR,DERRSAVE                                    0236
*     CALL IGFDE0(DERPLIST);        /* ISSUE ESTAE                   */
         LA    @12,DERPLIST                                        0237
         ST    @12,@AL00001                                        0237
         L     @15,@CV02814                                        0237
         LA    @01,@AL00001                                        0237
         BALR  @14,@15                                             0237
*   END;                            /* ?IGFDERR INIT ESTABLISH ESTAE */
*   DDRUTCB=TMCTCBP;                /* GET PTR TO MIH TCB            */
         L     @12,CVTPTR                                          0239
         L     @12,CVTTCBP(,@12)                                   0239
         L     @12,TMCTCBP+4(,@12)                                 0239
         ST    @12,DDRUTCB(,DDRPTR)                                0239
*   DERPTR=ADDR(DERPLIST);          /* GET ADDR OF DERPLIST          */
         LA    DERPTR,DERPLIST                                     0240
*   DDRREC1=DDRRIPL;                /* INDICATE TO WRITE IPL REC     */
         MVI   DDRREC1(DDRPTR),X'04'                               0241
*   CALL IGFDR0;                    /* CALL DDR RECORDER             */
         L     @15,@CV02812                                        0242
         BALR  @14,@15                                             0242
*   DDRPTR=DERRDDR;                 /* RESET DDRCOM PTR              */
         L     DDRPTR,DERRDDR                                      0243
*                                                                  0244
*/********************************************************************/
*/*                                                                  */
*/*  SET MIH TIME INTERVAL: SET USER PROVIDED TIME INTERVAL          */
*/*                                                                  */
*/*  INPUT: DDRPTR- PTR TO DDRCOM                                    */
*/*                                                                  */
*/*  FUNCTION: CHECK TO SEE IF THE USER PROVIDED TIME IS A VALID     */
*/*            ONE. IF SO, MOVE IT INTO THE DDRCOM TO BE USED        */
*/*            BY SETDIE. IF INVALID,SET TIME INTERVAL AS 3 MINUTES  */
*/*            FOR DEVICES OTHER THAN MSS.THE TIME INTERVAL FOR MSS  */
*/*            WILL BE 4 TIMES(USER MAY ALSO DEFINE) OVER THE REGULAR*/
*/*            TIME INTERVAL. IN THIS CASE IT WILL BE 12 MINUTES     */
*/*                                                                  */
*/*                                                                  */
*/*  OUTPUT:   DDRMIHTD- MIH TIME INTERVAL IN HHMMSSTH               */
*/*            MIHSECND- MIH TIME INTERVAL IN SECONDS                */
*/*                      THE HUNDREDTH OF SECONDS ARE IGNORED        */
*/*            MSSCOUNT- 3330V MSS TIME LIMIT COUNTER                */
*/*            MIHINTVL- COPY OF IGFINTVL FOR EXIT ROUTINES  @G24LNLC*/
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0244
*   DO I=ONE TO LENGTH(INTVL) WHILE(TIMERR=OFF);/* CHECK USER TIME   */
         LA    I,1                                                 0244
@DL00244 TM    TIMERR(DDRPTR),B'10000000'                          0244
         BNZ   @DC00244                                            0244
*     IF INTVL(I)<ZERODIG|INTVL(I)>NINE THEN/* VALUE IS 0-9 ?        */
         L     @12,@CV02815                                        0245
         ALR   @12,I                                               0245
         BCTR  @12,0                                               0245
         CLI   INTVL(@12),C'0'                                     0245
         BL    @RT00245                                            0245
         L     @12,@CV02815                                        0245
         ALR   @12,I                                               0245
         BCTR  @12,0                                               0245
         CLI   INTVL(@12),C'9'                                     0245
         BNH   @RF00245                                            0245
@RT00245 DS    0H                                                  0246
*       TIMERR=ON;                  /* NO-SET TIME ERROR             */
         OI    TIMERR(DDRPTR),B'10000000'                          0246
*   END;                            /* END OF SCAN SPECIFIED USER  0247
*                                      TIME INTERVAL                 */
@RF00245 AL    I,@CF00047                                          0247
         C     I,@CF00074                                          0247
         BNH   @DL00244                                            0247
@DC00244 DS    0H                                                  0248
*   IF TIMERR=OFF&INTVL^=DZERO THEN /* ALL CHARACTERS VALID?         */
         TM    TIMERR(DDRPTR),B'10000000'                          0248
         BNZ   @RF00248                                            0248
         L     @12,@CV02815                                        0248
         CLC   INTVL(8,@12),@CC02842                               0248
         BE    @RF00248                                            0248
*     DDRMIHT=INTVL;                /* YES-SET USER SPECIFIED TIME   */
         L     @12,@CV02815                                        0249
         MVC   DDRMIHT(8,DDRPTR),INTVL(@12)                        0249
*   ELSE                            /* NO                            */
*     DDRMIHT=TMCTIME;              /* SET DEFAULT TIME-3 MINUTES    */
         B     @RC00248                                            0250
@RF00248 MVC   DDRMIHT(8,DDRPTR),@CC02828                          0250
*   PACK(MIHOUR,TMCHR);             /* PACK HOUR TO DECIMAL          */
@RC00248 PACK  MIHOUR(2),TMCHR(2,DDRPTR)                           0251
*   CVB(HR,MIHOUR);                 /* CONVERT HOUR TO BINARY        */
         XC    @TS00001(8),@TS00001                                0252
         MVC   @TS00001+6(2),MIHOUR                                0252
         CVB   @12,@TS00001                                        0252
         ST    @12,HR                                              0252
*   PACK(MIHMIM,TMCMM);             /* PACK MINUTES TO DECIMAL       */
         PACK  MIHMIM(2),TMCMM(2,DDRPTR)                           0253
*   CVB(MM,MIHMIM);                 /* CONVERT MINUTES TO BINARY     */
         XC    @TS00001(8),@TS00001                                0254
         MVC   @TS00001+6(2),MIHMIM                                0254
         CVB   @11,@TS00001                                        0254
         ST    @11,MM                                              0254
*   PACK(MIHSEC,TMCSS);             /* PACK SECONDES TO DECIMAL      */
         PACK  MIHSEC(2),TMCSS(2,DDRPTR)                           0255
*   CVB(SS,MIHSEC);                 /* CONVERT SECONDS TO BINARY     */
         XC    @TS00001(8),@TS00001                                0256
         MVC   @TS00001+6(2),MIHSEC                                0256
         CVB   @06,@TS00001                                        0256
         ST    @06,SS                                              0256
*   MIHSECND=(HR*SIXTY+MM)*SIXTY+SS;/* STORE TIME INTERVAL IN SECONDS*/
         LA    @05,60                                              0257
         LR    @01,@12                                             0257
         MR    @00,@05                                             0257
         ALR   @01,@11                                             0257
         MR    @00,@05                                             0257
         ALR   @01,@06                                             0257
         ST    @01,MIHSECND(,DDRPTR)                               0257
*   MIHINTVL=INDATA;                /* COPY INTVL INTO WORKAREA FOR
*                                      USE BY EXITS          @G24LNLC*/
         L     @12,@CV02815                                        0258
         MVC   MIHINTVL(12,DDRPTR),INDATA(@12)                     0258
*   MIHINTVL(1:8)=DDRMIHT;          /* PUT IN CORRECTED TIME INTERVAL
*                                      IN CASE OF INPUT ERROR      0259
*                                                            @G24LNLC*/
         MVC   MIHINTVL(8,DDRPTR),DDRMIHT(DDRPTR)                  0259
*   MIHINTVA=ADDR(MIHINTVL);        /* SET UP FOR EXITS      @G24LNLC*/
         LA    @12,MIHINTVL(,DDRPTR)                               0260
         ST    @12,MIHINTVA(,DDRPTR)                               0260
*                                                                  0261
*/********************************************************************/
*/*                                                                  */
*/*  INIT CONTROL BLOCKS: TQE AND SRB WILL BE INTILIZED              */
*/*                                                                  */
*/*  INPUT: TQEPTR WILL POINT TO TQE                                 */
*/*         SRBPTR WILL POINT TO SRB                                 */
*/*                                                                  */
*/*  FUNCTION:TQE AND SRB WILL BE INITIALIZED TO CALL SETDIE         */
*/*           TO  SCHEDULE A SRB FOR CHECKING UCBS(IGFTMC01)         */
*/*           MIH WILL BE TERMINATED IF SETDIE FAILS                 */
*/*                                                                  */
*/*  OUTPUT: TQE AND SRB ARE INITIALIZED                             */
*/*                                                                  */
*/********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*  INITIALIZE SRB FOR CHECK UCB LIST IN THE SYSTEM                 */
*/*  THE SRB HAS NO RELATIONSHIP WITH THE TCB                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0261
*   SRBID=CSRBID;                   /* SET SRB ID                    */
         MVC   SRBID(4,SRBPTR),@CC02846                            0261
*   SRBASCB=ASVTENTY(ONE);          /* SET SRB ADDRESS SPACE         */
         L     @12,CVTPTR                                          0262
         L     @11,ASVTPTR(,@12)                                   0262
         L     @11,ASVTENTY(,@11)                                  0262
         ST    @11,SRBASCB(,SRBPTR)                                0262
*   PARMTQE=0;                      /* STORE TQE PTR TO ZERO TO    0263
*                                      INDICATE INITIALIZATION     0263
*                                                            @G24LNLC*/
         L     @11,PARMPTR                                         0263
         SLR   @06,@06                                             0263
         ST    @06,PARMTQE(,@11)                                   0263
*   PARMDCM=DDRPTR;                 /* STORE DDRCOM PTR AS PARAM     */
         ST    DDRPTR,PARMDCM(,@11)                                0264
*   PARMECB=ECBPTR;                 /* STORE ECB PTR AS PARAM        */
         L     @06,ECBPTR                                          0265
         ST    @06,PARMECB(,@11)                                   0265
*   SRBPARM=ADDR(PARMLIST);         /* SET PARM LIST ADDR            */
         ST    @11,SRBPARM(,SRBPTR)                                0266
*   SRBEP=RVTMIH2;                  /* SET IGFTMC01 ENTRY POINT      */
         L     @12,RVTPTR(,@12)                                    0267
         L     @12,RVTMIH2(,@12)                                   0267
         ST    @12,SRBEP(,SRBPTR)                                  0267
*/********************************************************************/
*/*                                                                  */
*/*  IGFTMC01 (IN MODULE IGFTMC00) IS SCHEDULED AS AN SRB TO PERFORM */
*/*  INITIALIZATION OF EXIT ROUTINE TABLES.  SUSPEND AND CALLDISP    */
*/*  ARE USED TO CAUSE SERIALIZATION OF THE SRB.  IT WILL ISSUE      */
*/*  RESUME TO CAUSE THIS CODE TO REGAIN CONTROL AFTER THE TABLE     */
*/*  INITIALIZATION IS COMPLETE.  THE LOCAL LOCK IS OBTAINED PRIOR   */
*/*  TO THE SCHEDULE TO ENSURE THAT IT IS COMPLETED PRIOR TO EXITING */
*/*  TO THE DISPATCHER.                                              */
*/*                                                          @G24LNLC*/
*/********************************************************************/
*                                                                  0268
*   SRBPTCB=PSATOLD;                /* ASSOCIATE SRB WITH TCB      0268
*                                                            @G24LNLC*/
         L     @12,PSATOLD                                         0268
         ST    @12,SRBPTCB(,SRBPTR)                                0268
*   RFY                                                            0269
*    (R0,                                                          0269
*     R1,                                                          0269
*     R11,                                                         0269
*     R12,                                                         0269
*     R14,                                                         0269
*     R15) RSTD;                    /*                       @ZA26986*/
*/* GET THE LOCAL LOCK IN ORDER TO USE SUSPEND               @G24LNLC*/
*                                                                  0270
*   GEN;                                                           0270
*                                                        /* @G24LNLC*/
        SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,REGS=USE,       @G24LNLC**
               RELATED=('FREED AFTER SCHEDULE OR IN ESTAE')   @G24LNLC
*   LCLLOCK=ON;                     /* INDICATE FOR ESTAE THAT LOCAL
*                                      LOCK IS HELD          @G24LNLC*/
         OI    LCLLOCK(DDRPTR),B'00010000'                         0271
*   R13SAVE=SAVEPTR;                /* SAVE R13 ACROSS SUSPEND     0272
*                                                            @G24LNLC*/
         ST    SAVEPTR,R13SAVE                                     0272
*   GEN REFS(CVTSUSP,CVT)(SUSPEND RB=CURRENT);/*             @G24LNLC*/
         SUSPEND RB=CURRENT
*   SAVEPTR=R13SAVE;                /* RESTORE R13           @G24LNLC*/
         L     SAVEPTR,R13SAVE                                     0274
*   R1=ADDR(SRB);                   /* SET UP SRB ADDR       @G24LNLC*/
         LR    R1,SRBPTR                                           0275
*   GEN REFS(CVTLSMQ,SRBFLNK)(SCHEDULE SRB=(1),SCOPE=LOCAL);/*     0276
*                                                            @G24LNLC*/
         SCHEDULE SRB=(1),SCOPE=LOCAL
*   GEN REFS(PSALITA);                                             0277
*                                                        /* @G24LNLC*/
        SETLOCK RELEASE,TYPE=LOCAL,REGS=USE,RELATED=('GOTTEN BEFORE SU**
               SPEND')                                   /* @G24LNLC*/
*   RFY                                                            0278
*    (R0,                                                          0278
*     R1,                                                          0278
*     R11,                                                         0278
*     R12,                                                         0278
*     R14,                                                         0278
*     R15) UNRSTD;                  /*                       @ZA26986*/
*   LCLLOCK=OFF;                    /* TURN OFF LOCAL LOCK HELD    0279
*                                      INDICATOR             @G24LNLC*/
         NI    LCLLOCK(DDRPTR),B'11101111'                         0279
*   GEN(CALLDISP);                  /*                       @G24LNLC*/
         CALLDISP
*   SRBPTCB=0;                      /* INDICATE SRB NOT RELATED TO 0281
*                                      TCB                   @G24LNLC*/
         SLR   @12,@12                                             0281
         ST    @12,SRBPTCB(,SRBPTR)                                0281
*   PARMTQE=TQEPTR;                 /* PASS PTR TO TQE TO SRB AS PARM
*                                                            @G24LNLC*/
         L     @12,TQEPTR                                          0282
         L     @11,PARMPTR                                         0282
         ST    @12,PARMTQE(,@11)                                   0282
*/********************************************************************/
*/*                                                                  */
*/*  INITIALIZE TQE FOR SETDIE AND TQE ENQUEUE                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0283
*   TQEAID=ONE;                     /* SET ASID AS MASTER SCHEDULE   */
         MVC   TQEAID(2,@12),@CH00047                              0283
*   TQEEXIT=RVTMIH;                 /* ENTRY POINT OF IGFTMC00       */
         L     @11,CVTPTR                                          0284
         L     @05,RVTPTR(,@11)                                    0284
         L     @05,RVTMIH(,@05)                                    0284
         ST    @05,TQEEXIT(,@12)                                   0284
*   TQEVAL=MIHTIMSD;                /* SET TIME INTERVAL FOR   SETDIE*/
         MVC   TQEVAL(8,@12),MIHTIMSD(DDRPTR)                      0285
*                                                                  0286
*/********************************************************************/
*/*                                                                  */
*/* SETDIE: CALL SETDIE AND WAIT                                     */
*/*                                                                  */
*/* INPUT: TQE CONTAINS REAL TIME INTERVAL AND DIE ADDRESS           */
*/*                                                                  */
*/* FUNCTION: CALL SETDIE TO INVOKE DIE ROUTINE TO CHECK             */
*/*           ALL UCBS FOR ACTIVE I/O INCLUDING A PENDING            */
*/*           MOUNT AND DDR SWAP. AFTER CALL DIE,PUT TASK IN WAIT    */
*/*           IT WILL BE WAKED UP BY IGFTMC01. AN OUTAGE RECORD IS   */
*/*           WRITTEN TO SYS1.LOGREC                                 */
*/*                                                                  */
*/* OUTPUT: R15=0 SUCCESSFUL                                         */
*/*         OUTAGE RECORD WILL BE WRITTEN TO STS1.LOGREC             */
*/********************************************************************/
*                                                                  0286
*   R13SAVE=SAVEPTR;                /* SAVE SAVEAREA ADDR            */
         ST    SAVEPTR,R13SAVE                                     0286
*   RFY                                                            0287
*    (R11,                                                         0287
*     R12,                                                         0287
*     R0,                                                          0287
*     R1,                                                          0287
*     R15) RSTD;                    /* RESTRICT REG0,1,11,12 AND 15  */
*   R1=TQEPTR;                      /* SET PARM REG                  */
         L     @14,TQEPTR                                          0288
         LR    R1,@14                                              0288
*   CALL SETDIE;                    /* ENQ TQE                       */
         L     @05,CVTPTR                                          0289
         L     @05,TPCPTR(,@05)                                    0289
         L     @15,TPCSDIE(,@05)                                   0289
         BALR  @14,@15                                             0289
*   RFY                                                            0290
*    (R11,                                                         0290
*     R12,                                                         0290
*     R0,                                                          0290
*     R1) UNRSTD;                   /* RELEASE REG11,12,0 AND 1      */
*   SAVEPTR=R13SAVE;                /* RESTORE REG 13                */
         L     SAVEPTR,R13SAVE                                     0291
*   IF RTNCODE^=ZERO THEN           /* SET DIE SUCCESS?              */
         LTR   RTNCODE,RTNCODE                                     0292
         BZ    @RF00292                                            0292
*     DO;                           /* NO                            */
*       DO;                         /* FREEMAIN(RC) LV(SQASIZE)A(TQE)
*                                      SP(245)                       */
*         RESPECIFY                                                0295
*          (GPR01F,                                                0295
*           GPR15F,                                                0295
*           GPR00F) RESTRICTED;                                    0295
*         GPR01F=0;                 /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0296
*         GPR15F=1;                 /* SET TYPE                      */
         LA    GPR15F,1                                            0297
*         GPR00F=SQASIZE;           /* LENGTH REQUESTED              */
         L     GPR00F,SQASIZE                                      0298
*         GPR01F=ADDR(TQE);         /* SET REGISTER ONE              */
         L     GPR01F,TQEPTR                                       0299
*         GPR15F=GPR15F+((245)*256);/* SUBPOOL VALUE                 */
         AL    GPR15F,@CF02958                                     0300
*         SVC(120);                 /* RC/RU-FORM OF GETMAIN         */
         SVC   120                                                 0301
*         RESPECIFY                                                0302
*          (GPR01F,                                                0302
*           GPR15F,                                                0302
*           GPR00F) UNRESTRICTED;                                  0302
*       END;                        /* FREEMAIN(RC) LV(SQASIZE)A(TQE)
*                                      SP(245)                       */
*       GOTO IGFTMCHR;              /* TERMINATE MIH                 */
         B     IGFTMCHR                                            0304
*     END;                                                         0305
*   RFY                                                            0306
*     RTNCODE UNRSTD;               /* RELEASE REG 15                */
@RF00292 DS    0H                                                  0307
*   SETDIEOK=ON;                    /* SETDIE SUCCESSFUL             */
         OI    SETDIEOK(DDRPTR),B'01000000'                        0307
*   DERLRC=ZERO;                    /* INIT LOCAL MSG AND ESTAE    0308
*                                      RETURN CODE                   */
         MVI   DERLRC,X'00'                                        0308
*MSGWAIT:                           /* MSG WAIT ENTRY                */
*   RFY                                                            0309
*     R1 RSTD;                      /* RESTRICT REG 1                */
MSGWAIT  DS    0H                                                  0310
*   R1=DDRPTR+DDRCMLEN;             /* SET PARM TO ECB               */
         LR    R1,DDRPTR                                           0310
         AL    R1,DDRCMLEN                                         0310
*   GEN;                                                           0311
*        /*
    WAIT  ECB=(1),RELATED=('ECB IS POSTED IN IGFTMC00 ENTRY IGFTMC01')
*   RFY                                                            0312
*     R1 UNRSTD;                    /* RELEASE REG 1                 */
*   IF COMPCODE^=ZERO               /* MSG ECB COMPLETED NOT       0313
*                                      SUCCESSFUL                    */
*       |DERLRC^=ZERO THEN          /* PREVIOUS MSGS FAILED          */
         L     @14,ECBPTR                                          0313
         L     @12,COMPCODE-1(,@14)                                0313
         LA    @12,0(,@12)                                         0313
         LTR   @12,@12                                             0313
         BNZ   @RT00313                                            0313
         CLI   DERLRC,0                                            0313
         BNE   @RT00313                                            0313
*     GOTO IGFTMCHR;                /* TERMINATE MIH WITHOUT FREEMAIN*/
*   ECB=ZERO;                       /* RESET ECB TO ZERO FOR POST    */
         SLR   @12,@12                                             0315
         ST    @12,ECB(,@14)                                       0315
*IGFTMCHW:                          /* IGFTMCHK RETRY ENTRY          */
*   DDRREC1=DDRRRDE;                /* OUTAGE RECORDING              */
IGFTMCHW MVI   DDRREC1(DDRPTR),X'06'                               0316
*   CALL IGFDR0;                    /* WRITE OUTAGE RECORD           */
         L     @15,@CV02812                                        0317
         BALR  @14,@15                                             0317
*   DDRPTR=DERRDDR;                 /* RESET PTR TO DDRCOM           */
         L     DDRPTR,DERRDDR                                      0318
*                                                                  0319
*/********************************************************************/
*/*                                                                  */
*/*  ISSUE MSG: ISSUE MIH MESSAGES                                   */
*/*                                                                  */
*/*  INPUT: DDRPTR   - PTR TO DDRCOM                                 */
*/*         MIHMSGPR - PTR TO MSG QUEUE                              */
*/*         MSGBLK   - PTR TO NEXT MSG                               */
*/*                  - MIH PENDING INFO                              */
*/*                  - USER ASID                                     */
*/*                  - PTR TO UCB                                    */
*/*                                                                  */
*/*  FUNCTION: MIH MESSAGE BLOCKS WILL BE DEQUEUED FROM DDRCOM.      */
*/*            DDRCOM WILL BE UPDATED WITH THE PENDING INFORMATION   */
*/*            CONTAINED IN THE MESSAGE BLOCK                        */
*/*            IF THE PENDING CONDITION IS RECORDABLE(CE,DE,CE AND   */
*/*            DE),THEN THE MIH RECORD IS WRITTEN TO SYS1.LOGREC     */
*/*            MESSAGE IGF991E ALWAYS BE ISSUED TO THE OPERATOR.     */
*/*                                                                  */
*/*  OUTPUT:   MIH RECORDS ARE WRITTENED ON SYS1.LOGREC              */
*/*            IGF991E IS ISSUED TO OPERATOR                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0319
*MSGDEQ:                                                           0319
*   RFY                                                            0319
*     R5 RSTD;                      /* RESTRICT REG 5                */
MSGDEQ   DS    0H                                                  0320
*   MSGPTR=MIHMSGPR;                /* GET CURRENT MSG PTR           */
         L     MSGPTR,MIHMSGPR(,DDRPTR)                            0320
*TRYAGN:                                                           0321
*   IF MSGPTR^=ZERO THEN            /* CURRENT MSG PTR ZERO?         */
TRYAGN   LTR   MSGPTR,MSGPTR                                       0321
         BZ    @RF00321                                            0321
*     DO;                           /* NO                            */
*       R5=NEXTMSG;                 /* GET NEXT MSG ON THE QUEUE     */
         L     R5,NEXTMSG(,MSGPTR)                                 0323
*       CS(MSGPTR,R5,MIHMSGPR);     /* DEQUE CURRENT MSG PTR         */
         CS    MSGPTR,@05,MIHMSGPR(DDRPTR)                         0324
*       BC(NE,TRYAGN);              /* CS FAILS TRY AGAIN            */
         BC    7,TRYAGN                                            0325
*     END;                          /* END OF DEQUEUE                */
*   ELSE                                                           0327
*     GOTO MSGWAIT;                 /* NO MSG-WAIT FOR NEXT MSG POST */
*   RFY                                                            0328
*     R5 UNRSTD;                    /* RELEASE R5                    */
*   UCBPTR=MIHUCB;                  /* SET UCB ADDRESSABILITY        */
         L     UCBPTR,MIHUCB(,MSGPTR)                              0329
*   DDRDSTAT=''B;                   /* RESET STATUS TO ZERO          */
         MVI   DDRDSTAT(DDRPTR),X'00'                              0330
*   IF UCB3DACC=ON THEN             /* DIRECT DEVICE                 */
         TM    UCB3DACC(UCBPTR),B'00100000'                        0331
         BNO   @RF00331                                            0331
*     DDRDA=ON;                     /* YES-PROCESSING DIRECT DEVICE  */
         OI    DDRDA(DDRPTR),B'01000000'                           0332
*   IF UCB3TAPE=ON THEN             /* TAPE?                         */
@RF00331 TM    UCB3TAPE(UCBPTR),B'10000000'                        0333
         BNO   @RF00333                                            0333
*     DDRMT=ON;                     /* YES-PROCESSING TAPE           */
         OI    DDRMT(DDRPTR),B'00100000'                           0334
*   IF UCB3UREC=ON THEN             /* UNIT RECORD?                  */
@RF00333 TM    UCB3UREC(UCBPTR),B'00001000'                        0335
         BNO   @RF00335                                            0335
*     DDRUR=ON;                     /* YES-PROCESSING UNIT RECORD    */
         OI    DDRUR(DDRPTR),B'00010000'                           0336
*   DDRFMCUA=UCBNAME;               /* SET UCB NAME IN DDRCOM        */
@RF00335 MVC   DDRFMCUA(3,DDRPTR),UCBNAME(UCBPTR)                  0337
*   DDRFMUCB=UCBPTR;                /* SET UCB ADDR IN DDRCOM        */
         ST    UCBPTR,DDRFMUCB(,DDRPTR)                            0338
*   DDRMIH=ERRCODE;                 /* SET MIH CODE                  */
         MVC   DDRMIH(1,DDRPTR),ERRCODE(MSGPTR)                    0339
*   DDRUASID=MIHASID;               /* SET USER ADDRESS SPACE        */
         LH    @14,MIHASID(,MSGPTR)                                0340
         STH   @14,DDRUASID(,DDRPTR)                               0340
*   IF DDRMIH=DDRMIHC|DDRMIH=DDRMIHD|DDRMIH=DDRMIHCD THEN/* CE,DE OR
*                                      CE DE ?                       */
         CLI   DDRMIH(DDRPTR),X'03'                                0341
         BE    @RT00341                                            0341
         CLI   DDRMIH(DDRPTR),X'02'                                0341
         BE    @RT00341                                            0341
         CLI   DDRMIH(DDRPTR),X'04'                                0341
         BNE   @RF00341                                            0341
@RT00341 DS    0H                                                  0342
*     DO;                           /* YES-RECORDABLE CONDITIONS     */
*       DDRREC1=DDRRMIH;            /* WRITE MIH RECORD              */
         MVI   DDRREC1(DDRPTR),X'05'                               0343
*       IF DDRUASID^=ZERO THEN      /* USER ADDRESS SPACE ?          */
         LH    @14,DDRUASID(,DDRPTR)                               0344
         LTR   @14,@14                                             0344
         BZ    @RF00344                                            0344
*         DDRUASCB=ASVTENTY(DDRUASID);/* YES-SET USER ADDR SPACE     */
         SLA   @14,2                                               0345
         L     @12,CVTPTR                                          0345
         L     @12,ASVTPTR(,@12)                                   0345
         L     @14,ASVTENTY-4(@14,@12)                             0345
         ST    @14,DDRUASCB(,DDRPTR)                               0345
*       ELSE                                                       0346
*         DDRUASCB=ZERO;            /* NO-RESET USER ADDR SPACE      */
         B     @RC00344                                            0346
@RF00344 SLR   @14,@14                                             0346
         ST    @14,DDRUASCB(,DDRPTR)                               0346
*       CALL IGFDR0;                /* RECORD MSG ON STS1.LOGREC     */
@RC00344 L     @15,@CV02812                                        0347
         BALR  @14,@15                                             0347
*       DDRPTR=DERRDDR;             /* RESET DDRCOM PTR              */
         L     DDRPTR,DERRDDR                                      0348
*     END;                          /* END OF WRITTING CE,DE OR CE DE
*                                      RECORD                        */
*   RFY                                                            0350
*     RTNCODE RSTD;                 /* RESTRICT REG15 FOR WTO        */
@RF00341 DS    0H                                                  0351
*   DO;                             /* ?IGFDMSG MSG(IGF991E)RETRY(2)C
*                                      ODE(MIH-CODE,FROM-CUA)        */
*                                                                  0351
*     /***************************************************************/
*     /*                                                             */
*     /* IGFDMSG - INVOKE THE DDR/MIH MESSAGE WRITER                 */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0352
*     DDRMSGCD=DDRM991E;            /* SET UP MSG CODE               */
         MVI   DDRMSGCD(DDRPTR),X'0B'                              0352
*     DDRMSGPN=2;                   /* SET UP NO. OF SUBST. CODES    */
         MVI   DDRMSGPN(DDRPTR),X'02'                              0353
*     DDRMSGPC(1)=DDRPMH;           /* SET SUBSTITUTION CODE 1       */
         MVI   DDRMSGPC(DDRPTR),X'08'                              0354
*     DDRMSGPC(2)=DDRPFM;           /* SET SUBSTITUTION CODE 2       */
         MVI   DDRMSGPC+1(DDRPTR),X'02'                            0355
*     RTNCODE=12;                   /* INDICATE MESSAGE NOT DONE YET */
         LA    RTNCODE,12                                          0356
*     DO DDRRETRY=1 TO 2 WHILE(RTNCODE=12);/* LOOP UNTIL MSG DONE    */
         LA    @14,1                                               0357
         STC   @14,DDRRETRY(,DDRPTR)                               0357
@DL00357 C     RTNCODE,@CF02817                                    0357
         BNE   @DC00357                                            0357
*       CALL IGFDM0;                /* OUTPUT MESSAGE                */
         L     @15,@CV02813                                        0358
         BALR  @14,@15                                             0358
*     END;                          /* END OF RETRY LOOP             */
         LA    @14,1                                               0359
         SLR   @12,@12                                             0359
         IC    @12,DDRRETRY(,DDRPTR)                               0359
         ALR   @14,@12                                             0359
         STC   @14,DDRRETRY(,DDRPTR)                               0359
         C     @14,@CF00087                                        0359
         BNH   @DL00357                                            0359
@DC00357 DS    0H                                                  0360
*   END;                            /* ?IGFDMSG MSG(IGF991E)RETRY(2)C
*                                      ODE(MIH-CODE,FROM-CUA)        */
*   RFY                                                            0361
*     RTNCODE UNRSTD;               /* RELEASE REG15                 */
*   DDRPTR=DERRDDR;                 /* RESET PTR TO DDRCOM           */
         L     DDRPTR,DERRDDR                                      0362
*   DO;                             /* FREEMAIN(RC)                0363
*                                      LV(LENGTH(MSGBLK))A(MSGBLK) 0363
*                                      SP(245)                       */
*     RESPECIFY                                                    0364
*      (GPR01F,                                                    0364
*       GPR15F,                                                    0364
*       GPR00F) RESTRICTED;                                        0364
*     GPR01F=0;                     /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0365
*     GPR15F=1;                     /* SET TYPE                      */
         LA    GPR15F,1                                            0366
*     GPR00F=LENGTH(MSGBLK);        /* LENGTH REQUESTED              */
         LA    GPR00F,16                                           0367
*     GPR01F=ADDR(MSGBLK);          /* SET REGISTER ONE              */
         LR    GPR01F,MSGPTR                                       0368
*     GPR15F=GPR15F+((245)*256);    /* SUBPOOL VALUE                 */
         AL    GPR15F,@CF02958                                     0369
*     SVC(120);                     /* RC/RU-FORM OF GETMAIN         */
         SVC   120                                                 0370
*     RESPECIFY                                                    0371
*      (GPR01F,                                                    0371
*       GPR15F,                                                    0371
*       GPR00F) UNRESTRICTED;                                      0371
*   END;                            /* FREEMAIN(RC)                0372
*                                      LV(LENGTH(MSGBLK))A(MSGBLK) 0372
*                                      SP(245)                       */
*   GOTO MSGDEQ;                                                   0373
         B     MSGDEQ                                              0373
*IGFTMCHR:                                                         0374
*   DO;                             /* ?IGFDERR CANCEL               */
*                                                                  0374
IGFTMCHR DS    0H                                                  0375
*     /***************************************************************/
*     /*                                                             */
*     /* IGFDERR - CANCEL RECOVERY ENVIRONMENT                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0375
*     DERFUNK=DERCANC;              /* INDICATE CANCEL               */
         MVI   DERFUNK,X'02'                                       0375
*     CALL IGFDE0(DERPLIST);        /* CANCEL ESTAE                  */
         LA    @14,DERPLIST                                        0376
         ST    @14,@AL00001                                        0376
         L     @15,@CV02814                                        0376
         LA    @01,@AL00001                                        0376
         BALR  @14,@15                                             0376
*   END;                            /* ?IGFDERR CANCEL CANCEL ESTAE
*                                      FOR IGFTMCHK                  */
*MIHEXIT:                                                          0378
*   RETURN;                         /* RETURN TO DISPATCHER          */
@EL00001 L     @13,4(,@13)                                         0378
@EF00001 L     @00,@SIZDATD                                        0378
         LR    @01,@09                                             0378
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0378
         BR    @14                                                 0378
*                                                                  0379
*/********************************************************************/
*/*                                                                  */
*/*  SOUBROUTINE: IGFTMCHS                                           */
*/*                                                                  */
*/*  DESCRIPTIVE-NAME: IGFTMCK ESTAE EXIT ROUTINE                    */
*/*                                                                  */
*/*  FUNCTION: IGFTMCHS IS ENTERED AS A SUBROUTINE OF IGFDE0.ITS     */
*/*            PURPOSE IS TO DETERMINE WHEN MIH REQUIRES RETRY.      */
*/*            WHEN THE ERROR OCCURRED IN MIH MAINLINE THE MIH       */
*/*            TASK WILL BE TERMINATED. IF THE ERROR OCCURED IN      */
*/*            ISSUING MIH MESSAGES,THEN THE MESSAGE PROCESSING      */
*/*            WILL BE RETRIED THREE TIME BEFORE TERMINATION         */
*/*                                                                  */
*/*  NOTES: NONE                                                     */
*/*                                                                  */
*/*    DEPENDCIES: NONE                                              */
*/*                                                                  */
*/*    REGISTERS-CONVENTIONS: SDWAPTR(REG0)-PTR TO SDWA              */
*/*                           SEE MODLUE SPECIFICATION               */
*/*                                                                  */
*/*  ENTRY-POINT: IGFTMEST                                           */
*/*                                                                  */
*/*    PURPOSE: TO HANDLE IGFTMCHK ABNORMAL TERMINATION              */
*/*                                                                  */
*/*    LINKAGE:CALL                                                  */
*/*                                                                  */
*/*    INPUT: SDWAPTR(REG 0) -PTR TO SDWA OR ZERO                    */
*/*                                                                  */
*/*    OUTPUT: NONE                                                  */
*/*                                                                  */
*/*    EXIT-NORMAL: IGFTMCHW-MIH RETRY ENTRY POINT                   */
*/*                                                                  */
*/*                                                                  */
*/*    EXIT-ERROR:  NONE                                             */
*/*                                                                  */
*/*  EXTERNAL-REFERENCES:                                            */
*/*    DATA-AREA: SDWA                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0379
*IGFTMCHS:                                                         0379
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0379
         B     @EL00001                                            0379
IGFTMCHS DS    0H                                                  0380
*   RFY                                                            0380
*     SDWAREG RSTD;                 /* RESTRICT REG 0                */
*   SDWAPTR=SDWAREG;                /* SET SDWAPTR                   */
         LR    SDWAPTR,SDWAREG                                     0381
*   IF SDWAPTR^=ZERO                /* SDWA EXIST?                   */
*       &SETDIEOK=ON&               /* SET DIE SUCCESSFUL?           */
*       TMCKRETY<=THREE THEN        /* NO-ALREADY TRY 3 TIMES?       */
         LTR   SDWAPTR,SDWAPTR                                     0382
         BZ    @RF00382                                            0382
         TM    SETDIEOK(DDRPTR),B'01000000'                        0382
         BNO   @RF00382                                            0382
         LH    @14,TMCKRETY(,DDRPTR)                               0382
         C     @14,@CF00306                                        0382
         BH    @RF00382                                            0382
*     DO;                           /* NOT YET                       */
*       TMCKRETY=TMCKRETY+ONE;      /* UPDATE RETRY COUNT            */
         AL    @14,@CF00047                                        0384
         STH   @14,TMCKRETY(,DDRPTR)                               0384
*       DERRETRY=ADDR(IGFTMCHW);    /* RETRY TO ISSUE MSG            */
         LA    @14,IGFTMCHW                                        0385
         ST    @14,DERRETRY                                        0385
*     END;                                                         0386
*   ELSE                            /* NO                            */
*     DERRETRY=ADDR(IGFTMCHR);      /* RETURN TO DISPATCHER          */
         B     @RC00382                                            0387
@RF00382 LA    @14,IGFTMCHR                                        0387
         ST    @14,DERRETRY                                        0387
*   RFY                                                            0388
*     SDWAREG UNRSTD;               /* RELEASE REG 0                 */
@RC00382 DS    0H                                                  0389
*   IF LCLLOCK=ON THEN                                             0389
         TM    LCLLOCK(DDRPTR),B'00010000'                         0389
         BNO   @RF00389                                            0389
*     DO;                           /* IF LOCAL LOCK HELD RELEASE IT
*                                                            @G24LNLC*/
*       RFY                                                        0391
*        (R0,                                                      0391
*         R1,                                                      0391
*         R14,                                                     0391
*         R15) RSTD;                /*                       @G24LNLC*/
*       GEN REFS(PSALITA);                                         0392
*                                                       /* @G24LNLC*/
        SETLOCK RELEASE,TYPE=LOCAL,REGS=USE,RELATED=('GOTTEN FOR SUSPE**
                 ND')                                   /* @G24LNLC*/
*       LCLLOCK=OFF;                /* RESET LOCK HELD INDICATOR   0393
*                                                            @G24LNLC*/
         NI    LCLLOCK(DDRPTR),B'11101111'                         0393
*       RFY                                                        0394
*        (R0,                                                      0394
*         R1,                                                      0394
*         R14,                                                     0394
*         R15) UNRSTD;              /*                       @G24LNLC*/
*     END;                          /*                       @G24LNLC*/
*   RETURN;                         /* RETURN TO CALLER-IGFDE0       */
@EL00002 DS    0H                                                  0396
@EF00002 DS    0H                                                  0396
@ER00002 BR    @14                                                 0396
*   END IGFTMCHS;                                                  0397
*                                                                  0397
         B     @EL00002                                            0397
*/* COMMON VARIABLES NEEDED FOR SYSTEM MACROS                        */
*                                                                  0398
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     0398
*     GPR01F FIXED(31) REG(1),                                     0398
*     GPR15F FIXED(31) REG(15);                                    0398
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0399
*     I031F FIXED(31) BASED,                                       0399
*     I031P PTR(31) BASED,                                         0399
*     I015F FIXED(15) BASED,                                       0399
*     I015P PTR(15) BASED,                                         0399
*     I008P PTR(8) BASED,                                          0399
*     I001C CHAR(1) BASED;                                         0399
*   END IGFTMCHK                                                   0400
*                                                                  0400
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAASVT )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHADDR  )                                       */
*/*%INCLUDE SYSLIB  (IHARVT  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHATQE  )                                       */
*/*%INCLUDE SYSLIB  (IEAVVTPC)                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*                                                                  0400
*       ;                                                          0400
@DATA    DS    0H
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@AL00001 DS    1A
IGFTMCHK CSECT
         DS    0F
@CF00047 DC    F'1'
@CH00047 EQU   @CF00047+2
@CF00087 DC    F'2'
@CF00306 DC    F'3'
@CF00041 DC    F'4'
@CF00074 DC    F'8'
@CF02817 DC    F'12'
@CF00790 DC    F'16'
@CF02958 DC    F'62720'
@DATD    DSECT
         DS    0D
TQEPTR   DS    A
TCBPTR   DS    A
RBSECPTR DS    A
ECBPTR   DS    A
DDRCMLEN DS    F
SQASIZE  DS    F
PARMPTR  DS    A
R13SAVE  DS    A
         DS    0D
@TS00001 DS    CL8
DERPLIST DS    CL48
         ORG   DERPLIST
DERFUNK  DS    AL1
DERSWCHS DS    BL1
         ORG   DERSWCHS
DERCRASH DS    BL1
DERPERK  EQU   DERSWCHS+0
DERECALL EQU   DERSWCHS+0
DERESTAE EQU   DERSWCHS+0
@NM00149 EQU   DERSWCHS+0
         ORG   DERPLIST+2
@NM00150 DS    CL2
DERREC   DS    AL4
DERSPEC  DS    AL4
DERRETRY DS    AL4
DERDATD  DS    CL4
         ORG   DERDATD
DERDASPN DS    FL1
DERDALNG DS    FL3
         ORG   DERPLIST+20
DERRSRC  DS    BL1
         ORG   DERRSRC
DERTAPE  DS    BL1
DERUREC  EQU   DERRSRC+0
DERDISK  EQU   DERRSRC+0
@NM00151 EQU   DERRSRC+0
         ORG   DERPLIST+21
DERLRC   DS    AL1
DERRUB   DS    CL18
         ORG   DERRUB
DERPFX   DS    BL2
DERRCODE DS    AL4
DERRDATA DS    AL4
DERRDDR  DS    AL4
DERRSAVE DS    AL4
         ORG   DERPLIST+40
DERGMSPL DS    CL4
         ORG   DERGMSPL
DERGMSPN DS    FL1
DERGMLNG DS    FL3
         ORG   DERPLIST+44
DERGMADR DS    AL4
         ORG   DERPLIST+48
MIHTMWK1 DS    CL6
         ORG   MIHTMWK1
MIHOUR   DS    CL2
MIHMIM   DS    CL2
MIHSEC   DS    CL2
         ORG   MIHTMWK1+6
         DS    CL2
MIHTMWK2 DS    CL12
         ORG   MIHTMWK2
HR       DS    FL4
MM       DS    FL4
SS       DS    FL4
         ORG   MIHTMWK2+12
IGFTMCHK CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02812 DC    V(IGFDR0)
@CV02813 DC    V(IGFDM0)
@CV02814 DC    V(IGFDE0)
@CV02815 DC    V(IGFINTVL)
         DS    0D
@CC02828 DC    C'00030000'
@CC02842 DC    C'00000000'
@CC02846 DC    C'SRB '
@CB02791 DC    B'0000000011100100'
DERRECPM DS    CL24
         ORG   DERRECPM
@NM00152 DC    CL8'IGFDI0'
@NM00153 DC    CL8'IGFTMCHK'
@NM00154 DC    CL8'77313'
         ORG   DERRECPM+24
IGFTMCHK CSECT
         DS   0H
TMCMAIN DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGFTMCHK CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
I        EQU   @03
SRBLEN   EQU   @11
TQELEN   EQU   @05
UCBPTR   EQU   @03
SRBPTR   EQU   @07
SDWAPTR  EQU   @05
CODEBASE EQU   @08
DATABASE EQU   @09
DDRPTR   EQU   @10
R0       EQU   @00
R1       EQU   @01
DERPTR   EQU   @02
MSGPTR   EQU   @04
R5       EQU   @05
R11      EQU   @11
R12      EQU   @12
SAVEPTR  EQU   @13
R14      EQU   @14
R15      EQU   @15
SDWAREG  EQU   @00
RTNCODE  EQU   @15
GPR01F   EQU   @01
GPR15F   EQU   @15
GPR00F   EQU   @00
R3       EQU   @03
R6       EQU   @06
R7       EQU   @07
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ASVT     EQU   0
ASVTFRST EQU   ASVT+524
ASVTENTY EQU   ASVT+528
CVTMAP   EQU   0
CVT      EQU   CVTMAP
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTTPC   EQU   CVTMAP+88
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTRMS   EQU   CVTMAP+224
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
DDRCOM   EQU   0
DDRSHORT EQU   DDRCOM
DDRCNTRL EQU   DDRSHORT+8
DDRSRC   EQU   DDRCNTRL
DDRSTAT  EQU   DDRCNTRL+1
DDRDCHAR EQU   DDRCNTRL+2
DDRDSTAT EQU   DDRDCHAR+1
DDRDA    EQU   DDRDSTAT
DDRMT    EQU   DDRDSTAT
DDRUR    EQU   DDRDSTAT
DDRUASID EQU   DDRSHORT+16
DDRFMCUA EQU   DDRSHORT+18
DDRLONG  EQU   DDRCOM+24
DDRFMUCB EQU   DDRLONG+4
DDRROWN  EQU   DDRLONG+8
DDRMIH   EQU   DDRLONG+9
DDRMIHT  EQU   DDRLONG+12
DDRUTCB  EQU   DDRLONG+24
DDRUASCB EQU   DDRLONG+28
DDRTER   EQU   DDRLONG+36
DDRINV   EQU   DDRLONG+38
DDRAPP   EQU   DDRLONG+40
DDRIOF   EQU   DDRLONG+52
DDRIOF2  EQU   DDRIOF+1
DDRMSG   EQU   DDRLONG+54
DDRMSGCD EQU   DDRMSG+1
DDRMSGP  EQU   DDRLONG+56
DDRMSGPN EQU   DDRMSGP
DDRMSGPC EQU   DDRMSGP+1
DDRLABEL EQU   DDRLONG+64
DDRRETRY EQU   DDRLONG+65
DDRREC   EQU   DDRLONG+66
DDRREC1  EQU   DDRREC
DDRREC2  EQU   DDRREC+1
DDRUSER  EQU   DDRLONG+68
RVT      EQU   0
RVTMIH   EQU   RVT+104
RVTMIH2  EQU   RVT+108
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBID    EQU   SRB
SRBFLNK  EQU   SRB+4
SRBASCB  EQU   SRB+8
SRBFLC   EQU   SRB+12
SRBPTCB  EQU   SRBFLC+4
SRBEP    EQU   SRB+20
SRBPARM  EQU   SRB+28
TQE      EQU   0
TQEAID   EQU   TQE+12
TQEFLGS  EQU   TQE+14
TQEFLGS2 EQU   TQE+15
TQEVAL   EQU   TQE+16
TQEEXIT  EQU   TQE+28
TQESRB   EQU   TQE+44
TQEFLGS3 EQU   TQE+88
TQESTCK  EQU   TQE+120
TPC      EQU   0
IEATPC   EQU   TPC
TPCFLGS1 EQU   IEATPC+4
TPCHDCCQ EQU   IEATPC+12
TPCDMTQE EQU   IEATPC+16
DFD      EQU   TPCDMTQE+4
TPCMNTQE EQU   IEATPC+40
MNIGHT   EQU   TPCMNTQE+16
TPCMFTQE EQU   IEATPC+64
IEATSELM EQU   IEATPC+88
TPCLMTQE EQU   IEATPC+112
TPCWORK  EQU   IEATPC+264
TPCSDIE  EQU   IEATPC+412
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00127 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBSTAWA EQU   TCB+252
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00133 EQU   RBSECT+10
@NM00134 EQU   @NM00133
RBTRSVRB EQU   @NM00134
@NM00136 EQU   @NM00133+1
RBETXR   EQU   @NM00136
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00143 EQU   RBSECT+28
@NM00144 EQU   @NM00143
IRBEND   EQU   RBSECT+96
@NM00147 EQU   RBSECT+96
RBRSV138 EQU   @NM00147+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
INDATA   EQU   0
INTVL    EQU   INDATA
SETDIE   EQU   0
TMCTCBP  EQU   0
DDRCOMWK EQU   0
MIHMSGPR EQU   DDRCOMWK+92
MIHRCNT  EQU   DDRCOMWK+96
TMCKRETY EQU   MIHRCNT
MIHTIMSD EQU   DDRCOMWK+104
MIHSECND EQU   MIHTIMSD
MIHTOD   EQU   DDRCOMWK+112
MIHLOCAL EQU   DDRCOMWK+120
MIHLSTAT EQU   MIHLOCAL
TIMERR   EQU   MIHLSTAT
SETDIEOK EQU   MIHLSTAT
LCLLOCK  EQU   MIHLSTAT
TMC1LOCL EQU   DDRCOMWK+124
TMCEXITP EQU   TMC1LOCL
MIHEFLG1 EQU   TMCEXITP
MIHINTVA EQU   TMCEXITP+4
MIHINTVL EQU   DDRCOMWK+136
PARMLIST EQU   0
PARMTQE  EQU   PARMLIST
PARMDCM  EQU   PARMLIST+4
PARMECB  EQU   PARMLIST+8
ECB      EQU   0
COMPCODE EQU   ECB+1
MSGBLK   EQU   0
NEXTMSG  EQU   MSGBLK
ERRCODE  EQU   MSGBLK+4
MIHASID  EQU   MSGBLK+6
MIHUCB   EQU   MSGBLK+8
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTASVT  EQU   CVTS01+208
CVTLSMQ  EQU   CVTS01+268
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTSUSP  EQU   CVTS01+692
ASVTPTR  EQU   CVTASVT
CVTPTR   EQU   FLCCVT
PSARSVTE EQU   PSARSVT
RVTPTR   EQU   CVTRMS
TPCPTR   EQU   CVTTPC
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00126 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
TMCMIHT  EQU   DDRMIHT
TMCHR    EQU   TMCMIHT
TMCMM    EQU   TMCMIHT+2
TMCSS    EQU   TMCMIHT+4
FLC      EQU   PSA
TQEECB   EQU   TQEEXIT
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
TMCTH    EQU   TMCMIHT+6
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00148 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBCDSAVE EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00126
UCBSKPFG EQU   @NM00126
UCBRIPND EQU   @NM00126
UCBRTIAC EQU   @NM00126
UCBRSV79 EQU   @NM00126
UCBRSV78 EQU   @NM00126
UCBRSV77 EQU   @NM00126
UCBOLTEP EQU   @NM00126
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00125 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00161 EQU   MSGBLK+12
@NM00160 EQU   MSGBLK+5
FLAGS    EQU   ECB
TMC01SAV EQU   DDRCOMWK+148
USERASID EQU   TMC1LOCL+10
MIHRSV0  EQU   TMC1LOCL+9
MIHCODE  EQU   TMC1LOCL+8
MIHCOND  EQU   TMCEXITP+3
MIHBYT2  EQU   TMCEXITP+1
MIHBITS  EQU   MIHEFLG1
MIHIOR   EQU   MIHEFLG1
@NM00159 EQU   MIHLOCAL+1
@NM00158 EQU   MIHLSTAT
TMC01RTY EQU   MIHLSTAT
@NM00157 EQU   MIHTOD+4
MIHTODS  EQU   MIHTOD
@NM00156 EQU   MIHTIMSD+4
R14SAVE  EQU   DDRCOMWK+100
TMC1RETY EQU   MIHRCNT+2
@NM00155 EQU   DDRCOMWK
MSSLIMIT EQU   INDATA+8
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00147+8
PRBEND   EQU   @NM00147+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00147+6
RBRSV136 EQU   @NM00147+4
RBRSV135 EQU   @NM00147
@NM00146 EQU   RBSECT+32
@NM00145 EQU   @NM00143+1
RBSCF    EQU   @NM00144
RBPGMQ1  EQU   RBPGMQ+1
@NM00142 EQU   RBPGMQ
@NM00141 EQU   RBSECT+16
@NM00140 EQU   @NM00136
@NM00139 EQU   @NM00136
RBIQETP  EQU   @NM00136
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00136
@NM00138 EQU   @NM00136
@NM00137 EQU   @NM00136
RBPMSVRB EQU   @NM00134
RBATNXIT EQU   @NM00134
@NM00135 EQU   @NM00134
RBWAITP  EQU   @NM00134
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00134
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00132 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
@NM00131 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00130 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAFX EQU   TCBSTAWA
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00129 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00128 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00127
UCBHALI  EQU   @NM00127
UCBRSV09 EQU   @NM00127
UCBRSV08 EQU   @NM00127
UCBRSV07 EQU   @NM00127
UCBRSV06 EQU   @NM00127
UCBRSV05 EQU   @NM00127
UCBRSV04 EQU   @NM00127
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00124 EQU   UCB
TPCOCL   EQU   IEATPC+416
TPCCLA   EQU   IEATPC+408
TPCCKQ   EQU   IEATPC+404
TPCRSRB  EQU   IEATPC+360
TPCTCWA  EQU   IEATPC+356
TPCCRSAV EQU   IEATPC+352
TPCFRRP  EQU   IEATPC+348
TPCVPTR  EQU   IEATPC+344
TPCMISC  EQU   IEATPC+272
TPCWORKR EQU   TPCWORK+4
TPCWORKL EQU   TPCWORK
TPCSAVE2 EQU   IEATPC+200
TPCSAVE1 EQU   IEATPC+136
@NM00123 EQU   TPCLMTQE+16
@NM00122 EQU   TPCLMTQE+15
@NM00121 EQU   TPCLMTQE+14
@NM00120 EQU   TPCLMTQE+12
@NM00119 EQU   TPCLMTQE+8
@NM00118 EQU   TPCLMTQE+4
@NM00117 EQU   TPCLMTQE
@NM00116 EQU   IEATSELM+16
@NM00115 EQU   IEATSELM+15
@NM00114 EQU   IEATSELM+14
@NM00113 EQU   IEATSELM+12
@NM00112 EQU   IEATSELM+8
@NM00111 EQU   IEATSELM+4
@NM00110 EQU   IEATSELM
@NM00109 EQU   TPCMFTQE+16
@NM00108 EQU   TPCMFTQE+15
@NM00107 EQU   TPCMFTQE+14
@NM00106 EQU   TPCMFTQE+12
@NM00105 EQU   TPCMFTQE+8
@NM00104 EQU   TPCMFTQE+4
@NM00103 EQU   TPCMFTQE
MNIGHTRH EQU   MNIGHT+4
MNIGHTLH EQU   MNIGHT
@NM00102 EQU   TPCMNTQE+15
@NM00101 EQU   TPCMNTQE+14
@NM00100 EQU   TPCMNTQE+12
@NM00099 EQU   TPCMNTQE+8
@NM00098 EQU   TPCMNTQE+4
@NM00097 EQU   TPCMNTQE
@NM00096 EQU   TPCDMTQE+16
@NM00095 EQU   TPCDMTQE+15
@NM00094 EQU   TPCDMTQE+14
@NM00093 EQU   TPCDMTQE+12
@NM00092 EQU   TPCDMTQE+8
@NM00091 EQU   TPCDMTQE
TPCTZORG EQU   IEATPC+8
TPCCC    EQU   IEATPC+7
@NM00090 EQU   IEATPC+5
@NM00089 EQU   TPCFLGS1
TPCSYNC  EQU   TPCFLGS1
TPCABND  EQU   TPCFLGS1
TPCTPCA  EQU   IEATPC
TQESTCKR EQU   TQESTCK+4
TQESTCKL EQU   TQESTCK
TQERSAVE EQU   TQE+116
@NM00088 EQU   TQE+89
@NM00087 EQU   TQEFLGS3
TQEDIE   EQU   TQEFLGS3
TQEDREGS EQU   TQESRB
TQELHPSW EQU   TQE+40
TQEASCB  EQU   TQE+36
TQETCB   EQU   TQE+32
TQESADDR EQU   TQE+24
TQEVALRH EQU   TQEVAL+4
TQEVALLH EQU   TQEVAL
TQEMIDN  EQU   TQEFLGS2
TQEMF1   EQU   TQEFLGS2
TQEOPT   EQU   TQEFLGS2
TQELM    EQU   TQEFLGS2
TQEDUM   EQU   TQEFLGS2
TQECRH   EQU   TQEFLGS2
TQEUSER  EQU   TQEFLGS2
TQECOMP  EQU   TQEFLGS2
TQETYPE  EQU   TQEFLGS
TQEXITSP EQU   TQEFLGS
TQEINCOM EQU   TQEFLGS
TQEWLIM  EQU   TQEFLGS
@NM00086 EQU   TQEFLGS
TQETOD   EQU   TQEFLGS
TQEOFF   EQU   TQEFLGS
TQEBLNK  EQU   TQE+8
TQEFLNK  EQU   TQE+4
TQETQE   EQU   TQE
@NM00085 EQU   SRB+40
@NM00084 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBRMTR  EQU   SRB+24
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
@NM00083 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00082 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00081 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00080 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00079 EQU   SDWADDAT+3
@NM00078 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00077 EQU   SDWADDAT+1
@NM00076 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00075 EQU   SDWADUMP+2
@NM00074 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00073 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00072 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00071 EQU   SDWAACF3
@NM00070 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00069 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00068 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00067 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00066 EQU   SDWA+239
@NM00065 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00064 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00063 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00062 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00061 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00060 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00059 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00058 EQU   SDWAINC2
@NM00057 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00056 EQU   SDWAILC2
@NM00055 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00054 EQU   SDWANXT2
@NM00053 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00052 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00051 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00050 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00049 EQU   SDWAINC1
@NM00048 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00047 EQU   SDWAILC1
@NM00046 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00045 EQU   SDWANXT1
@NM00044 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00043 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00042 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00041 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00040 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00039 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00038 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00037 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00036 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
RVTCCHCR EQU   RVT+100
RVTCCHDA EQU   RVT+96
RVTMSGLN EQU   RVT+92
RVTMSGPT EQU   RVT+88
RVTLRBPT EQU   RVT+84
RVTRWAPT EQU   RVT+80
RVT01MMM EQU   RVT+76
RVT00MMM EQU   RVT+72
RVTPEXIT EQU   RVT+68
RVTPKREF EQU   RVT+64
RVTPBUCR EQU   RVT+60
RVTPXMFA EQU   RVT+56
RVTPTAIM EQU   RVT+52
RVTPTCON EQU   RVT+48
RVTPTREC EQU   RVT+44
RVTPTSIG EQU   RVT+40
RVTPTERM EQU   RVT+36
RVTPMKTA EQU   RVT+32
RVTPMMSG EQU   RVT+28
RVTPMTHA EQU   RVT+24
RVTPMPFX EQU   RVT+20
RVTPMSCA EQU   RVT+16
RVTPMHCA EQU   RVT+12
RVTPMFRS EQU   RVT+8
RVTPMRTM EQU   RVT+4
RVTPMCIH EQU   RVT
DDRSSOB  EQU   DDRLONG+76
DDRUBCNT EQU   DDRLONG+72
@NM00035 EQU   DDRUSER+1
DDRUMODE EQU   DDRUSER
@NM00034 EQU   DDRREC2
DDRRFMTO EQU   DDRREC2
DDRLNOP  EQU   DDRLABEL
@NM00033 EQU   DDRLABEL
DDRLSD   EQU   DDRLABEL
DDRLNSL  EQU   DDRLABEL
DDRLNL   EQU   DDRLABEL
DDRLBLP  EQU   DDRLABEL
DDRLAL   EQU   DDRLABEL
DDRMSGOP EQU   DDRMSG
@NM00032 EQU   DDRIOF2
DDRICNT  EQU   DDRIOF2
DDRIMNT  EQU   DDRIOF2
DDRILAB  EQU   DDRIOF2
DDRITAKE EQU   DDRIOF2
DDRWHICH EQU   DDRIOF2
DDRIOF1  EQU   DDRIOF
DDRCOUNT EQU   DDRLONG+48
DDRIBUF  EQU   DDRLONG+44
DDRIBUFL EQU   DDRLONG+42
DDRAPP2  EQU   DDRAPP+1
DDRAPP1  EQU   DDRAPP
DDRINV2  EQU   DDRINV+1
DDRINV1  EQU   DDRINV
DDRTER2  EQU   DDRTER+1
DDRTER1  EQU   DDRTER
DDRTEST  EQU   DDRLONG+32
DDRUIOB  EQU   DDRLONG+20
DDRUDEB  EQU   DDRMIHT+4
DDRUDCB  EQU   DDRMIHT
DDRASID  EQU   DDRLONG+10
DDRFIRST EQU   DDRROWN
DDRJES3L EQU   DDRROWN
@NM00031 EQU   DDRROWN
DDRRDENQ EQU   DDRROWN
DDRRUENQ EQU   DDRROWN
DDRRTENQ EQU   DDRROWN
DDRTOUCB EQU   DDRLONG
DDRTOCUA EQU   DDRSHORT+21
DDRUIOSB EQU   DDRSHORT+12
@NM00030 EQU   DDRDSTAT
DDRBUFL  EQU   DDRDSTAT
DDRMDR   EQU   DDRDCHAR
@NM00029 EQU   DDRSTAT
DDRSIRB  EQU   DDRSTAT
DDRPRG   EQU   DDRSTAT
DDRRMV   EQU   DDRSTAT
DDRHAMA  EQU   DDRSTAT
DDRQUE   EQU   DDRSTAT
DDRACTV  EQU   DDRSTAT
@NM00028 EQU   DDRSRC
DDRPAGE  EQU   DDRSRC
DDRSYS   EQU   DDRSRC
DDROPER  EQU   DDRSRC
DDRNXT   EQU   DDRSHORT+4
DDRID    EQU   DDRSHORT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00003 EQU   CVTFIX+248
@NM00002 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
ASVTEND  EQU   ASVT+528
ASVTAVAL EQU   ASVTENTY
ASVTAVAI EQU   ASVTFRST
ASVTRS00 EQU   ASVT+520
ASVTMAXU EQU   ASVT+516
ASVTASVT EQU   ASVT+512
ASVTBEGN EQU   ASVT+512
@NM00001 EQU   ASVT
@NM00027 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00026 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00025 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00024 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00023 EQU   FLCFSA
@NM00022 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00021 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00020 EQU   FLCIOA
@NM00019 EQU   FLCMCLA+15
@NM00018 EQU   FLCMCLA+14
@NM00017 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00016 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00015 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00014 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00013 EQU   FLCPER
@NM00012 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00011 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00010 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00009 EQU   FLCPIILC
@NM00008 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00007 EQU   FLCSVILC
@NM00006 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00005 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00004 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00313 EQU   IGFTMCHR
@RF00321 EQU   MSGWAIT
MIHEXIT  EQU   @EL00001
@RF00389 EQU   @EL00002
@RT00213 EQU   MIHEXIT
@ENDDATA EQU   *
         END   IGFTMCHK,(C'PLS1717',0701,77313)
