         TITLE  'IGG019HJ - SETL I(D) APPENDAGE'
IGG019HJ CSECT
*              RELEASE OS/VS2-02 DELETIONS                            *
*                                                               YM03014
*              RELEASE 20 DELETIONS                                   *
*1042013000,013200,017600,017800,018000,018200,018400,018600,    S20201
*1042018800,019000,019200,019400,019600,019800,020000,020200,    S20201
*1042020400,020600,020800,021000,021200,021400,021600,021800,    S20201
*1042022000,022200,022400,022600,022800,023000,023200,023400,    S20201
*1042023600,023800,024000,024200,024400,024600,024800,025000,    S20201
*1042025200,025400,025600,025800,026000,026200,026400,026600,    S20201
*1042026800,027000,027200,027400,027600,027800,028000,028200,    S20201
*1042028400,028600,028800,029000,029200,029400,029600,029800,    S20201
*1042030000,030200,030400,030600,030800,031000,031200,031400,    S20201
*1042031600,031800,032000,032200,032400,032600,032800,033000,    S20201
*1042033200,033400,033600,033800,034000,034200,034400,034600,    S20201
*1042034800,035000,035200,035400,035600,035800,036000,036200,    S20201
*1042036400,036600,036800,037000,037200,037400,037600,037800,    S20201
*1042038000,038200,038400,038600,038800,039000,039200,039400,    S20201
*1042039600,039800,040000,040200,040400,040600,040800,041000,    S20201
*1042041200,041400,041600,041800,042000,042200,042400,042600,    S20201
*1042042800                                                      S20201
*                                                                     *
*              RELEASE 21 DELETIONS                                   *
*                                                                S21045
*                                                                     *
*STATUS CHANGE LEVEL 002
*FUNCTION/OPERATION- A CHANNEL END COMPLETION AT THE END OF THE SETL I*
*   CHANNEL PROGRAM INDICATING THE DESIRED RECORD WAS FOUND WILL      *
*   RESULT IN A NORMAL RETURN TO IOS.                                 *
*                                                                     *
*   AN ABNORMAL END OR A CHANNEL END SHOWING INCOMPLETE EXECUTION OF  *
*   THE SETL I CHANNEL PROGRAM CAUSES THE UNREACHABLE INDICATOR TO BE *
*   SET ON AND TAKES THE NORMAL RETURN TO IOS.                        *
*                                                                     *
*ENTRY POINTS- THE APPENDAGE VECTOR TABLE ADDRESSES THE ENTRY POINTS  *
*   TO MODULE 'IGG019HJ'                                              *
*        'SISSJB2'- CHANNEL END COMPLETION OF THE SETL I CHANNEL PGM  *
*        'SISSJB4'- ABNORMAL END COMPLETION OF THE SETL I CHANNEL PGM *
*                                                                     *
*INPUT- REGISTER 1- 12* ADDRESS                                       *
*       REGISTER 2- IOB ADDRESS                                       *
*       REGISTER 3- DEB ADDRESS                                       *
*       REGISTER 4- DCB ADDRESS                                       *
*       REGISTER 7- UCB ADDRESS                                       *
*       REGISTER 12- WORK AREA ADDRESS                                *
*       REGISTER 14- RETURN TO IOS VIA IGG019HG                       *
*       REGISTER 15- MODULE BASE ADDRESS                              *
*                                                                     *
*OUTPUT- SAME AS FOR INPUT                                            *
*                                                                     *
*EXTERNAL ROUTINES- N/A                                               *
*                                                                     *
*EXITS- NORMAL- RETURN TO IOS THROUGH IGG019HG                        *
*   ERROR-N/A                                                         *
*                                                                     *
*TABLES/WORK AREAS- DATA EXTENT BLOCK(DEB) DESCRIBED BY SISDEB DSECT  *
*   WORKAREA DESCRIBED BY SISWORK1 DSECT                              *
*   DATA CONTROL BLOCK DESCRIBED BY IHADCB DSECT                      *
*                                                                     *
*ATTRIBUTES- REENTRANT, READ ONLY                                     *
*                                                                     *
*NOTES- REGISTER USAGE IS CONSISTENT IN ALL SCAN MODE                 *
*   APPENDAGE MODULES                                                 *
         EJECT
         USING APPRET,R14
         USING SISWORK1,R12
         USING *,R15
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
CN31      EQU 96                        DISPLACEMENT TO CN31     S20201
SISCTSJ  DC    A(SISSJB2-SISCTSJ)
         DC    A(SISSJB4-SISCTSJ)
         USING *,R15
SISSJB2  L     R10,W1CP25PT
         LA    R10,CN31(R10)            IND RELATIVE POSITION    S20201
*                                       OFCN31 TO START OF CP
         L     R11,W1COMAD
         N     R11,SISSJCN2             AND OUT IRRELEVANT BIT
         CR    R11,R10                  WAS STOP AT CN30
         BE    SISSJC2                  YES, OK
SISSJB3  OI    W1OSBIT1,X'04'           SET ON UNREACHABLE BIT
SISSJC2  NI    W1IF1,X'FB'
RETURN   SR    R10,R10                  SET IOS RET ADDR OFST   YM03014
         BR    R14                      RETURN TO IOS VIA EXIT   Y02072
*                                       ROUTINE IN IGG019HG
SISSJB4  TM    W1ISENSE+2,X'3F'         ARE BITS 2-7 ONES
         BO    RETURN                   RETURN TO IOS VIA EXIT  YM03014
*                                       ROUTINE IN IGG019HG
         B     SISSJB3                  PERMANENT ERROR
         SPACE 5
*        CONSTANTS
SISSJCN1 DC    F'88'
SISSJCN2 DC    X'00FFFFFF'
         EJECT
APPRET DSECT                            FOR APPENDAGE RETURN TABLE
NORMAL   DS    F
SKIPPOST DS    F
EXCP     DS    F
BYPASS   DS    F
*
PATCH    DC    XL50'00'                 ZEROED PATCH AREA        Y02072
*
         EJECT
SISWORK1 IGGSCAN
         END
