IGG019JN CSECT
*
*            OS/VS2 RELEASE 040 CHANGES
*                                                               OZ02268
*
         TITLE 'IGG019JN - CHAN PROGS: WRITE KN,UNBL,SYS WA,NO WRT CHK'
*STATUS CHANGE LEVEL 001
* FUNCTION/OPERATION - CHANNEL PROGRAMS USED BY BISAM WRITE KN
*        WHEN THE RECORD FORMAT IS UNBLOCKED,
*        WHEN THE USER HAS NOT SUPPLIED A WORK AREA, AND
*        WHEN WRITE VALIDITY CHECKING IS NOT REQUESTED.
*        THIS MODULE IS LOADED AT OPEN TIME.  THE CHANNEL PROGRAMS ARE
*        MOVED TO A WORK AREA OBTAINED FOR THAT PURPOSE.  THEN THE
*        MODULE IS DELETED.
*        CP8    - SEARCH TRACK INDEX AND SEEK TO PROPER PRIME DATA
*                  TRACK.  IF THE RECORD IS IN AN OVERFLOW CHAIN, A
*                  FILE PROTECTION INTERRUPT WILL OCCUR ON THE
*                  ATTEMPTED SEEK.
*                  IF NO INTERRUPT OCCURS, SEARCH THE PRIME DATA
*                  TRACK TO DETERMINE THE FIRST RECORD TO BE BUMPED.
*        CP9A   - READ THE FIRST RECORD TO BE BUMPED.
*        CP9B   - WRITE THE NEW RECORD OR THE RECORD READ BY CP9C
*                  FROM THE AREA POINTED TO BY THE DECB.  IF THERE IS
*                  ANOTHER RECORD ON THE TRACK, READ IT INTO THE WORK
*                  AREA OBTAINED BY THE SYSTEM.
*        CP9C   - WRITE THE RECORD READ BY CP9B  FROM THE SYSTEM WORK
*                  AREA.  IF THERE IS ANOTHER RECORD ON THE TRACK, READ
*                  IT INTO THE DECB AREA.
*        CP10A  - WRITE A RECORD OVER AN EOF MARK.
*                  THIS CHANNEL PROGRAM IS USED WHEN A NEW RECORD IS
*                  ADDED TO THE END OF THE DATA SET
*                  OR WHEN A NEW RECORD IS INSERTED IN THE LAST TRACK
*                  OF THE DATA SET CAUSING AN ALREADY EXISTING RECORD
*                  TO BE BUMPED UP PAST THE LAST SLOT
*                  AND THE LAST TRACK IS NOT FULL.
*        CP10B  - WRITE A NEW EOF MARK.  THIS CHANNEL PROGRAM ALWAYS
*                  FOLLOWS CP10A.
*        CP14   - WRITE A NEW RECORD TO AN OVERFLOW CHAIN, UPDATING,
*                  WHERE NECESSARY, THE CYLINDER CONTROL RECORD, THE
*                  TRACK INDEX(ES), AND/OR THE LINK FIELD OF A
*                  LOGICALLY PRECEDING RECORD.
*        CP15   - WHEN ADDING TO THE END OF THE DATA SET, READ CERTAIN
*                  CONTROL INFORMATION USUALLY READ BY CP8.
*        CP16 - SEARCH A CHAIN OF OVERFLOW RECORDS.
*        CP17   - RE-WRITE THE KEY OF AN INDEX ENTRY.
* ENTRY POINTS - N/A
* INPUT - N/A
* OUTPUT - N/A
* EXTERNAL ROUTINES - N/A
* EXITS - N/A
* TABLES/WORK AREAS - N/A
* ATTRIBUTES - N/A
* NOTES - NONE
*
         IGGCPOPS
         IGGCP8
         IGGCP10B
         IGGCP14
         IGGCP15
         IGGCP16
         IGGCP17
         IGGCP10A
         IGGCP9A
         IGGCP9B
         IGGCP9C
         END
