IGG019JQ CSECT
*
*            OS/VS2 RELEASE 040 CHANGES
*                                                               OZ02268
*
         TITLE 'IGG019JQ - CHAN PROGS: WRITE KN,BLKD,SYS WA,W/ WRT CHK'
*STATUS CHANGE LEVEL 001
* FUNCTION/OPERATION - CHANNEL PROGRAMS USED BY BISAM WRITE KN
*        WHEN THE RECORD FORMAT IS   BLOCKED,
*        WHEN THE USER HAS NOT SUPPLIED A WORK AREA, AND
*        WHEN WRITE VALIDITY CHECKING IS     REQUESTED.
*        THIS MODULE IS LOADED AT OPEN TIME.  THE CHANNEL PROGRAMS ARE
*        MOVED TO A WORK AREA OBTAINED FOR THAT PURPOSE.  THEN THE
*        MODULE IS DELETED.
*        CP8    - SEARCH TRACK INDEX AND SEEK TO PROPER PRIME DATA
*                  TRACK.  IF THE RECORD IS IN AN OVERFLOW CHAIN, A
*                  FILE PROTECTION INTERRUPT WILL OCCUR ON THE
*                  ATTEMPTED SEEK.
*                  IF NO INTERRUPT OCCURS, SEARCH THE PRIME DATA
*                  TRACK TO DETERMINE THE FIRST RECORD TO BE BUMPED.
*        CP10AW - WRITE A RECORD OVER AN EOF MARK.
*                  THIS CHANNEL PROGRAM IS USED WHEN A NEW RECORD IS
*                  ADDED TO THE END OF THE DATA SET
*                  OR WHEN A NEW RECORD IS INSERTED IN THE LAST TRACK
*                  OF THE DATA SET CAUSING AN ALREADY EXISTING RECORD
*                  TO BE BUMPED UP PAST THE LAST SLOT
*                  AND THE LAST TRACK IS NOT FULL
*                  BUT THE LAST BLOCK IS FULL.
*        CP10BW - WRITE A NEW EOF MARK.  THIS CHANNEL PROGRAM ALWAYS
*                  FOLLOWS CP10AW.
*        CP11A   READ A BLOCK OF RECORDS WHICH MUST BE BUMPED UP ON A
*                  PRIME DATA TRACK.  OR
*                  READ THE LAST BLOCK OF THE DATA SET WHEN THE LAST
*                  BLOCK IS NOT FULL AND A RECORD IS BEING ADDED TO THE
*                  END OF THE DATA SET.
*        CP11BW - WRITE BACK A BLOCK OF RECORDS READ BY CP11A AFTER A
*                  NEW RECORD HAS BEEN INSERTED IN THE BLOCK.
*        CP14W  - WRITE A NEW RECORD TO AN OVERFLOW CHAIN, UPDATING,
*                  WHERE NECESSARY, THE CYLINDER CONTROL RECORD, THE
*                  TRACK INDEX(ES), AND/OR THE LINK FIELD OF A
*                  LOGICALLY PRECEDING RECORD.
*        CP15   - WHEN ADDING TO THE END OF THE DATA SET, READ CERTAIN
*                  CONTROL INFORMATION USUALLY READ BY CP8.
*        CP16 - SEARCH A CHAIN OF OVERFLOW RECORDS.
*        CP17W  - RE-WRITE THE KEY OF AN INDEX ENTRY.
* ENTRY POINTS - N/A
* INPUT - N/A
* OUTPUT - N/A
* EXTERNAL ROUTINES - N/A
* EXITS - N/A
* TABLES/WORK AREAS - N/A
* ATTRIBUTES - N/A
* NOTES - NONE
         IGGCPOPS
         IGGCP8
         IGGCP10B OPTCD=W                                        S20201
         IGGCP14  OPTCD=W                                        S20201
         IGGCP15
         IGGCP16
         IGGCP17  OPTCD=W                                        S20201
         IGGCP10A OPTCD=W                                        S20201
         IGGCP11A
         IGGCP11B OPTCD=W                                        S20201
         END
