         TITLE 'IGG019JS - CHAN PROGS: WRITE KN,BLKD,USR WA,NO WRT CHK'
IGG019JS CSECT
*
*            OS/VS2 RELEASE 040 CHANGES
*                                                               OZ02268
*
*STATUS CHANGE LEVEL 002
* FUNCTION/OPERATION - CHANNEL PROGRAMS USED BY BISAM WRITE KN
*        WHEN THE RECORD FORMAT IS   BLOCKED,
*        WHEN THE USER HAS     SUPPLIED A WORK AREA, AND
*        WHEN WRITE VALIDITY CHECKING IS NOT REQUESTED.
*        THIS MODULE IS LOADED AT OPEN TIME.  THE CHANNEL PROGRAMS ARE
*        MOVED TO A WORK AREA OBTAINED FOR THAT PURPOSE.  THEN THE
*        MODULE IS DELETED.
*        CP8    - SEARCH TRACK INDEX AND SEEK TO PROPER PRIME DATA
*                  TRACK.  IF THE RECORD IS IN AN OVERFLOW CHAIN, A
*                  FILE PROTECTION INTERRUPT WILL OCCUR ON THE
*                  ATTEMPTED SEEK.
*                  IF NO INTERRUPT OCCURS, SEARCH THE PRIME DATA
*                  TRACK TO DETERMINE THE FIRST RECORD TO BE BUMPED.
*        CP10A  - WRITE A RECORD OVER AN EOF MARK.
*                  THIS CHANNEL PROGRAM IS USED WHEN A NEW RECORD IS
*                  ADDED TO THE END OF THE DATA SET
*                  AND THE LAST TRACK IS NOT FULL
*                  BUT THE LAST BLOCK IS FULL.
*        CP10B  - WRITE A NEW EOF MARK.  THIS CHANNEL PROGRAM ALWAYS
*                  FOLLOWS CP10A.
*                  IT IS ALSO USED AFTER A NEW RECORD HAS BEEN INSERTED
*                  IN THE LAST PRIME DATA TRACK, THEREBY CAUSING THE
*                  EOF MARK TO BE ERASED.
*        CP13A  - READ A TRACK OF RECORDS FROM THE POINT AT WHICH THEY
*                  MUST BE BUMPED. OR
*                  READ THE LAST BLOCK OF THE DATA SET WHEN THE LAST
*                  BLOCK IS NOT FULL AND A RECORD IS BEING ADDED TO THE
*                  END OF THE DATA SET.
*        CP13B  - WRITE BACK THE TRACK OF RECORDS WITH THE NEW RECORD
*                  INSERTED.  OR
*                  WRITE BACK THE LAST BLOCK OF THE DATA SET.
*        CP13C  - WRITE A RECORD WHICH HAS REPLACED A 'DELETED' RECORD
*        CP14   - WRITE A NEW RECORD TO AN OVERFLOW CHAIN, UPDATING,
*                  WHERE NECESSARY, THE CYLINDER CONTROL RECORD, THE
*                  TRACK INDEX(ES), AND/OR THE LINK FIELD OF A
*                  LOGICALLY PRECEDING RECORD.
*        CP15   - WHEN ADDING TO THE END OF THE DATA SET, READ CERTAIN
*                  CONTROL INFORMATION USUALLY READ BY CP8.
*        CP16 - SEARCH A CHAIN OF OVERFLOW RECORDS.
*        CP17   - RE-WRITE THE KEY OF AN INDEX ENTRY.
* ENTRY POINTS - N/A
* INPUT - N/A
* OUTPUT - N/A
* EXTERNAL ROUTINES - N/A
* EXITS - N/A
* TABLES/WORK AREAS - N/A
* ATTRIBUTES - N/A
* NOTES - NONE
*
         IGGCPOPS
         IGGCP8
         IGGCP10B
         IGGCP14
         IGGCP15
         IGGCP16
         IGGCP17
         IGGCP10A
         IGGCP13C
         IGGCP13A
         IGGCP13B
         END
