         TITLE 'IGG019M0 - IBM 2740 (CHECKING)'
IGG019M0 CSECT
* STATUS -          CHANGE LEVEL  002   FEBURARY 20, 1969          000M
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    AL1(WC-A)                WRITE CONTINUE
         DC    X'FF'
         DC    AL1(WV-A)                WRITE CONVERSATIONAL
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    4X'FF'                                              000M
         DC    AL1(WTTV-A)              WRITE CONTINUE CONVERSATION000M
         DC    AL1(WCT-A)               WRITE CONTROL            A27629
         DC    4X'FF'                                            A33946
         DC    AL1(RBK-A)                                        A33946
         DC    AL1(WBK-A)                                        A33946
         DC    X'FF'                                             A33946
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'040B060C088101'        READ INITIAL               000H
WI       DC    X'030509078102'          WRITE INITIAL
RC       DC    X'0203088101'            READ CONTINUE
WC       DC    X'0209078102'            WRITE CONTINUE
WV       DC    X'030009078102'          WRITE CONVERSATIONAL
RR       DC    X'0204088101'            READ REPEAT
WA       DC    X'0101'                  WRITE ACKNOWLEDGE
RS       DC    X'010A'                  READ SKIP
WN       DC    X'0102'                  WRITE NEG-ACKNOWLEDGE
WTTV     DC    X'060D0E0B060C08'        WRITE CONTINUE CONVERSATION000M
WCT      DC    X'020F10'                WRITE CONTROL            A27629
RBK      DC    X'05110B060C088101'     READ INITIAL BREAK        A33946
WBK      DC    X'0411120907'           WRITE INITIAL BREAK       A33946
         SPACE 3                                                   000M
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C00',AL1(D-C)       WR D      X                1
         DC    X'80020001'
         DC    X'010C00',AL1(D-C)       WR DC               X    A32464
         DC    X'20210002'                                       A32464
         DC    X'010C00',AL1(E-C)       WR C                X    A32464
         DC    X'20210001'                                       A32464
         DC    X'010C00',AL1(F-C)       WR Y           X    X      1
         DC    X'60020001'
         DC    X'010C00',AL1(G-C)       WR N           X    X      1
         DC    X'60020001'
         DC    X'010C00',AL1(H-C)       WR D+IDLE X                16
         DC    X'80020010'
         DC    X'0600000060010001'      PREPARE        X    X      1
         DC    X'0208000120200002'      RD RESP             X    A33945
         DC    X'0204000020110400'      RD DATA             X      N
         DC    X'0104000060110400'      WR DATA        X    X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C00',AL1(E-C)       WR C           X    X    A32464
         DC    X'60020001'                                       A32464
         DC    X'0448000060040001'      SENSE          X    X      1
         DC    X'0138000060110800'      WR DATA             X      000M
         DC    X'0208000160200001'      RD RESP        X    X    1 000M
         DC    X'2F00000060010001'      DISABLE        X    X      1
         DC    X'2700000020240001'      ENABLE              X      1
         DC    X'0D0C00',AL1(H+1-C) WR BREAK                    YA01062
         DC    X'60230004'                                       A49669
         DC    X'010C00',AL1(E-C)      WR CD+IDLE X              A33946
         DC    X'80020011'                                       A33946
         SPACE 2
F        DC    X'76'                   CIRCLE Y
G        DC    X'40'                   CIRCLE N
D        DC    X'16'                   CIRCLE D
E        DC    X'1F'                   CIRCLE C
H        DC    X'16',15X'5E'           CIRCLE D, 15 IDLES
         CNOP  0,8
         END
