         TITLE 'IGG019M2 - 2740 WITH STN CTL AND AUTOPOLL MODULE'
IGG019M2 CSECT
* STATUS -               CHANGE LEVEL  001      AUGUST 3,1967      000B
         SPACE 2
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 16 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RS-A)                READ SKIP
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    9X'FF'                                              000B
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAM
RI       DC    X'0400040608'            READ INITIAL
WI       DC    X'06010503070B098102'    WRITE INITIAL
RS       DC    X'010A'                  READ SKIP
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C006060020003'      WR CCC         X    X      3
         DC    X'010C006080020004'      WR CCCS   X                4
         DC    X'010C006020210003'      WR CCC              X      3
         DC    X'010C006460040001'      WR SPACE       X    X      1
         DC    X'0924000060030000'      WR POLL        X    X     LIST
         DC    X'0114000080030001'      WR ADRS   X                1
         DC    X'02040000800A0002'      RD INDX   X                2
         DC    X'0208000020060002'      RD RESP             X      2
         DC    X'0204000220110402'      RD DATA             X      N-2
         DC    X'0104000020110400'      WR DATA             X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C006580040001'      WR D      X         X      1
         SPACE 2
         DC    X'1F1F1F'                CIRCLE C'S
         DC    X'37'                    CIRCLE S
         DC    X'01'                    SPACE
         DC    X'16'                    CIRCLE D
         CNOP  0,8
         END
