         TITLE 'IGG019M5 - IBM SYSTEM/360 CPU-CPU CONTENTION'
IGG019M5 CSECT
*72390104459000,549000,819000,828000,837000,846000,909000,918000
         SPACE 2
* STATUS -          CHANGE LEVEL 001    FEBRUARY 27, 1968
         SPACE
* FUNCTION-    THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE.  SPECIAL
*              CONTROL CHARACTERS ARE LOCATED IN THE FIRST 20 BYTES
*              OF THE DCB.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*              THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE.
*              ITS ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE
*              BY OPEN AT OPEN TIME.
         EJECT
A        DC    X'FF'                 00
         DC    AL1(RI-A)             01 READ INITIAL
         DC    AL1(WI-A)             02 WRITE INITIAL(R)
         DC    AL1(RC-A)             03 READ CONTINUE
         DC    AL1(WC-A)             04 WRITE CONTINUE(R)
         DC    X'FF'                 05
         DC    X'FF'                 06
         DC    AL1(RR-A)             07 READ REPEAT
         DC    X'FF'                 08
         DC    X'FF'                 09
         DC    AL1(WN-A)             0A WRITE RESET(R)
         DC    X'FF'                 0B
         DC    AL1(WIXB-A)           0C WRITE INIT XPARENT BLOCK
         DC    AL1(WIC-A)            0D WRITE INIT CONV
         DC    AL1(WCXB-A)           0E WRITE CONT XPARENT BLOCK
         DC    AL1(WCC-A)            0F WRITE CONTIN CONV
         DC    X'FF'                 10
         DC    X'FF'                 11
         DC    AL1(WIX-A)            12 WRITE INIT XPARENT(R)
         DC    AL1(RCL-A)            13 READ CONT W/ LEAD GRAPH
         DC    AL1(WCX-A)            14 WRITE CONT XPARENT(R)
         DC    AL1(RQ-A)             15 READ INQUIRY
         DC    AL1(WQ-A)             16 WRITE INQUIRY
         DC    AL1(RRL-A)            17 READ REP W/ LEAD GRAPH
         DC    AL1(C-A)              18 OFFSET TO CCW'S
         DC    AL1(RIQ-A)            19 READ INITIAL INQUIRY
         DC    AL1(WW-A)             1A WRITE WAIT BEFORE XMIT
         DC    AL1(RVI-A)            1B READ INTERRUPT
         DC    X'FF'                 1C
         DC    AL1(WICX-A)           1D WRITE INIT CONV XPRNT
         DC    X'FF'                 1E
         DC    AL1(WCCX-A)           1F WRITE CONT CONV XPRNT
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'0400060309'            READ INITIAL
WI       DC    X'0405070A0E810D'        WRITE INITIAL
RC       DC    X'020309'                READ CONTINUE
WC       DC    X'020A0E810D'            WRITE CONTINUE
RR       DC    X'020409'                READ REPEAT
WN       DC    X'010D'                  WRITE RESET
RQ       DC    X'0106'                  READ INQUIRY
WQ       DC    X'03050F0B'              WRITE INQUIRY            A32454
RIQ      DC    X'020006'                READ INITIAL INQUIRY
WIC      DC    X'050507100F0B'          WRITE INITIAL CONVERS
WCC      DC    X'03100F0B'              WRITE CONTIN CONVERS
RS       DC    X'021113'                READ STOP
WIX      DC    X'0505070A0C0E810D'      WRITE INITIAL XPARENT
RCL      DC    X'03010309'              READ CONTIN W/LEAD GRAPH
WCX      DC    X'030A0C0E810D'          WRITE CONTINUE XPARENT
RRL      DC    X'03010409'              READ REPEAT W/LEAD GRAPH
WW       DC    X'03020006'              WRITE WAIT BEFORE XMIT
RVI      DC    X'021109'               READ INTERRUPT              000J
WICX     DC    X'060507100C0F0B'        WRITE INIT CONV XPARENT
WCCX     DC    X'04100C0F0B'            WRITE CONTIN CONV XPARENT
WIXB     DC    X'0505070A120E'          WRITE INIT XPARENT BLOCK
WCXB     DC    X'030A120E'              WRITE CONT XPARENT BLOCK
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'0600000060010001'      PREPARE        X    X      1
         DC    X'013C000080010800'      WR GRAPH  X                N
         DC    X'0128004E60010002'     WR WACK         X    X      2 0J
         DC    X'0134004060080002'      WR RESP        X    X      2
         DC    X'0128004560080001'      WR NAK         X    X      1
         DC    X'0128004460030001'      WR INQ         X    X      1
         DC    X'02080000200B0002'      RD INQ              X      2
         DC    X'02080000200C0002'      RD RESP             X      2
         DC    X'02080000200C0002'      RD RESP             X      2
         DC    X'0204000020110400'      RD TXT              X      N
         DC    X'0104000060110400'      WR TXT         X    X      N
         DC    X'0204001420110414'      RD TXT              X     N-20
         DC    X'0128003E60130002'      WR DLEETX      X    X      2
         DC    X'0128004820210001'      WR EOT              X      1
         DC    X'0208000020250002'      RD RESP             X      2
         DC    X'02040000A0250C14'     RD RESP    X         X      200J
         DC    X'0138000060110800'      WR TXT         X    X      N
         DC    X'0128005060080002'      WR RVI         X    X      2
         DC    X'0128004A60130002'      WR DLEETB      X    X      2
         CNOP  0,8
         END
