         TITLE 'IGG019M6 - IBM SYSTEM/360 CPU-CPU SWITCHED'
IGG019M6 CSECT
*72420014408000,488000,744000,752000,760000,768000,792000,848000,856000
         SPACE 2
* STATUS -          CHANGE LEVEL 001    FEBRUARY 27, 1968
         SPACE
* FUNCTION-    THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE.  SPECIAL
*              CONTROL CHARACTERS ARE LOCATED IN THE FIRST 20 BYTES
*              OF THE DCB.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*              THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE.
*              ITS ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE
*              BY OPEN AT OPEN TIME.
         EJECT
A        DC    AL1(WB-A)             00 WRITE DISABLE
         DC    AL1(RI-A)             01 READ INITIAL
         DC    AL1(WI-A)             02 WRITE INITIAL(R)
         DC    AL1(RC-A)             03 READ CONTINUE
         DC    AL1(WC-A)             04 WRITE CONTINUE(R)
         DC    X'FF'                 05
         DC    X'FF'                 06
         DC    AL1(RR-A)             07 READ REPEAT
         DC    X'FF'                 08
         DC    AL1(RQM-A)            09 READ INQUIRY MONITOR
         DC    AL1(WN-A)             0A WRITE RESET
         DC    AL1(WRM-A)            0B WRITE RESET MONITOR
         DC    AL1(WIXB-A)           OC WRITE INIT XPARENT BLOCK
         DC    AL1(WIC-A)            0D WRITE INIT CONV
         DC    AL1(WCXB-A)           0E WRITE CONT XPARENT BLOCK
         DC    AL1(WCC-A)            0F WRITE CONTIN CONV
         DC    AL1(WD-A)             10 WRITE DISCONNECT
         DC    AL1(RCON-A)           11 READ CONNECT               000L
         DC    AL1(WIX-A)            12 WRITE INIT XPARENT(R)
         DC    AL1(RCL-A)            13 READ CONT W/ LEAD GRAPH
         DC    AL1(WCX-A)            14 WRITE CONT XPARENT(R)
         DC    AL1(RQ-A)             15 READ INQUIRY
         DC    AL1(WQ-A)             16 WRITE INQUIRY
         DC    AL1(RRL-A)            17 READ REP W/ LEAD GRAPH
         DC    AL1(C-A)              18 OFFSET TO CCW'S
         DC    X'FF'                 19
         DC    AL1(WW-A)             1A WRITE WAIT BEFORE XMIT
         DC    AL1(RVI-A)            1B READ INTERRUPT
         DC    AL1(WCON-A)              1C WRITE CONNECT           000H
         DC    AL1(WICX-A)           1D WRITE INIT CONV XPRNT
         DC    AL1(RTCW-A)           1E READ CONNECT WITH TONE     000L
         DC    AL1(WCCX-A)           1F WRITE CONT CONV XPRNT
         SPACE 2
*                   CHANNEL PROGRAMS
WB       DC    X'0112'                  WRITE DISABLE
RI       DC    X'07010708050A040D'      READ INITIAL
         DC    X'0B08070D'              READ INITIAL(ANSWER)
         DC    X'101708070D'            READ INITIAL(WORLD TRADE)  000H
WI       DC    X'050107080E13'          WRITE INITIAL
RC       DC    X'02040D'                READ CONTINUE
WC       DC    X'020E13'                WRITE CONTINUE
RR       DC    X'02060D'                READ REPEAT
WN       DC    X'021E0A'                WRITE RESET              A33954
WD       DC    X'021112'                WRITE DISCONNECT
RS       DC    X'021618'                READ STOP
RQ       DC    X'010A'                  READ INQUIRY
WQ       DC    X'0309140F'              WRITE INQUIRY            A32454
WIC      DC    X'0601070815140F'        WRITE INITIAL CONVERS
WCC      DC    X'0315140F'              WRITE CONTIN CONVERS
WIX      DC    X'060107080E1013'        WRITE INITIAL XPARENT
RCL      DC    X'0302040D'              READ CONTIN W/LEAD GRAPH
WCX      DC    X'030E1013'              WRITE CONTIN
RRL      DC    X'0302060D'              READ REPEAT W/LEAD GRAPH
WW       DC    X'02030A'                WRITE WAIT BEFORE XMIT
RVI      DC    X'02160D'               READ INTERRUPT              000J
WICX     DC    X'070107081510140F'      WRITE INIT CONV XPARENT
WCCX     DC    X'041510140F'            WRITE CONTIN CONV XPARENT
WCON     DC    X'03180708'              WRITE CONNECT              000H
         DC    X'061A19'                WRITE CONNECT (SWLST)      000L
RCON     DC    X'0718191A0D111B1C'      READ CONNECT               000L
RTCW     DC    X'081817191A0D111B1C'    READ CONNECT WITH TONE     000L
WIXB     DC    X'060107080E1D13'        WRITE INIT XPARENT BLOCK
WCXB     DC    X'030E1D13'              WRITE CONT XPARENT BLOCK
RQM      DC    X'02000A'                READ INQUIRY MONITOR
WRM      DC    X'031F000A'         WRITE RESET MONITOR         @ZA31078
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'0600000060010001'      PREPARE        X    X      1
         DC    X'292C000160010000'      DIAL           X    X      N
         DC    X'013C000080010800'      WR GRAPH  X                N
         DC    X'0128004E60010002'     WR WACK         X    X      2 0J
         DC    X'0134004060080002'      WR RESP        X    X      2
         DC    X'0128004860080001'      WR EOT         X    X      1
         DC    X'0128004560080001'      WR NACK        X    X      1
         DC    X'0130000160030000'      WR IDENT       X    X      N
         DC    X'0218000120070000'      RD IDENT            X      N
         DC    X'0128004460030001'      WR INQ         X    X      1
         DC    X'02080000200B0002'      RD INQ              X      2
         DC    X'02080000200C0002'      RD RESP             X      2
         DC    X'02080000200C0002'      RD RESP             X      2
         DC    X'0204000020110400'      RD TXT              X      N
         DC    X'0104000060110400'      WR TXT         X    X      N
         DC    X'0204001420110414'      RD TXT              X     N-20
         DC    X'0128003E60130002'      WR DLEETX      X    X      2
         DC    X'0128004760210002'      WR DLEEOT      X    X      2
         DC    X'2F00000020210001'      DISABLE             X      1
         DC    X'0208000020250002'      RD RESP             X      2
         DC    X'02040000A0250C14'     RD RESP    X         X      200J
         DC    X'0138000060110800'      WR TXT         X    X      N
         DC    X'0128005060080002'      WR RVI         X    X      2
         DC    X'014C000060010000'      WRITE TONE     X    X      N
         DC    X'2700000160010001'      ENABLE         X    X      1
         DC    X'0258000020070000'      RD ID SEQ           X      N 0L
         DC    X'015C000060030000'      WR ID SEQ      X    X      N 0L
         DC    X'2F00000060210001'      DISABLE        X    X      1 0L
         DC    X'0860000020090001'      TIC                 X      1 0L
         DC    X'0128004A60130002'      WR DLEETB      X    X      2
         DC    X'0128004860210001'      WR EOT         X    X      1
         DC    X'0128004820080001'      WR EOT              X      1
*                                       ABOVE LINE ADDED BY    @ZA31078
         CNOP  0,8
         END
