         TITLE 'IGG019MD - IBM 1050 NON-SWITCHED DEVICE I/O MODULE'
IGG019MD CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  002   AUGUST  5,1969             000M
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    AL1(WC-A)                WRITE CONTINUE
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    AL1(WTTV-A)           0F WRITE CONTINUE CONVERSATION000M
         DC    AL1(WCT-A)               WRITE CONTROL            A27629
         DC    7X'FF'                                            A27629
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'040005070B810E'        READ INITIAL
WI       DC    X'06000608020C098101'    WRITE INITIAL
RC       DC    X'02030A810E'            READ CONTINUE
WC       DC    X'020C098101'            WRITE CONTINUE
RR       DC    X'02040A810E'            READ REPEAT
WA       DC    X'010E'                  WRITE ACKNOWLEDGE
RS       DC    X'010D'                  READ SKIP
WN       DC    X'0101'                  WRITE NEG-ACKNOWLEDGE
WTTV     DC    X'06100F0005070B'        WRITE CONTINUE CONVERSATION000M
WCT      DC    X'021112'                WRITE CONTROL            A27629
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C009980020003'      WR CCC    X                3
         DC    X'010C009920210003'      WR CCC              X      3
         DC    X'010C009880080001'      WR D      X                1
         DC    X'010C009C60020001'      WR Y           X    X      1
         DC    X'010C009D60020001'      WR N           X    X      1
         DC    X'0114040060030002'      WR POLL        X    X      2
         DC    X'0114000060030002'      WR ADRS        X    X      2
         DC    X'0204000080050002'      RD RESP   X                2
         DC    X'0208000000060001'      RD RESP                    1
         DC    X'0208000100200001'      RD RESP                    1
         DC    X'0204000020110400'      RD DATA             X      N
         DC    X'0204000220110402'      RD DATA             X      N-2
         DC    X'0104000060110400'      WR DATA        X    X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C009820210004'      WR DCCC             X      4
         DC    X'0208000160200001'      RD RESP        X   X     1 000M
         DC    X'0138000060110800'      WR DATA        X    X   N  000M
         DC    X'2F00000060010001'      DISABLE        X    X      1
         DC    X'2700000020240001'      ENABLE              X      1
         SPACE 2
CC       EQU   *-C                      SPECIAL CHARACTER OFFSET   000M
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C
         DC    X'76'                    CIRCLE Y
         DC    X'40'                    CIRCLE N
         CNOP  0,8
         END
