         TITLE 'IGG319ME - 1050 NON-SWITCHED WITH AUTOPOLL I/O MODULE'
IGG019ME CSECT
* STATUS -              CHANGE LEVEL   001,     AUGUST 3,1967
         SPACE 2
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 16 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    AL1(WC-A)                WRITE CONTINUE
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    9X'FF'
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'040F05070B810E'        READ INITIAL
WI       DC    X'06000608020C098101'    WRITE INITIAL
RC       DC    X'02030A810E'            READ CONTINUE
WC       DC    X'020C098101'            WRITE CONTINUE
RR       DC    X'02040A810E'            READ REPEAT
WA       DC    X'010E'                  WRITE ACKNOWLEDGE
RS       DC    X'010D'                  READ SKIP
WN       DC    X'0101'                  WRITE NEG-ACKNOWLEDGE
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C008180020003'      WR CCC    X                3
         DC    X'010C008120210003'      WR CCC              X      3
         DC    X'010C008080080001'      WR D      X                1
         DC    X'010C008460020001'      WR Y           X    X      1
         DC    X'010C008560020001'      WR N           X    X      1
         DC    X'0924000060030000'      WR POLL        X    X     LIST
         DC    X'0114000060030002'      WR ADRS        X    X      2
         DC    X'02040000800A0002'      RD INDX   X                2
         DC    X'0208000000060001'      RD RESP                    1
         DC    X'0208000100200001'      RD RESP                    1
         DC    X'0204000020110400'      RD DATA             X      N
         DC    X'0204000220110402'      RD DATA             X      N-2
         DC    X'0104000060110400'      WR DATA        X    X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C008020210004'       WR DCCC            X      4
         DC    X'010C008160020003'      WR CCC         X    X      3
         SPACE 2
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C
         DC    X'76'                    CIRCLE Y
         DC    X'40'                    CIRCLE N
         CNOP  0,8
         END
