         TITLE 'IGG019MF - 1050 SWITCHED DEVICE I/O MODULE'
IGG019MF CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  002   AUGUST  5,1969             000M
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'                 00
         DC    AL1(RI-A)             01 READ INITIAL
         DC    AL1(WI-A)             02 WRITE INITIAL
         DC    AL1(RC-A)             03 READ CONTINUE
         DC    AL1(WC-A)             04 WRITE CONTINUE
         DC    AL1(RV-A)             05 READ CONVERSATIONAL
         DC    AL1(WV-A)             06 WRITE CONVERSATIONAL
         DC    AL1(RR-A)             07 READ REPEAT
         DC    AL1(WA-A)             08 WR ACKNOWLEDGE
         DC    AL1(RS-A)             09 READ-SKIP
         DC    AL1(WN-A)             0A WR NEG-ACKNOWLEDGE
         DC    X'FF'                 0B
         DC    X'FF'                 0C
         DC    X'FF'                 0D
         DC    X'FF'                 0E
         DC    AL1(WTTV-A)           0F WRITE CONTINUE CONVERSATION000M
         DC    8X'FF'                                              000M
         DC    AL1(C-A)
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'070A0907010C0E1182030B'         READ INITIAL
WI       DC    X'090A0907010D0F04131082000B'     WRITE INITIAL
RC       DC    X'02061282030B'                   READ CONTINUE
WC       DC    X'02131082000B'                   WRITE CONTINUE
RV       DC    X'04010C0E1182030B'               READ CONVERSATION
WV       DC    X'06020D0F04131082000B'           WRITE CONVERSATION
RR       DC    X'02051282030B'                   READ REPEAT
WA       DC    X'02030B'                         WRITE ACKNOWLEDGE
WN       DC    X'02000B'                         WRITE NEG-ACKNOWLEDGE
RS       DC    X'0114'                            READ SKIP
WTTV     DC    X'061615010C0E11'        WRITE CONTINUE CONVERSATION000M
         SPACE  3
*                   C C W 'S               I/O      F L A G S
*                                       OPERATION CD   CC   SLI  L=
C        DC    X'010C00B960210001'      WR   C         X    X   1  000M
         DC    X'010C00B980020003'      WR CCC   X               3 000M
         DC    X'010C00B880020004'      WR DCCC   X                000M
         DC    X'010C00B860210002'      WR DC          X    X    I 000M
         DC    X'010C00B880080001'      WR D     X               1 000M
         DC    X'010C00BC60020001'      WR N           X    X    1 000M
         DC    X'010C00BD60020001'      WR Y           X    X    1 000M
         DC    X'010C00BE6001000F'      WR PAD        X    X   15  000M
         DC    X'2700000020010001'      ENABLE              X    1
         DC    X'2910000160010000'      DIAL           X    X    N
         DC    X'2F20000060010001'      DISABLE        X    X    1
         DC    X'2F00000020210001'      DISABLE             X    1
         DC    X'011C040060030002'      WR POLL       X    X    2
         DC    X'011C000060030002'      WR ADRS       X    X    2
         DC    X'0204000080050002'      RD RESP   X              2
         DC    X'0208000000060001'      RD RESP                  1
         DC    X'0208000100200001'      RD RESP                  1
         DC    X'0204000220110402'      RD DATA             X    N-2
         DC    X'0204000020110400'      RD DATA             X    N
         DC    X'0104000060110400'      WR DATA        X    X   N
         DC    X'0200000030220400'      RD-SKIP   SKIP FLAG X    N
         DC    X'0208000160200001'      RD RESP        X   X     1 000M
         DC    X'0138000060110800'      WR DATA        X    X   N  000M
         SPACE 2                                                   000M
CC       EQU   *-C                      SPECIAL CHARACTER OFFSET   000M
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C
         DC    X'40'                    CIRCLE N
         DC    X'76'                    CIRCLE Y
         DC    15X'DF'                  PAD CHARACTER
         CNOP  0,8
         END
