         TITLE 'IGG019MI - IBM 1060 DEVICE I/O MODULE'
IGG019MI CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  001   AUGUST 28,1967             000B
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    9X'FF'                                              000B
         DC    AL1(C-A)                 OFFSETS TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'040005070A8102'        READ INITIAL
WI       DC    X'060006080D0B098101'    WRITE INITIAL
RC       DC    X'040305070A8102'        READ CONTINUE
RR       DC    X'040405070A8102'        READ REPEAT
WA       DC    X'0102'                  WRITE ACKNOWLEDGE
RS       DC    X'010C'                  READ SKIP
WN       DC    X'0101'                  WRITE NEG-ACKNOWLEDGE
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C007180020003'      WR CCC    X                3
         DC    X'010C007120210003'      WR CCC              X      3
         DC    X'010C007420210004'      WR YCCC             X      4
         DC    X'010C007480020004'      WR YCCC   X                1
         DC    X'010C007880020004'      WR NCCC   X                4
         DC    X'0114040060030002'      WR POLL        X    X      2
         DC    X'0114000060030002'      WR ADRS        X    X      2
         DC    X'0204000080050002'      RD RESP   X                2
         DC    X'0208000000060001'      RD RESP                    1
         DC    X'0208000120200001'      RD RESP             X      1
         DC    X'0204000220110402'      RD DATA             X      N-2
         DC    X'0104000060110400'      WR DATA        X    X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C007080080001'     WR D       X                1
         SPACE 2
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C'S
         DC    X'761F1F1F'              CIRCLE Y
         DC    X'401F1F1F'              CIRCLE N
         CNOP  0,8
         END
