         TITLE 'IGG019MN - WESTERN UNION 115A DEVICE I/O MODULE'
IGG019MN CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  001   AUGUST 28,1967             000B
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    AL1(WB-A)           00   WRITE BREAK
         DC    AL1(RI-A)           01   READ INITIAL
         DC    AL1(WI-A)           02   WRITE INITIAL
         DC    X'FF'               03
         DC    X'FF'               04
         DC    X'FF'               05
         DC    X'FF'               06
         DC    X'FF'               07
         DC    X'FF'               08
         DC    X'FF'               09
         DC    AL1(RS-A)           0A   READ SKIP
         DC    X'FF'               0B
         DC    X'FF'               0C
         DC    X'FF'               0D
         DC    X'FF'               0E
         DC    9X'FF'                                              000B
         DC    AL1(C-A)            0F   OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 3
WB       DC    X'0100'                  WRITE BREAK
RI       DC    X'0401030507'            READ INITIAL
WI       DC    X'04010406088102'        WRITE INITIAL
RS       DC    X'0109'                  READ SKIP
         SPACE 2
*                                         I/O       F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'0D00000020230400'      WR BREAK            X      N
         DC    X'010C005080020003'      WR F H L  X                3
         DC    X'010C005020210009'      WR F H L            X      9
         DC    X'0114040060030002'      WR POLL        X    X      2
         DC    X'0114000060030002'      WR ADRS        X    X      2
         DC    X'0204000080050002'      RD RESP   X                2
         DC    X'0208000000060001'      RD RESP                    1
         DC    X'0204000220110402'      RD DATA             X      N-2
         DC    X'0104000020110400'      WR DATA             X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         SPACE 2
         DC    X'1B051F1F1F1F1F1F1F'    FIGS H LTRS
         CNOP  0,8
         END
