         TITLE 'IGG019MT - IBM 2740 (BASIC) DEVICE I/O MODULE'
IGG019MT CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  001   AUGUST 28,1967             000B
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RS-A)                READ SKIP
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'                                             A27629
         DC    AL1(WCT-A)               WRITE CONTROL            A27629
         DC    7X'FF'                                            A27629
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'0406020703'            READ INITIAL               000H
WI       DC    X'0201048100'            WRITE INITIAL
RS       DC    X'0105'                  READ SKIP
WCT      DC    X'020809'                WRITE CONTROL            A27629
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C005020210001'      WR C                X      1
         DC    X'010C005380020010'      WR D IDLE X                16
         DC    X'0600000060010001'      PREPARE        X    X      1
         DC    X'0204000020110400'      RD DATA             X      N
         DC    X'0104000020110400'      WR DATA
         DC    X'0200000030220000'      RD SKIP   SK
         DC    X'010C005060210001'      WR C           X    X      1
         DC    X'0448000060040001'      SENSE          X    X      1
         DC    X'2F00000060010001'      DISABLE        X    X      1
         DC    X'2700000020240001'      ENABLE              X      1
         SPACE 2
         DC    X'1F1F1F'                CIRCLE C'S
         DC    X'16'                   CIRCLE D
         DC    15X'5E'                 15 IDLE CHARACTERS
         CNOP  0,8
         END
