         TITLE 'IGG019MU - 2740 BASIC WITH DIAL FEATURE'
IGG019MU CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  001   AUGUST 28,1967             000B
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'          00
         DC    AL1(RI-A)      01        READ INITIAL
         DC    AL1(WI-A)      02        WRITE INITIAL
         DC    X'FF'         03
         DC    X'FF'         04
         DC    AL1(RV-A)      05        READ CONVERSATIONAL
         DC    AL1(WV-A)      06        WRITE CONVERSATIONAL
         DC    X'FF'         07
         DC    X'FF'         08
         DC    AL1(RS-A)      09        READ SKIP
         DC    AL1(WN-A)      0A        WR NEG-ACKNOWLEDGE
         DC    X'FF'         0B
         DC    X'FF'         0C
         DC    X'FF'         0D
         DC    X'FF'         0E
         DC    9X'FF'                                              000B
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 3
*                   CHANNEL PROGRAMS
RI       DC    X'0408070A04820109'      READ INITIAL
WI       DC    X'050807020003820109'    WRITE INITIAL
RV       DC    X'020A04820109'          READ CONVERSATIONAL
WV       DC    X'020003820109'          WRITE CONVERSATIONAL
RS       DC    X'0105'                  READ SKIP
WN       DC    X'020109'                WRITE NEG-ACKNOWLEDGE
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI     =
C        DC    X'010C005880020001'      WR D      X              1
         DC    X'010C005960210001'      WR C           X    X    1
         DC    X'010C005A6001000F'      WR PAD        X    X   15
         DC    X'0104000020110400'      WR DATA             X    N
         DC    X'0204000020110400'      RD DATA             X    N
         DC    X'0200000030220400'      RD SKIP             X    N
         DC    X'2700000060010001'      ENABLE         X    X    1
         DC    X'2910000160010000'      DIAL           X    X    N
         DC    X'2F20000060010001'      DISABLE        X    X    1
         DC    X'2F00000020210001'      DISABLE             X    1
         DC    X'0600000060010001'      PREPARE        X    X    1
         DC    X'16'                    CIRCLE D
         DC    X'1F'                    CIRCLE C
         DC    15X'DF'                  PAD CHARACTER
         CNOP  0,8
         END
