         TITLE 'IGG019MW - IBM 2740  DIAL AND TRANSMIT CONTROL'
IGG019MW CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  001   AUGUST 28,1967             000B
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RV-A)                READ CONVERSATIONAL
         DC    AL1(WV-A)                WRITE CONVERSATIONAL
         DC    X'FF'
         DC    X'FF'
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    9X'FF'                                              000B
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
         SPACE
RI       DC    X'06050401020708820006'  READ INITIAL
WI       DC    X'050504010B09820006'    WRITE INITIAL
RV       DC    X'03020708820006'        READ CONVERSATIONAL
WV       DC    X'020B09820006'          WRITE CONVERSATIONAL
RS       DC    X'010A'                  READ SKIP
WN       DC    X'020006'                WRITE NEG-ACKNOWLEDGE
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
C        DC    X'010C006060210001'     WR C            X    X      1
         DC    X'010C00616001000F'  WR PAD             X    X     15
         DC    X'010C007060030002'  WR SELECT          X    X      2
         DC    X'2700000020010001'      ENABLE              X      1
         DC    X'2910000160010000'      DIAL           X    X      N
         DC    X'2F20000060010001'      DISABLE        X    X      1
         DC    X'2F00000020210001'      DISABLE             X      1
         DC    X'0204000080050002'      RD RESP   X                2
         DC    X'0204000220110402'      RD DATA             X      N-2
         DC    X'0104000020110400'      WR DATA             X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C007380080001'  WR D          X                1
         SPACE 2
         DC    X'1F'                    CIRCLE C
         DC    15X'DF'                  PAD CHARACTERS
         DC    X'230180'                SLASH, SPACE, END OF LIST
         DC    X'16'                   CIRCLE D
         CNOP  0,8
         END
