         TITLE 'IGG019MX - IBM 2740 DIAL WITH CHECKING'
IGG019MX CSECT
         SPACE 2
         SPACE 2                                                   000M
* STATUS -          CHANGE LEVEL  002   FEBURARY 20, 1969          000M
         SPACE 1                                                   000M
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    AL1(WC-A)                WRITE CONTINUE
         DC    AL1(RV-A)                READ CONVERSATIONAL
         DC    AL1(WV-A)                WRITE CONVERSATIONAL
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    4X'FF'                                              000M
         DC    AL1(WTTV-A)              WRITE CONTINUE CONVERSATION000M
         DC    8X'FF'                                              000M
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'                                              000B
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'0408060F0B820109'      READ INITIAL
WI       DC    X'06080705000C0A820209'  WRITE INITIAL
RC       DC    X'02030B820109'          READ CONTINUE
WC       DC    X'020C0A820209'          WRITE CONTINUE
RV       DC    X'030E0F0B820109'        READ CONVERSATIONAL
WV       DC    X'03000C0A820209'        WRITE CONVERSATIONAL
RR       DC    X'02040B820109'          READ REPEAT
WA       DC    X'020109'                WRITE ACKNOWLEDGE
RS       DC    X'010D'                  READ SKIP
WN       DC    X'020209'                WRITE NEG-ACKNOWLEDGE
WTTV     DC    X'0611120E0F100B'        WRITE CONTINUE CONVERSATION000M
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C009880020001'      WR D      X             1  000M
         DC    X'010C009860210002'      WR D,C         X    X    2 000M
         DC    X'010C009960210001'      WR C           X    X    1 000M
         DC    X'010C009C60020001'      WR Y           X    X    1 000M
         DC    X'010C009D60020001'      WR N           X    X    1 000M
         DC    X'010C009E6001000F'      WR PAD        X    X    15 000M
         DC    X'2700000060010001'      ENABLE         X    X      1
         DC    X'2910000160010000'      DIAL           X    X      N
         DC    X'2F00000060010001'      DISABLE        X    X      1
         DC    X'2F00000020210001'      DISABLE             X      1
         DC    X'0208000100200001'      RD RESP                    1
         DC    X'0204000020110400'      RD DATA             X      N
         DC    X'0104000060110400'      WR DATA             X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C009960020001'      WR C           X    X      1
         DC    X'0600000060010001'      PREPARE        X    X      1
         DC    X'0448000060050001'      SENSE          X    X      000M
         DC    X'0138000060110800'      WR DATA             X      000M
         DC    X'0208000160200001'      RD RESP        X    X    1 000M
         SPACE 2                                                   000M
CC       EQU   *-C                      OFFSET TO CONTROL CHARS.   000M
         SPACE 2
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C
         DC    X'76'                    CIRCLE Y
         DC    X'40'                    CIRCLE N
         DC    15X'DF'                  PAD CHARACTERS
         CNOP  0,8
         END
