         TITLE 'IGG019PB - BTAM WTTA DEVICE I/O MODULE'
IGG019PB CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL 000    MAY 10, 1968
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'          00
         DC    AL1(RI-A)      01        READ INITIAL
         DC    AL1(WI-A)      02        WRITE INITIAL
         DC    AL1(RC-A)      03        READ CONTINUE
         DC    AL1(WC-A)      04        WRITE CONTINUE
         DC    X'FF'          05
         DC    X'FF'          06
         DC    AL1(RCE-A)     07        READ CONTINUE WITH
*                                       IDENTIFICATION EXCHANGE
         DC    X'FF'          08
         DC    X'FF'          09
         DC    X'FF'          0A
         DC    X'FF'          0B
         DC    X'FF'          0C
         DC    X'FF'          0D
         DC    X'FF'          0E
         DC    9X'FF'
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'03000102'
WI       DC    X'03030607'
RC       DC    X'0102'
WC       DC    X'020307'
RCE      DC    X'050304050802'
         SPACE 2
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI     =
C        DC    X'060C004860010001' PREPARE              X     X      1
         DC    X'0448000060010001' SENSE                X     X      1
         DC    X'0204000020110400' READ TEXT                  X LENGTH
         DC    X'0144004860040C01' WRITE PADS CHAR.     X     X    1+M
         DC    X'0144000160040000' WRITE CPU ID.   X          X LENGTH
         DC    X'0144006960040001' WRITE WRU            X     X      1
         DC    X'010C005DA004000C' WRITE LETTERS   X          X     12
         DC    X'0104000020110400' WRITE TEXT                 X LENGTH
         DC    X'0244000120070000' READ TERM. ID.             X LENGTH
         SPACE 2
         DC    X'1F'                    PAD CHARACTER
         DC    20X'DF'                  MARK CHARACTERS
         DC    12X'1F'                  PAD CHARACTERS
         DC    X'32'                    WRU (OR FIG D)
         CNOP  0,8
         END
