         TITLE 'IGG019PC - S/360 MOD 20  DEVICE I/O'
IGG019PC CSECT
         SPACE 2
* STATUS -         CHANGE LEVEL 000    FEBRUARY 27, 1968
         SPACE
* FUNCTION-    THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE.  SPECIAL
*              CONTROL CHARACTERS ARE LOCATED IN THE FIRST 20 BYTES
*              OF THE DCB.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*              THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE.
*              ITS ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE
*              BY OPEN AT OPEN TIME.
         EJECT
A        DC    X'FF'                 00
         DC    AL1(RI-A)             01 READ INITIAL
         DC    AL1(WI-A)             02 WRITE INITIAL
         DC    AL1(RC-A)             03 READ CONTINUE
         DC    AL1(WC-A)             04 WRITE CONTINUE
         DC    X'FF'                 05
         DC    X'FF'                 06
         DC    AL1(RR-A)             07 READ REPEAT
         DC    X'FF'                 08
         DC    X'FF'                 09
         DC    AL1(WN-A)             0A WRITE RESET
         DC    X'FF'                 0B
         DC    AL1(WIXB-A)           0C WRITE INIT XPARENT BLOCK
         DC    AL1(WIC-A)            0D WRITE INIT CONV
         DC    AL1(WCXB-A)           0E WRITE CONT XPARENT BLOCK
         DC    AL1(WCC-A)            0F WRITE CONTIN CONV
         DC    X'FF'                 10
         DC    X'FF'                 11
         DC    AL1(WIX-A)            12 WRITE INIT XPARENT
         DC    AL1(RCL-A)            13 READ CONT W/ LEAD GRAPH
         DC    AL1(WCX-A)            14 WRITE CONTIN XPARENT
         DC    AL1(RQ-A)             15 READ INQUIRY
         DC    AL1(WQ-A)             16 WRITE INQUIRY
         DC    AL1(RRL-A)               17 READ REPEAT W/ LEAD GRAPH
         DC    AL1(C-A)              18 OFFSET TO CCW'S
         DC    X'FF'                 19
         DC    AL1(WW-A)             1A WRITE WAIT BEFORE XMIT
         DC    AL1(RVI-A)            1B READ INTERRUPT
         DC    X'FF'                 1C
         DC    AL1(WICX-A)           1D WRITE INIT CONV XPRNT
         DC    X'FF'                 1E
         DC    AL1(WCCX-A)           1F WRITE CONT CONV XPRNT
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'0400010203'            READ INITIAL
WI       DC    X'0504050607088109'      WRITE INITIAL
RC       DC    X'020A0B'                READ CONTINUE
WC       DC    X'0207088109'            WRITE CONTINUE
RR       DC    X'020C0B'                READ REPEAT
WN       DC    X'0109'                  WRITE RESET
WIC      DC    X'060405060D0E0F'        WRITE INITIAL CONVERS
WCC      DC    X'030D0E0F'              WRITE CONTIN CONVERS
WIX      DC    X'060405060710088109'    WRITE INITIAL XPARENT
RCL      DC    X'03120A0B'             READ CONTIN W/ LEAD GRAPG   000J
WCX      DC    X'030710088109'          WRITE CONTINUE XPARENT
RQ       DC    X'0113'                 READ INQUIRY                000J
WQ       DC    X'03140E0F'              WRITE INQUIRY            A32454
WW       DC    X'021513'               WRITE WAIT BEFORE XMIT      000J
RVI      DC    X'02110B'               READ INTERRUPT              000J
WICX     DC    X'070405060D100E0F8109'  WRITE INIT CONV XPARENT
WCCX     DC    X'040D100E0F'            WRITE CONTIN CONV XPARENT
WIXB     DC    X'06040506071608'        WRITE INIT XPARENT BLOCK
WCXB     DC    X'03071608'              WRITE CONT XPARENT BLOCK
RRL      DC    X'03120C0B'              READ REPEAT W/ LEAD GRAPH
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'0928004860020001'     WR EOT          X    X      1 0J
         DC    X'0924000060030001'      POLL           X    X     M2642
         DC    X'02040000800A0002'      RD INDX   X                2
         DC    X'0204000220110402'      RD TXT              X     N-2
         DC    X'0128004860020001'     WR EOT          X    X      1 0J
         DC    X'0114000060030000'      WR ADRS        X    X      N
         DC    X'0240000020060002'      RD RESP             X      2
         DC    X'0104000060110400'      WR TXT         X    X      N
         DC    X'0208000020250002'      RD RESP             X      2
         DC    X'0128004820210001'      WR EOT              X      1
         DC    X'0134004060080002'      WR RESP        X    X      2
         DC    X'0204000020110400'      RD TXT              X      N
         DC    X'0128004560080001'      WR NACK        X    X      1
         DC    X'0138000060110800'      WR TXT         X    X      N
         DC    X'02040000A0250C14'      RD RESP   X         X      20
         DC    X'0204001420110414'      RD TXT              X     N-20
         DC    X'0128003E60130002'      WR DLEETX      X    X      2
         DC    X'0128005060080002'      WR RVI         X    X      2
         DC    X'013C000080010800'      WR GRAPH  X                N
         DC    X'02080000200B0002'      RD INQ              X      2
         DC    X'0128004460030001'      WR INQ         X    X      1
         DC    X'0128004E60010002'     WR WACK         X    X      2 0J
         DC    X'0128004A60130002'      WR DLEETB      X    X      2
         CNOP  0,8
         END
