         TITLE 'IGG019PF - 2741 SWITCHED DEVICE I/O MODULE'
IGG019PF CSECT
         SPACE 2
* STATUS -     CHANGE LEVEL 000    23 OCTOBER 1968
         SPACE
* FUNCTION-    THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE.  FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
          SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*              THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE.
*              ITS ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE
*              BY OPEN AT OPEN TIME.
          EJECT
A        DC    X'FF'                 00
         DC    AL1(RI-A)             01 READ INITIAL
         DC    X'FF'                 02
         DC    AL1(RC-A)             03 READ CONTINUE
         DC    AL1(WC-A)             04 WRITE CONTINUE
         DC    AL1(RV-A)             05 READ CONVERSATIONAL
         DC    AL1(WV-A)             06 WRITE CONVERSATIONAL
         DC    X'FF'                 07
         DC    X'FF'                 08
         DC    AL1(RS-A)             09 READ SKIP
         DC    AL1(WN-A)             0A WRITE DISCONNECT
         DC    X'FF'                 0B
         DC    X'FF'                 0C
         DC    X'FF'                 0D
         DC    X'FF'                 0E
         DC    AL1(WTV-A)            0F WRITE CONTINUE CONVERSATIONAL
         DC    X'FF'                 10
         DC    X'FF'                 11
         DC    X'FF'                 12
         DC    X'FF'                 13
         DC    X'FF'                 14
         DC    X'FF'                 15
         DC    X'FF'                 16
         DC    X'FF'                 17
         DC    AL1(C-A)              18 OFFSET TO CCW'S
         DC    X'FF'                 19
         DC    X'FF'                 1A
         DC    X'FF'                 1B
         DC    X'FF'                 1C
         DC    X'FF'                 1D
         DC    X'FF'                 1E
         DC    X'FF'                 1F
         SPACE 2
RI       DC    X'0408070004'            READ INITIAL
RV       DC    X'03010004'              READ CONVERSATIONAL
RC       EQU   RV                       READ CONTINUE
WC       DC    X'0105'                  WRITE CONTINUE
WV       DC    X'020205'                WRITE CONVERSATIONAL
RS       DC    X'0106'                  READ SKIP
WTV      DC    X'0403010004'            WRITE CONTINUE CONVERSATIONAL
WN       DC    X'0109'                  WRITE DISCONECT
          SPACE 3
C        DS    0X
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
         DC    X'0600000060010001'   0  PREP           X    X      1
         DC    X'010C005060020001'   1  WR C           X    X      1
         DC    X'010C005180020001'   2  WR D      X                1
         DC    X'0138000060110800'   3  WR WAREA       X    X     WN
         DC    X'0A04000020110400'   4  INHIBIT             X      N
         DC    X'0104000020110400'   5  WR TEXT             X      N
         DC    X'0A00000030220400'   6  INHIBIT   SKIP FLAG X      N
         DC    X'2700000060010001'   7  ENABLE         X    X       1
         DC    X'2F00000060010001'   8  DISABLE        X    X       1
         DC    X'2F00000020210001'   9  DISABLE             X       1
         SPACE 2
CC       EQU   *-C                 OFFSET TO FIRST CONTROL CHARACTER
         SPACE
         DC    X'1F'                 EOT (CIRCLE C)
         DC    X'16'                 EOA (CIRCLE D)
         CNOP   0,8
         END
