         TITLE ' IGG019PH - LOCAL 3270 DEVICE I/O MODULE '
IGG019PH CSECT
***********************************************************************
*                     LOCAL 3270 DEVICE I/O MODULE                    *
***********************************************************************
*                                                                     *
* STATUS:                                                             *
*    CHANGE LEVEL 001         SEPT 30,1977                            *
*                                                                     *
* FUNCTION:                                                           *
*    THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE DEPENDENT     *
*    VARIABLE INFORMATION NEEDED BY BTAM READ/WRITE ROUTINE           *
*    (IGG019MA) TO PREPARE THE CHANNEL PROGRAM.                       *
*                                                                     *
*    EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE CHANNEL     *
*    COMMAND WORD OFFSETS FOR EACH TYPE OF I/O OPERATION. IF THE      *
*    OPERATION IS INVALID FOR THE LOCAL 3270, THE BYTE CONTAINS THE   *
*    VALUE X'FF'.                                                     *
*                                                                     *
*    FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT CCW'S THAT    *
*    ARE USED BY THE LOCAL 3270.                                      *
*                                                                     *
*    EXAMPLE OF CCW OFFSETS (IE. CONDENSED CHANNEL PROGRAM);          *
*    DC  X'0403050906                                                 *
*    04 - COUNT OF CCW'S                                              *
*    03,05,09,06 - CCW'S 3,5,9,6 COMPRISE CHANNEL PROGRAM             *
*                                                                     *
*    THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS ADDRESS   *
*    IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN AT OPEN TIME. *
*                                                                     *
* ENTRY:                                                              *
*         NONE                                                        *
*                                                                     *
* INPUT:                                                              *
*    NONE                                                             *
*                                                                     *
* OUTPUT:                                                             *
*    NONE                                                             *
*                                                                     *
* EXTERNAL REFERENCES:                                                *
*         NONE                                                        *
*                                                                     *
* EXITS, NORMAL:                                                      *
*         NONE                                                        *
*                                                                     *
* EXITS, ERROR:                                                       *
*         NONE                                                        *
*                                                                     *
* TABLES/WORK AREAS:                                                  *
*    NONE                                                             *
*                                                                     *
* ATTRIBUTES:                                                         *
*    RESIDENT, ONLY LOADABLE, NOT EDITABLE.                           *
*                                                                     *
* CHARACTER CODE DEPENDENCY:                                          *
*    NONE                                                             *
*                                                                     *
***********************************************************************
         EJECT
*
*    TABLE OF OFFSETS
*
A        DC    X'FF'               00
         DC    AL1(RI-A)           01 READ INITIAL
         DC    AL1(WI-A)           02 WRITE INITIAL
         DC    X'FF'               03
         DC    X'FF'               04
         DC    X'FF'               05
         DC    AL1(WEA-A)          06 WRITE ERASE ALTERNATE     ZA25924
         DC    X'FF'               07
         DC    X'FF'               08
         DC    X'FF'               09
         DC    X'FF'               0A
         DC    AL1(RB-A)           0B READ BUFFER
         DC    X'FF'               0C
         DC    X'FF'               0D
         DC    AL1(WE-A)           0E WRITE ERASE
         DC    X'FF'               0F
         DC    X'FF'               10
         DC    AL1(RI-A)           11 READ MODIFIED
         DC    AL1(WUE-A)          12 WRITE UNPROTECTED ERASE
         DC    AL1(RBP-A)          13 READ BUFFER FROM POSITION
         DC    X'FF'               14
         DC    X'FF'               15
         DC    X'FF'               16
         DC    X'FF'               17
         DC    AL1(C-A)            18 OFFSET TO CCW'S
         DC    AL1(RMP-A)          19 READ MODIFIED FROM POSITION
         DC    X'FF'               1A
         DC    X'FF'               1B
         DC    X'FF'               1C
         DC    X'FF'               1D
         DC    X'FF'               1E
         DC    X'FF'               1F
*
*    CHANNEL PROGRAM OFFSETS
*
RI       DC    X'020001'           READ INITIAL/READ MODIFIED
WI       DC    X'020004'           WRITE INITIAL
RB       DC    X'020002'           READ BUFFER
WE       DC    X'0105'             WRITE ERASE
WUE      DC    X'020607'           WRITE UNPROTECTED ERASE
RBP      DC    X'03000302'         READ BUFFER FROM POSITION
RMP      DC    X'03000301'         READ MODIFIED FROM POSITION
WEA      DC     X'0108'            WRITE ERASE ALTERNATE        ZA25924
*                 CCW'S              I/O               FLAGS LENGTH
*                                 OPERATION           CC SLI =
*
C        DC    X'0B04000060000001'  SELECT              X  X 1
         DC    X'0604000020000400'  RD MODIFIED            X N
         DC    X'0204000020000400'  RD BUFFER              X N
         DC    X'0164000060000004'  WRITE               X  X 4
         DC    X'0104000020000400'  WRITE                  X N
         DC    X'0504000020000400'  ERASE/WRITE            X N
         DC    X'0F00000060000001'  ERASE ALL UNPRO     X  X 1
         DC    X'0300000020000001'  NOP                    X 1
         DC    X'0D04000020000400'  WRITE ERASE ALTERNATE  X N  ZA25924
         CNOP  0,8
         END
