         TITLE 'IGG019PM - IBM 2740 CHECKING,OIU,DIAL'
IGG019PM CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  001   AUGUST 28,1967             000B
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    AL1(WC-A)                WRITE CONTINUE
         DC    AL1(RV-A)                READ CONVERSATIONAL
         DC    AL1(WV-A)                WRITE CONVERSATIONAL
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    X'FF'
         DC    AL1(WTIO-A)              WRITE INITIAL OPTICAL
         DC    AL1(RTTA-A)              READ CONTINUE W LEADING ACKN.
         DC    AL1(WTCO-A)              WRITE INVITATIONAL OPTICAL
         DC    X'FF'
         DC    X'FF'
         DC    X'FF'
         DC    AL1(WTVO-A)              WRITE CONVERSATIONAL OPT.
         DC    5X'FF'
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'0508060F100B820109'    READ INITIAL
WI       DC    X'06080705000C0A820209'  WRITE INITIAL
RC       DC    X'02030B820109'          READ CONTINUE
WC       DC    X'020C0A820209'          WRITE CONTINUE
RV       DC    X'040E0F100B820109'      READ CONVERSATIONAL
WV       DC    X'03000C0A820209'        WRITE CONVERSATIONAL
RR       DC    X'02040B820109'          READ REPEAT
WA       DC    X'020109'                WRITE ACKNOWLEDGE
RS       DC    X'010D'                  READ SKIP
WN       DC    X'020209'                WRITE NEG-ACKNOWLEDGE
WTIO     DC    X'080807051113121516'    WRITE INITIAL OPTICAL
RTTA     DC    X'04010F100B'            READ CONTINUE W LEADING ACKN.
WTCO     DC    X'08111412150E0F100B'    WRITE INVITATIONAL OPTICAL
WTVO     DC    X'051114121516'          WRITE CONVERSATIONAL OPT.
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C00B880020001'      WR D      X              1
         DC    X'010C00B860210004'      WR D,CCC       X    X    4
         DC    X'010C00B960210003'      WR CCC         X    X    3
         DC    X'010C00BC60020001'      WR Y           X    X    1
         DC    X'010C00BD60020001'      WR N           X    X    1
         DC    X'010C00C26001000F'      WR PAD        X    X    15
         DC    X'2700000060010001'      ENABLE         X    X    1
         DC    X'2910000160010000'      DIAL           X    X    N
         DC    X'2F00000060010001'      DISABLE        X    X    1
         DC    X'2F00000020210001'      DISABLE             X    1
         DC    X'0208000100200001'      RD RESP                  1
         DC    X'0204000020110400'      RD DATA             X    N
         DC    X'0104000060110400'      WR DATA             X    N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X    N
         DC    X'010C00B960020003'      WR CCC         X    X    3
         DC    X'0600000060010001'      PREPARE        X    X    1
         DC    X'0448000060040001'      SENSE          X    X    1
         DC    X'010C00BE80020003'      WR DPRE O X              3
         DC    X'010C00C160080001'      WR B           X    X    1
         DC    X'0154000080110003'      WR FRAME  X              3
         DC    X'0150000080110003'      WR FRAME  X              3
         DC    X'0208000160200001'      RD RESP        X    X    1
         DC    X'010C00B920210003'      WR CCC              X    3
         SPACE 2
CC       EQU   *-C                      OFFSET TO CONTROL CHARS.
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C
         DC    X'76'                    CIRCLE Y
         DC    X'40'                    CIRCLE N
         DC    X'163E4C'                CIRCLE D PRE O
         DC    X'3D'                    CIRCLE B
         DC    15X'DF'                  PAD CHARACTERS
         CNOP  0,8
         END
