         TITLE 'IGG019PP - IBM 2740X(CHECKING)'
IGG019PP CSECT
         SPACE 2
* STATUS -          CHANGE LEVEL  000   FEBURARY 20, 1969
         SPACE
*FUNCTION -
*              THE DEVICE INPUT/OUTPUT MODULE PROVIDES THE DEVICE
*              DEPENDENT VARIABLE INFORMATION NEEDED BY THE BTAM
*              READ/WRITE ROUTINE TO PREPARE THE TELE-PROCESSING
*              CHANNEL PROGRAMS.
         SPACE 2
*              EACH OF THE FIRST 32 BYTES CONTAINS AN OFFSET TO THE
*              CHANNEL COMMAND WORD OFFSETS FOR EACH TYPE OF I/O
*              OPERATION.
         SPACE 2
*              FOLLOWING THE CCW OFFSETS ARE ALL OF THE DIFFERENT
*              CCW'S THAT ARE USED BY THIS DEVICE TYPE. FOLLOWING
*              THE CCW'S ARE THE NECESSARY SPECIAL CONTROL CHARACTERS.
         SPACE 4
*              EXAMPLE OF CCW OFFSETS (I.E. CONDENSED CHANNEL PROGRAM)
         SPACE
*                   DC   X'0403050906820008'
         SPACE
*                        04 = COUNT OF CCW'S
*               03,05,09,06 = CCW'S 3,5,9 & 6 COMPRISE CHANNEL PROGRAM
*                        82 = COUNT OF RESET FUNCTION CCW'S (0 BIT = 1
*                             INDICATES RESET)
*                     00,08 = CCW'S 0 & 8 COMPRISE RESET CHANNEL PROG.
         SPACE 4
*        THE DEVICE I/O MODULE CONTAINS NO EXECUTABLE CODE. ITS
*        ADDRESS IS LOADED INTO THE BTAM READ/WRITE ROUTINE BY OPEN
*        AT OPEN TIME.
         EJECT
A        DC    X'FF'
         DC    AL1(RI-A)                READ INITIAL
         DC    AL1(WI-A)                WRITE INITIAL
         DC    AL1(RC-A)                READ CONTINUE
         DC    AL1(WC-A)                WRITE CONTINUE
         DC    X'FF'
         DC    AL1(WV-A)                WRITE CONVERSATIONAL
         DC    AL1(RR-A)                READ REPEAT
         DC    AL1(WA-A)                WRITE ACKNOWLEDGE
         DC    AL1(RS-A)                READ SKIP
         DC    AL1(WN-A)                WRITE NEG-ACKNOWLEDGE
         DC    4X'FF'
         DC    AL1(WTTV-A)              WRITE CONTINUE CONVERSATIONAL0J
         DC    8X'FF'                                              000J
         DC    AL1(C-A)                 OFFSET TO CCW'S
         DC    7X'FF'
         SPACE 2
*                   CHANNEL PROGRAMS
RI       DC    X'040B060C088101'        READ INITIAL
WI       DC    X'030509078102'          WRITE INITIAL
RC       DC    X'0203088101'            READ CONTINUE
WC       DC    X'0209078102'            WRITE CONTINUE
WV       DC    X'030009078102'          WRITE CONVERSATIONAL
RR       DC    X'0204088101'            READ REPEAT
WA       DC    X'0101'                  WRITE ACKNOWLEDGE
RS       DC    X'010A'                  READ SKIP
WN       DC    X'0102'                  WRITE NEG-ACKNOWLEDGE
WTTV     DC    X'060D0E0B060C08'        WRITE CONTINUE CONVERSATION
         SPACE 3
*                   C C W 'S               I/O      F L A G S    LENGTH
*                                       OPERATION CD   CC   SLI    =
C        DC    X'010C007880020001'      WR D      X              1
         DC    X'010C007820210004'      WR DCCC             X    4
         DC    X'010C007920210003'      WR CCC              X    3
         DC    X'010C007C60020001'      WR Y           X    X    1
         DC    X'010C007D60020001'      WR N           X    X    1
         DC    X'010C007E80020010'      WR D+IDLE X             16
         DC    X'0600000060010001'      PREPARE        X    X      1
         DC    X'0208000100200001'      RD RESP                    1
         DC    X'0A04000020110400'      INHIBIT             X
         DC    X'0104000060110400'      WR DATA        X    X      N
         DC    X'0200000030220400'      RD SKIP   SKIP FLAG X      N
         DC    X'010C007960020003'      WR CCC         X    X    3
         DC    X'0448000060050001'      SENSE          X    X
         DC    X'0138000060110800'      WR DATA             X      N
         DC    X'0208000160200001'      RD RESP        X    X    1
         SPACE 2
CC       EQU   *-C                      OFFSET TO CONTROL CHARS.
         DC    X'16'                    CIRCLE D
         DC    X'1F1F1F'                CIRCLE C'S
         DC    X'76'                    CIRCLE Y
         DC    X'40'                    CIRCLE N
         DC    X'165E5E5E5E5E5E5E5E5E5E5E5E5E5E5E' CIRCLE D, 15 IDLES
         CNOP  0,8
         END
