         TITLE 'IGG020T1 - SAM/PAM/DAM FORCE CLOSE EXECUTOR            *
                        '
IGG020T1 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(25)                                             0001
         DC    C'IGG020T1 ZA00415 11/04/74'                        0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@03                                         0001
*     */                                                           0123
*/*********************************************************************
*/* INITIALIZATION                                                    *
*/*********************************************************************
*                                                                  0124
* WRKSAV13 = GPR13P;                    /*SAVE REG SAVE AREA ADDR     *
*                                                                  0124
         ST    GPR13P,WRKSAV13(,RRECWKAR)                          0124
* RFY PARMLPTR RSTD;                                               0125
* RFY IECRRPL BASED(PARMLPTR);          /*ADDRESS TO RR PARM LIST     *
*/*********************************************************************
*/*MUST DETERMINE 2 THINGS:                                           *
*/*  1. IF FORCE CLOSE SHOULD BE EXECUTED-                            *
*/*     THE ONLY YES CONDITIONS ARE IF THE ERROR OCCURED DURING A     *
*/*     STANDARD OPEN OR AN OPEN TYPE = J. IF NOT, RETURN TO COMMON   *
*/*     CLOSES TRR.                                                   *
*/*  2. IF ABOVE CONDITIONS ARE MET THEN IT IS NECESSARY TO KNOW      *
*/*     IF THE USERS COPY OF THE DCB HAS BEEN REFRESHED. IF NOT,      *
*/*     EXECUTE THIS ROUTINE. IF YES, XCTL TO NORMAL CLOSE EXECUTORS. *
*/*********************************************************************
*                                                                  0127
*              /*******************************************************
*              /*MAKE TESTS OF RECOVERY ROUTINE PARAMETER LIST FOR    *
*              /*AN OPEN SVC (SET UP BY O/C/E AT THE TIME THE ESTAE   *
*              /*WAS ISSUED) TO DETERMINE IF THIS IS A FORCE CLOSE    *
*              /*SITUATION THAT CAN BE HANDLED BY THE ACCESS METHODS. *
*              /*IF NO PROCESSING IS TO BE DONE, GO TO THE EXIT       *
*              /*ROUTINE.                                             *
*              /*******************************************************
*                                                                  0127
* IF RRFUNCTN ^= RRFOPENJ               /*IF SVC IS NOT EQUAL TO 22   *
*   & RRFUNCTN ^= RRFOPEN THEN          /* OR IF SVC IS NOT EQUAL 19  *
         CLI   RRFUNCTN(PARMLPTR),X'16'                            0127
         BE    @RF00127                                            0127
         CLI   RRFUNCTN(PARMLPTR),X'13'                            0127
         BNE   @RT00127                                            0127
*   GOTO EXITRTN;                       /* EXIT THIS ROUTINE          *
* ELSE;                                 /*TEST FURTHER                *
*                                                                  0129
@RF00127 DS    0H                                                  0130
*              /*******************************************************
*              /*THE SECOND WORD OF THE AUDIT TRAIL IS USED AS  YM4697*
*              /*A COMMUNICATIONS AREA BETWEEN THE OPEN EXECS   YM4697*
*              /*AND THIS FORCE CLOSE EXEC. THE 2ND STAGE EXECS YM4697*
*              /*SAVE THE AMOUNT OF CORE GETMAINED FOR THE      YM4697*
*              /*IOB'S/ICB'S AND IGG01911 SAVES THE ADDRESS OF  YM4697*
*              /*THE WORKAREA PASSED TO THE ACCESS METHOD RTNS  YM4697*
*              /*WHEN PRIMEING BUFFERS.                         YM4697*
*              /*******************************************************
*                                                                  0130
* WRKAUDSV = DXATEXC2;                  /*SAVE INFO PASSED BY   YM4697
*                                          OPEN EXECUTORS       YM4697*
         MVC   WRKAUDSV(4,RRECWKAR),DXATEXC2(RCORE)                0130
* DXATEXC2 = 0;                         /*CLEAR AUDIT TRAIL     YM4697*
*                                                                  0131
         SLR   @12,@12                                             0131
         ST    @12,DXATEXC2(,RCORE)                                0131
*              /*******************************************************
*              /*ERROR DID OCCUR DURING OPEN THEREFOR IT IS           *
*              /*NECESSARY TO TEST AUDIT TRAIL BITS SET BY OPEN       *
*              /*EXECUTORS TO SEE IF DCB HAS BEEN REFRESHED.          *
*              /*******************************************************
*                                                                  0132
*  IF FCAOCOPY = SWON THEN              /*DCB HAS BEEN REFRESHED,     *
         TM    FCAOCOPY(RCORE),B'10000000'                         0132
         BO    @RT00132                                            0132
*    GOTO XCTLRTN;                      /*   GO TO NORMAL CLOSE EXECS *
*  ELSE;                                /*DCB HAS NOT BEEN REFRESHED,
*                                           PROCESS IN THIS ROUTINE   *
*  RFY PARMLPTR UNRSTD;                                            0135
*                                                                  0135
*              /*******************************************************
*              /*TEST FOR BDAM. IF YES, GO TO BDAM SECTION AS         *
*              /*PROCESSING WILL BE DIFFERENT THAN FOR SAM/PAM.       *
*              /*******************************************************
*                                                                  0136
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0136
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0137
         SLR   @12,@12                                             0137
         IC    @12,DXUKEY(,RCORE)                                  0137
         SPKA  0(@12)                                              0137
*    END; /*MODESET  KEYADDR(DXUKEY)*/         /*USER KEY TO FREE USER
*ORE  */                                                           0138
*                                                                  0138
* IF DCBDSGDA = SWON THEN               /*TEST FOR SAM/PAM VS DAM     *
         TM    DCBDSGDA+16(DCBPTR),B'00100000'                     0139
         BO    @RT00139                                            0139
*   GOTO BDAMRTN;                       /*GO PROCESS BDAM DATA SETS   *
* ELSE;                                 /*IF SAM/PAM, FALL THROUGH    *
*/*********************************************************************
*/*PROCESS SAM/PAM DATA SETS IN THIS ROUTINE. RESOURCES TO BE FREED   *
*/*OR RESTORED ARE:                                                   *
*/*   1. RECORD AREA                                                  *
*/*   2. BUFFER POOL CONTROL BLOCK AND BUFFER POOL                    *
*/*   3. IOB'S/ICB'S                                                  *
*/*   4. SEGMENT WORKAREA                                             *
*/*   5. DELETE IGGMSG01 (MESSAGE CSECT) IF LOADED.                   *
*/*   6. DELETE ANY UCSB/FCB IMAGES LOADED AND NOT DELETED.     YM4697*
*/*   7. ISSUE CLOSE FOR SYS1.IMAGELIB IF OPENED BUT NOT CLOSED.YM4697*
*/*********************************************************************
*                                                                  0142
* IF DCBCNQSM = SWOFF THEN              /*IF NOT QSAM GO FREE IOBS    *
         TM    DCBCNQSM+52(DCBPTR),B'00000001'                     0142
         BZ    @RT00142                                            0142
*   GOTO SAMIOB;                                                   0143
* ELSE                                                             0144
*   IF DCBCNEXB = SWON THEN             /*IF EXCHANGE BUFFERING YM7595*
         TM    DCBCNEXB+52(DCBPTR),B'00000001'                     0144
         BO    @RT00144                                            0144
*     GOTO SAMIOB;                      /* BYPASS BUFF LOGIC    YM7595*
*   ELSE;                                                          0146
*                                                                  0146
*              /*******************************************************
*              /*THE FIRST CHECK WILL BE FOR A LOGICAL RECORD AREA.   *
*              /*IF PRESENT, IT MUST BE FREEMAINED.                   *
*              /*******************************************************
*                                                                  0147
* RFY BCBPTR RSTD;                                                 0147
* RFY BCBLK BASED(BCBPTR);                                         0148
* BCBPTR = DCBBUFCA;                    /*ADDR OF BUFFER C.B.  ZA00415*
*                                                                  0149
         SLR   BCBPTR,BCBPTR                                       0149
         ICM   BCBPTR,7,DCBBUFCA+16(DCBPTR)                        0149
* IF FCAORECA = SWON THEN               /*TEST TO SEE IF REC AREA  0150
*                                             GOTTEN BY OPEN EXECS    *
         TM    FCAORECA(RCORE),B'00000010'                         0150
         BNO   @RF00150                                            0150
*   DO;                                 /*IF YES, FREEMAIN AREA       *
*   RFY LRIAREA BASED(RECARPTR);                                   0152
*   RFY RECARPTR RSTD;                                             0153
*   RECARPTR = BCBLRIAD;                /*ADDR OF RECORD AREA  ZA00415*
*                                                                  0154
         SLR   RECARPTR,RECARPTR                                   0154
         ICM   RECARPTR,7,BCBLRIAD(BCBPTR)                         0154
*                                       /*ISSUE FREEMAIN              *
*    DO; /*FREEMAIN(R) LV(LRILNGTH)SP(0)A(LRIAREA)*/               0155
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0156
*    GPR00F = LRILNGTH; /* LENGTH REQUESTED*/                      0157
         SLR   GPR00F,GPR00F                                       0157
         ICM   GPR00F,7,LRILNGTH(RECARPTR)                         0157
*    GPR01F = 0; /* SP IN REG 1 */                                 0158
         SLR   GPR01F,GPR01F                                       0158
*    GEN   (SLL   GPR01F,24)                                       0159
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0159
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0160
         OR    GPR00F,GPR01F                                       0160
*    GPR01F=ADDR(LRIAREA); /*SET REGISTER ONE*/                    0161
         LR    GPR01F,RECARPTR                                     0161
*    SVC(10); /* R-FORM OF GETMAIN*/                               0162
         SVC   10                                                  0162
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0163
*    END; /*FREEMAIN(R) LV(LRILNGTH)SP(0)A(LRIAREA)*/              0164
*                                                                  0164
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0165
*      SPKA (80); /*SET PSW KEY*/                                  0166
         LA    @01,80                                              0166
         SPKA  0(@01)                                              0166
*    END; /*MODESET  EXTKEY(DATAMGT)*/          /*AUDIT TRAIL IN KEY 5
*      */                                                          0167
*                                                                  0167
*   FCACRECA = SWON;                    /*INDICATE RECORD AREA FREED  *
*                                                                  0168
         OI    FCACRECA(RCORE),B'01000000'                         0168
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0169
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0170
         SLR   @01,@01                                             0170
         IC    @01,DXUKEY(,RCORE)                                  0170
         SPKA  0(@01)                                              0170
*    END; /*MODESET  KEYADDR(DXUKEY)*/                             0171
*                                                                  0171
*   RFY RECARPTR UNRSTD;                                           0172
*   END;                                                           0173
* ELSE;                                                            0174
*                                                                  0174
@RF00150 DS    0H                                                  0175
*              /*******************************************************
*              /*THE NEXT CHECK IS TO SEE IF THE OPEN EXECUTORS       *
*              /*GETMAINED BUFFERS. IF YES, AND THE USER SPECIFIED    *
*              /*CONCATINATION OF UNLIKE ATTRIBUTES, THEY MUST BE     *
*              /*FREEMAINED.                                          *
*              /*******************************************************
*                                                                  0175
* IF DCBOFEOV = SWOFF |                 /*TEST FOR CONCAT UNLIK YM7595*
*    FCAOBUF = SWOFF THEN               /*WAS A BUF POOL GOTTEN YM7595*
         TM    DCBOFEOV+40(DCBPTR),B'00100000'                     0175
         BZ    @RT00175                                            0175
         TM    FCAOBUF(RCORE),B'00100000'                          0175
         BZ    @RT00175                                            0175
*                                       /*  FOR THIS OPEN       YM7595*
*    GOTO SAMBUFLN;                     /*NO, GO RELINK BUFS    YM7595*
* ELSE;                                                            0177
*                                                                  0177
*SAMBUFFR:;                                                        0178
*                                                                  0178
SAMBUFFR DS    0H                                                  0179
*              /*******************************************************
*              /*THE AMOUNT TO FREEMAIN IS BUFFER LENGTH TIMES THE    *
*              /*NUMBER OF BUFFERS PLUS THE BUFFER CONTROL BLOCK LEN  *
*              /*(8 IF NOT EXTENDED, 16 IF EXTENDED)                  *
*              /*******************************************************
*                                                                  0179
* RFY RWORK2 RSTD;                                                 0179
* RWORK2 = BCBBUFNO * BCBBUFSZ + 8;     /*LEN TO FREE IF NOT EXTENDED *
*                                                                  0180
         SLR   @01,@01                                             0180
         ICM   @01,3,BCBBUFSZ(BCBPTR)                              0180
         SLR   RWORK2,RWORK2                                       0180
         IC    RWORK2,BCBBUFNO(,BCBPTR)                            0180
         MR    @00,RWORK2                                          0180
         AH    @01,@CH00040                                        0180
         LR    RWORK2,@01                                          0180
* IF FCAOXTND = SWON THEN               /*LENGTH TO FREEMAIN          *
         TM    FCAOXTND(RCORE),B'00000001'                         0181
         BNO   @RF00181                                            0181
*   RWORK2 = RWORK2 + 8;                /*  IF EXTENDED BCB           *
         AH    RWORK2,@CH00040                                     0182
* ELSE;                                 /*ISSUE FREEMAIN              *
*                                                                  0183
@RF00181 DS    0H                                                  0184
*    DO; /*FREEMAIN(R) LV(RWORK2)SP(0)A(BCBLK)*/                   0184
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0185
*    GPR00F = RWORK2; /* LENGTH REQUESTED*/                        0186
         LR    GPR00F,RWORK2                                       0186
*    GPR01F = 0; /* SP IN REG 1 */                                 0187
         SLR   GPR01F,GPR01F                                       0187
*    GEN   (SLL   GPR01F,24)                                       0188
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0188
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0189
         OR    GPR00F,GPR01F                                       0189
*    GPR01F=ADDR(BCBLK); /*SET REGISTER ONE*/                      0190
         LR    GPR01F,BCBPTR                                       0190
*    SVC(10); /* R-FORM OF GETMAIN*/                               0191
         SVC   10                                                  0191
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0192
*    END; /*FREEMAIN(R) LV(RWORK2)SP(0)A(BCBLK)*/                  0193
*                                                                  0193
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0194
*      SPKA (80); /*SET PSW KEY*/                                  0195
         LA    @01,80                                              0195
         SPKA  0(@01)                                              0195
*    END; /*MODESET  EXTKEY(DATAMGT)*/         /*AUDIT TRAIL IN KEY 5
*     */                                                           0196
*                                                                  0196
* FCACBUFC = SWON;                      /*INDIC BUFFERS FREED         *
*                                                                  0197
         OI    FCACBUFC(RCORE),B'00100000'                         0197
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0198
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0199
         SLR   @01,@01                                             0199
         IC    @01,DXUKEY(,RCORE)                                  0199
         SPKA  0(@01)                                              0199
*    END; /*MODESET  KEYADDR(DXUKEY)*/                             0200
*                                                                  0200
* GOTO SAMIOB;                          /*BYPASS RELINKING UBFS YM7595*
*                                                                  0201
         B     SAMIOB                                              0201
*              /*******************************************************
*              /*BEFORE RELINKING BUFFERS IT MUST BE KNOWN IF IT CAN  *
*              /*BE DONE SAFELY. OPEN COULD HAVE BEEN IN THE PROCESS  *
*              /*OF UNCHAINING BUFFERS FOR CCW WHEN THE ERROR OCCURED.*
*              /*IF THIS IS THE CASE, THE STATE OF THE BUFFER POOL    *
*              /*IS NOT KNOWN AND THEREFORE IT WOULD BE RISKY TO TRY  *
*              /*TO RECHAIN. IF THIS IS THE CASE THE BUFFER POOL      *
*              /*SHOULD BE FREEMAINED BECAUSE IT IS UNUSABLE.         *
*              /*******************************************************
*                                                                  0202
*SAMBUFLN:;                                                        0202
*                                                                  0202
SAMBUFLN DS    0H                                                  0203
* IF FCAOIOBC = SWON THEN               /*IOB BUILDING PROCESS  YM7595*
         TM    FCAOIOBC(RCORE),B'00010000'                         0203
         BO    @RT00203                                            0203
*   GOTO SAMBUFL2;                      /*  MUST HAVE FINISHED  YM7595*
*                                       /*  OR BUFFERS HAVE NOT YM7595*
*                                       /*  BEEN UNCHAINED      YM7595*
* ELSE                                                             0205
*   IF FCAOBUF = SWON THEN              /*DID OPEN GET BUFFERS  YM7595*
         TM    FCAOBUF(RCORE),B'00100000'                          0205
         BO    @RT00205                                            0205
*                                       /*  THIS TIME           YM7595*
*     GOTO SAMBUFFR;                    /*YES, FREE BUFFERS     YM7595*
*   ELSE                                                           0207
*     GOTO SAMIOB;                      /*NO, CANNOT FREE BUFS  YM7595*
         B     SAMIOB                                              0207
*                                       /*  THEY MIGHT BE IN A  YM7595*
*                                       /*  SHARED POOL         YM7595*
*                                                                  0208
*SAMBUFL2:;                                                        0208
*                                                                  0208
SAMBUFL2 DS    0H                                                  0209
* RWORK2 = DCBOFFSR;                    /*ASSUME INPUT          YM7595*
         SLR   RWORK2,RWORK2                                       0209
         IC    RWORK2,DCBOFFSR+52(,DCBPTR)                         0209
* IF DEBACCS = '1111'B THEN             /*TEST FOR OUTPUT       YM7595*
         TM    DEBACCS(DEBPTR),B'00001111'                         0210
         BNO   @RF00210                                            0210
*   RWORK2 = DCBOFFSW;                  /*GET OUTPUT OFFSET     YM7595*
         SLR   RWORK2,RWORK2                                       0211
         IC    RWORK2,DCBOFFSW+52(,DCBPTR)                         0211
* ELSE;                                                            0212
*                                                                  0212
@RF00210 DS    0H                                                  0213
* RFY IOBPTR RSTD;                                                 0213
* IOBPTR = DCBIOBAB;                    /*GET ADDR AND CLEAR    YM7595*
         SLR   IOBPTR,IOBPTR                                       0214
         ICM   IOBPTR,7,DCBIOBAB+52(DCBPTR)                        0214
*                                       /*  HI BYTE             YM7595*
* RFY (RWORK3,RWORK4,RWORK5) RSTD;                                 0215
*                                                                  0215
* DO RWORK4 = 1 TO DCBBUFNO;            /*MAX NUM OF IOBS       YM7595*
         LA    RWORK4,1                                            0216
         B     @DE00216                                            0216
@DL00216 DS    0H                                                  0217
*   RWORK3 = RWORK2 + IOBPTR;           /*ADDRESS OF R/W CCW    YM7595*
         LR    RWORK3,RWORK2                                       0217
         ALR   RWORK3,IOBPTR                                       0217
*   RFY CCW BASED(RWORK3);                                         0218
*   RWORK3 = CCWADDRB;                  /*BUFFER ADDRESS        YM7595*
*                                                                  0219
         SLR   @08,@08                                             0219
         ICM   @08,7,CCWADDRB(RWORK3)                              0219
         LR    RWORK3,@08                                          0219
*   IF DEBACCS = '0001'B THEN           /*IF READ BACK, CCW     YM7595*
         TM    DEBACCS(DEBPTR),B'00000001'                         0220
         BNO   @RF00220                                            0220
         TM    DEBACCS(DEBPTR),B'00001110'                         0220
         BNZ   @RF00220                                            0220
*     DO;                               /* BUFFER ADDR POINTS   YM7595*
*     RWORK5 = DCBBLKSI;                /* TO THE END OF THE    YM7595*
         LH    RWORK5,DCBBLKSI+52(,DCBPTR)                         0222
*     RWORK3 = RWORK3 - RWORK5 - 1;     /* BUFFER               YM7595*
         LR    @08,RWORK3                                          0223
         SLR   @08,RWORK5                                          0223
         BCTR  @08,0                                               0223
         LR    RWORK3,@08                                          0223
*     END;                                                         0224
*   ELSE                                                           0225
*     IF DCBDEVT ^< '5A'X &             /*TEST FOR 1285, 1287   YM7595*
*        DCBDEVT ^> '5C'X THEN          /* OR A 1288            YM7595*
         B     @RC00220                                            0225
@RF00220 CLI   DCBDEVT+16(DCBPTR),X'5A'                            0225
         BL    @RF00225                                            0225
         CLI   DCBDEVT+16(DCBPTR),X'5C'                            0225
         BH    @RF00225                                            0225
*                                       /*YES, GET BUFFER ADDR  YM7595*
*                                       /* FROM 2ND CCW         YM7595*
*       DO;                                                        0226
*       RWORK5 = IOBPTR + CCW2;         /*ADDR OF 2ND CCW       YM7595*
         LA    RWORK5,48                                           0227
         ALR   RWORK5,IOBPTR                                       0227
*       RFY CCW BASED(RWORK5);                                     0228
*       RWORK5 = CCWBYTE;               /*BYTE COUNT FROM 2ND   YM7595
*                                          CCW                  YM7595*
         SLR   @08,@08                                             0229
         ICM   @08,3,CCWBYTE(RWORK5)                               0229
         LR    RWORK5,@08                                          0229
*       RWORK3 = RWORK3 - RWORK5;       /*BUFFER ADDR FOR       YM7595
*                                           NON-VAR LEN RECDS   YM7595*
         SLR   RWORK3,RWORK5                                       0230
*       IF DCBRECFF ^= SWON THEN        /*FIXED OR UNDEFINED    YM7595*
         TM    DCBRECFF+28(DCBPTR),B'10000000'                     0231
         BO    @RF00231                                            0231
*         RWORK3 = RWORK3 + RDWLEN;     /*ADD RDW LEN           YM7595*
         AH    RWORK3,@CH00060                                     0232
*       ELSE;                                                      0233
@RF00231 DS    0H                                                  0234
*       END;                                                       0234
*     ELSE;                                                        0235
*                                                                  0235
@RF00225 DS    0H                                                  0236
*   RFY BUFFER BASED(RWORK3);                                      0236
@RC00220 DS    0H                                                  0237
*   BUFNXPTB = BCBBUFAD;                /*UPDATE BUF LINK FIELD YM7595*
         MVC   BUFNXPTB(3,RWORK3),BCBBUFAD(BCBPTR)                 0237
*   BCBBUFPT = RWORK3;                  /*UPDATE BUF CNTRL BLK  YM7595*
         ST    RWORK3,BCBBUFPT(,BCBPTR)                            0238
*   IOBPTR = IOBNIOBB;                  /*NEXT IOB              YM7595*
*                                                                  0239
         SLR   @08,@08                                             0239
         ICM   @08,7,IOBNIOBB-8(IOBPTR)                            0239
         LR    IOBPTR,@08                                          0239
* END;                                  /*RWORK4 = DCBBUFNO     YM7595*
*                                                                  0240
         AH    RWORK4,@CH00045                                     0240
@DE00216 SLR   @08,@08                                             0240
         IC    @08,DCBBUFNO+16(,DCBPTR)                            0240
         CR    RWORK4,@08                                          0240
         BNH   @DL00216                                            0240
*      DO; /*MODESET  EXTKEY(DATAMGT)*/                            0241
*        SPKA (80); /*SET PSW KEY*/                                0242
         LA    @08,80                                              0242
         SPKA  0(@08)                                              0242
*      END; /*MODESET  EXTKEY(DATAMGT)*/                           0243
*                                                                  0243
* FCACBUFP = SWON;                      /*BUFFER POOL REUSABLE  YM7595*
*                                                                  0244
         OI    FCACBUFP(RCORE),B'00010000'                         0244
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0245
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0246
         SLR   @08,@08                                             0246
         IC    @08,DXUKEY(,RCORE)                                  0246
         SPKA  0(@08)                                              0246
*    END; /*MODESET  KEYADDR(DXUKEY)*/                             0247
* RFY (BCBPTR,RWORK3,RWORK4,RWORK5) UNRSTD;                        0248
*                                                                  0248
*              /*******************************************************
*              /*THE NEXT CHECK IS TO SEE IF OPEN HAS GETMAINED IOBS. *
*              /*IF YES, THEY MUST BE FREEMAINED.                     *
*              /*******************************************************
*                                                                  0249
*SAMIOB:;                                                          0249
*                                                                  0249
SAMIOB   DS    0H                                                  0250
* IF FCAOIOB = SWON THEN               /*IF IOBS WERE GETMAINED       *
         TM    FCAOIOB(RCORE),B'00000100'                          0250
         BNO   @RF00250                                            0250
*   DO;                                 /* THEY MUST BE FREEMAINED    *
*                                                                  0251
*              /*******************************************************
*              /*GET THE NUMBER OF BYTES TO FREE                YM4697*
*              /*******************************************************
*                                                                  0252
*   RWORK2 = WRKAUDSV;                  /*LEN TO FREEMAIN       YM4697*
*                                                                  0252
         L     RWORK2,WRKAUDSV(,RRECWKAR)                          0252
*              /*******************************************************
*              /*GET BEGINNING ADDR OF AREA TO FREEMAIN.        YM4697*
*              /*******************************************************
*                                                                  0253
*   IF DCBCNCHS = SWON THEN             /*GET ADDR OF MIOB IF CH SCH  *
         TM    DCBCNCHS+52(DCBPTR),B'00000100'                     0253
         BNO   @RF00253                                            0253
*     IOBPTR = DCBIOBAA;                /*ADDR OF MIOB         ZA00415*
*                                                                  0254
         SLR   IOBPTR,IOBPTR                                       0254
         ICM   IOBPTR,7,DCBIOBAA+16(DCBPTR)                        0254
*   ELSE                                /*NON-CHAIN SCHEDULING        *
*     IOBPTR = DCBIOBAB;                /*ADDR OF IST PHYSICAL ZA00415*
         B     @RC00253                                            0255
@RF00253 SLR   IOBPTR,IOBPTR                                       0255
         ICM   IOBPTR,7,DCBIOBAB+52(DCBPTR)                        0255
*                                       /* IOB                 ZA00415*
*                                                                  0256
*    DO; /*FREEMAIN(R) LV(RWORK2)SP(0)A(IOBORG01)*/                0256
@RC00253 DS    0H                                                  0257
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0257
*    GPR00F = RWORK2; /* LENGTH REQUESTED*/                        0258
         LR    GPR00F,RWORK2                                       0258
*    GPR01F = 0; /* SP IN REG 1 */                                 0259
         SLR   GPR01F,GPR01F                                       0259
*    GEN   (SLL   GPR01F,24)                                       0260
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0260
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0261
         OR    GPR00F,GPR01F                                       0261
*    GPR01F=ADDR(IOBORG01); /*SET REGISTER ONE*/                   0262
         LR    GPR01F,IOBPTR                                       0262
*    SVC(10); /* R-FORM OF GETMAIN*/                               0263
         SVC   10                                                  0263
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0264
*    END; /*FREEMAIN(R) LV(RWORK2)SP(0)A(IOBORG01)*/               0265
*                                                                  0265
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0266
*      SPKA (80); /*SET PSW KEY*/                                  0267
         LA    @10,80                                              0267
         SPKA  0(@10)                                              0267
*    END; /*MODESET  EXTKEY(DATAMGT)*/         /*AUDIT TRAIL IN KEY 5
*     */                                                           0268
*                                                                  0268
*   FCACIOB = SWON;                     /*INDICATE IOB''S FREED       *
*                                                                  0269
         OI    FCACIOB(RCORE),B'00001000'                          0269
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0270
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0271
         SLR   @10,@10                                             0271
         IC    @10,DXUKEY(,RCORE)                                  0271
         SPKA  0(@10)                                              0271
*    END; /*MODESET  KEYADDR(DXUKEY)*/                             0272
*                                                                  0272
*   END;                                                           0273
* ELSE;                                 /*IOBS NOT GETMAINED          *
*                                                                  0274
@RF00250 DS    0H                                                  0275
* RFY IOBPTR UNRSTD;                                               0275
*                                                                  0275
*              /*******************************************************
*              /*NEXT CHECK TO SEE IF A SEGMENT WORKAREA NEEDS TO     *
*              /*FREED.                                               *
*              /*******************************************************
*                                                                  0276
*SAMSWA:;                                                          0276
*                                                                  0276
SAMSWA   DS    0H                                                  0277
* IF FCAOSWA = SWON THEN                /*TEST TO SEE IF SWA NEEDS    *
         TM    FCAOSWA(RCORE),B'00001000'                          0277
         BNO   @RF00277                                            0277
*   DO;                                 /* TO BE FREEMAINED           *
*   RFY SWAPTR RSTD;                                               0279
*                                                                  0279
*   SWAPTR = DCBEOBW;                   /*ADDR OF SWA                 *
         L     SWAPTR,DCBEOBW+72(,DCBPTR)                          0280
*   RFY SWACB BASED(SWAPTR);                                       0281
*   RWORK2 = SWACBNO * SWACBLNG + SWALNG; /*AMT TO FREE, NUMBER TIMES
*                                          LEN PLUS CNTRL BLK LEN     *
*                                                                  0282
         SLR   @01,@01                                             0282
         ICM   @01,3,SWACBLNG(SWAPTR)                              0282
         SLR   RWORK2,RWORK2                                       0282
         ICM   RWORK2,3,SWACBNO(SWAPTR)                            0282
         MR    @00,RWORK2                                          0282
         AH    @01,@CH00856                                        0282
         LR    RWORK2,@01                                          0282
*    DO; /*FREEMAIN(R) LV(RWORK2)SP(0)A(SWACB)*/                   0283
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0284
*    GPR00F = RWORK2; /* LENGTH REQUESTED*/                        0285
         LR    GPR00F,RWORK2                                       0285
*    GPR01F = 0; /* SP IN REG 1 */                                 0286
         SLR   GPR01F,GPR01F                                       0286
*    GEN   (SLL   GPR01F,24)                                       0287
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0287
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0288
         OR    GPR00F,GPR01F                                       0288
*    GPR01F=ADDR(SWACB); /*SET REGISTER ONE*/                      0289
         LR    GPR01F,SWAPTR                                       0289
*    SVC(10); /* R-FORM OF GETMAIN*/                               0290
         SVC   10                                                  0290
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0291
*    END; /*FREEMAIN(R) LV(RWORK2)SP(0)A(SWACB)*/                  0292
*                                                                  0292
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0293
*      SPKA (80); /*SET PSW KEY*/                                  0294
         LA    @01,80                                              0294
         SPKA  0(@01)                                              0294
*    END; /*MODESET  EXTKEY(DATAMGT)*/          /*AUDIT TRAIL IN KEY 5
*      */                                                          0295
*                                                                  0295
*   FCACSWA = SWON;                     /*INDICATE SWA FREEMAINED     *
         OI    FCACSWA(RCORE),B'00000100'                          0296
*   END;                                                           0297
* ELSE;                                                            0298
@RF00277 DS    0H                                                  0299
* RFY (SWAPTR,RWORK2) UNRSTD;                                      0299
*                                                                  0299
*              /*******************************************************
*              /*NEXT DETERMINE IF THE MESSAGE CSECT MUST BE DELETED. *
*              /*******************************************************
*                                                                  0300
*SAMMSG:;                                                          0300
*                                                                  0300
SAMMSG   DS    0H                                                  0301
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0301
*      SPKA (80); /*SET PSW KEY*/                                  0302
         LA    @12,80                                              0302
         SPKA  0(@12)                                              0302
*    END; /*MODESET  EXTKEY(DATAMGT)*/         /*AUDIT TRAIL IN KEY 5
*     */                                                           0303
*                                                                  0303
* IF DXMSGADR ^= 0 THEN                 /*TEST TO SEE IF MSG CSECT 0304
*                                          HAS BEEN DELETED           *
         ICM   @12,15,DXMSGADR(RCORE)                              0304
         BZ    @RF00304                                            0304
*   DO;                                 /*NO, MUST DELETE MSG CSECT   *
*                                                                  0305
*    DO;/* DELETE EP('IGGMSG01')*/                                 0306
*    RESPECIFY (GPR00P)RESTRICTED;                                 0307
*    GPR00P = ADDR('IGGMSG01');/* ->ENTRY NAME*/                   0308
         LA    GPR00P,@CC02030                                     0308
*    SVC    (9);/* DELETE SVC*/                                    0309
         SVC   9                                                   0309
*    RESPECIFY (GPR00P)UNRESTRICTED;                               0310
*    END;/* DELETE EP('IGGMSG01')*/            /*ISSUE DELETE MACRO
*     */                                                           0311
*                                                                  0311
*   FCACDELE = SWON;                    /*INDICATE MSG CSECT DELETED  *
*                                                                  0312
         OI    FCACDELE(RCORE),B'00010000'                         0312
*   END;                                                           0313
* ELSE;                                                            0314
*                                                                  0314
@RF00304 DS    0H                                                  0315
*              /*******************************************************
*              /*NEXT DETERMINE IF A UCSB/FCB IMAGE MUST BE DELETED.  *
*              /*******************************************************
*                                                                  0315
*SAMUCSFC:;                                                        0315
*                                                                  0315
SAMUCSFC DS    0H                                                  0316
* IF FCAOUCSL = SWON | FCAOFCBL = SWON THEN  /*MUST AN IMAGE BE YM4697*
         TM    FCAOUCSL(RCORE),B'01100000'                         0316
         BZ    @RF00316                                            0316
*                                       /*  DELETED             YM4697*
*   IF FCAOUCSL = SWON THEN             /*IS IT A UCS IMAGE     YM4697*
*                                                                  0317
         TM    FCAOUCSL(RCORE),B'01000000'                         0317
         BNO   @RF00317                                            0317
*       DO;/* DELETE EP(DXSAVUCS)*/                                0318
*       RESPECIFY (GPR00P)RESTRICTED;                              0319
*       GPR00P = ADDR(DXSAVUCS);/* ->ENTRY NAME*/                  0320
         LA    GPR00P,DXSAVUCS(,RCORE)                             0320
*       SVC    (9);/* DELETE SVC*/                                 0321
         SVC   9                                                   0321
*       RESPECIFY (GPR00P)UNRESTRICTED;                            0322
*       END;/* DELETE EP(DXSAVUCS)*/            /*ISSUE SVC DELETE 0323
*YM4697*/                                                          0323
*                                                                  0323
*                                                                  0323
*   ELSE                                /*NOT UCS, MUST BE FCB  YM4697*
*                                                                  0324
*       DO;/* DELETE EP(DXSAVFCB)*/                                0324
         B     @RC00317                                            0324
@RF00317 DS    0H                                                  0325
*       RESPECIFY (GPR00P)RESTRICTED;                              0325
*       GPR00P = ADDR(DXSAVFCB);/* ->ENTRY NAME*/                  0326
         LA    GPR00P,DXSAVFCB(,RCORE)                             0326
*       SVC    (9);/* DELETE SVC*/                                 0327
         SVC   9                                                   0327
*       RESPECIFY (GPR00P)UNRESTRICTED;                            0328
*       END;/* DELETE EP(DXSAVFCB)*/            /*ISSUE SVC DELETE 0329
*YM4697*/                                                          0329
*                                                                  0329
* ELSE;                                                            0330
*                                                                  0330
@RF00316 DS    0H                                                  0331
*              /*******************************************************
*              /*NEXT CHECK TO SEE IF SYS1.IMAGELIB IS OPEN.          *
*              /*******************************************************
*                                                                  0331
*SAMIMLIB:;                                                        0331
*                                                                  0331
@RC00316 DS    0H                                                  0331
SAMIMLIB DS    0H                                                  0332
* RFY GPR01P RSTD;                                                 0332
* IF FCAOIMGL = SWON THEN               /*WAS IMAGE LIB OPENED  YM4697*
         TM    FCAOIMGL(RCORE),B'10000000'                         0333
         BNO   @RF00333                                            0333
*   DO;                                 /*YES, MUST ISSUE CLOSE YM4697*
*   GPR01P = DXIMGDCB;                  /*ADDR OF IMAGELIB DCB  YM4697*
         L     GPR01P,DXIMGDCB(,RCORE)                             0335
*   GEN REFS(GPR01P) (IMGLIB CLOSE,(GPR01P));  /*CLOSE IMAGLIB  YM4697*
         IMGLIB CLOSE,(GPR01P)
*   END;                                                           0337
* ELSE;                                                            0338
*                                                                  0338
@RF00333 DS    0H                                                  0339
* RFY GPR01P UNRSTD;                                               0339
* RFY GPR15F RSTD;                                                 0340
* GPR15F = 0;                           /*GOOD RETURN CODE            *
         SLR   GPR15F,GPR15F                                       0341
* GOTO EXIT200;                         /*GO TO EXIT ROUTINE          *
         B     EXIT200                                             0342
*/*********************************************************************
*/*PROCESS BDAM DATA SETS IN THIS ROUTINE. RESOURCES TO BE FREED      *
*/*ARE:                                                               *
*/*   1. READX LIST                                                   *
*/*   2. BUFFER POOL AND BUFFER POOL CONTROL BLOCK                    *
*/*   3. USL LIST                                                     *
*/*   4. SWA POOL                                                     *
*/*********************************************************************
*                                                                  0343
*BDAMRTN:;                                                         0343
*                                                                  0343
BDAMRTN  DS    0H                                                  0344
*              /*******************************************************
*              /*THE FIRST CHECK FOR BDAM IS FOR A BUFFER POOL        *
*              /*GOTTEN BY OPEN. IF PRESENT, THE BUFFER POOL CONTROL  *
*              /*BLOCK AND BUFFER POOL MUST BE FREEMAINED.            *
*              /*******************************************************
*                                                                  0344
* IF FCAOBUF = SWON THEN                /*TEST TO SEE IF BUFFERS NEED
*                                          TO BE FREED                *
         TM    FCAOBUF(RCORE),B'00100000'                          0344
         BNO   @RF00344                                            0344
*   DO;                                 /*IF ON, PREPARE TO FREEMAIN  *
*                                                                  0345
*   RFY BCBPTR RSTD;                                               0346
*   BCBPTR = DCBBUFCA;                  /*ADDR OF BUF C.B.     ZA00415*
         SLR   BCBPTR,BCBPTR                                       0347
         ICM   BCBPTR,7,DCBBUFCA+16(DCBPTR)                        0347
*   RFY BCBDEFV BASED(BCBPTR);                                     0348
*                                                                  0348
*    DO; /*FREEMAIN(R) LV(BCBTBRS1)SP(0)A(BCBDEFV)*/               0349
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0350
*    GPR00F = BCBTBRS1; /* LENGTH REQUESTED*/                      0351
         L     GPR00F,BCBTBRS1(,BCBPTR)                            0351
*    GPR01F = 0; /* SP IN REG 1 */                                 0352
         SLR   GPR01F,GPR01F                                       0352
*    GEN   (SLL   GPR01F,24)                                       0353
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0353
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0354
         OR    GPR00F,GPR01F                                       0354
*    GPR01F=ADDR(BCBDEFV); /*SET REGISTER ONE*/                    0355
         LR    GPR01F,BCBPTR                                       0355
*    SVC(10); /* R-FORM OF GETMAIN*/                               0356
         SVC   10                                                  0356
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0357
*    END; /*FREEMAIN(R) LV(BCBTBRS1)SP(0)A(BCBDEFV)*/              0358
*                                                                  0358
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0359
*      SPKA (80); /*SET PSW KEY*/                                  0360
         LA    @14,80                                              0360
         SPKA  0(@14)                                              0360
*    END; /*MODESET  EXTKEY(DATAMGT)*/         /*AUDIT TRAIL IN KEY 5
*     */                                                           0361
*                                                                  0361
*   FCACBUF = SWON;                     /*INDICATE BUFFERS FREED      *
*                                                                  0362
         OI    FCACBUF(RCORE),B'00100000'                          0362
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0363
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0364
         SLR   @14,@14                                             0364
         IC    @14,DXUKEY(,RCORE)                                  0364
         SPKA  0(@14)                                              0364
*    END; /*MODESET  KEYADDR(DXUKEY)*/         /*BACK TO USER KEY  0365
*     */                                                           0365
*   END;                                                           0366
* ELSE;                                                            0367
@RF00344 DS    0H                                                  0368
* RFY BCBPTR UNRSTD;                                               0368
*                                                                  0368
*              /*******************************************************
*              /*THE NEXT CHECK IS TO SEE IF A USL LIST HAS BEEN      *
*              /*GETMAINED BY OPEN. IF YES, IT MUST BE FREED.         *
*              /*******************************************************
*                                                                  0369
*DAMUSL:;                                                          0369
*                                                                  0369
DAMUSL   DS    0H                                                  0370
* IF FCAOUSL = SWON THEN                /*TEST TO SEE IF USL MUST  0370
*                                          BE FREEMAINED              *
         TM    FCAOUSL(RCORE),B'00010000'                          0370
         BNO   @RF00370                                            0370
*   DO;                                 /*ISSUE FREEMAIN              *
*   RFY USL BASED(DCBDYNB);                                        0372
*                                                                  0372
*    DO; /*FREEMAIN(R) LV(USLSZFST)SP(0)A(USL)*/                   0373
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0374
*    GPR00F = USLSZFST; /* LENGTH REQUESTED*/                      0375
         LA    GPR00F,64                                           0375
*    GPR01F = 0; /* SP IN REG 1 */                                 0376
         SLR   GPR01F,GPR01F                                       0376
*    GEN   (SLL   GPR01F,24)                                       0377
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0377
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0378
         OR    GPR00F,GPR01F                                       0378
*    GPR01F=ADDR(USL); /*SET REGISTER ONE*/                        0379
         L     GPR01F,DCBDYNB+52(,DCBPTR)                          0379
*    SVC(10); /* R-FORM OF GETMAIN*/                               0380
         SVC   10                                                  0380
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0381
*    END; /*FREEMAIN(R) LV(USLSZFST)SP(0)A(USL)*/                  0382
*                                                                  0382
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0383
*      SPKA (80); /*SET PSW KEY*/                                  0384
         LA    @14,80                                              0384
         SPKA  0(@14)                                              0384
*    END; /*MODESET  EXTKEY(DATAMGT)*/         /*AUDIT TRAIL IN KEY 5
*     */                                                           0385
*                                                                  0385
*   FCACUSL = SWON;                     /*INDICATE USL FREED          *
*                                                                  0386
         OI    FCACUSL(RCORE),B'00001000'                          0386
*    DO; /*MODESET  KEYADDR(DXUKEY)*/                              0387
*      SPKA (DXUKEY); /*SET PSW KEY*/                              0388
         SLR   @14,@14                                             0388
         IC    @14,DXUKEY(,RCORE)                                  0388
         SPKA  0(@14)                                              0388
*    END; /*MODESET  KEYADDR(DXUKEY)*/         /*BACK TO USER KEY  0389
*     */                                                           0389
*   END;                                                           0390
* ELSE;                                                            0391
*                                                                  0391
@RF00370 DS    0H                                                  0392
*              /*******************************************************
*              /*THE NEXT CHECK IF FOR A SEGMENT WORKAREA. IF GOTTEN  *
*              /*BY OPEN, IT MUST BE FREEMAINED.                      *
*              /*******************************************************
*                                                                  0392
*DAMSWA:;                                                          0392
*                                                                  0392
DAMSWA   DS    0H                                                  0393
* IF FCAOSWA ^= SWON THEN                /*TEST TO SEE IF SWA MUST 0393
*                                          BE FREEMAINED              *
         TM    FCAOSWA(RCORE),B'00001000'                          0393
         BO    @RF00393                                            0393
*   DO;                                 /*IF NOT, GET INTO KEY 5      *
*     DO; /*MODESET  EXTKEY(DATAMGT)*/                             0395
*       SPKA (80); /*SET PSW KEY*/                                 0396
         LA    @14,80                                              0396
         SPKA  0(@14)                                              0396
*     END; /*MODESET  EXTKEY(DATAMGT)*/         /*READX LIST IN KEY 5
*      */                                                          0397
*     GOTO DAMREADX;                    /*BYPASS SWA CODE             *
         B     DAMREADX                                            0398
*   END;                                                           0399
* ELSE                                  /*IF SWA MUST BE FREED        *
*   DO;                                 /*PREPARE TO FREEMAIN SWA     *
@RF00393 DS    0H                                                  0401
*   RFY (SWAPTR,RWORK2) RSTD;                                      0401
*   SWAPTR = DCBDYNB;                   /*ADDR OF SWA CONTROL BLK     *
         L     SWAPTR,DCBDYNB+52(,DCBPTR)                          0402
*   RFY BCBDEFS BASED(SWAPTR);                                     0403
*                                                                  0403
*              /*******************************************************
*              /*THE AMOUNT TO FREEMAIN IS THE NUMBER OF BUFFERS      *
*              /*TIMES THE LENGTH OF EACH BUFFER PLUS THE LENGTH OF   *
*              /*THE BUFFER CONTROL BLOCK.                            *
*              /*******************************************************
*                                                                  0404
*   RWORK2 = BCBBFNUM * BCBBFLG + LENGTH(BCBDEFS);  /*LENGTH TO FREE  *
*                                                                  0404
         SLR   @01,@01                                             0404
         ICM   @01,3,BCBBFLG(SWAPTR)                               0404
         SLR   RWORK2,RWORK2                                       0404
         ICM   RWORK2,3,BCBBFNUM(SWAPTR)                           0404
         MR    @00,RWORK2                                          0404
         AH    @01,@CH00040                                        0404
         LR    RWORK2,@01                                          0404
*    DO; /*FREEMAIN(R) LV(RWORK2)SP(0)A(BCBDEFS)*/                 0405
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0406
*    GPR00F = RWORK2; /* LENGTH REQUESTED*/                        0407
         LR    GPR00F,RWORK2                                       0407
*    GPR01F = 0; /* SP IN REG 1 */                                 0408
         SLR   GPR01F,GPR01F                                       0408
*    GEN   (SLL   GPR01F,24)                                       0409
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0409
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0410
         OR    GPR00F,GPR01F                                       0410
*    GPR01F=ADDR(BCBDEFS); /*SET REGISTER ONE*/                    0411
         LR    GPR01F,SWAPTR                                       0411
*    SVC(10); /* R-FORM OF GETMAIN*/                               0412
         SVC   10                                                  0412
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0413
*    END; /*FREEMAIN(R) LV(RWORK2)SP(0)A(BCBDEFS)*/                0414
*                                                                  0414
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0415
*      SPKA (80); /*SET PSW KEY*/                                  0416
         LA    @14,80                                              0416
         SPKA  0(@14)                                              0416
*    END; /*MODESET  EXTKEY(DATAMGT)*/          /*AUDIT TRAIL IN KEY 5
*      */                                                          0417
*                                                                  0417
*   FCACSWA = SWON;                     /*INDICATE SWA HAS BEEN FREED *
         OI    FCACSWA(RCORE),B'00000100'                          0418
*   END;                                                           0419
* RFY (SWAPTR,RWORK2) UNRSTD;                                      0420
*                                                                  0420
*              /*******************************************************
*              /*THE NEXT CHECK IS FOR A READX LIST. IF GETMAINED BY  *
*              /*OPEN, IT MUST BE FREEMAINED.                         *
*              /*******************************************************
*                                                                  0421
*DAMREADX:;                                                        0421
*                                                                  0421
DAMREADX DS    0H                                                  0422
* IF FCAORDX = SWON THEN               /*TEST TO SEE IF READX LIST 0422
*                                          MUST BE FREEMAINED         *
         TM    FCAORDX(RCORE),B'01000000'                          0422
         BNO   @RF00422                                            0422
*   DO;                                 /*PREPARE TO FREE READX LIST  *
*                                                                  0423
*   RFY DEBXTN BASED(DXDEBXAD);                                    0424
*   RFY RDXLIST BASED(DEBXXARG);                                   0425
*                                                                  0425
*    DO; /*FREEMAIN(R) LV(RDXLSTLG)SP(230)A(RDXLIST)*/             0426
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                         0427
*    GPR00F = RDXLSTLG; /* LENGTH REQUESTED*/                      0428
         LA    GPR00F,152                                          0428
*    GPR01F = 230; /* SP IN REG 1 */                               0429
         LA    GPR01F,230                                          0429
*    GEN   (SLL   GPR01F,24)                                       0430
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;                  0430
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */                 0431
         OR    GPR00F,GPR01F                                       0431
*    GPR01F=ADDR(RDXLIST); /*SET REGISTER ONE*/                    0432
         L     @14,DXDEBXAD(,RCORE)                                0432
         L     GPR01F,DEBXXARG(,@14)                               0432
*    SVC(10); /* R-FORM OF GETMAIN*/                               0433
         SVC   10                                                  0433
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                       0434
*    END; /*FREEMAIN(R) LV(RDXLSTLG)SP(230)A(RDXLIST)*/            0435
*                                                                  0435
*   FCACRDX = SWON;                     /*INDICATE READX LIST FREED   *
         OI    FCACRDX(RCORE),B'00000100'                          0436
*   END;                                                           0437
*                                                                  0437
* ELSE;                                                            0438
@RF00422 DS    0H                                                  0439
* RFY GPR15F RSTD;                                                 0439
* GPR15F = 0;                           /*GOOD RETURN CODE            *
         SLR   GPR15F,GPR15F                                       0440
* GOTO EXIT200;                         /*GO TO EXIT ROUTINE          *
         B     EXIT200                                             0441
* RFY GPR15F UNRSTD;                                               0442
*/*********************************************************************
*/*THIS ROUTINE IS USED TO RETURN TO COMMON CLOSES TRR FOR 4          *
*/*CONDITIONS:                                                        *
*/*   1. THE FORCE CLOSE EXECUTOR WAS ENTERED FOR A FAILING FUNCTION  *
*/*      OTHER THAN OPEN. (RETURN CODE = 8)                           *
*/*   2. CLOSES SECOND LEVEL ESTAE GOT CONTROL BECAUSE THE NORMAL     *
*/*      CLOSE EXECUTOR STRING FAILED AFTER BEING GIVEN CONTROL       *
*/*      FROM THIS MODULE. (RETURN CODE = 8)                          *
*/*   3. NORMAL ENTRY TO THIS ROUTINE BY CLEANUP ROUTINE AFTER        *
*/*       SUCCESSFULLY CLEANING UP RESOURCES. (RETURN CODE = 0)       *
*/*   4. RETURN TO THIS ROUTINE FROM NORMAL CLOSE EXECUTORS AFTER     *
*/*      SUCCESSFULLY CLEANING UP RESOURCES. (RETURN CODE = 0)        *
*/*********************************************************************
*                                                                  0443
*EXITRTN:;                                                         0443
*                                                                  0443
EXITRTN  DS    0H                                                  0444
* RFY GPR15F RSTD;                                                 0444
* GPR15F = ERRCODE;                     /*ERROR RETURN CODE           *
*                                                                  0445
         LA    GPR15F,8                                            0445
*EXIT100:;                                                         0446
*                                                                  0446
EXIT100  DS    0H                                                  0447
* BASEREG = WRKBASRG;                   /*RESTORE ADDRESSABILITY      *
         L     BASEREG,WRKBASRG(,RRECWKAR)                         0447
*              /*******************************************************
*              /*MUST MOVE THE FORCE CLOSE AUDIT TRAIL INTO THE CRSA  *
*              /*SO IF THE USER HAS A STAE ROUTINE HE CAN DETERMINE   *
*              /*WHAT RESOURCES WERE CLEANED UP FOR HIM. THE CRSA     *
*              /*IS PASSED TO THE USERS STAE ROUTINE FROM COMMON      *
*              /*CLOSES ESTAE VIA THE SDWA.                           *
*              /*******************************************************
*                                                                  0448
*EXIT200:;                                                         0448
*                                                                  0448
EXIT200  DS    0H                                                  0449
*    DO; /*MODESET  EXTKEY(SUPR)*/                                 0449
*      SPKA (0); /*SET PSW KEY*/                                   0450
         SLR   @14,@14                                             0450
         SPKA  0(@14)                                              0450
*    END; /*MODESET  EXTKEY(SUPR)*/            /*KEY TO RETURN TO CLOSE
*IN   */                                                           0451
*                                                                  0451
* IF DXATCOM4 ^= 0 THEN                 /*VERIFY CRSA EXISTS          *
         ICM   @14,15,DXATCOM4(RCORE)                              0452
         BZ    @RF00452                                            0452
*    DXATCOM4 -> CRSFCXAT = DXATEXC2;   /*AUDIT TRAIL FOR USER        *
*                                                                  0453
         L     @14,DXATCOM4(,RCORE)                                0453
         MVC   CRSFCXAT(4,@14),DXATEXC2(RCORE)                     0453
* RFY (GPR00P,GPR12P,GPR13P,GPR14P) RSTD;                          0454
@RF00452 DS    0H                                                  0455
* GPR13P = WRKSAV13;                    /*ADDR REG SAVE AREA    YM3887*
         L     GPR13P,WRKSAV13(,RRECWKAR)                          0455
* LM (GPR00P,GPR12P,REG00T12);          /*LOAD TRRS REGS 0-12   YM3887*
         LM    GPR00P,GPR12P,REG00T12(GPR13P)                      0456
* GPR14P = REGSAV14;                    /*LOAD RETURN ADDR      YM3887*
*                                                                  0457
         L     GPR14P,REGSAV14(,GPR13P)                            0457
* BC (15,GPR14P);                       /*RETURN TO CLOSES TRR        *
         BCR   15,GPR14P                                           0458
* RFY (GPR12P,GPR13P,GPR14P) UNRSTD;                               0459
*/*********************************************************************
*/*THIS ROUTINE IS ENTERED WHEN IT IS FOUND THAT THE USERS DCB HAS    *
*/*ALREADY BEEN REFRESHED BY THE OPEN EXECUTORS. IT WILL SET UP AN    *
*/*ERROR ROUTINE RETURN ADDRESS FOR CLOSES SECOND LEVEL ESTAE AND     *
*/*THEN GIVE THE NORMAL CLOSE EXECUTORS CONTROL TO TRY TO DO NORMAL   *
*/*CLEAN UP FOR THE DATA SET.                                         *
*/*********************************************************************
*                                                                  0460
*XCTLRTN:;                                                         0460
*                                                                  0460
XCTLRTN  DS    0H                                                  0461
*              /*******************************************************
*              /*MUST FREEMAIN WORKAREA GOTTEN BY IGG01911      YM4697*
*              /*IF NOT FREEMAINED.                             YM4697*
*              /*******************************************************
*                                                                  0461
* IF WRKAUDSV ^= 0 THEN                 /*TEST TO SEE IF CORE   YM4697*
         ICM   @14,15,WRKAUDSV(RRECWKAR)                           0461
         BZ    @RF00461                                            0461
*   DO;                                 /* ALREADY FREEMIANED   YM4697*
*                                                                  0462
*        DO; /*MODESET  KEYADDR(DXUKEY)*/                          0463
*          SPKA (DXUKEY); /*SET PSW KEY*/                          0464
         SLR   @01,@01                                             0464
         IC    @01,DXUKEY(,RCORE)                                  0464
         SPKA  0(@01)                                              0464
*        END; /*MODESET  KEYADDR(DXUKEY)*/      /*USER KEY FOR FREEMAIN
*YM4697*/                                                          0465
*                                                                  0465
*        DO; /*FREEMAIN(R) LV(LENGTH(OPEXWRKA))SP(230)A(OPEXWRKA)*/
*        RESPECIFY (GPR01F,GPR00F) RESTRICTED;                     0467
*        GPR00F = LENGTH(OPEXWRKA); /* LENGTH REQUESTED*/          0468
         LA    GPR00F,72                                           0468
*        GPR01F = 230; /* SP IN REG 1 */                           0469
         LA    GPR01F,230                                          0469
*        GEN   (SLL   GPR01F,24)                                   0470
*        NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;              0470
         SLL   GPR01F,24
*        GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */             0471
         OR    GPR00F,GPR01F                                       0471
*        GPR01F=ADDR(OPEXWRKA); /*SET REGISTER ONE*/               0472
         L     GPR01F,WRKAUDSV(,RRECWKAR)                          0472
*        SVC(10); /* R-FORM OF GETMAIN*/                           0473
         SVC   10                                                  0473
*        RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                   0474
*        END; /*FREEMAIN(R) LV(LENGTH(OPEXWRKA))SP(230)A(OPEXWRKA)*/
*                                                                  0475
*   END;                                                           0476
*                                                                  0476
*              /*******************************************************
*              /*THE ADDRESS OF THIS FORCE CLOSE EXECUTORS EXIT RTN   *
*              /*IS STORED IN THE PARAMETER LIST (PASSED BY COMMON    *
*              /*CLOSES TRR). IN THE CASE WHERE THE SAM/PAM/DAM CLOSE *
*              /*EXECUTORS FAIL, COMMON CLOSES SECOND LEVEL ESTAE     *
*              /*WILL GIVE THE EXIT ROUTINE CONTROL AS A RETRY RTN.   *
*              /*******************************************************
*                                                                  0477
* RFY (RWTG,RPARC,RWTGC,PARMLPTR) RSTD;                            0477
*                                                                  0477
@RF00461 DS    0H                                                  0478
*    DO; /*MODESET  EXTKEY(DATAMGT)*/                              0478
*      SPKA (80); /*SET PSW KEY*/                                  0479
         LA    @01,80                                              0479
         SPKA  0(@01)                                              0479
*    END; /*MODESET  EXTKEY(DATAMGT)*/           /*ENTER CLOSE EXECS IN
*KEY 5  */                                                         0480
*                                                                  0480
* RRXRETRY = ADDR(EXITRTN);             /*SET UP RETRY ADDRESS FOR 0481
*                                           CLOSES SECOND LEVEL ESTAE *
         LA    @14,EXITRTN                                         0481
         ST    @14,RRXRETRY(,PARMLPTR)                             0481
* FCACFORC = SWON;                      /*INDIC TO NORMAL CLOSE EXECS
*                                           THIS IS FORCE CLOSE    0482
*                                           SITUATION                 *
         OI    FCACFORC(RCORE),B'10000000'                         0482
* RWTG = WRKSAV13->REGSAV6;             /*REAL WTG TABLE       OZ05202*
         L     @01,WRKSAV13(,RRECWKAR)                             0483
         L     RWTG,REGSAV6(,@01)                                  0483
* RPARC = ADDR(WRKDCBPT);               /*PARM LIST                   *
         LA    RPARC,WRKDCBPT(,RRECWKAR)                           0484
* RWTGC = ADDR(WRKPARML);               /*TO GIVE WORK AREA ADDR      *
*                                                                  0485
         LA    RWTGC,WRKPARML(,RRECWKAR)                           0485
* WRKDCBPT = DXPDCBAD;                  /*BDAM NEEDS PROT DCB ADDR    *
         MVC   WRKDCBPT(4,RRECWKAR),DXPDCBAD(RCORE)                0486
*                                       /*SAM GETS DCB ADDR FROM OPEN
*                                          WORKAREA  (PTR IN REG 4)   *
* WRKWORKA = RCORE;                     /*ADDR OF OPEN WORKAREA       *
         ST    RCORE,WRKWORKA(,RRECWKAR)                           0487
* WRKRETRN = ADDR(EXIT100);             /*CLOSE EXECS RETURN HERE IF
*                                          THEY ARE SUCCESSFUL        *
         LA    @14,EXIT100                                         0488
         ST    @14,WRKRETRN(,RRECWKAR)                             0488
* WRKBASRG = BASEREG;                   /*SAVE BASE REG FOR RETURN 0489
*                                          FROM EXECUTOR STRING       *
*                                                                  0489
         ST    BASEREG,WRKBASRG(,RRECWKAR)                         0489
*              /*******************************************************
*              /*DETERMINE CLOSE EXECUTOR TO XCTL TO:           YM6249*
*              /*  BDAM - ALWAYS IGG0203A                       YM6249*
*              /*  QSAM INPUT - DA : IGG0201Z TO DO PURGE FOR   YM6249*
*              /*                    I/O STARTED BY OPEN EXECS  YM6249*
*              /*           NON-DA : IGG0201A TO DO PURGE       YM6249*
*              /*  ALL OTHER  - DA : IGG0201Y FOR CLEAN UP      YM6249*
*              /*           NON-DA : IGG0201X FOR CLEAN UP      YM6249*
*              /*******************************************************
*                                                                  0490
* WTGMODNM = SAMNTDA2;                  /*ASSUME SAM, NON-DA,   YM6249*
         MVC   WTGMODNM(8,RWTG),SAMNTDA2                           0490
*                                       /*  OUTPUT              YM6249*
* IF DCBDSGDA = SWON THEN               /*IF BDAM, THEN SET UP FOR    *
         TM    DCBDSGDA+16(DCBPTR),B'00100000'                     0491
         BNO   @RF00491                                            0491
*   WTGMODID = DAMEXEC;                 /* IGG0203A                   *
         MVC   WTGMODID(2,RWTG),DAMEXEC                            0492
* ELSE                                                             0493
*   IF DCBDEVDA ^= SWON THEN            /*IF NON-DA AND         YM6249*
         B     @RC00491                                            0493
@RF00491 TM    DCBDEVDA+16(DCBPTR),B'00100000'                     0493
         BO    @RF00493                                            0493
*      IF DCBCNQSM = SWON &             /*IF QSAM AND           YM6249*
*         DEBACCS = '0000'B THEN        /*IF INPUT, I/O WAS     YM6249*
         TM    DCBCNQSM+52(DCBPTR),B'00000001'                     0494
         BNO   @RF00494                                            0494
         TM    DEBACCS(DEBPTR),B'00001111'                         0494
         BNZ   @RF00494                                            0494
*         WTGMODID = SAMNTDA1;          /*STARTED BY OPEN EXECS YM6249*
         MVC   WTGMODID(2,RWTG),SAMNTDA1                           0495
*      ELSE;                            /*ALREADY SET UP        YM6249*
@RF00494 DS    0H                                                  0497
*   ELSE                                                           0497
*      IF DCBCNQSM = SWON &             /*IF DA, QSAM AND       YM6249*
*         DEBACCS = '0000'B THEN        /*IF INPUT, I/O WAS     YM6249*
         B     @RC00493                                            0497
@RF00493 TM    DCBCNQSM+52(DCBPTR),B'00000001'                     0497
         BNO   @RF00497                                            0497
         TM    DEBACCS(DEBPTR),B'00001111'                         0497
         BNZ   @RF00497                                            0497
*         WTGMODID = SAMDIRA1;          /*STARTED BY OPEN EXECS YM6249*
         MVC   WTGMODID(2,RWTG),SAMDIRA1                           0498
*      ELSE                                                        0499
*         WTGMODID = SAMDIRA2;          /*ONLY CLEAN UP NEEDED  YM6249*
*                                                                  0499
         B     @RC00497                                            0499
@RF00497 MVC   WTGMODID(2,RWTG),SAMDIRA2                           0499
*    DO;  /* XCTL MF(E,XCTLPL,COMPLETE) EP(WTGMODNM) DCB(0) */     0500
@RC00497 DS    0H                                                  0500
@RC00493 DS    0H                                                  0500
@RC00491 DS    0H                                                  0501
*      XCTLPL =XCTLPL&& XCTLPL; /*INITIALIZE LIST*/                0501
         XC    XCTLPL(8,RCORE),XCTLPL(RCORE)                       0501
*      XCTLPL01='00'X; /*EP/DE FLAG*/                              0502
         MVI   XCTLPL01(RCORE),X'00'                               0502
*      XCTLPL02=ADDR(WTGMODNM); /*EP/DE NAME*/                     0503
         STCM  RWTG,7,XCTLPL02(RCORE)                              0503
*      XCTLPL03='00'X;/*FLAG BYTE*/                                0504
         MVI   XCTLPL03(RCORE),X'00'                               0504
*      XCTLPL04= 0; /*JOBLIB/STEPLIB DCB*/                         0505
         SLR   @14,@14                                             0505
         STCM  @14,7,XCTLPL04(RCORE)                               0505
*      RESPECIFY (GPR15P) RESTRICTED;                              0506
*      GPR15P=ADDR(XCTLPL); /*XCTL PARAMETER LIST*/                0507
         LA    GPR15P,XCTLPL(,RCORE)                               0507
*      SVC (7);/*ISSUE XCTL SVC*/                                  0508
         SVC   7                                                   0508
*      RESPECIFY (GPR15P) UNRESTRICTED;                            0509
*    END;  /* XCTL MF(E,XCTLPL,COMPLETE) EP(WTGMODNM) DCB(0) */  /*XCTL
*                                                    TO NORMAL CLOSE EX
*CS      */                                                        0510
*                                                                  0510
* RFY (RWTG,RPARC,RWTGC,PARMLPTR) UNRSTD;                          0511
*END IGG020T1                                                      0512
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IHACCW  )                                        *
*/*%INCLUDE SYSLIB  (IHADCBDF)                                        *
*/*%INCLUDE SYSLIB  (IHADCB  )                                        *
*/*%INCLUDE SYSLIB  (IEZDEB  )                                        *
*/*%INCLUDE SYSLIB  (IGGBCB  )                                        *
*/*%INCLUDE SYSLIB  (IGGUSL  )                                        *
*/*%INCLUDE SYSLIB  (IECDSECS)                                        *
*/*%INCLUDE SYSLIB  (IECDSECT)                                        *
*/*%INCLUDE SYSLIB  (IEZIOB  )                                        *
*/*%INCLUDE SYSLIB  (IGGRDX  )                                        *
*/*%INCLUDE SYSLIB  (IHAFCAUD)                                        *
*/*%INCLUDE SYSLIB  (IGGSWA  )                                        *
*/*%INCLUDE SYSLIB  (IECCRSA )                                        *
*/*%INCLUDE SYSLIB  (IHASDWA )                                        *
*;                                                                 0512
@DATA    DS    0H
@CH00045 DC    H'1'
@CH00060 DC    H'4'
@CH00040 DC    H'8'
@CH00856 DC    H'12'
@DATD    DSECT
         DS    0F
IGG020T1 CSECT
         DS    0F
@DATD    DSECT
         DS    0D
SDWAPTR  DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGG020T1 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC02030 DC    C'IGGMSG01'
PATCH    DS    CL50
         ORG   PATCH
@NM00162 DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         DC    XL1'0'
         ORG   PATCH+50
SAMNTDA2 DC    CL8'IGG0201X'
SAMNTDA1 DC    CL2'1A'
SAMDIRA1 DC    CL2'1Z'
SAMDIRA2 DC    CL2'1Y'
DAMEXEC  DC    CL2'3A'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
DCBPTR   EQU   @02
DEBPTR   EQU   @11
RWTG     EQU   @06
RWTGC    EQU   @08
RCORE    EQU   @04
IOBPTR   EQU   @09
GPR00F   EQU   @00
GPR01F   EQU   @01
GPR15F   EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
BASEREG  EQU   @03
RRECWKAR EQU   @05
RWORK5   EQU   @06
RPARC    EQU   @07
PARMLPTR EQU   @08
SWAPTR   EQU   @10
BCBPTR   EQU   @10
GPR12P   EQU   @12
RECARPTR EQU   @12
RWORK2   EQU   @12
GPR13P   EQU   @13
RWORK3   EQU   @14
RWORK4   EQU   @15
GPR14F   EQU   @14
RWORK1   EQU   @00
CCW      EQU   0
CCWADDRA EQU   CCW
CCWADDRB EQU   CCWADDRA+1
CCWFLGS  EQU   CCW+4
CCWBYTE  EQU   CCW+6
IHADCB   EQU   0
IHADCS00 EQU   0
DCBFDAD  EQU   IHADCS00+5
IHADCS01 EQU   0
DCBDVTBL EQU   IHADCS01
IHADCS07 EQU   0
DCBWTOID EQU   IHADCS07
IHADCS08 EQU   0
DCBERRCN EQU   IHADCS08
DCBERRCA EQU   DCBERRCN+1
DCBORFLG EQU   DCBERRCA+1
DCBDSPLY EQU   IHADCS08+4
DCBFRID  EQU   DCBDSPLY
DCBRESCN EQU   IHADCS08+8
DCBRDLNE EQU   DCBRESCN
DCBFRTBA EQU   DCBRDLNE
DCBORBYT EQU   IHADCS08+12
DCBEIB   EQU   IHADCS08+14
IHADCS11 EQU   0
DCBRELB  EQU   IHADCS11
DCBREL   EQU   DCBRELB+1
DCBDEVT  EQU   DCBREL
DCBBUFCB EQU   IHADCS11+4
DCBBUFNO EQU   DCBBUFCB
DCBBUFCA EQU   DCBBUFCB+1
DCBDSORG EQU   IHADCS11+10
DCBDSRG1 EQU   DCBDSORG
DCBDSGDA EQU   DCBDSRG1
DCBDSRG2 EQU   DCBDSORG+1
DCBIOBAD EQU   IHADCS11+12
DCBODEB  EQU   DCBIOBAD
DCBLNP   EQU   DCBODEB
DCBQSLM  EQU   DCBLNP
DCBIOBAA EQU   DCBODEB+1
IHADCS50 EQU   0
DCBSVCXL EQU   IHADCS50
DCBEODAD EQU   IHADCS50+4
DCBBFALN EQU   DCBEODAD
DCBHIARC EQU   DCBBFALN
DCBBFTEK EQU   DCBHIARC
DCBBFT   EQU   DCBBFTEK
DCBEXLST EQU   IHADCS50+8
DCBRECFM EQU   DCBEXLST
DCBRECLA EQU   DCBRECFM
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS26 EQU   0
DCBWRITE EQU   IHADCS26
DCBREAD  EQU   DCBWRITE
DCBWRITA EQU   DCBREAD+1
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS30 EQU   0
DCBCHECK EQU   IHADCS30
DCBOPTCD EQU   DCBCHECK
DCBBLKSI EQU   IHADCS30+10
DCBXARG  EQU   IHADCS30+32
DCBDRDX  EQU   IHADCS30+36
DCBDYNB  EQU   IHADCS30+48
IHADCS36 EQU   0
@NM00028 EQU   IHADCS36
@NM00029 EQU   @NM00028
DCBOPTH  EQU   @NM00029
DCBOPTO  EQU   DCBOPTH
DCBOPTZ  EQU   @NM00029
@NM00031 EQU   IHADCS36+4
DCBCIND1 EQU   IHADCS36+8
DCBCNEXB EQU   DCBCIND1
DCBCIND2 EQU   IHADCS36+9
DCBCNCHS EQU   DCBCIND2
DCBCNQSM EQU   DCBCIND2
DCBOFFSR EQU   IHADCS36+14
DCBOFFSW EQU   IHADCS36+15
DCBIOBA  EQU   IHADCS36+16
DCBCICB  EQU   DCBIOBA
DCBCICBA EQU   DCBCICB+1
IHADCS52 EQU   0
DCBDIRCT EQU   IHADCS52
DCBQSWS  EQU   DCBDIRCT
DCBUSASI EQU   DCBQSWS
DCBQADFS EQU   DCBUSASI
DCBBUFOF EQU   DCBDIRCT+1
IHADCS37 EQU   0
DCBFLAG1 EQU   IHADCS37
IHADCS38 EQU   0
DCBEOBR  EQU   IHADCS38
DCBEOBW  EQU   IHADCS38+4
DCBPOINT EQU   IHADCS38+12
DCBCNTRL EQU   DCBPOINT
IHADCS39 EQU   0
DCBGERR  EQU   IHADCS39
DCBPERR  EQU   DCBGERR
DCBGERRA EQU   DCBPERR+1
IHADCS40 EQU   0
DCBEOBAD EQU   IHADCS40
DCBCCCW  EQU   IHADCS40+4
DCBRECAD EQU   DCBCCCW
DCBRECBT EQU   DCBRECAD
DCBRCREL EQU   DCBRECBT
@NM00046 EQU   IHADCS40+12
DCBEROPT EQU   @NM00046
NOBASE   EQU   0
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBACCS  EQU   DEBOPATB
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
DEBXXARG EQU   DEBXTN+20
BCBLK    EQU   0
BCBBUFPT EQU   BCBLK
BCBBUFAD EQU   BCBBUFPT+1
BCBFLGS  EQU   BCBLK+4
BCBBUFNO EQU   BCBLK+5
BCBBUFSZ EQU   BCBLK+6
BCBLRIAR EQU   BCBLK+8
BCBLRIAD EQU   BCBLRIAR+1
LRIAREA  EQU   0
LRILOC   EQU   LRIAREA
LRILGTH  EQU   LRILOC
LRIFLG1  EQU   LRILGTH
LRILNGTH EQU   LRILGTH+1
LRIFLG2  EQU   LRILOC+4
LRITRKAD EQU   LRIAREA+8
LRINIOB  EQU   LRIAREA+16
LRIALIGN EQU   0
BUFFER   EQU   0
BCBDEFV  EQU   0
BCBTBRS1 EQU   BCBDEFV+12
BCBDEFR  EQU   0
BCBIOBS  EQU   BCBDEFR
BCBDEFS  EQU   0
BCBBFNUM EQU   BCBDEFS+4
BCBBFLG  EQU   BCBDEFS+6
USL      EQU   0
USLBFRQT EQU   USL+4
USLBFRQB EQU   USL+8
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGMODID EQU   WTGMODNM+6
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW1   EQU   DXCCW
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUKEY   EQU   FORCORE+526
DXDEBXAD EQU   FORCORE+552
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXMSGADR EQU   FORCORE+584
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATCOM4 EQU   FORCORE+600
DXATEXC1 EQU   FORCORE+604
DXATEXB1 EQU   DXATEXC1
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IOBPREFX EQU   0
IOBCFLG1 EQU   IOBPREFX
IOBSTDRD EQU   0
IOBFLAG1 EQU   IOBSTDRD
IOBCYCCK EQU   IOBFLAG1
IOBRSTRT EQU   IOBFLAG1
IOBFLAG2 EQU   IOBSTDRD+1
IOBPURGE EQU   IOBFLAG2
IOBRDHA0 EQU   IOBFLAG2
IOBSENS0 EQU   IOBSTDRD+2
IOBS0B7  EQU   IOBSENS0
IOBSENS1 EQU   IOBSTDRD+3
IOBECBPT EQU   IOBSTDRD+4
IOBFLAG3 EQU   IOBSTDRD+8
IOBFL3   EQU   IOBFLAG3
IOBCNC   EQU   IOBFL3
IOBICL   EQU   IOBFL3
IOBCSW   EQU   IOBSTDRD+9
IOBIOCSW EQU   IOBCSW
IOBSTBYT EQU   IOBIOCSW+3
IOBUSTAT EQU   IOBSTBYT
IOBCSTAT EQU   IOBSTBYT+1
IOBSTART EQU   IOBSTDRD+16
IOBDCBPT EQU   IOBSTDRD+20
IOBFLAG4 EQU   IOBDCBPT
IOBRESTR EQU   IOBSTDRD+24
IOBINCAM EQU   IOBSTDRD+28
IOBBTAMF EQU   IOBINCAM
RDXLIST  EQU   0
RDXENTRY EQU   0
SWACB    EQU   0
SWACBNO  EQU   SWACB+4
SWACBLNG EQU   SWACB+6
IECCRSA  EQU   0
CRSIECHD EQU   IECCRSA
CRSIECBS EQU   IECCRSA+16
CRSIECNT EQU   0
CRSIECFC EQU   CRSIECNT
CRSIECTP EQU   CRSIECNT+1
CRSIECDA EQU   CRSIECNT+2
CRSFCXAT EQU   CRSIECNT+4
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWACOMP EQU   SDWA+392
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
WRKAREA  EQU   0
WRKSAV13 EQU   WRKAREA
WRKPARML EQU   WRKAREA+4
WRKWORKA EQU   WRKPARML+4
WRKDCBPT EQU   WRKAREA+12
WRKRETRN EQU   WRKAREA+24
WRKAUDSV EQU   WRKAREA+28
WRKBASRG EQU   WRKAREA+32
REGSAVAR EQU   0
REG14T12 EQU   REGSAVAR+12
REGSAV14 EQU   REG14T12
REG00T12 EQU   REG14T12+8
REGSAV6  EQU   REG00T12+24
OPEXWRKA EQU   0
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
BUFNXPTA EQU   BUFFER
BUFNXPTB EQU   BUFNXPTA+1
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00083 EQU   DXXCTL
DXSAVMOD EQU   @NM00083+2
@NM00084 EQU   DXRESSW
IOBORG01 EQU   IOBPREFX+8
IOBNIOBA EQU   IOBORG01
IOBNFLG1 EQU   IOBNIOBA
IOBPRTOV EQU   IOBNFLG1
IOBNIOBB EQU   IOBNIOBA+1
IOBORG02 EQU   IOBPREFX+8
IOBDQADA EQU   IOBORG02
IOBDEQIN EQU   IOBDQADA
IOBORG03 EQU   IOBPREFX+12
IOBORG04 EQU   IOBINCAM
IOBORG12 EQU   IOBINCAM
IOBFL4   EQU   IOBORG12
IOBEXTEN EQU   IOBSTDRD+32
IOBSEEK  EQU   IOBEXTEN
IOBBB    EQU   IOBSEEK+1
IOBCC    EQU   IOBSEEK+3
IOBHH    EQU   IOBSEEK+5
IOBORG05 EQU   IOBEXTEN
IOBORG06 EQU   IOBEXTEN
IOBNXTPT EQU   IOBORG06+4
IOBSTATA EQU   IOBNXTPT
IOBORG07 EQU   IOBEXTEN+8
W1IEXTEN EQU   IOBORG07
IOBORG08 EQU   IOBEXTEN+8
IOBINDCT EQU   IOBORG08+4
IOBUNSQR EQU   IOBORG08+5
IOBFCHAD EQU   IOBORG08+8
IOBORG09 EQU   IOBEXTEN+8
IOBDPLAD EQU   IOBORG09+4
IOBDTYPE EQU   IOBORG09+8
IOBDTYP2 EQU   IOBORG09+9
IOBDSTAT EQU   IOBORG09+10
IOBSTAT1 EQU   IOBDSTAT
IOBORG10 EQU   IOBEXTEN+8
IOBSEEK2 EQU   IOBORG10
IOBORG11 EQU   IOBEXTEN
IOBERCT  EQU   IOBORG11
IOBUCBXV EQU   IOBERCT
IOBNAME  EQU   IOBORG11+4
IOBORG13 EQU   IOBEXTEN
IOBSKADR EQU   IOBORG13
FCAOPEN  EQU   DXATEXC1
FCAOPEN1 EQU   FCAOPEN
FCAOCOPY EQU   FCAOPEN1
FCAORDX  EQU   FCAOPEN1
FCAOBUF  EQU   FCAOPEN1
FCAOUSL  EQU   FCAOPEN1
FCAOSWA  EQU   FCAOPEN1
FCAOIOB  EQU   FCAOPEN1
FCAORECA EQU   FCAOPEN1
FCAOXTND EQU   FCAOPEN1
FCAOPEN2 EQU   FCAOPEN+1
FCAOIMGL EQU   FCAOPEN2
FCAOUCSL EQU   FCAOPEN2
FCAOFCBL EQU   FCAOPEN2
FCAOIOBC EQU   FCAOPEN2
FCACLOSE EQU   DXATEXC2
FCACLOS1 EQU   FCACLOSE
FCACFORC EQU   FCACLOS1
FCACRECA EQU   FCACLOS1
FCACBUFC EQU   FCACLOS1
FCACBUF  EQU   FCACBUFC
FCACBUFP EQU   FCACLOS1
FCACIOB  EQU   FCACLOS1
FCACSWA  EQU   FCACLOS1
FCACLOS2 EQU   FCACLOSE+1
FCACLOS3 EQU   FCACLOSE+2
FCACDELE EQU   FCACLOS3
FCACUSL  EQU   FCACLOS3
FCACRDX  EQU   FCACLOS3
DCBDEVIC EQU   DCBDEVT
DCBDEVDA EQU   DCBDEVIC
DCBRECFO EQU   DCBRECFM
DCBRECFF EQU   DCBRECFO
OPENWRKA EQU   DXCCW
DXSAVUCS EQU   OPENWRKA+40
DXIMGDCB EQU   OPENWRKA+56
DXSAVFCB EQU   OPENWRKA+64
DCBIOBAB EQU   DCBCICBA
XCTLPL   EQU   DXCCW1
XCTLPL01 EQU   XCTLPL
XCTLPL02 EQU   XCTLPL+1
XCTLPL03 EQU   XCTLPL+4
XCTLPL04 EQU   XCTLPL+5
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00158 EQU   OPENWRKA+60
@NM00157 EQU   OPENWRKA+48
@NM00156 EQU   OPENWRKA
@NM00155 EQU   DCBDEVIC
@NM00101 EQU   FCACLOS3
@NM00100 EQU   FCACLOS3
@NM00099 EQU   FCACLOS3
FCACIOBB EQU   FCACLOS2
FCACIOBU EQU   FCACLOS2
FCACIOBX EQU   FCACLOS2
FCACIOBP EQU   FCACLOS2
FCACDEQ  EQU   FCACLOS2
FCACPURG EQU   FCACLOS2
@NM00098 EQU   FCACLOS2
@NM00097 EQU   FCACLOS2
@NM00096 EQU   FCACLOS1
FCACFCR  EQU   FCACLOS1
IOBSKSS  EQU   IOBSKADR+3
IOBSK0   EQU   IOBSKADR+2
IOBSKTT  EQU   IOBSKADR+1
IOBSKRV  EQU   IOBSKADR
IOBCSWSV EQU   IOBORG11+17
IOBSENSV EQU   IOBORG11+16
IOBRCD   EQU   IOBORG11+12
IOBMDREC EQU   IOBORG11+8
IOBNAMEA EQU   IOBNAME+1
IOBNAMSZ EQU   IOBNAME
IOBERCTA EQU   IOBERCT+1
IOBRTYPE EQU   IOBUCBXV
IOBRDCHP EQU   IOBORG10+20
IOBNEXTA EQU   IOBORG10+16
IOBREADA EQU   IOBORG10+12
IOBBUFC  EQU   IOBORG10+8
IOBSK2R  EQU   IOBSEEK2+7
IOBSK2HH EQU   IOBSEEK2+5
IOBSK2CC EQU   IOBSEEK2+3
IOBSK2BB EQU   IOBSEEK2+1
IOBSK2M  EQU   IOBSEEK2
IOBCHNPR EQU   IOBORG09+40
IOBDNCRF EQU   IOBORG09+32
IOBRSV35 EQU   IOBORG09+24
IOBDQPTR EQU   IOBORG09+20
IOBRSV34 EQU   IOBORG09+18
IOBDBYTN EQU   IOBORG09+16
IOBDCPND EQU   IOBORG09+12
IOBSTAT2 EQU   IOBDSTAT+1
IOBSIORT EQU   IOBSTAT1
IOBADDVU EQU   IOBSTAT1
IOBBUFF  EQU   IOBSTAT1
IOBENQUE EQU   IOBSTAT1
IOBPASS2 EQU   IOBSTAT1
IOBSYNCH EQU   IOBSTAT1
IOBNEWVL EQU   IOBSTAT1
IOBABNRM EQU   IOBSTAT1
IOBRELEX EQU   IOBDTYP2
IOBADDTY EQU   IOBDTYP2
IOBTYPE  EQU   IOBDTYP2
IOBRQUST EQU   IOBDTYP2
IOBSUFFX EQU   IOBDTYP2
IOBSBLKL EQU   IOBDTYP2
IOBSKEY  EQU   IOBDTYP2
IOBRELBL EQU   IOBDTYPE
IOBRDEXC EQU   IOBDTYPE
IOBDYNBF EQU   IOBDTYPE
IOBACTAD EQU   IOBDTYPE
IOBFDBCK EQU   IOBDTYPE
IOBEXTSC EQU   IOBDTYPE
IOBOVFLO EQU   IOBDTYPE
IOBVERFY EQU   IOBDTYPE
IOBDPLB  EQU   IOBDPLAD+1
IOBDAYLI EQU   IOBDPLAD
IOBDIOBS EQU   IOBORG09+2
IOBDBYTR EQU   IOBORG09
IOBBCHAD EQU   IOBORG08+12
IOBFCHNB EQU   IOBFCHAD+1
IOBCOUNT EQU   IOBFCHAD
IOBASYN  EQU   IOBORG08+7
IOBAPP   EQU   IOBORG08+6
IOBRSV32 EQU   IOBUNSQR
IOBRSV31 EQU   IOBUNSQR
IOBRSV30 EQU   IOBUNSQR
IOBKNRWR EQU   IOBUNSQR
IOBKNWR  EQU   IOBUNSQR
IOBNTAV2 EQU   IOBUNSQR
IOBNTAV1 EQU   IOBUNSQR
IOBCPBSY EQU   IOBUNSQR
IOBCHNNL EQU   IOBINDCT
IOBRSV29 EQU   IOBINDCT
IOBRSV28 EQU   IOBINDCT
IOBRSV27 EQU   IOBINDCT
IOBKEYAD EQU   IOBINDCT
IOBOVPTR EQU   IOBINDCT
IOBUNSCH EQU   IOBINDCT
IOBDEQCP EQU   IOBINDCT
IOBCCWAD EQU   IOBORG08
W1OEXTEN EQU   W1IEXTEN
IOBCCW   EQU   IOBORG06+8
IOBNXTPB EQU   IOBNXTPT+1
IOBRSV26 EQU   IOBSTATA
IOBRSV25 EQU   IOBSTATA
IOBRSV24 EQU   IOBSTATA
IOBRSV23 EQU   IOBSTATA
IOBRSV22 EQU   IOBSTATA
IOBRSV21 EQU   IOBSTATA
IOBRSV20 EQU   IOBSTATA
IOBAVLFL EQU   IOBSTATA
IOBRSV37 EQU   IOBORG06+1
IOBUCBXG EQU   IOBORG06
IOBCPA   EQU   IOBORG05+32
IOBERINF EQU   IOBORG05+16
IOBERCCW EQU   IOBORG05+8
IOBSNDPT EQU   IOBORG05+7
IOBRCVPT EQU   IOBORG05+6
IOBWORK  EQU   IOBORG05+1
IOBUCBX  EQU   IOBORG05
IOBR     EQU   IOBSEEK+7
IOBHH2   EQU   IOBHH+1
IOBHH1   EQU   IOBHH
IOBCC2   EQU   IOBCC+1
IOBCC1   EQU   IOBCC
IOBBB2   EQU   IOBBB+1
IOBBB1   EQU   IOBBB
IOBM     EQU   IOBSEEK
IOBRSV46 EQU   IOBFL4
IOBRSV47 EQU   IOBFL4
IOBENT   EQU   IOBFL4
IOBEQP   EQU   IOBFL4
IOBBUS   EQU   IOBFL4
IOBDCK   EQU   IOBFL4
IOBREJ   EQU   IOBFL4
IOBOVR   EQU   IOBFL4
IOBCRILC EQU   IOBORG04+1
IOBCRDCC EQU   IOBORG04
IOBGQECB EQU   IOBORG03
IOBSWAP  EQU   IOBORG02+4
IOBDQADB EQU   IOBDQADA+1
IOBRSV13 EQU   IOBDEQIN
IOBRSV12 EQU   IOBDEQIN
IOBRSV11 EQU   IOBDEQIN
IOBRSV10 EQU   IOBDEQIN
IOBRSV09 EQU   IOBDEQIN
IOBRSV08 EQU   IOBDEQIN
IOBRSV07 EQU   IOBDEQIN
IOBDEQ   EQU   IOBDEQIN
IOBNECB  EQU   IOBORG01+4
IOBFIRST EQU   IOBNFLG1
IOBUPERR EQU   IOBNFLG1
IOBSPAN  EQU   IOBNFLG1
IOBBKSPC EQU   IOBNFLG1
IOBUPDAT EQU   IOBNFLG1
IOBREAD  EQU   IOBNFLG1
IOBWRITE EQU   IOBNFLG1
IOBSEGMT EQU   IOBPRTOV
DXRESIND EQU   @NM00084
DXSAVOFF EQU   @NM00083+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00083
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00068 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00067 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00066 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
@NM00062 EQU   BUFNXPTA
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
@NM00161 EQU   REG00T12
REGSAV15 EQU   REG14T12+4
@NM00160 EQU   REGSAVAR
WRKWTGT  EQU   WRKAREA+16
@NM00159 EQU   WRKPARML+2
WRKMODID EQU   WRKPARML
@NM00154 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00153 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00152 EQU   SDWA+396
SDWARCPL EQU   SDWA+364
@NM00151 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00150 EQU   SDWADDAT+3
@NM00149 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00148 EQU   SDWADDAT+1
@NM00147 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00146 EQU   SDWADUMP+2
@NM00145 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00144 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00143 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00142 EQU   SDWAACF3
@NM00141 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00140 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00139 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00138 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00137 EQU   SDWA+239
@NM00136 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00135 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00134 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00133 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00132 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00131 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00130 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00129 EQU   SDWAINC2
@NM00128 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00127 EQU   SDWAILC2
@NM00126 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00125 EQU   SDWANXT2
@NM00124 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00123 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00122 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00121 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00120 EQU   SDWAINC1
@NM00119 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00118 EQU   SDWAILC1
@NM00117 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00116 EQU   SDWANXT1
@NM00115 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00114 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00113 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00112 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00111 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00110 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00109 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00108 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00107 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
@NM00106 EQU   CRSIECNT+8
CRSFCXRC EQU   CRSIECNT+3
@NM00105 EQU   CRSIECDA
CRSEOFM  EQU   CRSIECDA
CRSDSCB  EQU   CRSIECDA
CRSNSL   EQU   CRSIECTP
CRSDISP  EQU   CRSIECTP
CRSEOF2T EQU   CRSIECTP
CRSEOF1T EQU   CRSIECTP
CRSEOF2  EQU   CRSIECTP
CRSEOF1  EQU   CRSIECTP
CRSTM2AD EQU   CRSIECTP
CRSTMAD  EQU   CRSIECTP
CRSREOPN EQU   CRSIECFC
@NM00104 EQU   CRSIECFC
CRSFCCOM EQU   CRSIECFC
CRSFCINC EQU   CRSIECFC
CRSOPMOD EQU   CRSIECFC
CRSFCAT  EQU   CRSIECFC
CRSLAST  EQU   CRSIECFC
@NM00103 EQU   CRSIECBS+1
CRSIECFN EQU   CRSIECBS
@NM00102 EQU   CRSIECHD+8
CRSIECKY EQU   CRSIECHD+7
CRSIECSP EQU   CRSIECHD+6
CRSIECLN EQU   CRSIECHD+4
CRSIECMM EQU   CRSIECHD+3
CRSIECID EQU   CRSIECHD
SWATTR   EQU   SWACB+8
SWACBPTR EQU   SWACB
RDXUQND  EQU   RDXENTRY+12
RDXIOBUQ EQU   RDXENTRY+8
RDXNQARG EQU   RDXENTRY
RDXENT   EQU   RDXLIST+8
RDXNEXT  EQU   RDXLIST+4
RDXRSV01 EQU   RDXLIST
IOBERRCT EQU   IOBSTDRD+30
IOBRSV19 EQU   IOBINCAM+1
IOBOLTST EQU   IOBBTAMF
IOBRFTMG EQU   IOBBTAMF
IOBRSV17 EQU   IOBBTAMF
IOBRSV16 EQU   IOBBTAMF
IOBRSV15 EQU   IOBBTAMF
IOBRSV14 EQU   IOBBTAMF
IOBINUSE EQU   IOBBTAMF
IOBPRMER EQU   IOBBTAMF
IOBRSTRB EQU   IOBRESTR+1
IOBREPOS EQU   IOBRESTR
IOBDCBPB EQU   IOBDCBPT+1
IOBRSV44 EQU   IOBFLAG4
IOBJES3I EQU   IOBFLAG4
IOBRSV42 EQU   IOBFLAG4
IOBRSV41 EQU   IOBFLAG4
IOBRSV40 EQU   IOBFLAG4
IOBPMERR EQU   IOBFLAG4
IOBCC3WE EQU   IOBFLAG4
IOBGDPOL EQU   IOBFLAG4
IOBSTRTB EQU   IOBSTART+1
IOBSIOCC EQU   IOBSTART
IOBCSB7  EQU   IOBCSTAT
IOBCSB6  EQU   IOBCSTAT
IOBCSB5  EQU   IOBCSTAT
IOBCSB4  EQU   IOBCSTAT
IOBCSB3  EQU   IOBCSTAT
IOBCSB2  EQU   IOBCSTAT
IOBCSB1  EQU   IOBCSTAT
IOBCSB0  EQU   IOBCSTAT
IOBUSB7  EQU   IOBUSTAT
IOBUSB6  EQU   IOBUSTAT
IOBUSB5  EQU   IOBUSTAT
IOBUSB4  EQU   IOBUSTAT
IOBUSB3  EQU   IOBUSTAT
IOBUSB2  EQU   IOBUSTAT
IOBUSB1  EQU   IOBUSTAT
IOBUSB0  EQU   IOBUSTAT
IOBCMDA  EQU   IOBIOCSW
IOBLOG   EQU   IOBFL3
IOBJAM   EQU   IOBICL
IOBMSG   EQU   IOBFL3
IOBSDR   EQU   IOBCNC
IOBACU   EQU   IOBFL3
IOBCDC   EQU   IOBFL3
IOBICC   EQU   IOBFL3
IOBCCC   EQU   IOBFL3
IOBECBPB EQU   IOBECBPT+1
IOBECBCC EQU   IOBECBPT
IOBS1B7  EQU   IOBSENS1
IOBS1B6  EQU   IOBSENS1
IOBS1B5  EQU   IOBSENS1
IOBS1B4  EQU   IOBSENS1
IOBS1B3  EQU   IOBSENS1
IOBS1B2  EQU   IOBSENS1
IOBS1B1  EQU   IOBSENS1
IOBS1B0  EQU   IOBSENS1
IOBSNSC9 EQU   IOBS0B7
IOBS0B6  EQU   IOBSENS0
IOBS0B5  EQU   IOBSENS0
IOBS0B4  EQU   IOBSENS0
IOBS0B3  EQU   IOBSENS0
IOBS0B2  EQU   IOBSENS0
IOBS0B1  EQU   IOBSENS0
IOBS0B0  EQU   IOBSENS0
IOBPNCH  EQU   IOBFLAG2
IOBSTATO EQU   IOBFLAG2
IOBSKUPD EQU   IOBFLAG2
IOBALTTR EQU   IOBFLAG2
IOBRRT2  EQU   IOBRDHA0
IOBRRT3  EQU   IOBPURGE
IOBSENSE EQU   IOBFLAG2
IOBHALT  EQU   IOBFLAG2
IOBSPSVC EQU   IOBRSTRT
IOBUNREL EQU   IOBFLAG1
IOBIOERR EQU   IOBFLAG1
IOBFCREX EQU   IOBCYCCK
IOBRPSTN EQU   IOBFLAG1
IOBERRTN EQU   IOBFLAG1
IOBCMDCH EQU   IOBFLAG1
IOBDATCH EQU   IOBFLAG1
IOBCNOPA EQU   IOBPREFX+12
IOBCICB  EQU   IOBPREFX+8
IOBCECB  EQU   IOBPREFX+4
IOBCONOP EQU   IOBPREFX+3
IOBCINOP EQU   IOBPREFX+2
IOBRSV05 EQU   IOBPREFX+1
IOBPCI   EQU   IOBCFLG1
IOBRSTCH EQU   IOBCFLG1
IOBABAPP EQU   IOBCFLG1
IOBPTST  EQU   IOBCFLG1
IOBRSV04 EQU   IOBCFLG1
IOBRSV03 EQU   IOBCFLG1
IOBRSV02 EQU   IOBCFLG1
IOBRSV01 EQU   IOBCFLG1
DXATEXB2 EQU   DXATEXC2
DXEXHASP EQU   DXATEXB1
DXATCOM3 EQU   FORCORE+596
@NM00095 EQU   DXATCOM2+3
@NM00094 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00093 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00092 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
DXPACBAD EQU   DXPDCBAD+1
@NM00091 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00090 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00089 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDSAB   EQU   FORCORE+548
DXDSABAD EQU   FORCORE+544
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00088 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXDCBDEB EQU   DXDCB+44
@NM00087 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00086 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00085 EQU   DXDAADDR
DXIOB    EQU   FORCORE+280
DXECB    EQU   FORCORE+276
DXJBF    EQU   FORCORE+100
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00082 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00081 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00080 EQU   WTGAREA+20
@NM00079 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
@NM00078 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00077 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00076 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00075 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00074 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00073 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00072 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00071 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECWTGTB EQU   IECEXTPR+72
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00070 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00069 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
@NM00065 EQU   USL+20
USLSLOT1 EQU   USL+16
USLCHAIN EQU   USL+12
USLIOB2  EQU   USLBFRQB+1
@NM00064 EQU   USLBFRQB
USLIOB1  EQU   USLBFRQT+1
USLFLAGS EQU   USLBFRQT
@NM00063 EQU   USL+2
USLSIZE  EQU   USL
BCBNXBUF EQU   BCBDEFS
BCBTBRS  EQU   BCBDEFR+12
BCBNABFR EQU   BCBDEFR+8
BCBFRQB  EQU   BCBIOBS+4
BCBFRQT  EQU   BCBIOBS
BCBRAOFS EQU   BCBDEFV+9
BCBBFAVL EQU   BCBDEFV+8
BCBBUFL  EQU   BCBDEFV+4
BCBBUF1  EQU   BCBDEFV
LRIDATA  EQU   LRIALIGN
@NM00061 EQU   LRIAREA+22
LRICOUNT EQU   LRIAREA+20
LRINXIOB EQU   LRINIOB+1
@NM00060 EQU   LRINIOB
LRIRECAD EQU   LRITRKAD+5
LRIMBBCC EQU   LRITRKAD
LRIPOS   EQU   LRILOC+6
LRIINDEX EQU   LRILOC+5
LRIASSEM EQU   LRIFLG2
@NM00059 EQU   LRIFLG2
LRINTSPN EQU   LRIFLG2
@NM00058 EQU   LRIFLG2
LRISEG   EQU   LRIFLG2
@NM00057 EQU   LRIFLG2
LRIRELSE EQU   LRIFLG2
@NM00056 EQU   LRIFLG2
LRIEOB   EQU   LRIFLG1
LRICOD   EQU   LRIFLG1
LRIEOD   EQU   LRIFLG1
BCBPAD   EQU   BCBLK+12
@NM00055 EQU   BCBLRIAR
BCBEXTND EQU   BCBFLGS
BCBLRI   EQU   BCBFLGS
@NM00054 EQU   BCBBUFPT
DEBXRV40 EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBRSV19 EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00053 EQU   DEBACS08+12
@NM00052 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00051 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00050 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
DCBEOB   EQU   IHADCS40+20
DCBPRECL EQU   IHADCS40+18
@NM00049 EQU   IHADCS40+16
@NM00048 EQU   @NM00046+1
@NM00047 EQU   DCBEROPT
DCBERABE EQU   DCBEROPT
DCBERSKP EQU   DCBEROPT
DCBERACC EQU   DCBEROPT
@NM00045 EQU   IHADCS40+10
@NM00044 EQU   IHADCS40+9
@NM00043 EQU   IHADCS40+8
DCBRECA  EQU   DCBRECAD+1
@NM00042 EQU   DCBRECBT
DCBRCFGT EQU   DCBRCREL
DCBRCTRU EQU   DCBRCREL
DCBLCCW  EQU   DCBEOBAD
DCBPERRA EQU   DCBGERRA
@NM00041 EQU   DCBPERR
DCBNOTE  EQU   DCBCNTRL
DCBLRECL EQU   IHADCS38+10
@NM00040 EQU   IHADCS38+8
DCBEOBRA EQU   DCBEOBR+1
DCBNCP   EQU   DCBEOBR
@NM00039 EQU   DCBFLAG1
DCBSTFLS EQU   DCBFLAG1
DCBSTQCK EQU   DCBFLAG1
DCBDIRCQ EQU   DCBBUFOF
DCBQSTRU EQU   DCBUSASI
@NM00038 EQU   DCBUSASI
DCBQADF3 EQU   DCBQADFS
DCBQADF2 EQU   DCBQADFS
DCBQADF1 EQU   DCBQADFS
DCBBLBP  EQU   DCBUSASI
@NM00037 EQU   DCBUSASI
@NM00036 EQU   DCBCICB
DCBWCPL  EQU   IHADCS36+13
DCBWCPO  EQU   IHADCS36+12
@NM00035 EQU   IHADCS36+10
DCBCNFEO EQU   DCBCIND2
DCBCNBFP EQU   DCBCIND2
DCBCNIOE EQU   DCBCIND2
DCBCNCLO EQU   DCBCIND2
DCBCNWRO EQU   DCBCIND2
DCBCNSTO EQU   DCBCIND2
@NM00034 EQU   DCBCIND1
DCBCNBRM EQU   DCBCIND1
@NM00033 EQU   DCBCIND1
DCBCNEVA EQU   DCBCIND1
DCBCNEVB EQU   DCBCIND1
DCBCNSRD EQU   DCBCIND1
DCBCNTOV EQU   DCBCIND1
@NM00032 EQU   @NM00031+1
DCBIOBL  EQU   @NM00031
@NM00030 EQU   @NM00028+1
DCBOPTJ  EQU   @NM00029
DCBOPTT  EQU   @NM00029
DCBSRCHD EQU   DCBOPTZ
DCBOPTQ  EQU   @NM00029
DCBBCKPT EQU   DCBOPTO
DCBOPTC  EQU   @NM00029
DCBOPTU  EQU   @NM00029
DCBOPTW  EQU   @NM00029
DCBDFBK  EQU   IHADCS30+44
DCBDFOR  EQU   IHADCS30+40
DCBDRDXA EQU   DCBDRDX+1
DCBMVXNO EQU   DCBDRDX
DCBXARGA EQU   DCBXARG+1
DCBXCNT  EQU   DCBXARG
DCBLIMCT EQU   IHADCS30+29
@NM00027 EQU   IHADCS30+28
DCBUQND  EQU   IHADCS30+24
DCBIOBUQ EQU   IHADCS30+20
DCBSQND  EQU   IHADCS30+16
DCBIOBSQ EQU   IHADCS30+12
@NM00026 EQU   IHADCS30+8
DCBSYNAD EQU   IHADCS30+4
DCBCHCKA EQU   DCBCHECK+1
DCBOPTRB EQU   DCBOPTCD
DCBOPTRE EQU   DCBOPTCD
DCBOPTDB EQU   DCBOPTCD
DCBOPTA  EQU   DCBOPTCD
DCBOPTF  EQU   DCBOPTCD
DCBOPTE  EQU   DCBOPTCD
DCBOPTTO EQU   DCBOPTCD
@NM00025 EQU   DCBOPTCD
DCBPUTA  EQU   DCBGETA
@NM00024 EQU   DCBPUT
DCBREADA EQU   DCBWRITA
@NM00023 EQU   DCBREAD
DCBDEBA  EQU   DCBDEBAD+1
@NM00022 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00021 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBRECKL EQU   DCBRECFM
DCBRECCC EQU   DCBRECFM
DCBRECSB EQU   DCBRECFM
DCBRECBR EQU   DCBRECFM
DCBRECTO EQU   DCBRECLA
DCBRECL  EQU   DCBRECLA
DCBEODA  EQU   DCBEODAD+1
DCBBFA   EQU   DCBBFTEK
DCBH0    EQU   DCBBFTEK
DCBBFTKD EQU   DCBBFTEK
DCBBFTE  EQU   DCBBFT
DCBBFTKR EQU   DCBBFT
DCBBFTS  EQU   DCBBFT
DCBH1    EQU   DCBBFTEK
DCBSVCXA EQU   DCBSVCXL+1
@NM00020 EQU   DCBSVCXL
DCBODEBA EQU   DCBIOBAA
@NM00019 EQU   DCBQSLM
DCBUPDBT EQU   DCBQSLM
DCBUPDCM EQU   DCBQSLM
DCB1DVDS EQU   DCBQSLM
@NM00018 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00017 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
@NM00016 EQU   DCBDSRG1
@NM00015 EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBDSGIS EQU   DCBDSRG1
DCBBUFL  EQU   IHADCS11+8
DCBKEYLE EQU   DCBRELB
@NM00014 EQU   IHADCS08+15
DCBORDCK EQU   DCBEIB
DCBORHPR EQU   DCBEIB
DCBORWLR EQU   DCBEIB
DCBORECK EQU   DCBEIB
DCBORERR EQU   DCBEIB
DCBORREJ EQU   DCBEIB
DCBORNRM EQU   DCBEIB
@NM00013 EQU   DCBEIB
@NM00012 EQU   IHADCS08+13
@NM00011 EQU   DCBORBYT
DCBORBFP EQU   DCBORBYT
DCBOREOF EQU   DCBORBYT
DCBORSYN EQU   DCBORBYT
DCBRDLNA EQU   DCBFRTBA+5
DCBRESCA EQU   DCBFRTBA+1
@NM00010 EQU   DCBFRTBA
DCBDSPLA EQU   DCBFRID+1
@NM00009 EQU   DCBFRID
@NM00008 EQU   DCBERRCA+2
@NM00007 EQU   DCBORFLG
DCBEOPFG EQU   DCBORFLG
DCBLFMAT EQU   DCBERRCA
DCBLNNUM EQU   DCBERRCN
DCBWTOIA EQU   DCBWTOID+1
@NM00006 EQU   DCBWTOID
DCBTRBAL EQU   IHADCS01+6
@NM00005 EQU   IHADCS01+5
@NM00004 EQU   IHADCS01+4
DCBDVTBA EQU   DCBDVTBL+1
@NM00003 EQU   DCBDVTBL
DCBKEYCN EQU   IHADCS00+4
DCBRELAD EQU   IHADCS00
@NM00002 EQU   IHADCB
@NM00001 EQU   CCW+5
CCWPCI   EQU   CCWFLGS
CCWSKIP  EQU   CCWFLGS
CCWSLI   EQU   CCWFLGS
CCWCC    EQU   CCWFLGS
CCWCD    EQU   CCWFLGS
CCWCOMCD EQU   CCWADDRA
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00127 EQU   EXITRTN
@RT00132 EQU   XCTLRTN
@RT00139 EQU   BDAMRTN
@RT00142 EQU   SAMIOB
@RT00144 EQU   SAMIOB
@RT00175 EQU   SAMBUFLN
@RT00203 EQU   SAMBUFL2
@RT00205 EQU   SAMBUFFR
@RF00205 EQU   SAMIOB
@RC00317 EQU   @RC00316
@ENDDATA EQU   *
         END   IGG020T1,(C'PLS0136',0701,76154)
