        TITLE '*****  IGG026DU    CATALOG CONTROLLER 3 DUMMY MODULE'
IGG026DU CSECT
**********************************************************************
*                                                                    *
*        MODULE NAME - IGG026DU                                      *
*                                                                    *
*        DESCRIPTIVE NAME - CATALOG CONTROLLER LEVEL 3 DUMMY MODULE  *
*                                                                    *
*        COPYRIGHT - NONE                                            *
*                                                                    *
*        STATUS - VS/2 RELEASE 3.7                                   *
*                                                                    *
*        FUNCTION                                                    *
*          THIS MODULE IS THE FIRST LOAD OF SVC 26 (CATALOG          *
*          MANAGEMENT). IT IS A DUMMY CSECT WHICH IMMEDIATELY PASSES *
*          CONTROL TO CATALOG MODULE IGC0002F WITHOUT CHANGING ANY   *
*          REGISTERS EXCEPT REGISTER 15.                             *
*                                                                    *
*          THIS CSECT MAY BE REPLACED BY A USER WRITTEN ROUTINE      *
*          IF DESIRED TO PERFORM PROCESSING BEFORE OR AFTER THE      *
*          SYSTEM CATALOG ROUTINES RECEIVE CONTROL.                  *
*                                                                    *
*          ANY USER WRITTEN ROUTINE WHICH REPLACES THIS CSECT MUST   *
*          BE RE-ENTRANT AND PASS CONTROL TO THE FIRST CATALOG       *
*          MODULE IGC0002F WITH THE REGISTER CONTENTS CONFORMING     *
*          TO STANDARD SVC ROUTINE CONVENTIONS. REGISTER 1 MUST      *
*          CONTAIN THE ADDRESS OF THE CATALOG PARAMETER LIST.        *
*                                                                    *
*          IF THE USER WRITTEN ROUTINE NEEDS TO SAVE REGISTERS,      *
*          IT MUST PROVIDE A RE-ENTRANT SAVE AREA TO SAVE AND        *
*          RESTORE ITS REGISTERS.  THE SVRB SAVE AREA SHOULD NOT     *
*          BE USED SINCE IT IS USED BY THE CATALOG ROUTINES.         *
*                                                                    *
*          DEPENDENCIES - EBCDIC CHARACTER CODE DEPENDENCIES - THIS  *
*                         MODULE MUST BE COMPILED AND EXECUTED ON    *
*                         A MACHINE WITH AN EBCDIC CHARACTER SET.    *
*
*                                                                    *
*          RESTRICTIONS - NONE                                       *
*                                                                    *
*          REGISTER CONVENTIONS -                                    *
*            UPON ENTRY TO IGG026DU:                                 *
*              R1 = CATALOG PARAMETER LIST ADDRESS                   *
*              R3 = POINTER TO CVT                                   *
*              R4 = POINTER TO TCB                                   *
*              R5 = POINTER TO SVRB                                  *
*             R14 = ADDRESS OF EXIT PROLOG                           *
*                                                                    *
*        MODULE TYPE - PROCEDURE                                     *
*                                                                    *
*          PROCESSOR - ASSEMBLER                                     *
*                                                                    *
*          MODULE SIZE - SEE LENGTH PRINTED IN EXTERNAL SYMBOL       *
*            DICTIONARY IN ASSEMBLY LISTING.                         *
*                                                                    *
*          ATTRIBUTES - REENTRANT AND READ-ONLY                      *
*                                                                    *
*        ENTRY POINT -                                               *
*          THE ONLY EXTERNAL ENTRY POINT OF THIS MODULE IS THE       *
*          MODULE NAME - IGG026DU. INVOKED BY SVC 26.                *
*                                                                    *
*          PURPOSE - TO ALLOW A USER WRITTEN ROUTINE TO BE EASILY    *
*                    PLACED BEFORE THE ENTRY POINT OF CATALOG.       *
*                                                                    *
*          LINKAGE - IGG026DU IS THE FIRST LOAD OF SVC 26 AND IS     *
*                    ENTERED VIA STANDARD LINKAGE CONVENTIONS        *
*                    WHENEVER SVC 26 IS INVOKED.                     *
*                                                                    *
*          INPUT -                                                   *
*            INPUT IS IN THE FORM OF A CATALOG REQUEST PARAMETER     *
*            LIST POINTED TO BY REGISTER 1.  THE LIST MAY BE IN THE  *
*            FORM OF AN OS/VS CAMLST OR A VSAM REQUEST LIST.         *
*                                                                    *
*          OUTPUT - REGISTER 15 CONTAINS THE ENTRY POINT ADDRESS OF  *
*            CATALOG MODULE IGC0002F. REGISTERS 0 - 14 ARE THE SAME  *
*            AS THEY WERE UPON ENTRY TO IGG026DU.                    *
*                                                                    *
*          EXIT NORMAL -                                             *
*            CONTROL IS PASSED TO THE CATALOG CONTROLLER MODULE      *
*            IGC0002F.                                               *
*                                                                    *
*          EXIT ERROR - NONE                                         *
*                                                                    *
*        EXTERNAL REFERENCES - NONE                                  *
*                                                                    *
*          DATA SETS - NONE                                          *
*                                                                    *
*          DATA AREAS - NONE                                         *
*                                                                    *
*        TABLES - NONE                                               *
*                                                                    *
*        MACROS - NONE                                               *
*                                                                    *
*        CHANGE ACTIVITY -                                           *
*                                                                    *
*    MODULE NEW FOR VS2-3.7  SU60                              @G60ASBJ
*                                                                    *
**********************************************************************
*REGISTER USAGE:
R0       EQU   0                       REGISTER 0 - NOT CHANGED
R15      EQU   15                      BASE REGISTER - ENTRY POINT ADDR
         SPACE 3
         BALR  R15,R0                  INITIALIZE REGISTER 15
         USING *,R15                   ESTABLISH BASE REGISTER
         L     R15,IGC0002F            GET ADDRESS OF IGC0002F ENTRY
         BR    R15                     TRANSFER CONTROL TO IGC0002F
IGC0002F DC    V(IGC0002F)             ENTRY POINT ADDRESS OF IGC0002F
         END
