 TITLE 'IGG029DU - DADSM SCRATCH - DUMMY MODULE ENTRY POINT'
IGG029DU CSECT
**********************************************************************
*                                                                    *
*MODULE NAME - IGG029DU                                              *
*                                                                    *
*DESCRIPTIVE NAME - DADSM SCRATCH - ENTRY POINT DUMMY MODULE         *
*                                                                    *
*COPYRIGHT - NONE                                                    *
*                                                                    *
*CHANGE ACTIVITY -                                                   *
*                                                                    *
*                  MODULE NEW FOR VS2-3.7  SU60                @G60ASBJ
*                                                                    *
*STATUS CHANGE LEVEL 000                                             *
*                                                                    *
*ATTRIBUTES - REENTRANT                                              *
*                                                                    *
*FUNCTION - THIS MODULE IS THE ENTRY POINT TO SCRATCH (SVC 29).      *
*          IT IS A DUMMY CSECT WHICH IMMEDIATELY PASSES CONTROL TO   *
*          SCRATCH MODULE IGC0002I WITHOUT CHANGING ANY REGISTERS    *
*          EXCEPT REGISTER 15.                                       *
*                                                                    *
*          THIS CSECT MAY BE REPLACED BY A USER WRITTEN ROUTINE      *
*          IF DESIRED TO PERFORM PROCESSING BEFORE OR AFTER THE      *
*          SYSTEM SCRATCH ROUTINES RECEIVE CONTROL.                  *
*                                                                    *
*          ANY USER WRITTEN ROUTINE WHICH REPLACES THIS CSECT MUST   *
*          BE RE-ENTRANT AND PASS CONTROL TO THE FIRST SCRATCH       *
*          MODULE IGC0002I WITH THE REGISTER CONTENTS CONFORMING     *
*          TO STANDARD SVC ROUTINE CONVENTIONS. REGISTER 1 MUST      *
*          CONTAIN THE ADDRESS OF THE SCRATCH PARAMETER LIST WITH    *
*          THE SAME FORMAT AS DESCRIBED BELOW UNDER INPUT.           *
*                                                                    *
*          IF THE USER WRITTEN ROUTINE NEEDS TO SAVE REGISTERS,      *
*          IT MUST PROVIDE A RE-ENTRANT SAVE AREA TO SAVE AND        *
*          RESTORE ITS REGISTERS.  THE SVRB SAVE AREA SHOULD NOT     *
*          BE USED SINCE IT IS USED BY THE SCRATCH ROUTINES.         *
*                                                                    *
*ENTRIES - THE ONLY ENTRY POINT TO THIS MODULE IS IGG029DU. ENTRY IS *
*          MADE BY SVC 29.                                           *
*                                                                    *
*SUPERVISOR CALLS AND EXTERNAL ROUTINES USED BY THIS MODULE - NONE   *
*                                                                    *
*OTHER MACROS ISSUED - NONE                                          *
*                                                                    *
*INPUT -   AT ENTRY TO THIS MODULE REGISTER 1 POINTS TO THE PARAMETER*
*          LIST.  REGISTER 0 MAY POINT TO A UCB, OR IT MAY CONTAIN NO*
*          ADDRESS. THE PARAMETER LIST CONSISTS OF 4 WORDS:          *
*                                                                    *
*          WORD 1 - CHECK PURGE DATE = X'41004000'                   *
*                 - OVERRIDE PURGE DATE = X'41005000'                *
*                   BIT 0 OF THE 2ND OPTION BYTE IS SET BY DYNAMIC   *
*                   UNALLOCATION AND BY JOB AND STEP TERMINATION     *
*                   TO INDICATE NOT TO INVOKE DYNAMIC ALLOCATION.    *
*                                                                    *
*                   IF THE SECOND WORD OF THE SECOND BYTE IS         *
*                   SET TO 1, AND IF (1) THE CALLER IS               *
*                   AUTHORIZED AND (2) RACF IS ACTIVE IN THE         *
*                   SYSTEM AND (3) THE JSCBPASS BIT IN THE           *
*                   JSCB IS SET TO 1, THEN THE RACDEF PROFILE        *
*                   DELETE IN SCRATCH MODULE IGG0299A WILL BE        *
*                   BYPASSED.                                        *
*                                                                    *
*                   BIT 0 OF THE THIRD OPTION BYTE IS SET BY         *
*                   DYNAMIC UNALLOCATION TO INDICATE THAT THE        *
*                   TIOT HAS ALREADY BEEN ENQ'ED.                    *
*                                                                    *
*          WORD 2 - ADDRESS OF THE DATA SET NAME                     *
*                   IF BIT 0 IS SET, ENTRY IS FROM JOB TERMINATION   *
*                   OR FROM STEP TERMINATION.  IF BIT 1 IS SET, ENTRY*
*                   IS FROM THE READER OR WRITER.                    *
*                                                                    *
*          WORD 3 - NOT USED                                         *
*                                                                    *
*          WORD 4 - ADDRESS OF THE VOLUME LIST                       *
*                                                                    *
*          THE VOLUME LIST IS VARIABLE IN LENGTH. THE FIRST TWO BYTES*
*          INDICATE THE NUMBER OF 12 BYTE VOLUME ID FIELDS WHICH     *
*          FOLLOW. A 12 BYTE VOLUME ID FIELD CONTAINS A FOUR BYTE    *
*          DEVICE CODE, SIX BYTE VOLUME SERIAL NUMBER, ONE BYTE SPARE*
*          AND ONE BYTE USED FOR RETURNING THE STATUS OF THE DATA SET*
*          ON THAT VOLUME AS FOLLOWS:                                *
*                                                                    *
*                    BINARY 0 - SUCCESSFUL SCRATCH                   *
*                    BINARY 1 - DSCB NOT FOUND IN VTOC               *
*                    BINARY 2 - PASSWORD DIFFICULITY                 *
*                    BINARY 3 - UNEXPIRED PURGE DATE                 *
*                    BINARY 4 - PERMANENT I/O ERROR                  *
*                    BINARY 5 - APPROPRIATE UCB UNAVAILABLE          *
*                    BINARY 6 - OPERATOR UNABLE TO MOUNT VOLUME      *
*                    BINARY 7 - DATA SET IS OPEN                     *
*                    BINARY 8 - THE DSCB INDICATES THAT THE DATA SET *
*                               IS DEFINED TO RACF BUT EITHER THE    *
*                               ACCESSOR IS NOT AUTHORIZED TO THE    *
*                               DATA SET OR TO THE VOLUME OR THE     *
*                               DATA SET IS A VSAM DATA SPACE OR THE *
*                               DATA SET IS NOT ACTUALLY DEFINED TO  *
*                               RACF.                                *
*                                                                    *
*                                                                    *
*OUTPUT -  REGISTER 15 CONTAINS THE ENTRY POINT ADDRESS OF THE NEXT  *
*          LOAD OF SCRATCH (IGC0002I). REGISTERS 0 - 14 CONTAIN THE  *
*          SAME VALUES AS THEY DID UPON ENTRY TO IGG029DU.           *
*                                                                    *
*ERROR CONDITIONS - NONE                                             *
*                                                                    *
*STORAGE - PROGRAM CODE = 12 BYTES.                                  *
*                                                                    *
*ERROR CONDITIONS IN THIS MODULE - NONE                              *
*                                                                    *
**********************************************************************
*REGISTER USAGE:
R0       EQU   0                        REGISTER 0 - NOT CHANGED
R15      EQU   15                       BASE REGISTER - ENTRY ADDRESS
         SPACE 3
         BALR  R15,R0                   LOAD REGISTER 15
         USING *,R15                    ESTABLISH BASE REGISTER
         L     R15,IGC0002I             GET IGC0002I ENTRY ADDRESS
         BR    R15                      TRANSFER CONTROL TO IGC0002I
IGC0002I DC    V(IGC0002I)              ADDRESS OF IGC0002I
         END
