         TITLE 'IGG030DU - DADSM RENAME DUMMY MODULE ENTRY POINT'
IGG030DU CSECT
**********************************************************************
*                                                                    *
* STATUS CHANGE LEVEL 000                                            *
*                                                                    *
*MODULE NAME - IGG030DU                                              *
*                                                                    *
*DESCRIPTIVE NAME - DADSM RENAME DUMMY MODULE.                       *
*                                                                    *
*COPYRIGHT - NONE                                                    *
*                                                                    *
*CHANGE ACTIVITY -                                                   *
*          VS2-3.7  MODULE NEW FOR SU60                        @G60ASBJ
*                                                                    *
*ATTRIBUTES - REENTRANT                                              *
*                                                                    *
*FUNCTION - THIS MODULE IS THE ENTRY POINT TO RENAME  (SVC 30).      *
*          IT IS A DUMMY CSECT WHICH IMMEDIATELY PASSES CONTROL TO   *
*          RENAME MODULE IGC00030 WITHOUT CHANGING ANY REGISTERS     *
*          EXCEPT REGISTER 15.                                       *
*                                                                    *
*          THIS CSECT MAY BE REPLACED BY A USER WRITTEN ROUTINE      *
*          IF DESIRED TO PERFORM PROCESSING BEFORE OR AFTER THE      *
*          SYSTEM RENAME ROUTINES RECEIVE CONTROL.                   *
*                                                                    *
*          ANY USER WRITTEN ROUTINE WHICH REPLACES THIS CSECT MUST   *
*          BE RE-ENTRANT AND PASS CONTROL TO THE FIRST RENAME        *
*          MODULE IGC00030 WITH THE REGISTER CONTENTS CONFORMING     *
*          TO STANDARD SVC ROUTINE CONVENTIONS. REGISTER 1 MUST      *
*          CONTAIN THE ADDRESS OF A RENAME PARAMETER LIST WITH THE   *
*          SAVE FORMAT AS SHOWN BELOW UNDER INPUT.                   *
*                                                                    *
*          IF THE USER WRITTEN ROUTINE NEEDS TO SAVE REGISTERS,      *
*          IT MUST PROVIDE A RE-ENTRANT SAVE AREA TO SAVE AND        *
*          RESTORE ITS REGISTERS.  THE SVRB SAVE AREA SHOULD NOT     *
*          BE USED SINCE IT IS USED BY THE RENAME ROUTINES.          *
*                                                                    *
*ENTRIES - THE ONLY ENTRY POINT TO THIS MODULE IS IGG030DU. ENTRY IS *
*          MADE BY ISSUING AN SVC 30.                                *
*                                                                    *
*SUPERVISOR CALLS AND EXTERNAL ROUTINES USED BY THIS MODULE - NONE   *
*                                                                    *
*OTHER MACROS USED: NONE                                             *
*                                                                    *
*INPUT -   AT ENTRY TO THIS MODULE, REGISTER 1 POINTS TO THE         *
*          PARAMETER LIST. REGISTER 0 MAY OR MAY NOT CONTAIN A UCB   *
*          ADDRESS. THE PARAMETER LIST CONSISTS OF FOUR WORDS:       *
*                                                                    *
*                    WORD 1 - RENAME = X'41002000'                   *
*                                                                    *
*                             IF THE SECOND BIT OF THE SECOND BYTE   *
*                             IS SET TO 1 AND IF (1) THE CALLER IS   *
*                             AUTHORIZED AND (2) RACF IS ACTIVE IN   *
*                             THE SYSTEM AND (3) THE JSCBPASS BIT    *
*                             IN THE JSCB IS SET TO ONE, THEN THE    *
*                             RACDEF IN RENAME MODULE IGG03001 WILL  *
*                             WILL BE BYPASSED.                      *
*                                                                    *
*                    WORD 2 - ADDR OF OLD DATA SET NAME              *
*                                                                    *
*                    WORD 3 - ADDR OF NEW DATA SET NAME              *
*                                                                    *
*                    WORD 4 - ADDR OF VOLUME LIST                    *
*                                                                    *
*          THE VOLUME LIST IS VARIABLE IN LENGTH. THE FIRST TWO BYTES*
*          INDICATE THE NUMBER OF 12 BYTE VOLUME ID FIELDS WHICH     *
*          FOLLOW. A 12 BYTE VOLUME ID FIELD CONTAINS A FOUR BYTE    *
*          DEVICE CODE, SIX BYTE VOLUME SERIAL NUMBER, ONE BYTE SPARE*
*          AND ONE BYTE USED FOR RETURNING THE STATUS OF THE DATA SET*
*          ON THAT VOLUME AS FOLLOWS:                                *
*                                                                    *
*                    BINARY 0 - SUCCESSFUL RENAME                    *
*                    BINARY 1 - DSCB NOT FOUND IN VTOC               *
*                    BINARY 2 - PASSWORD DIFFICULITY                 *
*                    BINARY 3 - DUPLICATE NAME EXISTS                *
*                    BINARY 4 - PERMANENT I/O ERROR                  *
*                    BINARY 5 - APPROPRIATE UCB UNAVAILABLE          *
*                    BINARY 6 - OPERATOR UNABLE TO MOUNT VOLUME      *
*                    BINARY 7 - DATA SET IS OPEN                     *
*                    BINARY 8 - THE DATA SET IS DEFINED TO RACF BUT  *
*                               EITHER THE ACCESSOR IS NOT ALTER     *
*                               AUTHORIZED TO THE DATA SET OR THE    *
*                               DATA SET IS DEFINED TO RACF ON       *
*                               MULTIPLE VOLUMES.                    *
*                                                                    *
*OUTPUT -  REGISTER 15 CONTAINS THE ENTRY POINT ADDRESS OF THE FIRST *
*          RENAME MODULE IGC00030. REGISTERS 0 - 14 CONTAIN THE SAME *
*          VALUES AS UPON ENTRY TO IGG030DU.                         *
*                                                                    *
*ERROR CONDITONS - NONE                                              *
*                                                                    *
*STORAGE - PROGRAM CODE CSECT = 12 BYTES                             *
*                                                                    *
**********************************************************************
*REGISTER USAGE:
R0       EQU   0                        REGISTER 0 - NOT USED
R15      EQU   15                       BASE REGISTER
         SPACE 3
         BALR  R15,R0                   LOAD REGISTER 15
         USING *,R15                    ESTABLISH BASE REGISTER
         L     R15,IGC00030             GET ADDRESS OF IGC00030
         BR    R15                      TRANSFER CONTROL TO IGC00030
IGC00030 DC    V(IGC00030)              ADDRESS OF IGC00030
         END
