*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IGGCICB                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = CATALOG INTEGRITY CONTROL BLOCK             */
*/*                                                                  */
*/*   FUNCTION = USED TO CONTROL VSAM CATALOGS PROCESS OF            */
*/*              MOVING THE NON-AUTHORIZED USERS INTERFACE           */
*/*              CONTROL BLOCK STRUCTURE TO KEY 0 FETCH              */
*/*              PROTECTED CORE TO ASSURE SYSTEM INTEGRITY           */
*/*              DURING THE CATALOG SVC REQUEST PROCESS.             */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY: VSAM CATALOG FIRST LOAD IGG0CLC9                   */
*/*                                                                  */
*/*   STATUS = VS/2 RELEASE 3.7-SU7  (CHANGE FLAG @ZA29164)          */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 8 MAY 78                                 */
*/*                                                                  */
*/********************************************************************/
*
*    DCL 1 IGGCICB BASED,           /* CATALAG INTEGRITY CB          */
*          2 CICBID CHAR(4),        /* CICB ID C'CICB'               */
*          2 CICFLAGS BIT(8),       /* PROCESSING CONTROL FLAGS      */
*            3 CICCOUNT BIT(1),     /* COUNT MODE                    */
*            3 CICPTRSW BIT(1),     /* WORKAREA POINTER IS SWITCHED  */
*            3 CICFPLOP BIT(1),     /* TEST FPL LOOP ERROR           */
*            3 CICPASWD BIT(1),     /* PASSWORD IS TO BE MOVED       */
*            3 *        BIT(4),     /* RESERVED                      */
*          2 CICUSKEY BIT(8),       /* USER KEY                      */
*          2 *          CHAR(2),    /* RESERVED                      */
*          2 CICGEOPR FIXED(31),    /* GEOMETRIC PROGRESSION COUNTER */
*          2 CICINCRM FIXED(31),    /* INCREMENTAL COUNTER           */
*          2 CICFVTCN FIXED(31),    /* FVT INCREMENTAL COUNTER       */
*          2 CICFVTDX FIXED(31),    /* FVT INDEX                     */
*          2 CICSVADR PTR(31),      /* SAVED FPL ADDRESS             */
*          2 CICFPLDI FIXED(31),    /* FPL DATA INDEX                */
*          2 CICFPLLP PTR(31),      /* FPL ADDRESS FOR LOOP CHECK    */
*          2 CICFVTPR PTR(31),      /* FVT ADDRESS                   */
*          2 CICBKPTR PTR(31),      /* POINTER TO BLOCK TO MOVE      */
*          2 CICBKLNG FIXED(31),    /* LENGTH OF BLOCK TO MOVE       */
*          2 CICNXTBK PTR(31),      /* POINTER TO NEXT AVAILABLE AREA*/
*          2 CICRMBYT FIXED(31),    /* REMAINING BYTES IN CISA       */
*          2 CICGMCNT FIXED(31),    /* COUNT FOR GETMAIN             */
*          2 CICRAREA PTR(31),      /* POINTER TO USER RETURN AREA   */
*          2 CICCISAP PTR(31),      /* POINTER TO BEGINNING OF CISA  */
*          2 CICCISSP PTR(31),      /* POINTER TO SECONDARY CISA     */
*          2 CICSABYT FIXED(31),    /* BYTES IN SECONDARY CISA       */
*          2 CICCICAB FIXED(31),    /* BYTES IN PRIMARY CISA         */
*          2 CICPRFPL PTR(31),      /* PRELIMINARY FPL ADDR          */
*          2 CICREGSV FIXED(31),    /* REGISTER SAVE AREA            */
*          2 CICMRGSV CHAR(40);     /* MULTIPLE REGISTER SAVE AREA   */
