*%;/*
         MACRO
         IGGFRWKA
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IGGFRWKA
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = CHANGE LEVEL 01
.*
.*01  DESCRIPTIVE-NAME = FREEDBUF SVRB EXTENDED SAVEAREA(WORKAREA)
.*
.*01  FUNCTION = FORMATS THE SVRB EXTENDED SAVEAREA WHICH IS USED
.*               AS WORKAREA FOR FREEDBUF SVC AND ESTAE
.*
.*01  NOTES = NONE
.*
.*02    DEPENDENCIES = NA
.*
.*02    PERFORMANCE = NA
.*
.*02    RESTRICTIONS = NA
.*
.*02    REGISTER-CONVENTIONS = NA
.*
.*02    PATCH-LABEL = NA
.*
.*01  MODULE-TYPE = MACRO
.*
.*02  MACRO-SIZE =  NA
.*
.*02  EXTERNAL-REFERENCES = NA
.*
.*01INNER-MACROS = NONE
.*
.*01SYSTEM-MACROS = NONE
.*
.*01  CHANGE-ACTIVITY = SEE BELOW
.*
.*             VS2 RELEASE 2
.*
.**** END OF SPECIFICATIONS ***/
*/* MACCOMP Y-2 SC1D7/SJD48                                          */
*/* MACSTAT Y-2 73122/021160                                         */
*/********************************************************************/
*/*THE FOLLOWING DSECT FORMATS THE WORKAREA USED BY FREEDBUF SVC (57)*/
*/*AND THOSE BDAM MODULES TO WHICH FREEDBUF PASSES CONTROL.  THIS    */
*/*WORKAREA IS LOCATED IN THE SVRB EXTENDED SAVEAREA AND MUST FOLLOW */
*/*THE RB DSECT MACRO CALL.                                          */
*/********************************************************************/
*%GOTO WKAPLS2;
         ORG   RBEXSAVE
WKAREA   DS    0CL48                    SVRB SVC WORKAREA
WKATRAIL DS    BL1                      AUDIT TRAIL BIT SAVED HERE
*  THE FOLLOWING ARE AUDIT TRAIL BITS SET AFTER CERTAIN FUNCTIONS ARE *
*  COMPLETED IN THE FBUFRTNE ROUTINE. THESE BITS WILL BE INTERROGATED *
*  BY THE FREEDBUF ESTAE ROUTINE DURING CLEANUP.                      *
WKAIOBQ  EQU   X'80'                    NEXT IOB HAS BEEN TAKEN FROM
*                                       IOB QUEUE BUT CHAN PGM NOT
*                                       INITIALIZED YET
WKABUFAS EQU   X'40'                    BUFFER HAS BEEN ASSIGNED TO
*                                       NEXT IOB AND CHAN PGM INIT-
*                                       IALIZED BUT EXCP NOT ISSUED
WKAEXCP  EQU   X'20'                    BUFFER HAS BEEN FREED AND
*                                       GIVEN TO NEW IOB FOR WHICH
*                                       EXCP WAS ISSUED
WKABUFQ  EQU   X'10'                    BUFFER HAS BEEN FREED AND
*                                       PUT BACK ON AVAILABLE QUEUE
WKASVKEY DS    BL1                      USER KEY SAVED
WKACLEAN DS    BL1                      RET CODE FROM ESTAE CLEANUP
WKADUMP  DS    BL1                      RET CODE FROM ESTAE SDUMP
WKASVC14 DS    A                        REG14 RETURN FROM SVC 57
WKAREG14 DS    0A                       REG14 RETURN TO FREEDBUF
WKADEBRC DS    BL1                      RET CODE FROM ESTAE DEBCHK
WKADEB   DS    AL3                      DEB ADDR AFTER ESTAE DEBCHK
WKABUFRG DS    A                        BUFFER PTR SAVED FOR ESTAE
WKAIOBRG DS    A                        IOB PTR SAVED FOR ESTAE
WKASAVE  DS    A                        USLBFRQT+1/BCBFRQT SAVED
WKASAVE2 DS    A                        BCBNABFR(4)/BCBBFAVL(1) SAVED
WKAESTAE ESTAE MF=L                     ESTAE PARAMETER LIST (20 BYTES)
WKALENG  EQU   *-WKAREA                 LENGTH OF WORKAREA
         MEND
*%WKAPLS2: ;
*DCL 1 WKAREA CHAR(48) BDY(WORD) DEF(RBEXSAVE),   /* SVRB WORKAREA   */
*      2 WKATRAIL FIXED(8),             /* AUDIT TRAIL BIT SET BY SVC*/
*/* THE FOLLOWING EQUATES ARE AUDIT TRAIL BITS SET AFTER CERTAIN     */
*/* FUNCTIONS ARE COMPLETED IN THE DYN BUF RTN. THESE BITS ARE TESTED*/
*/* BY THE FREEDBUF ESTAE ROUTINE DURING CLEANUP.                    */
*        3 WKAIOBQ BIT(1),              /* NEXT IOB HAS BEEN TAKEN
*                                          FROM IOB QUE BUT CHAN PGM
*                                          NOT INITIALIZED YET       */
*        3 WKABUFAS BIT(1),             /* BUFFER HAS BEEN ASSIGNED
*                                          TO NEXT IOB AND CHAN PGM
*                                          INITIALIZED BUT NO EXCP   */
*        3 WKAEXCP BIT(1),              /* BUFFER HAS BEEN FREED AND
*                                          GIVEN TO NEW IOB FOR WHICH
*                                          EXCP WAS ISSUED           */
*        3 WKABUFQ BIT(1),              /* BUFFER HAS BEEN FREED AND
*                                          PUT BACK ON AVAILABLE QUE */
*        3 *    BIT(3),
*        3 WKALOCK BIT(1),              /* TELLS DEBCHECK NOT TO FREE
*                                       THE LOCAL LOCK BEFORE RETURN */
*      2 WKASVKEY FIXED(8),             /* USER KEY USED BY SVC 57   */
*      2 WKACLEAN FIXED(8),             /* RET CODE FROM ESTAE CLEAN */
*      2 WKADUMP FIXED(8),              /* RET CODE FROM ESTAE SDUMP */
*      2 WKASVC14 FIXED(31),            /* REG14 RETURN FROM SVC 57  */
*      2 WKAREG14 PTR(31),              /* REG14 RET TO SVC OR ESTAE */
*        3 WKADEBRC FIXED(8),           /* ESTAE DEBCHK RETURN CODE  */
*        3 WKADEB PTR(24),              /* KEEPS VALID DEB PTR-ESTAE */
*      2 WKABUFRG PTR(31),              /* BUFFER PTR SAVED FOR ESTAE*/
*      2 WKAIOBRG PTR(31),              /* IOB PTR SAVED FOR ESTAE   */
*      2 WKASAVE FIXED(31),             /* USLBFRQT+1/BCBFRQT SAVED  */
*      2 WKASAVE2 FIXED(31),            /* BCBNABFR(4)/BCBBFAVL(1) SV*/
*      2 WKAESTAE CHAR(20) BDY(WORD),   /* LIST FORM FOR ESTAE MACRO */
*        3 WKATRACE CHAR(8) BDY(WORD),  /* LIST FORM FOR GTRACE MACRO*/
*          4 WKARETRN PTR(31),          /* RET FROM ESTAE CLEANUP RTN*/
*          4 WKASVREG FIXED(31),        /* RTM SAVE ADDR -CLEANUP RTN*/
*        3 WKATRCLG FIXED(8),           /* SAVES GTRACE RECORD LENGTH*/
*        3 *        CHAR(11);           /* UNUSED OUTSIDE ESTAE LIST */
