 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IGGMCTRC                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VSAM CATALOG MANAGEMENT RETURN CODES        */
 /*                                                                  */
 /*   FUNCTION = VSAM CATALOG MANAGEMENT ERROR RETURN AND            */
 /*              REASON CODES USED FOR PROBLEM DETERMINATION.        */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 4   (CHANGE FLAG @Z40RSXX)       @Z40RSRC*/
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 13 MAY 75                        @Z40RSRC*/
 /*                                                                  */
 /********************************************************************/
 /********************************************************************/
 /*             VSAM  CATALOG  MANAGEMENT  ERROR  CODES              */
 /********************************************************************/
    DECLARE                          /* DECLARATION                  */
      RCS      PTR(8) CONSTANT(  0), /* SUCCESSFUL - NO ERRORS       */
      RCCAT    PTR(8) CONSTANT(  4), /* CATALOG NON-EXISTENT OR NOT  */
                                     /*   OPENED                     */
      COCECOMP PTR(8) CONSTANT(  4), /* OPEN COMPLETE                */
      RCENT    PTR(8) CONSTANT(  8), /* ENTRY NOT EXIST (NON-DEF),   */
                                     /* ENTRY EXISTS (DEFINE)        */
      RCINSP   PTR(8) CONSTANT( 20), /* INSUFF SPACE CAT D.S.        */
      RCIOL    PTR(8) CONSTANT( 24), /* I/O ERROR CAT D.S. LOCATE    */
      RCIONL   PTR(8) CONSTANT( 28), /* I/O ERROR CAT D.S. NOT LOCATE*/
      RCINCPL  PTR(8) CONSTANT( 32), /* INVALID CPL OR USER WORK     */
                                     /* AREA OUTSIDE USER REGION     */
      RCDSNF   PTR(8) CONSTANT( 36), /* DATA SET NOT FOUND           */
      RCVLSZ   PTR(8) CONSTANT( 40), /* VOLUME LIST OR WORKAREA TOO  */
                                     /* SMALL, CORRECT SIZE IN       */
                                     /* FEEDBACK FIELD               */
      RCVLSM   PTR(8) CONSTANT( 44), /* WORKAREA TOO SMALL, UNABLE   */
                                     /* TO RETURN REQUIRED SIZE      */
      RCINFUNC PTR(8) CONSTANT( 48), /* INVALID FUNCTION             */
      RCIOU    PTR(8) CONSTANT( 52), /* I/O ERROR USER VOLUME        */
      RCSEC    PTR(8) CONSTANT( 56), /* SECURITY VERIFICATION        */
      RCINENT  PTR(8) CONSTANT( 60), /* INVALID ENTRY TYPE           */
      RCNAME   PTR(8) CONSTANT( 64), /* ASSOCIATION NAME NOT EXIST   */
      RCNOSP   PTR(8) CONSTANT( 68), /* NO SPACE ON USER VOLUME      */
      RCNMNTD  PTR(8) CONSTANT( 72), /* USER VOLUME NOT MOUNTED      */
      RCNUNIT  PTR(8) CONSTANT( 76), /* UNIT NOT AVAILABLE FOR       */
                                     /*   MOUNTING                   */
      RCRELOP  PTR(8) CONSTANT( 80), /* INVALID OPERATION FOR
                                          RELATIONSHIP       @Y30SSPJ*/
      RCDATE   PTR(8) CONSTANT( 84), /* UNEXPIRED PURGE DATE         */
      RCCRAOP  PTR(8) CONSTANT( 88), /* ERROR WITH CRA OPERATION
                                                             @Y30SSPJ*/
      RCDSEXT  PTR(8) CONSTANT( 92), /* D.S. MAX NO. OF EXTENTS      */
      RCOBTAIN PTR(8) CONSTANT( 94), /* OS/VS DADSM OBTAIN ERROR
                                                             @Y30SSSM*/
      RCSPANCK PTR(8) CONSTANT( 96), /* SPANNED RECORD VALIDITY
                                           CHECK FAILED      @Y30SSPJ*/
      RCRENAME PTR(8) CONSTANT( 98), /* DADSM RENAME ERROR   @Y30SSPJ*/
      RCSCRTCH PTR(8) CONSTANT(102), /* DADSM SCRATCH I/0 ERROR
                                                             @Y30SSPJ*/
      RCCATEX  PTR(8) CONSTANT(104), /* CATALOG EXISTS               */
      RCNTFMT4 PTR(8) CONSTANT(106), /* INVALID FORMAT 4 DSCB
                                           READ FROM VOLUME  @Y30SSPJ*/
      RCINFNAM PTR(8) CONSTANT(108), /* INVALID FIELDNAME            */
      RCPRFNDL PTR(8) CONSTANT(110), /* PROFILE NOT DELETED  @Z40RSRC*/
      RCINFPL  PTR(8) CONSTANT(112), /* INVALID FPL                  */
      RCDUPROF PTR(8) CONSTANT(114), /* DUPLICATE PROFILE    @Z40RSRC*/
      RCCATBAL PTR(8) CONSTANT(116), /* CATALOG OUT-OF-BALANCE       */
      RCNDEFSS PTR(8) CONSTANT(118), /* ENTITY CANNOT BE DEFINED
                                        TO SECURITY SUB SYS  @Z40RSRC*/
      RCSYSFLD PTR(8) CONSTANT(120), /* ATTEMPTED TO MODIFY SYSTEM   */
                                     /* FIELD OR NON-EXISTENT FIELD  */
      RCINCI   PTR(8) CONSTANT(124), /* INVALID CI NUMBER            */
      RCBLKVCK PTR(8) CONSTANT(128), /* VALIDITY CHECK ON USER BLOCK */
      RCINPTR  PTR(8) CONSTANT(132), /* INVALID POINTER              */
      RCMISPAR PTR(8) CONSTANT(136), /* MISSING REQUIRED PARAMETER   */
      RCINCNPM PTR(8) CONSTANT(140), /* INCONSISTENT PARAMETERS      */
      RCINENTN PTR(8) CONSTANT(144), /* INVALID ENTRYNAME            */
      RCVOLOWN PTR(8) CONSTANT(148), /* VOLUME ALREADY OWNED         */
      RCDNECAT PTR(8) CONSTANT(152), /* DELETE OF NON-EMPTY CATALOG  */
      RCNOSPSA PTR(8) CONSTANT(156), /* NO SPACE TO SUBALLOCATE      */
      RCVNDSPD PTR(8) CONSTANT(160), /* VOL NOT DELETED (SPACE DEL)  */
      RCINSSWA PTR(8) CONSTANT(164), /* INSUFF STORAGE FOR WORKAREA  */
      RCINVDTY PTR(8) CONSTANT(168), /* UNSUPPORTED DEVICE TYPE      */
      RCDUPNVL PTR(8) CONSTANT(172), /* DUPLICATE NAME ON VOLUME     */
      RCNSPVTC PTR(8) CONSTANT(176), /* NO SPACE ON VTOC             */
      RCDSNFND PTR(8) CONSTANT(180), /* DATA SPACE NOT FOUND         */
      RCDSO    PTR(8) CONSTANT(184), /* DATA SET OPEN - CANNOT       */
                                     /*   DELETE             @Y30SSSB*/
      RCCATUNA PTR(8) CONSTANT(188), /* CATALOG UNAVAILABLE          */
      RCMLRSZ  PTR(8) CONSTANT(192), /* MAX. LOG. REC. SIZE EXCEEDED */
      RCMCISZD PTR(8) CONSTANT(196), /* MAX CI SIZE EXCEEDED - DATA  */
      RCMCISZI PTR(8) CONSTANT(200), /* MAX CI SIZE EXCEEDED - INDEX */
      RCKEYINC PTR(8) CONSTANT(204), /* KEY EXTENDS BEYOND END OF    */
                                     /*   MAXIMUM LOGICAL RECORD     */
      RCBUFSIZ PTR(8) CONSTANT(208), /* BUFFER SIZE TOO SMALL        */
      RCSIZCAL PTR(8) CONSTANT(212), /* SIZE CALCULATIONS UNSOLVABLE */
      RCVTCBAL PTR(8) CONSTANT(216), /* VTOC OF VOLUME OUT-OF-BALANCE*/
      RCDOSVTC PTR(8) CONSTANT(220), /* DOS VTOC CANNOT BE CONVERTED */
                                     /*   TO OS VTOC                 */
      RCMXGRP  PTR(8) CONSTANT(224), /* CATALOG ENTRY HAS EXCEEDED MAX.
                                          NUMBER OF OCCURRENCES      */
      RCTSAUTH PTR(8) CONSTANT(226), /* TESTAUTH MACRO FAILED
                                                             @Y30SSJG*/
      RCLOCKER PTR(8) CONSTANT(228), /* TIME-OF-DAY CLOCK ERROR      */
      RCHIGH   PTR(8) CONSTANT(230), /* NOT LOW RANGE RECORD ON
                                           CI GET            @Y30SSJG*/
      RCSMFER  PTR(8) CONSTANT(232), /* SMF PROCESSING ERROR         */
      RCLEOD   PTR(8) CONSTANT(234), /* EOD ENCOUNTERED WHILE
                                           READING CATALOG LOW DATA
                                           KEY RANGE         @Y30SSJG*/
      RCSPMAPE PTR(8) CONSTANT(236), /* SPACE MAP SCAN ERROR         */
      RCNOUCEN PTR(8) CONSTANT(238), /* NO USER CATALOG ENTRY IN
                                           MASTER CATALOG FOR
                                           CONVERTV          @Y30SSJG*/
      RCINDER  PTR(8) CONSTANT(240), /* NO DDNAME ERROR      @Y30SSDW*/
      RCEFRMPH PTR(8) CONSTANT(242), /* PHYSICAL ERROR FROM RECORD
                                           MANAGEMENT DURING DELETE
                                           WITH ERASE OPTION @Y30SSPJ*/
      RCEF     PTR(8) CONSTANT(244), /* ERASE FAILED - DELETE NOT    */
                                     /*   PERFORMED                  */
      RCVOLENT PTR(8) CONSTANT(248), /* VOLUME ENTRY DOES NOT EXIST  */
      RCEFRM   PTR(8) CONSTANT(250), /* LOGICAL ERROR FROM RECORD
                                           MANAGEMENT DURING DELETE
                                           WITH ERASE OPTION @Y30SSPJ*/
      RCEE     PTR(8) CONSTANT(252); /* EARLY EXIT CODE              */

 /********************************************************************/
 /*             VSAM  CATALOG  MANAGEMENT  REASON  CODES             */
 /********************************************************************/
    DECLARE                         /* DECLARATION           @Y30SSPJ*/
      RSN0   PTR(31) CONSTANT(  0), /* REASON CODE 0         @Y30SSPJ*/
      RSN2   PTR(31) CONSTANT(  2), /* REASON CODE 2         @Y30SSPJ*/
      RSN4   PTR(31) CONSTANT(  4), /* REASON CODE 4         @Y30SSPJ*/
      RSN6   PTR(31) CONSTANT(  6), /* REASON CODE 6         @Y30SSPJ*/
      RSN8   PTR(31) CONSTANT(  8), /* REASON CODE 8         @Y30SSPJ*/
      RSN10  PTR(31) CONSTANT( 10), /* REASON CODE 10        @Y30SSPJ*/
      RSN12  PTR(31) CONSTANT( 12), /* REASON CODE 12        @Y30SSPJ*/
      RSN14  PTR(31) CONSTANT( 14), /* REASON CODE 14        @Y30SSPJ*/
      RSN16  PTR(31) CONSTANT( 16), /* REASON CODE 16        @Y30SSPJ*/
      RSN18  PTR(31) CONSTANT( 18), /* REASON CODE 18        @Y30SSPJ*/
      RSN20  PTR(31) CONSTANT( 20), /* REASON CODE 20        @Y30SSPJ*/
      RSN22  PTR(31) CONSTANT( 22), /* REASON CODE 22        @Y30SSPJ*/
      RSN24  PTR(31) CONSTANT( 24), /* REASON CODE 24        @Y30SSPJ*/
      RSN26  PTR(31) CONSTANT( 26), /* REASON CODE 26        @Y30SSPJ*/
      RSN28  PTR(31) CONSTANT( 28), /* REASON CODE 28        @Y30SSPJ*/
      RSN30  PTR(31) CONSTANT( 30), /* REASON CODE 30        @Y30SSPJ*/
      RSN32  PTR(31) CONSTANT( 32), /* REASON CODE 32        @Y30SSPJ*/
      RSN34  PTR(31) CONSTANT( 34), /* REASON CODE 34        @Y30SSPJ*/
      RSN36  PTR(31) CONSTANT( 36), /* REASON CODE 36        @Y30SSPJ*/
      RSN38  PTR(31) CONSTANT( 38), /* REASON CODE 38        @Y30SSPJ*/
      RSN40  PTR(31) CONSTANT( 40), /* REASON CODE 40        @Y30SSPJ*/
      RSN42  PTR(31) CONSTANT( 42), /* REASON CODE 42        @Y30SSPJ*/
      RSN44  PTR(31) CONSTANT( 44), /* REASON CODE 44        @Y30SSPJ*/
      RSN46  PTR(31) CONSTANT( 46), /* REASON CODE 46        @Y30SSPJ*/
      RSN48  PTR(31) CONSTANT( 48), /* REASON CODE 48        @Y30SSPJ*/
      RSN50  PTR(31) CONSTANT( 50), /* REASON CODE 50        @Y30SSPJ*/
      RSN52  PTR(31) CONSTANT( 52), /* REASON CODE 52        @Y30SSPJ*/
      RSN54  PTR(31) CONSTANT( 54), /* REASON CODE 54        @Y30SSPJ*/
      RSN56  PTR(31) CONSTANT( 56), /* REASON CODE 56        @Y30SSPJ*/
      RSN58  PTR(31) CONSTANT( 58), /* REASON CODE 58        @Y30SSPJ*/
      RSN60  PTR(31) CONSTANT( 60), /* REASON CODE 60        @Y30SSPJ*/
      RSN62  PTR(31) CONSTANT( 62), /* REASON CODE 62        @Y30SSPJ*/
      RSN64  PTR(31) CONSTANT( 64), /* REASON CODE 64        @Y30SSPJ*/
      RSN66  PTR(31) CONSTANT( 66), /* REASON CODE 66        @Y30SSPJ*/
      RSN68  PTR(31) CONSTANT( 68), /* REASON CODE 68        @Y30SSPJ*/
      RSN70  PTR(31) CONSTANT( 70), /* REASON CODE 70        @Y30SSPJ*/
      RSN72  PTR(31) CONSTANT( 72), /* REASON CODE 72        @Y30SSPJ*/
      RSN74  PTR(31) CONSTANT( 74), /* REASON CODE 74        @Y30SSPJ*/
      RSN76  PTR(31) CONSTANT( 76), /* REASON CODE 76        @Y30SSPJ*/
      RSN78  PTR(31) CONSTANT( 78), /* REASON CODE 78        @Y30SSPJ*/
      RSN80  PTR(31) CONSTANT( 80), /* REASON CODE 80        @Y30SSPJ*/
      RSN82  PTR(31) CONSTANT( 82), /* REASON CODE 82        @Y30SSPJ*/
      RSN84  PTR(31) CONSTANT( 84), /* REASON CODE 84        @Y30SSPJ*/
      RSN86  PTR(31) CONSTANT( 86), /* REASON CODE 86        @Y30SSPJ*/
      RSN88  PTR(31) CONSTANT( 88), /* REASON CODE 88        @Y30SSPJ*/
      RSN90  PTR(31) CONSTANT( 90), /* REASON CODE 90        @Y30SSPJ*/
      RSN92  PTR(31) CONSTANT( 92), /* REASON CODE 92        @Y30SSPJ*/
      RSN94  PTR(31) CONSTANT( 94), /* REASON CODE 94        @Y30SSPJ*/
      RSN96  PTR(31) CONSTANT( 96), /* REASON CODE 96        @Y30SSPJ*/
      RSN98  PTR(31) CONSTANT( 98), /* REASON CODE 98        @Y30SSPJ*/
      RSN100 PTR(31) CONSTANT(100), /* REASON CODE 100       @Y30SSPJ*/
      RSN102 PTR(31) CONSTANT(102), /* REASON CODE 102       @Y30SSPJ*/
      RSN104 PTR(31) CONSTANT(104), /* REASON CODE 104       @Y30SSPJ*/
      RSN106 PTR(31) CONSTANT(106), /* REASON CODE 106       @Y30SSPJ*/
      RSN108 PTR(31) CONSTANT(108), /* REASON CODE 108       @Y30SSPJ*/
      RSN110 PTR(31) CONSTANT(110), /* REASON CODE 110       @Y30SSPJ*/
      RSN112 PTR(31) CONSTANT(112), /* REASON CODE 112       @Y30SSPJ*/
      RSN114 PTR(31) CONSTANT(114), /* REASON CODE 114       @Y30SSPJ*/
      RSN116 PTR(31) CONSTANT(116), /* REASON CODE 116       @Y30SSPJ*/
      RSN118 PTR(31) CONSTANT(118), /* REASON CODE 118       @Y30SSPJ*/
      RSN120 PTR(31) CONSTANT(120), /* REASON CODE 120       @Y30SSPJ*/
      RSN122 PTR(31) CONSTANT(122), /* REASON CODE 122       @Y30SSPJ*/
      RSN124 PTR(31) CONSTANT(124), /* REASON CODE 124       @Y30SSPJ*/
      RSN126 PTR(31) CONSTANT(126); /* REASON CODE 126       @Y30SSPJ*/
