 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IGGMDCRA                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = DECLARATIONS FOR DEFINE CATALOG             */
 /*                      RECOVERY AREA PROCESSING                    */
 /*                                                                  */
 /*   FUNCTION = CONTAINS THE MAPPING STRUCTURE FOR THE DEFINE       */
 /*              CATALOG RECOVERY AREA WORKAREA, RECORD MAPPING      */
 /*              STRUCTURES, AND CONSTANTS AND REGISTER              */
 /*              DECLARATIONS USED IN DEFINE CRA PROCESSING.         */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY A BASE FOR SOME STRUCTURES */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 3 SEPT 75    @ZA05914                    */
 /*                                                                  */
 /********************************************************************/
 /********************************************************************/
 /*     DECLARE  BASE  REGISTER  FOR  THE  DEFINE  CRA  WORKAREA     */
 /********************************************************************/
    DECLARE
      DCRAWAPR PTR(31) REG(3) RSTD; /* POINTER TO DEFINE CRA WORKAREA*/
 /********************************************************************/
 /*            D E F I N E     C R A     W O R K A R E A             */
 /********************************************************************/
    DECLARE
      1 DCRAWKA BASED(DCRAWAPR),    /* DEFINE CRA WORKAREA MAPPING   */
        2 DCRACIPT (6) PTR(31),     /* ARRAY OF PTRS TO CRA CI'S 0-5 */
        2 DCRADSWA PTR(31),         /* SAVE ADDR OF CLAQ'S WORKAREA  */
        2 DCRADSUL PTR(31),         /* SAVE ADDR OF CLAQ'S VOLUME    */
                                    /*   SERIAL LIST                 */
        2 DCRADSAF PTR(31),         /* SAVE ADDR OF CLAQ'S DATA SET  */
                                    /*   ATTRIBUTES FPL              */
        2 DCRAOFPL PTR(31),         /* SAVE ADDR OF CLAQ'S SPACE     */
                                    /*   ALLOCATION FPL              */
        2 DCRAFVEN PTR(31),         /* CLAQ'S SPACE FVT     @ZA05914 */
                                    /* ENTRY NAME ADDRESS   @ZA05914 */
        2 DCRAR1PT PTR(31),         /* SAVE CCAR1REC RECORD POINTER  */
        2 DCRAR2PT PTR(31),         /* SAVE CCAR2REC RECORD POINTER  */
        2 DCRACHIU PTR(32),         /* HIGH USED RBA OF CRA          */
        2 DCRACHIA PTR(32),         /* HIGH ALLOCATED RBA OF CRA     */
        2 DCRAMNLN FIXED(31),       /* GETMAIN CORE LENGTH           */
        2 DCRATRCY FIXED(15),       /* NO. OF TRACKS PER CYLINDER    */
        2 DCRABTRK FIXED(15),       /* NO. OF BLOCKS PER TRACK       */
        2 DCRADESA                  /* DADSM EXTENT INFO SAVE AREA   */
             CHAR(LENGTH(CCADESA)),
        2 DCRAMCPL,                 /* CPL FOR MODIFY FUNCTION       */
          3 * CHAR(LENGTH(CTGPL)),  /* MAIN BODY OF CPL              */
          3 * CHAR(LENGTH(CTGFIELD)), /* POINTER TO AMDSB FPL        */
          3 * CHAR(LENGTH(CTGFIELD)), /* POINTER TO ASSOCIATION FPL  */
          3 * CHAR(LENGTH(CTGFIELD)), /* POINTER TO VOLUME G.O. FPL  */
        2 DCRAMFPL,                 /* AMDSB FPL FOR MODIFY FUNCTION */
          3 * CHAR(LENGTH(CTGFL)),  /* MAIN BODY OF FPL              */
          3 * CHAR(LENGTH(CTGFLDAT)), /* POINTER TO AMDSB            */
        2 DCRAMDSB CHAR(LENGTH(IDAAMDSB)), /* AMDSB SET OF FIELDS    */
        2 DCRASFPL,                 /* IN-CORE FPL FOR ASSOCIATION   */
          3 * CHAR(LENGTH(CTGFL)),  /* FIELD PARAMETER LIST (FPL)    */
          3 * CHAR(LENGTH(CTGFLDAT)), /* DATA LENGTH & DATA ADDR PAIR*/
        2 DCRASSOC,                 /* ASSOCIATION SET OF FIELDS     */
          3 DCRATYPE CHAR(1),       /* ASSOCIATION OBJECT TYPE       */
          3 DCRANAME PTR(24) BDY(BYTE), /* ASSOCIATION OBJECT NAME   */
        2 DCRAVFPL,                 /* VOLUME G.O. FPL FOR MODIFY    */
          3 * CHAR(LENGTH(CTGFL)),  /* MAIN BODY OF FPL              */
          3 * CHAR(LENGTH(CTGFLDAT)), /* POINTER TO VOLUME GRP OCCUR */
        2 DCRAVGO,                  /* VOLUME GROUP OCCURRENCE FIELDS*/
          3 * CHAR(LENGTH(CNTRLINF)), /* VGO CONTROL INFORMATION     */
          3 DCRAVGOM CHAR(LENGTH(GVO)), /* MAIN BODY OF VOL G.O.     */
          3 * CHAR(LENGTH(CMFXECTS)), /* VOLUME EXTENT STRUCTURE     */
        2 DCRARACI CHAR(3072) BDY(DWORD), /* CRA CI'S 0-5 BUILD AREA */
          3 DCRACI0  CHAR(512),     /* BUILD AREA FOR CRA CI 0       */
            4 DCRASALP CHAR(LENGTH(SALPARL)), /* SUBALLOC PARM LIST  */
              5 DCRASPRM CHAR(LENGTH(SPACEPRM)),
                                    /* SPACE ALLOCATION PARAMETERS   */
              5 DCRADSVL,           /* DEFINE SPACE VOLUME LIST      */
                6 * CHAR(LENGTH(USERLIST)), /* VOLUME LIST MAIN BODY */
                6 * CHAR(LENGTH(LTENTRY)), /* ONE VOLUME LIST ENTRY  */
          3 DCRACI15 CHAR(2560),    /* BUILD AREA FOR CRA CI'S 1-5   */
            4 * CHAR(2048),         /* BUILD AREA FOR CRA CI'S 1-4   */
            4 DCRACI5 CHAR(512),    /* CRA CI 5 - EXTENSION RECORD   */
              5 * CHAR(LENGTH(CATRCD)), /* NON-REPEATING FIELDS      */
              5 * CHAR(LENGTH(REPCNTRL)), /* REPEATING FIELD CONTROL
                                             INFORMATION             */
              5 * CHAR(LENGTH(CATGOPT)), /* GROUP OCCURRENCE POINTER */
              5 * CHAR(LENGTH(CNTRLINF)), /* VGO CONTROL INFORMATION */
              5 DCRA5VGO CHAR(LENGTH(GVO)), /* VOLUME INFORMATION
                                               SET-OF-FIELDS         */
        2 DCRAEND CHAR(0);          /* END OF DEFINE CRA WORKAREA    */
 /********************************************************************/
 /*     SAVE AREA FOR RECORD AREA BLOCK 3 AND RECORD AREA 3.         */
 /*     THIS AREA IS OBTAINED AND ATTACHED TO THE END OF THE         */
 /*     REGULAR DEFINE CRA WORKAREA ONLY IF THE CALLER OF DEFINE     */
 /*     CRA IS DEFINE CATALOG (IGG0CLAS).                            */
 /********************************************************************/
    DECLARE
      1 DCRARABS BASED(ADDR(DCRAEND)), /* ATTACH TO WORKAREA END     */
        2 DCRARAB3 CHAR(LENGTH(CCARAB)), /* SAVE AREA FOR RAB 3      */
        2 DCRARA3(2) CHAR(256);     /* SAVE AREA FOR RECORD AREA 3   */
 /********************************************************************/
 /*           CRA  CONTROL  RECORD  (CI 3)  INFORMATION              */
 /********************************************************************/
    DECLARE
      1 CCRCNTRL BASED(ADDR(RCDID)) POSITION(2),
        2 CCRHACI PTR(24) BDY(BYTE), /* NO. OF THE HIGH ALLOCATED CI */
        2 CCRNFCI PTR(24) BDY(BYTE); /* NO. OF THE NEXT FREE CI      */
 /********************************************************************/
 /*           STRUCTURE  FOR  A  BUFFERED  VOLUME  RECORD            */
 /********************************************************************/
    DECLARE
      1 BUFVOLRD BASED,             /* BUFFERED RECORD STRUCTURE     */
        2 BUFRECRD CHAR(508),       /* ACTUAL VOLUME RECORD          */
        2 BUFNEXTB PTR(31);         /* ADDR OF NEXT BUFFERED RECORD  */
 /********************************************************************/
 /*         C O N S T A N T     D E C L A R A T I O N S              */
 /********************************************************************/
    DECLARE
      BLANK    FIXED(31) CONSTANT(0),    /* A ZERO-VALUE COMPARATOR  */
      DCRACISZ FIXED(31) CONSTANT(512),  /* CONTROL INTERVAL SIZE    */
      DCRARCSZ FIXED(31) CONSTANT(505),  /* MAXIMUM RECORD SIZE      */
      DCRABRSZ FIXED(31) CONSTANT(2048), /* MINIMUM BUFFER SIZE (2K) */
      LEN10CIS FIXED(31) CONSTANT(5120), /* LENGTH OF 10 CRA CI'S    */
      ACTCOUNT FIXED(8)  CONSTANT(1), /* CATALOG ACTIVITY COUNT      */
      GOSEQNUM FIXED(8)  CONSTANT(1), /* GROUP OCCUR SEQUENCE NO.    */
      NUMLAPRS FIXED(8)  CONSTANT(1), /* NO. LENG/ADDR PAIRS IN FPL  */
      NUMGOPTR FIXED(8)  CONSTANT(1), /* NO. OF GROUP OCCURRENCE PTRS*/
      FREECI1  FIXED(8)  CONSTANT(1), /* FREE RECORD CI NUMBER       */
      STRINGNO FIXED(8)  CONSTANT(1), /* NUMBER OF STRINGS (ACB)     */
      NUMEXTS  FIXED(8)  CONSTANT(1), /* NUMBER OF EXTENTS FOR CRA   */
      CNTGOPTR FIXED(8)  CONSTANT(2), /* COUNT OF GROUP OCCUR PTRS   */
      CLUSTRCI FIXED(8)  CONSTANT(2), /* CLUSTER RECORD CI NUMBER    */
      DATBUFNO FIXED(8)  CONSTANT(2), /* NO. OF DATA BUFFERS (ACB)   */
      LNCATTR1 FIXED(8)  CONSTANT(1), /* LENGTH OF 'CATTR1' FLAG BYTE*/
      INCR1    FIXED(8)  CONSTANT(1), /* INCREMENTING VALUE          */
      INCR2    FIXED(8)  CONSTANT(2), /* CONSTANT 2                  */
      NUMFPLS  FIXED(8)  CONSTANT(3), /* NUMBER OF FPL'S FOR MODIFY  */
      CCRCINO  FIXED(8)  CONSTANT(3), /* CRA CONTROL RECORD CI NO.   */
      FREECI4  FIXED(8)  CONSTANT(4), /* FREE RECORD CI NUMBER       */
      EXTCINO  FIXED(8)  CONSTANT(5), /* DATA EXTENTION RECORD CI NO.*/
      CNTRLENG FIXED(8)  CONSTANT(6), /* TOTAL LENGTH OF CNTRL INFO  */
      SYSMASK  BIT(32) CONSTANT('FFDFFFFF'X), /* MASK FOR TURNING OFF
                                            CPU-SHARE BIT IN DEVICE
                                            TYPE OPTIONS FIELD       */
      NULLDATE BIT(24) CONSTANT('00000F'X), /* NULL EXPIRATION DATE  */
      CI2ASSOC BIT(24) CONSTANT('0006C4'X), /* CI 2 ASSOCIATION      */
      XIOPTNS  BIT(8)  CONSTANT('09'X), /* IGGPXIO OPTION CODES      */
      AMDIDVAL BIT(8)  CONSTANT('60'X), /* AMDSB ID CHARACTER        */
      SHROPTNS BIT(8)  CONSTANT('A0'X), /* REGION/SYSTEM SHARE OPTNS */
      FREERCID CHAR(1) CONSTANT('F'), /* FREE RECORD ID CHARACTER    */
      CCRRECID CHAR(1) CONSTANT('L'), /* CRA CONTROL RECORD ID CHAR  */
      STOP     CHAR(2) CONSTANT('NG'), /* LOOP CONTROL - HALT        */
      GO       CHAR(2) CONSTANT('GO'), /* LOOP CONTROL - PROCEED     */
      NAMEDS   CHAR(8) CONSTANT('NAMEDS  '), /* COMBINATION NAME
                                                     AND TYPE FIELDS */
      NULLDWRD BIT(64)                /* 8-BYTE NULL OWNER ID FIELD  */
               CONSTANT('FFFFFFFFFFFFFFFF'X);
 /********************************************************************/
 /*             O T H E R     D E C L A R A T I O N S                */
 /********************************************************************/
    DECLARE
      DCRACI2A PTR(24) BASED(CCACPE3); /* ASSOCIATION FIELDS IN CI 2 */
    DECLARE
      DCRADDNM CHAR(8) BASED;       /* DUMMY DDNAME FOR CRA ACB      */
    DECLARE
      DCRARCTR FIXED(31) REG(4) RSTD; /* RECORD CI COUNTER           */
