 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IGGMDRWA                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = DSCB READ WORKAREA                          */
 /*                                                                  */
 /*   FUNCTION = USED TO READ FORMAT 1 DSCB FOR CATALOGS AND         */
 /*              CLUSTER RECORD OF CATALOGS DURING OPEN OF A         */
 /*              CATALOG (NON-BUILD CASE).                           */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   CREATED BY: VSAM CATALOG OPEN ACB PROCESSOR (IFG0191X)         */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 17 JUL 74                                */
 /*                                                                  */
 /********************************************************************/
 %IF SYSTEM ='DOS' %THEN %GOTO DRWAWP1;
    DECLARE
      1 IGGMDRWA BASED(CAXDRWP),    /* BASE IS IN CAXWA              */
        2 DRWDEB CHAR(48) BDY(WORD), /* DEB AREA                     */
          3 * CHAR(16),             /* FILLER                        */
          3 DRWDEXT PTR(8),         /* DEB EXTENT COUNT              */
          3 * CHAR(7),              /* FILLER                        */
          3 DRWDID PTR(8),          /* DEB ID                        */
          3 DRWDDCB PTR(24),        /* DCB PTR                       */
          3 DRWDEXS PTR(8),         /* EXTENT SCALE                  */
          3 DRWDAPP PTR(24),        /* IOS APP. TABLE ADDR           */
          3 DRWDMOD PTR(8),         /* DEVICE MOD.                   */
          3 DRWDUCB PTR(24),        /* UCB ADDR                      */
          3 DRWDBB  PTR(15),        /* BB FROM SEEK                  */
          3 DRWSCC  CHAR(4),        /* START CCHH OF EXTENT          */
          3 DRWECC  CHAR(4),        /* END CCHH OF EXTENT            */
          3 DRWNTK  CHAR(2),        /* NO. TRACKS IN EXTENT          */
        2 DRWDEBP PTR(31),          /* DCB DEB PTR                   */
        2 DRWECB PTR(31),           /* ECB                           */
          3 DRWECMP PTR(8),         /* ECB COMP CODE                 */
          3 *       PTR(24),        /* RESERVED                      */
        2 DRWIOB CHAR(32) BDY(WORD), /* IOB AREA                     */
          3 *  CHAR(2),             /* FILLER                @XA03929*/
          3 DRWISN0 CHAR(1),        /* SENSE BYTE ZERO       @XA03929*/
          3 DRWISN1 CHAR(1),        /* SENSE BYTE ONE        @XA03929*/
          3 DRWIECB PTR(31),        /* ECB PTR                       */
          3 *       CHAR(8),        /* FILLER                        */
          3 DRWSCP  PTR(31),        /* CHANNEL PROG START ADDR       */
          3 DRWIDCB PTR(31),        /* IOB DCB PTR                   */
          3 *       CHAR(8),        /* FILLER                        */
        2 DRWSEEK CHAR(8),          /* IOB SEEK FIELD                */
          3 * CHAR(3),              /* M B B   AREA          @XA03929*/
          3 DRWSECC CHAR(2),        /* C C OF SEEK           @XA03929*/
          3 DRWSEHH CHAR(2),        /* H H OF SEEK           @XA03929*/
          3 DRWSER  CHAR(1),        /* R OF SEEK             @XA03929*/
        2 DRWCCW CHAR(104) BDY(DWORD), /* CCW AREA                   */
          3 DRWCCW0 CHAR(8),        /* SET SECTOR CCW                */
          3 DRWCCW1 CHAR(8),        /* SEARCH ID EQUAL               */
          3 DRWCCW2 CHAR(8),        /* TIC  CCW1                     */
          3 DRWCCW3 CHAR(8),        /* READ DATA                     */
          3 DRWCCW4 CHAR(8),        /* SEARCH EQ OR HI               */
          3 DRWCCW5 CHAR(8),        /* TIC CCW9                      */
          3 DRWCCW6 CHAR(8),        /* SEARCH EQ/HI KEY              */
          3 DRWCCW7 CHAR(8),        /* READ COUNT                    */
          3 DRWCCW8 CHAR(8),        /* TIC CCW11                     */
          3 DRWCCW9 CHAR(8),        /* SEARCH EQ/HI KEY              */
          3 DRWCCW10 CHAR(8),       /* TIC CCW4                      */
          3 DRWCCW11 CHAR(8),       /* READ DATA                     */
          3 DRWCCW12 CHAR(8),       /* READ COUNT                    */
        2 DRWTHETA PTR(8),          /* SET SECTOR THETA              */
        2 *        PTR(8),          /* RESERVED              @XA03929*/
        2 DRWF4TC CHAR(2),          /* TRACKS PER CYLINDER   @XA03929*/
        2 DRWRIA  CHAR(512),        /* READ IN AREA                  */
          3 DRWSKEY CHAR(44),       /* SEARCH KEY ARG                */
          3 DRWDSCB CHAR(140),      /* DSCB AREA F4 OR F1            */
          3 DRWCNT CHAR(5),         /* COUNT FIELD FOR RESEEK        */
          3 DRWHPCHR CHAR(5);       /* HI WATER MARK CCHHR           */
    DECLARE
      DRWDCB CHAR(44) DEF(DRWDEB) POS(5) BDY(WORD); /* DCB           */
 %IF SYSTEM ^='DOS' %THEN %GOTO DRWAWP2;
 %DRWAWP1:;
    DECLARE
      1 IGGMDRWA BASED(CAXDRWP),    /* BASE IS IN CAXWA              */
        2 DRWCCB CHAR(16) BDY(DWORD), /* DOS CCB FOR PIOCS           */
          3 DRWRCNT FIXED(15),      /* RESIDUAL COUNT                */
          3 DRWTRINF CHAR(2),       /* TRANSMISSION INFORMATION      */
            4 DRWBYTE2 CHAR(1),     /* CCB-BYTE 2                    */
            4 DRWBYTE3 CHAR(1),     /* CCB-BYTE 3                    */
          3 DRWCSWSB BIT(16),       /* CSW STATUS BITS               */
          3 DRWSUAD CHAR(2),        /* SYMBOLIC UNIT ADDRESS         */
          3 * CHAR(1),              /* RESERVED FOR LIOCS            */
          3 DRWSCP PTR(24),         /* A(CHANNEL PROGRAM)            */
          3 * CHAR(1),              /* RESERVED FOR PIOCS            */
          3 * PTR(24),              /* CCW ADDRESS IN CSW            */
        2 DRWSEEK CHAR(8),          /* IOB SEEK FIELD                */
        2 DRWCCW  CHAR(104) BDY(DWORD), /* CCW AREA                  */
          3 DRWCCW0 CHAR(8),        /* SET SECTOR CCW                */
          3 DRWCCW1 CHAR(8),        /* SEARCH ID EQUAL               */
          3 DRWCCW2 CHAR(8),        /* TIC  CCW1                     */
          3 DRWCCW3 CHAR(8),        /* READ DATA                     */
          3 DRWCCW4 CHAR(8),        /* SEARCH EQ OR HI               */
          3 DRWCCW5 CHAR(8),        /* TIC CCW9                      */
          3 DRWCCW6 CHAR(8),        /* SEARCH EQ/HI KEY              */
          3 DRWCCW7 CHAR(8),        /* READ COUNT                    */
          3 DRWCCW8 CHAR(8),        /* TIC CCW11                     */
          3 DRWCCW9 CHAR(8),        /* SEARCH EQ/HI KEY              */
          3 DRWCCW10 CHAR(8),       /* TIC CCW4                      */
          3 DRWCCW11 CHAR(8),       /* READ DATA                     */
          3 DRWCCW12 CHAR(8),       /* READ COUNT                    */
        2 DRWTHETA PTR(8),          /* SET SECTOR THETA              */
        2 *        PTR(24),         /* RESERVED                      */
        2 DRWRIA  CHAR(512),        /* READ IN AREA                  */
          3 DRWSKEY CHAR(44),       /* SEARCH KEY ARG                */
          3 DRWDSCB CHAR(140);      /* DSCB AREA F4 OR F1            */
 %DRWAWP2:;
