 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IGGMF4WA                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = READ/WRITE FORMAT 4 DSCB WORKAREA           */
 /*                                                                  */
 /*   FUNCTION = MAPPING MACRO FOR THE FORMAT 4 DSCB AND A           */
 /*              RELATED BUFFER/WORKAREA.                            */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY A BASE FOR IGGMF4WA        */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 17 JUL 74                                */
 /*                                                                  */
 /********************************************************************/
    DECLARE
      1 IGGMF4WA BDY(DWORD) BASED,  /* FORMAT 4 DSCB WORKAREA        */
        2 F4WDEB CHAR(48) BDY(DWORD), /* DEB AREA                    */
          3 *  CHAR(16),            /* FILLER                        */
          3 F4WEXT PTR(8),          /* EXTENT COUNT                  */
          3 *  CHAR(7),             /* FILLER                        */
          3 F4WDID PTR(8),          /* DEB ID                        */
          3 F4WDDCB PTR(24),        /* DCB PTR                       */
          3 F4WDEXS PTR(8),         /* EXTENT SCALE                  */
          3 F4WDAPP PTR(24),        /* IOS APP. TABLE ADDRESS        */
          3 F4WDMOD PTR(8),         /* DEVICE MODIFIER               */
          3 F4WDUCB PTR(24),        /* UCB ADDRESS                   */
          3 F4WDBB  PTR(15),        /* BB FROM SEEK                  */
          3 F4WSCC  CHAR(4),        /* START CCHH OF EXTENT          */
          3 F4WECC  CHAR(4),        /* END CCHH OF EXTENT            */
          3 F4WNTK  CHAR(2),        /* NO. OF TRACKS IN EXTENT       */
        2 F4WDEBP   PTR(31),        /* DCB DEB PTR                   */
        2 F4WECB    PTR(31),        /* ECB                           */
          3 F4WECMP PTR(8),         /* ECB COMPLETION CODE           */
          3  *      PTR(24),        /* RESERVED                      */
        2 F4WIOB CHAR(32) BDY(WORD), /* IOB                          */
          3 *       PTR(31),        /* FILLER                        */
          3 F4WIECB PTR(31),        /* PTR TO ECB                    */
          3 *       CHAR(8),        /* FILLER                        */
          3 F4WSCP  PTR(31),        /* PTR TO CHANNEL PROGRAM START  */
          3 F4WIDCB PTR(31),        /* PTR TO DCB                    */
          3 *       CHAR(8),        /* FILLER                        */
        2 F4WSEEK   CHAR(8),        /* SEEK FIELD                    */
        2 F4WCCW CHAR(24) BDY(DWORD), /* CHANNEL PROGRAM AREA        */
          3 F4WCCW1 CHAR(8),        /* SEARCH ID EQUAL               */
          3 F4WCCW2 CHAR(8),        /* TIC CCW1                      */
          3 F4WCCW3 CHAR(8),        /* READ OR WRITE DATA            */
        2 F4WBUF    CHAR(140);      /* BUFFER AREA                   */
    DECLARE
      F4WDCB CHAR(44) DEF(F4WDEB) POS(5); /* DCB                     */
