 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IGGMGVO                                           */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VOLUME INFORMATION SET OF FIELDS            */
 /*                                                                  */
 /*   FUNCTION = MAPPING FOR THE VOLUME OCCURRENCE FIELDS AS THEY    */
 /*              APPEAR IN THE RECORDS.  ALSO, A MAPPING OF THE      */
 /*              EXTENT STRUCTURE IN THE VOLUME OCCURRENCES.         */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY A BASE FOR GVO             */
 /*                             AND/OR CMFXECTS(*)                   */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 17 JUL 74                                */
 /*                                                                  */
 /********************************************************************/
 /********************************************************************/
 /*         VOLUME  GROUP  OCCURRENCE  AS  IN  THE  RECORDS          */
 /********************************************************************/
    DECLARE
      1 GVO BASED,                   /* VOLUME OCCURRENCE STRUCTURE  */
        2 CMFLDEVT PTR(32) BDY(BYTE),/* DEVICE TYPE                  */
        2 CMFLVOL  CHAR(6),          /* VOLUME SERIAL NUMBER         */
        2 CMFLFLSQ FIXED(15),        /* FILE SEQUENCE NUMBER         */
        2 CMFLVLFL BIT(8),           /* VOLUME FLAGS                 */
          3 CMFLVLPR BIT(1),         /* PRIME VOLUME                 */
          3 CMFLVLCN BIT(1),         /* CANDIDATE VOLUME             */
          3 CMFLVLOV BIT(1),         /* OVERFLOW VOLUME              */
          3 *        BIT(5),         /* RESERVED                     */
        2 CMFLNOEX PTR(8),           /* NO. OF EXTENTS               */
        2 CMFLHKBA PTR(32) BDY(BYTE),/* HIGH KEY CI VALUE, RANGE     */
        2 CMFLHUBA PTR(32) BDY(BYTE),/* HIGH USED RBA                */
        2 CMFLHABA PTR(32) BDY(BYTE),/* HIGH ALLOCATED RBA           */
        2 CMFLPHYB PTR(32) BDY(BYTE),/* PHYSICAL BLOCKSIZE           */
        2 CMFLNBTK FIXED(15),        /* BLOCKS PER TRACK             */
        2 CMFLNTKA FIXED(15),        /* TRACKS PER CONTROL AREA      */
        2 CMFLITEX BIT(8),           /* TYPE OF EXTENT               */
          3 CMFLSSDT BIT(1),         /* SEQUENCE SET WITH DATA       */
          3 CMFLNOPF BIT(1),         /* NOT PREFORMATTED SPACE       */
          3 *        BIT(6),         /* RESERVED                     */
        2 CMFLSSDS FIXED(15) BDY(BYTE),/* SS NO. OF DATA SET DIRCTRY */
        2 CMFOVERL CHAR(14);         /* STRUCTURE END INDICATION
                                                               Y02020*/
 /********************************************************************/
 /*                TRACK  OVERFLOW   (PAGE SPACE)              Y02020*/
 /********************************************************************/
    DECLARE
      1 CMFOVLAY BASED (ADDR(CMFOVERL)-8),                  /* Y02020*/
        2 CMFBYTRK FIXED(31) BDY(BYTE),/* BYTES PER TRACK (PAGE SPACE)
                                                               Y02020*/
        2 CMFBYTAU FIXED(31) BDY(BYTE),/* BYTES PER ALLOCATION UNIT
                                                               Y02020*/
        2 CMFLLKLN FIXED(15) BDY(BYTE),/* LOW KEY VALUE LENGTH       */
        2 CMFLHKLN FIXED(15) BDY(BYTE),/* HIGH KEY VALUE LENGTH      */
        2 CMFLEXLN FIXED(15) BDY(BYTE),/* LENGTH OF EXTENTS          */
        2 CMFLEND CHAR(0);          /* END OF VOLUME OCCUR FIELDS    */
 /********************************************************************/
 /*            EXTENT  STRUCTURE  IN  VOLUME  OCCURRENCES            */
 /********************************************************************/
    DECLARE
      1 CMFXECTS (*) CHAR(20) BASED, /* EXTENT STRUCTURE             */
        2 CMFXEXSS FIXED(15) BDY(BYTE),/* SPACE SEQUENCE NO.         */
        2 CMFXEXST CHAR(4),          /* STARTING CCHH                */
          3 CMFXSTA PTR(31) BDY(BYTE),/* ARITHMETIC FORM - CCHH      */
            4 CMFXSTCC FIXED(15) BDY(BYTE),/* CYLINDER START         */
            4 CMFXSTHH FIXED(15) BDY(BYTE),/* TRACK START            */
        2 CMFXEXED CHAR(4),          /* ENDING CCHH                  */
          3 CMFXEDA PTR(31) BDY(BYTE),/* ARITHMETIC FORM - CCHH      */
            4 CMFXEDCC FIXED(15) BDY(BYTE),/* CYLINDER END           */
            4 CMFXEDHH FIXED(15) BDY(BYTE),/* TRACK END              */
        2 CMFXNOTT FIXED(15) BDY(BYTE),/* NO. TRACKS IN EXTENT       */
        2 CMFXLRBA PTR(32) BDY(BYTE),/* STARTING DDDD IN EXTENT      */
        2 CMFXHRBA PTR(32) BDY(BYTE);/* ENDING DDDD IN EXTENT        */
