 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IGGMSAWA                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = SUBALLOCATE INTERFACE                       */
 /*                                                                  */
 /*   FUNCTION = SUBALLOCATE INTERFACE PARAMETER LIST                */
 /*              AND WORKAREA MAPPING MACRO.                         */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 17 JUL 74                                */
 /*                                                                  */
 /********************************************************************/
    DECLARE
      1 SALPARL BASED(CCAALPTR),    /* BASE IS IN IGGCCA             */
        3 SALOPTNS PTR(8),          /* ALLOCATION OPTIONS            */
        3 *        BIT(8),          /* RESERVED                      */
        3 SALSOURC PTR(8),          /* RECORD SOURCE INDICATOR       */
        3 SALDSCIN PTR(24) BDY(BYTE), /* OBJECT DATA SET CI NUMBER   */
        3 SALPARMS CHAR(8),         /* ALLOCATION PARAMETERS         */
          5 SALCALN  FIXED(15) BDY(BYTE), /* CONTROL AREA LENGTH     */
          5 SALBLKLN FIXED(15) BDY(BYTE), /* RECORD BLOCK LENGTH     */
          5 SALUNITS FIXED(15) BDY(BYTE), /* NUMBER OF UNITS REQUSTED*/
          5 SALMXEXT PTR(8),        /* MAX NO. EXTENTS ALLOWED       */
          5 *        PTR(8),        /* RESERVED FOR ALIGNMENT        */
        3 SALRLIST PTR(32) BDY(BYTE), /* PTR TO RESPONSE LIST        */
        3 SALVLIST PTR(32) BDY(BYTE), /* PTR TO USERLIST             */
        3 SALAXWA  CHAR(490);       /* IGGPSALL WORK AREA            */
 /********************************************************************/
 /*         PRLIST - SUBALLOCATE PROCESSING RESPONSE LIST            */
 /*                  ENTRIES PARALLEL USERLIST ENTRIES               */
 /********************************************************************/
    DECLARE
      1 PRLIST BASED(SALRLIST),     /* BASE IS IN SALPARL            */
        3 PRLLN PTR(8),             /* PRL VOL COUNT                 */
        3 PRLENT (*) CHAR(2) BDY(BYTE), /* RESPONSE ENTRY            */
          5 PRELENTF  FIXED(15) BDY(BYTE), /* SEQUENCE NO. OF DATA   */
                                    /* SET DIRECTORY ENTRY           */
            7 PRLPAR1 PTR(8),       /* RESPONSE PARAMENTER           */
            7 PRLPAR2 PTR(8);       /* RESPONSE PARAMETER            */
 /********************************************************************/
 /*     CONSTANTS USED TO SET AND/OR TEST FIELDS DECLARED ABOVE      */
 /********************************************************************/
    DECLARE                         /* ALLOCATION OPTIONS - SALOPTNS */
      SACYLOPT BIT(8) CONSTANT('C0'X), /* CYLINDER REQUEST           */
      SATRKOPT BIT(8) CONSTANT('80'X), /* TRACK REQUEST              */
      SARECOPT BIT(8) CONSTANT('40'X), /* RECORD REQUEST (RESERVED)  */
      SACANOPT BIT(8) CONSTANT('00'X); /* CANDIDATE REQUEST          */
    DECLARE                         /* RECORD SOURCE INDICATOR       */
      SARABS   BIT(8) CONSTANT('01'X), /* FIRST VER IN USERLIST IS
                                          IN RAB 3                   */
      SAVRLIST BIT(8) CONSTANT('02'X); /* FIRST VER IN USERLIST IS
                                          NOT IN RAB'S               */
