*
*        % GOTO MSGL1; /*
         MACRO
         IGGMSG
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IGGMSG
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = OS/VS2 RELEASE 2, LEVEL 0
.*
.*01  CHANGE-ACTIVITY = NONE
.*
.*01  DESCRIPTIVE-NAME = MESSAGE CSECT MAPPING
.*
.*01  FUNCTION = MAP S/P/D MESSAGE CSECTS
.*
.*01  NOTES = NONE
.*
.*01  MODULE-TYPE = MACRO
.*02    PROCESSOR = ASSEMBLER-370R  PLS
.*
.*02    EXTERNAL-REFERENCES = N/A
.*
.*01  INNER-MACROS = NONE
.*
.*01  SYSTEM-MACROS = NONE
.*
.*
.**** END OF SPECIFICATIONS ***/
*% MSGL1:;
* /* MACCOMP Y-2 SC1D0/SJD48                                         */
* /* MACSTAT Y-2 73040/021160                                        */
*/*                                                                  */
*/* **************************************************************** */
*/*                                                                  */
*/*            ****** MESSAGE CSECT ******                           */
*/*                                                                  */
*/*  OS/VS2 RELEASE 2                                                */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*     PL/S - RFY MSGINDEX BASED ON A PTR                           */
*/*          - DECLARE 'MSGNO' AS NUMBER OF DESIRED MESSAGE          */
*/*              OR VARIABLE CONTAINING MESSAGE NUMBER               */
*/*     BAL  - FOUR DSECTS ARE PRODUCED.  USING ON A DSECT NAME      */
*/*            GIVES ADDRESSABILITY FOR ALL SYMBOLS WITHIN THAT      */
*/*            DSECT.  THE DSECT NAMES AND SYMBOLS WITHIN EACH ARE:  */
*/*              MSGINDEX - MSGINDLN, MSGINDOF                       */
*/*              MSGENTRY - MSGOFF, MSGLNG, MSGOFF1, MSGOFF2,        */
*/*                         MSGOFF3, MSGOFF4, MSGOFF5                */
*/*              MSGTXTD  - MSGTXT                                   */
*/*              MSGTXTFD - MSGLNGF, MSGTXTF                         */
*/*                                                                  */
*/*  FUNCTION                                                        */
*/*     THE MESSAGE CSECT CONTAINS MESSAGES FROM SAM/PAM/DAM CODE.   */
*/*      THIS DSECT IS USED TO MAP THOSE MESSAGES.                   */
*/*                                                                  */
*/* **************************************************************** */
*
*% GOTO MSGL2; /*
*        THIS DSECT IS TO COVER THE MESSAGE CSECT.  THE MESSAGE
*        CSECT IS DIVIDED INTO TWO PARTS
*
*        THE FIRST IS THE INDEX.  TO FIND THE OFFSET TO A GIVEN
*        MESSAGE THE FOLLOWING SEQUENCE OF INSTRUCTIONS
*        MAY BE USED.
*              USING MSGINDEX,MSGBASE
*        MXXX  EQU   MSGNO*2
*              LH    RWK1,MSGINDOF+MXXX
*        AT THIS POINT RWK1 HAS THE OFFSET TO THE MESSAGE ENTRY
*        FROM THE BEGINNING OF THE CSECT.
*
MSGINDEX DSECT
MSGINDLN DS    H                        LENGTH OF INDEX
MSGINDOF DS    H                        OFFSET TO MESSAGE ENTRY
*
*        ONCE THE MESSAGE ENTRY IS FOUND THE MESSAGE ITSELF IS FOUND
*        BY ADDING THE MSGOFF FIELD TO THE BEGINNING OF THE ENTRY.
*        THE OFFSET TO ANY VARIABLE FIELDS THAT MUST BE FILLED IN ARE
*        CONTAINED IN MSGOFF1 THROUGH MSGOFF5.  MSGLNG CONTAINS THE
*        LENGTH OF THIS PARTICULAR MESSAGE MINUS ONE.  THE LENGTH IS
*        ONE LESS TO ALLOW IT TO BE USED IN AN EXECUTE OF A MOVE.
*
MSGENTRY DSECT
MSGOFF   DS    FL1                      OFFSET TO MESSAGE TEXT FROM
*                                       BEGINNING OF ENTRY
MSGLNG   DS    FL1                      LENGTH OF MESSAGE TEXT - 1
MSGOFF1  DS    FL1                      OFFSET TO FIRST VARIABLE
MSGOFF2  DS    FL1                      OFFSET TO SECOND VARIABLE
MSGOFF3  DS    FL1                      OFFSET TO THIRD VARIABLE
MSGOFF4  DS    FL1                      OFFSET TO FOURTH VARIABLE
MSGOFF5  DS    FL1                      OFFSET TO FIFTH VARIABLE
MSGOFF6  DS    FL1                      OFFSET TO SIXTH VARIABLE
MSGOFF7  DS    FL1                      OFFSET TO SEVENTH VARIABLE
*
*        THIS IS USED TO CREATE A LABEL THAT MAY BE USED IN THE
*        OBJECT OF AN EXECUTE INSTRUCTION.
*
MSGTXTD  DSECT
MSGTXT   DS    CL1                      MESSAGE TEXT
*
*        THIS SECTION OF THE DSECT DESCRIBES THE NO VARIABLE MESSAGES
*        SUCH AS THOSE USED IN SYNADAF..
*
MSGTXTFD DSECT
MSGLNGF  DS    AL1                      LENGTH OF MESSAGE TEXT
MSGTXTF  DS    CL1                      MESSAGE TEXT
         MEND  , */
*        % MSGL2:;
* /* *************************************************************** */
* /*                     MESSAGE INDEX SECTION                       */
* /* *************************************************************** */
*
*  DECLARE
*  1 MSGINDEX BASED BDY(WORD),
*     2 MSGINDLN PTR (15),              /* LENGTH OF INDEX SECTION   */
*     2 MSGINDOF(*) PTR (15),           /* OFFSET TO MESSAGE ENTRY   */
*
* /* *************************************************************** */
* /*                     MESSAGE ENTRY SECTION                       */
* /* *************************************************************** */
*
*  1 MSGENTRY BASED(ADDR(MSGINDEX) + MSGINDOF(MSGNO+1)) BDY(HWORD),
*     2 MSGOFF PTR (8),                 /*OFFSET TO MESSAGE TEXT     */
*     2 MSGLNG PTR (8),                 /*LENGTH OF MESSAGE TEXT - 1 */
*     2 MSGOFF1 PTR (8),                /*OFFSET TO FIRST VARIABLE   */
*     2 MSGOFF2 PTR (8),                /*OFFSET TO SECOND VARIABLE  */
*     2 MSGOFF3 PTR (8),                /*OFFSET TO THIRD VARIABLE   */
*     2 MSGOFF4 PTR (8),                /*OFFSET TO FOURTH VARIABLE  */
*     2 MSGOFF5 PTR (8),                /*OFFSET TO FIFTH VARIABLE   */
*     2 MSGOFF6 PTR (8),                /*OFFSET TO SIXTH VARIABLE   */
*     2 MSGOFF7 PTR (8),                /*OFFSET TO SEVENTH VARIABLE */
*
* /* *************************************************************** */
* /*                     MESSAGE TEXT                                */
* /* *************************************************************** */
*
*  1 MSGTXTD BASED(ADDR(MSGENTRY) + MSGOFF) BDY(BYTE),
*     2 MSGTXT CHAR(*),                 /* MESSAGE TEXT              */
* /* *************************************************************** */
* /*                     MESSAGE ENTRY NO VARIABLES                  */
* /* *************************************************************** */
*
* 1 MSGTXTFD BASED(ADDR(MSGINDEX) + MSGINDOF(MSGNO+1)) BDY(BYTE),
*    2 MSGLNGF PTR(8),                  /*LENGTH OF ENTRY            */
*    2 MSGTXTF CHAR(*);                 /*MESSAGE TEXT               */
*
