*%;/*
         MACRO
         IGGRDX
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IGGRDX
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = CHANGE LEVEL 01
.*
.*01  DESCRIPTIVE-NAME = READX EXCLUSIVE LIST FORMAT
.*
.*01  FUNCTION = FORMATS THE LIST CONTAINING IOBS WAITING FOR EXCLUSIVE
.*               CONTROL OF BLOCKS WHOSE IDS(UCB+CCHHR) ARE IDENTIFIED
.*               IN THE SAME READ EXCLUSIVE LIST ENTRY AND ARE AT THAT
.*               TIME UNDER THE CONTROL OF ANOTHER REQUEST.
.*
.*01  NOTES = NONE
.*
.*02    DEPENDENCIES = NA
.*
.*02    PERFORMANCE = NA
.*
.*02    RESTRICTIONS = NA
.*
.*02    REGISTER-CONVENTIONS = NA
.*
.*02    PATCH-LABEL = NA
.*
.*01  MODULE-TYPE = MACRO
.*
.*02  MACRO-SIZE =  NA
.*
.*02  EXTERNAL-REFERENCES = NA
.*
.*01INNER-MACROS = NONE
.*
.*01SYSTEM-MACROS = NONE
.*
.*01  CHANGE-ACTIVITY = SEE BELOW
.*
.*             VS2 RELEASE 2
.*
.**** END OF SPECIFICATIONS ***/
* /* MACCOMP Y-2 SC1D7/SJD48                                   Y02072*/
* /* MACSTAT Y-2 73122/021160                                  Y02072*/
*/********************************************************************/
*/*THE FOLLOWING DSECT FORMATS A BDAM READ EXCLUSIVE LIST SEGMENT,   */
*/*WITH NINE 16-BYTE ENTRIES,EACH ENTRY ASSOCIATED WITH A BLOCK UNDER*/
*/*EXCLUSIVE CONTROL.EACH ENTRY CONTAINS AN 8-BYTE BLOCK ID (UCB ADDR*/
*/*+CCHHR) AND THE FIRST AND LAST IOB ADDRESS IN A CHAIN OF IOBS     */
*/*WAITING FOR EXCLUSIVE CONTROL OF THE BLOCK. EACH IOB CONTAINS THE */
*/*ADDR OF THE NEXT WAITING IOB IN FIELD,IOBDQPTR.THE LIST IS MADE UP*/
*/*OF 152-BYTE SEGMENTS(9 ENTRIES/SEG) CHAINED TOGETHER. NEW SEGMENTS*/
*/*ARE GOTTEN DYNAMICALLY WHEN THE PREVIOUS SEGMENT IS FULL. THE ADDR*/
*/*OF THE NEXT SEGMENT IS STORED IN THE SECOND WORD OF THE PREVIOUS  */
*/*SEGMENT.                                                          */
*/********************************************************************/
*%GOTO RDXPLS2;                         /*                     Y02072*/
RDXLIST  DSECT
RDXRSV01 DS    XL4                      UNUSED                   Y02072
RDXMAXCT EQU   X'09'                    NUMBER OF ENTRIES PER SEGMENT
RDXNEXT  DS    A                        POINTER TO NEXT SEGMENT IF ONE
*                                       EXISTS, OTHERWISE ZEROES
RDXENT   EQU   *                        READX ENTRY (SEE BELOW)
RDXLSTLG EQU   152                      LENGTH OF LIST SEGMENT   Y02072
*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *
*                FORMAT OF ONE ENTRY IN THE LIST
*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *
RDXENTRY DSECT
RDXNQARG DS    XL8                      UCB/CCHHR FOR BLOCK      Y02072
RDXIOBUQ DS    A                        ADDR OF FIRST IOB ON     Y02072
*                                       UNPOSTED QUEUE (OR 0 )   Y02072
RDXUQND  DS    A                        ADDR LAST IOB ON QUEUE   Y02072
RDXENTLN EQU   *-RDXENTRY               LENGTH OF EACH ENTRY     Y02072
         MEND
*%RDXPLS2: ;                            /*                     Y02072*/
*DCL 1 RDXLIST CHAR(152) BDY(WORD) BASED,/* READ EXCLUSIVE LIST DSECT*/
*      2 RDXRSV01 CHAR(4) BDY(WORD),    /* UNUSED                    */
*      2 RDXNEXT PTR(31),               /* ADDRESS OF NEXT SEGMENT   */
*      2 RDXENT CHAR(16);               /* ENTRY IN READX LIST, DES-
*                                          CRIBED BELOW IN RDXENTRY  */
*DCL RDXMAXCT FIXED(8) CONSTANT(9),     /* NUMBER OF ENTRIES/SEGMENT */
*    RDXLSTLG FIXED(8) CONSTANT(152);   /* LENGTH OF 1 READX SEGMENT */
*/*                                                                  */
*/*   THE FOLLOWING FORMATS ONE ENTRY IN THE READ EXCLUSIVE LIST     */
*/*                                                                  */
*DCL 1 RDXENTRY CHAR(16) BDY(WORD) BASED, /* FORMAT OF 1 ENTRY       */
*      2 RDXNQARG CHAR(8),              /* ENQ/DEQ MINOR QNAME-
*                                          UCB + CCHHR OF BLOCK      */
*      2 RDXIOBUQ PTR(31),              /* ADDR OF FIRST IOB ON
*                                          UNPOSTED QUEUE (OR ZERO)  */
*      2 RDXUQND PTR(31);               /* ADDR OF LAST IOB ON QUEUE */
