*  %GOTO SPDL1;
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IGGSPD
.*
.*01  DESCRIPTIVE-NAME = SAM/PAM/DAM GTRACE BUFFER
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = VS2 RELEASE 2 LEVEL 0
.*
.*01  FUNCTION = DEFINES THE STRUCTURE OF THE GTRACE BUFFER
.*
.*01  MODULE-TYPE = MACRO
.*
.*02    MACRO-SIZE = N/A FOR A MAPPING MACRO
.*
.*02    PARAMETER-RECEIVED = NONE
.*
.*01  TABLES = NONE
.*
.*01  INNER-MACROS = NONE
.*
.*01  SYSTEM-MACROS = NONE
.*
.*01  CHANGE-ACTIVITY = SEE BELOW
.*    VS2 RELEASE 2 DELETIONS
.*
.**** END OF SPECIFICATIONS ***/
* %SPDL1: ;
* /* MACCOMP Y-2 SC1D0/SJD48                                         */
* /* MACSTAT Y-2 73141/021160                                        */
 /********************************************************************/
 /*                                                                  */
 /*      THIS MACRO DEFINES THE STRUCTURE OF A GTRACE BUFFER.        */
 /*                                                                  */
 /*      VS2 RELEASE 2, 5/21/73, LEVEL=0                             */
 /*                                                                  */
 /*      METHOD OF ACCESS - IF SPDBASE IS NOT OTHERWISE DECLARED IT  */
 /*                         WILL DEFAULT TO %SPDBASE = 'BASED'.      */
 /*                                                                  */
 /********************************************************************/
         %IF SPDBASE = ''               /* WAS SPDBASE DECLARED      */
           %THEN %SPDBASE = 'BASED';    /* USE DEFAULT VALUE IF NOT  */
 DCL 1 SPDBFR SPDBASE BDY(BYTE),
       2 SPDHDR,                        /* BUFFER HEADER             */
         3 SPDDDNAM CHAR(8),            /* DDNAME FROM TIOT          */
         3 SPDABCCD FIXED(8),           /* ABEND CONDITION CODE      */
       2 SPDTRACE CHAR(247);            /* TRACE RECORD AREA         */

 /********************************************************************/
 /*    THE FOLLOWING DEFINES THE STRUCTURE OF THE TRACE RECORD AREA  */
 /********************************************************************/
 DCL 1 SPDTRRCD BASED BDY(BYTE),
       2 SPDRCDHD,                      /* RECORD HEADER             */
         3 SPDRCDLN FIXED(8),           /* LENGTH OF THIS TRACE RCD  */
         3 SPDBLKID FIXED(8),           /* ID OF TRACED BLOCK        */
           4 SPDPTRSW BIT(1),           /* ADDR REQD WITH TRACE RCD  */
       2 SPDDATA1,                      /* AREA TO BE TRACED         */
         3 SPDBLKAD PTR(31) BDY(BYTE),  /* ADDR OF BLOCK (NOT PRESENT
                                           FOR ALL TRACE RECORDS)    */
         3 SPDDATA2 CHAR(*);            /* BLOCK TO BE TRACED        */

 /********************************************************************/
 /*   THE FOLLOWING DEFINES THE STRUCTURE OF THE TRACE RCD DATA AREA */
 /********************************************************************/
 DCL SPDRDATA CHAR(*) BASED BDY(BYTE);

 /********************************************************************/
 /* THE FOLLLOWING CONSTANTS IDENTIFY THE VARIOUS AREAS WHICH ARE    */
 /* TRACED. CONSTANTS 1 THROUGH 127 IDENTIFY AREAS WHOSE ADDRESSES   */
 /* ARE NOT TO BE TRACED.  CONSTANTS 129 THROUGH 255 IDENTIFY AREAS  */
 /* WHOSE ADDRESSES ARE TO BE TRACED.                                */
 /********************************************************************/
 DCL SPDONEXT FIXED(8) CONSTANT(1);     /* CURRENT DEB EXTENT ID     */
 DCL SPDALLXT FIXED(8) CONSTANT(2);     /* ALL DEB EXTENTS ID        */
 DCL SPDIOSEK FIXED(8) CONSTANT(3);     /* IOB OR ICB SEEK FIELD ID  */
 DCL SPDMAXBK FIXED(8) CONSTANT(4);     /* MAX BLOCK SIZE FIELD ID   */
 DCL SPDBCB   FIXED(8) CONSTANT(129);   /* BCB ID                    */
 DCL SPDDCB   FIXED(8) CONSTANT(130);   /* DCB ID                    */
 DCL SPDDECB  FIXED(8) CONSTANT(131);   /* DECB ID                   */
 DCL SPDECB   FIXED(8) CONSTANT(132);   /* ECB ID                    */
 DCL SPDIOB   FIXED(8) CONSTANT(133);   /* NORMAL SCHEDULING IOB ID  */
 DCL SPDCSIOB FIXED(8) CONSTANT(134);   /* CHAINED SCHEDULING IOB ID */
 DCL SPDICB   FIXED(8) CONSTANT(135);   /* CHAINED SCHEDULING ICB ID */
 DCL SPDBLOCK FIXED(8) CONSTANT(136);   /* USERS BDW AND BLOCK ID    */
 DCL SPDRECRD FIXED(8) CONSTANT(137);   /* USERS RDW AND RECORD ID   */
 DCL SPDEXLST FIXED(8) CONSTANT(138);   /* DCB EXIT LIST ENTRY ID    */
 DCL SPDSETPR FIXED(8) CONSTANT(139);   /* SETPRINT PARAMETER LIST   */
 DCL SPDREADX FIXED(8) CONSTANT(140);   /* READ EXCLUSIVE LIST ENTRY */
 DCL SPDFCBIM FIXED(8) CONSTANT(141);   /* 1ST 6 BYTES OF FCB IMAGE  */
 SPDFID: GEN(EQU   X'FE');              /* ID OF SAM/PAM/DAM GTRACE
                                           FORMAT ROUTINE            */
