 % IGGSTART: MACRO KEYS(CLEAN,USER,ENV,SDUMP);               /*YM7586*/
         ANS('DO; /*?' || MACNAME || ' ' || MACKEYS || '*/');
         ANS('* /* MACCOMP Y-2 SC1D0/SJ0082                */') COL(1);
         ANS('* /* MACSTAT Y-2 78152/@ZA32859              */') COL(1);
 DCL     (REMCOL, QUITCOL) FIXED;
         REMCOL = MACRMAR-31;           /* NORMALLY COL 41           */
         QUITCOL = MACRMAR-2;           /* NORMALLY COLUMN 70        */
 DCL     (ON, STRING) CHAR;
         ON = '''1''B';
         IF CLEAN = '' THEN
            ANS('***ERROR***''CLEAN'' IS A REQUIRED KEYWORD;') COL(1);
         IF USER = '' THEN
            ANS('***ERROR***''USER'' IS A REQUIRED KEYWORD;') COL(1);
         IF SDUMP = '' THEN
            ANS('***ERROR***''SDUMP'' IS A REQUIRED KEYWORD;') COL(1);
         IF LENGTH(MACLABEL) > 0 THEN   /* IF MACRO LABEL PRESENT,   */
            ANS(MACLABEL)               /* THEN PRINT IT AS DO LABEL */
               COL(MACLMAR);            /* AT THE LEFT MARGIN        */
         ANS('/' || REPEAT('*',MACRMAR-MACLMAR-2) || '/') COL(MACLMAR);
         ANS(COMMENT(
 ' THIS ROUTINE ANALYSES FLAGS IN THE SDWA TO DETERMINE              '
            )) COL(MACLMAR);  ANS(COMMENT(
 ' WHAT TYPE OF FUNCTION TO PERFORM                                  '
            )) COL(MACLMAR);  ANS(COMMENT(
 ' THE FLAG COMBINATIONS TESTED AND THE ACTIONS TAKEN ARE SUMMARIZED '
            )) COL(MACLMAR);  ANS(COMMENT(
 ' IN THE FOLLOWING TABLE:                                           '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);  ANS(COMMENT(
 '   PREVIOUS  || CAUSE OF ERROR ENTRY                               '
            )) COL(MACLMAR);  ANS(COMMENT(                   /*YM7586*/
 '  PROCESSING || MCHK/PGIO/TEXC  OTHER                              '
            )) COL(MACLMAR);  ANS(COMMENT(
 '  ___________||________________________                            '
            )) COL(MACLMAR);  ANS(COMMENT(                   /*YM7586*/
 '       *EAS  ||        C          C                                '
            )) COL(MACLMAR);  ANS(COMMENT(                   /*YM7586*/
 '       *CLUP ||        C          C                                '
            )) COL(MACLMAR);  ANS(COMMENT(                   /*YM7586*/
 '       *STAF ||        S          S                                '
            )) COL(MACLMAR); IF ENV='' THEN DO; ANS(COMMENT( /*YM7586*/
 '       *PERC ||        C          U                                '
            )) COL(MACLMAR);  ANS(COMMENT(                   /*YM7586*/
 '       *NRBE ||        C          U                                '
            )) COL(MACLMAR);  END;  ELSE DO;  ANS(COMMENT(   /*YM7586*/
 '       *PERC ||        C          E                                '
            )) COL(MACLMAR);  ANS(COMMENT(                   /*YM7586*/
 '       *NRBE ||        C          E                                '
            )) COL(MACLMAR);  END;  ANS(COMMENT(             /*YM7586*/
 '        NONE ||        C          U                                '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);  ANS(COMMENT(
 '       * THESE BITS ARE NOT ALL MUTUALLY EXCLUSIVE. THEY ARE       '
            )) COL(MACLMAR);  ANS(COMMENT(
 '         TESTED IN THE ORDER LISTED.                               '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);  ANS(COMMENT(
 '       * USER ABENDS ALWAYS GO TO THE CLEANRTN.                    '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);  ANS(COMMENT(
 '       FUNCTIONS TO BE PERFORMED:                                  '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);
         STRING = ' C ' || CLEAN ||
                  '--CLEAN UP RESOURCES AND PERCOLATE ERROR';
         STRING = STRING || REPEAT(' ',66-LENGTH(STRING));
         ANS(COMMENT(STRING)) COL(MACLMAR);
            ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);
         IF ENV ^= '' THEN DO;
            STRING = ' E ' || ENV ||
                    '--TEST FOR KNOWN ENVIRONMENTAL ERROR CONDITIONS,';
            STRING = STRING || REPEAT(' ',66-LENGTH(STRING));
            ANS(COMMENT(STRING)) COL(MACLMAR);
            ANS(COMMENT(
 ' AND IF FOUND, SET ERROR RETURN TO USER.                           '
            )) COL(MACLMAR);  ANS(COMMENT(
 ' IF UNKNOWN, TREAT AS U                                            '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);
         END;
         STRING = ' S ' || SDUMP ||
                  '--PREVIOUS RECOVERY ROUTINE FAILED.';
         STRING = STRING || REPEAT(' ',66-LENGTH(STRING));
         ANS(COMMENT(STRING)) COL(MACLMAR);
         ANS(COMMENT(
 ' TAKE A DUMP FOR IT, THEN TREAT AS C                               '
            )) COL(MACLMAR);  ANS(COMMENT(
 '                                                                   '
            )) COL(MACLMAR);
         STRING = ' U ' || USER ||
                  '--VALIDATE USER INPUT. IF IT IS IN ERROR,';
         STRING = STRING || REPEAT(' ',66-LENGTH(STRING));
         ANS(COMMENT(STRING)) COL(MACLMAR);
         ANS(COMMENT(
 ' TAKE PROBLEM DETERMINATION ACTIONS AND THEN CLEAN UP.             '
            )) COL(MACLMAR);  ANS(COMMENT(
 ' IF IT IS VALID, ASSUME A SYSTEM ERROR IN COVERED FUNCTION.        '
            )) COL(MACLMAR);  ANS(COMMENT(
 ' TAKE A DUMP, THEN TREAT AS C                                      '
            )) COL(MACLMAR);
         ANS('/' || REPEAT('*',MACRMAR-MACLMAR-2) || '/') COL(MACLMAR);
         ANS('IF SDWAEAS = ON')               COL(MACCOL) SKIP(2);
         ANS('/* LOWER ESTAE ALREADY DUMPED */') COL(REMCOL);
         ANS(' | SDWACLUP = ON THEN')         COL(MACCOL);
         ANS('/* OR RTM SAYS CLEANUP        */') COL(REMCOL);
         ANS('GOTO ' || CLEAN(1) || ';')      COL(MACCOL+3);
         ANS('/* GO CLEAN UP & GET OUT      */') COL(REMCOL);
         ANS('IF TCBCREQ = ON  THEN')       COL(MACCOL);
         ANS('/* TCB ABEND BIT IS ON @ZA32859*/') COL (REMCOL);
         ANS('GOTO ' || SDUMP(1) || ';')     COL(MACCOL+3);
         ANS('/*GO TO DUMP RTN       @ZA26062*/') COL (REMCOL);
         ANS('RFY GPR15F RSTD;')          COL(MACCOL);
         ANS('/* RESTRICT WORKREG 15 ZA02517*/') COL(REMCOL);
         ANS('GPR15F = ''FFF''X;')        COL(MACCOL);
         ANS('/* SET USER ABEND MASK ZA02517*/') COL(REMCOL);
         ANS('GEN REFS(SDWACMPC,SDWAPTR)(N GPR15F,SDWACMPC-1(SDWAPTR));'
 )                                        COL(MACCOL);
         ANS('IF GPR15F ^= 0 THEN')       COL(MACCOL);
         ANS('/* IF USER ABEND CODE  ZA02517*/') COL(REMCOL);
         ANS('GOTO ' || CLEAN(1) || ';')      COL(MACCOL+3);
         ANS('/* GO CLEAN UP & EXIT  ZA02517*/') COL(REMCOL);
         ANS('RFY GPR15F UNRSTD;')          COL(MACCOL);
         ANS('/* RELEASE WORKREG 15  ZA02517*/')  COL(REMCOL);
         ANS('IF SDWASTAF = ON THEN')         COL(MACCOL) SKIP(2);
         ANS('/* A LOWER LEVEL ESTAE/FRR    */') COL(REMCOL);
         ANS('GOTO ' || SDUMP(1) || ';')      COL(MACCOL+3);
         ANS('/* WAS EXECUTING AND FAILED   */') COL(REMCOL);
         ANS('/* TAKE A DUMP FOR IT         */') COL(REMCOL);
         ANS('IF SDWATEXC = ON')              COL(MACCOL);   /*YM7586*/
         ANS('/* SOME NON-PROGRAM TYPE      */') COL(REMCOL);
         ANS(' | SDWAPGIO = ON')              COL(MACCOL);   /*YM7586*/
         ANS('/* ERROR HAS OCCURRED         */') COL(REMCOL);
         ANS(' | SDWAMCHK = ON THEN')         COL(MACCOL);   /*YM7586*/
         ANS('/* GO CLEAN UP & GET OUT      */') COL(REMCOL);
         ANS('GOTO ' || CLEAN(1) || ';')      COL(MACCOL+3); /*YM7586*/
         IF ENV ^= '' THEN DO;
            ANS('IF SDWAPERC = ON')     COL(MACCOL) SKIP(2); /*YM7586*/
            ANS('/* ESTAE OR RB BELOW US       */') COL(REMCOL);
            ANS(' | SDWANRBE = ON THEN')      COL(MACCOL+3); /*YM7586*/
            ANS('/* TRYING TO SAY SOMETHING    */') COL(REMCOL);
            ANS('GOTO ' || ENV(1) || ';')     COL(MACCOL+6);
            ANS('/* CHECK FOR ENVIRON PROBLEMS */') COL(REMCOL);
                           END;
         ANS('GOTO ' || USER(1) || ';') COL(MACCOL) SKIP(2); /*YM7586*/
         ANS('/* CHECK USER INPUT           */') COL(REMCOL);
         ANS('/' || REPEAT('*',MACRMAR-MACLMAR-2) || '/') COL(MACLMAR);
         ANS('END;') COL(MACCOL);
 % END;
