*%;/*
         MACRO
         IGGUSL
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IGGUSL
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = CHANGE LEVEL 01
.*
.*01  DESCRIPTIVE-NAME = UNSCHEDULED LIST FORMAT
.*
.*01  FUNCTION = FORMATS THE LIST CONTAINING IOBS WAITING FOR BUFFERS
.*
.*01  NOTES = NONE
.*
.*02    DEPENDENCIES = NA
.*
.*02    PERFORMANCE = NA
.*
.*02    RESTRICTIONS = NA
.*
.*02    REGISTER-CONVENTIONS = NA
.*
.*02    PATCH-LABEL = NA
.*
.*01  MODULE-TYPE = MACRO
.*
.*02  MACRO-SIZE =  NA
.*
.*02  EXTERNAL-REFERENCES = NA
.*
.*01INNER-MACROS = NONE
.*
.*01SYSTEM-MACROS = NONE
.*
.*01  CHANGE-ACTIVITY = SEE BELOW
.*
.*             VS2 RELEASE 2
.*
.**** END OF SPECIFICATIONS ***/
* /* MACCOMP Y-2 SC1D7/SJD48                                         */
* /* MACSTAT Y-2 73122/021160                                        */
*/********************************************************************/
*/* THE FOLLOWING DSECT FORMATS A BDAM UNSCHEDULED LIST USED WHEN    */
*/* DYNAMIC BUFFERING IS SPECIFIED IN THE DCB AND THE ADDRESS SPACE  */
*/* = VIRTUAL. ITS ADDRESS IS STORED IN DCBDYNB.  THE LIST CONSISTS  */
*/* OF A 16-BYTE HEADER AREA AND 12 OR MORE 4-BYTE FIELDS, EACH OF   */
*/* WHICH MAY CONTAIN THE ADDRESS OF AN IOB WAITING FOR A BUFFER.    */
*/* THE LIST IS A WRAP AROUND LIST.  THE FIRST IOB IS NOT NECESSARILY*/
*/* IN THE TOP SLOT, BUT THE NEXT IOB TO GET A FREED BUFFER.         */
*/********************************************************************/
*%GOTO USLPLS2;                         /*                     Y02072*/
USL      DSECT                     UNSCHEDULED LIST
USLSIZE  DS    H                   SIZE OF CURRENT LIST IN BYTES
USLSZFST EQU   64                  SIZE OF FIRST COPY OF USL
         DS    H                   UNUSED
USLBFRQT DS    0A                  PTR TO ADDR OF IOB ON TOP OF BUF Q
USLFLAGS DS    BL1                 FLAG INDICATING IF THIS CURRENT LIST
USLCURNT EQU   X'80'               IF ON, THIS IS THE CURRENT LIST
USLIOB1  DS    AL3                 3 BYTE ADDR OF IOB ON TOP OF BUF Q
USLBFRQB DS    0A                  PTR TO ADDR OF LAST IOB ON BUF Q
         DS    XL1                 UNUSED
USLIOB2  DS    AL3                 3 BYTE ADDR OF LAST IOB ON BUF Q
USLCHAIN DS    A                   PTR TO PRIOR LIST COPY
USLSLOT1 DS    A                   TOP SLOT ON QUEUE
*     *     *     *     *     *     *     *     *     *     *     *
USLSLOT  DSECT                     FORMAT OF AN IOB ADDRESS FIELD
*                                  REPRESENTING 1 SLOT IN THE USL
USLIOBA  DS    0A                  IF USED, IOB ADDR ON BOUNDARY
USLSLTFL DS    BL1                 FLAGS
USLENDL  EQU   X'80'               IF ON, SLOT IS LAST IN THE USL
USLINUSE EQU   X'40'               IF ON, SLOT IS BEING USED
USLIOBAA DS    AL3                 IF SLOT IS USED, IOB ADDR
USLNXT   EQU   *                   NEXT SLOT IN LIST
         MEND
*%USLPLS2: ;                            /*                     Y02072*/
*DCL 1 USL CHAR(64) BDY(WORD) BASED,    /* BEGINNING OF USL    Y02072*/
*      2 USLSIZE CHAR(2),               /* SIZE OF THIS USL    Y02072*/
*      2 *       CHAR(2),
*      2 USLBFRQT PTR(31),              /* PTR TO ADDR OF IOB  Y02072*/
*        3 USLFLAGS FIXED(8),           /* CURRENT LIST FLAG   Y02072*/
*        3 USLIOB1 PTR(24),             /* ADDR OF IOB ON TOP  Y02072*/
*      2 USLBFRQB PTR(31),              /* PTR TO LAST IOB     Y02072*/
*        3 *      FIXED(8),
*        3 USLIOB2 PTR(24),             /*  ADDR OF LAST IOB   Y02072*/
*      2 USLCHAIN PTR(31),              /* PTR TO PRIOR COPY   Y02072*/
*      2 USLSLOT1 PTR(31),              /* TOP SLOT ON QUEUE   Y02072*/
*      2 *    CHAR(44);                 /* REMAINDER OF LIST   Y02072*/
*DCL USLSZFST FIXED(8) CONSTANT(64);    /* SIZE OF FIRST USL   Y02072*/
*DCL USLCURNT FIXED(8) CONSTANT(128);   /* FLAG - CURRENT LIST Y02072*/
