TMAC     TITLE 'IGTMAC -- APUT/APAT SKELETON FOR VPSS (IGT1VPSS)'
IGTMAC   CSECT ,
*/* * START OF SPECIFICATIONS ************************************** */
*/*                                                                  */
*/*   MODULE-NAME = IGT1VPSS (LAST FOUR CHARACTERS ARE SUBSYSTEM)    */
*/*                                                                  */
*/*   DESCRIPTIVE-NAME = VPSS APUT/APAT SKELETON                     */
*/*                                                                  */
*/*   COPYRIGHT = NONE                                               */
*/*                                                                  */
*/*   STATUS = RELEASE 1, MODIFICATION LEVEL 0.                      */
*/*                                                                  */
*/*   FUNCTION = THIS MODULE CONTAINS THE SKELETON APUT AND          */
*/*       APAT FOR VPSS.                                             */
*/*                                                                  */
*/*   NOTES =                                                        */
*/*     THIS MODULE MUST BE LINKEDITED AS SERIALLY REUSABLE WITH     */
*/*     A NAME OF IGT1XXXX WHERE XXXX IS THE NAME OF THE ASSOCIATED  */
*/*     SUBSYSTEM (NORMALLY VPSS).                                   */
*/*                                                                  */
*/*     DEPENDENCIES =                                               */
*/*        THE APUT MUST BE THE FIRST ENTRY IN THE MODULE.           */
*/*                                                                  */
*/*     RESTRICTIONS =  NONE.                                        */
*/*                                                                  */
*/*     REGISTER-CONVENTIONS = STANDARD VPSS CONVENTIONS             */
*/*                                                                  */
*/*     PATCH-LABEL = APPATCH                                        */
*/*                                                                  */
*/*   MODULE-TYPE = CSECT                                            */
*/*                                                                  */
*/*     PROCESSOR = VS/2 ASSEMBLER                                   */
*/*                                                                  */
*/*     MODULE SIZE = SEE END OF ASSEMBLER LISTING                   */
*/*                                                                  */
*/*     ATTRIBUTES = REUSABLE, ONLY-LOADABLE                         */
*/*                                                                  */
*/*   ENTRY-POINT = IGTMAC                                           */
*/*                                                                  */
*/*     PURPOSE = SAME AS FUNCTION                                   */
*/*                                                                  */
*/*     LINKAGE = MODULE IS ONLY LOADABLE                            */
*/*                                                                  */
*/*     INPUT = N/A.                                                 */
*/*                                                                  */
*/*     OUTPUT = N/A.                                                */
*/*                                                                  */
*/*   EXIT-NORMAL = N/A.                                             */
*/*                                                                  */
*/*   EXIT-ERROR  = N/A.                                             */
*/*                                                                  */
*/*   EXTERNAL-REFERENCES = NONE                                     */
*/*                                                                  */
*/*     ROUTINES = NONE                                              */
*/*                                                                  */
*/*     DATA-AREAS = NONE                                            */
*/*                                                                  */
*/*     CONTROL-BLOCKS = NONE                                        */
*/*                                                                  */
*/*   TABLES =                                                       */
*/*       THIS MODULE CONTAINS THE APUT AND APAT SKELETONS.          */
*/*                                                                  */
*/*   MACROS =                                                       */
*/*       IGTXEPLG                                                   */
*/*                                                                  */
*/*   CHANGE-ACTIVITY = NONE                                         */
*/*                                                                  */
*/*   MESSAGES = NONE                                                */
*/*                                                                  */
*/*   ABEND-CODES = NONE                                             */
*/*                                                                  */
*/* * END OF SPECIFICATIONS **************************************** */
         EJECT ,
         IGTXAPUT DSECT=NO,LIST=YES GENERATE APUT
         SPACE 3
         ORG   APUTAPAT            FILL-IN APAT POINTER
         DC    A(APAT)             POINT TO APAT -- ALSO IN THIS PGM
         ORG   ,                   RESET TO END OF APUT
         EJECT ,
         IGTXAPAT DSECT=NO,LIST=YES GENERATE APAT
         EJECT ,
         IGTXEPLG ,                PATCH AREA
         SPACE 3
         END   ,
