TKBF     TITLE 'IGTKBF -- VPSS I/O DRIVER PURGE                        *
                        '
IGTKBF   CSECT ,                   START OF CODE
*   STM(R0F,R15F,R13P->I256C);      /* SAVE INPUT REGISTERS          */
         STM   R0F,R15F,I256C(R13P)                             01S0119
*   RFY                                                         01S0120
*     APCODE RSTD;                  /* SAFE REGISTER                 */
*   APCODE=R15P;                    /* CHANGE BASE REGISTERS         */
         LR    APCODE,R15P                                      01S0121
*   GEN(USING IGTKBF,APCODE)                                    01S0122
*   NOSETS REFS(APCODE);            /* TELL THE ASSEMBLER            */
         USING IGTKBF,APCODE
*   RFY                                                         01S0123
*     R15P UNRSTD;                  /* DONE WITH BASE REGISTER       */
*                                                               01S0123
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE IF PURGE PROCESSING REQUIRED                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0124
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0124
*     /***************************************************************/
*     /*                                                             */
*     /* CHECK INPUT IPIB TO DETERMINE IF ANY WORK REQUIRED.         */
*     /* PROCESSING REQUIRED ONLY IF: (1) HALT REQUESTED, (2) NOT    */
*     /* MEMORY PURGE, (3) IOS FOUND ACTIVE WORK (IPIBSRB^=0). IF ANY*/
*     /* OF THESE CONDITIONS FAIL, THEN RETURN TO CALLER. THIS       */
*     /* PROCESSING CANNOT USE THE PL/S DYNAMIC SAVEAREA/WORKAREA    */
*     /* SINCE IT DOES NOT YET EXIST. THIS IS "FAST-PATH" CODE TO    */
*     /* PERFORM QUICK CHECK FOR FURTHER PURGE PROCESSING            */
*     /* REQUIREMENTS.                                               */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0125
*     IF IPIBHALT=BOFF|             /* IF QUIESCE OR                 */
*         IPIBMEM=BON|              /* MEMORY PURGE, OR              */
*         IPIBSRB=0 THEN            /* NO WORK FOUND BY IOS,         */
         TM    IPIBMEM(R1P),B'10000000'                         02S0125
         BNZ   @RT00125                                         02S0125
         TM    IPIBHALT(R1P),B'00000100'                        02S0125
         BNO   @RT00125                                         02S0125
         L     @06,IPIBSRB(,R1P)                                02S0125
         LTR   @06,@06                                          02S0125
         BNZ   @RF00125                                         02S0125
@RT00125 DS    0H                                               02S0126
*       DO;                         /* THEN EXIT -- PURGE COMPLETE.  */
*         LM(R0F,R15F,APSVPTR->I256C);/* RE-LOAD INPUT REGISTERS     */
         LM    R0F,R15F,I256C(APSVPTR)                          02S0127
*         RETURN;                   /* RETURN TO CALLER              */
@EL00001 DS    0H                                               02S0128
@EF00001 DS    0H                                               02S0128
@ER00001 BR    @14                                              02S0128
*       END;                        /* INITIAL CHECK COMPLETE        */
*   END;                            /* PURGE PROCESSING REQUIRED     */
@RF00125 DS    0H                                               02S0131
*                                                               01S0131
*   /*****************************************************************/
*   /*                                                               */
*   /* IGTKBF PURGE PROCESSING REQUIRED                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0131
*   GEN(MODESET EXTKEY=DATAMGT)                                 01S0131
*   NOREFS NOSETS;                  /* GET OUT OF KEY-0              */
         MODESET EXTKEY=DATAMGT
*   RFY                                                         01S0132
*     RIPIBPTR RSTD;                /* SAVE IPIB ADDRESS IN          */
*   RIPIBPTR=ADDR(IPIB);            /* IN NON-VOLITILE REGISTER      */
         LR    RIPIBPTR,R1P                                     01S0133
*   RFY                                                         01S0134
*     IPIB BASED(RIPIBPTR);         /* (REGISTER 1 DESTROYED).       */
*                                                               01S0134
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN AND INITIALIZE SAVEAREA/WORKAREA                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0135
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0135
*     /***************************************************************/
*     /*                                                             */
*     /* BUILD AND INITIALIZE A SAVEAREA/WORKAREA. ISSUE AN          */
*     /* UNCONDITIONAL GETMAIN FOR THE REQUESTED SAVEAREA/WORKAREA   */
*     /* SIZE. USE SP-230 (KEY-5).                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0136
*     RFY                                                       02S0136
*      (R0F,                                                    02S0136
*       R1P) RSTD;                  /* REQUIRED REGISTERS            */
*     R0F=(@SIZDATD+APSVOSLN)       /* LENGTH (SAVEAREA + WORKAREA)  */
*         |(CWORKSP*'01000000'X);   /* USE SUBPOOL 230               */
         LA    R0F,72                                           02S0137
         AL    R0F,@SIZDATD                                     02S0137
         O     R0F,@CF03115                                     02S0137
*     GEN(GETMAIN R,LV=(0));        /* GET THE STORAGE               */
         GETMAIN R,LV=(0)
*     RFY                                                       02S0139
*       R0F RSTD;                   /* DONE WITH LENGTH REGISTER     */
*                                                               02S0139
*     /***************************************************************/
*     /*                                                             */
*     /* BUILD SAVEAREA. POINT TO DYNAMIC AREA.                      */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0140
*     R1P->APSVPREV=APSVPTR;        /* PREVIOUS SAVEAREA             */
         ST    APSVPTR,APSVPREV(,R1P)                           02S0140
*     APSVPTR=R1P;                  /* POINT TO NEW SAVEAREA         */
         LR    APSVPTR,R1P                                      02S0141
*     RFY                                                       02S0142
*       R1P UNRSTD;                 /* FINISHED WITH REGISTER 1      */
*     RFY                                                       02S0143
*       APDATA RSTD;                /* SET APDATA TO ADDRESS         */
*     APDATA=ADDR(APSV)+APSVOSLN;   /* OF PL/S DYNAMIC AREA          */
         LA    APDATA,72(,APSVPTR)                              02S0144
*     GEN(USING @DATD,APDATA)                                   02S0145
*     NOSETS REFS(APDATA);          /* (AFTER OS SAVEAREA).          */
         USING @DATD,APDATA
*   END;                            /* END OF CODE SEGMENT           */
*                                                               01S0147
*   /*****************************************************************/
*   /*                                                               */
*   /* PROVIDE RECOVERY (FRR) SUPPORT                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0147
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0147
*     /***************************************************************/
*     /*                                                             */
*     /* ESTABLISH RECOVERY ENVIRONMENT. THIS EXIT WILL GAIN CONTROL */
*     /* IF AN ABEND OCCURS. A DUMP IS TAKEN, THE APPROPRIATE ERROR  */
*     /* FLAGS SET, AND CONTROL PASSED TO THE CLEANUP ROUTINE TO     */
*     /* RELEASE RESOURCES BEFORE RETURNING TO THE CALLER.           */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0148
*                                                               02S0148
*     /***************************************************************/
*     /*                                                             */
*     /* BUILD ESTAE/FRR EXIT PARAMETER LIST (APES). THE FRR EXIT    */
*     /* WILL BRANCH TO THE ADDRESS IN APESEXRA. THIS WILL BE EITHER */
*     /* THE ADDRESS OF AN IMMEDIATE RETURN (XNOSTAE) OR MODULE      */
*     /* 'IGTUKA' FOR THE SUBSYSTEM BEING PROCESSED. IT IS 'IGTUKA'  */
*     /* WHEN THE APIO IS ACTUALLY BEING PROCESSED.                  */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0148
*     RFY                                                       02S0148
*      (R0P,                                                    02S0148
*       R1F,                                                    02S0148
*       R14P,                                                   02S0148
*       R15F) RSTD;                 /* INITIALIZE APES BLOCK         */
*     R0P=ADDR(APES);               /* TO ZEROS                      */
         LA    R0P,APES                                         02S0149
*     R1F=LENGTH(APES);             /* USE MVCL TO                   */
         LA    R1F,648                                          02S0150
*     R15F=0;                       /* CLEAR, SINCE FIELD            */
         SLR   R15F,R15F                                        02S0151
*     MVCL(R0P,R14P);               /* MORE THAN 256 BYTES LONG      */
         MVCL  R0P,R14P                                         02S0152
*     RFY                                                       02S0153
*      (R0P,                                                    02S0153
*       R1F,                                                    02S0153
*       R14P,                                                   02S0153
*       R15F) UNRSTD;               /* FINISHED WITH MVCL REGS       */
*     APESID=APESIDC;               /* IN-CORE ID                    */
         MVC   APESID(4),@CC02952                               02S0154
*     APESADDR=ADDR(APES);          /* ESTAE/SETFRR PARM VALUE       */
         LA    @10,APES                                         02S0155
         ST    @10,APESADDR                                     02S0155
*     APESAPMV=ADDR(CMBRXZZZ);      /* MESSAGE INDEX VALUES          */
         LA    @10,CMBRXZZZ                                     02S0156
         ST    @10,APESAPMV                                     02S0156
*     APESFREC=BON;                 /* RECORD ON LOGREC              */
*     APESFSDP=BON;                 /* SDUMP ON ERROR                */
         OI    APESFREC,B'01100000'                             02S0158
*     APESMXCD=CERRN99;             /* NUMBER OF CMBRXZZZ ENTRIES    */
         MVI   APESMXCD,X'02'                                   02S0159
*     APESMOD='IGTKBF  ';           /* MODULE IN CONTROL             */
         MVC   APESMOD(8),@CC03019                              02S0160
*     APESPROC='IGTKBF  ';          /* CSECT IN CONTROL              */
         MVC   APESPROC(8),@CC03019                             02S0161
*     APESFRR='        ';           /* NO FRR ID                     */
         MVC   APESFRR(8),@CC03020                              02S0162
*     APESREGP=ADDR(APESREGZ);      /* DEFAULT REGISTER SAVEAREA     */
         LA    @10,APESREGZ                                     02S0163
         ST    @10,APESREGP                                     02S0163
*     RFY                                                       02S0164
*      (R15P) RSTD;                 /* SET REGISTER 15 TO            */
*     R15P=ADDR(EXIT);              /* BACKOUT ROUTINE               */
         LA    R15P,EXIT                                        02S0165
*     STM(R0F,R15F,APESREGZ);       /* SAVE REGISTERS FOR RETRY      */
         STM   R0F,R15F,APESREGZ                                02S0166
*     RFY                                                       02S0167
*       R15P UNRSTD;                /* FINISHED WITH 15              */
*     APESCODE=CERRN99;             /* 'UNKNOWN' ERROR               */
         MVI   APESCODE,X'02'                                   02S0168
*     CALL GETLLCK;                 /* GET LOCAL LOCK & ISSUE SETFRR */
         BAL   @14,GETLLCK                                      02S0169
*   END;                            /* RECOVERY ENVIRONMENT SET      */
*                                                               01S0171
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE RESOURCES FOR PURGED VPSS I/O REQUESTS                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0171
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0171
*     /***************************************************************/
*     /*                                                             */
*     /* CALL IGTKBC TO FREE THE RESOURCES ASSOCIATED WITH THE 3838  */
*     /* SUBSYSTEM IOSB. DO NOT POST/RESUME THE USER.                */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0172
*     DIPIBSRB=IPIBSRB;             /* FIRST SRB/IOSB ENTRY          */
         L     @10,IPIBSRB(,RIPIBPTR)                           02S0172
         ST    @10,DIPIBSRB                                     02S0172
*     GEN(MODESET EXTKEY=ZERO)                                  02S0173
*     NOREFS NOSETS;                /* IPIB KEY                      */
         MODESET EXTKEY=ZERO
*     IPIBSRB=0;                    /* ZERO CHAIN                    */
         SLR   @10,@10                                          02S0174
         ST    @10,IPIBSRB(,RIPIBPTR)                           02S0174
*     GEN(MODESET EXTKEY=DATAMGT)                               02S0175
*     NOREFS NOSETS;                /* RESUME STANDARD PROCESSING KEY*/
         MODESET EXTKEY=DATAMGT
*     DRETRY(01)=APESRTRY;          /* SAVE CURRENT RETRY POINT      */
         L     @10,APESREGP                                     02S0176
         L     @10,APESRTRY(,@10)                               02S0176
         ST    @10,DRETRY                                       02S0176
*     DRETRY(02)=APESEXRA;          /* SAVE CURRENT FRR EXIT POINT   */
         L     @10,APESEXRA                                     02S0177
         ST    @10,DRETRY+4                                     02S0177
*     DO WHILE(DIPIBSRB^=0);        /* PROCESS ALL SRB/IOSB ENTRIES  */
         B     @DE00178                                         02S0178
@DL00178 DS    0H                                               02S0179
*       RFY                                                     02S0179
*        (R0P,                                                  02S0179
*         R1P) RSTD;                /* IGTKBC INTERFACE REGISTERS    */
*       R1P=DIPIBSRB->SRBPARM;      /* POINT TO IOSB                 */
         L     @10,DIPIBSRB                                     02S0180
         L     R1P,SRBPARM(,@10)                                02S0180
*       RFY                                                     02S0181
*         APIO BASED(R1P);          /* (IOSB FIRST IN APIO)          */
*       DIPIBSRB=DIPIBSRB->SRBFLNK; /* KEEP NEXT POINTER             */
         L     @10,SRBFLNK(,@10)                                02S0182
         ST    @10,DIPIBSRB                                     02S0182
*       R0P=-ADDR(APIOSRB);         /* SRB ADDRESS (COMPLEMENTED
*                                      MEANS LOCAL LOCK OWNED)       */
         LA    R0P,APIOSRB(,R1P)                                02S0183
         LCR   R0P,R0P                                          02S0183
*       APCTPTR=APIOAPCT;           /* ESTABLISH APCT ADDRESS        */
         L     APCTPTR,APIOAPCT(,R1P)                           02S0184
*       APESREGC=APCTPTR;           /* IGTUKA REQUIRES APCT ADDRESS  */
         L     @10,APESREGP                                     02S0185
         ST    APCTPTR,APESREGC(,@10)                           02S0185
*       APESRTRY=ADDR(PURGE1);      /* RETRY POINT (TRY NEXT APIO)   */
         LA    @15,PURGE1                                       02S0186
         ST    @15,APESRTRY(,@10)                               02S0186
*       APESEXRA=APCTZUKA;          /* ESTAE EXIT ADDRESS            */
         L     @10,APCTZUKA(,APCTPTR)                           02S0187
         ST    @10,APESEXRA                                     02S0187
*       APESMOD='IGTKBC  ';         /* MODULE IN CONTROL             */
         MVC   APESMOD(8),@CC03025                              02S0188
*       APESPROC='IGTKBC  ';        /* CSECT IN CONTROL              */
         MVC   APESPROC(8),@CC03025                             02S0189
*       APESCODE=CERRN01;           /* ERROR CODE -- BAD APIO        */
         MVI   APESCODE,X'01'                                   02S0190
*       APIORET=BON;                /* IGTKBC RETURN WANTED          */
         OI    APIORET(R1P),B'00100000'                         02S0191
*       GEN(MODESET EXTKEY=ZERO)                                02S0192
*       NOREFS NOSETS;              /* IGTKBC REQUIRES KEY 0         */
         MODESET EXTKEY=ZERO
*       CALL APCVZKBC;              /* FREE THE RESOURCES            */
         L     @15,APCTZKBC(,APCTPTR)                           02S0193
         BALR  @14,@15                                          02S0193
*       GEN(MODESET EXTKEY=DATAMGT)                             02S0194
*       NOREFS NOSETS;              /* RESUME STANDARD KEY           */
         MODESET EXTKEY=DATAMGT
*       RFY                                                     02S0195
*         APIO;                     /* DONE WITH APIO                */
*       RFY                                                     02S0196
*        (R0P,                                                  02S0196
*         R1P) UNRSTD;              /* DONE WITH INTERFACE REGISTERS */
*PURGE1:                            /* RETRY POINT IF IGTKBC FAILS   */
*       DO;                         /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               02S0197
PURGE1   DS    0H                                               02S0198
*         /***********************************************************/
*         /*                                                         */
*         /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY DOES NOT     */
*         /* INSURE REGISTERS 0-5, 8-11, 14-15 VALID SINCE NOT SAVED */
*         /* IN APESREGS. ISSUE DUMMY RESTRICT TO WIPE PL/S          */
*         /* OPTIMIZATION MEMORY OF CURRENT REGISTER VALUES          */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0198
*         RFY                                                   02S0198
*          (R0RSTD,                                             02S0198
*           R1RSTD,                                             02S0198
*           R2RSTD,                                             02S0198
*           R3RSTD,                                             02S0198
*           R4RSTD,                                             02S0198
*           R5RSTD,                 /* 6-7 BASES                     */
*           R8RSTD,                                             02S0198
*           R9RSTD,                                             02S0198
*           R10RSTD,                                            02S0198
*           R11RSTD,                /* 12-13 APCT/APSV PTRS          */
*           R14RSTD,                                            02S0198
*           R15RSTD) RSTD;          /* KEEP PL/S FROM CARRYING DATA  */
*         GEN(MODESET EXTKEY=DATAMGT);/* SWITCH TO STANDARD KEY (5)  */
         MODESET EXTKEY=DATAMGT
*         RFY                                                   02S0200
*          (R0RSTD,                                             02S0200
*           R1RSTD,                                             02S0200
*           R2RSTD,                                             02S0200
*           R3RSTD,                                             02S0200
*           R4RSTD,                                             02S0200
*           R5RSTD,                 /* 6-7 BASES                     */
*           R8RSTD,                                             02S0200
*           R9RSTD,                                             02S0200
*           R10RSTD,                                            02S0200
*           R11RSTD,                /* 12-13 APCT/APSV PTRS          */
*           R14RSTD,                                            02S0200
*           R15RSTD) UNRSTD;        /* ALLOW PL/S TO USE REGS AGAIN  */
*       END;                        /* RETRY ENVIRONMENT SET         */
*       APESEXRA=DRETRY(02);        /* RESET EXIT ADDRESS            */
         L     @10,DRETRY+4                                     02S0202
         ST    @10,APESEXRA                                     02S0202
*       APESRTRY=DRETRY(01);        /* RESET RETRY ADDRESS           */
         L     @10,DRETRY                                       02S0203
         L     @01,APESREGP                                     02S0203
         ST    @10,APESRTRY(,@01)                               02S0203
*       APESMOD='IGTKBF  ';         /* MODULE IN CONTROL             */
         MVC   APESMOD(8),@CC03019                              02S0204
*       APESPROC='IGTKBF  ';        /* CSECT IN CONTROL              */
         MVC   APESPROC(8),@CC03019                             02S0205
*       DO;                         /* ERROR RECOVERY COMPLETE       */
*         APESFPRV=BOFF;            /* RESET RECURSION FLAG.         */
         NI    APESFPRV,B'10111111'                             02S0207
*         APESCODE=CERRN99;         /* RESET ERROR CODE              */
         MVI   APESCODE,X'02'                                   02S0208
*         APESFSDP=BON;             /* RESET DUMP/LOG FLAGS          */
*         APESFREC=BON;             /* TO THEIR NORMAL VALUES        */
         OI    APESFSDP,B'01100000'                             02S0210
*       END;                        /* ALL INDICATORS RESET          */
*     END;                          /* CONTINUE LOOP                 */
@DE00178 L     @10,DIPIBSRB                                     02S0212
         LTR   @10,@10                                          02S0212
         BNZ   @DL00178                                         02S0212
*   END;                            /* APIO RESOURCES FREED          */
*                                                               01S0214
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESSING COMPLETE. CANCEL RECOVERY ENVIRONMENT.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0214
*EXIT:                              /* RETRY POINT                   */
*   DO;                             /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               01S0214
EXIT     DS    0H                                               01S0215
*     /***************************************************************/
*     /*                                                             */
*     /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY DOES NOT INSURE  */
*     /* REGISTERS 0-5, 8-11, 14-15 VALID SINCE NOT SAVED IN         */
*     /* APESREGS. ISSUE DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION    */
*     /* MEMORY OF CURRENT REGISTER VALUES                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0215
*     RFY                                                       01S0215
*      (R0RSTD,                                                 01S0215
*       R1RSTD,                                                 01S0215
*       R2RSTD,                                                 01S0215
*       R3RSTD,                                                 01S0215
*       R4RSTD,                                                 01S0215
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0215
*       R9RSTD,                                                 01S0215
*       R10RSTD,                                                01S0215
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0215
*       R15RSTD) RSTD;              /* KEEP PL/S FROM CARRYING DATA  */
*     GEN(MODESET EXTKEY=DATAMGT);  /* SWITCH TO STANDARD KEY (5)    */
         MODESET EXTKEY=DATAMGT
*     RFY                                                       01S0217
*      (R0RSTD,                                                 01S0217
*       R1RSTD,                                                 01S0217
*       R2RSTD,                                                 01S0217
*       R3RSTD,                                                 01S0217
*       R4RSTD,                                                 01S0217
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0217
*       R9RSTD,                                                 01S0217
*       R10RSTD,                                                01S0217
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0217
*       R15RSTD) UNRSTD;            /* ALLOW PL/S TO USE REGS AGAIN  */
*   END;                            /* RETRY ENVIRONMENT SET         */
*                                                               01S0219
*   /*****************************************************************/
*   /*                                                               */
*   /* CANCEL RECOVERY SUPPORT                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0219
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0219
*     /***************************************************************/
*     /*                                                             */
*     /* CANCEL THE RECOVERY ENVIRONMENT AND RELEASE THE LOCAL LOCK. */
*     /* ALL PROCESSING NOW COMPLETE.                                */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0220
*     CALL FREELLCK;                /* FREE THE LOCAL LOCK           */
         BAL   @14,FREELLCK                                     02S0220
*   END;                            /* RECOVERY ENVIRONMENT CANCELLED*/
*                                                               01S0222
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE SAVEAREA/WORKAREA                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0222
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0222
*     /***************************************************************/
*     /*                                                             */
*     /* FREE THE ACQUIRED PL/S SAVEAREA/WORKAREA. RESET REGISTER 13 */
*     /* TO THE ADDRESS OF THE INPUT SAVEAREA .                      */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0223
*     RFY                                                       02S0223
*      (R0F,                                                    02S0223
*       R1P) RSTD;                  /* REQUIRED REGISTERS            */
*     R0F=(@SIZDATD+APSVOSLN)       /* LENGTH (SAVEAREA + WORKAREA)  */
*         |(CWORKSP*'01000000'X);   /* USE SUBPOOL 230               */
         LA    R0F,72                                           02S0224
         AL    R0F,@SIZDATD                                     02S0224
         O     R0F,@CF03115                                     02S0224
*     R1P=APSVPTR;                  /* ADDRESS OF ACQUIRED AREA      */
         LR    R1P,APSVPTR                                      02S0225
*     APSVPTR=APSVPTR->APSVPREV;    /* RESTORE INPUT REGISTER 13     */
         L     APSVPTR,APSVPREV(,APSVPTR)                       02S0226
*     GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE ACQUIRED STORAGE         */
         FREEMAIN R,LV=(0),A=(1)
*     RFY                                                       02S0228
*      (R0F,                                                    02S0228
*       R1P) UNRSTD;                /* DONE WITH REGISTERS           */
*   END;                            /* STORAGE RELEASED              */
*   GEN(MODESET EXTKEY=ZERO)                                    01S0230
*   NOREFS NOSETS;                  /* RESUME INPUT KEY (0)          */
         MODESET EXTKEY=ZERO
*   LM(R0F,R15F,APSVPTR->I256C);    /* RELOAD INPUT REGISTERS        */
         LM    R0F,R15F,I256C(APSVPTR)                          01S0231
*   GEN(BR    R14P)                                             01S0232
*   REFS(R14P) NOSETS NOSEQFLOW FLOWS(*);/* RETURN TO CALLER         */
         BR    R14P
         EJECT
*                                                               01S0233
*   /*****************************************************************/
*   /*                                                               */
*   /* INTERNAL SUBROUTINES                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0233
*GETLLCK:                           /* GET THE LOCAL LOCK AND        */
*   PROC OPTIONS(NOSAVEAREA);       /* ESTABLISH FRR ENVIRONMENT     */
*                                                               02S0233
GETLLCK  STM   @14,@12,12(@13)                                  02S0233
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE LOCAL LOCK. THEN ISSUE A SETFRR TO PROVIDE RECOVERY   */
*   /* SUPPORT. THE SAME PARAMETERS AS AVAILABLE TO AN ESTAE (IF ANY)*/
*   /* ARE PASSED ('APES' BLOCK)                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0234
*                                                               02S0234
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE LOCAL LOCK                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0234
*   STM(R11F,R13F,DSUPVSVE);        /* SAVE DESTROYED REGISTERS      */
         STM   R11F,R13F,DSUPVSVE                               02S0234
*   GEN REFS(PSALITA,FLC) SETS(R11F,R12F,R13F,R14F);            02S0235
*                                   /*
         MODESET EXTKEY=ZERO       SETLOCK REQUIRES KEY-0
         SETLOCK OBTAIN,           ACQUIRE THE                         *
               TYPE=LOCAL,         * LOCAL LOCK                        *
               MODE=UNCOND,        * UNCONDITIONALLY.                  *
               RELATED=(FREELLCK,APESFLLK) * R13 HAS RETURN CODE
         MODESET EXTKEY=DATAMGT    RESUME STANDARD KEY
*   LM(R11F,R13F,DSUPVSVE);         /* RELOAD DESTROYED REGISTERS    */
         LM    R11F,R13F,DSUPVSVE                               02S0236
*   APESFLLK=BON;                   /* SHOW LOCAL LOCK OWNED         */
*                                                               02S0237
         OI    APESFLLK,B'00100000'                             02S0237
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE SETFRR TO COVER THE PROCESSING. PARAMETER LIST IS 'APES'*/
*   /* BLOCK. THE EXIT ROUTINE IS 'XERR' WHICH BRANCHES TO THE       */
*   /* ADDRESS CONTAINED IN 'APESEXRA' (THE TRUE EXIT ROUTINE). THIS */
*   /* FIELD CONTAINS EITHER THE ADDRESS OF 'XNOSTAE' OF 'IGTUKA' FOR*/
*   /* THE APPROPRIATE 3838 SUBSYSTEM.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0238
*   APESEXRA=ADDR(XNOSTAE);         /* 'CONTINUE ABEND' EXIT         */
         LA    @10,XNOSTAE                                      02S0238
         ST    @10,APESEXRA                                     02S0238
*   RFY                                                         02S0239
*     R15P RSTD;                    /* SETFRR SETS TO PARM LIST      */
*   GEN REFS(PSA,PSACSTK,PSALSFCC,CXERR,FRRSFRRA,FRRSENTR,FRRSPARM,
*       FRRSCURR,FRRSLAST,FRRS) SETS(R14F,R15F,R15P) SEQFLOW FLOWS(XERR
*       ,XNOSTAE);                                              02S0240
*                                    /* SHOW ERROR FLOW
         MODESET EXTKEY=ZERO       SETFRR REQUIRES KEY-0
         SETFRR A,FRRAD=CXERR,     'XERR' IS EXIT ROUTINE              *
               PARMAD=(R15P),      * SAVE @ 6-WORD PARM FIELD HERE     *
               CLEAR=NO,           * DO NOT CLEAR PARM FIELD           *
               WRKREGS=(R14F,R15F), * WORK REGISTERS                   *
               RELATED=(FREELLCK,APES) * APES IS INPUT
*   R15P->I031P=ADDR(APES);         /* 1ST WORD OF PARM LIST IS 02S0241
*                                      ADDRESS OF 'APES'             */
         LA    @14,APES                                         02S0241
         ST    @14,I031P(,R15P)                                 02S0241
*   RFY                                                         02S0242
*     R15P UNRSTD;                  /* SETFRR PARM FIELD SET         */
*   GEN(MODESET EXTKEY=DATAMGT)                                 02S0243
*   NOREFS NOSETS;                  /* RESUME STANDARD KEY           */
         MODESET EXTKEY=DATAMGT
*   APESFFRR=BON;                   /* SHOW SETFRR ISSUED            */
*                                                               02S0244
         OI    APESFFRR,B'10000000'                             02S0244
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESSING COMPLETE. RETURN TO CALLER                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0245
*   RETURN;                         /* RETURN TO CALLER              */
@EL00002 DS    0H                                               02S0245
@EF00002 DS    0H                                               02S0245
@ER00002 LM    @14,@12,12(@13)                                  02S0245
         BR    @14                                              02S0245
*XERR:                                                          02S0246
*   ;                                                           02S0246
*                                                               02S0246
XERR     DS    0H                                               02S0247
*   /*****************************************************************/
*   /*                                                               */
*   /* SETFRR EXIT ROUTINE (DEFINED TO SETFRR MACRO). LOAD 'APESEXRA'*/
*   /* ADDRESS (TRUE EXIT ROUTINE) AND GO TO IT WITHOUT CHANGING ANY */
*   /* OTHER REGISTERS.                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0247
*   GEN REFS(R1P,SDWAPARM,SDWA,APESEXRA,APES) SETS(R15P) FLOWS(XNOSTAE,
*       APCVZUKA);                                              02S0247
*                                /*
         PUSH  USING               SAVE USING STATUS
         DROP  ,                   REGISTERS UNPREDICATBLE
         L     R15P,SDWAPARM-SDWA(,R1P) POINT TO 6-WORD RECOVERY AREA
         L     R15P,0(,R15P)       FIRST WORD IS ADDRESS OF APES
         L     R15P,APESEXRA-APES(,R15P) TRUE EXIT ROUTINE ADDRESS
         BR    R15P                GO TO 'XNOSTAE' OR 'IGTUKA'
         POP   USING               RESTORE USING STATUS
*XNOSTAE:                                                       02S0248
*   PROC                            /* 'IGTUKA' NOT ESTABLISHED      */
*       OPTIONS(NOSAVE,NOSAVEAREA); /* NO R13 SAVEAREA (FRR)         */
*                                                               02S0248
         B     @PB00003                                         02S0248
XNOSTAE  DS    0H                                               02S0249
*   /*****************************************************************/
*   /*                                                               */
*   /* CANNOT ASSOCIATE ERROR WITH PARTICULAR 3838 SUBSYSTEM. THIS   */
*   /* EXIT WILL RETURN IMMEDIATELY TO PERCOLATE THE ERROR TO THE    */
*   /* NEXT HIGHER SETFRR/ESTAE.                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0249
*   RETURN CODE(0);                 /* RETURN TO CONTINUE THE ABEND  */
         SLR   @15,@15                                          02S0249
@EL00003 DS    0H                                               02S0249
@EF00003 DS    0H                                               02S0249
@ER00003 BR    @14                                              02S0249
*   END XNOSTAE;                    /* END OF DUMMY SETFRR EXIT      */
*   END GETLLCK;                    /* END OF SUBROUTINE             */
         B     @EL00002                                         02S0251
         EJECT
*FREELLCK:                          /* RELEASE THE LOCAL LOCK        */
*   PROC OPTIONS(NOSAVEAREA);       /* CANCEL THE FRR ENVIRONMENT    */
*                                                               02S0252
FREELLCK STM   @14,@12,12(@13)                                  02S0252
*   /*****************************************************************/
*   /*                                                               */
*   /* CANCEL THE CURRENT FRR (SET BY GETLLCK). THEN RELEASE THE     */
*   /* LOCAL LOCK.                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0253
*                                                               02S0253
*   /*****************************************************************/
*   /*                                                               */
*   /* CANCEL THE RECOVERY ENVIRONMENT                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0253
*   IF APESFFRR=BON THEN            /* IF SETFRR ISSUED,             */
         TM    APESFFRR,B'10000000'                             02S0253
         BNO   @RF00253                                         02S0253
*     DO;                           /* THEN CANCEL IT.               */
*       APESFFRR=BOFF;              /* SHOW NOT IN FRR               */
         NI    APESFFRR,B'01111111'                             02S0255
*       GEN REFS(PSA,PSACSTK,FRRS,FRRSCURR,FRRSEMP,FRRSELEN,FRRSCURR)
*           SETS(R14F,R15F);                                    02S0256
*                                   /*
         MODESET EXTKEY=ZERO       SETFRR REQUIRES KEY-0
         SETFRR D,                 CANCEL THE CURRENT ENTRY            *
               WRKREGS=(R14F,R15F), * WORK REGISTERS                   *
               RELATED=(GETLLCK,APES) * APES WAS INPUT
         MODESET EXTKEY=DATAMGT    RESUME STANDARD KEY
*     END;                          /* FRR CANCELLED                 */
*                                                               02S0257
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE THE LOCAL LOCK                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0258
*   IF APESFLLK=BON THEN            /* IF LOCAL LOCK OWNED,          */
@RF00253 TM    APESFLLK,B'00100000'                             02S0258
         BNO   @RF00258                                         02S0258
*     DO;                           /* THEN RELEASE IT.              */
*       STM(R11F,R13F,DSUPVSVE);    /* SAVE DESTROYED REGISTERS      */
         STM   R11F,R13F,DSUPVSVE                               02S0260
*       GEN REFS(PSALITA,FLC) SETS(R11F,R12F,R13F,R14F);        02S0261
*                                      /*
         MODESET EXTKEY=ZERO       SETLOCK REQUIRES KEY-0
         SETLOCK RELEASE,          RELEASE THE                         *
               TYPE=LOCAL,         * LOCAL LOCK                        *
               RELATED=(GETLLCK,APESFLLK) * R13 HAS RETURN CODE
         MODESET EXTKEY=DATAMGT    RESUME STANDARD KEY
*       LM(R11F,R13F,DSUPVSVE);     /* RESTORE DESTROYED REGISTERS   */
         LM    R11F,R13F,DSUPVSVE                               02S0262
*       APESFLLK=BOFF;              /* SHOW LOCK NOT OWNED           */
         NI    APESFLLK,B'11011111'                             02S0263
*     END;                          /* LOCK RELEASED                 */
*                                                               02S0264
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESSING COMPLETE. RETURN TO THE CALLER.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0265
*   RETURN;                         /* RETURN TO THE CALLER          */
@EL00004 DS    0H                                               02S0265
@EF00004 DS    0H                                               02S0265
@ER00004 LM    @14,@12,12(@13)                                  02S0265
         BR    @14                                              02S0265
*   END FREELLCK;                   /* END OF SUBROUTINE             */
         B     @EL00004                                         02S0266
         EJECT
*                                   /* IGTXEPLG                      */
*                                                               01S0267
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0267
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0267
*     I031F FIXED(31) BASED,                                    01S0267
*     I031P PTR(31) BASED,                                      01S0267
*     I015F FIXED(15) BASED,                                    01S0267
*     I015P PTR(15) BASED,                                      01S0267
*     I008P PTR(8) BASED,                                       01S0267
*     I001C CHAR(1) BASED;                                      01S0267
*                                                               01S0268
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0268
*   DCL                                                         01S0268
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0268
*   GENERATE DATA DEFS(APPATCH);                                01S0269
*                                                               01S0270
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0270
*   DCL                                                         01S0270
*     R0F FIXED(31) REG(0),                                     01S0270
*     R0P PTR(24) REG(0),                                       01S0270
*     R0RSTD PTR(31) REG(0),                                    01S0270
*     R1F FIXED(31) REG(1),                                     01S0270
*     R1P PTR(24) REG(1),                                       01S0270
*     R1RSTD PTR(31) REG(1),                                    01S0270
*     R2F FIXED(31) REG(2),                                     01S0270
*     R2P PTR(24) REG(2),                                       01S0270
*     R2RSTD PTR(31) REG(2),                                    01S0270
*     R3F FIXED(31) REG(3),                                     01S0270
*     R3P PTR(24) REG(3),                                       01S0270
*     R3RSTD PTR(31) REG(3),                                    01S0270
*     R4F FIXED(31) REG(4),                                     01S0270
*     R4P PTR(24) REG(4),                                       01S0270
*     R4RSTD PTR(31) REG(4),                                    01S0270
*     R5F FIXED(31) REG(5),                                     01S0270
*     R5P PTR(24) REG(5),                                       01S0270
*     R5RSTD PTR(31) REG(5),                                    01S0270
*     R6F FIXED(31) REG(6),                                     01S0270
*     R6P PTR(24) REG(6),                                       01S0270
*     R6RSTD PTR(31) REG(6),                                    01S0270
*     R7F FIXED(31) REG(7),                                     01S0270
*     R7P PTR(24) REG(7),                                       01S0270
*     R7RSTD PTR(31) REG(7),                                    01S0270
*     R8F FIXED(31) REG(8),                                     01S0270
*     R8P PTR(24) REG(8),                                       01S0270
*     R8RSTD PTR(31) REG(8),                                    01S0270
*     R9F FIXED(31) REG(9),                                     01S0270
*     R9P PTR(24) REG(9),                                       01S0270
*     R9RSTD PTR(31) REG(9),                                    01S0270
*     R10F FIXED(31) REG(10),                                   01S0270
*     R10P PTR(24) REG(10),                                     01S0270
*     R10RSTD PTR(31) REG(10),                                  01S0270
*     R11F FIXED(31) REG(11),                                   01S0270
*     R11P PTR(24) REG(11),                                     01S0270
*     R11RSTD PTR(31) REG(11),                                  01S0270
*     R12F FIXED(31) REG(12),                                   01S0270
*     R12P PTR(24) REG(12),                                     01S0270
*     R12RSTD PTR(31) REG(12),                                  01S0270
*     R13F FIXED(31) REG(13),                                   01S0270
*     R13P PTR(24) REG(13),                                     01S0270
*     R13RSTD PTR(31) REG(13),                                  01S0270
*     R14F FIXED(31) REG(14),                                   01S0270
*     R14P PTR(24) REG(14),                                     01S0270
*     R14RSTD PTR(31) REG(14),                                  01S0270
*     R15F FIXED(31) REG(15),                                   01S0270
*     R15P PTR(24) REG(15),                                     01S0270
*     R15RSTD PTR(31) REG(15),                                  01S0270
*                                                               01S0270
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0270
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0270
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0270
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0270
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0270
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0270
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0270
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0270
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0270
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0270
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0270
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0270
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0270
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0271
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0271
*   DCL                             /* LOCAL REGISTERS               */
*     RIPIBPTR PTR(24) REG(11);     /* IPIB BASE REGISTER            */
*   END IGTKBF                      /* END OF MODULE                 */
*                                                               01S0272
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHASUBIT)                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IECDIPIB)                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCC)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCM)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCT)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPIO)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPMV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPSV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPES)                                       */
*/*%INCLUDE SYSUT5  (CHECKIN )                                       */
*/*%INCLUDE SYSUT5  (BSAWA   )                                       */
*/*%INCLUDE SYSUT5  (INITSTAE)                                       */
*/*%INCLUDE SYSUT5  (PURGE   )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRSTAE )                                       */
*/*%INCLUDE SYSUT5  (FREESTAE)                                       */
*/*%INCLUDE SYSUT5  (FSAWA   )                                       */
*/*%INCLUDE SYSUT5  (SUBRTNS )                                       */
*/*%INCLUDE SYSUT5  (GETLLCK )                                       */
*/*%INCLUDE SYSUT5  (FREELLCK)                                       */
*                                                               01S0272
*       ;                                                       01S0272
         B     @EL00001                                         01S0272
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IGTKBF   CSECT
         DS    0F
@CF03115 DC    F'-436207616'
@DATD    DSECT
         DS    0D
DIPIBSRB DS    A
         DS    CL4
APES     DS    CL648
         ORG   APES
APESID   DS    CL4
APESUSER DS    FL4
APESADDR DS    AL4
APESAPMV DS    AL4
APESFLGS DS    BL2
         ORG   APESFLGS
APESFLG0 DS    BL1
         ORG   APESFLG0
APESFDMP DS    BL1
APESFREC EQU   APESFLG0+0
APESFSDP EQU   APESFLG0+0
@NM00140 EQU   APESFLG0+0
APESFRTY EQU   APESFLG0+0
APESFEXR EQU   APESFLG0+0
@NM00141 EQU   APESFLG0+0
         ORG   APESFLGS+1
APESFLG1 DS    BL1
         ORG   APESFLG1
APESFFRR DS    BL1
APESFPRV EQU   APESFLG1+0
APESFLLK EQU   APESFLG1+0
APESFXLK EQU   APESFLG1+0
APESFGM  EQU   APESFLG1+0
APESFSDI EQU   APESFLG1+0
APESFSTE EQU   APESFLG1+0
@NM00142 EQU   APESFLG1+0
         ORG   APES+18
APESSUID DS    BL1
         ORG   APESSUID
APESSU33 DS    BL1
@NM00143 EQU   APESSUID+0
         ORG   APES+19
APESCODE DS    FL1
APESCOD1 DS    FL1
APESCNTR DS    FL1
APESMXCD DS    FL1
@NM00144 DS    FL1
@NM00145 DS    AL4
@NM00146 DS    AL4
@NM00147 DS    AL4
APESEXRA DS    AL4
APESR14S DS    AL4
APESREGP DS    AL4
APESREGZ DS    CL64
APESMOD  DS    CL8
APESPROC DS    CL8
APESFRR  DS    CL8
APESSDWA DS    CL512
         ORG   APES+648
DSUPVSVE DS    CL64
DRETRY   DS    10A
IGTKBF   CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CXERR    DC    AL4(XERR)
@CC03019 DC    C'IGTKBF  '
@CC03020 DC    C'        '
@CC03025 DC    C'IGTKBC  '
@CC02952 DC    C'APES'
CMBRXZZZ DS    CL16
         ORG   CMBRXZZZ
@NM00150 DS    CL8
         ORG   @NM00150
@NM00151 DC    H'21'
@NM00152 DC    H'45'
@NM00153 DC    AL1(0)
@NM00154 DC    AL1(4)
@NM00155 DC    H'10'
         ORG   CMBRXZZZ+8
@NM00156 DS    CL8
         ORG   @NM00156
@NM00157 DC    H'36'
@NM00158 DC    H'0'
@NM00159 DC    AL1(0)
@NM00160 DC    AL1(8)
@NM00161 DC    H'16'
         ORG   CMBRXZZZ+16
IGTKBF   CSECT
*                                   /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGTKBF   CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
APCODE   EQU   @07
FRRSPTR  EQU   @00
FRREPTR  EQU   @00
IOSBPTR  EQU   @00
SRBPTR   EQU   @00
IPIBPTR  EQU   @00
SDWAPTR  EQU   @00
APCTPTR  EQU   @12
APSVPTR  EQU   @13
R15P     EQU   @15
R1P      EQU   @01
R0F      EQU   @00
R15F     EQU   @15
R13P     EQU   @13
RIPIBPTR EQU   @11
APDATA   EQU   @06
R0P      EQU   @00
R1F      EQU   @01
R14P     EQU   @14
R0RSTD   EQU   @00
R1RSTD   EQU   @01
R2RSTD   EQU   @02
R3RSTD   EQU   @03
R4RSTD   EQU   @04
R5RSTD   EQU   @05
R8RSTD   EQU   @08
R9RSTD   EQU   @09
R10RSTD  EQU   @10
R11RSTD  EQU   @11
R14RSTD  EQU   @14
R15RSTD  EQU   @15
R11F     EQU   @11
R13F     EQU   @13
R12F     EQU   @12
R14F     EQU   @14
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APCWPTR  EQU   @08
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APIOPTR  EQU   @10
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R10F     EQU   @10
R10P     EQU   @10
R11P     EQU   @11
R12P     EQU   @12
R12RSTD  EQU   @12
R13RSTD  EQU   @13
R2F      EQU   @02
R2P      EQU   @02
R3F      EQU   @03
R3P      EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R5F      EQU   @05
R5P      EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7P      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R8P      EQU   @08
R9F      EQU   @09
R9P      EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00030 EQU   IOSB+20
IOSCSW   EQU   @NM00030+1
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSDIE   EQU   IOSB+68
IOSDIEFG EQU   IOSDIE
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLNK  EQU   SRB+4
SRBFLC   EQU   SRB+12
SRBPARM  EQU   SRB+28
IPIB     EQU   0
IPIBOPT  EQU   IPIB
IPIBMEM  EQU   IPIBOPT
IPIBHALT EQU   IPIBOPT
IPIBFLG1 EQU   IPIB+2
IPIBSRB  EQU   IPIB+16
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
APCT     EQU   0
APCTENQM EQU   APCT+12
APCTSMIN EQU   APCT+32
APCTSMAD EQU   APCT+36
APCTZ@@@ EQU   APCT+40
APCTU@@@ EQU   APCT+440
APCTBR14 EQU   APCT+840
APCTERRS EQU   APCT+876
@NM00096 EQU   APCT+936
APCTSTAT EQU   @NM00096
APCTPRSW EQU   @NM00096+1
APCTAPCQ EQU   APCT+944
APCTCQAQ EQU   APCT+952
APCTZ@@1 EQU   APCT+1120
APCVZUKA EQU   0
APCVZKBC EQU   0
APIO     EQU   0
APIOIOCB EQU   APIO
APIOFLGS EQU   APIO+248
APIOFLGA EQU   APIOFLGS
APIOFLG0 EQU   APIOFLGA
APIOFLG2 EQU   APIOFLGA+2
APIOFLG3 EQU   APIOFLGA+3
APIORET  EQU   APIOFLG3
APIOFLGB EQU   APIOFLGS+4
APIOFLG7 EQU   APIOFLGB+3
APIOINDX EQU   APIO+288
APIOSAVE EQU   APIOINDX
APIOTR   EQU   APIO+360
APIOGMSZ EQU   APIO+376
APIOAPCT EQU   APIO+380
APIONBR  EQU   APIO+384
APMV     EQU   0
APMVHDR  EQU   APMV
APMVHKWD EQU   APMVHDR+4
APMVHMSG EQU   APMVHDR+8
APMVKWD  EQU   0
APMVMSG  EQU   0
APSV     EQU   0
APSVPREV EQU   APSV+4
APSVREGS EQU   APSV+12
APESREGS EQU   0
APESREGC EQU   APESREGS+48
APESREGF EQU   APESREGS+60
APESRTRY EQU   APESREGF
APESMV   EQU   0
I256C    EQU   0
I031P    EQU   0
APCVZDAL EQU   0
APCVZDAP EQU   0
APCVZDBK EQU   0
APCVZDDA EQU   0
APCVZDDQ EQU   0
APCVZDEQ EQU   0
APCVZDID EQU   0
APCVZDIO EQU   0
APCVZDIP EQU   0
APCVZDMD EQU   0
APCVZDMM EQU   0
APCVZDQR EQU   0
APCVZDRI EQU   0
APCVZDUA EQU   0
APCVZDUL EQU   0
APCVZDWI EQU   0
APCVZDWT EQU   0
APCVZDX1 EQU   0
APCVZDX2 EQU   0
APCVZDX3 EQU   0
APCVZDX4 EQU   0
APCVZD10 EQU   0
APCVZD20 EQU   0
APCVZD4E EQU   0
APCVZD40 EQU   0
APCVZD41 EQU   0
APCVZD42 EQU   0
APCVZD43 EQU   0
APCVZD44 EQU   0
APCVZD45 EQU   0
APCVZD46 EQU   0
APCVZD47 EQU   0
APCVZD48 EQU   0
APCVZD49 EQU   0
APCVZD60 EQU   0
APCVZD80 EQU   0
APCVZD81 EQU   0
APCVZD82 EQU   0
APCVZD83 EQU   0
APCVZJAA EQU   0
APCVZJAD EQU   0
APCVZJAG EQU   0
APCVZJAJ EQU   0
APCVZJAM EQU   0
APCVZJAP EQU   0
APCVZJAX EQU   0
APCVZJAY EQU   0
APCVZJBA EQU   0
APCVZJBD EQU   0
APCVZJBG EQU   0
APCVZJBJ EQU   0
APCVZJBM EQU   0
APCVZJDA EQU   0
APCVZJDD EQU   0
APCVZJDG EQU   0
APCVZJDJ EQU   0
APCVZJDM EQU   0
APCVZJHC EQU   0
APCVZJHE EQU   0
APCVZJHF EQU   0
APCVZJHO EQU   0
APCVZJHQ EQU   0
APCVZJHR EQU   0
APCVZJHT EQU   0
APCVZJHW EQU   0
APCVZJH0 EQU   0
APCVZJH6 EQU   0
APCVZJI0 EQU   0
APCVZJI3 EQU   0
APCVZJJ0 EQU   0
APCVZKAA EQU   0
APCVZKBA EQU   0
APCVZKBB EQU   0
APCVZKBD EQU   0
APCVZKBE EQU   0
APCVZKBF EQU   0
APCVZKCA EQU   0
APCVZKDA EQU   0
APCVZKGA EQU   0
APCVZKGB EQU   0
APCVZKGC EQU   0
APCVZKGD EQU   0
APCVZLCA EQU   0
APCVZLCB EQU   0
APCVZMBA EQU   0
APCVZMBD EQU   0
APCVZMBG EQU   0
APCVZMBH EQU   0
APCVZMBK EQU   0
APCVZMBM EQU   0
APCVZMIB EQU   0
APCVZMIC EQU   0
APCVZMIF EQU   0
APCVZMJB EQU   0
APCVZMJC EQU   0
APCVZMJH EQU   0
APCVZMJI EQU   0
APCVZMMA EQU   0
APCVZUAA EQU   0
APCVZUAB EQU   0
APCVZUAC EQU   0
APCVZUAD EQU   0
APCVZUAE EQU   0
APCVZUAF EQU   0
APCVZUAG EQU   0
APCVZUBB EQU   0
APCVZUFA EQU   0
APCVZUHA EQU   0
APCVZUHB EQU   0
APCVZUJA EQU   0
APCV1CMD EQU   0
APCV1JAA EQU   0
APCV1JBJ EQU   0
APCV1JHC EQU   0
APCV1JHL EQU   0
APCV1JHT EQU   0
APCV1MAB EQU   0
APCV1MBD EQU   0
APCV2JHC EQU   0
APCV2JHL EQU   0
APCV2MBD EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
APCTZ    EQU   APCTZ@@@
APCTZUAA EQU   APCTZ
APCTZUAB EQU   APCTZ+4
APCTZUAC EQU   APCTZ+8
APCTZUAD EQU   APCTZ+12
APCTZUAE EQU   APCTZ+16
APCTZUBB EQU   APCTZ+24
APCTZD10 EQU   APCTZ+28
APCTZD20 EQU   APCTZ+32
APCTZD40 EQU   APCTZ+36
APCTZD41 EQU   APCTZ+40
APCTZD42 EQU   APCTZ+44
APCTZD43 EQU   APCTZ+48
APCTZD44 EQU   APCTZ+52
APCTZD45 EQU   APCTZ+56
APCTZD46 EQU   APCTZ+60
APCTZD47 EQU   APCTZ+64
APCTZD48 EQU   APCTZ+68
APCTZD49 EQU   APCTZ+72
APCTZD60 EQU   APCTZ+76
APCTZD80 EQU   APCTZ+80
APCTZD4E EQU   APCTZ+84
APCTZMBA EQU   APCTZ+88
APCTZMBD EQU   APCTZ+92
APCTZMBG EQU   APCTZ+96
APCTZMBR EQU   APCTZ+100
APCTZDX1 EQU   APCTZ+104
APCTZDX2 EQU   APCTZ+108
APCTZDX3 EQU   APCTZ+112
APCTZDX4 EQU   APCTZ+116
APCTZMBH EQU   APCTZ+120
APCTZMBK EQU   APCTZ+124
APCTZMBM EQU   APCTZ+128
APCTZMJB EQU   APCTZ+132
APCTZMJC EQU   APCTZ+136
APCTZMJH EQU   APCTZ+140
APCTZMMA EQU   APCTZ+144
APCTZDMD EQU   APCTZ+148
APCTZD81 EQU   APCTZ+152
APCTZDID EQU   APCTZ+156
APCTZDRI EQU   APCTZ+160
APCTZMJI EQU   APCTZ+164
APCTZDWT EQU   APCTZ+168
APCTZDMM EQU   APCTZ+172
APCTZDAL EQU   APCTZ+176
APCTZDBK EQU   APCTZ+180
APCTZDIP EQU   APCTZ+184
APCTZDDA EQU   APCTZ+188
APCTZDUL EQU   APCTZ+192
APCTZDEQ EQU   APCTZ+196
APCTZDDQ EQU   APCTZ+200
APCTZDUA EQU   APCTZ+204
APCTZUAF EQU   APCTZ+208
APCTZUAG EQU   APCTZ+212
APCTZDIO EQU   APCTZ+216
APCTZUHA EQU   APCTZ+220
APCTZUHB EQU   APCTZ+224
APCTZJAA EQU   APCTZ+232
APCTZJAD EQU   APCTZ+236
APCTZJAG EQU   APCTZ+240
APCTZJAJ EQU   APCTZ+244
APCTZJAM EQU   APCTZ+248
APCTZJAP EQU   APCTZ+252
APCTZJAY EQU   APCTZ+256
APCTZUFA EQU   APCTZ+260
APCTZUJA EQU   APCTZ+264
APCTZDAP EQU   APCTZ+268
APCTZKAA EQU   APCTZ+272
APCTZD82 EQU   APCTZ+276
APCTZMIB EQU   APCTZ+280
APCTZMIC EQU   APCTZ+284
APCTZD83 EQU   APCTZ+288
APCTZMIF EQU   APCTZ+296
APCTZJH0 EQU   APCTZ+300
APCTZJI0 EQU   APCTZ+304
APCTZJI3 EQU   APCTZ+308
APCTZJJ0 EQU   APCTZ+312
APCTZJBA EQU   APCTZ+316
APCTZJBD EQU   APCTZ+320
APCTZJBG EQU   APCTZ+324
APCTZJBJ EQU   APCTZ+328
APCTZJBM EQU   APCTZ+332
APCTZKCA EQU   APCTZ+340
APCTZKDA EQU   APCTZ+344
APCTZJDA EQU   APCTZ+356
APCTZJDJ EQU   APCTZ+360
APCTZJH6 EQU   APCTZ+364
APCTZJHO EQU   APCTZ+368
APCTZJHF EQU   APCTZ+372
APCTZJHE EQU   APCTZ+376
APCTZDQR EQU   APCTZ+380
APCTZJHR EQU   APCTZ+384
APCTZJHT EQU   APCTZ+388
APCTZJHW EQU   APCTZ+392
APCTZ1   EQU   APCTZ@@1
APCTZKBA EQU   APCTZ1
APCTZKBC EQU   APCTZ1+4
APCTZKBB EQU   APCTZ1+8
APCTZJHC EQU   APCTZ1+20
APCTZJHQ EQU   APCTZ1+24
APCTZKBD EQU   APCTZ1+28
APCTZKBE EQU   APCTZ1+40
APCTZUKA EQU   APCTZ1+56
APCTZKBF EQU   APCTZ1+60
APCTZJDD EQU   APCTZ1+64
APCTZJDG EQU   APCTZ1+68
APCTZJDM EQU   APCTZ1+72
APCTZLCA EQU   APCTZ1+76
APCTZLCB EQU   APCTZ1+80
APCTZDWI EQU   APCTZ1+84
APCTZJAX EQU   APCTZ1+88
APCTZKGA EQU   APCTZ1+92
APCTZKGB EQU   APCTZ1+96
APCTZKGC EQU   APCTZ1+100
APCTZKGD EQU   APCTZ1+104
APCTU    EQU   APCTU@@@
APCT1MAB EQU   APCTU
APCT1MBD EQU   APCTU+4
APCT2MBD EQU   APCTU+8
APCT1CMD EQU   APCTU+12
APCT1JAA EQU   APCTU+20
APCT1JHC EQU   APCTU+24
APCT2JHC EQU   APCTU+28
APCT1JHT EQU   APCTU+32
APCT1JHL EQU   APCTU+36
APCT2JHL EQU   APCTU+40
APCT1JBJ EQU   APCTU+44
@NM00136 EQU   APIOIOCB
APIOIOSB EQU   @NM00136
APIOSRB  EQU   @NM00136+128
@NM00137 EQU   APIOIOCB
CMBRX    EQU   CMBRXZZZ
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CMBXRCN  EQU   CMBRX+6
CMBXRCT  EQU   CMBRX+5
@NM00162 EQU   CMBRX+4
CMBRKT   EQU   CMBRX+2
CMBRMT   EQU   CMBRX
APIOIOB  EQU   @NM00137+160
@NM00138 EQU   @NM00137
@NM00128 EQU   APCTU+48
APCT1MBM EQU   APCTU+16
@NM00127 EQU   APCTZ1+108
@NM00126 EQU   APCTZ1+52
@NM00125 EQU   APCTZ1+48
@NM00124 EQU   APCTZ1+44
@NM00123 EQU   APCTZ1+36
@NM00122 EQU   APCTZ1+32
@NM00121 EQU   APCTZ1+16
@NM00120 EQU   APCTZ1+12
@NM00119 EQU   APCTZ+396
@NM00118 EQU   APCTZ+352
@NM00117 EQU   APCTZ+348
@NM00116 EQU   APCTZ+336
@NM00115 EQU   APCTZ+292
APCTZJFA EQU   APCTZ+228
@NM00114 EQU   APCTZ+20
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00035 EQU   IOSPCISC+4
@NM00034 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00033 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
@NM00149 EQU   APESMV+6
@NM00148 EQU   APESMV+4
APESMVKW EQU   APESMV+2
APESMVMS EQU   APESMV
APESREGE EQU   APESREGS+56
APESREGD EQU   APESREGS+52
APESREGB EQU   APESREGS+44
APESREGA EQU   APESREGS+40
APESREG9 EQU   APESREGS+36
APESREG8 EQU   APESREGS+32
APESREG7 EQU   APESREGS+28
APESREG6 EQU   APESREGS+24
APESREG5 EQU   APESREGS+20
APESREG4 EQU   APESREGS+16
APESREG3 EQU   APESREGS+12
APESREG2 EQU   APESREGS+8
APESREG1 EQU   APESREGS+4
APESREG0 EQU   APESREGS
APSVWORK EQU   APSV+80
@NM00139 EQU   APSV+80
APSVFREE EQU   APSV+76
APSVAPSM EQU   APSV+72
APSVRG12 EQU   APSVREGS+56
APSVRG11 EQU   APSVREGS+52
APSVRG10 EQU   APSVREGS+48
APSVRG9  EQU   APSVREGS+44
APSVRG8  EQU   APSVREGS+40
APSVRG7  EQU   APSVREGS+36
APSVRG6  EQU   APSVREGS+32
APSVRG5  EQU   APSVREGS+28
APSVRG4  EQU   APSVREGS+24
APSVRG3  EQU   APSVREGS+20
APSVRG2  EQU   APSVREGS+16
APSVRG1  EQU   APSVREGS+12
APSVRG0  EQU   APSVREGS+8
APSVRG15 EQU   APSVREGS+4
APSVRG14 EQU   APSVREGS
APSVNEXT EQU   APSV+8
APSVAPSC EQU   APSV
APMVMMSG EQU   APMVMSG+4
APMVMNBR EQU   APMVMSG
APMVKKWD EQU   APMVKWD+4
APMVKNBR EQU   APMVKWD
APMVHEM  EQU   APMVHDR
@NM00135 EQU   APIO+424
@NM00134 EQU   APIO+400
APIOTMEE EQU   APIO+396
APIOTMES EQU   APIO+392
APIOXTME EQU   APIO+388
APIONBRI EQU   APIONBR+2
APIONBRX EQU   APIONBR
APIOGMS1 EQU   APIOGMSZ+2
@NM00133 EQU   APIOGMSZ+1
APIOGMSP EQU   APIOGMSZ
APIOGMAD EQU   APIO+372
APIOCISZ EQU   APIO+370
APIOSIZE EQU   APIO+368
APIORB   EQU   APIOTR+4
APIOTCB  EQU   APIOTR
APIOECB  EQU   APIO+356
APIOTERM EQU   APIO+352
APIOASCB EQU   APIO+348
APIOTCSW EQU   APIOSAVE
APIOSNSE EQU   APIO+256
APIOACTV EQU   APIOFLG7
APIOFLG6 EQU   APIOFLGB+2
APIOFLG5 EQU   APIOFLGB+1
APIOFLG4 EQU   APIOFLGB
@NM00132 EQU   APIOFLG3
APIOPGFS EQU   APIOFLG3
APIOPGIP EQU   APIOFLG3
APIORSME EQU   APIOFLG3
APIONPST EQU   APIOFLG3
APIOIOCT EQU   APIOFLG3
@NM00131 EQU   APIOFLG2
APIODMPT EQU   APIOFLG2
APIODUMP EQU   APIOFLG2
APIOCSWT EQU   APIOFLG2
APIOVINX EQU   APIOFLG2
APIOVSNS EQU   APIOFLG2
APIOEXCL EQU   APIOFLG2
APIOFLG1 EQU   APIOFLGA+1
@NM00130 EQU   APIOFLG0
APIOSU50 EQU   APIOFLG0
APIOSYNC EQU   APIOFLG0
APIOFXED EQU   APIOFLG0
@NM00129 EQU   APIO+246
APIOOLAP EQU   APIO+244
APIOIOAP EQU   APIO+240
APIORGN  EQU   APIO+236
APIOPGFL EQU   APIO+232
APIOPGFX EQU   APIO+228
APIOAPCI EQU   APIO+224
APIOCCW  EQU   APIO+220
APIODEB  EQU   APIO+216
APIOAPXL EQU   APIO+212
APIOVCSW EQU   APIO+208
APIOAPUB EQU   APIO+204
APIOAPIO EQU   APIO+200
APIOUSER EQU   APIO+196
APIOID   EQU   APIO+192
@NM00113 EQU   APCT+1556
APCTSVCT EQU   APCT+1552
APCTDAVT EQU   APCT+1548
APCTLOGL EQU   APCT+1544
@NM00112 EQU   APCT+1540
APCTDMPU EQU   APCT+1536
APCTDMPM EQU   APCT+1532
APCTNDMP EQU   APCT+1530
APCTASID EQU   APCT+1528
APCTLGPG EQU   APCT+1526
APCTLGLN EQU   APCT+1524
APCTAPVU EQU   APCT+1520
APCTABR  EQU   APCT+1116
APCTACTR EQU   APCT+1112
APCTLOGD EQU   APCT+1108
APCTDCLD EQU   APCT+1104
APCTIOAP EQU   APCT+1100
@NM00111 EQU   APCT+1080
@NM00110 EQU   APCT+1078
APCTKCAX EQU   APCT+1076
APCTABND EQU   APCT+1072
@NM00109 EQU   APCT+1068
APCTAPIO EQU   APCT+1064
APCTCSCT EQU   APCT+1060
APCTSTDF EQU   APCT+1056
APCTSTMX EQU   APCT+1052
APCTRGMX EQU   APCT+1048
APCTSIZE EQU   APCT+1046
APCTCTUB EQU   APCT+1045
APCTMFID EQU   APCT+1044
APCTMFSZ EQU   APCT+1040
APCTCRTN EQU   APCT+1036
APCTAPCP EQU   APCT+1032
APCTAMNA EQU   APCT+1028
APCTEMNA EQU   APCT+1024
APCTAALP EQU   APCT+1020
APCTEALP EQU   APCT+1016
@NM00108 EQU   APCT+1012
@NM00107 EQU   APCT+1008
@NM00106 EQU   APCT+1004
APCTEIPL EQU   APCT+1000
@NM00105 EQU   APCT+996
@NM00104 EQU   APCT+992
@NM00103 EQU   APCT+988
@NM00102 EQU   APCT+984
@NM00101 EQU   APCT+980
APCTECPW EQU   APCT+976
APCTEULD EQU   APCT+972
APCTECPT EQU   APCT+968
APCTEALC EQU   APCT+964
APCTECBL EQU   APCT+960
APCTECIT EQU   APCT+956
APCTCQAF EQU   APCTCQAQ
APCTCQL  EQU   APCTAPCQ+4
APCTCQF  EQU   APCTAPCQ
APCTCQLK EQU   APCT+940
@NM00100 EQU   @NM00096+2
@NM00099 EQU   APCTPRSW
APCTAPST EQU   APCTPRSW
@NM00098 EQU   APCTPRSW
@NM00097 EQU   APCTSTAT
APCTWARM EQU   APCTSTAT
APCTTERM EQU   APCTSTAT
APCTHALT EQU   APCTSTAT
APCTQSCE EQU   APCTSTAT
APCTSTRT EQU   APCTSTAT
APCTACT  EQU   APCTSTAT
@NM00095 EQU   APCT+935
APCTSOUT EQU   APCT+934
APCTDAID EQU   APCT+933
APCTSV34 EQU   APCT+932
APCTMJOB EQU   APCT+928
APCTTCB  EQU   APCT+924
APCTASCB EQU   APCT+920
APCTDCNW EQU   APCT+918
APCTDCNR EQU   APCT+916
@NM00094 EQU   APCT+912
@NM00093 EQU   APCT+908
@NM00092 EQU   APCT+904
@NM00091 EQU   APCT+900
@NM00090 EQU   APCTERRS+22
APCTERTJ EQU   APCTERRS+20
APCTERTD EQU   APCTERRS+18
APCTERTC EQU   APCTERRS+16
APCTERTB EQU   APCTERRS+14
APCTERTA EQU   APCTERRS+12
APCTERT9 EQU   APCTERRS+10
APCTERT3 EQU   APCTERRS+8
APCTERT2 EQU   APCTERRS+6
APCTERT1 EQU   APCTERRS+4
APCTERT0 EQU   APCTERRS+2
APCTERTT EQU   APCTERRS
APCTDSAP EQU   APCT+872
APCTISUB EQU   APCT+868
APCTUBAP EQU   APCT+864
APCTAPDS EQU   APCT+860
APCTUBIC EQU   APCT+856
APCTUBIS EQU   APCT+852
APCTAPUB EQU   APCT+848
APCTUBLK EQU   APCT+844
APCTBR1A EQU   APCTBR14+2
@NM00089 EQU   APCTBR14
APCTSMSZ EQU   APCTSMAD+2
@NM00088 EQU   APCTSMAD+1
@NM00087 EQU   APCTSMAD
APCTSMIS EQU   APCTSMIN+2
@NM00086 EQU   APCTSMIN+1
APCTSMSP EQU   APCTSMIN
@NM00085 EQU   APCT+30
APCTLINE EQU   APCT+28
APCTLBSZ EQU   APCT+24
APCTREG  EQU   APCT+20
APCTSSID EQU   APCTENQM+4
@NM00084 EQU   APCTENQM
APCTSSVT EQU   APCT+8
APCTUSER EQU   APCT+4
APCTID   EQU   APCT
@NM00083 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00082 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00081 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00080 EQU   SDWADDAT+3
@NM00079 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00078 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00077 EQU   SDWADUMP+2
@NM00076 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00075 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00074 EQU   SDWAACF3
@NM00073 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00072 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00071 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00070 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
SDWACPUI EQU   SDWA+239
@NM00069 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00068 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00067 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00066 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00065 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00064 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00063 EQU   SDWAINC2
@NM00062 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00061 EQU   SDWAILC2
@NM00060 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00059 EQU   SDWANXT2
@NM00058 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00057 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00056 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00055 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00054 EQU   SDWAINC1
@NM00053 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00052 EQU   SDWAILC1
@NM00051 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00050 EQU   SDWANXT1
@NM00049 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00048 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00047 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00046 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00045 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00044 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00043 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00042 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00041 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
IPIBEND  EQU   IPIB+40
IPIBLNK  EQU   IPIB+36
IPIBPSQ  EQU   IPIB+32
IPIBPIRL EQU   IPIB+28
IPIBDVRU EQU   IPIB+24
IPIBIO   EQU   IPIB+20
IPIBARG  EQU   IPIB+12
IPIBECB  EQU   IPIB+8
IPIBCNT  EQU   IPIB+4
@NM00040 EQU   IPIB+3
@NM00039 EQU   IPIBFLG1
IPIBDQ   EQU   IPIBFLG1
IPIBDVID EQU   IPIB+1
@NM00038 EQU   IPIBOPT
IPIBOTCB EQU   IPIBOPT
IPIBREL  EQU   IPIBOPT
IPIBPOST EQU   IPIBOPT
IPIBRBP  EQU   IPIBOPT
IPIBTASK EQU   IPIBOPT
@NM00037 EQU   SRB+40
@NM00036 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBID    EQU   SRB
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00032 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00031 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSNOTRS EQU   IOSDIEFG
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00030
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00029 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSFLB2  EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
@NM00028 EQU   FRRSFLGS+1
@NM00027 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@PB00003 EQU   @EL00002
@RF00258 EQU   @EL00004
@ENDDATA EQU   *
         END   IGTKBF,(C'PLS2330',0701,77092)
