TMJB     TITLE 'IGTMJB --- GENERATE AN ACB                             *
                        '
IGTMJB   CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IGTMJB    77.179'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @07,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@07                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         IGTYGSV  R,LV=(0)
         LR    @06,@01                                          01S0001
         USING @DATD,@06                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @06,8(,@13)                                      01S0001
         LR    @13,@06                                          01S0001
         MVC   @PC00001(4),0(@01)                               01S0001
*                                                               01S0041
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERATE A NEW ACB                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0041
*   DO;                                                         01S0041
*     RFY                                                       01S0042
*       APCWPTR RSTD;                                           01S0042
*     APCWPTR=ADDR(DAPCW);          /* NEW POINTER FOR APCW          */
         L     APCWPTR,@PC00001                                 01S0043
*     RFY                                                       01S0044
*       APCW BASED(APCWPTR);                                    01S0044
*     RFY                                                       01S0045
*       APEM BASED(ADDR(APCWEMSG)); /* NEW POINTER FOR APEM          */
*     RFY                                                       01S0046
*       APCT BASED(APCTPTR);        /* NEW POINTER FOR APCT          */
*     RFY                                                       01S0047
*       APIN BASED(APCWAPIN);       /* NEW POINTER FOR APIN          */
*     RFY                                                       01S0048
*       APUT BASED(APCWAPUT);       /* NEW POINTER FOR APUT          */
*     RFY                                                       01S0049
*       APAT BASED(APUTAPAT);       /* NEW POINTER FOR APAT          */
*                                                               01S0049
*     /***************************************************************/
*     /*                                                             */
*     /* CONSTRUCT A NEW ACB WITH CALL EXTENSION AND EXIT LIST. THE  */
*     /* THREE BLOCKS ARE IN CONTIGUOUS STORAGE, AND ONE GETMAIN IS  */
*     /* USED. IF THE USE OF CONTIGUOUS STORAGE IS CEASED, THEN AN   */
*     /* APPROPRIATE CHANGE SHOULD BE MADE TO THE FREE ACB ROUTINE   */
*     /* (IGTMJG) ALSO.                                              */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0050
*     RFY                                                       01S0050
*       R0F RSTD;                   /* PREPARE FOR GETMAIN INPUT     */
*     R0F=(LENGTH(IFGACB)+7)/8*8    /* ALL THREE BLOCKS TO BE FORMED */
*         +(APCXLN+7)/8*8           /* AND ENOUGH SPACE OBTAINED     */
*         +(40+7)/8*8;              /* FOR EACH TO HAVE DWORD BDY.   */
         LA    R0F,160                                          01S0051
*     GENERATE(GETMAIN R,LV=(0))                                01S0052
*     REFS(R0F);                    /* OBTAIN REQUIRED SPACE         */
         GETMAIN R,LV=(0)
*     RFY                                                       01S0053
*       R1P RSTD;                   /* SECURE ADDR OF NEW ACB BLOCK  */
*     RFY                                                       01S0054
*       R0F UNRSTD;                 /* LET REG 0 GO BACK NOW         */
*     APCWACB=R1P;                  /* SET NEW ACB ADDRESS IN APCW   */
         ST    R1P,APCWACB(,APCWPTR)                            01S0055
*     APATACB(APINUNIT)=R1P;        /* SET NEW ACB ADDRESS IN APAT   */
         L     @09,APCWAPIN(,APCWPTR)                           01S0056
         L     @09,APINAUNT(,@09)                               01S0056
         L     @15,APINUNIT(,@09)                               01S0056
         SLA   @15,2                                            01S0056
         L     @14,APCWAPUT(,APCWPTR)                           01S0056
         L     @14,APUTAPAT(,@14)                               01S0056
         ST    R1P,APATACB-4(@15,@14)                           01S0056
*     RFY                                                       01S0057
*       IFGACB BASED(APCWACB);      /* NEW ACB BASED ON POINTER      */
*     RFY                                                       01S0058
*       R1P UNRSTD;                                             01S0058
*                                                               01S0058
*     /***************************************************************/
*     /*                                                             */
*     /* INITIALIZE THE ACB                                          */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0059
*     IFGACB=MJBACB;                /* MOVE IN INITIALIZATION VALUES */
         L     @15,APCWACB(,APCWPTR)                            01S0059
         MVC   IFGACB(76,@15),MJBACB                            01S0059
*     ACBDORGA=TRUE;                /* SET ACB INDICATOR BIT ON      */
         OI    ACBDORGA(@15),B'00001000'                        01S0060
*     ACBAMAX=APCWACB+(LENGTH(IFGACB)+7)/8*8;/* APCX IS AFTER ACB    */
         LA    @14,80                                           01S0061
         ALR   @14,@15                                          01S0061
         ST    @14,ACBAMAX(,@15)                                01S0061
*     ACBEXLST=ACBAMAX+(APCXLN+7)/8*8;/* EXLST IS AT END OF APCX     */
         AL    @14,@CF00362                                     01S0062
         ST    @14,ACBEXLST(,@15)                               01S0062
*     ACBMSGLN=APEMLN;              /* MSG LENGTH DEFINED IN APEM    */
         MVC   ACBMSGLN(2,@15),@CH00468                         01S0063
*     ACBLENG=(LENGTH(IFGACB)+7)/8*8/* ACBLENG INCLUDES LENGTHS OF   */
*         +(APCXLN+7)/8*8;          /* ACB AND ALSO APCX             */
         MVC   ACBLENG(2,@15),@CH00452                          01S0064
*     CALL APCVZMMA(APINUNIT,ACBDDNM);/* SET (FTNNF001) DDNAME IN ACB*/
*                                                               01S0065
         ST    @09,@AL00001                                     01S0065
         LA    @09,ACBDDNM(,@15)                                01S0065
         ST    @09,@AL00001+4                                   01S0065
         L     @15,APCTZMMA(,APCTPTR)                           01S0065
         LA    @01,@AL00001                                     01S0065
         BALR  @14,@15                                          01S0065
*     /***************************************************************/
*     /*                                                             */
*     /* INITIALIZE THE APCX                                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0066
*     RFY                                                       01S0066
*       APCX BASED(ACBAMAX);        /* SPECIFY POINTER FOR APCX      */
*     APCX=MJBAPCX;                 /* MOVE IN INITIALIZATION VALUES */
         L     @09,APCWACB(,APCWPTR)                            01S0067
         L     @15,ACBAMAX(,@09)                                01S0067
         MVI   APCX+36(@15),C' '                                01S0067
         MVC   APCX+37(3,@15),APCX+36(@15)                      01S0067
         MVC   APCX(36,@15),MJBAPCX                             01S0067
*     APCXAPUT=APCWAPUT;            /* SAVE APUT PTR FOR FUTURE USE  */
*                                                               01S0068
         L     @14,APCWAPUT(,APCWPTR)                           01S0068
         ST    @14,APCXAPUT(,@15)                               01S0068
*     /***************************************************************/
*     /*                                                             */
*     /* INITIALIZE THE EXIT LIST                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0069
*     RFY                                                       01S0069
*       IFGEXLST BASED(ACBEXLST);   /* SPECIFY POINTER FOR EXLST     */
*     IFGEXLST=MJBEXLST;            /* MOVE IN INITIALIZATION VALUES */
*                                                               01S0070
         L     @09,ACBEXLST(,@09)                               01S0070
         MVC   IFGEXLST(40,@09),MJBEXLST                        01S0070
*     /***************************************************************/
*     /*                                                             */
*     /* NOW EXAMINE THE USER'S INPUT PARAMETERS                     */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0071
*     CALL APCVZMJH(DAPCW);         /* MJH PROCESSES PARAM. VALUES   */
         L     @09,@PC00001                                     01S0071
         ST    @09,@AL00001                                     01S0071
         L     @15,APCTZMJH(,APCTPTR)                           01S0071
         LA    @01,@AL00001                                     01S0071
         BALR  @14,@15                                          01S0071
*     RETURN;                       /* MJH SETS NECESSARY ERROR CODES*/
@EL00001 L     @13,4(,@13)                                      01S0072
@EF00001 L     @00,@SIZDATD                                     01S0072
         LR    @01,@06                                          01S0072
         IGTYFSV  R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                  01S0072
         BR    @14                                              01S0072
*   END;                            /* END OF APCVZMJB PROCESSING    */
*                                   /* IGTXEPLG                      */
*                                                               01S0074
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0074
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0074
*     I031F FIXED(31) BASED,                                    01S0074
*     I031P PTR(31) BASED,                                      01S0074
*     I015F FIXED(15) BASED,                                    01S0074
*     I015P PTR(15) BASED,                                      01S0074
*     I008P PTR(8) BASED,                                       01S0074
*     I001C CHAR(1) BASED;                                      01S0074
*                                                               01S0075
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0075
*   DCL                                                         01S0075
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0075
*   GENERATE DATA DEFS(APPATCH);                                01S0076
*                                                               01S0077
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0077
*   DCL                                                         01S0077
*     R0F FIXED(31) REG(0),                                     01S0077
*     R0P PTR(24) REG(0),                                       01S0077
*     R0RSTD PTR(31) REG(0),                                    01S0077
*     R1F FIXED(31) REG(1),                                     01S0077
*     R1P PTR(24) REG(1),                                       01S0077
*     R1RSTD PTR(31) REG(1),                                    01S0077
*     R2F FIXED(31) REG(2),                                     01S0077
*     R2P PTR(24) REG(2),                                       01S0077
*     R2RSTD PTR(31) REG(2),                                    01S0077
*     R3F FIXED(31) REG(3),                                     01S0077
*     R3P PTR(24) REG(3),                                       01S0077
*     R3RSTD PTR(31) REG(3),                                    01S0077
*     R4F FIXED(31) REG(4),                                     01S0077
*     R4P PTR(24) REG(4),                                       01S0077
*     R4RSTD PTR(31) REG(4),                                    01S0077
*     R5F FIXED(31) REG(5),                                     01S0077
*     R5P PTR(24) REG(5),                                       01S0077
*     R5RSTD PTR(31) REG(5),                                    01S0077
*     R6F FIXED(31) REG(6),                                     01S0077
*     R6P PTR(24) REG(6),                                       01S0077
*     R6RSTD PTR(31) REG(6),                                    01S0077
*     R7F FIXED(31) REG(7),                                     01S0077
*     R7P PTR(24) REG(7),                                       01S0077
*     R7RSTD PTR(31) REG(7),                                    01S0077
*     R8F FIXED(31) REG(8),                                     01S0077
*     R8P PTR(24) REG(8),                                       01S0077
*     R8RSTD PTR(31) REG(8),                                    01S0077
*     R9F FIXED(31) REG(9),                                     01S0077
*     R9P PTR(24) REG(9),                                       01S0077
*     R9RSTD PTR(31) REG(9),                                    01S0077
*     R10F FIXED(31) REG(10),                                   01S0077
*     R10P PTR(24) REG(10),                                     01S0077
*     R10RSTD PTR(31) REG(10),                                  01S0077
*     R11F FIXED(31) REG(11),                                   01S0077
*     R11P PTR(24) REG(11),                                     01S0077
*     R11RSTD PTR(31) REG(11),                                  01S0077
*     R12F FIXED(31) REG(12),                                   01S0077
*     R12P PTR(24) REG(12),                                     01S0077
*     R12RSTD PTR(31) REG(12),                                  01S0077
*     R13F FIXED(31) REG(13),                                   01S0077
*     R13P PTR(24) REG(13),                                     01S0077
*     R13RSTD PTR(31) REG(13),                                  01S0077
*     R14F FIXED(31) REG(14),                                   01S0077
*     R14P PTR(24) REG(14),                                     01S0077
*     R14RSTD PTR(31) REG(14),                                  01S0077
*     R15F FIXED(31) REG(15),                                   01S0077
*     R15P PTR(24) REG(15),                                     01S0077
*     R15RSTD PTR(31) REG(15),                                  01S0077
*                                                               01S0077
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0077
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0077
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0077
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0077
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0077
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0077
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0077
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0077
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0077
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0077
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0077
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0077
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0077
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0078
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0078
*                                   /*                               */
*   END IGTMJB                                                  01S0078
*                                                               01S0078
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPAT)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCC)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCT)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCW)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCX)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPEM)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPIN)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPSV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPUT)                                       */
*                                                               01S0078
*       ;                                                       01S0078
         B     @EL00001                                         01S0078
@DATA    DS    0H
@CH00452 DC    H'120'
@CH00468 DC    H'128'
@DATD    DSECT
         DS    0F
@SA00001 DS    20F
@PC00001 DS    1F
@AL00001 DS    2A
IGTMJB   CSECT
         DS    0F
@CF00362 DC    F'40'
@DATD    DSECT
         DS    0D
IGTMJB   CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
MJBACB   DS    CL76
         ORG   MJBACB
MJBCOMN  DS    CL76
         ORG   MJBCOMN
MJB3838L DS    CL52
         ORG   MJB3838L
MJBID    DC    XL1'A0'
MJBSTYP  DC    AL1(0)
MJBLENG  DC    AL2(76)
MJBAMBL  DC    A(0)
MJBINRTN DC    A(0)
MJBMACRF DC    B'00000000'
         DC    XL1'0'
MJBBSTNO DC    AL1(0)
MJBSTRNO DC    AL1(0)
MJBBUFND DC    H'0'
MJBBUFNI DC    H'0'
MJBBUFPL DC    A(0)
MJBRECFM DC    B'00000000'
MJBCCTYP DC    B'00000000'
MJBOPT   DC    X'0008'
MJBMSGAR DC    A(0)
MJBPASSW DC    A(0)
MJBACLST DC    A(0)
MJBDDNM  DC    CL8'        '
MJBOFLGS DC    X'02'
MJBERFLG DC    B'00000000'
MJBINFLG DC    B'00000000'
         DC    XL1'0'
         ORG   MJBCOMN+52
MJBREM   DS    CL24
         ORG   MJBREM
MJBUJFCB DC    A(0)
MJBBUFSP DC    F'0'
@NM00093 DS    CL2
         ORG   @NM00093
MJBMSGLN DC    H'128'
         ORG   MJBREM+10
MJBLRECL DC    H'0'
MJBUAPTR DC    A(0)
MJBCBMWA DC    A(0)
MJBAPID  DC    A(0)
         ORG   MJBACB+76
MJBAPCX  DS    CL36
         ORG   MJBAPCX
MJBXID   DC    CL4'APCX'
MJBXUSER DC    F'0'
MJBXUSRI DS    CL28
         ORG   MJBXUSRI
MJBXREG  DC    F'0'
MJBXFLGS DC    A(0)
MJBXACCW DC    A(0)
MJBXAFNC DC    A(0)
MJBXARCD DC    A(0)
MJBXABSD DC    A(0)
MJBXINTV DC    B'00000000'
         DC    XL3'0'
         ORG   MJBAPCX+36
MJBEXLST DS    CL40
         ORG   MJBEXLST
MJBEXCOM DS    CL40
         ORG   MJBEXCOM
MJBEXLID DC    AL1(129)
MJBEXTYP DC    AL1(0)
MJBEXLEN DC    H'40'
@NM00094 DC    B'00000000'
MJBEODAD DS    CL5
         ORG   MJBEODAD
MJBEXFLG DC    B'00000000'
MJBEXPTR DC    AL4(0)
         ORG   MJBEXCOM+10
MJBSYNAD DS    CL5
         ORG   MJBSYNAD
MJBSNFLG DC    B'00000000'
MJBSNPTR DC    AL4(0)
         ORG   MJBEXCOM+15
MJBLERAD DS    CL5
         ORG   MJBLERAD
MJBLRFLG DC    B'00000000'
MJBLRPTR DC    AL4(0)
         ORG   MJBEXCOM+20
MJBSCIPP DS    CL5
         ORG   MJBSCIPP
MJBSCFLG DC    B'00000000'
MJBSCPTR DC    AL4(0)
         ORG   MJBEXCOM+25
MJBLOGON DS    CL5
         ORG   MJBLOGON
MJBLGFLG DC    B'00000000'
MJBLGPTR DC    AL4(0)
         ORG   MJBEXCOM+30
MJBJRNAD DS    CL5
         ORG   MJBJRNAD
MJBJRFLG DC    B'00000000'
MJBJRPTR DC    AL4(0)
         ORG   MJBEXCOM+35
MJBOPNAD DS    CL5
         ORG   MJBOPNAD
MJBOPFLG DC    B'00000000'
MJBOPPTR DC    AL4(0)
         ORG   MJBEXLST+40
IGTMJB   CSECT
*                                  /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGTMJB   CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
APDATA   EQU   @06
APCODE   EQU   @07
APCTPTR  EQU   @12
APSVPTR  EQU   @13
APCWPTR  EQU   @08
R0F      EQU   @00
R1P      EQU   @01
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APIOPTR  EQU   @10
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R0P      EQU   @00
R0RSTD   EQU   @00
R1F      EQU   @01
R1RSTD   EQU   @01
R10F     EQU   @10
R10P     EQU   @10
R10RSTD  EQU   @10
R11F     EQU   @11
R11P     EQU   @11
R11RSTD  EQU   @11
R12F     EQU   @12
R12P     EQU   @12
R12RSTD  EQU   @12
R13F     EQU   @13
R13P     EQU   @13
R13RSTD  EQU   @13
R14F     EQU   @14
R14P     EQU   @14
R14RSTD  EQU   @14
R15F     EQU   @15
R15P     EQU   @15
R15RSTD  EQU   @15
R2F      EQU   @02
R2P      EQU   @02
R2RSTD   EQU   @02
R3F      EQU   @03
R3P      EQU   @03
R3RSTD   EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R4RSTD   EQU   @04
R5F      EQU   @05
R5P      EQU   @05
R5RSTD   EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7P      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R8P      EQU   @08
R8RSTD   EQU   @08
R9F      EQU   @09
R9P      EQU   @09
R9RSTD   EQU   @09
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBIBCT  EQU   ACBJWA
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDORGA EQU   ACBDSORG+1
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBMSGLN EQU   ACBBLKSZ
ACBAPID  EQU   ACBCOMN+72
ACBAMAX  EQU   ACBAPID
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLSYNF  EQU   EXLCOMN+10
EXLLERF  EQU   EXLCOMN+15
EXLSCIPF EQU   EXLCOMN+20
EXLLGNF  EQU   EXLCOMN+25
EXLJRNF  EQU   EXLCOMN+30
EXLOPNF  EQU   EXLCOMN+35
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLEXITP EQU   EXLENTRY+1
APAT     EQU   0
APATACB  EQU   APAT+8
APCVZMJH EQU   0
APCVZMMA EQU   0
APCT     EQU   0
APCTENQM EQU   APCT+12
APCTSMIN EQU   APCT+32
APCTSMAD EQU   APCT+36
APCTZ@@@ EQU   APCT+40
APCTU@@@ EQU   APCT+440
APCTBR14 EQU   APCT+840
APCTERRS EQU   APCT+876
@NM00033 EQU   APCT+936
APCTSTAT EQU   @NM00033
APCTPRSW EQU   @NM00033+1
APCTAPCQ EQU   APCT+944
APCTCQAQ EQU   APCT+952
APCTZ@@1 EQU   APCT+1120
APCW     EQU   0
APCWAPIN EQU   APCW+8
APCWAPUT EQU   APCW+12
APCWACB  EQU   APCW+20
APCWSWS  EQU   APCW+46
APCWSW0  EQU   APCWSWS
APCWOPF  EQU   APCW+62
APCWR15C EQU   APCW+64
APCWRCDE EQU   APCW+68
APCWINTV EQU   APCW+72
APCWINT0 EQU   APCWINTV
APCWINT1 EQU   APCWINTV+1
APCWINT2 EQU   APCWINTV+2
APCWINT3 EQU   APCWINTV+3
APCWAPEM EQU   APCW+112
APCWEMSG EQU   APCWAPEM
APCX     EQU   0
APCXUSRI EQU   APCX+8
APCXFLGS EQU   APCXUSRI+4
APCXFLG0 EQU   APCXFLGS
APCXINTV EQU   APCXUSRI+24
APCXAPUT EQU   APCX+36
APEM     EQU   0
APEMMSG  EQU   APEM+92
APEMVALU EQU   APEM+108
APIN     EQU   0
APINAUNT EQU   APIN
APINAFNC EQU   APIN+4
APINFMTS EQU   APIN+8
APINUNIT EQU   0
APSV     EQU   0
APSVREGS EQU   APSV+12
APUT     EQU   0
APUTAPAT EQU   APUT+8
APUTFLGS EQU   APUT+24
APUTFLG0 EQU   APUTFLGS
APCVZDAL EQU   0
APCVZDAP EQU   0
APCVZDBK EQU   0
APCVZDDA EQU   0
APCVZDDQ EQU   0
APCVZDEQ EQU   0
APCVZDID EQU   0
APCVZDIO EQU   0
APCVZDIP EQU   0
APCVZDMD EQU   0
APCVZDMM EQU   0
APCVZDQR EQU   0
APCVZDRI EQU   0
APCVZDUA EQU   0
APCVZDUL EQU   0
APCVZDWI EQU   0
APCVZDWT EQU   0
APCVZDX1 EQU   0
APCVZDX2 EQU   0
APCVZDX3 EQU   0
APCVZDX4 EQU   0
APCVZD10 EQU   0
APCVZD20 EQU   0
APCVZD4E EQU   0
APCVZD40 EQU   0
APCVZD41 EQU   0
APCVZD42 EQU   0
APCVZD43 EQU   0
APCVZD44 EQU   0
APCVZD45 EQU   0
APCVZD46 EQU   0
APCVZD47 EQU   0
APCVZD48 EQU   0
APCVZD49 EQU   0
APCVZD60 EQU   0
APCVZD80 EQU   0
APCVZD81 EQU   0
APCVZD82 EQU   0
APCVZD83 EQU   0
APCVZJAA EQU   0
APCVZJAD EQU   0
APCVZJAG EQU   0
APCVZJAJ EQU   0
APCVZJAM EQU   0
APCVZJAP EQU   0
APCVZJAX EQU   0
APCVZJAY EQU   0
APCVZJBA EQU   0
APCVZJBD EQU   0
APCVZJBG EQU   0
APCVZJBJ EQU   0
APCVZJBM EQU   0
APCVZJDA EQU   0
APCVZJDD EQU   0
APCVZJDG EQU   0
APCVZJDJ EQU   0
APCVZJDM EQU   0
APCVZJHC EQU   0
APCVZJHE EQU   0
APCVZJHF EQU   0
APCVZJHO EQU   0
APCVZJHQ EQU   0
APCVZJHR EQU   0
APCVZJHT EQU   0
APCVZJHW EQU   0
APCVZJH0 EQU   0
APCVZJH6 EQU   0
APCVZJI0 EQU   0
APCVZJI3 EQU   0
APCVZJJ0 EQU   0
APCVZKAA EQU   0
APCVZKBA EQU   0
APCVZKBB EQU   0
APCVZKBC EQU   0
APCVZKBD EQU   0
APCVZKBE EQU   0
APCVZKBF EQU   0
APCVZKCA EQU   0
APCVZKDA EQU   0
APCVZKGA EQU   0
APCVZKGB EQU   0
APCVZKGC EQU   0
APCVZKGD EQU   0
APCVZLCA EQU   0
APCVZLCB EQU   0
APCVZMBA EQU   0
APCVZMBD EQU   0
APCVZMBG EQU   0
APCVZMBH EQU   0
APCVZMBK EQU   0
APCVZMBM EQU   0
APCVZMIB EQU   0
APCVZMIC EQU   0
APCVZMIF EQU   0
APCVZMJB EQU   0
APCVZMJC EQU   0
APCVZMJI EQU   0
APCVZUAA EQU   0
APCVZUAB EQU   0
APCVZUAC EQU   0
APCVZUAD EQU   0
APCVZUAE EQU   0
APCVZUAF EQU   0
APCVZUAG EQU   0
APCVZUBB EQU   0
APCVZUFA EQU   0
APCVZUHA EQU   0
APCVZUHB EQU   0
APCVZUJA EQU   0
APCVZUKA EQU   0
APCV1CMD EQU   0
APCV1JAA EQU   0
APCV1JBJ EQU   0
APCV1JHC EQU   0
APCV1JHL EQU   0
APCV1JHT EQU   0
APCV1MAB EQU   0
APCV1MBD EQU   0
APCV2JHC EQU   0
APCV2JHL EQU   0
APCV2MBD EQU   0
APINACI  EQU   0
APINACW  EQU   0
APINAPRL EQU   0
APINBIV  EQU   0
APINBLB  EQU   0
APINCHB  EQU   0
APINCHC  EQU   0
APINCHS  EQU   0
APINCHX  EQU   0
APINCXC  EQU   0
APINCXS  EQU   0
APINCXX  EQU   0
APINDLB  EQU   0
APINDSV  EQU   0
APINERR  EQU   0
APINFUNC EQU   0
APINICI  EQU   0
APINICW  EQU   0
APINKYVF EQU   0
APINKYVL EQU   0
APINKYVP EQU   0
APINKYWD EQU   0
APINPXB  EQU   0
APINPXC  EQU   0
APINPXF  EQU   0
APINPXP  EQU   0
APINSTB  EQU   0
APINSTD  EQU   0
APINUST  EQU   0
APINXBS  EQU   0
APINXBX  EQU   0
APINXCD  EQU   0
APINXCT  EQU   0
APINXID  EQU   0
APINXI1  EQU   0
APINXI2  EQU   0
APINXLB  EQU   0
APINXST  EQU   0
APINYST  EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
DAPCW    EQU   0
APCTZ    EQU   APCTZ@@@
APCTZUAA EQU   APCTZ
APCTZUAB EQU   APCTZ+4
APCTZUAC EQU   APCTZ+8
APCTZUAD EQU   APCTZ+12
APCTZUAE EQU   APCTZ+16
APCTZUBB EQU   APCTZ+24
APCTZD10 EQU   APCTZ+28
APCTZD20 EQU   APCTZ+32
APCTZD40 EQU   APCTZ+36
APCTZD41 EQU   APCTZ+40
APCTZD42 EQU   APCTZ+44
APCTZD43 EQU   APCTZ+48
APCTZD44 EQU   APCTZ+52
APCTZD45 EQU   APCTZ+56
APCTZD46 EQU   APCTZ+60
APCTZD47 EQU   APCTZ+64
APCTZD48 EQU   APCTZ+68
APCTZD49 EQU   APCTZ+72
APCTZD60 EQU   APCTZ+76
APCTZD80 EQU   APCTZ+80
APCTZD4E EQU   APCTZ+84
APCTZMBA EQU   APCTZ+88
APCTZMBD EQU   APCTZ+92
APCTZMBG EQU   APCTZ+96
APCTZDX1 EQU   APCTZ+104
APCTZDX2 EQU   APCTZ+108
APCTZDX3 EQU   APCTZ+112
APCTZDX4 EQU   APCTZ+116
APCTZMBH EQU   APCTZ+120
APCTZMBK EQU   APCTZ+124
APCTZMBM EQU   APCTZ+128
APCTZMJB EQU   APCTZ+132
APCTZMJC EQU   APCTZ+136
APCTZMJH EQU   APCTZ+140
APCTZMMA EQU   APCTZ+144
APCTZDMD EQU   APCTZ+148
APCTZD81 EQU   APCTZ+152
APCTZDID EQU   APCTZ+156
APCTZDRI EQU   APCTZ+160
APCTZMJI EQU   APCTZ+164
APCTZDWT EQU   APCTZ+168
APCTZDMM EQU   APCTZ+172
APCTZDAL EQU   APCTZ+176
APCTZDBK EQU   APCTZ+180
APCTZDIP EQU   APCTZ+184
APCTZDDA EQU   APCTZ+188
APCTZDUL EQU   APCTZ+192
APCTZDEQ EQU   APCTZ+196
APCTZDDQ EQU   APCTZ+200
APCTZDUA EQU   APCTZ+204
APCTZUAF EQU   APCTZ+208
APCTZUAG EQU   APCTZ+212
APCTZDIO EQU   APCTZ+216
APCTZUHA EQU   APCTZ+220
APCTZUHB EQU   APCTZ+224
APCTZJAA EQU   APCTZ+232
APCTZJAD EQU   APCTZ+236
APCTZJAG EQU   APCTZ+240
APCTZJAJ EQU   APCTZ+244
APCTZJAM EQU   APCTZ+248
APCTZJAP EQU   APCTZ+252
APCTZJAY EQU   APCTZ+256
APCTZUFA EQU   APCTZ+260
APCTZUJA EQU   APCTZ+264
APCTZDAP EQU   APCTZ+268
APCTZKAA EQU   APCTZ+272
APCTZD82 EQU   APCTZ+276
APCTZMIB EQU   APCTZ+280
APCTZMIC EQU   APCTZ+284
APCTZD83 EQU   APCTZ+288
APCTZMIF EQU   APCTZ+296
APCTZJH0 EQU   APCTZ+300
APCTZJI0 EQU   APCTZ+304
APCTZJI3 EQU   APCTZ+308
APCTZJJ0 EQU   APCTZ+312
APCTZJBA EQU   APCTZ+316
APCTZJBD EQU   APCTZ+320
APCTZJBG EQU   APCTZ+324
APCTZJBJ EQU   APCTZ+328
APCTZJBM EQU   APCTZ+332
APCTZKCA EQU   APCTZ+340
APCTZKDA EQU   APCTZ+344
APCTZJDA EQU   APCTZ+356
APCTZJDJ EQU   APCTZ+360
APCTZJH6 EQU   APCTZ+364
APCTZJHO EQU   APCTZ+368
APCTZJHF EQU   APCTZ+372
APCTZJHE EQU   APCTZ+376
APCTZDQR EQU   APCTZ+380
APCTZJHR EQU   APCTZ+384
APCTZJHT EQU   APCTZ+388
APCTZJHW EQU   APCTZ+392
APCTZ1   EQU   APCTZ@@1
APCTZKBA EQU   APCTZ1
APCTZKBC EQU   APCTZ1+4
APCTZKBB EQU   APCTZ1+8
APCTZJHC EQU   APCTZ1+20
APCTZJHQ EQU   APCTZ1+24
APCTZKBD EQU   APCTZ1+28
APCTZKBE EQU   APCTZ1+40
APCTZUKA EQU   APCTZ1+56
APCTZKBF EQU   APCTZ1+60
APCTZJDD EQU   APCTZ1+64
APCTZJDG EQU   APCTZ1+68
APCTZJDM EQU   APCTZ1+72
APCTZLCA EQU   APCTZ1+76
APCTZLCB EQU   APCTZ1+80
APCTZDWI EQU   APCTZ1+84
APCTZJAX EQU   APCTZ1+88
APCTZKGA EQU   APCTZ1+92
APCTZKGB EQU   APCTZ1+96
APCTZKGC EQU   APCTZ1+100
APCTZKGD EQU   APCTZ1+104
APCTU    EQU   APCTU@@@
APCT1MAB EQU   APCTU
APCT1MBD EQU   APCTU+4
APCT2MBD EQU   APCTU+8
APCT1CMD EQU   APCTU+12
APCT1JAA EQU   APCTU+20
APCT1JHC EQU   APCTU+24
APCT2JHC EQU   APCTU+28
APCT1JHT EQU   APCTU+32
APCT1JHL EQU   APCTU+36
APCT2JHL EQU   APCTU+40
APCT1JBJ EQU   APCTU+44
APINFMT1 EQU   APINFMTS
APINAERR EQU   APINFMT1
@NM00083 EQU   APINFMT1+4
APINAKYW EQU   @NM00083
APINAKYV EQU   @NM00083+4
APINFMT2 EQU   APINFMTS
APINAAR  EQU   APINFMT2
APINFMT3 EQU   APINFMTS
APINASTB EQU   APINFMT3
APINAACW EQU   APINFMT3+4
APINAICW EQU   APINFMT3+8
APINAACI EQU   APINFMT3+12
APINAICI EQU   APINFMT3+16
APINFMT4 EQU   APINFMTS
APINAXI1 EQU   APINFMT4
APINAXI2 EQU   APINFMT4+4
APINAXLB EQU   APINFMT4+8
APINAXCD EQU   APINFMT4+12
APINFMT5 EQU   APINFMTS
APINADLB EQU   APINFMT5
APINFMT6 EQU   APINFMTS
APINABIV EQU   APINFMT6
APINABLB EQU   APINFMT6+4
APINFMT7 EQU   APINFMTS
APINACHS EQU   APINFMT7
APINACHC EQU   APINFMT7+4
APINACHB EQU   APINFMT7+8
APINACHX EQU   APINFMT7+12
APINFMT8 EQU   APINFMTS
APINACXS EQU   APINFMT8
APINACXC EQU   APINFMT8+4
APINACXX EQU   APINFMT8+8
APINFMT9 EQU   APINFMTS
APINASTD EQU   APINFMT9
APINADSV EQU   APINFMT9+4
APINAYST EQU   APINFMT9+8
APINAXST EQU   APINFMT9+12
APINAUST EQU   APINFMT9+16
APINFM10 EQU   APINFMTS
APINAXBS EQU   APINFM10
APINAXCT EQU   APINFM10+4
APINAXBX EQU   APINFM10+8
APINAXID EQU   APINFM10+12
APINAPMS EQU   APIN
APINAP1  EQU   APINAPMS
APINAP2  EQU   APINAPMS+4
APINAP3  EQU   APINAPMS+8
APINAP4  EQU   APINAPMS+12
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
APINAP4P EQU   APINAP4+1
@NM00087 EQU   APINAP4
APINAP4E EQU   APINAP4
APINAP3P EQU   APINAP3+1
@NM00086 EQU   APINAP3
APINAP3E EQU   APINAP3
APINAP2P EQU   APINAP2+1
@NM00085 EQU   APINAP2
APINAP2E EQU   APINAP2
APINAP1P EQU   APINAP1+1
@NM00084 EQU   APINAP1
APINAP1E EQU   APINAP1
@NM00065 EQU   APCTU+48
APCT1MBM EQU   APCTU+16
@NM00064 EQU   APCTZ1+108
@NM00063 EQU   APCTZ1+52
@NM00062 EQU   APCTZ1+48
@NM00061 EQU   APCTZ1+44
@NM00060 EQU   APCTZ1+36
@NM00059 EQU   APCTZ1+32
@NM00058 EQU   APCTZ1+16
@NM00057 EQU   APCTZ1+12
@NM00056 EQU   APCTZ+396
@NM00055 EQU   APCTZ+352
@NM00054 EQU   APCTZ+348
@NM00053 EQU   APCTZ+336
@NM00052 EQU   APCTZ+292
APCTZJFA EQU   APCTZ+228
APCTZMBR EQU   APCTZ+100
@NM00051 EQU   APCTZ+20
@NM00092 EQU   APUT+160
APUTAPEM EQU   APUT+32
APUTRCDE EQU   APUT+28
@NM00091 EQU   APUT+26
APUTFLG1 EQU   APUTFLGS+1
@NM00090 EQU   APUTFLG0
APUTACT  EQU   APUTFLG0
@NM00089 EQU   APUT+18
APUTSIZE EQU   APUT+16
APUTAPCT EQU   APUT+12
APUTUSER EQU   APUT+4
APUTID   EQU   APUT
APSVWORK EQU   APSV+80
@NM00088 EQU   APSV+80
APSVFREE EQU   APSV+76
APSVAPSM EQU   APSV+72
APSVRG12 EQU   APSVREGS+56
APSVRG11 EQU   APSVREGS+52
APSVRG10 EQU   APSVREGS+48
APSVRG9  EQU   APSVREGS+44
APSVRG8  EQU   APSVREGS+40
APSVRG7  EQU   APSVREGS+36
APSVRG6  EQU   APSVREGS+32
APSVRG5  EQU   APSVREGS+28
APSVRG4  EQU   APSVREGS+24
APSVRG3  EQU   APSVREGS+20
APSVRG2  EQU   APSVREGS+16
APSVRG1  EQU   APSVREGS+12
APSVRG0  EQU   APSVREGS+8
APSVRG15 EQU   APSVREGS+4
APSVRG14 EQU   APSVREGS
APSVNEXT EQU   APSV+8
APSVPREV EQU   APSV+4
APSVAPSC EQU   APSV
@NM00082 EQU   APEM+128
APEMSSNM EQU   APEM+124
APEMCM17 EQU   APEM+123
APEMAPRL EQU   APEM+117
APEMCM16 EQU   APEM+116
APEMVALN EQU   APEMVALU+4
APEMVALP EQU   APEMVALU
APEMCM15 EQU   APEM+107
@NM00081 EQU   APEMMSG+4
APEMMSGN EQU   APEMMSG
APEMCM13 EQU   APEM+91
APEMCCWC EQU   APEM+85
APEMCM12 EQU   APEM+84
APEMDDN  EQU   APEM+76
APEMCM11 EQU   APEM+75
APEMDVTP EQU   APEM+73
APEMCM10 EQU   APEM+72
APEMUNIT EQU   APEM+69
APEMCM09 EQU   APEM+68
APEMSTEP EQU   APEM+60
APEMCM08 EQU   APEM+59
APEMJOB  EQU   APEM+51
APEMCM07 EQU   APEM+50
APEMCICT EQU   APEM+48
APEMCM06 EQU   APEM+47
APEMCIOP EQU   APEM+43
APEMCM05 EQU   APEM+42
APEMCINM EQU   APEM+38
APEMCM04 EQU   APEM+37
APEMNAME EQU   APEM+33
APEMCM03 EQU   APEM+32
APEMERCD EQU   APEM+26
APEMCM02 EQU   APEM+25
APEMTIME EQU   APEM+18
APEMCM01 EQU   APEM+17
APEMDATE EQU   APEM+12
APEMREG1 EQU   APEM+8
APEMZ2   EQU   APEM+6
APEMSZ2  EQU   APEM+4
APEMZ1   EQU   APEM+2
APEMSZ1  EQU   APEM
APCXINTF EQU   APCXINTV
APCXBSAD EQU   APCXUSRI+20
APCXARCD EQU   APCXUSRI+16
APCXAFNC EQU   APCXUSRI+12
APCXACCW EQU   APCXUSRI+8
APCXFLG3 EQU   APCXFLGS+3
APCXFLG2 EQU   APCXFLGS+2
APCXFLG1 EQU   APCXFLGS+1
@NM00080 EQU   APCXFLG0
APCXOWN  EQU   APCXFLG0
APCXREG  EQU   APCXUSRI
APCXUSER EQU   APCX+4
APCXID   EQU   APCX
@NM00079 EQU   APCW+240
@NM00078 EQU   APCW+112
@NM00077 EQU   APCW+80
@NM00076 EQU   APCW+76
APCWZCNV EQU   APCWINT3
APCWZFLO EQU   APCWINT3
APCWZFLU EQU   APCWINT3
APCWZFLD EQU   APCWINT3
APCWZIDX EQU   APCWINT3
APCWZFLN EQU   APCWINT3
@NM00075 EQU   APCWINT3
APCWZLGC EQU   APCWINT2
APCWZHDW EQU   APCWINT2
APCWZUKN EQU   APCWINT2
@NM00074 EQU   APCWINT2
@NM00073 EQU   APCWINT1
APCWZAM  EQU   APCWINT0
@NM00072 EQU   APCWINT0
APCWRCN  EQU   APCWRCDE+3
APCWRCC  EQU   APCWRCDE+2
APCWRCT  EQU   APCWRCDE+1
APCWRC0  EQU   APCWRCDE
APCWR15B EQU   APCWR15C+3
@NM00071 EQU   APCWR15C
APCWAPOP EQU   APCWOPF
@NM00070 EQU   APCW+60
APCWAPFN EQU   APCW+56
@NM00069 EQU   APCW+52
APCWNBRI EQU   APCW+48
APCWSW1  EQU   APCWSWS+1
@NM00068 EQU   APCWSW0
APCWSVAL EQU   APCWSW0
APCWSIX  EQU   APCWSW0
@NM00067 EQU   APCW+44
APCWAPAL EQU   APCW+40
@NM00066 EQU   APCW+36
APCWAPCP EQU   APCW+32
APCWAPIO EQU   APCW+28
APCWAPRL EQU   APCW+24
APCWACBF EQU   APCWACB
APCWAPSV EQU   APCW+16
APCWUSER EQU   APCW+4
APCWID   EQU   APCW
@NM00050 EQU   APCT+1556
APCTSVCT EQU   APCT+1552
APCTDAVT EQU   APCT+1548
APCTLOGL EQU   APCT+1544
@NM00049 EQU   APCT+1540
APCTDMPU EQU   APCT+1536
APCTDMPM EQU   APCT+1532
APCTNDMP EQU   APCT+1530
APCTASID EQU   APCT+1528
APCTLGPG EQU   APCT+1526
APCTLGLN EQU   APCT+1524
APCTAPVU EQU   APCT+1520
APCTABR  EQU   APCT+1116
APCTACTR EQU   APCT+1112
APCTLOGD EQU   APCT+1108
APCTDCLD EQU   APCT+1104
APCTIOAP EQU   APCT+1100
@NM00048 EQU   APCT+1080
@NM00047 EQU   APCT+1078
APCTKCAX EQU   APCT+1076
APCTABND EQU   APCT+1072
@NM00046 EQU   APCT+1068
APCTAPIO EQU   APCT+1064
APCTCSCT EQU   APCT+1060
APCTSTDF EQU   APCT+1056
APCTSTMX EQU   APCT+1052
APCTRGMX EQU   APCT+1048
APCTSIZE EQU   APCT+1046
APCTCTUB EQU   APCT+1045
APCTMFID EQU   APCT+1044
APCTMFSZ EQU   APCT+1040
APCTCRTN EQU   APCT+1036
APCTAPCP EQU   APCT+1032
APCTAMNA EQU   APCT+1028
APCTEMNA EQU   APCT+1024
APCTAALP EQU   APCT+1020
APCTEALP EQU   APCT+1016
@NM00045 EQU   APCT+1012
@NM00044 EQU   APCT+1008
@NM00043 EQU   APCT+1004
APCTEIPL EQU   APCT+1000
@NM00042 EQU   APCT+996
@NM00041 EQU   APCT+992
@NM00040 EQU   APCT+988
@NM00039 EQU   APCT+984
@NM00038 EQU   APCT+980
APCTECPW EQU   APCT+976
APCTEULD EQU   APCT+972
APCTECPT EQU   APCT+968
APCTEALC EQU   APCT+964
APCTECBL EQU   APCT+960
APCTECIT EQU   APCT+956
APCTCQAF EQU   APCTCQAQ
APCTCQL  EQU   APCTAPCQ+4
APCTCQF  EQU   APCTAPCQ
APCTCQLK EQU   APCT+940
@NM00037 EQU   @NM00033+2
@NM00036 EQU   APCTPRSW
APCTAPST EQU   APCTPRSW
@NM00035 EQU   APCTPRSW
@NM00034 EQU   APCTSTAT
APCTWARM EQU   APCTSTAT
APCTTERM EQU   APCTSTAT
APCTHALT EQU   APCTSTAT
APCTQSCE EQU   APCTSTAT
APCTSTRT EQU   APCTSTAT
APCTACT  EQU   APCTSTAT
APCTVUNX EQU   APCT+935
APCTSOUT EQU   APCT+934
APCTDAID EQU   APCT+933
APCTSV34 EQU   APCT+932
APCTMJOB EQU   APCT+928
APCTTCB  EQU   APCT+924
APCTASCB EQU   APCT+920
APCTDCNW EQU   APCT+918
APCTDCNR EQU   APCT+916
@NM00032 EQU   APCT+912
@NM00031 EQU   APCT+908
@NM00030 EQU   APCT+904
@NM00029 EQU   APCT+900
@NM00028 EQU   APCTERRS+22
APCTERTJ EQU   APCTERRS+20
APCTERTD EQU   APCTERRS+18
APCTERTC EQU   APCTERRS+16
APCTERTB EQU   APCTERRS+14
APCTERTA EQU   APCTERRS+12
APCTERT9 EQU   APCTERRS+10
APCTERT3 EQU   APCTERRS+8
APCTERT2 EQU   APCTERRS+6
APCTERT1 EQU   APCTERRS+4
APCTERT0 EQU   APCTERRS+2
APCTERTT EQU   APCTERRS
APCTDSAP EQU   APCT+872
APCTISUB EQU   APCT+868
APCTUBAP EQU   APCT+864
APCTAPDS EQU   APCT+860
APCTUBIC EQU   APCT+856
APCTUBIS EQU   APCT+852
APCTAPUB EQU   APCT+848
APCTUBLK EQU   APCT+844
APCTBR1A EQU   APCTBR14+2
@NM00027 EQU   APCTBR14
APCTSMSZ EQU   APCTSMAD+2
@NM00026 EQU   APCTSMAD+1
@NM00025 EQU   APCTSMAD
APCTSMIS EQU   APCTSMIN+2
@NM00024 EQU   APCTSMIN+1
APCTSMSP EQU   APCTSMIN
@NM00023 EQU   APCT+30
APCTLINE EQU   APCT+28
APCTLBSZ EQU   APCT+24
APCTREG  EQU   APCT+20
APCTSSID EQU   APCTENQM+4
@NM00022 EQU   APCTENQM
APCTSSVT EQU   APCT+8
APCTUSER EQU   APCT+4
APCTID   EQU   APCT
@NM00021 EQU   APAT+408
@NM00020 EQU   APAT+8
APATUSER EQU   APAT+4
APATID   EQU   APAT
EXLEADDR EQU   EXLEXITP
@NM00019 EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLSPEC  EQU   EXLENFL
EXLOPNP  EQU   EXLCOMN+36
@NM00018 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
EXLJRNP  EQU   EXLCOMN+31
@NM00017 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
EXLLGNP  EQU   EXLCOMN+26
@NM00016 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLSCIPP EQU   EXLCOMN+21
@NM00015 EQU   EXLSCIPF
EXLSCIPK EQU   EXLSCIPF
EXLSCIPA EQU   EXLSCIPF
EXLSCIPS EQU   EXLSCIPF
EXLLERP  EQU   EXLCOMN+16
@NM00014 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
EXLSYNP  EQU   EXLCOMN+11
@NM00013 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
EXLEODP  EQU   EXLCOMN+6
@NM00012 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00011 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
EXLSTYP  EQU   EXLCOMN+1
EXLID    EQU   EXLCOMN
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBBUFSP EQU   ACBCOMN+56
@NM00010 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00009 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00008 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00007 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00006 EQU   ACBDSORG+1
@NM00005 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00004 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00003 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00002 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00001 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBAMWAP EQU   ACBIBCT
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IGTMJB,(C'PLS1917',0701,77179)
