TUAG     TITLE 'IGTUAG -- SUPERVISOR STATE STORAGE MANAGEMENT INTERFACE*
               E        '
IGTUAG   CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IGTUAG    77.093'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @06,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@06                                      01S0001
*   RAPSVPTR=APSVPTR;               /* KEEP SAVEAREA PTR (R13 USED)  */
         LR    RAPSVPTR,APSVPTR                                 01S0025
*   RAPGFPTR=R1P;                   /* POINT TO INPUT PARMS          */
         LR    RAPGFPTR,R1P                                     01S0026
*   RFY                                                         01S0027
*    (R1P,                                                      01S0027
*     APSVPTR,                                                  01S0027
*     APCTPTR) UNRSTD;              /* FINISHED WITH THESE REGS      */
*   RFY                                                         01S0028
*     APSV BASED(RAPSVPTR);         /* TELL COMPILER OF              */
*   RFY                                                         01S0029
*     APGF BASED(RAPGFPTR);         /* NEW POINTERS                  */
*                                                               01S0029
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE INPUT PSW KEY & SWITCH TO KEY ZERO                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0030
*   RFY                             /* REQUIRED REGISTERS            */
*    (R2F,                          /* SET TO INPUT KEY BY MODESET   */
*     RINKEY) RSTD;                 /* HOLD INPUT KEY THROUGHOUT PGM */
*   GEN SETS(R2F) NOREFS;                                       01S0031
*                                   /*
         MODESET EXTKEY=ZERO,       GO TO KEY 0                        *
               SAVEKEY=(2)          SAVE INPUT KEY IN REG 2
*   RINKEY=R2F;                     /* SAVE INPUT KEY                */
*   RFY                                                         01S0033
*    (R2F) UNRSTD;                  /* FINISHED WITH R2F             */
*                                                               01S0033
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN THE LOCAL LOCK                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0034
*   DO;                             /* START OF CODE                 */
*                                                               02S0034
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE LOCAL LOCK IS NOT OWNED ON ENTRY, OBTAIN IT NOW. SET */
*     /* APGFSLCK=0 SO THE EXIT PROCEDURE WILL FREE IT.              */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0035
*     APGFSLCK=BON;                 /* SHOW LOCAL LOCK OWNED ON ENTRY*/
         OI    APGFSLCK(RAPGFPTR),B'00001000'                   02S0035
*     GEN NOSETS REFS(PSAHLHI) FLOWS(GETLOCK1) SEQFLOW;         02S0036
*                                   /*
         SETLOCK TEST,TYPE=LOCAL,  SEE IF LOCAL LOCK OWNED ON ENTRY    *
               BRANCH=(HELD,GETLOCK1), * IF OWNED, SKIP OBTAIN AND     *
               RELATED=APGFSLCK;   * SET APGFSLCK=1.
*     DO;                           /* GET THE LOCAL LOCK            */
*       APGFSLCK=BOFF;              /* FREE LOCAL LOCK ON EXIT       */
         NI    APGFSLCK(RAPGFPTR),B'11110111'                   02S0038
*       GEN REFS(FLC,PSALITA) SETS(R11F,R12F,R13F,R14F);        02S0039
*                                      /*
         SETLOCK OBTAIN,           ACQUIRE LOCAL LOCK                  *
               TYPE=LOCAL,         * SUSPEND UNTIL LOCK                *
               MODE=UNCOND,        * IS OBTAINED                       *
               RELATED=APGFSLCK    * APGFSLCK=0
*     END;                          /* LOCAL LOCK OBTAINED           */
*GETLOCK1:                          /* LOCAL LOCK OWNED ON ENTRY     */
*   END;                            /* END OF CODE -- LOCK OWNED     */
GETLOCK1 DS    0H                                               02S0042
*                                                               01S0042
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE GETMAIN/FREEMAIN REGISTERS                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0042
*   DO;                             /* SET GETMAIN/FREEMAIN REGS     */
*                                                               02S0042
*     /***************************************************************/
*     /*                                                             */
*     /* PLACED REQUIRED GETMAIN/FREEMAIN VALUES IN REGISTERS        */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0043
*     RFY                           /* NEEDED REGISTERS              */
*      (RTCBPTR,                    /* TCB                           */
*       RASCBPTR,                   /* ASCB                          */
*       RKEY,                       /* STORAGE KEY                   */
*       RSP,                        /* STORAGE SUBPOOL               */
*       RLV,                        /* STORAGE LENGTH                */
*       RADDR,                      /* PTR TO STORAGE                */
*       RCODE) RSTD;                /* HOLD PGM RETURN CODE          */
*     RSP=APGFXSP;                  /* STORAGE SUBPOOL               */
         SLR   RSP,RSP                                          02S0044
         IC    RSP,APGFXSP(,RAPGFPTR)                           02S0044
*     IF APGFXSP=CSP000 THEN        /* IF WANT SUBPOOL 0 (USER AREA) */
         CLI   APGFXSP(RAPGFPTR),0                              02S0045
         BNE   @RF00045                                         02S0045
*       RSP=CSP250;                 /* MUST USE 250 SINCE IN KEY 0.  */
         LA    RSP,250                                          02S0046
*     ELSE                          /* IF NOT WANTING SUBPOOL 0,     */
*       IF APGFXSP=CSP252 THEN      /* IF WANT SUBPOOL 252 (PROTECT) */
         B     @RC00045                                         02S0047
@RF00045 CLI   APGFXSP(RAPGFPTR),252                            02S0047
         BNE   @RF00047                                         02S0047
*         RSP=CSP000;               /* MUST USE 0 SINCE IN KEY 0.    */
         SLR   RSP,RSP                                          02S0048
*     RLV=APGFXLN;                  /* STORAGE LENGTH                */
@RF00047 DS    0H                                               02S0049
@RC00045 L     RLV,APGFXLN(,RAPGFPTR)                           02S0049
*     IF APGFSINL=BON THEN          /* IF INDIRECT LENGTH SPECIFIED, */
         TM    APGFSINL(RAPGFPTR),B'01000000'                   02S0050
         BNO   @RF00050                                         02S0050
*       RLV=RLV->I031F;             /* LOAD REQUIRED LENGTH          */
         L     RLV,I031F(,RLV)                                  02S0051
*     RLV=RLV&'00FFFFFF'X;          /* CLEAR SUBPOOL (IF ANY)        */
@RF00050 N     RLV,@CF01496                                     02S0052
*     RASCBPTR=PSAAOLD;             /* CURRENT ASCB ADDRESS          */
         L     RASCBPTR,PSAAOLD                                 02S0053
*     RTCBPTR=PSATOLD;              /* CURRENT TCB ADDRESS           */
         L     RTCBPTR,PSATOLD                                  02S0054
*     IF APGFSTCB=BON THEN          /* IF CURRENT TCB NOT TO BE USED */
         TM    APGFSTCB(RAPGFPTR),B'00000100'                   02S0055
         BNO   @RF00055                                         02S0055
*       RTCBPTR=APGFTCB;            /* USE PARAMETER LIST VALUE.     */
         L     RTCBPTR,APGFTCB(,RAPGFPTR)                       02S0056
*     IF APGFXKEY=255 THEN          /* IF USER KEY REQUESTED, USE    */
@RF00055 CLI   APGFXKEY(RAPGFPTR),255                           02S0057
         BNE   @RF00057                                         02S0057
*       RKEY=RTCBPTR->TCBPKF;       /* KEY FROM TCB.                 */
         SLR   RKEY,RKEY                                        02S0058
         IC    RKEY,TCBPKF(,RTCBPTR)                            02S0058
*     ELSE                          /* ELSE PUT GIVEN KEY IN BIT     */
*       RKEY=APGFXKEY*16;           /* POSITIONS 24-27.              */
         B     @RC00057                                         02S0059
@RF00057 SLR   RKEY,RKEY                                        02S0059
         IC    RKEY,APGFXKEY(,RAPGFPTR)                         02S0059
         SLA   RKEY,4                                           02S0059
*   END;                            /* END OF CODE                   */
@RC00057 DS    0H                                               02S0061
         EJECT
*                                                               01S0061
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE EITHER GETMAIN OR FREEMAIN BRANCH ENTRY                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0061
*   IF APGFSFRE=BOFF THEN           /* IF GETMAIN REQUESTED          */
         TM    APGFSFRE(RAPGFPTR),B'00000001'                   01S0061
         BNZ   @RF00061                                         01S0061
*     DO;                           /* GETMAIN THE STORAGE           */
*                                                               02S0062
*       /*************************************************************/
*       /*                                                           */
*       /* GETMAIN REQUESTED. ISSUE (UN)CONDITIONAL GETMAIN (BRANCH  */
*       /* ENTRY) FOR THE STORAGE. IF NOT OBTAINED, SET RCODE TO SHOW*/
*       /* THE FAILURE. OTHERWISE, AFTER SAVING THE ADDRESS OF THE   */
*       /* DYNAMIC STORAGE, INITIALIZE THE STORAGE (WITH APGFINIT) IF*/
*       /* REQUESTED (APGFSCLR=1).                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0063
*                                                               02S0063
*       /*************************************************************/
*       /*                                                           */
*       /* CLEAR ADDRESS OF STORAGE OBTAINED (FOR DEBUG)             */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0063
*       SPKA(RINKEY);               /* SWITCH TO CALLER'S KEY        */
         SPKA  0(RINKEY)                                        02S0063
*       IF APGFSINA=BOFF THEN       /* CLEAR STORAGE ADDRESS IN      */
         TM    APGFSINA(RAPGFPTR),B'10000000'                   02S0064
         BNZ   @RF00064                                         02S0064
*         APGFXADR=RADDR;           /* PARAMETER LIST OR WORD        */
         ST    RADDR,APGFXADR(,RAPGFPTR)                        02S0065
*       ELSE                        /* POINTED TO BY THE             */
*         APGFXADR->I031F=RADDR;    /* PARAMETER LIST.               */
         B     @RC00064                                         02S0066
@RF00064 L     @03,APGFXADR(,RAPGFPTR)                          02S0066
         ST    RADDR,I031F(,@03)                                02S0066
*       SPKA(KEY0);                 /* RETURN TO KEY 0               */
@RC00064 SPKA  0(KEY0)                                          02S0067
*       RFY                                                     02S0068
*        (R1P,                                                  02S0068
*         R15F) RSTD;               /* GETMAIN-SET REGISTERS         */
*       IF APGFSPGE=BON THEN        /* IF PAGE BOUNDARY WANTED       */
         TM    APGFSPGE(RAPGFPTR),B'00010000'                   02S0069
         BNO   @RF00069                                         02S0069
*         IF APGFSUNC=BON THEN      /* IF UNCONDITIONAL GETMAIN      */
         TM    APGFSUNC(RAPGFPTR),B'00000010'                   02S0070
         BNO   @RF00070                                         02S0070
*           GEN SETS(R0F,R1F,R14F,R15F,R3F,R7P) REFS(CVTPTR,CVTMAP,
*               CVTCRMN,RKEY,RSP,RLV);                          02S0071
*                                   /*
         GETMAIN RU,               UNCONDITIONAL GETMAIN               *
               SP=(RSP),           SUBPOOL                             *
               LV=(RLV),           SIZE                                *
               KEY=(RKEY),         KEY                                 *
               BNDRY=PAGE,         PAGE ALIGNMENT                      *
               BRANCH=YES          BRANCH ENTRY
*         ELSE                      /* IF CONDITIONAL GETMAIN        */
*           GEN SETS(R0F,R1F,R14F,R15F,R3F,R7P) REFS(CVTPTR,CVTMAP,
*               CVTCRMN,RKEY,RSP,RLV);                          02S0072
         B     @RC00070                                         02S0072
@RF00070 DS    0H                                               02S0072
*                                   /*
         GETMAIN RC,               CONDITIONAL GETMAIN                 *
               SP=(RSP),           SUBPOOL                             *
               LV=(RLV),           SIZE                                *
               KEY=(RKEY),         KEY                                 *
               BNDRY=PAGE,         PAGE ALIGNMENT                      *
               BRANCH=YES          BRANCH ENTRY
*       ELSE                        /* IF PAGE BOUNDARY NOT WANTED   */
*         IF APGFSUNC=BON THEN      /* IF UNCONDITIONAL GETMAIN      */
         B     @RC00069                                         02S0073
@RF00069 TM    APGFSUNC(RAPGFPTR),B'00000010'                   02S0073
         BNO   @RF00073                                         02S0073
*           GEN SETS(R0F,R1F,R14F,R15F,R3F,R7P) REFS(CVTPTR,CVTMAP,
*               CVTCRMN,RKEY,RSP,RLV);                          02S0074
*                                   /*
         GETMAIN RU,               UNCONDITIONAL GETMAIN               *
               SP=(RSP),           SUBPOOL                             *
               LV=(RLV),           SIZE                                *
               KEY=(RKEY),         KEY                                 *
               BNDRY=DBLWD,        DOUBLEWORD ALIGNMENT                *
               BRANCH=YES          BRANCH ENTRY
*         ELSE                      /* IF CONDITIONAL GETMAIN        */
*           GEN SETS(R0F,R1F,R14F,R15F,R3F,R7P) REFS(CVTPTR,CVTMAP,
*               CVTCRMN,RKEY,RSP,RLV);                          02S0075
         B     @RC00073                                         02S0075
@RF00073 DS    0H                                               02S0075
*                                   /*
         GETMAIN RC,               CONDITIONAL GETMAIN                 *
               SP=(RSP),           SUBPOOL                             *
               LV=(RLV),           SIZE                                *
               KEY=(RKEY),         KEY                                 *
               BNDRY=DBLWD,        DOUBLEWORD ALIGNMENT                *
               BRANCH=YES          BRANCH ENTRY
*           RCODE=R15F;             /* SAVE GETMAIN RETURN CODE      */
@RC00073 DS    0H                                               02S0076
@RC00069 LR    RCODE,R15F                                       02S0076
*       RADDR=R1P;                  /* SAVE ADDRESS OF OBTAINED AREA */
         LR    RADDR,R1P                                        02S0077
*       RFY                                                     02S0078
*        (R1P,                                                  02S0078
*         R15F) UNRSTD;             /* FINISHED WITH REGS 1 AND 15   */
*                                                               02S0078
*       /*************************************************************/
*       /*                                                           */
*       /* SAVE STORAGE ADDRESS IN CALLER'S AREA                     */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0079
*       IF RCODE=0 THEN             /* IF STORAGE OBTAINED           */
         LTR   RCODE,RCODE                                      02S0079
         BNZ   @RF00079                                         02S0079
*         DO;                       /* THEN DO --                    */
*           SPKA(RINKEY);           /* RETURN TO CALLER'S KEY        */
         SPKA  0(RINKEY)                                        02S0081
*           IF APGFSINA=BOFF THEN   /* SAVE STORAGE ADDRESS IN       */
         TM    APGFSINA(RAPGFPTR),B'10000000'                   02S0082
         BNZ   @RF00082                                         02S0082
*             APGFXADR=RADDR;       /* PARAMETER LIST OR WORD        */
         ST    RADDR,APGFXADR(,RAPGFPTR)                        02S0083
*           ELSE                    /* POINTED TO BY THE             */
*             APGFXADR->I031F=RADDR;/* PARAMETER LIST.               */
         B     @RC00082                                         02S0084
@RF00082 L     @03,APGFXADR(,RAPGFPTR)                          02S0084
         ST    RADDR,I031F(,@03)                                02S0084
*           SPKA(KEY0);             /* RETURN TO KEY 0               */
*                                                               02S0085
@RC00082 SPKA  0(KEY0)                                          02S0085
*           /*********************************************************/
*           /*                                                       */
*           /* IF REQUESTED, INITIALIZE ACQUIRED STORAGE TO APGFINIT */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0086
*           IF APGFSCLR=BON THEN    /* IF CLEARING OF OBTAINED AREA  */
         TM    APGFSCLR(RAPGFPTR),B'00100000'                   02S0086
         BNO   @RF00086                                         02S0086
*             DO;                   /* WANTED, THEN USE MVCL.        */
*               RFY                                             02S0088
*                (R0P,                                          02S0088
*                 R14P,                                         02S0088
*                 R1F,                                          02S0088
*                 R15F) RSTD;       /* INITIALIZE                    */
*               R0P=RADDR;          /* THE OBTAINED                  */
         LR    R0P,RADDR                                        02S0089
*               R1F=RLV;            /* DYNAMIC STORAGE.              */
         LR    R1F,RLV                                          02S0090
*               R15F=APGFINIT*CHIBYTE;/* FILL WITH 'APGFINIT'.       */
         SLR   R15F,R15F                                        02S0091
         IC    R15F,APGFINIT(,RAPGFPTR)                         02S0091
         SLA   R15F,24                                          02S0091
*               SPKA(RKEY);         /* GO TO STORAGE PROTECT KEY     */
         SPKA  0(RKEY)                                          02S0092
*               MVCL(R0P,R14P);     /* IN STORAGE KEY - NO 0C4       */
         MVCL  R0P,R14P                                         02S0093
*               SPKA(KEY0);         /* RESUME KEY-0                  */
         SPKA  0(KEY0)                                          02S0094
*               RFY                                             02S0095
*                (R0P,                                          02S0095
*                 R14P,                                         02S0095
*                 R1F,                                          02S0095
*                 R15F) UNRSTD;     /* DONE WITH REGS.               */
*             END;                  /* STORAGE INITIALIZED           */
*         END;                      /* STORAGE ACQUIRED              */
*     END;                          /* GETMAIN PROCESSED             */
*   ELSE                            /* ELSE IS FREEMAIN              */
         EJECT
*     DO;                           /* ISSUE FREEMAIN REQUEST        */
*                                                               02S0099
         B     @RC00061                                         02S0099
@RF00061 DS    0H                                               02S0100
*       /*************************************************************/
*       /*                                                           */
*       /* FREEMAIN REQUESTED. ISSUE (UN)CONDITIONAL FREEMAIN (BRANCH*/
*       /* ENTRY) FOR THE STORAGE. SET RCODE TO INDICATE IF THE      */
*       /* FREEMAIN WORKED (0 OR ^0).                                */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0100
*       SPKA(RINKEY);               /* INPUT KEY                     */
         SPKA  0(RINKEY)                                        02S0100
*       IF APGFSINA=BON THEN        /* FIND ADDRESS OF STORAGE       */
         TM    APGFSINA(RAPGFPTR),B'10000000'                   02S0101
         BNO   @RF00101                                         02S0101
*         DO;                       /* TO FREEMAIN. CONTAINED        */
*           RADDR=APGFXADR->I031P;  /* IN EITHER APGFXADR OR         */
         L     @03,APGFXADR(,RAPGFPTR)                          02S0103
         L     RADDR,I031P(,@03)                                02S0103
*           APGFXADR->I031P=0;      /* POINTED TO BY APGFXADR.       */
         SLR   @15,@15                                          02S0104
         ST    @15,I031P(,@03)                                  02S0104
*         END;                      /* AFTER ACQUIRING THE ADDRESS   */
*       ELSE                        /* RESET THE DYNAMIC AREA        */
*         DO;                       /* POINTER TO ZERO TO            */
         B     @RC00101                                         02S0106
@RF00101 DS    0H                                               02S0107
*           RADDR=APGFXADR;         /* PREVENT RECURSION LOOPING     */
         L     RADDR,APGFXADR(,RAPGFPTR)                        02S0107
*           APGFXADR=0;             /* IF THE FREEMAIN FAILS         */
         SLR   @03,@03                                          02S0108
         ST    @03,APGFXADR(,RAPGFPTR)                          02S0108
*         END;                      /* TO RETURN CONTROL.            */
*       SPKA(KEY0);                 /* RESUME KEY 0 PROCESSING       */
@RC00101 SPKA  0(KEY0)                                          02S0110
*       RFY                                                     02S0111
*        (R15F) RSTD;               /* FREEMAIN-SET REGISTER         */
*       IF APGFSUNC=BON THEN        /* IF UNCONDITIONAL FREEMAIN,    */
         TM    APGFSUNC(RAPGFPTR),B'00000010'                   02S0112
         BNO   @RF00112                                         02S0112
*         GEN SETS(R0F,R1F,R14F,R15F,R3F,R7P) REFS(CVTPTR,CVTMAP,
*             CVTCRMN,RKEY,RSP,RLV,RADDR);                      02S0113
*                                       /*
         FREEMAIN RU,              UNCONDITIONAL FREEMAIN              *
               SP=(RSP),           SUBPOOL                             *
               LV=(RLV),           LENGTH TO FREE                      *
               A=(RADDR),          DYNAMIC AREA ADDRESS                *
               KEY=(RKEY),         STORAGE KEY                         *
               BRANCH=YES          BRANCH ENTRY
*       ELSE                        /* IF CONDITIONAL FREEMAIN,      */
*         GEN SETS(R0F,R1F,R14F,R15F,R3F,R7P) REFS(CVTPTR,CVTMAP,
*             CVTCRMN,RKEY,RSP,RLV,RADDR);                      02S0114
         B     @RC00112                                         02S0114
@RF00112 DS    0H                                               02S0114
*                                       /*
         FREEMAIN RC,              CONDITIONAL FREEMAIN                *
               SP=(RSP),           SUBPOOL                             *
               LV=(RLV),           LENGTH TO FREE                      *
               A=(RADDR),          DYNAMIC AREA ADDRESS                *
               KEY=(RKEY),         STORAGE KEY                         *
               BRANCH=YES          BRANCH ENTRY
*         RCODE=R15F;               /* SAVE FREEMAIN RETURN CODE     */
@RC00112 LR    RCODE,R15F                                       02S0115
*       RFY                                                     02S0116
*        (R15F) UNRSTD;             /* FINISHED WITH REGISTER        */
*     END;                          /* FREEMAIN PROCESSED            */
         EJECT
*   RFY                                                         01S0118
*    (RTCBPTR,                                                  01S0118
*     RASCBPTR,                                                 01S0118
*     RKEY,                                                     01S0118
*     RSP,                                                      01S0118
*     RLV,                          /* FINISHED WITH TEMPORARY       */
*     RADDR) UNRSTD;                /* FINISHED WITH REGISTERS       */
*                                                               01S0118
@RC00061 DS    0H                                               01S0119
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE THE LOCAL LOCK                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0119
*   DO;                             /* START OF CODE                 */
*                                                               02S0119
*     /***************************************************************/
*     /*                                                             */
*     /* IF LOCAL LOCK OBTAINED BY THIS PROGRAM (APGFSLCK=0), RELEASE*/
*     /* IT NOW.                                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0120
*     IF APGFSLCK=BOFF THEN         /* IF LOCAL LOCK OBTAINED        */
         TM    APGFSLCK(RAPGFPTR),B'00001000'                   02S0120
         BNZ   @RF00120                                         02S0120
*       DO;                         /* THEN RELEASE IT               */
*         GEN REFS(FLC,PSALITA) SETS(R11F,R12F,R13F,R14F);      02S0122
*                                      /*
         SETLOCK RELEASE,          RELEASE THE                         *
               TYPE=LOCAL,         * LOCAL LOCK ONLY                   *
               RELATED=APGFSLCK    * IF APGFSLCK OFF
*       END;                        /* LOCK RELEASED                 */
*   END;                            /* END OF LOCK PROCESSING        */
@RF00120 DS    0H                                               02S0125
*                                                               01S0125
*   /*****************************************************************/
*   /*                                                               */
*   /* RESTORE THE INPUT KEY & RETURN TO THE CALLER                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0125
*   SPKA(RINKEY);                   /* INPUT PROTECT KEY             */
         SPKA  0(RINKEY)                                        01S0125
*   RFY                                                         01S0126
*     APSVPTR RSTD;                 /* REQUIRED SAVEAREA POINTER     */
*   APSVPTR=RAPSVPTR;               /* RESTORE PTR TO SAVEAREA       */
         LR    APSVPTR,RAPSVPTR                                 01S0127
*   RETURN CODE(RCODE);             /* EXIT TO CALLER                */
         LR    @15,RCODE                                        01S0128
         L     @14,12(,@13)                                     01S0128
         LM    @00,@12,20(@13)                                  01S0128
         BR    @14                                              01S0128
         EJECT
*                                   /* IGTXEPLG                      */
*                                                               01S0129
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0129
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0129
*     I031F FIXED(31) BASED,                                    01S0129
*     I031P PTR(31) BASED,                                      01S0129
*     I015F FIXED(15) BASED,                                    01S0129
*     I015P PTR(15) BASED,                                      01S0129
*     I008P PTR(8) BASED,                                       01S0129
*     I001C CHAR(1) BASED;                                      01S0129
*                                                               01S0130
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0130
*   DCL                                                         01S0130
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0130
*   GENERATE DATA DEFS(APPATCH);                                01S0131
*                                                               01S0132
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0132
*   DCL                                                         01S0132
*     R0F FIXED(31) REG(0),                                     01S0132
*     R0P PTR(24) REG(0),                                       01S0132
*     R0RSTD PTR(31) REG(0),                                    01S0132
*     R1F FIXED(31) REG(1),                                     01S0132
*     R1P PTR(24) REG(1),                                       01S0132
*     R1RSTD PTR(31) REG(1),                                    01S0132
*     R2F FIXED(31) REG(2),                                     01S0132
*     R2P PTR(24) REG(2),                                       01S0132
*     R2RSTD PTR(31) REG(2),                                    01S0132
*     R3F FIXED(31) REG(3),                                     01S0132
*     R3P PTR(24) REG(3),                                       01S0132
*     R3RSTD PTR(31) REG(3),                                    01S0132
*     R4F FIXED(31) REG(4),                                     01S0132
*     R4P PTR(24) REG(4),                                       01S0132
*     R4RSTD PTR(31) REG(4),                                    01S0132
*     R5F FIXED(31) REG(5),                                     01S0132
*     R5P PTR(24) REG(5),                                       01S0132
*     R5RSTD PTR(31) REG(5),                                    01S0132
*     R6F FIXED(31) REG(6),                                     01S0132
*     R6P PTR(24) REG(6),                                       01S0132
*     R6RSTD PTR(31) REG(6),                                    01S0132
*     R7F FIXED(31) REG(7),                                     01S0132
*     R7P PTR(24) REG(7),                                       01S0132
*     R7RSTD PTR(31) REG(7),                                    01S0132
*     R8F FIXED(31) REG(8),                                     01S0132
*     R8P PTR(24) REG(8),                                       01S0132
*     R8RSTD PTR(31) REG(8),                                    01S0132
*     R9F FIXED(31) REG(9),                                     01S0132
*     R9P PTR(24) REG(9),                                       01S0132
*     R9RSTD PTR(31) REG(9),                                    01S0132
*     R10F FIXED(31) REG(10),                                   01S0132
*     R10P PTR(24) REG(10),                                     01S0132
*     R10RSTD PTR(31) REG(10),                                  01S0132
*     R11F FIXED(31) REG(11),                                   01S0132
*     R11P PTR(24) REG(11),                                     01S0132
*     R11RSTD PTR(31) REG(11),                                  01S0132
*     R12F FIXED(31) REG(12),                                   01S0132
*     R12P PTR(24) REG(12),                                     01S0132
*     R12RSTD PTR(31) REG(12),                                  01S0132
*     R13F FIXED(31) REG(13),                                   01S0132
*     R13P PTR(24) REG(13),                                     01S0132
*     R13RSTD PTR(31) REG(13),                                  01S0132
*     R14F FIXED(31) REG(14),                                   01S0132
*     R14P PTR(24) REG(14),                                     01S0132
*     R14RSTD PTR(31) REG(14),                                  01S0132
*     R15F FIXED(31) REG(15),                                   01S0132
*     R15P PTR(24) REG(15),                                     01S0132
*     R15RSTD PTR(31) REG(15),                                  01S0132
*                                                               01S0132
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0132
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0132
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0132
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0132
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0132
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0132
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0132
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0132
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0132
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0132
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0132
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0132
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0132
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0133
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0133
*   DECLARE                         /* LOCAL REGISTERS               */
*     RINKEY REG(02) FIXED(31),     /* HOLD INPUT PSW KEY            */
*     RTCBPTR REG(04) PTR(24),      /* POINT TO TCB FOR SVC 120      */
*     RAPSVPTR REG(05) PTR(24),     /* HOLD APSV ADDRESS             */
*     RCODEPTR REG(06) PTR(24),     /* BASE REGISTER                 */
*     RASCBPTR REG(07) PTR(24),     /* POINT TO ASCB FOR SVC 120     */
*     RCODE REG(08) FIXED(31),      /* RETURN CODE                   */
*     RAPGFPTR REG(09) PTR(24),     /* APGF POINTER                  */
*     RADDR REG(10) PTR(24),        /* STORAGE ADDRESS               */
*     RSP REG(11) FIXED(31),        /* STORAGE SUBPOOL               */
*     RLV REG(12) FIXED(31),        /* STORAGE LENGTH                */
*     RKEY REG(13) FIXED(31);       /* STORAGE KEY                   */
*   END IGTUAG                      /* END OF MODULE                 */
*                                                               01S0134
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IGTXAPGF)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPSV)                                       */
*/*%INCLUDE SYSUT5  (GETLOCK )                                       */
*/*%INCLUDE SYSUT5  (SETREGS )                                       */
*/*%INCLUDE SYSUT5  (GETMAIN )                                       */
*/*%INCLUDE SYSUT5  (FREEMAIN)                                       */
*/*%INCLUDE SYSUT5  (FREELOCK)                                       */
*                                                               01S0134
*       ;                                                       01S0134
@EL00001 DS    0H                                               01S0134
@EF00001 DS    0H                                               01S0134
@ER00001 LM    @14,@12,12(@13)                                  01S0134
         BR    @14                                              01S0134
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IGTUAG   CSECT
         DS    0F
@CF01496 DC    XL4'00FFFFFF'
@DATD    DSECT
         DS    0D
IGTUAG   CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
IGTUAG   CSECT
*                                   /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
@ENDDATD EQU   *
IGTUAG   CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RCODEPTR EQU   @06
APSVPTR  EQU   @13
KEY0     EQU   @00
R1P      EQU   @01
RAPSVPTR EQU   @05
RAPGFPTR EQU   @09
APCTPTR  EQU   @12
R2F      EQU   @02
RINKEY   EQU   @02
R11F     EQU   @11
R12F     EQU   @12
R13F     EQU   @13
R14F     EQU   @14
RTCBPTR  EQU   @04
RASCBPTR EQU   @07
RKEY     EQU   @13
RSP      EQU   @11
RLV      EQU   @12
RADDR    EQU   @10
RCODE    EQU   @08
R15F     EQU   @15
R0F      EQU   @00
R1F      EQU   @01
R3F      EQU   @03
R7P      EQU   @07
R0P      EQU   @00
R14P     EQU   @14
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCODE   EQU   @07
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APCWPTR  EQU   @08
APDATA   EQU   @06
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APIOPTR  EQU   @10
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R0RSTD   EQU   @00
R1RSTD   EQU   @01
R10F     EQU   @10
R10P     EQU   @10
R10RSTD  EQU   @10
R11P     EQU   @11
R11RSTD  EQU   @11
R12P     EQU   @12
R12RSTD  EQU   @12
R13P     EQU   @13
R13RSTD  EQU   @13
R14RSTD  EQU   @14
R15P     EQU   @15
R15RSTD  EQU   @15
R2P      EQU   @02
R2RSTD   EQU   @02
R3P      EQU   @03
R3RSTD   EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R4RSTD   EQU   @04
R5F      EQU   @05
R5P      EQU   @05
R5RSTD   EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R8P      EQU   @08
R8RSTD   EQU   @08
R9F      EQU   @09
R9P      EQU   @09
R9RSTD   EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
APGF     EQU   0
APGFSW   EQU   APGF
APGFSINA EQU   APGFSW
APGFSINL EQU   APGFSW
APGFSCLR EQU   APGFSW
APGFSPGE EQU   APGFSW
APGFSLCK EQU   APGFSW
APGFSTCB EQU   APGFSW
APGFSUNC EQU   APGFSW
APGFSFRE EQU   APGFSW
APGFINIT EQU   APGF+1
APGFXSP  EQU   APGF+2
APGFXKEY EQU   APGF+3
APGFXADR EQU   APGF+4
APGFXLN  EQU   APGF+8
APGFTCB  EQU   APGF+12
APSV     EQU   0
APSVREGS EQU   APSV+12
I031F    EQU   0
I031P    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I256C    EQU   0
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTCRMN  EQU   CVTS01+156
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
TCBPTR   EQU   PSATOLD
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
APSVWORK EQU   APSV+80
@NM00032 EQU   APSV+80
APSVFREE EQU   APSV+76
APSVAPSM EQU   APSV+72
APSVRG12 EQU   APSVREGS+56
APSVRG11 EQU   APSVREGS+52
APSVRG10 EQU   APSVREGS+48
APSVRG9  EQU   APSVREGS+44
APSVRG8  EQU   APSVREGS+40
APSVRG7  EQU   APSVREGS+36
APSVRG6  EQU   APSVREGS+32
APSVRG5  EQU   APSVREGS+28
APSVRG4  EQU   APSVREGS+24
APSVRG3  EQU   APSVREGS+20
APSVRG2  EQU   APSVREGS+16
APSVRG1  EQU   APSVREGS+12
APSVRG0  EQU   APSVREGS+8
APSVRG15 EQU   APSVREGS+4
APSVRG14 EQU   APSVREGS
APSVNEXT EQU   APSV+8
APSVPREV EQU   APSV+4
APSVAPSC EQU   APSV
@NM00031 EQU   APGF+16
@NM00030 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00029 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00028 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00027 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00070 EQU   @RC00069
@RF00079 EQU   @RC00061
@RF00086 EQU   @RC00061
@ENDDATA EQU   *
         END   IGTUAG,(C'PLS0144',0701,77093)
