*%IF DVCIBASE = ''                      /* IF NO DVCTI BASE SPECIFIED*/
*%THEN %DVCIBASE = 'BASED(CVTZDTAB)';   /* USE CVTZDTAB              */
*%IF DVCTBASE = ''                      /* IF NO DVCT BASE SPECIFIED */
*                                       /* USE UCBTYP TO INDEX DVCTI */
*                                       /* AND USE CVTZDTAB + OFFSET */
*%THEN %DVCTBASE = 'BASED(CVTZDTAB+DVCTIOFF(UCBTYP & DVCTYPMK))';
*%;/*
         MACRO
         IHADVCT   &DSECT=YES
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IHADVCT
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = OS/VS2 RELEASE 2, LEVEL 0
.*
.*01  CHANGE-ACTIVITY = NONE
.*
.*01  DESCRIPTIVE-NAME = DEVICE CHARACTERISTICS TABLE MAPPING
.*
.*01  FUNCTION = THIS TABLE DESCRIBES PHYSICAL ATTRIBUTES OF EACH DASD
.*    DEVICE WHICH HAS BEEN SYSGENED
.*
.*01  NOTES = THE TABLE IS POINTED TO BY CVTZDTAB.
.*
.*01  MODULE-TYPE = MACRO
.*02    PROCESSOR = ASSEMBLER-370R
.*
.*02    MACRO-SIZE = 200 STATEMENTS
.*
.**** END OF SPECIFICATIONS ***/
* /* MACCOMP Y-2 SC1D0/SJD48                                         */
* /* MACSTAT Y-2 73226/021160                                        */
*/********************************************************************/
*/*                 DEVICE CHARACTERISTICS TABLE                     */
*/********************************************************************/
*/*                                                                  */
*/*         THIS TABLE MAY BE USED TO FIND THE CHARACTERISTICS       */
*/*         OF DIRECT ACCESS DEVICES.  THE APPLICABLE DEVICES ARE    */
*/*         THOSE CONTAINING UCBDACC IN UCBTBYT3 (SEE IEFUCBOB).     */
*/*                                                                  */
*/*         NOTE: DEVTYPE MAY BE USED TO EXTRACT INFORMATION         */
*/*         FROM THIS TABLE.  ITS OUTPUT AREA IS IN A SLIGHTLY       */
*/*         DIFFERENT FORMAT, AND IS MAPPED BY IHADVA.               */
*/*                                                                  */
*/*         THE TABLE IS COMPOSED OF AN INDEX FOLLOWED BY ONE        */
*/*         ENTRY FOR EACH DASD DEVICE WHICH HAS BEEN SYSGENED       */
*/*                                                                  */
*/*         FOR ASSEMBLER USE, TWO SEPARATE DSECTS ARE PROVIDED.     */
*/*         A USING ON DVCTI GIVES ADDRESSIBILITY TO THE INDEX,      */
*/*         AND A USING ON DVCT GIVES ADDRESSIBILITY TO AN ENTRY.    */
*/*         SPECIFYING DSECT=NO SUPPRESSES THE INDEX AND PROVIDES    */
*/*         AN ENTRY DESCRIPTION WITHOUT A DSECT STATEMENT           */
*/*                                                                  */
*/*         FOR PLS USE, TWO STRUCTURES ARE PROVIDED. THEIR STORAGE  */
*/*         ATTRIBUTES ARE CONTROLLED BY SETTING STRING MACRO        */
*/*         VARIABLES AS FOLLOWS:                                    */
*/*         STRUCTURE  MACRO-VAR       DEFAULT SETTING               */
*/*         DVCTI      %DVCIBASE  'BASED(CVTZDTAB)'                  */
*/*         DVCT       %DVCTBASE  'BASED(CVTZDTAB                    */
*/*                                +DVCTIOFF(UCBTYP&DVCTYPMK))'      */
*/*                                                                  */
*/*         THE DEFAULT SETTINGS WILL PROVIDE ADDRESSIBILITY TO      */
*/*         ALL FIELDS, BUT DEPEND ON CVT AND UCB ADDRESSIBILITY.    */
*/*                                                                  */
*/*               FORMAT OF EACH ENTRY                               */
*/*         _____________________________________________            */
*/*   0(00) |                     |                     |            */
*/*         |       DVCCYL        |       DVCTRK        |            */
*/*         |_____________________|_____________________|            */
*/*   4(04) |                     |       DVCOVHD       |            */
*/*         |       DVCTRKLN      | DVCOVNLB | DVCOVLB  |            */
*/*         |_____________________|__________|__________|            */
*/*   8(08) |          |          |                     |            */
*/*         | DVCOVNK  | DVCFLAGS |       DVCTOL        |            */
*/*         |__________|__________|_____________________|            */
*/*  12(0C) |                     |______________________            */
*/*         |       DVCALT        |                     |            */
*/*         |_____________________|       DVCOVR0       |  RPS       */
*/*         ______________________|_____________________|  ONLY      */
*/*  16(10) |          |          |                        SECTION   */
*/*         | DVCSECT  | DVCSECTD |                                  */
*/*         |__________|__________|                                  */
*/********************************************************************/
*%/*
         AIF   ('&DSECT' EQ 'NO').NODSECT
DVCTI    DSECT ,              INDEX TO DVCT
*              THIS INDEX IS LOCATED FROM CVTZDTAB.
*              THE PROPER ENTRY IS FOUND BY ADDING THE LOW ORDER
*              4 BITS OF UCBTYP TO THE ADDRESS IN CVTZDTAB.
DVCTYPMK EQU   X'0000000F'              TYPICAL USAGE:
*              LA    RWRK,DVCTYPMK      MASK FOR UNIT TYPE NUMBER
*              N     RWRK,UCBTYP        PICK UP UNIT TYPE NUMBER
*              IC    RWRK,DVCTIOFF(RWRK)  PICK UP OFFSET
DVCTIOFF DS    AL1                      OFFSET TO DVCT ENTRY
***********************************************************************
         SPACE 3
DVCT     DSECT ,                        FORMAT OF DVCT ENTRY
*              THE ENTRY IS LOCATED BY ADDING DVCTIOFF TO CVTZDTAB
         AGO   .ENTRY
.NODSECT ANOP
DVCT     DS    0H                       FORMAT OF DVCT ENTRY
.ENTRY   ANOP
*
DVCCYL   DS    H                        PHYS NO. CYL PER VOLUME
DVCTRK   DS    H                        NO. TRACKS PER CYLINDER
DVCTRKLN DS    H                        NO. OF BYTES PER TRACK
*
DVCOVHD  DS    0H                       BLOCK OVERHEAD IF DVC2BOV=1
*              USE FOLLOWING TWO CONSTANTS IF DVC2BOV=0
DVCOVNLB DS    XL1                      OVERHEAD NOT LAST BLOCK
DVCOVLB  DS    XL1                      OVERHEAD LAST BLOCK
*
DVCOVNK  DS    XL1                      OVERHEAD DECREMENT NOT KEYED
*
DVCFLAGS DS    BL1
DVC2BOV  EQU   X'08'                    IF 1, USE DVCOVHD
*                                       IF 0, USE DVCOVNLB,DVCOVLB
DVCFTOL  EQU   X'01'                    IF 1, APPLY TOLERANCE FACTOR
*
DVCTOL   DS    H                        TOLERANCE FACTOR
*              APPLY TOLERANCE FACTOR AS FOLLOWS:
*              1. ADD BLOCKSIZE AND KEYLENGTH
*              2. MULTIPLY BY DVCTOL
*              3. SHIFT RIGHT DVCTSHFT BITS
*              4. ADD APPROPRIATE OVERHEADS
DVCTSHFT EQU   9                        SHIFT AMT TO DIVIDE BY 512
*
DVCALT   DS    H                        NUMBER ALTERNATE TRKS/VOLUME
*
DVCENTLG EQU   *-DVCT                   BASIC SIZE OF DEVICE TABLE
*                                       ENTRY, NOT INCLUDING ADD'L
*                                       CHARACTERISTICS FOR RPS
**********************************************************************
*              THE FOLLOWING SECTION OF THE TABLE IS PRESENT         *
*              ONLY FOR RPS DEVICES--TEST UCBTBYT2 FOR UCB2OPT3      *
**********************************************************************
DVCRPS   DS    0CL4                     RPS SECTION
DVCOVR0  DS    H                        OVERHEAD BYTES FOR RECORD 0
DVCSECT  DS    XL1                      NUMBER SECTORS IN FULL TRACK
DVCSECTD DS    XL1                      NUMBER DATA SECTORS
*
*              END OF DVCT
         MEND
**/;
*
* DCL  1 DVCTI DVCIBASE,                /* INDEX TO DVCT             */
*        2 *   PTR(8),                  /* OFFSET TO ENTRY 0         */
*        2 DVCTIOFF (*) PTR(8);         /* OFFSETS TO ENTRIES 1 TO N */
*/*                                                                  */
*/*         USE THE LAST 4 BITS OF UCBTYP TO INDEX DVCTIOFF.         */
*/*         DVCTYPMK MAY BE USED AS A MASK TO 'AND' WITH UCBTYP.     */
*/*         THE INDEX ENTRIES ARE OFFSETS RELATIVE TO CVTZDTAB.      */
*/********************************************************************/
*
* DCL  1 DVCT DVCTBASE,                 /* FORMAT OF DVCT ENTRY      */
*        2 DVCCYL FIXED(15) UNSIGNED,   /* PHYS NO. CYL PER VOLUME   */
*        2 DVCTRK FIXED(15) UNSIGNED,   /* NO. TRACKS PER CYLINDER   */
*        2 DVCTRKLN FIXED(15) UNSIGNED, /* NO. BYTES PER TRACK       */
*
*        2 DVCOVHD FIXED(15),           /* BLOCK OVERHD IF DVC2BOV=1 */
*          /* USE THE FOLLOWING TWO CONSTANTS IF DVC2BOV=0           */
*          3 DVCOVNLB FIXED(8),         /* OVERHEAD NOT LAST BLOCK   */
*          3 DVCOVLB FIXED(8),          /* OVERHEAD FOR LAST BLOCK   */
*
*        2 DVCOVNK FIXED(8),            /* OVERHD DECREMENT NOT KEYED*/
*
*        2 DVCFLAGS BIT(8),
*          3 * BIT(4),                  /* RESERVED                  */
*          3 DVC2BOV BIT(1),            /* IF 1, USE DVCOVHD         */
*                                       /* IF 0, USE DVCOVNLB,OVLB   */
*          3 * BIT(2),                  /* RESERVED                  */
*          3 DVCFTOL BIT(1),            /* IF 1, APPLY TOLER FACTOR  */
*
*        2 DVCTOL FIXED(15) UNSIGNED,   /* TOLERANCE FACTOR          */
*/*         APPLY TOLERANCE AS FOLLOWS:                              */
*/*         (BLOCKSIZE+KEYLENGTH) * DVCTOL / DVCTSHFT + OVERHEADS    */
*
*        2 DVCALT FIXED(15),            /* NO. OF ALTERNATE TRACKS   */
*/********************************************************************/
*/*         THE FOLLOWING SETION OF THE TABLE IS PRESENT             */
*/*         ONLY FOR RPS DEVICES (UCB2OPT3=1)                        */
*/********************************************************************/
*        2 DVCRPS,                      /*RPS SECTION                */
*          3 DVCOVR0 FIXED(15),         /* OVERHD BYTES FOR RECORD 0 */
*          3 DVCSECT FIXED(8),          /* NO. SECTORS IN FULL TRACK */
*          3 DVCSECTD FIXED(8);         /* NO. OF DATA SECTORS       */
*/********************************************************************/
*
* DCL    DVCTSHFT FIXED(15) CONSTANT(512); /* DENOMINATOR FOR DVCTOL */
*/*         THE FOLLOWING CONSTANT CAN BE USED TO MASK OUT ALL BUT   */
*/*         THE DVCTIOFF SUBSCRIPT FROM THE UCB WORD UCBTYP          */
* DCL    DVCTYPMK BIT(32) CONSTANT('0000000F'X); /* UCBTYP MASK      */
*
*/*               END OF DVCT                                        */
