*%GOTO EXL001;                          /*                     Y02072*/
         MACRO
         IHAEXLST
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IHAEXLST
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = VS2 RELEASE 2 LEVEL 2
.*
.*01  DESCRIPTIVE-NAME = DCB EXIT LIST
.*
.*01  FUNCTION = USED TO DESCRIBE THE FORMAT OF THE DCB EXIT LIST.
.*
.*01  MODULE-TYPE = MACRO
.*
.*02    MACRO-SIZE = NA FOR MAPPING MACRO
.*
.*02    PARAMETER-RECEIVED = NONE
.*
.*01  TABLES = NONE
.*
.*01  INNER-MACROS = NONE
.*
.*01  SYSTEM-MACROS = NONE
.*
.*01  CHANGE-ACTIVITY = SEE BELOW
.*    VS2 REL 2
.*       MACRO CREATED
.*
.*
.**** END OF SPECIFICATIONS ***/
*%EXL001:;                              /*                     Y02072*/
* /* MACCOMP Y-2 SC1D0/SJD48            */
* /* MACSTAT Y-2 73124/021160           */
*%GOTO EXL002;                          /*                     Y02072*/
*
* THIS DSECT DEFINES THE VARIOUS TYPES OF EXIT LIST ENTRIES
* AND THE FORMAT OF EACH FULL WORD ENTRY OF A VARIABLE LENGTH
* EXIT LIST.
*
* DESCRIPTIVE LAYOUT
*      +0           +1
*       ___________________________________________________
*       |            |                                    |
*       | EXLIST     | ADDRESS OF EXIT                    |
*       | CODE       |                                    |
*       |____________|____________________________________|
*
         SPACE 2
EXLST    DSECT
EXLENTRA DS    0A                       SAME AS EXLENTRB BELOW
EXLCODES DS    B                        VARIOUS EXLST CODES
EXLINACT EQU   X'00'                    INACTIVE ENTRY
EXLIHLAB EQU   X'01'                    INPUT HEADER LABEL
EXLOHLAB EQU   X'02'                    OUTPUT HEADER LABEL
EXLITLAB EQU   X'03'                    INPUT TRAILER LABEL
EXLOTLAB EQU   X'04'                    OUTPUT TRAILER LABEL
EXLDCBEX EQU   X'05'                    DCB EXIT
EXLEOVEX EQU   X'06'                    END OF VOLUME EXIT
EXLUSTOT EQU   X'0A'                    USER''S TOTALING AREA ADDRESS
EXLBLCNT EQU   X'0B'                    UNEQUAL BLOCK COUNT EXIT
EXLDFRIT EQU   X'0C'                    DEFER PROCESSING OF USER INPUT
*                                         TRAILER LABEL
EXLDFNIT EQU   X'0D'                    DEFER PROCESSING A NONSTANDARD
*                                         INPUT TRAILER LABEL
EXLFCBIM EQU   X'10'                    DEFINE AN FCB IMAGE
EXLDCBAB EQU   X'11'                    ABEND EXIT
EXLLASTE EQU   X'80'                    LAST ENTRY IN LIST
EXLENTRB DS    AL3                      ADDRESS OF EXIT
EXLLENTH EQU   *-EXLENTRA               LENGTH OF DSECT (ONE ENTRY)
         MEND
*%EXL002:;                              /*                     Y02072*/
*/*                                                                  */
*/*THIS STRUCTURE DESCRIBES THE VARIOUS TYPES OF EXIT LIST ENTRIES   */
*/*AND THE FORMAT OF EACH FULL WORK ENTRY OF A VARIABLE LENGTH       */
*/*EXIT LIST.                                                        */
*/*                                                                  */
*/*DESCRIPTIVE LAYOUT                                                */
*/*    +0           +1                                               */
*/*     ___________________________________________________          */
*/*     |            |                                    |          */
*/*     | EXLIST     | ADDRESS OF EXIT                    |          */
*/*     | CODE       |                                    |          */
*/*     |____________|____________________________________|          */
*/*                                                                  */
*/*                                                                  */
*DCL 1 EXLST PTR(32) BASED,             /*                     Y02072*/
*      2 EXLENTRA PTR(31),              /*SAME AS EXLENTRB     Y02072*/
*        3 EXLCODES FIXED(8),           /*EXIT LIST CODES      Y02072*/
*           4 EXLLAST BIT(1),           /*BIT TO TST LAST ENTRYY02072*/
*        3 EXLENTRB PTR(24);            /*ADDRESS OF EXIT      Y02072*/
*/*                                                            Y02072*/
*/* THE FOLLOWING CONSTANTS REFER TO THE LABEL EXLCODES        Y02072*/
*/*                                                            Y02072*/
*DCL   EXLINACT FIXED(8) CONSTANT(0), /*INACTVE ENTRY          Y02072*/
*      EXLIHLAB FIXED(8) CONSTANT(1), /*INPUT HEAD LBL         Y02072*/
*      EXLOHLAB FIXED(8) CONSTANT(2), /*OUTPT HEAD LBL         Y02072*/
*      EXLITLAB FIXED(8) CONSTANT(3), /*IN TRAIL LBL           Y02072*/
*      EXLOTLAB FIXED(8) CONSTANT(4), /*OUT TRAIL LBL          Y02072*/
*      EXLDCBEX FIXED(8) CONSTANT(5), /*DCB EXIT               Y02072*/
*      EXLEOVEX FIXED(8) CONSTANT(6), /*EOV EXIT               Y02072*/
*      EXLUSTOT FIXED(8) CONSTANT(10), /*USER TOTALING         Y02072*/
*      EXLBLCNT FIXED(8) CONSTANT(11), /*UNEQUAL BLK CNT       Y02072*/
*      EXLDFRIT FIXED(8) CONSTANT(12), /*DEFER USR INPUT       Y02072*/
*                                      /*TRAILER LABEL PROCESS Y02072*/
*      EXLDFNIT FIXED(8) CONSTANT(13), /*DEFER PROCESS         Y02072*/
*                                      /*NONSTANDARD INPUT     Y02072*/
*                                      /*TRAILER LABEL         Y02072*/
*      EXLFCBIM FIXED(8) CONSTANT(16), /*DEFINE FCB IM         Y02072*/
*      EXLDCBAB FIXED(8) CONSTANT(17), /*ABEND EXIT            Y02072*/
*      EXLLASTE FIXED(8) CONSTANT(128), /*LAST ENTRY           Y02072*/
*      EXLLENTH FIXED(8) CONSTANT(4); /*LEN OF EXLST ENTRY     Y02072*/
