*%;/*
         MACRO
         IHAFCBIM &DSECT=YES,&LINES=0
.* /* START OF SPECIFICATIONS ****
.*
.*01  MODULE-NAME = IHAFCBIM
.*
.*01  COPYRIGHT = NONE
.*
.*01  STATUS = VS2 RELEASE 2 LEVEL 2
.*
.*01  CHANGE-ACTIVITY = STANDARDS UPGRADE
.*
.*01  DESCRIPTIVE-NAME = FORMS CONTROL BUFFER IMAGE
.*
.*01  FUNCTION = USED IN PLACE OF CARRIAGE TAPE FOR CERTAIN PRINTERS
.*
.*01  MODULE-TYPE = MACRO
.*
.*02    MACRO-SIZE = 150 STATEMENTS
.*
.*02    PARAMETER-RECEIVED = DSECT
.*
.*03      TYPE = CHARACTER STRING
.*
.*04        VALUE = YES OR NO
.*
.*02    PARAMETER-RECEIVED = LINES
.*
.*03      TYPE = NUMERIC
.*
.*04        VALUE = NUMBER OF LINES DESCRIBED
.*
.*01  TABLES = NONE
.*
.*01  INNER-MACROS = NONE
.*
.*01  SYSTEM-MACROS = NONE
.*
.**** END OF SPECIFICATIONS ***/
* /* MACCOMP Y-2 SC1D0/SJD48            */
* /* MACSTAT Y-2 73081/021160           */
*/********************************************************************/
*/*         FORMS CONTROL BUFFER IMAGE                               */
*/*                                                                  */
*/*   METHOD OF ACCESS                                               */
*/*     BAL  - TWO DSECTS ARE PRODUCED UNLESS DSECT=NO IS SPECIFIED. */
*/*         USING ON FCBIMAGE GIVES ADDRESSIBILITY TO ALL SYMBOLS    */
*/*         EXCEPT THOSE DESCRIBING A SINGLE ENTRY.                  */
*/*         USING ON FCBENTRY GIVES ADDRESSIBILITY TO ANY ENTRY.     */
*/*         WHEN DSECT=NO IS SPECIFIED,FCBENTRY CONTINUES TO EXPAND */
*/*         AS A DSECT, BUT THE REMAINING SYMBOLS ARE EXPANDED AS A  */
*/*         PART OF THE CURRENT CSECT OR DSECT, WITHOUT ALIGNMENT.   */
*/*         LINES=NN MAY BE USED TO CONTROL THE NUMBER OF ENTRIES    */
*/*         ALLOWED FOR IN FCBIMAGE. THE DEFAULT IS 0                */
*/*      PL/S - DCL FCBPTR AND FCBENPTR AS BASES FOR THE IMAGE AND   */
*/*         AND FOR AN INDIVIDUAL ENTRY.  DEFAULT IS SIMPLY BASED.   */
*/*                                                                  */
*/*    USE OF FCBIMAGE                                               */
*/*         THIS DSECT DESCRIBES AN FCB IMAGE THAT IS TO BE LOADED   */
*/*         INTO A PRINTER FORMS CONTROL BUFFER.                     */
*/*         THE MAPPING IS DIVIDED INTO THREE SEGMENTS, SOME OF      */
*/*         WHICH MAY NOT BE PRESENT.                                */
*/*         USER INTERFACE SEGMENT--PRESENT FOR IMAGES PASSED TO     */
*/*             OPEN OR SETPRT BY THEIR INVOKER                      */
*/*         IMAGE DESCRIPTOR SEGMENT--PRESENT IN SYS1.IMAGELIB       */
*/*             AND IN USER PROVIDED IMAGES                          */
*/*         IMAGE SEGMENT--ONLY THIS SEGMENT IS LOADED INTO THE      */
*/*             PRINTER BUFFER. IT IS ALWASY PRESENT                 */
*/*                                                                  */
*/*               USER INTERFACE SEGMENT                             */
*/*         __________________________________________________       */
*/*  0 (00) |                                                |       */
*/*         |                 FCBIMGID                       |       */
*/*         |________________________________________________|       */
*/*                                                                  */
*/*               IMAGE DESCRIPTOR SEGMENT                           */
*/*         _________________________                                */
*/*  4 (04) |           |           |                                */
*/*         | FCBDEFLT  |  FCBLENTH |                                */
*/*         |___________|___________|                                */
*/*                                                                  */
*/*                              IMAGE SEGMENT (WITHOUT INDEXING)    */
*/*                                 _________________________        */
*/*  4 (04)                         |           |                    */
*/*                                 |  FCBLINE1 |  VARIABLE          */
*/*         ________________________|___________|____________        */
*/*  8 (08)             |           |           |           |        */
*/*               NUMBER OF ONE BYTE ENTRIES                |        */
*/*         ____________|___________|___________|___________|        */
*/*                                                                  */
*/*                              IMAGE SEGMENT (WITH INDEXING)       */
*/*                                 _________________________        */
*/*  4 (04)                         |           |           |        */
*/*                                 |  FCBINDEX | FCBLNPI1  |        */
*/*         ________________________|___________|___________|        */
*/*  8 (08) |           |           |           |           |        */
*/*         |     VARIABLE NUMBER OF ONE BYTE ENTRIES       |        */
*/*         |___________|___________|___________|___________|        */
*/*                                                                  */
*/********************************************************************/
*%/*
         AIF   ('&DSECT' EQ 'NO').NODSCT
FCBIMAGE DSECT
         AGO   .CONT
.NODSCT  ANOP
FCBIMAGE DS    0C
.CONT    ANOP
*
*              USER INTERFACE SEGMENT
*
FCBIMGID DS    CL4                      FCB IMAGE IDENTIFIER
*
*              IMAGE DESCRIPTOR SEGMENT
*
FCBIMBEG DS    0C                       BEGINNING OF FCB
FCBDEFLT DS    B                        BYTE INDICATES IF IMAGE A DEFLT
FCBDEFYS EQU   X'80'                    IMAGE IS A DEFAULT
FCBDEFNO EQU   X'00'                    IMAGE IS NOT A DEFAULT
FCBLENTH DS    X                        BYTE CONTAINS LENGTH OF FCB
*                                         IMAGE
*
*              IMAGE SEGMENT
*
FCBLINE1 DS    0C                       FIRST LINE OF FCB IMAGE
FCBLNPIN DS    0B                       BYTE INDICATES NUMBER OF
*                                         LINES PER INCH (USE WHEN NO
*                                         INDEXING)
FCB8LINE EQU   X'10'                    EIGHT LINES PER INCH
FCB6LINE EQU   X'00'                    SIX LINES PER INCH
FCBINDEX DS    X                        BYTE INDICATES IF INDEXING
*                                         BEING USED
FCBRGTIN EQU   X'80'                    BIT FOR RIGHT INDEXING
FCBLFTIN EQU   X'40'                    BIT FOR LEFT INDEXING
FCBLNPN1 DS    0X                       SAME AS FCBLNPIN WITH INDEXING
*                                         BEING USED
         ORG   FCBLINE1                                          Y02072
FCBLINSG DS    &LINES.C                 AREA FOR LINE CODES      Y02072
*                                         WITHOUT INDEXING       Y02072
         ORG   FCBLINSG+1                                        Y02072
FCBLINS1 DS    &LINES.C                 AREA FOR LINE CODES      Y02072
*                                         WITH INDEXING          Y02072
*
*              EACH ENTRY DESCRIBES ONE LINE OF PRINTED PAGE
*
FCBENTRY DSECT                                                   Y02072
FCBLINE  DS    B                                                 Y02072
FCBLAST  EQU   X'10'                    ON IF LAST LINE OF PAGE  Y02072
*              NOTE: THIS BIT MAY ALSO BE ON FOR FIRST LINE
*                    OF PAGE. SEE FCB8LINE IN FCBLNPIN ABOVE
FCBCHAN  EQU   X'0F'                    MASK FOR CHANNEL NUMBER  Y02072
*                                       BINARY VALUE 1 TO 15
*                                       FOR SKIP COMMAND, OR 0
         MEND
**/;
* %IF FCBBASE = '' %THEN %FCBBASE = 'BASED';
* %IF FCBEBASE = '' %THEN %FCBEBASE = 'BASED';
*DCL  1  FCBIMAGE FCBBASE,              /*                     Y02072*/
*/*                  USER INTERFACE SEGMENT                          */
*        2  FCBIMGID CHAR(4),           /*FCB IMAGE IDENTIFIER Y02072*/
*/*                  IMAGE DESCRIPTOR SEGMENT                        */
*        2  FCBIMBEG,                   /*BEGINNING OF FCB     Y02072*/
*          3  FCBDEFLT CHAR(1),         /*IMAGE DEFAULT INDIC  Y02072*/
*            4 FCBDEFYS BIT(1),         /*IMAGE IS A DEFAULT   Y02072*/
*          3 FCBLENTH FIXED(8) UNSIGNED, /*LENGTH OF IMAGE     Y02072*/
*/*                  IMAGE SEGMENT                                   */
*        2  FCBLINE1,                   /*FIRST LINE OF FCB IM Y02072*/
*          3  FCBLNPIN CHAR(1),         /*LINE/INCH INDICATOR  Y02072*/
*                                       /*WITHOUT INDEXING     Y02072*/
*            4  * BIT(3),               /*RESERVED             Y02072*/
*            4  FCB8LINE BIT(1),        /*ON=8 LPI, OFF=6 LPI  Y02072*/
*              5  FCBINDEX CHAR(1),     /*INDEX BYTE           Y02072*/
*                6  FCBRGTIN BIT(1),    /*INDICATES RIGHT INDX Y02072*/
*                6  FCBLFTIN BIT(1),    /*INDICATES LEFT INDEX Y02072*/
*              5  FCBLNPN1 CHAR(1);     /*LINE/INCH INDICATOR  Y02072*/
*                                       /*WITH INDEXING        Y02072*/
*/*                                                                  */
*/*         EACH ENTRY DESCRIBES ONE LINE OF PRINTED PAGE            */
*/*                                                                  */
* DCL   1 FCBENTRY FCBEBASE,            /*                     Y02072*/
*        2 FCBLINE CHAR(1),             /*ONE BYTE PER LINE    Y02072*/
*          3 * BIT(3),                  /*RESERVED             Y02072*/
*          3 FCBLAST BIT(1),            /*ON IF LAST LINE      Y02072*/
*/*         NOTE: THIS BIT MAY ALSO BE ON FOR FIRST LINE             */
*/*               OF PAGE. SEE FCB8LINE IN FCBLNPIN ABOVE.           */
*          3 FCBCHAN BIT(4);            /*CHANNEL NUMBER 1 TO 15     */
