*        %GOTO PFTEPLS;                                              /*
         MACRO
         IHAPFTE &DSECT=YES
         AGO   .PFTBIT         DO NOT GENERATE PROLOGUE
***********************************************************************
*                                                                     *
* STATUS -                                                            *
*    CHANGE LEVEL 1                                                   *
* FUNCTION -                                                          *
*    MAPPING MACRO FOR PFTE                                           *
* ENTRY POINTS -                                                      *
*     IHAPFTE MACRO CALL                                              *
* INPUT -                                                             *
*    SEE IHAPFTE MACRO DEFINITION                                     *
* OUTPUT -                                                            *
*    PFTE MAPPING MACRO                                               *
* EXTERNAL REFERENCES -                                               *
*    N/A                                                              *
* EXITS, NORMAL -                                                     *
*    N/A                                                              *
* EXITS, ERROR -                                                      *
*    N/A                                                              *
* TABLES/WORK AREAS -                                                 *
*    N/A                                                              *
* ATTRIBUTES -                                                        *
*    BILINGUAL MACRO                                                  *
* CHARACTER CODE DEPENDENCY -                                         *
*    NONE                                                             *
* CHANGE-ACTIVITY -                                                   *
*    OZ31128                                                  @ZA31128*
* NOTES -                                                             *
*    NONE                                                             *
*                                                                     *
***********************************************************************
.PFTBIT  ANOP
         IEZBITS , -           DEFINE BITS
***********************************************************************
**                PAGE FRAME TABLE ENTRY       4/6/78                 *
**                                                                    *
**   THIS MACRO SUPPORTS: SU33                                @ZA31128*
**                                                                    *
**                                                                    *
**   ALL PFTES ARE CONTIGUOUS AND ARE LOCATED VIA DIRECT INDEX        *
**   ON THE HIGH ORDER 12 BITS OF ANY REAL ADDRESS. (THESE 12         *
**   BITS = PAGE FRAME NUMBER.) THE PAGE FRAME TABLE ENTRY            *
**   INDEX = PAGE FRAME NUMBER TIMES 16 (4 LOW ORDER BINARY ZEROS).   *
***********************************************************************
         AIF   ('&DSECT' EQ 'YES').PFT001 IS DSECT WANTED
PFTE     DS    0F
         AGO   .PFT002         BRANCH AROUND DSECT
.PFT001  ANOP                  GEN THE DESECT
PFTE     DSECT , PFTEPTR
.PFT002  ANOP
PFTPGID  DS    0F              AN IDENTIFIER OF THE VIRTUAL PAGE
*                              CURRENTLY OCCUPYING THIS FRAME.
*                              IF PFTIRRG IS 0, THIS FIELD IS
*                              SUBDIVIDED INTO PFTASID AND PFTVBN.
PFTASID  DS    XL2 -           THE ASID OF THE PAGE CURRENTLY
*                              OWNING THE FRAME
PFTVBN   DS    XL2 -           VIRTUAL BLOCK NUMBER  (HIGH
*                              ORDER 12 BITS OF 24 BIT VIRTUAL
*                              ADDRESS, LEFT ADJUSTED AND PADDED WITH
*                              4 LOW ORDER BINARY ZEROS) CURRENTLY
*                              OWNING THE REAL FRAME.
PFTQPTRS DS    0F              WORD CONTAINING PFTFQPTR AND PFTBQPTR
PFTFQPTR DS    H -             FORWARD PAGE FRAME QUEUE POINTER
*                              - THE PFTE INDEX OF THE NEXT ENTRY
*                              ON THIS PFQ
PFTBQPTR DS    H -             BACKWARD PAGE FRAME QUEUE POINTER
*                              - THE PFTE INDEX OF THE PREVIOUS
*                              ENTRY ON THIS PFQ
PFTFXCT  DS    H -             FIX COUNT OF THIS FRAME
PFTRSV1  DS    XL2 -           RESERVED
PFTFLAGS DS    0CL2 -          TWO PFTE FLAGS                  @G33VPOD
PFTFLAG1 DS    BL1 -           FIRST FLAG FIELD
PFTONAVQ EQU   BIT0 -          AVAILABLE FRAME QUEUE FLAG. WHEN 1,
*                              THIS PFTE IS ON AVAILABLE PFQ
PFTVRINT EQU   BIT1 -          WHEN 1, PFTE INTERCEPTED FOR V=R
PFTLSQA  EQU   BIT2 -          SQA/LSQA FLAG, WHEN 1, PAGE FRAME
*                              CONTAINS AN LSQA OR SQA PAGE. IF
*                              PFTASID=X'FFFF' THE FRAME CONTAINS A
*                              SQA PAGE.
PFTVRPLT EQU   BIT3 -          V=R AREA POLLUTED FLAG, WHEN 1, A
*                              REQUEST FOR A PREFERRED AREA FRAME WAS
*                              SATISFIED WITH THIS V=R FRAME.  @ZA31128
PFTPCBSI EQU   BIT4 -          PCB DEFINED FOR THIS PAGE FLAG, WHEN
*                              1, A PCB EXISTS FOR THIS PAGE.
PFTBADPG EQU   BIT5 -          BAD PAGE FRAME FLAG, WHEN 1, THIS PAGE
*                              FRAME MAY NOT BE ALLOCATED.
PFTVRALC EQU   BIT6 -          V = R ALLOCATED FLAG, WHEN 1, PFTE
*                              HAS BEEN ALLOCATED FOR A V=R REGION
PFTOFINT EQU   BIT7 -          WHEN 1, FRAME IS INTERCEPTED TO
*                              GO OFFLINE
PFTFLAG2 DS    BL1 -           SECOND FLAG FIELD
PFTDFRLS EQU   BIT0 -          DEFERRED RELEASE FLAG, WHEN 1, RELEASE
*                              HAS BEEN DEFERRED UNTIL THIS PAGE HAS
*                              BEEN FREED (PFTFXCT=0).
PFTOFFLN EQU   BIT1 -          FRAME ONLINE/OFFLINE FLAG, WHEN 1,
*                              FRAME IS OFFLINE
PFTVR    EQU   BIT2 -          V=R CANDIDATE, WHEN 1, FRAME MAY BE
*                              ALLOCATED TO A V=R REGION
PFTIRRG  EQU   BIT3 -          WHEN 1, INDICATES A VIO FRAME
PFTSTEAL EQU   BIT4 -          WHEN 1, INDICATES THIS PFTE SELECTED
*                              FOR STEALING, BUT HAS NOT BEEN STOLEN
*                              YET.
PFTPREF  EQU   BIT5 -          WHEN 1, INDICATES PFTE IN THE PREFERRED
*                              AREA                            @YD03005
PFTQNDX  DS    CL1 -           PFT QUEUE INDEX
PFTAFQN  EQU   X'00' -         PFTE ON AVAILABLE QUEUE
PFTSRQN  EQU   X'04' -         PFTE ON SQA RESERVED QUEUE
PFTCFQN  EQU   X'08' -         PFTE ON COMMON FRAME QUEUE
PFTSQAN  EQU   X'0C' -         PFTE ON SQA FRAME QUEUE
PFTRSBQN EQU   X'10' -         PFTE ON REAL STORAGE BUFFER (RSB)
*                              FRAME QUEUE                    @G33VPOD
PFTLFQN  EQU   X'80' -         PFTE ON LOCAL FRAME QUEUE
PFTLSQAN EQU   X'84' -         PFTE ON LSQA FRAME QUEUE
PFTNQN   EQU   X'FF' -         PFTE NOT QUEUED
PFTUIC   DS    FL1 -           NUMBER OF STEAL INTERVALS DURING WHICH
*                              THIS FRAME WAS NOT REFERENCED
PFTEND   DS    0C -            END OF PAGE FRAME TABLE ENTRY
PFTLEN   EQU   PFTEND-PFTE -   LENGTH OF PAGE TABLE ENTRY
         MEND  , */
*%PFTEPLS :  ;
* /*******************************************************************/
* /*                  PAGE FRAME TABLE ENTRY       4/6/78            */
* /*                                                                 */
* /* THIS MACRO SUPPORTS: SU33                               @ZA31128*/
* /*                                                                 */
* /*                                                                 */
* /* ALL PFTES ARE CONTIGUOUS AND ARE LOCATED VIA DIRECT INDEX       */
* /* ON THE HIGH ORDER 12 BITS OF ANY REAL ADDRESS. (THESE 12        */
* /* BITS = PAGE FRAME NUMBER.) THE PAGE FRAME TABLE ENTRY           */
* /* INDEX = PAGE FRAME NUMBER TIMES 16 (4 LOW ORDER BINARY ZEROS).  */
* /*******************************************************************/
*DCL
*  PFTAFQN  BIT(8) CONSTANT('00'X), /* PFTE ON AVAILABLE QUEUE       */
*  PFTSRQN  BIT(8) CONSTANT('04'X), /* PFTE ON SQA RESERVE QUEUE     */
*  PFTCFQN  BIT(8) CONSTANT('08'X), /* PFTE ON COMMON FRAME QUEUE    */
*  PFTSQAN  BIT(8) CONSTANT('0C'X), /* PFTE ON SQA FRAME QUEUE       */
*  PFTRSBQN BIT(8) CONSTANT('10'X), /* PFTE ON REAL STORAGE BUFFER
*                                      (RSB) FRAME QUEUE     @G33VPOD*/
*  PFTLFQN  BIT(8) CONSTANT('80'X), /* PFTE ON LOCAL FRAME QUEUE     */
*  PFTLSQAN BIT(8) CONSTANT('84'X), /* PFTE ON LSQA FRAME QUEUE      */
*  PFTNQN   BIT(8) CONSTANT('FF'X); /* PFTE NOT QUEUED.              */
*      %IF PFT9999^=','             /* IS BLOCK PART OF STRUCTURE    */
*          %THEN %PFT9999=';';      /* NO, END BLOCK NORMALLY        */
*      %IF PFTLEVEL^=''             /* INITIAL LEVEL NUMBER GIVEN    */
*          %THEN %GOTO PFTPLS1;     /* YES THEN DO NOT GEN 1 LEVEL   */
*%PFTPLS0: ;
* /*******************************************************************/
* /*                     PFTE MAPPING                                */
* /*******************************************************************/
*DECLARE
*  1 PFTE BASED(PFTEPTR)
*      %GOTO PFTPLS2;               /*SKIP USER-GIVEN LEVEL          */
*%PFTPLS1: PFTDUM=PFTLEVEL||' PFTE';
*  PFTDUM
*%PFTPLS2:;
*   BDY (WORD),
*    4 PFTPGID  FIXED(32),          /* AN IDENTIFIER OF THE VIRTUAL
*                                      PAGE CURRENTLY OCCUPYING THIS
*                                      FRAME. IF PFTIRRG IS 0, THIS
*                                      FIELD IS SUBDIVIDED INTO
*                                      PFTASID AND PFTVBN.           */
*      8 PFTASID FIXED(16),         /* THE ASID OF THE PAGE CURRENTLY
*                                      OWNING THIS FRAME             */
*      8 PFTVBN BIT(16),            /* VIRTUAL BLOCK NUMBER (HIGH
*                                      ORDER 12 BITS OF 24 BIT VIRTUAL
*                                      ADDRESS, LEFT ADJUSTED AND
*                                      PADDED WITH 4 LOW-ORDER BINARY
*                                      ZEROES) CURRENTLY OWNING THE
*                                      FRAME.                        */
*    4 PFTQPTRS BIT(32),            /* WORD CONTAINING PFTFQPTR AND
*                                      PFTBQPTR                      */
*      8 PFTFQPTR BIT(16),          /* FORWARD PAGE FRAME QUEUE
*                                      POINTER  - THE PFTE INDEX OF
*                                      THE NEXT ENTRY ON THIS PFQ    */
*      8 PFTBQPTR BIT(16),          /* BACKWARD PAGE FRAME QUEUE
*                                      POINTER  - THE PFTE INDEX OF
*                                      THE PREVIOUS FRAME            */
*    4 PFTFXCT FIXED(15),           /* FIX COUNT OF THIS FRAME       */
*    4 PFTRSV1 CHAR(2),             /* RESERVED                      */
*    4 PFTFLAGS CHAR(2),            /* TWO FLAG FIELDS       @G33VPOD*/
*    8 PFTFLAG1 BIT(8),             /* FIRST FLAG FIELD              */
*     12 PFTONAVQ BIT(1),           /* AVAILABLE FRAME QUEUE FLAG.
*                                      WHEN 1, THIS PFTE IS ON
*                                      AVAILABLE PFQ                 */
*     12 PFTVRINT BIT(1),           /* WHEN 1, PFTE INTERCEPTED FOR
*                                      USE IN A V=R REGION           */
*     12 PFTLSQA BIT(1),            /* SQA/LSQA FLAG, WHEN 1, PAGE
*                                      FRAME  CONTAINS AN LSQA OR SQA
*                                      PAGE. IF PFTASID=X'FFFF' THE
*                                      FRAME CONTAINS A SQA PAGE.    */
*     12 PFTVRPLT BIT(1),           /* V=R AREA POLLUTED FLAG, WHEN 1,
*                                      A REQUEST FOR A PREFERRED AREA
*                                      FRAME WAS SATISFIED WITH THIS
*                                      V=R FRAME.           @ZA31128*/
*     12 PFTPCBSI BIT(1),           /* PCB DEFINED FOR THIS PAGE
*                                      FLAG, WHEN  1, A PCB EXISTS
*                                      FOR THIS PAGE                 */
*     12 PFTBADPG BIT(1),           /* BAD PAGE FRAME FLAG. WHEN 1,
*                                      THIS PAGE FRAME MAY NOT BE
*                                      ALLOCATED.                    */
*     12 PFTVRALC BIT(1),           /* V = R ALLOCATED FLAG, WHEN 1,
*                                      FRAME IS ALLOCATED TO A
*                                      V=R REGION                    */
*     12 PFTOFINT BIT(1),           /* OFFLINE INTERCEPT FLAG. WHEN
*                                      1, THE FRAME IS INTERCEPTED
*                                      TO GO OFFLINE                 */
*    8 PFTFLAG2 BIT(8),             /* SECOND FLAG FIELD             */
*     12 PFTDFRLS BIT(1),           /* DEFERRED RELEASE FLAG, WHEN 1,
*                                      RELEASE HAS BEEN DEFERRED
*                                      UNTIL THIS PAGE HAS BEEN FREED
*                                      (PFTFXCT=0).                  */
*     12 PFTOFFLN BIT(1),           /* FRAME ONLINE/OFFLINE FLAG, WHEN
*                                      1, FRAME IS OFFLINE           */
*     12 PFTVR BIT(1),              /* V=R CANDIDATE, WHEN 1, FRAME
*                                      MAY BE ALLOCATED TO A V=R
*                                      REGION                        */
*     12 PFTIRRG BIT(1),            /* WHEN 1, INDICATES A VIO FRAME */
*     12 PFTSTEAL BIT(1),           /* WHEN 1, THIS PFTE SELECTED FOR
*                                      STEALING, BUT HAS NOT BEEN
*                                      STOLEN YET.                   */
*     12 PFTPREF BIT(1),            /* WHEN 1, PFTE IS IN THE PREFERRED
*                                      AREA                  @YD03005*/
*     12 * BIT(1),                  /* RESERVED                      */
*     12 * BIT(1),                  /* RESERVED                      */
*    4 PFTQNDX CHAR(1),             /* PFT QUEUE INDEX               */
*    4 PFTUIC FIXED(8) PFT9999      /* NUMBER OF STEAL INTERVALS
*                                      DURING WHICH THIS FRAME WAS
*                                      NOT REFERENCED                */
*      %PFTLEN='LENGTH(PFTE)';      /* LENGTH OF PFTE                */
