*/*******************************************************************/
*/*   IHASCE                                                        */
*/*           MACCOMP - SC1CM                                       */
*/*           MACSTAT - @G17SP2F                                    */
*/*                     @G33NPHE    SLIP NODUMP 12/30/76            */
*/*           MACMEAN - SCE MEANS SLIP CONTROL ELEMENT              */
*/*     THIS MACRO MAPS THE SCE. THE SCE, WITH THE VARIABLE AREA    */
*/*     (SEE IHASCVA), IS THE INTERNAL REPRESENTATION OF THE SLIP   */
*/*     OPERATOR COMMAND.  SCE'S ARE MATCHED AGAINST SYSTEM         */
*/*     CONDITIONS IN ORDER TO DETERMINE SLIP TRAP QUALIFICATION.   */
*/*     THE MOST RECENTLY SET TRAP (SCE) IS MATCHED FIRST. STORAGE  */
*/*     IS FROM FIXED SQA (SP245). IEECB905 GETS, BUILDS, AND       */
*/*     FREES THE SCE.                                              */
*/*******************************************************************/
     DCL 1 SCE BASED(SCEPTR) BDY(DWORD),
           2 SCECBID    CHAR(4),       /* CONTROL BLOCK ID = SCE     */
           2 *          CHAR(4),       /* RESERVED                   */
         2 SCECTRFW  CHAR(8) BDY(WORD),/* TO DELETE AN ENTRY,MUST CDS*/
             3 SCECTR   PTR(31),       /* PROCESSOR SERIALIZATION CTR*/
             3 SCEFWD   PTR(31),       /* FORWARD SCE CHAIN PRT      */
           2 SCEBKWD    PTR(31),       /* BACKWARD SCE CHAIN PTR     */
           2 SCEFLG1    BIT(8),        /* FLAGS                      */
             3 SCEDSABL BIT(1),        /* OFF=ENABLED,ON=DISABLED    */
             3 SCEDELP  BIT(1),        /* DELETE IS PENDG ON PREV SCE*/
             3 SCEEVERY BIT(1),        /* OFF=MODE ANY,ON=MODE EVERY */
             3 SCESVCD  BIT(1),        /* ACTION IS SVC DUMP         */
             3 SCEWAIT  BIT(1),        /* ACTION IS WAIT             */
             3 SCEIGNOR BIT(1),        /* ACTION IS IGNORE           */
             3 SCENODMP BIT(1),        /* ACTION IS NODUMP   @G33NPHE*/
             3 *        BIT(1),        /* RESERVED           @G33NPHE*/
           2 SCERRTYP   BIT(8),        /* ERRTYP FLAGS               */
             3 SCEMACH  BIT(1),        /* MACHINE CHECK              */
             3 SCEPROG  BIT(1),        /* PROGRAM CHECK INTERRUPT    */
             3 SCEREST  BIT(1),        /* RESTART INTERRUPT          */
             3 SCEABEND BIT(1),        /* ABEND                      */
             3 SCEMEMTM BIT(1),        /* MEMORY TERMINATION         */
             3 SCESVCER BIT(1),        /* SVC ERROR                  */
             3 SCEDAT   BIT(1),        /* DAT ERROR                  */
             3 SCEPGIO  BIT(1),        /* PAGING I/O ERROR           */
           2 SCEMODE    BIT(16),       /* MODE FLAGS                 */
             3 SCEMODE1 BIT(8),        /* FIRST EIGHT                */
               4 SCESUPR  BIT(1),      /* SUPERVISOR CONTROL MODE    */
               4 SCEDIS   BIT(1),      /* DISABLED                   */
               4 SCEGLSP  BIT(1),      /* GLOBAL SPIN LOCK           */
               4 SCEGLSD  BIT(1),      /* GLOBAL SUSPEND LOCK        */
               4 SCELLOC  BIT(1),      /* LOCAL LOCK                 */
               4 SCETYP1  BIT(1),      /* TYPE 1 SVC                 */
               4 SCESRB   BIT(1),      /* SRB                        */
               4 SCETCB   BIT(1),      /* TCB                        */
             3 SCEMODE2 BIT(8),        /* SECOND EIGHT               */
               4 SCERECV  BIT(1),      /* RECOVERY IN CONTROL        */
               4 SCEPP    BIT(1),      /* PROBLEM PROGRAM STATE      */
               4 SCESUPER BIT(1),      /* SUPERVISOR STATE           */
               4 SCESKEY  BIT(1),      /* SYSTEM KEY                 */
               4 SCEPKEY  BIT(1),      /* PROBLEM PROGRAM KEY        */
               4 SCEGLOC  BIT(1),      /* ANY GLOBAL LOCK            */
               4 SCELOCK  BIT(1),      /* ANY LOCK                   */
               4 *        BIT(1),      /* RESERVED                   */
           2 *          CHAR(3),       /* RESERVED                   */
           2 SCEUCMP    CHAR(1),       /* CONSOLE ID OF ISSUER       */
           2 SCEID      CHAR(4),       /* TRAP IDENTIFIER            */
           2 SCESCVA    PTR(31);       /* PTR TO THE SCVA            */
