*          %GOTO SPCTPLS;                                              /
*
***********************************************************************
*                                                                     *
* STATUS -                                                            *
*    CHANGE LEVEL 0 (OS/VS2 REL 4 VERSION)                            *
* FUNCTION -                                                          *
*    MAPPING MACRO FOR SWAP CONTROL TABLE                             *
* ENTRY POINTS -                                                      *
*     IHASPCT MACRO CALL                                              *
* INPUT -                                                             *
*    SEE IHASPCT MACRO DEFINITION                                     *
* OUTPUT -                                                            *
*    SWAP CONTROL TABLE MAPPING MACRO                                 *
* EXTERNAL REFERENCES -                                               *
*    N/A                                                              *
* EXITS, NORMAL -                                                     *
*    N/A                                                              *
* EXITS, ERROR -                                                      *
*    N/A                                                              *
* TABLES/WORK AREAS -                                                 *
*    N/A                                                              *
* ATTRIBUTES -                                                        *
*    PLS ONLY MACRO                                                   *
* CHARACTER CODE DEPENDENCY -                                         *
*    NONE                                                             *
* NOTES -                                                             *
*    NONE                                                             *
*                                                                     *
**********************************************************************/
*%SPCTPLS :  ;
*/********************************************************************/
*/*   SWAP COMMUNICATIONS TABLE MAPPING FOR VS2/4.   LEVEL  4/11/75. */
*/********************************************************************/
*        %IF SPCT9999 ^= ','        /* IF THIS IS LAST BLOCK         */
*          %THEN %SPCT9999 = ';';   /* THEN CLOSE DCL STATEMENT      */
*        %IF SPCTLEVL ^= ''         /* IF THIS IS CONCATENATED       */
*          %THEN %GOTO SPCTPLS1;    /* THEN SKIP DCL                 */
*DCL 1 SPCT BASED (SPCTPTR)         /* DECLARE SPCT LEVEL 1          */
*        %GO TO SPCTPLS2;           /* AND SKIP LEVEL TWO DCL        */
*%SPCTPLS1: SPCTDUM=SPCTLEVL ||' SPCT'; /* SET LEVEL FOR MINOR       */
*    SPCTDUM                        /* MINOR STRUCTURE NAME PARM     */
*%SPCTPLS2:;
*        BDY(WORD),
*    4 SPCTSWRT  PTR(31),   /* VSA OF THE SWAP IN ROOT PCB IF SPCTSWIN
*                             = 1. VSA OF SWAP OUT WORK PCB IF
*                             SPCTOUT = 1.                           */
*    4 SPCTFIX  FIXED(15), /* NUMBER OF FIX ENTRIES IN THIS SPCT     */
*    4 SPCTLSQA FIXED(15), /* NUMBER OF LSQA ENTRIES IN THIS SPCT    */
*    4 SPCTNSEG FIXED(8),  /* NUMBER OF SEGMENT ENTRIES THAT CAN BE
*                             HELD IN THIS SPCT                      */
*    4 SPCTSSEG FIXED(8),  /* NUMBER OF ACTIVE SEGMENT ENTRIES IN
*                             THIS SPCT. THERE IS ONE ENTRY FOR EACH
*                             ACTIVE PRIVATE AREA SEGMENT.           */
*    4 SPCTFLG1 BIT(8),    /* SPCT FLAG BYTE                         */
*        8 SPCTSWIN BIT(1),/* 1 - SWAP-IN IN PROGRESS                */
*        8 SPCTOUT  BIT(1),/* 1 - SWAP OUT IN PROGRESS               */
*        8 SPCTPURG BIT(1),/* 1 - PAGING WAS PURGED DURING SWAP OUT  */
*        8 SPCTBIG  BIT(1),/* 1 - THERE EXISTS ONE OR MORE FIX ENTRIES
*                             WITH A FIX COUNT GREATER THAN 255      */
*        8 SPCTPSET BIT(1),/* 1 - PAGE DATASET USED FOR LSQA PAGES ON
*                             LAST SWAP OUT. 0 - SWAP DATASET USED FOR
*                             LSQA PAGES ON LAST SWAP OUT.   @Z40WPYD*/
*       8 SPCTVROT BIT(1), /*1 - SWAP OUT HAS BEEN REQUESTED
*                            BY VEQRP          @ZA10767*/
*        8 *        BIT(2),/* RESERVED BIT FLAGS @ZA10767            */
*    4 SPCTIDEN CHAR(1),                /* IEAVITAS WILL SET TO SPCT ID
*                                          CHARACTER 'S'     @Z40WPYD*/
*    4 SPCTWSSZ FIXED(15), /* WORKING SET SIZE                       */
*    4 SPCTSIZE FIXED(15), /* THE SIZE IN BYTES OF THE SPCT          */
*    4 SPCTSWAP CHAR(56),  /* THIS AREA AND EVERY EXTENSION IS MAPPED
*                             BY SPCTEXTM                    @Z40WPYD*/
*                          /* SPCTSWAP CONTAINS A MAXIMUM OF 6 FIX SWAP
*                             ENTRIES OR 8 LSQA SWAP ENTRIES OR A
*                             COMBINATION OF THE TWO NOT EXCEEDING
*                             48 BYTES. ALL LSQA ENTRIES PRECEDE ALL
*                             FIX ENTRIES.                   @Z40WPYD*/
*    4 SPCTSEGS(*) CHAR(96) SPCT9999 /* AN AREA CONTAINING A LIST OF
*                             SEGMENT ENTRIES FOR THE ADDRESS SPACE.
*                             AS SEGMENTS ARE CREATED OR DESTROYED FOR
*                             THE ADDRESS SPACE THIS AREA EXPANDS OR
*                             CONTRACTS AS REQUIRED IN INCREMENTS OF
*                             96 BYTES (6 BYTES PER ACTIVE SEGMENT). */
*        %SPCTLEN = 'LENGTH(SPCT)'; /* OBTAIN LENGTH OF SPCT         */
*%SPCTPLS3: ;
* /*******************************************************************/
* /*                     SEGMENT ENTRY MAPPING                       */
* /*******************************************************************/
* DCL 1 SPCTSEGE CHAR(6) BDY(HWORD) BASED(SEGSPTR),/* DECLARE BASE FOR
*                             ENTRY  */
*    4 SPCTSEGX PTR(8),    /* CORRESPONDING INDEX INTO SEGMENT TABLE
*                             FOR THIS ENTRY.                        */
*    4 SPCTPGT  BIT(24),   /* VSA OF PAGE TABLE FOR SEGMENT IDENTIFIED
*                             IN INDEX.                              */
*    4 SPCTBITM BIT(16);   /* BIT MAP REPRESENTING PRIVATE AREA SEGMENT
*                             EACH PAGE MAPS TO A UNIQUE FLAG BIT.
*                             1 - PAGE IS TO BE SWAPPED IN.          */
*%SPCTPLS4: ;
* /*******************************************************************/
* /*                  FIX OR LSQA ENTRY MAPPING                      */
* /*******************************************************************/
* DCL 1 SPCTSWPE CHAR(8) BDY(HWORD) BASED(SWAPPTR),/* DECLARE BASE
*                                   FOR ENTRY                        */
*    4 SPCTLS,                  /* REFERENCE TO BEGINNING OF A LSQA
*                                  ENTRY.                            */
*         8 SPCTFLAG BIT(8), /* SPCT FLAG BITS.              @Z40WPYD*/
*           12 SPCTLVAL BIT(1), /*1=LSID IN SPCTSSID IS VALID  @Z40WPYD
*                                                                    */
*           12 SPCTLSQ  BIT(1), /*1=THIS IS A 6 BYTE LSQA ENTRY, ELSE,
*                                 THIS IS AN 8 BYTE FIXED ENTRY.
*                                                            @Z40WPYD*/
*           12 SPCTCOMM BIT(1), /*1=VBN IS FOR COMMON AREA   @Z40WPYD*/
*           12 SPCTDEFR BIT(1), /*1=PAGE WAS FLAGGED DEFER RELEASE AT
*                                 SWAP TIME.                 @Z40WPYD*/
*           12 *        BIT(4), /*RESERVED                   @Z40WPYD*/
*         8 SPCTSSID CHAR(3),   /*THREE BYTE LSID            @Z40WPYD*/
*         8 SPCTVBN  BIT(16),   /*VBN AND RESERVED BITS      @Z40WPYD*/
*    4 SPCTFIXC FIXED(15); /* FIX COUNT ASSOCIATED WITH FIX ENTRY.
*                             THIS FIELD DOESN'T EXIST FOR LSQA ENTRY*/
*%SPCTPLS5: ;
* /*******************************************************************/
* /*              SPCTSWAP AND SPCT EXTENSION MAPPING                */
* /*******************************************************************/
* DCL 1 SPCTEXTM CHAR(56) BDY(WORD) BASED,/* DECLARE STRUCTURE BASED
*                                                            @Z40WPYD*/
*         4 SPCTEXT PTR(31),    /* ADDRESS OF NEXT EXTENSION         */
*         4 *       CHAR(4),    /* RESERVED                  @Z40WPYD*/
*         4 SPCTENT CHAR(48),   /* FIX AND LSQA ENTRIES              */
*             8 SPCTENTS(8)CHAR(6), /* LSQA AND FIXED SWAP ENTRIES.
*                                                            @Z40WPYD*/
*             8 SPCTXEND CHAR(0); /* END OF EXTENSION                */
