         TITLE 'IKJCT462   OUTPUT COMMAND JOB PROCESSOR                *
                        '
IKJCT462 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IKJCT462  74.364'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  LA    @11,4095(,@12)                                      0001
         USING @PSTART,@12                                         0001
         USING @PSTART+4095,@11                                    0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @10,@01                                             0001
         USING @DATD,@10                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @00,@01,20(@13)                                     0001
         ST    @10,8(,@13)                                         0001
         LR    @13,@10                                             0001
         XC    @ZTEMPS(@ZLEN),@ZTEMPS
         MVC   @PC00001(4),0(@01)                                  0001
*                                                                  0089
*/********************************************************************/
*/*                                                                  */
*/*  THE BASIC FLOW OF IKJCT462, THE JOB PROCESSOR, CAN BE OBTAINED  */
*/*  FROM THE FOLLOWING SECTION OF CODE:                             */
*/*                                                                  */
*/*          1. INITIALIZE OUTCOMTB'S BASE                           */
*/*          2. IF IKJCT469 HAS NO MORE JOBS TO PROCESS, INVOKE      */
*/*             SUBSYSTEM FOR FINAL CALL TO INDICATE PROCESSING      */
*/*             COMPLETE, THEN RETURN IKJCT469                       */
*/*          3. SET UP SSOB & SSSO CONTROL BLOCKS                    */
*/*          4. INVOKE THE SUBSYSTEM TO LOCATE, ROUTE, OR DELETE     */
*/*             A SYSOUT DATA SET                                    */
*/*          5. IF PRINT REQUESTED, ALLOCATE THE SYSOUT DATA SET,    */
*/*             READ SYSOUT & WRITE TO DATA SET, UNALLOCATE THE      */
*/*             SYSOUT DATA SET                                      */
*/*          6. RETURN TO CALLER                                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0089
*   OCMTBPTR=OPTR;                  /* INIT BASE OF OUTCOMTB (USE A
*                                      REGISTER FOR EFFICIENCY) WITH
*                                      PTR PASSED AS A PARM          */
*                                                                  0089
         L     @14,@PC00001                                        0089
         L     OCMTBPTR,OPTR(,@14)                                 0089
*   /*****************************************************************/
*   /*                                                               */
*   /* IF NO MORE WORK TO DO FOR THE PREVIOUS JOB- ISSUE FINAL CALL  */
*   /* TO SUBSYSTEM FOR THIS JOB                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0090
*   IF NOWORK=ON THEN               /* NO MORE WORK TO DO            */
         TM    NOWORK(OCMTBPTR),B'00000010'                        0090
         BNO   @RF00090                                            0090
*     CALL FINISH;                  /* INVOKE SUBSYS - FINAL CALL    */
*                                                                  0091
         BAL   @14,FINISH                                          0091
*   /*****************************************************************/
*   /*                                                               */
*   /* ELSE WORK TO DO - PROCESS THE JOB                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0092
*   ELSE                            /* JOB TO PROCESS - GET BUSY     */
*     DO;                                                          0092
         B     @RC00090                                            0092
@RF00090 DS    0H                                                  0093
*       SKIPDS=OFF;                 /* INIT SWITCH TO ZERO           */
         NI    SKIPDS,B'01111111'                                  0093
*       SKIPGET=OFF;                /* INIT SWITCH TO ZERO           */
         NI    SKIPGET,B'01111111'                                 0094
*       SUBSYS=OFF;                 /* INIT SWITCH TO ZERO           */
*                                                                  0095
         NI    SUBSYS(OCMTBPTR),B'01111111'                        0095
*       /*************************************************************/
*       /*                                                           */
*       /* INITIALIZE THE SUBSYSTEM CONTROL BLOCKS                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0096
*       CALL INITSSSO;              /* CALL RTN TO SET UP SSOB & SSSO
*                                      CTL BLKS                      */
         BAL   @14,INITSSSO                                        0096
*       FIRSTIME=ON;                /* SET SWITCH FOR FIRST CALL TO
*                                      SUBSYS FOR A JOB/CLASS      0097
*                                      COMBINATION-USED TO DECIDE  0097
*                                      WHAT SSOBRETN=4 MEANS (NO DS
*                                      OR NO MORE DS)                */
         OI    FIRSTIME,B'10000000'                                0097
*       LOOP=YES;                   /* INIT LOOP CONTROL-ALWAYS GO 0098
*                                      THRU CODE AT LEAST ONCE. FOR
*                                      DELETING OR ROUTINE, DON'T  0098
*                                      LOOP TO SUBSYS AS FOR       0098
*                                      PRINTING.                     */
*                                                                  0098
         OI    LOOP,B'10000000'                                    0098
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS THE JOB IKJCT469 PASSED: 1) IF GROUP REQUEST, NEED*/
*       /* ONLY CALL SUBSYSTEM ONCE. 2) IF PRINT REQUEST, CALL THE   */
*       /* SUBSYSTEM TO GET A DATA SET. PROCESS IT, THEN LOOP BACK TO*/
*       /* THE SUBSYSTEM AND GET ANOTHER SYSOUT DATASET. CONTINUE    */
*       /* LOOPING UNTIL NO MORE DATASETS.                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0099
*       DO WHILE ERROR=NO&ENDSW=NO&SSOBRETN=ZERO&LOOP=YES;/* THIS  0099
*                                      LOOP WILL ACCESS SYSOUT DATA
*                                      SETS FOR A JOB/CLASS UNTIL: AN
*                                      ERROR OCCURS, END IS        0099
*                                      REQUESTED, OR NO MORE DATA  0099
*                                      SETS CAN BE FOUND. FOR GROUP
*                                      REQUESTS THE LOOP IS EXECUTED
*                                      ONCE.                         */
         B     @DE00099                                            0099
@DL00099 DS    0H                                                  0100
*         CALL SUBSYSTM;            /* CALL RTN TO SET-UP & INVOKE 0100
*                                      SUBSYS & CHECK RETURN CODE    */
         BAL   @14,SUBSYSTM                                        0100
*         FIRSTIME=OFF;             /* NO LONGER 1ST CALL TO SUBSYS  */
         NI    FIRSTIME,B'01111111'                                0101
*         IF ERROR=NO&PRINT=YES&SSOBRETN=ZERO THEN/* NO ERROR & A  0102
*                                      SYSOUT DATASET WAS FOUND      */
         TM    ERROR(OCMTBPTR),B'00001000'                         0102
         BNZ   @RF00102                                            0102
         TM    PRINT(OCMTBPTR),B'00000010'                         0102
         BNO   @RF00102                                            0102
         L     @14,OUTSOBH(,OCMTBPTR)                              0102
         L     @14,SSOBRETN(,@14)                                  0102
         LTR   @14,@14                                             0102
         BNZ   @RF00102                                            0102
*           CALL ALLOCSO;           /* CALL RTN TO ALLOCATE THE    0103
*                                      SYSOUT DS                     */
         BAL   @14,ALLOCSO                                         0103
*         IF ERROR=NO&PRINT=YES&SSOBRETN=ZERO THEN/* SYSOUT WAS ALLOC
*                                      & PRINT REQUESTED             */
@RF00102 TM    ERROR(OCMTBPTR),B'00001000'                         0104
         BNZ   @RF00104                                            0104
         TM    PRINT(OCMTBPTR),B'00000010'                         0104
         BNO   @RF00104                                            0104
         L     @14,OUTSOBH(,OCMTBPTR)                              0104
         L     @14,SSOBRETN(,@14)                                  0104
         LTR   @14,@14                                             0104
         BNZ   @RF00104                                            0104
*           CALL PRINTRTN;          /* CALL RTN TO READ SYSOUT &   0105
*                                      WRITE RCDS TO PRINT DS        */
         BAL   @14,PRINTRTN                                        0105
*         IF ALLOC=YES THEN         /* SYSOUT WAS ALLOCATED          */
@RF00104 TM    ALLOC(OCMTBPTR),B'00000100'                         0106
         BNO   @RF00106                                            0106
*           CALL UNALCSO;           /* CALL RTN TO DETERMINE THE   0107
*                                      UNALLOCATION DISPOSITION &  0107
*                                      UNALLOC IT APPROPRIATELY      */
         BAL   @14,UNALCSO                                         0107
*       END;                        /* END OF DO WHILE LOOP TO     0108
*                                      RETRIEVE SYSOUT DATA SETS     */
*                                                                  0108
@RF00106 DS    0H                                                  0108
@DE00099 TM    ERROR(OCMTBPTR),B'00011000'                         0108
         BNZ   @DC00099                                            0108
         L     @14,OUTSOBH(,OCMTBPTR)                              0108
         L     @14,SSOBRETN(,@14)                                  0108
         LTR   @14,@14                                             0108
         BNZ   @DC00099                                            0108
         TM    LOOP,B'10000000'                                    0108
         BO    @DL00099                                            0108
@DC00099 DS    0H                                                  0109
*       /*************************************************************/
*       /*                                                           */
*       /* IF EARLY TERMINATION DUE TO END SUBCMD OR ERROR, WHILE    */
*       /* PROCESSING A PRINT REQUEST ISSUE FINAL CALL TO SUBSYSTEM. */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0109
*       IF SUBSYS=YES&(ENDSW=YES|ERROR=YES) THEN/* EARLY TERMINATION
*                                      PROCESSING A SET OF DATASETS.
*                                      EITHER END SUBCMD OR ERROR.   */
         TM    SUBSYS(OCMTBPTR),B'10000000'                        0109
         BNO   @RF00109                                            0109
         TM    ENDSW(OCMTBPTR),B'00011000'                         0109
         BZ    @RF00109                                            0109
*         CALL FINISH;              /* RETURN TO SUBSYS WHEN DONE  0110
*                                      WITH DATA SETS IN THIS      0110
*                                      JOB/CLASS COMBINATION         */
         BAL   @14,FINISH                                          0110
*     END;                          /* END OF CODE TO PROCESS JOB    */
@RF00109 DS    0H                                                  0112
*   RETURN CODE(RETNCODE);          /* RETURN TO IKJCT469            */
@RC00090 L     @05,RETNCODE                                        0112
         L     @13,4(,@13)                                         0112
         L     @00,@SIZDATD                                        0112
         LR    @01,@10                                             0112
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@05                                             0112
         L     @14,12(,@13)                                        0112
         LM    @00,@12,20(@13)                                     0112
         BR    @14                                                 0112
*                                                                  0113
*/********************************************************************/
*/*                                                                  */
*/*      INITIALIZE THE NECESSARY SSOB FIELDS                        */
*/*      SET UP THE SSSO FLAGS & FIELDS BASED ON THE FUNCTION        */
*/*         REQUESTED (PRINT, DELETE, ETC.).                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0113
*INITSSSO:                                                         0113
*   PROC;                           /* INTERNAL PROCEDURE TO       0113
*                                      INITIALIZE SSOB & SSSO        */
@EL00001 L     @13,4(,@13)                                         0113
@EF00001 L     @00,@SIZDATD                                        0113
         LR    @01,@10                                             0113
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0113
         BR    @14                                                 0113
INITSSSO STM   @14,@12,12(@13)                                     0113
*   SSOBFUNC=SSOBSOUT;              /* SSOB HEADER REQUESTS LOCATE 0114
*                                      FUNCTION FROM SUBSYSTEM       */
         L     @14,OUTSOBH(,OCMTBPTR)                              0114
         MVC   SSOBFUNC(2,@14),@CH00033                            0114
*   SSOBINDV=ADDR(SSSO);            /* SSOB HEADER POINTS TO THE   0115
*                                      LOCATE FUNCTION CNTRL BLK     */
         L     @05,OUTSOBSO(,OCMTBPTR)                             0115
         ST    @05,SSOBINDV(,@14)                                  0115
*   SSOBRETN=SSOBRETN&&SSOBRETN;    /* INIT TO ZERO                  */
         L     @02,SSOBRETN(,@14)                                  0116
         LR    @09,@02                                             0116
         XR    @09,@02                                             0116
         ST    @09,SSOBRETN(,@14)                                  0116
*   SSSO=SSSO&&SSSO;                /* INIT TO ZERO                  */
         XC    SSSO(120,@05),SSSO(@05)                             0117
*   SSSOLEN=LENGTH(SSSO);           /* LENGTH OF SSSO SECTION        */
*                                                                  0118
         MVC   SSSOLEN(2,@05),@CH01559                             0118
*   /*****************************************************************/
*   /*                                                               */
*   /* SET SELECTION CRITERIA BITS AND FIELDS IN SSSO                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0119
*   SSSOSHLD=ON;                    /* INCLUDE HELD SYSOUT DS        */
*   SSSOSJBN=ON;                    /* USE JOBNAME                   */
         OI    SSSOSHLD(@05),B'10010000'                           0120
*   SSSOJOBN=JOBNAME(1:JOBNLEN);    /* PASS JOBNAME TO SUBSYSTEM.  0121
*                                      JOBNAME FOUND IN PDE.         */
         MVI   SSSOJOBN+1(@05),C' '                                0121
         MVC   SSSOJOBN+2(6,@05),SSSOJOBN+1(@05)                   0121
         L     @14,OUTJBPDE(,OCMTBPTR)                             0121
         LH    @02,JOBNLEN(,@14)                                   0121
         BCTR  @02,0                                               0121
         L     @09,JOBNMPTR(,@14)                                  0121
         EX    @02,@SM01575                                        0121
*   IF JOBIDLEN^=ZERO THEN          /* USER GAVE A JOBID             */
         LH    @02,JOBIDLEN(,@14)                                  0122
         LTR   @02,@02                                             0122
         BZ    @RF00122                                            0122
*     DO;                                                          0123
*       SSSOSJBI=ON;                /* USE JOBID                     */
         OI    SSSOSJBI(@05),B'00001000'                           0124
*       SSSOJOBI=JOBID(1:JOBIDLEN); /* PASS JOBID TO SUBSYSTEM. JOBID
*                                      IN PDE.                       */
         MVI   SSSOJOBI+1(@05),C' '                                0125
         MVC   SSSOJOBI+2(6,@05),SSSOJOBI+1(@05)                   0125
         BCTR  @02,0                                               0125
         L     @14,JOBIDPTR(,@14)                                  0125
         EX    @02,@SM01578                                        0125
*     END;                                                         0126
*   ELSE                                                           0127
*     ;                             /* NO JOBID GIVEN                */
@RF00122 DS    0H                                                  0128
*   IF CLASBUFF^=BLANKS THEN        /* USER ENTERED A CLASSNAME      */
         CLC   CLASBUFF(8,OCMTBPTR),@CC01391                       0128
         BE    @RF00128                                            0128
*     DO;                                                          0129
*       SSSOSCLS=ON;                /* USE CLASS                     */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0130
         OI    SSSOSCLS(@14),B'01000000'                           0130
*       SSSOCLSL=CLASBUFF;          /* CLASS(ES) TO CHOOSE           */
         MVC   SSSOCLSL(8,@14),CLASBUFF(OCMTBPTR)                  0131
*     END;                                                         0132
*   ELSE                                                           0133
*     ;                             /* USE SUBSYS CLASS DEFAULT WHICH
*                                      IS ALL HELD CLASSES           */
*                                                                  0133
@RF00128 DS    0H                                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* SET OTHER BITS AND FIELDS UNIQUE TO SPECIFIC FUNCTIONS        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0134
*   IF PRINT=YES THEN               /* PRINT REQUESTED               */
         TM    PRINT(OCMTBPTR),B'00000010'                         0134
         BNO   @RF00134                                            0134
*     SSSOCTRL=OFF;                 /* SUBSYSTEM TO RETURN A DATA SET
*                                      NAME                          */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0135
         NI    SSSOCTRL(@14),B'01111111'                           0135
*   ELSE                                                           0136
*     IF DELETE=YES THEN            /* DELETE REQUESTED              */
         B     @RC00134                                            0136
@RF00134 TM    DELETE(OCMTBPTR),B'00000100'                        0136
         BNO   @RF00136                                            0136
*       DO;                                                        0137
*         SSSODELC=ON;              /* SUBSYSTEM TO DELETE DS        */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0138
         OI    SSSODELC(@14),B'01000000'                           0138
*         SSSOCTRL=ON;              /* A 'DELETE' GROUP REQUEST IS 0139
*                                      REALLY A FINAL REQUEST        */
         OI    SSSOCTRL(@14),B'10000000'                           0139
*       END;                                                       0140
*     ELSE                          /* A ROUTING REQUEST             */
*       DO;                                                        0141
         B     @RC00136                                            0141
@RF00136 DS    0H                                                  0142
*         SSSOCTRL=ON;              /* A 'ROUTING' GROUP REQUEST IS
*                                      REALLY A FINAL REQUEST        */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0142
         OI    SSSOCTRL(@14),B'10000000'                           0142
*         IF NEWCLASS=YES THEN      /* NEWCLASS KEYWORD SPECIFIED    */
         TM    NEWCLASS(OCMTBPTR),B'00000001'                      0143
         BNO   @RF00143                                            0143
*           DO;                                                    0144
*             SSSOSETC=ON;          /* SUBSYSTEM TO CHANGE CLASS     */
         OI    SSSOSETC(@14),B'10000000'                           0145
*             SSSOCLAS=NEWCLAS;     /* NEWCLASS CLASS                */
         L     @05,ONEWCPDE(,OCMTBPTR)                             0146
         L     @05,NEWCLPTR(,@05)                                  0146
         MVC   SSSOCLAS(1,@14),NEWCLAS(@05)                        0146
*           END;                                                   0147
*         IF DEST=YES THEN          /* DEST KEYWORD SPECIFIED        */
@RF00143 TM    DEST(OCMTBPTR),B'01000000'                          0148
         BNO   @RF00148                                            0148
*           DO;                                                    0149
*             SSSOROUT=ON;          /* SUBSYSTEM TO ROUTE TO DEST    */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0150
         OI    SSSOROUT(@14),B'00100000'                           0150
*             SSSODEST=' ';         /* BLANK DESTID FIELD            */
         MVI   SSSODEST+1(@14),C' '                                0151
         MVC   SSSODEST+2(6,@14),SSSODEST+1(@14)                   0151
         MVI   SSSODEST(@14),C' '                                  0151
*             SSSODEST(1:DESTLEN)=DESTID(1:DESTLEN);/* REMOTE USERID */
         L     @05,ODESTPDE(,OCMTBPTR)                             0152
         LH    @02,DESTLEN(,@05)                                   0152
         BCTR  @02,0                                               0152
         L     @05,DESTPTR(,@05)                                   0152
         EX    @02,@SM01582                                        0152
*           END;                                                   0153
*         IF HOLD=YES THEN          /* HOLD KEYWORD SPECIFIED        */
@RF00148 TM    HOLD(OCMTBPTR),B'01000000'                          0154
         BNO   @RF00154                                            0154
*           SSSOHOLD=ON;            /* SUBSYSTEM SHOULD HOLD DS      */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0155
         OI    SSSOHOLD(@14),B'00010000'                           0155
*         ELSE                      /* NOHOLD SPECIFIED OR DEFAULTED */
*           SSSORLSE=ON;            /* SUBSYS SHOULD RELEASE DS      */
         B     @RC00154                                            0156
@RF00154 L     @14,OUTSOBSO(,OCMTBPTR)                             0156
         OI    SSSORLSE(@14),B'00001000'                           0156
*       END;                                                       0157
*   END INITSSSO;                                                  0158
@EL00002 DS    0H                                                  0158
@EF00002 DS    0H                                                  0158
@ER00002 LM    @14,@12,12(@13)                                     0158
         BR    @14                                                 0158
*                                                                  0159
*/********************************************************************/
*/*                                                                  */
*/*    INVOKE THE SUBSYSTEM TO:                                      */
*/*      LOCATE SYSOUT DATA SETS FOR THE JOB/CLASS COMBINATION       */
*/*        PASSED BY IKJCT469.                                       */
*/*      DELETE SYSOUT DATA SETS IN THE JOB/CLASSLIST PASSED.        */
*/*      ROUTE SYSOUT DATA SETS IN THE JOB/CLASSLIST PASSED.         */
*/*      ANALYZE THE RETURN CODE FROM THE SUBSYSTEM AND TAKE         */
*/*        APPROPRIATE ACTION.                                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0159
*SUBSYSTM:                                                         0159
*   PROC;                           /* INTERNAL PROCEDURE TO INVOKE
*                                      THE SUBSYSTEM                 */
SUBSYSTM STM   @14,@12,@SA00003                                    0159
*/********************************************************************/
*/*   INVOKE SUBSYSTEM TO PERFORM THE REQUESTED FUNCTION             */
*/********************************************************************/
*                                                                  0160
*   REG1=ADDR(OUTSOBH);             /* PASS SSOB PTR TO SUBSYSTEM    */
         LA    REG1,OUTSOBH(,OCMTBPTR)                             0160
*   HASPABND=ON;                    /* IN CASE SUBSYS ABENDS, TELL 0161
*                                      ESTAE EXIT                    */
         OI    HASPABND(OCMTBPTR),B'00000001'                      0161
*/*  ? IEFSSREQ;                                                     */
*/*                                                                  */
*/*  PASS CONTROL TO JOB ENTRY SUBSYSTEM TO                          */
*/*  PROCESS REQUEST -                                               */
*/*                                                                  */
*/*    INPUT - REGISTER 1 POINTS TO A ONE-                           */
*/*            WORD PARAMETER LIST WHICH                             */
*/*            POINTS TO THE SSOB                                    */
*/*                                                                  */
*                                                                  0162
*   CALL SSREQ;                     /* INVOKE SUBSYSTEM              */
         L     @05,CVTPTR                                          0162
         L     @05,CVTJESCT(,@05)                                  0162
         L     @15,JESSSREQ(,@05)                                  0162
         BALR  @14,@15                                             0162
*   HASPABND=OFF;                   /* NO LONGER IN SUBSYS           */
         NI    HASPABND(OCMTBPTR),B'11111110'                      0163
*   OUTRTCD=REG15;                  /* SAVE SUBSYSTEM RETURN CODE    */
         STH   REG15,OUTRTCD(,OCMTBPTR)                            0164
*   SSSOCHKP=OFF;                   /* TURN OFF IN CASE SET BY     0165
*                                      PREVIOUS CALL                 */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0165
         NI    SSSOCHKP(@14),B'10111111'                           0165
*                                                                  0166
*/********************************************************************/
*/*  ANALYZE THE SUBSYSTEM RETURN CODE                               */
*/********************************************************************/
*                                                                  0166
*   IF OUTRTCD=SSRTOK THEN          /* SUBSYSTEM COMPLETED OK        */
*                                                                  0166
         SLR   @14,@14                                             0166
         LH    @05,OUTRTCD(,OCMTBPTR)                              0166
         CR    @05,@14                                             0166
         BNE   @RF00166                                            0166
*     /***************************************************************/
*     /*                                                             */
*     /* SUBSYSTEM RETURN CODE IS ZERO                               */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0167
*     DO;                           /* CHECK SSOBRETN FIELD          */
*       IF SSOBRETN=SSSORTOK THEN   /* SSOBRETN=0 - COMPLETED OK     */
*                                                                  0168
         L     @05,OUTSOBH(,OCMTBPTR)                              0168
         C     @14,SSOBRETN(,@05)                                  0168
         BNE   @RF00168                                            0168
*         /***********************************************************/
*         /*                                                         */
*         /* SSOBRETN IS ZERO (SYSOUT DSN WAS RETURNED)              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0169
*         DO;                                                      0169
*           RETNCODE=ZERO;          /* TELL 69 TO PASS NEXT JB/CL    */
         ST    @14,RETNCODE                                        0170
*           WORKDONE=YES;           /* WORK DONE FOR THIS JOB.     0171
*                                      IKJCT469 INITS THIS BIT FOR 0171
*                                      1ST CALL TO '62 FOR EACH    0171
*                                      JOBNAME.                      */
         OI    WORKDONE(OCMTBPTR),B'00010000'                      0171
*           IF PRINT=YES THEN       /* IF PRINT FUNCTION,            */
         TM    PRINT(OCMTBPTR),B'00000010'                         0172
         BNO   @RF00172                                            0172
*             SUBSYS=ON;            /* INDICATE SUBSYS PROCESSING A
*                                      SET OF DATA SETS              */
         OI    SUBSYS(OCMTBPTR),B'10000000'                        0173
*           ELSE                    /* ELSE DELETE OR ROUTE FUNC     */
*             LOOP=NO;              /* FOR ROUTING, DONT LOOP TO   0174
*                                      SUBSYS, GO BACK TO IKJCT469 IN
*                                      CASE MORE CLASSES FOR THIS  0174
*                                      JOB, OR ANOTHER JOB TO PROCESS*/
         B     @RC00172                                            0174
@RF00172 NI    LOOP,B'01111111'                                    0174
*         END;                                                     0175
*       ELSE                        /* SSOBRETN NON ZERO             */
*                                                                  0176
*         /***********************************************************/
*         /*                                                         */
*         /* SSOBRETN IS NON ZERO - FIND OUT WHAT IT IS              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0176
*         IF SSOBRETN=SSSOEODS THEN /* SSOBRETN=4 - NO DATASETS OR NO
*                                      MORE DATASETS                 */
*                                                                  0176
         B     @RC00168                                            0176
@RF00168 L     @14,OUTSOBH(,OCMTBPTR)                              0176
         CLC   SSOBRETN(4,@14),@CF00053                            0176
         BNE   @RF00176                                            0176
*           /*********************************************************/
*           /*                                                       */
*           /* SSOBRETN=4 (NO DATASETS OR NO MORE DATASETS)          */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0177
*           DO;                                                    0177
*             IF PRINT=YES THEN     /* PRINT REQUESTED       @ZM30982*/
         TM    PRINT(OCMTBPTR),B'00000010'                         0178
         BNO   @RF00178                                            0178
*               IF FIRSTIME=YES&CLASBUFF^=BLANKS THEN/* CLASS      0179
*                                      REQUESTED BUT NO HELD OUTPUT
*                                                            @ZM30982*/
         TM    FIRSTIME,B'10000000'                                0179
         BNO   @RF00179                                            0179
         CLC   CLASBUFF(8,OCMTBPTR),@CC01391                       0179
         BE    @RF00179                                            0179
*                 DO;               /*                       @ZM30982*/
*                   OUTMSGID=56;    /* ISSUE MSG 320I SINCE ONLY 1 0181
*                                      CLASS SEARCHED AND NO HELD  0181
*                                      OUTPUT                @ZM30982*/
         MVI   OUTMSGID(OCMTBPTR),X'38'                            0181
*                   CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER    0182
*                                                            @ZM30982*/
         ST    OCMTBPTR,@AL00001                                   0182
         L     @15,@CV01406                                        0182
         LA    @01,@AL00001                                        0182
         BALR  @14,@15                                             0182
*                   RETNCODE=ZERO;  /* TELL 69 TO PASS NEXT JB/CL  0183
*                                      COMBINATION           @ZM30982*/
         SLR   @14,@14                                             0183
         ST    @14,RETNCODE                                        0183
*                 END;              /*                       @ZM30982*/
*               ELSE                /*                       @ZM30982*/
*                 IF FIRSTIME=YES&CLASBUFF=BLANKS THEN/* ALL HELD  0185
*                                      CLASSES SEARCHED BUT NO OUTPUT
*                                                            @ZM30982*/
         B     @RC00179                                            0185
@RF00179 TM    FIRSTIME,B'10000000'                                0185
         BNO   @RF00185                                            0185
         CLC   CLASBUFF(8,OCMTBPTR),@CC01391                       0185
         BNE   @RF00185                                            0185
*                   DO;             /*                       @ZM30982*/
*                     OUTMSGID=60;  /* ISSUE MSG 339I SINCE ALL    0187
*                                      CLASSES SEARCHED BUT NO OUTPUT
*                                                            @ZM30982*/
         MVI   OUTMSGID(OCMTBPTR),X'3C'                            0187
*                     CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER  0188
*                                                            @ZM30982*/
         ST    OCMTBPTR,@AL00001                                   0188
         L     @15,@CV01406                                        0188
         LA    @01,@AL00001                                        0188
         BALR  @14,@15                                             0188
*                     RETNCODE=FOUR;/* TELL 69 TO PASS NEXT JOB    0189
*                                                            @ZM30982*/
         MVC   RETNCODE(4),@CF00053                                0189
*                   END;            /*                       @ZM30982*/
*                 ELSE              /* NO MORE DATA SETS FOR THIS  0191
*                                      JOB/CLASS             @ZM30982*/
*                   RETNCODE=ZERO;  /* TELL 69 TO PASS NEXT JB/CL  0191
*                                      COMBINATION           @ZM30982*/
         B     @RC00185                                            0191
@RF00185 SLR   @14,@14                                             0191
         ST    @14,RETNCODE                                        0191
*             ELSE                  /* DELETE OR ROUTE REQUESTED   0192
*                                                            @ZM30982*/
*               IF ENDLIST=YES&WORKDONE=NO&CLASBUFF^=BLANKS THEN/* 0192
*                                      LAST CALL FOR THIS JOB AND NO
*                                      WORK ACCOMPLISHED FOR GIVEN 0192
*                                      CLASS(ES)             @ZM30982*/
         B     @RC00178                                            0192
@RF00178 TM    ENDLIST(OCMTBPTR),B'00001000'                       0192
         BNO   @RF00192                                            0192
         TM    WORKDONE(OCMTBPTR),B'00010000'                      0192
         BNZ   @RF00192                                            0192
         CLC   CLASBUFF(8,OCMTBPTR),@CC01391                       0192
         BE    @RF00192                                            0192
*                 DO;               /*                       @ZM30982*/
*                   OUTMSGID=64;    /* ISSUE MSG 343I, SINCE NO    0194
*                                      OUTPUT IN CLASSES REQUESTED 0194
*                                                            @ZM30982*/
         MVI   OUTMSGID(OCMTBPTR),X'40'                            0194
*                   CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER    0195
*                                                            @ZM30982*/
         ST    OCMTBPTR,@AL00001                                   0195
         L     @15,@CV01406                                        0195
         LA    @01,@AL00001                                        0195
         BALR  @14,@15                                             0195
*                   RETNCODE=FOUR;  /* TELL 69 TO PASS NEXT JOB    0196
*                                                            @ZM30982*/
         MVC   RETNCODE(4),@CF00053                                0196
*                 END;              /*                       @ZM30982*/
*               ELSE                /*                       @ZM30982*/
*                 IF ENDLIST=YES&WORKDONE=NO&CLASBUFF=BLANKS THEN/*
*                                      LAST AND ONLY CALL FOR THIS 0198
*                                      JOB-NO CLASS GIVEN & ALL HELD
*                                      CLASSES SEARCHED      @ZM30982*/
         B     @RC00192                                            0198
@RF00192 TM    ENDLIST(OCMTBPTR),B'00001000'                       0198
         BNO   @RF00198                                            0198
         TM    WORKDONE(OCMTBPTR),B'00010000'                      0198
         BNZ   @RF00198                                            0198
         CLC   CLASBUFF(8,OCMTBPTR),@CC01391                       0198
         BNE   @RF00198                                            0198
*                   DO;             /*                       @ZM30982*/
*                     OUTMSGID=60;  /* ISSUE MSG M339, SINCE NO    0200
*                                      OUTPUT IN ANY HELD CLASSES  0200
*                                                            @ZM30982*/
         MVI   OUTMSGID(OCMTBPTR),X'3C'                            0200
*                     CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER  0201
*                                                            @ZM30982*/
         ST    OCMTBPTR,@AL00001                                   0201
         L     @15,@CV01406                                        0201
         LA    @01,@AL00001                                        0201
         BALR  @14,@15                                             0201
*                     RETNCODE=FOUR;/* TELL 69 TO PASS NEXT JOB    0202
*                                                            @ZM30982*/
         MVC   RETNCODE(4),@CF00053                                0202
*                   END;            /*                       @ZM30982*/
*                 ELSE              /* NOT LAST CALL FOR THIS JOB  0204
*                                                            @ZM30982*/
*                   RETNCODE=ZERO;  /* TELL 69 TO PASS NEXT JB/CL  0204
*                                      COMBINATION           @ZM30982*/
         B     @RC00198                                            0204
@RF00198 SLR   @14,@14                                             0204
         ST    @14,RETNCODE                                        0204
*           END;                                                   0205
*         ELSE                      /* CHECK FURTHER                 */
*           IF SSOBRETN=SSSONJOB THEN/* SSOBRETN=8 - NO JOB FOUND    */
*                                                                  0206
         B     @RC00176                                            0206
@RF00176 L     @14,OUTSOBH(,OCMTBPTR)                              0206
         CLC   SSOBRETN(4,@14),@CF00047                            0206
         BNE   @RF00206                                            0206
*             /*******************************************************/
*             /*                                                     */
*             /* SSOBRETN=8 (NO JOB FOUND)                           */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0207
*             DO;                                                  0207
*               IF PRINT=YES THEN   /* PRINT REQUESTED               */
         TM    PRINT(OCMTBPTR),B'00000010'                         0208
         BNO   @RF00208                                            0208
*                 DO;                                              0209
*                   IF WORKDONE=NO THEN/* NO JOB FOUND AND NO WORK 0210
*                                      ACCOMPLISHED                  */
         TM    WORKDONE(OCMTBPTR),B'00010000'                      0210
         BNZ   @RF00210                                            0210
*                     DO;                                          0211
*                       RETNCODE=FOUR;/* TELL '69 TO PASS NEXT JOB   */
         MVC   RETNCODE(4),@CF00053                                0212
*                       OUTMSGID=102;/* ISSUE MSG 340I-JOB NOT FND   */
         MVI   OUTMSGID(OCMTBPTR),X'66'                            0213
*                     END;                                         0214
*                   ELSE            /* JOB NOT FOUND, BUT PREVIOUS 0215
*                                      WORK ACCOMPLISHED BEFORE DATA
*                                      PRINTED AND JOB PURGED        */
*                     DO;                                          0215
         B     @RC00210                                            0215
@RF00210 DS    0H                                                  0216
*                       RETNCODE=ZERO;/* TELL '69 TO PASS NEXT CLASS
*                                      WITH THIS JOB                 */
         SLR   @14,@14                                             0216
         ST    @14,RETNCODE                                        0216
*                       OUTMSGID=56;/* ISSUE MSG 320I-NO OUTPUT IN 0217
*                                      THIS CLASS            @ZM30892*/
         MVI   OUTMSGID(OCMTBPTR),X'38'                            0217
*                     END;                                         0218
*                   CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER      */
@RC00210 ST    OCMTBPTR,@AL00001                                   0219
         L     @15,@CV01406                                        0219
         LA    @01,@AL00001                                        0219
         BALR  @14,@15                                             0219
*                 END;              /* END OF PRINT PROCESSING FOR 0220
*                                      RC=8                          */
*               ELSE                /* DELETE OR ROUTE REQUEST       */
*                 DO;                                              0221
         B     @RC00208                                            0221
@RF00208 DS    0H                                                  0222
*                   RETNCODE=FOUR;  /* TELL '69 TO PASS NEXT JOB     */
         MVC   RETNCODE(4),@CF00053                                0222
*                   IF WORKDONE=NO THEN/* NO JOB FOUND AND NO WORK 0223
*                                      ACCOMPLISHED BEFORE           */
         TM    WORKDONE(OCMTBPTR),B'00010000'                      0223
         BNZ   @RF00223                                            0223
*                     DO;                                          0224
*                       OUTMSGID=102;/* ISSUE MSG 340I-JOB NOT FOUND */
         MVI   OUTMSGID(OCMTBPTR),X'66'                            0225
*                       CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER  */
         ST    OCMTBPTR,@AL00001                                   0226
         L     @15,@CV01406                                        0226
         LA    @01,@AL00001                                        0226
         BALR  @14,@15                                             0226
*                     END;                                         0227
*                   ELSE                                           0228
*                     ;             /* JOB NO LONGER FOUND, BUT WORK
*                                      WAS ACCOMPLISHED BEFORE       */
@RF00223 DS    0H                                                  0229
*                 END;              /* END OF ROUTE REQUEST        0229
*                                      PROCESSING FOR RC=8           */
*             END;                                                 0230
*           ELSE                    /* CHECK FURTHER                 */
*             IF SSOBRETN=SSSOINVA THEN/* SSOBRETN=12 - INV SRCH ARG */
*                                                                  0231
         B     @RC00206                                            0231
@RF00206 LA    @14,12                                              0231
         L     @05,OUTSOBH(,OCMTBPTR)                              0231
         L     @05,SSOBRETN(,@05)                                  0231
         CR    @05,@14                                             0231
         BNE   @RF00231                                            0231
*               /*****************************************************/
*               /*                                                   */
*               /* SSOBRETN=12 (INVALID SEARCH ARGS)                 */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0232
*               DO;                                                0232
*                 RETNCODE=TWELVE;  /* QUIT COMMAND                  */
         ST    @14,RETNCODE                                        0233
*                 ERROR=YES;        /* SEVERE ERROR                  */
         OI    ERROR(OCMTBPTR),B'00001000'                         0234
*                 OUTRTCD=SSOBRETN; /* SAVE SSOBRETN CODE FOR '67    */
         STH   @05,OUTRTCD(,OCMTBPTR)                              0235
*                 OUTMSGID=146;     /* ISSUE MSG 358I                */
         MVI   OUTMSGID(OCMTBPTR),X'92'                            0236
*                 CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER        */
         ST    OCMTBPTR,@AL00001                                   0237
         L     @15,@CV01406                                        0237
         LA    @01,@AL00001                                        0237
         BALR  @14,@15                                             0237
*               END;                                               0238
*             ELSE                  /* CHECK FURTHER                 */
*               IF SSOBRETN=SSSOUNAV THEN/* SSOBRETN=16 - UNABLE TO
*                                      PROCESS JOB NOW               */
*                                                                  0239
         B     @RC00231                                            0239
@RF00231 L     @14,OUTSOBH(,OCMTBPTR)                              0239
         CLC   SSOBRETN(4,@14),@CF00101                            0239
         BNE   @RF00239                                            0239
*                 /***************************************************/
*                 /*                                                 */
*                 /* SSOBRETN=16 (UNABLE TO PROCESS JOB NOW)         */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0240
*                 DO;                                              0240
*                   RETNCODE=FOUR;  /* TELL 69 TO PASS NEXT JOB      */
         MVC   RETNCODE(4),@CF00053                                0241
*                   OUTMSGID=129;   /* ISSUE MSG 350I                */
         MVI   OUTMSGID(OCMTBPTR),X'81'                            0242
*                   CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER      */
         ST    OCMTBPTR,@AL00001                                   0243
         L     @15,@CV01406                                        0243
         LA    @01,@AL00001                                        0243
         BALR  @14,@15                                             0243
*                 END;                                             0244
*               ELSE                /* CHECK FURTHER                 */
*                 IF SSOBRETN=SSSODUPJ THEN/* SSOBRETN=20 - DUP    0245
*                                      JOBNAMES                      */
*                                                                  0245
         B     @RC00239                                            0245
@RF00239 L     @14,OUTSOBH(,OCMTBPTR)                              0245
         CLC   SSOBRETN(4,@14),@CF00813                            0245
         BNE   @RF00245                                            0245
*                   /*************************************************/
*                   /*                                               */
*                   /* SSOBRETN=20 (DUPLICATE JOB NAMES)             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0246
*                   DO;                                            0246
*                     RETNCODE=FOUR;/* TELL 69 TO PASS NEXT JOB      */
         MVC   RETNCODE(4),@CF00053                                0247
*                     OUTMSGID=136; /* ISSUE MSG 348I                */
         MVI   OUTMSGID(OCMTBPTR),X'88'                            0248
*                     CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER    */
         ST    OCMTBPTR,@AL00001                                   0249
         L     @15,@CV01406                                        0249
         LA    @01,@AL00001                                        0249
         BALR  @14,@15                                             0249
*                   END;                                           0250
*                 ELSE              /* CHECK FURTHER                 */
*                   IF SSOBRETN=SSSOINVJ THEN/* SSOBRETN=24 - INV  0251
*                                      JOBNAME- JOBID COMBINATION    */
*                                                                  0251
         B     @RC00245                                            0251
@RF00245 L     @14,OUTSOBH(,OCMTBPTR)                              0251
         CLC   SSOBRETN(4,@14),@CF00182                            0251
         BNE   @RF00251                                            0251
*                     /***********************************************/
*                     /*                                             */
*                     /* SSOBRETN=24 (INVALID JOBNAME/JOBID)         */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0252
*                     DO;                                          0252
*                       RETNCODE=FOUR;/* TELL 69 TO PASS NEXT JOB    */
         MVC   RETNCODE(4),@CF00053                                0253
*                       OUTMSGID=137;/* ISSUE MSG 349I               */
         MVI   OUTMSGID(OCMTBPTR),X'89'                            0254
*                       CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER  */
         ST    OCMTBPTR,@AL00001                                   0255
         L     @15,@CV01406                                        0255
         LA    @01,@AL00001                                        0255
         BALR  @14,@15                                             0255
*                     END;                                         0256
*                   ELSE            /* CHECK FURTHER                 */
*                     IF SSOBRETN=SSSOIDST THEN/* SSOBRETN=28 -    0257
*                                      INVALID DESTID                */
*                                                                  0257
         B     @RC00251                                            0257
@RF00251 L     @14,OUTSOBH(,OCMTBPTR)                              0257
         L     @14,SSOBRETN(,@14)                                  0257
         CH    @14,@CH00823                                        0257
         BNE   @RF00257                                            0257
*                       /*********************************************/
*                       /*                                           */
*                       /* SSOBRETN=28 (INVALID DESTID)              */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0258
*                       DO;                                        0258
*                         RETNCODE=TWELVE;/* QUIT COMMAND            */
         MVC   RETNCODE(4),@CF00034                                0259
*                         ERROR=YES;/* SEVERE ERROR                  */
         OI    ERROR(OCMTBPTR),B'00001000'                         0260
*                         OUTRTCD=SSOBRETN;/* SAVE SSOBRETN CODE FOR
*                                      '67                           */
         STH   @14,OUTRTCD(,OCMTBPTR)                              0261
*                         OUTMSGID=130;/* ISSUE MSG 351I             */
         MVI   OUTMSGID(OCMTBPTR),X'82'                            0262
*                         CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER*/
         ST    OCMTBPTR,@AL00001                                   0263
         L     @15,@CV01406                                        0263
         LA    @01,@AL00001                                        0263
         BALR  @14,@15                                             0263
*                       END;                                       0264
*                     ELSE          /* SSOBRETN=? - SOME STRANGE   0265
*                                      RETURN CODE                   */
*                                                                  0265
*                       /*********************************************/
*                       /*                                           */
*                       /* SSOBRETN=? (STRANGE RC)                   */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0265
*                       DO;                                        0265
         B     @RC00257                                            0265
@RF00257 DS    0H                                                  0266
*                         RETNCODE=TWELVE;/* QUIT COMMAND            */
         MVC   RETNCODE(4),@CF00034                                0266
*                         ERROR=YES;/* ERROR OCCURRED                */
         OI    ERROR(OCMTBPTR),B'00001000'                         0267
*                         OUTRTCD=SSOBRETN;/* SAVE SSOB RETURN CODE
*                                      FOR '67                       */
         L     @14,OUTSOBH(,OCMTBPTR)                              0268
         MVC   OUTRTCD(2,OCMTBPTR),SSOBRETN+2(@14)                 0268
*                         OUTMSGID=138;/* ISSUE MSG 353I             */
         MVI   OUTMSGID(OCMTBPTR),X'8A'                            0269
*                         CALL IKJCT467(OUTCOMTB);/* CALL MSG HANDLER*/
         ST    OCMTBPTR,@AL00001                                   0270
         L     @15,@CV01406                                        0270
         LA    @01,@AL00001                                        0270
         BALR  @14,@15                                             0270
*                       END;                                       0271
*     END;                          /* END OF SSOBRETN CHECK         */
*                                                                  0273
*   /*****************************************************************/
*   /*                                                               */
*   /* SUBSYSTEM RETURN CODE IS NON ZERO                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0273
*   ELSE                            /* SUBSYSTEM RETURN CODE IS NON
*                                      ZERO - ANALYZE FURTHER        */
*     DO;                                                          0273
         B     @RC00166                                            0273
@RF00166 DS    0H                                                  0274
*       ERROR=ON;                   /* SET QUIT SW INDICATION ERR    */
         OI    ERROR(OCMTBPTR),B'00001000'                         0274
*       RETNCODE=TWELVE;            /* SET RETURN CODE TO 12         */
         MVC   RETNCODE(4),@CF00034                                0275
*       IF OUTRTCD=SSRTNSUP|OUTRTCD=SSRTLERR THEN/* SUBSYS RC=4 OR 0276
*                                      20, FUNCTION NOT SUPPORTED OR
*                                      LOGICAL ERROR                 */
         LH    @14,OUTRTCD(,OCMTBPTR)                              0276
         CH    @14,@CH00053                                        0276
         BE    @RT00276                                            0276
         CH    @14,@CH00813                                        0276
         BNE   @RF00276                                            0276
@RT00276 DS    0H                                                  0277
*         OUTMSGID=133;             /* ISSUE MSG 345I                */
         MVI   OUTMSGID(OCMTBPTR),X'85'                            0277
*       ELSE                        /* CHECK FURTHER                 */
*         IF OUTRTCD=SSRTNTUP THEN  /* SUBSYS RC=8,SUBSYS NOT UP     */
         B     @RC00276                                            0278
@RF00276 CLC   OUTRTCD(2,OCMTBPTR),@CH00047                        0278
         BNE   @RF00278                                            0278
*           OUTMSGID=135;           /* ISSUE MSG 347I                */
         MVI   OUTMSGID(OCMTBPTR),X'87'                            0279
*         ELSE                      /* SUBSYS RC=12,16,OR ANY OTHER
*                                      NON ZERO- SUBSYS NO EXIST OR
*                                      DISASTROUS ERROR              */
*           OUTMSGID=134;           /* ISSUE MSG 346I                */
         B     @RC00278                                            0280
@RF00278 MVI   OUTMSGID(OCMTBPTR),X'86'                            0280
*       CALL IKJCT467(OUTCOMTB);    /* CALL MESSAGE HANDLER          */
@RC00278 DS    0H                                                  0281
@RC00276 ST    OCMTBPTR,@AL00001                                   0281
         L     @15,@CV01406                                        0281
         LA    @01,@AL00001                                        0281
         BALR  @14,@15                                             0281
*     END;                                                         0282
*   END SUBSYSTM;                   /* END OF SUBSYS RTN             */
@EL00003 DS    0H                                                  0283
@EF00003 DS    0H                                                  0283
@ER00003 LM    @14,@12,@SA00003                                    0283
         BR    @14                                                 0283
*                                                                  0284
*/********************************************************************/
*/*                                                                  */
*/*    INITIALIZE THE REQUEST BLOCK POINTER, THE TEXT UNIT POINTER   */
*/*      LIST AND THE TEXT UNITS FOR ALLOCATING THE SYSOUT DATA SET  */
*/*    SET REGISTER 1 WITH THE REQUEST BLOCK POINTER ADDRESS AND     */
*/*      ISSUE SVC 99                                                */
*/*    ANALYZE THE RETURN CODE AND TAKE APPROPRIATE ACTION           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0284
*ALLOCSO:                                                          0284
*   PROC;                           /* INTERNAL PROCEDURE TO ALLOCATE
*                                      THE SYSOUT DATASET            */
ALLOCSO  STM   @14,@12,@SA00004                                    0284
*/********************************************************************/
*/*   SET UP THE REQUEST BLOCK                                       */
*/********************************************************************/
*                                                                  0285
*   S99RB=S99RB&&S99RB;             /* CLEAR THE REQUEST BLOCK       */
         XC    S99RB(20),S99RB                                     0285
*   S99RBLN=LENGTH(S99RB);          /* LENGTH OF REQUEST BLOCK       */
         MVI   S99RBLN,X'14'                                       0286
*   S99VERB=S99VRBAL;               /* ALLOCATION VERB CODE          */
         MVI   S99VERB,X'01'                                       0287
*   S99TXTPP=ADDR(PTRLIST);         /* ADDRESS TEXT UNIT PTR LIST    */
         LA    @14,PTRLIST                                         0288
         ST    @14,S99TXTPP                                        0288
*/********************************************************************/
*/*   SETUP TEXT UNIT POINTER LIST AND THE TEXT UNITS FOR ALLOCATING */
*/*   THE SYSOUT DATA SET                                            */
*/********************************************************************/
*                                                                  0289
*   PLIST=PLIST&&PLIST;             /* CLEAR POINTER LIST            */
         XC    PLIST(16),PLIST                                     0289
*   ADSNTU=ADSNTU&&ADSNTU;          /* CLEAR TEXT UNIT               */
         XC    ADSNTU(54),ADSNTU                                   0290
*   ASSREQTU=ASSREQTU&&ASSREQTU;    /* CLEAR TEXT UNIT               */
         XC    ASSREQTU(4),ASSREQTU                                0291
*   ARTDDNTU=ARTDDNTU&&ARTDDNTU;    /* CLEAR TEXT UNIT               */
         XC    ARTDDNTU(18),ARTDDNTU                               0292
*   RFY                                                            0293
*     S99TUNIT BASED(S99TUPTR(ELEM));/* BASE TEXT UNIT ON ADDR IN  0293
*                                      CURRENT PTR LIST ELEMENT      */
*/*                                                                  */
*                                                                  0294
*   ELEM=ONE;                       /* INIT INDEX INTO PTR LIST      */
         LA    @05,1                                               0294
         LR    ELEM,@05                                            0294
*   S99TUPTR(ELEM)=ADDR(ADSNTU);    /* ADDR 'DSN ALC' TU INTO PTRLST */
         LR    @09,ELEM                                            0295
         SLA   @09,2                                               0295
         LA    @08,ADSNTU                                          0295
         AL    @09,@CF01588                                        0295
         ST    @08,S99TUPTR(@09,@14)                               0295
*   S99TUKEY=DALDSNAM;              /* KEY FOR DSN SPECIFICATION     */
         MVC   S99TUKEY(2,@08),@CB00926                            0296
*   S99TUNUM=1;                     /* ONE PARAMETER                 */
         MVC   S99TUNUM(2,@08),@CH00033                            0297
*   S99TUPAR(1:44)=SSSODSN;         /* SYSOUT DSNAME                 */
         L     @09,OUTSOBSO(,OCMTBPTR)                             0298
         MVC   S99TUPAR(44,@08),SSSODSN(@09)                       0298
*   S99TULNG=LENGTH(SSSODSN);       /* LENGTH OF SYSOUT DSNAME       */
         MVC   S99TULNG(2,@08),@CH00857                            0299
*/*                                                                  */
*                                                                  0300
*   ELEM=ELEM+ONE;                  /* INCRE INDEX INTO PTR LIST     */
         ALR   ELEM,@05                                            0300
*   S99TUPTR(ELEM)=ADDR(ASSREQTU);  /* ADDR 'SUBSYS REQ' TU IN LST   */
         LR    @09,ELEM                                            0301
         SLA   @09,2                                               0301
         LA    @08,ASSREQTU                                        0301
         AL    @09,@CF01588                                        0301
         ST    @08,S99TUPTR(@09,@14)                               0301
*   S99TUKEY=DALSSREQ;              /* KEY FOR SUBSYS REQ ON ALLOC   */
         MVC   S99TUKEY(2,@08),@CB01106                            0302
*   S99TUNUM=0;                     /* NO PARAMETERS                 */
         SLR   @09,@09                                             0303
         ST    @09,@TF00001                                        0303
         MVC   S99TUNUM(2,@08),@TF00001+2                          0303
*/*                                                                  */
*                                                                  0304
*   ELEM=ELEM+ONE;                  /* INCRE INDEX INTO PTR LIST     */
         ALR   ELEM,@05                                            0304
*   S99TUPTR(ELEM)=ADDR(ARTDDNTU);  /* ADDR 'RETN DDN' TU INTO PLST  */
         LR    @09,ELEM                                            0305
         SLA   @09,2                                               0305
         LA    @08,ARTDDNTU                                        0305
         AL    @09,@CF01588                                        0305
         ST    @08,S99TUPTR(@09,@14)                               0305
*   S99TUKEY=DALRTDDN;              /* KEY FOR DDN RETURN            */
         MVC   S99TUKEY(2,@08),@CB01092                            0306
*   S99TUNUM=1;                     /* ONE PARAMETER                 */
         MVC   S99TUNUM(2,@08),@CH00033                            0307
*   S99TUPAR(1:8)='';               /* DDNAME - INIT TO BLANKS       */
         MVI   S99TUPAR(@08),C' '                                  0308
         MVC   S99TUPAR+1(7,@08),S99TUPAR(@08)                     0308
*   S99TULNG=8;                     /* LENGTH DDNAME                 */
         MVC   S99TULNG(2,@08),@CH00047                            0309
*/*                                                                  */
*                                                                  0310
*   ELEM=ELEM+ONE;                  /* INCRE INDEX INTO PTR LIST     */
         ALR   ELEM,@05                                            0310
*   S99TUPTR(ELEM)=ADDR(ADISPTU);   /* ADDR 'DS STATUS' TU IN LIST   */
         LR    @09,ELEM                                            0311
         SLA   @09,2                                               0311
         LA    @08,ADISPTU                                         0311
         LA    @07,0(@09,@14)                                      0311
         AL    @07,@CF01588                                        0311
         ST    @08,S99TUPTR(,@07)                                  0311
*   S99TUKEY=DALSTATS;              /* KEY FOR DS STATUS             */
         MVC   S99TUKEY(2,@08),@CB00930                            0312
*   S99TUNUM=1;                     /* ONE PARAMETER                 */
         MVC   S99TUNUM(2,@08),@CH00033                            0313
*   S99TUPAR(1)=1;                  /* DISPOSITION 'OLD'             */
         STC   @05,S99TUPAR(,@08)                                  0314
*   S99TULNG=1;                     /* LENGTH OF DISPOSION           */
         MVC   S99TULNG(2,@08),@CH00033                            0315
*/*                                                                  */
*                                                                  0316
*   S99TUPLN(ELEM)=ON;              /* SET END OF PTRLIST INDICATOR  */
         ALR   @14,@09                                             0316
         AL    @14,@CF01588                                        0316
         OI    S99TUPLN(@14),B'10000000'                           0316
*                                                                  0317
*/********************************************************************/
*/*   INVOKE DYNAMIC ALLOCATION                                      */
*/********************************************************************/
*                                                                  0317
*   S99RBPTR=ADDR(S99RB);           /* SET UP REQUEST BLOCK PTR      */
         LA    @14,S99RB                                           0317
         ST    @14,S99RBPTR                                        0317
*   S99RBPND=ON;                    /* TURN ON HI ORDER BIT          */
         OI    S99RBPND,B'10000000'                                0318
*   REG1=ADDR(S99RBPTR);            /* PASS S99RB PTR TO DYN ALC     */
         LA    REG1,S99RBPTR                                       0319
*/* MACDATE Y-2 73082                                                */
*                                                                  0320
*   SVC(99);                        /* INVOKE DYNAMIC ALLOCATION     */
         SVC   99                                                  0320
*   OUTRTCD=REG15;                  /* SAVE DYN ALLOC RTN CODE       */
         STH   REG15,OUTRTCD(,OCMTBPTR)                            0321
*/********************************************************************/
*/*   ANALYZE DYNAMIC ALLOCATION RETURN CODE                         */
*/********************************************************************/
*                                                                  0322
*   IF OUTRTCD=ZERO THEN            /* IF ALLOCATION WAS SUCCESSFUL  */
         SLR   @14,@14                                             0322
         LH    @05,OUTRTCD(,OCMTBPTR)                              0322
         CR    @05,@14                                             0322
         BNE   @RF00322                                            0322
*     DO;                                                          0323
*       ALLOC=ON;                   /* INDICATE SYSOUT IS ALLOC      */
         OI    ALLOC(OCMTBPTR),B'00000100'                         0324
*       RFY                                                        0325
*         S99TUNIT BASED(ADDR(ARTDDNTU));/* BASE TU MAP ON 'RETN DDN'
*                                      TU                            */
*       OSYSODDN(1:8)=S99TUPAR(1:8);/* SAVE DDN OF ALLOC SYSOUT DATA
*                                      SET                           */
         LA    @05,ARTDDNTU                                        0326
         MVC   OSYSODDN(8,OCMTBPTR),S99TUPAR(@05)                  0326
*       IF S99INFO^=ZERO THEN       /* IF INFO MESSAGE NEEDED        */
         MVC   @ZT00002+2(2),S99INFO                               0327
         C     @14,@ZT00002                                        0327
         BE    @RF00327                                            0327
*         DO;                                                      0328
*           OUTDARB=ADDR(S99RB);    /* SET UP FOR DAIRFAIL           */
         LA    @14,S99RB                                           0329
         ST    @14,OUTDARB(,OCMTBPTR)                              0329
*           OUTMSGID=8;             /* MSG ID FOR IKJCT467           */
         MVI   OUTMSGID(OCMTBPTR),X'08'                            0330
*           CALL IKJCT467(OUTCOMTB);/* CALL MESSAGE HANDLER          */
         ST    OCMTBPTR,@AL00001                                   0331
         L     @15,@CV01406                                        0331
         LA    @01,@AL00001                                        0331
         BALR  @14,@15                                             0331
*         END;                                                     0332
*       ELSE                                                       0333
*         ;                         /* NO INFO MSG NEEDED            */
@RF00327 DS    0H                                                  0334
*     END;                                                         0334
*   ELSE                            /* ALLOCATION NOT SUCCESSFUL     */
*     DO;                           /* DYN ALC RETURN CODE NOT ZERO  */
         B     @RC00322                                            0335
@RF00322 DS    0H                                                  0336
*       OUTDARB=ADDR(S99RB);        /* SET UP FOR DAIRFAIL           */
         LA    @14,S99RB                                           0336
         ST    @14,OUTDARB(,OCMTBPTR)                              0336
*       OUTMSGID=8;                 /* MSG ID FOR IKJCT467           */
         MVI   OUTMSGID(OCMTBPTR),X'08'                            0337
*       CALL IKJCT467(OUTCOMTB);    /* CALL MESSAGE HANDLER          */
         ST    OCMTBPTR,@AL00001                                   0338
         L     @15,@CV01406                                        0338
         LA    @01,@AL00001                                        0338
         BALR  @14,@15                                             0338
*       ERROR=YES;                  /* SET QUIT SWITCH               */
         OI    ERROR(OCMTBPTR),B'00001000'                         0339
*       RETNCODE=TWELVE;            /* RETURN CODE OF 12             */
         MVC   RETNCODE(4),@CF00034                                0340
*     END;                                                         0341
*   END ALLOCSO;                                                   0342
@EL00004 DS    0H                                                  0342
@EF00004 DS    0H                                                  0342
@ER00004 LM    @14,@12,@SA00004                                    0342
         BR    @14                                                 0342
*                                                                  0343
*/********************************************************************/
*/*                                                                  */
*/*    DETERMINE WHERE TO BEGIN PRINTING BASED ON WHETHER 'HERE',    */
*/*      'BEGIN', OR 'NEXT' WAS ON THE COMMAND AND WHETHER THE       */
*/*      SYSOUT DATA SET HAS BEEN PREVIOUSLY CHECKPOINTED.           */
*/*    IF THE SYSOUT DATA SET IS NOT TO BE SKIPPED, INITIALIZE THE   */
*/*      RPL/ACB CONTROL BLOCKS AND OPEN THE SYSOUT DATA SET.        */
*/*    READ AND WRITE THE SYSOUT DATA SET UNTIL:                     */
*/*      ATTENTION AND 'CONTINUE NEXT' SUBCOMMAND ENTERED            */
*/*      ATTENTION AND 'END' SUBCOMMAND ENTERED                      */
*/*      END OF DATA AND NOPAUSE WAS SPECIFIED                       */
*/*      END OF DATA,PAUSE SPECIFIED, AND 'CONTINUE HERE' SUBCOMMAND */
*/*      END OF DATA,PAUSE SPECIFIED, AND 'CONTINUE NEXT' SUBCOMMAND */
*/*      END OF DATA,PAUSE SPECIFIED, AND 'END' SUBCOMMAND           */
*/*      ERROR OCCURS                                                */
*/*    IF EOD/PAUSE OR ATTENTION OCCURS, CALL IKJCT463 TO PROCESS    */
*/*      SUBCOMMANDS.                                                */
*/*    WHEN DONE WITH THE SYSOUT DATASET, CLOSE IT.                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0343
*PRINTRTN:                                                         0343
*   PROC;                           /* INTERNAL PROCEDURE TO READ AND
*                                      WRITE SYSOUT RCDS             */
PRINTRTN STM   @14,@12,@SA00005                                    0343
*   CALL STARTPT;                   /* CALL RTN TO DECIDE WHERE TO 0344
*                                      BEGIN PRINTING SYSOUT DS      */
         BAL   @14,STARTPT                                         0344
*   IF SKIPDS=NO THEN               /* SYSOUT DS NOT TO BE SKIPPED   */
         TM    SKIPDS,B'10000000'                                  0345
         BNZ   @RF00345                                            0345
*     DO;                                                          0346
*       CALL OPENSYSO;              /* CALL RTN TO INIT RPL & ACB, 0347
*                                      OPEN DS AND GET INPUT BUFFERS */
         BAL   @14,OPENSYSO                                        0347
*       DO WHILE ERROR=NO&SKIPGET=NO&ENDSW=NO;/* THIS LOOP GETS AND
*                                      PUTS SYSOUT RCDS UNTIL ERROR
*                                      OR FINISHED WITH THIS DATASET:
*                                      ATTN/CONT NEXT EOD-NOPAUSE  0348
*                                      EOD-PAUSE/CONT HERE         0348
*                                      EOD-PAUSE/CONT NEXT           */
         B     @DE00348                                            0348
@DL00348 DS    0H                                                  0349
*         CALL IKJCT470(OPTR);      /* GO GET A RECORD               */
         L     @14,@PC00001                                        0349
         ST    @14,@AL00001                                        0349
         L     @15,@CV01407                                        0349
         LA    @01,@AL00001                                        0349
         BALR  @14,@15                                             0349
*         IF POSTED=YES THEN        /* ATTN INTERRUPT OCCURRED       */
         TM    POSTED(OCMTBPTR),B'01000000'                        0350
         BNO   @RF00350                                            0350
*           CALL ATTNRTN;           /* HANDLE SUBCOMMANDS            */
         BAL   @14,ATTNRTN                                         0351
*         ELSE                      /* CHECK FURTHER                 */
*           IF EODSW=YES THEN       /* EOD REACHED ON SYSOUT         */
         B     @RC00350                                            0352
@RF00350 TM    EODSW(OCMTBPTR),B'00010000'                         0352
         BNO   @RF00352                                            0352
*             DO;                                                  0353
*               IF TERM=YES THEN    /* PRINTING TO A TERMINAL        */
         TM    TERM(OCMTBPTR),B'00001000'                          0354
         BNO   @RF00354                                            0354
*                 CALL IKJCT471(OPTR);/* CALL '71 TO PUT A BLANK   0355
*                                      SEPARATOR AFTER THIS DS       */
         L     @14,@PC00001                                        0355
         ST    @14,@AL00001                                        0355
         L     @15,@CV01408                                        0355
         LA    @01,@AL00001                                        0355
         BALR  @14,@15                                             0355
*               CALL EODRTN;        /* GO HANDLE END OF DATA         */
@RF00354 BAL   @14,EODRTN                                          0356
*             END;                                                 0357
*           ELSE                    /* ELSE GOT A RCD OR AN ERROR. IF
*                                      ERROR, SWITCH ALREADY SET TO
*                                      STOP FURTHER PROCESSING. IF 0358
*                                      SUCCESSFUL RETRIEVE OF RCD, 0358
*                                      CONTINUE WITH PUT.            */
*             IF ERROR=YES THEN     /* ERROR DETECTED DURING GET     */
         B     @RC00352                                            0358
@RF00352 TM    ERROR(OCMTBPTR),B'00001000'                         0358
         BNO   @RF00358                                            0358
*               DO;                                                0359
*                 SSSOCHKP=YES;     /* TELL SUBSYS TO CHECKPOINT     */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0360
         OI    SSSOCHKP(@14),B'01000000'                           0360
*                 SSSORBA=OUTHOLD;  /* CKPT RBA CORRESPONDS TO LAST
*                                      RCD PUT. ANY RCDS STACKED IN
*                                      BUF WILL BE PUT AT CLOSE.     */
         MVC   SSSORBA(8,@14),OUTHOLD(OCMTBPTR)                    0361
*               END;                                               0362
*             ELSE                  /* SUCCESSFUL GET                */
*               DO;                                                0363
         B     @RC00358                                            0363
@RF00358 DS    0H                                                  0364
*                 CALL IKJCT471(OPTR);/* GO 'PUT' THE RECORD         */
         L     @14,@PC00001                                        0364
         ST    @14,@AL00001                                        0364
         L     @15,@CV01408                                        0364
         LA    @01,@AL00001                                        0364
         BALR  @14,@15                                             0364
*                 IF SYNADERR=YES THEN/* ERROR WHILE PUT OF RCD      */
         TM    SYNADERR(OCMTBPTR),B'10000000'                      0365
         BNO   @RF00365                                            0365
*                   DO;                                            0366
*                     RETNCODE=TWELVE;/* SET RETURN CODE FOR '69     */
         MVC   RETNCODE(4),@CF00034                                0367
*                     ERROR=YES;    /* INDICATE TERMINATING ERR      */
         OI    ERROR(OCMTBPTR),B'00001000'                         0368
*                     SSSOCHKP=YES; /* TELL SUBSYS TO CKPT           */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0369
         OI    SSSOCHKP(@14),B'01000000'                           0369
*                     SSSORBA=OUTBKAPX;/* CKPT 10 PUT RCDS BACK SINCE
*                                      LAST BUFFER WAS NOT WRITTEN 0370
*                                      OUT                           */
         MVC   SSSORBA(8,@14),OUTBKAPX(OCMTBPTR)                   0370
*                   END;                                           0371
*               END;                                               0372
@RF00365 DS    0H                                                  0373
*       END;                        /* END OF GET-PUT DO WHILE       */
@RC00358 DS    0H                                                  0373
@RC00352 DS    0H                                                  0373
@RC00350 DS    0H                                                  0373
@DE00348 TM    ERROR(OCMTBPTR),B'00001000'                         0373
         BNZ   @DC00348                                            0373
         TM    SKIPGET,B'10000000'                                 0373
         BNZ   @DC00348                                            0373
         TM    ENDSW(OCMTBPTR),B'00010000'                         0373
         BZ    @DL00348                                            0373
@DC00348 DS    0H                                                  0374
*       SKIPGET=OFF;                /* TURN OFF SKIPGET SWITCH       */
         NI    SKIPGET,B'01111111'                                 0374
*       CALL CLSSYSO;               /* DONE WITH THIS DATASET. GO  0375
*                                      FREE BUFS AND CLOSE IT.       */
         BAL   @14,CLSSYSO                                         0375
*     END;                          /* END OPEN/PRINT/CLOSE GROUP    */
*   ELSE                            /* ELSE SKIP PRINTING THIS DS    */
*     SKIPDS=OFF;                   /* TURN OFF SKIPDS SWITCH        */
         B     @RC00345                                            0377
@RF00345 NI    SKIPDS,B'01111111'                                  0377
*                                                                  0378
*/********************************************************************/
*/*                                                                  */
*/*  IF SYSOUT DATASET NEVER CHECKPOINTED, HERE/BEGIN/NEXT ALL START */
*/*     PRINTING AT THE BEGINNING.                                   */
*/*  IF SYSOUT DATASET WAS PREVIOUSLY INTERRUPTED (CHECKPOINTED),    */
*/*     HERE/BEGIN/NEXT CONTROL THE POINT WHERE PRINTING STARTS.     */
*/*             BEGIN - START AT THE BEGINNING AND IGNORE CHECKPOINT */
*/*             HERE  - START AT THE CHECKPOINT                      */
*/*             NEXT  - SKIP THIS DATASET                            */
*/*  AN EXCEPTION TO THE ABOVE RULES FOR INTERRUPTED DATASETS IS     */
*/*     THE CASE WHERE 'CONTINUE HERE' WAS ENTERED AFTER A PAUSE.    */
*/*     WHEN THE NEXT DATASET IS ACCESSED, PRINTING SHOULD START     */
*/*     FROM THE BEGINNING.  IF A CHECKPOINT EXISTS IT IS IGNORED.   */
*/********************************************************************/
*                                                                  0378
*STARTPT:                                                          0378
*   PROC;                           /* INTERNAL PROCEDURE TO DECIDE
*                                      WHERE TO START PRINT          */
         B     @PB00006                                            0378
STARTPT  STM   @14,@12,@SA00006                                    0378
*/********************************************************************/
*/* INITIALIZE THE FIELDS USED IN CALCULATING SEVERAL RECORDS BACK   */
*/* WHEN ATTENTION OCCURS. IF THIS SYSOUT DATA SET WAS NEVER         */
*/* INTERRUPTED, PROCESSING STARTS AT BEGINNING.                     */
*/********************************************************************/
*                                                                  0379
*   OUTHOLD=ZEROS;                  /* INIT CURRENT RBA FIELD        */
         MVC   OUTHOLD(8,OCMTBPTR),@CB01394                        0379
*   OUTBKAPX=ZEROS;                 /* INIT APPROX RBA FOR BACKUP    */
         MVC   OUTBKAPX(8,OCMTBPTR),@CB01394                       0380
*   OUTBKNEW=ZEROS;                 /* INIT TEMP. APPROX RBA FOR   0381
*                                      BACKUP                        */
         MVC   OUTBKNEW(8,OCMTBPTR),@CB01394                       0381
*   OUTBKCNT=ZERO;                  /* ZERO COUNT FIELD              */
         SLR   @14,@14                                             0382
         ST    @14,OUTBKCNT(,OCMTBPTR)                             0382
*   POINT=YES;                      /* TELL IKJCT470 TO POINT        */
         OI    POINT(OCMTBPTR),B'10000000'                         0383
*   IF SSSORBA^=ZEROS THEN          /* SYSOUT WAS PREVIOUSLY       0384
*                                      INTERRUPTED (CHECKPOINTED). 0384
*                                      CHECK FOR FURTHER INDICATION
*                                      OF WHERE TO START PRINTING    */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0384
         CLC   SSSORBA(8,@14),@CB01394                             0384
         BE    @RF00384                                            0384
*     IF SUBHERE=ON|BEGIN=YES THEN  /* EITHER THIS DS NEXT TO BE   0385
*                                      ACCESSED AFTER 'PAUSE-CONT  0385
*                                      HERE' OR BEGIN SPECIFIED ON 0385
*                                      COMMAND. SO IGNORE CHECKPOINT
*                                      AND START AT BEGINNING.       */
         TM    SUBHERE(OCMTBPTR),B'00010000'                       0385
         BO    @RT00385                                            0385
         TM    BEGIN(OCMTBPTR),B'00010000'                         0385
         BNO   @RF00385                                            0385
@RT00385 DS    0H                                                  0386
*       SUBHERE=OFF;                /* TURN OFF SUBHERE SWITCH       */
         NI    SUBHERE(OCMTBPTR),B'11101111'                       0386
*     ELSE                          /* PRINT CKPTED SYSOUT ON BASIS
*                                      OF HERE OR NEXT               */
*       IF HERE=YES THEN            /* PRINT FROM LAST POINT OF    0387
*                                      INTERRUPTION                  */
         B     @RC00385                                            0387
@RF00385 TM    HERE(OCMTBPTR),B'00100000'                          0387
         BNO   @RF00387                                            0387
*         DO;                                                      0388
*           OUTHOLD=SSSORBA;        /* START READING AT CKPT         */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0389
         MVC   OUTHOLD(8,OCMTBPTR),SSSORBA(@14)                    0389
*           OUTBKAPX=OUTHOLD;       /* SET FOR IKJCT471              */
         MVC   OUTBKAPX(8,OCMTBPTR),OUTHOLD(OCMTBPTR)              0390
*           OUTBKNEW=OUTHOLD;       /* SET FOR IKJCT471              */
         MVC   OUTBKNEW(8,OCMTBPTR),OUTHOLD(OCMTBPTR)              0391
*           INTRPMSG=YES;           /* SO IKJCT471 WILL ISSUE MSG    */
         OI    INTRPMSG(OCMTBPTR),B'00000010'                      0392
*         END;                                                     0393
*       ELSE                        /* ELSE NEXT GIVEN ON COMMAND. 0394
*                                      SKIP THIS DATASET             */
*         DO;                                                      0394
         B     @RC00387                                            0394
@RF00387 DS    0H                                                  0395
*           SKIPDS=YES;             /* SKIP THIS CKPT DATASET        */
         OI    SKIPDS,B'10000000'                                  0395
*           OUTMSGID=132;           /* ISSUE MSG 344I                */
         MVI   OUTMSGID(OCMTBPTR),X'84'                            0396
*           CALL IKJCT467(OUTCOMTB);/* CALL MESSAGE HANDLER          */
         ST    OCMTBPTR,@AL00001                                   0397
         L     @15,@CV01406                                        0397
         LA    @01,@AL00001                                        0397
         BALR  @14,@15                                             0397
*           IF ERROR=YES THEN       /* ANY TERMINATING ERRORS FROM 0398
*                                      MESSAGE HANDLER               */
         TM    ERROR(OCMTBPTR),B'00001000'                         0398
         BNO   @RF00398                                            0398
*             DO;                                                  0399
*               RETNCODE=TWELVE;    /* SET RETURN CODE 12            */
         MVC   RETNCODE(4),@CF00034                                0400
*               ERROR=YES;          /* TURN ON QUIT SWITCH           */
         OI    ERROR(OCMTBPTR),B'00001000'                         0401
*             END;                                                 0402
*           ELSE                                                   0403
*             ;                     /* NO ERRORS IN MSG HANDLER      */
@RF00398 DS    0H                                                  0404
*         END;                                                     0404
*   ELSE                                                           0405
*     ;                             /* SYSOUT NEVER INTERRUPTED.   0405
*                                      START AT BEGINNING.           */
@RF00384 DS    0H                                                  0406
*   END STARTPT;                    /* END OF RTN TO CALC START OF 0406
*                                      PRINTING                      */
@EL00006 DS    0H                                                  0406
@EF00006 DS    0H                                                  0406
@ER00006 LM    @14,@12,@SA00006                                    0406
         BR    @14                                                 0406
*                                                                  0407
*/********************************************************************/
*/*                                                                  */
*/*   INITIALIZE THE RPL                                             */
*/*   INITIALIZE THE ACB                                             */
*/*   OPEN ACB                                                       */
*/*   ANALYZE OPEN RETURN CODE AND TAKE APPROPRIATE ACTION           */
*/*   GET CORE FOR INPUT BUFFERS                                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0407
*OPENSYSO:                                                         0407
*   PROC;                           /* INTERNAL PROCEDURE TO OPEN A
*                                      SYSOUT DATA SET               */
OPENSYSO STM   @14,@12,@SA00007                                    0407
*/********************************************************************/
*/*   INITIALIZE THE RPL AND ASSOCIATED OUTCOMTB FIELDS              */
*/********************************************************************/
*                                                                  0408
*   OUTRPL=ADDR(RPLCORE);           /* POINTER TO RPL IN OUTCOMTB    */
         LA    @14,RPLCORE                                         0408
         ST    @14,OUTRPL(,OCMTBPTR)                               0408
*   OUTRPLL=LENGTH(RPLCORE);        /* LENGTH OF RPL IN OUTCOMTB     */
         LA    @05,76                                              0409
         ST    @05,OUTRPLL(,OCMTBPTR)                              0409
*   RFY                                                            0410
*     IFGRPL BASED(OUTRPL);         /* BASE RPL MAP ON RPLCORE       */
*   IFGRPL=IFGRPL&&IFGRPL;          /* CLEAR THE RPL                 */
         XC    IFGRPL(76,@14),IFGRPL(@14)                          0411
*   IFGRPL=INPRPL;                  /* MOVE THE INLINE EXPANDED RPL
*                                      TO DYNAMIC CORE               */
         MVC   IFGRPL(76,@14),INPRPL                               0412
*   RPLDACB=ADDR(ACBCORE);          /* PUT ADDR OF DYNAMIC ACB IN RPL*/
         LA    @02,ACBCORE                                         0413
         ST    @02,RPLDACB(,@14)                                   0413
*   RPLARG=ADDR(OUTHOLD);           /* ADDR SEARCH ARG FOR POINT     */
         LA    @09,OUTHOLD(,OCMTBPTR)                              0414
         ST    @09,RPLARG(,@14)                                    0414
*/********************************************************************/
*/*   INITIALIZE THE ACB AND ASSOCIATED OUTCOMTB FIELDS              */
*/********************************************************************/
*                                                                  0415
*   OUTACB=ADDR(ACBCORE);           /* POINTER TO ACB IN OUTCOMTB    */
         ST    @02,OUTACB(,OCMTBPTR)                               0415
*   OUTACBL=LENGTH(ACBCORE);        /* LENGTH OF ACB IN OUTCOMTB     */
         ST    @05,OUTACBL(,OCMTBPTR)                              0416
*   RFY                                                            0417
*     IFGACB BASED(OUTACB);         /* BASE ACB MAP ON ACB CORE      */
*   IFGACB=IFGACB&&IFGACB;          /* CLEAR CORE FOR THE ACB        */
         XC    IFGACB(76,@02),IFGACB(@02)                          0418
*   IFGACB=INPACB;                  /* MOVE ACB TO DYNAMIC CORE      */
         MVC   IFGACB(76,@02),INPACB                               0419
*   ACBDDNM=OSYSODDN;               /* DDNAME IN ACB FROM TXT UNT    */
         MVC   ACBDDNM(8,@02),OSYSODDN(OCMTBPTR)                   0420
*   ACBLENG=LENGTH(ACBCORE);        /* ACB LEN IN ACB FOR SUBSYS     */
         STH   @05,ACBLENG(,@02)                                   0421
*/********************************************************************/
*/*    OPEN THE ACB                                                  */
*/********************************************************************/
*                                                                  0422
*   OPENLSTA(1:LNGOLSTS)=OPENLSTS(1:LNGOLSTS);/* MOVE OPEN LIST TO 0422
*                                      DYN CORE                      */
         L     @14,LNGOLSTS                                        0422
         BCTR  @14,0                                               0422
         EX    @14,@SM01592                                        0422
*   REG4=ADDR(ACBCORE);             /* ADDR OF ACB TO OPEN           */
         LR    REG4,@02                                            0423
*   GEN(OPEN  ((4)),MF=(E,OPENLSTA));/* OPEN THE ACB                 */
         OPEN  ((4)),MF=(E,OPENLSTA)
*   OUTRTCD=REG15;                                                 0425
         STH   REG15,OUTRTCD(,OCMTBPTR)                            0425
*   IF ACBOPEN=NO THEN              /* ACB DID NOT OPEN              */
         L     @14,OUTACB(,OCMTBPTR)                               0426
         TM    ACBOPEN(@14),B'00010000'                            0426
         BNZ   @RF00426                                            0426
*     DO;                                                          0427
*       ERROR=YES;                  /* INDICATE TERMINATING ERR      */
         OI    ERROR(OCMTBPTR),B'00001000'                         0428
*       OUTMSGID=52;                /* ISSUE MSG VIA VSMFAIL         */
         MVI   OUTMSGID(OCMTBPTR),X'34'                            0429
*       CALL IKJCT467(OUTCOMTB);    /* CALL MSG HANDLER              */
         ST    OCMTBPTR,@AL00001                                   0430
         L     @15,@CV01406                                        0430
         LA    @01,@AL00001                                        0430
         BALR  @14,@15                                             0430
*       RETNCODE=TWELVE;            /* SET ERROR RETURN CODE         */
         MVC   RETNCODE(4),@CF00034                                0431
*     END;                                                         0432
*   ELSE                            /* ACB OPENED SUCCESSFULLY       */
*/********************************************************************/
*/*      GET CORE FOR INPUT BUFFERS AND SAVE INFO.                   */
*/********************************************************************/
*                                                                  0433
*     DO;                                                          0433
         B     @RC00426                                            0433
@RF00426 DS    0H                                                  0434
*       OPENED=YES;                 /* INDICATE SYSOUT IS OPENED     */
         OI    OPENED(OCMTBPTR),B'01000000'                        0434
*       RPLBUFL=ACBLRECL;           /* INPUT BUFFER LEN- MAX SYSOUT
*                                      RCD                           */
         L     @14,OUTRPL(,OCMTBPTR)                               0435
         L     @05,OUTACB(,OCMTBPTR)                               0435
         LH    @05,ACBLRECL(,@05)                                  0435
         ST    @05,RPLBUFL(,@14)                                   0435
*       REG4=ACBLRECL;              /* RCD LEN FOR GETMAIN BUF       */
         LR    REG4,@05                                            0436
*       GEN(GETMAIN R,LV=(4),SP=1);                                0437
         GETMAIN R,LV=(4),SP=1
*       RPLAREA=REG1;               /* ADDR OF 'INPUT' BUF           */
         L     @14,OUTRPL(,OCMTBPTR)                               0438
         ST    REG1,RPLAREA(,@14)                                  0438
*       FREEBUF=YES;                /* FREEMAIN BEFORE END           */
         OI    FREEBUF,B'10000000'                                 0439
*     END;                                                         0440
*   END OPENSYSO;                   /* END OF OPEN SYSOUT RTN        */
@EL00007 DS    0H                                                  0441
@EF00007 DS    0H                                                  0441
@ER00007 LM    @14,@12,@SA00007                                    0441
         BR    @14                                                 0441
*                                                                  0442
*/********************************************************************/
*/*                                                                  */
*/*       ATTENTION ROUTINE                                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0442
*ATTNRTN:                                                          0442
*   PROC;                           /* INTERNAL TO PRINTRTN - HANDLE
*                                      ATTENTION INTERRUPTS          */
ATTNRTN  STM   @14,@12,@SA00008                                    0442
*   EODSW=OFF;                      /* IN CASE EOD, IGNORE           */
         NI    EODSW(OCMTBPTR),B'11101111'                         0443
*   CALL TCLRQSTK;                  /* CALL RTN TO CLEARQ AND RESET
*                                      THE STACK                     */
*                                                                  0444
         BAL   @14,TCLRQSTK                                        0444
*   /*****************************************************************/
*   /*                                                               */
*   /* INVOKE IKJCT463 TO PROCESS THE SUBCMD. ANALYZE THE RESULTS.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0445
*   CALL IKJCT463(OPTR);            /* GO PROCESS SUBCOMMAND ENTERED
*                                      AFTER ATTN HIT                */
         L     @14,@PC00001                                        0445
         ST    @14,@AL00001                                        0445
         L     @15,@CV01405                                        0445
         LA    @01,@AL00001                                        0445
         BALR  @14,@15                                             0445
*   IF ERROR=YES THEN               /* IF IKJCT463 FAILED            */
*                                                                  0446
         TM    ERROR(OCMTBPTR),B'00001000'                         0446
         BNO   @RF00446                                            0446
*     /***************************************************************/
*     /*                                                             */
*     /* ERROR OCCURRED                                              */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0447
*     DO;                                                          0447
*       SSSOCHKP=YES;               /* TELL SUBSYS TO CHECKPOINT   0448
*                                      INTERRUPTED SYSOUT DS         */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0448
         OI    SSSOCHKP(@14),B'01000000'                           0448
*       IF TERM=YES THEN            /* PRINT TO A TERMINAL, THERE- 0449
*                                      FORE TCAM BUFFERS WERE LOST 0449
*                                      AFTER ATTENTION.              */
         TM    TERM(OCMTBPTR),B'00001000'                          0449
         BNO   @RF00449                                            0449
*         SSSORBA=OUTBKAPX;         /* GIVE SUBSYS THE CKPT RBA    0450
*                                      CORRESPONDING TO APPROX 10 PUT
*                                      LINES BACK.                   */
         MVC   SSSORBA(8,@14),OUTBKAPX(OCMTBPTR)                   0450
*       ELSE                        /* PRINT TO A DATASET, BUFS NOT
*                                      LOST. RCDS REMAINING IN PUT 0451
*                                      BUFS ARE WRITTEN DURING CLOSE,
*                                      SO DON'T BACK UP.             */
*         SSSORBA=OUTHOLD;          /* USE CURRENT RBA IN OUTHOLD    */
         B     @RC00449                                            0451
@RF00449 L     @14,OUTSOBSO(,OCMTBPTR)                             0451
         MVC   SSSORBA(8,@14),OUTHOLD(OCMTBPTR)                    0451
*     END;                                                         0452
*   ELSE                            /* NO ERROR, SEE WHAT SUBCMD     */
*     IF SUBCONT=YES&SUBBEGN=YES THEN/* IF CONTINUE BEGIN SUBCMD     */
*                                                                  0453
         B     @RC00446                                            0453
@RF00446 TM    SUBCONT(OCMTBPTR),B'00101000'                       0453
         BNO   @RF00453                                            0453
*       /*************************************************************/
*       /*                                                           */
*       /* 'CONTINUE BEGIN' SUBCMD ENTERED                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0454
*       DO;                                                        0454
*         SUBCONT=OFF;              /* TURN OFF SUBCONT INDICATOR    */
*         SUBBEGN=OFF;              /* TURN OFF SUBBEGN INDICATOR    */
         NI    SUBCONT(OCMTBPTR),B'11010111'                       0456
*         POINT=YES;                /* TELL '70 TO POINT             */
         OI    POINT(OCMTBPTR),B'10000000'                         0457
*         OUTHOLD=ZEROS;            /* SET POINT ARG FOR '70         */
         MVC   OUTHOLD(8,OCMTBPTR),@CB01394                        0458
*         OUTBKAPX=ZEROS;           /* APPROX CTRS AT 1ST RCD AGAIN  */
         MVC   OUTBKAPX(8,OCMTBPTR),@CB01394                       0459
*         OUTBKNEW=ZEROS;           /* APPROX CTRS AT 1ST RCD AGAIN  */
         MVC   OUTBKNEW(8,OCMTBPTR),@CB01394                       0460
*         OUTBKCNT=ZERO;            /* START '71 COUNTING AGAIN      */
         SLR   @14,@14                                             0461
         ST    @14,OUTBKCNT(,OCMTBPTR)                             0461
*       END;                                                       0462
*     ELSE                          /* CHECK FURTHER                 */
*       IF SUBCONT=YES&SUBHERE=YES THEN/* IF CONTINUE HERE SUBCMD    */
*                                                                  0463
         B     @RC00453                                            0463
@RF00453 TM    SUBCONT(OCMTBPTR),B'00110000'                       0463
         BNO   @RF00463                                            0463
*         /***********************************************************/
*         /*                                                         */
*         /* 'CONTINUE HERE' SUBCMD ENTERED                          */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0464
*         DO;                                                      0464
*           SUBCONT=OFF;            /* TURN OFF SUBCONT INDICATOR    */
*           SUBHERE=OFF;            /* TURN OFF SUBHERE INDICATOR    */
         NI    SUBCONT(OCMTBPTR),B'11001111'                       0466
*           INTRPMSG=YES;           /* TELL IKJCT471 TO ISSUE MSG    */
*           POINT=YES;              /* TELL '70 TO POINT             */
         OI    INTRPMSG(OCMTBPTR),B'10000010'                      0468
*           OUTBKCNT=ZERO;          /* START '71 COUNTING AGAIN      */
         SLR   @14,@14                                             0469
         ST    @14,OUTBKCNT(,OCMTBPTR)                             0469
*           IF TERM=YES THEN        /* PRINTING TO A TERMINAL, BACK
*                                      UP SO RCDS NOT LOST           */
         TM    TERM(OCMTBPTR),B'00001000'                          0470
         BNO   @RF00470                                            0470
*             DO;                                                  0471
*               OUTHOLD=OUTBKAPX;   /* SET POINT ARG FOR '70         */
         MVC   OUTHOLD(8,OCMTBPTR),OUTBKAPX(OCMTBPTR)              0472
*               OUTBKNEW=OUTBKAPX;  /* APPROX CTRS AT INTRP POINT    */
         MVC   OUTBKNEW(8,OCMTBPTR),OUTBKAPX(OCMTBPTR)             0473
*             END;                                                 0474
*           ELSE                                                   0475
*             ;                     /* PRINT TO DS - POINT TO CURRENT
*                                      OUTHOLD RCD. REREAD LAST RCD
*                                      WHICH WAS NEVER PUT           */
@RF00470 DS    0H                                                  0476
*         END;                                                     0476
*       ELSE                        /* CHECK FURTHER                 */
*         IF SUBCONT=YES&SUBNEXT=YES THEN/* CONT NEXT SUBCMD         */
*                                                                  0477
         B     @RC00463                                            0477
@RF00463 TM    SUBCONT(OCMTBPTR),B'00100100'                       0477
         BNO   @RF00477                                            0477
*           /*********************************************************/
*           /*                                                       */
*           /* 'CONTINUE NEXT' SUBCMD ENTERED                        */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0478
*           DO;                     /* IF CONTINUE NEXT SUBCMD       */
*             SKIPGET=YES;          /* SKIP FURTHER GETS FROM DS     */
         OI    SKIPGET,B'10000000'                                 0479
*             SUBCONT=OFF;          /* TURN OFF SUBCONT INDICATOR    */
*             SUBNEXT=OFF;          /* TURN OFF SUBNEXT INDICATOR    */
         NI    SUBCONT(OCMTBPTR),B'11011011'                       0481
*             IF KEEP=YES THEN      /* IF KEEP REQUESTED             */
         TM    KEEP(OCMTBPTR),B'10000000'                          0482
         BNO   @RF00482                                            0482
*               DO;                                                0483
*                 SSSOCHKP=YES;     /* TELL SUBSYS TO CKPT SYSOUT    */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0484
         OI    SSSOCHKP(@14),B'01000000'                           0484
*                 IF TERM=YES THEN  /* PRINTING TO A TERMINAL        */
         TM    TERM(OCMTBPTR),B'00001000'                          0485
         BNO   @RF00485                                            0485
*                   SSSORBA=OUTBKAPX;/* GIVE SUSBYS THE CKPT RBA   0486
*                                      CORRESPONDING TO APPROX 10 PUT
*                                      LINES BACK.                   */
         MVC   SSSORBA(8,@14),OUTBKAPX(OCMTBPTR)                   0486
*                 ELSE              /* PRINTING TO A DATASET         */
*                   SSSORBA=OUTHOLD;                               0487
         B     @RC00485                                            0487
@RF00485 L     @14,OUTSOBSO(,OCMTBPTR)                             0487
         MVC   SSSORBA(8,@14),OUTHOLD(OCMTBPTR)                    0487
*               END;                                               0488
*             ELSE                                                 0489
*               ;                   /* DS TO BE DELETED, SO DON'T  0489
*                                      NEED TO CKPT                  */
@RF00482 DS    0H                                                  0490
*           END;                                                   0490
*         ELSE                      /* CHECK FURTHER                 */
*           IF ENDSW=YES THEN       /* IF END SUBCMD                 */
*                                                                  0491
         B     @RC00477                                            0491
@RF00477 TM    ENDSW(OCMTBPTR),B'00010000'                         0491
         BNO   @RF00491                                            0491
*             /*******************************************************/
*             /*                                                     */
*             /* 'END' SUBCMD ENTERED                                */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0492
*             DO;                                                  0492
*               ENDKEEP=YES;        /* OVERRIDE ANY 'NOKEEP' STATUS
*                                      SINCE PROCESSING WAS        0493
*                                      INTERRUPTED                   */
         OI    ENDKEEP(OCMTBPTR),B'00000100'                       0493
*               SSSOCHKP=YES;       /* TELL SUBSYS TO CKPT SYSOUT    */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0494
         OI    SSSOCHKP(@14),B'01000000'                           0494
*               IF TERM=YES THEN    /* PRINT TO A TERMINAL, THERE- 0495
*                                      FORE TCAM BUFS LOST AFTER   0495
*                                      ATTENTION.                    */
         TM    TERM(OCMTBPTR),B'00001000'                          0495
         BNO   @RF00495                                            0495
*                 SSSORBA=OUTBKAPX; /* GIVE SUBSYS THE CKPT RBA    0496
*                                      CORRESPONDING TO APPROX 10  0496
*                                      LINES BACK.                   */
         MVC   SSSORBA(8,@14),OUTBKAPX(OCMTBPTR)                   0496
*               ELSE                /* PRINT TO A DS. REST OF RCDS 0497
*                                      WRITTEN DURING CLOSE SO NEED
*                                      NOT BACK UP.                  */
*                 SSSORBA=OUTHOLD;  /* USE CURRENT RBA IN OUTHOLD    */
         B     @RC00495                                            0497
@RF00495 L     @14,OUTSOBSO(,OCMTBPTR)                             0497
         MVC   SSSORBA(8,@14),OUTHOLD(OCMTBPTR)                    0497
*             END;                                                 0498
*           ELSE                                                   0499
*             ;                     /* NO OTHER VALID SUBCMDS        */
@RF00491 DS    0H                                                  0500
*   END ATTNRTN;                    /* END RTN TO HANDLE ATTN        */
@EL00008 DS    0H                                                  0500
@EF00008 DS    0H                                                  0500
@ER00008 LM    @14,@12,@SA00008                                    0500
         BR    @14                                                 0500
*                                                                  0501
*/********************************************************************/
*/*                                                                  */
*/*        END OF DATA ROUTINE                                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0501
*EODRTN:                                                           0501
*   PROC;                           /* INTERNAL TO PRINTRTN - HANDLE
*                                      END OF DATA                   */
EODRTN   STM   @14,@12,@SA00009                                    0501
*   EODSW=OFF;                      /* TURN OFF EOD INDICATOR        */
         NI    EODSW(OCMTBPTR),B'11101111'                         0502
*   IF PAUSE=NO THEN                /* DONT PAUSE FOR SUBCMDS        */
         TM    PAUSE(OCMTBPTR),B'10000000'                         0503
         BNZ   @RF00503                                            0503
*     SKIPGET=YES;                  /* SKIP NEXT GET FROM THIS DS    */
         OI    SKIPGET,B'10000000'                                 0504
*   ELSE                            /* PAUSE FOR SUBCMDS             */
*     DO;                                                          0505
         B     @RC00503                                            0505
@RF00503 DS    0H                                                  0506
*       OUTMSGID=0;                 /* INDICATE MODE MSG NEEDED      */
         MVI   OUTMSGID(OCMTBPTR),X'00'                            0506
*       CALL IKJCT467(OUTCOMTB);    /* CALL MESSAGE HANDLER TO     0507
*                                      RETRIEVE A SUBCMD             */
         ST    OCMTBPTR,@AL00001                                   0507
         L     @15,@CV01406                                        0507
         LA    @01,@AL00001                                        0507
         BALR  @14,@15                                             0507
*       IF ERROR=NO THEN            /* IF SUBCMD RETRIEVED           */
         TM    ERROR(OCMTBPTR),B'00001000'                         0508
         BNZ   @RF00508                                            0508
*         DO;                                                      0509
*           IF POSTED=YES THEN      /* IKJCT467 WAS INTERRUPTED BY 0510
*                                      ATTENTION                     */
         TM    POSTED(OCMTBPTR),B'01000000'                        0510
         BNO   @RF00510                                            0510
*             CALL TCLRQSTK;        /* CALL RTN TO CLEAR Q AND RESET
*                                      THE STACK                     */
         BAL   @14,TCLRQSTK                                        0511
*           ELSE                                                   0512
*             ;                                                    0512
@RF00510 DS    0H                                                  0513
*           CALL IKJCT463(OPTR);    /* CALL SUBCMD HANDLER           */
         L     @14,@PC00001                                        0513
         ST    @14,@AL00001                                        0513
         L     @15,@CV01405                                        0513
         LA    @01,@AL00001                                        0513
         BALR  @14,@15                                             0513
*           IF ERROR=YES THEN       /* IF IKJCT463 FAILED            */
         TM    ERROR(OCMTBPTR),B'00001000'                         0514
         BNO   @RF00514                                            0514
*             DO;                                                  0515
*               SSSOCHKP=NO;        /* DON'T TELL SUBSYS TO CKPT   0516
*                                      SYSOUT SINCE EOF REACHED      */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0516
         NI    SSSOCHKP(@14),B'10111111'                           0516
*             END;                                                 0517
*           ELSE                    /* ELSE IKJCT463 SUCCESSFUL,   0518
*                                      DETERMINE WHICH SUBCMD        */
*             IF SUBCONT=YES&SUBBEGN=YES THEN/* IF CONTINUE BEGIN  0518
*                                      SUBCMD                        */
*                                                                  0518
         B     @RC00514                                            0518
@RF00514 TM    SUBCONT(OCMTBPTR),B'00101000'                       0518
         BNO   @RF00518                                            0518
*               /*****************************************************/
*               /*                                                   */
*               /* 'CONTINUE BEGIN' SUBCMD ENTERED                   */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0519
*               DO;                                                0519
*                 SUBCONT=OFF;      /* TURN OFF SUBCONT INDICATOR    */
*                 SUBBEGN=OFF;      /* TURN OFF SUBBEGN INDICATOR    */
         NI    SUBCONT(OCMTBPTR),B'11010111'                       0521
*                 POINT=YES;        /* TELL '70 TO POINT             */
         OI    POINT(OCMTBPTR),B'10000000'                         0522
*                 OUTHOLD=ZEROS;    /* SET POINT ARG FOR '70         */
         MVC   OUTHOLD(8,OCMTBPTR),@CB01394                        0523
*                 OUTBKAPX=ZEROS;   /* APPROX CTRS AT 1ST RCD AGAIN  */
         MVC   OUTBKAPX(8,OCMTBPTR),@CB01394                       0524
*                 OUTBKNEW=ZEROS;   /* APPROX CTRS AT 1ST RCD AGAIN  */
         MVC   OUTBKNEW(8,OCMTBPTR),@CB01394                       0525
*                 OUTBKCNT=ZERO;    /* START '71 COUNTING AGAIN      */
         SLR   @14,@14                                             0526
         ST    @14,OUTBKCNT(,OCMTBPTR)                             0526
*               END;                                               0527
*             ELSE                  /* CHECK FURTHER                 */
*               IF SUBCONT=YES&SUBHERE=YES THEN/* IF CONTINUE HERE 0528
*                                      SUBCMD                        */
*                                                                  0528
         B     @RC00518                                            0528
@RF00518 TM    SUBCONT(OCMTBPTR),B'00110000'                       0528
         BNO   @RF00528                                            0528
*                 /***************************************************/
*                 /*                                                 */
*                 /* 'CONTINUE HERE' SUBCMD ENTERED                  */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0529
*                 DO;                                              0529
*                   SUBCONT=OFF;    /* TURN OFF SUBCONT INDICATOR. 0530
*                                      LEAVE SUBHERE ON TO TELL    0530
*                                      STARTPT RTN TO IGNORE CKPTS 0530
*                                      AND BEGIN AT START OF NEXT  0530
*                                      SYSOUT DS ACCESSED            */
         NI    SUBCONT(OCMTBPTR),B'11011111'                       0530
*                   SKIPGET=YES;    /* NO MORE READS FOR THIS DS     */
         OI    SKIPGET,B'10000000'                                 0531
*                 END;                                             0532
*               ELSE                /* CHECK FURTHER                 */
*                 IF SUBCONT=YES&SUBNEXT=YES THEN/* IF CONTINUE NEXT
*                                      SUBCMD                        */
*                                                                  0533
         B     @RC00528                                            0533
@RF00528 TM    SUBCONT(OCMTBPTR),B'00100100'                       0533
         BNO   @RF00533                                            0533
*                   /*************************************************/
*                   /*                                               */
*                   /* 'CONTINUE NEXT' SUBCMD ENTERED                */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0534
*                   DO;                                            0534
*                     SKIPGET=YES;  /* SKIP FURTHER GETS FROM DS     */
         OI    SKIPGET,B'10000000'                                 0535
*                     SUBCONT=OFF;  /* TURN OFF SUBCONT INDICATOR    */
*                     SUBNEXT=OFF;  /* TURN OFF SUBNEXT INDICATOR    */
         NI    SUBCONT(OCMTBPTR),B'11011011'                       0537
*                   END;                                           0538
*                 ELSE              /* CHECK FURTHER                 */
*                   IF ENDSW=YES THEN/* IF END SUBCMD                */
*                                                                  0539
         B     @RC00533                                            0539
@RF00533 TM    ENDSW(OCMTBPTR),B'00010000'                         0539
         BNO   @RF00539                                            0539
*                     /***********************************************/
*                     /*                                             */
*                     /* 'END' SUBCMD ENTERED                        */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0540
*                     DO;                                          0540
*                       SSSOCHKP=NO;/* DON'T TELL SUBSYS TO CKPT   0541
*                                      SYSOUT SINCE EOF REACHED      */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0541
         NI    SSSOCHKP(@14),B'10111111'                           0541
*                     END;                                         0542
*                   ELSE                                           0543
*                     ;             /* NO OTHER VALID SUBCMDS        */
@RF00539 DS    0H                                                  0544
*         END;                                                     0544
*       ELSE                                                       0545
*         ;                         /* ELSE SUBCMD NOT RETRIEVED     */
@RF00508 DS    0H                                                  0546
*     END;                                                         0546
*   END EODRTN;                     /* END RTN TO HANDLE EOD         */
@EL00009 DS    0H                                                  0547
@EF00009 DS    0H                                                  0547
@ER00009 LM    @14,@12,@SA00009                                    0547
         BR    @14                                                 0547
*                                                                  0548
*/********************************************************************/
*/*                                                                  */
*/*  WHEN POSTED BIT IS DETECTED, THIS ROUTINE IS CALLED             */
*/*  TO CLEAR THE INPUT QUEUE AND RESET THE STACK.                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0548
*TCLRQSTK:                                                         0548
*   PROC;                                                          0548
TCLRQSTK STM   @14,@12,@SA00010                                    0548
*   DO WHILE POSTED=YES;                                           0549
         B     @DE00549                                            0549
@DL00549 DS    0H                                                  0550
*     POSTED=NO;                    /* TURN OFF POSTED BIT           */
*                                                                  0550
         NI    POSTED(OCMTBPTR),B'10111111'                        0550
*     /***************************************************************/
*     /*                                                             */
*     /* INITIALIZE THE IOPL                                         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0551
*     IOPLPTR=ADDR(IOPLAREA);       /* BASE IOPL                     */
         LA    @14,IOPLAREA(,OCMTBPTR)                             0551
         ST    @14,IOPLPTR(,OCMTBPTR)                              0551
*     IOPLUPT=CPPLUPT;              /* ADDR OF UPT                   */
         L     @05,CPPLPTR(,OCMTBPTR)                              0552
         MVC   IOPLUPT(4,@14),CPPLUPT(@05)                         0552
*     IOPLECT=CPPLECT;              /* ADDR OF ECT                   */
         MVC   IOPLECT(4,@14),CPPLECT(@05)                         0553
*     IOPLECB=ADDR(OUTATTN);        /* ADDR OF ECB                   */
         LA    @05,OUTATTN(,OCMTBPTR)                              0554
         ST    @05,IOPLECB(,@14)                                   0554
*     IOPLIOPB=ADDR(STCKLSTA);      /* ADDR OF STPB IN IOPL          */
*                                                                  0555
         LA    @05,STCKLSTA                                        0555
         ST    @05,IOPLIOPB(,@14)                                  0555
*     /***************************************************************/
*     /*                                                             */
*     /* TCLEARQ                                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0556
*     GEN(TCLEARQ  INPUT);                                         0556
*                                                                  0556
         TCLEARQ  INPUT
*     /***************************************************************/
*     /*                                                             */
*     /* STACK                                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0557
*     STCKLSTA(1:STCKLNGS)=STCKLSTS(1:STCKLNGS);/* LIST TO DYN CORE  */
         L     @14,STCKLNGS                                        0557
         BCTR  @14,0                                               0557
         EX    @14,@SM01595                                        0557
*     REG1=IOPLPTR;                 /* SET PARM REG FOR STACK      0558
*                                                            @OZ01550*/
         L     REG1,IOPLPTR(,OCMTBPTR)                             0558
*     KEY1=NO;                                                     0559
         NI    KEY1(OCMTBPTR),B'01111111'                          0559
*     GEN(MODESET EXTKEY=SUPR);                                    0560
         MODESET EXTKEY=SUPR
*     GEN(STACK MF=(E,(1)));                                       0561
         STACK MF=(E,(1))
*     GEN(MODESET EXTKEY=SCHED);                                   0562
         MODESET EXTKEY=SCHED
*     KEY1=YES;                                                    0563
         OI    KEY1(OCMTBPTR),B'10000000'                          0563
*                                                                  0564
*     /***************************************************************/
*     /*                                                             */
*     /* FREE PREVIOUS BUFFER AND SAVE ADDRESS OF NEW ONE            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0564
*     IF OUTSBBUF^=ZERO THEN        /* THERE IS A PREVIOUS BUFFER TO
*                                      FREE                          */
         L     @14,OUTSBBUF(,OCMTBPTR)                             0564
         LTR   @14,@14                                             0564
         BZ    @RF00564                                            0564
*       DO;                                                        0565
*         REG1=OUTSBBUF;            /* ADDR OF BUFFER TO FREE        */
         LR    REG1,@14                                            0566
*         REG0=PSUBLEN;             /* LEN OF PREVIOUS BUFFER        */
         LH    REG0,PSUBLEN(,@14)                                  0567
*         REG0=REG0|SUBPOOL1;       /* SUBPOOL NO. IN HI ORDER BYTE  */
         O     REG0,@CF01397                                       0568
*         GEN(FREEMAIN R,LV=(0),A=(1));/* FREE PREVIOUS BUFFER       */
         FREEMAIN R,LV=(0),A=(1)
*         OUTSBBUF=OUTSBBUF&&OUTSBBUF;/* INDICATE BUFFER FREED       */
         L     @14,OUTSBBUF(,OCMTBPTR)                             0570
         LR    @05,@14                                             0570
         XR    @05,@14                                             0570
         ST    @05,OUTSBBUF(,OCMTBPTR)                             0570
*       END;                                                       0571
*     ELSE                                                         0572
*       ;                           /* NO BUFFER TO FREE             */
@RF00564 DS    0H                                                  0573
*     OUTSBBUF=OUTEMPSB;            /* SAVE PTR OF SUBCMD RETRIEVED
*                                      BY '72                        */
         MVC   OUTSBBUF(4,OCMTBPTR),OUTEMPSB(OCMTBPTR)             0573
*   END;                            /* END DOWHILE PROCESSING FOR  0574
*                                      ATTN                          */
@DE00549 TM    POSTED(OCMTBPTR),B'01000000'                        0574
         BO    @DL00549                                            0574
*   END TCLRQSTK;                                                  0575
@EL00010 DS    0H                                                  0575
@EF00010 DS    0H                                                  0575
@ER00010 LM    @14,@12,@SA00010                                    0575
         BR    @14                                                 0575
*                                                                  0576
*/********************************************************************/
*/*                                                                  */
*/*     FREE INPUT BUFFERS IF NECCESSARY                             */
*/*     CLOSE SYSOUT DATA SET IF OPENED                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0576
*CLSSYSO:                                                          0576
*   PROC;                           /* INTERNAL PROCEDURE TO CLOSE A
*                                      SYSOUT DATA SET               */
CLSSYSO  STM   @14,@12,@SA00011                                    0576
*/********************************************************************/
*/*    FREE INPUT BUFFERS                                            */
*/********************************************************************/
*                                                                  0577
*   IF FREEBUF=YES THEN             /* NEED TO FREE INPUT BUFFER     */
         TM    FREEBUF,B'10000000'                                 0577
         BNO   @RF00577                                            0577
*     DO;                                                          0578
*       REG1=RPLAREA;               /* ADDR OF AREA TO FREE          */
         L     @14,OUTRPL(,OCMTBPTR)                               0579
         L     REG1,RPLAREA(,@14)                                  0579
*       REG4=RPLBUFL;               /* LENGTH OF AREA TO FREE        */
         L     REG4,RPLBUFL(,@14)                                  0580
*       GEN(FREEMAIN R,LV=(4),A=(1),SP=1);/* ISSUE FREEMAIN          */
         FREEMAIN R,LV=(4),A=(1),SP=1
*       FREEBUF=NO;                                                0582
         NI    FREEBUF,B'01111111'                                 0582
*     END;                                                         0583
*   ELSE                                                           0584
*     ;                                                            0584
*                                                                  0584
@RF00577 DS    0H                                                  0585
*/********************************************************************/
*/*    CLOSE THE ACB                                                 */
*/********************************************************************/
*                                                                  0585
*   IF OPENED=YES THEN              /* A DATA SET IS OPEN            */
         TM    OPENED(OCMTBPTR),B'01000000'                        0585
         BNO   @RF00585                                            0585
*     DO;                                                          0586
*       REG4=ADDR(ACBCORE);         /* ADDR OF ACB TO CLOSE          */
         LA    REG4,ACBCORE                                        0587
*       CLSLSTA(1:LNGCLSTS)=CLSLSTS(1:LNGCLSTS);/* MOVE CLOSE LST TO
*                                      DYN CORE                      */
         L     @14,LNGCLSTS                                        0588
         BCTR  @14,0                                               0588
         EX    @14,@SM01597                                        0588
*       OPENED=NO;                  /* INDICATE SYSOUT NOT OPENED. 0589
*                                      TURN THIS BIT OFF BEFORE    0589
*                                      CLOSE, SO IF CLOSE ABENDS,  0589
*                                      ESTAE WON'T TRY TO CLOSE AGAIN*/
         NI    OPENED(OCMTBPTR),B'10111111'                        0589
*       GEN(CLOSE ((4)),MF=(E,CLSLSTA));/* CLOSE THE ACB             */
         CLOSE ((4)),MF=(E,CLSLSTA)
*     END;                                                         0591
*   ELSE                                                           0592
*     ;                                                            0592
@RF00585 DS    0H                                                  0593
*   END PRINTRTN;                                                  0593
@EL00011 DS    0H                                                  0593
@EF00011 DS    0H                                                  0593
@ER00011 LM    @14,@12,@SA00011                                    0593
         BR    @14                                                 0593
@EL00005 DS    0H                                                  0594
@EF00005 DS    0H                                                  0594
@ER00005 LM    @14,@12,@SA00005                                    0594
         BR    @14                                                 0594
*                                                                  0595
*/********************************************************************/
*/*                                                                  */
*/*    INITIALIZE THE REQUEST BLOCK POINTER AND THE REQUEST BLOCK.   */
*/*    DETERMINE THE NATURE OF THE UNALLOCATION REQUEST AND          */
*/*       INITIALIZE THE NECESSARY TEXT UNITS. SET UP THE POINTER    */
*/*       LIST ACCORDINGLY.                                          */
*/*    ANALYZE THE RETURN CODE AND TAKE APPROPRIATE ACTION.          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0595
*UNALCSO:                                                          0595
*   PROC;                           /* INTERNAL PROCEDURE TO       0595
*                                      UNALLOCATE SYSOUT DATA SET    */
UNALCSO  STM   @14,@12,@SA00012                                    0595
*/********************************************************************/
*/*   SET UP REQUEST BLOCK                                           */
*/********************************************************************/
*                                                                  0596
*   S99RB=S99RB&&S99RB;             /* CLEAR THE REQUEST BLOCK       */
         XC    S99RB(20),S99RB                                     0596
*   S99RBLN=LENGTH(S99RB);          /* LENGTH OF REQUEST BLOCK       */
         MVI   S99RBLN,X'14'                                       0597
*   S99VERB=S99VRBUN;               /* UNALLOCATE VERB CODE          */
         MVI   S99VERB,X'02'                                       0598
*   S99TXTPP=ADDR(PTRLIST);         /* ADDR TEXT UNIT PTR LIST       */
         LA    @14,PTRLIST                                         0599
         ST    @14,S99TXTPP                                        0599
*/********************************************************************/
*/* INITIALIZE THE POINTER LIST AND TEXT UNITS TO ZERO.              */
*/*   SET UP THE TU KEY TO SPECIFY DDNAME - ALWAYS USED.             */
*/********************************************************************/
*                                                                  0600
*   PLIST=''B;                      /* CLEAR POINTER LIST            */
         XC    PLIST(16),PLIST                                     0600
*   UDDNTU=UDDNTU&&UDDNTU;          /* CLEAR DDN UNALC TU            */
         XC    UDDNTU(18),UDDNTU                                   0601
*   UDISPTU=UDISPTU&&UDISPTU;       /* CLEAR OVRIDE DISP TU          */
         XC    UDISPTU(11),UDISPTU                                 0602
*   UHLDQTU=UHLDQTU&&UHLDQTU;       /* CLEAR HOLD TEXT UNIT          */
         XC    UHLDQTU(6),UHLDQTU                                  0603
*   UNONHQTU=UNONHQTU&&UNONHQTU;    /* CLEAR RLSE TEXT UNIT          */
         XC    UNONHQTU(6),UNONHQTU                                0604
*   ELEM=ONE;                       /* INIT INDEX INTO PTR LIST      */
         LA    @05,1                                               0605
         LR    ELEM,@05                                            0605
*   RFY                                                            0606
*     S99TUNIT BASED(S99TUPTR(ELEM));/* BASE TEXT UNIT ON ADDR IN  0606
*                                      CURRENT PTR LIST ELEM         */
*   S99TUPTR(ELEM)=ADDR(UDDNTU);    /* ADR 'DDN UNALC' TU IN PL      */
         LR    @09,ELEM                                            0607
         SLA   @09,2                                               0607
         LA    @08,UDDNTU                                          0607
         AL    @09,@CF01588                                        0607
         ST    @08,S99TUPTR(@09,@14)                               0607
*   S99TUKEY=DUNDDNAM;              /* KEY TO UNALC WITH DDN         */
         MVC   S99TUKEY(2,@08),@CB00924                            0608
*   S99TUNUM=1;                     /* ONE PARAMETER                 */
         MVC   S99TUNUM(2,@08),@CH00033                            0609
*   S99TUPAR(1:8)=OSYSODDN;         /* DDNAME PARM                   */
         MVC   S99TUPAR(8,@08),OSYSODDN(OCMTBPTR)                  0610
*   S99TULNG=8;                     /* LENGTH OF DDNAME PARM         */
         MVC   S99TULNG(2,@08),@CH00047                            0611
*/********************************************************************/
*/*   INITIALIZE THE OTHER NECESSARY TEXT UNITS AND PUT THEIR        */
*/*       ADDRESSES IN THE POINTER LIST                              */
*/********************************************************************/
*                                                                  0612
*                                   /* SET UP KEY 5 TO OVERRIDE    0612
*                                      DISPOSTION                    */
*   ELEM=ELEM+ONE;                  /* INCRE INDEX INTO PTR LST      */
         ALR   ELEM,@05                                            0612
*   S99TUPTR(ELEM)=ADDR(UDISPTU);   /* ADR 'OVRIDE DISP' TU IN PL    */
         LR    @05,ELEM                                            0613
         SLA   @05,2                                               0613
         LA    @09,UDISPTU                                         0613
         AL    @14,@CF01588                                        0613
         ST    @09,S99TUPTR(@05,@14)                               0613
*   S99TUKEY=DUNOVDSP;              /* KEY TO OVERRIDE DISP          */
         MVC   S99TUKEY(2,@09),@CB00932                            0614
*   S99TUNUM=1;                     /* ONE PARAMETER                 */
         MVC   S99TUNUM(2,@09),@CH00033                            0615
*   S99TULNG=1;                     /* LENGTH OF DISP PARM           */
         MVC   S99TULNG(2,@09),@CH00033                            0616
*   IF KEEP=YES|ERROR=YES|ENDKEEP=YES THEN/* IF KEEP SPECIFIED OR  0617
*                                      ERROR OCCURRED OR END       0617
*                                      REQUESTED AFTER ATTN, KEEP THE
*                                      SYSOUT DS                     */
         TM    KEEP(OCMTBPTR),B'10000000'                          0617
         BO    @RT00617                                            0617
         TM    ERROR(OCMTBPTR),B'00001100'                         0617
         BZ    @RF00617                                            0617
@RT00617 DS    0H                                                  0618
*     S99TUPAR(1)=KEEPDISP;         /* SET PARM FOR KEEP DISP        */
         LR    @14,ELEM                                            0618
         SLA   @14,2                                               0618
         L     @05,S99TXTPP                                        0618
         AL    @05,@CF01588                                        0618
         L     @14,S99TUPTR(@14,@05)                               0618
         MVI   S99TUPAR(@14),X'08'                                 0618
*   ELSE                            /* ELSE DELETE THE DS            */
*     S99TUPAR(1)=DELDISP;          /* SET PARM FOR DELETE DISP      */
         B     @RC00617                                            0619
@RF00617 LR    @14,ELEM                                            0619
         SLA   @14,2                                               0619
         L     @05,S99TXTPP                                        0619
         AL    @05,@CF01588                                        0619
         L     @14,S99TUPTR(@14,@05)                               0619
         MVI   S99TUPAR(@14),X'04'                                 0619
*   IF HOLD=YES|ERROR=YES|ENDKEEP=YES THEN/* IF HOLD WAS SPECIFIED OR
*                                      ERROR OCCURRED OR END       0620
*                                      REQUESTED AFTER ATTN, HOLD  0620
*                                      HOLD THE SYSOUT DS            */
@RC00617 TM    HOLD(OCMTBPTR),B'01000000'                          0620
         BO    @RT00620                                            0620
         TM    ERROR(OCMTBPTR),B'00001100'                         0620
         BZ    @RF00620                                            0620
@RT00620 DS    0H                                                  0621
*     DO;                           /* SET UP TXT UNIT FOR KEY59     */
*       ELEM=ELEM+ONE;              /* INCRE INDEX INTO PTR LIST     */
         AH    ELEM,@CH00033                                       0622
*       S99TUPTR(ELEM)=ADDR(UHLDQTU);/* ADR 'OVRIDE W/ HOLD' TU IN 0623
*                                      PTR LIST                      */
         LR    @14,ELEM                                            0623
         SLA   @14,2                                               0623
         LA    @05,UHLDQTU                                         0623
         L     @09,S99TXTPP                                        0623
         AL    @09,@CF01588                                        0623
         ST    @05,S99TUPTR(@14,@09)                               0623
*       S99TUKEY=DUNOVSHQ;          /* KEY TO OVERRIDE W/ HOLD Q     */
         MVC   S99TUKEY(2,@05),@CB01100                            0624
*       S99TUNUM=0;                 /* NO PARMS                      */
         SLR   @14,@14                                             0625
         ST    @14,@TF00001                                        0625
         MVC   S99TUNUM(2,@05),@TF00001+2                          0625
*     END;                                                         0626
*   ELSE                            /* IF NOHOLD SPECIFIED OR      0627
*                                      DEFAULTED                     */
*     DO;                           /* SET UP KEY 0A                 */
         B     @RC00620                                            0627
@RF00620 DS    0H                                                  0628
*       ELEM=ELEM+ONE;              /* INCRE INDEX INTO PTR LIST     */
         AH    ELEM,@CH00033                                       0628
*       S99TUPTR(ELEM)=ADDR(UNONHQTU);/* ADR 'OVRIDE W/ NO HOLD' TU
*                                      IN PTR LIST                   */
         LR    @14,ELEM                                            0629
         SLA   @14,2                                               0629
         LA    @05,UNONHQTU                                        0629
         L     @09,S99TXTPP                                        0629
         AL    @09,@CF01588                                        0629
         ST    @05,S99TUPTR(@14,@09)                               0629
*       S99TUKEY=DUNOVSNH;          /* KEY TO OVRIDE W/ NO HOLDQ     */
         MVC   S99TUKEY(2,@05),@CB00942                            0630
*       S99TUNUM=0;                 /* NO PARMS                      */
         SLR   @14,@14                                             0631
         ST    @14,@TF00001                                        0631
         MVC   S99TUNUM(2,@05),@TF00001+2                          0631
*     END;                                                         0632
*   S99TUPLN(ELEM)=ON;              /* SET LAST TU PTR INDICATOR     */
@RC00620 LR    @14,ELEM                                            0633
         SLA   @14,2                                               0633
         L     @05,S99TXTPP                                        0633
         ALR   @05,@14                                             0633
         AL    @05,@CF01588                                        0633
         OI    S99TUPLN(@05),B'10000000'                           0633
*                                                                  0634
*/********************************************************************/
*/*   INVOKE DYNAMIC UNALLOCATION                                    */
*/********************************************************************/
*                                                                  0634
*   S99RBPTR=ADDR(S99RB);           /* SET UP REQUEST BLOCK PTR      */
         LA    @14,S99RB                                           0634
         ST    @14,S99RBPTR                                        0634
*   REG1=ADDR(S99RBPTR);            /* REG1 PTS TO ADDR S99RB        */
         LA    REG1,S99RBPTR                                       0635
*   S99RBPND=ON;                    /* TURN ON HI ORDER BIT          */
         OI    S99RBPND,B'10000000'                                0636
*   ALLOC=OFF;                      /* INDICATE SYSOUT IS UNALLOC. 0637
*                                      TURN THIS BIT OFF BEFORE    0637
*                                      SVC99, SO IF UNALLOC ABENDS,
*                                      ESTAE WON'T TRY TO UNALLOC  0637
*                                      AGAIN.                        */
         NI    ALLOC(OCMTBPTR),B'11111011'                         0637
*/* MACDATE Y-2 73082                                                */
*                                                                  0638
*   SVC(99);                                                       0638
         SVC   99                                                  0638
*   OUTRTCD=REG15;                  /* SAVE DYN ALLOC RTN CODE       */
         STH   REG15,OUTRTCD(,OCMTBPTR)                            0639
*/********************************************************************/
*/*   ANALYZE DYNAMIC UNALLOCATION RETURN CODE                       */
*/********************************************************************/
*                                                                  0640
*   IF OUTRTCD=ZERO THEN            /* IF UNALLOC WAS SUCCESSFUL     */
         SLR   @14,@14                                             0640
         LH    @05,OUTRTCD(,OCMTBPTR)                              0640
         CR    @05,@14                                             0640
         BNE   @RF00640                                            0640
*     DO;                                                          0641
*       IF S99INFO^=ZERO THEN       /* IF INFO MESSAGE NEEDED        */
         MVC   @ZT00002+2(2),S99INFO                               0642
         C     @14,@ZT00002                                        0642
         BE    @RF00642                                            0642
*         DO;                                                      0643
*           OUTDARB=ADDR(S99RB);    /* SET UP FOR DAIRFAIL           */
         LA    @14,S99RB                                           0644
         ST    @14,OUTDARB(,OCMTBPTR)                              0644
*           OUTMSGID=8;             /* MSG ID FOR IKJCT467           */
         MVI   OUTMSGID(OCMTBPTR),X'08'                            0645
*           CALL IKJCT467(OUTCOMTB);/* CALL MESSAGE HANDLER          */
         ST    OCMTBPTR,@AL00001                                   0646
         L     @15,@CV01406                                        0646
         LA    @01,@AL00001                                        0646
         BALR  @14,@15                                             0646
*         END;                                                     0647
*       ELSE                                                       0648
*         ;                         /* NO INFO MSG NEEDED            */
@RF00642 DS    0H                                                  0649
*     END;                                                         0649
*   ELSE                            /* DYN ALC RETURN CODE NOT ZERO  */
*     DO;                                                          0650
         B     @RC00640                                            0650
@RF00640 DS    0H                                                  0651
*       OUTDARB=ADDR(S99RB);        /* SET UP FOR DAIRFAIL           */
         LA    @14,S99RB                                           0651
         ST    @14,OUTDARB(,OCMTBPTR)                              0651
*       OUTMSGID=8;                 /* MSG ID FOR IKJCT467           */
         MVI   OUTMSGID(OCMTBPTR),X'08'                            0652
*       CALL IKJCT467(OUTCOMTB);    /* CALL MESSAGE HANDLER          */
         ST    OCMTBPTR,@AL00001                                   0653
         L     @15,@CV01406                                        0653
         LA    @01,@AL00001                                        0653
         BALR  @14,@15                                             0653
*       ERROR=YES;                  /* SET QUIT SWITCH               */
         OI    ERROR(OCMTBPTR),B'00001000'                         0654
*       RETNCODE=TWELVE;            /* RETURN CODE OF 12             */
         MVC   RETNCODE(4),@CF00034                                0655
*     END;                                                         0656
*   END UNALCSO;                    /* END OF UNALLOCATION RTN       */
@EL00012 DS    0H                                                  0657
@EF00012 DS    0H                                                  0657
@ER00012 LM    @14,@12,@SA00012                                    0657
         BR    @14                                                 0657
*                                                                  0658
*/********************************************************************/
*/*                                                                  */
*/*    INVOKE SUBSYSTEM TO TELL IT NO MORE PROCESSING FOR THIS       */
*/*      JOB (EARLY TERMINATION, OR NO MORE CLASSES FOR THIS JOB)    */
*/*    ANALYZE THE SUBSYSTEM RETURN CODE AND TAKE APPROPRIATE ACTION.*/
*/*    RETURN TO CALLER.                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0658
*FINISH:                                                           0658
*   PROC;                           /* INTERNAL PROCEDURE TO TELL  0658
*                                      SUBSYS OF COMPLETION          */
FINISH   STM   @14,@12,@SA00013                                    0658
*   SSSOCTRL=ON;                    /* PROCESSING COMPLETE FOR JOB   */
         L     @14,OUTSOBSO(,OCMTBPTR)                             0659
         OI    SSSOCTRL(@14),B'10000000'                           0659
*   SSSOUFLG=SSSOUFLG&&SSSOUFLG;    /* ZERO GROUP REQUEST FLAGS FOR
*                                      FINAL CALL (FLAGS TELL TYPE OF
*                                      GROUP REQUEST)                */
         XC    SSSOUFLG(1,@14),SSSOUFLG(@14)                       0660
*   IF NOWORK=ON THEN               /* NO MORE CLASSES TO SELECT FOR
*                                      JOB. WON'T NEED SUBSYSTEM ANY
*                                      MORE FOR THIS JOB.            */
         TM    NOWORK(OCMTBPTR),B'00000010'                        0661
         BNO   @RF00661                                            0661
*     SSSOFLG1=SSSOFLG1&&SSSOFLG1;  /* ZERO DS SELECTION FLAGS FOR 0662
*                                      THIS SITUATION (FLAGS TELL  0662
*                                      WHAT TO USE FOR SEARCH)       */
         XC    SSSOFLG1(1,@14),SSSOFLG1(@14)                       0662
*   REG1=ADDR(OUTSOBH);             /* PASS ADDR SSOB PTR TO SUBSYS  */
@RF00661 LA    REG1,OUTSOBH(,OCMTBPTR)                             0663
*   HASPABND=ON;                    /* IF SUBSYS ABENDS TELL ESTAE   */
         OI    HASPABND(OCMTBPTR),B'00000001'                      0664
*/*  ? IEFSSREQ;                                                     */
*/*                                                                  */
*/*  PASS CONTROL TO JOB ENTRY SUBSYSTEM TO                          */
*/*  PROCESS REQUEST -                                               */
*/*                                                                  */
*/*    INPUT - REGISTER 1 POINTS TO A ONE-                           */
*/*            WORD PARAMETER LIST WHICH                             */
*/*            POINTS TO THE SSOB                                    */
*/*                                                                  */
*                                                                  0665
*   CALL SSREQ;                     /* INVOKE SUBSYSTEM              */
         L     @05,CVTPTR                                          0665
         L     @05,CVTJESCT(,@05)                                  0665
         L     @15,JESSSREQ(,@05)                                  0665
         BALR  @14,@15                                             0665
*   HASPABND=OFF;                   /* NO LONGER IN SUBSYS           */
         NI    HASPABND(OCMTBPTR),B'11111110'                      0666
*   OUTRTCD=REG15;                  /* SAVE SUSBYS RETURN CODE       */
         STH   REG15,OUTRTCD(,OCMTBPTR)                            0667
*                                                                  0668
*/********************************************************************/
*/*  ANALYZE THE SUBSYSTEM RETURN CODE                               */
*/********************************************************************/
*                                                                  0668
*   IF OUTRTCD^=SSRTOK THEN         /* SUBSYSTEM FAILED              */
         LH    @14,OUTRTCD(,OCMTBPTR)                              0668
         LTR   @14,@14                                             0668
         BZ    @RF00668                                            0668
*     DO;                                                          0669
*       ERROR=YES;                  /* QUIT SWITCH INDICATES ERR     */
         OI    ERROR(OCMTBPTR),B'00001000'                         0670
*       RETNCODE=TWELVE;            /* SET RETURN CODE TO 12         */
         MVC   RETNCODE(4),@CF00034                                0671
*       OUTMSGID=134;               /* ISSUE MSG 346I                */
         MVI   OUTMSGID(OCMTBPTR),X'86'                            0672
*       CALL IKJCT467(OUTCOMTB);    /* CALL MESSAGE HANDLER          */
         ST    OCMTBPTR,@AL00001                                   0673
         L     @15,@CV01406                                        0673
         LA    @01,@AL00001                                        0673
         BALR  @14,@15                                             0673
*     END;                                                         0674
*   ELSE                            /* SUBSYSTEM SUCCESSFUL          */
*     DO;                                                          0675
         B     @RC00668                                            0675
@RF00668 DS    0H                                                  0676
*       SUBSYS=OFF;                 /* SUBSYSTEM HAS COMPLETED DATA
*                                      SET PROCESSING FOR THIS SET OF
*                                      DATA SETS                     */
         NI    SUBSYS(OCMTBPTR),B'01111111'                        0676
*       RETNCODE=FOUR;              /* TELL '69 TO PASS THE NEXT JOB.*/
         MVC   RETNCODE(4),@CF00053                                0677
*     END;                                                         0678
*   END FINISH;                                                    0679
@EL00013 DS    0H                                                  0679
@EF00013 DS    0H                                                  0679
@ER00013 LM    @14,@12,@SA00013                                    0679
         BR    @14                                                 0679
*   END IKJCT462                                                   0680
*                                                                  0680
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IKJOCMTB)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEFJESCT)                                       */
*/*%INCLUDE SYSLIB  (IEFJSSOB)                                       */
*/*%INCLUDE SYSLIB  (IEFZB4D0)                                       */
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IKJCPPL )                                       */
*/*%INCLUDE SYSLIB  (IKJIOPL )                                       */
*                                                                  0680
*       ;                                                          0680
@DATA    DS    0H
@CH00033 DC    H'1'
@CH00823 DC    H'28'
@CH00857 DC    H'44'
@CH01559 DC    H'120'
@SM01575 MVC   SSSOJOBN(0,@05),JOBNAME(@09)
@SM01578 MVC   SSSOJOBI(0,@05),JOBID(@14)
@SM01582 MVC   SSSODEST(0,@14),DESTID(@05)
@SM01592 MVC   OPENLSTA(0),OPENLSTS
@SM01595 MVC   STCKLSTA(0),STCKLSTS
@SM01597 MVC   CLSLSTA(0),CLSLSTS
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@SA00013 DS    15F
@SA00003 DS    15F
@SA00005 DS    15F
@SA00007 DS    15F
@SA00008 DS    15F
@SA00009 DS    15F
@SA00011 DS    15F
@SA00010 DS    15F
@SA00006 DS    0F
@SA00012 DS    0F
@SA00004 DS    0F
         DS    15F
@AL00001 DS    1A
@TF00001 DS    F
@ZTEMPS  DS    0F
@ZT00002 DC    F'0'
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
IKJCT462 CSECT
         DS    0F
@CF00053 DC    F'4'
@CH00053 EQU   @CF00053+2
@CF00047 DC    F'8'
@CH00047 EQU   @CF00047+2
@CF00034 DC    F'12'
@CF00101 DC    F'16'
@CF00813 DC    F'20'
@CH00813 EQU   @CF00813+2
@CF00182 DC    F'24'
@CF01588 DC    F'-4'
@CF01397 DC    XL4'01000000'
@DATD    DSECT
         DS    0D
S99RBPTR DS    AL4
         ORG   S99RBPTR
S99RBPND DS    BL1
         ORG   S99RBPTR+4
S99TUFP  DS    A
RETNCODE DS    F
S99RB    DS    CL20
         ORG   S99RB
S99RBLN  DS    CL1
S99VERB  DS    CL1
S99FLAG1 DS    CL2
         ORG   S99FLAG1
S99FLG11 DS    CL1
         ORG   S99FLG11
S99ONCNV DS    BL1
S99NOCNV EQU   S99FLG11+0
S99NOMNT EQU   S99FLG11+0
S99JBSYS EQU   S99FLG11+0
         ORG   S99FLAG1+1
S99FLG12 DS    CL1
         ORG   S99RB+4
S99RSC   DS    CL4
         ORG   S99RSC
S99ERROR DS    CL2
S99INFO  DS    CL2
         ORG   S99RB+8
S99TXTPP DS    AL4
S99RSV01 DS    FL4
S99FLAG2 DS    CL4
         ORG   S99FLAG2
S99FLG21 DS    CL1
         ORG   S99FLG21
S99WTVOL DS    BL1
S99WTDSN EQU   S99FLG21+0
S99NORES EQU   S99FLG21+0
S99WTUNT EQU   S99FLG21+0
S99OFFLN EQU   S99FLG21+0
S99TIONQ EQU   S99FLG21+0
S99CATLG EQU   S99FLG21+0
S99MOUNT EQU   S99FLG21+0
         ORG   S99FLAG2+1
S99FLG22 DS    CL1
         ORG   S99FLG22
S99UDEVT DS    BL1
S99PCINT EQU   S99FLG22+0
         ORG   S99FLAG2+2
S99FLG23 DS    CL1
S99FLG24 DS    CL1
         ORG   S99RB+20
SKIPDS   DS    BL1
SKIPGET  DS    BL1
FIRSTIME DS    BL1
LOOP     DS    BL1
FREEBUF  DS    BL1
ADSNTU   DS    CL54
ADISPTU  DS    CL7
ASSREQTU DS    CL4
ARTDDNTU DS    CL18
UDDNTU   DS    CL18
UDISPTU  DS    CL11
UHLDQTU  DS    CL6
UNONHQTU DS    CL6
         DS    CL3
ACBCORE  DS    CL76
RPLCORE  DS    CL76
PTRLIST  DS    4A
IKJCT462 CSECT
         DS    0F
@SIZDATD DC    AL1(1)
         DC    AL3(@ENDDATD-@DATD)
@CV01405 DC    V(IKJCT463)
@CV01406 DC    V(IKJCT467)
@CV01407 DC    V(IKJCT470)
@CV01408 DC    V(IKJCT471)
         DS    0D
@CC01391 DC    C'        '
@CB01394 DC    X'0000000000000000'
@CB00924 DC    X'0001'
@CB00926 DC    X'0002'
@CB00930 DC    X'0004'
@CB00932 DC    X'0005'
@CB00942 DC    X'000A'
@CB01092 DC    X'0055'
@CB01100 DC    X'0059'
@CB01106 DC    X'005C'
PATCH62  DS    CL100
         ORG   PATCH62
PTCHINIT DC    20CL5'ZAP62'
         ORG   PATCH62+100
IKJCT462 CSECT
***********************************************************************
*    CREATE RPL  -  LOCAL                                             *
***********************************************************************
INPRPL   RPL ACB=INPACB,                                               *
               OPTCD=(ADR,SEQ,SYN,NUP,MVE)
         EJECT
***********************************************************************
*    CREATE ACB  -  LOCAL                                             *
***********************************************************************
INPACB   ACB   MACRF=(ADR,SEQ,IN)
IKJCT462 CSECT
*                                      /* OPEN LIST FORM-LOCAL       */
OPENLSTS OPEN (0),MF=L
ENDOPENL EQU   *
LNGOLSTS DC  A(ENDOPENL-OPENLSTS)         LENGTH OF LIST
@DATD    DSECT
*                                      /* OPEN LIST FORM-DYNAMIC     */
OPENLSTA OPEN (0),MF=L
IKJCT462 CSECT
*                                      /* CLOSE LIST FORM-LOCAL      */
CLSLSTS  CLOSE (0),MF=L
ENDCLSL  EQU   *
LNGCLSTS DC   A(ENDCLSL-CLSLSTS)          LENGTH OF LIST
@DATD    DSECT
*                                      /* CLOSE LIST FORM-DYNAMIC    */
CLSLSTA  CLOSE (0),MF=L
IKJCT462 CSECT
*                                    /* LIST FORM OF STACK - LOCAL */
STCKLSTS STACK DELETE=ALL,MF=L
ENDSTCKL EQU   *
STCKLNGS DC    A(ENDSTCKL-STCKLSTS)            LENGTH OF LIST
@DATD    DSECT
*                                    /* LIST FORM OF STACK - AUTO */
STCKLSTA STACK DELETE=ALL,MF=L
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IKJCT462 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ELEM     EQU   @02
OCMTBPTR EQU   @03
REG0     EQU   @00
REG1     EQU   @01
REG4     EQU   @04
REG15    EQU   @15
CVTPTR   EQU   16
OUTCOMTB EQU   0
OUTCPPL  EQU   OUTCOMTB
OUTMSGID EQU   OUTCOMTB+4
OUTFLAGS EQU   OUTCOMTB+5
KEY1     EQU   OUTFLAGS
OUTRTCD  EQU   OUTCOMTB+6
OUTATTN  EQU   OUTCOMTB+24
POSTED   EQU   OUTATTN
OUTSOBH  EQU   OUTCOMTB+40
OUTSOBSO EQU   OUTCOMTB+44
OUTRPL   EQU   OUTCOMTB+48
OUTRPLL  EQU   OUTCOMTB+52
OUTACB   EQU   OUTCOMTB+56
OUTACBL  EQU   OUTCOMTB+60
OUTEMPSB EQU   OUTCOMTB+64
OUTHOLD  EQU   OUTCOMTB+68
OUTBKNEW EQU   OUTCOMTB+76
OUTBKAPX EQU   OUTCOMTB+84
OUTBKCNT EQU   OUTCOMTB+92
O73PARM  EQU   OUTCOMTB+100
@NM00002 EQU   O73PARM+16
OUTKEYWD EQU   OUTCOMTB+146
PAUSE    EQU   OUTKEYWD
HOLD     EQU   OUTKEYWD
HERE     EQU   OUTKEYWD
BEGIN    EQU   OUTKEYWD
DELETE   EQU   OUTKEYWD
PRINT    EQU   OUTKEYWD
NEWCLASS EQU   OUTKEYWD
KEEP     EQU   OUTKEYWD+1
DEST     EQU   OUTKEYWD+1
SUBCONT  EQU   OUTKEYWD+1
SUBHERE  EQU   OUTKEYWD+1
SUBBEGN  EQU   OUTKEYWD+1
SUBNEXT  EQU   OUTKEYWD+1
OUTSW    EQU   OUTCOMTB+148
SUBSYS   EQU   OUTSW
ENDSW    EQU   OUTSW
ERROR    EQU   OUTSW
ENDKEEP  EQU   OUTSW
NOWORK   EQU   OUTSW
HASPABND EQU   OUTSW
SYNADERR EQU   OUTSW+1
OPENED   EQU   OUTSW+1
WORKDONE EQU   OUTSW+1
ENDLIST  EQU   OUTSW+1
OUTIDSSW EQU   OUTCOMTB+150
POINT    EQU   OUTIDSSW
EODSW    EQU   OUTIDSSW
TERM     EQU   OUTIDSSW
ALLOC    EQU   OUTIDSSW
INTRPMSG EQU   OUTIDSSW
OUTDARB  EQU   OUTCOMTB+152
OUTXMSG  EQU   OUTCOMTB+164
OUTSBBUF EQU   OUTCOMTB+184
CLASBUFF EQU   OUTCOMTB+244
OSYSODDN EQU   OUTCOMTB+252
OUTPLIST EQU   OUTCOMTB+260
ONEWCPDE EQU   OUTPLIST+8
ODESTPDE EQU   OUTPLIST+12
OUTJBPDE EQU   OUTCOMTB+276
IOPLPTR  EQU   OUTCOMTB+292
IOPLAREA EQU   OUTCOMTB+296
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTJESCT EQU   CVTMAP+296
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
JESCT    EQU   0
JESWAA   EQU   JESCT+8
JESSSREQ EQU   JESCT+20
SSREQ    EQU   0
SSOB     EQU   0
SSOBFUNC EQU   SSOB+6
SSOBRETN EQU   SSOB+12
SSOBINDV EQU   SSOB+16
SSSO     EQU   0
SSSOLEN  EQU   SSSO
SSSOUFLG EQU   SSSO+2
SSSOSETC EQU   SSSOUFLG
SSSODELC EQU   SSSOUFLG
SSSOROUT EQU   SSSOUFLG
SSSOHOLD EQU   SSSOUFLG
SSSORLSE EQU   SSSOUFLG
SSSOFLG1 EQU   SSSO+4
SSSOSHLD EQU   SSSOFLG1
SSSOSCLS EQU   SSSOFLG1
SSSOSJBN EQU   SSSOFLG1
SSSOSJBI EQU   SSSOFLG1
SSSOFLG2 EQU   SSSO+5
SSSOCTRL EQU   SSSOFLG2
SSSOCHKP EQU   SSSOFLG2
SSSOJOBN EQU   SSSO+8
SSSOJOBI EQU   SSSO+16
SSSOCLAS EQU   SSSO+24
SSSODEST EQU   SSSO+28
SSSORBA  EQU   SSSO+44
SSSODSN  EQU   SSSO+52
SSSOCLSL EQU   SSSO+100
S99TUPL  EQU   0
S99TUPTR EQU   S99TUPL
S99TUPLN EQU   S99TUPTR
S99TUP   EQU   0
S99TUNIT EQU   0
S99TUKEY EQU   S99TUNIT
S99TUNUM EQU   S99TUNIT+2
S99TUENT EQU   S99TUNIT+4
S99TULNG EQU   S99TUENT
S99TUPAR EQU   S99TUENT+2
S99TUFLD EQU   0
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBIXLST EQU   ACBAMBL
ACBJWA   EQU   ACBIXLST
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBLFB   EQU   ACBCOMN+20
ACBBUFPL EQU   ACBLFB
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBOPEN  EQU   ACBOFLGS
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBWAPTR EQU   ACBUJFCB
ACBLRECL EQU   ACBCOMN+62
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBK  EQU   RPLCOMN+13
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLBUFL  EQU   RPLCOMN+52
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPL6RBA  EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
CPPL     EQU   0
CPPLUPT  EQU   CPPL+4
CPPLECT  EQU   CPPL+12
IOPL     EQU   0
IOPLUPT  EQU   IOPL
IOPLECT  EQU   IOPL+4
IOPLECB  EQU   IOPL+8
IOPLIOPB EQU   IOPL+12
PSUBBUF  EQU   0
PSUBLEN  EQU   PSUBBUF
JOBNPDE  EQU   0
JOBNMPTR EQU   JOBNPDE
JOBNLEN  EQU   JOBNPDE+4
JOBIDPTR EQU   JOBNPDE+8
JOBIDLEN EQU   JOBNPDE+12
JOBNAME  EQU   0
JOBID    EQU   0
NEWCLPDE EQU   0
NEWCLPTR EQU   NEWCLPDE
NEWCLAS  EQU   0
DESTPDE  EQU   0
DESTPTR  EQU   DESTPDE
DESTLEN  EQU   DESTPDE+4
DESTID   EQU   0
SWAMGR   EQU   0
OPTR     EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CPPLPTR  EQU   OUTCPPL
PLIST    EQU   PTRLIST
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTRV610 EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTRV608 EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
NEWCLLEN EQU   NEWCLPDE+4
NEXTJOB  EQU   JOBNPDE+16
@NM00030 EQU   JOBNPDE+14
@NM00029 EQU   JOBNPDE+6
CPPLPSCB EQU   CPPL+8
CPPLCBUF EQU   CPPL
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00028 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPL6RBA+2
RPLS2S2  EQU   RPL6RBA
RPLS1S1  EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00027 EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLCOMN+12
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBBLKSZ EQU   ACBCOMN+60
ACBBUFSP EQU   ACBCOMN+56
@NM00026 EQU   ACBWAPTR+1
ACBOPTN  EQU   ACBWAPTR
ACBVVIC  EQU   ACBINFLG
@NM00025 EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00024 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00023 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00022 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
@NM00021 EQU   ACBCOMN+28
@NM00020 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00019 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00018 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
@NM00017 EQU   ACBBUFPL
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+14
@NM00016 EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
ACBCHN   EQU   ACBMACR2
ACBCBRD  EQU   ACBMACR2
ACBCBOPN EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
S99TUPRM EQU   S99TUFLD+2
S99TULEN EQU   S99TUFLD
S99TUPND EQU   S99TUP
SSSODSID EQU   SSSO+112
SSSOWTRC EQU   SSSO+108
SSSOFORM EQU   SSSO+96
SSSOPGMN EQU   SSSO+36
@NM00015 EQU   SSSO+25
SSSOCOPY EQU   SSSO+6
@NM00014 EQU   SSSOFLG2
@NM00013 EQU   SSSOFLG1
SSSOSFRM EQU   SSSOFLG1
SSSOSPGM EQU   SSSOFLG1
SSSOSDST EQU   SSSOFLG1
@NM00012 EQU   SSSO+3
@NM00011 EQU   SSSOUFLG
SSOBSSIB EQU   SSOB+8
SSOBLEN  EQU   SSOB+4
SSOBID   EQU   SSOB
JESPJESN EQU   JESCT+28
JESSSCT  EQU   JESCT+24
JESRESQM EQU   JESCT+16
JESQMGR  EQU   JESCT+12
JESUNITS EQU   JESCT+4
@NM00010 EQU   JESCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00009 EQU   CVTFIX+248
@NM00008 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
EWAPTR   EQU   OUTCOMTB+288
OSVDSPDE EQU   OUTCOMTB+284
OUTCLPDE EQU   OUTCOMTB+280
OPRDSPDE EQU   OUTPLIST+4
OUTCPDE1 EQU   OUTPLIST
OUTWORK  EQU   OUTCOMTB+196
OUTSTAE  EQU   OUTCOMTB+188
OUTSBPDL EQU   OUTCOMTB+180
OHELPECB EQU   OUTCOMTB+176
OUTTCBH  EQU   OUTCOMTB+172
OUTXRPLY EQU   OUTCOMTB+168
OUTSYNMS EQU   OUTXMSG
OUTPDL   EQU   OUTCOMTB+160
OUTDAIR  EQU   OUTCOMTB+156
@NM00007 EQU   OUTIDSSW
@NM00006 EQU   OUTIDSSW
@NM00005 EQU   OUTIDSSW
NONTERM  EQU   OUTSW+1
UNALCALL EQU   OUTSW
SUBCMODE EQU   OUTSW
NEXT     EQU   OUTKEYWD
OUTRECL  EQU   OUTCOMTB+144
OUTRECA  EQU   OUTCOMTB+140
OUTBUFL  EQU   @NM00002+2
OUTRECUN EQU   @NM00002+1
NOMEMNAM EQU   @NM00002+1
NEWDS    EQU   @NM00002+1
NEEDFREE EQU   @NM00002+1
OUTRECV  EQU   @NM00002+1
DSOPEN   EQU   @NM00002+1
DSALLOC  EQU   @NM00002+1
@NM00004 EQU   @NM00002+1
@NM00003 EQU   @NM00002
OUTBUFA  EQU   O73PARM+12
PRINTDDN EQU   O73PARM+4
OUTDCB   EQU   O73PARM
STRCTNUM EQU   OUTCOMTB+96
OUTEMPMN EQU   OUTCOMTB+32
OUTEXTRA EQU   OUTCOMTB+28
@NM00001 EQU   OUTATTN
OUTCMDNM EQU   OUTCOMTB+16
OUTMACN  EQU   OUTCOMTB+8
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00136 EQU   @EL00002
@RC00134 EQU   @EL00002
@RC00154 EQU   @EL00002
@RC00166 EQU   @EL00003
@RC00322 EQU   @EL00004
@RC00384 EQU   @EL00006
@RC00426 EQU   @EL00007
@RC00491 EQU   @EL00008
@RC00477 EQU   @EL00008
@RC00463 EQU   @EL00008
@RC00453 EQU   @EL00008
@RC00446 EQU   @EL00008
@RC00503 EQU   @EL00009
@RC00508 EQU   @EL00009
@PB00011 EQU   @EL00005
@RC00640 EQU   @EL00012
@RC00668 EQU   @EL00013
@RC00257 EQU   @RC00166
@RC00251 EQU   @RC00166
@RC00245 EQU   @RC00166
@RC00239 EQU   @RC00166
@RC00231 EQU   @RC00166
@RC00206 EQU   @RC00166
@RC00176 EQU   @RC00166
@RC00168 EQU   @RC00166
@RC00387 EQU   @RC00384
@RC00385 EQU   @RC00384
@RC00449 EQU   @RC00446
@RC00482 EQU   @RC00477
@RC00495 EQU   @RC00491
@RC00533 EQU   @RC00508
@RC00528 EQU   @RC00508
@RC00518 EQU   @RC00508
@RC00514 EQU   @RC00508
@PB00010 EQU   @PB00011
@RC00172 EQU   @RC00168
@RC00198 EQU   @RC00176
@RC00192 EQU   @RC00176
@RC00178 EQU   @RC00176
@RC00208 EQU   @RC00206
@RC00485 EQU   @RC00482
@PB00009 EQU   @PB00010
@RC00185 EQU   @RC00178
@RC00179 EQU   @RC00178
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@RC00345 EQU   @PB00006
@ENDDATA EQU   *
         END   IKJCT462,(C'PLS2038',0603,74364)
