BEM1     TITLE 'TSO EDIT COMMAND - IKJEBEM1 - MESSAGE MODULE ONE'
IKJEBEM1 CSECT
***********************************************************************
*                                                                     *
* STATUS -- VERSION NO. 01, OS/360 RELEASE NO. 20                     *
*                                                                     *
* FUNCTION --                                                         *
*    THIS CONTROL SECTION CONTAINS MESSAGE CONTROL LISTS FOR EDIT     *
*    COMMAND MESSAGES, AND BEGINS WITH A VECTOR TABLE TO ADDRESS      *
*    THEM BY RELATIVE MESSAGE NUMBER.  SECOND-LEVEL MESSAGE CONTROL   *
*    LISTS ARE CHAINED TO AN INDEX CONTAINED IN THE FIRST-LEVEL       *
*    CONTROL LIST OR IN THE PRECEDING SECOND-LEVEL LIST.  THIS        *
*    CONTROL SECTION CONTAINS NO EXECUTABLE CODE.  THIS CSECT IS      *
*    LOADED AND DELETED BY THE IKJEBEMS (MESSAGE SELECTION) ROUTINE.  *
*                                                                     *
* ENTRY POINTS --                                                     *
*         IKJEBEM1 - THIS MODULE IS LOADED BY IKJEBEMS WHEN IT IS     *
*         DETERMINED THAT IT CONTAINS A MESSAGE REQUESTED BY AN EDIT  *
*         SUBCOMMAND OR SERVICE ROUTINE.                              *
*                                                                     *
* INPUT -- N/A.                                                       *
*                                                                     *
* OUTPUT -- N/A.                                                      *
*                                                                     *
* EXTERNAL REFERENCES --                                              *
*                                                                     *
*         THE DATA IN THIS MODULE IS GENERATED BY THE FOLLOWING       *
*         MACRO INSTRUCTIONS --                                       *
*                                                                     *
*         IKJEBEMB - BUILDS INDIVIDUAL MESSAGE CONTROL LISTS.         *
*                                                                     *
*         IKJEBEMT - CONSTRUCTS A VECTOR TABLE FOR N MESSAGE CONTROL  *
*         LISTS INDEXED BY RELATIVE MESSAGE NUMBER.                   *
*                                                                     *
* EXITS, NORMAL -- N/A.                                               *
*                                                                     *
* EXITS, ERROR -- N/A.                                                *
*                                                                     *
* TABLES/WORK AREAS --                                                *
*                                                                     *
*    1.  VECTOR TABLE (MSGPTTBL) FORMAT -                             *
*                                                                     *
*    LABEL   OFFSET   CONTENTS                                        *
*                                                                     *
*    M00     00       ADDRESS OF RELATIVE MESSAGE 0                   *
*    M01     04       ADDRESS OF RELATIVE MESSAGE 1                   *
*    .       .        .                                               *
*    .       .        .                                               *
*    .       .        .                                               *
*    M(N-1)  4(N-1)   ADDRESS OF RELATIVE MESSAGE (N-1)               *
*                                                                     *
*    2.  MESSAGE CONTROL LIST FORMAT --                               *
*                                                                     *
*    LENGTH   OFFSET   CONTENTS                                       *
*                                                                     *
*    4        0        ADDRESS OF NEXT LEVEL-2 LIST (0 IF NONE)       *
*    2        4        LENGTH OF BASIC MESSAGE TEXT + 4               *
*    2        6        ALWAYS ZERO                                    *
*    VARIES   8        MESSAGE TEXT                                   *
*                                                                     *
* ATTRIBUTES --                                                       *
*    REFRESHABLE, ENABLED, NON-PRIVILEGED                             *
*                                                                     *
* CHARACTER CODE DEPENDENCY -- NONE.                                  *
*                                                                     *
* NOTES -- NONE.                                                      *
*                                                                     *
***********************************************************************
         SPACE 2
         IKJEBEMT 17              BUILD TABLE FOR ADDRESSING MSGS
         SPACE 2
* THE FOLLOWING ARE DUMMY LABELS FOR MESSAGES REMOVED FROM THIS
* CONTROL SECTION -
M02      EQU   *              DUMMY MESSAGE - REL MSG 02 REMOVED
M03      EQU   *              DUMMY MESSAGE - REL MSG 03 REMOVED
M07      EQU   *              DUMMY MESSAGE - REL MSG 07 REMOVED
M08      EQU   *              DUMMY MESSAGE - REL MSG 08 REMOVED
M09      EQU   *              DUMMY MESSAGE - REL MSG 09 REMOVED
M10      EQU   *              DUMMY MESSAGE - REL MSG 10 REMOVED
M12      EQU   *              DUMMY MESSAGE - REL MSG 12 REMOVED
         EJECT
M00      IKJEBEMB M01L1,'301I UTILITY DATA SET NOT ALLOCATED, TOO MANY X
               DATA SETS+'
*THE INSERTION FOR DATA SET NAME IN M01 HAS AN OFFSET OF 19
M01      IKJEBEMB M01L1,'301I DATA SET  NOT ALLOCATED, TOO MANY DATA SEX
               TS+'
M01L1    IKJEBEMB 0,'301I USE FREE COMMAND TO FREE UNUSED DATA SETS'
M04      IKJEBEMB M05L1,'304I UTILITY DATA SET NOT ALLOCATED, SYSTEM ORX
                INSTALLATION ERROR+'
         EJECT
* THE INSERTION FOR DATA SET NAME IN M05 HAS AN OFFSET OF 19
M05      IKJEBEMB M05L1,'304I DATA SET  NOT ALLOCATED, SYSTEM OR INSTALX
               LATION ERROR+'
* THE INSERTION IN M05L1 FOR DYNAMIC ALLOCATION RETURN CODE HAS AN
* OFFSET OF 40
M05L1    IKJEBEMB M05L2,'304I DYNAMIC ALLOCATION ERROR CODE  '
*THE INSERTION IN M05L2 FOR CATALOG RETURN CODE HAS AN OFFSET OF 29
M05L2    IKJEBEMB M05L3,'304I CATALOG ERROR CODE  '
M05L3    IKJEBEMB 0,'304I CATALOG I/O ERROR'
         EJECT
* THE INSERTION FOR DATA SET NAME IN M06 HAS AN OFFSET OF 19
M06      IKJEBEMB 0,'314I DATA SET  RESIDES ON MULTIPLE VOLUMES, NOT SUX
               PPORTED'
* THE INSERTION FOR DATA SET NAME IN M11 HAS AN OFFSET OF 19
M11      IKJEBEMB M11L1,'309I DATA SET  NOT USEABLE+'
* THE INSERTION FOR OPEN ERROR CODE IN M11L1 HAS AN OFFSET OF 26
M11L1    IKJEBEMB M11L2,'309I OPEN ERROR CODE  '
* THE INSERTION FOR I/O SYNAD ERROR IN M11L2 HAS AN OFFSET OF 26
M11L2    IKJEBEMB M11L3,'309I I/O SYNAD ERROR '
         EJECT
M11L3    IKJEBEMB 0,'309I CANNOT OPEN DATA SET'
* THE INSERTION FOR MEMBER NAME IN M13 HAS AN OFFSET OF 17
* THE INSERTION FOR DATA SET NAME IN M13 HAS AN OFFSET OF 32
M13      IKJEBEMB 0,'311I MEMBER  SPECIFIED BUT  NOT A PARTITIONED DATAX
                SET'
* THE INSERTION FOR COMMAND OR SUBCOMMAND IS AT OFFSET 45
M14      IKJEBEMB 0,'312I INSUFFICIENT  STORAGE  TO  EXECUTE '
M15      IKJEBEMB M15L1,'313I COMMAND SYSTEM ERROR+'
         EJECT
* THE INSERTION FOR SERVICE ROUTINE NAME IN M15L1 HAS AN OFFSET OF 10
* THE INSERTION FOR ERROR RETURN CODE IN M15L1 HAS AN OFFSET OF 22
M15L1    IKJEBEMB 0,'313I  ERROR CODE  '
M16      IKJEBEMB M11L1,'309I UTILITY DATA SET NOT USABLE+'
         END
