BEM3     TITLE 'TSO EDIT COMMAND - IKJEBEM3 - MESSAGE MODULE THREE'
IKJEBEM3 CSECT
***********************************************************************
*                                                                     *
* STATUS -- VERSION NO. 01, OS/360 RELEASE NO. 20                     *
*                                                                     *
* FUNCTION --                                                         *
*    THIS CONTROL SECTION CONTAINS MESSAGE CONTROL LISTS FOR EDIT     *
*    COMMAND MESSAGES, AND BEGINS WITH A VECTOR TABLE TO ADDRESS      *
*    THEM BY RELATIVE MESSAGE NUMBER.  SECOND-LEVEL MESSAGE CONTROL   *
*    LISTS ARE CHAINED TO AN INDEX CONTAINED IN THE FIRST-LEVEL       *
*    CONTROL LIST OR IN THE PRECEDING SECOND-LEVEL LIST.  THIS        *
*    CONTROL SECTION CONTAINS NO EXECUTABLE CODE.  THIS CSECT IS      *
*    LOADED AND DELETED BY THE IKJEBEMS (MESSAGE SELECTION) ROUTINE.  *
*                                                                     *
* ENTRY POINTS --                                                     *
*         IKJEBEM3 - THIS MODULE IS LOADED BY IKJEBEMS WHEN IT IS     *
*         DETERMINED THAT IT CONTAINS A MESSAGE REQUESTED BY AN EDIT  *
*         SUBCOMMAND OR SERVICE ROUTINE.                              *
*                                                                     *
* INPUT -- N/A.                                                       *
*                                                                     *
* OUTPUT -- N/A.                                                      *
*                                                                     *
* EXTERNAL REFERENCES --                                              *
*                                                                     *
*         THE DATA IN THIS MODULE IS GENERATED BY THE FOLLOWING       *
*         MACRO INSTRUCTIONS --                                       *
*                                                                     *
*         IKJEBEMB - BUILDS INDIVIDUAL MESSAGE CONTROL LISTS.         *
*                                                                     *
*         IKJEBEMT - CONSTRUCTS A VECTOR TABLE FOR N MESSAGE CONTROL  *
*         LISTS INDEXED BY RELATIVE MESSAGE NUMBER.                   *
*                                                                     *
* EXITS, NORMAL -- N/A.                                               *
*                                                                     *
* EXITS, ERROR -- N/A.                                                *
*                                                                     *
* TABLES/WORK AREAS --                                                *
*                                                                     *
*    1.  VECTOR TABLE (MSGPTTBL) FORMAT -                             *
*                                                                     *
*    LABEL   OFFSET   CONTENTS                                        *
*                                                                     *
*    M00     00       ADDRESS OF RELATIVE MESSAGE 0                   *
*    M01     04       ADDRESS OF RELATIVE MESSAGE 1                   *
*    .       .        .                                               *
*    .       .        .                                               *
*    .       .        .                                               *
*    M(N-1)  4(N-1)   ADDRESS OF RELATIVE MESSAGE (N-1)               *
*                                                                     *
*    2.  MESSAGE CONTROL LIST FORMAT --                               *
*                                                                     *
*    LENGTH   OFFSET   CONTENTS                                       *
*                                                                     *
*    4        0        ADDRESS OF NEXT LEVEL-2 LIST (0 IF NONE)       *
*    2        4        LENGTH OF BASIC MESSAGE TEXT + 4               *
*    2        6        ALWAYS ZERO                                    *
*    VARIES   8        MESSAGE TEXT                                   *
*                                                                     *
* ATTRIBUTES --                                                       *
*    REFRESHABLE, ENABLED, NON-PRIVILEGED                             *
*                                                                     *
* CHARACTER CODE DEPENDENCY -- NONE.                                  *
*                                                                     *
* NOTES -- NONE.                                                      *
*                                                                     *
***********************************************************************
         IKJEBEMT 12          BUILD TABLE FOR ADDRESSING MESSAGES
         EJECT
*INSERTION FOR STARTING COLUMN IN M00 HAS A VALUE OF 53
*INSERTION FOR LENGTH IN M00 HAS A VALUE OF 54
M00      IKJEBEMB M00L1,'360I INVALID LINE NUMBER FIELD SPECIFIED, USINX
               G , +'
M00L1    IKJEBEMB M00L2,'360I STARTING COLUMN MUST BE WITHIN THE RANGE X
               73-80'
M00L2    IKJEBEMB M00L3,'360I LINE NUMBER FIELD FALLS OUTSIDE RECORD SIX
               ZE'
M00L3    IKJEBEMB 0,'360I LINE NUMBER FIELD OPERANDS ARE VALID FOR ASM X
               DATA SETS ONLY'
         EJECT
*INSERTION FOR DATA SET TYPE IN M01 HAS A VALUE OF 27
M01      IKJEBEMB 0,'361I ASIS INVALID FOR  DATA SET, USING CAPS'
*INSERTION FOR DATA SET TYPE IN M02 HAS A VALUE OF 28
M02      IKJEBEMB 0,'362I NONUM INVALID FOR  DATA SET, USING NUM OPTIONX
               '
* THE INSERTION FOR RECORD FORMAT IN M03 HAS AN OFFSET OF 24
M03      IKJEBEMB 0,'331I RECORD FORMAT  NOT ACCEPTABLE'
* THE INSERTION FOR LINE NUMBER IN M04 HAS AN OFFSET OF 61
M04      IKJEBEMB M04L1,'565I INCOMPLETE SCAN FOR LINE NUMBER REFERENCEX
               S IN LINE +'
         EJECT
M04L1    IKJEBEMB 0,'565I SYNTAX ERROR OR NON-EXISTENT LINE NUMBER REFEX
               RENCED'
*INSERTION FOR FIRST MARGIN IN M05 HAS A VALUE OF 33
*INSERTION FOR LAST MARGIN IN M05 HAS A VALUE OF 34
M05      IKJEBEMB M05L1,'365I INVALID SOURCE MARGIN (,)+'
M05L1    IKJEBEMB 0,'365I SPECIFIED SOURCE MARGIN FALLS OUTSIDE LINE LIX
               MITS'
*INSERTION FOR LINE NUMBER IN M06 HAS A VALUE OF 48
M06      IKJEBEMB 0,'400I INPUT TERMINATED, NEXT LINE NUMBER IS '
         EJECT
* INSERTION FOR COMMAND NAME IN M07 HAS A VALUE OF 30
M07      IKJEBEMB 0,'425I COMMAND NOT FOUND - '
* INSERTION FOR LIMIT IN M08 HAS A VALUE OF 28
M08      IKJEBEMB 0,'402I LINE NUMBER LIMIT  EXCEEDED'
* THE INSERTION FOR DATA SET TYPE IN M09 HAS AN OFFSET OF 10
M09      IKJEBEMB 0,'423I  DATA SET CANNOT BE RUN'
* THE INSERTION FOR DATA SET NAME IN M10 HAS AN OFFSET OF 10
M10      IKJEBEMB 0,'339I  ALREADY EXISTS'
         EJECT
* INSERTION FOR COMMAND NAME IN M11 IS AT OFFSET 30
M11      IKJEBEMB 0,'425I COMMAND NOT FOUND - '
         END
