BEM4     TITLE 'TSO EDIT COMMAND - IKJEBEM4 - MESSAGE MODULE FOUR'
IKJEBEM4 CSECT
***********************************************************************
*                                                                     *
* STATUS -- VERSION NO. 01, OS/360 RELEASE NO. 20                     *
*                                                                     *
* FUNCTION --                                                         *
*    THIS CONTROL SECTION CONTAINS MESSAGE CONTROL LISTS FOR EDIT     *
*    COMMAND MESSAGES, AND BEGINS WITH A VECTOR TABLE TO ADDRESS      *
*    THEM BY RELATIVE MESSAGE NUMBER.  SECOND-LEVEL MESSAGE CONTROL   *
*    LISTS ARE CHAINED TO AN INDEX CONTAINED IN THE FIRST-LEVEL       *
*    CONTROL LIST OR IN THE PRECEDING SECOND-LEVEL LIST.  THIS        *
*    CONTROL SECTION CONTAINS NO EXECUTABLE CODE.  THIS CSECT IS      *
*    LOADED AND DELETED BY THE IKJEBEMS (MESSAGE SELECTION) ROUTINE.  *
*                                                                     *
* ENTRY POINTS --                                                     *
*         IKJEBEM4 - THIS MODULE IS LOADED BY IKJEBEMS WHEN IT IS     *
*         DETERMINED THAT IT CONTAINS A MESSAGE REQUESTED BY AN EDIT  *
*         SUBCOMMAND OR SERVICE ROUTINE.                              *
*                                                                     *
* INPUT -- N/A.                                                       *
*                                                                     *
* OUTPUT -- N/A.                                                      *
*                                                                     *
* EXTERNAL REFERENCES --                                              *
*                                                                     *
*         THE DATA IN THIS MODULE IS GENERATED BY THE FOLLOWING       *
*         MACRO INSTRUCTIONS --                                       *
*                                                                     *
*         IKJEBEMB - BUILDS INDIVIDUAL MESSAGE CONTROL LISTS.         *
*                                                                     *
*         IKJEBEMT - CONSTRUCTS A VECTOR TABLE FOR N MESSAGE CONTROL  *
*         LISTS INDEXED BY RELATIVE MESSAGE NUMBER.                   *
*                                                                     *
* EXITS, NORMAL -- N/A.                                               *
*                                                                     *
* EXITS, ERROR -- N/A.                                                *
*                                                                     *
* TABLES/WORK AREAS --                                                *
*                                                                     *
*    1.  VECTOR TABLE (MSGPTTBL) FORMAT -                             *
*                                                                     *
*    LABEL   OFFSET   CONTENTS                                        *
*                                                                     *
*    M00     00       ADDRESS OF RELATIVE MESSAGE 0                   *
*    M01     04       ADDRESS OF RELATIVE MESSAGE 1                   *
*    .       .        .                                               *
*    .       .        .                                               *
*    .       .        .                                               *
*    M(N-1)  4(N-1)   ADDRESS OF RELATIVE MESSAGE (N-1)               *
*                                                                     *
*    2.  MESSAGE CONTROL LIST FORMAT --                               *
*                                                                     *
*    LENGTH   OFFSET   CONTENTS                                       *
*                                                                     *
*    4        0        ADDRESS OF NEXT LEVEL-2 LIST (0 IF NONE)       *
*    2        4        LENGTH OF BASIC MESSAGE TEXT + 4               *
*    2        6        ALWAYS ZERO                                    *
*    VARIES   8        MESSAGE TEXT                                   *
*                                                                     *
* ATTRIBUTES --                                                       *
*    REFRESHABLE, ENABLED, NON-PRIVILEGED                             *
*                                                                     *
* CHARACTER CODE DEPENDENCY -- NONE.                                  *
*                                                                     *
* NOTES -- NONE.                                                      *
*                                                                     *
***********************************************************************
         IKJEBEMT 13          BUILD TABLE FOR ADDRESSING MESSAGES
         EJECT
M00      IKJEBEMB 0,'550I NO OPERAND, SUBCOMMAND IGNORED'
*INSERTION FOR 'BS' OR 'ATTN' HAS A VALUE OF 10
M01      IKJEBEMB 0,'551I  NOT AVAILABLE ON THIS TERMINAL'
*INSERTION FOR EDIT DATA SET NAME IN M02 HAS A VALUE OF 24
*INSERTION FOR SAVE DATA SET NAME IN M02 HAS A VALUE OF 43
M02      IKJEBEMB M02L1,'552I EDIT DATA SET  AND SAVE DATA SET  ARE NOTX
                COMPATIBLE+'
*INSERTION FOR EDIT RECORD FORMAT IN M02L1 HAS A VALUE OF 28
*INSERTION FOR SAVE RECORD FORMAT IN M02L1 HAS A VALUE OF 62
M02L1    IKJEBEMB M02L2,'552I EDIT DATA SET HAS  RECORD FORMAT, SAVE DAX
               TA SET HAS  RECORD FORMAT, USE ANOTHER DATA SET'
         EJECT
* THE INSERTION FOR EDIT DATA SET LRECL IN M02L2 HAS AN OFFSET OF 38
* THE INSERTION FOR SAVE DATA SET LRECL IN M02L2 HAS AN OFFSET OF 68
M02L2    IKJEBEMB M02L3,'552I EDIT DATA SET HAS LINE SIZE , SAVE DATA SX
               ET HAS LINE SIZE , USE ANOTHER DATA SET'
* THE INSERTION FOR EDIT BLOCK SIZE IN M02L3 HAS AN OFFSET OF 41
* THE INSERTION FOR SAVE BLOCK SIZE IN M02L3 HAS AN OFFSET OF 74
M02L3    IKJEBEMB 0,'552I EDIT DATA SET HAS BLOCK LENGTH , SAVE DATA SEX
               T HAS BLOCK LENGTH , USE ANOTHER DATA SET'
M03      IKJEBEMB 0,'553I SAVED, DATA SET IS EMPTY'
M04      IKJEBEMB 0,'554I BLOCK VALUE TOO LARGE FOR OUTPUT DEVICE, NOTHX
               ING SAVED'
         EJECT
M05      IKJEBEMB 0,'555I NOTHING SAVED'
*INSERTION FOR TABSET IN M06 HAS A VALUE OF 20
*INSERTION FOR LENGTH IN M06 HAS A VALUE OF 52
M06      IKJEBEMB 0,'556I TABSET OF  EXCEEDS MAXIMUM DATA LENGTH OF '
M07      IKJEBEMB 0,'557I ONLY FIRST 10 VALID TABS USED'
M08      IKJEBEMB 0,'558I LINE OVERFLOW, NEW LINE CREATED'
         EJECT
M09      IKJEBEMB 0,'559I MISSING COUNT OR STRING'
M10      IKJEBEMB 0,'560I LINE NUMBER LENGTH EXCEEDS LINE SIZE'
* THE INSERTION FOR LINE NUMBER IN M11 IS AT OFFSET 49
M11      IKJEBEMB 0,'561I INSERT TERMINATED, NEXT LINE NUMBER IS '
M12      IKJEBEMB 0,'562I TABSET OF 0 IGNORED'
         END
