BEM5     TITLE 'TSO EDIT COMMAND - IKJEBEM5 - MESSAGE MODULE FIVE'
IKJEBEM5 CSECT
*A904500-910500                                                  Y01156
*C536000                                                         Y01156
*A824500-825000                                                  Y02676
*C832000                                                         Y02676
***********************************************************************
*                                                                     *
* STATUS -- VERSION NO. 01, OS/360 RELEASE NO. 20                     *
*                                                                     *
* FUNCTION --                                                         *
*    THIS CONTROL SECTION CONTAINS MESSAGE CONTROL LISTS FOR EDIT     *
*    COMMAND MESSAGES, AND BEGINS WITH A VECTOR TABLE TO ADDRESS      *
*    THEM BY RELATIVE MESSAGE NUMBER.  SECOND-LEVEL MESSAGE CONTROL   *
*    LISTS ARE CHAINED TO AN INDEX CONTAINED IN THE FIRST-LEVEL       *
*    CONTROL LIST OR IN THE PRECEDING SECOND-LEVEL LIST.  THIS        *
*    CONTROL SECTION CONTAINS NO EXECUTABLE CODE.  THIS CSECT IS      *
*    LOADED AND DELETED BY THE IKJEBEMS (MESSAGE SELECTION) ROUTINE.  *
*                                                                     *
* ENTRY POINTS --                                                     *
*         IKJEBEM5 - THIS MODULE IS LOADED BY IKJEBEMS WHEN IT IS     *
*         DETERMINED THAT IT CONTAINS A MESSAGE REQUESTED BY AN EDIT  *
*         SUBCOMMAND OR SERVICE ROUTINE.                              *
*                                                                     *
* INPUT -- N/A.                                                       *
*                                                                     *
* OUTPUT -- N/A.                                                      *
*                                                                     *
* EXTERNAL REFERENCES --                                              *
*                                                                     *
*         THE DATA IN THIS MODULE IS GENERATED BY THE FOLLOWING       *
*         MACRO INSTRUCTIONS --                                       *
*                                                                     *
*         IKJEBEMB - BUILDS INDIVIDUAL MESSAGE CONTROL LISTS.         *
*                                                                     *
*         IKJEBEMT - CONSTRUCTS A VECTOR TABLE FOR N MESSAGE CONTROL  *
*         LISTS INDEXED BY RELATIVE MESSAGE NUMBER.                   *
*                                                                     *
* EXITS, NORMAL -- N/A.                                               *
*                                                                     *
* EXITS, ERROR -- N/A.                                                *
*                                                                     *
* TABLES/WORK AREAS --                                                *
*                                                                     *
*    1.  VECTOR TABLE (MSGPTTBL) FORMAT -                             *
*                                                                     *
*    LABEL   OFFSET   CONTENTS                                        *
*                                                                     *
*    M00     00       ADDRESS OF RELATIVE MESSAGE 0                   *
*    M01     04       ADDRESS OF RELATIVE MESSAGE 1                   *
*    .       .        .                                               *
*    .       .        .                                               *
*    .       .        .                                               *
*    M(N-1)  4(N-1)   ADDRESS OF RELATIVE MESSAGE (N-1)               *
*                                                                     *
*    2.  MESSAGE CONTROL LIST FORMAT --                               *
*                                                                     *
*    LENGTH   OFFSET   CONTENTS                                       *
*                                                                     *
*    4        0        ADDRESS OF NEXT LEVEL-2 LIST (0 IF NONE)       *
*    2        4        LENGTH OF BASIC MESSAGE TEXT + 4               *
*    2        6        ALWAYS ZERO                                    *
*    VARIES   8        MESSAGE TEXT                                   *
*                                                                     *
* ATTRIBUTES --                                                       *
*    REFRESHABLE, ENABLED, NON-PRIVILEGED                             *
*                                                                     *
* CHARACTER CODE DEPENDENCY -- NONE.                                  *
*                                                                     *
* NOTES -- NONE.                                                      *
*                                                                     *
***********************************************************************
         SPACE 2
         IKJEBEMT 17               BUILD MESSAGE VECTOR TABLE    Y01156
         EJECT
***********************************************************************
*M00 IS USED BY THE MESSAGE SELECTION ROUTINE(IKJEBEMS) TO
*SERVICE REQUESTS FROM THE SYNTAX CHECKERS FOR TERMINAL MESSAGES
*NOT ASSOCIATED SPECIFICALLY WITH THE EDIT COMMAND.  IT IS ALSO
*USED WHEN THE VERIFY LINE IS TO BE PRINTED AT THE TERMINAL.
***********************************************************************
         SPACE 2
M00      IKJEBEMB M00L1,' '
M00L1    IKJEBEMB ,' '
         EJECT
*INSERTION FOR INVALID SUBCOMMAND NAME IN M01 HAS A VALUE OF 29
M01      IKJEBEMB 0,'366I INVALID SUBCOMMAND '
M02      IKJEBEMB M03L1,'305I UTILITY DATA SET NOT ALLOCATED, NOT ENOUGX
               H SPACE ON VOLUMES+'
* THE INSERTION FOR DATA SET NAME IN M03 HAS AN OFFSET OF 19
M03      IKJEBEMB M03L1,'305I DATA SET  NOT ALLOCATED, NOT ENOUGH SPACEX
                ON VOLUMES+'
M03L1    IKJEBEMB 0,'305I USE DELETE COMMAND TO DELETE UNUSED DATA SETSX
               '
         EJECT
* INSERTION FOR DSNAME IN M04 IS AT OFFSET 19
M04      IKJEBEMB 0,'317I DATA SET  NOT ON A DIRECT ACCESS DEVICE, NOT X
               SUPPORTED'
*INSERTION FOR COMMAND OR SUBCOMMAND NAME IN M05 HAS A VALUE OF 10
M05      IKJEBEMB M05L1,'422I  ENDED DUE TO ERROR+'
*INSERTION FOR COMPLETION CODE IN M05L1 HAS A VALUE OF 36
M05L1    IKJEBEMB M05L2,'422I SYSTEM COMPLETION CODE IS  '
*INSERTION FOR COMPLETION CODE IN M05L2 HAS A VALUE OF 34
M05L2    IKJEBEMB 0,'422I USER COMPLETION CODE IS  '
         EJECT
M06      IKJEBEMB 0,'500I END OF DATA'
M07      IKJEBEMB 0,'501I NO LINES IN DATA SET'
M08      IKJEBEMB 0,'502I DATA SET NOT LINE NUMBERED'
* THE OLD LINE NUMBER INSERTION IN M09 IS AT OFFSET 36           Y02676
* THE END LINE NUMBER INSERTION IN M09 IS AT OFFSET 37           Y02676
M09      IKJEBEMB 0,'503I INVALID LINE NUMBER RANGE  '           Y02676
         EJECT
*INSERTION FOR LINE NUMBER IN M10 HAS A VALUE OF 22
M10      IKJEBEMB 0,'504I LINE NUMBER  NOT FOUND'
M11      IKJEBEMB 0,'505I TOP OF DATA SET'
M12      IKJEBEMB 0,'506I TEXT NOT FOUND'
*INSERTION FOR LINE NUMBER IN M13 HAS A VALUE OF 15
M13      IKJEBEMB M13L1,'507I LINE  TRUNCATED+'
         EJECT
*INSERTION FOR LINE LENGTH IN M13L1 HAS A VALUE OF 25
M13L1    IKJEBEMB 0,'507I LINE LENGTH IS '
* THE DATA SET TYPE INSERTION IN M14 HAS AN OFFSET OF 34         Y01156
M14      IKJEBEMB 0,'570I LIB OPERAND IGNORED FOR  DATA SET'     Y01156
* THE DATA SET NAME INSERTION IN M15 HAS AN OFFSET OF 34         Y01156
M15      IKJEBEMB M15L1,'571I SAVE REJECTED, DATA SET  IS PARTITIONED WX
               ITH THE PRINT CONTROL ATTRIBUTE+'                 Y01156
M15L1    IKJEBEMB 0,'571I ANOTHER DATA SET MUST BE USED FOR SAVING'
         EJECT
* THE DATA SET NAME INSERTION IN M16 HAS AN OFFSET OF 28         Y01156
M16      IKJEBEMB 0,'572I WARNING, DATA SET  WILL BE SAVED WITHOUT PRINX
               T CONTROL CHARACTERS'                             Y01156
         END





