         TITLE 'IKJEES74 - LISTBC MESSAGE MODULE'
***********************************************************************
*                                                              Y02676 *
*   MODULE-NAME= IKJEES74                                             *
*                                                                     *
*   DESCRIPTIVE-NAME= LISTBC CP MESSAGE MODULE                        *
*                                                                     *
*   COPYRIGHT= NONE                                                   *
*                                                                     *
*   STATUS= OS/VS2, REL.2, LEVEL=0                                    *
*                                                                     *
*   FUNCTION= LISTBC MESSAGES DATA AREA                               *
*                                                                     *
*     OPERATION= THIS MODULE CONSISTS OF MESSAGE HEADERS AND TEXT.    *
*       IT PROVIDES THE LISTBC I/O ROUTINE WITH FORMATTED MESSAGE     *
*       BLOCKS AND SEGMENTS AS REQUIRED BY THE PUTLINE SERVICE        *
*       ROUTINE.                                                      *
*                                                                     *
*   NOTES=                                                            *
*                                                                     *
*     DEPENDENCIES=                                                   *
*                                                                     *
*       CHARACTER-CODE-DEPENDENCIES= NONE                             *
*                                                                     *
*     RESTRICTIONS= NONE                                              *
*                                                                     *
*     REGISTER-CONVENTIONS= N/A                                       *
*                                                                     *
*     PATCH-LABEL= NONE                                               *
*                                                                     *
*   MODULE-TYPE= TABLE                                                *
*                                                                     *
*     PROCESSOR= ASM                                                  *
*                                                                     *
*     MODULE-SIZE= 836 BYTES                                          *
*                                                                     *
*     ATTRIBUTES= NOT EXECUTABLE                                      *
*                                                                     *
*   ENTRY-POINT= LSTBMSG                                              *
*                                                                     *
*     PURPOSE= LABEL OF TABLE OF 2-BYTE OFFSETS (FROM TABLE LABEL)    *
*       OF MESSAGE BLOCKS                                             *
*                                                                     *
*     LINKAGE= N/A                                                    *
*                                                                     *
*     INPUT= N/A                                                      *
*                                                                     *
*   EXIT-NORMAL= N/A                                                  *
*                                                                     *
*   EXIT-ERROR= N/A                                                   *
*                                                                     *
*   EXTERNAL REFERENCES= N/A                                          *
*                                                                     *
*   TABLES= N/A                                                       *
*                                                                     *
*   MACROS=                                                           *
*     MODID                                                           *
*                                                                     *
*     SERIALIZATION= N/A                                              *
*                                                                     *
*   CHANGE-ACTIVITY= S/D SUPPORT CODE IS Y02676.                      *
*                                                                     *
*   MESSAGES= N/A                                                     *
*                                                                     *
*   ABEND-CODES= N/A                                                  *
*                                                                     *
***********************************************************************
         EJECT
IKJEES74 CSECT
         ENTRY LSTBMSG
         MODID  BRANCH=NO                                       Y01886
LSTBMSG  DS    0D                      NAME OF OFFSET AREA
OFSET1   DC    AL2(BCMSG1-LSTBMSG)     OFFSET TO MESSAGE 1
OFSET2   DC    AL2(BCMSG2-LSTBMSG)     OFFSET TO MESSAGE 2
OFSET3   DC    AL2(BCMSG3-LSTBMSG)     OFFSET TO MESSAGE 3
OFSET4   DC    AL2(BCMSG4-LSTBMSG)     OFFSET TO MESSAGE 4
OFSET5   DC    AL2(BCMSG5-LSTBMSG)     OFFSET TO MESSAGE 5
OFSET6   DC    AL2(BCMSG6-LSTBMSG)     OFFSET TO MESSAGE 6
OFSET7   DC    AL2(BCMSG7-LSTBMSG)     OFFSET TO MESSAGE 7
OFSET8   DC    AL2(BCMSG8-LSTBMSG)     OFFSET TO MESSAGE 8
OFSET9   DC    AL2(BCMSG9-LSTBMSG)     OFFSET TO MESSAGE 9
OFSET10  DC    AL2(BCMSG10-LSTBMSG)    OFFSET TO MESSAGE 10
OFSET11  DC    AL2(BCMSG11-LSTBMSG)    OFFSET TO MESSAGE 11
OFSET12  DC    AL2(BCMSG12-LSTBMSG)    OFFSET TO MESSAGE 12
OFSET13  DC    AL2(BCMSG13-LSTBMSG)    OFFSET TO MESSAGE 13
OFSET14  DC    AL2(BCMSG14-LSTBMSG)    OFFSET TO MESSAGE 14      Y02676
OFSET15  DC    AL2(BCMSG15-LSTBMSG)    OFFSET TO MESSAGE 15      Y02676
OFSET16  DC    AL2(BCMSG16-LSTBMSG)    OFFSET TO MESSAGE 16      Y02676
OFSET17  DC    AL2(BCMSG17-LSTBMSG)    OFFSET TO MESSAGE 17      Y02676
BCMSG1   DC    A(BMSG10)          PTR TO SECOND LEVEL MSG DESCRIPTOR
         DC    A(2)               NUMBER OF SEGMENTS
         DC    A(BMSG1A)          PTR TO THE FIRST SEGMENT
         DC    A(BMSG1B)          PTR TO THE SECOND SEGMENT
BMSG1A   DC    AL2(14)            LENGTH OF THE SEGMENT + 4-BYTE HEADER
         DC    AL2(0)             OFFSET FROM PRIMARY SEGMENT
         DC    C'IKJ56950I '      TEXT FOR THIS SEGMENT
BMSG1B   DC    AL2(34)
         DC    AL2(10)
         DC    C'BROADCAST DATA SET NOT USABLE+'
BMSG10   DC    A(0)
         DC    A(2)
         DC    A(BMSG1A)
         DC    A(BMSG1C)
BMSG1C   DC    AL2(20)
         DC    AL2(10)
         DC    C'I/O SYNAD ERROR'
BCMSG2   DC    A(BMSG20)
         DC    A(2)
         DC    A(BMSG1A)
         DC    A(BMSG1B)
BMSG20   DC    A(0)
         DC    A(2)
         DC    A(BMSG1A)
         DC    A(BMSG1D)
BMSG1D   DC    AL2(24)
         DC    AL2(10)
         DC    C'CANNOT OPEN DATA SET'
         SPACE
BCMSG3   DC    A(2)
         DC    A(BMSG3A)
         DC    A(BMSG3B)
BMSG3A   DC    AL2(14)
         DC    AL2(0)
         DC    C'IKJ56951I '
BMSG3B   DC    AL2(25)
         DC    AL2(10)
         DC    C'NO BROADCAST MESSAGES'
         SPACE 1
BCMSG4   DS    0F                                                Y02676
BCMSG5   DS    0F                                                Y02676
BCMSG6   DS    0F                                                Y02676
BCMSG7   DS    0F                                                Y02676
         SPACE 1
BCMSG8   DC    A(2)
         DC    A(BMSG8A)
         DC    A(BMSG8B)
BMSG8A   DC    AL2(14)
         DC    AL2(0)
         DC    C'IKJ56957I '
BMSG8B   DC    AL2(41)                                           Y02676
         DC    AL2(10)
         DC    C'NOT ENOUGH STORAGE TO EXECUTE COMMAND'          Y02676
         SPACE 1
BCMSG9   DS    0F                                                Y02676
BCMSG10  DS    0F                                                Y02676
BCMSG11  DS    0F                                                Y02676
         SPACE
BCMSG12  DC    A(BMSGC0)
         DC    A(2)
         DC    A(BMSG12A)
         DC    A(BMSG12B)
BMSG12A  DC    AL2(14)
         DC    AL2(0)
         DC    C'IKJ56959I '
BMSG12B  DC    AL2(25)
         DC    AL2(10)
         DC    C'COMMAND SYSTEM ERROR+'
BMSGC0   DC    A(0)
         DC    A(3)
         DC    A(BMSG12A)
         DC    A(BMSG12C)
         DC    A(BMSG12D)                                        Y02676
BMSG12C  DC    AL2(23)
         DC    AL2(10)
         DC    C'PUTLINE ERROR CODE '
BMSG12D  DC    AL2(8)                                            Y02676
         DC    AL2(29)                                           Y02676
         DC    C'    '                                           Y02676
BCMSG13  DC    A(BMSGD0)
         DC    A(2)
         DC    A(BMSG12A)
         DC    A(BMSG12B)
BMSGD0   DC    A(0)
         DC    A(3)
         DC    A(BMSG12A)
         DC    A(BMSG13A)
         DC    A(BMSG13D)                                        Y02676
BMSG13A  DC    AL2(21)
         DC    AL2(10)
         DC    C'PARSE ERROR CODE '
BMSG13D  DC    AL2(8)                                            Y02676
         DC    AL2(27)                                           Y02676
         DC    C'    '                                           Y02676
         SPACE 1
BCMSG14  DC    A(BMSGE0)                                         Y02676
         DC    A(2)                                              Y02676
         DC    A(BMSG1A)                                         Y02676
         DC    A(BMSG1B)                                         Y02676
BMSGE0   DC    A(0)                                              Y02676
         DC    A(2)                                              Y02676
         DC    A(BMSG1A)                                         Y02676
         DC    A(BMSG1E)                                         Y02676
BMSG1E   DC    AL2(30)                                           Y02676
         DC    AL2(10)                                           Y02676
         DC    C'INSTALLATION MUST REFORMAT'                     Y02676
         SPACE 1
BCMSG15  DC    A(0)                                              Y02676
         DC    A(2)                                              Y02676
         DC    A(BMSG15A)                                        Y02676
         DC    A(BMSG15B)                                        Y02676
BMSG15A  DC    AL2(14)                                           Y02676
         DC    AL2(0)                                            Y02676
         DC    C'IKJ56458I '                                     Y02676
BMSG15B  DC    AL2(50)                                           Y02676
         DC    AL2(10)                                           Y02676
         DC    C'BROADCAST DATA SET NOT USABLE, I/O SYNAD ERROR' Y02676
         SPACE 1
BCMSG16  DC    A(0)                                              Y02676
         DC    A(2)                                              Y02676
         DC    A(BMSG16A)                                        Y02676
         DC    A(BMSG16B)                                        Y02676
BMSG16A  DC    AL2(14)                                           Y02676
         DC    AL2(0)                                            Y02676
         DC    C'IKJ56459I '                                     Y02676
BMSG16B  DC    AL2(55)                                           Y02676
         DC    AL2(10)                                           Y02676
*                                                                Y02676
         DC    C'BROADCAST DATA SET NOT USABLE, CANNOT OPEN DATA SET'
         SPACE 1
BCMSG17  DC    A(0)                                              Y02676
         DC    A(2)                                              Y02676
         DC    A(BMSG17A)                                        Y02676
         DC    A(BMSG17B)                                        Y02676
BMSG17A  DC    AL2(14)                                           Y02676
         DC    AL2(0)                                            Y02676
         DC    C'IKJ56461I '                                     Y02676
BMSG17B  DC    AL2(61)                                           Y02676
         DC    AL2(10)                                           Y02676
         DC    C'BROADCAST DATA SET NOT USABLE, INSTALLATION MUST REFORX
               MAT'                                              Y02676
         END   IKJEES74
