         TITLE 'ALLOCATE SPACE PROCESSOR                               *
                        '
IKJEFD33 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IKJEFD33  78.174'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @11,@01                                             0001
         USING @DATD,@11                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @00,@01,20(@13)                                     0001
         ST    @11,8(,@13)                                         0001
         LR    @13,@11                                             0001
         XC    @ZTEMPS(@ZLEN),@ZTEMPS
         MVC   @PC00001(4),0(@01)                                  0001
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      SPACERTE                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE HANDLES ALL SPACE PARAMETERS (SPACE, SPACE     */
*/*      INCREMENT, BLOCK, AVBLOCK, TRACKS, CYLINDERS, AND DIR).     */
*/*      PROMPTING AND BUILDING TEXT UNITS IS DONE WHERE NECESSARY.  */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      IF BLOCK ENTERED, AND USING NOT, BUILD TEXT UNIT FOR DCB    */
*/*      PARAMETER BLOCKSIZE. IF BLOCK IS ENTERED AND SPACE IS NOT,  */
*/*      MARK BLOCK NOT ENTERED - TO BE USED ONLY AS DCB BLOCKSIZE.  */
*/*      IF BLOCK IS ENTERED, AND SPACE IS ENTERED, INVOKE SPCTEXT   */
*/*      TO PROCESS SPACE. IF BLOCK NOT ENTERED, BUT AVBLOCK, TRACKS */
*/*      OR CYLINDERS IS ENTERED AND SPACE IS ENTERED, INVOKE        */
*/*      SPCTEXT TO PROCESS SPACE. IF SPACE IS NOT ENTERED, PROMPT   */
*/*      FOR SPACE PARAMETER. IF NEITHER OF THE BLOCK, AVBLOCK,      */
*/*      TRACKS OR CYLINDERS IS ENTERED, AND SPACE IS ENTERED,       */
*/*      PROMPT FOR BLOCK PARAMETER AND REPEAT ABOVE PROCESS. IF     */
*/*      DIR IS NOT ENTERED AND A MEMBER NAME IS SPECIFIED, PROMPT   */
*/*      FOR DIR VALUE.                                              */
*/*      IF RLSE OR ROUND ARE ENTERED BUT SPACE AND UNIT OF  @ZA08703*/
*/*      SPACE WERE NOT ENTERED SPACE AND UNIT OF SPACE WILL @ZA08703*/
*/*      BE DEFAULTED.                                       @ZA08703*/
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO SPACE PDE                                            */
*/*      PTR TO USING PDE                                            */
*/*      PTR TO DSNAME PDE                                           */
*/*      PTR TO BLOCK/AVBLOCK/TRACKS/CYLINDERS PDE                   */
*/*      PTR TO DIR PDE                                              */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      NECESSARY PROMPTING DONE                                    */
*/*      TEXT UNITS BUILT WHERE NEEDED                               */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    SPACERTE:                                                     0061
*        AWAPTR = R1;                  /* PTR TO WORKAREA            */
SPACERTE LR    AWAPTR,R1                                           0061
*        CNVRTYPE = '00'X;             /* INITIALIZE FLAGS           */
         MVI   CNVRTYPE,X'00'                                      0062
*        INC = ADDNUM + 1;             /* INITIALIZE SUBSCRIPT       */
         L     @10,GTPLPTR(,AWAPTR)                                0063
         L     @10,GTPLABLK(,@10)                                  0063
         LA    INC,1                                               0063
         AH    INC,ADDNUM(,@10)                                    0063
*        IF DIRPDE = 0 THEN            /* IF DIR NOT ENTERED,        */
         L     @10,PTRPDL(,AWAPTR)                                 0064
         LH    @02,DIRPDE(,@10)                                    0064
         LTR   @02,@02                                             0064
         BNZ   @RF00064                                            0064
*          DO;                         /* AND                        */
*            IF MBRPRES = '1'B &       /* IF MEMBER SPEC AND @OZ05962*/
*              DSEXISTS = '0'B THEN   /* DATA SET NEW       @OZ05962*/
         TM    MBRPRES(@10),B'10000000'                            0066
         BNO   @RF00066                                            0066
         TM    DSEXISTS(AWAPTR),B'00100000'                        0066
         BNZ   @RF00066                                            0066
*              CALL PRMPTDIR;          /* POINT FOR DIRECTORY        */
         BAL   @14,PRMPTDIR                                        0067
*          END;                                                    0068
@RF00066 DS    0H                                                  0069
*        DO WHILE (CONT ='0'B);        /* CHECK CONTROL SWITCH       */
@RF00064 B     @DE00069                                            0069
@DL00069 DS    0H                                                  0070
*        IF BLOKPDE = 1 THEN           /* IF BLOCK ENTERED,          */
         L     @10,PTRPDL(,AWAPTR)                                 0070
         CLC   BLOKPDE(2,@10),@CH00033                             0070
         BNE   @RF00070                                            0070
*          DO;                                                     0071
*            CONT= '1'B;               /* INDICATE TO EXIT DO-WHILE  */
         OI    CONT(AWAPTR),B'00010000'                            0072
*            IF USINGPDE = 0 THEN      /* IF USING NOT ENTERED,      */
         LH    @10,USINGPDE(,@10)                                  0073
         LTR   @10,@10                                             0073
         BNZ   @RF00073                                            0073
*              DO;                                                 0074
*                BLKCNVRT = '1'B;      /* INDICATE TO CONVERT BLOCK  */
         OI    BLKCNVRT,B'10000000'                                0075
*                CALL CONVERT;         /* INVOKE CONVERSION RTN      */
         BAL   @14,CONVERT                                         0076
*                CALL DCBTEXT;         /* SET UP DCB TEXT            */
         BAL   @14,DCBTEXT                                         0077
*              END;                                                0078
*            IF SPACEPDE = 0 & DIRPDE=0 THEN /* IF SPACE NOT       0079
*                                               ENTERED,     @YM06119*/
@RF00073 SLR   @10,@10                                             0079
         L     @02,PTRPDL(,AWAPTR)                                 0079
         CH    @10,SPACEPDE(,@02)                                  0079
         BNE   @RF00079                                            0079
         CH    @10,DIRPDE(,@02)                                    0079
         BNE   @RF00079                                            0079
*              BLOKPDE = 0;            /* MARK BLOCK IGNORED         */
         STH   @10,BLOKPDE(,@02)                                   0080
*            ELSE                      /* IF SPACE ENTERED,          */
*              DO;                                   /*      @YM06119*/
         B     @RC00079                                            0081
@RF00079 DS    0H                                                  0082
*                IF SPACEPDE = 0 & DIRPDE = 1 THEN   /*      @YM06119*/
         L     @10,PTRPDL(,AWAPTR)                                 0082
         LH    @02,SPACEPDE(,@10)                                  0082
         LTR   @02,@02                                             0082
         BNZ   @RF00082                                            0082
         CLC   DIRPDE(2,@10),@CH00033                              0082
         BNE   @RF00082                                            0082
*                  CALL PRMPTSPC;                    /*      @YM06119*/
         BAL   @14,PRMPTSPC                                        0083
*                CALL SPCTEXT;                       /*      @YM06119*/
@RF00082 BAL   @14,SPCTEXT                                         0084
*              END;                                  /*      @YM06119*/
*          END;                                                    0086
*        ELSE                                                      0087
*          DO;                         /* IF BLOCK NOT ENTERED,      */
         B     @RC00070                                            0087
@RF00070 DS    0H                                                  0088
*            IF BLOKPDE > 1 THEN       /* BUT AVBLOCK, TRK OR CYL    */
         LA    @10,1                                               0088
         L     @02,PTRPDL(,AWAPTR)                                 0088
         CH    @10,BLOKPDE(,@02)                                   0088
         BNL   @RF00088                                            0088
*              DO;                     /* ENTERED,                   */
*                CONT = '1'B;          /* INDICATE TO EXIT DO-WHILE  */
         OI    CONT(AWAPTR),B'00010000'                            0090
*                IF SPACEPDE = 1 THEN  /* IF SPACE ENTERED,          */
         CH    @10,SPACEPDE(,@02)                                  0091
         BNE   @RF00091                                            0091
*                  CALL SPCTEXT;       /* GO TO PROCESS              */
         BAL   @14,SPCTEXT                                         0092
*                ELSE                  /* IF SPACE NOT ENTERED,      */
*                  DO;                 /* THEN                       */
         B     @RC00091                                            0093
@RF00091 DS    0H                                                  0094
*                    CALL PRMPTSPC;    /* PROMPT FOR SPACE VALUE     */
         BAL   @14,PRMPTSPC                                        0094
*                    IF RBCODE12 = '0'B THEN                       0095
         TM    RBCODE12(AWAPTR),B'10000000'                        0095
         BNZ   @RF00095                                            0095
*                      CALL SPCTEXT;   /* PROCESS SPACE PARMS        */
         BAL   @14,SPCTEXT                                         0096
*                  END;                                            0097
*              END;                                                0098
*            ELSE                      /* IF NEITHER BLOCK,AVBLOCK,  */
*              DO;                     /* TRK OR CYL ENTERED,        */
         B     @RC00088                                            0099
@RF00088 DS    0H                                                  0100
*                IF SPACEPDE = 1 | DIRPDE=1 THEN /* AND SPACE IS   0100
*                                                   ENTERED, @YM06119*/
         LA    @10,1                                               0100
         L     @02,PTRPDL(,AWAPTR)                                 0100
         CH    @10,SPACEPDE(,@02)                                  0100
         BE    @RT00100                                            0100
         CH    @10,DIRPDE(,@02)                                    0100
         BNE   @RF00100                                            0100
@RT00100 DS    0H                                                  0101
*                  DO;                                             0101
*                  CALL PRMPTBLK;      /* PROMPT FOR BLOCK PARM      */
         BAL   @14,PRMPTBLK                                        0102
*                  IF RBCODE12 = '1'B THEN                         0103
         TM    RBCODE12(AWAPTR),B'10000000'                        0103
         BNO   @RF00103                                            0103
*                    CONT = '1'B;                                  0104
         OI    CONT(AWAPTR),B'00010000'                            0104
*                  END;                                            0105
*                ELSE                  /* OTHERWISE,                 */
*                  IF RLSEPDE ^= 0 |   /* IF ANY OTHER SPACE @ZA08703*/
*                     RNDPDE ^= 0      /* TYPE INFO SPECIFIED@ZA08703*/
*                    THEN              /* SPACE AND UNIT OF  @ZA08703*/
         B     @RC00100                                            0106
@RF00100 SLR   @10,@10                                             0106
         L     @02,PTRPDL(,AWAPTR)                                 0106
         CH    @10,RLSEPDE(,@02)                                   0106
         BNE   @RT00106                                            0106
         CH    @10,RNDPDE(,@02)                                    0106
         BE    @RF00106                                            0106
@RT00106 DS    0H                                                  0107
*                      CALL SPCDEFLT;  /* SPACE GET DEFAULTED@ZA08703*/
         BAL   @14,SPCDEFLT                                        0107
*                    ELSE              /* OTHERWISE          @ZA08703*/
*                      CONT = '1'B;    /* GET OUT OF LOOP    @ZA08703*/
         B     @RC00106                                            0108
@RF00106 OI    CONT(AWAPTR),B'00010000'                            0108
*              END;                                                0109
@RC00106 DS    0H                                                  0109
@RC00100 DS    0H                                                  0110
*          END;                                                    0110
@RC00088 DS    0H                                                  0111
*        END;                          /* END DO-WHILE               */
@RC00070 DS    0H                                                  0111
@DE00069 TM    CONT(AWAPTR),B'00010000'                            0111
         BZ    @DL00069                                            0111
*        RETURN;                                                   0112
@EL00001 L     @13,4(,@13)                                         0112
@EF00001 L     @00,@SIZDATD                                        0112
         LR    @01,@11                                             0112
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0112
         BR    @14                                                 0112
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      SPCTEXT                                                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE CONVERTS THE PRIMARY AND SECONDARY SPACE       */
*/*      PARAMETERS TO BINARY, AND BUILDS THE TEXT UNITS FOR SPACE.  */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      THE PRIMARY SPACE QUANTITY IS CONVERTED TO BINARY. THE TEXT */
*/*      UNIT IS BUILT. IF A SECONDARY SPACE VALUE IS SPECIFIED, IT  */
*/*      IS CONVERTED TO BINARY. THE TEXT UNIT IS BUILT. THE SPACE   */
*/*      PDE IS MARKED NOT ENTERED - SO THAT GENTRANS WILL NOT TRY   */
*/*      TO TRANSLATE IT.                                            */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      SPACE PDE                                                   */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      SPACE TEXT UNITS IN LIST                                    */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/*                                                                  */
*/*        THE GENTRANS ROUTINE CANNOT HANDLE THE SPACE PARAMETER    */
*/*        BECAUSE OF THE FORMAT - A KEYWORD WITH A SUBFIELD LIST,   */
*/*        WHERE EACH ELEMENT IN THE LIST HAS A DIFFERENT KEY.  IF   */
*/*        THE FORMAT CHANGES, OR GENTRANS CHANGES, THESE TEXT UNITS */
*/*        MAY BE HANDLED BY GENTRANS.                               */
*/********************************************************************/
*    SPCTEXT: PROC;                                                0113
SPCTEXT  STM   @14,@03,@SA00002                                    0113
         STM   @06,@12,@SA00002+24                                 0113
*        SPCCNVRT = '1'B;              /* INDICATE TO CONVERT SPACE  */
         OI    SPCCNVRT,B'01000000'                                0114
*        CALL CONVERT;                 /* INVOKE CONVERSION RTN      */
         BAL   @14,CONVERT                                         0115
*        ADDNUM = ADDNUM + 1;          /* INCREMENT TEXT COUNTER     */
         L     @10,GTPLPTR(,AWAPTR)                                0116
         L     @10,GTPLABLK(,@10)                                  0116
         LA    @02,1                                               0116
         LH    @15,ADDNUM(,@10)                                    0116
         ALR   @15,@02                                             0116
         STH   @15,ADDNUM(,@10)                                    0116
*        ADLKEY = DALPRIME;            /* SET KEY,                   */
         L     @15,TXT(,AWAPTR)                                    0117
         MVC   ADLKEY(2,@15),@CH00412                              0117
*        ADLNBR = 1;                   /* NUMBER,                    */
         STH   @02,ADLNBR(,@15)                                    0118
*        ADLLEN = 3;                   /* LENGTH AND PARM IN TEXT    */
         LA    @14,3                                               0119
         STH   @14,ADLLEN(,@15)                                    0119
*        ADLPARM(1:ADLLEN)=SAVPARM(2:4);                           0120
         LR    @09,@14                                             0120
         BCTR  @09,0                                               0120
         EX    @09,@SM00677                                        0120
*        ADDTEXT(INC) = TXT;           /* PTR TO TEXT IN LIST        */
         LR    @09,INC                                             0121
         SLA   @09,2                                               0121
         ST    @15,ADDTEXT-4(@09,@10)                              0121
*        TXT=TXT+6 + ADLLEN;           /* INCREMNT TEXT PTR          */
         AL    @15,@CF00168                                        0122
         ALR   @15,@14                                             0122
         ST    @15,TXT(,AWAPTR)                                    0122
*        INC=INC+1;                    /* INCREMENT SUBSCRIPT        */
         ALR   INC,@02                                             0123
*        IF SPCPRES2 = '1'B THEN       /* IF SECONDARY SPACE ENTERED */
         L     @10,PTRPDL(,AWAPTR)                                 0124
         TM    SPCPRES2(@10),B'10000000'                           0124
         BNO   @RF00124                                            0124
*          DO;                                                     0125
*            INCCNVRT = '1'B;          /* INDICATE TO CONVERT SECND  */
         OI    INCCNVRT,B'00100000'                                0126
*            CALL CONVERT;             /* INVOKE CONVERSION RTN      */
         BAL   @14,CONVERT                                         0127
*            ADDNUM = ADDNUM + 1;      /* INCREMENT TEXT COUNTER     */
         L     @10,GTPLPTR(,AWAPTR)                                0128
         L     @10,GTPLABLK(,@10)                                  0128
         LA    @02,1                                               0128
         LH    @15,ADDNUM(,@10)                                    0128
         ALR   @15,@02                                             0128
         STH   @15,ADDNUM(,@10)                                    0128
*            ADLKEY = DALSECND;        /* SET KEY,                   */
         L     @15,TXT(,AWAPTR)                                    0129
         MVC   ADLKEY(2,@15),@CH00414                              0129
*            ADLNBR = 1;               /* NUMBER,                    */
         STH   @02,ADLNBR(,@15)                                    0130
*            ADLLEN = 3;               /* LENGTH AND PARM IN TEXT    */
         LA    @14,3                                               0131
         STH   @14,ADLLEN(,@15)                                    0131
*            ADLPARM(1:ADLLEN)=SAVPARM(2:4);                       0132
         LR    @09,@14                                             0132
         BCTR  @09,0                                               0132
         EX    @09,@SM00677                                        0132
*            ADDTEXT(INC)= TXT;        /* PTR TO TEXT IN LIST        */
         LR    @09,INC                                             0133
         SLA   @09,2                                               0133
         ST    @15,ADDTEXT-4(@09,@10)                              0133
*            TXT=TXT+6 + ADLLEN;       /* INCREMENT TEXT PTR         */
         AL    @15,@CF00168                                        0134
         ALR   @15,@14                                             0134
         ST    @15,TXT(,AWAPTR)                                    0134
*            INC=INC+1;                /* INCREMENT SUBSCRIPT        */
         ALR   INC,@02                                             0135
*          END;                                                    0136
*        SPACEPDE = 0;                 /* MARK SPACE NOT ENTERED     */
@RF00124 L     @10,PTRPDL(,AWAPTR)                                 0137
         SLR   @02,@02                                             0137
         STH   @02,SPACEPDE(,@10)                                  0137
* END SPCTEXT;                                                     0138
@EL00002 DS    0H                                                  0138
@EF00002 DS    0H                                                  0138
@ER00002 LM    @14,@03,@SA00002                                    0138
         LM    @06,@12,@SA00002+24                                 0138
         BR    @14                                                 0138
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      CONVERT                                                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE CONVERTS THE NUMERIC VALUES FOR BLOCK, SPACE   */
*/*      AND SPACE INCREMNT TO BINARY.                               */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      THE PACK AREA IS CLEARED. DETERMINE THE PARAMETER TO BE     */
*/*      CONVERTED, AND SAVE THE APPROPRIATE LENGTH AND VALUE.       */
*/*      PERFORM THE CONVERSION AND SAVE THE RESULTS.                */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO SPACE PDE                                            */
*/*      PTR TO BLOCK PDE                                            */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      NUMERIC VALUE CONVERTED TO BINARY                           */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    CONVERT:  PROC;                                               0139
CONVERT  STM   @14,@04,@SA00003                                    0139
         STM   @06,@12,@SA00003+28                                 0139
*        PKAREA(1) = 'F0'X;            /* FIRST BYTE SET TO F0       */
         MVI   PKAREA,X'F0'                                        0140
*        P = ADDR(PKAREA(1));          /* POINT TO FIRST BYTE        */
         LA    @10,PKAREA                                          0141
         ST    @10,P(,AWAPTR)                                      0141
*        Q = ADDR(PKAREA(2));          /* POINT TO SECOND BYTE       */
         LA    @04,PKAREA+1                                        0142
         ST    @04,Q(,AWAPTR)                                      0142
*        Q -> AREA1 = P -> AREA2;      /* SET PACKAREA TO ALL F0     */
         MVC   AREA1(15,@04),AREA2(@10)                            0143
*        IF BLKCNVRT = '1'B THEN       /* IF BLOCK TO BE CONVERTED,  */
         TM    BLKCNVRT,B'10000000'                                0144
         BNO   @RF00144                                            0144
*          DO;                                                     0145
*            VALLEN = BLKLEN;          /* SAVE BLOCK LENGTH AND      */
         L     @10,PTRPDL(,AWAPTR)                                 0146
         LH    VALLEN,BLKLEN(,@10)                                 0146
*            VALBUF = BLKBUF;          /* BLOCK BUFFER               */
         L     @10,BLKPTR(,@10)                                    0147
         MVC   VALBUF(8),BLKBUF(@10)                               0147
*          END;                                                    0148
*        ELSE                                                      0149
*          IF SPCCNVRT = '1'B THEN     /* IF SPACE TO BE CONVERTED   */
         B     @RC00144                                            0149
@RF00144 TM    SPCCNVRT,B'01000000'                                0149
         BNO   @RF00149                                            0149
*            DO;                                                   0150
*              VALLEN = SPACELEN;      /* SAVE SPACE LENGTH AND      */
         L     @10,PTRPDL(,AWAPTR)                                 0151
         LH    VALLEN,SPACELEN(,@10)                               0151
*              VALBUF = SPACEBUF;      /* SPACE BUFFER               */
         L     @10,SPACEPTR(,@10)                                  0152
         MVC   VALBUF(8),SPACEBUF(@10)                             0152
*            END;                                                  0153
*          ELSE                                                    0154
*            IF INCCNVRT = '1'B THEN   /* IF SECONDARY SPACE TO BE   */
         B     @RC00149                                            0154
@RF00149 TM    INCCNVRT,B'00100000'                                0154
         BNO   @RF00154                                            0154
*              DO;                     /* CONVERTED,                 */
*                VALLEN = SPACLEN2;    /* SAVE SEC SPACE LENGTH      */
         L     @10,PTRPDL(,AWAPTR)                                 0156
         LH    VALLEN,SPACLEN2(,@10)                               0156
*                VALBUF = SPACBUF2;    /* AND SEC SPACE BUFFER       */
         L     @10,SPACPTR2(,@10)                                  0157
         MVC   VALBUF(8),SPACBUF2(@10)                             0157
*              END;                                                0158
*        RFY Y RSTD;                                               0159
@RF00154 DS    0H                                                  0159
@RC00149 DS    0H                                                  0159
@RC00144 DS    0H                                                  0160
*        Y = 8 - VALLEN + ADDR(PKAREA);/* POINT TO BUFFER POSITION   */
         LA    Y,8                                                 0160
         SLR   Y,VALLEN                                            0160
         LA    @10,PKAREA                                          0160
         ALR   Y,@10                                               0160
*        PKAREA1(1:VALLEN)= VALBUF(1:VALLEN);/* MOVE PARM TO BUFFER  */
         LR    @10,VALLEN                                          0161
         BCTR  @10,0                                               0161
         EX    @10,@SM00680                                        0161
*        GENERATE REFS(CVBAREA);                                   0162
         PACK  CVBAREA(8),PKAREA(8)
         CVB   Y,CVBAREA
*        SAVPARM = Y;                  /* SAVE RESULT                */
         ST    Y,@TF00001                                          0163
         MVC   SAVPARM(4),@TF00001                                 0163
*        RFY Y UNRSTD;                                             0164
*        CNVRTYPE = '00'X;             /* CLEAR FLAG FIELD           */
         MVI   CNVRTYPE,X'00'                                      0165
*   END CONVERT;                                                   0166
@EL00003 DS    0H                                                  0166
@EF00003 DS    0H                                                  0166
@ER00003 LM    @14,@04,@SA00003                                    0166
         LM    @06,@12,@SA00003+28                                 0166
         BR    @14                                                 0166
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      DCBTEXT                                                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE SETS UP THE TEXT UNIT FOR DCB BLOCK SIZE.      */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      THE COUNTER FOR THE NUMBER OF ENTRIES IS INCREMENTED. THE   */
*/*      KEY, NUMBER, LENGTH, AND VALUE ARE PUT INTO THE TEXT. THE   */
*/*      ADDRESS OF THE TEXT IS PUT INTO THE ADDRESS LIST.           */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO VALUE                                                */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      TEXT UNIT BUILT                                             */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/*                                                                  */
*/*        THIS TEXT UNIT MUST BE SET UP SINCE THE BLOCK PARAMETER   */
*/*        NEEDS 2 KEYS - DCB BLOCK SIZE, AND AVERAGE RECORD LENGTH. */
*/*        GENTRANS CAN PROCESS THE KEY FOR AVERAGE RECORD LENGTH.   */
*/********************************************************************/
*    DCBTEXT:  PROC OPTIONS(NOSAVEAREA);                           0167
DCBTEXT  STM   @14,@03,12(@13)                                     0167
         STM   @05,@12,40(@13)                                     0167
*        ADDNUM = ADDNUM + 1;               /* INCREMENT ENTRY CTR   */
         L     @10,GTPLPTR(,AWAPTR)                                0168
         L     @10,GTPLABLK(,@10)                                  0168
         LA    @05,1                                               0168
         LH    @02,ADDNUM(,@10)                                    0168
         ALR   @02,@05                                             0168
         STH   @02,ADDNUM(,@10)                                    0168
*        ADLKEY = DALBLKSZ;                 /* PUT KEY,              */
         L     @02,TXT(,AWAPTR)                                    0169
         MVC   ADLKEY(2,@02),@CH00488                              0169
*        ADLNBR = 1;                        /* NUMBER,               */
         STH   @05,ADLNBR(,@02)                                    0170
*        ADLLEN = 2;                        /* LENGTH AND            */
         LA    @15,2                                               0171
         STH   @15,ADLLEN(,@02)                                    0171
*        ADLPARM(1:ADLLEN)=SAVPARM(3:4);    /* PARM INTO TEXT        */
         BCTR  @15,0                                               0172
         EX    @15,@SM00682                                        0172
*        ADDTEXT(INC) = TXT;                /* TEXT PTR IN LIST      */
         LR    @15,INC                                             0173
         SLA   @15,2                                               0173
         ST    @02,ADDTEXT-4(@15,@10)                              0173
*        TXT = TXT + 8;                     /* INCREMENT TEXT PTR    */
         AL    @02,@CF00095                                        0174
         ST    @02,TXT(,AWAPTR)                                    0174
*        INC = INC + 1;                     /* INCREMENT SUBSCRIPT   */
         ALR   INC,@05                                             0175
*   END  DCBTEXT;                                                  0176
@EL00004 DS    0H                                                  0176
@EF00004 DS    0H                                                  0176
@ER00004 LM    @14,@03,12(@13)                                     0176
         LM    @05,@12,40(@13)                                     0176
         BR    @14                                                 0176
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      PRMPTSPC                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE REENTERS PARSE TO PROMPT FOR A SPACE VALUE     */
*/*      WHEN ONE HAS NOT BEEN ENTERED AND IS REQUIRED.              */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      INVOKE PARSE WITH A SECONDARY PCL AND PDL ADDRESS. IF PARSE */
*/*      FAILS, INVOKE PARSERR ROUTINE. ELSE, OVERLAY THE ORIGINAL   */
*/*      PDE WITH THE PDE ROTURNED FORM THE PROMPT. RELEASE THE      */
*/*      PROMPT PDE.                                                 */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO SPACE PDE                                            */
*/*      PTR TO SECONDARY PCL                                        */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      SPACE PDE OVERLAID  WITH NEW DATA                           */
*/*                                                                  */
*/* NOTE:  THIS ROTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN     */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    PRMPTSPC: PROC;                                               0177
PRMPTSPC STM   @14,@12,@SA00005                                    0177
*        ENTRYCD = 5;                  /* INDICATE SPACE PROMPT      */
         MVC   ENTRYCD(2,AWAPTR),@CH00064                          0178
*        R1 = AWAPTR;                  /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0179
*        CALL IKJEFD37;                /* INVOKE PARSE               */
         L     @15,@CV00045                                        0180
         BALR  @14,@15                                             0180
*        IF RCODESV > 0 THEN           /* IF PARSE FAILED,           */
         L     @10,RCODESV(,AWAPTR)                                0181
         LTR   @10,@10                                             0181
         BNP   @RF00181                                            0181
*          DO;                                                     0182
*            ENTRYCD = 2;              /* SET ENTRY CODE             */
         MVC   ENTRYCD(2,AWAPTR),@CH00061                          0183
*            R1 = AWAPTR;              /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0184
*            CALL IKJEFD35;            /* PROCESS PARSE ERROR        */
         L     @15,@CV00044                                        0185
         BALR  @14,@15                                             0185
*          END;                                                    0186
*        ELSE                                                      0187
*          DO;                         /* IF PARSE SUCCESSFUL,       */
         B     @RC00181                                            0187
@RF00181 DS    0H                                                  0188
*            SPACEPTR = ADDR(NSPCBUF1);/* PTR IN PDE TO NEW BUFFER   */
         L     @10,PTRPDL(,AWAPTR)                                 0188
         LA    @02,NSPCBUF1                                        0188
         ST    @02,SPACEPTR(,@10)                                  0188
*            NSPCBUF1(1:SPCLEN1)=SPCBUF1(1:SPCLEN1);               0189
         L     @02,PMPTPDL(,AWAPTR)                                0189
         LH    @15,SPCLEN1(,@02)                                   0189
         LR    @14,@15                                             0189
         BCTR  @14,0                                               0189
         L     @01,SPCPTR1(,@02)                                   0189
         EX    @14,@SM00684                                        0189
*            SPACELEN = SPCLEN1;       /* LENGTH, AND                */
         STH   @15,SPACELEN(,@10)                                  0190
*            SPACEFLG = SPCFLAG1;      /* FLAGS - INTO OLD PDE       */
         MVC   SPACEFLG(1,@10),SPCFLAG1(@02)                       0191
*            IF SPC2PRES = '1'B THEN   /* IF SEC SPACE ENTERED,      */
         TM    SPC2PRES(@02),B'10000000'                           0192
         BNO   @RF00192                                            0192
*              DO;                                                 0193
*                SPACPTR2 = ADDR(NSPCBUF2);  /* MOVE POINTER,        */
         LA    @15,NSPCBUF2                                        0194
         ST    @15,SPACPTR2(,@10)                                  0194
*                NSPCBUF2(1:SPCLEN2)=SPCBUF2(1:SPCLEN2);           0195
         LH    @15,SPCLEN2(,@02)                                   0195
         LR    @14,@15                                             0195
         BCTR  @14,0                                               0195
         L     @01,SPCPTR2(,@02)                                   0195
         EX    @14,@SM00686                                        0195
*                SPACLEN2 = SPCLEN2;         /* LENGTH,  AND         */
         STH   @15,SPACLEN2(,@10)                                  0196
*                SPACFLG2 = SPCFLAG2;        /* FLAGS INTO OLD PDE   */
         MVC   SPACFLG2(1,@10),SPCFLAG2(@02)                       0197
*             END;                                                 0198
*            RFY R5 RSTD;                                          0199
@RF00192 DS    0H                                                  0200
*            R5 = ADDR(PMPTPDL);       /* PROMPT PDL IN REG 5        */
         LA    R5,PMPTPDL(,AWAPTR)                                 0200
*            GEN (IKJRLSA (5));        /* RELEASE PROMPT PDL         */
         IKJRLSA (5)
*            RFY R5 UNRSTD;                                        0202
*          END;                                                    0203
*   END PRMPTSPC;                                                  0204
@EL00005 DS    0H                                                  0204
@EF00005 DS    0H                                                  0204
@ER00005 LM    @14,@12,@SA00005                                    0204
         BR    @14                                                 0204
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      PRMPTBLK                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE PROMPTS THE USER TO ENTER BLOCK, AVBLOCK,      */
*/*      TRACKS OR CYLINDERS WHEN THE PARAMETER HAS BEEN OMITTED     */
*/*      AND IS REQUIRED.                                            */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      INVOKE PARSE WITH A SECONDARY PCL AND PDL ADDRESS. IF PARSE */
*/*      FAILS, INVOKE PARSERR ROUTINE. ELSE, OVERLAY THE ORIGINAL   */
*/*      PDE WITH THE PADE RETURNED FROM THE PROMPT. RELEASE THE     */
*/*      PROMPT PDL.                                                 */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO BLOCK PDE                                            */
*/*      PTR TO SECONDARY PCL                                        */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      BLOCK PDE OVERLAID WITH NEW DATA                            */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INLCUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/*************************(******************************************/
*    PRMPTBLK: PROC;                                               0205
PRMPTBLK STM   @14,@12,@SA00006                                    0205
*        ENTRYCD = 7;                  /* INDICATE PROMPT FOR BLOCK  */
         MVC   ENTRYCD(2,AWAPTR),@CH00175                          0206
*        R1 = AWAPTR;                  /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0207
*        CALL IKJEFD37;                /* INVOKE PARSE               */
         L     @15,@CV00045                                        0208
         BALR  @14,@15                                             0208
*        IF RCODESV > 0 THEN           /* IF PARSE FAILED,           */
         L     @10,RCODESV(,AWAPTR)                                0209
         LTR   @10,@10                                             0209
         BNP   @RF00209                                            0209
*          DO;                         /* THEN                       */
*            ENTRYCD = 2;              /* INDICATE PARSE ERROR       */
         MVC   ENTRYCD(2,AWAPTR),@CH00061                          0211
*            R1 = AWAPTR;              /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0212
*            CALL IKJEFD35;            /* ISSUE ERROR MESSAGE        */
         L     @15,@CV00044                                        0213
         BALR  @14,@15                                             0213
*          END;                                                    0214
*        ELSE                                                      0215
*          DO;                         /* IF PARSE SUCCESSFUL,       */
         B     @RC00209                                            0215
@RF00209 DS    0H                                                  0216
*            RFY R5 RSTD;              /* RESTRICT REG 5             */
*            R5 = ADDR(PMPTPDL);       /* PROMPT PDL IN REG 5        */
         LA    R5,PMPTPDL(,AWAPTR)                                 0217
*            GEN (IKJRLSA (5));        /* RELEASE PROMPT PDL         */
         IKJRLSA (5)
*            RFY R5 UNRSTD;            /* UNRESTRICT REG 5           */
*          END;                                                    0220
*   END PRMPTBLK;                                                  0221
@EL00006 DS    0H                                                  0221
@EF00006 DS    0H                                                  0221
@ER00006 LM    @14,@12,@SA00006                                    0221
         BR    @14                                                 0221
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      PRMPTDIR                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE PROMPTS THE USER TO ENTER A DIR VALUE WHEN     */
*/*      THE PARAMETER HAS BEEN OMITTED AND IS REQUIRED.             */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      INVOKE PARSE WITH A SECONDARY PCL AND PDL ADDRESS. IF PARSE */
*/*      FAILS, INVOKE PARSERR ROUTINE. ELSE, OVERLAY THE ORIGINAL   */
*/*      PDE WITH THE PDE RETURNED FROM THE PROMPT. RELEASE THE      */
*/*      PROMPT PDL.                                                 */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO DIR PDE                                              */
*/*      PTR TO SECONDARY PCL                                        */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      DIR PDE OVERLAID WITH NEW DATA                              */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*   PRMPTDIR:  PROC;                                               0222
PRMPTDIR STM   @14,@12,@SA00007                                    0222
*        ENTRYCD = 6;                  /* INDICATE PROMPT FOR DIR    */
         MVC   ENTRYCD(2,AWAPTR),@CH00168                          0223
*        R1 = AWAPTR;                  /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0224
*        CALL IKJEFD37;                /* INVOKE PARSE               */
         L     @15,@CV00045                                        0225
         BALR  @14,@15                                             0225
*        IF RCODESV > 0 THEN           /* IF PARSE FAILED,           */
         L     @10,RCODESV(,AWAPTR)                                0226
         LTR   @10,@10                                             0226
         BNP   @RF00226                                            0226
*          DO;                         /* THEN                       */
*            ENTRYCD = 2;              /* SET ENTRY CODE             */
         MVC   ENTRYCD(2,AWAPTR),@CH00061                          0228
*            R1 = AWAPTR;              /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0229
*            CALL IKJEFD35;            /* PROCESS PARSE ERROR        */
         L     @15,@CV00044                                        0230
         BALR  @14,@15                                             0230
*          END;                                                    0231
*        ELSE                                                      0232
*          DO;                         /* IF PARSE SUCCESSFUL,       */
         B     @RC00226                                            0232
@RF00226 DS    0H                                                  0233
*            DIRPDE = 1;                                           0233
         L     @10,PTRPDL(,AWAPTR)                                 0233
         MVC   DIRPDE(2,@10),@CH00033                              0233
*            DIRPTR = ADDR(NDIRBUF1);  /* PTR IN PDE TO NEW BUFFER   */
         LA    @02,NDIRBUF1                                        0234
         ST    @02,DIRPTR(,@10)                                    0234
*            NDIRBUF1(1:DIRLEN1)=DIRBUF1(1:DIRLEN1);               0235
         L     @02,PMPTPDL(,AWAPTR)                                0235
         LH    @15,DIRLEN1(,@02)                                   0235
         LR    @14,@15                                             0235
         BCTR  @14,0                                               0235
         L     @01,DIRPTR1(,@02)                                   0235
         EX    @14,@SM00688                                        0235
*            DIRLEN = DIRLEN1;         /* LENGTH, AND                */
         STH   @15,DIRLEN(,@10)                                    0236
*            DIRFLAGS = DIRFLAG1;      /* FLAGS INTO OLD PDE         */
         MVC   DIRFLAGS(1,@10),DIRFLAG1(@02)                       0237
*            RFY R5 RSTD;              /* RESTRICT REG 5             */
*            R5 = ADDR(PMPTPDL);       /* PROMPT PDL IN REG 5        */
         LA    R5,PMPTPDL(,AWAPTR)                                 0239
*            GEN (IKJRLSA (5));        /* RELEASE PROMPT PDL         */
         IKJRLSA (5)
*            RFY R5 UNRSTD;            /* UNRESTRICT REG 5           */
*          END;                                                    0242
*   END PRMPTDIR;                                                  0243
@EL00007 DS    0H                                                  0243
@EF00007 DS    0H                                                  0243
@ER00007 LM    @14,@12,@SA00007                                    0243
         BR    @14                                                 0243
*                                                                  0244
*                                                                  0244
*                                                                  0244
*    /****************************************************************/
*    /*                                                              */
*    /* SUBROUTINE - SPCDEFLT                                        */
*    /* FUNCTION - PROVIDE MINIMAL DEFAULTS FOR PRIMARY, SECONDARY   */
*    /*     AND UNIT OF SPACE WHEN NO SPACE DEFAULTING CAN BE        */
*    /*     PERFORMED BY SVC99. THIS OCCURS WHEN KEYWORDS RLSE OR    */
*    /*     ROUND HAVE BEEN SPECIFIED BY THE TERMINAL USER WITHOUT   */
*    /*     ANY OTHER SPACE TYPE PARAMETERS.                 @ZA08703*/
*    /*                                                              */
*    /* OPERATION - LOAD IEFAB445 (ALLOCATION DEFAULT CSECT)         */
*    /*     CONVERT PRIMARY,SECONDARY,AVBLKSIZE AND DIRECTORY        */
*    /*     VALUES TO EBCDIC AND UPDATE PDE'S FOR THESE VALUES       */
*    /*     TO INDICATE THEIR PRESENCE AND POINT TO THESE DEFAULT    */
*    /*     VALUES. DELETE IEFAB445.                                 */
*    /*                                                              */
*    /* INPUT - ALLOCATE COMMAND'S PDL                               */
*    /*         IEFAB445 (ALLOCATION DEFAULT CSECT)                  */
*    /*                                                              */
*    /* OUTPUT - ALLOCATE COMMAND'S PDL OVERLAID WITH DEFAULTED      */
*    /*          DATA.                                               */
*    /*                                                              */
*    /* NOTE - IEFAB445 IS THE ALLOCATION DEFAULT CSECT. IT IS       */
*    /*        MAPPED BY MACRO IEFZB445.                             */
*    /*                                                              */
*    /****************************************************************/
*    SPCDEFLT: PROC;                   /* DEFAULT SPACE      @ZA08703*/
SPCDEFLT STM   @14,@12,@SA00008                                    0244
*          RFY (R0) RSTD;              /* RESERVE REG 0      @ZA08703*/
*          GEN SETS(R0) (LOAD EP=IEFAB445); /* LOAD DEFAULT  @ZA08703*/
         LOAD EP=IEFAB445
*          AB445PTR = R0;              /* CSECT,SET BASE FOR @ZA08703*/
         LR    AB445PTR,R0                                         0247
*          RFY (R0) UNRSTD;            /* MAPPING MACRO      @ZA08703*/
*          INPTR = ADDR(DEFPQTY);      /* MOVE OVERLAY       @ZA08703*/
         LR    INPTR,AB445PTR                                      0249
*          CVD(FIXED24,PKAREA);        /* GET EBCDIC FOR     @ZA08703*/
         LR    @10,INPTR                                           0250
         BCTR  @10,0                                               0250
         L     @10,FIXED24(,@10)                                   0250
         LA    @10,0(,@10)                                         0250
         CVD   @10,@TS00001                                        0250
         MVC   PKAREA(8),@TS00001                                  0250
*          UNPK(NSPCBUF1,PKAREA(4:8)); /* PRIMARY SPACE      @ZA08703*/
         UNPK  NSPCBUF1(8),PKAREA+3(5)                             0251
*          SPACEPTR = ADDR(NSPCBUF1);  /* OVERLAY PDE        @ZA08703*/
         L     @10,PTRPDL(,AWAPTR)                                 0252
         LA    @05,NSPCBUF1                                        0252
         ST    @05,SPACEPTR(,@10)                                  0252
*          SPACELEN = 8;               /* SET LENGTH         @ZA08703*/
         LA    @05,8                                               0253
         STH   @05,SPACELEN(,@10)                                  0253
*          SPACPRES = '1'B;            /* INDICATE SPACE     @ZA08703*/
         OI    SPACPRES(@10),B'10000000'                           0254
*          SPACEPDE = 1;               /* PRESENT            @ZA08703*/
         MVC   SPACEPDE(2,@10),@CH00033                            0255
*          IF DEFSQTY ^= 0             /* IF SECONDARY AMT   @ZA08703*/
*            THEN DO;                  /* HAS DEFAULT        @ZA08703*/
         MVC   @ZT00001+1(3),DEFSQTY(AB445PTR)                     0256
         L     @02,@ZT00001                                        0256
         LTR   @02,@02                                             0256
         BZ    @RF00256                                            0256
*              INPTR = ADDR(DEFSQTY);  /* SET OVERLAY        @ZA08703*/
         LA    INPTR,DEFSQTY(,AB445PTR)                            0258
*              CVD(FIXED24,PKAREA);    /* CONVERT TO EBCDIC  @ZA08703*/
         LR    @02,INPTR                                           0259
         BCTR  @02,0                                               0259
         L     @02,FIXED24(,@02)                                   0259
         LA    @02,0(,@02)                                         0259
         CVD   @02,@TS00001                                        0259
         MVC   PKAREA(8),@TS00001                                  0259
*              UNPK(NSPCBUF2,PKAREA(4:8));/* FOR PDE         @ZA08703*/
         UNPK  NSPCBUF2(8),PKAREA+3(5)                             0260
*              SPACPTR2 = ADDR(NSPCBUF2); /* OVERLAY PDE     @ZA08703*/
         LA    @05,NSPCBUF2                                        0261
         ST    @05,SPACPTR2(,@10)                                  0261
*              SPACLEN2 = 8;              /* SET LENGTH      @ZA08703*/
         LA    @05,8                                               0262
         STH   @05,SPACLEN2(,@10)                                  0262
*              SPCPRES2 = '1'B;        /* INDICATE VALUE     @ZA08703*/
         OI    SPCPRES2(@10),B'10000000'                           0263
*            END;                      /* PRESENT            @ZA08703*/
*          IF DEFDQTY ^= 0             /* IF DEFAULT FOR     @ZA08703*/
*            THEN DO;                  /* DIRECTORY BLOCKS   @ZA08703*/
@RF00256 L     @10,DEFDQTY-1(,AB445PTR)                            0265
         LA    @10,0(,@10)                                         0265
         LTR   @10,@10                                             0265
         BZ    @RF00265                                            0265
*              INPTR = ADDR(DEFDQTY);  /* SET OVERLAY        @ZA08703*/
         LA    INPTR,DEFDQTY(,AB445PTR)                            0267
*              CVD(FIXED24,PKAREA);    /* GET IT'S EBCDIC    @ZA08703*/
         LR    @10,INPTR                                           0268
         BCTR  @10,0                                               0268
         L     @10,FIXED24(,@10)                                   0268
         LA    @10,0(,@10)                                         0268
         CVD   @10,@TS00001                                        0268
         MVC   PKAREA(8),@TS00001                                  0268
*              UNPK(NDIRBUF1,PKAREA(4:8));  /* EQUIVALENT    @ZA08703*/
         UNPK  NDIRBUF1(8),PKAREA+3(5)                             0269
*              DIRPDE = 1;             /* SHOW KEYWD PRESENT @ZA08703*/
         L     @10,PTRPDL(,AWAPTR)                                 0270
         MVC   DIRPDE(2,@10),@CH00033                              0270
*              DIRPTR = ADDR(NDIRBUF1);/* OVERLAY PDE        @ZA08703*/
         LA    @05,NDIRBUF1                                        0271
         ST    @05,DIRPTR(,@10)                                    0271
*              DIRLEN = 8;             /* SET LENGTH         @ZA08703*/
         MVC   DIRLEN(2,@10),@CH00095                              0272
*              DIRPRES = '1'B;         /* SHOW VALUE PRESENT @ZA08703*/
         OI    DIRPRES(@10),B'10000000'                            0273
*            END;                      /*                    @ZA08703*/
*          IF DEFBLKLN = '1'B          /* IF UNITS OF SPACE  @ZA08703*/
*            THEN DO;                  /* IN AVBLOCK         @ZA08703*/
@RF00265 TM    DEFBLKLN(AB445PTR),B'00100000'                      0275
         BNO   @RF00275                                            0275
*              BLOKPDE = 2;            /* SHOW AVBLOCK REQ'D @ZA08703*/
         L     @10,PTRPDL(,AWAPTR)                                 0277
         MVC   BLOKPDE(2,@10),@CH00061                             0277
*              INPTR = ADDR(DEFDRLH);  /* SET OVERLAY        @ZA08703*/
         LA    INPTR,DEFDRLH(,AB445PTR)                            0278
*              CVD(FIXED24,PKAREA);    /* GET EBCDIC FOR     @ZA08703*/
         LR    @02,INPTR                                           0279
         BCTR  @02,0                                               0279
         L     @02,FIXED24(,@02)                                   0279
         LA    @02,0(,@02)                                         0279
         CVD   @02,@TS00001                                        0279
         MVC   PKAREA(8),@TS00001                                  0279
*              UNPK(NBLKBUF1,PKAREA(4:8));    /* AVBLOCK LEN @ZA08703*/
         UNPK  NBLKBUF1(8,AWAPTR),PKAREA+3(5)                      0280
*              ABLKPTR = ADDR(NBLKBUF1);      /* OVERLAY PDE @ZA08703*/
         LA    @05,NBLKBUF1(,AWAPTR)                               0281
         ST    @05,ABLKPTR(,@10)                                   0281
*              ABLKLEN = 8;            /* SET LENGTH         @ZA08703*/
         MVC   ABLKLEN(2,@10),@CH00095                             0282
*              ABLKPRES = '1'B;        /* INDICATE AVBLOCK   @ZA08703*/
         OI    ABLKPRES(@10),B'10000000'                           0283
*            END;                      /* VALUE SUPPLIED     @ZA08703*/
*          IF DEFTRK = '1'B            /* IF UNITS OF SPACE  @ZA08703*/
*            THEN                      /* ARE IN TRACKS      @ZA08703*/
@RF00275 TM    DEFTRK(AB445PTR),B'10000000'                        0285
         BNO   @RF00285                                            0285
*              BLOKPDE = 3;            /* INDICATE TRACKS    @ZA08703*/
         L     @10,PTRPDL(,AWAPTR)                                 0286
         MVC   BLOKPDE(2,@10),@CH00319                             0286
*          IF DEFCYL = '1'B            /* IF UNITS OF SPACE  @ZA08703*/
*            THEN                      /* ARE IN CYLINDERS   @ZA08703*/
@RF00285 TM    DEFCYL(AB445PTR),B'01000000'                        0287
         BNO   @RF00287                                            0287
*              BLOKPDE = 4;            /* INDICATE CYLINDERS @ZA08703*/
         L     @10,PTRPDL(,AWAPTR)                                 0288
         MVC   BLOKPDE(2,@10),@CH00317                             0288
*          GEN(DELETE EP=IEFAB445);    /* DELETE DEFAULT     @ZA08703*/
@RF00287 DS    0H                                                  0289
         DELETE EP=IEFAB445
*        END SPCDEFLT;                 /* CSECT              @ZA08703*/
@EL00008 DS    0H                                                  0290
@EF00008 DS    0H                                                  0290
@ER00008 LM    @14,@12,@SA00008                                    0290
         BR    @14                                                 0290
*                                                                  0291
*    END IKJEFD33                                                  0291
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IKJZT430)                                        *
*/*%INCLUDE SYSLIB  (IKJZB831)                                        *
*/*%INCLUDE SYSLIB  (IKJPPL  )                                        *
*/*%INCLUDE SYSLIB  (IKJCPPL )                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                        *
*/*%INCLUDE SYSLIB  (IEFZB445)                                        *
*;                                                                 0291
@DATA    DS    0H
@CH00033 DC    H'1'
@CH00061 DC    H'2'
@CH00319 DC    H'3'
@CH00317 DC    H'4'
@CH00064 DC    H'5'
@CH00175 DC    H'7'
@CH00412 DC    XL2'000A'
@CH00414 DC    XL2'000B'
@CH00488 DC    XL2'0030'
@SM00677 MVC   ADLPARM(0,@15),SAVPARM+1
@SM00680 MVC   PKAREA1(0,Y),VALBUF
@SM00682 MVC   ADLPARM(0,@02),SAVPARM+2
@SM00684 MVC   NSPCBUF1(0),SPCBUF1(@01)
@SM00686 MVC   NSPCBUF2(0),SPCBUF2(@01)
@SM00688 MVC   NDIRBUF1(0),DIRBUF1(@01)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@SAV001  EQU   @SA00001
@SA00007 DS    15F
@SA00003 DS    14F
@SA00005 DS    15F
@SA00002 DS    13F
@SA00006 DS    15F
@SA00008 DS    15F
@TF00001 DS    F
@ZTEMPS  DS    0F
@ZT00001 DC    F'0'
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
@TEMPS   EQU   @ZTEMPS
@L       EQU   @ZLEN
IKJEFD33 CSECT
         DS    0F
@CF00168 DC    F'6'
@CH00168 EQU   @CF00168+2
@CF00095 DC    F'8'
@CH00095 EQU   @CF00095+2
@DATD    DSECT
         DS    0D
PDLADDR2 DS    A
         DS    0D
@TS00001 DS    CL8
CNVRTYPE DS    CL1
         ORG   CNVRTYPE
BLKCNVRT DS    BL1
SPCCNVRT EQU   CNVRTYPE+0
INCCNVRT EQU   CNVRTYPE+0
@NM00008 EQU   CNVRTYPE+0
         ORG   CNVRTYPE+1
SAVPARM  DS    CL4
VALBUF   DS    CL8
NSPCBUF1 DS    CL8
NSPCBUF2 DS    CL8
NDIRBUF1 DS    CL8
PKAREA   DS    CL8
         DS    CL3
CVBAREA  DS    CL8
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
@DATEND  EQU   *
IKJEFD33 CSECT
         DS    0F
@SIZDATD DC    AL1(1)
         DC    AL3(@ENDDATD-@DATD)
@SIZ001  EQU   @SIZDATD
@CV00044 DC    V(IKJEFD35)
@CV00045 DC    V(IKJEFD37)
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
@0       EQU   00
@1       EQU   01
@2       EQU   02
@3       EQU   03
@4       EQU   04
@5       EQU   05
@6       EQU   06
@7       EQU   07
@8       EQU   08
@9       EQU   09
@A       EQU   10
@B       EQU   11
@C       EQU   12
@D       EQU   13
@E       EQU   14
@F       EQU   15
INPTR    EQU   @05
AB445PTR EQU   @04
VALLEN   EQU   @05
INC      EQU   @04
AWAPTR   EQU   @03
R0       EQU   @00
R1       EQU   @01
R5       EQU   @05
Y        EQU   @08
R13      EQU   @13
R14      EQU   @01
R15      EQU   @15
ALLOCWA  EQU   0
CPPLPTR  EQU   ALLOCWA
PTRPDL   EQU   ALLOCWA+4
GTPLPTR  EQU   ALLOCWA+8
SWITCH   EQU   ALLOCWA+12
RBCODE12 EQU   SWITCH
CONT     EQU   SWITCH
SWITCH2  EQU   ALLOCWA+13
DSEXISTS EQU   SWITCH2
ENTRYCD  EQU   ALLOCWA+14
TXT      EQU   ALLOCWA+16
RCODESV  EQU   ALLOCWA+24
VCFLAGS  EQU   ALLOCWA+36
PMPTPDL  EQU   ALLOCWA+40
P        EQU   ALLOCWA+52
Q        EQU   ALLOCWA+56
CMDTWO   EQU   ALLOCWA+60
NBLKBUF1 EQU   ALLOCWA+164
PPLPTR   EQU   ALLOCWA+172
ALLOCPDL EQU   0
BLOKPDE  EQU   ALLOCPDL+16
SPACEPDE EQU   ALLOCPDL+18
DIRPDE   EQU   ALLOCPDL+20
USINGPDE EQU   ALLOCPDL+22
RLSEPDE  EQU   ALLOCPDL+42
RNDPDE   EQU   ALLOCPDL+44
DSNPDE   EQU   ALLOCPDL+48
DSNPTR   EQU   DSNPDE
DSNFLAGS EQU   DSNPDE+6
MBRPTR   EQU   DSNPDE+8
MBRFLAGS EQU   DSNPDE+14
MBRPRES  EQU   MBRFLAGS
PASSPTR  EQU   DSNPDE+16
PASSFLAG EQU   DSNPDE+22
DDNMEPDE EQU   ALLOCPDL+76
DDNPTR   EQU   DDNMEPDE
DDNFLAGS EQU   DDNMEPDE+6
CLASPDE  EQU   ALLOCPDL+84
CLASPTR  EQU   CLASPDE
CLASFLG  EQU   CLASPDE+6
SERPDE   EQU   ALLOCPDL+92
SERPTR   EQU   SERPDE
SERFLAGS EQU   SERPDE+6
BLKPDE   EQU   ALLOCPDL+104
BLKPTR   EQU   BLKPDE
BLKLEN   EQU   BLKPDE+4
BLKFLAGS EQU   BLKPDE+6
ABLKPDE  EQU   ALLOCPDL+112
ABLKPTR  EQU   ABLKPDE
ABLKLEN  EQU   ABLKPDE+4
ABLKFLG  EQU   ABLKPDE+6
ABLKPRES EQU   ABLKFLG
SPACPDE  EQU   ALLOCPDL+120
SPACEPTR EQU   SPACPDE
SPACELEN EQU   SPACPDE+4
SPACEFLG EQU   SPACPDE+6
SPACPRES EQU   SPACEFLG
SPACPDE2 EQU   ALLOCPDL+128
SPACPTR2 EQU   SPACPDE2
SPACLEN2 EQU   SPACPDE2+4
SPACFLG2 EQU   SPACPDE2+6
SPCPRES2 EQU   SPACFLG2
DIRECPDE EQU   ALLOCPDL+136
DIRPTR   EQU   DIRECPDE
DIRLEN   EQU   DIRECPDE+4
DIRFLAGS EQU   DIRECPDE+6
DIRPRES  EQU   DIRFLAGS
ATTRPDE  EQU   ALLOCPDL+144
ATTRPTR  EQU   ATTRPDE
ATTRFLAG EQU   ATTRPDE+6
USIDPDE  EQU   ALLOCPDL+152
USIDPTR  EQU   USIDPDE
USIDFLAG EQU   USIDPDE+6
UTYPPDE  EQU   ALLOCPDL+160
UTYPPTR  EQU   UTYPPDE
UTYPFLAG EQU   UTYPPDE+6
UNCNTPDE EQU   ALLOCPDL+168
UCNTPTR  EQU   UNCNTPDE
UCNTFLAG EQU   UNCNTPDE+6
POSTPDE  EQU   ALLOCPDL+180
POSPTR   EQU   POSTPDE
POSFLAG  EQU   POSTPDE+6
MXVOLPDE EQU   ALLOCPDL+188
MXVOLPTR EQU   MXVOLPDE
MXVOLFLG EQU   MXVOLPDE+6
VOLSQPDE EQU   ALLOCPDL+196
VOLSQPTR EQU   VOLSQPDE
VOLSQFLG EQU   VOLSQPDE+6
MSVGPDE  EQU   ALLOCPDL+204
MSVGPTR  EQU   MSVGPDE
MSVGFLG  EQU   MSVGPDE+6
DSNBUF   EQU   0
BLKBUF   EQU   0
SPACEBUF EQU   0
SPACBUF2 EQU   0
GTPL     EQU   0
GTPLABLK EQU   GTPL+16
TEXTCORE EQU   0
ADDNUM   EQU   TEXTCORE
ADDTEXT  EQU   TEXTCORE+4
ADLTEXT  EQU   0
ADLKEY   EQU   ADLTEXT
ADLNBR   EQU   ADLTEXT+2
ADLLEN   EQU   ADLTEXT+4
ADLPARM  EQU   ADLTEXT+6
PPL      EQU   0
CPPL     EQU   0
SPCPDE1  EQU   0
SPCPTR1  EQU   SPCPDE1+8
SPCLEN1  EQU   SPCPDE1+12
SPCFLAG1 EQU   SPCPDE1+14
SPCPTR2  EQU   SPCPDE1+16
SPCLEN2  EQU   SPCPDE1+20
SPCFLAG2 EQU   SPCPDE1+22
SPC2PRES EQU   SPCFLAG2
SPCBUF1  EQU   0
SPCBUF2  EQU   0
DIRPDE1  EQU   0
DIRPTR1  EQU   DIRPDE1+8
DIRLEN1  EQU   DIRPDE1+12
DIRFLAG1 EQU   DIRPDE1+14
DIRBUF1  EQU   0
IEFAB445 EQU   0
DEFSPACE EQU   IEFAB445
DEFPQTY  EQU   DEFSPACE
DEFSQTY  EQU   DEFSPACE+3
DEFDRLH  EQU   DEFSPACE+6
DEFDQTY  EQU   DEFSPACE+9
@NM00017 EQU   DEFSPACE+12
DEFTRK   EQU   @NM00017
DEFCYL   EQU   @NM00017
DEFBLKLN EQU   @NM00017
PKAREA1  EQU   0
AREA1    EQU   0
AREA2    EQU   0
FIXED24  EQU   0
ABLKBUF  EQU   0
ATTRBUF  EQU   0
CLASSBUF EQU   0
DDNBUF   EQU   0
DIRBUF   EQU   0
MBRBUF   EQU   0
MSVGBUF  EQU   0
MXVOLBUF EQU   0
PASSBUF  EQU   0
POSTBUF  EQU   0
SERBUF   EQU   0
UCNTBUF  EQU   0
USIDBUF  EQU   0
UTYPBUF  EQU   0
VSEQBUF  EQU   0
INPARMS  EQU   0
*                                      START UNREFERENCED COMPONENTS
DEFUNIT  EQU   IEFAB445+13
DEFROUND EQU   @NM00017
DEFALX   EQU   @NM00017
DEFMIXG  EQU   @NM00017
DEFCONTG EQU   @NM00017
DEFRLSE  EQU   @NM00017
@NM00016 EQU   DIRPDE1+15
@NM00015 EQU   DIRPDE1+4
@NM00014 EQU   DIRPDE1
@NM00013 EQU   SPCPDE1+23
@NM00012 EQU   SPCFLAG2
@NM00011 EQU   SPCPDE1+15
@NM00010 EQU   SPCPDE1+4
@NM00009 EQU   SPCPDE1
CPPLECT  EQU   CPPL+12
CPPLPSCB EQU   CPPL+8
CPPLUPT  EQU   CPPL+4
CPPLCBUF EQU   CPPL
PPLUWA   EQU   PPL+24
PPLCBUF  EQU   PPL+20
PPLANS   EQU   PPL+16
PPLPCL   EQU   PPL+12
PPLECB   EQU   PPL+8
PPLECT   EQU   PPL+4
PPLUPT   EQU   PPL
ADDUNIT  EQU   TEXTCORE+36
@NM00007 EQU   TEXTCORE+2
GTPLOUTA EQU   GTPL+20
GTPLTBLE EQU   GTPL+12
GTPLKLST EQU   GTPL+8
GTPLPCL  EQU   GTPL+4
GTPLPDL  EQU   GTPL
DSNTERM  EQU   DSNBUF
MSVGRSV2 EQU   MSVGPDE+7
MSVGRSV1 EQU   MSVGFLG
MSVGPRES EQU   MSVGFLG
MSVGLEN  EQU   MSVGPDE+4
VOLRSV2  EQU   VOLSQPDE+7
VOLRSV1  EQU   VOLSQFLG
VOLPRES  EQU   VOLSQFLG
VOLSQLEN EQU   VOLSQPDE+4
MXVRSV2  EQU   MXVOLPDE+7
MXVRSV1  EQU   MXVOLFLG
MXVPRES  EQU   MXVOLFLG
MXVOLLEN EQU   MXVOLPDE+4
POSRSV2  EQU   POSTPDE+7
POSRSV1  EQU   POSFLAG
POSPRES  EQU   POSFLAG
POSLEN   EQU   POSTPDE+4
LABLRSV1 EQU   ALLOCPDL+178
LABELPDE EQU   ALLOCPDL+176
UCNTRSV2 EQU   UNCNTPDE+7
UCNTRSV1 EQU   UCNTFLAG
UCNTPRES EQU   UCNTFLAG
UCNTLEN  EQU   UNCNTPDE+4
UTYPRSV2 EQU   UTYPPDE+7
UTYPRSV1 EQU   UTYPFLAG
UTYPPRES EQU   UTYPFLAG
UTYPLEN  EQU   UTYPPDE+4
USIDRSV2 EQU   USIDPDE+7
USIDRSV1 EQU   USIDFLAG
USIDPRES EQU   USIDFLAG
USIDLEN  EQU   USIDPDE+4
ATTRRSV2 EQU   ATTRPDE+7
ATTRRSV1 EQU   ATTRFLAG
ATTRPRES EQU   ATTRFLAG
ATTRLEN  EQU   ATTRPDE+4
DIRRSV2  EQU   DIRECPDE+7
DIRRSV1  EQU   DIRFLAGS
SPCRSV22 EQU   SPACPDE2+7
SPCRSV12 EQU   SPACFLG2
SPACRSV2 EQU   SPACPDE+7
SPACRSV1 EQU   SPACEFLG
ABLKRSV2 EQU   ABLKPDE+7
ABLKRSV1 EQU   ABLKFLG
BLKRSV2  EQU   BLKPDE+7
BLKRSV1  EQU   BLKFLAGS
BLKPRES  EQU   BLKFLAGS
SERNEXT  EQU   SERPDE+8
SERRSV2  EQU   SERPDE+7
SERRSV1  EQU   SERFLAGS
SERPRES  EQU   SERFLAGS
SERLEN   EQU   SERPDE+4
CLASRSV2 EQU   CLASPDE+7
CLASRSV1 EQU   CLASFLG
CLASPRES EQU   CLASFLG
CLASLEN  EQU   CLASPDE+4
DDNRSV2  EQU   DDNMEPDE+7
DDNRSV1  EQU   DDNFLAGS
DDNPRES  EQU   DDNFLAGS
DDNLEN   EQU   DDNMEPDE+4
DSNNEXT  EQU   DSNPDE+24
PASSRSV2 EQU   DSNPDE+23
PASSRSV1 EQU   PASSFLAG
PASSPRES EQU   PASSFLAG
PASSLEN  EQU   DSNPDE+20
MBRRSV2  EQU   DSNPDE+15
MBRRSV1  EQU   MBRFLAGS
MBRLEN   EQU   DSNPDE+12
DSNRSV2  EQU   DSNPDE+7
DSNRSV1  EQU   DSNFLAGS
DSNQUOT  EQU   DSNFLAGS
DSNPRES  EQU   DSNFLAGS
DSNLENGH EQU   DSNPDE+4
DISPPDE  EQU   ALLOCPDL+46
VSEQPDE  EQU   ALLOCPDL+40
PRIVPDE  EQU   ALLOCPDL+38
MAXVPDE  EQU   ALLOCPDL+36
POSPDE   EQU   ALLOCPDL+34
LABLPDE  EQU   ALLOCPDL+32
UCNTPDE  EQU   ALLOCPDL+30
UNITPDE  EQU   ALLOCPDL+28
HOLDPDE  EQU   ALLOCPDL+26
DESTPDE  EQU   ALLOCPDL+24
VOLPDE   EQU   ALLOCPDL+14
STATSPDE EQU   ALLOCPDL+12
FILEPDE  EQU   ALLOCPDL+10
DSPDE    EQU   ALLOCPDL+8
@NM00006 EQU   ALLOCPDL+4
@NM00005 EQU   ALLOCPDL
FIRSTPTR EQU   ALLOCWA+176
COMMECB  EQU   ALLOCWA+160
PDLADDR3 EQU   ALLOCWA+156
PPLTWO   EQU   ALLOCWA+128
CMDTWOBF EQU   CMDTWO+4
CMDTWOOF EQU   CMDTWO+2
CMDTWOLN EQU   CMDTWO
MSGPTR   EQU   ALLOCWA+48
PRCODE   EQU   ALLOCWA+44
@NM00004 EQU   ALLOCWA+38
NCLASBUF EQU   ALLOCWA+37
@NM00003 EQU   VCFLAGS
SPACE2   EQU   VCFLAGS
SPACE1   EQU   VCFLAGS
AVBLK    EQU   VCFLAGS
PTRMSGS  EQU   ALLOCWA+32
DSNCTR   EQU   ALLOCWA+30
VLISTCTR EQU   ALLOCWA+28
PTRS99RB EQU   ALLOCWA+20
@NM00002 EQU   SWITCH2
@NM00001 EQU   SWITCH2
FIRSTPDE EQU   SWITCH
AWARSV1  EQU   SWITCH
ASTRSK   EQU   SWITCH
TERMOPT  EQU   SWITCH
PROMPT   EQU   SWITCH
DSOVRLAY EQU   SWITCH
*                                      END UNREFERENCED COMPONENTS
@RC00079 EQU   @RC00070
@RC00091 EQU   @RC00088
@RF00095 EQU   @RC00088
@RF00103 EQU   @RC00100
@RC00181 EQU   @EL00005
@RC00209 EQU   @EL00006
@RC00226 EQU   @EL00007
@EL01    EQU   @EL00001
@ENDDATA EQU   *
         END   IKJEFD33,(C'PLS1037',0701,78174)
