         TITLE 'CONCATENATION ROUTINE                                  *
                        '
IKJEFD34 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IKJEFD34  75.248'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @11,@01                                             0001
         USING @DATD,@11                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @00,@01,20(@13)                                     0001
         ST    @11,8(,@13)                                         0001
         LR    @13,@11                                             0001
         XC    @ZTEMPS(@ZLEN),@ZTEMPS
         MVC   @PC00001(4),0(@01)                                  0001
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      CONCATRQ                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE PROCESSES A CONCATENATION REQUEST.             */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      IF A STATUS OF MOD, NEW OR SYSOUT WAS SPECIFIED,            */
*/*      THEN ISSUE AN ERROR MESSAGE AND TERMINATE.                  */
*/*      IF FILE WAS NOT SPECIFIED, PROMPT THE USER                  */
*/*      TO ENTER A FILENAME. MARK EXTRANEOUS PARAMETERS NOT         */
*/*      ENTERED IN THE PDL. ISSUE A GETMAIN FOR STORAGE TO HOLD     */
*/*      THE TEXT UNITS FOR THE DDNAMES ASSOCIATED WITH EACH DATA    */
*/*      SET. TRANSLATE PARAMETERS TO TEXT FORMAT. INVOKE ROUTINE    */
*/*      CONCTDSN TO ALLOCATE EACH DATA SET. IF THE ALLOCATION WAS   */
*/*      SUCCESSFUL, INVOKE DYNAMIC ALLOCATION TO CONCATENATE THE    */
*/*      DDNAMES.                                                    */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO PDL                                                  */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      RBCODE12 = 0 - CONCATENATION SUCCESSFUL                     */
*/*                 1 - ERROR IN ALLOCATION OR CONCATENATION         */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    CONCATRQ:                                                     0088
*          AWAPTR = R1;                     /* POINTER TO WORKAREA   */
CONCATRQ LR    AWAPTR,R1                                           0088
*          INC = ADDNUM + 1;                /* SUBSCRIPT USED FOR  0089
*                                              ADDITIONAL TEXT       */
         L     @06,GTPLPTR(,AWAPTR)                                0089
         L     @06,GTPLABLK(,@06)                                  0089
         LA    INC,1                                               0089
         AH    INC,ADDNUM(,@06)                                    0089
*          CNCTFLAG = '00'X;                /* INITIALIZE FLAGS      */
         MVI   CNCTFLAG,X'00'                                      0090
*          IF STATSPDE > 2 THEN             /* IF MOD,NEW OR SYSOUT, */
         L     @06,PTRPDL(,AWAPTR)                                 0091
         LH    @06,STATSPDE(,@06)                                  0091
         C     @06,@CF00080                                        0091
         BNH   @RF00091                                            0091
*            DO;                            /* THEN                  */
*              RBCODE12 = '1'B;             /* INDICATE ALLOC FAILED */
         OI    RBCODE12(AWAPTR),B'10000000'                        0093
*              STATSERR = '1'B;             /* INDICATE ERROR TYPE   */
         OI    STATSERR,B'10000000'                                0094
*              CALL CCERRMSG;               /* ISSUE ERROR MSG       */
         BAL   @14,CCERRMSG                                        0095
*            END;                                                  0096
*          ELSE                                                    0097
*            DO;                                                   0097
         B     @RC00091                                            0097
@RF00091 DS    0H                                                  0098
*              IF FILEPDE = 0 THEN          /* IF FILE NOT ENTERED,  */
         L     @06,PTRPDL(,AWAPTR)                                 0098
         LH    @06,FILEPDE(,@06)                                   0098
         LTR   @06,@06                                             0098
         BNZ   @RF00098                                            0098
*                CALL PRMPTDDN;             /* PROMPT FOR FILENAME   */
         BAL   @14,PRMPTDDN                                        0099
*              I = 1;                       /* INITIALIZE SUBSCRIPT  */
@RF00098 LA    I,1                                                 0100
*    /* MARK EXTRANEOUS PARAMETERS NOT ENTERED IN PDL                */
*              DO WHILE (CONT='0'B);                               0101
         B     @DE00101                                            0101
@DL00101 DS    0H                                                  0102
*              IF CONCTEXT(I)='00'X THEN    /* IF END OF LIST,       */
         LA    @06,CONCTEXT-1(I)                                   0102
         CLI   0(@06),X'00'                                        0102
         BNE   @RF00102                                            0102
*                CONT='1'B;                 /* EXIT DO-WHILE         */
         OI    CONT(AWAPTR),B'00010000'                            0103
*              ELSE                         /* ELSE,                 */
*                DO;                        /* GET ADDRESS OF PDE    */
         B     @RC00102                                            0104
@RF00102 DS    0H                                                  0105
*                 EXTRAN = ADDR(ALLOCPDL)+CONCTEXT(I);             0105
         SLR   EXTRAN,EXTRAN                                       0105
         IC    EXTRAN,CONCTEXT-1(I)                                0105
         AL    EXTRAN,PTRPDL(,AWAPTR)                              0105
*                 PDEEXT = 0;               /* SET PDE TO 0          */
         SLR   @06,@06                                             0106
         STH   @06,PDEEXT(,EXTRAN)                                 0106
*                 I = I+1;                  /* INCREMENT SUBSCRIPT   */
         AL    I,@CF00033                                          0107
*                END;                                              0108
*              END;                         /* END DO-WHILE          */
@RC00102 DS    0H                                                  0109
@DE00101 TM    CONT(AWAPTR),B'00010000'                            0109
         BZ    @DL00101                                            0109
*              CONT = '0'B;                 /* RESET SWITCH          */
         NI    CONT(AWAPTR),B'11101111'                            0110
*              SIZE = (DSNCTR*10) + 16;     /* CORE NEEDED FOR CONCAT*/
         LH    @02,DSNCTR(,AWAPTR)                                 0111
         MH    @02,@CH00839                                        0111
         LA    @02,16(,@02)                                        0111
         ST    @02,@TF00001                                        0111
         MVC   SIZE(3),@TF00001+1                                  0111
*              SPNO = '01'X;                /* SUBPOOL NUMBER        */
         MVI   SPNO,X'01'                                          0112
*              R0 = CORE;                   /* SBPOOL AND SIZE IN 0  */
         L     R0,CORE                                             0113
*              GEN (GETMAIN R,LV=(0));      /* ISSUE GETMAIN         */
         GETMAIN R,LV=(0)
*              DDNAPTR = R1;                /* PTR TO STORAGE        */
         LR    DDNAPTR,R1                                          0115
*              DDLST = ADDR(DDNMLEN);       /* PTR TO LIST POSITION  */
         LA    DDLST,DDNMLEN(,DDNAPTR)                             0116
*              PERMCTPT = ADDR(PERMCTXT);   /* TEXT FOR PERM CONCAT  */
         LA    @02,PERMCTXT(,DDNAPTR)                              0117
         ST    @02,PERMCTPT(,DDNAPTR)                              0117
*              PERMCTKY = DCCPERMC;         /* KEY AND               */
         MVC   PERMCTKY(2,DDNAPTR),@CH00620                        0118
*              PERMCTNM = 0;                /* NUMBER                */
         SLR   @02,@02                                             0119
         STH   @02,PERMCTNM(,DDNAPTR)                              0119
*              DDNMPTR = ADDR(DDNMTXT);     /* TEXT FOR DDNAMES      */
         LA    @02,DDNMTXT(,DDNAPTR)                               0120
         ST    @02,DDNMPTR(,DDNAPTR)                               0120
*              DDNMKEY = DCCDDNAM;          /* KEY AND               */
         MVC   DDNMKEY(2,DDNAPTR),@CH00614                         0121
*              DDNMNBR = DSNCTR;            /* NUMBER                */
         LH    @02,DSNCTR(,AWAPTR)                                 0122
         STH   @02,DDNMNBR(,DDNAPTR)                               0122
*              DDNMEND = '1'B;              /* END OF ADDR LIST      */
         OI    DDNMEND(DDNAPTR),B'10000000'                        0123
*              CALL CNCATTXT;               /* SET UP TEXT UNITS     */
         BAL   @14,CNCATTXT                                        0124
*              CALL TRANSRTN;               /* TRANSLATE PARAMETERS  */
         BAL   @14,TRANSRTN                                        0125
*              IF RBCODE12 = '0'B THEN      /* IF TRANSLATE          */
         TM    RBCODE12(AWAPTR),B'10000000'                        0126
         BNZ   @RF00126                                            0126
*                DO;                        /* SUCCESSFUL,           */
*                  CALL CONCTDSN;           /* ALLOC EACH DATASET    */
         BAL   @14,CONCTDSN                                        0128
*                  IF RBCODE12 = '0'B THEN  /* IF ALLOCATION GOOD,   */
         TM    RBCODE12(AWAPTR),B'10000000'                        0129
         BNZ   @RF00129                                            0129
*                    DO;                                           0130
*                  S99VERB = S99VRBCC;      /* SET CONCAT VERB       */
         L     @10,PTRS99RB(,AWAPTR)                               0131
         MVI   S99VERB(@10),X'03'                                  0131
*                  S99TXTPP = DDNAPTR;      /* SET PTR TO CONCAT TEXT*/
         ST    DDNAPTR,S99TXTPP(,@10)                              0132
*                  CALL DYNSVC;             /* INVOKE DYN ALLOCATION */
         BAL   @14,DYNSVC                                          0133
*                  IF RCODESV > 0 THEN      /* IF ALLOCATION FAILED  */
         L     @10,RCODESV(,AWAPTR)                                0134
         LTR   @10,@10                                             0134
         BNP   @RF00134                                            0134
*                    DO;                    /* THEN                  */
*                      RBCODE12 = '1'B;     /* INDICATE ALLOC FAILED */
         OI    RBCODE12(AWAPTR),B'10000000'                        0136
*                      CALL CONCTERR;       /* ISSUE MSG & FREE DS   */
         BAL   @14,CONCTERR                                        0137
*                    END;                                          0138
*                    END;                                          0139
@RF00134 DS    0H                                                  0140
*                END;                                              0140
@RF00129 DS    0H                                                  0141
*            END;                                                  0141
@RF00126 DS    0H                                                  0142
*        IF RBCODE12 = '1'B THEN       /* IF ERROR OCCURRED          */
@RC00091 TM    RBCODE12(AWAPTR),B'10000000'                        0142
         BNO   @RF00142                                            0142
*          RETCODE = 12;               /* RETURN CODE OF 12          */
         L     @10,REGSAVE(,R13)                                   0143
         MVC   RETCODE(4,@10),@CF00845                             0143
*        ELSE                          /* ELSE                       */
*          RETCODE = 0;                /* RETURN CODE 0              */
         B     @RC00142                                            0144
@RF00142 L     @10,REGSAVE(,R13)                                   0144
         SLR   @15,@15                                             0144
         ST    @15,RETCODE(,@10)                                   0144
*        RETURN;                                                   0145
@EL00001 L     @13,4(,@13)                                         0145
@EF00001 L     @00,@SIZDATD                                        0145
         LR    @01,@11                                             0145
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0145
         BR    @14                                                 0145
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      CNCATTXT                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE BUILDS ADDITIONAL TEXT UNITS NEEDED WHEN       */
*/*      ALLOCATING DATA SETS TO BE CONCATENATED.                    */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      BUILD TEXT UNIT TO RETURN DDNAME. BUILD TEXT UNIT TO RETURN */
*/*      DSORG.                                                      */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      WORKAREA                                                    */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      TEXT UNITS BUILT                                            */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/*                                                                  */
*/*        THESE TEXT UNITS HAVE TO BE SET UP HERE BECAUSE GENTRANS  */
*/*        CAN ONLY BUILD TEXT UNITS RELATED TO PARAMETERS IN        */
*/*        THE PDL.                                                  */
*/********************************************************************/
*    CNCATTXT: PROC;                                               0146
         B     @EL00001                                            0146
CNCATTXT STM   @14,@07,12(@13)                                     0146
         STM   @09,@12,56(@13)                                     0146
*        ADDNUM = ADDNUM + 1;          /* INCREMENT TEXT COUNTER     */
         L     @10,GTPLPTR(,AWAPTR)                                0147
         L     @10,GTPLABLK(,@10)                                  0147
         LA    @09,1                                               0147
         LH    @02,ADDNUM(,@10)                                    0147
         ALR   @02,@09                                             0147
         STH   @02,ADDNUM(,@10)                                    0147
*        ADLKEY = DALRTDDN;            /* RETURN DDNAME KEY          */
         L     @15,TXT(,AWAPTR)                                    0148
         MVC   ADLKEY(2,@15),@CH00782                              0148
*        ADLNBR = 1;                   /* NUMBER                     */
         STH   @09,ADLNBR(,@15)                                    0149
*        ADLLEN = 8;                   /* MAX LENGTH                 */
         LA    @14,8                                               0150
         STH   @14,ADLLEN(,@15)                                    0150
*        ADDTEXT(INC) = TXT;           /* PTR TO TEXT UNIT IN LIST   */
         LR    @07,INC                                             0151
         SLA   @07,2                                               0151
         ST    @15,@TF00001                                        0151
         ALR   @07,@10                                             0151
         MVC   ADDTEXT-4(4,@07),@TF00001                           0151
*        TXT = TXT + 14;               /* INCREMENT TEXT PTR         */
         AL    @15,@CF00463                                        0152
         ST    @15,TXT(,AWAPTR)                                    0152
*        INC = INC + 1;                /* INCREMENT ADDR SUBSCRIPT   */
         ALR   INC,@09                                             0153
*        ADDNUM = ADDNUM + 1;          /* INCREMENT TEXT COUNTER     */
         ALR   @02,@09                                             0154
         STH   @02,ADDNUM(,@10)                                    0154
*        ADLKEY = DALRTORG;            /* RETURN DSORG KEY           */
         MVC   ADLKEY(2,@15),@CH00786                              0155
*        ADLNBR = 1;                   /* NUMBER                     */
         STH   @09,ADLNBR(,@15)                                    0156
*        ADLLEN = 2;                   /* LENGTH                     */
         MVC   ADLLEN(2,@15),@CH00080                              0157
*        ADDTEXT(INC) = TXT;           /* PTR TO TEXT UNIT IN LIST   */
         LR    @02,INC                                             0158
         SLA   @02,2                                               0158
         ST    @15,@TF00001                                        0158
         ALR   @10,@02                                             0158
         MVC   ADDTEXT-4(4,@10),@TF00001                           0158
*        TXT = TXT + 8;                /* INCREMENT TEXT PTR         */
         ALR   @15,@14                                             0159
         ST    @15,TXT(,AWAPTR)                                    0159
*        INC = INC + 1;                /* INCREMENT ADDR SUBSCRIPT   */
         ALR   INC,@09                                             0160
*   END CNCATTXT;                                                  0161
@EL00002 DS    0H                                                  0161
@EF00002 DS    0H                                                  0161
@ER00002 LM    @14,@07,12(@13)                                     0161
         LM    @09,@12,56(@13)                                     0161
         BR    @14                                                 0161
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      CONCTDSN                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE ALLOCATES A LIST OF DATA SETS TO BE            */
*/*      CONCATENATED.                                               */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      ALLOCATE ONE DATA SET AT A TIME. IF THE ALLOCATION IS NOT   */
*/*      SUCCESSFUL, ISSUE AN ERROR MESSAGE AND TERMINATE. IF THE    */
*/*      DSORG IS NOT THE SAME FOR ALL THE DATA SETS IN THE LIST,    */
*/*      ISSUE AN ERROR MESSAGE AND TERMINATE. IF EITHER OF THE      */
*/*      ABOVE ERRORS ARE FOUND, ROUTINE CONCTERR IS INVOKED TO      */
*/*      FREE ANY PREVIOUSLY ALLOCATED DATA SETS.                    */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      PTR TO DSNAME, MEMBER AND PASSWORD TEXT UNITS               */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      RBCODE12 = 0 - ALLOCATION OF LIST SUCCESSFUL                */
*/*                 1 - ERROR IN ALLOCATION                          */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    CONCTDSN: PROC;                                               0162
CONCTDSN STM   @14,@07,@SA00003                                    0162
         STM   @09,@12,@SA00003+40                                 0162
*        DPTR2 = ADDR(DALEN);               /* PTR TO DSN LEN & PARM */
         L     @15,TUDSN(,GTPLOUT1)                                0163
         LA    DPTR2,DALEN(,@15)                                   0163
*        LISTNMBR = DSNCTR;                 /* SAVE DSN NUMBER       */
         LH    LISTNMBR,DSNCTR(,AWAPTR)                            0164
*        DANUM = 1;                         /* SET DSN NUMBER TO 1   */
         MVC   DANUM(2,@15),@CH00033                               0165
*        IF TUMBR ^= 0 THEN                 /* IF MEMBER UNIT BUILT  */
         SLR   @15,@15                                             0166
         L     @14,TUMBR(,GTPLOUT1)                                0166
         CR    @14,@15                                             0166
         BE    @RF00166                                            0166
*         DO;                               /* THEN                  */
*           MPTR2 = ADDR(MBLEN);            /* PTR TO MBR LEN & PARM */
         LA    MPTR2,MBLEN(,@14)                                   0168
*           SAVMBLEN = MEMLEN;              /* SAVE MEMBER LENGTH    */
         LH    @01,MEMLEN(,MPTR2)                                  0169
         LR    SAVMBLEN,@01                                        0169
*           IF MEMLEN = 0 THEN              /* IF MBR NOT ENTERED,   */
         CR    @01,@15                                             0170
         BNE   @RF00170                                            0170
*             DO;                           /* THEN,                 */
*               MBKEY = 0;                  /* SET KEY TO 0          */
         STH   @15,MBKEY(,@14)                                     0172
*               MBNUM = 0;                  /* SET NUMBER TO 0       */
         STH   @15,MBNUM(,@14)                                     0173
*             END;                                                 0174
*           ELSE                            /* ELSE,                 */
*             MBNUM = 1;                    /* SET MBR NUMBER TO 1   */
         B     @RC00170                                            0175
@RF00170 L     @01,TUMBR(,GTPLOUT1)                                0175
         MVC   MBNUM(2,@01),@CH00033                               0175
*         END;                                                     0176
@RC00170 DS    0H                                                  0177
*        IF TUPSWD ^= 0 THEN                /* IF PSWORD UNIT BUILT  */
@RF00166 SLR   @15,@15                                             0177
         L     @14,TUPSWD(,GTPLOUT1)                               0177
         CR    @14,@15                                             0177
         BE    @RF00177                                            0177
*         DO;                               /* THEN                  */
*           PPTR2 = ADDR(PWLEN);            /* PTR TO PSW LEN & PARM */
         LA    PPTR2,PWLEN(,@14)                                   0179
*           SAVPWLEN = PSWLEN;              /* SAVE PASSWORD LENGTH  */
         LH    @01,PSWLEN(,PPTR2)                                  0180
         STH   @01,SAVPWLEN                                        0180
*           IF PSWLEN = 0 THEN              /* IF PSW NOT ENTERED,   */
         CR    @01,@15                                             0181
         BNE   @RF00181                                            0181
*             DO;                           /* THEN                  */
*               PWKEY = 0;                  /* SET KEY TO 0          */
         STH   @15,PWKEY(,@14)                                     0183
*               PWNUM = 0;                  /* SET NUMBER TO 0       */
         STH   @15,PWNUM(,@14)                                     0184
*             END;                                                 0185
*           ELSE                            /* ELSE,                 */
*             PWNUM = 1;                    /* SET PSW NUMBER TO 1   */
         B     @RC00181                                            0186
@RF00181 L     @01,TUPSWD(,GTPLOUT1)                               0186
         MVC   PWNUM(2,@01),@CH00033                               0186
*         END;                                                     0187
@RC00181 DS    0H                                                  0188
*        CNCTFLG1 = '00'X;                  /* SET FLAGS TO 0        */
@RF00177 MVI   CNCTFLG1,X'00'                                      0188
*        S99NOCNV = '1'B;                   /* DONT USE EXISTING   0189
*                                              ALLOCATIONS           */
         L     @01,PTRS99RB(,AWAPTR)                               0189
         OI    S99NOCNV(@01),B'01000000'                           0189
*        DO WHILE (SEARCH = '0'B);          /* ALLOCATE DS LIST      */
         B     @DE00190                                            0190
@DL00190 DS    0H                                                  0191
*          CALL DYNSVC;                     /* INVOKE DYN ALLOCATION */
         BAL   @14,DYNSVC                                          0191
*          IF LISTNMBR = DSNCTR THEN        /* IF 1ST DS IN LIST,    */
         CH    LISTNMBR,DSNCTR(,AWAPTR)                            0192
         BNE   @RF00192                                            0192
*            CALL FIRSTCC;                  /* PROCESS               */
         BAL   @14,FIRSTCC                                         0193
*          ELSE                             /* IF NOT 1ST DS,        */
*            CALL OTHERCC;                  /* PROCESS               */
         B     @RC00192                                            0194
@RF00192 BAL   @14,OTHERCC                                         0194
*          IF RBCODE12 = '0'B THEN          /* IF NO ERROR FOUND     */
@RC00192 TM    RBCODE12(AWAPTR),B'10000000'                        0195
         BNZ   @RF00195                                            0195
*            DO;                            /* WHILE PROCESSING      */
*              LISTNMBR = LISTNMBR-1;       /* DECREMENT COUNTER     */
         BCTR  LISTNMBR,0                                          0197
*              IF LISTNMBR = 0 THEN         /* IF COUNTER 0          */
         LTR   LISTNMBR,LISTNMBR                                   0198
         BNZ   @RF00198                                            0198
*                SEARCH = '1'B;             /* EXIT FROM DO-WHILE    */
         OI    SEARCH,B'10000000'                                  0199
*              ELSE                         /* OTHERWISE             */
*                DO;                        /* PROCESS NEXT DSN      */
         B     @RC00198                                            0200
@RF00198 DS    0H                                                  0201
*                  DPTR2 = DPTR2+2+DALEN;   /* UPDATE DSN PTR,       */
         LA    @15,2                                               0201
         LR    @14,DPTR2                                           0201
         ALR   @14,@15                                             0201
         L     @01,TUDSN(,GTPLOUT1)                                0201
         AH    @14,DALEN(,@01)                                     0201
         LR    DPTR2,@14                                           0201
*                  DALEN = DATALEN;         /* MOVE DS LEN & PARM    */
         LH    @00,DATALEN(,DPTR2)                                 0202
         STH   @00,DALEN(,@01)                                     0202
*                  DAPARM(1:DALEN)=DATAVAL(1:DALEN);               0203
         BCTR  @00,0                                               0203
         LR    @14,@00                                             0203
         EX    @14,@SM00888                                        0203
*                  IF TUMBR ^= 0 THEN       /* IF MEMBER UNIT BUILT  */
         SLR   @14,@14                                             0204
         L     @01,TUMBR(,GTPLOUT1)                                0204
         CR    @01,@14                                             0204
         BE    @RF00204                                            0204
*                   DO;                     /* THEN                  */
*                  MPTR2 = MPTR2+2+SAVMBLEN;/* PTR TO MBR LEN & PARM */
         ALR   @15,MPTR2                                           0206
         ALR   @15,SAVMBLEN                                        0206
         LR    MPTR2,@15                                           0206
*                  SAVMBLEN = MEMLEN;       /* SAVE MEMBER LENGTH    */
         LH    @15,MEMLEN(,MPTR2)                                  0207
         LR    SAVMBLEN,@15                                        0207
*                  IF MEMLEN = 0 THEN       /* IF MBR NOT ENTERED,   */
         CR    @15,@14                                             0208
         BNE   @RF00208                                            0208
*                    DO;                    /* THEN                  */
*                    MBKEY = 0;             /* SET KEY TO 0          */
         STH   @14,MBKEY(,@01)                                     0210
*                    MBNUM = 0;             /* SET NUMBER TO 0       */
         STH   @14,MBNUM(,@01)                                     0211
*                    END;                                          0212
*                  ELSE                                            0213
*                    DO;                    /* OTHERWISE             */
         B     @RC00208                                            0213
@RF00208 DS    0H                                                  0214
*                      MBKEY = DALMEMBR;    /* SET MEMBER KEY        */
         L     @15,TUMBR(,GTPLOUT1)                                0214
         MVC   MBKEY(2,@15),@CH00618                               0214
*                      MBNUM = 1;           /* SET MBR NUMBER        */
         MVC   MBNUM(2,@15),@CH00033                               0215
*                      MBLEN = MEMLEN;      /* MOVE MBR LEN & PARM   */
         LH    @14,MEMLEN(,MPTR2)                                  0216
         STH   @14,MBLEN(,@15)                                     0216
*                      MBPARM(1:MBLEN)=MBRVAL(1:MBLEN);            0217
         BCTR  @14,0                                               0217
         EX    @14,@SM00890                                        0217
*                    END;                                          0218
*                   END;                                           0219
@RC00208 DS    0H                                                  0220
*                  IF TUPSWD ^= 0 THEN      /* IF PSWORD UNIT BUILT  */
@RF00204 SLR   @15,@15                                             0220
         L     @14,TUPSWD(,GTPLOUT1)                               0220
         CR    @14,@15                                             0220
         BE    @RF00220                                            0220
*                   DO;                     /* THEN                  */
*                  PPTR2 = PPTR2+2+SAVPWLEN;/* PTR TO PSW LEN & PARM */
         LA    @01,2                                               0222
         ALR   @01,PPTR2                                           0222
         AH    @01,SAVPWLEN                                        0222
         LR    PPTR2,@01                                           0222
*                  SAVPWLEN = PSWLEN;       /* SAVE PASSWORD LENGTH  */
         LH    @01,PSWLEN(,PPTR2)                                  0223
         STH   @01,SAVPWLEN                                        0223
*                  IF PSWLEN = 0 THEN       /* IF PSW NOT ENTERED,   */
         CR    @01,@15                                             0224
         BNE   @RF00224                                            0224
*                    DO;                    /* THEN                  */
*                    PWKEY = 0;             /* SET KEY TO 0          */
         STH   @15,PWKEY(,@14)                                     0226
*                    PWNUM = 0;             /* SET NUMBER TO 0       */
         STH   @15,PWNUM(,@14)                                     0227
*                    END;                                          0228
*                  ELSE                                            0229
*                    DO;                    /* OTHERWISE             */
         B     @RC00224                                            0229
@RF00224 DS    0H                                                  0230
*                      PWKEY = DALPASSW;    /* SET PASSWORD KEY      */
         L     @15,TUPSWD(,GTPLOUT1)                               0230
         MVC   PWKEY(2,@15),@CH00772                               0230
*                      PWNUM = 1;           /* SET PASSWORD NUMBER   */
         MVC   PWNUM(2,@15),@CH00033                               0231
*                      PWLEN = PSWLEN;      /* MOVE PSW LEN & PARM   */
         LH    @14,PSWLEN(,PPTR2)                                  0232
         STH   @14,PWLEN(,@15)                                     0232
*                      PWPARM(1:PWLEN)=PSWVAL(1:PWLEN);            0233
         BCTR  @14,0                                               0233
         EX    @14,@SM00892                                        0233
*                    END;                                          0234
*                   END;                                           0235
*                END;                                              0236
*            END;                                                  0237
*          ELSE                             /* IF ERROR IN PROCESSING*/
*            SEARCH = '1'B;                 /* EXIT DO-WHILE         */
         B     @RC00195                                            0238
@RF00195 OI    SEARCH,B'10000000'                                  0238
*        END;                               /* END DO-WHILE          */
@RC00195 DS    0H                                                  0239
@DE00190 TM    SEARCH,B'10000000'                                  0239
         BZ    @DL00190                                            0239
*        SEARCH = '0'B;                     /* RE-SET SWITCH         */
         NI    SEARCH,B'01111111'                                  0240
*        S99NOCNV = '0'B;                   /* TURN OFF NO CONVERT   */
         L     @10,PTRS99RB(,AWAPTR)                               0241
         NI    S99NOCNV(@10),B'10111111'                           0241
*   END CONCTDSN;                                                  0242
@EL00003 DS    0H                                                  0242
@EF00003 DS    0H                                                  0242
@ER00003 LM    @14,@07,@SA00003                                    0242
         LM    @09,@12,@SA00003+40                                 0242
         BR    @14                                                 0242
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      CONCTERR                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE FREES ANY DATA SETS THAT HAVE BEEN ALLOCATED   */
*/*      PRIOR TO FINDING AN ERROR IN THE CONCATENATION REQUEST.     */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      EACH DDNAME IS FREED. IF AN ERROR OCCURS WHILE FREEING ANY  */
*/*      OF THE DATA SETS, ISSUE AN ERROR MESSAGE AND CONTINUE.      */
*/*      WHEN ALL THE DATA SETS HAVE BEEN FREED, ISSUE THE           */
*/*      APPROPRIATE ERROR MSG.                                      */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      LIST OF DDNAMES                                             */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      LIST OF DDNAMES FREED                                       */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    CONCTERR: PROC;                                               0243
CONCTERR STM   @14,@04,@SA00004                                    0243
         STM   @06,@12,@SA00004+28                                 0243
*        DDLST = ADDR(DDNMLEN);        /* PTR TO DD LEN & PARM       */
         LA    DDLST,DDNMLEN(,DDNAPTR)                             0244
*        IF ALLOCERR = '1'B THEN       /* IF ALLOCATION ERROR        */
         TM    ALLOCERR,B'01000000'                                0245
         BNO   @RF00245                                            0245
*          DSFREED = DSNCTR - LISTNMBR;/* GET NUMBER TO FREE         */
         LH    DSFREED,DSNCTR(,AWAPTR)                             0246
         SLR   DSFREED,LISTNMBR                                    0246
*        ELSE                          /* IF OTHER ERROR,            */
*          DSFREED = DSNCTR - LISTNMBR +1;   /* ADD 1 MORE           */
         B     @RC00245                                            0247
@RF00245 LH    DSFREED,DSNCTR(,AWAPTR)                             0247
         SLR   DSFREED,LISTNMBR                                    0247
         AL    DSFREED,@CF00033                                    0247
*        PERMCTKY = DUNUNALC;          /* SET UNALLOC OPTION KEY     */
@RC00245 MVC   PERMCTKY(2,DDNAPTR),@CH00626                        0248
*        DDNMPTR = ADDR(DDFREEBF);     /* PTR TO TEXT TO BE BUILT    */
         LA    @10,DDFREEBF                                        0249
         ST    @10,DDNMPTR(,DDNAPTR)                               0249
*        DDFKEY = DUNDDNAM;            /* SET KEY IN TEXT UNIT       */
         MVC   DDFKEY(2),@CH00614                                  0250
*        DDFNUM = 1;                   /* SET NUMBER TO 1            */
         MVC   DDFNUM(2),@CH00033                                  0251
*        DDFLEN = DDNMLNGH;            /* MOVE DDNAME LENGTH         */
         LH    @10,DDNMLNGH(,DDLST)                                0252
         STH   @10,DDFLEN                                          0252
*        DDFVAL(1:DDFLEN)=DDNMPARM(1:DDFLEN);  /* MOVE DDNAME        */
         BCTR  @10,0                                               0253
         EX    @10,@SM00896                                        0253
*        S99VERB = S99VRBUN;           /* SET UNALLOC VERB CODE      */
         L     @10,PTRS99RB(,AWAPTR)                               0254
         MVI   S99VERB(@10),X'02'                                  0254
*        S99TXTPP = DDNAPTR;           /* PTR TO DDNAMES             */
         ST    DDNAPTR,S99TXTPP(,@10)                              0255
*        S99NOCNV = '0'B;              /* TURN OFF FLAGS             */
         NI    S99NOCNV(@10),B'10111111'                           0256
*        DDNMEND = '1'B;               /* END ADDRESS LIST           */
         OI    DDNMEND(DDNAPTR),B'10000000'                        0257
*        DO WHILE (SEARCH='0'B);       /* UNALLOCATE DDNAMES         */
         B     @DE00258                                            0258
@DL00258 DS    0H                                                  0259
*          CALL DYNSVC;                /* INVOKE DYN ALLOCATION      */
         BAL   @14,DYNSVC                                          0259
*          IF RCODESV > 0 THEN         /* IF UNALLOCATION FAILED,    */
         L     @10,RCODESV(,AWAPTR)                                0260
         LTR   @10,@10                                             0260
         BNP   @RF00260                                            0260
*            DO;                                                   0261
*              ENTRYCD = 1;            /* SET ENTRY CODE             */
         MVC   ENTRYCD(2,AWAPTR),@CH00033                          0262
*              R1 = AWAPTR;            /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0263
*              CALL IKJEFD35;          /* ISSUE ERROR MESSAGE        */
         L     @15,@CV00340                                        0264
         BALR  @14,@15                                             0264
*            END;                                                  0265
*          DSFREED = DSFREED-1;        /* DECREMENT CTR BY 1         */
@RF00260 BCTR  DSFREED,0                                           0266
*          IF DSFREED = 0 THEN         /* IF CTR IS 0 (END OF LIST)  */
         LTR   DSFREED,DSFREED                                     0267
         BNZ   @RF00267                                            0267
*            SEARCH = '1'B;            /* EXIT FROM DO-WHILE         */
         OI    SEARCH,B'10000000'                                  0268
*          ELSE                                                    0269
*            DO;                       /* OTHERWISE, UPDATE PTR TO   */
         B     @RC00267                                            0269
@RF00267 DS    0H                                                  0270
*              DDLST = DDLST + 2 + DDNMLNGH; /* DD LEN AND PARM      */
         LA    @10,2                                               0270
         ALR   @10,DDLST                                           0270
         AH    @10,DDNMLNGH(,DDLST)                                0270
         LR    DDLST,@10                                           0270
*              DDFLEN = DDNMLNGH;     /* MOVE LEN AND PARM          */
         LH    @10,DDNMLNGH(,DDLST)                                0271
         STH   @10,DDFLEN                                          0271
*              DDFVAL(1:DDFLEN)=DDNMPARM(1:DDFLEN);                0272
         BCTR  @10,0                                               0272
         EX    @10,@SM00896                                        0272
*            END;                                                  0273
*        END;                          /* END DO-WHILE               */
@RC00267 DS    0H                                                  0274
@DE00258 TM    SEARCH,B'10000000'                                  0274
         BZ    @DL00258                                            0274
*        SEARCH = '0'B;                /* RESET SWITCH               */
         NI    SEARCH,B'01111111'                                  0275
*        CALL CCERRMSG;                /* ISSUE APPROPRIATE MSG      */
         BAL   @14,CCERRMSG                                        0276
*   END CONCTERR;                                                  0277
@EL00004 DS    0H                                                  0277
@EF00004 DS    0H                                                  0277
@ER00004 LM    @14,@04,@SA00004                                    0277
         LM    @06,@12,@SA00004+28                                 0277
         BR    @14                                                 0277
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      FIRSTCC                                                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      IF DYNAMIC ALLOCATION FAILED DUE TO FILE IN USE, PROMPT     */
*/*      THE USER FOR THE OPTION. IF USER REQUESTS TO TERMINATE,     */
*/*      ISSUE MESSAGE AND TERMINATE. IF MORE THAN 16 PARTITIONED    */
*/*      DATA SETS SPECIFIED, ISSUE ERROR MESSAGE AND TERMINATE.     */
*/*      ELSE, SAVE THE DSORG (FOR LATER COMPARISONS) AND THE        */
*/*      DDNAME.                                                     */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      WORKAREA                                                    */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      RBCODE12 = 0 - CONTINUE WITH NEXT DSNAME                    */
*/*                 1 - ERROR FOUND, TERMINATE                       */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    FIRSTCC: PROC;                                                0278
FIRSTCC  STM   @14,@04,@SA00005                                    0278
         STM   @06,@12,@SA00005+28                                 0278
*        IF RCODESV > 0 & S99ERROR = '0410'X  THEN  /* IF ALLOCATION
*                                                    FAILED  @YM06354*/
         L     @10,RCODESV(,AWAPTR)                                0279
         LTR   @10,@10                                             0279
         BNP   @RF00279                                            0279
         L     @09,PTRS99RB(,AWAPTR)                               0279
         CLC   S99ERROR(2,@09),@CB00860                            0279
         BNE   @RF00279                                            0279
*          DO;                         /* & FILE IN USE THEN @YM06354*/
*            SAVERC = RCODESV;         /* SAVE DYN RC        @Z30LPKH*/
         LR    SAVERC,@10                                          0281
*            R1 = AWAPTR;              /* WORKAREA PTR IN REG 1      */
         LR    R1,AWAPTR                                           0282
*            CALL IKJEFD36;            /* PROMPT FOR FILE OPTION     */
         L     @15,@CV00341                                        0283
         BALR  @14,@15                                             0283
*            RCODESV = SAVERC;         /* RESTORE DYN RC     @Z30LPKH*/
         ST    SAVERC,RCODESV(,AWAPTR)                             0284
*            IF TERMOPT = '1'B THEN    /* IF OPTION TO TERMINATE     */
         TM    TERMOPT(AWAPTR),B'00001000'                         0285
         BNO   @RF00285                                            0285
*            DO;                       /* THEN                       */
*            TERMOPT = '0'B;           /* TURN OFF INDICATOR         */
         NI    TERMOPT(AWAPTR),B'11110111'                         0287
*            ALLOCERR = '1'B;          /* INDICATE ERROR TYPE        */
         OI    ALLOCERR,B'01000000'                                0288
*            CALL CCERRMSG;            /* ISSUE ERROR MESSAGE        */
         BAL   @14,CCERRMSG                                        0289
*            END;                                                  0290
*            ELSE                                 /*         @YM06354*/
*              FREEFL = '1'B;                     /*         @YM06354*/
         B     @RC00285                                            0291
@RF00285 OI    FREEFL,B'00001000'                                  0291
*          END;                                   /*         @YM06354*/
*        ELSE                          /*                    @OZ02964*/
*            IF RCODESV > 0 & S99ERROR ^= '0410'X THEN  /*   @YM06354*/
         B     @RC00279                                            0293
@RF00279 L     @10,RCODESV(,AWAPTR)                                0293
         LTR   @10,@10                                             0293
         BNP   @RF00293                                            0293
         L     @10,PTRS99RB(,AWAPTR)                               0293
         CLC   S99ERROR(2,@10),@CB00860                            0293
         BE    @RF00293                                            0293
*              DO;                                                 0294
*                ALLOCERR = '1'B;      /* INDICATE ERROR TYPE        */
         OI    ALLOCERR,B'01000000'                                0295
*                ENTRYCD = 1;          /* SET ENTRY CODE             */
         MVC   ENTRYCD(2,AWAPTR),@CH00033                          0296
*                R1 = AWAPTR;          /* WORKAREA IN REG 1          */
         LR    R1,AWAPTR                                           0297
*                CALL IKJEFD35;        /* ISSUE DYNALLOC ERROR MSG   */
         L     @15,@CV00340                                        0298
         BALR  @14,@15                                             0298
*                CALL CCERRMSG;        /* ISSUE ERROR MESSAGE        */
         BAL   @14,CCERRMSG                                        0299
*              END;                                                0300
*        IF FREEFL = '1'B | RCODESV = 0 THEN /* IF ALLOCATION      0301
*                                                 SUCCESSFUL @YM06354*/
@RF00293 DS    0H                                                  0301
@RC00279 TM    FREEFL,B'00001000'                                  0301
         BO    @RT00301                                            0301
         L     @10,RCODESV(,AWAPTR)                                0301
         LTR   @10,@10                                             0301
         BNZ   @RF00301                                            0301
@RT00301 DS    0H                                                  0302
*          DO;                         /* THEN                       */
*            FILEKY = 0;               /* SET FILE KEY TO 0          */
         SLR   @10,@10                                             0303
         L     @09,TUFILE(,GTPLOUT1)                               0303
         STH   @10,FILEKY(,@09)                                    0303
*            FILENUM = 0;                                          0304
         STH   @10,FILENUM(,@09)                                   0304
*            DDNMLNGH = RTDDNLEN;      /* SAVE DDNAME RETURNED       */
         L     @10,TURTDDN(,GTPLOUT1)                              0305
         LH    @09,RTDDNLEN(,@10)                                  0305
         STH   @09,DDNMLNGH(,DDLST)                                0305
*            DDNMPARM(1:RTDDNLEN) = RTDDNAME(1:RTDDNLEN);          0306
         LR    @07,@09                                             0306
         BCTR  @07,0                                               0306
         EX    @07,@SM00900                                        0306
*            DDLST = DDLST + 2 + RTDDNLEN;                         0307
         LA    @07,2                                               0307
         ALR   @07,DDLST                                           0307
         ALR   @07,@09                                             0307
         LR    DDLST,@07                                           0307
*            RTDDNLEN = 8;             /* SET DDNAME LENGTH TO 8     */
         MVC   RTDDNLEN(2,@10),@CH00096                            0308
*                                      /* IF DSORG PARTITIONED AND 0309
*                                         OVER 16 DSNAMES GIVEN,     */
*            IF DSNCTR > 16 & PARTND = '1'B THEN                   0309
         LH    @10,DSNCTR(,AWAPTR)                                 0309
         C     @10,@CF00613                                        0309
         BNH   @RF00309                                            0309
         L     @10,TURTDSO(,GTPLOUT1)                              0309
         TM    PARTND(@10),B'00000010'                             0309
         BNO   @RF00309                                            0309
*              DO;                     /* THEN                       */
*                MAXERR = '1'B;        /* INDICATE ERROR TYPE        */
         OI    MAXERR,B'00100000'                                  0311
*                CALL CONCTERR;        /* ISSUE ERROR MESSAGE        */
         BAL   @14,CONCTERR                                        0312
*              END;                                                0313
*            ELSE                                                  0314
*              DO;                                                 0314
         B     @RC00309                                            0314
@RF00309 DS    0H                                                  0315
*                IF SEQUEN = '1'B THEN /* IF SEQUENTIAL DSORG        */
         L     @10,TURTDSO(,GTPLOUT1)                              0315
         TM    SEQUEN(@10),B'01000000'                             0315
         BNO   @RF00315                                            0315
*                  DSORGSQ = '1'B;     /* INDICATE SO                */
         OI    DSORGSQ,B'01000000'                                 0316
*                ELSE                                              0317
*                  IF PARTND = '1'B THEN   /* IF PARTITIONED DSORG   */
         B     @RC00315                                            0317
@RF00315 L     @10,TURTDSO(,GTPLOUT1)                              0317
         TM    PARTND(@10),B'00000010'                             0317
         BNO   @RF00317                                            0317
*                    IF MBNUM = 1 THEN     /* WITH MEMB SPEC @ZA04568*/
         L     @10,TUMBR(,GTPLOUT1)                                0318
         CLC   MBNUM(2,@10),@CH00033                               0318
         BNE   @RF00318                                            0318
*                      DSORGSQ = '1'B;     /* INDICATE SEQ   @ZA04568*/
         OI    DSORGSQ,B'01000000'                                 0319
*                    ELSE                  /* DSORG. MEM NOT @ZA04568*/
*                      DSORGPR = '1'B;     /* SPEC DSORD IS  @ZA04568*/
         B     @RC00318                                            0320
@RF00318 OI    DSORGPR,B'00100000'                                 0320
*                                          /* PARTITIONED    @ZA04568*/
*                  ELSE                                            0321
*                    IF VSAM = '1'B THEN   /* IF VSAM DATA SET       */
         B     @RC00317                                            0321
@RF00317 L     @10,TURTDSO(,GTPLOUT1)                              0321
         TM    VSAM(@10),B'00010000'                               0321
         BNO   @RF00321                                            0321
*                      DSORGVM = '1'B;     /* INDICATE SO            */
         OI    DSORGVM,B'00010000'                                 0322
*                    ELSE                                          0323
*                      DO;                 /* IF NEITHER OF ABOVE    */
         B     @RC00321                                            0323
@RF00321 DS    0H                                                  0324
*                        INVORG = '1'B;    /* INDICATE ERROR TYPE    */
         OI    INVORG,B'00001000'                                  0324
*                        CALL CONCTERR;    /* ISSUE ERROR MESSAGE    */
         BAL   @14,CONCTERR                                        0325
*                      END;                                        0326
*              END;                                                0327
*          END;                                                    0328
*    END FIRSTCC;                                                  0329
@EL00005 DS    0H                                                  0329
@EF00005 DS    0H                                                  0329
@ER00005 LM    @14,@04,@SA00005                                    0329
         LM    @06,@12,@SA00005+28                                 0329
         BR    @14                                                 0329
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      OTHERCC                                                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE PROCESSES DATA SETS IN THE LIST OTHER THAN     */
*/*      THE FIRST DATA SET.                                         */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      IF DYNAMIC ALLOCATION FAILED, ISSUE ERROR MESSAGE AND       */
*/*      TERMINATE. IF THE DATA SET ORGANIZATION IS NOT THE SAME     */
*/*      AS THAT OF THE FIRST DATA SET, ISSUE AN ERROR MESSAGE AND   */
*/*      TERMINATE. SAVE THE DDNAME RETURNED BY DYNAMIC ALLOCATION   */
*/*      FOR THIS DATA SET.                                          */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      DATA SET ORGANIZATION                                       */
*/*      DDNAME                                                      */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      RBCODE12 = 0 - CONTINUE WITH NEXT DSNAME                    */
*/*                 1 - ERROR FOUND, TERMINATE                       */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    OTHERCC: PROC;                                                0330
OTHERCC  STM   @14,@04,@SA00006                                    0330
         STM   @06,@12,@SA00006+28                                 0330
*        IF RCODESV > 0 THEN           /* IF ALLOCATION FAILED,      */
         L     @10,RCODESV(,AWAPTR)                                0331
         LTR   @10,@10                                             0331
         BNP   @RF00331                                            0331
*          DO;                         /* THEN                       */
*            ALLOCERR = '1'B;          /* INDICATE ERROR TYPE        */
         OI    ALLOCERR,B'01000000'                                0333
*            ENTRYCD = 1;              /* SET ENTRY CODE             */
         MVC   ENTRYCD(2,AWAPTR),@CH00033                          0334
*            R1 = AWAPTR;              /* WORKAREA IN REG 1          */
         LR    R1,AWAPTR                                           0335
*            CALL IKJEFD35;            /* ISSUE DYNALLOC ERROR MSG   */
         L     @15,@CV00340                                        0336
         BALR  @14,@15                                             0336
*            CALL CONCTERR;            /* ISSUE ERROR MESSAGE        */
         BAL   @14,CONCTERR                                        0337
*          END;                                                    0338
*        ELSE                          /* ELSE,                      */
*          DO;                                                     0339
         B     @RC00331                                            0339
@RF00331 DS    0H                                                  0340
*            DDNMLNGH = RTDDNLEN;      /* SAVE DDNAME RETURNED       */
         L     @10,TURTDDN(,GTPLOUT1)                              0340
         LH    @09,RTDDNLEN(,@10)                                  0340
         STH   @09,DDNMLNGH(,DDLST)                                0340
*            DDNMPARM(1:RTDDNLEN) = RTDDNAME(1:RTDDNLEN);          0341
         LR    @07,@09                                             0341
         BCTR  @07,0                                               0341
         EX    @07,@SM00900                                        0341
*            DDLST = DDLST +2 + RTDDNLEN;                          0342
         LA    @10,2                                               0342
         ALR   @10,DDLST                                           0342
         ALR   @10,@09                                             0342
         LR    DDLST,@10                                           0342
*                                      /* CHECK DSORG TO BE SAME     */
*            IF (DSORGSQ='1'B & (SEQUEN='0'B & MBNUM=0))|  /*@ZA04568*/
*               (DSORGPR='1'B & PARTND='0'B) |                     0343
*               (DSORGPR='1'B & (PARTND='1'B & MBNUM=1))|  /*@ZA04568*/
*                (DSORGVM='1'B & VSAM='0'B) THEN                   0343
         TM    DSORGSQ,B'01000000'                                 0343
         BNO   @GL00007                                            0343
         L     @10,TURTDSO(,GTPLOUT1)                              0343
         TM    SEQUEN(@10),B'01000000'                             0343
         BNZ   @GL00007                                            0343
         L     @10,TUMBR(,GTPLOUT1)                                0343
         LH    @10,MBNUM(,@10)                                     0343
         LTR   @10,@10                                             0343
         BZ    @RT00343                                            0343
@GL00007 TM    DSORGPR,B'00100000'                                 0343
         BNO   @GL00006                                            0343
         L     @10,TURTDSO(,GTPLOUT1)                              0343
         TM    PARTND(@10),B'00000010'                             0343
         BZ    @RT00343                                            0343
@GL00006 TM    DSORGPR,B'00100000'                                 0343
         BNO   @GL00005                                            0343
         L     @10,TURTDSO(,GTPLOUT1)                              0343
         TM    PARTND(@10),B'00000010'                             0343
         BNO   @GL00005                                            0343
         L     @10,TUMBR(,GTPLOUT1)                                0343
         CLC   MBNUM(2,@10),@CH00033                               0343
         BE    @RT00343                                            0343
@GL00005 TM    DSORGVM,B'00010000'                                 0343
         BNO   @RF00343                                            0343
         L     @10,TURTDSO(,GTPLOUT1)                              0343
         TM    VSAM(@10),B'00010000'                               0343
         BNZ   @RF00343                                            0343
@RT00343 DS    0H                                                  0344
*              DO;                     /* NO -                       */
*                DSORGERR = '1'B;      /* INDICATE ERROR TYPE        */
         OI    DSORGERR,B'00010000'                                0345
*                CALL CONCTERR;        /* ISSUE ERROR MESSAGE        */
         BAL   @14,CONCTERR                                        0346
*              END;                                                0347
*          END;                                                    0348
*    END OTHERCC;                                                  0349
@EL00006 DS    0H                                                  0349
@EF00006 DS    0H                                                  0349
@ER00006 LM    @14,@04,@SA00006                                    0349
         LM    @06,@12,@SA00006+28                                 0349
         BR    @14                                                 0349
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      CCERRMSG                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE ISSUES A MESSAGE WHEN AN ERROR HAS BEEN FOUND  */
*/*      IN THE CONCATENATION REQUEST.                               */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      THE FIRST LEVEL MESSAGE NOTIFIES THE USER THAT THE DATA SETS*/
*/*      WERE NOT CONCATENATED. THE SECOND LEVEL MESSAGE GIVES ONE   */
*/*      OF THE FOLLOWING REASONS-                                   */
*/*      NUMBER OF DATA SETS IN THE LIST EXCEEDS THE MAXIMUM, DSORG  */
*/*      IS NOT THE SAME FOR ALL DATA SETS IN THE LIST, STATUS IS    */
*/*      NEW,MOD, OR SYSOUT, OR ALLOCATION ERROR OCCURRED.           */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      ERROR TYPE INDICATOR                                        */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      MESSAGE ISSUED                                              */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE      */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    CCERRMSG: PROC;                                               0350
CCERRMSG STM   @14,@12,@SA00007                                    0350
*        MSGTABLE = MSGTABLE && MSGTABLE;/* CLEAR INTERFACE AREA     */
         L     @10,MSGPTR(,AWAPTR)                                 0351
         XC    MSGTABLE(64,@10),MSGTABLE(@10)                      0351
*        RBCODE12 = '1'B;                /* INDICATE ALLOC FAILED    */
         OI    RBCODE12(AWAPTR),B'10000000'                        0352
*        IF MAXERR = '1'B THEN           /* IF MAXIMUM ERROR,        */
         TM    MAXERR,B'00100000'                                  0353
         BNO   @RF00353                                            0353
*          MSGID = '107A';               /* SET MESSAGE ID           */
         MVC   MSGID(4,@10),@CC00867                               0354
*        IF DSORGERR = '1'B THEN         /* IF DSORG ERROR,          */
@RF00353 TM    DSORGERR,B'00010000'                                0355
         BNO   @RF00355                                            0355
*          MSGID = '106A';               /* SET MESSAGE ID           */
         L     @10,MSGPTR(,AWAPTR)                                 0356
         MVC   MSGID(4,@10),@CC00868                               0356
*        IF INVORG = '1'B THEN           /* IF INVALID DSORG,        */
@RF00355 TM    INVORG,B'00001000'                                  0357
         BNO   @RF00357                                            0357
*          MSGID = '110A';               /* SET MESSAGE ID           */
         L     @10,MSGPTR(,AWAPTR)                                 0358
         MVC   MSGID(4,@10),@CC00869                               0358
*        IF STATSERR = '1'B THEN         /* IF STATUS ERROR,         */
@RF00357 TM    STATSERR,B'10000000'                                0359
         BNO   @RF00359                                            0359
*          DO;                           /* THEN                     */
*            MSGID = '108A';             /* SET MESSAGE ID           */
         L     @10,MSGPTR(,AWAPTR)                                 0361
         MVC   MSGID(4,@10),@CC00870                               0361
*            IF STATSPDE = 3 THEN        /* IF STATUS MOD,           */
         L     @05,PTRPDL(,AWAPTR)                                 0362
         CLC   STATSPDE(2,@05),@CH00320                            0362
         BNE   @RF00362                                            0362
*              DO;                       /* THEN                     */
*                VAR1 = ADDR(MOD);       /* PUT MOD VARIABLE         */
         LA    @05,MOD                                             0364
         ST    @05,@TF00001                                        0364
         MVC   VAR1(3,@10),@TF00001+1                              0364
*                L1 = LENGTH(MOD);       /* AND LENGTH IN LIST       */
         MVI   L1(@10),X'03'                                       0365
*              END;                                                0366
*            IF STATSPDE = 4 THEN        /* IF STATUS NEW            */
@RF00362 L     @10,PTRPDL(,AWAPTR)                                 0367
         CLC   STATSPDE(2,@10),@CH00318                            0367
         BNE   @RF00367                                            0367
*              DO;                       /* THEN,                    */
*                VAR1 = ADDR(NEW);       /* PUT NEW VARIABLE         */
         L     @10,MSGPTR(,AWAPTR)                                 0369
         LA    @05,NEW                                             0369
         ST    @05,@TF00001                                        0369
         MVC   VAR1(3,@10),@TF00001+1                              0369
*                L1 = LENGTH(NEW);       /* AND LENGTH IN LIST       */
         MVI   L1(@10),X'03'                                       0370
*              END;                                                0371
*            IF STATSPDE = 5 THEN        /* IF STATUS SYSOUT         */
@RF00367 L     @10,PTRPDL(,AWAPTR)                                 0372
         CLC   STATSPDE(2,@10),@CH00047                            0372
         BNE   @RF00372                                            0372
*              DO;                       /* THEN                     */
*                VAR1 = ADDR(SYSOUT);    /* PUT SYSOUT VARIABLE      */
         L     @10,MSGPTR(,AWAPTR)                                 0374
         LA    @05,SYSOUT                                          0374
         ST    @05,@TF00001                                        0374
         MVC   VAR1(3,@10),@TF00001+1                              0374
*                L1 = LENGTH(SYSOUT);    /* AND LENGTH IN LIST       */
         MVI   L1(@10),X'06'                                       0375
*              END;                                                0376
*          END;                                                    0377
@RF00372 DS    0H                                                  0378
*        IF ALLOCERR = '1'B THEN         /* IF ALLOCATION ERROR,     */
@RF00359 TM    ALLOCERR,B'01000000'                                0378
         BNO   @RF00378                                            0378
*          DO;                                                     0379
*            MSGID = '109A';             /* SET MESSAGE ID           */
         L     @10,MSGPTR(,AWAPTR)                                 0380
         MVC   MSGID(4,@10),@CC00872                               0380
*            VAR1 = ADDR(DAPARM);        /* PUT DSNAME VARIABLE      */
         L     @05,TUDSN(,GTPLOUT1)                                0381
         LA    @02,DAPARM(,@05)                                    0381
         ST    @02,@TF00001                                        0381
         MVC   VAR1(3,@10),@TF00001+1                              0381
*            L1 = DALEN;                 /* AND LENGTH IN LIST       */
         LH    @05,DALEN(,@05)                                     0382
         STC   @05,L1(,@10)                                        0382
*          END;                                                    0383
*        LISTPTR = ADDR(MSGCSECT);       /* ADDR OF PARM LIST        */
@RF00378 L     @10,MSGPTR(,AWAPTR)                                 0384
         LA    @05,MSGCSECT(,@10)                                  0384
         ST    @05,LISTPTR(,@10)                                   0384
*        MTCPPL = CPPLPTR;               /* PTR TO CPPL              */
         L     @05,CPPLPTR(,AWAPTR)                                0385
         ST    @05,MTCPPL(,@10)                                    0385
*        ECBPTR = ADDR(COMMECB);         /* PTR TO ECB               */
         LA    @05,COMMECB(,AWAPTR)                                0386
         ST    @05,ECBPTR(,@10)                                    0386
*        COMMECB = 0;                    /* INIT ECB TO 0            */
         SLR   @05,@05                                             0387
         ST    @05,COMMECB(,AWAPTR)                                0387
*        MTHIGH = '1'B;                  /* SET HIGH ORDER BIT ON    */
         OI    MTHIGH(@10),B'10000000'                             0388
*        MTPUTLSW = '1'B;                /* INDICATE PUTLINE         */
         OI    MTPUTLSW(@10),B'01000000'                           0389
*        MSGCSECT = PTRMSGS;             /* MSG CSECT ADDRESS        */
         L     @05,PTRMSGS(,AWAPTR)                                0390
         ST    @05,MSGCSECT(,@10)                                  0390
*        R1 = ADDR(MSGTABLE);            /* PARM LIST IN REG 1       */
         LR    R1,@10                                              0391
*        GEN (LINK EP=IKJEFF02);         /* INVOKE MESSAGE PROCESSOR */
*                                                                  0392
         LINK EP=IKJEFF02
*    END CCERRMSG;                                                 0393
@EL00007 DS    0H                                                  0393
@EF00007 DS    0H                                                  0393
@ER00007 LM    @14,@12,@SA00007                                    0393
         BR    @14                                                 0393
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      PRMPTDDN                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE PROMPTS THE USER TO ENTER A FILENAME WHEN      */
*/*      THE PARAMETER HAS BEEN OMITTED AND IS REQUIRED.             */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*       INVOKE PARSE WITH A SECONDARY PCL AND PDL ADDRESS.  IF     */
*/*       PARSE FAILS, ISSUE ERROR MESSAGE. ELSE, OVERLAY THE        */
*/*       ORIGINAL PDE WITH THE PDE RETURNED FROM THE PROMPT.        */
*/*                                                                  */
*/* INPUT -                                                          */
*/*       PTR TO FILE PDE                                            */
*/*       PTR TO SECONDARY PCL                                       */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*       FILE PDE OVERLAID WITH NEW DATA                            */
*/*                                                                  */
*/* NOTE:  THIS ROUTINE REPRESENTS A DIRECT LINE FUNCTION AND CAN    */
*/*        CAN BE INCORPORATED AS AN INCLUDED CODE SEGMENT WHEN THE  */
*/*        INCLUDE FUNCTION HAS RECEIVED A STANDARD DEFINITION.      */
*/********************************************************************/
*    PRMPTDDN: PROC;                                               0394
PRMPTDDN STM   @14,@12,@SA00008                                    0394
*        ENTRYCD = 4;                      /* INDICATE DDN PROMPT    */
         MVC   ENTRYCD(2,AWAPTR),@CH00318                          0395
*        R1 = AWAPTR;                      /* WORKAREA PTR IN REG 1  */
         LR    R1,AWAPTR                                           0396
*        CALL IKJEFD37;                                            0397
         L     @15,@CV00342                                        0397
         BALR  @14,@15                                             0397
*        IF RCODESV > 0 THEN               /* IF RETURN CODE >0      */
         L     @10,RCODESV(,AWAPTR)                                0398
         LTR   @10,@10                                             0398
         BNP   @RF00398                                            0398
*          DO;                                                     0399
*            ENTRYCD = 2;                  /* SET ENTRY CODE         */
         MVC   ENTRYCD(2,AWAPTR),@CH00080                          0400
*            R1 = AWAPTR;                                          0401
         LR    R1,AWAPTR                                           0401
*            CALL IKJEFD35;                                        0402
         L     @15,@CV00340                                        0402
         BALR  @14,@15                                             0402
*          END;                                                    0403
*        ELSE                                                      0404
*          DO;                             /* ELSE,                  */
         B     @RC00398                                            0404
@RF00398 DS    0H                                                  0405
*            FILEPDE = 1;                  /* INDICATE FILE PRESENT  */
         L     @10,PTRPDL(,AWAPTR)                                 0405
         MVC   FILEPDE(2,@10),@CH00033                             0405
*            DDNPTR = ADDR(NDDNBUF1);      /* PTR TO NEW BUFFER      */
         LA    @02,NDDNBUF1                                        0406
         ST    @02,DDNPTR(,@10)                                    0406
*            DDNLEN = DDLNGH2;             /* NEW LENGTH             */
         L     @02,PMPTPDL(,AWAPTR)                                0407
         LH    @15,DDLNGH2(,@02)                                   0407
         STH   @15,DDNLEN(,@10)                                    0407
*            DDNFLAGS = DDFLAG2;           /* FLAGS AND PARM         */
         MVC   DDNFLAGS(1,@10),DDFLAG2(@02)                        0408
*            NDDNBUF1(1:DDNLEN) = DDNBUF1(1:DDNLEN);               0409
         BCTR  @15,0                                               0409
         L     @10,DDPTR2(,@02)                                    0409
         EX    @15,@SM00903                                        0409
*            RFY R5 RSTD;                  /* RESTRICT REG 5         */
*            R5 = ADDR(PMPTPDL);          /* PROMPT PDL IN REG 5    */
         LA    R5,PMPTPDL(,AWAPTR)                                 0411
*            GEN (IKJRLSA (5));            /* RELEASE PDL            */
         IKJRLSA (5)
*            RFY R5 UNRSTD;                /* UNRESTRICT REG 5       */
*          END;                                                    0414
*    END PRMPTDDN;                                                 0415
@EL00008 DS    0H                                                  0415
@EF00008 DS    0H                                                  0415
@ER00008 LM    @14,@12,@SA00008                                    0415
         BR    @14                                                 0415
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      TRANSRTN                                                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS MODULE INVOKES GENTRANS TO TRANSLATE PARAMETERS TO     */
*/*      DYNAMIC ALLOCATION TEXT FORMAT.                             */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      THE TEXT UNIT FOR PERMANENT ALLOCATION IS SET UP. GENTRANS  */
*/*      IS INVOKED. IF GENTRANS FAILS, AN INDICATOR IS SET TO       */
*/*      SHOW THE ERROR. ELSE, THE POINTER TO THE TEXT BUILT BY      */
*/*      GENTRANS IS PUT INTO THE DYNAMIC ALLOCATION REQUEST BLOCK.  */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      GENTRANS PARAMETER LIST                                     */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      RBOCDE12 = 0 - GENTRANS SUCCESSFUL                          */
*/*                 1 - GENTRANS ERROR                               */
*/*                                                                  */
*/********************************************************************/
*    TRANSRTN: PROC;                                               0416
TRANSRTN STM   @14,@03,@SA00009                                    0416
         STM   @05,@12,@SA00009+24                                 0416
*        ADLKEY = DALPERMA;            /* PERMANENT ALLOC KEY        */
         L     @10,TXT(,AWAPTR)                                    0417
         MVC   ADLKEY(2,@10),@CH00776                              0417
*        ADLNBR = 0;                   /* NUMBER 0                   */
         SLR   @09,@09                                             0418
         STH   @09,ADLNBR(,@10)                                    0418
*        ADDTEXT(INC) = TXT;           /* PTR TO TEXT UNIT           */
         LR    @09,INC                                             0419
         SLA   @09,2                                               0419
         L     @05,GTPLPTR(,AWAPTR)                                0419
         L     @02,GTPLABLK(,@05)                                  0419
         ST    @10,@TF00001                                        0419
         ALR   @09,@02                                             0419
         MVC   ADDTEXT-4(4,@09),@TF00001                           0419
*        ADDNUM = ADDNUM + 1;          /* INCREMENT NUMBER OF ENTRIES *
         LA    @10,1                                               0420
         AH    @10,ADDNUM(,@02)                                    0420
         STH   @10,ADDNUM(,@02)                                    0420
*        R1 = GTPLPTR;                 /* PARM LIST IN REG 1         */
         LR    R1,@05                                              0421
*        GEN (LINK EP=IKJCB831);       /* INVOKE GENTRANS            */
         LINK EP=IKJCB831
*        RCODESV = R15;                /* SAVE RETURN CODE           */
         ST    R15,RCODESV(,AWAPTR)                                0423
*        IF RCODESV > 0 THEN           /* IF GENTRANS FAILED,        */
         L     @10,RCODESV(,AWAPTR)                                0424
         LTR   @10,@10                                             0424
         BNP   @RF00424                                            0424
*          DO;                         /* THEN                       */
*            ENTRYCD = 3;              /* SET ENTRY CODE             */
         MVC   ENTRYCD(2,AWAPTR),@CH00320                          0426
*            R1 = AWAPTR;                                          0427
         LR    R1,AWAPTR                                           0427
*            CALL IKJEFD35;                                        0428
         L     @15,@CV00340                                        0428
         BALR  @14,@15                                             0428
*          END;                                                    0429
*        ELSE                          /* OTHERWISE,                 */
*          DO;                                                     0430
         B     @RC00424                                            0430
@RF00424 DS    0H                                                  0431
*            S99TXTPP = GTPLOUTA + 8;  /* TEXT PTR IN REQUEST BLOCK  */
         L     @10,PTRS99RB(,AWAPTR)                               0431
         L     @05,GTPLPTR(,AWAPTR)                                0431
         L     @05,GTPLOUTA(,@05)                                  0431
         LA    @02,8                                               0431
         ALR   @02,@05                                             0431
         ST    @02,S99TXTPP(,@10)                                  0431
*            GTPLOUT1 = GTPLOUTA;      /* SAVE TEXT PTR              */
         LR    GTPLOUT1,@05                                        0432
*          END;                                                    0433
*                                                                  0433
*    END TRANSRTN;                                                 0434
@EL00009 DS    0H                                                  0434
@EF00009 DS    0H                                                  0434
@ER00009 LM    @14,@03,@SA00009                                    0434
         LM    @05,@12,@SA00009+24                                 0434
         BR    @14                                                 0434
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -                                                   */
*/*      DYNSVC                                                      */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*      THIS ROUTINE INVOKES DYNAMIC ALLOCATION.                    */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      THE PARAMETER LIST IS COMPLETED. SVC 99 IS ISSUED. THE      */
*/*      RETURN CODE IN REGISTER 15 IS SAVED.                        */
*/*                                                                  */
*/* INPUT -                                                          */
*/*      SVC 99 REQUEST BLOCK                                        */
*/*                                                                  */
*/* OUTPUT -                                                         */
*/*      RETURN CODE                                                 */
*/*                                                                  */
*/********************************************************************/
*    DYNSVC: PROC;                                                 0435
*                                                                  0435
DYNSVC   STM   @14,@12,12(@13)                                     0435
*        R1 = ADDR(S99RBPTR);                                      0436
         LA    R1,S99RBPTR                                         0436
*        S99RBPTR = PTRS99RB;                                      0437
         L     @10,PTRS99RB(,AWAPTR)                               0437
         ST    @10,S99RBPTR                                        0437
*        S99RBPND = '1'B;              /* HIGH ORDER BIT ON          */
*                                                                  0438
*                                                                  0438
         OI    S99RBPND,B'10000000'                                0438
*         /*MACDATE Y-2 73082*/                                    0439
*         SVC (99);                    /* ISSUE SVC 99               */
*                                                                  0439
         SVC   99                                                  0439
*        RCODESV = R15;                /* SAVE RETURN CODE           */
*                                                                  0440
         ST    R15,RCODESV(,AWAPTR)                                0440
*    END DYNSVC;                                                   0441
@EL00010 DS    0H                                                  0441
@EF00010 DS    0H                                                  0441
@ER00010 LM    @14,@12,12(@13)                                     0441
         BR    @14                                                 0441
*    END IKJEFD34                                                  0442
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IKJZT430)                                        *
*/*%INCLUDE SYSLIB  (IKJCPPL )                                        *
*/*%INCLUDE SYSLIB  (IKJPPL  )                                        *
*/*%INCLUDE SYSLIB  (IKJEFFMT)                                        *
*/*%INCLUDE SYSLIB  (IKJZB831)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D0)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                        *
*;                                                                 0442
@DATA    DS    0H
@CH00320 DC    H'3'
@CH00318 DC    H'4'
@CH00047 DC    H'5'
@CH00096 DC    H'8'
@CH00839 DC    H'10'
@CH00614 DC    XL2'0001'
@CH00618 DC    XL2'0003'
@CH00620 DC    XL2'0004'
@CH00626 DC    XL2'0007'
@CH00772 DC    XL2'0050'
@CH00776 DC    XL2'0052'
@CH00782 DC    XL2'0055'
@CH00786 DC    XL2'0057'
@SM00888 MVC   DAPARM(0,@01),DATAVAL(DPTR2)
@SM00890 MVC   MBPARM(0,@15),MBRVAL(MPTR2)
@SM00892 MVC   PWPARM(0,@15),PSWVAL(PPTR2)
@SM00896 MVC   DDFVAL(0),DDNMPARM(DDLST)
@SM00900 MVC   DDNMPARM(0,DDLST),RTDDNAME(@10)
@SM00903 MVC   NDDNBUF1(0),DDNBUF1(@10)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@SAV001  EQU   @SA00001
@SA00007 DS    15F
@SA00008 DS    15F
@SA00009 DS    14F
@SA00003 DS    14F
@SA00004 DS    14F
@SA00005 DS    14F
@SA00006 DS    14F
@TF00001 DS    F
@ZTEMPS  DS    C
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
@TEMPS   EQU   @ZTEMPS
@L       EQU   @ZLEN
IKJEFD34 CSECT
         DS    0F
@CF00033 DC    F'1'
@CH00033 EQU   @CF00033+2
@CF00080 DC    F'2'
@CH00080 EQU   @CF00080+2
@CF00845 DC    F'12'
@CF00463 DC    F'14'
@CF00613 DC    F'16'
@DATD    DSECT
         DS    0D
S99RBPTR DS    AL4
         ORG   S99RBPTR
S99RBPND DS    BL1
         ORG   S99RBPTR+4
S99TUFP  DS    A
SAVPWLEN DS    H
         DS    CL2
CORE     DS    CL4
         ORG   CORE
SPNO     DS    CL1
SIZE     DS    AL3
         ORG   CORE+4
DDFREEBF DS    CL14
         ORG   DDFREEBF
DDFKEY   DS    FL2
DDFNUM   DS    FL2
DDFLEN   DS    FL2
DDFVAL   DS    CL8
         ORG   DDFREEBF+14
CNCTFLAG DS    CL1
         ORG   CNCTFLAG
STATSERR DS    BL1
ALLOCERR EQU   CNCTFLAG+0
MAXERR   EQU   CNCTFLAG+0
DSORGERR EQU   CNCTFLAG+0
INVORG   EQU   CNCTFLAG+0
@NM00011 EQU   CNCTFLAG+0
         ORG   CNCTFLAG+1
CNCTFLG1 DS    CL1
         ORG   CNCTFLG1
SEARCH   DS    BL1
DSORGSQ  EQU   CNCTFLG1+0
DSORGPR  EQU   CNCTFLG1+0
DSORGVM  EQU   CNCTFLG1+0
FREEFL   EQU   CNCTFLG1+0
@NM00021 EQU   CNCTFLG1+0
         ORG   CNCTFLG1+1
NDDNBUF1 DS    CL8
SAVEFLG  DS    CL1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
@DATEND  EQU   *
IKJEFD34 CSECT
         DS    0F
@SIZDATD DC    AL1(1)
         DC    AL3(@ENDDATD-@DATD)
@SIZ001  EQU   @SIZDATD
@CV00340 DC    V(IKJEFD35)
@CV00341 DC    V(IKJEFD36)
@CV00342 DC    V(IKJEFD37)
         DS    0D
@CC00867 DC    C'107A'
@CC00868 DC    C'106A'
@CC00869 DC    C'110A'
@CC00870 DC    C'108A'
@CC00872 DC    C'109A'
@CB00860 DC    X'0410'
MOD      DC    CL3'MOD'
NEW      DC    CL3'NEW'
SYSOUT   DC    CL6'SYSOUT'
         DS    CL2
PATCH32  DC    25F'0'
CONCTEXT DC    X'12'
         DC    X'10'
         DC    X'14'
         DC    X'1E'
         DC    X'2E'
         DC    X'20'
         DC    X'22'
         DC    X'1A'
         DC    X'1C'
         DC    X'2A'
         DC    X'2C'
         DC    X'24'
         DC    X'0E'
         DC    X'26'
         DC    X'28'
         DC    X'18'
         DC    X'16'
         DC    X'00'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
@0       EQU   00
@1       EQU   01
@2       EQU   02
@3       EQU   03
@4       EQU   04
@5       EQU   05
@6       EQU   06
@7       EQU   07
@8       EQU   08
@9       EQU   09
@A       EQU   10
@B       EQU   11
@C       EQU   12
@D       EQU   13
@E       EQU   14
@F       EQU   15
GTPLOUT1 EQU   @04
LISTNMBR EQU   @08
DSFREED  EQU   @07
DDLST    EQU   @05
DDNAPTR  EQU   @06
SAVMBLEN EQU   @10
PPTR2    EQU   @09
MPTR2    EQU   @07
DPTR2    EQU   @02
INC      EQU   @08
EXTRAN   EQU   @05
SAVERC   EQU   @07
AWAPTR   EQU   @03
I        EQU   @02
R0       EQU   @00
R1       EQU   @01
R5       EQU   @05
R13      EQU   @13
R15      EQU   @15
R14      EQU   @14
REGSAVE  EQU   4
RETCODE  EQU   16
ALLOCWA  EQU   0
CPPLPTR  EQU   ALLOCWA
PTRPDL   EQU   ALLOCWA+4
GTPLPTR  EQU   ALLOCWA+8
SWITCH   EQU   ALLOCWA+12
RBCODE12 EQU   SWITCH
CONT     EQU   SWITCH
TERMOPT  EQU   SWITCH
ENTRYCD  EQU   ALLOCWA+14
TXT      EQU   ALLOCWA+16
PTRS99RB EQU   ALLOCWA+20
RCODESV  EQU   ALLOCWA+24
DSNCTR   EQU   ALLOCWA+30
PTRMSGS  EQU   ALLOCWA+32
VCFLAGS  EQU   ALLOCWA+36
PMPTPDL  EQU   ALLOCWA+40
MSGPTR   EQU   ALLOCWA+48
CMDTWO   EQU   ALLOCWA+60
COMMECB  EQU   ALLOCWA+160
PPLPTR   EQU   ALLOCWA+172
ALLOCPDL EQU   0
FILEPDE  EQU   ALLOCPDL+10
STATSPDE EQU   ALLOCPDL+12
DSNPDE   EQU   ALLOCPDL+48
DSNPTR   EQU   DSNPDE
DSNFLAGS EQU   DSNPDE+6
MBRPTR   EQU   DSNPDE+8
MBRFLAGS EQU   DSNPDE+14
PASSPTR  EQU   DSNPDE+16
PASSFLAG EQU   DSNPDE+22
DDNMEPDE EQU   ALLOCPDL+76
DDNPTR   EQU   DDNMEPDE
DDNLEN   EQU   DDNMEPDE+4
DDNFLAGS EQU   DDNMEPDE+6
CLASPDE  EQU   ALLOCPDL+84
CLASPTR  EQU   CLASPDE
CLASFLG  EQU   CLASPDE+6
SERPDE   EQU   ALLOCPDL+92
SERPTR   EQU   SERPDE
SERFLAGS EQU   SERPDE+6
BLKPDE   EQU   ALLOCPDL+104
BLKPTR   EQU   BLKPDE
BLKFLAGS EQU   BLKPDE+6
ABLKPDE  EQU   ALLOCPDL+112
ABLKPTR  EQU   ABLKPDE
ABLKFLG  EQU   ABLKPDE+6
SPACPDE  EQU   ALLOCPDL+120
SPACEPTR EQU   SPACPDE
SPACEFLG EQU   SPACPDE+6
SPACPDE2 EQU   ALLOCPDL+128
SPACPTR2 EQU   SPACPDE2
SPACFLG2 EQU   SPACPDE2+6
DIRECPDE EQU   ALLOCPDL+136
DIRPTR   EQU   DIRECPDE
DIRFLAGS EQU   DIRECPDE+6
ATTRPDE  EQU   ALLOCPDL+144
ATTRPTR  EQU   ATTRPDE
ATTRFLAG EQU   ATTRPDE+6
USIDPDE  EQU   ALLOCPDL+152
USIDPTR  EQU   USIDPDE
USIDFLAG EQU   USIDPDE+6
UTYPPDE  EQU   ALLOCPDL+160
UTYPPTR  EQU   UTYPPDE
UTYPFLAG EQU   UTYPPDE+6
UNCNTPDE EQU   ALLOCPDL+168
UCNTPTR  EQU   UNCNTPDE
UCNTFLAG EQU   UNCNTPDE+6
POSTPDE  EQU   ALLOCPDL+180
POSPTR   EQU   POSTPDE
POSFLAG  EQU   POSTPDE+6
MXVOLPDE EQU   ALLOCPDL+188
MXVOLPTR EQU   MXVOLPDE
MXVOLFLG EQU   MXVOLPDE+6
VOLSQPDE EQU   ALLOCPDL+196
VOLSQPTR EQU   VOLSQPDE
VOLSQFLG EQU   VOLSQPDE+6
MSVGPDE  EQU   ALLOCPDL+204
MSVGPTR  EQU   MSVGPDE
MSVGFLG  EQU   MSVGPDE+6
DSNBUF   EQU   0
CPPL     EQU   0
PPL      EQU   0
PDEEXT   EQU   0
MSGTABLE EQU   0
LISTPTR  EQU   MSGTABLE
TMCTPTR  EQU   MSGTABLE+4
MTCPPL   EQU   TMCTPTR
ECBPTR   EQU   MSGTABLE+8
@NM00005 EQU   MSGTABLE+12
MTHIGH   EQU   @NM00005
MSGCSECT EQU   MSGTABLE+16
SW       EQU   MSGTABLE+20
MTPUTLSW EQU   SW
RETMSG   EQU   MSGTABLE+21
SW2      EQU   MSGTABLE+24
MSGID    EQU   MSGTABLE+40
MTINSRTS EQU   MSGTABLE+44
L1       EQU   MTINSRTS
VAR1     EQU   MTINSRTS+1
L2       EQU   MTINSRTS+4
L3       EQU   MTINSRTS+8
L4       EQU   MTINSRTS+12
RET      EQU   0
TEXTCORE EQU   0
ADDNUM   EQU   TEXTCORE
ADDTEXT  EQU   TEXTCORE+4
ADLTEXT  EQU   0
ADLKEY   EQU   ADLTEXT
ADLNBR   EQU   ADLTEXT+2
ADLLEN   EQU   ADLTEXT+4
FILETXT  EQU   0
FILEKY   EQU   FILETXT
FILENUM  EQU   FILETXT+2
DSNTUNIT EQU   0
DANUM    EQU   DSNTUNIT+2
DALEN    EQU   DSNTUNIT+4
DAPARM   EQU   DSNTUNIT+6
DSUNIT   EQU   0
DATALEN  EQU   DSUNIT
DATAVAL  EQU   DSUNIT+2
MBRTUNIT EQU   0
MBKEY    EQU   MBRTUNIT
MBNUM    EQU   MBRTUNIT+2
MBLEN    EQU   MBRTUNIT+4
MBPARM   EQU   MBRTUNIT+6
MBUNIT   EQU   0
MEMLEN   EQU   MBUNIT
MBRVAL   EQU   MBUNIT+2
PSWTUNIT EQU   0
PWKEY    EQU   PSWTUNIT
PWNUM    EQU   PSWTUNIT+2
PWLEN    EQU   PSWTUNIT+4
PWPARM   EQU   PSWTUNIT+6
PWUNIT   EQU   0
PSWLEN   EQU   PWUNIT
PSWVAL   EQU   PWUNIT+2
DDNCAREA EQU   0
PERMCTPT EQU   DDNCAREA
DDNMPTR  EQU   DDNCAREA+4
DDNMEND  EQU   DDNMPTR
PERMCTXT EQU   DDNCAREA+8
PERMCTKY EQU   PERMCTXT
PERMCTNM EQU   PERMCTXT+2
DDNMTXT  EQU   DDNCAREA+12
DDNMKEY  EQU   DDNMTXT
DDNMNBR  EQU   DDNMTXT+2
DDNMLEN  EQU   DDNMTXT+4
DDNMLIST EQU   0
DDNMLNGH EQU   DDNMLIST
DDNMPARM EQU   DDNMLIST+2
DADSORG  EQU   0
RTDSORG  EQU   DADSORG+6
SEQUEN   EQU   RTDSORG
PARTND   EQU   RTDSORG
VSAM     EQU   RTDSORG+1
DADDNAME EQU   0
RTDDNLEN EQU   DADDNAME+4
RTDDNAME EQU   DADDNAME+6
DDPDE2   EQU   0
DDPTR2   EQU   DDPDE2+8
DDLNGH2  EQU   DDPDE2+12
DDFLAG2  EQU   DDPDE2+14
DDNBUF1  EQU   0
GTPL     EQU   0
GTPLABLK EQU   GTPL+16
GTPLOUTA EQU   GTPL+20
TEXTRET  EQU   0
TUDSN    EQU   TEXTRET+8
TUMBR    EQU   TEXTRET+12
TUPSWD   EQU   TEXTRET+16
TUFILE   EQU   TEXTRET+20
TURTDDN  EQU   TEXTRET+96
TURTDSO  EQU   TEXTRET+100
S99RB    EQU   0
S99VERB  EQU   S99RB+1
S99FLAG1 EQU   S99RB+2
S99FLG11 EQU   S99FLAG1
S99NOCNV EQU   S99FLG11
S99RSC   EQU   S99RB+4
S99ERROR EQU   S99RSC
S99TXTPP EQU   S99RB+8
S99FLAG2 EQU   S99RB+16
S99FLG21 EQU   S99FLAG2
S99FLG22 EQU   S99FLAG2+1
S99TUPL  EQU   0
S99TUPTR EQU   S99TUPL
S99TUP   EQU   0
S99TUNIT EQU   0
S99TUENT EQU   S99TUNIT+4
S99TUFLD EQU   0
ABLKBUF  EQU   0
ATTRBUF  EQU   0
BLKBUF   EQU   0
CLASSBUF EQU   0
DDNBUF   EQU   0
DIRBUF   EQU   0
MBRBUF   EQU   0
MSGECB   EQU   0
MSGTMCT  EQU   0
MSVGBUF  EQU   0
MXVOLBUF EQU   0
PASSBUF  EQU   0
POSTBUF  EQU   0
SERBUF   EQU   0
SPACBUF2 EQU   0
SPACEBUF EQU   0
UCNTBUF  EQU   0
USIDBUF  EQU   0
UTYPBUF  EQU   0
VSEQBUF  EQU   0
INPARMS  EQU   0
*                                      START UNREFERENCED COMPONENTS
S99TUPRM EQU   S99TUFLD+2
S99TULEN EQU   S99TUFLD
S99TUPAR EQU   S99TUENT+2
S99TULNG EQU   S99TUENT
S99TUNUM EQU   S99TUNIT+2
S99TUKEY EQU   S99TUNIT
S99TUPND EQU   S99TUP
S99TUPLN EQU   S99TUPTR
S99FLG24 EQU   S99FLAG2+3
S99FLG23 EQU   S99FLAG2+2
S99PCINT EQU   S99FLG22
S99UDEVT EQU   S99FLG22
S99MOUNT EQU   S99FLG21
S99CATLG EQU   S99FLG21
S99TIONQ EQU   S99FLG21
S99OFFLN EQU   S99FLG21
S99WTUNT EQU   S99FLG21
S99NORES EQU   S99FLG21
S99WTDSN EQU   S99FLG21
S99WTVOL EQU   S99FLG21
S99RSV01 EQU   S99RB+12
S99INFO  EQU   S99RSC+2
S99FLG12 EQU   S99FLAG1+1
S99JBSYS EQU   S99FLG11
S99NOMNT EQU   S99FLG11
S99ONCNV EQU   S99FLG11
S99RBLN  EQU   S99RB
TUDISP   EQU   TEXTRET+92
TURND    EQU   TEXTRET+88
TURLSE   EQU   TEXTRET+84
TUVSEQ   EQU   TEXTRET+80
TUPRIV   EQU   TEXTRET+76
TUMAXV   EQU   TEXTRET+72
TUPOS    EQU   TEXTRET+68
TULABEL  EQU   TEXTRET+64
TUUCNT   EQU   TEXTRET+60
TUUNIT   EQU   TEXTRET+56
TUHOLD   EQU   TEXTRET+52
TUDEST   EQU   TEXTRET+48
TUUSING  EQU   TEXTRET+44
TUDIR    EQU   TEXTRET+40
TUSPACE  EQU   TEXTRET+36
TUBLOK   EQU   TEXTRET+32
TUVOL    EQU   TEXTRET+28
TUSTATS  EQU   TEXTRET+24
TUPSWDND EQU   TUPSWD
ENTRYNBR EQU   TEXTRET+4
SBPLSIZE EQU   TEXTRET
GTPLTBLE EQU   GTPL+12
GTPLKLST EQU   GTPL+8
GTPLPCL  EQU   GTPL+4
GTPLPDL  EQU   GTPL
@NM00024 EQU   DDPDE2+15
@NM00023 EQU   DDPDE2+4
@NM00022 EQU   DDPDE2
@NM00020 EQU   DADDNAME+2
@NM00019 EQU   DADDNAME
@NM00018 EQU   RTDSORG+1
@NM00017 EQU   RTDSORG
@NM00016 EQU   RTDSORG
@NM00015 EQU   RTDSORG
@NM00014 EQU   DADSORG+4
@NM00013 EQU   DADSORG+2
@NM00012 EQU   DADSORG
DDNMVAL  EQU   DDNMTXT+6
DAKEY    EQU   DSNTUNIT
ADLPARM  EQU   ADLTEXT+6
ADDUNIT  EQU   TEXTCORE+36
@NM00010 EQU   TEXTCORE+2
RETCHAR  EQU   RET+2
RETSIZE  EQU   RET
MSGRTN   EQU   MSGTABLE+60
VAR4     EQU   MTINSRTS+13
HIGHL4   EQU   L4
VAR3     EQU   MTINSRTS+9
HIGHL3   EQU   L3
VAR2     EQU   MTINSRTS+5
HIGHL2   EQU   L2
HIGHL1   EQU   L1
@NM00009 EQU   MSGTABLE+36
@NM00008 EQU   MSGTABLE+32
MTOLDPTR EQU   MSGTABLE+28
@NM00007 EQU   MSGTABLE+25
@NM00006 EQU   SW2
MTPGMSW  EQU   SW2
MTNPLMSW EQU   SW2
MTNOXQSW EQU   SW2
MTDOMSW  EQU   SW2
MT2OLDSW EQU   SW2
MTNHEXSW EQU   SW
MTWTPSW  EQU   SW
MTJOBISW EQU   SW
MTKEY1SW EQU   SW
MTHEXSW  EQU   SW
MTWTOSW  EQU   SW
MTNOIDSW EQU   SW
PPLUWA   EQU   PPL+24
PPLCBUF  EQU   PPL+20
PPLANS   EQU   PPL+16
PPLPCL   EQU   PPL+12
PPLECB   EQU   PPL+8
PPLECT   EQU   PPL+4
PPLUPT   EQU   PPL
CPPLECT  EQU   CPPL+12
CPPLPSCB EQU   CPPL+8
CPPLUPT  EQU   CPPL+4
CPPLCBUF EQU   CPPL
DSNTERM  EQU   DSNBUF
MSVGRSV2 EQU   MSVGPDE+7
MSVGRSV1 EQU   MSVGFLG
MSVGPRES EQU   MSVGFLG
MSVGLEN  EQU   MSVGPDE+4
VOLRSV2  EQU   VOLSQPDE+7
VOLRSV1  EQU   VOLSQFLG
VOLPRES  EQU   VOLSQFLG
VOLSQLEN EQU   VOLSQPDE+4
MXVRSV2  EQU   MXVOLPDE+7
MXVRSV1  EQU   MXVOLFLG
MXVPRES  EQU   MXVOLFLG
MXVOLLEN EQU   MXVOLPDE+4
POSRSV2  EQU   POSTPDE+7
POSRSV1  EQU   POSFLAG
POSPRES  EQU   POSFLAG
POSLEN   EQU   POSTPDE+4
LABLRSV1 EQU   ALLOCPDL+178
LABELPDE EQU   ALLOCPDL+176
UCNTRSV2 EQU   UNCNTPDE+7
UCNTRSV1 EQU   UCNTFLAG
UCNTPRES EQU   UCNTFLAG
UCNTLEN  EQU   UNCNTPDE+4
UTYPRSV2 EQU   UTYPPDE+7
UTYPRSV1 EQU   UTYPFLAG
UTYPPRES EQU   UTYPFLAG
UTYPLEN  EQU   UTYPPDE+4
USIDRSV2 EQU   USIDPDE+7
USIDRSV1 EQU   USIDFLAG
USIDPRES EQU   USIDFLAG
USIDLEN  EQU   USIDPDE+4
ATTRRSV2 EQU   ATTRPDE+7
ATTRRSV1 EQU   ATTRFLAG
ATTRPRES EQU   ATTRFLAG
ATTRLEN  EQU   ATTRPDE+4
DIRRSV2  EQU   DIRECPDE+7
DIRRSV1  EQU   DIRFLAGS
DIRPRES  EQU   DIRFLAGS
DIRLEN   EQU   DIRECPDE+4
SPCRSV22 EQU   SPACPDE2+7
SPCRSV12 EQU   SPACFLG2
SPCPRES2 EQU   SPACFLG2
SPACLEN2 EQU   SPACPDE2+4
SPACRSV2 EQU   SPACPDE+7
SPACRSV1 EQU   SPACEFLG
SPACPRES EQU   SPACEFLG
SPACELEN EQU   SPACPDE+4
ABLKRSV2 EQU   ABLKPDE+7
ABLKRSV1 EQU   ABLKFLG
ABLKPRES EQU   ABLKFLG
ABLKLEN  EQU   ABLKPDE+4
BLKRSV2  EQU   BLKPDE+7
BLKRSV1  EQU   BLKFLAGS
BLKPRES  EQU   BLKFLAGS
BLKLEN   EQU   BLKPDE+4
SERNEXT  EQU   SERPDE+8
SERRSV2  EQU   SERPDE+7
SERRSV1  EQU   SERFLAGS
SERPRES  EQU   SERFLAGS
SERLEN   EQU   SERPDE+4
CLASRSV2 EQU   CLASPDE+7
CLASRSV1 EQU   CLASFLG
CLASPRES EQU   CLASFLG
CLASLEN  EQU   CLASPDE+4
DDNRSV2  EQU   DDNMEPDE+7
DDNRSV1  EQU   DDNFLAGS
DDNPRES  EQU   DDNFLAGS
DSNNEXT  EQU   DSNPDE+24
PASSRSV2 EQU   DSNPDE+23
PASSRSV1 EQU   PASSFLAG
PASSPRES EQU   PASSFLAG
PASSLEN  EQU   DSNPDE+20
MBRRSV2  EQU   DSNPDE+15
MBRRSV1  EQU   MBRFLAGS
MBRPRES  EQU   MBRFLAGS
MBRLEN   EQU   DSNPDE+12
DSNRSV2  EQU   DSNPDE+7
DSNRSV1  EQU   DSNFLAGS
DSNQUOT  EQU   DSNFLAGS
DSNPRES  EQU   DSNFLAGS
DSNLENGH EQU   DSNPDE+4
DISPPDE  EQU   ALLOCPDL+46
RNDPDE   EQU   ALLOCPDL+44
RLSEPDE  EQU   ALLOCPDL+42
VSEQPDE  EQU   ALLOCPDL+40
PRIVPDE  EQU   ALLOCPDL+38
MAXVPDE  EQU   ALLOCPDL+36
POSPDE   EQU   ALLOCPDL+34
LABLPDE  EQU   ALLOCPDL+32
UCNTPDE  EQU   ALLOCPDL+30
UNITPDE  EQU   ALLOCPDL+28
HOLDPDE  EQU   ALLOCPDL+26
DESTPDE  EQU   ALLOCPDL+24
USINGPDE EQU   ALLOCPDL+22
DIRPDE   EQU   ALLOCPDL+20
SPACEPDE EQU   ALLOCPDL+18
BLOKPDE  EQU   ALLOCPDL+16
VOLPDE   EQU   ALLOCPDL+14
DSPDE    EQU   ALLOCPDL+8
@NM00004 EQU   ALLOCPDL+4
@NM00003 EQU   ALLOCPDL
FIRSTPTR EQU   ALLOCWA+176
NBLKBUF1 EQU   ALLOCWA+164
PDLADDR3 EQU   ALLOCWA+156
PPLTWO   EQU   ALLOCWA+128
CMDTWOBF EQU   CMDTWO+4
CMDTWOOF EQU   CMDTWO+2
CMDTWOLN EQU   CMDTWO
Q        EQU   ALLOCWA+56
P        EQU   ALLOCWA+52
PRCODE   EQU   ALLOCWA+44
@NM00002 EQU   ALLOCWA+38
NCLASBUF EQU   ALLOCWA+37
@NM00001 EQU   VCFLAGS
SPACE2   EQU   VCFLAGS
SPACE1   EQU   VCFLAGS
AVBLK    EQU   VCFLAGS
VLISTCTR EQU   ALLOCWA+28
AWARSV2  EQU   ALLOCWA+13
FIRSTPDE EQU   SWITCH
AWARSV1  EQU   SWITCH
ASTRSK   EQU   SWITCH
PROMPT   EQU   SWITCH
DSOVRLAY EQU   SWITCH
*                                      END UNREFERENCED COMPONENTS
@RC00142 EQU   @EL00001
@RC00198 EQU   @RC00195
@RF00220 EQU   @RC00195
@RC00224 EQU   @RC00195
@RC00285 EQU   @RC00279
@RF00301 EQU   @EL00005
@RC00309 EQU   @EL00005
@RC00321 EQU   @EL00005
@RC00317 EQU   @EL00005
@RC00315 EQU   @EL00005
@RC00331 EQU   @EL00006
@RF00343 EQU   @EL00006
@RC00398 EQU   @EL00008
@RC00424 EQU   @EL00009
@RC00318 EQU   @RC00317
@EL01    EQU   @EL00001
@ENDDATA EQU   *
         END   IKJEFD34,(C'PLS1704',0701,75248)
