         TITLE 'IKJEFF03 - MESSAGE CSECT FOR SUBMIT COMMAND'
***********************************************************************
*
*             MODULE NAME = IKJEFF03
*
*             DESCRIPTIVE NAME =  MESSAGE CSECT FOR SUBMIT COMMAND
*
*             COPYRIGHT = NONE
*
*             STATUS
*                RELEASE 02.0 OF VS2
*
*             FUNCTION
*                .        THIS MODULE CONTAINS MESSAGES.   THESE
*                .        ARE  CODED  WITH THE 'IKJTSMSG' MACRO
*                .        AND ARE PROCESSED BY MODULE IKJEFF02.
*                .
*                .        ALL MESSAGES ARE USED BY THE SUBMIT
*                .        COMMAND.  MESSAGES 251I AND 259I ARE
*                .        ALSO USED BY OTHER FIB (FOREGROUND
*                .        INITIATED BACKGROUND) COMMANDS
*                .        AND ARE ALSO IN IKJEFF55, THE MESSAGE
*                .        CSECT FOR CANCEL/STATUS.
*
*             ENTRY POINTS     N/A
*
*             INPUT            N/A
*
*             OUTPUT           N/A
*
*             EXTERNAL REFERENCES     N/A
*
*             EXITS,NORMAL     N/A
*
*             EXITS,ERROR      N/A
*
*             TABLES/WORK AREA        N/A
*
*             EXECUTABLE MACROS
*                       NONE
*
*             NON-EXECUTABLE MACROS
*                       IKJTSMSG, MODID
*
*             ATTRIBUTES
*                       REENTRANT AND REFRESHABLE
*
*             NOTES
*                   CHARACTER CODE DEPENDENCY = EBCDIC
*                   - REASSEMBLE IF NEED ANOTHER CHARACTER CODE
*
*
*             CHANGE ACTIVITY = Y02064
*                APAR HISTORY
*C021500,023000                                               OS=A43009
*
*                PTM HISTORY
*                  YM7267 - IMPROVE IKJEFF02'S ERROR MESSAGES
*
*                . SUPPORT CODES =
*                .     Y02064 - TSO REDIRECTED SYSOUT (INTERNAL RDR)
*                .     Y02656 - SCHEDULER PROTECTION
*                .     Y02993 - MODULE CLEANUP
*
***********************************************************************
         EJECT
*
*
*
*                   INDEX TO MESSAGES
*                   ***** ** ********
*                       . THE   EXTERNAL   MESSAGE    IDENTIFIER
*                         INDICATES WHICH IKJEFF-- MODULE IS THE
*                         ORIGINATOR OR CALLER.
*
*                       . IF A RELATED MESSAGE IS IDENTIFIED  BY
*                         A 'Q' NUMBER, THEN THE RELATED MESSAGE
*                         IS PUT OUT IF A QUESTION MARK IS GIVEN
*                         AS A RESPONSE TO THE FIRST MESSAGE
*                         (THIS IS USED FOR PUTGET LOGIC - REPLY
*                         OBTAINED, ALSO)
*
*                       . IF A RELATED MESSAGE IS IDENTIFIED  BY
*                         AN   'R'   NUMBER,  THEN  THE  RELATED
*                         MESSAGE APPEARS FIRST  AND  THE  FIRST
*                         MESSAGE  IS PUT OUT (ULTIMATELY BY THE
*                         TMP) IN RESPONSE TO A  QUESTION  MARK.
*                         THIS IS CALLED 'REVERSAL'.
*                         (THIS IS USED FOR PUTLINE LOGIC - NO REPLY)
*
*
*
*                   MESSAGE IDS
*                   ******* ***
*                       TERMINAL MESSAGE NUMBERS
*                       . IKJ56250-299 = SUBMIT, SEE TSO MESSAGES SRL
*                                        FOR OFFICIAL MESSAGE ID LIST
*
*                             (290I-299I USED FOR IKJEFF19 VSAMFAIL
*                              AND GENERAL FAILURE ROUTINE)
*
*
*                       OPERATOR CONSOLE MESSAGE NUMBERS
*                       . IKJ500-548 SUBMIT      (UNUSED IN REL.2)
*                       . IKJ549 - CANCEL/STATUS (UNUSED IN REL.2)
*
         EJECT
*                   MESSAGES IN THIS CSECT
*                   ******** ** **** *****
*
*                     (DESCRIPTIONS ARE AT THE END OF THIS MODULE,
*                      FOLLOWING THE MESSAGE TEXTS)
*
*               BAL   EXTERNAL    INTERNAL      2ND LEVEL MESSAGE ID
*               LABEL MSGID       MSGID         (PUTGET)      (PUTLINE)
*               ***** *****       *****         ********      *********
*                   A IKJ56250I - 12B (DETECTED BY MODULE IKJEFF12;
*                                      B IS UNIQUE MESSAGE IDENTIFIER)
*                   C      251I - 01A                                R1
*                   AB     252I - 17A (ALSO DETECTED BY MOD. IKJEFF04)
*                   E      253A - 13A              Q5
*                   -      254I - ***UNASSIGNED***
*                   G      255I - 13C
*                   H      255A - 13D              Q2
*                   J      256I - 12D
*                   K      257I - 13B
*                   -      258I - ***UNASSIGNED***
*                   Z      259I - 01B                                R5
*                   AO     260I - 05I (ALSO DETECTED BY IKJEFF04)
*                   AH     261I - 05F
*                   AN     262I - 05H
*                   AM     263I - 05G
*                   -      264I - ***UNASSIGNED***
*                   L      265I - 05D,05E,05J                        R2
*                   AG     266I - 09D
*                   -      267I - ***UNASSIGNED***
*                   AJ     268I - 17B
*                   AK     269I - 17C
*                   -      270I - ***UNASSIGNED***
*                   -      271I - ***UNASSIGNED***
*                   AR     272I - 05K
*                   AS     273I - 05L
*                   -      274I THRU 279I - ***UNASSIGNED***
*                   V      280A - 09A              Q3
*                   -      281I - ***UNASSIGNED***
*                   X      282I - 09C                                R6
*                   Y      283I - 09B
*                   -      284I - (NOT IN THIS CSECT-IN IKJEFF02)
*                   -      285I - ***UNASSIGNED***
*                   -      286I - ***UNASSIGNED***
*                   AY     287I - 12C (ALSO DETECTED BY IKJEFF15)
*                   AZ     288I - 04A
*                   BA     289I - 04B (ALSO DETECTED BY IKJEFF08)
*                   -      290I-299I - ASSIGNED TO IKJEFF19 (VSAMFAIL
*                                                        AND GNRLFAIL)
         EJECT
IKJEFF03 CSECT
*A-000000-999999                                                @Y02993
A     IKJTSMSG ('IKJ56250I JOB ',,' SUBMITTED'),12B             @Y02064
*
C     IKJTSMSG ('IKJ56251I ',,' COMMAND NOT AUTHORIZED+'),R1
D    IKJTSMSG ('IKJ56251I YOUR INSTALLATION MUST AUTHORIZE USE OF THIS X
               COMMAND'),01A,R1                                  A43009
*
E     IKJTSMSG ('IKJ56253A ENTER JOBNAME CHARACTER+ -'),13A,Q5
F IKJTSMSG ('IKJ56253A JOBNAME IS CREATED FROM USERID PLUS',       XXXXX
               ' ONE ALPHANUMERIC OR NATIONAL CHARACTER'),Q5
*
G     IKJTSMSG ('IKJ56255I INVALID CHARACTER - ',),13C
*
*
H     IKJTSMSG ('IKJ56255A REENTER+ -'),13D,Q2
I     IKJTSMSG ('IKJ56255A CHARACTER MUST BE ALPHANUMERIC OR NATIONAL')+
               ,Q2                                              @Y02064
*
*
J     IKJTSMSG ('IKJ56256I ',,' TERMINATED ON JOB ',),12D       @Y02064
*
*
K     IKJTSMSG ('IKJ56257I MISSING JOBNAME CHARACTER AND UNABLE TO PROM+
               PT'),13B
*
*
L IKJTSMSG ('IKJ56265I INPUT DATA SET ',,' NOT USABLE+'),R2
*
*
V     IKJTSMSG ('IKJ56280A ',,'+'),09A,Q3
W     IKJTSMSG ('IKJ56280A ENTER REPLY FOR EXIT -'),Q3
*
*
X     IKJTSMSG ('IKJ56282I ',,' COMMAND FAILED - UNABLE TO PROMPT USER+X
               '),R6
XX    IKJTSMSG ('IKJ56282I MISSING REPLY FOR ''',,''' FROM EXIT'),09C,RX
               6
*
*
Y     IKJTSMSG ('IKJ56283I ',),09B
*
*
Z    IKJTSMSG ('IKJ56259I ',,' COMMAND ENDED DUE TO FIB SVC ',,' ERROR X
               CODE ',,'+'),R5                                  @Y02656
AA    IKJTSMSG ('IKJ56259I REENTER COMMAND, THEN IF ERROR CALL YOUR SYSX
               TEM PROGRAMMER'),01B,R5                          @Y02656
*
*
AB    IKJTSMSG ('IKJ56252I COMMAND SYSTEM ERROR - ',,' ERROR CODE ',),1X
               7A
*
AG    IKJTSMSG ('IKJ56266I UNABLE TO DIAGNOSE EXIT RETURN CODE ',),09D
*
AH    IKJTSMSG ('IKJ56261I RECORD LENGTH OF DATA SET ',,' NOT 80'),05F
*
AJ    IKJTSMSG ('IKJ56268I INVALID DATA SET NAME ',,', EXCEEDS 44 CHARAX
               CTERS'),17B
*
AK    IKJTSMSG ('IKJ56269I DATA SET ',,' NOT IN CATALOG'),17C
*
AM    IKJTSMSG ('IKJ56263I RECORD FORMAT FOR DATA SET ',,' NOT FIXED'),X
               05G
*
*
AN    IKJTSMSG ('IKJ56262I MEMBER ',,' NOT IN DATA SET ',),05H
*
*
AO    IKJTSMSG ('IKJ56260I INSUFFICIENT STORAGE TO EXECUTE ',,' COMMANDX
               '),05I
*
*
AP    IKJTSMSG ('IKJ56265I CANNOT OPEN DATA SET'),05E,R2
AQ    IKJTSMSG ('IKJ56265I FIND I/O ERROR'),05J,R2
*
AR    IKJTSMSG ('IKJ56272I ORGANIZATION OF DATA SET ',,' NOT',         *
               ' SEQUENTIAL OR PARTITIONED'),05K
*
AS    IKJTSMSG ('IKJ56273I MEMBER ',,' SPECIFIED BUT DATA SET ',,' NOT *
               A PARTITIONED DATA SET'),05L
*
AT    IKJTSMSG ('IKJ56265I I/O SYNAD ERROR ',),05D,R2
*
*
*
AY    IKJTSMSG ('IKJ56287I JOB ',,' NOT SUBMITTED - INVALID ENTRY CODE +
               FOR ',),12C                                      @Y02064
*
*
AZ    IKJTSMSG ('IKJ56288I ',,' FAILED - LOGON ACCOUNTING INFORMATION E+
               XCEEDS 142 CHARACTERS'),04A
*
*
BA    IKJTSMSG ('IKJ56289I ',,' FAILED - LOGON ACCOUNTING INFORMATION W+
               ON''T FIT ON JOB STATEMENT'),04B
*
*
LAST  IKJTSMSG
         MODID BRANCH=NO
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                                     *
*       SUBMIT MESSAGE TEXTS, DETECTOR MODULES, AND DESCRIPTIONS      *
*                                                                     *
*         < > INDICATES AN INSERTION                                  *
*                                                                     *
*         MOST OF THESE DESCRIPTIONS ARE EXPANSIONS OF THE            *
*         DESCRIPTIONS IN THE TSO TERMINAL MESSAGES SRL.              *
*                                                                     *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56250I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            JOB <JOBNAME(JOBID)> SUBMITTED
*
*    EXPLANATION-
*      THE JOB HAS BEEN ENTERED INTO THE BACKGROUND FOR BATCH
*      PROCESSING.
*
*      JOBNAME IS THE NAME OF THE JOB ON THE JOB CARD AND JOBID IS
*      THE UNIQUE JOB IDENTIFIER ASSIGNED BY THE JOB ENTRY SUBSYSTEM.
*    SYSTEM ACTION-
*      NONE.
*    USER RESPONSE-
*      NONE.
*
*
*  IKJ56251I IKJEFF01   IKJEFF02   IKJEFF03   SUBMIT
*            IKJEFF56   IKJEFF02   IKJEFF55   CANCEL/STATUS
*
*            <COMMANDNAME> COMMAND NOT AUTHORIZED+
*              YOUR INSTALLATION MUST AUTHORIZE USE OF THIS COMMAND
*
*    EXPLANATION-
*      THE MESSAGE IS IN RESPONSE TO THE INSERTED COMMAND NAME AND
*      INDICATES THAT THE USER IS NOT AUTHORIZED TO USE THE
*      FOREGROUND INITIATED BACKGROUND (FIB) COMMANDS:  CANCEL,
*      OUTPUT, STATUS, AND SUBMIT.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      ASK YOUR INSTALLATION MANAGER TO AUTHORIZE YOU FOR JCL ABILITY.
*
*
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56252I IKJEFF04   IKJEFF02   IKJEFF03   SUBMIT
*            IKJEFF16
*
*            COMMAND SYSTEM ERROR - <SERVICEROUTINE>
*            ERROR CODE <NNN>
*
*    EXPLANATION-
*      FOR THE 'SWA MANAGER' INSERT, THE RETURN CODE TO IKJEFF04
*      WAS NON-ZERO FROM A REQUEST FOR THE JCT OR ACT CONTROL
*      BLOCK'S ADDRESS.
*
*      FOR THE 'DEFAULT' INSERT THERE WAS A RETURN CODE OTHER THAN
*      0, 4, 8, 16, 20, OR 36 TO IKJEFF17 FROM IKJDFLT SERVICE
*      ROUTINE (CSECT IKJEFF17 IS IN ASSEMBLY MODULE IKJEFF16).
*
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      RETRY THE COMMAND, THEN IF ERROR CONTACT YOUR SYSTEM
*      PROGRAMMER.
*
*
*  IKJ56253A IKJEFF13   IKJEFF02   IKJEFF03   SUBMIT
*
*            ENTER JOBNAME CHARACTER+ -
*              JOBNAME IS CREATED FROM USERID PLUS ONE ALPHANUMERIC
*              OR NATIONAL CHARACTER
*
*    EXPLANATION-
*      SUBMIT COMMAND PROMPTS FOR A CHARACTER TO COMPLETE THE JOB
*      NAME IF THE JOBNAME CONSISTS OF USERID ONLY.  IT ALSO
*      PROMPTS IF A JOB STATEMENT MUST BE GENERATED.
*    SYSTEM ACTION-
*      WAIT FOR USER REPLY.
*    USER RESPONSE-
*      TYPE ONE CHARACTER OR HIT ATTENTION TO TERMINATE SUBMIT COMMAND.
*
         EJECT
*
*
*  IKJ56255A IKJEFF13   IKJEFF02   IKJEFF03   SUBMIT
*
*            REENTER+ -
*              CHARACTER MUST BE ALPHANUMERIC OR NATIONAL
*
*    EXPLANATION-
*      SUBMIT COMMAND NEEDS A REPLY OF ONE ALPHANUMERIC OR NATIONAL
*      CHARACTER TO COMPLETE THE JOBNAME, WHICH CURRENTLY CONSISTS
*      OF THE USERID.  THE REPLY TO MESSAGE IKJ56253A WAS INCORRECT.
*    SYSTEM ACTION-
*      WAIT FOR USER REPLY.
*    USER RESPONSE-
*      TYPE ONE VALID CHARACTER OR HIT ATTENTION TO TERMINATE SUBMIT
*      COMMAND.
*
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56255I IKJEFF13   IKJEFF02   IKJEFF03   SUBMIT
*
*            INVALID CHARACTER - <C>
*
*    EXPLANATION-
*      AN INVALID CHARACTER, C, WAS ENTERED IN RESPONSE TO PROMPT
*      MESSAGE IKJ56253A.  THE CHARACTER MUST BE ALPHANUMERIC OR
*      NATIONAL.  THIS MESSAGE IS FOLLOWED BY MESSAGE IKJ56255A.
*    SYSTEM ACTION-
*      NONE
*    USER RESPONSE-
*      NONE
*
*  IKJ56256I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            <COMMANDNAME> TERMINATED ON JOB <JOBNAME>
*
*    EXPLANATION-
*      AN ERROR HAS OCCURRED IN PROCESSING THE JOBNAME, AND THAT
*      JOB ALONG WITH ANY REMAINING JOBS HAS NOT BEEN SUBMITTED.
*      MESSAGE IKJ56291I IS ALSO ISSUED TO DESCRIBE THE SUBMIT OUTPUT
*      DATA SET ERROR.  COMMANDNAME IS SUBMIT'S NAME AS ENTERED.
*     SYSTEM ACTION-
*      THE COMMAND IS TERMINATED AFTER MESSAGE IKJ56285I.
*    USER RESPONSE-
*      RESUBMIT THE JOB.  IF THE ERROR REOCCURS, CALL YOUR SYSTEM
*      PROGRAMMER.
*
*
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56257I IKJEFF13   IKJEFF02   IKJEFF03   SUBMIT
*
*            MISSING JOBNAME CHARACTER AND UNABLE TO PROMPT
*
*    EXPLANATION-
*      SUBMIT COMMAND ISSUES THIS MESSAGE AFTER TRYING TO ISSUE
*      PROMPTING MESSAGE IKJ56253A, WHICH HAD A NON-ZERO PUTGET
*      RETURN CODE.  THE JOBNAME MUST BE THE USERID PLUS ONE CHARACTER.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      THE PROBABLE CAUSE IS THAT THE USER IS IN NOPROMPT MODE OR
*      THE SUBMIT COMMAND IS IN A CLIST.  USE THE PROFILE COMMAND TO
*      CHANGE TO PROMPT MODE IF NOT USING A CLIST.  OTHERWISE, PUT
*      A COMPLETE JOB CARD IN THE DATA SET BEING SUBMITTED (SO
*      PROMPTING IS NOT NECESSARY) OR USE THE PROMPT KEYWORD WHEN
*      EXECUTING THE CLIST.
*
*
*  IKJ56259I IKJEFF01   IKJEFF02   IKJEFF03   SUBMIT
*            IKJEFF56   IKJEFF02   IKJEFF55   CANCEL/STATUS
*
*            <COMMAND> COMMAND ENDED DUE TO FIB SVC <MACRONAME> ERROR
*            CODE <NNN>+
*              RETRY COMMAND, THEN IF ERROR CALL YOUR SYSTEM PROGRAMMER
*
*    EXPLANATION-
*      THE MESSAGE IS IN RESPONSE TO THE INSERTED COMMAND NAME.  IT
*      INDICATES THAT A MACRO WAS ISSUED BY FIB (FOREGROUND INITIATED
*      BACKGROUND) SVC 100 AND THE MACRO ROUTINE FAILED WITH THE
*      INSERTED ERROR CODE. MACRONAME MAY TAKE THE VALUE OF ATTACH.
*
*      IF MACRONAME IS NOT INSERTED THE ERROR CODE IS FROM SVC 100 (OR
*      AN UNIDENTIFIED RETURN CODE FROM A MODULE ATTACHED BY SVC 100).
*
*      RETURN CODE 88 INDICATES INVALID INPUT TO THE SVC - EITHER AN
*      UNAUTHORIZED COMMAND CODE IN THE FIBID FIELD OF THE INPUT
*      PARAMETER LIST, OR AN INVALID POINTER TO THE PSCB CONTROL
*      BLOCK (JSCBPSCB POINTER^=CPPLPSCB POINTER), OR THE HIGH-
*      ORDER BIT ISN'T ON IN THE POINTER TO THE INPUT PARAMETER
*      LIST (REGISTER 1->POINTER->FIBPARMS).
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      SEE SECOND LEVEL MESSAGE.
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56260I            IKJEFF02   IKJEFF03   SUBMIT
*            IKJEFF05
*
*            INSUFFICIENT STORAGE TO EXECUTE <COMMANDNAME> COMMAND
*
*    EXPLANATION-
*      IKJEFF05 COULD NOT DO A GETMAIN FOR ENOUGH BUFFER SPACE
*      FOR A SUBMITTED DATA SET. COMMANDNAME IS SUBMIT'S NAME.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      LOGON IN A LARGER TSO REGION.
*
*
*  IKJ56261I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            RECORD LENGTH OF DATA SET <DSNAME> NOT 80
*
*    EXPLANATION-
*      THE DATA SET SUBMITTED DID NOT HAVE LOGICAL RECORDS OF 80
*      BYTES.  BLOCKSIZE NEED NOT BE 80, BUT LRECL MUST BE 80, SINCE
*      THE RECORDS ARE TREATED AS STANDARD JCL CARDS.  DATA POINTED
*      TO BY DD CARDS MAY BE IN OTHER TYPES OF DATA SETS.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      RECREATE THE JCL DATA SET WITH AN LRECL OF 80.  ALLOCATE
*      COMMAND MAY BE USED, OR EDIT A NEW CNTL TYPE DATA SET.
*
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56262I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            MEMBER <MEMBERNAME> NOT IN DATA SET <DSNAME>
*
*    EXPLANATION-
*      THE PARTITIONED DATA SET MEMBER SPECIFIED IN THE SUBMIT
*      COMMAND COULD NOT BE FOUND.  A FIND MACRO WAS ISSUED FOR
*      THE MEMBERNAME AFTER THE DSNAME WAS SUCCESSFULLY ALLOCATED,
*      AND A CODE OF 4 WAS RETURNED.
*
*      ISSUE A LISTDS COMMAND FOR THE DSNAME, WITH MEMBER OPTION.
*      THIS WILL TELL WHAT MEMBERS ARE IN THE DATA SET AND THE
*      SUBMIT COMMAND CAN BE REISSUED WITH THE CORRECT MEMBER NAME.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      ISSUE A LISTDS COMMAND FOR THE DSNAME, WITH MEMBER OPTION.
*      THIS WILL TELL WHAT MEMBERS ARE IN THE DATA SET AND THE
*      SUBMIT COMMAND CAN BE REISSUED WITH THE CORRECT MEMBER NAME.
*
*
*  IKJ56263I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            RECORD FORMAT FOR DATA SET <DSNAME> NOT FIXED
*
*    EXPLANATION-
*      THE DATA SET BEING SUBMITTED DID NOT HAVE A RECORD
*      FORMAT OF FIXED OR FIXED BLOCKED.  ALL JCL MUST BE IN A
*      FIXED/FIXED BLOCKED DATA SET, BUT DATA POINTED TO BY DD
*      CARDS CAN BE IN OTHER TYPES OF DATA SETS.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      RECREATE THE DATA SET WITH A RECFM=F OR FB.  THE ALLOCATE
*      COMMAND MAY BE USED, OR EDIT A NEW DATA SET WITH CNTL AS
*      THE DATA SET TYPE.
*
*
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56265I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            INPUT DATA SET <DSNAME> NOT USABLE+
*              CANNOT OPEN DATA SET
*
*    EXPLANATION-
*      THE OPEN FAILED FOR THE INDICATED SUBMITTED DATA SET.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      CORRECT THE PROBLEM WITH THE DATA SET.
*
*            INPUT DATA SET <DSNAME> NOT USABLE+
*              FIND I/O ERROR
*
*    EXPLANATION-
*      THE FIND FOR THE INDICATED MEMBER OF THE SUBMITTED DATA
*      SET FAILED WITH A RETURN CODE OF 8.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      RETRY THE COMMAND, THEN IF STILL FAILING, RECREATE THE
*      MEMBER OR CALL YOUR SYSTEM PROGRAMMER.
*
*            INPUT DATA SET <DSNAME> NOT USABLE+
*              I/O SYNAD ERROR <XXXX>
*
*    EXPLANATION-
*      THE SYNAD EXIT WAS ENTERED DURING I/O FOR THE INDICATED
*      SUBMITTED DATA SET.  XXXX IS THE SYNADAF I/O ERROR INFORMATION.
*
*      THE FORMAT OF THE SYNADAF DATA SET IS DESCRIBED UNDER THE
*      SYNADAF MACRO IN THE 'OS/VS DATA MANAGEMENT MACRO INSTRUCTIONS'
*      PUBLICATION.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      RETRY THE COMMAND, THEN IF STILL FAILING, RECREATE THE
*      MEMBER OR DATA SET, OR CALL YOUR SYSTEM PROGRAMMER.
*
*
         EJECT
*
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56266I IKJEFF09   IKJEFF02   IKJEFF03   SUBMIT
*
*            UNABLE TO DIAGNOSE EXIT RETURN CODE <NNNN>
*
*    EXPLANATION-
*      THE SUBMIT INSTALLATION EXIT (IKJEFF10) RETURNED AN UNEXPECTED
*      RETURN CODE IN REGISTER 15.  DEFINED RETURN CODES ARE 0, 4,
*      8, 12, AND 16.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      HAVE YOUR SYSTEM PROGRAMMER CORRECT THE LOGIC IN IKJEFF10.
*
*
*  IKJ56268I IKJEFF16   IKJEFF02   IKJEFF03   SUBMIT
*
*            INVALID DATA SET NAME <DSNAME>, EXCEEDS
*            44 CHARACTERS
*
*    EXPLANATION-
*      AFTER THE APPROPRIATE QUALIFIERS WERE ADDED TO THE NAME
*      OF THE DATA SET TO BE SUBMITTED, THE NAME EXCEEDED THE
*      OS/VS2 LIMIT OF 44 CHARACTERS.  THIS SITUATION IS
*      DETECTED IN CSECT IKJEFF17 OF ASSEMBLY MODULE IKJEFF16.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      CORRECT THE DATA SET NAME.  IF IT IS NOT A TSO NAME,
*      ENTER IT ENCLOSED IN APOSTROPHES.
*
*
         EJECT
*
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56269I IKJEFF16   IKJEFF02   IKJEFF03   SUBMIT
*
*            DATA SET <DSNAME> NOT IN CATALOG
*
*    EXPLANATION-
*      THE NAME OF THE DATA SET TO BE SUBMITTED IS NOT IN THE SYSTEM
*      CATALOG.  THE IKJDFLT (DEFAULT) SERVICE ROUTINE DETECTED THIS
*      ERROR AFTER THE TSO USERID WAS ADDED TO THE UNQUALIFIED
*      INPUT DATA SET NAME.  IKJEFF17 IS THE CSECT IN ASSEMBLY
*      MODULE IKJEFF16 WHICH CALLS IKJDFLT AND DETECTS THE ERROR
*      CONDITION.
*
*      USE THE LISTCAT COMMAND TO FIND WHAT DATA SETS ARE
*      CATALOGED UNDER YOUR IDENTIFICATION QUALIFIER.  (USUALLY
*      THIS IS YOUR TSO USERID).
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      CATALOG THE DATA SET.
*
*
*  IKJ56272I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            ORGANIZATION OF DATA SET <DSNAME> NOT SEQUENTIAL
*            OR PARTITIONED
*
*    EXPLANATION-
*      THE INDICATED DATA SET THAT WAS SUBMITTED DOES NOT HAVE THE
*      PROPER DATA SET ORGANIZATION (DSORG=PS OR DSORG=PO).  ALL
*      JCL MUST BE IN A SEQUENTIAL OR PARTITIONED DATA SET, BUT
*      DATA POINTED TO BY DD CARDS MAY BE IN OTHER TYPES OF
*      DATA SETS.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      PLACE JCL TO BE SUBMITTED IN A SEQUENTIAL OR PARTITIONED
*      DATA SET.
*
*
         EJECT
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56273I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*
*            MEMBER <MEMBERNAME> SPECIFIED BUT DATA SET <DSNAME>
*            NOT A PARTITIONED DATA SET
*
*    EXPLANATION-
*      THE SUBMITTED DATA SET IS SEQUENTIAL, SO IT MAY NOT HAVE
*      A MEMBER SPECIFIED ON THE SUBMIT COMMAND.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      SUBMIT JUST THE DATA SET, WITHOUT MEMBER NAME.
*
*
*  IKJ56280A IKJEFF09   IKJEFF02   IKJEFF03   SUBMIT
*
*            <EXITMESSAGE>+
*              ENTER REPLY FOR EXIT -
*
*    EXPLANATION-
*      THE INSERTED MESSAGE TEXT IS SUPPLIED BY THE SUBMIT
*      INSTALLATION EXIT (IKJEFF10) AND IT PROMPTS THE USER
*      FOR A REPLY.
*    SYSTEM ACTION-
*      WAIT FOR REPLY.
*    USER RESPONSE-
*      REPLY TO THE EXIT'S PROMPT MESSAGE OR HIT ATTENTION TO
*      TERMINATE THE SUBMIT COMMAND.
*
*
*  IKJ56282I IKJEFF09   IKJEFF02   IKJEFF03   SUBMIT
*
*            <COMMANDNAME> COMMAND FAILED - UNABLE TO PROMPT USER+
*              MISSING REPLY FOR <EXITMESSAGE> FROM EXIT
*
*    EXPLANATION-
*      SUBMIT COMMAND WAS UNABLE TO ISSUE PROMPTING MESSAGE
*      IKJ56280A BECAUSE THE USER IS IN NOPROMPT MODE OR THE SUBMIT
*      COMMAND WAS EXECUTED IN A CLIST AND THE PROMPT KEYWORD WAS
*      NOT USED.  THE PUTGET MACRO RETURNED A CODE OF 12.
*      EXITMESSAGE IS 80 CHARACTERS OF THE EXIT'S INSERT FOR MESSAGE
*      IKJ56280A.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      USE THE PROFILE COMMAND TO CHANGE TO PROMPT MODE IF NOT USING
*      A CLIST.  OTHERWISE, EXECUTE THE CLIST WITH PROMPT SPECIFIED.
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56283I IKJEFF09   IKJEFF02   IKJEFF03   SUBMIT
*
*            <EXITMESSAGE>
*
*    EXPLANATION-
*      THE INSERTED MESSAGE TEXT IS SUPPLIED BY THE SUBMIT
*      INSTALLATION EXIT (IKJEFF10).  THE EXIT WILL USE A
*      RETURN CODE TO TELL SUBMIT WHETHER TO TERMINATE OR
*      CONTINUE EXECUTION AFTER THE MESSAGE HAS BEEN ISSUED.
*    SYSTEM ACTION-
*      DETERMINED BY EXIT'S RETURN CODE.
*    USER RESPONSE-
*      NONE.
*
*  IKJ56284I IKJEFF02   IKJEFF02   IKJEFF02   SUBMIT
*
*      (THE DESCRIPTION AND TEXT FOR THIS MESSAGE ARE IN
*      MODULE IKJEFF02)
*
*
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56287I IKJEFF05   IKJEFF02   IKJEFF03   SUBMIT
*            IKJEFF15
*
*            JOB <JJJ> NOT SUBMITTED - INVALID ENTRY CODE FOR
*            <MODULENAME>
*
*    EXPLANATION-
*      THE MESSAGE IS IN RESPONSE TO THE SUBMIT COMMAND AND
*      INDICATES AN INTERNAL PROGRAM LOGIC ERROR.
*
*      JJJ IS THE LAST JOBNAME BEING PROCESSED, AND IT MUST
*      BE RESUBMITTED.
*
*      MODULENAME CAN BE IKJEFF05 OR IKJEFF15.
*      IKJEFF05 (CODE SEGMENT IKJEFF12) WILL ONLY
*      ACCEPT A VALUE OF 2 OR 3 IN THE HTCODE FIELD OF
*      THE SUBMIT HISTORY TABLE.  IKJEFF15 WILL ACCEPT 1 OR 4.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      CALL YOUR SYSTEM PROGRAMMER.  IF YOU HAVE MODIFIED A
*      MODULE WHICH CALLS IKJEFF05 OR 15, DOUBLECHECK THE
*      VALUE IN HTCODE.
*
*
*  IKJ56288I IKJEFF04   IKJEFF02   IKJEFF03   SUBMIT
*
*            <COMMANDNAME> FAILED - LOGON ACCOUNTING INFORMATION
*            EXCEEDS 142 CHARACTERS
*
*    EXPLANATION -
*      MODULE IKJEFF04 COMPUTED THE TSO USER'S
*      ACCOUNTING INFORMATION TO HAVE A LENGTH GREATER THAN
*      142.  IKJEFF04 REFERENCES ACCOUNT FIELDS IN THE ACCOUNT
*      CONTROL TABLE (ACT) CREATED WHEN THE USER LOGGED ON TO TSO
*      IN ORDER TO RECREATE THE ACCOUNTING INFORMATION IN JOB
*      CARD FORMAT.
*
*      THE ACCOUNTING INFORMATION LENGTH IS A MAXIMUM OF 142, AS
*      STATED IN THE JCL REFERENCE SRL.  SUBMIT MODULES IKJEFF08
*      AND IKJEFF09 USE THE ACCOUNTING INFORMATION, AND EXPECT
*      THE ABOVE LIMIT.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      CALL YOUR SYSTEM PROGRAMMER.
         EJECT
*
*  MESSAGE   DETECTED   ISSUED     LOCATED    PROGRAM
*    ID         IN        BY         IN
*
*  IKJ56289I IKJEFF04   IKJEFF02   IKJEFF03   SUBMIT
*            IKJEFF08
*
*            <COMMANDNAME> FAILED - LOGON ACCOUNTING INFORMATION
*            WON'T FIT ON JOB STATEMENT
*
*    EXPLANATION-
*      IF SUBMIT GENERATES A JOB STATEMENT, IT CAN
*      INSERT 54 CHARACTERS, FOLLOWED BY A COMMA, ON THE JOB CARD
*      AND 67 CHARACTERS ON EACH OF TWO CONTINUATION CARDS.  THUS
*      THE ACCOUNTING INFORMATION, RECREATED FROM THE ACCOUNT
*      CONTROL TABLE (ACT) CONTROL BLOCK FOR THE USER, MAY BE UP
*      TO 190 CHARACTERS IN LENGTH (COUNTING TWO COMMAS USED AS
*      BREAKING POINTS FOR INSERTS).  IF THERE ARE TOO FEW COMMAS
*      BETWEEN FIELDS IT MAY BE IMPOSSIBLE TO CREATE TWO OR THREE
*      INSERTS OF THE CORRECT LENGTH, HOWEVER.
*    SYSTEM ACTION-
*      THE COMMAND IS TERMINATED.
*    USER RESPONSE-
*      CALL YOUR SYSTEMS PROGRAMMER.
*
*
*  NOTE - THE DESCRIPTIONS FOR MESSAGES IKJ56291I - IKJ56299I ARE
*         IN VSAMFAIL MODULE IKJEFF19 (IN MESSAGE CSECT IKJEFF21).
*
*
*  IKJ56700A IKJPARS    IKJPARS    IKJEFF16   SUBMIT
*
*            ENTER DATA SET NAME+
*              ENTER NAME OF DATA SET CONTAINING JCL
*
*    EXPLANATION-
*      THE PARSE SERVICE ROUTINE IS PROMPTING THE USER BECAUSE
*      THE SUBMIT COMMAND IS INVALID AS ENTERED.  EITHER NO
*      DATA SET NAME WAS SPECIFIED OR IT IS INVALID.  SUBMIT
*      SUPPLIES THE TEXT OF THE SECOND LEVEL MESSAGE AS A
*      PARSE PCL IN CSECT IKJEFF16 OF ASSEMBLY MODULE IKJEFF16.
*    SYSTEM ACTION-
*      WAIT FOR REPLY.
*    USER RESPONSE-
*      REPLY WITH A DATA SET NAME OR HIT ATTENTION TO TERMINATE
*      THE SUBMIT COMMAND.
*
*
         END
