    TITLE  'IKJEFH00'
**********************************************************************
*                                                                    *
*             IKJEFH00 - MESSAGE CSECT                               *
*                                                                    *
* STATUS                                                             *
*    CHANGE LEVEL 000                                                *
*                                                                    *
* FUNCTION                                                           *
*    THIS MODULE CONTAINS ALL OF THE MESSAGES FOR THE                *
*    HELP CP EXCEPT FOR THOSE ISSUED IN RESPONSE TO DAIR             *
*    RETURN CODES.  THE MESSAGES ARE CODED USING THE 'IKJTSMSG'      *
*    MACRO AND ARE PROCESSED BY MODULE IKJEFF02.  (SEE SUBMIT        *
*    CP FOR IKJEFF02 AND FOR IKJEFF18 FOR DAIR MESSAGES)             *
*                                                                    *
* ENTRY POINTS                                                       *
*         IKJEFH00 - IKJEFF02 SEARCHES                               *
*         FOR THE MESSAGE TEXT TO BE PUT OUT TO THE TERMINAL.        *
*                                                                    *
* INPUT                                                              *
*    NONE                                                            *
*                                                                    *
* OUTPUT                                                             *
*    NONE                                                            *
*                                                                    *
* EXTERNAL REFERENCES                                                *
*         NONE                                                       *
*                                                                    *
* EXITS,NORMAL                                                       *
*         NONE                                                       *
*                                                                    *
* EXITS,ERROR                                                        *
*         NONE                                                       *
*                                                                    *
* TABLES/WORK AREAS                                                  *
*    NONE                                                            *
*                                                                    *
* ATTRIBUTES                                                         *
*    REENTRANT AND REFRESHABLE                                       *
*                                                                    *
* NOTES                                                              *
*    MESSAGE IDENTIFICATION                                          *
*             MOST HELP ERROR  MESSAGES  ARE  MULTI-LEVEL.   THE     *
*        FIRST  LEVEL INDICATES AN ERROR OCCURED IN HELP AND THE     *
*        SECOND (ISSUED IN RESPONSE  TO  A  '?')  GIVES  A  MORE     *
*        DETAILED  DESCRIPTION  OF  THE  FAILURE.  THE FOLLOWING     *
*        LISTS EACH FIRST LEVEL HELP  MESSAGE  AND  ITS  RELATED     *
*        SECOND LEVEL MESSAGE, IF ANY.  THE FIRST DIGIT OF THE       *
*        IDENTIFIER IS THE LAST DIGIT OF THE NAME OF THE ISSUING     *
*        MODULE.  EXCEPTION - 100A IS ISSUED BY MODULES 1 & 3.       *
*        MESSAGE 200Z IS A DUMMY MESSAGE USED TO PUT OUT HELP DATA.  *
*                                                                    *
*              FIRST LEVEL MESSAGE_______SECOND LEVEL MESSAGE        *
*                   IDENTIFIER                IDENTIFIER             *
*                                                                    *
*                      200Z                                          *
*                      100A                     100B                 *
*                                               100C                 *
*                                               300D                 *
*                                               100E                 *
*                                               100T                 *
*                      100F                     100G                 *
*                                               100H                 *
*                                               100I                 *
*                                               100K                 *
*                                               100L                 *
*                                               100M                 *
*                      100N                                          *
*                      100O                                          *
*                      100P                                          *
*                      100Q                                          *
*                      100R                     100S                 *
*                                                                    *
*                                                                    *
*    MESSAGES TO THE TERMINAL                                        *
*                                                                    *
*                 TERMINAL MESSAGE NUMBERS ASSIGNED TO HELP          *
*                            IKJ56800 - IKJ56849                     *
*                                                                    *
*                 IKJ56801I  HELP DATA SET NOT USABLE+               *
*                 IKJ56801I  CANNOT OPEN DATA SET                    *
*                 IKJ56801I  FIND I/O ERROR                          *
*                 IKJ56801I  I/O SYNAD ERROR 'SYNAD INFO'            *
*                 IKJ56801I  LOGICAL RECORD LENGTH NOT 80            *
*                 IKJ56801I  HELP REQUIRES A PARTITIONED DATA SET    *
*                 IKJ56802I  HELP NOT AVAILABLE+                     *
*                 IKJ56802I  COMMAND 'CHARSTRING' NOT FOUND,         *
*                            FOR MORE HELP ENTER HELP                *
*                 IKJ56802I  COMMAND 'CHARSTRING' NOT FOUND          *
*                 IKJ56802I  LIST OF COMMANDS NOT FOUND              *
*                 IKJ56802I  SUBCOMMAND HELP NOT FOUND               *
*                 IKJ56802I  SUBCOMMAND 'CHARSTRING' NOT FOUND,      *
*                            FOR MORE HELP ENTER HELP                *
*                 IKJ56802I  'COMMANDNAME' SUBCOMMAND LIST NOT       *
*                            FOUND                                   *
*                 IKJ56803I  FOR MORE INFORMATION ENTER HELP         *
*                            COMMANDNAME OR HELP HELP                *
*                 IKJ56804I  FOR MORE INFORMATION ENTER HELP         *
*                            SUBCOMMANDNAME OR HELP HELP             *
*                 IKJ56805I  'COMMANDNAME'/'SUBCOMMANDNAME'          *
*                            'OPERAND IDENTIFIER' NOT FOUND          *
*                 IKJ56806I  'COMMANDNAME'/'SUBCOMMANDNAME'          *
*                            'KEYWORD' KEYWORD NOT FOUND             *
*                 IKJ56807I  COMMAND SYSTEM ERROR+                   *
*                            'SERVICE ROUTINE' ERROR CODE 'CODE'     *
*                                                                    *
*    CHARACTER CODE DEPENDENCY -                                     *
*    EBCDIC CHARACTER SET USED IN ASSEMBLING.                        *
*    MODULE MUST BE REASSEMBLED IF A DIFFERENT CHARACTER SET IS USED.*
*                                                                    *
**********************************************************************
IKJEFH00 CSECT
M200Z IKJTSMSG (,' '),200Z
M100A IKJTSMSG ('IKJ56801I HELP DATA SET NOT USABLE+'),100A
M100B IKJTSMSG ('IKJ56801I CANNOT OPEN DATA SET'),100B,100A
M100C IKJTSMSG ('IKJ56801I FIND I/O ERROR'),100C,100A
M300D IKJTSMSG ('IKJ56801I I/O SYNAD ERROR ',),300D,100A
M100E IKJTSMSG ('IKJ56801I LOGICAL RECORD LENGTH NOT 80'),100E,100A
M100F IKJTSMSG ('IKJ56802I HELP NOT AVAILABLE+'),100F
M100G IKJTSMSG ('IKJ56802I COMMAND ',,' NOT FOUND, FOR MORE HELP ENTER X
               HELP'),100G,100F
M100H IKJTSMSG ('IKJ56802I COMMAND ',,' NOT FOUND'),100H,100F
M100I IKJTSMSG ('IKJ56802I LIST OF COMMANDS NOT FOUND'),100I,100F
M100K IKJTSMSG ('IKJ56802I SUBCOMMAND ',,' NOT FOUND, FOR MORE HELP ENTX
               ER HELP'),100K,100F
M100L IKJTSMSG ('IKJ56802I SUBCOMMAND HELP NOT FOUND'),100L,100F
M100M IKJTSMSG ('IKJ56802I ',,' SUBCOMMAND LIST NOT FOUND'),100M,100F
M100N IKJTSMSG ('IKJ56803I FOR MORE INFORMATION ENTER HELP COMMANDNAME X
               OR HELP HELP'),100N
M100O IKJTSMSG ('IKJ56804I FOR MORE INFORMATION ENTER HELP SUBCOMMANDNAX
               ME OR HELP HELP'),100O
M100P IKJTSMSG ('IKJ56805I ',,' ',,' NOT FOUND'),100P
M100Q IKJTSMSG ('IKJ56806I ',,' ',,' KEYWORD NOT FOUND'),100Q
M100R IKJTSMSG ('IKJ56807I COMMAND SYSTEM ERROR+'),100R
M100S IKJTSMSG ('IKJ56807I ',,' ERROR CODE ',),100S,100R
M100T IKJTSMSG ('IKJ56801I HELP REQUIRES A PARTITIONED DATA SET'),100T,X
               100A
M100U IKJTSMSG ('IKJ56808I MSGID CONFLICTS WITH OTHER ENTERED KEYWORDS'X
               ),100U
      IKJTSMSG
         END
