         TITLE 'IKJEFLPA -- TOD && DATE TEXT PREPARATION'
*         GENERATE;
FLPA     TITLE 'IKJEFLPA -- TOD && TEXT PREPARATION -- MODULE PROLOGUE *
               && SPECIFICATIONS'
         LCLA  &T,&SPN,&LDAY(12),&I,&LNDESCR
         LCLC  &LUPDAT
&SPN     SETA  1  OBTAIN DYNAMIC AREA FROM SUBPOOL 1
&LUPDAT  SETC  '70166' DATE OF LAST MODULE UPDATE
IKJEFLPA  START 0  FORCE ASSIGNMENT OF ADDRESSES TO IKJEFLPA FIRST
* /*******************************************************************/
* /*                                                                 */
* /* STATUS --                                                       */
* /*    RELEASE 20, MODIFICATION LEVEL 01                            */
* /*    A 0-999999                                            S20032 */
* /*    C                                                      21974 */
* /*                                                                 */
* /* FUNCTION --                                                     */
* /*    THIS MODULE ACCEPTS TWO BUFFERS AS INPUT AND FORMATS THE TWO */
* /*    INTO THE FORM OF TEXT INSERTION BUFFERS CONTAINING THE TIME  */
* /*    OF DAY IN THE FORMAT 'HH:MM:SS' AND THE DATE IN THE FORMAT   */
* /*    'MONTH DAY, YEAR'                                            */
* /*                                                                 */
* /* ENTRY POINTS --                                                 */
* /*         IKJEFLPA                                                */
* /*                                                                 */
* /* INPUT --                                                        */
* /*    R1 = THE ADDRESS OF A TYPE I PARAMETER LIST CONSISTING OF TWO*/
* /*         POINTERS, THE FIRST OF WHICH MUST CONTAIN THE ADDRESS OF*/
* /*         A WRITABLE BUFFER AT LEAST 22 BYTES IN LENGTH; THIS     */
* /*         BUFFER IS KNOWN AS THE TIME-OF-DAY OR TOD BUFFER WITHIN */
* /*         THIS MODULE.  THE SECOND POINTER MUST CONTAIN THE       */
* /*         ADDRESS OF A WRITABLE BUFFER AT LEAST 22 BYTES IN       */
* /*         LENGTH; THIS BUFFER IS KNOWN AS THE DATE BUFFER WITHIN  */
* /*         THIS MODULE.                                            */
* /*    R13 = THE ADDRESS OF A 72-BYTE SAVE AREA                     */
* /*    R14 = THE ADDRESS TO WHICH CONTROL SHOULD BE RETURNED        */
* /*    R15 = THE ADDRESS OF THE ENTRY POINT OF IKJEFLPA             */
* /*                                                                 */
* /* OUTPUT --                                                       */
* /*    R1 = ADDRESS OF INPUT PARAMETER LIST. THE TOD BUFFER HAS BEEN*/
* /*         PROVIDED WITH A LENGTH FIELD AND TEXT DESCRIBING THE    */
* /*         TIME OF DAY, AND THE DATE BUFFER HAS BEEN PROVIDED WITH */
* /*         A LENGTH FIELD AND TEXT DESCRIBING THE DATE.            */
* /*    R13 = THE SAME VALUE AS ON INPUT                             */
* /*    R14 = THE SAME VALUE AS ON INPUT                             */
* /*    R15 = THE SAME VALUE AS ON INPUT                             */
* /*                                                                 */
* /* EXTERNAL REFERENCES --                                          */
* /*         NONE                                                    */
* /*                                                                 */
* /* EXITS, NORMAL --                                                */
* /*         INVOKER                                                 */
* /*                                                                 */
* /* EXITS, ERROR --                                                 */
* /*         NONE                                                    */
* /*                                                                 */
* /* TABLE/WORK AREAS --                                             */
* /*         NONE                                                    */
* /*                                                                 */
* /* ATTRIBUTES --                                                   */
* /*         REENTRANT, REFRESHABLE                                  */
* /*                                                                 */
* /* NOTES --                                                        */
* /*    SEE THE FOLLOWING SPECIFICATIONS FOR A MORE DETAILED         */
* /*    DESCRIPTION OF THE MODULE.  THIS MODULE IS CHARACTER CODE    */
* /*    DEPENDENT ON THE INTERNAL CONFIGURATION OF THE EBCDIC        */
* /*    CHARACTERS.  REASSEMBLY IS NECESSARY IF A DIFFERENT          */
* /*    CHARACTER SET IS TO BE USED DURING EXECUTION.                */
* /*                                                                 */
* /*******************************************************************/
* /* START OF SPECIFICATIONS ****
*1MODULE-NAME = IKJEFLPA
*  2PROCESSOR = BSL
** THE RELEASE FOR WHICH THIS MODULE WAS MOST RECENTLY UPDATED
*1STATUS = 20 MODIFICATION LEVEL 00
*1DESCRIPTIVE-NAME = TOD & TEXT PREPARATION
*1DESCRIPTION = THIS MODULE ACCEPTS TWO BUFFERS AS INPUT AND FORMATS -
*THE TWO INTO THE FORM OF TEXT INSERTION BUFFERS CONTAINING THE TIME -
*OF DAY IN THE FORMAT 'HH:MM:SS' AND THE DATE IN THE FORMAT 'MONTH   -
*DAY, YEAR'
*1ASSUMPTIONS = OS/360 OPERATING ENVIRONMENT
*1FUNCTION = SEE DESCRIPTION
*1MODULE-TYPE = PROCEDURE
*1MODULE-SIZE = 1024 BYTES
*1CODE-ATTRIBUTES = REENTERABLE
*1LOAD-ATTRIBUTES = SCATTER, REFRESHABLE
*1ENTRY-POINT = IKJEFLPA
*  2LINKAGE = LINK
*  * THE FOLLOWING DESCRIBES THE REQUIRED INPUT TO THIS MODULE.
*  * DATA MADE AVAILABLE THROUGH THE STANDARD INVOCATION SEQUENCE
*  * BUT NOT USED IN ANY WAY IS NOT NECESSARILY MENTIONED HERE.
*  2PARAMETER-RECEIVED = POINTER-TO-PARAMETER-LIST
*  2HOW-PASSED = REGISTER 1
*  2LENGTH-OF-LIST = 8 BYTES
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = PARAM1
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 0 BYTES
*      4TYPE = ADDRESS
*      4ADDRESS-LENGTH = 32 BITS
*      4ADDRESS-OF = TOD
*        5REFERENCE-TYPE = WRITE
*        5TYPE-ADDRESSED = TABLE
*        5PURPOSE = PROVIDE ADDRESSIBILITY TO A BUFFER TO BE         -
*        FORMATTED INTO A TEXT INSERTION BUFFER CONTAINING THE TIME  -
*        OF DAY
*        5SCOPE = INTERNAL
*        5TABLE-SIZE = 12 BYTES
*        *************************************************************/
*        /*************************************************************
*        5FIELD = TODLEN
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 0 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = IGNORED ON INPUT.
*        *************************************************************/
*        /*************************************************************
*        5FIELD = TODOFF
*          6DISPLACEMENT = 2 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = IGNORED ON INPUT.
*        *************************************************************/
*        /*************************************************************
*        5FIELD = TODTXT
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 4 BYTES
*          6TYPE = CHARACTER STRING
*          6LENGTH+MODE = 8 CHARACTERS
*          6VALUE = IGNORED ON INPUT.
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = PARAM2
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 4 BYTES
*      4TYPE = ADDRESS
*      4ADDRESS-LENGTH = 32 BITS
*      4ADDRESS-OF = DATE
*        5REFERENCE-TYPE = WRITE
*        5TYPE-ADDRESSED = TABLE
*        5PURPOSE = PROVIDE ADDRESSIBILITY TO A BUFFER TO BE         -
*        FORMATTED INTO A TEXT INSERTION BUFFER CONTAINING THE DATE
*        5SCOPE = INTERNAL
*        5TABLE-SIZE = 22 BYTES
*        *************************************************************/
*        /*************************************************************
*        5FIELD = DATELEN
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 0 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = IGNORED ON INPUT.
*        *************************************************************/
*        /*************************************************************
*        5FIELD = DATEOFF
*          6DISPLACEMENT = 2 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = IGNORED ON INPUT.
*        *************************************************************/
*        /*************************************************************
*        5FIELD = DATETXT
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 4 BYTES
*          6TYPE = CHARACTER STRING
*          6LENGTH+MODE = 18 CHARACTERS
*          6VALUE = IGNORED ON INPUT.
**********************************************************************/
* /********************************************************************
*1EXIT = INVOKER
*  2CONDITIONS-WHEN-TAKEN = ALWAYS
*  2LINKAGE = RETURN
*  * THE FOLLOWING DESCRIBES THE OUTPUT OF THIS MODULE.
*  * DATA MADE AVAILABLE TO THE FOLLOWING MODULE AS A
*  * RESULT OF THE CURRENT IMPLEMENTATION BUT NOT GUARANTEED
*  * TO THAT MODULE IS NOT ENUMERATED.
*  2PARAMETER-RETURNED = POINTER-TO-PARAMETER-LIST
*  2HOW-PASSED = REGISTER 1
*  2LENGTH-OF-LIST = 8 BYTES
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = PARAM1
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 0 BYTES
*      4TYPE = ADDRESS
*      4ADDRESS-LENGTH = 32 BITS
*      4ADDRESS-OF = TOD
*        5REFERENCE-TYPE = WRITE
*        5TYPE-ADDRESSED = TABLE
*        5PURPOSE = DESCRIBE THE TIME OF DAY IN THE FORM 'HH:MM:SS'.
*        5REMARKS-ON-USE = THIS BUFFER IS IN SUITABLE CONDITION TO   -
*        BE USED AS A TEXT-INSERTION BUFFER EXCEPT FOR THE TODOFF    -
*        FIELD WHICH MAY BE SUPPLIED BY THE INVOKER EITHER BEFORE    -
*        OR AFTER INVOKING IKJEFLPA.
*        5SCOPE = INTERNAL
*        5TABLE-SIZE = 12 BYTES
*        *************************************************************/
*        /*************************************************************
*        5FIELD = TODLEN
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 0 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = 12
*        *************************************************************/
*        /*************************************************************
*        5FIELD = TODOFF
*          6DISPLACEMENT = 2 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = SAME AS ON INPUT.
*        *************************************************************/
*        /*************************************************************
*        5FIELD = TODTXT
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 4 BYTES
*          6TYPE = CHARACTER STRING
*          6LENGTH+MODE = 8 CHARACTERS
*          6VALUE = TIME OF DAY IN THE FORM 'HH:MM:SS'.
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = PARAM2
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 4 BYTES
*      4TYPE = ADDRESS
*      4ADDRESS-LENGTH = 32 BITS
*      4ADDRESS-OF = DATE
*        5REFERENCE-TYPE = WRITE
*        5TYPE-ADDRESSED = TABLE
*        5PURPOSE = DESCRIBE THE DATE IN THE FORM 'MONTH DAY, YEAR'.
*        5REMARKS-ON-USE = THIS BUFFER IS IN SUITABLE CONDITION TO   -
*        BE USED AS A TEXT-INSERTION BUFFER EXCEPT FOR THE DATEOFF   -
*        FIELD WHICH MAY BE SUPPLIED BY THE INVOKER EITHER BEFORE    -
*        OR AFTER INVOKING IKJEFLPA.
*        5SCOPE = INTERNAL
*        5TABLE-SIZE = 22 BYTES
*        *************************************************************/
*        /*************************************************************
*        5FIELD = DATELEN
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 0 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = LENGTH OF TEXT-INSERTION BUFFER CONTENTS.        -
*          15-22 BYTES
*        *************************************************************/
*        /*************************************************************
*        5FIELD = DATEOFF
*          6DISPLACEMENT = 2 BYTES
*          6TYPE = ARITHMETIC
*          6MODE = BINARY
*          6LENGTH = 15 BITS
*          6SIGN = SIGNED
*          6VALUE = SAME AS ON INPUT.
*        *************************************************************/
*        /*************************************************************
*        5FIELD = DATETXT
*          6REFERENCE-TYPE = WRITE
*          6DISPLACEMENT = 4 BYTES
*          6TYPE = CHARACTER STRING
*          6LENGTH+MODE = 18 CHARACTERS
*          6VALUE = DATE IN THE FORM 'MONTH DAY, YEAR'
**********************************************************************/
* /********************************************************************
*1EXTERNAL-MACRO = IEFDCL1
*  2PURPOSE = PROVIDE PRE-PROCESSOR VARIABLE DECLARATIONS
*  2PARAMETER-PASSED = NONE
**********************************************************************/
* /********************************************************************
*1EXTERNAL-MACRO = IEFDCL2
*  2PURPOSE = PROVIDE DECLARATIONS OF REGISTERS, A SAVEAREA, AND A   -
*  TYPE 1 PARAMETER LIST
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = REGISTER
*  2HOW-PASSED = KEYWORD
*  2TYPE = ARITHMETIC
*  2MODE = BINARY
*  2LENGTH = 31 BITS
*  2SIGN = SIGNED
*  2VALUE = 1. THIS CAUSES IEFDCL2 TO PROVIDE A MAPPING OF THE       -
*  GENERAL PURPOSE REGISTERS.
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = R0STAT
*  2HOW-PASSED = KEYWORD
*  2TYPE = CHARACTER STRING
*  2LENGTH+MODE = 32767 BYTES
*  2VALUE = 'RESTRICTED'
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = R1STAT
*  2HOW-PASSED = KEYWORD
*  2TYPE = CHARACTER STRING
*  2LENGTH+MODE = 32767 BYTES
*  2VALUE = 'RESTRICTED'
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = R4TYPE
*  2HOW-PASSED = KEYWORD
*  2TYPE = CHARACTER STRING
*  2LENGTH+MODE = 32767 BYTES
*  2VALUE = 'FIXED(15)'
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = R5TYPE
*  2HOW-PASSED = KEYWORD
*  2TYPE = CHARACTER STRING
*  2LENGTH+MODE = 32767 BYTES
*  2VALUE = 'FIXED(15)'
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = SAVEAREA
*  2HOW-PASSED = KEYWORD
*  2TYPE = ARITHMETIC
*  2MODE = BINARY
*  2LENGTH = 31 BITS
*  2SIGN = SIGNED
*  2VALUE = 1. THIS CAUSES IEFDCL2 TO PROVIDE A MAPPING OF A SAVEAREA.
*  *******************************************************************/
*  /*******************************************************************
*  2PARAMETER-PASSED = PARAM
*  2HOW-PASSED = KEYWORD
*  2TYPE = ARITHMETIC
*  2MODE = BINARY
*  2LENGTH = 31 BITS
*  2SIGN = SIGNED
*  2VALUE = 1. THIS CAUSES IEFDCL2 TO PROVIDE A MAPPING OF A TYPE I  -
*  PARAMETER LIST.
**********************************************************************/
* /********************************************************************
*1SYSTEM-MACROS = TIME, GETMAIN, FREEMAIN
*1INTERNAL-PROCEDURES = NONE
*
**** END OF SPECIFICATIONS ***/
*/*IKJEFLPA: CHART (DTYPE,AMODE,IBM68,NSAVE,NSEQ)                    */
*/*       HEADER
*/*IKJEFLPA -- TOD & DATE TEXT INSERTION BUFFER PREPARATION          */
*/*IKJEFLPA: E  BUFFER PREPARATION FUNCTION                          */
*         GENERATE;
IKJEFLPA CSECT
PA000100 B     PA000300-PA000100(0,R15)   BRANCH AROUND IDENTIFIER
** /*
         DC    AL1(L'PA000200)            LENGTH OF IDENTIFIER
** */
PA000200 DC    C'IKJEFLPA&LUPDAT' IDENTIFIER
PA000300 DS    0H                         BRANCH TARGET
         AGO   .@001
*IKJEFLPA:PROCEDURE/*(TOD, DATE)*/ OPTIONS(REENTRANT);
         LCLA  &T,&SPN                                            0003
.@001    ANOP                                                     0003
IKJEFLPA CSECT ,                                                  0003
         STM   @E,@C,12(@D)                                       0003
         BALR  @B,0                                               0003
@PSTART  DS    0H                                                 0003
         USING @PSTART+00000,@B                                   0003
         L     @0,@SIZ001                                         0003
         GETMAIN  R,LV=(0)                                        0003
         LR    @C,@1                                              0003
         USING @DATD+00000,@C                                     0003
         LM    @0,@1,20(@D)                                       0003
         XC    @TEMPS(@L),@TEMPS                                  0003
         ST    @D,@SAV001+4                                       0003
         LA    @F,@SAV001                                         0003
         ST    @F,8(0,@D)                                         0003
         LR    @D,@F                                              0003
*         GENERATE;
         TITLE     'IKJEFLPA -- TOD && DATE TEXT PREPARATION -- DEFINE *
               VARIABLES'
         DS    0H
*
*
* /*******************************************************************/
* /*      DEFINE THE GENERAL PURPOSE REGISTERS                       */
* /*******************************************************************/
* DECLARE
*         R0 POINTER(31) REGISTER(0) RESTRICTED,
*         /***********************************************************/
*         /*    STANDARD LINKAGE CONVENTION PARAMETER LIST POINTER   */
*         /***********************************************************/
*         R1 POINTER(31) REGISTER(1) RESTRICTED,
*         R2 POINTER(31) REGISTER(2) UNRESTRICTED,
*         R3 POINTER(31) REGISTER(3) UNRESTRICTED,
*         R4 FIXED(15) REGISTER(4) UNRESTRICTED,
*         R5 FIXED(15) REGISTER(5) UNRESTRICTED,
*         R6 POINTER(31) REGISTER(6) UNRESTRICTED,
*         R7 POINTER(31) REGISTER(7) UNRESTRICTED,
*         R8 POINTER(31) REGISTER(8) UNRESTRICTED,
*         R9 POINTER(31) REGISTER(9) UNRESTRICTED,
*         R10 POINTER(31) REGISTER(10) UNRESTRICTED,
*         R11 POINTER(31) REGISTER(11) UNRESTRICTED,
*         R12 POINTER(31) REGISTER(12) UNRESTRICTED,
*         /***********************************************************/
*         /*   STANDARD LINKAGE CONVENTION SAVE AREA POINTER         */
*         /***********************************************************/
*         R13 POINTER(31) REGISTER(13) UNRESTRICTED,
*         /***********************************************************/
*         /*   STANDARD LINKAGE CONVENTION RETURN POINTER            */
*         /***********************************************************/
*         R14 POINTER(31) REGISTER(14) UNRESTRICTED,
*         /***********************************************************/
*         /*   STANDARD LINKAGE CONVENTION SUBROUTINE ENTRY POINTER  */
*         /***********************************************************/
*         R15 POINTER(31) REGISTER(15) UNRESTRICTED;
*
* /*******************************************************************/
* /*      DEFINE A SAVE AREA                                         */
* /*******************************************************************/
* DECLARE
* 1       SAVEAREA  BASED( R13) BOUNDARY( WORD),
*         /***********************************************************/
*         /*    PL/I USES THIS WORD TO INDICATE THE LENGTH OF THE    */
*         /*    DYNAMIC STORAGE AREA REPRESENTED BY THIS SAVE AREA   */
*         /***********************************************************/
*         2     SAVEWRD1 POINTER(32),
*               3  SAVEPFLG POINTER(8),
*               3  SAVEPLGH POINTER(24),
*         /***********************************************************/
*         /*    POINTER TO THE PREVIOUS SAVE AREA, THE SAVE AREA OF  */
*         /*    THE INVOKER UNLESS THIS SUBROUTINE PROVIDES NO SAVE  */
*         /*    AREA OF ITS OWN                                      */
*         /***********************************************************/
*         2     SAVELAST POINTER(32),
*         /***********************************************************/
*         /*    POINTER TO THE NEXT SAVE AREA FOR ALL BUT THE LOWEST */
*         /*    LEVEL SUBROUTINE ON THE STACK                        */
*         /***********************************************************/
*         2     SAVENEXT POINTER(32),
*         /***********************************************************/
*         /*    SAVE AREA WORD FOR INPUT REGISTER 14, THE ADDRESS TO */
*         /*    WHICH CONTROL IS NORMALLY TO BE RETURNED AFTER A     */
*         /*    SUBROUTINE HAS CONCLUDED PROCESSING.  THE HIGH-ORDER */
*         /*    BYTE OF THIS POINTER SHOULD BE SET TO 'FF'X IF THIS  */
*         /*    ROUTINE HAS CONTROL AFTER A RETURN HAS BEEN MADE FROM*/
*         /*    A SUBROUTINE.                                        */
*         /***********************************************************/
*         2     SAVER14 POINTER(32),
*               3  SAVERETF POINTER(8),
*         /***********************************************************/
*         /*    SAVE AREA FOR INPUT REGISTERS 15 THROUGH 12          */
*         /***********************************************************/
*         2     SAVER15 POINTER(32),
*         2     SAVER0 POINTER(32),
*         2     SAVER1 POINTER(32),
*         2     SAVER2 POINTER(32),
*         2     SAVER3 POINTER(32),
*         2     SAVER4 POINTER(32),
*         2     SAVER5 POINTER(32),
*         2     SAVER6 POINTER(32),
*         2     SAVER7 POINTER(32),
*         2     SAVER8 POINTER(32),
*         2     SAVER9 POINTER(32),
*         2     SAVER10 POINTER(32),
*         2     SAVER11 POINTER(32),
*         2     SAVER12 POINTER(32),
*         /***********************************************************/
*         /*   AREA USED BY PL/I AND BSL FOR TEMPORARY AND AUTOMATIC */
*         /*   STORAGE AREAS                                         */
*         /***********************************************************/
*         2     SAVEXTNT CHARACTER( 8);
*
* /*******************************************************************/
* /*      DEFINE A TYPE I PARAMETER LIST                             */
* /*******************************************************************/
* DECLARE
* 1       PARAM BASED( R1) BOUNDARY( WORD),
*         2     PARAM1 POINTER(32),
*         2     PARAM2 POINTER(32),
*         2     PARAM3 POINTER(32),
*         2     PARAM4 POINTER(32),
*         2     PARAM5 POINTER(32),
*         2     PARAM6 POINTER(32),
*         2     PARAM7 POINTER(32),
*         2     PARAM8 POINTER(32),
*         2     PARAM9 POINTER(32),
*         2     PARAM10 POINTER(32),
*         2     PARAM11 POINTER(32),
*         2     PARAM12 POINTER(32),
*         2     PARAM13 POINTER(32),
*         2     PARAM14 POINTER(32),
*         2     PARAM15 POINTER(32),
*         2     PARAM16 POINTER(32),
*         2     PARAM17 POINTER(32),
*         2     PARAM18 POINTER(32),
*         2     PARAM19 POINTER(32),
*         2     PARAM20 POINTER(32),
*         2     PARAM21 POINTER(32),
*         2     PARAM22 POINTER(32),
*         2     PARAM23 POINTER(32),
*         2     PARAM24 POINTER(32),
*         2     PARAM25 POINTER(32),
*         2     PARAM26 POINTER(32),
*         2     PARAM27 POINTER(32),
*         2     PARAM28 POINTER(32),
*         2     PARAM29 POINTER(32),
*         2     PARAM30 POINTER(32);
*
*         DECLARE
*         /***********************************************************/
*         /*    INTERNAL AUTOMATIC VARIABLES                         */
*         /***********************************************************/
*
*         CNVRT1 CHARACTER(8) AUTOMATIC BOUNDARY(DWORD), /*CONVERSION
*                                       BUFFER FOR CONVERSION FROM
*                                       DECIMAL TO BINARY, FROM DECIMAL
*                                       TO EBCDIC, & FROM BINARY TO
*                                       DECIMAL                      */
*         CNVRT2 CHARACTER(4) AUTOMATIC BOUNDARY(WORD),  /*CONVERSION
*                                       BUFFER FOR CONVERSION FROM
*                                       DECIMAL TO EBCDIC            */
*         /***********************************************************/
*         /*    INTERNAL BASED VARIABLES, GENERATED CSECT VARIABLES, */
*         /*    & ARGUMENTS PASSED INTO IKJEFLPA                     */
*         /***********************************************************/
*         1     TOD BASED BOUNDARY(BYTE),
*               2  TODLEN FIXED(15) BOUNDARY(BYTE),
*               2  TODOFF FIXED(15) BOUNDARY(BYTE),
*               2  TODTXT CHARACTER(8) BOUNDARY(BYTE),
*         DATEBUF CHARACTER(18) BASED BOUNDARY(BYTE),
*         1     DATE BASED BOUNDARY(BYTE),
*               2  DATELEN FIXED(15) BOUNDARY(BYTE),
*               2  DATEOFF FIXED(15) BOUNDARY(BYTE),
*               2  DATETXT CHARACTER(18) BOUNDARY(BYTE),
*         IKJEFLPB LABEL EXTERNAL,
*         PBORIGIN LABEL GENERATED,
*         PBCNTURY GENERATED CHARACTER(1) BOUNDARY(BYTE),
*         PBCOLON GENERATED CHARACTER(1) BOUNDARY(BYTE),
*         PBCOMBL GENERATED CHARACTER(2) BOUNDARY(BYTE),
*         PBCOMMA GENERATED CHARACTER(1) BOUNDARY(BYTE),
*         PBBLANK GENERATED CHARACTER(1) BOUNDARY(BYTE),
*         1     PBMDESCR(12) GENERATED BOUNDARY(HWORD),
*               2  PBMLDAY FIXED(15) BOUNDARY(HWORD),
*               2  PBMLEN FIXED(15) BOUNDARY(HWORD),
*               2  PBMOFF FIXED(15) BOUNDARY(HWORD),
*         PBMONTH CHARACTER(9) BASED BOUNDARY(BYTE);
*/*       L     GET TIME OF DAY AND DATE FROM THE SYSTEM */
*         GENERATE;
         TITLE 'IKJEFLPA -- TOD && TEXT PREPARATION -- IKJEFLPB EBCDIC *
               CHARACTERS FOR TOD && DATE'
* /******************************************************************/
* /*     DEFINE ALL CHARACTER-SET AND LANGUAGE-DEPENDENT DATA       */
* /*     REQUIRED FOR IKJEFLPA OPERATION                            */
* /******************************************************************/
IKJEFLPB CSECT
PBORIGIN EQU   IKJEFLPB SYNONYM FOR IKJEFLPB
PBCNTURY DC    X'19'    PACKED DECIMAL DIGITS FOR THE CURRENT CENTURY
PBCOLON  DC    C':'     IMAGE OF AN EBCDIC COLON
PBCOMBL  DS    C', '    IMAGE OF COMMA AND BLANK
         ORG   PBCOMBL
PBCOMMA  DC    C','     IMAGE OF AN EBCDIC COMMA
PBBLANK  DC    C' '     IMAGE OF AN EBCDIC BLANK
&LNDESCR SETA  6        LENGTH OF PBMDESCR ARRAY ELEMENT
         SPACE
* /******************************************************************/
* /*     ALLOW AT LEAST ENOUGH SPACE IN IKJEFLPB FOR 2 ARRAY        */
* /*     ELEMENTS BEFORE GENERATING THE PBMDESCR ARRAY              */
* /******************************************************************/
         ORG   IKJEFLPB RESET THE LOCATION COUNTER TO IKJEFLPB
         DS    CL(2*&LNDESCR) FORCE THE LOCATION COUNTER TO 2 TIMES    *
                        THE LENGTH OF ONE PBDESCR ARRAY ELEMENT
         ORG   ,        SET THE LOCATION COUNTER TO THE HIGHEST VALUE  *
                        IT HAS YET ASSUMED
         DS    0H       ALIGN PBMDESCR ARRAY ON HALFWORD
PBMDESCR DS    CL&LNDESCR ARRAY ELEMENT
         ORG   PBMDESCR GENERATE INITIALIZED ARRAY OF                  *
                        MONTH-DESCRIPTORS
&LDAY(1) SETA  31             LAST DAY OF JANUARY
&LDAY(2) SETA  &LDAY(1)+28    LAST DAY OF FEBRUARY
&LDAY(3) SETA  &LDAY(2)+31    LAST DAY OF MARCH
&LDAY(4) SETA  &LDAY(3)+30    LAST DAY OF APRIL
&LDAY(5) SETA  &LDAY(4)+31    LAST DAY OF MAY
&LDAY(6) SETA  &LDAY(5)+30    LAST DAY OF JUNE
&LDAY(7) SETA  &LDAY(6)+31    LAST DAY OF JULY
&LDAY(8) SETA  &LDAY(7)+31    LAST DAY OF AUGUST
&LDAY(9) SETA  &LDAY(8)+30    LAST DAY OF SEPTEMBER
&LDAY(10) SETA &LDAY(9)+31    LAST DAY OF OCTOBER
&LDAY(11) SETA &LDAY(10)+30   LAST DAY OF NOVEMBER
&LDAY(12) SETA &LDAY(11)+31   LAST DAY OF DECEMBER
** /*
&I       SETA  0
.PB00100 ANOP
&I       SETA  &I+1
         DC    H'&LDAY(&I)' LAST DAY OF MONTH
         DC    AL2(L'PB&I) LENGTH OF THE NAME OF THE MONTH
         DC    AL2(PB&I-IKJEFLPB) OFFSET OF THE NAME OF THE MONTH
         AIF   (&I LT 12).PB00100
PB1      DC    C'JANUARY'     ENGLISH NAME FOR 1ST MONTH IN EBCDIC
PB2      DC    C'FEBRUARY'    ENGLISH NAME FOR 2ND MONTH IN EBCDIC
PB3      DC    C'MARCH'       ENGLISH NAME FOR 3RD MONTH IN EBCDIC
PB4      DC    C'APRIL'       ENGLISH NAME FOR 4TH MONTH IN EBCDIC
PB5      DC    C'MAY'         ENGLISH NAME FOR 5TH MONTH IN EBCDIC
PB6      DC    C'JUNE'        ENGLISH NAME FOR 6TH MONTH IN EBCDIC
PB7      DC    C'JULY'        ENGLISH NAME FOR 7TH MONTH IN EBCDIC
PB8      DC    C'AUGUST'      ENGLISH NAME FOR 8TH MONTH IN EBCDIC
PB9      DC    C'SEPTEMBER'   ENGLISH NAME FOR 9TH MONTH IN EBCDIC
PB10     DC    C'OCTOBER'     ENGLISH NAME FOR 10TH MONTH IN EBCDIC
PB11     DC    C'NOVEMBER'    ENGLISH NAME FOR 11TH MONTH IN EBCDIC
PB12     DC    C'DECEMBER'    ENGLISH NAME FOR 12TH MONTH IN EBCDIC
         TITLE    'IKJEFLPA -- TOD && DATE TEXT PREPARATION -- PREPARE *
               TOD BUFFER'
IKJEFLPA CSECT
** */
*        /***********************************************************/
*        /*     R0 = 'HHMMSSTQ' WHERE HH IS THE HOUR, MM IS THE     */
*        /*        MINUTE, SS IS THE SECOND, T IS THE TENTH OF A    */
*        /*        SECOND, AND Q IS THE HUNDREDTH                   */
*        /*     R1 = '00YYDDDZ' WHERE YY IS THE YEAR DDD IS THE DAY */
*        /*        AND Z IS A ZONE WHICH INDICATES A POSITIVE       */
*        /*        DECIMAL NUMBER                                   */
*        /***********************************************************/
         TIME  DEC      OBTAIN TIME IN R0, DATE IN R1
         DS    0H
*         CNVRT2 = R0;                /*CNVRT2 = '00HHMMSS' WHERE HH
*                                       IS THE HOUR, MM IS THE  MINUTE,
*                                       AND SS IS THE SECOND         */
         ST    @0,CNVRT2                                          0010
*         RESPECIFY( R0) UNRESTRICTED; /*ALLOW IMPLICIT REFERENCES TO
*                                       R0                           */
*         RESPECIFY( R2, R3) RESTRICTED; /*RESERVE VARIABLES FOR
*                                       EXPLICIT REFERENCES          */
*         /***********************************************************/
*         /*    ESTABLISH A POINTER TO THE TIME-OF-DAY (TOD) TEXT    */
*         /*    INSERTION BUFFER                                     */
*         /***********************************************************/
*         R2 = SAVELAST -> SAVER1 -> PARAM1;
         L     @8,4(0,@D)
         L     @8,24(0,@8)         SAVEAREA                       0013
         L     @2,0(0,@8)                                         0013
*         RESPECIFY( TOD) BASED(R2);
*         R3 = ADDR(IKJEFLPB);         /*ESTABLISH A POINTER TO
*                                        IKJEFLPB                    */
         L     @9,@V1              ADDRESS OF IKJEFLPB            0015
         LR    @3,@9                                              0015
*/*       P     PLACE TOD IN BYTES 7-12 OF BUFFER                    */
*         GENERATE;
         USING IKJEFLPB,R3          TELL THE ASSEMBLER HOW TO FIND     *
                                    IKJEFLPB
         SPACE
*        /************************************************************
*             PLACE TOD IN BYTES 7-12 OF BUFFER
*        ************************************************************/
         MVO  CNVRT1(4),CNVRT2(3)   SHIFT OUT TENTHS OF SECONDS DIGIT
         UNPK TODTXT+2-TOD(6,R2),CNVRT1(4)   CONVERT TIME OF DAY TO    *
                                    CHARACTER FORMAT
         MVZ  TODTXT+7-TOD(1,R2),TODTXT+2-TOD(R2)  INSERT PROPER ZONE  *
                                    FIELD INTO THE FINAL SECONDS DIGIT
         DS    0H
*         /***********************************************************/
*/*       P     SET LENGTH OF TOD BUFFER                             */
*         /***********************************************************/
*         TODLEN = 12;
         MVC   0(2,@2),@D1                                        0017
*
*         /***********************************************************/
*/*       P     MOVE DIGITS OF HOUR TO BYTES 5-6 OF BUFFER           */
*         /***********************************************************/
*         TODTXT( 1: 2) = TODTXT( 3: 4);
         MVC   4(2,@2),6(@2)                                      0018
*
*         /***********************************************************/
*/*       P     MOVE COLON TO BYTE 7 OF BUFFER                       */
*         /***********************************************************/
*         TODTXT( 3) = PBCOLON;
         MVC   6(1,@2),PBCOLON                                    0019
*
*         /***********************************************************/
*/*       P     MOVE DIGITS OF MINUTE TO BYTES 8-9 OF BUFFER         */
*         /***********************************************************/
*         TODTXT( 4: 5) = TODTXT( 5: 6);
         MVC   7(2,@2),8(@2)                                      0020
*
*         /***********************************************************/
*/*       P     MOVE COLON TO BYTE 10 OF BUFFER                      */
*         /***********************************************************/
*         TODTXT( 6) = PBCOLON;
         MVC   9(1,@2),PBCOLON                                    0021
*         GENERATE;
         TITLE    'IKJEFLPA -- TOD && DATE TEXT PREPARATION -- PREPARE *
               DATE BUFFER'
         DS    0H
*
*         /***********************************************************/
*         /*     DATE PROCESSING                                     */
*         /***********************************************************/
*         CNVRT2 = R1;                /*SET CNVRT2 TO THE DATE IN
*                                       DECIMAL                      */
         ST    @1,CNVRT2                                          0023
*         RESPECIFY( R1) UNRESTRICTED; /*ALLOW IMPLICIT REFERENCES
*                                       TO R1                        */
*
*         /***********************************************************/
*         /*    ESTABLISH POINTER TO DATE TEXT INSERTION BUFFER      */
*         /***********************************************************/
*         R2 = SAVELAST -> SAVER1 -> PARAM2;
         L     @2,4(0,@8)                                         0025
*         RESPECIFY( DATE) BASED(R2);
*
*         /***********************************************************/
*         /*    CNVRT1 = '000000000000DDDZ'X                         */
*         /***********************************************************/
*         CNVRT1( 1: 6) = CNVRT1( 1: 6) && CNVRT1( 1: 6);
         XC    CNVRT1(6),CNVRT1                                   0027
*         CNVRT1( 7: 8) = CNVRT2( 3: 4);
         MVC   CNVRT1+6(2),CNVRT2+2                               0028
*         RESPECIFY( R4, R5) RESTRICTED; /*RESERVE VARIABLES FOR
*                                       EXPLICIT REFERENCES          */
*
*         /***********************************************************/
*         /*    R4 = DAY OF YEAR IN BINARY                           */
*         /*    R5 = YEAR IN BINARY                                  */
*         /***********************************************************/
*         GENERATE;
         CVB   R4,CNVRT1               R4 = DAY OF YEAR IN BINARY
         MVO   CNVRT1+6(2),CNVRT2+1(1) CNVRT1 = YEAR IN DECIMAL
         CVB   R5,CNVRT1               R5 = YEAR IN BINARY
         DS    0H
*
*         RESPECIFY( R7) RESTRICTED;  /*RESERVE VARIABLE FOR
*                                       EXPLICIT REFERENCES          */
*
*         /***********************************************************/
*/*       P     SET INDEX OF MONTH TO JANUARY                        */
*         /***********************************************************/
*         R7 = 1;
         LA    @7,1                                               0032
*
*         /***********************************************************/
*/*       D     (YES,PA000620,NO,)
*/*             MONTH = JANUARY                                      */
*         /*    IF THE DAY IS WITHIN JANUARY, CONSTRUCT THE DATE TEXT*/
*         /*    INSERTION BUFFER                                     */
*         /***********************************************************/
*         IF R4 <= PBMLDAY(1)
*         THEN
         CH    @4,PBMDESCR                                        0033
*               GO TO PA000620;
         BC    12,PA000620                                        0034
*
*         /***********************************************************/
*/*       D     (YES,,NO,PA000400)
*/*             LEAP YEAR?                                           */
*         /*    IF THE DAY IS NOT WITHIN JANUARY AND THE YEAR IS     */
*         /*    DIVISIBLE BY FOUR, TREAT THE YEAR AS A LEAP YEAR     */
*         /***********************************************************/
*         R5 = R5 // 4;
         LR    @E,@5                                              0035
         SRDA  @E,32                                              0035
         LA    @0,4                                               0035
         DR    @E,@0                                              0035
         LR    @5,@E                                              0035
*         IF R5 = 0
*         THEN
         LTR   @5,@5                                              0036
         BC    07,@9FF                                            0036
*               /*****************************************************/
*/*             P  DECREMENT DAY OF YEAR TO COMPENSATE FOR LONG
*/*                FEBRUARY                                          */
*               /*****************************************************/
*               R4 = R4 - 1;
         BCTR  @4,0                                               0037
*
*PA000400:/***********************************************************/
*/*PA000400: P  INCREMENT INDEX OF MONTH                             */
*         /***********************************************************/
*         R7 = R7 + 1;
@9FF     EQU   *                                                  0038
PA000400 AH    @7,@D2                                             0038
*
*         /***********************************************************/
*/*       D     (YES,PA000600,NO,)
*/*             INDEX OF MONTH > 11                                  */
*         /***********************************************************/
*         IF R7 > 11
*         THEN
         CH    @7,@D3                                             0039
*               GO TO PA000600;
         BC    02,PA000600                                        0040
*
*         /***********************************************************/
*/*       D     (YES,PA000400,NO,)
*/*             DAY OF YEAR > LAST DAY OF INDEXED MONTH              */
*         /***********************************************************/
*         IF R4 > PBMLDAY( R7)
*         THEN
         LR    @1,@7                                              0041
         MH    @1,@D4                                             0041
         CH    @4,PBMDESCR-6(@1)                                  0041
*               GO TO PA000400;
         BC    02,PA000400                                        0042
*
*         /***********************************************************/
*/*       D     (YES,,NO,PA000600)
*/*             MONTH = FEBRUARY & LEAP YEAR                         */
*         /***********************************************************/
*         IF R7 = 2 & R5 = 0
*         THEN
         CH    @7,@D5                                             0043
         BC    07,@9FE                                            0043
         LTR   @5,@5                                              0043
         BC    07,@9FD                                            0043
*               /*****************************************************/
*/*             P  INCREMENT DAY OF YEAR TO ALLOW FEBRUARY 29 DAYS   */
*               /*****************************************************/
*               R4 = R4 + 1;
         AH    @4,@D2                                             0044
*         RESPECIFY( R5) UNRESTRICTED; /*ALLOW IMPLICIT REFERENCES
*                                        TO R5                       */
@9FD     EQU   *                                                  0045
@9FE     EQU   *                                                  0045
*
*PA000600:/***********************************************************/
*/*PA000600: P  DAY OF MONTH = DAY OF YEAR - LAST DAY OF
*/*             PREVIOUS MONTH                                       */
*         /***********************************************************/
*         R4 = R4 - PBMLDAY( R7 - 1);
PA000600 LR    @1,@7                                              0046
         MH    @1,@D4                                             0046
         LH    @F,PBMDESCR-12(@1)                                 0046
         LCR   @F,@F                                              0046
         AR    @4,@F                                              0046
*         RESPECIFY( R5, R6) RESTRICTED; /*RESERVE VARIABLES FOR
*                                       EXPLICIT REFERENCES          */
*PA000620:/***********************************************************/
*/*PA000620: P  MOVE NAME OF THE MONTH TO DATE BUFFER                */
*         /***********************************************************/
*         R5 = PBMLEN( R7);           /*R5 = LENGTH OF THE NAME OF
*                                       THE MONTH                    */
PA000620 LR    @1,@7                                              0048
         MH    @1,@D4                                             0048
         LH    @5,PBMDESCR-4(@1)                                  0048
*         R6 = ADDR( PBORIGIN) + PBMOFF( R7);/*R6 = ADDRESS OF THE NAME
*                                       OF THE MONTH                 */
         LH    @F,PBMDESCR-2(@1)                                  0049
         LA    @0,PBORIGIN                                        0049
         AR    @F,@0                                              0049
         LR    @6,@F                                              0049
*         RESPECIFY( R7) UNRESTRICTED;/*ALLOW IMPLICIT REFERENCES TO A
*                                       VARIABLE                     */
*
*         /***********************************************************/
*         /*    MOVE NAME OF THE MONTH TO DATE BUFFER                */
*         /***********************************************************/
*         DATETXT( 1: R5) = R6 -> PBMONTH( 1: R5);
         LR    @E,@6                                              0051
         LR    @7,@5                                              0051
         BCTR  @7,0                                               0051
         LA    @A,4(0,@2)                                         0051
         EX    @7,@MVC                                            0051
*         R6 = ADDR( DATETXT( R5 + 1)); /*R6 = ADDRESS OF FIRST UNUSED
*                                       CHARACTER OF DATE BUFFER     */
         LA    @7,1                                               0052
         AR    @7,@5                                              0052
         LA    @6,3(@7,@2)                                        0052
*
*         /***********************************************************/
*/*       P     MOVE BLANK AFTER THE NAME OF THE MONTH               */
*         /***********************************************************/
*         R6 -> DATEBUF( 1) = PBBLANK;
         MVC   0(1,@6),PBBLANK                                    0053
*
*         /***********************************************************/
*         /*    CNVRT1 = '0000000000000DDZ'X WHERE DD IS THE DAY     */
*         /*    WITHIN THE MONTH AND Z IS A POSITIVE ZONE FIELD      */
*         /***********************************************************/
*         GENERATE(CVD   R4,CNVRT1);
         CVD   R4,CNVRT1
         DS    0H
*         RESPECIFY( R4) UNRESTRICTED; /*ALLOW IMPLICIT REFERENCES
*                                       TO R4                        */
*         /***********************************************************/
*         /*    CNVRT1 = '0000000DDZ000DDZ'X                         */
*         /***********************************************************/
*         CNVRT1( 4: 5) = CNVRT1( 7: 8);
         MVC   CNVRT1+3(2),CNVRT1+6                               0056
*         GENERATE;
         SPACE
*        /***********************************************************/
*        /*    CNVRT1 = '0000000DDZ000YYZ'X                         */
*        /***********************************************************/
         MVO   CNVRT1+6(2),CNVRT2+1(1)
         SPACE
*        /***********************************************************/
*        /*    CNVRT1 = '0000000DDZ0CCYYZ'X WHERE DD IS THE DAY OF  */
*        /*    THE MONTH, Z IS A POSITIVE ZONE, CC IS THE CENTURY,  */
*        /*    AND YY IS THE YEAR                                   */
*        /***********************************************************/
         MVO   CNVRT1+5(2),PBCNTURY
         DS    0H
*
*         /***********************************************************/
*/*       D     (YES,PA000700,NO,PA000800)
*/*             DAY OF MONTH < 10                                    */
*         /***********************************************************/
*         IF CNVRT1( 4) = '00'X
*         THEN
         CLI   CNVRT1+3,X'00'                                     0058
         BC    07,@9FC                                            0058
*/*PA000700:    P  MOVE DIGITS OF DATE TO BUFFER. ONE DIGIT FOR DAY  */
*
*PA000700:               DO;
*               /*****************************************************/
*               /* DATE = '????MONTH D??CCY' || 'ZY'X WHERE D IS THE */
*               /* FINAL DIGIT OF THE DAY OF THE MONTH, CC IS THE    */
*               /* CENTURY, Y IS THE FIRST DIGIT OF THE YEAR, Z IS A */
*               /* POSITIVE ZONE DIGIT, AND Y IS THE SECOND DIGIT OF */
*               /* THE YEAR                                          */
*               /*****************************************************/
*               GENERATE(UNPK  DATEBUF+1-DATEBUF(7,R6),CNVRT1+4(4));
PA000700 UNPK  DATEBUF+1-DATEBUF(7,R6),CNVRT1+4(4)
         DS    0H
*               /*****************************************************/
*/*             P  (,%A000900)
*/*                SET DATE BUFFER LENGTH FIELD                      */
*               /*****************************************************/
*               DATELEN = R5 + 12;
         LA    @F,12                                              0061
         AR    @F,@5                                              0061
         ST    @F,@TEMP4                                          0061
         MVC   0(2,@2),@TEMP4+2                                   0061
*               /*****************************************************/
*               /* R6 = ADDRESS OF THE LAST CHARACTER OF THE NAME OF */
*               /* THE MONTH WITHIN THE DATE BUFFER                  */
*               /*****************************************************/
*               R6 = R6 - 1;
         BCTR  @6,0                                               0062
         BC    15,@9FB                                            0064
*               END PA000700;
*
*         /***********************************************************/
*         /*  IF THE FIRST DIGIT OF THE DAY OF THE MONTH IS NONZERO, */
*         /*  PLACE A TWO-DIGIT DAY OF THE MONTH IN THE DATE BUFFER  */
*         /***********************************************************/
*         ELSE
*/*PA000800:    P  MOVE DIGITS OF DATE TO BUFFER. TWO DIGITS FOR DAY */
*
*PA000800:               DO;
@9FC     EQU   *                                                  0064
*               /*****************************************************/
*               /* DATE = '????MONTH DD??CCY' || 'ZY'X WHERE DD IS   */
*               /* THE DAY OF THE MONTH, CC IS THE CENTURY, Y IS     */
*               /* THE FIRST DIGIT OF THE YEAR, Z IS A POSITIVE ZONE */
*               /* DIGIT, AND Y IS THE SECOND DIGIT OF THE YEAR      */
*               /*****************************************************/
*
*               GENERATE(UNPK  DATEBUF+1-DATEBUF(8,R6),CNVRT1+3(5));
PA000800 UNPK  DATEBUF+1-DATEBUF(8,R6),CNVRT1+3(5)
         DS    0H
*
*               /*****************************************************/
*/*             P  (,%A000900)
*/*                SET DATE BUFFER LENGTH FIELD                      */
*               /*****************************************************/
*               DATELEN = R5 + 13;
         LA    @F,13                                              0066
         AR    @F,@5                                              0066
         ST    @F,@TEMP4                                          0066
         MVC   0(2,@2),@TEMP4+2                                   0066
*               END PA000800;
*
*         /***********************************************************/
*/*%A000900: P  MOVE COMMA AND BLANK AFTER DIGIT(S) OF MONTH         */
*         /***********************************************************/
*         R6 -> DATEBUF( 4: 5) = PBCOMBL;
@9FB     MVC   3(2,@6),PBCOMBL                                    0068
*         GENERATE;
         SPACE
*        /***********************************************************/
*        /*    PROVIDE PROPER ZONE FIELD FOR FINAL DIGIT OF THE YEAR*/
*        /***********************************************************/
         MVZ   DATEBUF+8-DATEBUF(1,R6),DATEBUF+2-DATEBUF(R6)
         TITLE 'IKJEFLPA -- TOD && DATE TEXT PREPARATION -- EPILOGUE'
         DS    0H
*         /***********************************************************/
*/*       R     RETURN TO INVOKER                                    */
*/*IKJEFLPA: END                                                     */
*         /***********************************************************/
*         RETURN;
*         END IKJEFLPA
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IEFDCL1 )                                        *
*/*%INCLUDE SYSLIB  (IEFDCL2 )                                        *
*;
@EL01    L     @D,4(0,@D)                                         0071
         LR    @1,@C                                              0071
         L     @0,@SIZ001                                         0071
         FREEMAIN R,LV=(0),A=(1)                                  0071
         LM    @E,@C,12(@D)                                       0071
         BCR   15,@E                                              0071
@DATA1   EQU   *
@0       EQU   00                  EQUATES FOR REGISTERS 0-15
@1       EQU   01
@2       EQU   02
@3       EQU   03
@4       EQU   04
@5       EQU   05
@6       EQU   06
@7       EQU   07
@8       EQU   08
@9       EQU   09
@A       EQU   10
@B       EQU   11
@C       EQU   12
@D       EQU   13
@E       EQU   14
@F       EQU   15
@D1      DC    H'12'
@D2      DC    H'1'
@D3      DC    H'11'
@D4      DC    H'6'
@D5      DC    H'2'
@MVC     MVC   0(1,@A),0(@E)
@V1      DC    V(IKJEFLPB)
         DS    0F
@SIZ001  DC    AL1(&SPN)
         DC    AL3(@DATEND-@DATD)
         DS    0F
         DS    0D
@DATA    EQU   *
R0       EQU   00000000            FULLWORD POINTER REGISTER
R1       EQU   00000001            FULLWORD POINTER REGISTER
R2       EQU   00000002            FULLWORD POINTER REGISTER
R3       EQU   00000003            FULLWORD POINTER REGISTER
R4       EQU   00000004            FULLWORD INTEGER REGISTER
R5       EQU   00000005            FULLWORD INTEGER REGISTER
R6       EQU   00000006            FULLWORD POINTER REGISTER
R7       EQU   00000007            FULLWORD POINTER REGISTER
R8       EQU   00000008            FULLWORD POINTER REGISTER
R9       EQU   00000009            FULLWORD POINTER REGISTER
R10      EQU   00000010            FULLWORD POINTER REGISTER
R11      EQU   00000011            FULLWORD POINTER REGISTER
R12      EQU   00000012            FULLWORD POINTER REGISTER
R13      EQU   00000013            FULLWORD POINTER REGISTER
R14      EQU   00000014            FULLWORD POINTER REGISTER
R15      EQU   00000015            FULLWORD POINTER REGISTER
SAVEAREA EQU   00000000            80 BYTE(S) ON WORD
SAVEWRD1 EQU   SAVEAREA+00000000   FULLWORD POINTER
SAVEPFLG EQU   SAVEAREA+00000000   1  BYTE  POINTER
SAVEPLGH EQU   SAVEAREA+00000001   3  BYTE  POINTER ON WORD+1
SAVELAST EQU   SAVEAREA+00000004   FULLWORD POINTER
SAVENEXT EQU   SAVEAREA+00000008   FULLWORD POINTER
SAVER14  EQU   SAVEAREA+00000012   FULLWORD POINTER
SAVERETF EQU   SAVEAREA+00000012   1  BYTE  POINTER
SAVER15  EQU   SAVEAREA+00000016   FULLWORD POINTER
SAVER0   EQU   SAVEAREA+00000020   FULLWORD POINTER
SAVER1   EQU   SAVEAREA+00000024   FULLWORD POINTER
SAVER2   EQU   SAVEAREA+00000028   FULLWORD POINTER
SAVER3   EQU   SAVEAREA+00000032   FULLWORD POINTER
SAVER4   EQU   SAVEAREA+00000036   FULLWORD POINTER
SAVER5   EQU   SAVEAREA+00000040   FULLWORD POINTER
SAVER6   EQU   SAVEAREA+00000044   FULLWORD POINTER
SAVER7   EQU   SAVEAREA+00000048   FULLWORD POINTER
SAVER8   EQU   SAVEAREA+00000052   FULLWORD POINTER
SAVER9   EQU   SAVEAREA+00000056   FULLWORD POINTER
SAVER10  EQU   SAVEAREA+00000060   FULLWORD POINTER
SAVER11  EQU   SAVEAREA+00000064   FULLWORD POINTER
SAVER12  EQU   SAVEAREA+00000068   FULLWORD POINTER
SAVEXTNT EQU   SAVEAREA+00000072   8 BYTE(S)
PARAM    EQU   00000000            120 BYTE(S) ON WORD
PARAM1   EQU   PARAM+00000000      FULLWORD POINTER
PARAM2   EQU   PARAM+00000004      FULLWORD POINTER
PARAM3   EQU   PARAM+00000008      FULLWORD POINTER
PARAM4   EQU   PARAM+00000012      FULLWORD POINTER
PARAM5   EQU   PARAM+00000016      FULLWORD POINTER
PARAM6   EQU   PARAM+00000020      FULLWORD POINTER
PARAM7   EQU   PARAM+00000024      FULLWORD POINTER
PARAM8   EQU   PARAM+00000028      FULLWORD POINTER
PARAM9   EQU   PARAM+00000032      FULLWORD POINTER
PARAM10  EQU   PARAM+00000036      FULLWORD POINTER
PARAM11  EQU   PARAM+00000040      FULLWORD POINTER
PARAM12  EQU   PARAM+00000044      FULLWORD POINTER
PARAM13  EQU   PARAM+00000048      FULLWORD POINTER
PARAM14  EQU   PARAM+00000052      FULLWORD POINTER
PARAM15  EQU   PARAM+00000056      FULLWORD POINTER
PARAM16  EQU   PARAM+00000060      FULLWORD POINTER
PARAM17  EQU   PARAM+00000064      FULLWORD POINTER
PARAM18  EQU   PARAM+00000068      FULLWORD POINTER
PARAM19  EQU   PARAM+00000072      FULLWORD POINTER
PARAM20  EQU   PARAM+00000076      FULLWORD POINTER
PARAM21  EQU   PARAM+00000080      FULLWORD POINTER
PARAM22  EQU   PARAM+00000084      FULLWORD POINTER
PARAM23  EQU   PARAM+00000088      FULLWORD POINTER
PARAM24  EQU   PARAM+00000092      FULLWORD POINTER
PARAM25  EQU   PARAM+00000096      FULLWORD POINTER
PARAM26  EQU   PARAM+00000100      FULLWORD POINTER
PARAM27  EQU   PARAM+00000104      FULLWORD POINTER
PARAM28  EQU   PARAM+00000108      FULLWORD POINTER
PARAM29  EQU   PARAM+00000112      FULLWORD POINTER
PARAM30  EQU   PARAM+00000116      FULLWORD POINTER
TOD      EQU   00000000            12 BYTE(S)
TODLEN   EQU   TOD+00000000        2  BYTE  INTEGER
TODOFF   EQU   TOD+00000002        2  BYTE  INTEGER
TODTXT   EQU   TOD+00000004        8 BYTE(S)
DATEBUF  EQU   00000000            18 BYTE(S)
DATE     EQU   00000000            22 BYTE(S)
DATELEN  EQU   DATE+00000000       2  BYTE  INTEGER
DATEOFF  EQU   DATE+00000002       2  BYTE  INTEGER
DATETXT  EQU   DATE+00000004       18 BYTE(S)
PBMLDAY  EQU   PBMDESCR+00000000   HALFWORD INTEGER
PBMLEN   EQU   PBMDESCR+00000002   HALFWORD INTEGER
PBMOFF   EQU   PBMDESCR+00000004   HALFWORD INTEGER
PBMONTH  EQU   00000000            9 BYTE(S)
         DS    00000000C
@L       EQU   1
@DATD    DSECT
@SAV001  EQU   @DATD+00000000      72 BYTE(S) ON WORD
CNVRT1   EQU   @DATD+00000072      8 BYTE(S) ON DWORD
CNVRT2   EQU   @DATD+00000080      4 BYTE(S) ON WORD
         DS    00000084C
@TEMPS   DS    0F
@TEMP4   DC    F'0'
@DATEND  EQU   *
IKJEFLPA CSECT ,
         END   IKJEFLPA
