         MACRO
         MESSAGE &TEXT
.*
.* THIS MACRO IS USED TO DEFINE THE MESSAGE FORMATS. EACH MESSAGE IS
.* GENERATED INTO A FORM ACCEPTABLE TO THE TSO I/O ROUTINES.
.*
         LCLA  &LENGTH
         LCLC  &NAME
&LENGTH  SETA  K'&TEXT-2               LENGTH OF MESSAGE MINUS QUOTES
&NAME    SETC  '&TEXT'(2,8)            USE 8 BYTES OF MESSAGE ID AS
.*                                        LABEL
&NAME    DC    0H'0'                   ALIGN MESSAGE SEGMENT
         DC    AL2(&LENGTH+4)          SEGMENT LENGTH
         DC    AL2(0)                  FIRST SEGMENT OFFSET
         DC    C&TEXT                  MESSAGE TEXT
         MEND
P10      TITLE 'IKJEFP10   TSO PARSE MESSAGE MODULE   VERSION 2 DATE 3/*
               9/71'
***********************************************************************
*                                                                     *
* TITLE -- 'IKJEFP10  MESSAGE MODULE FOR TSO PARSE ROUTINE            *
*                                                                     *
* STATUS -- VERSION 4                                                 *
*                                                                     *
* FUNCTION --  THIS MODULE CONTAINS THE MESSAGE SEGMENTS USED BY      *
*    THE TSO PARSE ROUTINE (MODULE IKJEFP00) TO CONSTRUCT THE         *
*    MESSAGES WHICH MAY BE SENT TO THE TERMINAL USER IN THE COURSE    *
*    OF ITS PROCESSING.  THE MESSAGE SEGMENTS ARE IN THE FORMAT       *
*    REQUIRED BY THE TSO I/O SERVICE ROUTINES.  THEY ARE ACCESSED     *
*    BY INDEXING INTO A TABLE WHICH CONTAINS THE ADDRESSES OF         *
*    THE MESSAGE SEGMENTS.                                            *
*                                                                     *
* ENTRY POINTS - THIS MODULE CONTAINS NO EXECUTABLE CODE.             *
*         IKJEFP10:  ADDRESS OF THE TABLE USED TO ACCESS THE          *
*                    MESSAGE SEGMENTS.                                *
*                                                                     *
* INPUT -- N/A                                                        *
*                                                                     *
* OUTPUT -- N/A                                                       *
*                                                                     *
* EXTERNAL REFERENCES -- NONE                                         *
*                                                                     *
* EXISTS,NORMAL -- N/A                                                *
*                                                                     *
* EXITS,ERROR -- N/A                                                  *
*                                                                     *
* TABLES/WORK AREAS -- THE MESSAGE SEGMENTS ARE ACCESSED BY           *
*    INDEXING INTO A TABLE WHICH CONTAINS THE ADDRESSES OF THE        *
*    MESSAGE SEGMENTS.                                                *
*                                                                     *
* ATTRIBUTES -- N/A                                                   *
*                                                                     *
* CHARACTER CODE DEPENDENCY --  CLASS A:  THE OPERATION OF THIS       *
*    MODULE DOES NOT DEPEND UPON A PARTICULAR INTERNAL REPRESENTATION *
*    OF THE EXTERNAL CHARACTER SET.                                   *
*                                                                     *
* NOTES -- THE BEGINNING OF THIS MODULE CONTAINS A PRIVATE MACRO      *
*    WHICH IS USED TO DEFINE THE MESSAGE SEGMENT FORMAT.              *
*                                                                     *
* RELEASE 20 SUPPORT CODE -- 20035                                    *
*                                                                     *
* RELEASE 2.0 (VS) SUPPORT CODE -- Y02666                             *
*                                                                     *
***********************************************************************
         EJECT
IKJEFP10 CSECT
* M1564
         SPACE
         DC    A(IKJ56700)             CODE = 0  ENTER
         DC    A(IKJ56701)             CODE = 4  MISSING
         DC    A(IKJ56703)             CODE = 8  REENTER
         DC    A(IKJ56704)             CODE = 12 AMBIGUOUS
         DC    A(IKJ56705)             CODE = 16 MISSING PASSWORD
         DC    A(IKJ56702)             CODE = 20 INVALID
         DC    A(IKJ56706)             CODE = 24 END QUOTE ASSUMED
         DC    A(IKJ56707)             CODE = 28 RIGHT PAREN ASSUMED
         DC    A(IKJ56708)             CODE = 32 INVALID CURRENT
*                                                PASSWORD      @Z40RPKQ
         DC    A(IKJ56709)             CODE = 36 INVALID DATA SET NAME
         DC    A(IKJ56710)             CODE = 40 INVALID USERID
         DC    A(IKJ56711)             CODE = 44 INVALID ADDRESS
         DC    A(IKJ56712)             CODE = 48 INVALID KEYWORD
         DC    A(IKJ56713)             CODE = 52 INVALID VALUE
         DC    A(IKJ56714)             CODE = 56 ENTER CURRENT PASSWORD
*                                                              @Z40RPKQ
         DC    A(IKJ56715)             CODE = 60 INVALID STRING
         DC    A(IKJ56716)             CODE = 64 EXTRANEOUS INFORMATION
         DC    A(IKJ56717)             CODE = 68 INVALID          M1564
         DC    A(IKJ56718)             CODE = 72 REENTER+        Y01156
         DC    A(IKJ56719)             CODE = 76 INVALID JOBNAME Y02666
         DC    A(IKJ56720)             CODE = 80 INVALID DDNAME  Y02666
         DC    A(IKJ56721)             CODE = 84 INVALID NEW PASSWORD
*                                                              @Z40RPKQ
         DC    A(IKJ56722)             CODE = 88 ENTER NEW PASSWORD
*                                                              @Z40RPKQ
         SPACE
         MESSAGE 'IKJ56700A ENTER  -     '                       Y01156
         SPACE
         MESSAGE 'IKJ56701I MISSING '
         SPACE
         MESSAGE 'IKJ56702I INVALID , '
         SPACE
         MESSAGE 'IKJ56703A REENTER -    '                       Y01156
         SPACE
         MESSAGE 'IKJ56704I  AMBIGUOUS'
         SPACE
         MESSAGE 'IKJ56705I MISSING PASSWORD FOR '
         SPACE
         MESSAGE 'IKJ56706I ENDING QUOTE ASSUMED, '
         SPACE
         MESSAGE 'IKJ56707I RIGHT PARENTHESIS ASSUMED, '
         SPACE
         MESSAGE 'IKJ56708I INVALID CURRENT PASSWORD '         @Z40RPKQ
         SPACE
         MESSAGE 'IKJ56709I INVALID DATA SET NAME, '
         SPACE
         MESSAGE 'IKJ56710I INVALID USERID, '
         SPACE
         MESSAGE 'IKJ56711I INVALID ADDRESS, '
         SPACE
         MESSAGE 'IKJ56712I INVALID KEYWORD, '
         SPACE
         MESSAGE 'IKJ56713I INVALID VALUE, '
         SPACE
         MESSAGE 'IKJ56714A ENTER CURRENT PASSWORD FOR -'      @Z40RPKQ
         SPACE
         MESSAGE 'IKJ56715I INVALID STRING, '
         SPACE
         MESSAGE 'IKJ56716I EXTRANEOUS INFORMATION - IGNORED, '
         SPACE
         MESSAGE 'IKJ56717I INVALID '
         SPACE
         MESSAGE 'IKJ56718A REENTER+ -   '                       Y01156
         SPACE
         MESSAGE 'IKJ56719I INVALID JOBNAME, '                   Y02666
         SPACE
         MESSAGE 'IKJ56720I INVALID DDNAME, '                    Y02666
         SPACE
         MESSAGE 'IKJ56721I INVALID NEW PASSWORD '             @Z40RPKQ
         SPACE
         MESSAGE 'IKJ56722I ENTER NEW PASSWORD FOR -'          @Z40RPKQ
         END
