          TITLE  'I K J R B B U 1  --  UADSREFM MESSAGES'
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                                     *
*               P R O L O G U E   FOR   I K J R B B U 1               *
*                        REFORM MESSAGE CSECT                         *
* STATUS --                                                           *
*    CHANGE LEVEL --   VS/2                                           *
*                                                                     *
* FUNCTION --                                                         *
*    THE MESSAGE CSECT  CONTAINS THE SOURCE DATA  FOR ALL THE FIXED   *
*    CONTENT MESSAGES  OF THE  UADS REFORMATTER ROUTINE,  IKJRBBU0.   *
*    THE MESSAGE DATA IS PREFACED WITH AN INDEX TABLE BY WHICH EACH   *
*    MESSAGE MAY BE REFERENCED                                        *
*                                                                     *
* ENTRY POINTS --                                                     *
*         IKJRBBU1 -- THIS NAME IS USED TO REFERENCE THE INDEX AND    *
*            CONSEQUENTLY THE MESSAGES.                               *
*         ANDXL -- THIS NAME IS AN ALIAS FOR IKJRBBU1                 *
*                                                                     *
* INPUT --                                                            *
*    NONE                                                             *
*                                                                     *
* OUTPUT --                                                           *
*    NONE                                                             *
*                                                                     *
* EXTERNAL REFERENCES --                                              *
*    NONE                                                             *
*                                                                     *
* EXITS, NORMAL --                                                    *
*    NONE                                                             *
*                                                                     *
* EXITS, ERROR --                                                     *
*    NONE                                                             *
*                                                                     *
* TABLES/WORK AREAS --                                                *
*   NONE                                                              *
*                                                                     *
* ATTRIBUTES --                                                       *
*   REFRESHABLE                                                       *
*                                                                     *
* NOTES --                                                            *
*                                                                     *
*    . THE FOLLOWING MESSAGE NUMBERS ARE MARKED RESERVED AND ARE      *
*      AVAILABLE FOR NEW ADDITIONAL MESSAGES --                       *
*          TMSG7, TMSG20, TMSG22, TMSG24, TMSG25                      *
*                                                                     *
*    . MODULE SUPPORT CODE -- Y02097                                  *
*                                                                     *
*    . THE FUNCTION OF THIS MODULE DEPENDS UPON AN INTERNAL REPRE-    *
*      SENTATION OF THE EXTERNAL CHARACTER SET WHICH IS EQUIVALENT    *
*      TO THE ONE USED AT ASSEMBLY TIME.   CLASS  C.                  *
*                                                                     *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         EJECT
IKJRMSG  CSECT
         ENTRY ANDXL                  IDENTIFY MESSAGE INDEX
         DC    C'IKJRBBU1'            MESSAGE CSECT NAME
         DC    X'01251972'            UPDATE LEVEL
ANDXL    DS    0D                     NAME OF OFFSET AREA
MOFF1    DC    AL2(TMSG1-ANDXL)       OFFSET TO MESSAGE 1
MOFF2    DC    AL2(TMSG2-ANDXL)       OFFSET TO MESSAGE 2
MOFF3    DC    AL2(TMSG3-ANDXL)       OFFSET TO MESSAGE 3
MOFF4    DC    AL2(TMSG4-ANDXL)       OFFSET TO MESSAGE 4
MOFF5    DC    AL2(TMSG5-ANDXL)       OFFSET TO MESSAGE 5
MOFF6    DC    AL2(TMSG6-ANDXL)       OFFSET TO MESSAGE 6
MOFF7    DC    AL2(TMSG7-ANDXL)       OFFSET TO MESSAGE 7
MOFF8    DC    AL2(TMSG8-ANDXL)       OFFSET TO MESSAGE 8
MOFF9    DC    AL2(TMSG9-ANDXL)       OFFSET TO MESSAGE 9
MOFF10   DC    AL2(TMSG10-ANDXL)      OFFSET TO MESSAGE 10
MOFF11   DC    AL2(TMSG11-ANDXL)      OFFSET TO MESSAGE 11
MOFF12   DC    AL2(TMSG12-ANDXL)      OFFSET TO MESSAGE 12
MOFF13   DC    AL2(TMSG13-ANDXL)      OFFSET TO MESSAGE 13
MOFF14   DC    AL2(TMSG14-ANDXL)      OFFSET TO MESSAGE 14
MOFF15   DC    AL2(TMSG15-ANDXL)      OFFSET TO MESSAGE 15
MOFF16   DC    AL2(TMSG16-ANDXL)      OFFSET TO MESSAGE 16
MOFF17   DC    AL2(TMSG17-ANDXL)      OFFSET TO MESSAGE 17
MOFF18   DC    AL2(TMSG18-ANDXL)      OFFSET TO MESSAGE 18
MOFF19   DC    AL2(TMSG19-ANDXL)      OFFSET TO MESSAGE 19
MOFF20   DC    AL2(TMSG20-ANDXL)      OFFSET TO MESSAGE 20
MOFF21   DC    AL2(TMSG21-ANDXL)      OFFSET TO MESSAGE 21
MOFF22   DC    AL2(TMSG22-ANDXL)      OFFSET TO MESSAGE 22
MOFF23   DC    AL2(TMSG23-ANDXL)      OFFSET TO MESSAGE 23
MOFF24   DC    AL2(TMSG24-ANDXL)      OFFSET TO MESSAGE 24
MOFF25   DC    AL2(TMSG25-ANDXL)      OFFSET TO MESSAGE 25
MOFF26   DC    AL2(TMSG26-ANDXL)      OFFSET TO MESSAGE 26
MOFF27   DC    AL2(TMSG27-ANDXL)      OFFSET TO MESSAGE 27
MOFF28   DC    AL2(TMSG28-ANDXL)      OFFSET TO MESSAGE 28
MOFF29   DC    AL2(TMSG29-ANDXL)      OFFSET TO MESSAGE 29
MOFF30   DC    AL2(TMSG30-ANDXL)      OFFSET TO MESSAGE 30
MOFFND   DC    X'FFFF'                END OF OFFSET LIST
         SPACE 2
RMSGTXT  DS    0F                     NAME OF TEXT AREA
TMSG1    EQU   *
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG1TA)             PTR TO 1ST SEGMENT
TMSG1TA  DC    AL2(56)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ551I NOT ENOUGH MAIN STORAGE TO EXECUTE REFORMAT '
         SPACE 1
TMSG2    DS    0F
         DC    A(TMSG2A)              PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG2TA  DC    AL2(34)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ552I UTILITY SYSTEM ERROR+ '
TMSG2A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS2T2B)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS2T2A  DC    AL2(26)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ552I  ERROR CODE   '
TMS2T2B  DC    AL2(11)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'PUTLINE'
         SPACE 1
TMSG3    DS    0F
         DC    A(TMSG3A)              PTR TO NEXT LEVEL
         DC    A(2)                   NUMBER OF SEGMENTS
         DC    A(TMSG3TA)             PTR TO 1ST SEGMENT
         DC    A(TMSG3TB)             PTR TO 2ND SEGMENT
TMSG3TA  DC    AL2(34)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ554I  DATA SET NOT USABLE+ '
TMSG3TB  DC    AL2(11)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'SYSUADN '
TMSG3A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF POINTERS
         DC    A(TMS3T2A)             PTR TO 1ST SEGMENT
TMS3T2A  DC    AL2(32)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ554I CANNOT OPEN DATA SET'
         SPACE 1
TMSG4    DS    0F
         DC    A(TMSG3A)              PTR TO NEXT LEVEL
         DC    A(2)                   NUMBER OF SEGMENTS
         DC    A(TMSG3TA)             PTR TO 1ST SEGMENT
         DC    A(TMSG4TB)             PTR TO 2ND SEGMENT
TMSG4TB  DC    AL2(11)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'SYSUADS '
         SPACE 1
TMSG5    DS    0F
         DC    A(2)                   NUMBER OF SEGMENTS
         DC    A(TMSG5TA)             PTR TO 1ST SEGMENT
         DC    A(0)                   PTR TO 2ND SEGMENT
TMSG5TA  DC    AL2(30)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ556I USERID  NOT FOUND '
         SPACE 1
TMSG6    DS    0F
         DC    A(4)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG6TA)             PTR TO 1ST SEGMENT
         DC    A(TMSG6TB)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
         DC    A(TMSG6TC)             PTR TO 4TH SEGMENT
TMSG6TA  DC    AL2(14)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ555I   '
TMSG6TB  DC    AL2(22)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'UNABLE TO REFORMAT'
TMSG6TC  DC    AL2(19)                LENGTH OF SEGMENT
         DC    AL2(9)                 TEXT OFFSET
         DC    C', USERID IN USE'
         SPACE 1
TMSG7    DS    0F
         DC    A(0)                   NO SEGMENT/LEVEL PTR
         DC    A(0)                   NO SEGMENTS
         DC    A(TMST7)               PTR TO 1ST SEGMENT
TMST7    DC    AL2(0)                 NO LENGTH
         DC    AL2(0)                 NO OFFSET
         DC    C'    '                BLANKS
         SPACE 1
TMSG8    DS    0F
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG8TA)             PTR TO 1ST SEGMENT
TMSG8TA  DC    AL2(24)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ550I REFORMATTED '
         SPACE 1
TMSG9    DS    0F
         DC    A(TMSG9A)              PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG9A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMSG9TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMSG9TA  DC    AL2(8)                 LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'STAE'
         SPACE 1
TMSG10   DS    0F
         DC    A(TMS10A)              PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS10TA)             PTR TO 1ST SEGMENT
TMS10TA  DC    AL2(40)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ553I UNABLE TO EXECUTE REFORMAT+ '
TMS10A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS10TB)             PTR TO 1ST SEGMENT
TMS10TB  DC    AL2(34)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ553I SYSUADN RDJFCB FAILURE'
         SPACE 1
TMSG11   DS    0F
         DC    A(TMS11A)              PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS10TA)             PTR TO 1ST SEGMENT
TMS11A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS11TB)             PTR TO 1ST SEGMENT
TMS11TB  DC    AL2(34)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ553I SYSUADS RDJFCB FAILURE'
         SPACE 1
TMSG12   DS    0F
         DC    A(TMS12A)              PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS12TA)             PTR TO 1ST SEGMENT
TMS12TA  DC    AL2(40)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ557I UADSREFM ENDED DUE TO ERROR+'
TMS12A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(2)                   NUMBER OF SEGMENTS
         DC    A(TMS12TB)             PTR TO 1ST SEGMENT
         DC    A(0)                   PTR TO 2ND SEGMENT
TMS12TB  DC    AL2(36)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ557I UTILITY COMPLETION CODE '
         SPACE 1
TMSG13   DS    0F
         DC    A(TMSG13A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG13A  DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS13TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS13TA  DC    AL2(7)                 LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'ENQ'
         SPACE 1
TMSG14   DS    0F
         DC    A(TMS14A)              PTR TO NEXT LEVEL
         DC    A(2)                   NUMBER OF SEGMENTS
         DC    A(TMSG3TA)             PTR TO 1ST SEGMENT
         DC    A(TMSG4TB)             PTR TO 2ND SEGMENT
TMS14A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS14TA)             PTR TO 1ST SEGMENT
         DC    A(TMS14TB)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS14TA  DC    AL2(28)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ554I  I/O ERROR CODE '
TMS14TB  DC    AL2(8)                 LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'STOW'
         SPACE 1
TMSG15   DS    0F
         DC    A(TMSG15A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS10TA)             PTR TO 1ST SEGMENT
         SPACE 1
TMSG15A  DS    0F
         DC    A(0)                   NO PTR TO NEXT SEGMENT
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS15TA)             PTR TO 1ST SEGMENT
TMS15TA  DC    AL2(40)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ553I SYSUADS BLOCKSIZE TOO SMALL '
         SPACE 1
TMSG16   DS    0F
         DC    A(2)                   NUMBER OF SEGMENTS
         DC    A(TMS16TA)             PTR TO 1ST SEGMENT
         DC    A(0)                   PTR TO 2ND SEGMENT
TMS16TA  DC    AL2(56)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ551I NOT ENOUGH MAIN STORAGE TO REFORMAT USERID  '
         SPACE 1
TMSG17   DS    0F
         DC    A(TMSG17A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG17A  DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS17TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS17TA  DC    AL2(8)                 LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'READ'
         SPACE 1
TMSG18   DS    0F
         DC    A(4)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG6TA)             PTR TO 1ST SEGMENT
         DC    A(TMSG6TB)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
         DC    A(TMS18TA)             PTR TO 4TH SEGMENT
TMS18TA  DC    AL2(34)                LENGTH OF SEGMENT
         DC    AL2(9)                 TEXT OFFSET
         DC    C', SYSUADS BLOCKSIZE TOO SMALL '
         SPACE 1
TMSG19   DS    0F
         DC    A(TMSG19A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG19A  DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS19TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS19TA  DC    AL2(12)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'GETSPACE'
         SPACE 1
TMSG20   DS    0F
         DC    A(0)                   NO SEGMENT/LEVEL PTR
         DC    A(0)                   NO SEGMENTS
         DC    A(TMST20)              PTR TO 1ST SEGMENT
TMST20   DC    AL2(0)                 NO LENGTH
         DC    AL2(0)                 NO OFFSET
         DC    C'    '                BLANKS
         SPACE 1
TMSG21   DS    0F
         DC    A(TMSG21A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG21A  DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS21TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS21TA  DC    AL2(13)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'BACKSPACE '
         SPACE 1
TMSG22   DS    0F
         DC    A(0)                   NO SEGMENT/LEVEL PTR
         DC    A(0)                   NO SEGMENTS
         DC    A(TMST22)              PTR TO 1ST SEGMENT
TMST22   DC    AL2(0)                 NO LENGTH
         DC    AL2(0)                 NO OFFSET
         DC    C'    '                BLANKS
         SPACE 1
TMSG23   DS    0F
         DC    A(TMSG23A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG23A  DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS23TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS23TA  DC    AL2(10)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'WRITE '
         SPACE 1
TMSG24   DS    0F
         DC    A(0)                   NO SEGMENT/LEVEL PTR
         DC    A(0)                   NO SEGMENTS
         DC    A(TMST24)              PTR TO 1ST SEGMENT
TMST24   DC    AL2(0)                 NO LENGTH
         DC    AL2(0)                 NO OFFSET
         DC    C'    '                BLANKS
         SPACE 1
TMSG25   DS    0F
         DC    A(0)                   NO SEGMENT/LEVEL PTR
         DC    A(0)                   NO SEGMENTS
         DC    A(TMST25)              PTR TO 1ST SEGMENT
TMST25   DC    AL2(0)                 NO LENGTH
         DC    AL2(0)                 NO OFFSET
         DC    C'    '                BLANKS
         SPACE 1
TMSG26   DS    0F
         DC    A(TMS26A)              PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS10TA)             PTR TO 1ST SEGMENT
TMS26A   DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF SEGMENTS
         DC    A(TMS26TA)             PTR TO 1ST SEGMENT
TMS26TA  DC    AL2(56)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ553I NONIDENTICAL BLOCKSIZES FOR SYSUADN/SYSUADS '
         SPACE 1
TMSG27   DS    0F
         DC    A(TMSG27A)             PTR TO NEXT LEVEL
         DC    A(1)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG2TA)             PTR TO 1ST SEGMENT
TMSG27A  DS    0F
         DC    A(0)                   NO PTR TO NEXT LEVEL
         DC    A(3)                   NUMBER OF SEGMENTS
         DC    A(TMS2T2A)             PTR TO 1ST SEGMENT
         DC    A(TMS27TA)             PTR TO 2ND SEGMENT
         DC    A(0)                   PTR TO 3RD SEGMENT
TMS27TA  DC    AL2(8)                 LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'DEQ '
         SPACE 1
TMSG28   DS    0F
         DC    A(3)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMSG8TA)             PTR TO 1ST SEGMENT
         DC    A(TMS28TA)             PTR TO 2ND SEGMENT
         DC    A(TMS28TB)             PTR TO 3RD SEGMENT
TMS28TA  DC    AL2(12)                LENGTH OF SEGMENT
         DC    AL2(8)                 TEXT OFFSET
         DC    C'USERIDS '
TMS28TB  DC    AL2(6)                LENGTH OF SEGMENT
         DC    AL2(20)               TEXT OFFSET
         DC    C'--'
         SPACE 1
TMSG29   DS    0F
         DC    A(2)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMS29TA)             PTR TO 1ST SEGMENT
         DC    A(TMS29TB)             PTR TO 2ND SEGMENT
TMS29TA  DC    AL2(38)                LENGTH OF SEGMENT
         DC    AL2(0)                 TEXT OFFSET
         DC    C'IKJ5558I UNABLE TO CLOSE  DATA SET'
TMS29TB  DC    AL2(11)                LENGTH OF SEGMENT
         DC    AL2(25)                TEXT OFFSET
         DC    C'SYSUADS'
         SPACE 1
TMSG30   DS    0F
         DC    A(2)                   NUMBER OF MESSAGE SEGMENTS
         DC    A(TMS29TA)             PTR TO 1ST SEGMENT
         DC    A(TMS30TA)             PTR TO 2ND SEGMENT
TMS30TA  DC    AL2(11)                LENGTH OF SEGMENT
         DC    AL2(25)                TEXT OFFSET
         DC    C'SYSUADN'
         SPACE 1
TXTEND   DC    X'FFFF'                END OF TEXT AREA
         SPACE 1
         END
