         TITLE 'IKTCAS40 - CONSOLE COMMUNICATIONS DRIVER'
IKTCAS40 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IKTCAS40  80.263'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         ST    @13,@SA00001+4                                   01S0001
         LA    @14,@SA00001                                     01S0001
         ST    @14,8(,@13)                                      01S0001
         LR    @13,@14                                          01S0001
         EJECT
*                                                               01S0028
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS PROGRAM IS ORGANIZED AS FOLLOWS:                         */
*/*                                                                  */
*/*        A - HOUSEKEEPING                                          */
*/*                                                                  */
*/*        B - MAINLINE, WHICH CONSISTS OF THE FOLLOWING:            */
*/*            1)  WAIT ON A LIST OF ECB'S                           */
*/*            2)  PROCESS AN OPERATOR COMMAND (IF ENTERED)          */
*/*            3)  PROCESS THE SYNCHRONOUS QUEUE                     */
*/*            4)  PROCESS MY STOP QUEUE (VIA IKTCAS41)              */
*/*            5)  PROCESS MY MODIFY QUEUE (VIA IKTCAS42)            */
*/*            6)  IF A STOP SUB-TASK COMMAND HAS NOT BEEN           */
*/*                GENERATED, GO BACK AND WAIT ON THE ECB'S          */
*/*                                                                  */
*/*        C - CLEANUP AND RETURN                                    */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0028
*   TWAPTR=R1;                      /* PICK UP WORK AREA PTR         */
         LR    TWAPTR,R1                                        01S0028
*   GOSW='1'B;                      /* INITIALIZE GO SWITCH          */
         OI    GOSW,B'10000000'                                 01S0029
*   TWACSKIP='N';                   /* INITIALIZE SKIP SWITCH        */
         MVI   TWACSKIP(TWAPTR),C'N'                            01S0030
*   ECBADDR1=CHECBP;                /* SET UP                        */
         L     @10,CSCBPTR(,TWAPTR)                             01S0031
         L     @00,CHECBP(,@10)                                 01S0031
         ST    @00,ECBADDR1                                     01S0031
*   ECBADDR2=ADDR(TWACECB);         /* ECB                           */
         LA    @00,TWACECB(,TWAPTR)                             01S0032
         ST    @00,ECBADDR2                                     01S0032
*   ECBEND='80'X;                   /* WAIT LIST                     */
         MVI   ECBEND,X'80'                                     01S0033
*   TWACEIFC(1)=1;                  /* SET UP ESTAE                  */
         MVI   TWACEIFC(TWAPTR),X'01'                           01S0034
*   TWACERA(1)=0;                   /* FOOTPRINTS                    */
         SLR   @15,@15                                          01S0035
         STCM  @15,7,TWACERA(TWAPTR)                            01S0035
*   TWACERRS(1)=0;                  /* LIST                          */
         ST    @15,TWACERRS(,TWAPTR)                            01S0036
*   R2=ADDR(CHCIBP);                /* LOAD CIB PTR                  */
         LA    R2,CHCIBP(,@10)                                  01S0037
*   GEN CODE(QEDIT  ORIGIN=(R2),CIBCTR=3);                      01S0038
         QEDIT  ORIGIN=(R2),CIBCTR=3
*   DO WHILE(GOSW='1'B);            /* MAINLINE CODE                 */
         B     @DE00039                                         01S0039
@DL00039 DS    0H                                               01S0040
*     CALL CHKECBS;                 /* CHK FOR OPERATOR CMND         */
         BAL   @14,CHKECBS                                      01S0040
*     CALL CHKSYNCQ;                /* PROCESS SYNC Q                */
         BAL   @14,CHKSYNCQ                                     01S0041
*     CALL IKTCAS41;                /* PROCESS STOP Q                */
         L     @15,@CV00058                                     01S0042
         BALR  @14,@15                                          01S0042
*     CALL IKTCAS42;                /* PROCESS MODIFY Q              */
         L     @15,@CV00059                                     01S0043
         BALR  @14,@15                                          01S0043
*     TWACSKIP='N';                 /* TURN OFF SKIP SWITCH          */
         MVI   TWACSKIP(TWAPTR),C'N'                            01S0044
*     IF GOSW='1'B THEN             /* IF CONT SW IS ON              */
         TM    GOSW,B'10000000'                                 01S0045
         BNO   @RF00045                                         01S0045
*       DO;                         /* YES,CONTINUE                  */
*         GEN SETS(ECBLIST);                                    01S0047
         WAIT  ECBLIST=ECBLIST     WAIT ON ECB LIST FOR WORK
*       END;                                                    01S0048
*   END;                            /* GO BACK TO SLEEP              */
@RF00045 DS    0H                                               01S0049
@DE00039 TM    GOSW,B'10000000'                                 01S0049
         BO    @DL00039                                         01S0049
*   TWACEIFC(1)=0;                  /* CLEAR ESTAE FOOTPRINTS        */
         MVI   TWACEIFC(TWAPTR),X'00'                           01S0050
*   RETURN CODE(0);                 /* FINISHED                      */
         SLR   @15,@15                                          01S0051
         L     @13,4(,@13)                                      01S0051
         L     @14,12(,@13)                                     01S0051
         LM    @00,@12,20(@13)                                  01S0051
         BR    @14                                              01S0051
         EJECT
*CHKECBS:                                                       01S0052
*   PROC OPTIONS(SAVE(14));                                     01S0052
CHKECBS  ST    @14,@SA00002                                     01S0052
*                                                               01S0053
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE HANDLES THE COMMAND(S) ENTERED BY THE         */
*/*    OPERATOR (IF ANY).  THE MAIN PROCESSING IS AS FOLLOWS:        */
*/*                                                                  */
*/*    -   ZERO OUT TWACECB (ECB USED BY OTHER TASKS TO POST ME)     */
*/*    -   IF OPERATOR COMMAND ECB NOT POSTED, EXIT                  */
*/*    -   ZERO OUT OPERATOR COMMAND ECB                             */
*/*    -   IF CIB Q IS EMPTY, EXIT                                   */
*/*    -   USING THE FIRST CIB IN THE Q, BUILD THE PROPER TYPE OF    */
*/*        W.E.                                                      */
*/*    -   PUT THE W.E. ON THE PROPER ASYNCHRONOUS Q                 */
*/*    -   DEQUEUE THE CIB USING THE QEDIT MACRO                     */
*/*    -   GO BACK UP AND SEE IF THE CIB Q IS NOW EMPTY              */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0053
*   TWACECB=TWACECB&&TWACECB;       /* CLEAR MY WAIT ECB             */
         XC    TWACECB(4,TWAPTR),TWACECB(TWAPTR)                01S0053
*   GEN REFS(R0,R1,R14,R15)(MODESET KEY=ZERO,MODE=SUP);         01S0054
         MODESET KEY=ZERO,MODE=SUP
*   OPRTRECB=OPRTRECB&&OPRTRECB;    /* CLEAR OPERATOR ECB            */
         L     @10,CSCBPTR(,TWAPTR)                             01S0055
         L     @10,CHECBP(,@10)                                 01S0055
         XC    OPRTRECB(4,@10),OPRTRECB(@10)                    01S0055
*   GEN REFS(R0,R1,R14,R15)(MODESET KEY=NZERO,MODE=PROB);       01S0056
         MODESET KEY=NZERO,MODE=PROB
*   DO WHILE(CIBPTR^=0);            /* PROCESS CIB Q                 */
         B     @DE00057                                         01S0057
@DL00057 DS    0H                                               01S0058
*     IF CIBVERB='40'X THEN         /* IS THIS A STOP CIB            */
         L     @10,CSCBPTR(,TWAPTR)                             01S0058
         L     @10,CIBPTR(,@10)                                 01S0058
         CLI   CIBVERB(@10),X'40'                               01S0058
         BNE   @RF00058                                         01S0058
*       CALL BLDSTPWE;              /* YES - BUILD STOP W.E.         */
         BAL   @14,BLDSTPWE                                     01S0059
*     ELSE                          /* NO - TRY ANOTHER CODE         */
*       IF CIBVERB='44'X THEN       /* IS THIS A MODIFY CIB          */
         B     @RC00058                                         01S0060
@RF00058 L     @10,CSCBPTR(,TWAPTR)                             01S0060
         L     @10,CIBPTR(,@10)                                 01S0060
         CLI   CIBVERB(@10),X'44'                               01S0060
         BNE   @RF00060                                         01S0060
*         CALL BLDMODWE;            /* YES - BUILD MODIFY W.E.       */
         BAL   @14,BLDMODWE                                     01S0061
*     R2=ADDR(CHCIBP);              /* ADDR OF CIB PTR               */
@RF00060 DS    0H                                               01S0062
@RC00058 L     @10,CSCBPTR(,TWAPTR)                             01S0062
         LA    R2,CHCIBP(,@10)                                  01S0062
*     R3=CHCIBP;                    /* ADDR OF CIB TO BE FREED       */
         L     R3,CHCIBP(,@10)                                  01S0063
*     GEN REFS(R0,R1,R2,R3,R14,R15)(QEDIT ORIGIN=(R2),BLOCK=(R3));/*
*                                      FREE CIB                      */
         QEDIT ORIGIN=(R2),BLOCK=(R3)
*   END;                            /* END PROCESS CIB Q             */
@DE00057 L     @10,CSCBPTR(,TWAPTR)                             01S0065
         L     @10,CIBPTR(,@10)                                 01S0065
         LTR   @10,@10                                          01S0065
         BNZ   @DL00057                                         01S0065
*   END CHKECBS;                                                01S0066
@EL00002 DS    0H                                               01S0066
@EF00002 DS    0H                                               01S0066
@ER00002 L     @14,@SA00002                                     01S0066
         BR    @14                                              01S0066
         EJECT
*BLDSTPWE:                                                      01S0067
*   PROC OPTIONS(SAVE(14));                                     01S0067
BLDSTPWE ST    @14,@SA00003                                     01S0067
*                                                               01S0068
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE WILL GET THE SPACE FOR A STOP W.E., BUILD     */
*/*    IT, AND THEN Q IT ON THE STOP Q                               */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0068
*   LENGTH=16;                      /* LENGTH OF W.E.                */
         LA    LENGTH,16                                        01S0068
*   SUBPL=4;                        /* SUBPOOL NUMBER                */
         LA    SUBPL,4                                          01S0069
*   CALL GETSPACE;                  /* GET SPACE                     */
         BAL   @14,GETSPACE                                     01S0070
*   WECODE1T=TCCONSLE;              /* MY TASK                       */
         L     @10,WEPTR                                        01S0071
         MVI   WECODE1T(@10),X'04'                              01S0071
*   WECODE2T=TCCONSLE;              /* CODE                          */
         MVI   WECODE2T(@10),X'04'                              01S0072
*   WECODE1F=FCCSTOP;               /* STOP FUNCTION                 */
         MVI   WECODE1F(@10),X'11'                              01S0073
*   WECODE2F=FCCSTOP;               /* CODE                          */
         MVI   WECODE2F(@10),X'11'                              01S0074
*   WERC=0;                         /* ZERO OUT                      */
         SLR   @04,@04                                          01S0075
         STH   @04,WERC(,@10)                                   01S0075
*   WELEN=LENGTH;                   /* LENGTH OF W.E.                */
         STH   LENGTH,WELEN(,@10)                               01S0076
*LOOP1:                             /* COMPARE AND SWAP LOOP         */
*   TEMPPTR=TWACSTPQ;               /* CURRENT POINTER               */
LOOP1    L     TEMPPTR,TWACSTPQ(,TWAPTR)                        01S0077
*   WENEXT=TEMPPTR;                 /* SET UP CHAIN FIELD            */
         L     @10,WEPTR                                        01S0078
         ST    TEMPPTR,WENEXT(,@10)                             01S0078
*   CS(TEMPPTR,ADDRESS,TWACSTPQ);   /* TRY TO ADD ANOTHER W.E.       */
         L     @10,ADDRESS                                      01S0079
         CS    TEMPPTR,@10,TWACSTPQ(TWAPTR)                     01S0079
*   BC(7,LOOP1);                    /* DIDN'T WORK - TRY AGAIN       */
         BC    7,LOOP1                                          01S0080
*   END BLDSTPWE;                                               01S0081
@EL00003 DS    0H                                               01S0081
@EF00003 DS    0H                                               01S0081
@ER00003 L     @14,@SA00003                                     01S0081
         BR    @14                                              01S0081
         EJECT
*BLDMODWE:                                                      01S0082
*   PROC OPTIONS(SAVE(14));                                     01S0082
BLDMODWE ST    @14,@SA00004                                     01S0082
*                                                               01S0083
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE WILL GET THE SPACE FOR A MODIFY W.E., BUILD   */
*/*    IT, AND THEN Q IT ON THE MODIFY Q                             */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0083
*                                   /* CALCULATE THE SIZE OF THE W.E.
*                                      BY ADDING 12 (FOR THE SIZE OF
*                                      THE FIXED PART), CIBDATLN+4
*                                      (FOR THE SIZE OF THE VARIABLE
*                                      PART) AND ROUNDING UP TO THE
*                                      NEXT DOUBLEWORD               */
*   LENGTH=((12+CIBDATLN+4)+7)/8*8;                             01S0083
         L     @10,CSCBPTR(,TWAPTR)                             01S0083
         L     @10,CIBPTR(,@10)                                 01S0083
         LA    @04,23                                           01S0083
         AH    @04,CIBDATLN(,@10)                               01S0083
         SRDA  @04,32                                           01S0083
         D     @04,@CF00065                                     01S0083
         SLA   LENGTH,3                                         01S0083
*   SUBPL=4;                        /* SUBPOOL NUMBER                */
         LA    SUBPL,4                                          01S0084
*   CALL GETSPACE;                  /* GET SPACE                     */
         BAL   @14,GETSPACE                                     01S0085
*   WECODE1T=TCCONSLE;              /* MY TASK                       */
         L     @10,WEPTR                                        01S0086
         MVI   WECODE1T(@10),X'04'                              01S0086
*   WECODE2T=TCCONSLE;              /* CODE                          */
         MVI   WECODE2T(@10),X'04'                              01S0087
*   WECODE1F=FCCMODFY;              /* MODIFY FUNCTION               */
         MVI   WECODE1F(@10),X'21'                              01S0088
*   WECODE2F=FCCMODFY;              /* CODE                          */
         MVI   WECODE2F(@10),X'21'                              01S0089
*   WERC=0;                         /* ZERO OUT                      */
         SLR   @04,@04                                          01S0090
         STH   @04,WERC(,@10)                                   01S0090
*   WELEN=LENGTH;                   /* LENGTH OF W.E.                */
         STH   LENGTH,WELEN(,@10)                               01S0091
*   WEDATA(1:CIBDATLN+4)=BLANKS;    /* SPACE OUT                     */
         L     @05,CSCBPTR(,TWAPTR)                             01S0092
         L     @05,CIBPTR(,@05)                                 01S0092
         LH    @15,CIBDATLN(,@05)                               01S0092
         LA    @14,3                                            01S0092
         ALR   @14,@15                                          01S0092
         EX    @14,@SM00404                                     01S0092
*   IF CIBDATLN>0 THEN              /* IF PARMS ENTERED THEN         */
         CR    @15,@04                                          01S0093
         BNH   @RF00093                                         01S0093
*     MVC(WEDATA(1:CIBDATLN),CIBDATA);/* SAVE PARAMETERS FROM MODIFY
*                                      COMMAND                       */
         L     @04,CSCBPTR(,TWAPTR)                             01S0094
         L     @04,CIBPTR(,@04)                                 01S0094
         LH    @04,CIBDATLN(,@04)                               01S0094
         BCTR  @04,0                                            01S0094
         EX    @04,@SM00406                                     01S0094
*LOOP2:                             /* COMPARE AND SWAP LOOP         */
*   TEMPPTR=TWACMODQ;               /* CURRENT POINTER               */
@RF00093 DS    0H                                               01S0095
LOOP2    L     TEMPPTR,TWACMODQ(,TWAPTR)                        01S0095
*   WENEXT=TEMPPTR;                 /* SET UP CHAIN FIELD            */
         L     @10,WEPTR                                        01S0096
         ST    TEMPPTR,WENEXT(,@10)                             01S0096
*   CS(TEMPPTR,ADDRESS,TWACMODQ);   /* TRY TO ADD ANOTHER W.E.       */
         L     @10,ADDRESS                                      01S0097
         CS    TEMPPTR,@10,TWACMODQ(TWAPTR)                     01S0097
*   BC(7,LOOP2);                    /* DIDN'T WORK - TRY AGAIN       */
         BC    7,LOOP2                                          01S0098
*   END BLDMODWE;                                               01S0099
@EL00004 DS    0H                                               01S0099
@EF00004 DS    0H                                               01S0099
@ER00004 L     @14,@SA00004                                     01S0099
         BR    @14                                              01S0099
         EJECT
*CHKSYNCQ:                                                      01S0100
*   PROC OPTIONS(SAVE(14));                                     01S0100
CHKSYNCQ ST    @14,@SA00005                                     01S0100
*                                                               01S0101
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE PROCESSES THE W.E.'S FOUND ON THE             */
*/*    SYNCHRONOUS QUEUE.  THE MAIN PROCESSING IS AS FOLLOWS:        */
*/*                                                                  */
*/*    -   IF THE Q IS EMPTY, EXIT                                   */
*/*    -   IF THE FIRST W.E. IS NOT FOR ME, POST THE OWNER, EXIT,    */
*/*        AND GO BACK TO SLEEP                                      */
*/*    -   PROCESS THE W.E., AND DEQUEUE IT                          */
*/*    -   IF THE Q IS NOW EMPTY, POST ALL OF THE OTHER SUB-TASKS    */
*/*        AND EXIT                                                  */
*/*    -   IF THE TOP W.E. IS FOR ME, GO BACK UP TO THE PROCESS W.E. */
*/*        LINE AND LOOP BACK THRU                                   */
*/*  ************************* ***************O********************* */
*                                                               01S0101
*   RFY                                                         01S0101
*     WESTD BASED(TWASYNQH);        /* SET UP NEW BASE FOR W.E       */
*   IF TWASYNQH^=0 THEN             /* IS SYNC Q NON-EMPTY           */
         L     @10,TWASYNQH(,TWAPTR)                            01S0102
         LTR   @10,@10                                          01S0102
         BZ    @RF00102                                         01S0102
*     DO;                           /* YES-PROCESS AND DEQUEUE W.E.'S
*                                      WHILE Q NOT EMPTY AND TOP W.E.
*                                      IS MINE                       */
*       DO WHILE(TWASYNQH^=0&WECODE1T=TCCONSLE);                01S0104
         B     @DE00104                                         01S0104
@DL00104 DS    0H                                               01S0105
*         ADDRESS=TWASYNQH;         /* SAVE FOR PRCSSYNE             */
         L     @10,TWASYNQH(,TWAPTR)                            01S0105
         ST    @10,ADDRESS                                      01S0105
*         TEMPPTR=WENEXT;           /* PT TO NEXT W.E. ON CHAIN      */
         L     TEMPPTR,WENEXT(,@10)                             01S0106
*         CS(TWASYNQH,TEMPPTR,TWASYNQH);/* DEQUEUE TOP W.E.          */
         L     @10,TWASYNQH(,TWAPTR)                            01S0107
         CS    @10,@05,TWASYNQH(TWAPTR)                         01S0107
         BZ    @BC00107                                         01S0107
         ST    @10,TWASYNQH(,TWAPTR)                            01S0107
@BC00107 DS    0H                                               01S0108
*         CALL PRCSSYNE;            /* PROCESS JUST DEQUED W.E.      */
         BAL   @14,PRCSSYNE                                     01S0108
*       END;                        /* LOOP BACK THRU                */
@DE00104 L     @10,TWASYNQH(,TWAPTR)                            01S0109
         LTR   @10,@10                                          01S0109
         BZ    @DC00104                                         01S0109
         CLI   WECODE1T(@10),X'04'                              01S0109
         BE    @DL00104                                         01S0109
@DC00104 DS    0H                                               01S0110
*       IF TWASYNQH=0 THEN          /* IS Q EMPTY                    */
         L     @10,TWASYNQH(,TWAPTR)                            01S0110
         LTR   @10,@10                                          01S0110
         BNZ   @RF00110                                         01S0110
*         DO;                       /* YES - POST EVERYBODY          */
*           R1=ADDR(TWAMECB);       /* ADDR OF ECB TO POST           */
         LA    R1,TWAMECB(,TWAPTR)                              01S0112
*           GEN(POST      (1))      /* POST MAIN TASK                */
*           REFS(R0,R1,R14,R15);                                01S0113
         POST      (1)
*           R1=ADDR(TWAVECB);       /* ADDR OF ECB TO POST           */
         LA    R1,TWAVECB(,TWAPTR)                              01S0114
*           GEN(POST      (1))      /* POST VTAM SUB-TASK            */
*           REFS(R0,R1,R14,R15);                                01S0115
         POST      (1)
*           R1=ADDR(TWAUECB);       /* ADDR OF ECB TO POST           */
         LA    R1,TWAUECB(,TWAPTR)                              01S0116
*           GEN(POST      (1))      /* POST USER SUB-TASK            */
*           REFS(R0,R1,R14,R15);                                01S0117
         POST      (1)
*         END;                                                  01S0118
*       ELSE                                                    01S0119
*         DO;                       /* NO                            */
         B     @RC00110                                         01S0119
@RF00110 DS    0H                                               01S0120
*           CALL POSTIT;            /* POST PROPER TASK              */
         BAL   @14,POSTIT                                       01S0120
*           TWACSKIP='Y';           /* AND GO BACK TO SLEEP          */
         MVI   TWACSKIP(TWAPTR),C'Y'                            01S0121
*         END;                                                  01S0122
*     END;                                                      01S0123
*   RFY                                                         01S0124
*     WESTD;                        /* REVERT TO OLD BASE            */
*   END CHKSYNCQ;                                               01S0125
@EL00005 DS    0H                                               01S0125
@EF00005 DS    0H                                               01S0125
@ER00005 L     @14,@SA00005                                     01S0125
         BR    @14                                              01S0125
         EJECT
*POSTIT:                                                        01S0126
*   PROC OPTIONS(SAVE(14));                                     01S0126
POSTIT   ST    @14,@SA00006                                     01S0126
*                                                               01S0127
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE WILL POST THE TASK WHOSE W.E. IS ON TOP OF    */
*/*    THE SYNC Q.                                                   */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0127
*   RFY                                                         01S0127
*     WESTD BASED(TWASYNQH);        /* SET UP NEW BASE FOR W.E.      */
*   IF WECODE1T=TCMAIN THEN         /* W.E. FOR MAIN TASK            */
         L     @10,TWASYNQH(,TWAPTR)                            01S0128
         CLI   WECODE1T(@10),X'01'                              01S0128
         BNE   @RF00128                                         01S0128
*     DO;                           /* YES                           */
*       R1=ADDR(TWAMECB);           /* ADDR OF ECB TO POST           */
         LA    R1,TWAMECB(,TWAPTR)                              01S0130
*       GEN(POST  (1))              /* POST HIM                      */
*       REFS(R0,R1,R14,R15);                                    01S0131
         POST  (1)
*     END;                                                      01S0132
*   ELSE                            /* NO                            */
*     IF WECODE1T=TCVTAM THEN       /* W.E. FOR VTAM SUB-TASK        */
         B     @RC00128                                         01S0133
@RF00128 L     @10,TWASYNQH(,TWAPTR)                            01S0133
         CLI   WECODE1T(@10),X'02'                              01S0133
         BNE   @RF00133                                         01S0133
*       DO;                         /* YES                           */
*         R1=ADDR(TWAVECB);         /* ADDR OF ECB TO POST           */
         LA    R1,TWAVECB(,TWAPTR)                              01S0135
*         GEN(POST    (1))          /* POST HIM                      */
*         REFS(R0,R1,R14,R15);                                  01S0136
         POST    (1)
*       END;                                                    01S0137
*     ELSE                          /* NO - FOR USER SUB-TASK        */
*       DO;                                                     01S0138
         B     @RC00133                                         01S0138
@RF00133 DS    0H                                               01S0139
*         R1=ADDR(TWAUECB);         /* ADDR OF ECB TO POST           */
         LA    R1,TWAUECB(,TWAPTR)                              01S0139
*         GEN(POST    (1))          /* POST HIM                      */
*         REFS(R0,R1,R14,R15);                                  01S0140
         POST    (1)
*       END;                                                    01S0141
*   RFY                                                         01S0142
*     WESTD;                        /* REVERT TO OLD BASE            */
*   END POSTIT;                                                 01S0143
@EL00006 DS    0H                                               01S0143
@EF00006 DS    0H                                               01S0143
@ER00006 L     @14,@SA00006                                     01S0143
         BR    @14                                              01S0143
         EJECT
*PRCSSYNE:                                                      01S0144
*   PROC OPTIONS(SAVE(14));                                     01S0144
PRCSSYNE ST    @14,@SA00007                                     01S0144
*                                                               01S0145
*/*  *****************************************************************/
*/*                                                                  */
*/*    THE PURPOSE OF THIS SUBROUTINE IS TO PROCESS A W.E. FROM THE  */
*/*    SYNC Q.  THE MAIN PROCESSING IS AS FOLLOWS:                   */
*/*                                                                  */
*/*    -   IF THE W.E. IS A NORMAL RETURN W.E., FREE UP THE SPACE    */
*/*        STARTING WITH THE ADDRESS OF THE W.E., USING THE LENGTH   */
*/*        FOUND IN 'WELEN', AND IN SUBPOOL 4.  IN ADDITION, IF THIS */
*/*        W.E. WAS PLACED HERE BY STOP PROCESSING, TURN 'GOSW' OFF  */
*/*        AND TURN ON 'TWACSKIP'.                                   */
*/*    -   IF THE W.E. IS AN END OF TASK W.E., TURN OFF 'GOSW' AND   */
*/*        TURN ON 'TWACSKIP'.                                       */
*/*    -   IF THE W.E. IS AN ABNORMAL RETURN MODIFY W.E., ISSUE AN   */
*/*        APPROPRIATE ERROR MESSAGE                                 */
*/*    -   EXIT                                                      */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0145
*   IF WECODE1F=FCRETURN THEN       /* NORMAL RETURN W.E.            */
         L     @10,WEPTR                                        01S0145
         CLI   WECODE1F(@10),X'FF'                              01S0145
         BNE   @RF00145                                         01S0145
*     DO;                           /* YES                           */
*       IF WECODE2F=FCCSTOP THEN    /* SET UP BY STOP COMMAND        */
         CLI   WECODE2F(@10),X'11'                              01S0147
         BNE   @RF00147                                         01S0147
*         DO;                       /* YES                           */
*           TWACSKIP='Y';           /* TURN ON SKIP SW               */
         MVI   TWACSKIP(TWAPTR),C'Y'                            01S0149
*           GOSW='0'B;              /* TURN OFF LOOP SW              */
         NI    GOSW,B'01111111'                                 01S0150
*         END;                                                  01S0151
*       LENGTH=WELEN;               /* LENGTH OF FREE SPACE          */
@RF00147 L     @10,WEPTR                                        01S0152
         LH    LENGTH,WELEN(,@10)                               01S0152
*       SUBPL=4;                    /* SUBPOOL NUMBER                */
         LA    SUBPL,4                                          01S0153
*       CALL FRESPACE;              /* FREE THE SPACE                */
         BAL   @14,FRESPACE                                     01S0154
*       RETURN;                     /* EXIT                          */
@EL00007 DS    0H                                               01S0155
@EF00007 DS    0H                                               01S0155
@ER00007 L     @14,@SA00007                                     01S0155
         BR    @14                                              01S0155
*     END;                                                      01S0156
*   IF WECODE1F=FCCEOT THEN         /* END OF TASK W.E.              */
@RF00145 L     @10,WEPTR                                        01S0157
         CLI   WECODE1F(@10),X'03'                              01S0157
         BNE   @RF00157                                         01S0157
*     DO;                           /* YES                           */
*       TWACSKIP='Y';               /* TURN ON SKIP SW               */
         MVI   TWACSKIP(TWAPTR),C'Y'                            01S0159
*       GOSW='0'B;                  /* TURN OFF LOOP SW              */
         NI    GOSW,B'01111111'                                 01S0160
*     END;                                                      01S0161
*   ELSE                            /* NO                            */
*     IF WECODE1F=FCCMODFY THEN     /* ABNRML RETURN MODFY W.E.      */
         B     @RC00157                                         01S0162
@RF00157 L     @10,WEPTR                                        01S0162
         CLI   WECODE1F(@10),X'21'                              01S0162
         BNE   @RF00162                                         01S0162
*       DO;                         /* YES                           */
*         IF WECODE2T=TCVTAM THEN   /* REJECTED BY VTAM INTER        */
         CLI   WECODE2T(@10),X'02'                              01S0164
         BNE   @RF00164                                         01S0164
*           DO;                     /* YES                           */
*             R1=11;                /* MESSAGE NUMBER                */
         LA    R1,11                                            01S0166
*             CALL MSGBLK;          /* ADDR OF LIST FORM OF MSG      */
         L     @15,TWAMSG(,TWAPTR)                              01S0167
         BALR  @14,@15                                          01S0167
*             MVC(IKT011I(1:MSGLNGTH),MSGDATA);/* MOVE LIST FORM     */
         L     @10,MSGLNGTH(,R1)                                01S0168
         BCTR  @10,0                                            01S0168
         EX    @10,@SM00409                                     01S0168
*             R1=ADDR(IKT011I);     /* ADDR OF LIST FORM             */
         LA    R1,IKT011I                                       01S0169
*             IF WECODE2F=FCVQUSCE THEN/* MOVE                       */
         L     @10,WEPTR                                        01S0170
         CLI   WECODE2F(@10),X'13'                              01S0170
         BNE   @RF00170                                         01S0170
*               IKT011IA='QUIESCE'; /* IN                            */
         MVC   IKT011IA(7),@CC00390                             01S0171
*             ELSE                  /* PROPER                        */
*               IKT011IA='ACCEPT '; /* IDENTIFIER            @ZA48384*/
         B     @RC00170                                         01S0172
@RF00170 MVC   IKT011IA(7),@CC00391                             01S0172
*             R3=WERC;              /* MOVE REASON CODE INTO WORK
*                                      REGISTER              @ZA48384*/
@RC00170 L     @10,WEPTR                                        01S0173
         LH    R3,WERC(,@10)                                    01S0173
*             CVD(R3,TEMPREAS);     /* CONVERT REASON CODE TO DECIMAL
*                                                            @ZA48384*/
         CVD   R3,TEMPREAS                                      01S0174
*             UNPK(IKT011IR,TEMPREAS(6:8));/* OBTAIN EBCDIC  @ZA48384*/
         UNPK  IKT011IR(5),TEMPREAS+5(3)                        01S0175
*             IKT011IR(5)=IKT011IR(5)|'F0'X;/* MAKE LAST CHARACTER
*                                      PRINTABLE             @ZA48384*/
         OI    IKT011IR+4,X'F0'                                 01S0176
*             GEN REFS(R0,R1,R14,R15)(WTO   MF=(E,(1)));/* ISSUE WTO */
         WTO   MF=(E,(1))
*           END;                                                01S0178
*       END;                                                    01S0179
*   END PRCSSYNE;                                               01S0180
         B     @EL00007                                         01S0180
         EJECT
*FRESPACE:                                                      01S0181
*   PROC OPTIONS(SAVE(14));                                     01S0181
FRESPACE ST    @14,@SA00008                                     01S0181
*                                                               01S0182
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE DOES A FREEMAIN FOR THE NUMBER OF BYTES       */
*/*    SPECIFIED IN 'LENGTH', USING THE ADDRESS FOUND IN 'ADDRESS'   */
*/*    AS A STARTING ADDRESS, AND USING THE VALUE FOUND IN 'SUBPL'   */
*/*    AS THE SUBPOOL NUMBER                                         */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0182
*   R2=LENGTH;                                                  01S0182
         LR    R2,LENGTH                                        01S0182
*   R3=SUBPL;                                                   01S0183
         LR    R3,SUBPL                                         01S0183
*   GEN(FREEMAIN EU,LV=(R2),A=ADDRESS,SP=(R3))                  01S0184
*   REFS(ADDRESS,R0,R1,R2,R3,R14,R15);                          01S0184
         FREEMAIN EU,LV=(R2),A=ADDRESS,SP=(R3)
*   END FRESPACE;                                               01S0185
@EL00008 DS    0H                                               01S0185
@EF00008 DS    0H                                               01S0185
@ER00008 L     @14,@SA00008                                     01S0185
         BR    @14                                              01S0185
         EJECT
*GETSPACE:                                                      01S0186
*   PROC OPTIONS(SAVE(14));                                     01S0186
GETSPACE ST    @14,@SA00009                                     01S0186
*                                                               01S0187
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE DOES A GETMAIN FOR THE NUMBER OF BYTES        */
*/*    SPECIFIED IN 'LENGTH' (SHOULD BE A DOUBLEWORD MULTIPLE),      */
*/*    FROM THE SUBPOOL SPECIFIED IN 'SUBPL', AND THEN PLACES THE    */
*/*    STARTING ADDRESS OF THE GETMAIN'ED AREA IN 'ADDRESS'.         */
*/*                                                                  */
*/*  *****************************************************************/
*                                                               01S0187
*   R2=LENGTH;                                                  01S0187
         LR    R2,LENGTH                                        01S0187
*   R3=SUBPL;                                                   01S0188
         LR    R3,SUBPL                                         01S0188
*   GEN(GETMAIN EU,LV=(R2),A=ADDRESS,SP=(R3))                   01S0189
*   REFS(ADDRESS,R0,R1,R2,R3,R14,R15);                          01S0189
         GETMAIN EU,LV=(R2),A=ADDRESS,SP=(R3)
*   END GETSPACE;                                               01S0190
@EL00009 DS    0H                                               01S0190
@EF00009 DS    0H                                               01S0190
@ER00009 L     @14,@SA00009                                     01S0190
         BR    @14                                              01S0190
*   DO;                             /* TPEPILOG                      */
*     GEN(PRINT OFF);                                           01S0192
         PRINT OFF
*     GEN(PRINT ON);                                            01S0193
         PRINT ON
*   END;                            /* TPEPILOG                      */
*   END IKTCAS40                                                01S0195
*                                                               01S0195
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (PROLOG  )                                       */
*/*%INCLUDE SYSUT5  (IKTCAS40)                                       */
*/*%INCLUDE SYSLIB  (IEECHAIN)                                       */
*/*%INCLUDE SYSLIB  (IEZCIB  )                                       */
*/*%INCLUDE SYSLIB  (IKTCASWA)                                       */
*                                                               01S0195
*       ;                                                       01S0195
@EL00001 L     @13,4(,@13)                                      01S0195
@EF00001 DS    0H                                               01S0195
@ER00001 LM    @14,@12,12(@13)                                  01S0195
         BR    @14                                              01S0195
@DATA    DS    0H
@SM00404 MVC   WEDATA(0,@10),BLANKS
@SM00406 MVC   WEDATA(0,@10),CIBDATA(@05)
@SM00409 MVC   IKT011I(0),MSGDATA(R1)
         DS    0F
@SA00001 DS    18F
@SA00002 DS    1F
@SA00005 DS    1F
@SA00003 DS    1F
@SA00004 DS    1F
@SA00009 DS    1F
@SA00007 DS    1F
@SA00006 DS    1F
@SA00008 DS    1F
         DS    0F
@CF00065 DC    F'8'
@CV00058 DC    V(IKTCAS41)
@CV00059 DC    V(IKTCAS42)
         DS    0D
ADDRESS  DS    A
@CC00390 DC    C'QUIESCE'
@CC00391 DC    C'ACCEPT '
BLANKS   DC    CL48' '
         DS    CL2
ECBLIST  DS    CL8
         ORG   ECBLIST
ECBADDR1 DS    FL4
ECBADDR2 DS    FL4
         ORG   ECBADDR2
ECBEND   DS    FL1
@NM00001 DS    FL3
         ORG   ECBLIST+8
SWITCHES DS    CL1
         ORG   SWITCHES
GOSW     DS    BL1
@NM00002 EQU   SWITCHES+0
         ORG   SWITCHES+1
         DS    CL3
IKT011I  DS    CL61
         ORG   IKT011I
@NM00004 DS    CL28
IKT011IA DS    CL7
@NM00005 DS    CL21
IKT011IR DS    CL5
         ORG   IKT011I+61
         DS    CL3
TEMPREAS DS    CL8
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
TEMPPTR  EQU   @05
SUBPL    EQU   @06
LENGTH   EQU   @05
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
TWAPTR   EQU   @11
R14      EQU   @14
R15      EQU   @15
OPRTRECB EQU   0
MSGBLK   EQU   0
@NM00003 EQU   0
MSGLNGTH EQU   @NM00003
MSGDATA  EQU   @NM00003+4
WESTD    EQU   0
WECODE1T EQU   WESTD
WECODE1F EQU   WESTD+1
WECODE2T EQU   WESTD+2
WECODE2F EQU   WESTD+3
WENEXT   EQU   WESTD+4
WERC     EQU   WESTD+8
WELEN    EQU   WESTD+10
WEDATA   EQU   WESTD+12
CHAIN    EQU   0
CHFLG    EQU   CHAIN+4
CHSTS    EQU   CHFLG+2
CHACT    EQU   CHFLG+3
CHKEY    EQU   CHAIN+8
CHPARM   EQU   CHKEY
CHPKE    EQU   CHAIN+28
CHTJID   EQU   CHAIN+30
CHPROCSN EQU   CHAIN+32
CHACT1   EQU   CHPROCSN+3
CHASM    EQU   CHAIN+40
CHECBP   EQU   CHASM
CHCIBP   EQU   CHASM+4
CHRGNSZ  EQU   CHASM+8
CHSTEP   EQU   CHASM+24
CHSWT    EQU   CHSTEP
CHSHORT  EQU   CHASM+32
CIBNAME  EQU   0
CIBVERB  EQU   CIBNAME+4
CIBASID  EQU   CIBNAME+10
CIBDATLN EQU   CIBNAME+14
CIBDATA  EQU   CIBNAME+16
TWAR     EQU   0
TWASYNQH EQU   TWAR+4
TWACSCB  EQU   TWAR+16
TWAMSG   EQU   TWAR+48
TWAMECB  EQU   TWAR+64
TWAMFL   EQU   TWAR+80
TWAVFL   EQU   TWAR+81
TWAUFL   EQU   TWAR+82
TWACFL   EQU   TWAR+83
TWAM     EQU   TWAR+84
TWAME    EQU   TWAM+68
TWAMEI   EQU   TWAME
TWAV     EQU   TWAR+184
TWAVE    EQU   TWAV+68
TWAVEI   EQU   TWAVE
TWAVI    EQU   TWAR+284
TWAVECB  EQU   TWAVI
TWAU     EQU   TWAR+300
TWAUE    EQU   TWAU+68
TWAUEI   EQU   TWAUE
TWAUI    EQU   TWAR+400
TWAUECB  EQU   TWAUI
TWAC     EQU   TWAR+408
TWACE    EQU   TWAC+68
TWACEI   EQU   TWACE
TWACEIFC EQU   TWACEI
TWACERA  EQU   TWACEI+1
TWACERRS EQU   TWACE+4
TWACI    EQU   TWAR+508
TWACECB  EQU   TWACI
TWACSTPQ EQU   TWACI+4
TWACMODQ EQU   TWACI+8
TWACSKIP EQU   TWACI+12
CIBPTR   EQU   CHCIBP
CSCBPTR  EQU   TWACSCB
WEPTR    EQU   ADDRESS
CHAINS01 EQU   CHASM
CHTYPE   EQU   CHAINS01+124
CHTRSTAT EQU   CHAINS01+125
CHCSYSO  EQU   CHAINS01+134
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CHLAST   EQU   CHAINS01+136
CHSPA    EQU   CHAINS01+135
CHUSERID EQU   CHCSYSO
CHJB     EQU   CHCSYSO
CHDUMP   EQU   CHCSYSO
CHQUE    EQU   CHCSYSO
CHHOLD   EQU   CHCSYSO
CHOUT    EQU   CHCSYSO
CHINN    EQU   CHCSYSO
CHALL    EQU   CHCSYSO
CHINC    EQU   CHAINS01+132
CHPEND   EQU   CHAINS01+128
CHARID   EQU   CHAINS01+127
CHCNID   EQU   CHAINS01+126
@NM00009 EQU   CHTRSTAT
CHTSL    EQU   CHTRSTAT
CHTS     EQU   CHTRSTAT
CHINITL  EQU   CHTRSTAT
CHINIT   EQU   CHTRSTAT
CHJOBSL  EQU   CHTRSTAT
CHJOBS   EQU   CHTRSTAT
CHDEF    EQU   CHTYPE
CHHIAR   EQU   CHTYPE
CHARSV29 EQU   CHTYPE
CHARSV28 EQU   CHTYPE
CHARSV27 EQU   CHTYPE
CHARSV26 EQU   CHTYPE
CHARSV25 EQU   CHTYPE
CHDSTAT  EQU   CHTYPE
CHBUF    EQU   CHAINS01
TWAEND   EQU   TWAR+536
TWAWORKE EQU   TWAR+524
@NM00016 EQU   TWACI+13
TWACRTFC EQU   TWAC+60
TWACABFC EQU   TWAC+56
TWACTWA  EQU   TWAC+52
TWACEWA  EQU   TWAC+4
TWACID   EQU   TWAC
TWAUACQH EQU   TWAUI+4
TWAUERRS EQU   TWAUE+4
TWAUERA  EQU   TWAUEI+1
TWAUEIFC EQU   TWAUEI
TWAURTFC EQU   TWAU+60
TWAUABFC EQU   TWAU+56
TWAUTWA  EQU   TWAU+52
TWAUEWA  EQU   TWAU+4
TWAUID   EQU   TWAU
TWAVACQH EQU   TWAVI+12
TWAVTHQH EQU   TWAVI+8
TWAVTEQH EQU   TWAVI+4
TWAVERRS EQU   TWAVE+4
TWAVERA  EQU   TWAVEI+1
TWAVEIFC EQU   TWAVEI
TWAVRTFC EQU   TWAV+60
TWAVABFC EQU   TWAV+56
TWAVTWA  EQU   TWAV+52
TWAVEWA  EQU   TWAV+4
TWAVID   EQU   TWAV
TWAMERRS EQU   TWAME+4
TWAMERA  EQU   TWAMEI+1
TWAMEIFC EQU   TWAMEI
TWAMRTFC EQU   TWAM+60
TWAMABFC EQU   TWAM+56
TWAMTWA  EQU   TWAM+52
TWAMEWA  EQU   TWAM+4
TWAMID   EQU   TWAM
@NM00015 EQU   TWACFL
TWACFL4  EQU   TWACFL
TWACFL2  EQU   TWACFL
TWACFL1  EQU   TWACFL
@NM00014 EQU   TWAUFL
TWAUFL4  EQU   TWAUFL
TWAUFL3  EQU   TWAUFL
TWAUFL2  EQU   TWAUFL
TWAUFL1  EQU   TWAUFL
@NM00013 EQU   TWAVFL
TWAVFL6  EQU   TWAVFL
TWAVFL5  EQU   TWAVFL
TWAVFL4  EQU   TWAVFL
TWAVFL3  EQU   TWAVFL
TWAVFL2  EQU   TWAVFL
TWAVFL1  EQU   TWAVFL
@NM00012 EQU   TWAMFL
TWAMFL1  EQU   TWAMFL
TWACCOMP EQU   TWAR+76
TWAUCOMP EQU   TWAR+72
TWAVCOMP EQU   TWAR+68
TWACTCB  EQU   TWAR+60
TWAUTCB  EQU   TWAR+56
TWAVTCB  EQU   TWAR+52
TWADEQAS EQU   TWAR+44
TWAEESR  EQU   TWAR+40
TWAPPSR  EQU   TWAR+36
TWATCSR  EQU   TWAR+32
TWATTSR  EQU   TWAR+28
TWAINIT  EQU   TWAR+24
TWATCAST EQU   TWAR+20
TWAASCB  EQU   TWAR+12
TWAPASQH EQU   TWAR+8
TWARSON  EQU   TWAR+2
TWACOMP  EQU   TWAR
@NM00011 EQU   CIBNAME+13
CIBCONID EQU   CIBNAME+12
CIBTJID  EQU   CIBASID
@NM00010 EQU   CIBNAME+6
CIBLEN   EQU   CIBNAME+5
CIBNEXT  EQU   CIBNAME
CHARSV16 EQU   CHSHORT+100
CHARSV15 EQU   CHSHORT+96
CHJSCBVS EQU   CHSHORT+92
CHUSCVS  EQU   CHSHORT+88
@NM00008 EQU   CHSHORT+84
@NM00007 EQU   CHSHORT+80
CHSQA    EQU   CHSHORT+44
CHQPA    EQU   CHSHORT+8
CHJCL    EQU   CHSHORT+4
CHSPC    EQU   CHSHORT
CHSPB    EQU   CHSTEP+4
CHTCB    EQU   CHSTEP+1
CHARSV23 EQU   CHSWT
CHARSV22 EQU   CHSWT
CHARSV21 EQU   CHSWT
CHAC     EQU   CHSWT
CHPSF    EQU   CHSWT
CHPSD    EQU   CHSWT
CHJCT    EQU   CHSWT
CHARSV20 EQU   CHSWT
CHCECB   EQU   CHASM+20
CHECB    EQU   CHASM+16
CHRGNAD  EQU   CHASM+12
CHARSV18 EQU   CHRGNSZ+1
CHRPRTY  EQU   CHRGNSZ
@NM00006 EQU   CHCIBP
CHEND    EQU   CHCIBP
CHDER    EQU   CHPROCSN+4
CHARSV10 EQU   CHACT1
CHARSV09 EQU   CHACT1
CHARSV08 EQU   CHACT1
CHARSV07 EQU   CHACT1
CHARSV06 EQU   CHACT1
CHARSV05 EQU   CHACT1
CHARSV04 EQU   CHACT1
CHRDWTR  EQU   CHACT1
CHARSV30 EQU   CHPROCSN+2
CHQID    EQU   CHPROCSN
CHASID   EQU   CHTJID
CHUCMP   EQU   CHAIN+29
CHTRKID  EQU   CHPKE
CHCIBCTR EQU   CHAIN+27
CHUNIT   EQU   CHAIN+24
CHCLS    EQU   CHAIN+16
CHPCOI   EQU   CHPARM
CHIFY    EQU   CHACT
CHAIFX   EQU   CHACT
CHCLD    EQU   CHACT
CHCL     EQU   CHACT
CHDSI    EQU   CHACT
CHDISC   EQU   CHACT
CHTERM   EQU   CHACT
CHSWAP   EQU   CHACT
CHABTERM EQU   CHSTS
CHFC     EQU   CHSTS
CHDL     EQU   CHSTS
CHAD     EQU   CHSTS
CHQSPC   EQU   CHSTS
CHSOUT   EQU   CHSTS
CHSYS    EQU   CHSTS
CHAP     EQU   CHSTS
CHSZE    EQU   CHFLG+1
CHVCD    EQU   CHFLG
CHPTR    EQU   CHAIN
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00102 EQU   @EL00005
@RC00110 EQU   @EL00005
@RC00133 EQU   @EL00006
@RC00128 EQU   @EL00006
@RF00162 EQU   @EL00007
@RC00157 EQU   @EL00007
@RF00164 EQU   @EL00007
@ENDDATA EQU   *
         END   IKTCAS40,(C'PLS2119',0702,80263)
