         TITLE '     IKTCAS41 - STOP Q PROCESSOR'
IKTCAS41 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IKTCAS41  80.232'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         ST    @13,@SA00001+4                                      0001
         LA    @14,@SA00001                                        0001
         ST    @14,8(,@13)                                         0001
         LR    @13,@14                                             0001
         EJECT
*                                                                  0039
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE PROCESSES THE W.E.'S FOUND ON THE             */
*/*    ASYNCHRONOUS STOP QUEUE.  THE MAIN PROCESSING IS AS FOLLOWS:  */
*/*                                                                  */
*/*    -   IF THE Q IS EMPTY, EXIT                                   */
*/*    -   FIND THE W.E. AT THE TOP OF THE Q                         */
*/*    -   CALL THE SUBROUTINE 'PRCSSTPE'                            */
*/*    -   UPON RETURN FROM 'PRCSSTPE', IF THE SUBROUTINE WAS        */
*/*        UNABLE TO HANDLE THE REQUEST, EXIT AND GO BACK TO SLEEP   */
*/*    -   OTHERWISE, DEQUEUE THE TOP W.E. AND EXIT                  */
*/*                                                                  */
*/*  *****************************************************************/
*                                                                  0039
*   IF TWACSKIP='N'&TWACSTPQ^=0 THEN/* SHOULD WE PROCESS STOP Q      */
         CLI   TWACSKIP(TWAPTR),C'N'                               0039
         BNE   @RF00039                                            0039
         L     @10,TWACSTPQ(,TWAPTR)                               0039
         LTR   @10,@10                                             0039
         BZ    @RF00039                                            0039
*     DO;                           /* YES                           */
*       RESPECIFY                                                  0041
*        (WESTD) BASED(TEMPPTR);    /* SET UP NEW BASE FOR W.E.      */
*       TEMPPTR=TWACSTPQ;           /* GET BEGINNING POINTER         */
         LR    TEMPPTR,@10                                         0042
*       DO WHILE(WENEXT^=0);        /* FIND                          */
         B     @DE00043                                            0043
@DL00043 DS    0H                                                  0044
*         TEMPPTR=WENEXT;           /* LAST W.E.                     */
         L     TEMPPTR,WENEXT(,TEMPPTR)                            0044
*       END;                        /* ON Q                          */
@DE00043 L     @10,WENEXT(,TEMPPTR)                                0045
         LTR   @10,@10                                             0045
         BNZ   @DL00043                                            0045
*       CALL PRCSSTPE;              /* PROCESS THE W.E.              */
         BAL   @14,PRCSSTPE                                        0046
*       IF TWACSKIP='N' THEN        /* KEEP ON GOING                 */
         CLI   TWACSKIP(TWAPTR),C'N'                               0047
         BNE   @RF00047                                            0047
*         DO;                       /* YES                           */
*LOOP1:                             /* COMPARE AND SWAP LOOP         */
*           TEMPPTR=TWACSTPQ;       /* GET BEGINNING POINTER MAKE  0049
*                                      TWACSTPQ THE WENEXT FIELD OF A
*                                      PSUEDO W.E.                   */
LOOP1    L     TEMPPTR,TWACSTPQ(,TWAPTR)                           0049
*           TEMPPTR2=ADDR(TWACSTPQ)-(ADDR(WENEXT)-ADDR(WESTD));    0050
         LA    TEMPPTR2,TWACSTPQ(,TWAPTR)                          0050
         SL    TEMPPTR2,@CF00107                                   0050
*           DO WHILE(WENEXT^=0);    /* FIND                          */
         B     @DE00051                                            0051
@DL00051 DS    0H                                                  0052
*             TEMPPTR2=TEMPPTR;     /* LAST                          */
         LR    TEMPPTR2,TEMPPTR                                    0052
*             TEMPPTR=WENEXT;       /* W.E.                          */
         L     TEMPPTR,WENEXT(,TEMPPTR)                            0053
*           END;                    /* ON Q HAVE ANY W.E.'S BEEN   0054
*                                      INSERTED BETWEEN THE BOTTOM 0054
*                                      W.E. AND THE NEXT TO BOTTOM 0054
*                                      W.E.                          */
@DE00051 L     @10,WENEXT(,TEMPPTR)                                0054
         LTR   @10,@10                                             0054
         BNZ   @DL00051                                            0054
*           CS(TEMPPTR,WENEXT,TEMPPTR2->WENEXT);                   0055
         CS    TEMPPTR,@10,WENEXT(TEMPPTR2)                        0055
*           BC(7,LOOP1);            /* YES - TRY AGAIN               */
         BC    7,LOOP1                                             0056
*           IF WECODE1T=TCCONSLE&   /* FOR HALT CANCEL       @ZM21019*/
*               WECODE1F=FCCIVT THEN                               0057
         CLI   WECODE1T(TEMPPTR),X'04'                             0057
         BNE   @RF00057                                            0057
         CLI   WECODE1F(TEMPPTR),X'12'                             0057
         BE    @RT00057                                            0057
*             ;                     /* BYPASS THE FREEMAIN SINCE   0058
*                                      STORAGE WAS ACQUIRED BY     0058
*                                      ANOTHER TCB. FREEMAIN HERE  0058
*                                      WOULD CAUSE 305 ABEND. STORAGE
*                                      WILL BE FREED BY SYSTEM WHEN
*                                      TCAS ENDS, WHICH IS IMMINENT.
*                                                            @ZM21019*/
*           ELSE                                                   0059
*             DO;                   /*                       @ZM21019*/
@RF00057 DS    0H                                                  0060
*               LENGTH=WELEN;       /* FREE                          */
         LH    LENGTH,WELEN(,TEMPPTR)                              0060
*               SUBPL=WECODE2T;     /* THE                           */
         SLR   SUBPL,SUBPL                                         0061
         IC    SUBPL,WECODE2T(,TEMPPTR)                            0061
*               ADDRESS=TEMPPTR;    /* OLD                           */
         ST    TEMPPTR,ADDRESS                                     0062
*               CALL FRESPACE;      /* W.E.                          */
         BAL   @14,FRESPACE                                        0063
*             END;                  /*                       @ZM21019*/
*         END;                                                     0065
@RT00057 DS    0H                                                  0066
*       RESPECIFY                                                  0066
*        (WESTD);                   /* REVERT TO OLD BASE            */
@RF00047 DS    0H                                                  0067
*     END;                                                         0067
*   RETURN CODE(0);                 /* FINISHED                      */
@RF00039 SLR   @15,@15                                             0068
         L     @13,4(,@13)                                         0068
         L     @14,12(,@13)                                        0068
         LM    @00,@12,20(@13)                                     0068
         BR    @14                                                 0068
         EJECT
*PRCSSTPE:                                                         0069
*   PROC OPTIONS(SAVE(14));                                        0069
@EL00001 L     @13,4(,@13)                                         0069
@EF00001 DS    0H                                                  0069
@ER00001 LM    @14,@12,12(@13)                                     0069
         BR    @14                                                 0069
PRCSSTPE ST    @14,@SA00002                                        0069
*                                                                  0070
*/*  *****************************************************************/
*/*                                                                  */
*/*    THE PURPOSE OF THIS SUBROUTINE IS TO PROCESS A W.E. FROM THE  */
*/*    STOP Q.  THE MAIN PROCESSING IS AS FOLLOWS:                   */
*/*                                                                  */
*/*    -   TRY AND PUT A RETURN W.E. ON THE SYNC Q.  IF              */
*/*        UNSUCCESSFUL, EXIT AND GO BACK TO SLEEP.  NOTE THAT       */
*/*        PUTTING MY RETURN W.E. ON THE TOP OF THE SYNC Q HAS THE   */
*/*        EFFECT OF LOCKING OUT ALL OTHER TASKS WHICH PROCESS       */
*/*        THE SYNC Q.                                               */
*/*    -   FIND OUT FROM THE OPERATOR WHAT KIND OF STOP HE WANTS,    */
*/*        FSTOP OR SIC.                                             */
*/*    -   BUILD THE SET OF REQUIRED W.E.'S AND PUT THEM ON THE      */
*/*        SYNC Q.                                                   */
*/*    -   POST VTAM SUB-TASK                                        */
*/*    -   EXIT                                                      */
*/*                                                                  */
*/*  *****************************************************************/
*                                                                  0070
*   IF TWASYNQH^=0 THEN             /* IS SYNC Q EMPTY               */
         L     @10,TWASYNQH(,TWAPTR)                               0070
         LTR   @10,@10                                             0070
         BZ    @RF00070                                            0070
*     TWACSKIP='Y';                 /* NO - GO BACK TO SLEEP         */
         MVI   TWACSKIP(TWAPTR),C'Y'                               0071
*   ELSE                                                           0072
*     DO;                           /* YES CALCULATE THE LENGTH OF A
*                                      RETURN W.E. + A CLOSE ACB W.E.
*                                      + AN ADDRESS SPACE TERMINATION
*                                      W.E. + A TCAS TERMINATION W.E.
*                                      + AN END TCAS MAIN TASK W.E.,
*                                      ROUNDED UP TO THE NEXT      0072
*                                      DOUBLEWORD.                   */
         B     @RC00070                                            0072
@RF00070 DS    0H                                                  0073
*       LENGTH=((12+12+12+12+12)+7)/8*8;                           0073
         LA    LENGTH,64                                           0073
*       SUBPL=4;                    /* SUBPOOL NUMBER                */
         LA    SUBPL,4                                             0074
*       CALL GETSPACE;              /* GET SPACE                     */
         BAL   @14,GETSPACE                                        0075
*       SAVEADDR=ADDRESS;           /* SAVE FOR FUTURE USE           */
         L     @10,ADDRESS                                         0076
         LR    SAVEADDR,@10                                        0076
*       WECODE1T=TCCONSLE;          /* MY TASK CODE                  */
         L     @07,WEPTR                                           0077
         MVI   WECODE1T(@07),X'04'                                 0077
*       WECODE2T=TCCONSLE;          /* CODE                          */
         MVI   WECODE2T(@07),X'04'                                 0078
*       WECODE1F=FCRETURN;          /* RETURN FUNCTION CODE          */
         MVI   WECODE1F(@07),X'FF'                                 0079
*       WECODE2F=FCCSTOP;           /* STOP FUNCTION CODE            */
         MVI   WECODE2F(@07),X'11'                                 0080
*       WERC=0;                     /* ZERO OUT                      */
         SLR   @15,@15                                             0081
         STH   @15,WERC(,@07)                                      0081
*       WENEXT=0;                   /* ZERO OUT                      */
         ST    @15,WENEXT(,@07)                                    0082
*       WELEN=LENGTH;               /* TOTAL LENGTH OF SPACE         */
         STH   LENGTH,WELEN(,@07)                                  0083
*       TEMPPTR2=0;                 /* SEE IF SYNC                   */
         SLR   TEMPPTR2,TEMPPTR2                                   0084
*       CS(TEMPPTR2,ADDRESS,TWASYNQH);/* Q STILL EMPTY               */
         CS    TEMPPTR2,@10,TWASYNQH(TWAPTR)                       0085
*       BC(8,STPESKIP);             /* YES                           */
         BC    8,STPESKIP                                          0086
*       CALL FRESPACE;              /* NO - FREE SPACE               */
         BAL   @14,FRESPACE                                        0087
*       TWACSKIP='Y';               /* AND GO BACK                   */
         MVI   TWACSKIP(TWAPTR),C'Y'                               0088
*       RETURN;                     /* TO SLEEP                      */
@EL00002 DS    0H                                                  0089
@EF00002 DS    0H                                                  0089
@ER00002 L     @14,@SA00002                                        0089
         BR    @14                                                 0089
*STPESKIP:                                                         0090
*       ADDRESS=ADDRESS+12;         /* PT TO NEXT FREE W.E.          */
STPESKIP LA    @10,12                                              0090
         L     @05,ADDRESS                                         0090
         ALR   @05,@10                                             0090
         ST    @05,ADDRESS                                         0090
*       WECODE1T=TCVTAM;            /* TELL VTAM                     */
         L     @02,WEPTR                                           0091
         MVI   WECODE1T(@02),X'02'                                 0091
*       WECODE1F=FCVACBCL;          /* INTERFACE                     */
         MVI   WECODE1F(@02),X'12'                                 0092
*       WENEXT=ADDRESS+12;          /* DRIVER TO                     */
         ALR   @05,@10                                             0093
         ST    @05,WENEXT(,@02)                                    0093
*       CALL FILLINWE;              /* CLOSE ACB                     */
         BAL   @14,FILLINWE                                        0094
*       ADDRESS=ADDRESS+12;         /* POINT TO NEXT FREE W.E.       */
         LA    @10,12                                              0095
         AL    @10,ADDRESS                                         0095
         ST    @10,ADDRESS                                         0095
*       WECODE1T=TCUSER;            /* TASK CODE= U.I.               */
         L     @10,WEPTR                                           0096
         MVI   WECODE1T(@10),X'03'                                 0096
*       WTOREPLY='';                /* CLEAR REPLY ARE@YM03218       */
         MVI   WTOREPLY,C' '                                       0097
         MVC   WTOREPLY+1(5),WTOREPLY                              0097
*       IF TEMPPTR->WECODE1T=TCCONSLE&/* IF W.E. FOR HALT VTAM       */
*           TEMPPTR->WECODE1F=FCCIVT THEN/* (W.E. ID 0412)   @ZM21019*/
         CLI   WECODE1T(TEMPPTR),X'04'                             0098
         BNE   @RF00098                                            0098
         CLI   WECODE1F(TEMPPTR),X'12'                             0098
         BNE   @RF00098                                            0098
*         WECODE1F=FCUFSTOP;        /* FORCE FSTOP           @ZM21019*/
         MVI   WECODE1F(@10),X'22'                                 0099
*       ELSE                        /* NORMAL W.E. FOR CONSOLE     0100
*                                      COMMUNICATION         @ZM21019*/
*         IF TCASUSEC^=0            /* IF THERE IS USR@YM03218       */
*           THEN                                                   0100
         B     @RC00098                                            0100
@RF00098 L     @10,TCASTPTR(,TWAPTR)                               0100
         LH    @10,TCASUSEC(,@10)                                  0100
         LTR   @10,@10                                             0100
         BZ    @RF00100                                            0100
*           CALL STPWTOR;           /* THEN GO ASK OPE@YM03218       */
         BAL   @14,STPWTOR                                         0101
*       IF WTOREPLY(1)='S' THEN     /* IF OP REPLY IS SIC            */
@RF00100 DS    0H                                                  0102
@RC00098 CLI   WTOREPLY,C'S'                                       0102
         BNE   @RF00102                                            0102
*         WECODE1F=FCUSIC;          /* CONSTRUCT SIC W.E.            */
         L     @10,WEPTR                                           0103
         MVI   WECODE1F(@10),X'21'                                 0103
*       ELSE                        /* IF NOT                        */
*         WECODE1F=FCUFSTOP;        /* CONSTRUCT FSTOP W.E.          */
         B     @RC00102                                            0104
@RF00102 L     @10,WEPTR                                           0104
         MVI   WECODE1F(@10),X'22'                                 0104
*       WENEXT=ADDRESS+12;          /* INSERT NEXT W.E. ADDR         */
@RC00102 LA    @10,12                                              0105
         AL    @10,ADDRESS                                         0105
         L     @02,WEPTR                                           0105
         ST    @10,WENEXT(,@02)                                    0105
*       CALL FILLINWE;              /* FILL IN NEXT W.E.             */
         BAL   @14,FILLINWE                                        0106
*       ADDRESS=ADDRESS+12;         /* POINT TO NEXT FREE W.E.       */
         LA    @10,12                                              0107
         L     @02,ADDRESS                                         0107
         ALR   @02,@10                                             0107
         ST    @02,ADDRESS                                         0107
*       WECODE1T=TCMAIN;            /* TELL                          */
         L     @15,WEPTR                                           0108
         MVI   WECODE1T(@15),X'01'                                 0108
*       WECODE1F=FCMTCTRM;          /* TCAS                          */
         MVI   WECODE1F(@15),X'80'                                 0109
*       WENEXT=ADDRESS+12;          /* ABOUT                         */
         ALR   @02,@10                                             0110
         ST    @02,WENEXT(,@15)                                    0110
*       CALL FILLINWE;              /* TERMINATION                   */
         BAL   @14,FILLINWE                                        0111
*       WERC2='07'X;                /* REQUEST                       */
         L     @10,WEPTR                                           0112
         MVI   WERC2(@10),X'07'                                    0112
*       ADDRESS=ADDRESS+12;         /* POINT TO NEXT FREE W.E.       */
         LA    @10,12                                              0113
         AL    @10,ADDRESS                                         0113
         ST    @10,ADDRESS                                         0113
*       WECODE1T=TCMAIN;            /* TELL                          */
         L     @10,WEPTR                                           0114
         MVI   WECODE1T(@10),X'01'                                 0114
*       WECODE1F=FCMOKEND;          /* TCAS                          */
         MVI   WECODE1F(@10),X'91'                                 0115
*       WENEXT=SAVEADDR;            /* TO                            */
         ST    SAVEADDR,WENEXT(,@10)                               0116
*       CALL FILLINWE;              /* TERMINATE                     */
         BAL   @14,FILLINWE                                        0117
*       ADDRESS=SAVEADDR+12;        /* ADDR OF NEW FIRST W.E.        */
         LA    @10,12                                              0118
         ALR   @10,SAVEADDR                                        0118
         ST    @10,ADDRESS                                         0118
*       CS(TWASYNQH,ADDRESS,TWASYNQH);/* PT Q HEAD AT NEW FRONT      */
         L     @15,TWASYNQH(,TWAPTR)                               0119
         CS    @15,@10,TWASYNQH(TWAPTR)                            0119
         BZ    @BC00119                                            0119
         ST    @15,TWASYNQH(,TWAPTR)                               0119
@BC00119 DS    0H                                                  0120
*       RESPECIFY                                                  0120
*        (R1) RESTRICTED;                                          0120
*       R1=ADDR(TWAVECB);           /* ADDR OF ECB TO POST           */
         LA    R1,TWAVECB(,TWAPTR)                                 0121
*       GEN(POST  (1))              /* TELL VTAM SUB-TASK            */
*       REFS(R0,R1,R14,R15);                                       0122
         POST  (1)
*       RESPECIFY                                                  0123
*        (R1) UNRESTRICTED;                                        0123
*     END;                                                         0124
*   END PRCSSTPE;                                                  0125
         B     @EL00002                                            0125
         EJECT
*STPWTOR:                                                          0126
*   PROC OPTIONS(SAVE(14));                                        0126
STPWTOR  ST    @14,@SA00003                                        0126
*                                                                  0127
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE FINDS OUT FROM THE OPERATOR WHAT KIND OF STOP */
*/*    HE WANTS, 'FSTOP' OF 'SIC'.                                   */
*/*                                                                  */
*/*  *****************************************************************/
*                                                                  0127
*   RESPECIFY                                                      0127
*    (R1) RESTRICTED;                                              0127
*   R1=10;                          /* MESSAGE NUMBER                */
         LA    R1,10                                               0128
*   CALL MSGBLK;                    /* ADDR OF LIST FORM OF MSG      */
         L     @15,TWAMSG(,TWAPTR)                                 0129
         BALR  @14,@15                                             0129
*   MVC(IKT010D(1:MSGLNGTH),MSGDATA);/* MOVE IN LIST FORM            */
         L     @10,MSGLNGTH(,R1)                                   0130
         BCTR  @10,0                                               0130
         EX    @10,@SM00316                                        0130
*   R1=16;                          /* MESSAGE NUMBER                */
         LA    R1,16                                               0131
*   CALL MSGBLK;                    /* ADDR OF LIST FORM OF MSG      */
         L     @15,TWAMSG(,TWAPTR)                                 0132
         BALR  @14,@15                                             0132
*   MVC(IKT016D(1:MSGLNGTH),MSGDATA);/* MOVE IN LIST FORM            */
         L     @10,MSGLNGTH(,R1)                                   0133
         BCTR  @10,0                                               0133
         EX    @10,@SM00318                                        0133
*   CVD(TCASUSEC,DBLWORD);          /* NUMBER OF                     */
         L     @10,TCASTPTR(,TWAPTR)                               0134
         LH    @10,TCASUSEC(,@10)                                  0134
         CVD   @10,DBLWORD                                         0134
*   UNPK(IKT010DA,DBLWORD);         /* ACTIVE                        */
         UNPK  IKT010DA(5),DBLWORD(8)                              0135
*   IKT010DA(5)=IKT010DA(5)|'F0'X;  /* USERS                         */
         OI    IKT010DA+4,X'F0'                                    0136
*   WTOREPLY='';                    /* CLEAR REPLY AREA              */
         MVI   WTOREPLY,C' '                                       0137
         MVC   WTOREPLY+1(5),WTOREPLY                              0137
*   WTORECB=0;                      /* CLEAR REPLY ECB               */
         SLR   @10,@10                                             0138
         ST    @10,WTORECB                                         0138
*   R1=ADDR(IKT010D);               /* ADDR OF MSG                   */
         LA    R1,IKT010D                                          0139
*   GEN(WTOR  ,WTOREPLY,6,WTORECB,MF=(E,(1)))                      0140
*   REFS(R0,R1,R14,R15,WTOREPLY,WTORECB);/* ISSUE WTOR               */
         WTOR  ,WTOREPLY,6,WTORECB,MF=(E,(1))
*   GEN(WAIT  ECB=WTORECB)          /* WAIT FOR OPERATOR             */
*   REFS(R0,R1,R14,R15,WTORECB);                                   0141
         WAIT  ECB=WTORECB
*   IF WTOREPLY='FSTOP '|WTOREPLY='SIC   ' THEN/* IF GOOD, EXIT      */
         CLC   WTOREPLY(6),@CC00301                                0142
         BE    @RT00142                                            0142
         CLC   WTOREPLY(6),@CC00302                                0142
         BE    @RT00142                                            0142
*     ;                                                            0143
*   ELSE                            /* NO - GET A GOOD REPLY         */
*     DO UNTIL(WTOREPLY='FSTOP '|WTOREPLY='SIC   ');               0144
@DL00144 DS    0H                                                  0145
*       WTOREPLY='';                /* CLEAR REPLY AREA              */
         MVI   WTOREPLY,C' '                                       0145
         MVC   WTOREPLY+1(5),WTOREPLY                              0145
*       WTORECB=0;                  /* CLEAR REPLY ECB               */
         SLR   @10,@10                                             0146
         ST    @10,WTORECB                                         0146
*       R1=ADDR(IKT016D);           /* ADDR OF MSG                   */
         LA    R1,IKT016D                                          0147
*       GEN(WTOR  ,WTOREPLY,6,WTORECB,MF=(E,(1)))                  0148
*       REFS(R0,R1,R14,R15,WTOREPLY,WTORECB);/* ISSUE WTOR           */
         WTOR  ,WTOREPLY,6,WTORECB,MF=(E,(1))
*       GEN(WAIT  ECB=WTORECB)      /* WAIT FOR OPERATOR             */
*       REFS(R0,R1,R14,R15,WTORECB);                               0149
         WAIT  ECB=WTORECB
*     END;                                                         0150
@DE00144 CLC   WTOREPLY(6),@CC00301                                0150
         BE    @DC00144                                            0150
         CLC   WTOREPLY(6),@CC00302                                0150
         BNE   @DL00144                                            0150
@DC00144 DS    0H                                                  0151
*   RESPECIFY                                                      0151
*    (R1) UNRESTRICTED;                                            0151
*   END STPWTOR;                                                   0152
@EL00003 DS    0H                                                  0152
@EF00003 DS    0H                                                  0152
@ER00003 L     @14,@SA00003                                        0152
         BR    @14                                                 0152
         EJECT
*FILLINWE:                                                         0153
*   PROC OPTIONS(SAVE(14));                                        0153
FILLINWE ST    @14,12(,@13)                                        0153
*                                                                  0154
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE FILLS IN COMMON STOP W.E. INFORMATION         */
*/*                                                                  */
*/*  *****************************************************************/
*                                                                  0154
*   WECODE2T=TCCONSLE;              /* MY TASK CODE                  */
         L     @10,WEPTR                                           0154
         MVI   WECODE2T(@10),X'04'                                 0154
*   WECODE2F=FCCSTOP;               /* STOP FUNCTION CODE            */
         MVI   WECODE2F(@10),X'11'                                 0155
*   WERC=0;                         /* ZERO OUT                      */
         SLR   @05,@05                                             0156
         STH   @05,WERC(,@10)                                      0156
*   WELEN=0;                        /* ZERO OUT                      */
         STH   @05,WELEN(,@10)                                     0157
*   END FILLINWE;                                                  0158
@EL00004 DS    0H                                                  0158
@EF00004 DS    0H                                                  0158
@ER00004 L     @14,12(,@13)                                        0158
         BR    @14                                                 0158
         EJECT
*FRESPACE:                                                         0159
*   PROC OPTIONS(SAVE(14));                                        0159
FRESPACE ST    @14,@SA00005                                        0159
*                                                                  0160
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE DOES A FREEMAIN FOR THE NUMBER OF BYTES       */
*/*    SPECIFIED IN 'LENGTH', USING THE ADDRESS FOUND IN 'ADDRESS'   */
*/*    AS A STARTING ADDRESS, AND USING THE VALUE FOUND IN 'SUBPL'   */
*/*    AS THE SUBPOOL NUMBER                                         */
*/*                                                                  */
*/*  *****************************************************************/
*                                                                  0160
*   RESPECIFY                                                      0160
*    (R2,                                                          0160
*     R3) RESTRICTED;                                              0160
*   R2=LENGTH;                                                     0161
         LR    R2,LENGTH                                           0161
*   R3=SUBPL;                                                      0162
         LR    R3,SUBPL                                            0162
*   GEN(FREEMAIN EU,LV=(R2),A=ADDRESS,SP=(R3))                     0163
*   REFS(ADDRESS,R0,R1,R2,R3,R14,R15);                             0163
         FREEMAIN EU,LV=(R2),A=ADDRESS,SP=(R3)
*   RESPECIFY                                                      0164
*    (R2,                                                          0164
*     R3) UNRESTRICTED;                                            0164
*   END FRESPACE;                                                  0165
@EL00005 DS    0H                                                  0165
@EF00005 DS    0H                                                  0165
@ER00005 L     @14,@SA00005                                        0165
         BR    @14                                                 0165
         EJECT
*GETSPACE:                                                         0166
*   PROC OPTIONS(SAVE(14));                                        0166
GETSPACE ST    @14,@SA00006                                        0166
*                                                                  0167
*/*  *****************************************************************/
*/*                                                                  */
*/*    THIS SUBROUTINE DOES A GETMAIN FOR THE NUMBER OF BYTES        */
*/*    SPECIFIED IN 'LENGTH' (SHOULD BE A DOUBLEWORD MULTIPLE),      */
*/*    FROM THE SUBPOOL SPECIFIED IN 'SUBPL', AND THEN PLACES THE    */
*/*    STARTING ADDRESS OF THE GETMAIN'ED AREA IN 'ADDRESS'.         */
*/*                                                                  */
*/*  *****************************************************************/
*                                                                  0167
*   RESPECIFY                                                      0167
*    (R2,                                                          0167
*     R3) RESTRICTED;                                              0167
*   R2=LENGTH;                                                     0168
         LR    R2,LENGTH                                           0168
*   R3=SUBPL;                                                      0169
         LR    R3,SUBPL                                            0169
*   GEN(GETMAIN EU,LV=(R2),A=ADDRESS,SP=(R3))                      0170
*   REFS(ADDRESS,R0,R1,R2,R3,R14,R15);                             0170
         GETMAIN EU,LV=(R2),A=ADDRESS,SP=(R3)
*   RESPECIFY                                                      0171
*    (R2,                                                          0171
*     R3) UNRESTRICTED;                                            0171
*   END GETSPACE;                                                  0172
@EL00006 DS    0H                                                  0172
@EF00006 DS    0H                                                  0172
@ER00006 L     @14,@SA00006                                        0172
         BR    @14                                                 0172
         EJECT
*   END IKTCAS41                                                   0173
*                                                                  0173
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IKTTCAST)                                       */
*/*%INCLUDE SYSLIB  (IKTCASWA)                                       */
*                                                                  0173
*       ;                                                          0173
@DATA    DS    0H
@SM00316 MVC   IKT010D(0),MSGDATA(R1)
@SM00318 MVC   IKT016D(0),MSGDATA(R1)
         DS    0F
@SA00001 DS    18F
@SA00002 DS    1F
@SA00005 DS    1F
@SA00006 DS    1F
@SA00003 DS    1F
         DS    0F
@CF00107 DC    F'4'
         DS    0D
ADDRESS  DS    A
WTORECB  DS    F
@CC00301 DC    C'FSTOP '
@CC00302 DC    C'SIC   '
         DS    CL4
DBLWORD  DS    CL8
IKT016D  DS    CL96
WTOREPLY DS    CL6
         DS    CL2
IKT010D  DS    CL96
         ORG   IKT010D
@NM00002 DS    CL20
IKT010DA DS    CL5
@NM00003 DS    CL71
         ORG   IKT010D+96
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
TEMPPTR2 EQU   @02
TEMPPTR  EQU   @04
SUBPL    EQU   @06
LENGTH   EQU   @05
SAVEADDR EQU   @03
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
TWAPTR   EQU   @11
R14      EQU   @14
R15      EQU   @15
MSGBLK   EQU   0
@NM00001 EQU   0
MSGLNGTH EQU   @NM00001
MSGDATA  EQU   @NM00001+4
WESTD    EQU   0
WECODE1T EQU   WESTD
WECODE1F EQU   WESTD+1
WECODE2T EQU   WESTD+2
WECODE2F EQU   WESTD+3
WENEXT   EQU   WESTD+4
WERC     EQU   WESTD+8
WERC2    EQU   WERC+1
WELEN    EQU   WESTD+10
TCAST    EQU   0
TCASUSER EQU   TCAST+4
TCASUSEC EQU   TCASUSER
TCASFLG1 EQU   TCAST+88
TWAR     EQU   0
TWASYNQH EQU   TWAR+4
TWATCAST EQU   TWAR+20
TWAMSG   EQU   TWAR+48
TWAMFL   EQU   TWAR+80
TWAVFL   EQU   TWAR+81
TWAUFL   EQU   TWAR+82
TWACFL   EQU   TWAR+83
TWAM     EQU   TWAR+84
TWAME    EQU   TWAM+68
TWAMEI   EQU   TWAME
TWAV     EQU   TWAR+184
TWAVE    EQU   TWAV+68
TWAVEI   EQU   TWAVE
TWAVI    EQU   TWAR+284
TWAVECB  EQU   TWAVI
TWAU     EQU   TWAR+300
TWAUE    EQU   TWAU+68
TWAUEI   EQU   TWAUE
TWAUI    EQU   TWAR+400
TWAC     EQU   TWAR+408
TWACE    EQU   TWAC+68
TWACEI   EQU   TWACE
TWACI    EQU   TWAR+508
TWACSTPQ EQU   TWACI+4
TWACSKIP EQU   TWACI+12
TCASTPTR EQU   TWATCAST
WEPTR    EQU   ADDRESS
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
TWAEND   EQU   TWAR+536
TWAWORKE EQU   TWAR+524
@NM00013 EQU   TWACI+13
TWACMODQ EQU   TWACI+8
TWACECB  EQU   TWACI
TWACERRS EQU   TWACE+4
TWACERA  EQU   TWACEI+1
TWACEIFC EQU   TWACEI
TWACRTFC EQU   TWAC+60
TWACABFC EQU   TWAC+56
TWACTWA  EQU   TWAC+52
TWACEWA  EQU   TWAC+4
TWACID   EQU   TWAC
TWAUACQH EQU   TWAUI+4
TWAUECB  EQU   TWAUI
TWAUERRS EQU   TWAUE+4
TWAUERA  EQU   TWAUEI+1
TWAUEIFC EQU   TWAUEI
TWAURTFC EQU   TWAU+60
TWAUABFC EQU   TWAU+56
TWAUTWA  EQU   TWAU+52
TWAUEWA  EQU   TWAU+4
TWAUID   EQU   TWAU
TWAVACQH EQU   TWAVI+12
TWAVTHQH EQU   TWAVI+8
TWAVTEQH EQU   TWAVI+4
TWAVERRS EQU   TWAVE+4
TWAVERA  EQU   TWAVEI+1
TWAVEIFC EQU   TWAVEI
TWAVRTFC EQU   TWAV+60
TWAVABFC EQU   TWAV+56
TWAVTWA  EQU   TWAV+52
TWAVEWA  EQU   TWAV+4
TWAVID   EQU   TWAV
TWAMERRS EQU   TWAME+4
TWAMERA  EQU   TWAMEI+1
TWAMEIFC EQU   TWAMEI
TWAMRTFC EQU   TWAM+60
TWAMABFC EQU   TWAM+56
TWAMTWA  EQU   TWAM+52
TWAMEWA  EQU   TWAM+4
TWAMID   EQU   TWAM
@NM00012 EQU   TWACFL
TWACFL4  EQU   TWACFL
TWACFL2  EQU   TWACFL
TWACFL1  EQU   TWACFL
@NM00011 EQU   TWAUFL
TWAUFL4  EQU   TWAUFL
TWAUFL3  EQU   TWAUFL
TWAUFL2  EQU   TWAUFL
TWAUFL1  EQU   TWAUFL
@NM00010 EQU   TWAVFL
TWAVFL6  EQU   TWAVFL
TWAVFL5  EQU   TWAVFL
TWAVFL4  EQU   TWAVFL
TWAVFL3  EQU   TWAVFL
TWAVFL2  EQU   TWAVFL
TWAVFL1  EQU   TWAVFL
@NM00009 EQU   TWAMFL
TWAMFL1  EQU   TWAMFL
TWACCOMP EQU   TWAR+76
TWAUCOMP EQU   TWAR+72
TWAVCOMP EQU   TWAR+68
TWAMECB  EQU   TWAR+64
TWACTCB  EQU   TWAR+60
TWAUTCB  EQU   TWAR+56
TWAVTCB  EQU   TWAR+52
TWADEQAS EQU   TWAR+44
TWAEESR  EQU   TWAR+40
TWAPPSR  EQU   TWAR+36
TWATCSR  EQU   TWAR+32
TWATTSR  EQU   TWAR+28
TWAINIT  EQU   TWAR+24
TWACSCB  EQU   TWAR+16
TWAASCB  EQU   TWAR+12
TWAPASQH EQU   TWAR+8
TWARSON  EQU   TWAR+2
TWACOMP  EQU   TWAR
TCASTEND EQU   TCAST+148
TCASTTYO EQU   TCAST+144
TCAS767O EQU   TCAST+140
TCAS767I EQU   TCAST+136
TCASDUMP EQU   TCAST+132
TCASSCHD EQU   TCAST+128
TCASTPND EQU   TCAST+124
TCASOMJR EQU   TCAST+120
@NM00008 EQU   TCAST+118
TCASBR14 EQU   TCAST+116
TCASATTN EQU   TCAST+112
TCASASCI EQU   TCAST+108
TCASTTQH EQU   TCAST+104
@NM00007 EQU   TCAST+102
@NM00006 EQU   TCAST+100
TCASTGTF EQU   TCAST+96
TCASASCB EQU   TCAST+92
TCASFLG4 EQU   TCAST+91
TCASFLG3 EQU   TCAST+90
TCASFLG2 EQU   TCAST+89
TCASCONF EQU   TCASFLG1
@NM00005 EQU   TCASFLG1
TCASHAST EQU   TCASFLG1
TCASNACT EQU   TCASFLG1
TCASVSD  EQU   TCASFLG1
TCASABND EQU   TCASFLG1
TCASMDSW EQU   TCASFLG1
TCASBKMD EQU   TCASFLG1
TCASLTE  EQU   TCAST+84
TCASEXIT EQU   TCAST+80
TCASOQM  EQU   TCAST+76
TCASIQM  EQU   TCAST+72
TCASTSB  EQU   TCAST+68
TCASTTL  EQU   TCAST+64
TCASWA   EQU   TCAST+60
TCASFRR  EQU   TCAST+56
TCASMSGS EQU   TCAST+52
TCASDATO EQU   TCAST+48
TCASDATI EQU   TCAST+44
TCASXECB EQU   TCAST+40
TCASTID  EQU   TCAST+32
@NM00004 EQU   TCAST+31
TCASCHNL EQU   TCAST+30
TCASCRSZ EQU   TCAST+28
TCASLBUF EQU   TCAST+24
TCASHBUF EQU   TCAST+20
TCASCLSZ EQU   TCAST+18
TCASRCON EQU   TCAST+16
TCASACBP EQU   TCAST+8
TCASUMAX EQU   TCASUSER+2
TCASID   EQU   TCAST
WEDATA   EQU   WESTD+12
WERC1    EQU   WERC
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00070 EQU   @EL00002
@RT00142 EQU   @EL00003
@ENDDATA EQU   *
         END   IKTCAS41,(C'PLS2004',0702,80232)
