         TITLE '     IKTCAS42 - MODIFY Q PROCESSOR'
IKTCAS42 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IKTCAS42  80.232'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         ST    @13,@SA00001+4                                      0001
         LA    @14,@SA00001                                        0001
         ST    @14,8(,@13)                                         0001
         LR    @13,@14                                             0001
         EJECT
*  /******************************************************************/
*  /*                                                                */
*  /*  THIS SUBROUTINE PROCESSES THE W.E.'S FOUND ON THE             */
*  /*  ASYNCHRONOUS MODIFY QUEUE.  THE MAIN PROCESSING IS AS         */
*  /*  FOLLOWS:                                                      */
*  /*                                                                */
*  /*  -   IF THE Q IS EMPTY, EXIT                                   */
*  /*  -   FIND THE W.E. AT THE TOP OF THE Q                         */
*  /*  -   CALL THE SUBROUTINE 'PRCSMODE'                            */
*  /*  -   UPON RETURN FROM 'PRCSMODE', IF THE SUBROUTINE WAS        */
*  /*      UNABLE TO HANDLE THE REQUEST, EXIT AND GO BACK TO SLEEP   */
*  /*  -   OTHERWISE, DEQUEUE THE TOP W.E. AND EXIT                  */
*  /*                                                                */
*  /******************************************************************/
*  TCASTPTR=TWATCAST ;                     /*ESTABLISH TCAST ADDRESS */
         L     TCASTPTR,TWATCAST(,TWAPTR)                          0037
*  PARMERR = '0'B;                         /*INITIALIZE SWITCH       */
         NI    PARMERR,B'01111111'                                 0038
*  RESPECIFY (WESTD) BASED (TEMPPTR);      /*SET UP NEW BASE FOR W.E.*/
*  IF TWACSKIP = 'N' & TWACMODQ ^= 0 THEN  /*SHOULD WE PROCESS MOD Q */
         CLI   TWACSKIP(TWAPTR),C'N'                               0040
         BNE   @RF00040                                            0040
         L     @10,TWACMODQ(,TWAPTR)                               0040
         LTR   @10,@10                                             0040
         BZ    @RF00040                                            0040
*      DO;                                 /*YES                     */
*      TEMPPTR = TWACMODQ;                 /*GET BEGINNING POINTER   */
         LR    TEMPPTR,@10                                         0042
*      DO WHILE (WENEXT ^= 0);             /*FIND                    */
         B     @DE00043                                            0043
@DL00043 DS    0H                                                  0044
*          TEMPPTR = WENEXT;               /* LAST W.E.              */
         L     TEMPPTR,WENEXT(,TEMPPTR)                            0044
*      END;                                /*  ON Q                  */
@DE00043 L     @10,WENEXT(,TEMPPTR)                                0045
         LTR   @10,@10                                             0045
         BNZ   @DL00043                                            0045
*      CALL PRCSMODE;                      /*PROCESS THE W.E.        */
         BAL   @14,PRCSMODE                                        0046
*      IF TWACSKIP = 'N' THEN              /*KEEP ON GOING           */
         CLI   TWACSKIP(TWAPTR),C'N'                               0047
         BNE   @RF00047                                            0047
*          DO;                             /*YES                     */
*LOOP1:                                    /*COMPARE AND SWAP LOOP   */
*          TEMPPTR = TWACMODQ;             /*GET BEGINNING POINTER   */
LOOP1    L     TEMPPTR,TWACMODQ(,TWAPTR)                           0049
*                                          /*MAKE TWACMODQ THE WENEXT*/
*                                          /*FIELD OF A PSEUDO W.E.  */
*          TEMPPTR2 = ADDR(TWACMODQ) - (ADDR(WENEXT) - ADDR(WESTD));
         LA    TEMPPTR2,TWACMODQ(,TWAPTR)                          0050
         SL    TEMPPTR2,@CF00118                                   0050
*          DO WHILE (WENEXT ^= 0);         /*FIND                    */
         B     @DE00051                                            0051
@DL00051 DS    0H                                                  0052
*              TEMPPTR2 = TEMPPTR;         /* LAST                   */
         LR    TEMPPTR2,TEMPPTR                                    0052
*              TEMPPTR = WENEXT;           /*  W.E.                  */
         L     TEMPPTR,WENEXT(,TEMPPTR)                            0053
*          END;                            /*   ON Q                 */
@DE00051 L     @10,WENEXT(,TEMPPTR)                                0054
         LTR   @10,@10                                             0054
         BNZ   @DL00051                                            0054
*                                          /*HAVE ANY W.E.'S BEEN    */
*                                          /*INSERTED BETWEEN THE    */
*                                          /*BOTTOM W.E. AND THE NEXT*/
*                                          /*TO BOTTOM W.E.          */
*          CS(TEMPPTR,WENEXT,TEMPPTR2 -> WENEXT);                  0055
         CS    TEMPPTR,@10,WENEXT(TEMPPTR2)                        0055
*          BC(7,LOOP1);                    /*YES - TRY AGAIN         */
         BC    7,LOOP1                                             0056
*          LENGTH = WELEN;                 /*FREE                    */
         LH    LENGTH,WELEN(,TEMPPTR)                              0057
*          SUBPL = WECODE2T;               /* THE                    */
         SLR   SUBPL,SUBPL                                         0058
         IC    SUBPL,WECODE2T(,TEMPPTR)                            0058
*          ADDRESS = TEMPPTR;              /*  OLD                   */
         ST    TEMPPTR,ADDRESS                                     0059
*          CALL FRESPACE;                  /*   W.E.                 */
         BAL   @14,FRESPACE                                        0060
*          END;                                                    0061
*      END;                                                        0062
@RF00047 DS    0H                                                  0063
*  RESPECIFY (WESTD);                      /*REVERT TO OLD BASE      */
@RF00040 DS    0H                                                  0064
*  RETURN CODE(0);                         /*FINISHED                */
         SLR   @15,@15                                             0064
         L     @13,4(,@13)                                         0064
         L     @14,12(,@13)                                        0064
         LM    @00,@12,20(@13)                                     0064
         BR    @14                                                 0064
         EJECT
*PRCSMODE: PROC OPTIONS (SAVE (14));                               0065
@EL00001 L     @13,4(,@13)                                         0065
@EF00001 DS    0H                                                  0065
@ER00001 LM    @14,@12,12(@13)                                     0065
         BR    @14                                                 0065
PRCSMODE ST    @14,@SA00002                                        0065
*  /******************************************************************/
*  /*                                                                */
*  /*  THE PURPOSE OF THIS SUBROUTINE IS TO PROCESS A W.E. FROM THE  */
*  /*  MODIFY Q.  THE W.E. IS POINTED TO BY 'TEMPPTR'.  THE MAIN     */
*  /*  PROCESSING IS AS FOLLOWS:                                     */
*  /*                                                                */
*  /*  -   TRY AND PUT A RETURN ELEMENT ON THE SYNC Q.  IF           */
*  /*      UNSUCCESSFUL, EXIT AND GO BACK TO SLEEP.  NOTE THAT       */
*  /*      PUTTING MY RETURN W.E. ON THE TOP OF THE SYNC Q HAS THE   */
*  /*      EFFECT OF LOCKING OUT ALL OTHER TASKS WHICH PROCESS THE   */
*  /*      SYNC Q.                                                   */
*  /*  -   CALL PARAMETER PROCESSING TO EVALUATE THE PARAMETERS IN   */
*  /*      WEDATA (FOR W.E.'S CAUSED BY AN OPERATOR COMMAND, THIS    */
*  /*      WAS DONE BY 'BLDMODWE' IN IKTCAS40).                      */
*  /*  -   BUILD W.E.'S (DEPENDING ON WHAT PARAMETERS WERE ENTERED)  */
*  /*      AND PUT THEM ON THE Q                                     */
*  /*  -   POST THE TASK WHOSE W.E. IS ON TOP OF THE SYNC Q          */
*  /*  -   EXIT                                                      */
*  /*                                                                */
*  /******************************************************************/
*  IF TWASYNQH ^= 0 THEN                   /*IS SYNC Q EMPTY         */
         L     @10,TWASYNQH(,TWAPTR)                               0066
         LTR   @10,@10                                             0066
         BZ    @RF00066                                            0066
*      TWACSKIP = 'Y';                     /* NO - GO BACK TO SLEEP  */
         MVI   TWACSKIP(TWAPTR),C'Y'                               0067
*  ELSE                                                            0068
*      DO;                                 /*YES                     */
         B     @RC00066                                            0068
@RF00066 DS    0H                                                  0069
*      IF TCASUMAX=0                  /*IS USER COUNT ZERO           */
*         THEN PMFL2MX='EF'X ;        /*SET MASK TO INDICATE ZERO    */
         LH    @10,TCASUMAX(,TCASTPTR)                             0069
         LTR   @10,@10                                             0069
         BNZ   @RF00069                                            0069
         MVI   PMFL2MX,X'EF'                                       0070
*                                     /* USER COUNT                  */
*         ELSE PMFL2MX='F7'X ;        /* SET MASK TO > ZERO USER C   */
         B     @RC00069                                            0071
@RF00069 MVI   PMFL2MX,X'F7'                                       0071
*      CALL PARMSCAN;                      /*SCAN MODIFY PARAMETERS  */
@RC00069 BAL   @14,PARMSCAN                                        0072
*      MLPMFL2=MLPMFL2 & PMFL2MX ;    /* MASK OUTPUT FLAG FROM SCAN  */
         NC    MLPMFL2(1),PMFL2MX                                  0073
*      IF MLPMFL2 ^= '00'X            /* IS OUTPUT FLAG ON           */
*      THEN DO ;                      /* YES, PROCESS IT             */
         CLI   MLPMFL2,X'00'                                       0074
         BE    @RF00074                                            0074
*      IF PARMERR = '1'B THEN              /*WAS AN ERROR DISCOVERED */
         TM    PARMERR,B'10000000'                                 0076
         BNO   @RF00076                                            0076
*          PARMERR = '0'B;                 /*YES                     */
         NI    PARMERR,B'01111111'                                 0077
*      ELSE                                                        0078
*          DO;                             /*NO - KEEP GOING         */
         B     @RC00076                                            0078
@RF00076 DS    0H                                                  0079
*                                          /*CALCULATE THE LENGTH OF */
*                                          /*A RETURN W.E., VTAM     */
*                                          /*W.E., AND USER W.E.     */
*                                          /*ROUNDED UP TO A         */
*                                          /*DOUBLEWORD              */
*          LENGTH = ((12+12+12)+7)/8*8;                            0079
         LA    LENGTH,40                                           0079
*          SUBPL = 4;                      /*SUBPOOL NUMBER          */
         LA    SUBPL,4                                             0080
*          CALL GETSPACE;                  /*GET SPACE               */
         BAL   @14,GETSPACE                                        0081
*          SAVEADDR = ADDRESS;             /*SAVE FOR FUTURE USE     */
         L     @10,ADDRESS                                         0082
         LR    SAVEADDR,@10                                        0082
*          WECODE1T = TCCONSLE;            /*MY TASK                 */
         L     @07,WEPTR                                           0083
         MVI   WECODE1T(@07),X'04'                                 0083
*          WECODE2T = TCCONSLE;            /* CODE                   */
         MVI   WECODE2T(@07),X'04'                                 0084
*          WECODE1F = FCRETURN;            /*RETURN FUNCTION CODE    */
         MVI   WECODE1F(@07),X'FF'                                 0085
*          WECODE2F = FCCMODFY;            /*MODIFY FUNCTION CODE    */
         MVI   WECODE2F(@07),X'21'                                 0086
*          WERC = 0;                       /*ZERO OUT                */
         SLR   @02,@02                                             0087
         STH   @02,WERC(,@07)                                      0087
*          WENEXT = 0;                     /*ZERO OUT                */
         ST    @02,WENEXT(,@07)                                    0088
*          WELEN = LENGTH;                 /*TOTAL LENGTH OF SPACE   */
         STH   LENGTH,WELEN(,@07)                                  0089
*          TEMPPTR2 = 0;                   /*SEE IF SYNC Q           */
         SLR   TEMPPTR2,TEMPPTR2                                   0090
*          CS(TEMPPTR2,ADDRESS,TWASYNQH);  /* IS STILL EMPTY         */
         CS    TEMPPTR2,@10,TWASYNQH(TWAPTR)                       0091
*          BC(8,MODESKIP);                 /*YES                     */
         BC    8,MODESKIP                                          0092
*          CALL FRESPACE;                  /*NO - FREE SPACE         */
         BAL   @14,FRESPACE                                        0093
*          TWACSKIP = 'Y';                 /* AND GO BACK            */
         MVI   TWACSKIP(TWAPTR),C'Y'                               0094
*          RETURN;                         /*  TO SLEEP              */
@EL00002 DS    0H                                                  0095
@EF00002 DS    0H                                                  0095
@ER00002 L     @14,@SA00002                                        0095
         BR    @14                                                 0095
*      MODESKIP:                                                   0096
*          ADDRESS = ADDRESS + 12;         /*PT TO NEXT FREE W.E.    */
MODESKIP LA    @10,12                                              0096
         AL    @10,ADDRESS                                         0096
         ST    @10,ADDRESS                                         0096
*          IF MLPMUZ = '1'B THEN           /*USERMAX=0 SPECIFIED     */
         TM    MLPMUZ,B'00010000'                                  0097
         BNO   @RF00097                                            0097
*              DO;                         /*YES                     */
*              WECODE1T = TCVTAM;          /*TELL VTAM               */
         L     @10,WEPTR                                           0099
         MVI   WECODE1T(@10),X'02'                                 0099
*              WECODE1F = FCVQUSCE;        /* INTERFACE DRIVER       */
         MVI   WECODE1F(@10),X'13'                                 0100
*              CALL ADDAWE;                /*  TO                    */
         BAL   @14,ADDAWE                                          0101
*              END;                        /*   QUIESCE LOGON'S      */
*          IF MLPMFS = '1'B THEN           /*USER=FSTOP SPECIFIED    */
@RF00097 TM    MLPMFS,B'00000100'                                  0103
         BNO   @RF00103                                            0103
*              DO;                         /*YES                     */
*              WECODE1T = TCUSER;          /*TELL USER               */
         L     @10,WEPTR                                           0105
         MVI   WECODE1T(@10),X'03'                                 0105
*              WECODE1F = FCUFSTOP;        /* INTERFACE DRIVER TO    */
         MVI   WECODE1F(@10),X'22'                                 0106
*              CALL ADDAWE;                /*  TERMINATE ADDRESS     */
         BAL   @14,ADDAWE                                          0107
*              END;                        /*   SPACES FSTOP         */
*          ELSE                                                    0109
*              IF MLPMSIC = '1'B THEN      /*USER=SIC SPECIFIED      */
         B     @RC00103                                            0109
@RF00103 TM    MLPMSIC,B'00000010'                                 0109
         BNO   @RF00109                                            0109
*                  DO;                     /*YES                     */
*                  WECODE1T = TCUSER;      /*TELL USER               */
         L     @10,WEPTR                                           0111
         MVI   WECODE1T(@10),X'03'                                 0111
*                  WECODE1F = FCUSIC;      /* INTERFACE DRIVER TO    */
         MVI   WECODE1F(@10),X'21'                                 0112
*                  CALL ADDAWE;            /*  TERMINATE ADDRESS     */
         BAL   @14,ADDAWE                                          0113
*                  END;                    /*   SPACES SIC           */
*          IF MLPMUNZ = '1'B THEN          /*USERMAX>0 SPECIFIED     */
@RF00109 DS    0H                                                  0115
@RC00103 TM    MLPMUNZ,B'00001000'                                 0115
         BNO   @RF00115                                            0115
*              DO;                         /*YES                     */
*              WECODE1T = TCVTAM;          /*TELL VTAM               */
         L     @10,WEPTR                                           0117
         MVI   WECODE1T(@10),X'02'                                 0117
*              WECODE1F = FCVSTART;        /* INTERFACE DRIVER       */
         MVI   WECODE1F(@10),X'14'                                 0118
*              CALL ADDAWE;                /*  TO                    */
         BAL   @14,ADDAWE                                          0119
*              END;                        /*   START LOGON'S        */
*          ADDRESS = ADDRESS - 12;         /*POINT LAST ADDED W.E. AT*/
@RF00115 LA    @10,12                                              0121
         L     @04,ADDRESS                                         0121
         SLR   @04,@10                                             0121
         ST    @04,ADDRESS                                         0121
*          WENEXT = SAVEADDR;              /* RETURN W.E.            */
         L     @04,WEPTR                                           0122
         ST    SAVEADDR,WENEXT(,@04)                               0122
*          SAVEADDR -> WENEXT = 0;         /*SHOW RETURN W.E. IS LAST*/
         SLR   @04,@04                                             0123
         ST    @04,WENEXT(,SAVEADDR)                               0123
*                                          /*ONE ON Q                */
*          ADDRESS = SAVEADDR + 12;        /*ADDR OF NEW FIRST W.E.  */
         ALR   @10,SAVEADDR                                        0124
         ST    @10,ADDRESS                                         0124
*          CS(TWASYNQH,ADDRESS,TWASYNQH);  /*POINT Q HEAD AT NEW     */
         L     @15,TWASYNQH(,TWAPTR)                               0125
         CS    @15,@10,TWASYNQH(TWAPTR)                            0125
         BZ    @BC00125                                            0125
         ST    @15,TWASYNQH(,TWAPTR)                               0125
@BC00125 DS    0H                                                  0126
*                                          /*FIRST W.E.              */
*          RESPECIFY (R1) RESTRICTED;      /*FREEZE FOR POST         */
*          IF WECODE1T = TCVTAM THEN       /*TOP W.E. FOR VTAM       */
         L     @10,WEPTR                                           0127
         CLI   WECODE1T(@10),X'02'                                 0127
         BNE   @RF00127                                            0127
*              DO;                         /*YES                     */
*              R1 = ADDR(TWAVECB);         /*ADDR OF ECB TO POST     */
         LA    R1,TWAVECB(,TWAPTR)                                 0129
*              GEN (POST  (1))             /*POST VTAM SUB-TASK      */
*                  REFS(R0,R1,R14,R15);                            0130
         POST  (1)
*              END;                                                0131
*          ELSE                                                    0132
*              DO;                         /*NO                      */
         B     @RC00127                                            0132
@RF00127 DS    0H                                                  0133
*              R1 = ADDR(TWAUECB);         /*ADDR OF ECB TO POST     */
         LA    R1,TWAUECB(,TWAPTR)                                 0133
*              GEN (POST  (1))             /*POST USER SUB-TASK      */
*                  REFS(R0,R1,R14,R15);                            0134
         POST  (1)
*              END;                                                0135
*          RESPECIFY (R1) UNRESTRICTED;                            0136
@RC00127 DS    0H                                                  0137
*          END;                                                    0137
*        END ;                                                     0138
*      END;                                                        0139
*END PRCSMODE;                                                     0140
         B     @EL00002                                            0140
         EJECT
*PARMSCAN: PROC OPTIONS (SAVE (14));                               0141
PARMSCAN ST    @14,@SA00003                                        0141
*  /******************************************************************/
*  /*                                                                */
*  /*  THIS SUBROUTINE PROCESSES THE PARAMETERS FOUND ON THE MODIFY  */
*  /*  COMMAND.  THE MAIN PROCESSING IS AS FOLLOWS:                  */
*  /*                                                                */
*  /*  -   SET UP THE SCANNER'S PARAMETER LIST                       */
*  /*  -   BRANCH TO THE SCANNER                                     */
*  /*  -   IF ANY ERROR'S ARE DETECTED, ISSUE AN ERROR MESSAGE AND   */
*  /*      SET AN ERROR SWITCH                                       */
*  /*  -   EXIT                                                      */
*  /*                                                                */
*  /******************************************************************/
*  RESPECIFY (WESTD) BASED (TEMPPTR);      /*SET UP NEW BASE FOR W.E.*/
*  MLPMPML = MLPMPML && MLPMPML;           /*CLEAR PARM LIST         */
         XC    MLPMPML(8),MLPMPML                                  0143
*  MLPMBUF = '1'B;                         /*SHOW WHERE SCAN DATA    */
*                                          /*WILL COME FROM          */
*  MLPMUPTB = '1'B;                        /*UPDATE TCAS TABLE       */
         OI    MLPMBUF,B'00001010'                                 0145
*  MLPMSCA = ADDR(WEDATA);                 /*ADDR OF SCAN DATA       */
         LA    @10,WEDATA(,TEMPPTR)                                0146
         ST    @10,MLPMSCA                                         0146
*  RESPECIFY (R9) RESTRICTED;                                      0147
*  R9 = ADDR(MLPMPML);                     /*ADDR OF PARM LIST       */
         LA    R9,MLPMPML                                          0148
*  CALL SCANNER;                           /*BRANCH TO SCANNER       */
         L     @15,TWAPPSR(,TWAPTR)                                0149
         BALR  @14,@15                                             0149
*  RESPECIFY (R9) UNRESTRICTED;                                    0150
*  IF MLPMINV = '1'B |                     /*CHECK FOR               */
*     MLPMIGN = '1'B THEN                  /* ERRORS                 */
         TM    MLPMINV,B'01000001'                                 0151
         BZ    @RF00151                                            0151
*      DO;                                 /*FOUND ONE               */
*      PARMERR = '1'B;                     /*SET ERROR SW            */
         OI    PARMERR,B'10000000'                                 0153
*      RESPECIFY (R1) RESTRICTED;                                  0154
*      R1 = 15;                            /*MESSAGE NUMBER          */
         LA    R1,15                                               0155
*      CALL MSGBLK;                        /*ADDR OF LIST FORM OF MSG*/
         L     @15,TWAMSG(,TWAPTR)                                 0156
         BALR  @14,@15                                             0156
*      R1 = ADDR(IKT015I);                 /*TELL THE                */
         LA    @10,IKT015I(,R1)                                    0157
         LR    R1,@10                                              0157
*      GEN (WTO   MF=(E,(1)))              /* OPERATOR               */
*          REFS (R0,R1,R14,R15);           /*  ABOUT                 */
         WTO   MF=(E,(1))
*      RESPECIFY (R1) UNRESTRICTED;        /*   THE ERROR            */
*      END;                                                        0160
*  RESPECIFY (WESTD);                      /*REVERT TO OLD BASE      */
*END PARMSCAN;                                                     0162
@EL00003 DS    0H                                                  0162
@EF00003 DS    0H                                                  0162
@ER00003 L     @14,@SA00003                                        0162
         BR    @14                                                 0162
         EJECT
*ADDAWE: PROC OPTIONS (SAVE (14));                                 0163
ADDAWE   ST    @14,12(,@13)                                        0163
*  /******************************************************************/
*  /*                                                                */
*  /*  THIS SUBROUTINE DOES THE FOLLOWING THINGS:                    */
*  /*                                                                */
*  /*  -   FILL IN THE COMMON MODIFY W.E. INFORMATION                */
*  /*  -   FIND THE LAST W.E. ON THE SYNC Q                          */
*  /*  -   ADD ON THE NEW W.E.                                       */
*  /*  -   POINT AT THE NEXT FREE MODIFY W.E.                        */
*  /*                                                                */
*  /******************************************************************/
*  WECODE2T = TCCONSLE;                    /*MY TASK CODE            */
         L     @10,WEPTR                                           0164
         MVI   WECODE2T(@10),X'04'                                 0164
*  WECODE2F = FCCMODFY;                    /*MODIFY FUNCTION CODE    */
         MVI   WECODE2F(@10),X'21'                                 0165
*  WENEXT = 0;                             /*ZERO OUT                */
         SLR   @04,@04                                             0166
         ST    @04,WENEXT(,@10)                                    0166
*  WERC = 0;                               /*ZERO OUT                */
         STH   @04,WERC(,@10)                                      0167
*  WELEN = 0;                              /*ZERO OUT                */
         STH   @04,WELEN(,@10)                                     0168
*  RESPECIFY (WESTD) BASED (TEMPPTR);      /*SET UP NEW BASE FOR W.E.*/
*  TEMPPTR = TWASYNQH;                     /*START SEARCH AT TOP     */
         L     TEMPPTR,TWASYNQH(,TWAPTR)                           0170
*  DO WHILE (WENEXT ^= 0);                 /*FIND                    */
         B     @DE00171                                            0171
@DL00171 DS    0H                                                  0172
*      TEMPPTR = WENEXT;                   /* LAST                   */
         L     TEMPPTR,WENEXT(,TEMPPTR)                            0172
*  END;                                    /*  W.E.                  */
@DE00171 L     @10,WENEXT(,TEMPPTR)                                0173
         LTR   @10,@10                                             0173
         BNZ   @DL00171                                            0173
*  WENEXT = ADDRESS;                       /*ADD ON NEW W.E.         */
         L     @10,ADDRESS                                         0174
         ST    @10,WENEXT(,TEMPPTR)                                0174
*  RESPECIFY (WESTD);                      /*REVERT TO OLD BASE      */
*  ADDRESS = ADDRESS + 12;                 /*PT AT NEXT FREE W.E.    */
         AL    @10,@CF00277                                        0176
         ST    @10,ADDRESS                                         0176
*END ADDAWE;                                                       0177
@EL00004 DS    0H                                                  0177
@EF00004 DS    0H                                                  0177
@ER00004 L     @14,12(,@13)                                        0177
         BR    @14                                                 0177
         EJECT
*FRESPACE: PROC OPTIONS (SAVE (14));                               0178
FRESPACE ST    @14,@SA00005                                        0178
*  /******************************************************************/
*  /*                                                                */
*  /*  THIS SUBROUTINE DOES A FREEMAIN FOR THE NUMBER OF BYTES       */
*  /*  SPECIFIED IN 'LENGTH', USING THE ADDRESS FOUND IN 'ADDRESS'   */
*  /*  AS A STARTING ADDRESS, AND USING THE VALUE FOUND IN 'SUBPL'   */
*  /*  AS THE SUBPOOL NUMBER                                         */
*  /*                                                                */
*  /******************************************************************/
*  RESPECIFY (R2,R3) RESTRICTED;                                   0179
*  R2 = LENGTH;                                                    0180
         LR    R2,LENGTH                                           0180
*  R3 = SUBPL;                                                     0181
         LR    R3,SUBPL                                            0181
*  GEN (FREEMAIN EU,LV=(R2),A=ADDRESS,SP=(R3))                     0182
*      REFS (ADDRESS,R0,R1,R2,R3,R14,R15);                         0182
         FREEMAIN EU,LV=(R2),A=ADDRESS,SP=(R3)
*  RESPECIFY (R2,R3) UNRESTRICTED;                                 0183
*END FRESPACE;                                                     0184
@EL00005 DS    0H                                                  0184
@EF00005 DS    0H                                                  0184
@ER00005 L     @14,@SA00005                                        0184
         BR    @14                                                 0184
         EJECT
*GETSPACE: PROC OPTIONS (SAVE (14));                               0185
GETSPACE ST    @14,@SA00006                                        0185
*  /******************************************************************/
*  /*                                                                */
*  /*  THIS SUBROUTINE DOES A GETMAIN FOR THE NUMBER OF BYTES        */
*  /*  SPECIFIED IN 'LENGTH' (SHOULD BE A DOUBLEWORD MULTIPLE),      */
*  /*  FROM THE SUBPOOL SPECIFIED IN 'SUBPL', AND THEN PLACES THE    */
*  /*  STARTING ADDRESS OF THE GETMAIN'ED AREA IN 'ADDRESS'.         */
*  /*                                                                */
*  /******************************************************************/
*  RESPECIFY (R2,R3) RESTRICTED;                                   0186
*  R2 = LENGTH;                                                    0187
         LR    R2,LENGTH                                           0187
*  R3 = SUBPL;                                                     0188
         LR    R3,SUBPL                                            0188
*  GEN (GETMAIN EU,LV=(R2),A=ADDRESS,SP=(R3))                      0189
*      REFS (ADDRESS,R0,R1,R2,R3,R14,R15);                         0189
         GETMAIN EU,LV=(R2),A=ADDRESS,SP=(R3)
*  RESPECIFY (R2,R3) UNRESTRICTED;                                 0190
*END GETSPACE;                                                     0191
@EL00006 DS    0H                                                  0191
@EF00006 DS    0H                                                  0191
@ER00006 L     @14,@SA00006                                        0191
         BR    @14                                                 0191
         EJECT
*END IKTCAS42                                                      0192
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IKTTCAST)                                        *
*/*%INCLUDE SYSLIB  (IKTCASWA)                                        *
*;                                                                 0192
@DATA    DS    0H
         DS    0F
@SA00001 DS    18F
@SA00002 DS    1F
@SA00005 DS    1F
@SA00003 DS    1F
@SA00006 DS    1F
         DS    0F
@CF00118 DC    F'4'
@CF00277 DC    F'12'
         DS    0D
ADDRESS  DS    A
SWITCHES DS    CL1
         ORG   SWITCHES
PARMERR  DS    BL1
@NM00001 EQU   SWITCHES+0
         ORG   SWITCHES+1
         DS    CL3
MLPMPML  DS    CL8
         ORG   MLPMPML
MLPMFL1  DS    BL1
         ORG   MLPMFL1
@NM00003 DS    BL1
MLPMSTRT EQU   MLPMFL1+0
MLPMWPM  EQU   MLPMFL1+0
MLPMUPTB EQU   MLPMFL1+0
MLPMRLIB EQU   MLPMFL1+0
MLPMBUF  EQU   MLPMFL1+0
MLPMCIB  EQU   MLPMFL1+0
         ORG   MLPMPML+1
MLPMFL2  DS    BL1
         ORG   MLPMFL2
@NM00004 DS    BL1
MLPMINV  EQU   MLPMFL2+0
MLPMERR  EQU   MLPMFL2+0
MLPMUZ   EQU   MLPMFL2+0
MLPMUNZ  EQU   MLPMFL2+0
MLPMFS   EQU   MLPMFL2+0
MLPMSIC  EQU   MLPMFL2+0
MLPMIGN  EQU   MLPMFL2+0
         ORG   MLPMPML+2
@NM00005 DS    BL2
MLPMSCA  DS    AL4
         ORG   MLPMPML+8
PMFL2MX  DC    X'FF'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
TCASTPTR EQU   @03
TEMPPTR2 EQU   @03
TEMPPTR  EQU   @02
SUBPL    EQU   @06
LENGTH   EQU   @04
SAVEADDR EQU   @05
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R9       EQU   @09
TWAPTR   EQU   @11
R14      EQU   @14
R15      EQU   @15
SCANNER  EQU   0
MSGBLK   EQU   0
@NM00002 EQU   0
MSGDATA  EQU   @NM00002+4
WESTD    EQU   0
WECODE1T EQU   WESTD
WECODE1F EQU   WESTD+1
WECODE2T EQU   WESTD+2
WECODE2F EQU   WESTD+3
WENEXT   EQU   WESTD+4
WERC     EQU   WESTD+8
WELEN    EQU   WESTD+10
WEDATA   EQU   WESTD+12
TCAST    EQU   0
TCASUSER EQU   TCAST+4
TCASUMAX EQU   TCASUSER+2
TCASFLG1 EQU   TCAST+88
TWAR     EQU   0
TWASYNQH EQU   TWAR+4
TWATCAST EQU   TWAR+20
TWAPPSR  EQU   TWAR+36
TWAMSG   EQU   TWAR+48
TWAMFL   EQU   TWAR+80
TWAVFL   EQU   TWAR+81
TWAUFL   EQU   TWAR+82
TWACFL   EQU   TWAR+83
TWAM     EQU   TWAR+84
TWAME    EQU   TWAM+68
TWAMEI   EQU   TWAME
TWAV     EQU   TWAR+184
TWAVE    EQU   TWAV+68
TWAVEI   EQU   TWAVE
TWAVI    EQU   TWAR+284
TWAVECB  EQU   TWAVI
TWAU     EQU   TWAR+300
TWAUE    EQU   TWAU+68
TWAUEI   EQU   TWAUE
TWAUI    EQU   TWAR+400
TWAUECB  EQU   TWAUI
TWAC     EQU   TWAR+408
TWACE    EQU   TWAC+68
TWACEI   EQU   TWACE
TWACI    EQU   TWAR+508
TWACMODQ EQU   TWACI+8
TWACSKIP EQU   TWACI+12
WEPTR    EQU   ADDRESS
IKT015I  EQU   MSGDATA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
TWAEND   EQU   TWAR+536
TWAWORKE EQU   TWAR+524
@NM00015 EQU   TWACI+13
TWACSTPQ EQU   TWACI+4
TWACECB  EQU   TWACI
TWACERRS EQU   TWACE+4
TWACERA  EQU   TWACEI+1
TWACEIFC EQU   TWACEI
TWACRTFC EQU   TWAC+60
TWACABFC EQU   TWAC+56
TWACTWA  EQU   TWAC+52
TWACEWA  EQU   TWAC+4
TWACID   EQU   TWAC
TWAUACQH EQU   TWAUI+4
TWAUERRS EQU   TWAUE+4
TWAUERA  EQU   TWAUEI+1
TWAUEIFC EQU   TWAUEI
TWAURTFC EQU   TWAU+60
TWAUABFC EQU   TWAU+56
TWAUTWA  EQU   TWAU+52
TWAUEWA  EQU   TWAU+4
TWAUID   EQU   TWAU
TWAVACQH EQU   TWAVI+12
TWAVTHQH EQU   TWAVI+8
TWAVTEQH EQU   TWAVI+4
TWAVERRS EQU   TWAVE+4
TWAVERA  EQU   TWAVEI+1
TWAVEIFC EQU   TWAVEI
TWAVRTFC EQU   TWAV+60
TWAVABFC EQU   TWAV+56
TWAVTWA  EQU   TWAV+52
TWAVEWA  EQU   TWAV+4
TWAVID   EQU   TWAV
TWAMERRS EQU   TWAME+4
TWAMERA  EQU   TWAMEI+1
TWAMEIFC EQU   TWAMEI
TWAMRTFC EQU   TWAM+60
TWAMABFC EQU   TWAM+56
TWAMTWA  EQU   TWAM+52
TWAMEWA  EQU   TWAM+4
TWAMID   EQU   TWAM
@NM00014 EQU   TWACFL
TWACFL4  EQU   TWACFL
TWACFL2  EQU   TWACFL
TWACFL1  EQU   TWACFL
@NM00013 EQU   TWAUFL
TWAUFL4  EQU   TWAUFL
TWAUFL3  EQU   TWAUFL
TWAUFL2  EQU   TWAUFL
TWAUFL1  EQU   TWAUFL
@NM00012 EQU   TWAVFL
TWAVFL6  EQU   TWAVFL
TWAVFL5  EQU   TWAVFL
TWAVFL4  EQU   TWAVFL
TWAVFL3  EQU   TWAVFL
TWAVFL2  EQU   TWAVFL
TWAVFL1  EQU   TWAVFL
@NM00011 EQU   TWAMFL
TWAMFL1  EQU   TWAMFL
TWACCOMP EQU   TWAR+76
TWAUCOMP EQU   TWAR+72
TWAVCOMP EQU   TWAR+68
TWAMECB  EQU   TWAR+64
TWACTCB  EQU   TWAR+60
TWAUTCB  EQU   TWAR+56
TWAVTCB  EQU   TWAR+52
TWADEQAS EQU   TWAR+44
TWAEESR  EQU   TWAR+40
TWATCSR  EQU   TWAR+32
TWATTSR  EQU   TWAR+28
TWAINIT  EQU   TWAR+24
TWACSCB  EQU   TWAR+16
TWAASCB  EQU   TWAR+12
TWAPASQH EQU   TWAR+8
TWARSON  EQU   TWAR+2
TWACOMP  EQU   TWAR
TCASTEND EQU   TCAST+148
TCASTTYO EQU   TCAST+144
TCAS767O EQU   TCAST+140
TCAS767I EQU   TCAST+136
TCASDUMP EQU   TCAST+132
TCASSCHD EQU   TCAST+128
TCASTPND EQU   TCAST+124
TCASOMJR EQU   TCAST+120
@NM00010 EQU   TCAST+118
TCASBR14 EQU   TCAST+116
TCASATTN EQU   TCAST+112
TCASASCI EQU   TCAST+108
TCASTTQH EQU   TCAST+104
@NM00009 EQU   TCAST+102
@NM00008 EQU   TCAST+100
TCASTGTF EQU   TCAST+96
TCASASCB EQU   TCAST+92
TCASFLG4 EQU   TCAST+91
TCASFLG3 EQU   TCAST+90
TCASFLG2 EQU   TCAST+89
TCASCONF EQU   TCASFLG1
@NM00007 EQU   TCASFLG1
TCASHAST EQU   TCASFLG1
TCASNACT EQU   TCASFLG1
TCASVSD  EQU   TCASFLG1
TCASABND EQU   TCASFLG1
TCASMDSW EQU   TCASFLG1
TCASBKMD EQU   TCASFLG1
TCASLTE  EQU   TCAST+84
TCASEXIT EQU   TCAST+80
TCASOQM  EQU   TCAST+76
TCASIQM  EQU   TCAST+72
TCASTSB  EQU   TCAST+68
TCASTTL  EQU   TCAST+64
TCASWA   EQU   TCAST+60
TCASFRR  EQU   TCAST+56
TCASMSGS EQU   TCAST+52
TCASDATO EQU   TCAST+48
TCASDATI EQU   TCAST+44
TCASXECB EQU   TCAST+40
TCASTID  EQU   TCAST+32
@NM00006 EQU   TCAST+31
TCASCHNL EQU   TCAST+30
TCASCRSZ EQU   TCAST+28
TCASLBUF EQU   TCAST+24
TCASHBUF EQU   TCAST+20
TCASCLSZ EQU   TCAST+18
TCASRCON EQU   TCAST+16
TCASACBP EQU   TCAST+8
TCASUSEC EQU   TCASUSER
TCASID   EQU   TCAST
MSGLNGTH EQU   @NM00002
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00066 EQU   @EL00002
@RF00074 EQU   @EL00002
@RC00076 EQU   @EL00002
@RF00151 EQU   @EL00003
@ENDDATA EQU   *
         END   IKTCAS42,(C'PLS2006',0702,80232)
