* /* MACMEAN ASMH MEANS AUXILIARY STORAGE MANAGEMENT HEADER          */
* /* MACCOMP Y-4SC1CW/PZD81                                          */
* /* MACSTAT Y-475078/415304                                         */
*/*A-000000-999999                                           @Z40WPWK*/
*/********************************************************************/
*/*                                                                  */
*/*  NAME: ILRASMHD                                                  */
*/*                                                                  */
*/*  FUNCTION:  AUXILIARY STORAGE MANAGEMENT HEADER                  */
*/*                                                                  */
*/*  STATUS:  OS/VS2 RELEASE 4.1, LEVEL 0                            */
*/*                                                                  */
*/*  EXTERNAL REFERENCES:  ASMHDPTR - USER DEFINED POINTER TO ASMHD  */
*/*                                                                  */
*/*  REGISTERS USED:  N/A                                            */
*/*                                                                  */
*/*  REGISTERS CLOBBERED: N/A                                        */
*/*                                                                  */
*/*  NOTES:  THE ASMHD IS USED BY I/O CONTROL TO MANAGE PAGING I/O   */
*/*          AND SWAP OPERATIONS FOR EACH PRIVATE ADDRESS SPACE.  VIO*/
*/*          CONTROL ALSO USES THE ASMHD TO CONTROL ALL OPERATIONS   */
*/*          FOR VIO DATA SETS OWNED BY A PRIVATE ADDRESS SPACE.  AN */
*/*          ASMHD EXISTS FOR EACH ACTIVE ADDRESS SPACE.  IT IS BUILT*/
*/*          IN SQA AND REFERENCED VIA A POINTER IN THE ASCB.  THE   */
*/*          FIELD NAMES ARE PREFIXED WITH ASH BECAUSE THE ASM PREFIX*/
*/*          IS ALREADY USED FOR THE ASMVT.                          */
*/*                                                                  */
*/*  METHOD OF ACCESS:                                               */
*/*          PL/S - DECLARE ASMHDPTR PTR                             */
*/*                 % INCLUDE SYSLIB(ILRASMHD)                       */
*/*                 TO INCLUDE THE ASMHD IN ANOTHER STRUCTURE -      */
*/*                 %ASH9999=','                                     */
*/*                 %ASHLEVEL='N'                                    */
*/*                 WHERE N IS THE NUMBER TO BE USED AS THE          */
*/*                 STRUCTURE LEVEL NUMBER.                          */
*/*                 THE LENGTH OF THE ASMHD MAY BE OBTAINED BY       */
*/*                 REFERENCING THE MACRO VARIABLE ASHLEN.           */
*/*          BAL  - DSECT=NO   SHOULD BE SPECIFIED ON THE MACRO CALL */
*/*                 TO AVOID CREATING A DSECT.  A USING ON ASMHD WILL*/
*/*                 ESTABLISH ADDRESSIBILITY FOR ALL SYMBOLS.        */
*/*                                                                  */
*/********************************************************************/
*           %GOTO   ASHPLS;           /* BILINGUAL HEADER
            MACRO
            ILRASMHD    &DUMMY,&DSECT=YES
            AIF         ('&DSECT' EQ 'YES').ASMHD01
ASMHD       DS          0F            ASMHD CONTROL BLOCK
            AGO         .ASMHD02      CALL FOR BIT DEFINITION
.ASMHD01    ANOP
ASMHD       DSECT       , ASMHDPTR
.ASMHD02    SPACE       2
            IEZBITS     ,
ASHFLAG1    DS          B             I/O CONTROL FLAGS
ASHSWPOT    EQU         BIT0          SWAP-OUT FLAG
*                                     1 = SWAP-OUT OPERATION IN
*                                     PROGRESS
*                                     0 = NO SWAP-OUT IN PROGRESS
ASHCAPER    EQU         BIT1          SWAP CAPTURE QUEUE ERROR
*                                     1 = ONE OR MORE SWAP-OUT CAPTURE
*                                     AIAS ON SWAP CAPTURE HAS SUFFERED
*                                     AN I/O ERROR
*                                     0 = ALL AIAS ON SWAP CAPTURE
*                                     QUEUE HAVE COMPLETED SUCCESSFULLY
ASHPERME    EQU         BIT2          PERMANENT SOFTWARE ERROR FLAG
*                                     1 = ONE OR MORE SWAP-OUT AIAS
*                                     ON THE SWAP CAPTURE Q HAS AN
*                                     UNRESTARTABLE SOFT ERROR
*                                     0 = ALL AIAS ON THE SWAP
*                                     CAPTURE Q HAVE NO LOGICAL
*                                     ERRORS
ASHRSV2     EQU         BIT3          RESERVED
ASHRSV3     EQU         BIT4          RESERVED
ASHRSV4     EQU         BIT5          RESERVED
ASHRSV5     EQU         BIT6          RESERVED
ASHRSV6     EQU         BIT7          RESERVED
ASHFLAG2    DS          B             VIO CONTROL FLAGS
ASHSCHED    EQU         BIT0          SRB CONTROLLER SCHEDULED FLAG
*                                     1 = SRB CONTROLLER HAS BEEN
*                                     SCHEDULED, BUT NOT DISPATCHED
*                                     SRB FOR ADDRESS SPACE NOT
*                                     AVAILABLE
*                                     0 = SRB FOR ADDRESS SPACE
*                                     AVAILABLE
ASHRSV13    EQU         BIT1          RESERVED
ASHRSV7     EQU         BIT2          RESERVED
ASHRSV8     EQU         BIT3          RESERVED
ASHRSV9     EQU         BIT4          RESERVED
ASHRSV10    EQU         BIT5          RESERVED
ASHRSV11    EQU         BIT6          RESERVED
ASHRSV12    EQU         BIT7          RESERVED
ASHSWPCT    DS          H             COUNT OF STARTED BUT NOT COMPLETE
*                                     LSQA SWAP-OUT AIAS
ASHBKSLT    DS          F             NUMBER OF AUXILIARY STORAGE SLOTS
*                                     RESERVED FOR THIS ADDRESS SPACE
ASHIOCNT    DS          F             COUNT OF PRIVATE AREA AIA I/O
*                                     REQUEST STARTED BUT NOT COMPLETE
ASHSWAPQ    DS          A             SWAP QUEUE FOR AIAS, THIS QUEUE
*                                     IS A HOLD QUEUE FOR LSQA AIAS
*                                     DURING SWAP-OUT PROCESSING OF
*                                     NON-LSQA I/O.
ASHCAPQ     DS          A             SWAP CAPTURE QUEUE USED TO
*                                     COLLECT I/O COMPLETE AIAS
*                                     DURING LSQA SWAP-OUT
*                                     PROCESSING
ASHLOCK     DS          F             LOCK WORD FOR ASM CLASS LOCK,
*                                     USED BY VIO CONTROL PROCESSING
ASHVSRBP    DS          A             ADDRESS OF SRB USED BY VIO
*                                     CONTROL TO DISPATCH THE SRB
*                                     CONTROLLER. THIS POINTER IS ZERO
*                                     IF NO VIO DATA SETS HAVE EVER
*                                     BEEN USED BY THE ADDRESS SPACE.
*                                     ONCE CREATED, THE SRB IS NOT
*                                     FREED UNTIL ADDRESS SPACE
*                                     TERMINATION
ASHLGEQ     DS          A             ADDRESS OF FIRST LGE IN QUEUE
*                                     OF LGES FOR VIO DATA SETS
            MEND
*           */
*%ASHPLS:;                            /* PLS COMPILE TIME TARGET     */
*       %IF ASH9999 ^= ','            /* IF THIS IS LAST BLOCK       */
*          %THEN ASH9999 = ';';       /* THEN CLOSE DCL STATEMENT    */
*       %IF ASHLEVEL ^= ''            /* IF THIS IS CONCATENATED     */
*          %THEN %GOTO ASHPLS1;       /* THEN SKIP DCL STATEMENT     */
*DECLARE
*  1 ASMHD BASED(ASMHDPTR) BDY(WORD), /* ASM HEADER                  */
*          %GOTO ASHPLS2;             /* SKIP LEVEL 2 DECLARE        */
*%ASHPLS1:
*     ASHNUM = ASHLEVEL || ' ASMHD BDY(WORD),'; /* SET MINOR LEVEL   */
*     ASHNUM                          /* STRUCTURE                   */
*%ASHPLS2:;
*    4 ASHFLAG1 BIT(8),               /* I/O CONTROL FLAGS           */
*      6 ASHSWPOT BIT(1),             /* SWAP-OUT FLAG
*                                        1 = SWAP-OUT OPERATION IN
*                                        PROGRESS
*                                        0 = NO SWAP-OUT IN PROGRESS */
*      6 ASHCAPER BIT(1),             /* SWAP CAPTURE QUEUE ERROR
*                                        1 = ONE OR MORE SWAP-OUT AIAS
*                                        ON SWAP CAPTURE QUEUE HAS
*                                        SUFFERED AN I/O ERROR
*                                        0 = ALL AIAS ON SWAP CAPTURE
*                                        QUEUE HAVE COMPLETED
*                                        SUCCESSFULLY                */
*      6 ASHPERME BIT(1),             /* PERMANENT SOFTWARE ERROR FLAG
*                                        1 = ONE OR MORE SWAP-OUT AIAS
*                                        ON THE SWAP CAPTURE Q HAS AN
*                                        UNRESTARTABLE SOFT ERROR
*                                        0 = ALL AIAS ON THE SWAP
*                                        CAPTURE Q HAVE NO LOGICAL
*                                        ERRORS                      */
*      6 ASHRSV2 BIT(1),              /* RESERVED                    */
*      6 ASHRSV3 BIT(1),              /* RESERVED                    */
*      6 ASHRSV4 BIT(1),              /* RESERVED                    */
*      6 ASHRSV5 BIT(1),              /* RESERVED                    */
*      6 ASHRSV6 BIT(1),              /* RESERVED                    */
*    4 ASHFLAG2 BIT(8),               /* VIO CONTROL FLAGS           */
*      6 ASHSCHED BIT(1),             /* SRB CONTROLLER SCHEDULED FLAG
*                                        1 = SRB CONTROLLER HAS BEEN
*                                        SCHEDULED, BUT NOT DISPATCHED
*                                        SRB FOR ADDRESS SPACE NOT
*                                        AVAILABLE
*                                        0 = SRB FOR ADDRESS SPACE
*                                        AVAILABLE                   */
*      6 ASHRSV13 BIT(1),             /* RESERVED                    */
*      6 ASHRSV7 BIT(1),              /* RESERVED                    */
*      6 ASHRSV8 BIT(1),              /* RESERVED                    */
*      6 ASHRSV9 BIT(1),              /* RESERVED                    */
*      6 ASHRSV10 BIT(1),             /* RESERVED                    */
*      6 ASHRSV11 BIT(1),             /* RESERVED                    */
*      6 ASHRSV12 BIT(1),             /* RESERVED                    */
*    4 ASHSWPCT FIXED(15),            /* COUNT OF STARTED BUT NOT
*                                        COMPLETE LSQA SWAP-OUT AIAS */
*    4 ASHBKSLT FIXED(31),            /* NUMBER OF AUXILIARY STORAGE
*                                        SLOTS RESERVED FOR THIS
*                                        ADDRESS SPACE               */
*    4 ASHIOCNT FIXED(31),            /* COUNT OF PRIVATE AREA AIA I/O
*                                        REQUEST STARTED BUT NOT
*                                        COMPLETE                    */
*    4 ASHSWAPQ PTR(31),              /* SWAP QUEUE FOR AIAS, THIS
*                                        QUEUE IS A HOLD QUEUE FOR
*                                        LSQA AIAS DURING SWAP-OUT
*                                        PROCESSING OF NON-LSQA I/O  */
*    4 ASHCAPQ PTR(31),               /* SWAP CAPTURE QUEUE USED TO
*                                        COLLECT I/O COMPLETE AIAS
*                                        DURING LSQA SWAP-OUT
*                                        PROCESSING                  */
*    4 ASHLOCK FIXED(31),             /* LOCK WORD FOR ASM CLASS LOCK,
*                                        USED BY VIO CONTROL
*                                        PROCESSING                  */
*    4 ASHVSRBP PTR(31),              /* ADDRESS OF SRB USED BY VIO
*                                        CONTROL TO DISPATCH THE SRB
*                                        CONTROLLER. THIS POINTER IS
*                                        ZERO IF NO VIO DATA SETS HAVE
*                                        EVER BEEN USED BY THE ADDRESS
*                                        SPACE. ONCE CREATED, THE SRB
*                                        IS NOT FREED UNTIL ADDRESS
*                                        SPACE TERMINATION           */
*    4 ASHLGEQ PTR(31) ASH9999        /* ADDRESS OF FIRST LGE IN QUEUE
*                                        OF LGES FOR VIO DATA SETS   */
*    %ASHLEN = 'LENGTH(ASMHD)';       /* OBTAIN LENGTH OF ASMHD      */
