* /* MACMEAN IORB MEANS INPUT OUTPUT REQUEST BLOCK                   */
* /* MACCOMP Y-4SC1CW/PZD81                                          */
* /* MACSTAT Y-474240/415301                                         */
*/*A-000000-999999                                           @Z40APWA*/
*/********************************************************************/
*/*                                                                  */
*/*  NAME:  ILRIORB                                                  */
*/*                                                                  */
*/*  FUNCTION:  INPUT/OUTPUT REQUEST BLOCK                           */
*/*                                                                  */
*/*  STATUS:  OS/VS2 RELEASE 4.1, LEVEL 0                            */
*/*                                                                  */
*/*  EXTERNAL REFERENCES: IORBPTR - USER DEFINED POINTER TO IORB     */
*/*                                                                  */
*/*  REGISTERS USED:  N/A                                            */
*/*                                                                  */
*/*  REGISTERS CLOBBERED:  N/A                                       */
*/*                                                                  */
*/*  NOTES:  THIS MAPPING MACRO DESCRIBES THE CONTROL BLOCK PASSED   */
*/*          TO THE I/O MANAGER BY AUXILIARY STORAGE MANAGER. IT     */
*/*          CONTAINS POINTERS TO OTHER CONTROL BLOCKS, A POINTER TO */
*/*          AN EIGHTEEN WORD SAVE AREA, AND FLAGS FOR I/O MANAGERS  */
*/*          USE.                                                    */
*/*                                                                  */
*/*          THE IORB IS USED IN CONJUNCTION WITH AN IOSB AND AN SRB */
*/*          FOR I/O PURPOSES IN PLACE OF THE IOB USED BY OTHER IOS  */
*/*          DRIVERS. THE IORB POINTS TO THE IOSB, WHICH POINTS TO   */
*/*          THE SRB.                                                */
*/*                                                                  */
*/*  METHOD OF ACCESS:                                               */
*/*         BAL  - DSECT=NO  SHOULD BE SPECIFIED ON THE MACRO CALL   */
*/*                TO AVOID CREATING A DSECT. A USING ON IORB WILL   */
*/*                ESTABLISH ADDRESSIBILITY FOR ALL SYMBOLS.         */
*/*         PL/S - DCL IORBPTR PTR                                   */
*/*                                                                  */
*/********************************************************************/
*          %GOTO   IORBPLS;          /* BILINGUAL HEADER
           MACRO
           ILRIORB    &DUMMY,&DSECT=YES
           AIF        ('&DSECT' EQ 'YES').IORB01
IORB       DS         0D             IORB CONTROL BLOCK
           AGO        .IORB02        CALL FOR BIT DEFINITION
.IORB01    ANOP
IORB       DSECT      , IORBPTR
.IORB02    SPACE      2
           IEZBITS    ,
IORID      DS         C              IORB IDENTIFIER X'88'
IORNUM     DS         X              NO. OF IORBS FOR THIS PAGE SPACE
IORRQSZ    DS         X              NUMBER OF PCCWS IN THIS REQUEST
IORFLGS    DS         B              INTERNAL FLAGS
IORFUSE    EQU        BIT0           X'80' = IORB IN USE
IORFRPS    EQU        BIT1           X'40' = RPS DEVICE
IORSWAP    EQU        BIT4           SWAP DATA SET FLAG
*                                    1 = IORB FOR SWAP DATA SET
*                                    0 = IORB FOR PAGE DATA SET
IORAPND    EQU        BIT5           APPENDAGE FLAGS
IORFDI     EQU        BIT5           X'04' = DIE COMPLETED
IORFNE     EQU        BIT6           X'02' = NORMAL END COMPLETED
IORFAE     EQU        BIT7           X'01' = ABNORMAL END COMPLETED
IORIORB    DS         A              POINTER TO NEXT IORB
IORPCCW    DS         A              POINTER TO FIRST PCCW
IORSCCW    EQU        IORPCCW        POINTER TO FIRST SCCW
IORIOSB    DS         A              IOSB ADDRESS
IORSAVE    DS         A              POINTER TO 18 WORD SAVE AREA
IORERR     DS         A              ADDRESS OF PCCW IN ERROR
IORTSMP    DS         CL8            ILRSRT TOD STAMP
IORPARTE   DS         A              POINTER TO PARTE
IORRSV     DS         F              RESERVED
           MEND
*          */
*%IORBPLS:;                          /* PLS COMPILE TIME TARGET      */
*       DCL 1 IORB BASED(IORBPTR) CHAR(40) BDY(DWORD), /* IORB       */
*             2 IORID  CHAR(1),      /* IORB IDENTIFIER X'88'        */
*             2 IORNUM FIXED(8),     /* NO. OF IORBS FOR PAGE SPACE  */
*             2 IORRQSZ FIXED(8),    /* NUMBER OF PCCWS THIS REQUEST */
*             2 IORFLGS BIT(8),      /* INTERNAL FLAGS               */
*               3 IORFUSE BIT(1),    /* X'80' = IORB IN USE          */
*               3 IORFRPS BIT(1),    /* X'40' = RPS DEVICE           */
                3 * BIT(2),          /* RESERVED                     */
*               3 IORSWAP BIT(1),    /* SWAP DATA SET FLAG
*                                       1 = IORB FOR SWAP DATA SET
*                                       0 = IORB FOR PAGE DATA SET   */
*               3 IORAPND BIT(3),    /* APPENDAGE FLAGS              */
*                 4 IORFDI BIT(1),   /* DIE COMPLETED                */
*                 4 IORFNE BIT(1),   /* NORMAL END COMPLETED FLAG    */
                  4 IORFAE BIT(1),   /* ABNORMAL END COMPLETED FLAG  */
*             2 IORIORB PTR(31),     /* POINTER TO NEXT IORB         */
*             2 IORPCCW PTR(31),     /* POINTER TO FIRST PCCW        */
*               3 IORSCCW PTR(31),   /* POINTER TO FIRST SCCW        */
*             2 IORIOSB PTR(31),     /* IOSB ADDRESS                 */
*             2 IORSAVE PTR(31),     /* POINTER TO 18 WORD SAVE AREA */
*             2 IORERR PTR(31),      /* POINTER TO PCCW IN ERROR     */
*             2 IORTSMP CHAR(8),     /* ILRSRT TOD STAMP             */
*             2 IORPARTE PTR(31),    /* POINTER TO PARTE             */
*             2 IORRSV CHAR(4),      /* RESERVED                     */
*             2 * CHAR(0) BDY(DWORD);
