         TITLE 'ILRSLOTC,MEMORY BACKING SLOT CONSTANTS'
ILRSLOTC CSECT
*A-000000-999999                                                @Y026SB
* /* START OF SPECIFICATIONS ****
*
*01*  NAME = ILRSLOTC
*02*    ASSEMBLY-MODULE-NAME = ILRSLOTC
*
*02*    COMMON-NAME = MEMORY BACKING SLOT CONSTANT
*02*    LOAD-MODULE-NAME = IEANUC01
*02*    ALIASES = ILRSLOTV
*02*    CSECTS = ILRSLOTC
*                ILRSLOTV
*
*01*  COPYRIGHT = NONE
*
*01*  STATUS = OS/VS2, RELEASE 2, LEVEL 0
*
*01*  FUNCTION = NON-EXECUTABLE CSECT CONTAINING FULL WORD
*     CONSTANTS USED TO GENERATE THE NUMBER OF SLOTS NEEDED TO BACK A
*     LOGICAL GROUP OR PRIVATE ADDRESS SPACE. ASM USES THESE CONSTANTS
*     IN DECIDING WHETHER A LOGICAL OR ADDRESS SPACE CAN BE CREATED.
*     THE MAXIMUM NUMBER OF SLOTS THAT CAN USED IS DIVIDED BY THE
*     APPROPRIATE CONSTANT (SLOTC FOR A MEMORY, SLOTV FOR A VIO DATA
*     SET) THE RESULT COMPARED WITH THE NUMBER OF USER AUXILIARY SLOTS
*     REMAINING. IF THERE ARE ENOUGH, THE REQUEST IS ALLOWED TO
*     CONTINUE, OTHERWISE IT IS REFUSED.
*
*01*  OPERATION = NONE
*
*01*  NOTES = ILRSLOTC MAY BE SUPERZAPPED BY THE USER INSTALLATION,
*             REQUIRING THE SECOND CSECT.
*
*             THE SLOTC VALUE IS SET TO 8 TO PROVIDE 1 MEGABYTE OF
*             RESERVED SLOTS PER ADDRESS SPACE. THIS VALUE ASSUMES THE
*             AVERAGE ADDRESS SPACE SIZE IS 8 MEGABYTES.  IF THIS
*             AVERAGE CHANGES, SO SHOULD THE SLOTC CONSTANT.
*
*02*    CHARACTER-CODE-DEPENDENCIES = NONE
*
*02*    DEPENDENCIES = NONE
*
*02*    RESTRICTIONS = NON-EXECUTABLE.
*
*02*    REGISTER-CONVENTIONS = N/A
*
*02*    PATCH-LABEL = N/A
*
*01*  MODULE-TYPE = MODULE
*
*02*    PROCESSOR = ASSEM-370R
*
*02*    MODULE-SIZE = 12 BYTES
*
*02*    ATTRIBUTES = NON-EXECUTABLE
*
*01*  ENTRY-POINT = N/A
*
*02*    EXIT = N/A
*
*01*  EXTERNAL-REFERENCES = NONE
*
*02*    DATA-SETS = N/A
*
*02*    DATA-AREA = N/A
*
*02*    CONTROL-BLOCKS = N/A
*
*01*  TABLES = N/A
*
*01*  MAPPING-MACROS = N/A
*
*01*  EXECUTABLE-MACROS = N/A
*
*01*  ABEND-CODES = N/A
*
*01*  ENQUEUE-RESOURCES = N/A
*
*01*  MESSAGES = N/A
*
*01*  CHANGE-ACTIVITY = S/D CODE = Y02152, Z40WPWG
*
**** END OF SPECIFICATIONS ***/
         DC   F'8'                MEMORY BACKING SLOT CONSTANT @Z40WPWG
ILRSLOTV CSECT
         DC   F'4'                VIO DATA SET BACKING SLOT CONSTANT
         END
