*        %GOTO PLSIOBK;           /* BILINGUAL HEADER
         MACRO
         IOBLOCKS
*
*        I/O CONTROL BLOCKS  (ECB,TECB ADDRESS,IOB,DCB)
*
*        VERSION 10.0 (TCAM,TOTE)                              @Y17XAXU
*
IOBLOCKS DSECT
*
*        EVENT CONTROL BLOCK
*
ECBOLT   DS    F .                EVENT CONTROL BLOCK
*
*        UNIT CONTROL BLOCK ADDRESS
*
OLTUCBA  DS    AL2 .              UCB ADDRESS
*
*        TERMINAL NAME TABLE ENTRY OFFSET
*
OLTTCOFF DS    H .                C. TNT ENTRY OFFSET          @Y17XAXU
OLTTNOFF DS    H .                REAL TNT ENTRY OFFSET        @Y17XAXU
OLTTRSID DS    H                  NETWORK ADDRESS              @Y17XAXU
*
*        TCAM RELATIVE LINE NUMBER
*
OLTTCRLN DS    C .                RLN
OLTLCBA  DS    AL3 .              LCB ADDRESS OF 3705          @Y17XAXU
*
OLTTCTNT DS    F .                C. TNT ENTRY ADDRESS         @Y17XAXU
OLTRLTNT DS    A                  REAL TNT ENTRY ADDRESS       @Y17XAXU
OLTTDLN  DS    H .                LENGTH OF TD TTE AREA        @Y17XAXU
OLTFLAG1 DS    C .                TEST DEVICE FLAG BYTE        @Y17XAXU
OLTTNTAS EQU   X'80'              TOTE TNT ENTRY ASSIGNED      @Y17XAXU
OLTPRSC  EQU   X'20'              ON=PRI TD, OFF=SEC TD        @Y17XAXU
OLTUNRD  EQU   X'10'              ON=UNREAD DATA               @Y17XAXU
*                                 OFF=NO UNREAD DATA           @Y17XAXU
OLTEX    EQU   X'08'              EXCEPTION RESPONSE           @Y17XAXU
OLTFME   EQU   X'04'              DEFINITE RESPONSE            @Y17XAXU
OLTEN    EQU   X'02'              ON=EXPEDITED,OFF=NORMAL      @Y17XAXU
         DS    C                  RESERVED                     @Y17XAXU
OLTQCBA  DS    A                  QCB ADDRESS                    S22024
OLTCCWA  DS    A                  ADDRESS OF READ CCW CHAIN      S22024
OLTBUFA  DS    A                  ADDRESS OF BUFFER CONTAINING   S22024
*                                 READ DATA                      S22024
*
*        DATA BLOCKING FIELD
*
OLTDTBUF DS    A .                RESPONSE BUFFER ADDRESS
OLTDTCNT DS    H .                RESPONSE BUFFER SIZE
OLTFLAG2 DS    BL1 .              DATA BLOCKING SIZE
*
OLTPTIMD EQU   X'80' .            POST WAITIO IMMEDIATELY
OLTMVDAT EQU   X'40' .            MOVE RESPONSE TO BUFFER
OLTLV3IO EQU   X'20' .            LAST EXIO TO DEV WAS LEVEL 3
OLTSIOAC EQU   X'10' .            EXIO TO DEVICE IS OUTSTANDING
*
         DS    CL1                RESERVED                     @ZM47554
OLTSN    DS    0F                 DEVICE SEQ NUMBER FIELD      @ZM47554
         DS    CL2                FLAGS                        @ZM47554
OLTSEQ   DS    H                  SEQUENCE NUMBER (FROM SNA TH)@ZM47554
*
*        TEST EVENT CONTROL BLOCK ADDRESS
*
TECBADDR DS    F .                ADDRESS OF TECB
*
*        I/O BLOCK
*
IOB      DS    0F
*
IOBFLG1  DS    CL1                FIRST FLAG BYTE
IOBFLG2  DS    CL1                SECOND FLAG BYTE
IOBSNS   DS    CL2                FIRST TWO SENSE BYTES
IOBECBAD DS    0F                 ECB ADDRESS
IOBECBCD DS    CL1                ECB CODE
         DS    CL3
IOBCSW   DS    0F                 CHANNEL STATUS WORD
IOBFLG3  DS    CL1                THIRD FLAG BYTE
IOBCSW1  DS    CL7                LAST 7 BYTES OF LAST CSW.
IOBCCWAD DS    0F                 CCW ADDRESS
IOBSIOCD DS    CL1                START I/O CODE
         DS    CL3
IOBDCBAD DS    F                  DCB ADDRESS
IOBREPM  DS    CL1                REPOSITION MODIFIER
IOBRSTAD DS    CL3                RESTART ADDRESS
IOBINCR  DS    CL2                BLOCK COUNT INCREMENT
IOBERRCT DS    CL2                ERROR COUNTS
IOBUCBX  DS    CL1                UCB INDEX                      S99528
IOBWORK  DS    CL3                WORK AREA                      S99528
IOBFLG4  DS    CL1                FLAGS FOR TOTE & ITS APPENDAGE S99528
IOBATTN  EQU   X'80'              ATTENTION INTERRUPT EXPECTED   S99528
IOBCSWV  EQU   X'40'              CSW SAVE AREA VALID            S99528
IOBSEC   EQU   X'20'              SECONDARY IOB                  S99528
IOBPRI   EQU   X'10'              PRIMARY IOB                    S99528
IOBATNE  EQU   X'08'              ERROR ON CE/DE BEFORE ATTN     S99528
IOBCSWNV EQU   X'04'              CSW AREA TWO INVALID           S99528
IOBCSWS  DS    CL7                CSW SAVE AREA
*
*        DATA EXTENT BLOCK ADDRESS
*
         ORG   IOB+44
*
*        DATA CONTROL BLOCK
*
DCB      EQU   *
*
DCBDCDEP DS    5F                 DEVICE DEPENDENT FIELD
DCBBUFNO DS    C                  NUMBER OF BUFFERS IN DATA SET
DCBBUFCB DS    CL3                BUFFER POOL CONTROL BLOCK ADDRESS
DCBBUFL  DS    H                  BUFFER LENGTH
DCBDSORG DS    H                  DATA SET ORGANIZATION
DCBIOBAD DS    F                  I/O BLOCK ADDRESS
DCBBGFEK DS    C                  BUFFER TECNIQUE, BUFFER ALIGNMENT
DCBEODAD DS    CL3                END OF DATA SET ROUTINE
DCBRECFM DS    C                  RECORD FORMAT
DCBEXLST DS    CL3                EXIT LIST
DCBTIOT  DS    H
DCBMACRF DS    H                  MACRO INSTRUCTION REFERENCE
DCBIFLGS DS    C                  I/O SUPERVISOR FLAGS
DCBDEBAD DS    CL3                DATA EXTENT BLOCK ADDRESS
OLTDEBA  EQU   DCB+44             DEB ADDRESS
DCBOFLGS DS    C                  OPEN FLAGS
         DS    CL3                RESERVED
DCBOPTCD DS    CL1                OPTION CODES
         DS    CL7                RESERVED
DCBEOEA  DS    H                  END OF EXTENT APPENDAGE
DCBPCIA  DS    H                  PROGRAM CONTROLLED INTERRUPT APPENDAG
DCBSIOA  DS    H                  START I/O APPENDAGE
DCBCENDA DS    H                  CHANNEL END APPENDAGE
DCBXENDA DS    H                  ABNORMAL END APPENDAGE
         DS    H                  RESERVED
         MEND                                                @Y17XAXU*/
*%PLSIOBK: ;
*DECLARE
*  1 IOBLOCKS BDY(WORD) BASED,    /*                         @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*/*      I/O CONTROL BLOCKS  (ECB,TECB ADDRESS,IOB,DCB)      @Y17XAXU*/
*/*                 VERSION 10.0 (TCAM,TOTE)                 @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*/*      EVENT CONTROL BLOCK                                 @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*   2 ECBOLT PTR(31),             /* EVENT CONTROL BLOCK     @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*/*      UNIT CONTROL BLOCK ADDRESS                          @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*   2 OLTUCBA FIXED(16),          /* UCB ADDRESS             @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*   2 OLTTCOFF FIXED(16),         /* C. TNT ENTRY OFFSET     @Y17XAXU*/
*   2 OLTTNOFF FIXED(16),         /* REAL TNT OFFSET         @Y17XAXU*/
*   2 OLTTRSID FIXED(16),         /* NETWORK ADDRESS         @Y17XAXU*/
*   2 OLTTCRLN CHAR(1),           /* RLN                     @Y17XAXU*/
*   2 OLTLCBA PTR(24),            /* LCB ADDRESS OF 3705     @Y17XAXU*/
*   2 OLTTCTNT PTR(31),           /* C. TNT ENTRY ADDRESS    @Y17XAXU*/
*   2 OLTRLTNT PTR(31),           /* REAL TNT ENTRY ADDRESS  @Y17XAXU*/
*   2 OLTTDLN FIXED(15),          /* LENGTH OF TD TTE AREA   @Y17XAXU*/
*   2 OLTFLAG1 BIT(8),            /* TEST DEVICE FLAG BYTE 1 @Y17XAXU*/
*    3 OLTTNTAS BIT(1),           /* TD TNT ENTRY ASSIGNED   @Y17XAXU*/
*    3 * BIT(1),                  /* RESERVED                @Y17XAXU*/
*    3 OLTPRSC BIT(1),            /* ON=PRI TD,OFF=SEC TD    @Y17XAXU*/
*    3 OLTUNRD BIT(1),            /* ON=UNREAD DATA          @Y17XAUU*/
*                                 /* OFF=NO UNREAD DATA      @Y17XAUU*/
*    3 OLTEX BIT(1),              /* EXCEPTION RESPONSE      @Y17XAXU*/
*    3 OLTFME BIT(1),             /* DEFINITE RESPONSE       @Y17XAXU*/
*    3 OLTEN BIT(1),              /* ON=EXPEDITED            @Y17XAXU*/
*                                 /* OFF=NORMAL              @Y17XAXU*/
*    3 * BIT(1),                  /* UNUSED                  @Y17XAXU*/
*   2 * CHAR(1),                  /* RESERVED                @Y17XAXU*/
*   2 OLTQCBA PTR(31),            /* QCB ADDRESS             @Y17XAXU*/
*   2 OLTCCWA PTR(31),            /* READ CCW CHAIN ADDRESS  @Y17XAXU*/
*   2 OLTBUFA PTR(31),            /* ADDRESS OF BUFFER       @Y17XAXU*/
*                                 /* CONTAINING READ DATA    @Y17XAXU*/
*   2 OLTDTBUF PTR(31),           /* RESPONSE BUFFER ADDRESS @Y17XAXU*/
*   2 OLTDTCNT FIXED(15),         /* RESPONSE BUFFER SIZE    @Y17XAXU*/
*   2 OLTFLAG2 BIT(8),            /* TEST DEVICE FLAG BYTE 2 @Y17XAXU*/
*    3 OLTPTIMD BIT(1),           /* POST WAITI/0 IMMEDIATELY@Y17XAXU*/
*    3 OLTMVDAT BIT(1),           /* MOVE RESPONSE TO BUFFER @Y17XAXU*/
*    3 OLTLV3IO BIT(1),           /* LAST EXIO WAS LEVEL 3   @Y17XAXU*/
*    3 OLTSIOAC BIT(1),           /* EXIO TO DEVICE IS       @Y17XAXU*/
*                                 /* OUTSTANDING             @Y17XAXU*/
*    3 * BIT(4),                  /* RESERVED                @Y17XAXU*/
*   2 * CHAR(1),                  /* RESERVED                @Y17XAXU*/
*   2 OLTSN CHAR(4) BDY(WORD),    /* DEVICE SEQ NUMBER FIELD @ZM47554*/
*     3 * CHAR(2),                /* FLAGS                   @ZM47554*/
*     3 OLTSEQ FIXED(16),         /* SEQUENCE NUMBER (FROM SNA TH    */
*                                   /*                       @ZM47554*/
*   2 TECBADDR PTR(31),           /* TECB ADDRESS            @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*/*      I/O BLOCK                                           @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*   2 IOB BDY(WORD),              /* IOB CONTROL BLOCK       @Y17XAXU*/
*    3 IOBFLG1 CHAR(1),           /* FIRST FLAG BYTE         @Y17XAXU*/
*    3 IOBFLG2 CHAR(1),           /* SECOND FLAG BYTE        @Y17XAXU*/
*    3 IOBSNS CHAR(2),            /* FIRST TWO SENSE BYTE    @Y17XAXU*/
*    3 IOBECBAD BDY(WORD),        /* ECB ADDRESS             @Y17XAXU*/
*     4 IOBECBCD CHAR(1),         /* ECB CODE                @Y17XAXU*/
*     4 * CHAR(3),                /* RESERVED                @Y17XAXU*/
*    3 IOBCSW BDY(WORD),          /* CHANNEL STATUS WORD     @Y17XAXU*/
*     4 IOBFLG3 CHAR(1),          /* THIRD FLAG BYTE         @Y17XAXU*/
*     4 IOBCSW1 CHAR(7),          /* LAST 7 BYTES OF LAST CSW@Y17XAXU*/
*    3 IOBCCWAD BDY(WORD),        /* CHANNEL COMMAND WORD    @Y17XAXU*/
*     4 IOBSIOCD CHAR(1),         /* START I/O CODE          @Y17XAXU*/
*     4 * CHAR(3),                /* LAST 3 BYTES OF CCW     @Y17XAXU*/
*    3 IOBDCBAD PTR(31),          /* DCB ADDRESS             @Y17XAXU*/
*    3 IOBREPM CHAR(1),           /* REPOSITION MODIFIER     @Y17XAXU*/
*    3 IOBRSTAD CHAR(3),          /* RESTART ADDRESS         @Y17XAXU*/
*    3 IOBINCR CHAR(2),           /* BLOCK COUNT INCREMENT   @Y17XAXU*/
*    3 IOBERRCT CHAR(2),          /* ERROR COUNT             @Y17XAXU*/
*    3 IOBUCBX CHAR(1),           /* UCB INDEX               @Y17XAXU*/
*    3 IOBWORK CHAR(3),           /* WORK AREA               @Y17XAXU*/
*    3 IOBFLG4 BIT(8),            /* FLAGS FOR TOTE AND ITS  @Y17XAXU*/
*                                 /* APPENDAGE               @Y17XAXU*/
*     4 IOBATTN BIT(1),           /* ATTENTION INTERRUPT     @Y17XAXU*/
*                                 /* EXPECTED                @Y17XAXU*/
*     4 IOBCSWV BIT(1),           /* CSW SAVE AREA VALID     @Y17XAXU*/
*     4 IOBSEC BIT(1),            /* SECONDARY IOB           @Y17XAXU*/
*     4 IOBPRI BIT(1),            /* PRIMARY IOB             @Y17XAXU*/
*     4 IOBATNE BIT(1),           /* ERROR ON CE/DE BEFORE   @Y17XAXU*/
*                                 /* ATTENTION               @Y17XAXU*/
*     4 IOBCSWNV BIT(1),          /* CSW AREA TWO INVALID    @Y17XAXU*/
*     4 * BIT(2),                 /* RESERVED                @Y17XAXU*/
*    3 IOBCSWS CHAR(7),           /* CSW SAVE AREA           @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*/*      DATA EXTENT BLOCK                                   @Y17XAXU*/
*/*                                                          @Y17XAXU*/
*   2 DCB BDY(WORD),              /* DATA CONTROL BLOCK      @Y17XAXU*/
*    3 DCBDCDEP(5) PTR(31),       /* DEVICE DEPENDENT FIELD  @Y17XAXU*/
*    3 DCBBUFNO CHAR(1),          /* NUMBER OF BUFFERS IN    @Y17XAXU*/
*                                 /* DATA SET                @Y17XAXU*/
*    3 DCBBUFCB CHAR(3),          /* BUFFER POOL CONTROL BLOCK       */
*                                 /* ADDRESS                 @Y17XAXU*/
*    3 DCBBUFL FIXED(15),         /* BUFFER LENGTH           @Y17XAXU*/
*    3 DCBDSORG CHAR(2),          /* DATA SET ORGANIZATION   @Y17XAXU*/
*    3 DCBIOBAD PTR(31),          /* I/O BLOCK ADDRESS       @Y17XAXU*/
*    3 DCBBGFEK CHAR(1),          /* BUFFER TECHNIQUE        @Y17XAXU*/
*                                 /* BUFFER ALLIGNMENT       @Y17XAXU*/
*    3 DCBEODAD PTR(24),          /* END OF DATASET ROUTINE  @Y17XAXU*/
*                                 /* ADDRESS                 @Y17XAXU*/
*    3 DCBRECFM CHAR(1),          /* RECORD FORMAT           @Y17XAXU*/
*    3 DCBEXLST PTR(24),          /* EXIT LIST               @Y17XAXU*/
*    3 DCBTIOT FIXED(15),         /* OFFSET FROM TIOT ORIGIN @Y17XAXU*/
*                                 /* TO TIOELNGH FIELD IN    @Y17XAXU*/
*                                 /* TIOT ENTRY FOR DD       @Y17XAXU*/
*                                 /* STATEMENT ASSOCIATED    @Y17XAXU*/
*                                 /* WITH THIS DCB           @Y17XAXU*/
*    3 DCBMACFR CHAR(2),          /* MACRO INSTRUCTION REF   @Y17XAXU*/
*    3 OLTDEBA PTR(31),           /* ADDRESS OF ASSOCIATED   @Y17XAXU*/
*                                 /* DEB                     @Y17XAXU*/
*     4 DCBIFLGS CHAR(1),         /* I/O SUPERVISOR FLAGS    @Y17XAXU*/
*     4 DCBDEBAD PTR(24) BDY(BYTE), /* ADDRESS OF ASSOCIATED @Y17XAXU*/
*                                 /* DEB                     @Y17XAXU*/
*    3 DCBOFLGS CHAR(1),          /* OPEN FLAGS              @Y17XAXU*/
*    3 * CHAR(3),                 /* RESERVED                @Y17XAXU*/
*    3 DCBOPTCD CHAR(1),          /* OPTION CODE             @Y17XAXU*/
*    3 * CHAR(7),                 /* RESERVED                @Y17XAXU*/
*    3 DCBEOEA FIXED(15),         /* END OF EXTENT APPENDAGE @Y17XAXU*/
*    3 DCBPCIA FIXED(15),         /* PCI APPENDAGE           @Y17XAXU*/
*    3 DCBSIOA FIXED(15),         /* SIO I/O APPENDAGE       @Y17XAXU*/
*    3 DCBCENDA FIXED(15),        /* CHANNEL END APPENDAGE   @Y17XAXU*/
*    3 DCBXENDA FIXED(15),        /* ABNORMAL END APPENDAGE  @Y17XAXU*/
*    3 * CHAR(2);                 /* RESERVED                @Y17XAXU*/
*                                 /*                         @Y17XAXU*/
*%IOBKEND: ;                      /* END OF IOBLOCKS         @Y17XAXU*/
