*        %GOTO CCTPLS1;            /*
         MACRO
         IRACCT &DSECT=YES
*                                                                    */
*%CCTPLS1 : ;
*/*                                                                  */
*/* MACCOMP Z-4 SC1CX/PKD16                                          */
*/* MACSTAT Z-4 75007/Z40BPSS                                        */
*/********************************************************************/
*/*                                                                  */
*/*      MACRO NAME - IRACCT                                         */
*/*                                                                  */
*/*      DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CPU             */
*/*                         MANAGEMENT CONTROL TABLE                 */
*/*                                                                  */
*/*      STATUS - OS/VS2 RELEASE 2, 02/15/74,LEVEL=7                 */
*/*                                                                  */
*/*      METHOD OF ACCESS                                            */
*/*        BAL - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.     */
*/*              USING ON CCT GIVES ADDRESSIBILITY FOR ALL SYMBOLS.  */
*/*        PLS - TO ACCESS AS STAND ALONE STRUCTURE DCL CCTPTR PTR.  */
*/*              TO CONCATENATE WITH PREVIOUSLY DEFINED STRUCTURE    */
*/*                SET %CCTLEVEL TO DESIRED STRUCTURE LEVEL.         */
*/*              TO PREVENT STRUCTURE FROM BEING CLOSED,             */
*/*                SET %CCT9999=','.                                 */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*        %GOTO CCTPLS2;            /*
         AIF   ('&DSECT' EQ 'YES').CCT001
CCT      DS    0D -                CPU MANAGEMENT CONTROL TABLE
         AGO   .CCT002
.CCT001  ANOP
CCT      DSECT , -                 CPU MANAGEMENT CONTROL TABLE
.CCT002  ANOP
CCTCCT   DC    CL4'CCT' -          ACRONYM IN EBCDIC -CCT-
*
*        CPU CONTROL CONSTANTS
*
* TIME INTERVAL CONSTANTS - 1000 UNITS = APPROXIMATELY 1 SECOND
CCCAPMET DC    F'200' -            MINIMUM USER EXECUTION INTERVAL FOR
*                                  MEAN TIME TO WAIT COMPUTATION
CCCAPMIN DC    F'1000' -           MINIMUM APG INVOCATION INTERVAL
CCCAPMAX DC    F'0003000' -        MAXIMUM APG INVOCATION INTERVAL
CCCAPDEL DC    F'1000' -           DELTA FOR CHANGING APG INTERVAL
CCCMNUIN DC    F'30000' -           TIME USER MUST BE IN MAIN STORAGE
*                                   BEFORE SWAP OUT CPU REC IS GIVEN
CCCMNSIN DC    F'5000' -           MINIMUM INTERVAL FOR COMPUTING
*                                  SYSTEM CPU UTILIZATION
CCCRSVF1 DC    F'0' -              RESERVED
* APG DISPATCHING PRIORITY COMPUTATION CONSTANTS
CCCAPDIV DC    H'4' -              DP COMPUTATION DIVISOR      @Z40BPEB
CCCAPROT DC    H'11' -             VALUE OF APG ROTATE GROUP   @Z40BPEB
CCCAPBDP DC    H'15' -             BASE DP FROM WHICH QUOTIENT IS
*                                  SUBTRACTED
CCCAPLDP DC    H'1' -              DP FOR UNDISPATCHED APG USERS
CCCAPMDP DC    H'0' -              DP FOR MAX MEAN TIME TO WAIT
CCCAPGDP DC    H'06' -             APG INITIAL DP              @Z40BPCH
CCCR01    DC    H'0' -             RESERVED                  @ZM43085
* APG THRESHOLDS EXPRESSED AS % OF APG USERS CHAPPED AT APG CALL
CCCAPRLT DC    H'20' -             LOW THRESHOLD - LENGTHEN APG
*                                  INVOCATION INTERVAL
CCCAPRHT DC    H'60' -             HIGH THRESHOLD - SHORTEN INTERVAL
* CPU LOAD BALANCING RECOMMENDATION VALUE COMPUTATION CONSTANTS
CCCUTHIT DC    H'100' -            HIGH UTILIZATION IMBALANCE
*                                  THRESHOLD
CCCUTLOT DC    H'80' -             LOW UTILIZATION IMBALANCE
*                                  THRESHOLD
CCCHISCF DC    H'6400' -           HIGH THRESHOLD SCALING FACTOR
CCCLOSCF DC    H'1' -              LOW THRESHOLD SCALING FACTOR
CCCMAXRV DC    H'128' -            MAXIMUM CPL REC VALUE
CCCMINRV DC    H'-128' -           MINIMUM CPL REC VALUE
CCCSCFAC DC    H'64' -             REC VALUE SCALING DIVISOR
CCCSIGDP DC    H'02' -             SIGNIFICANT CPU USER D PRIORITY
CCCSIGUR DC    H'26' -             SIGNIFICANT MEAN TIME TO WAIT IN MS
CCCR02   DC    H'0' -              RESERVED                   @ZM43085
CCCSCFC1 DC    H'10' -             SYSTEM WAIT % AVERAGING FACTOR
CCCSCFC2 DC    H'11' -             CCCSCFC1+1
CCCRSVH1 DC    H'0' -              RESERVED
CCCEND   DS    0F -                END OF CCT CONSTANTS
*
*        CPU CONTROL VARIABLES
*
CCVR03  DC    F'0' -               RESERVED                   @ZM43085
CCVRBSWT DC    F'0' -              RECENT BASE SYSTEM WAIT TIME
CCVR04   DC    F'0' -              RESERVED                  @ZM43085
CCVRBSTD DC    F'0' -              RECENT BASE TIME OF DAY
CCVRVSWF DC    F'0' -              SYSTEM WAIT FACTOR FOR CPL
*                                  RECOMMENDATION VALUE COMPUTATION
CCVPGCPF DC    F'0' -              PAGE CP SERVICE FACTOR FOR CPL
*                                  RECOMMENDATION VALUE COMPUTATION
CCVEJST  DC    F'0' -              LOW PRIORITY USER JOB STEP TIME
CCVIMBBT DC    F'0' -               TIME OF LAST CPU IMBALANCE
CCVR05   DC    H'0' -              RESERVED                   @ZM43085
CCVUTILP DC    H'50' -             SYSTEM CPU UTILIZATION
CCVR06   DC    H'0' -              RESERVED                  @ZM43085
CCVR07   DC   H'0' -               RESERVED                   @ZM43085
CCVLGUTL DC    AL2(50*256) -       LONG TERM UTILIZATION * 256
CCVLGFMC DC    H'10' -             AVERAGE AVAILABLE FRAME COUNT
CCVENQCT DC    H'0' -              NO. OF USERS NON SWAPPABLE FOR
*                                  ENQ REASONS
CCVCPUCT DC    H'0' -              NUMBER OF ONLINE CPUS
*
*        CPU CONTROL FLAGS
*
CCTFLG1  DC    B'0' -
CCTALL   EQU   BIT0 -              LOW PRIORITY USER NOT DISPATCHED
CCTCPUOT EQU   BIT1 -              CPU OUT OF BALANCE
CCTFLG2  DC    3B'0' -             RESERVED
CCVEND   DS    0D -                END OF CCT
CCTLEN   EQU   CCVEND-CCT -        LENGTH OF CCT
         MEND  , -                                                   */
*%CCTPLS2 : ;
*    %IF CCT9999^=','              /* IF THIS IS LAST BLOCK          */
*      %THEN CCT9999=';';          /* THEN CLOSE DECLARE STATEMENT   */
*    %IF CCTLEVEL^=''              /* IF MINOR LEVEL IS SPECIFIED,   */
*      %THEN %GOTO CCTPLS3;        /* SKIP MAJOR DECLARE             */
*DECLARE                           /*                                */
*  1 CCT BASED(CCTPTR)             /*     CPU CONTROL TABLE          */
*    %GOTO CCTPLS4;                /* MAJOR STRUCTURE                */
*%CCTPLS3: CCTDUM=CCTLEVEL||' CCT'; /* CONCATENATE AS MINOR STRUCTURE*/
*  CCTDUM                          /*     CPU CONTROL TABLE          */
*%CCTPLS4:;
*          BDY(DWORD),
*       5 CCTCCT CHAR(4),          /* ACRONYM IN EBCDIC -CCT-        */
*/*                                                                  */
*/*      CPU CONTROL CONSTANTS                                       */
*/*                                                                  */
*/* TIME INTERVAL CONSTANTS                                          */
*       5 CCCAPMET FIXED(31),      /* MINIMUM USER EXECUTION INTERVAL
*                                   FOR MEAN TIME TO WAIT COMPUTATION*/
*       5 CCCAPMIN FIXED(31),      /* MINIMUM APG INVOCATION INTERVAL*/
*       5 CCCAPMAX FIXED(31),      /* MAXIMUM APG INVOCATION INTERVAL*/
*       5 CCCAPDEL FIXED(31),      /* DELTA FOR CHANGING APG INTERVAL*/
*       5 CCCMNUIN FIXED(31),       /* TIME USER MUST REMAIN IN STORAGE
*                                      BEFORE CPU RECOMMENDATION FOR
*                                      SWAP OUT IS GIVEN             */
*       5 CCCMNSIN FIXED(31),      /* MINIMUM INTERVAL FOR COMPUTING
*                                     SYSTEM CPU UTILIZATION         */
*       5 CCCRSVF1 FIXED(31),      /* RESERVED                       */
*/* APG DISPATCHING PRIORITY (DP) COMPUTATION CONSTANTS              */
*       5 CCCAPDIV FIXED(15),      /* DP COMPUTATION DIVISOR  @Z40BPEB*/
*       5 CCCAPROT FIXED(15),      /* APG ROTATE VALUE        @Z40BPEB*/
*       5 CCCAPBDP FIXED(15),      /* BASE DP FROM WHICH QUOTIENT IS
*                                     SUBTRACTED                     */
*       5 CCCAPLDP FIXED(15),      /* DP FOR UNDISPATCHED APG USERS  */
*       5 CCCAPMDP FIXED(15),      /* DP FOR MAX MEAN TIME TO WAIT   */
*       5 CCCAPGDP FIXED(15),      /* APG INITIAL DP                 */
*       5 CCCR01 FIXED(15),        /* RESERVED               @ZM43085*/
*/* APG THRESHOLDS EXPRESSED AS % OF APG USERS CHAPPED AT APG CALL   */
*       5 CCCAPRLT FIXED(15),      /* LOW THRESHOLD - LENGTHEN APG
*                                     INVOCATION INTERVAL            */
*       5 CCCAPRHT FIXED(15),      /* HIGH THRESHOLD - SHORTEN INT   */
*
*/* CPU LOAD BALANCING RECOMMENDATION VALUE COMPUTATION CONSTANTS    */
*       5 CCCUTHIT FIXED(15),      /* HIGH UTILIZATION IMBALANCE
*                                     THRESHOLD                      */
*       5 CCCUTLOT FIXED(15),      /* LOW UTILIZATION IMBALANCE
*                                     THRESHOLD                      */
*       5 CCCHISCF FIXED(15),      /* HIGH THRESHOLD SCALING FACTOR  */
*       5 CCCLOSCF FIXED(15),      /* LOW THRESHOLD SCALING FACTOR   */
*       5 CCCMAXRV FIXED(15),      /* MAXIMUM CPL REC VALUE          */
*       5 CCCMINRV FIXED(15),      /* MINIMUM CPL REC VALUE          */
*       5 CCCSCFAC FIXED(15),      /* REC VALUE SCALING FACTOR       */
*       5 CCCSIGDP FIXED(15),      /* SIGNIFICANT CPU USER D PRIORITY*/
*       5 CCCSIGUR FIXED(15),      /* SIGNIFICANT MEAN TIME TO WAIT  */
*      5 CCCR02 FIXED(15),         /* RESERVED                @ZM43085*/
*       5 CCCSCFC1 FIXED(15),      /* SYSTEM WAIT % AVERAGING FACTOR */
*       5 CCCSCFC2 FIXED(15),      /* CCCSCFC1+1                     */
*       5 CCCRSVH1 FIXED(15),      /* RESERVED                       */
*       5 CCCEND CHAR(0) BDY(WORD),/* END OF CCT CONSTANTS           */
*/*                                                                  */
*/*      CPU CONTROL VARIABLES                                       */
*/*                                                                  */
*      5 CCVR03 FIXED(32),         /* RESERVED               @ZM43085*/
*      5 CCVRBSWT FIXED(32),       /* RECENT BASE SYSTEM WIAT TIME   */
*      5 CCVR04 FIXED(32),          /* RESERVED             @ZM43085*/
*      5 CCVRBSTD FIXED(32),       /* RECENT BASE TIME OF DAY        */
*      5 CCVRVSWF FIXED(31),        /* SYSTEM WAIT FACTOR FOR CPL
*                                      REC VALUE COMPUTATION         */
*      5 CCVPGCPF FIXED(31),       /* PAGE CP SERVICE FACTOR FOR CPL
*                                     RECOMMENDATION VALUE
*                                     COMPUTATION                    */
*      5 CCVEJST BIT(32),          /* LOW PRIORITY USER JOB STEP TIME*/
*      5 CCVIMBBT FIXED(31),        /* TIME OF LAST CPU IMBALANCE    */
*      5 CCVR05 FIXED(15),         /* RESERVED              @ZM43085*/
*      5 CCVUTILP FIXED(15),       /* SYSTEM CPU UTILIZATION         */
*      5 CCVR06 FIXED(15),         /* RESERVED              @ZM43085*/
*      5 CCVR07 FIXED(15),          /* RESERVED             @ZM43085*/
*      5 CCVLGUTL FIXED(15),       /* LONG TERM CPU UTILIZATION * 256*/
*      5 CCVLGFMC FIXED(15),        /* AVERAGE AVAILABLE FRAME COUNT */
*      5 CCVENQCT FIXED(15),        /* NO. OF USERS NON-SWAPPABLE FOR
*                                      ENQ REASONS                   */
*      5 CCVCPUCT FIXED(15),        /* NUMBER OF ONLINE CPUS         */
*/*                                                                  */
*/*                                                                  */
*/*      CPU CONTROL FLAGS                                           */
*      5 CCTFLG1 BIT(8),           /*                                */
*        10 CCTALL BIT(1),         /* LOW PRTY USER NOT DISPATCHED   */
*        10 CCTCPUOT BIT(1),       /* CPU OUT OF BALANCE             */
*      5 CCTFLG2 BIT(24),          /* RESERVED                       */
*      5 CCVEND CHAR(0)            /* END OF CCT                     */
*          BDY(DWORD) CCT9999
*%CCTLEN='LENGTH(CCT)';            /* OBTAIN LENGTH OF CCT           */
*      @EJECT;
