*        %GOTO DMDTPLS1; /*
         MACRO
         IRADMDT  &DSECT=YES                                        */
*%DMDTPLS1:  ;
*/* MACCOMP Z-4 SC1CX/PKD16                                          */
*/* MACSTAT Z-4 75007/Z40BPSS                                        */
*/********************************************************************/
*/* MACRO NAME - IRADMDT                                             */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DOMAIN TABLE DESCRIPTION                      */
*/*                                                                  */
*/* COPYRIGHT - NONE                                                 */
*/*                                                                  */
*/* STATUS - OS/VS2 RELEASE 4, 07/30/75                              */
*/*                                                                  */
*/* FUNCTION - THE DMDT SPECIFIES THE DOMAINS INTO WHICH             */
*/*            USER TRANSACTIONS ARE DIVIDED, AND FOR EACH           */
*/*            DOMAIN, THE CONSTRAINTS ON ITS PARTICIPATION          */
*/*            IN THE CHANGING OF THE MULTI-PROGRAMMING              */
*/*            LEVEL AND CURRENT DOMAIN CONTROL STATUS.              */
*/*                                                                  */
*/*            THE DOMAIN TO BE USED FOR A TRANSACTION IS            */
*/*            INDICATED BY THE -WPGPDMN- FIELD OF THE               */
*/*            CURRENT PERIOD WITHIN THE APPLICABLE PERFORMANCE      */
*/*            GROUP DESCRIPTION.                                    */
*/*                                                                  */
*/* METHOD-OF-ACCESS - THE ADDRESS OF THE DOMAIN TABLE ENTRY FOR A   */
*/*                    PARTICULAR SYSTEM USER IS OBTAINED BY ADDING  */
*/*                    THE OFFSET IN THE -OUCBDMO- FIELD OF THE      */
*/*                    SYSTEM RESOURCES MANAGER USER CONTROL BLOCK   */
*/*                    TO THE ADDRESS IN THE -WMSTDMDT- FIELD OF THE */
*/*                    WORKLOAD MANAGER SPECIFICATION TABLE.         */
*/********************************************************************/
*        %GOTO DMDTPLS2; /*
         AGO   .DMDTAL1                                              */
*/********************************************************************/
*/*                                                                  */
*/* INVOCATION PARAMETERS AND/OR KEYWORDS =                          */
*/*                                                                  */
*/*   BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.                 */
*/*                                                                  */
*/*     USING ON DMDT GIVES ADDRESSABILITY TO ALL SYMBOLS            */
*/*                                                                  */
*/*   PLS - %DMDTLEVL='USERLEVL' IF THE DMDT MAPPING IS TO BE        */
*/*         CONCATENATED WITH A PREVIOUS DECLARATION,WITH THE        */
*/*         DMDT BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.       */
*/*       - %DMDT9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED      */
*/*                                                                  */
*/*         TO ACCESS AS A STANDALONE STRUCTURE DCL DMDTPTR PTR.     */
*/*                                                                  */
*/*  CHANGE ACTIVITY =@Z40BFEM                                       */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
.DMDTAL1 ANOP
         SPACE 1
         AIF  ('&DSECT' EQ 'NO').DMDTAL2
DMDT     DSECT
         AGO  .DMDTAL3
.DMDTAL2 ANOP
         DS   0F
DMDT     EQU  *
.DMDTAL3 ANOP
         SPACE 1
DMDTNO   DS   AL1                  DOMAIN NUMBER
DMDTLO   DS   AL1                  MIN MPL LEVEL
DMDTHI   DS   AL1                  MAX MPL LEVEL
DMDTWT   DS   AL1                  WEIGHTING FACTOR
DMDTMPLT DS   H                    CURRENT MPL TARGET
DMDTRUA  DS   H                    AVE # OF READY USERS
DMDTGOOU DS   H                    CURRENT # OF USERS GOING OUT
DMDTCMPL DS   H                    CURRENT MPL
DMDTOUTU DS   H                    CURRENT # USERS ON OUT Q
DMDTINCU DS   H                    CURRENT # SWAPPABLE INCORE USERS
DMDTRUC  DS   F                    ACCUMULATOR FOR READY USER COUNT
DMDTEND  DS   0F                   END OF DMDT
DMDTLEN  EQU  DMDTEND-DMDT         LENGTH OF DMDT
         MEND
*                                                                    */
*%DMDTPLS2:  ;
*        %IF DMDT9999 ^= ','       /* DOES STRUCTURE CONTINUE        */
*            %THEN %DMDT9999 = ';';/* NO, END DECLARE STATEMENT      */
*        %IF DMDTLEVL ^= ''        /* IS STRUCTURE CONCATENATED      */
*            %THEN %GOTO DMDTPLS3; /* YES, OMIT DECLARE STATEMENT    */
*   DCL
*     1 DMDT BASED(DMDTPTR) BDY(WORD),
*        %GOTO DMDTPLS4;           /* SKIP USER GIVEN LEVEL          */
*%DMDTPLS3:  DMDTDUM = DMDTLEVL||' DMDT';  /* PICK UP GIVEN LEVEL    */
*     DMDTDUM BDY(WORD),
*%DMDTPLS4:   ;
*        10 DMDTNO FIXED(8),       /* DOMAIN NUMBER                  */
*        10 DMDTLO FIXED(8),       /* MIN MPL LEVEL                  */
*        10 DMDTHI FIXED(8),       /* MAX MPL LEVEL                  */
*        10 DMDTWT FIXED(8),       /* WEIGHTING FACTOR               */
*        10 DMDTMPLT FIXED(15),    /* CURRENT MPL TARGET             */
*        10 DMDTRUA FIXED(15),     /* AVE # OF READY USERS           */
*        10 DMDTGOOU FIXED(15),    /* CURRENT # OF USERS GOING OUT   */
*        10 DMDTCMPL FIXED(15),    /* CURRENT MPL                    */
*        10 DMDTOUTU FIXED(15),    /* CURRENT # USERS ON OUT Q       */
*        10 DMDTINCU FIXED(15),    /* CURRENT # SWAPPABLE INCORE     */
*/*                                   USERS                          */
*        10 DMDTRUC FIXED(31),     /* ACCUMULATOR FOR READY USER     */
*/*                                   AVERAGE                        */
*        10 DMDTEND CHAR(0) BDY(WORD)  /* END OF DMDT                */
*     DMDT9999
*     %DMDTLEN = 'LENGTH(DMDT)';   /* SYMBOLIC FOR DMDT LENGTH       */
