*%/*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRAEPNMP                                         */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER ENTRY POINT       */
* /*                      NAME MAPPING MACRO                         */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 07/30/75, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE IRAEPNMP MACRO DEFINES, IN MACHINE-READABLE    */
* /*         FORM, THE CHARACTERISTICS OF EACH INVOCABLE ROUTINE     */
* /*         WITHIN THE SYSTEM RESOURCES MANAGER COMPONENT.          */
* /*                                                                 */
* /*   NOTES - THE IRAEPNMP MACRO PROVIDES THE INFORMATION NEEDED    */
* /*         TO CONSTRUCT CALLING SEQUENCES, ENTRY CODE, AND EXIT    */
* /*         CODE FOR EACH INDIVIDUAL SYSTEM RESOURCES MANAGER       */
* /*         ROUTINE.  THUS, ANY ROUTINES ADDED TO THE SYSTEM        */
* /*         RESOURCES MANAGER COMPONENT SHOULD HAVE THEIR           */
* /*         CHARACTERISTICS ENTERED INTO THE IRAEPNMP MACRO.        */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS - SEE ASSEM/PLS MACRO   */
* /*         HEADER STATEMENTS AND ADJACENT GLOBAL DECLARATIONS.     */
* /*                                                                 */
* /*   CHANGE ACTIVITY =                                             */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
* /*
         MACRO
         IRAEPNMP  &EPN=,          ROUTINE (ENTRY POINT) IDENTIFIER    *
               &ERR=               ROUTINE RECOVRY POINT IDENTIFIER
         GBLC  &IRAEPAD            ROUTINE ENTRY POINT ADDRESS NAME
         GBLC  &IRAEPER            ROUTINE RECOVERY POINT ADDR NAME
         GBLC  &IRAEPFL            ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP02                                        @Z40BPCH
*                                                                    */
* /* *************************************************************** */
* /*                                                                 */
* /*   ROUTINES WHICH PERFORM ALGORITHMIC PROCESSING FOR THE SYSTEM  */
* /*   RESOURCES MANAGER.  THEY ARE INVOKED BY THE CNTRL ALGORITHM   */
* /*   ON THE BASIS OF REQUEST BITS IN THE RMCTALA-RMCTALR FLDS OF   */
* /*   THE SYSTEM RESOURCES MANAGER CONTROL TABLE.  THE IRAEPNMP     */
* /*   MACRO DEFINES THE BIT FLAG ASSOCIATED WITH EACH ROUTINE.      */
* /*                                                                 */
* /* *************************************************************** */
* /*
.EPNMP02 AIF   ('&EPN' NE 'IL1').EPNMP04
&IRAEPFL SETC  '40000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP04 AIF   ('&EPN' NE 'CL1').EPNMP06
&IRAEPFL SETC  '20000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP06 AIF   ('&EPN' NE 'SQA').EPNMP08
&IRAEPFL SETC  '10000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP08 AIF   ('&EPN' NE 'CAN').EPNMP10
&IRAEPFL SETC  '08000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP10 AIF   ('&EPN' NE 'A05').EPNMP12
&IRAEPFL SETC  '04000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP12 AIF   ('&EPN' NE 'AP1').EPNMP14
&IRAEPFL SETC  '02000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP14 AIF   ('&EPN' NE 'PR1').EPNMP16
&IRAEPFL SETC  '01000000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP16 AIF   ('&EPN' NE 'EQ1').EPNMP18
&IRAEPFL SETC  '00800000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP18 AIF   ('&EPN' NE 'A09').EPNMP20
&IRAEPFL SETC  '00400000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP20 AIF   ('&EPN' NE 'A10').EPNMP22
&IRAEPFL SETC  '00200000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP22 AIF   ('&EPN' NE 'ASM').EPNMP24
&IRAEPFL SETC  '00100000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP24 AIF   ('&EPN' NE 'MS6').EPNMP26
&IRAEPFL SETC  '00080000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP26 AIF   ('&EPN' NE 'PR5').EPNMP28
&IRAEPFL SETC  '00040000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP28 AIF   ('&EPN' NE 'A14').EPNMP32                       @Z40BPCH
&IRAEPFL SETC  '00020000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP32 AIF   ('&EPN' NE 'MS2').EPNMP34
&IRAEPFL SETC  '00008000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP34 AIF   ('&EPN' NE 'RM1').EPNMP36                       @Z40BPCH
&IRAEPFL SETC  '00004000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP36 AIF   ('&EPN' NE 'RM2').EPNMP38                       @Z40BPCH
&IRAEPFL SETC  '00002000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP38 AIF   ('&EPN' NE 'WM2').EPNMP40
&IRAEPFL SETC  '00001000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP40 AIF   ('&EPN' NE 'CAP').EPNMP42
&IRAEPFL SETC  '00000800'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP42 AIF   ('&EPN' NE 'A21').EPNMP44
&IRAEPFL SETC  '00000400'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP44 AIF   ('&EPN' NE 'A22').EPNMP50                       @Z40BPCH
&IRAEPFL SETC  '00000200'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
*                                                                    */
* /* *************************************************************** */
* /*                                                                 */
* /*   ROUTINES WHICH PERFORM ANALYSIS PROCESSING FOR THE SYSTEM     */
* /*   RESOURCES MANAGER.  THEY ARE INVOKED BY THE CTRL ALGORITHM    */
* /*   ON THE BASIS OF STATUS BITS IN THE RMCTALU FIELD OF THE       */
* /*   SYSTEM RESOURCES MANAGER CONTROL TABLE.  THE IRAEPNMP MACRO   */
* /*   DEFINES THE BIT FLAG ASSOCIATED WITH EACH ROUTINE.            */
* /*                                                                 */
* /* *************************************************************** */
* /*
.EPNMP50 AIF   ('&EPN' NE 'IL3').EPNMP52
&IRAEPFL SETC  '00004000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP52 AIF   ('&EPN' NE 'CL3').EPNMP54
&IRAEPFL SETC  '00002000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP54 AIF   ('&EPN' NE 'WM3').EPNMP64
&IRAEPFL SETC  '00001000'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
*                                                                    */
* /* *************************************************************** */
* /*                                                                 */
* /*   ROUTINES WHICH PERFORM USER-LEVEL DEFERRED ACTION PROCESSING  */
* /*   FOR THE SYSTEM RESOURCES MANAGER.  THEY ARE INVOKED BY THE    */
* /*   CNTRL ALGORITHM ON THE BASIS OF REQUEST BITS IN THE OUCBACN   */
* /*   FIELD OF THE SYSTEM RESOURCES MANAGER USER CONTROL BLOCK.     */
* /*   THE IRAEPNMP MACRO DEFINES THE BIT FLAG ASSOCIATED WITH       */
* /*   EACH ROUTINE.                                                 */
* /*                                                                 */
* /* *************************************************************** */
* /*
.EPNMP64 AIF   ('&EPN' NE 'DEL').EPNMP66
&IRAEPFL SETC  '80000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP66 AIF   ('&EPN' NE 'UXB').EPNMP68
&IRAEPFL SETC  '40000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP68 AIF   ('&EPN' NE 'IL4').EPNMP70
&IRAEPFL SETC  '20000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP70 AIF   ('&EPN' NE 'IPS').EPNMP72
&IRAEPFL SETC  '10000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP72 AIF   ('&EPN' NE 'D04').EPNMP74
&IRAEPFL SETC  '08000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP74 AIF   ('&EPN' NE 'D05').EPNMP76
&IRAEPFL SETC  '04000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP76 AIF   ('&EPN' NE 'D06').EPNMP78
&IRAEPFL SETC  '02000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
.EPNMP78 AIF   ('&EPN' NE 'HIT').EPNMP80
&IRAEPFL SETC  '01000001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP80 AIF   ('&EPN' NE 'RPS').EPNMP82
&IRAEPFL SETC  '00800001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP82 AIF   ('&EPN' NE 'WM5').EPNMP84
&IRAEPFL SETC  '00400001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP84 AIF   ('&EPN' NE 'D10').EPNMP88                       @Z40BPCH
&IRAEPFL SETC  '00200001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
*                                                                    */
* /* *************************************************************** */
* /*                                                                 */
* /*   ROUTINES WHICH PERFORM USER-LEVEL TIME-DEPENDENT ACTION       */
* /*   PROCESSING FOR THE SYSTEM RESOURCES MANAGER.  THEY ARE        */
* /*   INVOKED BY THE CTRL ALGORITHM ON THE BASIS OF REQUEST         */
* /*   BITS IN THE OUCBACN FIELD OF THE SYSTEM RESOURCES MNGR        */
* /*   USER CONTROL BLOCK.  THE IRAEPNMP MACRO DEFINES THE BIT       */
* /*   FLAG ASSOCIATED WITH EACH ROUTINE.                            */
* /*                                                                 */
* /* *************************************************************** */
* /*
.EPNMP88 AIF   ('&EPN' NE 'CSO').EPNMP90
&IRAEPFL SETC  '00080001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP90 AIF   ('&EPN' NE 'CSI').EPNMP92
&IRAEPFL SETC  '00040001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP92 AIF   ('&EPN' NE 'CSR').EPNMP94
&IRAEPFL SETC  '00020001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMPOK
.EPNMP94 AIF   ('&EPN' NE 'D15').EPNMR02
&IRAEPFL SETC  '00010001'          ROUTINE INVOCATION FLAG MASK
         AGO   .EPNMP96
*                                                                    */
* /* *************************************************************** */
* /*                                                                 */
* /*   ROUTINES WHICH PERFORM THE ROUTING OF CONTROL WITHIN THE      */
* /*   SYSTEM RESOURCES MANAGER.  THEY ARE ENTERED BY A DIRECT       */
* /*   BRANCH, AND PERFORM THEIR OWN REGISTER SETUP FUNCTIONS.       */
* /*   THE IRARMEP MACRO DEFINES THE NAME OF THE RETRY POINT TO      */
* /*   BE GIVEN CONTROL IF THAT ROUTINE EXPERIENCES AN ERROR.        */
* /*                                                                 */
* /* *************************************************************** */
* /*
.EPNMR02 ANOP
&IRAEPFL SETC  '00000000'          INVOCATION FLAG NOT USED
         AIF   ('&EPN' EQ 'EVT').EPNMPOK
         AIF   ('&EPN' EQ 'CTL').EPNMPOK
         AIF   ('&EPN' EQ 'CAS').EPNMPOK
         AGO   .EPNMR04
.*             INVALID REQUEST DEFAULT NAMING CONVENTIONS
.EPNMR04 ANOP
&IRAEPAD SETC  'IRARMNOP'          DUMMY INDICATES EPN NOT FOUND
&IRAEPER SETC  'IRARMNOP'          DUMMY INDICATES EPN NOT FOUND
         AGO   .EPNMP96
.*             SUBROUTINE ENTRY POINT NAMING CONVENTIONS
.EPNMPOK ANOP
&IRAEPAD SETC  'IRARM&EPN'         ROUTINE ENTRY POINT ADDRESS NAME
&IRAEPER SETC  '&IRAEPAD'          ROUTINE RECOVERY POINT ADDR NAME
         AIF   ('&ERR' EQ '').EPNMP96
&IRAEPER SETC  'IRARM&ERR'         ROUTINE RECOVERY POINT ADDR NAME
.EPNMP96 ANOP
         MEND
*                                                                    */
*IRAEPNMP: MACRO KEYS(EPN);         /* GIVEN ENTRY POINT NAME IDENT  */
*    DCL IRAEPNML CHAR EXT;         /* ROUTINE ENTRY POINT LOCATOR   */
*    DCL IRAEPNMS CHAR EXT;         /* ROUTINE SAVE AREA IDENTIFIER  */
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES TO WHICH A REQUEST FOR SYSTEM RESOURCES MANAGER   */
* /*   ALGORITHMIC PROCESSING IS DIRECTED.  THEY ARE LINKED-TO       */
* /*   DIRECTLY BY THE INVOKING ROUTINE.  THE INVOCATION OF THE      */
* /*   REQUESTED ALGORITHM IS DEFERRED, TO BE SUBSEQUENTLY ACTED     */
* /*   UPON BY THE SYSTEM RESOURCES MANAGER CONTROL ALGORITHM.       */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE IN THE RMSB TABLE.          */
* /*         - ROUTINES USE THE 1ST LEVEL CPU SAVE AREA TO STORE     */
* /*           THE REQUESTOR'S REGISTERS.                            */
* /*         - SAVE AREA USAGE IS SERIALIZED BY DISABLEMENT, OR      */
* /*           BY THE NON-PREEMPTABILITY OF AN SRB.                  */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'IRARMCPU' ;        /* FLAG CPU-LEVEL REQUEST RUTNE  */
*    IRAEPNMS = 'IRAEPL01' ;        /* RTNE USES LEVEL 1 REG SAVEAR  */
*    IF EPN(1) = 'CRL' THEN         /* RECEIVE SYS ALGRTHM REQUEST   */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES TO WHICH A REQUEST FOR SERIALIZED USER-LEVEL      */
* /*   SYSTEM RESOURCES MANAGER PROCESSING IS DIRECTED.  THEY ARE    */
* /*   LINKED-TO DIRECTLY BY THE INVOKING ROUTINE.  DEPENDING ON     */
* /*   SYSTEM RESOURCES MANAGER STATUS, THE REQUESTED PROCESSING     */
* /*   ACTION MAY BE INVOKED IMMEDIATELY, OR THE REQUEST FOR SUCH    */
* /*   PROCESSING ACTION MAY BE DEFERRED UNTIL ANY CONCURRENT        */
* /*   PROCESSING HAS BEEN COMPLETED.                                */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE IN THE RMSB TABLE.          */
* /*         - ROUTINES USE THE 2ND LEVEL CPU SAVE AREA TO STORE     */
* /*           THE REQUESTOR'S REGISTERS.                            */
* /*         - SAVE AREA USAGE IS SERIALIZED BY DISABLEMENT, OR      */
* /*           BY THE NON-PREEMPTABILITY OF AN SRB.                  */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNMS = 'IRAEPL02' ;        /* RTNE USES LEVEL 2 REG SAVEAR  */
*    IF EPN(1) = 'CRN' THEN         /* RECEIVE USER ACTION REQUEST   */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES WHICH PERFORM INTERNAL SERVICES FOR OTHER SYSTEM  */
* /*   RESOURCES MANAGER ROUTINES WHICH DO NOT HOLD THE SRM LOCK.    */
* /*   THEY ARE LINKED-TO DIRECTLY BY THE INVOKING ROUTINE.          */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE IN THE RMSB TABLE.          */
* /*         - ROUTINES USE THE 3RD LEVEL CPU SAVE AREA TO STORE     */
* /*           THE INVOKER'S REGISTERS.                              */
* /*         - SAVE AREA USAGE IS SERIALIZED BY DISABLEMENT, OR      */
* /*           BY THE NON-PREEMPTABILITY OF AN SRB.                  */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNMS = 'IRAEPL03' ;        /* RTNE USES LEVEL 3 REG SAVEAR  */
*    IF EPN(1) = 'I10' THEN         /* ABEND THE SRM INVOCATION      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CRY' THEN         /* RECEIVE USER ANALYZ REQUEST   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WM1' THEN         /* CALCULAT USER SERVICE AMT     */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WM4' THEN         /* CALCULAT USER NORMALIZD LVL   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WM5' THEN         /* UPDATE PERF GROUP PERIOD      */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES WHICH PERFORM EXTERNAL SERVICES FOR THE SYSTEM    */
* /*   RESOURCES MANAGER.  THEY ARE LINKED-TO DIRECTLY AS PART OF    */
* /*   THE INVOCATION SEQUENCE FOR NON-RESIDENT SYSTEM RESOURCES     */
* /*   MANAGER SERVICE ROUTINES.                                     */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE DYNAMICALLY INSERTED INTO   */
* /*           THE RMSB TABLE.                                       */
* /*         - ROUTINES USE THE 5TH LEVEL SRM SAVE AREA TO STORE     */
* /*           THE LINKING ROUTINE REGISTERS.                        */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE SRM LOCK.        */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'RMSB'||EPN(1) ;    /* REQUESTED SUBROUTINE POINTER  */
*    IRAEPNMS = 'IRAEPL05' ;        /* RTNE USES LEVEL 5 REG SAVEAR  */
*    IF EPN(1) = 'SET' THEN         /* PROCESS NEWIPS SYSEVENT RTN   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'NOP' THEN         /* RETURN TO INVOKING ROUTINE    */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES WHICH PERFORM EXTERNAL SERVICES FOR OTHER SYSTEM  */
* /*   RESOURCES MANAGER ROUTINES.  THEY ARE LINKED-TO DIRECTLY BY   */
* /*   THE INVOKING ROUTINE.                                         */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE IN THE RMSB TABLE.          */
* /*         - ROUTINES USE THE 4TH LEVEL SRM SAVE AREA TO STORE     */
* /*           THE INVOKER'S REGISTERS.                              */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE SRM LOCK.        */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNMS = 'IRAEPL04' ;        /* RTNE USES LEVEL 4 REG SAVEAR  */
*    IF EPN(1) = 'I02' THEN         /* INVOKE ASCBCHAP SERVICE       */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I03' THEN         /* INVOKE REAL FRAME STEAL       */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I04' THEN         /* INVOKE STORAGE GET/FREE       */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I05' THEN         /* INVOKE TIME INTERVL SET       */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I06' THEN         /* INVOKE QUIESCE FOR SWAPOUT    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I07' THEN         /* INVOKE SCHEDULE OF SWAP-IN    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I08' THEN         /* INVOKE SCHEDULE OF SRM SRB    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I09' THEN         /* INVOKE RECORD TO OPERATOR     */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WR4' THEN         /* CALCULAT ACTIVITY MEASRMNT    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WR6' THEN         /* RECALCULAT ACTIVITY RATE      */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES WHICH PERFORM INTERNAL SERVICES FOR OTHER SYSTEM  */
* /*   RESOURCES MANAGER ROUTINES HOLDING THE SRM LOCK.  THEY ARE    */
* /*   LINKED-TO DIRECTLY BY THE INVOKING ROUTINE.                   */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE IN THE RMSB TABLE.          */
* /*         - ROUTINES USE THE 3RD LEVEL SRM SAVE AREA TO STORE     */
* /*           THE INVOKER'S REGISTERS.                              */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE SRM LOCK.        */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNMS = 'IRAEPL03' ;        /* RTNE USES LEVEL 3 REG SAVEAR  */
*    IF EPN(1) = 'WMK' THEN         /* RESUME PREV USER TRANSACTN    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WMO' THEN         /* STOP CURRNT USER TRANSACTN    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WMQ' THEN         /* PROCESS QUIESCE CMPLT EVENT   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WMY' THEN         /* PROCESS SYSTEM TIME ADJUST    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'AP0' THEN         /* COMPUTE USER DSPCH PRIORITY   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CL0' THEN         /* ADJ CPU UTIL WHEN SWAP USER   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'IL0' THEN         /* COMPUTE USER I/O PROFILE      */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SUBROUTINES WHICH PERFORM WORKLOAD MANAGER TRANSACTION        */
* /*   RELATED ACTIONS FOR OTHER SYSTEM RESOURCES MNGR ROUTNS        */
* /*   HOLDING THE SRM LOCK.  THEY ARE LINKED-TO DIRECTLY BY         */
* /*   THE INVOKING ROUTINE.                                         */
* /*                                                                 */
* /*         - ENTRY POINT ADDRESSES ARE IN THE RMSB TABLE.          */
* /*         - ROUTINES USE THE 1ST LEVEL SRM SAVE AREA TO STORE     */
* /*           THE INVOKER'S REGISTERS.                              */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE SRM LOCK.        */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNMS = 'IRAEPL01' ;        /* RTNE USES LEVEL 1 REG SAVEAR  */
*    IF EPN(1) = 'WMN' THEN         /* START A NEW USER TRANSACTN    */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WMR' THEN         /* PROCESS RESTORE CMPLT EVENT   */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SYSTEM RESOURCES MANAGER SYSTEM-LEVEL ALGORITHMIC PROCESSING  */
* /*   ROUTINES.  THEY ARE EXECUTED AS THE RESULT OF BEING INDIVI-   */
* /*   DUALLY REQUESTED AND/OR BEING SCHEDULED ON A PERIODIC BASIS,  */
* /*   BUT ARE ALWAYS INVOKED BY A CONTROL ROUTINE AS OPPOSED TO     */
* /*   DIRECTLY BY THE REQUESTOR.                                    */
* /*                                                                 */
* /*         - ENTRY POINT BLOCKS ARE IN THE EPAT TABLE.             */
* /*         - ROUTINES USE THE 1ST LEVEL LOCKED SAVE AREA TO STORE  */
* /*           THE INVOKING (CONTROL) ROUTINE REGISTERS.             */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE CONTROL ROUTINE  */
* /*           DOING THE INVOKING.                                   */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'RMSBCRL'  ;        /* RTNE TO RECEIVE ALGRTH REQST  */
*    IRAEPNMS = 'IRAEPL01' ;        /* RTNE USES LEVEL 1 REG SAVEAR  */
*    IF EPN(1) = 'MS2' THEN         /* MSO ANALYSIS ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'MS6' THEN         /* MSO WAIT CHK ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'EQ1' THEN         /* ENQ MONITORG ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'IL1' THEN         /* IOL UTIL MON ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'RM1' THEN         /* RES MONITORING RTNE   @Z40BPCH*/
*      GOTO EPNMPOK;
*    IF EPN(1) = 'RM2' THEN         /* RES MONITOR ADJ RTNE  @Z40BPCH*/
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CL1' THEN         /* CPU ANALYSIS ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'SQA' THEN         /* SQA MSG PRNT ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WM2' THEN         /* WLM ANALYSIS ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'ASM' THEN         /* ASM SHRT MON ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CAN' THEN         /* CTL FUL ANAL ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CAP' THEN         /* CTL PRT ANAL ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'AP1' THEN         /* APG ANALYSIS ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'PR1' THEN         /* PRA ANALYSIS ALGORITHM        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'PR5' THEN         /* PRA FORC STL ALGORITHM        */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SYSTEM RESOURCES MANAGER USER-LEVEL SERIALIZED PROCESSING     */
* /*   ACTION ROUTINES.  THEY ARE EXECUTED AS THE RESULT OF AN       */
* /*   INDIVIDUAL REQUEST, BUT ARE ALWAYS INVOKED VIA A CONTROL      */
* /*   ROUTINE, AS OPPOSED TO DIRECTLY BY THE REQUESTOR.             */
* /*                                                                 */
* /*         - ENTRY POINT BLOCKS ARE IN THE EPDT TABLE.             */
* /*         - ROUTINES USE THE 2ND LEVEL SRM SAVE AREA TO STORE     */
* /*           THE INVOKING (CONTROL) ROUTINE REGISTERS.             */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE CONTROL ROUTINE  */
* /*           DOING THE INVOKING.                                   */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'RMSBCRN'  ;        /* RTNE TO RECEIVE ACTION REQST  */
*    IRAEPNMS = 'IRAEPL02' ;        /* RTNE USES LEVEL 2 REG SAVEAR  */
*    IF EPN(1) = 'DEL' THEN         /* OUCB DELETE ACTION RUTNE      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'UXB' THEN         /* OUXB DELETE ACTION RUTNE      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'IL4' THEN         /* IMCB DELETE ACTION RUTNE      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'IPS' THEN         /* IPS DELETE NOTIFY ACTION      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'HIT' THEN         /* USER READY PROCES ACTION      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'RPS' THEN         /* USER STATE CHANGE ACTION      */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SYSTEM RESOURCES MANAGER TIME-DEPENDENT ACTION SUBROUTINES.   */
* /*   THEY ARE EXECUTED AS A RESULT OF HAVING BEEN SPECIFIED FOR    */
* /*   A PARTICULAR TIME, BUT ARE ALWAYS INVOKED BY A CONTROL RTNE   */
* /*   AS OPPOSED TO DIRECTLY BY THE REQUESTOR.                      */
* /*                                                                 */
* /*         - ENTRY POINT BLOCKS ARE IN THE EPST TABLE.             */
* /*         - ROUTINES USE THE 3RD LEVEL SRM SAVE AREA TO STORE     */
* /*           THE INVOKING (CONTROL) ROUTINE REGISTERS.             */
* /*         - SAVE AREA USAGE IS SERIALIZED BY THE CONTROL ROUTINE  */
* /*           DOING THE INVOKING.                                   */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'RMSBCRY'  ;        /* RTNE TO RECEIVE ANALYZ REQST  */
*    IRAEPNMS = 'IRAEPL03' ;        /* RTNE USES LEVEL 3 REG SAVEAR  */
*    IF EPN(1) = 'CSO' THEN         /* PROCESS USER SWAPOUT DEMAND   */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CSI' THEN         /* PROCESS USER SWAP-IN DEMAND   */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SYSTEM RESOURCES MANAGER ANALYSIS SUBROUTINES.  THEY ARE      */
* /*   SELECTIVELY INVOKED BY THE CONTROL ALGORITHM AS PART OF       */
* /*   PERIODIC ANALYSIS PROCESSING.                                 */
* /*                                                                 */
* /*         - ENTRY POINT BLOCKS ARE IN THE EPST TABLE.             */
* /*         - ROUTINES USE THE 3RD LEVEL SRM SAVE AREA TO STORE     */
* /*           THE INVOKING (CONTROL) ROUTINE REGISTERS.             */
* /*         - SAVE AREA USAGE IS SERIALIZED BY DISABLEMENT, OR      */
* /*           BY THE NON-PREEMPTABILITY OF AN SRB.                  */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'EPST'||EPN(1) ;    /* REQUESTED SUBROUTINE POINTER  */
*    IF EPN(1) = 'IL3' THEN         /* USER I/O LOD EVAL ACTION      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CL3' THEN         /* USER CPU LOD EVAL ACTION      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'WM3' THEN         /* USER WORKLOD EVAL ACTION      */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   SYSTEM RESOURCES MANAGER MAJOR CONTROL ROUTINES.  THEY ARE    */
* /*   EXPLICITLY LINKED-TO BY SUPERVISOR COMPONENTS/MODULES.        */
* /*                                                                 */
* /*         - ENTRY POINT BLOCKS ARE IN THE RMEX TABLE.             */
* /*         - ROUTINES DO NOT SAVE REGISTERS OF INVOKER, OR ELSE    */
* /*           USE SAVE AREA PROVIDED BY INVOKER.                    */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'RMEX'||EPN(1) ;    /* REQUESTED CTL ROUTNE POINTER  */
*    IRAEPNMS = '';                 /* RTNE USES UNDEFIN REG SAVEAR  */
*    IF EPN(1) = 'EVT' THEN         /* PROCESS INPUT SYSEVENT        */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'I01' THEN         /* EXIT FROM SRM PROCESSING      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CTL' THEN         /* ROUTE CONTROL WITHIN SRM      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CET' THEN         /* TIMEREXP SRM CNTRL ENTRY      */
*      GOTO EPNMPOK;
*    IF EPN(1) = 'CAS' THEN         /* EXIT FROM FULL ANALYSIS       */
*      GOTO EPNMPOK;
* /* *************************************************************** */
* /*                                                                 */
* /*   THE REQUESTED ENTRY POINT NAME HAS NOT BEEN FOUND.  PASS      */
* /*   DUMMY CHARACTERISTICS BACK TO THE IRAEPNMP MACRO INVOKER.     */
* /*                                                                 */
* /* *************************************************************** */
*    IRAEPNML = 'IRARMNOP' ;        /* DMMY INDICATES EPN NOT FOUND  */
*    IRAEPNMS = '';                 /* DMMY DOES NOT USE REG SAVEAR  */
*EPNMPOK:  ;                        /* IRAEPNMP NORMAL EXIT POINT    */
*%   END;
