*        %GOTO ICTPLS1;            /*
         MACRO
         IRAICT &DSECT=YES
*                                                                    */
*%ICTPLS1 : ;
*/*                                                                  */
*/* MACCOMP Z-4 SC1CX/PKD16                                          */
*/* MACSTAT Z-4 75007/Z40BPSS                                        */
*/********************************************************************/
*/*                                                                  */
*/*      MACRO NAME - IRAICT                                         */
*/*                                                                  */
*/*      DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER I/O             */
*/*                         MANAGEMENT CONTROL TABLE                 */
*/*                                                                  */
*/*      STATUS - OS/VS2 RELEASE 4, 09/17/75, LEVEL=1                */
*/*                                                                  */
*/*      METHOD OF ACCESS                                            */
*/*        BAL - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.     */
*/*              USING ON ICT GIVES ADDRESSIBILITY FOR ALL SYMBOLS.  */
*/*        PLS - TO ACCESS AS STAND ALONE STRUCTURE DCL ICTPTR PTR.  */
*/*              TO CONCATENATE WITH PREVIOUSLY DEFINED STRUCTURE    */
*/*                SET %ICTLEVEL TO DESIRED STRUCTURE LEVEL.         */
*/*              TO PREVENT STRUCTURE FROM BEING CLOSED,             */
*/*                SET %ICT9999=','.                                 */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*        %GOTO ICTPLS2;            /*
         AIF   ('&DSECT' EQ 'YES').ICT001
ICT      DS    0D -                I/O MANAGEMENT CONTROL TABLE
         AGO   .ICT002
.ICT001  ANOP
ICT      DSECT , -                 I/O MANAGEMENT CONTROL TABLE
.ICT002  ANOP
ICTICT   DC    CL4'ICT' -          ACRONYM IN EBCDIC -ICT-
*
*        I/O CONTROL CONSTANTS
*
ICCMRSV1 DC    F'0' -               RESERVED                   @ZM43085
ICCMXICT DC    F'60000' -          MAX TIME HEAVY I/O USER REMAIN
*                                  IN MAIN STORAGE WITHOUT BEING
*                                  MONITORED FOR I/O USAGE
ICCMNUIN DC    F'10000' -          MIN INT FOR USER I/O MONITORING
ICCMNSWP DC    F'30000' -          MINIMUM SWAP OUT TIME FOR I/O
*                                  IMBALANCE CORRECTION
ICCLCLST DC    A(0)                POINTER TO LAST LCH TABLE ENTRY
ICCLCHN  DC    H'0' -              LOGICAL CHANNEL COUNT
ICCMNIOR DC    H'5' -              MIN I/O RATE FOR USER I/O MONITORING
ICCRVSCF DC    H'1' -              IOL REC VALUE SCALING FACTOR
ICCMAXRV DC    H'128' -            MAXIMUM IOL RECOMMENDATION VALUE
ICCMINRV DC    H'-128' -           MINIMUM IOL RECOMMENDATION VALUE
ICCDASF1 DC    H'10' -             AVERAGING FACTOR FOR LCH UTILIZATION
*                                  COMPUTATION
ICCDASF2 DC    H'11' -             ICCDASF1+1
* LCH UTILIZATION IMBALANCE THRESHOLDS (EXPRESSED AS PERCENTAGES)
ICCHIUTH DC    H'0' -              HIGH IMBALANCE THRESHOLD
ICCLOUTH DC    H'0' -              LOW IMBALANCE THRESHOLD
ICCDAUTH DC    H'0' -              THRESHOLD FOR DEVICE ALLOCATION *256
* LCH UTILIZATION IMBALANCE THRESHOLD INITIALIZATION VALUES FOR UNI
* OR MULTIPROCESSOR CASES
ICCINHIT DS    0HL4 -              HIGH THRESHOLD INITIALIZATION VALUES
ICCINHI1 DC    H'70' -               UNIPROCESSOR CASE
ICCINHI2 DC    H'80' -               MULTIPROCESSOR CASE
ICCINLOT DS    0HL4 -              LOW THRESHOLD INITIAIZATION VALUES
ICCINLO1 DC    H'30' -               UNIPROCESSOR CASE
ICCINLO2 DC    H'40' -               MULTIPROCESSOR CASE
ICCINDAT DS    0HL4 -              DEV ALLOCATION INTIIAL VALUES
ICCINDA1 DC    AL2(70*256) -         UNIPROCESSOR CASE
ICCINDA2 DC    AL2(80*256) -         MULTIPROCESSOR CASE
ICCSIGUP DC    H'5' -              SIGNIFICANT USER LCH USAGE
*                                  PERCENTAGE
ICCSRSV2 DC    H'0' -              RESERVED                 @ZM43085
ICCEDSUT DC    AL2(05*256) -       EST DATASET UTILIZ IMPACT   @Z30WIAW
ICCRSV01 DC    HL2'0' -            RESERVED                    @Z40BPCH
ICCEND   DS    0F -                END OF ICT CONSTANTS
*
*        I/O CONTROL VARIABLES
*
ICVLUTBT DC    F'0' -              LCH UTILIZATION COMPUTATION BASE
*                                  TIME
ICVLCBPT DC    BL4'0' -            LCH IMBALANCE BIT PATTERN
ICVOLCBT DC    BL4'0' -            OVERUTILIZED LCH BIT PATTERN
ICVULCBT DC    BL4'0' -            UNDERUTILIZED LCH BIT PATTERN
ICVIRSV3 DC   F'0' -               RESERVED                  @ZM43085
*
*        I/O CONTROL FLAGS
*
ICTFLAGS DC    B'0' -              I/O CONTROL FLAGS
ICTDRSV4 EQU   BIT0 -               RESERVED                  @ZM43085
ICTIOL   EQU   BIT1                 I/O LOAD BALANCING ACTIVE FLAG
ICTIOOT  EQU   BIT3                SOME LOGICAL CHANNELS OUT OF BALANCE
*                                                              @Z40BPCH
ICTRSVB1 DC    B'0' -               RESERVED
ICTRSVB2 DC    B'0' -               RESERVED                   @Z40BPCH
ICTRSVB3 DC    B'0' -               RESERVED                   @Z40BPCH
ICTEND   DS    0D -                END OF ICT
ICTLEN   EQU   ICTEND-ICT -        LENGTH OF ICT
         MEND  , -                                                   */
*%ICTPLS2 : ;
*    %IF ICT9999^=','              /* IF THIS IS LAST BLOCK          */
*      %THEN ICT9999=';';          /* THEN CLOSE DECLARE STATEMENT   */
*    %IF ICTLEVEL^=''              /* IF MINOR LEVEL IS SPECIFIED,   */
*      %THEN %GOTO ICTPLS3;        /* SKIP MAJOR DECLARE             */
*DECLARE                           /*                                */
*  1 ICT BASED(ICTPTR)             /*     I/O CONTROL TABLE          */
*    %GOTO ICTPLS4;                /* MAJOR STRUCTURE                */
*%ICTPLS3: ICTDUM=ICTLEVEL||' ICT'; /* CONCATENATE AS MINOR STRUCTURE*/
*  ICTDUM                          /*     I/O CONTROL TABLE          */
*%ICTPLS4:;
*          BDY(DWORD),
*      5 ICTICT CHAR(4),           /* ACRONYM IN EBCDIC -ICT-        */
*/*                                                                  */
*/*      I/O CONTROL CONSTANTS                                       */
*/*                                                                  */
*      5 ICCMRSV1 FIXED(31),       /* RESERVED              @ZM43085*/
*      5 ICCMXICT FIXED(31),       /* MAX TIME HEAVY I/O USER CAN
*                                     REMAIN IN MAIN STORAGE WITHOUT
*                                     BEING MONITORED FOR I/O USAGE  */
*      5 ICCMNUIN FIXED(31),       /* MIN INT FOR USER I/O MONITORING*/
*      5 ICCMNSWP FIXED(31),       /* MINIMUM SWAP OUT TIME FOR I/O
*                                    IMBALANCE CORRECTION            */
*      5 ICCLCLST PTR(31),         /* POINTER TO LAST RLCT TABLE
*                                     ENTRY                          */
*      5 ICCLCHN FIXED(15),        /* LOGICAL CHANNEL COUNT          */
*      5 ICCMNIOR FIXED(15),       /* MIN I/O RATE FOR USER I/O
*                                     MONITORING                     */
*      5 ICCRVSCF FIXED(15),       /* IOL REC VALUE SCALING FACTOR   */
*      5 ICCMAXRV FIXED(15),       /* MAXIMUM IOL RECOMMENDATION VAL */
*      5 ICCMINRV FIXED(15),       /* MINIMUM IOL RECOMMENDATION VAL */
*      5 ICCDASF1 FIXED(15),       /* AVERAGING FACTOR FOR LCH
*                                     UTILIZATION COMPUTATION        */
*      5 ICCDASF2 FIXED(15),       /* ICCDASF1+1                     */
*/* LCH UTILIZATION IMBALANCE THRESHOLDS                             */
*      5 ICCHIUTH FIXED(15),       /* HIGH IMBALANCE THRESHOLD       */
*      5 ICCLOUTH FIXED(15),       /* LOW IMBLAANCE THRESHOLD        */
*      5 ICCDAUTH FIXED(15),       /* THRESHOLD FOR DEVICE ALLOCATION
*                                     SYSEVENT * 256                 */
*/* LCH UTILIZATION THRESHOLD INITIALIZATION VALUES FOR UNI OR MULTI
*    PROCESSOR CASES                                                 */
*      5 ICCINHIT (2) FIXED(15),   /* HIGH THRESHOLD INIT VALUES     */
*      5 ICCINLOT (2) FIXED(15),   /* LOW THRESHOLD INIT VALUE S     */
*      5 ICCINDAT (2) FIXED(15),   /* DEV ALLOC THRESHOLD INIT VALUES*/
*      5 ICCSIGUP FIXED(15),       /* SIGNIFICANT USER LCH USAGE
*                                     PERCENTAGE                     */
*      5 ICCSRSV2 FIXED(15),       /* RESERVED               @ZM43085*/
*      5 ICCEDSUT FIXED(15),        /* EST DD UTILIZ IMPACT  @Z30WIAW*/
*      5 ICCRSV01 CHAR(2) BDY(HWORD), /* RESERVED            @Z40BPCH*/
*      5 ICCEND CHAR(0) BDY(WORD), /* END OF ICT CONSTANTS           */
*/*                                                                  */
*/*      I/O CONTROL VARIABLES                                       */
*/*                                                                  */
*      5 ICVLUTBT FIXED(31),       /* LCH UTILIZATION COMPUTATION
*                                     BASE TIME                      */
*      5 ICVLCBPT BIT(32),         /* LCH IMBALANCE BIT PATTERN      */
*      5 ICVOLCBT BIT(32),         /* OVERUTILIZED LCH BIT PATTERN   */
*      5 ICVULCBT BIT(32),         /* UNDERUTILIZED LCH BIT PATTERN  */
*     5 ICVIRSV3 FIXED(31),        /* RESERVED               @ZM43085*/
*/*                                                                  */
*/*      I/O CONTROL FLAGS                                           */
*/*                                                                  */
*      5 ICTFLAGS BIT(8),          /* I/O CONTROL FLAGS              */
*        10 ICTDRSV4 BIT(1),       /* RESERVED               @ZM43085*/
*        10 ICTIOL BIT(1),          /* I/O LOAD BALANCING ACTIVE FLAG*/
*        10 ICTIOOT BIT(1),         /* SOME LOGICAL CHANNELS OUT OF
*                                      BALANCE               @Z40BPCH*/
*        10 ICT003 BIT(5),          /* RESERVED              @Z40BPCH*/
*      5 ICTRSVB1 BIT(8),           /* RESERVED                      */
*      5 ICTRSVB2 BIT(8),           /* RESERVED              @Z40BPCH*/
*      5 ICTRSVB3 BIT(8),           /* RESERVED              @Z40BPCH*/
*      5 ICTEND CHAR(0)            /* END OF ICT                     */
*          BDY(DWORD) ICT9999
*%ICTLEN='LENGTH(ICT)';            /* OBTAIN LENGTH OF ICT           */
*      @EJECT;
