*        %GOTO  MCTPLS1;
         MACRO
         IRAMCT &DSECT=YES
*/*                                                                  */
*%MCTPLS1 : ;
*/*                                                                  */
*/*  MACCOMP Z-4 SC1CX/PKD16                                         */
*/*  MACSTAT Z-4 76007/Z40BPSS                                       */
*/********************************************************************/
*/*                                                                  */
*/*      MACRO NAME - IRAMCT                                         */
*/*                                                                  */
*/*      DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER STORAGE         */
*/*                         MANAGEMENT CONTROL TABLE                 */
*/*                                                                  */
*/*      STATUS - OS/VS2 RELEASE 4, 09/19/75, LEVEL=1                */
*/*                                                                  */
*/*      METHOD OF ACCESS                                            */
*/*        BAL - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.     */
*/*              USING ON MCT GIVES ADDRESSIBILITY FOR ALL SYMBOLS.  */
*/*        PLS - TO ACCESS AS STAND ALONE STRUCTURE DCL MCTPTR PTR.  */
*/*              TO CONCATENATE WITH PREVIOUSLY DEFINED STRUCTURE    */
*/*                SET %MCTLEVEL TO DESIRED STRUCTURE LEVEL.         */
*/*              TO PREVENT STRUCTURE FROM BEING CLOSED,             */
*/*                SET %MCT9999=','.                                 */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*        %GOTO  MCTPLS2;          /*
         AIF   ('&DSECT' EQ 'YES').MCT001
MCT      DS    0D -                STORAGE CONTROL TABLE
         AGO   .MCT002
.MCT001  ANOP
MCT      DSECT , -                 STORAGE CONTROL TABLE
.MCT002  ANOP
MCTMCT   DC    CL4'MCT' -         ACRONYM IN EDCDIC -MCT-
*
*        STORAGE CONTROL CONSTANTS
*
*        POINTERS TO SHORTAGE MESSAGES
MCCMS100 DC    V(IRARM100) -      SQA SHORTAGE MESSAGE ADDRESS
MCCMS101 DC    V(IRARM101) -      CRITICAL SQA SHORTAGE MESSAGE ADDRESS
MCCMS102 DC    V(IRARM102) -      SQA SHORTAGE RELIEVED MESSAGE ADDRESS
MCCMS200 DC    V(IRARM200) -      AUX SHORTAGE MESSAGE ADDRESS
MCCMS201 DC    V(IRARM201) -      CRITICAL AUX SHORTAGE MESSAGE ADDRESS
MCCMS202 DC    V(IRARM202) -      AUX SHORTAGE RELIEVED MESSAGE ADDRESS
MCCMS203 DC    V(IRARM203) -      AUX SHORTAGE USER MSG ADDR   @ZM43072
MCCMS400 DC    V(IRARM400) -      FIX PAGE SHORTAGE MSG ADDR   @Z40BPCH
MCCMS401 DC    V(IRARM401) -      CRITICAL FIX PAGE SHORTAGE MSG ADDR
*                                                              @Z40BPCH
MCCMS402 DC    V(IRARM402) -      FIX PAGE SHORTAGE RELIEVED MSG ADDR
*                                                              @Z40BPCH
MCCMS403 DC    V(IRARM403) -      FIX PAGE USER MESSAGE ADDR   @ZM43072
*
*        STORAGE CONTROL CONSTANTS                             @Z40BPCH
*
MCCPLUS  DC    H'10' -             AVAILABLE FRAME QUEUE DELTA FOR
*                                  STEALING                    @Z40BPCH
MCCRSVH1 DC    H'0' -              RESERVED                    @Z40BPCH
*
*        AUX STORAGE MONITORING CONSTANTS
*
MCCASMT1 DC    H'70' -             FIRST AUX SHORTAGE THRESHOLD
MCCASMT2 DC    H'85' -             SECOND AUX SHORTAGE THRESHOLD
MCCEND   DS    0F -                END OF MCT CONSTANTS
*
*        STORAGE CONTROL VARIABLES
*
MCVSTCRI DC    H'0' -              HIGHEST SYSTEM UIC          @Z40BPCH
MCVFRCNT DC    H'0' -              NUMBER OF PAGES NEEDED TO BE STOLEN
*                                  BY THE FORCE STEAL ROUTINE
MCVAVQC  DC    F'0' -              COUNT OF AVQLOWS            @Z40BPCH
*
*        MEMORY CONTROL FLAGS
*
MCTSFLGS DC    B'0' -              FLAGS MODIFIED UNDER SALLOC LOCK
MCTSQA1  EQU   BIT0 -              SQA FIRST LEVEL SHORTAGE
MCTSQA2  EQU   BIT1 -              SQA SECOND LEVEL SHORTAGE
MCTAVQ1  EQU   BIT2 -              AVQ BELOW LIMIT
MCTFAVQ  EQU   BIT3 -              FIXED FRAMES ABOVE LIMIT    @Z40BPCH
MCTOFLGS DC    B'0' -              FLAGS MODIFIED UNDER SRM LOCK
MCTASM1  EQU   BIT0 -              ASM FIRST LEVEL SHORTAGE
MCTASM2  EQU   BIT1 -              ASM SECOND LEVEL SHORTAGE
MCTAMS2  EQU   BIT3 -              ASM SECOND LEVEL MESSAGE
MCTSMS1  EQU   BIT4 -              SQA FIRST LEVEL MESSAGE
MCTSMS2  EQU   BIT5 -              SQA SECOND LEVEL MESSAGE
MCTFX1   EQU   BIT6 -              FIX PG 1ST LEVEL MSG        @Z40BPCH
MCTFX2   EQU   BIT7 -              FIX PG 2ND LEVEL MSG        @Z40BPCH
MCTXRSVD DC    B'0' -              RESERVED                  @ZM43085
* BITS 1-7 UNAVAILABLE BECAUSE OF SERIALIZATION PROBLEMS
MCTRSVB1 DC    B'0' -               RESERVED                   @YM05630
*
*        TIME INTERVAL VALUES FOR PR1 INVOCATION               @ZM43064
*
MCCUICBD DC    F'00000008' -        UIC LIMIT BEFORE ADJUSTING @ZM43064
MCCUICIN DC    F'00001000' -        PR1 INTERVAL INCREMENT     @ZM43064
MCCPR1IN DC    F'0' -               INITIAL RMEPINT FOR PR1    @ZM43064
MCCINTMX DC    F'00002000' -        MAX PR1 INTERVAL           @ZM43097
MCVRSVF1 DC    F'0' -               RESERVED                   @Z30WIPH
MCVRSVF2 DC    F'0' -               RESERVED                   @Z30WIPH
MCVRSVF3 DC    F'0' -               RESERVED                   @Z30WIPH
MCTEND   DS    0F -                END OF MCT
MCTLEN   EQU   MCTEND-MCT -        LENGTH OF MCT
         MEND
*        */
*%MCTPLS2 : ;
*    %IF MCT9999^=','              /* IF THIS IS LAST BLOCK          */
*      %THEN %MCT9999=';';         /* THEN CLOSE DECLARE STATEMENT   */
*    %IF MCTLEVEL^=''              /* IF MINOR LEVEL IS SPECIFIED,   */
*      %THEN %GOTO MCTPLS3;        /* SKIP MAJOR DECLARE             */
*DECLARE                           /*                                */
*  1 MCT BASED(MCTPTR)             /* STORAGE CONTROL TABLE          */
*    %GOTO MCTPLS4;                /* MAJOR STRUCTURE                */
*%MCTPLS3: MCTDUM=MCTLEVEL||' MCT'; /* CONCATENATE AS MINOR STRUCTURE*/
*  MCTDUM                          /* STORAGE CONTROL TABLE          */
*%MCTPLS4:;
*        BDY(DWORD),
*      5 MCTMCT CHAR(4),           /* ACRONYM IN EBCDIC -MCT-        */
*/*                                                                  */
*/*      STORAGE CONTROL CONSTANTS                                   */
*/*                                                                  */
*/* POINTERS TO SHORTAGE MESSAGES                                    */
*      5 MCCMS100 PTR(31),         /* SQA SHORTAGE MESSAGE ADDRESS   */
*      5 MCCMS101 PTR(31),         /* CRITICAL SQA SHORTAGE MSG ADDR */
*      5 MCCMS102 PTR(31),         /* SQA SHORTAGE RELIEVED MSG ADDR */
*      5 MCCMS200 PTR(31),         /* AUX SHORTAGE MESSAGE ADDRESS   */
*      5 MCCMS201 PTR(31),         /* CRITICAL AUX SHORTAGE MSG ADDR */
*      5 MCCMS202 PTR(31),         /* AUX SHORTAGE RELIEVED MSG ADDR */
*      5 MCCMS203 PTR(31),         /* AUX SHORTAGE USER MESSAGE ADDRESS
*                                                            @ZM43072*/
*      5 MCCMS400 PTR(31),         /* FIX PAGE SHORTAGE MSG ADDR
*                                                           @Z40BPCH */
*      5 MCCMS401 PTR(31),         /* CRITICAL FIX PAGE SHORTAGE MSG
*                                     ADDR                  @Z40BPCH */
*      5 MCCMS402 PTR(31),         /* FIX PAGE SHORTAGE RELIEVED
*                                     MSG ADDR              @Z40PBCH */
*      5 MCCMS403 PTR(31),         /* FIX PAGE USER MESSAGE ADDRESS
*                                                            @ZM43072*/
*/*                                                                  */
*/* STORAGE CONTROL CONSTANTS                                @Z40BPCH*/
*/*                                                                  */
*      5 MCCPLUS FIXED(15),        /* AVAILABLE FRAME QUEUE DELTA FOR
*                                     STEALING               @Z40BPCH*/
*      5 MCCRSVH1 FIXED(15),       /* RESERVED               @Z40BPCH*/
*/*                                                                  */
*/* AUX STORAGE MONITORING CONSTANTS                                 */
*/*                                                                  */
*      5 MCCASMT1 FIXED(15),       /* FIRST AUX SHORTAGE THRESHOLD   */
*      5 MCCASMT2 FIXED(15),       /* SECOND AUX SHORTAGE THRESHOLD  */
*      5 MCCEND CHAR(0) BDY(WORD), /* END OF MCT CONSTANTS           */
*/*                                                                  */
*/*      STORAGE CONTROL VARIABLES                                   */
*/*                                                                  */
*      5 MCVSTCRI FIXED(15),       /* HIGHEST SYSTEM UIC     @Z40BPCH*/
*      5 MCVFRCNT FIXED(15),       /* NUMBER OF PAGES NEEDED TO BE
*                                     STOLEN BY THE FORCE STEAL RTN  */
*      5 MCVAVQC FIXED(31),        /* COUNT OF AVQLOWS       @Z40BPCH*/
*/*                                                                  */
*/*      MEMORY CONTROL FLAGS                                        */
*/*                                                                  */
*      5 MCTSFLGS BIT(8),          /* FLAGS MODIFIED UNDER SALLOC LCK*/
*        10 MCTSQA1 BIT(1),        /* SQA FIRST LEVEL SHORTAGE       */
*        10 MCTSQA2 BIT(1),        /* SQA SECOND LEVEL SHORTAGE      */
*        10 MCTAVQ1 BIT(1),        /* AVQ BELOW LIMIT                */
*        10 MCTFAVQ  BIT(1),       /* FIXED FRAMES ABOVE LIM @Z40BPCH*/
*        10 MCTSF04 BIT(4),        /* RESERVED               @Z40BPCH*/
*      5 MCTOFLGS BIT(8),          /* FLAGS MODIFIED UNDER SRM LOCK  */
*        10 MCTASM1 BIT(1),        /* ASM FIRST LEVEL SHORTAGE       */
*        10 MCTASM2 BIT(1),        /* ASM SECOND LEVEL SHORTAGE      */
*        10 *       BIT(1),        /* RESERVED               @Z40BPSS*/
*        10 MCTAMS2 BIT(1),        /* ASM SECOND LEVEL MESSAGE       */
*        10 MCTSMS1 BIT(1),        /* SQA FIRST LEVEL MESSAGE        */
*        10 MCTSMS2 BIT(1),        /* SQA SECOND LEVEL MESSAGE       */
*        10 MCTFX1  BIT(1),        /* FIX PG 1ST LEVEL MSG   @Z40BPCH*/
*        10 MCTFX2  BIT(1),        /* FIX PG 2ND LEVEL MSG   @Z40BPCH*/
*      5 MCTXRSVD BIT(8),          /* RESERVED               @ZM43085*/
*      5 MCTRSVB1 BIT(8),           /* RESERVED              @YM05630*/
*/*                                                                  */
*/*    TIME INTERVAL VALUES FOR PR1 INVOCATION               @ZM43064*/
*/*                                                                  */
*        5 MCCUICBD FIXED(31),      /* UIC LIMIT BEFORE ADJUSTING
*                                                            @ZM43064*/
*        5 MCCUICIN FIXED(31),     /* PR1 INTERVAL INCREMENT @ZM43064*/
*        5 MCCPR1IN FIXED(31),      /* INITIAL RMEPINT FOR PR1
*                                                            @ZM43064*/
*        5 MCCINTMX FIXED(31),      /* MAX PR1 INTERVAL      @ZM43097*/
*        5 MCVRSVF1 FIXED(31),      /* RESERVED              @Z30WIPH*/
*        5 MCVRSVF2 FIXED(31),      /* RESERVED              @Z30WIPH*/
*        5 MCVRSVF3 FIXED(31),      /* RESERVED              @Z30WIPH*/
*      5 MCTEND CHAR(0)            /* END OF MCT                     */
*          BDY(DWORD) MCT9999
*%MCTLEN='LENGTH(MCT)';            /* OBTAIN LENGTH OF MCT           */
*@EJECT;
