*        %GOTO  RCTPLS1;           /*
         MACRO
         IRARCT &DSECT=YES
*                                                                    */
*%RCTPLS1 : ;
*/*                                                                  */
*/*  MACCOMP Z-4 SC1CX/PKD16                                         */
*/*  MACSTAT Z-4 75007/Z40BPSS                                       */
*/********************************************************************/
*/*                                                                  */
*/*      MACRO NAME - IRARCT                                         */
*/*                                                                  */
*/*      DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER RESOURCE        */
*/*                         MANAGEMENT CONTROL TABLE                 */
*/*                                                                  */
*/*      STATUS - OS/VS2 RELEASE 4, 10/29/75, LEVEL=1                */
*/*                                                                  */
*/*      METHOD OF ACCESS                                            */
*/*        BAL - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.     */
*/*              USING ON RCT GIVES ADDRESSIBILITY FOR ALL SYMBOLS.  */
*/*        PLS - TO ACCESS AS STAND ALONE STRUCTURE DCL RCTPTR PTR.  */
*/*              TO CONCATENATE WITH PREVIOUSLY DEFINED STRUCTURE    */
*/*                SET %RCTLEVEL TO DESIRED STRUCTURE LEVEL.         */
*/*              TO PREVENT STRUCTURE FROM BEING CLOSED,             */
*/*                SET %RCT9999=','.                                 */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*        %GOTO  RCTPLS2;          /*
         AIF   ('&DSECT' EQ 'YES').RCT001
RCT      DS    0D -                RESOURCE CONTROL TABLE
         AGO   .RCT002
.RCT001  ANOP
RCT      DSECT , -                 RESOURCE CONTROL TABLE
.RCT002  ANOP
RCTRCT   DC    CL4'RCT' -         ACRONYM IN EDCDIC -RCT-
*
*        RESOURCE CONTROL CONSTANTS
*
RCCUICTL DC    H'2'               UIC LOW THRESHOLD            @ZM43098
RCCUICTH DC    H'4'               UIC HIGH THRESHOLD           @ZM43098
RCCCPUTL DC    H'1536'            CPU LOW THRESHOLD SHIFTED    @ZM43098
RCCCPUTH DC    H'1615'            CPU HIGH THRESHOLD SHIFTED   @ZM43098
RCCPTRTL DC    H'100'             PAGING RATE LOW THRESHOLD    @ZM43098
RCCPTRTH DC    H'100'             PAGING RATE HIGH THRESHOLD   @ZM43098
RCCASMTL DC    H'7'               ASM QUEUED REQ LOW THRESHOLD @ZM43098
RCCASMTH DC    H'10'              ASM QUEUED REQ HIGH THRSHOLD @ZM43098
RCCTOTUT DC    H'100' -           AVERAGE DEFERRED IO UTILIZATION
*                                 THRESHOLD                    @ZM43083
RCCLCHUT DC    H'100' -           LCH DEFERRED UTILIZATION
*                                 THRESHOLD                    @ZM43083
RCCLCHRR DC    H'50' -            LCH REQUEST RATE THRESHOLD   @ZM43083
RCCRSVF1 DC    H'0' -             RESERVED
RCCRSVF2 DC    F'0' -             RESERVED
RCCRSVF3 DC    F'0' -             RESERVED
*
*        RESOURCE CONTROL VARIABLES
*
RCVCTMC  DC    H'0' -              SAMPLE INTERVAL COUNT
RCVUICA  DC    H'0' -              UIC AVERAGE
RCVCPUA  DC    H'0' -              CPU AVERAGE
RCVAVQC  DC    H'0' -              NUMBER OF AVQ LOWS
RCVASMQA DC    H'0' -              ASM QUEUE LENGTH AVERAGE
RCVPTR   DC    H'0' -              PAGING RATE
RCVUICC  DC    F'0' -              UIC ACCUMULATOR
RCVCPUC  DC    F'0' -              CPU ACCUMULATOR
RCVAVQP  DC    F'0' -              AVQ LOW COUNT SAVE
RCVASMQ  DC    F'0' -              ASM QUEUE LENGTH ACCUMULATOR
RCVBPTCT DC    F'0' -              BASE PAGE FAULT COUNT
RCVBPTTM DC    F'0' -              BASE PAGE FAULT TIME
RCVTOTDF DC    H'0' -              AVERAGE DEFERRED IO UTIL    @ZM43083
RCVRSVF1 DC    H'0' -              RESERVED
RCVTAPAD DC    F'0' -              LAST ALLOCATED TAPE ADDRESS @ZM43099
RCVRSVF2 DC    F'0' -              RESERVED
RCVRSVF3 DC    F'0' -              RESERVED
RCTEND   DS    0D -                END OF RCT
RCTLEN   EQU   RCTEND-RCT -        LENGTH OF RCT
         MEND
*        */
*%RCTPLS2 : ;
*    %IF RCT9999^=','              /* IF THIS IS LAST BLOCK          */
*      %THEN %RCT9999=';';         /* THEN CLOSE DECLARE STATEMENT   */
*    %IF RCTLEVEL^=''              /* IF MINOR LEVEL IS SPECIFIED,   */
*      %THEN %GOTO RCTPLS3;        /* SKIP MAJOR DECLARE             */
*DECLARE                           /*                                */
*  1 RCT BASED(RCTPTR)             /* RESOURCE CONTROL TABLE         */
*    %GOTO RCTPLS4;                /* MAJOR STRUCTURE                */
*%RCTPLS3: RCTDUM=RCTLEVEL||' RCT'; /* CONCATENATE AS MINOR STRUCTURE*/
*  RCTDUM                          /* RESOURCE CONTROL TABLE         */
*%RCTPLS4:;
*        BDY(DWORD),
*      5 RCTRCT CHAR(4),           /* ACRONYM IN EBCDIC -RCT-        */
*/*                                                                  */
*/*      RESOURCE CONTROL CONSTANTS                                  */
*/*                                                                  */
*      5 RCCUICTL FIXED(15),       /* UIC THRESHOLD LOW              */
*      5 RCCUICTH FIXED(15),       /* UIC HIGH THRESHOLD             */
*      5 RCCCPUTL FIXED(15),       /* CPU LOW THRESHOLD              */
*      5 RCCCPUTH FIXED(15),       /* CPU HIGH THRESHOLD             */
*      5 RCCPTRTL FIXED(15),       /* PAGING RATE LOW THRESHOLD      */
*      5 RCCPTRTH FIXED(15),       /* PAGING RATE HIGH THRESHOLD     */
*      5 RCCASMTL FIXED(15),       /* ASM QUEUED REQUEST LOW
                                      THRESHOLD                      */
*      5 RCCASMTH FIXED(15),       /* ASM QUEUED REQUEST HIGH
                                      THRESHOLD                      */
*      5 RCCTOTUT FIXED(15),      /* AVERAGE DEFERRED IO UTIL THRESHOLD
*                                                            @ZM43083*/
*      5 RCCLCHUT FIXED(15),      /* LCH DEFERRED UTIL THRESHOLD
*                                                            @ZM43083*/
*      5 RCCLCHRR FIXED(15),       /* LCH REQ RATE THRESHOLD @ZM43083*/
*        5 RCCRSVF1 FIXED(15),      /* RESERVED                      */
*        5 RCCRSVF2 FIXED(31),      /* RESERVED                      */
*        5 RCCRSVF3 FIXED(31),      /* RESERVED                      */
*/*                                                                  */
*/*   RESOURCE CONTROL VARIABLES                                     */
*/*                                                                  */
*      5 RCVCTMC FIXED(15),        /* SAMPLE INTERVALS COUNT         */
*      5 RCVUICA FIXED(15),        /* UIC AVERAGE                    */
*      5 RCVCPUA FIXED(15),        /* CPU USAGE AVERAGE              */
*      5 RCVAVQC FIXED(15),        /* AVQ LOW COUNT                  */
*      5 RCVASMQA FIXED(15),       /* ASM QUEUE LENGTH AVERAGE       */
*      5 RCVPTR FIXED(15),         /* PAGING RATE                    */
*      5 RCVUICC FIXED(31),        /* UIC ACCUMULATOR                */
*      5 RCVCPUC FIXED(31),        /* CPU USAGE ACCUMULATOR          */
*      5 RCVAVQP FIXED(31),        /* AVQ LOW COUNT SAVE AREA        */
*      5 RCVASMQ FIXED(31),        /* ASM QUEUE LENGTH ACCUMULATOR   */
*      5 RCVBPTCT FIXED(31),       /* BASE PAGE FAULT COUNT          */
*      5 RCVBPTTM FIXED(31),       /* BASE PAGE FAULT TIME           */
*      5 RCVTOTDF FIXED(15),       /* AVERAGE DEFERRED IO UTILIZATION
*                                                            @ZM43083*/
*        5 RCVRSVF1 FIXED(15),      /* RESERVED                      */
*        5 RCVTAPAD FIXED(31),      /* LAST ALLOCATED TAPE   @ZM43099*/
*        5 RCVRSVF2 FIXED(31),      /* RESERVED                      */
*        5 RCVRSVF3 FIXED(31),      /* RESERVED                      */
*      5 RCTEND CHAR(0)            /* END OF RCT                     */
*          BDY(DWORD) RCT9999
*%RCTLEN='LENGTH(RCT)';            /* OBTAIN LENGTH OF RCT           */
*@EJECT;
