*        %GOTO RMCAPLS1; /*
         MACRO
         IRARMCA   &DSECT=YES                                        */
*%RMCAPLS1:  ;
* /*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRARMCA                                          */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CONTROL AREA      */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 09/19/75, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE RMCA PROVIDES THE STORAGE AREA CONTAINING      */
* /*         SWAP ANALYSIS VARIABLES USED WITHIN THE SYSTEM RE-      */
* /*         SOURCES MANAGER.  AS A RESULT OF USING THE RMCA AS      */
* /*         A WORK AREA, THE IRARMCTL AND IRARMWLM MODULES CAN      */
* /*         BE MADE READ-ONLY.                                      */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE RMCA IS CONTAINED       */
* /*         IN THE -RMCTRMCA- FIELD OF THE SYSTEM RESOURCES         */
* /*         MANAGER CONTROL TABLE.                                  */
* /*                                                                 */
* /* *************************************************************** */
*        %GOTO RMCAPLS2; /*
         AGO   .RMCAAL1                                              */
* /* *************************************************************** */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*           NOTE - THE BAL FORM OF THE MACRO IS CODED WITH        */
* /*           'DC' INSTRUCTIONS, SO THAT THE MACRO MAY BE USED      */
* /*           TO ASSEMBLE THE INITIAL FIELD VALUES FOR THE          */
* /*           IRARMCNS MODULE, WHICH CONTAINS THE RMCA.             */
* /*                                                                 */
* /*         USING ON RMCA GIVES ADDRESSABILITY TO ALL SYMBOLS.      */
* /*                                                                 */
* /*     PLS - %RMCALEVL='USERLEVL' IF THE RMCA MAPPING IS TO BE     */
* /*           CONCATENATED WITH A PREVIOUS DECLARATION, WITH THE    */
* /*           RMCA BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.    */
* /*         - %RMCA9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED.  */
* /*                                                                 */
* /*         TO ACCESS AS A STANDALONE STRUCTURE, DCL RMCAPTR PTR.   */
* /*                                                                 */
* /*   CHANGE ACTIVITY = @ZM43085                                    */
* /*                     @ZA15788                                   */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
* /*
.RMCAAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').RMCAAL2
RMCA     DSECT
         AGO   .RMCAAL3
.RMCAAL2 ANOP
         DS    0D
RMCA     EQU   *
.RMCAAL3 ANOP
         SPACE 1
RMCANAME DC    C'RMCA' -           BLOCK IDENTIFICATION
RMCAR04  DC    H'0' -              RESERVED
RMCAINUS DC    H'0' -              COUNT OF IN-CORE USERS
RMCARSV1 DC    H'0' -              RESERVED                  @ZM43085
RMCARSV2 DC    H'0' -              RESERVED                  @ZM43085
RMCATQS  DC    F'0' -              SYSTEM QUIESCE TIME
RMCATRS  DC    F'0' -              SYSTEM RESTART TIME
RMCATOI  DC    F'0' -              TIME OF EXPECTED TIMER INTERRUPT
RMCARSV3 DC    F'0' -              RESERVED                  @ZM43085
RMCARSV4 DC    F'0' -              RESERVED                  @ZM43085
RMCARSV5 DC    F'0' -              RESERVED                  @ZM43085
RMCAFLGS DC    1B'00000000' -      SAVEAREA AVAIL. FLAGS     @ZA15788
RMCASAAF EQU   BIT0 -              SIXTH LVL SAVEAREA AVAIL  @ZA15788
         DC    3B'00000000' -       RESERVED                  @ZA15788
RMCARSV7 DC    F'0' -               RESERVED                  @ZM43085
RMCARSV8 DC    F'0' -               RESERVED                  @ZM43085
RMCACHP  DC    X'800000FF' -       CHAP LIST FOR SWAPOUT PRTY  @YM05632
RMCACHU  DC    A(0) -              USER TO BE CHAPPED ON SWAP  @YM05632
RMCARSV9 DC    F'0' -               RESERVED                  @ZM43085
RMCAR10   DC    F'0' -              RESERVED                  @ZM43085
RMCAINV  DC    F'0' -              ROUTINE INVOCATION WORK AREA
RMCAR11  DC    H'0' -               RESERVED                  @ZM43085
RMCAISV  DC    H'1' -              ISV RECOMM. VALUE BOOST     @Z40BPCH
RMCALGPG DC    HL1'2' -            DEF LOGON PERF GROUP NUMBER @Z40BPCH
RMCABCPG DC    HL1'1' -            DEF BATCH PERF GROUP NUMBER @Z40BPCH
RMCAR20  DC    H'0' -              RESERVED                    @Z40BPCH
RMCAMAS  DC    V(IEAMASCB) -       ASCB ADDR FOR MASTER SCHEDULER
RMCAWKA  DC    8F'0' -              NONRESIDENT ROUTINE WORKAREA
RMCAR13 DC    F'0' -               RESERVED                    @ZM43085
RMCAR14  DC    H'0' -              RESERVED                    @ZM43085
RMCACIUS DC    H'0' -              COUNT OF USERS COMING IN    @Z30WIMG
RMCACPW1 DC    F'0' -              CAP WORK AREA               @Z40BPCH
RMCASRC  EQU   *    -              SWAP REASON COUNTS          @Z40BPCH
RMCATOSC DC    F'0' -              TERMINAL OUTPUT SWAP COUNT  @Z40BPCH
RMCATISC DC    F'0' -              TERMINAL INPUT SWAP COUNT   @Z40BPCH
RMCALWSC DC    F'0' -              LONG WAIT SWAP COUNT        @Z40BPCH
RMCAXSSC DC    F'0' -              AUX STOR SHORT SWAP COUNT   @Z40BPCH
RMCARSSC DC    F'0' -              REAL STOR SHORT SWAP COUNT  @Z40BPCH
RMCADWSC DC    F'0' -              DETECTED WAIT SWAP COUNT    @Z40BPCH
RMCARQSC DC    F'0' -              REQSWAP SWAP COUNT          @Z40BPCH
RMCANQSC DC    F'0' -              CAP ENQ EXCHANGE SWAP CNT   @Z40BPCH
RMCAEXSC DC    F'0' -              CAP EXCHANGE BASED ON RECOMMENDATION
*                                  VALUES SWAP COUNT           @Z40BPCH
RMCAUSSC DC    F'0' -              CAP UNILATERAL SWAP OUT CNT @Z40BPCH
*
RMCAR90  DC    F'0' -              RESERVED                    @Z40BPCH
*
RMCAEND  DS    0D -                END OF RMCA
RMCALEN  EQU   RMCAEND-RMCA -      LENGTH OF RMCA
         MEND
*                                                                    */
*%RMCAPLS2:  ;
*        %IF RMCA9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %RMCA9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %IF RMCALEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO RMCAPLS3;  /* YES, OMIT DECLARE STATEMENT   */
*   DCL
*     1 RMCA BASED(RMCAPTR) BDY(DWORD),
*            %GOTO RMCAPLS4;        /* SKIP USER-GIVEN LEVEL         */
*%RMCAPLS3:  RMCADUM = RMCALEVL||' RMCA';  /* PICK UP GIVEN LEVEL    */
*     RMCADUM BDY(DWORD),
*%RMCAPLS4:  ;
*       10 RMCANAME CHAR(4),        /* BLOCK IDENTIFICATION - 'RMCA' */
*       10 RMCAR04  FIXED(15),      /* RESERVED                      */
*       10 RMCAINUS FIXED(15),      /* COUNT OF IN-CORE USERS        */
*       10 RMCARSV1 FIXED(15),      /* RESERVED              @ZM43085*/
*        10 RMCARSV2 FIXED(15),      /* RESERVED              @ZM43085*/
*       10 RMCATQS  FIXED(32) UNSIGNED, /* SYSTEM QUIESCE TIME       */
*       10 RMCATRS  FIXED(32) UNSIGNED, /* SYSTEM RESTART TIME       */
*       10 RMCATOI  FIXED(32) UNSIGNED, /* TIME OF EXPECTD INTERRUPT */
*       10 RMCARSV3 FIXED(32) UNSIGNED, /* RESERVED          @ZM43085*/
*       10 RMCARSV4 FIXED(32) UNSIGNED, /* RESERVED          @ZM43085*/
*       10 RMCARSV5 FIXED,          /* RESERVED              @ZM43085*/
*       10 RMCAFLGS FIXED(32) BDY(WORD),/*SAVEAREA AVAIL. FLAGS
*                                                            @ZA15788*/
*          12 RMCASAAF BIT(1), /* SIXTH LVL SAVEAREA AVAIL. FLG
*                                                            @ZA15788*/
*          12 RMCARSVF BIT(31), /* RESERVED                  @ZA15788*/
*       10 RMCARSV7 FIXED(32) UNSIGNED, /* RESERVED          @ZM43085*/
*       10 RMCARSV8 FIXED(32) UNSIGNED, /* RESERVED          @ZM43085*/
*       10 RMCACHP  CHAR(4) BDY(WORD), /* CHAP LIST FOR SWAP @YM05632*/
*       10 RMCACHU  PTR(31),        /* USER CHAPPED FOR SWAP @YM05632*/
*       10 RMCARSV9 FIXED(32) UNSIGNED, /* RESERVED          @ZM43085*/
*       10 RMCAR10 FIXED(32) UNSIGNED, /* RESERVED           @ZM43085*/
*       10 RMCAINV  BIT(32) BDY(WORD), /* RTNE INVOCATION WORK AREA  */
*       10 RMCAR11 FIXED(15),       /* RESERVED             @ZM43085*/
*       10 RMCAISV  FIXED(16),      /* ISV REC. VALUE BOOST  @Z40BPCH*/
*       10 RMCALGPG PTR(8),         /* DEF LOGON PERF GRP #  @Z40BPCH*/
*       10 RMCABCPG PTR(8),         /* DEF BATCH PERF GRP #  @Z40BPCH*/
*       10 RMCAR20  FIXED(15),      /* RESERVED              @Z40BPCH*/
*       10 RMCAMAS  PTR(31),        /* ASCB ADDR FOR MASTER SCHEDULR */
*       10 RMCAWKA  CHAR(32) BDY(DWORD), /* NONRESIDENT RTN WORKAREA*/
*       10 RMCAR13 FIXED,           /* RESERVED              @ZM43085*/
*       10 RMCAR14 FIXED(15),       /* RESERVED              @ZM43085*/
*       10 RMCACIUS FIXED(15),      /* CT OF USERS COMING IN @Z30WIMG*/
*       10 RMCACPW1 PTR(31),        /* CAP WORK AREA         @Z40BPCH*/
*       10 RMCASRC,                 /* SWAP OUT REASON CNTS. @Z40BPCH*/
*          12 RMCATOSC FIXED(32),     /* TERMINAL OUTPUT SWAP COUNT
*                                                            @Z40BPCH*/
*          12 RMCATISC FIXED(32),     /* TERMINAL OUTPUT SWAP COUNT
*                                                            @Z40BPCH*/
*          12 RMCALWSC FIXED(32),     /* LONG WAIT SWAP COUNT
*                                                            @Z40BPCH*/
*          12 RMCAXSSC FIXED(32),     /* AUT STOR SHORTAGE SWAP COUNT
*                                                            @Z40BPCH*/
*          12 RMCARSSC FIXED(32),     /* REAL STOR SHORTAGE SWAP COUNT
*                                                            @Z40BPCH*/
*          12 RMCADWSC FIXED(32),     /* DETECTED WAIT SWAP COUNT
*                                                            @Z40BPCH*/
*          12 RMCARQSC FIXED(32),     /* REQSWAP SWAP COUNT  @Z40BPCH*/
*          12 RMCANQSC FIXED(32),     /* CAP ENQ EXCHANGE SWAP COUNT
*                                                           @Z40BPCH*/
*          12 RMCAEXSC FIXED(32),     /* CAP EXCHANGE BASED ON RECOMM.
*                                      VALUE SWAP COUNT     @Z40BPCH*/
*          12 RMCAUSSC FIXED(32),     /* CAP UNILATERAL SWAP OUT COUNT
*                                                           @Z40BPCH*/
*       10 RMCAR90 FIXED,             /* RESERVED           @Z40BPCH*/
*
*       10 RMCAEND  CHAR(0) BDY(DWORD)  /* END OF RMCA               */
*   RMCA9999
*   %RMCALEN = 'LENGTH(RMCA)';      /* SYMBOLIC FOR LENGTH OF RMCA   */
