CNS      TITLE 'SYSTEM RESOURCES MANAGER CONSTANTS MODULE'
IRARMCNS START
* A-000000-999999                                               @Y02133
*/** START OF SPECIFICATION **************************************** */
*/*                                                                  */
*/*  MODULE NAME - IRARMCNS  (COMPONENT - 5742-SC1CX)                */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CONSTANTS MODULE    */
*/*                                                                  */
*/*  COPYRIGHT - NONE                                                */
*/*                                                                  */
*/*  STATUS - OS/VS2 RELEASE 4, 06/16/76, LEVEL=2                    */
*/*                                                                  */
*/*  FUNCTION - PROVIDES THE PRE-ASSEMBLED TABLES USED WITHIN THE    */
*/*        SYSTEM RESOURCES MANAGER FOR DYNAMIC (NON-REFRESHABLE)    */
*/*        DATA.  CATEGORIZES THE ROUTINES INTERNAL TO THE SYSTEM    */
*/*        RESOURCES MANAGER COMPONENT.                              */
*/*                                                                  */
*/*  NOTES - THE RESOURCES MANAGER CONTROL TABLE IS FIRST IN THE     */
*/*        MODULE.  THE CPU MANAGEMENT, I/O MANAGEMENT, STORAGE      */
*/*        MANAGEMENT, AND CONTROL ALGORITHM TABLES, AND THEN THE    */
*/*        RESOURCES MANAGER (SUB)ROUTINE ENTRY POINT DESCRIPTOR     */
*/*        TABLES ARE NEXT, IN THAT ORDER, SO THAT THEY MAY ALL      */
*/*        BE ADDRESSED WITH ONE REGISTER.                           */
*/*                                                                  */
*/*    DEPENDENCIES - SYSTEM RESOURCES MANAGER INITIALIZATION TO     */
*/*          PROVIDE ADDRESSES OF DYNAMICALLY CREATED TABLES.        */
*/*                                                                  */
*/*    RESTRICTIONS - NONE                                           */
*/*                                                                  */
*/*    REGISTER CONVENTIONS - REG 2 (RMCTPTR) IS USED TO ADDRESS     */
*/*          ALL THE TABLES, UP TO AND INCLUDING THE EPST, THAT      */
*/*          FOLLOW THE RMCT WITHIN THE IRARMCNS MODULE.             */
*/*                                                                  */
*/*  MODULE TYPE - TABLE                                             */
*/*                                                                  */
*/*    PROCESSOR - ASSEMBLER XF                                      */
*/*                                                                  */
*/*    MODULE SIZE - 2K BYTES                                        */
*/*                                                                  */
*/*    ATTRIBUTES - NUCLEUS RESIDENT                                 */
*/*                 NON-EXECUTABLE                                   */
*/*                                                                  */
*/*  ENTRY POINT - N/A                                               */
*/*                                                                  */
*/*  INPUT - N/A                                                     */
*/*                                                                  */
*/*  OUTPUT - N/A                                                    */
*/*                                                                  */
*/*  EXIT - N/A                                                      */
*/*                                                                  */
*/*  EXTERNAL REFERENCES - SEE EXTERNAL SYBOL DICTIONARY FOR         */
*/*        ROUTINE NAMES OF THE FORM IRARMXXX.                       */
*/*                                                                  */
*/*  TABLES - LOCATES IRARLCT                                        */
*/*                   IRAWMST                                        */
*/*                   IRAWAMT                                        */
*/*                                                                  */
*/*  MACROS - IRARMCT                                                */
*/*           IRACCT                                                 */
*/*           IRAICT                                                 */
*/*           IRAMCT                                                 */
*/*           IRARMPT                                                */
*/*           IRARMCA                                                */
*/*           IRARMEX                                                */
*/*           IRARMSB                                                */
*/*           IRAEPDT                                                */
*/*           IRAEPAT                                                */
*/*           IRARMQH                                                */
*/*           IRAOUCB                                                */
*/*           IRAOUXB                                                */
*/*           IRARQSRV                                       @Z40BPCH*/
*/*                                                                  */
*/*  CHANGE ACTIVITY =@ZM43084,@ZA11855                              */
*/*                                                                  */
*/*  A000000-999999                                            Y02133*/
*/*                                                                  */
*/** END OF SPECIFICATION ****************************************** */
         EJECT
         IEZBITS
         EJECT
         IRARMCT   DSECT=NO
         EJECT
         IRACCT    DSECT=NO
         EJECT
         IRAICT    DSECT=NO
         EJECT
         IRAMCT    DSECT=NO
         EJECT
         IRARCT    DSECT=NO                                    @Z40BPCH
         EJECT                                                 @Z40BPCH
         IRARMPT   DSECT=NO
         EJECT
         IRARMCA   DSECT=NO
         EJECT
         IRARMEX   DSECT=NO
         EJECT
         IRARMSB   DSECT=NO
         EJECT
         IRAEPAT   DSECT=NO
         EJECT
         IRAEPDT   DSECT=NO
         EJECT
         IRAEPST   DSECT=NO
         EJECT
*
*        SYSTEM RESOURCES MANAGER TIMER-DRIVEN ENTRY POINT
*              SCHEDULING QUEUE HEADER
*
         DS    0D
IRACTMQE EQU   *
         DS    0CL32 -             QUEUE HEADER BLOCK
         DC    V(IRARMNOP) -       DUMMY ROUTINE ENTRY ADDRESS
         DC    V(IRARMNOP) -       DUMMY ROUTINE RETRY ADDRESS
         DC    X'00000000' -       DUMMY ROUTINE INVOCATION ID
         DC    C'TMQE' -           QUEUE IDENTIFICATION
         DC    A(IRACTMQE) -       QUEUE FORWARD POINTER
         DC    A(EPATSCH) -        QUEUE BCKWARD POINTER
         DC    X'FFFFFFFF' -       QUEUE ENTRY ORDERING VALUE
         DC    F'0' -              DUMMY INVOCATION INTERVAL
         EJECT
         IRARMQH   DSECT=NO,QUE=WTQE
         IRARMQH   DSECT=NO,QUE=OTQE
         IRARMQH   DSECT=NO,QUE=INQE
         IRAOUCB   DSECT=NO,LABEL=IRAOUCB
         EJECT
         IHAOUXB   DSECT=NO,LABEL=IRAOUXB
         EJECT
*
*        REQUEST SERVICE SYSEVENT(38) DATA AREA                @Z40BPCH
*
         IRARQSRV DSECT=NO                                     @Z40BPCH
         EJECT
*
*        FIELDS ADJUSTED WHENEVER TIME OF DAY INCREMENT IS CHANGED
*
IRAFLTM  DC    A(FLTMSYS)
         DC    A(FLTMUSR)
         DC    A(FLTMSAV)                                      @Z30WIMG
         LA    15,0
         USING RMCT,2
         USING OUCB,4
         USING OUXB,6
FLTMSYS  DS    0H
         DC    S(RMCATQS)
         DC    S(CCVRBSTD)
         DC    S(ICVLUTBT)
         DC    S(RMCATOI)
         DC    AL2(0)
FLTMUSR  DS    0H
         DC    S(OUCBTMA)
         DC    S(OUCBTMW)
         DC    S(OUCBTMS)
         DC    S(OUCBTMO)
         DC    S(OUCBTMP)
         DC    S(OUCBTCP)                                      @Z40BPCH
         DC    S(OUCBTIO)                                      @Z40BPCH
         DC    AL2(0)                                          @Z30WIMG
FLTMSAV  DS    0H                                              @Z30WIMG
         DC    S(OUXBNQT)
         DC    S(OUXBITD)
         DC    S(OUXBSTD)
         DC    AL2(0)
         DROP  2,4,6
         EJECT                                                 @Z30WIMG
         SPACE 1
*
*        ROUTINES WHOSE INTERVAL IS ADJUSTED BY INITIALIZATION
*
IRAEPPR  DC    A(RMEPBCL1)
         DC    A(RMEPBEQ1)
         DC    A(RMEPBCAP)                                     @Z40BPCH
         DC    A(RMEPBIL1)                                     @Z40BPCH
         DC    A(RMEPBAP1)                                     @Z40BPCH
         DC    A(RMEPBASM)                                     @Z40BPCH
         DC    A(RMEPBMS6)                                     @Z40BPCH
         DC    A(0)
         SPACE 1
*
*        RESOURCES MANAGER PREASSEMBLED SRB TABLE
*
         DS    0D
IRASRBT  EQU   *
         DC    C'SRBP'
         DC    A(0)
         DC    V(IEAMASCB)
         DC    2A(0)
         DC    V(IRARMCED)
         DC    V(IRARMSRE)
         DC    F'0'
         DC    3F'0'
         END
