IRARMCPU START
*/* A000000-999999                                           @G51CPEB*/
*/********************************************************************/
*/* MODULE NAME = IRARMCPU                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME = CPU ADJUSTMENT ARRAY                          */
*/*                                                                  */
*/* STATUS = OS/VS2 RELEASE 3.7, SU51, 2/11/77                       */
*/*                                                                  */
*/* FUNTION = THIS MODULE CONTAINS ALL OF THE SRM'S DEVICE DEPENDENT */
*/*           VARIABLES.                                             */
*/* NOTES = THIS MODULE WAS CREATED FOR THE PURPOSE OF ISOLATING ALL */
*/*         SRM'S DEVICE DEPENDENT CODE.  THE ISOLATION OF THESE     */
*/*         VARIABLES WILL LIMIT THE NUMBER OF MULTILEVEL MODULES    */
*/*         DUE TO HARDWARE SUPPORT.                                 */
*/*                                                                  */
*/* MODULE TYPE = TABLE                                              */
*/*   PROCESSOR = ASSEMBLER XF                                       */
*/*   MODULE SIZE = 72 BYTES                                         */
*/*   ATTRIBUTES = NUCLEUS RESIDENT                                  */
*/*                NON - EXECUTABLE                                  */
*/* ENTRY POINT - N/A                                                */
*/*                                                                  */
*/* INPUT - N/A                                                      */
*/*                                                                  */
*/* OUTPUT - N/A                                                     */
*/*                                                                  */
*/* EXIT - N/A                                                       */
*/*                                                                  */
*/* EXTERNAL REFERENCES - NONE                                       */
*/*                                                                  */
*/* TABLES - IRARMCMD - CPU MODEL TABLE                              */
*/*                                                                  */
*/* CHANGE ACTIVITY = @ZM48346                                       */
*/*                                                                  */
*/********************************************************************/
         ENTRY IRARMCMD
IRARMCMD DS    0D
RMCPU1   DS    0F
RMCP145M DC    AL2(X'0145')       CPU MODEL 145
RMCP145R DC    AL2(X'0000')       RESERVED
RMCP145A DC    A(1750*1024)       CPU ADJUSTMENT FACTOR
RMCPU2   DS    0F
RMCP155M DC    AL2(X'0155')       CPU MODEL 155
RMCP155R DC    AL2(X'0000')       RESERVED
RMCP155A DC    A(1000*1024)       CPU ADJUSTMENT FACTOR
RMCPU3   DS    0F
RMCP158M DC    AL2(X'0158')       CPU MODEL 158
RMCP158R DC    AL2(X'0000')       RESERVED
RMCP158A DC    A(0820*1024)       CPU ADJUSTMENT FACTOR
RMCPU4   DS    0F
RMCP165M DC    AL2(X'0165')       CPU MODEL 165
RMCP165R DC    AL2(X'0000')       RESERVED
RMCP165A DC    A(0336*1024)       CPU ADJUSTMENT FACTOR
RMCPU5   DS    0F
RMCP168M DC    AL2(X'0168')       CPU MODEL 168
RMCP168R DC    AL2(X'0000')       RESERVED
RMCP168A DC    A(0278*1024)       CPU ADJUSTMENT FACTOR
RMCPU6   DS    0F
RMC3031M DC    AL2(X'3031')       CPU MODEL 3031
RMC3031R DC    AL2(X'0000')       RESERVED
RMC3031A DC    A(0654*1024)       CPU ADJUSTMENT FACTOR
RMCPU7   DS    0F
RMC3032M DC    AL2(X'3032')       CPU MODEL 3032
RMC3032R DC    AL2(X'0000')       RESERVED
RMC3032A DC    A(0252*1024)       CPU ADJUSTMENT FACTOR     @ZM48346
RMCPU8   DS    0F
RMC3033M DC    AL2(X'3033')       CPU MODEL 3033
RMC3033R DC    AL2(X'0000')       RESERVED
RMC3033A DC    A(0160*1024)       CPU ADJUSTMENT FACTOR
RMCPU9   DS    0F
RMCPXXXM DC    AL2(X'0000')       CPU MODEL 000 INDICATES LAST ENTRY
RMCPXXXR DC    AL2(X'0000')       RESERVED
RMCPXXXA DC    A(0)               CPU ADJUSTMENT FACTOR
         END
