*        %GOTO RMCTPLS1; /*
         MACRO
         IRARMCT &DSECT=YES
         IEZBITS                                                     */
*%RMCTPLS1:  ;
* /*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRARMCT                                          */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CONTROL TABLE     */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 10/28/75, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE RMCT SERVES AS THE ORIGIN TO LOCATE SYSTEM     */
* /*         RESOURCES MANAGER TABLES AND ENTRY POINTS.  THE RMCT    */
* /*         LOCATES THE SCHEDULING / ROUTING INFORMATION USED TO    */
* /*         INVOKE THE REQUIRED PROCESSING FOR THE VARIOUS SYSTEM   */
* /*         RESOURCES MANAGER FUNCTIONS.                            */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE RMCT IS CONTAINED IN    */
* /*         THE -CVTOPCTP- FIELD OF THE CVT.                        */
* /*                                                                 */
* /*         BY CONVENTION WITHIN THE SYSTEM RESOURCES MANAGER       */
* /*         ROUTINES, REGISTER 2 IS ALWAYS RESERVED TO CONTAIN      */
* /*         THE ADDRESS OF THE RMCT.                                */
* /*                                                                 */
* /* *************************************************************** */
*        %GOTO RMCTPLS2; /*
         AGO   .RMCTAL1                                              */
* /* *************************************************************** */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*           NOTE - THE BAL FORM OF THE MACRO IS CODED WITH        */
* /*           'DC' INSTRUCTIONS, SO THAT THE MACRO MAY BE USED      */
* /*           TO ASSEMBLE THE INITIAL FIELD VALUES FOR THE          */
* /*           IRARMCNS MODULE, WHICH CONTAINS THE RMCT.             */
* /*                                                                 */
* /*         USING ON RMCT GIVES ADDRESSABILITY TO ALL SYMBOLS.      */
* /*                                                                 */
* /*     PLS - %RMCTLEVL='USERLEVL' IF THE RMCT MAPPING IS TO BE     */
* /*           CONCATENATED WITH A PREVIOUS DECLARATION, WITH THE    */
* /*           RMCT BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.    */
* /*         - %RMCT9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED.  */
* /*                                                                 */
* /*           NOTE - INASMUCH AS THE RMCT TABLE APPEARS AT THE      */
* /*           VERY BEGINNING OF THE -IRARMCNS- MODULE, ONLY A       */
* /*           STRUCTURE LEVEL OF '1' (ONE) SHOULD BE USED FOR       */
* /*           THE RMCT.                                             */
* /*                                                                 */
* /*         TO ACCESS THE RMCT AS A DECLARED STRUCTURE,             */
* /*         DCL RMCTPTR PTR.                                        */
* /*                                                                 */
* /*   CHANGE ACTIVITY = @ZM43085                                    */
* /*                     @ZA10831                                    */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
* /*
.RMCTAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').RMCTAL2
RMCT     DSECT
         AGO   .RMCTAL3
.RMCTAL2 ANOP
         DS    0D
RMCT     EQU   *
.RMCTAL3 ANOP
         SPACE 1
RMCTNAME DC    C'RMCT' -           BLOCK IDENTIFICATION
RMCTCCT  DC    A(CCT) -            CPU MANAGEMENT CONTROL TABLE
RMCTICT  DC    A(ICT) -            I/O MANAGEMENT CONTROL TABLE
RMCTMCT  DC    A(MCT) -            STORAGE MANAGEMENT CONTROL TABLE
RMCTRMPT DC    A(RMPT) -           CTL ALGORITHM PARAMETER TABLE
RMCTRMCA DC    A(RMCA) -           CTL ALGORITHM CONTROL AREA
RMCTWMST DC    A(0) -              ADDR OF WLM SPECIFICATION TABLE
RMCTRLCT DC    A(0) -              ADDR OF LOGICAL CHANNEL MGMT TABLE
RMCTRMSA DC    A(0) -              ADDR OF RESOURCES MANAGER SAVE AREA
RMCTRMPD DC    A(0) -              ADDR OF RESOURCES MANAGER PERF DATA
RMCTRMEX DC    A(RMEX) -           ROUTINE EXITING VECTOR TABLE
RMCTRMSB DC    A(RMSB) -           SUBROUTINE CALLING VECTOR TABLE
RMCTEPPA DC    A(IRAEPPA) -        PRTL ANALYSIS ENTRY TABLE
RMCTEPDT DC    A(EPDTSCN) -        USER ACTION ENTRY TABLE
RMCTEPAT DC    A(EPATSCN) -        ALGORITHM ENTRY TABLE
RMCTEPBG DC    A(EPAT) -           ADDR OF ALG ENTRY PT TABLE  @ZA10831
RMCTADJC DC    F'0' -              ADJUSTMENT FACTOR FOR CPU RATE
RMCTITT  DC    V(IRASECHT) -       INTFC EVENT CHARACTERISTICS TABLE
RMCTEPET DC    V(IRAPRCSR) -       EVENT ROUTING VECTOR TABLE
RMCTFLTM DC    A(IRAFLTM) -        TIME OF DAY ADJUST VECTOR TABLE
RMCTEPPR DC    A(IRAEPPR) -        PROCESS RATE DEPENDENT ENTRY TABLE
RMCTWAST DC    A(0) -              ADDR OF WAR SPECIFICATION TABLE
RMCTWAMT DC    A(0) -              ADDR OF WAR MEASUREMENT TABLE
RMCTTMQE DC    A(IRACTMQE) -       SCHEDULED RTNE QUEUE HEADER ADDR
RMCTAQCT DC    F'0' -              ACTION QUEUE MEMBER COUNT
RMCTAQHD DC    A(IRAOUCB) -        ACTION QUEUE FORWARD POINTER
RMCTWTQE DC    A(IRAWTQE) -        WAIT - QUEUE HEADER BLOCK ADDRESS
RMCTOTQE DC    A(IRAOTQE) -        OUT - QUEUE HEADER BLOCK ADDRESS
RMCTINQE DC    A(IRAINQE) -        IN - QUEUE HEADER BLOCK ADDRESS
RMCTR10  DC    F'0' -              RESERVED                    @Z40BPCH
RMCTTBS  DC    F'0' -              STARTING TIME BASE FOR TIME OF DAY
RMCTTOD  DC    F'0' -              TIME OF DAY - SYST RSRC MGR INVOKE
RMCTTOC  DC    D'0' -              TIME OF CENTURY - 64BIT BINARY NMB
RMCTALA  DC    4B'00000000' -      ALGORITHM REQUEST ACCUMULATOR FIELD
RMCTALR  DC    4B'00000000' -      IMMEDIATE ALGORITHM REQUEST FIELD
RMCTRQSV DC    A(RQSV) -           ADDR OF REQ SRV DATA AREA   @Z40BPCH
RMCTFLGS DC    1B'00000000' -      PROCESSING CONTROL FLAGS
RMCTMFA  EQU   BIT0 -              MEASUREMENT FACILITY ACTIVE
RMCTCPS1 EQU   BIT1                CAP SWITCH                  @Z40BPSS
RMCTINIT EQU   BIT3 -              SRM INITIALIZATION WAS PERFORMED
RMCTRSV1 EQU   BIT4 -              RESERVED                   @ZM43085
RMCTSTW  EQU   BIT5 -              SET HAS STOPPED WAR COLLECTION
RMCTRSV2 EQU   BIT6 -              RESERVED                   @ZM43085
         DC    1B'00000000' -      OVERRIDE CONDITION FLAGS
RMCTMFS  EQU   BIT1 -              MF1 ACTIVE,SET IPS RCVD    @Z40BPCH
         DC    2B'00000000' -      RESERVED
RMCTTELM DC    V(IEATSELM) -       RESOURCES MANAGER TIMING ELEMENT
RMCTCPID DC    C'RM1',X'03' -      RESOURCES MANAGER CELL POOL ID
RMCTTOCI DC    D'0' -              CLOCK READ AREA - 64BIT BINARY NMB
RMCTOUCB DC    A(IRAOUCB) -        PREASSEMBLED MODEL OUCB
RMCTOUXB DC    A(IRAOUXB) -        INTERPOSED DUMMY OUXB
RMCTSRBT DC    A(IRASRBT) -        RESOURCES MANAGER SRB TABLE
RMCTDMDT DC    A(0) -              ADDR OF DOMAIN TABLE        @Z40BPCH
RMCTDMDE DC    A(0) -              ADDR OF LAST DMN TAB ENTRY  @Z40BPCH
RMCTDMNC DC    H'0' -              NUMBER OF DOMAINS           @Z40BPCH
RMCTR50  DC    H'0' -              RESERVED                    @Z40BPCH
RMCTEND  DS    0D -                END OF RMCT
RMCTLEN  EQU   RMCTEND-RMCT -      LENGTH OF RMCT
         MEND
*                                                                    */
*%RMCTPLS2:  ;
*        %IF RMCT9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %RMCT9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %IF RMCTLEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO RMCTPLS3;  /* YES, OMIT DECLARE STATEMENT   */
*   DCL
*     1 RMCT BASED(RMCTPTR) BDY(DWORD),
*            %GOTO RMCTPLS4;        /* SKIP USER-GIVEN LEVEL         */
*%RMCTPLS3:  RMCTDUM = RMCTLEVL||' RMCT';  /* PICK UP GIVEN LEVEL    */
*     RMCTDUM BDY(DWORD),
*%RMCTPLS4:  ;
*       10 RMCTNAME CHAR(4),        /* BLOCK IDENTIFICATION - 'RMCT' */
*       10 RMCTCCT  PTR(31),        /* CPU MGMT CONTROL TABLE        */
*       10 RMCTICT  PTR(31),        /* I/O MGMT CONTROL TABLE        */
*       10 RMCTMCT  PTR(31),        /* STORAGE MGMT CONTROL TABLE    */
*       10 RMCTRMPT PTR(31),        /* CTL ALGORITHM PARAMETER TBL   */
*       10 RMCTRMCA PTR(31),        /* CTL ALGORITHM CONTROL AREA    */
*       10 RMCTWMST PTR(31),        /* WLM SPECIFICATION TABLE       */
*       10 RMCTRLCT PTR(31),        /* LOGICAL CHANNEL MGMT TABLE    */
*       10 RMCTRMSA PTR(31),        /* RESOURCES MANAGER SAVE AREA   */
*       10 RMCTRMPD PTR(31),        /* RESOURCES MANAGER PERF DATA   */
*       10 RMCTRMEX PTR(31),        /* ROUTINE EXITING VECTOR TABLE  */
*       10 RMCTRMSB PTR(31),        /* SUBRTNE CALLING VECTOR TABLE  */
*       10 RMCTEPPA PTR(31),        /* PRTL ANALYSIS ENTRY TABLE     */
*       10 RMCTEPDT PTR(31),        /* USER ACTION ENTRY TABLE       */
*       10 RMCTEPAT PTR(31),        /* ALGORITHM ENTRY TABLE         */
*       10 RMCTEPBG PTR(31),    /* BEGIN ALG ENTRY PT TABLE  @ZA10831*/
*       10 RMCTADJC FIXED,          /* CPU RATE ADJUSTMENT           */
*       10 RMCTITT  PTR(31),        /* EVENT CHARACTERISTICS TABLE   */
*       10 RMCTEPET PTR(31),        /* EVENT ROUTING VECTOR TABLE    */
*       10 RMCTFLTM PTR(31),        /* TIME OF DAY DEPENDENT TABLE   */
*       10 RMCTEPPR PTR(31),        /* PROCESS RATE DEPENDENT TABLE  */
*       10 RMCTWAST PTR(31),        /* WAR SPECIFICATION TABLE       */
*       10 RMCTWAMT PTR(31),        /* WAR MEASUREMENT TABLE         */
*       10 RMCTTMQE PTR(31),        /* SCHED RTNE QUEUE HEAD ADDR    */
*       10 RMCTAQCT FIXED BDY(DWORD), /* ACTION QUEUE MEMBER COUNT   */
*       10 RMCTAQHD PTR(31),        /* ACTION QUEUE FORWARD POINTER  */
*       10 RMCTWTQE PTR(31),        /* WAIT - QUEUE HEADER ADDRESS   */
*       10 RMCTOTQE PTR(31),        /* OUT - QUEUE HEADER ADDRESS    */
*       10 RMCTINQE PTR(31),        /* IN - QUEUE HEADER ADDRESS     */
*       10 RMCTR10 FIXED,           /* RESERVED              @Z40BPCH*/
*       10 RMCTTBS  FIXED(32) UNSIGNED, /* SRM TIME OF DAY BASE      */
*       10 RMCTTOD  FIXED(32) UNSIGNED, /* CURRENT TIME OF DAY       */
*       10 RMCTTOC  BIT(64) BDY(DWORD), /* CURR TIME OF CENTURY      */
*       10 RMCTALA  BIT(32) BDY(WORD), /* ALG REQUEST ACCUMULATOR    */
*       10 RMCTALR  BIT(32) BDY(WORD), /* IMMED ALG REQUEST ACCUMUL  */
*       10 RMCTRQSV PTR(31),        /* REQ SERVICE WORK AREA @Z40BPCH*/
*       10 RMCTFLGS BIT(32) BDY(WORD), /* PROCESSING CONTROL FLAGS   */
*         12 RMCTMFA  BIT(1),       /* MEASUREMENT FACILITY ACTIVE   */
*         12 RMCTCPS1 BIT(1),       /* CAP SWITCH            @Z40BPSS*/
*         12 RMCTF03  BIT(1),       /* RESERVED              @Z40BPSS*/
*         12 RMCTINIT BIT(1),       /* SRM INITIALIZATION DONE       */
*         12 RMCTRSV1 BIT(1),       /* RESERVED              @ZM43085*/
*         12 RMCTSTW  BIT(1),       /* SET STOPPED WAR COLLECTION    */
*         12 RMCTRSV2 BIT(1),       /* RESERVED              @ZM43085*/
*         12 RMCTF06  BIT(1),       /* RESERVED              @Z40BPCH*/
*         12 RMCTF07  BIT(1),       /* RESERVED              @Z40BPCH*/
*         12 RMCTMFS  BIT(1),       /* MF1 ACT.,SET IPS RCVD @Z40BPCH*/
*         12 RMCTF09  BIT(22),      /* RESERVED              @Z40BPCH*/
*       10 RMCTTELM PTR(31),        /* RSRC MANAGER TIMING ELEMENT   */
*       10 RMCTCPID CHAR(4) BDY(WORD), /* RSRC MANAGER CELL POOL ID  */
*       10 RMCTTOCI BIT(64) BDY(DWORD), /* TOD CLOCK READ AREA       */
*       10 RMCTOUCB PTR(31),        /* PREASSEMBLED MODEL OUCB       */
*       10 RMCTOUXB PTR(31),        /* INTERPOSED DUMMY OUXB         */
*       10 RMCTSRBT PTR(31),        /* PREBUILT SRB TABLE            */
*       10 RMCTDMDT PTR(31),        /* ADDR OF DOMAIN TABLE  @Z40BPCH*/
*       10 RMCTDMDE PTR(31),        /* ADDR OF LAST DMDT ENT @Z40BPCH*/
*       10 RMCTDMNC FIXED(15),      /* NUMBER OF DOMAINS     @Z40BPCH*/
*       10 RMCTR50 FIXED(15),       /* RESERVED              @Z40BPCH*/
*       10 RMCTEND  CHAR(0) BDY(DWORD)   /* END OF RMCT              */
*   RMCT9999
*   %RMCTLEN = 'LENGTH(RMCT)';      /* SYMBOLIC FOR LENGTH OF RMCT   */
