*        %GOTO RMPTPLS1; /*
         MACRO
         IRARMPT &DSECT=YES                                          */
*%RMPTPLS1:  ;
* /*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRARMPT                                          */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER PARAMETER TABLE   */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 08/01/75, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE RMPT CONTAINS VALUES USED BY THE SYSTEM        */
* /*         RESOURCES MANAGER CONTROL ALGORITHM TO DETERMINE        */
* /*         THE CRITERIA AND THE FREQUENCY OF SWAP ANALYSIS.        */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE RMPT IS CONTAINED       */
* /*         IN THE -RMCTRMPT- FIELD OF THE SYSTEM RESOURCES         */
* /*         MANAGER CONTROL TABLE.                                  */
* /*                                                                 */
* /* *************************************************************** */
*        %GOTO RMPTPLS2; /*
         AGO   .RMPTAL1                                              */
* /* *************************************************************** */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*           NOTE - THE BAL FORM OF THE MACRO IS CODED WITH        */
* /*           'DC' INSTRUCTIONS, SO THAT THE MACRO MAY BE USED      */
* /*           TO ASSEMBLE THE INITIAL FIELD VALUES FOR THE          */
* /*           IRARMCNS MODULE, WHICH CONTAINS THE RMPT.             */
* /*                                                                 */
* /*         USING ON RMPT GIVES ADDRESSABILITY TO ALL SYMBOLS.      */
* /*                                                                 */
* /*     PLS - %RMPTLEVL='USERLEVL' IF THE RMPT MAPPING IS TO BE     */
* /*           CONCATENATED WITH A PREVIOUS DECLARATION, WITH THE    */
* /*           RMPT BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.    */
* /*         - %RMPT9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED.  */
* /*                                                                 */
* /*         TO ACCESS AS A STANDALONE STRUCTURE, DCL RMPTPTR PTR.   */
* /*                                                                 */
* /*   CHANGE ACTIVITY = @ZM43084                                    */
* /*                     @ZM43085                                    */
* /*                     @ZM43090                                    */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
* /*
.RMPTAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').RMPTAL2
RMPT     DSECT
         AGO   .RMPTAL3
.RMPTAL2 ANOP
         DS    0D
RMPT     EQU   *
.RMPTAL3 ANOP
         SPACE 1
RMPTNAME DC    C'RMPT' -           BLOCK IDENTIFICATION
RMPTCPU  DC    F'1' -     CPU RESOURCE FACTOR COEFFICIENT @ZM43084
RMPTIOC  DC    F'1' -       I/O RESOURCE FACTOR COEFFICIENT @ZM43084
RMPTERV  DC    F'1' -              ENQ RESIDENCY CPU SERVICE VALUE
RMPTIMN  DC    F'100' -            MINIMUM FOR INTERVAL SERVICE VALUE
RMPTTCS  DC    F'81920000' -       SYSTEM CLOCK STEP TIME
RMPTTOM  DC    F'1000' -           TOLERANCE FOR TIME PERIOD   @ZM43090
RMPTTOL  DC    F'500' -            TOLERANCE FOR TIME-DRIVEN   @ZM43090
RMPTRSV1  DC    F'0' -              RESERVED                   @ZM43085
RMPTRSV2  DC    H'0' -              RESERVED                   @ZM43085
RMPTRSV3 DC    H'0'  -             RESERVED                    @ZM43085
RMPTXCHT DC    F'256' -            SWAP EXCHANGE THRESHOLD     @Z40BPCH
RMPTSAET DC    F'1000' -           SWAP ANALYSYS EVALUATION THRESHOLD
*                                  (UNSIGNED TIME VALUE)       @Z40BPCH
RMPTWMET DC    F'1000' -           WLM EVALUATION THRESHOLD    @Z40BPCH
*                                  (UNSIGNED TIME VALUE)       @Z40BPCH
RMPTCPET DC    F'1000'             CPU EVALUATION THRESHOLD    @Z40BPCH
*                                  UNSIGNED TIME VALUE         @Z40BPCH
RMPTIOET DC    F'1000'             I/0 EVALUATION THRESHOLD    @Z40BPCH
*                                  UNSIGNED TIME VALUE         @Z40BPCH
RMPTOPC  DC    CL3'0.1'            CPU RESOURCE FACTOR COEF.   @ZM43084
RMPTOPI  DC    CL3'0.1'            I/O RESOURCE FACTOR COEF.   @ZM43084
RMPTOPE  DC    CL6'000001'         ENQ RESIDENCY CPU SERV. VAL @Z40BPCH
RMPTEND  DS    0D -                END OF RMPT
RMPTLEN  EQU   RMPTEND-RMPT -      LENGTH OF RMPT
         MEND
*                                                                    */
*%RMPTPLS2:  ;
*        %IF RMPT9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %RMPT9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %IF RMPTLEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO RMPTPLS3;  /* YES, OMIT DECLARE STATEMENT   */
*   DCL
*     1 RMPT BASED(RMPTPTR) BDY(DWORD),
*            %GOTO RMPTPLS4;        /* SKIP USER-GIVEN LEVEL         */
*%RMPTPLS3:  RMPTDUM = RMPTLEVL||' RMPT';  /* PICK UP GIVEN LEVEL    */
*     RMPTDUM BDY(DWORD),
*%RMPTPLS4:  ;
*       10 RMPTNAME CHAR(4),        /* BLOCK IDENTIFICATION - 'RMPT' */
*       10 RMPTCPU  FIXED,          /* CPU RESOURCE FACTOR           */
*       10 RMPTIOC  FIXED,          /* I/O RESOURCE FACTOR           */
*       10 RMPTERV  FIXED,          /* ENQ RESIDENCE INTERVAL VALUE  */
*       10 RMPTIMN  FIXED,          /* MIN INTERVAL SERVICE VALUE    */
*       10 RMPTTCS  FIXED(32) UNSIGNED, /* SYSTEM CLOCK STEP TIME    */
*       10 RMPTTOM  FIXED(32) UNSIGNED, /* TIME DRIVEN MINIMUM
*                                          TOLERANCE         @ZM43090*/
*       10 RMPTTOL  FIXED(32) UNSIGNED, /* TIME DRIVEN INVOKE
*                                          TOLERANCE         @ZM43090*/
*       10 RMPTRSV1 FIXED(32) UNSIGNED, /* RESERVED          @ZM43085*/
*       10 RMPTRSV2 FIXED(15),      /* RESERVED              @ZM43085*/
*       10 RMPTRSV3 PTR(15),        /* RESERVED              @ZM43085*/
*       10 RMPTXCHT FIXED(31),      /* SWAP EXCHANGE THRESH. @Z40BPCH*/
*       10 RMPTSAET FIXED(32),      /* SWAP ANAL. EVALUATION THRES.  */
*                                   /* (UNSIGNED TIME VALUE) @Z40BPCH*/
*       10 RMPTWMET FIXED(32),      /* WLM EVALUATION THRESH @Z40BPCH*/
*                                   /* (UNSIGNED TIME VALUE  @Z40BPCH*/
*       10 RMPTCPET FIXED(32),      /* CPU EVALUATION THRESHOLD
*                                     UNSIGNED TIME VALUE    @Z40BPCH*/
*       10 RMPTIOET FIXED(32),       /* I/0 EVALUATION THRESHOLD
*                                        UNSIGNED TIME VALUE @Z40BPCH*/
*       10 RMPTOPC CHAR(3),         /* CPU RESOURCE FACTOR   @Z40BPCH*/
*                                   /* COEFFICIENT           @Z40BPCH*/
*       10 RMPTOPI CHAR(3),         /* I/O RESOURCE FACTOR   @Z40BPCH*/
*                                   /* COEFFICIENT           @Z40BPCH*/
*       10 RMPTOPE CHAR(6),         /* ENQ RES CPU SERV VALU @Z40BPCH*/
*       10 RMPTEND  CHAR(0) BDY(DWORD)   /* END OF RMPT              */
*   RMPT9999
*   %RMPTLEN = 'LENGTH(RMPT)';      /* SYMBOLIC FOR LENGTH OF RMPT   */
