*        %GOTO RQSVPLS1; /*
         MACRO
         IRARQSRV &DSECT=YES                                         */
*%RQSVPLS1:  ;
* /*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRARQSRV                                         */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - REQUEST SERVICE STORAGE AREA               */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 04/07/76, LEVEL=2                  */
* /*                                                                 */
* /*   FUNCTION - THE RQSV PROVIDES A STORAGE AREA TO TEMPORARILY    */
* /*         SAVE INFORMATION GATHERED BY SYSEVENT 49 SO THAT IT CAN */
* /*         LATER STORE IT INTO SMF AREA UNDER A DIFFERENT KEY.     */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE RQSV IS CONTAINED IN    */
* /*         THE -RMCTRQSV- FIELD OF THE SYSTEM RESOURCES MANAGER    */
* /*         CONTROL TABLE.                                          */
* /*                                                                 */
* /* *************************************************************** */
*        %GOTO RQSVPLS2; /*
         AGO   .RQSVAL1                                              */
* /* *************************************************************** */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*         USING ON RQSV GIVES ADDRESSABILITY TO ALL SYMBOLS.      */
* /*                                                                 */
* /*     PLS - %RQSVLEVL='USERLEVL' IF THE RQSV MAPPING IS TO BE     */
* /*           CONCATENATED WITH A PREVIOUS DECLARATION, WITH THE    */
* /*           RQSV BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.    */
* /*         - %RQSV9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED.  */
* /*                                                                 */
* /*         TO ACCESS AS A STANDALONE STRUCTURE DCL RQSVPTR PTR.    */
* /*                                                                 */
* /*   CHANGE ACTIVITY =                                             */
* /*                                                                 */
* /*   A000000-999999                                        @Z40BPEB*/
* /*                                                                 */
* /* *************************************************************** */
* /*
.RQSVAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').RQSVAL2
RQSV     DSECT
         AGO   .RQSVAL3
.RQSVAL2 ANOP
         DS    0D
RQSV     EQU   *
.RQSVAL3 ANOP
         SPACE 1
RQSVDATA DS    0F                 STORAGE FOR EVENT 49      @ZM43092
         ORG   RQSVDATA                                     @ZM43092
RQSVSRV  DS    F -                 TRANSACTION SERVICE
RQSVTIM  DS    F -                 TRANSACTION ACTIVE TIME
RQSVPGSC DS    F -                 PGN AND TRANSACTION COUNT
RQSVSRT  DS    F -                 SESSION RESIDENCY TIME
RQSVRSV  DS    F -                 RESERVED FOR FUTURE
RQSVEND  DS    0D -                END OF RQSV
RQSVLEN  EQU   RQSVEND-RQSV -      LENGTH OF RQSV
         MEND
*                                                                    */
*%RQSVPLS2:  ;
*        %IF RQSV9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %RQSV9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %IF RQSVLEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO RQSVPLS3;  /* YES, OMIT DECLARE STATEMENT   */
*   DCL
*     1 RQSV BASED(RQSVPTR) BDY(WORD),
*            %GOTO RQSVPLS4;        /* SKIP USER-GIVEN LEVEL         */
*%RQSVPLS3:  RQSVDUM = RQSVLEVL||' RQSV';  /* PICK UP GIVEN LEVEL    */
*     RQSVDUM BDY(WORD),
*%RQSVPLS4:  ;
*     5  RQSVDATA CHAR(16) BDY(WORD),  /* SMF DATA AREA      @ZM43092*/
*      10 RQSVSRV FIXED(31),     /* TOTAL TRANSACTION SERVICE     */
*      10 RQSVTIM FIXED(31),     /* TRANSACTION ACTIVE TIME       */
*       10 RQSVPGSC CHAR(4) BDY(WORD), /* PGN AND TRANSACTION COUNT */
*          15 RQSVPGN FIXED(15),   /* PEFORMANCE GROUP NUMBER     */
*          15 RQSVTRC FIXED(15),   /* TRANSACTION COUNT           */
*       10 RQSVSRT FIXED(31),      /* SESSION RESIDENCY TIME      */
*     5    RQSVRSV FIXED(31),         /* RESERVED                 */
*     5    RQSVEND CHAR(0)            /* END OF STORAGE AREA         */
*   RQSV9999
*   %RQSVLEN = 'LENGTH(RQSV)';      /* SYMBOLIC FOR LENGTH OF RQSV   */
