*        %GOTO WMSTPLS1; /*
         MACRO
         IRAWMST &DSECT=YES                                          */
*%WMSTPLS1:  ;
* /*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRAWMST                                          */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - WORKLOAD MANAGER SPECIFICATION TABLE       */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 09/17/75, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE WMST COMBINES IN A SINGLE TABLE THE INFORMA-   */
* /*         TION REQUIRED BY THE VARIOUS ROUTINES WHICH REFERENCE   */
* /*         THE INSTALLATION PERFORMANCE SPECIFICATION.  THE WMST   */
* /*         RESIDES IN SQA, AND IS DYNAMICALLY CONSTRUCTED DURING   */
* /*         SYSTEM INITIALIZATION, AND DURING SET IPS PROCESSING.   */
* /*         THE IPS USED BY THE  SYSTEM RESOURCES MANAGER  MAY BE   */
* /*         CHANGED BY SIMPLY SUBSTITUTING THE ADDRESS OF THE NEW   */
* /*         WMST INTO -RMCTWMST-.                                   */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE WMST IS CONTAINED IN    */
* /*         THE -RMCTWMST- FIELD OF THE SYSTEM RESOURCES MANAGER    */
* /*         CONTROL TABLE.                                          */
* /*                                                                 */
* /* *************************************************************** */
*        %GOTO WMSTPLS2; /*
         AGO   .WMSTAL1                                              */
* /* *************************************************************** */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*         USING ON WMST GIVES ADDRESSABILITY TO ALL SYMBOLS.      */
* /*                                                                 */
* /*     PLS - %WMSTLEVL='USERLEVL' IF THE WMST MAPPING IS TO BE     */
* /*           CONCATENATED WITH A PREVIOUS DECLARATION, WITH THE    */
* /*           WMST BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.    */
* /*         - %WMST9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED.  */
* /*                                                                 */
* /*         TO ACCESS AS A STANDALONE STRUCTURE DCL WMSTPTR PTR.    */
* /*                                                                 */
* /*   CHANGE ACTIVITY =@ZM43084                                     */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
* /*
.WMSTAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').WMSTAL2
WMST     DSECT
         AGO   .WMSTAL3
.WMSTAL2 ANOP
         DS    0D
WMST     EQU   *
.WMSTAL3 ANOP
         SPACE 1
WMSTNAME DS    C'WMST' -           TABLE IDENTIFICATION
WMSTID   DS    CL2 -               PERF. SPECIFICATION IDENTIFIER
WMSTWLLO DS    H -                 LOWEST WORKLOAD LEVEL SPECIFIED
WMSTPGVT DS    A -                 PERF GROUP VECTOR TABLE ADDRESS
WMSTPGVS DS    F -                 PERF GROUP VECTOR TABLE SIZE
WMSTPGDT DS    A -                 FIRST PERF GROUP DESCRIPTOR ADDRESS
WMSTPGDS DS    F -                 TOTAL PERF GROUP DESCRIPTOR SIZE
WMSTPOVT DS    A -                 PERF OBJECTIVE VECTOR TABLE ADDRESS
WMSTPOVS DS    F -                 PERF OBJECTIVE VECTOR TABLE SIZE
WMSTPODT DS    A -                 1ST PERF OBJECTIVE DESCRIPT ADDRESS
WMSTPODS DS    F -                 TOT PERF OBJECTIVE DESCRIPT SIZE
WMSTDMDT DS    A -                 FIRST DOMAIN DESCRIPTR ADDR @Z40BPCH
WMSTDMDS DS    F -                 TOT DOMAIN DESCRIPTOR SIZE  @Z40BPCH
WMSTDMVT DS    A -                 DOMAIN VECTOR TABLE ADDR    @Z40BPCH
WMSTDMVS DS    F -                 DOMAIN VECTOR TABLE SIZE    @Z40BPCH
WMSTDMDE DS    A -                 DMN TABLE LAST ENTRY ADDR   @Z40BPCH
WMSTWLHI DS    H -                 HIGHEST WORKLOAD LEVEL SPEC @Z40BPCH
WMSTPGHI DS    H -                 HIGHEST PERF GROUP NUMBER
WMSTPGPC DS    H -                 TOTAL COUNT OF PERF GROUP PERIODS
WMSTDMNC DS    H -                 TOTAL DOMAIN COUNT          @Z40BPCH
WMSTCPU  DS    F -                 CPU SERVICE COEFFICIENT
WMSTIOC  DS    F -                 IOC SERVICE COEFFICIENT
WMSTMSO  DS    F -                 MSO SERVICE COEFFICIENT
WMSTREAL DS    CL1                 REAL TIME INDICATOR        @ZM43084
WMSTRSVD DS    CL3                 RESERVED                   @ZM43084
WMSTSET  DS    A -                 SET IPS PROCESSOR ROUTINE ADDRESS
WMSTSTCB DS    A -                 SET IPS PROCESSOR TASK ADDRESS
WMSTNWST DS    A -                 SET IPS PROCESSOR NXT WMST ADDRESS
WMSTSECB DS    F -                 ECB FOR SET IPS PROCESSOR
WMSTIPC  DS    CL4 -               CPU SERVICE COEFICIENT      @Z40BPCH
WMSTIPI  DS    CL4 -               I/O SERVICE COEFFICIENT     @Z40BPCH
WMSTIPM  DS    CL4 -               MSO SERVICE COEFFICIENT     @Z40BPCH
WMSTEND  DS    0D -                END OF WMST
WMSTLEN  EQU   WMSTEND-WMST -      LENGTH OF WMST
         MEND
*                                                                    */
*%WMSTPLS2:  ;
*        %IF WMST9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %WMST9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %IF WMSTLEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO WMSTPLS3;  /* YES, OMIT DECLARE STATEMENT   */
*   DCL
*     1 WMST BASED(WMSTPTR) BDY(DWORD),
*            %GOTO WMSTPLS4;        /* SKIP USER-GIVEN LEVEL         */
*%WMSTPLS3:  WMSTDUM = WMSTLEVL||' WMST';  /* PICK UP GIVEN LEVEL    */
*     WMSTDUM BDY(DWORD),
*%WMSTPLS4:  ;
*       10 WMSTNAME CHAR(4),        /* TABLE IDENTIFICATION - 'WMST' */
*       10 WMSTID   CHAR(2) BDY(WORD), /* PERF SPECIFICATION ID      */
*       10 WMSTWLLO FIXED(15),      /* LOWEST WORKLOAD LEVEL SPEC'D  */
*       10 WMSTPGVT PTR(31),        /* PERF GRP VECTOR TABLE ADDR    */
*       10 WMSTPGVS FIXED,          /* PERF GRP VECTOR TABLE SIZE    */
*       10 WMSTPGDT PTR(31),        /* 1ST PERF GRP DESCRIPTOR ADDR  */
*       10 WMSTPGDS FIXED,          /* TOT PERF GRP DESCRIPTOR SIZE  */
*       10 WMSTPOVT PTR(31),        /* PERF OBJ VECTOR TABLE ADDR    */
*       10 WMSTPOVS FIXED,          /* PERF OBJ VECTOR TABLE SIZE    */
*       10 WMSTPODT PTR(31),        /* 1ST PERF OBJ DESCRIPTOR ADDR  */
*       10 WMSTPODS FIXED,          /* TOT PERF OBJ DESCRIPTOR SIZE  */
*       10 WMSTDMDT PTR(31),        /* FIRST DMN DESC ADDR   @Z40BPCH*/
*       10 WMSTDMDS FIXED(31),      /* TOT DOMAIN DESC SIZE  @Z40BPCH*/
*       10 WMSTDMVT PTR(31),        /* DMN VECTOR TABLE ADDR @Z40BPCH*/
*       10 WMSTDMVS FIXED(31),      /* DMN VECTOR TABLE SIZE @Z40BPCH*/
*       10 WMSTDMDE PTR(31),        /* DMN TAB LAST NTRY ADR @Z40BPCH*/
*       10 WMSTWLHI FIXED(15),      /* HIGHEST WORKLD LEV SP @Z40BPCH*/
*       10 WMSTPGHI FIXED(15),      /* HIGH PERF GROUP NUMBER        */
*       10 WMSTPGPC FIXED(15),      /* TOTL PERF GROUP PERIOD COUNT  */
*       10 WMSTDMNC FIXED(15),      /* TOT DOMAIN COUNT      @Z40BPCH*/
*       10 WMSTCPU  FIXED,          /* CPU SERVICE COEFFICIENT       */
*       10 WMSTIOC  FIXED,          /* IOC SERVICE COEFFICIENT       */
*       10 WMSTMSO  FIXED,          /* MSO SERVICE COEFFICIENT       */
*       10 WMSTREAL FIXED(8),       /* REAL TIME INDICATOR   @ZM43084*/
*       10 WMSTRSVD FIXED(24),      /* RESERVED              @ZM43084*/
*       10 WMSTSET  PTR(31),        /* SET PROCS ROUTINE ADDR        */
*       10 WMSTSTCB PTR(31),        /* SET PROCS TASK ADDRESS        */
*       10 WMSTNWST PTR(31),        /* SET PROCS NXT WMST ADR        */
*       10 WMSTSECB CHAR(4) BDY(WORD), /* SET PROCS ECB              */
*       10 WMSTIPC CHAR(4) BDY(WORD), /* CPU SERVICE COEF.   @Z40BPCH*/
*       10 WMSTIPI CHAR(4) BDY(WORD), /* I/O SERVICE COEF.   @Z40BPCH*/
*       10 WMSTIPM CHAR(4) BDY(WORD), /* MSO SERVICE COEF.   @Z40BPCH*/
*       10 WMSTEND  CHAR(0) BDY(DWORD)   /* END OF WMST              */
*   WMST9999
*   %WMSTLEN = 'LENGTH(WMST)';      /* SYMBOLIC FOR LENGTH OF WMST   */
