*        %GOTO WPGDPLS1; /*
         MACRO
         IRAWPGDT  &DSECT=YES
         IEZBITS                                                     */
*%WPGDPLS1:  ;
* /*                                                                 */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRAWPGDT                                         */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - PERFORMANCE GROUP TABLE DESCRIPTION        */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 4, 07/30/75, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE WPGD PROVIDES THE DESCRIPTION OF HOW SERVICE   */
* /*         OBJECTIVES ARE ASSOCIATED TO GIVEN USER TRANSACTIONS    */
* /*         AT VARIOUS PERIODS OF THEIR EXISTENCE.  IT ALSO KEEPS   */
* /*         A HISTORY OF THE RATE OF UTILIZATION OF RESOURCES BY    */
* /*         THE TRANSACTIONS.                                       */
* /*                                                                 */
* /*         THE WPGP'S, WHICH ARE LISTED SEQUENTIALLY IN THE WPGD,  */
* /*         DEFINE PERIODS OF PROCESSING OR OF TIME, AND INDICATE   */
* /*         THE PERFORMANCE OBJECTIVES (I.E. - THE SERVICE RATES),  */
* /*         AND THE RESIDENCY INTERVALS, TO BE APPLIED.             */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE WPGD FOR A PARTICULAR   */
* /*         SYSTEM USER IS OBTAINED BY ADDING THE OFFSET IN THE     */
* /*         -OUCBWMG- FIELD OF THE SYSTEM RESOURCES MANAGER USER    */
* /*         CONTROL BLOCK TO THE ADDRESS IN THE -WMSTPGDT- FIELD    */
* /*         OF THE WORKLOAD MANAGER SPECIFICATION TABLE.            */
* /*                                                                 */
* /*         THE ADDRESS OF THE CURRENT WPGP IS OBTAINED BY ADDING   */
* /*         THE OFFSET IN THE -OUCBPGP- FIELD TO THE ADDRESS OF     */
* /*         THE WPGD.  THE ADDRESS OF A PARTICULAR WPGL VALUE IS    */
* /*         ALSO OBTAINED BY ADDING ITS INDICATED OFFSET TO THE     */
* /*         ADDRESS OF THE WPGD.                                    */
* /*                                                                 */
* /* *************************************************************** */
*        %GOTO WPGDPLS2; /*
         AGO   .WPGDAL1                                              */
* /* *************************************************************** */
* /*                                                                 */
* /*   CONSTRUCTION METHOD - THE ADDRESS OF THE 1ST WPGD IS PLACED   */
* /*         IN THE -WMSTPGDT- FIELD OF THE WORKLOAD MANAGER SPECI-  */
* /*         FICATION TABLE.  THE OFFSET TO THE WPGD FOR A GIVEN     */
* /*         PERFORMANCE GROUP NUMBER IS PLACED IN THE -WPGVTENT-    */
* /*         FIELD OF THE CORRESPONDING (NUMBERED) ENTRY IN THE      */
* /*         WORKLOAD MANAGER PERFORMANCE GROUP VECTOR TABLE.        */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*         USING ON WPGD GIVES ADDRESSABILITY TO WPGD SYMBOLS.     */
* /*         USING ON WPGP GIVES ADDRESSABILITY TO WPGP SYMBOLS.     */
* /*         USING ON WPGL GIVES ADDRESSABILITY TO WPGL SYMBOLS.     */
* /*                                                                 */
* /*     PLS - %WPGDLEVL='USERLEVL' IF THE WPGD MAPPING IS TO BE     */
* /*           CONCATENATED WITH A PREVIOUS DECLARATION, WITH THE    */
* /*           WPGD BEING ASSIGNED THE INDICATED STRUCTURE LEVEL.    */
* /*         - %WPGD9999=',' IF THE STRUCTURE SHOULD NOT BE CLOSED.  */
* /*                                                                 */
* /*         TO ACCESS AS A SET OF STANDALONE STRUCTURES,            */
* /*         DECLARE  WPGDPTR PTR FOR THE WPGD,                      */
* /*                  WPGPPTR PTR FOR THE WPGP,                      */
* /*                  WPGLPTR PTR FOR THE WPGL.                      */
* /*                                                                 */
* /*   CHANGE ACTIVITY =                                             */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
* /*
.WPGDAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').WPGDAL2
WPGD     DSECT
         AGO   .WPGDAL3
.WPGDAL2 ANOP
         DS    0F
WPGD     EQU   *
.WPGDAL3 ANOP
         SPACE 1
WPGDPGN  DS    AL1 -               PERFORMANCE GROUP NUMBER
WPGDSIZ  DS    AL1 -               PERFORMANCE GROUP DESCRIPTOR SIZE-1
WPGDR02  DS    CL1 -               RESERVED
WPGDDFL  DS    CL1 -               PERFORMANCE GROUP DESCRIPTIVE FLAGS
WPGDVLD  EQU   BIT0 -              VALID PERFORMANCE GROUP IN NEW IPS
WPGDATM  DS    F -                 AVG TIME TO ABSORB ISV SERVICE AMT
WPGDISV  DS    F -                 PERFM GRP INTERVAL SERVICE VALUE
WPGDPGP  DS    0F -                1ST PERIOD ENTRY FOR PERFM GROUP
WPGDOBJN DS    AL1 -               PG PERIOD PERFORMANCE OBJECTIVE NO.
WPGDDMN  DS    AL1 -               PG PERIOD DOMAIN NO.        @Z40BPCH
         DS    CL2 -               RESERVED                    @Z40BPCH
WPGDAPGV DS    CL1 -               APG VALUE IF SPECIFIED      @Z40BPCH
WPGDINDS DS    CL1 -               PG PERIOD DESCRIPTIVE INDICATORS
WPGDFIN  EQU   BIT0 -              FINAL PERFORMANCE GROUP PERIOD
WPGDUNT  EQU   BIT1 -              PG PERIOD DURATION IS IN REAL TIME
WPGDAPG  EQU   BIT2 -              APG VALUE SPECIFIED      @Z40BPCH
WPGDRTB  EQU   BIT7 -              PG PERIOD RESPONSE/THROUGHPUT BIAS
WPGDISVP DS    AL1 -               PGP INTERVAL SERVICE VALUE OFFSET
WPGDDURP DS    AL1 -               PGP DURATION VALUE OFFSET IN WPGD
WPGDPGL  DS    0F -                START OF POSSIBLE WPGD EXTENSION
WPGDEND  DS    0F -                END OF WPGD
WPGDLEN  EQU   WPGDEND-WPGD -      LENGTH OF WPGD
         AIF   ('&DSECT' EQ 'NO').WPGDAL4
         SPACE 1
WPGP     DSECT
         SPACE 1
WPGPOBJN DS    AL1 -               PERFORMANCE OBJECTIVE NUMBER
WPGPDMN  DS    AL1 -               DOMAIN NUMBER               @Z40BPCH
         DS    CL2 -               RESERVED                    @Z40BPCH
WPGPAPGV DS    CL1 -               APG VALUE IF SPECIFIED      @Z40BPCH
WPGPINDS DS    CL1 -               PERIOD DESCRIPTIVE INDICATORS
WPGPFIN  EQU   BIT0 -              FINAL PERIOD FOR PERFORMANCE GROUP
WPGPUNT  EQU   BIT1 -              PERIOD DURATION IS IN REAL TIME
WPGPAPG  EQU   BIT2 -              APG VALUE SPECIFIED     @Z40BPCH
WPGPRTB  EQU   BIT7 -              PERIOD RESPONSE/THROUGHPUT BIAS
WPGPISVP DS    AL1 -               INTERVAL SERVICE VALUE OFFSET
WPGPDURP DS    AL1 -               PERIOD DURATION VALUE OFFSET
WPGPEND  DS    0F -                END OF WPGP
WPGPLEN  EQU   WPGPEND-WPGP -      LENGTH OF WPGP
         SPACE 1
WPGL     DSECT
         SPACE 1
WPGLISV  DS    0F -                INTERVAL SERVICE VALUE FOR A PERIOD
WPGLDUR  DS    0F -                PERIOD DURATION VALUE FOR A PERIOD
         DS    F -                 SPECIFIED VALUE STORAGE AREA
WPGLEND  DS    0F -                END OF WPGL
WPGLLEN  EQU   WPGLEND-WPGL -      LENGTH OF WPGL
.WPGDAL4 ANOP
         MEND
*                                                                    */
*%WPGDPLS2:  ;
*        %IF WPGD9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %WPGD9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %IF WPGDLEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO WPGDPLS3;  /* YES, OMIT DECLARE STATEMENT   */
*   DCL
*     1 WPGD BASED(WPGDPTR) BDY(WORD),
*            %GOTO WPGDPLS4;        /* SKIP USER-GIVEN LEVEL         */
*%WPGDPLS3:  WPGDDUM = WPGDLEVL||' WPGD';  /* PICK UP GIVEN LEVEL    */
*     WPGDDUM BDY(WORD),
*%WPGDPLS4:  ;
*       10 WPGDPGN  PTR(08),        /* PERFORMANCE GROUP NUMBER      */
*       10 WPGDSIZ  PTR(08),        /* PERF GROUP DESCRIPTOR SIZE-1  */
*       10 WPGDR02  FIXED(08),      /* RESERVED                      */
*       10 WPGDDFL  BIT(8),         /* PERF GROUP DESCRIPTIVE FLAGS  */
*         12 WPGDVLD BIT(1),        /* VALID PERF GROUP IN NEW IPS   */
*         12 WPGDRD1 BIT(7),        /* RESERVED                      */
*       10 WPGDATM  FIXED(32) UNSIGNED, /* TIME TO ABSORB ISV SERVIC */
*       10 WPGDISV  FIXED,          /* BASE ISV SERVICE FOR PERF GRP */
*       10 WPGDPGP  CHAR(8) BDY(WORD), /* 1ST PGP ENTRY FOR PERF GRP
*                                                           @Z40BPCH*/
*         12 WPGDOBJN PTR(8),       /* PGP PERFORMANCE OBJECTIVE NO. */
*         12 WPGDDMN PTR(8),        /* PGP DOMAIN NO.       @Z40BPCH */
*         12 * CHAR(2) BDY(HWORD),  /* RESERVED             @Z40BPCH */
*         12 WPGDAPGV PTR(8),       /* APG VALUE IF SPEC    @Z40BPCH */
*         12 WPGDINDS BIT(8),       /* PERF GRP PERIOD INDICATORS    */
*           14 WPGDFIN BIT(1),      /* FINAL PERF GROUP PERIOD       */
*           14 WPGDUNT BIT(1),      /* PGP DURATION IS IN REAL TIME  */
*           14 WPGDAPG BIT(1),      /*  APG VALUE SPECIFEID @Z40BPCH */
*           14 WPGDRB2 BIT(4),      /* RESERVED                      */
*           14 WPGDRTB BIT(1),      /* PGP RESPONSE/THROUGHPUT BIAS  */
*         12 WPGDISVP PTR(8),       /* PGP INTVL SERV VALUE OFFSET   */
*         12 WPGDDURP PTR(8),       /* PGP DURATION OFFSET IN WPGD   */
*       10 WPGDPGL  CHAR(0) BDY(WORD), /* BEGIN FIXED(31) DUR OR ISV */
*       10 WPGDEND  CHAR(0) BDY(WORD)  /* END OF WPGD                */
*        %IF WPGDLEVL ^= ''         /* IS STRUCTURE CONCATENATED     */
*            %THEN %GOTO WPGDPLS5;  /* YES, OMIT WPGP STANDALON SPEC */
*   ,
*     1 WPGP BASED(WPGPPTR) BDY(WORD), /* PERFORMANCE PERIOD ENTRY   */
*       10 WPGPOBJN PTR(8),         /* PERFORMANCE OBJECTIVE NUMBER  */
*       10 WPGPDMN PTR(8),          /* DOMAIN NUMBER        @Z40BPCH */
*       10 * CHAR(2) BDY(HWORD),    /* RESERVED             @Z40BPCH */
        10 WPGPAPGV PTR(8),         /* APG VALUE IF SPEC.   @Z40BPCH */
*       10 WPGPINDS BIT(8),         /* PERIOD DESCRIPTIVE INDICATORS */
*         12 WPGPFIN BIT(1),        /* FINAL PERIOD FOR PERF GROUP   */
*         12 WPGPUNT BIT(1),        /* PERIOD DURATION IS REAL TIME  */
*         12 WPGPAPG BIT(1),        /* APG VALUE SPECIFIED  @Z40BPCH */
*         12 WPGPRB2 BIT(4),        /* RESERVED                      */
*         12 WPGPRTB BIT(1),        /* PERIOD RESPONSE/THRUPUT BIAS  */
*       10 WPGPISVP PTR(8),         /* PERIOD INTVL SERV VALU OFFSET */
*       10 WPGPDURP PTR(8),         /* PERIOD DURATN OFFSET IN WPGD  */
*       10 WPGPEND  CHAR(0) BDY(WORD)  /* END OF WPGP                */
*   ,
*     1 WPGL BASED(WPGLPTR) BDY(WORD), /* SPECIFIED VALUE STORE AREA */
*       10 WPGLISV  FIXED(31),      /* INTVL SERV VALUE FOR ANY PGP  */
*         12 WPGLDUR  FIXED(32) UNSIGNED, /* DURATN VLU FOR ANY PGP  */
*       10 WPGLEND  CHAR(0) BDY(WORD)  /* END OF WPGL                */
*   %WPGPLEN = 'LENGTH(WPGP)';      /* SYMBOLIC FOR LENGTH OF WPGP   */
*   %WPGLLEN = 'LENGTH(WPGL)';      /* SYMBOLIC FOR LENGTH OF WPGL   */
*%WPGDPLS5:  ;
*   WPGD9999
*   %WPGDLEN = 'LENGTH(WPGD)';      /* SYMBOLIC FOR LENGTH OF WPGD   */
