*%;  /*
         MACRO
         IRAWPODT  &DSECT=YES
         AGO   .WPODAL0                                              */
*@       LIST  PUSH;                /* SAVE LISTING STATUS FOR WPOD  */
*        %IF WPODSFX = ''           /* IS NAMING CHARACTER OMITTED   */
*            %THEN %WPODSFX = ' ';  /* YES, INSERT PLACEHOLDER BLANK */
*        %IF WPODSFX ^= ' '         /* IS THIS THE DUPLICATE INCLUDE */
*            %THEN %WPODDUM = '@       LIST  OFF '; /* BYP INTRO CMT */
*        %ELSE     %WPODDUM = '@       LIST  PUSH'; /* DMY CNTRL CMT */
*WPODDUM;
*        %IF WPODSFX = ' '          /* IS THIS  THE FIRST INCLUDE    */
*            %THEN %WPODDUM = '@       LIST  POP '; /* PRT INTRO CMT */
*WPODDUM;
*%;  /*
.WPODAL0 ANOP                                                        */
* /* MACCOMP Z-4 SC1CX/PKD16                                         */
* /* MACSTAT Z-4 75007/Z40BPSS                                       */
* /* *************************************************************** */
* /*                                                                 */
* /*   MACRO NAME - IRAWPODT                                         */
* /*                                                                 */
* /*   DESCRIPTIVE NAME - PERFORMANCE OBJECTIVE TABLE DESCRIPTION    */
* /*                                                                 */
* /*   COPYRIGHT - NONE                                              */
* /*                                                                 */
* /*   STATUS - OS/VS2 RELEASE 2, 04/05/73, LEVEL=1                  */
* /*                                                                 */
* /*   FUNCTION - THE WPOD SPECIFIES, AS A FUNCTION OF THE SYSTEM    */
* /*         WORKLOAD, THE RATES AT WHICH RESOURCES ARE TO BE MADE   */
* /*         AVAILABLE TO USER TRANSACTIONS.  ACTUAL SERVICE RATES   */
* /*         ARE APPLIED TO THE WPOD'S TO CALCULATE THE EQUIVALENT   */
* /*         WORKLOAD LEVELS, WHOSE COMPARISON THEN INDICATES WHICH  */
* /*         TRANSACTIONS ARE 'BEHIND' OR 'AHEAD' OF THE REST.       */
* /*                                                                 */
* /*         THE WPOD TO BE USED FOR A TRANSACTION IS INDICATED BY   */
* /*         THE -WPGPOBJN- FIELD OF THE CURRENT PERIOD WITHIN THE   */
* /*         APPLICABLE PERFORMANCE GROUP DESCRIPTION.               */
* /*                                                                 */
* /*   METHOD OF ACCESS - THE ADDRESS OF THE WPOD FOR A PARTICULAR   */
* /*         SYSTEM USER IS OBTAINED BY ADDING THE OFFSET IN THE     */
* /*         -OUCBWMO- FIELD OF THE SYSTEM RESOURCES MANAGER USER    */
* /*         CONTROL BLOCK TO THE ADDRESS IN THE -WMSTPODT- FIELD    */
* /*         OF THE WORKLOAD MANAGER SPECIFICATION TABLE.            */
* /*                                                                 */
* /* *************************************************************** */
*%;  /*
         AGO   .WPODAL1                                              */
*@       LIST  OFF;                 /* BYPASS EXPLANATORY COMMENTS   */
* /* *************************************************************** */
* /*                                                                 */
* /*   CONSTRUCTION METHOD - THE ADDRESS OF THE 1ST WPOD IS PLACED   */
* /*         IN THE -WMSTPODT- FIELD OF THE WORKLOAD MANAGER SPECI-  */
* /*         FICATION TABLE.  THE OFFSET TO THE WPOD FOR A GIVEN     */
* /*         PERFORMANCE OBJECTIVE NO. IS PLACED IN THE -WPOVTENT-   */
* /*         FIELD OF THE CORRESPONDING (NUMBERED) ENTRY IN THE      */
* /*         WORKLOAD MANAGER PERFORMANCE OBJECTIVE VECTOR TABLE.    */
* /*                                                                 */
* /*   INVOCATION PARAMETERS AND/OR KEYWORDS =                       */
* /*                                                                 */
* /*     BAL - DSECT=NO IF DSECT IS NOT TO BE PRODUCED.              */
* /*                                                                 */
* /*         USING ON WPOD GIVES ADDRESSABILITY TO WPOD SYMBOLS.     */
* /*                                                                 */
* /*     PLS - %WPODSFX='USERCHAR' IF THE INDICATED CHARACTER IS     */
* /*           TO BE APPENDED TO ALL NAMES IN THE MAPPING, THEREBY   */
* /*           CREATING DUPLICATE DEFINITIONS BASED ON DIFFERENT     */
* /*           POINTERS.                                             */
* /*                                                                 */
* /*           NOTE - DUE TO THE FACILITY WHICH PERMITS MULTIPLE     */
* /*           INCLUDES OF THE IRAWPODT MAPPING MACRO, IT IS NOT     */
* /*           POSSIBLE TO CONCATENATE THE IRAWPODT DECLARATION      */
* /*           WITH ANOTHER DECLARATION IN SUCH A FASHION THAT       */
* /*           BOTH DECLARATIONS ARE BASED ON THE SAME POINTER.      */
* /*                                                                 */
* /*         TO ACCESS AS A STANDALONE STRUCTURE DCL WPODPTR PTR.    */
* /*                                                                 */
* /*   CHANGE ACTIVITY =                                             */
* /*                                                                 */
* /*   A000000-999999                                          Y02133*/
* /*                                                                 */
* /* *************************************************************** */
*%;  /*
.WPODAL1 ANOP
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').WPODAL2
WPOD     DSECT
         AGO   .WPODAL3
.WPODAL2 ANOP
         DS    0H
WPOD     EQU   *
.WPODAL3 ANOP
         SPACE 1
WPOP     DS    0CL4 -              PREV PERFORMANCE OBJECTIVE SEGMENT
WPOPSRV  DS    H -                 SERVICE RATE AT PREVIOUS POINT
WPOPWKL  DS    H -                 WORKLOD LEVL AT PREVIOUS POINT
WPOS     DS    0CL4 -              CURR PERFORMANCE OBJECTIVE SEGMENT
WPOSSRV  DS    H -                 SERVICE RATE AT CURR PT IN OBJCTV
WPOSWKL  DS    H -                 WORKLOD LEVL AT CURR PT IN OBJCTV
WPODEND  DS    0H -                END OF WPOD
WPODLEN  EQU   WPODEND-WPOS -      LENGTH OF WPOD
         MEND
*                                                                    */
*@       LIST  POP;                 /* RESUME MACRO OUTPUT LISTING   */
*        %WPODLABL = 'WPOD'  ;      /* INITIALIZE THE LABEL VARIABLE */
*        %IF WPODSFX ^= ' '         /* IS THIS THE DUPLICATE INCLUDE */
*            %THEN %WPODLABL = 'WPOD'||WPODSFX ; /* RENAME STRUCTURE */
*        %IF WPOD9999 ^= ','        /* DOES STRUCTURE CONTINUE       */
*            %THEN %WPOD9999 = ';'; /* NO, END DECLARE STATEMENT     */
*        %WPODDUM = WPODLABL||'PTR' ;  /* QUALIFY BASED POINTER NAME */
*   DCL
*     1 WPODLABL BASED(WPODDUM) BDY(WORD),
*            %WPODLABL = 'WPOP'||WPODSFX   ;
*       10 WPODLABL BDY(WORD),      /* PREV PERF OBJECTIVE SEGMENT   */
*            %WPODLABL = 'WPOPSRV'||WPODSFX;
*         12 WPODLABL FIXED(15),    /* SERVICE RATE AT PREV POINT    */
*            %WPODLABL = 'WPOPWKL'||WPODSFX;
*         12 WPODLABL FIXED(16) UNSIGNED, /* WKLD LEVL AT PREV PT    */
*            %WPODLABL = 'WPODEND'||WPODSFX;
*       10 WPODLABL CHAR(0) BDY(WORD), /* END OF ONE WPOD SEGMENT    */
*            %WPODLABL = 'WPOS'||WPODSFX   ;
*       10 WPODLABL BDY(WORD),      /* CURR PERF OBJECTIVE SEGMENT   */
*            %WPODLABL = 'WPOSSRV'||WPODSFX;
*         12 WPODLABL FIXED(15),    /* SERVICE RATE AT CURR POINT    */
*            %WPODLABL = 'WPOSWKL'||WPODSFX;
*         12 WPODLABL FIXED(16) UNSIGNED, /* WKLD LEVL AT CURR PT    */
*            %WPODLABL = 'WPOSEND'||WPODSFX;
*       10 WPODLABL CHAR(0) BDY(WORD) /* END OF CURR WPOD SEGMENT    */
*   WPOD9999
*   %WPODLEN = 'LENGTH(WPOS)';      /* SYMBOLIC FOR LENGTH OF WPOD   */
