         TITLE '*/* IRBMFEDV - DEVICE SAMPLING MODULE                  *
                        '
IRBMFEDV CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IRBMFEDV  74.213'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*                                                                  0025
*/* BEGIN MAINLINE PROCESSING                                        */
*                                                                  0025
*   /*****************************************************************/
*   /*                                                               */
*   /* INCREMENT NUMBER OF SAMPLES TAKEN IN INTERVAL                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0025
*   EDDESAMP=EDDESAMP+1;                                           0025
*                                                                  0025
         LA    @00,1                                               0025
         AL    @00,EDDESAMP(,EDDEDPTR)                             0025
         ST    @00,EDDESAMP(,EDDEDPTR)                             0025
*   /*****************************************************************/
*   /*                                                               */
*   /* COLLECT DATA. LOOP THROUGH DEVICE CLASS DATA TABLE. EACH ENTRY*/
*   /* POINTS TO A TABLE OF DEVICE DATA BLOCKS. IF NO TABLE EXISTS,  */
*   /* THE COUNT OF ENTRIES WILL BE ZERO MACDATE Y-2 73018           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0026
*   RESPECIFY                                                      0026
*    (EDDCDPTR,                                                    0026
*     EDDDBPTR) RESTRICTED;                                        0026
*   DO EDDCDPTR=EDDEDCDT BY LENGTH(EDDCDT) TO EDDEDCDT+(EDDECLAS-1)*
*         LENGTH(EDDCDT);                                          0027
*                                                                  0027
         L     EDDCDPTR,EDDEDCDT(,EDDEDPTR)                        0027
         B     @DE00027                                            0027
@DL00027 DS    0H                                                  0028
*     /***************************************************************/
*     /*                                                             */
*     /* LOOP THROUGH TABLE OF DDBS                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0028
*     RESPECIFY                                                    0028
*      (UCBPTR) RESTRICTED;                                        0028
*     DO EDDDBPTR=EDDCDDBQ BY LENGTH(EDDDB) TO EDDCDDBQ+(EDDCDNUM-1)*
*           LENGTH(EDDDB);                                         0029
         L     EDDDBPTR,EDDCDDBQ(,EDDCDPTR)                        0029
         B     @DE00029                                            0029
@DL00029 DS    0H                                                  0030
*       IF EDDDVALD='0'B|EDDDALIV='0'B THEN                        0030
         TM    EDDDVALD(EDDDBPTR),B'00000101'                      0030
         BNO   @RT00030                                            0030
*         GO TO EDLAB1;             /* DONT COLLECT DATA IF INVALID
*                                      ENTRY OR OFFLINE              */
*                                                                  0031
*       /*************************************************************/
*       /*                                                           */
*       /* POINT TO UCB FOR THIS DDB                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0032
*       UCBPTR=EDDDUCBA;                                           0032
*                                                                  0032
         LH    UCBPTR,EDDDUCBA(,EDDDBPTR)                          0032
         N     UCBPTR,@CF00463                                     0032
*       /*************************************************************/
*       /*                                                           */
*       /* INCREMENT SIOS FIELD WITH WRAP-AROUND LOGIC. THE NUMBER OF*/
*       /* SIOS IS MAINTAINED BY IOS IN A HALFWORD UCB FIELD         */
*       /* (UCBMFCNT)                                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0033
*       RESPECIFY                                                  0033
*        (EDWRKREG) RESTRICTED;                                    0033
*       EDWRKREG=UCBMFCNT;          /* GET CURRENT SIO COUNT         */
         L     @05,UCBEXTPT(,UCBPTR)                               0034
         LH    EDWRKREG,UCBMFCNT(,@05)                             0034
*       RESPECIFY                                                  0035
*        (EDWRKRG2) RESTRICTED;                                    0035
*       EDWRKRG2=EDDDLSIO;          /* GET LAST SIO READING          */
         LH    EDWRKRG2,EDDDLSIO(,EDDDBPTR)                        0036
         N     EDWRKRG2,@CF00463                                   0036
*       EDDDLSIO=EDWRKREG;          /* SAVE NEW LAST SIO VALUE       */
         STH   EDWRKREG,EDDDLSIO(,EDDDBPTR)                        0037
*       EDWRKREG=EDWRKREG-EDWRKRG2; /* SUBTRACT LAST SIO READING FROM
*                                      CURRENT READING               */
         SLR   EDWRKREG,EDWRKRG2                                   0038
*       RESPECIFY                                                  0039
*        (EDWRKRG2) UNRESTRICTED;                                  0039
*                                                                  0039
*       /*************************************************************/
*       /*                                                           */
*       /* COMPENSATE FOR POSSIBLE WRAPAROUND                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0040
*       EDWRKREG=EDWRKREG&EDKILLHI;                                0040
*                                                                  0040
         N     EDWRKREG,@CF00463                                   0040
*       /*************************************************************/
*       /*                                                           */
*       /* INCREMENT TOTAL SIOS IN INTERVAL FIELD                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0041
*       EDWRKREG=EDWRKREG+EDDDSIOS;                                0041
*                                                                  0041
         AL    EDWRKREG,EDDDSIOS(,EDDDBPTR)                        0041
*       /*************************************************************/
*       /*                                                           */
*       /* UPDATE TOTAL SIOS FIELD                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0042
*       EDDDSIOS=EDWRKREG;                                         0042
         ST    EDWRKREG,EDDDSIOS(,EDDDBPTR)                        0042
*       RESPECIFY                                                  0043
*        (EDWRKREG) UNRESTRICTED;                                  0043
*                                                                  0043
*       /*************************************************************/
*       /*                                                           */
*       /* INCREMENT DEVICE BUSY SAMPLES IF DEVICE IS BUSY           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0044
*       IF UCBBSY='1'B THEN                                        0044
         TM    UCBBSY(UCBPTR),B'10000000'                          0044
         BNO   @RF00044                                            0044
*         EDDDBUSY=EDDDBUSY+1;                                     0045
*                                                                  0045
         LA    @05,1                                               0045
         AL    @05,EDDDBUSY(,EDDDBPTR)                             0045
         ST    @05,EDDDBUSY(,EDDDBPTR)                             0045
*       /*************************************************************/
*       /*                                                           */
*       /* INCREMENT CUMMULATIVE SRBS ENQUEUED BY CURRENT NUMBER OF  */
*       /* SRBS ENQUEUED                                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0046
*       EDDDNENQ=EDDDNENQ+UCBCNT;                                  0046
@RF00044 SLR   @05,@05                                             0046
         IC    @05,UCBCNT(,UCBPTR)                                 0046
         AL    @05,EDDDNENQ(,EDDDBPTR)                             0046
         ST    @05,EDDDNENQ(,EDDDBPTR)                             0046
*EDLAB1:                            /* END OF DEVICE DATA BLOCK TABLE
*                                      LOOP                          */
*     END;                                                         0047
EDLAB1   AL    EDDDBPTR,@CF00475                                   0047
@DE00029 LH    @05,EDDCDNUM(,EDDCDPTR)                             0047
         BCTR  @05,0                                               0047
         MH    @05,@CH00475                                        0047
         AL    @05,EDDCDDBQ(,EDDCDPTR)                             0047
         CR    EDDDBPTR,@05                                        0047
         BNH   @DL00029                                            0047
*     RESPECIFY                                                    0048
*      (UCBPTR) UNRESTRICTED;                                      0048
*   END;                                                           0049
*                                                                  0049
         AL    EDDCDPTR,@CF00039                                   0049
@DE00027 SLR   @00,@00                                             0049
         IC    @00,EDDECLAS(,EDDEDPTR)                             0049
         BCTR  @00,0                                               0049
         SLA   @00,3                                               0049
         AL    @00,EDDEDCDT(,EDDEDPTR)                             0049
         CR    EDDCDPTR,@00                                        0049
         BNH   @DL00027                                            0049
*   /*****************************************************************/
*   /*                                                               */
*   /* MACDATE Y-2 73018                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0050
*   RESPECIFY                                                      0050
*    (EDDCDPTR,                                                    0050
*     EDDDBPTR) UNRESTRICTED;                                      0050
*                                                                  0050
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK TO SEE IF IT IS TIME FOR A CONFIGURATION CHECK.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0051
*   IF EDDESAMP//EDDECCHK=0 THEN    /* IF NUMBER OF SAMPLES IS AN  0051
*                                      EVEN MULTIPLE OF THE        0051
*                                      CONFIGURATION CHECK FIELD     */
         L     @03,EDDESAMP(,EDDEDPTR)                             0051
         SLR   @02,@02                                             0051
         D     @02,EDDECCHK(,EDDEDPTR)                             0051
         LTR   @02,@02                                             0051
         BNZ   @RF00051                                            0051
*     DO;                                                          0052
*                                                                  0052
*       /*************************************************************/
*       /*                                                           */
*       /* MACDATE Y-2 73018                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0053
*       RESPECIFY                                                  0053
*        (EDDCDPTR,                                                0053
*         EDDDBPTR) RESTRICTED;                                    0053
*       DO EDDCDPTR=EDDEDCDT BY LENGTH(EDDCDT) TO EDDEDCDT+(EDDECLAS-1)
*             *LENGTH(EDDCDT);                                     0054
*                                                                  0054
         L     EDDCDPTR,EDDEDCDT(,EDDEDPTR)                        0054
         B     @DE00054                                            0054
@DL00054 DS    0H                                                  0055
*         /***********************************************************/
*         /*                                                         */
*         /* LOOP THROUGH QUEUE OF DDBS                              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0055
*         RESPECIFY                                                0055
*          (UCBPTR) RESTRICTED;                                    0055
*         DO EDDDBPTR=EDDCDDBQ BY LENGTH(EDDDB) TO EDDCDDBQ+(EDDCDNUM-1
*               )*LENGTH(EDDDB);                                   0056
*                                                                  0056
         L     EDDDBPTR,EDDCDDBQ(,EDDCDPTR)                        0056
         B     @DE00056                                            0056
@DL00056 DS    0H                                                  0057
*           /*********************************************************/
*           /*                                                       */
*           /* POINT TO UCB CORRESPONDING TO THIS DDB                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0057
*           UCBPTR=EDDDUCBA;                                       0057
         LH    UCBPTR,EDDDUCBA(,EDDDBPTR)                          0057
         N     UCBPTR,@CF00463                                     0057
*           IF UCBMTPXP='0'B        /* IF NOT MULTIPLE EXPOSURE DEV  */
*               &UCBONLI='0'B       /* AND ONLINE FLAG NOT SET       */
*               &EDDDALIV='1'B      /* AND MF1 DEVICE ENTRY IS ALIVE */
*               |UCBMTPXP='0'B      /* OR NOT MULTIPLE EXPOSURE DEV  */
*               &UCBONLI='1'B       /* AND ONLINE FLAG SET           */
*               &EDDDALIV='0'B      /* AND MF1 ENTRY IS NOT ALIVE    */
*               |UCBMTPXP='1'B      /* OR IF MULTIPLE EXPOSURE DEV   */
*               &(UCBBASE+LENGTH(UCB))->UCBONLI='0'B/* & BASE UCB S*
*                                      HOWS OFFLINE                  */
*               &EDDDALIV='1'B      /* AND MF1 DEVICE ENTRY IS ALIVE */
*               |UCBMTPXP='1'B      /* OR IF MULTIPLE EXPOSURE DEV   */
*               &(UCBBASE+LENGTH(UCB))->UCBONLI='1'B/* AND BASE UCB*
*                                      SHOWS ONLIN                   */
*               &EDDDALIV='0'B      /* AND MF1 ENTRY IS NOT ALIVE    */
*             THEN                  /* DEVICE CONFIGURATION CHANGED  */
         TM    UCBMTPXP(UCBPTR),B'00001000'                        0058
         BNZ   @GL00003                                            0058
         TM    UCBONLI(UCBPTR),B'10000000'                         0058
         BNZ   @GL00003                                            0058
         TM    EDDDALIV(EDDDBPTR),B'00000001'                      0058
         BO    @RT00058                                            0058
@GL00003 TM    UCBMTPXP(UCBPTR),B'00001000'                        0058
         BNZ   @GL00002                                            0058
         TM    UCBONLI(UCBPTR),B'10000000'                         0058
         BNO   @GL00002                                            0058
         TM    EDDDALIV(EDDDBPTR),B'00000001'                      0058
         BZ    @RT00058                                            0058
@GL00002 TM    UCBMTPXP(UCBPTR),B'00001000'                        0058
         BNO   @GL00001                                            0058
         L     @05,UCBBASE(,UCBPTR)                                0058
         TM    UCBONLI+512(@05),B'10000000'                        0058
         BNZ   @GL00001                                            0058
         TM    EDDDALIV(EDDDBPTR),B'00000001'                      0058
         BO    @RT00058                                            0058
@GL00001 TM    UCBMTPXP(UCBPTR),B'00001000'                        0058
         BNO   @RF00058                                            0058
         L     @05,UCBBASE(,UCBPTR)                                0058
         TM    UCBONLI+512(@05),B'10000000'                        0058
         BNO   @RF00058                                            0058
         TM    EDDDALIV(EDDDBPTR),B'00000001'                      0058
         BNZ   @RF00058                                            0058
@RT00058 DS    0H                                                  0059
*             DO;                   /* IF ONLINE FLAG IN THE UCB AND
*                                      ALIVE FLAG IN THE DDB DO NOT
*                                      MATCH                         */
*                                                                  0059
*               /*****************************************************/
*               /*                                                   */
*               /* USE COMPARE AND SWAP TECHNIQUES ON FLAG BYTE      */
*               /* MACDATE Y-2 73018                                 */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0060
*               RESPECIFY                                          0060
*                (EDWRKREG,                                        0060
*                 EDWRKRG2) RESTRICTED;                            0060
*EDLAB2:                                                           0061
*               EDWRKREG=EDCMPSWP;  /* GET FLAGS INTO REGISTER       */
EDLAB2   L     EDWRKREG,EDCMPSWP(,EDDDBPTR)                        0061
*               EDWRKRG2=EDWRKREG;  /* COPY TO WORK REGISTER         */
*                                                                  0062
         LR    EDWRKRG2,EDWRKREG                                   0062
*               /*****************************************************/
*               /*                                                   */
*               /* INDICATE THAT THE CONFIGURATION CHANGED           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0063
*               EDWRKRG2=EDWRKRG2|EDDDCCON;                        0063
*                                                                  0063
         O     EDWRKRG2,@CF00071                                   0063
*               /*****************************************************/
*               /*                                                   */
*               /* INDICATE CURRENT DEVICE STATUS (ONLINE/OFFLINE)   */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0064
*               IF UCBMTPXP='0'B    /* IF NOT MULTIPLE EXPOSURE DEV  */
*                   &UCBONLI='1'B   /* AND ONLINE FLAG SET           */
*                   |UCBMTPXP='1'B  /* OR IF MULTIPLE EXPOSURE DEV   */
*                   &(UCBBASE+LENGTH(UCB))->UCBONLI='1'B/* AND BASE
*                                      UCB S* HOWS ONLINE            */
*                 THEN              /* DEVICE IS ONLINE              */
         TM    UCBMTPXP(UCBPTR),B'00001000'                        0064
         BNZ   @GL00012                                            0064
         TM    UCBONLI(UCBPTR),B'10000000'                         0064
         BO    @RT00064                                            0064
@GL00012 TM    UCBMTPXP(UCBPTR),B'00001000'                        0064
         BNO   @RF00064                                            0064
         L     @07,UCBBASE(,UCBPTR)                                0064
         TM    UCBONLI+512(@07),B'10000000'                        0064
         BNO   @RF00064                                            0064
@RT00064 DS    0H                                                  0065
*                 DO;                                              0065
*                                                                  0065
*                   /*************************************************/
*                   /*                                               */
*                   /* MARK ONLINE                                   */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0066
*                   EDWRKRG2=EDWRKRG2|EDDDALON;                    0066
*                                                                  0066
         O     EDWRKRG2,@CF00075                                   0066
*                   /*************************************************/
*                   /*                                               */
*                   /* SET DEVICE ENTRY VALID                        */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0067
*                   EDWRKRG2=EDWRKRG2|EDDDVAON;                    0067
*                                                                  0067
         O     EDWRKRG2,@CF00067                                   0067
*                   /*************************************************/
*                   /*                                               */
*                   /* SET IN CURRENT SIO READING                    */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0068
*                   EDDDLSIO=UCBMFCNT;                             0068
         L     @07,UCBEXTPT(,UCBPTR)                               0068
         LH    @07,UCBMFCNT(,@07)                                  0068
         STH   @07,EDDDLSIO(,EDDDBPTR)                             0068
*                 END;                                             0069
*               ELSE                /* OFFLINE                       */
*                 EDWRKRG2=EDWRKRG2&EDDDALOF;                      0070
         B     @RC00064                                            0070
@RF00064 N     EDWRKRG2,@CF00077                                   0070
*               CS(EDWRKREG,EDWRKRG2,EDCMPSWP);                    0071
@RC00064 CS    EDWRKREG,@05,EDCMPSWP(EDDDBPTR)                     0071
*               BC(7,EDLAB2);       /* LOOP IF UNSUCCESSFUL          */
*                                                                  0072
         BC    7,EDLAB2                                            0072
*               /*****************************************************/
*               /*                                                   */
*               /* MACDATE Y-2 73018                                 */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0073
*               RESPECIFY                                          0073
*                (EDWRKREG,                                        0073
*                 EDWRKRG2) UNRESTRICTED;                          0073
*             END;                                                 0074
*           IF UCBNAME^=EDDDADDR THEN/* IF DEVICE ADDRESSES DO NOT 0075
*                                      MATCH IN THE UCB AND IN THE 0075
*                                      DDB THEN DDR ACTIVITY HAS   0075
*                                      TAKEN PLACE                   */
@RF00058 CLC   UCBNAME(3,UCBPTR),EDDDADDR(EDDDBPTR)                0075
         BE    @RF00075                                            0075
*             DO;                                                  0076
*                                                                  0076
*               /*****************************************************/
*               /*                                                   */
*               /* INDICATE THAT THE CONFIGURATION HAS CHANGED       */
*               /* MACDATE Y-2 73018                                 */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0077
*               RESPECIFY                                          0077
*                (EDWRKREG,                                        0077
*                 EDWRKRG2) RESTRICTED;                            0077
*EDLAB3:                                                           0078
*               EDWRKREG=EDCMPSWP;  /* GET FLAGS                     */
*                                                                  0078
EDLAB3   L     EDWRKREG,EDCMPSWP(,EDDDBPTR)                        0078
*               /*****************************************************/
*               /*                                                   */
*               /* TURN ON CONFIGURATION CHANGED FLAG                */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0079
*               EDWRKRG2=EDWRKREG|EDDDCCON;                        0079
         LR    EDWRKRG2,EDWRKREG                                   0079
         O     EDWRKRG2,@CF00071                                   0079
*               CS(EDWRKREG,EDWRKRG2,EDCMPSWP);                    0080
         CS    EDWRKREG,@05,EDCMPSWP(EDDDBPTR)                     0080
*               BC(7,EDLAB3);       /* BRANCH IF UNSUCCESSFUL        */
*                                                                  0081
         BC    7,EDLAB3                                            0081
*               /*****************************************************/
*               /*                                                   */
*               /* MACDATE Y-2 73018                                 */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0082
*               RESPECIFY                                          0082
*                (EDWRKREG,                                        0082
*                 EDWRKRG2) UNRESTRICTED;                          0082
*                                                                  0082
*               /*****************************************************/
*               /*                                                   */
*               /* SET CURRENT EBCDIC DEVICE ADDRESS INTO DDB        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0083
*               EDDDADDR=UCBNAME;                                  0083
         MVC   EDDDADDR(3,EDDDBPTR),UCBNAME(UCBPTR)                0083
*             END;                                                 0084
*         END;                                                     0085
@RF00075 AL    EDDDBPTR,@CF00475                                   0085
@DE00056 LH    @05,EDDCDNUM(,EDDCDPTR)                             0085
         BCTR  @05,0                                               0085
         MH    @05,@CH00475                                        0085
         AL    @05,EDDCDDBQ(,EDDCDPTR)                             0085
         CR    EDDDBPTR,@05                                        0085
         BNH   @DL00056                                            0085
*         RESPECIFY                                                0086
*          (UCBPTR) UNRESTRICTED;                                  0086
*       END;                                                       0087
*                                                                  0087
         AL    EDDCDPTR,@CF00039                                   0087
@DE00054 SLR   @00,@00                                             0087
         IC    @00,EDDECLAS(,EDDEDPTR)                             0087
         BCTR  @00,0                                               0087
         SLA   @00,3                                               0087
         AL    @00,EDDEDCDT(,EDDEDPTR)                             0087
         CR    EDDCDPTR,@00                                        0087
         BNH   @DL00054                                            0087
*       /*************************************************************/
*       /*                                                           */
*       /* MACDATE Y-2 73018                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0088
*       RESPECIFY                                                  0088
*        (EDDCDPTR,                                                0088
*         EDDDBPTR) UNRESTRICTED;                                  0088
*     END;                                                         0089
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 DS    0H                                                  0090
@EF00001 DS    0H                                                  0090
@ER00001 LM    @14,@12,12(@13)                                     0090
         BR    @14                                                 0090
*   END                                                            0091
*                                                                  0091
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*                                                                  0091
*       ;                                                          0091
         B     @EL00001                                            0091
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IRBMFEDV CSECT
         DS    0F
@CF00039 DC    F'8'
@CF00475 DC    F'20'
@CH00475 EQU   @CF00475+2
@CF00067 DC    XL4'04000000'
@CF00071 DC    XL4'02000000'
@CF00075 DC    XL4'01000000'
@CF00077 DC    XL4'FEFFFFFF'
@CF00463 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
IRBMFEDV CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
EDPATCH  DS    CL100
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
EDDEDPTR EQU   @01
EDDCDPTR EQU   @03
EDDDBPTR EQU   @02
UCBPTR   EQU   @04
EDWRKRG2 EQU   @05
EDWRKREG EQU   @06
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
EDDEDT   EQU   0
EDDEDCDT EQU   EDDEDT
EDDECLAS EQU   EDDEDT+7
EDDESAMP EQU   EDDEDT+8
EDDECCHK EQU   EDDEDT+12
EDDCDT   EQU   0
EDDCDDBQ EQU   EDDCDT
EDDCDNUM EQU   EDDCDT+4
EDDDB    EQU   0
EDDDFLGS EQU   EDDDB
EDDDVALD EQU   EDDDFLGS
EDDDALIV EQU   EDDDFLGS
EDDDADDR EQU   EDDDB+1
EDDDUCBA EQU   EDDDB+4
EDDDLSIO EQU   EDDDB+6
EDDDSIOS EQU   EDDDB+8
EDDDBUSY EQU   EDDDB+12
EDDDNENQ EQU   EDDDB+16
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBONLI  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBCNT   EQU   UCBOB+9
UCBWGT   EQU   UCBOB+12
UCBMTPXP EQU   UCBWGT
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00004 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMFCNT EQU   UCBCMEXT+12
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
UCBBGN   EQU   0
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBBASE  EQU   UCBOBS01+16
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00003 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBOBS09 EQU   UCBDEV
EDCMPSWP EQU   EDDDFLGS
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBCTCF1 EQU   UCBOBS08+4
UCBCTCAD EQU   UCBOBS08
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00003
UCBSKPFG EQU   @NM00003
UCBRIPND EQU   @NM00003
UCBRTIAC EQU   @NM00003
UCBRSV79 EQU   @NM00003
UCBRSV78 EQU   @NM00003
UCBRSV77 EQU   @NM00003
UCBOLTEP EQU   @NM00003
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00002 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRV028 EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBRV034 EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBRV032 EQU   UCBFLP1
UCBRV031 EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00004
UCBHALI  EQU   @NM00004
UCBRSV09 EQU   @NM00004
UCBRSV08 EQU   @NM00004
UCBRSV07 EQU   @NM00004
UCBRSV06 EQU   @NM00004
UCBRSV05 EQU   @NM00004
UCBRSV04 EQU   @NM00004
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBFLB7  EQU   UCBFLB
UCBFLB6  EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBRSV02 EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBRV002 EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00001 EQU   UCB
EDDDCCHG EQU   EDDDFLGS
EDDDRS01 EQU   EDDDFLGS
EDDCRS01 EQU   EDDCDT+6
EDDERS01 EQU   EDDEDT+4
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00030 EQU   EDLAB1
@RF00051 EQU   @EL00001
@ENDDATA EQU   *
         END   IRBMFEDV,(C'PLS0637',0700,74213)
