         TITLE ' /* IRBMFMPR - MF/1 MESSAGE PROCESSOR                  *
                       '
         MACRO
&SYMBOL  MDL   &MPL=,&DESC=,&ROUTCDE=,&WTOR=NO,&MSGDS=NO,&MSGID=,      *
               &COLUMN=,&WTO=YES,&CARCTL=
         AGO   .BEGIN
*/***** START OF SPECIFICATIONS **************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACMEAN -MDL MEANS MESSAGE DESCRIPTOR LIST                       */
*/*                                                                  */
*/* MODULE NAME = MDL (MACRO)                                        */
*/*                                                                  */
*/* DESCRIPTIVE NAME = MESSAGE DESCRIPTOR LIST                       */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* FUNCTION = DESCRIBES INFORMATION NECESSARY FOR THE ISSUING OF    */
*/*            MESSAGES:                                             */
*/*            -MESSAGE PARTS LIST                                   */
*/*            -ROUTING CODES                                        */
*/*            -DESCRIPTOR CODES                                     */
*/*            -WTO/WTOR/ISSUE MESSAGE TO DATA SET                   */
*/*            -MESSAGE ID                                           */
*/*            -COLUMN TO START MESSAGE IN                           */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE TYPE = BAL EXECUTABLE MACRO                               */
*/*                                                                  */
*/* CHANGE ACTIVITY = SEE BELOW                                      */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* METHOD OF INVOCATION = SEE BELOW                                 */
*/*                                                                  */
*/*    BAL - MDL MPL=A,DESC=B,ROUTCDE=C,WTOR=D,MSGDS=E,MSGID=F,      */
*/*              COLUMN=G                                            */
*/*          WHERE                                                   */
*/*              A - A MESSAGE PART NUMBER OR A LIST OF MESSAGE PART */
*/*                  NUMBERS                                         */
*/*              B - DESCRIPTOR CODE OR A LIST OF DESCRIPTOR CODES   */
*/*              C - ROUTING CODE OR A LIST OF ROUTING CODES         */
*/*              D - 'YES' IF MESSAGE IS A WTOR TYPE                 */
*/*                  'NO' IF MESSAGE IS WTO TYPE                     */
*/*              E - 'YES' IF MESSAGE IS TO BE ISSUED TO A DATA SET  */
*/*                  'NO' OTHERWISE                                  */
*/*              F - MESSAGE ID NUMBER (IRBXXXI, E.G.)               */
*/*              G - COLUMN IN WHICH MESSAGE TEXT SHOULD BEGIN       */
*/*                                                                  */
*/*    PLS - NONE                                                    */
*/***** END OF SPECIFICATIONS ****************************************/
.BEGIN   ANOP
*/* MACDATE Y-2 73026                                                */
         LCLA  &LOOP
         LCLA  &R(16)
         LCLA  &D(16)
         LCLA  &NUM
         LCLA  &F(8)
         LCLC  &CAR
&NUM     SETA  N'&MPL
         AIF   (T'&ROUTCDE EQ 'O').LABEL3
&LOOP    SETA  1
.LABEL2  ANOP
         AIF   (&LOOP GT N'&ROUTCDE).LABEL3
&R(&ROUTCDE(&LOOP)) SETA 1
&LOOP    SETA  &LOOP+1
         AGO   .LABEL2
.LABEL3  ANOP
         AIF   (T'&DESC EQ 'O').LABEL4
&LOOP    SETA  1
.LABEL5  ANOP
         AIF   (&LOOP GT N'&DESC).LABEL4
&D(&DESC(&LOOP)) SETA 1
&LOOP    SETA  &LOOP+1
         AGO   .LABEL5
.LABEL4  ANOP
         AIF   ('&WTO' NE 'YES').LABEL6
&F(1)    SETA  1
.LABEL6  ANOP
         AIF   ('&WTOR' NE 'YES').LABEL7
&F(2)    SETA  1
.LABEL7  ANOP
         AIF   ('&MSGDS' NE 'YES').LABEL8
&F(3)    SETA  1
.LABEL8  ANOP
         AIF   (T'&CARCTL EQ 'O').LABEL9
&CAR     SETC  '&CARCTL'
         AGO   .LABEL10
.LABEL9  ANOP
&CAR     SETC  ' '
.LABEL10 ANOP
IRBMFMPR CSECT .                  MESSAGE DESCRIPTOR LIST (MDL)
&SYMBOL  DC    A(MPL&SYSNDX) .    ADDRESS OF MESSAGE PARTS LIST (MPL)
         DC    BL2'&R(1)&R(2)&R(3)&R(4)&R(5)&R(6)&R(7)&R(8)&R(9)&R(10)&*
               R(11)&R(12)&R(13)&R(14)&R(15)&R(16)' ROUTING CODES
         DC    BL2'&D(1)&D(2)&D(3)&D(4)&D(5)&D(6)&D(7)&D(8)&D(9)&D(10)&*
               D(11)&D(12)&D(13)&D(14)&D(15)&D(16)' DESCRIPTOR CODES
         DC    BL1'&F(1)&F(2)&F(3)&F(4)&F(5)&F(6)&F(7)&F(8)' FLAGS
         DC    AL1(&NUM) .        NUMBER OF MPL ENTRIES
         DC    CL7'&MSGID' .      MESSAGE ID
         DC    FL1'&COLUMN' .     COLUMN TO START MSG IN
         DC    CL1'&CAR'  . CARRIAGE CONTROL CHARACTER
         DC    AL1(0) .           RESERVED
IRBMFVPL CSECT
MPL&SYSNDX DS  0H .               MESSAGE PARTS LIST
&LOOP    SETA  1
.MSGPRT1 ANOP
         AIF   (&LOOP GT &NUM).MSGPRT2
         DC    H'&MPL(&LOOP)'
&LOOP    SETA  &LOOP+1
         AGO   .MSGPRT1
.MSGPRT2 ANOP
         MEND
IRBMFMPR CSECT ,                                                   0002
@MAINENT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL1(16)                                             0002
         DC    C'IRBMFMPR  74.087'                                 0002
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0002
         BALR  @12,0                                               0002
@PSTART  DS    0H                                                  0002
         USING @PSTART,@12                                         0002
         L     @00,@SIZDATD                                        0002
         GETMAIN R,LV=(0)
         LR    @11,@01                                             0002
         USING @DATD,@11                                           0002
         ST    @13,@SA00001+4                                      0002
         LM    @00,@01,20(@13)                                     0002
         ST    @11,8(,@13)                                         0002
         LR    @13,@11                                             0002
         XC    @ZTEMPS(@ZLEN),@ZTEMPS
         MVC   @PC00001(16),0(@01)                                 0002
*   IF MPWTOR(MPINDEX)='1'B THEN    /* WTOR TYPE MESSAGE?            */
         L     @10,@PC00001                                        0016
         L     @10,MPINDEX(,@10)                                   0016
         MH    @10,@CH00271                                        0016
         LA    @01,MPWTOR-20(@10)                                  0016
         TM    0(@01),B'01000000'                                  0016
         BNO   @RF00016                                            0016
*     DO;                           /* INITIALIZE PREFIX             */
*       WPLRLN=MPREPLEN;            /* REPLY LENGTH                  */
         LA    @10,MPWTORL                                         0018
         L     @15,@PC00001+8                                      0018
         MVC   WPLRLN(1,@10),MPREPLEN+1(@15)                       0018
*       WPLRPTRA=ADDR(MPREPTXT);    /* ADDRESS OF REPLY BUFFER       */
         LA    @15,MPREPTXT(,@15)                                  0019
         ST    @15,@TF00001                                        0019
         MVC   WPLRPTRA(3,@10),@TF00001+1                          0019
*       WPLRECB=ADDR(MPECB);        /* ADDRESS OF ECB                */
*                                                                  0020
         LA    @15,MPECB                                           0020
         ST    @15,WPLRECB(,@10)                                   0020
*       /*************************************************************/
*       /*                                                           */
*       /* BLANK OUT REPLY BUFFER                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0021
*       DO I=1 TO MPREPLEN;                                        0021
         LA    I,1                                                 0021
         B     @DE00021                                            0021
@DL00021 DS    0H                                                  0022
*         MPREPTXT(I)=' ';                                         0022
         L     @10,@PC00001+8                                      0022
         ALR   @10,I                                               0022
         MVI   MPREPTXT-1(@10),C' '                                0022
*       END;                                                       0023
         AH    I,@CH00056                                          0023
@DE00021 L     @10,@PC00001+8                                      0023
         CH    I,MPREPLEN(,@10)                                    0023
         BNH   @DL00021                                            0023
*     END;                                                         0024
*                                                                  0024
*/* COMMON SECTION OF WPL                                            */
*                                                                  0025
*   WPLLGH=MPBUFLEN+4;              /* LENGTH OF COMMON SECTION (4) +
*                                      TEXT LENGTH (80)              */
@RF00016 LA    @10,MPWTOL                                          0025
         MVC   WPLLGH(2,@10),@CH00206                              0025
*   WPLMCSF=0;                      /* ZERO FLAGS                    */
         SR    @05,@05                                             0026
         ST    @05,@TF00001                                        0026
         MVC   WPLMCSF(2,@10),@TF00001+2                           0026
*   WPLMCSFA='1'B;                  /* ROUTE AND DESCRIPTOR CODES ARE
*                                      PASSED                        */
         OI    WPLMCSFA(@10),B'10000000'                           0027
*   MPDESC=MPDESCCD(MPINDEX);       /* DESCRIPTOR CODES              */
         L     @05,@PC00001                                        0028
         L     @05,MPINDEX(,@05)                                   0028
         MH    @05,@CH00271                                        0028
         LA    @03,MPDESCCD-20(@05)                                0028
         MVC   MPDESC(2),0(@03)                                    0028
*   MPROUT=MPROUTCD(MPINDEX);       /* ROUTING CODES                 */
         LA    @03,MPROUTCD-20(@05)                                0029
         MVC   MPROUT(2),0(@03)                                    0029
*   MPECB=0;                        /* ZERO OUT ECB                  */
         SR    @03,@03                                             0030
         ST    @03,MPECB                                           0030
*   MP1STLIN='1'B;                  /* INDICATE 1ST LINE             */
         OI    MP1STLIN,B'10000000'                                0031
*   MPBUFPTR=MPCOLUMN(MPINDEX);     /* BEGINNING OF 1ST LINE         */
         SR    MPBUFPTR,MPBUFPTR                                   0032
         IC    MPBUFPTR,MPCOLUMN-20(@05)                           0032
*   MPMSGBUF(1:MPBUFLEN)=' ';       /* BLANK OUT BUFFER              */
         MVI   MPMSGBUF+1(@10),C' '                                0033
         MVC   MPMSGBUF+2(78,@10),MPMSGBUF+1(@10)                  0033
         MVI   MPMSGBUF(@10),C' '                                  0033
*   MPMSGBUF(1:7)=MPMSGID(MPINDEX); /* MOVE IN MESSAGE ID            */
         LA    @03,MPMSGID-20(@05)                                 0034
         MVC   MPMSGBUF(7,@10),0(@03)                              0034
*   MPTXTIDX=1;                     /* VARIABLE TEXT LIST INDEX      */
         LA    @10,1                                               0035
         LR    MPTXTIDX,@10                                        0035
*   DO I=1 TO MPMPLENT(MPINDEX);    /* DO FOR EACH MPL ENTRY         */
         LR    I,@10                                               0036
         B     @DE00036                                            0036
@DL00036 DS    0H                                                  0037
*     IF MPVPNUM(I)^=0 THEN         /* MPL CALLS FOR MSG PART?       */
         LR    @10,I                                               0037
         AR    @10,@10                                             0037
         L     @05,@PC00001                                        0037
         L     @05,MPINDEX(,@05)                                   0037
         MH    @05,@CH00271                                        0037
         L     @05,MPVPLADR-20(@05)                                0037
         AL    @05,@CF00275                                        0037
         LH    @10,MPVPNUM(@10,@05)                                0037
         LTR   @10,@10                                             0037
         BZ    @RF00037                                            0037
*       DO;                                                        0038
*         MPLENGTH=IRBMFLMV(MPVPNUM(I))->MPMSGLEN;/* MSG PART LENGTH */
         SLA   @10,2                                               0039
         L     @05,@CA00190                                        0039
         AL    @05,@CF00276                                        0039
         L     @10,IRBMFLMV-IRBMFLMV(@10,@05)                      0039
         MVC   MPLENGTH(4),MPMSGLEN(@10)                           0039
*         MPTXTPTR=ADDR(IRBMFLMV(MPVPNUM(I))->MPMSGTXT);/* MSG TEXT  */
         LA    @10,MPMSGTXT(,@10)                                  0040
         ST    @10,MPTXTPTR                                        0040
*         CALL MFBLDMSG(MPLENGTH,MPTXTPTR);/* BUILD MSG BUFFER       */
         LA    @10,MPLENGTH                                        0041
         ST    @10,@AL00001                                        0041
         LA    @10,MPTXTPTR                                        0041
         ST    @10,@AL00001+4                                      0041
         LA    @01,@AL00001                                        0041
         BAL   @14,MFBLDMSG                                        0041
*       END;                                                       0042
*     ELSE                          /* MPL CALLS FOR VARIABLE TEXT   */
*       DO;                                                        0043
         B     @RC00037                                            0043
@RF00037 DS    0H                                                  0044
*         IF MPPRTNUM=MPVTXTID&MPTXTLEN^=0 THEN/* VARIABLE TEXT    0044
*                                      EXIST?                        */
         SR    @10,@10                                             0044
         LR    @05,MPTXTIDX                                        0044
         SLA   @05,2                                               0044
         L     @15,@PC00001+4                                      0044
         AL    @15,@CF00276                                        0044
         L     @05,MPVARTXT(@05,@15)                               0044
         CH    @10,MPPRTNUM(,@05)                                  0044
         BNE   @RF00044                                            0044
         CH    @10,MPTXTLEN(,@05)                                  0044
         BE    @RF00044                                            0044
*           DO;                                                    0045
*             CALL MFBLDMSG(EVAL(MPTXTLEN),ADDR(MPVTEXT));/* YES,PUT
*                                      IN MESSAGE BUFFER             */
         LH    @10,MPTXTLEN(,@05)                                  0046
         ST    @10,@AFTEMPS                                        0046
         LA    @10,@AFTEMPS                                        0046
         ST    @10,@AL00001                                        0046
         LA    @10,MPVTEXT(,@05)                                   0046
         ST    @10,@AFTEMPS+4                                      0046
         LA    @10,@AFTEMPS+4                                      0046
         ST    @10,@AL00001+4                                      0046
         LA    @01,@AL00001                                        0046
         BAL   @14,MFBLDMSG                                        0046
*           END;                                                   0047
*         IF MPPRTNUM^=MPVTXTID THEN/* IS VARIABLE TEXT A MSG PART.  */
@RF00044 LR    @10,MPTXTIDX                                        0048
         SLA   @10,2                                               0048
         L     @05,@PC00001+4                                      0048
         AL    @05,@CF00276                                        0048
         L     @10,MPVARTXT(@10,@05)                               0048
         LH    @10,MPPRTNUM(,@10)                                  0048
         LTR   @10,@10                                             0048
         BZ    @RF00048                                            0048
*           DO;                                                    0049
*             MPLENGTH=IRBMFLMV(MPPRTNUM)->MPMSGLEN;/* MSG PART    0050
*                                      LENGTH                        */
         SLA   @10,2                                               0050
         L     @05,@CA00190                                        0050
         AL    @05,@CF00276                                        0050
         L     @10,IRBMFLMV-IRBMFLMV(@10,@05)                      0050
         MVC   MPLENGTH(4),MPMSGLEN(@10)                           0050
*             MPTXTPTR=ADDR(IRBMFLMV(MPPRTNUM)->MPMSGTXT);/* PART  0051
*                                      TEXT                          */
         LA    @10,MPMSGTXT(,@10)                                  0051
         ST    @10,MPTXTPTR                                        0051
*             CALL MFBLDMSG(MPLENGTH,MPTXTPTR);/* BUILD MSG BUFFER   */
         LA    @10,MPLENGTH                                        0052
         ST    @10,@AL00001                                        0052
         LA    @10,MPTXTPTR                                        0052
         ST    @10,@AL00001+4                                      0052
         LA    @01,@AL00001                                        0052
         BAL   @14,MFBLDMSG                                        0052
*           END;                                                   0053
*         MPTXTIDX=MPTXTIDX+1;      /* UPDATE ARRAY INDEX            */
@RF00048 AH    MPTXTIDX,@CH00056                                   0054
*       END;                                                       0055
*   END;                                                           0056
*                                                                  0056
@RC00037 AH    I,@CH00056                                          0056
@DE00036 L     @10,@PC00001                                        0056
         L     @10,MPINDEX(,@10)                                   0056
         MH    @10,@CH00271                                        0056
         LA    @05,MPMPLENT-20(@10)                                0056
         MVC   @ZT00003+3(1),0(@05)                                0056
         C     I,@ZT00003                                          0056
         BNH   @DL00036                                            0056
*   /*****************************************************************/
*   /*                                                               */
*   /* WRITE OUT LAST BUFFER                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0057
*/*   IF ANY TEXT IN  BUFFER, WRITE IT OUT.                          */
*                                                                  0057
*   IF MP1STLIN='1'B&MPBUFPTR^=MPCOLUMN(MPINDEX)|MP1STLIN='0'B&MPBUFPTR
*       ^=MPCOLUMN(MPINDEX)+MPINDENT THEN                          0057
         TM    MP1STLIN,B'10000000'                                0057
         BNO   @GL00002                                            0057
         L     @10,@PC00001                                        0057
         L     @10,MPINDEX(,@10)                                   0057
         MH    @10,@CH00271                                        0057
         LA    @05,MPCOLUMN-20(@10)                                0057
         MVC   @ZT00003+3(1),0(@05)                                0057
         C     MPBUFPTR,@ZT00003                                   0057
         BNE   @RT00057                                            0057
@GL00002 TM    MP1STLIN,B'10000000'                                0057
         BNZ   @RF00057                                            0057
         L     @10,@PC00001                                        0057
         L     @10,MPINDEX(,@10)                                   0057
         MH    @10,@CH00271                                        0057
         LA    @05,10                                              0057
         LA    @01,MPCOLUMN-20(@10)                                0057
         MVC   @ZT00003+3(1),0(@01)                                0057
         A     @05,@ZT00003                                        0057
         CR    MPBUFPTR,@05                                        0057
         BE    @RF00057                                            0057
@RT00057 DS    0H                                                  0058
*     CALL MFOUTMSG;                /* PRINT MESSAGE                 */
         BAL   @14,MFOUTMSG                                        0058
*   IF MPWTOR(MPINDEX)='1'B&MP1STLIN='0'B THEN/* WTOR TYPE AND WTOR
*                                      ISSUED                        */
@RF00057 L     @10,@PC00001                                        0059
         L     @10,MPINDEX(,@10)                                   0059
         MH    @10,@CH00271                                        0059
         LA    @01,MPWTOR-20(@10)                                  0059
         TM    0(@01),B'01000000'                                  0059
         BNO   @RF00059                                            0059
         TM    MP1STLIN,B'10000000'                                0059
         BNZ   @RF00059                                            0059
*     DO;                                                          0060
*       RFY                                                        0061
*        (GPR00P,                                                  0061
*         GPR01P,                                                  0061
*         GPR14P,                                                  0061
*         GPR15P)RSTD;                                             0061
*       GEN(WAIT ECB=MPECB,LONG=YES);/* WAIT FOR REPLY TO MESSAGE.   */
         WAIT ECB=MPECB,LONG=YES
*       RFY                                                        0063
*        (GPR00P,                                                  0063
*         GPR01P,                                                  0063
*         GPR14P,                                                  0063
*         GPR15P)UNRSTD;                                           0063
*     END;                                                         0064
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 L     @13,4(,@13)                                         0065
@EF00001 L     @00,@SIZDATD                                        0065
         LR    @01,@11                                             0065
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0065
         BR    @14                                                 0065
*                                                                  0066
*/*  PROCEDURE NAME = MFBLDMSG                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = BUILD MESSAGE BUFFER                         */
*/*                                                                  */
*/*  FUNCTION = INSERT MESSAGE TEXT INTO A BUFFER TO BE USED IN      */
*/*             ISSUING A MESSAGE                                    */
*/*                                                                  */
*                                                                  0066
*MFBLDMSG:                                                         0066
*   PROCEDURE(BLLENGTH,BLTXTPTR);                                  0066
MFBLDMSG STM   @14,@03,@SA00002                                    0066
         STM   @05,@12,@SA00002+24                                 0066
         MVC   @PC00002(8),0(@01)                                  0066
*   DECLARE                                                        0067
*     BLTXTPTR                      /* PTR TO TEXT IN MSG BUFFER     */
*         PTR(31),                                                 0067
*     BLLENGTH                      /* LENGTH OF TEXT                */
*         FIXED(31),                                               0067
*     BLBUPTR1                      /* NUMBER OF BYTES LEFT IN BUF   */
*         FIXED(8),                                                0067
*     BLTEXT                        /* MSG TEXT                      */
*         CHAR(*)                                                  0067
*                                                                  0067
*     /***************************************************************/
*     /*                                                             */
*     /* BEGINNING OF A NEW LINE                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0067
*         BASED(BLTXTPTR),                                         0067
*     J                             /* TEXT POINTER                  */
*         FIXED(31);                                               0067
*BLDBEGIN:                                                         0068
*                                                                  0068
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THIS IS THE BEGINNING OF A NEW LINE                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0068
*   IF MP1STLIN='1'B&MPBUFPTR=MPCOLUMN(MPINDEX)|MP1STLIN='0'B&MPBUFPTR=
*       MPCOLUMN(MPINDEX)+MPINDENT THEN                            0068
BLDBEGIN TM    MP1STLIN,B'10000000'                                0068
         BNO   @GL00006                                            0068
         L     @10,@PC00001                                        0068
         L     @10,MPINDEX(,@10)                                   0068
         MH    @10,@CH00271                                        0068
         LA    @05,MPCOLUMN-20(@10)                                0068
         MVC   @ZT00003+3(1),0(@05)                                0068
         C     MPBUFPTR,@ZT00003                                   0068
         BE    @RT00068                                            0068
@GL00006 TM    MP1STLIN,B'10000000'                                0068
         BNZ   @RF00068                                            0068
         L     @10,@PC00001                                        0068
         L     @10,MPINDEX(,@10)                                   0068
         MH    @10,@CH00271                                        0068
         LA    @05,10                                              0068
         LA    @01,MPCOLUMN-20(@10)                                0068
         MVC   @ZT00003+3(1),0(@01)                                0068
         A     @05,@ZT00003                                        0068
         CR    MPBUFPTR,@05                                        0068
         BNE   @RF00068                                            0068
@RT00068 DS    0H                                                  0069
*     DO;                           /* TAKE OUT LEADING BLANKS       */
*       DO J=1 TO BLLENGTH WHILE(BLTEXT(J)=' ');                   0070
         LA    J,1                                                 0070
         B     @DE00070                                            0070
@DL00070 L     @10,@PC00002+4                                      0070
         L     @10,BLTXTPTR(,@10)                                  0070
         ALR   @10,J                                               0070
         AL    @10,@CF00267                                        0070
         CLI   BLTEXT(@10),C' '                                    0070
         BNE   @DC00070                                            0070
*       END;                                                       0071
         AH    J,@CH00056                                          0071
@DE00070 L     @10,@PC00002                                        0071
         C     J,BLLENGTH(,@10)                                    0071
         BNH   @DL00070                                            0071
@DC00070 DS    0H                                                  0072
*       IF J=BLLENGTH+1 THEN        /* GONE BEYOND TEXT PTR?         */
         LA    @10,1                                               0072
         L     @05,@PC00002                                        0072
         L     @03,BLLENGTH(,@05)                                  0072
         LR    @15,@03                                             0072
         AR    @15,@10                                             0072
         CR    J,@15                                               0072
         BE    @RT00072                                            0072
*         RETURN;                   /* RETURN TO MPR                 */
*       BLLENGTH=BLLENGTH-J+1;      /* DECREASE LENGTH OF TEXT       */
         SR    @03,J                                               0074
         AR    @03,@10                                             0074
         ST    @03,BLLENGTH(,@05)                                  0074
*       BLTXTPTR=BLTXTPTR+J-1;      /* MOVE TEXT PTR PAST BLANKS     */
         L     @10,@PC00002+4                                      0075
         LR    @05,J                                               0075
         A     @05,BLTXTPTR(,@10)                                  0075
         BCTR  @05,0                                               0075
         ST    @05,BLTXTPTR(,@10)                                  0075
*     END;                                                         0076
*   IF(MPBUFLEN-MPBUFPTR+1)>=BLLENGTH THEN/* ENOUGH ROOM IN BUFFER   */
@RF00068 LA    @10,80                                              0077
         SR    @10,MPBUFPTR                                        0077
         AH    @10,@CH00056                                        0077
         L     @05,@PC00002                                        0077
         L     @05,BLLENGTH(,@05)                                  0077
         CR    @10,@05                                             0077
         BL    @RF00077                                            0077
*     DO;                           /* MOVE TEXT INTO BUFFER         */
*       MPMSGBUF(MPBUFPTR:MPBUFPTR+BLLENGTH-1)=BLTEXT(1:BLLENGTH); 0079
         LA    @10,MPWTOL                                          0079
         ALR   @10,MPBUFPTR                                        0079
         LR    @15,@05                                             0079
         BCTR  @15,0                                               0079
         L     @14,@PC00002+4                                      0079
         L     @01,BLTXTPTR(,@14)                                  0079
         EX    @15,@SM00277                                        0079
*       MPBUFPTR=MPBUFPTR+BLLENGTH; /* UPDATE CURRENT PTR            */
         AR    MPBUFPTR,@05                                        0080
*       RETURN;                     /* RETURN TO MPR                 */
@EL00002 DS    0H                                                  0081
@EF00002 DS    0H                                                  0081
@ER00002 LM    @14,@03,@SA00002                                    0081
         LM    @05,@12,@SA00002+24                                 0081
         BR    @14                                                 0081
*     END;                                                         0082
*                                                                  0082
*   /*****************************************************************/
*   /*                                                               */
*   /* NOT ENOUGH ROOM IN BUFFER FOR ENTIRE MSG - PRINT PART OF IT.  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0083
*   BLBUPTR1=MPBUFLEN-MPBUFPTR+1;   /* # BYTES LEFT DETERMINED       */
*                                                                  0083
@RF00077 LA    BLBUPTR1,80                                         0083
         SR    BLBUPTR1,MPBUFPTR                                   0083
         AH    BLBUPTR1,@CH00056                                   0083
*   /*****************************************************************/
*   /*                                                               */
*   /* IF TEXT CAN BE SPLIT, INSERT FIRST PORTION AND LEAVE THE REST */
*   /* FOR THE NEXT BUFFER                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0084
*   IF BLTEXT(BLBUPTR1+1)=' '|BLTEXT(BLBUPTR1)=','|BLTEXT(BLBUPTR1)=' '
*     THEN                                                         0084
         L     @10,@PC00002+4                                      0084
         L     @10,BLTXTPTR(,@10)                                  0084
         LR    @05,@10                                             0084
         ALR   @05,BLBUPTR1                                        0084
         CLI   BLTEXT(@05),C' '                                    0084
         BE    @RT00084                                            0084
         LR    @05,@10                                             0084
         ALR   @05,BLBUPTR1                                        0084
         AL    @05,@CF00267                                        0084
         CLI   BLTEXT(@05),C','                                    0084
         BE    @RT00084                                            0084
         ALR   @10,BLBUPTR1                                        0084
         AL    @10,@CF00267                                        0084
         CLI   BLTEXT(@10),C' '                                    0084
         BNE   @RF00084                                            0084
@RT00084 DS    0H                                                  0085
*     DO;                                                          0085
*       MPBUFPTR=MPBUFPTR+BLBUPTR1; /* UPDATE CURRENT PTR            */
         AR    MPBUFPTR,BLBUPTR1                                   0086
*       CALL MFOUTMSG;              /* PRINT MESSAGE                 */
         BAL   @14,MFOUTMSG                                        0087
*       BLLENGTH=BLLENGTH-BLBUPTR1; /* NEW TEXT LENGTH               */
         L     @10,@PC00002                                        0088
         L     @05,BLLENGTH(,@10)                                  0088
         SR    @05,BLBUPTR1                                        0088
         ST    @05,BLLENGTH(,@10)                                  0088
*       BLTXTPTR=BLTXTPTR+BLBUPTR1; /* MOVE TEXT PTR TO UNWRITTEN PRT*/
         L     @10,@PC00002+4                                      0089
         LR    @05,BLBUPTR1                                        0089
         A     @05,BLTXTPTR(,@10)                                  0089
         ST    @05,BLTXTPTR(,@10)                                  0089
*       GOTO BLDBEGIN;              /* START A NEW LINE              */
         B     BLDBEGIN                                            0090
*     END;                                                         0091
*                                                                  0091
*   /*****************************************************************/
*   /*                                                               */
*   /* TEXT WILL NOT FIT AT NATURAL BREAK POINT. TRY TO FIND A BREAK */
*   /* POINT BY SEARCHING BACKWARD.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0092
*   DO J=BLBUPTR1 TO 1 BY-1 WHILE(BLTEXT(J)^=' '&BLTEXT(J)^=',');  0092
@RF00084 LR    J,BLBUPTR1                                          0092
         B     @DE00092                                            0092
@DL00092 L     @10,@PC00002+4                                      0092
         L     @10,BLTXTPTR(,@10)                                  0092
         LR    @05,@10                                             0092
         ALR   @05,J                                               0092
         AL    @05,@CF00267                                        0092
         CLI   BLTEXT(@05),C' '                                    0092
         BE    @DC00092                                            0092
         ALR   @10,J                                               0092
         AL    @10,@CF00267                                        0092
         CLI   BLTEXT(@10),C','                                    0092
         BE    @DC00092                                            0092
*   END;                                                           0093
         BCTR  J,0                                                 0093
@DE00092 LTR   J,J                                                 0093
         BP    @DL00092                                            0093
@DC00092 DS    0H                                                  0094
*   IF J^=0 THEN                    /* NONBLANK-NONCOMMA TEXT EXIST? */
         LTR   J,J                                                 0094
         BZ    @RF00094                                            0094
*     DO;                                                          0095
*       MPMSGBUF(MPBUFPTR:MPBUFPTR+J-1)=BLTEXT(1:J);               0096
         LA    @10,MPWTOL                                          0096
         ALR   @10,MPBUFPTR                                        0096
         LR    @05,J                                               0096
         BCTR  @05,0                                               0096
         L     @03,@PC00002+4                                      0096
         L     @15,BLTXTPTR(,@03)                                  0096
         EX    @05,@SM00279                                        0096
*       MPBUFPTR=MPBUFPTR+J;        /* UPDATE CURRENT PTR            */
         AR    MPBUFPTR,J                                          0097
*       BLLENGTH=BLLENGTH-J;        /* NEW TEXT LENGTH               */
         L     @10,@PC00002                                        0098
         L     @14,BLLENGTH(,@10)                                  0098
         SR    @14,J                                               0098
         ST    @14,BLLENGTH(,@10)                                  0098
*       BLTXTPTR=BLTXTPTR+J;        /* MOVE TEXT PTR PAST ' ' OR ',' */
         AR    @15,J                                               0099
         ST    @15,BLTXTPTR(,@03)                                  0099
*     END;                                                         0100
*   CALL MFOUTMSG;                  /* ISSUE MESSAGE                 */
@RF00094 BAL   @14,MFOUTMSG                                        0101
*   GOTO BLDBEGIN;                  /* START A NEW LINE              */
         B     BLDBEGIN                                            0102
*   END MFBLDMSG;                                                  0103
         B     @EL00002                                            0103
*                                                                  0104
*/*  PROCEDURE NAME = MFOUTMSG                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = ISSUE MESSAGE                                */
*/*                                                                  */
*/*  FUNCTION = ISSUE WTO, WTOR, OR PUT TO PRINT MESSAGE             */
*/*                                                                  */
*                                                                  0104
*MFOUTMSG:                                                         0104
*   PROCEDURE;                                                     0104
MFOUTMSG STM   @14,@03,@SA00003                                    0104
         STM   @05,@12,@SA00003+24                                 0104
*   IF MPWTOR(MPINDEX)='1'B&MP1STLIN='1'B THEN/* WTOR TYPE AND 1ST 0105
*                                      LINE?                         */
         L     @10,@PC00001                                        0105
         L     @10,MPINDEX(,@10)                                   0105
         MH    @10,@CH00271                                        0105
         LA    @01,MPWTOR-20(@10)                                  0105
         TM    0(@01),B'01000000'                                  0105
         BNO   @RF00105                                            0105
         TM    MP1STLIN,B'10000000'                                0105
         BNO   @RF00105                                            0105
*     DO;                                                          0106
*       RFY                                                        0107
*        (GPR00P,                                                  0107
*         GPR01P,                                                  0107
*         GPR15P,                                                  0107
*         GPR14P)RSTD;                                             0107
*       GPR01P=ADDR(MPWTORL);       /* WTOR PARM LIST                */
         LA    GPR01P,MPWTORL                                      0108
*       GEN(WTOR MF=(E,(@01)));     /* WRITE MESSAGE                 */
         WTOR MF=(E,(@01))
*       RFY                                                        0110
*        (GPR00P,                                                  0110
*         GPR01P,                                                  0110
*         GPR15P,                                                  0110
*         GPR14P)UNRSTD;                                           0110
*     END;                                                         0111
*   ELSE                            /* CHECK FOR WTOR OR WTO         */
*     DO;                                                          0112
         B     @RC00105                                            0112
@RF00105 DS    0H                                                  0113
*       IF MPWTOR(MPINDEX)='1'B|MPWTO(MPINDEX)='1'B THEN/* WTO OR  0113
*                                      WTOR?                         */
         L     @10,@PC00001                                        0113
         L     @10,MPINDEX(,@10)                                   0113
         MH    @10,@CH00271                                        0113
         LA    @01,MPWTOR-20(@10)                                  0113
         TM    0(@01),B'11000000'                                  0113
         BZ    @RF00113                                            0113
*         DO;                                                      0114
*           RFY                                                    0115
*            (GPR00P,                                              0115
*             GPR01P,                                              0115
*             GPR14P,                                              0115
*             GPR15P)RSTD;                                         0115
*           GPR01P=ADDR(MPWTOL);    /* WTO PARM LIST                 */
         LA    GPR01P,MPWTOL                                       0116
*           GEN(WTO  MF=(E,(@01))); /* WRITE MESSAGE                 */
         WTO  MF=(E,(@01))
*           RFY                                                    0118
*            (GPR00P,                                              0118
*             GPR01P,                                              0118
*             GPR14P,                                              0118
*             GPR15P)UNRSTD;                                       0118
*         END;                                                     0119
*     END;                                                         0120
@RF00113 DS    0H                                                  0121
*   IF MPWTDS(MPINDEX)='1'B THEN    /* WRITE TO DATA SET?            */
@RC00105 L     @10,@PC00001                                        0121
         L     @10,MPINDEX(,@10)                                   0121
         MH    @10,@CH00271                                        0121
         LA    @01,MPWTDS-20(@10)                                  0121
         TM    0(@01),B'00100000'                                  0121
         BNO   @RF00121                                            0121
*     DO;                                                          0122
*       MPWLEN=LENGTH(MPPUTBUF);    /* LENGTH OF BUFFER + CONTROL    */
         MVC   MPWLEN(2),@CH00272                                  0123
*       MPWFILL=0;                                                 0124
         SR    @15,@15                                             0124
         STH   @15,MPWFILL                                         0124
*       MPCARIGE=MPCARCTL(MPINDEX); /* CARRIAGE CONTROL              */
         LA    @01,MPCARCTL-20(@10)                                0125
         MVC   MPCARIGE(1),0(@01)                                  0125
*       MPWTEXT=MPMSGBUF;           /* MOVE IN MESSAGE TEXT          */
         LA    @10,MPWTOL                                          0126
         MVC   MPWTEXT(80),MPMSGBUF(@10)                           0126
*       RFY                                                        0127
*        (GPR00P,                                                  0127
*         GPR01P,                                                  0127
*         GPR14P,                                                  0127
*         GPR15P)RSTD;                                             0127
*       GPR15P=MPDCBADP;            /* DCB ADDRESS                   */
         L     @10,@PC00001+12                                     0128
         L     GPR15P,MPDCBADP(,@10)                               0128
*       GPR00P=ADDR(MPPUTBUF);                                     0129
         LA    GPR00P,MPPUTBUF                                     0129
*       GEN(PUT (GPR15P));                                         0130
         PUT (GPR15P)
*       RFY                                                        0131
*        (GPR00P,                                                  0131
*         GPR01P,                                                  0131
*         GPR14P,                                                  0131
*         GPR15P)UNRSTD;                                           0131
*     END;                                                         0132
*   MP1STLIN='0'B;                  /* TURN OFF 1ST LINE INDICATOR   */
@RF00121 NI    MP1STLIN,B'01111111'                                0133
*   MPMSGBUF(1:MPBUFLEN)=' ';       /* CLEAR OUT MSG BUFFER          */
*                                                                  0134
         LA    @10,MPWTOL                                          0134
         MVI   MPMSGBUF+1(@10),C' '                                0134
         MVC   MPMSGBUF+2(78,@10),MPMSGBUF+1(@10)                  0134
         MVI   MPMSGBUF(@10),C' '                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* SET BUFFER POINTER TO BEGINNING OF NEW LINE                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0135
*   MPBUFPTR=MPCOLUMN(MPINDEX)+MPINDENT;                           0135
         L     @15,@PC00001                                        0135
         L     @15,MPINDEX(,@15)                                   0135
         MH    @15,@CH00271                                        0135
         LA    MPBUFPTR,10                                         0135
         LA    @14,MPCOLUMN-20(@15)                                0135
         MVC   @ZT00003+3(1),0(@14)                                0135
         A     MPBUFPTR,@ZT00003                                   0135
*   MPMSGBUF(1:7)=MPMSGID(MPINDEX); /* MOVE IN MESSAGE ID            */
         LA    @05,MPMSGID-20(@15)                                 0136
         MVC   MPMSGBUF(7,@10),0(@05)                              0136
*   RETURN;                         /* RETURN TO BLDMSG OR MPR       */
@EL00003 DS    0H                                                  0137
@EF00003 DS    0H                                                  0137
@ER00003 LM    @14,@03,@SA00003                                    0137
         LM    @05,@12,@SA00003+24                                 0137
         BR    @14                                                 0137
*   END MFOUTMSG;                                                  0138
*   END IRBMFMPR                                                   0139
*                                                                  0139
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IEZWPL  )                                       */
*                                                                  0139
*       ;                                                          0139
         B     @EL00001                                            0139
@DATA    DS    0H
@CH00056 DC    H'1'
@CH00271 DC    H'20'
@CH00206 DC    H'84'
@CH00272 DC    H'85'
@SM00277 MVC   MPMSGBUF-1(0,@10),BLTEXT(@01)
@SM00279 MVC   MPMSGBUF-1(0,@10),BLTEXT(@15)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    4F
@SA00002 DS    14F
@PC00002 DS    2F
@SA00003 DS    14F
@AL00001 DS    2A
@TF00001 DS    F
@AFTEMPS DS    2F
@ZTEMPS  DS    0F
@ZT00003 DC    F'0'
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
IRBMFMPR CSECT
         DS    0F
@CF00276 DC    F'-4'
@CF00275 DC    F'-2'
@CF00267 DC    F'-1'
@DATD    DSECT
         DS    0D
MPTXTPTR DS    A
MPLENGTH DS    F
MPECB    DS    F
MPLIST   DS    CL96
         ORG   MPLIST
MPWTORL  DS    CL8
MPWTOL   DS    CL84
MPWTOFLG DS    CL4
         ORG   MPWTOFLG
MPDESC   DS    CL2
MPROUT   DS    CL2
         ORG   MPLIST+96
MP1STLIN DS    BL1
         DS    CL1
MPPUTBUF DS    CL85
         ORG   MPPUTBUF
MPWLEN   DS    FL2
MPWFILL  DS    FL2
MPCARIGE DS    CL1
MPWTEXT  DS    CL80
         ORG   MPPUTBUF+85
IRBMFMPR CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CA00190 DC    A(IRBMFLMV)
         DS    0D
MPPATCH  DS    CL100
IRBMFMPR CSECT
MPMDL    DS    0F
* 01 MF/1 IS ACTIVE
M100I01  MDL   MPL=1,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB100I,  *
               COLUMN=9
* 02 MF/1 REPORT AVAILABLE FOR PRINTING
M101I02  MDL   MPL=2,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB101I,  *
               COLUMN=9
* 03 MF/1 TERMINATED
M102I03  MDL   MPL=3,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB102I,  *
               COLUMN=9
* 04 MF/1 OPTIONS IN EFFECT
M103I04  MDL   MPL=4,WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=9,CARCTL=1,*
               WTO=NO
* 05 MF/1 IS ALREADY ACTIVE
M200I05  MDL   MPL=5,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB200I,  *
               COLUMN=9
* 06 MF/1 TASK REINSTATED UXXXX/SXXX
M201I06  MDL   MPL=(6,0),WTOR=NO,MSGDS=YES,MSGID=IRB201I,COLUMN=9,     *
               DESC=4,ROUTCDE=2
* 07 NO MF/1 MEASUREMENTS SELECTED
M202I07  MDL   MPL=67,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB202I, *
               COLUMN=9
* 08 MF/1 SYNTAX ERROR IN OR FOLLOWING TEXT BEGINNING (ERROR TEXT)
*    IN OPERATOR/PARM/LIBRARY/REPLY INPUT
M300I08  MDL   MPL=(7,0,8,0,12),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,*
               MSGID=IRB300I,COLUMN=9
* 09 RESPECIFY MF/1 OPTIONS OR REPLY IGNORE
M308D09  MDL   MPL=13,DESC=2,ROUTCDE=(1,11),WTOR=YES,                  *
               MSGDS=NO,MSGID=IRB308D,COLUMN=9
* 10 INVALID VALUES OR MUTUALLY EXCLUSIVE OPTIONS APPEAR IN MF/1
*    OPERATOR/PARM/LIBRARY/REPLY/NULL INPUT
M301I10  MDL   MPL=(14,0,12),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB301I,COLUMN=9
* 11 MF/1 OPTIONS ASSUMED FROM SOURCE IN ERROR:
M309I11  MDL   MPL=69,DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,          *
               MSGID=IRB309I,COLUMN=9
* 12 MEMBER IRBMF1NN NOT FOUND IN THE MF/1 LIBRARY
M302I12  MDL   MPL=(15,0,16),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB302I,COLUMN=9
* 13 MEMBER KEYWORD SPECIFIED IN MF/1 LIBRARY MEMBER IRBMF1NN
M303I13  MDL   MPL=(17,0),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,      *
               MSGID=IRB303I,COLUMN=9
* 14 I/O ERROR WHILE PROCESSING MF/1 LIBRARY DATA SET.  THE SYNAD
*    TEXT FOLLOWS/NULL (SYNAD TEXT)/NULL
M304I14  MDL   MPL=(18,0,0),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,    *
               MSGID=IRB304I,COLUMN=9
* 15 MF/1 PARAMETERS
M305I15  MDL   MPL=19,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB305I, *
               COLUMN=9
* 16 REPLY WITH MF/1 OPTIONS OR GO
M306D16  MDL   MPL=20,DESC=2,ROUTCDE=(1,11),WTOR=YES,MSGDS=NO,         *
               MSGID=IRB306D,COLUMN=9
* 17 NO MF/1 OPTIONS ASSUMED
M305I17  MDL   MPL=70,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB305I, *
               COLUMN=11
* 18 I/O ERROR ON MF/1 WRITE.  THE SYNAD TEXT FOLLOWS. (SYNAD TEXT)
M400I18  MDL   MPL=(23,0),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=YES,          *
               MSGID=IRB400I,COLUMN=9
* 19 MF/1 REPORT SUBTASK FOR INTERVAL BEGINNING HH.MM.SS REINSTATED
*    UXXXX/SXXX
M401I19  MDL   MPL=(24,0,25,0),WTOR=NO,MSGDS=YES,MSGID=IRB401I,        *
               DESC=4,ROUTCDE=2,COLUMN=9
* 20 MF/1 REPORT SUBTASK FOR INTERVAL BEGINNING HH.MM.SS ABENDED
*    UXXXX/SXXX
M402I20  MDL   MPL=(24,0,26,0),WTOR=NO,MSGDS=YES,MSGID=IRB402I,        *
               COLUMN=9,DESC=4,ROUTCDE=2
* 21 CPU/NOCPU/PAGING/NOPAGING/CHAN/NOCHAN/TRACE/NOTRACE/NODEVICE/
*    NOREPORT/NOSTOP/NOWKLD
M103I21  MDL   MPL=0,WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,WTO=NO
* 22 WKLD(PERIOD/GROUP)
M103I22  MDL   MPL=(35,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 23 REPORT(REALTIME/DEFER)
M103I23  MDL   MPL=(39,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 24 INTERVAL(NNM/NN)
M103I24  MDL   MPL=(38,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 25 CYCLE(NNN)
M103I25  MDL   MPL=(37,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 26 STOP(NNNNM/NNNN/NNNH)
M103I26  MDL   MPL=(36,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 27 SYSOUT(X)
M103I27  MDL   MPL=(34,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 28 DEVICE( DEVICE LIST SEPARATED BY DELIMITERS )
M103I28  MDL   MPL=(32,0,55,0,55,0,55,0,55,0,55,0,45),WTOR=NO,WTO=NO,  *
               MSGDS=YES,MSGID=IRB103I,COLUMN=11
* 29 CPU/NOCPU/PAGING/NOPAGING/CHAN/NOCHAN/TRACE/NOTRACE/NODEVICE/
*     NOREPORT/NOSTOP/NOWKLD
M305I29  MDL   MPL=0,DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,MSGID=IRB305I,  *
               COLUMN=11
* 30 WKLD(PERIOD/GROUP)
M305I30  MDL   MPL=(35,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 31 REPORT(REALTIME/DEFER)
M305I31  MDL   MPL=(39,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 32 INTERVAL(NNM/NN)
M305I32  MDL   MPL=(38,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 33 CYCLE(NNN)
M305I33  MDL   MPL=(37,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 34 STOP(NNNNM/NNNN/NNNH)
M305I34  MDL   MPL=(36,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 35 SYSOUT(X)
M305I35  MDL   MPL=(34,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 36 DEVICE( DEVICE LIST SEPARATED BY DELIMITERS )
M305I36  MDL   MPL=(32,0,55,0,55,0,55,0,55,0,55,0,45),DESC=4,ROUTCDE=2,*
               WTOR=NO,MSGDS=NO,MSGID=IRB305I,COLUMN=11
* 37 MEMBER(NN)
M305I37  MDL   MPL=(68,0,45),DESC=4,ROUTCDE=2,WTOR=NO,MSGDS=NO,        *
               MSGID=IRB305I,COLUMN=11
* 38 MEMBER(NN)
M103I38  MDL   MPL=(68,0,45),WTOR=NO,MSGDS=YES,MSGID=IRB103I,COLUMN=11,*
               WTO=NO
* 39 CPU/NOCPU/PAGING/NOPAGING/CHAN/NOCHAN/TRACE/NOTRACE/NODEVICE/
*     NOREPORT/NOSTOP/NOWKLD
M309I39  MDL   MPL=0,DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,           *
               MSGID=IRB309I,COLUMN=11
* 40 WKLD(PERIOD/GROUP)
M309I40  MDL   MPL=(35,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 41 REPORT(REALTIME/DEFER)
M309I41  MDL   MPL=(39,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 42 INTERVAL(NNM/NN)
M309I42  MDL   MPL=(38,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 43 CYCLE(NNN)
M309I43  MDL   MPL=(37,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 44 STOP(NNNNM/NNNN/NNNH)
M309I44  MDL   MPL=(36,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 45 SYSOUT(X)
M309I45  MDL   MPL=(34,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 46 DEVICE( DEVICE LIST SEPARATED BY DELIMITERS )
M309I46  MDL   MPL=(32,0,55,0,55,0,55,0,55,0,55,0,45),DESC=4,          *
               ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,MSGID=IRB309I,COLUMN=11
* 47 MEMBER(NN)
M309I47  MDL   MPL=(68,0,45),DESC=4,ROUTCDE=(2,11),WTOR=NO,MSGDS=NO,   *
               MSGID=IRB309I,COLUMN=11
* 48 NO MF/1 OPTIONS ASSUMED
M309I48  MDL   MPL=70,DESC=4,ROUTCDE(2,11),WTOR=NO,MSGDS=NO,           *
               MSGID=IRB309I,COLUMN=11
* 49 NO MF/1 OPTIONS ASSUMED
M103I49  MDL   MPL=70,WTOR=NO,WTO=NO,MSGDS=YES,MSGID=IRB103I,          *
               COLUMN=11
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IRBMFMPR CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
J        EQU   @02
BLBUPTR1 EQU   @03
I        EQU   @03
MPBUFPTR EQU   @04
MPTXTIDX EQU   @02
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR00F   EQU   @00
GPR01F   EQU   @01
GPR14F   EQU   @14
GPR15F   EQU   @15
         EXTRN IRBMFLMV
WPLRF    EQU   0
WPLRPTR  EQU   WPLRF
WPLRLN   EQU   WPLRPTR
WPLRPTRA EQU   WPLRPTR+1
WPLRECB  EQU   WPLRF+4
WPLPTR   EQU   0
WPL      EQU   0
WPLLGH   EQU   WPL
WPLMCSF  EQU   WPL+2
WPLMCSF1 EQU   WPLMCSF
WPLMCSFA EQU   WPLMCSF1
WPLMCSF2 EQU   WPLMCSF+1
WPLTXT   EQU   WPL+4
WPLFLGS  EQU   0
WPLDESC  EQU   WPLFLGS
WPLDESC1 EQU   WPLDESC
WPLDESC2 EQU   WPLDESC+1
WPLROUT  EQU   WPLFLGS+2
WPLROUT1 EQU   WPLROUT
WPLROUT2 EQU   WPLROUT+1
WPLMSGTY EQU   WPLFLGS+4
WPLMSGT1 EQU   WPLMSGTY
WPLMSGT2 EQU   WPLMSGTY+1
WPLLS01  EQU   0
WPLLTF   EQU   WPLLS01
WPLLTF1  EQU   WPLLTF
WPLML    EQU   0
WPLMLLTF EQU   WPLML+2
WPLMLLT1 EQU   WPLMLLTF
MPMSGPRT EQU   0
MPMSGLEN EQU   MPMSGPRT
MPMSGTXT EQU   MPMSGPRT+4
MPVTXLST EQU   0
MPPRTNUM EQU   MPVTXLST
MPTXTLEN EQU   MPVTXLST+2
MPVTEXT  EQU   MPVTXLST+4
MPVPNUM  EQU   0
BLTEXT   EQU   0
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
MPVPLADR EQU   MPMDL
MPROUTCD EQU   MPMDL+4
MPDESCCD EQU   MPMDL+6
MPFLGBYT EQU   MPMDL+8
MPWTO    EQU   MPFLGBYT
MPWTOR   EQU   MPFLGBYT
MPWTDS   EQU   MPFLGBYT
MPMPLENT EQU   MPMDL+9
MPMSGID  EQU   MPMDL+10
MPCOLUMN EQU   MPMDL+17
MPCARCTL EQU   MPMDL+18
MPINDEX  EQU   0
MPVARTXT EQU   0
MPREPBUF EQU   0
MPREPLEN EQU   MPREPBUF
MPREPTXT EQU   MPREPBUF+2
MPDCBADP EQU   0
BLLENGTH EQU   0
BLTXTPTR EQU   0
MPMSGBUF EQU   WPLTXT
*                                      START UNREFERENCED COMPONENTS
MPRESRVD EQU   MPMDL+19
@NM00002 EQU   MPFLGBYT
WPLMLTXT EQU   WPLML+4
WPLMLLT2 EQU   WPLMLLTF+1
WPLRSV24 EQU   WPLMLLT1
WPLRSV23 EQU   WPLMLLT1
WPLRSV22 EQU   WPLMLLT1
WPLRSV21 EQU   WPLMLLT1
WPLMLLTD EQU   WPLMLLT1
WPLMLLTC EQU   WPLMLLT1
WPLMLLTB EQU   WPLMLLT1
WPLMLLTA EQU   WPLMLLT1
WPLMLLEN EQU   WPLML+1
WPLML0   EQU   WPLML
WPLLINES EQU   WPLLS01+3
WPLAREA  EQU   WPLLS01+2
WPLLTF2  EQU   WPLLTF+1
WPLRSV20 EQU   WPLLTF1
WPLRSV19 EQU   WPLLTF1
WPLRSV18 EQU   WPLLTF1
WPLRSV17 EQU   WPLLTF1
WPLLTFD  EQU   WPLLTF1
WPLLTFC  EQU   WPLLTF1
WPLLTFB  EQU   WPLLTF1
WPLLTFA  EQU   WPLLTF1
WPLQID   EQU   WPLFLGS+6
WPLRSV32 EQU   WPLMSGT2
WPLRSV31 EQU   WPLMSGT2
WPLRSV30 EQU   WPLMSGT2
WPLRSV29 EQU   WPLMSGT2
WPLRSV28 EQU   WPLMSGT2
WPLRSV27 EQU   WPLMSGT2
WPLRSV26 EQU   WPLMSGT2
WPLRSV25 EQU   WPLMSGT2
WPLRSV16 EQU   WPLMSGT1
WPLRSV15 EQU   WPLMSGT1
WPLMSGTF EQU   WPLMSGT1
WPLRSV14 EQU   WPLMSGT1
WPLMSGTD EQU   WPLMSGT1
WPLMSGTC EQU   WPLMSGT1
WPLMSGTB EQU   WPLMSGT1
WPLMSGTA EQU   WPLMSGT1
WPLRSV13 EQU   WPLROUT2
WPLROUTO EQU   WPLROUT2
WPLROUTN EQU   WPLROUT2
WPLROUTM EQU   WPLROUT2
WPLROUTL EQU   WPLROUT2
WPLROUTK EQU   WPLROUT2
WPLROUTJ EQU   WPLROUT2
WPLROUTI EQU   WPLROUT2
WPLROUTH EQU   WPLROUT1
WPLROUTG EQU   WPLROUT1
WPLROUTF EQU   WPLROUT1
WPLROUTE EQU   WPLROUT1
WPLROUTD EQU   WPLROUT1
WPLROUTC EQU   WPLROUT1
WPLROUTB EQU   WPLROUT1
WPLROUTA EQU   WPLROUT1
WPLRSV12 EQU   WPLDESC2
WPLRSV11 EQU   WPLDESC2
WPLRSV10 EQU   WPLDESC2
WPLRSV09 EQU   WPLDESC2
WPLRSV08 EQU   WPLDESC2
WPLRSV07 EQU   WPLDESC2
WPLDESCJ EQU   WPLDESC2
WPLDESCI EQU   WPLDESC2
WPLDESCH EQU   WPLDESC1
WPLDESCG EQU   WPLDESC1
WPLDESCF EQU   WPLDESC1
WPLDESCE EQU   WPLDESC1
WPLDESCD EQU   WPLDESC1
WPLDESCC EQU   WPLDESC1
WPLDESCB EQU   WPLDESC1
WPLDESCA EQU   WPLDESC1
WPLTXTL  EQU   WPLTXT+125
@NM00001 EQU   WPLTXT
WPLRSV05 EQU   WPLMCSF2
WPLRSV04 EQU   WPLMCSF2
WPLMCSFN EQU   WPLMCSF2
WPLRSV03 EQU   WPLMCSF2
WPLNOWTP EQU   WPLMCSF2
WPLMCSFK EQU   WPLMCSF2
WPLMCSFJ EQU   WPLMCSF2
WPLMCSFI EQU   WPLMCSF2
WPLMCSFH EQU   WPLMCSF1
WPLMCSFG EQU   WPLMCSF1
WPLMCSFF EQU   WPLMCSF1
WPLMCSFE EQU   WPLMCSF1
WPLMCSFD EQU   WPLMCSF1
WPLMCSFC EQU   WPLMCSF1
WPLMCSFB EQU   WPLMCSF1
*                                      END UNREFERENCED COMPONENTS
@RF00059 EQU   @EL00001
@RT00072 EQU   @EL00002
@PB00003 EQU   @EL00001
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IRBMFMPR,(C'PL/S-II',0502,74087)
