*%IRBSTGST:                         /* GLOBAL SUPERVISOR TABLE       */
*  MACRO
*        KEYS(
*              ATTRIBUT             /* ATTRIBUTES OF THE STRUCTURE
*                                      PRODUCED BY THIS MACRO. (THE
*                                      BOUNDARY ATTRIBUTE IS APPENDED
*                                      TO IT.)                       */
*            );
* /* BILINGUAL (MAPPING) MACRO
         MACRO
&STGSLBL IRBSTGST
*
*/**** START OF SPECIFICATIONS ***************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACSTAT Y-2 73121/Y02150                                         */
*/* MACMEAN STGST MEANS GLOBAL SUPERVISOR TABLE                      */
*/*                                                                  */
*/* MODULE-NAME = IRBSTGST                                           */
*/*                                                                  */
*/* DESCRIPTIVE-NAME = GLOBAL SUPERVISOR TABLE                       */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, VERSION 0                                    */
*/*                                                                  */
*/* FUNCTION = MAPPING MACRO FOR THE STGST.  IT CONTAINS MF/1 DATA   */
*/*            WHICH MUST BE FIXED OR BE ACCESSIBLE FROM ANY ADDRESS */
*/*            SPACE.                                                */
*/*                                                                  */
*/* NOTES = SEE BELOW                                                */
*/*                                                                  */
*/* MODULE-TYPE = BILINGUAL MAPPING MACRO                            */
*/*                                                                  */
*/* CHANGE-ACTIVITY =                                                */
*/*                                                                  */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* METHOD-OF-INVOCATION = SEE BELOW                                 */
*/*                                                                  */
*/*    PLS - .QUESTION MARK.IRBSTGST ATTRIBUT(ATTRIBUTES)            */
*/*          WHERE ATTRIBUTES ARE ANY ACCEPTABLE PLS ATTRIBUTES      */
*/*          FOR STRUCTURE DECLARATIONS.                             */
*/*                                                                  */
*/*    BAL - LABEL IRBSTGST                                          */
*/*          WHERE THE OPTIONAL LABEL PROVIDES A DSECT BY THE SAME   */
*/*          NAME.                                                   */
*/*                                                                  */
*/**** END OF SPECIFICATIONS *****************************************/
*/*
&STGSLBL DSECT ,                    START OF GLOBAL SUPERVISOR TABLE
         DS    0F                   FULLWORD BOUNDARY
STGSNAME DS    CL4'STGS'            TABLE NAME FOR DUMP IDENTIFICATION
STGSSCT  DS    A                    ADDRESS OF SCT
STGSTCB  DS    A                    ADDRESS OF MF/1 MAINLINE TCB
STGSASID DS    AL2                  MF/1 ASID
STGSRES1 DS    AL2                  RESERVED
STGSMMV  DS    A                    ADDRESS OF MFROUTER VECTOR TABLE
STGSCYC  DS    2F                   SAMPLING CYCLE INTERVAL, BIT 51
*                                         IS ONE MICROSECOND
         MEXIT
         MEND
**/
*    DCL KEY CHAR;                  /* KEY WORD PRINTED IN COMMENT   */
     ANS(                                                              '
*/**** START OF SPECIFICATIONS ***************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACSTAT Y-2 73121/Y02150                                         */
*/* MACMEAN STGST MEANS GLOBAL SUPERVISOR TABLE                      */
*/*                                                                  */
*/* MODULE-NAME = IRBSTGST                                           */
*/*                                                                  */
*/* DESCRIPTIVE-NAME = GLOBAL SUPERVISOR TABLE                       */
*/*                                                                  */
 '      ) COL(2);
     ANS(                                                              '
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, VERSION 0                                    */
*/*                                                                  */
*/* FUNCTION = MAPPING MACRO FOR THE STGST.  IT CONTAINS MF/1 DATA   */
*/*            WHICH MUST BE FIXED OR BE ACCESSIBLE FROM ANY ADDRESS */
*/*            SPACE.                                                */
*/*                                                                  */
*/* NOTES = SEE BELOW                                                */
*/*                                                                  */
*/* MODULE-TYPE = BILINGUAL MAPPING MACRO                            */
 '      ) COL(2);
     ANS(                                                              '
*/*                                                                  */
*/* CHANGE-ACTIVITY =                                                */
*/*                                                                  */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
 '      ) COL(2);
     ANS(                                                              '
*/* METHOD-OF-INVOCATION = SEE BELOW                                 */
*/*                                                                  */
*/*    PLS - .QUESTION MARK.IRBSTGST ATTRIBUT(ATTRIBUTES)            */
*/*          WHERE ATTRIBUTES ARE ANY ACCEPTABLE PLS ATTRIBUTES      */
*/*          FOR STRUCTURE DECLARATIONS.                             */
*/*                                                                  */
*/*    BAL - LABEL IRBSTGST                                          */
*/*          WHERE THE OPTIONAL LABEL PROVIDES A DSECT BY THE SAME   */
*/*          NAME.                                                   */
*/*                                                                  */
*/**** END OF SPECIFICATIONS *****************************************/
 '      ) COL(2);
*
*    /* ANSWER BACK A COPY OF INVOKING STATEMENT                     */
*    IF ATTRIBUT = '' THEN          /* IF NO STRUCTURE ATTRIBUTES WERE
*                                      INPUT, DO NOT PRINT KEY WORD  */
*      KEY = '';                    /* KEY WORD IS BLANKS            */
*    ELSE
*      KEY = 'ATTRIBUT';            /* PRINT KEYWORD NAME            */
*    ANS('/* ?'||MACLABEL||MACNAME||' '||MACLIST||KEY||ATTRIBUT||' */'
*       ) SKIP;
*
*    /* ANSWER DECLARE, STRUCTURE NAME, INPUT ATTRIBUTES OF STRUCTURE*/
*    /* AND BOUNDARY ATTRIBUTE.                                      */
*    ANS(
*              'DECLARE                                               '
*       )SKIP;
*    ANS(
*          '  1 STGST               /* GLOBAL SUPERVISOR TABLE      */'
*       )SKIP;
*    ANS(
*              '        '||ATTRIBUT(1)||'                             '
*       )SKIP;
*    ANS(
*              '        BDY(WORD),                                    '
*       )SKIP;
*
*    /* ANSWER BACK THE STRUCTURE DEFINITION                         */
*ANS(
*          '    2 STGSNAME          /* TABLE NAME (STGS)             */
*                     CHAR(4),
*               2 STGSSCT           /* ADDRESS OF SUPERVISOR CONTROL
*                                      TABLE (STSCT)                 */
*                     PTR(31),
*               2 STGSTCB           /* TCB ADDRESS OF TASK WHICH
*                                      ISSUED MSTART SVC (SVC 103,
*                                      CODE 13) (IRBMFMFC)           */
*                     PTR(31),                                        '
*   )SKIP;
*ANS(
*          '    2 STGSASID          /* ASID OF TASK WHICH ISSUED
*                                      MFSTART SVC (SVC 103, CODE 13)
*                                      (IRBMFMFC)                    */
*                     FIXED(15),
*               2 *   CHAR(2),
*               2 STGSMMV           /* ADDRESS OF MFROUTER MG VECTOR
*                                      TABLE (MFMMV)                 */
*                     PTR(31),
*               2 STGSCYC           /* MF/1 SAMPLING CYCLE PERIOD, IN
*                                      TIME OF DAY (TOD) CLOCK FORMAT*/
*                     CHAR(8)                                         '
*   )SKIP;
*
*    ANS(';') SKIP;                 /* ALIGN ; OF DECLARE WITH 'D'   */
*  %END;
