*%IRBSTMMV:
*/* BILINGUAL MAPPING MACRO
         MACRO
         IRBSTMMV
**/
*/**** START OF SPECIFICATIONS ***************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACSTAT Y-2 73018/Y02150                                         */
*/* MACMEAN MEANS MFROUTER MEASUREMENT VECTOR TABLE                  */
*/*                                                                  */
*/* MODULE-NAME = IRBSTMMV                                           */
*/*                                                                  */
*/* DESCRIPTIVE-NAME = MFROUTER MEASUREMENT VECTOR TABLE (MMV)       */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2 / VERSION 0                                   */
*/*                                                                  */
*/* FUNCTION = MAPPING MACRO FOR THE MMV.  THE MMV CONTAINS ONE      */
*/*            CONTROL BLOCK FOR EACH TYPE OF MFROUTER CALL.  EACH   */
*/*            OF THESE ENTRIES POINTS TO A LIST OF MEASUREMENT      */
*/*            GATHERING ROUTINES AND THEIR ASSOCIATED PARAMETERS    */
*/*            WHICH ARE TO BE EXECUTED AT THIS MFROUTER CALL.       */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE-TYPE = BILINGUAL MAPPING MACRO                            */
*/*                                                                  */
*/* CHANGE-ACTIVITY =                                                */
*/*                                                                  */
*/* A000000-999999                                             Y01250*/
*/*                                                                  */
*/* METHOD-OF-INVOCATION = SEE BELOW                                 */
*/*                                                                  */
*/*    PLS - .QUESTION MARK.IRBSTMMV  ATTRIBUT(ATTRIBUTES)           */
*/*          WHERE THE ATTRIBUTES ARE ANY ACCEPTABLE PLS ATTRIBUTES  */
*/*                                                                  */
*/*    BAL - IRBSTMMV - PROVIDES TWO DSECTS NAMED                    */
*/*                     IRBMMEVTL - EVENT LIST ELEMENT               */
*/*                     IRBMMMGRL - MG ROUTINE LIST ELEMENT          */
*/*                                                                  */
*/***** END OF SPECIFICATIONS ****************************************/
*/*
STMMEVTL DSECT ,                    START OF MMV
STMMEVNT DS    A                    ADDRESS OF MG ROUTINE LIST FOR THIS
*                                   EVENT
STMMNXMG DS    F                    INDEX OF NEXT AVAILABLE SLOT IN MG
*                                   ROUTINE LIST
STMMMGRL DSECT ,                    START OF MG ROUTINE LIST
STMMMGAD DS    A                    ADDRESS OF MG ROUTINE
STMMMGDA DS    A                    ADDRESS OF DATA FOR THIS MG ROUTINE
STMMMGNX DS    0C                   NEXT AVAILABLE POSITION IN DSECT
         MEXIT
         MEND
**/
*  MACRO
*        KEYS(
*              ATTRIBUT             /* ATTRIBUTES OF THE STRUCTURE
*                                      PRODUCED BY THIS MACRO. (THE
*                                      BOUNDARY ATTRIBUTE IS APPENDED
*                                      TO IT.)                       */
*            );
*
*    DCL KEY CHAR;                  /* KEY WORD PRINTED IN COMMENT   */
     ANS(                                                              '
*/*                                                                   */
*/**** START OF SPECIFICATIONS ****************************************/
*/*                                                                   */
*/* MACCOMP Y-2 SC1CQ/GAM20                                           */
*/* MACSTAT Y-2 73018/Y02150                                          */
*/* MACMEAN MEANS MFROUTER MEASUREMENT VECTOR TABLE                   */
*/*                                                                   */
*/* MODULE-NAME = IRBSTMMV                                            */
*/*                                                                   */
*/* DESCRIPTIVE-NAME = MFROUTER MEASUREMENT VECTOR TABLE (MMV)        */
*/*                                                                   */
*/* COPYRIGHT = NONE                                                  */
*/*                                                                   */
 '      ) COL(2);
     ANS(                                                              '
*/* STATUS = RELEASE 2 / VERSION 0                                    */
*/*                                                                   */
*/* FUNCTION = MAPPING MACRO FOR THE MMV.  THE MMV CONTAINS ONE       */
*/*            CONTROL BLOCK FOR EACH TYPE OF MFROUTER CALL.  EACH    */
*/*            OF THESE ENTRIES POINTS TO A LIST OF MEASUREMENT       */
*/*            GATHERING ROUTINES AND THEIR ASSOCIATED PARAMETERS     */
*/*            WHICH ARE TO BE EXECUTED AT THIS MFROUTER CALL.        */
*/*                                                                   */
*/* NOTES = NONE                                                      */
*/*                                                                   */
*/* MODULE-TYPE = BILINGUAL MAPPING MACRO                             */
*/*                                                                   */
 '      ) COL(2);
     ANS(                                                              '
*/* CHANGE-ACTIVITY =                                                 */
*/*                                                                   */
*/* A000000-999999                                             Y02150 */
*/*                                                                   */
*/* METHOD-OF-INVOCATION = SEE BELOW                                  */
*/*                                                                   */
*/*    PLS - .QUESTION MARK.IRBSTMMV  ATTRIBUT(ATTRIBUTES)            */
*/*          WHERE THE ATTRIBUTES ARE ANY ACCEPTABLE PLS ATTRIBUTES   */
*/*                                                                   */
 '      ) COL(2);
     ANS(                                                              '
*/*    BAL - IRBSTMMV - PROVIDES TWO DSECTS NAMED                     */
*/*                     IRBMMEVTL - EVENT LIST ELEMENT                */
*/*                     IRBMMMGRL - MG ROUTINE LIST ELEMENT           */
*/*                                                                   */
*/***** END OF SPECIFICATIONS *****************************************/
*/*                                                                   */
 '      ) COL(2);
*
*    /* ANSWER BACK A COPY OF INVOKING STATEMENT                     */
*    IF ATTRIBUT = '' THEN          /* IF NO STRUCTURE ATTRIBUTES WERE
*                                      INPUT, DO NOT PRINT KEY WORD  */
*      KEY = '';                    /* KEY WORD IS BLANKS            */
*    ELSE
*      KEY = 'ATTRIBUT';            /* PRINT KEYWORD NAME            */
*    ANS('/* ?'||MACLABEL||MACNAME||' '||MACLIST||KEY||ATTRIBUT||' */'
*       ) SKIP;
*
*    /* ANSWER DECLARE, STRUCTURE NAME, INPUT ATTRIBUTES OF STRUCTURE*/
*    /* AND BOUNDARY ATTRIBUTE.                                      */
*    ANS(
*              'DECLARE                                               '
*       )SKIP;
*    ANS(
*              '  1 STMMEVTL        /* MMV EVENT LIST               */
*                        (*)                                          '
*       )SKIP;
*    ANS(
*              '        '||ATTRIBUT(1)||'                             '
*       )SKIP;
*    ANS(
*              '        BDY(WORD),                                    '
*       )SKIP;
*
*    /* ANSWER BACK THE STRUCTURE DEFINITION                         */
*
*    ANS(
*              '   2 STMMEVNT       /* ADDRESS OF MG ROUTINE LIST FOR
*                                      THIS EVENT                   */
*                        POINTER(31),
*                  2 STMMNXMG       /* INDEX OF NEXT AVAILABLE SLOT
*                                      IN THE MG ROUTINE LIST       */
*                        FIXED BINARY(31),
*                1 STMMMGRL         /* MG ROUTINE LIST              */
*                      (*)
*                      BASED,
*                  2 STMMMGAD       /* ADDRESS OF MG ROUTINE        */
*                        POINTER(31),
*                  2 STMMMGDA       /* ADDRESS OF DATA FOR THIS
*                                      MG ROUTINE                   */
*                        POINTER(31),                                 '
*       )SKIP;
*    ANS(
*              ' STMMTIME           /* TQE EXPIRED EVENT NUMBER     */
*                      FIXED BINARY(31)
*                      CONSTANT(1),
*                STMMTCH            /* TEST CHANNEL SIGP INTERRUPT  */
*                      FIXED BINARY(31)
*                      CONSTANT(2),
*                STMMMEVT           /* MAX MF/1 EVENT INDEX         */
*                      FIXED BINARY(31)
*                      CONSTANT(2),
*                STMMMMGR           /* MAX MG ROUTINES PER EVENT    */
*                      FIXED BINARY(31)
*                      CONSTANT(3)                                    '
*       )SKIP;
*    ANS(';') SKIP;                 /* ALIGN ; OF DECLARE WITH 'D'   */
*  %END;
