
    /*****************************************************************/
    /*                                                               */
    /* ISDACVT - SDA CONTROL VECTOR TABLE                            */
    /*                                                               */
    /*****************************************************************/

 /* %INCLUDE ISDADCLS(ISDACVT)                               @Y30LB55*/

    DCL                             /* SDA CONTROL VECTOR TABLE
                                                             @Y30LB55*/
      1 ISDACVT BASED(CVTPTR),
       2 CVTPTRS0,                  /* PROC WORK POINTERS    @Y30LB55*/
        3 DATAPTR PTR(31),          /* -> LOG RECORD (0)     @Y30LB55*/
        3 SDATAPTR PTR(31),         /* -> SENSE DATA (4)     @Y30LB55*/
        3 PARMPTR PTR(31),          /* -> SDA PARM TABLE (8) @Y30LB55*/
        3 SDA00PTR PTR(31),         /* -> ISDASDA0 WORK AREA (12)
                                                             @Y30LB55*/
        3 PARM0PTR PTR(31),         /* -> SDA PARM FIELD (16)@Y30LB55*/
        3 TYPE0PTR PTR(31),         /* -> ISDATYPE WORKAREA (20)
                                                             @Y30LB55*/
        3 GET00PTR PTR(31),         /* -> ISDAGET0 WORK AREA (24)
                                                             @Y30LB55*/
        3 PRT00PTR PTR(31),         /* -> ISDAPRT0 WORK AREA (28)
                                                             @Y30LB55*/
        3 HIST0PTR PTR(31),         /* -> ISDAHIST WORKAREA (32)
                                                             @Y30LB55*/
        3 LOG00PTR PTR(31),         /* -> ISDALOG0 WORK AREA (36)
                                                             @Y30LB55*/
        3 DCS00PTR PTR(31),         /* -> ISDADCS0 WORK AREA (40)
                                                             @Y30LB55*/
        3 PAD00PTR PTR(31),         /* -> ISDAPAD0 WORK AREA (44)
                                                             @Y30LB55*/
        3 SUM00PTR PTR(31),         /* -> ISDASUM0 WORK AREA (48)
                                                             @Y30LB55*/
        3 DHE00PTR PTR(31),         /* -> ISDADHE0 WORK AREA (52)
                                                             @Y30LB55*/
        3 FSC00PTR PTR(31),         /* -> ISDAFSC0 WORK AREA (56)
                                                             @Y30LB55*/
        3 EQC00PTR PTR(31),         /* -> ISDAEQC0 WORK AREA (60)
                                                             @Y30LB55*/
        3 DCK00PTR PTR(31),         /* -> ISDADCK0 WORK AREA (64)
                                                             @Y30LB55*/
        3 CSB00PTR PTR(31),         /* -> ISDACSB0 WORK AREA (68)
                                                             @Y30LB55*/
        3 DAT00PTR PTR(31),         /* -> ISDADAT0 WORK AREA (72)
                                                             @Y30LB55*/
        3 DRC00PTR PTR(31),         /* -> ISDADRC0 WORK AREA (76)
                                                             @Y30LB55*/
        3 APR00PTR PTR(31),         /* -> ISDAAPR0 WORK AREA (80)
                                                             @Y30LB55*/
        3 PWR00PTR PTR(31),         /* SPARE - RESERVED      (84)
                                                             @ZM30976*/
        3 CNFG0PTR PTR(31),         /* -> CONFIGUATION TABLE (88)
                                                             @Y30LB55*/
        3 GEN00PTR PTR(31),         /* -> ISDAGEN0 WORKAREA (92)
                                                             @Y30LB55*/
 /* TO CALL XXX(WORKPTR), SET R1=ADDR(WORKCALL) AND CALL XXX @Y30LB55*/

        3 WORKCALL PTR(31),         /* =ADDR(WORKPTR) (96)   @Y30LB55*/

      /***************************************************************/
      /*                                                             */
      /* PARAMETERS FOR ISDAGET0, ISDAGET1, AND ISDAFREE             */
      /*                                                             */
      /***************************************************************/

       2 GET0CALL,                  /* PARAMETERS FOR ISDAGET0 (100)
                                                             @Y30LB55*/
        3 SPNOLEN FIXED(31),        /* SPNO + LENGTH         @Y30LB55*/
         4 SPNO BIT(8),             /* SUBPOOL NUMBER        @Y30LB55*/
         4 CORELEN FIXED(24),       /* LENGTH OF REQUESTED AREA
                                                             @Y30LB55*/
        3 COREADDR PTR(31),         /* ADDRESS OF AREA, FILLED IN BY
                                       GET0                  @Y30LB55*/

      /***************************************************************/
      /*                                                             */
      /* PARAMETERS FOR ISDAHEXP                                     */
      /*                                                             */
      /***************************************************************/

       2 HEXPCALL,                  /* PARAMETERS FOR ISDAHEXP (108)
                                                             @Y30LB55*/
        3 DUMPADDR PTR(31),         /* ADDRESS OF AREA TO DUMP
                                                             @Y30LB55*/
        3 DUMPLEN FIXED(31),        /* LENGTH OF AREA TO DUMP@Y30LB55*/
        3 DUMPIDNO FIXED(31),       /* ID NUMBER OF DUMP     @Y30LB55*/

      /***************************************************************/
      /*                                                             */
      /* PARAMETERS FOR ISDAPRT0 AND ISDATYPE                        */
      /*                                                             */
      /***************************************************************/

       2 PRT0CALL,                  /* PARAMETERS FOR ISDAPRT0 (120)
                                                             @Y30LB55*/
        3 OUTLINE CHAR(133),        /* FULL OUTPUT LINE      @Y30LB55*/
         4 ANSI CHAR(1),            /* PRINTER CONTROL CHARACTER
                                                             @Y30LB55*/
         4 LINE CHAR(132),          /* TEXT FOR OUTPUT       @Y30LB55*/
        3 SDARPTID CHAR(3),         /* REPORT ID FOR PAGE HEADER.
                                  SET TO 000000 TO NOT MOVE  @ZD00192*/

      /***************************************************************/
      /*                                                             */
      /* SDA SAVE AREAS AND WORK AREAS FOR DATAREG                   */
      /*                                                             */
      /***************************************************************/

       2 SDADATD,                   /* 160 BYTE SDA SAVE AREA FOR ALL
                                       PROCS                 @Y30LB55*/
        3 SDASA001(18) FIXED(31),   /* MAIN SAVE AREA        @Y30LB55*/
        3 SDAPC001 FIXED(31),       /* PARAMETER SAVE        @Y30LB55*/
        3 SDASA002(15) FIXED(31),   /* INNER PROC SAVE AREA  @Y30LB55*/
        3 SDATEMPS(6) FIXED(31),    /* TEMP SPACE            @Y30LB55*/
       2 PRTDATD,                   /* 160 BYTE SAVE AREA FOR
                                       ISDAPRT0 AND ISDATYPE @Y30LB55*/
        3 PRTSA001(40) FIXED(31);   /* 2ND LEVEL CALL SAVE   @Y30LB55*/
    %SDACVTL='LENGTH(ISDACVT)';                            /*@Y30LB55*/

 /* %SDACVTL='LENGTH(ISDACVT)'                               @Y30LB55*/
 /*   DCL CVTPTR PTR(31)  AND SET CVTPTR=WORKPTR             @Y30LB55*/
