
    /*****************************************************************/
    /*                                                               */
    /* DATWORK IS THE STRUCTURE FOR THE DAT WORK AREA        @Y30LB50*/
    /*                                                               */
    /*****************************************************************/

    DCL
      1 DATWORK BASED(DATPTR),      /*                       @Y30LB50*/
       2 CSPTRS(4) PTR(31),         /* POINTERS TO ACCUMULATOR BLOCKS
                                       FOR EACH CARTRIDGE STORE
                                       ENCOUNTERED           @Y30LB50*/
       2 TSUM FIXED(31),            /* TOTAL OF BIT COUNTS   @Y30LB50*/
       2 WORK1 CHAR(8),             /* COMPACTED DAT CHECKS BYTES
                                                             @Y30LB50*/
        3 WORK2 BIT(8),             /*                       @Y30LB50*/
         4 CURRBIT BIT(1),          /* BIT BEING EXAMINED    @Y30LB50*/
         4 RESTBITS BIT(7),         /*                       @Y30LB50*/
        3 WORK3 BIT(56),            /*                       @Y30LB50*/
       2 I FIXED(15),               /* LOOP INDEX            @Y30LB50*/
       2 J FIXED(15),               /* LOOP INDEX            @Y30LB50*/
       2 K FIXED(15),               /* LOOP INDEX            @Y30LB50*/
       2 L FIXED(15),               /* LOOP INDEX            @Y30LB50*/
       2 M FIXED(15),               /* LOOP INDEX            @Y30LB50*/
       2 LOOPEND FIXED(15),         /* LOOP END COMPARAND    @Y30LB50*/
       2 HOLDDBL CHAR(8),           /* DOUBLE WORD FOR CONVERTING
                                                             @Y30LB50*/
        3 HOLD0 CHAR(4),            /*                       @Y30LB50*/
        3 HOLD CHAR(4),             /* WORK AREA FOR CONVERTING
                                                             @Y30LB50*/
         4 HOLD2 CHAR(1),           /*                       @Y30LB50*/
         4 HOLD1 CHAR(3),           /*                       @Y30LB50*/
          5 CSNUMB CHAR(2),         /* ISOLATE INFO FROM SSID
                                                             @Y30LB50*/
           6 SSIDWORK CHAR(2),      /* ISOLATE UNIT          @Y30LB50*/
          5 XXX CHAR(1);            /*                       @Y30LB50*/
    %DATWORKL='LENGTH(DATWORK)';    /*                       @Y30LB50
                                                                     */
 @EJECT;

    /*****************************************************************/
    /*                                                               */
    /* DESCRIPTION OF DAT ACCUMULATOR BLOCK                  @Y30LB50*/
    /*                                                               */
    /*****************************************************************/

    DCL
      1 DATACCM BASED(CSPTR),       /*                       @Y30LB50*/
       2 BYTEBIT FIXED(15),         /* 2 BYTE COUNTER FOR ONE BIT FOR
                                       ONE DRC               @Y30LB50*/
       2 BYTEBIT3 CHAR(22),         /* 2 BYTE COUNTER FOR ONE BIT FOR
                                       OTHER DRCS AND DRDS   @Y30LB50*/
       2 BYTE0 CHAR(168),           /* BIT COUNTERS FOR OTHER BITS OF
                                       MSC BYTE 4            @Y30LB50*/
        3 BIT0 CHAR(24),            /* BIT COUNTERS FOR ONE BIT
                                                             @Y30LB50*/
        3 BITN CHAR(144),           /* BIT COUNTERS FOR OTHER BITS
                                                             @Y30LB50*/
       2 BYTE1 CHAR(192),           /* BIT COUNTERS FOR MSC BYTE 5
                                                             @Y30LB50*/
       2 BYTE2 CHAR(192),           /* BIT COUNTERS FOR MSC BYTE 13
                                                             @Y30LB50*/
       2 BYTE3 CHAR(192),           /* BIT COUNTERS FOR MSC BYTE 14
                                                             @Y30LB50*/
       2 BYTE4 CHAR(192);           /* BIT COUNTERS FOR MSC BYTE 15
                                                             @Y30LB50*/
    %DATACCML='LENGTH(DATACCM)';    /*                       @Y30LB50
                                                                     */
 @EJECT;

    /*****************************************************************/
    /*                                                               */
    /* DESCRIPTION OF ISDADAT0 AND ISDADAT1 CONSTANTS        @Y30LB50*/
    /*                                                               */
    /*****************************************************************/

    DCL
      CVTPTR PTR(31) REG(2) RSTD;   /* SDACVT POINTER        @Y30LB50*/
    DCL
      RETRNREG FIXED(31) REG(9) RSTD;/* RETURN CODE          @Y30LB50*/
    DCL
      DATPTR PTR(31) REG(10) RSTD;  /* DAT WORK AREA PTR     @Y30LB50*/
    DCL
      CSPTR PTR(31) REG(8) RSTD;    /* CARTRIDGE STORE-DAT
                                       ACCUMULATOR POINTER   @Y30LB50*/
    DCL
      WORKPTR PTR(31);              /* CALLING PARAMETER--SDACVT PTR
                                                             @Y30LB50*/
    DCL
      R1 FIXED(31) REG(1) UNRSTD;   /*                       @Y30LB50*/
    DCL
      R0 FIXED(31) REG(0) UNRSTD;   /*                       @Y30LB50*/
    DCL
      R15 FIXED(31) REG(15) UNRSTD; /*                       @Y30LB50*/
    DCL
      DATSPNO CHAR(1) STATIC LOCAL INIT('00'X);/* SUBPOOL NUMBER FOR
                                       DAT REQUESTS          @Y30LB50*/
    DCL
      MAXDRC FIXED(15) CONSTANT(4); /* MAXIMUM NUMBER OF DRCS
                                                             @Y30LB50*/
    DCL
      MAXCS  FIXED(15) CONSTANT(4); /*MAXIMUM NUMBER OF CARTRIDGE
                                      STORES                 @Y30LB50*/
    DCL
      1 PATCH CHAR(50) STATIC LOCAL,
       2 *(50) CHAR(1) INIT((50)'00'X);/* MAINTENANCE AREA   @Y30LB50*/
