
 /* EQC ACCUMULATOR WORK TABLE.                                      */

    /*****************************************************************/
    /*                                                               */
    /* EQCWORK -- EQC REPORT MODULES WORK TABLE. THIS TABLE SERVES AS*/
    /* THE COMMUNICATIONS VECTOR TABLE (CVT) BETWEEN THE MODULES     */
    /* (ISDAEQC0 AND ISDAEQC1) INVOLVED IN THE PREPARATION OF THE    */
    /* EQUIPMENT CHECK (EQC) REPORT.                                 */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 EQCWORK BASED(EQCWKPTR),    /*                       @Y30LB51*/
       2 GET0PTR PTR(31),           /* PTR TO EQC TABLE.     @Y30LB51*/
       2 PTRSAVE PTR(31),           /* PTR SAVE AREA.        @Y30LB51*/
       2 LOGPTR PTR(31),            /* LOCAL PTR TO RECORD.  @Y30LB51*/
       2 SENSEPTR PTR(31),          /* LOCAL PTR TO SENSE AREA.
                                                             @Y30LB51*/
       2 FREEPTR PTR(31),           /* PTR TO FREE TABLE ENTRY.
                                                             @Y30LB51*/
       2 OLDPTR PTR(31),            /* PTR TO EQC CHAIN START.
                                                             @Y30LB51*/
       2 RUASAVE CHAR(2),           /* REAL UNIT ADDRESS SAVE AREA.
                                                             @ZD00149*/
       2 SSIDSAVE CHAR(2),          /* SSID AND FLAGS SAVE AREA.
                                                             @Y30LB51*/
        3 SSIDDEV CHAR(1),          /* DEVICE TYPE CHARACTER.@Y30LB51*/
        3 * CHAR(1),                /*                       @Y30LB51*/
       2 FSCSYSSV CHAR(2),          /* SAVE AREA FOR NON-LIBRARY FSC.
                                                             @Y30LB51*/
       2 FSCSAVE1 CHAR(4),          /* FSC SAVE AREA (RIGHT ACCESSOR).
                                                             @Y30LB51*/
       2 FSCSAVE2 CHAR(4),          /* FSC SAVE AREA (LEFT ACCESSOR).
                                                             @Y30LB51*/
       2 RECCOUNT FIXED(15),        /* COUNT OF TABLE ELEMENTS.
                                                             @Y30LB51*/
       2 LINECT FIXED(15),          /* COUNT OF PRINTED LINES.
                                                             @Y30LB51*/
       2 I FIXED(15),               /* WORK COUNTER.         @Y30LB51*/
       2 J FIXED(15),               /* WORK COUNTER.         @Y30LB51*/
       2 K FIXED(15),               /* WORK COUNTER.         @Y30LB51*/
       2 L FIXED(15),               /* WORK COUNTER.         @Y30LB51*/
       2 SENSELEN FIXED(15),        /* SENSE DATA LENGTH.    @Y30LB51*/
       2 EQCSW BIT(16),             /* SWITCHES.             @Y30LB51*/
        3 FMT3ACC1 BIT(1),          /* RT ACC FSC FLAG.      @Y30LB51*/
        3 FMT3ACC2 BIT(1),          /* LEFT ACC FSC FLAG.    @Y30LB51*/
        3 WORKAPR BIT(1),           /* APR ALTERED SSID FLAG.@Y30LB51*/
        3 NOFSC BIT(1),             /* NO FSC FLAG.          @Y30LB51*/
        3 MSCREC BIT(1),            /* MSC RECORD FLAG.      @Y30LB51*/
        3 * BIT(11),                /*                       @Y30LB51*/
       2 DEVBYTES BIT(16),          /* WORK AREA FOR DEVICE IDS.
                                                             @ZD00149*/
        3 DEVBYTEA BIT(8),          /* FIRST WORK BYTE.      @ZD00149*/
        3 DEVBYTEB BIT(8);          /* SECOND WORK BYTE.     @ZD00149*/
    %EQCWORKL='LENGTH(EQCWORK)';
 @EJECT;

 /* FORMAT OF THE EQC ACCUMULATOR TABLE ENTRY.                       */

    /*****************************************************************/
    /*                                                               */
    /* EQCTBL -- TABLE FOR THE ACCUMULATION OF THE MOST RECENT 100   */
    /* EQUPMENT CHECK RECORDS.                                       */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 EQCTBL BASED(TBLPTR),       /*                       @Y30LB51*/
       2 EQCTPTR PTR(31),           /* PTR TO NEXT ELEMENT ON CHAIN.
                                                             @Y30LB51*/
       2 EQCRUA CHAR(2),            /* REAL UNIT ADDRESS.    @ZD00149*/
       2 EQCSSID CHAR(2),           /* SSID AND FLAGS AREA.  @Y30LB51*/
        3 DEVCHAR CHAR(1),          /* DEVICE CHARACTER.     @Y30LB51*/
        3 UNITCHAR CHAR(1),         /* UNIT CHARACTERS.      @Y30LB51*/
       2 EQCFLAGS BIT(16),          /* ACCUMULATOR TABLE FLAGS.
                                                             @Y30LB51*/
        3 FAKEFSC BIT(1),           /* GENERATED FSC.        @Y30LB51*/
        3 DASDFLAG BIT(1),          /* DASD SSID.            @Y30LB51*/
        3 REALDASD BIT(1),          /* READ DASD SSID.       @Y30LB51*/
        3 VIRTDASD BIT(1),          /* VIRTUAL DASD SSID.    @Y30LB51*/
        3 EQCNOFSC BIT(1),          /* NO FSC IN RECORD.     @Y30LB51*/
        3 EQCAPR BIT(1),            /* APR ALTERED SSID FLAG.@Y30LB51*/
        3 MSCFLAG BIT(1),           /* MSC RECORD FLAG.      @Y30LB51*/
        3 CSFLAG BIT(1),            /* CS DEVICE FLAG.       @Y30LB51*/
        3 DEVIN BIT(1),             /* DEVICE IDS FLAG.      @ZD00149*/
        3 * BIT(7),                 /*                       @ZD00149*/
       2 EQCFSC CHAR(4),            /* FSC AREA.             @Y30LB51*/
        3 FSCSYS CHAR(2),           /* NON-LIBRARY DEVICE FSC.
                                                             @Y30LB51*/
        3 * CHAR(2),                /*                       @Y30LB51*/
       2 EQCDT CHAR(8),             /* DATE/TIME STAMP FROM RECORD.
                                                             @Y30LB51*/
        3 EQCDATE CHAR(4),          /* DATE -- YEAR AND DAY. @Y30LB51*/
         4 EQCYR CHAR(2),           /* YEAR.                 @Y30LB51*/
         4 EQCDAY CHAR(2),          /* DAY.                  @Y30LB51*/
        3 EQCTIME CHAR(4),          /* TIME.                 @Y30LB51*/
         4 EQCHR CHAR(1),           /* HOURS.                @Y30LB51*/
         4 EQCMIN CHAR(1),          /* MINUTES.              @Y30LB51*/
         4 EQCSEC CHAR(1),          /* SECONDS.              @Y30LB51*/
         4 EQCHSEC CHAR(1),         /* HUNDREDTHS OF A SECOND.
                                                             @Y30LB51*/
       2 EQCUNIT CHAR(2),           /* UNIT IDS.             @ZD00149*/
        3 CNTLUNIT CHAR(1),         /* CONTROL UNIT ID.      @ZD00149*/
        3 UNITID CHAR(1),           /* DRIVE ID.             @ZD00149*/
       2 EQCSENSE CHAR(32),         /* SENSE AREA.           @Y30LB51*/
        3 DASDDATA CHAR(28),        /* DASD SENSE.           @Y30LB51*/
        3 * CHAR(4);                /*                       @Y30LB51*/
    %EQCTBLL='LENGTH(EQCTBL)';
 @EJECT;

 /* FORMAT OF THE DASD RECORD.                                       */

    /*****************************************************************/
    /*                                                               */
    /* MSCDASD -- DASD RECORD FORMAT. (THIS FORMAT MAY BE USED AS THE*/
    /* FORMAT OF THE MSC FORMAT 5 RECORD BY ADDING 4 TO SENSEPTR.)   */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 MSCDASD BASED(SENSEPTR),    /*                       @Y30LB51*/
       2 * CHAR(4),                 /* BYTES 0 - 3.          @ZD00149*/
       2 DRIVE BIT(8),              /* DRIVE ID.             @ZD00149*/
       2 * CHAR(2),                 /* BYTES 5 AND 6.        @ZD00149*/
       2 FMTMSG BIT(8),             /* BYTE 7.               @Y30LB51*/
        3 DASDFMT BIT(4),           /* DASD SUBFORMAT CODE.  @Y30LB51*/
        3 DASDMSG BIT(4),           /* DASD MESSAGE CODE.    @Y30LB51*/
       2 * CHAR(2),                 /* BYTES 8 AND 9.        @Y30LB51*/
       2 DASD10 BIT(8),             /* BYTE 10.              @Y30LB51*/
        3 TIMEBIT BIT(1),           /* LATE/EARLY BIT.       @Y30LB51*/
        3 CLOCKERR BIT(1),          /* CLOCK ERROR BIT.      @Y30LB51*/
        3 * BIT(6),                 /*                       @Y30LB51*/
       2 DASD11 BIT(8),             /* BYTE 11.              @Y30LB51*/
       2 * CHAR(8),                 /* BYTES 12 - 19.        @Y30LB51*/
       2 DASD20 BIT(8),             /* BYTE 20.              @Y30LB51*/
       2 * CHAR(1),                 /* BYTE 21.              @Y30LB51*/
       2 FSCDASD BIT(16),           /* BYTES 22 AND 23, FSC. @Y30LB51*/
       2 * CHAR(2),                 /* BYTES 24 AND 25.      @ZD00149*/
       2 DASDSSID CHAR(2);          /* DASD DRIVE SSID.      @ZD00149*/
