
 /* FSC ACCUMULATOR WORK TABLE.                                      */

    /*****************************************************************/
    /*                                                               */
    /* FSCWORK -- FSC REPORT MODULES WORK TABLE. THIS TABLE SERVES AS*/
    /* A COMMUNICATIONS VECTOR TABLE (CVT) BETWEEN THE MODULES       */
    /* (ISDAFSC0, ISDAFSC1 AND ISDAFSC2) INVOLVED IN THE PREPARATION */
    /* OF THE FAULT SYMPTOM CODE (FSC) REPORT.                       */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 FSCWORK BASED(FSCWKPTR),    /*                       @Y30LB51*/
       2 GET0PTR PTR(31),           /* PTR TO LAST FSC TABLE.@Y30LB51*/
       2 PTRSAVE PTR(31),           /* POINTER SAVE AREA.    @Y30LB51*/
       2 FSCPTR PTR(31),            /* POINTER TO FIRST FSC TABLE.
                                                             @Y30LB51*/
       2 LOGPTR PTR(31),            /* PTR TO RECORD.        @Y30LB51*/
       2 SENSEPTR PTR(31),          /* PTR TO SENSE AREA.    @Y30LB51*/
       2 FREEPTR PTR(31),           /* FSC TABLE FREE ELEMENT PTR.
                                                             @Y30LB51*/
       2 SUMTABLE PTR(31),          /* ADDRESS OF SUM TABLE. @Y30LB51*/
       2 SUMSTART PTR(31),          /* PTR TO SUM CHAIN START.
                                                             @Y30LB51*/
       2 CHAINTBL PTR(31),          /* ADDRESS OF CHAIN TABLE.
                                                             @Y30LB51*/
       2 PRINTTBL PTR(31),          /* ADDRESS OF PRINT TABLE.
                                                             @Y30LB51*/
       2 TBLPTRSV PTR(31),          /* TABLE POINTER SAVE AREA.
                                                             @Y30LB51*/
       2 PRTPTR PTR(31),            /* POINTER TO PRINT TABLE.
                                                             @ZA20267*/
       2 SUMPTR PTR(31),            /* POINTER TO SUM TABLE. @ZA20267*/
       2 FSCTBLCT FIXED(15),        /* COUNT OF FSC TABLES.  @Y30LB51*/
       2 SSIDCT FIXED(15),          /* MAXIMUM NR OF SSIDS IN SYSTEM.
                                                             @Y30LB51*/
       2 SSIDCTR FIXED(15),         /* SSID CHAIN COUNTER.   @Y30LB51*/
       2 TBLELMCT FIXED(15),        /* FSC TABLE ELEMENT COUNTER.
                                                             @Y30LB51*/
       2 I FIXED(15),               /* WORK COUNTER.         @Y30LB51*/
       2 WORKFLGS BIT(16),          /* WORK FLAGS.           @Y30LB51*/
        3 MSCREC BIT(1),            /* MSC DEVICE RECORD.    @Y30LB51*/
        3 SAREC BIT(1),             /* SA DEVICE RECORD.     @Y30LB51*/
        3 DRCREC BIT(1),            /* DRC DEVICE RECORD.    @Y30LB51*/
        3 DRDREC BIT(1),            /* DRD DEVICE RECORD.    @Y30LB51*/
        3 CSREC BIT(1),             /* CS DEVICE RECORD.     @Y30LB51*/
        3 DIRREC BIT(1),            /* 3830 DEVICE RECORD.   @Y30LB51*/
        3 DAREC BIT(1),             /* 3330 DEVICE RECORD.   @Y30LB51*/
        3 DASDREC BIT(1),           /* DASD DEVICE RECORD.   @Y30LB51*/
        3 FMT3ACC1 BIT(1),          /* RT ACCESSOR FSC.      @Y30LB51*/
        3 FMT3ACC2 BIT(1),          /* LEFT ACCESSOR FSC.    @Y30LB51*/
        3 FSCCOUNT BIT(1),          /* COUNT BY FSC ONLY.    @Y30LB51*/
        3 WORKAPR BIT(1),           /* APR ALTERED SSID.     @Y30LB51*/
        3 TBLFULL BIT(1),           /* CHAIN TABLE FULL.     @ZA17155*/
        3 PERMERR BIT(1),           /* PERMANENT ERROR.      @ZA20267*/
        3 TEMPERR BIT(1),           /* TEMPORARY ERROR.      @ZA20267*/
        3 ADDCORE BIT(1),           /* ADDED FSC TABLE NEEDED SW.
                                                             @Y30LB51*/
       2 LSSID CHAR(2),             /* STORAGE FOR SSID.     @Y30LB51*/
       2 LFSC CHAR(4),              /* STORAGE FOR LIBRARY FSC.
                                                             @Y30LB51*/
       2 LFSCSYS CHAR(2),           /* STORAGE FOR NON-LIBRARY FSC.
                                                             @Y30LB51*/
       2 LTYPE CHAR(2),             /* STORAGE FOR DEVICE TYPE.
                                                             @Y30LB51*/
       2 SSIDSAVE BIT(16),          /* SSID AND FLAGS WORK AREA.
                                                             @Y30LB51*/
        3 CUAFLAG BIT(4),           /* SSID FLAG.            @Y30LB51*/
        3 SSIDDEV BIT(4),           /* DEVICE TYPE CHARACTER.
                                                             @Y30LB51*/
        3 * BIT(8),                 /*                       @Y30LB51*/
       2 SEVSAVE CHAR(2),           /* SEVERITY CODE SAVE AREA.
                                                             @ZA20267*/
       2 SEVMASK BIT(16),           /* SEVERITY CODE SEARCH MASK.
                                                             @ZA20267*/
        3 SEVMFMT BIT(8),           /* RECORD FORMAT.        @ZA20267*/
        3 SEVMSFMT BIT(8),          /* SUBFMT AND MSG CODE.  @ZA20267*/
       2 FSCSYSSV CHAR(2),          /* SAVE AREA FOR NON-LIBRARY FSC.
                                                             @Y30LB51*/
       2 FSCSAVE1 CHAR(4),          /* FSC SAVE AREA (RT ACC).
                                                             @Y30LB51*/
       2 FSCSAVE2 CHAR(4),          /* FSC SAVE AREA (LEFT ACC).
                                                             @Y30LB51*/
       2 SUMBUILD FIXED(15),        /* WORK AREA TO COMPUTE SUM.
                                                             @Y30LB51*/
       2 LINECT FIXED(15),          /* OUTPUT LINE COUNTER.  @Y30LB51*/
       2 DEVBYTES BIT(16),          /* WORK AREA FOR DEVICE ID.
                                                             @ZD00149*/
        3 DEVBYTEA BIT(8),          /* FIRST WORK BYTE.      @ZD00149*/
        3 DEVBYTEB BIT(8);          /* SECOND WORK BYTE.     @ZD00149*/
    %FSCWORKL='LENGTH(FSCWORK)';
 @EJECT;

 /*  FORMAT OF THE FSC TABLE ELEMENT.                                */

    /*****************************************************************/
    /*                                                               */
    /* FSCTBL -- TABLE FOR THE ACCUMULATION OF THE COUNT OF RECORDS  */
    /* PROCESSED.                                                    */
    /*                                                               */
    /*****************************************************************/

     DCL 1 FSCTBL BASED(TBLPTR),    /*                       @Y30LB51*/
       2 FSCSPTR PTR(31),           /* PTR TO NEXT ELEMENT ON SSID
                                       CHAIN.                @Y30LB51*/
       2 FSCSSID CHAR(2),           /* SSID.                 @ZA20267*/
        3 DEVCHAR CHAR(1),          /* DEVICE CHARACTER.     @Y30LB51*/
        3 UNITCHAR CHAR(1),         /* UNIT CHARACTER.       @Y30LB51*/
       2 FSCSEV FIXED(15),          /* SEVERITY CODE.        @ZA20267*/
       2 FSCFSC CHAR(4),            /* FSC.                  @Y30LB51*/
        3 FSCSYS CHAR(2),           /* SUBSYSTEM FSC.        @Y30LB51*/
        3 * CHAR(1),                /*                       @ZD00149*/
        3 CNTLUNIT BIT(8),          /* DASD CONTROL UNIT.    @ZD00149*/
       2 FSCDT CHAR(8),             /* DATE/TIME STAMP.      @Y30LB51*/
        3 FSCDATE CHAR(4),          /* DATE -- YEAR AND DAY. @Y30LB51*/
         4 FSCYR CHAR(2),           /* YEAR.                 @Y30LB51*/
         4 FSCDAY CHAR(2),          /* DAY.                  @Y30LB51*/
        3 FSCTIME CHAR(4),          /* TIME.                 @Y30LB51*/
         4 FSCHR CHAR(1),           /* HOURS.                @Y30LB51*/
         4 FSCMIN CHAR(1),          /* MINUTES.              @Y30LB51*/
         4 FSCSEC CHAR(1),          /* SECONDS.              @Y30LB51*/
         4 FSCHSEC CHAR(1),         /* HUNDREDTHS OF A SECOND.
                                                             @Y30LB51*/
       2 FSCCTR FIXED(15),          /* RECORD COUNTER.       @Y30LB51*/
       2 FSCSUM FIXED(15),          /* TOTAL ERRORS FOR THIS SSID.
                                                             @Y30LB51*/
       2 FSCPCT FIXED(15),          /* PERCENT (FSCCTR/FSCSUM).
                                                             @Y30LB51*/
       2 FSCFLAGS BIT(16),          /* FSC TABLE FLAGS.      @Y30LB51*/
        3 MSCFLAG BIT(1),           /* MSC DEVICE FLAG.      @Y30LB51*/
        3 SAFLAG BIT(1),            /* SA DEVICE FLAG.       @Y30LB51*/
        3 DRCFLAG BIT(1),           /* DRC DEVICE FLAG.      @Y30LB51*/
        3 DRDFLAG BIT(1),           /* DRD DEVICE FLAG.      @Y30LB51*/
        3 CSFLAG BIT(1),            /* CS DEVICE FLAG.       @Y30LB51*/
        3 DIRFLAG BIT(1),           /* 3830 DEVICE FLAG.     @Y30LB51*/
        3 DAFLAG BIT(1),            /* 3330 DEVICE FLAG.     @Y30LB51*/
        3 DASDFLAG BIT(1),          /* DASD SSID FLAG.       @Y30LB51*/
        3 REALDASD BIT(1),          /* REAL DASD FLAG.       @Y30LB51*/
        3 VIRTDASD BIT(1),          /* VIRTUAL DASD FLAG.    @Y30LB51*/
        3 FAKEFSC BIT(1),           /* GENERATED FSC FLAG.   @Y30LB51*/
        3 FSCAPR BIT(1),            /* APR ALTERED SSID FLAG.
                                                             @Y30LB51*/
        3 NOSEVCD BIT(1),           /* NO SEVERITY CODE.     @ZA20267*/
        3 * BIT(2),                 /*                       @Y30LB51*/
        3 INPRTTBL BIT(1),          /* ELEMENT IN PRINT TABLE FLAG.
                                                             @ZD00149*/
       2 FSCDEVS BDY(WORD) CHAR(16),/* DEVICE COUNTERS.      @ZD00149*/
        3 DEVACTR FIXED(15),        /* DEVICE A COUNTER.     @ZD00149*/
        3 DEVBCTR FIXED(15),        /* DEVICE B COUNTER.     @ZD00149*/
        3 DEVCCTR FIXED(15),        /* DEVICE C COUNTER.     @ZD00149*/
        3 DEVDCTR FIXED(15),        /* DEVICE D COUNTER.     @ZD00149*/
        3 DEVECTR FIXED(15),        /* DEVICE E COUNTER.     @ZD00149*/
        3 DEVFCTR FIXED(15),        /* DEVICE F COUNTER.     @ZD00149*/
        3 DEVGCTR FIXED(15),        /* DEVICE G COUNTER.     @ZD00149*/
        3 DEVHCTR FIXED(15);        /* DEVICE H COUNTER.     @ZD00149*/
    %FSCTBLL='LENGTH(FSCTBL)';
 @EJECT;

 /*  FORMAT OF THE CHAIN TABLE ELEMENT.                              */

    /*****************************************************************/
    /*                                                               */
    /* CHNTBL -- THIS TABLE CONTAINS THE SSIDS THAT HAVE BEEN        */
    /* PROCESSED FOR THE FSC REPORT ALONG WITH A POINTER TO THE START*/
    /* OF THE CHAIN OF ENTRIES IN THE FSC TABLE FOR EACH SSID.       */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 CHNTBL BASED(CHNPTR),       /*                       @Y30LB51*/
       2 CHNTPTR PTR(31),           /* PTR TO NEXT TABLE ELEMENT.
                                                             @Y30LB51*/
       2 CHNSSIDF CHAR(2),          /* SSID AND FLAGS AREA.  @Y30LB51*/
        3 SSIDFLGS BIT(4),          /* SSID FLAGS.           @Y30LB51*/
        3 CHNSSID BIT(12),          /* SSID.                 @Y30LB51*/
       2 * CHAR(2),                 /*                       @Y30LB51*/
       2 FSCTPTR PTR(31);           /* PTR TO FSC TABLE.     @Y30LB51*/
    %CHNTBLL='LENGTH(CHNTBL)';
 @EJECT;

 /* FORMAT OF THE SUM TABLE ELEMENT.                                 */

    /*****************************************************************/
    /*                                                               */
    /* SUMTBL -- THIS IS A WORK TABLE USED FOR THE COMPUTATION OF THE*/
    /* TOTAL NUMBER OF RECORDS PROCESSED FOR EACH SSID.              */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 SUMTBL BASED(SUMPTR),       /*                       @Y30LB51*/
       2 SUMTPTR PTR(31),           /* PTR TO NEXT SUM CHAIN ELEMENT.
                                                             @Y30LB51*/
       2 SUMSSID CHAR(2),           /* SSID.                 @Y30LB51*/
       2 SUMTOTAL FIXED(15),        /* TOTAL RECORDS FOR THIS SSID.
                                                             @Y30LB51*/
       2 SUMFPTR PTR(31),           /* PTR TO SSID CHAIN.    @Y30LB51*/
       2 SUMSCTR FIXED(15),         /* COUNT OF ELEMENTS ON SSID
                                       CHAIN.                @Y30LB51*/
       2 SUMPCTR FIXED(15);         /* COUNT OF ELEMENTS PROCESSED.
                                                             @Y30LB51*/
    %SUMTBLL='LENGTH(SUMTBL)';

 /* FORMAT OF THE PRINT TABLE ELEMENT.                               */

    /*****************************************************************/
    /*                                                               */
    /* PRTTBL -- THIS TABLE CONSISTS OF POINTERS TO THE FSC TABLE    */
    /* ENTRIES IN THE ORDER IN WHICH THE FSC TABLE ENTRIES WILL      */
    /* APPEAR IN THE REPORT.                                         */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 PRTTBL BASED(PRTPTR),       /*                       @Y30LB51*/
       2 PRTTPTR PTR(31);           /* PTR TO FSC TABLE ELEMENT.
                                                             @Y30LB51*/
    %PRTTBLL='LENGTH(PRTTBL)';
