
    /*****************************************************************/
    /*                                                       @Y30LB55*/
    /* ISDALOBR - FULL DCL FOR SDA INPUT RECORDS             @Y30LB55*/
    /*                                                       @Y30LB55*/
    /*****************************************************************/

 /* %INCLUDE ISDADCLS(ISDALOBR)                              @Y30LB55*/

    DCL                             /* BASE STRUCTURE FOR RECORDS
                                       FROM SYS1.LOGREC      @Y30LB55*/
      1 OBRMDR BASED(LOGPTR),       /* 1832=BLKSIZE EREP0    @Y30LB55*/
       2 SCW FIXED(31),             /* SEGMENT CONTROL WORD  @Y30LB55*/
        3 SLENGTH FIXED(15),        /* LENGTH OF SEGMENT     @Y30LB55*/
        3 SCODE BIT(8),             /* SEGMENT CODE          @Y30LB55*/
        3 * CHAR(1),                /*                       @Y30LB55*/
       2 CLASRC BIT(8),             /* 0                     @Y30LB55*/
       2 SYSREL BIT(8),             /* 1                     @Y30LB55*/
       2 SWITCHES CHAR(4),          /* 2                     @Y30LB55*/
        3 SWITCH0 BIT(8),
        3 SWITCH1 BIT(8),           /* BIT 2 = 1 = OBR SHORT @Y30LB55*/
        3 SWITCH2 BIT(8),           /* DEV TYPE FOR MDR      @Y30LB55*/
        3 SWITCH3 BIT(8),           /*                       @Y30LB55*/
       2 RCDCNT BIT(8),             /* 6                     @Y30LB55*/
       2 RECENTRY BIT(8),           /* 7 REC TYPE ID FOR MDR @Y30LB55
                                       SHORT(SWAP)                   */
       2 DATETIME CHAR(8),          /* 8 DATETIME USED FOR HI LOW
                                       COMPARES              @Y30LB55*/
        3 DATE CHAR(4),             /* 8 PACKED YEAR AND DAY @Y30LB55*/
         4 YEAR CHAR(2),            /* YEAR IN PACKED DECIMAL@Y30LB55*/
         4 DAY CHAR(2),             /* DAY IN PACKED DECIMAL @Y30LB55*/
        3 TIME CHAR(4),             /* 12 SEE BITS 1 AND 4 OF SWITCH0
                                                             @Y30LB55*/
         4 HOUR CHAR(1),            /* HOUR IN PACKED DECIMAL@Y30LB55*/
         4 MINUTE CHAR(1),          /* MINUTE IN PACKED DECIMAL
                                                             @Y30LB55*/
         4 SECOND CHAR(1),          /* SECOND IN PACKED DECIMAL
                                                             @Y30LB55*/
         4 TENSHUND CHAR(1),        /* TENTHS, HUNDRETHS PACKED
                                                             @Y30LB55*/
       2 VERNO BIT(8),              /* 16                    @Y30LB55*/
       2 CPUSERID CHAR(5),          /* 17-21 CPU USER+ID     @Y30LB55*/
        3 CPUSER CHAR(3),           /* 17                    @Y30LB55*/
        3 CPUID CHAR(2),            /* 20                    @Y30LB55*/
       2 SDRCNT1 CHAR(2),           /* 22 OBR SHORT DATA LENGTH
                                                             @Y30LB55*/
       2 DEVDEP1,                   /* 24 DEVICE DATA FOR MDR LONG
                                                             @Y30LB55*/
        3 JOBID CHAR(8),            /* 24 OBR LONG           @Y30LB55*/
         4 DEVTYPE1 CHAR(4),        /* 24 OBR SHORT UCBTYP   @Y30LB55*/
          5 MDRCUA CHAR(2),         /* 24 CUA FOR ALL MDR    @Y30LB55*/
         4 * CHAR(1),               /* 28 OBR SHORT          @Y30LB55*/
         4 CUA2 CHAR(3),            /* 29 OBR SHORT          @Y30LB55*/
        3 SDRINF,                   /* 32 OBR SHORT, ALL MDR DATA
                                                             @Y30LB55*/
         4 FAILCCW CHAR(8),         /* 32 OBR LONG           @Y30LB55*/
         4 CSW CHAR(8),             /* 40 OBR LONG           @Y30LB55*/
         4 DEVDEPC CHAR(1),         /* 48 NO. DEVDEP/8       @Y30LB55*/
         4 SECUA CHAR(3),           /* 49 OBR LONG           @Y30LB55*/
         4 DEVTYPE2 CHAR(4),        /* 52 OBR LONG UCBTYP    @Y30LB55*/
         4 SDRCNT2 CHAR(1),         /* 56 NO. SDR BYTES      @Y30LB55*/
         4 PCUA CHAR(3),            /* 57 OBR LONG-PRIMARY CUA
                                                             @Y30LB55*/
         4 IORETRY CHAR(2),         /* 60 OBR LONG           @Y30LB55*/
         4 SENSCNT CHAR(2),         /* 62 SENSE LENGTH       @Y30LB55*/
         4 DEVDEP2 CHAR(1764);      /* 64 OBR LONG DATA      @Y30LB55*/
    %OBRMDRL='LENGTH(OBRMDR)';                             /*@Y30LB55*/
    DCL
      1 DEVTYPE CHAR(4) BASED(DEVPTR),/* UCBTYP FIELD        @Y30LB55*/
       2 IOFLAGS BIT(8),            /*                       @Y30LB55*/
       2 OPTFLAGS BIT(8),           /*                       @Y30LB55*/
       2 CLASTYPE BIT(16),          /*                       @Y30LB55*/
        3 DEVCLASS BIT(8),          /*                       @Y30LB55*/
        3 UNITTYPE BIT(8);                                 /*@Y30LB55*/

 /*  DCL DEVPTR PTR(31)  ADDRESS OF DEVTYPE1 OR DEVTYPE2     @Y30LB55*/
 /*  DCL  LOGPTR PTR(31)  AND SET LOGPTR=DATAPTR             @Y30LB55*/
 /*  %OBRMDRL='LENGTH(OBRMDR)'                               @Y30LB55*/
