
    /*****************************************************************/
    /*                                                               */
    /* ISDAMSCS - 32 BYTE MSS SENSE DCL                              */
    /*                                                               */
    /*****************************************************************/

 /* %INCLUDE ISDADCLS(ISDAMSCS)                              @Y30LB55*/

    DCL                             /* MSC SENSE DATA        @Y30LB55*/
      1 ISDAMSCS BASED(SENSEPTR),   /* 32 BYTE SENSE         @Y30LB55*/
       2 STATUS BIT(8),             /* 0 MSC STATUS BYTE     @Y30LB55*/
       2 SUBSYSID BIT(16),          /* 1,2 SSID IN BITS (4-15)
                                                             @Y30LB55*/
        3 SSIDFLAG BIT(4),          /* CE,OFF LINE,HOST CHAN ID
                                                             @Y30LB55*/
        3 SSID BIT(12),             /* 3 DIGIT SSID          @Y30LB55*/
         4 SSIDTYPE BIT(4),         /* 0=DASD,1=CS,2=DRD,4=DRC,8=SA
                                                             @Y30LB55*/
         4 SSIDLIBN BIT(4),         /* RSG 0-29,CS NO. 0-3,SA NO. 0-F
                                                             @Y30LB55*/
         4 SSIDDEVT BIT(4),         /* LOWER DEVICE ID,      @Y30LB55
                                       0-7,0-2,0-7,0-3,0             */
       2 FORMATNO BIT(8),           /* 3 FORMAT IN BITS(0-5) @Y30LB55*/
       2 SUBSENSE CHAR(28),         /* 28 BYTE SENSE DATA    @Y30LB55*/
        3 SUBSTAT4 BIT(8),          /* 4 BYTE 0 OF LOWER UNIT@Y30LB55*/
        3 SUBSTAT5 BIT(8),          /* 5 BYTE 1 OF LOWER UNIT@Y30LB55*/
        3 SALOWADD BIT(8),          /* 6 (SA BYTE 6)=LOWER LOGICAL
                                       ADDR                  @Y30LB55*/
        3 DASDFMTN BIT(8),          /* 7 DASD OBR FORMAT NUMBER
                                                             @Y30LB55*/
        3 * CHAR(1),                /* 8 SPARE               @Y30LB55*/
        3 SARETRY BIT(8),           /* 9 (SA BYTE 5)= RETRY  @Y30LB55*/
        3 SALOWAD2 BIT(8),          /* 10 SAME AS BYTE 6, SALOWADD
                                                             @Y30LB55*/
        3 SUBFMTMG BIT(8),          /* 11 SUBFMT AND MSG CODE@Y30LB55*/
         4 SUBFMTNO BIT(4),         /* SUBFORMAT NUMBER      @Y30LB55*/
         4 MSGCODEN BIT(4),         /* MESSAGE CODE          @Y30LB55*/
        3 * CHAR(10),               /* 12-21                 @Y30LB55*/
        3 DASDFSC BIT(16),          /* 22,23 DASD OBR FAULT SYMPTOM
                                       CODE                  @Y30LB55*/
        3 RUADASD BIT(8),           /* 24 DASD REAL UNIT ADDRESS
                                                             @Y30LB55*/
        3 * CHAR(1),                /* 25                    @Y30LB55*/
        3 MSCFSC BIT(16),           /* 26,27 (SA BYTE 22,23)=FMT 4,5
                                       FSC                   @Y30LB55*/
        3 RUAMSCD BIT(8),           /* 28 RUA FOR VIRT DASD  @Y30LB55*/
        3 RCYLMSCD BIT(16),         /* 29,30 REAL CYL FOR VIRT DASD
                                                             @Y30LB55*/
        3 SANOMSCD BIT(8);          /* 31 SA NUMBER FOR VIRT DASD
                                                             @Y30LB55*/
    %MSCSENSL='LENGTH(ISDAMSCS)';                          /*@Y30LB55*/

 /*  %MSCSENSL='LENGTH(ISDAMSCS)'                            @Y30LB55*/
 /* DCL SENSEPTR PTR(31)  AND SET SENSEPTR=SDATAPTR          @Y30LB55*/
