    /*****************************************************************/
    /*                                                               */
    /*                                                       @Y30LB52*/
    /* THE FOLLOWING VARIABLES AND STRUCTURES MAP THE VARIABLE       */
    /* CONFIGURATION DATA PRODUCED BY THE 'ISDACNFG' ROUTINE. THE    */
    /* TABLES ARE ANCHORED BY POINTERS IN THE FIXED CONFIGURATION    */
    /* STRUCTURE.                                            @Y30LB52*/
    /*                                                       @Y30LB52*/
    /*                                                               */
    /*****************************************************************/

    DCL

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THE FOLLOWING IS A BASED VARIABLE MAPPING THE 16 POSSIBLE   */
      /* CPU SERIAL ID'S ATTACHED TO THE SUBSYSTEM IN THE    @Y30LB52*/
      /* CONFIGURATION DESCRIBED. EACH SERIAL IS 5 BYTES.    @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      CPUSERS CHAR(80) BASED(CPUSERAD),/* CPU SERIALS        @Y30LB52*/

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THIS STRUCTURE MAPS THE LOGICAL CONFIGURATION OF THE SS/1   */
      /* DRC'S AND DRD'S ONTO THE PHYSICAL CONFIGURATION THIS@Y30LB52*/
      /* STRUCTURE CONTAINS AN ENTRY FOR EACH DRC IN A PHYSICAL      */
      /* LIBRARY. FOR EACH ENTRY THE PHYSICAL SA(FOR DRC) AND ITS    */
      /* LOGICAL CONNECTION IS GIVEN.                        @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      LTPDRDP PTR(31),              /* LOGICAL TO PHYSICAL TABLE BASE
                                                             @Y30LB52*/
      1 LTPDRDTB CHAR(8) BDY(HWORD) BASED(LTPDRDP),/* LOGICAL TO
                                       PHYSICAL SA-CONTROLLER
                                       CONNECTION TABLE      @Y30LB52*/
       2 LTPDRC(4) CHAR(2),         /* FOUR CONTROLLERS MAXIMUM PER
                                       CARTRIDGE STORE       @Y30LB52*/
        3 DRCL0 CHAR(1),            /* SA AND LOGICAL CONNECTION FOR
                                       FIRST INTERFACE       @Y30LB52*/
        3 DRCL1 CHAR(1),            /* SA CNTN AND LOGICALNO.
                                                             @Y30LB52
                                                                     */
 @EJECT;

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* FOR EACH MSC, THERE IS A SA ARRAY                   @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      1 SADRDDSD(16) CHAR(8) BDY(WORD) BASED,/* TWO LOWER LEVEL
                                       POINTERS FOR EACH SA  @Y30LB52*/
       2 SADRDACC PTR(31),          /* PTR TO DRD ACCUMULATORS       */
       2 SADASDAC PTR(31),          /* PTR TO DASD ACCUMULATORS      */
      CSADRDDS CHAR(128) DEF(SADRDDSD),/* CHARACTER MAP OF THE ABOVE
                                       ARRAY                 @Y30LB52*/

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* FOR EACH SA, THERE IS A SEPARATE SET OF ACCUMULATORS@Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      DRDACCTB(4,4) CHAR(6) BDY(HWORD) BASED,/* ARRAY OF ERROR
                                       ACCUMULATORS FOR AN ENTIRE
                                       LIBRARY               @Y30LB52*/
      CDRDACCT CHAR(96) DEF(DRDACCTB),/* CHARACTER MASK FOR THE
                                       ACCUMULATOR ARRAY     @Y30LB52*/
      1 DRDACCS BASED,              /* THREE ERROR TYPES     @Y30LB52*/
       2 DRDERRS FIXED(15),         /* DRD ERRORS            @Y30LB52*/
       2 CTLIERRS FIXED(15),        /* CTL-I INTERFACE ERRORS@Y30LB52*/
       2 DRCERRS FIXED(15),         /* DRD CONTROLLER ERRORS @Y30LB52
                                                                     */
 @ EJECT;

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THIS IS THE TOP LEVEL OF AN ALTERNATE MEANS OF ACCESSING THE*/
      /* STRUCTURE OF HOST/SA DASD ERROR ACCUMULATORS. THIS IS AN    */
      /* ARRAY OF POINTERS TO THE 'CHCUTAB' ENTRIES BASED ON 'SA'    */
      /* NUMBER AND INTERFACE.                               @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      SAINTF(3) PTR(31) BASED,      /* ONE POINTER FOR EACH UPPER
                                       INTERFACE ATTACHED TO A HOST
                                       CHANNEL               @Y30LB52*/

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THIS STRUCTURE MAPS THE TABLE EQUATING CPU/CH/CU    @Y30LB52*/
      /* IDENTIFICATIONS TO ABSOLUTE STORAGE ADAPTOR UPPER   @Y30LB52*/
      /* INTERFACES. THIS TABLE ALSO PROVIDES A POINTER, FOR EACH    */
      /* INTERFACE, TO AN ARRAY OF ACCUMULATORS FOR ERRORS IN A DASD */
      /* PATH.                                               @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      1 CHCUTAB CHAR(12) BDY(WORD) BASED,/* CHANNEL AND CONTROL UNIT
                                       TO SA TABLE           @Y30LB52*/
       2 CPUIDSER CHAR(5),          /* HOST SERIAL           @Y30LB52*/
       2 CHCU CHAR(1),              /* CHANNEL/CONTROL UNIT IDS      */
       2 SA CHAR(1),                /* SA NUMBER             @Y30LB52*/
       2 INTF CHAR(1),              /* WHICH INTERFACE       @Y30LB52*/
       2 SPLTABP PTR(31),           /* PTR TO SPINDLE ACCUMULATORS   */

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* FOR EACH SA AND UPPER INTERFACE(B, C, D), THERE IS A SET OF */
      /* ACCUMULATORS, ONE FOR EACH LOGICAL CONTROLLER AND PHYSICAL  */
      /* DRIVE                                               @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      SPNDLETB(4,8) CHAR(6) BDY(HWORD) BASED,/* SPINDLE ACCUMULATORS */
      CSPNDLET CHAR(192) DEF(SPNDLETB),/* CHARACTER MAP      @Y30LB52*/
      1 SPNDLES BASED,              /* THREE RECORDED ERRORS @Y30LB52*/
       2 DRVEQCHK FIXED(15),        /* DRIVE CHECKS          @Y30LB52*/
       2 STCTLCHK FIXED(15),        /* STORAGE CONTROL CHECKS@Y30LB52*/
       2 STCTLCCK FIXED(15),        /* STORAGE CONTROL CONTROL CHECKS
                                                             @Y30LB52
                                                                     */
 @EJECT;

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THIS STRUCTURE MAPS THE HEADER OF THE FIRST BLOCK OF DYNAMIC*/
      /* STORAGE OBTAINED.                                   @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      1 P0WORK BDY(WORD) BASED(PAD00PTR),
       2 PADFPTR PTR(31),           /* NEXT BLOCK ADDRESS    @Y30LB52*/
       2 PADLASTB PTR(31),          /* LAST BLOCK ADDRESS    @Y30LB52*/
       2 COREASG PTR(31),           /* NEXT AVAILABLE BYTE   @Y30LB52*/
       2 ENDCORE PTR(31),           /* END OF BLOCK          @Y30LB52*/

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THE HIGHEST LEVEL CONTAINS MSC UNIT ADDRESSES AND A POINTER */
      /* TO AN SA TABLE                                      @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

       2 MSCDRDAC(8) CHAR(8) BDY(WORD),
        3 MSCINTF CHAR(2),          /* MSC UNIT ADDRESS      @Y30LB52*/
        3 * CHAR(2),
        3 SATABPTR PTR(31),         /* POINTER TO THE SA LEVEL       */

      /***************************************************************/
      /*                                                             */
      /* TOTAL ERROR ACCUMULATOR FOR CARTRIDGE STORE'S AND MSC'S     */
      /*                                                             */
      /***************************************************************/

      2 CSFTOTAL(4) FIXED(15),      /* CS TOTALS             @Y30LB52*/
      2 MSCTOTAL FIXED(15),         /* TOTAL ERRORS FOR MSC(DASD)
                                                             @Y30LB52*/
      2 HTOTAL FIXED(15),           /* TOTAL ERRORS FROM HOST(DASD)
                                                             @Y30LB52*/

      /***************************************************************/
      /*                                                             */
      /*                                                     @Y30LB52*/
      /* THIS STRUCTURE MAPS THE HEADER OF ALL BLOCKS AFTER THE      */
      /* FIRST.                                              @Y30LB52*/
      /*                                                     @Y30LB52*/
      /*                                                             */
      /***************************************************************/

      1 P0WORK1 BDY(WORD) BASED,
       2 PADFPTR1 PTR(31);
