
    /*****************************************************************/
    /*                            ISDAPRMS                           */
    /* SDA PARAMATER CONTROL BLOCK. THIS CONTROL BLOCK IS USED BY THE*/
    /* MAIN PROC FOR DISPATCHING. IF THE CONTROL FLAG FOR A          */
    /* PARTICULAR REPORT IS '00'X THE REPORT PROC IS NEVER CALLED.   */
    /* THOSE REPORTS THAT HAVE MORE THAN ONE FUNCTION MUST CHECK ITS */
    /* CONTROL FLAG FOR THE VALUE '01'X=REPORT 1 ONLY, '02'X=REPORT2 */
    /* ONLY, AND '03'X=BOTH REPORT 1 AND 2. IF AN ACCUMULATOR DECIDES*/
    /* THAT IT CANNOT PRODUCE A MEANINGFUL REPORT, IT SHOULD RESET   */
    /* ITS REPORT CONTROL FLAG TO '00'X. THIS WILL PREVENT THE       */
    /* CONTROLLER FROM EVER CALLING EITHER THE ACCUMLATOR OR THE     */
    /* OUTPUT FORMATER FOR THAT REPORT.                              */
    /*                                                               */
    /*****************************************************************/

 /* %INCLUDE ISDADCLS(ISDAPRMS)                              @Y30LB55*/

    DCL                             /* SDA CONTROL PARAMATERS@Y30LB55*/
      1 ISDAPRMS BASED(LPARMPTR),
       2 CINPUT CHAR(2),            /* (XY) = INPUT SOURCE   @Y30LB55*/
        3 CLOGIN CHAR(1),           /* (Y|N) = LOGREC        @Y30LB55*/
        3 CHISTIN CHAR(1),          /* (Y|N) = HISTORY       @Y30LB55*/
       2 CSTART CHAR(4),            /* (00YYDDDF) = START DATE
                                                             @Y30LB55*/
        3 CSTYEAR CHAR(2),          /* (00YY) = YEAR         @ZD00192*/
        3 CSTDAY  CHAR(2),          /* (DDDF) = DAY          @ZD00192*/
       2 CEND CHAR(4),              /* (00YYDDDF) = END DATE @Y30LB55*/
        3 CENDYEAR CHAR(2),         /* (00YY) = YEAR         @ZD00192*/
        3 CENDDAY  CHAR(2),         /* (DDDF) = DAY          @ZD00192*/
       2 CSUMMARY CHAR(1),          /* (X) = Y OR N          @Y30LB55*/
       2 CTYPE CHAR(2),             /* (XX) = SA|RC|RD|CS|DA @Y30LB55*/
       2 CFSCONLY CHAR(4),          /* (FSC)=FAULT SYMPTOM CODE (HEX)
                                                             @Y30LB55*/
        3 CFSC12 CHAR(2),           /* 2 BYTE FSC FOR FMT 4 AND 5
                                                             @Y30LB55*/
        3 CFSC34 CHAR(2),           /* ='00' WHEN 2 BYTE FSC @Y30LB55*/
       2 CSSIDF CHAR(2),            /* (SSID) = SUBSYSTEM ID (HEX)
                                                             @Y30LB55*/
        3 * BIT(4),                 /* ZERO                  @Y30LB55*/
        3 CSSID BIT(12),            /* (SSID) = SUBSYSTEM ID @Y30LB55*/
       2 CRATIO CHAR(2),            /* (XX) = ERROR RATIO TO PRINT
                                                             @Y30LB55*/
       2 CSERIAL CHAR(12),          /* (XXX YYYYYYYY) CART SER
                                                             @Y30LB55*/
        3 CIBM CHAR(3),             /* ALPHA ID OF CART      @Y30LB55*/
        3 * CHAR(1),                /* BLANK                 @Y30LB55*/
        3 CSERNO CHAR(8),           /* CART SERIAL NO.       @Y30LB55*/
 /*  REPORT CONTROL FLAGS, '00'X = REPORT NOT REQUESTED      @Y30LB55*/

       2 CREPORTS,                  /* REPORT CONTROL FLAGS  @Y30LB55*/
        3 CDCS BIT(8),              /* (X) = 00 OR 01 HEX    @Y30LB55*/
        3 CPAD BIT(8),              /* (X) = 00 OR 01 HEX    @Y30LB55*/
        3 CSUM BIT(8),              /* (X) = 00,01,02, OR 03 HEX
                                  01=SUM, 02=DETAIL, 03=BOTH @Y30LB55*/

        3 CDHEDHU BIT(8),           /* (X) = 00,01,02, OR 03 HEX
                                    01=DHE, 02=DHU, 03=BOTH  @Y30LB55*/

        3 CFSC BIT(8),              /* (X) = 00 OR 01 HEX    @Y30LB55*/
        3 CEQC BIT(8),              /* (X) = 00 OR 01 HEX    @Y30LB55*/
        3 CDCKTLX BIT(8),           /* (X) = 00,01,02, OR 03 HEX
                                    01=DCK, 02=TLX, 03=BOTH  @Y30LB55*/

        3 CCSBCSF BIT(8),           /* (X) = 00,01,02, OR 03 HEX
                                    01=CSB, 02=CSF, 03=BOTH  @Y30LB55*/

        3 CDAT BIT(8),              /* (X) = 00 OR 01 HEX    @Y30LB55*/
        3 CDRC BIT(8),              /* (X) = 00 OR 01 HEX    @Y30LB55*/
        3 CAPRSUU BIT(8),           /* (X) = 00,01,02, OR 03 HEX
                                  01=APR, 02=SUU, 03=BOTH    @ZD00192*/
        3 CPWR BIT(8),              /* SPARE - RESERVED      @ZM30976*/
       2 CPERIOD FIXED(8),          /* (X) = NO. DAYS TO REPORT
                                                             @Y30LB55*/
       2 CDETAIL BIT(8),            /* (X) = SUMMARY PRINT MASK
                                                             @ZD00192*/
  /*                                   BIT 0 = FORMAT 0
                                       BIT 1 = FORMAT 1
                                       BIT 2 = FORMAT 2
                                       BIT 3 = FORMAT 3
                                       BIT 4 = FORMAT 4
                                       BIT 5 = FORMAT 5
                                       BIT 6 = TRACE IN ISDASDA0
                                       BIT 7 = NOT USED              */
       2 CGEN BIT(8),               /* (X)=00,01,02,04(NO,SUM,FSC,EQC)
                                                             @Y30LB55*/
       2 CTRACE BIT(8);             /* (X)=00 FOR TRACE OFF, XX FOR
                                       TRACE ON              @Y30LB55*/
    %SDAPARML='LENGTH(ISDAPRMS)';                          /*@Y30LB55*/

 /*  %SDAPARML='LENGTH(ISDAPRMS)'                            @Y30LB55*/
 /* DCL LPARMPTR PTR(31)  AND SET LPARMPTR=PARMPTR           @Y30LB55*/
