
    /*****************************************************************/
    /*                                                               */
    /* ISDASOBR - SHORT DCL FOR SDA INPUT RECORDS                    */
    /*                                                               */
    /*****************************************************************/

 /* %INCLUDE ISDADCLS(ISDASOBR)                              @Y30LB55*/

    DCL                             /* SHORT STRUCTURE FOR RECORDS
                                       FROM SYS1.LOGREC      @Y30LB55*/
      1 OBRMDR BASED(LOGPTR),       /* SHORT OBR-MDR HEADER  @Y30LB55*/
       2 SCW FIXED(31),             /* SEGMENT CONTROL WORD  @Y30LB55*/
        3 SLENGTH FIXED(15),        /* LENGTH OF SEGMENT     @Y30LB55*/
        3 SCODE BIT(8),             /* SEGMENT CODE          @Y30LB55*/
        3 * CHAR(1),                /*                       @Y30LB55*/
       2 CLASRC BIT(8),             /* 0                     @Y30LB55*/
       2 SYSREL BIT(8),             /* 1                     @Y30LB55*/
       2 SWITCHES CHAR(4),          /* 2                     @Y30LB55*/
        3 SWITCH0 BIT(8),           /*                       @Y30LB55*/
        3 SWITCH1 BIT(8),           /* BIT 2 = 1 = OBR SHORT @Y30LB55*/
        3 SWITCH2 BIT(8),           /* DEV TYPE FOR MDR      @Y30LB55*/
        3 SWITCH3 BIT(8),           /*                       @Y30LB55*/
       2 RCDCNT BIT(8),             /* 6                     @Y30LB55*/
       2 RECENTRY BIT(8),           /* 7 REC TYPE ID FOR MDR @Y30LB55
                                       SHORT(SWAP)                   */
       2 DATETIME CHAR(8),          /* 8 DATETIME USED FOR HI LOW
                                       COMPARES              @Y30LB55*/
        3 DATE CHAR(4),             /* 8 PACKED YEAR AND DAY @Y30LB55*/
         4 YEAR CHAR(2),            /* YEAR IN PACKED DECIMAL@Y30LB55*/
         4 DAY CHAR(2),             /* DAY IN PACKED DECIMAL @Y30LB55*/
        3 TIME CHAR(4),             /* 12 SEE BITS 1 AND 4 OF SWITCH0
                                                             @Y30LB55*/
         4 HOUR CHAR(1),            /* HOUR IN PACKED DECIMAL@Y30LB55*/
         4 MINUTE CHAR(1),          /* MINUTE IN PACKED DECIMAL
                                                             @Y30LB55*/
         4 SECOND CHAR(1),          /* SECOND IN PACKED DECIMAL
                                                             @Y30LB55*/
         4 TENSHUND CHAR(1),        /* TENTHS, HUNDRETHS PACKED
                                                             @Y30LB55*/
       2 VERNO BIT(8),              /* 16                    @Y30LB55*/
       2 CPUSERID CHAR(5),          /* 17-21 CPU USER+ID     @Y30LB55*/
        3 CPUSER CHAR(3),           /* 17                    @Y30LB55*/
        3 CPUID CHAR(2);            /* 20                    @Y30LB55*/
    %OBRMDRL='LENGTH(OBRMDR)';                             /*@Y30LB55*/

 /*  %OBRMDRL='LENGTH(OBRMDR)'                               @Y30LB55*/
 /* DCL LOGPTR PTR(31) AND SET LOGPTR=DATAPTR                @Y30LB55*/
