
    /*****************************************************************/
    /*                                                               */
    /* SUMWORK - LOCAL DYNAMIC WORKAREA                              */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 SUMWORK BASED(SUMWKPTR),    /* ISDASUM0 WORK AREA    @Y30LB55*/
       2 SUMWORK1,                  /* POINTERS AND COUNTERS @Y30LB55*/
        3 ACCM0PTR PTR(31),         /* PTR TO ACCUMULATOR 0  @Y30LB55*/
        3 ACCUMPTR PTR(31),         /* PTR TO START OF SUMACCUM
                                                             @Y30LB55*/
        3 ACCM0END PTR(31),         /* PTR TO END OF SUMACCUM@Y30LB55*/
        3 LOGPTR PTR(31),           /* PTR TO OBRMDR         @Y30LB55*/
        3 SENSEPTR PTR(31),         /* PTR TO MSCSENSE       @Y30LB55*/
        3 RCODEPTR PTR(31),         /* PTR TO RCODES         @ZM31074*/
        3 RCODECNT FIXED(31),       /* COUNT OF REASON CODES @ZM31074*/
        3 SUM2PTR PTR(31),          /* ADDR OF ISDASUM2 + 4  @Y30LB55*/
        3 SEVSTART PTR(32),         /* START ADDR SEVRLIST   @ZA20267*/
        3 SEVRLEN FIXED(32),        /* LENGTH OF SEVRLIST    @ZA20267*/
        3 SEVRLCNT FIXED(32),       /* NO. SEVRLIST ENTRIES  @ZA20267*/
        3 GTOTALS,                  /* GRAND TOTALS FOR FORMATS
                                                             @Y30LB55*/
          5 CNTF0 FIXED(31),        /* COUNT OF FORMAT 0     @Y30LB55*/
          5 CNTF1 FIXED(31),        /* COUNT OF FORMAT 1     @Y30LB55*/
          5 CNTF2 FIXED(31),        /* COUNT OF FORMAT 2     @Y30LB55*/
          5 CNTF3 FIXED(31),        /* COUNT OF FORMAT 3     @Y30LB55*/
          5 CNTF4 FIXED(31),        /* COUNT OF FORMAT 4     @Y30LB55*/
          5 CNTF5 FIXED(31),        /* COUNT OF FORMAT 5     @Y30LB55*/
          5 CNTFDASD FIXED(31),     /* COUNT OF HOST DASD    @Y30LB55*/
          5 CNTSENSE FIXED(31),     /* COUNT OF SENSE RECORDS@Y30LB55*/
          5 CNTLOG FIXED(31),       /* COUNT OF BUFFERED LOG RECORDS
                                                             @Y30LB55*/
        3 TOTPERMS FIXED(31),       /* NO. OF PERM ERRORS    @Y30LB55*/
        3 TOTTEMPS FIXED(31),       /* NO. OF TEMP ERRORS    @Y30LB55*/
        3 ACCUMCNT FIXED(16),       /* NO. OF ACCUMULATORS   @Y30LB55*/
        3 SUMACCL FIXED(16),        /* LENGTH OF SUMACCUM    @Y30LB55*/
        3 NCOUNTER FIXED(16),       /* NUMBER OF COUNTERS IN SUMACCUM
                                                             @Y30LB55*/
        3 NCPUUSED FIXED(16),       /* NO. CPUIDS FOUND      @Y30LB55*/
        3 NCPUCNTS FIXED(16),       /* MAX NO. CPUIDS ALLOWED@Y30LB55*/
       2 SUMWORK2,                  /* CPU IDS               @Y30LB55*/
        3 CPUFOUND(16) CHAR(5),     /* 16 CPUIDS TOTAL FOUND @Y30LB55*/
       2 SUMTEMPS,                  /* TEMP AREA             @Y30LB55*/
        3 TEMP9 CHAR(9),            /* USED FOR CVD          @Y30LB55*/
         4 TEMP8 CHAR(8),           /* USED FOR CVD          @Y30LB55*/
          5 TEMP7 CHAR(7),          /* USED FOR CVD          @Y30LB55*/
           6 TEMP6 CHAR(6),         /* USED FOR CVD          @Y30LB55*/
            7 TEMP5 CHAR(5),        /* USED FOR CVD          @Y30LB55*/
             8 TEMP4 CHAR(4),       /* USED FOR CVD          @Y30LB55*/
              9 TEMP3 CHAR(3),      /* USED FOR CVD          @Y30LB55*/
               10 TEMP2 CHAR(2),    /* USED FOR CVD          @Y30LB55*/
                11 TEMP1 CHAR(1),   /* TEMP CHAR             @Y30LB55*/
        3 TEMP20 CHAR(20),          /* SAVEAREA FOR LINE 2 OF DETAIL
                                                             @Y30LB55*/
         4 TEMP16 CHAR(6),          /* CPUSERM01             @Y30LB55*/
         4 TEMP710 CHAR(4),         /* CPUIDM01              @Y30LB55*/
         4 TEMP1113 CHAR(3),        /* SSIDM01               @Y30LB55*/
         4 TEMP1417 CHAR(4),        /* FSCM01                @Y30LB55*/
         4 TEMP1820 CHAR(3),        /* DEVCUA01              @Y30LB55*/
        3 TEMP3032 CHAR(3),         /* END OF 32 BYTE AREA   @Y30LB55*/
       2 SUMWORK3,                  /* MASKS AND FLAGS       @Y30LB55*/
        3 SUMFLAGS BIT(8),          /* COMUNICATION BYTE     @Y30LB55*/
 /*  SUMFLAGS - USED FOR COMMUNICATION BETWEEN ISDASUM0 AND ISDASUM1
     BIT 0 = 1 FOR SPECIAL CALL TO SUM0 TO PRINT SEVERITY REPORT
     BIT 1 = SPARE
     BIT 2 = SPARE
     BIT 3 = SPARE
     BIT 4 = SPARE
     BIT 5 = SPARE
     BIT 6 = SPARE
     BIT 7 = CPUFOUND TABLE OVERFLOWED                       @ZA20267*/

        3 FORMATNC CHAR(1),         /* EBCDIC FORMAT NUMBER  @Y30LB55*/
        3 MAINMASK,                 /* 3 BYTE MASK           @Y30LB55*/
          5 FORMATCK BIT(8),        /* FORMATNO BITS 0-5     @Y30LB55*/
          5 FLAGMASK BIT(8),        /* FLAG MASK             @Y30LB55*/
          5 SUBFMASK BIT(8),        /* SUBFMT MSG CODE MASK  @Y30LB55*/
        3 FMTIDSV CHAR(7),          /* EBCDIC RECORD ID      @Y30LB55*/
        3 SUBFIDSV CHAR(1),         /* EBCDIC SUBFORMAT NO.  @Y30LB55*/
        3 MSGCODSV CHAR(1),         /* EBCDIC MESSAGE CODE   @Y30LB55*/
        3 TSEVTEMP,                 /* SEVERITY WORK AREA    @ZA20267*/
         4 TSEVCDID,                /* SEV CODE + SSID       @ZA20267*/
          5 TSEVCODE CHAR(2),       /* SEVERITY CODE         @ZA20267*/
          5 TSSID CHAR(2),          /* SSID                  @ZA20267*/
         4 TPTFLAG BIT(8),          /* PERM-TEMP FLAG        @ZA20267*/
         4 TSEVFMTS,                /* FORMAT + SUBFMT       @ZA20267*/
          5 TSEVFMT BIT(8),         /* FORMAT                @ZA20267*/
          5 TSEVSUBF BIT(8),        /* SUBFORMAT + MSG CODE  @ZA20267*/
         4 TSEVMASK BIT(8),         /* RECORD TYPE MASK      @ZA20267*/
         4 TSEVECOD BIT(8);         /* BYTE 12 OR BYTE 27    @ZA20267*/
    %SUMWORKL='LENGTH(SUMWORK)';    /* LENGTH OF SUMWORK     @Y30LB55*/
 /* %SUMWORKL='LENGTH(SUMWORK)'  LENGTH OF SUMWORK           @Y30LB55*/

    DCL                             /* OVERLAYS FOR UNPACK   @Y30LB55*/
      TEMP68 CHAR(3) DEF(TEMP8) POS(6),/* BYTES 6-8          @Y30LB55*/
      TEMP78 CHAR(2) DEF(TEMP8) POS(7);/* BYTES 7-8          @Y30LB55*/

    /*****************************************************************/
    /*                                                               */
    /* ACCUMULATOR FOR ISDASUM0                                      */
    /*                                                               */
    /*****************************************************************/

    DCL
      SUMACCUM BASED(ACCUMPTR);     /* FORMAT COUNTERS       @Y30LB55*/

    /*****************************************************************/
    /*                                                               */
    /* MODEL FOR DEFAULT TABLE ISDASUM2 (OFFSET 4)                   */
    /*                                                               */
    /*****************************************************************/

    DCL                             /* MODEL FOR DEVIDTB     @Y30LB55*/
      1 MDEVIDTB BASED(DEVIDPTR),   /* 48 BYTES EACH ENTRY   @Y30LB55*/
        3 MDFMTXXX,                 /* FORMAT X              @Y30LB55*/
          5 MDMASK,                 /* 3 BYTE MASK           @Y30LB55*/
            7 MDFXXX BIT(8),        /* FORMAT MASK           @Y30LB55*/
 /* MDFLAG - 8 BIT FLAG FOR COMPARE WITH FLAGMASK            @Y30LB55
     BIT 0 = DRD UNLOAD FAILURE = SA FMT 9C,9D, OR 9E
     BIT 1 = SPARE
     BIT 2 = REAL 3330
     BIT 3 = VIRTUAL 3330
     BIT 4 = FORMAT 0 UNIT UNUSABLE OR MEDIA FAILURE
     BIT 5 = CS RECONFIGURED
     BIT 6 = CS FORCED LOGGING MODE
     BIT 7 = BUFFERED LOG DATA                               @Y30LB55*/

            7 MDFLAG BIT(8),        /* FLAG MASK             @Y30LB55*/
            7 MDSMXXX BIT(8),       /* SUBFMT MSG CODE MASK  @Y30LB55*/
          5 MDIDS,                  /* FORMAT IDS            @Y30LB55*/
            7 MDCFXXX CHAR(4),      /* FORMAT ID             @Y30LB55*/
            7 MDCSMXXX CHAR(2),     /* SUBFMT MSG CODE ID    @Y30LB55*/
             8 MDCSXXX CHAR(1),     /* EBCDIC SA FORMAT      @Y30LB55*/
             8 MDCMXXX CHAR(1),     /* EBCDIC MSG CODE       @Y30LB55*/
            7 MDIDXXX CHAR(5),      /* DEVICE ID             @Y30LB55*/
          5 MDMSGXXX CHAR(34);      /* FORMAT MESSAGE        @Y30LB55*/
    %DFMTL='LENGTH(MDEVIDTB)';      /* LENGTH OF EACH ENTRY  @Y30LB55*/
 /* DFMTL='LENGTH(MDEVIDTB)' LENGTH OF EACH ENTRY            @Y30LB55*/

    /*****************************************************************/
    /*                                                               */
    /* MODEL FOR COUNTERS - SUMACCUM                                 */
    /*                                                               */
    /*****************************************************************/

    DCL                             /* MODEL FOR SUMACCUM    @Y30LB55*/
      1 MCOUNTER BASED(COUNTPTR),   /* 28 BYTES EACH ENTRY   @Y30LB55*/
        3 MCFMTXXX,                 /* COUNTER FOR FORMAT X  @Y30LB55*/
          5 MCADDXXX PTR(31),       /* ADDR OF DEFAULT TABLE FOR FMT
                                       X                     @Y30LB55*/
          5 MCOUNTS,                /* COUNTS FOR FORMAT X   @Y30LB55*/
            7 MCPXXX FIXED(16),     /* NO. PERM ERROR OR OBR @Y30LB55*/
            7 MCTXXX FIXED(16),     /* NO. TEMP ERROR OR MDR @Y30LB55*/
          5 MCMASK,                 /* 3 BYTE MASK           @Y30LB55*/
            7 MCFXXX BIT(8),        /* FORMAT MASK           @Y30LB55*/
            7 MCFLAG BIT(8),        /* FLAG MASK             @Y30LB55*/
            7 MCSMXXX BIT(8),       /* SUBFMT MSG CODE MASK  @Y30LB55*/
          5 MCSPARE BIT(8),         /* SPARE BYTE            @Y30LB55*/
          5 MLDTIME CHAR(8),        /* LOW DATE + TIME       @Y30LB55*/
            7 MLDATE CHAR(4),       /* LOW DATE              @Y30LB55*/
            7 MLTIME CHAR(4),       /* LOW TIME              @Y30LB55*/
          5 MHDTIME CHAR(8),        /* HIGH DATE + TIME      @Y30LB55*/
            7 MHDATE CHAR(4),       /* HIGH DATE             @Y30LB55*/
            7 MHTIME CHAR(4);       /* HISG TIME             @Y30LB55*/
    %CFMTL='LENGTH(MCOUNTER)';      /* LENGTH OF EACH ENTRY  @Y30LB55*/
 /* CFMTL='LENGTH(MCOUNTER)'  LENGTH OF EACH ENTRY           @Y30LB55*/

    /*****************************************************************/
    /*                                                               */
    /* DEFAULT TABLE - THE FIRST 4 BYTES IS A COUNT OF THE NUMBER OF */
    /* ENTRIES. THE ACTUAL TABLE STARTS AT ISDASUM2 + 4              */
    /*                                                               */
    /*****************************************************************/

    DCL
      ISDASUM2 FIXED(31) BOUNDARY(WORD) NONLOCAL EXTERNAL; /*@Y30LB55*/
    DCL                             /* REASON CODE DCLS      @ZM31074*/
      RCODES (256)FIXED(16) BASED(RCODEPTR),/* 16X16 TABLE   @ZM31074*/
      RCODELEN FIXED(31) CONSTANT(1024);/* LENGTH OF RCODES  @ZM31074*/

    /*****************************************************************/
    /*                                                               */
    /* SEVERITY CODE TABLE - 16 MOST SEVERE ERRORS                   */
    /*                                                               */
    /*****************************************************************/

    DCL
      1 SEVRLIST BASED(SEVRPTR),    /* SEVERITY DATA BUFFER  @ZA20267*/
       2 SEVRCNT FIXED(16),         /* NUMBER OF OCCURRENCES @ZA20267*/
       2 SEVHMOVE,                  /* HEADER                @ZA20267*/
        3 SEVCDSID,                 /* SEV CODE + SSID       @ZA20267*/
         4 SEVRCODE FIXED(16),      /* SEVERITY CODE         @ZA20267*/
         4 SEVSSID CHAR(2),         /* SSID                  @ZA20267*/
        3 PTFLAG BIT(8),            /* PERM-TEMP FLAG        @ZA20267*/
        3 SEVFMT BIT(8),            /* FORMAT                @ZA20267*/
        3 SEVSUBF BIT(8),           /* SUBFORMAT + MSG CODE  @ZA20267*/
        3 SEVFMASK BIT(8),          /* RECORD TYPE MASK      @ZA20267*/
        3 SEVECODE BIT(8),          /* BYTE 12 OR BYTE 27    @ZA20267*/
       2 SEVSPARE BIT(8),           /* SPARE                 @ZA20267*/
       2 SEVSDAWK CHAR(20),         /* SAVE SDAWORK AREA     @ZA20267*/
       2 SEVSDPTR PTR(32),          /* OFFSET TO SENSE DATA  @ZA20267*/
       2 SEVDEVPT PTR(32),          /* OFFSET TO DEVICE DATE @ZA20267*/
       2 SEVDATA CHAR(128),         /* SAVE AREA FOR DATA    @ZA20267*/
        3 * CHAR(12),               /*                       @ZA20267*/
        3 SEVDATET CHAR(8);         /* DATE - TIME IN DATA   @ZA20267*/
