* /* START OF SPECIFICATIONS ****
*     PROLOGUE
*
*01*  MINI-MODULE-NAME = ISTDVCBA
*
*01*  FUNCTIONS = TO CREATE A SKELETEL DVT FOR THE USER (NON SNA)
*                 CONTAINING THE PROCESS MODULES NEEDED TO BE USED
*                 ALONG WITH THE NECESSARY QUALIFIERS SO AS THE PROPER
*                 FUNCTIONS ARE SELECTED AS PER DEVICE TYPE USED
*                NOTE -- SEE FUNCT MACRO FOR QUALIFYING ARGUMENTS
*
*01*  MODULE-SIZE = 64-BYTES
*
*01*  PROCESSOR = ASSEMBLER
*
*01*  SYSTEMS-WHERE-USED = OS/VS1, OS/VS2
*
*01*  HOW-USED = AS-FOLLOWS:
*
*                THE SKELETEL DVT WILL BE SCANNED BY ISTOCCMD AND
*                THE CORRECT PROCESSES RETAINED BY MATCHING FUNCTION
*                QUALIFIERS WITH RESOURCE DEFINITION TABLE ENTRY INFO
*
*01*  INPUT-OUTPUT = NONE
*
*01*  CHANGE-ACTIVITY = NONE
*
**** END OF SPECIFICATIONS ***/
ISTDVCBA STRTMODE  ,  BASIC MODE PROCESSOR (VS2)
*A-000000-999999                                                XL03HBS
*
**********************************************************************
*
ISTCLOBP DVT           ,     START C L OUTBOUND PROCESSING
*
         FUNCT     PROC=ISTDCC00
*
         FUNCT     PROC=ISTDCC02
*
IDSOLICT DVT           ,     SOLICIT PROCESSING
*
         FUNCT     PROC=ISTDCC20
*
         FUNCT     PROC=ISTDCC02
*
IDREAD   DVT           ,     READ PROCESSING
*
         FUNCT     PROC=ISTDCC21
*
         FUNCT     PROC=ISTDCC02
*
IDWRITE  DVT           ,     WRITE PROCESSING
*
         FUNCT     PROC=ISTDCC22
*
         FUNCT     PROC=ISTDCC02
*
IDFINISH DVT           ,     REQUEST FINISH PROCESSING
*
         FUNCT     PROC=ISTDCC02
*
IDRESET  DVT           ,     RESET PROCESSING
*
         FUNCT     PROC=ISTDCC23
*
         FUNCT     PROC=ISTDCC02
*
IDDO     DVT           ,     DO PROCESSING
*
         FUNCT     PROC=ISTDCC31
*
IDSOLLDO DVT           ,     SOLICIT LDO PROCESSING
*
         FUNCT     PROC=ISTDCC10
*
         FUNCT     PROC=ISTDCC31
*
IDRDLDO  DVT           ,     READ LDO PROCESSING
*
         FUNCT     PROC=ISTDCC11
*
         FUNCT     PROC=ISTDCC31
*
IDWRTLDO DVT           ,     WRITE LDO PROCESSING
*
         FUNCT     PROC=ISTDCC12
*
         FUNCT     PROC=ISTDCC31
*
IDRSTLDO DVT           ,     RESET LDO PROCESSING
*
         FUNCT     PROC=ISTDCC13
*
         FUNCT     PROC=ISTDCC31
*
IDPURGEO DVT           ,     PURGE OUTBOUND PROCESSING
*
         FUNCT     PROC=ISTDCC80
*
         EJECT
***********************************************************************
*
ISTCLIBP DVT           ,     START C L INBOUND PROCESSING
*
         FUNCT     PROC=ISTDCC30
*
         FUNCT     PROC=ISTDCC32
*
IDSRWFB  DVT           ,     SOL/WRT/RD MACRO FB PROCESSING
         FUNCT     PROC=ISTDCC50
*
         FUNCT     PROC=ISTDCC32
*
IDFBFIN  DVT           ,     FEEDBACK FINISH PROCESSING
*
         FUNCT     PROC=ISTDCC32
*
IDRSTFB  DVT           ,     RESET MACRO FB PROCESSING
*
         FUNCT     PROC=ISTDCC51
*
         FUNCT     PROC=ISTDCC32
*
IDDOFB   DVT           ,     DO FB PROCESSING
*
         FUNCT     PROC=ISTDCC31
*
IDSRLDFB DVT           ,     FB SOL/READ LCCW PROCESSING
*
         FUNCT     PROC=ISTDCC40
*
         FUNCT     PROC=ISTDCC32
*
IDWTLDFB DVT           ,     FB WRITE LCCW PROCESSING
*
         FUNCT     PROC=ISTDCC41
*
         FUNCT     PROC=ISTDCC32
*
IDRTLDFB DVT           ,     FB RESET LCCW PROCESSING
*
         FUNCT     PROC=ISTDCC42
*
         FUNCT     PROC=ISTDCC32
*
IDPURGEI DVT           ,     PURGE INBOUND PROCESSING
*
         FUNCT     PROC=ISTDCC81
*
IDFBKST2 DVT  ,     EXTENSION OF FB START
*
         FUNCT     PROC=ISTDCC35
         FUNCT     PROC=ISTDCC32
         EJECT
***********************************************************************
*
ISTTPOBP DVT  ,     TPIOS OUTBOUND PROCESSOR
         SPACE
*        REMOTE DEVICE SCHEDULER
         SPACE
         FUNCT PROC=ISTZAF0B,ATTACH=R,CU=(SA,,CLCM,MCOMP)
         FUNCT PROC=ISTZDFL0,ATTACH=R,CU=(,CLUS,,)
         FUNCT PROC=ISTZAF0A,ATTACH=L
         SPACE
*        LCCW TO BTU TRANSLATOR
         SPACE
         FUNCT PROC=ISTZBF0B,ATTACH=R
         FUNCT PROC=ISTZBF0A,ATTACH=L
         SPACE
*        DIALOG SCHEDULER
         SPACE
         FUNCT PROC=ISTZCF0B,ATTACH=R,EXCEPT=32XX
         FUNCT PROC=ISTZCFAI,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZCF0A,ATTACH=L
         SPACE
*        SESSION SCHEDULER
         SPACE
         FUNCT PROC=ISTZBFND,ATTACH=R,CU=(,,,MCOMP),LINE=(,PP,)
         FUNCT PROC=ISTZBFNB,ATTACH=R,CU=(,,,MCOMP),LINE=(,MP,)
         FUNCT PROC=ISTZBFNB,ATTACH=R,CU=(SA,,CLCM,),LINE=(NS,,)
         FUNCT PROC=ISTZBFNE,ATTACH=R,CU=(SA,,,),LINE=(S,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        READ
         SPACE
         FUNCT PROC=ISTZBFAB,ATTACH=R,CU=(SA,,,MCOMP),LINE=(NS,,)
         FUNCT PROC=ISTZBFAG,ATTACH=R,CU=(SA,,,),LINE=(S,,BSC)
         FUNCT PROC=ISTZBFAE,ATTACH=R,CU=(SA,,,),LINE=(S,,SS),         *
               EXCEPT=TWX
         FUNCT PROC=ISTZBFAG,ATTACH=R,DVC=TWX,LINE=(S,,SS)
         FUNCT PROC=ISTZBFAI,ATTACH=R,CU=(,,CLCM,),LINE=(NS,,)
         FUNCT PROC=ISTZBFAA,ATTACH=L
         SPACE
*        WRITE
         SPACE
         FUNCT PROC=ISTZBFBB,ATTACH=R,CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZBFBI,ATTACH=R,CU=(,,CLCM,),LINE=(NS,,)
         FUNCT PROC=ISTZBFBA,ATTACH=L
         SPACE
*        WRITE SOH
         SPACE
         FUNCT PROC=ISTZBFCB,ATTACH=R,CU=(SA,,,MCOMP),LINE=(,,BSC)
         FUNCT PROC=ISTZBFX0,ATTACH=R,LINE=(,,SS)
         FUNCT PROC=ISTZBFX0,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        COPY
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R,CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZBFDI,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        WRITE CONTROL
         SPACE
         FUNCT PROC=ISTZBFEB,ATTACH=R,CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZBFX0,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        RESET
         SPACE
         FUNCT PROC=ISTZBFFB,ATTACH=R
         FUNCT PROC=ISTZBFFA,ATTACH=L
         SPACE
*        CONTROL (INVALID)
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        CONTACT
         SPACE
         FUNCT PROC=ISTZBFHB,ATTACH=R
         FUNCT PROC=ISTZBFHA,ATTACH=L
         SPACE
*        DISCONNECT
         SPACE
         FUNCT PROC=ISTZBFIB,ATTACH=R
         FUNCT PROC=ISTZBFIA,ATTACH=L
         SPACE
*        TEST LCCW
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        PREEMPT
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R                          @X04BHDA
         FUNCT PROC=ISTZBFXA,ATTACH=L                          @X04BHDA
         SPACE
*        RESTORE
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R                          @X04BHDA
         FUNCT PROC=ISTZBFXA,ATTACH=L                          @X04BHDA
         SPACE
*        INVALID COMMAND
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        SEND LCCW
         SPACE
         FUNCT PROC=ISTZBFX0,ATTACH=R
         FUNCT PROC=ISTZBFXA,ATTACH=L
         SPACE
*        PREEMPT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0                                   @X04BHDA
         SPACE
*        RESET CLEANUP (PHASE 1)
         SPACE
         FUNCT PROC=ISTZIFSB
         SPACE
*        RESET CLEANUP (PHASE 3)
         SPACE
         FUNCT PROC=ISTZIFUB
         SPACE
*        RESET CLEANUP (PHASE 4)
         SPACE
         FUNCT PROC=ISTZIFVB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        SESSION CONTROL
         SPACE
         FUNCT PROC=ISTZDFL0
ISTTPIBP DVT  ,     TPIOS  INBOUND PROCESSOR
         SPACE
*        REQUEST COMPLETION CONTROL
         SPACE
         FUNCT PROC=ISTZIF0B,ATTACH=R,CU=(SA,,CLCM,MCOMP)
         FUNCT PROC=ISTZDFL0,ATTACH=R,CU=(,CLUS,,)
         FUNCT PROC=ISTZGF0A,ATTACH=L
         SPACE
*        DIALOG SCHEDULER
         SPACE
         FUNCT PROC=ISTZCFCI                                   @X04BHDA
         SPACE
*        DEVICE STATUS CONTROLLER
         SPACE
         FUNCT PROC=ISTZJF0B,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        NRP DISCONNECT PHASE
         SPACE
         FUNCT PROC=ISTZJFBB,ATTACH=R,CU=(SA,,,MCOMP),LINE=(NS,,)
         FUNCT PROC=ISTZDFL0,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZDFL0,ATTACH=R,LINE=(S,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        NRP RESET PHASE
         SPACE
         FUNCT PROC=ISTZJFAB,ATTACH=R,LINE=(NS,,),CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZDFL0,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZDFL0,ATTACH=R,LINE=(S,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        NRP INVITE PHASE
         SPACE
         FUNCT PROC=ISTZJFCB,ATTACH=R,LINE=(NS,,),CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZDFL0,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZDFL0,ATTACH=R,LINE=(S,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        RESCHEDULE STATE
         SPACE
         FUNCT PROC=ISTZIFAB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        PREEMPT PENDING STATE
         SPACE
         FUNCT PROC=ISTZDFL0                                   @X04BHDA
         SPACE
*        READ COMPLETION
         SPACE
         FUNCT PROC=ISTZIFLB,ATTACH=R,CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZIFKB,ATTACH=R,CU=(,,CLCM,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        INVITE COMPLETION
         SPACE
         FUNCT PROC=ISTZIFKB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        WRITE COMPLETION
         SPACE
         FUNCT PROC=ISTZIFMB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        CONTACT DISCONNECT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFOB,ATTACH=R
         FUNCT PROC=ISTZIFOA,ATTACH=L
         SPACE
*        RESET COMMAND COMPLETION
         SPACE
         FUNCT PROC=ISTZIFNB,ATTACH=R
         FUNCT PROC=ISTZIFNA,ATTACH=L
         SPACE
*        TEST COMPLETION COMMAND
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        CONTROL COMMAND
         SPACE
         FUNCT PROC=ISTZGFBB
         SPACE
*        PREEMPT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0                                   @X04BHDA
         SPACE
*        OUTPUT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFEB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        OUTPUT ERROR STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFDB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        INPUT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFCB,ATTACH=R,CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZIFCI,ATTACH=R,CU=(,,CLCM,),LINE=(NS,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        INPUT ERROR STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFBB,ATTACH=R,CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZIFBI,ATTACH=R,CU=(,,CLCM,),LINE=(NS,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        CONTACT DISCONNECT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFHB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        CONTACT ERROR ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFGB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        COMMAND RESET COMPLETION
         SPACE
         FUNCT PROC=ISTZIFAB,ATTACH=R
         FUNCT PROC=ISTZIFAA,ATTACH=L
         SPACE
*        LOGICAL ERROR RECOVERY
         SPACE
         FUNCT PROC=ISTZIFIB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        INVALID DEVICE COMMAND
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        RESET CLEANUP (PHASE 1)
         SPACE
         FUNCT PROC=ISTZIFSB,ATTACH=R
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        RESET CLEANUP (PHASE 2)
         SPACE
         FUNCT PROC=ISTZIFTB
         SPACE
*        DIAL DISCONNECT
         SPACE
         FUNCT PROC=ISTZKFBB,ATTACH=R,LINE=(NS,,)
         FUNCT PROC=ISTZKFBN,ATTACH=R,LINE=(S,,),CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZDFL0,ATTACH=R,CU=(,,CLCM,),LINE=(S,,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        MANUAL DIAL
         SPACE
         FUNCT PROC=ISTZKFCB,ATTACH=R,LINE=(NS,,)
         FUNCT PROC=ISTZKFCN,ATTACH=R,LINE=(S,,),CU=(SA,,,MCOMP)
         FUNCT PROC=ISTZDFL0,ATTACH=R,LINE=(S,,),CU=(,,CLCM,)
         FUNCT PROC=ISTZDFL0,ATTACH=L
         SPACE
*        UNSOLICITED BTU PROCESSOR
         SPACE
         FUNCT PROC=ISTZIFJB
         SPACE
*        SEGMENT PROCESSOR
         SPACE
         FUNCT PROC=ISTZDFWB
ISTATOBP DVT
         SPACE
         FUNCT PROC=ISTZDFL0
*
ISTDVCBA ENDMODE       ,
         END
