* /* START OF SPECIFICATIONS ****
*     PROLOGUE
*
*01*  MINI-MODULE-NAME = ISTDVCRC
*
*01*  FUNCTIONS = TO CREATE A SKELETEL DVT FOR THE USER (SNA ONLY)
*                 CONTAINING THE PROCESS MODULES NEEDED TO BE USED
*                 ALONG WITH THE NECESSARY QUALIFIERS SO AS THE PROPER
*                 FUNCTIONS ARE SELECTED AS PER DEVICE TYPE USED
*                NOTE -- SEE FUNCT MACRO FOR QUALIFYING ARGUMENTS
*
*01*  MODULE-SIZE = 64-BYTES
*
*01*  PROCESSOR = ASSEMBLER
*
*01*  SYSTEMS-WHERE-USED = OS/VS1, OS/VS2
*
*01*  HOW-USED = AS-FOLLOWS:
*
*                THE SKELETEL DVT WILL BE SCANNED BY ISTOCCMD AND
*                THE CORRECT PROCESSES RETAINED BY MATCHING FUNCTION
*                QUALIFIERS WITH RESOURCE DEFINITION TABLE ENTRY INFO
*
*01*  INPUT-OUTPUT = NONE
*
*01*  CHANGE-ACTIVITY =
*                       APAR OZ16994                        @ZA16994
*
**** END OF SPECIFICATIONS ***/
ISTDVCRC STRTMODE ,  DVT FOR RECORD MODE (VS2)
*A-000000-999999                                                XL03HBS
*
***********************************************************************
*
IRSNDOUT DVT
*
         FUNCT PROC=ISTRCC22
         FUNCT PROC=ISTDCC02
*
IRRCVOUT DVT
*
         FUNCT PROC=ISTRCC21
         FUNCT PROC=ISTDCC02
*
IRRCVIN  DVT
*
         FUNCT PROC=ISTRCC51
         FUNCT PROC=ISTDCC32
*
IRSENDIN DVT
*
         FUNCT PROC=ISTRCC53
         FUNCT PROC=ISTDCC32
*
IRSYNFDB DVT
*
         FUNCT PROC=ISTRCC52
         FUNCT PROC=ISTDCC32
*
IRASYFDB DVT
*
         FUNCT PROC=ISTRCC54
         FUNCT PROC=ISTDCC32
*
IRFINISH DVT  ,   FEEDBACK FINISH                              @X04BHDA
*
         FUNCT PROC=ISTDCC32                                   @X04BHDA
*
ISTCLOBP DVT     ,          START C L OUTBOUND PROCESSING
*
         FUNCT   PROC=ISTDCC00
         FUNCT   PROC=ISTDCC02
*
IRRSTOUT DVT
*
         FUNCT PROC=ISTRCC23
         FUNCT PROC=ISTDCC02
*
IRCLROUT DVT
*
         FUNCT PROC=ISTRCC80
*
***********************************************************************
*
ISTCLIBP DVT       ,         START C L INBOUND PROCESSING
*
         FUNCT PROC=ISTRCC30
         FUNCT PROC=ISTRCC51                                   @X04BHDA
         FUNCT PROC=ISTRCC52                                   @X04BHDA
         FUNCT PROC=ISTDCC32
*
IRCLRIN  DVT
*
         FUNCT PROC=ISTRCC81
*
***********************************************************************
*
ISTTPOBP DVT  ,     OUTBOUND- CONTROL MODE
         SPACE
*        REMOTE DEVICE SCHEDULER
         SPACE
         FUNCT PROC=ISTZAF1B,EXCEPT=32XX
         FUNCT PROC=ISTZAF0B,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZAF0A,ATTACH=L,DVC=32XX
         SPACE
*        LCCW TO BTU TRANSLATOR
         SPACE
         FUNCT PROC=ISTZBF0B,EXCEPT=32XX
         FUNCT PROC=ISTZBF0L,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBF0B,ATTACH=R,DVC=32XX
         SPACE
*        DIALOG SCHEDULER
         SPACE
         FUNCT PROC=ISTZDFL0,EXCEPT=32XX
         FUNCT PROC=ISTZCFAI,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZCF0A,ATTACH=L,DVC=32XX
         SPACE
*        SESSION SCHEDULER
         SPACE
         FUNCT PROC=ISTZDFL0,EXCEPT=32XX
         FUNCT PROC=ISTZBFNB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        READ
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFAR,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZBFAL,ATTACH=L,DVC=32XX
         SPACE
*        WRITE
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFBR,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZBFBA,ATTACH=L,DVC=32XX
         SPACE
*        WRITE SOH
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX
         SPACE
*        COPY
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFDR,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         SPACE
*        WRITE CONTROL
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX
         SPACE
*        RESET
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFFB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZBFFA,ATTACH=L,DVC=32XX
         SPACE
*        INVALID CONTROL
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX
         SPACE
*        CONTACT
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX
         SPACE
*        DISCONNECT
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFIB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZBFIA,ATTACH=L,DVC=32XX
         SPACE
*        TEST LCCW
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX
         SPACE
*        PREEMPT
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX                 @X04BHDA
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX                 @X04BHDA
         SPACE
*        RESTORE
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX                 @X04BHDA
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX                 @X04BHDA
         SPACE
*        INVALID COMMAND
         SPACE
         FUNCT PROC=ISTZBFX0,EXCEPT=32XX
         FUNCT PROC=ISTZBFXA,ATTACH=L,DVC=32XX
         FUNCT PROC=ISTZBFX0,ATTACH=R,DVC=32XX
         SPACE
*        SEND LCCW
         SPACE
         FUNCT PROC=ISTZBFID,DVC=LU01,ATTACH=R                 @X50BHDA
         FUNCT PROC=ISTZBFIF,DVC=LU01,ATTACH=L                 @X50BHDA
         FUNCT PROC=ISTZDFL0,DVC=32XX
         SPACE
*        PREEMPT COMPLETION
         SPACE
         FUNCT PROC=ISTZDFL0,EXCEPT=32XX
         FUNCT PROC=ISTZIFX0,DVC=32XX                          @X04BHDA
         SPACE
*        RESET CLEANUP (PHASE 1)
         SPACE
         FUNCT PROC=ISTZDFL0,EXCEPT=32XX
         FUNCT PROC=ISTZIFSB,DVC=32XX
         SPACE
*        RESET CLEANUP (PHASE 3)
         SPACE
         FUNCT PROC=ISTZDFL0,EXCEPT=32XX
         FUNCT PROC=ISTZIFUB,DVC=32XX                       @ZA16994
         SPACE
*        RESET CLEANUP (PHASE 4)
         SPACE
         FUNCT PROC=ISTZDFL0,EXCEPT=32XX
         FUNCT PROC=ISTZIFVB,DVC=32XX
         SPACE
*        SESSION CONTROL FOR TPIOS
         SPACE
         FUNCT PROC=ISTZBFSC,EXCEPT=32XX
         FUNCT PROC=ISTZDFL0,DVC=32XX
ISTTPIBP DVT  ,   INBOUND - CONTROL MODE
         SPACE
*        PIU ROUTER
         SPACE
         FUNCT PROC=ISTZIF1B,EXCEPT=32XX
         SPACE
*        FID1 PROCESSOR
         SPACE
         FUNCT PROC=ISTZIFID,EXCEPT=32XX
         SPACE
*        SESSION CONTROL
         SPACE
         FUNCT PROC=ISTZIFSC,EXCEPT=32XX
         SPACE
*        SEGMENTING PROCESSOR                                  @X50BHDA
         SPACE
         FUNCT PROC=ISTZIFSG,EXCEPT=32XX                       @X50BHDA
         SPACE
*        REQUEST COMPLETION CONTROL
         SPACE
         FUNCT PROC=ISTZIF0B,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZGF0A,ATTACH=L,DVC=32XX
         SPACE
*        DIALOG SCHED
         SPACE
         FUNCT PROC=ISTZCFCI,DVC=32XX
         SPACE
*        STATUS CONTROLLER
         SPACE
         FUNCT PROC=ISTZJF0B,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        NEGATIVE RESPONSE TO POLLING
         SPACE
         FUNCT PROC=ISTZIFX0,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        NRP RESET PHASE
         SPACE
         FUNCT PROC=ISTZIFX0,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        NRP INVITE PHASE
         SPACE
         FUNCT PROC=ISTZIFX0,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        RESCHEDULE STATE
         SPACE
         FUNCT PROC=ISTZIFAB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        PREEMPT PENDING STATE
         SPACE
         FUNCT PROC=ISTZDFL0,DVC=32XX                          @X04BHDA
         SPACE
*        READ COMPLETION
         SPACE
         FUNCT PROC=ISTZIFKB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        INVITE COMPLETION
         SPACE
         FUNCT PROC=ISTZIFKB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        WRITE COMPLETION
         SPACE
         FUNCT PROC=ISTZIFMB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        CONTACT DISCONNECT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFOB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZIFOA,ATTACH=L,DVC=32XX
         SPACE
*        RESET COMMAND COMPLETION
         SPACE
         FUNCT PROC=ISTZIFNB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZIFNA,ATTACH=L,DVC=32XX
         SPACE
*        TEST COMPLETION COMMAND
         SPACE
         FUNCT PROC=ISTZIFX0,DVC=32XX
         SPACE
*        CONTROL COMMAND
         SPACE
         FUNCT PROC=ISTZGFBB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZIFX0,ATTACH=L,DVC=32XX
         SPACE
*        PREEMPT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0,DVC=32XX                          @X04BHDA
         SPACE
*        OUTPUT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFEB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        OUTPUT ERROR STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFDB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        INPUT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFCI,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        INPUT ERROR STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFBI,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        CONTACT DISCONNECT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFHB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        CONTACT ERROR ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFGB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        COMMAND RESET COMPLETION
         SPACE
         FUNCT PROC=ISTZIFAB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZIFAA,ATTACH=L,DVC=32XX
         SPACE
*        LOGICAL ERROR RECOVERY
         SPACE
         FUNCT PROC=ISTZIFIB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        INVALID DEVICE COMMAND
         SPACE
         FUNCT PROC=ISTZIFX0,DVC=32XX
         SPACE
*        RESET CLEANUP (PHASE 1)
         SPACE
         FUNCT PROC=ISTZIFSB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        RESET CLEANUP (PHASE 2)
         SPACE
         FUNCT PROC=ISTZIFTB,DVC=32XX
         SPACE
*        DIAL DISCONNECT
         SPACE
         FUNCT PROC=ISTZKFBB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        MANUAL DIAL
         SPACE
         FUNCT PROC=ISTZKFCB,ATTACH=R,DVC=32XX
         FUNCT PROC=ISTZDFL0,ATTACH=L,DVC=32XX
         SPACE
*        UNSOLICITED BTU PROCESSOR
         SPACE
         FUNCT PROC=ISTZIFJB,DVC=32XX
         SPACE
*        3270 SEGMENT PROCESSOR
         SPACE
         FUNCT PROC=ISTZDFWR,ATTACH=R,DVC=32XX
         SPACE
ISTATOBP DVT  ,   ASYN OUTBOUND
         SPACE
*        ASYNCH SCHEDULER
         SPACE
         FUNCT PROC=ISTZAF1B,EXCEPT=32XX
         FUNCT PROC=ISTZAF1R,DVC=32XX
ISTDVCRC ENDMODE
         END
