         TITLE 'ISTOCCDF - SRT DELETE/FIND                             *
                        '
ISTOCCDF CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(8)                                              0001
         DC    C'OCCDF000'                                         0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*        CRETCODE=CNEGVAL;             /* SET RETURN CODE NEGATIVE */
         L     CRETCODE,CNEGVAL                                    0061
*        CNAMEPTR = CREG0;        /* REFERENCE SYMBOLIC NAME */    0062
*                                                                  0062
*/********************************************************************/
*/*                                                                  */
*/*  GET ADDRESS OF SRT DIRECTORY FROM ATCAM CVT AND PUT IN CSRTDPTR */
*/*  IF THE DIRECTORY IS NOT PRESENT, AN ERROR CODE IS SET AND NO    */
*/*  PROCESSING OCCURS.                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0063
*        RFY (ATCVTPTR,CBHSPTR,CSRTDPTR) RSTD;   /* BASE FOR ATCVT  */
*                                                                  0063
*          DO; /* LISATCVT CVTBASE(PAGEABLE,(ATCVTPTR)) */         0064
*            ATCVTPTR = ATCLCPTR; /*SET UP ATCVT POINTER*/         0065
         L     ATCVTPTR,ATCLCPTR                                   0065
*          END; /*LISATCVT*/  /* LOCATE CVT */                     0066
*         CSRTDPTR = ATCSRT;     /* SRT DIRECTORY POINTER */       0067
         L     CSRTDPTR,ATCSRT(,ATCVTPTR)                          0067
*        RFY ATCVTPTR UNRSTD;  /* DROP ATCVT BASE */               0068
*        IF CSRTDPTR = 0 THEN CRETCODE = CNODIR; /* ERROR-NO DIRECTORY*
         LTR   CSRTDPTR,CSRTDPTR                                   0069
         BNZ   @RF00069                                            0069
         LA    CRETCODE,8                                          0070
*        ELSE DO;                                                  0071
         B     @RC00069                                            0071
@RF00069 DS    0H                                                  0072
*             /* USE HASHING MECHANISM TO REFERENCE PROPER         0072
*                ENTRY IN THE DIRECTORY.  THE TWO HALVES OF THE    0072
*                SYMBOLIC NAMES ARE OR'ED TOGETHER                 0072
*                  THE RESULT IS DIVIDED BY THE                    0072
*                NUMBER OF ENTRIES IN THE TABLE.  THE REMAINDER IS 0072
*                MULTIPLIED BY 4 AND THE OFFSET TO THE START OF THE
*                ENTRIES IS ADDED.                                  */
*      RFY CTEMP RSTD;                                     /*@Z30APGK*/
*      CTEMP=CBHSPTR; /* SAVE REG2 AROUND MODESET            @Z30APGK*/
         LR    CTEMP,CBHSPTR                                       0073
*       DO; /*MODESET  SAVEKEY(GPR02F) EXTKEY(ZERO)*/              0074
*         RESPECIFY (GPR02F) RESTRICTED;                           0075
*         IPK; /*SAVE CURRENT PSW KEY*/                            0076
         IPK                                                       0076
*         SPKA (0); /*SET PSW KEY*/                                0077
         SLR   @09,@09                                             0077
         SPKA  0(@09)                                              0077
*         GPR02F = GPR02F;                                         0078
*         RESPECIFY (GPR02F) UNRESTRICTED;                         0079
*       END; /*MODESET  SAVEKEY(GPR02F) EXTKEY(ZERO)*/              /*@
*30APGK*/                                                          0080
*             CLASTPTR = (CSYMNAM1 | CSYMNAM2);  /* FOLD NAME */   0081
         LR    @09,CNAMEPTR                                        0081
         ICM   CLASTPTR,15,CSYMNAM1(@09)                           0081
         LR    @09,CNAMEPTR                                        0081
         ICM   @08,15,CSYMNAM2(@09)                                0081
         OR    CLASTPTR,@08                                        0081
*       DO; /*MODESET  KEYADDR(GPR02F)*/                           0082
*         SPKA (GPR02F); /*SET PSW KEY*/                           0083
         SPKA  0(GPR02F)                                           0083
*       END; /*MODESET  KEYADDR(GPR02F)*/                           /*@
*30APGK*/                                                          0084
*             GEN;                                                 0085
              LR     15,CLASTPTR      FOLDED NAME
              SR     14,14            CLEAR FOR DIVIDE
              LA     11,1023          NUMBER OF TABLE ENTRIES
              DR     14,11            COMPUTE REMAINDER
              LR     CLASTPTR,14      PICK UP REMAINDER
*             CLASTPTR=CLASTPTR*4+CSRTDOFF+CSRTDPTR; /*COMPUTE ENTRY*/
         LR    @09,CLASTPTR                                        0086
         SLA   @09,2                                               0086
         AL    @09,@CF00054                                        0086
         ALR   @09,CSRTDPTR                                        0086
         LR    CLASTPTR,@09                                        0086
*             END;                                                 0087
*        IF CRETCODE ^= CNEGVAL THEN;  /* ERROR PATH */            0088
@RC00069 C     CRETCODE,CNEGVAL                                    0088
         BNE   @RT00088                                            0088
*        ELSE IF CSRTDENT = 0 THEN CRETCODE = CNTFOUND; /*NO ENTRY*/
         L     @09,CSRTDENT(,CLASTPTR)                             0090
         LTR   @09,@09                                             0090
         BNZ   @RF00090                                            0090
         LA    CRETCODE,4                                          0091
*             ELSE DO;                                             0092
         B     @RC00090                                            0092
@RF00090 DS    0H                                                  0093
*                  /* SEARCH THROUGH ALL ENTRIES HASHED TO SAME    0093
*                     PLACE SEARCHING FOR SYMBOLIC NAME WHICH      0093
*                     MATCHES THE ONE PASSED AS AN ARGUMENT.       0093
*                     SEARCH UNTIL MATCH OR END OF CHAIN.           */
*                  SRTPTR=CSRTDENT; /* ENTRY ADDRESS */            0093
         L     SRTPTR,CSRTDENT(,CLASTPTR)                          0093
*       DO; /*MODESET  SAVEKEY(GPR02F) EXTKEY(ZERO)*/              0094
*         RESPECIFY (GPR02F) RESTRICTED;                           0095
*         IPK; /*SAVE CURRENT PSW KEY*/                            0096
         IPK                                                       0096
*         SPKA (0); /*SET PSW KEY*/                                0097
         SLR   @09,@09                                             0097
         SPKA  0(@09)                                              0097
*         GPR02F = GPR02F;                                         0098
*         RESPECIFY (GPR02F) UNRESTRICTED;                         0099
*       END; /*MODESET  SAVEKEY(GPR02F) EXTKEY(ZERO)*/              /*@
*30APGK*/                                                          0100
*                  DO WHILE (CSYMNAME ^= SRTSYMNM & SRTSRTE ^= 0); 0101
         B     @DE00101                                            0101
@DL00101 DS    0H                                                  0102
*                  CLASTPTR = SRTPTR;  /* UPDATE TO NEXT ON CHAIN */
         LR    CLASTPTR,SRTPTR                                     0102
*                  SRTPTR = SRTSRTE;   /* NEXT SRTE */             0103
         L     SRTPTR,SRTSRTE(,SRTPTR)                             0103
*                  END;                                            0104
@DE00101 LR    @09,CNAMEPTR                                        0104
         CLC   CSYMNAME(8,@09),SRTSYMNM(SRTPTR)                    0104
         BE    @DC00101                                            0104
         L     @09,SRTSRTE(,SRTPTR)                                0104
         LTR   @09,@09                                             0104
         BNZ   @DL00101                                            0104
@DC00101 DS    0H                                                  0105
*                  IF CSYMNAME ^= SRTSYMNM THEN CRETCODE = CNTFOUND;
         LR    @09,CNAMEPTR                                        0105
         CLC   CSYMNAME(8,@09),SRTSYMNM(SRTPTR)                    0105
         BE    @RF00105                                            0105
         LA    CRETCODE,4                                          0106
*                  ELSE;  /* MATCH FOUND */                        0107
@RF00105 DS    0H                                                  0108
*       DO; /*MODESET  KEYADDR(GPR02F)*/                           0108
*         SPKA (GPR02F); /*SET PSW KEY*/                           0109
         SPKA  0(GPR02F)                                           0109
*       END; /*MODESET  KEYADDR(GPR02F)*/                           /*@
*30APGK*/                                                          0110
*        CBHSPTR=CTEMP;   /* RESTORE REG2                    @Z30APGK*/
         LR    CBHSPTR,CTEMP                                       0111
*        RFY CTEMP UNRSTD;                                 /*@Z30APGK*/
*                  END;                                            0113
*                  RFY CSRTDPTR UNRSTD;                            0114
@RC00090 DS    0H                                                  0114
@RT00088 DS    0H                                                  0115
*        IF CRETCODE ^= CNEGVAL THEN;  /* ERROR WAS FOUND */       0115
         C     CRETCODE,CNEGVAL                                    0115
         BNE   @RT00115                                            0115
*        ELSE IF CBHSPTR < 0             /* BHSET INDICATED */     0117
*            THEN DO;                                              0117
         LTR   CBHSPTR,CBHSPTR                                     0117
         BNM   @RF00117                                            0117
*                IF SRTBHSET=CON         /* INSURE BHSET ENTRY */  0119
*                    THEN CALL CDFBHSET;                           0119
         TM    SRTBHSET(SRTPTR),B'10000000'                        0119
         BNO   @RF00119                                            0119
         BAL   @14,CDFBHSET                                        0120
*                    ELSE CRETCODE=CNTFOUND;                       0121
         B     @RC00119                                            0121
@RF00119 LA    CRETCODE,4                                          0121
*                 END;                                             0122
*            ELSE DO; /* PROCESS FOR RDT OR PROCESS MODULE */      0123
         B     @RC00117                                            0123
@RF00117 DS    0H                                                  0124
*                     /* IS SDVT INDICATOR = TO SRTE DVT INDICATOR */
*                    IF ((CREG1<0 & SRTSDVT=CON) |                 0124
*                       (CREG1^<0 & SRTSDVT=COFF))                 0124
*                     THEN;  /* ENTRY FOUND */                     0124
         LTR   CREG1,CREG1                                         0124
         BNM   @GL00002                                            0124
         TM    SRTSDVT(SRTPTR),B'01000000'                         0124
         BO    @RT00124                                            0124
@GL00002 LTR   CREG1,CREG1                                         0124
         BM    @RF00124                                            0124
         TM    SRTSDVT(SRTPTR),B'01000000'                         0124
         BZ    @RT00124                                            0124
*                     ELSE IF SRTSRTE=0                            0126
*                            THEN CRETCODE=CNTFOUND;               0126
@RF00124 L     @10,SRTSRTE(,SRTPTR)                                0126
         LTR   @10,@10                                             0126
         BNZ   @RF00126                                            0126
         LA    CRETCODE,4                                          0127
*                            ELSE DO;                              0128
         B     @RC00126                                            0128
@RF00126 DS    0H                                                  0129
*                       CLASTPTR=SRTPTR;     /* SEARCH FOR MATCH */
         LR    CLASTPTR,SRTPTR                                     0129
*                       SRTPTR=SRTSRTE;                            0130
         L     SRTPTR,SRTSRTE(,SRTPTR)                             0130
*                       DO WHILE (SRTSRTE^=0 & CSYMNAME^=SRTSYMNM);
         B     @DE00131                                            0131
@DL00131 DS    0H                                                  0132
*                       CLASTPTR=SRTPTR;                           0132
         LR    CLASTPTR,SRTPTR                                     0132
*                       SRTPTR=SRTSRTE;                            0133
         L     SRTPTR,SRTSRTE(,SRTPTR)                             0133
*                       END;                                       0134
@DE00131 L     @10,SRTSRTE(,SRTPTR)                                0134
         LTR   @10,@10                                             0134
         BZ    @DC00131                                            0134
         LR    @10,CNAMEPTR                                        0134
         CLC   CSYMNAME(8,@10),SRTSYMNM(SRTPTR)                    0134
         BNE   @DL00131                                            0134
@DC00131 DS    0H                                                  0135
*                       IF CSYMNAME^=SRTSYMNM  /* SYMBOLIC NAMES ^=? */
*                        THEN CRETCODE=CNTFOUND;                   0135
         LR    @10,CNAMEPTR                                        0135
         CLC   CSYMNAME(8,@10),SRTSYMNM(SRTPTR)                    0135
         BE    @RF00135                                            0135
         LA    CRETCODE,4                                          0136
*                               /* MATCH FOUND ON NAMES    */      0137
*                               /* SDVT INDICATORS EQUAL ? */      0137
*                        ELSE     IF ((CREG1<0 & SRTSDVT=CON) |    0137
*                                    (CREG1^<0 & SRTSDVT=COFF))    0137
*                                   THEN;  /* ENTRY FOUND */       0137
         B     @RC00135                                            0137
@RF00135 LTR   CREG1,CREG1                                         0137
         BNM   @GL00006                                            0137
         TM    SRTSDVT(SRTPTR),B'01000000'                         0137
         BO    @RT00137                                            0137
@GL00006 LTR   CREG1,CREG1                                         0137
         BM    @RF00137                                            0137
         TM    SRTSDVT(SRTPTR),B'01000000'                         0137
         BZ    @RT00137                                            0137
*                                   ELSE CRETCODE=CNTFOUND;        0139
@RF00137 LA    CRETCODE,4                                          0139
*       DO; /*MODESET  KEYADDR(GPR02F)*/                           0140
@RT00137 DS    0H                                                  0140
@RC00135 DS    0H                                                  0141
*         SPKA (GPR02F); /*SET PSW KEY*/                           0141
         SPKA  0(GPR02F)                                           0141
*       END; /*MODESET  KEYADDR(GPR02F)*/                           /*@
*30APGK*/                                                          0142
*        CBHSPTR=CTEMP;   /* RESTORE REG2                    @Z30APGK*/
         LR    CBHSPTR,CTEMP                                       0143
*        RFY CTEMP UNRSTD;                                 /*@Z30APGK*/
*                          END;                                    0145
*                       END;                                       0146
@RC00126 DS    0H                                                  0146
@RT00124 DS    0H                                                  0147
*        IF CRETCODE ^= CNEGVAL THEN;  /* PROCESSING COMPLETED */  0147
@RC00117 DS    0H                                                  0147
@RT00115 C     CRETCODE,CNEGVAL                                    0147
         BNE   @RT00147                                            0147
*        ELSE DO;   /* NON BHSET REQUESTED - NORMAL ENTRY */       0149
*             /* A FIND OR DELETE FOR A NORMAL SRT ENTRY WAS       0150
*                REQUESTED.                                   */   0150
*              IF (CNAMEPTR&CBITMASK)=CBITMASK THEN DO;            0150
         LR    @10,CNAMEPTR                                        0150
         ICM   @04,15,CBITMASK                                     0150
         NR    @10,@04                                             0150
         ICM   @04,15,CBITMASK                                     0150
         CLR   @10,@04                                             0150
         BNE   @RF00150                                            0150
*                               /* THE REQUEST WAS FOR FIND.  THE  0152
*                                  PROPER ENTRY IS POINTED TO BY   0152
*                                  BASE REGISTER SRTPTR. THE RDT   0152
*                                  ENTRY ADDRESS MUST BE PLACED IN 0152
*                                  REGISTER 0.                      */
*                               CREG0 = SRTRDTE;  /* RDTE ADDRESS */
         L     CREG0,SRTRDTE(,SRTPTR)                              0152
*                               CRETCODE = CGOOD;                  0153
         SLR   CRETCODE,CRETCODE                                   0153
*                               END;                               0154
*             ELSE DO;                                             0155
         B     @RC00150                                            0155
@RF00150 DS    0H                                                  0156
*                  /* A DELETE WAS REQUESTED.  THE CHAIN OF ENTRIES
*                     MUST BE UPDATED TO REFLECT THIS ENTRY BEING  0156
*                     REMOVED.  THE STORAGE OCCUPIED BY THIS ENTRY 0156
*                     MUST BE FREED.                                */
*                  CLASTPTR -> SRTSRTE = SRTSRTE; /* RECHAIN */    0156
         L     @10,SRTSRTE(,SRTPTR)                                0156
         ST    @10,SRTSRTE(,CLASTPTR)                              0156
*                  CWORKREG=SRTLNGTH; /* LENGTH FOR FREESTOR */    0157
         LH    CWORKREG,SRTLNGTH(,SRTPTR)                          0157
         N     CWORKREG,@CF01315                                   0157
*                  RFY REG9 RSTD;                         /* @XM06239*/
*                  REG9=SRTPTR;                           /* @XM06239*/
         LR    REG9,SRTPTR                                         0159
*         /*FREESTOR AREA(REG9)FETCHP(NO)SIZE(CWORKREG)*/          0160
*          DO;                                                     0160
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0161
*/* END OF ATBUILD */                                              0161
*         DCL GPR00F FIXED(31) REG(00);                            0161
*         DCL GPR00P PTR(31)   REG(00);                            0162
*         DCL GPR01F FIXED(31) REG(01);                            0163
*         DCL GPR01P PTR(31)   REG(01);                            0164
*         DCL GPR02F FIXED(31) REG(02);                            0165
*         DCL GPR02P PTR(31)   REG(02);                            0166
*         DCL GPR03F FIXED(31) REG(03);                            0167
*         DCL GPR03P PTR(31)   REG(03);                            0168
*         DCL GPR04F FIXED(31) REG(04);                            0169
*         DCL GPR04P PTR(31)   REG(04);                            0170
*         DCL GPR05F FIXED(31) REG(05);                            0171
*         DCL GPR05P PTR(31)   REG(05);                            0172
*         DCL GPR06F FIXED(31) REG(06);                            0173
*         DCL GPR06P PTR(31)   REG(06);                            0174
*         DCL GPR07F FIXED(31) REG(07);                            0175
*         DCL GPR07P PTR(31)   REG(07);                            0176
*         DCL GPR08F FIXED(31) REG(08);                            0177
*         DCL GPR08P PTR(31)   REG(08);                            0178
*         DCL GPR09F FIXED(31) REG(09);                            0179
*         DCL GPR09P PTR(31)   REG(09);                            0180
*         DCL GPR10F FIXED(31) REG(10);                            0181
*         DCL GPR10P PTR(31)   REG(10);                            0182
*         DCL GPR11F FIXED(31) REG(11);                            0183
*         DCL GPR11P PTR(31)   REG(11);                            0184
*         DCL GPR12F FIXED(31) REG(12);                            0185
*         DCL GPR12P PTR(31)   REG(12);                            0186
*         DCL GPR13F FIXED(31) REG(13);                            0187
*         DCL GPR13P PTR(31)   REG(13);                            0188
*         DCL GPR14F FIXED(31) REG(14);                            0189
*         DCL GPR14P PTR(31)   REG(14);                            0190
*         DCL GPR15F FIXED(31) REG(15);                            0191
*         DCL GPR15P PTR(31)   REG(15);                            0192
*         RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                  0193
*         RFY ISTRPH BASED(GPR01P);                                0194
*         GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,                    0195
*                  GPR06P,GPR07P,GPR08P,GPR09P,                    0195
*                  GPR10P,GPR11P,GPR12P,GPR13P)                    0195
*             SETS(RPHWORK);                                       0195
*                                                                  0195
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*         GPR00F = CWORKREG;                           /*SIZE IN REG0*/
         LR    GPR00F,CWORKREG                                     0196
*         DCL 1 CMZA0019 FIXED(31) STATIC LOCAL,                   0197
*               2 * FIXED(8) INIT(64),               /* OPTION FLAGS */
*               2 * FIXED(8) INIT(96),                /* STORAGE KEY */
*               2 * FIXED(8) INIT(241),            /* SUBPOOL NUMBER */
*               2 * FIXED(8) INIT('01'X);            /* REQUEST TYPE */
*         GPR03F = CMZA0019;                                       0198
         L     GPR03F,CMZA0019                                     0198
*         RFY (GPR04P) RSTD;                                       0199
*         GPR04P = REG9;                  /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0200
         LR    GPR04P,REG9                                         0200
*         DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */            0201
*           GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/            0202
         L     GPR02P,ATCLCPTR                                     0202
*         END; /*LISATCVT*/                                        0203
*         CALL GPR02P -> ATCGTSTR;                    /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0204
         BALR  @14,@15                                             0204
*         RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;         0205
*         END ;                                     /*END OF FREESTOR*/
* /* @XM06239*/                                                    0207
*                  RFY REG9 UNRSTD;                       /* @XM06239*/
*                  CRETCODE=CGOOD;                                 0208
         SLR   CRETCODE,CRETCODE                                   0208
*                END;                                              0209
*         END;                                                     0210
@RC00150 DS    0H                                                  0211
*        GENERATE;                                                 0211
@RT00147 DS    0H                                                  0211
         LR    CRCODE,CRETCODE
         L     CRETPTR,12(13)
         LM    1,12,24(13)
         BR    CRETPTR
*CDFBHSET: PROC OPTIONS(NOSAVEAREA,NOSAVE);                        0212
         B     @PB00002                                            0212
CDFBHSET DS    0H                                                  0213
*        CSAVE = CRETPTR;       /* SAVE RETURN ADDRESS */          0213
         LR    CSAVE,CRETPTR                                       0213
*        RFY CSAVE RSTD;                                           0214
*                                                                  0214
*        /* THIS ROUTINE WILL SEARCH A SRT ENTRY WHICH WAS IDENTIFIED
*           AS CONTAINING BHSETS TO FIND THE ONE WHICH MATCHES THE 0215
*           RDTE ADDRESS WHICH WAS PASSED AS A PARAMETER.  IF FIND 0215
*           WAS REQUESTED, THE CORRESPONDING BHID IS RETURNED TO THE
*           CALLER IN REGISTER 0.  IF A DELETE WAS RIQUESTED, THE  0215
*           BHSET IS DELETED FROM THE SRT ENTRY.                    */
*        CBHSPTR=CBHSPTR & CBHSTMSK; /* CLEAR FLAG BIT */          0215
         ICM   @10,15,CBHSTMSK                                     0215
         NR    CBHSPTR,@10                                         0215
*        RFY CSIZE RSTD;                                           0216
*        CSIZE = SRTLNGTH-16;   /* FOR LOOP CONTROL */             0217
         LH    CSIZE,SRTLNGTH(,SRTPTR)                             0217
         N     CSIZE,@CF01315                                      0217
         SL    CSIZE,@CF00974                                      0217
*        /* SEARCH UNTIL MATCH OF RDTE ADDRESSES OR END OF ENTRY */
*        DO WHILE (CBHSPTR ^= SRTRDTE & CSIZE ^= 0);               0218
         B     @DE00218                                            0218
@DL00218 DS    0H                                                  0219
*        SRTPTR = SRTPTR + CBHLNGTH;  /* UPDATE TO NEXT BHSET */   0219
         AL    SRTPTR,@CF01239                                     0219
*        CSIZE = CSIZE-CBHLNGTH;  /* DECREMENT CSIZE LEFT IN ENTRY */
         SL    CSIZE,@CF01239                                      0220
*        END;                                                      0221
@DE00218 C     CBHSPTR,SRTRDTE(,SRTPTR)                            0221
         BE    @DC00218                                            0221
         LTR   CSIZE,CSIZE                                         0221
         BNZ   @DL00218                                            0221
@DC00218 DS    0H                                                  0222
*        IF CBHSPTR=SRTRDTE THEN DO;   /* MATCH FOUND */           0222
         C     CBHSPTR,SRTRDTE(,SRTPTR)                            0222
         BNE   @RF00222                                            0222
*                  IF (CNAMEPTR&CBITMASK)=CBITMASK THEN DO;        0224
         LR    @10,CNAMEPTR                                        0224
         ICM   @09,15,CBITMASK                                     0224
         NR    @10,@09                                             0224
         ICM   @09,15,CBITMASK                                     0224
         CLR   @10,@09                                             0224
         BNE   @RF00224                                            0224
*                                   /* RETURN BHID TO CALLER */    0226
*                                   CREG0 = SRTBHID;               0226
         SLR   CREG0,CREG0                                         0226
         IC    CREG0,SRTBHID(,SRTPTR)                              0226
*                                   CRETCODE = CGOOD;              0227
         SLR   CRETCODE,CRETCODE                                   0227
*                                   END;                           0228
*                  ELSE DO;  /* DELETE REQUESTED */                0229
         B     @RC00224                                            0229
@RF00224 DS    0H                                                  0230
*                       RFY CBHSPTR UNRSTD;                        0230
*                       SRTPTR=CLASTPTR->SRTSRTE; /*EST BASE */    0231
         L     SRTPTR,SRTSRTE(,CLASTPTR)                           0231
*                       IF SRTLNGTH= CBHNTRY1 THEN DO;             0232
         CLC   SRTLNGTH(2,SRTPTR),@CH01243                         0232
         BNE   @RF00232                                            0232
*                      /* ONLY ONE BHSET PRESENT SO                0234
*                         THE SRT ENTRY CAN BE DELETED */          0234
*                       CLASTPTR->SRTSRTE=SRTSRTE; /* RECHAIN ENTRIES*/
         L     @10,SRTSRTE(,SRTPTR)                                0234
         ST    @10,SRTSRTE(,CLASTPTR)                              0234
*                       CWORKREG = SRTLNGTH;  /* LENGTH FOR FREESTOR */
         LH    CWORKREG,SRTLNGTH(,SRTPTR)                          0235
         N     CWORKREG,@CF01315                                   0235
*                       RFY REG9 RSTD;                    /* @XM06239*/
*                       REG9=SRTPTR;                      /* @XM06239*/
         LR    REG9,SRTPTR                                         0237
*            /*FREESTOR AREA(REG9)FETCHP(NO)SIZE(CWORKREG)*/       0238
*             DO;                                                  0238
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0239
*/* END OF ATBUILD */                                              0239
*            RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;               0239
*            RFY ISTRPH BASED(GPR01P);                             0240
*            GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,                 0241
*                     GPR06P,GPR07P,GPR08P,GPR09P,                 0241
*                     GPR10P,GPR11P,GPR12P,GPR13P)                 0241
*                SETS(RPHWORK);                                    0241
*                                                                  0241
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*            GPR00F = CWORKREG;                        /*SIZE IN REG0*/
         LR    GPR00F,CWORKREG                                     0242
*            DCL 1 CMZA0038 FIXED(31) STATIC LOCAL,                0243
*                  2 * FIXED(8) INIT(64),            /* OPTION FLAGS */
*                  2 * FIXED(8) INIT(96),             /* STORAGE KEY */
*                  2 * FIXED(8) INIT(241),         /* SUBPOOL NUMBER */
*                  2 * FIXED(8) INIT('01'X);         /* REQUEST TYPE */
*            GPR03F = CMZA0038;                                    0244
         L     GPR03F,CMZA0038                                     0244
*            RFY (GPR04P) RSTD;                                    0245
*            GPR04P = REG9;               /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0246
         LR    GPR04P,REG9                                         0246
*            DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */         0247
*              GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/         0248
         L     GPR02P,ATCLCPTR                                     0248
*            END; /*LISATCVT*/                                     0249
*            CALL GPR02P -> ATCGTSTR;                 /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0250
         BALR  @14,@15                                             0250
*            RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;      0251
*            END ;                                  /*END OF FREESTOR*/
**@XM06239*/                                                       0252
*                       RFY REG9 UNRSTD;                  /* @XM06239*/
*                       CRETCODE=CGOOD;  /* SUCCESSFUL DELETE */   0254
         SLR   CRETCODE,CRETCODE                                   0254
*                       END;                                       0255
*                       ELSE DO;                                   0256
         B     @RC00232                                            0256
@RF00232 DS    0H                                                  0257
*                       /* MORE THAN ONE BHSET EXISTS FOR THE SRT  0257
*                          ENTRY.  STORAGE MUST BE OBTAINED AND THE
*                          EXISTING ENTRY COPIED TO IT, DELETING   0257
*                          THE BHSET THAT WAS REQUESTED TO BE      0257
*                          DELETED.  THE STORAGE FOR THE OLD ENTRY 0257
*                          WILL BE FREED.                           */
*                       RFY CTEMP RSTD;                            0257
*                       CTEMP=SRTLNGTH-CBHLNGTH; /*AMT FOR GETSTOR */
         LH    CTEMP,SRTLNGTH(,SRTPTR)                             0258
         N     CTEMP,@CF01315                                      0258
         SL    CTEMP,@CF01239                                      0258
*                   RFY SRTPTR UNRSTD;                             0259
*                   RFY CLASTPTR UNRSTD;                           0260
*                         /*GETSTOR SIZE(CTEMP)CLEAR(YES)FETCHP(NO)*/
*                          DO;                                     0261
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0262
*/* END OF ATBUILD */     RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;  0262
*                         RFY ISTRPH BASED(GPR01P);                0263
*                         GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,    0264
*                                  GPR06P,GPR07P,GPR08P,GPR09P,    0264
*                                  GPR10P,GPR11P,GPR12P,GPR13P)    0264
*                             SETS(RPHWORK);                       0264
*                                                                  0264
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*                         GPR00F = CTEMP;              /*SIZE IN REG0*/
         LR    GPR00F,CTEMP                                        0265
*                         DCL 1 CMZA0057 FIXED(31) STATIC LOCAL,   0266
*                               2 * FIXED(8) INIT(96),             0266
*                                                    /* OPTION FLAGS */
*                               2 * FIXED(8) INIT(96),/* STORAGE KEY */
*                               2 * FIXED(8) INIT(241),            0266
*                                                  /* SUBPOOL NUMBER */
*                               2 * FIXED(8) INIT('00'X);          0266
*                                                    /* REQUEST TYPE */
*                         GPR03F = CMZA0057;                       0267
*                                                                  0267
         L     GPR03F,CMZA0057                                     0267
*                         DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */
*                           GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/
         L     GPR02P,ATCLCPTR                                     0269
*                         END; /*LISATCVT*/                        0270
*                         CALL GPR02P -> ATCGTSTR;    /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0271
         BALR  @14,@15                                             0271
*                         RFY (GPR00P,GPR01P,GPR02P,GPR03P) UNRSTD;
*                         END ;                      /*END OF GETSTOR*/
*                   RFY SRTPTR RSTD;                               0274
*                   RFY CLASTPTR RSTD;                             0275
*                       CWORKREG=RPHSRPRM;  /* ADDRESS OF STORAGE */
         L     CWORKREG,RPHSRPRM(,GPR01P)                          0276
*                       IF CRCODE=0                                0277
*                          THEN DO;  /* STORAGE ACQUIRED */        0277
         LTR   CRCODE,CRCODE                                       0277
         BNZ   @RF00277                                            0277
*                          CSIZE = SRTLNGTH-CSIZE; /* AMT TO COPY */
         LH    @09,SRTLNGTH(,SRTPTR)                               0279
         N     @09,@CF01315                                        0279
         SLR   @09,CSIZE                                           0279
         LR    CSIZE,@09                                           0279
*                          CWORKREG->ISTSRT(1:CSIZE)=              0280
*                             ISTSRT(1:CSIZE);                     0280
         LR    @09,CSIZE                                           0280
         BCTR  @09,0                                               0280
         EX    @09,@SM01316                                        0280
*                          IF CTEMP=CSIZE THEN; /*BHSET AT END*/   0281
         CR    CTEMP,CSIZE                                         0281
         BE    @RT00281                                            0281
*                          ELSE DO;   /* MOVE REMAINDER */         0283
*                          CSIZE=CSIZE+1;  /* UPDATE START */      0284
         AL    CSIZE,@CF00081                                      0284
*                          CWORKREG->ISTSRT(CSIZE:CTEMP)=          0285
*                          ISTSRT(CSIZE+CBHLNGTH:CTEMP+CBHLNGTH);  0285
         LR    @09,CWORKREG                                        0285
         ALR   @09,CSIZE                                           0285
         AL    @09,@CF01233                                        0285
         LR    @04,CTEMP                                           0285
         SLR   @04,CSIZE                                           0285
         LR    @02,SRTPTR                                          0285
         ALR   @02,CSIZE                                           0285
         EX    @04,@SM01318                                        0285
*                          END;                                    0286
*                          RFY CSIZE UNRSTD;                       0287
@RT00281 DS    0H                                                  0288
*                          CWORKREG->SRTLNGTH=CTEMP; /* NEW LENGTH*/
         STH   CTEMP,SRTLNGTH(,CWORKREG)                           0288
*                         RFY CTEMP UNRSTD;                        0289
*                          CLASTPTR->SRTSRTE=CWORKREG; /*CHAIN NEW BLK*
         ST    CWORKREG,SRTSRTE(,CLASTPTR)                         0290
*                          CWORKREG=SRTLNGTH; /* LENGTH FOR FREESTOR */
         LH    CWORKREG,SRTLNGTH(,SRTPTR)                          0291
         N     CWORKREG,@CF01315                                   0291
*                          RFY REG9 RSTD;                 /* @XM06239*/
*                          REG9=SRTPTR;                   /* @XM06239*/
         LR    REG9,SRTPTR                                         0293
*            /*FREESTOR AREA(REG9)FETCHP(NO)SIZE(CWORKREG)*/       0294
*             DO;                                                  0294
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0295
*/* END OF ATBUILD */                                              0295
*            RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;               0295
*            RFY ISTRPH BASED(GPR01P);                             0296
*            GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,                 0297
*                     GPR06P,GPR07P,GPR08P,GPR09P,                 0297
*                     GPR10P,GPR11P,GPR12P,GPR13P)                 0297
*                SETS(RPHWORK);                                    0297
*                                                                  0297
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*            GPR00F = CWORKREG;                        /*SIZE IN REG0*/
         LR    GPR00F,CWORKREG                                     0298
*            DCL 1 CMZA0075 FIXED(31) STATIC LOCAL,                0299
*                  2 * FIXED(8) INIT(64),            /* OPTION FLAGS */
*                  2 * FIXED(8) INIT(96),             /* STORAGE KEY */
*                  2 * FIXED(8) INIT(241),         /* SUBPOOL NUMBER */
*                  2 * FIXED(8) INIT('01'X);         /* REQUEST TYPE */
*            GPR03F = CMZA0075;                                    0300
         L     GPR03F,CMZA0075                                     0300
*            RFY (GPR04P) RSTD;                                    0301
*            GPR04P = REG9;               /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0302
         LR    GPR04P,REG9                                         0302
*            DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */         0303
*              GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/         0304
         L     GPR02P,ATCLCPTR                                     0304
*            END; /*LISATCVT*/                                     0305
*            CALL GPR02P -> ATCGTSTR;                 /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0306
         BALR  @14,@15                                             0306
*            RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;      0307
*            END ;                                  /*END OF FREESTOR*/
**@XM06239*/                                                       0308
*                          RFY REG9 UNRSTD;               /* @XM06239*/
*                          CRETCODE=CGOOD;  /* SUCCESSFUL DELETE */
         SLR   CRETCODE,CRETCODE                                   0310
*                          END;                                    0311
*                       ELSE CRETCODE=CNOCORE; /* ERROR-NO STORAGE */
         B     @RC00277                                            0312
@RF00277 LA    CRETCODE,12                                         0312
*                       END;                                       0313
*                  END;                                            0314
*                  END;                                            0315
*        ELSE CRETCODE=CNTFOUND;  /* MATCH NOT FOUND */            0316
         B     @RC00222                                            0316
@RF00222 LA    CRETCODE,4                                          0316
*        CRETPTR = CSAVE;        /* GET RETURN ADDRESS */          0317
@RC00222 LR    CRETPTR,CSAVE                                       0317
*        RFY CSAVE UNRSTD;                                         0318
*END CDFBHSET;                                                     0319
*                                                                  0319
@EL00002 DS    0H                                                  0319
@EF00002 DS    0H                                                  0319
@ER00002 BR    @14                                                 0319
@PB00002 DS    0H                                                  0319
*/* TPEPILOG   */                                                  0320
* GEN (PRINT OFF);                                                 0320
*                                                                  0320
         PRINT OFF
* GEN (PRINT ON);                                                  0321
         PRINT ON
*/* END OF TPEPILOG */                                             0322
*/* ATDSPLY   INVOKED. */                                          0322
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTPAB                                               */
*/*             ISTDYPAB                                             */
*/*             ISTRPH                                               */
*/*             ISTLOK                                               */
*/*             ISTATCVT                                             */
*/*             ISTSRT                                               */
*/********************************************************************/
*/* END OF ATDSPLY. */                                             0322
*END ISTOCCDF                                                      0322
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*;                                                                 0322
@DATA    DS    0H
@CH01243 DC    H'26'
@SM01316 MVC   ISTSRT(0,CWORKREG),ISTSRT(SRTPTR)
@SM01318 MVC   ISTSRT(0,@09),ISTSRT+9(@02)
@DATD    DSECT
         DS    0F
ISTOCCDF CSECT
         DS    0F
@CF00081 DC    F'1'
@CF00054 DC    F'4'
@CF01239 DC    F'10'
@CF00974 DC    F'16'
@CF01233 DC    F'-1'
@CF01315 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTOCCDF CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CNEGVAL  DC    F'-1'
CMZA0019 DS    FL4
         ORG   CMZA0019
@NM00018 DC    AL1(64)
@NM00019 DC    AL1(96)
@NM00020 DC    AL1(241)
@NM00021 DC    XL1'01'
         ORG   CMZA0019+4
CMZA0038 DS    FL4
         ORG   CMZA0038
@NM00022 DC    AL1(64)
@NM00023 DC    AL1(96)
@NM00024 DC    AL1(241)
@NM00025 DC    XL1'01'
         ORG   CMZA0038+4
CMZA0057 DS    FL4
         ORG   CMZA0057
@NM00026 DC    AL1(96)
@NM00027 DC    AL1(96)
@NM00028 DC    AL1(241)
@NM00029 DC    XL1'00'
         ORG   CMZA0057+4
CMZA0075 DS    FL4
         ORG   CMZA0075
@NM00030 DC    AL1(64)
@NM00031 DC    AL1(96)
@NM00032 DC    AL1(241)
@NM00033 DC    XL1'01'
         ORG   CMZA0075+4
CBHSTMSK DC    X'7FFFFFFF'
CBITMASK DC    X'80000000'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
CREG0    EQU   @00
CNAMEPTR EQU   @00
CREG1    EQU   @01
CBHSPTR  EQU   @02
SRTPTR   EQU   @03
CSRTDPTR EQU   @04
CLASTPTR EQU   @05
CWORKREG EQU   @06
CRETCODE EQU   @07
ATCVTPTR EQU   @08
CSIZE    EQU   @08
REG9     EQU   @09
CTEMP    EQU   @10
CSAVE    EQU   @11
CRETPTR  EQU   @14
CRCODE   EQU   @15
RPHPTR   EQU   @01
GPR02F   EQU   @02
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR01F   EQU   @01
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
ATCLCPTR EQU   1032
CSRTDENT EQU   0
CSYMNAME EQU   0
CSYMNAM1 EQU   CSYMNAME
CSYMNAM2 EQU   CSYMNAME+4
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTDYPAB EQU   0
ISTRPH   EQU   0
RPHFLAGS EQU   ISTRPH+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   ISTRPH+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00007 EQU   LOKCHNG+2
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCSRT   EQU   ATCCOM+16
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCVLCNT EQU   ISTATCVT+772
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTSRT   EQU   0
SRTSRTE  EQU   ISTSRT
SRTFLAGS EQU   ISTSRT+4
SRTBHSET EQU   SRTFLAGS
SRTSDVT  EQU   SRTFLAGS
SRTLNGTH EQU   ISTSRT+6
SRTSYMNM EQU   ISTSRT+8
SRTRDTE  EQU   ISTSRT+16
SRTBHID  EQU   ISTSRT+25
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTEVERM EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
SRTRES4  EQU   ISTSRT+20
SRTRES2  EQU   ISTSRT+5
@NM00017 EQU   SRTFLAGS
@NM00016 EQU   SRTFLAGS
@NM00015 EQU   SRTFLAGS
@NM00014 EQU   SRTFLAGS
@NM00013 EQU   SRTFLAGS
SRTSDEL  EQU   SRTFLAGS
ATCAOS   EQU   ISTATCVT+1552
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMBP EQU   ATCAOSM+440
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00012 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPT18 EQU   ATCAOSM+300
ATCRPT17 EQU   ATCAOSM+296
ATCRPT16 EQU   ATCAOSM+292
ATCRPT15 EQU   ATCAOSM+288
ATCRPT14 EQU   ATCAOSM+284
ATCRPT13 EQU   ATCAOSM+280
ATCRPT12 EQU   ATCAOSM+276
ATCRPT11 EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
ATCRSVBB EQU   ISTATCVT+908
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00011 EQU   ISTATCVT+818
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ISTATCVT+788
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00010 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00009 EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
LOKXCL   EQU   @NM00007
LOKPRY   EQU   @NM00007
@NM00008 EQU   @NM00007
@NM00006 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHCRR   EQU   ISTRPH+32
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00005 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00004 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00003 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   ISTRPH+1
RPHTYPE  EQU   ISTRPH
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00119 EQU   @RC00117
@RC00224 EQU   @RC00222
@RC00232 EQU   @RC00222
@RC00277 EQU   @RC00222
@ENDDATA EQU   *
         END   ISTOCCDF,(C'PLS0632',0603,75130)
