SVTM     TITLE 'ISTOCCRL - FUNCTION RELEASE - DVT                      *
                        '
ISTOCCRL CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTOCCRL  75.130'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*                                                                  0282
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME : ISTOCCRL - MAIN LINE OF FUNCTION RELEASE        */
*/*                                                                  */
*/*   FUNCTION : UNDER THE PROTECTION OF THE DVTLOCK A PTR TO        */
*/*              EACH DVT IS OBTAINED FROM THE EPT AND A SUBOUTINE IS*/
*/*              CALLED TO DECREMENT THE DVT USE COUNT AND OR RELEASE*/
*/*              THE DVT CORE. THE EPT USE COUNT IS DECREMENTED      */
*/*              AND IF THIS WAS THE ONLY DESTINATION USING THIS     */
*/*              EPT,A SUBROUTINE IS CALLED TO UNCHAIN AND           */
*/*              RELEASE THE EPT CORE.                               */
*/*                                                                  */
*/*   INPUT : R1 = PTR TO RPH (ISTOCW PTR IN RPHWEA & EPT PTR IN OCW)*/
*/*                                                                  */
*/*   OUTPUT : R15 = RETURN CODE                                     */
*/*                                                                  */
*/*   ROUTINES CALLED : RELDVT - DECREMENTS THE DVT USE COUNT AND    */
*/*                              DETERMINES IF THE DVT SHOULD BE     */
*/*                              RELEASED.                           */
*/*                     DEQEPT - DEQUEUES THE EPT FROM THE ATCVT     */
*/*                              CHAIN AND RELEASES THE CORE         */
*/*                                                                  */
*/*   MACROS USED : CRRMAINT - TO PROVIDE A MODULE TRACE THRU VTAM   */
*/*                 TPLOCK,TPUNLOCK - TO PROTECT THE EPT AND DVT     */
*/*                                    CHAINS IN THE ATCVT WHILE     */
*/*                                    THE USE COUNTS ARE BEING      */
*/*                                    DECREMENTED AND WHILE THE EPTS*/
*/*                                    AND DVTS ARE BEING DEQUEUED   */
*/*                                                                  */
*/********************************************************************/
* R4=RPHWEA;                          /* ISTOCW PTR           */   0283
*                                                                  0283
         L     R4,RPHWEA(,RPHPTR)                                  0283
*  DO;                                                             0284
*/***  CRRMAINT  PROCNM(ISTOCCRL)COMP(OC)FUNC(SUB)  ***/           0285
*  DCL CMZK0006 PTR(31) REG(1);                                    0285
*  RFY (CMZK0006) RSTD;                                            0286
*                                                                  0286
*/* ATBUILD (ISTRPH,ISTCRA,ISTPFCRR,ISTOCCRR)  */                  0287
*  RFY ISTCNSTA;                                                   0287
*  RFY ISTOCCRR;                                                   0288
*/* END OF ATBUILD */                                              0289
*  /*** SET ENTERED BIT FOR THIS PROCEDURE ***/                    0289
*CMZK0006->RPHCRR->CRACRR->NOCCRL = '1'B;                          0289
         L     @03,RPHCRR(,CMZK0006)                               0289
         L     @03,CRACRR(,@03)                                    0289
         OI    NOCCRL(@03),B'01000000'                             0289
*  /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/                   0290
*CMZK0006->RPHCRR->CRACRR->OCCCRT = '0'B;                          0290
         XC    OCCCRT+1(2,@03),OCCCRT+1(@03)                       0290
         MVI   OCCCRT(@03),B'00000000'                             0290
*CMZK0006->RPHCRR->CRACRR->COCCRL = '1'B;                          0291
         OI    COCCRL(@03),B'01000000'                             0291
*  END;                                                            0292
*                                                                  0292
*/*** START -TPLOCK (DVTLOCK)TYPE(XCLSIVE)- ***/                   0293
*  DO;                                                             0293
*  DCL GPR05F FIXED(31) REG(05);                                   0294
*  DCL GPR05P PTR(31)   REG(05);                                   0295
*  DCL GPR06F FIXED(31) REG(06);                                   0296
*  DCL GPR06P PTR(31)   REG(06);                                   0297
*  DCL GPR07F FIXED(31) REG(07);                                   0298
*  DCL GPR07P PTR(31)   REG(07);                                   0299
*  DCL GPR08F FIXED(31) REG(08);                                   0300
*  DCL GPR08P PTR(31)   REG(08);                                   0301
*  DCL GPR09F FIXED(31) REG(09);                                   0302
*  DCL GPR09P PTR(31)   REG(09);                                   0303
*  DCL GPR10F FIXED(31) REG(10);                                   0304
*  DCL GPR10P PTR(31)   REG(10);                                   0305
*  DCL GPR11F FIXED(31) REG(11);                                   0306
*  DCL GPR11P PTR(31)   REG(11);                                   0307
*  DCL GPR12F FIXED(31) REG(12);                                   0308
*  DCL GPR12P PTR(31)   REG(12);                                   0309
*  DCL GPR13F FIXED(31) REG(13);                                   0310
*  DCL GPR13P PTR(31)   REG(13);                                   0311
*  DCL GPR14F FIXED(31) REG(14);                                   0312
*  DCL GPR14P PTR(31)   REG(14);                                   0313
*                                                                  0313
*  DCL GPR00F FIXED(31) REG(00);                                   0314
*  DCL GPR00P PTR(31)   REG(00);                                   0315
*  DCL GPR01F FIXED(31) REG(01);                                   0316
*  DCL GPR01P PTR(31)   REG(01);                                   0317
*  DCL GPR02F FIXED(31) REG(02);                                   0318
*  DCL GPR02P PTR(31)   REG(02);                                   0319
*  DCL GPR03F FIXED(31) REG(03);                                   0320
*  DCL GPR03P PTR(31)   REG(03);                                   0321
*  DCL GPR04F FIXED(31) REG(04);                                   0322
*  DCL GPR04P PTR(31)   REG(04);                                   0323
*  DCL GPR15F FIXED(31) REG(15);                                   0324
*  DCL GPR15P PTR(31)   REG(15);                                   0325
*  RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) RSTD;           0326
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*        GPR15P = ATCAP36;              /*ADDRESS OF LOCK ROUTINE*/
         L     @11,OCWACVT(,R4)                                    0328
         L     GPR15P,ATCAP36(,@11)                                0328
*        GPR02P = ADDR(ATCDVTLK);       /*SET PARAM - LOCKWORD PTR*/
         LA    GPR02P,ATCDVTLK(,@11)                               0329
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/ 0330
         L     GPR04P,RPHCRR(,GPR01P)                              0330
*        GPR00P = CRALMS08;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,128                                          0331
*        GPR03P = ADDR(GPR04P->CRAL8PTR);                          0332
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0332
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*        DCL FMZL0008 BASED(GPR15P) LABEL VALUERANGE(*);           0333
*        CALL FMZL0008;                                            0334
         BALR  @14,@15                                             0334
*        GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                      0335
*                                                                  0335
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*  RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD;         0336
*        END;                                                      0337
*/*** END -TPLOCK (DVTLOCK)TYPE(XCLSIVE)- ***/                     0338
* IF RCREG=0                                                       0338
*   THEN DO;                                                       0338
         LTR   RCREG,RCREG                                         0338
         BNZ   @RF00338                                            0338
*        OCWDLOCK='1'B;                                            0340
         OI    OCWDLOCK(R4),B'00001000'                            0340
*        R13=R13+OCWSLEN;    /* STEP FOR NEXT OCW SAVEAREA */      0341
         SLR   @03,@03                                             0341
         IC    @03,OCWSLEN(,R4)                                    0341
         ALR   R13,@03                                             0341
*        OCWODFST=OCWEPTAB+LENGTH(ISTEPT);                         0342
*                                                                  0342
         L     @03,OCWEPTAB(,R4)                                   0342
         LA    @00,12                                              0342
         ALR   @00,@03                                             0342
         ST    @00,OCWODFST(,R4)                                   0342
*        /*------------------------------------------------- @DL31HMP*/
*        /* THIS MODIFICATION WAS FOR ZTR-9600-K             @DL31HMP*/
*        /*------------------------------------------------- @DL31HMP*/
*        /* RELEASE POINTERS IN ENTRY POINT TABLE            @DL31HMP*/
*        DO ILOOPCTR=OCWEPTAB->EPTHECNT TO 2 BY -1; /* LOOP  @DL31HMP*/
*                                                                  0343
         LH    ILOOPCTR,EPTHECNT(,@03)                             0343
         B     @DE00343                                            0343
@DL00343 DS    0H                                                  0344
*          CALL RELDVT;                                            0344
         BAL   @14,RELDVT                                          0344
*        END;                                                      0345
*                                                                  0345
         BCTR  ILOOPCTR,0                                          0345
@DE00343 CH    ILOOPCTR,@CH00072                                   0345
         BNL   @DL00343                                            0345
*        /* DECR EPTAB USE CNT.  ONLY 1 EPTAB/USER */              0346
*        OCWEPTAB->EPTHUCNT=OCWEPTAB->EPTHUCNT-1;                  0346
         L     @03,OCWEPTAB(,R4)                                   0346
         LH    @00,EPTHUCNT(,@03)                                  0346
         BCTR  @00,0                                               0346
         STH   @00,EPTHUCNT(,@03)                                  0346
*        IF OCWEPTAB->EPTHUCNT=0                                   0347
*        THEN CALL DEQEPT;                   /* D-Q FROM CVT CHAIN   */
         LTR   @00,@00                                             0347
         BNZ   @RF00347                                            0347
         BAL   @14,DEQEPT                                          0348
*        ELSE;                                                     0349
@RF00347 DS    0H                                                  0350
*        IF OCWDLOCK='1'B                                          0350
*           THEN DO;                                               0350
*                                                                  0350
         TM    OCWDLOCK(R4),B'00001000'                            0350
         BNO   @RF00350                                            0350
*/*** START -TPUNLOCK (DVTLOCK)- ***/                              0352
*                DO;                                               0352
*                                                                  0352
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)  */                             0353
*/* END OF ATBUILD */                                              0353
*                RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) RSTD;
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*        GPR02P = ADDR(ATCDVTLK);       /*SET PARAM - LOCKWORD PTR*/
         L     GPR02P,OCWACVT(,R4)                                 0355
         LA    GPR02P,ATCDVTLK(,GPR02P)                            0355
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/ 0356
         L     GPR04P,RPHCRR(,GPR01P)                              0356
*        GPR00P = CRALMS08;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,128                                          0357
*        GPR03P = ADDR(GPR04P->CRAL8PTR);                          0358
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0358
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*                                                                  0359
*                DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */     0359
*                  GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/     0360
         L     GPR15P,ATCLCPTR                                     0360
*                END; /*LISATCVT*/                                 0361
*        GPR15P=GPR15P->ATCAP33;                                   0362
         L     GPR15P,ATCAP33(,GPR15P)                             0362
*        DCL FMZL0013 BASED(GPR15P) LABEL VALUERANGE(*);           0363
*        CALL FMZL0013;                                            0364
         BALR  @14,@15                                             0364
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                      0365
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*                RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD
*        END;                                                      0367
*/*** END -TPUNLOCK (DVTLOCK)- ***/                                0368
*               OCWDLOCK='0'B;                                     0368
         NI    OCWDLOCK(R4),B'11110111'                            0368
*               END;                                               0369
*           ELSE;                                                  0370
@RF00350 DS    0H                                                  0371
*        R13=R13-OCWSLEN;                                          0371
         SLR   @03,@03                                             0371
         IC    @03,OCWSLEN(,R4)                                    0371
         SLR   R13,@03                                             0371
*        RCREG=0;                                                  0372
         SLR   RCREG,RCREG                                         0372
*       END;                                                       0373
*   ELSE DO;                                                       0374
         B     @RC00338                                            0374
@RF00338 DS    0H                                                  0375
*       OCWRC='24'X;                                               0375
         MVI   OCWRC(R4),X'24'                                     0375
*       OCWEC='10'X;                                               0376
         MVI   OCWEC(R4),X'10'                                     0376
*       END;                                                       0377
* RETURN CODE(RCREG);                                              0378
@RC00338 L     @14,12(,@13)                                        0378
         LM    @00,@12,20(@13)                                     0378
         BR    @14                                                 0378
*                                                                  0379
*/********************************************************************/
*/*   ROUTINE NAME : RELDVT - RELEASE DVT                            */
*/*                                                                  */
*/*   FUNCTION : TO DECREMENT THE USE COUNT OF THE DVT AND IF THIS   */
*/*              IS THE ONLY DESTINATION USING THE DVT, DEQDVT IS    */
*/*              CALLED TO DEQUEUE AND RELEASE THE CORE              */
*/*                                                                  */
*/*   INPUT : OCWODFST - POINTS TO A DVT ADDRESS (EPT ENTRY)         */
*/*                                                                  */
*/*   OUTPUT : OCWODFST - POINTS TO THE NEXT EPT ENTRY               */
*/*                                                                  */
*/*   ROUTINES CALLED : DEQDVT - CALLED TO DEQUEUE THE DVT FROM      */
*/*                              THE ATCVT DVT CHAIN AND RELEASE THE */
*/*                              CORE                                */
*/*                                                                  */
*/*   MACROS USED : NONE                                             */
*/*                                                                  */
*/*********************************************************************
*RELDVT: PROC OPTIONS(NOSAVE,NOSAVEAREA);    /* RELEASE DVT          */
RELDVT   DS    0H                                                  0380
*        C14SAVE=CR14PTR;                                          0380
         LA    @03,624                                             0380
         ALR   @03,R4                                              0380
         L     @11,C14SVPTR(,@03)                                  0380
         ST    CR14PTR,C14SAVE(,@11)                               0380
*        C14SVPTR=C14SVPTR+4;                                      0381
         AH    @11,@CH00052                                        0381
         ST    @11,C14SVPTR(,@03)                                  0381
*        DDVT=OCWODFST->EPTDVT-LENGTH(DVTHDR); /* DELETED DVT PTR    */
         L     @03,OCWODFST(,R4)                                   0382
         L     DDVT,EPTDVT(,@03)                                   0382
         SH    DDVT,@CH00069                                       0382
*        DVTHUCNT=DVTHUCNT-1;                /* DECR DVT USE CNT     */
         LH    @03,DVTHUCNT(,DDVT)                                 0383
         BCTR  @03,0                                               0383
         STH   @03,DVTHUCNT(,DDVT)                                 0383
*        IF DVTHUCNT=0                                             0384
*          THEN DO;                                                0384
         LTR   @03,@03                                             0384
         BNZ   @RF00384                                            0384
*          CALL DEQDVT;                                            0386
         BAL   @14,DEQDVT                                          0386
*          END;                                                    0387
*          ELSE;                                                   0388
@RF00384 DS    0H                                                  0389
*        OCWODFST=OCWODFST+LENGTH(ISTEPTE);  /* STEP FOR NEXT DVT PTR*/
         LA    @03,12                                              0389
         AL    @03,OCWODFST(,R4)                                   0389
         ST    @03,OCWODFST(,R4)                                   0389
*        C14SVPTR=C14SVPTR-4;                                      0390
         LA    @03,624                                             0390
         ALR   @03,R4                                              0390
         L     @00,C14SVPTR(,@03)                                  0390
         SH    @00,@CH00052                                        0390
         ST    @00,C14SVPTR(,@03)                                  0390
*        CR14PTR=C14SAVE;                                          0391
         LR    @03,@00                                             0391
         L     CR14PTR,C14SAVE(,@03)                               0391
*        END   RELDVT;                                             0392
@EL00002 DS    0H                                                  0392
@EF00002 DS    0H                                                  0392
@ER00002 BR    @14                                                 0392
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME : DEQDVT - DEQUEUE DVT                            */
*/*                                                                  */
*/*   FUNCTION : TO REMOVE THE DVT FROM THE ATCVT CHAIN OF DVTS AND  */
*/*              TO RELEASE THE CORE OF THE DVT.                     */
*/*                                                                  */
*/*   INPUT : DDVT - POINTER TO THE DVT TO BE DEQUEUED AND RELEASED  */
*/*                                                                  */
*/*   OUTPUT : NONE                                                  */
*/*                                                                  */
*/*   ROUTINES CALLED : NONE                                         */
*/*                                                                  */
*/*   MACROS USED : FREESTOR - TO RETURN THE DVT CORE TO STORAGE     */
*/*                            MANAGEMENT POOL                       */
*/*                                                                  */
*/********************************************************************/
*DEQDVT: PROC OPTIONS(NOSAVE,NOSAVEAREA);                          0393
DEQDVT   DS    0H                                                  0394
*        C14SAVE=CR14PTR;                                          0394
         LA    @03,624                                             0394
         ALR   @03,R4                                              0394
         L     @11,C14SVPTR(,@03)                                  0394
         ST    CR14PTR,C14SAVE(,@11)                               0394
*        C14SVPTR=C14SVPTR+4;                                      0395
         AH    @11,@CH00052                                        0395
         ST    @11,C14SVPTR(,@03)                                  0395
*        IF DDVT=OCWACVT->ATCFDVT     /* DOES CVT POINT TO D DVT     */
*        THEN OCWACVT->ATCFDVT=DVTHFORW;      /* PUT NEXT DVT@ IN CVT *
         L     @03,OCWACVT(,R4)                                    0396
         C     DDVT,ATCFDVT(,@03)                                  0396
         BNE   @RF00396                                            0396
         MVC   ATCFDVT(4,@03),DVTHFORW(DDVT)                       0397
*        ELSE DO;                                                  0398
         B     @RC00396                                            0398
@RF00396 DS    0H                                                  0399
*          A=OCWACVT->ATCFDVT;                /* PREV DVT@            *
         L     @11,OCWACVT(,R4)                                    0399
         L     A,ATCFDVT(,@11)                                     0399
*          B=A->DVTHFORW;                    /* NEXT DVT@            */
         L     B,DVTHFORW(,A)                                      0400
*            DO WHILE (B^=DDVT);             /* SEARCH FOR D DVT     */
         B     @DE00401                                            0401
@DL00401 DS    0H                                                  0402
*            A=B;                                                  0402
         LR    A,B                                                 0402
*            B=B->DVTHFORW;                                        0403
         L     B,DVTHFORW(,B)                                      0403
*            END;                                                  0404
@DE00401 CR    B,DDVT                                              0404
         BNE   @DL00401                                            0404
*          A->DVTHFORW=B->DVTHFORW;          /* POINT AROUND D DVT   */
         MVC   DVTHFORW(4,A),DVTHFORW(B)                           0405
*          END;                                                    0406
*        OCWODFST->EPTDVT=0;                 /* ZERO D DVT IN EPTAB  */
@RC00396 L     @03,OCWODFST(,R4)                                   0407
         SLR   @00,@00                                             0407
         ST    @00,EPTDVT(,@03)                                    0407
*         /*FREESTOR AREA(DDVT)FETCHP(NO)SIZE(DVTHLEN)SAVE(YES)*/  0408
*          DO;                                                     0408
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0409
*/* END OF ATBUILD */                                              0409
*         RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                  0409
*         RFY ISTRPH BASED(GPR01P);                                0410
*         GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,                    0411
*                  GPR06P,GPR07P,GPR08P,GPR09P,                    0411
*                  GPR10P,GPR11P,GPR12P,GPR13P)                    0411
*             SETS(RPHWORK);                                       0411
*                                                                  0411
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*         GPR00F = DVTHLEN;                            /*SIZE IN REG0*/
         LH    GPR00F,DVTHLEN(,DDVT)                               0412
*         DCL 1 CMZA0023 FIXED(31) STATIC LOCAL,                   0413
*               2 * FIXED(8) INIT(64),               /* OPTION FLAGS */
*               2 * FIXED(8) INIT(96),                /* STORAGE KEY */
*               2 * FIXED(8) INIT(241),            /* SUBPOOL NUMBER */
*               2 * FIXED(8) INIT('01'X);            /* REQUEST TYPE */
*         GPR03F = CMZA0023;                                       0414
         L     GPR03F,CMZA0023                                     0414
*         RFY (GPR04P) RSTD;                                       0415
*         GPR04P = DDVT;                  /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0416
         LR    GPR04P,DDVT                                         0416
*         DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */            0417
*           GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/            0418
         L     GPR02P,ATCLCPTR                                     0418
*         END; /*LISATCVT*/                                        0419
*         CALL GPR02P -> ATCGTSTR;                    /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0420
         BALR  @14,@15                                             0420
*         RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;         0421
*         END ;                                     /*END OF FREESTOR*/
*/*               @D31KKJY*/                                       0423
*        C14SVPTR=C14SVPTR-4;                                      0423
         LA    @03,624                                             0423
         ALR   @03,R4                                              0423
         L     @00,C14SVPTR(,@03)                                  0423
         SH    @00,@CH00052                                        0423
         ST    @00,C14SVPTR(,@03)                                  0423
*        CR14PTR=C14SAVE;                                          0424
         LR    @03,@00                                             0424
         L     CR14PTR,C14SAVE(,@03)                               0424
*        END DEQDVT;                                               0425
@EL00003 DS    0H                                                  0425
@EF00003 DS    0H                                                  0425
@ER00003 BR    @14                                                 0425
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME : DEQEPT - DEQUEUE EPT                            */
*/*                                                                  */
*/*   FUNCTION : TO DECHAIN THE EPT FROM THE ATCVT EPT CHAIN AND     */
*/*              TO RELEASE THE EPT CORE.                            */
*/*                                                                  */
*/*   INPUT : OCWEPTAB - POINTS TO THE EPT                           */
*/*                                                                  */
*/*   OUTPUT : NONE                                                  */
*/*                                                                  */
*/*   ROUTINES CALLED : NONE                                         */
*/*                                                                  */
*/*   MACROS USED : FREESTOR - TO RETURN THE EPT CORE TO STORAGE     */
*/*                            MANAGEMENT POOLS.                     */
*/*                                                                  */
*/********************************************************************/
*DEQEPT:  PROC OPTIONS  (NOSAVE,NOSAVEAREA);                       0426
DEQEPT   DS    0H                                                  0427
*        C14SAVE=CR14PTR;                                          0427
         LA    @03,624                                             0427
         ALR   @03,R4                                              0427
         L     @11,C14SVPTR(,@03)                                  0427
         ST    CR14PTR,C14SAVE(,@11)                               0427
*        C14SVPTR=C14SVPTR+4;                                      0428
         AH    @11,@CH00052                                        0428
         ST    @11,C14SVPTR(,@03)                                  0428
*        IF OCWEPTAB= OCWACVT->ATCFEPT   /* DOES CVT POINT TO D EPTAB *
*        THEN OCWACVT->ATCFEPT = OCWEPTAB->EPTHFORM; /*NXT EPTAB - CVT*
         L     @03,OCWEPTAB(,R4)                                   0429
         L     @11,OCWACVT(,R4)                                    0429
         C     @03,ATCFEPT(,@11)                                   0429
         BNE   @RF00429                                            0429
         MVC   ATCFEPT(4,@11),EPTHFORM(@03)                        0430
*        ELSE DO;                                                  0431
         B     @RC00429                                            0431
@RF00429 DS    0H                                                  0432
*          A=OCWACVT->ATCFEPT;                /* PREV EPTAB@          *
         L     @11,OCWACVT(,R4)                                    0432
         L     A,ATCFEPT(,@11)                                     0432
*          B=A->EPTHFORM;                    /* NEXT EPTAB@          */
         L     B,EPTHFORM(,A)                                      0433
*            DO WHILE (B^=OCWEPTAB);         /* SEARCH FOR D EPTAB   */
         B     @DE00434                                            0434
@DL00434 DS    0H                                                  0435
*            A=B;                                                  0435
         LR    A,B                                                 0435
*            B=B->EPTHFORM;                                        0436
         L     B,EPTHFORM(,B)                                      0436
*            END;                                                  0437
@DE00434 C     B,OCWEPTAB(,R4)                                     0437
         BNE   @DL00434                                            0437
*          A->EPTHFORM=B->EPTHFORM;          /* POINT AROUND D EPTAB */
         MVC   EPTHFORM(4,A),EPTHFORM(B)                           0438
*          END;                                                    0439
*        B=OCWEPTAB;                                               0440
@RC00429 L     B,OCWEPTAB(,R4)                                     0440
*        A=B->EPTHLEN;    /* B->EPTHECNT*4+20 */                   0441
         LH    A,EPTHLEN(,B)                                       0441
*         /*FREESTOR AREA(B)FETCHP(NO)SIZE(A)SAVE(YES)*/           0442
*          DO;                                                     0442
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0443
*/* END OF ATBUILD */                                              0443
*         RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                  0443
*         RFY ISTRPH BASED(GPR01P);                                0444
*         GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,                    0445
*                  GPR06P,GPR07P,GPR08P,GPR09P,                    0445
*                  GPR10P,GPR11P,GPR12P,GPR13P)                    0445
*             SETS(RPHWORK);                                       0445
*                                                                  0445
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*         GPR00F = A;                                  /*SIZE IN REG0*/
         LR    GPR00F,A                                            0446
*         DCL 1 CMZA0042 FIXED(31) STATIC LOCAL,                   0447
*               2 * FIXED(8) INIT(64),               /* OPTION FLAGS */
*               2 * FIXED(8) INIT(96),                /* STORAGE KEY */
*               2 * FIXED(8) INIT(241),            /* SUBPOOL NUMBER */
*               2 * FIXED(8) INIT('01'X);            /* REQUEST TYPE */
*         GPR03F = CMZA0042;                                       0448
         L     GPR03F,CMZA0042                                     0448
*         RFY (GPR04P) RSTD;                                       0449
*         GPR04P = B;                     /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0450
         LR    GPR04P,B                                            0450
*         DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */            0451
*           GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/            0452
         L     GPR02P,ATCLCPTR                                     0452
*         END; /*LISATCVT*/                                        0453
*         CALL GPR02P -> ATCGTSTR;                    /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0454
         BALR  @14,@15                                             0454
*         RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;         0455
*         END ;                                     /*END OF FREESTOR*/
*/* EPTAB STOR                                                     0457
*    @D31KKJY*/                                                    0457
*        C14SVPTR=C14SVPTR-4;                                      0457
         LA    @03,624                                             0457
         ALR   @03,R4                                              0457
         L     @00,C14SVPTR(,@03)                                  0457
         SH    @00,@CH00052                                        0457
         ST    @00,C14SVPTR(,@03)                                  0457
*        CR14PTR=C14SAVE;                                          0458
         LR    @03,@00                                             0458
         L     CR14PTR,C14SAVE(,@03)                               0458
*        END DEQEPT;                                               0459
*                                                                  0459
*                                                                  0459
@EL00004 DS    0H                                                  0459
@EF00004 DS    0H                                                  0459
@ER00004 BR    @14                                                 0459
*/* TPEPILOG   */                                                  0460
*         GEN (PRINT OFF);                                         0460
*                                                                  0460
         PRINT OFF
* /*  CONNECTION SERVICES COMPONENT RECOVERY RECORD                  */
* /* COMPLETED DCR SOLUTIONS                                         */
* /* 1H0540 APRIL 28, 1973 MB                                        */
*/* ZTR4417 JUNE 20, 73 DNM */                                     0461
* DCL 1 ISTCNSTA BDY(WORD) BASED,       /* CONNECTION SERVICES     0461
*                                          COMPONENT RECOVERY RECORD */
*     2  CNSTPFX CHAR(LENGTH(ISTPFCRR)), /* STANDARD PREFIX        0461
*                                          FOR CRR                   */
*     2  CNSTFLDA CHAR(3),              /* TRACE FIELD A - HISTORY   */
*        3  CNSMRINA BIT(1),            /* MASTER ENTERED            */
*        3  CNSAUTHA BIT(1),            /* ABOUT TO CALL AUTHORI-  0461
*                                          SATION EXIT       ZTR4417 */
*        3  CNSAQINA BIT(1),            /* ACQUIRE ENTERED           */
*        3  CNSXREQA BIT(1),            /* ACQUIRE SATISFIED         */
*        3  CNSQREQA BIT(1),            /* ACQUIRE QUEUED            */
*        3  CNSRLINA BIT(1),            /* RELEASE ENTERED           */
*        3  CNSDORLA BIT(1),            /* DOREL REALLOCATION      0461
*                                          ENTERED                   */
*        3  CNSTRRLA BIT(1),            /* RELEASE OF ACTIVE       0461
*                                          CONNECTION                */
*        3  CNSRQRLA BIT(1),            /* RELEASE QUEUED REQUEST    */
*        3  CNSPSINA BIT(1),            /* PASS ENTERED              */
*        3  CNSACINA BIT(1),            /* ACCEPT ENTERED            */
*        3  CNSLGINA BIT(1),            /* LOGON ENTERED             */
*        3  CNSGBINA BIT(1),            /* PREEMPT ENTERED           */
*        3  CNSCLINA BIT(1),            /* CANCEL ENTERED            */
*        3  CNSCLAQA BIT(1),            /* CANCEL ACQUIRES           */
*        3  CNSTCONA BIT(1),            /* TCONNECT                  */
*        3  CNSACONA BIT(1),            /* ACONNECT                  */
*        3  CNSQUEUA BIT(1),            /* QUEUE                     */
*        3  CNSSEARA BIT(1),            /* SEARCH Q                  */
*        3  CNSGETSA BIT(1),            /* CONNECTION SERVICES     0461
*                                          GETSTORE                  */
*        3  CNSFREEA BIT(1),            /* CONNECTION SERVICES     0461
*                                          FREESTORE                 */
*        3  CNSACCTA BIT(1),            /* ABOUT TO CALL           0461
*                                          ACCOUNTING EXIT           */
*        3  CNSLOG0A BIT(1),            /* LOGON 0                   */
*        3  CNSRSV01 BIT(1),            /* RESERVED                  */
*     2  CNSTFLDB CHAR(3),              /* TRACE FIELD B -         0461
*                                          CURRENT ACTIVITY          */
*        3  CNSMRINB BIT(1),                                       0461
*        3  CNSAUTHB BIT(1),                                       0461
*        3  CNSAQINB BIT(1),                                       0461
*        3  CNSXREQB BIT(1),                                       0461
*        3  CNSQREQB BIT(1),                                       0461
*        3  CNSRLINB BIT(1),                                       0461
*        3  CNSDORLB BIT(1),                                       0461
*        3  CNSTRRLB BIT(1),                                       0461
*        3  CNSRQRLB BIT(1),                                       0461
*        3  CNSPSINB BIT(1),                                       0461
*        3  CNSACINB BIT(1),                                       0461
*        3  CNSLGINB BIT(1),                                       0461
*        3  CNSGBINB BIT(1),                                       0461
*        3  CNSCLINB BIT(1),                                       0461
*        3  CNSCLAQB BIT(1),                                       0461
*        3  CNSTCONB BIT(1),                                       0461
*        3  CNSACONB BIT(1),                                       0461
*        3  CNSQUEUB BIT(1),                                       0461
*        3  CNSSEARB BIT(1),                                       0461
*        3  CNSGETSB BIT(1),                                       0461
*        3  CNSFREEB BIT(1),                                       0461
*        3  CNSACCTB BIT(1),                                       0461
*        3  CNSLOG0B BIT(1),                                       0461
*        3  CNSRSV05 BIT(1);                                       0461
* /*     CRR FOR OPEN/CLOSE                                          */
*/*  REVISIONS                                         002 03/27/75  */
* DCL 1 ISTOCCRR BDY(WORD) BASED,       /* CRR FOR OPEN/CLOSE        */
*     2  OCCCNS   CHAR(LENGTH(ISTCNSTA)), /* RESERVE SPACE FOR     0462
*                                          CONN. SVC'S AUDIT         */
*     2  OCCAUDIT,                      /* AUDIT TRAIL FOR OPEN/CLOSE*/
*        3  OCCNTRD CHAR(3),            /* LIST OF MODULES IN OPEN/
*                                          CLOSE ENTERED             */
*           4  NOCCOC BIT(1),           /* INDICATES MODULE ISTOCCOC
*                                          ENTERED                   */
*           4  NOCCCL BIT(1),           /* INDICATES MODULE ISTOCCCL
*                                          ENTERED                   */
*           4  NOCCCH BIT(1),           /* INDICATES MODULE ISTOCCCH
*                                          ENTERED                   */
*           4  NOCCSL BIT(1),           /* INDICATES MODULE ISTOCCSL
*                                          ENTERED                   */
*           4  NOCCFO BIT(1),           /* INDICATES MODULE ISTOCCFO
*                                          ENTERED                   */
*           4  NOCCFR BIT(1),           /* INDICATES MODULE ISTOCCFR
*                                          ENTERED                   */
*           4  NOCCMD BIT(1),           /* INDICATES MODULE ISTOCCMD
*                                          ENTERED                   */
*           4  NOCCFD BIT(1),           /* INDICATES MODULE ISTOCCFD
*                                          ENTERED                   */
*           4  NOCCRD BIT(1),           /* INDICATES MODULE ISTOCCRD
*                                          ENTERED                   */
*           4  NOCCSD BIT(1),           /* INDICATES MODULE ISTOCCSD
*                                          ENTERED                   */
*           4  NOCCOD BIT(1),           /* INDICATES MODULE ISTOCCOD
*                                          ENTERED                   */
*           4  NOCCOE BIT(1),           /* INDICATES MODULE ISTOCCOE
*                                          ENTERED                   */
*           4  NOCCLD BIT(1),           /* INDICATES MODULE ISTOCCLD
*                                          ENTERED                   */
*           4  NOCCOF BIT(1),           /* INDICATES MODULE ISTOCCOF
*                                          ENTERED                   */
*           4  NOCCFB BIT(1),           /* INDICATES MODULE ISTOCCFB
*                                          ENTERED                   */
*           4  NOCCRT BIT(1),           /* INDICATES MODULE ISTOCCRT
*                                          ENTERED                   */
*           4  NOCCQU BIT(1),           /* INDICATES MODULE ISTOCCQU
*                                          ENTERED                   */
*           4  NOCCRL BIT(1),           /* INDICATES MODULE ISTOCCRL
*                                          ENTERED                   */
*           4  NOCCCC   BIT(1),         /* INDICATES MODULE ISTOCCCC
*                                          ENTERED                   */
*           4  NOCCNV BIT(1),           /* INDICATES MODULE ISTOCCNV
*                                          ENTERED                   */
*           4  NOCCCM BIT(1),           /* ISTOCCCM ENTERED          */
*           4  NOCCCN BIT(1),           /* ISTOCCCN ENTERED          */
*           4  NOCACX   BIT(1),                                    0462
*           4  NOCPOI BIT(1),           /* ISTCFCPO ENTERED OR       */
*                                       /* ISTCFCPC ENTERED          */
*        3  OCCCRT CHAR(3),             /* LIST OF OPEN/CLOSE      0462
*                                          MODULES RUNNING           */
*           4  COCCOC BIT(1),           /* INDICATES MODULE ISTOCCOC
*                                          RUNNING                   */
*           4  COCCCL BIT(1),           /* INDICATES MODULE ISTOCCCL
*                                          RUNNING                   */
*           4  COCCCH BIT(1),           /* INDICATES MODULE ISTOCCCH
*                                          RUNNING                   */
*           4  COCCSL BIT(1),           /* INDICATES MODULE ISTOCCSL
*                                          RUNNING                   */
*           4  COCCFO BIT(1),           /* INDICATES MODULE ISTOCCFO
*                                          RUNNING                   */
*           4  COCCFR BIT(1),           /* INDICATES MODULE ISTOCCFR
*                                          RUNNING                   */
*           4  COCCMD BIT(1),           /* INDICATES MODULE ISTOCCMD
*                                          RUNNING                   */
*           4  COCCFD BIT(1),           /* INDICATES  MODULE ISTOCCFD
*                                          RUNNING                   */
*           4  COCCRD BIT(1),           /* INDICATES MODULE ISTOCCRD
*                                          RUNNING                   */
*           4  COCCSD BIT(1),           /* INDICATES MODULE ISTOCCSD
*                                          RUNNING                   */
*           4  COCCOD BIT(1),           /* INDICATES MODULE ISTOCCOD
*                                          RUNNING                   */
*           4  COCCOE BIT(1),           /* INDICATES MODULE ISTOCCOE
*                                          RUNNING                   */
*           4  COCCLD BIT(1),           /* INDICATES MODULE ISTOCCLD
*                                          RUNNING                   */
*           4  COCCOF BIT(1),           /* INDICATES MODULE ISTOCCOF
*                                          RUNNING                   */
*           4  COCCFB BIT(1),           /* INDICATES MODULE ISTOCCFB
*                                          RUNNING                   */
*           4  COCCRT BIT(1),           /* INDICATES MODULE ISTOCCRT
*                                          RUNNING                   */
*           4  COCCQU BIT(1),           /* INDICATES MODULE ISTOCCQU
*                                          RUNNING                   */
*           4  COCCRL BIT(1),           /* INDICATES MODULE ISTOCCRL
*                                          RUNNING                   */
*           4  COCCCC   BIT(1),         /* INDICATES MOD ISTOCCCC  0462
*                                          RUNNING                   */
*           4  COCCNV BIT(1),           /* INDICATES MODULE ISTOCCNV
*                                          RUNNING                   */
*           4  COCCCM BIT(1),           /* ISTOCCCM RUNNING          */
*           4  COCCCN BIT(1),           /* ISTOCCCN RUNNING          */
*           4  COCACX   BIT(1),                                    0462
*           4  COCPOI BIT(1);           /* ISTCFCPO RUNNING OR       */
*                                       /* ISTCFCPC RUNNING          */
*DCL TIDOCCCC BIT(8) CONSTANT('00'X);   /* THREAD ID FOR           0463
*                                          ISTOCCCC                  */
*DCL TIDOCCCH BIT(8) CONSTANT('01'X);   /* THREAD ID FOR           0464
*                                          ISTOCCCH                  */
*DCL TIDOCCOD BIT(8) CONSTANT('02'X);   /* THREAD ID FOR           0465
*                                          ISTOCCOD                  */
*DCL TIDOCCCL BIT(8) CONSTANT('04'X);   /* THREAD ID FOR           0466
*                                          ISTOCCCL                  */
*DCL TIDOCCOC BIT(8) CONSTANT('08'X);   /* THREAD ID FOR           0467
*                                          ISTOCCOC                  */
*DCL TIDOCCRT BIT(8) CONSTANT('10'X);   /* THREAD ID FOR           0468
*                                          ISTOCCRT                  */
*DCL TIDOCCQU BIT(8) CONSTANT('20'X);   /* THREAD ID FOR           0469
*                                          ISTOCCQU                  */
*DCL TIDOCACX BIT(8) CONSTANT('30'X);   /* THREAD ID FOR           0470
*                                          ISTOCACX                  */
*         GEN (PRINT ON);                                          0471
         PRINT ON
*/* END OF TPEPILOG */                                             0472
*                                                                  0472
*/* ATDSPLY   INVOKED. */                                          0472
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTCSP                                               */
*/*             ISTPROCD                                             */
*/*             ISTDEVCH                                             */
*/*             ISTBIND                                              */
*/*             ISTCSL                                               */
*/*             ISTNIB                                               */
*/*             ISTOCW                                               */
*/*             ISTLOK                                               */
*/*             ISTDVT                                               */
*/*             ISTEPT                                               */
*/*             ISTPAB                                               */
*/*             ISTDYPAB                                             */
*/*             ISTRPH                                               */
*/*             ISTATCVT                                             */
*/*             ISTLCCW                                              */
*/*             ISTLCPB                                              */
*/*             ISTZSAVE                                             */
*/*             ISTPFCRR                                             */
*/*             ISTCFCRR                                             */
*/*             ISTZCRR                                              */
*/*             ISTASCRR                                             */
*/*             ISTAPCRR                                             */
*/*             ISTCRA                                               */
*/*             ISTCNSTA                                             */
*/*             ISTOCCRR                                             */
*/********************************************************************/
*/* END OF ATDSPLY. */                                             0472
*        END ISTOCCRL                                              0472
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IFGRPL  )                                        *
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                        *
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                        *
*;                                                                 0472
@EL00001 DS    0H                                                  0472
@EF00001 DS    0H                                                  0472
@ER00001 LM    @14,@12,12(@13)                                     0472
         BR    @14                                                 0472
@DATA    DS    0H
@CH00072 DC    H'2'
@CH00052 DC    H'4'
@CH00069 DC    H'24'
@DATD    DSECT
         DS    0F
ISTOCCRL CSECT
         DS    0F
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
LCPBPTR  DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTOCCRL CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CMZA0023 DS    FL4
         ORG   CMZA0023
@NM00060 DC    AL1(64)
@NM00061 DC    AL1(96)
@NM00062 DC    AL1(241)
@NM00063 DC    XL1'01'
         ORG   CMZA0023+4
CMZA0042 DS    FL4
         ORG   CMZA0042
@NM00064 DC    AL1(64)
@NM00065 DC    AL1(96)
@NM00066 DC    AL1(241)
@NM00067 DC    XL1'01'
         ORG   CMZA0042+4
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPHPTR   EQU   @01
R4       EQU   @04
R13      EQU   @13
A        EQU   @02
B        EQU   @05
ILOOPCTR EQU   @09
RCREG    EQU   @15
DDVT     EQU   @08
CR14PTR  EQU   @14
CMZK0006 EQU   @01
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR15P   EQU   @15
GPR01F   EQU   @01
GPR02F   EQU   @02
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
GPR15F   EQU   @15
ATCLCPTR EQU   1032
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLVTEXT EQU   IFGRPL+76
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLDSB2  EQU   RPLDSB+1
RPLUSNSI EQU   RPLFDBK2+2
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLOPT10 EQU   RPLOPTC3+1
RPLOPT11 EQU   RPLOPTC3+2
RPLOPT12 EQU   RPLOPTC3+3
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLRTYPE EQU   RPLSRTYP
RPLCHN   EQU   RPLOF16+2
RPLVTFL1 EQU   RPLOF16+3
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLRESP  EQU   RPLVTFL2
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLCNTDC EQU   RPLCNTRL+1
RPLCNTSC EQU   RPLCNTRL+2
RPLOF60  EQU   0
RPLOBSQ  EQU   RPLOF60+4
RPLIBSQ  EQU   RPLOF60+5
ISTCSP   EQU   0
CSPOPT   EQU   ISTCSP+2
CSPOPT1  EQU   CSPOPT
CSPOPT2  EQU   CSPOPT+1
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTBIND  EQU   0
BINFMTY  EQU   ISTBIND
BINPRIP  EQU   ISTBIND+3
BINSECP  EQU   ISTBIND+4
BINCMNP  EQU   ISTBIND+5
BINCMNP2 EQU   ISTBIND+6
ISTCSL   EQU   0
CSLRDEF  EQU   ISTCSL
CSLRDTE  EQU   CSLRDEF
CSLNDEF  EQU   ISTCSL+4
CSLNIB   EQU   CSLNDEF
CSLDDEF  EQU   ISTCSL+8
CSLDATA  EQU   CSLDDEF
ISTNIB   EQU   0
NIBFLGS  EQU   ISTNIB+40
NIBFLG1  EQU   NIBFLGS
ISTOCW   EQU   0
OCWSLEN  EQU   ISTOCW+1
OCWACVT  EQU   ISTOCW+24
OCWLRDTE EQU   ISTOCW+40
OCWDRDTE EQU   OCWLRDTE
OCWEPTAB EQU   ISTOCW+52
OCWODFST EQU   ISTOCW+88
OCWODRC  EQU   ISTOCW+92
OCWRC    EQU   OCWODRC
OCWEC    EQU   OCWODRC+1
OCWSVCOD EQU   ISTOCW+94
OCWSWTA  EQU   ISTOCW+204
OCWSWTB  EQU   ISTOCW+205
OCWSWTC  EQU   ISTOCW+206
OCWSWTD  EQU   ISTOCW+207
OCWR14SV EQU   ISTOCW+624
OCWSWTRD EQU   ISTOCW+730
OCWSWTE  EQU   ISTOCW+731
OCWLOCKS EQU   ISTOCW+740
OCWDLOCK EQU   OCWLOCKS
OCWCID   EQU   ISTOCW+744
OCWSHPL  EQU   ISTOCW+784
OCWBIND  EQU   ISTOCW+796
OCWFLG1  EQU   ISTOCW+847
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00038 EQU   LOKCHNG+2
ISTDVT   EQU   0
DVTHDR   EQU   ISTDVT
DVTHFORW EQU   DVTHDR
DVTHUCNT EQU   DVTHDR+6
DVTHFGA  EQU   DVTHDR+8
DVTHLEN  EQU   DVTHDR+10
ISTDVTE  EQU   0
DVTPROC  EQU   ISTDVTE
DVTFLAG1 EQU   DVTPROC
ISTEPT   EQU   0
EPTHDR   EQU   ISTEPT
EPTHFORM EQU   EPTHDR
EPTHFW1  EQU   EPTHFORM
EPTHECNT EQU   EPTHDR+4
EPTHUCNT EQU   EPTHDR+6
EPTHFGA  EQU   EPTHDR+8
EPTHLEN  EQU   EPTHDR+10
ISTEPTE  EQU   0
EPTDVT   EQU   ISTEPTE+8
EPTFLAG1 EQU   EPTDVT
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTDYPAB EQU   0
ISTRPH   EQU   0
RPHFLAGS EQU   ISTRPH+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   ISTRPH+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCFDVT  EQU   ATCCOM+116
ATCFEPT  EQU   ATCCOM+120
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP36  EQU   ISTATCVT+452
ATCDVTLK EQU   ISTATCVT+456
ATCVLCNT EQU   ISTATCVT+772
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRALKACT EQU   CRABASIC+8
CRAL8PTR EQU   CRABASIC+40
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
C14SVPTR EQU   0
C14SAVE  EQU   0
ISTCNSTA EQU   0
CNSTFLDA EQU   ISTCNSTA+16
CNSTFLDB EQU   ISTCNSTA+19
ISTOCCRR EQU   0
OCCAUDIT EQU   ISTOCCRR+22
OCCNTRD  EQU   OCCAUDIT
NOCCRL   EQU   OCCNTRD+2
OCCCRT   EQU   OCCAUDIT+3
COCCRL   EQU   OCCCRT+2
FMZL0008 EQU   0
FMZL0013 EQU   0
ISTRPL   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTEVERM EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
COCPOI   EQU   OCCCRT+2
COCACX   EQU   OCCCRT+2
COCCCN   EQU   OCCCRT+2
COCCCM   EQU   OCCCRT+2
COCCNV   EQU   OCCCRT+2
COCCCC   EQU   OCCCRT+2
COCCQU   EQU   OCCCRT+2
COCCRT   EQU   OCCCRT+1
COCCFB   EQU   OCCCRT+1
COCCOF   EQU   OCCCRT+1
COCCLD   EQU   OCCCRT+1
COCCOE   EQU   OCCCRT+1
COCCOD   EQU   OCCCRT+1
COCCSD   EQU   OCCCRT+1
COCCRD   EQU   OCCCRT+1
COCCFD   EQU   OCCCRT
COCCMD   EQU   OCCCRT
COCCFR   EQU   OCCCRT
COCCFO   EQU   OCCCRT
COCCSL   EQU   OCCCRT
COCCCH   EQU   OCCCRT
COCCCL   EQU   OCCCRT
COCCOC   EQU   OCCCRT
NOCPOI   EQU   OCCNTRD+2
NOCACX   EQU   OCCNTRD+2
NOCCCN   EQU   OCCNTRD+2
NOCCCM   EQU   OCCNTRD+2
NOCCNV   EQU   OCCNTRD+2
NOCCCC   EQU   OCCNTRD+2
NOCCQU   EQU   OCCNTRD+2
NOCCRT   EQU   OCCNTRD+1
NOCCFB   EQU   OCCNTRD+1
NOCCOF   EQU   OCCNTRD+1
NOCCLD   EQU   OCCNTRD+1
NOCCOE   EQU   OCCNTRD+1
NOCCOD   EQU   OCCNTRD+1
NOCCSD   EQU   OCCNTRD+1
NOCCRD   EQU   OCCNTRD+1
NOCCFD   EQU   OCCNTRD
NOCCMD   EQU   OCCNTRD
NOCCFR   EQU   OCCNTRD
NOCCFO   EQU   OCCNTRD
NOCCSL   EQU   OCCNTRD
NOCCCH   EQU   OCCNTRD
NOCCCL   EQU   OCCNTRD
NOCCOC   EQU   OCCNTRD
OCCCNS   EQU   ISTOCCRR
CNSRSV05 EQU   CNSTFLDB+2
CNSLOG0B EQU   CNSTFLDB+2
CNSACCTB EQU   CNSTFLDB+2
CNSFREEB EQU   CNSTFLDB+2
CNSGETSB EQU   CNSTFLDB+2
CNSSEARB EQU   CNSTFLDB+2
CNSQUEUB EQU   CNSTFLDB+2
CNSACONB EQU   CNSTFLDB+2
CNSTCONB EQU   CNSTFLDB+1
CNSCLAQB EQU   CNSTFLDB+1
CNSCLINB EQU   CNSTFLDB+1
CNSGBINB EQU   CNSTFLDB+1
CNSLGINB EQU   CNSTFLDB+1
CNSACINB EQU   CNSTFLDB+1
CNSPSINB EQU   CNSTFLDB+1
CNSRQRLB EQU   CNSTFLDB+1
CNSTRRLB EQU   CNSTFLDB
CNSDORLB EQU   CNSTFLDB
CNSRLINB EQU   CNSTFLDB
CNSQREQB EQU   CNSTFLDB
CNSXREQB EQU   CNSTFLDB
CNSAQINB EQU   CNSTFLDB
CNSAUTHB EQU   CNSTFLDB
CNSMRINB EQU   CNSTFLDB
CNSRSV01 EQU   CNSTFLDA+2
CNSLOG0A EQU   CNSTFLDA+2
CNSACCTA EQU   CNSTFLDA+2
CNSFREEA EQU   CNSTFLDA+2
CNSGETSA EQU   CNSTFLDA+2
CNSSEARA EQU   CNSTFLDA+2
CNSQUEUA EQU   CNSTFLDA+2
CNSACONA EQU   CNSTFLDA+2
CNSTCONA EQU   CNSTFLDA+1
CNSCLAQA EQU   CNSTFLDA+1
CNSCLINA EQU   CNSTFLDA+1
CNSGBINA EQU   CNSTFLDA+1
CNSLGINA EQU   CNSTFLDA+1
CNSACINA EQU   CNSTFLDA+1
CNSPSINA EQU   CNSTFLDA+1
CNSRQRLA EQU   CNSTFLDA+1
CNSTRRLA EQU   CNSTFLDA
CNSDORLA EQU   CNSTFLDA
CNSRLINA EQU   CNSTFLDA
CNSQREQA EQU   CNSTFLDA
CNSXREQA EQU   CNSTFLDA
CNSAQINA EQU   CNSTFLDA
CNSAUTHA EQU   CNSTFLDA
CNSMRINA EQU   CNSTFLDA
CNSTPFX  EQU   ISTCNSTA
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
@NM00059 EQU   ISTAPCRR+137
@NM00058 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00057 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00056 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00055 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00054 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00053 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00052 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00051 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00050 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00049 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00048 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPNXLCW EQU   ISTLCPB+20
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00047 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
ATCAOS   EQU   ISTATCVT+1552
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMBP EQU   ATCAOSM+440
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00046 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPT18 EQU   ATCAOSM+300
ATCRPT17 EQU   ATCAOSM+296
ATCRPT16 EQU   ATCAOSM+292
ATCRPT15 EQU   ATCAOSM+288
ATCRPT14 EQU   ATCAOSM+284
ATCRPT13 EQU   ATCAOSM+280
ATCRPT12 EQU   ATCAOSM+276
ATCRPT11 EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
ATCRSVBB EQU   ISTATCVT+908
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00045 EQU   ISTATCVT+818
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ISTATCVT+788
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCAP35  EQU   ISTATCVT+448
ATCRSV99 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00044 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00043 EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00042 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00041 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00040 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   ISTRPH+1
RPHTYPE  EQU   ISTRPH
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
EPTDVTA  EQU   EPTDVT+1
EPTRSV14 EQU   EPTFLAG1
EPTRSV13 EQU   EPTFLAG1
EPTRSV12 EQU   EPTFLAG1
EPTRSV11 EQU   EPTFLAG1
EPTRSV10 EQU   EPTFLAG1
EPTRSV09 EQU   EPTFLAG1
EPTRSV08 EQU   EPTFLAG1
EPTENDF  EQU   EPTFLAG1
EPTNAME  EQU   ISTEPTE
EPTENTRY EQU   ISTEPT+12
EPTHFGB  EQU   EPTHDR+9
EPTRSV07 EQU   EPTHFGA
EPTRSV06 EQU   EPTHFGA
EPTRSV05 EQU   EPTHFGA
EPTRSV04 EQU   EPTHFGA
EPTRSV03 EQU   EPTHFGA
EPTRSV02 EQU   EPTHFGA
EPTRSVO1 EQU   EPTHFGA
EPTHFGA1 EQU   EPTHFGA
EPTHFWDA EQU   EPTHFORM+1
EPTHFW1B EQU   EPTHFW1
EPTHFW1A EQU   EPTHFW1
DVTPROCA EQU   DVTPROC+1
DVTRSV14 EQU   DVTFLAG1
DVTRSV13 EQU   DVTFLAG1
DVTRSV12 EQU   DVTFLAG1
DVTRSV11 EQU   DVTFLAG1
DVTRSV10 EQU   DVTFLAG1
DVTRSV09 EQU   DVTFLAG1
DVTRSV08 EQU   DVTFLAG1
DVTEXITF EQU   DVTFLAG1
DVTENTRY EQU   ISTDVT+24
DVTRSV01 EQU   DVTHDR+20
DVTRSV15 EQU   DVTHDR+14
DVTHDCNT EQU   DVTHDR+12
DVTHFGB  EQU   DVTHDR+9
DVTRSV07 EQU   DVTHFGA
DVTRSV06 EQU   DVTHFGA
DVTRSV05 EQU   DVTHFGA
DVTRSV04 EQU   DVTHFGA
DVTRSV03 EQU   DVTHFGA
DVTRSV02 EQU   DVTHFGA
DVTHFGA1 EQU   DVTHFGA
DVTHFGA0 EQU   DVTHFGA
DVTHECNT EQU   DVTHDR+4
LOKXCL   EQU   @NM00038
LOKPRY   EQU   @NM00038
@NM00039 EQU   @NM00038
@NM00037 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
OCWEND   EQU   ISTOCW+848
@NM00036 EQU   OCWFLG1
OCWEXIT  EQU   OCWFLG1
OCWSENSE EQU   ISTOCW+843
OCWBNDSZ EQU   ISTOCW+841
OCWBINDD EQU   OCWBIND+37
OCWBINDA EQU   OCWBIND+1
OCWBINDC EQU   OCWBIND
OCWSHPLC EQU   OCWSHPL+8
OCWSHPLB EQU   OCWSHPL+4
OCWSHPLA EQU   OCWSHPL
OCWBNDRU EQU   ISTOCW+780
OCWELCP  EQU   ISTOCW+776
OCWRSV12 EQU   ISTOCW+772
OCWRSV11 EQU   ISTOCW+768
OCWRSV10 EQU   ISTOCW+764
OCWRSV09 EQU   ISTOCW+760
OCWPROCD EQU   ISTOCW+756
OCWRSV08 EQU   ISTOCW+752
OCWRSV07 EQU   ISTOCW+748
OCWDAF   EQU   OCWCID+2
OCWSAF   EQU   OCWCID
OCWNMLLN EQU   ISTOCW+742
OCWRSV0A EQU   ISTOCW+741
OCWRSV82 EQU   OCWLOCKS
OCWMLOCK EQU   OCWLOCKS
OCWALOCK EQU   OCWLOCKS
OCWCLOCK EQU   OCWLOCKS
OCWELOCK EQU   OCWLOCKS
OCWRLOCK EQU   OCWLOCKS
OCWVLOCK EQU   OCWLOCKS
OCWACE   EQU   ISTOCW+736
OCWIOMIN EQU   ISTOCW+735
OCWIOMAJ EQU   ISTOCW+734
OCWBHSID EQU   ISTOCW+733
OCWRSV03 EQU   ISTOCW+732
OCWSWTE7 EQU   OCWSWTE
OCWSWTE6 EQU   OCWSWTE
OCWSWTE5 EQU   OCWSWTE
OCWSWTE4 EQU   OCWSWTE
OCWSWTE3 EQU   OCWSWTE
OCWSWTE2 EQU   OCWSWTE
OCWLCPBC EQU   OCWSWTE
OCWSKEL  EQU   OCWSWTE
OCWSWTR7 EQU   OCWSWTRD
OCWSWTR6 EQU   OCWSWTRD
OCWSWTR5 EQU   OCWSWTRD
OCWDPDVT EQU   OCWSWTRD
OCWEPTLP EQU   OCWSWTRD
OCWCPARE EQU   OCWSWTRD
OCWCLEN  EQU   OCWSWTRD
OCWSRDVT EQU   OCWSWTRD
OCWCLCD2 EQU   ISTOCW+728
OCWCLCD1 EQU   ISTOCW+726
OCWLALEN EQU   ISTOCW+724
OCWSDVTA EQU   ISTOCW+720
OCWOENIB EQU   ISTOCW+716
OCWSORTP EQU   ISTOCW+712
OCWMDVT  EQU   ISTOCW+708
OCWSDVT  EQU   ISTOCW+704
OCWPREV  EQU   ISTOCW+700
OCWLCPBA EQU   ISTOCW+696
OCWSAVE5 EQU   ISTOCW+552
OCWSAVE4 EQU   ISTOCW+480
OCWSAVE3 EQU   ISTOCW+408
OCWSAVE2 EQU   ISTOCW+336
OCWSAVE1 EQU   ISTOCW+264
OCWCSPL  EQU   ISTOCW+224
OCWRSVD  EQU   ISTOCW+212
OCWVPAB  EQU   ISTOCW+208
OCWSWTD7 EQU   OCWSWTD
OCWSWTD6 EQU   OCWSWTD
OCWSWTD5 EQU   OCWSWTD
OCWSWTD4 EQU   OCWSWTD
OCWSWTD3 EQU   OCWSWTD
OCWSTCTL EQU   OCWSWTD
OCWNPOST EQU   OCWSWTD
OCWCLDEB EQU   OCWSWTD
OCWVARY  EQU   OCWSWTC
OCWPRMTR EQU   OCWSWTC
OCWPBH   EQU   OCWSWTC
OCWRBH   EQU   OCWSWTC
OCWCKACE EQU   OCWSWTC
OCWODCLS EQU   OCWSWTC
OCWSWTC1 EQU   OCWSWTC
OCWSPCLS EQU   OCWSWTC
OCWCSCAL EQU   OCWSWTB
OCWPSREQ EQU   OCWSWTB
OCWOLOCK EQU   OCWSWTB
OCWCOREQ EQU   OCWSWTB
OCWDOPHY EQU   OCWSWTB
OCWCLOOP EQU   OCWSWTB
OCWRECL  EQU   OCWSWTB
OCWGOFUN EQU   OCWSWTB
OCWNODLT EQU   OCWSWTA
OCWODCL  EQU   OCWSWTA
OCWGODST EQU   OCWSWTA
OCWSORT  EQU   OCWSWTA
OCWGOCNT EQU   OCWSWTA
OCWNOCON EQU   OCWSWTA
OCWSRT   EQU   OCWSWTA
OCWGTLST EQU   OCWSWTA
OCWSCPAD EQU   ISTOCW+176
OCWDNIB  EQU   ISTOCW+112
OCWBADNO EQU   ISTOCW+110
OCWDSTNO EQU   ISTOCW+108
OCWODCT2 EQU   ISTOCW+106
OCWODCT1 EQU   ISTOCW+104
OCWRSV02 EQU   ISTOCW+100
OCWRSV01 EQU   ISTOCW+96
OCWSVEC  EQU   OCWSVCOD+1
OCWSVRC  EQU   OCWSVCOD
OCWODNAS EQU   ISTOCW+84
OCWODLST EQU   ISTOCW+80
OCWLPOST EQU   ISTOCW+76
OCWCPOST EQU   ISTOCW+72
OCWFPOST EQU   ISTOCW+68
OCWACDEB EQU   ISTOCW+64
OCWNCB   EQU   ISTOCW+60
OCWFMCB  EQU   ISTOCW+56
OCWARDTE EQU   ISTOCW+48
OCWNIB   EQU   ISTOCW+44
OCWDRHOB EQU   OCWDRDTE
OCWCSL   EQU   ISTOCW+28
OCWPAB   EQU   ISTOCW+20
OCWRPH   EQU   ISTOCW+16
OCWRPL   EQU   ISTOCW+12
OCWCHAIN EQU   ISTOCW+8
OCWPBCHN EQU   ISTOCW+4
OCWTLEN  EQU   ISTOCW+2
OCWID    EQU   ISTOCW
NIBRESV  EQU   ISTNIB+60
NIBNDAR  EQU   ISTNIB+56
NIBLMODE EQU   ISTNIB+48
NIBEXLST EQU   ISTNIB+44
NIBLIMIT EQU   ISTNIB+42
@NM00035 EQU   ISTNIB+41
@NM00034 EQU   NIBFLG1
@NM00033 EQU   NIBFLG1
@NM00032 EQU   NIBFLG1
@NM00031 EQU   NIBFLG1
NIBSHLTP EQU   NIBFLG1
NIBSDAPP EQU   NIBFLG1
NIBCON   EQU   NIBFLG1
NIBLAST  EQU   NIBFLG1
NIBPROCD EQU   ISTNIB+36
NIBDEVCH EQU   ISTNIB+28
NIBMODE  EQU   ISTNIB+20
NIBSYM   EQU   ISTNIB+12
NIBUSER  EQU   ISTNIB+8
NIBCID   EQU   ISTNIB+4
NIBLEN   EQU   ISTNIB+3
NIBCONDN EQU   ISTNIB+2
NIBRSV01 EQU   ISTNIB+1
NIBID    EQU   ISTNIB
CSLDATAF EQU   CSLDATA
CSLNIBF  EQU   CSLNIB
CSLRDTEF EQU   CSLRDTE
BINUSE   EQU   ISTBIND+36
BINUSEL  EQU   ISTBIND+35
BINPRIM  EQU   ISTBIND+27
BINPRIML EQU   ISTBIND+26
BINPRSVC EQU   ISTBIND+7
BINCONR  EQU   BINCMNP2
BINRCHN  EQU   BINCMNP2
BINMDIBK EQU   BINCMNP2
BINBKFS  EQU   BINCMNP2
BINRCVR  EQU   BINCMNP2
BINFMTRM EQU   BINCMNP2
BINRSV04 EQU   BINCMNP
BINALT   EQU   BINCMNP
BINBKTR  EQU   BINCMNP
BINBRAK  EQU   BINCMNP
BINFMHD  EQU   BINCMNP
BINRSV03 EQU   BINCMNP
BINSSEB  EQU   BINSECP
BINSCMP  EQU   BINSECP
BINRSV02 EQU   BINSECP
BINSCHNR EQU   BINSECP
BINSMCH  EQU   BINSECP
BINSCHN  EQU   BINSECP
BINPSEB  EQU   BINPRIP
BINPCMP  EQU   BINPRIP
BINRSV01 EQU   BINPRIP
BINPCHNR EQU   BINPRIP
BINPMCH  EQU   BINPRIP
BINPCHN  EQU   BINPRIP
BINTS    EQU   ISTBIND+2
BINFM    EQU   ISTBIND+1
BINTYPE  EQU   BINFMTY
BINFMT   EQU   BINFMTY
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PRORSV11 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
CSPRSC2B EQU   ISTCSP+32
CSPTRDTE EQU   ISTCSP+28
CSPRLRPH EQU   ISTCSP+24
CSPNO    EQU   ISTCSP+22
CSPCC    EQU   ISTCSP+20
CSPDATA  EQU   ISTCSP+16
CSPRSCE  EQU   ISTCSP+12
CSPDEST  EQU   ISTCSP+8
CSPSRC   EQU   ISTCSP+4
@NM00030 EQU   CSPOPT2
CSPRSC2F EQU   CSPOPT2
CSPWASQD EQU   CSPOPT2
CSPACQS  EQU   CSPOPT2
CSPACES  EQU   CSPOPT2
CSPNOREL EQU   CSPOPT2
CSPCOREQ EQU   CSPOPT2
CSPSTAP  EQU   CSPOPT2
@NM00029 EQU   CSPOPT1
CSPANY   EQU   CSPOPT1
CSPACT   EQU   CSPOPT1
CSPSESS  EQU   CSPOPT1
CSPPND   EQU   CSPOPT1
CSPLOGI  EQU   CSPOPT1
CSPQ     EQU   CSPOPT1
CSPRSC   EQU   CSPOPT1
CSPIDX   EQU   ISTCSP
RPLSEQNO EQU   RPLOF60+6
@NM00028 EQU   RPLIBSQ
RPLIINV  EQU   RPLIBSQ
RPLINEG  EQU   RPLIBSQ
RPLIPOS  EQU   RPLIBSQ
RPLIIGN  EQU   RPLIBSQ
RPLIRSET EQU   RPLIBSQ
RPLITST  EQU   RPLIBSQ
RPLISET  EQU   RPLIBSQ
@NM00027 EQU   RPLOBSQ
RPLOINV  EQU   RPLOBSQ
RPLONEG  EQU   RPLOBSQ
RPLOPOS  EQU   RPLOBSQ
RPLOIGN  EQU   RPLOBSQ
RPLORSET EQU   RPLOBSQ
RPLOTST  EQU   RPLOBSQ
RPLOSET  EQU   RPLOBSQ
RPLIBSQV EQU   RPLOF60+2
RPLOBSQV EQU   RPLOF60
@NM00026 EQU   RPLCNTSC
RPLRSHUT EQU   RPLCNTSC
RPLRQR   EQU   RPLCNTSC
RPLSHUTC EQU   RPLCNTSC
RPLSHUTD EQU   RPLCNTSC
RPLSTSN  EQU   RPLCNTSC
RPLCLEAR EQU   RPLCNTSC
RPLSDT   EQU   RPLCNTSC
@NM00025 EQU   RPLCNTDC
RPLSIGNL EQU   RPLCNTDC
RPLLUS   EQU   RPLCNTDC
RPLRTR   EQU   RPLCNTDC
RPLBID   EQU   RPLCNTDC
@NM00024 EQU   RPLCNTDF
RPLQI    EQU   RPLCNTDF
RPLRELQ  EQU   RPLCNTDF
RPLCHASE EQU   RPLCNTDF
RPLQEC   EQU   RPLCNTDF
RPLQC    EQU   RPLCNTDF
RPLCNCEL EQU   RPLCNTDF
RPLDATA  EQU   RPLCNTDF
RPLRRN   EQU   RPLRESP
RPLNFME  EQU   RPLRESP
RPLEX    EQU   RPLRESP
@NM00023 EQU   RPLRESP
@NM00022 EQU   RPLPOSTV
RPLSCHED EQU   RPLPOSTV
@NM00021 EQU   RPLVTFL1
RPLAUTUS EQU   RPLVTFL1
RPLVTUSE EQU   RPLVTFL1
@NM00020 EQU   RPLVTFL1
@NM00019 EQU   RPLCHN
RPLONLY  EQU   RPLCHN
RPLLAST  EQU   RPLCHN
RPLMIDLE EQU   RPLCHN
RPLFIRST EQU   RPLCHN
@NM00018 EQU   RPLRTYPE
RPLDFASY EQU   RPLRTYPE
RPLNFSYN EQU   RPLRTYPE
RPLRRESP EQU   RPLRTYPE
@NM00017 EQU   RPLSTYPE
RPLSRESP EQU   RPLSTYPE
@NM00016 EQU   RPLRH3
RPLCSI   EQU   RPLRH3
RPLCHREQ EQU   RPLRH3
RPLCMD   EQU   RPLRH3
RPLEB    EQU   RPLRH3
RPLBB    EQU   RPLRH3
RPLSIGDA EQU   RPLVTEXT+32
RPLSAV13 EQU   RPLVTEXT+28
RPLUSNSO EQU   RPLOSENS+2
RPLSSMO  EQU   RPLSSNSO+1
@NM00015 EQU   RPLSSEO
RPLRRO   EQU   RPLSSEO
RPLFIO   EQU   RPLSSEO
RPLSTATO EQU   RPLSSEO
RPLCPMO  EQU   RPLSSEO
@NM00014 EQU   RPLSSEO
RPLFMHDR EQU   RPLOPT12
@NM00013 EQU   RPLOPT12
@NM00012 EQU   RPLOPT12
@NM00011 EQU   RPLOPT12
RPLNIBTK EQU   RPLOPT12
RPLTRUNC EQU   RPLOPT12
RPLKEEP  EQU   RPLOPT12
@NM00010 EQU   RPLOPT12
RPLRSVE8 EQU   RPLOPT11
RPLRSVE7 EQU   RPLOPT11
RPLRSVE6 EQU   RPLOPT11
RPLRSVE5 EQU   RPLOPT11
RPLRSVE4 EQU   RPLOPT11
RPLSTOP  EQU   RPLOPT11
RPLSTART EQU   RPLOPT11
RPLQUIES EQU   RPLOPT11
RPLRSVI6 EQU   RPLOPT10
RPLRSVI5 EQU   RPLOPT10
RPLRSVI4 EQU   RPLOPT10
RPLRSVI3 EQU   RPLOPT10
RPLRSVI2 EQU   RPLOPT10
RPLSPARM EQU   RPLOPT10
RPLDSPLY EQU   RPLOPT10
RPLBSCID EQU   RPLOPT10
RPLTOPL  EQU   RPLOPT9
RPLCIDE  EQU   RPLOPT9
RPLRNNM  EQU   RPLOPT9
RPLAPPST EQU   RPLOPT9
RPLCOUNT EQU   RPLOPT9
RPLTERMS EQU   RPLOPT9
RPLDEVCH EQU   RPLOPT9
RPLLOGON EQU   RPLOPT9
RPLUSFLD EQU   RPLVTEXT+16
RPLESR2  EQU   RPLUSNSI+1
RPLESR1  EQU   RPLUSNSI
RPLSSMI  EQU   RPLDSB2
@NM00009 EQU   RPLSSEI
RPLRRI   EQU   RPLSSEI
RPLFII   EQU   RPLSSEI
RPLSTATI EQU   RPLSSEI
RPLCPMI  EQU   RPLSSEI
RPLPATHI EQU   RPLSSEI
RPLARCLN EQU   RPLVTEXT+8
RPLAARLN EQU   RPLVTEXT+4
RPLAAREA EQU   RPLVTEXT
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00008 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00007 EQU   RPLRBAR+3
@NM00006 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00005 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00004 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00003 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLDACB  EQU   RPLCOMN+24
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   ISTOCCRL,(C'PLS0747',0603,75130)
