         TITLE 'ISTOCCSD - SKELETON DVT READER ROUTINE                 *
                        '
ISTOCCSD CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTOCCSD  75.130'                                 0001
         DROP  @15
@PROLOG  ST    @14,12(,@13)                                        0001
         STM   @01,@12,24(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*/********************************************************************/
*/*   ROUTINE NAME : SKELETAL DVT READER                             */
*/*                                                                  */
*/*   FUNCTION : TO OBTAIN THE ADDRESS OF THE SKELETAL DVT & MAKE A  */
*/*              COPY OF THE SKELETAL DVT (MASTER DVT) FOR USE BY    */
*/*              ISTOCCFD,ISTOCCMD,ISTOCCRD IN THE BUILDING OF       */
*/*              THE EPT AND DVTS FOR THE DESTINATION BEING OPENDSTED*/
*/*                                                                  */
*/*   INPUT : SEE PROLOGUE                                           */
*/*                                                                  */
*/*   OUTPUT : SEE PROLOGUE                                          */
*/*                                                                  */
*/*   ROUTINES CALLED : DONOSTR - TO HANDLE NON-ZERO RETURN CODE FROM*/
*/*                               GETSTOR MACRO                      */
*/*                     DONOFIND - TO HANDLE NON-ZERO RETURN CODE    */
*/*                                FROM CALL TO SRTFIND(ISTOCCDF)    */
*/*                     ISTOCCDF - TO OBTAIN THE ADDRESS OF THE      */
*/*                                SKELETAL DVT.                     */
*/*                                                                  */
*/*   MACROS USED : CRRMAINT - FOR A MODULE TRACE THRU VTAM          */
*/*                 GETSTOR - TO OBTAIN CORE IN WHICH TO MAKE A      */
*/*                            COPY OF THE SKELETAL DVT              */
*/********************************************************************/
*                                                                  0288
*                                                                  0288
*                                                                  0288
*          DO;                                                     0288
*/***  CRRMAINT  PROCNM(ISTOCCSD)COMP(OC)FUNC(SUB)  ***/           0289
*          DCL CMZK0005 PTR(31) REG(1);                            0289
*          RFY (CMZK0005) RSTD;                                    0290
*                                                                  0290
*/* ATBUILD (ISTRPH,ISTCRA,ISTPFCRR,ISTOCCRR)  */                  0291
*          RFY ISTCNSTA;                                           0291
*          RFY ISTOCCRR;                                           0292
*/* END OF ATBUILD */                                              0293
*          /*** SET ENTERED BIT FOR THIS PROCEDURE ***/            0293
*CMZK0005->RPHCRR->CRACRR->NOCCSD = '1'B;                          0293
         L     @05,RPHCRR(,CMZK0005)                               0293
         L     @05,CRACRR(,@05)                                    0293
         OI    NOCCSD(@05),B'01000000'                             0293
*          /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/           0294
*CMZK0005->RPHCRR->CRACRR->OCCCRT = '0'B;                          0294
         XC    OCCCRT+1(2,@05),OCCCRT+1(@05)                       0294
         MVI   OCCCRT(@05),B'00000000'                             0294
*CMZK0005->RPHCRR->CRACRR->COCCSD = '1'B;                          0295
         OI    COCCSD(@05),B'01000000'                             0295
*          END;                                                    0296
*          SVEAREA=SVEAREA+4*DIM(OCWSAVE1);/* BUMP SAVE AREA POINTER */
         AL    SVEAREA,@CF02387                                    0297
*          PARMPTR=PARMPTR|CMASK;   /* TURN ON HIGH ORDER BIT OF REG */
         L     @05,CMASK                                           0298
         OR    PARMPTR,@05                                         0298
*          WKREG=CZERO;             /* CLEAR REG 2 FOR ISTOCCDF      */
         SLR   WKREG,WKREG                                         0299
*          RPHPTR=RPHPTR|CMASK;     /*INDICATE MOD/DVT PROCESS NAME  */
         OR    RPHPTR,@05                                          0300
*          CALL SRTDF;              /* FIND REQUESTED SKELETON DVT   */
         L     @05,OCWACVT(,OCWPTR)                                0301
         L     @15,ATCSRTDF(,@05)                                  0301
         BALR  @14,@15                                             0301
*          RPHPTR=RPHPTR&HIGHOFF;   /* TURN OFF INDICATOR            */
         N     RPHPTR,HIGHOFF                                      0302
*          IF RCREG^=CZERO          /* FIND SUCCESSFUL?              */
*            THEN                   /* NO,                           */
         LTR   RCREG,RCREG                                         0303
         BZ    @RF00303                                            0303
*              CALL DONOFIND;       /* INDICATE ERROR EXITS          */
         BAL   @14,DONOFIND                                        0304
*            ELSE                   /* YES,                          */
*              DO;                  /* DO THE FOLLOWING:             */
         B     @RC00303                                            0305
@RF00303 DS    0H                                                  0306
*                SDVTPTR=PARMPTR;   /* SET BASE REG FOR SKELETON DVT */
         LR    SDVTPTR,PARMPTR                                     0306
*                CLNG1=SDVTOTAL*LENGTH(ISTSDVT);/* GET LENGTH OF DVT */
         LH    CLNG1,SDVTOTAL(,SDVTPTR)                            0307
         MH    CLNG1,@CH01401                                      0307
*                 /*GETSTOR ADSPACE(PRIVATE)SIZE((CLNG1))*/        0308
*                  DO;                                             0308
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0309
*/* END OF ATBUILD */                                              0309
*                 DCL GPR00F FIXED(31) REG(00);                    0309
*                 DCL GPR00P PTR(31)   REG(00);                    0310
*                 DCL GPR01F FIXED(31) REG(01);                    0311
*                 DCL GPR01P PTR(31)   REG(01);                    0312
*                 DCL GPR02F FIXED(31) REG(02);                    0313
*                 DCL GPR02P PTR(31)   REG(02);                    0314
*                 DCL GPR03F FIXED(31) REG(03);                    0315
*                 DCL GPR03P PTR(31)   REG(03);                    0316
*                 DCL GPR04F FIXED(31) REG(04);                    0317
*                 DCL GPR04P PTR(31)   REG(04);                    0318
*                 DCL GPR05F FIXED(31) REG(05);                    0319
*                 DCL GPR05P PTR(31)   REG(05);                    0320
*                 DCL GPR06F FIXED(31) REG(06);                    0321
*                 DCL GPR06P PTR(31)   REG(06);                    0322
*                 DCL GPR07F FIXED(31) REG(07);                    0323
*                 DCL GPR07P PTR(31)   REG(07);                    0324
*                 DCL GPR08F FIXED(31) REG(08);                    0325
*                 DCL GPR08P PTR(31)   REG(08);                    0326
*                 DCL GPR09F FIXED(31) REG(09);                    0327
*                 DCL GPR09P PTR(31)   REG(09);                    0328
*                 DCL GPR10F FIXED(31) REG(10);                    0329
*                 DCL GPR10P PTR(31)   REG(10);                    0330
*                 DCL GPR11F FIXED(31) REG(11);                    0331
*                 DCL GPR11P PTR(31)   REG(11);                    0332
*                 DCL GPR12F FIXED(31) REG(12);                    0333
*                 DCL GPR12P PTR(31)   REG(12);                    0334
*                 DCL GPR13F FIXED(31) REG(13);                    0335
*                 DCL GPR13P PTR(31)   REG(13);                    0336
*                 DCL GPR14F FIXED(31) REG(14);                    0337
*                 DCL GPR14P PTR(31)   REG(14);                    0338
*                 DCL GPR15F FIXED(31) REG(15);                    0339
*                 DCL GPR15P PTR(31)   REG(15);                    0340
*                 RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;          0341
*                 RFY ISTRPH BASED(GPR01P);                        0342
*                 GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,            0343
*                          GPR06P,GPR07P,GPR08P,GPR09P,            0343
*                          GPR10P,GPR11P,GPR12P,GPR13P)            0343
*                     SETS(RPHWORK);                               0343
*                                                                  0343
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*                 GPR00F = (CLNG1);                    /*SIZE IN REG0*/
         LR    GPR00F,CLNG1                                        0344
*                 DCL 1 CMZA0007 FIXED(31) STATIC LOCAL,           0345
*                       2 * FIXED(8) INIT(64),       /* OPTION FLAGS */
*                       2 * FIXED(8) INIT(96),        /* STORAGE KEY */
*                       2 * FIXED(8) INIT(229),    /* SUBPOOL NUMBER */
*                       2 * FIXED(8) INIT('00'X);    /* REQUEST TYPE */
*                 GPR03F = CMZA0007;                               0346
*                                                                  0346
         L     GPR03F,CMZA0007                                     0346
*                 DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */    0347
*                   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/    0348
         L     GPR02P,ATCLCPTR                                     0348
*                 END; /*LISATCVT*/                                0349
*                 CALL GPR02P -> ATCGTSTR;            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0350
         BALR  @14,@15                                             0350
*                 RFY (GPR00P,GPR01P,GPR02P,GPR03P) UNRSTD;        0351
*                 END ;                              /*END OF GETSTOR*/
*                             /* GET STORAGE FOR SDVT COPY   @D31KKJY*/
*                IF RCREG^=CZERO    /* STORAGE GOTTEN?               */
*                  THEN             /* NO,                           */
         LTR   RCREG,RCREG                                         0353
         BZ    @RF00353                                            0353
*                    CALL DONOSTR;  /* INDICATE ERROR EXISTS         */
         BAL   @14,DONOSTR                                         0354
*                  ELSE             /* YES,                          */
*                    DO;            /* DO THE FOLLOWING:             */
         B     @RC00353                                            0355
@RF00353 DS    0H                                                  0356
*                      STRPTR=RPHSRPRM;/* SET BASE REG FOR MOVE      */
         L     STRPTR,RPHSRPRM(,GPR01P)                            0356
*                      PARMPTR=STRPTR;/* SET RETURN REG WITH POINTER */
         LR    PARMPTR,STRPTR                                      0357
*                      CLNG2=CLNG1; /* SET UP LENGTH FOR MVCL INSTR  */
         LR    CLNG2,CLNG1                                         0358
*                      GEN REFS(STRPTR,SDVTPTR)                    0359
*                              (MVCL  STRPTR,SDVTPTR);             0359
         MVCL  STRPTR,SDVTPTR
*                                   /* SET UP USER COPY SKELETON DVT */
*                      RCREG=CZERO; /* INDICATE SUCCESSFUL COMPLETION*/
         SLR   RCREG,RCREG                                         0360
*                    END;                                          0361
*              END;                                                0362
@RC00353 DS    0H                                                  0363
*          SVEAREA=SVEAREA-4*DIM(OCWSAVE1);/* RETURN SAVE AREA PTR   */
@RC00303 SL    SVEAREA,@CF02387                                    0363
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME : DONOSTR -NO STORAGE ERROR HANDLER               */
*/*                                                                  */
*/*   FUNCTION : TO ANALIZE THE ERROR RETURN CODE FROM THE           */
*/*              GETSTOR MACRO AND TO PLACE AN EXPLANATORY RETURN    */
*/*              CODE IN THE ISTOCW SO IT CAN BE PASSED TO THE USER  */
*/*                                                                  */
*/*   INPUT : R15 - ERROR CODE FROM GETSTOR                          */
*/*                                                                  */
*/*   OUTPUT : OCWEC AND OCWRC CONTAIN A DETAILED ERROR CODE         */
*/*                                                                  */
*/*   ROUTINES CALLED : NONE                                         */
*/*                                                                  */
*/*   MACROS USED : NONE                                             */
*/*                                                                  */
*/********************************************************************/
*DONOSTR: PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0364
         B     @PB00002                                            0364
DONOSTR  DS    0H                                                  0365
*/* CALLED TO HANDLE ERROR RETURN CODES FROM GETSTOR                 */
*    C14SAVE=CR14PTR;       /*SAVE R14 FOR RETURN*/                0365
         LA    @05,624                                             0365
         ALR   @05,OCWPTR                                          0365
         L     @03,C14SVPTR(,@05)                                  0365
         ST    CR14PTR,C14SAVE(,@03)                               0365
*    C14SVPTR=C14SVPTR+4;                                          0366
         LA    @11,4                                               0366
         ALR   @03,@11                                             0366
         ST    @03,C14SVPTR(,@05)                                  0366
*    IF RCREG=4                                                    0367
*        THEN DO;                                                  0367
         CR    RCREG,@11                                           0367
         BNE   @RF00367                                            0367
*            OCWRC='14'X;                                          0369
         MVI   OCWRC(OCWPTR),X'14'                                 0369
*            OCWEC='01'X;                                          0370
         MVI   OCWEC(OCWPTR),X'01'                                 0370
*            END;                                                  0371
*        ELSE DO;                                                  0372
         B     @RC00367                                            0372
@RF00367 DS    0H                                                  0373
*            OCWRC='24'X;                                          0373
         MVI   OCWRC(OCWPTR),X'24'                                 0373
*            OCWEC='01'X;                                          0374
         MVI   OCWEC(OCWPTR),X'01'                                 0374
*            END;                                                  0375
*    C14SVPTR=C14SVPTR-4;                                          0376
@RC00367 LA    @05,624                                             0376
         ALR   @05,OCWPTR                                          0376
         L     @03,C14SVPTR(,@05)                                  0376
         SL    @03,@CF00038                                        0376
         ST    @03,C14SVPTR(,@05)                                  0376
*    CR14PTR=C14SAVE;                                              0377
         L     CR14PTR,C14SAVE(,@03)                               0377
*END DONOSTR;                                                      0378
@EL00002 DS    0H                                                  0378
@EF00002 DS    0H                                                  0378
@ER00002 BR    @14                                                 0378
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME : DONOFIND -                                      */
*/*                  ERROR CODE HANDLER FOR SRTFIND (ISTOCCDF)       */
*/*                                                                  */
*/*   FUNCTION : TO ANALIZE ERROR RETURN CODES FROM ISTOCCDF AND     */
*/*              PLACE AN EXPLANATORY RETURN CODE INTO THE           */
*/*               ISTOCW TO BE RETURNED TO THE USER                  */
*/*                                                                  */
*/*   INPUT : R15 - ERROR CODE FROM ISTOCCDF                         */
*/*                                                                  */
*/*   OUTPUT : OCWEC AND OCWRC CONTAIN A DETAILED ERROR CODE         */
*/*             DESCRIBING THE SRTFIND (ISTOCCDF) FAILURE            */
*/*                                                                  */
*/*   ROUTINES CALLED : NONE                                         */
*/*                                                                  */
*/*   MACROS USED : NONE                                             */
*/*                                                                  */
*/********************************************************************/
*DONOFIND: PROC OPTIONS(NOSAVE,NOSAVEAREA);                        0379
DONOFIND DS    0H                                                  0380
*/* CALLED TO HANDLE BAD RETURN CODES FROM ISTOCCDF               */
*     C14SAVE=CR14PTR;                                             0380
         LA    @05,624                                             0380
         ALR   @05,OCWPTR                                          0380
         L     @03,C14SVPTR(,@05)                                  0380
         ST    CR14PTR,C14SAVE(,@03)                               0380
*     C14SVPTR=C14SVPTR+4;                                         0381
         AL    @03,@CF00038                                        0381
         ST    @03,C14SVPTR(,@05)                                  0381
*     IF RCREG=8                                                   0382
*         THEN DO;                                                 0382
         C     RCREG,@CF00040                                      0382
         BNE   @RF00382                                            0382
*             OCWRC='24'X;               /*SYSTEM ERROR            */
         MVI   OCWRC(OCWPTR),X'24'                                 0384
*             OCWEC='02'X;              /*SRT DIR NOT FOUND       */
         MVI   OCWEC(OCWPTR),X'02'                                 0385
*             END;                                                 0386
*         ELSE                                                     0387
*             IF RCREG=4                                           0387
*                 THEN DO;                                         0387
         B     @RC00382                                            0387
@RF00382 C     RCREG,@CF00038                                      0387
         BNE   @RF00387                                            0387
*                     OCWRC='08'X;      /*LOGIC ERROR             */
         MVI   OCWRC(OCWPTR),X'08'                                 0389
*                     OCWEC='4F'X;      /*NAME NOT IN DIRECTORY   */
         MVI   OCWEC(OCWPTR),X'4F'                                 0390
*                     END;                                         0391
*                 ELSE DO;                                         0392
         B     @RC00387                                            0392
@RF00387 DS    0H                                                  0393
*                     OCWRC='24'X;       /*SYSTEM ERROR            */
         MVI   OCWRC(OCWPTR),X'24'                                 0393
*                     OCWEC='01'X;      /*UNEXPECTED RETURN CODE  */
         MVI   OCWEC(OCWPTR),X'01'                                 0394
*                     END;                                         0395
*                                                                  0395
*    C14SVPTR=C14SVPTR-4;                                          0396
@RC00387 DS    0H                                                  0396
@RC00382 LA    @05,624                                             0396
         ALR   @05,OCWPTR                                          0396
         L     @03,C14SVPTR(,@05)                                  0396
         SL    @03,@CF00038                                        0396
         ST    @03,C14SVPTR(,@05)                                  0396
*    CR14PTR=C14SAVE;                                              0397
         L     CR14PTR,C14SAVE(,@03)                               0397
*END DONOFIND;                                                     0398
*                                                                  0398
@EL00003 DS    0H                                                  0398
@EF00003 DS    0H                                                  0398
@ER00003 BR    @14                                                 0398
@PB00003 DS    0H                                                  0399
*/* TPEPILOG   */                                                  0399
* GEN (PRINT OFF);                                                 0399
*                                                                  0399
         PRINT OFF
* /*  CONNECTION SERVICES COMPONENT RECOVERY RECORD                  */
* /* COMPLETED DCR SOLUTIONS                                         */
* /* 1H0540 APRIL 28, 1973 MB                                        */
*/* ZTR4417 JUNE 20, 73 DNM */                                     0400
* DCL 1 ISTCNSTA BDY(WORD) BASED,       /* CONNECTION SERVICES     0400
*                                          COMPONENT RECOVERY RECORD */
*     2  CNSTPFX CHAR(LENGTH(ISTPFCRR)), /* STANDARD PREFIX        0400
*                                          FOR CRR                   */
*     2  CNSTFLDA CHAR(3),              /* TRACE FIELD A - HISTORY   */
*        3  CNSMRINA BIT(1),            /* MASTER ENTERED            */
*        3  CNSAUTHA BIT(1),            /* ABOUT TO CALL AUTHORI-  0400
*                                          SATION EXIT       ZTR4417 */
*        3  CNSAQINA BIT(1),            /* ACQUIRE ENTERED           */
*        3  CNSXREQA BIT(1),            /* ACQUIRE SATISFIED         */
*        3  CNSQREQA BIT(1),            /* ACQUIRE QUEUED            */
*        3  CNSRLINA BIT(1),            /* RELEASE ENTERED           */
*        3  CNSDORLA BIT(1),            /* DOREL REALLOCATION      0400
*                                          ENTERED                   */
*        3  CNSTRRLA BIT(1),            /* RELEASE OF ACTIVE       0400
*                                          CONNECTION                */
*        3  CNSRQRLA BIT(1),            /* RELEASE QUEUED REQUEST    */
*        3  CNSPSINA BIT(1),            /* PASS ENTERED              */
*        3  CNSACINA BIT(1),            /* ACCEPT ENTERED            */
*        3  CNSLGINA BIT(1),            /* LOGON ENTERED             */
*        3  CNSGBINA BIT(1),            /* PREEMPT ENTERED           */
*        3  CNSCLINA BIT(1),            /* CANCEL ENTERED            */
*        3  CNSCLAQA BIT(1),            /* CANCEL ACQUIRES           */
*        3  CNSTCONA BIT(1),            /* TCONNECT                  */
*        3  CNSACONA BIT(1),            /* ACONNECT                  */
*        3  CNSQUEUA BIT(1),            /* QUEUE                     */
*        3  CNSSEARA BIT(1),            /* SEARCH Q                  */
*        3  CNSGETSA BIT(1),            /* CONNECTION SERVICES     0400
*                                          GETSTORE                  */
*        3  CNSFREEA BIT(1),            /* CONNECTION SERVICES     0400
*                                          FREESTORE                 */
*        3  CNSACCTA BIT(1),            /* ABOUT TO CALL           0400
*                                          ACCOUNTING EXIT           */
*        3  CNSLOG0A BIT(1),            /* LOGON 0                   */
*        3  CNSRSV01 BIT(1),            /* RESERVED                  */
*     2  CNSTFLDB CHAR(3),              /* TRACE FIELD B -         0400
*                                          CURRENT ACTIVITY          */
*        3  CNSMRINB BIT(1),                                       0400
*        3  CNSAUTHB BIT(1),                                       0400
*        3  CNSAQINB BIT(1),                                       0400
*        3  CNSXREQB BIT(1),                                       0400
*        3  CNSQREQB BIT(1),                                       0400
*        3  CNSRLINB BIT(1),                                       0400
*        3  CNSDORLB BIT(1),                                       0400
*        3  CNSTRRLB BIT(1),                                       0400
*        3  CNSRQRLB BIT(1),                                       0400
*        3  CNSPSINB BIT(1),                                       0400
*        3  CNSACINB BIT(1),                                       0400
*        3  CNSLGINB BIT(1),                                       0400
*        3  CNSGBINB BIT(1),                                       0400
*        3  CNSCLINB BIT(1),                                       0400
*        3  CNSCLAQB BIT(1),                                       0400
*        3  CNSTCONB BIT(1),                                       0400
*        3  CNSACONB BIT(1),                                       0400
*        3  CNSQUEUB BIT(1),                                       0400
*        3  CNSSEARB BIT(1),                                       0400
*        3  CNSGETSB BIT(1),                                       0400
*        3  CNSFREEB BIT(1),                                       0400
*        3  CNSACCTB BIT(1),                                       0400
*        3  CNSLOG0B BIT(1),                                       0400
*        3  CNSRSV05 BIT(1);                                       0400
* /*     CRR FOR OPEN/CLOSE                                          */
*/*  REVISIONS                                         002 03/27/75  */
* DCL 1 ISTOCCRR BDY(WORD) BASED,       /* CRR FOR OPEN/CLOSE        */
*     2  OCCCNS   CHAR(LENGTH(ISTCNSTA)), /* RESERVE SPACE FOR     0401
*                                          CONN. SVC'S AUDIT         */
*     2  OCCAUDIT,                      /* AUDIT TRAIL FOR OPEN/CLOSE*/
*        3  OCCNTRD CHAR(3),            /* LIST OF MODULES IN OPEN/
*                                          CLOSE ENTERED             */
*           4  NOCCOC BIT(1),           /* INDICATES MODULE ISTOCCOC
*                                          ENTERED                   */
*           4  NOCCCL BIT(1),           /* INDICATES MODULE ISTOCCCL
*                                          ENTERED                   */
*           4  NOCCCH BIT(1),           /* INDICATES MODULE ISTOCCCH
*                                          ENTERED                   */
*           4  NOCCSL BIT(1),           /* INDICATES MODULE ISTOCCSL
*                                          ENTERED                   */
*           4  NOCCFO BIT(1),           /* INDICATES MODULE ISTOCCFO
*                                          ENTERED                   */
*           4  NOCCFR BIT(1),           /* INDICATES MODULE ISTOCCFR
*                                          ENTERED                   */
*           4  NOCCMD BIT(1),           /* INDICATES MODULE ISTOCCMD
*                                          ENTERED                   */
*           4  NOCCFD BIT(1),           /* INDICATES MODULE ISTOCCFD
*                                          ENTERED                   */
*           4  NOCCRD BIT(1),           /* INDICATES MODULE ISTOCCRD
*                                          ENTERED                   */
*           4  NOCCSD BIT(1),           /* INDICATES MODULE ISTOCCSD
*                                          ENTERED                   */
*           4  NOCCOD BIT(1),           /* INDICATES MODULE ISTOCCOD
*                                          ENTERED                   */
*           4  NOCCOE BIT(1),           /* INDICATES MODULE ISTOCCOE
*                                          ENTERED                   */
*           4  NOCCLD BIT(1),           /* INDICATES MODULE ISTOCCLD
*                                          ENTERED                   */
*           4  NOCCOF BIT(1),           /* INDICATES MODULE ISTOCCOF
*                                          ENTERED                   */
*           4  NOCCFB BIT(1),           /* INDICATES MODULE ISTOCCFB
*                                          ENTERED                   */
*           4  NOCCRT BIT(1),           /* INDICATES MODULE ISTOCCRT
*                                          ENTERED                   */
*           4  NOCCQU BIT(1),           /* INDICATES MODULE ISTOCCQU
*                                          ENTERED                   */
*           4  NOCCRL BIT(1),           /* INDICATES MODULE ISTOCCRL
*                                          ENTERED                   */
*           4  NOCCCC   BIT(1),         /* INDICATES MODULE ISTOCCCC
*                                          ENTERED                   */
*           4  NOCCNV BIT(1),           /* INDICATES MODULE ISTOCCNV
*                                          ENTERED                   */
*           4  NOCCCM BIT(1),           /* ISTOCCCM ENTERED          */
*           4  NOCCCN BIT(1),           /* ISTOCCCN ENTERED          */
*           4  NOCACX   BIT(1),                                    0401
*           4  NOCPOI BIT(1),           /* ISTCFCPO ENTERED OR       */
*                                       /* ISTCFCPC ENTERED          */
*        3  OCCCRT CHAR(3),             /* LIST OF OPEN/CLOSE      0401
*                                          MODULES RUNNING           */
*           4  COCCOC BIT(1),           /* INDICATES MODULE ISTOCCOC
*                                          RUNNING                   */
*           4  COCCCL BIT(1),           /* INDICATES MODULE ISTOCCCL
*                                          RUNNING                   */
*           4  COCCCH BIT(1),           /* INDICATES MODULE ISTOCCCH
*                                          RUNNING                   */
*           4  COCCSL BIT(1),           /* INDICATES MODULE ISTOCCSL
*                                          RUNNING                   */
*           4  COCCFO BIT(1),           /* INDICATES MODULE ISTOCCFO
*                                          RUNNING                   */
*           4  COCCFR BIT(1),           /* INDICATES MODULE ISTOCCFR
*                                          RUNNING                   */
*           4  COCCMD BIT(1),           /* INDICATES MODULE ISTOCCMD
*                                          RUNNING                   */
*           4  COCCFD BIT(1),           /* INDICATES  MODULE ISTOCCFD
*                                          RUNNING                   */
*           4  COCCRD BIT(1),           /* INDICATES MODULE ISTOCCRD
*                                          RUNNING                   */
*           4  COCCSD BIT(1),           /* INDICATES MODULE ISTOCCSD
*                                          RUNNING                   */
*           4  COCCOD BIT(1),           /* INDICATES MODULE ISTOCCOD
*                                          RUNNING                   */
*           4  COCCOE BIT(1),           /* INDICATES MODULE ISTOCCOE
*                                          RUNNING                   */
*           4  COCCLD BIT(1),           /* INDICATES MODULE ISTOCCLD
*                                          RUNNING                   */
*           4  COCCOF BIT(1),           /* INDICATES MODULE ISTOCCOF
*                                          RUNNING                   */
*           4  COCCFB BIT(1),           /* INDICATES MODULE ISTOCCFB
*                                          RUNNING                   */
*           4  COCCRT BIT(1),           /* INDICATES MODULE ISTOCCRT
*                                          RUNNING                   */
*           4  COCCQU BIT(1),           /* INDICATES MODULE ISTOCCQU
*                                          RUNNING                   */
*           4  COCCRL BIT(1),           /* INDICATES MODULE ISTOCCRL
*                                          RUNNING                   */
*           4  COCCCC   BIT(1),         /* INDICATES MOD ISTOCCCC  0401
*                                          RUNNING                   */
*           4  COCCNV BIT(1),           /* INDICATES MODULE ISTOCCNV
*                                          RUNNING                   */
*           4  COCCCM BIT(1),           /* ISTOCCCM RUNNING          */
*           4  COCCCN BIT(1),           /* ISTOCCCN RUNNING          */
*           4  COCACX   BIT(1),                                    0401
*           4  COCPOI BIT(1);           /* ISTCFCPO RUNNING OR       */
*                                       /* ISTCFCPC RUNNING          */
*DCL TIDOCCCC BIT(8) CONSTANT('00'X);   /* THREAD ID FOR           0402
*                                          ISTOCCCC                  */
*DCL TIDOCCCH BIT(8) CONSTANT('01'X);   /* THREAD ID FOR           0403
*                                          ISTOCCCH                  */
*DCL TIDOCCOD BIT(8) CONSTANT('02'X);   /* THREAD ID FOR           0404
*                                          ISTOCCOD                  */
*DCL TIDOCCCL BIT(8) CONSTANT('04'X);   /* THREAD ID FOR           0405
*                                          ISTOCCCL                  */
*DCL TIDOCCOC BIT(8) CONSTANT('08'X);   /* THREAD ID FOR           0406
*                                          ISTOCCOC                  */
*DCL TIDOCCRT BIT(8) CONSTANT('10'X);   /* THREAD ID FOR           0407
*                                          ISTOCCRT                  */
*DCL TIDOCCQU BIT(8) CONSTANT('20'X);   /* THREAD ID FOR           0408
*                                          ISTOCCQU                  */
*DCL TIDOCACX BIT(8) CONSTANT('30'X);   /* THREAD ID FOR           0409
*                                          ISTOCACX                  */
* GEN (PRINT ON);                                                  0410
         PRINT ON
*/* END OF TPEPILOG */                                             0411
*/* ATDSPLY   INVOKED. */                                          0411
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTCSP                                               */
*/*             ISTPROCD                                             */
*/*             ISTDEVCH                                             */
*/*             ISTBIND                                              */
*/*             ISTCSL                                               */
*/*             ISTNIB                                               */
*/*             ISTOCW                                               */
*/*             ISTRPH                                               */
*/*             ISTSDVT                                              */
*/*             ISTLCCW                                              */
*/*             ISTLCPB                                              */
*/*             ISTZSAVE                                             */
*/*             ISTPFCRR                                             */
*/*             ISTCFCRR                                             */
*/*             ISTZCRR                                              */
*/*             ISTASCRR                                             */
*/*             ISTAPCRR                                             */
*/*             ISTCRA                                               */
*/*             ISTPAB                                               */
*/*             ISTLOK                                               */
*/*             ISTDYPAB                                             */
*/*             ISTATCVT                                             */
*/*             ISTCNSTA                                             */
*/*             ISTOCCRR                                             */
*/********************************************************************/
*/* END OF ATDSPLY. */                                             0411
*END ISTOCCSD                       /* EXIT TO CALLER                */
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IFGRPL  )                                        *
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                        *
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*;                                                                 0411
@EL00001 DS    0H                                                  0411
@EF00001 DS    0H                                                  0411
@ER00001 L     @14,12(,@13)                                        0411
         LM    @01,@12,24(@13)                                     0411
         BR    @14                                                 0411
@DATA    DS    0H
@CH01401 DC    H'28'
@DATD    DSECT
         DS    0F
ISTOCCSD CSECT
         DS    0F
@CF00038 DC    F'4'
@CF00040 DC    F'8'
@CF02387 DC    F'72'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
LCPBPTR  DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTOCCSD CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CMASK    DC    XL4'80000000'
HIGHOFF  DC    XL4'7FFFFFFF'
CMZA0007 DS    FL4
         ORG   CMZA0007
@NM00060 DC    AL1(64)
@NM00061 DC    AL1(96)
@NM00062 DC    AL1(229)
@NM00063 DC    XL1'00'
         ORG   CMZA0007+4
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPHPTR   EQU   @01
PARMPTR  EQU   @00
WKREG    EQU   @02
OCWPTR   EQU   @04
SDVTPTR  EQU   @06
CLNG1    EQU   @07
STRPTR   EQU   @08
CLNG2    EQU   @09
SVEAREA  EQU   @13
RCREG    EQU   @15
CR14PTR  EQU   @14
CMZK0005 EQU   @01
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR01F   EQU   @01
GPR02F   EQU   @02
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
ATCLCPTR EQU   1032
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLVTEXT EQU   IFGRPL+76
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLDSB2  EQU   RPLDSB+1
RPLUSNSI EQU   RPLFDBK2+2
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLOPT10 EQU   RPLOPTC3+1
RPLOPT11 EQU   RPLOPTC3+2
RPLOPT12 EQU   RPLOPTC3+3
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLRTYPE EQU   RPLSRTYP
RPLCHN   EQU   RPLOF16+2
RPLVTFL1 EQU   RPLOF16+3
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLRESP  EQU   RPLVTFL2
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLCNTDC EQU   RPLCNTRL+1
RPLCNTSC EQU   RPLCNTRL+2
RPLOF60  EQU   0
RPLOBSQ  EQU   RPLOF60+4
RPLIBSQ  EQU   RPLOF60+5
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ISTCSP   EQU   0
CSPOPT   EQU   ISTCSP+2
CSPOPT1  EQU   CSPOPT
CSPOPT2  EQU   CSPOPT+1
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTBIND  EQU   0
BINFMTY  EQU   ISTBIND
BINPRIP  EQU   ISTBIND+3
BINSECP  EQU   ISTBIND+4
BINCMNP  EQU   ISTBIND+5
BINCMNP2 EQU   ISTBIND+6
ISTCSL   EQU   0
CSLRDEF  EQU   ISTCSL
CSLRDTE  EQU   CSLRDEF
CSLNDEF  EQU   ISTCSL+4
CSLNIB   EQU   CSLNDEF
CSLDDEF  EQU   ISTCSL+8
CSLDATA  EQU   CSLDDEF
ISTNIB   EQU   0
NIBFLGS  EQU   ISTNIB+40
NIBFLG1  EQU   NIBFLGS
ISTOCW   EQU   0
OCWACVT  EQU   ISTOCW+24
OCWLRDTE EQU   ISTOCW+40
OCWDRDTE EQU   OCWLRDTE
OCWODRC  EQU   ISTOCW+92
OCWRC    EQU   OCWODRC
OCWEC    EQU   OCWODRC+1
OCWSVCOD EQU   ISTOCW+94
OCWSWTA  EQU   ISTOCW+204
OCWSWTB  EQU   ISTOCW+205
OCWSWTC  EQU   ISTOCW+206
OCWSWTD  EQU   ISTOCW+207
OCWSAVE1 EQU   ISTOCW+264
OCWR14SV EQU   ISTOCW+624
OCWSWTRD EQU   ISTOCW+730
OCWSWTE  EQU   ISTOCW+731
OCWLOCKS EQU   ISTOCW+740
OCWCID   EQU   ISTOCW+744
OCWSHPL  EQU   ISTOCW+784
OCWBIND  EQU   ISTOCW+796
OCWFLG1  EQU   ISTOCW+847
ISTRPH   EQU   0
RPHFLAGS EQU   ISTRPH+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   ISTRPH+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTSDVT  EQU   0
SDVNAME  EQU   ISTSDVT
SDVOPTNS EQU   ISTSDVT+8
SDVTOTAL EQU   SDVOPTNS
SDVID    EQU   ISTSDVT+12
SDVFLAGS EQU   SDVID
SDVPARM  EQU   SDVID+1
SDVQUALC EQU   ISTSDVT+16
SDVCUATT EQU   SDVQUALC+6
SDVLINET EQU   SDVQUALC+7
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRALKACT EQU   CRABASIC+8
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00054 EQU   LOKCHNG+2
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCSRTDF EQU   ATCCOM+208
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCVLCNT EQU   ISTATCVT+772
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
C14SAVE  EQU   0
C14SVPTR EQU   0
SRTDF    EQU   0
ISTCNSTA EQU   0
CNSTFLDA EQU   ISTCNSTA+16
CNSTFLDB EQU   ISTCNSTA+19
ISTOCCRR EQU   0
OCCAUDIT EQU   ISTOCCRR+22
OCCNTRD  EQU   OCCAUDIT
NOCCSD   EQU   OCCNTRD+1
OCCCRT   EQU   OCCAUDIT+3
COCCSD   EQU   OCCCRT+1
ISTRPL   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
SDVCPATT EQU   SDVOPTNS
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
SDVCONDD EQU   SDVCPATT
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTEVERM EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
COCPOI   EQU   OCCCRT+2
COCACX   EQU   OCCCRT+2
COCCCN   EQU   OCCCRT+2
COCCCM   EQU   OCCCRT+2
COCCNV   EQU   OCCCRT+2
COCCCC   EQU   OCCCRT+2
COCCRL   EQU   OCCCRT+2
COCCQU   EQU   OCCCRT+2
COCCRT   EQU   OCCCRT+1
COCCFB   EQU   OCCCRT+1
COCCOF   EQU   OCCCRT+1
COCCLD   EQU   OCCCRT+1
COCCOE   EQU   OCCCRT+1
COCCOD   EQU   OCCCRT+1
COCCRD   EQU   OCCCRT+1
COCCFD   EQU   OCCCRT
COCCMD   EQU   OCCCRT
COCCFR   EQU   OCCCRT
COCCFO   EQU   OCCCRT
COCCSL   EQU   OCCCRT
COCCCH   EQU   OCCCRT
COCCCL   EQU   OCCCRT
COCCOC   EQU   OCCCRT
NOCPOI   EQU   OCCNTRD+2
NOCACX   EQU   OCCNTRD+2
NOCCCN   EQU   OCCNTRD+2
NOCCCM   EQU   OCCNTRD+2
NOCCNV   EQU   OCCNTRD+2
NOCCCC   EQU   OCCNTRD+2
NOCCRL   EQU   OCCNTRD+2
NOCCQU   EQU   OCCNTRD+2
NOCCRT   EQU   OCCNTRD+1
NOCCFB   EQU   OCCNTRD+1
NOCCOF   EQU   OCCNTRD+1
NOCCLD   EQU   OCCNTRD+1
NOCCOE   EQU   OCCNTRD+1
NOCCOD   EQU   OCCNTRD+1
NOCCRD   EQU   OCCNTRD+1
NOCCFD   EQU   OCCNTRD
NOCCMD   EQU   OCCNTRD
NOCCFR   EQU   OCCNTRD
NOCCFO   EQU   OCCNTRD
NOCCSL   EQU   OCCNTRD
NOCCCH   EQU   OCCNTRD
NOCCCL   EQU   OCCNTRD
NOCCOC   EQU   OCCNTRD
OCCCNS   EQU   ISTOCCRR
CNSRSV05 EQU   CNSTFLDB+2
CNSLOG0B EQU   CNSTFLDB+2
CNSACCTB EQU   CNSTFLDB+2
CNSFREEB EQU   CNSTFLDB+2
CNSGETSB EQU   CNSTFLDB+2
CNSSEARB EQU   CNSTFLDB+2
CNSQUEUB EQU   CNSTFLDB+2
CNSACONB EQU   CNSTFLDB+2
CNSTCONB EQU   CNSTFLDB+1
CNSCLAQB EQU   CNSTFLDB+1
CNSCLINB EQU   CNSTFLDB+1
CNSGBINB EQU   CNSTFLDB+1
CNSLGINB EQU   CNSTFLDB+1
CNSACINB EQU   CNSTFLDB+1
CNSPSINB EQU   CNSTFLDB+1
CNSRQRLB EQU   CNSTFLDB+1
CNSTRRLB EQU   CNSTFLDB
CNSDORLB EQU   CNSTFLDB
CNSRLINB EQU   CNSTFLDB
CNSQREQB EQU   CNSTFLDB
CNSXREQB EQU   CNSTFLDB
CNSAQINB EQU   CNSTFLDB
CNSAUTHB EQU   CNSTFLDB
CNSMRINB EQU   CNSTFLDB
CNSRSV01 EQU   CNSTFLDA+2
CNSLOG0A EQU   CNSTFLDA+2
CNSACCTA EQU   CNSTFLDA+2
CNSFREEA EQU   CNSTFLDA+2
CNSGETSA EQU   CNSTFLDA+2
CNSSEARA EQU   CNSTFLDA+2
CNSQUEUA EQU   CNSTFLDA+2
CNSACONA EQU   CNSTFLDA+2
CNSTCONA EQU   CNSTFLDA+1
CNSCLAQA EQU   CNSTFLDA+1
CNSCLINA EQU   CNSTFLDA+1
CNSGBINA EQU   CNSTFLDA+1
CNSLGINA EQU   CNSTFLDA+1
CNSACINA EQU   CNSTFLDA+1
CNSPSINA EQU   CNSTFLDA+1
CNSRQRLA EQU   CNSTFLDA+1
CNSTRRLA EQU   CNSTFLDA
CNSDORLA EQU   CNSTFLDA
CNSRLINA EQU   CNSTFLDA
CNSQREQA EQU   CNSTFLDA
CNSXREQA EQU   CNSTFLDA
CNSAQINA EQU   CNSTFLDA
CNSAUTHA EQU   CNSTFLDA
CNSMRINA EQU   CNSTFLDA
CNSTPFX  EQU   ISTCNSTA
ATCAOS   EQU   ISTATCVT+1552
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMBP EQU   ATCAOSM+440
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00059 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPT18 EQU   ATCAOSM+300
ATCRPT17 EQU   ATCAOSM+296
ATCRPT16 EQU   ATCAOSM+292
ATCRPT15 EQU   ATCAOSM+288
ATCRPT14 EQU   ATCAOSM+284
ATCRPT13 EQU   ATCAOSM+280
ATCRPT12 EQU   ATCAOSM+276
ATCRPT11 EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
ATCRSVBB EQU   ISTATCVT+908
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00058 EQU   ISTATCVT+818
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ISTATCVT+788
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00057 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00056 EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LOKXCL   EQU   @NM00054
LOKPRY   EQU   @NM00054
@NM00055 EQU   @NM00054
@NM00053 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
@NM00052 EQU   ISTAPCRR+137
@NM00051 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00050 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00049 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00048 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00047 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00046 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00045 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00044 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00043 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00042 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00041 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPNXLCW EQU   ISTLCPB+20
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00040 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
SDVPMEPA EQU   ISTSDVT+24
SDVRSV13 EQU   SDVLINET
SDVLNDLC EQU   SDVLINET
SDVLNBSC EQU   SDVLINET
SDVLNSS  EQU   SDVLINET
SDVLNMP  EQU   SDVLINET
SDVLNPP  EQU   SDVLINET
SDVLNSW  EQU   SDVLINET
SDVLNNSW EQU   SDVLINET
SDVRSV11 EQU   SDVCUATT
SDVRSV10 EQU   SDVCUATT
SDVCUCLC EQU   SDVCUATT
SDVCUCLU EQU   SDVCUATT
SDVRSV14 EQU   SDVCUATT
SDVCUSA  EQU   SDVCUATT
SDVCURMT EQU   SDVCUATT
SDVCULCL EQU   SDVCUATT
SDVFEAT  EQU   SDVQUALC+4
SDVTTYPE EQU   SDVQUALC
SDVRSV08 EQU   SDVID+2
SDVNORT  EQU   SDVPARM
SDVRTRN  EQU   SDVPARM
SDVOUT   EQU   SDVPARM
SDVIN    EQU   SDVPARM
SDVQUAL  EQU   SDVPARM
SDVEXCPT EQU   SDVPARM
SDVCOND  EQU   SDVPARM
SDVUNCON EQU   SDVPARM
SDVRSV06 EQU   SDVFLAGS
SDVRSV05 EQU   SDVFLAGS
SDVRSV04 EQU   SDVFLAGS
SDVRSV03 EQU   SDVFLAGS
SDVRSV02 EQU   SDVFLAGS
SDVRSV01 EQU   SDVFLAGS
SDVBLDL  EQU   SDVFLAGS
SDVINCLD EQU   SDVFLAGS
SDVCNT   EQU   SDVOPTNS+2
SDVDEVC  EQU   SDVNAME+4
SDVRSV09 EQU   SDVNAME
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00039 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00038 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00037 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   ISTRPH+1
RPHTYPE  EQU   ISTRPH
OCWEND   EQU   ISTOCW+848
@NM00036 EQU   OCWFLG1
OCWEXIT  EQU   OCWFLG1
OCWSENSE EQU   ISTOCW+843
OCWBNDSZ EQU   ISTOCW+841
OCWBINDD EQU   OCWBIND+37
OCWBINDA EQU   OCWBIND+1
OCWBINDC EQU   OCWBIND
OCWSHPLC EQU   OCWSHPL+8
OCWSHPLB EQU   OCWSHPL+4
OCWSHPLA EQU   OCWSHPL
OCWBNDRU EQU   ISTOCW+780
OCWELCP  EQU   ISTOCW+776
OCWRSV12 EQU   ISTOCW+772
OCWRSV11 EQU   ISTOCW+768
OCWRSV10 EQU   ISTOCW+764
OCWRSV09 EQU   ISTOCW+760
OCWPROCD EQU   ISTOCW+756
OCWRSV08 EQU   ISTOCW+752
OCWRSV07 EQU   ISTOCW+748
OCWDAF   EQU   OCWCID+2
OCWSAF   EQU   OCWCID
OCWNMLLN EQU   ISTOCW+742
OCWRSV0A EQU   ISTOCW+741
OCWRSV82 EQU   OCWLOCKS
OCWMLOCK EQU   OCWLOCKS
OCWALOCK EQU   OCWLOCKS
OCWDLOCK EQU   OCWLOCKS
OCWCLOCK EQU   OCWLOCKS
OCWELOCK EQU   OCWLOCKS
OCWRLOCK EQU   OCWLOCKS
OCWVLOCK EQU   OCWLOCKS
OCWACE   EQU   ISTOCW+736
OCWIOMIN EQU   ISTOCW+735
OCWIOMAJ EQU   ISTOCW+734
OCWBHSID EQU   ISTOCW+733
OCWRSV03 EQU   ISTOCW+732
OCWSWTE7 EQU   OCWSWTE
OCWSWTE6 EQU   OCWSWTE
OCWSWTE5 EQU   OCWSWTE
OCWSWTE4 EQU   OCWSWTE
OCWSWTE3 EQU   OCWSWTE
OCWSWTE2 EQU   OCWSWTE
OCWLCPBC EQU   OCWSWTE
OCWSKEL  EQU   OCWSWTE
OCWSWTR7 EQU   OCWSWTRD
OCWSWTR6 EQU   OCWSWTRD
OCWSWTR5 EQU   OCWSWTRD
OCWDPDVT EQU   OCWSWTRD
OCWEPTLP EQU   OCWSWTRD
OCWCPARE EQU   OCWSWTRD
OCWCLEN  EQU   OCWSWTRD
OCWSRDVT EQU   OCWSWTRD
OCWCLCD2 EQU   ISTOCW+728
OCWCLCD1 EQU   ISTOCW+726
OCWLALEN EQU   ISTOCW+724
OCWSDVTA EQU   ISTOCW+720
OCWOENIB EQU   ISTOCW+716
OCWSORTP EQU   ISTOCW+712
OCWMDVT  EQU   ISTOCW+708
OCWSDVT  EQU   ISTOCW+704
OCWPREV  EQU   ISTOCW+700
OCWLCPBA EQU   ISTOCW+696
OCWSAVE5 EQU   ISTOCW+552
OCWSAVE4 EQU   ISTOCW+480
OCWSAVE3 EQU   ISTOCW+408
OCWSAVE2 EQU   ISTOCW+336
OCWCSPL  EQU   ISTOCW+224
OCWRSVD  EQU   ISTOCW+212
OCWVPAB  EQU   ISTOCW+208
OCWSWTD7 EQU   OCWSWTD
OCWSWTD6 EQU   OCWSWTD
OCWSWTD5 EQU   OCWSWTD
OCWSWTD4 EQU   OCWSWTD
OCWSWTD3 EQU   OCWSWTD
OCWSTCTL EQU   OCWSWTD
OCWNPOST EQU   OCWSWTD
OCWCLDEB EQU   OCWSWTD
OCWVARY  EQU   OCWSWTC
OCWPRMTR EQU   OCWSWTC
OCWPBH   EQU   OCWSWTC
OCWRBH   EQU   OCWSWTC
OCWCKACE EQU   OCWSWTC
OCWODCLS EQU   OCWSWTC
OCWSWTC1 EQU   OCWSWTC
OCWSPCLS EQU   OCWSWTC
OCWCSCAL EQU   OCWSWTB
OCWPSREQ EQU   OCWSWTB
OCWOLOCK EQU   OCWSWTB
OCWCOREQ EQU   OCWSWTB
OCWDOPHY EQU   OCWSWTB
OCWCLOOP EQU   OCWSWTB
OCWRECL  EQU   OCWSWTB
OCWGOFUN EQU   OCWSWTB
OCWNODLT EQU   OCWSWTA
OCWODCL  EQU   OCWSWTA
OCWGODST EQU   OCWSWTA
OCWSORT  EQU   OCWSWTA
OCWGOCNT EQU   OCWSWTA
OCWNOCON EQU   OCWSWTA
OCWSRT   EQU   OCWSWTA
OCWGTLST EQU   OCWSWTA
OCWSCPAD EQU   ISTOCW+176
OCWDNIB  EQU   ISTOCW+112
OCWBADNO EQU   ISTOCW+110
OCWDSTNO EQU   ISTOCW+108
OCWODCT2 EQU   ISTOCW+106
OCWODCT1 EQU   ISTOCW+104
OCWRSV02 EQU   ISTOCW+100
OCWRSV01 EQU   ISTOCW+96
OCWSVEC  EQU   OCWSVCOD+1
OCWSVRC  EQU   OCWSVCOD
OCWODFST EQU   ISTOCW+88
OCWODNAS EQU   ISTOCW+84
OCWODLST EQU   ISTOCW+80
OCWLPOST EQU   ISTOCW+76
OCWCPOST EQU   ISTOCW+72
OCWFPOST EQU   ISTOCW+68
OCWACDEB EQU   ISTOCW+64
OCWNCB   EQU   ISTOCW+60
OCWFMCB  EQU   ISTOCW+56
OCWEPTAB EQU   ISTOCW+52
OCWARDTE EQU   ISTOCW+48
OCWNIB   EQU   ISTOCW+44
OCWDRHOB EQU   OCWDRDTE
OCWCSL   EQU   ISTOCW+28
OCWPAB   EQU   ISTOCW+20
OCWRPH   EQU   ISTOCW+16
OCWRPL   EQU   ISTOCW+12
OCWCHAIN EQU   ISTOCW+8
OCWPBCHN EQU   ISTOCW+4
OCWTLEN  EQU   ISTOCW+2
OCWSLEN  EQU   ISTOCW+1
OCWID    EQU   ISTOCW
NIBRESV  EQU   ISTNIB+60
NIBNDAR  EQU   ISTNIB+56
NIBLMODE EQU   ISTNIB+48
NIBEXLST EQU   ISTNIB+44
NIBLIMIT EQU   ISTNIB+42
@NM00035 EQU   ISTNIB+41
@NM00034 EQU   NIBFLG1
@NM00033 EQU   NIBFLG1
@NM00032 EQU   NIBFLG1
@NM00031 EQU   NIBFLG1
NIBSHLTP EQU   NIBFLG1
NIBSDAPP EQU   NIBFLG1
NIBCON   EQU   NIBFLG1
NIBLAST  EQU   NIBFLG1
NIBPROCD EQU   ISTNIB+36
NIBDEVCH EQU   ISTNIB+28
NIBMODE  EQU   ISTNIB+20
NIBSYM   EQU   ISTNIB+12
NIBUSER  EQU   ISTNIB+8
NIBCID   EQU   ISTNIB+4
NIBLEN   EQU   ISTNIB+3
NIBCONDN EQU   ISTNIB+2
NIBRSV01 EQU   ISTNIB+1
NIBID    EQU   ISTNIB
CSLDATAF EQU   CSLDATA
CSLNIBF  EQU   CSLNIB
CSLRDTEF EQU   CSLRDTE
BINUSE   EQU   ISTBIND+36
BINUSEL  EQU   ISTBIND+35
BINPRIM  EQU   ISTBIND+27
BINPRIML EQU   ISTBIND+26
BINPRSVC EQU   ISTBIND+7
BINCONR  EQU   BINCMNP2
BINRCHN  EQU   BINCMNP2
BINMDIBK EQU   BINCMNP2
BINBKFS  EQU   BINCMNP2
BINRCVR  EQU   BINCMNP2
BINFMTRM EQU   BINCMNP2
BINRSV04 EQU   BINCMNP
BINALT   EQU   BINCMNP
BINBKTR  EQU   BINCMNP
BINBRAK  EQU   BINCMNP
BINFMHD  EQU   BINCMNP
BINRSV03 EQU   BINCMNP
BINSSEB  EQU   BINSECP
BINSCMP  EQU   BINSECP
BINRSV02 EQU   BINSECP
BINSCHNR EQU   BINSECP
BINSMCH  EQU   BINSECP
BINSCHN  EQU   BINSECP
BINPSEB  EQU   BINPRIP
BINPCMP  EQU   BINPRIP
BINRSV01 EQU   BINPRIP
BINPCHNR EQU   BINPRIP
BINPMCH  EQU   BINPRIP
BINPCHN  EQU   BINPRIP
BINTS    EQU   ISTBIND+2
BINFM    EQU   ISTBIND+1
BINTYPE  EQU   BINFMTY
BINFMT   EQU   BINFMTY
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PRORSV11 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
CSPRSC2B EQU   ISTCSP+32
CSPTRDTE EQU   ISTCSP+28
CSPRLRPH EQU   ISTCSP+24
CSPNO    EQU   ISTCSP+22
CSPCC    EQU   ISTCSP+20
CSPDATA  EQU   ISTCSP+16
CSPRSCE  EQU   ISTCSP+12
CSPDEST  EQU   ISTCSP+8
CSPSRC   EQU   ISTCSP+4
@NM00030 EQU   CSPOPT2
CSPRSC2F EQU   CSPOPT2
CSPWASQD EQU   CSPOPT2
CSPACQS  EQU   CSPOPT2
CSPACES  EQU   CSPOPT2
CSPNOREL EQU   CSPOPT2
CSPCOREQ EQU   CSPOPT2
CSPSTAP  EQU   CSPOPT2
@NM00029 EQU   CSPOPT1
CSPANY   EQU   CSPOPT1
CSPACT   EQU   CSPOPT1
CSPSESS  EQU   CSPOPT1
CSPPND   EQU   CSPOPT1
CSPLOGI  EQU   CSPOPT1
CSPQ     EQU   CSPOPT1
CSPRSC   EQU   CSPOPT1
CSPIDX   EQU   ISTCSP
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00028 EQU   CVTFIX+248
@NM00027 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
     /




                   000095


               960634 JOB 'D0406P,D58,B7062C36,S=U,L=1','JM DELANCEY   '
       20300000
                                                      ASS=T,MSGCLASS=A,M
VEL=(1,1)                                    20309000

RM    LINECT=0                                                   2032900

                   BLIB   DD  DSN=CLR6.JOBLIB,
          *20408000

    SP=(SHR,PASS)                                          20417000

                                      DSN=SYS1.NOTLIB,DISP=(SHR,PASS)
                   20710000
                                          STXT EXEC  PGM=CLRTXT00,COND=(
),REGION=80K,                    *71700

//  PARM=(D04MVM,VS22,TSOTUG,DOC40,@,,@,                               *
0000




                            820000

                                                               ROUT1  DD
SOUT=T,SPACE=(TRK,(80,20),RLSE),                      *72120000
/
                                             B=(BLKSIZE=3458,RECFM=FBSA)
                        72180000
                                  RPRINT DD SYSOUT=A,SPACE=(TRK,(5,10)),
                         *72280000

                B=(RECFM=FA,BLKSIZE=133)                               7
000
                                    SUDUMP   DD  SYSOUT=A,SPACE=(TRK,(80
)                           72420000

                 DS     DD  DSN=CASTER.CONTROL.D04MVM,DISP=SHR

                                                    480000


                                            T      DD  DSN=D04MVM.VS22.T
G.DOC40.TXT(0),DISP=SHR,           *72540000
 /
                                              B=(RECFM=U,BLKSIZE=2000)
                         72600000
                                                     W      DD  UNIT=SYS
ISP=(MOD,PASS),SPACE=(TRK,(5,10)),          *7

        60000
 60000

                         B=(LRECL=80,RECFM=FB,BLKSIZE=1680)
    72720000
                              STXT EXEC  PGM=CLRTXT00,COND=(8,LE),REGION
,                    *71700
                                                               0


                                                 RM=(D04MVM,VS22,TSOTUG,
1,@,,@,                                    71760000
 ,@,,@,1,1)



                                                820000


       ROUT1  DD  SYSOUT=T,SPACE=(TRK,(80,20),RLSE),
2120000
                                                                 B=(BLKS
3458,RECFM=FBSA)                            72180000
                                                      RPRINT DD SYSOUT=A
CE=(TRK,(5,10)),                             *72280000

                                    B=(RECFM=FA,BLKSIZE=133)
               72300000
                                                        SUDUMP   DD  SYS
A,SPACE=(TRK,(80,20))                           72420000

                                     DS     DD  DSN=CASTER.CONTROL.D04MV
SP=SHR

00

                                                                T      D
SN=D04MVM.VS22.TSOTUG.DOC41.TXT(0),DISP=SHR,           *72540000

                                                                  B=(REC
,BLKSIZE=2000)                               72600000

    DD  UNIT=SYSDA,DISP=(MOD,PASS),SPACE=(TRK,(5,10)),          *7

                            60000

/
                                             B=(LRECL=80,RECFM=FB,BLKSIZ
80)                     72720000
                                                  STXT EXEC  PGM=CLRTXT0
ND=(8,LE),REGION=80K,                    *71700

       0

                                                                     RM=
MVM,VS22,TSOTUG,DOC42,@,,@,                                    71760000
     /               ,@,,@,1,1)



                                                                    8200


                           ROUT1  DD  SYSOUT=T,SPACE=(TRK,(80,20),RLSE),
                  *72120000

         B=(BLKSIZE=3458,RECFM=FBSA)                            72180000
      /
RINT DD SYSOUT=A,SPACE=(TRK,(5,10)),                             *722800

                                                        B=(RECFM=FA,BLKS
133)                               72300000

SUDUMP   DD  SYSOUT=A,SPACE=(TRK,(80,20))                           7242
//SDDS     DD  DSN=CASTER.CO
                                     ROL.D04MVM,DISP=SHR
   72480000

              T      DD  DSN=D04MVM.VS22.TSOTUG.DOC42.TXT(0),DISP=SHR,
     *72540000

                B=(RECFM=U,BLKSIZE=2000)                               7
000
                       W      DD  UNIT=SYSDA,DISP=(MOD,PASS),SPACE=(TRK,
0)),          *7
                                                      60000


                                                                       B
ECL=80,RECFM=FB,BLKSIZE=1680)                     72720000

STXT EXEC  PGM=CLRTXT00,COND=(8,LE),REGION=80K,                    *7170

                                 0


                   RM=(D04MVM,VS22,TSOTUG,DOC43,@,,@,
             71760000




                  820000

                                                     ROUT1  DD  SYSOUT=T
CE=(TRK,(80,20),RLSE),                      *72120000

                                   B=(BLKSIZE=3458,RECFM=FBSA)
              72180000
                        RPRINT DD SYSOUT=A,SPACE=(TRK,(5,10)),
               *72280000

      B=(RECFM=FA,BLKSIZE=133)                               72300000
   /
                          SUDUMP   DD  SYSOUT=A,SPACE=(TRK,(80,20))
                  72420000

       DS     DD  DSN=CASTER.CONTROL.D04MVM,DISP=SHR

                                          480000


                                  T      DD  DSN=D04MVM.VS22.TSOTUG.DOC4
T(0),DISP=SHR,           *72540000

                                    B=(RECFM=U,BLKSIZE=2000)
               72600000
                                           W      DD  UNIT=SYSDA,DISP=(M
ASS),SPACE=(TRK,(5,10)),          *7

000


               B=(LRECL=80,RECFM=FB,BLKSIZE=1680)                     72
00
                    STXT EXEC  PGM=CLRTXT00,COND=(8,LE),REGION=80K,
           *71700
                                                     0


                                       RM=(D04MVM,VS22,TSOTUG,DOC44,@,,@
                                 71760000
)



                                      820000

     /
T1  DD  SYSOUT=T,SPACE=(TRK,(80,20),RLSE),                      *7212000

                                                       B=(BLKSIZE=3458,R
=FBSA)                            72180000
                                            RPRINT DD SYSOUT=A,SPACE=(TR
,10)),                             *72280000

                          B=(RECFM=FA,BLKSIZE=133)
     72300000
                                              SUDUMP   DD  SYSOUT=A,SPAC
RK,(80,20))                           72420000
    /
                           DS     DD  DSN=CASTER.CONTROL.D04MVM,DISP=SHR

                                                              480000


                                                      T      DD  DSN=D04
VS22.TSOTUG.DOC44.TXT(0),DISP=SHR,           *72540000

                                                        B=(RECFM=U,BLKSI
000)                               72600000
                                                               W      DD
IT=SYSDA,DISP=(MOD,PASS),SPACE=(TRK,(5,10)),          *7

                  60000


                                   B=(LRECL=80,RECFM=FB,BLKSIZE=1680)
