         TITLE 'ISTSDCDS - VTAM SYSTEM DEFINITION DIALSET MACRO HANDLER*
               R        '
ISTSDCDS CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTSDCDS  75.130'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*                                                                  0161
*/********************************************************************/
*/*                       ENTRY LINKAGE                              */
*/********************************************************************/
*                                                                  0161
*   DATDREG=ADDR(RNCDAT1);          /* SET UP DYNAMIC DATA REG       */
         LA    DATDREG,RNCDAT1(,RNCAREG)                           0161
*   GENERATE NOREFS NOSETS;                                        0162
         USING @DATD,DATDREG            @ABILITY FOR DATA
*   SVBACKWD=ADDR(SAVIN);           /* POINT TO CALLER'S SAVE AREA   */
         ST    SAVREG,SVBACKWD(,RNCAREG)                           0163
*   SVFORWRD=ADDR(SAVOUT);          /* POINT TO NEW SAVE AREA        */
         LA    @10,SAVOUT(,RNCAREG)                                0164
         ST    @10,SVFORWRD(,SAVREG)                               0164
*   SAVREG=ADDR(SAVOUT);            /* SAVREG READY FOR A CALL OUT   */
         LR    SAVREG,@10                                          0165
*   RFY                                                            0166
*     SAVIN;                        /* INPUT SAVE AREA NOT @ABLE     */
*/********************************************************************/
*/*          THE BASE MODEL FOR THE LCDO (LOGICAL CONNECT DIAL       */
*/*          OUT) IS CREATED AND SUPPLIED WITH DEFAULT VALUES        */
*/*          BY SIFTDEF (ISTSDCRS).  AT ENTRY TO SIFTDEF             */
*/*          REG 1 CONTAINS THE RDT ENTRY TYPE.                      */
*/********************************************************************/
*                                                                  0167
*   GPR1=RPRENTDS;                  /* RDT ENTRY TYPE                */
         LA    GPR1,32                                             0167
*   CALL ISTSDCRS;                  /* CREATE LCDO MODEL W/ DEFAULTS */
         L     @15,@CV01167                                        0168
         BALR  @14,@15                                             0168
*/********************************************************************/
*/*          UPON RETURN FROM SIFTDEF REG 1 CONTAINS @ OF THE        */
*/*          LCDO ENTRY MODEL.                                       */
*/*          THE MODEL IS MOVED INTO THE BUILD AREA BY AREA          */
*/*          HANDLER (ISTSDCC1).  AT ENTRY TO AREA HANDLER           */
*/*            REG 0 CONTAINS 0                                      */
*/*            REG 1 CONTAINS @ OF LCDO ENTRY MODEL (JUST SET        */
*/*                           BY SIFTDEF)                            */
*/********************************************************************/
*                                                                  0169
*   GPR0=0;                                                        0169
         SLR   GPR0,GPR0                                           0169
*   CALL ISTSDCC1;                  /* MOVE LCDO MODEL TO BUILD AREA */
         L     @15,@CV01166                                        0170
         BALR  @14,@15                                             0170
*/********************************************************************/
*/*          UPON RETURN FROM AREA HANDLER                           */
*/*            REG 0 CONTAINS OFFSET TO LCDO IN THE BUILD AREA       */
*/*            REG 1 CONTAINS @ OF LCDO IN THE BUILD AREA            */
*/*            REG 15 CONTAINS A RETURN CODE                         */
*/*                   0 IF MOVE WAS SUCCESSFUL                       */
*/*                  ^0 IF STORAGE NOT AVAILABLE.  IN THIS CASE      */
*/*                     A MESSAGE AS BEEN PUT OUT BY AREA            */
*/*                     HANDLER,  REGS 0 AND 1 DO NOT CONTAIN        */
*/*                     THE OFFSET AND @ INDICATED ABOVE.            */
*/********************************************************************/
*                                                                  0171
*   IF GPR15^=0 THEN                                               0171
         LTR   GPR15,GPR15                                         0171
         BZ    @RF00171                                            0171
*     RC=4;                         /* WAS LCDO MOVE SUCCESSFUL?   0172
*                                      NO-SET RETURN CODE. NEXT INSTR
*                                      AT 'RETRN'                    */
         LA    RC,4                                                0172
*   ELSE                                                           0173
*FILLCDO:                                                          0173
*     DO;                           /* YES-FILL IN LCDO SKELETON     */
         B     @RC00171                                            0173
@RF00171 DS    0H                                                  0173
FILLCDO  DS    0H                                                  0174
*       RFY                                                        0174
*        (ISTRDS,                                                  0174
*         ISTRPRE) BASED(GPR1);                                    0174
*                                                                  0174
*/********************************************************************/
*/*          SINCE THE COMMUNICATION ID FIELD IN THE RDT             */
*/*          ENTRY PREFIX IS NOT USED PRIOR TO GENEND PRO-           */
*/*          CESSING, IT MAY BE USED TO SAVE A POINTER TO THE        */
*/*          LCDO.  GENEND WILL USE THE LCDO POINTER PRIOR TO        */
*/*          FILLING IN THE COMMUNICATION ID FIELD.                  */
*/********************************************************************/
*                                                                  0175
*       RPRCOMID=GPR0;              /* OFFSET TO LCDO                */
         ST    GPR0,RPRCOMID(,GPR1)                                0175
*/********************************************************************/
*/*          THE POINTER TO THE DOT (DIAL OUT TABLE) IN A            */
*/*          DIALSET (EQUIVALENT TO LCDO) OF THE RDT IS NOT          */
*/*          NEEDED UNTIL THE DOT IS CREATED BY GENEND.  THUS        */
*/*          THE POINTER TO THE DOT MAY BE USED TO CHAIN THE         */
*/*          LCDO'S TOGETHER.                                        */
*/********************************************************************/
*                                                                  0176
*       RDSADDOT=RNCDS;             /* PLACE NEW LCDO AT HEAD OF     */
         L     @07,RNCDS(,RNCAREG)                                 0176
         ST    @07,RDSADDOT(,GPR1)                                 0176
*       RNCDS=ADDR(ISTRDS);         /* LCDO CHAIN                    */
         ST    GPR1,RNCDS(,RNCAREG)                                0177
*       RC=0;                       /* SET VALID RETURN CODE         */
         SLR   RC,RC                                               0178
*     END FILLCDO;                                                 0179
*RETRN:                                                            0180
*   SAVREG=SVBACKWD;                /* POINT TO INPUT SAVE AREA      */
@RC00171 DS    0H                                                  0180
RETRN    L     SAVREG,SVBACKWD(,RNCAREG)                           0180
*   RETURN CODE(RC);                /* RETURN TO CALLER              */
         LR    @15,RC                                              0181
         L     @14,12(,@13)                                        0181
         LM    @00,@12,20(@13)                                     0181
         BR    @14                                                 0181
*/* TPEPILOG                                                         */
*                                                                  0182
*   GEN(PRINT OFF);                                                0182
         PRINT OFF
*   GEN(PRINT ON);                                                 0183
*                                                                  0183
         PRINT ON
*/* END OF TPEPILOG                                                  */
*                                                                  0184
*   END ISTSDCDS;                                                  0184
@EL00001 DS    0H                                                  0184
@EF00001 DS    0H                                                  0184
@ER00001 LM    @14,@12,12(@13)                                     0184
         BR    @14                                                 0184
@DATA    DS    0H
@DATD    DSECT
         DS    0F
ISTSDCDS CSECT
         DS    0F
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTSDCDS CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV01166 DC    V(ISTSDCC1)
@CV01167 DC    V(ISTSDCRS)
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RC       EQU   @10
GPR0     EQU   @00
GPR1     EQU   @01
R3       EQU   @03
R4       EQU   @04
MLCAREG  EQU   @05
RNCAREG  EQU   @06
DATDREG  EQU   @11
SAVREG   EQU   @13
GPR14    EQU   @14
GPR15    EQU   @15
R12      EQU   @12
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00002 EQU   LOKCHNG+2
ISTRPRE  EQU   0
RPRCOMID EQU   ISTRPRE+8
RPRFLAGA EQU   ISTRPRE+21
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRFLAGD EQU   ISTRPRE+61
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTFLAGB EQU   ISTRDT+91
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
ISTRAP   EQU   0
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNUCBAD EQU   RRNADR+1
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNUCBAD EQU   RLNADR+1
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTDITT  EQU   ISTRPT+128
RPTFLAG1 EQU   ISTRPT+140
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
ISTRDS   EQU   0
RDSADDOT EQU   ISTRDS+76
ISTDOT   EQU   0
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCFLAGB EQU   ISTRCC+74
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCCRFLG EQU   ISTRCC+108
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUNCPPC EQU   ISTRLU+134
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
ISTRLS   EQU   0
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATFLAGA EQU   ISTPAT+7
ISTRNCA  EQU   0
RNCDS    EQU   ISTRNCA+12
RNCRNMDL EQU   ISTRNCA+2984
RNCTRMDL EQU   RNCRNMDL
RNCLUMDL EQU   RNCTRMDL
RNCLNMDL EQU   RNCLUMDL
RNCSWMDL EQU   RNCLNMDL
RNCLSMDL EQU   RNCSWMDL
RNCCLMDL EQU   RNCLSMDL
RNCDAMDL EQU   RNCCLMDL
RNCCMMDL EQU   ISTRNCA+3240
RNCINMDL EQU   RNCCMMDL
RNCCCMDL EQU   RNCINMDL
RNCGPMDL EQU   RNCCCMDL
RNCPXMDL EQU   RNCGPMDL
RNCSAV1  EQU   ISTRNCA+3460
RNCDAT1  EQU   ISTRNCA+3532
RNCWORK1 EQU   ISTRNCA+3844
RNCPHR1  EQU   RNCWORK1
RNCWORK2 EQU   ISTRNCA+5892
RNCPHR2  EQU   RNCWORK2
RNCWORK3 EQU   ISTRNCA+7940
ISTLCST  EQU   0
LCSTTYPE EQU   ISTLCST+12
LCSTACR  EQU   ISTLCST+18
ISTDITHD EQU   0
ISTDHDVI EQU   0
DHDDIVTH EQU   ISTDHDVI+12
ISTDDTVI EQU   0
ISTRNCDT EQU   0
ISTRNCGT EQU   0
ISTRNCPT EQU   0
ISTMLCA  EQU   0
MLCFLAGS EQU   ISTMLCA+16
MLCERBF  EQU   ISTMLCA+28
MLCERBF1 EQU   MLCERBF
MLCERBF2 EQU   MLCERBF+8
MLCERBF3 EQU   MLCERBF+32
MLCPTRS  EQU   ISTMLCA+96
MLCPTR1  EQU   MLCPTRS+4
MLCADSAV EQU   ISTMLCA+652
MLCADDAT EQU   ISTMLCA+724
MLCWRK1  EQU   ISTMLCA+964
MLCWRK2  EQU   ISTMLCA+1220
MLCOCPRM EQU   MLCWRK2
MLCWRK3  EQU   ISTMLCA+1284
MLCRDPRM EQU   MLCWRK3
MLCWRK4  EQU   ISTMLCA+1348
MLCTPMSG EQU   MLCWRK4
MLCDECB2 EQU   MLCTPMSG+32
SAVIN    EQU   0
SVFORWRD EQU   SAVIN+8
SAVOUT   EQU   RNCSAV1
SVBACKWD EQU   SAVOUT+4
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00016 EQU   SAVOUT+8
@NM00015 EQU   SAVOUT
@NM00014 EQU   SAVIN+4
@NM00013 EQU   SAVIN
MLCSTOWL EQU   MLCDECB2
MLCDECB1 EQU   MLCTPMSG
MLCLDPRM EQU   MLCRDPRM
MLCACPRM EQU   MLCOCPRM
MLCDCB   EQU   MLCWRK1
MLCMHDAT EQU   ISTMLCA+908
MLCERDAT EQU   ISTMLCA+852
MLCERSAV EQU   ISTMLCA+780
MLCARDAT EQU   MLCADDAT
MLCARSAV EQU   MLCADSAV
MLCDAT4  EQU   ISTMLCA+596
MLCSAV4  EQU   ISTMLCA+524
MLCDAT3  EQU   ISTMLCA+468
MLCSAV3  EQU   ISTMLCA+396
MLCDAT2  EQU   ISTMLCA+340
MLCSAV2  EQU   ISTMLCA+268
MLCDAT1  EQU   ISTMLCA+212
MLCSAV1  EQU   ISTMLCA+140
@NM00012 EQU   ISTMLCA+136
MLCNCSPL EQU   MLCPTRS+36
MLCLENT  EQU   MLCPTRS+32
MLCPTR7  EQU   MLCPTRS+28
MLCPTR6  EQU   MLCPTRS+24
MLCPTR5  EQU   MLCPTRS+20
MLCPTR4  EQU   MLCPTRS+16
MLCPTR3  EQU   MLCPTRS+12
MLCPTR2  EQU   MLCPTRS+8
MLCPTR0  EQU   MLCPTRS
MLCGETSZ EQU   ISTMLCA+92
MLCFIII  EQU   MLCERBF3+8
MLCCNFG2 EQU   MLCERBF3
MLCFII   EQU   MLCERBF2+16
MLCMACRO EQU   MLCERBF2+8
MLCNAME  EQU   MLCERBF2
MLCCONFG EQU   MLCERBF1
MLCKWD   EQU   ISTMLCA+24
MLCENT   EQU   ISTMLCA+20
MLCINT   EQU   MLCFLAGS
MLCSKDCB EQU   ISTMLCA+12
MLCSKEL  EQU   ISTMLCA+8
MLCRPH   EQU   ISTMLCA+4
MLCSECCA EQU   ISTMLCA
RNCPT    EQU   ISTRNCPT+4
RNCPTLN  EQU   ISTRNCPT
RNCGT    EQU   ISTRNCGT+4
RNCGTLN  EQU   ISTRNCGT
RNCDT    EQU   ISTRNCDT+4
RNCDTLN  EQU   ISTRNCDT
DDTASSOC EQU   ISTDDTVI+40
DDTRDTPT EQU   ISTDDTVI+36
DDTTRNM  EQU   ISTDDTVI+28
DDTBSCLN EQU   ISTDDTVI+27
DDTBSCID EQU   ISTDDTVI+4
DDTFWPTR EQU   ISTDDTVI
DHDGPPTR EQU   ISTDHDVI+32
DHDDVOFF EQU   ISTDHDVI+28
DHDDTPTR EQU   ISTDHDVI+24
DHDDHPTR EQU   ISTDHDVI+20
DHDRSVD  EQU   DHDDIVTH+6
DHDIDLEN EQU   DHDDIVTH+4
DHDNUMFE EQU   DHDDIVTH+2
DHDNUME  EQU   DHDDIVTH
DHDHNAME EQU   ISTDHDVI+4
DHDFWPTR EQU   ISTDHDVI
DITDITT  EQU   ISTDITHD+16
DITLEN   EQU   ISTDITHD+15
DITUNUSD EQU   ISTDITHD+12
DITLSTNM EQU   ISTDITHD+4
DITFWDPT EQU   ISTDITHD
LCSTCODE EQU   ISTLCST+19
LCSTACR3 EQU   LCSTACR
LCSTACR2 EQU   LCSTACR
LCSTACR1 EQU   LCSTACR
LCSTACR0 EQU   LCSTACR
LCSTLCCD EQU   LCSTTYPE+5
LCSTLCTP EQU   LCSTTYPE
LCSTNAME EQU   ISTLCST+4
LCSTFWDP EQU   ISTLCST
RNCWORD5 EQU   ISTRNCA+8084
RNCWORD4 EQU   ISTRNCA+8080
RNCWORD3 EQU   ISTRNCA+8076
RNCWORD2 EQU   ISTRNCA+8072
RNCWORD1 EQU   ISTRNCA+8068
RNCWORK4 EQU   ISTRNCA+8004
RNCLDPRM EQU   RNCWORK3
RNCOCPRM EQU   RNCPHR2
RNCLMDCB EQU   RNCPHR1
RNCDAT3  EQU   ISTRNCA+3788
RNCSAV3  EQU   ISTRNCA+3716
RNCDAT2  EQU   ISTRNCA+3660
RNCSAV2  EQU   ISTRNCA+3588
@NM00011 EQU   ISTRNCA+3456
RNCLXMDL EQU   RNCPXMDL
RNCDSMDL EQU   RNCDAMDL
RNCCCLU  EQU   ISTRNCA+2808
RNCCLTR  EQU   ISTRNCA+2596
RNCLNLU  EQU   ISTRNCA+2420
RNCLNTR  EQU   ISTRNCA+2208
RNCLNPX  EQU   ISTRNCA+2124
RNCLNCC  EQU   ISTRNCA+1976
RNCLNCL  EQU   ISTRNCA+1880
RNCGPLU  EQU   ISTRNCA+1704
RNCGPTR  EQU   ISTRNCA+1492
RNCGPPX  EQU   ISTRNCA+1408
RNCGPCC  EQU   ISTRNCA+1260
RNCGPCL  EQU   ISTRNCA+1164
RNCGPLN  EQU   ISTRNCA+1004
RNCLUDEF EQU   ISTRNCA+828
RNCTRDEF EQU   ISTRNCA+616
RNCPXDEF EQU   ISTRNCA+532
RNCCCDEF EQU   ISTRNCA+384
RNCCLDEF EQU   ISTRNCA+288
RNCLNDEF EQU   ISTRNCA+128
RNCRSV01 EQU   ISTRNCA+127
RNCTBFR  EQU   ISTRNCA+127
RNCGPUIN EQU   ISTRNCA+127
RNCGVB   EQU   ISTRNCA+127
RNCGLSBD EQU   ISTRNCA+126
RNCGSWBD EQU   ISTRNCA+126
RNCGRNBD EQU   ISTRNCA+126
RNCGCLPU EQU   ISTRNCA+126
RNCGANS  EQU   ISTRNCA+126
RNCGINOD EQU   ISTRNCA+126
RNCGCUA  EQU   ISTRNCA+126
RNCGRNAM EQU   ISTRNCA+126
RNCGDLLN EQU   ISTRNCA+125
RNCGRGAP EQU   ISTRNCA+125
RNCLNID  EQU   ISTRNCA+125
RNCGPID  EQU   ISTRNCA+125
RNCLNOW  EQU   ISTRNCA+125
RNCGNOW  EQU   ISTRNCA+125
RNCLQUE  EQU   ISTRNCA+125
RNCGQUE  EQU   ISTRNCA+125
RNCDTYPE EQU   ISTRNCA+124
RNCGVSEQ EQU   ISTRNCA+123
RNCGTWX  EQU   ISTRNCA+123
RNCGCTRM EQU   ISTRNCA+123
RNCGSTBH EQU   ISTRNCA+123
RNCGCOMP EQU   ISTRNCA+123
RNCGLU   EQU   ISTRNCA+123
RNCGTERM EQU   ISTRNCA+123
RNCGPA   EQU   ISTRNCA+123
RNCGPU   EQU   ISTRNCA+122
RNCGCLUS EQU   ISTRNCA+122
RNCGLINE EQU   ISTRNCA+122
RNCGGRP  EQU   ISTRNCA+122
RNCGHOST EQU   ISTRNCA+122
RNCGSYSC EQU   ISTRNCA+122
RNCGBLD  EQU   ISTRNCA+122
RNCGPCCU EQU   ISTRNCA+122
RNCLPCT  EQU   ISTRNCA+120
RNCLPNM  EQU   ISTRNCA+112
RNCDIVT  EQU   ISTRNCA+108
RNCDITT  EQU   ISTRNCA+104
RNCLCST  EQU   ISTRNCA+100
RNCLWS   EQU   ISTRNCA+96
RNCFWS   EQU   ISTRNCA+92
RNCOFFS2 EQU   ISTRNCA+88
RNCOFFST EQU   ISTRNCA+84
RNCLTBLS EQU   ISTRNCA+80
RNCFTBLS EQU   ISTRNCA+76
RNCLENT  EQU   ISTRNCA+72
RNCFENT  EQU   ISTRNCA+68
RNCLRNLL EQU   ISTRNCA+64
RNCFRNLL EQU   ISTRNCA+60
RNCPX    EQU   ISTRNCA+56
RNCDA    EQU   ISTRNCA+52
RNCLLN   EQU   ISTRNCA+48
RNCCM    EQU   ISTRNCA+44
RNCIN    EQU   ISTRNCA+40
RNCLU    EQU   ISTRNCA+36
RNCTR    EQU   ISTRNCA+32
RNCCC    EQU   ISTRNCA+28
RNCCL    EQU   ISTRNCA+24
RNCLN    EQU   ISTRNCA+20
RNCGP    EQU   ISTRNCA+16
RNCRSV07 EQU   ISTRNCA+8
RNCSWLS  EQU   ISTRNCA+4
RNCRN    EQU   ISTRNCA
PATRSV01 EQU   PATFLAGA
PATUSEFG EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATPTHID EQU   ISTPAT+4
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSCTELU EQU   ISTRLS+136
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDADACUA EQU   ISTRDA+76
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWCTELU EQU   ISTRSW+148
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWGRUPT EQU   ISTRSW+140
RSWDIALT EQU   ISTRSW+136
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLULGMOD EQU   ISTRLU+164
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUNCPPN EQU   RLUNCPPC
RLUPACEM EQU   RLUPACE+1
RLUPACEN EQU   RLUPACE
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLURBISA EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCPATHZ EQU   ISTRCC+124
RCCPATHT EQU   ISTRCC+120
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
RCCVPAB  EQU   ISTRCC+88
@NM00010 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCTELU EQU   ISTRCC+76
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCRESET EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCRBISA EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
DOTADTRM EQU   ISTDOT
RDSCTATR EQU   ISTRDS+74
RDSCTTRM EQU   ISTRDS+72
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINLOCRN EQU   ISTRIN+148
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRDIAA  EQU   ISTRTR+176
RTRPOLA  EQU   ISTRTR+172
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRCRSV1 EQU   RTRCRFLG
RTRTRMAX EQU   ISTRTR+142
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRCTECM EQU   ISTRTR+128
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRVTERM EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRBISA EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLGPOLA EQU   ISTRCL+84
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLCTECM EQU   ISTRCL+78
RCLCTETR EQU   ISTRCL+76
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRBISA EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTDAFSV EQU   ISTRPT+142
RPTRSV01 EQU   ISTRPT+141
RPTISTAT EQU   RPTFLAG1
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTUTERM EQU   ISTRPT+136
RPTATERM EQU   ISTRPT+132
RPTDIVT  EQU   RPTDITT
RPTCTNM  EQU   ISTRPT+120
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00009 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSVSKP EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNNPRLM EQU   RLNLSCMD
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNPAUSE EQU   ISTRLN+101
RLNPOLMT EQU   ISTRLN+100
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNCTSES EQU   ISTRLN+95
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNTTV   EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNANSWR EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNPORT  EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNRACAT EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTECM EQU   ISTRLN+82
RLNCTEIN EQU   ISTRLN+80
RLNCTETR EQU   ISTRLN+78
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNRBISA EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTETR EQU   ISTRGP+78
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPADIL  EQU   RGPFLG
RGPPRE   EQU   ISTRGP
RRNRINNM EQU   ISTRRN+248
@NM00008 EQU   ISTRRN+247
RRNRDCUA EQU   ISTRRN+244
RRNLASTE EQU   ISTRRN+240
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHBUFS EQU   ISTRRN+218
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNFLUX  EQU   ISTRRN+180
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRBREM EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTECM EQU   ISTRRN+168
RRNCTEIN EQU   ISTRRN+166
RRNCTETR EQU   ISTRRN+164
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNCTBHS EQU   ISTRRN+156
RRNBHSET EQU   ISTRRN+152
RRNTRENT EQU   ISTRRN+148
RRNRSV22 EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNGRPA  EQU   ISTRRN+140
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRBISA EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRBISA EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPRSV09 EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPALLF  EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPACEAP EQU   ISTRAP+100
RAPICEAQ EQU   ISTRAP+96
RAPICEAC EQU   ISTRAP+92
RAPICELG EQU   ISTRAP+88
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
RDTVSRPL EQU   ISTRDT+132
RDTCRSPW EQU   ISTRDT+124
RDTCRSDS EQU   ISTRDT+116
@NM00007 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTVPAB  EQU   ISTRDT+92
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTNODID EQU   ISTRDT+89
RDTMAXID EQU   ISTRDT+88
RDTCTSNT EQU   ISTRDT+86
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
RDTPRIAP EQU   RDTPRIOR
@NM00006 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
RCPLGNAP EQU   RCPLGNIN
@NM00005 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPACETR EQU   ISTRCPRE+84
RCPICEAQ EQU   ISTRCPRE+80
RCPLNAPA EQU   ISTRCPRE+76
RCPICELN EQU   ISTRCPRE+72
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
@NM00004 EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRCONCT EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRDEVCH EQU   ISTRPRE+44
RPRNCBA  EQU   ISTRPRE+40
RPRNSNEA EQU   ISTRPRE+36
RPRLGONB EQU   ISTRPRE+32
RPRLGONF EQU   ISTRPRE+28
RPRHDTYP EQU   ISTRPRE+27
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRCRCPT EQU   RPRCAUSE
RPRNOSRT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTED EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRINV   EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRENTRY EQU   ISTRPRE+20
RPRPELEN EQU   ISTRPRE+18
RPRELEN  EQU   ISTRPRE+16
RPRRLOCK EQU   ISTRPRE+12
RPRDAF   EQU   RPRCOMID+2
RPRSAF   EQU   RPRCOMID
RPRNAME  EQU   ISTRPRE
LOKXCL   EQU   @NM00002
LOKPRY   EQU   @NM00002
@NM00003 EQU   @NM00002
@NM00001 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   ISTSDCDS,(C'PLS1056',0603,75130)
