* /* START OF SPECIFICATIONS ****
*     PROLOGUE
*
*01*  MINI-MODULE-NAME = ISTYPSOL
*
*01*  FUNCTIONS = TO CREATE A SKELETEL DVT FOR THE PORT SOLICITOR
*                 CONTAINING THE PROCESS MODULES NEEDED TO BE USED
*                 ALONG WITH THE NECESSARY QUALIFIERS SO AS THE PROPER
*                 FUNCTIONS ARE SELECTED AS PER DEVICE TYPE USED
*                NOTE -- SEE FUNCT MACRO FOR QUALIFYING ARGUMENTS
*
*01*  MODULE-SIZE = 64-BYTES
*
*01*  PROCESSOR = ASSEMBLER
*
*01*  SYSTEMS-WHERE-USED = OS/VS1, OS/VS2
*
*01*  HOW-USED = AS-FOLLOWS:
*
*                THE SKELETEL DVT WILL BE SCANNED BY ISTOCCMD AND
*                THE CORRECT PROCESSES RETAINED BY MATCHING FUNCTION
*                QUALIFIERS WITH RESOURCE DEFINITION TABLE ENTRY INFO
*
*01*  INPUT-OUTPUT = NONE
*
*01*  CHANGE-ACTIVITY = NONE
*
**** END OF SPECIFICATIONS ***/
ISTYPSOL STRTMODE , PORT SOLICITOR DVT
*A-000000-999999                                                XL03HBS
*
**********************************************************************
*
ISTCLOBP DVT   ,   START C L OUTBOUND PROCESSING
         FUNCT     PROC=ISTNMC4P      PSOP ROUTER
*
INFIRST  DVT   ,   FIRST TIME DRIVER
         FUNCT     PROC=ISTNMC5P
*
INRESCL  DVT   ,   RESET AND CONTROL
         FUNCT     PROC=ISTNMC6P
*
ININPUT  DVT   ,   PROCESS INPUT
         FUNCT     PROC=ISTNMC7P
*
INOPURGE DVT   ,   TPPURGE
         FUNCT     PROC=ISTNMC8P
*
INRESET  DVT   ,   DIAL LINE CLOSE
         FUNCT     PROC=ISTNMC7S
*
INOCLPUR DVT   ,   CONTROL LAYER PURGE
         FUNCT     PROC=ISTDCC80
*
***********************************************************************
*
ISTCLIBP DVT   ,   START C L INBOUND PROCESSING
         FUNCT     PROC=ISTNMC9P
*
INCONCOP DVT    ,   I/C COMPLETE
         FUNCT     PROC=ISTNMC1S
*
INREDRVE DVT   ,  REDRIVE
         FUNCT     PROC=ISTNMC2S
*
INDDPROC DVT   ,   DIAL DISCONNECT PROCESSOR
         FUNCT     PROC=ISTNMC3S
*
INIPURGE DVT   ,   TPPURGE
         FUNCT     PROC=ISTNMC4S
*
INNFDBK  DVT   ,   FEEDBACK PROCESSOR
         FUNCT     PROC=ISTNMC5S
*
INICRTRY DVT   ,   I/C RETRY PROCESSOR
         FUNCT     PROC=ISTNMC6S
*
INICLPUR DVT   ,   CONTROL PLAYER PURGE (INBOUND)
         FUNCT     PROC=ISTDCC81
*
***********************************************************************
*
ISTTPOBP DVT  , TPIOS OUTBOUND DVT
         SPACE
*        REMOTE DEVICE SCHEDULER
         SPACE
         FUNCT PROC=ISTZDFL0,LINE=(NS,,)
         FUNCT PROC=ISTZAF0B,LINE=(S,,)
         SPACE
*        LCCW TO BTU TRANSLATOR
         SPACE
         FUNCT PROC=ISTZBF0B
         SPACE
*        DIALOG SCHEDULER
         SPACE
         FUNCT PROC=ISTZCF0B
         SPACE
*        SESSION SCHEDULER
         SPACE
         FUNCT PROC=ISTZBFNE
         SPACE
*        READ
         SPACE
         FUNCT PROC=ISTZHFAN
         SPACE
*        WRITE
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        WRITE SOH
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        COPY
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        WRITE CONTROL
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        RESET
         SPACE
         FUNCT PROC=ISTZBFFB
         SPACE
*        INVALID CONTROL
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        CONTACT
         SPACE
         FUNCT PROC=ISTZBFHB,LINE=(S,,SS),EXCEPT=TWX
         FUNCT PROC=ISTZBFX0,LINE=(S,,BSC)
         FUNCT PROC=ISTZBFX0,DVC=TWX
         SPACE
*        DISCONNECT
         SPACE
         FUNCT PROC=ISTZBFIB
         SPACE
*        TEST LCCW
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        PREEMPT
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        RESTORE
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        INVALID COMMAND
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        SEND LCCW
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
*        PREEMPT COMPLETION
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        RESET CLEANUP (PHASE 1)
         SPACE
         FUNCT PROC=ISTZIFSB
         SPACE
*        RESET CLEANUP (PHASE 3)
         SPACE
         FUNCT PROC=ISTZIFUB
         SPACE
*        RESET CLEANUP (PHASE 4)
         SPACE
         FUNCT PROC=ISTZIFVB
         SPACE
*        SESSION CONTROL
         SPACE
         FUNCT PROC=ISTZBFX0
         SPACE
ISTTPIBP DVT  , TPIOS INBOUND DVT
         SPACE
*        REQUEST COMPLETION CONTROL
         SPACE
         FUNCT PROC=ISTZIF0B
         SPACE
*        DIALOG SCHEDULER
         SPACE
         FUNCT PROC=ISTZCFCI                                   @X04BHDA
         SPACE
*        DEVICE STATUS CONTROLLER
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        NEGATIVE RESPONSE TO POLLING
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        NRP RESET PHASE
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        NRP INVITE PHASE
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        RESCHEDULE STATE
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        PREEMPT PENDING STATE
         SPACE
         FUNCT PROC=ISTZDFL0
         SPACE
*        READ COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        INVITE COMPLETION
         SPACE
         FUNCT PROC=ISTZIFKG,LINE=(S,,BSC)
         FUNCT PROC=ISTZIFX0,LINE=(S,,SS),EXCEPT=TWX
         FUNCT PROC=ISTZIFKG,DVC=TWX,LINE=(S,,SS)
         SPACE
*        WRITE COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        CONTACT DISCONNECT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFOE,LINE=(S,,SS),EXCEPT=TWX
         FUNCT PROC=ISTZIFOB,LINE=(S,,BSC)
         FUNCT PROC=ISTZIFOB,DVC=TWX,LINE=(S,,SS)
         SPACE
*        RESET COMMAND COMPLETION
         SPACE
         FUNCT PROC=ISTZIFNB
         SPACE
*        TEST COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        CONTROL COMMAND
         SPACE
         FUNCT PROC=ISTZGFBB
         SPACE
*        PREEMPT COMPLETION
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        OUTPUT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        OUTPUT ERROR ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        INPUT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFCB
         SPACE
*        INPUT ERROR ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFBB
         SPACE
*        CONTACT DISCONNECT COMPLETION STATUS ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFHB
         SPACE
*        CONTACT ERROR ANALYSIS
         SPACE
         FUNCT PROC=ISTZIFX0,LINE=(S,,BSC)
         FUNCT PROC=ISTZIFGB,LINE=(S,,SS),EXCEPT=TWX
         FUNCT PROC=ISTZIFX0,DVC=TWX
         SPACE
*        COMMAND RESET COMPLETION
         SPACE
         FUNCT PROC=ISTZIFAB
         SPACE
*        LOGICAL ERROR RECOVERY
         SPACE
         FUNCT PROC=ISTZIFIB
         SPACE
*        INVALID DEVICE COMMAND
         SPACE
         FUNCT PROC=ISTZIFX0
         SPACE
*        RESET CLEANUP (PHASE 1)
         SPACE
         FUNCT PROC=ISTZIFSB
         SPACE
*        RESET CLEANUP (PHASE 2)
         SPACE
         FUNCT PROC=ISTZIFTB
         SPACE
*        DIAL DISCONNECT
         SPACE
         FUNCT PROC=ISTZKFBN
         SPACE
*        MANUAL DIAL
         SPACE
         FUNCT PROC=ISTZKFCN
ISTATOBP DVT
         FUNCT PROC=ISTZDFL0
*
ISTYPSOL ENDMODE
*
             END
