*        %GOTO PLSSNS;                                               /*
         MACRO
         TSNSD
.*A000000-999999                                               @Y17XAXG
IEDSNSD  DSECT
*               SENSE BYTE DSECT
SNSSYSTM DS    0XL2                     SYSTEM SENSE BYTES
SNSMAJ   DS    XL1                      MAJOR SENSE BYTE
SNSPATH  EQU   X'80'                    PATH ERROR
SNSRHUSE EQU   X'40'                    RH USAGE ERROR
SNSSTERR EQU   X'20'                    STATE ERROR
SNSRQERR EQU   X'10'                    REQUEST ERROR
SNSRQREJ EQU   X'08'                    REQUEST REJECT
SNSMIN   DS    XL1                      MINOR SENSE BYTE
*    REQUEST FOR PATH ERROR BYTES
SNSLNKF  EQU   X'02'                    DATA LINK FAILURE
SNSLUINP EQU   X'03'                    LU INOPERATIVE         @YM08991
SNSLOSCT EQU   X'0D'                    LOST CONTACT
*    REQUEST ERROR MINOR SENSE BYTES
SNSRUDAT EQU   X'01'                    RU DATA ERROR
SNSRULEN EQU   X'02'                    RU LENGTH ERROR
SNSNFUNC EQU   X'03'                    FUNCTION NOT SUPPORTED
SNSNCAT  EQU   X'07'                    CATEGORY NOT SUPPORTED
SNSINVHD EQU   X'08'                    INVALID FM HEADER
*    REQUEST REJECT MINOR SENSE BYTES
SNSRNAV  EQU   X'01'                    RESOURCE NOT AVAILABLE
SNSIVREQ EQU   X'02'                    INTERVENTION REQUIRED
SNSMPSWD EQU   X'03'                    MISSING PASSWORD
SNSSLIM  EQU   X'05'                    SESSION LIMIT EXCEEDED
SNSMODIN EQU   X'09'                    MODE INCONSISTENCY
SNSBRACE EQU   X'0B'                    BRACKET RACE ERROR
SNSPRCNS EQU   X'0C'                    PROCEDURE NOT SUPPORTED
SNSCNCL  EQU   X'11'                    CANCEL KEY HIT
SNSNRSCE EQU   X'12'                    INSUFFICIENT RESOURCE
SNSNACT  EQU   X'16'                    FUNCION INATIVE
SNSNRTR  EQU   X'19'                    RTR NOT REQUIRED
SNSSRFER EQU   X'1E'                    SESSION REFERENCE ERROR
SNSUNCTL EQU   X'23'                    UNKNOWN CONTROL VECTOR
SNSINTRQ EQU   X'80'                    INTERVENTION REQUIRED
SNSRCXMT EQU   X'1B'                    RECEIVER IN TRANSMIT MODE
SNSNGRB  EQU   X'13'                    NEGATIVE RESP TO BID
SNSRTRY  EQU   X'27'                    RETRY REQUESTED
SNSACTV  EQU   X'15'                    FUNCTION ALREADY ACTIVE
SNSUSER  DS    0XL2                     USER SENSE BYTES
SNSUSR1  DS    XL1                      FIRST USER BYTE
SNSUSR2  DS    XL1                      SECOND USER BYTE
         MEND                                                        */
*%PLSSNS : ;
*DECLARE 1 IEDSNSD BASED(SNSPTR),       /* SENSE BYTE STRUCTURE      */
*          2 SNSSYSTM  CHAR(2),        /* SYSTEM SENSE BYTES        */
*            3 SNSMAJ  BIT(8),          /* MAJOR SENSE BYTE          */
*            3 SNSMIN  BIT(8),          /* MINOR SENSE BYTE          */
*          2 SNSUSER   CHAR(2),        /* USER SENSE BYTES          */
*            3 SNSUSR1 BIT(8),          /* FIRST USER BYTE           */
*            3 SNSUSR2 BIT(8);          /* SECOND USER BYTE          */
*/*                                                                  */
*/*            REQUEST FOR PATH ERROR BYTES                          */
*/*                                                                  */
*DCL SNSLNKF  BIT(8) CONSTANT('02'X);   /* DATA LINK FAILURE         */
*DCL SNSLUINP BIT(8) CONSTANT('03'X);   /* LU INOPERATIVE    @YM08991*/
*DCL SNSLOSCT BIT(8) CONSTANT('0D'X);   /* LOST CONTACT              */
*/*                                                                  */
*/*            CONSTANTS TO BE USED WITH MAJOR SENSE                 */
*/*                                                                  */
*DCL SNSPATH BIT(8) CONSTANT('80'X);    /* PATH ERROR               */
*DCL SNSRHUSE BIT(8) CONSTANT('40'X);   /* RH USAGE ERROR            */
*DCL SNSSTERR BIT(8) CONSTANT('20'X);   /* STATE ERROR               */
*DCL SNSRQERR BIT(8) CONSTANT('10'X);   /* REQUEST ERROR             */
*DCL SNSRQREJ BIT(8) CONSTANT('08'X);   /* REQUEST REJECT            */
*/*                                                                  */
*/*            CONSTANTS TO BE USED WITH MINOR SENSE                 */
*/*                                                                  */
*/*                                                                  */
*/*  REQUEST ERROR MINOR SENSE BYTES                                 */
*/*                                                                  */
*DCL SNSRUDAT BIT(8) CONSTANT('01'X);   /* RU DATA ERROR             */
*DCL SNSRULEN BIT(8) CONSTANT('02'X);   /* RU LENGTH ERROR           */
*DCL SNSNFUNC BIT(8) CONSTANT('03'X);   /* FUNCTION NOT SUPPORTED    */
*DCL SNSNCAT  BIT(8) CONSTANT('07'X);   /* CATEGORY NOT SUPPORTED    */
*DCL SNSINVHD BIT(8) CONSTANT('08'X);   /* INVALID FM HEADER         */
*/*                                                                  */
*/*  REQUEST REJECT MINOR SENSE BYTES                                */
*/*                                                                  */
*DCL SNSRNAV  BIT(8) CONSTANT('01'X);   /* RESOURCE NOT AVAILABLE    */
*DCL SNSIVREQ BIT(8) CONSTANT('02'X);   /* INTERVENTION REQUIRED     */
*DCL SNSMPSWD BIT(8) CONSTANT('03'X);   /* MISSING PASSWORD          */
*DCL SNSSLIM  BIT(8) CONSTANT('05'X);   /* SESSION LIMIT EXCEEDED    */
*DCL SNSMODIN BIT(8) CONSTANT('09'X);   /* MODE INCONSISTENCY        */
*DCL SNSBRACE BIT(8) CONSTANT('0B'X);   /* BRACKET RACE ERROR        */
*DCL SNSPRCNS BIT(8) CONSTANT('0C'X);   /* PROCEDURE NOT SUPPORTED   */
*DCL SNSCNCL  BIT(8) CONSTANT('11'X);   /* CANCEL KEY HIT            */
*DCL SNSNRSCE BIT(8) CONSTANT('12'X);   /* INSUFFICIENT RESOURCE     */
*DCL SNSNACT  BIT(8) CONSTANT('16'X);   /* FUNCTION INACTIVE         */
*DCL SNSNRTR  BIT(8) CONSTANT('19'X);   /* RTR NOT REQUIRED          */
*DCL SNSSRFER BIT(8) CONSTANT('1E'X);   /* SESSION REFERENCE ERROR   */
*DCL SNSUNCTL BIT(8) CONSTANT('23'X);   /* UNKNOWN CONTROL VECTOR    */
*DCL SNSINTRQ BIT(8) CONSTANT('80'X);   /* INTERVENTION REQUIRED     */
*DCL SNSRCXMT BIT(8) CONSTANT('1B'X);   /* RECEIVER IN TRANSMIT MODE */
*DCL SNSNGRB  BIT(8) CONSTANT('13'X);   /* NEGATIVE RESP TO BID      */
*DCL SNSRTRY  BIT(8) CONSTANT('27'X);   /* RETRY REQUESTED           */
*DCL SNSACTV  BIT(8) CONSTANT('15'X);   /* FUNCTION ALREADY ACTIVE   */
*/*                                                                  */
