WS05     TITLE 'AHLSBLOK && AHLSFEOB, BLOCKING RTN FOR THE STACK MACRO *
                         '
*                                                                  0001
AHLSBLOK CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(19)                                             0001
         DC    C'AHLSBLOKR0200073286'                              0001
         DROP  @15
@PROLOG  DS    0H                                                  0002
*/*A-000000-999999                                           @YA02014*/
*                                                                  0002
*   ;                                                              0002
*                                                                  0002
*/* %DCL DIAGAIDS CHAR;                THIS IS SET EQUAL TO        0003
*                                      'GENERATE' TO OBTAIN THE    0003
*                                      NONESSENTIAL PIECES OF CODE 0003
*                                      WHICH HAVE BEEN PUT INTO THE
*                                      TRACE WRITER FOR DIAGNOSTIC 0003
*                                      PURPOSES                      */
*/* %DCL FL1CHART CHAR;             THIS IS SET EQUAL TO 'NOFL1LST' TO
*                                   HAVE THE FL1 LISTING           0003
*                                   SUPPRESSED                       */
*/*  %DIAGAIDS='GENERATE';                                           */
*/*  %FL1CHART='';                                                   */
*/*AHLSBLOK: CHART (AMODE,SEQ)                                       */
*/*AHLSBLOK: HEADER                                                0003
*/*AHLSBLOK   RECORD BLOKING ROUTINES FOR THE WRITER-STACK SERVICE 0003
*/*                                                      PAGE   #    */
*/*AHLSBLOK: E R1->TRACE REC R2->GTFPCT R3->MCAWSA                   */
*                                                                  0003
*                                                                  0003
*/********************************************************************/
*/*                              MCAWSA                              */
*/********************************************************************/
*/*                                                                  */
*/* LEVEL OF APPLICABILITY                                           */
*/*   VS2-R2                                                         */
*/*                                                                  */
*/* FUNCTION                                                         */
*/*   THIS MAPPING DESCRIBES THE MCAWSA, MONITOR CALL APPLICATION    */
*/*   WORK SAVE AREA, USED BY FGBRS.                                 */
*/*                                                                  */
*/* INITIALIZATION                                                   */
*/*   THIS CONTROL BLOCK IS OBTAINED BY AHLVCON AT VARY CPU ONLINE   */
*/*   TIME, OR AHLSETEV JUST BEFORE SETTING CONTROL REGISTER 8       */
*/*   THE CLASS MASK REGISTER.  THERE IS ONE MCAWSA PER CPU AND      */
*/*   IT IS POINTED TO BY MCRWSA.  WHEN AHLMCER GIVES CONTROL TO     */
*/*   A FGBR, THE MCAWSA IS POINTED TO BY REGISTER THREE. THE        */
*/*   MCAWSA ALLOWS FGBR ROUTINES TO BE REENTRANT ON A PER CPU BASIS */
*/*   THE MCAWSA IS FREED BY AHLSETEV AT GTF TERMINATION OR          */
*/*   AHLVCOFF AT VARY CPU OFFLINE TIME.                             */
*/*   MCAWSA CURRENTLY HAS A MAXIMUM SIZE OF 800 BYTES.              */
*/*                                                                  */
*/* RESIDENCE                                                        */
*/*   THIS CONTROL IS OBTAINED FROM SQA AND THEREFORE IS FIXED       */
*/*   COMMON.                                                        */
*/*                                                                  */
*/* PHILOSOPHY OF DESIGN                                             */
*/*   THIS CONTROL BLOCK MAPPING ASSUMES THAT THE USER WILL          */
*/*   ESTABLISH ADDRESSABILITY.                                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0003
*   DECLARE                                                        0003
*     1 MCAWSA BDY(WORD) BASED(AWSAPTR) CHAR(800),                 0003
*      2 MCASBLOK(14) PTR(31),      /* SAVE AREA FOR AHLSBLOK        */
*      2 MCASFEOB(14) PTR(31),      /* SAVE AREA FOR AHLSFEOB        */
*      2 MCAFWORK CHAR(16) BDY(WORD),/* SBLOK/FEOB WORK AREA         */
*      2 MCASETEV CHAR(64),         /* SAVE AREA FOR DISABLED ENTRY
*                                      TO AHLSETEV REGS              */
*      2 MCAMSG CHAR(64),           /* AHLWTASK REG SAVE AREA        */
*      2 MCATRAIL CHAR(8),          /* FGBR AUDIT TRAIL              */
*       3 MCATRL1 PTR(8),           /* AUDIT BYTE ONE                */
*        4 MCASVC BIT(1),           /* SVC FGBR IN CONTROL           */
*        4 MCAEXT BIT(1),           /* EXT FGBR IN CONTROL           */
*        4 MCAIO BIT(1),            /* IO FGBR INCONTROL             */
*        4 MCASIO BIT(1),           /* SIO FGBR IN CONTROL           */
*        4 MCADSP BIT(1),           /* DSP FGBR IN CONTROL           */
*        4 MCASRB BIT(1),           /* SRB FGBR IN CONTROL           */
*        4 MCAPI BIT(1),            /* PI FGBR IN CONTROL            */
*        4 MCAUSR BIT(1),           /* USR FGBR IN CONTROL           */
*       3 MCATRL2 PTR(8),           /* AUDIT BYTE TWO                */
*        4 MCARNIO BIT(1),          /* RNIO FGBR IN CONTROL          */
*        4 MCASRM BIT(1),           /* SRM FGBR IN CONTROL           */
*        4 MCAFRR BIT(1),           /* FRR FGBR IN CONTROL           */
*        4 MCASTA BIT(1),           /* STAE/ESTAE FGBR IN CONTROL    */
*        4 MCAUIO BIT(1),           /* UIO FGBR IN CONTROL           */
*        4 MCAERROR BIT(1),         /* ERROR ROUTINE FOR INDICATED 0003
*                                      FGBR IN CONTROL               */
*        4 MCALSR BIT(1),           /* LSR ROUTINE IN CONTROL        */
*        4 MCATDIR BIT(1),          /* AHLTDIR IN CONTROL            */
*       3 MCATRL3 PTR(8),           /* FILTER BYTE INDICATORS        */
*        4 MCASVCF BIT(1),          /* SVC FILTER IN CONTROL         */
*        4 MCAIOF BIT(1),           /* IO FILTER IN CONTROL          */
*        4 MCASIOF BIT(1),          /* SIO FILTER IN CONTROL         */
*        4 MCAPIF BIT(1),           /* PI FILTER IN CONTROL          */
*        4 MCAFRSA BIT(1),          /* AHLTFOR GATHERING ASCB FOR SRM*/
*        4 MCAFRSJ BIT(1),          /* AHLTFOR GATHERING JOBNAME FOR
*                                      SRM                           */
*        4 MCAFRFA BIT(1),          /* AHLTFOR GATHERING ASCB FOR FRR*/
*        4 MCAFRFRT BIT(1),         /* AHLTFOR GATHERING DATA FROM 0003
*                                      RTCA FOR FRR RECORD           */
*       3 MCATRL4 PTR(8),           /* AUDIT TRAIL BYTE 4            */
*        4 MCAMEXT BIT(1),          /* GATHERING EXTERNAL            */
*        4 MCAMUCB BIT(1),          /* GATHERING FROM UCB            */
*        4 MCAMASCB BIT(1),         /* GATHERING ASCB                */
*        4 MCAMTCB BIT(1),          /* GATHERING TCB                 */
*        4 MCAMIOSB BIT(1),         /* GATHERING FROM IOSB           */
*        4 MCAMBTU BIT(1),          /* GATHERING FROM BTU            */
*        4 MCAMSDWA BIT(1),         /* GATHERING FROM RTCA           */
*        4 MCAMJOBN BIT(1),         /* GATHERING JOBNAME             */
*       3 MCATRL5 PTR(8),           /* AUDIT BYTE FIVE               */
*        4 MCAFREPC BIT(1),         /* AHLTFOR GATHERING PSW AND   0003
*                                      COMPLETION CODE FOR ESTAE     */
*        4 MCAFRERT BIT(1),         /* AHLTFOR GATHERING DATA FROM 0003
*                                      RTCA FOR ESTAE RECORD         */
*        4 MCAFRRA BIT(1),          /* AHLTFOR GATHERING ASCB FOR  0003
*                                      RNIO                          */
*        4 MCAFRRJ BIT(1),          /* AHLTFOR GATHERING JOBNAME FOR
*                                      RNIO RECORD                   */
*        4 MCAFRRB BIT(1),          /* AHLTFOR GATHERING DATA FROM 0003
*                                      BTU FOR RNIO RECORD           */
*        4 MCADREGS BIT(1),         /* GATHERING DSP,SRB REGS        */
*        4 * BIT(2),                /* RESERVED                      */
*       3 MCATRL6 PTR(8),           /* AUDIT TRAIL BYTE SIX          */
*        4 MCAFRPIJ BIT(1),         /* AHLTPID GATHERING PI JOBNAME  */
*        4 MCAFRPIC BIT(1),         /* AHLTPID GATHERING PI CDE NAME */
*        4 MCAFRDPC BIT(1),         /* AHLTPID GATHERING DSP CDE NAME*/
*        4 MCAFRDMJ BIT(1),         /* AHLTPID GATHERING DSP JOBNAME */
*        4 MCAFRSBR BIT(1),         /* AHLTPID GATHERING DSP REGS    */
*       3 MCATRL7 PTR(8),           /* AUDIT TRAIL BYTE SEVEN        */
*        4 MCAFREXJ BIT(1),         /* AHLTEXT GATHERING JOBNAME     */
*        4 MCAFRESP BIT(1),         /* AHLTEXT GATHERING SIG PROC    */
*        4 MCAFRECC BIT(1),         /* AHLTEXT GATHERING CLK COMP    */
*        4 MCAFRECT BIT(1),         /* AHLTEXT GATHERING CPU TIMER   */
*       3 MCATRL8 PTR(8),           /* AUDIT TRAIL BYTE EIGHT        */
*      2 MCAMCR PTR(31),            /* @ MCRWSA                      */
*      2 MCARECPR CHAR(16),         /* RECORD PREFIX BUILD AREA      */
*      2 MCAREC CHAR(300),          /* RECORD BUILD AREA             */
*      2 MCAWORK CHAR(60) BDY(WORD),/* WORK AREA FOR FGBRS           */
*      2 MCASWORK CHAR(32);         /* WORK AREA FOR SDUMPMOD      0003
*                                                                    */
*                                                                  0004
*/********************************************************************/
*/*                              GTFBLOK                             */
*/********************************************************************/
*/*                                                                  */
*/* LEVEL OF APPLICABILITY                                           */
*/*   OS/VS2-R2                                                      */
*/*                                                                  */
*/* FUNCTION                                                         */
*/*   THIS MAPPING DESCRIBES THE GTF BLOCK.  THE GTFBLOK ARE USED    */
*/*   BY AHLSBLOK FOR BLOCKING TRACE RECORDS BEFORE HAVING AHLSBUF   */
*/*   BUFFER THEM.                                                   */
*/*                                                                  */
*/* INITIALIZATION                                                   */
*/*   THIS CONTROL BLOCK IS OBTAINED BY WRITER INITIALIZATION,       */
*/*   AND WILL BE INITIALIZED AT THAT TIME.  THIS CONTROL BLOCK/DATA */
*/*   AREA MUST BE IN COMMON ADDRESS SPACE AND ON A DOUBLE WORD      */
*/*   BOUNDRY. IT WILL BE FREED BY THE TRACE WRITER AT               */
*/*   TERMINATION.                                                   */
*/*                                                                  */
*/* RESIDENCE                                                        */
*/*   THIS CONTROL BLOCK IS OBTAINED FROM SQA                        */
*/*   AND THEREFORE, IS FIXED, COMMON.                               */
*/*                                                                  */
*/* PHILOSOPHY OF DESIGN                                             */
*/*   THIS CONTROL BLOCK MAPPING ASSUMES THAT THE USER WILL QUALIFY  */
*/*   ALL ADDRESSING TO IT.                                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0004
*   DECLARE                                                        0004
*     1 GTFBLOK BDY(DWORD) BASED,                                  0004
*      2 BLOKID CHAR(8),            /* EBCDIC IDENTIFIER- GTFBLOK    */
*      2 BLKCHAIN PTR(31) BDY(DWORD),/* ADDRESS OF THE NEXT GTFBLOK
*                                      ON THE CHAIN                  */
*       3 BLKINUSE BIT(1),          /* THIS BIT IS SET BY AHLSBUF TO
*                                      INDICATE THAT THIS GTFBLOK IS
*                                      BEING BUFFERED. AHLSBLOK    0004
*                                      CHECKS THIS IN THE PROCESS OF
*                                      RESERVING SPACE IN A GTFBLOK  */
*      2 BLOKAREA CHAR(4096) BDY(WORD),/* RECORD BLOCKING AREA THE 0004
*                                      FORMAT OF THIS AREA WILL BE 0004
*                                      THAT OF A VARIABLE BLOCKED  0004
*                                      RECORD WITH THE MAJOR LENGTH
*                                      FIELD BEING BLOKLEN           */
*       3 BLOKLEN PTR(15),          /* LENGTH OF DATA IN THIS BLOCK  */
*       3 BLOKUSE PTR(15),          /* NUMBER OF RECORDS WHICH HAVE
*                                      SPACE RESERVED FOR THEM IN  0004
*                                      THIS GTFBLOK BUT HAVE NOT BEEN
*                                      MOVED IN YET BY AHLSBLOK. THIS
*                                      HALF WILL BE 0 ONLY WHEN THIS
*                                      GTFBLOK IS IN A CONDITION TO
*                                      BE BUFFERED BY AHLSBUF        */
*/* THIS VARIABLE NAME IS USED FOR CDS OF THE GTFBLOK FIELDS         */
*/*   BLKCHAIN, BLKINUSE, BLOKLEN, & BLOKUSE                         */
*                                                                  0004
*     BLOKSWAP CHAR(8) BDY(DWORD) DEFINED(BLKCHAIN);               0004
*                                                                  0004
*   /*****************************************************************/
*   /*                                                               */
*   /* MAP OF GTF TIME-STAMP RECORD AND/OR LOST EVENTS RECORD        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0005
*   DCL                                                            0005
*     1 RECMAP DEFINED(BLOKAREA) POSITION(5),                      0005
*      2 RECLL FIXED(15),           /* LENGTH OF THIS RECORD         */
*      2 RECRES1 CHAR(2),           /* QSAM COMPATABILITY            */
*      2 RECAID CHAR(1),            /* AID                           */
*      2 RECFID CHAR(1),            /* FID                           */
*      2 RECTIME CHAR(12),          /* TIME FIELD                    */
*       3 RECVTTZ CHAR(4),          /* CVT TIME ZONE                 */
*       3 RECTOD CHAR(8),           /* TOD VALUE                     */
*      2 RECGTFOP BIT(32) BDY(BYTE),/* GTF OPTION WORD, IF THIS IS A
*                                      TIME-STAMP RECORD, OR         */
*       3 RECLSTEV PTR(31) BDY(BYTE);/* LOST EVENT COUNT, IF THIS IS
*                                      A LOST EVENTS RECORD          */
*                                                                  0005
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS A MAPPING OF A SAVEHOOK RECORD. THIS RECORD IS BUILT  */
*   /* BY AHLTDIR TO REQUEST THAT AHLSBUF RETAIN GTFBUR CURRENTLY ON */
*   /* THE HISTORY QUEUE FOR AHLREADR                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0006
*   DCL                                                            0006
*     1 SVHKREC BASED,              /* SAVE HOOK RECORD FORMAT       */
*      2 SVHKLEN PTR(15),                                          0006
*      2 * CHAR(2),                                                0006
*      2 SVHKAFID CHAR(2),                                         0006
*      2 SVHKDATA CHAR(8),                                         0006
*       3 SVHKEID CHAR(2),                                         0006
*       3 SVHKASID CHAR(2),                                        0006
*       3 SVHKTCB CHAR(4);                                         0006
*                                                                  0007
*/********************************************************************/
*/*                              GTFPCT                              */
*/********************************************************************/
*/*                                                                  */
*/* LEVEL OF APPLICABILITY                                           */
*/*   OS/VS2-R2                                                      */
*/*                                                                  */
*/* FUNCTION                                                         */
*/*   THIS MAPPING DESCRIBES THE GTF PRIMARY CONTROL BLOCK.          */
*/*   THE GTFPCT CONTAINS INFORMATION NECESSARY FOR GTF              */
*/*   TO FUNCTION.                                                   */
*/*                                                                  */
*/* INITIALIZATION                                                   */
*/*   THIS CONTROL BLOCK IS OBTAINED BY AHLGTFI.  IT IS INITIALIZED  */
*/*   BY AHLGTFI AND AHLXWRIT, I.E., WRITER INITIALIZATION.          */
*/*   GTFPCT IS FREED AT TERMINATION BY EITHER AHLGTFI OR AHLTMON    */
*/*   AFTER WRITER TERMINATION IS  COMPLETE.                         */
*/*                                                                  */
*/* RESIDENCE                                                        */
*/*   THIS CONTROL BLOCK IS OBTAINED FROM AND RESIDES IN SQA,        */
*/*   AND THEREFORE, IS FIXED, COMMON.                               */
*/*                                                                  */
*/* PHILOSOPHY OF DESIGN                                             */
*/*   THIS CONTROL BLOCK MAPPING ASSUMES THAT THE USER WILL QUALIFY  */
*/*   ALL ADDRESSING TO IT.                                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0007
*   DECLARE                                                        0007
*     1 GTFPCT BDY(DWORD) BASED(PCTPTR),                           0007
*      2 GTFPCTID CHAR(8),          /* EBCDIC IDENTIFIER             */
*      2 GTFSTAT PTR(31),           /* FLAGS INDICATING STATUS       */
*       3 GTFMODE BIT(1),           /* 0=INTERNAL, 1=EXTERNAL        */
*       3 GTFDEBUG BIT(1),          /* 1=DEBUG MODE                  */
*       3 GTFRESV BIT(30),          /* RESERVED FLAGS                */
*      2 GTFOPTS CHAR(4),           /* GTF OPTION WORD               */
*       3 GTFOPTS1 PTR(8),          /* FIRST OPTION BYTE             */
*        4 OPTSYSM BIT(1),          /* MINIMAL TRACING FOR IO,SIO, 0007
*                                      SVC,PI,EXT, FRR               */
*        4 OPTSYSP BIT(1),          /* MAX TRACING FOR IO,SIO,SVC, 0007
*                                      PI,EXT,FRR WITH POSSIBLE    0007
*                                      SELECTIVE TRACING             */
*        4 OPTSYS BIT(1),           /* MAXIMUM TRACING FOR IO,SIO, 0007
*                                      SVC,PI,EXT,FRR                */
*        4 OPTUSR BIT(1),           /* ALL GTRACE EVENTS REQUESTED   */
*        4 OPTTRC BIT(1),           /* ALL EVENTS ASSOCIATED WITH THE
*                                      EXECUTION SHOULD BE TRACED    */
*        4 OPTDSP BIT(1),           /* ALL DISPATCHER EVENTS TRACED  */
*        4 OPTRES1 BIT(1),          /* RESERVED                      */
*        4 OPTPCI BIT(1),           /* PCI EVENTS ARE TO TRACED      */
*       3 GTFOPTS2 PTR(8),          /* SECOND OPTION BYTE            */
*        4 OPTSVC BIT(1),           /* SVC EVENTS TO BE TRACED       */
*        4 OPTSVCP BIT(1),          /* SVC FILTERING REQUESTED       */
*        4 OPTSIO BIT(1),           /* ALL SIO EVENTS TO BE TRACED   */
*        4 OPTSIOP BIT(1),          /* SIO FILTERING REQUESTED       */
*        4 OPTPI BIT(1),            /* ALL PI EVENTS TO BE TRACED    */
*        4 OPTPIP BIT(1),           /* PI FILTERING REQUESTED        */
*        4 OPTIO BIT(1),            /* ALL IO INTERRUPTS TRACED      */
*        4 OPTIOP BIT(1),           /* IO FILTERING REQUESTED        */
*       3 GTFOPTS3 PTR(8),          /* THIRD OPTION BYTE             */
*        4 OPTEXT BIT(1),           /* EXTERNAL INTERRUPTS TRACED    */
*        4 OPTRNIO BIT(1),          /* RNIO EVENTS TO BE TRACED      */
*        4 OPTSRM BIT(1),           /* ALL EVENTS FROM SYSTEMS     0007
*                                      RESOUR- CES MANAGER TO BE   0007
*                                      TRACED                        */
*        4 OPTRR BIT(1),            /* RETURN FROM ALL RECOVERY    0007
*                                      ROUTINES TRACED- FRR AND ESTAE*/
*        4 OPTRES2 BIT(3),          /* RESERVED                      */
*        4 OPTIOSIO BIT(1),         /* IO=SIO REQUESTED              */
*       3 GTFOPTS4 PTR(8),          /* FOURTH OPTION BYTE            */
*        4 OPTRES3 BIT(7),          /* RESERVED                      */
*        4 OPTTIME BIT(1),          /* ALL RECORDS TIMESTAMPED       */
*      2 PCTCATF PTR(31),           /* CURRENT ACTIVE TRACE FUNCTIONS*/
*       3 PCTSVC BIT(1),            /* SVC FUNCTION ACTIVE           */
*       3 PCTEXT BIT(1),            /* EXT FUNCTION ACTIVE           */
*       3 PCTIO BIT(1),             /* IO FUNCTION ACTIVE            */
*       3 PCTSIO BIT(1),            /* SIO FUNCTION ACTIVE           */
*       3 PCTDSP BIT(1),            /* DSP FUNCTION ACTIVE           */
*       3 * BIT(1),                 /* RESVRD FOR COMPATIBILITY WITH
*                                      MCATRAIL                      */
*       3 PCTPI BIT(1),             /* PI FUNCTION ACTIVE            */
*       3 PCTUSR BIT(1),            /* USR FUNCTION ACTIVE           */
*       3 PCTRNIO BIT(1),           /* RNIO FUNCTION ACTIVE          */
*       3 PCTSRM BIT(1),            /* SRM FUNCTION ACTIVE           */
*       3 PCTRR BIT(1),             /* RR FUNTION ( FRR AND ESTAE) 0007
*                                      ACTIVE                        */
*       3 PCTSVCF BIT(1),           /* SVC FILTERING ACTIVE          */
*       3 PCTIOF BIT(1),            /* IO FILTERING ACTIVE           */
*       3 PCTSIOF BIT(1),           /* SIO FILTERING ACTIVE          */
*       3 PCTPIF BIT(1),            /* PI FILTERING ACTIVE           */
*       3 * BIT(17),                /* RESERVED FOR C&S LOGIC        */
*      2 GTFSIOFT PTR(31),          /* @ SIO FILTER TABLE            */
*      2 GTFSIOBL PTR(31),          /* @ SIO FGBR ENTRY, USED BY   0007
*                                      FILTER ROUTINE                */
*      2 GTFIOFT PTR(31),           /* @ IO FILTER TABLE             */
*      2 GTFIOBL PTR(31),           /* @ IO FGBR ENTRY, USED BY    0007
*                                      FILTER ROUTINE                */
*      2 GTFSVCFT PTR(31),          /* @ SVC FILTER TABLE            */
*      2 GTFSVCBL PTR(31),          /* @ SVC FGBR ENTRY, USED BY   0007
*                                      FILTER ROUTINE                */
*      2 GTFPIFT PTR(31),           /* @ PI FILTER TABLE             */
*      2 GTFPIBL PTR(31),           /* @ PI FGBR ENTRY, USED BY    0007
*                                      FILTER ROUTINE                */
*      2 GTFEIDL PTR(31),           /* @ EID LIST TABLE              */
*      2 MCQEPTR PTR(31),           /* @ MCQE                        */
*      2 INITPTR PTR(31),           /* @ INITDATA                    */
*      2 FIXPTR PTR(31),            /* @ FIXTAB                      */
*      2 FIXLEN PTR(31),            /* LENGTH OF FIXTAB              */
*      2 ECBADRLT PTR(31),          /* ADDRESS OF ADDRESS LIST OF  0007
*                                      ECBS FOR AHLTMON POSTED FOR 0007
*                                      NORMAL OR ABNORMAL TERMINATION
*                                      OF GTF                        */
*      2 STOPECBA PTR(31),          /* ADDR STOP ECB                 */
*      2 AHLECB PTR(32),            /* ECB FOR WTOR AHL018A POSTED 0007
*                                      WHEN OPERATOR REPLIES         */
*      2 ATTCHECB PTR(31),          /* ECB USED WHEN WRITER IS     0007
*                                      ATTACHED POSTED BY SYSTEM WHEN
*                                      WRITER TERMINATES             */
*      2 WMTABPTR PTR(31),          /* @ WMSGTAB                     */
*      2 WTASKECB PTR(31),          /* AHLWTASK COMMUNICATION ECB- 0007
*                                      POSTED BY AHLWPOST            */
*      2 WTSKINIT PTR(31),          /* ECB POSTED WHEN AHLWTASK INIT-
*                                      IALIZATION COMPLETE           */
*      2 WTSKATTH PTR(31),          /* ECB USED WHEN AHLWTASK IS   0007
*                                      ATTACHED, POSTED BY SYSTEM  0007
*                                      WHEN AHLWTASK TERMINATES      */
*      2 TRMWTASK PTR(31),          /* ECB POSTED TO CAUSE AHLWTASK
*                                      TO TERMINATE                  */
*      2 WRTRTCBA PTR(31),          /* @ WRITERS TCB                 */
*      2 WTSKTCBA PTR(31),          /* @ AHLWTASK TCB                */
*      2 WPOSTSRB PTR(31),          /* @ SRB USED USED BY WTO SERVICE*/
*      2 EQHEAD PTR(31),            /* @ 1ST GTFBCB ON EMPTY QUEUE OR
*                                      0 IF IT IS NULL. THE TRACE  0007
*                                      WRITER USES THIS PTR TO ADD 0007
*                                      GTFBCB TO THE HEAD OF THE   0007
*                                      EMPTY QUEUE & AHLSBUF USES IT
*                                      TO REMOVE THEM. THE END OF  0007
*                                      THIS QUEUE IS A 0 IN THE    0007
*                                      BCBCHAIN FIELD OF THE LAST  0007
*                                      GTFBCB.                       */
*      2 RQHEAD PTR(31),            /* @ 1ST GTFBCB ON RELEASE QUEUE
*                                      OR 0 IF IT IS NULL. AHLSBUF 0007
*                                      USES THIS PTR TO ADD GTFBCB TO
*                                      THE HEAD OF THE RELEASE QUEUE
*                                      AND THE TRACE WRITER USES IT
*                                      TO REMOVE THEM. THE END OF  0007
*                                      THIS QUEUE IS A 0 IN THE    0007
*                                      BCBCHAIN FIELD OF THE LAST  0007
*                                      GTFBCB.                       */
*      2 WQHEAD PTR(31),            /* THIS PTR POINTS TO THE GTFBCB
*                                      THAT IS TO BE PROCESSED NEXT
*                                      BY THE TRACE WRITER, IT IS 0
*                                      IF THERE ARE NONE. GTFBCB ON
*                                      THIS QUEUE MAY ALSO BE ON THE
*                                      HISTORY AND SAVELIST QUEUES.
*                                      THE END OF THIS QUEUE IS A 0
*                                      IN THE BCBCHAIN FIELD OF THE
*                                      LAST GTFBCB. AHLSBUF UPDATES
*                                      THIS PTR ONLY IF IT WAS 0 WHEN
*                                      A GTFBCB WAS ADDED AT QTAIL.  */
*      2 HQHEAD PTR(31),            /* THIS PTR POINTS TO THE GTFBCB
*                                      WHICH HAS THE OLDEST DATA   0007
*                                      BEING SAVED FOR HISTORICAL  0007
*                                      PURPOSES. AHLSBUF KEEPS IT UP
*                                      TO DATE. GTFBCB ON THIS QUEUE
*                                      MAY ALSO BE ON THE WRITE &  0007
*                                      SAVELIST QUEUES. THE END OF 0007
*                                      THIS QUEUE IS A 0 IN THE    0007
*                                      BCBCHAIN FIELD OF THE LAST  0007
*                                      GTFBCB.                       */
*      2 QTAIL PTR(31),             /* POINTS TO THE LAST GTFBCB ON
*                                      THE HISTORY QUEUE AND ON THE
*                                      WRITE QUEUE (IF IT IS NOT   0007
*                                      NULL). THIS FIELD IS USED BY
*                                      AHLSBUF TO ADD JUST FILLED  0007
*                                      GTFBCB TO THE HISTORY & WRITE
*                                      QUEUES.                       */
*      2 HQLENGTH PTR(31),          /* IS THE NUMBER OF GTFBCB TO BE
*                                      MAINTAINED ON THE HISTORY   0007
*                                      QUEUE AND THE NUMBER OF GTFBCB
*                                      THAT WILL BE ON AN SLEBCBQ.   */
*      2 SLQHEAD PTR(31),           /* @ 1ST SLE ON SAVELIST QUEUE.
*                                      AHLSBUF & AHLREADR ADD SLE TO
*                                      THE HEAD OF THIS QUEUE WITH 0007
*                                      CS, & AHLREADR REMOVES SLE  0007
*                                      FROM ANYWHERE IN THE QUEUE. A
*                                      0 IN SLQCHAIN IS THE QUEUE END*/
*      2 SAVECNT PTR(31),           /* NUMBER OF SAVE HOOK RECORDS 0007
*                                      STACKED BY AHLTDIR BUT NOT YET
*                                      BUFFERED BY AHLSBUF. AHLTDIR
*                                      USES CS TO INCR THIS WHENEVER
*                                      IT STACKS A SAVEHOOK, &     0007
*                                      AHLSBUF DECR IT WHEN IT BUILDS
*                                      AN SLE                        */
*      2 SLEPAGE PTR(31),           /* ADDRESS OF THE PAGE OF SLE. 0007
*                                      THIS IS USED BY AHLREADR TO 0007
*                                      BUILD ITS LIST OF ADDRESS   0007
*                                      SPACE TO BE DUMPED BY SVCDUMP */
*      2 BCBPAGE(4) PTR(31),        /* ADDRESSES OF FROM 1 TO 4 PAGES
*                                      CONTAINING THE GTFBCB. THIS IS
*                                      USED BY AHLREADR TO BUILD ITS
*                                      LIST OF ADDRESS SPACE TO BE 0007
*                                      DUMPED BY SVCDUMP             */
*      2 WSMODBEG PTR(31),          /* BEGINNING AND END ADDR OF THE
*                                      LOAD MODULE AHLWSMOD          */
*      2 WSMODEND PTR(31),          /* THESE ARE KEPT SO A PGFREE CAN
*                                      BE DONE IN ERROR RECOVERY     */
*      2 NEXTBLOK PTR(31),          /* @ NEXT GTFBLOK TO BE BUFFERED.
*                                      AHLSBUF USES THIS PTR TO    0007
*                                      DETERMINE WHICH GTFBLOK IS TO
*                                      BE EMPTIED INTO A GTFBUFR   0007
*                                      NEXT.                         */
*       3 GBCDS BIT(1),             /* THIS IS THE GTFBLOK CHAIN   0007
*                                      DISABLE SWITCH. IT IS SET   0007
*                                      (NEXTBLOK MADE NEG) BY THE  0007
*                                      TRACE WRITER TO PREVENT     0007
*                                      AHLSFEOB FROM UPDATING      0007
*                                      CURRBLOK. IT IS TESTED BY   0007
*                                      AHLSFEOB                      */
*      2 CURRBLOK PTR(31),          /* AHLSFEOB PUTS THE ADDR OF THE
*                                      GTFBLOK TO BE FILLED BY     0007
*                                      AHLSBLOK HERE. IT IS THE    0007
*                                      CURRENT ONE                   */
*      2 SBLOKRTN PTR(31),          /* @ AHLSBLOK- USED BY AHLSTACK
*                                      MACRO. IF THIS FIELD IS 0 THE
*                                      AHLSTACK MACRO WILL NOT     0007
*                                      ATTEMPT TO CALL AHLSBLOK.     */
*      2 SFEOBRTN PTR(31),          /* AHLSFEOB ADDR USED BY THE   0007
*                                      TRACE WRITER & AHLTDIR TO FEOB*/
*      2 AHLRDPLQ PTR(31),          /* HEAD OF THE QUEUE OF REQUESTS
*                                      FOR DATA TO BE TRANSFERED TO
*                                      OTHER PROGRAMS                */
*      2 TRANSCNT PTR(31),          /* THIS IS THE COUNT OF THE    0007
*                                      NUMBER OF REQUESTS FOR DATA 0007
*                                      THAT WERE PROCESSED FROM    0007
*                                      AHLRDPLQ                      */
*      2 WRTRCOM PTR(32),           /* WRITER COMMUNICATIONS ECB-  0007
*                                      POSTED BY AHLSBUF EACH TIME IT
*                                      RUNS. THE TRACE WRITER WAITS
*                                      ON THIS ECB WHEN IT HAS NO  0007
*                                      WORK TO DO                    */
*       3 * BIT(1),                                                0007
*       3 WRTRCOMP BIT(1),          /* THE POST BIT                  */
*      2 GTFCMECB PTR(32),          /* ECB POSTED BY THE TRACE WRITER
*                                      TO INFORM THE MOTHER TASK THAT
*                                      INITIALIZATION IS COMPLETE    */
*      2 TRMWRIT PTR(31),           /* THIS ECB IS POSTED BY THE   0007
*                                      MOTHER TASK WHEN ALL FGBR   0007
*                                      ACTIVITY HAS BEEN QUIESED AND
*                                      THE TRACE WRITER IS TO      0007
*                                      TERMINATE.                    */
*       3 * BIT(1),                                                0007
*       3 TRMWRITP BIT(1),          /* THE POST BIT                  */
*      2 WRTRERR PTR(31),           /* THIS ECB IS POSTED BY THE   0007
*                                      TRACE WRITER OR ANY OF THE  0007
*                                      WRITER- STACK RECOVERY RTNS TO
*                                      REQUEST THAT THE MOTHER TASK
*                                      TERMINATE THE TRACE WRITER.   */
*       3 * BIT(1),                                                0007
*       3 WRTRERRP BIT(1),          /* THE POST BIT                  */
*      2 GTFSSRB PTR(31),           /* PTR TO THE SRB USED BY      0007
*                                      AHLSFEOB TO SCHEDULE AHLSBUF.
*                                      0 IF AHLSBUF IS DISABLED.     */
*       3 SRBAVAIL BIT(1),          /* THIS BIT IS SET WHEN THE SRB
*                                      IS AVAILABLE FOR SCHEDULING.
*                                      IT IS USED TO SERIALIZE THE 0007
*                                      USE OF THE SRB AND PORTIONS OF
*                                      THE CODE IN AHLSBUF           */
*      2 GTFLOSTR PTR(31),          /* COUNT OF RECORDS LOST WHEN  0007
*                                      AHLSBLOK WAS UNABLE TO STACK
*                                      RECORDS.                      */
*      2 WRITERDD CHAR(8),          /* DDNAME OF TRACE DATASET FOR 0007
*                                      THE TRACE WRITER OUTPUT       */
*      2 QLOCKWRD CHAR(4),          /* A PRIVATE COOPERATIVE LOCK  0007
*                                      USED BY AHLSBUF & THE TRACE 0007
*                                      WRITER                        */
*       3 QLOCK CHAR(1),            /* TEST AND SET IS USED TO SET 0007
*                                      THIS BYTE TO OBTAIN CONTROL OF
*                                      THE RESOURCES                 */
*       3 POSTWRIT CHAR(1),         /* THIS BYTE IS SET BY THE TRACE
*                                      WRITER TO REQUEST THAT AHLSBUF
*                                      POST QLOCKECB WHEN IT RELEASES
*                                      QLOCK                         */
*       3 SCHEDBUF CHAR(1),         /* THIS BYTE IS SET BY AHLSBUF TO
*                                      REQUEST THAT THE TRACE WRITER
*                                      SCHEDULE IT WHEN IT RELEASES
*                                      QLOCK                         */
*       3 * CHAR(1),                /* THIS BYTE IS RESERVED         */
*      2 QLOCKECB PTR(32),          /* THIS ECB IS WAITED ON BY THE
*                                      TRACE WRITER IF THE QLOCK IS
*                                      NOT AVAILABLE. IT IS POSTED BY
*                                      AHLSBUF AFTER THE IT HAS FREED
*                                      THE QLOCK                     */
*       3 * BIT(1),                                                0007
*       3 QLECBP BIT(1),            /* THE POST BIT                  */
*      2 WQLENGTH PTR(31),          /* NUMBER OF GTFBCB ON THE WRITE
*                                      Q DIAGNOSTIC AID              */
*      2 WQMAX PTR(31),             /* MOST GTFBCB EVER ON THE WRITE
*                                      Q DIAGNOSTIC AID              */
*      2 EQLENGTH PTR(31),          /* NUMBER OF GTFBCB ON THE EMPTY
*                                      Q                             */
*      2 EQMIN PTR(31),             /* LEAST NUMBER OF BUFFERS EVER
*                                      ON THE EMPTY QUEUE DIAGNOSTIC
*                                      AID                           */
*      2 SLESUSED PTR(31),          /* TOTAL NUMBER OF SLE EVER USED
*                                      DIAGNOSTIC AID                */
*      2 SBUFDISA PTR(31),          /* NUMBER OF TIMES AHLSBUF     0007
*                                      DISABLED DUE TO NULL EMPTY  0007
*                                      QUEUE DIAGNOSTIC AID          */
*      2 NUMOFBUF PTR(31),          /* TOTAL NUMBER OF BUFFERS     0007
*                                      PROCESSED BY WRITER DIAGNOSTIC
*                                      AID                           */
*      2 WRTDLST PTR(31),           /* THE ADDRESS OF A LIST FORM  0007
*                                      SDUMP MACRO TO BE USED BY ALL
*                                      THE WRITER-STACK SEVICE ERROR
*                                      RTNS                          */
*      2 RQTOTAL PTR(31),           /* THE TOTAL NUMBER OF GTFBCB  0007
*                                      THAT WERE PUT ON THE RELEASE
*                                      QUEUE DIAGNOSTIC AID          */
*      2 RQPURGE PTR(31),           /* THE NUMBER OF TIMES THE WRITER
*                                      PURGED THE RELEASE QUEUE    0007
*                                      DIAGNOSTIC AID                */
*      2 SLECNT PTR(31),            /* THE NUMBER OF SLE ON THE SLE
*                                      QUEUE THAT ARE IN USE       0007
*                                      DIAGNOSTIC AID                */
*      2 SLEMAX PTR(31),            /* THIS CONTAINS THE COUNT OF THE
*                                      MOST SLE THAT WERE IN USE AT
*                                      ONE TIME DIAGNOSTIC AID       */
*      2 EQSHORT PTR(31),           /* COUNT OF THE NUMBER OF TIMES
*                                      THE TRACE WRITER HAS FOUND  0007
*                                      THAT THE EMPTY QUEUE WAS LESS
*                                      THAN THE MINIMUM RESERVE    0007
*                                      GTFBCB.                       */
*      2 AUDITFLG CHAR(4),          /* AUDIT FLAGS USED BY THE     0007
*                                      WRITERS ALSO ERROR FLAGS SET
*                                      BY ANY WRITER-STACK SERVICE 0007
*                                      RTN TO INDICATE THE ERROR     */
*       3 AFIWRIT BIT(1),           /* SET TO INDICATE THAT AHLIWRIT
*                                      IS THE TRACE WRITER ATTACHED  */
*       3 AFCWRIT BIT(1),           /* SET TO INDICATE THAT AHLCWRIT
*                                      IS THE TRACE WRITER ATTACHED  */
*       3 AFWWRIT BIT(1),           /* SET TO INDICATE THAT AHLWWRIT
*                                      IS THE TRACE WRITER ATTACHED  */
*       3 AFINIT BIT(1),            /* ON DURING INITIALIZATION OF 0007
*                                      THE THE TRACE WRITER          */
*       3 AFTERM BIT(1),            /* SET DURING THE FINAL STAGES OF
*                                      WRITER TERMINATION, AFTER THE
*                                      DATA FLUSHING IS OVER         */
*       3 AFWAIT BIT(1),            /* SET WHILE THE WRITER IS IN THE
*                                      WAIT STATE                    */
*       3 AFGMSRB BIT(1),           /* SET WHILE THE SRB FOR AHLSBUF
*                                      IS BEING GOTTEN               */
*       3 AFGMBLOK BIT(1),          /* SET WHILE GTFBLOK ARE BEING 0007
*                                      GOTTEN                        */
*       3 AFOPEN BIT(1),            /* SET WHILE THE DEVTYPE AND OPEN
*                                      ARE BEING DONE ON THE TRACE DD*/
*       3 AFCLOSE BIT(1),           /* SET WHILE THE TRACE DATASET IS
*                                      BEING CLOSED                  */
*       3 AFLDFX BIT(1),            /* SET WHILE AHLSBLOK, AHLSFEOB,
*                                      & AHLSBUF ARE BEING LOADED OR
*                                      FIXED                         */
*       3 AFBUFOFF BIT(1),          /* SET WHILE THE WRITER IS     0007
*                                      ENGAGED IN CODE FOR THE     0007
*                                      PURPOSE OF REMOVING GTFBCB  0007
*                                      FROM THE WRITER QUEUE         */
*       3 AFWRAP BIT(1),            /* SET WHEN THE WRITER IS      0007
*                                      RESETTING BSAM TO THE       0007
*                                      BEGINNING OF THE DA DATASET   */
*       3 AFPGRLSE BIT(1),          /* SET WHILE THE WRITER IS     0007
*                                      PURGING THE RELEASE QUEUE     */
*       3 AFEQFIX BIT(1),           /* SET WHILE THE WRITER IS     0007
*                                      GETTING ANOTHER PAGE OF GTFBCB
*                                      TO PUT ON THE EMPTY QUEUE     */
*       3 AFBLKFIX BIT(1),          /* SET WHILE THE WRITER IS TRYING
*                                      TO REPLACE A GTFBLOK THAT HAS
*                                      A BLOKUSE WHICH WILL PROBALBLY
*                                      NOT GO TO ZERO                */
*       3 AFFEOB BIT(1),            /* SET WHEN THE WRITER CALLS   0007
*                                      AHLSFEOB TO PURGE THE GTFBLOK */
*       3 AFBUFGET BIT(1),          /* SET WHENEVER THE WRITER IS  0007
*                                      GETTING GTFBCB & GTFBUFR      */
*       3 AFSLEGET BIT(1),          /* SET WHEN THE WRITER IS GETTING
*                                      THE SLE                       */
*       3 AFQLWAIT BIT(1),          /* SET WHILE THE TRACE WRITER IS
*                                      WAITING FOR THE QLOCK         */
*       3 AFXWRIT BIT(1),           /* SET WHILE THE AHLXWRIT      0007
*                                      SUBROUTINE IS RUNNING         */
*       3 TERMFLAG BIT(1),          /* SET WHEN IT IS DETECTED THAT
*                                      THE TRMWRIT ECB HAS BEEN    0007
*                                      POSTED. IF THIS IS SET ALL  0007
*                                      FGBR ACTIVITY HAS BEEN QUIESED*/
*       3 WSERFLAG BIT(1),                                         0007
*       3 WSERFG02 BIT(1),          /* SET BY AHLSFRR IF THE TRACE IS
*                                      BEING TERMINATED BECAUSE OF AN
*                                      ERROR IN AHLSBUF              */
*       3 WSERFG03 BIT(1),          /* SET BY AHLSBFRR IF THE TRACE
*                                      IS BEING TERMINATED BECAUSE OF
*                                      AN ERROR IN AHLSBLOK OR     0007
*                                      AHLSFEOB                      */
*       3 WSERFG04 BIT(1),          /* SET BY THE WRITER IF THE TRACE
*                                      IS BEING TERMINATED BECAUSE OF
*                                      A CRONIC GTFBLOK PROBLEM      */
*       3 WSERFG05 BIT(1),          /* SET BY AHLWSTAE WHEN IT IS  0007
*                                      ENTERED                       */
*       3 WSERFG06 BIT(1),          /* SET BY                        */
*       3 AFSLEBLD BIT(1),          /* SET BY AHLSBUF WHILE EXECUTING
*                                      CODE TO SUPPORT AHLREADR      */
*       3 * BIT(3),                 /* RESERVED FOR TRACE WRITER USE */
*      2 GTFASCB PTR(31),           /* ADDRESS OF ASCB FOR GTF       */
*      2 TRANSMAX PTR(31),          /* THIS IS THE MAX NUMBER OF   0007
*                                      AHLRDPL EVER ON THE AHLRDPLQ
*                                      AT ONE TIME                   */
*      2 PCTDMPMD PTR(31),          /* ADDRESS OF THE GTF          0007
*                                      SDUMP-TAKING ROUTINE          */
*      2 PCTWTOMD PTR(31);          /* ADDRESS OF THE GTF WTO      0007
*                                      ROUTINE, USED TO WRITE ERROR
*                                      MESSAGES                    0007
*                                                                    */
*                                                                  0008
*/*                                                                  */
*/*      COMMUNICATION VECTOR TABLE                                  */
*/*                                                                  */
*/*      OS/VS1 RELEASE 3, OS/VS2 RELEASE 2, 09/07/73, LEVEL=31      */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*      PL/S - DCL CVTPTR PTR                                       */
*/*      BAL  - DSECT=YES SHOULD BE SPECIFIED ON MACRO CALL EXCEPT   */
*/*             WHEN CALLED DURING SYSGEN TO CREATE CSECT.  CVT FOR  */
*/*             OS/VS2 IS MAPPED UNLESS SYS=AOS1 IS SPECIFIED.  THE  */
*/*             PREFIX IS NOT MAPPED UNLESS PREFIX=YES IS SPECIFIED. */
*/*             A USING ON CVTMAP OR DSECT NAME WILL ESTABLISH       */
*/*             ADDRESSABILITY FOR ALL SYMBOLS EXCEPT IN THE 2       */
*/*             EXTENSIONS.  TO ESTABLISH ADDRESSABILITY FOR THE     */
*/*             OS - OS/VS COMMON EXTENSION, YOU SHOULD CODE         */
*/*                                                                  */
*/*             L     REG,CVTEXT1                                    */
*/*             USING CVTXTNT1,REG                                   */
*/*                                                                  */
*/*             TO ESTABLISH ADDRESSABILITY FOR THE OS/VS1 - OS/VS2  */
*/*             COMMON EXTENSION, YOU SHOULD CODE                    */
*/*                                                                  */
*/*             L     REG,CVTEXT2                                    */
*/*             USING CVTXTNT2,REG                                   */
*/*                                                                  */
*/*             WHERE REG IN EITHER CASE IS ANY REGISTER OTHER       */
*/*             THAN ZERO.                                           */
*/*                                                                  */
*/*             WHEN LISTING IS SUPPRESSED, YOU CAN DETERMINE WHICH  */
*/*             DSECT A SYMBOL IS IN BY USING THE STATEMENT NUMBER   */
*/*             IN THE DEFN COLUMN IN THE CROSS REFERENCE LISTING.   */
*/*             FOR EXAMPLE, ANY SYMBOL DEFINED BETWEEN THE          */
*/*             STATEMENT NUMBERS FOR CVTXTNT1 AND CVTXTNT2 IS IN    */
*/*             THE OS - OS/VS COMMON EXTENSION.                     */
*/*                                                                  */
*/*  F.E.'S                                                          */
*/*      MICROFICHE LISTING - CVT                                    */
*/*                                                                  */
*/*  DEVELOPERS                                                      */
*/*      BAL LISTING  - SPECIFY LIST=YES ON MACRO CALL               */
*/*      PL/S LISTING - SPECIFY %IHALIST='YES' BEFORE INCLUDE        */
*/*                                                                  */
*/*      FOR INTEGRATION, A LISTING MUST NOT BE REQUESTED UNLESS     */
*/*      YOUR MODULE CREATES THE CSECT.                              */
*                                                                  0008
*                                                                  0008
*/*                    CVT PROPER                                    */
*                                                                  0008
*   DECLARE                                                        0008
*     1 CVTMAP BASED(CVTPTR) BDY(WORD),                            0008
*      2 CVT CHAR(0) BDY(WORD),     /* BEGINNING OF CVT MDC150       */
*      2 CVTTCBP PTR(31),           /* ADDRESS OF A DOUBLE WORD, THE
*                                      FIRST CONTAINING THE NEXT-TO-
*                                      BE-DISPATCHED TCB ADDRESS. THE
*                                      SECOND CONTAINING THE LAST  0008
*                                      (CURRENT) TCB ADDRESS. BOTH 0008
*                                      WORDS ARE IDENTICAL UNLESS THE
*                                      TASK GOES INTO A WAIT STATE.
*                                      WHEN IN A WAIT STATE, THE   0008
*                                      FIRST WORD IS SET TO ZERO   0008
*                                      UNTIL THE WAITING IS OVER AND
*                                      THEN BOTH WORDS ARE ONCE AGAIN
*                                      IDENTICAL. (OS/VS1) ADDRESS OF
*                                      4-WORD LIST OF ADDRESSES - THE
*                                      NEXT TCB, THE CURRENT TCB, THE
*                                      NEXT ASCB AND THE CURRENT   0008
*                                      ASCB, IN THAT ORDER (OS/VS2)
*                                      MDC026                        */
*      2 CVT0EF00 PTR(31),          /* ADDRESS OF ROUTINE TO SCHEDULE
*                                      ASYNCHRONOUS EXITS            */
*      2 CVTLINK PTR(31),           /* ADDRESS OF DCB FOR          0008
*                                      SYS1.LINKLIB DATA SET         */
*      2 CVTJOB PTR(31),            /* ADDRESS OF QUEUE MANAGER    0008
*                                      RESIDENT DATA AREA (QMRES)  0008
*                                      (OS/VS1) (MDC083)       XM4042*/
*      2 CVTBUF PTR(31),            /* ADDRESS OF THE BUFFER OF THE
*                                      RESIDENT CONSOLE INTERRUPT  0008
*                                      ROUTINE                       */
*      2 CVTXAPG PTR(31),           /* ADDRESS OF I/O SUPERVISOR   0008
*                                      APPENDAGE VECTOR TABLE        */
*      2 CVT0VL00 PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      TASK SUPERVISOR'S ADDRESS   0008
*                                      VALIDITY CHECKING ROUTINE     */
*      2 CVTPCNVT PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      ROUTINE WHICH CONVERTS A    0008
*                                      RELATIVE TRACK ADDRESS (TTR)
*                                      TO AN ABSOLUTE TRACK ADDRESS
*                                      (MBBCCHHR)                    */
*      2 CVTPRLTV PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      ROUTINE WHICH CONVERTS AN   0008
*                                      ABSOLUTE TRACK ADDRESS      0008
*                                      (MBBCCHHR) TO A RELATIVE TRACK
*                                      ADDRESS (TTR)                 */
*      2 CVTILK1 PTR(31),           /* ADDRESS OF THE CHANNEL AND  0008
*                                      CONTROL UNIT PORTION OF THE 0008
*                                      UCB LOOKUP TABLE              */
*      2 CVTILK2 PTR(31),           /* ADDRESS OF THE UCB HALFWORD 0008
*                                      ADDRESS LIST PORTION OF THE 0008
*                                      UCB LOOKUP TABLE              */
*      2 CVTXTLER PTR(31),          /* ADDRESS OF ENTRY POINT OF AN
*                                      XCTL ROUTINE THAT BRINGS    0008
*                                      SYSTEM ERROR ROUTINES INTO THE
*                                      ERROR TRANSIENT AREA          */
*      2 CVTSYSAD PTR(31),          /* ADDRESS OF THE SYSTEM       0008
*                                      RESIDENCE VOLUME ENTRY IN THE
*                                      UCB LOOKUP TABLE              */
*      2 CVTBTERM PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      ABTERM ROUTINE                */
*      2 CVTDATE CHAR(4) BDY(WORD), /* CURRENT DATE IN PACKED DECIMAL*/
*      2 CVTMSLT PTR(31),           /* ADDRESS OF THE MASTER COMMON
*                                      AREA IN MASTER SCHEDULER    0008
*                                      RESIDENT DATA AREA. NOTE - USE
*                                      CVTMSER INSTEAD TO ADDRESS  0008
*                                      MASTER SCHEDULER RESIDENT DATA
*                                      AREA.                         */
*      2 CVTZDTAB PTR(31),          /* ADDRESS OF I/O DEVICE       0008
*                                      CHARACTERISTIC TABLE          */
*      2 CVTXITP PTR(31),           /* ADDRESS OF ERROR INTERPRETER
*                                      ROUTINE                       */
*      2 CVTDAR PTR(31),            /* SAME AS CVTDARA BELOW (OS/VS1)
*                                      MDC029                        */
*       3 CVTFLGS1 BIT(8),          /* FLAG BYTE (OS/VS1) MDC030     */
*        4 CVTDMPLK BIT(1),         /* SVC DUMP IS IN PROGRESS     0008
*                                      (OS/VS1) MDC030               */
*        4 CVTRSV01 BIT(1),         /* RESERVED                      */
*        4 CVTRSV02 BIT(1),         /* RESERVED                      */
*        4 CVTRSV03 BIT(1),         /* RESERVED                      */
*        4 CVTRSV04 BIT(1),         /* RESERVED                      */
*        4 CVTRSV05 BIT(1),         /* RESERVED                      */
*        4 CVTRSV06 BIT(1),         /* RESERVED                      */
*        4 CVTRSV07 BIT(1),         /* RESERVED                      */
*       3 CVTDARA PTR(24),          /* ADDRESS OF THE SYS1.DUMP I/O
*                                      CONTROL BLOCKS NEEDED BY    0008
*                                      ABEND'S DAMAGE ASSESSMENT   0008
*                                      ROUTINE (DAR) (OS/VS1) MDC029 */
*      2 CVT0FN00 PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      FINCH ROUTINE (OS/VS1)        */
*      2 CVTEXIT CHAR(2) BDY(WORD), /* AN SVC 3 INSTRUCTION. EXIT TO
*                                      DISPATCHER.                   */
*      2 CVTBRET CHAR(2) BDY(WORD,3),/* A BCR 15,14 INSTRUCTION.   0008
*                                      RETURN TO CALLER (USED BY DATA
*                                      MANAGEMENT ROUTINES)          */
*      2 CVTSVDCB PTR(31),          /* ADDRESS OF THE DCB FOR THE  0008
*                                      SYS1.SVCLIB DATA SET          */
*      2 CVTTPC PTR(31),            /* ADDRESS OF THE TIMER        0008
*                                      SUPERVISOR WORK AREA          */
*      2 CVTPBLDL PTR(31),          /* ADDRESS OF BRANCH AND LINK  0008
*                                      (BALR) ENTRY POINT OF THE BLDL
*                                      ROUTINE (OS/VS1) MDC103       */
*      2 CVTSJQ PTR(31),            /* ADDRESS OF THE SELECTED JOB 0008
*                                      QUEUE (OS/VS1)                */
*      2 CVTCUCB PTR(31),           /* ADDRESS OF THE TABLE THAT   0008
*                                      CONTAINS THE CURRENT CONSOLE
*                                      UCB ADDRESSES                 */
*      2 CVTQTE00 PTR(31),          /* ADDRESS OF THE TIMER ENQUEUE
*                                      ROUTINE FOR INTERVAL TIMER    */
*      2 CVTQTD00 PTR(31),          /* ADDRESS OF THE TIMER DEQUEUE
*                                      ROUTINE FOR INTERVAL TIMER    */
*      2 CVTSTB PTR(31),            /* ADDRESS OF THE I/O DEVICE   0008
*                                      STATISTICS TABLE              */
*      2 CVTDCB CHAR(1) BDY(WORD),  /* OPERATING SYSTEM CONFIGURATION*/
*        4 CVTRSV08 BIT(1),         /* RESERVED                      */
*        4 CVT1SSS BIT(1),          /* PCP                           */
*        4 CVT2SPS BIT(1),          /* MFT, OS/VS1                   */
*        4 CVT4MS1 BIT(1),          /* MVT, OS/VS2                   */
*        4 CVTRSV09 BIT(1),         /* RESERVED                      */
*        4 CVT4MPS BIT(1),          /* MODEL 65 MULTIPROCESSING      */
*        4 CVT6DAT BIT(1),          /* DYNAMIC ADDRESS TRANSLATION BY
*                                      CPU (OS/VS1, OS/VS2)          */
*        4 CVTMVS2 BIT(1),          /* MULTIPLE MEMORY OPTION OF   0008
*                                      OS/VS2 IS PRESENT MDC131      */
*      2 CVTDCBA PTR(24),           /* ADDRESS OF THE DCB FOR THE  0008
*                                      SYS1.LOGREC (OUTBOARD       0008
*                                      RECORDER) DATA SET FOR SYSTEM
*                                      ENVIRONMENT RECORDING (SER)   */
*      2 CVTIOQET PTR(31),          /* ADDRESS OF IOS REQUEST ELEMENT
*                                      TABLE (OS/VS1) MDC020         */
*      2 CVTIXAVL PTR(31),          /* ADDRESS OF THE I/O          0008
*                                      SUPERVISOR'S FREELIST POINTER
*                                      WHICH CONTAINS THE ADDRESS OF
*                                      THE NEXT REQUEST ELEMENT    0008
*                                      (OS/VS1) ADDRESS OF THE I/O 0008
*                                      SUPERVISOR'S COMMUNICATION  0008
*                                      AREA (IOCOM) (OS/VS2)         */
*      2 CVTNUCB PTR(31),           /* LOWEST ADDRESS NOT IN THE   0008
*                                      NUCLEUS (ON PAGE BOUNDARY)    */
*      2 CVTFBOSV PTR(31),          /* ADDRESS OF PROGRAM FETCH    0008
*                                      ROUTINE                       */
*      2 CVT0DS PTR(31),            /* ADDRESS OF ENTRY POINT OF THE
*                                      DISPATCHER                    */
*      2 CVTILCH PTR(31),           /* ADDRESS OF THE LOGICAL CHANNEL
*                                      WORD TABLE                    */
*      2 CVTIERLC PTR(31),          /* ADDRESS OF THE ASYNCHRONOUS 0008
*                                      EXIT QUEUE                    */
*      2 CVTMSER PTR(31),           /* ADDRESS OF DATA AREA OF MASTER
*                                      SCHEDULER RESIDENT DATA AREA  */
*      2 CVT0PT01 PTR(31),          /* ADDRESS OF BRANCH ENTRY POINT
*                                      OF POST ROUTINE               */
*      2 CVTRSV11 PTR(31),          /* ** CVTTRMTB FIELD UNUSED IN 0008
*                                      OS/VS **                      */
*      2 CVTHEAD PTR(31),           /* ADDRESS OF THE HIGHEST      0008
*                                      PRIORITY TCB IN THE READY   0008
*                                      QUEUE (OS/VS1) MDC025         */
*      2 CVTMZ00 PTR(31),           /* HIGHEST ADDRESS IN VIRTUAL  0008
*                                      STORAGE FOR THE MACHINE       */
*      2 CVT1EF00 PTR(31),          /* ADDRESS OF ROUTINE WHICH    0008
*                                      CREATES IRB'S FOR EXITS       */
*      2 CVTQOCR PTR(31),           /* GRAPHICS INTERFACE TASK (GFX)
*                                      FIELD. ADDRESS OF SEVENTH WORD
*                                      OF GFX PARAMETER LIST, IF GFX
*                                      IS ACTIVE. ZERO IF GFX IS NOT
*                                      ACTIVE.                       */
*      2 CVTQMWR PTR(31),           /* ADDRESS OF QUEUE MANAGER'S  0008
*                                      SYSTEM OUTPUT COMMUNICATIONS-
*                                      DATA-AREA (CDA), WHICH IS   0008
*                                      STORED ON AN EXTERNAL DEVICE  */
*      2 CVTSNCTR FIXED(15),        /* SERIAL NUMBER COUNTER FOR   0008
*                                      ASSIGNING SERIAL NUMBERS TO 0008
*                                      NON-SPECIFIC, UNLABELED     0008
*                                      MAGNETIC TAPE VOLUMES         */
*      2 CVTOPTA CHAR(1),           /* OPTION INDICATORS             */
*       3 CVTCCH BIT(1),            /* CHANNEL CHECK HANDLER (CCH) 0008
*                                      OPTION PRESENT - RECOVERY   0008
*                                      MANAGEMENT SUPPORT (RMS)    0008
*                                                              XM4686*/
*       3 CVTAPR BIT(1),            /* ALTERNATE PATH RETRY (APR)  0008
*                                      OPTION PRESENT - RECOVERY   0008
*                                      MANAGEMENT SUPPORT (RMS)      */
*       3 CVTDDR BIT(1),            /* DYNAMIC DEVICE RECONFIGURATION
*                                      (DDR) OPTION PRESENT -      0008
*                                      RECOVERY MANAGEMENT SUPPORT 0008
*                                      (RMS) (OS/VS1) DDR          0008
*                                      SYSTEM-INITIATED SWAP ACTIVE
*                                      (OS/VS2) MDC126               */
*       3 CVTNIP BIT(1),            /* NIP IS EXECUTING              */
*       3 CVTRSV12 BIT(1),          /* RESERVED                      */
*       3 CVTRSV13 BIT(1),          /* RESERVED                      */
*       3 CVTASCII BIT(1),          /* ASCII TAPE PROCESSING IS    0008
*                                      GENERATED IN THIS SYSTEM      */
*       3 CVTXPFP BIT(1),           /* CPU HAS EXTENDED PRECISION  0008
*                                      FLOATING POINT FEATURE        */
*      2 CVTOPTB CHAR(1),           /* MISCELLANEOUS FLAGS           */
*       3 CVTPROT BIT(1),           /* CPU HAS STORE PROTECTION    0008
*                                      FEATURE (OS/VS1)              */
*       3 CVTCTIMS BIT(1),          /* IF ON, HARDWARE HAS THE CLOCK
*                                      COMPARATOR AND CPU TIMER    0008
*                                      FEATURE INSTALLED, AND OS/VS1
*                                      SYSGEN HAS SPECIFIED THIS   0008
*                                      FEATURE (OS/VS1) MDC127       */
*       3 CVTTOD BIT(1),            /* CPU HAS TIME-OF-DAY CLOCK   0008
*                                      FEATURE                       */
*       3 CVTNLOG BIT(1),           /* SYS1.LOGREC IS UNAVAILABLE FOR
*                                      ERROR RECORDING. ALWAYS SET TO
*                                      ZERO FOR OS/VS1 ICB382        */
*       3 CVTAPTHR BIT(1),          /* NIP SETS THIS BIT TO 1 WHEN 0008
*                                      DEVICE TESTING IS COMPLETE. IF
*                                      1, I/O SUPERVISOR USES AN   0008
*                                      ALTERNATE PATH TO A DEVICE  0008
*                                      WHEN A CONDITION CODE OF 3  0008
*                                      EXISTS. THIS BIT IS RESET BY
*                                      NIP TO 0 AFTER THE LINK PACK
*                                      AREA IS INITIALIZED.    YM2670*/
*       3 CVTFP BIT(1),             /* CPU HAS FETCH PROTECTION    0008
*                                      FEATURE (OS/VS1) ICB427       */
*       3 CVTRSV16 BIT(1),          /* RESERVED                      */
*       3 CVTRSV17 BIT(1),          /* RESERVED                      */
*      2 CVTQCDSR PTR(31),          /* CDE SEARCH ROUTINE ADDRESS  0008
*                                      (OS/VS2) ADDRESS OF THE     0008
*                                      ROUTINE THAT SEARCHES THE   0008
*                                      REENTERABLE LOAD MODULE QUEUE
*                                      (OS/VS1)                      */
*      2 CVTQLPAQ PTR(31),          /* ADDRESS OF POINTER TO MOST  0008
*                                      RECENT ENTRY ON LINK PACK AREA
*                                      CDE QUEUE (OS/VS2) ADDRESS OF
*                                      THE REENTERABLE LOAD MODULE 0008
*                                      QUEUE (OS/VS1)                */
*      2 CVTRSV18 PTR(31),          /* ** CVTMPCVT FIELD UNUSED IN 0008
*                                      OS/VS **                      */
*      2 CVTSMCA PTR(31),           /* ADDRESS OF THE SYSTEM       0008
*                                      MANAGEMENT CONTROL AREA (SMCA)
*                                      IF THE SYSTEM MANAGEMENT    0008
*                                      FACILITIES (SMF) OPTION IS  0008
*                                      PRESENT IN THE SYSTEM.      0008
*                                      OTHERWISE, ZERO.              */
*      2 CVTABEND PTR(31),          /* ADDRESS OF SECONDARY CVT FOR
*                                      ABEND IN EOT (OS/VS2) USED BY
*                                      AN INTERNAL ABEND TRACE     0008
*                                      ROUTINE FOR DEBUG PURPOSES  0008
*                                      (OS/VS1)                XM0615*/
*      2 CVTUSER PTR(31),           /* A WORD AVAILABLE TO THE USER  */
*      2 CVTMDLDS PTR(31),          /* RESERVED FOR MODEL-DEPENDENT
*                                      SUPPORT                       */
*      2 CVTQABST CHAR(2) BDY(WORD),/* AN SVC 13 (ABEND) INSTRUCTION
*                                      (OS/VS2) RESERVED (OS/VS1)    */
*      2 CVTLNKSC CHAR(2) BDY(WORD,3),/* AN SVC 6 (LINK) INSTRUCTION
*                                      ICB369                        */
*      2 CVTTSCE PTR(31),           /* ADDRESS OF THE FIRST TIME   0008
*                                      SLICE CONTROL ELEMENT (TSCE)  */
*      2 CVTPATCH PTR(31),          /* ADDRESS OF A 200-BYTE FE PATCH
*                                      AREA                          */
*      2 CVTRMS PTR(31),            /* RECOVERY MANAGEMENT SUPPORT 0008
*                                      (RMS) COMMUNICATIONS VECTOR.
*                                      ADDRESS OF A MACHINE STATUS 0008
*                                      BLOCK.                        */
*      2 CVTRV515 PTR(31),          /* ** CVTTSCVT FIELD UNUSED IN 0008
*                                      OS/VS2 REL 2 ** MDC037        */
*      2 CVT0SCR1 PTR(31),          /* ADDRESS OF THE SECTOR       0008
*                                      CALCULATION ROUTINE FOR     0008
*                                      ROTATIONAL POSITION SENSING 0008
*                                      (RPS)                         */
*      2 CVTGTF PTR(31),            /* GENERALIZED TRACE FACILITY  0008
*                                      (GTF) CONTROL WORD ICB312     */
*       3 CVTGTFST BIT(8),          /* GTF FLAG BYTE ICB312          */
*        4 CVTGTFS BIT(2),          /* GTF STATUS (OS/VS1) MDC088    */
*         5 CVTGTFAV BIT(1),        /* IF ZERO, GTF NOT ACTIVE. IF 0008
*                                      ONE, GTF ACTIVE. (OS/VS2)   0008
*                                      MDC098                        */
*         5 CVTRV315 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTSTATE BIT(1),         /* GTF IS IN CONTROL PROCESSING A
*                                      HOOK (OS/VS1) MDC093          */
*         5 CVTRV316 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTTMODE BIT(1),         /* IF 0, MODE=INT SPECIFIED. IF
*                                      1, MODE=EXT SPECIFIED WHICH 0008
*                                      MEANS TRACE DATA IS TO BE   0008
*                                      WRITTEN TO AN EXTERNAL DEVICE.
*                                      (OS/VS1) MDC094               */
*         5 CVTRV317 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTFORM BIT(1),          /* TRACE DATA IS TO BE FORMATTED
*                                      ON ABNORMAL TERMINATION     0008
*                                      (OS/VS1) MDC095               */
*         5 CVTRV318 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTUSR BIT(1),           /* TRACE=USR SPECIFIED.        0008
*                                      USER-REQUESTED TRACE DATA IS
*                                      TO BE INCLUDED IN THE TRACE 0008
*                                      DATA SET. (OS/VS1) MDC096     */
*         5 CVTRV319 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTRNIO BIT(1),          /* GTF IS ACTIVE AND TRACING RNIO
*                                      EVENTS MDC187                 */
*        4 CVTRSV27 BIT(1),         /* RESERVED                      */
*       3 CVTGTFA PTR(24),          /* ADDRESS OF THE MONITOR CALL 0008
*                                      VECTOR TABLE (OS/VS1) ADDRESS
*                                      OF MAIN MONITOR CALL ROUTING
*                                      TABLE, MCHEAD (OS/VS2) MDC156 */
*      2 CVTAQAVT PTR(31),          /* ADDRESS OF THE FIRST WORD OF
*                                      THE TCAM DISPATCHER WHICH   0008
*                                      CONTAINS THE ADDRESS OF THE 0008
*                                      ADDRESS VECTOR TABLE (AVT). IF
*                                      ZERO, TCAM IS NOT STARTED     */
*       3 CVTTCMFG CHAR(1),         /* TCAM FLAGS                    */
*        4 CVTTCRDY BIT(1),         /* TCAM IS READY TO ACCEPT USERS */
*        4 CVTRSV28 BIT(1),         /* RESERVED                      */
*        4 CVTRSV29 BIT(1),         /* RESERVED                      */
*        4 CVTRSV30 BIT(1),         /* RESERVED                      */
*        4 CVTRSV31 BIT(1),         /* RESERVED                      */
*        4 CVTRSV32 BIT(1),         /* RESERVED                      */
*        4 CVTRSV33 BIT(1),         /* RESERVED                      */
*        4 CVTRSV34 BIT(1),         /* RESERVED                      */
*       3 CVTAQAVB PTR(24),         /* SAME AS CVTAQAVT ABOVE        */
*      2 CVTVOLM2 PTR(31),          /* RESERVED POINTER (OS/VS2)   0008
*                                      MDC192                        */
*       3 CVTTATA PTR(31),          /* ADDRESS OF THE FIRST ENTRY IN
*                                      THE TCB ADDRESS TABLE. THE  0008
*                                      FIRST ENTRY IS FOR PARTITION
*                                      0. (OS/VS1)                   */
*        4 CVTTSKS PTR(8),          /* MAXIMUM ALLOWABLE NUMBER OF 0008
*                                      ENTRIES IN THE TCB ADDRESS  0008
*                                      TABLE (OS/VS1)                */
*         5 CVTVOLF2 BIT(8),        /* RESERVED INITIALIZATION BYTE
*                                      (OS/VS2) MDC202               */
*          6 CVTVOLI2 BIT(1),       /* RESERVED INITIALIZATION FLAG
*                                      (OS/VS2) MDC203               */
*        4 CVTTAT PTR(24),          /* SAME AS CVTTATA ABOVE         */
*         5 CVTVOLT2 PTR(24),       /* RESERVED PARAMETER (OS/VS2) 0008
*                                      MDC204                        */
*      2 CVTATER PTR(31),           /* ADDRESS OF THE SYSTEM ERROR 0008
*                                      TCB. THE PURGE ROUTINE USES 0008
*                                      THIS FIELD TO ACCESS THE SIRB.
*                                      (OS/VS1) ICB346               */
*       3 CVTSYST PTR(8),           /* NUMBER OF ENTRIES IN THE TCB
*                                      ADDRESS TABLE FOR TCB'S     0008
*                                      CREATED DURING SYSTEM       0008
*                                      GENERATION (OS/VS1)           */
*       3 CVTATERA PTR(24),         /* SAME AS CVTATER ABOVE         */
*      2 CVTEXT1 PTR(31),           /* ADDRESS OF OS - OS/VS COMMON
*                                      EXTENSION ICB421              */
*      2 CVTCBSP PTR(31),           /* ADDRESS OF ACCESS METHOD    0008
*                                      CONTROL BLOCK STRUCTURE MDC195*/
*      2 CVTPURG PTR(31),           /* ADDRESS OF SUBSYSTEM PURGE  0008
*                                      ROUTINE ICB330                */
*       3 CVTRSV35 PTR(8),          /* RESERVED ICB330               */
*       3 CVTPURGA PTR(24),         /* ADDRESS OF SUBSYSTEM PURGE  0008
*                                      ROUTINE ICB330                */
*      2 CVTAMFF CHAR(4),           /* RESERVED FOR ACCESS METHOD  0008
*                                      FLAGS ICB436                  */
*      2 CVTQMSG PTR(31),           /* ADDRESS OF INFORMATION TO BE
*                                      PRINTED BY ABEND ICB307       */
*       3 CVTRSV36 PTR(8),          /* RESERVED ICB307               */
*       3 CVTQMSGA PTR(24),         /* ADDRESS OF INFORMATION TO BE
*                                      PRINTED BY ABEND ICB307       */
*      2 CVTDMSR PTR(31),           /* SAME AS CVTDMSRA BELOW ICB346 */
*       3 CVTRSV37 PTR(8),          /* RESERVED ICB346               */
*       3 CVTDMSRA PTR(24),         /* ADDRESS OF THE OPEN/CLOSE/EOV
*                                      SUPERVISORY ROUTINE IN THE  0008
*                                      NUCLEUS. THIS ROUTINE HANDLES
*                                      THE ROUTING OF CONTROL AMONG
*                                      THE I/O SUPPORT ROUTINES.   0008
*                                      ICB346                        */
*      2 CVTRSV38 PTR(31),          /* RESERVED                      */
*      2 CVTRSV39 PTR(31),          /* RESERVED                      */
*/*            OS/VS1 - OS/VS2 COMMON SECTION                        */
*                                                                  0008
*      2 CVTREAL PTR(31),           /* ADDRESS OF THE VIRTUAL STORAGE
*                                      BYTE FOLLOWING THE HIGHEST  0008
*                                      VIRTUAL=REAL STORAGE ADDRESS
*                                      ICB368                        */
*      2 CVTPTRV PTR(31),           /* ADDRESS OF PAGING SUPERVISOR
*                                      GENERAL ROUTINE TO TRANSLATE
*                                      REAL ADDRESSES TO VIRTUAL   0008
*                                      ADDRESSES                     */
*      2 CVTMODE PTR(31),           /* ADDRESS OF ROUTINE TO CHANGE
*                                      SYSTEM MASK                   */
*      2 CVTJESCT PTR(31),          /* ADDRESS OF JOB ENTRY SUBSYSTEM
*                                      (JES) CONTROL TABLE           */
*      2 CVTJEPS PTR(31),           /* ADDRESS OF JOB ENTRY        0008
*                                      PERIPHERAL SERVICES (JEPS)  0008
*                                      MONITOR TCB (OS/VS1)    YM2702*/
*      2 CVTTZ FIXED(31),           /* DIFFERENCE BETWEEN LOCAL TIME
*                                      AND GREENWICH MEAN TIME IN  0008
*                                      BINARY UNITS OF 1.048576    0008
*                                      SECONDS                       */
*      2 CVTMCHPR PTR(31),          /* ADDRESS OF MACHINE CHECK    0008
*                                      PARAMETER LIST                */
*      2 CVTEORM PTR(31),           /* HIGHEST REAL ADDRESS IN MAIN
*                                      STORAGE (OS/VS1) POTENTIAL  0008
*                                      REAL HIGH STORAGE ADDRESS   0008
*                                      (OS/VS2) MDC087               */
*      2 CVTERPV PTR(31),           /* ADDRESS OF I/O SUPERVISOR   0008
*                                      SUBROUTINE TO CONVERT CCW DATA
*                                      ADDRESSES TO VIRTUAL ADDRESSES
*                                      ICB367                        */
*      2 CVTINTLA PTR(31),          /* ADDRESS OF A TIME INTERVAL. 0008
*                                      I/O LOAD BALANCING COUNTS THE
*                                      NUMBER OF EXCP'S ISSUED DURING
*                                      THIS TIME INTERVAL AND USES 0008
*                                      THE VALUE IN DETERMINING THE
*                                      AMOUNT OF I/O ACTIVITY IN THE
*                                      SYSTEM. ICB341                */
*      2 CVTAPF PTR(31),            /* SAME AS CVTAPFA BELOW ICB360  */
*       3 CVTRSV40 PTR(8),          /* RESERVED ICB360               */
*       3 CVTAPFA PTR(24),          /* ADDRESS OF BRANCH ENTRY POINT
*                                      IN AUTHORIZED PROGRAM FACILITY
*                                      (APF) ROUTINE                 */
*      2 CVTEXT2 PTR(31),           /* ADDRESS OF OS/VS1 - OS/VS2  0008
*                                      COMMON EXTENSION ICB330       */
*       3 CVTRSV41 PTR(8),          /* RESERVED ICB330               */
*       3 CVTEXT2A PTR(24),         /* SAME AS CVTEXT2 ABOVE ICB330  */
*      2 CVTHJES PTR(31),           /* SAME AS CVTHJESA BELOW ICB454 */
*       3 CVTRSV42 PTR(8),          /* RESERVED ICB454               */
*       3 CVTHJESA PTR(24),         /* ADDRESS OF OPTIONAL JOB ENTRY
*                                      SUBSYSTEM (JES) COMMUNICATION
*                                      VECTOR TABLE ICB454           */
*      2 CVTRSV43 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV44 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV45 PTR(31),          /* RESERVED                      */
*      2 CVTRSV46 PTR(31),          /* RESERVED                      */
*/*            OS/VS1 OVERLAY                                        */
*                                                                  0008
*      2 CVTPGSIA PTR(31),          /* ADDRESS OF PAGING SUPERVISOR
*                                      INFORMATION AREA              */
*      2 CVTPCVT PTR(31),           /* ADDRESS OF PAGED CVT EXTENSION*/
*      2 CVTA1F1 CHAR(1),           /* PAGE FAULT FLAGS              */
*       3 CVTPFSW BIT(1),           /* ONLY THE PAGING TASK MAY BE 0008
*                                      DISPATCHED                    */
*       3 CVTSRSW BIT(1),           /* NO TASK EXCEPT THE PAGING TASK
*                                      MAY EXECUTE DISABLED CODE     */
*       3 CVTRSV47 BIT(1),          /* RESERVED                      */
*       3 CVTRSV48 BIT(1),          /* RESERVED                      */
*       3 CVTRSV49 BIT(1),          /* RESERVED                      */
*       3 CVTRSV50 BIT(1),          /* RESERVED                      */
*       3 CVTRSV51 BIT(1),          /* RESERVED                      */
*       3 CVTRSV52 BIT(1),          /* RESERVED                      */
*      2 CVTSYSK CHAR(1),           /* SYSTEM LOCK. IF NOT ZERO, ONLY
*                                      THE PAGING TASK MAY BE      0008
*                                      DISPATCHED                    */
*       3 CVTRSV53 BIT(1),          /* RESERVED                      */
*       3 CVTRSV54 BIT(1),          /* RESERVED                      */
*       3 CVTRSV55 BIT(1),          /* RESERVED                      */
*       3 CVTRSV56 BIT(1),          /* RESERVED                      */
*       3 CVTSLKR BIT(1),           /* MACHINE CHECK HANDLING IS IN
*                                      PROGRESS ICB320               */
*       3 CVTSLKQ BIT(1),           /* SYSTEM QUEUE AREA (SQA) HAS 0008
*                                      BEEN EXHAUSTED                */
*       3 CVTSLKP BIT(1),           /* LAST PAGING CONTROL BLOCK   0008
*                                      (PCB) HAS BEEN USED           */
*       3 CVTSLKO BIT(1),           /* A ROUTINE RUNNING DISABLED HAS
*                                      PRODUCED A PAGE FAULT         */
*      2 CVTSULK FIXED(15),         /* SUPERVISOR LOCK. NUMBER OF  0008
*                                      TASKS ATTEMPTING TO EXECUTE 0008
*                                      DISABLED ROUTINES. IF NOT   0008
*                                      ZERO, ONLY ENABLED TASKS MAY
*                                      RUN.                          */
*      2 CVTSMF PTR(31),            /* ADDRESS OF SYSTEM MANAGEMENT
*                                      FACILITIES (SMF) TCB ICB395   */
*      2 CVTPNWFR PTR(31),          /* ADDRESS OF ROUTINE WHICH FREES
*                                      THE 'EMERGENCY' WORK AREA   0008
*                                      (ICB413)                XM2452*/
*      2 CVTDDCE PTR(31),           /* ADDRESS OF DYNAMIC DISPATCHING
*                                      CONTROL ELEMENT ICB466        */
*      2 CVTRSV57 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV58 FIXED(15),        /* RESERVED                      */
*      2 CVTSTOA FIXED(31),         /* SAVE AREA FOR THE REAL STORAGE
*                                      ADDRESS OF THE SEGMENT TABLE
*                                      ORIGIN ICB496                 */
*      2 CVTVOLM1 PTR(31),          /* RESERVED POINTER MDC191       */
*       3 CVTVOLF1 BIT(8),          /* RESERVED INITIALIZATION BYTE
*                                      MDC199                        */
*        4 CVTVOLI1 BIT(1),         /* RESERVED INITIALIZATION FLAG
*                                      MDC200                        */
*       3 CVTVOLT1 PTR(24),         /* RESERVED PARAMETER MDC201     */
*      2 CVTRSV61 PTR(31),          /* RESERVED                      */
*      2 CVTATMCT PTR(31),          /* POINTER TO VTAM CONTROL TABLE
*                                      MDC082                        */
*       3 CVTATMST CHAR(1),         /* VTAM START STATUS MDC135      */
*       3 CVTATMCA PTR(24),         /* POINTER TO VTAM CONTROL TABLE
*                                      MDC138                        */
*      2 CVTAUTH PTR(31),           /* POINTER TO AUTHORIZED LIBRARY
*                                      TABLE MDC188                  */
*      2 CVTRV484 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV485 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV486 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV487 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV488 PTR(31);          /* RESERVED MDC106               */
*/*            OS/VS2 OVERLAY                                        */
*                                                                  0009
*   DECLARE                                                        0009
*     1 CVTS01 DEF(CVTPGSIA) BDY(WORD),                            0009
*      2 CVTGETL PTR(31),           /* ADDRESS OF IKJGETL, TSO GET 0009
*                                      LINE ROUTINE (MDC206)   YM2225*/
*      2 CVTLPDSR PTR(31),          /* ADDRESS OF LINK PACK AREA   0009
*                                      (LPA) DIRECTORY SEARCH ROUTINE*/
*      2 CVTPVTP PTR(31),           /* ADDRESS OF PAGE VECTOR TABLE  */
*      2 CVTLPDIA PTR(31),          /* ADDRESS OF LINK PACK AREA   0009
*                                      (LPA) DIRECTORY (ON PAGE    0009
*                                      BOUNDARY)                     */
*       3 CVTDIRST CHAR(1),         /* FLAG BYTE                     */
*        4 CVTDICOM BIT(1),         /* LPA DIRECTORY HAS BEEN      0009
*                                      INITIALIZED BY NIP            */
*        4 CVTRSV63 BIT(1),         /* RESERVED                      */
*        4 CVTRSV64 BIT(1),         /* RESERVED                      */
*        4 CVTRSV65 BIT(1),         /* RESERVED                      */
*        4 CVTRSV66 BIT(1),         /* RESERVED                      */
*        4 CVTRSV67 BIT(1),         /* RESERVED                      */
*        4 CVTRSV68 BIT(1),         /* RESERVED                      */
*        4 CVTRSV69 BIT(1),         /* RESERVED                      */
*       3 CVTLPDIR PTR(24),         /* ADDRESS OF LPA DIRECTORY. ON
*                                      PAGE BOUNDARY                 */
*      2 CVTRV320 PTR(31),          /* ** CVTPAGE1 FIELD UNUSED IN 0009
*                                      OS/VS2 REL 2 ** MDC112        */
*      2 CVTRV321 PTR(31),          /* ** CVTPGSUP FIELD UNUSED IN 0009
*                                      OS/VS2 REL 2 ** MDC113        */
*      2 CVTSLIDA CHAR(4) BDY(WORD),/* IDENTITY OF TCB CAUSING     0009
*                                      SUPERVISOR LOCK BYTE (CVTSYLK)
*                                      TO BE SET OR IDENTITY OF TCB
*                                      THAT SECOND EXIT PROCESSING IS
*                                      FOR WHEN CVTSEIC=1            */
*       3 CVTSYLK CHAR(1),          /* SUPERVISOR LOCK. ONLY ENABLED
*                                      TASKS MAY BE DISPATCHED       */
*       3 CVTSLID CHAR(3),          /* SAME AS CVTSLIDA ABOVE        */
*      2 CVTRV322 PTR(31),          /* ** CVTSER AND SUBFIELDS UNUSED
*                                      IN OS/VS2 REL 2 **          0009
*                                      MDC114-MDC117                 */
*      2 CVTRV328 PTR(31),          /* ** CVTSEG AND CVTSEGA FIELDS
*                                      UNUSED IN OS/VS2 REL 2 **   0009
*                                      MDC139-MDC140                 */
*      2 CVTRV329 PTR(31),          /* ** CVTSEGB FIELD UNUSED IN  0009
*                                      OS/VS2 REL 2 ** MDC141        */
*      2 CVTRV330 PTR(31),          /* ** CVTSEGC AND SUBFIELDS    0009
*                                      UNUSED IN OS/VS2 REL 2 **   0009
*                                      MDC142-MDC144                 */
*      2 CVTRV331 PTR(31),          /* ** CVTSEGD AND SUBFIELDS    0009
*                                      UNUSED IN OS/VS2 REL 2 **   0009
*                                      MDC145-MDC147                 */
*      2 CVTRSV77 PTR(8),           /* RESERVED                      */
*      2 CVTSPVLK PTR(8),           /* NUMBER OF TASKS WHICH HAVE  0009
*                                      TERMINATED WHILE OWNING     0009
*                                      SUPERVISOR LOCK WITHOUT     0009
*                                      OPERATOR HAVING YET BEEN    0009
*                                      NOTIFIED                      */
*      2 CVTCTLFG CHAR(1),          /* SYSTEM CONTROL FLAGS          */
*       3 CVTRV323 BIT(1),          /* ** CVTPSIC BIT UNUSED IN    0009
*                                      OS/VS2 REL 2 ** MDC118        */
*       3 CVTRV333 BIT(1),          /* ** CVTAPGB BIT UNUSED IN    0009
*                                      OS/VS2 REL 2 ** MDC151        */
*       3 CVTRSV78 BIT(1),          /* RESERVED ICB382               */
*       3 CVTDSTAT BIT(1),          /* DEVSTAT OPTION IN EFFECT.   0009
*                                      DEVICE ADDRESS FOR 2319, 3330,
*                                      2314, 3330-1, 3340 CAN VARY 0009
*                                      ACROSS SYSTEMS MDC189         */
*       3 CVTRSV79 BIT(1),          /* RESERVED                      */
*       3 CVTNOMP BIT(1),           /* MULTIPROCESSING CODE IS NOT IN
*                                      THE SYSTEM MDC176             */
*       3 CVTGTRCE BIT(1),          /* GENERALIZED TRACE FACILITY  0009
*                                      (GTF) HAS SUPPRESSED        0009
*                                      SUPERVISOR TRACE ICB446       */
*       3 CVTSDTRC BIT(1),          /* SVC DUMP HAS SUPPRESSED     0009
*                                      SUPERVISOR TRACE ICB446       */
*      2 CVTAPG CHAR(1),            /* DISPATCHING PRIORITY OF     0009
*                                      AUTOMATIC PRIORITY GROUP (APG)
*                                      ICB339                        */
*      2 CVTTRACE CHAR(2) BDY(WORD),/* BRANCH ON REGISTER          0009
*                                      INSTRUCTION. SET BY NIP.    0009
*                                      REGISTER TEN FOR TRACE.     0009
*                                      REGISTER ELEVEN FOR NO TRACE. */
*      2 CVTTRAC2 CHAR(2) BDY(WORD,3),/* BRANCH ON REGISTER 11     0009
*                                      INSTRUCTION. THIS ALLOWS FOR
*                                      SUPPRESSING TRACE DYNAMICALLY
*                                      BY SETTING CONDITION CODE MASK
*                                      TO ZERO IN FIRST INSTRUCTION
*                                      (CVTTRACE)                    */
*      2 CVTRSCN PTR(31),           /* ADDRESS OF ROUTINE TO SCAN TCB
*                                      TREE                          */
*      2 CVTTAS PTR(31),            /* ADDRESS OF ROUTINE TO TRANSFER
*                                      ADDRESS SPACE                 */
*      2 CVTRV332 PTR(31),          /* ** CVTPVALD FIELD UNUSED IN 0009
*                                      OS/VS2 REL 2 ** MDC148        */
*      2 CVTSHRVM PTR(31),          /* LOWEST ADDRESS OF SHARED    0009
*                                      VIRTUAL STORAGE AREA. THIS  0009
*                                      ADDRESS WILL BE EITHER THE  0009
*                                      BEGINNING OF LINK PACK AREA 0009
*                                      (LPA) DIRECTORY OR THE      0009
*                                      BEGINNING OF LPA UPDATE AREA
*                                      IF 'MLPA' OPTION WAS USED AT
*                                      SUPERVISOR INITIALIZATION.    */
*      2 CVT0VL01 PTR(31),          /* ENTRY POINT ADDRESS OF      0009
*                                      VALIDITY CHECK ROUTINE      0009
*                                      (IEA0VL01) USED TO COMPARE  0009
*                                      PROTECT KEY OF AN ADDRESS WITH
*                                      TCB PROTECT KEY.              */
*      2 CVTRV324 PTR(31),          /* ** CVTPFIXQ FIELD UNUSED IN 0009
*                                      OS/VS2 REL 2 ** MDC119        */
*      2 CVTRV325 PTR(31),          /* ** CVTPFIXR FIELD UNUSED IN 0009
*                                      OS/VS2 REL 2 ** MDC120        */
*      2 CVTRV326 PTR(31),          /* ** CVTPFIXP FIELD UNUSED IN 0009
*                                      OS/VS2 REL 2 ** MDC121        */
*      2 CVTRV327 PTR(31),          /* ** CVTPTCD FIELD UNUSED IN  0009
*                                      OS/VS2 REL 2 ** MDC122        */
*      2 CVTSYSWT PTR(31),          /* ADDRESS OF THE SYSTEM       0009
*                                      MANAGEMENT FACILITIES (SMF) 0009
*                                      SYSTEM WAIT TIME COLLECTION 0009
*                                      AREA ICB469                   */
*      2 CVTPUTL PTR(31),           /* ADDRESS OF IKJPUTL, TSO PUT 0009
*                                      LINE ROUTINE (MDC207)   YM2225*/
*      2 CVTSRBRT PTR(31),          /* DISPATCHER RETURN ADDRESS FOR
*                                      SRB ROUTINES MDC130           */
*      2 CVTOLT0A PTR(31),          /* BRANCH ENTRY TO OLTEP MEMORY
*                                      TERMINATION RESOURCE MANAGER
*                                      MDC129                        */
*      2 CVTSMFEX PTR(31),          /* BRANCH ENTRY TO SYSTEM      0009
*                                      MANAGEMENT FACILITIES (SMF) 0009
*                                      EXCP COUNTING ROUTINE FOR VAM
*                                      WINDOW INTERCEPT MDC133       */
*      2 CVTCSPIE PTR(31),          /* FOR CHECKPOINT/RESTART, BRANCH
*                                      ENTRY TO SPIE MDC149          */
*      2 CVTPTGT PTR(31),           /* ADDRESS OF IKJPTGT, TSO PUTGET
*                                      ROUTINE (MDC208)        YM2225*/
*      2 CVTIOSPL PTR(8),           /* PRIORITY LEVEL OF I/O       0009
*                                      SUPERVISOR CHANNEL SCHEDULER
*                                      MDC019                        */
*      2 CVTRV513 CHAR(1),          /* RESERVED MDC165               */
*      2 CVTDSSAC CHAR(1),          /* DYNAMIC SUPPORT SYSTEM (DSS)
*                                      ACTIVATED FLAG - USED BY    0009
*                                      RESTART FLIH. IF X'00', DSS 0009
*                                      NOT INITIALIZED. IF X'FF', DSS
*                                      HAS BEEN INITIALIZED. MDC163  */
*      2 CVTRV139 PTR(8),           /* RESERVED                      */
*      2 CVTSTCK PTR(31),           /* ADDRESS OF IKJSTCK, TSO STACK
*                                      ROUTINE (MDC209)        YM2225*/
*      2 CVTMAXMP PTR(15),          /* FOR MEASUREMENT FACILITY    0009
*                                      (MF/1), MAXIMUM PHYSICAL CPU
*                                      ADDRESS SUPPORTED BY THIS   0009
*                                      RELEASE MDC165                */
*      2 CVTRV144 FIXED(15),        /* RESERVED                      */
*      2 CVTSCAN PTR(31),           /* ADDRESS OF IKJSCAN, TSO SCAN
*                                      ROUTINE (MDC210)        YM2225*/
*      2 CVTAUTHL PTR(31),          /* POINTER TO AUTHORIZED LIBRARY
*                                      TABLE MDC001                  */
*      2 CVTBLDCP PTR(31),          /* BRANCH ENTRY TO BUILD POOL  0009
*                                      MDC003                        */
*      2 CVTGETCL PTR(31),          /* BRANCH ENTRY TO GET CELL    0009
*                                      MDC004                        */
*      2 CVTFRECL PTR(31),          /* BRANCH ENTRY TO FREE CELL   0009
*                                      MDC005                        */
*      2 CVTDELCP PTR(31),          /* BRANCH ENTRY TO DELETE POOL 0009
*                                      MDC006                        */
*      2 CVTCRMN PTR(31),           /* BRANCH ENTRY TO SVC 120     0009
*                                      (GETMAIN/FREEMAIN:CRBRANCH) 0009
*                                      MDC007                        */
*      2 CVTCRAS PTR(31),           /* BRANCH ENTRY TO 'CREATE     0009
*                                      ADDRESS SPACE' MDC008         */
*      2 CVTQSAS PTR(31),           /* BRANCH ENTRY TO TASK        0009
*                                      TERMINATION MDC009            */
*      2 CVTFRAS PTR(31),           /* BRANCH ENTRY TO FREE ADDRESS
*                                      SPACE MDC010                  */
*      2 CVTS1EE PTR(31),           /* BRANCH ENTRY TO STAGE 1 EXIT
*                                      EFFECTOR MDC011               */
*      2 CVTPARS PTR(31),           /* ADDRESS OF IKJPARS, TSO PARSE
*                                      ROUTINE (MDC211)        YM2225*/
*      2 CVTQUIS PTR(31),           /* BRANCH ENTRY TO QUIESCE MDC013*/
*      2 CVTSTXU PTR(31),           /* BRANCH ENTRY TO ATTENTION EXIT
*                                      EPILOGUE MDC014               */
*      2 CVTOPTE PTR(31),           /* BRANCH ENTRY ADDRESS TO     0009
*                                      SYSEVENT MDC015               */
*      2 CVTSDRM PTR(31),           /* BRNACH ENTRY ADDRESS OF THE 0009
*                                      RESOURCE MANAGER ROUTINE FOR
*                                      SVC DUMP. THIS ROUTINE CAN BE
*                                      INVOKED BY MEMORY TERMINATION
*                                      MDC077                        */
*      2 CVTIOSCS PTR(31),          /* ENTRY POINT OF I/O SUPERVISOR
*                                      CHANNEL SCHEDULER MDC018      */
*      2 CVTAQTOP PTR(31),          /* POINTER TO AREA CONTAINING  0009
*                                      QUIESCE DESCRIPTOR BLOCK    0009
*                                      (QDB'S) FOR DEVICE ALLOCATION
*                                      MDC021                        */
*      2 CVTVVMDI PTR(31),          /* CONSTANT USED BY PAGED LINK 0009
*                                      PACK AREA (LPA) DIRECTORY   0009
*                                      SEARCH ALGORITHM MDC022       */
*      2 CVTASVT PTR(31),           /* POINTER TO ADDRESS SPACE    0009
*                                      VECTOR TABLE (ASVT) MDC070    */
*      2 CVTGDA PTR(31),            /* POINTER TO GLOBAL DATA AREA 0009
*                                      (GDA) IN SQA MDC024           */
*      2 CVTASCBH PTR(31),          /* POINTER TO HIGHEST PRIORITY 0009
*                                      ADDRESS SPACE CONTROL BLOCK 0009
*                                      (ASCB) ON THE ASCB DISPATCHING
*                                      QUEUE MDC027                  */
*      2 CVTASCBL PTR(31),          /* POINTER TO LOWEST PRIORITY  0009
*                                      ASCB ON ASCB DISPATCHING QUEUE
*                                      MDC028                        */
*      2 CVTRTMCT PTR(31),          /* POINTER TO                  0009
*                                      RECOVERY/TERMINATION CONTROL
*                                      TABLE MDC031                  */
*      2 CVTSV60 PTR(31),           /* ADDRESS OF SVC 60 BRANCH ENTRY
*                                      POINT USED BY TYPE 2, 3, 4, 0009
*                                      SVC'S MDC032                  */
*      2 CVTSDMP PTR(31),           /* ADDRESS OF SVC DUMP BRANCH  0009
*                                      ENTRY POINT MDC033            */
*      2 CVTSCBP PTR(31),           /* ADDRESS OF SCB PURGE RESOURCE
*                                      MANAGER MDC034                */
*      2 CVTSDBF PTR(31),           /* ADDRESS OF 4K SQA BUFFER USED
*                                      BY SVC DUMP. HIGH ORDER BIT OF
*                                      THIS CVT WORD IS USED AS LOCK
*                                      TO INDICATE BUFFER IS IN USE
*                                      MDC035                        */
*      2 CVTRTMS PTR(31),           /* RTM1 INTERNAL SERVICABILITY 0009
*                                      LEVEL INDICATOR MDC036        */
*      2 CVTTPIOS PTR(31),          /* ADDRESS OF THE TELEPROCESSING
*                                      I/O SUPERV1SOR ROUTINE (TPIOS)
*                                      MDC078                        */
*      2 CVTSIC PTR(31),            /* BRANCH ENTRY ADDRESS OF THE 0009
*                                      ROUTINE TO SCHEDULE SYSTEM  0009
*                                      INITIALIZED CANCEL MDC042     */
*      2 CVTOPCTP PTR(31),          /* ADDRESS OF SYSTEM RESOURCES 0009
*                                      MANAGER (SRM) CONTROL TABLE 0009
*                                      MDC043                        */
*      2 CVTEXPRO PTR(31),          /* ADDRESS OF EXIT PROLOGUE/TYPE
*                                      1 EXIT MDC044                 */
*      2 CVTGSMQ PTR(31),           /* ADDRESS OF GLOBAL SERVICE   0009
*                                      MANAGER QUEUE MDC045          */
*      2 CVTLSMQ PTR(31),           /* ADDRESS OF LOCAL SERVICE    0009
*                                      MANAGER QUEUE MDC046          */
*      2 CVTGSPL PTR(31),           /* ADDRESS OF GLOBAL SYSTEM    0009
*                                      PRIORITY LIST QUEUE MDC047    */
*      2 CVTVWAIT PTR(31),          /* ADDRESS OF WAIT ROUTINE MDC048*/
*      2 CVTPARRL PTR(31),          /* ADDRESS OF PARTIALLY LOADED 0009
*                                      DELETE QUEUE MDC049           */
*      2 CVTAPFT PTR(31),           /* ADDRESS OF AUTHORIZED PROGRAM
*                                      FACILITY (APF) TABLE.       0009
*                                      INITIALIZED BY NIP. MDC050    */
*      2 CVTQCS01 PTR(31),          /* BRANCH ENTRY ADDRESS TO     0009
*                                      PROGRAM MANAGER USED BY ATTACH
*                                      MDC051                        */
*      2 CVTFQCB PTR(31),           /* POINTER TO FIRST MAJOR QCB FOR
*                                      ENQ MDC052                    */
*      2 CVTLQCB PTR(31),           /* POINTER TO LAST MAJOR QCB FOR
*                                      ENQ MDC053                    */
*      2 CVTRENQ PTR(31),           /* RESOURCE MANAGER ADDRESS FOR
*                                      ENQ MDC054                    */
*      2 CVTRSPIE PTR(31),          /* RESOURCE MANAGER FOR SPIE   0009
*                                      MDC055                        */
*      2 CVTLKRMA PTR(31),          /* RESOURCE MANAGER ADDRESS FOR
*                                      LOCK MANAGER MDC056           */
*      2 CVTCSD PTR(31),            /* VIRTUAL ADDRESS OF COMMON   0009
*                                      SYSTEM DATA AREA (CSD).     0009
*                                      INITIALIZED BY NIP. MDC057    */
*      2 CVTDQIQE PTR(31),          /* RESOURCE MANAGER FOR EXIT   0009
*                                      EFFECTORS MDC058              */
*      2 CVTRPOST PTR(31),          /* RESOURCE MANAGER FOR POST   0009
*                                      MDC059                        */
*      2 CVT062R1 PTR(31),          /* BRANCH ENTRY TO DETACH MDC060 */
*      2 CVTVEAC0 PTR(31),          /* ASCBCHAP BRANCH ENTRY MDC061  */
*      2 CVTGLMN PTR(31),           /* GLOBAL BRANCH ENTRY ADDRESS 0009
*                                      FOR GETMAIN/FREEMAIN MDC062   */
*      2 CVTSPSA PTR(31),           /* POINTER TO GLOBAL WORK/SAVE 0009
*                                      AREA VECTOR TABLE (WSAG)    0009
*                                      MDC071                        */
*      2 CVTWSAL PTR(31),           /* ADDRESS OF TABLE OF LENGTHS OF
*                                      LOCAL WORK/SAVE AREAS MDC072  */
*      2 CVTWSAG PTR(31),           /* ADDRESS OF TABLE OF LENGTHS OF
*                                      GLOBAL WORK/SAVE AREAS MDC073 */
*      2 CVTWSAC PTR(31),           /* ADDRESS OF TABLE OF LENGTHS OF
*                                      CPU WORK/SAVE AREAS MDC074    */
*      2 CVTRECRQ PTR(31),          /* ADDRESS OF THE RECORDING    0009
*                                      REQUEST FACILITY (PART OF RTM1
*                                      - CALLED BY RTM2 AND RMS)   0009
*                                      MDC075                        */
*      2 CVTASMVT PTR(31),          /* POINTER TO AUXILIARY STORAGE
*                                      MANAGEMENT VECTOR TABLE (AMVT)
*                                      MDC076                        */
*      2 CVTIOBP PTR(31),           /* ADDRESS OF THE BLOCK PROCESSOR
*                                      CVT MDC079                    */
*      2 CVTSPOST PTR(31),          /* POST RESOURCE MANAGER       0009
*                                      TERMINATION ROUTINE (RMTR)  0009
*                                      ENTRY POINT MDC085            */
*      2 CVTRSTWD FIXED(31),        /* RESTART RESOURCE MANAGEMENT 0009
*                                      WORD - CONTAINS IDENTIFIER OF
*                                      USER IF RESTART IS IN USE.  0009
*                                      OTHERWISE, ZERO. MDC161       */
*      2 CVTFETCH PTR(31),          /* ADDRESS OF ENTRY POINT FOR  0009
*                                      BASIC FETCH MDC196            */
*      2 CVT044R2 PTR(31),          /* ADDRESS OF IGC044R2 IN CHAP 0009
*                                      SERVICE ROUTINE MDC197        */
*      2 CVTPERFM PTR(31),          /* ADDRESS OF THE PERFORMANCE  0009
*                                      WORK AREA. SET BY IGX00018. 0009
*                                      MDC205                        */
*      2 CVTDAIR PTR(31),           /* ADDRESS OF IKJDAIR, TSO     0009
*                                      DYNAMIC ALLOCATION INTERFACE
*                                      ROUTINE (MDC212)        YM2225*/
*      2 CVTEHDEF PTR(31),          /* ADDRESS OF IKJEHDEF, TSO    0009
*                                      DEFAULT SERVICE ROUTINE     0009
*                                      (MDC213)                YM2225*/
*      2 CVTEHCIR PTR(31),          /* ADDRESS OF IKJEHCIR, TSO    0009
*                                      CATALOG INFORMATION ROUTINE 0009
*                                      (MDC214)                YM2225*/
*      2 CVTSSAP PTR(31),           /* ADDRESS OF SYSTEM SAVE AREA 0009
*                                      MDC063                        */
*      2 CVTAIDVT PTR(31),          /* POINTER TO APPENDAGE ID VECTOR
*                                      TABLE MDC064                  */
*      2 CVTIPCDS PTR(31),          /* BRANCH ENTRY FOR DIRECT SIGNAL
*                                      SERVICE ROUTINE MDC065        */
*      2 CVTIPCRI PTR(31),          /* BRANCH ENTRY FOR REMOTE     0009
*                                      IMMEDIATE SIGNAL SERVICE    0009
*                                      ROUTINE MDC066                */
*      2 CVTIPCRP PTR(31),          /* BRANCH ENTRY FOR REMOTE     0009
*                                      PENDABLE SIGNAL SERVICE     0009
*                                      ROUTINE MDC067                */
*      2 CVTPCCAT PTR(31),          /* POINTER TO PHYSICAL CCA VECTOR
*                                      TABLE MDC068                  */
*      2 CVTLCCAT PTR(31),          /* POINTER TO LOGICAL CCA VECTOR
*                                      TABLE MDC069                  */
*      2 CVTRV210 BIT(8),           /* RESERVED                      */
*       3 CVTRV211 BIT(1),          /* RESERVED                      */
*       3 CVTRV212 BIT(1),          /* RESERVED                      */
*       3 CVTRV213 BIT(1),          /* RESERVED                      */
*       3 CVTRV214 BIT(1),          /* RESERVED                      */
*       3 CVTRV215 BIT(1),          /* RESERVED                      */
*       3 CVTRV216 BIT(1),          /* RESERVED                      */
*       3 CVTRV217 BIT(1),          /* RESERVED                      */
*       3 CVTRV218 BIT(1),          /* RESERVED                      */
*      2 CVTRV219 BIT(8),           /* RESERVED                      */
*       3 CVTRV220 BIT(1),          /* RESERVED                      */
*       3 CVTRV221 BIT(1),          /* RESERVED                      */
*       3 CVTRV222 BIT(1),          /* RESERVED                      */
*       3 CVTRV223 BIT(1),          /* RESERVED                      */
*       3 CVTRV224 BIT(1),          /* RESERVED                      */
*       3 CVTRV225 BIT(1),          /* RESERVED                      */
*       3 CVTRV226 BIT(1),          /* RESERVED                      */
*       3 CVTRV227 BIT(1),          /* RESERVED                      */
*      2 CVTRV228 BIT(8),           /* RESERVED                      */
*       3 CVTRV229 BIT(1),          /* RESERVED                      */
*       3 CVTRV230 BIT(1),          /* RESERVED                      */
*       3 CVTRV231 BIT(1),          /* RESERVED                      */
*       3 CVTRV232 BIT(1),          /* RESERVED                      */
*       3 CVTRV233 BIT(1),          /* RESERVED                      */
*       3 CVTRV234 BIT(1),          /* RESERVED                      */
*       3 CVTRV235 BIT(1),          /* RESERVED                      */
*       3 CVTRV236 BIT(1),          /* RESERVED                      */
*      2 CVTRV237 BIT(8),           /* RESERVED                      */
*       3 CVTRV238 BIT(1),          /* RESERVED                      */
*       3 CVTRV239 BIT(1),          /* RESERVED                      */
*       3 CVTRV240 BIT(1),          /* RESERVED                      */
*       3 CVTRV241 BIT(1),          /* RESERVED                      */
*       3 CVTRV242 BIT(1),          /* RESERVED                      */
*       3 CVTRV243 BIT(1),          /* RESERVED                      */
*       3 CVTRV244 BIT(1),          /* RESERVED                      */
*       3 CVTRV245 BIT(1),          /* RESERVED                      */
*      2 CVTRV246 PTR(8),           /* RESERVED                      */
*      2 CVTRV247 PTR(8),           /* RESERVED                      */
*      2 CVTRV248 PTR(8),           /* RESERVED                      */
*      2 CVTRV249 PTR(8),           /* RESERVED                      */
*      2 CVTRV250 PTR(8),           /* RESERVED                      */
*      2 CVTRV251 PTR(8),           /* RESERVED                      */
*      2 CVTRV252 PTR(15),          /* RESERVED                      */
*      2 CVTRV253 FIXED(15),        /* RESERVED                      */
*      2 CVTRV254 FIXED(15),        /* RESERVED                      */
*      2 CVTPWI PTR(31),            /* ADDRESS OF THE WINDOW       0009
*                                      INTERCEPT ROUTINE MDC104      */
*      2 CVTPVBP PTR(31),           /* ADDRESS OF THE VIRTUAL BLOCK
*                                      PROCESSOR MDC105              */
*      2 CVTMFCTL PTR(31),          /* POINTER TO MEASUREMENT      0009
*                                      FACILITY CONTROL BLOCK MDC100 */
*      2 CVTMFRTR PTR(31),          /* IF MEASUREMENT FACILITY IS  0009
*                                      ACTIVE, CONTAINS ADDRESS OF 0009
*                                      MEASUREMENT FACILITY ROUTER.
*                                      OTHERWISE, ADDRESS OF CVTBRET.
*                                      MDC101                        */
*       3 CVTMFACT BIT(1),          /* IF ONE, I/O SUPERVISOR AND  0009
*                                      TIMER SECOND LEVEL INTERRUPT
*                                      HANDLER HOOKS BRANCH TO     0009
*                                      MEASUREMENT FACILITY ROUTER 0009
*                                      MDC102                        */
*      2 CVTVPSIB PTR(31),          /* BRANCH ENTRY TO PAGE SERVICES
*                                      MDC108                        */
*      2 CVTVSI PTR(31),            /* BRANCH ENTRY TO VAM SERVICES
*                                      MDC109                        */
*      2 CVTVFP PTR(31),            /* BRANCH ENTRY TO FINDPAGE    0009
*                                      MDC110                        */
*      2 CVTRV262 BIT(8),           /* RESERVED                      */
*       3 CVTRV263 BIT(1),          /* RESERVED                      */
*       3 CVTRV264 BIT(1),          /* RESERVED                      */
*       3 CVTRV265 BIT(1),          /* RESERVED                      */
*       3 CVTRV266 BIT(1),          /* RESERVED                      */
*       3 CVTRV267 BIT(1),          /* RESERVED                      */
*       3 CVTRV268 BIT(1),          /* RESERVED                      */
*       3 CVTRV269 BIT(1),          /* RESERVED                      */
*       3 CVTRV270 BIT(1),          /* RESERVED                      */
*      2 CVTRV271 BIT(8),           /* RESERVED                      */
*       3 CVTRV272 BIT(1),          /* RESERVED                      */
*       3 CVTRV273 BIT(1),          /* RESERVED                      */
*       3 CVTRV274 BIT(1),          /* RESERVED                      */
*       3 CVTRV275 BIT(1),          /* RESERVED                      */
*       3 CVTRV276 BIT(1),          /* RESERVED                      */
*       3 CVTRV277 BIT(1),          /* RESERVED                      */
*       3 CVTRV278 BIT(1),          /* RESERVED                      */
*       3 CVTRV279 BIT(1),          /* RESERVED                      */
*      2 CVTRV280 BIT(8),           /* RESERVED                      */
*       3 CVTRV281 BIT(1),          /* RESERVED                      */
*       3 CVTRV282 BIT(1),          /* RESERVED                      */
*       3 CVTRV283 BIT(1),          /* RESERVED                      */
*       3 CVTRV284 BIT(1),          /* RESERVED                      */
*       3 CVTRV285 BIT(1),          /* RESERVED                      */
*       3 CVTRV286 BIT(1),          /* RESERVED                      */
*       3 CVTRV287 BIT(1),          /* RESERVED                      */
*       3 CVTRV288 BIT(1),          /* RESERVED                      */
*      2 CVTRV289 BIT(8),           /* RESERVED                      */
*       3 CVTRV290 BIT(1),          /* RESERVED                      */
*       3 CVTRV291 BIT(1),          /* RESERVED                      */
*       3 CVTRV292 BIT(1),          /* RESERVED                      */
*       3 CVTRV293 BIT(1),          /* RESERVED                      */
*       3 CVTRV294 BIT(1),          /* RESERVED                      */
*       3 CVTRV295 BIT(1),          /* RESERVED                      */
*       3 CVTRV296 BIT(1),          /* RESERVED                      */
*       3 CVTRV297 BIT(1),          /* RESERVED                      */
*      2 CVTRV298 PTR(8),           /* RESERVED                      */
*      2 CVTRV299 PTR(8),           /* RESERVED                      */
*      2 CVTRV300 PTR(8),           /* RESERVED                      */
*      2 CVTRV301 PTR(8),           /* RESERVED                      */
*      2 CVTRV302 PTR(15),          /* RESERVED                      */
*      2 CVTRV303 PTR(15),          /* RESERVED                      */
*      2 CVTRV304 FIXED(15),        /* RESERVED                      */
*      2 CVTRV305 FIXED(15),        /* RESERVED                      */
*      2 CVTRV306 FIXED(15),        /* RESERVED                      */
*      2 CVTRV307 FIXED(15),        /* RESERVED                      */
*      2 CVTVIOP PTR(31),           /* ENTRY POINT OF PAGE I/O POST
*                                      MDC111                        */
*      2 CVTRMBR PTR(31),           /* ADDRESS OF REGMAIN BRANCH   0009
*                                      ENTRY MDC123                  */
*      2 CVTLFRM PTR(31),           /* LIST FORMAT FREEMAIN BRANCH 0009
*                                      ENTRY POINT MDC124            */
*      2 CVTGMBR PTR(31),           /* LIST FORMAT GETMAIN BRANCH  0009
*                                      ENTRY POINT MDC125            */
*      2 CVT0TC0A PTR(31),          /* ADDRESS OF TASK CLOSE MODULE
*                                      IFG0TC0A MDC128               */
*      2 CVTRLSTG FIXED(31),        /* SIZE OF ACTUAL REAL STORAGE 0009
*                                      ONLINE AT IPL TIME IN 'K'.  0009
*                                      VALUE PLACED HERE BY IEAVNIP0.
*                                      MDC153                        */
*      2 CVTSPFRR PTR(31),          /* 'SUPER FRR' ADDRESS (ADDRESS
*                                      OF FUNCTIONAL RECOVERY ROUTINE
*                                      ESTABLISHED AT NIP0 TIME TO 0009
*                                      PROTECT SUPERVISOR CONTROL  0009
*                                      PROGRAM) MDC154               */
*      2 CVTVEMS0 PTR(31),          /* ADDRESS OF MEMORY SWITCH    0009
*                                      ROUTINE MDC155                */
*      2 CVTJRECM PTR(31),          /* ADDRESS OF SUBSYSTEM INTERFACE
*                                      RESOURCE MANAGER MDC157       */
*      2 CVTIRECM PTR(31),          /* ADDRESS OF INITIATOR RESOURCE
*                                      MANAGER MDC158                */
*      2 CVTDARCM PTR(31),          /* ADDRESS OF DEVICE ALLOCATION
*                                      RESOURCE MANAGER MDC159       */
*      2 CVT0PT02 PTR(31),          /* ADDRESS OF POST ENTRY POINT 0009
*                                      IEA0PT02 MDC160               */
*      2 CVTSTPRS PTR(31),          /* ENTRY POINT OF STOP AND     0009
*                                      RESTART SUBROUTINE MDC162     */
*      2 CVTWTCB PTR(31),           /* ADDRESS OF WAIT STATE TCB   0009
*                                      MDC164                        */
*      2 CVTVACR PTR(31),           /* ACR/VARY CPU CHANNEL RECOVERY
*                                      ROUTINE ADDRESS. ADDRESS    0009
*                                      FILLED IN BY VARY CPU       0009
*                                      PROCESSOR. MDC178             */
*      2 CVTQUIT PTR(31),           /* VARY CPU SHUTDOWN ROUTINE   0009
*                                      ADDRESS. ADDRESS FILLED IN BY
*                                      VARY CPU PROCESSOR. MDC179    */
*      2 CVTGTFR8 PTR(31),          /* GENERALIZED TRACE FACILITY  0009
*                                      (GTF) CONTROL REGISTER 8    0009
*                                      INITIALIZATION ROUTINE ADDRESS
*                                      MDC180                        */
*      2 CVTVSTOP PTR(31),          /* ADDRESS OF VARY CPU STOP CPU
*                                      ROUTINE MDC169                */
*      2 CVTVPSA PTR(31),           /* ADDRESS OF COPY OF SYSGEN'ED
*                                      PSA - PLACED HERE BY NIP    0009
*                                      MDC170                        */
*      2 CVTRMPTT PTR(31),          /* ADDRESS OF ISTRAMA1, THE    0009
*                                      RESOURCE MANAGER FOR NORMAL 0009
*                                      AND ABNORMAL TASK TERMINATION
*                                      MDC171                        */
*      2 CVTRMPMT PTR(31),          /* ADDRESS OF ISTRAMA2, THE    0009
*                                      RESOURCE MANAGER FOR NORMAL 0009
*                                      AND ABNORMAL MEMORY         0009
*                                      TERMINATION MDC172            */
*      2 CVTEXP1 PTR(31),           /* ADDRESS OF EXIT PROLOGUE WHICH
*                                      RETURNS TO THE DISPATCHER   0009
*                                      MDC173                        */
*      2 CVTCSDRL PTR(31),          /* REAL ADDRESS OF COMMON SYSTEM
*                                      DATA AREA (CSD). INITIALIZED
*                                      BY NIP. MDC174                */
*      2 CVTSSRB PTR(31),           /* STATUS STOP SRB ENTRY MDC175  */
*      2 CVTRPT PTR(31),            /* ADDRESS OF IGARPT01 MODULE OF
*                                      RADIX PARTITION TREE SERVICES.
*                                      INITIALIZED BY NIP. MDC177    */
*      2 CVTQV1 PTR(31),            /* ADDRESS OF QUEUE VERIFICATION
*                                      FOR SINGLE THREADED QUEUES  0009
*                                      WITH HEADERS ONLY MDC181      */
*      2 CVTQV2 PTR(31),            /* ADDRESS OF QUEUE VERIFICATION
*                                      FOR SINGLE THREADED QUEUES  0009
*                                      WITH HEADER AND TRAILER MDC182*/
*      2 CVTQV3 PTR(31),            /* ADDRESS OF QUEUE VERIFICATION
*                                      FOR DOUBLE THREADED QUEUES  0009
*                                      MDC183                        */
*      2 CVTGSDA PTR(31),           /* ADDRESS OF GLOBAL SYSTEM    0009
*                                      DUPLEX AREA. ADDRESS FILLED IN
*                                      BY NIP0. MDC184               */
*       3 CVTGSDAB BIT(1),          /* IF HIGH-ORDER BIT IS ONE,   0009
*                                      THERE IS A VALID VALUE IN   0009
*                                      FOLLOWING 31 BITS MDC185      */
*      2 CVTADV PTR(31),            /* ADDRESS OF ADDRESS          0009
*                                      VERIFICATION ROUTINE MDC186   */
*      2 CVTTPIO PTR(31);           /* ADDRESS OF VTAM TPIO (SVC 124)
*                                      ROUTINE MDC193                */
*/*                                                                  */
*/*            OS - OS/VS COMMON EXTENSION                           */
*/*                                                                  */
*                                                                  0010
*   DECLARE                                                        0010
*     1 CVTXTNT1 BASED(CVTEXT1),    /* START OF OS - OS/VS COMMON  0010
*                                      EXTENSION ICB421              */
*      2 CVTFACHN PTR(31),          /* ADDRESS OF CHAIN OF DCB FIELD
*                                      AREAS (ISAM) ICB421           */
*      2 CVTRSV87 PTR(31),          /* RESERVED                      */
*      2 CVTRSV88 PTR(31);          /* RESERVED                      */
*/*                                                                  */
*/*            OS/VS1 - OS/VS2 COMMON EXTENSION                      */
*/*                                                                  */
*                                                                  0011
*   DECLARE                                                        0011
*     1 CVTXTNT2 BASED(CVTEXT2),    /* START OF OS/VS1 - OS/VS2    0011
*                                      EXTENSION                     */
*      2 CVTDSSV PTR(31),           /* ADDRESS OF THE DYNAMIC SUPPORT
*                                      SYSTEM (DSS) VECTOR TABLE   0011
*                                      ICB313                        */
*       3 CVTRSV89 PTR(8),          /* RESERVED ICB313               */
*       3 CVTDSSVA PTR(24),         /* ADDRESS OF THE DSS VECTOR   0011
*                                      TABLE ICB313                  */
*      2 CVTNUCLS CHAR(1),          /* IDENTIFICATION OF THE NUCLEUS
*                                      MEMBER NAME ICB322            */
*      2 CVTRSV90 BIT(8),           /* RESERVED                      */
*       3 CVTRSV9A BIT(1),          /* RESERVED                      */
*       3 CVTRSV9B BIT(1),          /* RESERVED                      */
*       3 CVTRSV9C BIT(1),          /* RESERVED                      */
*       3 CVTRSV9D BIT(1),          /* RESERVED                      */
*       3 CVTRSV9E BIT(1),          /* RESERVED                      */
*       3 CVTRSV9F BIT(1),          /* RESERVED                      */
*       3 CVTRSV9G BIT(1),          /* RESERVED                      */
*       3 CVTRSV9H BIT(1),          /* RESERVED                      */
*      2 CVTRSV91 FIXED(15),        /* RESERVED                      */
*      2 CVTDEBVR PTR(31),          /* ADDRESS OF BRANCH ENTRY POINT
*                                      OF DEB VALIDITY CHECK ROUTINE
*                                      (ICB380)                XM9028*/
*      2 CVTRSV92 PTR(31),          /* RESERVED (MDC190)       YM2278*/
*      2 CVTRSV93 PTR(31),          /* RESERVED                      */
*      2 CVTRSV94 PTR(31),          /* RESERVED                      */
*      2 CVTQID PTR(31),            /* SAVE AS CVTQIDA BELOW ICB381  */
*       3 CVTRSV95 PTR(8),          /* RESERVED ICB381               */
*       3 CVTQIDA PTR(24),          /* ADDRESS OF QUEUE            0011
*                                      IDENTIFICATION (QID) TABLE  0011
*                                      PREFIX ICB381                 */
*      2 CVTOLTEP PTR(31),          /* POINTER TO CONTROL BLOCK    0011
*                                      CREATED BY SVC 59 TO POINT TO
*                                      PSEUDO-DEB'S ICB423           */
*      2 CVTRSV96 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV97 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV98 PTR(31),          /* RESERVED                      */
*      2 CVTRSV99 PTR(31),          /* RESERVED                      */
*      2 CVTRSVA0 PTR(31),          /* RESERVED                      */
*      2 CVTRSVA1 PTR(31),          /* RESERVED                      */
*      2 CVTRV400 BIT(8),           /* RESERVED                      */
*       3 CVTRV401 BIT(1),          /* RESERVED                      */
*       3 CVTRV402 BIT(1),          /* RESERVED                      */
*       3 CVTRV403 BIT(1),          /* RESERVED                      */
*       3 CVTRV404 BIT(1),          /* RESERVED                      */
*       3 CVTRV405 BIT(1),          /* RESERVED                      */
*       3 CVTRV406 BIT(1),          /* RESERVED                      */
*       3 CVTRV407 BIT(1),          /* RESERVED                      */
*       3 CVTRV408 BIT(1),          /* RESERVED                      */
*      2 CVTRV409 BIT(8),           /* RESERVED                      */
*       3 CVTRV410 BIT(1),          /* RESERVED                      */
*       3 CVTRV411 BIT(1),          /* RESERVED                      */
*       3 CVTRV412 BIT(1),          /* RESERVED                      */
*       3 CVTRV413 BIT(1),          /* RESERVED                      */
*       3 CVTRV414 BIT(1),          /* RESERVED                      */
*       3 CVTRV415 BIT(1),          /* RESERVED                      */
*       3 CVTRV416 BIT(1),          /* RESERVED                      */
*       3 CVTRV417 BIT(1),          /* RESERVED                      */
*      2 CVTRV418 PTR(8),           /* RESERVED                      */
*      2 CVTRV419 PTR(8),           /* RESERVED                      */
*      2 CVTRV420 PTR(15),          /* RESERVED                      */
*      2 CVTRV421 FIXED(15),        /* RESERVED                      */
*      2 CVTRV422 FIXED(15),        /* RESERVED                      */
*      2 CVTRV423 FIXED(15),        /* RESERVED                      */
*      2 CVTATCVT PTR(31),          /* POINTER TO VTAM'S CVT MDC080  */
*       3 CVTATACT BIT(1),          /* IF ON, VTAM IS ACTIVE MDC081  */
*      2 CVTRV425 PTR(31),          /* RESERVED                      */
*      2 CVTRV426 PTR(31),          /* RESERVED                      */
*      2 CVTRV427 PTR(31),          /* RESERVED                      */
*      2 CVTRV428 FIXED(31),        /* RESERVED                      */
*      2 CVTRV429 BIT(8),           /* RESERVED                      */
*       3 CVTRV430 BIT(1),          /* RESERVED                      */
*       3 CVTRV431 BIT(1),          /* RESERVED                      */
*       3 CVTRV432 BIT(1),          /* RESERVED                      */
*       3 CVTRV433 BIT(1),          /* RESERVED                      */
*       3 CVTRV434 BIT(1),          /* RESERVED                      */
*       3 CVTRV435 BIT(1),          /* RESERVED                      */
*       3 CVTRV436 BIT(1),          /* RESERVED                      */
*       3 CVTRV437 BIT(1),          /* RESERVED                      */
*      2 CVTRV438 BIT(8),           /* RESERVED                      */
*       3 CVTRV439 BIT(1),          /* RESERVED                      */
*       3 CVTRV440 BIT(1),          /* RESERVED                      */
*       3 CVTRV441 BIT(1),          /* RESERVED                      */
*       3 CVTRV442 BIT(1),          /* RESERVED                      */
*       3 CVTRV443 BIT(1),          /* RESERVED                      */
*       3 CVTRV444 BIT(1),          /* RESERVED                      */
*       3 CVTRV445 BIT(1),          /* RESERVED                      */
*       3 CVTRV446 BIT(1),          /* RESERVED                      */
*      2 CVTRV447 PTR(8),           /* RESERVED                      */
*      2 CVTRV448 PTR(8),           /* RESERVED                      */
*      2 CVTRV449 PTR(15),          /* RESERVED                      */
*      2 CVTRV450 FIXED(15),        /* RESERVED                      */
*      2 CVTRV451 FIXED(15),        /* RESERVED                      */
*      2 CVTRV452 FIXED(15),        /* RESERVED                      */
*      2 CVTRV453 PTR(31),          /* RESERVED                      */
*      2 CVTRV454 PTR(31),          /* RESERVED                      */
*      2 CVTRV455 PTR(31),          /* RESERVED                      */
*      2 CVTRV456 PTR(31),          /* RESERVED                      */
*      2 CVTRV457 BIT(8),           /* RESERVED                      */
*       3 CVTRV458 BIT(1),          /* RESERVED                      */
*       3 CVTRV459 BIT(1),          /* RESERVED                      */
*       3 CVTRV460 BIT(1),          /* RESERVED                      */
*       3 CVTRV461 BIT(1),          /* RESERVED                      */
*       3 CVTRV462 BIT(1),          /* RESERVED                      */
*       3 CVTRV463 BIT(1),          /* RESERVED                      */
*       3 CVTRV464 BIT(1),          /* RESERVED                      */
*       3 CVTRV465 BIT(1),          /* RESERVED                      */
*      2 CVTRV466 BIT(8),           /* RESERVED                      */
*       3 CVTRV467 BIT(1),          /* RESERVED                      */
*       3 CVTRV468 BIT(1),          /* RESERVED                      */
*       3 CVTRV469 BIT(1),          /* RESERVED                      */
*       3 CVTRV470 BIT(1),          /* RESERVED                      */
*       3 CVTRV471 BIT(1),          /* RESERVED                      */
*       3 CVTRV472 BIT(1),          /* RESERVED                      */
*       3 CVTRV473 BIT(1),          /* RESERVED                      */
*       3 CVTRV474 BIT(1),          /* RESERVED                      */
*      2 CVTRV475 PTR(8),           /* RESERVED                      */
*      2 CVTRV476 PTR(8),           /* RESERVED                      */
*      2 CVTRV477 PTR(8),           /* RESERVED                      */
*      2 CVTRV478 PTR(8),           /* RESERVED                      */
*      2 CVTRV479 FIXED(15),        /* RESERVED                      */
*      2 CVTRV480 PTR(31),          /* RESERVED                      */
*      2 CVTRV481 PTR(31),          /* RESERVED                      */
*      2 CVTRV482 PTR(31);          /* RESERVED                      */
*/*                       CVT PREFIX                                 */
*                                                                  0012
*   DCL                                                            0012
*     1 CVTFIX BASED(CVTPTR-256) BDY(WORD),                        0012
*      2 * CHAR(248) BDY(WORD),     /* RESERVED                      */
*      2 * CHAR(2) BDY(WORD),       /* RESERVED                      */
*      2 CVTMDL CHAR(2) BDY(WORD,3),/* CPU MODEL NUMBER IN SIGNLESS
*                                      PACKED DECIMAL, I.E., A MODEL
*                                      145 WOULD BE REPRESENTED AS 0012
*                                      0145 HEX                      */
*      2 CVTRELNO CHAR(4) BDY(WORD),/* RELEASE NUMBER (EBCDIC)       */
*       3 CVTNUMB CHAR(2) BDY(WORD),/* RELEASE NUMBER                */
*       3 CVTLEVL CHAR(2) BDY(WORD,3);/* LEVEL NUMBER OF THIS RELEASE*/
*/*                    END OF CVT MACRO                              */
*                                                                  0013
*                                                                  0013
*/* **************************************************************** */
*/*                                                                  */
*/*            PREFIXED SAVE AREA                                    */
*/*                                                                  */
*/*  OS/VS2 RELEASE 2, 10/10/73, LEVEL=22                            */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*      BAL  - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.      */
*/*             USING ON PSA GIVES ADDRESSABILITY FOR ALL SYMBOLS.   */
*/*      PL/S - PSA WILL BE BASED(0) FOR PL/S I OR LOCATION(0) FOR   */
*/*             PL/S II UNLESS %PSABASE IS SET TO SOME OTHER VALUE   */
*/*             BEFORE INCLUDE FOR MACRO.                            */
*/*                                                                  */
*/*  NOTE                                                            */
*/*      THE LABELS BEGINNING WITH PSA OR FLC ARE THE PROPER LABELS  */
*/*      TO USE.  THE OTHER LABELS ARE GIVEN AS ALIAS NAMES FOR      */
*/*      COMPATIBILITY WITH LABELS USED FOR SYSTEM 360 LOW CORE.     */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0013
*   DECLARE                                                        0013
*     1 PSA LOCATION(0) BDY(DWORD),                                0013
*      2 FLCRNPSW CHAR(8) BDY(DWORD),/* RESTART NEW PSW (AFTER IPL)  */
*       3 FLCIPPSW CHAR(8) BDY(DWORD),/* IPL PSW                     */
*      2 FLCROPSW CHAR(8) BDY(DWORD),/* RESTART OLD PSW (AFTER IPL)  */
*       3 FLCICCW1 CHAR(8) BDY(DWORD),/* IPL CCW1                    */
*      2 FLCICCW2 CHAR(8) BDY(DWORD),/* IPL CCW2                     */
*       3 FLCCVT PTR(31),           /* ADDRESS OF CVT (AFTER IPL)    */
*       3 * CHAR(4),                /* RESERVED (AFTER IPL)          */
*      2 FLCEOPSW CHAR(8) BDY(DWORD),/* EXTERNAL OLD PSW             */
*      2 FLCSOPSW CHAR(8) BDY(DWORD),/* SVC OLD PSW                  */
*      2 FLCPOPSW CHAR(8) BDY(DWORD),/* PROGRAM CHECK OLD PSW        */
*      2 FLCMOPSW CHAR(8) BDY(DWORD),/* MACHINE CHECK OLD PSW        */
*      2 FLCIOPSW CHAR(8) BDY(DWORD),/* INPUT/OUTPUT OLD PSW         */
*      2 FLCCSW CHAR(8) BDY(DWORD), /* CHANNEL STATUS WORD           */
*      2 FLCCAW CHAR(4) BDY(WORD),  /* CHANNEL ADDRESS WORD          */
*      2 FLCCVT2 PTR(31),           /* ADDRESS OF CVT - USED BY DUMP
*                                      ROUTINES ICB319               */
*      2 FLCTIMER CHAR(4),          /* TIMER                         */
*      2 FLCTRACE PTR(31),          /* ADDRESS OF TRACE TABLE HEADER */
*      2 FLCENPSW CHAR(8) BDY(DWORD),/* EXTERNAL NEW PSW             */
*      2 FLCSNPSW CHAR(8) BDY(DWORD),/* SVC NEW PSW                  */
*      2 FLCPNPSW CHAR(8) BDY(DWORD),/* PROGRAM CHECK NEW PSW        */
*      2 FLCMNPSW CHAR(8) BDY(DWORD),/* MACHINE CHECK NEW PSW        */
*      2 FLCINPSW CHAR(8) BDY(DWORD),/* INPUT/OUTPUT NEW PSW         */
*      2 * CHAR(4),                 /* RESERVED                      */
*      2 PSAEEPSW CHAR(4) BDY(WORD),/* EXTENDED PSW DATA STORED ON 0013
*                                      EXTERNAL INTERRUPT MDC084     */
*       3 PSASPAD FIXED(15),        /* ISSUING PROCESSOR'S PHYSICAL
*                                      ADDRESS ON EMS OR EXTERNAL  0013
*                                      CALL INTERRUPT MDC046         */
*       3 FLCEICOD FIXED(15),       /* EXTERNAL INTERRUPTION CODE    */
*      2 PSAESPSW CHAR(4) BDY(WORD),/* EXTENDED PSW DATA STORED ON 0013
*                                      SVC INTERRUPT MDC085          */
*       3 * CHAR(1),                /* RESERVED - SET TO ZERO        */
*       3 FLCSVILC PTR(8),          /* SVC INSTRUCTION LENGTH COUNTER
*                                      - NUMBER OF BYTES MDC079      */
*        4 * BIT(5),                /* ALWAYS ZERO                   */
*        4 FLCSILCB BIT(3),         /* SIGNIFICANT BITS IN ILC FIELD
*                                      - LAST BIT IS ALWAYS ZERO   0013
*                                      MDC080                        */
*       3 FLCSVCN FIXED(15),        /* SVC INTERRUPTION CODE - SVC 0013
*                                      NUMBER MDC081                 */
*      2 PSAEPPSW CHAR(8) BDY(WORD),/* EXTENDED PSW FOR PROGRAM    0013
*                                      INTERRUPT MDC086              */
*       3 * CHAR(1),                /* RESERVED - SET TO ZERO        */
*       3 FLCPIILC PTR(8),          /* PROGRAM INSTRUCTION LENGTH  0013
*                                      COUNTER - NUMBER OF BYTES IN
*                                      INSTRUCTION CAUSING PROGRAM 0013
*                                      INTERRUPTION MDC082           */
*        4 * BIT(5),                /* ALWAYS ZERO                   */
*        4 FLCPILCB BIT(3),         /* SIGNIFICANT BITS IN ILC FIELD
*                                      - LAST BIT IS ALWAYS ZERO   0013
*                                      MDC083                        */
*       3 FLCPICOD FIXED(15),       /* PROGRAM INTERRUPTION CODE     */
*        4 PSARV049 CHAR(1),        /* RESERVED FOR IMPRECISE      0013
*                                      INTERRUPTS MDC087             */
*        4 PSAPICOD PTR(8),         /* 8-BIT INTERRUPT CODE MDC088   */
*         5 PSAPIPER BIT(1),        /* PER INTERRUPT OCCURRED MDC089 */
*         5 PSAPIMC BIT(1),         /* MONITOR CALL INTERRUPT      0013
*                                      OCCURRED MDC090               */
*         5 PSAPIPC BIT(6),         /* AN UNSOLICITED PROGRAM CHECK
*                                      HAS OCCURRED IF ANY OF THESE 6
*                                      BITS ARE ON MDC091            */
*       3 FLCTEA PTR(31),           /* TRANSLATION EXCEPTION ADDRESS */
*        4 * CHAR(1),               /* RESERVED - SET TO ZERO        */
*        4 FLCTEAA PTR(24),         /* TRANSLATION EXCEPTION ADDRESS */
*      2 * CHAR(1),                 /* RESERVED - SET TO ZERO        */
*      2 FLCMCNUM PTR(8),           /* MONITOR CLASS NUMBER          */
*      2 FLCPERCD CHAR(1),          /* PROGRAM EVENT RECORDING CODE  */
*      2 * CHAR(1),                 /* RESERVED - SET TO ZERO        */
*      2 FLCPER PTR(31),            /* PER ADDRESS                   */
*       3 * CHAR(1),                /* RESERVED - SET TO ZERO        */
*       3 FLCPERA PTR(24),          /* PER ADDRESS                   */
*      2 * CHAR(1),                 /* RESERVED - SET TO ZERO        */
*      2 FLCMTRCD CHAR(3),          /* MONITOR CODE                  */
*      2 * CHAR(8),                 /* RESERVED                      */
*      2 FLCMCLA CHAR(344) BDY(DWORD),/* MACHINE CHECK LOGOUT AREA   */
*       3 FLCCHNID CHAR(4),         /* CHANNEL ID                    */
*       3 FLCIOEL PTR(31),          /* SAME AS FLCIOELA BELOW        */
*        4 * CHAR(1),               /* RESERVED                      */
*        4 FLCIOELA PTR(24),        /* I/O EXTENDED LOGOUT (IOEL)  0013
*                                      POINTER                       */
*       3 FLCLCL CHAR(4),           /* LIMITED CHANNEL LOGOUT (ECSW) */
*       3 * CHAR(2),                /* RESERVED                      */
*       3 * CHAR(1),                /* RESERVED MDC051               */
*       3 * CHAR(1),                /* RESERVED MDC052               */
*       3 FLCIOA PTR(31),           /* I/O ADDRESS                   */
*        4 * CHAR(1),               /* RESERVED                      */
*        4 FLCIOAA PTR(24),         /* I/O ADDRESS                   */
*       3 * CHAR(44),               /* RESERVED                      */
*       3 FLCMCIC CHAR(8),          /* MACHINE-CHECK INTERRUPTION  0013
*                                      CODE                          */
*       3 * CHAR(8),                /* RESERVED                      */
*       3 FLCFSA PTR(31),           /* FAILING STORAGE ADDRESS       */
*        4 * CHAR(1),               /* ZEROES                        */
*        4 FLCFSAA PTR(24),         /* FAILING STORAGE ADDRESS       */
*       3 FLCRGNCD CHAR(4),         /* REGION CODE                   */
*       3 FLCFLA CHAR(96) BDY(WORD),/* FIXED LOGOUT AREA             */
*       3 FLCFPSAV CHAR(32) BDY(DWORD),/* FLOATING POINT REGISTER  0013
*                                      SAVE AREA                     */
*       3 FLCGRSAV(16) FIXED(31),   /* GENERAL REGISTER SAVE AREA    */
*       3 FLCCRSAV(16) FIXED(31),   /* CONTROL REGISTER SAVE AREA    */
*      2 FLCHDEND CHAR(0) BDY(DWORD),/* END OF HARDWARE ASSIGNMENTS  */
*      2 PSAPSA CHAR(4) BDY(WORD),  /* CONTROL BLOCK ACRONYM IN    0013
*                                      EBCDIC                        */
*      2 PSACPUPA PTR(15),          /* PHYSICAL CPU ADDRESS          */
*      2 PSACPULA PTR(15),          /* LOGICAL CPU ADDRESS           */
*      2 PSAPCCAV PTR(31),          /* VIRTUAL ADDRESS OF PCCA       */
*      2 PSAPCCAR PTR(31),          /* REAL ADDRESS OF PCCA          */
*      2 PSALCCAV PTR(31),          /* VIRTUAL ADDRESS OF LCCA       */
*      2 PSALCCAR PTR(31),          /* REAL ADDRESS OF LCCA          */
*      2 PSATNEW PTR(31),           /* TCB NEW POINTER               */
*      2 PSATOLD PTR(31),           /* TCB OLD POINTER               */
*      2 PSAANEW PTR(31),           /* ASCB NEW POINTER              */
*      2 PSAAOLD PTR(31),           /* ASCB OLD POINTER              */
*      2 PSASUPER CHAR(4) BDY(WORD),/* SUPERVISOR CONTROL WORD       */
*       3 PSASUP1 BIT(8),           /* FIRST BYTE OF PSASUPER        */
*        4 PSAIO BIT(1),            /* I/O FLIH                      */
*        4 PSASVC BIT(1),           /* SVC FLIH                      */
*        4 PSAEXT BIT(1),           /* EXTERNAL FLIH                 */
*        4 PSAPI BIT(1),            /* PROGRAM CHECK FLIH            */
*        4 PSALOCK BIT(1),          /* LOCK ROUTINE                  */
*        4 PSADISP BIT(1),          /* DISPATCHER                    */
*        4 PSAIPCDR BIT(1),         /* SIGP - DIRECT                 */
*        4 PSAIPCRP BIT(1),         /* SIGP - REMOTE PENDING         */
*       3 PSASUP2 BIT(8),           /* SECOND BYTE OF PSASUPER       */
*        4 PSAIPCRI BIT(1),         /* SIGP - REMOTE IMMEDIATE       */
*        4 PSAGTF BIT(1),           /* GTF GIVEN CONTROL FROM FLIH   */
*        4 PSAIPCEC BIT(1),         /* EXTERNAL CALL SLIH IS ACTIVE
*                                      MDC047                        */
*        4 PSAIPCES BIT(1),         /* EMERGENCY SIGNAL SLIH IS    0013
*                                      ACTIVE MDC048                 */
*        4 PSAIPCE2 BIT(1),         /* EMERGENCY SIGNAL (EMS) SLIH 0013
*                                      RECURSIVE ENTRY FLAG MDC110   */
*        4 PSAACR BIT(1),           /* AUTOMATIC CPU RECONFIGURATION
*                                      (ACR) IN CONTROL MDC119       */
*        4 PSARTM BIT(1),           /* RECOVERY TERMINATION MONITOR
*                                      (RTM) IN CONTROL MDC120       */
*        4 PSALCR BIT(1),           /* LOW CORE REFRESH ROUTINE IS 0013
*                                      ACTIVE MDC126                 */
*       3 PSASUP3 BIT(8),           /* THIRD BYTE OF PSASUPER        */
*        4 PSAIOSUP BIT(1),         /* IF ON, A MAINLINE IOS       0013
*                                      COMPONENT SUCH AS CHANNEL   0013
*                                      SCHEDULER HAS ENTERED A     0013
*                                      PHYSICALLY DISABLED STATE   0013
*                                      WITHOUT REGARD TO LOCKING   0013
*                                      REQUIREMENTS MDC127           */
*        4 PSARV008 BIT(1),         /* RESERVED                      */
*        4 PSARV009 BIT(1),         /* RESERVED                      */
*        4 PSARV010 BIT(1),         /* RESERVED                      */
*        4 PSARV011 BIT(1),         /* RESERVED                      */
*        4 PSARV012 BIT(1),         /* RESERVED                      */
*        4 PSARV013 BIT(1),         /* RESERVED                      */
*        4 PSARV014 BIT(1),         /* RESERVED                      */
*       3 PSASUP4 BIT(8),           /* FOURTH BYTE OF PSASUPER       */
*        4 PSARV015 BIT(1),         /* RESERVED                      */
*        4 PSARV016 BIT(1),         /* RESERVED                      */
*        4 PSARV017 BIT(1),         /* RESERVED                      */
*        4 PSARV018 BIT(1),         /* RESERVED                      */
*        4 PSARV019 BIT(1),         /* RESERVED                      */
*        4 PSARV020 BIT(1),         /* RESERVED                      */
*        4 PSARV021 BIT(1),         /* RESERVED                      */
*        4 PSARV022 BIT(1),         /* RESERVED                      */
*      2 PSAGPREG(3) FIXED(31),     /* REGISTER SAVE AREA FOR I/O  0013
*                                      FLIH, SVC FLIH, EXTERNAL FLIH
*                                      AND SYSTEM TRACE              */
*      2 PSARSREG FIXED(31),        /* RESTART FLIH REGISTER SAVE    */
*      2 PSAPIREG FIXED(31),        /* PROGRAM CHECK FLIH REGISTER 0013
*                                      SAVE                          */
*      2 PSAEXPS1 CHAR(8) BDY(DWORD),/* EXTERNAL FLIH PSW SAVE AREA 1*/
*      2 PSAEXPS2 CHAR(8) BDY(DWORD),/* EXTERNAL FLIH PSW SAVE AREA 2*/
*      2 PSAMPSW CHAR(8) BDY(DWORD),/* SETLOCK MODEL PSW             */
*      2 PSAMCHEX CHAR(8) BDY(DWORD),/* MCH EXIT PSW                 */
*      2 PSAIPCR CHAR(4) BDY(WORD), /* IPC INSTRUCTION TO BE EXECUTED*/
*      2 PSAIPCRM CHAR(1),          /* BYTE USED BY ABOVE IPC      0013
*                                      INSTRUCTION                   */
*      2 * CHAR(3),                 /* RESERVED                      */
*      2 PSAIPCD CHAR(4) BDY(WORD), /* IPC INSTRUCTION TO BE EXECUTED*/
*      2 PSAIPCDM CHAR(1),          /* BYTE USED BY ABOVE IPC      0013
*                                      INSTRUCTION                   */
*      2 * CHAR(3),                 /* RESERVED                      */
*      2 PSAIPCSA FIXED(31),        /* IPC REGISTER SAVE AREA MDC049 */
*      2 PSAHLHIS FIXED(31),        /* SAVE AREA FOR PSAHLHI MDC050  */
*      2 PSARECUR CHAR(1),          /* RESTART FLIH RECURSION      0013
*                                      INDICATOR. IF X'00', FLIH NOT
*                                      IN CONTROL. IF X'FF', FLIH IN
*                                      CONTROL, ENTRY IS RECURSIVE 0013
*                                      MDC093                        */
*      2 PSADSSGO PTR(8),           /* INITIALIZE DSS FLAG, SET BY 0013
*                                      OPERATOR. IF X'00', DSS NOT TO
*                                      BE ACTIVATED. IF NOT X'00', 0013
*                                      NEXT RESTART INTERRUPT FROM 0013
*                                      CONSOLE SHOULD INITIALIZE DSS.
*                                      MDC094                        */
*      2 PSARV050 FIXED(15),        /* RESERVED                      */
*      2 PSASRSA PTR(31),           /* REAL ADDRESS OF SAVE AREA USED
*                                      DURING STOP AND RESTART     0013
*                                      SUBROUTINE MDC095             */
*      2 PSACLHT CHAR(56) BDY(WORD),/* CPU LOCKS HELD TABLE.       0013
*                                      INITIALIZED TO ZERO. IF LOCK
*                                      IS HELD, WORD REPRESENTING  0013
*                                      LOCK HAS ITS ADDRESS.         */
*       3 PSADISPL PTR(31),         /* GLOBAL DISPATCHER LOCK        */
*       3 PSAASML PTR(31),          /* AUXILIARY STORAGE MANAGEMENT
*                                      (ASM) LOCK MDC002             */
*       3 PSASALCL PTR(31),         /* SPACE ALLOCATION LOCK MDC003  */
*       3 PSAIOSSL PTR(31),         /* IOS SYNCHRONIZATION LOCK    0013
*                                      MDC010                        */
*       3 PSAIOSCL PTR(31),         /* IOS CHANNEL AVAILABLE TABLE 0013
*                                      LOCK MDC004                   */
*       3 PSAIOSUL PTR(31),         /* IOS UNIT CONTROL BLOCK LOCK 0013
*                                      MDC005                        */
*       3 PSAIOSLL PTR(31),         /* IOS LOGICAL CHANNEL QUEUE LOCK
*                                      MDC006                        */
*       3 PSATPNCL PTR(31),         /* TCAM'S TPNCP LOCK MDC007      */
*       3 PSATPDNL PTR(31),         /* TCAM'S TPDNCB LOCK MDC008     */
*       3 PSATPACL PTR(31),         /* TCAM'S TPACBDEB LOCK MDC009   */
*       3 PSAOPTL PTR(31),          /* OPTIMIZER LOCK                */
*       3 PSACMSL PTR(31),          /* CROSS MEMORY SERVICES LOCK    */
*       3 PSALOCAL PTR(31),         /* LOCAL LOCK                    */
*       3 PSARV023 PTR(31),         /* RESERVED LOCK                 */
*      2 PSALKSA CHAR(64) BDY(WORD),/* SETLOCK REGISTER SAVE AREA    */
*       3 PSALKR0 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 0 */
*       3 PSALKR1 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 1 */
*       3 PSALKR2 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 2 */
*       3 PSALKR3 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 3 */
*       3 PSALKR4 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 4 */
*       3 PSALKR5 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 5 */
*       3 PSALKR6 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 6 */
*       3 PSALKR7 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 7 */
*       3 PSALKR8 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 8 */
*       3 PSALKR9 FIXED(31),        /* SETLOCK'S CALLER'S REGISTER 9 */
*       3 PSALKR10 FIXED(31),       /* SETLOCK'S CALLER'S REGISTER 10*/
*       3 PSALKR11 FIXED(31),       /* SETLOCK'S CALLER'S REGISTER 11*/
*       3 PSALKR12 FIXED(31),       /* SETLOCK'S CALLER'S REGISTER 12*/
*       3 PSALKR13 FIXED(31),       /* SETLOCK'S CALLER'S REGISTER 13*/
*       3 PSALKR14 FIXED(31),       /* SETLOCK'S CALLER'S REGISTER 14*/
*       3 PSALKR15 FIXED(31),       /* SETLOCK'S CALLER'S REGISTER 15*/
*      2 PSAHLHI CHAR(4) BDY(WORD), /* HIGHEST LOCK HELD INDICATOR   */
*       3 PSACLHS BIT(32) BDY(WORD),/* CPU LOCKS HELD STRING MDC122  */
*      2 PSALITA PTR(31),           /* ADDRESS OF LOCK INTERFACE   0013
*                                      TABLE                         */
*      2 PSAPSWSV CHAR(8) BDY(DWORD),/* PSW SAVE AREA FOR DISPATCHER
*                                      AND ACR                       */
*      2 PSACR0 FIXED(31),          /* SAVE AREA FOR CONTROL REGISTER
*                                      0                             */
*      2 PSAMCHFL BIT(8),           /* MCH RECURSION FLAGS           */
*      2 PSASYMSK CHAR(1),          /* THIS FIELD WILL BE USED IN  0013
*                                      CONJUNCTION WITH THE STNSM  0013
*                                      INSTRUCTION TO PLACE IOS    0013
*                                      CHANNEL SCHEDULER INTO A    0013
*                                      DISABLED STATE AND          0013
*                                      SIMULTANEOUSLY SAVE THE SYSTEM
*                                      MASK OF THE CALLER MDC022     */
*      2 PSAMODE CHAR(1),           /* SAVE AREA FOR MODESET TO STORE
*                                      PSW SYSTEM MASK (MDC060)    0013
*                                                              YM0401*/
*      2 PSAMCHIC CHAR(1),          /* MCH INITIALIZATION COMPLETE 0013
*                                      FLAGS MDC098                  */
*      2 PSAWKRAP PTR(31),          /* REAL ADDRESS OF VARY CPU    0013
*                                      PARAMETER LIST MDC106         */
*      2 PSAWKVAP PTR(31),          /* VIRTUAL ADDRESS OF VARY CPU 0013
*                                      PARAMETER LIST MDC107         */
*      2 PSAVSTAP FIXED(15),        /* WORK AREA FOR VARY CPU MDC108 */
*      2 PSARV058 FIXED(15),        /* RESERVED                      */
*      2 PSASTOR FIXED(31),         /* MASTER MEMORY'S SEGMENT TABLE
*                                      ORIGIN REGISTER (STOR) VALUE  */
*      2 PSADSSRS FIXED(31),        /* REGISTER SAVE FOR DSS PROGRAM
*                                      AND SVC INTERRUPT HANDLERS  0013
*                                      MDC053                        */
*      2 PSADSSR2 FIXED(31),        /* REGISTER SAVE AREA FOR DSS I/O
*                                      AND EXTERNAL INTERRUPT      0013
*                                      HANDLERS MDC054               */
*      2 PSADSSR3 FIXED(31),        /* REGISTER SAVE AREA FOR DSS  0013
*                                      ERROR RECOVERY ROUTINE MDC055 */
*      2 PSADSSWK FIXED(31),        /* WORK AREA FOR DSS INTERRUPT 0013
*                                      HANDLERS MDC056               */
*      2 PSADSSTS(5) FIXED(31),     /* REGISTER SAVE FOR DSS MODULES
*                                      MAKING CALLS TO IQATSS MDC023 */
*      2 PSADSSFL CHAR(4) BDY(WORD),/* DSS FLAG BYTES MDC024         */
*       3 PSADSSF1 BIT(8),          /* DSS STATUS BYTE MDC029        */
*        4 PSADSSMV BIT(1),         /* DSS MONITORING, VS2 RUNNING 0013
*                                      MDC030                        */
*        4 PSADSSDM BIT(1),         /* DSS IN VS2-2 VM MDC031        */
*        4 PSADSSDD BIT(1),         /* DSS IN DSS VM MDC032          */
*        4 PSADSSDW BIT(1),         /* DSS IN DSS WAIT MDC033        */
*        4 PSADSSTP BIT(1),         /* DSS PROCESSING SIGP MDC034    */
*        4 PSADSSSP BIT(1),         /* DSS SIGP PENDING MDC035       */
*        4 PSADSSOI BIT(1),         /* DSS EXECUTING OVERLAID      0013
*                                      INSTRUCTION MDC036            */
*        4 PSADSSPI BIT(1),         /* DSS EXECUTING PRIVILEGED    0013
*                                      INSTRUCTION MDC037            */
*       3 PSADSSF2 CHAR(1),         /* SYSTEM STATUS BYTE MDC038     */
*       3 PSADSSF3 BIT(8),          /* DSS FLAG BYTE MDC099          */
*        4 PSADSSGP BIT(1),         /* DSS SIGP INDICATOR MDC100     */
*        4 PSADSSES BIT(1),         /* ERROR SHORT SAVE INDICATOR  0013
*                                      MDC113                        */
*        4 PSADSSNM BIT(1),         /* NON-MONITORABLE CODE INDICATOR
*                                      MDC114                        */
*        4 PSADSSRW BIT(1),         /* DSS OWNS CVTRSTWD MDC117      */
*        4 PSARV054 BIT(1),         /* RESERVED FOR DSS MDC100       */
*        4 PSARV055 BIT(1),         /* RESERVED FOR DSS MDC100       */
*        4 PSARV056 BIT(1),         /* RESERVED FOR DSS MDC100       */
*        4 PSARV057 BIT(1),         /* RESERVED FOR DSS MDC100       */
*       3 PSADSSF4 BIT(8),          /* DSS RECURSION FLAGS MDC101    */
*        4 PSADSSRC BIT(1),         /* PROGRAM-SVC RECURSION FLAG  0013
*                                      MDC057                        */
*        4 PSADSS12 BIT(1),         /* PROGRAM INTERRUPT 12 RECURSION
*                                      FLAG MDC058                   */
*        4 PSADSSIE BIT(1),         /* I/O-EXTERNAL RECURSION FLAG 0013
*                                      MDC059                        */
*        4 PSADSSC0 BIT(1),         /* CONTROL REGISTER 0 INVALID  0013
*                                      FLAG MDC092                   */
*        4 PSADSSDE BIT(1),         /* DAT ERROR WHILE DSS RUNNING IN
*                                      VS2 VM MDC102                 */
*        4 PSADSSVE BIT(1),         /* DAT ERROR WHILE DSS RUNNING IN
*                                      DSS VM MDC103                 */
*        4 PSADSS10 BIT(1),         /* SEGMENT EXCEPTION RECURSION 0013
*                                      FLAG MDC104                   */
*        4 PSADSS05 BIT(1),         /* ADDRESSING EXCEPTION RECURSION
*                                      FLAG MDC105                   */
*      2 PSADSSRP CHAR(8) BDY(DWORD),/* DSS TO VS2-2 RESUME PSW    0013
*                                      MDC025                        */
*      2 PSADSSPP CHAR(8) BDY(DWORD),/* DSS PSW FOR RETURNING CONTROL
*                                      FROM PRIVILEGED INSTRUCTION 0013
*                                      STREAM TO VS2 MDC026          */
*      2 PSADSS14 FIXED(31),        /* RESTART SECOND LEVEL INTERRUPT
*                                      HANDLER CONTROL REGISTER 14 0013
*                                      SAVE AREA MDC115              */
*      2 PSADSSFW FIXED(31),        /* FULL-WORD DSS WORK AREA MDC116*/
*      2 PSADSSPR FIXED(31),        /* DSS REGISTER SAVE FOR       0013
*                                      PRIVILEGED INSTRUCTION STREAM
*                                      MDC028                        */
*      2 PSADSSED CHAR(0) BDY(WORD),/* END OF DSS FIELDS MDC045      */
*      2 PSARV025 FIXED(31),        /* RESERVED FOR DSS              */
*      2 PSARV040 PTR(31),          /* RESERVED FOR DSS              */
*      2 PSARV041 PTR(31),          /* RESERVED FOR DSS              */
*      2 PSARV042 PTR(31),          /* RESERVED FOR DSS              */
*      2 PSARV043 PTR(31),          /* RESERVED FOR DSS              */
*      2 PSARV044 PTR(31),          /* RESERVED FOR DSS              */
*      2 PSARV045 PTR(31),          /* RESERVED FOR DSS              */
*      2 PSARSVT(16) PTR(31),       /* RECOVERY STACK VECTOR TABLE 0013
*                                      (EACH ELEMENT MAPPED BELOW) 0013
*                                      MDC064                        */
*      2 PSASRPSW CHAR(8) BDY(DWORD),/* RESUME PSW FOR STOP AND    0013
*                                      RESTART SUBROUTINE MDC096     */
*      2 PSARSPSW CHAR(8) BDY(DWORD),/* RESUME PSW FIELD FOR RESTART
*                                      INTERRUPT HANDLER MDC097      */
*      2 PSASTART CHAR(16) BDY(DWORD),/* START FATHOM RECORDING    0013
*                                      MDC111                        */
*      2 PSASTOP CHAR(16) BDY(DWORD),/* STOP FATHOM RECORDING MDC112 */
*      2 PSASFACC CHAR(4) BDY(WORD),/* SETFRR ABEND COMPLETION CODE
*                                      USED WHEN A SETFRR ADD IS   0013
*                                      ISSUED AGAINST A FULL FRR   0013
*                                      STACK MDC123                  */
*      2 PSALSFCC CHAR(4) BDY(WORD),/* A LOAD INSTRUCTION TO PRIME 0013
*                                      REGISTER 1 WITH THE SETFRR  0013
*                                      ABEND COMPLETION CODE IN    0013
*                                      PSASFACC MDC124               */
*      2 PSASVC13 CHAR(2),          /* AN SVC 13 INSTRUCTION MDC125  */
*      2 PSARV059 FIXED(15),        /* RESERVED                      */
*      2 PSARV060 FIXED(31),        /* RESERVED                      */
*      2 PSAPCPSW CHAR(8) BDY(DWORD),/* TEMPORARY OLD PSW STORAGE FOR
*                                      PROGRAM FLIH (MDC129)   YM0943*/
*      2 PSAUSEND CHAR(0) BDY(DWORD),/* END OF ASSIGNED FIELDS MDC109*/
*      2 * CHAR(2040) BDY(DWORD),   /* RESERVED                      */
*      2 PSASTAK CHAR(340) BDY(DWORD),/* NORMAL FRR STACK MDC118     */
*      2 * CHAR(684);               /* RESERVED FOR EXPANSION OF   0013
*                                      PSASTAK MDC118                */
*   DECLARE                                                        0014
*     FLC DEF(PSA) CHAR(LENGTH(PSA)) BDY(DWORD);                   0014
*   DECLARE                                                        0015
*     1 PSARSVTE CHAR(64) DEF(PSARSVT) BDY(WORD),/* RECOVERY STACK 0015
*                                      VECTOR TABLE MDC065           */
*      2 PSACSTK PTR(31),           /* ADDRESS OF CURRENTLY USED   0015
*                                      FUNCTIONAL RECOVERY ROUTINE 0015
*                                      (FRR) STACK MDC061            */
*      2 PSANSTK PTR(31),           /* ADDRESS OF NORMAL FRR STACK 0015
*                                      MDC062                        */
*      2 PSASSTK PTR(31),           /* ADDRESS OF SVC-I/O- DISPATCHER
*                                      FRR STACK MDC063              */
*      2 PSASSAV PTR(31),           /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY SVC-I/O- DISPATCHER
*                                      MDC066                        */
*      2 PSAMSTK PTR(31),           /* ADDRESS OF MCH FRR STACK    0015
*                                      MDC067                        */
*      2 PSAMSAV PTR(31),           /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY MCH MDC068           */
*      2 PSAPSTK PTR(31),           /* ADDRESS OF PROGRAM CHECK FLIH
*                                      FRR STACK MDC069              */
*      2 PSAPSAV PTR(31),           /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY PROGRAM CHECK FLIH 0015
*                                      MDC070                        */
*      2 PSAESTK1 PTR(31),          /* ADDRESS OF EXTERNAL FLIH FRR
*                                      STACK FOR NON- RECURSIVE    0015
*                                      ENTRIES MDC071                */
*      2 PSAESAV1 PTR(31),          /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY NON- RECURSIVE     0015
*                                      ENTRIES MDC072                */
*      2 PSAESTK2 PTR(31),          /* ADDRESS OF EXTERNAL FLIH FRR
*                                      STACK FOR FIRST LEVEL       0015
*                                      RECURSIONS MDC073             */
*      2 PSAESAV2 PTR(31),          /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY EXTERNAL FLIH FOR  0015
*                                      FIRST LEVEL RECURSIONS MDC074 */
*      2 PSAESTK3 PTR(31),          /* ADDRESS OF EXTERNAL FLIH FRR
*                                      STACK FOR SECOND LEVEL      0015
*                                      RECURSIONS AND ACR MDC075     */
*      2 PSAESAV3 PTR(31),          /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY EXTERNAL FLIH (ACR)
*                                      FOR SECOND LEVEL RECURSIONS 0015
*                                      MDC076                        */
*      2 PSARSTK PTR(31),           /* ADDRESS OF RESTART FLIH FRR 0015
*                                      STACK MDC077                  */
*      2 PSARSAV PTR(31);           /* ADDRESS OF INTERRUPTED STACK
*                                      SAVED BY RESTART FLIH MDC078
*                                                                    */
*                                                                  0016
*/*  MACMEAN FRRS MEANS FUNCTIONAL RECOVERY ROUTINE STACK            */
*/*  MACCOMP Y-1 SC1C5/PZD81                                         */
*/*  MACSTAT Y-1 72137/DCR20412                                      */
*                                                                  0016
*   DECLARE                                                        0016
*     1 FRRS BASED(FRRSPTR),                                       0016
*      2 FRRSHEAD CHAR(16) BDY(WORD),/* THE HEADER OF THE FRR STACK  */
*       3 FRRSEMP PTR(31),          /* ADDRESS WHICH INDICATES AN  0016
*                                      EMPTY STACK                   */
*       3 FRRSLAST PTR(31),         /* ADDRESS OF LAST ENTRY IN STACK*/
*       3 FRRSELEN FIXED(31),       /* LENGTH OF EACH ENTRY IN THE 0016
*                                      STACK                         */
*       3 FRRSCURR PTR(31),         /* ADDRESS OF CURRENT FRR ENTRY
*                                      IN THE STACK                  */
*      2 FRRSRTMW CHAR(68) BDY(WORD),/* THE RTM1 WORK AREA PORTION OF
*                                      THE FRR STACK                 */
*      2 FRRSENTS CHAR(256);        /* THE FRR ENTRIES IN THE STACK  */
*   DECLARE                                                        0017
*     1 FRRSENTR BASED(FRREPTR),    /* THE MAPPING OF A FRR ENTRY    */
*      2 FRRSFRRA PTR(31),          /* THE ADDRESS OF THE FRR        */
*      2 FRRSFLGS CHAR(4),          /* FLAGS USED BY RTM DURING FRR
*                                      PROCESSING                    */
*       3 FRRSFLG1 CHAR(1),         /* RECURSION USED BY RTM         */
*        4 FRRSRCUR BIT(1),         /* RECURSION FLAG USED WHEN    0017
*                                      GIVING CONTROL TO FRR AND WHEN
*                                      RECEIVING CONTROL BACK FROM 0017
*                                      FRR                           */
*        4 FRRSNEST BIT(1),         /* FLAG INDICATING A NESTED FRR
*                                      ENTRY                         */
*        4 * BIT(6),                /* RESERVED                      */
*       3 * CHAR(3),                /* RESERVED                      */
*      2 FRRSPARM CHAR(24);         /* PARAMETER AREA PASSED TO FRR  */
*   DCL                                                            0018
*     FRRSESZE FIXED(31) CONSTANT(32);/* LENGTH OF EACH FRR ENTRY    */
*   DCL                                                            0019
*     FRRSFENT FIXED(31) CONSTANT(84);/* DISPLACEMENT INTO FRR STACK
*                                      OF FIRST FRR ENTRY            */
*   DCL                                                            0020
*     FRRSNENT FIXED(31) CONSTANT(8);/* NUMBER OF FRR ENTRIES IN THE
*                                      STACK                         */
*   DCL                                                            0021
*     FRRSTLEN FIXED(31) CONSTANT(340);/* TOTAL LENGTH OF NORMAL FRR
*                                      STACK                       0021
*                                                                    */
*                                                                  0022
*/*********SERVICE REQUEST BLOCK************************************ */
*/*  OS/VS2 RELEASE 2    12/8/72   LEVEL=1                           */
*/*     BAL- DSECT  ALWAYS PRODUCED, PERFORM USING ON SRBSECT        */
*/*                                                                  */
*/*     PL/S  - SRBSECT WILL BE BASED(SRBPTR) .                      */
*/*        1. IF YOU WISH TO APPEND THE SRB TO THE END OF            */
*/*           ANOTHER CONTROL BLOCK, SET %SRBLEVEL='N'               */
*/*           WHERE N IS AN INTEGER BETWEEN 2 AND 3,INCLUSIVE.       */
*/*           SRBSECT WILL THEN BE AN UNBASED LEVEL N  VARIABLE.     */
*/*        2. IF YOU WISH TO APPEND ANOTHER CONTROL BLOCK TO THE END */
*/*           OF THE SRB, SET %SRB9999=',', AND THE SEMICOLON AT     */
*/*           THE END OF THE SRB WILL BE REPLACED WITH A COMMA.      */
*/*                                                                  */
*/*      EXAMPLE OF PLACING SRB BETWEEN TWO OTHER BLOCKS:            */
*/*         %SRBLEVEL='2'     ;                                      */
*/*         %SRB9999=',' ;                                           */
*/*     DECLARE  1 MYBLOCK,                                          */
*/*         2 MYFIELD,                                               */
*/*        %INCLUDE SYSLIB(IHASRB)  ;                                */
*/*         2 MYFIELD2 ;                                             */
*/****************************************************************** */
*                                                                  0022
*   DECLARE                                                        0022
*     1 SRBSECT BASED(SRBPTR) BDY(WORD),                           0022
*        4 SRB,                                                    0022
*          6 SRBID CHAR(4),         /* SRB EBCDIC ACRONYM            */
*          6 SRBFLNK PTR(31),       /* FORWARD CHAIN FIELD           */
*          6 SRBASCB PTR(31),       /* ADDRESS SPACE TO BE DISPATCHED*/
*          6 SRBFLC BDY(WORD),      /* SRB AREA MOVED TO LOW CORE    */
*            8 SRBCPAFF BIT(16),    /* CPU AFFINITY MASK             */
*            8 SRBPASID FIXED(15),  /* PURGEDQ ASID                  */
*            8 SRBPTCB PTR(31),     /* PURGEDQ TCB ADDRESS           */
*          6 SRBEP PTR(31),         /* ENTRY POINT ADDRESS OF      0022
*                                      ASYNCHRONOUS ROUTINE          */
*          6 SRBRMTR PTR(31),       /* ADDRESS OF RESOURCE MGR     0022
*                                      TERMINATION ROUTINE FOR     0022
*                                      PURGEDQ                       */
*          6 SRBPARM PTR(31),       /* USER PARAMETER                */
*          6 SRBSAVE PTR(31),       /* SAVE AREA POINTER FOR       0022
*                                      REDISPATCH OF SUSPENDED S SRB.*/
*          6 SRBPKF BIT(8),         /* PROTECT KEY IN HIGH ORDER 4 0022
*                                      BITS, LOW ORDER BITS 0        */
*          6 SRBPRIOR PTR(8),       /* PRIORITY LEVEL                */
*          6 * CHAR(2),             /* RESERVED                      */
*          6 * PTR(31)              /* RESERVED                      */
*                ;                                                 0022
*                                                                  0023
*/* ******************************************************************/
*/*                                                                  */
*/*  THE SDWA (SYSTEM DIAGNOSTIC WORK AREA) IS USED BY BOTH (E)STA   */
*/*  EXIT ROUTINES AND FRR ROUTINES AS THE COMMUNICATION AREA        */
*/*  BETWEEN THE RTM AND THE (E)STA OR FRR WHEN ERRORS OCCUR.        */
*/*  IT IS ALSO REFERRED TO AS THE RTCA (RECOVERY TERMINATION        */
*/*  COMMUNICATION AREA). IT CONTAINS DATA CONCERNING THE ORIGINAL   */
*/*  ERROR AND ALSO CONCERNING ACTIONS OF PREVIOUSLY ENTERED         */
*/*  RECOVERY ROUTINES.                                              */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*  BAL                                                             */
*/*              IHASDWA DSECT =  YES                                */
*/*                               NO                                 */
*/*  DSECT = YES IS THE DEFAULT AND WILL PRODUCE THE SDWA            */
*/*             AS A DSECT.                                          */
*/*  DSECT = NO WILL PRODUCE THE SDWA AS A CONTINUATION OF           */
*/*             DEFINED STORAGE. (NO DSECT CARD PRODUCED)            */
*/*  PLS                                                             */
*/*    IF MACRO VARIABLE %SDWA9999 IS NOT EQUAL TO ','               */
*/*    AND %SDWALVL IS NULL, THE SDWA WILL BE INCLUDED               */
*/*    AS A LEVEL 1 STRUCTURE BASED ON SDWAPTR.                      */
*/*                                                                  */
*/*    IF %SDWALVL IS SPECIFIED AS A NUMBER FROM 1 TO 4              */
*/*    THE SDWA WILL BE A NON-BASED STRUCTURE WITH THE               */
*/*    TOP LEVEL EQUAL TO %SDWALVL.                                  */
*/*                                                                  */
*/*    IF SDWA9999 IS EQUAL TO ',' THE SDWA WILL                     */
*/*    TERMINATE WITH A COMMA RATHER THAN A                          */
*/*    SEMI-COLON.                                                   */
*/*                                                                  */
*/*                                                                  */
*/*  MACMEAN SDWA MEANS SYSTEM DIAGNOSTIC WORK AREA                  */
*/*  MACCOMP Y-1 SC1C5/PZD81                                         */
*/*  MACSTAT Y-1 72318/Y02703,Y02704                                 */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0023
*   DECLARE                                                        0023
*     1 SDWA BASED(SDWAPTR),                                       0023
*          6 SDWAPARM PTR(31),      /* PARAMETER LIST ADDRESS IF   0023
*                                      (E)STA MACRO SPECIFIED PARAM
*                                      OPTION OR 0. FOR FRRS THIS IS
*                                      THE ADDRESS OF THE 6 WORD PARM
*                                      AREA RETURNED BY THE SETFRR 0023
*                                      MACRO WHEN THE PARMAD KEYWORD
*                                      IS SPECIFIED ON THE ON THE  0023
*                                      SETFRR MACRO                  */
*          6 SDWAFIOB PTR(31),      /* ADDRESS OF PURGE I/O REQUEST
*                                      LIST (PIRL), OR 0 IF HALT I/O
*                                      IS REQUESTED ON ENTRY TO RETRY
*                                      ROUTINE FOR (E)STA.           */
*           7 SDWAABCC CHAR(4),     /* ABEND COMPLETION CODE ON ENTRY
*                                      TO EXIT ROUTINE               */
*            8 SDWACMPF CHAR(1),    /* FLAG BITS IN COMPLETION CODE. */
*             9 SDWAREQ BIT(1),     /* ON, DUMP TO BE GIVEN. SET IF
*                                      DUMP REQUESTED BY ABEND,    0023
*                                      CALLRTM, OR SETRP MACRO.      */
*             9 SDWASTEP BIT(1),    /* ON, JOBSTEP TO BE           0023
*                                      TERMINATED.SET IF STEP OPTION
*                                      SPECIFIED ON ABEND MACRO.     */
*             9 * BIT(1),           /* RESERVED                      */
*             9 SDWASTCC BIT(1),    /* ON, DON'T STORE COMPLETION  0023
*                                      CODE. NOT USED IN OS/VS2 REL.
*                                      2                             */
*             9 * BIT(4),           /* RESERVED                      */
*            8 SDWACMPC CHAR(3),    /* SYSTEM COMPLETION CODE (FIRST
*                                      12 BITS) AND USER COMPLETION
*                                      CODE (SECOND 12 BITS).        */
*          6 SDWACTL1 CHAR(8) BDY(WORD),/* BC MODE PSW AT TIME OF  0023
*                                      ERROR. NOT INITIALIZED FOR  0023
*                                      FRRS.                         */
*           7 SDWACMKA CHAR(1),     /* CHANNEL INTERRUPTS MASKS      */
*            8 SDWAIOA BIT(7),      /* I/O INTERRUPTS (ALL ZEROS OR
*                                      ALL ONES).                    */
*            8 SDWAEXTA BIT(1),     /* EXTERNAL INTERRUPT.           */
*           7 SDWAMWPA CHAR(1),     /* PSW KEY AND 'M-W-P'.          */
*            8 SDWAKEYA BIT(4),     /* PSW KEY                       */
*            8 * BIT(1),            /* RESERVED                      */
*            8 SDWAMCKA BIT(1),     /* MACHINE CHECK INTERRUPT       */
*            8 SDWAWATA BIT(1),     /* WAIT STATE.                   */
*            8 SDWASPVA BIT(1),     /* SUPERVISOR/PROBLEM- PROGRAM 0023
*                                      MODE.                         */
*           7 SDWAINTA CHAR(2),     /* INTERRUPT CODE (LAST 2 BYTES
*                                      OF INTERRUPT CODE IF I/O    0023
*                                      INTERRUPT).                   */
*           7 SDWAPMKA CHAR(1),     /* INSTRUCTION LENGTH CODE,    0023
*                                      CONDITION CODE, AND PROGRAM 0023
*                                      MASKS.                        */
*            8 SDWAILA BIT(2),      /* INSTRUCTION LENGTH CODE       */
*            8 SDWACCA BIT(2),      /* LAST CONDITION CODE           */
*            8 SDWAFPA BIT(1),      /* FIXED-POINT OVERFLOW          */
*            8 SDWADOA BIT(1),      /* DECIMAL OVERFLOW              */
*            8 SDWAEUA BIT(1),      /* EXPONENT UNDERFLOW            */
*            8 SDWASGA BIT(1),      /* SIGNIFANCE                    */
*           7 SDWANXTA PTR(24),     /* ADDRESS OF NEXT INSTRUCTION TO
*                                      BE EXECUTED                   */
*          6 SDWACTL2 CHAR(8) BDY(WORD),/* BC MODE PSW FROM LAST PRB
*                                      ON RB CHAIN. ZERO FOR FRRS.   */
*           7 SDWACMKP CHAR(1),     /* CHANNEL INTERRUPTS MASKS      */
*            8 SDWAIOP BIT(7),      /* I/O INTERRUPTS (ALL ZEROS OR
*                                      ALL ONES).                    */
*            8 SDWAEXTP BIT(1),     /* EXTERNAL INTERRUPT.           */
*           7 SDWAMWPP CHAR(1),     /* PSW KEY AND 'M-W-P'.          */
*            8 SDWAKEYP BIT(4),     /* PSW KEY                       */
*            8 * BIT(1),            /* RESERVED                      */
*            8 SDWAMCKP BIT(1),     /* MACHINE CHECK INTERRUPT       */
*            8 SDWAWATP BIT(1),     /* WAIT STATE.                   */
*            8 SDWASPVP BIT(1),     /* SUPERVISOR/PROBLEM- PROGRAM 0023
*                                      MODE.                         */
*           7 SDWAINTP CHAR(2),     /* INTERRUPT CODE (LAST 2 BYTES
*                                      OF INTERRUPT CODE IF I/O    0023
*                                      INTERRUPT).                   */
*           7 SDWAPMKP CHAR(1),     /* INSTRUCTION LENGTH CODE,    0023
*                                      CONDITION CODE, AND PROGRAM 0023
*                                      MASKS.                        */
*            8 SDWAILP BIT(2),      /* INSTRUCTION LENGTH CODE       */
*            8 SDWACCP BIT(2),      /* LAST CONDITION CODE           */
*            8 SDWAFPP BIT(1),      /* FIXED-POINT OVERFLOW          */
*            8 SDWADOP BIT(1),      /* DECIMAL OVERFLOW              */
*            8 SDWAEUP BIT(1),      /* EXPONENT UNDERFLOW            */
*            8 SDWASGP BIT(1),      /* SIGNIFICANCE                  */
*           7 SDWANXTP PTR(24),     /* ADDRESS OF NEXT INSTRUCTION TO
*                                      BE EXECUTED                   */
*          6 SDWAGRSV CHAR(64) BDY(WORD),/* GENERAL PURPOSE REGISTERS
*                                      AT TIME OF ERROR              */
*           7 SDWAGR00 FIXED(31),   /* GPR 0.                        */
*           7 SDWAGR01 FIXED(31),   /* GPR 1.                        */
*           7 SDWAGR02 FIXED(31),   /* GPR 2.                        */
*           7 SDWAGR03 FIXED(31),   /* GPR 3.                        */
*           7 SDWAGR04 FIXED(31),   /* GPR 4.                        */
*           7 SDWAGR05 FIXED(31),   /* GPR 5.                        */
*           7 SDWAGR06 FIXED(31),   /* GPR 6.                        */
*           7 SDWAGR07 FIXED(31),   /* GPR 7.                        */
*           7 SDWAGR08 FIXED(31),   /* GPR 8.                        */
*           7 SDWAGR09 FIXED(31),   /* GPR 9.                        */
*           7 SDWAGR10 FIXED(31),   /* GPR 10.                       */
*           7 SDWAGR11 FIXED(31),   /* GPR 11.                       */
*           7 SDWAGR12 FIXED(31),   /* GPR 12.                       */
*           7 SDWAGR13 FIXED(31),   /* GPR 13.                       */
*           7 SDWAGR14 FIXED(31),   /* GPR 14.                       */
*           7 SDWAGR15 FIXED(31),   /* GPR 15.                       */
*          6 SDWANAME CHAR(8) BDY(WORD),/* IF PROBLEM PROGRAM MODE 0023
*                                      NAME OF ABENDING PROGRAM, OR
*                                      ZERO IF NO NAME IS AVAILABLE.
*                                      ZERO IF NOT RUNNING UNDER AN
*                                      RB.                           */
*           7 SDWARBAD PTR(31),     /* RB ADDRESS OF ABENDING      0023
*                                      PROGRAM. (IF SUPERVISOR MODE
*                                      PROGRAM RUNNING UNDER AN RB)  */
*           7 * CHAR(4),            /* CONTAINS ZEROS IF SUPERVISOR
*                                      MODE PROGRAM RUNNING UNDER AN
*                                      RB. OR IF PROGRAM NOT RUNNING
*                                      UNDER AN RB.                  */
*          6 SDWAEPA PTR(31),       /* ENTRY POINT ADDRESS OF      0023
*                                      ABENDING PROGRAM. ZERO IF NOT
*                                      RUNNING UNDER AN RB.          */
*          6 SDWAIOBR PTR(31),      /* POINTER TO SDWAFIOB FIELD, OR
*                                      0 IF NO RETRY, OR 0 IF HALT 0023
*                                      I/O IS REQUESTED FOR (E)STA 0023
*                                      EXITS. ZERO FOR FRRS. ICB3777 */
*          6 SDWAEC1 CHAR(8) BDY(WORD),/* EXTENDED CONTROL PSW AT  0023
*                                      TIME OF ERROR(ABEND)          */
*           7 SDWAEMK1 CHAR(1),     /* INTERRUPT INFORMATION MASKS   */
*            8 * BIT(1),            /* RESERVED                      */
*            8 SDWAPER1 BIT(1),     /* ON,PROGRAM EVENT RECORD- ING
*                                      INTERRUPTS CAN OCCUR        0023
*                                      OFF,PROGRAM EVENT RECORD- ING
*                                      INTERRUPTS CANNOT OCCUR       */
*            8 * BIT(3),            /* RESERVED                      */
*            8 SDWATRM1 BIT(1),     /* ON,ADDRESS TRANSLATION ACTIVE */
*            8 SDWAIO1 BIT(1),      /* OFF,I/O INTERRUPTIONS CANNOT
*                                      OCCUR ON,I/O INTERRUPTIONS CAN
*                                      OCCUR SUBJECT TO CHANNEL MASK
*                                      BITS IN CONTROL REGS 2 AND 3  */
*            8 SDWAEXT1 BIT(1),     /* OFF,EXTERNAL INTERRUPTIONS  0023
*                                      CANNOT OCCUR ON,EXTERNAL    0023
*                                      INTERRUPTIONS CAN OCCUR     0023
*                                      SUBJECT TO EXTERNAL SUBCLASS
*                                      MASK BITS OF CONTROL REGISTER
*                                      0                             */
*           7 SDWAMWP1 CHAR(1),     /* PSW KEY AND 'M-W-P'           */
*            8 SDWAKEY1 BIT(4),     /* PSW KEY                       */
*            8 SDWAECT1 BIT(1),     /* EXTENDED CONTROL MODE BIT     */
*            8 SDWAMCK1 BIT(1),     /* OFF,MACHINE CHECKS CANNOT   0023
*                                      OCCUR ON,MACHINE CHECKS DUE TO
*                                      SYSTEM DAMAGE AND           0023
*                                      INSTRUCTION-PROCESSING DAMAGE
*                                      CAN OCCUR. OTHER MACHINE    0023
*                                      CHECKS SUBJECT TO MASK BITS IN
*                                      CONTROL REGISTER 14           */
*            8 SDWAWAT1 BIT(1),     /* ON,CPU IN WAIT STATE          */
*            8 SDWAPGM1 BIT(1),     /* ON,PROBLEM STATE            0023
*                                      OFF,SUPERVISOR STATE          */
*           7 SDWAINT1 CHAR(1),     /* CONDITION CODE AND PROGRAM  0023
*                                      MASK                          */
*            8 * BIT(2),            /* RESERVED                      */
*            8 SDWACC1 BIT(2),      /* CONDITION CODE                */
*            8 SDWAFPO1 BIT(1),     /* FIXED POINT OVERFLOW          */
*            8 SDWADEC1 BIT(1),     /* DECIMAL OVERFLOW              */
*            8 SDWAEXP1 BIT(1),     /* EXPONENT UNDERFLOW            */
*            8 SDWASGN1 BIT(1),     /* SIGNIFICANCE                  */
*           7 * CHAR(1),            /* RESERVED                      */
*           7 SDWANXT1 PTR(31),     /* ADDRESS OF NEXT INSTRUCTION TO
*                                      BE EXECUTED                   */
*            8 * PTR(8),            /* RESERVED                      */
*            8 SDWAADD1 PTR(24),    /* INSTRUCTION ADDRESS           */
*          6 SDWAAEC1 CHAR(8) BDY(WORD),/* ADDITIONAL EC MODE      0023
*                                      INFORMATION                   */
*           7 * CHAR(1),            /* RESERVED                      */
*           7 SDWAILC1 PTR(8),      /* INSTRUCTION LENGTH CODE FOR 0023
*                                      PSW DEFINED BY         SDWAEC1*/
*            8 * BIT(5),            /* RESERVED ALWAYS ZERO          */
*            8 SDWAIL1 BIT(2),      /* INSTRUCTION LENGTH CODE       */
*            8 * BIT(1),            /* RESERVED ALWAYS ZERO          */
*           7 SDWAINC1 FIXED(16),   /* INTERRUPT CODE. IF PROGRAM  0023
*                                      CHECK OCCURRED THE SUBFIELDS
*                                      ARE FURTHER DIVIDED           */
*            8 * CHAR(1),           /* RESERVED FOR IMPRECISE      0023
*                                      INTERRUPTS IF PROGRAM CHECK   */
*            8 SDWAICD1 PTR(8),     /* 8 BIT INTERRUPT CODE IF     0023
*                                      PROGRAM CHECK                 */
*             9 SDWAIPR1 BIT(1),    /* PER INTERRUPT OCCURRED        */
*             9 SDWAIMC1 BIT(1),    /* MONITOR CALL INTERRUPT      0023
*                                      OCCURRED                      */
*             9 SDWAIPC1 BIT(6),    /* AN UNSOLICITED PROGRAM CHECK
*                                      HAS OCCURRED                  */
*           7 SDWATRAN PTR(31),     /* VIRTUAL ADDRESS CAUSING     0023
*                                      TRANSLATION EXCEPTION         */
*          6 SDWAEC2 CHAR(8) BDY(WORD),/* EC MODE PSW OF THE RB WHICH
*                                      CREATED THE ESTAE EXIT AT THE
*                                      TIME IT LAST INCURRED AN    0023
*                                      INTERRUPT OR 0 FOR ESTAI. OR
*                                      PSW USED TO GIVE FRR CONTROL  */
*           7 SDWAEMK2 CHAR(1),     /* INTERRUPT INFORMATION MASKS   */
*            8 * BIT(1),            /* RESERVED                      */
*            8 SDWAPER2 BIT(1),     /* ON,PROGRAM EVENT RECORD- ING
*                                      INTERRUPTS CAN OCCUR        0023
*                                      OFF,PROGRAM EVENT RECORD- ING
*                                      INTERRUPTS CANNOT OCCUR       */
*            8 * BIT(3),            /* RESERVED                      */
*            8 SDWATRM2 BIT(1),     /* ON,ADDRESS TRANSLATION ACTIVE */
*            8 SDWAIO2 BIT(1),      /* OFF,I/O INTERRUPTIONS CANNOT
*                                      OCCUR ON,I/O INTERRUPTIONS CAN
*                                      OCCUR SUBJECT TO CHANNEL MASK
*                                      BITS IN CONTROL REGS 2 AND 3  */
*            8 SDWAEXT2 BIT(1),     /* OFF,EXTERNAL INTERRUPTIONS  0023
*                                      CANNOT OCCUR ON,EXTERNAL    0023
*                                      INTERRUPTIONS CAN OCCUR     0023
*                                      SUBJECT TO EXTERNAL SUBCLASS
*                                      MASK BITS OF CONTROL REGISTER
*                                      0                             */
*           7 SDWAMWP2 CHAR(1),     /* PSW KEY AND 'M-W-P'           */
*            8 SDWAKEY2 BIT(4),     /* PSW KEY                       */
*            8 SDWAECT2 BIT(1),     /* EXTENDED CONTROL MODE BIT     */
*            8 SDWAMCK2 BIT(1),     /* OFF,MACHINE CHECKS CANNOT   0023
*                                      OCCUR ON,MACHINE CHECKS DUE TO
*                                      SYSTEM DAMAGE AND           0023
*                                      INSTRUCTION-PROCESSING DAMAGE
*                                      CAN OCCUR. OTHER MACHINE    0023
*                                      CHECKS SUBJECT TO MASK BITS IN
*                                      CONTROL REGISTER 14           */
*            8 SDWAWAT2 BIT(1),     /* ON,CPU IN WAIT STATE          */
*            8 SDWAPGM2 BIT(1),     /* ON,PROBLEM STATE            0023
*                                      OFF,SUPERVISOR STATE          */
*           7 SDWAINT2 CHAR(1),     /* CONDITION CODE AND PROGRAM  0023
*                                      MASK                          */
*            8 * BIT(2),            /* RESERVED                      */
*            8 SDWACC2 BIT(2),      /* CONDITION CODE                */
*            8 SDWAFPO2 BIT(1),     /* FIXED POINT OVERFLOW          */
*            8 SDWADEC2 BIT(1),     /* DECIMAL OVERFLOW              */
*            8 SDWAEXP2 BIT(1),     /* EXPONENT UNDERFLOW            */
*            8 SDWASGN2 BIT(1),     /* SIGNIFICANCE                  */
*           7 * CHAR(1),            /* RESERVED                      */
*           7 SDWANXT2 PTR(31),     /* ADDRESS OF NEXT INSTRUCTION TO
*                                      BE EXECUTED                   */
*            8 * PTR(8),            /* RESERVED                      */
*            8 SDWAADD2 PTR(24),    /* INSTRUCTION ADDRESS           */
*          6 SDWAAEC2 CHAR(8) BDY(WORD),/* ADDITIONAL EC MODE      0023
*                                      INFORMATION                   */
*           7 * CHAR(1),            /* RESERVED                      */
*           7 SDWAILC2 CHAR(1),     /* INSTRUCTION LENGTH CODE FOR 0023
*                                      PSW DEFINED BY         SDWAEC2*/
*            8 * BIT(5),            /* RESERVED ALWAYS ZERO          */
*            8 SDWAIL2 BIT(2),      /* INSTRUCTION LENGTH CODE       */
*            8 * BIT(1),            /* RESERVED ALWAYS ZERO          */
*           7 SDWAINC2 FIXED(16),   /* INTERRUPT CODE. IF PROGRAM  0023
*                                      CHECK OCCURRED THE SUBFIELDS
*                                      ARE FURTHER DIVIDED           */
*            8 * CHAR(1),           /* RESERVED FOR IMPRECISE      0023
*                                      INTERRUPTS ON PROGRAM CHECK 0023
*                                      INTERRUPT                     */
*            8 SDWAICD2 PTR(8),     /* 8 BIT INTERRUPT CODE IF     0023
*                                      PROGRAM CHECK                 */
*             9 SDWAIPR2 BIT(1),    /* PER INTERRUPT OCCURRED        */
*             9 SDWAIMC2 BIT(1),    /* MONITOR CALL INTERRUPT      0023
*                                      OCCURRED                      */
*             9 SDWAIPC2 BIT(6),    /* AN UNSOLICITED PROGRAM CHECK
*                                      OCCURRED                      */
*           7 SDWATRN2 PTR(31),     /* VIRTUAL ADDRESS CAUSING     0023
*                                      TRANSLATION EXCEPTION         */
*          6 SDWASRSV CHAR(64) BDY(WORD),/* GENERAL PURPOSE REGISTERS
*                                      OF THE RB LEVEL WHICH CREATED
*                                      THE ESTAE EXIT AT THE TIME IT
*                                      LAST INCURRED AN INTERRUPT OR
*                                      0 FOR ESTAI. FOR FRRS       0023
*                                      INITIALIZED TO REGISTERS AT 0023
*                                      TIME OF ERROR. THIS REGISTER
*                                      AREA IS USED TO UPDATE      0023
*                                      REGISTER CONTENTS FOR RETRY IF
*                                      REQUESTED                     */
*           7 SDWASR00 FIXED(31),   /* GPR 0.                        */
*           7 SDWASR01 FIXED(31),   /* GPR 1.                        */
*           7 SDWASR02 FIXED(31),   /* GPR 2.                        */
*           7 SDWASR03 FIXED(31),   /* GPR 3.                        */
*           7 SDWASR04 FIXED(31),   /* GPR 4.                        */
*           7 SDWASR05 FIXED(31),   /* GPR 5.                        */
*           7 SDWASR06 FIXED(31),   /* GPR 6.                        */
*           7 SDWASR07 FIXED(31),   /* GPR 7.                        */
*           7 SDWASR08 FIXED(31),   /* GPR 8.                        */
*           7 SDWASR09 FIXED(31),   /* GPR 9.                        */
*           7 SDWASR10 FIXED(31),   /* GPR 10,                       */
*           7 SDWASR11 FIXED(31),   /* GPR 11.                       */
*           7 SDWASR12 FIXED(31),   /* GPR 12.                       */
*           7 SDWASR13 FIXED(31),   /* GPR 13.                       */
*           7 SDWASR14 FIXED(31),   /* GPR 14.                       */
*           7 SDWASR15 FIXED(31),   /* GPR 15.                       */
*          6 SDWAIDNT CHAR(4),      /* SDWA IDENTIFICATION AND     0023
*                                      ATTRIBUTES                    */
*           7 SDWASPID CHAR(1),     /* SUBPOOL ID OF STORAGE       0023
*                                      CONTAINING THIS SDWA          */
*           7 SDWALNTH CHAR(3),     /* LENGTH OF THIS SDWA IN BYTES  */
*          6 SDWAMCH CHAR(28) BDY(WORD),/* CONTAINS MACHINE CHECK  0023
*                                      DATA IF SDWAMCHK IS ON        */
*           7 SDWASTCK CHAR(8) BDY(WORD),/* BEGINNING AND ENDING   0023
*                                      STORAGE CHECK ADDRESSES.    0023
*                                      FILLED IN DUE TO STORAGE ERROR
*                                      (SDWASCK) OR A KEY FAILURE  0023
*                                      (SDWASKYF) THESE ADDRESSES ARE
*                                      VALID ONLY IF INDICATED BY THE
*                                      SDWASRVL FLAG.                */
*            8 SDWASCKB PTR(31),    /* BEGINNING VIRTUAL ADDRESS OF
*                                      STORAGE CHECK                 */
*            8 SDWASCKE PTR(31),    /* ENDING VIRTUAL ADDRESS OF   0023
*                                      STORAGE CHECK                 */
*           7 SDWAMCHI CHAR(2),     /* ADDITIONAL MCH INFORMATION  0023
*                                      FLAGS                         */
*            8 SDWAMCHS CHAR(1),    /* MCH FLAG BYTE                 */
*             9 SDWASRVL BIT(1),    /* ON,STORAGE ADDRESS SUPPLIED 0023
*                                      (SDWASTCK, SDWARFSA) ARE    0023
*                                      VALID.                        */
*             9 SDWARCDF BIT(1),    /* ON,MACHINE CHECK RECORD NOT 0023
*                                      RECORDED                      */
*             9 SDWATSVL BIT(1),    /* ON,TIME STAMP VALID           */
*             9 SDWAINVP BIT(1),    /* ON,STORAGE IS RECONFIGURED, 0023
*                                      PAGE IS INVALIDATED.          */
*             9 SDWARSRC BIT(1),    /* ON,STORAGE RECONFIGURATION  0023
*                                      STATUS AVAILABLE            0023
*                                      (SDWARSR1,SDWARSR2)           */
*             9 SDWARSRF BIT(1),    /* ON,STORAGE RECONFIGURATION NOT
*                                      ATTEMPTED (SDWARSR1, SDWARSR2
*                                      ARE INVALID )                 */
*             9 * BIT(2),           /* RESERVED                      */
*            8 SDWAMCHD CHAR(1),    /* INPUT INFORMATION TO RECOVERY
*                                      ROUTINE CON- CERNING A MACHINE
*                                      CHECK ERROR                   */
*             9 SDWASKYF BIT(1),    /* ON,STORAGE KEY FAILURE        */
*             9 SDWAREGU BIT(1),    /* ON,GENERAL PURPOSE REGISTER 0023
*                                      CONTENTS AT TIME OF MACHINE 0023
*                                      CHECK UNPREDICTABLE           */
*             9 SDWAPSWU BIT(1),    /* ON,PSW AND-OR CONTROL       0023
*                                      REGISTERS AT TIME OF MACHINE
*                                      CHECK UNPREDICTABLE           */
*             9 SDWASCK BIT(1),     /* ON,STORAGE DATA CHECK         */
*             9 SDWAACR BIT(1),     /* ON,INDICATES ACR REQUEST      */
*             9 SDWAINSF BIT(1),    /* ON,INSTRUCTION FAILURE        */
*             9 SDWAFPRX BIT(1),    /* ON, CONTENTS OF FLOATING POINT
*                                      REGISTERS AT TIME OF MACHINE
*                                      CHECK ARE UNPREDICTABLE       */
*             9 SDWATERR BIT(1),    /* ON,TIMER ERROR - CAUSES ENTRY
*                                      TO RECOVERY ROUTINES ONLY IF
*                                      LOGOUT FAILED                 */
*           7 SDWACPID CHAR(2),     /* ID OF FAILING CPU CAUSING ACR */
*           7 SDWARSR1 CHAR(1),     /* ADDITIONAL STORAGE FRAME ERROR
*                                      INDICATORS AS RETURNED FROM 0023
*                                      REAL STORAGE RECONFIGURATION  */
*            8 * BIT(6),            /* RESERVED                      */
*            8 SDWAMSER BIT(1),     /* STORAGE ERROR ALREADY SET IN
*                                      FRAME                         */
*            8 SDWACHNG BIT(1),     /* CHANGE INDICATOR WAS ON IN  0023
*                                      FRAME                         */
*           7 SDWARSR2 CHAR(1),     /* ADDITIONAL STORAGE ERROR    0023
*                                      INDICATORS.                   */
*            8 SDWAOFLN BIT(1),     /* FRAME OFFLINE OR SCHEDULED TO
*                                      GO OFFLINE IF SDWAINTC IS ON  */
*            8 SDWAINTC BIT(1),     /* INTERCEPT THE FRAME IS      0023
*                                      SCHEDULED TO GO OFFLINE OR THE
*                                      FRAME HAS INCURRED A STORAGE
*                                      ERROR OR IS V=R               */
*            8 SDWASPER BIT(1),     /* STORAGE ERROR PERMANENT ON  0023
*                                      FRAME                         */
*            8 SDWANUCL BIT(1),     /* FRAME CONTAINS PERMANENT    0023
*                                      RESIDENT STORAGE,I.E. NUCLEUS.*/
*            8 SDWAFSQA BIT(1),     /* FRAME IN SQA                  */
*            8 SDWAFLSQ BIT(1),     /* FRAME IN LSQA                 */
*            8 SDWAPGFX BIT(1),     /* FRAME IS PAGE FIXED           */
*            8 SDWAVEQR BIT(1),     /* FRAME IS VIRTUAL=REAL OR    0023
*                                      SCHEDULED FOR VIRTUAL= REAL.
*                                      IF SDWAINTC IS ON             */
*           7 * CHAR(2),            /* RESERVED                      */
*           7 SDWARFSA PTR(31),     /* REAL STORAGE FAILING ADDRESS.
*                                      ( VALID ONLY IF INDICATED BY
*                                      SDWASRVL )                    */
*           7 SDWATIME CHAR(8),     /* TIME STAMP OF ASSOCIATED    0023
*                                      MACHINE CHECK RECORD.         */
*          6 SDWAFLGS CHAR(4),      /* INPUT FLAGS DESCRIBING REASONS
*                                      AND CONDITIONS FOR ENTERING A
*                                      RECOVERY EXIT ROUTINE         */
*           7 SDWAERRA CHAR(1),     /* ERROR TYPE CAUSING ENTRY TO 0023
*                                      RECOVERY ROUTINE              */
*            8 SDWAMCHK BIT(1),     /* ON,MACHINE CHECK              */
*            8 SDWAPCHK BIT(1),     /* ON,PROGRAM CHECK              */
*            8 SDWARKEY BIT(1),     /* ON,INDICATES CONSOLE RESTART
*                                      KEY DEPRESSED                 */
*            8 SDWASVCD BIT(1),     /* ON,INDICATES TASK ISSUED SVC
*                                      13                            */
*            8 SDWAABTM BIT(1),     /* ON,INDICATES SYSTEM FORCED SVC
*                                      13(ABTERM)                    */
*            8 SDWASVCE BIT(1),     /* ON,INDICATES AN SVC WAS ISSUED
*                                      BY A LOCKED OR SRB ROUTINE    */
*            8 SDWATEXC BIT(1),     /* ON,INDICATES AN UNRECOVERABLE
*                                      TRANSLATION FAILURE           */
*            8 SDWAPGIO BIT(1),     /* ON,INDICATES A PAGE I/O ERROR */
*           7 SDWAERRB CHAR(1),     /* ADDITIONAL ERROR ENTRY      0023
*                                      INFORMATION                   */
*            8 * BIT(4),            /* RESERVED                      */
*            8 SDWATYP1 BIT(1),     /* ON,TYPE1 SVC IN CONTROL AT  0023
*                                      TIME OF ERROR                 */
*            8 SDWAENRB BIT(1),     /* ON,ENABLED RB IN CONTROL AT 0023
*                                      TIME OF ERROR                 */
*            8 SDWALDIS BIT(1),     /* ON,A LOGICALLY OR PHYSICALLY
*                                      DISABLED ROUTINE WAS IN     0023
*                                      CONTROL AT TIME OF ERROR.     */
*            8 SDWASRBM BIT(1),     /* SYSTEM IN SRB MODE AT TIME OF
*                                      ERROR                         */
*           7 SDWAERRC CHAR(1),     /* ADDITIONAL ERROR ENTRY      0023
*                                      INFORMATION                   */
*            8 SDWASTAF BIT(1),     /* ON,A PREVIOUS (E)STA EXIT OR
*                                      FRR FAILED                    */
*            8 SDWASTAI BIT(1),     /* ON, A (E)STAI EXIT PREVIOUSLY
*                                      RECEIVED CONTROL              */
*            8 SDWAIRB BIT(1),      /* ON,AN IRB PRECEDED THE RB THAT
*                                      IS ASSOCIATED WITH THIS EXIT  */
*            8 SDWAPERC BIT(1),     /* ON,THIS RECOVERY ROUTINE IS 0023
*                                      BEING PERCOLATED TO           */
*            8 SDWAEAS BIT(1),      /* ON INDICATES A LOWER LEVEL  0023
*                                      EXIT HAS RECOGNIZED AN ERROR
*                                      AND PROVIDED SERVICE- ABILITY
*                                      INFORMATION                   */
*            8 * BIT(3),            /* RESERVED.                     */
*           7 SDWAERRD CHAR(1),     /* ADDITIONAL ERROR ENTRY      0023
*                                      INFORMATION.                  */
*            8 SDWACLUP BIT(1),     /* ON,INDICATES RECOVERY ROUTINE
*                                      ONLY TO CLEANUP AND NOT RETRY
*                                      (IF ESTA EXIT AND 33E       0023
*                                      COMPLETION CODE THE DUMP IS 0023
*                                      TAKEN AFTER ENTRY TO THE    0023
*                                      RECOVERY ROUTINE,IF THE     0023
*                                      COMPLETION CODE IS OTHER THAN
*                                      33E AND IT IS AN ESTA EXIT THE
*                                      DUMP IS TAKEN BEFORE ENTRY TO
*                                      THE RECOVERY ROUTINE)         */
*            8 SDWANRBE BIT(1),     /* ON,RB ASSOCIATED WITH THIS  0023
*                                      ESTA EXIT WAS NOT IN CONTROL
*                                      AT TIME OF ERROR              */
*            8 SDWASTAE BIT(1),     /* ON,THIS ESTA EXIT HAS BEEN  0023
*                                      ENTERED FOR A PREVIOUS ABEND.
*                                      NEVER ON FOR FRRS.            */
*            8 SDWACTS BIT(1),      /* ON,THIS TASK WAS NOT IN     0023
*                                      CONTROL AT TIME OF ERROR BUT A
*                                      TASK WITHIN THE SAME JOBSTEP
*                                      TREE REQUESTED A 'STEP' ABEND.
*                                      ONLY 'ON' IF SDWACLUP IS 'ON'.*/
*            8 SDWAMABD BIT(1),     /* ON,THIS TASK WAS NOT IN     0023
*                                      CONTROL AT TIME OF ERROR BUT
*                                      AN ANCESTOR OF THIS TASK HAS
*                                      ABENDED. ONLY 'ON' IF SDWACLUP
*                                      IS 'ON'                       */
*            8 SDWARPIV BIT(1),     /* ON, THE REGISTERS AND PSW AT
*                                      TIME OF ERROR ARE UNAVAILABLE */
*            8 SDWAMCIV BIT(1),     /* ON, MACHINE CHECK ERROR     0023
*                                      INFORMATION IS UNAVAILABLE.   */
*            8 * BIT(1),            /* RESERVED                      */
*          6 SDWAFMID CHAR(2),      /* ASID OF MEMORY IN WHICH ERROR
*                                      OCCURRED =0, IF MEMORY IS   0023
*                                      CURRENT NOT=0, IF OTHER MEMORY
*                                      IS CURRENT. FOR FRRS- IF THE
*                                      VALUE IS NON ZERO THE FRR IS
*                                      RECEIVING CONTROL IN THE    0023
*                                      MASTER SCHEDULER ADDRESS SPACE
*                                      AND CANNOT ADDRESS THE PRIVATE
*                                      AREA OF THE FAILING ADDRESS 0023
*                                      SPACE. FOR ESTA- IF THE VALUE
*                                      IS NON ZERO ENTRY IS DUE TO 0023
*                                      CROSS MEMORY ABTERM.          */
*          6 SDWAIOFS CHAR(1),      /* THIS IS THE CURRENT I/O     0023
*                                      STATUS.(THE I/O PROCESSING  0023
*                                      REQUESTED BY THE FIRST (E)STA
*                                      EXIT IS THE ONLY REQUEST    0023
*                                      HONORED )                     */
*            8 SDWAIOQR BIT(1),     /* ON,I/O FOR FAILING PROGRAM HAS
*                                      BEEN QUIESCED AND IS        0023
*                                      RESTOREABLE                   */
*            8 SDWAIOHT BIT(1),     /* ON,I/O FOR FAILING PROGRAM IS
*                                      HALTED AND IS NOT RESTOREABLE */
*            8 SDWANOIO BIT(1),     /* ON,FAILING PROGRAM HAS NO I/O
*                                      OUTSTANDING                   */
*            8 SDWANIOP BIT(1),     /* ON,USER REQUESTED NO I/O    0023
*                                      PROCESSING                    */
*            8 * BIT(4),            /* RESERVED                      */
*          6 * CHAR(1),             /* RESERVED                      */
*          6 SDWARTYA PTR(31),      /* ADDRESS OF RETRY ROUTINE      */
*          6 SDWARECA PTR(31),      /* ADDRESS OF VARIABLE RECORDING
*                                      AREA WITHIN SDWA              */
*          6 SDWACPUA CHAR(4) BDY(WORD),/* ADDRESS OF CPU HOLDING  0023
*                                      RESOURCE WHICH CAUSES VALID 0023
*                                      SPIN ON CURRENT CPU-USED WITH
*                                      RESTART KEY ERROR TYPE.IF THIS
*                                      FIELD IS VALIDLY FILLED IN BY
*                                      AN FRR THE FRRS MAINLINE    0023
*                                      PROGRAM WILL BE RESUMED AT THE
*                                      NEXT SEQUENTIAL INSTRUCTION.
*                                      NOT VALID FOR ESTAE EXITS.    */
*           7 * CHAR(2),            /* RESERVED                      */
*           7 SDWALCPU PTR(15) BDY(HWORD),/* LOGICAL ADDRESS OF CPU
*                                      HOLDING RESOURCE              */
*          6 SDWAPARQ CHAR(4),      /* FLAGS SET BY RECOVERY ROUTINE
*                                      TO REQUEST FUR- THEIR       0023
*                                      PROCESSING ACTION             */
*           7 SDWARCDE CHAR(1),     /* RETURN CODE FROM RECOVERY   0023
*                                      ROUTINE TO INDICATE RETRY OR
*                                      TERMINATION ACTIONS : 0,    0023
*                                      CONTINUE WITH TERMINATION THIS
*                                      INDICATION IMPLIES PERCOLATION
*                                      4, RETRY 16, PREVENT FURTHER
*                                      (E)STAI PROCESSING            */
*           7 SDWAACF2 CHAR(1),     /* FLAGS TO INDICATE ADDITIO- NAL
*                                      PROCESSING REQUESTS           */
*            8 SDWARCRD BIT(1),     /* ON,RECORDING REQUESTED        */
*            8 * BIT(1),            /* RESERVED                      */
*            8 SDWASPIN BIT(1),     /* ON,PROGRAM INTERRUPTED VIA THE
*                                      RESTART KEY WAS IN A VALID  0023
*                                      SPIN(SET BY THE SETRP MACRO 0023
*                                      WHEN CPU ADDRESS IS SPECIFIED
*                                      ALONG WITH CPU ADDRESS IN   0023
*                                      SDWACPUA FIELD TO ALLOW     0023
*                                      RESTART OF ALTERNATE CPU)     */
*            8 * BIT(1),            /* RESERVED                      */
*            8 SDWAUPRG BIT(1),     /* ON,UPDATED REGISTERS STARTING
*                                      WITH SDWASR00 ARE TO BE USED
*                                      FOR RETRY                     */
*            8 SDWAFREE BIT(1),     /* ON,SDWA/RTCA TO BE FREED PRIOR
*                                      TO RETRY ONLY VALID FOR ESTA
*                                      EXITS                         */
*            8 * BIT(2),            /* RESERVED                      */
*           7 SDWAACF3 CHAR(1),     /* FLAGS INDICATING WHAT GLOBAL
*                                      LOCKS ARE TO BE FREED (KEY 0
*                                      SUPERVISOR ONLY.) ONLY VALID
*                                      FOR FRRS                      */
*            8 * BIT(3),            /* RESERVED                      */
*            8 SDWADISP BIT(1),     /* ON THE DISPATCHER LOCK        */
*            8 SDWAASMP BIT(1),     /* ON, THE ASMPAT LOCK           */
*            8 SDWASALL BIT(1),     /* ON, THE SALLOC LOCK           */
*            8 SDWAIPRG BIT(1),     /* ON, THE IOSYNCH LOCK          */
*            8 SDWAICAT BIT(1),     /* ON,THE IOSCAT LOCK            */
*           7 SDWAACF4 CHAR(1),     /* ADDITIONAL LOCKS TO BE FREED  */
*            8 SDWAIUCB BIT(1),     /* ON,THE IOSUCB LOCK            */
*            8 SDWAILCH BIT(1),     /* ON, THE IOSLCH LOCK           */
*            8 SDWATNCB BIT(1),     /* ON,THE NCB LOCK               */
*            8 SDWATDNB BIT(1),     /* ON,THE DNCB LOCK              */
*            8 SDWATADB BIT(1),     /* ON,THE ACBDEBS LOCK           */
*            8 SDWAOPTM BIT(1),     /* ON,THE SYSTEM RESOURCE      0023
*                                      MGR(SRM) LOCK                 */
*            8 SDWACMS BIT(1),      /* ON,THE CMS LOCK               */
*            8 SDWAFLLK BIT(1),     /* ON,THE LOCAL LOCK             */
*          6 SDWALKWA CHAR(36) BDY(WORD),/* LOCK AREA                */
*           7 SDWALKWS CHAR(32) BDY(WORD),/* LOCKWORDS REQUIRED TO 0023
*                                      FREE THE GLOBAL LOCKS ONLY  0023
*                                      USED FOR FRRS                 */
*            8 SDWAICLW PTR(31),    /* LOCKWORD FOR THE IOSCAT LOCK  */
*            8 SDWAIULW PTR(31),    /* LOCKWORD FOR THE IOSUCB LOCK  */
*            8 SDWAILLW PTR(31),    /* LOCKWORD FOR THE IOSLCH LOCK  */
*            8 SDWAIPLW PTR(31),    /* LOCKWORD FOR THE IOSYNCH LOCK */
*            8 SDWAAPLW PTR(31),    /* LOCKWORD FOR THE ASMPAT LOCK  */
*            8 SDWATNLW PTR(31),    /* LOCKWORD FOR THE NCB LOCK     */
*            8 SDWATDLW PTR(31),    /* LOCKWORD FOR THE DNCB LOCK    */
*            8 SDWATALW PTR(31),    /* LOCKWORD FOR THE ACBDEBS LOCK */
*           7 * PTR(31),            /* RESERVED                      */
*          6 SDWARECP CHAR(24),     /* RECORDING PARAMETERS (MODULE
*                                      ,CSECT,AND RECOVERY ROUTINE 0023
*                                      NAME-RESPECTIVELY)            */
*           7 SDWAMODN CHAR(8),     /* THE MODULE NAME INVOLVED IN 0023
*                                      THE ERROR (SUPPLIED BY THE  0023
*                                      RECOVERY ROUTINE)             */
*           7 SDWACSCT CHAR(8),     /* THE CSECT NAME INVOLVED IN THE
*                                      ERROR(SUPPLIED BY THE RECOVERY
*                                      ROUTINE)                      */
*           7 SDWAREXN CHAR(8),     /* THE RECOVERY ROUTINE NAME   0023
*                                      HANDLING THE ERROR            */
*          6 SDWADPLA PTR(31),      /* POINTER TO DUMP PARAMETER LIST
*                                      RESIDING IN SDWA.             */
*          6 SDWASNPA CHAR(8),      /* SNAP PARAMETER LIST FLAGS     */
*           7 SDWADUMP CHAR(4),     /* DUMP CHARACTERISTICS          */
*            8 SDWADPID CHAR(1),    /* ID OF DUMP REQUESTED          */
*            8 SDWADPFS CHAR(1),    /* DUMP FLAGS                    */
*             9 SDWADPT BIT(1),     /* ALWAYS OFF,INDICATES SNAP DUMP
*                                      REQUEST                       */
*             9 SDWADLST BIT(1),    /* ALWAYS ON, INDICATES OS/VS2 0023
*                                      REL. 2 DUMP PARAMETER LIST  0023
*                                      SUPPLIED. USED BY RTM TO    0023
*                                      INDICATE DUMP OPTIONS ARE   0023
*                                      AVAILABLE IN THE SDWA         */
*             9 * BIT(4),           /* RESERVED.                     */
*             9 SDWASLST BIT(1),    /* ON,STORAGE LIST SUPPLIED FOR
*                                      DUMP                          */
*             9 * BIT(1),           /* RESERVED                      */
*            8 * CHAR(2),           /* RESERVED                      */
*           7 SDWADDAT CHAR(4),     /* SDATA/PDATA OPTIONS           */
*            8 SDWASDAT CHAR(1),    /* SDATA OPTIONS                 */
*             9 SDWANUC BIT(1),     /* DISPLAY NUCLEUS               */
*             9 SDWASQA BIT(1),     /* DISPLAY SQA                   */
*             9 SDWALSQA BIT(1),    /* DISPLAY LSQA                  */
*             9 SDWASWA BIT(1),     /* DISPLAY SWA                   */
*             9 SDWAGTF BIT(1),     /* DISPLAY GTF INCORE TRACE TABLE*/
*             9 SDWACBS BIT(1),     /* FORMAT AND DISPLAY CONTROL  0023
*                                      BLOCKS                        */
*             9 SDWAQQS BIT(1),     /* FORMAT AND DISPLAY QCBS/ QELS */
*             9 * BIT(1),           /* RESERVED                      */
*            8 * CHAR(1),           /* RESERVED                      */
*            8 SDWAPDAT CHAR(1),    /* PDATA OPTIONS                 */
*             9 SDWADSAS BIT(1),    /* DISPLAY SAVE AREAS            */
*             9 SDWADSAH BIT(1),    /* DISPLAY SAVE AREA HEADER      */
*             9 SDWADREG BIT(1),    /* DISPLAY REGISTERS             */
*             9 SDWATLPA BIT(1),    /* DISPLAY LPA MODULES OF TASK   */
*             9 SDWATJPA BIT(1),    /* DISPLAY JPA MODULES OF TASK   */
*             9 SDWADPSW BIT(1),    /* DISPLAY PSW                   */
*             9 SDWAUSPL BIT(1),    /* DISPLAY USER SUBPOOLS         */
*             9 * BIT(1),           /* RESERVED                      */
*            8 * CHAR(1),           /* RESERVED                      */
*          6 SDWADPSA CHAR(36) BDY(WORD),/* DUMP RANGES AREA         */
*           7 SDWADPSL CHAR(32) BDY(WORD),/* DUMP STORAGE LISTS(MAX 4
*                                      RANGES AVAILABLE)             */
*            8 SDWAFRM1 PTR(31),    /* BEGINNING ADDRESS FOR STORAGE
*                                      RANGE 1                       */
*            8 SDWATO1 PTR(31),     /* ENDING ADDRESS FOR STORAGE  0023
*                                      RANGE 1                       */
*            8 SDWAFRM2 PTR(31),    /* BEGINNING ADDRESS FOR STORAGE
*                                      RANGE 2                       */
*            8 SDWATO2 PTR(31),     /* ENDING ADDRESS FOR STORAGE  0023
*                                      RANGE 2                       */
*            8 SDWAFRM3 PTR(31),    /* BEGINNING ADDRESS FOR STORAGE
*                                      RANGE 3                       */
*            8 SDWATO3 PTR(31),     /* ENDING ADDRESS FOR STORAGE  0023
*                                      RANGE 3                       */
*            8 SDWAFRM4 PTR(31),    /* BEGINNING ADDRESS FOR STORAGE
*                                      RANGE 4                       */
*            8 SDWATO4 PTR(31),     /* ENDING ADDRESS FOR STORAGE  0023
*                                      RANGE 4                       */
*           7 * PTR(31),            /* RESERVED                      */
*          6 SDWARCPL CHAR(28) BDY(WORD),/* RESERVED FOR RTM USE     */
*          6 SDWACOMP PTR(31),      /* THIS WORD IS PROVIDED FOR   0023
*                                      COMMUNICATION OF ADDITIONAL 0023
*                                      RECOVERY DATA ON A PER      0023
*                                      COMPONENT BASIS (FOR OS/VS2 0023
*                                      RELEASE 2 THIS FIELD IS ONLY
*                                      USED BY DATA MANAGER).        */
*          6 * PTR(31),             /* RESERVED                      */
*          6 SDWARA CHAR(112),      /* VARIABLE RECORDING AREA     0023
*                                      PREFIXED BY TWO BYTE LENGTH 0023
*                                      FIELD OF AREA AND A TWO BYTE
*                                      FIELD WITH LENGTH OF USER   0023
*                                      SUPPLIED INFORMATION          */
*           7 SDWAVRAL CHAR(2),     /* LENGTH OF VARIABLE RECORD- ING
*                                      AREA                          */
*           7 SDWADPVA CHAR(1),     /* DEFINES DUMPING OF DATA IN  0023
*                                      VARIABLE AREA.                */
*            8 SDWAHEX BIT(1),      /* DATA TO BE DUMPED BY EREP IN
*                                      HEX.                          */
*            8 SDWAEBC BIT(1),      /* DATA TO BE DUMPED BY EREP   0023
*                                      EBCDIC.                       */
*            8 * BIT(6),            /* RESERVED                      */
*           7 SDWAURAL CHAR(1),     /* LENGTH OF USER SUPPLIED     0023
*                                      INFORMATION                   */
*           7 SDWAVRA CHAR(108),    /* VARIABLE RECORDING AREA       */
*          6 * CHAR(0) BDY(DWORD);  /* ROUND UP TO DOUBLE WORD       */
*/* THESE CONSTANTS MAP RETURN CODES FROM AN EXIT IN FIELD           */
*/* SDWARCDE                                                         */
*                                                                  0024
*   DECLARE                                                        0024
*     SDWACWT CONSTANT(0),          /* CONTINUE WITH TERMINATION.  0024
*                                      THIS INDICATION IMPLIES     0024
*                                      PERCOLATION                   */
*     SDWARETY CONSTANT(4),         /* RETRY USING RETRY ADDRESS IN
*                                      SDWARTYA FIELD                */
*     SDWAPSTI CONSTANT(16);        /* PREVENT FURTHER (E)STAI     0024
*                                      PROCESSING                  0024
*                                                                    */
*                                                                  0025
*/* **************************************************************** */
*/*                                                                  */
*/*            ADDRESS SPACE CONTROL BLOCK                           */
*/*                                                                  */
*/*  OS/VS2 RELEASE 2, 07/10/73, LEVEL=13                            */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*      BAL  - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.      */
*/*             USING ON ASCB GIVES ADDRESSABILITY FOR ALL SYMBOLS.  */
*/*      PL/S - DCL ASCBPTR PTR                                      */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0025
*   DCL                                                            0025
*     1 ASCB BASED(ASCBPTR) BDY(DWORD),                            0025
*      2 ASCBEGIN CHAR(0),          /* BEGINNING OF ASCB             */
*      2 ASCBASCB CHAR(4) BDY(WORD),/* ACRONYM IN EBCDIC -ASCB-      */
*      2 ASCBFWDP PTR(31),          /* ADDRESS OF NEXT ASCB ON ASCB
*                                      READY QUEUE                   */
*      2 ASCBBWDP PTR(31),          /* ADDRESS OF PREVIOUS ASCB ON 0025
*                                      ASCB READY QUEUE              */
*      2 ASCBLOCK FIXED(31),        /* LOCAL LOCK                    */
*      2 ASCBIOSP PTR(31),          /* POINTER TO IOS PURGE INTERFACE
*                                      CONTROL BLOCK (IPIB)          */
*      2 ASCBFSLQ PTR(31),          /* POINTER TO FIRST SUSPENDED SRB
*                                      ON THE LOCK SUSPENDED SRB   0025
*                                      QUEUE                         */
*      2 ASCBLSLQ PTR(31),          /* POINTER TO LAST SUSPENDED SRB
*                                      ON THE LOCK SUSPENDED SRB   0025
*                                      QUEUE                         */
*      2 ASCBSPL PTR(31),           /* POINTER TO SPL                */
*      2 ASCBCPUS FIXED(31),        /* NUMBER OF CPU'S ACTIVE IN THIS
*                                      MEMORY MDC007                 */
*      2 ASCBASID BIT(16) BDY(WORD),/* ADDRESS SPACE IDENTIFIER FOR
*                                      THE ASCB                      */
*      2 ASCBSEQN FIXED(15),        /* SEQUENCE NUMBER THAT        0025
*                                      REPRESENTS THE ASCB'S POSITION
*                                      ON THE DISPATCHING QUEUE      */
*      2 ASCBIOSM FIXED(15) BDY(WORD),/* I/O SERVICE MEASURE         */
*      2 ASCBRV07 PTR(8),           /* RESERVED MDC017               */
*      2 ASCBDP PTR(8),             /* DISPATCHING PRIORITY RANGE  0025
*                                      FROM 0-255                    */
*      2 ASCBSTOR PTR(31),          /* TABLE LENGTH AND REAL ADDRESS
*                                      OF SEGMENT TABLE IN THE SAME
*                                      FORMAT AS CONTROL REGISTER ONE
*                                      MDC027                        */
*      2 ASCBLDA PTR(31),           /* POINTER TO LOCAL DATA AREA  0025
*                                      PART OF LSQA FOR VSM          */
*      2 ASCBRSM PTR(31),           /* ADDRESS OF RSM'S CONTROL BLOCK
*                                      HEADER                        */
*      2 ASCBCSCB PTR(31),          /* ADDRESS OF CSCB               */
*      2 ASCBTSB PTR(31),           /* ADDRESS OF TSB                */
*      2 ASCBEJST BIT(64) BDY(DWORD),/* ELAPSED JOB STEP TIMING    0025
*                                      UNSIGNED 64-BIT BINARY NUMBER */
*      2 ASCBEWST BIT(64) BDY(DWORD),/* TIME OF DAY WHENEVER I-STREAM
*                                      IS SWITCHED FROM A MEMORY     */
*      2 ASCBJSTL BIT(32) BDY(WORD),/* CPU TIME LIMIT FOR THE JOB  0025
*                                      STEP                          */
*      2 ASCBECB BIT(32) BDY(WORD), /* RCT'S WORK ECB                */
*      2 ASCBUBET BIT(32) BDY(WORD),/* TIME STAMP WHEN USER BECAME 0025
*                                      READY                         */
*      2 ASCBQSVC FIXED(31),        /* CPID FOR SVRB QUICKCELL       */
*      2 ASCBDUMP PTR(31),          /* SVC DUMP'S ECB POINTER        */
*      2 ASCBFW1 FIXED(31),         /* FULL-WORD LABEL TO BE USED FOR
*                                      COMPARE AND SWAP FOR ANY BIT
*                                      IN THIS WORD MDC026           */
*       3 ASCBAFFN BIT(16) BDY(WORD),/* CPU AFFINITY INDICATOR       */
*       3 ASCBRCTF BIT(8),          /* FLAGS FOR RCT                 */
*        4 ASCBTMNO BIT(1),         /* MEMORY IS BEING QUIESCED, IS
*                                      QUIESCED, OR IS BEING RESTORED*/
*        4 ASCBFRS BIT(1),          /* RESTORE REQUEST               */
*        4 ASCBFQU BIT(1),          /* QUICESCE REQUEST              */
*        4 ASCBRV08 BIT(1),         /* RESERVED (MDC031)       YM2236*/
*        4 ASCBWAIT BIT(1),         /* LONG WAIT INDICATOR           */
*        4 ASCBOUT BIT(1),          /* ADDRESS SPACE CONSIDERED    0025
*                                      SWAPPED OUT                   */
*        4 ASCBTMLW BIT(1),         /* MEMORY IS IN A LONG WAIT      */
*        4 ASCBRF01 BIT(1),         /* RESERVED                      */
*       3 ASCBFLG1 BIT(8),          /* FLAG BYTE                     */
*        4 ASCBTOFF BIT(1),         /* MEMORY SHOULD NOT BE CHECKED
*                                      FOR JOB STEP TIMING           */
*        4 ASCBCMSH BIT(1),         /* CMS LOCK HELD                 */
*        4 ASCBS3S BIT(1),          /* STAGE II EXIT EFFECTOR HAS  0025
*                                      SCHEDULED A RQE OR IQE AND  0025
*                                      STAGE III EXIT EFFECTOR SHOULD
*                                      BE INVOKED                    */
*        4 ASCBTERM BIT(1),         /* ADDRESS SPACE TERMINATING   0025
*                                      NORMALLY                      */
*        4 ASCBABNT BIT(1),         /* ADDRESS SPACE TERMINATING   0025
*                                      ABNORMALLY                    */
*        4 ASCBSTND BIT(1),         /* TCB'S NON-DISPATCHABLE        */
*        4 ASCBTYP1 BIT(1),         /* TYPE1 SVC HAS CONTROL         */
*        4 ASCBNSWP BIT(1),         /* PROGRAM IS NON SWAPPABLE OR 0025
*                                      WILL RUN IN V=R REGION        */
*      2 ASCBTMCH PTR(31),          /* TERMINATION QUEUE CHAIN       */
*      2 ASCBASXB PTR(31),          /* POINTER TO ADDRESS SPACE    0025
*                                      EXTENSION CONTROL BLOCK (ASXB)*/
*      2 ASCBSWCT FIXED(15) BDY(WORD),/* NUMBER OF TIMES MEMORY    0025
*                                      ENTERS SHORT WAIT             */
*      2 ASCBDSP1 BIT(8),           /* NON-DISPATCHABILITY FLAGS     */
*       3 ASCBNOQ BIT(1),           /* ASCB NOT ON ASCB DISPATCHING
*                                      QUEUE                         */
*       3 ASCBFAIL BIT(1),          /* A FAILURE HAS OCCURRED WITHIN
*                                      THE ADDRESS SPACE. THE MEMORY
*                                      IS NONDISPATCHABLE            */
*       3 ASCBRF02 BIT(1),          /* RESERVED MDC013               */
*       3 ASCBRF03 BIT(1),          /* RESERVED MDC014               */
*       3 ASCBRF04 BIT(1),          /* RESERVED                      */
*       3 ASCBRF05 BIT(1),          /* RESERVED                      */
*       3 ASCBRF06 BIT(1),          /* RESERVED                      */
*       3 ASCBRF07 BIT(1),          /* RESERVED                      */
*      2 ASCBFLG2 BIT(8),           /* FLAG BYTE MDC015              */
*       3 ASCBXMPT BIT(1),          /* ASCB EXEMPT FROM SYSTEM     0025
*                                      NON-DISPATCHABLE MDC013       */
*       3 ASCBPXMT BIT(1),          /* ASCB PERMANENTLY EXEMPT FROM
*                                      SYSTEM NON-DISPATCHABLE MDC014*/
*       3 ASCBCEXT BIT(1),          /* CANCEL TIMER EXTENSION BECAUSE
*                                      EOT PROCESSING IS STARTED FOR
*                                      THE JOB STEP TCB MDC021       */
*       3 ASCBS2S BIT(1),           /* FOR LOCK MANAGER, ENTRY MADE
*                                      TO STAGE II EXIT EFFECTOR   0025
*                                      WITHOUT CORRESPONDING ENTRY TO
*                                      STAGE III EXIT EFFECTOR MDC020*/
*       3 ASCBSNQS BIT(1),          /* STATUS STOP NON-QUIESCEABLE 0025
*                                      LEVEL SRB'S MDC028            */
*       3 ASCBRV04 BIT(1),          /* RESERVED                      */
*       3 ASCBRV05 BIT(1),          /* RESERVED                      */
*       3 ASCBRV06 BIT(1),          /* RESERVED                      */
*      2 ASCBSSRB FIXED(15) BDY(WORD),/* COUNT OF STATUS STOP SRB'S  */
*      2 ASCBSRBS FIXED(15),        /* COUNT OF SRB'S DISPATCHED IN
*                                      THIS MEMORY                   */
*      2 ASCBVSC FIXED(15) BDY(WORD),/* ALLOCATED AUXILIARY SLOT   0025
*                                      COUNT (VAM) MDC004            */
*      2 ASCBNVSC FIXED(15),        /* ALLOCATED AUXILIARY SLOT COUNT
*                                      (NON-VAM) MDC005              */
*      2 ASCBTCBS FIXED(31),        /* NUMBER OF READY TCB'S IN THIS
*                                      MEMORY MDC006                 */
*      2 ASCBCMSF PTR(31),          /* ADDRESS OF NEXT ASCB ON CMS 0025
*                                      SUSPEND QUEUE                 */
*      2 ASCBCMSB PTR(31),          /* ADDRESS OF PREVIOUS ASCB ON 0025
*                                      CMS SUSPEND QUEUE             */
*      2 ASCBQECB BIT(32) BDY(WORD),/* QUIESCE ECB                   */
*      2 ASCBMECB BIT(32) BDY(WORD),/* MEMORY CREATE/DELETE ECB      */
*      2 ASCBOUCB PTR(31),          /* SYSTEM RESOURCES MANAGER (SRM)
*                                      USER CONTROL BLOCK POINTER    */
*      2 ASCBOUXB PTR(31),          /* SYSTEM RESOURCES MANAGER (SRM)
*                                      USER EXTENSION BLOCK POINTER  */
*      2 ASCBFMCT FIXED(15) BDY(WORD),/* ALLOCATED PAGE FRAME COUNT  */
*      2 ASCBRS01 FIXED(15),        /* RESERVED FOR FUTURE USE       */
*      2 ASCBXMPQ PTR(31),          /* POINTER TO XMPOST SRB QUEUE 0025
*                                      MDC023                        */
*      2 ASCBIQEA PTR(31),          /* POINTER TO IQE FOR ATCAM    0025
*                                      ASYNCHRONOUS PROCESSING MDC010*/
*      2 ASCBRTWA PTR(31),          /* POINTER TO LAST RTM2 WORK AREA
*                                      ACQUIRED FROM SQA MDC011      */
*      2 ASCBMCC CHAR(4) BDY(WORD), /* USED TO HOLD A MEMORY       0025
*                                      TERMINATION COMPLETION CODE ON
*                                      ABNORMAL MEMORY TERMINATION 0025
*                                      MDC012                        */
*      2 ASCBJBNI PTR(31),          /* POINTER TO JOBNAME FIELD FOR
*                                      INITIATED PROGRAMS OR ZERO  0025
*                                      MDC018                        */
*      2 ASCBJBNS PTR(31),          /* POINTER TO JOBNAME FIELD FOR
*                                      START/MOUNT/LOGON OR ZERO   0025
*                                      MDC019                        */
*      2 ASCBLGCB PTR(31),          /* ADDRESS OF LOGICAL GROUP CHAIN
*                                      BLOCK (LGCB) CHAIN MDC022     */
*      2 ASCBVGTT PTR(31),          /* ADDRESS OF VSAM GLOBAL      0025
*                                      TERMINATION TABLE (VGTT)    0025
*                                      MDC024                        */
*      2 ASCBPCTT PTR(31),          /* ADDRESS OF PRIVATE CATALOG  0025
*                                      TERMINATION TABLE (PCTT)    0025
*                                      MDC025                        */
*      2 ASCBRS12 FIXED(15),        /* RESERVED FOR FUTURE USE       */
*      2 ASCBSMCT PTR(8),           /* NUMBER OF OUTSTANDING STEP  0025
*                                      MUST COMPLETE REQUESTS IN   0025
*                                      ADDRESS SPACE MDC016          */
*      2 ASCBRS14 BIT(8),           /* RESERVED FOR FUTURE USE       */
*      2 ASCBSWTL FIXED(31),        /* STEP WAIT TIME LIMIT MDC029   */
*      2 ASCBSRBT CHAR(8) BDY(DWORD),/* ACCUMULATED SRB TIME MDC030  */
*      2 ASCBEND CHAR(0) BDY(DWORD);/* END OF ASCB                 0025
*                                                                    */
*                                                                  0026
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATION OF MAPPING BASES                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0026
*   DCL                                                            0026
*     PCTPTR PTR(31) REG(2) RSTD;   /* THE ADDRESS OF THE GTFPCT IS
*                                      PASSED BY CONVENTION IN GPR2  */
*   DCL                                                            0027
*     AWSAPTR PTR(31) REG(3) RSTD;  /* THE ADDRESS OF THE MCAWSA IS
*                                      PASSED BY CONVENTION IN GPR 3 */
*   DCL                                                            0028
*     CVTPTR LOCATION(16);                                         0028
*   DCL                                                            0029
*    (SRBPTR,                                                      0029
*     ASCBPTR,                                                     0029
*     FRREPTR,                                                     0029
*     FRRSPTR) PTR(31) BASED;       /* PTRS FOR SRB, FRR, & ASCB   0029
*                                      MAPPINGS THAT AREN'T BEING  0029
*                                      USED BUT HAVE TO BE DECLARED
*                                      BECAUSE THEY ARE IN THE     0029
*                                      MAPPINGS                      */
*   DCL                                                            0030
*     SDWAPTR PTR(31) REG(7);       /* THIS IS THE BASE FOR THE SDWA,
*                                      THE WORK AREA FOR RTM AND THE
*                                      FRRS                        0030
*                                                                    */
*                                                                  0031
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATIONS OF LABELS, CONSTANTS, AND ENTRIES                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0031
*   DCL                                                            0031
*     AHLSFEOB LABEL EXTERNAL;      /* DECLARED AS EXTERNAL TO CAUSE
*                                      AN ENTRY TO BE MADE IN THE ESD*/
*   DCL                                                            0032
*     FEOBALTE LABEL INTERNAL,                                     0032
*     FEOBNTRY ENTRY BASED(ADDR(FEOBALTE));/* A PSEUDO-NAME DECLARED
*                                      AS ENTRY IS REQUIRED TO PERMIT
*                                      A CALL TO FEOBALTE            */
*   DCL                                                            0033
*     AHLSBFRR LABEL;               /* ENTRY POINT OF FUNCTIONAL   0033
*                                      RECOVERY ROUTINE              */
*   DCL                                                            0034
*     PLACE LABEL BASED;                                           0034
*   DCL                                                            0035
*     RCSUCCSS CONSTANT(0) FIXED(31);/* SUCCESSFUL RETURN CODE       */
*   DCL                                                            0036
*     RCFAIL CONSTANT(4) FIXED(31); /* USED TO SET A RETURN CODE   0036
*                                      MEANING FAILURE               */
*   DCL                                                            0037
*     ON CONSTANT('1'B) BIT(1),                                    0037
*     OFF CONSTANT('0'B) BIT(1);    /* USED TO SET & TEST BITS     0037
*                                                                    */
*                                                                  0038
*   /*****************************************************************/
*   /*                                                               */
*   /* REGISTER ASSIGNMENTS OTHER THAN MAPPING BASES                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0038
*   DCL                                                            0038
*     CURRENT REG(4) PTR(31) RSTD;  /* HOLDS THE STABLE VALUE OF   0038
*                                      CURRBLOK THAT WILL BE USED  0038
*                                      THROUGHOUT AHLSBLOK SINCE THE
*                                      REAL CURRBLOK MAY CHANGE. THIS
*                                      IS ALSO A PARM TO AHLSFEOB. 0038
*                                      AND IS BY CONVENTION GPR4   0038
*                                      AHLSFEOB WILL NOT UPDATE THIS
*                                      PTR                           */
*   DCL                                                            0039
*    (COMPREG REG(8),                                              0039
*     SWAPREG REG(9)) PTR(31);      /* USED FOR CS                   */
*   DCL                                                            0040
*     BLOKCURR PTR(31) REG(7);      /* USED IN AHLSFEOB TO MAINTAIN A
*                                      STABLE COPY OF CURRBLOK       */
*   DCL                                                            0041
*     LRRECPTR PTR(31) REG(6);      /* USED TO POINT TO SPACE      0041
*                                      RESERVED FOR LOSTRECR IN A  0041
*                                      GTFBLOK                       */
*   DCL                                                            0042
*     RECPTR PTR(31) REG(1) RSTD;   /* PTR TO THE BEGINNING OF THE 0042
*                                      TRACE RECORD TO BE BLOCKED BY
*                                      CONVENTION THIS WILL BE PASSED
*                                      FROM THE FGBR VIA THE AHLSTACK
*                                      MACRO IN REG1                 */
*   DCL                                                            0043
*     RCREG PTR(31) REG(15);        /* USED TO SET A RETURN CODE OF:
*                                      0 FOR RECORD BLOCK OR 4 FOR 0043
*                                      RECORD LOST, BY AHLSBLOK.   0043
*                                      AHLSFEOB SETS 0 FOR FEOB DONE
*                                      OR 4 FOR NO FEOB DONE         */
*   DCL                                                            0044
*     MVCLTPTR REG(6) PTR(31),      /* THESE 4 REGS ARE USED FOR AN  */
*     MVCLTLEN REG(7) PTR(31),      /* MVCL INSTRUCTION              */
*     MVCLFPTR REG(8) PTR(31),      /* THESE MUST BE EVEN-ODD PAIRS  */
*     MVCLFLEN REG(9) PTR(31);                                     0044
*   DCL                                                            0045
*    (FRREPAD REG(6),                                              0045
*     SETFREG1 REG(8),                                             0045
*     SETFREG2 REG(9)) PTR(31);     /* USED FOR PARAMETERS TO THE  0045
*                                      SETFRR MCARO                  */
*   DCL                                                            0046
*     BASEREG PTR(31) REG(12) RSTD; /* RESTRICTS BASE REGISTER THIS
*                                      IS NEEDED BECAUSE NOCODEREG IS
*                                      SPECIFIED ON THE PROC OPTIONS */
*   DCL                                                            0047
*     RTRNREG REG(14) PTR(31),                                     0047
*     FRR14SAV PTR(31) REG(8);      /* USED TO SAVE THE RETURN     0047
*                                      ADDRESS IN IN THE FRR PORTION
*                                      OF THE CODE                   */
*   DCL                                                            0048
*     R1 PTR(31) REG(1);                                           0048
*                                                                  0049
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATIONS: BECAUSE THIS MODULE MUST BE TOTALLY REENTRANT NO*/
*   /* VARIABLE MAY HAVE AN ATTRIBUTE WHICH WILL CAUSE ADDRESS SPACE */
*   /* TO BE ALLOCATED TO IT. THE ONLY EXCEPTION IS THE CONSTANT     */
*   /* ATTRIBUTE. THE AUTOMATIC ATTRIBUTE MUST ALSO BE AVOIDED       */
*   /* BECAUSE NO GETMAIN MAY BE DONE                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0049
*   DCL                                                            0049
*     1 TRCREC CHAR(272) BASED(RECPTR) BDY(WORD),/* A PSEUDO TRACE 0049
*                                      RECORD MAPPING WITH THE LENGTH
*                                      FIELD USED TO REFERENCE THE 0049
*                                      TRACE RECORD BEING BLOCKED    */
*      2 TRECLEN PTR(15);                                          0049
*   DCL                                                            0050
*     1 WORKAREA DEFINED(MCAFWORK) BDY(WORD),/* MAPPING OF THE WORK
*                                      AREA IN THE MCAWSA WHICH IS 0050
*                                      USED INSTEAD OF DEFINED OR  0050
*                                      GOTTEN STORAGE                */
*      2 DWCOMP CHAR(8) BDY(WORD),  /* THIS IS USED TO HOLD THE    0050
*                                      STABLE COPY OF BLOKSWAP FOR 0050
*                                      CDS TO RESERVE GTFBLOK SPACE  */
*       3 * PTR(31),                                               0050
*       3 OLDLEN PTR(15),           /* THIS IS THE OLD BLOKLEN WHICH
*                                      IS USED TO LOCATE THE GTFBLOK
*                                      SPACE THAT HAS BEEN RESERVED
*                                      FOR THE TRACE RECORD AFTER THE
*                                      CDS                           */
*      2 DWSWAP CHAR(8) BDY(WORD),  /* ALTERED VERSION OF BLOKSWAP 0050
*                                      FOR CDS                       */
*       3 CHNFIELD PTR(31),                                        0050
*        4 INUSEBIT BIT(1),                                        0050
*       3 LENFIELD PTR(15),                                        0050
*       3 USEFIELD PTR(15);                                        0050
*   DCL                                                            0051
*     1 LOSTRECR BASED(LRRECPTR),   /* LOST RECORD RECORD FORMAT THIS
*                                      IS USED TO BUILD A LOST RECORD
*                                      RECORD DIRECTLY IN SPACE    0051
*                                      RESERVED IN A GTFBLOK         */
*      2 LRRLEN FIXED(16),                                         0051
*      2 LRRQSAM FIXED(16),                                        0051
*      2 LRRAID FIXED(8),                                          0051
*      2 LRRFID FIXED(8),                                          0051
*      2 LRRCVTTZ CHAR(4),                                         0051
*      2 LRRTODCV CHAR(8),                                         0051
*      2 LRRCNT PTR(31) BDY(BYTE);                                 0051
*   DCL                                                            0052
*     1 LRRPROTO STATIC BDY(WORD),  /* THE INITIAL VALUES OF THE   0052
*                                      FIRST 4 FIELDS OF A LOST    0052
*                                      RECORD RECORD. THESE ARE    0052
*                                      CONSTANT                      */
*      2 * FIXED(16) INIT(LENGTH(LOSTRECR)),/* LENGTH                */
*      2 * CHAR(4) INIT('00000002'X);/* QSAM, AID, FID               */
*   DCL                                                            0053
*     SBLKADDR PTR(31) INIT(ADDR(AHLSBLOK));/* BASE ADDRESS FOR    0053
*                                      ESTABLISHING ADDRESSIBILITY AT
*                                      ALTERNATE E.P.                */
*   DCL                                                            0054
*     RECID CHAR(24) INIT('AHLWSMODAHLSBLOKAHLSBFRR');/* RECORD ID 0054
*                                      FOR SETRP MACRO             0054
*                                                                    */
*                                                                  0055
*   /*****************************************************************/
*   /*                                                               */
*   /* BECAUSE THIS MODULE IS REENTRANT IT SAVES REGS IN THE WORK    */
*   /* AREA MCAWSA. STANDARD LINKAGE CONVENTIONS ARE NOT USED, REGS  */
*   /* ARE SAVED 4-1. REGISTER BASEREG IS USED AS THE BASE REGISTER. */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0055
*/* P SAVE R4-1 IN MCASBLOK AND SET UP THE BASE REG                  */
*/* S SETFRR: ADD AHLSBFRR ADDR TO FRR STACK LIST                    */
*                                                                  0055
*   GEN CODE NOEXIT NOFLOWS SEQFLOW REFS(AWSAPTR) SETS(BASEREG,MCASBLOK
*       ) NODEFS;                                                  0055
   STM    @04,@01,MCASBLOK(AWSAPTR)
   LR   BASEREG,@15
   USING  AHLSBLOK,BASEREG
*   RFY                                                            0056
*     FRREPAD RSTD;                                                0056
*   FRREPAD=ADDR(AHLSBFRR);         /* THE ADDRESS OF THE FRR EP IS
*                                      PUT IN A REG FOR THE MACRO SO
*                                      THAT MORE EFFICIENT CODE WILL
*                                      BE GENERATED                  */
         LA    FRREPAD,AHLSBFRR                                    0057
*   RFY                                                            0058
*    (SETFREG1,                                                    0058
*     SETFREG2) RSTD;               /* WORK REGS FOR SETFRR          */
*   GEN CODE SETS(SETFREG1,SETFREG2) NOEXIT NOFLOWS REFS(PSACSTK,PSA,
*       FRRSCURR,FRRS,FRRSLAST,FRRSELEN,FRRSFRRA,FRRSENTR,PSALSFCC,
*       FRREPAD,FRRSPARM) SEQFLOW NODEFS;                          0059
     SETFRR A,FRRAD=(FRREPAD),WRKREGS=(SETFREG1,SETFREG2)
*   RFY                                                            0060
*    (FRREPAD,                                                     0060
*     SETFREG1,                                                    0060
*     SETFREG2) UNRSTD;                                            0060
*                                                                  0061
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING SECTION OF CODE DOES THE BLOCKING OF THE TRACE  */
*   /* RECORD FOUND IN THE MCAWSA INTO A GTFBLOK IF POSSIBLE.        */
*   /* ------------------------------------------------------------- */
*   /* FIRST IT MUST BE DETERMINED IF THE RECORD WILL FIT INTO THE   */
*   /* GTFBLOK CURRENTLY BEING FILLED                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0061
*/*RESTART: P GET A STABLE COPY OF CURRBLOK (IN CURRENT)             */
*/* N THIS WILL BE USED THROUGHOUT BLOCKING OF THE REC IN PLACE OF 0061
*/* CURRBLOK                                                         */
*/*FIT: P OBTAIN A STABLE COPY OF THE CONTROL PORTION OF THE GTFBLOK TO
*/* BE USED                                                          */
*/* P CALC WHAT THE NEW BLOKLEN WILL BE IF THIS REC IS ADDED         */
*/* D (NO,%SWAP,YES,%IN) IS NEW LENGTH <= MAX & BLKINUSE OFF         */
*                                                                  0061
*RESTART:                                                          0061
*   CURRENT=CURRBLOK;               /* OBTAIN A STABLE COPY OF     0061
*                                      CURRBLOK THIS MUST BE DONE TO
*                                      INSURE THAT THE SAME GTFBLOK
*                                      IS REFERENCED AS CURRENT    0061
*                                      THROUGH OUT THE BLOCKING OF 0061
*                                      THIS REC                      */
RESTART  L     CURRENT,CURRBLOK(,PCTPTR)                           0061
*   RFY                                                            0062
*     RECPTR RSTD;                                                 0062
*FIT:                                                              0063
*   DWSWAP=CURRENT->BLOKSWAP;       /* MAKE A COPY OF THE FIRST 2  0063
*                                      FIELDS OF THE GTFBLOK FOR   0063
*                                      REFERENCE & ALTERATION. SHOULD
*                                      THE GTFBLOK FIELDS NEED     0063
*                                      UPDATING THIS WILL BE USE FOR
*                                      A CDS                         */
FIT      MVC   DWSWAP(8,AWSAPTR),BLOKSWAP(CURRENT)                 0063
*   DWCOMP=DWSWAP;                  /* KEEP AN UNCHANGING COPY FOR 0064
*                                      THE CDS ALSO                  */
         MVC   DWCOMP(8,AWSAPTR),DWSWAP(AWSAPTR)                   0064
*   LENFIELD=LENFIELD+TRECLEN;      /* CALC WHAT THE NEW BLOKLEN WILL
*                                      HAVE TO BE TO ADD THIS RECORD
*                                      AND UPDATE THE COPY WHICH WILL
*                                      BE SWAPPED IN IF SPACE IS   0065
*                                      RESERVED                      */
         LH    @05,LENFIELD(,AWSAPTR)                              0065
         AH    @05,TRECLEN(,RECPTR)                                0065
         STH   @05,LENFIELD(,AWSAPTR)                              0065
*   IF LENFIELD<=LENGTH(BLOKAREA)&INUSEBIT=OFF/* COMPARE THE PROPOSED
*                                      NEW BLOKLEN TO THE MAX      0066
*                                      POSSIBLE BLOKLEN TO SEE IF THE
*                                      RECORD WILL FIT AND CHECK TO
*                                      BE SURE THE BLKINUSE BIT WAS
*                                      OFF                         0066
*                                                                    */
*                                                                  0066
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE RECORD WILL FIT INTO THE GTFBLOK THEN TRY TO PUT IT IN */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0066
*/*%IN: P INCREMENT THE STABLE COPY BLOKUSE BY 1                     */
*/* P CS IN NEW BLOKLEN & BLOKUSE, & VERIFY BLKINUSE BIT STILL OFF   */
*/* D (FAIL,FIT,OK,) CS?                                             */
*/* P MOVE RECORD INTO GTFBLOK SPACE RESERVED                        */
*/* P OBTAIN A STABLE COPY OF THE CONTROL PORTION OF THE GTFBLOK BEING
*/*USED                                                              */
*/*DECR: P DECREMENT THE STABLE COPY BLOKUSE BY 1                    */
*/* P CS IN THE NEW BLOKUSE                                          */
*/* D (FAIL,DECR,OK,) CS?                                            */
*/* P (,%XY1) SET RETURN CODE, R15=0                                 */
*                                                                  0066
*     THEN                                                         0066
         CH    @05,@CH00119                                        0066
         BH    @RF00066                                            0066
         TM    INUSEBIT(AWSAPTR),B'10000000'                       0066
         BNZ   @RF00066                                            0066
*     DO;                                                          0067
*       USEFIELD=USEFIELD+1;        /* PREPARE INCREMENTED USE COUNT
*                                      TO GO INTO THE GTFBLOK ALONG
*                                      WITH THE LENGTH BY UPDATING 0068
*                                      THE COPY THAT WILL BE SWAPPED
*                                      IN                            */
         LA    @05,1                                               0068
         AH    @05,USEFIELD(,AWSAPTR)                              0068
         STH   @05,USEFIELD(,AWSAPTR)                              0068
*       CDS(DWCOMP,DWSWAP,CURRENT->BLOKSWAP);/* ATTEMPT TO UPDATE THE
*                                      GTFBLOK WITH THE NEW VALUES   */
         LM    @06,@07,DWCOMP(AWSAPTR)                             0069
         LM    @08,@09,DWSWAP(AWSAPTR)                             0069
         CDS   @06,@08,BLOKSWAP(CURRENT)                           0069
         BZ    @BC00069                                            0069
         STM   @06,@07,DWCOMP(AWSAPTR)                             0069
@BC00069 DS    0H                                                  0070
*       BC(4,FIT);                  /* IF THE CDS FAILED EITHER THE
*                                      BLKINUSE FLAG WAS ON, THE   0070
*                                      GTFBLOK HAS BEEN BUFFERED BY
*                                      AHLSBUF SO THAT IT IS NEITHER
*                                      CURRENT NOR WAITING TO BE   0070
*                                      BUFFERED, OR SOMEONE ELSE BEAT
*                                      US TO THE SPACE WE WERE TRYING
*                                      TO RESERVE. IN ANY EVENT GO 0070
*                                      BACK AND TRY TO FIT THE RECORD
*                                      IN AGAIN                      */
         BC    4,FIT                                               0070
*       RFY                         /* IF THE CDS COMPLETED MOVE THE
*                                      RECORD INTO THE GTFBLOK SPACE
*                                      RESERVED                      */
*        (MVCLTPTR,                                                0071
*         MVCLTLEN,                                                0071
*         MVCLFPTR,                                                0071
*         MVCLFLEN) RSTD;                                          0071
*       MVCLTPTR=ADDR(CURRENT->BLOKAREA)+OLDLEN;/* THE TRACE RECORD
*                                      IS TO BE MOVED INTO THE     0072
*                                      GTFBLOK BEGINNING WITH WHAT 0072
*                                      WAS THE FIRST UNRESERVED BYTE
*                                      IN THE DATA AREA PORTION    0072
*                                      BEFORE THE CDS WAS DONE       */
         LA    MVCLTPTR,BLOKAREA(,CURRENT)                         0072
         AH    MVCLTPTR,OLDLEN(,AWSAPTR)                           0072
*       MVCLTLEN=TRECLEN;                                          0073
         LH    MVCLTLEN,TRECLEN(,RECPTR)                           0073
*       MVCLFLEN=MVCLTLEN;          /* THE LENGTH OF BOTH FIELDS IS
*                                      THE LENGTH OF THE RECORD      */
         LR    MVCLFLEN,MVCLTLEN                                   0074
*       MVCLFPTR=RECPTR;            /* THE TRACE RECORD WILL BE    0075
*                                      LOCATED VIA THE PTR PASSED BY
*                                      AHLSTACK IN REG1              */
         LR    MVCLFPTR,RECPTR                                     0075
*       GEN(MVCL  MVCLTPTR,MVCLFPTR)                               0076
*       REFS(MVCLTPTR,MVCLTLEN,MVCLFPTR,MVCLFLEN,RECPTR) SETS(BLOKAREA)
*           NOFLOWS SEQFLOW NOEXIT NODEFS;                         0076
         MVCL  MVCLTPTR,MVCLFPTR
*       DWCOMP=CURRENT->BLOKSWAP;   /* ONCE THE DATA IS IN THE     0077
*                                      RESERVED SPACE THE USE COUNT
*                                      MUST BE DECREMENTED IN THE  0077
*                                      SAME WAY IT WAS INCREMENTED   */
         MVC   DWCOMP(8,AWSAPTR),BLOKSWAP(CURRENT)                 0077
*DECR:                                                             0078
*       DWSWAP=DWCOMP;                                             0078
DECR     MVC   DWSWAP(8,AWSAPTR),DWCOMP(AWSAPTR)                   0078
*       USEFIELD=USEFIELD-1;        /* PREPARE A DECREMENTED USE   0079
*                                      COUNT BUT LEAVE EVERYTHING  0079
*                                      ELSE THE SAME                 */
         LH    @05,USEFIELD(,AWSAPTR)                              0079
         BCTR  @05,0                                               0079
         STH   @05,USEFIELD(,AWSAPTR)                              0079
*       CDS(DWCOMP,DWSWAP,CURRENT->BLOKSWAP);/* ATTEMPT TO UPDATE THE
*                                      GTFBLOK                       */
         LM    @10,@11,DWCOMP(AWSAPTR)                             0080
         LM    @14,@15,DWSWAP(AWSAPTR)                             0080
         CDS   @10,@14,BLOKSWAP(CURRENT)                           0080
         BZ    @BC00080                                            0080
         STM   @10,@11,DWCOMP(AWSAPTR)                             0080
@BC00080 DS    0H                                                  0081
*       BC(4,DECR);                 /* IF THE CDS FAILED TRY AGAIN   */
         BC    4,DECR                                              0081
*       RFY                                                        0082
*        (RECPTR,                                                  0082
*         MVCLFPTR,                                                0082
*         MVCLFLEN,                                                0082
*         MVCLTPTR,                                                0082
*         MVCLTLEN) UNRSTD;                                        0082
*       RFY                                                        0083
*         RCREG RSTD;                                              0083
*       RCREG=RCSUCCSS;             /* SET THE SUCCESSFUL RETURN CODE*/
         SLR   RCREG,RCREG                                         0084
*     END;                          /* GO ON TO REMOVE THE FRR &   0085
*                                      RETURN                      0085
*                                                                    */
*                                                                  0086
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE NEW BLOKLEN WOULD BE TOO LARGE, THEN CHECK TO SEE IF   */
*   /* ANOTHER GTFBLOK HAS BEEN MADE CURRENT AND IF SO USE IT,       */
*   /* OTHERWISE HAVE AHLSFEOB UPDATE THE CURRBLOK PTR TO AN EMPTY   */
*   /* GTFBLOK AND THEN TRY AGAIN                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0086
*/*%SWAP: D (YES,RESTART,NO,) CURRENT^= CURRBLOK                     */
*/* S AHLSFEOB: SWAP CURRBLOK TO AN EMPTY GTFBLOK                    */
*/* D (YES,RESTART,NO,) IS AHLSFEOB RETURN CODE 0                    */
*/* P OBTAIN STABLE COPY OF GTFLOSTR FOR CS                          */
*/*INCRGLR: P INCREMENT STABLE COPY LOST RECORD COUNT BY 1           */
*/* P CS NEW LOST RECORD COUNT INTO GTFLOSTR                         */
*/* D (FAIL,INCRGLR,OK,) CS?                                         */
*                                                                  0086
*   ELSE                                                           0086
*     DO;                                                          0086
         B     @RC00066                                            0086
@RF00066 DS    0H                                                  0087
*       IF CURRENT^=CURRBLOK        /* CHECK TO SEE IF SOMEONE ELSE
*                                      HAS ALREADY DONE A FEOB SINCE
*                                      THE STABLE COPY OF CURRBLOK 0087
*                                      WAS MADE                      */
*         THEN                                                     0087
         C     CURRENT,CURRBLOK(,PCTPTR)                           0087
         BNE   @RT00087                                            0087
*         GO TO RESTART;            /* IF IT HAS CHANGED GO BACK AND
*                                      TRY THE NEW GTFBLOK           */
*       RFY                                                        0089
*         RCREG RSTD;               /* THIS WILL CONTAIN THE RETURN
*                                      CODE FROM AHLSFEOB 4 IF NO  0089
*                                      FEOB OR 0 IA FEOB HAS BEEN  0089
*                                      DONE & CURRENT IS UPDATED     */
*       CALL FEOBNTRY;                                             0090
         LA    @15,FEOBALTE                                        0090
         BALR  @14,@15                                             0090
*       IF RCREG=0                  /* DID AHLSFEOB SUCCEED          */
*         THEN                                                     0091
         LTR   RCREG,RCREG                                         0091
         BZ    @RT00091                                            0091
*         GO TO RESTART;            /* YES, SO GO BACK AND TRY TO FIT
*                                      THE RECORD INTO THE NEW     0092
*                                      GTFBLOK                       */
*       RFY                                                        0093
*        (COMPREG,                                                 0093
*         SWAPREG) RSTD;                                           0093
*       COMPREG=GTFLOSTR;           /* GTFLOSTR MUST BE UPDATED VIA
*                                      CS LOGIC BECAUSE IT IS ALSO 0094
*                                      ALTERED BY AHLSBUF            */
         L     COMPREG,GTFLOSTR(,PCTPTR)                           0094
*INCRGLR:                                                          0095
*       SWAPREG=COMPREG+1;          /* PREPARE TO INCREMENT THE COUNT
*                                      BY 1 FOR THE RECORD WHICH   0095
*                                      CANNOT BE BLOCKED             */
INCRGLR  LA    SWAPREG,1                                           0095
         ALR   SWAPREG,COMPREG                                     0095
*       CS(COMPREG,SWAPREG,GTFLOSTR);/* ATTEMT THE UPDATE            */
         CS    COMPREG,SWAPREG,GTFLOSTR(PCTPTR)                    0096
*       BC(4,INCRGLR);              /* IF AT FIRST YOU DON'T SUCCEED
*                                      TRY TRY AGAIN                 */
         BC    4,INCRGLR                                           0097
*       RFY                                                        0098
*        (COMPREG,                                                 0098
*         SWAPREG) UNRSTD;                                         0098
*     END;                          /* IF AHLSFEOB FAILED FORWARD THE
*                                      RETURN CODE ON TO THE CALLING
*                                      PGM WITHOUT BLOCKING THE    0099
*                                      RECORD                        */
*   RFY                                                            0100
*     RECPTR UNRSTD;                                               0100
@RC00066 DS    0H                                                  0101
*                                                                  0101
*   /*****************************************************************/
*   /*                                                               */
*   /* AFTER THE TRACE RECORD IS EITHER BLOCKED OR CANNOT BE BLOCKED */
*   /* AND GTFLOSTR HAS BEEN INCREMENTED THE FRR IS REMOVED AND      */
*   /* CONTROL RETURNED TO THE CALLER. AT THIS POINT IN THE CODE     */
*   /* GPR15 HAS ALREADY HAD THE RETURN CODE PLACED IN IT AND IT IS  */
*   /* FORWARDED ON TO THE CALLER                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0101
*/*%XY1: S SETFRR: DELETE AHLSBFRR ADDR FROM STACK LIST              */
*/* P RESTORE R4-14 & 0-1 FROM MCASBLOK                              */
*/* R R15= RETURN CODE                                               */
*                                                                  0101
*   RFY                                                            0101
*    (SETFREG1,                                                    0101
*     SETFREG2) RSTD;                                              0101
*   GEN CODE SETS(SETFREG1,SETFREG2) NOEXIT NOFLOWS SEQFLOW REFS(  0102
*       PSACSTK,PSA,FRRSCURR,FRRS,FRRSEMP,FRRSELEN) NODEFS;        0102
    SETFRR   D,WRKREGS=(SETFREG1,SETFREG2)
*   RFY                                                            0103
*    (SETFREG1,                                                    0103
*     SETFREG2) UNRSTD;                                            0103
*   GEN CODE(LM   @04,@14,MCASBLOK(AWSAPTR))                       0104
*   NOSETS NOEXIT REFS(AWSAPTR,MCASBLOK) NOFLOWS SEQFLOW NODEFS;/* 0104
*                                      RESTORE THE GPRS PRIOR TO   0104
*                                      RETURNING WITH THE EXCEPTION
*                                      OF REG15 WHICH CONTAINS THE 0104
*                                      RETURN CODE                   */
         LM   @04,@14,MCASBLOK(AWSAPTR)
*   GEN CODE(LM @00,@01,MCASBLOK+48(AWSAPTR));                     0105
         LM @00,@01,MCASBLOK+48(AWSAPTR)
*   GEN CODE EXIT(BR @14);          /* RETURN                        */
         BR @14
*   RFY                                                            0107
*     RCREG UNRSTD;                                                0107
*                                                                  0108
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS THE FORCE END OF BLOCK SERVICE. IT IS USED PRIMARILY  */
*   /* BY AHLSBLOK AND IS THEREFORE PART OF AHLSBLOK. IT'S FUNCTION  */
*   /* IS TO EITHER GUARENTEE CURRBLOK HAS BEEN UPDATED TO AN EMPTY  */
*   /* GTFBLOK OR TO RETURN A NONZERO CODE IF THERE ARE NO EMPTY     */
*   /* GTFBLOK                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0108
*/*AHLSFEOB: E R2->GTFPCT R3->MCAWSA R4=CURRBLOK                     */
*/* N THIS EP IS FOR ENTRY FROM ANOTHER MODULE                       */
*/* P SAVE R4-1 IN MCASFEOB                                          */
*/* P (,GBCDSON) ESTABLISH ADDRESSABILITY                            */
*/*FEOBALTE: E R2->GTFPCT R3->MCAWSA R4=CURRBLOK                     */
*/* N THIS EP IS FOR ENTRY FROM AHLSBLOK                             */
*/* P SAVE R4-1 IN MCASFEOB                                          */
*/*GBCDSON: D (NO,,YES,SETRC) IS NEXTBLOK NEGATIVE?                  */
*                                                                  0108
*   /*****************************************************************/
*   /*                                                               */
*   /* BECAUSE THIS MODULE IS REENTRANT IT SAVES REGS IN THE WORK    */
*   /* AREA MCAWSA. STANDARD LINKAGE CONVENTIONS ARE NOT USED, REGS  */
*   /* ARE SAVED 4-1                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0108
*AHLSFEOB:                                                         0108
*   GEN CODE NOEXIT REFS(AWSAPTR) SETS(MCASFEOB,BASEREG) NOFLOWS   0108
*       SEQFLOW NODEFS;                                            0108
AHLSFEOB DS    0H                                                  0108
   STM    @04,@01,MCASFEOB(AWSAPTR)
   USING     AHLSFEOB,@15
   L      BASEREG,SBLKADDR      OBTAIN ADDR OF AHLSBLOK
   DROP   @15
*   GO TO GBCDSON;                  /* SKIP THE INTERNAL ENTRY POINT */
*                                                                  0109
         B     GBCDSON                                             0109
*   /*****************************************************************/
*   /*                                                               */
*   /* FEOBALTE IS AN ALTERNATE ENTRY POINT THAT PERMITS AHLSBLOK TO */
*   /* CALL THIS ROUTINE AS AN INTERNAL SUBROUTINE AND, AT THE SAME  */
*   /* TIME, AVOID THE OVERHEAD OF ESTABLISHING ADDRESSABILITY.      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0110
*FEOBALTE:                                                         0110
*   GEN CODE NOEXIT REFS(AWSAPTR) SETS(MCASFEOB) NOFLOWS SEQFLOW NODEFS
*       ;                                                          0110
*                                                                  0110
FEOBALTE DS    0H                                                  0110
   STM    @04,@01,MCASFEOB(AWSAPTR)  SAVE REGS IN WORK AREA
*   /*****************************************************************/
*   /*                                                               */
*   /* BEFORE ATTEMPTING TO FEOB THE GTFBLOK CHAIN DISABLE SWITCH IS */
*   /* CHECKED. THIS SWITCH IS TURNED ON BY THE TRACE WRITER TO      */
*   /* INDICATE THAT CURRBLOK, NEXTBLOK, AND ALL THE BLKCHAIN FIELDS */
*   /* ARE NOT TO BE ALTERED. AHLSBLOK MAY CONTINUE TO BLOCK RECORDS,*/
*   /* BUT AHLSFEOB MUST NOT FEOB                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0111
*GBCDSON:                                                          0111
*   IF GBCDS=ON THEN                /* THE TRACE WRITER IS WORKING ON
*                                      THE GTFBLOK CHAIN AND NO FEOB
*                                      MAY BE DONE                   */
GBCDSON  TM    GBCDS(PCTPTR),B'10000000'                           0111
         BO    @RT00111                                            0111
*     GO TO SETRC;                  /* GO SEE IF CURRBLOK HAS BEEN 0112
*                                      UPDATED AND SET THE RETURN  0112
*                                      CODE ACCORDINGLY            0112
*                                                                    */
*                                                                  0113
*   /*****************************************************************/
*   /*                                                               */
*   /* IF A FEOB MAY BE DONE THIS CODE GETS CONTROL AND DETERMINES IF*/
*   /* A FEOB CAN BE DONE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0113
*/* P OBTAIN A STABLE COPY OF CURRBLOK                               */
*/* D (NO,,YES,NOFEOB) NEXTBLOK= CURRBLOK-> BLKCHAIN                 */
*                                                                  0113
*   RFY                                                            0113
*     BLOKCURR RSTD;                                               0113
*   BLOKCURR=CURRBLOK;              /* GET STABLE COPY OF CURRBLOK IN
*                                      CASE A LOST RECORD RECORD HAS
*                                      TO BE GENERATED SO THAT THE 0114
*                                      RECORD WILL BE PLACED INTO THE
*                                      SAME GTFBLOK AS WAS COMPARED
*                                      WITH NEXTBLOK                 */
         L     BLOKCURR,CURRBLOK(,PCTPTR)                          0114
*   IF NEXTBLOK=BLOKCURR->BLKCHAIN  /* DETERMINE IF A FEOB CAN BE  0115
*                                      DONE                          */
*     THEN                                                         0115
         L     @06,BLKCHAIN(,BLOKCURR)                             0115
         C     @06,NEXTBLOK(,PCTPTR)                               0115
         BE    @RT00115                                            0115
*     GO TO NOFEOB;                 /* IF THIS CONDITION IS TRUE IT
*                                      MEANS THAT THE GTFBLOK THAT 0116
*                                      WOULD BECOME THE NEXT ONE   0116
*                                      POINTED TO BY CURRBLOK HAS NOT
*                                      YET BEEN EMPTIED BY AHLSBUF 0116
*                                      AND THEREFORE CANNOT BE GIVEN
*                                      TO AHLSBLOK TO BE FILLED.   0116
*                                      HOWEVER THIS DOES NOT MEAN  0116
*                                      TOTAL FAILURE. CURRBLOK MAY 0116
*                                      HAVE ALREADY BEEN UPDATED,  0116
*                                      ALSO AHLSBUF SHOULD BE      0116
*                                      SCHEDULED TO POST THE TRACE 0116
*                                      WRITER SO THAT IT CAN CORRECT
*                                      A POSSIBLE PROBLEM            */
*   ELSE                                                           0117
*     ;                             /* IF THE CONDITION IS FALSE GO
*                                      THROUGH THE FEOB PROCESS    0117
*                                                                    */
*                                                                  0118
*   /*****************************************************************/
*   /*                                                               */
*   /* BEFORE AN EMPTY GTFBLOK IS MADE CURRENT TO BE FILLED BY       */
*   /* AHLSBLOK THE LOST RECORD COUNT MUST BE 0. THE COUNT (GTFLOSTR)*/
*   /* IS INCREMENTED ONCE EACH TIME AHLSBLOK HAS TO RETURN TO ITS   */
*   /* CALLER WITHOUT BEING ABLE TO BLOCK THE RECORD BECAUSE THERE IS*/
*   /* NO GTFBLOK SPACE. TO SET GTFLOSTR BACK TO 0 A LOST RECORD     */
*   /* RECORD HAS TO BE PLACED IN THE FIRST GTFBLOK SPACE TO BECOME  */
*   /* AVAILABLE                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0118
*/* D (YES,%AX3,NO,) GTFLOSTR=0?                                     */
*/* N TRY TO PLACE A LOST REC REC INTO CURRBLOK-> BLKCHAIN-> GTFBLOK */
*/* P OBTAIN A STABLE COPY OF GTFBLOK CONTROL FIELDS WHERE THE LE  0118
*/*REC WILL GO                                                       */
*/* D (NO,,YES,GBCDSON) BLOKLEN >GTFBLOK SIZE OR BLKINUSE ON         */
*/* P INCREMENT STABLE COPY BLOKUSE BY 1                             */
*/* P CS TO PUT IN NEW BLOKUSE, BLOKLEN, & VERIFY BLKINUSE=OFF       */
*/* D (FAIL,SETRC,OK,) CS?                                           */
*                                                                  0118
*   IF GTFLOSTR^=0 THEN                                            0118
         ICM   @05,15,GTFLOSTR(PCTPTR)                             0118
         BZ    @RF00118                                            0118
*     DO;                           /* IF THE LOST RECORD COUNT IS 0119
*                                      NOT 0 PUT IN A LOST RECORD  0119
*                                      RECORD AND SET THE COUNT TO 0 */
*       DWCOMP=BLOKCURR->BLKCHAIN->BLOKSWAP;/* GET A STABLE COPY OF
*                                      THE CONTROL FIELDS IN THE   0120
*                                      GTFBLOK TO CONTAIN LOST REC 0120
*                                      REC                           */
         MVC   DWCOMP(8,AWSAPTR),BLOKSWAP(@06)                     0120
*       DWSWAP=DWCOMP;              /* PREPARE TO BLOCK THE LOST   0121
*                                      RECORD RECORD INTO THE GTFBLOK
*                                      FOLLOWING THE ONE POINTED TO
*                                      BY CURRBLOK. THE BLOCKING   0121
*                                      PROCEDURE MUST BE THE SAME AS
*                                      THAT IN AHLSBLOK BECAUSE THE
*                                      GTFBLOK COULD BE IN USE AT  0121
*                                      ANYTIME                       */
         MVC   DWSWAP(8,AWSAPTR),DWCOMP(AWSAPTR)                   0121
*       LENFIELD=LENFIELD+LENGTH(LOSTRECR);/* SET UP THE PROPOSED NEW
*                                      BLOKLEN WHICH WILL RESERVE  0122
*                                      SPACE FOR THE LOST REC REC    */
         LA    @05,22                                              0122
         AH    @05,LENFIELD(,AWSAPTR)                              0122
         STH   @05,LENFIELD(,AWSAPTR)                              0122
*       IF LENFIELD>LENGTH(BLOKAREA)|INUSEBIT=ON/* VERIFY THE NEW  0123
*                                      BLOKLEN IS VALID THAT IS, THE
*                                      RECORD WILL FIT AND THAT THE
*                                      GTFBLOK IS NOT IN USE BY    0123
*                                      AHLSBUF                       */
*         THEN                                                     0123
         CH    @05,@CH00119                                        0123
         BH    @RT00123                                            0123
         TM    INUSEBIT(AWSAPTR),B'10000000'                       0123
         BO    @RT00123                                            0123
*         GO TO GBCDSON;            /* THE RECORD WON'T FIT. SOMEHOW
*                                      THE GTFBLOK HAS BEEN FILLED UP
*                                      SINCE CURRBLOK WAS SAVED IN 0124
*                                      BLOKCURR SO START OVER AGAIN  */
*       USEFIELD=USEFIELD+1;        /* IF THE RECORD WILL FIT PREPARE
*                                      THE INCREMENTED BLOKUSE       */
         LA    @05,1                                               0125
         AH    @05,USEFIELD(,AWSAPTR)                              0125
         STH   @05,USEFIELD(,AWSAPTR)                              0125
*       CDS(DWCOMP,DWSWAP,BLOKCURR->BLKCHAIN->BLOKSWAP);/* ATTEMPT TO
*                                      UPDATE THE GTFBLOK CONTROL  0126
*                                      FIELDS WITH THE NEW VALUES AND
*                                      VERIFY BLKINUSE IS STILL OFF  */
         LM    @00,@01,DWCOMP(AWSAPTR)                             0126
         LM    @08,@09,DWSWAP(AWSAPTR)                             0126
         CDS   @00,@08,BLOKSWAP(@06)                               0126
         BZ    @BC00126                                            0126
         STM   @00,@01,DWCOMP(AWSAPTR)                             0126
@BC00126 DS    0H                                                  0127
*       BC(4,SETRC);                /* IF THE CDS FAILED THE GTFBLOK
*                                      HAS HAD A FEOB DONE ON IT   0127
*                                      ALREADY AND ITS STATUS HAS  0127
*                                      CHANGED, ALSO GTFLOSTR HAS  0127
*                                      NECESSARILY BEEN SET TO 0   0127
*                                      SINCE EVERYTHING THAT WAS   0127
*                                      GOING TO BE DONE HAS ALREADY
*                                      BEEN DONE BY ANOTHER AHLSFEOB
*                                      SO JUST RETURN TO THE CALLER
*                                                                    */
         BC    4,SETRC                                             0127
*                                                                  0128
*       /*************************************************************/
*       /*                                                           */
*       /* ONCE SPACE HAS BEEN SUCCESSFULLY RESERVED IN THE GTFBLOK  */
*       /* THE LOST EVENT RECORD IS BUILT IN IT                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0128
*/* P CALC THE ADDRESS OF THE SPACE RESERVED FOR THE LE REC          */
*/* P SAVE STABLE COUNT OF GTFLOSTR                                  */
*/*ZEROCNT: P CS ZERO INTO GTFLOSTR                                  */
*/* D (FAIL,ZEROCNT,OK,) CS?                                         */
*/* P MOVE LOST REC RECORD PREFIX INTO THE RESERVED SPACE            */
*/* P MOVE TIMEZONE INTO THE RESERVED SPACE                          */
*/* P STORE THE TOD CLOCK VALUE INTO THE RESERVED SPACE              */
*/* P SAVE THE COUNT IN THE RESERVED SPACE                           */
*/* N THE LOST EVENT RECORD IS NOW BUILT                             */
*/* P OBTAIN A STABLE COPY OF THE GTFBLOK CONTROL FIELDS             */
*/*LRRBUD: P DECREMENT THE BLOKUSE IN THE STABLE COPY                */
*/* P ATTEMPT TO CS IN THE DECREMENTED BLOKUSE                       */
*/* D (FAIL,LRRBUD,OK,) CS?                                          */
*                                                                  0128
*       RFY                                                        0128
*         LRRECPTR RSTD;                                           0128
*       LRRECPTR=ADDR(BLOKCURR->BLKCHAIN->BLOKAREA)+OLDLEN;/* GET THE
*                                      ADDR OF THE GTFBLOK SPACE   0129
*                                      RESERVED TO BE USED AS A BASE
*                                      FOR LOSTRECR                  */
         L     LRRECPTR,BLKCHAIN(,BLOKCURR)                        0129
         LA    LRRECPTR,BLOKAREA(,LRRECPTR)                        0129
         AH    LRRECPTR,OLDLEN(,AWSAPTR)                           0129
*       RFY                                                        0130
*        (COMPREG,                                                 0130
*         SWAPREG) RSTD;                                           0130
*       SWAPREG=0;                  /* PREPARE NEW VALUE FOR GTFLOSTR*/
         SLR   SWAPREG,SWAPREG                                     0131
*       COMPREG=GTFLOSTR;           /* SAVE STABLE COPY OF GTFLOSTR  */
         L     COMPREG,GTFLOSTR(,PCTPTR)                           0132
*ZEROCNT:                                                          0133
*       CS(COMPREG,SWAPREG,GTFLOSTR);/* ATTEMPT TO UPDATE GTFLOSTR   */
ZEROCNT  CS    COMPREG,SWAPREG,GTFLOSTR(PCTPTR)                    0133
*       BC(4,ZEROCNT);              /* IF THE CS FAILED TRY AGAIN. 0134
*                                      GTFLOSTR WAS PROBABLY ZEROED
*                                      ALREADY, BUT SINCE SPACE HAS
*                                      ALREADY BEEN RESERVED THE LOST
*                                      RECORD RECORD MUST BE BUILT 0134
*                                      EVEN WITH A 0 COUNT           */
         BC    4,ZEROCNT                                           0134
*       LOSTRECR(1:LENGTH(LRRPROTO))=LRRPROTO;/* MOVE IN THE RECORD
*                                      PREFIX                        */
         MVC   LOSTRECR(6,LRRECPTR),LRRPROTO                       0135
*       LRRCVTTZ=CVTTZ;             /* MOVE IN THE TIMEZONE          */
         L     @05,CVTPTR                                          0136
         MVC   LRRCVTTZ(4,LRRECPTR),CVTTZ(@05)                     0136
*       GEN CODE(STCK LRRTODCV(LRRECPTR))                          0137
*       NOEXIT NOFLOWS REFS(LRRECPTR) SETS(LRRTODCV)/* PUT           */
*           NODEFS SEQFLOW;         /* THE TOD CLOCK VALUE INTO THE
*                                      LOST RECORD RECORD            */
         STCK LRRTODCV(LRRECPTR)
*       LRRCNT=COMPREG;             /* SAVE THE COUNT IN THE SPACE 0138
*                                      RESERVED                      */
         ST    COMPREG,LRRCNT(,LRRECPTR)                           0138
*       RFY                                                        0139
*        (COMPREG,                                                 0139
*         SWAPREG) UNRSTD;                                         0139
*       DWCOMP=BLOKCURR->BLKCHAIN->BLOKSWAP;/* NOW THAT THE LOST   0140
*                                      RECORD RECORD IS BUILT AND IN
*                                      PLACE                         */
         L     @05,BLKCHAIN(,BLOKCURR)                             0140
         MVC   DWCOMP(8,AWSAPTR),BLOKSWAP(@05)                     0140
*LRRBUD:                                                           0141
*       DWSWAP=DWCOMP;              /* PREPARE TO DECREMENT THE    0141
*                                      BLOKUSE TO INDICATE THE     0141
*                                      RESERVED SPACE IS FILLED      */
LRRBUD   MVC   DWSWAP(8,AWSAPTR),DWCOMP(AWSAPTR)                   0141
*       USEFIELD=USEFIELD-1;        /* PREPARE NEW BLOKUSE           */
         LH    @05,USEFIELD(,AWSAPTR)                              0142
         BCTR  @05,0                                               0142
         STH   @05,USEFIELD(,AWSAPTR)                              0142
*       CDS(DWCOMP,DWSWAP,BLOKCURR->BLKCHAIN->BLOKSWAP);/* ATTEMPT 0143
*                                      UPDATE                        */
         LM    @00,@01,DWCOMP(AWSAPTR)                             0143
         LM    @08,@09,DWSWAP(AWSAPTR)                             0143
         L     @05,BLKCHAIN(,BLOKCURR)                             0143
         CDS   @00,@08,BLOKSWAP(@05)                               0143
         BZ    @BC00143                                            0143
         STM   @00,@01,DWCOMP(AWSAPTR)                             0143
@BC00143 DS    0H                                                  0144
*       BC(4,LRRBUD);               /* IF CDS FAILS TRY AGAIN        */
         BC    4,LRRBUD                                            0144
*       RFY                                                        0145
*         LRRECPTR UNRSTD;                                         0145
*     END;                                                         0146
*                                                                  0147
*   /*****************************************************************/
*   /*                                                               */
*   /* AFTER IT HAS BEEN DETERMINED THAT GTFLOSTR=0 OR ELSE A LOST   */
*   /* RECORD RECORD HAS BEEN BUILT THIS SECTION OF CODE IS ENTERED. */
*   /* IT EITHER DETERMINES THAT A FEOB HAS ALREADY BEEN DONE (IN    */
*   /* WHICH CASE ANOTHER IS NOT NEEDED), OR IT DOES ONE             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0147
*/*%AX3: P MAKE A COPY OF THE CURRENT GTFBLOK PTR (REG4) PASSED BY THE
*/*CALLER                                                            */
*/* N THIS COPY IS USED AS THE CS CONTROL SO CURRENT WIL NOT BE ALTERED
*/*                                                                  */
*/* P CS TO DO FEOB USING CURRBLOK VALUE PASSED IN REG4 (CURRENT)    */
*/* N THIS IS DONE SO THAT IF A FEOB WAS ALREADY DONE ANOTHER WILL BE
*/*AVOIDED                                                           */
*/* D (FAIL,NOFEOB,OK,) CS?                                          */
*/* P COMPLETE THE TIME REC IN THE GTFBLOK JUST MADE CURRENT         */
*/* P OBTAIN A STABLE COPY OF THE CONTROL FIELDS OF THE NEWLY CURRENT
*/*GTFBLOK                                                           */
*/*%TIMECS: P DECREMENT BLOKUSE IN THE STABLE COPY                   */
*/* P CS IN THE NEW BLOKUSE                                          */
*/* D (FAIL,%TIMECS,OK,) CS?                                         */
*                                                                  0147
*   RFY                                                            0147
*     COMPREG RSTD;                                                0147
@RF00118 DS    0H                                                  0148
*   COMPREG=CURRENT;                /* THIS IS DONE TO AVOID HAVING
*                                      TH CS INST UPDATE CURRENT IF
*                                      THE COMPARE SHOULD FAIL       */
         LR    COMPREG,CURRENT                                     0148
*   BLOKCURR=CURRENT->BLKCHAIN;     /* PREPARE TO ATTEMPT FEOB       */
         L     BLOKCURR,BLKCHAIN(,CURRENT)                         0149
*   CS(COMPREG,BLOKCURR,CURRBLOK);  /* IF THE STABLE COPY OF CURRBLOK
*                                      PASSED BY THE CALLER (CURRENT)
*                                      IS STILL THE SAME AS CURRBLOK
*                                      THE CS WILL UPDATE CURRBLOK TO
*                                      THE NEXT GTFBLOK IN THE CHAIN,
*                                      THIS IS A FEOB                */
         CS    COMPREG,BLOKCURR,CURRBLOK(PCTPTR)                   0150
*   BC(4,NOFEOB);                   /* IF CURRBLOK HAS CHANGED SINCE
*                                      CURRENT WAS SET BY THE CALLER
*                                      NO FEOB NEED BE DONE BECAUSE
*                                      ONE HAS ALREADY BEEN DONE THAT
*                                      THE CALLER IS NOT AWARE OF    */
         BC    4,NOFEOB                                            0151
*   RFY                                                            0152
*     COMPREG UNRSTD;                                              0152
*   GEN CODE(STCK RECTOD(BLOKCURR))                                0153
*   NODEFS NOEXIT SEQFLOW REFS(BLOKCURR) SETS(RECTOD) NOFLOWS;/* IF
*                                      THE CS IS SUCCESSFUL THE FIRST
*                                      RECORD IN THE GTFBLOK MUST  0153
*                                      HAVE ITS TIME FIELD UPDATED   */
         STCK RECTOD(BLOKCURR)
*   DWCOMP=BLOKCURR->BLOKSWAP;                                     0154
         MVC   DWCOMP(8,AWSAPTR),BLOKSWAP(BLOKCURR)                0154
*TIMECS:                                                           0155
*   DWSWAP=DWCOMP;                  /* PREPARE TO DECREMENT THE    0155
*                                      BLOKUSE TO INDICATE THE SPACE
*                                      RESERVED FOR THE TIME RECORD
*                                      IS COMPLETED                  */
TIMECS   MVC   DWSWAP(8,AWSAPTR),DWCOMP(AWSAPTR)                   0155
*   USEFIELD=USEFIELD-1;            /* PREPARE THE PROPOSED NEW    0156
*                                      BLOKUSE                       */
         LH    @06,USEFIELD(,AWSAPTR)                              0156
         BCTR  @06,0                                               0156
         STH   @06,USEFIELD(,AWSAPTR)                              0156
*   CDS(DWCOMP,DWSWAP,BLOKCURR->BLOKSWAP);/* ATTEMPT THE UPDATE      */
         LM    @00,@01,DWCOMP(AWSAPTR)                             0157
         LM    @08,@09,DWSWAP(AWSAPTR)                             0157
         CDS   @00,@08,BLOKSWAP(BLOKCURR)                          0157
         BZ    @BC00157                                            0157
         STM   @00,@01,DWCOMP(AWSAPTR)                             0157
@BC00157 DS    0H                                                  0158
*   BC(4,TIMECS);                   /* IF THE CDS FAILS TRY AGAIN    */
         BC    4,TIMECS                                            0158
*   RFY                                                            0159
*     BLOKCURR UNRSTD;                                             0159
*                                                                  0160
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SECTION OF CODE WILL SKIP SCHEDULING AHLSBUF IF THERE ARE*/
*   /* NO FULL GTFBLOK, OR IF THE NEXTBLOK-> GTFBLOK (NEXT TO BE     */
*   /* BUFFERED BY AHLSBUF) HAS A NONZERO BLOKUSE AND WRTRCOM ECB IS */
*   /* POSTED. THE REASON FOR SCHEDULING AHLSBUF WHEN THE NEXTBLOK-> */
*   /* GTFBLOK BLOKUSE IS NONZERO (MEANING AHLSBUF CANNOT BUFFER IT) */
*   /* IS THAT AHLSBUF WILL POST THE TRACE WRITER ANYWAY WHICH MAY BE*/
*   /* ABLE TO CORRECT THE PROBLEM                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0160
*/*NOFEOB: D (YES,,NO,SETRC) NEXTBLOK^= CURRBLOK?                    */
*/* D (YES,,NO,%AX2) IS NEXTBLOK-> BLOKUSE^=0                        */
*/* D (YES,SETRC,NO,) IS WRTRCOM POSTED?                             */
*                                                                  0160
*NOFEOB:                                                           0160
*                                                                  0160
*/*   IF THE NEXT TO BE BUFFERED IS NOT THE SAME AS THE CURRENT BLOCK,
*  THEN AN ATTEMPT SHOULD BE MADE TO SCHEDULE THE FULL BLOCK(S) FOR BUF
*RING.  ON THE OTHER HAND, IF THEY ARE THE SAME, THEN ALL BLOCKS HAVE
*   RECENTLY BEEN BUFFERED AND THE NEXT ONE TO BE BUFFERED IS      0160
*HE BLOCK CURRENTLY BEING FILLED.  THEREFORE, NO SCHEDULING IS DONE  */
*                                                                  0160
*   IF NEXTBLOK^=CURRBLOK           /* ARE THERE ANY GTFBLOK THAT ARE
*                                      BOTH FULL AND NOT CURRENT     */
*     THEN                                                         0160
NOFEOB   L     @05,NEXTBLOK(,PCTPTR)                               0160
         C     @05,CURRBLOK(,PCTPTR)                               0160
         BE    @RF00160                                            0160
*     DO;                           /* YES THERE ARE FULL GTFBLOK    */
*       IF NEXTBLOK->BLOKUSE^=0     /* THEN IS THE NEXT GTFBLOK TO BE
*                                      BUFFERED READY FOR BUFFERING  */
*         THEN                      /* NO, THE NEXT GTFBLOK IS NOT 0162
*                                      READY FOR BUFFERING. SCHEDULE
*                                      AHLSBUF ANYWAY JUST TO GET THE
*                                      TRACE WRITER POSTED           */
         ICM   @15,3,BLOKUSE(@05)                                  0162
         BZ    @RF00162                                            0162
*         IF WRTRCOMP=ON            /* UNLESS IT IS ALREADY POSTED.
*                                      WRTRCOMP IS THE POST BIT OF 0163
*                                      THE WRTRCOM ECB               */
*           THEN                                                   0163
         TM    WRTRCOMP(PCTPTR),B'01000000'                        0163
         BO    @RT00163                                            0163
*           GO TO SETRC;            /* THE NEXT GTFBLOK IS NOT READY
*                                      FOR BUFFERING AND THE TRACE 0164
*                                      WRITER IS POSTED SO THERE IS
*                                      NOTHING AHLSBUF CAN DO      0164
*                                                                    */
*                                                                  0165
*       /*************************************************************/
*       /*                                                           */
*       /* IF THERE IS A FULL GTFBLOK AND EITHER IT IS READY TO BE   */
*       /* BUFFERED (BLOKUSE=0) OR WRTRCOM ECB IS NOT POSTED THE     */
*       /* FOLLOWING CODE IS EXECUTED TO SCHEDULE THE SRB FOR AHLSBUF*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0165
*/*%AX2: P OBTAIN A STABLE COPY OF GTFSSRB & FORCE SRBAVAIL OFF IN IT
*/*                                                                  */
*/* P CS TO VERIFY SRBAVAIL IS OFF AND THE TURN IT ON                */
*/* D (FAIL,SETRC,OK,) CS?                                           */
*/* S SCHEDULE: SCHEDULE AHLSBUF                                     */
*                                                                  0165
*       RFY                                                        0165
*        (COMPREG,                                                 0165
*         SWAPREG) RSTD;                                           0165
@RF00162 DS    0H                                                  0166
*       COMPREG=GTFSSRB;                                           0166
         L     COMPREG,GTFSSRB(,PCTPTR)                            0166
*       SWAPREG=COMPREG;            /* PREPARE TO GET CONTROL OF THE
*                                      SRB FOR AHLSBUF               */
         LR    SWAPREG,COMPREG                                     0167
*       SWAPREG=SWAPREG&'7FFFFFFF'X;/* THIS FORCES OFF THE SRBAVAIL
*                                      BIT SO THAT IF THE CS GOES THE
*                                      SRB WILL NO LONGER BE       0168
*                                      AVAILABLE                     */
         N     SWAPREG,@CF01787                                    0168
*       COMPREG=COMPREG|'80000000'X;/* THIS FORCES ON THE SRBAVAIL 0169
*                                      BIT IN THE CONTROL SO THAT IF
*                                      IT WAS NOT ON IN GTFSSRB THE
*                                      CS WILL FAIL                  */
         O     COMPREG,@CF01788                                    0169
*       CS(COMPREG,SWAPREG,GTFSSRB);                               0170
         CS    COMPREG,SWAPREG,GTFSSRB(PCTPTR)                     0170
*       BC(4,SETRC);                /* IF THE CS FAILED SKIP TRYING
*                                      TO SCHEDULE AHLSBUF BECAUSE IT
*                                      IS ALREADY SCHEDULED          */
         BC    4,SETRC                                             0171
*       GEN CODE(SCHEDULE  SRB=(SWAPREG),SCOPE=GLOBAL)             0172
*       NODEFS NOEXIT NOSETS NOFLOWS SEQFLOW REFS(SRBFLNK,SRBSECT, 0172
*           CVTGSMQ,CVTMAP,CVTPTR,SWAPREG);                        0172
         SCHEDULE  SRB=(SWAPREG),SCOPE=GLOBAL
*       RFY                                                        0173
*        (COMPREG,                                                 0173
*         SWAPREG) UNRSTD;                                         0173
*     END;                                                         0174
*                                                                  0175
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS THE EXIT CODE FOR ALL PATHS THROUGH AHLSFEOB. BEFORE  */
*   /* RETURNNING TO THE CALLER IT IS NECESSARY TO SET THE RETURN    */
*   /* CODE. THE CRITERION USED IS ACTUALLY WHETHER THE STABLE COPY  */
*   /* OF CURRBLOK PASSED BY THE CALLER (CURRENT) HAS BEEN UPDATED OR*/
*   /* NOT, INSTEAD OF WHETHER A FEOB HAS BEEN DONE. THE REASON FOR  */
*   /* THIS IS THAT AHLSFEOB IS NOT SERIAL, SO A FEOB MIGHT HAVE BEEN*/
*   /* DONE BETWEEN THE TIME CURRBLOK WAS SAVED IN CURRENT AND NOW.  */
*   /* THE RETURN CODE THEREFORE MUST INDICATE IF A FEOB WAS DONE AT */
*   /* ANY TIME NOT JUST NOW.                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0175
*/*SETRC: D (YES,,NO,%RCODE)  CURRBLOK^= CURRENT (REG4)              */
*/* N CURRENT IS THE VALUE OF CURRBLOK BEING USED BY THE CALLING RTN */
*/* P SET RETURN CODE = 0?                                           */
*/* N (,%R1) A CHANGE IN CURRBLOK MEANS A FEOB AS FAR AS THE CALLER IS
*/* CONCERNED                                                        */
*/*%RCODE: P SET RETURN CODE = 4                                     */
*/* N NO CHANGE IN CURRBLOK MEANS NO FEOB                            */
*/*%R1: R RETURN                                                     */
*                                                                  0175
*   RFY                                                            0175
*     RCREG RSTD;                                                  0175
@RF00160 DS    0H                                                  0176
*SETRC:                                                            0176
*   IF CURRENT^=CURRBLOK            /* WAS ANY FEOB DONE BY ANYONE 0176
*                                      SINCE CURRENT WAS SET BY THE
*                                      CALLER                        */
*     THEN                          /* YES                           */
SETRC    C     CURRENT,CURRBLOK(,PCTPTR)                           0176
         BE    @RF00176                                            0176
*     RCREG=RCSUCCSS;               /* SET THE RETURN CODE TO      0177
*                                      INDICATE THAT A FEOB WAS DONE
*                                      SINCE SINCE THE CALLER SAVED
*                                      CURRBLOK IN CURRENT AND THAT
*                                      CURRENT HAS BEEN UPDATED      */
         SLR   RCREG,RCREG                                         0177
*   ELSE                                                           0178
*     RCREG=RCFAIL;                 /* SET RETURN CODE FOR NO FEOB   */
         B     @RC00176                                            0178
@RF00176 LA    RCREG,4                                             0178
*   GEN CODE(LM  @04,@14,MCASFEOB(AWSAPTR))                        0179
*   NOEXIT REFS(AWSAPTR,MCASFEOB) NOSETS NOFLOWS SEQFLOW NODEFS;/* 0179
*                                      RESTORE ALL REGS EXCEPT 15  0179
*                                      WHICH HAS THE RETURN CODE     */
@RC00176 DS    0H                                                  0179
         LM  @04,@14,MCASFEOB(AWSAPTR)
*   GEN CODE(LM @00,@01,MCASFEOB+48(AWSAPTR));                     0180
         LM @00,@01,MCASFEOB+48(AWSAPTR)
*   GEN CODE EXIT(BR @14);          /* RETURN TO THE CALLER          */
         BR @14
*   RFY                                                            0182
*    (RCREG) UNRSTD;                                               0182
*                                                                  0183
*   /*****************************************************************/
*   /*                                                               */
*   /* FRR CODE FOR AHLSBLOK, AND FOR AHLSFEOB IF IT IS ENTERED BY   */
*   /* AHLSBLOK                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0183
*/*AHLSBFRR: E FROM RTM                                              */
*/* P SET UP ADDRESSABILITY TO ALL OF AHLSBLOK                       */
*/* P SAVE THE RETURN ADDRESS (REG14)                                */
*/* P SBLOKRTN=0 GTFSSRB=0 DISABLE AHLSTACK & AHLSBUF                */
*/* P SET WSERFG02                                                   */
*/* S SDUMP: TAKE AN SVC DUMP                                        */
*/* P SDWAEAS=ON                                                     */
*/* S SETRP: PERCOLATE TO TERMINATE THE APPLICATION                  */
*/* P RESTORE THE RETURN ADDRESS                                     */
*/* R RETURN TO RTM                                                  */
*                                                                  0183
*   RFY                                                            0183
*    (SDWAPTR,                                                     0183
*     RTRNREG,                                                     0183
*     R1,                                                          0183
*     FRR14SAV) RSTD;                                              0183
*AHLSBFRR:                                                         0184
*   GEN SETS(BASEREG) NOEXIT NOFLOWS SEQFLOW;                      0184
AHLSBFRR DS    0H                                                  0184
          USING  AHLSBFRR,@15   ASSIGN TEMP ADDRESSIBILITY
          L      BASEREG,SBLKADDR   RESTORE NORMAL ADDRESSIBILITY
          DROP   @15
*   SDWAPTR=R1;                                                    0185
         LR    SDWAPTR,R1                                          0185
*   RFY                                                            0186
*     R1 UNRSTD;                                                   0186
*   FRR14SAV=RTRNREG;               /* SAVE THE RETURN ADDRESS       */
         LR    FRR14SAV,RTRNREG                                    0187
*   PCTPTR=SDWAGR02;                /* RESTORE THE BASE ADDRESS FOR
*                                      THE GTFPCT                    */
         L     PCTPTR,SDWAGR02(,SDWAPTR)                           0188
*   SBLOKRTN=0;                     /* ZERO OUT THE ADDRESS TO THIS
*                                      ROUTINE                       */
         SLR   @15,@15                                             0189
         ST    @15,SBLOKRTN(,PCTPTR)                               0189
*   GTFSSRB=0;                      /* ZERO OUT THE ADDRESS OF THE 0190
*                                      SRB ROUTINE                   */
         ST    @15,GTFSSRB(,PCTPTR)                                0190
*/*  AN SVC DUMP WILL BE PROVIDED BY THE FGBR FRR                    */
*                                                                  0191
*   WSERFG03=ON;                    /* SET ERROR FLAG                */
         OI    WSERFG03(PCTPTR),B'10000000'                        0191
*   IF SDWAMCHK=ON&SDWAINSF=ON&SDWAREGU=OFF&SDWAPSWU=OFF/* IT THIS A
*                                      RECOVERABLE ACR MACHINE CHECK
*                                      TYPE ERROR                    */
*     THEN                                                         0192
         TM    SDWAMCHK(SDWAPTR),B'10000000'                       0192
         BNO   @RF00192                                            0192
         TM    SDWAINSF(SDWAPTR),B'00000100'                       0192
         BNO   @RF00192                                            0192
         TM    SDWAREGU(SDWAPTR),B'01100000'                       0192
         BNZ   @RF00192                                            0192
*     DO;                                                          0193
*       SBLOKRTN=ADDR(AHLSBLOK);                                   0194
         L     @15,@CA00028                                        0194
         ST    @15,SBLOKRTN(,PCTPTR)                               0194
*       WSERFG03=OFF;                                              0195
         NI    WSERFG03(PCTPTR),B'01111111'                        0195
*       DO;                         /* SETRP RECPARM(RECID)        0196
*                                      WKAREA(SDWAPTR) RECORD(YES) 0196
*                                      RC(SDWARETY)                0196
*                                      RETADDR(SDWANXT1->PLACE)      */
*         RESPECIFY                                                0197
*          (GPR00P,                                                0197
*           GPR01P,                                                0197
*           GPR14P,                                                0197
*           GPR15P) RSTD;                                          0197
*         GPR01P=SDWAPTR;                                          0198
         LR    GPR01P,SDWAPTR                                      0198
*         GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0199
*         GPR01P->SDWARTYA=ADDR(SDWANXT1->PLACE);/* SAVE RETRY     0200
*                                      ADDRESS                       */
         MVC   SDWARTYA(4,GPR01P),SDWANXT1(SDWAPTR)                0200
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0201
*         GPR15P=ADDR(RECID);       /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0202
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0203
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0203
*         RESPECIFY                                                0204
*          (GPR00P,                                                0204
*           GPR01P,                                                0204
*           GPR14P,                                                0204
*           GPR15P) UNRSTD;                                        0204
*       END;                                                       0205
*     END;                                                         0206
*   ELSE                                                           0207
*     DO;                                                          0207
*                                                                  0207
         B     @RC00192                                            0207
@RF00192 DS    0H                                                  0208
*/*  PERCOLATE TO CAUSE TERMINATION OF THE APPLICATION (GTF)         */
*                                                                  0208
*       DO;                         /* SETRP RECPARM(RECID)        0208
*                                      WKAREA(SDWAPTR) RECORD(YES) 0208
*                                      RC(SDWACWT)                   */
*         RESPECIFY                                                0209
*          (GPR00P,                                                0209
*           GPR01P,                                                0209
*           GPR14P,                                                0209
*           GPR15P) RSTD;                                          0209
*         GPR01P=SDWAPTR;                                          0210
         LR    GPR01P,SDWAPTR                                      0210
*         GPR01P->SDWARCDE=SDWACWT; /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0211
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0212
*         GPR15P=ADDR(RECID);       /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0213
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0214
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0214
*         RESPECIFY                                                0215
*          (GPR00P,                                                0215
*           GPR01P,                                                0215
*           GPR14P,                                                0215
*           GPR15P) UNRSTD;                                        0215
*       END;                                                       0216
*     END;                                                         0217
*   RTRNREG=FRR14SAV;               /* RESTORE THE RETURN ADDRESS    */
@RC00192 LR    RTRNREG,FRR14SAV                                    0218
*   GEN CODE EXIT(BR 14);           /* RETURN TO RTM                 */
         BR 14
*   RFY                                                            0220
*    (SDWAPTR,                                                     0220
*     RTRNREG,                                                     0220
*     FRR14SAV) UNRSTD;                                            0220
*                                                                  0221
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS MACRO WILL GENERATE A PATCH AREA OF 5% OF THE MODULE     */
*   /* SIZE, AND NAME IT PATCHLOC. THE AREA WILL BE SET TO 0         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0221
*   DCL                                                            0221
*     PATCHLOC FIXED(31) STATIC;                                   0221
*   GEN DATA DEFS(PATCHLOC);                                       0222
*                                                                  0222
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOG MACRO. THIS MACRO IS REQUIRED IF ANY PLS SYSTEM MACRO  */
*   /* HAS BEEN USED. IT SHOULD COME AFTER ALL OTHER USES OF SYSTEM  */
*   /* MACROS                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0223
*/*AHLSBLOK: END                                                     */
*                                                                  0223
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                       0223
*     GPR01P PTR(31) REG(1),                                       0223
*     GPR14P PTR(31) REG(14),                                      0223
*     GPR15P PTR(31) REG(15);                                      0223
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0224
*     I031F FIXED(31) BASED,                                       0224
*     I031P PTR(31) BASED,                                         0224
*     I015F FIXED(15) BASED,                                       0224
*     I015P PTR(15) BASED,                                         0224
*     I008P PTR(8) BASED,                                          0224
*     I001C CHAR(1) BASED;                                         0224
*   END                                                            0225
*                                                                  0225
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (MCAWSA  )                                       */
*/*%INCLUDE SYSLIB  (GTFBLOK )                                       */
*/*%INCLUDE SYSLIB  (RECMAP  )                                       */
*/*%INCLUDE SYSLIB  (GTFPCT  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*                                                                  0225
*       ;                                                          0225
@EL00001 DS    0H                                                  0225
@EF00001 DS    0H                                                  0225
@ER00001 BR    @14                                                 0225
@DATA    DS    0H
@CH00119 DC    H'4096'
@DATD    DSECT
         DS    0F
AHLSBLOK CSECT
         DS    0F
@CF01787 DC    XL4'7FFFFFFF'
@CF01788 DC    XL4'80000000'
@DATD    DSECT
         DS    0D
AHLSBLOK CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CA00028 DC    A(AHLSBLOK)
         DS    0D
SBLKADDR DC    AL4(AHLSBLOK)
LRRPROTO DS    CL6
         ORG   LRRPROTO
@NM00090 DC    AL2(22)
@NM00091 DC    X'00000002'
         ORG   LRRPROTO+6
RECID    DC    CL24'AHLWSMODAHLSBLOKAHLSBFRR'
AHLSBLOK CSECT
         DS   0H
PATCHLOC DC (120)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
AHLSBLOK CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
AWSAPTR  EQU   @03
PCTPTR   EQU   @02
SDWAPTR  EQU   @07
CURRENT  EQU   @04
COMPREG  EQU   @08
SWAPREG  EQU   @09
BLOKCURR EQU   @07
LRRECPTR EQU   @06
RECPTR   EQU   @01
RCREG    EQU   @15
MVCLTPTR EQU   @06
MVCLTLEN EQU   @07
MVCLFPTR EQU   @08
MVCLFLEN EQU   @09
FRREPAD  EQU   @06
SETFREG1 EQU   @08
SETFREG2 EQU   @09
BASEREG  EQU   @12
RTRNREG  EQU   @14
FRR14SAV EQU   @08
R1       EQU   @01
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
         ENTRY AHLSFEOB
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
MCAWSA   EQU   0
MCASBLOK EQU   MCAWSA
MCASFEOB EQU   MCAWSA+56
MCAFWORK EQU   MCAWSA+112
MCATRAIL EQU   MCAWSA+256
MCATRL1  EQU   MCATRAIL
MCATRL2  EQU   MCATRAIL+1
MCATRL3  EQU   MCATRAIL+2
MCATRL4  EQU   MCATRAIL+3
MCATRL5  EQU   MCATRAIL+4
MCATRL6  EQU   MCATRAIL+5
MCATRL7  EQU   MCATRAIL+6
GTFBLOK  EQU   0
BLKCHAIN EQU   GTFBLOK+8
BLOKAREA EQU   GTFBLOK+12
BLOKUSE  EQU   BLOKAREA+2
SVHKREC  EQU   0
SVHKDATA EQU   SVHKREC+6
GTFPCT   EQU   0
GTFSTAT  EQU   GTFPCT+8
GTFOPTS  EQU   GTFPCT+12
GTFOPTS1 EQU   GTFOPTS
GTFOPTS2 EQU   GTFOPTS+1
GTFOPTS3 EQU   GTFOPTS+2
GTFOPTS4 EQU   GTFOPTS+3
PCTCATF  EQU   GTFPCT+16
NEXTBLOK EQU   GTFPCT+180
GBCDS    EQU   NEXTBLOK
CURRBLOK EQU   GTFPCT+184
SBLOKRTN EQU   GTFPCT+188
WRTRCOM  EQU   GTFPCT+204
WRTRCOMP EQU   WRTRCOM
TRMWRIT  EQU   GTFPCT+212
WRTRERR  EQU   GTFPCT+216
GTFSSRB  EQU   GTFPCT+220
GTFLOSTR EQU   GTFPCT+224
QLOCKWRD EQU   GTFPCT+236
QLOCKECB EQU   GTFPCT+240
AUDITFLG EQU   GTFPCT+296
WSERFG03 EQU   AUDITFLG+3
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTTZ    EQU   CVTMAP+304
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSPTR  EQU   0
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
FRREPTR  EQU   0
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLNK  EQU   SRB+4
SRBFLC   EQU   SRB+12
SRBPTR   EQU   0
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWAGR02 EQU   SDWAGRSV+8
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWAREGU EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAMCHK EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
ASCB     EQU   0
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBPTR  EQU   0
FEOBNTRY EQU   0
PLACE    EQU   0
TRCREC   EQU   0
TRECLEN  EQU   TRCREC
LOSTRECR EQU   0
LRRCVTTZ EQU   LOSTRECR+6
LRRTODCV EQU   LOSTRECR+10
LRRCNT   EQU   LOSTRECR+18
I256C    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
BLOKSWAP EQU   BLKCHAIN
RECMAP   EQU   BLOKAREA+4
RECTIME  EQU   RECMAP+6
RECTOD   EQU   RECTIME+4
RECGTFOP EQU   RECMAP+18
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTGSMQ  EQU   CVTS01+264
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
WORKAREA EQU   MCAFWORK
DWCOMP   EQU   WORKAREA
OLDLEN   EQU   DWCOMP+4
DWSWAP   EQU   WORKAREA+8
CHNFIELD EQU   DWSWAP
INUSEBIT EQU   CHNFIELD
LENFIELD EQU   DWSWAP+4
USEFIELD EQU   DWSWAP+6
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00089 EQU   DWCOMP
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTWSAG  EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTSYSWT EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
RECLSTEV EQU   RECGTFOP
RECVTTZ  EQU   RECTIME
RECFID   EQU   RECMAP+5
RECAID   EQU   RECMAP+4
RECRES1  EQU   RECMAP+2
RECLL    EQU   RECMAP
LRRFID   EQU   LOSTRECR+5
LRRAID   EQU   LOSTRECR+4
LRRQSAM  EQU   LOSTRECR+2
LRRLEN   EQU   LOSTRECR
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00088 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00087 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00086 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00085 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00084 EQU   SDWADDAT+3
@NM00083 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00082 EQU   SDWADDAT+1
@NM00081 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00080 EQU   SDWADUMP+2
@NM00079 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00078 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00077 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00076 EQU   SDWAACF3
@NM00075 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00074 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00073 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00072 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00071 EQU   SDWA+239
@NM00070 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00069 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00068 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00067 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00066 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00065 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00064 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00063 EQU   SDWAINC2
@NM00062 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00061 EQU   SDWAILC2
@NM00060 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00059 EQU   SDWANXT2
@NM00058 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00057 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00056 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00055 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00054 EQU   SDWAINC1
@NM00053 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00052 EQU   SDWAILC1
@NM00051 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00050 EQU   SDWANXT1
@NM00049 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00048 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00047 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00046 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00045 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00044 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00043 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00042 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00041 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
@NM00040 EQU   SRB+40
@NM00039 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBID    EQU   SRB
@NM00038 EQU   FRRSFLGS+1
@NM00037 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00012 EQU   CVTFIX+248
@NM00011 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTINTLA EQU   CVTMAP+320
CVTERPV  EQU   CVTMAP+316
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTIERLC EQU   CVTMAP+144
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
PCTWTOMD EQU   GTFPCT+312
PCTDMPMD EQU   GTFPCT+308
TRANSMAX EQU   GTFPCT+304
GTFASCB  EQU   GTFPCT+300
@NM00010 EQU   AUDITFLG+3
AFSLEBLD EQU   AUDITFLG+3
WSERFG06 EQU   AUDITFLG+3
WSERFG05 EQU   AUDITFLG+3
WSERFG04 EQU   AUDITFLG+3
WSERFG02 EQU   AUDITFLG+2
WSERFLAG EQU   AUDITFLG+2
TERMFLAG EQU   AUDITFLG+2
AFXWRIT  EQU   AUDITFLG+2
AFQLWAIT EQU   AUDITFLG+2
AFSLEGET EQU   AUDITFLG+2
AFBUFGET EQU   AUDITFLG+2
AFFEOB   EQU   AUDITFLG+2
AFBLKFIX EQU   AUDITFLG+1
AFEQFIX  EQU   AUDITFLG+1
AFPGRLSE EQU   AUDITFLG+1
AFWRAP   EQU   AUDITFLG+1
AFBUFOFF EQU   AUDITFLG+1
AFLDFX   EQU   AUDITFLG+1
AFCLOSE  EQU   AUDITFLG+1
AFOPEN   EQU   AUDITFLG+1
AFGMBLOK EQU   AUDITFLG
AFGMSRB  EQU   AUDITFLG
AFWAIT   EQU   AUDITFLG
AFTERM   EQU   AUDITFLG
AFINIT   EQU   AUDITFLG
AFWWRIT  EQU   AUDITFLG
AFCWRIT  EQU   AUDITFLG
AFIWRIT  EQU   AUDITFLG
EQSHORT  EQU   GTFPCT+292
SLEMAX   EQU   GTFPCT+288
SLECNT   EQU   GTFPCT+284
RQPURGE  EQU   GTFPCT+280
RQTOTAL  EQU   GTFPCT+276
WRTDLST  EQU   GTFPCT+272
NUMOFBUF EQU   GTFPCT+268
SBUFDISA EQU   GTFPCT+264
SLESUSED EQU   GTFPCT+260
EQMIN    EQU   GTFPCT+256
EQLENGTH EQU   GTFPCT+252
WQMAX    EQU   GTFPCT+248
WQLENGTH EQU   GTFPCT+244
QLECBP   EQU   QLOCKECB
@NM00009 EQU   QLOCKECB
@NM00008 EQU   QLOCKWRD+3
SCHEDBUF EQU   QLOCKWRD+2
POSTWRIT EQU   QLOCKWRD+1
QLOCK    EQU   QLOCKWRD
WRITERDD EQU   GTFPCT+228
SRBAVAIL EQU   GTFSSRB
WRTRERRP EQU   WRTRERR
@NM00007 EQU   WRTRERR
TRMWRITP EQU   TRMWRIT
@NM00006 EQU   TRMWRIT
GTFCMECB EQU   GTFPCT+208
@NM00005 EQU   WRTRCOM
TRANSCNT EQU   GTFPCT+200
AHLRDPLQ EQU   GTFPCT+196
SFEOBRTN EQU   GTFPCT+192
WSMODEND EQU   GTFPCT+176
WSMODBEG EQU   GTFPCT+172
BCBPAGE  EQU   GTFPCT+156
SLEPAGE  EQU   GTFPCT+152
SAVECNT  EQU   GTFPCT+148
SLQHEAD  EQU   GTFPCT+144
HQLENGTH EQU   GTFPCT+140
QTAIL    EQU   GTFPCT+136
HQHEAD   EQU   GTFPCT+132
WQHEAD   EQU   GTFPCT+128
RQHEAD   EQU   GTFPCT+124
EQHEAD   EQU   GTFPCT+120
WPOSTSRB EQU   GTFPCT+116
WTSKTCBA EQU   GTFPCT+112
WRTRTCBA EQU   GTFPCT+108
TRMWTASK EQU   GTFPCT+104
WTSKATTH EQU   GTFPCT+100
WTSKINIT EQU   GTFPCT+96
WTASKECB EQU   GTFPCT+92
WMTABPTR EQU   GTFPCT+88
ATTCHECB EQU   GTFPCT+84
AHLECB   EQU   GTFPCT+80
STOPECBA EQU   GTFPCT+76
ECBADRLT EQU   GTFPCT+72
FIXLEN   EQU   GTFPCT+68
FIXPTR   EQU   GTFPCT+64
INITPTR  EQU   GTFPCT+60
MCQEPTR  EQU   GTFPCT+56
GTFEIDL  EQU   GTFPCT+52
GTFPIBL  EQU   GTFPCT+48
GTFPIFT  EQU   GTFPCT+44
GTFSVCBL EQU   GTFPCT+40
GTFSVCFT EQU   GTFPCT+36
GTFIOBL  EQU   GTFPCT+32
GTFIOFT  EQU   GTFPCT+28
GTFSIOBL EQU   GTFPCT+24
GTFSIOFT EQU   GTFPCT+20
@NM00004 EQU   PCTCATF+1
PCTPIF   EQU   PCTCATF+1
PCTSIOF  EQU   PCTCATF+1
PCTIOF   EQU   PCTCATF+1
PCTSVCF  EQU   PCTCATF+1
PCTRR    EQU   PCTCATF+1
PCTSRM   EQU   PCTCATF+1
PCTRNIO  EQU   PCTCATF+1
PCTUSR   EQU   PCTCATF
PCTPI    EQU   PCTCATF
@NM00003 EQU   PCTCATF
PCTDSP   EQU   PCTCATF
PCTSIO   EQU   PCTCATF
PCTIO    EQU   PCTCATF
PCTEXT   EQU   PCTCATF
PCTSVC   EQU   PCTCATF
OPTTIME  EQU   GTFOPTS4
OPTRES3  EQU   GTFOPTS4
OPTIOSIO EQU   GTFOPTS3
OPTRES2  EQU   GTFOPTS3
OPTRR    EQU   GTFOPTS3
OPTSRM   EQU   GTFOPTS3
OPTRNIO  EQU   GTFOPTS3
OPTEXT   EQU   GTFOPTS3
OPTIOP   EQU   GTFOPTS2
OPTIO    EQU   GTFOPTS2
OPTPIP   EQU   GTFOPTS2
OPTPI    EQU   GTFOPTS2
OPTSIOP  EQU   GTFOPTS2
OPTSIO   EQU   GTFOPTS2
OPTSVCP  EQU   GTFOPTS2
OPTSVC   EQU   GTFOPTS2
OPTPCI   EQU   GTFOPTS1
OPTRES1  EQU   GTFOPTS1
OPTDSP   EQU   GTFOPTS1
OPTTRC   EQU   GTFOPTS1
OPTUSR   EQU   GTFOPTS1
OPTSYS   EQU   GTFOPTS1
OPTSYSP  EQU   GTFOPTS1
OPTSYSM  EQU   GTFOPTS1
GTFRESV  EQU   GTFSTAT
GTFDEBUG EQU   GTFSTAT
GTFMODE  EQU   GTFSTAT
GTFPCTID EQU   GTFPCT
SVHKTCB  EQU   SVHKDATA+4
SVHKASID EQU   SVHKDATA+2
SVHKEID  EQU   SVHKDATA
SVHKAFID EQU   SVHKREC+4
@NM00002 EQU   SVHKREC+2
SVHKLEN  EQU   SVHKREC
BLOKLEN  EQU   BLOKAREA
BLKINUSE EQU   BLKCHAIN
BLOKID   EQU   GTFBLOK
MCASWORK EQU   MCAWSA+644
MCAWORK  EQU   MCAWSA+584
MCAREC   EQU   MCAWSA+284
MCARECPR EQU   MCAWSA+268
MCAMCR   EQU   MCAWSA+264
MCATRL8  EQU   MCATRAIL+7
MCAFRECT EQU   MCATRL7
MCAFRECC EQU   MCATRL7
MCAFRESP EQU   MCATRL7
MCAFREXJ EQU   MCATRL7
MCAFRSBR EQU   MCATRL6
MCAFRDMJ EQU   MCATRL6
MCAFRDPC EQU   MCATRL6
MCAFRPIC EQU   MCATRL6
MCAFRPIJ EQU   MCATRL6
@NM00001 EQU   MCATRL5
MCADREGS EQU   MCATRL5
MCAFRRB  EQU   MCATRL5
MCAFRRJ  EQU   MCATRL5
MCAFRRA  EQU   MCATRL5
MCAFRERT EQU   MCATRL5
MCAFREPC EQU   MCATRL5
MCAMJOBN EQU   MCATRL4
MCAMSDWA EQU   MCATRL4
MCAMBTU  EQU   MCATRL4
MCAMIOSB EQU   MCATRL4
MCAMTCB  EQU   MCATRL4
MCAMASCB EQU   MCATRL4
MCAMUCB  EQU   MCATRL4
MCAMEXT  EQU   MCATRL4
MCAFRFRT EQU   MCATRL3
MCAFRFA  EQU   MCATRL3
MCAFRSJ  EQU   MCATRL3
MCAFRSA  EQU   MCATRL3
MCAPIF   EQU   MCATRL3
MCASIOF  EQU   MCATRL3
MCAIOF   EQU   MCATRL3
MCASVCF  EQU   MCATRL3
MCATDIR  EQU   MCATRL2
MCALSR   EQU   MCATRL2
MCAERROR EQU   MCATRL2
MCAUIO   EQU   MCATRL2
MCASTA   EQU   MCATRL2
MCAFRR   EQU   MCATRL2
MCASRM   EQU   MCATRL2
MCARNIO  EQU   MCATRL2
MCAUSR   EQU   MCATRL1
MCAPI    EQU   MCATRL1
MCASRB   EQU   MCATRL1
MCADSP   EQU   MCATRL1
MCASIO   EQU   MCATRL1
MCAIO    EQU   MCATRL1
MCAEXT   EQU   MCATRL1
MCASVC   EQU   MCATRL1
MCAMSG   EQU   MCAWSA+192
MCASETEV EQU   MCAWSA+128
@NM00036 EQU   PSA+3412
PSASTAK  EQU   PSA+3072
@NM00035 EQU   PSA+1032
PSAUSEND EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSARV060 EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSARV054 EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSARV058 EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSAMODE  EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00034 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00033 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSARV009 EQU   PSASUP3
PSARV008 EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00032 EQU   FLCFSA
@NM00031 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00030 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00029 EQU   FLCIOA
@NM00028 EQU   FLCMCLA+15
@NM00027 EQU   FLCMCLA+14
@NM00026 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00025 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00024 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00023 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00022 EQU   FLCPER
@NM00021 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00020 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00019 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00018 EQU   FLCPIILC
@NM00017 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00016 EQU   FLCSVILC
@NM00015 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00014 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00013 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00087 EQU   RESTART
@RT00091 EQU   RESTART
@RT00111 EQU   SETRC
@RT00115 EQU   NOFEOB
@RT00123 EQU   GBCDSON
@RT00163 EQU   SETRC
@ENDDATA EQU   *
         END   AHLSBLOK,(C'PL/S-II',0503,73286)
