         TITLE 'AHLTEXT - FGBR FOR COMP. EXTERNAL TRACE RECORD         *
                       '
AHLTEXT  CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'AHLTEXT   74.016'                                 0001
         DROP  @15
@PROLOG  DS    0H                                                  0002
         USING AHLTEXT,R15ENTRY    SET UP TEMP BASE
         L     RBASE,EXTEBASE      GET BASE ADDRESS UPON ENTRY
         USING AHLTEXT,RBASE       TELL ASSEM ABOUT BASE
         DROP  R15ENTRY            TELL ASSEM TO STOP USING R15
*   DO;                                                            0058
*                                                                  0058
*/* ******************************************************************/
*/*                                                                  */
*/*      THIS IS THE MAIN LINE PROCESSING FOR AHLTEXT.               */
*/*      IT CONTAINS THE FOLLOWING FUNCTIONS ---                     */
*/*            -HOUSEKEEPING                                         */
*/*            -COMPLETION OF THE COMMON PORTIONS OF THE             */
*/*             COMPREHENSIVE EXT TRACE RECORD                       */
*/*            -COMPLETION OF THE SPECIAL SUFFIX FOR THE             */
*/*             EXTERNAL TRACE RECORD                                */
*/*            -COMPLETION PROCESSING                                */
*/*                                                                  */
*/* ******************************************************************/
*/*                                                                  */
*/* ******************************************************************/
*/*                                                                  */
*/*      HOUSEKEEPING                                                */
*/*            - SET THE MCATRAIL TO EXT IN CONTROL                  */
*/*              AND UNRECOVERABLE ERROR                             */
*/*            - SET UP ERROR RECOVERY USING SETFRR                  */
*/*            - SAVE REG 14 IN THE SETFRR PARM AREA                 */
*/*            - TEST FOR HOOK BEING ISSUED FROM SUPV STATE          */
*/*              AND KEY ZERO                                        */
*/* ******************************************************************/
*                                                                  0059
*     RFY                                                          0059
*      (R9WORK,                                                    0059
*       RRTN)RSTD;                                                 0059
*     SVREG0=R0;                    /* SAVE MCQE BASE REG            */
         ST    R0,SVREG0(,AWSAPTR)                                 0060
*     MCATRAIL=TRAILSET;            /* SET TRAIL TO INDICATE THAT EXT
*                                      IN CONTROL                    */
         MVC   MCATRAIL(8,AWSAPTR),@CB02691                        0061
*     R9WORK=ADDR(AHLTEXTE);        /* GET ADDRESS OF THE RECOVERY 0062
*                                      ROUTINE                       */
         LA    R9WORK,AHLTEXTE                                     0062
*     GEN SETS(R9WORK,R10WORK)NOEXIT SEQFLOW NOFLOWS REFS(AHLTEXTE,
*         PSACSTK,PSA,FRRSCURR,FRRS,FRRSLAST,FRRSELEN,FRRSEMP,FRRSFRRA,
*         FRRSENTR,FRRSPARM);                                      0063
  SETFRR A,FRRAD=(R9WORK),PARMAD=(FRRPTR),WRKREGS=(FRRPTR,R10WORK)
*     R0=SVREG0;                    /* RESTORE MCQE BASE REG         */
         L     R0,SVREG0(,AWSAPTR)                                 0064
*     SVR14NRM=RRTN;                /* SAVE RETURN ADDRESS           */
         ST    RRTN,SVR14NRM(,FRRPTR)                              0065
*     RFY                                                          0066
*      (RRTN,                                                      0066
*       R9WORK)UNRSTD;                                             0066
*     IF MCRBRENT='0'B THEN                                        0067
         L     @04,MCAMCR(,AWSAPTR)                                0067
         TM    MCRBRENT(@04),B'00010000'                           0067
         BZ    @RT00067                                            0067
*       GO TO EXTEND;               /* QUIT IF NOT A BRANCH HOOK     */
*                                                                  0068
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*      CREATE COMMON PORTION OF THE COMPREHENSIVE                  */
*/*      EXTERNAL TRACE RECORD. FILL IN THE FOLLOWING --             */
*/*            - ASCB ADDRESS                                        */
*/*            - CPU IDENTIFICATION                                  */
*/*            - JOBNAME                                             */
*/*            - PSW AT TIME OF INTERRUPT                            */
*/*            - ADDRESS OF THE INIT TCB                             */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*                                                                  0069
*     IF PSAAOLD=GTFASCB THEN       /* IS THIS A GTF INTERRUPT?      */
         CLC   PSAAOLD(4),GTFASCB(PCTPTR)                          0069
         BNE   @RF00069                                            0069
*       IF OPTTRC=OFF THEN          /* YES - SEE IF WE ARE TRACING 0070
*                                      GTF.                          */
         TM    OPTTRC(PCTPTR),B'00001000'                          0070
         BZ    @RT00070                                            0070
*         GO TO EXTEND;             /* NO - GO TO END                */
*     EXTASCB=PSAAOLD;              /* NO - SAVE ASCB ADDR           */
@RF00069 L     @04,PSAAOLD                                         0072
         ST    @04,EXTASCB(,AWSAPTR)                               0072
*     MCATRL7=FREXJ;                /* SET AUDIT TRAIL TO INDICATE 0073
*                                      OBTAINING JOBNAME             */
         MVI   MCATRL7(AWSAPTR),X'08'                              0073
*     RFY                                                          0074
*      (ASCBPTR,                    /* FREEZE REGS FOR OBTAINING     */
*       R10WORK)RSTD;               /* JOBNAME                       */
*     ASCBPTR=PSAAOLD;              /* GET ASCB ADDR                 */
         L     @11,PSAAOLD                                         0075
         LR    ASCBPTR,@11                                         0075
*     R10WORK=ASCBJBNI;             /* GET FIRST JOBNAME POINTER     */
         L     R10WORK,ASCBJBNI(,ASCBPTR)                          0076
*     IF R10WORK=0 THEN             /* CHECK FOR NO ADDRESS          */
         SR    @11,@11                                             0077
         CR    R10WORK,@11                                         0077
         BNE   @RF00077                                            0077
*       DO;                                                        0078
*         R10WORK=ASCBJBNS;         /* GET SECOND POINTER            */
         L     R10WORK,ASCBJBNS(,ASCBPTR)                          0079
*         IF R10WORK=0 THEN         /* GOOD ADDRESS?                 */
         CR    R10WORK,@11                                         0080
         BE    @RT00080                                            0080
*           GO TO EXTJNNA;          /* NO - GO SET ADDR TO N/A       */
*       END;                                                       0082
*     IF JBNMTEST^=0 THEN           /* JOBNAME GOOD?                 */
@RF00077 ICM   @11,15,JBNMTEST(R10WORK)                            0083
         BZ    @RF00083                                            0083
*       EXTJBN=JOBNAME;             /* YES - USE IT                  */
         MVC   EXTJBN(8,AWSAPTR),JOBNAME(R10WORK)                  0084
*     ELSE                                                         0085
*EXTJNNA:                                                          0085
*       EXTJBN=NOTAPP;              /* NO - SET NAME = N/A           */
         B     @RC00083                                            0085
@RF00083 DS    0H                                                  0085
EXTJNNA  MVC   EXTJBN(8,AWSAPTR),@CC02680                          0085
*     RFY                                                          0086
*      (R10WORK,                    /* FREE REGS WHICH WERE NEEDED   */
*       ASCBPTR)UNRSTD;             /* FOR OBTAINING JOBNAME         */
@RC00083 DS    0H                                                  0087
*AHLTEXJ:                                                          0087
*     MCATRL7=UNRECOV;              /* SET AUDIT TRAIL TO          0087
*                                      UNRECOVERABLE                 */
AHLTEXJ  MVI   MCATRL7(AWSAPTR),X'00'                              0087
*     EXTCPUID=PSACPUSA;            /* GET CPU ID            @YMO3489*/
         MVC   EXTCPUID(2,AWSAPTR),PSACPUSA                        0088
*     EXTOPSW=FLCEOPSW;             /* GET OLD PSW                   */
         MVC   EXTOPSW(8,AWSAPTR),FLCEOPSW                         0089
*     EXTOPIT=FLCEICOD;             /* GET INTERRUPT TYPE INTO PSW 0090
*                                      FOR 360 COMPATABILIBY         */
         MVC   EXTOPIT(2,AWSAPTR),FLCEICOD                         0090
*     RFY                                                          0091
*       LCCAPTR RSTD;               /* FREEZE REG FOR OBTAINING TCB
*                                      ADDR                          */
*     LCCAPTR=PSALCCAV;             /* GET LCCA ADDR                 */
         L     LCCAPTR,PSALCCAV                                    0092
*     IF LCCASRBM=ON THEN           /* IS THIS AN SRB?               */
         TM    LCCASRBM(LCCAPTR),B'10000000'                       0093
         BNO   @RF00093                                            0093
*       EXTITTCB=NOTAPP;            /* YES - PUT N/A IN TCB@ FIELD   */
         MVC   EXTITTCB(4,AWSAPTR),@CC02680                        0094
*     ELSE                                                         0095
*       EXTITTCB=PSATOLD;           /* NO - GET TCB@ FROM PSA        */
         B     @RC00093                                            0095
@RF00093 MVC   EXTITTCB(4,AWSAPTR),PSATOLD                         0095
*     RFY                                                          0096
*       LCCAPTR UNRSTD;                                            0096
*                                                                  0096
@RC00093 DS    0H                                                  0097
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*     COMPLETION OF THE SPECIAL SUFFIX FOR                         */
*/*     THE EXTERNAL TRACE RECORD                                    */
*/*                                                                  */
*/*           - TEST FLCEICOD TO DETERMINE INTERRUPT TYPE            */
*/*                                                                  */
*/*                --TYPE = EXT OR CLOCK SYNC - NO SUFFIX            */
*/*                --TYPE = CLOCK COMP, CPU TIMER OR SIG P --        */
*/*                         --SPECIAL SUFFIX                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0097
*     IF INTTYPE(1:1)=ETSP0 THEN    /* TYPE = SIG P?                 */
         CLI   INTTYPE,X'12'                                       0097
         BNE   @RF00097                                            0097
*       DO;                         /* YES - FORMAT SIG P SUFFIX     */
*                                                                  0098
*/********************************************************************/
*/*                                                                  */
*/*      COMPLETE SUFFIX FOR SIG P INTERRUPT                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0099
*         MCATRL7=FRESP;            /* SET AUDIT TRAIL               */
         MVI   MCATRL7(AWSAPTR),X'01'                              0099
*         EXTSPARM=SIGPARM;         /* MOVE PARM INTO SUFFIX         */
         MVC   EXTSPARM(4,AWSAPTR),SIGPARM                         0100
*         EXTSPROC=SIGPROC;         /* MOVE PROC@ INFO TO SUFFIX     */
         MVC   EXTSPROC(2,AWSAPTR),SIGPROC                         0101
*AHLTESP:                                                          0102
*         RFY                                                      0102
*           RECSIZE RSTD;                                          0102
AHLTESP  DS    0H                                                  0103
*         RECSIZE=LENGTH(EXTPREF)+LENGTH(EXTSUFSP);/* GET SIZE OF  0103
*                                      RECORD                        */
         LA    RECSIZE,32                                          0103
*         GO TO EXTSTACK;           /* AND GO STACK RECORD           */
         B     EXTSTACK                                            0104
*         RFY                                                      0105
*           RECSIZE UNRSTD;                                        0105
*       END;                                                       0106
*     ELSE                                                         0107
*       IF INTTYPE=ETCC THEN        /* TYPE = CLOCK COMP?            */
@RF00097 CLC   INTTYPE(2),@CB02701                                 0107
         BNE   @RF00107                                            0107
*         DO;                                                      0108
*                                                                  0108
*/********************************************************************/
*/*                                                                  */
*/*      COMPLETE SUFFIX FOR CLOCK COMP INTERRUPT                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0109
*           MCATRL7=FRECC;          /* SET AUDIT TRAIL TO INDICATE 0109
*                                      CLOCK COMPARATOR SUFFIX       */
         MVI   MCATRL7(AWSAPTR),X'04'                              0109
*           RFY                                                    0110
*            (PCCAPTR,              /* FREEZE REGS                   */
*             TQEPTR)RSTD;                                         0110
*           PCCAPTR=PSAPCCAV;       /* GET ADDR OF PCCA              */
         L     PCCAPTR,PSAPCCAV                                    0111
*           IF PCCATQEP=0 THEN      /* PCCATQEP GOOD?                */
         ICM   @06,15,PCCATQEP(PCCAPTR)                            0112
         BNZ   @RF00112                                            0112
*             DO;                   /* NO --                         */
*               EXTCFLGS=UNAVS;     /* THEN MOVE UNAVAILABLE         */
         MVC   EXTCFLGS(2,AWSAPTR),@CC02695                        0114
*               EXTCEXIT=UNAV;      /* INDICATORS INTO ALL           */
         MVC   EXTCEXIT(4,AWSAPTR),@CC02682                        0115
*               EXTCASCB=UNAV;      /* FIELDS OF THE CLOCK COMP      */
         MVC   EXTCASCB(4,AWSAPTR),@CC02682                        0116
*               EXTCTCB=UNAV;       /* SUFFIX.                       */
         MVC   EXTCTCB(4,AWSAPTR),@CC02682                         0117
*             END;                                                 0118
*           ELSE                                                   0119
*             DO;                   /* YES --                        */
         B     @RC00112                                            0119
@RF00112 DS    0H                                                  0120
*               TQEPTR=PCCATQEP;    /* GET TQE@                      */
         L     TQEPTR,PCCATQEP(,PCCAPTR)                           0120
*               EXTCQFL=TQEFLGS;    /* GET TQEFLGS                   */
         MVC   EXTCQFL(1,AWSAPTR),TQEFLGS(TQEPTR)                  0121
*               EXTCQFL2=TQEFLGS2;                                 0122
         MVC   EXTCQFL2(1,AWSAPTR),TQEFLGS2(TQEPTR)                0122
*               EXTCEXIT=TQEEXIT;   /* GET TQEEXIT                   */
         MVC   EXTCEXIT(4,AWSAPTR),TQEEXIT(TQEPTR)                 0123
*               EXTCASCB=TQEASCB;                                  0124
         MVC   EXTCASCB(4,AWSAPTR),TQEASCB(TQEPTR)                 0124
*               EXTCTCB=TQETCB;                                    0125
         MVC   EXTCTCB(4,AWSAPTR),TQETCB(TQEPTR)                   0125
*               RFY                                                0126
*                (PCCAPTR,          /* FREE REGS                     */
*                 TQEPTR)UNRSTD;                                   0126
*             END;                                                 0127
*AHLTECC:                           /* ENTRY POINT FOR FRR           */
*           RFY                                                    0128
*             RECSIZE RSTD;                                        0128
@RC00112 DS    0H                                                  0128
AHLTECC  DS    0H                                                  0129
*           RECSIZE=LENGTH(EXTPREF)+LENGTH(EXTSUFCC);              0129
*                                                                  0129
         LA    RECSIZE,40                                          0129
*           /*********************************************************/
*           /*                                                       */
*           /* GET SIZE OF RECORD                                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0130
*           GO TO EXTSTACK;         /* AND GO STACK IT               */
         B     EXTSTACK                                            0130
*           RFY                                                    0131
*             RECSIZE UNRSTD;                                      0131
*         END;                                                     0132
*       ELSE                                                       0133
*         IF INTTYPE=ETCT THEN      /* TYPE = CPU TIMER?             */
@RF00107 CLC   INTTYPE(2),@CB02703                                 0133
         BNE   @RF00133                                            0133
*           DO;                     /* YES --                        */
*                                                                  0134
*/********************************************************************/
*/*                                                                  */
*/*      COMPLETE SUFFIX FOR CPU TIMER  INTERRUPT                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0135
*             MCATRL7=FRECT;        /* SET AUDIT TRAIL TO IND CPU T  */
         MVI   MCATRL7(AWSAPTR),X'02'                              0135
*             RFY                                                  0136
*              (TQEPTR,             /* FREEZE REGS                   */
*               R9WORK)RSTD;                                       0136
*             R9WORK=PSATOLD;       /* GET PTR TO TCB                */
         L     R9WORK,PSATOLD                                      0137
*             TQEPTR=R9WORK->TCBTME;/* GET TQE@                      */
         L     TQEPTR,TCBTME(,R9WORK)                              0138
*             RFY                                                  0139
*               R9WORK UNRSTD;                                     0139
*             IF TQEPTR^=0 THEN                                    0140
         LTR   TQEPTR,TQEPTR                                       0140
         BZ    @RF00140                                            0140
*               DO;                 /* GATHER FLAGS AND EXIT IF TQE
*                                      EXISTS                        */
*                 EXTTQFL=TQEFLGS;                                 0142
         MVC   EXTTQFL(1,AWSAPTR),TQEFLGS(TQEPTR)                  0142
*                 EXTTQFL2=TQEFLGS2;                               0143
         MVC   EXTTQFL2(1,AWSAPTR),TQEFLGS2(TQEPTR)                0143
*                 EXTTEXIT=TQEEXIT;                                0144
         MVC   EXTTEXIT(4,AWSAPTR),TQEEXIT(TQEPTR)                 0144
*               END;                                               0145
*             ELSE                                                 0146
*               DO;                 /* IF TQE DOES NOT EXIST, MOVE IN
*                                      INDICATION                    */
         B     @RC00140                                            0146
@RF00140 DS    0H                                                  0147
*                 EXTTFLGS=UNAVS;                                  0147
         MVC   EXTTFLGS(2,AWSAPTR),@CC02695                        0147
*                 EXTTEXIT=UNAV;                                   0148
         MVC   EXTTEXIT(4,AWSAPTR),@CC02682                        0148
*               END;                                               0149
*             RFY                                                  0150
*               TQEPTR UNRSTD;      /* FREE REG                      */
@RC00140 DS    0H                                                  0151
*AHLTECT:                           /* ENTRY POINT FROM FRR          */
*             RFY                                                  0151
*               RECSIZE RSTD;                                      0151
AHLTECT  DS    0H                                                  0152
*             RECSIZE=LENGTH(EXTPREF)+LENGTH(EXTSUFCT);/* GET REC  0152
*                                      SIZE                          */
         LA    RECSIZE,32                                          0152
*             GO TO EXTSTACK;       /* AND GO STACK RECORD           */
         B     EXTSTACK                                            0153
*           END;                                                   0154
*         ELSE                                                     0155
*                                                                  0155
*/********************************************************************/
*/*                                                                  */
*/*        INTERRUPT TYPE WAS NONE OF THE ABOVE -- JUST USE PREFIX   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0155
*           RECSIZE=LENGTH(EXTPREF);                               0155
@RF00133 LA    RECSIZE,26                                          0155
*     RFY                                                          0156
*       RECSIZE UNRSTD;                                            0156
*                                                                  0156
*/* ******************************************************************/
*/*                                                                  */
*/*      COMPLETION PROCESSING                                       */
*/*            - SET AUDIT TRAIL TO UNRECOVERABLE                    */
*/*            - USE AHLSTACK MACRO TO PLACE EXT TRACE               */
*/*              RECORD INTO THE BUFFER                              */
*/*            - RESTORE REGISTER 14                                 */
*/*            - USE SETFRR TO DELETE FRR FROM LIST                  */
*/*            - RETURN TO MCIH                                      */
*/*                                                                  */
*/* ******************************************************************/
*/*                                                                  */
*                                                                  0157
*EXTSTACK:                                                         0157
*     RFY                                                          0157
*       RECSIZE RSTD;                                              0157
EXTSTACK DS    0H                                                  0158
*     MCATRL7=UNRECOV;              /* SET AUDIT TRAIL TO UNRECOVER  */
         MVI   MCATRL7(AWSAPTR),X'00'                              0158
*     DO;                           /* AHLSTACK DLENGTH(RECSIZE)   0159
*                                      FID(EXTFIDC) AID(EXTAIDC)     */
*                                                                  0159
*       /*************************************************************/
*       /*                                                           */
*       /* THE FOLLOWING CODE IS GENERATED BY THE AHLSTACK MACRO.    */
*       /* THIS CODE BUILDS THE GTF RECORD PREFIX AND THEN CALLS     */
*       /* AHLSBLOK TO STACK THE RECORD.                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0160
*       DCL                                                        0160
*         1 AHLGREC INT BASED(AHLRECPR)BDY(WORD),/* MAPPING FOR    0160
*                                      RECORD PREFIX                 */
*          2 AHLGLGTH PTR(16),      /* LENGTH OF RECORD PLUS PREFIX  */
*          2 AHLGRES PTR(16),       /* FOR COMPATIBILITY TO QSAM     */
*          2 AHLGAID PTR(8),        /* APPLICATION ID                */
*          2 AHLGFID PTR(8),        /* FORMAT APPENDAGE ID           */
*          2 AHLGTST CHAR(8),       /* TIMESTAMP IF SPECIFIED        */
*           3 AHLGEIDS PTR(16)BDY(BYTE),/* RECORD EVENT IDENTIFIER IF
*                                      NO TIMESTAMP                  */
*          2 AHLGEIDL PTR(16);      /* RECORD EVENT IDENTIFIER WITH
*                                      TIMESTAMP                     */
*       DCL                                                        0161
*         AHLRECPR PTR(31)REG(1),   /* USED AS POINTER TO RECORD   0161
*                                      PREFIX AREA                   */
*         AHLSBREG PTR(31)REG(14),  /* USED TO HOLD A STABLE COPY OF
*                                      THE SBLOKRTN FIELD IN THE   0161
*                                      GTFPCT                        */
*         AHLRETCD PTR(31)REG(15);  /* USED TO PASS RETURN CODE TO 0161
*                                      INVOKER                       */
*       DCL                                                        0162
*         AHLSBLOK ENTRY OPTIONS(NOEXIT,SEQFLOW,REFS(MCAWSA),SETS( 0162
*             AHLRETCD),NOFLOWS)BASED(AHLSBREG)VALRG(0);/* ENTRY FOR
*                                      AHLSBLOK                      */
*       RFY                                                        0163
*        (AHLRECPR,                                                0163
*         AHLSBREG,                                                0163
*         AHLRETCD)RSTD;                                           0163
*       IF OPTTIME='1'B THEN        /* CHECK FOR TIMESTAMP REQUESTED */
         TM    OPTTIME(PCTPTR),B'00000001'                         0164
         BNO   @RF00164                                            0164
*         DO;                       /* YES, TIMESTAMP                */
*           AHLRECPR=ADDR(MCARECPR);/* SETUP ADDRESSIBILITY TO PREFIX
*                                      FOR PREFIX WITH TIMESTAMP     */
         LA    AHLRECPR,MCARECPR(,AWSAPTR)                         0166
*           AHLGLGTH=RECSIZE+16;    /* SET LENGTH TO INCLUDE ***   0167
*                                      DLENGTH *** PLUS TIMESTAMP  0167
*                                      PREFIX                        */
         LA    @08,16                                              0167
         AR    @08,RECSIZE                                         0167
         STH   @08,AHLGLGTH(,AHLRECPR)                             0167
*           GEN                                                    0168
*(STCK AHLGTST(AHLRECPR) PUT TOD CLOCK VALUE INTO PREFIX )         0168
*           SETS(AHLGTST)NOEXIT SEQFLOW NOFLOWS;                   0168
         STCK AHLGTST(AHLRECPR) PUT TOD CLOCK VALUE INTO PREFIX
*           AHLGEIDL=MCAMCR->MCREID;/* *** EID *** NOT SPECIFIED PUT
*                                      DEFAULT INTO PREFIX           */
         L     @08,MCAMCR(,AWSAPTR)                                0169
         MVC   AHLGEIDL(2,AHLRECPR),MCREID(@08)                    0169
*         END;                                                     0170
*       ELSE                        /* NO TIMESTAMP TO BE DONE, BUILD
*                                      SHORT PREFIX                  */
*         DO;                                                      0171
         B     @RC00164                                            0171
@RF00164 DS    0H                                                  0172
*           AHLRECPR=ADDR(MCARECPR)+8;/* SETUP ADDRESSIBILITY TO FOR
*                                      SHORT PREFIX WITHOUT TIMESTAMP*/
         LA    @08,8                                               0172
         LA    AHLRECPR,MCARECPR(,AWSAPTR)                         0172
         AR    AHLRECPR,@08                                        0172
*           AHLGLGTH=RECSIZE+8;     /* PUT TOTAL RECORD LENGTH INTO
*                                      PREFIX *** DLENGTH *** PLUS 0173
*                                      PREFIX LENGTH                 */
         AR    @08,RECSIZE                                         0173
         STH   @08,AHLGLGTH(,AHLRECPR)                             0173
*           AHLGEIDS=MCAMCR->MCREID;/* *** EID *** NOT SPECIFIED PUT
*                                      DEFAULT INTO PREFIX           */
         L     @08,MCAMCR(,AWSAPTR)                                0174
         MVC   AHLGEIDS(2,AHLRECPR),MCREID(@08)                    0174
*         END;                                                     0175
*       AHLGRES=0;                  /* ZERO OUT FOR QSAM           0176
*                                      COMPATIBILITY                 */
@RC00164 SR    @08,@08                                             0176
         STH   @08,AHLGRES(,AHLRECPR)                              0176
*       AHLGAID=EXTAIDC;            /* PUT *** AID *** INTO PREFIX   */
         MVI   AHLGAID(AHLRECPR),X'FF'                             0177
*       AHLGFID=EXTFIDC;            /* PUT *** FID *** INTO PREFIX   */
         MVI   AHLGFID(AHLRECPR),X'05'                             0178
*       AHLRETCD=4;                 /* SET DEFAULT RETURN CODE       */
         LA    AHLRETCD,4                                          0179
*       AHLSBREG=SBLOKRTN;          /* GET A STABLE COPY OF AHLSBLOK
*                                      ADDR                          */
         L     AHLSBREG,SBLOKRTN(,PCTPTR)                          0180
*       IF AHLSBREG^=0 THEN         /* CHECK TO SEE IF AHLSBLOK IS 0181
*                                      AVAILABLE                     */
         CR    AHLSBREG,@08                                        0181
         BE    @RF00181                                            0181
*         CALL AHLSBLOK;            /* YES, SO CALL AHLSBLOK TO BLOCK
*                                      RECORD                        */
         LR    @15,AHLSBREG                                        0182
         BALR  @14,@15                                             0182
*       RFY                                                        0183
*        (AHLRECPR,                                                0183
*         AHLSBREG,                                                0183
*         AHLRETCD)UNRSTD;                                         0183
@RF00181 DS    0H                                                  0184
*     END;                                                         0184
*     R0=SVREG0;                    /* RESTORE MCQE BASE REG         */
         L     R0,SVREG0(,AWSAPTR)                                 0185
*     RFY                                                          0186
*       RECSIZE UNRSTD;                                            0186
*                                                                  0186
*/*      RESTORE REG 14,                                             */
*/*      DELETE THE FRR                                              */
*/*      AND RETURN TO MCIH.                                         */
*/*                                                                  */
*                                                                  0187
*     RFY                                                          0187
*      (R10WORK,                    /* FREEZE REGS FOR EXIT PROCESS  */
*       RRTN)RSTD;                                                 0187
*EXTEND:                                                           0188
*     RRTN=SVR14NRM;                /* RESTORE R14 TO ORIGINAL RETURN
*                                      ADDR                          */
EXTEND   L     RRTN,SVR14NRM(,FRRPTR)                              0188
*     GEN SETS(FRRPTR,R10WORK)NOEXIT SEQFLOW NOFLOWS;              0189
   SETFRR D,WRKREGS=(FRRPTR,R10WORK)
*     R0=SVREG0;                    /* RESTORE MCQE BASE REG         */
         L     R0,SVREG0(,AWSAPTR)                                 0190
*     GEN SETS(RRTN)EXIT( BR RRTN RETURN TO CALLER);               0191
          BR RRTN RETURN TO CALLER
*     RFY                                                          0192
*      (R10WORK,                                                   0192
*       RRTN)UNRSTD;                                               0192
*   END;                                                           0193
*AHLTEXTE:                                                         0194
*   GEN SETS(RBASE)NOEXIT NOFLOWS SEQFLOW;                         0194
*                                                                  0194
AHLTEXTE DS    0H                                                  0194
         USING AHLTEXTE,R15ENTRY   SET UP TEMP BASE
         L     RBASE,EXTEBASE      GET BASE ADDRESS UPON ENTRY
         USING AHLTEXT,RBASE       TELL ASSEM ABOUT BASE
         DROP  R15ENTRY            TELL ASSEM TO STOP USING R15
*/*                                                                  */
*/*      AHLTEXT FRR ROUTINE                                         */
*/*                                                                  */
*                                                                  0195
*   DO;                                                            0195
*                                                                  0195
*/********************************************************************/
*/*                                                                  */
*/*      AHLTEXTE --                                                 */
*/*      THIS IS THE FRR FOR AHLTEXT.  IF AN ERROR OCCURS DURING     */
*/*      PROCESSING OF AHLTEXT, THIS ROUTINE GAINS CONTROL.          */
*/*      APPROPRIATE PROCESSING OCCURS DEPENDING ON THE ERROR.       */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*      INITIALIZE FRR PROCESSING                                   */
*/*            - SAVE PARM@ FROM RTCA                                */
*/*            - SAVE REG 14 IN PARM AREA                            */
*/*            - RESTORE APPROPRIATE BASE REGS                       */
*/*            - TAKE CARE OF MCATRAIL                               */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*                                                                  0196
*     RFY                                                          0196
*      (RRTN,                                                      0196
*       R1)RSTD;                                                   0196
*     FRRPTR=SDWAPARM;              /* GET @ FRR PARM FIELD          */
         L     FRRPTR,SDWAPARM(,SDWAPTR)                           0197
*     SVR14FRR=RRTN;                /* SAVE RETURN @ TO RTM          */
         ST    RRTN,SVR14FRR(,FRRPTR)                              0198
*     RFY                                                          0199
*       RRTN UNRSTD;                                               0199
*     RFY                                                          0200
*       LCCA BASED(PSALCCAV);                                      0200
*     RFY                                                          0201
*       MCRWSA BASED(WSACGTF);                                     0201
*     AWSAPTR=MCRMCA;               /* GET MCAWSA@ AT ERROR          */
         L     @04,PSALCCAV                                        0202
         L     @04,LCCACPUS(,@04)                                  0202
         L     @04,WSACGTF(,@04)                                   0202
         L     AWSAPTR,MCRMCA(,@04)                                0202
*     SVREG1=R1;                    /* SAVE SDWA BASE REG            */
         ST    R1,SVREG1(,AWSAPTR)                                 0203
*     RFY                                                          0204
*       MCRWSA BASED(MCAMCR);                                      0204
*     TRAILSAV=MCATRAIL;            /* SAVE TRAIL BITS FOR C&S LOGIC
*                                      LATER                         */
         MVC   TRAILSAV(4,FRRPTR),MCATRAIL(AWSAPTR)                0205
*     MCAERROR=ON;                  /* INDICATE ERROR ROUTINE IN   0206
*                                      CONTROL                       */
         OI    MCAERROR(AWSAPTR),B'00000100'                       0206
*     R0=MCROUTSA(1:4);             /* GET MCQE@ AT TIME OF ERROR    */
         L     @04,MCAMCR(,AWSAPTR)                                0207
         L     R0,MCROUTSA(,@04)                                   0207
*     PCTPTR=R0->MCQEAT;            /* GET ADDR OF PCT AT TIME OF  0208
*                                      ERROR                         */
*                                                                  0208
         LR    @04,R0                                              0208
         L     PCTPTR,MCQEAT(,@04)                                 0208
*/********************************************************************/
*/*                                                                  */
*/*      DETERMINE WHAT THE ERROR WAS                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0209
*     IF SDWAMCHK=ON THEN           /* WAS THIS A MACHINE CHECK      */
*                                                                  0209
         TM    SDWAMCHK(SDWAPTR),B'10000000'                       0209
         BNO   @RF00209                                            0209
*/********************************************************************/
*/*                                                                  */
*/*      IF MACHINE CHECK --                                         */
*/*           TEST FOR INSTRUCTION FAIL AND SEE IF PSW AND REGS      */
*/*           ARE PREDICTABLE.  IF PROBLEM IS INSTRUCTION FAIL       */
*/*           OR IF EITHER PSW OR REGS ARE UNPREDICTABLE,            */
*/*           GO TO CATASTROPHIC ERROR PROCESSING.                   */
*/*                OTHERWISE, SET RETURN CODE TO RETRY AT THE        */
*/*                NEXT INSTRUCTION TO BE EXECUTED.                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0210
*       DO;                                                        0210
*         IF SDWAINSF=ON THEN       /* WAS THIS AN INSTRUCTION FAIL  */
         TM    SDWAINSF(SDWAPTR),B'00000100'                       0211
         BNO   @RF00211                                            0211
*           DO;                                                    0212
*             IF SDWAREGU=OFF&SDWAPSWU=OFF THEN/* ARE BOTH PSW AND 0213
*                                      REGS UNPREDICTABLE            */
         TM    SDWAREGU(SDWAPTR),B'01100000'                       0213
         BNZ   @RF00213                                            0213
*               DO;                                                0214
*                 DO;               /* SETRP RECPARM(RECID)        0215
*                                      RETADDR(MCADDR) RECORD(YES) 0215
*                                      RC(SDWARETY)                  */
*                   RESPECIFY                                      0216
*                    (GPR00P,                                      0216
*                     GPR01P,                                      0216
*                     GPR14P,                                      0216
*                     GPR15P)RSTD;                                 0216
*                   GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA  */
         MVI   SDWARCDE(GPR01P),X'04'                              0217
*                   GPR01P->SDWARTYA=ADDR(MCADDR);/* SAVE RETRY    0218
*                                      ADDRESS                       */
         MVC   SDWARTYA(4,GPR01P),SDWANXT1(SDWAPTR)                0218
*                   GPR01P->SDWARCRD='1'B;/* TURN ON RECORD INDICATOR*/
         OI    SDWARCRD(GPR01P),B'10000000'                        0219
*                   GPR15P=ADDR(RECID);/* ACCESS RECORD PARAMETER  0220
*                                      LIST                          */
         LA    GPR15P,RECID                                        0220
*                   GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY   0221
*                                      RECORD PARAMETERS             */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0221
*                   RESPECIFY                                      0222
*                    (GPR00P,                                      0222
*                     GPR01P,                                      0222
*                     GPR14P,                                      0222
*                     GPR15P)UNRSTD;                               0222
*                 END;                                             0223
*                 MCAERROR=OFF;     /* RESET ERROR ROUTINE IN CONTROL
*                                      INDICATOR                     */
         NI    MCAERROR(AWSAPTR),B'11111011'                       0224
*                 RFY                                              0225
*                   RRTN RSTD;                                     0225
*                 RRTN=SVR14FRR;    /* RESTORE RTM RTN @             */
         L     @04,SVR14FRR(,FRRPTR)                               0226
         LR    RRTN,@04                                            0226
*                 GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);    0227
         BR RRTN RETURN TO CALLER
*                 RFY                                              0228
*                   RRTN UNRSTD;                                   0228
*               END;                                               0229
*             ELSE                                                 0230
*               ;                                                  0230
@RF00213 DS    0H                                                  0231
*           END;                                                   0231
*         ELSE                                                     0232
*           ;                                                      0232
@RF00211 DS    0H                                                  0233
*         CALL CATERR;              /* CALL CATERR ROUTINE           */
         BAL   @14,CATERR                                          0233
*       END;                                                       0234
*     ELSE                          /* NOT ACR ERROR                 */
*       IF SDWAPERC=ON THEN         /* CHECK TO SEE IF WE WERE     0235
*                                      PERCOLATED TO                 */
*                                                                  0235
         B     @RC00209                                            0235
@RF00209 TM    SDWAPERC(SDWAPTR),B'00010000'                       0235
         BNO   @RF00235                                            0235
*/********************************************************************/
*/*                                                                  */
*/*      IF THIS FRR WAS PERCOLATED TO --                            */
*/*           SEE IF A LOWER LEVEL HAS GIVEN SERVICEABILITY INFO.    */
*/*           IF ONE HAS NOT, GO TAKE A DUMP.                        */
*/*                IN EITHER CASE, SET RETURN CODE TO CONTINUE       */
*/*                WITH TERMINATION.                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0236
*         DO;                                                      0236
*           IF SDWAEAS=OFF THEN                                    0237
         TM    SDWAEAS(SDWAPTR),B'00001000'                        0237
         BNZ   @RF00237                                            0237
*             DO;                   /* HAS LOWER LEVEL GIVEN       0238
*                                      SERVICEABILITY INFO           */
*               R0=ADDR(SDUMPLST);  /* POINT TO SDUMP PLIST          */
         LA    R0,SDUMPLST                                         0239
*               CALL DUMPMOD;       /* NO -- TAKE A DUMP             */
         L     @15,PCTDMPMD(,PCTPTR)                               0240
         BALR  @14,@15                                             0240
*             END;                                                 0241
*           ELSE                                                   0242
*             ;                                                    0242
@RF00237 DS    0H                                                  0243
*           DO;                     /* SETRP RECPARM(RECID)        0243
*                                      RECORD(YES) RC(SDWACWT)       */
*             RESPECIFY                                            0244
*              (GPR00P,                                            0244
*               GPR01P,                                            0244
*               GPR14P,                                            0244
*               GPR15P)RSTD;                                       0244
*             GPR01P->SDWARCDE=SDWACWT;/* SAVE RC VALUE              */
         MVI   SDWARCDE(GPR01P),X'00'                              0245
*             GPR01P->SDWARCRD='1'B;/* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0246
*             GPR15P=ADDR(RECID);   /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0247
*             GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD  0248
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0248
*             RESPECIFY                                            0249
*              (GPR00P,                                            0249
*               GPR01P,                                            0249
*               GPR14P,                                            0249
*               GPR15P)UNRSTD;                                     0249
*           END;                                                   0250
*           RFY                                                    0251
*             RRTN RSTD;                                           0251
*           RRTN=SVR14FRR;          /* RESTORE RETURN ADDR           */
         L     RRTN,SVR14FRR(,FRRPTR)                              0252
*           GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);          0253
         BR RRTN RETURN TO CALLER
*           RFY                                                    0254
*             RRTN UNRSTD;                                         0254
*         END;                                                     0255
*       ELSE                                                       0256
*         IF GTFDEBUG=ON|SDWACLUP=ON THEN/* DOES USER WANT DUMP AND
*                                      TERMINATION OR WAS RESTART  0256
*                                      PRESSED OR IS THERE A DAT   0256
*                                      ERROR                         */
*                                                                  0256
         B     @RC00235                                            0256
@RF00235 TM    GTFDEBUG(PCTPTR),B'01000000'                        0256
         BO    @RT00256                                            0256
         TM    SDWACLUP(SDWAPTR),B'10000000'                       0256
         BNO   @RF00256                                            0256
@RT00256 DS    0H                                                  0257
*/********************************************************************/
*/*                                                                  */
*/*      IF USER SPECIFIED DEBUG=YES OR RESTART WAS PRESSED OR       */
*/*      THERE IS DYANMIC ADDRESS TRANSLATION ERROR --               */
*/*           SET RETURN CODE TO CONTINUE WITH TERMINATION.          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0257
*           DO;                                                    0257
*             R0=ADDR(SDUMPLST);    /* POINT TO SDUMP PLIST          */
         LA    R0,SDUMPLST                                         0258
*             CALL DUMPMOD;         /* CALL TO TAKE A DUMP           */
         L     @15,PCTDMPMD(,PCTPTR)                               0259
         BALR  @14,@15                                             0259
*             DUMPIND=R15RC;        /* STORE INDICATOR INTO SDUMP  0260
*                                      PLIST                         */
         STH   R15RC,DUMPIND(,AWSAPTR)                             0260
*             WTOPARM(1:LENGTH(WTOSKELT))=WTOSKELT;/* MOVE WTO PLIST
*                                      TO WORK AREA                  */
         MVC   WTOPARM(14,AWSAPTR),WTOSKELT                        0261
*             R1=ADDR(WTOPARM);     /* POINT TO IT                   */
         LA    R1,WTOPARM(,AWSAPTR)                                0262
*             CALL WTOMOD;          /* GO ISSUE ERROR MESSAGE        */
         L     @15,PCTWTOMD(,PCTPTR)                               0263
         BALR  @14,@15                                             0263
*             DO;                   /* SETRP RECPARM(RECID)        0264
*                                      RECORD(YES) RC(SDWACWT)       */
*               RESPECIFY                                          0265
*                (GPR00P,                                          0265
*                 GPR01P,                                          0265
*                 GPR14P,                                          0265
*                 GPR15P)RSTD;                                     0265
*               GPR01P->SDWARCDE=SDWACWT;/* SAVE RC VALUE            */
         MVI   SDWARCDE(GPR01P),X'00'                              0266
*               GPR01P->SDWARCRD='1'B;/* TURN ON RECORD INDICATOR    */
         OI    SDWARCRD(GPR01P),B'10000000'                        0267
*               GPR15P=ADDR(RECID); /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0268
*               GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0269
*               RESPECIFY                                          0270
*                (GPR00P,                                          0270
*                 GPR01P,                                          0270
*                 GPR14P,                                          0270
*                 GPR15P)UNRSTD;                                   0270
*             END;                                                 0271
*             RFY                                                  0272
*               RRTN RSTD;                                         0272
*             RRTN=SVR14FRR;        /* RESTORE RETURN ADDR           */
         L     RRTN,SVR14FRR(,FRRPTR)                              0273
*             GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);        0274
         BR RRTN RETURN TO CALLER
*             RFY                                                  0275
*               RRTN UNRSTD;                                       0275
*           END;                                                   0276
*         ELSE                      /* NOT DEBUG MODE SO CHECK MORE  */
*           IF MCATRL7=UNRECOV THEN                                0277
*                                                                  0277
         B     @RC00256                                            0277
@RF00256 CLI   MCATRL7(AWSAPTR),0                                  0277
         BNE   @RF00277                                            0277
*/********************************************************************/
*/*                                                                  */
*/*      IF ERROR IS UNRECOVERABLE--                                 */
*/*           CALL CATASTROPHIC ERROR PROCESSING ROUTINE             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0278
*UNRECERR:                          /* CHECK FOR UNRECOVERABLE ERROR */
*             CALL CATERR;          /* GO TO CATERR ROUTINE          */
UNRECERR BAL   @14,CATERR                                          0278
*           ELSE                    /* CHECK FOR RECURSION ERROR     */
*             DO;                                                  0279
*                                                                  0279
         B     @RC00277                                            0279
@RF00277 DS    0H                                                  0280
*/********************************************************************/
*/*                                                                  */
*/*      ERROR IS NONE OF THE ABOVE--                                */
*/*           IF THIS IS A RECURSIVE ERROR, AND THIS FRR HAS         */
*/*           BEEN ENTERED TOO MANY TIMES, CALL CATASTROPHIC         */
*/*           ERROR PRECOSSING ROUTINE.                              */
*/*                OTHERWISE, CONTINUE WITH RECOVERABLE              */
*/*                ERROR PROCESSING.                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0280
*               RECURCTR=RECURCTR+1;/* INCREMENT RECURSION COUNTER   */
         LA    @04,1                                               0280
         A     @04,RECURCTR(,FRRPTR)                               0280
         ST    @04,RECURCTR(,FRRPTR)                               0280
*               IF RECURCTR>=RECURLMT THEN/* TOO MANY ENTRIES?       */
         CH    @04,@CH01417                                        0281
         BL    @RF00281                                            0281
*                 CALL CATERR;      /* YES - GO TO CATERR ROUTINE    */
         BAL   @14,CATERR                                          0282
*               ELSE                /* NO - SET PROPER ERROR       0283
*                                      INDICATORS AND RECOVER        */
*                 DO;                                              0283
         B     @RC00281                                            0283
@RF00281 DS    0H                                                  0284
*                   RFY                                            0284
*                     RRTN RSTD;                                   0284
*                                                                  0284
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*      WHEN A RECOVERABLE ERROR OCCURS AND DEBUG=NO, THIS SECTION  */
*/*      OF CODE IS ENTERED. IT PERFORMS THE FOLLOWING PROCESSING--  */
*/*            --DETERMINES WHICH FIELDS WERE BEING GATHERED         */
*/*              WHEN THE ERROR OCCURRED                             */
*/*            --PUTS ASTERISKS INTO THOSE FIELDS                    */
*/*            --SETS THE RETRY ADDRESS TO THE APPROPRIATE SECTION   */
*/*              OF CODE TO CONTINUE GATHERING DATA FOR THE RECORD   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0285
*                   IF MCATRL7=FREXJ THEN/* GATHERING JOBNAME?       */
*                                                                  0285
         CLI   MCATRL7(AWSAPTR),8                                  0285
         BNE   @RF00285                                            0285
*/********************************************************************/
*/*                                                                  */
*/*      RECOVERABLE ERROR OCCURRED WHEN GATHERING JOBNAME--         */
*/*           SET JOBNAME FIELD TO ASTERISKS                         */
*/*           SET RETURN CODE TO RETRY AT 'AHLTEXJ'.                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0286
*                     DO;                                          0286
*                       EXTJBN=ERRIND;/* YES - SET IT TO ASTER.      */
         MVC   EXTJBN(8,AWSAPTR),@CC02684                          0287
*                       DO;         /* SETRP RECPARM(RECID)        0288
*                                      RETADDR(AHLTEXJ) RC(SDWARETY)
*                                      RECORD(YES)                   */
*                         RESPECIFY                                0289
*                          (GPR00P,                                0289
*                           GPR01P,                                0289
*                           GPR14P,                                0289
*                           GPR15P)RSTD;                           0289
*                         GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO
*                                      SDWA                          */
         MVI   SDWARCDE(GPR01P),X'04'                              0290
*                         GPR01P->SDWARTYA=ADDR(AHLTEXJ);/* SAVE   0291
*                                      RETRY ADDRESS                 */
         LA    @04,AHLTEXJ                                         0291
         ST    @04,SDWARTYA(,GPR01P)                               0291
*                         GPR01P->SDWARCRD='1'B;/* TURN ON RECORD  0292
*                                      INDICATOR                     */
         OI    SDWARCRD(GPR01P),B'10000000'                        0292
*                         GPR15P=ADDR(RECID);/* ACCESS RECORD      0293
*                                      PARAMETER LIST                */
         LA    GPR15P,RECID                                        0293
*                         GPR01P->SDWARECP=GPR15P->I256C(1:24);/*  0294
*                                      COPY RECORD PARAMETERS        */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0294
*                         RESPECIFY                                0295
*                          (GPR00P,                                0295
*                           GPR01P,                                0295
*                           GPR14P,                                0295
*                           GPR15P)UNRSTD;                         0295
*                       END;                                       0296
*                       MCAERROR=OFF;/* RESET MCATRAIL ERROR BIT     */
         NI    MCAERROR(AWSAPTR),B'11111011'                       0297
*                       RRTN=SVR14FRR;/* RESTORE RTM RETURN ADDRESS  */
         L     RRTN,SVR14FRR(,FRRPTR)                              0298
*                       GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);
         BR RRTN RETURN TO CALLER
*                     END;                                         0300
*                   ELSE                                           0301
*                     IF MCATRL7=FRECC THEN/* GATH CLOCK COMP SUF?   */
*                                                                  0301
         B     @RC00285                                            0301
@RF00285 CLI   MCATRL7(AWSAPTR),4                                  0301
         BNE   @RF00301                                            0301
*/********************************************************************/
*/*                                                                  */
*/*      RECOVERABLE ERROR OCCURRED WHEN GATHERING CLOCK COMP SUFFIX */
*/*           SET CLOCK COMP SUFFIX TO ASTERISKS.                    */
*/*           SET RETURN CODE TO RETRY AT 'AHLTECC'.                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0302
*                       DO;                                        0302
*                         EXTSUFCC=ERRIND;/* YES - SET SUFFIX TO ERR */
         MVC   EXTSUFCC(14,AWSAPTR),@CC02684                       0303
*                         DO;       /* SETRP RECPARM(RECID)        0304
*                                      RETADDR(AHLTECC) RC(SDWARETY)
*                                      RECORD(YES)                   */
*                           RESPECIFY                              0305
*                            (GPR00P,                              0305
*                             GPR01P,                              0305
*                             GPR14P,                              0305
*                             GPR15P)RSTD;                         0305
*                           GPR01P->SDWARCDE=SDWARETY;/* STORE RC  0306
*                                      INTO SDWA                     */
         MVI   SDWARCDE(GPR01P),X'04'                              0306
*                           GPR01P->SDWARTYA=ADDR(AHLTECC);/* SAVE 0307
*                                      RETRY ADDRESS                 */
         LA    @04,AHLTECC                                         0307
         ST    @04,SDWARTYA(,GPR01P)                               0307
*                           GPR01P->SDWARCRD='1'B;/* TURN ON RECORD
*                                      INDICATOR                     */
         OI    SDWARCRD(GPR01P),B'10000000'                        0308
*                           GPR15P=ADDR(RECID);/* ACCESS RECORD    0309
*                                      PARAMETER LIST                */
         LA    GPR15P,RECID                                        0309
*                           GPR01P->SDWARECP=GPR15P->I256C(1:24);/*
*                                      COPY RECORD PARAMETERS        */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0310
*                           RESPECIFY                              0311
*                            (GPR00P,                              0311
*                             GPR01P,                              0311
*                             GPR14P,                              0311
*                             GPR15P)UNRSTD;                       0311
*                         END;                                     0312
*                         MCAERROR=OFF;/* RESET MCATRAIL ERR BIT     */
         NI    MCAERROR(AWSAPTR),B'11111011'                       0313
*                         RRTN=SVR14FRR;/* RESTORE RTM RTN @         */
         L     RRTN,SVR14FRR(,FRRPTR)                              0314
*                         GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);
         BR RRTN RETURN TO CALLER
*                       END;                                       0316
*                     ELSE                                         0317
*                       IF MCATRL7=FRECT THEN/* GAT CPU TIMER SUF?   */
*                                                                  0317
         B     @RC00301                                            0317
@RF00301 CLI   MCATRL7(AWSAPTR),2                                  0317
         BNE   @RF00317                                            0317
*/********************************************************************/
*/*                                                                  */
*/*      RECOVERABLE ERROR OCCURRED WHEN GATHERING CPU TIMER  SUFFIX */
*/*           SET CPU TIMER SUFFIX TO ASTERISKS.                     */
*/*           SET RETURN CODE TO RETRY AT 'AHLTECT'.                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0318
*                         DO;                                      0318
*                           EXTSUFCT=ERRIND;/* SET SUFFIX TO ERROR   */
         MVC   EXTSUFCT(6,AWSAPTR),@CC02684                        0319
*                           DO;     /* SETRP RECPARM(RECID)        0320
*                                      RETADDR(AHLTECT) RC(SDWARETY)
*                                      RECORD(YES)                   */
*                             RESPECIFY                            0321
*                              (GPR00P,                            0321
*                               GPR01P,                            0321
*                               GPR14P,                            0321
*                               GPR15P)RSTD;                       0321
*                             GPR01P->SDWARCDE=SDWARETY;/* STORE RC
*                                      INTO SDWA                     */
         MVI   SDWARCDE(GPR01P),X'04'                              0322
*                             GPR01P->SDWARTYA=ADDR(AHLTECT);/* SAVE
*                                      RETRY ADDRESS                 */
         LA    @04,AHLTECT                                         0323
         ST    @04,SDWARTYA(,GPR01P)                               0323
*                             GPR01P->SDWARCRD='1'B;/* TURN ON RECORD
*                                      INDICATOR                     */
         OI    SDWARCRD(GPR01P),B'10000000'                        0324
*                             GPR15P=ADDR(RECID);/* ACCESS RECORD  0325
*                                      PARAMETER LIST                */
         LA    GPR15P,RECID                                        0325
*                             GPR01P->SDWARECP=GPR15P->I256C(1:24);/*
*                                      COPY RECORD PARAMETERS        */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0326
*                             RESPECIFY                            0327
*                              (GPR00P,                            0327
*                               GPR01P,                            0327
*                               GPR14P,                            0327
*                               GPR15P)UNRSTD;                     0327
*                           END;                                   0328
*                           MCAERROR=OFF;/* RESET ERR BIT            */
         NI    MCAERROR(AWSAPTR),B'11111011'                       0329
*                           RRTN=SVR14FRR;/* GET RTM RTN@            */
         L     RRTN,SVR14FRR(,FRRPTR)                              0330
*                           GEN SETS(RRTN)EXIT(BR RRTN RETN TO CALR);
         BR RRTN RETN TO CALR
*                         END;                                     0332
*                       ELSE                                       0333
*                         IF MCATRL7^=FRESP THEN/* GAT SIG P SUF?    */
*                                                                  0333
         B     @RC00317                                            0333
@RF00317 CLI   MCATRL7(AWSAPTR),1                                  0333
         BE    @RF00333                                            0333
*/********************************************************************/
*/*                                                                  */
*/*      MCATRL7 NOT CORRECT.                                        */
*/*           GO TO CATASTROPHIC ERROR PROCESSING.                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0334
*                           DO;                                    0334
*                             CALL CATERR;/* NO - GO TO CATER        */
         BAL   @14,CATERR                                          0335
*                           END;                                   0336
*                         ELSE                                     0337
*                                                                  0337
*/********************************************************************/
*/*                                                                  */
*/*      RECOVERABLE ERROR OCCURRED WHEN GATHERING SIG P SUFFIX      */
*/*           SET SIG P SUFFIX TO ASTERISKS.                         */
*/*           SET RETURN CODE TO RETRY AT 'AHLTESP'.                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0337
*                           EXTSUFSP=ERRIND;/* SET SIG P SUFF        */
         B     @RC00333                                            0337
@RF00333 MVC   EXTSUFSP(6,AWSAPTR),@CC02684                        0337
*                   DO;             /* SETRP RECPARM(RECID)        0338
*                                      RETADDR(AHLTESP) RC(SDWARETY)
*                                      RECORD(YES)                   */
@RC00333 DS    0H                                                  0338
@RC00317 DS    0H                                                  0338
@RC00301 DS    0H                                                  0338
@RC00285 DS    0H                                                  0339
*                     RESPECIFY                                    0339
*                      (GPR00P,                                    0339
*                       GPR01P,                                    0339
*                       GPR14P,                                    0339
*                       GPR15P)RSTD;                               0339
*                     GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA*/
         MVI   SDWARCDE(GPR01P),X'04'                              0340
*                     GPR01P->SDWARTYA=ADDR(AHLTESP);/* SAVE RETRY 0341
*                                      ADDRESS                       */
         LA    @04,AHLTESP                                         0341
         ST    @04,SDWARTYA(,GPR01P)                               0341
*                     GPR01P->SDWARCRD='1'B;/* TURN ON RECORD      0342
*                                      INDICATOR                     */
         OI    SDWARCRD(GPR01P),B'10000000'                        0342
*                     GPR15P=ADDR(RECID);/* ACCESS RECORD PARAMETER
*                                      LIST                          */
         LA    GPR15P,RECID                                        0343
*                     GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY 0344
*                                      RECORD PARAMETERS             */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0344
*                     RESPECIFY                                    0345
*                      (GPR00P,                                    0345
*                       GPR01P,                                    0345
*                       GPR14P,                                    0345
*                       GPR15P)UNRSTD;                             0345
*                   END;                                           0346
*                   MCAERROR=OFF;   /* RESET MCATRAIL ERROR BIT      */
         NI    MCAERROR(AWSAPTR),B'11111011'                       0347
*                   RRTN=SVR14FRR;  /* RESTORE RTN@                  */
         L     RRTN,SVR14FRR(,FRRPTR)                              0348
*                   GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALR);    0349
         BR RRTN RETURN TO CALR
*                   RFY                                            0350
*                     RRTN UNRSTD;                                 0350
*                 END;                                             0351
*             END;                                                 0352
@RC00281 DS    0H                                                  0353
*     RFY                                                          0353
*       RRTN RSTD;                  /* FREEZE REG FOR RETURN CODE    */
@RC00277 DS    0H                                                  0353
@RC00256 DS    0H                                                  0353
@RC00235 DS    0H                                                  0353
@RC00209 DS    0H                                                  0354
*     RRTN=SVR14FRR;                /* RESTORE RTM RETURN ADDRESS    */
         L     RRTN,SVR14FRR(,FRRPTR)                              0354
*     GEN SETS(RRTN)EXIT(BR RRTN  RETURN TO CALLER);               0355
         BR RRTN  RETURN TO CALLER
*     RFY                                                          0356
*       RRTN UNRSTD;                /* FREE REG USED FOR RETURN CODE */
*   END;                                                           0357
*                                                                  0357
*/*                                                                  */
*/*      CATASTROPHIC ERROR PROCESSING                               */
*/*                                                                  */
*                                                                  0358
*CATERR:                                                           0358
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0358
         B     @PB00002                                            0358
CATERR   DS    0H                                                  0359
*   RFY                                                            0359
*     RRTN RSTD;                    /* FREEZE REG                    */
*                                                                  0359
*/********************************************************************/
*/*                                                                  */
*/*     IF AN UNRECOVERABLE ERROR IS ENCOUNTERED AND DEBUG=NO,       */
*/*     THIS ROUTINE IS CALLED.  IT PERFORMS THE FOLLOWING           */
*/*     FUNCTIONS --                                                 */
*/*           -- SETS THE ASCB@ TO INDICATE ERROR CONDITION          */
*/*           -- ISSUE STACK MACRO TO PUT ERROR RECORD IN            */
*/*              GTF BUFFER                                          */
*/*           -- TURN OFF THE ACTIVE FUNCTION BIT FOR THE EVENT      */
*/*              BEING TRACED WHEN THE ERROR OCCURRED VIA SETEVENT   */
*/*           -- CALL THE DUMP ROUTINE FOR A DUMP                    */
*/*           -- ISSUE SETRP MACRO TO RETURN TO MCIH AND CWT WHEN    */
*/*              SOME TRACE FUNCTIONS STILL ACTIVE AND DELETE        */
*/*              THE FRR FROM THE LIST                               */
*/*           -- WHEN NO TRACE FUNCTIONS REMAIN, ISSUES SETRP MACRO  */
*/*              TO CWT                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0360
*   RFY                                                            0360
*     RRTN UNRSTD;                                                 0360
*   ERRASCB=CATERIND;               /* SET ERROR INDICATOR           */
         MVC   ERRASCB(2,AWSAPTR),@CB02687                         0361
*   DO;                             /* AHLSTACK DLENGTH(DEFLGTH)   0362
*                                      AID(EXTAIDC) FID(EXTFIDC)     */
*                                                                  0362
*     /***************************************************************/
*     /*                                                             */
*     /* THE FOLLOWING CODE IS GENERATED BY THE AHLSTACK MACRO. THIS */
*     /* CODE BUILDS THE GTF RECORD PREFIX AND THEN CALLS AHLSBLOK TO*/
*     /* STACK THE RECORD.                                           */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0363
*     RFY                                                          0363
*      (AHLRECPR,                                                  0363
*       AHLSBREG,                                                  0363
*       AHLRETCD)RSTD;                                             0363
*     IF OPTTIME='1'B THEN          /* CHECK FOR TIMESTAMP REQUESTED */
         TM    OPTTIME(PCTPTR),B'00000001'                         0364
         BNO   @RF00364                                            0364
*       DO;                         /* YES, TIMESTAMP                */
*         AHLRECPR=ADDR(MCARECPR);  /* SETUP ADDRESSIBILITY TO PREFIX
*                                      FOR PREFIX WITH TIMESTAMP     */
         LA    AHLRECPR,MCARECPR(,AWSAPTR)                         0366
*         AHLGLGTH=DEFLGTH+16;      /* SET LENGTH TO INCLUDE ***   0367
*                                      DLENGTH *** PLUS TIMESTAMP  0367
*                                      PREFIX                        */
         MVC   AHLGLGTH(2,AHLRECPR),@CH01539                       0367
*         GEN(STCK AHLGTST(AHLRECPR) PUT TOD CLOCK VALUE INTO PREFIX )
*         SETS(AHLGTST)NOEXIT SEQFLOW NOFLOWS;                     0368
         STCK AHLGTST(AHLRECPR) PUT TOD CLOCK VALUE INTO PREFIX
*         AHLGEIDL=MCAMCR->MCREID;  /* *** EID *** NOT SPECIFIED PUT
*                                      DEFAULT INTO PREFIX           */
         L     @04,MCAMCR(,AWSAPTR)                                0369
         MVC   AHLGEIDL(2,AHLRECPR),MCREID(@04)                    0369
*       END;                                                       0370
*     ELSE                          /* NO TIMESTAMP TO BE DONE, BUILD
*                                      SHORT PREFIX                  */
*       DO;                                                        0371
         B     @RC00364                                            0371
@RF00364 DS    0H                                                  0372
*         AHLRECPR=ADDR(MCARECPR)+8;/* SETUP ADDRESSIBILITY TO FOR 0372
*                                      SHORT PREFIX WITHOUT TIMESTAMP*/
         LA    AHLRECPR,MCARECPR(,AWSAPTR)                         0372
         AH    AHLRECPR,@CH00058                                   0372
*         AHLGLGTH=DEFLGTH+8;       /* PUT TOTAL RECORD LENGTH INTO
*                                      PREFIX *** DLENGTH *** PLUS 0373
*                                      PREFIX LENGTH                 */
         MVC   AHLGLGTH(2,AHLRECPR),@CH01064                       0373
*         AHLGEIDS=MCAMCR->MCREID;  /* *** EID *** NOT SPECIFIED PUT
*                                      DEFAULT INTO PREFIX           */
         L     @04,MCAMCR(,AWSAPTR)                                0374
         MVC   AHLGEIDS(2,AHLRECPR),MCREID(@04)                    0374
*       END;                                                       0375
*     AHLGRES=0;                    /* ZERO OUT FOR QSAM           0376
*                                      COMPATIBILITY                 */
@RC00364 SR    @04,@04                                             0376
         STH   @04,AHLGRES(,AHLRECPR)                              0376
*     AHLGAID=EXTAIDC;              /* PUT *** AID *** INTO PREFIX   */
         MVI   AHLGAID(AHLRECPR),X'FF'                             0377
*     AHLGFID=EXTFIDC;              /* PUT *** FID *** INTO PREFIX   */
         MVI   AHLGFID(AHLRECPR),X'05'                             0378
*     AHLRETCD=4;                   /* SET DEFAULT RETURN CODE       */
         LA    AHLRETCD,4                                          0379
*     AHLSBREG=SBLOKRTN;            /* GET A STABLE COPY OF AHLSBLOK
*                                      ADDR                          */
         L     AHLSBREG,SBLOKRTN(,PCTPTR)                          0380
*     IF AHLSBREG^=0 THEN           /* CHECK TO SEE IF AHLSBLOK IS 0381
*                                      AVAILABLE                     */
         CR    AHLSBREG,@04                                        0381
         BE    @RF00381                                            0381
*       CALL AHLSBLOK;              /* YES, SO CALL AHLSBLOK TO BLOCK
*                                      RECORD                        */
         LR    @15,AHLSBREG                                        0382
         BALR  @14,@15                                             0382
*     RFY                                                          0383
*      (AHLRECPR,                                                  0383
*       AHLSBREG,                                                  0383
*       AHLRETCD)UNRSTD;                                           0383
@RF00381 DS    0H                                                  0384
*   END;                                                           0384
*   R1=SVREG1;                      /* RESTORE REGISTER 1            */
*                                                                  0385
         L     R1,SVREG1(,AWSAPTR)                                 0385
*   /*****************************************************************/
*   /*                                                               */
*   /* TAKE A DUMP AND SET UP FOR WTO                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0386
*   R0=ADDR(SDUMPLST);              /* POINT TO SVCDUMP PLIST        */
         LA    R0,SDUMPLST                                         0386
*   ENDAD=ADDR(@ENDDATA);           /* FILL IN THE LAST ADDRESS      */
         LA    @04,@ENDDATA                                        0387
         STCM  @04,7,ENDAD                                         0387
*   CALL DUMPMOD;                   /* GO TAKE DUMP                  */
         L     @15,PCTDMPMD(,PCTPTR)                               0388
         BALR  @14,@15                                             0388
*   DUMPIND=R15RC;                  /* SAVE INDICATOR                */
         STH   R15RC,DUMPIND(,AWSAPTR)                             0389
*   WTOPARM(1:LENGTH(WTOSKELT))=WTOSKELT;/* MOVE REST OF PLIST TO  0390
*                                      WORKAREA                      */
         MVC   WTOPARM(14,AWSAPTR),WTOSKELT                        0390
*   R0=MCROUTSA(1:4);               /* RESTORE REGISTER 0            */
*                                                                  0391
         L     @04,MCAMCR(,AWSAPTR)                                0391
         L     R0,MCROUTSA(,@04)                                   0391
*/********************************************************************/
*/*                                                                  */
*/*      DETERMINE WHICH FUNCTION IS ACTIVE AND TURN 'OFF' ITS       */
*/*      INDICATOR IN THE PCTCATF FIELD                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0392
*   RFY                                                            0392
*    (R11WORK,                                                     0392
*     R10WORK)RSTD;                 /* FREEZE REGS FOR C&S           */
*CKBIT:                                                            0393
*   R11WORK=TRAILSAV;               /* GET TRAIL BIT INDICATING    0393
*                                      GATHER ROUTINE IN CONTROL     */
CKBIT    L     R11WORK,TRAILSAV(,FRRPTR)                           0393
*   R10WORK=PCTCATF;                /* GET INDICATOR FOR CURRENT   0394
*                                      TRACE FUNCTIONS               */
         L     R10WORK,PCTCATF(,PCTPTR)                            0394
*   IF(R10WORK&R11WORK)^=0 THEN     /* CHECK TO SEE IF GATHER      0395
*                                      FUNCTIONS CURRENT BIT IS ON   */
         LR    @04,R10WORK                                         0395
         NR    @04,R11WORK                                         0395
         LTR   @04,@04                                             0395
         BZ    @RF00395                                            0395
*     DO;                                                          0396
*                                                                  0396
*/********************************************************************/
*/*                                                                  */
*/*      GATHER FUNCTIONS CURRENT BIT IS ON--                        */
*/*           WHEN OK, ISSUE WTO                                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0397
*       R11WORK=R11WORK&&R10WORK;   /* TURN OFF CURRENT TO PREPARE 0397
*                                      FOR C&S                       */
         XR    R11WORK,R10WORK                                     0397
*       CS(R10WORK,R11WORK,PCTCATF);/* CHECK FOR SAME STATUS         */
         CS    R10WORK,R11WORK,PCTCATF(PCTPTR)                     0398
*       BC(4,CKBIT);                /* IF CHANGED, START OVER AGAIN  */
         BC    4,CKBIT                                             0399
*       R1=ADDR(WTOPARM);           /* POINT TO WTO PLIST            */
         LA    R1,WTOPARM(,AWSAPTR)                                0400
*       CALL WTOMOD;                /* GO ISSUE ERROR MESSAGE        */
         L     @15,PCTWTOMD(,PCTPTR)                               0401
         BALR  @14,@15                                             0401
*       RFY                                                        0402
*        (R11WORK,                                                 0402
*         R10WORK)UNRSTD;           /* FREE REGS                     */
*                                                                  0402
*/*                                                                  */
*/*      ISSUE SETEVENT MACRO TO DISABLE TRACING OF THIS FUNCTION    */
*/*                                                                  */
*                                                                  0403
*       DO;                         /* SETEVENT NAME('GTF')        0403
*                                      MCQE(MCQE) ACTION(DISABLE)  0403
*                                      EIDAD(MCREID)               0403
*                                      MF(E,DMPPARMS,COMPLETE)     0403
*                                      EIDNO(1)                      */
*                                                                  0403
*         /***********************************************************/
*         /*                                                         */
*         /* THE FOLLOWING SECTION OF CODE IS GENERATED BY THE       */
*         /* SETEVENT MACRO. THIS CODE WILL BE EITHER AN INITIALIZED */
*         /* PARAMETER LIST, OR IF IT IS THE RESULT OF STANDARD OR   */
*         /* EXECUTE FORM IT WILL FILL in the list, GENERATE ALL     */
*         /* LINKAGES AND CALL THE PROPER sERVICE, EITHER AHLSETEV OR*/
*         /* AHLSETD                                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0404
*         DCL                                                      0404
*           AHLPPTR REG(1)PTR(31)RSTD;/* PARAMETER LIST ADDRESS      */
*         DCL                                                      0405
*           AHLSETEV ENTRY OPTIONS(EXIT,SEQFLOW)BASED(MCHSETE)VALRG(0);
*                                   /* ENTRY FOR ADD ACTIVAT,FREE    */
*         DCL                                                      0406
*           AHLSETD ENTRY OPTIONS(EXIT,SEQFLOW)BASED(MCHSETD)VALRG(0);
*                                   /* ENTRY FOR DISABLE AND CHANGE  */
*         DCL                                                      0407
*           1 SEPL BASED(AHLPPTR)BDY(WORD),/* DSECT PARAMETER LIST   */
*            2 SEFG PTR(8),         /* ACTION GLAGS                  */
*            2 * PTR(8),                                           0407
*            2 SEEN PTR(8),         /* EID COUNT                     */
*            2 SECN PTR(8),         /* CLASS COUNT                   */
*            2 SENM CHAR(8),        /* APPLICATION NMAE              */
*            2 SEEL PTR(31),        /* ADDRESS OF LIST OF EIDS       */
*            2 SECL PTR(31),        /* ADDRESS OF LIST OF CLASSES    */
*            2 SEMC PTR(31);        /* MCQE ADDRESS                  */
*         AHLPPTR=ADDR(DMPPARMS);   /* SET UP PLIST PTR              */
         LA    AHLPPTR,DMPPARMS(,AWSAPTR)                          0408
*         SEPL=SEPL&&SEPL;          /* INIT PLIST TO ZERO            */
         XC    SEPL(24,AHLPPTR),SEPL(AHLPPTR)                      0409
*         SEMC=ADDR(MCQE);          /* SET UP MCQE ADDRESS           */
         ST    R0,SEMC(,AHLPPTR)                                   0410
*         SENM='GTF';               /* MOVE NAME INTO PLIST          */
         MVI   SENM+3(AHLPPTR),C' '                                0411
         MVC   SENM+4(4,AHLPPTR),SENM+3(AHLPPTR)                   0411
         MVC   SENM(3,AHLPPTR),@CC02827                            0411
*         SEFG=32;                  /* MOVE FLAGS INTO PLIST         */
         MVI   SEFG(AHLPPTR),X'20'                                 0412
*         SEEN=1;                   /* SET TO VALUE SPECIFIED        */
         MVI   SEEN(AHLPPTR),X'01'                                 0413
*         SEEL=ADDR(MCREID);        /* SET TO VALUE SPECIFIED        */
         L     @04,MCAMCR(,AWSAPTR)                                0414
         LA    @04,MCREID(,@04)                                    0414
         ST    @04,SEEL(,AHLPPTR)                                  0414
*         IF SEFG=32|SEFG=8 THEN    /* CHECK FOR DISABLE OR * CHANGE */
         CLI   SEFG(AHLPPTR),32                                    0415
         BE    @RT00415                                            0415
         CLI   SEFG(AHLPPTR),8                                     0415
         BNE   @RF00415                                            0415
@RT00415 DS    0H                                                  0416
*           CALL AHLSETD;           /* YES                           */
         L     @04,CVTPTR                                          0416
         L     @04,CVTGTF(,@04)                                    0416
         L     @15,MCHSETD(,@04)                                   0416
         BALR  @14,@15                                             0416
*         ELSE                      /* NO                            */
*           CALL AHLSETEV;                                         0417
         B     @RC00415                                            0417
@RF00415 L     @04,CVTPTR                                          0417
         L     @04,CVTGTF(,@04)                                    0417
         L     @15,MCHSETE(,@04)                                   0417
         BALR  @14,@15                                             0417
*       END;                                                       0418
@RC00415 DS    0H                                                  0419
*       R1=SVREG1;                  /* RESTORE REGISTER 1            */
         L     R1,SVREG1(,AWSAPTR)                                 0419
*       R0=MCROUTSA(1:4);           /* RESTORE REGISTER 0            */
         L     @04,MCAMCR(,AWSAPTR)                                0420
         L     R0,MCROUTSA(,@04)                                   0420
*     END;                                                         0421
*   IF PCTCATF=0 THEN               /* CHECK TO SEE IF ALL FUNCTIONS
*                                      ARE DISABLED                  */
*                                                                  0422
@RF00395 ICM   @04,15,PCTCATF(PCTPTR)                              0422
         BNZ   @RF00422                                            0422
*/********************************************************************/
*/*                                                                  */
*/*      IF ALL GTF FUNCTIONS HAVE BEEN DISABLED--                   */
*/*           SET RETURN CODE TO CONTINUE WITH TERMINATION.          */
*/*                OTHERWISE, SET RETURN CODE TO RETRY AT THE        */
*/*                ADDRESS IN REG 14 WHEN AHLTEXT FIRST ENTERED      */
*/*                AND DELETE THIS FRR ADDRESS FROM THE STACK.       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0423
*     DO;                                                          0423
*       DO;                         /* SETRP RECPARM(RECID)        0424
*                                      RECORD(YES) RC(SDWACWT)       */
*         RESPECIFY                                                0425
*          (GPR00P,                                                0425
*           GPR01P,                                                0425
*           GPR14P,                                                0425
*           GPR15P)RSTD;                                           0425
*         GPR01P->SDWARCDE=SDWACWT; /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0426
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0427
*         GPR15P=ADDR(RECID);       /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0428
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0429
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0429
*         RESPECIFY                                                0430
*          (GPR00P,                                                0430
*           GPR01P,                                                0430
*           GPR14P,                                                0430
*           GPR15P)UNRSTD;                                         0430
*       END;                                                       0431
*       RFY                                                        0432
*         RRTN RSTD;                                               0432
*       RRTN=SVR14FRR;              /* RESTORE RETURN ADDRESS        */
         L     RRTN,SVR14FRR(,FRRPTR)                              0433
*       GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);              0434
         BR RRTN RETURN TO CALLER
*       RFY                                                        0435
*         RRTN UNRSTD;                                             0435
*     END;                                                         0436
*   ELSE                                                           0437
*     DO;                           /* SETRP RECPARM(RECID)        0437
*                                      RETADDR(RETSVR14) RECORD(YES)
*                                      RC(SDWARETY)                  */
         B     @RC00422                                            0437
@RF00422 DS    0H                                                  0438
*       RESPECIFY                                                  0438
*        (GPR00P,                                                  0438
*         GPR01P,                                                  0438
*         GPR14P,                                                  0438
*         GPR15P)RSTD;                                             0438
*       GPR01P->SDWARCDE=SDWARETY;  /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0439
*       GPR01P->SDWARTYA=ADDR(RETSVR14);/* SAVE RETRY ADDRESS        */
         MVC   SDWARTYA(4,GPR01P),SVR14NRM(FRRPTR)                 0440
*       GPR01P->SDWARCRD='1'B;      /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0441
*       GPR15P=ADDR(RECID);         /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0442
*       GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD        0443
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0443
*       RESPECIFY                                                  0444
*        (GPR00P,                                                  0444
*         GPR01P,                                                  0444
*         GPR14P,                                                  0444
*         GPR15P)UNRSTD;                                           0444
*     END;                                                         0445
*   RFY                                                            0446
*     RRTN RSTD;                                                   0446
@RC00422 DS    0H                                                  0447
*   RRTN=SVR14FRR;                  /* RESTORE RETURN ADDRESS        */
         L     RRTN,SVR14FRR(,FRRPTR)                              0447
*   GEN SETS(FRRPTR,R10WORK)NOEXIT SEQFLOW NOFLOWS;                0448
         SETFRR D,WRKREGS=(FRRPTR,R10WORK)
*   GEN SETS(RRTN)EXIT(BR RRTN RETURN TO CALLER);                  0449
         BR RRTN RETURN TO CALLER
*   RFY                                                            0450
*     RRTN UNRSTD;                                                 0450
*   END;                            /* END CATERR                    */
@EL00002 DS    0H                                                  0451
@EF00002 DS    0H                                                  0451
@ER00002 BR    @14                                                 0451
@PB00002 DS    0H                                                  0451
*AHLTEXTN:                                                         0452
*   END AHLTEXT                                                    0452
*                                                                  0452
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (EXTPRO  )                                       */
*/*%INCLUDE SYSUT5  (EXTDCL  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (GTFPCT  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHATQE  )                                       */
*/*%INCLUDE SYSLIB  (MCAWSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (MCHEAD  )                                       */
*/*%INCLUDE SYSLIB  (MCRWSA  )                                       */
*/*%INCLUDE SYSLIB  (MCQE    )                                       */
*/*%INCLUDE SYSUT5  (EXTMAIN )                                       */
*/*%INCLUDE SYSUT5  (EXTFRR  )                                       */
*/*%INCLUDE SYSUT5  (EXTCAT  )                                       */
*                                                                  0452
*       ;                                                          0452
AHLTEXTN DS    0H                                                  0452
@DATA    DS    0H
@CH01417 DC    H'5'
@CH00058 DC    H'8'
@CH01064 DC    H'48'
@CH01539 DC    H'56'
@DATD    DSECT
         DS    0F
AHLTEXT  CSECT
         DS    0F
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
AHLTEXT  CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
EXTEBASE DC    AL4(AHLTEXT)
@CC02695 DC    C'U/'
@CC02827 DC    C'GTF'
@CC02680 DC    C'N/A     '
@CC02682 DC    C'U/A     '
@CC02684 DC    C'**************'
@CB02687 DC    X'EEEE'
@CB02701 DC    X'1004'
@CB02703 DC    X'1005'
@CB02691 DC    X'4000000000000000'
RECID    DC    CL24'AHLTEXT AHLTEXT AHLTEXTE'
         DS    CL3
SDMPLST  DS    CL8
         ORG   SDMPLST
STORSTRT DC    AL4(AHLTEXT)
STOREND  DS    AL4
         ORG   STOREND
LISTEND  DC    X'80'
STORENDA DC    AL3(AHLTEXTN)
         ORG   SDMPLST+8
SDUMPLST DS    CL12
         ORG   SDUMPLST
@NM00101 DC    AL4(SDUMPHDR)
@NM00102 DC    AL4(AHLTEXT)
@NM00103 DC    XL1'80'
ENDAD    DC    AL3(@ENDDATA)
         ORG   SDUMPLST+12
SDUMPHDR DS    CL28
         ORG   SDUMPHDR
@NM00104 DC    AL1(27)
HDRDATA  DC    CL27'DUMP OF GTF MODULE AHLTEXT'
         ORG   SDUMPHDR+28
WTOSKELT DC    CL14'EXT EXT   TRAC'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PCTPTR   EQU   @02
ASCBPTR  EQU   @04
LCCAPTR  EQU   @06
PCCAPTR  EQU   @07
SDWAPTR  EQU   @01
TCBPTR   EQU   @07
TQEPTR   EQU   @04
AWSAPTR  EQU   @03
GPR00P   EQU   @00
R0       EQU   @00
GPR01P   EQU   @01
R1       EQU   @01
SDMPPTR  EQU   @04
FRRPTR   EQU   @05
RECSIZE  EQU   @09
R9WORK   EQU   @09
R10WORK  EQU   @10
R11WORK  EQU   @11
RBASE    EQU   @12
FRREADDR EQU   @13
GPR14P   EQU   @14
RRTN     EQU   @14
R15RC    EQU   @15
GPR15P   EQU   @15
AHLRECPR EQU   @01
AHLSBREG EQU   @14
AHLRETCD EQU   @15
AHLPPTR  EQU   @01
R15ENTRY EQU   @15
R6WORK   EQU   @06
R7WORK   EQU   @07
         ENTRY AHLTEXTE
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
FLCEOPSW EQU   PSA+24
PSAEEPSW EQU   PSA+132
FLCEICOD EQU   PSAEEPSW+2
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAPCCAV EQU   PSA+520
PSALCCAV EQU   PSA+528
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSACPUSA EQU   PSA+794
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
SIGPARM  EQU   128
SIGPROC  EQU   132
ADDRPARM EQU   128
ADDRPROC EQU   132
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
GTFPCT   EQU   0
GTFSTAT  EQU   GTFPCT+8
GTFDEBUG EQU   GTFSTAT
GTFOPTS  EQU   GTFPCT+12
GTFOPTS1 EQU   GTFOPTS
OPTTRC   EQU   GTFOPTS1
GTFOPTS2 EQU   GTFOPTS+1
GTFOPTS3 EQU   GTFOPTS+2
GTFOPTS4 EQU   GTFOPTS+3
OPTTIME  EQU   GTFOPTS4
PCTCATF  EQU   GTFPCT+16
NEXTBLOK EQU   GTFPCT+180
SBLOKRTN EQU   GTFPCT+188
WRTRCOM  EQU   GTFPCT+204
TRMWRIT  EQU   GTFPCT+212
WRTRERR  EQU   GTFPCT+216
GTFSSRB  EQU   GTFPCT+220
QLOCKWRD EQU   GTFPCT+236
QLOCKECB EQU   GTFPCT+240
AUDITFLG EQU   GTFPCT+296
GTFASCB  EQU   GTFPCT+300
PCTDMPMD EQU   GTFPCT+308
PCTWTOMD EQU   GTFPCT+312
ASCB     EQU   0
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBJBNI EQU   ASCB+172
ASCBJBNS EQU   ASCB+176
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSPTR  EQU   0
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
FRREPTR  EQU   0
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCACPUS EQU   LCCA+536
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASRBM EQU   LCCADSF2
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
PCCA     EQU   0
PCCATQEP EQU   PCCA+20
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWAREGU EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAMCHK EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAPERC EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWACLUP EQU   SDWAERRD
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
TQE      EQU   0
TQEFLGS  EQU   TQE+14
TQEFLGS2 EQU   TQE+15
TQEVAL   EQU   TQE+16
TQEEXIT  EQU   TQE+28
TQETCB   EQU   TQE+32
TQEASCB  EQU   TQE+36
MCAWSA   EQU   0
MCATRAIL EQU   MCAWSA+256
MCATRL1  EQU   MCATRAIL
MCATRL2  EQU   MCATRAIL+1
MCAERROR EQU   MCATRL2
MCATRL3  EQU   MCATRAIL+2
MCATRL4  EQU   MCATRAIL+3
MCATRL5  EQU   MCATRAIL+4
MCATRL6  EQU   MCATRAIL+5
MCATRL7  EQU   MCATRAIL+6
MCAMCR   EQU   MCAWSA+264
MCARECPR EQU   MCAWSA+268
MCAREC   EQU   MCAWSA+284
MCAWORK  EQU   MCAWSA+584
WSAC     EQU   0
WSACGTF  EQU   WSAC+4
MCHEAD   EQU   0
MCHFLGS  EQU   MCHEAD+24
MCHFLG1  EQU   MCHFLGS
MCHSETE  EQU   MCHEAD+28
MCHSETD  EQU   MCHEAD+32
MCRWSA   EQU   0
MCROUTSA EQU   MCRWSA+64
MCRMCA   EQU   MCRWSA+128
MCRWSAF  EQU   MCRWSA+132
MCRBRENT EQU   MCRWSAF
MCREID   EQU   MCRWSA+134
MCQE     EQU   0
MCQEAT   EQU   MCQE+32
MCQEFLGS EQU   MCQE+41
SRB      EQU   0
FRRPARM  EQU   0
RECURCTR EQU   FRRPARM
TRAILSAV EQU   FRRPARM+4
SVR14NRM EQU   FRRPARM+8
SVR14FRR EQU   FRRPARM+12
SDMPBUF  EQU   0
JOBNAME  EQU   0
JBNMTEST EQU   JOBNAME
RETSVR14 EQU   0
MCADDR   EQU   0
DUMPMOD  EQU   0
WTOMOD   EQU   0
I256C    EQU   0
AHLGREC  EQU   0
AHLGLGTH EQU   AHLGREC
AHLGRES  EQU   AHLGREC+2
AHLGAID  EQU   AHLGREC+4
AHLGFID  EQU   AHLGREC+5
AHLGTST  EQU   AHLGREC+6
AHLGEIDS EQU   AHLGTST
AHLGEIDL EQU   AHLGREC+14
AHLSBLOK EQU   0
AHLSETEV EQU   0
AHLSETD  EQU   0
SEPL     EQU   0
SEFG     EQU   SEPL
SEEN     EQU   SEPL+2
SENM     EQU   SEPL+4
SEEL     EQU   SEPL+12
SEMC     EQU   SEPL+20
ACRADDR  EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
RECOVRTN EQU   0
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSDBF  EQU   CVTS01+240
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
WORKAREA EQU   MCAWORK
DMPPARMS EQU   WORKAREA
SVREG0   EQU   WORKAREA+52
SVREG1   EQU   WORKAREA+56
EXTREC   EQU   MCAREC
EXTPREF  EQU   EXTREC
EXTASCB  EQU   EXTPREF
EXTCPUID EQU   EXTPREF+4
EXTJBN   EQU   EXTPREF+6
EXTOPSW  EQU   EXTPREF+14
EXTOPIT  EQU   EXTOPSW+2
EXTITTCB EQU   EXTPREF+22
EXTSUF   EQU   EXTREC+26
EXTSUFCC EQU   EXTSUF
EXTCFLGS EQU   EXTSUFCC
EXTCQFL  EQU   EXTCFLGS
EXTCQFL2 EQU   EXTCFLGS+1
EXTCEXIT EQU   EXTSUFCC+2
EXTCASCB EQU   EXTSUFCC+6
EXTCTCB  EQU   EXTSUFCC+10
EXTSUFCT EQU   EXTSUF
EXTTFLGS EQU   EXTSUFCT
EXTTQFL  EQU   EXTTFLGS
EXTTQFL2 EQU   EXTTFLGS+1
EXTTEXIT EQU   EXTSUFCT+2
EXTSUFSP EQU   EXTSUF
EXTSPARM EQU   EXTSUFSP
EXTSPROC EQU   EXTSUFSP+4
POPSW    EQU   FLCEOPSW
PSWADDR  EQU   POPSW+4
ERRASCB  EQU   MCAREC
INTTYPE  EQU   FLCEICOD
WTOPARM  EQU   MCAWORK
DUMPIND  EQU   WTOPARM+14
CLEARPRM EQU   MCAWORK
FLC      EQU   PSA
SDMPBIT  EQU   CVTSDBF
TQEECB   EQU   TQEEXIT
*                                      START UNREFERENCED COMPONENTS
WTOFNCT  EQU   WTOPARM+8
WTOOPT   EQU   WTOPARM+4
WTONAME  EQU   WTOPARM
POPSWIT  EQU   POPSW+2
KEYCMWP  EQU   POPSW+1
@NM00100 EQU   POPSW
@NM00099 EQU   EXTOPSW+4
@NM00098 EQU   EXTOPSW
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTWSAG  EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTSYSWT EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
SECL     EQU   SEPL+16
SECN     EQU   SEPL+3
@NM00105 EQU   SEPL+1
ZEROLGTH EQU   SDMPBUF+1470
ZEROADD  EQU   SDMPBUF+1466
RTCDMP   EQU   SDMPBUF+954
RTCLGTH  EQU   SDMPBUF+952
RTCADD   EQU   SDMPBUF+948
MCADMP   EQU   SDMPBUF+148
MCALGTH  EQU   SDMPBUF+146
MCAADD   EQU   SDMPBUF+142
MCRDMP   EQU   SDMPBUF+6
MCRLGTH  EQU   SDMPBUF+4
MCRADD   EQU   SDMPBUF
SVR14CAL EQU   FRRPARM+16
MCQESRB  EQU   MCQE+44
@NM00097 EQU   MCQE+42
@NM00096 EQU   MCQEFLGS
MCQEACT  EQU   MCQEFLGS
MCQESCHE EQU   MCQE+40
MCQETECB EQU   MCQE+36
MCQEMCCL EQU   MCQE+28
MCQEMCEE EQU   MCQE+24
MCQEMCQE EQU   MCQE+20
MCQEASCB EQU   MCQE+16
MCQENAME EQU   MCQE+8
MCQEIDEN EQU   MCQE
MCRRESV  EQU   MCRWSAF
MCERROR  EQU   MCRWSAF
MCINFGBR EQU   MCRWSAF
MCINCTL  EQU   MCRWSAF
MCRMCIH  EQU   MCRWSA
MCHEADTR EQU   MCHEAD+48
MCHEADRD EQU   MCHEAD+44
MCHFRRAD EQU   MCHEAD+40
MCHMCER  EQU   MCHEAD+36
@NM00095 EQU   MCHFLGS+1
@NM00094 EQU   MCHFLG1
MCHTERM  EQU   MCHFLG1
MCHACT   EQU   MCHFLG1
MCHDIS   EQU   MCHEAD+20
MCHCTL   EQU   MCHEAD+16
MCHCNT   EQU   MCHEAD+12
MCHCUR   EQU   MCHEAD+8
MCHIDEN  EQU   MCHEAD
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACACR  EQU   WSAC+16
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACCWSA EQU   WSAC
MCASWORK EQU   MCAWSA+644
MCATRL8  EQU   MCATRAIL+7
MCAFRECT EQU   MCATRL7
MCAFRECC EQU   MCATRL7
MCAFRESP EQU   MCATRL7
MCAFREXJ EQU   MCATRL7
MCAFRSBR EQU   MCATRL6
MCAFRDMJ EQU   MCATRL6
MCAFRDPC EQU   MCATRL6
MCAFRPIC EQU   MCATRL6
MCAFRPIJ EQU   MCATRL6
@NM00093 EQU   MCATRL5
MCADREGS EQU   MCATRL5
MCAFRRB  EQU   MCATRL5
MCAFRRJ  EQU   MCATRL5
MCAFRRA  EQU   MCATRL5
MCAFRERT EQU   MCATRL5
MCAFREPC EQU   MCATRL5
MCAMJOBN EQU   MCATRL4
MCAMSDWA EQU   MCATRL4
MCAMBTU  EQU   MCATRL4
MCAMIOSB EQU   MCATRL4
MCAMTCB  EQU   MCATRL4
MCAMASCB EQU   MCATRL4
MCAMUCB  EQU   MCATRL4
MCAMEXT  EQU   MCATRL4
MCAFRFRT EQU   MCATRL3
MCAFRFA  EQU   MCATRL3
MCAFRSJ  EQU   MCATRL3
MCAFRSA  EQU   MCATRL3
MCAPIF   EQU   MCATRL3
MCASIOF  EQU   MCATRL3
MCAIOF   EQU   MCATRL3
MCASVCF  EQU   MCATRL3
MCATDIR  EQU   MCATRL2
MCALSR   EQU   MCATRL2
MCAUIO   EQU   MCATRL2
MCASTA   EQU   MCATRL2
MCAFRR   EQU   MCATRL2
MCASRM   EQU   MCATRL2
MCARNIO  EQU   MCATRL2
MCAUSR   EQU   MCATRL1
MCAPI    EQU   MCATRL1
MCASRB   EQU   MCATRL1
MCADSP   EQU   MCATRL1
MCASIO   EQU   MCATRL1
MCAIO    EQU   MCATRL1
MCAEXT   EQU   MCATRL1
MCASVC   EQU   MCATRL1
MCAMSG   EQU   MCAWSA+192
MCASETEV EQU   MCAWSA+128
MCAFWORK EQU   MCAWSA+112
MCASFEOB EQU   MCAWSA+56
MCASBLOK EQU   MCAWSA
@NM00092 EQU   TQE+88
TQESRB   EQU   TQE+44
TQELHPSW EQU   TQE+40
TQESADDR EQU   TQE+24
TQEVALRH EQU   TQEVAL+4
TQEVALLH EQU   TQEVAL
TQEMIDN  EQU   TQEFLGS2
TQEMF1   EQU   TQEFLGS2
TQEOPT   EQU   TQEFLGS2
TQELM    EQU   TQEFLGS2
TQEDUM   EQU   TQEFLGS2
@NM00091 EQU   TQEFLGS2
TQEUSER  EQU   TQEFLGS2
TQECOMP  EQU   TQEFLGS2
TQETYPE  EQU   TQEFLGS
TQEXITSP EQU   TQEFLGS
TQEINCOM EQU   TQEFLGS
TQEWLIM  EQU   TQEFLGS
@NM00090 EQU   TQEFLGS
TQETOD   EQU   TQEFLGS
TQEOFF   EQU   TQEFLGS
TQEAID   EQU   TQE+12
TQEBLNK  EQU   TQE+8
TQEFLNK  EQU   TQE+4
TQETQE   EQU   TQE
@NM00089 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBRSV48 EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00088 EQU   TCB+296
TCBRV185 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBRSV36 EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBRSV35 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00087 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBRSV04 EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00086 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
@NM00085 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00084 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00083 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00082 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00081 EQU   SDWADDAT+3
@NM00080 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00079 EQU   SDWADDAT+1
@NM00078 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00077 EQU   SDWADUMP+2
@NM00076 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00075 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00074 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00073 EQU   SDWAACF3
@NM00072 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00071 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00070 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00069 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00068 EQU   SDWA+239
@NM00067 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00066 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
@NM00065 EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00064 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00063 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00062 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00061 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00060 EQU   SDWAINC2
@NM00059 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00058 EQU   SDWAILC2
@NM00057 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00056 EQU   SDWANXT2
@NM00055 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00054 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00053 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00052 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00051 EQU   SDWAINC1
@NM00050 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00049 EQU   SDWAILC1
@NM00048 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00047 EQU   SDWANXT1
@NM00046 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00045 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00044 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00043 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00042 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00041 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00040 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00039 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00038 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
@NM00013 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCACPUM EQU   PCCA+376
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCARV49 EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCACPID EQU   PCCA+4
PCCAPCCA EQU   PCCA
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCAR123 EQU   LCCA+956
LCCAR122 EQU   LCCA+952
LCCAR121 EQU   LCCA+948
LCCAR120 EQU   LCCA+944
LCCAR119 EQU   LCCA+940
LCCAR118 EQU   LCCA+936
LCCAR117 EQU   LCCA+932
LCCAR116 EQU   LCCA+928
LCCAR115 EQU   LCCA+924
LCCAR114 EQU   LCCA+920
LCCAR113 EQU   LCCA+916
LCCAR112 EQU   LCCA+912
LCCAR111 EQU   LCCA+908
LCCAR110 EQU   LCCA+904
LCCAR109 EQU   LCCA+900
LCCAR108 EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCARV90 EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCARSFP EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
@NM00012 EQU   FRRSFLGS+1
@NM00011 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
TRANSMAX EQU   GTFPCT+304
@NM00010 EQU   AUDITFLG+3
AFSLEBLD EQU   AUDITFLG+3
WSERFG06 EQU   AUDITFLG+3
WSERFG05 EQU   AUDITFLG+3
WSERFG04 EQU   AUDITFLG+3
WSERFG03 EQU   AUDITFLG+3
WSERFG02 EQU   AUDITFLG+2
WSERFLAG EQU   AUDITFLG+2
TERMFLAG EQU   AUDITFLG+2
AFXWRIT  EQU   AUDITFLG+2
AFQLWAIT EQU   AUDITFLG+2
AFSLEGET EQU   AUDITFLG+2
AFBUFGET EQU   AUDITFLG+2
AFFEOB   EQU   AUDITFLG+2
AFBLKFIX EQU   AUDITFLG+1
AFEQFIX  EQU   AUDITFLG+1
AFPGRLSE EQU   AUDITFLG+1
AFWRAP   EQU   AUDITFLG+1
AFBUFOFF EQU   AUDITFLG+1
AFLDFX   EQU   AUDITFLG+1
AFCLOSE  EQU   AUDITFLG+1
AFOPEN   EQU   AUDITFLG+1
AFGMBLOK EQU   AUDITFLG
AFGMSRB  EQU   AUDITFLG
AFWAIT   EQU   AUDITFLG
AFTERM   EQU   AUDITFLG
AFINIT   EQU   AUDITFLG
AFWWRIT  EQU   AUDITFLG
AFCWRIT  EQU   AUDITFLG
AFIWRIT  EQU   AUDITFLG
EQSHORT  EQU   GTFPCT+292
SLEMAX   EQU   GTFPCT+288
SLECNT   EQU   GTFPCT+284
RQPURGE  EQU   GTFPCT+280
RQTOTAL  EQU   GTFPCT+276
WRTDLST  EQU   GTFPCT+272
NUMOFBUF EQU   GTFPCT+268
SBUFDISA EQU   GTFPCT+264
SLESUSED EQU   GTFPCT+260
EQMIN    EQU   GTFPCT+256
EQLENGTH EQU   GTFPCT+252
WQMAX    EQU   GTFPCT+248
WQLENGTH EQU   GTFPCT+244
QLECBP   EQU   QLOCKECB
@NM00009 EQU   QLOCKECB
@NM00008 EQU   QLOCKWRD+3
SCHEDBUF EQU   QLOCKWRD+2
POSTWRIT EQU   QLOCKWRD+1
QLOCK    EQU   QLOCKWRD
WRITERDD EQU   GTFPCT+228
GTFLOSTR EQU   GTFPCT+224
SRBAVAIL EQU   GTFSSRB
WRTRERRP EQU   WRTRERR
@NM00007 EQU   WRTRERR
TRMWRITP EQU   TRMWRIT
@NM00006 EQU   TRMWRIT
GTFCMECB EQU   GTFPCT+208
WRTRCOMP EQU   WRTRCOM
@NM00005 EQU   WRTRCOM
TRANSCNT EQU   GTFPCT+200
AHLRDPLQ EQU   GTFPCT+196
SFEOBRTN EQU   GTFPCT+192
CURRBLOK EQU   GTFPCT+184
GBCDS    EQU   NEXTBLOK
WSMODEND EQU   GTFPCT+176
WSMODBEG EQU   GTFPCT+172
BCBPAGE  EQU   GTFPCT+156
SLEPAGE  EQU   GTFPCT+152
SAVECNT  EQU   GTFPCT+148
SLQHEAD  EQU   GTFPCT+144
HQLENGTH EQU   GTFPCT+140
QTAIL    EQU   GTFPCT+136
HQHEAD   EQU   GTFPCT+132
WQHEAD   EQU   GTFPCT+128
RQHEAD   EQU   GTFPCT+124
EQHEAD   EQU   GTFPCT+120
WPOSTSRB EQU   GTFPCT+116
WTSKTCBA EQU   GTFPCT+112
WRTRTCBA EQU   GTFPCT+108
TRMWTASK EQU   GTFPCT+104
WTSKATTH EQU   GTFPCT+100
WTSKINIT EQU   GTFPCT+96
WTASKECB EQU   GTFPCT+92
WMTABPTR EQU   GTFPCT+88
ATTCHECB EQU   GTFPCT+84
AHLECB   EQU   GTFPCT+80
STOPECBA EQU   GTFPCT+76
ECBADRLT EQU   GTFPCT+72
FIXLEN   EQU   GTFPCT+68
FIXPTR   EQU   GTFPCT+64
INITPTR  EQU   GTFPCT+60
MCQEPTR  EQU   GTFPCT+56
GTFEIDL  EQU   GTFPCT+52
GTFPIBL  EQU   GTFPCT+48
GTFPIFT  EQU   GTFPCT+44
GTFSVCBL EQU   GTFPCT+40
GTFSVCFT EQU   GTFPCT+36
GTFIOBL  EQU   GTFPCT+32
GTFIOFT  EQU   GTFPCT+28
GTFSIOBL EQU   GTFPCT+24
GTFSIOFT EQU   GTFPCT+20
@NM00004 EQU   PCTCATF+1
PCTPIF   EQU   PCTCATF+1
PCTSIOF  EQU   PCTCATF+1
PCTIOF   EQU   PCTCATF+1
PCTSVCF  EQU   PCTCATF+1
PCTRR    EQU   PCTCATF+1
PCTSRM   EQU   PCTCATF+1
PCTRNIO  EQU   PCTCATF+1
PCTUSR   EQU   PCTCATF
PCTPI    EQU   PCTCATF
@NM00003 EQU   PCTCATF
PCTDSP   EQU   PCTCATF
PCTSIO   EQU   PCTCATF
PCTIO    EQU   PCTCATF
PCTEXT   EQU   PCTCATF
PCTSVC   EQU   PCTCATF
OPTRES3  EQU   GTFOPTS4
OPTIOSIO EQU   GTFOPTS3
OPTRES2  EQU   GTFOPTS3
OPTRR    EQU   GTFOPTS3
OPTSRM   EQU   GTFOPTS3
OPTRNIO  EQU   GTFOPTS3
OPTEXT   EQU   GTFOPTS3
OPTIOP   EQU   GTFOPTS2
OPTIO    EQU   GTFOPTS2
OPTPIP   EQU   GTFOPTS2
OPTPI    EQU   GTFOPTS2
OPTSIOP  EQU   GTFOPTS2
OPTSIO   EQU   GTFOPTS2
OPTSVCP  EQU   GTFOPTS2
OPTSVC   EQU   GTFOPTS2
OPTPCI   EQU   GTFOPTS1
OPTRES1  EQU   GTFOPTS1
OPTDSP   EQU   GTFOPTS1
OPTUSR   EQU   GTFOPTS1
OPTSYS   EQU   GTFOPTS1
OPTSYSP  EQU   GTFOPTS1
OPTSYSM  EQU   GTFOPTS1
GTFRESV  EQU   GTFSTAT
GTFMODE  EQU   GTFSTAT
GTFPCTID EQU   GTFPCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTINTLA EQU   CVTMAP+320
CVTERPV  EQU   CVTMAP+316
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTIERLC EQU   CVTMAP+144
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00037 EQU   PSA+3412
PSASTAK  EQU   PSA+3072
@NM00036 EQU   PSA+1032
PSAUSEND EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSARV060 EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSARV054 EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSAMODE  EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00035 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00034 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSARV009 EQU   PSASUP3
PSARV008 EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00033 EQU   FLCFSA
@NM00032 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00031 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00030 EQU   FLCIOA
@NM00029 EQU   FLCMCLA+15
@NM00028 EQU   FLCMCLA+14
@NM00027 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00026 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00025 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00024 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00023 EQU   FLCPER
@NM00022 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00021 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00020 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00019 EQU   FLCPIILC
@NM00018 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00017 EQU   FLCSVILC
@NM00016 EQU   PSAESPSW
PSASPAD  EQU   PSAEEPSW
@NM00015 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
@NM00014 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RT00067 EQU   EXTEND
@RT00070 EQU   EXTEND
@RT00080 EQU   EXTJNNA
@ENDDATA EQU   *
         END   AHLTEXT,(C'PL/S-II',0502,74016)
