         TITLE 'IDA0192C - VSAM CATALOG INTERFACE                      *
                        '
IDA0192C CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192C  78.151'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  LA    @12,4095(,@03)                                      0001
         USING @PSTART,@03                                         0001
         USING @PSTART+4095,@12                                    0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL ZERO
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  ZERO THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR ZERO
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        ZERO IF THE GETMAIN WAS UNSUCCESSFUL.
*   IF R15=0 THEN                   /* GETMAIN FAIL                  */
         LTR   R15,R15                                             0220
         BNZ   @RF00220                                            0220
*     DO;                                                          0221
*       GEN(L @15,GMFAIL);          /* INIT RETURN CODE      @X04SVGP*/
         L @15,GMFAIL
*       GEN(LM R0,R12,20(R13));     /* RESTORE REGS                  */
         LM R0,R12,20(R13)
*       GEN(L  RET,12(R13));                                       0224
         L  RET,12(R13)
*       GEN(BR RET);                /* RETURN TO CALLER              */
         BR RET
*     END;                                                         0226
*   RESPECIFY                                                      0227
*     R13 RESTRICTED;                                              0227
@RF00220 DS    0H                                                  0228
*   GEN(ST R13,4(R15));             /* SAVE SAVE REG                 */
         ST R13,4(R15)
*   GEN( L R0,20(,R13));            /* IDAGMAIN USES R0, RESTORE IT.
*                                                            @Z30SSMD*/
          L R0,20(,R13)
*   GEN( L R1,24(,R13));            /* IDAGMAIN USES R1, RESTORE IT.
*                                                            @Z30SSMD*/
          L R1,24(,R13)
*   R13=R15;                        /* NO,                           */
         LR    R13,R15                                             0231
*   GEN(USING @DATD,R13);           /* ADDRESSABILITY TO WA          */
         USING @DATD,R13
*   PARMPT=R1;                      /* INIT PARAMETER PTR            */
         ST    R1,PARMPT                                           0233
*   ACBPT=RACB;                     /* INIT ACB PTR                  */
         ST    RACB,ACBPT                                          0234
*   RESPECIFY                                                      0235
*     RACB UNRESTRICTED;                                           0235
*                                                                  0235
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD CATALOG WORK AREA                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0236
*   RESPECIFY                                                      0236
*     IDAAMB BASED(R5);             /*                       @X04SVGP*/
*   PPFUNC=PDF1;                    /* NOTE FUNCTION         @X04SVGP*/
         MVI   PPFUNC,X'01'                                        0237
*   SUBPOOL=WKPOOL;                 /* INIT SUBPOOL FOR GETMAIN      */
         MVI   SUBPOOL,X'FC'                                       0238
*   CORELEN=SWKLEN*2;               /* INIT LENGTH FOR GETMAIN       */
         LA    CORELEN,2048                                        0239
*   CALL GETCORE;                   /* GET CORE FOR CAT WORK AREA    */
         BAL   @14,GETCORE                                         0240
*   IF PPCODE=0 THEN                /* GETMAIN SUCCESSFUL    @Z30SSRL*/
         CLI   PPCODE,0                                            0241
         BNE   @RF00241                                            0241
*     DO;                                                          0242
*       CTGPLPTR=COREADDR;          /* PTR TO CAT PARAMETER LIST     */
         L     @15,COREADDR                                        0243
         ST    @15,CTGPLPTR                                        0243
*       CTGFLPTR=CTGPLPTR+LENGTH(CTGPL)+LENGTH(CTGFIELD)*6;/* PTR 1ST
*                                      FIELD                         */
         LA    CTGFLPTR,52                                         0244
         ALR   CTGFLPTR,@15                                        0244
*       CATWKPTR=CTGFLPTR+(LENGTH(CTGFL)+LENGTH(CTGFLDAT))*FLMAX;/*
*                                      PTR TO CAT WORK FOR UPDATE AND
*                                      RETURN OF CAT INFO            */
         LA    @14,432                                             0245
         ALR   @14,CTGFLPTR                                        0245
         ST    @14,CATWKPTR                                        0245
*       CATWKPTR=((CATWKPTR+7)/8)*8;                               0246
         AL    @14,@CF00070                                        0246
         SRDA  @14,32                                              0246
         D     @14,@CF00049                                        0246
         SLA   @15,3                                               0246
         ST    @15,CATWKPTR                                        0246
*       WORKLEN=(COREADDR+SWKLEN*2)-CATWKPTR;/* INIT WORK AREA LENGTH*/
         L     @02,COREADDR                                        0247
         AL    @02,@CF03903                                        0247
         SLR   @02,@15                                             0247
         STH   @02,WORKLEN(,@15)                                   0247
*       CATBLKLN=CATWKPTR-CTGPLPTR; /* INIT LENGTH OF CAT BLKS AND 0248
*                                      FIELD LISTS                   */
         L     @02,CTGPLPTR                                        0248
         SLR   @15,@02                                             0248
         STH   @15,CATBLKLN                                        0248
*       IF ID=OP1 THEN              /* IS THIS 1ST OPEN CALL @X04SVGP*/
         L     @02,PARMPT                                          0249
         CLI   ID(@02),4                                           0249
         BNE   @RF00249                                            0249
*         CALL LOC1;                /* YES, PERFORM REQ LOCATES      */
         BAL   @14,LOC1                                            0250
*       ELSE                        /* NOT 1ST OPEN CALL     @X04SVRL*/
*         IF ID=OP2 THEN            /* LOCATE DS ATTRIBUTES  @X04SVGP*/
         B     @RC00249                                            0251
@RF00249 L     @02,PARMPT                                          0251
         CLI   ID(@02),44                                          0251
         BNE   @RF00251                                            0251
*           CALL LOC2;              /* YES, DO LOCATE        @X04SVGP*/
         BAL   @14,LOC2                                            0252
*         ELSE                      /* NO,                           */
*           IF ID=CLM THEN          /* IS THIS 1ST CLOSE CALL        */
         B     @RC00251                                            0253
@RF00251 L     @02,PARMPT                                          0253
         CLI   ID(@02),8                                           0253
         BNE   @RF00253                                            0253
*             CALL CLMAIN;          /* YES, PERFORM REQ UPDATES      */
         BAL   @14,CLMAIN                                          0254
*           ELSE                    /* NOT 1ST CLOSE CALL    @Z30SSRL*/
*             IF ID=OPO THEN        /* UPDATE OPEN INDICATOR         */
         B     @RC00253                                            0255
@RF00253 L     @02,PARMPT                                          0255
         CLI   ID(@02),12                                          0255
         BNE   @RF00255                                            0255
*               CALL OPOBIT;        /* YES, UPD                      */
         BAL   @14,OPOBIT                                          0256
*             ELSE                  /* NOT UPDATE OPEN IND   @Z30SSRL*/
*               IF ID=PRE THEN      /* UPDATE PREFORMAT INDICATOR    */
         B     @RC00255                                            0257
@RF00255 L     @02,PARMPT                                          0257
         CLI   ID(@02),32                                          0257
         BNE   @RF00257                                            0257
*                 CALL PREFORM;     /* YES, UPDATE PREFMT IND        */
         BAL   @14,PREFORM                                         0258
*               ELSE                /* NOT UPDATE PREFMT IND @Z30SSRL*/
*                 IF ID=OPP THEN    /* PASSWORD VERIFICATION         */
         B     @RC00257                                            0259
@RF00257 L     @02,PARMPT                                          0259
         CLI   ID(@02),16                                          0259
         BNE   @RF00259                                            0259
*                   CALL OPPSWD;    /* YES, CALL PSWRD ROUTINE       */
         BAL   @14,OPPSWD                                          0260
*                 ELSE              /* NOT PSWRD VERIFICATION      0261
*                                                            @Z30SSRL*/
*                   IF ID=VLT THEN  /* TIME STAMP REQUEST            */
         B     @RC00259                                            0261
@RF00259 L     @02,PARMPT                                          0261
         CLI   ID(@02),20                                          0261
         BNE   @RF00261                                            0261
*                     CALL VLTSTMP; /* YES, LOCATE T.S.              */
         BAL   @14,VLTSTMP                                         0262
*                   ELSE            /* NOT TIMESTAMP REQUEST @Z30SSRL*/
*                     IF ID=RCM THEN/* RCD MGMT CALL                 */
         B     @RC00261                                            0263
@RF00261 L     @02,PARMPT                                          0263
         CLI   ID(@02),36                                          0263
         BNE   @RF00263                                            0263
*                       CALL RCMUPD;/* RCD MGMT UPDATE       @Z30SSRL*/
         BAL   @14,RCMUPD                                          0264
*                     ELSE          /* NOT RCD MGMT          @Z30SSRL*/
*                       IF ID=CLC THEN/* LOCATE CL DSN       @X04SVRL*/
         B     @RC00263                                            0265
@RF00263 L     @02,PARMPT                                          0265
         CLI   ID(@02),48                                          0265
         BNE   @RF00265                                            0265
*                         CALL CLNLOC;/* YES, GET NAME       @X04SVGP*/
         BAL   @14,CLNLOC                                          0266
*                       ELSE        /* NOT LOC CL DSN        @X04SVRL*/
*                         IF ID=CLD THEN/* LOCATE EL DSN     @X04SVRL*/
         B     @RC00265                                            0267
@RF00265 L     @02,PARMPT                                          0267
         CLI   ID(@02),40                                          0267
         BNE   @RF00267                                            0267
*                           CALL ELNLOC;/* YES,GET NAME      @X04SVGP*/
         BAL   @14,ELNLOC                                          0268
*                         ELSE      /* NOT LOC EL DSN        @X04SVRL*/
*                           CALL DUMLOC;/* DUMMY LOCATE FOR OPENING
*                                      CATALOG                       */
*                                                                  0269
         B     @RC00267                                            0269
@RF00267 BAL   @14,DUMLOC                                          0269
*       /*************************************************************/
*       /*                                                           */
*       /* FREE CATALOG WORK AREAS                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0270
*       FREEAD=CTGPLPTR;            /* PT TO CAT PARM LIST   @Z30SSRL*/
@RC00267 DS    0H                                                  0270
@RC00265 DS    0H                                                  0270
@RC00263 DS    0H                                                  0270
@RC00261 DS    0H                                                  0270
@RC00259 DS    0H                                                  0270
@RC00257 DS    0H                                                  0270
@RC00255 DS    0H                                                  0270
@RC00253 DS    0H                                                  0270
@RC00251 DS    0H                                                  0270
@RC00249 L     @02,CTGPLPTR                                        0270
         ST    @02,FREEAD                                          0270
*       SUBPOOL=WKPOOL;             /* GET SUBPOOL NO.       @Z30SSRL*/
         MVI   SUBPOOL,X'FC'                                       0271
*       FREELEN=CATBLKLN;           /* LENGTH OF PARM LIST   @Z30SSRL*/
         LH    @02,CATBLKLN                                        0272
         STH   @02,FREELEN                                         0272
*       CALL FREECORE;              /* FREEMAIN CAT PARM LIST      0273
*                                                            @Z30SSRL*/
         BAL   @14,FREECORE                                        0273
*       FREEAD=CATWKPTR;            /* PT TO CAT WORK AREA   @Z30SSRL*/
         L     @02,CATWKPTR                                        0274
         ST    @02,FREEAD                                          0274
*       FREELEN=WORKLEN;            /* GET LENGTH OF WRK AREA      0275
*                                                            @Z30SSRL*/
         LH    @02,WORKLEN(,@02)                                   0275
         STH   @02,FREELEN                                         0275
*       CALL FREECORE;              /* FREEMAIN CAT WRK AREA @Z30SSRL*/
         BAL   @14,FREECORE                                        0276
*     END;                                                         0277
*   IF PPCODE=0 THEN                /* ANY ERRORS                    */
@RF00241 CLI   PPCODE,0                                            0278
         BNE   @RF00278                                            0278
*     PPFUNC=0;                     /* NO, ZERO RETURN CODE          */
         MVI   PPFUNC,X'00'                                        0279
*   R6=PD;                          /* LOAD RETURN CODE              */
@RF00278 L     R6,PD                                               0280
*   MAINPOOL=WKPOOL;                /* SET SUBPOOL FOR FREEMAIN      */
         MVI   MAINPOOL,X'FC'                                      0281
*   GEN(L R7,@SIZDATD);             /* LOAD BLOCK SIZE               */
         L R7,@SIZDATD
*   MAINLEN=R7;                     /* SET LENGTH FOR FREEMAIN       */
         STCM  R7,7,MAINLEN                                        0283
*   RESPECIFY                                                      0284
*    (R0,                                                          0284
*     R1) RESTRICTED;                                              0284
*   R1=R13;                         /* POINT TO BLOCK ADDR           */
         LR    R1,R13                                              0285
*   R0=MAINR0;                      /* LOAD SUBPOOL/LENGTB           */
         L     R0,MAINR0                                           0286
*   GEN(L R13,4(R13));              /* POINT TO LAST SAVEAREA        */
         L R13,4(R13)
*   GEN(FREEMAIN R,LV=(0),A=(1));   /* FREE AUTOMATICS               */
         FREEMAIN R,LV=(0),A=(1)
*   GEN(L RET,12(R13));             /* LOAD RETURN ADDRESS           */
         L RET,12(R13)
*   RETCODE=R6;                     /* LOAD RETURN CODE              */
         LR    RETCODE,R6                                          0290
*   GEN(LM R0,R12,20(R13));         /* RESTORE REGISTERS 0-12        */
         LM R0,R12,20(R13)
*   GEN(BR RET);                    /* RETURN TO CALLER              */
         BR RET
*   RESPECIFY                                                      0293
*    (R0,                                                          0293
*     R1) UNRESTRICTED;                                            0293
*LOC1:                                                             0294
*                                                                  0294
*/********************************************************************/
*/*                                                          @X04SVGP*/
*/*     0U FUNCTION - LOCATE FROM THE CATALOG THE CI NBR FOR EACH    */
*/*                   DATA SET ASSOCIATED WITH THE ACB, AND ALSO     */
*/*                   THE ADDRESS OF THE CATALOG ACB.        @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*     01 INPUT    - ACB WORK AREA, LOCATE DESCRIPTOR RECORD, JFCB  */
*/*                                                          @X04SVGP*/
*/*     01 OUTPUT   - CI NBRS AND CATALOG ACB ADDRESS        @X04SVRL*/
*/*                   ARE INITIALIZED IN THE ACB WORK AREA   @X04SVGP*/
*/*                                                          @X04SVGP*/
*/********************************************************************/
*                                                                  0294
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVGP*/
LOC1     DS    0H                                                  0295
*   RSAVLA=RET;                     /* SAVE RETURN ADDRESS   @X04SVGP*/
         ST    RET,RSAVLA                                          0295
*   RESPECIFY                                                      0296
*     IFGACB BASED(ACBPT);          /*                       @X04SVGP*/
*   IF OPWCAT=ON|OPWSCRA=ON|OPWUCRA=ON THEN/* SPECIAL DATA SET       */
         TM    OPWCAT(RCORE),B'11000000'                           0297
         BNZ   @RT00297                                            0297
         TM    OPWUCRA(RCORE),B'10000000'                          0297
         BNO   @RF00297                                            0297
@RT00297 DS    0H                                                  0298
*     DO;                           /* YES, CONTINUE         @X04SVGP*/
*       OPWBDTCI=CATCIDTA;          /* INIT DATA CI          @X04SVGP*/
         SLR   @02,@02                                             0299
         STCM  @02,7,OPWBDTCI(RCORE)                               0299
*       OPWBIXCI=CATCIIDX;          /* INIT INDEX CI         @X04SVGP*/
         MVC   OPWBIXCI(3,RCORE),@CF00053+1                        0300
*       OPWCACB=ACBPT;              /* INIT CAT ACB ADDR     @X04SVGP*/
         L     @02,ACBPT                                           0301
         ST    @02,OPWCACB(,RCORE)                                 0301
*       OPWUPD=ON;                  /* AUTHORIZED FOR UPD    @X04SVGP*/
*       OPWCINV=ON;                 /* AUTHORIZED FOR CINV   @X04SVGP*/
         OI    OPWUPD(RCORE),B'01100000'                           0303
*       IF OPWSCRA=ON|OPWUCRA=ON THEN/* CRA DATA SET         @X04SVGP*/
         TM    OPWSCRA(RCORE),B'01000000'                          0304
         BO    @RT00304                                            0304
         TM    OPWUCRA(RCORE),B'10000000'                          0304
         BNO   @RF00304                                            0304
@RT00304 DS    0H                                                  0305
*         OPWBIXCI=0;               /* INIT CI TO ZERO       @X04SVGP*/
         SLR   @02,@02                                             0305
         STCM  @02,7,OPWBIXCI(RCORE)                               0305
*     END;                          /*                       @X04SVGP*/
*   ELSE                            /* NOT A SPECIAL DATA SET      0307
*                                                            @X04SVRL*/
*     DO;                           /* PROCESS NON CAT       @X04SVGP*/
         B     @RC00297                                            0307
@RF00297 DS    0H                                                  0308
*       CALL CLUPDESR;              /* CLEAR UPDATE DESCRIPTOR RECORD*/
         BAL   @14,CLUPDESR                                        0308
*       PPFUNC=PDF2;                /* NOTE FUNCTION         @X04SVGP*/
         MVI   PPFUNC,X'02'                                        0309
*       NAME44=ON;                  /* LOCATE BY NAME        @X04SVGP*/
         OI    NAME44,B'10000000'                                  0310
*       IF OPWVVIC=OFF THEN         /* VVIC DATA SET         @X04SVGP*/
         TM    OPWVVIC(RCORE),B'00100000'                          0311
         BNZ   @RF00311                                            0311
*         PSWRD=ON;                 /* NO, DO AUTH CHECK     @X04SVGP*/
         OI    PSWRD,B'00000010'                                   0312
*       ELSE                        /* YES,                  @X04SVGP*/
*         DO;                       /*                       @X04SVGP*/
         B     @RC00311                                            0313
@RF00311 DS    0H                                                  0314
*           OPWUPD=ON;              /* AUTHORIZED FOR UPD    @X04SVGP*/
*           OPWCINV=ON;             /* AUTHORIZED FOR CINV   @X04SVGP*/
         OI    OPWUPD(RCORE),B'01100000'                           0315
*         END;                      /*                       @X04SVGP*/
*       DO CTR=1 TO 6;              /* PROCESS 6 FIELDS      @Y30DSMD*/
@RC00311 LA    CTR,1                                               0317
@DL00317 DS    0H                                                  0318
*         FLACTIVE(CTR,1)=ON;       /* ACTIVATE 6 LOCATE FIELDS    0318
*                                                            @Y30DSMD*/
         LR    @11,CTR                                             0318
         MH    @11,@CH00144                                        0318
         LA    @02,FLACTIVE-60(@11)                                0318
         OI    0(@02),B'10000000'                                  0318
*       END;                        /*                       @X04SVGP*/
         AL    CTR,@CF00053                                        0319
         C     CTR,@CF00040                                        0319
         BNH   @DL00317                                            0319
*       FLNAME(1,1)='DSTYPNAM';     /* INIT SYMBOLIC FIELD NAMES     */
         MVC   FLNAME(8),@CC03760                                  0320
*       FLNAME(2,1)='CATACB  ';     /*                       @X04SVGP*/
         MVC   FLNAME+60(8),@CC03761                               0321
*       FLNAME(3,1)='NAMEDS  ';     /*                       @X04SVGP*/
         MVC   FLNAME+120(8),@CC03762                              0322
*       FLNAME(4,1)='CRAVOL  ';     /*                       @X04SVGP*/
         MVC   FLNAME+180(8),@CC03763                              0323
*       FLNAME(5,1)='UPGRADE ';     /*                       @X04SVGP*/
         MVC   FLNAME+240(8),@CC03764                              0324
*       FLNAME(6,1)='CATTR   ';     /* REQUEST CLUSTER ATTRS.      0325
*                                                            @Y30DSMD*/
         MVC   FLNAME+300(8),@CC03765                              0325
*       DSNDD=JFCBDSNM;             /* INIT DSNAME FROM DD STMT      */
         L     @02,OPWCOMWA(,RCORE)                                0326
         MVC   DSNDD(44),JFCBDSNM+100(@02)                         0326
*       CALL CTINTRFC;              /* INIT FIELDS,PARM LIST, AND  0327
*                                      ISSUE SVC 26          @X04SVGP*/
         BAL   @14,CTINTRFC                                        0327
*       IF PPCODE=0 THEN            /* ANY ERRORS            @X04SVGP*/
         CLI   PPCODE,0                                            0328
         BNE   @RF00328                                            0328
*         DO;                       /* NO, CONTINUE          @X04SVGP*/
*           CTGFLPTR=CTGFIELD(1);   /* INIT CURRENT FIELD PTR        */
         L     @15,CTGPLPTR                                        0330
         L     CTGFLPTR,CTGFIELD(,@15)                             0330
*           IF CTGFLPT(1)^=0 THEN   /* FIELD POINTER NOT ZERO      0331
*                                                            @X04SVRL*/
         L     @14,CTGFLPT(,CTGFLPTR)                              0331
         LTR   @14,@14                                             0331
         BZ    @RF00331                                            0331
*             DO;                   /* LOCATE SUCCESSFUL?    @X04SVGP*/
*               IF ENTYPE='G' THEN  /* OPEN AIX AS END USE   @X04SVGP*/
         CLI   ENTYPE(@14),C'G'                                    0333
         BNE   @RF00333                                            0333
*                 DO;               /* YES,                  @X04SVGP*/
*                   OPWAIXDT=ON;    /* INDICATE SUCH IN ACBWA      0335
*                                                            @X04SVGP*/
         OI    OPWAIXDT(RCORE),B'00100000'                         0335
*                   CTGFLPTR=CTGFIELD(3);/* ADDR FOR 3RD FIELD     0336
*                                                            @X04SVGP*/
         L     CTGFLPTR,CTGFIELD+8(,@15)                           0336
*                   OPWBDTCI=NAME;  /* INIT BASE DATA CI     @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0337
         MVC   OPWBDTCI(3,RCORE),NAME(@15)                         0337
*                   CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/* NEXT CI
*                                                            @X04SVGP*/
         AL    @15,@CF00082                                        0338
         ST    @15,CTGFLPT(,CTGFLPTR)                              0338
*                   OPWBIXCI=NAME;  /* INIT BASE IX CI       @X04SVGP*/
         MVC   OPWBIXCI(3,RCORE),NAME(@15)                         0339
*                 END;              /*                       @X04SVGP*/
*               ELSE                /* FIELD POINTER IS ZERO @X04SVRL*/
*                 IF ENTYPE='C' THEN/* CLUSTER ENTRY         @X04SVGP*/
         B     @RC00333                                            0341
@RF00333 L     @15,CTGFLPT(,CTGFLPTR)                              0341
         CLI   ENTYPE(@15),C'C'                                    0341
         BNE   @RF00341                                            0341
*                   DO;             /*                       #X04SVGP*/
*                                                                  0342
*                     /***********************************************/
*                     /*                                             */
*                     /* FOR VS2 CHECK IF THE CLUSTER IS REALLY A    */
*                     /* CATALOG. VS2 REQUIRES APF AUTHORIZATION TO  */
*                     /* OPEN A CATALOG AS A DATA SET.               */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0343
*                     IF ENTIDNO=CATIDNO THEN/* IF THIS IS A CTLG  0343
*                                                            @Y30DSMD*/
         CLC   ENTIDNO(3,@15),CATIDNO                              0343
         BNE   @RF00343                                            0343
*                       DO;         /* THEN PERFORM APF CHECK.     0344
*                                                            @Y30DSMD*/
*                         GEN( TESTAUTH FCTN=1)                    0345
*                         SETS(RETCODE);/* VERIFY AUTHORIZATION.   0345
*                                                            @Y30DSMD*/
          TESTAUTH FCTN=1
*                         IF RETCODE^=0 THEN/* IF NOT APF VALID    0346
*                                                            @Y30DSMD*/
         LTR   RETCODE,RETCODE                                     0346
         BZ    @RF00346                                            0346
*                           PPCODE=PP40;/* THEN SET ERROR CODE.    0347
*                                                            @Y30DSMD*/
         MVI   PPCODE,X'28'                                        0347
*                       END;        /* END OF APF TESTING.   @Y30DSMD*/
@RF00346 DS    0H                                                  0349
*                     CTGFLPTR=CTGFIELD(3);/* YES, ADDR 3RD FIELD  0349
*                                                            #X04SVGP*/
@RF00343 L     @01,CTGPLPTR                                        0349
         L     CTGFLPTR,CTGFIELD+8(,@01)                           0349
*                     OPWBDTCI=NAME;/* INIT BASE DATA CI     #X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0350
         MVC   OPWBDTCI(3,RCORE),NAME(@15)                         0350
*                     IF CTGFLNG(1)>LENGTH(NAMEDS) THEN/* IX CI EXIST*/
         LA    @14,4                                               0351
         C     @14,CTGFLNG(,CTGFLPTR)                              0351
         BNL   @RF00351                                            0351
*                       DO;         /*                       @X04SVGP*/
*                         CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/* NXT
*                                      CI                            */
         ALR   @15,@14                                             0353
         ST    @15,CTGFLPT(,CTGFLPTR)                              0353
*                         IF TYPE='I' THEN/* IF INDEX TYPE THEN    0354
*                                                            @X04SVGP*/
         CLI   TYPE(@15),C'I'                                      0354
         BNE   @RF00354                                            0354
*                           OPWBIXCI=NAME;/* INIT BASE IX CI @X04SVGP*/
         MVC   OPWBIXCI(3,RCORE),NAME(@15)                         0355
*                       END;        /*                       @X04SVGP*/
*                   END;            /*                       #X04SVGP*/
*                 ELSE              /* NOT CLUSTER ENTRY     @X04SVRL*/
*                   IF ENTYPE='R' THEN/* PATH ENTRY          @X04SVGP*/
         B     @RC00341                                            0358
@RF00341 L     @01,CTGFLPT(,CTGFLPTR)                              0358
         CLI   ENTYPE(@01),C'R'                                    0358
         BNE   @RF00358                                            0358
*                     DO;           /* YES,                  @X04SVGP*/
*                       CTGFLPTR=CTGFIELD(3);/* ADDR 3RD FIELD     0360
*                                                            @X04SVGP*/
         L     @01,CTGPLPTR                                        0360
         L     CTGFLPTR,CTGFIELD+8(,@01)                           0360
*                       IF TYPE='G'&ACBAIX=OFF THEN/* IS THIS REAL 0361
*                                      PATH                          */
         L     @15,CTGFLPT(,CTGFLPTR)                              0361
         CLI   TYPE(@15),C'G'                                      0361
         BNE   @RF00361                                            0361
         L     @01,ACBPT                                           0361
         TM    ACBAIX(@01),B'00000001'                             0361
         BNZ   @RF00361                                            0361
*                         DO;       /* YES, CONTINUE         @X04SVGP*/
*                           CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/*
*                                      NXT CI                        */
         LA    @14,4                                               0363
         ALR   @15,@14                                             0363
         ST    @15,CTGFLPT(,CTGFLPTR)                              0363
*                           OPWPDTCI=NAME;/* INIT PATH DATA CI     0364
*                                                            @X04SVGP*/
         MVC   OPWPDTCI(3,RCORE),NAME(@15)                         0364
*                           CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/*
*                                      NXT CI                        */
         ALR   @15,@14                                             0365
         ST    @15,CTGFLPT(,CTGFLPTR)                              0365
*                           OPWPIXCI=NAME;/* INIT PATH IX CI @X04SVGP*/
         MVC   OPWPIXCI(3,RCORE),NAME(@15)                         0366
*                           CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/*
*                                      NXT CI                        */
         ALR   @15,@14                                             0367
         ST    @15,CTGFLPT(,CTGFLPTR)                              0367
*                           OPWBDTCI=NAME;/* INIT BASE DATA CI     0368
*                                                            @X04SVGP*/
         MVC   OPWBDTCI(3,RCORE),NAME(@15)                         0368
*                           CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/*
*                                      NXT CI                        */
         ALR   @15,@14                                             0369
         ST    @15,CTGFLPT(,CTGFLPTR)                              0369
*                           IF CTGFLNG(1)>4*LENGTH(NAMEDS) THEN/* IX
*                                      EXIST                         */
         L     @14,CTGFLNG(,CTGFLPTR)                              0370
         C     @14,@CF00150                                        0370
         BNH   @RF00370                                            0370
*                             OPWBIXCI=NAME;/* YES, INIT BASE IX CI
*                                                            @X04SVGP*/
         MVC   OPWBIXCI(3,RCORE),NAME(@15)                         0371
*                         END;      /*                       @X04SVGP*/
*                       ELSE        /* NOT REAL PATH         @X04SVRL*/
*                         DO;       /* MUST BE NO-UPD PATH   @X04SVGP
*                                      OR OPEN PATH AIX AS END USE   */
         B     @RC00361                                            0373
@RF00361 DS    0H                                                  0374
*                           IF TYPE='G' THEN/* IF PATH NAME  @X04SVGP*/
         L     @01,CTGFLPT(,CTGFLPTR)                              0374
         CLI   TYPE(@01),C'G'                                      0374
         BNE   @RF00374                                            0374
*                             OPWAIXDT=ON;/* INDICATE AIX IS END USE */
         OI    OPWAIXDT(RCORE),B'00100000'                         0375
*                           CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/*
*                                      NXT CI                        */
@RF00374 LA    @15,4                                               0376
         L     @14,CTGFLPT(,CTGFLPTR)                              0376
         ALR   @14,@15                                             0376
         ST    @14,CTGFLPT(,CTGFLPTR)                              0376
*                           OPWBDTCI=NAME;/* INIT BASE DATA CI     0377
*                                                            @X04SVGP*/
         MVC   OPWBDTCI(3,RCORE),NAME(@14)                         0377
*                           CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/*
*                                      NXT CI                        */
         ALR   @14,@15                                             0378
         ST    @14,CTGFLPT(,CTGFLPTR)                              0378
*                           IF CTGFLNG(1)>2*LENGTH(NAMEDS) THEN/* IX
*                                      EXIST                         */
         L     @15,CTGFLNG(,CTGFLPTR)                              0379
         C     @15,@CF00049                                        0379
         BNH   @RF00379                                            0379
*                             OPWBIXCI=NAME;/* YES, INIT BASE IX CI
*                                                            @X04SVGP*/
         MVC   OPWBIXCI(3,RCORE),NAME(@14)                         0380
*                         END;      /*                       @X04SVGP*/
*                     END;          /*                       @X04SVGP*/
*                   ELSE            /* NOT PATH ENTRY        @X04SVRL*/
*                     DO;           /* ENTRY MUST BE D, I, OR ERROR  */
         B     @RC00358                                            0383
@RF00358 DS    0H                                                  0384
*                       IF ENTYPE='I'|ENTYPE='D' THEN/* DATA OR INDEX*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0384
         CLI   ENTYPE(@15),C'I'                                    0384
         BE    @RT00384                                            0384
         CLI   ENTYPE(@15),C'D'                                    0384
         BNE   @RF00384                                            0384
@RT00384 DS    0H                                                  0385
*                         DO;       /* YES,                  @X04SVGP*/
*                           IF ENTYPE='I' THEN/* INDEX ENTRY @X04SVGP*/
         L     @01,CTGFLPT(,CTGFLPTR)                              0386
         CLI   ENTYPE(@01),C'I'                                    0386
         BNE   @RF00386                                            0386
*                             OPWIXDT=ON;/* YES, OPEN INDX AS ESDS 0387
*                                                            @X04SVGP*/
         OI    OPWIXDT(RCORE),B'01000000'                          0387
*                           OPWBDTCI=ENTIDNO;/* INIT BASE DATA CI  0388
*                                                            @X04SVGP*/
@RF00386 L     @01,CTGFLPT(,CTGFLPTR)                              0388
         MVC   OPWBDTCI(3,RCORE),ENTIDNO(@01)                      0388
*                         END;      /*                       @X04SVGP*/
*                       ELSE        /* NOT DATA OR INDEX     @X04SVRL*/
*                         PPCODE=PP76;/* INVALID ENTRY TYPE  @X04SVGP*/
         B     @RC00384                                            0390
@RF00384 MVI   PPCODE,X'4C'                                        0390
*                     END;          /*                       @X04SVGP*/
@RC00384 DS    0H                                                  0392
*               IF PPCODE=0 THEN    /* ANY ERRORS            @X04SVGP*/
@RC00358 DS    0H                                                  0392
@RC00341 DS    0H                                                  0392
@RC00333 CLI   PPCODE,0                                            0392
         BNE   @RF00392                                            0392
*                 DO;               /* NO,                   @X04SVGP*/
*                   ACBERFLG=0;     /* CLEAR POSSIBLE 188    @X04SVGP*/
         L     @15,ACBPT                                           0394
         MVI   ACBERFLG(@15),X'00'                                 0394
*                   ACBAMETH=AMTYPE;/* SET VSAM ACB          @X04SVGP*/
         MVI   ACBAMETH(@15),X'11'                                 0395
*                   CTGFLPTR=CTGFIELD(2);/* ADDR 2ND FIELD   @X04SVGP*/
         L     @15,CTGPLPTR                                        0396
         L     CTGFLPTR,CTGFIELD+4(,@15)                           0396
*                   OPWCACB=CATACB; /* INIT CATALOG ACB PTR  @X04SVGP*/
         L     @01,CTGFLPT(,CTGFLPTR)                              0397
         L     @14,CATACB(,@01)                                    0397
         ST    @14,OPWCACB(,RCORE)                                 0397
*                   CTGFLPTR=CTGFIELD(4);/* ADDR 4TH FIELD   @X04SVGP*/
         L     CTGFLPTR,CTGFIELD+12(,@15)                          0398
*                   IF CTGFLPTR^=0 THEN/* CRA VOL SER RETURNED     0399
*                                                            @X04SVGP*/
         LTR   CTGFLPTR,CTGFLPTR                                   0399
         BZ    @RF00399                                            0399
*                     OPWCRA=CRAVOL;/* YES, INIT IN ACB WK   @X04SVGP*/
         L     @01,CTGFLPT(,CTGFLPTR)                              0400
         MVC   OPWCRA(6,RCORE),CRAVOL(@01)                         0400
*                   CTGFLPTR=CTGFIELD(5);/* ADDR 5TH FIELD   @X04SVGP*/
@RF00399 L     @01,CTGPLPTR                                        0401
         L     CTGFLPTR,CTGFIELD+16(,@01)                          0401
*                   IF CTGFLPTR^=0&OPWAIXDT=OFF THEN/* UPGRADE EXIST
*                                                            @X04SVGP*/
         LTR   CTGFLPTR,CTGFLPTR                                   0402
         BZ    @RF00402                                            0402
         TM    OPWAIXDT(RCORE),B'00100000'                         0402
         BNZ   @RF00402                                            0402
*                     DO;           /* YES, RECORD IN ACB WK @X04SVGP*/
*                       MEMNUM=CTGFLNG(1)/(LENGTH(NAMEDS)*2);/* NBR
*                                      UPGR ENT                      */
         L     @00,CTGFLNG(,CTGFLPTR)                              0404
         SRDA  @00,32                                              0404
         D     @00,@CF00049                                        0404
         STC   @01,MEMNUM                                          0404
*                       OPWNOUPG=MEMNUM;/* INIT NO. OF UPGR DS IN OPW
*                                                            @X04SVRL*/
         STC   @01,OPWNOUPG(,RCORE)                                0405
*                       DO CTR=1 TO MEMNUM;/* PROCESS EACH ENTRY   0406
*                                                            @X04SVRL*/
         LA    CTR,1                                               0406
         B     @DE00406                                            0406
@DL00406 DS    0H                                                  0407
*                         OPWUDTCI(CTR)=NAME;/* INIT UPGR DATA CI  0407
*                                                            @X04SVGP*/
         LR    @11,CTR                                             0407
         SLA   @11,3                                               0407
         L     @15,CTGFLPT(,CTGFLPTR)                              0407
         ST    @11,@TF00001                                        0407
         ALR   @11,RCORE                                           0407
         MVC   OPWUDTCI-8(3,@11),NAME(@15)                         0407
*                         CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/* NXT
*                                      CI                            */
         LA    @11,4                                               0408
         ALR   @15,@11                                             0408
         ST    @15,CTGFLPT(,CTGFLPTR)                              0408
*                         OPWUIXCI(CTR)=NAME;/* INIT UPGR INDEX CI 0409
*                                                            @X04SVGP*/
         LR    @01,RCORE                                           0409
         AL    @01,@TF00001                                        0409
         MVC   OPWUIXCI-8(3,@01),NAME(@15)                         0409
*                         CTGFLPT(1)=CTGFLPT(1)+LENGTH(NAMEDS);/* NXT
*                                      CI                            */
         ALR   @15,@11                                             0410
         ST    @15,CTGFLPT(,CTGFLPTR)                              0410
*                       END;        /*                       @X04SVGP*/
         AL    CTR,@CF00053                                        0411
@DE00406 SLR   @11,@11                                             0411
         IC    @11,MEMNUM                                          0411
         CR    CTR,@11                                             0411
         BNH   @DL00406                                            0411
*                     END;          /*                       @X04SVGP*/
*                 END;              /*                       @X04SVGP*/
*                                                                  0413
@RF00402 DS    0H                                                  0414
*               /*****************************************************/
*               /*                                                   */
*               /* TEST TO SEE IF LOCATE(6) WAS SUCCESSFULL. IF NOT, */
*               /*                                           @Y30DSMD*/
*               /* ISSUE SET AN ERROR CODE. IF SO THEN CHECK FOR THE */
*               /*                                           @Y30DSMD*/
*               /* EXISTENCE OF THE DATA. CLUSTER ATTRIBUTES ARE SET */
*               /*                                           @Y30DSMD*/
*               /* FOR THE PAGE SPACE DATA SET.              @Y30DSMD*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0414
*               CTGFLPTR=CTGFIELD(6);/* POINT TO 6TH FIELD.  @Y30DSMD*/
@RF00392 L     @01,CTGPLPTR                                        0414
         L     CTGFLPTR,CTGFIELD+20(,@01)                          0414
*               IF CTGFLPT(1)=0 THEN/* IF LOCATE WAS NOT SUCCESSFULL,
*                                                            @Y30DSMD*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0415
         LTR   @15,@15                                             0415
         BNZ   @RF00415                                            0415
*                 PPCODE=PP32;      /* THEN SET ERROR CODE.  @Y30DSMD*/
         MVI   PPCODE,X'20'                                        0416
*               ELSE                /* IF LOCATE OK THEN     @Y30DSMD*/
*                 IF CCATTRO^='FF'X THEN/* IF DATA EXIST     @Z30SSRL*/
         B     @RC00415                                            0417
@RF00415 L     @15,CTGFLPT(,CTGFLPTR)                              0417
         CLI   CCATTRO(@15),X'FF'                                  0417
         BE    @RF00417                                            0417
*                   OPWCATTR=CCATTRO;/* COPY CLUSTER ATTRIBUTES.   0418
*                                                            @Z30SSRL*/
         MVC   OPWCATTR(1,RCORE),CCATTRO(@15)                      0418
*                 ELSE              /* IF DATA DOESNOT EXIST THEN  0419
*                                      IGNORE IT.            @Y30DSMD*/
*                   ;                                              0419
@RF00417 DS    0H                                                  0420
*             END;                  /*                       #X04SVGP*/
*           ELSE                    /* LOCATE FAILED         #X04SVGP*/
*             PPCODE=PP32;          /* INIT ERROR RETURN CODE        */
         B     @RC00331                                            0421
@RF00331 MVI   PPCODE,X'20'                                        0421
*         END;                      /*                       #X04SVGP*/
@RC00331 DS    0H                                                  0423
*     END;                          /*                       #X04SVGP*/
@RF00328 DS    0H                                                  0424
*   RET=RSAVLA;                     /*                       #X04SVGP*/
@RC00297 L     RET,RSAVLA                                          0424
*   END LOC1;                       /* RETURN TO CALLER      #X04SVGP*/
@EL00002 DS    0H                                                  0425
@EF00002 DS    0H                                                  0425
@ER00002 BR    @14                                                 0425
*LOC2:                                                             0426
*                                                                  0426
*/********************************************************************/
*/*                                                          @X04SVGP*/
*/*     01 FUNCTION - LOCATE ALL DATA SET AND VOLUME INFORMATION FOR */
*/*                   EACH DATA SET BELONGING TO THE CLUSTER.  INPUT */
*/*                   TO THE CATALOG ROUTINES ARE THE CI NBR AND     */
*/*                   ADDRESS OF THE CATALOG ACB,  CATALOG IS INVOKED*/
*/*                   ONCE PER CI NBR.                       @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*     01 INPUT    - ACB WORK AREA, LOCATE DESCRIPTOR       @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*     02 OUTPUT   - ALL DATA SET ATTRIBUTES AND VOLUME INFORMATION */
*/*                   ARE MERGED INTO THE AMB WORK AREAS.    @X04SVGP*/
*/*                                                          @X04SVGP*/
*/********************************************************************/
*                                                                  0426
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVGP*/
LOC2     DS    0H                                                  0427
*   RESPECIFY                                                      0427
*     AMBWORK BASED(RCOREF);        /*                       @X04SVGP*/
*   RSAVLA=RET;                     /* SAVE RETURN REG       @X04SVGP*/
         ST    RET,RSAVLA                                          0428
*   CALL CLUPDESR;                  /* CLEAR UPDATE DESCRIPTOR RECORD*/
         BAL   @14,CLUPDESR                                        0429
*   LOCTYPE=LOCTYPE&&LOCTYPE;       /* CLEAR LOCATE TYPE     @X04SVGP*/
         XC    LOCTYPE(1),LOCTYPE                                  0430
*   PPFUNC=PDF3;                    /* FUNCTION ID           @X04SVGP*/
         MVI   PPFUNC,X'03'                                        0431
*   CALL LOC2INIT;                  /* BUILD AMB WORK        @X04SVGP*/
         BAL   @14,LOC2INIT                                        0432
*   IF PPCODE=0 THEN                /* ANY ERRORS            @X04SVGP*/
         CLI   PPCODE,0                                            0433
         BNE   @RF00433                                            0433
*     DO;                           /* NO, CONTINUE          @X04SVGP*/
*       DSNCI=DSNDCI;               /* PROCESS DATA SET FIRST        */
         MVC   DSNCI(3),DSNDCI                                     0435
*       ID3=ON;                     /* INDICATE LOCATE BY CI NBR     */
         OI    ID3,B'00100000'                                     0436
*       DO CTR=1 TO 3;              /*                       @X04SVGP*/
         LA    CTR,1                                               0437
@DL00437 DS    0H                                                  0438
*         FLACTIVE(CTR,1)=ON;       /* INDICATE 6 FIELDS FOR LOC     */
         LR    @11,CTR                                             0438
         MH    @11,@CH00144                                        0438
         LA    @02,FLACTIVE-60(@11)                                0438
         OI    0(@02),B'10000000'                                  0438
*       END;                        /*                       @X04SVGP*/
         AL    CTR,@CF00053                                        0439
         C     CTR,@CF00032                                        0439
         BNH   @DL00437                                            0439
*       FLNAME(1,1)='OPENC2  ';     /* INIT SYMBOLIC FLD NAMES       */
         MVC   FLNAME(8),@CC03772                                  0440
*       FLNAME(2,1)='DSATRO  ';     /*                       @X04SVGP*/
         MVC   FLNAME+60(8),@CC03773                               0441
*       FLNAME(3,1)='AMDSBCAT';     /*                       @X04SVGP*/
         MVC   FLNAME+120(8),@CC03774                              0442
*       CALL LOC3;                  /*                       @X04SVGP*/
         BAL   @14,LOC3                                            0443
*       RCOREF=DATAWAPT;            /*                       @X04SVGP*/
         L     @02,PARMPT                                          0444
         L     @02,DATAWAPT(,@02)                                  0444
         ST    @02,RCOREF                                          0444
*       RFY                                                        0445
*         IDAAMBL BASED(ACBAMBL);   /* ADDRESSABILITY TO AMBL      0445
*                                                            @ZA31693*/
*       DO CTRB=1 TO MEMNUM WHILE PPCODE=0;/* PROCESS DATA AND INDX  */
         LA    @02,1                                               0446
         B     @DE00446                                            0446
@DL00446 CLI   PPCODE,0                                            0446
         BNE   @DC00446                                            0446
*         IF CTRB=1 THEN            /* PROCESSING DATA       @X04SVGP*/
         C     @02,@CF00053                                        0447
         BNE   @RF00447                                            0447
*           IF ACBRST=ON&BIBREST=OFF THEN/* YES, IS IT RESET @ZA31693*/
         L     @02,ACBPT                                           0448
         TM    ACBRST(@02),B'00000100'                             0448
         BNO   @RF00448                                            0448
         L     @02,ACBAMBL(,@02)                                   0448
         L     @02,AMBLBIB(,@02)                                   0448
         TM    BIBREST(@02),B'01000000'                            0448
         BNZ   @RF00448                                            0448
*             DO;                   /* YES,                  @X04SVGP*/
*               UPD=ON;             /* INDICATE UPDATE       @X04SVGP*/
*               REU=ON;             /* SET RE-USE INDICATOR  @X04SVGP*/
         OI    UPD,B'00001001'                                     0451
*               IF MEMNUM=2 THEN    /* KSDS                  @X04SVGP*/
         CLI   MEMNUM,2                                            0452
         BNE   @RF00452                                            0452
*                 RSTCI=DSNICI;     /* YES, INIT IX CI       @X04SVGP*/
         L     @02,CATWKPTR                                        0453
         MVC   RSTCI(3,@02),DSNICI                                 0453
*             END;                  /*                       @X04SVGP*/
@RF00452 DS    0H                                                  0455
*         IF OPWUCRA=ON THEN        /* IF UCRA               @X04SVRP*/
@RF00448 DS    0H                                                  0455
@RF00447 TM    OPWUCRA(RCORE),B'10000000'                          0455
         BNO   @RF00455                                            0455
*           PSWRD=ON;               /* THEN FORCE AUTH CHECK @X04SVRP*/
         OI    PSWRD,B'00000010'                                   0456
*         CALL CTINTRFC;            /* SET UP PL,FLDS, & ISSUE SVC   */
@RF00455 BAL   @14,CTINTRFC                                        0457
*         UPD=OFF;                  /* RESET UPDATE          @X04SVGP*/
*         REU=OFF;                  /* RESET RESET IND       @X04SVGP*/
         NI    UPD,B'11110110'                                     0459
*         IF PPCODE=0 THEN          /* IS PROBLEM CODE ZERO  @X04SVRL*/
         CLI   PPCODE,0                                            0460
         BNE   @RF00460                                            0460
*           DO;                     /*                       @X04SVGP*/
*             CTGFLPTR=CTGFIELD(1); /* INIT CURRENT FLD PTR  @X04SVGP*/
         L     @01,CTGPLPTR                                        0462
         L     CTGFLPTR,CTGFIELD(,@01)                             0462
*             IF CTGFLPT(1)^=0 THEN /* LOCATE GOOD?          @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0463
         LTR   @15,@15                                             0463
         BZ    @RF00463                                            0463
*               DO;                 /*                       @X04SVGP*/
*                 IF CYL=CYLTEST THEN/* CYLINDER ALLOCATION  @X04SVGP*/
         TM    CYL(@15),B'11000000'                                0465
         BNO   @RF00465                                            0465
*                   CTCYL=ON;       /* YES, NOTE FOR LATER   @X04SVGP*/
         L     @01,RCOREF                                          0466
         OI    CTCYL(@01),B'01000000'                              0466
*                 CTBUFSIZ=BUFSIZE; /*                       @X04SVGP*/
@RF00465 L     @15,RCOREF                                          0467
         L     @14,CTGFLPT(,CTGFLPTR)                              0467
         MVC   CTBUFSIZ(4,@15),BUFSIZE(@14)                        0467
*                 CTDATANM=ENTNAME; /*                       @X04SVGP*/
         MVC   CTDATANM(44,@15),ENTNAME(@14)                       0468
*                 CTHURBA=HURBADS;  /*                       @X04SVGP*/
         MVC   CTHURBA(4,@15),HURBADS(@14)                         0469
*                 CTEXEX=EXNM;      /* INIT EXCP EXIT NAME   @X04SVGP*/
         MVC   CTEXEX(8,@15),EXNM(@14)                             0470
*                 CTGFLPTR=CTGFIELD(2);/* NXT FIELD          @X04SVGP*/
         L     @01,CTGPLPTR                                        0471
         L     CTGFLPTR,CTGFIELD+4(,@01)                           0471
*                 IF CTGFLPT(1)^=0 THEN/* LOCATE GOOD?       @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0472
         LTR   @15,@15                                             0472
         BZ    @RF00472                                            0472
*                   DO;             /*                       @X04SVGP*/
*                     RESPECIFY                                    0474
*                       IGGCAXWA BASED(ACBUAPTR);/*          @X04SVRL*/
*                     IF ACBCAT=ON THEN/* IF CATALOG         @X04SVRL*/
         L     @14,ACBPT                                           0475
         TM    ACBCAT(@14),B'00010000'                             0475
         BNO   @RF00475                                            0475
*                       IF RECOVCAT=ON THEN/* CATLG RECOVER BIT ON 0476
*                                                            @X04SVRL*/
         TM    RECOVCAT(@15),B'00001000'                           0476
         BNO   @RF00476                                            0476
*                         CAXF2REC=ON;/* INDICATE CATLG RECOVERY   0477
*                                                            @X04SVRL*/
         L     @01,ACBUAPTR(,@14)                                  0477
         OI    CAXF2REC(@01),B'00000010'                           0477
*                     CTATTRA=DSATTR1;/* INIT DS OPTIONS     @X04SVGP*/
@RF00476 DS    0H                                                  0478
@RF00475 L     @15,RCOREF                                          0478
         L     @14,CTGFLPT(,CTGFLPTR)                              0478
         MVC   CTATTRA(1,@15),DSATTR1(@14)                         0478
*                     IF NUSE=ON THEN/* UNUSABLE DS          @X04SVGP*/
         TM    NUSE(@14),B'00000001'                               0479
         BNO   @RF00479                                            0479
*                       CTUNUSE=ON; /* YES, FLAG IN WA       @X04SVGP*/
         OI    CTUNUSE(@15),B'00000001'                            0480
*                     IF DSOPINDX=ON THEN/* DS OPEN          @X04SVGP*/
@RF00479 L     @01,CTGFLPT(,CTGFLPTR)                              0481
         TM    DSOPINDX(@01),B'10000000'                           0481
         BNO   @RF00481                                            0481
*                       CTOPEN=ON;  /* YES, REFLECT IN CAT W.A.      */
         L     @01,RCOREF                                          0482
         OI    CTOPEN(@01),B'10000000'                             0482
*                     IF CROSSREG=SHRF|JFCSHARE=OFF THEN/* FULL    0483
*                                      INTEGRITY OR NOT SHAREABLE  0483
*                                                            @ZA07533*/
@RF00481 L     @01,CTGFLPT(,CTGFLPTR)                              0483
         TM    CROSSREG(@01),B'11000000'                           0483
         BZ    @RT00483                                            0483
         L     @01,OPWCOMWA(,RCORE)                                0483
         TM    JFCSHARE+100(@01),B'00001000'                       0483
         BNZ   @RF00483                                            0483
@RT00483 DS    0H                                                  0484
*                       CTSHRF=ON;  /* YES                   @X04SVGP*/
         L     @01,RCOREF                                          0484
         OI    CTSHRF(@01),B'00100000'                             0484
*                     ELSE          /* NO,                   @X04SVGP*/
*                       DO;         /*                       @X04SVGP*/
         B     @RC00483                                            0485
@RF00483 DS    0H                                                  0486
*                         IF CROSSREG=SHRW THEN/* WRITE INTEGRITY    */
         L     @01,CTGFLPT(,CTGFLPTR)                              0486
         TM    CROSSREG(@01),B'01000000'                           0486
         BNO   @RF00486                                            0486
         TM    CROSSREG(@01),B'10000000'                           0486
         BNZ   @RF00486                                            0486
*                           CTSHRW=ON;/* YES                 @X04SVGP*/
         L     @01,RCOREF                                          0487
         OI    CTSHRW(@01),B'01000000'                             0487
*                         ELSE      /* NO,                   @X04SVGP*/
*                           DO;     /*                       @X04SVGP*/
         B     @RC00486                                            0488
@RF00486 DS    0H                                                  0489
*                             IF CROSSREG=SHR THEN/* FULL SHARE    0489
*                                                            @X04SVGP*/
         L     @01,CTGFLPT(,CTGFLPTR)                              0489
         TM    CROSSREG(@01),B'10000000'                           0489
         BNO   @RF00489                                            0489
         TM    CROSSREG(@01),B'01000000'                           0489
         BNZ   @RF00489                                            0489
*                               CTSHARE=ON;/* YES            @X04SVGP*/
         L     @01,RCOREF                                          0490
         OI    CTSHARE(@01),B'10000000'                            0490
*                             ELSE  /* NO,                   @X04SVGP*/
*                               CTHELP=ON;/* INVALIDATE BFRS @X04SVGP*/
         B     @RC00489                                            0491
@RF00489 L     @01,RCOREF                                          0491
         OI    CTHELP(@01),B'00010000'                             0491
*                           END;    /*                       @X04SVGP*/
@RC00489 DS    0H                                                  0493
*                       END;        /*                       @X04SVGP*/
@RC00486 DS    0H                                                  0494
*                     IF CROSSSYS=HELP&JFCSHARE=ON THEN/* SHARED DASD
*                                      BFR INVALIDATION AND SHARE  0494
*                                      SPECIFIED             @ZA07533*/
@RC00483 L     @01,CTGFLPT(,CTGFLPTR)                              0494
         TM    CROSSSYS(@01),B'00110000'                           0494
         BNO   @RF00494                                            0494
         L     @01,OPWCOMWA(,RCORE)                                0494
         TM    JFCSHARE+100(@01),B'00001000'                       0494
         BNO   @RF00494                                            0494
*                       CTSDHELP=ON;/* YES                   @X04SVGP*/
         L     @01,RCOREF                                          0495
         OI    CTSDHELP(@01),B'00001000'                           0495
*                     IF INTERDS=ON THEN/* IF INTERNAL DATA SET    0496
*                                                            @Z40WSRL*/
@RF00494 L     @01,CTGFLPT(,CTGFLPTR)                              0496
         TM    INTERDS(@01),B'00000010'                            0496
         BNO   @RF00496                                            0496
*                       CTINTDS=ON; /* INDICATE IN AMBWRK    @Z40WSRL*/
         L     @02,RCOREF                                          0497
         OI    CTINTDS(@02),B'00000010'                            0497
*                     CTGFLPTR=CTGFIELD(3);/* NXT FIELD      @X04SVGP*/
@RF00496 L     @01,CTGPLPTR                                        0498
         L     CTGFLPTR,CTGFIELD+8(,@01)                           0498
*                     IF CTGFLPT(1)^=0 THEN/* 3RD LOCATE GOOD      0499
*                                                            @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0499
         LTR   @15,@15                                             0499
         BZ    @RF00499                                            0499
*                       DO;         /*                       @X04SVGP*/
*                         R9=LENGTH(IDAAMDSB);/* YES, LENGTH OF AMDSB
*                                                            @X04SVGP*/
         LA    R9,96                                               0501
*                         CTAMDSB(1:R9)=AMDSBCAT(1:R9);/* INIT AMDSB
*                                                            @X04SVGP*/
         L     @14,RCOREF                                          0502
         LR    @11,R9                                              0502
         BCTR  @11,0                                               0502
         EX    @11,@SM03928                                        0502
*                         RESPECIFY                                0503
*                           IDAAMDSB BASED(ADDR(CTAMDSB));         0503
*                         CTCISIZ=AMDCINV;/*                 @X04SVGP*/
         L     @02,AMDCINV+132(,@14)                               0504
         ST    @02,CTCISIZ(,@14)                                   0504
*                         CALL MERGVOL;/*                    @X04SVGP*/
         BAL   @14,MERGVOL                                         0505
*                         IF PPCODE=0 THEN/* PROBLEM CODE IS ZERO  0506
*                                                            @X04SVRL*/
         CLI   PPCODE,0                                            0506
         BNE   @RF00506                                            0506
*                           DO;     /*                       @X04SVGP*/
*                             DSNCI=DSNICI;/* CURRENT CI NBR IS INDX
*                                                            @X04SVGP*/
         MVC   DSNCI(3),DSNICI                                     0508
*                             RCOREF=INDXWAPT;/*             @X04SVGP*/
         L     @02,PARMPT                                          0509
         L     @02,INDXWAPT(,@02)                                  0509
         ST    @02,RCOREF                                          0509
*                           END;    /*                       @X04SVGP*/
*                       END;        /*                       @X04SVGP*/
*                     ELSE          /* 3RD LOCATE NOT GOOD   @X04SVRL*/
*                       PPCODE=PP32;/* ERROR RETURN          @X04SVGP*/
         B     @RC00499                                            0512
@RF00499 MVI   PPCODE,X'20'                                        0512
*                   END;            /*                       @X04SVGP*/
*                 ELSE              /* 2ND LOCATE NOT GOOD   @X04SVRL*/
*                   PPCODE=PP32;    /* ERROR RETURN          @X04SVGP*/
         B     @RC00472                                            0514
@RF00472 MVI   PPCODE,X'20'                                        0514
*               END;                /*                       @X04SVGP*/
*             ELSE                  /* 1ST LOCATE NO GOOD    @X04SVRL*/
*               PPCODE=PP32;        /* ERROR RETURN          @X04SVGP*/
         B     @RC00463                                            0516
@RF00463 MVI   PPCODE,X'20'                                        0516
*           END;                    /*                       @X04SVGP*/
@RC00463 DS    0H                                                  0518
*       END;                        /*                       @X04SVGP*/
@RF00460 LA    @02,1                                               0518
         AL    @02,CTRB                                            0518
@DE00446 ST    @02,CTRB                                            0518
         SLR   @15,@15                                             0518
         IC    @15,MEMNUM                                          0518
         CR    @02,@15                                             0518
         BNH   @DL00446                                            0518
@DC00446 DS    0H                                                  0519
*     END;                          /*                       @X04SVGP*/
*   RET=RSAVLA;                     /* RESTORE RETURN REG    @X04SVGP*/
@RF00433 L     RET,RSAVLA                                          0520
*   END LOC2;                       /* RETURN TO CALLER      @X04SVGP*/
@EL00003 DS    0H                                                  0521
@EF00003 DS    0H                                                  0521
@ER00003 BR    @14                                                 0521
*CLMAIN:                                                           0522
*                                                                  0522
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - UPDATE THE CATALOG STATISTICS AND HIGH RBA     */
*/*                   INFORMATION.  RESET THE OPEN INDICATOR IF      */
*/*                   REQUIRED.                                      */
*/*                                                                  */
*/*     01 INPUT    - ARDB'S, AMB, AND AMDSB                         */
*/*                                                                  */
*/*     01 OUTPUT   - CATALOG IS UPDATED TO REFLECT ALL PROCESSING   */
*/*                   THAT HAS OCCURRED.                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0522
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0522
CLMAIN   DS    0H                                                  0523
*   RSAVLB=RET;                     /* SAVE RETURN REG               */
         ST    RET,RSAVLB                                          0523
*   PPFUNC=PDF6;                    /* FUNCTION ID           @X04SVGP*/
         MVI   PPFUNC,X'06'                                        0524
*   RESPECIFY                                                      0525
*     IDAARDB BASED(R6);                                           0525
*   RESPECIFY                                                      0526
*     IDAAMDSB BASED(AMBDSB);                                      0526
*   CALL LOCSTAT;                   /* SET UP TO LOCATE STATISTICS 0527
*                                      AND DSNAME                    */
         BAL   @14,LOCSTAT                                         0527
*   CALL CTINTRFC;                  /* LOCATE INFO FROM CATALOG      */
         BAL   @14,CTINTRFC                                        0528
*   CTR=1;                          /* START UPDATES AT 1ST FL CHN   */
         LA    CTR,1                                               0529
*   CALL UPSTAT;                    /* SET UP TO UPDATE STATISTICS   */
         BAL   @14,UPSTAT                                          0530
*   CTR=CTR+1;                      /* INDICATE NEXT FL CHAIN        */
         AL    CTR,@CF00053                                        0531
*   IF OUTBIT=OFF THEN              /* OUTPUT REQUEST POSSIBLE       */
         L     @11,AMBWKA(,R5)                                     0532
         TM    OUTBIT(@11),B'10000000'                             0532
         BNZ   @RF00532                                            0532
*     CALL CTINTRFC;                /* NO, UPDATE STATISTICS ONLY    */
         BAL   @14,CTINTRFC                                        0533
*   ELSE                            /* YES, CONTINUE TO              */
*     DO;                           /* UPDATE HI RBAS & OPEN       0534
*                                      INDICATOR                     */
         B     @RC00532                                            0534
@RF00532 DS    0H                                                  0535
*       R6=AMDPARDB;                /* PT TO 1ST ARDB                */
         L     @11,AMBDSB(,R5)                                     0535
         L     R6,AMDPARDB(,@11)                                   0535
*       CALL UPDSHI;                /* SET UP TO UPDATE DS HI RBA    */
         BAL   @14,UPDSHI                                          0536
*       CTR=CTR+1;                  /* INDICATE NEXT FL CHAIN        */
         AL    CTR,@CF00053                                        0537
*       CALL UPOBIT;                /* SET UP TO UPDATE OPEN IND.    */
         BAL   @14,UPOBIT                                          0538
*       CTR=CTR+1;                  /* NEXT FL CHAIN                 */
         AL    CTR,@CF00053                                        0539
*       R6=AMDPARDB;                /* PT TO FIRST ARDB              */
         L     @11,AMBDSB(,R5)                                     0540
         L     R6,AMDPARDB(,@11)                                   0540
*       DO WHILE R6^=0;             /* PROCESS ALL ARDB'S            */
         B     @DE00541                                            0541
@DL00541 DS    0H                                                  0542
*         CALL UPKRHI;              /* SET UP TO UPDATE KR HI RBAS   */
         BAL   @14,UPKRHI                                          0542
*         IF CTR=>6 THEN            /* WAS PARAMETER LIST FILLED   0543
*                                                            @XA03610*/
         C     CTR,@CF00040                                        0543
         BL    @RF00543                                            0543
*           DO;                     /* YES,                  @XA03610*/
*             CALL CTINTRFC;        /* UPDATE CATALOG        @XA03610*/
         BAL   @14,CTINTRFC                                        0545
*             CTR=1;                /* RESET TO 1ST FL CHAIN @XA03610*/
         LA    CTR,1                                               0546
*           END;                    /* END CATALOG UPDATE    @XA03610*/
*         ELSE                      /* PARAMETER LIST NOT FILLED   0548
*                                                            @XA03610*/
*           ;                                                      0548
@RF00543 DS    0H                                                  0549
*       END;                        /* END IF ALL ARDB'S PROCESSED 0549
*                                                            @XA03610*/
@DE00541 LTR   R6,R6                                               0549
         BNZ   @DL00541                                            0549
*       R6=AMDPARDB;                /* PT TO FIRST ARDB      @XA03610*/
         L     @11,AMBDSB(,R5)                                     0550
         L     R6,AMDPARDB(,@11)                                   0550
*       DO WHILE R6^=0;             /* PROCESS ALL ARDB'S    @XA03610*/
         B     @DE00551                                            0551
@DL00551 DS    0H                                                  0552
*         CALL UPKYHI;              /* SET UP TO UPDATE HI KEY RBAS
*                                                            @XA03610*/
         BAL   @14,UPKYHI                                          0552
*         CALL CTINTRFC;            /* UPDATE CATALOG        @XA03610*/
         BAL   @14,CTINTRFC                                        0553
*         CTR=1;                    /* RESET TO 1ST FL CHAIN @XA03610*/
         LA    CTR,1                                               0554
*       END;                        /* END IF ALL ARDB'S PROCESSED 0555
*                                                            @XA03610*/
@DE00551 LTR   R6,R6                                               0555
         BNZ   @DL00551                                            0555
*     END;                                                         0556
*   RET=RSAVLB;                     /* RESTORE RETURN REG            */
@RC00532 L     RET,RSAVLB                                          0557
*   END CLMAIN;                                                    0558
@EL00004 DS    0H                                                  0558
@EF00004 DS    0H                                                  0558
@ER00004 BR    @14                                                 0558
*VLTSTMP:                                                          0559
*                                                                  0559
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - LOCATE VOLUME TIME STAMPS                      */
*/*                                                                  */
*/*     01 INPUT    - CALLER'S PARAMETER LIST CONTAINING THE VOLUME  */
*/*                   SERIAL NBRS FOR WHICH TIME STAMPS ARE DESIRED. */
*/*                   ADDRESS OF CATALOG ACB.                        */
*/*                                                                  */
*/*     02 OUTPUT   - CALLER'S PARAMETER LIST IS UPDATED TO REFLECT  */
*/*                   THE TIME STAMPS ASSOCIATED WITH EACH SPECIFIED */
*/*                   VOLUME                                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0559
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0559
VLTSTMP  DS    0H                                                  0560
*   RSAVLB=RET;                                                    0560
         ST    RET,RSAVLB                                          0560
*   PPFUNC=PDF7;                    /* FUNCTION ID           @X04SVGP*/
*                                                                  0561
         MVI   PPFUNC,X'07'                                        0561
*   /*****************************************************************/
*   /*                                                               */
*   /* INIT LOCATE/UPDATE DESCRIPTOR                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0562
*   NAME6=ON;                       /* INDICATE VOL SER ENTRY        */
*   VMT=ON;                         /* VOL TIME STAMP RETRIEVAL      */
         OI    NAME6,B'01000100'                                   0563
*   DSCATACB=VLCATACB;              /* COPY CATALOG ACB PTR          */
         L     @02,PARMPT                                          0564
         L     @02,VLCATACB(,@02)                                  0564
         ST    @02,DSCATACB                                        0564
*   FLACTIVE(1,1)=ON;               /* ACTIVE FIELD                  */
         OI    FLACTIVE,B'10000000'                                0565
*   FLNAME(1,1)='VOLTSTMP';         /* FIELD FOR VOLUME TIME STAMP   */
         MVC   FLNAME(8),@CC03795                                  0566
*   DO CTRB=1 TO VLENTNO;           /* PROCESS ALL VOLSER'S PASSED   */
         LA    @02,1                                               0567
         B     @DE00567                                            0567
@DL00567 DS    0H                                                  0568
*     DSNVLSER=VLSER(CTRB);                                        0568
         MH    @02,@CH03906                                        0568
         L     @01,PARMPT                                          0568
         ALR   @01,@02                                             0568
         BCTR  @01,0                                               0568
         BCTR  @01,0                                               0568
         MVC   DSNVLSER(6),VLSER-12(@01)                           0568
*     CALL CTINTRFC;                /* LOCATE TS THIS VOL            */
         BAL   @14,CTINTRFC                                        0569
*     CTGFLPTR=CTGFIELD(1);         /* ADDRESSABILITY 1ST FIELD      */
         L     @01,CTGPLPTR                                        0570
         L     CTGFLPTR,CTGFIELD(,@01)                             0570
*     IF CTGFLPT(1)^=0 THEN         /* TIME STAMP RETURNED?          */
         L     @15,CTGFLPT(,CTGFLPTR)                              0571
         LTR   @15,@15                                             0571
         BZ    @RF00571                                            0571
*       VLTS(CTRB)=VLTSFA;          /* YES, MOVE TO CALLER AREA      */
         L     @14,CTRB                                            0572
         MH    @14,@CH03906                                        0572
         L     @01,PARMPT                                          0572
         ALR   @01,@14                                             0572
         MVC   VLTS-14(8,@01),VLTSFA(@15)                          0572
*   END;                                                           0573
@RF00571 LA    @02,1                                               0573
         AL    @02,CTRB                                            0573
@DE00567 ST    @02,CTRB                                            0573
         L     @01,PARMPT                                          0573
         CH    @02,VLENTNO(,@01)                                   0573
         BNH   @DL00567                                            0573
*   RET=RSAVLB;                                                    0574
         L     RET,RSAVLB                                          0574
*   END VLTSTMP;                                                   0575
@EL00005 DS    0H                                                  0575
@EF00005 DS    0H                                                  0575
@ER00005 BR    @14                                                 0575
*PREFORM:                                                          0576
*                                                                  0576
*/********************************************************************/
*/*                                                                  */
*/*    01 FUNCTION - UPDATE THE PREFORMAT INDICATOR IN THE CATALOG.  */
*/*                  THE ARDB'S ARE SCANNED, AND, IF ONE IS FOUND    */
*/*                  WITH THE PREFORMAT INDICATOR ON THE BIT IS RESET*/
*/*                  IN THE ARDB AS WELL AS THE CORRESPONDING KEY    */
*/*                  RANGE ENTRY IN THE CATALOG.                     */
*/*                                                                  */
*/*    01 INPUT    - AMB, AMDSB, ARDB'S                              */
*/*                                                                  */
*/*    02 OUTPUT   - PREFORMAT  INDICATOR RESET IN ARDB'S AND ALSO   */
*/*                  IN CORRESPONDING CATALOG KEY RANGE ENTRY        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0576
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0576
PREFORM  DS    0H                                                  0577
*   RSAVLB=RET;                                                    0577
         ST    RET,RSAVLB                                          0577
*   PPFUNC=PDF9;                    /* INIT FUNCTION ID      @X04SVGP*/
         MVI   PPFUNC,X'09'                                        0578
*   UPD=ON;                         /* INDICATE CATALOG UPDATE       */
*   ID3=ON;                         /* USING CI INTERFACE TO CAT     */
         OI    UPD,B'00101000'                                     0580
*   DSCATACB=AMBCACB;               /* ADDRESS OF CATALOG ACB        */
         L     @02,AMBCACB(,R5)                                    0581
         ST    @02,DSCATACB                                        0581
*   DSNCI=AMBDDSN;                  /* CI OF DATA SET                */
         MVC   DSNCI(3),AMBDDSN(R5)                                0582
*   RESPECIFY                                                      0583
*     IDAARDB BASED(R6);                                           0583
*   RESPECIFY                                                      0584
*     IDAAMDSB BASED(AMBDSB);                                      0584
*   R6=AMDPARDB;                    /* PT TO 1ST ARDB                */
         L     @02,AMBDSB(,R5)                                     0585
         L     R6,AMDPARDB(,@02)                                   0585
*   DO WHILE R6^=0;                 /* PROCESS ALL ARDB'S            */
         B     @DE00586                                            0586
@DL00586 DS    0H                                                  0587
*     DO CTR=1 TO 6 WHILE R6^=0;    /* PROCESS 6 ARDB'S AT A TIME    */
         LA    CTR,1                                               0587
@DL00587 LTR   R6,R6                                               0587
         BZ    @DC00587                                            0587
*       IF CTR=1 THEN               /* FIRST ARDB                    */
         C     CTR,@CF00053                                        0588
         BNE   @RF00588                                            0588
*         CALL CLUPDESR;            /* CLEAR UPDATE DESCRIPTOR RECORD*/
         BAL   @14,CLUPDESR                                        0589
*       DO WHILE(R6^=0&ARDPRFMT=OFF);/* SCAN ARDB'S FOR PREFORMAT ON */
@RF00588 B     @DE00590                                            0590
@DL00590 DS    0H                                                  0591
*         R6=ARDNPTR;               /* PT NEXT ARDB 2                */
         L     R6,ARDNPTR(,R6)                                     0591
*       END;                                                       0592
@DE00590 LTR   R6,R6                                               0592
         BZ    @DC00590                                            0592
         TM    ARDPRFMT(R6),B'01000000'                            0592
         BZ    @DL00590                                            0592
@DC00590 DS    0H                                                  0593
*       IF R6^=0 THEN               /* ARDB CHAIN EXHAUSTED          */
         LTR   R6,R6                                               0593
         BZ    @RF00593                                            0593
*         DO;                       /* NO, THEN ARDPRFMT MUST BE ON  */
*           ARDPRFMT=OFF;           /* TURN OFF PRFMT INDICATOR      */
         NI    ARDPRFMT(R6),B'10111111'                            0595
*           FLACTIVE(CTR,1)=ON;     /* FIELD IS ACTIVE               */
         LR    @11,CTR                                             0596
         MH    @11,@CH00144                                        0596
         LA    @02,FLACTIVE-60(@11)                                0596
         OI    0(@02),B'10000000'                                  0596
*           FLNAME(CTR,1)='ITYPEXT ';/* BYTE TO BE UPDATED IN CAT    */
         LA    @02,FLNAME-60(@11)                                  0597
         MVC   0(8,@02),@CC03801                                   0597
*           FLTSTPTR(CTR,1)=ADDR(ARDPRF);/* REPLACEMENT BYTE IN CORE */
         LA    @02,ARDPRF(,R6)                                     0598
         ST    @02,FLTSTPTR-60(@11)                                0598
*           FLTSTLEN(CTR,1)=LENGTH(ARDPRF);/* LENGTH OF UPDATE DATA  */
         LA    @02,8                                               0599
         ST    @02,FLTSTLEN-60(@11)                                0599
*           FLACTIVE(CTR,2)=ON;     /* TEST FIELD ACTIVE             */
         LA    @02,FLACTIVE-40(@11)                                0600
         OI    0(@02),B'10000000'                                  0600
*           FLNAME(CTR,2)='RELREPNO';/* RELATIVE REP NBR IS TESTED   */
         LA    @02,FLNAME-40(@11)                                  0601
         MVC   0(8,@02),@CC03802                                   0601
*           FLTSTPTR(CTR,2)=ADDR(ARDRELNO);/* AGAINST VOL OCCURRENCE
*                                      NBR                           */
         LA    @02,ARDRELNO(,R6)                                   0602
         ST    @02,FLTSTPTR-40(@11)                                0602
*           FLTSTLEN(CTR,2)=LENGTH(ARDRELNO);/* INIT LENGTH OF TEST
*                                      DATA                          */
         LA    @02,2                                               0603
         ST    @02,FLTSTLEN-40(@11)                                0603
*           FLCOND(CTR,2)=CTGFLDEQ; /* UPDATE THIS OCCURRENCE ONLY   */
         LA    @02,FLCOND-40(@11)                                  0604
         MVI   0(@02),X'80'                                        0604
*           R6=ARDNPTR;             /* PT TO NEXT ARDB               */
         L     R6,ARDNPTR(,R6)                                     0605
*         END;                                                     0606
*     END;                                                         0607
@RF00593 AL    CTR,@CF00053                                        0607
         C     CTR,@CF00040                                        0607
         BNH   @DL00587                                            0607
@DC00587 DS    0H                                                  0608
*     IF FLACTIVE(1,1)=ON THEN      /* ANY FIELDS ACTIVE             */
         TM    FLACTIVE,B'10000000'                                0608
         BNO   @RF00608                                            0608
*       DO;                         /* YES,                          */
*         CALL CTINTRFC;            /* UPDATE CATALOG                */
         BAL   @14,CTINTRFC                                        0610
*         IF PPCODE^=0 THEN         /* ERRORS                        */
         CLI   PPCODE,0                                            0611
         BE    @RF00611                                            0611
*           R6=0;                   /* YES, END LOOP                 */
         SLR   R6,R6                                               0612
*       END;                                                       0613
@RF00611 DS    0H                                                  0614
*   END;                                                           0614
@RF00608 DS    0H                                                  0614
@DE00586 LTR   R6,R6                                               0614
         BNZ   @DL00586                                            0614
*   RET=RSAVLB;                                                    0615
         L     RET,RSAVLB                                          0615
*   END PREFORM;                                                   0616
@EL00006 DS    0H                                                  0616
@EF00006 DS    0H                                                  0616
@ER00006 BR    @14                                                 0616
*RCMUPD:                                                           0617
*                                                                  0617
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - UPDATE THE CATALOG AMDSB STATISTICS            */
*/*                                                                  */
*/*     01 INPUT    - AMB, AMDSB                                     */
*/*                                                                  */
*/*     01 OUTPUT   - CATALOG AMDSB STATISTICS ARE UPDATED. THE      */
*/*                   STATISTICS SAVED BY OPEN ARE UPDATED TO THE    */
*/*                   SAME CATALOG VALUES                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0617
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0617
RCMUPD   DS    0H                                                  0618
*   RSAVLB=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLB                                          0618
*   PPFUNC=PDF8;                    /* SET FUNCTION CODE     @X04SVGP*/
         MVI   PPFUNC,X'08'                                        0619
*   CALL LOCSTAT;                   /* SET UP LOCATE STATISTICS      */
         BAL   @14,LOCSTAT                                         0620
*   CALL CTINTRFC;                  /* LOCATE STATISTICS             */
         BAL   @14,CTINTRFC                                        0621
*   CTR=1;                          /* SET COUNTER FOR UPSTAT        */
         LA    CTR,1                                               0622
*   CALL UPSTAT;                    /* SET UP TO UPDATE STATISTICS   */
         BAL   @14,UPSTAT                                          0623
*   CALL CTINTRFC;                  /* UPDATE AMDSB                  */
         BAL   @14,CTINTRFC                                        0624
*   RET=RSAVLB;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLB                                          0625
*   END RCMUPD;                                                    0626
@EL00007 DS    0H                                                  0626
@EF00007 DS    0H                                                  0626
@ER00007 BR    @14                                                 0626
*OPOBIT:                                                           0627
*                                                                  0627
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - UPDATE THE DATA SET OPEN INDICATOR             */
*/*                                                                  */
*/*     01 INPUT    - AMB, 1 BYTE VALUE PASSED BY CALLER TO REPLACE  */
*/*                   EXISTING OPEN INDICATOR BYTE IN CATALOG        */
*/*                                                                  */
*/*     01 OUTPUT   - UPDATED  CATALOG OPEN INDICATOR                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0627
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0627
OPOBIT   DS    0H                                                  0628
*   RSAVLB=RET;                                                    0628
         ST    RET,RSAVLB                                          0628
*   PPFUNC=PDF5;                    /* FUNCTION ID           @X04SVGP*/
         MVI   PPFUNC,X'05'                                        0629
*   UPD=ON;                         /* INDICATE UPDATE REQUEST       */
*   ID3=ON;                         /* INDICATE UPDATE BY CI         */
         OI    UPD,B'00101000'                                     0631
*   FLACTIVE(1,1)=ON;               /* INDICATE FIELD ACTIVE         */
         OI    FLACTIVE,B'10000000'                                0632
*   FLNAME(1,1)='OPENIND ';         /* FIELD FOR OPEN INDICATOR      */
         MVC   FLNAME(8),@CC03809                                  0633
*   FLTSTPTR(1,1)=ADDR(OPENSET);    /* INIT PTR TO UPDATE VALUE      */
         LA    @02,4                                               0634
         AL    @02,PARMPT                                          0634
         ST    @02,FLTSTPTR                                        0634
*   FLTSTLEN(1,1)=LENGTH(OPENSET);  /* INIT LENGTH OF UPDATE DATA    */
         MVC   FLTSTLEN(4),@CF00053                                0635
*   DSCATACB=AMBCACB;               /* INIT PTR TO CAT ACB           */
         L     @02,AMBCACB(,R5)                                    0636
         ST    @02,DSCATACB                                        0636
*   DSNCI=AMBDDSN;                  /* INIT DATA SET CINBR           */
         MVC   DSNCI(3),AMBDDSN(R5)                                0637
*   CALL CTINTRFC;                  /* UPDATE OPEN INDICATOR         */
         BAL   @14,CTINTRFC                                        0638
*   RET=RSAVLB;                     /* RESTORE RETURN REG            */
         L     RET,RSAVLB                                          0639
*   END OPOBIT;                     /* RETURN TO CALLER              */
@EL00008 DS    0H                                                  0640
@EF00008 DS    0H                                                  0640
@ER00008 BR    @14                                                 0640
*OPPSWD:                                                           0641
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0641
*                                                                  0641
OPPSWD   DS    0H                                                  0642
*/********************************************************************/
*/*                                                                  */
*/*  01 FUNCTION - PERFORM MASTER LEVEL AUTHORIZATION CHECK ON EVERY */
*/*                DATA SET RESIDING WITHIN THE SPECIFIED DATA SPACE */
*/*                                                                  */
*/*  01 INPUT    - DATA SPACE NAME AND ASSOCIATED VOLUME SERIAL NBR  */
*/*                PASSED BY CALLER                                  */
*/*                                                                  */
*/*  01 OUTPUT   - MASTER LEVEL AUTHORIZATION VERIFIED FOR ALL DATA  */
*/*                SETS                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0642
*   RSAVLA=RET;                                                    0642
         ST    RET,RSAVLA                                          0642
*   NAME6=ON;                       /* LOCATE BY VOL SER NBR         */
         OI    NAME6,B'01000000'                                   0643
*   FLACTIVE(1,1)=ON;               /* ACTIVATE LOCATE ELEMENT       */
         OI    FLACTIVE,B'10000000'                                0644
*   FLNAME(1,1)='GENDSP  ';         /* INIT SYMBLLIC FIELD NAME      */
         MVC   FLNAME(8),@CC03813                                  0645
*   DSNVLSER=DTASPVOL;              /* INIT VOL SER NBR              */
         L     @02,PARMPT                                          0646
         L     @01,DSPVLPT(,@02)                                   0646
         MVC   DSNVLSER(6),DTASPVOL(@01)                           0646
*   FLTSTPTR(1,1)=DSPPT;            /* INIT PTR TO DATA SAACE NAME   */
         L     @02,DSPPT(,@02)                                     0647
         ST    @02,FLTSTPTR                                        0647
*   CALL CTINTRFC;                  /* LOCATE CI INFORMATION         */
         BAL   @14,CTINTRFC                                        0648
*   IF PPCODE=0 THEN                /* ANY ERRORS                    */
         CLI   PPCODE,0                                            0649
         BNE   @RF00649                                            0649
*     DO;                           /* NO,                           */
*       CTGFLPTR=CTGFIELD(1);       /* INIT CURRENT FIELD PTR        */
         L     @01,CTGPLPTR                                        0651
         L     CTGFLPTR,CTGFIELD(,@01)                             0651
*       IF CTGFLPT(1)^=DSPPT&       /* DID CATALOG RETURN ANY        */
*           CTGFLPT(1)^=0 THEN      /* CI NUMBERS                    */
         L     @15,CTGFLPT(,CTGFLPTR)                              0652
         L     @14,PARMPT                                          0652
         C     @15,DSPPT(,@14)                                     0652
         BE    @RF00652                                            0652
         LTR   @15,@15                                             0652
         BZ    @RF00652                                            0652
*         DO;                       /* YES,                          */
*           DSPCIPT1=CTGFLPT(1);    /* INIT BASE FOR ACB PTR,        */
         ST    @15,DSPCIPT1                                        0654
*           DSPCIPT2=CTGFLPT(1)+LENGTH(DSPCI);/* LENGTH AND CI NBRS  */
         AL    @15,@CF00040                                        0655
         ST    @15,DSPCIPT2                                        0655
*           CALL MSTRVER;           /* VERIFY MASTER LEVEL FOR ALL   */
         BAL   @14,MSTRVER                                         0656
*         END;                      /* CI NBRS                       */
*     END;                                                         0658
@RF00652 DS    0H                                                  0659
*   RET=RSAVLA;                                                    0659
@RF00649 L     RET,RSAVLA                                          0659
*MSTRVER:                                                          0660
*                                                                  0660
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM MASTER LEVEL AUTHORIZATION CHK ON ALL DATA SETS       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0660
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0660
         B     @PB00010                                            0660
MSTRVER  DS    0H                                                  0661
*   RSAVLB=RET;                                                    0661
         ST    RET,RSAVLB                                          0661
*   CALL CLUPDESR;                  /* CLEAR UPDATE DESCRIPTOR RECORD*/
         BAL   @14,CLUPDESR                                        0662
*   ID3=ON;                         /* LOCATE BY CI NBR              */
*   NAME6=OFF;                      /* RESET VOL LOC FLG     @XA04272*/
         OI    ID3,B'00100000'                                     0664
         NI    NAME6,B'10111111'                                   0664
*   FLACTIVE(1,1)=ON;               /* ACTIVATE LOCATE ELEMENT       */
         OI    FLACTIVE,B'10000000'                                0665
*   FLNAME(1,1)='PASSATMP';         /* INIT SYMBOLIC FIELD NAME    0666
*                                                            @XA04272*/
         MVC   FLNAME(8),@CC03818                                  0666
*   DSCATACB=DSPACBPT;              /* INIT CAT ACB PTR              */
         L     @02,DSPCIPT1                                        0667
         L     @02,DSPACBPT(,@02)                                  0667
         ST    @02,DSCATACB                                        0667
*   PSWRD=ON;                       /* PERFORM AUTHORIZATION CHK     */
         OI    PSWRD,B'00000010'                                   0668
*   DO CTRB=1 TO DSPCILEN/LENGTH(DSPCINUM(1)) WHILE PPCODE=0;      0669
         LA    @02,1                                               0669
         B     @DE00669                                            0669
@DL00669 CLI   PPCODE,0                                            0669
         BNE   @DC00669                                            0669
*     DSNCI=DSPCINUM(CTRB);         /* INIT NEXT CI NBR              */
         MH    @02,@CH00032                                        0670
         L     @01,DSPCIPT2                                        0670
         ALR   @01,@02                                             0670
         AL    @01,@CF03931                                        0670
         MVC   DSNCI(3),DSPCINUM(@01)                              0670
*     CALL CTINTRFC;                /* LOCATE CAUSES MASTER LEVEL  0671
*                                      AUTHORIZATION VERIFICATION    */
         BAL   @14,CTINTRFC                                        0671
*   END;                                                           0672
         LA    @02,1                                               0672
         AL    @02,CTRB                                            0672
@DE00669 ST    @02,CTRB                                            0672
         L     @01,DSPCIPT1                                        0672
         LH    @00,DSPCILEN(,@01)                                  0672
         SRDA  @00,32                                              0672
         D     @00,@CF00032                                        0672
         CR    @02,@01                                             0672
         BNH   @DL00669                                            0672
@DC00669 DS    0H                                                  0673
*   RET=RSAVLB;                                                    0673
         L     RET,RSAVLB                                          0673
*   END MSTRVER;                                                   0674
@EL00010 DS    0H                                                  0674
@EF00010 DS    0H                                                  0674
@ER00010 BR    @14                                                 0674
*   END OPPSWD;                                                    0675
@EL00009 DS    0H                                                  0675
@EF00009 DS    0H                                                  0675
@ER00009 BR    @14                                                 0675
*DUMLOC:                                                           0676
*                                                                  0676
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - THIS ROUTINE ISSUES A LOCATE WITH A DUMMY      */
*/*                   INDICATOR SET.  THIS INDICATES TO THE          */
*/*                   CATALOG ROUTINES THAT AN OPEN, CLOSE, OR       */
*/*                   EOV CONDITION HAS BEEN COMPLETED ON A          */
*/*                   CATALOG DATA SET.                              */
*/*                                                                  */
*/*     01 INPUT    - AMB, CAXWA                                     */
*/*                                                                  */
*/*     01 OUTPUT   - CATALOG ROUTINES HAVE BEEN NOTIFIED THAT NO    */
*/*                   FURTHER CATALOG REQUESTS WILL OCCUR            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0676
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0676
DUMLOC   DS    0H                                                  0677
*   RSAVLB=RET;                                                    0677
         ST    RET,RSAVLB                                          0677
*   DSNCI=0;                        /* INIT DATA CI                  */
         SLR   @02,@02                                             0678
         STCM  @02,7,DSNCI                                         0678
*   ID3=ON;                         /* LOCATE BY CI                  */
         OI    ID3,B'00100000'                                     0679
*   DSCATACB=AMBCACB;                                              0680
         L     @02,AMBCACB(,R5)                                    0680
         ST    @02,DSCATACB                                        0680
*   RESPECIFY                                                      0681
*     IGGCAXWA BASED(ACBUAPTR);     /* ADDRABILITY CAT WA            */
*   AMBCACB->ACBUAPTR->CAXCMP=ON;   /* INDICATE LAST OPEN LOCATE   0682
*                                                            @X04SVCJ*/
         L     @02,ACBUAPTR(,@02)                                  0682
         OI    CAXCMP(@02),B'00001000'                             0682
*   CALL CTINTRFC;                  /* ALLOW CATALOG TO FREE WA      */
         BAL   @14,CTINTRFC                                        0683
*   RET=RSAVLB;                                                    0684
         L     RET,RSAVLB                                          0684
*   END DUMLOC;                                                    0685
@EL00011 DS    0H                                                  0685
@EF00011 DS    0H                                                  0685
@ER00011 BR    @14                                                 0685
*CLNLOC:                            /*                       @X04SVGP*/
*/********************************************************************/
*/*                                                          @X04SVGP*/
*/*  01 FUNCTION - LOCATE 44 BYTE CLUSTER NAME ASSOCIATED    @X04SVGP*/
*/*                WITH INPUT AMB.                           @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*  01 INPUT    - PARAMETER LIST POINTED TO BY REG 1        @X04SVRL*/
*/*                                                          @X04SVRL*/
*/*  01 OUTPUT   - 44 BYTE CLUSTER NAME IN CALLER'S PARM     @X04SVGP*/
*/*                LIST                                      @X04SVGP*/
*/*                                                          @X04SVGP*/
*/********************************************************************/
*                                                                  0686
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVGP*/
CLNLOC   DS    0H                                                  0687
*   RSAVLB=RET;                     /*                       @X04SVGP*/
         ST    RET,RSAVLB                                          0687
*   PPFUNC=PDF10;                   /* INIT FUNCTION CODE    @X04SVGP*/
         MVI   PPFUNC,X'0A'                                        0688
*   ID3=ON;                         /* INDICATE LOCATE BY CI @X04SVGP*/
         OI    ID3,B'00100000'                                     0689
*   FLACTIVE(1,1)=ON;               /* INDICATE FIELD ACTIVE @X04SVGP*/
         OI    FLACTIVE,B'10000000'                                0690
*   FLNAME(1,1)='NAMEDS  ';         /* ASK FOR CLUSTER CI    @X04SVGP*/
         MVC   FLNAME(8),@CC03762                                  0691
*   DSCATACB=DSNCACB;               /* INIT CAT ACB ADDR     @X04SVRL*/
         L     @02,PARMPT                                          0692
         L     @15,DSNCACB(,@02)                                   0692
         ST    @15,DSCATACB                                        0692
*   DSNCI=DSNCINUM;                 /* INIT DS CI NBR        @X04SVRL*/
         MVC   DSNCI(3),DSNCINUM(@02)                              0693
*   CALL CTINTRFC;                  /* LOCATE ASSOCIATIONS   @X04SVGP*/
         BAL   @14,CTINTRFC                                        0694
*   IF PPCODE=0 THEN                /* ERROR                 @X04SVGP*/
         CLI   PPCODE,0                                            0695
         BNE   @RF00695                                            0695
*     DO;                           /* NO, CONTINUE          @X04SVGP*/
*       CTGFLPTR=CTGFIELD(1);       /* ADDR 1ST FIELD        @X04SVGP*/
         L     @01,CTGPLPTR                                        0697
         L     CTGFLPTR,CTGFIELD(,@01)                             0697
*       IF CTGFLPT(1)^=0 THEN       /* INFO RETURNED         @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0698
         LTR   @15,@15                                             0698
         BZ    @RF00698                                            0698
*         DO;                       /* YES, CONTINUE         @X04SVGP*/
*           FLNAME(1,1)='ENTNAME '; /* ASK FOR 44 BYTE DSN   @X04SVGP*/
         MVC   FLNAME(8),@CC03826                                  0700
*           DSNCI=NAME;             /* INIT CLUSTER CI       @X04SVGP*/
         MVC   DSNCI(3),NAME(@15)                                  0701
*           CALL CTINTRFC;          /* LOCATE NAME           @X04SVGP*/
         BAL   @14,CTINTRFC                                        0702
*           IF PPCODE=0 THEN        /* ERROR                 @X04SVGP*/
         CLI   PPCODE,0                                            0703
         BNE   @RF00703                                            0703
*             DO;                   /* GET CLUSTER NAME      @X04SVGP*/
*               CTGFLPTR=CTGFIELD(1);/* BASE FOR FIRST FIELD @X04SVGP*/
         L     @01,CTGPLPTR                                        0705
         L     CTGFLPTR,CTGFIELD(,@01)                             0705
*               IF CTGFLPT(1)^=0 THEN/* INFO RETURNED        @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0706
         LTR   @15,@15                                             0706
         BZ    @RF00706                                            0706
*                 RDSN=DSNFA;       /* YES, INIT DSN PRM LST @X04SVGP*/
         L     @01,PARMPT                                          0707
         MVC   RDSN(44,@01),DSNFA(@15)                             0707
*             END;                  /*                       @X04SVGP*/
@RF00706 DS    0H                                                  0709
*         END;                      /*                       @X04SVGP*/
@RF00703 DS    0H                                                  0710
*     END;                          /*                       @X04SVGP*/
@RF00698 DS    0H                                                  0711
*   RET=RSAVLB;                     /* RESTORE RETURN REG    @X04SVGP*/
@RF00695 L     RET,RSAVLB                                          0711
*   END CLNLOC;                     /*                       @X04SVGP*/
@EL00012 DS    0H                                                  0712
@EF00012 DS    0H                                                  0712
@ER00012 BR    @14                                                 0712
*ELNLOC:                            /*                       @X04SVGP*/
*/********************************************************************/
*/*                                                          @X04SVGP*/
*/*   01 FUNCTION - LOCATE 44 BYTE ELEMENTARY DATA SET NAME  @X04SVGP*/
*/*                 ASSOCIATED WITH INPUT AMB                @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*   01 INPUT    - PARAMETER LIST POINTED TO BY REG 1       @X04SVRL*/
*/*                                                          @X04SVGP*/
*/*   01 OUTPUT   - 44 BYTE ELEMENTARY DATA SET NAME IN      @X04SVGP*/
*/*                 CALLER'S PARM LIST                       @X04SVGP*/
*/*                                                          @X04SVGP*/
*/********************************************************************/
*                                                                  0713
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVGP*/
ELNLOC   DS    0H                                                  0714
*   RSAVLB=RET;                     /* SAVE RETURN REG       @X04SVGP*/
         ST    RET,RSAVLB                                          0714
*   PPFUNC=PDF11;                   /* INIT FUNCTION CODE    @X04SVGP*/
         MVI   PPFUNC,X'0B'                                        0715
*   ID3=ON;                         /* INDICATE LOCATE BY CI @X04SVGP*/
         OI    ID3,B'00100000'                                     0716
*   FLACTIVE(1,1)=ON;               /* INDICATE FIELD ACTIVE @X04SVGP*/
         OI    FLACTIVE,B'10000000'                                0717
*   FLNAME(1,1)='ENTNAME ';         /* ASK FOR 44 BYTE NAME  @X04SVGP*/
         MVC   FLNAME(8),@CC03826                                  0718
*   DSCATACB=DSNCACB;               /* INIT CATALOG ACB ADDR @X04SVGP*/
         L     @02,PARMPT                                          0719
         L     @15,DSNCACB(,@02)                                   0719
         ST    @15,DSCATACB                                        0719
*   DSNCI=DSNCINUM;                 /* INIT CI NBR           @X04SVGP*/
         MVC   DSNCI(3),DSNCINUM(@02)                              0720
*   CALL CTINTRFC;                  /* LOCATE DS NAME        @X04SVGP*/
         BAL   @14,CTINTRFC                                        0721
*   IF PPCODE=0 THEN                /* ERROR                 @X04SVGP*/
         CLI   PPCODE,0                                            0722
         BNE   @RF00722                                            0722
*     DO;                           /* NO, CONTINUE          @X04SVGP*/
*       CTGFLPTR=CTGFIELD(1);       /* ADDR 1ST FIELD        @X04SVGP*/
         L     @01,CTGPLPTR                                        0724
         L     CTGFLPTR,CTGFIELD(,@01)                             0724
*       IF CTGFLPT(1)^=0 THEN       /* INFO RETURNED         @X04SVGP*/
         L     @15,CTGFLPT(,CTGFLPTR)                              0725
         LTR   @15,@15                                             0725
         BZ    @RF00725                                            0725
*         RDSN=DSNFA;               /* YES, INIT 44 BYTE NAME      0726
*                                                            @X04SVGP
*                                      IN CALLER'S PARM LIST @X04SVGP*/
         L     @01,PARMPT                                          0726
         MVC   RDSN(44,@01),DSNFA(@15)                             0726
*     END;                          /*                       @X04SVGP*/
@RF00725 DS    0H                                                  0728
*   RET=RSAVLB;                     /* RESTORE RETURN REG    @X04SVGP*/
@RF00722 L     RET,RSAVLB                                          0728
*   END ELNLOC;                     /*                       @X04SVGP*/
@EL00013 DS    0H                                                  0729
@EF00013 DS    0H                                                  0729
@ER00013 BR    @14                                                 0729
*LOC2INIT:                          /*                       @X04SVGP*/
*/********************************************************************/
*/*     01 FUNCTION - BUILD AMB WORK AREAS                   @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*     01 INPUT    - ACB WORK AREA, MODULE WORK AREA        @X04SVGP*/
*/*                                                          @X04SVGP*/
*/*     01 OUTPUT   - AMB WORK AREAS ARE BUILT AND INITIALIZED       */
*/*                                                          @X04SVGP*/
*/********************************************************************/
*                                                                  0730
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVGP*/
LOC2INIT DS    0H                                                  0731
*   RSAVLB=RET;                     /*                       @X04SVGP*/
         ST    RET,RSAVLB                                          0731
*   SUBPOOL=WKPOOL;                 /* INIT SUBPOOL          @X04SVGP*/
         MVI   SUBPOOL,X'FC'                                       0732
*   CORELEN=SWKLEN;                 /* INIT LENGTH OF AMBWORK      0733
*                                                            @X04SVGP*/
         LA    CORELEN,1024                                        0733
*   CALL GETCORE;                   /* GET CORE FOR AMBWORK  @X04SVGP*/
         BAL   @14,GETCORE                                         0734
*   IF PPCODE=0 THEN                /* ERROR                 @X04SVGP*/
         CLI   PPCODE,0                                            0735
         BNE   @RF00735                                            0735
*     DO;                           /* NO, CONTINUE          @X04SVGP*/
*       OPWDTWRK=COREADDR;          /* ACBWK PT TO DATA AMBWK      0737
*                                                            @X04SVGP*/
         L     @11,COREADDR                                        0737
         ST    @11,OPWDTWRK(,RCORE)                                0737
*       RCOREF=COREADDR;            /* ADDR TO AMB WORK      @X04SVGP*/
         ST    @11,RCOREF                                          0738
*       AMALEN=SWKLEN;              /* INIT AMBWORK LENGTH   @X04SVGP*/
         MVC   AMALEN(2,@11),@CH00164                              0739
*       CTHSHDSN=CID;               /* INIT DATA CI IN AMBWORK       */
         L     @02,OPWCURPT(,RCORE)                                0740
         MVC   CTHSHDSN(3,@11),CID(@02)                            0740
*       IF OPWIXDT=ON THEN          /* OPEN IX AS ESDS       @X04SVGP*/
         TM    OPWIXDT(RCORE),B'01000000'                          0741
         BNO   @RF00741                                            0741
*         CTINDX=ON;                /* YES, INDICATE INDX    @X04SVGP*/
         OI    CTINDX(@11),B'00010000'                             0742
*       CTHSHCAT=OPWCACB;           /* INIT CAT ACB PTR      @X04SVGP*/
@RF00741 L     @11,OPWCACB(,RCORE)                                 0743
         L     @02,RCOREF                                          0743
         ST    @11,CTHSHCAT(,@02)                                  0743
*       MEMNUM=1;                   /* SET NBR OF CI'S       @X04SVGP*/
         MVI   MEMNUM,X'01'                                        0744
*       IF CII^=0 THEN              /* INDEX EXIST           @X04SVGP*/
         L     @11,OPWCURPT(,RCORE)                                0745
         L     @11,CII-1(,@11)                                     0745
         LA    @11,0(,@11)                                         0745
         LTR   @11,@11                                             0745
         BZ    @RF00745                                            0745
*         DO;                       /* YES, CONTINUE         @X04SVGP*/
*           CALL GETCORE;           /* GET CORE FOR IX AMBWK @X04SVGP*/
         BAL   @14,GETCORE                                         0747
*           IF PPCODE=0 THEN        /* ERROR                 @X04SVGP*/
         CLI   PPCODE,0                                            0748
         BNE   @RF00748                                            0748
*             DO;                   /* NO, CONTINUE          @X04SVGP*/
*               OPWIXWRK=COREADDR;  /* ACBWK PTS TO IX AMBWK @X04SVGP*/
         L     @02,COREADDR                                        0750
         ST    @02,OPWIXWRK(,RCORE)                                0750
*               RCOREF=COREADDR;    /* ADDR TO AMB WORK      @X04SVGP*/
         ST    @02,RCOREF                                          0751
*               AMALEN=SWKLEN;      /* INIT AMBWORK LENGTH   @X04SVGP*/
         MVC   AMALEN(2,@02),@CH00164                              0752
*               CTHSHDSN=CII;       /* INIT IX CI IN AMBWORK @X04SVGP*/
         L     @01,OPWCURPT(,RCORE)                                0753
         MVC   CTHSHDSN(3,@02),CII(@01)                            0753
*               CTINDX=ON;          /* INDICATE INDEX        @X04SVGP*/
         OI    CTINDX(@02),B'00010000'                             0754
*               CTHSHCAT=OPWCACB;   /* INIT CAT ACB PTR      @X04SVGP*/
         L     @15,OPWCACB(,RCORE)                                 0755
         ST    @15,CTHSHCAT(,@02)                                  0755
*               MEMNUM=2;           /* NBR OF CI'S IS TWO    @X04SVGP*/
         MVI   MEMNUM,X'02'                                        0756
*             END;                  /*                       @X04SVGP*/
*           ELSE                    /* GETMAIN FAILURE       @X04SVRL*/
*             DO;                   /*                       @X04SVRL*/
         B     @RC00748                                            0758
@RF00748 DS    0H                                                  0759
*               RET=RSAVLB;         /*                       @X04SVGP*/
         L     RET,RSAVLB                                          0759
*               RETURN;             /*                       @X04SVGP*/
@EL00014 DS    0H                                                  0760
@EF00014 DS    0H                                                  0760
@ER00014 BR    @14                                                 0760
*             END;                  /*                       @X04SVGP*/
*         END;                      /*                       @X04SVGP*/
@RC00748 DS    0H                                                  0763
*       DSNDCI=CID;                 /* INIT DATA CI IN MOD WK      0763
*                                                            @X04SVGP*/
@RF00745 L     @02,OPWCURPT(,RCORE)                                0763
         MVC   DSNDCI(3),CID(@02)                                  0763
*       DSNICI=CII;                 /* IX CI OR ZERO         @X04SVGP*/
         MVC   DSNICI(3),CII(@02)                                  0764
*       DSCATACB=OPWCACB;           /* INIT CAT ACB PTR      @X04SVGP*/
         L     @02,OPWCACB(,RCORE)                                 0765
         ST    @02,DSCATACB                                        0765
*       DATAWAPT=OPWDTWRK;          /* INIT DTA AMB WK PTR   @X04SVGP*/
         L     @02,PARMPT                                          0766
         L     @15,OPWDTWRK(,RCORE)                                0766
         ST    @15,DATAWAPT(,@02)                                  0766
*       INDXWAPT=OPWIXWRK;          /* INIT IX AMB WK PTR    @X04SVGP*/
         L     @15,OPWIXWRK(,RCORE)                                0767
         ST    @15,INDXWAPT(,@02)                                  0767
*     END;                          /*                       @X04SVGP*/
*   RET=RSAVLB;                     /*                       @X04SVGP*/
@RF00735 L     RET,RSAVLB                                          0769
*   END LOC2INIT;                   /*                       @X04SVGP*/
         B     @EL00014                                            0770
*LOC3:                                                             0771
*                                                                  0771
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - INITIALIZE FIELD DESCRIPTORS TO LOCATE ALL     */
*/*                   VOLUME INFORMATION.                            */
*/*                                                                  */
*/*     01 INPUT    - LOCATE DESCRIPTOR                              */
*/*                                                                  */
*/*     01 OUTPUT   - LOCATE DESCRIPTOR INITIALIZED TO RETRIEVE ALL  */
*/*                   VOLUME INFORMATION.                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0771
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0771
LOC3     DS    0H                                                  0772
*   RSAVLC=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLC                                          0772
*   DO CTR=4 TO 6;                  /* PROCESS LOCATE FIELDS         */
         LA    CTR,4                                               0773
@DL00773 DS    0H                                                  0774
*     DO CTR2=1 TO 3;               /* PROCESS ALL TEST FIELDS       */
         LA    CTR2,1                                              0774
@DL00774 DS    0H                                                  0775
*       FLACTIVE(CTR,CTR2)=ON;      /* INDICATE FIELD IS ACTIVE      */
         LR    @02,CTR                                             0775
         MH    @02,@CH00032                                        0775
         ALR   @02,CTR2                                            0775
         MH    @02,@CH00358                                        0775
         LA    @01,FLACTIVE-80(@02)                                0775
         OI    0(@01),B'10000000'                                  0775
*     END;                                                         0776
         AL    CTR2,@CF00053                                       0776
         C     CTR2,@CF00032                                       0776
         BNH   @DL00774                                            0776
*   END;                                                           0777
         AL    CTR,@CF00053                                        0777
         C     CTR,@CF00040                                        0777
         BNH   @DL00773                                            0777
*   FLNAME(4,1)='TOVOLDEV  ';       /* INIT SYMBOLIC FIELD NAMES   0778
*                                                            @Z30SSMD*/
         MVC   FLNAME+180(8),@CC03836                              0778
*   FLNAME(4,2)='ITYPEXT ';                                        0779
         MVC   FLNAME+200(8),@CC03801                              0779
*   FLTSTPTR(4,2)=ADDR(SSTEST);     /* INIT PTR TO TEST DATA         */
         LA    @02,SSTEST                                          0780
         ST    @02,FLTSTPTR+200                                    0780
*   FLTSTLEN(4,2)=1;                /* INIT LENGTH OF TEST DATA      */
         LA    @15,1                                               0781
         ST    @15,FLTSTLEN+200                                    0781
*   FLCOND(4,2)=CTGFLDON;           /* INDICATE TYPE OF TEST         */
         MVI   FLCOND+200,X'10'                                    0782
*   FLNAME(4,3)='CNTREPNO';                                        0783
         MVC   FLNAME+220(8),@CC03838                              0783
*   FLTSTPTR(4,3)=ADDR(REPTEST);                                   0784
         LA    @14,REPTEST                                         0784
         ST    @14,FLTSTPTR+220                                    0784
*   FLTSTLEN(4,3)=2;                                               0785
         LA    @11,2                                               0785
         ST    @11,FLTSTLEN+220                                    0785
*   FLCOND(4,3)=CTGFLDLE;                                          0786
         MVI   FLCOND+220,X'C0'                                    0786
*   FLNAME(5,1)='TOVOLDEV  ';       /* ASK FOR TOTAL VOLDEV. @Z30SSMD*/
         MVC   FLNAME+240(8),@CC03836                              0787
*   FLNAME(5,2)='ITYPEXT ';                                        0788
         MVC   FLNAME+260(8),@CC03801                              0788
*   FLTSTPTR(5,2)=ADDR(SSTEST);                                    0789
         ST    @02,FLTSTPTR+260                                    0789
*   FLTSTLEN(5,2)=1;                                               0790
         ST    @15,FLTSTLEN+260                                    0790
*   FLCOND(5,2)=CTGFLDZ;                                           0791
         MVI   FLCOND+260,X'80'                                    0791
*   FLNAME(5,3)='CNTREPNO';                                        0792
         MVC   FLNAME+280(8),@CC03838                              0792
*   FLTSTPTR(5,3)=ADDR(REPTEST);                                   0793
         ST    @14,FLTSTPTR+280                                    0793
*   FLTSTLEN(5,3)=2;                                               0794
         ST    @11,FLTSTLEN+280                                    0794
*   FLCOND(5,3)=CTGFLDLE;                                          0795
         MVI   FLCOND+280,X'C0'                                    0795
*   FLNAME(6,1)='VOLPHY  ';                                        0796
         MVC   FLNAME+300(8),@CC03839                              0796
*   FLNAME(6,2)='VOLFLG  ';                                        0797
         MVC   FLNAME+320(8),@CC03840                              0797
*   FLTSTPTR(6,2)=ADDR(CANDTEST);                                  0798
         LA    @02,CANDTEST                                        0798
         ST    @02,FLTSTPTR+320                                    0798
*   FLTSTLEN(6,2)=1;                                               0799
         ST    @15,FLTSTLEN+320                                    0799
*   FLCOND(6,2)=CTGFLDZ;                                           0800
         MVI   FLCOND+320,X'80'                                    0800
*   FLACTIVE(6,3)=OFF;              /* ONLY 1 TEST THIS LOCATE       */
         NI    FLACTIVE+340,B'01111111'                            0801
*   RET=RSAVLC;                     /* RESTORE RETURN REG            */
         L     RET,RSAVLC                                          0802
*   END LOC3;                       /* RETURN TO CALLER              */
@EL00015 DS    0H                                                  0803
@EF00015 DS    0H                                                  0803
@ER00015 BR    @14                                                 0803
*LOCSTAT:                                                          0804
*                                                                  0804
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - LOCATE THE STATISTICS FROM THE CATALOG.  INPUT */
*/*                   TO THE CATALOG ROUTINES ARE THE CI NBR OF THE  */
*/*                   DATA SET BEING PROCESSED AND THE ADDRESS OF THE*/
*/*                   CATALOG ACB.                                   */
*/*                                                                  */
*/*     01 INPUT    - AMB, LOCATE DESCRIPTOR                         */
*/*                                                                  */
*/*     02 OUTPUT   - LOCATE DESCRIPTOR INITIALIZED TO LOCATE THE    */
*/*                   DATA SET STATISTICS                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0804
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0804
LOCSTAT  DS    0H                                                  0805
*   RSAVLC=RET;                                                    0805
         ST    RET,RSAVLC                                          0805
*   CALL CLUPDESR;                  /* CLEAR UPDATE DESCRIPTOR RECORD*/
         BAL   @14,CLUPDESR                                        0806
*   LOCTYPE=LOCTYPE&&LOCTYPE;       /* CLEAR LOCATE TYPE             */
*                                                                  0807
         XC    LOCTYPE(1),LOCTYPE                                  0807
*   /*****************************************************************/
*   /*                                                               */
*   /* INIT LOCATE/UPDATE DESCRIPTOR TO LOCATE STATISTICS            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0808
*   ID3=ON;                         /* INDICATE LOCATE BY CI         */
         OI    ID3,B'00100000'                                     0808
*   DSCATACB=AMBCACB;               /* INIT PTR TO CAT ACB           */
         L     @02,AMBCACB(,R5)                                    0809
         ST    @02,DSCATACB                                        0809
*   DSNCI=AMBDDSN;                  /* INIT CI NBR OF DATA SET       */
         MVC   DSNCI(3),AMBDDSN(R5)                                0810
*   FLACTIVE(1,1)=ON;               /* FIELD IS ACTIVE               */
         OI    FLACTIVE,B'10000000'                                0811
*   FLNAME(1,1)='AMDSBCAT';         /* FIELD IS FOR AMDSB            */
         MVC   FLNAME(8),@CC03774                                  0812
*   IF ID^=RCM THEN                 /* IF NOT CALL FROM EOV          */
         L     @02,PARMPT                                          0813
         CLI   ID(@02),36                                          0813
         BE    @RF00813                                            0813
*     DO;                                                          0814
*                                                                  0814
*       /*************************************************************/
*       /*                                                           */
*       /* INIT LOCATE/UPDATE DESCRIPTOR TO LOCATE DATA SET NAME     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0815
*       FLACTIVE(2,1)=ON;           /* 2ND FIELD ACTIVE              */
         OI    FLACTIVE+60,B'10000000'                             0815
*       FLNAME(2,1)='ENTNAME ';     /* LOCATE DATA SET NAME          */
         MVC   FLNAME+60(8),@CC03826                               0816
*     END;                                                         0817
*   RET=RSAVLC;                                                    0818
@RF00813 L     RET,RSAVLC                                          0818
*   END LOCSTAT;                                                   0819
@EL00016 DS    0H                                                  0819
@EF00016 DS    0H                                                  0819
@ER00016 BR    @14                                                 0819
*UPSTAT:                                                           0820
*                                                                  0820
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - BASED ON THE STATISTICS SAVED AT OPEN, THE     */
*/*                   STATISTICS IN THE CATALOG, AND THE AMDSB       */
*/*                   STATISTICS, COMPUTE THE NEW STATISTICS TO      */
*/*                   BE REPLACED IN THE CATALOG FOR THE DATA SET    */
*/*                                                                  */
*/*     01 INPUT    - AMDSB,STATISTICS SAVED BY OPEN, AND THE CATALOG*/
*/*                   STATISTICS                                     */
*/*                                                                  */
*/*     02 OUTPUT   - FIELD DESCRIPTOR RECORD INITIALIZED TO UPDATE  */
*/*                   THE NEWLY COMPUTED STATISTICS INTO THE CATALOG */
*/*     NOTES - WHEN THE CATALOG IS UPDATED, THE OPEN COPY OF THE    */
*/*             AMDSB IS UPDATED TO SYNCHRONIZE THE CATALOG AND THE  */
*/*             COPY KEPT TO COMPUTE STATISTICS CHANGES.             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0820
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0820
UPSTAT   DS    0H                                                  0821
*   RSAVLC=RET;                                                    0821
         ST    RET,RSAVLC                                          0821
*   IF ID^=RCM THEN                 /* IF NOT CALL FROM EOV          */
         L     @11,PARMPT                                          0822
         CLI   ID(@11),36                                          0822
         BE    @RF00822                                            0822
*     DO;                                                          0823
*                                                                  0823
*       /*************************************************************/
*       /*                                                           */
*       /* SAVE NAME FOR CLOSE                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0824
*       CTGFLPTR=CTGFIELD(2);       /* ADDRESSABILITY 2ND FIELD      */
         L     @11,CTGPLPTR                                        0824
         L     CTGFLPTR,CTGFIELD+4(,@11)                           0824
*       IF CTGFLPT(1)^=0 THEN       /* LOCATE SUCCESSFUL?            */
         L     @11,CTGFLPT(,CTGFLPTR)                              0825
         LTR   @11,@11                                             0825
         BZ    @RF00825                                            0825
*         DSNCHR44=DSNFA;           /* YES, MOVE DSN CALLER'S AREA   */
         L     @01,AMBWKA(,R5)                                     0826
         MVC   DSNCHR44(44,@01),DSNFA(@11)                         0826
*     END;                                                         0827
*                                                                  0827
@RF00825 DS    0H                                                  0828
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE NEW STATISTICS TO BE ENTERED IN CATALOG             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0828
*   CTGFLPTR=CTGFIELD(1);           /* ADDRESSABILITY FIRST FIELD    */
@RF00822 L     @11,CTGPLPTR                                        0828
         L     CTGFLPTR,CTGFIELD(,@11)                             0828
*   R8=CTGFLPT(1);                  /* ADDRESSABILITY TO CAT AMDSB 0829
*                                                            @XA05646*/
         L     R8,CTGFLPT(,CTGFLPTR)                               0829
*   R6=AMBDSB;                      /* ADDRESSABILITY TO REAL AMDSB
*                                                            @XA05646*/
         L     R6,AMBDSB(,R5)                                      0830
*   R7=R6+LENGTH(AMDSTAT);          /* ADDR OF STATISTICS AT OPEN  0831
*                                                            @XA05646*/
         LA    R7,48                                               0831
         ALR   R7,R6                                               0831
*   IF R8^=0 THEN                   /* LOCATE SUCCESSFUL?    @XM02250*/
         LTR   R8,R8                                               0832
         BZ    @RF00832                                            0832
*     DO;                           /* YES, DO:                      */
*                                                                  0833
*       /*************************************************************/
*       /*                                                           */
*       /* UNCONDITIONAL REPLACEMENT                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0834
*       R8->AMDSTSP=R6->AMDSTSP;    /* UPDATE SYSTEM TIME STAMP      */
         MVC   AMDSTSP(8,R8),AMDSTSP(R6)                           0834
*       R8->AMDASPA=R6->AMDASPA;    /* UPDATE BYTES OF FREE SPACE    */
         L     @11,AMDASPA(,R6)                                    0835
         ST    @11,AMDASPA(,R8)                                    0835
*       R8->AMDHLRBA=R6->AMDHLRBA;  /* UPDATE RBA OF HI LEVEL INDX   */
         L     @11,AMDHLRBA(,R6)                                   0836
         ST    @11,AMDHLRBA(,R8)                                   0836
*       R8->AMDSSRBA=R6->AMDSSRBA;  /* UPDATE 1ST SEQ SET REC RBA    */
         L     @11,AMDSSRBA(,R6)                                   0837
         ST    @11,AMDSSRBA(,R8)                                   0837
*       IF R6->AMDLM=ON THEN        /* CREATE COMPLETE?      @XM02250*/
         TM    AMDLM(R6),B'00001000'                               0838
         BNO   @RF00838                                            0838
*         R8->AMDLM=ON;             /* THEN IND IT           @XM02250*/
*                                                                  0839
         OI    AMDLM(R8),B'00001000'                               0839
*       /*************************************************************/
*       /*                                                           */
*       /* REPLACE ONLY IF LARGER                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0840
*       IF(R6->AMDNIL>R8->AMDNIL) THEN                             0840
@RF00838 LH    @11,AMDNIL(,R6)                                     0840
         CH    @11,AMDNIL(,R8)                                     0840
         BNH   @RF00840                                            0840
*         R8->AMDNIL=R6->AMDNIL;    /* UPDATE NBR INDX LEVELS        */
         STH   @11,AMDNIL(,R8)                                     0841
*       IF(R6->AMDNEXT>R8->AMDNEXT) THEN/* IF MORE EXTENTS   @XA05646*/
@RF00840 LH    @11,AMDNEXT(,R6)                                    0842
         CH    @11,AMDNEXT(,R8)                                    0842
         BNH   @RF00842                                            0842
*         R8->AMDNEXT=R6->AMDNEXT;  /* UPD NBR OF EXTENTS    @XA05646*/
*                                                                  0843
         STH   @11,AMDNEXT(,R8)                                    0843
*       /*************************************************************/
*       /*                                                           */
*       /* ADD DEL FOR THIS PROCESSING TO EXISTING CAT VALUES        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0844
*       R8->AMDNLR=R6->AMDNLR-R7->AMDNLR+R8->AMDNLR;/* UPD NBR LOG 0844
*                                      RECS                          */
@RF00842 L     @11,AMDNLR(,R6)                                     0844
         SL    @11,AMDNLR(,R7)                                     0844
         AL    @11,AMDNLR(,R8)                                     0844
         ST    @11,AMDNLR(,R8)                                     0844
*       R8->AMDDELR=R6->AMDDELR-R7->AMDDELR+R8->AMDDELR;/* NBR     0845
*                                      DELETED RECS                  */
         L     @11,AMDDELR(,R6)                                    0845
         SL    @11,AMDDELR(,R7)                                    0845
         AL    @11,AMDDELR(,R8)                                    0845
         ST    @11,AMDDELR(,R8)                                    0845
*       R8->AMDIREC=R6->AMDIREC-R7->AMDIREC+R8->AMDIREC;/* NBR     0846
*                                      INSERTED RECS                 */
         L     @11,AMDIREC(,R6)                                    0846
         SL    @11,AMDIREC(,R7)                                    0846
         AL    @11,AMDIREC(,R8)                                    0846
         ST    @11,AMDIREC(,R8)                                    0846
*       R8->AMDUPR=R6->AMDUPR-R7->AMDUPR+R8->AMDUPR;/* NBR UPDATED 0847
*                                      RECS                          */
         L     @11,AMDUPR(,R6)                                     0847
         SL    @11,AMDUPR(,R7)                                     0847
         AL    @11,AMDUPR(,R8)                                     0847
         ST    @11,AMDUPR(,R8)                                     0847
*       R8->AMDRETR=R6->AMDRETR-R7->AMDRETR+R8->AMDRETR;/* NBR     0848
*                                      RETRIEVED REC                 */
         L     @11,AMDRETR(,R6)                                    0848
         SL    @11,AMDRETR(,R7)                                    0848
         AL    @11,AMDRETR(,R8)                                    0848
         ST    @11,AMDRETR(,R8)                                    0848
*       R8->AMDNCIS=R6->AMDNCIS-R7->AMDNCIS+R8->AMDNCIS;/* NBR CI  0849
*                                      SPLITS                        */
         L     @11,AMDNCIS(,R6)                                    0849
         SL    @11,AMDNCIS(,R7)                                    0849
         AL    @11,AMDNCIS(,R8)                                    0849
         ST    @11,AMDNCIS(,R8)                                    0849
*       R8->AMDNCAS=R6->AMDNCAS-R7->AMDNCAS+R8->AMDNCAS;/* NBR CA  0850
*                                      SPLITS                        */
         L     @11,AMDNCAS(,R6)                                    0850
         SL    @11,AMDNCAS(,R7)                                    0850
         AL    @11,AMDNCAS(,R8)                                    0850
         ST    @11,AMDNCAS(,R8)                                    0850
*       R8->AMDEXCP=R6->AMDEXCP-R7->AMDEXCP+R8->AMDEXCP;/* UPDATE NBR
*                                      EXCP'S                        */
         L     @11,AMDEXCP(,R6)                                    0851
         SL    @11,AMDEXCP(,R7)                                    0851
         AL    @11,AMDEXCP(,R8)                                    0851
         ST    @11,AMDEXCP(,R8)                                    0851
*       R7->AMDSTAT=R8->AMDSTAT;    /* UPDATE OPEN STATISTICS.     0852
*                                                            @Z30SSMD*/
         MVC   AMDSTAT(48,R7),AMDSTAT(R8)                          0852
*       CALL CLUPDESR;              /* CLEAR UPDATE DESCRIPTOR RECORD
*                                                            @XA02420*/
*                                                                  0853
         BAL   @14,CLUPDESR                                        0853
*       /*************************************************************/
*       /*                                                           */
*       /* INIT LOCATE/UPDATE DESCRIPTOR TO UPDATE STATISTICS        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0854
*       UPD=ON;                     /* INDICATE UPDATE REQUEST       */
         OI    UPD,B'00001000'                                     0854
*       FLACTIVE(CTR,1)=ON;         /* FIELD ACTIVE                  */
         LR    @11,CTR                                             0855
         MH    @11,@CH00144                                        0855
         LA    @01,FLACTIVE-60(@11)                                0855
         OI    0(@01),B'10000000'                                  0855
*       FLNAME(CTR,1)='AMDSBCAT';   /* FIELD FOR AMDSB               */
         LA    @01,FLNAME-60(@11)                                  0856
         MVC   0(8,@01),@CC03774                                   0856
*       FLTSTPTR(CTR,1)=CTGFLPT(1); /* PT TO UPDATED AMDSB           */
         L     @15,CTGFLPT(,CTGFLPTR)                              0857
         ST    @15,FLTSTPTR-60(@11)                                0857
*       FLTSTLEN(CTR,1)=CTGFLNG(1); /* LENGTH OF AMDSB               */
         L     @15,CTGFLNG(,CTGFLPTR)                              0858
         ST    @15,FLTSTLEN-60(@11)                                0858
*     END;                          /* END OF LOCATE SUCCESSFUL DO 0859
*                                      GROUP.                @Z30SSMD*/
*   ELSE                            /* IF LOCATE NOT SUCCESSFUL THEN,
*                                                            @Z30SSMD*/
*     CTR=CTR-1;                    /* DECRMENT THE COUNTER. @Z30SSMD*/
         B     @RC00832                                            0860
@RF00832 BCTR  CTR,0                                               0860
*   RET=RSAVLC;                                                    0861
@RC00832 L     RET,RSAVLC                                          0861
*   END UPSTAT;                                                    0862
@EL00017 DS    0H                                                  0862
@EF00017 DS    0H                                                  0862
@ER00017 BR    @14                                                 0862
*UPDSHI:                                                           0863
*                                                                  0863
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - SET UP THE FIELD DESCRIPTOR RECORD TO UPDATE   */
*/*                   THE DATA SET HIGH USED RBA.  THE HIGH USED     */
*/*                   RBA IS DETERMINED BY SCANNING FOR THE EOD ARDB.*/
*/*                                                                  */
*/*     01 INPUT    - FIELD DESCRIPTOR RECORD, R6 PTS TO 1ST ARDB.   */
*/*                                                                  */
*/*     01 OUTPUT   - FIELD DESCRIPTOR INITIALIZED TO UPDATE DATA SET*/
*/*                   HIGH USED RBA                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0863
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0863
UPDSHI   DS    0H                                                  0864
*   RSAVLC=RET;                     /* SAVE RETURN REG               */
*                                                                  0864
         ST    RET,RSAVLC                                          0864
*   /*****************************************************************/
*   /*                                                               */
*   /* LOCATE HIGH USED RBA OF DATA SET BY SCANNING ARDB'S           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0865
*   RESPECIFY                                                      0865
*     IDAARDB BASED(R6);            /* ADDRESSABILITY-ARDB           */
*   DO WHILE ARDEOD=OFF&ARDNPTR^=0; /* LOCATE ARDB WITH HI RBA       */
         B     @DE00866                                            0866
@DL00866 DS    0H                                                  0867
*     R6=ARDNPTR;                   /* NEXT ARDB                     */
         L     R6,ARDNPTR(,R6)                                     0867
*   END;                                                           0868
*                                                                  0868
@DE00866 TM    ARDEOD(R6),B'00001000'                              0868
         BNZ   @DC00866                                            0868
         L     @11,ARDNPTR(,R6)                                    0868
         LTR   @11,@11                                             0868
         BNZ   @DL00866                                            0868
@DC00866 DS    0H                                                  0869
*   /*****************************************************************/
*   /*                                                               */
*   /* INIT LOCATE/UPDATE DESCRIPTOR TO UPDATE HI RBA OF DS          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0869
*   FLACTIVE(CTR,1)=ON;             /* THIS FIELD ACTIVE             */
         LR    @11,CTR                                             0869
         MH    @11,@CH00144                                        0869
         LA    @02,FLACTIVE-60(@11)                                0869
         OI    0(@02),B'10000000'                                  0869
*   FLNAME(CTR,1)='HURBADS ';       /* FILED FOR DATA SET HI RBA     */
         LA    @02,FLNAME-60(@11)                                  0870
         MVC   0(8,@02),@CC03851                                   0870
*   FLTSTPTR(CTR,1)=ADDR(ARDHRBA);  /* NEW HI RBA                    */
         LA    @02,ARDHRBA(,R6)                                    0871
         ST    @02,FLTSTPTR-60(@11)                                0871
*   FLTSTLEN(CTR,1)=LENGTH(ARDHRBA);/* LENGTH OF RBA DATA            */
*                                                                  0872
         LA    @15,4                                               0872
         ST    @15,FLTSTLEN-60(@11)                                0872
*   /*****************************************************************/
*   /*                                                               */
*   /* IF RESTART IS THE CALLER, UNCONDITIONALLY REPLACE HIGH USED   */
*   /* RBA. IF NOT RESTART, REPLACE THE VALUE ONLY IF THE NEW VALUE  */
*   /* IS GREATER THAN THE OLD, EXISTING VALUE.              @Z30SSMD*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0873
*   RESPECIFY                                                      0873
*     IDAAMBL BASED(ACBAMBL);       /* ADDRESSABILITY TO AMBL      0873
*                                                            @XA02369*/
*   IF BIBREST=OFF THEN             /* IF ENTRY WAS NOT FOR RESTART
*                                      HIGH RBA UPDATE       @Z30SSMD*/
         L     @01,ACBPT                                           0874
         L     @01,ACBAMBL(,@01)                                   0874
         L     @01,AMBLBIB(,@01)                                   0874
         TM    BIBREST(@01),B'01000000'                            0874
         BNZ   @RF00874                                            0874
*     DO;                           /*                       @XA02369*/
*       FLACTIVE(CTR,2)=ON;         /* ACTIVE FIELD                  */
         LA    @01,FLACTIVE-40(@11)                                0876
         OI    0(@01),B'10000000'                                  0876
*       FLNAME(CTR,2)='HURBADS ';   /* TEST FIELD FOR HI RBA OF DS   */
         LA    @01,FLNAME-40(@11)                                  0877
         MVC   0(8,@01),@CC03851                                   0877
*       FLTSTPTR(CTR,2)=ADDR(ARDHRBA);/* PTR TO NEW HI RBA           */
         ST    @02,FLTSTPTR-40(@11)                                0878
*       FLTSTLEN(CTR,2)=LENGTH(ARDHRBA);/* LENGTH OF RBA DATA        */
         ST    @15,FLTSTLEN-40(@11)                                0879
*       FLCOND(CTR,2)=CTGFLDLT;     /* NEW HI MUST BE GREATER THAN 0880
*                                      CURRENT HI RBA IN CAT         */
         LA    @02,FLCOND-40(@11)                                  0880
         MVI   0(@02),X'40'                                        0880
*     END;                          /*                       @XA02369*/
*   RET=RSAVLC;                                                    0882
@RF00874 L     RET,RSAVLC                                          0882
*   END UPDSHI;                                                    0883
@EL00018 DS    0H                                                  0883
@EF00018 DS    0H                                                  0883
@ER00018 BR    @14                                                 0883
*UPOBIT:                                                           0884
*                                                                  0884
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - INITIALIZE FIELD DESCRIPTOR TO RESET THE DATA  */
*/*                   SET OPEN INDICATOR IN THE CATALOG              */
*/*                                                                  */
*/*     01 INPUT    - FIELD DESCRIPTOR RECORD                        */
*/*                                                                  */
*/*     01 OUTPUT   - FIELD DESCRIPTOR INITIALIZED                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0884
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0884
UPOBIT   DS    0H                                                  0885
*   RSAVLC=RET;                                                    0885
         ST    RET,RSAVLC                                          0885
*   FLACTIVE(CTR,1)=ON;             /* INDICATE ACTIVE FIELD         */
         LR    @11,CTR                                             0886
         MH    @11,@CH00144                                        0886
         LA    @02,FLACTIVE-60(@11)                                0886
         OI    0(@02),B'10000000'                                  0886
*   FLNAME(CTR,1)='OPENIND ';       /* FIELD FOR OPEN INDICATOR      */
         LA    @02,FLNAME-60(@11)                                  0887
         MVC   0(8,@02),@CC03809                                   0887
*   FLTSTPTR(CTR,1)=ADDR(OPENOFF);  /* PT TO NEW OPEN INDICATOR      */
         L     @02,AMBWKA(,R5)                                     0888
         LA    @02,OPENOFF(,@02)                                   0888
         ST    @02,FLTSTPTR-60(@11)                                0888
*   FLTSTLEN(CTR,1)=LENGTH(OPENOFF);/* LENGTH OF OPEN INDICATOR      */
         LA    @02,1                                               0889
         ST    @02,FLTSTLEN-60(@11)                                0889
*   RET=RSAVLC;                                                    0890
         L     @11,RSAVLC                                          0890
         LR    RET,@11                                             0890
*   END UPOBIT;                                                    0891
@EL00019 DS    0H                                                  0891
@EF00019 DS    0H                                                  0891
@ER00019 BR    @14                                                 0891
*UPKRHI:                                                           0892
*                                                                  0892
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - SET UP THE FIELD DESCRIPTOR RECORD TO UPDATE   */
*/*                   THE HIGH USED RBA OF EACH KEY RANGE WITHIN THE */
*/*                   DATA SET.                                      */
*/*                                                                  */
*/*     01 INPUT    - FIELD DESCRIPTOR RECORD, R6 PTS TO FIRST ARDB. */
*/*                                                                  */
*/*     01 OUTPUT   - FIELD DESCRIPTOR INITIALIZED TO UPDATE ALL     */
*/*                   KEY RANGE HIGH USED RBA'S.                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0892
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0892
UPKRHI   DS    0H                                                  0893
*   RSAVLC=RET;                                                    0893
         ST    RET,RSAVLC                                          0893
*   IF CTR=1 THEN                   /* RE-USING FIELDS?              */
         C     CTR,@CF00053                                        0894
         BNE   @RF00894                                            0894
*     CALL CLUPDESR;                /* CLEAR UPDATE DESCRIPTOR RCD   */
*                                                                  0895
         BAL   @14,CLUPDESR                                        0895
*   /*****************************************************************/
*   /*                                                               */
*   /* INIT LOCATE/UPDATE DESCRIPTOR TO UPDATE HI USED RBAS  @XA03610*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0896
*   RESPECIFY                                                      0896
*     IDAARDB BASED(R6);                                           0896
@RF00894 DS    0H                                                  0897
*   DO CTR2=CTR TO 6 WHILE R6^=0;   /* PROCESS ALL ARDB'S NOT TO   0897
*                                      EXCEED NBR FIELD CHAINS       */
         LR    CTR2,CTR                                            0897
         B     @DE00897                                            0897
@DL00897 LTR   R6,R6                                               0897
         BZ    @DC00897                                            0897
*     FLACTIVE(CTR2,1)=ON;          /* FIELD IS ACTIVE               */
         LR    @02,CTR2                                            0898
         MH    @02,@CH00144                                        0898
         LA    @01,FLACTIVE-60(@02)                                0898
         OI    0(@01),B'10000000'                                  0898
*     FLNAME(CTR2,1)='HURBA  ';     /* FIELD FOR HI USED RBA @YA04459*/
         LA    @01,FLNAME-60(@02)                                  0899
         MVI   7(@01),C' '                                         0899
         MVC   0(7,@01),@CC03860                                   0899
*     FLTSTPTR(CTR2,1)=ADDR(ARDHRBA);/* NEW HI USED RBA      @XA03610*/
         LA    @15,ARDHRBA(,R6)                                    0900
         ST    @15,FLTSTPTR-60(@02)                                0900
*     FLTSTLEN(CTR2,1)=LENGTH(ARDHRBA);/* LENGTH OF DATA     @XA03610*/
*                                                                  0901
         LA    @14,4                                               0901
         ST    @14,FLTSTLEN-60(@02)                                0901
*     /***************************************************************/
*     /*                                                             */
*     /* 1ST TEST- DIRECT CATALOG TO CORRECT VOLUME OCCURRENCE       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0902
*     FLACTIVE(CTR2,2)=ON;          /* 1ST TEST FIELD ACTIVE         */
         LA    @01,FLACTIVE-40(@02)                                0902
         OI    0(@01),B'10000000'                                  0902
*     FLNAME(CTR2,2)='RELREPNO';    /* FIELD FOR RELREPNO            */
         LA    @01,FLNAME-40(@02)                                  0903
         MVC   0(8,@01),@CC03802                                   0903
*     FLTSTPTR(CTR2,2)=ADDR(ARDRELNO);/* SPECIFY VOLUME OCCURRENCE   */
         LA    @01,ARDRELNO(,R6)                                   0904
         ST    @01,FLTSTPTR-40(@02)                                0904
*     FLTSTLEN(CTR2,2)=LENGTH(ARDRELNO);/* LENGTH OF TEST DATA       */
         LA    @01,2                                               0905
         ST    @01,FLTSTLEN-40(@02)                                0905
*     FLCOND(CTR2,2)=CTGFLDEQ;      /* UPD THIS OCCURRENCE ONLY      */
*                                                                  0906
         LA    @01,FLCOND-40(@02)                                  0906
         MVI   0(@01),X'80'                                        0906
*     /***************************************************************/
*     /*                                                             */
*     /* IF RESTART IS THE CALLER, UNCONDITIONALLY REPLACE HIGH KEY  */
*     /* RBA. IF NOT RESTART, REPLACE THE VALUE ONLY IF THE NEW VALUE*/
*     /* IS GREATER THAN THE OLD, EXISTING VALUE. .                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0907
*     IF BIBREST=OFF THEN           /* IF ENTRY WAS NOT FOR RESTART .
*                                      HIGH RBA UPDATE       @Z30SSMD*/
         L     @01,ACBPT                                           0907
         L     @01,ACBAMBL(,@01)                                   0907
         L     @01,AMBLBIB(,@01)                                   0907
         TM    BIBREST(@01),B'01000000'                            0907
         BNZ   @RF00907                                            0907
*       DO;                         /*                       @XA02369*/
*         FLACTIVE(CTR2,3)=ON;      /* 2ND TEST FIELD ACTIVE         */
         LA    @01,FLACTIVE-20(@02)                                0909
         OI    0(@01),B'10000000'                                  0909
*         FLNAME(CTR2,3)='HURBA   ';/* FIELD FOR KR HI USED RBA      */
         LA    @01,FLNAME-20(@02)                                  0910
         MVC   0(8,@01),@CC03861                                   0910
*         FLTSTPTR(CTR2,3)=ADDR(ARDHRBA);/* NEW HI USED RBA          */
         ST    @15,FLTSTPTR-20(@02)                                0911
*         FLTSTLEN(CTR2,3)=LENGTH(ARDHRBA);/* LENGTH OF RBA DATA     */
         ST    @14,FLTSTLEN-20(@02)                                0912
*         FLCOND(CTR2,3)=CTGFLDLT;  /* NEW RBA MUST BE LARGER        */
         LA    @01,FLCOND-20(@02)                                  0913
         MVI   0(@01),X'40'                                        0913
*       END;                        /*                       @XA02369*/
*     R6=ARDNPTR;                   /* PT TO NEXT ARDB               */
@RF00907 L     R6,ARDNPTR(,R6)                                     0915
*     CTR=CTR+1;                    /* INCREMENT FIELD COUNT @XA03610*/
         AL    CTR,@CF00053                                        0916
*   END;                                                           0917
         AL    CTR2,@CF00053                                       0917
@DE00897 C     CTR2,@CF00040                                       0917
         BNH   @DL00897                                            0917
@DC00897 DS    0H                                                  0918
*   RET=RSAVLC;                                                    0918
         L     RET,RSAVLC                                          0918
*   END UPKRHI;                                                    0919
@EL00020 DS    0H                                                  0919
@EF00020 DS    0H                                                  0919
@ER00020 BR    @14                                                 0919
*UPKYHI:                            /* UPDATE HI KEY RBA     @XA03610*/
*/********************************************************************/
*/*                                                          @XA03610*/
*/*     01 FUNCTION - SET UP THE FIELD DESCRIPTOR RECORD TO UPDATE   */
*/*                   THE HIGH KEY RBA OF EACH KEY RANGE WITHIN THE  */
*/*                   DATA SET.                              @XA03610*/
*/*                                                          @XA03610*/
*/*     01 INPUT    - FIELD DESCRIPTOR RECORD, R6 PTS TO FIRST ARDB. */
*/*                                                          @XA03610*/
*/*     01 OUTPUT   - FIELD DESCRIPTOR INITIALIZED TO UPDATE ALL     */
*/*                   KEY RANGE HIGH KEY RBA'S.              @XA03610*/
*/*                                                          @XA03610*/
*/********************************************************************/
*                                                                  0920
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @XA03610*/
UPKYHI   DS    0H                                                  0921
*   RSAVLC=RET;                     /*                       @XA03610*/
         ST    RET,RSAVLC                                          0921
*   IF CTR=1 THEN                   /* RE-USING FIELDS?      @XA03610*/
         C     CTR,@CF00053                                        0922
         BNE   @RF00922                                            0922
*     CALL CLUPDESR;                /* CLEAR UPDATE DESCRIPTOR RECORD
*                                                            @XA03610*/
*                                                                  0923
         BAL   @14,CLUPDESR                                        0923
*   /*****************************************************************/
*   /*                                                               */
*   /*                                                       @XA03610*/
*   /* INIT LOCATE/UPDATE DESCRIPTOR TO UPDATE KEY RANGE HI RBAS     */
*   /*                                                       @XA03610*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0924
*   RESPECIFY                                                      0924
*     IDAARDB BASED(R6);            /*                       @XA03610*/
@RF00922 DS    0H                                                  0925
*   DO CTR2=CTR TO 6 WHILE R6^=0;   /* PROCESS ALL ARDB'S NOT TO   0925
*                                      EXCEED NBR FIELD CHAINS     0925
*                                                            @XA03610*/
         LR    CTR2,CTR                                            0925
         B     @DE00925                                            0925
@DL00925 LTR   R6,R6                                               0925
         BZ    @DC00925                                            0925
*     FLACTIVE(CTR2,1)=ON;          /* FIELD IS ACTIVE       @XA03610*/
         LR    @02,CTR2                                            0926
         MH    @02,@CH00144                                        0926
         LA    @01,FLACTIVE-60(@02)                                0926
         OI    0(@01),B'10000000'                                  0926
*     FLNAME(CTR2,1)='HKRBA  ';     /* FIELD FOR KR HI KEY RBA     0927
*                                                            @YA04459*/
         LA    @01,FLNAME-60(@02)                                  0927
         MVI   7(@01),C' '                                         0927
         MVC   0(7,@01),@CC03866                                   0927
*     FLTSTPTR(CTR2,1)=ADDR(ARDHKRBA);/* NEW HI KEY RBA      @XA03610*/
         LA    @15,ARDHKRBA(,R6)                                   0928
         ST    @15,FLTSTPTR-60(@02)                                0928
*     FLTSTLEN(CTR2,1)=LENGTH(ARDHKRBA);/* LENGTH OF DATA    @XA03610*/
*                                                                  0929
         LA    @14,4                                               0929
         ST    @14,FLTSTLEN-60(@02)                                0929
*     /***************************************************************/
*     /*                                                             */
*     /*                                                     @XA03610*/
*     /* 1ST TEST- DIRECT CATALOG TO CORRECT VOLUME OCCURRENCE       */
*     /*                                                     @XA03610*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0930
*     FLACTIVE(CTR2,2)=ON;          /* 1ST TEST FIELD ACTIVE @XA03610*/
         LA    @01,FLACTIVE-40(@02)                                0930
         OI    0(@01),B'10000000'                                  0930
*     FLNAME(CTR2,2)='RELREPNO';    /* FIELD FOR RELREPNO    @XA03610*/
         LA    @01,FLNAME-40(@02)                                  0931
         MVC   0(8,@01),@CC03802                                   0931
*     FLTSTPTR(CTR2,2)=ADDR(ARDRELNO);/* SPECIFY VOLUME OCCURRENCE 0932
*                                                            @XA03610*/
         LA    @01,ARDRELNO(,R6)                                   0932
         ST    @01,FLTSTPTR-40(@02)                                0932
*     FLTSTLEN(CTR2,2)=LENGTH(ARDRELNO);/* LENGTH OF TEST DATA     0933
*                                                            @XA03610*/
         LA    @01,2                                               0933
         ST    @01,FLTSTLEN-40(@02)                                0933
*     FLCOND(CTR2,2)=CTGFLDEQ;      /* UPD THIS OCCURRENCE ONLY    0934
*                                                            @XA03610*/
*                                                                  0934
         LA    @01,FLCOND-40(@02)                                  0934
         MVI   0(@01),X'80'                                        0934
*     /***************************************************************/
*     /*                                                             */
*     /* IF RESTART IS THE CALLER, UNCONDITIONALLY REPLACE THE HIGH  */
*     /* KEY RBA. IF NOT RESTART, REPLACE THE VALUE ONLY IF THE NEW  */
*     /* VALUE IS GREATER THAN THE OLD, EXISTING VALUE. .            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0935
*     IF BIBREST=OFF THEN           /* IF ENTRY WAS NOT FOR RESTART
*                                      HIGH RBA UPDATE       @Z30SSMD*/
         L     @01,ACBPT                                           0935
         L     @01,ACBAMBL(,@01)                                   0935
         L     @01,AMBLBIB(,@01)                                   0935
         TM    BIBREST(@01),B'01000000'                            0935
         BNZ   @RF00935                                            0935
*       DO;                         /*                       @XA03610*/
*         FLACTIVE(CTR2,3)=ON;      /* 2ND TEST FIELD ACTIVE @XA03610*/
         LA    @01,FLACTIVE-20(@02)                                0937
         OI    0(@01),B'10000000'                                  0937
*         FLNAME(CTR2,3)='HKRBA   ';/* FIELD FOR KR HI KEY RBA     0938
*                                                            @YA04459*/
         LA    @01,FLNAME-20(@02)                                  0938
         MVC   0(8,@01),@CC03867                                   0938
*         FLTSTPTR(CTR2,3)=ADDR(ARDHKRBA);/* NEW HI KEY RBA  @XA03610*/
         ST    @15,FLTSTPTR-20(@02)                                0939
*         FLTSTLEN(CTR2,3)=LENGTH(ARDHKRBA);/* LNG OF RBA DATA     0940
*                                                            @XA03610*/
         ST    @14,FLTSTLEN-20(@02)                                0940
*         FLCOND(CTR2,3)=CTGFLDLT;  /* NEW RBA MUST BE LARGER      0941
*                                                            @XA03610*/
         LA    @01,FLCOND-20(@02)                                  0941
         MVI   0(@01),X'40'                                        0941
*       END;                        /*                       @XA03610*/
*     R6=ARDNPTR;                   /* PT TO NEXT ARDB       @XA03610*/
@RF00935 L     R6,ARDNPTR(,R6)                                     0943
*   END;                            /*                       @XA03610*/
         AL    CTR2,@CF00053                                       0944
@DE00925 C     CTR2,@CF00040                                       0944
         BNH   @DL00925                                            0944
@DC00925 DS    0H                                                  0945
*   RET=RSAVLC;                     /*                       @XA03610*/
         L     RET,RSAVLC                                          0945
*   END UPKYHI;                     /*                       @XA03610*/
@EL00021 DS    0H                                                  0946
@EF00021 DS    0H                                                  0946
@ER00021 BR    @14                                                 0946
*CTINTRFC:                                                         0947
*                                                                  0947
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - INITIALIZE THE CPL AND FPL'S AS INDICATED BY   */
*/*                   THE FIELD DESCRIPTOR RECORD.  THE FIELD        */
*/*                   DESCRIPTOR RECORD IS A 3 X 6 ARRAY, EACH       */
*/*                   ELEMENT CORRESPONDING TO AN FPL.  THE CPL &    */
*/*                   FPL'S ARE THEN PASSED TO THE CATALOG ROUTINES  */
*/*                   VIA AN SVC 26.                                 */
*/*                                                                  */
*/*     01 INPUT    - FIELD DESCRIPTOR RECORD                        */
*/*                                                                  */
*/*     01 OUTPUT   - CPL & FPL'S ARE INITIALIZED & THE SVC 26 IS    */
*/*                   ISSUED TO PERFORM THE REQUESTED CATALOG ACTION */
*/*                                                                  */
*/********************************************************************/
*                                                                  0947
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0947
CTINTRFC DS    0H                                                  0948
*   RSAVLC=RET;                     /* SAVE RETURN ADDR              */
         ST    RET,RSAVLC                                          0948
*   R9=LENGTH(CTGPL)+LENGTH(CTGFIELD)*6;/* COMPUTE LENGTH OF PARM  0949
*                                      LIST                          */
         LA    R9,52                                               0949
*   CTGPL(1:R9)=CTGPL(1:R9)&&CTGPL(1:R9);/* CLEAR PARAMETER LIST     */
         L     @15,CTGPLPTR                                        0950
         LR    @14,R9                                              0950
         BCTR  @14,0                                               0950
         EX    @14,@SX03933                                        0950
*   CTGFLPTR=CTGPLPTR+R9;           /* INIT PTR TO 1ST FIELD LIST    */
         ALR   @15,R9                                              0951
         LR    CTGFLPTR,@15                                        0951
*   IF PSWRD=ON THEN                /* AUTHORIZATION CHECK REQUIRED  */
         TM    PSWRD,B'00000010'                                   0952
         BNO   @RF00952                                            0952
*     CALL AUTHCHK;                 /* YES, SPECIAL PROCESSING       */
         BAL   @14,AUTHCHK                                         0953
*   ELSE                            /* NO,                           */
*     CTGBYPSS=ON;                  /* BYPASS SECURITY CHK           */
*                                                                  0954
         B     @RC00952                                            0954
@RF00952 L     @01,CTGPLPTR                                        0954
         OI    CTGBYPSS(@01),B'10000000'                           0954
*   /*****************************************************************/
*   /*                                                               */
*   /* IF JSCBPASS IS ON THEN BYPASS AUTHORIZATION CHECKING.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0955
*   IF JSCBPASS=ON THEN             /* IF BYPASS REQUESTED THEN    0955
*                                                            @Y30DSMD*/
@RC00952 L     @01,CVTPTR                                          0955
         L     @01,CVTTCBP(,@01)                                   0955
         L     @01,TCBPTR(,@01)                                    0955
         L     @01,TCBJSCB(,@01)                                   0955
         TM    JSCBPASS(@01),B'10000000'                           0955
         BNO   @RF00955                                            0955
*     CTGBYPSS=ON;                  /* BYPASS PASSWORD CHECKING.   0956
*                                                            @Y30DSMD*/
         L     @01,CTGPLPTR                                        0956
         OI    CTGBYPSS(@01),B'10000000'                           0956
*   IF UPD=OFF THEN                 /* NOT UPDATE REQUEST    @Z30SSRL*/
@RF00955 TM    UPD,B'00001000'                                     0957
         BNZ   @RF00957                                            0957
*     CTGFUNC=CTGLOC;               /* INDICATE LOCATE REQUEST       */
         L     @01,CTGPLPTR                                        0958
         NI    CTGFUNC(@01),B'00111111'                            0958
         OI    CTGFUNC(@01),B'00100000'                            0958
*   ELSE                            /* UPDATE REQUEST        @Z30SSRL*/
*     DO;                           /*                       @X04SVRL*/
         B     @RC00957                                            0959
@RF00957 DS    0H                                                  0960
*       CTGDDNM=BIBVMT;             /* INIT DD NAME ADDRESS  @X04SVRL*/
         L     @15,CTGPLPTR                                        0960
         L     @01,ACBPT                                           0960
         L     @01,ACBAMBL(,@01)                                   0960
         L     @01,AMBLBIB(,@01)                                   0960
         L     @14,BIBVMT(,@01)                                    0960
         ST    @14,CTGDDNM(,@15)                                   0960
*       CTGFUNC=CTGUPDAT;                                          0961
         NI    CTGFUNC(@15),B'01111111'                            0961
         OI    CTGFUNC(@15),B'01100000'                            0961
*     END;                          /*                       @X04SVRL*/
*   CTGNUM=ON;                      /* SEARCH AM/0 CAT ONLY          */
@RC00957 DS    0H                                                  0964
*   CTGAM0=ON;                      /* INDICATE AM/0 REQUEST         */
         L     @15,CTGPLPTR                                        0964
         OI    CTGNUM(@15),B'00000011'                             0964
*   CTGWKA=CATWKPTR;                /* INIT ADDR OF WA FOR CAT INF   */
         L     @14,CATWKPTR                                        0965
         ST    @14,CTGWKA(,@15)                                    0965
*   IF NAME44=ON THEN               /* ENTRY TYPE REAL NAME?         */
         TM    NAME44,B'10000000'                                  0966
         BNO   @RF00966                                            0966
*     DO;                           /* YES, DO:                      */
*       CTGNAME=ON;                 /* INDICATE REAL NAME            */
*       CTGCNAME=ON;                /* INDICATE CAT ACB PTR = 0      */
         OI    CTGNAME(@15),B'00000110'                            0969
*       CTGENT=ADDR(DSNDD);         /* INIT DS NAME PTR              */
         LA    @14,DSNDD                                           0970
         ST    @14,CTGENT(,@15)                                    0970
*     END;                                                         0971
*   ELSE                            /* ENT TYP NOT REAL NAME @Z30SSRL*/
*     DO;                                                          0972
         B     @RC00966                                            0972
@RF00966 DS    0H                                                  0973
*       IF NAME6=ON THEN            /* VOL SER FOR ENTRY TYPE        */
         TM    NAME6,B'01000000'                                   0973
         BNO   @RF00973                                            0973
*         DO;                       /* YES, CONTINUE                 */
*           CTGENT=ADDR(DSNVLSER);  /* INIT VOLSER PTR IN CPL        */
         L     @15,CTGPLPTR                                        0975
         LA    @14,DSNVLSER                                        0975
         ST    @14,CTGENT(,@15)                                    0975
*           CTGNAME=ON;             /* INDICATE LOCATE BY REAL NAME  */
         OI    CTGNAME(@15),B'00000100'                            0976
*           IF DSCATACB=0 THEN      /* CATALOG ACB PTR EXIST         */
         L     @14,DSCATACB                                        0977
         LTR   @14,@14                                             0977
         BNZ   @RF00977                                            0977
*             CTGCNAME=ON;          /* NO, INDICATE SUCH             */
         OI    CTGCNAME(@15),B'00000010'                           0978
*           ELSE                    /* YES,                          */
*             CTGCAT=ADDR(DSCATACB);/* INIT CAT ACB PTR IN CPL       */
         B     @RC00977                                            0979
@RF00977 LA    @15,DSCATACB                                        0979
         L     @14,CTGPLPTR                                        0979
         ST    @15,CTGCAT(,@14)                                    0979
*         END;                                                     0980
*       ELSE                        /* LOCATE BY CI NBR              */
*         DO;                                                      0981
         B     @RC00973                                            0981
@RF00973 DS    0H                                                  0982
*           CTGENT=ADDR(DSNCI);     /* INIT PTR TO CI NBR            */
         L     @15,CTGPLPTR                                        0982
         LA    @14,DSNCI                                           0982
         ST    @14,CTGENT(,@15)                                    0982
*           CTGCAT=ADDR(DSCATACB);  /* INIT PTR TO CAT ACB PTR       */
         LA    @14,DSCATACB                                        0983
         ST    @14,CTGCAT(,@15)                                    0983
*           IF REU=ON THEN          /* RESET SPECIFIED       @X04SVGP*/
         TM    REU,B'00000001'                                     0984
         BNO   @RF00984                                            0984
*             CTGREL=ON;            /* YES, INDICATE IN CPL  @X04SVGP*/
         OI    CTGREL(@15),B'01000000'                             0985
*         END;                                                     0986
@RF00984 DS    0H                                                  0987
*     END;                                                         0987
@RC00973 DS    0H                                                  0988
*   IF VMT=ON THEN                  /* LOCATE VOLUME TIME STAMP      */
@RC00966 TM    VMT,B'00000100'                                     0988
         BNO   @RF00988                                            0988
*     CTGVMNT=ON;                   /* YES, NOTE IN CPL              */
         L     @01,CTGPLPTR                                        0989
         OI    CTGVMNT(@01),B'00100000'                            0989
*   DO CTR=1 TO 6 WHILE FLACTIVE(CTR,1)=ON;/* PROCESS ALL LOCATES    */
@RF00988 LA    CTR,1                                               0990
@DL00990 LR    @11,CTR                                             0990
         MH    @11,@CH00144                                        0990
         LA    @01,FLACTIVE-60(@11)                                0990
         TM    0(@01),B'10000000'                                  0990
         BNO   @DC00990                                            0990
*     CTGFIELD(CTR)=CTGFLPTR;       /* INIT PL FIELD PTR             */
         LR    @11,CTR                                             0991
         SLA   @11,2                                               0991
         L     @01,CTGPLPTR                                        0991
         ST    CTGFLPTR,CTGFIELD-4(@11,@01)                        0991
*     DO CTR2=1 TO 3 WHILE FLACTIVE(CTR,CTR2)=ON;/* PROCESS ALL FLDS
*                                      FOR THIS LOCATE               */
         LA    CTR2,1                                              0992
@DL00992 LR    @15,CTR                                             0992
         MH    @15,@CH00032                                        0992
         ALR   @15,CTR2                                            0992
         MH    @15,@CH00358                                        0992
         LA    @14,FLACTIVE-80(@15)                                0992
         TM    0(@14),B'10000000'                                  0992
         BNO   @DC00992                                            0992
*       R9=LENGTH(CTGFL)+LENGTH(CTGFLDAT);/* COMPUTE LENGTH OF FIELD */
         LA    R9,24                                               0993
*       CTGFL(1:R9)=CTGFL(1:R9)&&CTGFL(1:R9);/* ZERO FIELD           */
         LR    @14,R9                                              0994
         BCTR  @14,0                                               0994
         EX    @14,@SX03937                                        0994
*       CTGFLCHN=CTGFLPTR+R9;       /* INIT FIELD CHAIN PTR          */
         LR    @14,CTGFLPTR                                        0995
         ALR   @14,R9                                              0995
         ST    @14,CTGFLCHN(,CTGFLPTR)                             0995
*       CTGFLDNM=ADDR(FLNAME(CTR,CTR2));/* INIT SYMBOLIC NAME PTR    */
         LA    @14,FLNAME-80(@15)                                  0996
         ST    @14,CTGFLDNM(,CTGFLPTR)                             0996
*       CTGFLNG(1)=FLTSTLEN(CTR,CTR2);/* INTI LENGTH OF TST DATA     */
         L     @14,FLTSTLEN-80(@15)                                0997
         ST    @14,CTGFLNG(,CTGFLPTR)                              0997
*       CTGFLPT(1)=FLTSTPTR(CTR,CTR2);/* INIT PTR TO TST DATA        */
         L     @14,FLTSTPTR-80(@15)                                0998
         ST    @14,CTGFLPT(,CTGFLPTR)                              0998
*       CTGFLDNO=1;                 /* INIT NBR OF CTGFLPT'S         */
         MVI   CTGFLDNO(CTGFLPTR),X'01'                            0999
*       CTGFLDCD=FLCOND(CTR,CTR2);  /* INIT TEST CONDITION           */
         LA    @14,FLCOND-80(@15)                                  1000
         MVC   CTGFLDCD(1,CTGFLPTR),0(@14)                         1000
*       IF FLNAME(CTR,CTR2)='RELREPNO' THEN/* TEST FIELD NAME      1001
*                                                            @Z30SSRL*/
         LA    @14,FLNAME-80(@15)                                  1001
         CLC   0(8,@14),@CC03802                                   1001
         BNE   @RF01001                                            1001
*         CTGFLDGC=GRPCODE;         /* SET GROUP CODE        @Z30SSRL*/
         MVI   CTGFLDGC(CTGFLPTR),X'03'                            1002
*       R7=CTGFLPTR;                /* NOTE ADDR THIS FIELD          */
@RF01001 LR    R7,CTGFLPTR                                         1003
*       CTGFLPTR=CTGFLCHN;          /* ADDRESSABILITY NXT FLD        */
         L     CTGFLPTR,CTGFLCHN(,CTGFLPTR)                        1004
*     END;                          /* END FLDS FOR THIS LOCATE      */
         AL    CTR2,@CF00053                                       1005
         C     CTR2,@CF00032                                       1005
         BNH   @DL00992                                            1005
@DC00992 DS    0H                                                  1006
*     CTGFLPTR=R7;                  /* ADDRESSABILITY PREVIOUS FLD   */
         LR    CTGFLPTR,R7                                         1006
*     CTGFLCHN=0;                   /* ZERO CHAIN PTR                */
         SLR   @11,@11                                             1007
         ST    @11,CTGFLCHN(,CTGFLPTR)                             1007
*     CTGFLPTR=R7+R9;               /* RESTORE ADDRESSABILITY        */
         LR    CTGFLPTR,R7                                         1008
         ALR   CTGFLPTR,R9                                         1008
*   END;                            /* END FLDS FOR THIS PARM LIST   */
         AL    CTR,@CF00053                                        1009
         C     CTR,@CF00040                                        1009
         BNH   @DL00990                                            1009
@DC00990 DS    0H                                                  1010
*   CTGNOFLD=CTR-1;                 /* NOTE NBR OF FIELD LST PTRS    */
         LR    @11,CTR                                             1010
         BCTR  @11,0                                               1010
         L     @02,CTGPLPTR                                        1010
         STC   @11,CTGNOFLD(,@02)                                  1010
*   RETRY=ON;                       /* INDICATE RETRY POSSIBLE       */
         OI    RETRY,B'00010000'                                   1011
*   DO WHILE RETRY=ON;              /* TRY HARD TO LOCATE            */
         B     @DE01012                                            1012
@DL01012 DS    0H                                                  1013
*     R1=CTGPLPTR;                  /* INIT PTR TO PARAMETER LIST    */
         L     R1,CTGPLPTR                                         1013
*     GEN(SVC 26);                  /* ISSUE CATALOG SVC             */
         SVC 26
*     CATCDF=RETCODE;               /* NOTE RETURN CODE              */
         ST    RETCODE,CATCDF                                      1015
*     IF CATCODEF^=0 THEN           /* SUCCESSFUL LOCATE?            */
         CLI   CATCODEF,0                                          1016
         BE    @RF01016                                            1016
*       IF((CATCODEF=SMALL1)|(CATCODEF=SMALL2)) THEN/* NO, WA TOO  1017
*                                      SMALL                         */
         CLI   CATCODEF,40                                         1017
         BE    @RT01017                                            1017
         CLI   CATCODEF,44                                         1017
         BNE   @RF01017                                            1017
@RT01017 DS    0H                                                  1018
*         DO;                                                      1018
*           CALL REBLDWA;           /* YES, BUILD A LARGER WA        */
         BAL   @14,REBLDWA                                         1019
*           IF PPCODE^=0 THEN       /* REBUILDING SUCCESSFUL?        */
         CLI   PPCODE,0                                            1020
         BE    @RF01020                                            1020
*             RETRY=OFF;            /* NO, MUST STOP TRYING          */
         NI    RETRY,B'11101111'                                   1021
*         END;                                                     1022
*       ELSE                        /* WRK AREA NOT TOO SMALL      1023
*                                                            @Z30SSRL*/
*         RETRY=OFF;                /* UNKNOWN ERROR, STOP LOCATE    */
         B     @RC01017                                            1023
@RF01017 NI    RETRY,B'11101111'                                   1023
*     ELSE                          /* LOCATE WAS SUCCESSFUL         */
*       RETRY=OFF;                  /* FURTHER ATTEMPTS NOT REQ      */
         B     @RC01016                                            1024
@RF01016 NI    RETRY,B'11101111'                                   1024
*   END;                            /* LOCATE(GOOD OR BAD) IS THRU   */
@RC01016 DS    0H                                                  1025
@DE01012 TM    RETRY,B'00010000'                                   1025
         BO    @DL01012                                            1025
*   IF CATCODEF^=0 THEN             /* CATALOG ERROR                 */
         CLI   CATCODEF,0                                          1026
         BE    @RF01026                                            1026
*     DO;                           /* YES, CONTINUE                 */
*       IF PPCODE=0 THEN            /* OTHER ERROR                   */
         CLI   PPCODE,0                                            1028
         BNE   @RF01028                                            1028
*         DO;                       /* NO, CONTINUE                  */
*           IF CATCODEF=SECFAIL THEN/* AUTHORIZATION VERIFIED        */
         CLI   CATCODEF,56                                         1030
         BNE   @RF01030                                            1030
*             PPCODE=PP40;          /* NO                            */
         MVI   PPCODE,X'28'                                        1031
*           ELSE                    /* YES,                          */
*             DO;                   /* CONTINUE                      */
         B     @RC01030                                            1032
@RF01030 DS    0H                                                  1033
*               IF(CATCODEF=IOERR1|CATCODEF=IOERR2) THEN/* I/O ERROR */
         CLI   CATCODEF,24                                         1033
         BE    @RT01033                                            1033
         CLI   CATCODEF,28                                         1033
         BNE   @RF01033                                            1033
@RT01033 DS    0H                                                  1034
*                 PPCODE=PP36;      /* I/O ERROR                     */
         MVI   PPCODE,X'24'                                        1034
*               ELSE                /* NOT I/O ERROR         @Z30SSRL*/
*                 DO;                                              1035
         B     @RC01033                                            1035
@RF01033 DS    0H                                                  1036
*                   IF CATCODEF=CATNUL THEN/* CATALOG OPEN           */
         CLI   CATCODEF,4                                          1036
         BNE   @RF01036                                            1036
*                     PPCODE=PP28;  /* NO, INDICATE SUCH             */
         MVI   PPCODE,X'1C'                                        1037
*                   ELSE            /* YES,                          */
*                     DO;                                          1038
         B     @RC01036                                            1038
@RF01036 DS    0H                                                  1039
*                       IF CATCODEF=ENTNUL THEN/* ENTRY DOES NOT   1039
*                                      EXIST                 @X04SVRL*/
         CLI   CATCODEF,8                                          1039
         BNE   @RF01039                                            1039
*                         PPCODE=PP32;/* SET ERROR           @X04SVRL*/
         MVI   PPCODE,X'20'                                        1040
*                       ELSE        /* ENTRY EXIST           @X04SVRL*/
*                         IF(CATCODEF=RCINENT&CTGREAS2=RSN42)|/*   1041
*                                      REUSE ENTRY IS NOT A DATA   1041
*                                      ENTRY OR              @X04SVRL*/
*                             (CATCODEF=RCINCNPM&CTGREAS2=RSN54) THEN
         B     @RC01039                                            1041
@RF01039 CLI   CATCODEF,60                                         1041
         BNE   @GL00014                                            1041
         L     @02,CTGPLPTR                                        1041
         CLI   CTGREAS2(@02),42                                    1041
         BE    @RT01041                                            1041
@GL00014 CLI   CATCODEF,140                                        1041
         BNE   @RF01041                                            1041
         L     @02,CTGPLPTR                                        1041
         CLI   CTGREAS2(@02),54                                    1041
         BNE   @RF01041                                            1041
@RT01041 DS    0H                                                  1042
*                                   /* NO CI NO. IN REUSE PARM LIST
*                                                            @X04SVRL*/
*                           PPCODE=PP48;/* SET PROBLEM CODE  @X04SVRL*/
         MVI   PPCODE,X'30'                                        1042
*                         ELSE      /* OTHERWISE             @X04SVRL*/
*                           IF CATCODEF=FORTY8&CTGREAS2=RSN16 THEN/*
*                                      NON-REUSABLE DS       @X04SVRL*/
         B     @RC01041                                            1043
@RF01041 CLI   CATCODEF,48                                         1043
         BNE   @RF01043                                            1043
         L     @02,CTGPLPTR                                        1043
         CLI   CTGREAS2(@02),16                                    1043
         BNE   @RF01043                                            1043
*                             PPCODE=PP84;/* INDICATE RESET SPECIFIED
*                                      FOR NON-REUSABLE DATA SET   1044
*                                                            @X04SVRL*/
         MVI   PPCODE,X'54'                                        1044
*                           ELSE    /* NOT NON-REUSABLE DS   @X04SVRL*/
*                             PPCODE=PP37;/* IND UNEXPECTED RETURN 1045
*                                      CODE FROM CATALOG     @X04SVRL*/
         B     @RC01043                                            1045
@RF01043 MVI   PPCODE,X'25'                                        1045
*                     END;                                         1046
@RC01043 DS    0H                                                  1046
@RC01041 DS    0H                                                  1046
@RC01039 DS    0H                                                  1047
*                 END;                                             1047
@RC01036 DS    0H                                                  1048
*             END;                                                 1048
@RC01033 DS    0H                                                  1049
*           IF SFIPT^=0 THEN        /* SFI EXIST             @X04SVGP*/
@RC01030 L     @02,PARMPT                                          1049
         L     @02,SFIPT-1(,@02)                                   1049
         LA    @02,0(,@02)                                         1049
         LTR   @02,@02                                             1049
         BZ    @RF01049                                            1049
*             DO;                   /* YES,                  @X04SVGP*/
*               SFIRETCD=CATCDF;    /* INIT CAT RETURN CODE  @X04SVGP*/
         L     @15,CATCDF                                          1051
         ST    @15,SFIRETCD(,@02)                                  1051
*               SFIRSNCD=CTGREAS2;  /* INIT REASON CODE      @X04SVGP*/
         L     @15,CTGPLPTR                                        1052
         IC    @14,CTGREAS2(,@15)                                  1052
         STC   @14,SFIRSNCD(,@02)                                  1052
*               SFIMODID=CTGMODID;  /* INIT FAILING MODULE ID      1053
*                                                            @X04SVGP*/
         MVC   SFIMODID(2,@02),CTGMODID(@15)                       1053
*             END;                  /*                       @X04SVGP*/
*         END;                                                     1055
@RF01049 DS    0H                                                  1056
*     END;                                                         1056
@RF01028 DS    0H                                                  1057
*   RET=RSAVLC;                     /* RESTORE RETURN REG            */
@RF01026 L     RET,RSAVLC                                          1057
*   END CTINTRFC;                   /* RETURN TO CALLER              */
@EL00022 DS    0H                                                  1058
@EF00022 DS    0H                                                  1058
@ER00022 BR    @14                                                 1058
*MERGVOL:                                                          1059
*                                                                  1059
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - MERGE ALL VOLUME INFORMATION FROM THE CATALOG  */
*/*                   WORK AREA INTO THE AMB WORK AREA               */
*/*                                                                  */
*/*     01 INPUT    - CATALOG WORK AREA, AMB WORK AREA               */
*/*                                                                  */
*/*     01 OUTPUT   - AMB WORK AREA IS INITIALIZED WITH ALL VOLUME   */
*/*                   INFORMATION FOR THE DATA SET                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  1059
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1059
MERGVOL  DS    0H                                                  1060
*   RSAVLC=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLC                                          1060
*   CTGFLPTR=CTGFIELD(4);           /* PT TO 1ST LOCATE FIELD        */
         L     @01,CTGPLPTR                                        1061
         L     CTGFLPTR,CTGFIELD+12(,@01)                          1061
*   SW=OFF;                         /* CLEAR SWITCH                  */
         NI    SW,B'01111111'                                      1062
*   IF CTGFLPT(1)^=0 THEN           /* LOCATE SUCCESSFUL?            */
         L     @15,CTGFLPT(,CTGFLPTR)                              1063
         LTR   @15,@15                                             1063
         BZ    @RF01063                                            1063
*     DO;                           /* YES, DO:                      */
*       CTSTRKAU=NOTRKAU;           /* RECORD TRK/ALLOC UNIT         */
         L     @14,RCOREF                                          1065
         LH    @11,NOTRKAU(,@15)                                   1065
         ST    @11,CTSTRKAU(,@14)                                  1065
*       CTSBLKTR=NOBLKTRK;          /* RECORD BLKS/TRK               */
         LH    @15,NOBLKTRK(,@15)                                  1066
         ST    @15,CTSBLKTR(,@14)                                  1066
*       CTINDXSS=ON;                /* NOTE SEQ SET W/DATA           */
         OI    CTINDXSS(@14),B'00100000'                           1067
*     END;                                                         1068
*   CTGFLPTR=CTGFIELD(5);           /* PT TO 2ND LOCATE FIELD        */
@RF01063 L     @01,CTGPLPTR                                        1069
         L     CTGFLPTR,CTGFIELD+16(,@01)                          1069
*   IF CTGFLPT(1)^=0 THEN           /* LOCATE SUCCESSFUL?            */
         L     @15,CTGFLPT(,CTGFLPTR)                              1070
         LTR   @15,@15                                             1070
         BZ    @RF01070                                            1070
*     DO;                           /* YES, DO:                      */
*       CTTRKAU=NOTRKAU;            /* RECORD TRKS/ALLOC UNIT        */
         L     @14,RCOREF                                          1072
         LH    @11,NOTRKAU(,@15)                                   1072
         ST    @11,CTTRKAU(,@14)                                   1072
*       CTBLKTR=NOBLKTRK;           /* RECORD BLKS/TRK CONTINUE      */
         LH    @11,NOBLKTRK(,@15)                                  1073
         ST    @11,CTBLKTR(,@14)                                   1073
*       CTBLKSZ=PHYBLKSZ;           /* RECORD BLOCK SIZE             */
         L     @11,PHYBLKSZ(,@15)                                  1074
         ST    @11,CTBLKSZ(,@14)                                   1074
*       CTDEVTYP=DEVTYP;            /* INIT DEVICE TYPE CODE         */
         MVC   CTDEVTYP(4,@14),DEVTYP(@15)                         1075
*       CTBYTAU=NOBYTAU;            /* COPY BYTES PER CA.    @Y30DSMD*/
         L     @11,NOBYTAU(,@15)                                   1076
         ST    @11,CTBYTAU(,@14)                                   1076
*       CTBYTTRK=NOBYTTRK;          /* COPY BYTES PER TRACK. @Y30DSMD*/
         L     @15,NOBYTTRK(,@15)                                  1077
         ST    @15,CTBYTTRK(,@14)                                  1077
*       IF CTINDXSS=ON&             /* IF INDEX WKA AND SS/W DATA    */
*           CTBRPS=OFF&             /* IF NOT ALREADY RPS            */
*           DATAWAPT->CTBRPS=ON THEN/* IF DATA ON RPS DEVICE         */
         TM    CTINDXSS(@14),B'00100000'                           1078
         BNO   @RF01078                                            1078
         TM    CTBRPS(@14),B'00010000'                             1078
         BNZ   @RF01078                                            1078
         L     @02,PARMPT                                          1078
         L     @02,DATAWAPT(,@02)                                  1078
         TM    CTBRPS(@02),B'00010000'                             1078
         BNO   @RF01078                                            1078
*         CTBRPS=ON;                /* SET BIT TO GET EXTRA CCW SLOT */
         OI    CTBRPS(@14),B'00010000'                             1079
*       CTGFLPTR=CTGFIELD(6);       /* PT TO 3RD LOCATE FIELD        */
@RF01078 L     @01,CTGPLPTR                                        1080
         L     CTGFLPTR,CTGFIELD+20(,@01)                          1080
*       IF CTGFLPT(1)^=0 THEN       /* LOCATE SUCCESSFUL?            */
         SLR   @15,@15                                             1081
         L     @14,CTGFLPT(,CTGFLPTR)                              1081
         CR    @14,@15                                             1081
         BE    @RF01081                                            1081
*         DO;                       /* YES, CONTINUE                 */
*           RESPECIFY                                              1083
*             IDAAMDSB BASED(ADDR(CTAMDSB));                       1083
*           ENDPT=CTGFLPT(1)+CTGFLNG(1);/* PT TO END OF ALL CAT INFO */
         LR    @10,@14                                             1084
         AL    @10,CTGFLNG(,CTGFLPTR)                              1084
         ST    @10,ENDPT                                           1084
*           MASTRPT=CTGFLPT(1);     /* PT TO 1ST CATALOG VOL ENTRY   */
         ST    @14,MASTRPT                                         1085
*           CURPT=0;                /* CLEAR CAT VOL ENT PTR         */
         SLR   CURPT,CURPT                                         1086
*           RESPECIFY                                              1087
*             CTVOLENT BASED(R6);   /* ADDRESSABILITY FOR VOL ENT    */
*           RESPECIFY                                              1088
*             CTKEYENT BASED(R7);   /* ADDRESSABILITY FOR KEY ENT    */
*           RESPECIFY                                              1089
*             CTEXTENT BASED(R8);   /* ADDRESSABILITY FOR EXT ENT    */
*           R6=ADDR(AMBWORK)+LENGTH(AMBWORK);/* INIT PTR 1ST VOL ENT */
         L     @10,RCOREF                                          1090
         LA    R6,232                                              1090
         ALR   R6,@10                                              1090
*           VOLENTNO=0;             /* CLEAR NBR VOL ENTRIES         */
         STH   @15,VOLENTNO(,@10)                                  1091
*           DO WHILE(PPCODE=0&MASTRPT<ENDPT);/* PROCESS ALL VOL INFO */
         B     @DE01092                                            1092
@DL01092 DS    0H                                                  1093
*             MASTRSER=VOLSER;      /* NOTE THIS VOL SER             */
         L     @10,CTGFLPT(,CTGFLPTR)                              1093
         MVC   MASTRSER(6),VOLSER(@10)                             1093
*             CTVOLSER=MASTRSER;    /* INIT AMBWORK VOL SER          */
         MVC   CTVOLSER(6,R6),MASTRSER                             1094
*             VOLENTNO=VOLENTNO+1;  /* UPDATE NBR VOL ENTRIES        */
         L     @15,RCOREF                                          1095
         LA    @14,1                                               1095
         AH    @14,VOLENTNO(,@15)                                  1095
         STH   @14,VOLENTNO(,@15)                                  1095
*             IF OVERFLOW=ON THEN   /* OVERFLOW VOLUME?              */
         TM    OVERFLOW(@10),B'00100000'                           1096
         BNO   @RF01096                                            1096
*               CTOFLOW=ON;         /* YES, RECORD IN AMBWORK        */
         OI    CTOFLOW(R6),B'01000000'                             1097
*             CNTEXT=0;             /* CLEAR NBR EXTS FIELD          */
@RF01096 MVI   CNTEXT,X'00'                                        1098
*             CNTKR=0;              /* CLEAR NBR KEY RANGES FIELD    */
         MVI   CNTKR,X'00'                                         1099
*             IF AMDKEYLN^=0 THEN   /* KEY LENGTH NOT ZERO   @Z30SSRL*/
         L     @10,RCOREF                                          1100
         LH    @10,AMDKEYLN+132(,@10)                              1100
         LTR   @10,@10                                             1100
         BZ    @RF01100                                            1100
*               CTKEYLEN=AMDKEYLN;  /* RECORD KEY LENGTH FOR KEY   1101
*                                      RANGE SPECIFICATION           */
         STH   @10,CTKEYLEN(,R6)                                   1101
*             ELSE                  /* KEY LENGTH IS ZERO    @Z30SSRL*/
*               CTKEYLEN=4;         /* SET KEY LENGTH TO 4   @Z30SSRL*/
         B     @RC01100                                            1102
@RF01100 MVC   CTKEYLEN(2,R6),@CH00082                             1102
*             R7=R6+LENGTH(CTVOLENT);/* PT TO 1ST KEY RANGE ENTRY    */
@RC01100 LA    R7,20                                               1103
         ALR   R7,R6                                               1103
*             IF((ADDR(CTKEY)+CTKEYLEN*2)>(ADDR(AMBWORK)+AMALEN)) THEN
         LA    @10,CTKEY(,R7)                                      1104
         LH    @15,CTKEYLEN(,R6)                                   1104
         ALR   @15,@15                                             1104
         ALR   @10,@15                                             1104
         L     @15,RCOREF                                          1104
         LH    @14,AMALEN(,@15)                                    1104
         ALR   @14,@15                                             1104
         CR    @10,@14                                             1104
         BNH   @RF01104                                            1104
*               CALL AMBWKRB;       /* GET BIGGER AMB WK IF REQ      */
         BAL   @14,AMBWKRB                                         1105
*             DO WHILE(PPCODE=0&CURPT<ENDPT&VOLSER=MASTRSER);/*    1106
*                                      PROCESS ALL           @ZA05911
*                                      KEY RANGES THIS VOL           */
@RF01104 B     @DE01106                                            1106
@DL01106 DS    0H                                                  1107
*               VOLSER=VOLSER&&VOLSER;/* INDICATE THIS CAT VOL ENTRY
*                                      HAS BEEN PROCESSED            */
         L     @10,CTGFLPT(,CTGFLPTR)                              1107
         XC    VOLSER(6,@10),VOLSER(@10)                           1107
*               R8=ADDR(CTKEY)+CTKEYLEN*2;/* PT TO 1ST EXT THIS KR   */
         LA    R8,CTKEY(,R7)                                       1108
         ST    @10,@TF00001                                        1108
         LH    @10,CTKEYLEN(,R6)                                   1108
         ALR   @10,@10                                             1108
         ALR   R8,@10                                              1108
*               IF((R8+LL3)>(ADDR(AMBWORK)+AMALEN)) THEN/* IF AMB  1109
*                                      WORK AREA NOT BIG ENOUGH    1109
*                                                            @Z30SSRL*/
         LA    @10,2                                               1109
         L     @01,@TF00001                                        1109
         LA    @15,LL1(,@01)                                       1109
         L     @14,@TF00001                                        1109
         ICM   @14,12,LL1(@14)                                     1109
         SRA   @14,16                                              1109
         ALR   @15,@14                                             1109
         ALR   @15,@10                                             1109
         ICM   @14,12,LL2(@15)                                     1109
         SRA   @14,16                                              1109
         ALR   @14,@15                                             1109
         ALR   @14,@10                                             1109
         LR    @10,R8                                              1109
         ICM   @15,12,LL3(@14)                                     1109
         SRA   @15,16                                              1109
         ALR   @10,@15                                             1109
         L     @15,RCOREF                                          1109
         LH    @14,AMALEN(,@15)                                    1109
         ALR   @14,@15                                             1109
         CR    @10,@14                                             1109
         BNH   @RF01109                                            1109
*                 CALL AMBWKRB;     /* GET BIGGER AMB WK IF REQ      */
         BAL   @14,AMBWKRB                                         1110
*               IF PPCODE=0 THEN    /* NO PROBLEM EXIST      @Z30SSRL*/
@RF01109 CLI   PPCODE,0                                            1111
         BNE   @RF01111                                            1111
*                 DO;               /* GET BIGGER AMB WK IF REQ      */
*                   IF SSW=ON THEN  /* SEQ SET W/DATA?               */
         L     @01,CTGFLPT(,CTGFLPTR)                              1113
         TM    SSW(@01),B'10000000'                                1113
         BNO   @RF01113                                            1113
*                     CTSSWDTA=ON;  /* YES, NOTE IN AMBWORK          */
         OI    CTSSWDTA(R7),B'10000000'                            1114
*                   IF PFRM=ON THEN /* PREFORMAT REQUIRED            */
@RF01113 L     @01,CTGFLPT(,CTGFLPTR)                              1115
         TM    PFRM(@01),B'01000000'                               1115
         BNO   @RF01115                                            1115
*                     CTPRFMT=ON;   /* YES,INDICATE IN WA            */
         OI    CTPRFMT(R7),B'01000000'                             1116
*                   CTNOKEXT=(LL3/LENGTH(EXTENT));/* COMPUTE NBR   1117
*                                      EXTENTS THIS KEY RANGE        */
@RF01115 LA    @15,2                                               1117
         L     @14,CTGFLPT(,CTGFLPTR)                              1117
         LA    @11,LL1(,@14)                                       1117
         ICM   @10,12,LL1(@14)                                     1117
         SRA   @10,16                                              1117
         ALR   @11,@10                                             1117
         ALR   @11,@15                                             1117
         ICM   @01,12,LL2(@11)                                     1117
         SRA   @01,16                                              1117
         ALR   @01,@11                                             1117
         ALR   @01,@15                                             1117
         ICM   @00,12,LL3(@01)                                     1117
         SRA   @00,16                                              1117
         SRDA  @00,32                                              1117
         D     @00,@CF00358                                        1117
         STC   @01,CTNOKEXT(,R7)                                   1117
*                   CTKHKRBA=HKRBA; /* RECORD HI KEY RBA             */
         MVC   CTKHKRBA(4,R7),HKRBA(@14)                           1118
*                   CTKHURBA=HURBA; /* RECORD HI USED RBA            */
         MVC   CTKHURBA(4,R7),HURBA(@14)                           1119
*                   CTKHARBA=HARBA; /* RECORD HI ALLOCATED RBA       */
         MVC   CTKHARBA(4,R7),HARBA(@14)                           1120
*                   CTKRELNO=RREPNO;/* INIT VOL OCCURRENCE NBR       */
         LH    @15,RREPNO(,@14)                                    1121
         STH   @15,CTKRELNO(,R7)                                   1121
*                   IF LL1^=0 THEN  /* IF KEY RANGE NOT ZERO @Z30SSRL*/
         LTR   @10,@10                                             1122
         BZ    @RF01122                                            1122
*                     CTKEY(1:LL1)=LOKEYV(1:LL1);/* NOTE KEY RANGE   */
         BCTR  @10,0                                               1123
         EX    @10,@SM03940                                        1123
*                   DO;                                            1124
@RF01122 DS    0H                                                  1125
*                     RESPECIFY                                    1125
*                      (R10,                                       1125
*                       R11) RESTRICTED;                           1125
*                     GEN(STM R8,R11,TEMPSR);/* SAVE REGISTERS       */
         STM R8,R11,TEMPSR
*                     R8=ADDR(CTKEY(CTKEYLEN+1));/* POINT TO START OF
*                                      HI KEY                        */
         LH    @15,CTKEYLEN(,R6)                                   1127
         LA    R8,CTKEY(@15,R7)                                    1127
*                     R10=ADDR(HIKEYV(1));/* POINT TO START OF KEY FR
*                                      CAT                           */
         L     @14,CTGFLPT(,CTGFLPTR)                              1128
         LA    R10,LL1(,@14)                                       1128
         ICM   @14,12,LL1(@14)                                     1128
         SRA   @14,16                                              1128
         ALR   R10,@14                                             1128
         AL    R10,@CF00057                                        1128
         LA    @14,HIKEYV(,R10)                                    1128
         ST    R10,@TF00001                                        1128
         LR    R10,@14                                             1128
*                     R9=CTKEYLEN;  /* SET FINAL KEY LENGTH          */
         LR    R9,@15                                              1129
*                     R11=LL2;      /* SET STARTING KEY LENGTH       */
         L     @01,@TF00001                                        1130
         ICM   R11,12,LL2(@01)                                     1130
         SRA   R11,16                                              1130
*                     GEN(ICM R11,8,PADKEYHI)/* INSERT PAD CHARACTER */
*                     REFS(R11,PADKEYHI);                          1131
         ICM R11,8,PADKEYHI
*                     GEN(MVCL R8,R10)/* MOVE AND PAD KEY            */
*                     REFS(R8,R10);                                1132
         MVCL R8,R10
*                     GEN(LM R8,R11,TEMPSR);/* RESTORE REGISTERS     */
         LM R8,R11,TEMPSR
*                     RESPECIFY                                    1134
*                      (R10,                                       1134
*                       R11) UNRESTRICTED;                         1134
*                   END;                                           1135
*                   CNTEXT=CNTEXT+CTNOKEXT;/* UPDATE NBR EXTS THIS 1136
*                                      VOL                           */
         SLR   @15,@15                                             1136
         IC    @15,CNTEXT                                          1136
         SLR   @14,@14                                             1136
         IC    @14,CTNOKEXT(,R7)                                   1136
         ALR   @15,@14                                             1136
         STC   @15,CNTEXT                                          1136
*                   CNTKR=CNTKR+1;  /* UPD NBR KEY RANGES THIS VOL   */
         IC    @01,CNTKR                                           1137
         LA    @01,1(,@01)                                         1137
         STC   @01,CNTKR                                           1137
*                   IF LL3^=0 THEN  /* EXTENT LENGTH NOT ZERO      1138
*                                                            @Z30SSRL*/
         LA    @15,2                                               1138
         L     @14,CTGFLPT(,CTGFLPTR)                              1138
         LA    @11,LL1(,@14)                                       1138
         ICM   @10,12,LL1(@14)                                     1138
         SRA   @10,16                                              1138
         ALR   @11,@10                                             1138
         ALR   @11,@15                                             1138
         ICM   @14,12,LL2(@11)                                     1138
         SRA   @14,16                                              1138
         ALR   @14,@11                                             1138
         ALR   @14,@15                                             1138
         ICM   @15,3,LL3(@14)                                      1138
         BZ    @RF01138                                            1138
*                     DO;                                          1139
*                       GEN(STM R6,R9,TEMPSR);/* SAVE REGS           */
         STM R6,R9,TEMPSR
*                       R7=LL3;     /* INIT EXTENT LENGTH            */
         LA    @15,2                                               1141
         L     @14,CTGFLPT(,CTGFLPTR)                              1141
         LA    @11,LL1(,@14)                                       1141
         ICM   @10,12,LL1(@14)                                     1141
         SRA   @10,16                                              1141
         ALR   @11,@10                                             1141
         ALR   @11,@15                                             1141
         ICM   @14,12,LL2(@11)                                     1141
         SRA   @14,16                                              1141
         ALR   @14,@11                                             1141
         ALR   @14,@15                                             1141
         ICM   R7,12,LL3(@14)                                      1141
         SRA   R7,16                                               1141
*                       R9=R7;      /* PUT LENGTH IN R9      @Z30SSRL*/
         LR    R9,R7                                               1142
*                       R6=ADDR(EXTENT);/* GET EXTENT ADDR   @Z30SSRL*/
         LA    R6,EXTENT(,@14)                                     1143
*                       GEN(MVCL R8,R6);/* MOVE EXTENTS              */
         MVCL R8,R6
*                       GEN(LM R6,R9,TEMPSR);/* RESTORE REGS         */
         LM R6,R9,TEMPSR
*                     END;                                         1146
*                   R7=R8+LL3;      /* UPDATE EXT LEN IN R7  @Z30SSRL*/
@RF01138 LA    @10,2                                               1147
         L     @15,CTGFLPT(,CTGFLPTR)                              1147
         LA    @14,LL1(,@15)                                       1147
         ICM   @01,12,LL1(@15)                                     1147
         SRA   @01,16                                              1147
         ALR   @14,@01                                             1147
         ALR   @14,@10                                             1147
         ICM   @01,12,LL2(@14)                                     1147
         SRA   @01,16                                              1147
         ALR   @01,@14                                             1147
         ALR   @01,@10                                             1147
         LR    R7,R8                                               1147
         ICM   @10,12,LL3(@01)                                     1147
         SRA   @10,16                                              1147
         ALR   R7,@10                                              1147
*                   CURPT=CTGFLPT(1);/* INIT FOR FOLLOWING LOOP      */
         LR    CURPT,@15                                           1148
*                   DO WHILE(CURPT<ENDPT&VOLSER^=MASTRSER);/* SCAN 1149
*                                      FOR ANOTHER KEY RANGE THIS VOL*/
         B     @DE01149                                            1149
@DL01149 DS    0H                                                  1150
*                     ENTLEN=LENGTH(VOLPHY)+LL1+LENGTH(LL2)+LL2+LENGTH(
*                         LL3)+LL3; /* LENGTH OF CAT VOL ENT         */
         LA    @15,2                                               1150
         L     @14,CTGFLPT(,CTGFLPTR)                              1150
         ICM   @01,12,LL1(@14)                                     1150
         SRA   @01,16                                              1150
         LA    ENTLEN,27                                           1150
         ALR   ENTLEN,@01                                          1150
         LA    @14,LL1(,@14)                                       1150
         ALR   @14,@01                                             1150
         ALR   @14,@15                                             1150
         ICM   @01,12,LL2(@14)                                     1150
         SRA   @01,16                                              1150
         ALR   ENTLEN,@01                                          1150
         ALR   ENTLEN,@15                                          1150
         ALR   @14,@01                                             1150
         ALR   @14,@15                                             1150
         ICM   @15,12,LL3(@14)                                     1150
         SRA   @15,16                                              1150
         ALR   ENTLEN,@15                                          1150
*                     CURPT=CURPT+ENTLEN;/* PT TO NXT CAT VOL ENT    */
         ALR   CURPT,ENTLEN                                        1151
*                     CTGFLPT(1)=CURPT;/* ADDRESSABILITY NXT CAT VOL */
         ST    CURPT,CTGFLPT(,CTGFLPTR)                            1152
*                   END;                                           1153
@DE01149 C     CURPT,ENDPT                                         1153
         BNL   @DC01149                                            1153
         L     @10,CTGFLPT(,CTGFLPTR)                              1153
         CLC   VOLSER(6,@10),MASTRSER                              1153
         BNE   @DL01149                                            1153
@DC01149 DS    0H                                                  1154
*                   IF CURPT<ENDPT THEN/* NOT END OF ALL CAT VOLS  1154
*                                                            @Z30SSRL*/
         C     CURPT,ENDPT                                         1154
         BNL   @RF01154                                            1154
*                     IF(ADDR(CTKEY)+CTKEYLEN*2)>(ADDR(AMBWORK)+AMALEN)
*                       THEN        /* IF AMB WORK AREA NOT BIG    1155
*                                      ENOUGH                @Z30SSRL*/
         LA    @10,CTKEY(,R7)                                      1155
         LH    @15,CTKEYLEN(,R6)                                   1155
         ALR   @15,@15                                             1155
         ALR   @10,@15                                             1155
         L     @15,RCOREF                                          1155
         LH    @14,AMALEN(,@15)                                    1155
         ALR   @14,@15                                             1155
         CR    @10,@14                                             1155
         BNH   @RF01155                                            1155
*                       CALL AMBWKRB;/* GET BIGGER AMB WK IF REQ     */
         BAL   @14,AMBWKRB                                         1156
*                 END;                                             1157
@RF01155 DS    0H                                                  1157
@RF01154 DS    0H                                                  1158
*             END;                                                 1158
@RF01111 DS    0H                                                  1158
@DE01106 CLI   PPCODE,0                                            1158
         BNE   @DC01106                                            1158
         C     CURPT,ENDPT                                         1158
         BNL   @DC01106                                            1158
         L     @10,CTGFLPT(,CTGFLPTR)                              1158
         CLC   VOLSER(6,@10),MASTRSER                              1158
         BE    @DL01106                                            1158
@DC01106 DS    0H                                                  1159
*             CTGFLPT(1)=MASTRPT;   /* ADDRESSABILITY ORIGINAL CAT 1159
*                                      VOL ENT                       */
         L     @10,MASTRPT                                         1159
         ST    @10,CTGFLPT(,CTGFLPTR)                              1159
*             CTNOEXT=CNTEXT;       /* NOTE NBR EXTENTS THIS VOL     */
         IC    @10,CNTEXT                                          1160
         STC   @10,CTNOEXT(,R6)                                    1160
*             CTNOKEY=CNTKR;        /* NOTE NBR KEY RNGES THIS VOL   */
         SLR   @10,@10                                             1161
         IC    @10,CNTKR                                           1161
         STH   @10,CTNOKEY(,R6)                                    1161
*             DO WHILE(MASTRPT<ENDPT&VOLSER=NULL);/* SCAN FOR NEW VOL
*                                      SER TO PROCESS        @Z30SSRL*/
         B     @DE01162                                            1162
@DL01162 DS    0H                                                  1163
*               ENTLEN=LENGTH(VOLPHY)+LL1+LENGTH(LL2)+LL2+LENGTH(LL3)+
*                   LL3;            /* LENGTH THIS CAT VOL ENT       */
         LA    @15,2                                               1163
         L     @14,CTGFLPT(,CTGFLPTR)                              1163
         ICM   @01,12,LL1(@14)                                     1163
         SRA   @01,16                                              1163
         LA    ENTLEN,27                                           1163
         ALR   ENTLEN,@01                                          1163
         LA    @14,LL1(,@14)                                       1163
         ALR   @14,@01                                             1163
         ALR   @14,@15                                             1163
         ICM   @01,12,LL2(@14)                                     1163
         SRA   @01,16                                              1163
         ALR   ENTLEN,@01                                          1163
         ALR   ENTLEN,@15                                          1163
         ALR   @14,@01                                             1163
         ALR   @14,@15                                             1163
         ICM   @15,12,LL3(@14)                                     1163
         SRA   @15,16                                              1163
         ALR   ENTLEN,@15                                          1163
*               MASTRPT=MASTRPT+ENTLEN;/* PT NXT CAT VOL ENT         */
         LR    @15,ENTLEN                                          1164
         AL    @15,MASTRPT                                         1164
         ST    @15,MASTRPT                                         1164
*               CTGFLPT(1)=MASTRPT; /* ADDRESSABILITY NXT CAT VOL    */
         ST    @15,CTGFLPT(,CTGFLPTR)                              1165
*               CURPT=MASTRPT;                                     1166
         LR    CURPT,@15                                           1166
*             END;                  /* NEW VOL SER FOUND, OR DONE    */
@DE01162 CLC   MASTRPT(4),ENDPT                                    1167
         BNL   @DC01162                                            1167
         L     @10,CTGFLPT(,CTGFLPTR)                              1167
         CLC   VOLSER(6,@10),NULL                                  1167
         BE    @DL01162                                            1167
@DC01162 DS    0H                                                  1168
*             R6=R7;                /* ADDRESSABILITY NXT VOL ENT  1168
*                                      ENTRY IN AMBWORK              */
         LR    R6,R7                                               1168
*             IF CURPT<ENDPT THEN   /* NOT END OF ALL CAT VOLS     1169
*                                                            @Z30SSRL*/
         C     CURPT,ENDPT                                         1169
         BNL   @RF01169                                            1169
*               IF(R6+LENGTH(CTVOLENT))>(ADDR(AMBWORK)+AMALEN) THEN/*
*                                      IF AMB WORK AREA NOT BIG    1170
*                                      ENOUGH                @Z30SSRL*/
         LA    @10,20                                              1170
         ALR   @10,R6                                              1170
         L     @15,RCOREF                                          1170
         LH    @14,AMALEN(,@15)                                    1170
         ALR   @14,@15                                             1170
         CR    @10,@14                                             1170
         BNH   @RF01170                                            1170
*                 CALL AMBWKRB;     /* GET BIGGER AMBWK IF REQ       */
         BAL   @14,AMBWKRB                                         1171
*           END;                                                   1172
@RF01170 DS    0H                                                  1172
@RF01169 DS    0H                                                  1172
@DE01092 CLI   PPCODE,0                                            1172
         BNE   @DC01092                                            1172
         CLC   MASTRPT(4),ENDPT                                    1172
         BL    @DL01092                                            1172
@DC01092 DS    0H                                                  1173
*         END;                                                     1173
*       ELSE                        /* LOCATE WAS UNSUCCESSFUL     1174
*                                                            @Z30SSRL*/
*         PPCODE=PP32;              /* INDICATE LOCATE FAILED        */
         B     @RC01081                                            1174
@RF01081 MVI   PPCODE,X'20'                                        1174
*     END;                                                         1175
*   ELSE                            /* LOCATE WAS UNSUCCESSFUL     1176
*                                                            @Z30SSRL*/
*     PPCODE=PP32;                  /* INDICATE LOCATE FAILED        */
         B     @RC01070                                            1176
@RF01070 MVI   PPCODE,X'20'                                        1176
*   RET=RSAVLC;                     /* RESTORE RETURN REG            */
@RC01070 L     RET,RSAVLC                                          1177
*   END MERGVOL;                    /* RETURN TO CALLER              */
@EL00023 DS    0H                                                  1178
@EF00023 DS    0H                                                  1178
@ER00023 BR    @14                                                 1178
*AUTHCHK:                                                          1179
*                                                                  1179
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - DETERMINE LEVEL OF AUTHORIZATION REQUIRED AND  */
*/*                   SET CORRESPONDING INDICATION IN CPL            */
*/*                                                                  */
*/*     01 INPUT    - ACB, CALLER ID, CPL, AND AMB WORK AREA         */
*/*                                                                  */
*/*     01 OUTPUT   - AUTHORIZATION LEVEL REQUIRED IS SET IN CPL AND */
*/*                   AMB WORK AREA.  THE CPL PASSWORD PTR IS        */
*/*                   INITIALIZED IF A PASSWORD WAS SPECIFIED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  1179
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1179
AUTHCHK  DS    0H                                                  1180
*   RESPECIFY                                                      1180
*     IFGACB BASED(ACBPT);                                         1180
*   RSAVLD=RET;                                                    1181
         ST    RET,RSAVLD                                          1181
*   RCOREF=DATAWAPT;                /* PT TO DATA CAT REC            */
         L     @15,PARMPT                                          1182
         L     @14,DATAWAPT(,@15)                                  1182
         ST    @14,RCOREF                                          1182
*   IF ID^=OPP THEN                 /* FIRST OPEN LOCATE             */
         CLI   ID(@15),16                                          1183
         BE    @RF01183                                            1183
*     DO;                           /* YES, CONTINUE                 */
*       IF OPWUCRA=ON THEN          /* IF UCRA               @X04SVRP*/
         TM    OPWUCRA(RCORE),B'10000000'                          1185
         BNO   @RF01185                                            1185
*         CTGBYPSS=ON;              /* THEN IND BYPASS SECURITY    1186
*                                      CHECK. CATALOG FORCES A     1186
*                                      SECURITY CHECK ON FIRST LOCATE
*                                      FOR A UCRA            @X04SVRP*/
         L     @01,CTGPLPTR                                        1186
         OI    CTGBYPSS(@01),B'10000000'                           1186
*       ELSE                        /* ELSE SET SECURITY LEVEL     1187
*                                                            @X04SVRP*/
*         DO;                       /* SET AUTH LEVEL        @X04SVRP*/
         B     @RC01185                                            1187
@RF01185 DS    0H                                                  1188
*           IF ACBCNV=ON THEN       /* CONTROL INTERVAL PROCESSING   */
         L     @01,ACBPT                                           1188
         TM    ACBCNV(@01),B'00100000'                             1188
         BNO   @RF01188                                            1188
*             DO;                   /* YES,                          */
*               CTGCI=ON;           /* SET AUTHORIZATION LEVEL       */
         L     @01,CTGPLPTR                                        1190
         OI    CTGCI(@01),B'00100000'                              1190
*               OPWCINV=ON;         /* ALSO IN CATALOG W.A.  @X04SVGP*/
*               OPWUPD=ON;          /*                       @X04SVGP*/
         OI    OPWCINV(RCORE),B'01100000'                          1192
*             END;                                                 1193
*           ELSE                    /* NOT CI PROCESSING     @Z30SSRL*/
*             DO;                                                  1194
         B     @RC01188                                            1194
@RF01188 DS    0H                                                  1195
*               IF ACBOUT=ON|ACBRST=ON THEN/* OUTPUT OR UPDATE     1195
*                                                            @X04SVGP*/
         L     @15,ACBPT                                           1195
         TM    ACBOUT(@15),B'00000010'                             1195
         BO    @RT01195                                            1195
         TM    ACBRST(@15),B'00000100'                             1195
         BNO   @RF01195                                            1195
@RT01195 DS    0H                                                  1196
*                 DO;               /* YES,                          */
*                   CTGUPD=ON;      /* SET UPD AUTH LEVEL            */
         L     @01,CTGPLPTR                                        1197
         OI    CTGUPD(@01),B'00010000'                             1197
*                   OPWUPD=ON;      /* ALSO IN CATALOG W.A.  @X04SVGP*/
         OI    OPWUPD(RCORE),B'00100000'                           1198
*                 END;                                             1199
*               ELSE                /* NOT OUTPUT OR UPDATE          */
*                 CTGREAD=ON;       /* READ LEVEL REQUIRED           */
         B     @RC01195                                            1200
@RF01195 L     @01,CTGPLPTR                                        1200
         OI    CTGREAD(@01),B'00001000'                            1200
*             END;                                                 1201
@RC01195 DS    0H                                                  1202
*         END;                                                     1202
@RC01188 DS    0H                                                  1203
*       IF ACBPASSW^=0&PWL^=0 THEN  /* ACB PASSWORD EXIST            */
@RC01185 L     @01,ACBPT                                           1203
         L     @15,ACBPASSW(,@01)                                  1203
         LTR   @15,@15                                             1203
         BZ    @RF01203                                            1203
         CLI   PWL(@15),0                                          1203
         BE    @RF01203                                            1203
*         DO;                       /* YES, CONTINUE                 */
*           MYPW=BLANKS;            /* BLANK PASSWORD FIELD          */
         MVC   MYPW(8),BLANKS                                      1205
*           MYPW(1:MIN(PWL,8))=PWP(1:MIN(PWL,8));/* MOVE IN USER   1206
*                                      PASSWD                        */
         SLR   @14,@14                                             1206
         IC    @14,PWL(,@15)                                       1206
         LA    @11,8                                               1206
         CR    @14,@11                                             1206
         BNH   *+6
         LR    @14,@11                                             1206
         BCTR  @14,0                                               1206
         EX    @14,@SM03942                                        1206
*           CTGPSWD=ADDR(MYPW);     /* CPL PTS TO PASSWORD           */
         LA    @15,MYPW                                            1207
         L     @14,CTGPLPTR                                        1207
         ST    @15,CTGPSWD(,@14)                                   1207
*         END;                                                     1208
*     END;                                                         1209
*   ELSE                            /* CALLED BY COMMON OPEN         */
*     CTGMAST=ON;                   /* MASTER PASSWORD REQUIRED      */
         B     @RC01183                                            1210
@RF01183 L     @01,CTGPLPTR                                        1210
         OI    CTGMAST(@01),B'01000000'                            1210
*/*   CHECK FOR AN AUTHORIZED CALLER REQUESTING BYPASS OF AUTHORIZATION
*     CHECKING.                                              @Z40RSRC*/
*                                                                  1211
*   IF ACBBYPSS=ON THEN             /* IF BYPASS REQUEST     @Z40RSRC*/
@RC01183 L     @01,ACBPT                                           1211
         TM    ACBBYPSS(@01),B'00000001'                           1211
         BNO   @RF01211                                            1211
*     DO;                           /*                       @Z40RSRC*/
*       RFY                                                        1213
*        (R0,                                                      1213
*         R1,                                                      1213
*         RETCODE) RSTD;            /*                       @Z40RSRC*/
*       GEN SETS(R0,R1,RETCODE)                                    1214
*           (TESTAUTH FCTN=1,STATE=YES,KEY=YES,RBLEVEL=2);/* @Z40RSRC*/
         TESTAUTH FCTN=1,STATE=YES,KEY=YES,RBLEVEL=2
*       IF RETCODE=0 THEN           /* IF AUTH'D CALLER      @Z40RSRC*/
         LTR   RETCODE,RETCODE                                     1215
         BNZ   @RF01215                                            1215
*         CTGBYPSS=ON;              /* BYPASS AUTH CHK       @Z40RSRC*/
         L     @14,CTGPLPTR                                        1216
         OI    CTGBYPSS(@14),B'10000000'                           1216
*       ELSE                                                       1217
*         ;                         /* CALLER NOT AUTH'D     @Z40RSRC*/
@RF01215 DS    0H                                                  1218
*       RFY                                                        1218
*        (R0,                                                      1218
*         R1,                                                      1218
*         RETCODE) UNRSTD;          /*                       @Z40RSRC*/
*     END;                          /*                       @Z40RSRC*/
*   ELSE                                                           1220
*     ;                             /* NO BYPASS REQUEST     @Z40RSRC*/
@RF01211 DS    0H                                                  1221
*   RET=RSAVLD;                                                    1221
         L     RET,RSAVLD                                          1221
*   END AUTHCHK;                                                   1222
@EL00024 DS    0H                                                  1222
@EF00024 DS    0H                                                  1222
@ER00024 BR    @14                                                 1222
*AMBWKRB:                                                          1223
*                                                                  1223
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - THE SIZE OF THE EXISTING AMB WORK AREA HAS BEEN*/
*/*                   EXCEEDED.  THIS ROUTINE WILL GET A LARGER WORK */
*/*                   AREA, COPY EXISTING INFORMATION FROM THE OLD   */
*/*                   WORK AREA, AND THEN FREE THE OLD AREA.         */
*/*                                                                  */
*/*     01 INPUT    - AMB WORK AREA. AND REGS 6,7,8 WHICH ARE PLACE  */
*/*                   HOLDERS WITHIN THE WORK AREA.                  */
*/*                                                                  */
*/*     02 OUTPUT   - NEW AMB WORK AREA. PLACE HOLDER REGS 6,7,&8    */
*/*                   ARE ADJUSTED TO SAME RELATIVE POSITIONS WITHIN */
*/*                   THE NEW AMB WORK AREA                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  1223
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1223
AMBWKRB  DS    0H                                                  1224
*   RSAVLD=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLD                                          1224
*   IF(R8+LL3)>(ADDR(AMBWORK)+AMALEN) THEN/* AMBWORK EXCEEDED BY   1225
*                                      EXTS?                         */
         LA    @10,2                                               1225
         L     @15,CTGFLPT(,CTGFLPTR)                              1225
         LA    @14,LL1(,@15)                                       1225
         ICM   @15,12,LL1(@15)                                     1225
         SRA   @15,16                                              1225
         ALR   @14,@15                                             1225
         ALR   @14,@10                                             1225
         ICM   @15,12,LL2(@14)                                     1225
         SRA   @15,16                                              1225
         ALR   @15,@14                                             1225
         ALR   @15,@10                                             1225
         ICM   @10,12,LL3(@15)                                     1225
         SRA   @10,16                                              1225
         LR    @15,R8                                              1225
         ALR   @15,@10                                             1225
         L     @14,RCOREF                                          1225
         LH    @01,AMALEN(,@14)                                    1225
         ALR   @01,@14                                             1225
         CR    @15,@01                                             1225
         BNH   @RF01225                                            1225
*     CORELEN=MAX(LL3,SWKLEN);      /* YES, BUMP SIZE BY LARGER OF 1226
*                                      EXTENT LENGTH OR 500          */
         ST    @10,@TF00001                                        1226
         L     CORELEN,@TF00001                                    1226
         LA    @15,1024                                            1226
         CR    CORELEN,@15                                         1226
         BNL   *+6
         LR    CORELEN,@15                                         1226
*   ELSE                            /* NOT EXCEEDED BY EXT   @Z30SSRL*/
*     CORELEN=SWKLEN;               /* BUMP SIZE BY 500      @Z30SSRL*/
         B     @RC01225                                            1227
@RF01225 LA    CORELEN,1024                                        1227
*   CORELEN=CORELEN+AMALEN;         /* ADD IN EXISTING WORK SIZE     */
@RC01225 L     @01,RCOREF                                          1228
         AH    CORELEN,AMALEN(,@01)                                1228
*   SUBPOOL=WKPOOL;                 /* INIT SUBPOOL NBR              */
         MVI   SUBPOOL,X'FC'                                       1229
*   CALL GETCORE;                   /* GET CORE FOR NEW AMBWORK      */
         BAL   @14,GETCORE                                         1230
*   IF PPCODE=0 THEN                /* IF SUCCESSFUL         @Z30SSRL*/
         CLI   PPCODE,0                                            1231
         BNE   @RF01231                                            1231
*     DO;                                                          1232
*       TRANS=COREADDR-RCOREF;      /* DETERMIN AMT TO ADD TO CALLERS
*                                      PLACE HOLDERS                 */
         L     @15,COREADDR                                        1233
         SL    @15,RCOREF                                          1233
         ST    @15,TRANS                                           1233
*       GEN(STM R6,R9,TEMPSR);      /* SAVE REGS                     */
         STM R6,R9,TEMPSR
*       R6=ADDR(NEWAMBWK);          /* PT TO NEW BLOCK               */
         L     R6,COREADDR                                         1235
*       R8=ADDR(AMBWORK);           /* PT TO OLD BLOCK               */
         L     @15,RCOREF                                          1236
         LR    R8,@15                                              1236
*       R7=AMALEN;                  /* LOAD BLOCK LENGTH             */
         LH    R7,AMALEN(,@15)                                     1237
*       R9=R7;                      /* COPY BLOCK LENGTH             */
         LR    R9,R7                                               1238
*       GEN(MVCL R6,R8);            /* COPY BLOCK                    */
         MVCL R6,R8
*       GEN(LM R6,R9,TEMPSR);       /* RESTORE REGS                  */
         LM R6,R9,TEMPSR
*       FREELEN=AMALEN;                                            1241
         L     @15,RCOREF                                          1241
         LH    @14,AMALEN(,@15)                                    1241
         STH   @14,FREELEN                                         1241
*       FREEAD=RCOREF;                                             1242
         ST    @15,FREEAD                                          1242
*       CALL FREECORE;              /* FREE OLD AMBWORK              */
         BAL   @14,FREECORE                                        1243
*       IF RCOREF=DATAWAPT THEN     /* EXTENDING DATA AMB WK AREA?   */
         L     @15,PARMPT                                          1244
         CLC   RCOREF(4),DATAWAPT(@15)                             1244
         BNE   @RF01244                                            1244
*         DATAWAPT=COREADDR;        /* YES, UPDATE ADDRESS OF DATA   */
         L     @14,COREADDR                                        1245
         ST    @14,DATAWAPT(,@15)                                  1245
*       ELSE                        /* NO,                           */
*         INDXWAPT=COREADDR;        /* UPDATE ADDR OF INDX           */
         B     @RC01244                                            1246
@RF01244 L     @15,COREADDR                                        1246
         L     @14,PARMPT                                          1246
         ST    @15,INDXWAPT(,@14)                                  1246
*       RCOREF=COREADDR;            /* ADDRESSABILITY NEW WK AREA    */
@RC01244 L     @15,COREADDR                                        1247
         ST    @15,RCOREF                                          1247
*       AMALEN=CORELEN;             /* RECORD NEW WK AREA LENGTH     */
         STH   CORELEN,AMALEN(,@15)                                1248
*       R6=R6+TRANS;                /* UPDATE CALLERS PLACE PTRS     */
         L     @10,TRANS                                           1249
         ALR   R6,@10                                              1249
*       R7=R7+TRANS;                                               1250
         ALR   R7,@10                                              1250
*       R8=R8+TRANS;                                               1251
         ALR   R8,@10                                              1251
*     END;                                                         1252
*   RET=RSAVLD;                     /* RESTORE RETURN ADDR           */
@RF01231 L     RET,RSAVLD                                          1253
*   END AMBWKRB;                    /* RETURN TO CALLER              */
@EL00025 DS    0H                                                  1254
@EF00025 DS    0H                                                  1254
@ER00025 BR    @14                                                 1254
*REBLDWA:                                                          1255
*                                                                  1255
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - THE SIZE OF THE CATALOG WORK AREA HAS BEEN     */
*/*                   EXCEEDED.  THIS ROUTINE WILL GET A LARGER      */
*/*                   WORK AREA, AND THEN FREE THE OLD WORK AREA     */
*/*                                                                  */
*/*     01 INPUT    - CPL, OLD CATALOG WORK AREA                     */
*/*                                                                  */
*/*     02 OUTPUT   - NEW CATALOG WORK AREA, CPL MODIFIED TO POINT   */
*/*                   TO NEW WORK AREA                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1255
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1255
REBLDWA  DS    0H                                                  1256
*   RSAVLD=RET;                     /* SAVE RETURN REG               */
         ST    RET,RSAVLD                                          1256
*   CORELEN=REQLEN;                 /* LENGTH FOR GETMAIN            */
         L     @02,CATWKPTR                                        1257
         LH    CORELEN,REQLEN(,@02)                                1257
*   SUBPOOL=WKPOOL;                 /* SUBPOOL INIT FOR GETMAIN      */
         MVI   SUBPOOL,X'FC'                                       1258
*   CALL GETCORE;                   /* GET CORE FOR NEW WORK AREA    */
         BAL   @14,GETCORE                                         1259
*   IF PPCODE=0 THEN                /* IF SUCCESSFUL         @Z30SSRL*/
         CLI   PPCODE,0                                            1260
         BNE   @RF01260                                            1260
*     DO;                                                          1261
*       FREEAD=CTGWKA;              /* ADDR OF OLD WORK AREA         */
         L     @11,CTGPLPTR                                        1262
         L     @11,CTGWKA(,@11)                                    1262
         ST    @11,FREEAD                                          1262
*       FREELEN=WORKLEN;            /* LENGTH TO FREE                */
         L     @11,CATWKPTR                                        1263
         LH    @11,WORKLEN(,@11)                                   1263
         STH   @11,FREELEN                                         1263
*       CALL FREECORE;              /* FREE OLD WORK AREA            */
         BAL   @14,FREECORE                                        1264
*       CTGWKA=COREADDR;            /* INIT PRT TO NEW WK AREA       */
         L     @11,COREADDR                                        1265
         L     @02,CTGPLPTR                                        1265
         ST    @11,CTGWKA(,@02)                                    1265
*       CATWKPTR=CTGWKA;                                           1266
         ST    @11,CATWKPTR                                        1266
*       WORKLEN=CORELEN;            /* INIT LENGTH NEW WORK AREA     */
         STH   CORELEN,WORKLEN(,@11)                               1267
*     END;                                                         1268
*   RET=RSAVLD;                     /* RESTORE RETURN ADDRESS        */
@RF01260 L     RET,RSAVLD                                          1269
*   END REBLDWA;                    /* RETURN TO CALLER              */
@EL00026 DS    0H                                                  1270
@EF00026 DS    0H                                                  1270
@ER00026 BR    @14                                                 1270
*GETCORE:                                                          1271
*                                                                  1271
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - PERFORM GETMAIN FOR A SPECIFIED AMOUNT OF CORE */
*/*                   FROM THE REQUESTED SUBPOOL.  ZERO GOTTEN CORE. */
*/*                                                                  */
*/*     01 INPUT    - MODULE WORKAREA CONTAINING THE SUBPOOL NBR     */
*/*                   AND CORE LENGTH REQUIRED.                      */
*/*                                                                  */
*/*     02 OUTPUT   - COREADDR (MODULE WORK AREA FIELD) CONTAINS THE */
*/*                   ADDRESS OF GOTTEN CORE.                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  1271
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1271
GETCORE  DS    0H                                                  1272
*   RSAVLE=RET;                     /* SAVE RETURN ADDR              */
         ST    RET,RSAVLE                                          1272
*   CORELEN=(CORELEN+7)/DWORDLEN*DWORDLEN;/* ROUND UP LENGTH FOR GETM*/
         LA    @00,7                                               1273
         ALR   @00,CORELEN                                         1273
         SRDA  @00,32                                              1273
         D     @00,@CF00049                                        1273
         SLA   @01,3                                               1273
         LR    CORELEN,@01                                         1273
*   GEN(STM R6,R9,TEMPSR);                                         1274
         STM R6,R9,TEMPSR
*   R7=SUBPOOL;                     /* INIT SUBPOOL FOR GETMAIN      */
         SLR   R7,R7                                               1275
         IC    R7,SUBPOOL                                          1275
*   R9=CORELEN;                     /* INIT LENGTH FOR GETMAIN       */
         LR    R9,CORELEN                                          1276
*   GEN(GETMAIN EC,LV=(R9),A=COREADDR,SP=(R7),MF=(E,MAINLIST));    1277
         GETMAIN EC,LV=(R9),A=COREADDR,SP=(R7),MF=(E,MAINLIST)
*   IF RETCODE=0 THEN               /* GETMAIN SUCCESSFUL?           */
         LTR   RETCODE,RETCODE                                     1278
         BNZ   @RF01278                                            1278
*     DO;                           /* YES,DO:                       */
*       R8=COREADDR;                /* CLEAR GETMAINED CORE          */
         L     R8,COREADDR                                         1280
*       R7=0;                                                      1281
         SLR   R7,R7                                               1281
*       GEN(MVCL R8,R6);                                           1282
         MVCL R8,R6
*     END;                                                         1283
*   ELSE                            /* GETMAIN FAILED        @Z30SSRL*/
*     DO;                                                          1284
         B     @RC01278                                            1284
@RF01278 DS    0H                                                  1285
*       PPCODE=PP20;                /* SET PROBLEM CODE      @Z30SSRL*/
         MVI   PPCODE,X'14'                                        1285
*     END;                                                         1286
*   GEN(LM R6,R9,TEMPSR);                                          1287
@RC01278 DS    0H                                                  1287
         LM R6,R9,TEMPSR
*   RET=RSAVLE;                     /* RESTORE RETURN REG            */
         L     RET,RSAVLE                                          1288
*   END GETCORE;                    /* RETURN TO CALLER              */
@EL00027 DS    0H                                                  1289
@EF00027 DS    0H                                                  1289
@ER00027 BR    @14                                                 1289
*FREECORE:                                                         1290
*                                                                  1290
*/********************************************************************/
*/*                                                                  */
*/*     01 FUNCTION - PERFORM FREEMAIN FOR A SPECIFIED AMOUNT OF CORE*/
*/*                   FROM THE REQUESTED CORE LOCATION.              */
*/*                                                                  */
*/*     01 INPUT    - MODULE WORK AREA CONTAINING THE ADDRESS OF THE */
*/*                   LOCATION TO BE FREED AND LENGTH TO BE FREED.   */
*/*                                                                  */
*/*     01 OUTPUT   - SPECIFIED CORE IS FREED.                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  1290
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1290
FREECORE DS    0H                                                  1291
*   RSAVLE=RET;                     /* SAVE RETURN REG               */
         ST    RET,RSAVLE                                          1291
*   GEN(STM R6,R9,TEMPSR);          /* SAVE REGISTERS                */
         STM R6,R9,TEMPSR
*   R7=SUBPOOL;                     /* INIT SUBPOOL FOR FREEMAIN     */
         SLR   R7,R7                                               1293
         IC    R7,SUBPOOL                                          1293
*   R9=FREELEN;                     /* INIT LENGTH FOR FREEMAIN      */
         LH    R9,FREELEN                                          1294
*   GEN(FREEMAIN E,LV=(R9),A=FREEAD,SP=(R7),MF=(E,MAINLIST));      1295
         FREEMAIN E,LV=(R9),A=FREEAD,SP=(R7),MF=(E,MAINLIST)
*   GEN(LM R6,R9,TEMPSR);           /* RESTORE REGISTERS             */
         LM R6,R9,TEMPSR
*   RET=RSAVLE;                     /* RESTORE RETURN REG            */
         L     RET,RSAVLE                                          1297
*   END FREECORE;                   /* RETURN TO CALLER              */
@EL00028 DS    0H                                                  1298
@EF00028 DS    0H                                                  1298
@ER00028 BR    @14                                                 1298
*CLUPDESR:                                                         1299
*                                                                  1299
*/********************************************************************/
*/*                                                                  */
*/*    01 FUNCTION - ZERO FIELD DESCRIPTOR RECORD.                   */
*/*                                                                  */
*/*    01 INPUT    - FIELD DESCRIPTOR RECORD.                        */
*/*                                                                  */
*/*    01 OUTPUT   - FIELD DESCRIPTOR RECORD IS CLEARED.             */
*/*                                                                  */
*/********************************************************************/
*                                                                  1299
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1299
CLUPDESR DS    0H                                                  1300
*   RSAVLD=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLD                                          1300
*   R7=0;                           /* ZERO PAD/LENGTH               */
         SLR   R7,R7                                               1301
*   R8=ADDR(FL(1,1));               /* SET START OF FIELD TO ZERO    */
         LA    R8,FL                                               1302
*   R9=LENGTH(FL(1,1))*LOC18;       /* SET LENGTH OF FIELD TO ZERO   */
         LA    R9,360                                              1303
*   GEN(MVCL R8,R6);                /* ZERO FIELD                    */
         MVCL R8,R6
*   RET=RSAVLD;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLD                                          1305
*   END CLUPDESR;                                                  1306
@EL00029 DS    0H                                                  1306
@EF00029 DS    0H                                                  1306
@ER00029 BR    @14                                                 1306
@PB00029 DS    0H                                                  1306
*   END IDA0192C                                                   1307
*                                                                  1307
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IDAERRCD)                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDACTREC)                                       */
*/*%INCLUDE SYSLIB  (IDAOPWRK)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IDASFI  )                                       */
*/*%INCLUDE SYSLIB  (IDAFOREC)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                       */
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGPL)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGFL)                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDABIB  )                                       */
*/*%INCLUDE SYSLIB  (IGGCAXWA)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IEZXRB  )                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  1307
*       ;                                                          1307
@DATA    DS    0H
@CH03906 DC    H'14'
@CH00144 DC    H'60'
@CH00164 DC    H'1024'
@SM03928 MVC   CTAMDSB(0,@14),AMDSBCAT(@15)
@SX03933 XC    CTGPL(0,@15),CTGPL(@15)
@SX03937 XC    CTGFL(0,CTGFLPTR),CTGFL(CTGFLPTR)
@SM03940 MVC   CTKEY(0,R7),LOKEYV(@14)
@SM03942 MVC   MYPW(0),PWP(@15)
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
@TF00001 DS    F
IDA0192C CSECT
         DS    0F
@CF00053 DC    F'1'
@CF00057 DC    F'2'
@CF00032 DC    F'3'
@CH00032 EQU   @CF00032+2
@CF00082 DC    F'4'
@CH00082 EQU   @CF00082+2
@CF00040 DC    F'6'
@CF00070 DC    F'7'
@CF00049 DC    F'8'
@CF00150 DC    F'16'
@CF00358 DC    F'20'
@CH00358 EQU   @CF00358+2
@CF03903 DC    F'2048'
@CF03931 DC    F'-3'
@DATD    DSECT
         DS    0D
CTGPLPTR DS    A
DSPCIPT1 DS    A
DSPCIPT2 DS    A
RSAVLA   DS    A
RSAVLB   DS    A
RSAVLC   DS    A
RSAVLD   DS    A
RSAVLE   DS    A
MASTRPT  DS    A
ENDPT    DS    A
COREADDR DS    A
TRANS    DS    F
FREEAD   DS    A
RCOREF   DS    A
CATWKPTR DS    A
ACBPT    DS    A
PARMPT   DS    A
CTRB     DS    F
ENDAMBPT DS    A
LASTKEY  DS    A
RSAVLF   DS    A
FREELEN  DS    H
CATBLKLN DS    H
CNTEXT   DS    FL1
CNTKR    DS    FL1
SUBPOOL  DS    FL1
MEMNUM   DS    FL1
LOCDES   DS    CL465
         ORG   LOCDES
DSNDD    DS    CL44
DSNVLS   DS    CL44
         ORG   DSNVLS
DSNVLSER DS    CL6
         ORG   LOCDES+88
DSNCCI   DS    CL3
DSNDCI   DS    CL3
DSNICI   DS    CL3
DSNCI    DS    CL3
DSCATACB DS    AL4
FL       DS    CL20
         ORG   FL+0
FLNAME   DS    CL8
FLTSTPTR DS    AL4
FLTSTLEN DS    FL4
FLCOND   DS    CL1
FLFLG    DS    BL1
         ORG   FLFLG+0
FLACTIVE DS    BL1
         ORG   FL+18
@NM00001 DS    CL2
         ORG   LOCDES+464
LOCTYPE  DS    CL1
         ORG   LOCTYPE
NAME44   DS    BL1
NAME6    EQU   LOCTYPE+0
ID3      EQU   LOCTYPE+0
RETRY    EQU   LOCTYPE+0
UPD      EQU   LOCTYPE+0
VMT      EQU   LOCTYPE+0
PSWRD    EQU   LOCTYPE+0
REU      EQU   LOCTYPE+0
         ORG   LOCDES+465
BITBANK  DS    BL1
         ORG   BITBANK
SW       DS    BL1
@NM00002 EQU   BITBANK+0
         ORG   BITBANK+1
MASTRSER DS    CL6
MYPW     DS    CL8
MAINR0   DS    CL4
         ORG   MAINR0
MAINPOOL DS    FL1
MAINLEN  DS    FL3
         ORG   MAINR0+4
CATCDF   DS    CL4
         ORG   CATCDF
@NM00003 DS    CL3
CATCODEF DS    FL1
         ORG   CATCDF+4
PD       DS    CL4
         ORG   PD
PPCODE   DS    FL1
PPFUNC   DS    FL1
PPSFC    DS    FL1
@NM00004 DS    CL1
         ORG   PD+4
MAINLIST DS    3F
TEMPSR   DS    4A
IDA0192C CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
REPTEST  DC    H'1'
@CC03836 DC    C'TOVOLDEV  '
@CC03760 DC    C'DSTYPNAM'
@CC03761 DC    C'CATACB  '
@CC03762 DC    C'NAMEDS  '
@CC03763 DC    C'CRAVOL  '
@CC03764 DC    C'UPGRADE '
@CC03765 DC    C'CATTR   '
@CC03772 DC    C'OPENC2  '
@CC03773 DC    C'DSATRO  '
@CC03774 DC    C'AMDSBCAT'
@CC03795 DC    C'VOLTSTMP'
@CC03801 DC    C'ITYPEXT '
@CC03802 DC    C'RELREPNO'
@CC03809 DC    C'OPENIND '
@CC03813 DC    C'GENDSP  '
@CC03818 DC    C'PASSATMP'
@CC03826 DC    C'ENTNAME '
@CC03838 DC    C'CNTREPNO'
@CC03839 DC    C'VOLPHY  '
@CC03840 DC    C'VOLFLG  '
@CC03851 DC    C'HURBADS '
@CC03861 DC    C'HURBA   '
@CC03867 DC    C'HKRBA   '
@CC03860 EQU   @CC03861
@CC03866 EQU   @CC03867
SSTEST   DC    X'80'
NOSSTEST DC    X'00'
CANDTEST DC    X'40'
NULL     DC    X'000000000000'
PADKEYHI DC    X'FF'
CATIDNO  DC    X'000002'
         DS    CL3
GMFAIL   DC    X'14010000'
BLANKS   DC    X'4040404040404040'
IDA0192C CSECT
         DS    0D                   START ON DOUBLE WORD BOUNDARY
PTCH192C DC    ((*-IDA0192C)/20)X'00' PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192C CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
CORELEN  EQU   @10
ENTLEN   EQU   @10
CURPT    EQU   @11
CTR2     EQU   @11
CTR      EQU   @10
CTGFLPTR EQU   @02
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
R13      EQU   @13
RCORE    EQU   @04
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
RET      EQU   @14
RETCODE  EQU   @15
R15      EQU   @15
RDEB     EQU   @11
RTIOT    EQU   @09
RUCB     EQU   @10
CVTPTR   EQU   16
OPNCALL1 EQU   0
SPACOP   EQU   OPNCALL1
CYL      EQU   SPACOP
BUFSIZE  EQU   OPNCALL1+1
ENTNAME  EQU   OPNCALL1+5
HURBADS  EQU   OPNCALL1+49
EXNM     EQU   OPNCALL1+53
CRAVOL   EQU   0
AMDSBCAT EQU   0
DSTYPNAM EQU   0
ENTYPE   EQU   DSTYPNAM
ENTIDNO  EQU   DSTYPNAM+1
CATACB   EQU   0
NAMEDS   EQU   0
TYPE     EQU   NAMEDS
NAME     EQU   NAMEDS+1
VOLDEV   EQU   0
DEVTYP   EQU   VOLDEV
PHYBLKSZ EQU   VOLDEV+4
NOBLKTRK EQU   VOLDEV+8
NOTRKAU  EQU   VOLDEV+10
NOBYTTRK EQU   VOLDEV+12
NOBYTAU  EQU   VOLDEV+16
VOLPHY   EQU   0
RREPNO   EQU   VOLPHY
VOLSER   EQU   VOLPHY+2
VOLFLG   EQU   VOLPHY+8
OVERFLOW EQU   VOLFLG
HRBAS    EQU   VOLPHY+10
HKRBA    EQU   HRBAS
HURBA    EQU   HRBAS+4
HARBA    EQU   HRBAS+8
ITYPEXT  EQU   VOLPHY+22
SSW      EQU   ITYPEXT
PFRM     EQU   ITYPEXT
LL1      EQU   VOLPHY+23
LOKEYV   EQU   VOLPHY+25
LL2X     EQU   0
LL2      EQU   LL2X
HIKEYV   EQU   LL2X+2
LL3X     EQU   0
LL3      EQU   LL3X
EXTENT   EQU   LL3X+2
DSATO    EQU   0
DSATTR   EQU   DSATO
DSATTR1  EQU   DSATTR
RECOVCAT EQU   DSATTR1
DSATTR2  EQU   DSATTR+1
CROSSREG EQU   DSATTR2
CROSSSYS EQU   DSATTR2
INTERDS  EQU   DSATTR2
NUSE     EQU   DSATTR2
DSOPIND  EQU   DSATO+2
DSOPINDX EQU   DSOPIND
CCATTRO  EQU   0
CATWORK  EQU   0
WORKLEN  EQU   CATWORK
REQLEN   EQU   CATWORK+2
RSTCI    EQU   CATWORK+4
NEWAMBWK EQU   0
WAPT     EQU   0
DATAWAPT EQU   WAPT+4
INDXWAPT EQU   WAPT+8
PRMLST   EQU   0
ID       EQU   PRMLST
SFIPT    EQU   PRMLST+1
AMBCLWK  EQU   0
DSNCHR44 EQU   AMBCLWK
CLFLG1   EQU   AMBCLWK+44
OUTBIT   EQU   CLFLG1
OPENOFF  EQU   AMBCLWK+45
DSNFA    EQU   0
VLTSFA   EQU   0
OPENSET  EQU   0
VOLSTS   EQU   0
VLENTNO  EQU   VOLSTS+6
VLCATACB EQU   VOLSTS+8
VLSERTS  EQU   VOLSTS+12
VLSER    EQU   VLSERTS
VLTS     EQU   VLSERTS+6
CIINFO   EQU   0
CID      EQU   CIINFO+1
CII      EQU   CIINFO+5
DSNMPARM EQU   0
DSNCINUM EQU   DSNMPARM+5
DSNCACB  EQU   DSNMPARM+8
RDSN     EQU   DSNMPARM+12
PW       EQU   0
PWL      EQU   PW
PWP      EQU   PW+1
CAXWAPTR EQU   0
DSPSEC   EQU   0
DSPPT    EQU   DSPSEC+4
DSPVLPT  EQU   DSPSEC+8
DTASPVOL EQU   0
DSPCI    EQU   0
DSPACBPT EQU   DSPCI
DSPCILEN EQU   DSPCI+4
DSPCINUM EQU   0
@NM00017 EQU   0
TCBPTR   EQU   @NM00017+4
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDNEST  EQU   IDAAMDSB+4
AMDKEYLN EQU   IDAAMDSB+8
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDPARDB EQU   IDAAMDSB+36
AMDATTR3 EQU   IDAAMDSB+40
AMDLM    EQU   AMDATTR3
AMDSTAT  EQU   IDAAMDSB+48
AMDSTSP  EQU   AMDSTAT
AMDNIL   EQU   AMDSTAT+8
AMDNEXT  EQU   AMDSTAT+10
AMDNLR   EQU   AMDSTAT+12
AMDDELR  EQU   AMDSTAT+16
AMDIREC  EQU   AMDSTAT+20
AMDUPR   EQU   AMDSTAT+24
AMDRETR  EQU   AMDSTAT+28
AMDASPA  EQU   AMDSTAT+32
AMDNCIS  EQU   AMDSTAT+36
AMDNCAS  EQU   AMDSTAT+40
AMDEXCP  EQU   AMDSTAT+44
AMBWORK  EQU   0
AMALEN   EQU   AMBWORK+6
VOLENTNO EQU   AMBWORK+12
CTINFO   EQU   AMBWORK+14
CTATTRA  EQU   CTINFO
CTATTRB  EQU   CTINFO+1
CTOPEN   EQU   CTATTRB
CTCYL    EQU   CTATTRB
CTINDXSS EQU   CTATTRB
CTINDX   EQU   CTATTRB
CTSHROP  EQU   CTINFO+2
CTSHARE  EQU   CTSHROP
CTSHRW   EQU   CTSHROP
CTSHRF   EQU   CTSHROP
CTHELP   EQU   CTSHROP
CTSDHELP EQU   CTSHROP
CTINTDS  EQU   CTSHROP
CTUNUSE  EQU   CTSHROP
CTAUTH   EQU   CTINFO+3
CTBLKSZ  EQU   CTINFO+6
CTDEVTYP EQU   CTINFO+10
CTDEV2   EQU   CTDEVTYP+1
CTBRPS   EQU   CTDEV2
CTTRKAU  EQU   CTINFO+14
CTSTRKAU EQU   CTINFO+18
CTBLKTR  EQU   CTINFO+22
CTSBLKTR EQU   CTINFO+26
CTBYTAU  EQU   CTINFO+30
CTBYTTRK EQU   CTINFO+38
CTHSHDSN EQU   CTINFO+46
CTHSHCAT EQU   CTINFO+50
CTHURBA  EQU   CTINFO+54
CTBUFSIZ EQU   CTINFO+58
CTCISIZ  EQU   CTINFO+62
CTEXEX   EQU   CTINFO+66
CTDATANM EQU   CTINFO+74
CTAMDSB  EQU   CTINFO+118
CTVOLENT EQU   0
CTVOLFLG EQU   CTVOLENT
CTOFLOW  EQU   CTVOLFLG
CTNOEXT  EQU   CTVOLENT+1
CTNOKEY  EQU   CTVOLENT+8
CTKEYLEN EQU   CTVOLENT+10
CTVOLSER EQU   CTVOLENT+12
CTKEYENT EQU   0
CTKEYFLG EQU   CTKEYENT
CTSSWDTA EQU   CTKEYFLG
CTPRFMT  EQU   CTKEYFLG
CTNOKEXT EQU   CTKEYENT+1
CTKRELNO EQU   CTKEYENT+2
CTKHKRBA EQU   CTKEYENT+4
CTKHURBA EQU   CTKEYENT+8
CTKHARBA EQU   CTKEYENT+12
CTKEY    EQU   CTKEYENT+16
CTEXTENT EQU   0
CTABSBEG EQU   CTEXTENT+2
CTABSEND EQU   CTEXTENT+6
IDAOPWRK EQU   0
OPWFLGS1 EQU   IDAOPWRK+12
OPWCAT   EQU   OPWFLGS1
OPWSCRA  EQU   OPWFLGS1
OPWVVIC  EQU   OPWFLGS1
OPWFLGS2 EQU   IDAOPWRK+13
OPWUCRA  EQU   OPWFLGS2
OPWIXDT  EQU   OPWFLGS2
OPWAIXDT EQU   OPWFLGS2
OPWFLGS3 EQU   IDAOPWRK+14
OPWFLGS4 EQU   IDAOPWRK+15
OPWCINV  EQU   OPWFLGS4
OPWUPD   EQU   OPWFLGS4
OPWCOMWA EQU   IDAOPWRK+20
OPWIDF   EQU   IDAOPWRK+24
OPWCACB  EQU   OPWIDF
OPWQ     EQU   OPWIDF+7
OPWVSMPL EQU   IDAOPWRK+32
OPWVMFLG EQU   OPWVSMPL+13
OPWVSMWA EQU   IDAOPWRK+48
OPWVGSPL EQU   OPWVSMWA+40
OPWVLSAV EQU   OPWVSMWA+80
OPWVFMPL EQU   OPWVSMWA+88
OPWSAVE  EQU   IDAOPWRK+144
OPWCURPT EQU   IDAOPWRK+164
OPWCRA   EQU   IDAOPWRK+192
OPWQ2    EQU   IDAOPWRK+198
OPWCATTR EQU   IDAOPWRK+199
OPWDTWRK EQU   IDAOPWRK+212
OPWIXWRK EQU   IDAOPWRK+216
OPWBSECL EQU   IDAOPWRK+568
OPWBDTCI EQU   OPWBSECL+1
OPWBIXCI EQU   OPWBSECL+5
OPWPTAIX EQU   IDAOPWRK+576
OPWPDTCI EQU   OPWPTAIX+1
OPWPIXCI EQU   OPWPTAIX+5
OPWNOUPG EQU   IDAOPWRK+584
OPWUPAIX EQU   IDAOPWRK+588
OPWUDTCI EQU   OPWUPAIX+1
OPWUIXCI EQU   OPWUPAIX+5
OPWCURCL EQU   0
OPWCFLG1 EQU   OPWCURCL
OPWFLG2  EQU   OPWCURCL+4
IDASFI   EQU   0
SFIRETCD EQU   IDASFI+4
SFIRSNCD EQU   IDASFI+9
SFIMODID EQU   IDASFI+10
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXJBF    EQU   FORCORE+100
DXIOB    EQU   FORCORE+280
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXB1 EQU   DXATEXC1
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECWTGTB EQU   IECEXTPR+72
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCSHARE EQU   JFCBIND2
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
IDAPDPRM EQU   0
PDPMSGFL EQU   IDAPDPRM+34
CTGPL    EQU   0
CTGOPTN1 EQU   CTGPL
CTGBYPSS EQU   CTGOPTN1
CTGMAST  EQU   CTGOPTN1
CTGCI    EQU   CTGOPTN1
CTGUPD   EQU   CTGOPTN1
CTGREAD  EQU   CTGOPTN1
CTGNAME  EQU   CTGOPTN1
CTGCNAME EQU   CTGOPTN1
CTGOPTN2 EQU   CTGPL+1
CTGEXT   EQU   CTGOPTN2
CTGERASE EQU   CTGOPTN2
CTGSMF   EQU   CTGERASE
CTGREL   EQU   CTGSMF
CTGPURG  EQU   CTGOPTN2
CTGVMNT  EQU   CTGPURG
CTGRCATN EQU   CTGVMNT
CTGOPTN3 EQU   CTGPL+2
CTGFUNC  EQU   CTGOPTN3
CTGNUM   EQU   CTGOPTN3
CTGAM0   EQU   CTGOPTN3
CTGOPTN4 EQU   CTGPL+3
CTGENT   EQU   CTGPL+4
CTGCAT   EQU   CTGPL+8
CTGWKA   EQU   CTGPL+12
CTGDSORG EQU   CTGPL+16
CTGNOFLD EQU   CTGPL+19
CTGDDNM  EQU   CTGPL+20
CTGNEWNM EQU   CTGDDNM
CTGFBFLG EQU   CTGNEWNM+2
CTGJSCB  EQU   CTGPL+24
CTGPSWD  EQU   CTGJSCB
CTGFIELD EQU   CTGPL+28
CTGFL    EQU   0
CTGFLDNO EQU   CTGFL
CTGFLDCD EQU   CTGFL+1
CTGFLDGC EQU   CTGFL+2
CTGFLDRE EQU   CTGFL+3
CTGFLDNM EQU   CTGFL+8
CTGFLCHN EQU   CTGFL+12
CTGFLDAT EQU   CTGFL+16
CTGFLNG  EQU   CTGFLDAT
CTGFLPT  EQU   CTGFLDAT+4
IDAARDB  EQU   0
ARDTYPE  EQU   IDAARDB+1
ARDEOD   EQU   ARDTYPE
ARDNPTR  EQU   IDAARDB+4
ARDHKRBA EQU   IDAARDB+8
ARDHRBA  EQU   IDAARDB+12
ARDRELNO EQU   IDAARDB+26
ARDPRF   EQU   IDAARDB+28
ARDPRFMT EQU   ARDPRF
IDAAMB   EQU   0
AMBCACB  EQU   IDAAMB+16
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBDDSN  EQU   IDAAMB+35
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBWKA   EQU   IDAAMB+60
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDABIB   EQU   0
BIBHDR   EQU   IDABIB
BIBFLG1  EQU   BIBHDR+1
BIBREST  EQU   BIBFLG1
BIBVMT   EQU   IDABIB+12
BIBRTNS  EQU   IDABIB+60
IGGCAXWA EQU   0
CAXFLGS  EQU   IGGCAXWA+8
CAXCMP   EQU   CAXFLGS
CAXFLG2  EQU   IGGCAXWA+9
CAXF2REC EQU   CAXFLG2
CAXFLG3  EQU   IGGCAXWA+10
CAXCCR   EQU   IGGCAXWA+32
CAXCNAM  EQU   IGGCAXWA+52
CAXOPLST EQU   IGGCAXWA+96
COPTS    EQU   CAXOPLST
CAXCCA   EQU   IGGCAXWA+104
CAXECB   EQU   IGGCAXWA+120
CAXECBHB EQU   CAXECB
CAXHRPLW EQU   IGGCAXWA+128
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBRST   EQU   ACBMACR2
ACBAIX   EQU   ACBMACR2
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBPASSW EQU   ACBCOMN+32
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBINFL1 EQU   ACBINFLG
ACBCAT   EQU   ACBINFL1
ACBVVIC  EQU   ACBINFL1
ACBBYPSS EQU   ACBINFL1
ACBINFL2 EQU   ACBINFLG+1
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBUAPTR EQU   ACBCOMN+64
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLQ2   EQU   IDAAMBL+31
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLVVIC EQU   AMBLFLG1
AMBLFLG2 EQU   IDAAMBL+36
AMBLBIB  EQU   IDAAMBL+60
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLSYNF  EQU   EXLCOMN+10
EXLLERF  EQU   EXLCOMN+15
EXLSCIPF EQU   EXLCOMN+20
EXLUPADF EQU   EXLSCIPF
EXLSCIPS EQU   EXLUPADF
EXLSCIPA EQU   EXLUPADF
EXLSCIPK EQU   EXLUPADF
EXLSCIPP EQU   EXLCOMN+21
EXLLGNF  EQU   EXLCOMN+25
EXLJRNF  EQU   EXLCOMN+30
EXLOPNF  EQU   EXLCOMN+35
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLEXITP EQU   EXLENTRY+1
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFERA  EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBSYSTK EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFLGS3 EQU   TCBFLGS+2
TCBADINP EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBDWSTA EQU   TCBFLGS3
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBFTJST EQU   TCB+44
TCBJPQ   EQU   TCBFTJST
TCBPURGE EQU   TCBJPQ
TCBFTJSA EQU   TCBJPQ+1
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBIDF   EQU   TCBFSA
TCBTME   EQU   TCB+120
TCBPIB   EQU   TCB+124
TCBJSTCB EQU   TCBPIB
TCBPIBT  EQU   TCBJSTCB
TCBPIBA  EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBPQE   EQU   TCB+152
TCBFTFLG EQU   TCBPQE+1
TCBFTFL1 EQU   TCBFTFLG
TCBFTFL2 EQU   TCBFTFLG+1
TCBFTFL3 EQU   TCBFTFLG+2
TCBAQE   EQU   TCB+156
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBXCTL  EQU   TCBNSTAE
TCBSCAT  EQU   TCBNSTAE
TCBSUPER EQU   TCBNSTAE
TCBRETRY EQU   TCBNSTAE
TCBVALID EQU   TCBNSTAE
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBLJSND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBNDINT EQU   TCBNDSP3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBCPU   EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBNTJS  EQU   TCBFLGS6
TCBFLGS7 EQU   TCBBITS+3
TCBGPECB EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBPCB   EQU   TCB+212
TCBARB   EQU   TCB+220
TCBTTQE  EQU   TCB+224
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
XRBPRFX  EQU   0
XRBPRFX1 EQU   0
XRB      EQU   0
@NM00161 EQU   XRB+10
@NM00162 EQU   @NM00161
XRBLRBFX EQU   @NM00162
@NM00164 EQU   @NM00161+1
@NM00165 EQU   @NM00164
@NM00166 EQU   @NM00164
XRBWTL   EQU   XRB+12
XRBEP    EQU   XRBWTL
@NM00169 EQU   XRB+16
XRTLPRB  EQU   @NM00169+4
XRBLOCK  EQU   XRTLPRB
XRBFLAG1 EQU   XRBLOCK
@NM00172 EQU   XRB+28
CDB      EQU   0
CDBMDAD  EQU   CDB
CDBMDSZ  EQU   CDB+4
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBPASS EQU   JSCBSWT1
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
DSNWA    EQU   0
DTASPNM  EQU   0
RBEEA    EQU   0
RRNO     EQU   0
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00076 EQU   DXXCTL
DXSAVMOD EQU   @NM00076+2
@NM00077 EQU   DXRESSW
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
PDWLIST  EQU   FORCORE
PDWWORK  EQU   DXDCB
@NM00090 EQU   CTGDDNM
CTGPROB  EQU   @NM00090
CTGMODID EQU   CTGPROB
CTGREASN EQU   CTGPROB+2
CTGREAS2 EQU   CTGREASN+1
TCBS01   EQU   TCBPCB
TCBXSCT  EQU   TCBS01+28
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCBS01+32
TCBSTAWA EQU   TCBS01+40
TCBESTAE EQU   TCBS01+52
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCBS01+64
TCBFBYT2 EQU   TCBS01+65
TCBRV124 EQU   TCBS01+66
TCBRV133 EQU   TCBS01+67
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00180 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00179 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
@NM00148 EQU   TCBS01+84
TCBSVCA2 EQU   TCBS01+80
TCBSWASA EQU   TCBS01+76
TCBDBTB  EQU   TCBS01+72
TCBRPT   EQU   TCBS01+68
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCBS01+62
TCBRV326 EQU   TCBS01+60
TCBUKYSP EQU   TCBS01+56
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCBS01+48
TCBTCBID EQU   TCBS01+44
TCBSTAFX EQU   TCBSTAWA
TCBSWA   EQU   TCBS01+36
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCBS01+27
TCBTID   EQU   TCBS01+26
TCBRSVAA EQU   TCBS01+25
TCBABCUR EQU   TCBS01+24
TCBTMSAV EQU   TCBS01+20
TCBIOTIM EQU   TCBS01+16
TCBRTWA  EQU   TCBS01+12
TCBBACK  EQU   TCBS01+8
TCBTIRB  EQU   TCBS01+4
TCBAECB  EQU   TCBS01
CTGREAS1 EQU   CTGREASN
PDWORKSP EQU   PDWWORK+88
PDWERRCD EQU   PDWWORK+84
PDWMSGPT EQU   PDWWORK+80
PDWSAVED EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00081 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00080 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00079 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
DXRESIND EQU   @NM00077
DXSAVOFF EQU   @NM00076+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00076
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00061 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00060 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00059 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00182 EQU   CVTFIX+248
@NM00181 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00178 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00177 EQU   IEZJSCB
CDBMDSZA EQU   CDBMDSZ+1
CDBSUBPL EQU   CDBMDSZ
CDBMDADA EQU   CDBMDAD+1
CDBNLSZ  EQU   CDBMDAD
XSVRBEND EQU   XRB+152
@NM00176 EQU   XRB+96
XSIRBEND EQU   XRB+96
XIRBEND  EQU   XRB+96
@NM00175 EQU   XRB+32
XLPRBEND EQU   XRB+32
XPRBEND  EQU   XRB+32
@NM00174 EQU   @NM00172+1
@NM00173 EQU   @NM00172
XRBQ     EQU   XRB+24
XFRBEND  EQU   XRB+24
@NM00171 EQU   XRTLPRB+1
XRBWTIS  EQU   XRBFLAG1
@NM00170 EQU   XRBFLAG1
XRBSRSW  EQU   XRBFLAG1
XRBPFSW  EQU   XRBFLAG1
XRREQ    EQU   @NM00169
XLRBEND  EQU   XRB+16
XRBEPA   EQU   XRBEP+1
XRBUSE   EQU   XRBEP
@NM00168 EQU   @NM00164
@NM00167 EQU   @NM00164
XRBIRBBT EQU   @NM00164
XRBREUS  EQU   @NM00164
XRBRSREG EQU   @NM00164
XRBGTMAN EQU   @NM00166
XRBNRENT EQU   @NM00165
XRBREFR  EQU   @NM00162
XRBETXR  EQU   XRBLRBFX
@NM00163 EQU   @NM00162
XRBSVRES EQU   @NM00162
XRBTYPF  EQU   @NM00162
XRBSZY   EQU   XRB+9
XRBCDBPY EQU   XRB+8
XRBNM    EQU   XRB
XRBPFXND EQU   XRBPRFX1+8
XRBPRE   EQU   XRBPRFX1+4
XRBSUC   EQU   XRBPRFX1
XRBQMAJ  EQU   XRBPRFX+4
@NM00160 EQU   XRBPRFX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00159 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00158 EQU   RBOPSWB2
@NM00157 EQU   XRBPSW
@NM00156 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00155 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00154 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00153 EQU   XSTAB1
@NM00152 EQU   RBBASIC+8
@NM00151 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00150 EQU   RBPRFX
@NM00149 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00147 EQU   TCB+232
TCBRV190 EQU   TCB+229
TCBSVCA1 EQU   TCB+228
TCBJSONQ EQU   TCBTTQE
TCBARBA  EQU   TCBARB+1
TCBRSV85 EQU   TCBARB
TCBGQE   EQU   TCB+216
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSV84 EQU   TCBADMP
TCBRSV83 EQU   TCBRSTSK
TCBSVCS  EQU   TCBFLGS7
TCBFWDD  EQU   TCBSTACK
TCBFDDEI EQU   TCBRSV34
TCBFDDT  EQU   TCBRSV33
TCBFDD   EQU   TCBGPECB
TCBSTIJS EQU   TCBNTJS
TCBDSINQ EQU   TCBAPG
TCBRUNJB EQU   TCBMIGR
TCBRUNPN EQU   TCBRV303
TCBFPROT EQU   TCBSPVLK
TCBPANIC EQU   TCBCPU
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBNDGTF EQU   TCBNDSP5
TCBNDSPL EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00146 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBRSV28 EQU   TCBNDINT
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBNDSDA EQU   TCBSRBND
TCBABTER EQU   TCBRV302
TCBTERM  EQU   TCBLJSND
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBVALID
TCBRV301 EQU   TCBRETRY
TCBSYNCH EQU   TCBSUPER
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBSCAT
TCB33E   EQU   TCBXCTL
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBDDRTI EQU   TCBAQE
TCBRSV73 EQU   TCBFTFL3
TCBRSV72 EQU   TCBFTFL3
TCBFTDUM EQU   TCBFTFL3
TCBRSV71 EQU   TCBFTFL3
TCBRSV70 EQU   TCBFTFL3
TCBRSV69 EQU   TCBFTFL3
TCBRSV68 EQU   TCBFTFL3
TCBRSV67 EQU   TCBFTFL3
TCBRSV66 EQU   TCBFTFL2
TCBSYSAB EQU   TCBFTFL2
@NM00145 EQU   TCBFTFL2
TCBRSV65 EQU   TCBFTFL2
TCBLPAGE EQU   TCBFTFL2
TCBDDEN  EQU   TCBFTFL2
TCBRSV62 EQU   TCBFTFL2
TCBRSV61 EQU   TCBFTFL2
TCBENQ   EQU   TCBFTFL1
TCBFTCOM EQU   TCBFTFL1
TCBFTTOP EQU   TCBFTFL1
TCBRSV60 EQU   TCBFTFL1
TCBRSV59 EQU   TCBFTFL1
TCBRWTOR EQU   TCBFTFL1
TCBVTAM  EQU   TCBFTFL1
TCBTCAM  EQU   TCBFTFL1
TCBFTLMP EQU   TCBPQE
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBPIBA
TCBSCHED EQU   TCBPIBT
TCBWRITE EQU   TCBPIBT
TCBSCHTI EQU   TCBPIBT
TCBRSV54 EQU   TCBPIBT
TCBSTOP  EQU   TCBPIBT
TCBSIZE  EQU   TCBPIBT
TCBPART  EQU   TCBPIBT
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBIDF
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBFTJSA
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBRSV53 EQU   TCBDWSTA
TCBPKCHG EQU   TCBRSV08
TCBSCHAB EQU   TCBRSV07
TCBFLREG EQU   TCBRSV06
TCBRSV52 EQU   TCBABGM
TCBSYSER EQU   TCBABTRM
TCBRSV51 EQU   TCBADINP
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBRSV50 EQU   TCBFDSOP
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBSYSTK
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBPOOL  EQU   TCBFT
TCBDMPA  EQU   TCBPDUMP
TCBJSTE  EQU   TCBNONPR
@NM00144 EQU   TCBFERA
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00143 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
EXLEADDR EQU   EXLEXITP
@NM00142 EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLSPEC  EQU   EXLENFL
EXLOPNP  EQU   EXLCOMN+36
@NM00141 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
EXLJRNP  EQU   EXLCOMN+31
@NM00140 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
EXLLGNP  EQU   EXLCOMN+26
@NM00139 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLUPADP EQU   EXLSCIPP
@NM00138 EQU   EXLUPADF
EXLUPADK EQU   EXLSCIPK
EXLUPADA EQU   EXLSCIPA
EXLUPADS EQU   EXLSCIPS
EXLLERP  EQU   EXLCOMN+16
@NM00137 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
EXLSYNP  EQU   EXLCOMN+11
@NM00136 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
EXLEODP  EQU   EXLCOMN+6
@NM00135 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00134 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
EXLSTYP  EQU   EXLCOMN+1
EXLID    EQU   EXLCOMN
AMBLCMB  EQU   IDAAMBL+64
AMBLIX   EQU   IDAAMBL+56
AMBLDTA  EQU   IDAAMBL+52
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00133 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00132 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00131 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLSDS  EQU   AMBLVVIC
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00130 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00129 EQU   AMBLQ2
AMBLCBIC EQU   AMBLQ2
@NM00128 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00127 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00126 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00125 EQU   ACBINFL2
ACBCBIC  EQU   ACBINFL2
@NM00124 EQU   ACBINFL2
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFL1
ACBSCRA  EQU   ACBINFL1
ACBIJRQE EQU   ACBINFL1
ACBJEPS  EQU   ACBINFL1
@NM00123 EQU   ACBINFL1
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00122 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00121 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBMSGAR EQU   ACBCOMN+28
@NM00120 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00119 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00118 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00117 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00116 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00115 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBDSN   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00114 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
CAXWNQID EQU   CAXHRPLW+2
CAXHRPLC EQU   CAXHRPLW
CAXASCBP EQU   IGGCAXWA+124
@NM00113 EQU   CAXECB+1
@NM00112 EQU   CAXECBHB
CAXECBPB EQU   CAXECBHB
CAXECBWB EQU   CAXECBHB
CAXRACP  EQU   IGGCAXWA+116
CAXCRACB EQU   IGGCAXWA+112
CAXJDE   EQU   IGGCAXWA+108
CAXPLOCK EQU   CAXCCA
CAXOPEWA EQU   IGGCAXWA+100
COPACB   EQU   CAXOPLST+1
@NM00111 EQU   COPTS
CENLST   EQU   COPTS
@NM00110 EQU   CAXCNAM+22
CAXRADDN EQU   CAXCNAM+14
CAXRATEP EQU   CAXCNAM+10
CAXRACTS EQU   CAXCNAM+6
CAXVOLID EQU   CAXCNAM
CAXRPL   EQU   IGGCAXWA+48
CAXRPLCT EQU   IGGCAXWA+46
CAXASID  EQU   IGGCAXWA+44
CAXFDCI  EQU   CAXCCR+9
CAXCDCI  EQU   CAXCCR+6
CAXNFCI  EQU   CAXCCR+3
CAXHACI  EQU   CAXCCR
CAXUCB   EQU   IGGCAXWA+28
CAXACB   EQU   IGGCAXWA+24
CAXDRWP  EQU   IGGCAXWA+20
CAXSCHWA EQU   IGGCAXWA+16
CAXATIOT EQU   IGGCAXWA+12
CAXACT   EQU   IGGCAXWA+11
@NM00109 EQU   CAXFLG3
CAXF3B6  EQU   CAXFLG3
CAXF3B5  EQU   CAXFLG3
CAXRAC   EQU   CAXFLG3
@NM00108 EQU   CAXFLG3
CAXF3ANE EQU   CAXFLG3
CAXF3AT  EQU   CAXFLG3
CAXF2VTU EQU   CAXFLG2
CAXF2CA  EQU   CAXFLG2
CAXF2CLR EQU   CAXFLG2
CAXF2IOE EQU   CAXFLG2
CAXF2NCR EQU   CAXFLG2
CAXF2NDD EQU   CAXFLG2
CAXF2DT  EQU   CAXFLG2
CAXSCR   EQU   CAXFLGS
CAXCMR   EQU   CAXFLGS
CAXMCT   EQU   CAXFLGS
CAXEOV   EQU   CAXFLGS
CAXCLS   EQU   CAXFLGS
CAXOPN   EQU   CAXFLGS
CAXBLD   EQU   CAXFLGS
CAXCHN   EQU   IGGCAXWA+4
@NM00107 EQU   IGGCAXWA+1
CAXID    EQU   IGGCAXWA
BIBVSRTP EQU   IDABIB+104
BIBASCB  EQU   IDABIB+100
BIBDDNM  EQU   IDABIB+92
BIBSTPNM EQU   IDABIB+84
BIBJOBNM EQU   IDABIB+76
BIBSIOAP EQU   BIBRTNS+12
BIBASYRT EQU   BIBRTNS+8
BIBCEAPP EQU   BIBRTNS+4
BIBINTRF EQU   BIBRTNS
BIBVGTT  EQU   IDABIB+56
BIBPSAB  EQU   IDABIB+52
BIBCSL   EQU   IDABIB+48
BIBWSHD  EQU   IDABIB+44
BIBVCRT  EQU   IDABIB+40
BIBHEBFQ EQU   IDABIB+36
BIBHEBPT EQU   IDABIB+32
BIBPRSPH EQU   IDABIB+28
BIBSPHPT EQU   IDABIB+24
BIBPAMBL EQU   IDABIB+20
BIBDACB  EQU   IDABIB+16
BIBUPT   EQU   IDABIB+8
@NM00106 EQU   IDABIB+5
BIBFLG2  EQU   IDABIB+4
BIBLEN   EQU   BIBHDR+2
@NM00105 EQU   BIBFLG1
BIBCKPT  EQU   BIBFLG1
BIBVIRT  EQU   BIBFLG1
BIBID    EQU   BIBHDR
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00104 EQU   AMBCSWD1+1
@NM00103 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00102 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00101 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00100 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00099 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBSDS   EQU   AMBINFL
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00098 EQU   AMBINFL
@NM00097 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00096 EQU   IDAAMB+38
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00095 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00094 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00093 EQU   AMBFLG0
AMBSWSP  EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
ARDKEYS  EQU   IDAARDB+29
@NM00092 EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDVOLSR EQU   IDAARDB+20
ARDERBA  EQU   IDAARDB+16
ARDLEN   EQU   IDAARDB+2
ARDUSED  EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDKR    EQU   ARDTYPE
ARDID    EQU   IDAARDB
CTGFLDWA EQU   CTGFL+4
CTGFLDTS EQU   CTGFLDRE
@NM00091 EQU   CTGFLDRE
@NM00089 EQU   CTGFBFLG
CTGNGDSN EQU   CTGFBFLG
CTGGDGB  EQU   CTGFBFLG
CTGKEEP  EQU   CTGFBFLG
CTGPAR   EQU   CTGFBFLG
CTGFDBK  EQU   CTGNEWNM
CTGTYPE  EQU   CTGPL+18
@NM00088 EQU   CTGDSORG
CTGOPTNS EQU   CTGDSORG
CTGCVOL  EQU   CTGCAT
CTGFVT   EQU   CTGENT
@NM00087 EQU   CTGOPTN4
CTGTIOT  EQU   CTGOPTN4
CTGBYPMT EQU   CTGOPTN4
CTGCOIN  EQU   CTGOPTN4
CTGNPROF EQU   CTGOPTN4
CTGDOCAT EQU   CTGOPTN4
CTGLBASE EQU   CTGOPTN4
CTGSRH   EQU   CTGOPTN3
CTGGDGL  EQU   CTGOPTN3
CTGSUPLT EQU   CTGOPTN3
@NM00086 EQU   CTGOPTN2
CTGSCR   EQU   CTGOPTN2
CTGOVRID EQU   CTGOPTN2
CTGDISC  EQU   CTGOPTN2
CTGGTNXT EQU   CTGOPTN2
CTGSWAP  EQU   CTGRCATN
CTGGTALL EQU   CTGREL
CTGNSVS  EQU   CTGEXT
CTGGENLD EQU   CTGOPTN1
PDPSFI   EQU   IDAPDPRM+36
@NM00085 EQU   IDAPDPRM+35
PDPNOMSG EQU   PDPMSGFL
PDPNOTRC EQU   PDPMSGFL
PDPSPACE EQU   PDPMSGFL
PDPNOTFC EQU   PDPMSGFL
PDPDSTYP EQU   IDAPDPRM+33
PDPKEY   EQU   IDAPDPRM+32
PDPCTACB EQU   IDAPDPRM+28
PDPDSN   EQU   IDAPDPRM+24
PDPCLSNM EQU   IDAPDPRM+20
PDPVLSER EQU   IDAPDPRM+16
PDPTIOT  EQU   IDAPDPRM+12
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPSFC   EQU   IDAPDPRM+3
PDPFUNC  EQU   IDAPDPRM+2
PDPCODE  EQU   IDAPDPRM+1
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00084 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00083 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00082 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00078 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00075 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00074 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00073 EQU   WTGAREA+20
@NM00072 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00071 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00070 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00069 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00068 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00067 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00066 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00065 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00064 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00063 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00062 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
DXATEXB2 EQU   DXATEXC2
DXEXHASP EQU   DXATEXB1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00058 EQU   DXATCOM2+3
@NM00057 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00056 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00055 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
DXPACBAD EQU   DXPDCBAD+1
@NM00054 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00053 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00052 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDEBXAD EQU   FORCORE+552
DXDSAB   EQU   FORCORE+548
DXDSABAD EQU   FORCORE+544
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXUKEY   EQU   FORCORE+526
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00051 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
@NM00050 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00049 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00048 EQU   DXDAADDR
DXECB    EQU   FORCORE+276
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
@NM00047 EQU   IDASFI+8
@NM00046 EQU   IDASFI+1
SFIDESC  EQU   IDASFI
OPWCIXCI EQU   OPWCURCL+5
OPWIOPEN EQU   OPWFLG2
OPWERR2B EQU   OPWFLG2
OPWEMPUP EQU   OPWFLG2
OPWMODWK EQU   OPWFLG2
OPWDOPEN EQU   OPWFLG2
OPWCDTCI EQU   OPWCURCL+1
OPWPRTBL EQU   OPWCFLG1
OPWSVWRK EQU   OPWCFLG1
OPWUPGR  EQU   OPWCFLG1
OPWPATH  EQU   OPWCFLG1
OPWBASE  EQU   OPWCFLG1
@NM00045 EQU   OPWUPAIX+4
@NM00044 EQU   OPWUPAIX
OPW2YPLH EQU   IDAOPWRK+585
@NM00043 EQU   OPWPTAIX+4
@NM00042 EQU   OPWPTAIX
@NM00041 EQU   OPWBSECL+4
@NM00040 EQU   OPWBSECL
OPWSAVEA EQU   IDAOPWRK+564
OPWERMAP EQU   IDAOPWRK+308
OPWSFI   EQU   IDAOPWRK+296
OPWDACB  EQU   IDAOPWRK+244
@NM00039 EQU   IDAOPWRK+243
OPWBSTRN EQU   IDAOPWRK+242
OPWSTRNO EQU   IDAOPWRK+241
OPWCSTRN EQU   IDAOPWRK+240
OPWBUFNI EQU   IDAOPWRK+236
OPWBUFND EQU   IDAOPWRK+232
OPWTIOT  EQU   IDAOPWRK+228
OPWJSTCB EQU   IDAOPWRK+224
OPWCTCB  EQU   IDAOPWRK+220
OPWWRKPT EQU   IDAOPWRK+208
OPWUACB  EQU   IDAOPWRK+204
OPWUPT   EQU   IDAOPWRK+200
OPWPSDS  EQU   OPWCATTR
OPWSWSP  EQU   OPWCATTR
@NM00038 EQU   OPWCATTR
@NM00037 EQU   OPWQ2
OPWCBIC  EQU   OPWQ2
OPWPAMBL EQU   IDAOPWRK+188
OPWBAMBL EQU   IDAOPWRK+184
OPWPCON  EQU   IDAOPWRK+180
OPWBCON  EQU   IDAOPWRK+176
OPWCAMBL EQU   IDAOPWRK+172
OPWXAMBL EQU   IDAOPWRK+168
OPWSSL   EQU   OPWSAVE+16
OPWDSL   EQU   OPWSAVE+12
OPWPSL   EQU   OPWSAVE+8
OPWESL   EQU   OPWSAVE+4
OPWCSL   EQU   OPWSAVE
OPWVFMPT EQU   OPWVFMPL+4
OPWVFMLN EQU   OPWVFMPL+1
OPWVFMSP EQU   OPWVFMPL
OPWVRG13 EQU   OPWVLSAV+4
OPWVRG12 EQU   OPWVLSAV
OPWVANCS EQU   OPWVSMWA+76
OPWVREQL EQU   OPWVGSPL+9
OPWVGFLG EQU   OPWVGSPL+8
OPWVGSPT EQU   OPWVGSPL+4
OPWVGETL EQU   OPWVGSPL+1
OPWVGSSP EQU   OPWVGSPL
OPWVSAVE EQU   OPWVSMWA+24
OPWVR13  EQU   OPWVSMWA+20
OPWVHDRE EQU   OPWVSMWA+16
OPWVCSLE EQU   OPWVSMWA+12
OPWVCSLP EQU   OPWVSMWA+8
OPWVTBLP EQU   OPWVSMWA+4
OPWVANCP EQU   OPWVSMWA
@NM00036 EQU   OPWVSMPL+14
OPWVMTCB EQU   OPWVMFLG
OPWVMNSL EQU   OPWVMFLG
OPWVMSRB EQU   OPWVMFLG
OPWVMDXK EQU   OPWVMFLG
OPWVMKE5 EQU   OPWVMFLG
OPWVMPGB EQU   OPWVMFLG
OPWVMTYP EQU   OPWVSMPL+12
OPWVMADR EQU   OPWVSMPL+8
OPWVMLNG EQU   OPWVSMPL+5
OPWVMSP  EQU   OPWVSMPL+4
OPWVMANC EQU   OPWVSMPL
OPWDFR   EQU   OPWQ
OPWESDS  EQU   OPWQ
OPWKSDS  EQU   OPWQ
OPWUBF   EQU   OPWQ
OPWFSTP  EQU   OPWQ
OPWLSR   EQU   OPWQ
OPWGSR   EQU   OPWQ
OPWDDC   EQU   OPWQ
OPWDCI   EQU   OPWIDF+4
OPWBIB   EQU   IDAOPWRK+16
@NM00035 EQU   OPWFLGS4
OPWFULL  EQU   OPWFLGS4
@NM00034 EQU   OPWFLGS3
OPWRSTRT EQU   OPWFLGS3
OPWNOWRK EQU   OPWFLGS3
OPWUPGOP EQU   OPWFLGS3
OPWPUPGR EQU   OPWFLGS3
OPWDAVAT EQU   OPWFLGS3
@NM00033 EQU   OPWFLGS2
OPWDUMMY EQU   OPWFLGS2
@NM00032 EQU   OPWFLGS1
OPWSDS   EQU   OPWVVIC
OPWID    EQU   IDAOPWRK+4
OPWLENTH EQU   IDAOPWRK+1
OPWSUBPL EQU   IDAOPWRK
@NM00031 EQU   CTEXTENT+20
CTRBAEND EQU   CTEXTENT+16
CTRBABEG EQU   CTEXTENT+12
CTNOTRKS EQU   CTEXTENT+10
CTHHEND  EQU   CTABSEND+2
CTCCEND  EQU   CTABSEND
CTHHBEG  EQU   CTABSBEG+2
CTCCBEG  EQU   CTABSBEG
@NM00030 EQU   CTEXTENT+1
CTEXTFLG EQU   CTEXTENT
CTKEYEN1 EQU   CTVOLENT+20
@NM00029 EQU   CTVOLENT+18
CTVOLUCB EQU   CTVOLENT+4
@NM00028 EQU   CTVOLENT+2
CTVOLMT  EQU   CTVOLFLG
@NM00027 EQU   CTINFO+214
@NM00026 EQU   CTINFO+49
CTSBYTRK EQU   CTINFO+42
CTSBYTAU EQU   CTINFO+34
CTVIRT   EQU   CTDEV2
@NM00025 EQU   CTDEV2
@NM00024 EQU   CTDEVTYP
@NM00023 EQU   CTINFO+4
CTUPD    EQU   CTAUTH
CTCINV   EQU   CTAUTH
CTFULL   EQU   CTAUTH
@NM00022 EQU   CTSHROP
CTTOVFL  EQU   CTATTRA
CTTEMPEX EQU   CTATTRA
CTRDONLY EQU   CTATTRA
@NM00021 EQU   CTATTRA
CTERASE  EQU   CTATTRA
CTRELOP  EQU   CTATTRA
CTUNIQ   EQU   CTATTRA
CTAMDSPD EQU   CTATTRA
AMATIOE  EQU   AMBWORK+8
AMATIOT  EQU   AMBWORK+4
AMACATLG EQU   AMBWORK
@NM00020 EQU   IDAAMDSB+41
@NM00019 EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
@NM00018 EQU   @NM00017
@NM00016 EQU   DSPSEC+1
DSPID    EQU   DSPSEC
@NM00015 EQU   DSNMPARM+4
@NM00014 EQU   DSNMPARM
@NM00013 EQU   CIINFO+4
@NM00012 EQU   CIINFO
@NM00011 EQU   VOLSTS+4
VLSFI    EQU   VOLSTS+1
VLID     EQU   VOLSTS
@NM00010 EQU   WAPT
@NM00009 EQU   DSATTR2
@NM00008 EQU   DSATTR1
@NM00007 EQU   DSATTR1
@NM00006 EQU   EXTENT+20
RBAEXT   EQU   EXTENT+12
ABSOLUTE EQU   EXTENT+2
DSSN     EQU   EXTENT
NOEXTNT  EQU   VOLPHY+9
CANDIDAT EQU   VOLFLG
PRIME    EQU   VOLFLG
@NM00005 EQU   SPACOP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00304 EQU   @RC00297
@RF00351 EQU   @RC00341
@RF00354 EQU   @RC00341
@RC00361 EQU   @RC00358
@RF00379 EQU   @RC00358
@RC00415 EQU   @RC00331
@RC00472 EQU   @RC00463
@PB00010 EQU   @EL00009
@RC00977 EQU   @RC00973
@RC01017 EQU   @RC01016
@RC01081 EQU   @RC01070
@RF01203 EQU   @RC01183
@PB00028 EQU   @PB00029
@RF00370 EQU   @RC00361
@RC00499 EQU   @RC00472
@RF01020 EQU   @RC01017
@PB00027 EQU   @PB00028
@RF00506 EQU   @RC00499
@PB00026 EQU   @PB00027
@PB00025 EQU   @PB00026
@PB00024 EQU   @PB00025
@PB00023 EQU   @PB00024
@PB00022 EQU   @PB00023
@PB00021 EQU   @PB00022
@PB00020 EQU   @PB00021
@PB00019 EQU   @PB00020
@PB00018 EQU   @PB00019
@PB00017 EQU   @PB00018
@PB00016 EQU   @PB00017
@PB00015 EQU   @PB00016
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00009 EQU   @PB00011
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0192C,(C'PLS1836',0701,78151)
