         TITLE 'IDA0192F - VSAM, OPEN CLUSTERS IN SPHERE VS2-3         *
                        '
IDA0192F CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192F  78.199'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  LA    @12,4095(,@03)                                      0001
         USING @PSTART,@03                                         0001
         USING @PSTART+4095,@12                                    0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0282
*/********************************************************************/
*/*                                                                  */
*/*                      MODULE IDA0192F                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0282
*   RSTATRTN=IDAR192F;              /* INDIC 192F IN CONTROL @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0282
         MVC   RSTATRTN(4,@05),@CC04581                            0282
*/********************************************************************/
*/*           IDAGMAIN - GETS CORE STORAGE FOR AUTOMATICS.           */
*/*                      FOR VS2 IDAGMAIN WILL MOVE THE      @Z30SSRL*/
*/*                      ID AND DATE OF THE MODULE TO A      @Z30SSRL*/
*/*                      LOCATION DIRECTLY AFTER THE PLS     @Z30SSRL*/
*/*                      GENERATED SAVE AREA.                @Z30SSRL*/
*/*           DATE OF LAST CHANGE = 3 DECEMBER 74            @Z30SSRL*/
*/********************************************************************/
*                                                                  0283
*   GEN;                                                           0283
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL ZERO
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  ZERO THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR ZERO
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        ZERO IF THE GETMAIN WAS UNSUCCESSFUL.
*   RFY                                                            0284
*    (R1,                                                          0284
*     RETCODE) RSTD;                                               0284
*   IF RETCODE=0 THEN               /* IF GETMAIN ERROR              */
         LTR   RETCODE,RETCODE                                     0285
         BNZ   @RF00285                                            0285
*     DO;                           /* THEN CALL PROB DET            */
*       ACBERFLG=OPERR136;          /* SET ACB ERROR FLAG            */
         MVI   ACBERFLG(RACB),X'88'                                0287
*       PDPCODE=PP20;               /* SET PROB DET ERROR CODE       */
         L     @14,OPWCOMWA(,RCORE)                                0288
         MVI   PDPCODE+280(@14),X'14'                              0288
*       R1=OPWCOMWA;                /* PT TO COMMON WORK AREA        */
         LR    R1,@14                                              0289
*       RFY                                                        0290
*        (R1,                                                      0290
*         RETCODE) UNRSTD;                                         0290
*       RSTATRTN=IDAR192P;          /* INDIC 192P CONTROL    @Y30DSDP*/
         MVC   RSTATRTN(4,@14),@CC04587                            0291
*       CALL IDA0192P;              /* WRITE PROB DET MESSAGE        */
         L     @15,@CV04818                                        0292
         BALR  @14,@15                                             0292
*       RSTATRTN=IDAR192F;          /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0293
         MVC   RSTATRTN(4,@05),@CC04581                            0293
*       OPWNOWRK=ON;                /* IND NO MODULE WORK AREA       */
         OI    OPWNOWRK(RCORE),B'00010000'                         0294
*       GOTO TERM192F;              /* RESTORE ACB AND EXIT MODULE   */
         B     TERM192F                                            0295
*     END;                                                         0296
*                                                                  0296
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH MODULE ADDRESSABILITY                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0297
*   RFY                                                            0297
*     R15 RSTD;                                                    0297
@RF00285 DS    0H                                                  0298
*   GEN(ST R13,4(R15))                                             0298
*   REFS(R13,R15) NOSETS;           /* SAVE LAST SAVE AREA PTR       */
         ST R13,4(R15)
*   R13=R15;                        /* SET BASE FOR MOD WORK AREA    */
         LR    R13,R15                                             0299
*   RFY                                                            0300
*     R15 UNRSTD;                                                  0300
*   GEN(USING @DATD,R13)                                           0301
*   REFS(R13) NOSETS;                                              0301
*                                                                  0301
         USING @DATD,R13
*   /*****************************************************************/
*   /*                                                               */
*   /* MAIN ROUTINE                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0302
*   IF OPWDUMMY=OFF THEN            /* IF NOT DUMMY DATA SET         */
         TM    OPWDUMMY(RCORE),B'00010000'                         0302
         BNZ   @RF00302                                            0302
*     CALL VOLMNT;                  /* MOUNT AND VERIFY VOLUMES      */
         BAL   @14,VOLMNT                                          0303
*   IF OPWRSTRT=OFF THEN            /* IF NOT RESTART PROCESSING     */
@RF00302 TM    OPWRSTRT(RCORE),B'00001000'                         0304
         BNZ   @RF00304                                            0304
*     DO;                           /* THEN DO NORMAL OPEN           */
*       CALL OPNBASE;               /* OPEN BASE DS                  */
         BAL   @14,OPNBASE                                         0306
*       IF OPWDUMMY=OFF THEN        /* IF NOT DUMMY DS               */
         TM    OPWDUMMY(RCORE),B'00010000'                         0307
         BNZ   @RF00307                                            0307
*         DO;                       /* THEN DO UPGRADE PROCESSING    */
*           IF AMBLWRIT=ON&AMBLCINV=OFF THEN/* IF BASE OPEN FOR    0309
*                                      OUTPUT AND NOT CINV PROCESSING*/
         L     @05,MWAXAMBL                                        0309
         TM    AMBLWRIT(@05),B'00100000'                           0309
         BNO   @RF00309                                            0309
         TM    AMBLCINV(@05),B'01000000'                           0309
         BNZ   @RF00309                                            0309
*             IF OPWNOUPG>0&BIBUPT=0 THEN/* THEN IF UPGR SET EXISTS
*                                      AND NOT ALREADY OPEN          */
         CLI   OPWNOUPG(RCORE),0                                   0310
         BNH   @RF00310                                            0310
         L     @05,OPWBIB(,RCORE)                                  0310
         L     @05,BIBUPT(,@05)                                    0310
         LTR   @05,@05                                             0310
         BNZ   @RF00310                                            0310
*               CALL OPNUPGR;       /* THEN OPEN UPGRADE SET         */
         BAL   @14,OPNUPGR                                         0311
*           IF OPWPDTCI^=0 THEN     /* IF PATH PROCESSING            */
@RF00310 DS    0H                                                  0312
@RF00309 L     @05,OPWPDTCI-1(,RCORE)                              0312
         LA    @05,0(,@05)                                         0312
         LTR   @05,@05                                             0312
         BZ    @RF00312                                            0312
*             CALL OPNPATH;         /* THEN OPEN PATH                */
         BAL   @14,OPNPATH                                         0313
*         END;                                                     0314
@RF00312 DS    0H                                                  0315
*     END;                                                         0315
@RF00307 DS    0H                                                  0316
*TERM192F:                                                         0316
*                                                                  0316
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: MODULE TERMINATION.  FREES MODULE WORK AREA AND SETS */
*/*             A RETURN CODE IN REGISTER 15.                        */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO OPW IN RCORE.                              */
*/*                                                                  */
*/*   OUTPUTS:  1. IF NO ERRORS ARE DETECTED, REGISTER 15 IS SET TO  */
*/*                ZERO.  IF AN ERROR IS DETECTED, REGISTER 15 IS    */
*/*                SET TO EIGHT.                                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0316
*   RFY                                                            0316
*    (R0,                                                          0316
*     R1,                                                          0316
*     R6) RSTD;                                                    0316
@RF00304 DS    0H                                                  0316
TERM192F DS    0H                                                  0317
*   IF OPWNOWRK=OFF THEN            /* IF MODULE WORK AREA EXISTS    */
         TM    OPWNOWRK(RCORE),B'00010000'                         0317
         BNZ   @RF00317                                            0317
*     DO;                           /* THEN FREE MODULE WORK AREA    */
*       MWAGFSP=WKPOOL;             /* INIT SUBPOOL OF WORK AREA     */
         MVI   MWAGFSP,X'FC'                                       0319
*       GEN(L R0,@SIZDATD)                                         0320
*       SETS(R0);                   /* INIT SIZE                     */
         L R0,@SIZDATD
*       MWAGFLEN=R0;                /* LD LENGTH OF MWA              */
         STCM  R0,7,MWAGFLEN                                       0321
*       R1=R13;                     /* PT TO MODULE WORK AREA        */
         LR    R1,R13                                              0322
*       R0=MWAGFR0;                 /* LD LENGTH AND SUBPPOL OF MWA  */
         L     R0,MWAGFR0                                          0323
*       IF MWAOFAIL=ON THEN         /* IF OPEN FAILURE               */
         TM    MWAOFAIL,B'10000000'                                0324
         BNO   @RF00324                                            0324
*         R6=8;                     /* THEN IND OPEN FAILURE         */
         LA    R6,8                                                0325
*       ELSE                        /* NO OPEN FAILURE               */
*         R6=0;                     /* ELSE IND OPEN SUCCESSFUL      */
         B     @RC00324                                            0326
@RF00324 SLR   R6,R6                                               0326
*       GEN(L R13,4(R13))                                          0327
*       SETS(R13);                  /* PT TO LAST SAVE AREA          */
@RC00324 DS    0H                                                  0327
         L R13,4(R13)
*       GEN(FREEMAIN R,LV=(0),A=(1));/* FREE MODULE WORK AREA        */
         FREEMAIN R,LV=(0),A=(1)
*     END;                                                         0329
*   ELSE                            /* MODULE WORK AREA DOES NOT   0330
*                                      EXIST                         */
*     R6=8;                         /* ELSE IND OPEN FAILURE         */
         B     @RC00317                                            0330
@RF00317 LA    R6,8                                                0330
*   GEN REFS(R6,R13) SETS(R12,RET,RETCODE);                        0331
@RC00317 DS    0H                                                  0331
         ST    R6,16(R13)               STORE RETURN CODE
         LM    RET,R12,12(R13)          RESTORE REGISTERS
         BR    RET                      RETURN TO
*   RFY                                                            0332
*    (R0,                                                          0332
*     R1,                                                          0332
*     R6) UNRSTD;                                                  0332
*VOLMNT:                                                           0333
*                                                                  0333
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: VOLUME MOUNT.  THIS ROUTINE SCANS THE TIOT ENTRY     */
*/*             FOR THE SPHERE.  FOR EACH DEVICE TYPE IN THE TIOT    */
*/*             ENTRY, A VOLUME LIST (VVOLL) IS BUILT.  IF THIS IS   */
*/*             A CONNECT OPEN AND A VMT EXISTS FOR THE DEVICE       */
*/*             TYPE ASSOCIATED WITH THE TIOT ENTRY, THEN CALL       */
*/*             OLDDEV TO MOUNT VOLUMES, OTHERWISE CALL NEWDEV       */
*/*             TO MOUNT VOLUMES.  IF THIS IS A PRIMARY OPEN, THEN   */
*/*             CALL NEWDEV TO MOUNT VOLUMES.                        */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO TIOT ENTRY IN OPWTIOT.                     */
*/*                                                                  */
*/*   OUTPUTS:  1. VOLUMES MOUNTED FOR SPHERE AND VMT'S BUILT.       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0333
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0333
VOLMNT   DS    0H                                                  0334
*   PDPFUNC=PDF85;                  /* SET FUNCTION CODE             */
         L     @05,OPWCOMWA(,RCORE)                                0334
         MVI   PDPFUNC+280(@05),X'55'                              0334
*   RFY                                                            0335
*     RET RSTD;                                                    0335
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0336
*   RFY                                                            0337
*     RET UNRSTD;                                                  0337
*   MWADSABP=DXDSABAD;              /* SET UP DSAB ADDR      @Y30DSDP*/
         L     @15,DXDSABAD(,@05)                                  0338
         ST    @15,MWADSABP                                        0338
*   MWATIOT=OPWTIOT;                /* PT TO TIOT ENTRY FOR DDNAME   */
         L     @15,OPWTIOT(,RCORE)                                 0339
         ST    @15,MWATIOT                                         0339
*   MWANEWSW=ON;                    /* IND NEW VVOLL NEEDED          */
         OI    MWANEWSW,B'00001000'                                0340
*   MWAJFCB=ADDR(DXJBF);            /* PT TO JFCB IN COMMON WRK AREA */
         LA    @05,DXJBF(,@05)                                     0341
         ST    @05,MWAJFCB                                         0341
*   DO UNTIL(MWADSABP=0|TIOEDDNM^='        ');/* SCAN TIOT ENTRY FOR
*                                      ALL DEVICE TYPES      @Z30SSDP*/
@DL00342 DS    0H                                                  0343
*     IF MWANEWSW=ON THEN           /* IF NEW VVOLL NEEDED           */
         TM    MWANEWSW,B'00001000'                                0343
         BNO   @RF00343                                            0343
*       DO;                         /* THEN BUILD NEW VOLUME LIST  0344
*                                      (VVOLL) AND INITIALIZE FIXED
*                                      PART OF HEADER                */
*         MWAGFLEN=LENGTH(IDAVVOLL)+LENGTH(VVOLLENT)*JFCBNVOL;/* CALC
*                                      LENGTH OF VVOLL               */
         L     @05,MWAJFCB                                         0345
         SLR   @15,@15                                             0345
         IC    @15,JFCBNVOL(,@05)                                  0345
         MH    @15,@CH00033                                        0345
         LA    @15,36(,@15)                                        0345
         STCM  @15,7,MWAGFLEN                                      0345
*         MWAGFSP=WKPOOL;           /* INIT SUBPOOL                  */
         MVI   MWAGFSP,X'FC'                                       0346
*         CALL GETCORE;             /* OBTAIN STORAGE FOR VVOLL      */
         BAL   @14,GETCORE                                         0347
*         MWAVVOLL=MWAGFADR;        /* INIT PTR TO VVOLL             */
         L     @05,MWAGFADR                                        0348
         ST    @05,MWAVVOLL                                        0348
*         MWAVVLNG=MWAGFLEN;        /* SAVE LENGTH OF VVOLL          */
         MVC   MWAVVLNG(3),MWAGFLEN                                0349
*         MWAVVNBR=JFCBNVOL;        /* INIT MAX NO. OF ENTRIES IN  0350
*                                      VVOLL                         */
         L     @01,MWAJFCB                                         0350
         SLR   @00,@00                                             0350
         IC    @00,JFCBNVOL(,@01)                                  0350
         STH   @00,MWAVVNBR                                        0350
*         VVOLLID=ON;               /* IND VOLUME LIST               */
*         VVOLLOPE=ON;              /* IND CALLER IS OPEN            */
         OI    VVOLLID(@05),B'01010000'                            0352
*         IF OPWSCRA^=ON&OPWUCRA^=ON&OPWCAT^=ON THEN/* IF NOT      0353
*                                      CATALOG, SCRA OR UCRA @XM02259*/
         TM    OPWSCRA(RCORE),B'01000000'                          0353
         BO    @RF00353                                            0353
         TM    OPWUCRA(RCORE),B'10000000'                          0353
         BO    @RF00353                                            0353
         TM    OPWCAT(RCORE),B'10000000'                           0353
         BO    @RF00353                                            0353
*           VVOLLACB=OPWCACB;       /* INIT PTR TO CATALOG ACB       */
         L     @15,OPWCACB(,RCORE)                                 0354
         ST    @15,VVOLLACB(,@05)                                  0354
*         MWANEWSW=OFF;             /* RESET NEW VVOLL NEEDED INDR   */
@RF00353 NI    MWANEWSW,B'11110111'                                0355
*       END;                                                       0356
*                                                                  0356
*     /***************************************************************/
*     /*                                                             */
*     /* INITIALIZE VARIABLE PART OF VVOLL HEADER                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0357
*     VVOLLNBR=JFCBNVOL;            /* INIT NO. OF VOLUME ENTRIES    */
@RF00343 L     @05,MWAVVOLL                                        0357
         L     @01,MWAJFCB                                         0357
         SLR   @00,@00                                             0357
         IC    @00,JFCBNVOL(,@01)                                  0357
         STH   @00,VVOLLNBR(,@05)                                  0357
*     VVOLLTAB=MWATIOT;             /* INIT PTR TO TIOT ENTRY        */
         L     @15,MWATIOT                                         0358
         ST    @15,VVOLLTAB(,@05)                                  0358
*     VVOLLERR=0;                   /* ZERO RETURN CODE              */
         SLR   @14,@14                                             0359
         ST    @14,VVOLLERR(,@05)                                  0359
*     VVOLLSFI=VVOLLSFI&&VVOLLSFI;  /* ZERO SUB-FUNCTION INFORMATION */
         XC    VVOLLSFI(12,@05),VVOLLSFI(@05)                      0360
*     MWADEV=UCBTYP(2:4);           /* LD DEVICE TYPE FROM UCB       */
         L     @05,TIOEFSRT-1(,@15)                                0361
         LA    @05,0(,@05)                                         0361
         MVC   MWADEV(3),UCBTYP+1(@05)                             0361
*     MWADVOP=MWADVOP&DVOPMASK;     /* RESET UNNECESSARY BITS IN   0362
*                                      OPTION BYTE                   */
         NI    MWADVOP,B'00001000'                                 0362
*     IF UCB2OPT4=ON THEN           /* IF VIRTUAL UCB                */
         TM    UCB2OPT4(@05),B'00001000'                           0363
         BNO   @RF00363                                            0363
*       BIBVIRT=ON;                 /* THEN IND VIRT UCB'S IN SPHERE */
         L     @05,OPWBIB(,RCORE)                                  0364
         OI    BIBVIRT(@05),B'10000000'                            0364
*     IF OPWBCON^=0 THEN            /* IF CONNECTING                 */
@RF00363 L     @05,OPWBCON(,RCORE)                                 0365
         LTR   @05,@05                                             0365
         BZ    @RF00365                                            0365
*       DO;                         /* THEN SEARCH VMT CHAIN FOR LIKE
*                                      DEVICE TYPE                   */
*         MWAVMT=BIBVMT;            /* PT TO FIRST VMT               */
         L     @05,OPWBIB(,RCORE)                                  0367
         L     @05,BIBVMT(,@05)                                    0367
         ST    @05,MWAVMT                                          0367
*         DO WHILE(MWAVMT^=0&MWADEV^=VMTDEV);/* SCAN VMT'S FOR LIKE
*                                      DEVICE TYPE                   */
         B     @DE00368                                            0368
@DL00368 DS    0H                                                  0369
*           MWAVMT=VMTNXT;          /* PT TO NEXT VMT ON CHAIN       */
         L     @05,MWAVMT                                          0369
         L     @05,VMTNXT(,@05)                                    0369
         ST    @05,MWAVMT                                          0369
*         END;                                                     0370
@DE00368 L     @05,MWAVMT                                          0370
         LTR   @05,@05                                             0370
         BZ    @DC00368                                            0370
         CLC   MWADEV(3),VMTDEV(@05)                               0370
         BNE   @DL00368                                            0370
@DC00368 DS    0H                                                  0371
*         IF MWAVMT^=0 THEN         /* IF LIKE DEVICE TYPE FOUND     */
         L     @05,MWAVMT                                          0371
         LTR   @05,@05                                             0371
         BZ    @RF00371                                            0371
*           CALL OLDDEV;            /* MOUNT VOLUMES FOR EXISTING  0372
*                                      DEVICE TYPE                   */
         BAL   @14,OLDDEV                                          0372
*         ELSE                      /* LIKE DEVICE TYPE NOT FOUND    */
*           CALL NEWDEV;            /* MOUNT VOLUMES FOR NEW DEVICE
*                                      TYPE                          */
         B     @RC00371                                            0373
@RF00371 BAL   @14,NEWDEV                                          0373
*       END;                                                       0374
*     ELSE                          /* NOT CONNECTING                */
*       CALL NEWDEV;                /* NOT CONNECTING. MOUNT VOLUMES
*                                      FOR NEW DEVICE TYPE           */
         B     @RC00365                                            0375
@RF00365 BAL   @14,NEWDEV                                          0375
*     IF MWADSABP^=0 THEN           /* IF THERE IS A DSAB POINTER    */
@RC00365 L     @05,MWADSABP                                        0376
         SLR   @15,@15                                             0376
         CR    @05,@15                                             0376
         BE    @RF00376                                            0376
*       DO;                         /* CHECK FOR CONCATENATION       */
*         MWADSABP=DSABFCHN;        /* UPDATE DSAB PTR       @Z30SSDP*/
         L     @05,DSABFCHN(,@05)                                  0378
         ST    @05,MWADSABP                                        0378
*         MWATIOT=DSABTIOT;         /* UPDATE TIOT ENTRY PTR @Z30SSDP*/
         L     @14,DSABTIOT(,@05)                                  0379
         ST    @14,MWATIOT                                         0379
*         IF MWADSABP^=0&           /* CHK FOR CONCATENATION @Y30DSDP*/
*             TIOEDDNM='        ' THEN/* TIOT DD NAME IS BLANK     0380
*                                                            @Z30SSRL*/
         CR    @05,@15                                             0380
         BE    @RF00380                                            0380
         CLC   TIOEDDNM(8,@14),@CC04828                            0380
         BNE   @RF00380                                            0380
*           DO;                     /* YES,                  @Z30SSDP*/
*             MWAJFTTR(1:3)=TIOEJFCB;/* LD TTR OF NEXT JFCB          */
         MVC   MWAJFTTR(3),TIOEJFCB(@14)                           0382
*             CALL READJFCB;        /* READ NEXT JFCB                */
         BAL   @14,READJFCB                                        0383
*             IF MWAVVNBR<JFCBNVOL THEN/* IF OLD VVOLL NOT LARGE   0384
*                                      ENOUGH                        */
         LH    @05,MWAVVNBR                                        0384
         L     @01,MWAJFCB                                         0384
         SLR   @00,@00                                             0384
         IC    @00,JFCBNVOL(,@01)                                  0384
         CR    @05,@00                                             0384
         BNL   @RF00384                                            0384
*               DO;                 /* THEN FREE OLD VVOLL           */
*                 MWAGFADR=MWAVVOLL;/* POINT TO VVOLL                */
         L     @05,MWAVVOLL                                        0386
         ST    @05,MWAGFADR                                        0386
*                 MWAGFSP=WKPOOL;   /* INIT SUBPOOL                  */
         MVI   MWAGFSP,X'FC'                                       0387
*                 MWAGFLEN=MWAVVLNG;/* INIT LENGTH                   */
         MVC   MWAGFLEN(3),MWAVVLNG                                0388
*                 CALL FREECORE;    /* FREE OLD VVOLL                */
         BAL   @14,FREECORE                                        0389
*                 MWANEWSW=ON;      /* IND NEW VVOLL NEEDED          */
         OI    MWANEWSW,B'00001000'                                0390
*               END;                                               0391
*           END;                                                   0392
@RF00384 DS    0H                                                  0393
*       END;                                                       0393
@RF00380 DS    0H                                                  0394
*   END;                                                           0394
@RF00376 DS    0H                                                  0394
@DE00342 L     @05,MWADSABP                                        0394
         LTR   @05,@05                                             0394
         BZ    @DC00342                                            0394
         L     @05,MWATIOT                                         0394
         CLC   TIOEDDNM(8,@05),@CC04828                            0394
         BE    @DL00342                                            0394
@DC00342 DS    0H                                                  0395
*   MWAGFADR=MWAVVOLL;              /* PT TO VVOLL                   */
         L     @05,MWAVVOLL                                        0395
         ST    @05,MWAGFADR                                        0395
*   MWAGFSP=WKPOOL;                 /* INIT SUBPOOL OF CURRENT VVOLL */
         MVI   MWAGFSP,X'FC'                                       0396
*   MWAGFLEN=MWAVVLNG;              /* INIT LENGTH OF CURRENT VVOLL  */
         MVC   MWAGFLEN(3),MWAVVLNG                                0397
*   CALL FREECORE;                  /* FREE CURRENT VVOLL            */
         BAL   @14,FREECORE                                        0398
*   IF MWAJFBSW=ON THEN             /* IF JFCB WORK AREA OBTAINED    */
         TM    MWAJFBSW,B'00000010'                                0399
         BNO   @RF00399                                            0399
*     DO;                           /* THEN FREE IT                  */
*       MWAGFADR=MWAJFBWA;          /* INIT ADDRESS                  */
         L     @05,MWAJFBWA                                        0401
         ST    @05,MWAGFADR                                        0401
*       MWAGFSP=WKPOOL;             /* INIT SUBPOOL                  */
         MVI   MWAGFSP,X'FC'                                       0402
*       MWAGFLEN=LENGTH(JFCBWRKA);  /* INIT LENGTH                   */
         MVC   MWAGFLEN(3),@CF04928+1                              0403
*       CALL FREECORE;              /* FREE JFCB WORK AREA           */
         BAL   @14,FREECORE                                        0404
*       MWAJFBSW=OFF;               /* IND WORK AREA FREED           */
         NI    MWAJFBSW,B'11111101'                                0405
*     END;                                                         0406
*   IF OPWCRA^='000000000000'X THEN /* IF CATLG RECOVERY             */
@RF00399 CLC   OPWCRA(6,RCORE),@CB04834                            0407
         BE    @RF00407                                            0407
*     DO;                           /* THEN DETERMINE IF CRA VOLUME
*                                      MOUNTED                       */
*       MWAVMT=BIBVMT;              /* PT TO FIRST VMT               */
         L     @05,OPWBIB(,RCORE)                                  0409
         L     @05,BIBVMT(,@05)                                    0409
         ST    @05,MWAVMT                                          0409
*       DO WHILE(MWAVMT^=0&MWACRAMT=OFF);/* SCAN VMT CHAIN FOR CRA 0410
*                                      VOLUME                        */
         B     @DE00410                                            0410
@DL00410 DS    0H                                                  0411
*         DO MWAI=1 TO VMTNOVOL WHILE(VMTVLSER(MWAI)^=OPWCRA);/* SCAN
*                                      VMT FOR CRA VOLUME            */
         LA    @05,1                                               0411
         B     @DE00411                                            0411
@DL00411 LR    @15,@05                                             0411
         SLA   @15,4                                               0411
         L     @01,MWAVMT                                          0411
         ALR   @01,@15                                             0411
         CLC   VMTVLSER-16(6,@01),OPWCRA(RCORE)                    0411
         BE    @DC00411                                            0411
*         END;                                                     0412
         AL    @05,@CF00053                                        0412
@DE00411 ST    @05,MWAI                                            0412
         L     @01,MWAVMT                                          0412
         CH    @05,VMTNOVOL(,@01)                                  0412
         BNH   @DL00411                                            0412
@DC00411 DS    0H                                                  0413
*         IF MWAI>VMTNOVOL THEN     /* IF CRA VOLUME NOT FOUND       */
         L     @05,MWAVMT                                          0413
         L     @15,MWAI                                            0413
         CH    @15,VMTNOVOL(,@05)                                  0413
         BNH   @RF00413                                            0413
*           MWAVMT=VMTNXT;          /* THEN PT TO NEXT VMT           */
         L     @05,VMTNXT(,@05)                                    0414
         ST    @05,MWAVMT                                          0414
*         ELSE                      /* CRA VOLUME FOUND              */
*           MWACRAMT=ON;            /* IND CRA VOL MOUNTED           */
         B     @RC00413                                            0415
@RF00413 OI    MWACRAMT,B'00000100'                                0415
*       END;                                                       0416
@RC00413 DS    0H                                                  0416
@DE00410 L     @05,MWAVMT                                          0416
         LTR   @05,@05                                             0416
         BZ    @DC00410                                            0416
         TM    MWACRAMT,B'00000100'                                0416
         BZ    @DL00410                                            0416
@DC00410 DS    0H                                                  0417
*       IF MWACRAMT=OFF THEN        /* IF CRA VOL NOT MOUNTED        */
         TM    MWACRAMT,B'00000100'                                0417
         BNZ   @RF00417                                            0417
*         DO;                       /* THEN WRITE PROB DET MSG       */
*           PDPCODE=PP168;          /* THEN SET FAILING ERROR CODE   */
         L     @05,OPWCOMWA(,RCORE)                                0419
         MVI   PDPCODE+280(@05),X'A8'                              0419
*           CALL PROBDT;            /* WRITE MESSAGE                 */
         BAL   @14,PROBDT                                          0420
*         END;                                                     0421
*     END;                                                         0422
@RF00417 DS    0H                                                  0423
*   RFY                                                            0423
*     RET RSTD;                                                    0423
@RF00407 DS    0H                                                  0424
*   RET=MWASAVEA;                   /* RESTORE RETURN ADDR           */
         L     RET,MWASAVEA                                        0424
*   RFY                                                            0425
*     RET UNRSTD;                                                  0425
*   END VOLMNT;                                                    0426
@EL00002 DS    0H                                                  0426
@EF00002 DS    0H                                                  0426
@ER00002 BR    @14                                                 0426
*NEWDEV:                                                           0427
*                                                                  0427
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: VOLUME MOUNT FOR NEW DEVICE TYPE.  THIS ROUTINE      */
*/*             MOVES VOLUME SERIAL NUMBERS FROM JFCB AND JFCB       */
*/*             EXTENSIONS INTO THE VVOLL.  IDA0192V IS CALLED TO    */
*/*             MOUNT THE VOLUMES IN THE VVOLL.  UPON RETURN FROM    */
*/*             IDA0192V A VMT IS BUILT FOR THE MOUNTED VOLUMES      */
*/*             AND ADDED TO THE VMT CHAIN.                          */
*/*                                                                  */
*/*   INPUTS    1. PTR TO VVOLL IN OPWVVOLL.                         */
*/*             2. PTR TO TIOT ENTRY IN MWATIOT.                     */
*/*             3. PTR TO JFCB IN MWAJFCB.                           */
*/*             4. NUMBER OF VOLUME SERIAL NUMBERS IN JFCB AND       */
*/*                EXTENSIONS IN VVOLLNBR.                           */
*/*                                                                  */
*/*   OUTPUTS:  1. VMT FOR NEW DEVICE ADDED TO VMT CHAIN.            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0427
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0427
NEWDEV   DS    0H                                                  0428
*   RFY                                                            0428
*     RET RSTD;                                                    0428
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        0429
*   RFY                                                            0430
*     RET UNRSTD;                                                  0430
*                                                                  0430
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE VOLUME SERIAL NUMBER FROM JFCB AND JFCB EXTENSIONS INTO  */
*   /* VVOLL.                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0431
*   RFY                                                            0431
*     VOLSER BASED(MWAPTRA);                                       0431
*   MWAPTRA=ADDR(JFCBVOLS);         /* PT TO VOL SER NOS. IN JFCB    */
         L     @05,MWAJFCB                                         0432
         LA    @05,JFCBVOLS(,@05)                                  0432
         ST    @05,MWAPTRA                                         0432
*   MWANEXTC=JFCBPNVL;              /* SET COUNT FOR NEXT JFCB EXT   */
         MVC   MWANEXTC(4),@CF00145                                0433
*   DO MWAI=1 TO VVOLLNBR;          /* SCAN VOL SER NUMBERS          */
         LA    @05,1                                               0434
         B     @DE00434                                            0434
@DL00434 DS    0H                                                  0435
*     IF MWAI>MWANEXTC THEN         /* IF NEXT JFCB EXT NEEDED       */
         L     @15,MWANEXTC                                        0435
         CR    @05,@15                                             0435
         BNH   @RF00435                                            0435
*       DO;                         /* THEN READ NEXT EXTENSION      */
*         IF MWANEXTC=JFCBPNVL THEN /* IF FIRST EXTENSION            */
         C     @15,@CF00145                                        0437
         BNE   @RF00437                                            0437
*           MWAJFTTR(1:3)=JFCBEXAD; /* SET DISK ADDR OF FIRST EXT    */
         L     @05,MWAJFCB                                         0438
         MVC   MWAJFTTR(3),JFCBEXAD(@05)                           0438
*         ELSE                      /* ELSE PROCESSING EXTENSION     */
*           MWAJFTTR(1:3)=JFCBXTTR; /* SET DISK ADDR FOR NEXT JFCB 0439
*                                      EXTENSION                     */
         B     @RC00437                                            0439
@RF00437 L     @05,MWAJFCB                                         0439
         MVC   MWAJFTTR(3),JFCBXTTR(@05)                           0439
*         CALL READJFCB;            /* READ JFCB EXTENSION           */
@RC00437 BAL   @14,READJFCB                                        0440
*         MWANEXTC=MWANEXTC+JFCBXNVL;/* INCR CNT FOR NEXT EXTENSION  */
         LA    @05,15                                              0441
         AL    @05,MWANEXTC                                        0441
         ST    @05,MWANEXTC                                        0441
*         MWAPTRA=ADDR(JFCBXVOL);   /* PT TO FIRST VOL SER NO. IN  0442
*                                      JFCB EXTENSION                */
         L     @05,MWAJFCB                                         0442
         LA    @05,JFCBXVOL(,@05)                                  0442
         ST    @05,MWAPTRA                                         0442
*       END;                                                       0443
*     VVOLLVSR(MWAI)=VOLSER;        /* MOVE VOL SER NO. INTO VVOLL   */
@RF00435 L     @05,MWAI                                            0444
         LR    @15,@05                                             0444
         MH    @15,@CH00033                                        0444
         L     @01,MWAVVOLL                                        0444
         ALR   @01,@15                                             0444
         L     @15,MWAPTRA                                         0444
         MVC   VVOLLVSR-12(6,@01),VOLSER(@15)                      0444
*     MWAPTRA=MWAPTRA+LENGTH(VOLSER);/* PT TO NEXT VOLSER            */
         AL    @15,@CF00089                                        0445
         ST    @15,MWAPTRA                                         0445
*   END;                                                           0446
         AL    @05,@CF00053                                        0446
@DE00434 ST    @05,MWAI                                            0446
         L     @01,MWAVVOLL                                        0446
         CH    @05,VVOLLNBR(,@01)                                  0446
         BNH   @DL00434                                            0446
*   RFY                                                            0447
*     R1 RSTD;                                                     0447
*   R1=MWAVVOLL;                    /* PT TO VVOLL                   */
         L     R1,MWAVVOLL                                         0448
*   RFY                                                            0449
*     R1 UNRSTD;                                                   0449
*   RSTATRTN=IDAR192V;              /* INDIC 192V CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0450
         MVC   RSTATRTN(4,@05),@CC04591                            0450
*   CALL IDA0192V;                  /* MOUNT VOLUMES                 */
         L     @15,@CV04841                                        0451
         BALR  @14,@15                                             0451
*   RSTATRTN=IDAR192F;              /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0452
         MVC   RSTATRTN(4,@05),@CC04581                            0452
*   RFY                                                            0453
*     RETCODE RSTD;                                                0453
*   IF RETCODE>0 THEN               /* IF ALL VOLUMES NOT MOUNTED    */
         LTR   RETCODE,RETCODE                                     0454
         BNP   @RF00454                                            0454
*     DO;                           /* THEN IND ALL VOLS NOT MOUNTED */
*       IF RETCODE>4 THEN           /* IF ERROR DETECTED BY VOL MNT  */
         C     RETCODE,@CF00095                                    0456
         BNH   @RF00456                                            0456
*         DO;                       /* THEN DETERMINE TYPE OF ERROR  */
*           RFY                                                    0458
*             RETCODE UNRSTD;                                      0458
*           PDPCODE=VVOLLPDC;       /* LD PROB DET CODE              */
         AL    @05,@CF04927                                        0459
         L     @15,MWAVVOLL                                        0459
         IC    @14,VVOLLPDC(,@15)                                  0459
         STC   @14,PDPCODE(,@05)                                   0459
*           PDPSFC=VVOLLSFC;        /* LD SUB-FUNCTION CODE          */
         IC    @14,VVOLLSFC(,@15)                                  0460
         STC   @14,PDPSFC(,@05)                                    0460
*           IF PDPCODE=PP116|       /* IF I/O ERROR READING DSCB     */
*               PDPCODE=PP59 THEN   /* OR VOL TIME STAMP ERROR       */
         CLI   PDPCODE(@05),116                                    0461
         BE    @RT00461                                            0461
         CLI   PDPCODE(@05),59                                     0461
         BNE   @RF00461                                            0461
@RT00461 DS    0H                                                  0462
*             PDPVLSER=ADDR(VVOLLVSR(VVOLLCNT));/* PT TO BAD VOLUME  */
         L     @05,OPWCOMWA(,RCORE)                                0462
         L     @15,MWAVVOLL                                        0462
         SLR   @14,@14                                             0462
         IC    @14,VVOLLCNT(,@15)                                  0462
         MH    @14,@CH00033                                        0462
         LA    @15,VVOLLVSR-12(@14,@15)                            0462
         ST    @15,PDPVLSER+280(,@05)                              0462
*           IF PDPSFC=0&            /* IF NO SUB-FUNCTION CODE       */
*               SFIRETCD^=0 THEN    /* AND SFI INITIALIZED           */
@RF00461 LA    @05,280                                             0463
         AL    @05,OPWCOMWA(,RCORE)                                0463
         CLI   PDPSFC(@05),0                                       0463
         BNE   @RF00463                                            0463
         L     @15,MWAVVOLL                                        0463
         L     @14,SFIRETCD+16(,@15)                               0463
         LTR   @14,@14                                             0463
         BZ    @RF00463                                            0463
*             PDPSFI=ADDR(VVOLLSFI);/* THEN PT TO SFI IN VVOLL       */
         LA    @15,VVOLLSFI(,@15)                                  0464
         ST    @15,PDPSFI(,@05)                                    0464
*           ELSE                    /* IF NOT                        */
*             PDPSFI=0;             /* ZERO SFI PTR                  */
         B     @RC00463                                            0465
@RF00463 L     @05,OPWCOMWA(,RCORE)                                0465
         SLR   @15,@15                                             0465
         ST    @15,PDPSFI+280(,@05)                                0465
*           IF PDPCODE=PP59&        /* IF VOLUME TIME STAMP ERROR    */
*               (ACBOUT=ON|ACBRST=ON) THEN/* AND OPEN FOR OUTPUT   0466
*                                                            @XM01165*/
@RC00463 L     @05,OPWCOMWA(,RCORE)                                0466
         CLI   PDPCODE+280(@05),59                                 0466
         BNE   @RF00466                                            0466
         TM    ACBOUT(RACB),B'00000010'                            0466
         BO    @RT00466                                            0466
         TM    ACBRST(RACB),B'00000100'                            0466
         BNO   @RF00466                                            0466
@RT00466 DS    0H                                                  0467
*             PDPCODE=PP60;         /* THEN IND TERMINATING ERROR    */
         L     @05,OPWCOMWA(,RCORE)                                0467
         MVI   PDPCODE+280(@05),X'3C'                              0467
*           CALL PROBDT;            /* WRITE PROB DET MESSAGE        */
@RF00466 BAL   @14,PROBDT                                          0468
*         END;                                                     0469
*       MWAVOLCT=0;                 /* IND ALL VOLUMES NOT MOUNTED   */
@RF00456 SLR   @05,@05                                             0470
         ST    @05,MWAVOLCT                                        0470
*     END;                                                         0471
*   ELSE                            /* ELSE ALL VOLUMES MOUNTED      */
*     MWAVOLCT=VVOLLNBR;            /* VOLUME COUNT EQUAL NO. IN   0472
*                                      VVOLL                         */
*                                                                  0472
         B     @RC00454                                            0472
@RF00454 L     @05,MWAVVOLL                                        0472
         LH    @05,VVOLLNBR(,@05)                                  0472
         ST    @05,MWAVOLCT                                        0472
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE NUMBER OF VOLUMES MOUNTED, BUILD VMT AND MOVE VOLUME*/
*   /* SERIAL NUMBERS MOUNTED INTO VMT.                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0473
*   IF MWAVOLCT=0 THEN              /* IF ALL VOLUMES NOT MOUNTED    */
@RC00454 L     @05,MWAVOLCT                                        0473
         LTR   @05,@05                                             0473
         BNZ   @RF00473                                            0473
*     DO MWAI=1 TO VVOLLNBR;        /* THEN COUNT NO. OF VOLS MNTED  */
         LA    @05,1                                               0474
         B     @DE00474                                            0474
@DL00474 DS    0H                                                  0475
*       IF VVOLLMNT(MWAI)=ON THEN   /* IF VOLUME MOUNTED             */
         MH    @05,@CH00033                                        0475
         L     @01,MWAVVOLL                                        0475
         ALR   @01,@05                                             0475
         TM    VVOLLMNT-12(@01),B'10000000'                        0475
         BNO   @RF00475                                            0475
*         MWAVOLCT=MWAVOLCT+1;      /* THEN INCR VOLUME COUNT        */
         LA    @05,1                                               0476
         AL    @05,MWAVOLCT                                        0476
         ST    @05,MWAVOLCT                                        0476
*     END;                                                         0477
@RF00475 LA    @05,1                                               0477
         AL    @05,MWAI                                            0477
@DE00474 ST    @05,MWAI                                            0477
         L     @01,MWAVVOLL                                        0477
         CH    @05,VVOLLNBR(,@01)                                  0477
         BNH   @DL00474                                            0477
*   IF OPWFLGS1^=0 THEN             /* IF SYSTEM DATA SET            */
@RF00473 CLI   OPWFLGS1(RCORE),0                                   0478
         BE    @RF00478                                            0478
*     MWAGFSP=CATPOOL;              /* THEN SET SQA SUBPOOL NUMBER   */
         MVI   MWAGFSP,X'E7'                                       0479
*   ELSE                            /* NO, CHK FOR GSR       @Y30DSDP*/
*     IF OPWGSR=ON|OPWCBIC=ON THEN  /* CHK FOR GSR OR CBIC   @ZA16012*/
         B     @RC00478                                            0480
@RF00478 TM    OPWGSR(RCORE),B'01000000'                           0480
         BO    @RT00480                                            0480
         TM    OPWCBIC(RCORE),B'10000000'                          0480
         BNO   @RF00480                                            0480
@RT00480 DS    0H                                                  0481
*       MWAGFSP=GSRPOOL;            /* SET GSR SUBPOOL       @Y30DSDP*/
         MVI   MWAGFSP,X'F1'                                       0481
*     ELSE                          /* NOT SYSTEM DATA SET           */
*       MWAGFSP=VMTPOOL;            /* SET VMT SUBPOOL               */
         B     @RC00480                                            0482
@RF00480 MVI   MWAGFSP,X'FC'                                       0482
*   MWAGFLEN=LENGTH(IDAVMT)+LENGTH(VMTVOL)*MWAVOLCT;/* CALCULATE   0483
*                                      LENGTH OF VMT                 */
@RC00480 DS    0H                                                  0483
@RC00478 L     @05,MWAVOLCT                                        0483
         SLA   @05,4                                               0483
         LA    @05,16(,@05)                                        0483
         STCM  @05,7,MWAGFLEN                                      0483
*   CALL GETCORE;                   /* OBTAIN STORAGE FOR VMT        */
         BAL   @14,GETCORE                                         0484
*   MWAVMT=MWAGFADR;                /* PT TO VMT                     */
         L     @15,MWAGFADR                                        0485
         ST    @15,MWAVMT                                          0485
*   VMTID=IDXVMT;                   /* INIT CB ID IN VMT             */
         MVI   VMTID(@15),B'00010010'                              0486
*   VMTLEN=MWAGFLEN;                /* INIT LENGTH IN VMT            */
         L     @14,MWAGFLEN-1                                      0487
         LA    @14,0(,@14)                                         0487
         STH   @14,VMTLEN(,@15)                                    0487
*   VMTDEV=MWADEV;                  /* INIT DEVICE TYPE IN VMT       */
         MVC   VMTDEV(3,@15),MWADEV                                0488
*   MWAJ=0;                         /* INIT INDEX FOR VMTVOL         */
         SLR   MWAJ,MWAJ                                           0489
*   DO MWAI=1 TO VVOLLNBR;          /* SCAN ENTRIES IN VVOLL         */
         LA    @15,1                                               0490
         B     @DE00490                                            0490
@DL00490 DS    0H                                                  0491
*     IF VVOLLMNT(MWAI)=ON THEN     /* IF VOLUME MOUNTED             */
         L     @14,MWAVVOLL                                        0491
         MH    @15,@CH00033                                        0491
         ST    @15,@TF00001                                        0491
         ALR   @15,@14                                             0491
         TM    VVOLLMNT-12(@15),B'10000000'                        0491
         BNO   @RF00491                                            0491
*       DO;                         /* THEN ADD ENTRY TO VMT         */
*         MWAJ=MWAJ+1;              /* INCR INDEX FOR VMTVOL         */
         AL    MWAJ,@CF00053                                       0493
*         VMTVLSER(MWAJ)=VVOLLVSR(MWAI);/* MOVE VOLSER INTO VMT      */
         L     @15,MWAVMT                                          0494
         LR    @11,MWAJ                                            0494
         SLA   @11,4                                               0494
         ST    @11,@TF00002                                        0494
         ALR   @11,@15                                             0494
         LR    @10,@14                                             0494
         AL    @10,@TF00001                                        0494
         MVC   VMTVLSER-16(6,@11),VVOLLVSR-12(@10)                 0494
*         VMTUCB(MWAJ)=VVOLLUCB(MWAI);/* MOVE UCB PTR INTO VMT       */
         L     @01,@TF00001                                        0495
         L     @14,VVOLLUCB-12(@01,@14)                            0495
         L     @01,@TF00002                                        0495
         ST    @14,VMTUCB-16(@01,@15)                              0495
*         VMTOPEN(MWAJ)=ON;         /* IND VOL BEING PROCESSED BY  0496
*                                      OPEN                          */
         AL    @15,@TF00002                                        0496
         OI    VMTOPEN-16(@15),B'10000000'                         0496
*       END;                                                       0497
*   END;                                                           0498
@RF00491 LA    @15,1                                               0498
         AL    @15,MWAI                                            0498
@DE00490 ST    @15,MWAI                                            0498
         L     @14,MWAVVOLL                                        0498
         CH    @15,VVOLLNBR(,@14)                                  0498
         BNH   @DL00490                                            0498
*   VMTNOVOL=MWAJ;                  /* SET NO. OF ENTRIES IN VMT     */
         L     @15,MWAVMT                                          0499
         STH   MWAJ,VMTNOVOL(,@15)                                 0499
*   VMTNXT=BIBVMT;                  /* PT TO FIRST VMT ON CHAIN      */
         L     @05,OPWBIB(,RCORE)                                  0500
         L     @14,BIBVMT(,@05)                                    0500
         ST    @14,VMTNXT(,@15)                                    0500
*   BIBVMT=MWAVMT;                  /* ADD NEW VMT TO CHAIN          */
         ST    @15,BIBVMT(,@05)                                    0501
*   RFY                                                            0502
*     RET RSTD;                                                    0502
*   RET=MWASAVEB;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEB                                        0503
*   RFY                                                            0504
*     RET UNRSTD;                                                  0504
*   END NEWDEV;                                                    0505
@EL00003 DS    0H                                                  0505
@EF00003 DS    0H                                                  0505
@ER00003 BR    @14                                                 0505
*OLDDEV:                                                           0506
*                                                                  0506
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: MOUNT VOLUMES FOR EXISTING DEVICE TYPE.  THIS        */
*/*             ROUTINE COMPARES THE VOLUME SERIAL NUMBERS IN THE    */
*/*             JFCB TO THE VOLUME SERIAL NUMBERS IN THE VMT FOR     */
*/*             THE SAME DEVICE TYPE. THE VOLUME SERIAL NUMBERS FOR  */
*/*             VOLUMES THAT ARE NOT MOUNTED (THOSE NOT IN VMT) ARE  */
*/*             MOVED INTO THE VVOLL.  IDA0192V IS CALLED TO MOUNT   */
*/*             THE VOLUMES.  UPON RETURN FROM IDA0192V, A NEW VMT   */
*/*             IS BUILT, THE OLD VMT IS COPIED INTO IT, AND THE     */
*/*             VOLUME SERIAL NUMBERS FOR THE NEW VOLUMES THAT WERE  */
*/*             MOUNTED ARE ADDED TO THE NEW VMT.  THE NEW VMT       */
*/*             REPLACES THE OLD ONE AND THE OLD VMT IS FREED.       */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO VMT IN MWAVMT.                             */
*/*             2. PTR TO JFCB IN MWAJFCB.                           */
*/*             3. PTR TO VVOLL IN MWAVVOLL.                         */
*/*             4. NUMBER OF VOLUME SERIAL NUMBERS IN JFCB AND       */
*/*                JFCB EXTENSIONS IN VVOLLNBR.                      */
*/*                                                                  */
*/*   OUTPUTS:  1. NEW VOLUME SERIAL NUMBERS FOR DEVICE TYPE ARE     */
*/*               ADDED TO VMT.                                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0506
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0506
OLDDEV   DS    0H                                                  0507
*   RFY                                                            0507
*     RET RSTD;                                                    0507
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        0508
*   RFY                                                            0509
*     RET UNRSTD;                                                  0509
*                                                                  0509
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPARE VOLUME SERIAL NUMBERS IN JFCB TO VMT. MOVE NEW VOLUME */
*   /* SERIAL NUMBERS FOR VOLUMES NOT MOUNTED INTO VOLL AND CALL     */
*   /* IDA0192V TO MOUNT THEM.                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0510
*   RFY                                                            0510
*     VOLSER BASED(MWAPTRA);                                       0510
*   MWAPTRA=ADDR(JFCBVOLS);         /* PT TO FIRST VOL SER NO. IN  0511
*                                      JFCB                          */
         L     @05,MWAJFCB                                         0511
         LA    @05,JFCBVOLS(,@05)                                  0511
         ST    @05,MWAPTRA                                         0511
*   MWANEXTC=JFCBPNVL;              /* SET COUNT FOR NEXT JFCB EXT   */
         MVC   MWANEXTC(4),@CF00145                                0512
*   MWAVOLCT=0;                     /* SET VOLUME CTR TO ZERO        */
         SLR   @05,@05                                             0513
         ST    @05,MWAVOLCT                                        0513
*   DO MWAI=1 TO VVOLLNBR;          /* SCAN VOL SER NOS. IN JFCB     */
         LA    @05,1                                               0514
         B     @DE00514                                            0514
@DL00514 DS    0H                                                  0515
*     IF MWAI>MWANEXTC THEN         /* IF NEXT JFCB EXT NEEDED       */
         L     @15,MWANEXTC                                        0515
         CR    @05,@15                                             0515
         BNH   @RF00515                                            0515
*       DO;                         /* THEN READ NEXT EXTENSION      */
*         IF MWANEXTC=JFCBPNVL THEN /* IF FIRST EXTENSION            */
         C     @15,@CF00145                                        0517
         BNE   @RF00517                                            0517
*           MWAJFTTR(1:3)=JFCBEXAD; /* SET DISK ADDR OF FIRST EXT    */
         L     @05,MWAJFCB                                         0518
         MVC   MWAJFTTR(3),JFCBEXAD(@05)                           0518
*         ELSE                      /* ELSE PROCESSING EXTENSION     */
*           MWAJFTTR(1:3)=JFCBXTTR; /* SET DISK ADDR FOR NEXT JFCB 0519
*                                      EXTENSION                     */
         B     @RC00517                                            0519
@RF00517 L     @05,MWAJFCB                                         0519
         MVC   MWAJFTTR(3),JFCBXTTR(@05)                           0519
*         CALL READJFCB;            /* READ JFCB EXTENSION           */
@RC00517 BAL   @14,READJFCB                                        0520
*         MWANEXTC=MWANEXTC+JFCBXNVL;/* INCR CNT FOR NEXT EXTENSION  */
         LA    @05,15                                              0521
         AL    @05,MWANEXTC                                        0521
         ST    @05,MWANEXTC                                        0521
*         MWAPTRA=ADDR(JFCBXVOL);   /* PT TO FIRST VOL SER NO. IN  0522
*                                      JFCB EXTENSION                */
         L     @05,MWAJFCB                                         0522
         LA    @05,JFCBXVOL(,@05)                                  0522
         ST    @05,MWAPTRA                                         0522
*       END;                                                       0523
*     DO MWAJ=1 TO VMTNOVOL WHILE(VOLSER^=VMTVLSER(MWAJ));/* SCAN  0524
*                                      VMT, LOOK FOR VOL SER NO.     */
@RF00515 LA    MWAJ,1                                              0524
         B     @DE00524                                            0524
@DL00524 LR    @15,MWAJ                                            0524
         SLA   @15,4                                               0524
         L     @01,MWAPTRA                                         0524
         L     @14,MWAVMT                                          0524
         ALR   @14,@15                                             0524
         CLC   VOLSER(6,@01),VMTVLSER-16(@14)                      0524
         BE    @DC00524                                            0524
*     END;                                                         0525
         AL    MWAJ,@CF00053                                       0525
@DE00524 L     @01,MWAVMT                                          0525
         CH    MWAJ,VMTNOVOL(,@01)                                 0525
         BNH   @DL00524                                            0525
@DC00524 DS    0H                                                  0526
*     IF MWAJ>VMTNOVOL THEN         /* IF VOL SER NO. NOT IN VMT     */
         L     @01,MWAVMT                                          0526
         CH    MWAJ,VMTNOVOL(,@01)                                 0526
         BNH   @RF00526                                            0526
*       DO;                         /* THEN ADD VOL SER NO. TO VVOLL */
*         MWAVOLCT=MWAVOLCT+1;      /* INCR VOL CTR                  */
         LA    @05,1                                               0528
         AL    @05,MWAVOLCT                                        0528
         ST    @05,MWAVOLCT                                        0528
*         VVOLLVSR(MWAVOLCT)=VOLSER;/* MOVE VOL SER NO. FROM JFCB TO
*                                      VVOLL                         */
         MH    @05,@CH00033                                        0529
         L     @01,MWAVVOLL                                        0529
         ALR   @01,@05                                             0529
         L     @05,MWAPTRA                                         0529
         MVC   VVOLLVSR-12(6,@01),VOLSER(@05)                      0529
*       END;                                                       0530
*     MWAPTRA=MWAPTRA+LENGTH(VOLSER);/* PT TO NEXT VOL SER NO. IN  0531
*                                      JFCB                          */
@RF00526 LA    @05,6                                               0531
         AL    @05,MWAPTRA                                         0531
         ST    @05,MWAPTRA                                         0531
*   END;                                                           0532
         LA    @05,1                                               0532
         AL    @05,MWAI                                            0532
@DE00514 ST    @05,MWAI                                            0532
         L     @01,MWAVVOLL                                        0532
         CH    @05,VVOLLNBR(,@01)                                  0532
         BNH   @DL00514                                            0532
*   IF MWAVOLCT>0 THEN              /* IF ANY VOLUMES TO MOUNT       */
         L     @05,MWAVOLCT                                        0533
         LTR   @05,@05                                             0533
         BNP   @RF00533                                            0533
*     DO;                           /* THEN MOUNT NEW VOLUMES        */
*       VVOLLNBR=MWAVOLCT;          /* SET NO. OF VOLUMES IN VVOLL   */
         L     @15,MWAVVOLL                                        0535
         STH   @05,VVOLLNBR(,@15)                                  0535
*       RFY                                                        0536
*         R1 RSTD;                                                 0536
*       R1=MWAVVOLL;                /* PT TO VVOLL                   */
         LR    R1,@15                                              0537
*       RFY                                                        0538
*         R1 UNRSTD;                                               0538
*       RSTATRTN=IDAR192V;          /* INDIC 192V CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0539
         MVC   RSTATRTN(4,@05),@CC04591                            0539
*       CALL IDA0192V;              /* CALL VOLUME MOUNT             */
         L     @15,@CV04841                                        0540
         BALR  @14,@15                                             0540
*       RSTATRTN=IDAR192F;          /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0541
         MVC   RSTATRTN(4,@05),@CC04581                            0541
*       RFY                                                        0542
*         RETCODE RSTD;                                            0542
*       IF RETCODE>0 THEN           /* IF ALL VOLS NOT MOUNTED       */
         LTR   RETCODE,RETCODE                                     0543
         BNP   @RF00543                                            0543
*         DO;                       /* THEN IND ALL VOLS NOT MOUNTED */
*           IF RETCODE>4 THEN       /* IF ERROR DETECTED BY VOL MNT  */
         C     RETCODE,@CF00095                                    0545
         BNH   @RF00545                                            0545
*             DO;                   /* THEN DETERMINE TYPE OF ERROR  */
*               RFY                                                0547
*                 RETCODE UNRSTD;                                  0547
*               PDPCODE=VVOLLPDC;   /* LD PROB DET CODE              */
         AL    @05,@CF04927                                        0548
         L     @15,MWAVVOLL                                        0548
         IC    @14,VVOLLPDC(,@15)                                  0548
         STC   @14,PDPCODE(,@05)                                   0548
*               PDPSFC=VVOLLSFC;    /* LD SUB-FUNCTION CODE          */
         IC    @14,VVOLLSFC(,@15)                                  0549
         STC   @14,PDPSFC(,@05)                                    0549
*               IF PDPCODE=PP116|   /* IF I/O ERROR READING DSCB     */
*                   PDPCODE=PP59 THEN/* OR VOL TIME STAMP ERROR      */
         CLI   PDPCODE(@05),116                                    0550
         BE    @RT00550                                            0550
         CLI   PDPCODE(@05),59                                     0550
         BNE   @RF00550                                            0550
@RT00550 DS    0H                                                  0551
*                 PDPVLSER=ADDR(VVOLLVSR(VVOLLCNT));/* PT TO BAD   0551
*                                      VOLUME                        */
         L     @05,OPWCOMWA(,RCORE)                                0551
         L     @15,MWAVVOLL                                        0551
         SLR   @14,@14                                             0551
         IC    @14,VVOLLCNT(,@15)                                  0551
         MH    @14,@CH00033                                        0551
         LA    @15,VVOLLVSR-12(@14,@15)                            0551
         ST    @15,PDPVLSER+280(,@05)                              0551
*               IF PDPSFC=0&        /* IF NO SUB-FUNCTION CODE       */
*                   SFIRETCD^=0 THEN/* AND SFI INITIALIZED           */
@RF00550 LA    @05,280                                             0552
         AL    @05,OPWCOMWA(,RCORE)                                0552
         CLI   PDPSFC(@05),0                                       0552
         BNE   @RF00552                                            0552
         L     @15,MWAVVOLL                                        0552
         L     @14,SFIRETCD+16(,@15)                               0552
         LTR   @14,@14                                             0552
         BZ    @RF00552                                            0552
*                 PDPSFI=ADDR(VVOLLSFI);/* THEN PT TO SFI IN VVOLL   */
         LA    @15,VVOLLSFI(,@15)                                  0553
         ST    @15,PDPSFI(,@05)                                    0553
*               ELSE                /* OTHERWISE                     */
*                 PDPSFI=0;         /* ZERO SFI PTR                  */
         B     @RC00552                                            0554
@RF00552 L     @05,OPWCOMWA(,RCORE)                                0554
         SLR   @15,@15                                             0554
         ST    @15,PDPSFI+280(,@05)                                0554
*               IF PDPCODE=PP59&    /* IF VOLUME TIME STAMP ERROR    */
*                   (ACBOUT=ON|ACBRST=ON) THEN/* AND OPEN FOR OUTPUT
*                                                            @XM01165*/
@RC00552 L     @05,OPWCOMWA(,RCORE)                                0555
         CLI   PDPCODE+280(@05),59                                 0555
         BNE   @RF00555                                            0555
         TM    ACBOUT(RACB),B'00000010'                            0555
         BO    @RT00555                                            0555
         TM    ACBRST(RACB),B'00000100'                            0555
         BNO   @RF00555                                            0555
@RT00555 DS    0H                                                  0556
*                 PDPCODE=PP60;     /* THEN IND TERMINATING ERROR    */
         L     @05,OPWCOMWA(,RCORE)                                0556
         MVI   PDPCODE+280(@05),X'3C'                              0556
*               CALL PROBDT;        /* WRITE PROB DET MESSAGE        */
@RF00555 BAL   @14,PROBDT                                          0557
*             END;                                                 0558
*           MWAVOLCT=0;             /* IND ALL VOLUMES NOT MOUNTED   */
@RF00545 SLR   @05,@05                                             0559
         ST    @05,MWAVOLCT                                        0559
*         END;                                                     0560
*       IF MWAVOLCT=0 THEN          /* IF ALL VOLUMES NOT MOUNTED    */
@RF00543 L     @05,MWAVOLCT                                        0561
         LTR   @05,@05                                             0561
         BNZ   @RF00561                                            0561
*         DO;                       /* THEN COUNT NO. OF VOLS MNTED  */
*           DO MWAI=1 TO VVOLLNBR;  /* COUNT MOUNTED VOLS IN VVOLL   */
         LA    @05,1                                               0563
         B     @DE00563                                            0563
@DL00563 DS    0H                                                  0564
*             IF VVOLLMNT(MWAI)=ON THEN/* IF VOLUME MOUNTED          */
         MH    @05,@CH00033                                        0564
         L     @01,MWAVVOLL                                        0564
         ALR   @01,@05                                             0564
         TM    VVOLLMNT-12(@01),B'10000000'                        0564
         BNO   @RF00564                                            0564
*               MWAVOLCT=MWAVOLCT+1;/* THEN INCR VOLUME COUNT        */
         LA    @05,1                                               0565
         AL    @05,MWAVOLCT                                        0565
         ST    @05,MWAVOLCT                                        0565
*           END;                                                   0566
@RF00564 LA    @05,1                                               0566
         AL    @05,MWAI                                            0566
@DE00563 ST    @05,MWAI                                            0566
         L     @01,MWAVVOLL                                        0566
         CH    @05,VVOLLNBR(,@01)                                  0566
         BNH   @DL00563                                            0566
*         END;                                                     0567
*                                                                  0567
*       /*************************************************************/
*       /*                                                           */
*       /* BUILD A NEW VMT, COPY OLD VMT INTO IT, ADD NEW VOLUME     */
*       /* SERIAL NUMBERS AND REPLACE OLD VMT WITH NEW VMT           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0568
*       IF MWAVOLCT>0 THEN          /* IF ANY VOLUMES MOUNTED        */
@RF00561 L     @05,MWAVOLCT                                        0568
         LTR   @05,@05                                             0568
         BNP   @RF00568                                            0568
*         DO;                       /* THEN BUILD NEW VMT            */
*           IF OPWGSR=ON|OPWCBIC=ON THEN/* CHK FOR GSR OR CBIC     0570
*                                                            @ZA16012*/
         TM    OPWGSR(RCORE),B'01000000'                           0570
         BO    @RT00570                                            0570
         TM    OPWCBIC(RCORE),B'10000000'                          0570
         BNO   @RF00570                                            0570
@RT00570 DS    0H                                                  0571
*             MWAGFSP=GSRSPOOL;     /* YES, SET GSR SUBPOOL  @Y30DSDP*/
         MVI   MWAGFSP,X'F1'                                       0571
*           ELSE                    /* NO, NOT GSR           @Y30DSDP*/
*             MWAGFSP=VMTPOOL;      /* INIT SUBPOOL OF VMT           */
         B     @RC00570                                            0572
@RF00570 MVI   MWAGFSP,X'FC'                                       0572
*           MWAGFLEN=LENGTH(IDAVMT)+LENGTH(VMTVOL)*(MWAVOLCT+VMTNOVOL);
@RC00570 L     @05,MWAVMT                                          0573
         LH    @05,VMTNOVOL(,@05)                                  0573
         AL    @05,MWAVOLCT                                        0573
         SLA   @05,4                                               0573
         LA    @05,16(,@05)                                        0573
         STCM  @05,7,MWAGFLEN                                      0573
*                                   /* CALCULATE LENGTH OF NEW VMT   */
*           CALL GETCORE;           /* OBTAIN STORAGE FOR NEW VMT    */
         BAL   @14,GETCORE                                         0574
*           MWAPTRA=MWAVMT;         /* SAVE PTR TO OLD VMT           */
         L     @05,MWAVMT                                          0575
         ST    @05,MWAPTRA                                         0575
*           MWAVMT=MWAGFADR;        /* PT TO NEW VMT                 */
         L     @15,MWAGFADR                                        0576
         ST    @15,MWAVMT                                          0576
*           IDAVMT=MWAPTRA->IDAVMT; /* COPY HDR INFO INTO NEW VMT    */
         MVC   IDAVMT(16,@15),IDAVMT(@05)                          0577
*           VMTNOVOL=MWAPTRA->VMTNOVOL+MWAVOLCT;/* INIT NO. OF     0578
*                                      ENTRIES                       */
         LH    @14,VMTNOVOL(,@05)                                  0578
         AL    @14,MWAVOLCT                                        0578
         STH   @14,VMTNOVOL(,@15)                                  0578
*           VMTLEN=MWAGFLEN;        /* INIT LENGTH IN NEW VMT        */
         L     @14,MWAGFLEN-1                                      0579
         LA    @14,0(,@14)                                         0579
         STH   @14,VMTLEN(,@15)                                    0579
*           VMTDEV=MWAPTRA->VMTDEV; /* COPY DEVICE TYPE FROM OLD VMT */
         MVC   VMTDEV(3,@15),VMTDEV(@05)                           0580
*           VMTNXT=MWAPTRA->VMTNXT; /* COPY PTR TO NEXT VMT          */
         L     @05,VMTNXT(,@05)                                    0581
         ST    @05,VMTNXT(,@15)                                    0581
*           DO MWAI=1 TO MWAPTRA->VMTNOVOL;/* MOVE VOLUME ENTRY FROM
*                                      OLD VMT TO NEW VMT            */
         LA    @05,1                                               0582
         B     @DE00582                                            0582
@DL00582 DS    0H                                                  0583
*             VMTVOL(MWAI)=MWAPTRA->VMTVOL(MWAI);/* LD VOL ENTRY     */
         LR    @15,@05                                             0583
         SLA   @15,4                                               0583
         L     @01,MWAVMT                                          0583
         ALR   @01,@15                                             0583
         L     @14,MWAPTRA                                         0583
         ALR   @14,@15                                             0583
         MVC   VMTVOL-16(16,@01),VMTVOL-16(@14)                    0583
*           END;                                                   0584
         AL    @05,@CF00053                                        0584
@DE00582 ST    @05,MWAI                                            0584
         L     @01,MWAPTRA                                         0584
         CH    @05,VMTNOVOL(,@01)                                  0584
         BNH   @DL00582                                            0584
*           MWAI=MWAI-1;            /* DECR INDEX TO LAST USER ENTRY
*                                      IN NEW VMT                    */
         BCTR  @05,0                                               0585
         ST    @05,MWAI                                            0585
*           DO MWAJ=1 TO VVOLLNBR;  /* MOVE NEW VOLUME SERIAL NUMBERS
*                                      INTO VMT                      */
         LA    MWAJ,1                                              0586
         B     @DE00586                                            0586
@DL00586 DS    0H                                                  0587
*             IF VVOLLMNT(MWAJ)=ON THEN/* IF VOLUME MOUNTED          */
         L     @15,MWAVVOLL                                        0587
         LR    @14,MWAJ                                            0587
         MH    @14,@CH00033                                        0587
         ST    @14,@TF00001                                        0587
         ALR   @14,@15                                             0587
         TM    VVOLLMNT-12(@14),B'10000000'                        0587
         BNO   @RF00587                                            0587
*               DO;                 /* THEN INIT ENTRY IN NEW VMT    */
*                 MWAI=MWAI+1;      /* INCR IDX FOR NEW VMT          */
         LA    @14,1                                               0589
         AL    @14,MWAI                                            0589
         ST    @14,MWAI                                            0589
*                 VMTVLSER(MWAI)=VVOLLVSR(MWAJ);/* INIT VOL SER NO.  */
         L     @11,MWAVMT                                          0590
         SLA   @14,4                                               0590
         ST    @14,@TF00002                                        0590
         ALR   @14,@11                                             0590
         LR    @01,@15                                             0590
         AL    @01,@TF00001                                        0590
         MVC   VMTVLSER-16(6,@14),VVOLLVSR-12(@01)                 0590
*                 VMTUCB(MWAI)=VVOLLUCB(MWAJ);/* INIT PTR TO UCB     */
         L     @14,@TF00001                                        0591
         L     @10,VVOLLUCB-12(@14,@15)                            0591
         L     @01,@TF00002                                        0591
         ST    @10,VMTUCB-16(@01,@11)                              0591
*                 VMTOPEN(MWAI)=ON; /* IND ENTRY BEING PROCESSED BY
*                                      OPEN                          */
         AL    @11,@TF00002                                        0592
         OI    VMTOPEN-16(@11),B'10000000'                         0592
*               END;                                               0593
*           END;                                                   0594
*                                                                  0594
@RF00587 AL    MWAJ,@CF00053                                       0594
@DE00586 L     @01,MWAVVOLL                                        0594
         CH    MWAJ,VVOLLNBR(,@01)                                 0594
         BNH   @DL00586                                            0594
*           /*********************************************************/
*           /*                                                       */
*           /* DECHAIN OLD VMT, ADD NEW VMT TO CHAIN, AND FREE OLD   */
*           /* VMT                                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0595
*           IF BIBVMT=MWAPTRA THEN  /* IF OLD VMT IS FIRST ON CHAIN  */
         L     @05,OPWBIB(,RCORE)                                  0595
         CLC   BIBVMT(4,@05),MWAPTRA                               0595
         BNE   @RF00595                                            0595
*             BIBVMT=MWAVMT;        /* THEN REPLACE OLD VMT WITH NEW
*                                      VMT                           */
         L     @15,MWAVMT                                          0596
         ST    @15,BIBVMT(,@05)                                    0596
*           ELSE                    /* OLD VMT NOT FIRST ON CHAIN    */
*             DO;                                                  0597
         B     @RC00595                                            0597
@RF00595 DS    0H                                                  0598
*               RFY                                                0598
*                 IDAVMT BASED(MWAPTRB);                           0598
*               MWAPTRB=BIBVMT;     /* PT TO FIRST VMT ON CHAIN      */
         L     @05,OPWBIB(,RCORE)                                  0599
         L     @05,BIBVMT(,@05)                                    0599
         ST    @05,MWAPTRB                                         0599
*               DO WHILE(VMTNXT^=MWAPTRA);/* SCAN VMT CHAIN FOR VMT
*                                      PREVIOUS TO OLD VMT           */
         B     @DE00600                                            0600
@DL00600 DS    0H                                                  0601
*                 MWAPTRB=VMTNXT;   /* PT TO NEXT VMT IN CHAIN       */
         L     @05,MWAPTRB                                         0601
         L     @05,VMTNXT(,@05)                                    0601
         ST    @05,MWAPTRB                                         0601
*               END;                                               0602
@DE00600 L     @05,MWAPTRB                                         0602
         CLC   VMTNXT(4,@05),MWAPTRA                               0602
         BNE   @DL00600                                            0602
*               RFY                                                0603
*                 IDAVMT BASED(MWAVMT);                            0603
*               MWAPTRB->VMTNXT=MWAVMT;/* REPLACE OLD VMT WITH NEW 0604
*                                      VMT                           */
         L     @15,MWAVMT                                          0604
         ST    @15,VMTNXT(,@05)                                    0604
*             END;                                                 0605
*           IF OPWGSR=ON|OPWCBIC=ON THEN/* CHK FOR GSR OR CBIC     0606
*                                                            @ZA16012*/
@RC00595 TM    OPWGSR(RCORE),B'01000000'                           0606
         BO    @RT00606                                            0606
         TM    OPWCBIC(RCORE),B'10000000'                          0606
         BNO   @RF00606                                            0606
@RT00606 DS    0H                                                  0607
*             MWAGFSP=GSRSPOOL;     /* YES, SET GSR SUBPOOL  @Y30DSDP*/
         MVI   MWAGFSP,X'F1'                                       0607
*           ELSE                    /* NO, NOT GSR           @Y30DSDP*/
*             MWAGFSP=VMTPOOL;      /* INIT SUBPOOL FOR VMT          */
         B     @RC00606                                            0608
@RF00606 MVI   MWAGFSP,X'FC'                                       0608
*           MWAGFADR=MWAPTRA;       /* PT TO OLD VMT                 */
@RC00606 L     @05,MWAPTRA                                         0609
         ST    @05,MWAGFADR                                        0609
*           MWAGFLEN=MWAPTRA->VMTLEN;/* INIT LENGTH OF OLD VMT       */
         LH    @05,VMTLEN(,@05)                                    0610
         STCM  @05,7,MWAGFLEN                                      0610
*           CALL FREECORE;          /* FREE OLD VMT                  */
         BAL   @14,FREECORE                                        0611
*         END;                                                     0612
*     END;                                                         0613
@RF00568 DS    0H                                                  0614
*   RFY                                                            0614
*     RET RSTD;                                                    0614
@RF00533 DS    0H                                                  0615
*   RET=MWASAVEB;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEB                                        0615
*   RFY                                                            0616
*     RET UNRSTD;                                                  0616
*   END OLDDEV;                                                    0617
@EL00004 DS    0H                                                  0617
@EF00004 DS    0H                                                  0617
@ER00004 BR    @14                                                 0617
*READJFCB:                                                         0618
*                                                                  0618
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: THIS ROUTINE READS A JFCB.                           */
*/*                                                                  */
*/*   INPUTS:   1. TTR OF JFCB IN MWAJFTTR.                          */
*/*                                                                  */
*/*   OUTPUTS:  1. ADDRESS OF JFCB READ IN MWAJFCB.                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0618
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0618
READJFCB DS    0H                                                  0619
*   RFY                                                            0619
*     RET RSTD;                                                    0619
*   MWASAVEC=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEC                                        0620
*   RFY                                                            0621
*     RET UNRSTD;                                                  0621
*   IF MWAJFBSW=OFF THEN            /* IF CORE BLOCK IS NEEDED       */
         TM    MWAJFBSW,B'00000010'                                0622
         BNZ   @RF00622                                            0622
*     DO;                                                          0623
*       MWAGFSP=WKPOOL;             /* SET SUBPOOL FOR GETMAIN       */
         MVI   MWAGFSP,X'FC'                                       0624
*       MWAGFLEN=LENGTH(JFCBWRKA);  /* CORE SIZE FOR AND JES WORK  0625
*                                      AREA                          */
         MVC   MWAGFLEN(3),@CF04928+1                              0625
*       CALL GETCORE;               /* GET CORE                      */
         BAL   @14,GETCORE                                         0626
*       MWAJFBWA=MWAGFADR;          /* SAVE PTR TO WORKAREA          */
         L     @05,MWAGFADR                                        0627
         ST    @05,MWAJFBWA                                        0627
*       MWAJFBSW=ON;                /* IND NEED FOR FREEING AT END   */
         OI    MWAJFBSW,B'00000010'                                0628
*       QMITCBAD=ADDR(TCB);         /* INIT PTR TO TCB               */
         L     @15,OPWCTCB(,RCORE)                                 0629
         ST    @15,QMITCBAD(,@05)                                  0629
*       QMIRECAD=ADDR(JFCB);        /* POINT TO RECORD AREA          */
         ST    @05,QMIRECAD(,@05)                                  0630
*       QMIWRKAD=ADDR(JESWORK);     /* POINT TO JES WORK AREA        */
         LA    @15,JESWORK(,@05)                                   0631
         ST    @15,QMIWRKAD(,@05)                                  0631
*       QMIRECL=LENGTH(JFCB);       /* SET LENGTH OF RECORD          */
         MVC   QMIRECL(2,@05),@CH01428                             0632
*       QMIOREAD=ON;                /* INDICATE READ REQD            */
         OI    QMIOREAD(@05),B'10000000'                           0633
*     END;                                                         0634
*   QMIDSKAD=MWAJFTTR;              /* LOAD TTR OF JFCB              */
@RF00622 L     @05,MWAJFBWA                                        0635
         MVC   QMIDSKAD(4,@05),MWAJFTTR                            0635
*   RESPECIFY                                                      0636
*    (R1,                                                          0636
*     R15) RESTRICTED;                                             0636
*   R1=ADDR(QMIOP);                 /* POINT TO PARAMETER LIST       */
         LA    R1,QMIOP(,@05)                                      0637
*   R15=JESRESQM;                   /* LOAD ADDR OF QUEUE MANAGER    */
         L     @05,FLCCVT                                          0638
         L     @05,CVTJESCT(,@05)                                  0638
         L     R15,JESRESQM(,@05)                                  0638
*   GEN(BALR RET,R15);              /* GO TO QUEUE MANAGER           */
         BALR RET,R15
*   IF RETCODE^=0 THEN              /* IF ANY ERROR                  */
         LTR   RETCODE,RETCODE                                     0640
         BZ    @RF00640                                            0640
*     DO;                                                          0641
*       PDPCODE=PP4;                /* SET ERROR CODE                */
         L     @14,OPWCOMWA(,RCORE)                                0642
         MVI   PDPCODE+280(@14),X'04'                              0642
*       CALL PROBDT;                /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0643
*     END;                                                         0644
*   MWAJFCB=ADDR(JFCB);             /* COPY POINTER TO JFCB          */
@RF00640 L     @14,MWAJFBWA                                        0645
         ST    @14,MWAJFCB                                         0645
*   RESPECIFY                                                      0646
*    (R1,                                                          0646
*     R15) UNRESTRICTED;                                           0646
*   RFY                                                            0647
*     RET RSTD;                                                    0647
*   RET=MWASAVEC;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEC                                        0648
*   RFY                                                            0649
*     RET UNRSTD;                                                  0649
*   END READJFCB;                                                  0650
@EL00005 DS    0H                                                  0650
@EF00005 DS    0H                                                  0650
@ER00005 BR    @14                                                 0650
*OPNBASE:                                                          0651
*                                                                  0651
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: OPEN BASE CLUSTER.  IF THIS IS A PRIMARY OPEN OF     */
*/*             BASE AND PATH PROCESSING, BUILD DUMMY ACB AND DUMMY  */
*/*             AMBL FOR BASE CLUSTER AND INIT BIB PTR TO DUMMY ACB. */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO OPW IN RCORE.                              */
*/*                                                                  */
*/*   OUTPUTS:  1. PTR TO BASE AMBL IN OPWBAMBL WHICH POINTS TO      */
*/*                BASE CLUSTER CONTROL BLOCK STRUCTURE.             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0651
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0651
OPNBASE  DS    0H                                                  0652
*   RFY                                                            0652
*     RET RSTD;                                                    0652
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0653
*   RFY                                                            0654
*     RET UNRSTD;                                                  0654
*   PDPFUNC=PDF88;                  /* IND OPEN BASE FUNCTION        */
         L     @05,OPWCOMWA(,RCORE)                                0655
         MVI   PDPFUNC+280(@05),X'58'                              0655
*   OPWCURPT=ADDR(OPWBSECL);        /* PT TO BASE CLUSTER            */
         LA    @05,OPWBSECL(,RCORE)                                0656
         ST    @05,OPWCURPT(,RCORE)                                0656
*   OPWBASE=ON;                     /* IND OPEN BASE CLUSTER         */
         OI    OPWBASE(@05),B'10000000'                            0657
*   OPWCSTRN=OPWBSTRN;              /* INIT CURRENT STRING NO.       */
         IC    @05,OPWBSTRN(,RCORE)                                0658
         STC   @05,OPWCSTRN(,RCORE)                                0658
*   OPWCAMBL=OPWBCON;               /* IF CONNECTING SO INDICATE     */
         L     @05,OPWBCON(,RCORE)                                 0659
         ST    @05,OPWCAMBL(,RCORE)                                0659
*   CALL BLDAMBL;                   /* BUILD AMBL FOR BASE           */
         BAL   @14,BLDAMBL                                         0660
*   IF OPWDUMMY=OFF THEN            /* IF NOT DUMMY DATA SET         */
         TM    OPWDUMMY(RCORE),B'00010000'                         0661
         BNZ   @RF00661                                            0661
*     DO;                           /* THEN OPEN BASE CLUSTER        */
*       AMBLFLG1=AMBLFLG1|OPWFLGS4; /* SET AUTHORIZATION LEVEL IN  0663
*                                      BASE AMBL                     */
         L     @05,MWAXAMBL                                        0663
         OC    AMBLFLG1(1,@05),OPWFLGS4(RCORE)                     0663
*       IF(AMBLFULL=ON|AMBLCINV=ON|AMBLUPD=ON)&(ACBOUT=ON|ACBRST=ON)
*         THEN                      /* IF WRITE AUTHORIZATION      0664
*                                                            @XM01165*/
         TM    AMBLFULL(@05),B'11100000'                           0664
         BZ    @RF00664                                            0664
         TM    ACBOUT(RACB),B'00000010'                            0664
         BO    @RT00664                                            0664
         TM    ACBRST(RACB),B'00000100'                            0664
         BNO   @RF00664                                            0664
@RT00664 DS    0H                                                  0665
*         AMBLWRIT=ON;              /* IND ACB OPEN FOR WRITE      0665
*                                      PROCESSING                    */
         L     @05,MWAXAMBL                                        0665
         OI    AMBLWRIT(@05),B'00100000'                           0665
*       IF OPWBCON=0 THEN           /* IF PRIMARY OPEN               */
@RF00664 L     @05,OPWBCON(,RCORE)                                 0666
         LTR   @05,@05                                             0666
         BNZ   @RF00666                                            0666
*         BIBPAMBL=MWAXAMBL;        /* INIT PRIM AMBL PTR IN BIB     */
         L     @05,OPWBIB(,RCORE)                                  0667
         L     @15,MWAXAMBL                                        0667
         ST    @15,BIBPAMBL(,@05)                                  0667
*       IF OPWPDTCI^=0 THEN         /* IF PATH PROCESSING            */
@RF00666 L     @05,OPWPDTCI-1(,RCORE)                              0668
         LA    @05,0(,@05)                                         0668
         LTR   @05,@05                                             0668
         BZ    @RF00668                                            0668
*         DO;                                                      0669
*           IF BIBDACB=0 THEN       /* THEN IF BIB DUMMY ACB DOES NOT
*                                      EXIST                         */
         L     @05,OPWBIB(,RCORE)                                  0670
         L     @15,BIBDACB(,@05)                                   0670
         LTR   @15,@15                                             0670
         BNZ   @RF00670                                            0670
*             DO;                   /* THEN BUILD BIB DUMMY ACB      */
*               OPWVSMPL=OPWVSMPL&&OPWVSMPL;/* ZERO PARM LIST        */
         XC    OPWVSMPL(16,RCORE),OPWVSMPL(RCORE)                  0672
*               OPWVMANC=OPWBIB;    /* INIT ANCHOR BLOCK             */
         ST    @05,OPWVMANC(,RCORE)                                0673
*               OPWVMTYP=SPHBLK;    /* INIT BLOCK TYPE TO SPHERE     */
         MVI   OPWVMTYP(RCORE),X'80'                               0674
*               OPWVMLNG=LENGTH(IFGACB);/* INIT LENGTH OF DUMMY ACB  */
         MVC   OPWVMLNG(3,RCORE),@CF02015+1                        0675
*               CALL IDA0192M;      /* GET STORAGE FOR DUMMY ACB     */
         L     @15,@CV04855                                        0676
         BALR  @14,@15                                             0676
*               RSTATRTN=IDAR192F;  /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0677
         MVC   RSTATRTN(4,@05),@CC04581                            0677
*               IF OPWVMADR=0 THEN  /* IF STORAGE NOT OBTAINED       */
         L     @15,OPWVMADR(,RCORE)                                0678
         LTR   @15,@15                                             0678
         BNZ   @RF00678                                            0678
*                 DO;               /* THEN CALL PROB DET            */
*                   PDPCODE=PP20;   /* IND GETMAIN ERROR             */
         MVI   PDPCODE+280(@05),X'14'                              0680
*                   CALL PROBDT;    /* WRITE PROB DET MESSAGE        */
         BAL   @14,PROBDT                                          0681
*                 END;                                             0682
*               BIBDACB=OPWVMADR;   /* INIT DUMMY ACB PTR IN BIB     */
@RF00678 L     @05,OPWBIB(,RCORE)                                  0683
         L     @15,OPWVMADR(,RCORE)                                0683
         ST    @15,BIBDACB(,@05)                                   0683
*               RACB=OPWVMADR;      /* INIT ACB PTR                  */
         LR    RACB,@15                                            0684
*               ACBID='A0'X;        /* INIT ID FOR ACB               */
         MVI   ACBID(RACB),X'A0'                                   0685
*               ACBLENG=OPWVMLNG;   /* INIT LENGTH OF ACB            */
         L     @15,OPWVMLNG-1(,RCORE)                              0686
         LA    @15,0(,@15)                                         0686
         STH   @15,ACBLENG(,RACB)                                  0686
*               ACBDORGA=ON;        /* IND CONTROL BLOCK IS AN ACB   */
         OI    ACBDORGA(RACB),B'00001000'                          0687
*               ACBAMETH='11'X;     /* IND ACCESS METHOD IS VSAM     */
         MVI   ACBAMETH(RACB),X'11'                                0688
*               ACBINRTN=BIBINTRF;  /* INIT PTR TO INTERFACE ROUTINE */
         L     @05,BIBINTRF(,@05)                                  0689
         ST    @05,ACBINRTN(,RACB)                                 0689
*               ACBLOCK=ON;         /* IND ACB NOT LOCKED            */
         OI    ACBLOCK(RACB),B'00000010'                           0690
*               MWADAMBL=ON;        /* IND BUILD DUMMY AMBL FOR BASE */
         OI    MWADAMBL,B'01000000'                                0691
*               IF AMBLWRIT=ON THEN /* IF OPEN FOR OUTPUT    @XM01165*/
         L     @05,MWAXAMBL                                        0692
         TM    AMBLWRIT(@05),B'00100000'                           0692
         BNO   @RF00692                                            0692
*                 DO;                                              0693
*                   IF OPWUACB->ACBCRNCK=ON THEN/* IF NO CHECK FOR 0694
*                                      MODIFY                        */
         L     @05,OPWUACB(,RCORE)                                 0694
         TM    ACBCRNCK(@05),B'10000000'                           0694
         BNO   @RF00694                                            0694
*                     ACBCRNCK=ON;  /* IND NO CHECK FOR MODIFY       */
         OI    ACBCRNCK(RACB),B'10000000'                          0695
*                   IF OPWUACB->ACBCRNRE=ON THEN/* IF NO DATA ERASE
*                                      OR REPOSITION                 */
@RF00694 L     @05,OPWUACB(,RCORE)                                 0696
         TM    ACBCRNRE(@05),B'01000000'                           0696
         BNO   @RF00696                                            0696
*                     ACBCRNRE=ON;  /* IND NO DATA ERASE OR        0697
*                                      REPOSITION                    */
         OI    ACBCRNRE(RACB),B'01000000'                          0697
*                 END;                                             0698
*             END;                                                 0699
*           ELSE                    /* DUMMY ACB EXIST               */
*             DO;                   /* ELSE INIT DUMMY ACB IN ACB WRK*/
         B     @RC00670                                            0700
@RF00670 DS    0H                                                  0701
*               IF AMBLWRIT=ON THEN /* IF BASE AMBL OPEN FOR WRITE   */
         L     @05,MWAXAMBL                                        0701
         TM    AMBLWRIT(@05),B'00100000'                           0701
         BNO   @RF00701                                            0701
*                 DO;               /* THEN SET AUTHORIZATION LEVEL
*                                      IN D-AMBL FOR BASE            */
*                   RACB=BIBDACB;   /* PT TO D-ACB FOR BASE          */
         L     @05,OPWBIB(,RCORE)                                  0703
         L     RACB,BIBDACB(,@05)                                  0703
*                   MWAXAMBL=ACBAMBL;/* PT TO D-AMBL FOR BASE        */
         L     @05,ACBAMBL(,RACB)                                  0704
         ST    @05,MWAXAMBL                                        0704
*                   IF AMBLWRIT=OFF THEN/* IF BASE NOT OPEN FOR WRITE*/
         TM    AMBLWRIT(@05),B'00100000'                           0705
         BNZ   @RF00705                                            0705
*                     DO;           /* THEN SET INDICATORS           */
*                       AMBLWRIT=ON;/* IND AMBL OPEN FOR WRITE       */
         OI    AMBLWRIT(@05),B'00100000'                           0707
*                       IF OPWUACB->ACBCRNCK=ON THEN/* IF NO CHECK 0708
*                                      FOR MODIFY                    */
         L     @05,OPWUACB(,RCORE)                                 0708
         TM    ACBCRNCK(@05),B'10000000'                           0708
         BNO   @RF00708                                            0708
*                         ACBCRNCK=ON;/* IND NO CHECK FOR MODIFY     */
         OI    ACBCRNCK(RACB),B'10000000'                          0709
*                       IF OPWUACB->ACBCRNRE=ON THEN/* IF NO DATA  0710
*                                      ERASE OR REPOSITION           */
@RF00708 L     @05,OPWUACB(,RCORE)                                 0710
         TM    ACBCRNRE(@05),B'01000000'                           0710
         BNO   @RF00710                                            0710
*                         ACBCRNRE=ON;/* IND NO DATA ERASE OR      0711
*                                      REPOSITION                    */
         OI    ACBCRNRE(RACB),B'01000000'                          0711
*                     END;                                         0712
@RF00710 DS    0H                                                  0713
*                   AMBLFLG1=AMBLFLG1|OPWBAMBL->AMBLFLG1;/* SET    0713
*                                      HIGHEST AUTH LEVEL REQUIRED IN
*                                      D-AMBL FOR BASE               */
@RF00705 L     @05,MWAXAMBL                                        0713
         L     @15,OPWBAMBL(,RCORE)                                0713
         OC    AMBLFLG1(1,@05),AMBLFLG1(@15)                       0713
*                   MWAXAMBL=OPWBAMBL;/* RESET PTR TO BASE AMBL      */
         ST    @15,MWAXAMBL                                        0714
*                 END;                                             0715
*               RACB=ADDR(OPWDACB); /* INIT ACB PTR TO DUMMY ACB IN
*                                      ACB WORK                      */
@RF00701 LA    RACB,OPWDACB(,RCORE)                                0716
*               ACBAMETH='11'X;     /* IND ACCESS METHOD IS VSAM     */
         MVI   ACBAMETH(RACB),X'11'                                0717
*               ACBID='A0'X;        /* INIT ID FOR ACB               */
         MVI   ACBID(RACB),X'A0'                                   0718
*               ACBLENG=LENGTH(IFGACB);/* INIT LENGTH OF ACB         */
         MVC   ACBLENG(2,RACB),@CH02015                            0719
*               ACBDORGA=ON;        /* IND CONTROL BLOCK IS AN ACB   */
         OI    ACBDORGA(RACB),B'00001000'                          0720
*             END;                                                 0721
*           ACBBUSY=ON;             /* INDICATE ACB BUSY     @XM02092*/
@RC00670 OI    ACBBUSY(RACB),B'00000001'                           0722
*           ACBMACRF=OPWUACB->ACBMACRF;/* COPY MACRF FROM USER ACB   */
         L     @05,OPWUACB(,RCORE)                                 0723
         MVC   ACBMACRF(2,RACB),ACBMACRF(@05)                      0723
*           ACBMACR3=OPWUACB->ACBMACR3;/* COPY MACRF FROM USER ACB   */
         MVC   ACBMACR3(1,RACB),ACBMACR3(@05)                      0724
*           ACBEXLST=OPWUACB->ACBEXLST;/* COPY EXIT LIST PTR FROM  0725
*                                      USER ACB                      */
         L     @15,ACBEXLST(,@05)                                  0725
         ST    @15,ACBEXLST(,RACB)                                 0725
*           ACBKEY=OFF;             /* RESET KEYED PROCESSING INDR   */
*           ACBSEQ=OFF;             /* RESET SEQUENTIAL PROC INDR    */
         NI    ACBKEY(RACB),B'01101111'                            0727
*           ACBSKP=OFF;             /* RESET SKIP SEQ PROCESSING INDR*/
         NI    ACBSKP(RACB),B'11101111'                            0728
*           ACBDIR=ON;              /* IND DIRECT PROCESSING         */
         OI    ACBDIR(RACB),B'00001000'                            0729
*           ACBTIOT=OPWUACB->ACBTIOT;/* INIT TIOT OFFSET             */
         LH    @05,ACBTIOT(,@05)                                   0730
         STH   @05,ACBTIOT(,RACB)                                  0730
*           ACBAMBL=OPWBAMBL;       /* PT DUMMY ACB TO BASE AMBL     */
         L     @05,OPWBAMBL(,RCORE)                                0731
         ST    @05,ACBAMBL(,RACB)                                  0731
*           AMBLACB=BIBDACB;        /* PT BASE AMBL TO DUMMY ACB     */
         L     @05,OPWBIB(,RCORE)                                  0732
         L     @05,BIBDACB(,@05)                                   0732
         L     @01,MWAXAMBL                                        0732
         ST    @05,AMBLACB(,@01)                                   0732
*         END;                                                     0733
*       ELSE                        /* ELSE NOT PATH PROCESSING      */
*         DO;                                                      0734
         B     @RC00668                                            0734
@RF00668 DS    0H                                                  0735
*           RACB=OPWUACB;           /* PT TO USER ACB                */
         L     RACB,OPWUACB(,RCORE)                                0735
*           ACBAMBL=OPWBAMBL;       /* PT USER ACB TO BASE AMBL      */
         L     @05,OPWBAMBL(,RCORE)                                0736
         ST    @05,ACBAMBL(,RACB)                                  0736
*           AMBLACB=RACB;           /* PT BASE AMBL TO USER ACB      */
         L     @05,MWAXAMBL                                        0737
         ST    RACB,AMBLACB(,@05)                                  0737
*           IF OPWAIXDT=ON THEN     /* IF OPENING AIX FOR END-USE    */
         TM    OPWAIXDT(RCORE),B'00100000'                         0738
         BNO   @RF00738                                            0738
*             AMBLAIX=ON;           /* THEN IND AMBL FOR AIX         */
         OI    AMBLAIX(@05),B'00100000'                            0739
*         END;                                                     0740
@RF00738 DS    0H                                                  0741
*       IF ACBICI=ON&ACBNCFX=ON THEN/* IF ICI AND PAGE FIX SPECIFIED */
@RC00668 TM    ACBICI(RACB),B'00010010'                            0741
         BNO   @RF00741                                            0741
*         DO;                       /* THEN PAGE FIX CONTROL BLOCKS  */
*           RFY                                                    0743
*             TCB BASED(OPWCTCB);                                  0743
*           RFY                                                    0744
*            (R6,                                                  0744
*             RETCODE) RSTD;                                       0744
*           R6=1;                   /* SET AUTHORIZATION LEVEL REQ   */
         LA    R6,1                                                0745
*           GEN(TESTAUTH FCTN=(R6))                                0746
*           REFS(R6);               /* TEST AUTHORIZATION LEVEL      */
         TESTAUTH FCTN=(R6)
*           IF RETCODE=0|RBLINK->PROTKEY='0000'B|RBLINK->PPSTATE=OFF
*             THEN                  /* IF USER IS AUTHORISED         */
         LTR   RETCODE,RETCODE                                     0747
         BZ    @RT00747                                            0747
         L     @14,OPWCTCB(,RCORE)                                 0747
         L     @14,TCBRBP(,@14)                                    0747
         L     @14,RBLINK(,@14)                                    0747
         TM    PROTKEY(@14),B'11110000'                            0747
         BZ    @RT00747                                            0747
         TM    PPSTATE(@14),B'00000001'                            0747
         BNZ   @RF00747                                            0747
@RT00747 DS    0H                                                  0748
*             DO;                   /* THEN PAGE FIX CONTROL BLOCKS  */
*               AMBLFIX=ON;         /* IND PAGE FIX IN AMBL          */
         L     @14,MWAXAMBL                                        0749
         OI    AMBLFIX(@14),B'00001000'                            0749
*             END;                                                 0750
*           RFY                                                    0751
*             TCB BASED(OPWJSTCB);                                 0751
@RF00747 DS    0H                                                  0752
*           RFY                                                    0752
*            (R6,                                                  0752
*             RETCODE) UNRSTD;                                     0752
*         END;                                                     0753
*       PDPDSTYP=PDPBASE;           /* SET DATA SET TYPE TO BASE     */
@RF00741 L     @05,OPWCOMWA(,RCORE)                                0754
         MVI   PDPDSTYP+280(@05),X'02'                             0754
*       CALL IDA0192B;              /* OPEN BASE CLUSTER             */
         L     @15,@CV04860                                        0755
         BALR  @14,@15                                             0755
*       IF OPWPDTCI^=0 THEN         /* IF INTERNAL ACB       @XM02092*/
         L     @05,OPWPDTCI-1(,RCORE)                              0756
         LA    @05,0(,@05)                                         0756
         LTR   @05,@05                                             0756
         BZ    @RF00756                                            0756
*         ACBBUSY=OFF;              /* THEN RESET BUSY BIT   @XM02092*/
         NI    ACBBUSY(RACB),B'11111110'                           0757
*       RSTATRTN=IDAR192F;          /* INDIC 192F CONTROL    @Y30DSDP*/
@RF00756 L     @05,OPWCOMWA(,RCORE)                                0758
         MVC   RSTATRTN(4,@05),@CC04581                            0758
*       PDPDSTYP=PDPDDNM;           /* RESET DATA SET TYPE TO DD NAME*/
         AL    @05,@CF04927                                        0759
         MVI   PDPDSTYP(@05),X'01'                                 0759
*       PDPFUNC=PDF88;              /* RESET FUNCTION CODE           */
         MVI   PDPFUNC(@05),X'58'                                  0760
*       RFY                                                        0761
*         RETCODE RSTD;                                            0761
*       IF RETCODE>4 THEN           /* IF TERMINATING ERROR          */
         C     RETCODE,@CF00095                                    0762
         BNH   @RF00762                                            0762
*         DO;                                                      0763
*           RFY                                                    0764
*             RETCODE UNRSTD;                                      0764
*           MWAOFAIL=ON;            /* IND TERMINATING ERROR         */
         OI    MWAOFAIL,B'10000000'                                0765
*           RETURN TO TERM192F;     /* TERMINATE OPEN                */
         LA    @14,TERM192F                                        0766
@EL00006 DS    0H                                                  0766
@EF00006 DS    0H                                                  0766
@ER00006 BR    @14                                                 0766
*         END;                                                     0767
*       IF AMBLFIX=ON THEN          /* IF PAGE FIX INDICATED         */
@RF00762 L     @05,MWAXAMBL                                        0768
         TM    AMBLFIX(@05),B'00001000'                            0768
         BNO   @RF00768                                            0768
*         CALL PAGEFIX;             /* THEN PAGE FIX CONTROL BLOCKS  */
         BAL   @14,PAGEFIX                                         0769
*       ELSE                        /* NOT PAGE FIX                  */
*         IF MWADAMBL=ON THEN       /* IF BUILD DUMMY AMBL INDICATED */
         B     @RC00768                                            0770
@RF00768 TM    MWADAMBL,B'01000000'                                0770
         BNO   @RF00770                                            0770
*           DO;                     /* THEN BUILD DUMMY AMBL         */
*             CALL BLDAMBL;         /* BUILD DUMMY AMBL FOR BASE     */
         BAL   @14,BLDAMBL                                         0772
*             AMBLFLG1=AMBLFLG1|OPWFLGS4;/* SET AUTH LEVEL IN D-AMBL
*                                      FOR BASE                      */
         L     @05,MWAXAMBL                                        0773
         OC    AMBLFLG1(1,@05),OPWFLGS4(RCORE)                     0773
*             IF OPWBAMBL->AMBLWRIT=ON THEN/* IF WRITE AUTHORIZATION
*                                      SET IN BASE AMBL              */
         L     @01,OPWBAMBL(,RCORE)                                0774
         TM    AMBLWRIT(@01),B'00100000'                           0774
         BNO   @RF00774                                            0774
*               AMBLWRIT=ON;        /* THEN SET WRITE AUTH IN D-AMBL
*                                      FOR BASE                      */
         OI    AMBLWRIT(@05),B'00100000'                           0775
*             MWADAMBL=OFF;         /* RESET DUMMY AMBL INDICATOR    */
@RF00774 NI    MWADAMBL,B'10111111'                                0776
*             ACBAMBL=MWAXAMBL;     /* PT ACB TO DUMMY AMBL          */
         L     @05,MWAXAMBL                                        0777
         ST    @05,ACBAMBL(,RACB)                                  0777
*             AMBLACB=BIBDACB;      /* PT AMBL TO BIB DUMMY ACB      */
         L     @01,OPWBIB(,RCORE)                                  0778
         L     @15,BIBDACB(,@01)                                   0778
         ST    @15,AMBLACB(,@05)                                   0778
*             AMBLDTA=OPWBAMBL->AMBLDTA;/* PT AMBL TO DATA AMB       */
         L     @15,OPWBAMBL(,RCORE)                                0779
         L     @14,AMBLDTA(,@15)                                   0779
         ST    @14,AMBLDTA(,@05)                                   0779
*             AMBLIX=OPWBAMBL->AMBLIX;/* PT AMBL TO INDEX AMB        */
         L     @14,AMBLIX(,@15)                                    0780
         ST    @14,AMBLIX(,@05)                                    0780
*             AMBLBASE=ON;          /* IND AMBL FOR BASE             */
         OI    AMBLBASE(@05),B'00010000'                           0781
*             AMBLCMB=OPWBAMBL->AMBLCMB;/* INIT CMB PTR              */
         L     @14,AMBLCMB(,@15)                                   0782
         ST    @14,AMBLCMB(,@05)                                   0782
*             AMBLBIB=OPWBAMBL->AMBLBIB;/* INIT BIB PTR              */
         L     @15,AMBLBIB(,@15)                                   0783
         ST    @15,AMBLBIB(,@05)                                   0783
*           END;                                                   0784
*     END;                                                         0785
*   ELSE                            /* ELSE, DUMMY DATA SET          */
*     DO;                           /* PROCESS DUMMY DATA SET        */
         B     @RC00661                                            0786
@RF00661 DS    0H                                                  0787
*       ACBAMBL=MWAXAMBL;           /* INIT AMBL PTR IN USER ACB     */
         L     @05,MWAXAMBL                                        0787
         ST    @05,ACBAMBL(,RACB)                                  0787
*     END;                                                         0788
*   RFY                                                            0789
*     RET RSTD;                                                    0789
@RC00661 DS    0H                                                  0790
*   RET=MWASAVEA;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEA                                        0790
*   RFY                                                            0791
*     RET UNRSTD;                                                  0791
*   END OPNBASE;                                                   0792
         B     @EL00006                                            0792
*PAGEFIX:                                                          0793
*                                                                  0793
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: CALLED BY OPNBASE TO PAGE FIX THE AMBL AND THE       */
*/*             STORAGE BLOCKS POINTED TO BY THE CMB.                */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO AMBL IN MWAXAMBL.                          */
*/*             2. PTR TO CMB IN AMBLCMB.                            */
*/*             3. PTR'S TO HEB ELEMENTS THAT DEFINE STORAGE         */
*/*                BLOCKS IN CMB.                                    */
*/*                                                                  */
*/*   OUTPUTS:  1. PTR TO PSL THAT DEFINES FIXED PAGES IN OPWPSL.    */
*/*             2. CONTROL BLOCKS REFERENCED BY RECORD MANAGEMENT    */
*/*                ARE PAGE FIXED.                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0793
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0793
PAGEFIX  DS    0H                                                  0794
*   RFY                                                            0794
*     RET RSTD;                                                    0794
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        0795
*   RFY                                                            0796
*     RET UNRSTD;                                                  0796
*   PDPFUNC=PDF83;                  /* INIT FUNCTION CODE            */
*                                                                  0797
         L     @01,OPWCOMWA(,RCORE)                                0797
         MVI   PDPFUNC+280(@01),X'53'                              0797
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD PAGE FIX/SAVE LIST                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0798
*   RFY                                                            0798
*     HEBHDREL BASED(MWAPTRA);                                     0798
*   MWAJ=0;                         /* SET PSL ENTRY CTR TO ZERO     */
         SLR   MWAJ,MWAJ                                           0799
*   IF OPWBCON=0 THEN               /* IF PRIMARY OPEN               */
         L     @15,OPWBCON(,RCORE)                                 0800
         LTR   @15,@15                                             0800
         BNZ   @RF00800                                            0800
*     DO MWAI=1 TO CMBCNT;          /* THEN SCAN CMB ENTRIES         */
         LA    @15,1                                               0801
         B     @DE00801                                            0801
@DL00801 DS    0H                                                  0802
*       MWAPTRA=CMBPTMAP(MWAI);     /* PT TO FIRST HEB ELEMENT       */
         SLA   @15,2                                               0802
         L     @01,MWAXAMBL                                        0802
         L     @14,AMBLCMB(,@01)                                   0802
         L     @15,CMBPTMAP-4(@15,@14)                             0802
         ST    @15,MWAPTRA                                         0802
*       IF MWAPTRA^=CMBFSTPT&       /* IF NOT FIXED STRING BLOCK     */
*           MWAPTRA^=CMBUFSPT&      /* AND NOT UPGR FIXED STRNG BLK  */
*           MWAPTRA^=CMBDEBPT THEN  /* AND NOT DEB BLOCK             */
         C     @15,CMBFSTPT(,@14)                                  0803
         BE    @RF00803                                            0803
         C     @15,CMBUFSPT(,@14)                                  0803
         BE    @RF00803                                            0803
         C     @15,CMBDEBPT(,@14)                                  0803
         BE    @RF00803                                            0803
*         DO WHILE(MWAPTRA^=0);     /* THEN CNT HEB ELEMENTS IN CHN  */
         B     @DE00804                                            0804
@DL00804 DS    0H                                                  0805
*           MWAJ=MWAJ+1;            /* INCR PSL ENTRY CTR            */
         AL    MWAJ,@CF00053                                       0805
*           MWAPTRA=HEBELCHN;       /* PT TO NEXT HEB ELEMENT        */
         L     @01,MWAPTRA                                         0806
         L     @15,HEBELCHN(,@01)                                  0806
         ST    @15,MWAPTRA                                         0806
*         END;                                                     0807
@DE00804 L     @15,MWAPTRA                                         0807
         LTR   @15,@15                                             0807
         BNZ   @DL00804                                            0807
*     END;                                                         0808
@RF00803 LA    @15,1                                               0808
         AL    @15,MWAI                                            0808
@DE00801 ST    @15,MWAI                                            0808
         L     @14,MWAXAMBL                                        0808
         L     @14,AMBLCMB(,@14)                                   0808
         CH    @15,CMBCNT(,@14)                                    0808
         BNH   @DL00801                                            0808
*   MWAJ=MWAJ+1;                    /* INCR PSL ENTRY CTR FOR AMBL   */
@RF00800 AL    MWAJ,@CF00053                                       0809
*   MWAGFLEN=LENGTH(IDAPSL)+LENGTH(PSLENTRY)*MWAJ;/* CALC LENGTH OF
*                                      PSL                           */
         LR    @15,MWAJ                                            0810
         SLA   @15,3                                               0810
         LA    @15,16(,@15)                                        0810
         STCM  @15,7,MWAGFLEN                                      0810
*   MWAGFSP=FIXDPOOL;               /* INIT SUBPOOL                  */
         MVI   MWAGFSP,X'F5'                                       0811
*   CALL GETCORE;                   /* OBTAIN STORAGE FOR PSL        */
         BAL   @14,GETCORE                                         0812
*   RFY                                                            0813
*     IDAPSL BASED(MWAGFADR);                                      0813
*   PSLSUBPL=FIXDPOOL;              /* INIT SUBPOOL                  */
         L     @15,MWAGFADR                                        0814
         MVI   PSLSUBPL(@15),X'F5'                                 0814
*   PSLLENTH=MWAGFLEN;              /* INIT LENGTH OF PSL            */
         MVC   PSLLENTH(3,@15),MWAGFLEN                            0815
*   PSLID=IDAPSLID;                 /* INIT EBCDIC ID                */
         MVC   PSLID(8,@15),@CC02354                               0816
*   PSLNXPTR=OPWPSL;                /* PT TO FIRST PSL ON CHAIN      */
         L     @14,OPWPSL(,RCORE)                                  0817
         ST    @14,PSLNXPTR(,@15)                                  0817
*   OPWPSL=MWAGFADR;                /* CHAIN NEW PSL                 */
         ST    @15,OPWPSL(,RCORE)                                  0818
*   RFY                                                            0819
*     IDAPSL BASED(OPWPSL);                                        0819
*                                                                  0819
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE ENTRIES IN PAGE FIX/SAVE LIST                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0820
*   MWAK=0;                         /* ZERO PSL ENTRY INIT COUNTER   */
         SLR   MWAK,MWAK                                           0820
*   IF OPWBCON=0 THEN               /* IF NOT PRIMARY OPEN           */
         L     @15,OPWBCON(,RCORE)                                 0821
         LTR   @15,@15                                             0821
         BNZ   @RF00821                                            0821
*     DO MWAI=1 TO CMBCNT;          /* THEN SCAN CMB ENTRIES         */
         LA    @15,1                                               0822
         B     @DE00822                                            0822
@DL00822 DS    0H                                                  0823
*       MWAPTRA=CMBPTMAP(MWAI);     /* PT TO FIRST HEB ELEMENT       */
         SLA   @15,2                                               0823
         L     @01,MWAXAMBL                                        0823
         L     @14,AMBLCMB(,@01)                                   0823
         L     @15,CMBPTMAP-4(@15,@14)                             0823
         ST    @15,MWAPTRA                                         0823
*       IF MWAPTRA^=CMBFSTPT&       /* IF NOT FIXED STRING BLOCK     */
*           MWAPTRA^=CMBUFSPT&      /* AND NOT UPGR FIXED STRNG BLK  */
*           MWAPTRA^=CMBDEBPT THEN  /* AND NOT DEB BLOCK             */
         C     @15,CMBFSTPT(,@14)                                  0824
         BE    @RF00824                                            0824
         C     @15,CMBUFSPT(,@14)                                  0824
         BE    @RF00824                                            0824
         C     @15,CMBDEBPT(,@14)                                  0824
         BE    @RF00824                                            0824
*         DO WHILE(MWAPTRA^=0);     /* THEN SCAN HEB ELEMENTS        */
         B     @DE00825                                            0825
@DL00825 DS    0H                                                  0826
*           MWAK=MWAK+1;            /* INCR PSL ENTRY INIT CTR       */
         AL    MWAK,@CF00053                                       0826
*           PSLSTAD(MWAK)=HEBBLKPT; /* LD STARTING ADDR OF BLOCK     */
         LR    @15,MWAK                                            0827
         SLA   @15,3                                               0827
         L     @14,OPWPSL(,RCORE)                                  0827
         L     @11,MWAPTRA                                         0827
         L     @10,HEBBLKPT(,@11)                                  0827
         ST    @10,PSLSTAD-8(@15,@14)                              0827
*           PSLENDAD(MWAK)=HEBBLKPT+HEBLN;/* LD ENDING ADDR OF BLOCK */
         L     @09,HEBLN-1(,@11)                                   0828
         LA    @09,0(,@09)                                         0828
         ALR   @10,@09                                             0828
         ALR   @14,@15                                             0828
         STCM  @10,7,PSLENDAD-8(@14)                               0828
*           MWAPTRA=HEBELCHN;       /* PT TO NEXT HEB ELEMENT        */
         L     @15,HEBELCHN(,@11)                                  0829
         ST    @15,MWAPTRA                                         0829
*         END;                                                     0830
@DE00825 L     @15,MWAPTRA                                         0830
         LTR   @15,@15                                             0830
         BNZ   @DL00825                                            0830
*     END;                                                         0831
@RF00824 LA    @15,1                                               0831
         AL    @15,MWAI                                            0831
@DE00822 ST    @15,MWAI                                            0831
         L     @14,MWAXAMBL                                        0831
         L     @14,AMBLCMB(,@14)                                   0831
         CH    @15,CMBCNT(,@14)                                    0831
         BNH   @DL00822                                            0831
*   MWAK=MWAK+1;                    /* INCR PSL ENTRY INIT CTR       */
@RF00821 AL    MWAK,@CF00053                                       0832
*   PSLSTAD(MWAK)=MWAXAMBL;         /* LD STARTING ADDR OF AMBL      */
         L     @15,MWAXAMBL                                        0833
         LR    @14,MWAK                                            0833
         SLA   @14,3                                               0833
         L     @11,OPWPSL(,RCORE)                                  0833
         ST    @15,PSLSTAD-8(@14,@11)                              0833
*   PSLENDAD(MWAK)=MWAXAMBL+AMBLLEN;/* LOAD ENDING ADDR OF AMBL      */
         SLR   @10,@10                                             0834
         IC    @10,AMBLLEN(,@15)                                   0834
         ALR   @10,@15                                             0834
         ST    @14,@TF00001                                        0834
         ALR   @14,@11                                             0834
         STCM  @10,7,PSLENDAD-8(@14)                               0834
*   PSLFLGLT(MWAK)=ON;              /* IND LAST ENTRY                */
         LR    @10,@11                                             0835
         AL    @10,@TF00001                                        0835
         OI    PSLFLGLT-8(@10),B'10000000'                         0835
*   RFY                                                            0836
*    (R6,                                                          0836
*     R7) RSTD;                                                    0836
*   MWAFIX=OFF;                     /* RESET WORK SWITCH             */
         NI    MWAFIX,B'11011111'                                  0837
*   R6=ADDR(PSLENTRY(1));           /* POINT TO LIST                 */
         LA    R6,PSLENTRY(,@11)                                   0838
*   R7=ADDR(MWAPFECB);              /* POINT TO ECB                  */
         LA    R7,MWAPFECB                                         0839
*   DO WHILE MWAFIX=OFF;            /* LOOP UNTIL COMPLETE OR FAILURE*/
         B     @DE00840                                            0840
@DL00840 DS    0H                                                  0841
*     GEN(PGFIX L,LA=(R6),ECB=(R7),SUSPEND=Y);/* PAGE FIX CONTROL  0841
*                                      BLKS                          */
         PGFIX L,LA=(R6),ECB=(R7),SUSPEND=Y
*     RFY                                                          0842
*       RETCODE RSTD;                                              0842
*     MWARETCD=RETCODE;             /* SAVE RETURN CODE              */
         LR    MWARETCD,RETCODE                                    0843
*     RFY                                                          0844
*       RETCODE UNRSTD;                                            0844
*     IF MWARETCD=0 THEN            /* IF COMPLETE                   */
         LTR   MWARETCD,MWARETCD                                   0845
         BNZ   @RF00845                                            0845
*       MWAFIX=ON;                  /* SET SWITCH TO GET OUT         */
         OI    MWAFIX,B'00100000'                                  0846
*     ELSE                          /* IF NOT COMPLETE               */
*       DO;                                                        0847
         B     @RC00845                                            0847
@RF00845 DS    0H                                                  0848
*         IF MWARETCD^=8&           /* IF NOT PROCEEDING             */
*             MWARETCD^=28 THEN     /* IF LONG WAIT                  */
         C     MWARETCD,@CF00038                                   0848
         BE    @RF00848                                            0848
         C     MWARETCD,@CF01970                                   0848
         BE    @RF00848                                            0848
*           DO;                                                    0849
*             PDPCODE=PP50;         /* SET ERROR CODE                */
         L     @05,OPWCOMWA(,RCORE)                                0850
         MVI   PDPCODE+280(@05),X'32'                              0850
*             CALL PROBDT;          /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0851
*           END;                                                   0852
*         ELSE                      /* IF OK AND PROCESSING          */
*           DO;                                                    0853
         B     @RC00848                                            0853
@RF00848 DS    0H                                                  0854
*             GEN(WAIT ECB=MWAPFECB);/* WAIT FOR PAGE TO BE FIXED    */
         WAIT ECB=MWAPFECB
*             IF MWAECBAD=ON THEN   /* PAGE FIX UNSUCCESSFUL         */
         TM    MWAECBAD,B'00000100'                                0855
         BNO   @RF00855                                            0855
*               DO;                                                0856
*                 PDPCODE=PP50;     /* SET ERROR CODE                */
         L     @05,OPWCOMWA(,RCORE)                                0857
         MVI   PDPCODE+280(@05),X'32'                              0857
*                 CALL PROBDT;      /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0858
*               END;                                               0859
*             ELSE                  /* IF PAGE FIX NOT UNSUCCESSFUL  */
*               IF MWAECBCC^=48 THEN/* IF NO NEED TO RESTART         */
         B     @RC00855                                            0860
@RF00855 CLI   MWAECBCC,48                                         0860
         BE    @RF00860                                            0860
*                 MWAFIX=ON;        /* THEN WE ARE DONE              */
         OI    MWAFIX,B'00100000'                                  0861
*               ELSE                /* WE NEED TO RETRY              */
*                 MWAPFECB=0;       /* ZERO ECB FOR RETRY            */
         B     @RC00860                                            0862
@RF00860 SLR   @05,@05                                             0862
         ST    @05,MWAPFECB                                        0862
*           END;                                                   0863
@RC00860 DS    0H                                                  0863
@RC00855 DS    0H                                                  0864
*       END;                                                       0864
@RC00848 DS    0H                                                  0865
*   END;                                                           0865
@RC00845 DS    0H                                                  0865
@DE00840 TM    MWAFIX,B'00100000'                                  0865
         BZ    @DL00840                                            0865
*   RFY                                                            0866
*    (R6,                                                          0866
*     R7) UNRSTD;                                                  0866
*   RFY                                                            0867
*     RET RSTD;                                                    0867
*   RET=MWASAVEB;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEB                                        0868
*   RFY                                                            0869
*     RET UNRSTD;                                                  0869
*   END PAGEFIX;                                                   0870
@EL00007 DS    0H                                                  0870
@EF00007 DS    0H                                                  0870
@ER00007 BR    @14                                                 0870
*OPNUPGR:                                                          0871
*                                                                  0871
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: OPEN UPGRADE SET.  BUILDS UPT, UPGRADE RPL'S, AND    */
*/*             UPGRADE ACB'S.  CALLS BLDAMBL TO BUILD THE UPGRADE   */
*/*             AMBL'S.  CALLS IDA0192B TO OPEN THE UPGRADE          */
*/*             INDEXES.                                             */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO OPW IN RCORE.                              */
*/*                                                                  */
*/*   OUTPUTS:  1. PTR TO UPT IN OPWUPT.                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0871
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0871
OPNUPGR  DS    0H                                                  0872
*   RFY                                                            0872
*     RET RSTD;                                                    0872
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0873
*   RFY                                                            0874
*     RET UNRSTD;                                                  0874
*   PDPFUNC=PDF89;                  /* INIT FUNCTION CODE            */
*                                                                  0875
         L     @05,OPWCOMWA(,RCORE)                                0875
         MVI   PDPFUNC+280(@05),X'59'                              0875
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD UPGRADE TABLE AND INITIALIZE HEADER                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0876
*   OPWVSMPL=OPWVSMPL&&OPWVSMPL;    /* ZERO PARAMETER LIST FOR VSM   */
         XC    OPWVSMPL(16,RCORE),OPWVSMPL(RCORE)                  0876
*   OPWVMLNG=LENGTH(IDAUPT)+LENGTH(UPTAXENT)*OPWNOUPG;/* COMPUTE   0877
*                                      LENGTH OF UPT                 */
         SLR   @05,@05                                             0877
         IC    @05,OPWNOUPG(,RCORE)                                0877
         MH    @05,@CH00033                                        0877
         AL    @05,@CF01709                                        0877
         STCM  @05,7,OPWVMLNG(RCORE)                               0877
*   OPWVMTYP=SPHBLK;                /* IND REQUEST FOR SPHERE BLOCK  */
         MVI   OPWVMTYP(RCORE),X'80'                               0878
*   OPWVMANC=ADDR(IDABIB);          /* INIT ANCHOR BLOCK TO BIB      */
         L     @05,OPWBIB(,RCORE)                                  0879
         ST    @05,OPWVMANC(,RCORE)                                0879
*   CALL IDA0192M;                  /* OBTAIN STORAGE FOR UPT        */
         L     @15,@CV04855                                        0880
         BALR  @14,@15                                             0880
*   RSTATRTN=IDAR192F;              /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0881
         MVC   RSTATRTN(4,@05),@CC04581                            0881
*   IF OPWVMADR=0 THEN              /* IF STORAGE NOT OBTAINED       */
         L     @15,OPWVMADR(,RCORE)                                0882
         LTR   @15,@15                                             0882
         BNZ   @RF00882                                            0882
*     DO;                           /* THEN CALL PROB DET            */
*       PDPCODE=PP20;               /* IND GETMAIN ERROR             */
         MVI   PDPCODE+280(@05),X'14'                              0884
*       CALL PROBDT;                /* WRITE PROB DET MESSAGE        */
         BAL   @14,PROBDT                                          0885
*     END;                                                         0886
*   OPWUPT=OPWVMADR;                /* INIT PTR TO UPT               */
@RF00882 L     @05,OPWVMADR(,RCORE)                                0887
         ST    @05,OPWUPT(,RCORE)                                  0887
*   UPTID=IDXUPT;                   /* INIT ID FOR UPT               */
         MVI   UPTID(@05),B'01000101'                              0888
*   UPTLEN=OPWVMLNG;                /* INIT LENGTH OF UPT            */
         L     @15,OPWVMLNG-1(,RCORE)                              0889
         LA    @15,0(,@15)                                         0889
         STH   @15,UPTLEN(,@05)                                    0889
*   UPTNOENT=OPWNOUPG;              /* INIT NO. OF ENTRIES IN UPT    */
         IC    @15,OPWNOUPG(,RCORE)                                0890
         STC   @15,UPTNOENT(,@05)                                  0890
*   MWASWPTR=ADDR(BIBUPT);          /* INIT PTR TO SWAP WORD         */
         L     @01,OPWBIB(,RCORE)                                  0891
         LA    @15,BIBUPT(,@01)                                    0891
         ST    @15,MWASWPTR                                        0891
*   MWASWAP=OPWVMADR;               /* INIT SWAP CONTENTS            */
         ST    @05,MWASWAP                                         0892
*   CALL UPDSSL;                    /* UPDATE SWAP SAVE LIST         */
*                                                                  0893
         BAL   @14,UPDSSL                                          0893
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE ALTERNATE INDEX ENTRIES IN UPGRADE TABLE           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0894
*   MWAXAMBL=OPWBAMBL;              /* PT TO BASE AMBL               */
         L     @05,OPWBAMBL(,RCORE)                                0894
         ST    @05,MWAXAMBL                                        0894
*   IF OPWBIXCI^=0 THEN             /* IF KSDS                       */
         L     @15,OPWBIXCI-1(,RCORE)                              0895
         LA    @15,0(,@15)                                         0895
         LTR   @15,@15                                             0895
         BZ    @RF00895                                            0895
*     MWABSEKL=AMDKEYLN;            /* THEN INIT KEY LENGTH          */
         L     @05,AMBLDTA(,@05)                                   0896
         L     @05,AMBDSB(,@05)                                    0896
         LH    @05,AMDKEYLN(,@05)                                  0896
         STH   @05,MWABSEKL                                        0896
*   ELSE                            /* ELSE ESDS                     */
*     MWABSEKL=ESDSKEYL;            /* INIT KEY LENGTH TO LENGTH OF
*                                      RBA                           */
         B     @RC00895                                            0897
@RF00895 MVC   MWABSEKL(2),@CH00095                                0897
*   DO MWAU=1 TO OPWNOUPG;          /* OPEN UPGRADE AIX'S            */
@RC00895 LA    @05,1                                               0898
         B     @DE00898                                            0898
@DL00898 DS    0H                                                  0899
*     OPWCURPT=ADDR(OPWUPAIX(MWAU));/* SET CURR PTR TO UPGR AIX      */
         SLA   @05,3                                               0899
         LA    @05,OPWUPAIX-8(@05,RCORE)                           0899
         ST    @05,OPWCURPT(,RCORE)                                0899
*     IF OPWPDTCI=OPWCDTCI THEN     /* IF THIS UPGRADE ALSO A PATH   */
         CLC   OPWPDTCI(3,RCORE),OPWCDTCI(@05)                     0900
         BNE   @RF00900                                            0900
*       OPWSVWRK=ON;                /* THEN IND DON'T FREE AMB WA'S  */
         OI    OPWSVWRK(@05),B'00010000'                           0901
*     ELSE                          /* UPGRADE NOT ALSO A PATH       */
*       OPWSVWRK=OFF;               /* ELSE IND FREE AMB WORK AREAS  */
         B     @RC00900                                            0902
@RF00900 L     @05,OPWCURPT(,RCORE)                                0902
         NI    OPWSVWRK(@05),B'11101111'                           0902
*     OPWVSMPL=OPWVSMPL&&OPWVSMPL;  /* ZERO VSM PARM LIST            */
@RC00900 XC    OPWVSMPL(16,RCORE),OPWVSMPL(RCORE)                  0903
*     OPWVMANC=OPWBIB;              /* INIT PTR TO ANCHOR BLK        */
         L     @05,OPWBIB(,RCORE)                                  0904
         ST    @05,OPWVMANC(,RCORE)                                0904
*     OPWVMTYP=SPHBLK;              /* IND REQUEST FOR SPHERE BLK    */
         MVI   OPWVMTYP(RCORE),X'80'                               0905
*     OPWVMLNG=LENGTH(IFGACB)+LENGTH(IFGRPL);/* CALC LENGTH OF     0906
*                                      UPGRADE RPL AND ACB           */
         MVC   OPWVMLNG(3,RCORE),@CF01420+1                        0906
*     CALL IDA0192M;                /* OBTAIN STORAGE FOR ACB & RPL  */
         L     @15,@CV04855                                        0907
         BALR  @14,@15                                             0907
*     RSTATRTN=IDAR192F;            /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0908
         MVC   RSTATRTN(4,@05),@CC04581                            0908
*     IF OPWVMADR=0 THEN            /* IF VSM NOT SUCCESSFUL         */
         L     @15,OPWVMADR(,RCORE)                                0909
         LTR   @15,@15                                             0909
         BNZ   @RF00909                                            0909
*       DO;                         /* THEN CALL PROB DET            */
*         PDPCODE=PP20;             /* IND GETMAIN ERROR             */
         MVI   PDPCODE+280(@05),X'14'                              0911
*         CALL PROBDT;              /* WRITE PROB DET MESSAGE        */
         BAL   @14,PROBDT                                          0912
*       END;                                                       0913
*     MWARPLPT=OPWVMADR;            /* INIT PTR TO UPGRADE RPL       */
@RF00909 L     @05,OPWVMADR(,RCORE)                                0914
         ST    @05,MWARPLPT                                        0914
*     RACB=MWARPLPT+LENGTH(IFGRPL); /* INIT PTR TO UPGRADE ACB       */
         LA    @15,76                                              0915
         LR    RACB,@05                                            0915
         ALR   RACB,@15                                            0915
*     ACBID='A0'X;                  /* INIT ID FOR ACB               */
         MVI   ACBID(RACB),X'A0'                                   0916
*     ACBLENG=LENGTH(IFGACB);       /* INIT LENGTH OF ACB            */
         STH   @15,ACBLENG(,RACB)                                  0917
*     ACBDORGA=ON;                  /* IND CONTROL BLOCK IS AN ACB   */
         OI    ACBDORGA(RACB),B'00001000'                          0918
*     ACBAMETH='11'X;               /* IND ACCESS METHOD IS VSAM     */
         MVI   ACBAMETH(RACB),X'11'                                0919
*     ACBLOCK=ON;                   /* IND ACB NOT LOCKED            */
         OI    ACBLOCK(RACB),B'00000010'                           0920
*     ACBDIR=ON;                    /* IND DIRECT PROCESSING         */
*     ACBOUT=ON;                    /* IND OUTPUT PROCESSING         */
         OI    ACBDIR(RACB),B'00001010'                            0922
*     ACBMACR3=OPWUACB->ACBMACR3;   /* COPY MACRF FROM USER ACB      */
         L     @15,OPWUACB(,RCORE)                                 0923
         MVC   ACBMACR3(1,RACB),ACBMACR3(@15)                      0923
*     ACBEXLST=OPWUACB->ACBEXLST;   /* COPY EXIT LIST PTR FROM USER
*                                      ACB                           */
         L     @15,ACBEXLST(,@15)                                  0924
         ST    @15,ACBEXLST(,RACB)                                 0924
*     ACBINRTN=BIBINTRF;            /* LD ADDR OF INTERFACE ROUTINE  */
         L     @01,OPWBIB(,RCORE)                                  0925
         L     @15,BIBINTRF(,@01)                                  0925
         ST    @15,ACBINRTN(,RACB)                                 0925
*     UPTRPL(MWAU)=MWARPLPT;        /* INIT RPL PTR IN UPT ENTRY     */
         L     @15,MWAU                                            0926
         MH    @15,@CH00033                                        0926
         L     @01,OPWUPT(,RCORE)                                  0926
         ST    @05,UPTRPL-12(@15,@01)                              0926
*     RPLID='00'X;                  /* INIT ID FOR RPL               */
         MVI   RPLID(@05),X'00'                                    0927
*     RPLKEY=ON;                    /* IND KEYED ACCESSING           */
         OI    RPLKEY(@05),B'10000000'                             0928
*     RPLDIR=ON;                    /* IND DIRECT ACCESSING          */
*     RPLASY=ON;                    /* IND ASYNCHRONOUS REQUEST      */
         OI    RPLDIR(@05),B'01001000'                             0930
*     RPLLEN=LENGTH(IFGRPL);        /* INIT LENGTH OF RPL            */
         MVI   RPLLEN(@05),X'4C'                                   0931
*     RPLDACB=RACB;                 /* INIT PTR TO ACB               */
*                                                                  0932
         ST    RACB,RPLDACB(,@05)                                  0932
*     /***************************************************************/
*     /*                                                             */
*     /* DETERMINE IF UPGRADE AIX ALREADY OPEN AS A PATH             */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0933
*     OPWESDS=OFF;                  /* RESET ESDS INDICATOR          */
         NI    OPWESDS(RCORE),B'11111101'                          0933
*     OPWDCI=OPWCDTCI;              /* INIT DATA CINV NO. FOR UPGRADE
*                                      AIX                           */
         L     @05,OPWCURPT(,RCORE)                                0934
         MVC   OPWDCI(3,RCORE),OPWCDTCI(@05)                       0934
*     OPWKSDS=ON;                   /* IND CLUSTER IS A KSDS         */
         OI    OPWKSDS(RCORE),B'00000100'                          0935
*     IF OPWBCON^=0 THEN            /* IF CONNECT PROCESSING         */
         SLR   @05,@05                                             0936
         L     @15,OPWBCON(,RCORE)                                 0936
         CR    @15,@05                                             0936
         BE    @RF00936                                            0936
*       DO;                         /* THEN SEARCH PATH AMBL'S       */
*         MWAXAMBL=OPWBCON;         /* PT TO PRIMARY AMBL FOR BASE   */
         ST    @15,MWAXAMBL                                        0938
*         OPWCAMBL=0;               /* ZERO PTR TO CONN AMBL FOR PATH*/
         ST    @05,OPWCAMBL(,RCORE)                                0939
*         DO WHILE(MWAXAMBL^=0&OPWCAMBL=0);/* SEARCH PATH AMBL'S     */
         B     @DE00940                                            0940
@DL00940 DS    0H                                                  0941
*           IF AMBLXPT^=0&          /* IF PATH AMBL EXISTS           */
*               AMBLXPT->AMBLPRIM=ON&/* AND PATH AMBL IS PRIMARY     */
*               (AMBLXPT->AMBLIDF=OPWIDF&/* AND PATH AMBL IS @ZA16012*/
*               AMBLXPT->AMBLQ2=OPWQ2) THEN/* FOR SAME AIX   @ZA16012*/
         L     @05,MWAXAMBL                                        0941
         L     @05,AMBLXPT(,@05)                                   0941
         LTR   @05,@05                                             0941
         BZ    @RF00941                                            0941
         TM    AMBLPRIM(@05),B'10000000'                           0941
         BNO   @RF00941                                            0941
         CLC   AMBLIDF(8,@05),OPWIDF(RCORE)                        0941
         BNE   @RF00941                                            0941
         CLC   AMBLQ2(1,@05),OPWQ2(RCORE)                          0941
         BNE   @RF00941                                            0941
*             DO;                                                  0942
*               OPWCAMBL=AMBLXPT;   /* INIT CURR CONN AMBL PTR       */
         ST    @05,OPWCAMBL(,RCORE)                                0943
*               OPWPRTBL=ON;        /* IND PARTIAL CB BUILD          */
         L     @05,OPWCURPT(,RCORE)                                0944
         OI    OPWPRTBL(@05),B'00001000'                           0944
*             END;                                                 0945
*           ELSE                    /* NO PATH AMBL                  */
*             MWAXAMBL=AMBLSCHN;    /* POINT TO NEXT AMBL            */
         B     @RC00941                                            0946
@RF00941 L     @05,MWAXAMBL                                        0946
         L     @05,AMBLSCHN(,@05)                                  0946
         ST    @05,MWAXAMBL                                        0946
*         END;                                                     0947
@RC00941 DS    0H                                                  0947
@DE00940 SLR   @05,@05                                             0947
         C     @05,MWAXAMBL                                        0947
         BE    @DC00940                                            0947
         C     @05,OPWCAMBL(,RCORE)                                0947
         BE    @DL00940                                            0947
@DC00940 DS    0H                                                  0948
*       END;                                                       0948
*     OPWCSTRN=1;                   /* SET CURRENT STRING NO. TO 1   */
@RF00936 MVI   OPWCSTRN(RCORE),X'01'                               0949
*     OPWUPGR=ON;                   /* IND UPGRADE AIX               */
         L     @05,OPWCURPT(,RCORE)                                0950
         OI    OPWUPGR(@05),B'00100000'                            0950
*     CALL BLDAMBL;                 /* BUILD UPGRADE AMBL            */
         BAL   @14,BLDAMBL                                         0951
*     AMBLWRIT=ON;                  /* IND AMBL OPEN FOR WRITE       */
         L     @05,MWAXAMBL                                        0952
         OI    AMBLWRIT(@05),B'00100000'                           0952
*     AMBLUPD=ON;                   /* IND UPDATE AUTHORIZATION      */
         OI    AMBLUPD(@05),B'00100000'                            0953
*     ACBAMBL=MWAXAMBL;             /* CHAIN UAMBL OFF UACB          */
         ST    @05,ACBAMBL(,RACB)                                  0954
*     AMBLACB=RACB;                 /* INIT ACB PTR IN AMBL          */
         ST    RACB,AMBLACB(,@05)                                  0955
*     PDPDSTYP=PDPUPGR;             /* SET DATA SET TYPE TO UPGRADE  */
         L     @05,OPWCOMWA(,RCORE)                                0956
         MVI   PDPDSTYP+280(@05),X'04'                             0956
*     ACBBUSY=ON;                   /* INDICATE ACB BUSY     @XM02092*/
         OI    ACBBUSY(RACB),B'00000001'                           0957
*     CALL IDA0192B;                /* OPEN UPGRADE AIX              */
         L     @15,@CV04860                                        0958
         BALR  @14,@15                                             0958
*     ACBBUSY=OFF;                  /* RESET BUSY BIT        @XM02092*/
         NI    ACBBUSY(RACB),B'11111110'                           0959
*     RSTATRTN=IDAR192F;            /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                0960
         MVC   RSTATRTN(4,@05),@CC04581                            0960
*     PDPDSTYP=PDPDDNM;             /* RESET DATA SET TYPE TO DD NAME*/
         AL    @05,@CF04927                                        0961
         MVI   PDPDSTYP(@05),X'01'                                 0961
*     PDPFUNC=PDF89;                /* RESET FUNCTION CODE           */
         MVI   PDPFUNC(@05),X'59'                                  0962
*     RFY                                                          0963
*       RETCODE RSTD;                                              0963
*     IF RETCODE>4 THEN             /* IF TERMINATING ERROR          */
         C     RETCODE,@CF00095                                    0964
         BNH   @RF00964                                            0964
*       DO;                         /* THEN                          */
*         RFY                                                      0966
*           RETCODE UNRSTD;                                        0966
*         MWAOFAIL=ON;              /* IND OPEN FAILURE              */
         OI    MWAOFAIL,B'10000000'                                0967
*         RETURN TO TERM192F;       /* TERMINATE OPEN                */
         LA    @14,TERM192F                                        0968
@EL00008 DS    0H                                                  0968
@EF00008 DS    0H                                                  0968
@ER00008 BR    @14                                                 0968
*       END;                                                       0969
*     IF OPWSVWRK=ON THEN           /* IF AMB WORK AREAS NOT FREED   */
@RF00964 L     @05,OPWCURPT(,RCORE)                                0970
         TM    OPWSVWRK(@05),B'00010000'                           0970
         BNO   @RF00970                                            0970
*       DO;                         /* THEN SAVE WORK AREA PTR'S     */
*         MWADTWRK=OPWDTWRK;        /* SAVE PTR TO DATA AMB WA       */
         L     @15,OPWDTWRK(,RCORE)                                0972
         ST    @15,MWADTWRK                                        0972
*         MWAIXWRK=OPWIXWRK;        /* SAVE PTR TO IDX AMB WA        */
         L     @15,OPWIXWRK(,RCORE)                                0973
         ST    @15,MWAIXWRK                                        0973
*         OPWSVWRK=OFF;             /* RESET SAVE WORK AREAS INDR    */
         NI    OPWSVWRK(@05),B'11101111'                           0974
*         OPWDTWRK=0;               /* ZERO PTR TO DATA AMBWORK      */
         SLR   @05,@05                                             0975
         ST    @05,OPWDTWRK(,RCORE)                                0975
*         OPWIXWRK=0;               /* ZERO PTR INDEX AMBWORK        */
         ST    @05,OPWIXWRK(,RCORE)                                0976
*       END;                                                       0977
*     IF OPWEMPUP=ON THEN           /* IF UPGRADE AIX EMPTY          */
@RF00970 L     @05,OPWCURPT(,RCORE)                                0978
         TM    OPWEMPUP(@05),B'00100000'                           0978
         BNO   @RF00978                                            0978
*       UPTF1NOP(MWAU)=ON;          /* IND UPGRADE AIX NOT OPEN      */
         L     @05,MWAU                                            0979
         MH    @05,@CH00033                                        0979
         L     @01,OPWUPT(,RCORE)                                  0979
         ALR   @01,@05                                             0979
         OI    UPTF1NOP-12(@01),B'00010000'                        0979
*     ELSE                          /* UPGRADE AIX NOT EMPTY         */
*       DO;                         /* ASSIGN UPGRADE RPL TO UPGRADE
*                                      PLH                           */
         B     @RC00978                                            0980
@RF00978 DS    0H                                                  0981
*         IF OPWLSR=OFF&OPWGSR=OFF THEN/* IF NOT LSR OR GSR  @ZA18502*/
         TM    OPWLSR(RCORE),B'01100000'                           0981
         BNZ   @RF00981                                            0981
*           DO;                     /* INIT PLH PTR                  */
*             MWAPLHPT=AMBUPLH+LENGTH(IDAPLHDR);/* PT TO PLH ENTRY   */
         L     @01,MWAXAMBL                                        0983
         L     @01,AMBLDTA(,@01)                                   0983
         LA    MWAPLHPT,16                                         0983
         AL    MWAPLHPT,AMBUPLH(,@01)                              0983
*             PLHCRPL=MWARPLPT;     /* SAVE RPL POINTER INTO PLH     */
         L     @15,MWARPLPT                                        0984
         ST    @15,PLHCRPL(,MWAPLHPT)                              0984
*             PLHMRPL=MWARPLPT;     /* SAVE RPL POINTER INTO PLH     */
         ST    @15,PLHMRPL(,MWAPLHPT)                              0985
*             PLHAVL='FF'X;         /* SET PLH AVAILABILITY BYTE     */
         MVI   PLHAVL(MWAPLHPT),X'FF'                              0986
*             RPLPLHPT=MWAPLHPT;    /* SAVE PLH POINTER INTO RPL     */
         ST    MWAPLHPT,RPLPLHPT(,@15)                             0987
*           END;                                                   0988
*         UPTRKP(MWAU)=AMDAXRKP;    /* INIT REL KEY POSITION         */
@RF00981 L     @05,MWAU                                            0989
         MH    @05,@CH00033                                        0989
         L     @15,OPWUPT(,RCORE)                                  0989
         L     @14,MWAXAMBL                                        0989
         L     @14,AMBLDTA(,@14)                                   0989
         L     @14,AMBDSB(,@14)                                    0989
         LH    @11,AMDAXRKP(,@14)                                  0989
         STH   @11,UPTRKP-12(@05,@15)                              0989
*         UPTLNCDE(MWAU)=AMDKEYLN-1;/* INIT LENGTH CODE              */
         LH    @11,AMDKEYLN(,@14)                                  0990
         LR    @10,@11                                             0990
         BCTR  @10,0                                               0990
         STC   @10,UPTLNCDE-12(@05,@15)                            0990
*         UPTBG(MWAU)=MAX(BGCNST,LENGTH(IDAAIX)+AMDKEYLN+MWABSEKL);/*
*                                      INIT LENGTH OF RPL AREA       */
         AL    @11,@CF00145                                        0991
         AH    @11,MWABSEKL                                        0991
         LA    @10,252                                             0991
         CR    @11,@10                                             0991
         BNL   *+6
         LR    @11,@10                                             0991
         STH   @11,UPTBG-12(@05,@15)                               0991
*         IF AMDUNQ=ON THEN         /* AMDSB NON UNIQUE KEY          */
         TM    AMDUNQ(@14),B'10000000'                             0992
         BNO   @RF00992                                            0992
*           UPTF1NUK(MWAU)=ON;      /* YES, SET UPT NON UNIQUE KEY   */
         ALR   @15,@05                                             0993
         OI    UPTF1NUK-12(@15),B'00100000'                        0993
*         OPWUPGOP=ON;              /* IND UPGRADE SET OPENED        */
@RF00992 OI    OPWUPGOP(RCORE),B'00100000'                         0994
*         IF UPTLLEN<AMDKEYLN+AMDAXRKP THEN/* IF MAX LENGTH CODE LESS
*                                      THAN CURRENT LENGTH CODE      */
         L     @05,OPWUPT(,RCORE)                                  0995
         L     @01,MWAXAMBL                                        0995
         L     @01,AMBLDTA(,@01)                                   0995
         L     @15,AMBDSB(,@01)                                    0995
         LH    @14,AMDKEYLN(,@15)                                  0995
         AH    @14,AMDAXRKP(,@15)                                  0995
         CH    @14,UPTLLEN(,@05)                                   0995
         BNH   @RF00995                                            0995
*           UPTLLEN=AMDKEYLN+AMDAXRKP;/* UPDATE LENGTH CODE          */
         STH   @14,UPTLLEN(,@05)                                   0996
*       END;                                                       0997
@RF00995 DS    0H                                                  0998
*   END;                                                           0998
@RC00978 LA    @05,1                                               0998
         AL    @05,MWAU                                            0998
@DE00898 ST    @05,MWAU                                            0998
         SLR   @15,@15                                             0998
         IC    @15,OPWNOUPG(,RCORE)                                0998
         CR    @05,@15                                             0998
         BNH   @DL00898                                            0998
*   UPTF1LST(MWAU-1)=ON;            /* SET LAST ENTRY INDICATOR      */
         L     @05,MWAU                                            0999
         MH    @05,@CH00033                                        0999
         L     @01,OPWUPT(,RCORE)                                  0999
         ALR   @01,@05                                             0999
         OI    UPTF1LST-24(@01),B'10000000'                        0999
*   RFY                                                            1000
*     RET RSTD;                                                    1000
*   RET=MWASAVEA;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEA                                        1001
*   RFY                                                            1002
*     RET UNRSTD;                                                  1002
*   END OPNUPGR;                                                   1003
         B     @EL00008                                            1003
*UPDSSL:                                                           1004
*                                                                  1004
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: UPDATE SWAP SAVE LIST (SSL).  DETERMINES IF THERE IS */
*/*             AVAILABLE ENTRY IN SSL.  IF THERE IS AN ENTRY, THE   */
*/*             CONTENTS OF MWASWSAV ARE PLACED IN THE ENTRY AND THE */
*/*             SSLACEN FIELD IS UPDATED.  IF THER IS NOT AN         */
*/*             AVAILABLE ENTRY, A NEW SSL IS BUILT AND INITIALIZED, */
*/*             THE CONTENTS OF MWASWSAV ARE LOADED INTO THE FIRST   */
*/*             ENTRY, AND THE NEW SSL IS ADDED TO THE SSL CHAIN.    */
*/*                                                                  */
*/*   INPUTS:   1. CONTENTS OF NEW SSL ENTRY IN MWASWSAV.            */
*/*             2. PTR TO SSL CHAIN IN OPWSSL.                       */
*/*                                                                  */
*/*   OUTPUTS:  1. NEW ENTRY ADDED TO SSL.                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  1004
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1004
UPDSSL   DS    0H                                                  1005
*   RFY                                                            1005
*     RET RSTD;                                                    1005
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        1006
*   RFY                                                            1007
*     RET UNRSTD;                                                  1007
*   IF SSLACEN>=DIM(SSLENTRY) THEN  /* IF SSL FULL                   */
         L     @05,OPWSSL(,RCORE)                                  1008
         LH    @05,SSLACEN(,@05)                                   1008
         C     @05,@CF00050                                        1008
         BL    @RF01008                                            1008
*     DO;                           /* THEN BUILD A NEW SSL          */
*       MWAGFSP=WKPOOL;             /* INIT SUBPOOL                  */
         MVI   MWAGFSP,X'FC'                                       1010
*       MWAGFLEN=LENGTH(IDASSL);    /* INIT LENGTH                   */
         MVC   MWAGFLEN(3),@CF01418+1                              1011
*       CALL GETCORE;               /* OBTAIN STORAGE FOR SSL        */
         BAL   @14,GETCORE                                         1012
*       RFY                                                        1013
*         IDASSL BASED(MWAGFADR);                                  1013
*       SSLNXPTR=OPWSSL;            /* PT TO FIRST SSL ON CHAIN      */
         L     @05,MWAGFADR                                        1014
         L     @15,OPWSSL(,RCORE)                                  1014
         ST    @15,SSLNXPTR(,@05)                                  1014
*       SSLSUBPL=WKPOOL;            /* INIT SUBPOOL IN SSL           */
         MVI   SSLSUBPL(@05),X'FC'                                 1015
*       SSLLENTH=MWAGFLEN;          /* INIT LENGTH OF SSL            */
         MVC   SSLLENTH(3,@05),MWAGFLEN                            1016
*       SSLID=IDASSLID;             /* INIT EBCDIC ID                */
         MVC   SSLID(8,@05),@CC02838                               1017
*       OPWSSL=MWAGFADR;            /* ADD SSL TO CHAIN              */
         ST    @05,OPWSSL(,RCORE)                                  1018
*       RFY                                                        1019
*         IDASSL BASED(OPWSSL);                                    1019
*     END;                                                         1020
*   SSLACEN=SSLACEN+1;              /* INCR NO. OF ACTIVE ENTRIES    */
@RF01008 L     @05,OPWSSL(,RCORE)                                  1021
         LA    @15,1                                               1021
         AH    @15,SSLACEN(,@05)                                   1021
         STH   @15,SSLACEN(,@05)                                   1021
*   SSLENTRY(SSLACEN)=MWASWSAV;     /* ADD NEW ENTRY TO SSL          */
         SLA   @15,3                                               1022
         ALR   @05,@15                                             1022
         MVC   SSLENTRY-8(8,@05),MWASWSAV                          1022
*   RFY                                                            1023
*     RET RSTD;                                                    1023
*   RET=MWASAVEB;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEB                                        1024
*   RFY                                                            1025
*     RET UNRSTD;                                                  1025
*   END UPDSSL;                                                    1026
@EL00009 DS    0H                                                  1026
@EF00009 DS    0H                                                  1026
@ER00009 BR    @14                                                 1026
*OPNPATH:                                                          1027
*                                                                  1027
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: OPENS PATH AIX.  CALLS CONPATH TO DETERMINE IF PATH  */
*/*             AIX ALREADY OPEN AS A PATH OR UPGRADE AIX. CALLS     */
*/*             BLDAMBL TO BUILD PATH AMBL. CALLS IDA0192B TO        */
*/*             OPEN PATH AIX.                                       */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO OPW IN RCORE.                              */
*/*                                                                  */
*/*   OUTPUTS:  1. OPENED PATH AIX.                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  1027
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1027
OPNPATH  DS    0H                                                  1028
*   RFY                                                            1028
*     RET RSTD;                                                    1028
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        1029
*   RFY                                                            1030
*     RET UNRSTD;                                                  1030
*   PDPFUNC=PDF90;                  /* SET FUNCTION CODE             */
         LA    @05,280                                             1031
         AL    @05,OPWCOMWA(,RCORE)                                1031
         MVI   PDPFUNC(@05),X'5A'                                  1031
*   PDPDSTYP=PDPPATH;               /* IND PATH DATA SET             */
         MVI   PDPDSTYP(@05),X'03'                                 1032
*   OPWCURPT=ADDR(OPWPTAIX);        /* IND OPEN PATH AIX             */
         LA    @05,OPWPTAIX(,RCORE)                                1033
         ST    @05,OPWCURPT(,RCORE)                                1033
*   CALL CONPATH;                   /* CONNECT PROCESSING FOR PATH 1034
*                                      AIX                           */
         BAL   @14,CONPATH                                         1034
*   OPWCSTRN=OPWSTRNO;              /* INIT CURRENT STR NO.FOR PATH  */
         IC    @05,OPWSTRNO(,RCORE)                                1035
         STC   @05,OPWCSTRN(,RCORE)                                1035
*   OPWPATH=ON;                     /* INDICATE OPEN PATH AIX        */
         L     @05,OPWCURPT(,RCORE)                                1036
         OI    OPWPATH(@05),B'01000000'                            1036
*   CALL BLDAMBL;                   /* BUILD PATH AMBL               */
         BAL   @14,BLDAMBL                                         1037
*   OPWBAMBL->AMBLXPT=OPWPAMBL;     /* INIT PATH-AMBL PTR IN BASE  1038
*                                      AMBL                          */
         L     @05,OPWBAMBL(,RCORE)                                1038
         L     @15,OPWPAMBL(,RCORE)                                1038
         ST    @15,AMBLXPT(,@05)                                   1038
*   AMBLXPT=OPWBAMBL;               /* INIT BASE-AMBL PTR IN PATH  1039
*                                      AMBL                          */
         L     @14,MWAXAMBL                                        1039
         ST    @05,AMBLXPT(,@14)                                   1039
*   RACB=OPWUACB;                   /* INIT ACB PTR TO USER ACB      */
         L     RACB,OPWUACB(,RCORE)                                1040
*   ACBAMBL=OPWPAMBL;               /* INIT AMBL PTR IN ACB          */
         ST    @15,ACBAMBL(,RACB)                                  1041
*   AMBLACB=RACB;                   /* INIT ACB PTR IN PATH AMBL     */
         ST    RACB,AMBLACB(,@14)                                  1042
*   MWAMACRF=ACBMACRF;              /* SAVE ACBMACRF                 */
         MVC   MWAMACRF(2),ACBMACRF(RACB)                          1043
*   ACBOUT=OFF;                     /* RESET OUTPUT INDR             */
         NI    ACBOUT(RACB),B'11111101'                            1044
*   CALL IDA0192B;                  /* OPEN PATH AIX                 */
         L     @15,@CV04860                                        1045
         BALR  @14,@15                                             1045
*   RFY                                                            1046
*     RETCODE RSTD;                 /*                       @Z30SSDP*/
*   RSTATRTN=IDAR192F;              /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @14,OPWCOMWA(,RCORE)                                1047
         MVC   RSTATRTN(4,@14),@CC04581                            1047
*   PDPDSTYP=PDPDDNM;               /* RESET DATA SET TYPE TO DD NAME*/
         AL    @14,@CF04927                                        1048
         MVI   PDPDSTYP(@14),X'01'                                 1048
*   ACBMACRF=MWAMACRF;              /* RESTORE ACBMACRF              */
         MVC   ACBMACRF(2,RACB),MWAMACRF                           1049
*   PDPFUNC=PDF90;                  /* RESTORE FUNCTION CODE         */
         MVI   PDPFUNC(@14),X'5A'                                  1050
*   IF RETCODE>4 THEN               /* IF TERMINATING ERROR          */
         C     RETCODE,@CF00095                                    1051
         BNH   @RF01051                                            1051
*     DO;                           /* THEN TERMINATE OPEN           */
*       RFY                                                        1053
*         RETCODE UNRSTD;                                          1053
*       MWAOFAIL=ON;                /* IND OPEN FAILURE              */
         OI    MWAOFAIL,B'10000000'                                1054
*       RETURN TO TERM192F;         /* TERMINATE OPEN                */
         LA    @14,TERM192F                                        1055
@EL00010 DS    0H                                                  1055
@EF00010 DS    0H                                                  1055
@ER00010 BR    @14                                                 1055
*     END;                                                         1056
*   AMBLDTA->AMBTRACE=OPWBAMBL->AMBLDTA->AMBTRACE;/* USE BASE      1057
*                                      AMBTRACE ADDR         @ZA29388*/
@RF01051 L     @05,MWAXAMBL                                        1057
         L     @01,AMBLDTA(,@05)                                   1057
         L     @15,OPWBAMBL(,RCORE)                                1057
         L     @15,AMBLDTA(,@15)                                   1057
         L     @00,AMBTRACE(,@15)                                  1057
         ST    @00,AMBTRACE(,@01)                                  1057
*   IF AMBLKSDS=ON THEN             /* IF KSDS THEN          @ZA29388*/
         TM    AMBLKSDS(@05),B'00000100'                           1058
         BNO   @RF01058                                            1058
*     AMBLIX->AMBTRACE=AMBLDTA->AMBTRACE;/* USE DATA AMBTRACE ADDR IN
*                                      INDEX AMB             @ZA29388*/
         L     @05,AMBLIX(,@05)                                    1059
         ST    @00,AMBTRACE(,@05)                                  1059
*   RFY                                                            1060
*     RET RSTD;                                                    1060
@RF01058 DS    0H                                                  1061
*   RET=MWASAVEA;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEA                                        1061
*   RFY                                                            1062
*     RET UNRSTD;                                                  1062
*   END OPNPATH;                                                   1063
         B     @EL00010                                            1063
*CONPATH:                                                          1064
*                                                                  1064
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: CALLED BY OPNPATH TO DETERMINE IF PATH AIX IS        */
*/*             ALREADY OPEN AS A PATH (SIMPLE CONNECT) OR AS AN     */
*/*             UPGRADE AIX (COMPLEX CONNECT).                       */
*/*                                                                  */
*/*   INPUTS: 1. PTR TO OPW IN RCORE.                                */
*/*                                                                  */
*/*   OUTPUTS 1. IF SIMPLE OR COMPLEX CONNECT, THEN OPWCAMBL POINTS  */
*/*              TO AMBL CONNECTING TO, OTHERWISE, IT IS SET TO      */
*/*              ZERO.                                               */
*/*           2. IF SIMPLE CONNECT, THEN OPWPCON POINTS TO PATH AMBL */
*/*              CONNECTING TO, OTHERWISE, IT IS SET TO ZERO.        */
*/*           3. IF COMPLEX CONNECT, THEN OPWPRTBL IS SET ON,        */
*/*              OTHERWISE, IT IS SET OFF.                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  1064
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1064
CONPATH  DS    0H                                                  1065
*   RFY                                                            1065
*     RET RSTD;                                                    1065
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        1066
*   RFY                                                            1067
*     RET UNRSTD;                                                  1067
*   OPWESDS=OFF;                    /* RESET ESDS INDICATOR          */
         NI    OPWESDS(RCORE),B'11111101'                          1068
*   OPWDCI=OPWCDTCI;                /* INIT CINV NO. FOR DATA        */
         L     @05,OPWCURPT(,RCORE)                                1069
         MVC   OPWDCI(3,RCORE),OPWCDTCI(@05)                       1069
*   OPWKSDS=ON;                     /* IND CLUSTER IS A KSDS         */
         OI    OPWKSDS(RCORE),B'00000100'                          1070
*   IF OPWBCON^=0 THEN              /* IF CONNECT PROCESSING         */
         SLR   @05,@05                                             1071
         L     @15,OPWBCON(,RCORE)                                 1071
         CR    @15,@05                                             1071
         BE    @RF01071                                            1071
*     DO;                           /* THEN INIT SEARCH ARGUMENT     */
*       MWAXAMBL=OPWBCON;           /* PT TO PRIMARY AMBL FOR BASE   */
         ST    @15,MWAXAMBL                                        1073
*       OPWCAMBL=0;                 /* ZERO CONNECT AMBL PTR         */
         ST    @05,OPWCAMBL(,RCORE)                                1074
*       DO UNTIL(MWAXAMBL=0|OPWPCON^=0);/* SEARCH PATH AMBL'S        */
@DL01075 DS    0H                                                  1076
*         IF AMBLXPT^=0&            /* IF PATH AMBL EXISTS           */
*             AMBLXPT->AMBLPRIM=ON& /* AND PATH AMBL IS PRIMARY      */
*             (AMBLXPT->AMBLIDF=OPWIDF&/* AND PATH AMBL IS   @ZA16012*/
*             AMBLXPT->AMBLQ2=OPWQ2) THEN/* FOR SAME AIX     @ZA16012*/
         L     @05,MWAXAMBL                                        1076
         L     @05,AMBLXPT(,@05)                                   1076
         LTR   @05,@05                                             1076
         BZ    @RF01076                                            1076
         TM    AMBLPRIM(@05),B'10000000'                           1076
         BNO   @RF01076                                            1076
         CLC   AMBLIDF(8,@05),OPWIDF(RCORE)                        1076
         BNE   @RF01076                                            1076
         CLC   AMBLQ2(1,@05),OPWQ2(RCORE)                          1076
         BNE   @RF01076                                            1076
*           DO;                                                    1077
*             OPWPCON=AMBLXPT;      /* INIT PTR TO PATH CONNECT AMBL */
         ST    @05,OPWPCON(,RCORE)                                 1078
*             OPWCAMBL=AMBLXPT;     /* INIT CURRENT CONNECT AMBL PTR */
         ST    @05,OPWCAMBL(,RCORE)                                1079
*           END;                                                   1080
*         ELSE                      /* IF NOT                        */
*           MWAXAMBL=AMBLSCHN;      /* PT TO NEXT SECONDARY AMBL FOR
*                                      BASE                          */
         B     @RC01076                                            1081
@RF01076 L     @05,MWAXAMBL                                        1081
         L     @05,AMBLSCHN(,@05)                                  1081
         ST    @05,MWAXAMBL                                        1081
*       END;                                                       1082
@RC01076 DS    0H                                                  1082
@DE01075 SLR   @05,@05                                             1082
         C     @05,MWAXAMBL                                        1082
         BE    @DC01075                                            1082
         C     @05,OPWPCON(,RCORE)                                 1082
         BE    @DL01075                                            1082
@DC01075 DS    0H                                                  1083
*     END;                                                         1083
*   IF OPWUPT=0 THEN                /* IF UPT IN OPWRK NOT EXISTS  1084
*                                                            @ZA18253*/
@RF01071 L     @05,OPWUPT(,RCORE)                                  1084
         LTR   @05,@05                                             1084
         BNZ   @RF01084                                            1084
*     OPWUPT=BIBUPT;                /* NO USE OLD ONE        @ZA18253*/
         L     @05,OPWBIB(,RCORE)                                  1085
         L     @05,BIBUPT(,@05)                                    1085
         ST    @05,OPWUPT(,RCORE)                                  1085
*   IF OPWPCON=0&OPWUPT^=0 THEN     /* IF NOT CONNECT TO PATH AIX AND
*                                      UPDATE TABLE EXISTS   @ZA13578*/
@RF01084 SLR   @05,@05                                             1086
         C     @05,OPWPCON(,RCORE)                                 1086
         BNE   @RF01086                                            1086
         C     @05,OPWUPT(,RCORE)                                  1086
         BE    @RF01086                                            1086
*     DO;                           /* INIT SEARCH ARGUMENT          */
*       RFY                                                        1088
*         IFGRPL BASED(UPTRPL(MWAI));                              1088
*       RFY                                                        1089
*         IFGACB BASED(RPLDACB);                                   1089
*       RFY                                                        1090
*         IDAAMBL BASED(ACBAMBL);                                  1090
*       DO MWAI=1 TO UPTNOENT       /* SCAN UPT FOR          @ZA16012*/
*             WHILE(AMBLIDF^=OPWIDF|AMBLQ2^=OPWQ2);/* MATCH  @ZA16012*/
         LA    @05,1                                               1091
         B     @DE01091                                            1091
@DL01091 MH    @05,@CH00033                                        1091
         L     @01,OPWUPT(,RCORE)                                  1091
         L     @05,UPTRPL-12(@05,@01)                              1091
         L     @05,RPLDACB(,@05)                                   1091
         L     @05,ACBAMBL(,@05)                                   1091
         CLC   AMBLIDF(8,@05),OPWIDF(RCORE)                        1091
         BNE   @DB01091                                            1091
         CLC   AMBLQ2(1,@05),OPWQ2(RCORE)                          1091
         BE    @DC01091                                            1091
@DB01091 DS    0H                                                  1092
*       END;                                                       1092
         LA    @05,1                                               1092
         AL    @05,MWAI                                            1092
@DE01091 ST    @05,MWAI                                            1092
         L     @01,OPWUPT(,RCORE)                                  1092
         SLR   @00,@00                                             1092
         IC    @00,UPTNOENT(,@01)                                  1092
         CR    @05,@00                                             1092
         BNH   @DL01091                                            1092
@DC01091 DS    0H                                                  1093
*       IF MWAI<=UPTNOENT&UPTF1NOP(MWAI)=OFF THEN/* IF PATH AIX IN 1093
*                                      UPGRADE SET                   */
         L     @05,MWAI                                            1093
         L     @15,OPWUPT(,RCORE)                                  1093
         SLR   @14,@14                                             1093
         IC    @14,UPTNOENT(,@15)                                  1093
         CR    @05,@14                                             1093
         BH    @RF01093                                            1093
         MH    @05,@CH00033                                        1093
         ST    @05,@TF00001                                        1093
         ALR   @05,@15                                             1093
         TM    UPTF1NOP-12(@05),B'00010000'                        1093
         BNZ   @RF01093                                            1093
*         DO;                                                      1094
*           OPWPRTBL=ON;            /* THEN IND PARTIAL CB BUILD     */
         L     @05,OPWCURPT(,RCORE)                                1095
         OI    OPWPRTBL(@05),B'00001000'                           1095
*           OPWCAMBL=ADDR(IDAAMBL); /* INIT CURRENT CONNECT AMBL PTR */
         L     @05,@TF00001                                        1096
         L     @05,UPTRPL-12(@05,@15)                              1096
         L     @05,RPLDACB(,@05)                                   1096
         L     @05,ACBAMBL(,@05)                                   1096
         ST    @05,OPWCAMBL(,RCORE)                                1096
*           IF MWADTWRK^=0 THEN     /* IF AMBWORKS NOT FREED         */
         L     @05,MWADTWRK                                        1097
         LTR   @05,@05                                             1097
         BZ    @RF01097                                            1097
*             DO;                   /* THEN RESTORE PTR'S IN OPW     */
*               OPWDTWRK=MWADTWRK;  /* RESTORE DATA AMBWORK PTR      */
         ST    @05,OPWDTWRK(,RCORE)                                1099
*               OPWIXWRK=MWAIXWRK;  /* RESTORE INDEX AMBWORK PTR     */
         L     @05,MWAIXWRK                                        1100
         ST    @05,OPWIXWRK(,RCORE)                                1100
*             END;                                                 1101
*         END;                                                     1102
@RF01097 DS    0H                                                  1103
*       RFY                                                        1103
*         IFGACB BASED(RACB);                                      1103
@RF01093 DS    0H                                                  1104
*       RFY                                                        1104
*         IDAAMBL BASED(MWAXAMBL);                                 1104
*       RFY                                                        1105
*         IFGRPL BASED(MWARPLPT);                                  1105
*     END;                                                         1106
*   RFY                                                            1107
*     RET RSTD;                                                    1107
@RF01086 DS    0H                                                  1108
*   RET=MWASAVEB;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEB                                        1108
*   RFY                                                            1109
*     RET UNRSTD;                                                  1109
*   END CONPATH;                                                   1110
@EL00011 DS    0H                                                  1110
@EF00011 DS    0H                                                  1110
@ER00011 BR    @14                                                 1110
*BLDAMBL:                                                          1111
*                                                                  1111
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: BUILDS AN AMBL AND INITIALIZES IT.  CALLS VATUPD TO  */
*/*             ADD AN ENTRY TO VATS FOR AMBL.  CALLS CHNAMBL TO     */
*/*             ADD AMBL TO APPROPRIATE CHAIN.                       */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO OPW IN RCORE.                              */
*/*             2. IF DUMMY AMBL FOR BASE OR UPGRADE, THEN MWADAMBL  */
*/*                 IS SET ON.                                       */
*/*                                                                  */
*/*   OUTPUTS:  1. PTR TO AMBL IN MWAXAMBL.                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  1111
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1111
BLDAMBL  DS    0H                                                  1112
*   RFY                                                            1112
*     RET RSTD;                                                    1112
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        1113
*   RFY                                                            1114
*     RET UNRSTD;                                                  1114
*   OPWVSMPL=OPWVSMPL&&OPWVSMPL;    /* ZERO VSM PARAMETER LIST       */
         XC    OPWVSMPL(16,RCORE),OPWVSMPL(RCORE)                  1115
*   IF MWADAMBL=ON|OPWUPGR=ON THEN  /* IF DUMMY AMBL FOR BASE OR   1116
*                                      UPGRADE                       */
         TM    MWADAMBL,B'01000000'                                1116
         BO    @RT01116                                            1116
         L     @05,OPWCURPT(,RCORE)                                1116
         TM    OPWUPGR(@05),B'00100000'                            1116
         BNO   @RF01116                                            1116
@RT01116 DS    0H                                                  1117
*     DO;                           /* THEN INIT VSM PARM LIST FOR 1117
*                                      PROT SPH BLK                  */
*       OPWVMANC=ADDR(IDABIB);      /* INIT PTR TO ANCHOR BLOCK      */
         L     @05,OPWBIB(,RCORE)                                  1118
         ST    @05,OPWVMANC(,RCORE)                                1118
*       OPWVMTYP=PSAMBLBK;          /* IND FOR PROT AMBL BLK @Z30SSDP*/
         MVI   OPWVMTYP(RCORE),X'86'                               1119
*       OPWVMLNG=LENGTH(IDAAMBL);   /* INIT LENGTH OF AMBL           */
         MVC   OPWVMLNG(3,RCORE),@CF02011+1                        1120
*     END;                                                         1121
*   ELSE                            /* INIT VSM PARM LIST FOR DIRECT
*                                      REQUEST                       */
*     DO;                                                          1122
         B     @RC01116                                            1122
@RF01116 DS    0H                                                  1123
*       IF OPWFLGS1^=0 THEN         /* IF SYSTEM DATA SET            */
         CLI   OPWFLGS1(RCORE),0                                   1123
         BE    @RF01123                                            1123
*         OPWVMSP=CATPOOL;          /* THEN INIT SYSTEM SUBPOOL      */
         MVI   OPWVMSP(RCORE),X'E7'                                1124
*       ELSE                        /* NOT SYSTEM DATA SET   @Y30DSDP*/
*         IF OPWGSR=ON|OPWCBIC=ON THEN/* CHK FOR GSR OR CBIC @ZA16012*/
         B     @RC01123                                            1125
@RF01123 TM    OPWGSR(RCORE),B'01000000'                           1125
         BO    @RT01125                                            1125
         TM    OPWCBIC(RCORE),B'10000000'                          1125
         BNO   @RF01125                                            1125
@RT01125 DS    0H                                                  1126
*           OPWVMSP=GSRPOOL;        /* YES, SET GSR POOL     @Y30DSDP*/
         MVI   OPWVMSP(RCORE),X'F1'                                1126
*         ELSE                      /* ELSE, INIT NORMAL SUBPOOL     */
*           OPWVMSP=AMBLPOOL;       /* INIT SUBPOOL FOR AMBL         */
         B     @RC01125                                            1127
@RF01125 MVI   OPWVMSP(RCORE),X'FC'                                1127
*       OPWVMLNG=LENGTH(IDAAMBL);   /* INIT LENGTH OF AMBL           */
@RC01125 DS    0H                                                  1128
@RC01123 MVC   OPWVMLNG(3,RCORE),@CF02011+1                        1128
*       OPWVMTYP=DIRCTREQ;          /* IND DIRECT REQUEST    @Y30DSDP*/
         MVI   OPWVMTYP(RCORE),X'85'                               1129
*     END;                                                         1130
*   CALL IDA0192M;                  /* OBTAIN STORAGE FOR AMBL       */
@RC01116 L     @15,@CV04855                                        1131
         BALR  @14,@15                                             1131
*   RSTATRTN=IDAR192F;              /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                1132
         MVC   RSTATRTN(4,@05),@CC04581                            1132
*   IF OPWVMADR=0 THEN              /* IF STORAGE NOT OBTAINED       */
         L     @15,OPWVMADR(,RCORE)                                1133
         LTR   @15,@15                                             1133
         BNZ   @RF01133                                            1133
*     DO;                           /* THEN WRITE ERROR MESSAGE      */
*       PDPCODE=PP20;               /* IND GETMAIN ERROR             */
         MVI   PDPCODE+280(@05),X'14'                              1135
*       CALL PROBDT;                /* WRITE PROB DET MESSAGE        */
         BAL   @14,PROBDT                                          1136
*     END;                                                         1137
*   MWAXAMBL=OPWVMADR;              /* INIT PTR TO CURRENT AMBL      */
*                                                                  1138
@RF01133 L     @05,OPWVMADR(,RCORE)                                1138
         ST    @05,MWAXAMBL                                        1138
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE AMBL                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1139
*   IF OPWGSR=ON THEN               /* CHK FOR GSR SPEC      @Y30DSDP*/
         TM    OPWGSR(RCORE),B'01000000'                           1139
         BNO   @RF01139                                            1139
*     AMBLGSR=ON;                   /* YES, SET GSR BIT      @Y30DSDP*/
         OI    AMBLGSR(@05),B'01000000'                            1140
*   ELSE                            /* NO,                   @Y30DSDP*/
*     IF OPWLSR=ON THEN             /* CHK FOR LSR SPEC      @Y30DSDP*/
         B     @RC01139                                            1141
@RF01139 TM    OPWLSR(RCORE),B'00100000'                           1141
         BNO   @RF01141                                            1141
*       AMBLLSR=ON;                 /* YES, SET LSR BIT      @Y30DSDP*/
         L     @05,MWAXAMBL                                        1142
         OI    AMBLLSR(@05),B'00100000'                            1142
*   AMBLLEN=OPWVMLNG;               /* INIT LENGTH OF AMBL           */
@RF01141 DS    0H                                                  1143
@RC01139 L     @05,MWAXAMBL                                        1143
         L     @15,OPWVMLNG-1(,RCORE)                              1143
         STC   @15,AMBLLEN(,@05)                                   1143
*   AMBLID=IDXAMBL;                 /* INIT CB ID OF AMBL            */
         MVI   AMBLID(@05),B'01010000'                             1144
*   AMBLIDF=OPWIDF;                 /* INIT DS IDENTIFIER            */
         MVC   AMBLIDF(8,@05),OPWIDF(RCORE)                        1145
*   AMBLQ2=OPWQ2;                   /* INIT EXTENSION OF DATA SET  1146
*                                      IDENTIFIER            @ZA16012*/
         MVC   AMBLQ2(1,@05),OPWQ2(RCORE)                          1146
*   AMBLBIB=OPWBIB;                 /* INIT PTR TO BIB               */
         L     @15,OPWBIB(,RCORE)                                  1147
         ST    @15,AMBLBIB(,@05)                                   1147
*   IF OPWCIXCI=0 THEN              /* IF NOT OPENING A KSDS         */
         L     @01,OPWCURPT(,RCORE)                                1148
         L     @15,OPWCIXCI-1(,@01)                                1148
         LA    @15,0(,@15)                                         1148
         LTR   @15,@15                                             1148
         BNZ   @RF01148                                            1148
*     AMBLNUM=1;                    /* THEN IND ONE AMB PTR IN AMBL  */
         MVC   AMBLNUM(2,@05),@CH00053                             1149
*   ELSE                            /* ELSE OPENING A KSDS           */
*     AMBLNUM=2;                    /* IND TWO AMB PTR'S IN AMBL     */
         B     @RC01148                                            1150
@RF01148 L     @05,MWAXAMBL                                        1150
         MVC   AMBLNUM(2,@05),@CH00092                             1150
*   IF OPWFLGS1=0&                  /* IF NOT SYSTEM DATA SET        */
*       OPWDUMMY=OFF THEN           /* AND NOT DUMMY DS              */
@RC01148 CLI   OPWFLGS1(RCORE),0                                   1151
         BNE   @RF01151                                            1151
         TM    OPWDUMMY(RCORE),B'00010000'                         1151
         BNZ   @RF01151                                            1151
*     DO;                           /* THEN ADD AMBL TO VAT          */
*       CALL VATUPD;                /* ADD AMBL TO VAT               */
         BAL   @14,VATUPD                                          1153
*       IF MWADAMBL=ON THEN         /* IF DUMMY AMBL FOR BASE        */
         TM    MWADAMBL,B'01000000'                                1154
         BNO   @RF01154                                            1154
*         OPWDAVAT=ON;              /* IND DUMMY AMBL FOR BASE ADDED
*                                      TO VAT                        */
         OI    OPWDAVAT(RCORE),B'10000000'                         1155
*     END;                                                         1156
@RF01154 DS    0H                                                  1157
*   IF MWADAMBL=OFF THEN            /* IF NOT DUMMY AMBL FOR BASE    */
@RF01151 TM    MWADAMBL,B'01000000'                                1157
         BNZ   @RF01157                                            1157
*     CALL CHNAMBL;                 /* THEN CHAIN AMBL               */
         BAL   @14,CHNAMBL                                         1158
*   RFY                                                            1159
*     RET RSTD;                                                    1159
@RF01157 DS    0H                                                  1160
*   RET=MWASAVEB;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEB                                        1160
*   RFY                                                            1161
*     RET UNRSTD;                                                  1161
*   END BLDAMBL;                                                   1162
@EL00012 DS    0H                                                  1162
@EF00012 DS    0H                                                  1162
@ER00012 BR    @14                                                 1162
*VATUPD:                                                           1163
*                                                                  1163
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: CALLED BY BLDAMBL TO ADD AN ENTRY TO VAT FOR AN      */
*/*             AMBL.                                                */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO AMBL IN MWAXAMBL.                          */
*/*                                                                  */
*/*   OUTPUTS:  1. NEW ENTRY ADDED TO VAT FOR AMBL AND AMBL CHECK    */
*/*                INFORMATION INITIALIZED IN AMBL.                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  1163
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1163
VATUPD   DS    0H                                                  1164
*   RFY                                                            1164
*     RET RSTD;                                                    1164
*   MWASAVEC=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEC                                        1165
*   RFY                                                            1166
*     RET UNRSTD;                                                  1166
*   RFY                                                            1167
*     IDAVAT BASED(MWAPTRA);                                       1167
*   RFY                                                            1168
*    (R6,                                                          1168
*     R7) RSTD;                                                    1168
*   R6=JSCBSHR;                     /* SAVE JSCBSHR                  */
         L     @05,OPWJSTCB(,RCORE)                                1169
         L     @05,TCBJSCB(,@05)                                   1169
         L     @15,JSCBSHR(,@05)                                   1169
         LR    R6,@15                                              1169
*   IF(JSCBSHR=0|VATCBSTP^=JSCBSTEP) THEN/* IF VAT DOESN'T EXIST     */
         LTR   @15,@15                                             1170
         BZ    @RT01170                                            1170
         CLC   VATCBSTP+196(1,@05),JSCBSTEP(@05)                   1170
         BE    @RF01170                                            1170
@RT01170 DS    0H                                                  1171
*     DO;                           /* THEN BUILD FIRST VAT          */
*       MWAGFSP=VATPOOL;            /* INIT SUBPOOL OF VAT           */
         MVI   MWAGFSP,X'FC'                                       1172
*       MWAGFLEN=LENGTH(IDAVAT);    /* INIT LENGTH OF VAT            */
         MVC   MWAGFLEN(3),@CF00034+1                              1173
*       CALL GETCORE;               /* OBTAIN STORAGE FOR VAT        */
         BAL   @14,GETCORE                                         1174
*       MWAGFADR->VATID=IDXVAT;     /* INIT CB ID            @OZ03937*/
         L     @05,MWAGFADR                                        1175
         MVI   VATID(@05),B'00010001'                              1175
*       MWAGFADR->VATLEN=MWAGFLEN;  /* INIT LENGTH           @OZ03937*/
         L     @15,MWAGFLEN-1                                      1176
         LA    @15,0(,@15)                                         1176
         STH   @15,VATLEN(,@05)                                    1176
*       MWAGFADR->VATVRT=0;         /* IND FIRST VAT         @OZ03937*/
         MVI   VATVRT(@05),X'00'                                   1177
*       MWAGFADR->VATENO=DIM(VATAMBL);/* INIT NO. OF ENTRIES @OZ03937*/
         MVI   VATENO(@05),X'10'                                   1178
*       ADDR(MWAGFADR)->VATCBSTP=JSCBSTEP;/* CURRENT STEP NO @OZ03937*/
         LA    @05,MWAGFADR                                        1179
         L     @01,OPWJSTCB(,RCORE)                                1179
         L     @15,TCBJSCB(,@01)                                   1179
         IC    @14,JSCBSTEP(,@15)                                  1179
         STC   @14,VATCBSTP(,@05)                                  1179
*       R7=ADDR(MWAGFADR)->IDAVATCB;/* INIT SWAP REG         @ZA07697*/
         L     R7,IDAVATCB(,@05)                                   1180
*       CS(R6,R7,JSCBSHR);          /* COMPARE AND SWAP VAT PTR      */
         CS    R6,@07,JSCBSHR(@15)                                 1181
*       IF R7^=JSCBSHR THEN         /* IF COMPARE AND SWAP FAILED    */
         C     R7,JSCBSHR(,@15)                                    1182
         BE    @RF01182                                            1182
*         CALL FREECORE;            /* THEN FREE NEW VAT             */
         BAL   @14,FREECORE                                        1183
*     END;                                                         1184
@RF01182 DS    0H                                                  1185
*   MWAVATSW=OFF;                   /* RESET VAT ENTRY FOUND SW      */
@RF01170 NI    MWAVATSW,B'11101111'                                1185
*   DO UNTIL(MWAVATSW=ON);                                         1186
@DL01186 DS    0H                                                  1187
*     MWAPTRA=JSCBSHR;              /* INIT PTR TO FIRST VAT         */
         L     @05,OPWJSTCB(,RCORE)                                1187
         L     @05,TCBJSCB(,@05)                                   1187
         L     @05,JSCBSHR(,@05)                                   1187
         ST    @05,MWAPTRA                                         1187
*     MWAI=1;                       /* INIT PTR TO FIRST ENTRY       */
         MVC   MWAI(4),@CF00053                                    1188
*     DO UNTIL(MWAPTRA=0|VATAMBL(MWAI)=0);/* SEARCH VAT CHAIN FOR  1189
*                                      INACTIVE ENTRY                */
@DL01189 DS    0H                                                  1190
*       IF VATNAE<VATENO THEN       /* IF THIS VAT NOT FULL          */
         L     @05,MWAPTRA                                         1190
         L     @15,VATNAE(,@05)                                    1190
         SLR   @14,@14                                             1190
         IC    @14,VATENO(,@05)                                    1190
         CR    @15,@14                                             1190
         BNL   @RF01190                                            1190
*         DO;                       /* THEN SEARCH ENTRIES           */
*           DO MWAI=1 TO VATENO WHILE(VATAMBL(MWAI)^=0);/* SEARCH FOR
*                                      INACTIVE ENTRY                */
         LA    @05,1                                               1192
         B     @DE01192                                            1192
@DL01192 LR    @15,@05                                             1192
         SLA   @15,2                                               1192
         L     @01,MWAPTRA                                         1192
         L     @15,VATAMBL-4(@15,@01)                              1192
         LTR   @15,@15                                             1192
         BZ    @DC01192                                            1192
*           END;                                                   1193
         AL    @05,@CF00053                                        1193
@DE01192 ST    @05,MWAI                                            1193
         L     @01,MWAPTRA                                         1193
         SLR   @00,@00                                             1193
         IC    @00,VATENO(,@01)                                    1193
         CR    @05,@00                                             1193
         BNH   @DL01192                                            1193
@DC01192 DS    0H                                                  1194
*           IF MWAI>VATENO THEN     /* IF INACTIVE ENTRY NOT FOUND   */
         L     @05,MWAPTRA                                         1194
         L     @15,MWAI                                            1194
         SLR   @14,@14                                             1194
         IC    @14,VATENO(,@05)                                    1194
         CR    @15,@14                                             1194
         BNH   @RF01194                                            1194
*             DO;                                                  1195
*               MWAPTRB=MWAPTRA;    /* SAVE PTR TO LAST VAT          */
         ST    @05,MWAPTRB                                         1196
*               MWAPTRA=VATNEXT;    /* POINT TO NEXT VAT             */
         L     @05,VATNEXT(,@05)                                   1197
         ST    @05,MWAPTRA                                         1197
*               MWAI=1;             /* INIT INDEX TO FIRST ENTRY     */
         MVC   MWAI(4),@CF00053                                    1198
*             END;                                                 1199
*         END;                                                     1200
*       ELSE                        /* ELSE VAT IS FULL              */
*         DO;                                                      1201
         B     @RC01190                                            1201
@RF01190 DS    0H                                                  1202
*           MWAPTRB=MWAPTRA;        /* SAVE PTR TO LAST VAT          */
         L     @05,MWAPTRA                                         1202
         ST    @05,MWAPTRB                                         1202
*           MWAPTRA=VATNEXT;        /* POINT TO NEXT VAT             */
         L     @05,VATNEXT(,@05)                                   1203
         ST    @05,MWAPTRA                                         1203
*           MWAI=1;                 /* INIT INDEX TO FIRST ENTRY     */
         MVC   MWAI(4),@CF00053                                    1204
*         END;                                                     1205
*     END;                                                         1206
@RC01190 DS    0H                                                  1206
@DE01189 L     @05,MWAPTRA                                         1206
         SLR   @15,@15                                             1206
         CR    @05,@15                                             1206
         BE    @DC01189                                            1206
         L     @14,MWAI                                            1206
         SLA   @14,2                                               1206
         C     @15,VATAMBL-4(@14,@05)                              1206
         BNE   @DL01189                                            1206
@DC01189 DS    0H                                                  1207
*     IF MWAPTRA^=0 THEN            /* IF INACTIVE ENTRY FOUND       */
         L     @05,MWAPTRA                                         1207
         SLR   @15,@15                                             1207
         CR    @05,@15                                             1207
         BE    @RF01207                                            1207
*       DO;                         /* THEN ADD ENTRY TO VAT         */
*         R6=0;                     /* ZERO COMPARE WORD             */
         SLR   R6,R6                                               1209
*         CS(R6,MWAXAMBL,VATAMBL(MWAI));/* COMPARE AND SWAP AMBL PTR */
         L     @14,MWAXAMBL                                        1210
         LR    @11,@14                                             1210
         L     @10,MWAI                                            1210
         LR    @09,@10                                             1210
         SLA   @09,2                                               1210
         ALR   @09,@05                                             1210
         CS    R6,@11,VATAMBL-4(@09)                               1210
*         IF R6=0 THEN              /* IF CS SUCCESSFUL              */
         CR    R6,@15                                              1211
         BNE   @RF01211                                            1211
*           DO;                     /* THEN INIT VAT INFO IN AMBL    */
*             AMBLVRT=VATVRT;       /* INIT TABLE NUMBER             */
         IC    @15,VATVRT(,@05)                                    1213
         STC   @15,AMBLVRT(,@14)                                   1213
*             AMBLENO=MWAI;         /* INIT ENTRY NUMBER             */
         STC   @10,AMBLENO(,@14)                                   1214
*             R6=VATNAE;            /* INIT COMPARE WORD TO NUMBER OF
*                                      ACTIVE ENTRIES                */
         L     R6,VATNAE(,@05)                                     1215
*             DO UNTIL(R7=R6+1);    /* UPDATE NO. OF ENTRIES IN VAT  */
@DL01216 DS    0H                                                  1217
*               R7=R6+1;            /* INIT SWAP WORD WITH         1217
*                                      INCREMENTED COUNTER           */
         LA    R7,1                                                1217
         ALR   R7,R6                                               1217
*               CS(R6,R7,VATNAE);   /* COMPARE AND SWAP COUNTER      */
         L     @05,MWAPTRA                                         1218
         CS    R6,@07,VATNAE(@05)                                  1218
*             END;                                                 1219
@DE01216 LA    @05,1                                               1219
         ALR   @05,R6                                              1219
         CR    R7,@05                                              1219
         BNE   @DL01216                                            1219
*             MWAVATSW=ON;          /* IND AMBL ENTRY ADDED TO VAT   */
         OI    MWAVATSW,B'00010000'                                1220
*           END;                                                   1221
*       END;                                                       1222
*     ELSE                          /* INACTIVE ENTRY NOT FOUND      */
*       DO;                         /* BUILD NEW VAT                 */
         B     @RC01207                                            1223
@RF01207 DS    0H                                                  1224
*         MWAPTRA=MWAPTRB;          /* PT TO LAST VAT ON CHAIN       */
         L     @05,MWAPTRB                                         1224
         ST    @05,MWAPTRA                                         1224
*         MWAGFSP=VATPOOL;          /* INIT SUBPOOL OF VAT           */
         MVI   MWAGFSP,X'FC'                                       1225
*         MWAGFLEN=LENGTH(IDAVAT);  /* INIT LENGTH OF VAT            */
         MVC   MWAGFLEN(3),@CF00034+1                              1226
*         CALL GETCORE;             /* OBTAIN STORAGE FOR VAT        */
         BAL   @14,GETCORE                                         1227
*         R6=0;                     /* INIT COMPARE REG TO 0         */
         SLR   R6,R6                                               1228
*         R7=MWAGFADR;              /* INIT SWAP REG                 */
         L     R7,MWAGFADR                                         1229
*         R7->VATID=IDXVAT;         /* INIT CB ID            @OZ03937*/
         MVI   VATID(R7),B'00010001'                               1230
*         R7->VATLEN=MWAGFLEN;      /* INIT LENGTH           @OZ03937*/
         L     @05,MWAGFLEN-1                                      1231
         LA    @05,0(,@05)                                         1231
         STH   @05,VATLEN(,R7)                                     1231
*         R7->VATVRT=MWAPTRA->VATVRT+1;/* INIT TABLE NUMBER  @OZ03937*/
         L     @05,MWAPTRA                                         1232
         LA    @15,1                                               1232
         SLR   @14,@14                                             1232
         IC    @14,VATVRT(,@05)                                    1232
         ALR   @15,@14                                             1232
         STC   @15,VATVRT(,R7)                                     1232
*         R7->VATENO=DIM(VATAMBL);  /* INIT NO. OF ENTRIES   @OZ03937*/
         MVI   VATENO(R7),X'10'                                    1233
*         CS(R6,R7,MWAPTRA->VATNEXT);/* ADD NEW VAT TO END OF CHAIN  */
         CS    R6,@07,VATNEXT(@05)                                 1234
*         IF R6^=0 THEN             /* IF NOT SUCCESSFUL             */
         LTR   R6,R6                                               1235
         BZ    @RF01235                                            1235
*           CALL FREECORE;          /* THEN FREE NEW VAT             */
         BAL   @14,FREECORE                                        1236
*       END;                                                       1237
@RF01235 DS    0H                                                  1238
*   END;                                                           1238
@RC01207 DS    0H                                                  1238
@DE01186 TM    MWAVATSW,B'00010000'                                1238
         BNO   @DL01186                                            1238
*   MWAPTRA=JSCBSHR;                /* RESTORE THE VAT POINTER TO THE
*                                      ADDR OF THE FIRST VAT @ZA07991*/
         L     @05,OPWJSTCB(,RCORE)                                1239
         L     @05,TCBJSCB(,@05)                                   1239
         L     @05,JSCBSHR(,@05)                                   1239
         ST    @05,MWAPTRA                                         1239
*   RFY                                                            1240
*     RET RSTD;                                                    1240
*   RET=MWASAVEC;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEC                                        1241
*   RFY                                                            1242
*     RET UNRSTD;                                                  1242
*   RFY                                                            1243
*    (R6,                                                          1243
*     R7) UNRSTD;                                                  1243
*   END VATUPD;                                                    1244
@EL00013 DS    0H                                                  1244
@EF00013 DS    0H                                                  1244
@ER00013 BR    @14                                                 1244
*CHNAMBL:                                                          1245
*                                                                  1245
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: CALLED BY BLDAMBL.  INITIALIZES THE TYPE FIELDS IN   */
*/*             THE AMBL.  IF AMBL IS NOT FOR A DUMMY, CATALOG       */
*/*             OR SCRA DATA SET, THEN ADD AMBL TO APPROPRIATE       */
*/*             AMBL CHAIN.                                          */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO AMBL IN MWAXAMBL.                          */
*/*                                                                  */
*/*   OUTPUTS:  1. PTR TO PATH AND BASE AMBL'S INITIALIZED IN OPW.   */
*/*                                                                  */
*/********************************************************************/
*                                                                  1245
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1245
CHNAMBL  DS    0H                                                  1246
*   RFY                                                            1246
*     RET RSTD;                                                    1246
*   MWASAVEC=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEC                                        1247
*   RFY                                                            1248
*     RET UNRSTD;                                                  1248
*   IF OPWUPGR=ON THEN              /* IF UPGRADE AMBL               */
         L     @05,OPWCURPT(,RCORE)                                1249
         TM    OPWUPGR(@05),B'00100000'                            1249
         BNO   @RF01249                                            1249
*     DO;                           /* PROCESS UPGRADE AMBL          */
*       AMBLUPGR=ON;                /* FLAG AMBL AS UPGRADE          */
         L     @05,MWAXAMBL                                        1251
         OI    AMBLUPGR(@05),B'01000000'                           1251
*       IF OPWCAMBL^=0 THEN         /* IF CONNECTING                 */
         L     @15,OPWCAMBL(,RCORE)                                1252
         LTR   @15,@15                                             1252
         BZ    @RF01252                                            1252
*         AMBLCMB=OPWCAMBL->AMBLCMB;/* THEN POINT AMBL TO EXISTING 1253
*                                      CMB                           */
         L     @15,AMBLCMB(,@15)                                   1253
         ST    @15,AMBLCMB(,@05)                                   1253
*       ELSE                        /* NOT CONNECTING                */
*         DO;                                                      1254
         B     @RC01252                                            1254
@RF01252 DS    0H                                                  1255
*           CALL BLDCMB;            /* BUILD CMB                     */
         BAL   @14,BLDCMB                                          1255
*           CMBOUT=ON;              /* IND CLUSTER OPEN FOR OUTPUT   */
         L     @05,MWAXAMBL                                        1256
         L     @05,AMBLCMB(,@05)                                   1256
         OI    CMBOUT(@05),B'10000000'                             1256
*         END;                                                     1257
*     END;                                                         1258
*   ELSE                            /* NOT UPGRADE AMBL              */
*     DO;                                                          1259
         B     @RC01249                                            1259
@RF01249 DS    0H                                                  1260
*       IF OPWPATH=ON THEN          /* IF PATH AMBL                  */
         L     @05,OPWCURPT(,RCORE)                                1260
         TM    OPWPATH(@05),B'01000000'                            1260
         BNO   @RF01260                                            1260
*         DO;                       /* THEN PROCESS PATH AMBL        */
*           AMBLPATH=ON;            /* FLAG AMBL AS PATH             */
         L     @15,MWAXAMBL                                        1262
         OI    AMBLPATH(@15),B'10000000'                           1262
*           OPWPAMBL=MWAXAMBL;      /* INIT PATH AMBL PTR IN ACBWORK */
         ST    @15,OPWPAMBL(,RCORE)                                1263
*           IF OPWCAMBL^=0 THEN     /* IF CONNECTING                 */
         L     @14,OPWCAMBL(,RCORE)                                1264
         LTR   @14,@14                                             1264
         BZ    @RF01264                                            1264
*             DO;                                                  1265
*               AMBLCMB=OPWCAMBL->AMBLCMB;/* PT AMBL TO EXISTING CMB */
         L     @14,AMBLCMB(,@14)                                   1266
         ST    @14,AMBLCMB(,@15)                                   1266
*               IF OPWPRTBL=ON THEN /* IF PARTIAL CB BUILD REQUIRED  */
         TM    OPWPRTBL(@05),B'00001000'                           1267
         BNO   @RF01267                                            1267
*                 DO;                                              1268
*                   AMBLPRIM=ON;    /* THEN IND PRIMARY AMBL         */
         OI    AMBLPRIM(@15),B'10000000'                           1269
*                   CMBNST=OPWCSTRN;/* SET NO. OF STRINGS FOR PATH   */
         IC    @05,OPWCSTRN(,RCORE)                                1270
         STC   @05,CMBNST(,@14)                                    1270
*                 END;                                             1271
*               ELSE                /* PARTIAL BUILD NOT REQUIRED    */
*                 DO;               /* ADD AMBL TO SECONDARY AMBL  1272
*                                      CHAIN FOR PATH                */
         B     @RC01267                                            1272
@RF01267 DS    0H                                                  1273
*                   AMBLSCHN=OPWCAMBL->AMBLSCHN;/* PT CURRENT AMBL TO
*                                      FIRST SECONDARY AMBL          */
         L     @05,MWAXAMBL                                        1273
         L     @15,OPWCAMBL(,RCORE)                                1273
         L     @14,AMBLSCHN(,@15)                                  1273
         ST    @14,AMBLSCHN(,@05)                                  1273
*                   OPWCAMBL->AMBLSCHN=MWAXAMBL;/* CHAIN AMBL        */
         ST    @05,AMBLSCHN(,@15)                                  1274
*                 END;                                             1275
*             END;                                                 1276
*           ELSE                    /* NOT CONNECTING                */
*             DO;                                                  1277
         B     @RC01264                                            1277
@RF01264 DS    0H                                                  1278
*               AMBLPRIM=ON;        /* FLAG AMBL AS PRIMARY          */
         L     @05,MWAXAMBL                                        1278
         OI    AMBLPRIM(@05),B'10000000'                           1278
*               CALL BLDCMB;        /* BUILD CMB                     */
         BAL   @14,BLDCMB                                          1279
*             END;                                                 1280
*         END;                                                     1281
*       ELSE                        /* NOT PATH AMBL                 */
*         DO;                       /* PROCESS BASE AMBL             */
         B     @RC01260                                            1282
@RF01260 DS    0H                                                  1283
*           AMBLBASE=ON;            /* FLAG AMBL AS BASE             */
         L     @05,MWAXAMBL                                        1283
         OI    AMBLBASE(@05),B'00010000'                           1283
*           OPWBAMBL=MWAXAMBL;      /* INIT BASE AMBL PTR IN ACBWORK */
         ST    @05,OPWBAMBL(,RCORE)                                1284
*           IF OPWDUMMY=ON THEN     /* IF DUMMY DATA SET             */
         TM    OPWDUMMY(RCORE),B'00010000'                         1285
         BNO   @RF01285                                            1285
*             DO;                   /* THEN SET DUMMY INDICATORS     */
*               AMBLDUMY=ON;        /* FLAG AMBL AS DUMMY            */
         OI    AMBLDUMY(@05),B'00000001'                           1287
*               AMBLNUM=0;          /* INDICATE NO AMB'S             */
         SLR   @15,@15                                             1288
         STH   @15,AMBLNUM(,@05)                                   1288
*             END;                                                 1289
*           ELSE                    /* NOT DUMMY DATA SET            */
*             DO;                   /* PROCESS BASE AMBL             */
         B     @RC01285                                            1290
@RF01285 DS    0H                                                  1291
*               IF OPWFLGS1^=0 THEN /* IF OPEN FOR SYSTEM DATA SET   */
         CLI   OPWFLGS1(RCORE),0                                   1291
         BE    @RF01291                                            1291
*                 DO;               /* THEN SET AMBL FLAGS           */
*                   AMBLPRIM=ON;    /* IND PRIMARY AMBL              */
         L     @05,MWAXAMBL                                        1293
         OI    AMBLPRIM(@05),B'10000000'                           1293
*                   AMBLCAT=ON;     /* IND AMBL FOR CATALOG          */
         OI    AMBLCAT(@05),B'00000010'                            1294
*                   CALL BLDCMB;    /* BUILD CMB                     */
         BAL   @14,BLDCMB                                          1295
*                   IF ACBOUT=ON|ACBRST=ON THEN/* IF OUTPUT SPECIFIED
*                                                            @XM01165*/
         TM    ACBOUT(RACB),B'00000010'                            1296
         BO    @RT01296                                            1296
         TM    ACBRST(RACB),B'00000100'                            1296
         BNO   @RF01296                                            1296
@RT01296 DS    0H                                                  1297
*                     CMBOUT=ON;    /* IND CLUSTER OPEN FOR OUTPUT   */
         L     @05,MWAXAMBL                                        1297
         L     @05,AMBLCMB(,@05)                                   1297
         OI    CMBOUT(@05),B'10000000'                             1297
*                   IF OPWSCRA=ON THEN/* ELSE IF SCRA OPEN           */
@RF01296 TM    OPWSCRA(RCORE),B'01000000'                          1298
         BNO   @RF01298                                            1298
*                     AMBLSCRA=ON;  /* THEN IND SCRA AMBL            */
         L     @05,MWAXAMBL                                        1299
         OI    AMBLSCRA(@05),B'00001000'                           1299
*                   ELSE            /* NOT SCRA OPEN                 */
*                     IF OPWVVIC=ON THEN/* ELSE IF VVIC              */
         B     @RC01298                                            1300
@RF01298 TM    OPWVVIC(RCORE),B'00100000'                          1300
         BNO   @RF01300                                            1300
*                       AMBLVVIC=ON;/* THEN IND VVIC AMBL            */
         L     @05,MWAXAMBL                                        1301
         OI    AMBLVVIC(@05),B'00010000'                           1301
*                 END;                                             1302
*               ELSE                /* NOT OPEN FOR SYSTEM DATA SET  */
*                 DO;               /* COMPLETE AMBL CHAINING        */
         B     @RC01291                                            1303
@RF01291 DS    0H                                                  1304
*                   IF OPWUCRA=ON THEN/* IF OPEN FOR UCRA            */
         TM    OPWUCRA(RCORE),B'10000000'                          1304
         BNO   @RF01304                                            1304
*                     AMBLUCRA=ON;  /* THEN IND AMBL FOR UCRA        */
         L     @05,MWAXAMBL                                        1305
         OI    AMBLUCRA(@05),B'00000100'                           1305
*                   IF OPWCAMBL^=0 THEN/* IF CONNECTING              */
@RF01304 L     @05,OPWCAMBL(,RCORE)                                1306
         LTR   @05,@05                                             1306
         BZ    @RF01306                                            1306
*                     DO;           /* THEN ADD AMBL TO BASE       1307
*                                      SECONDARY CHAIN               */
*                       AMBLCMB=OPWCAMBL->AMBLCMB;/* PT AMBL TO    1308
*                                      EXISTING CMB                  */
         L     @15,MWAXAMBL                                        1308
         L     @14,AMBLCMB(,@05)                                   1308
         ST    @14,AMBLCMB(,@15)                                   1308
*                       AMBLSCHN=OPWCAMBL->AMBLSCHN;/* PT CURRENT  1309
*                                      AMBL TO FIRST SECONDARY AMBL  */
         L     @14,AMBLSCHN(,@05)                                  1309
         ST    @14,AMBLSCHN(,@15)                                  1309
*                       OPWCAMBL->AMBLSCHN=MWAXAMBL;/* CHAIN AMBL    */
         ST    @15,AMBLSCHN(,@05)                                  1310
*                     END;                                         1311
*                   ELSE            /* NOT CONNECTING                */
*                     DO;           /* FLAG AMBL AS PRIMARY AND CHAIN
*                                      TO PRIMARY AMBL CHAIN         */
         B     @RC01306                                            1312
@RF01306 DS    0H                                                  1313
*                       AMBLPRIM=ON;/* IND PRIMARY AMBL              */
         L     @05,MWAXAMBL                                        1313
         OI    AMBLPRIM(@05),B'10000000'                           1313
*                       RFY                                        1314
*                        (R6,                                      1314
*                         R7) RSTD;                                1314
*                       AMBLPCHN=VATPAMBL;/* PT AMBL TO FIRST PRIMARY
*                                      AMBL                          */
         L     @01,MWAPTRA                                         1315
         L     @15,VATPAMBL(,@01)                                  1315
         ST    @15,AMBLPCHN(,@05)                                  1315
*                       R6=AMBLPCHN;/* INIT CS COMPARE VALUE         */
         LR    R6,@15                                              1316
*CS1:                               /*                       @ZA28741*/
*                       ;           /* ADD PRIMARY AMBL TO CHAIN   1317
*                                                            @ZA28741*/
CS1      DS    0H                                                  1318
*                       R7=MWAXAMBL;/* INIT CS SWAP VALUE            */
         L     R7,MWAXAMBL                                         1318
*                       CS(R6,R7,VATPAMBL);/* CHAIN AMBL             */
         L     @05,MWAPTRA                                         1319
         CS    R6,@07,VATPAMBL(@05)                                1319
*                       BC(4,CS1);  /* BR IF CS FAILS        @ZA28741*/
         BC    4,CS1                                               1320
*                       RFY                                        1321
*                        (R6,                                      1321
*                         R7) UNRSTD;                              1321
*                       CALL BLDCMB;/* BUILD CMB                     */
         BAL   @14,BLDCMB                                          1322
*                       IF(OPWFULL=ON|OPWCINV=ON|OPWUPD=ON)&(ACBOUT=ON|
*                           ACBRST=ON) THEN/* IF OPEN FOR OUTPUT     */
         TM    OPWFULL(RCORE),B'11100000'                          1323
         BZ    @RF01323                                            1323
         TM    ACBOUT(RACB),B'00000010'                            1323
         BO    @RT01323                                            1323
         TM    ACBRST(RACB),B'00000100'                            1323
         BNO   @RF01323                                            1323
@RT01323 DS    0H                                                  1324
*                         CMBOUT=ON;/* THEN IND CLUSTER OPEN FOR   1324
*                                      OUTPUT                        */
         L     @05,MWAXAMBL                                        1324
         L     @05,AMBLCMB(,@05)                                   1324
         OI    CMBOUT(@05),B'10000000'                             1324
*                     END;                                         1325
@RF01323 DS    0H                                                  1326
*                 END;                                             1326
@RC01306 DS    0H                                                  1327
*             END;                                                 1327
@RC01291 DS    0H                                                  1328
*         END;                                                     1328
@RC01285 DS    0H                                                  1329
*     END;                                                         1329
@RC01260 DS    0H                                                  1330
*   RFY                                                            1330
*     RET RSTD;                                                    1330
@RC01249 DS    0H                                                  1331
*   RET=MWASAVEC;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEC                                        1331
*   RFY                                                            1332
*     RET UNRSTD;                                                  1332
*   END CHNAMBL;                                                   1333
@EL00014 DS    0H                                                  1333
@EF00014 DS    0H                                                  1333
@ER00014 BR    @14                                                 1333
*BLDCMB:                                                           1334
*                                                                  1334
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: CALLED BY CHNAMBL TO BUILD A CMB.                    */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO AMBL IN MWAXAMBL.                          */
*/*             1. NUMBER OF STRINGS IN OPWCSTRN.                    */
*/*                                                                  */
*/*   OUTPUTS:  1. PTR TO CMB IN AMBLCMB.                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  1334
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1334
BLDCMB   DS    0H                                                  1335
*   RFY                                                            1335
*     RET RSTD;                                                    1335
*   MWASAVED=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVED                                        1336
*   RFY                                                            1337
*     RET UNRSTD;                                                  1337
*                                                                  1337
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN STORAGE FOR CMB                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1338
*   OPWVSMPL=OPWVSMPL&&OPWVSMPL;    /* ZERO VSM PARAMETER LIST       */
         XC    OPWVSMPL(16,RCORE),OPWVSMPL(RCORE)                  1338
*   OPWVMANC=MWAXAMBL;              /* INIT PTR TO ANCHOR BLOCK      */
         L     @05,MWAXAMBL                                        1339
         ST    @05,OPWVMANC(,RCORE)                                1339
*   IF OPWFLGS1^=0 THEN             /* IF SYSTEM DATA SET            */
         CLI   OPWFLGS1(RCORE),0                                   1340
         BE    @RF01340                                            1340
*     OPWVMSP=CATPOOL;              /* THEN IND SQA SUBPOOL          */
         MVI   OPWVMSP(RCORE),X'E7'                                1341
*   ELSE                            /* NOT SYSTEM DATA SET   @Y30DSDP*/
*     IF OPWGSR=ON|OPWCBIC=ON THEN  /* CHK FOR GSR OR CBIC   @ZA16012*/
         B     @RC01340                                            1342
@RF01340 TM    OPWGSR(RCORE),B'01000000'                           1342
         BO    @RT01342                                            1342
         TM    OPWCBIC(RCORE),B'10000000'                          1342
         BNO   @RF01342                                            1342
@RT01342 DS    0H                                                  1343
*       OPWVMSP=GSRPOOL;            /* YES, SET GSR SUBPOOL  @Y30DSDP*/
         MVI   OPWVMSP(RCORE),X'F1'                                1343
*     ELSE                          /* ELSE IND NORMAL SUBPOOL       */
*       OPWVMSP=CMBPOOL;            /* INIT SUBPOOL FOR CMB          */
         B     @RC01342                                            1344
@RF01342 MVI   OPWVMSP(RCORE),X'FC'                                1344
*   OPWVMLNG=LENGTH(IDACMB);        /* INIT LENGTH OF CMB            */
@RC01342 DS    0H                                                  1345
@RC01340 MVC   OPWVMLNG(3,RCORE),@CF02224+1                        1345
*   OPWVMTYP=DIRCTREQ;              /* IND DIRECT REQUEST    @Y30DSDP*/
         MVI   OPWVMTYP(RCORE),X'85'                               1346
*   CALL IDA0192M;                  /* OBTAIN STORAGE FOR CMB        */
         L     @15,@CV04855                                        1347
         BALR  @14,@15                                             1347
*   RSTATRTN=IDAR192F;              /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                1348
         MVC   RSTATRTN(4,@05),@CC04581                            1348
*   IF OPWVMADR=0 THEN              /* IF STORAGE NOT OBTAINED       */
         L     @15,OPWVMADR(,RCORE)                                1349
         LTR   @15,@15                                             1349
         BNZ   @RF01349                                            1349
*     DO;                           /* THEN SRITE PROB DET MESSAGE   */
*       PDPCODE=PP20;               /* IND GETMAIN ERROR             */
         MVI   PDPCODE+280(@05),X'14'                              1351
*       CALL PROBDT;                /* WRITE ERROR MESSAGE           */
         BAL   @14,PROBDT                                          1352
*     END;                                                         1353
*                                                                  1353
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE CMB                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1354
*   AMBLCMB=OPWVMADR;               /* INIT CMB PTR IN AMBL          */
@RF01349 L     @05,OPWVMADR(,RCORE)                                1354
         L     @01,MWAXAMBL                                        1354
         ST    @05,AMBLCMB(,@01)                                   1354
*   CMBID=IDXCMB;                   /* INIT CONTROL BLOCK ID         */
         MVI   CMBID(@05),B'00010001'                              1355
*   CMBLEN=OPWVMLNG;                /* INIT CMB LENGTH               */
         L     @15,OPWVMLNG-1(,RCORE)                              1356
         LA    @15,0(,@15)                                         1356
         STH   @15,CMBLEN(,@05)                                    1356
*   CMBCNT=LENGTH(CMBPTRS)/FWORDLEN;/* INIT NO. OF STORAGE BLOCK   1357
*                                      PTR'S IN CMB                  */
         MVC   CMBCNT(2,@05),@CH02818                              1357
*   IF OPWUPGR=OFF THEN             /* IF NOT UPGRADE AIX            */
         L     @01,OPWCURPT(,RCORE)                                1358
         TM    OPWUPGR(@01),B'00100000'                            1358
         BNZ   @RF01358                                            1358
*     CMBNST=OPWCSTRN;              /* THEN INIT NUMBER OF STRINGS   */
         IC    @15,OPWCSTRN(,RCORE)                                1359
         STC   @15,CMBNST(,@05)                                    1359
*   RFY                                                            1360
*     RET RSTD;                                                    1360
@RF01358 DS    0H                                                  1361
*   RET=MWASAVED;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVED                                        1361
*   RFY                                                            1362
*     RET UNRSTD;                                                  1362
*   END BLDCMB;                                                    1363
@EL00015 DS    0H                                                  1363
@EF00015 DS    0H                                                  1363
@ER00015 BR    @14                                                 1363
*GETCORE:                                                          1364
*                                                                  1364
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: THIS ROUTINE GETS VIRTUAL STORAGE.                   */
*/*                                                                  */
*/*   INPUTS:   1. SUBPOOL REQUIRED IN MWAGFSP.                      */
*/*             2. LENGTH OF STORAGE REQUIRED IN MWAGFLEN.           */
*/*                                                                  */
*/*   OUTPUTS:  1. GETMAIN IS ISSUED.                                */
*/*             2. PPCODE IS SET IF NOT ENOUGH STORAGE AVAILABLE.    */
*/*             3. STORAGE ALLOCATED IS ZEROED.                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  1364
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1364
GETCORE  DS    0H                                                  1365
*   RFY                                                            1365
*     RET RSTD;                                                    1365
*   MWASAVEE=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEE                                        1366
*   RFY                                                            1367
*     RET UNRSTD;                                                  1367
*   RFY                                                            1368
*    (R0,                                                          1368
*     R1,                                                          1368
*     R6,                                                          1368
*     R7,                                                          1368
*     R8,                                                          1368
*     R9) RSTD;                                                    1368
*   STM(R6,R9,MWAGFSVE);            /* SAVE WORK REGISTERS           */
         STM   R6,R9,MWAGFSVE                                      1369
*   MWAGFLEN=(MWAGFLEN+SEVEN)&NEGEIGHT;/* ROUND UP TO DOUBLE WORD  1370
*                                      BOUNDARY                      */
         LA    @05,7                                               1370
         L     @15,MWAGFLEN-1                                      1370
         LA    @15,0(,@15)                                         1370
         ALR   @05,@15                                             1370
         N     @05,@CF04735                                        1370
         STCM  @05,7,MWAGFLEN                                      1370
*   R6=MWAGFSP;                     /* LOAD SUBPOOL                  */
         SLR   R6,R6                                               1371
         IC    R6,MWAGFSP                                          1371
*   R7=MWAGFLEN;                    /* LOAD BLOCK LENGTH             */
         LR    R7,@05                                              1372
*   GEN(GETMAIN RC,LV=(R7),SP=(R6)) /*                       @Y30DSDP*/
*   SETS(RETCODE);                  /* GET BLOCK             @Y30DSDP*/
         GETMAIN RC,LV=(R7),SP=(R6)
*   RFY                                                            1374
*     RETCODE RSTD;                                                1374
*   IF RETCODE=0 THEN               /* WAS GETMAIN SUCCESSFUL        */
         LTR   RETCODE,RETCODE                                     1375
         BNZ   @RF01375                                            1375
*     DO;                           /* YES - ZERO CORE BLOCK         */
*       MWAGFADR=R1;                /* PTR TO GOTTEN CORE    @Y30DSDP*/
         ST    R1,MWAGFADR                                         1377
*       R6=MWAGFADR;                /* POINT TO CORE BLOCK           */
         L     @14,MWAGFADR                                        1378
         LR    R6,@14                                              1378
*       R7=MWAGFLEN;                /* LOAD BLOCK LENGTH             */
         L     R7,MWAGFLEN-1                                       1379
         LA    R7,0(,R7)                                           1379
*       R9=0;                       /* ZERO PAD CHARACTER            */
         SLR   R9,R9                                               1380
*       MVCL(R6,R8);                /* ZERO CORE BLOCK               */
         MVCL  R6,R8                                               1381
*     END;                                                         1382
*   LM(R6,R9,MWAGFSVE);             /* RESTORE WORK REGISTERS        */
@RF01375 LM    R6,R9,MWAGFSVE                                      1383
*   IF RETCODE^=0 THEN              /* WAS GETMAIN SUCCESSFUL        */
         LTR   RETCODE,RETCODE                                     1384
         BZ    @RF01384                                            1384
*     DO;                                                          1385
*       PDPCODE=PP20;               /* SET ERROR CODE                */
         L     @14,OPWCOMWA(,RCORE)                                1386
         MVI   PDPCODE+280(@14),X'14'                              1386
*       CALL PROBDT;                /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          1387
*     END;                                                         1388
*   RFY                                                            1389
*     RETCODE UNRSTD;                                              1389
@RF01384 DS    0H                                                  1390
*   RFY                                                            1390
*     RET RSTD;                                                    1390
*   RET=MWASAVEE;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEE                                        1391
*   RFY                                                            1392
*     RET UNRSTD;                                                  1392
*   RFY                                                            1393
*    (R0,                                                          1393
*     R1,                                                          1393
*     R6,                                                          1393
*     R7,                                                          1393
*     R8,                                                          1393
*     R9) UNRSTD;                                                  1393
*   END GETCORE;                                                   1394
@EL00016 DS    0H                                                  1394
@EF00016 DS    0H                                                  1394
@ER00016 BR    @14                                                 1394
*FREECORE:                                                         1395
*                                                                  1395
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: THIS ROUTINE ISSUES THE FREEMAIN FOR IDA0192F        */
*/*                                                                  */
*/*   INPUTS:   1. SUBPOOL IN MWAGFSP                                */
*/*             2. LENGTH IN MWAGFLEN                                */
*/*             3. ADDRESS IN MWAGFADR                               */
*/*                                                                  */
*/*   OUTPUTS:  1. THE FREEMAIN IS ISSUED                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  1395
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1395
FREECORE DS    0H                                                  1396
*   RFY                                                            1396
*     RET RSTD;                                                    1396
*   MWASAVEE=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEE                                        1397
*   RFY                                                            1398
*     RET UNRSTD;                                                  1398
*   RFY                                                            1399
*    (R0,                                                          1399
*     R1) RSTD;                                                    1399
*   R0=MWAGFR0;                     /* INIT REG 0 FOR FREEMAIN       */
         L     R0,MWAGFR0                                          1400
*   R1=MWAGFADR;                    /* INIT REG 1 FOR FREEMAIN       */
         L     R1,MWAGFADR                                         1401
*   GEN(FREEMAIN R,LV=(0),A=(1));   /* ISSUE FREEMAIN                */
         FREEMAIN R,LV=(0),A=(1)
*   RFY                                                            1403
*    (R0,                                                          1403
*     R1) UNRSTD;                                                  1403
*   RFY                                                            1404
*     RET RSTD;                                                    1404
*   RET=MWASAVEE;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEE                                        1405
*   RFY                                                            1406
*     RET UNRSTD;                                                  1406
*   END FREECORE;                                                  1407
@EL00017 DS    0H                                                  1407
@EF00017 DS    0H                                                  1407
@ER00017 BR    @14                                                 1407
*PROBDT:                                                           1408
*                                                                  1408
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION: PROBLEM DETERMINATION INTERFACE.  INITIALIZES THE    */
*/*             CLUSTER NAME IN THE PROBLEM DETERMINATION PARAMETER  */
*/*             LIST (IDAPDPRM) TO THE DSNAME SPECIFIED ON THE DD    */
*/*             STATEMENT FOR THE SPHERE.  THE ACBERFLG FIELD IN THE */
*/*             USER ACB IS INITIALIZED TO THE CODE CORRESPONDING    */
*/*             TO THE PROBLEM DETERMINATION ERROR CODE (PPCODE).    */
*/*             THE ACBERFLG IS SET BY REFERENCING THE ARRAY         */
*/*             OPWERMAP THAT MAPS PPCODE TO ACBERFLG.  THIS ARRAY   */
*/*             IS  DEFINED BY IDAERMAP.  IDA0192P IS CALLED         */
*/*             TO WRITE THE PROBLEM DETERMINATION MESSAGE.          */
*/*                                                                  */
*/*   INPUTS:   1. PTR TO FORCORE WHICH CONTAINS THE PROBLEM         */
*/*               DETERMINATION PARAMETER LIST IN OPWCOMWA.          */
*/*             2. PTR TO USER ACB IN OPWUACB.                       */
*/*                                                                  */
*/*   OUTPUTS:  1. IF ERROR (ACBERFLG>=128), THEN MWAOFAIL IS SET    */
*/*                ON AND CONTROL IS GIVEN TO TERM192A.              */
*/*             2. IF WARNING (ACBERFLG<128), THEN CONTROL IS GIVEN  */
*/*                TO CALLER.                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  1408
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1408
PROBDT   DS    0H                                                  1409
*   RFY                                                            1409
*     RET RSTD;                                                    1409
*   MWASAVEF=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEF                                        1410
*   RFY                                                            1411
*     RET UNRSTD;                                                  1411
*   RACB=OPWUACB;                   /* PT TO USER ACB                */
         L     RACB,OPWUACB(,RCORE)                                1412
*   ACBERFLG=OPWERMAP(PDPCODE);     /* SET ACBERFLG IN USER ACB      */
         L     @05,OPWCOMWA(,RCORE)                                1413
         SLR   @01,@01                                             1413
         IC    @01,PDPCODE+280(,@05)                               1413
         ALR   @01,RCORE                                           1413
         MVC   ACBERFLG(1,RACB),OPWERMAP-1(@01)                    1413
*   RFY                                                            1414
*     R1 RSTD;                                                     1414
*   R1=OPWCOMWA;                    /* POINT TO FORCORE              */
         LR    R1,@05                                              1415
*   RFY                                                            1416
*     R1 UNRSTD;                                                   1416
*   RSTATRTN=IDAR192P;              /* INDIC 192P CONTROL    @Y30DSDP*/
         MVC   RSTATRTN(4,@05),@CC04587                            1417
*   CALL IDA0192P;                  /* WRITE PROB DET MESSAGE        */
         L     @15,@CV04818                                        1418
         BALR  @14,@15                                             1418
*   RSTATRTN=IDAR192F;              /* INDIC 192F CONTROL    @Y30DSDP*/
         L     @05,OPWCOMWA(,RCORE)                                1419
         MVC   RSTATRTN(4,@05),@CC04581                            1419
*   IF ACBERFLG>=128 THEN           /* IF TERMINATING ERROR          */
         CLI   ACBERFLG(RACB),128                                  1420
         BL    @RF01420                                            1420
*     DO;                           /* THEN TERMINATE OPEN           */
*       MWAOFAIL=ON;                /* IND OPEN FAILURE              */
         OI    MWAOFAIL,B'10000000'                                1422
*       RETURN TO TERM192F;         /* GOTO TERMINATE OPEN           */
         LA    @14,TERM192F                                        1423
@EL00018 DS    0H                                                  1423
@EF00018 DS    0H                                                  1423
@ER00018 BR    @14                                                 1423
*     END;                                                         1424
*   RFY                                                            1425
*     RET RSTD;                                                    1425
@RF01420 DS    0H                                                  1426
*   RET=MWASAVEF;                   /* RESTORE RETURN ADDRESS        */
         L     RET,MWASAVEF                                        1426
*   RFY                                                            1427
*     RET UNRSTD;                                                  1427
*   END PROBDT;                                                    1428
         B     @EL00018                                            1428
@PB00018 DS    0H                                                  1428
*   END IDA0192F                                                   1429
*                                                                  1429
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAIR  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IDABIB  )                                       */
*/*%INCLUDE SYSLIB  (IDACMB  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHADSAB )                                       */
*/*%INCLUDE SYSLIB  (IDAHEB  )                                       */
*/*%INCLUDE SYSLIB  (IDAIDXCB)                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IDAERRCD)                                       */
*/*%INCLUDE SYSLIB  (IDAOPWRK)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IDAPSL  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IDASFI  )                                       */
*/*%INCLUDE SYSLIB  (IDASSL  )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IDAUPT  )                                       */
*/*%INCLUDE SYSLIB  (IDAVAT  )                                       */
*/*%INCLUDE SYSLIB  (IDAVVOLL)                                       */
*/*%INCLUDE SYSLIB  (IDAVMT  )                                       */
*/*%INCLUDE SYSLIB  (IDAFOREC)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                       */
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                       */
*/*%INCLUDE SYSLIB  (IDARTMAC)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  1429
*       ;                                                          1429
@DATA    DS    0H
@CH00092 DC    H'2'
@CH00033 DC    H'12'
@CH02818 DC    H'14'
@CH01428 DC    H'176'
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
@TF00001 DS    F
@TF00002 DS    F
IDA0192F CSECT
         DS    0F
@CF00053 DC    F'1'
@CH00053 EQU   @CF00053+2
@CF00095 DC    F'4'
@CH00095 EQU   @CF00095+2
@CF00145 DC    F'5'
@CF00089 DC    F'6'
@CF00038 DC    F'8'
@CF00050 DC    F'16'
@CF01970 DC    F'28'
@CF02224 DC    F'64'
@CF02011 DC    F'68'
@CF02015 DC    F'76'
@CH02015 EQU   @CF02015+2
@CF01709 DC    F'88'
@CF00034 DC    F'92'
@CF01418 DC    F'148'
@CF01420 DC    F'152'
@CF04927 DC    F'280'
@CF04928 DC    F'496'
@CF04735 DC    F'-8'
@DATD    DSECT
         DS    0D
MWADSABP DS    A
MWATIOT  DS    A
MWAI     DS    F
MWAJFBWA DS    A
MWAU     DS    F
MWAPTRA  DS    A
MWAPTRB  DS    A
MWAXAMBL DS    A
MWARPLPT DS    A
MWAPFECB DS    FL4
         ORG   MWAPFECB
@NM00213 DS    CL3
MWAECBCC DS    FL1
         ORG   MWAECBCC
@NM00214 DS    BL1
MWAECBAD EQU   MWAECBCC+0
         ORG   MWAPFECB+4
MWAJFCB  DS    A
MWAVOLCT DS    F
MWAVVOLL DS    A
MWAVMT   DS    A
MWANEXTC DS    F
MWAVVNBR DS    H
MWABSEKL DS    H
         DS    CL1
MWAVVLNG DS    FL3
MWAGFWRK DS    CL36
         ORG   MWAGFWRK
MWAGFSVE DS    CL16
MWAGFADR DS    AL4
MWAGFR0  DS    FL4
         ORG   MWAGFR0
MWAGFSP  DS    FL1
MWAGFLEN DS    FL3
         ORG   MWAGFWRK+24
MWAGFPRM DS    3F
         ORG   MWAGFWRK+36
MWAFLGS1 DS    BL1
         ORG   MWAFLGS1
MWAOFAIL DS    BL1
MWADAMBL EQU   MWAFLGS1+0
MWAFIX   EQU   MWAFLGS1+0
MWAVATSW EQU   MWAFLGS1+0
MWANEWSW EQU   MWAFLGS1+0
MWACRAMT EQU   MWAFLGS1+0
MWAJFBSW EQU   MWAFLGS1+0
         ORG   MWAFLGS1+1
         DS    CL3
MWASAVER DS    CL24
         ORG   MWASAVER
MWASAVEA DS    AL4
MWASAVEB DS    AL4
MWASAVEC DS    AL4
MWASAVED DS    AL4
MWASAVEE DS    AL4
MWASAVEF DS    AL4
         ORG   MWASAVER+24
MWASWSAV DS    CL8
         ORG   MWASWSAV
MWASWPTR DS    AL4
MWASWAP  DS    FL4
         ORG   MWASWSAV+8
MWAAMBSV DS    CL8
         ORG   MWAAMBSV
MWADTWRK DS    AL4
MWAIXWRK DS    AL4
         ORG   MWAAMBSV+8
MWADEV   DS    BL3
         ORG   MWADEV
MWADVOP  DS    BL1
MWADVTYP DS    BL2
         ORG   MWADEV+3
MWAJFTTR DS    CL4
MWAMACRF DS    BL2
IDA0192F CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV04818 DC    V(IDA0192P)
@CV04841 DC    V(IDA0192V)
@CV04855 DC    V(IDA0192M)
@CV04860 DC    V(IDA0192B)
         DS    0D
@CC02354 DC    C' IDAPSL '
@CC02838 DC    C' IDASSL '
@CC04828 DC    C'        '
@CC04581 DC    C'192F'
@CC04587 DC    C'192P'
@CC04591 DC    C'192V'
@CB04834 DC    X'000000000000'
IDA0192F CSECT
         DS    0D                       START ON DOUBLE WORD BOUNDARY
PATCH2F  DC    ((*-IDA0192F)/20)X'00'   PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192F CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
MWARETCD EQU   @05
MWAPLHPT EQU   @05
MWAK     EQU   @05
MWAJ     EQU   @05
RCORE    EQU   @04
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
R13      EQU   @13
R4       EQU   @04
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
RET      EQU   @14
RETCODE  EQU   @15
R15      EQU   @15
RDEB     EQU   @11
RTIOT    EQU   @09
RUCB     EQU   @10
R10      EQU   @10
R11      EQU   @11
R5       EQU   @05
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBID    EQU   ACBCOMN
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBINRTN EQU   ACBCOMN+8
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBKEY   EQU   ACBMACR1
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBSKP   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBICI   EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBCRNCK EQU   ACBCROPS
ACBCRNRE EQU   ACBCROPS
ACBDVIND EQU   ACBDSORG
ACBDORGA EQU   ACBDSORG+1
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBTIOT  EQU   ACBDDNM
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBLOCK  EQU   ACBEXFG
ACBIOSFG EQU   ACBOFLGS
ACBBUSY  EQU   ACBIOSFG
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBINFL1 EQU   ACBINFLG
ACBVVIC  EQU   ACBINFL1
ACBINFL2 EQU   ACBINFLG+1
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAIX   EQU   0
AIXFG    EQU   IDAAIX
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBUPLH  EQU   IDAAMB+80
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
AMBTRACE EQU   IDAAMB+120
IDAAMBL  EQU   0
AMBLPCHN EQU   IDAAMBL
AMBLSCHN EQU   IDAAMBL+4
AMBLACB  EQU   IDAAMBL+8
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLGSR  EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLXPT  EQU   IDAAMBL+24
AMBLVC   EQU   IDAAMBL+28
AMBLVRT  EQU   AMBLVC
AMBLENO  EQU   AMBLVC+1
AMBLTYPE EQU   IDAAMBL+30
AMBLPATH EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLQ2   EQU   IDAAMBL+31
AMBLID   EQU   IDAAMBL+32
AMBLSHAR EQU   IDAAMBL+33
AMBLPRIM EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLLEN  EQU   IDAAMBL+34
AMBLFLG1 EQU   IDAAMBL+35
AMBLFULL EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLDUMY EQU   AMBLFLG1
AMBLFLG2 EQU   IDAAMBL+36
AMBLNUM  EQU   IDAAMBL+38
AMBLDTA  EQU   IDAAMBL+52
AMBLIX   EQU   IDAAMBL+56
AMBLBIB  EQU   IDAAMBL+60
AMBLCMB  EQU   IDAAMBL+64
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDNEST  EQU   IDAAMDSB+4
AMDAXRKP EQU   AMDNEST
AMDKEYLN EQU   IDAAMDSB+8
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDPARDB EQU   IDAAMDSB+36
AMDATTR3 EQU   IDAAMDSB+40
AMDUNQ   EQU   AMDATTR3
AMDSTAT  EQU   IDAAMDSB+48
IDAARDB  EQU   0
ARDTYPE  EQU   IDAARDB+1
ARDPRF   EQU   IDAARDB+28
IDABIB   EQU   0
BIBHDR   EQU   IDABIB
BIBFLG1  EQU   BIBHDR+1
BIBVIRT  EQU   BIBFLG1
BIBUPT   EQU   IDABIB+8
BIBVMT   EQU   IDABIB+12
BIBDACB  EQU   IDABIB+16
BIBPAMBL EQU   IDABIB+20
BIBRTNS  EQU   IDABIB+60
BIBINTRF EQU   BIBRTNS
IDACMB   EQU   0
CMBID    EQU   IDACMB
CMBLEN   EQU   IDACMB+2
CMBFLGS  EQU   IDACMB+4
CMBOUT   EQU   CMBFLGS
CMBNST   EQU   IDACMB+5
CMBCNT   EQU   IDACMB+6
CMBPTRS  EQU   IDACMB+8
CMBFSTPT EQU   CMBPTRS+16
CMBUFSPT EQU   CMBPTRS+20
CMBDEBPT EQU   CMBPTRS+32
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTJESCT EQU   CVTMAP+296
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABANMI EQU   0
DSABGIDL EQU   0
HEBHDREL EQU   0
HEBFREMN EQU   HEBHDREL
HEBLN    EQU   HEBFREMN+1
HEBBLKPT EQU   HEBFREMN+4
HEBFLAGS EQU   HEBHDREL+8
HEBELCHN EQU   HEBHDREL+12
@NM00048 EQU   HEBHDREL+20
IDAHEB   EQU   0
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBSHR  EQU   JSCBSEC1+8
JSCBDCB  EQU   JSCBSEC1+36
JSCBSTEP EQU   JSCBSEC1+40
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
IDAOPWRK EQU   0
OPWFLGS1 EQU   IDAOPWRK+12
OPWCAT   EQU   OPWFLGS1
OPWSCRA  EQU   OPWFLGS1
OPWVVIC  EQU   OPWFLGS1
OPWFLGS2 EQU   IDAOPWRK+13
OPWUCRA  EQU   OPWFLGS2
OPWAIXDT EQU   OPWFLGS2
OPWDUMMY EQU   OPWFLGS2
OPWFLGS3 EQU   IDAOPWRK+14
OPWDAVAT EQU   OPWFLGS3
OPWUPGOP EQU   OPWFLGS3
OPWNOWRK EQU   OPWFLGS3
OPWRSTRT EQU   OPWFLGS3
OPWFLGS4 EQU   IDAOPWRK+15
OPWFULL  EQU   OPWFLGS4
OPWCINV  EQU   OPWFLGS4
OPWUPD   EQU   OPWFLGS4
OPWBIB   EQU   IDAOPWRK+16
OPWCOMWA EQU   IDAOPWRK+20
OPWIDF   EQU   IDAOPWRK+24
OPWCACB  EQU   OPWIDF
OPWDCI   EQU   OPWIDF+4
OPWQ     EQU   OPWIDF+7
OPWGSR   EQU   OPWQ
OPWLSR   EQU   OPWQ
OPWKSDS  EQU   OPWQ
OPWESDS  EQU   OPWQ
OPWVSMPL EQU   IDAOPWRK+32
OPWVMANC EQU   OPWVSMPL
OPWVMSP  EQU   OPWVSMPL+4
OPWVMLNG EQU   OPWVSMPL+5
OPWVMADR EQU   OPWVSMPL+8
OPWVMTYP EQU   OPWVSMPL+12
OPWVMFLG EQU   OPWVSMPL+13
OPWVSMWA EQU   IDAOPWRK+48
OPWVGSPL EQU   OPWVSMWA+40
OPWVLSAV EQU   OPWVSMWA+80
OPWVFMPL EQU   OPWVSMWA+88
OPWSAVE  EQU   IDAOPWRK+144
OPWPSL   EQU   OPWSAVE+8
OPWSSL   EQU   OPWSAVE+16
OPWCURPT EQU   IDAOPWRK+164
OPWCAMBL EQU   IDAOPWRK+172
OPWBCON  EQU   IDAOPWRK+176
OPWPCON  EQU   IDAOPWRK+180
OPWBAMBL EQU   IDAOPWRK+184
OPWPAMBL EQU   IDAOPWRK+188
OPWCRA   EQU   IDAOPWRK+192
OPWQ2    EQU   IDAOPWRK+198
OPWCBIC  EQU   OPWQ2
OPWCATTR EQU   IDAOPWRK+199
OPWUPT   EQU   IDAOPWRK+200
OPWUACB  EQU   IDAOPWRK+204
OPWDTWRK EQU   IDAOPWRK+212
OPWIXWRK EQU   IDAOPWRK+216
OPWCTCB  EQU   IDAOPWRK+220
OPWJSTCB EQU   IDAOPWRK+224
OPWTIOT  EQU   IDAOPWRK+228
OPWCSTRN EQU   IDAOPWRK+240
OPWSTRNO EQU   IDAOPWRK+241
OPWBSTRN EQU   IDAOPWRK+242
OPWDACB  EQU   IDAOPWRK+244
OPWERMAP EQU   IDAOPWRK+308
OPWBSECL EQU   IDAOPWRK+568
OPWBIXCI EQU   OPWBSECL+5
OPWPTAIX EQU   IDAOPWRK+576
OPWPDTCI EQU   OPWPTAIX+1
OPWNOUPG EQU   IDAOPWRK+584
OPWUPAIX EQU   IDAOPWRK+588
OPWCURCL EQU   0
OPWCFLG1 EQU   OPWCURCL
OPWBASE  EQU   OPWCFLG1
OPWPATH  EQU   OPWCFLG1
OPWUPGR  EQU   OPWCFLG1
OPWSVWRK EQU   OPWCFLG1
OPWPRTBL EQU   OPWCFLG1
OPWCDTCI EQU   OPWCURCL+1
OPWFLG2  EQU   OPWCURCL+4
OPWEMPUP EQU   OPWFLG2
OPWCIXCI EQU   OPWCURCL+5
IDAPLHDR EQU   0
IDAPLH   EQU   0
PLHAVL   EQU   IDAPLH
PLHFLG1  EQU   IDAPLH+2
PLHFLG2  EQU   IDAPLH+3
PLHEFLGS EQU   IDAPLH+4
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHMRPL  EQU   IDAPLH+16
PLHCRPL  EQU   IDAPLH+20
PLHCRBA  EQU   IDAPLH+28
PLHJORBA EQU   PLHCRBA
PLHJCODE EQU   IDAPLH+40
PLHRSCS  EQU   IDAPLH+43
PLHDIOB  EQU   IDAPLH+76
PLHRETO  EQU   IDAPLH+116
PLHRET1  EQU   IDAPLH+120
PLHEOVPT EQU   IDAPLH+180
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHKEYPT EQU   IDAPLH+248
PLHTMRPL EQU   IDAPLH+265
PLHEND   EQU   IDAPLH+280
IDAPSL   EQU   0
PSLSUBPL EQU   IDAPSL
PSLLENTH EQU   IDAPSL+1
PSLID    EQU   IDAPSL+4
PSLNXPTR EQU   IDAPSL+12
PSLENTRY EQU   IDAPSL+16
PSLSTAD  EQU   PSLENTRY
PSLFLG   EQU   PSLENTRY+4
PSLFLGLT EQU   PSLFLG
PSLENDAD EQU   PSLENTRY+5
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00115 EQU   RBSECT+10
@NM00116 EQU   @NM00115
RBTRSVRB EQU   @NM00116
@NM00118 EQU   @NM00115+1
RBETXR   EQU   @NM00118
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00125 EQU   RBSECT+28
@NM00126 EQU   @NM00125
IRBEND   EQU   RBSECT+96
@NM00129 EQU   RBSECT+96
RBRSV138 EQU   @NM00129+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLID    EQU   RPLIDWD
RPLLEN   EQU   RPLIDWD+3
RPLPLHPT EQU   RPLCOMN+4
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLDIR   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLKEY   EQU   RPLOPT2
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
IDASFI   EQU   0
SFIRETCD EQU   IDASFI+4
IDASSL   EQU   0
SSLSUBPL EQU   IDASSL
SSLLENTH EQU   IDASSL+1
SSLID    EQU   IDASSL+4
SSLNXPTR EQU   IDASSL+12
SSLACEN  EQU   IDASSL+16
SSLENTRY EQU   IDASSL+20
SSLSWPTR EQU   SSLENTRY
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBTIO   EQU   TCB+12
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOEDDNM EQU   TIOENTRY+4
TIOEJFCB EQU   TIOENTRY+12
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
TIOEFSRT EQU   TIOENTRY+17
POOLSTAR EQU   TIOENTRY+20
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00148 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
IDAUPT   EQU   0
UPTHDR   EQU   IDAUPT
UPTID    EQU   UPTHDR
UPTFLG0  EQU   UPTHDR+1
UPTLEN   EQU   UPTHDR+2
UPTNOENT EQU   IDAUPT+13
UPTLLEN  EQU   IDAUPT+14
UPTSA    EQU   IDAUPT+16
UPTAXENT EQU   IDAUPT+88
UPTRPL   EQU   UPTAXENT
UPTFLG1  EQU   UPTAXENT+4
UPTF1LST EQU   UPTFLG1
UPTF1NUK EQU   UPTFLG1
UPTF1NOP EQU   UPTFLG1
UPTRKP   EQU   UPTAXENT+6
UPTLNCDE EQU   UPTAXENT+9
UPTBG    EQU   UPTAXENT+10
IDAVAT   EQU   0
VATHDR   EQU   IDAVAT
VATID    EQU   VATHDR
VATLEN   EQU   VATHDR+2
VATNEXT  EQU   IDAVAT+4
VATVSRT  EQU   IDAVAT+8
VATPAMBL EQU   IDAVAT+16
VATVC    EQU   IDAVAT+20
VATVRT   EQU   VATVC
VATENO   EQU   VATVC+1
VATNAE   EQU   IDAVAT+24
VATAMBL  EQU   IDAVAT+28
IDAVVOLL EQU   0
@NM00152 EQU   IDAVVOLL
VVOLLID  EQU   @NM00152
VVOLLOPE EQU   @NM00152
VVOLLNBR EQU   IDAVVOLL+2
VVOLLTAB EQU   IDAVVOLL+4
VVOLLACB EQU   IDAVVOLL+8
VVOLLERR EQU   IDAVVOLL+12
VVOLLPDC EQU   VVOLLERR
VVOLLSFC EQU   VVOLLERR+2
VVOLLCNT EQU   VVOLLERR+3
VVOLLSFI EQU   IDAVVOLL+16
VVOLLENT EQU   IDAVVOLL+36
VVOLLUCB EQU   VVOLLENT
@NM00155 EQU   VVOLLENT+4
VVOLLMNT EQU   @NM00155
VVOLLVSR EQU   VVOLLENT+6
IDAVMT   EQU   0
VMTHDR   EQU   IDAVMT
VMTID    EQU   VMTHDR
VMTLEN   EQU   VMTHDR+2
VMTNXT   EQU   IDAVMT+4
VMTNOVOL EQU   IDAVMT+8
VMTDEV   EQU   IDAVMT+13
VMTVOL   EQU   IDAVMT+16
VMTVFLG1 EQU   VMTVOL+4
VMTOPEN  EQU   VMTVFLG1
VMTVLSER EQU   VMTVOL+6
VMTUCB   EQU   VMTVOL+12
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXJBF    EQU   FORCORE+100
DXIOB    EQU   FORCORE+280
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXDSABAD EQU   FORCORE+544
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXB1 EQU   DXATEXC1
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECWTGTB EQU   IECEXTPR+72
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
JFCBXTTR EQU   JFCBX
JFCBXVOL EQU   JFCBX+4
IDAPDPRM EQU   0
PDPCODE  EQU   IDAPDPRM+1
PDPFUNC  EQU   IDAPDPRM+2
PDPSFC   EQU   IDAPDPRM+3
PDPVLSER EQU   IDAPDPRM+16
PDPDSTYP EQU   IDAPDPRM+33
PDPMSGFL EQU   IDAPDPRM+34
PDPSFI   EQU   IDAPDPRM+36
IDAVGTT  EQU   0
VGTTTYPE EQU   IDAVGTT+4
IDAVATCB EQU   0
VATCBSTP EQU   IDAVATCB
JFCBWRKA EQU   0
JFCB     EQU   JFCBWRKA
QMIOP    EQU   JFCBWRKA+176
QMITCBAD EQU   QMIOP
QMIRECAD EQU   QMIOP+4
QMIWRKAD EQU   QMIOP+8
QMIDSKAD EQU   QMIOP+12
QMIRECL  EQU   QMIOP+16
QMIFLAGS EQU   QMIOP+18
QMIOREAD EQU   QMIFLAGS
JESWORK  EQU   JFCBWRKA+196
JESCT    EQU   0
JESRESQM EQU   JESCT+16
VOLSER   EQU   0
PLHKEY   EQU   0
PLHPDL   EQU   0
PLHPDLE  EQU   0
PLHRRN   EQU   0
SWAPWORD EQU   0
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+5
PSARSVTE EQU   PSARSVT
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00147 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00188 EQU   DXXCTL
DXSAVMOD EQU   @NM00188+2
@NM00189 EQU   DXRESSW
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBNVOL EQU   JFCUCSEG+9
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBEXAD EQU   JFCBS001+31
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
PDWLIST  EQU   FORCORE
PDWWORK  EQU   DXDCB
IDARRPL  EQU   DXATCOM1
IDARRFLG EQU   IDARRPL+1
IDARSTAT EQU   DXATEXC1
RSTAT    EQU   IDARSTAT
RSTATCRO EQU   RSTAT+1
RSTATOP2 EQU   RSTAT+2
IDARRTN  EQU   DXATEXC2
RSTATRTN EQU   IDARRTN
PSW      EQU   RBOPSW
@NM00208 EQU   PSW+1
PROTKEY  EQU   @NM00208
PPSTATE  EQU   @NM00208
CMBPTMAP EQU   CMBPTRS
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
FLC      EQU   PSA
IDAESPL  EQU   DXATCOM1
IDARTSA  EQU   DXJBF
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00210 EQU   PSW+2
@NM00209 EQU   @NM00208
@NM00207 EQU   PSW
@NM00206 EQU   RSTAT+3
@NM00205 EQU   RSTATOP2
RSTATCSA EQU   RSTATOP2
IDARCURS EQU   RSTATCRO
IDARCRCU EQU   RSTATCRO
IDARRSTR EQU   RSTATCRO
IDARCKPT EQU   RSTATCRO
RSTATOPT EQU   RSTAT
@NM00204 EQU   IDARRPL+2
@NM00203 EQU   IDARRFLG
RRPLVSAM EQU   IDARRFLG
@NM00202 EQU   IDARRFLG
@NM00201 EQU   IDARRPL
PDWORKSP EQU   PDWWORK+88
PDWERRCD EQU   PDWWORK+84
PDWMSGPT EQU   PDWWORK+80
PDWSAVED EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00193 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00192 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00191 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
DXRESIND EQU   @NM00189
DXSAVOFF EQU   @NM00188+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00188
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00173 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00172 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00171 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00147
UCBSKPFG EQU   @NM00147
UCBRIPND EQU   @NM00147
UCBRTIAC EQU   @NM00147
UCBRSV79 EQU   @NM00147
UCBRSV78 EQU   @NM00147
UCBRSV77 EQU   @NM00147
UCBOLTEP EQU   @NM00147
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00146 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00130 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBCDSAVE EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
PLHBMSV5 EQU   PLHEXTEN+24
PLHBMSV4 EQU   PLHEXTEN+20
PLHBMSV3 EQU   PLHEXTEN+16
PLHBMSV2 EQU   PLHEXTEN+12
PLHBMSV1 EQU   PLHEXTEN+8
PLHRDCNT EQU   PLHEXTEN+6
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00078 EQU   PLHEXTEN+4
PLHRESR1 EQU   PLHEXTEN
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00055 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00054 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00212 EQU   JESCT
@NM00211 EQU   QMIOP+19
QMIOWRIT EQU   QMIFLAGS
VATCBPTR EQU   IDAVATCB+1
VGTTCORE EQU   IDAVGTT+32
@NM00200 EQU   IDAVGTT+28
VGTTPSB  EQU   IDAVGTT+24
VGTTVUSE EQU   IDAVGTT+20
VGTTBIB  EQU   IDAVGTT+16
VGTTNEXT EQU   IDAVGTT+12
VGTTSIZE EQU   IDAVGTT+8
VGTTSP   EQU   IDAVGTT+7
VGTTGSRK EQU   IDAVGTT+6
@NM00199 EQU   IDAVGTT+5
@NM00198 EQU   VGTTTYPE
VGTTCBIC EQU   VGTTTYPE
VGTTOPEN EQU   VGTTTYPE
VGTTCTLG EQU   VGTTTYPE
VGTTLSR  EQU   VGTTTYPE
VGTTGSR  EQU   VGTTTYPE
VGTTSDS  EQU   VGTTTYPE
VGTTID   EQU   IDAVGTT
@NM00197 EQU   IDAPDPRM+35
PDPNOMSG EQU   PDPMSGFL
PDPNOTRC EQU   PDPMSGFL
PDPSPACE EQU   PDPMSGFL
PDPNOTFC EQU   PDPMSGFL
PDPKEY   EQU   IDAPDPRM+32
PDPCTACB EQU   IDAPDPRM+28
PDPDSN   EQU   IDAPDPRM+24
PDPCLSNM EQU   IDAPDPRM+20
PDPTIOT  EQU   IDAPDPRM+12
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00196 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00195 EQU   JFCBX+94
@NM00194 EQU   JFCBX+3
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00190 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00187 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00186 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00185 EQU   WTGAREA+20
@NM00184 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00183 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00182 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00181 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00180 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00179 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00178 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00177 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00176 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00175 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00174 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
DXATEXB2 EQU   DXATEXC2
DXEXHASP EQU   DXATEXB1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00170 EQU   DXATCOM2+3
@NM00169 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00168 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00167 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
DXPACBAD EQU   DXPDCBAD+1
@NM00166 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00165 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00164 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDEBXAD EQU   FORCORE+552
DXDSAB   EQU   FORCORE+548
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXUKEY   EQU   FORCORE+526
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00163 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
@NM00162 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00161 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00160 EQU   DXDAADDR
DXECB    EQU   FORCORE+276
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
@NM00159 EQU   VMTVOL+5
@NM00158 EQU   VMTVFLG1
VMTUSECT EQU   VMTVOL
VMTDVTYP EQU   VMTDEV+1
VMTDVOPT EQU   VMTDEV
@NM00157 EQU   IDAVMT+10
@NM00156 EQU   VMTHDR+1
VVOLLVFY EQU   @NM00155
VVOLLDEB EQU   IDAVVOLL+32
VVOLLBIB EQU   IDAVVOLL+28
VVOLLFNC EQU   VVOLLERR+1
@NM00154 EQU   IDAVVOLL+1
VVOLLSWD EQU   @NM00152
VVOLLCAT EQU   @NM00152
VVOLLEOV EQU   @NM00152
VVOLLTIO EQU   @NM00152
@NM00153 EQU   @NM00152
@NM00151 EQU   IDAVAT+22
VATVPTR  EQU   VATVSRT+4
VATVUSE  EQU   VATVSRT
@NM00150 EQU   VATHDR+1
UPTPASS  EQU   UPTAXENT+8
UPTF1PUD EQU   UPTFLG1+1
UPTF1PNU EQU   UPTFLG1+1
UPTF1ERA EQU   UPTFLG1+1
UPTF1PHY EQU   UPTFLG1+1
UPTF1LOG EQU   UPTFLG1+1
UPTF1BKO EQU   UPTFLG1+1
UPTF1UPG EQU   UPTFLG1
UPTF1RTY EQU   UPTFLG1
UPTF1KEY EQU   UPTFLG1
UPTF1NRF EQU   UPTFLG1
UPTF1ATV EQU   UPTFLG1
UPTF1LOP EQU   UPTRPL
UPTR15   EQU   UPTSA+16
UPTR14   EQU   UPTSA+12
UPTSARES EQU   UPTSA+11
@NM00149 EQU   UPTSA+10
UPTBERCD EQU   UPTSA+9
UPTBEREG EQU   UPTSA+8
UPTLSA   EQU   UPTSA+4
UPTBRPL  EQU   UPTSA
UPTRSC   EQU   IDAUPT+12
UPTOLD   EQU   IDAUPT+8
UPTNEW   EQU   IDAUPT+4
UPTPWS   EQU   UPTFLG0
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00148
UCBHALI  EQU   @NM00148
UCBRSV09 EQU   @NM00148
UCBRSV08 EQU   @NM00148
UCBRSV07 EQU   @NM00148
UCBRSV06 EQU   @NM00148
UCBRSV05 EQU   @NM00148
UCBRSV04 EQU   @NM00148
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00145 EQU   UCB
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00144 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00143 EQU   POOLSTAR
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
@NM00142 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00141 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBSTAFX EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00140 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00139 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
SSLSWAP  EQU   SSLENTRY+4
@NM00138 EQU   IDASSL+18
SFIMODID EQU   IDASFI+10
SFIRSNCD EQU   IDASFI+9
@NM00137 EQU   IDASFI+8
@NM00136 EQU   IDASFI+1
SFIDESC  EQU   IDASFI
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00135 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00134 EQU   RPLRBAR+3
@NM00133 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00132 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
@NM00131 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00129+8
PRBEND   EQU   @NM00129+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00129+6
RBRSV136 EQU   @NM00129+4
RBRSV135 EQU   @NM00129
@NM00128 EQU   RBSECT+32
@NM00127 EQU   @NM00125+1
RBSCF    EQU   @NM00126
RBPGMQ1  EQU   RBPGMQ+1
@NM00124 EQU   RBPGMQ
@NM00123 EQU   RBSECT+16
@NM00122 EQU   @NM00118
@NM00121 EQU   @NM00118
RBIQETP  EQU   @NM00118
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00118
@NM00120 EQU   @NM00118
@NM00119 EQU   @NM00118
RBPMSVRB EQU   @NM00116
RBATNXIT EQU   @NM00116
@NM00117 EQU   @NM00116
RBWAITP  EQU   @NM00116
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00116
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00114 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00113 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00112 EQU   RBOPSWB2
@NM00111 EQU   XRBPSW
@NM00110 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00109 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00108 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00107 EQU   XSTAB1
@NM00106 EQU   RBBASIC+8
@NM00105 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00104 EQU   RBPRFX
@NM00103 EQU   PSLFLG
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00077 EQU   IDAPLH+266
@NM00076 EQU   PLHTMRPL
PLHTMIOB EQU   PLHTMRPL
PLHTMINX EQU   PLHTMRPL
PLHTMDTA EQU   PLHTMRPL
PLHTMDIW EQU   PLHTMRPL
PLHTMBUF EQU   PLHTMRPL
PLHTERM  EQU   PLHTMRPL
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHNOSEG EQU   IDAPLH+240
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00075 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHIBUFC EQU   IDAPLH+188
PLHNRBA  EQU   IDAPLH+184
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00074 EQU   IDAPLH+172
@NM00073 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHRETOS EQU   IDAPLH+118
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHSAVE1 EQU   IDAPLH+84
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHRDFC  EQU   IDAPLH+72
PLHRDFP  EQU   IDAPLH+68
PLHFSP   EQU   IDAPLH+64
PLHRECP  EQU   IDAPLH+60
PLHNBUFC EQU   IDAPLH+56
PLHDBUFC EQU   IDAPLH+52
PLHLRECL EQU   IDAPLH+48
PLHARDB  EQU   IDAPLH+44
@NM00072 EQU   PLHRSCS
PLHDBPER EQU   PLHRSCS
PLHDSERR EQU   PLHRSCS
PLHASYER EQU   PLHRSCS
@NM00071 EQU   PLHRSCS
PLHBUFHD EQU   PLHRSCS
PLHINEOV EQU   PLHRSCS
PLHEOVR  EQU   IDAPLH+42
PLHRCODE EQU   IDAPLH+41
PLHUCODE EQU   PLHJCODE
PLHJNRBA EQU   IDAPLH+36
PLHJRNLL EQU   IDAPLH+32
PLHUPECB EQU   PLHJORBA
PLHDSIDA EQU   IDAPLH+24
PLHBFRNO EQU   IDAPLH+15
PLHFRCNT EQU   IDAPLH+14
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRAE   EQU   PLHAFLGS
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHDBDC  EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
PLHIOSRQ EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHEOVDF EQU   PLHFLG3
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00070 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHINVAL EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLHSKPER EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHNOSPC EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHKRE   EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHKEYMD EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
PLHSR    EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHRDEXC EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHENDRQ EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRCUR EQU   IDAPLHDR+10
PLHDRMAX EQU   IDAPLHDR+8
PLHDRREQ EQU   IDAPLHDR+4
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
OPWIOPEN EQU   OPWFLG2
OPWERR2B EQU   OPWFLG2
OPWMODWK EQU   OPWFLG2
OPWDOPEN EQU   OPWFLG2
OPWUIXCI EQU   OPWUPAIX+5
@NM00069 EQU   OPWUPAIX+4
OPWUDTCI EQU   OPWUPAIX+1
@NM00068 EQU   OPWUPAIX
OPW2YPLH EQU   IDAOPWRK+585
OPWPIXCI EQU   OPWPTAIX+5
@NM00067 EQU   OPWPTAIX+4
@NM00066 EQU   OPWPTAIX
@NM00065 EQU   OPWBSECL+4
OPWBDTCI EQU   OPWBSECL+1
@NM00064 EQU   OPWBSECL
OPWSAVEA EQU   IDAOPWRK+564
OPWSFI   EQU   IDAOPWRK+296
@NM00063 EQU   IDAOPWRK+243
OPWBUFNI EQU   IDAOPWRK+236
OPWBUFND EQU   IDAOPWRK+232
OPWWRKPT EQU   IDAOPWRK+208
OPWPSDS  EQU   OPWCATTR
OPWSWSP  EQU   OPWCATTR
@NM00062 EQU   OPWCATTR
@NM00061 EQU   OPWQ2
OPWXAMBL EQU   IDAOPWRK+168
OPWDSL   EQU   OPWSAVE+12
OPWESL   EQU   OPWSAVE+4
OPWCSL   EQU   OPWSAVE
OPWVFMPT EQU   OPWVFMPL+4
OPWVFMLN EQU   OPWVFMPL+1
OPWVFMSP EQU   OPWVFMPL
OPWVRG13 EQU   OPWVLSAV+4
OPWVRG12 EQU   OPWVLSAV
OPWVANCS EQU   OPWVSMWA+76
OPWVREQL EQU   OPWVGSPL+9
OPWVGFLG EQU   OPWVGSPL+8
OPWVGSPT EQU   OPWVGSPL+4
OPWVGETL EQU   OPWVGSPL+1
OPWVGSSP EQU   OPWVGSPL
OPWVSAVE EQU   OPWVSMWA+24
OPWVR13  EQU   OPWVSMWA+20
OPWVHDRE EQU   OPWVSMWA+16
OPWVCSLE EQU   OPWVSMWA+12
OPWVCSLP EQU   OPWVSMWA+8
OPWVTBLP EQU   OPWVSMWA+4
OPWVANCP EQU   OPWVSMWA
@NM00060 EQU   OPWVSMPL+14
OPWVMTCB EQU   OPWVMFLG
OPWVMNSL EQU   OPWVMFLG
OPWVMSRB EQU   OPWVMFLG
OPWVMDXK EQU   OPWVMFLG
OPWVMKE5 EQU   OPWVMFLG
OPWVMPGB EQU   OPWVMFLG
OPWDFR   EQU   OPWQ
OPWUBF   EQU   OPWQ
OPWFSTP  EQU   OPWQ
OPWDDC   EQU   OPWQ
@NM00059 EQU   OPWFLGS4
@NM00058 EQU   OPWFLGS3
OPWPUPGR EQU   OPWFLGS3
@NM00057 EQU   OPWFLGS2
OPWIXDT  EQU   OPWFLGS2
@NM00056 EQU   OPWFLGS1
OPWSDS   EQU   OPWVVIC
OPWID    EQU   IDAOPWRK+4
OPWLENTH EQU   IDAOPWRK+1
OPWSUBPL EQU   IDAOPWRK
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00053 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00052 EQU   IEZJSCB
HEBHDELS EQU   IDAHEB+12
HEBCNT   EQU   IDAHEB+10
@NM00051 EQU   IDAHEB+8
HEBNHEB  EQU   IDAHEB+4
HEBLEN   EQU   IDAHEB+2
@NM00050 EQU   IDAHEB+1
HEBID    EQU   IDAHEB
@NM00049 EQU   @NM00048+1
HEBGSRK  EQU   @NM00048
HEBNBYTE EQU   HEBHDREL+16
HEBAVSP  EQU   HEBHDREL+9
HEBRTFLG EQU   HEBFLAGS
HEBIOSUP EQU   HEBFLAGS
HEBGSRKT EQU   HEBFLAGS
HEBKEY5  EQU   HEBFLAGS
HEBJSTCB EQU   HEBFLAGS
HEBSP    EQU   HEBFREMN
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABSIOT EQU   DSAB+64
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00047 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00046 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00045 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00044 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00043 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABID   EQU   DSAB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00042 EQU   CVTFIX+248
@NM00041 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00040 EQU   CMBPTRS+52
CMBFXDPT EQU   CMBPTRS+48
CMBPUSPT EQU   CMBPTRS+44
CMBPSTPT EQU   CMBPTRS+40
CMBEDBPT EQU   CMBPTRS+36
CMBUBFPT EQU   CMBPTRS+28
CMBBFRPT EQU   CMBPTRS+24
CMBUSPTR EQU   CMBPTRS+12
CMBSTPTR EQU   CMBPTRS+8
CMBPRPTR EQU   CMBPTRS+4
CMBUSRPT EQU   CMBPTRS
@NM00039 EQU   IDACMB+1
BIBVSRTP EQU   IDABIB+104
BIBASCB  EQU   IDABIB+100
BIBDDNM  EQU   IDABIB+92
BIBSTPNM EQU   IDABIB+84
BIBJOBNM EQU   IDABIB+76
BIBSIOAP EQU   BIBRTNS+12
BIBASYRT EQU   BIBRTNS+8
BIBCEAPP EQU   BIBRTNS+4
BIBVGTT  EQU   IDABIB+56
BIBPSAB  EQU   IDABIB+52
BIBCSL   EQU   IDABIB+48
BIBWSHD  EQU   IDABIB+44
BIBVCRT  EQU   IDABIB+40
BIBHEBFQ EQU   IDABIB+36
BIBHEBPT EQU   IDABIB+32
BIBPRSPH EQU   IDABIB+28
BIBSPHPT EQU   IDABIB+24
@NM00038 EQU   IDABIB+5
BIBFLG2  EQU   IDABIB+4
BIBLEN   EQU   BIBHDR+2
@NM00037 EQU   BIBFLG1
BIBCKPT  EQU   BIBFLG1
BIBREST  EQU   BIBFLG1
BIBID    EQU   BIBHDR
ARDKEYS  EQU   IDAARDB+29
@NM00036 EQU   ARDPRF
ARDPRFMT EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDRELNO EQU   IDAARDB+26
ARDVOLSR EQU   IDAARDB+20
ARDERBA  EQU   IDAARDB+16
ARDHRBA  EQU   IDAARDB+12
ARDHKRBA EQU   IDAARDB+8
ARDNPTR  EQU   IDAARDB+4
ARDLEN   EQU   IDAARDB+2
ARDUSED  EQU   ARDTYPE
ARDEOD   EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDKR    EQU   ARDTYPE
ARDID    EQU   IDAARDB
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00035 EQU   IDAAMDSB+41
@NM00034 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDCINV  EQU   IDAAMDSB+20
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDRKP   EQU   IDAAMDSB+6
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00033 EQU   IDAAMBL+40
AMBLNST  EQU   IDAAMBL+37
@NM00032 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00031 EQU   AMBLFLG2
AMBLSDS  EQU   AMBLVVIC
@NM00030 EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
@NM00029 EQU   AMBLQ2
AMBLCBIC EQU   AMBLQ2
@NM00028 EQU   AMBLTYPE
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00027 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00026 EQU   AMBCSWD1+1
@NM00025 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00024 EQU   AMBAFLG
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00023 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00022 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00021 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBSDS   EQU   AMBINFL
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00020 EQU   AMBINFL
@NM00019 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00018 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00017 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00016 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00015 EQU   AMBFLG0
AMBSWSP  EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
AIXKY    EQU   IDAAIX+5
AIXKL    EQU   IDAAIX+4
AIXPC    EQU   IDAAIX+2
AIXPL    EQU   IDAAIX+1
AIXPKP   EQU   AIXFG
@NM00014 EQU   AIXFG
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00013 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00012 EQU   ACBINFL2
ACBCBIC  EQU   ACBINFL2
@NM00011 EQU   ACBINFL2
ACBBYPSS EQU   ACBINFL1
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFL1
ACBSCRA  EQU   ACBINFL1
ACBCAT   EQU   ACBINFL1
ACBIJRQE EQU   ACBINFL1
ACBJEPS  EQU   ACBINFL1
@NM00010 EQU   ACBINFL1
@NM00009 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00008 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00007 EQU   ACBDSORG+1
@NM00006 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBASA   EQU   ACBCCTYP
@NM00005 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00004 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00003 EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00002 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
@NM00001 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
@NM00102 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00101 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00100 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00099 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00098 EQU   FLCFSA
@NM00097 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00096 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00095 EQU   FLCIOA
@NM00094 EQU   FLCMCLA+15
@NM00093 EQU   FLCMCLA+14
@NM00092 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00091 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00090 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00089 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00088 EQU   FLCPER
@NM00087 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00086 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00085 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00084 EQU   FLCPIILC
@NM00083 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00082 EQU   FLCSVILC
@NM00081 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00080 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00079 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00371 EQU   @RC00365
@RF00692 EQU   @RC00670
@RF00696 EQU   @RC00670
@RF00770 EQU   @RC00661
@RC00768 EQU   @RC00661
@RF01194 EQU   @RC01190
@RF01211 EQU   @RC01207
@RC01252 EQU   @RC01249
@RC01264 EQU   @RC01260
@RF01300 EQU   @RC01291
@RC01298 EQU   @RC01291
@PB00017 EQU   @PB00018
@RC01267 EQU   @RC01264
@PB00016 EQU   @PB00017
@PB00015 EQU   @PB00016
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0192F,(C'PLS1020',0701,78199)
