         TITLE 'IDA0192S - MVM WRITE VSAM SMF RECORD                   *
                        '
IDA0192S CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192S  78.144'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@03                                         0001
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL ZERO
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  ZERO THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR ZERO
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        ZERO IF THE GETMAIN WAS UNSUCCESSFUL.
*   IF RETCODE=0 THEN               /* IF GETMAIN FAILED             */
         LTR   RETCODE,RETCODE                                     0167
         BNZ   @RF00167                                            0167
*     DO;                                                          0168
*       RETCODE=GMFAIL;             /* INDICATE ERROR                */
         L     RETCODE,GMFAIL                                      0169
*     END;                                                         0170
*   ELSE                            /* IF GETMAIN SUCCESSFUL         */
*     DO;                                                          0171
         B     @RC00167                                            0171
@RF00167 DS    0H                                                  0172
*       GEN(ST R13,4(R15));         /* SAVE SAVE REG                 */
         ST R13,4(R15)
*       GEN( L R0,20(,R13));        /* IDAGMAIN USES R0, RESTORE IT.
*                                                            @Z30SSMD*/
          L R0,20(,R13)
*       GEN( L R1,24(,R13));        /* IDAGMAIN USES R1, RESTORE IT.
*                                                            @Z30SSMD*/
          L R1,24(,R13)
*       R13=RETCODE;                /* INIT DATA REG                 */
         LR    R13,RETCODE                                         0175
*       RESPECIFY                                                  0176
*         R13 RESTRICTED;                                          0176
*       GEN(USING @DATD,R13);       /* GET ADDRESSING                */
         USING @DATD,R13
*       RESPECIFY                                                  0178
*         R1 RESTRICTED;                                           0178
*       PPFUNC=PDF30;               /* SET FUNCTION CODE     @Y30DSMD*/
         MVI   PPFUNC,X'1E'                                        0179
*       RCDPARMA=R1;                /* INIT PTR TO PARMS             */
         ST    R1,RCDPARMA                                         0180
*       RESPECIFY                                                  0181
*         R1 UNRESTRICTED;                                         0181
*       IF RCDNBR=OPENRCD THEN      /* IF REQUEST FOR OPEN RCD       */
         L     @11,RCDPARMA                                        0182
         CLI   RCDNBR(@11),62                                      0182
         BNE   @RF00182                                            0182
*         CALL START62;             /* THEN START RCD 62             */
         BAL   @14,START62                                         0183
*       ELSE                        /* NOT REQ FOR OPEN RCD  @Z30SSRL*/
*         IF RCDNBR=CLOSERCD THEN   /* IF REQUEST FOR CLOSE RCD      */
         B     @RC00182                                            0184
@RF00182 L     @11,RCDPARMA                                        0184
         CLI   RCDNBR(@11),64                                      0184
         BNE   @RF00184                                            0184
*           CALL START64;           /* THEN START RCD 64             */
         BAL   @14,START64                                         0185
*       CALL CREACOM;               /* COMPLETE COMMON PART OF RCD   */
@RF00184 DS    0H                                                  0186
@RC00182 BAL   @14,CREACOM                                         0186
*       IF RCDNBR=OPENRCD THEN      /* IF REQUEST FOR OPEN RCD       */
         L     @11,RCDPARMA                                        0187
         CLI   RCDNBR(@11),62                                      0187
         BNE   @RF00187                                            0187
*         CALL FIN62;               /* THEN FINISH RCD 62            */
         BAL   @14,FIN62                                           0188
*       ELSE                        /* NOT REQ FOR OPEN RCD  @Z30SSRL*/
*         IF RCDNBR=CLOSERCD THEN   /* IF REQUEST FOR CLOSE RCD      */
         B     @RC00187                                            0189
@RF00187 L     @11,RCDPARMA                                        0189
         CLI   RCDNBR(@11),64                                      0189
         BNE   @RF00189                                            0189
*           CALL FIN64;             /* THEN FINISH RCD 64            */
         BAL   @14,FIN64                                           0190
*       CALL WRITERCD;              /* WRITE THE RECORD              */
@RF00189 DS    0H                                                  0191
@RC00187 BAL   @14,WRITERCD                                        0191
*EXIT:                              /* EXIT PROCESSING       @Z30SSRL*/
*       IF PPCODE=0 THEN            /* IF NO PROBLEM         @Z30SSRL*/
EXIT     CLI   PPCODE,0                                            0192
         BNE   @RF00192                                            0192
*         PPFUNC=0;                 /* RESET FUNCTION CODE   @Z30SSRL*/
         MVI   PPFUNC,X'00'                                        0193
*       R6=PD;                      /* LOAD RETURN CODE              */
@RF00192 L     R6,PD                                               0194
*       MAINPOOL=WKPOOL;            /* SET SUBPOOL FOR FREEMAIN      */
         MVI   MAINPOOL,X'FC'                                      0195
*       GEN(L R7,@SIZDATD);         /* LOAD BLOCK SIZE               */
         L R7,@SIZDATD
*       MAINLEN=R7;                 /* SET LENGTH FOR FREEMAIN       */
         STCM  R7,7,MAINLEN                                        0197
*       RESPECIFY                                                  0198
*        (R0,                                                      0198
*         R1) RESTRICTED;                                          0198
*       R1=R13;                     /* POINT TO BLOCK ADDR           */
         LR    R1,R13                                              0199
*       R0=MAINR0;                  /* LOAD SUBPOOL/LENGTH           */
         L     R0,MAINR0                                           0200
*       GEN(L R13,4(R13));          /* POINT TO LAST SAVEAREA        */
         L R13,4(R13)
*       IF ACVTDBUG=OFF THEN        /* IF OK TO ISSUE FREEMAINS      */
         L     @11,CVTPTR                                          0202
         TM    ACVTDBUG(@11),B'00000010'                           0202
         BNZ   @RF00202                                            0202
*         GEN(FREEMAIN R,LV=(0),A=(1));/* FREE AUTOMATICS            */
         FREEMAIN R,LV=(0),A=(1)
*       RESPECIFY                                                  0204
*        (R0,                                                      0204
*         R1) UNRESTRICTED;                                        0204
@RF00202 DS    0H                                                  0205
*       RETCODE=R6;                 /* LOAD RETURN CODE              */
         LR    RETCODE,R6                                          0205
*     END;                                                         0206
*   GEN(L RET,12(R13));             /* LOAD RETURN ADDRESS           */
@RC00167 DS    0H                                                  0207
         L RET,12(R13)
*   GEN(LM R0,R12,20(R13));         /* RESTORE REGISTERS 0-12        */
         LM R0,R12,20(R13)
*   GEN(BR RET);                    /* RETURN TO CALLER              */
         BR RET
*START62:                                                          0210
*                                                                  0210
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - CALCULATES AMOUNT OF STORAGE NEEDED FOR SMF      */
*/*                 RECORD 62.                                       */
*/*   01 INPUT  -   1. ADDRESS OF ACB IN RCD62ACB                    */
*/*   01 OUTPUT -   1. LENGTH OF SMF RECORD 62 IN RCDLEN             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0210
*   PROC;                                                          0210
START62  STM   @14,@12,12(@13)                                     0210
*   RACB=RCD62ACB;                  /* LOAD POINTER TO ACB           */
         L     @11,RCDPARMA                                        0211
         L     RACB,RCD62ACB-1(,@11)                               0211
         LA    RACB,0(,RACB)                                       0211
*   IF RCD62OOK=ON THEN             /* IF OPEN WAS SUCCESSFUL        */
         TM    RCD62OOK(@11),B'10000000'                           0212
         BNO   @RF00212                                            0212
*     DO;                                                          0213
*       R7=0;                       /* ZERO BLOCK LENGTH             */
         SLR   R7,R7                                               0214
*       VMTPT=BIBVMT;               /* INIT VMT PTR          @Y30DSMD*/
         L     @11,ACBAMBL(,RACB)                                  0215
         L     @11,AMBLBIB(,@11)                                   0215
         L     @11,BIBVMT(,@11)                                    0215
         ST    @11,VMTPT                                           0215
*       DO WHILE VMTPT^=0;          /* PROCESS ALL VMT'S     @Y30DSMD*/
         B     @DE00216                                            0216
@DL00216 DS    0H                                                  0217
*         R7=R7+VMTNOVOL;           /* ADD VOLS THIS VMT     @Y30DSMD*/
         L     @11,VMTPT                                           0217
         AH    R7,VMTNOVOL(,@11)                                   0217
*         VMTPT=VMTNXT;             /* ADDRESS NXT VMT       @Y30DSMD*/
         L     @11,VMTNXT(,@11)                                    0218
         ST    @11,VMTPT                                           0218
*       END;                        /* END OF VMT PROCESSING LOGIC.
*                                                            @Y30DSMD*/
@DE00216 L     @11,VMTPT                                           0219
         LTR   @11,@11                                             0219
         BNZ   @DL00216                                            0219
*       RCDLEN=LENGTH(SMFRCD62)+R7*LENGTH(SMF62VLT);/* CORE NEEDED 0220
*                                      FOR RCD                       */
         LR    @11,R7                                              0220
         MH    @11,@CH02447                                        0220
         AL    @11,@CF03646                                        0220
         ST    @11,RCDLEN                                          0220
*     END;                                                         0221
*   ELSE                            /* OPEN NOT SUCCESSFUL   @Z30SSRL*/
*     RCDLEN=LENGTH(SMFRCD62);      /* RCD HAS NO VOLUME LIST        */
         B     @RC00212                                            0222
@RF00212 MVC   RCDLEN(4),@CF03646                                  0222
*   END START62;                                                   0223
@EL00002 DS    0H                                                  0223
@EF00002 DS    0H                                                  0223
@ER00002 LM    @14,@12,12(@13)                                     0223
         BR    @14                                                 0223
*   RESPECIFY                                                      0224
*     RTIOT UNRESTRICTED;                                          0224
*START64:                                                          0225
*                                                                  0225
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - CALCULATES AMOUNT OF STORAGE NEEDED FOR SMF      */
*/*                 RECORD 64.                                       */
*/*   01 INPUT  -   1. ADDRESS OF AMB IN RCD64AMB                    */
*/*                 2. ADDRESS OF DEB IN AMBDEBPT                    */
*/*   01 OUTPUT -   1. LENGTH OF SMF RECORD 64 IN RCDLEN             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0225
*   PROC;                                                          0225
START64  STM   @14,@12,12(@13)                                     0225
*   R5=RCD64AMB;                    /* LOAD POINTER TO AMB   @Y30DSMD*/
         L     @11,RCDPARMA                                        0226
         L     R5,RCD64AMB-1(,@11)                                 0226
         LA    R5,0(,R5)                                           0226
*   RESPECIFY                                                      0227
*     RDEB RESTRICTED;                                             0227
*   RDEB=AMBDEBPT;                  /* LOAD POINTER TO DEB           */
         L     RDEB,AMBDEBPT(,R5)                                  0228
*   RCDLEN=LENGTH(SMFRCD64)+LENGTH(SMF64STS)+LENGTH(SMF64EXT)*DEBNMEXT;
         SLR   @15,@15                                             0229
         IC    @15,DEBNMEXT(,RDEB)                                 0229
         MH    @15,@CH03648                                        0229
         AL    @15,@CF03647                                        0229
         ST    @15,RCDLEN                                          0229
*                                   /* GET LENGTH OF RECORD 64       */
*   END START64;                                                   0230
@EL00003 DS    0H                                                  0230
@EF00003 DS    0H                                                  0230
@ER00003 LM    @14,@12,12(@13)                                     0230
         BR    @14                                                 0230
*   RESPECIFY                                                      0231
*     RDEB UNRESTRICTED;                                           0231
*CREACOM:                                                          0232
*                                                                  0232
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - OBTAINS STORAGE FOR SMF RECORD AND               */
*/*                 INITIALIZES COMMON FIELDS.                       */
*/*   01 INPUT  -   1. LENGTH OF SMF RECORD IN RCDLEN                */
*/*   01 OUTPUT -   1. STORAGE NEEDED TO BUILD SMF RECORD WITH       */
*/*                    COMMON FIELDS INITIALIZED. ADDRESS OF         */
*/*                    RECORD IS IN RCDPTR.                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0232
*   PROC;                                                          0232
CREACOM  STM   @14,@12,@SA00004                                    0232
*   PPFUNC=PDF31;                   /* SET FUNCTION CODE     @Y30DSMD*/
         MVI   PPFUNC,X'1F'                                        0233
*   R6=RCDLEN;                      /* LOAD RECORD LENGTH            */
         L     R6,RCDLEN                                           0234
*   GEN(GETMAIN EC,LV=(R6),A=RCDPTR,SP=0,MF=(E,MAINWORK));         0235
         GETMAIN EC,LV=(R6),A=RCDPTR,SP=0,MF=(E,MAINWORK)
*   IF RETCODE^=0 THEN              /* IF NO CORE                    */
         LTR   RETCODE,RETCODE                                     0236
         BZ    @RF00236                                            0236
*     DO;                                                          0237
*       PPCODE=PP20;                /* GETMAIN FAILURE       @Y30DSMD*/
         MVI   PPCODE,X'14'                                        0238
*       GOTO EXIT;                  /* GET OUT OF MODULE             */
         B     EXIT                                                0239
*     END;                                                         0240
*   R6=RCDPTR;                      /* LOAD PTR TO CORE              */
@RF00236 L     R6,RCDPTR                                           0241
*   R7=RCDLEN;                      /* LOAD CORE LENGTH              */
         L     R7,RCDLEN                                           0242
*   R9=0;                           /* PAD CHAR/LENGTH               */
         SLR   R9,R9                                               0243
*   GEN(MVCL R6,R8);                /* ZERO CORE                     */
         MVCL R6,R8
*   RESPECIFY                                                      0245
*     SMFRCD62 BASED(RCDPTR);       /* USE RCD 62 FOR MODEL          */
*   SMF62RTY=RCDNBR;                /* INIT RECORD TYPE              */
         L     @11,RCDPTR                                          0246
         L     @01,RCDPARMA                                        0246
         IC    @00,RCDNBR(,@01)                                    0246
         STC   @00,SMF62RTY(,@11)                                  0246
*   R6=ADDR(JMRJOB);                /* POINT TO JOB NAME             */
         L     @01,CVTPTR                                          0247
         L     @01,CVTTCBP(,@01)                                   0247
         L     @01,TCBPTR(,@01)                                    0247
         L     @01,TCBTCT(,@01)                                    0247
         L     @15,TCTJMR(,@01)                                    0247
         LR    R6,@15                                              0247
*   R7=ADDR(SMF62JNM);              /* POINT TO SMF JOB NAME         */
         LA    R7,SMF62JNM(,@11)                                   0248
*   R7->NMFLD=R6->NMFLD;            /* MOVE JOB NAME INTO RECORD     */
         MVC   NMFLD(8,R7),NMFLD(R6)                               0249
*   SMF62RST=JMRENTRY;              /* COPY READER START TIME        */
         MVC   SMF62RST(4,@11),JMRENTRY(@15)                       0250
*   SMF62RDT=JMREDATE;              /* COPY READER START DATE        */
         MVC   SMF62RDT(4,@11),JMREDATE(@15)                       0251
*   R6=ADDR(JMRUSEID);              /* POINT TO USER ID              */
         LA    R6,JMRUSEID(,@15)                                   0252
*   R7=ADDR(SMF62UID);              /* POINT TO SMF USER ID          */
         LA    R7,SMF62UID(,@11)                                   0253
*   R7->NMFLD=R6->NMFLD;            /* MOVE USER ID INTO RECORD      */
         MVC   NMFLD(8,R7),NMFLD(R6)                               0254
*   END CREACOM;                                                   0255
@EL00004 DS    0H                                                  0255
@EF00004 DS    0H                                                  0255
@ER00004 LM    @14,@12,@SA00004                                    0255
         BR    @14                                                 0255
*FIN62:                                                            0256
*                                                                  0256
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - COMPLETES BUILD OF SMF RECORD 62.                */
*/*   01 INPUT  -   1. ADDRESS OF ACB IN RACB                        */
*/*                 2. ADDRESS OF SMF RECORD (SMFRCD62) IN RCDPTR    */
*/*   01 OUTPUT -   1. COMPLETED SMF RECORD 62                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0256
*   PROC;                                                          0256
FIN62    STM   @14,@12,12(@13)                                     0256
*   RESPECIFY                                                      0257
*     RDEB RESTRICTED;                                             0257
*   SMF62IND=RCD62IND;              /* COPY INDICATORS               */
         L     @15,RCDPTR                                          0258
         L     @14,RCDPARMA                                        0258
         MVC   SMF62IND(4,@15),RCD62IND(@14)                       0258
*   SMF62DNM=RCDCLSNM;              /* MOVE IN DATA SET/CLUSTER NAME */
         L     @01,DSNPTR(,@14)                                    0259
         MVC   SMF62DNM(44,@15),RCDCLSNM(@01)                      0259
*   IF SMF62DNM(1:20)=SMFCATNM THEN /* IF VSAM CAT OPEN MSG  @XA04428*/
         CLC   SMF62DNM(20,@15),@CC03591                           0260
         BNE   @RF00260                                            0260
*     SMF62DNM(20:24)=SMFBLANK;     /* THEN EDIT LAST 5 BYTES      0261
*                                                            @XA04428*/
         MVC   SMF62DNM+19(5,@15),@CC03594                         0261
*   SMF62CVS=CATVLSER;              /* COPY CATALOG VOLSER           */
@RF00260 L     @15,RCDPTR                                          0262
         L     @14,RCDPARMA                                        0262
         L     @01,RCD62VSR(,@14)                                  0262
         MVC   SMF62CVS(6,@15),CATVLSER(@01)                       0262
*   SMF62CNM=CATDSN;                /* COPY CATALOG DATA SET NAME    */
         L     @01,RCD64CNM(,@14)                                  0263
         MVC   SMF62CNM(44,@15),CATDSN(@01)                        0263
*   IF SMF62OOK=ON THEN             /* IF OPEN OK -                  */
         TM    SMF62OOK(@15),B'10000000'                           0264
         BNO   @RF00264                                            0264
*     DO;                                                          0265
*       R6=0;                       /* ZERO LIST INDEX               */
*                                                                  0266
         SLR   R6,R6                                               0266
*       /*************************************************************/
*       /*                                                           */
*       /* INSERT AN ENTRY IN SMF RECORD 62 FOR EACH VOLUME SERIAL   */
*       /* NUMBER ALLOCATED TO DATA SET                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0267
*       VMTPT=BIBVMT;               /* INIT VMT PTR          @Y30DSMD*/
         L     @01,ACBAMBL(,RACB)                                  0267
         L     @01,AMBLBIB(,@01)                                   0267
         L     @15,BIBVMT(,@01)                                    0267
         ST    @15,VMTPT                                           0267
*       DO WHILE VMTPT^=0;          /* PROCESS ALL VMT'S     @Y30DSMD*/
         B     @DE00268                                            0268
@DL00268 DS    0H                                                  0269
*         DO C1=1 TO VMTNOVOL;      /* PROCESS ALL VMT ENTRIES       */
         LA    @15,1                                               0269
         B     @DE00269                                            0269
@DL00269 DS    0H                                                  0270
*           IF VMTVLSER(C1)^=VLZERO THEN/* VOL ENTRY ACTIVE  @Y30DSMD*/
         L     @14,VMTPT                                           0270
         SLA   @15,4                                               0270
         ST    @15,@TF00001                                        0270
         ALR   @15,@14                                             0270
         CLC   VMTVLSER-16(6,@15),VLZERO                           0270
         BE    @RF00270                                            0270
*             DO;                   /* YES, CONTINUE         @Y30DSMD*/
*               R6=R6+1;            /* BUMP LIST COUNT       @Y30DSMD*/
         AL    R6,@CF00061                                         0272
*               SMF62VSR(R6)=VMTVLSER(C1);/* MOVE VOL SER TO LIST  0273
*                                                            @Y30DSMD*/
         L     @15,RCDPTR                                          0273
         LR    @01,R6                                              0273
         MH    @01,@CH02447                                        0273
         ST    @01,@TF00002                                        0273
         ALR   @01,@15                                             0273
         LR    @15,@14                                             0273
         AL    @15,@TF00001                                        0273
         MVC   SMF62VSR-10(6,@01),VMTVLSER-16(@15)                 0273
*               SMF62DTY(R6)=VMTUCB(C1)->UCBTYP;/* INIT UCB TYPE   0274
*                                                            @Y30DSMD*/
         L     @15,RCDPTR                                          0274
         AL    @15,@TF00002                                        0274
         L     @01,@TF00001                                        0274
         L     @01,VMTUCB-16(@01,@14)                              0274
         MVC   SMF62DTY-10(4,@15),UCBTYP(@01)                      0274
*             END;                  /*                       @Y30DSMD*/
*         END;                      /*                       @Y30DSMD*/
@RF00270 LA    @15,1                                               0276
         AL    @15,C1                                              0276
@DE00269 ST    @15,C1                                              0276
         L     @14,VMTPT                                           0276
         CH    @15,VMTNOVOL(,@14)                                  0276
         BNH   @DL00269                                            0276
*         VMTPT=VMTNXT;             /* ADDRESS NXT VMT       @Y30DSMD*/
         L     @01,VMTPT                                           0277
         L     @15,VMTNXT(,@01)                                    0277
         ST    @15,VMTPT                                           0277
*       END;                        /*                       @Y30DSMD*/
@DE00268 L     @15,VMTPT                                           0278
         LTR   @15,@15                                             0278
         BNZ   @DL00268                                            0278
*       SMF62VCT=R6;                /* INIT LIST COUNT               */
         L     @15,RCDPTR                                          0279
         STH   R6,SMF62VCT(,@15)                                   0279
*       SMF62LEN=LENGTH(SMFRCD62)+R6*LENGTH(SMF62VLT);/* INIT REAL 0280
*                                      LENGTH                        */
         LR    @14,R6                                              0280
         MH    @14,@CH02447                                        0280
         AL    @14,@CF03646                                        0280
         STH   @14,SMF62LEN(,@15)                                  0280
*     END;                                                         0281
*   ELSE                            /* IF OPEN NOT SUCCESSFUL -      */
*     DO;                                                          0282
         B     @RC00264                                            0282
@RF00264 DS    0H                                                  0283
*       SMF62LEN=LENGTH(SMFRCD62);  /* INIT RCD LENGTH               */
         L     @15,RCDPTR                                          0283
         MVC   SMF62LEN(2,@15),@CH03646                            0283
*       SMF62VCT=0;                 /* SET VOLUME COUNT TO ZERO      */
         SLR   @14,@14                                             0284
         STH   @14,SMF62VCT(,@15)                                  0284
*     END;                                                         0285
*   RESPECIFY                                                      0286
*     RDEB UNRESTRICTED;                                           0286
*   END FIN62;                                                     0287
@EL00005 DS    0H                                                  0287
@EF00005 DS    0H                                                  0287
@ER00005 LM    @14,@12,12(@13)                                     0287
         BR    @14                                                 0287
*FIN64:                                                            0288
*                                                                  0288
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - COMPLETES BUILD OF SMF RECORD 64.                */
*/*   01 INPUT  -   1. ADDRESS OF AMB IN RCD64AMB                    */
*/*                 2. ADDRESS OF SMF RECORD 64 IN RCDPTR            */
*/*   01 OUTPUT -   1. COMPLETED SMF RECORD 64                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0288
*   PROC;                                                          0288
FIN64    STM   @14,@12,@SA00006                                    0288
*   RESPECIFY                                                      0289
*     SMFRCD64 BASED(RCDPTR);                                      0289
*   R5=RCD64AMB;                    /* LOAD POINTER TO AMB   @Y30DSMD*/
         L     @11,RCDPARMA                                        0290
         L     R5,RCD64AMB-1(,@11)                                 0290
         LA    R5,0(,R5)                                           0290
*   SMF64RIN=RCD64RIN;              /* COPY RECORDING INDICS         */
         L     @15,RCDPTR                                          0291
         MVC   SMF64RIN(1,@15),RCD64RIN(@11)                       0291
*   IF AMBTYPE=AMBDATA THEN         /* IF AMB IS FOR DATA -          */
         TM    AMBTYPE(R5),B'01000000'                             0292
         BNZ   @RF00292                                            0292
*     SMF64DTA=ON;                  /* SET DATA INDIC                */
         OI    SMF64DTA(@15),B'10000000'                           0293
*   ELSE                            /* NOT DATA AMB          @Z30SSRL*/
*     IF AMBTYPE=AMBINDEX THEN      /* IF AMB IS FOR INDEX -         */
         B     @RC00292                                            0294
@RF00292 TM    AMBTYPE(R5),B'01000000'                             0294
         BNO   @RF00294                                            0294
*       SMF64IDX=ON;                /* SET INDEX INDIC               */
         L     @11,RCDPTR                                          0295
         OI    SMF64IDX(@11),B'01000000'                           0295
*   IF SMF64OSP=ON THEN             /* IF OUT OF SPACE INDICATED -   */
@RF00294 DS    0H                                                  0296
@RC00292 L     @11,RCDPTR                                          0296
         TM    SMF64OSP(@11),B'00100000'                           0296
         BNO   @RF00296                                            0296
*     SMF64NTR=RCD64NTR;            /* COPY NBR TRACKS REQUESTED     */
         L     @01,RCDPARMA                                        0297
         L     @15,RCD64NTR(,@01)                                  0297
         STH   @15,SMF64NTR(,@11)                                  0297
*   SMF64CNM=CATDSN;                /* COPY CAT DSN INTO RECORD      */
@RF00296 L     @11,RCDPTR                                          0298
         L     @15,RCDPARMA                                        0298
         L     @01,RCD64CNM(,@15)                                  0298
         MVC   SMF64CNM(44,@11),CATDSN(@01)                        0298
*   SMF64DNM=RCDCLSNM;              /* DATA/INDEX SET NAME INTO RCD  */
         L     @01,DSNPTR(,@15)                                    0299
         MVC   SMF64DNM(44,@11),RCDCLSNM(@01)                      0299
*   R9=AMDPARDB;                    /* LOAD PTR TO FIRST ARDB      0300
*                                                            @XM01564*/
         L     @11,AMBDSB(,R5)                                     0300
         L     R9,AMDPARDB(,@11)                                   0300
*   RESPECIFY                                                      0301
*     IDAARDB BASED(R9);            /*                       @XM01564*/
*   DO WHILE(R9^=0&ARDEOD=OFF);     /* FIND EOD ARDB         @XM01564*/
         B     @DE00302                                            0302
@DL00302 DS    0H                                                  0303
*     R9=ARDNPTR;                   /* LOAD PTR TO NEXT ARDB @XM01564*/
         L     R9,ARDNPTR(,R9)                                     0303
*   END;                            /*                       @XM01564*/
@DE00302 LTR   R9,R9                                               0304
         BZ    @DC00302                                            0304
         TM    ARDEOD(R9),B'00001000'                              0304
         BZ    @DL00302                                            0304
@DC00302 DS    0H                                                  0305
*   IF R9^=0 THEN                   /* IF EOD FOUND          @XM01564*/
         LTR   R9,R9                                               0305
         BZ    @RF00305                                            0305
*     SMF64CHR=ARDHRBA;             /* COPY HIGH USED RBA    @XM01564*/
         L     @11,RCDPTR                                          0306
         MVC   SMF64CHR(4,@11),ARDHRBA(R9)                         0306
*   RESPECIFY                                                      0307
*     RDEB RESTRICTED;                                             0307
@RF00305 DS    0H                                                  0308
*   RDEB=AMBDEBPT;                  /* LOAD POINTER TO DEB           */
         L     RDEB,AMBDEBPT(,R5)                                  0308
*   SMF64ESL=LENGTH(SMF64EXT)*DEBNMEXT;/* FIND EXTENT SEGMENT LENGTH */
         L     @15,RCDPTR                                          0309
         SLR   @14,@14                                             0309
         IC    @14,DEBNMEXT(,RDEB)                                 0309
         MH    @14,@CH03648                                        0309
         STH   @14,SMF64ESL(,@15)                                  0309
*   R7=ADDR(SMF64FEX);              /* POINT TO FIRST EXTENT         */
         LA    R7,SMF64FEX(,@15)                                   0310
*   RESPECIFY                                                      0311
*     SMF64EXT BASED(R7);                                          0311
*   R6=ADDR(DEBBASND);              /* PT TO FIRST EXTENT            */
         LA    R6,DEBBASND(,RDEB)                                  0312
*   RESPECIFY                                                      0313
*     DEBDASD BASED(R6);                                           0313
*   DO C1=1 TO DEBNMEXT;            /* LOOP THRU DEB EXTENTS         */
         LA    @15,1                                               0314
         B     @DE00314                                            0314
@DL00314 DS    0H                                                  0315
*     GEN(MVC SMF64FCC(8,R7),DEBSTRCC(R6))                         0315
*     SETS(SMF64FCC) REFS(DEBSTRCC);/* COPY CCHH'S                   */
         MVC SMF64FCC(8,R7),DEBSTRCC(R6)
*     RUCB=DEBUCBAD;                /* LOAD PTR TO UCB FROM DEB      */
         L     RUCB,DEBUCBAD(,R6)                                  0316
*     SMF64VSN=UCBVOLI;             /* COPY VOLSER FROM UCB          */
         MVC   SMF64VSN(6,R7),UCBVOLI(RUCB)                        0317
*     SMF64CUU(1)=UCBCHA&CHAMASK;   /* MOVE IN CHANNEL               */
         LA    @15,63                                              0318
         SLR   @14,@14                                             0318
         IC    @14,UCBCHA(,RUCB)                                   0318
         NR    @15,@14                                             0318
         STC   @15,SMF64CUU(,R7)                                   0318
*     SMF64CUU(2:2)=UCBUA;          /* MOVE IN UNIT ADDRESS          */
         IC    @15,UCBUA(,RUCB)                                    0319
         STC   @15,SMF64CUU+1(,R7)                                 0319
*     IF UCB2OPT4=OFF THEN          /* IF NOT AN MSS DEVICE  @ZA04901*/
         TM    UCB2OPT4(RUCB),B'00001000'                          0320
         BNZ   @RF00320                                            0320
*       DO;                         /* THEN DO               @ZA04901*/
*         CALL GETSENSE;            /* GET SPINDLE CHAR              */
         BAL   @14,GETSENSE                                        0322
*         SMF64SPD(2:2)=SPINDLE&SPINMASK;/* COPY SPINDLE CHAR        */
         LA    @15,63                                              0323
         SLR   @14,@14                                             0323
         IC    @14,SPINDLE                                         0323
         NR    @15,@14                                             0323
         STC   @15,SMF64SPD+1(,R7)                                 0323
*       END;                        /* END GET SPINDLE ID    @ZA04901*/
*     SMF64UTY=UCBTYP;              /* COPY DEVICE TYPE              */
@RF00320 MVC   SMF64UTY(4,R7),UCBTYP(RUCB)                         0325
*     R6=R6+LENGTH(DEBDASD);        /* PT TO NEXT DEB EXTENT         */
         AL    R6,@CF00078                                         0326
*     R7=R7+LENGTH(SMF64EXT);       /* PT TO NEXT SMF EXTENT         */
         AL    R7,@CF03648                                         0327
*   END;                                                           0328
         LA    @15,1                                               0328
         AL    @15,C1                                              0328
@DE00314 ST    @15,C1                                              0328
         SLR   @14,@14                                             0328
         IC    @14,DEBNMEXT(,RDEB)                                 0328
         CR    @15,@14                                             0328
         BNH   @DL00314                                            0328
*   R6=ADDR(SMFRCD64)+LENGTH(SMFRCD64)+SMF64ESL;/* PT TO STATS       */
         L     @15,RCDPTR                                          0329
         LA    R6,140                                              0329
         ALR   R6,@15                                              0329
         AH    R6,SMF64ESL(,@15)                                   0329
*   RESPECIFY                                                      0330
*     SMF64STS BASED(R6);                                          0330
*   SMF64SLN=LENGTH(SMF64STS);      /* SET STATISTICS LENGTH         */
*                                                                  0331
         MVC   SMF64SLN(4,R6),@CF03384                             0331
*   /*****************************************************************/
*   /*                                                               */
*   /* GET OPEN TIME STATISTICS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0332
*   R8=ADDR(IDAAMDSB)+2*LENGTH(AMDSTAT);/* PT TO OPEN STATISTICS   0332
*                                                            @OZ04709*/
         L     @14,AMBDSB(,R5)                                     0332
         LA    R8,96                                               0332
         ALR   R8,@14                                              0332
*   RESPECIFY                                                      0333
*     IDAAMDSB BASED(R8);                                          0333
*   SMF64NLR=AMDNLR;                /* COPY NO. LOGICAL RECORDS      */
         L     @01,AMDNLR(,R8)                                     0334
         ST    @01,SMF64NLR(,R6)                                   0334
*   SMF64NIN=AMDIREC;               /* COPY NO. OF INSERTS           */
         L     @00,AMDIREC(,R8)                                    0335
         ST    @00,SMF64NIN(,R6)                                   0335
*   SMF64NRE=AMDRETR;               /* COPY NO. OF RETRIEVES         */
         MVC   SMF64NRE(4,R6),AMDRETR(R8)                          0336
*   SMF64NUP=AMDUPR;                /* COPY NO. OF UPDATES           */
         L     @15,AMDUPR(,R8)                                     0337
         ST    @15,SMF64NUP(,R6)                                   0337
*   SMF64NDE=AMDDELR;               /* COPY NO. OF DELETES           */
         L     @15,AMDDELR(,R8)                                    0338
         ST    @15,SMF64NDE(,R6)                                   0338
*   SMF64NFS=AMDASPA;               /* COPY FREE SPACE               */
         MVC   SMF64NFS(4,R6),AMDASPA(R8)                          0339
*   SMF64NIL=AMDNIL;                /* COPY NO. OF INDEX LEVELS      */
         LH    @15,AMDNIL(,R8)                                     0340
         ST    @15,SMF64NIL(,R6)                                   0340
*   SMF64NCS=AMDNCIS;               /* COPY NO. OF CI SPLITS         */
         MVC   SMF64NCS(4,R6),AMDNCIS(R8)                          0341
*   SMF64NAS=AMDNCAS;               /* COPY NO. OF CA SPLITS         */
         MVC   SMF64NAS(4,R6),AMDNCAS(R8)                          0342
*   SMF64NEX=AMDNEXT;               /* COPY NO. EXTENTS              */
         LH    @15,AMDNEXT(,R8)                                    0343
         ST    @15,SMF64NEX(,R6)                                   0343
*   SMF64NEP=AMDEXCP;               /* COPY NO. EXCPS                */
*                                                                  0344
         MVC   SMF64NEP(4,R6),AMDEXCP(R8)                          0344
*   /*****************************************************************/
*   /*                                                               */
*   /* GET CLOSE TIME STATISTICS                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0345
*   RESPECIFY                                                      0345
*     IDAAMDSB BASED(AMBDSB);                                      0345
*   SMF64DIL=AMDNIL-SMF64NIL;       /* COPY NO. OF INDEX LEVELS      */
         L     @15,SMF64NIL(,R6)                                   0346
         LCR   @15,@15                                             0346
         AH    @15,AMDNIL(,@14)                                    0346
         ST    @15,SMF64DIL(,R6)                                   0346
*   SMF64DEX=AMDNEXT-SMF64NEX;      /* COPY NO. OF EXTENTS           */
         L     @15,SMF64NEX(,R6)                                   0347
         LCR   @15,@15                                             0347
         AH    @15,AMDNEXT(,@14)                                   0347
         ST    @15,SMF64DEX(,R6)                                   0347
*   SMF64DLR=AMDNLR-SMF64NLR;       /* COPY NO. OF LOGICAL RECORDS   */
         LCR   @01,@01                                             0348
         AL    @01,AMDNLR(,@14)                                    0348
         ST    @01,SMF64DLR(,R6)                                   0348
*   SMF64DDE=AMDDELR-SMF64NDE;      /* COPY NO. OF DELETES           */
         L     @15,SMF64NDE(,R6)                                   0349
         LCR   @15,@15                                             0349
         AL    @15,AMDDELR(,@14)                                   0349
         ST    @15,SMF64DDE(,R6)                                   0349
*   SMF64DIN=AMDIREC-SMF64NIN;      /* COPY NO. OF INSERTS           */
         LCR   @00,@00                                             0350
         AL    @00,AMDIREC(,@14)                                   0350
         ST    @00,SMF64DIN(,R6)                                   0350
*   SMF64DUP=AMDUPR-SMF64NUP;       /* COPY NO. OF UPDATES           */
         L     @15,SMF64NUP(,R6)                                   0351
         LCR   @15,@15                                             0351
         AL    @15,AMDUPR(,@14)                                    0351
         ST    @15,SMF64DUP(,R6)                                   0351
*   SMF64DRE=AMDRETR-SMF64NRE;      /* COPY NO. OF RETRIEVES         */
         L     @15,AMDRETR(,@14)                                   0352
         SL    @15,SMF64NRE(,R6)                                   0352
         ST    @15,SMF64DRE(,R6)                                   0352
*   SMF64DFS=AMDASPA-SMF64NFS;      /* COPY FREE SPACE               */
         L     @15,AMDASPA(,@14)                                   0353
         SL    @15,SMF64NFS(,R6)                                   0353
         ST    @15,SMF64DFS(,R6)                                   0353
*   SMF64DCS=AMDNCIS-SMF64NCS;      /* COPY NO. OF CI SPLITS         */
         L     @15,AMDNCIS(,@14)                                   0354
         SL    @15,SMF64NCS(,R6)                                   0354
         ST    @15,SMF64DCS(,R6)                                   0354
*   SMF64DAS=AMDNCAS-SMF64NAS;      /* COPY NO. OF CA SPLITS         */
         L     @15,AMDNCAS(,@14)                                   0355
         SL    @15,SMF64NAS(,R6)                                   0355
         ST    @15,SMF64DAS(,R6)                                   0355
*   SMF64DEP=AMDEXCP-SMF64NEP;      /* COPY NO. OF EXCP'S            */
         L     @15,AMDEXCP(,@14)                                   0356
         SL    @15,SMF64NEP(,R6)                                   0356
         ST    @15,SMF64DEP(,R6)                                   0356
*   SMF64LEN=RCDLEN;                /* COPY RECORD LENGTH            */
         L     @15,RCDPTR                                          0357
         L     @01,RCDLEN                                          0357
         STH   @01,SMF64LEN(,@15)                                  0357
*   SMF64BSZ=LPMBLKSZ;              /* PHYSICAL BLOCK SIZE   @OZ04708*/
         L     @01,AMBEDB(,R5)                                     0358
         L     @01,EDBLPMBC(,@01)                                  0358
         L     @15,LPMBLKSZ(,@01)                                  0358
         ST    @15,SMF64BSZ(,R6)                                   0358
*   SMF64CSZ=AMDCINV;               /* CONTROL INTERVAL SIZE @OZ04708*/
         L     @15,AMDCINV(,@14)                                   0359
         ST    @15,SMF64CSZ(,R6)                                   0359
*   SMF64RSZ=AMDLRECL;              /* RECORD SIZE           @OZ04708*/
         L     @15,AMDLRECL(,@14)                                  0360
         ST    @15,SMF64RSZ(,R6)                                   0360
*   SMF64KLN=AMDKEYLN;              /* KEY LENGTH            @OZ04708*/
         LH    @15,AMDKEYLN(,@14)                                  0361
         STH   @15,SMF64KLN(,R6)                                   0361
*   SMF64DDN=TIOEDDNM;              /* TIOT ENTRY DD NAME    @OZ04708*/
         L     @01,RCDPARMA                                        0362
         L     @01,RCD64TIO(,@01)                                  0362
         MVC   SMF64DDN(8,R6),TIOEDDNM(@01)                        0362
*   END FIN64;                                                     0363
@EL00006 DS    0H                                                  0363
@EF00006 DS    0H                                                  0363
@ER00006 LM    @14,@12,@SA00006                                    0363
         BR    @14                                                 0363
*   RESPECIFY                                                      0364
*     RDEB UNRESTRICTED;                                           0364
*WRITERCD:                                                         0365
*                                                                  0365
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - WRITES SMF RECORD TO SMF DATA SET.               */
*/*   01 INPUT  -   1. ADDRESS OF SMF RECORD IN RCDPTR               */
*/*   01 OUTPUT -   1. SMF RECORD WRITTEN TO SMF DATA SET            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0365
*   PROC;                                                          0365
WRITERCD STM   @14,@12,@SA00007                                    0365
*   RESPECIFY                                                      0366
*    (R0,                                                          0366
*     R1) RESTRICTED;                                              0366
*   R1=RCDPTR;                      /* COPY PTR TO SMF RECORD        */
         L     R1,RCDPTR                                           0367
*   GEN(SMFWTM (1));                /* WRITE THE SMF RECORD          */
         SMFWTM (1)
*   R0=RCDLEN;                      /* LOAD RECORD LENGTH            */
         L     R0,RCDLEN                                           0369
*   R1=RCDPTR;                      /* COPY PTR TO SMF RECORD        */
         L     R1,RCDPTR                                           0370
*   IF ACVTDBUG=OFF THEN            /* IF OK TO ISSUE FREEMAINS      */
         L     @11,CVTPTR                                          0371
         TM    ACVTDBUG(@11),B'00000010'                           0371
         BNZ   @RF00371                                            0371
*     GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE CORE FOR RECORD          */
         FREEMAIN R,LV=(0),A=(1)
*   END WRITERCD;                                                  0373
@EL00007 DS    0H                                                  0373
@EF00007 DS    0H                                                  0373
@ER00007 LM    @14,@12,@SA00007                                    0373
         BR    @14                                                 0373
*   RESPECIFY                                                      0374
*    (R0,                                                          0374
*     R1) RESTRICTED;                                              0374
*GETSENSE:                                                         0375
*                                                                  0375
*/********************************************************************/
*/*                                                                  */
*/*   01 FUNCTION - OBTAINS SENSE INFORMATION FROM DEVICE IN ORDER   */
*/*                 TO DETERMINE WHICH DRIVE VOLUME IS MOUNTED ON.   */
*/*   01 INPUT  -   1. ADDRESS OF UCB IN RUCB                        */
*/*   01 OUTPUT -   2. CHARACTER THAT INDICATES WHICH DRIVE VOLUME   */
*/*                    IS MOUNTED ON                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0375
*   PROC;                                                          0375
GETSENSE STM   @14,@12,@SA00008                                    0375
*   IF UCBVTOC^=0 THEN              /* UCB AVAILABLE?        @ZA14574*/
         L     @11,UCBVTOC(,RUCB)                                  0376
         LTR   @11,@11                                             0376
         BZ    @RF00376                                            0376
*     DO;                           /* YES-                  @ZA14574*/
*       IF CCWBLT=OFF THEN          /* CONTROL BLOCKS & CCW NOT BUILT*/
         TM    CCWBLT,B'10000000'                                  0378
         BNZ   @RF00378                                            0378
*         DO;                                                      0379
*           DXCB=DXCB&&DXCB;        /* ZERO CONTROL BLOCK WORK AREA  */
*                                                                  0380
         XC    DXCB(200),DXCB                                      0380
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP CONTROL BLOCK BASES                            */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0381
*           IOBSTPTR=ADDR(DXCB);    /* IOB IS FIRST IN CB            */
         LA    @11,DXCB                                            0381
         ST    @11,IOBSTPTR                                        0381
*           RESPECIFY                                              0382
*             RDEB RESTRICTED;                                     0382
*           RDEB=IOBSTPTR+LENGTH(IOBSTDRD);/* DEB IS SECOND          */
         L     @15,IOBSTPTR                                        0383
         LA    @14,32                                              0383
         LR    RDEB,@15                                            0383
         ALR   RDEB,@14                                            0383
*           DCBPTR=RDEB+LENGTH(DEBBASIC);/* DCB IS THIRD             */
*                                                                  0384
         ALR   @14,RDEB                                            0384
         ST    @14,DCBPTR                                          0384
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP DCB                                            */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0385
*           DCBDEBAD=ADDR(DEBBASIC);/* DCB POINTS TO DEB             */
*                                                                  0385
         STCM  RDEB,15,DCBDEBAD(@14)                               0385
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP DEB                                            */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0386
*           DEBAPPAD=CVTXAPG;       /* SET IOS APPNG VECTOR TBL ADDR
*                                                            @Y021130*/
         L     @15,CVTPTR                                          0386
         MVC   DEBAPPAD(4,RDEB),CVTXAPG(@15)                       0386
*           DEBEXSCL='04'X;         /* SET EXTENT SCALE      @Y021130*/
         MVI   DEBEXSCL(RDEB),X'04'                                0387
*           DEBDCBB=ADDR(IHADCB);   /* DEB POINTS TO DCB     @Y021130*/
         STCM  @14,7,DEBDCBB(RDEB)                                 0388
*           DEBDEBID=IDXDEB;        /* SET DEB ID            @Y021130*/
         MVI   DEBDEBID(RDEB),B'00001111'                          0389
*           DEBNMEXT=1;             /* ONLY ONE EXTENT       @Y021130*/
         MVI   DEBNMEXT(RDEB),X'01'                                0390
*           DEBDAPTR=ADDR(DEBBASND);/* POINT TO FIRST EXTENT @Y021130*/
         LA    @15,DEBBASND(,RDEB)                                 0391
         ST    @15,DEBDAPTR                                        0391
*           RESPECIFY                                              0392
*             DEBDASD BASED(DEBDAPTR);/*                     @Y021130*/
*           DEBSTRCC(1:2)='0000'X;  /* ZERO STARTING CYLINDER      0393
*                                                            @Y021130*/
         MVC   DEBSTRCC(2,@15),@CB03642                            0393
*           DEBSTRHH(1:2)='0000'X;  /* ZERO STARTING HEAD    @Y021130*/
         MVC   DEBSTRHH(2,@15),@CB03642                            0394
*           DEBENDHH(1:2)='0000'X;  /* ZERO ENDING HEAD      @Y021130*/
         MVC   DEBENDHH(2,@15),@CB03642                            0395
*           DEBENDCC(1:2)='7FFF'X;  /* SET END CYLINDER HIGH @Y021130*/
         MVC   DEBENDCC(2,@15),@CB03643                            0396
*           DEBNMTRK(1:2)='7FFF'X;  /* SET NUMBER OF TRACKS HIGH   0397
*                                                            @Y021130*/
         MVC   DEBNMTRK(2,@15),@CB03643                            0397
*           RESPECIFY                                              0398
*             RDEB UNRESTRICTED;                                   0398
*                                                                  0398
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP IOB                                            */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0399
*           IOBUNREL=ON;            /* SET NON-SEQUENTIAL BIT        */
         L     @11,IOBSTPTR                                        0399
         OI    IOBUNREL(@11),B'00000010'                           0399
*           IOBDCBPT=ADDR(IHADCB);  /* IOB POINTS TO DCB             */
         ST    @14,IOBDCBPT(,@11)                                  0400
*           IOBECBPT=ADDR(DXECB);   /* IOB POINTS TO ECB             */
         LA    @15,DXECB                                           0401
         ST    @15,IOBECBPT(,@11)                                  0401
*           IOBSTART=ADDR(DXCCW1);  /* IOB POINTS TO FIRST CCW       */
         LA    @15,DXCCW1                                          0402
         ST    @15,IOBSTART(,@11)                                  0402
*           DXCCW1=DXCCW1&&DXCCW1;  /* ZERO CCW1                     */
         XC    DXCCW1(8),DXCCW1                                    0403
*           DXCCW1(1:4)=ADDR(SENSEDTA);/* POINT CCW TO DATA AREA     */
         LA    @11,SENSEDTA                                        0404
         STCM  @11,15,DXCCW1                                       0404
*           DXCCW1(1)='04'X;        /* SET COMMAND CODE FOR SENSE    */
         MVI   DXCCW1,X'04'                                        0405
*           DXCCW1(5)='20'X;        /* SET SILI BIT ON               */
         MVI   DXCCW1+4,X'20'                                      0406
*           DXCCW1(8)='05'X;        /* SET LENGTH AT 5               */
         MVI   DXCCW1+7,X'05'                                      0407
*           CCWBLT=ON;              /* INDIC CONTROL BLKS & CCW BUILT*/
         OI    CCWBLT,B'10000000'                                  0408
*         END;                                                     0409
*       DEBUCBA=RUCB;               /* SET UCB PTR IN EXTENT         */
@RF00378 L     @11,DEBDAPTR                                        0410
         STCM  RUCB,7,DEBUCBA(@11)                                 0410
*       DXECB=DXECB&&DXECB;         /* ZERO ECB                      */
         XC    DXECB(4),DXECB                                      0411
*       SPINDLE=SPINDLE&&SPINDLE;   /* ZERO SPINDLE CHARACTER        */
         SLR   @11,@11                                             0412
         IC    @11,SPINDLE                                         0412
         LR    @15,@11                                             0412
         XR    @15,@11                                             0412
         STC   @15,SPINDLE                                         0412
*       RESPECIFY                                                  0413
*         R1 RESTRICTED;                                           0413
*       R1=IOBSTPTR;                /* POINT TO IOB                  */
         L     R1,IOBSTPTR                                         0414
*       GEN(EXCP (1));              /* EXECUTE THE I/O               */
         EXCP (1)
*       GEN(WAIT ECB=DXECB);        /* WAIT FOR COMPLETE             */
         WAIT ECB=DXECB
*       RESPECIFY                                                  0417
*         R1 UNRESTRICTED;                                         0417
*     END;                          /*                       @ZA14574*/
*   END GETSENSE;                                                  0419
@EL00008 DS    0H                                                  0419
@EF00008 DS    0H                                                  0419
@ER00008 LM    @14,@12,@SA00008                                    0419
         BR    @14                                                 0419
@PB00008 DS    0H                                                  0419
*   END IDA0192S                                                   0420
*                                                                  0420
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IDAIDXCB)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEESMCA )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IEZXRB  )                                       */
*/*%INCLUDE SYSLIB  (IEFTCT  )                                       */
*/*%INCLUDE SYSLIB  (IEFJMR  )                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAEDB  )                                       */
*/*%INCLUDE SYSLIB  (IDALPMB )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                       */
*/*%INCLUDE SYSLIB  (IEZIOB  )                                       */
*/*%INCLUDE SYSLIB  (IDABIB  )                                       */
*/*%INCLUDE SYSLIB  (IDAVMT  )                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  0420
*       ;                                                          0420
@DATA    DS    0H
@CH02447 DC    H'10'
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
@SA00004 DS    15F
@SA00006 DS    15F
@SA00007 DS    15F
@SA00008 DS    15F
@TF00001 DS    F
@TF00002 DS    F
IDA0192S CSECT
         DS    0F
@CF00061 DC    F'1'
@CF00078 DC    F'16'
@CF03648 DC    F'26'
@CH03648 EQU   @CF03648+2
@CF03384 DC    F'114'
@CF03646 DC    F'142'
@CH03646 EQU   @CF03646+2
@CF03647 DC    F'254'
@DATD    DSECT
         DS    0D
DEBDAPTR DS    A
IOBSTPTR DS    A
VMTPT    DS    A
DCBPTR   DS    A
C1       DS    F
RCDLEN   DS    F
RCDPARMA DS    A
RCDPTR   DS    A
MAINR0   DS    FL4
         ORG   MAINR0
MAINPOOL DS    FL1
MAINLEN  DS    FL3
         ORG   MAINR0+4
C2       DS    F
C3       DS    F
BITBANK  DS    BL1
         ORG   BITBANK
CCWBLT   DS    BL1
FOUND    EQU   BITBANK+0
         ORG   BITBANK+1
         DS    CL3
PD       DS    CL4
         ORG   PD
PPCODE   DS    FL1
PPFUNC   DS    FL1
PPSFC    DS    FL1
@NM00107 DS    CL1
         ORG   PD+4
DXCB     DS    CL200
         DS    CL4
DXCCW1   DS    CL8
DXECB    DS    CL4
SENSEDTA DS    CL5
         ORG   SENSEDTA
@NM00109 DS    CL4
SPINDLE  DS    FL1
         ORG   SENSEDTA+5
         DS    CL3
MAINWORK DS    3F
IDA0192S CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC03591 DC    C'VSAM-CATLG-OPEN-ACB='
@CC03594 DC    C'     '
@CB03642 DC    X'0000'
@CB03643 DC    X'7FFF'
         DS    CL3
GMFAIL   DC    X'141E0000'
VLZERO   DC    X'000000000000'
IDA0192S CSECT
         DS    0D                       START ON DOUBLE WORD BOUNDARY
PTCH192S DC    ((*-IDA0192S)/20)X'00'   PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192S CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
R13      EQU   @13
RCORE    EQU   @04
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
RTIOT    EQU   @09
R9       EQU   @09
RUCB     EQU   @10
RDEB     EQU   @11
RETCODE  EQU   @15
RET      EQU   @14
R10      EQU   @10
R11      EQU   @11
R15      EQU   @15
CVTPTR   EQU   16
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTXAPG  EQU   CVTMAP+20
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTSMCA  EQU   CVTMAP+196
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTAMFF  EQU   CVTMAP+264
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SMCABASE EQU   0
SMCAOPT  EQU   SMCABASE
SMCAMISC EQU   SMCABASE+1
SMCABUF  EQU   SMCABASE+12
SMCAPSTA EQU   SMCABASE+30
SMCAPLBL EQU   SMCABASE+34
SMCASTA  EQU   SMCABASE+46
SMCAALBL EQU   SMCABASE+50
SMCAENTY EQU   SMCABASE+80
SMCAENDI EQU   SMCAENTY
SMCAFOPT EQU   SMCABASE+82
SMCASWA  EQU   SMCABASE+104
SMCAASCB EQU   SMCABASE+120
SMCAPGIN EQU   SMCABASE+136
SMCAPGOT EQU   SMCABASE+140
@NM00004 EQU   0
TCBPTR   EQU   @NM00004+4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFERA  EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBSYSTK EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFLGS3 EQU   TCBFLGS+2
TCBADINP EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBDWSTA EQU   TCBFLGS3
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBFTJST EQU   TCB+44
TCBJPQ   EQU   TCBFTJST
TCBPURGE EQU   TCBJPQ
TCBFTJSA EQU   TCBJPQ+1
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBIDF   EQU   TCBFSA
TCBTME   EQU   TCB+120
TCBPIB   EQU   TCB+124
TCBJSTCB EQU   TCBPIB
TCBPIBT  EQU   TCBJSTCB
TCBPIBA  EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBPQE   EQU   TCB+152
TCBFTFLG EQU   TCBPQE+1
TCBFTFL1 EQU   TCBFTFLG
TCBFTFL2 EQU   TCBFTFLG+1
TCBFTFL3 EQU   TCBFTFLG+2
TCBAQE   EQU   TCB+156
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBXCTL  EQU   TCBNSTAE
TCBSCAT  EQU   TCBNSTAE
TCBSUPER EQU   TCBNSTAE
TCBRETRY EQU   TCBNSTAE
TCBVALID EQU   TCBNSTAE
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBLJSND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBNDINT EQU   TCBNDSP3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBCPU   EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBNTJS  EQU   TCBFLGS6
TCBFLGS7 EQU   TCBBITS+3
TCBGPECB EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBPCB   EQU   TCB+212
TCBARB   EQU   TCB+220
TCBTTQE  EQU   TCB+224
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
XRBPRFX  EQU   0
XRBPRFX1 EQU   0
XRB      EQU   0
@NM00024 EQU   XRB+10
@NM00025 EQU   @NM00024
XRBLRBFX EQU   @NM00025
@NM00027 EQU   @NM00024+1
@NM00028 EQU   @NM00027
@NM00029 EQU   @NM00027
XRBWTL   EQU   XRB+12
XRBEP    EQU   XRBWTL
@NM00032 EQU   XRB+16
XRTLPRB  EQU   @NM00032+4
XRBLOCK  EQU   XRTLPRB
XRBFLAG1 EQU   XRBLOCK
@NM00035 EQU   XRB+28
CDB      EQU   0
CDBMDAD  EQU   CDB
CDBMDSZ  EQU   CDB+4
SMFTCT   EQU   0
TCTSW    EQU   SMFTCT+3
TCTCRTBL EQU   SMFTCT+8
TCTIOTBL EQU   SMFTCT+12
TCTPOOL  EQU   SMFTCT+16
TCTJMR   EQU   SMFTCT+28
TCTJSTX  EQU   SMFTCT+36
TCTTJLM  EQU   SMFTCT+40
TCTPGSMF EQU   SMFTCT+64
TCTPGIN  EQU   TCTPGSMF
TCTPGOUT EQU   TCTPGSMF+4
TCTRGNS  EQU   TCTPGSMF+8
TCTCORE  EQU   0
TCTTIOT  EQU   0
TCTPLEXT EQU   TCTTIOT
JMR      EQU   0
JMRJOB   EQU   JMR
JMRENTRY EQU   JMR+8
JMREDATE EQU   JMR+12
JMRUSEID EQU   JMR+20
JMRFLG   EQU   JMR+30
JMROPT   EQU   JMR+54
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBCHA   EQU   UCBCHAN
UCBUA    EQU   UCBCHAN+1
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00050 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBNMEXT EQU   DEBUSRPG
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBDEBID EQU   DEBPROTG
DEBDCBB  EQU   DEBDCBAD+1
DEBAPPAD EQU   DEBBASIC+28
DEBEXSCL EQU   DEBAPPAD
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBUCBA  EQU   DEBUCBAD+1
DEBSTRCC EQU   DEBDASD+6
DEBSTRHH EQU   DEBDASD+8
DEBENDCC EQU   DEBDASD+10
DEBENDHH EQU   DEBDASD+12
DEBNMTRK EQU   DEBDASD+14
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLBIB  EQU   IDAAMBL+60
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBTYPE  EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEDB   EQU   IDAAMB+52
AMBEOVPT EQU   IDAAMB+56
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAEDBHD EQU   0
EDBLPMBC EQU   IDAEDBHD+4
IDAEDB   EQU   0
EDBFLG1  EQU   IDAEDB+2
IDALPMB  EQU   0
LPMBFLGS EQU   IDALPMB+1
LPMBLKSZ EQU   IDALPMB+12
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDNEST  EQU   IDAAMDSB+4
AMDKEYLN EQU   IDAAMDSB+8
AMDCINV  EQU   IDAAMDSB+20
AMDLRECL EQU   IDAAMDSB+24
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDPARDB EQU   IDAAMDSB+36
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
AMDNIL   EQU   AMDSTAT+8
AMDNEXT  EQU   AMDSTAT+10
AMDNLR   EQU   AMDSTAT+12
AMDDELR  EQU   AMDSTAT+16
AMDIREC  EQU   AMDSTAT+20
AMDUPR   EQU   AMDSTAT+24
AMDRETR  EQU   AMDSTAT+28
AMDASPA  EQU   AMDSTAT+32
AMDNCIS  EQU   AMDSTAT+36
AMDNCAS  EQU   AMDSTAT+40
AMDEXCP  EQU   AMDSTAT+44
IDAARDB  EQU   0
ARDTYPE  EQU   IDAARDB+1
ARDEOD   EQU   ARDTYPE
ARDNPTR  EQU   IDAARDB+4
ARDHRBA  EQU   IDAARDB+12
ARDPRF   EQU   IDAARDB+28
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOEDDNM EQU   TIOENTRY+4
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
IOBPREFX EQU   0
IOBCFLG1 EQU   IOBPREFX
IOBSTDRD EQU   0
IOBFLAG1 EQU   IOBSTDRD
IOBCYCCK EQU   IOBFLAG1
IOBUNREL EQU   IOBFLAG1
IOBRSTRT EQU   IOBFLAG1
IOBFLAG2 EQU   IOBSTDRD+1
IOBPURGE EQU   IOBFLAG2
IOBRDHA0 EQU   IOBFLAG2
IOBSENS0 EQU   IOBSTDRD+2
IOBS0B7  EQU   IOBSENS0
IOBSENS1 EQU   IOBSTDRD+3
IOBECBPT EQU   IOBSTDRD+4
IOBFLAG3 EQU   IOBSTDRD+8
IOBFL3   EQU   IOBFLAG3
IOBCNC   EQU   IOBFL3
IOBICL   EQU   IOBFL3
IOBCSW   EQU   IOBSTDRD+9
IOBIOCSW EQU   IOBCSW
IOBSTBYT EQU   IOBIOCSW+3
IOBUSTAT EQU   IOBSTBYT
IOBCSTAT EQU   IOBSTBYT+1
IOBSTART EQU   IOBSTDRD+16
IOBDCBPT EQU   IOBSTDRD+20
IOBFLAG4 EQU   IOBDCBPT
IOBRESTR EQU   IOBSTDRD+24
IOBINCAM EQU   IOBSTDRD+28
IOBBTAMF EQU   IOBINCAM
IDABIB   EQU   0
BIBHDR   EQU   IDABIB
BIBFLG1  EQU   BIBHDR+1
BIBVMT   EQU   IDABIB+12
BIBRTNS  EQU   IDABIB+60
IDAVMT   EQU   0
VMTHDR   EQU   IDAVMT
VMTNXT   EQU   IDAVMT+4
VMTNOVOL EQU   IDAVMT+8
VMTDEV   EQU   IDAVMT+13
VMTVOL   EQU   IDAVMT+16
VMTVFLG1 EQU   VMTVOL+4
VMTVLSER EQU   VMTVOL+6
VMTUCB   EQU   VMTVOL+12
SMFRCD62 EQU   0
SMF62LEN EQU   SMFRCD62
SMF62STY EQU   SMFRCD62+4
SMF62RTY EQU   SMFRCD62+5
SMF62JNM EQU   SMFRCD62+18
SMF62RST EQU   SMFRCD62+26
SMF62RDT EQU   SMFRCD62+30
SMF62UID EQU   SMFRCD62+34
SMF62IND EQU   SMFRCD62+42
SMF62OOK EQU   SMF62IND
SMF62CNM EQU   SMFRCD62+46
SMF62CVS EQU   SMFRCD62+90
SMF62DNM EQU   SMFRCD62+96
SMF62VCT EQU   SMFRCD62+140
SMF62VLT EQU   SMFRCD62+142
SMF62VSR EQU   SMF62VLT
SMF62DTY EQU   SMF62VLT+6
SMFRCD64 EQU   0
SMF64LEN EQU   SMFRCD64
SMF64STY EQU   SMFRCD64+4
SMF64RIN EQU   SMFRCD64+42
SMF64OSP EQU   SMF64RIN
SMF64DTY EQU   SMFRCD64+43
SMF64DTA EQU   SMF64DTY
SMF64IDX EQU   SMF64DTY
SMF64CNM EQU   SMFRCD64+44
SMF64DNM EQU   SMFRCD64+88
SMF64NTR EQU   SMFRCD64+132
SMF64CHR EQU   SMFRCD64+134
SMF64ESL EQU   SMFRCD64+138
SMF64FEX EQU   SMFRCD64+140
SMF64EXT EQU   0
SMF64FCC EQU   SMF64EXT
SMF64VSN EQU   SMF64EXT+8
SMF64CUU EQU   SMF64EXT+14
SMF64SPD EQU   SMF64EXT+16
SMF64UTY EQU   SMF64EXT+18
SMF64STS EQU   0
SMF64SLN EQU   SMF64STS
SMF64NIL EQU   SMF64STS+4
SMF64NEX EQU   SMF64STS+8
SMF64NLR EQU   SMF64STS+12
SMF64NDE EQU   SMF64STS+16
SMF64NIN EQU   SMF64STS+20
SMF64NUP EQU   SMF64STS+24
SMF64NRE EQU   SMF64STS+28
SMF64NFS EQU   SMF64STS+32
SMF64NCS EQU   SMF64STS+36
SMF64NAS EQU   SMF64STS+40
SMF64NEP EQU   SMF64STS+44
SMF64DIL EQU   SMF64STS+48
SMF64DEX EQU   SMF64STS+52
SMF64DLR EQU   SMF64STS+56
SMF64DDE EQU   SMF64STS+60
SMF64DIN EQU   SMF64STS+64
SMF64DUP EQU   SMF64STS+68
SMF64DRE EQU   SMF64STS+72
SMF64DFS EQU   SMF64STS+76
SMF64DCS EQU   SMF64STS+80
SMF64DAS EQU   SMF64STS+84
SMF64DEP EQU   SMF64STS+88
SMF64BSZ EQU   SMF64STS+92
SMF64CSZ EQU   SMF64STS+96
SMF64RSZ EQU   SMF64STS+100
SMF64KLN EQU   SMF64STS+104
SMF64DDN EQU   SMF64STS+106
RCD62    EQU   0
RCDNBR   EQU   RCD62
RCD62ACB EQU   RCD62+5
DSNPTR   EQU   RCD62+8
RCD62IND EQU   RCD62+12
RCD62OOK EQU   RCD62IND
RCD62VSR EQU   RCD62+20
RCD64    EQU   0
RCD64RIN EQU   RCD64+1
RCD64AMB EQU   RCD64+5
RCD64NTR EQU   RCD64+12
RCD64CNM EQU   RCD64+16
RCD64TIO EQU   RCD64+20
RCDCLSNM EQU   0
CATDSN   EQU   0
CATVLSER EQU   0
IHADCB   EQU   0
DCBDEBAD EQU   IHADCB+44
NMFLD    EQU   0
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
TCBS01   EQU   TCBPCB
TCBFOE   EQU   TCBS01+32
TCBESTAE EQU   TCBS01+52
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCBS01+64
TCBFBYT2 EQU   TCBS01+65
TCBRV124 EQU   TCBS01+66
TCBRV133 EQU   TCBS01+67
TCTIODSP EQU   TCTPLEXT+8
TCTDCBLE EQU   TCTIODSP+4
TCTDDENT EQU   TCTDCBLE+4
TCTFLGS  EQU   TCTDDENT+3
UCBOBS01 EQU   UCBDEV
UCBVTOC  EQU   UCBOBS01
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00049 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
IOBORG01 EQU   IOBPREFX+8
IOBNIOBA EQU   IOBORG01
IOBNFLG1 EQU   IOBNIOBA
IOBPRTOV EQU   IOBNFLG1
IOBORG02 EQU   IOBPREFX+8
IOBDQADA EQU   IOBORG02
IOBDEQIN EQU   IOBDQADA
IOBORG03 EQU   IOBPREFX+12
IOBORG04 EQU   IOBINCAM
IOBORG12 EQU   IOBINCAM
IOBFL4   EQU   IOBORG12
IOBEXTEN EQU   IOBSTDRD+32
IOBSEEK  EQU   IOBEXTEN
IOBBB    EQU   IOBSEEK+1
IOBCC    EQU   IOBSEEK+3
IOBHH    EQU   IOBSEEK+5
IOBORG05 EQU   IOBEXTEN
IOBORG06 EQU   IOBEXTEN
IOBNXTPT EQU   IOBORG06+4
IOBSTATA EQU   IOBNXTPT
IOBORG07 EQU   IOBEXTEN+8
W1IEXTEN EQU   IOBORG07
IOBORG08 EQU   IOBEXTEN+8
IOBINDCT EQU   IOBORG08+4
IOBUNSQR EQU   IOBORG08+5
IOBFCHAD EQU   IOBORG08+8
IOBORG09 EQU   IOBEXTEN+8
IOBDPLAD EQU   IOBORG09+4
IOBDTYPE EQU   IOBORG09+8
IOBDTYP2 EQU   IOBORG09+9
IOBDSTAT EQU   IOBORG09+10
IOBSTAT1 EQU   IOBDSTAT
IOBORG10 EQU   IOBEXTEN+8
IOBSEEK2 EQU   IOBORG10
IOBORG11 EQU   IOBEXTEN
IOBERCT  EQU   IOBORG11
IOBUCBXV EQU   IOBERCT
IOBNAME  EQU   IOBORG11+4
IOBORG13 EQU   IOBEXTEN
IOBSKADR EQU   IOBORG13
@NM00110 EQU   CVTAMFF
ACVTDBUG EQU   @NM00110+2
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00111 EQU   @NM00110
IOBSKSS  EQU   IOBSKADR+3
IOBSK0   EQU   IOBSKADR+2
IOBSKTT  EQU   IOBSKADR+1
IOBSKRV  EQU   IOBSKADR
IOBCSWSV EQU   IOBORG11+17
IOBSENSV EQU   IOBORG11+16
IOBRCD   EQU   IOBORG11+12
IOBMDREC EQU   IOBORG11+8
IOBNAMEA EQU   IOBNAME+1
IOBNAMSZ EQU   IOBNAME
IOBERCTA EQU   IOBERCT+1
IOBRTYPE EQU   IOBUCBXV
IOBRDCHP EQU   IOBORG10+20
IOBNEXTA EQU   IOBORG10+16
IOBREADA EQU   IOBORG10+12
IOBBUFC  EQU   IOBORG10+8
IOBSK2R  EQU   IOBSEEK2+7
IOBSK2HH EQU   IOBSEEK2+5
IOBSK2CC EQU   IOBSEEK2+3
IOBSK2BB EQU   IOBSEEK2+1
IOBSK2M  EQU   IOBSEEK2
IOBCHNPR EQU   IOBORG09+40
IOBDNCRF EQU   IOBORG09+32
IOBRSV35 EQU   IOBORG09+24
IOBDQPTR EQU   IOBORG09+20
IOBRSV34 EQU   IOBORG09+18
IOBDBYTN EQU   IOBORG09+16
IOBDCPND EQU   IOBORG09+12
IOBSTAT2 EQU   IOBDSTAT+1
IOBSIORT EQU   IOBSTAT1
IOBADDVU EQU   IOBSTAT1
IOBBUFF  EQU   IOBSTAT1
IOBENQUE EQU   IOBSTAT1
IOBPASS2 EQU   IOBSTAT1
IOBSYNCH EQU   IOBSTAT1
IOBNEWVL EQU   IOBSTAT1
IOBABNRM EQU   IOBSTAT1
IOBRELEX EQU   IOBDTYP2
IOBADDTY EQU   IOBDTYP2
IOBTYPE  EQU   IOBDTYP2
IOBRQUST EQU   IOBDTYP2
IOBSUFFX EQU   IOBDTYP2
IOBSBLKL EQU   IOBDTYP2
IOBSKEY  EQU   IOBDTYP2
IOBRELBL EQU   IOBDTYPE
IOBRDEXC EQU   IOBDTYPE
IOBDYNBF EQU   IOBDTYPE
IOBACTAD EQU   IOBDTYPE
IOBFDBCK EQU   IOBDTYPE
IOBEXTSC EQU   IOBDTYPE
IOBOVFLO EQU   IOBDTYPE
IOBVERFY EQU   IOBDTYPE
IOBDPLB  EQU   IOBDPLAD+1
IOBDAYLI EQU   IOBDPLAD
IOBDIOBS EQU   IOBORG09+2
IOBDBYTR EQU   IOBORG09
IOBBCHAD EQU   IOBORG08+12
IOBFCHNB EQU   IOBFCHAD+1
IOBCOUNT EQU   IOBFCHAD
IOBASYN  EQU   IOBORG08+7
IOBAPP   EQU   IOBORG08+6
IOBRSV32 EQU   IOBUNSQR
IOBRSV31 EQU   IOBUNSQR
IOBRSV30 EQU   IOBUNSQR
IOBKNRWR EQU   IOBUNSQR
IOBKNWR  EQU   IOBUNSQR
IOBNTAV2 EQU   IOBUNSQR
IOBNTAV1 EQU   IOBUNSQR
IOBCPBSY EQU   IOBUNSQR
IOBCHNNL EQU   IOBINDCT
IOBRSV29 EQU   IOBINDCT
IOBRSV28 EQU   IOBINDCT
IOBRSV27 EQU   IOBINDCT
IOBKEYAD EQU   IOBINDCT
IOBOVPTR EQU   IOBINDCT
IOBUNSCH EQU   IOBINDCT
IOBDEQCP EQU   IOBINDCT
IOBCCWAD EQU   IOBORG08
W1OEXTEN EQU   W1IEXTEN
IOBCCW   EQU   IOBORG06+8
IOBNXTPB EQU   IOBNXTPT+1
IOBRSV26 EQU   IOBSTATA
IOBRSV25 EQU   IOBSTATA
IOBRSV24 EQU   IOBSTATA
IOBRSV23 EQU   IOBSTATA
IOBRSV22 EQU   IOBSTATA
IOBRSV21 EQU   IOBSTATA
IOBRSV20 EQU   IOBSTATA
IOBAVLFL EQU   IOBSTATA
IOBRSV37 EQU   IOBORG06+1
IOBUCBXG EQU   IOBORG06
IOBCPA   EQU   IOBORG05+32
IOBERINF EQU   IOBORG05+16
IOBERCCW EQU   IOBORG05+8
IOBSNDPT EQU   IOBORG05+7
IOBRCVPT EQU   IOBORG05+6
IOBWORK  EQU   IOBORG05+1
IOBUCBX  EQU   IOBORG05
IOBR     EQU   IOBSEEK+7
IOBHH2   EQU   IOBHH+1
IOBHH1   EQU   IOBHH
IOBCC2   EQU   IOBCC+1
IOBCC1   EQU   IOBCC
IOBBB2   EQU   IOBBB+1
IOBBB1   EQU   IOBBB
IOBM     EQU   IOBSEEK
IOBRSV46 EQU   IOBFL4
IOBRSV47 EQU   IOBFL4
IOBENT   EQU   IOBFL4
IOBEQP   EQU   IOBFL4
IOBBUS   EQU   IOBFL4
IOBDCK   EQU   IOBFL4
IOBREJ   EQU   IOBFL4
IOBOVR   EQU   IOBFL4
IOBCRILC EQU   IOBORG04+1
IOBCRDCC EQU   IOBORG04
IOBGQECB EQU   IOBORG03
IOBSWAP  EQU   IOBORG02+4
IOBDQADB EQU   IOBDQADA+1
IOBRSV13 EQU   IOBDEQIN
IOBRSV12 EQU   IOBDEQIN
IOBRSV11 EQU   IOBDEQIN
IOBRSV10 EQU   IOBDEQIN
IOBRSV09 EQU   IOBDEQIN
IOBRSV08 EQU   IOBDEQIN
IOBRSV07 EQU   IOBDEQIN
IOBDEQ   EQU   IOBDEQIN
IOBNECB  EQU   IOBORG01+4
IOBNIOBB EQU   IOBNIOBA+1
IOBFIRST EQU   IOBNFLG1
IOBUPERR EQU   IOBNFLG1
IOBSPAN  EQU   IOBNFLG1
IOBBKSPC EQU   IOBNFLG1
IOBUPDAT EQU   IOBNFLG1
IOBREAD  EQU   IOBNFLG1
IOBWRITE EQU   IOBNFLG1
IOBSEGMT EQU   IOBPRTOV
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00049
UCBSKPFG EQU   @NM00049
UCBRIPND EQU   @NM00049
UCBRTIAC EQU   @NM00049
UCBRSV79 EQU   @NM00049
UCBRSV78 EQU   @NM00049
UCBRSV77 EQU   @NM00049
UCBOLTEP EQU   @NM00049
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00048 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
TCTTKRLD EQU   TCTDDENT+13
TCTEXRLD EQU   TCTDDENT+12
TCTRSV10 EQU   TCTDDENT+8
TCTDCTR  EQU   TCTDDENT+4
TCTRSV26 EQU   TCTFLGS
TCTRSV25 EQU   TCTFLGS
TCTRSV24 EQU   TCTFLGS
TCTRSV23 EQU   TCTFLGS
TCTRSV22 EQU   TCTFLGS
TCTNOCNT EQU   TCTFLGS
TCTVAMDS EQU   TCTFLGS
TCTDDIND EQU   TCTFLGS
TCTSCTR  EQU   TCTDDENT+2
TCTUCBP  EQU   TCTDDENT
TCTIOTSD EQU   TCTIODSP+2
TCTDCBTD EQU   TCTIODSP
@NM00011 EQU   TCBS01+84
TCBSVCA2 EQU   TCBS01+80
TCBSWASA EQU   TCBS01+76
TCBDBTB  EQU   TCBS01+72
TCBRPT   EQU   TCBS01+68
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCBS01+62
TCBCCPVI EQU   TCBS01+60
TCBUKYSP EQU   TCBS01+56
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCBS01+48
TCBTCBID EQU   TCBS01+44
TCBRSV96 EQU   TCBS01+40
TCBSWA   EQU   TCBS01+36
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCBS01+28
TCBRSV41 EQU   TCBS01+27
TCBTID   EQU   TCBS01+26
TCBRSVAA EQU   TCBS01+25
TCBABCUR EQU   TCBS01+24
TCBTMSAV EQU   TCBS01+20
TCBIOTIM EQU   TCBS01+16
TCBRTWA  EQU   TCBS01+12
TCBBACK  EQU   TCBS01+8
TCBTIRB  EQU   TCBS01+4
TCBAECB  EQU   TCBS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00108 EQU   IHADCB
@NM00106 EQU   RCD64+8
@NM00105 EQU   RCD64+2
@NM00104 EQU   RCD64
RCD62TIO EQU   RCD62+24
@NM00103 EQU   RCD62+16
RCD62SVL EQU   RCD62IND
@NM00102 EQU   RCD62+1
@NM00101 EQU   SMF64EXT+22
SMF64TCC EQU   SMF64EXT+4
SMF64VSW EQU   SMF64RIN
SMF64CLO EQU   SMF64RIN
SMF64UID EQU   SMFRCD64+34
SMF64RDT EQU   SMFRCD64+30
SMF64RST EQU   SMFRCD64+26
SMF64JNM EQU   SMFRCD64+18
SMF64MOD EQU   SMFRCD64+16
SMF64SID EQU   SMFRCD64+14
SMF64DTE EQU   SMFRCD64+10
SMF64TME EQU   SMFRCD64+6
SMF64RTY EQU   SMFRCD64+5
SMF64VS1 EQU   SMF64STY
SMF64VS2 EQU   SMF64STY
@NM00100 EQU   SMF64STY
SMF64SEG EQU   SMFRCD64+2
SMF62SVL EQU   SMF62IND
SMF62MOD EQU   SMFRCD62+16
SMF62SID EQU   SMFRCD62+14
SMF62DTE EQU   SMFRCD62+10
SMF62TME EQU   SMFRCD62+6
SMF62VS1 EQU   SMF62STY
SMF62VS2 EQU   SMF62STY
@NM00099 EQU   SMF62STY
SMF62SEG EQU   SMFRCD62+2
@NM00098 EQU   VMTVOL+5
@NM00097 EQU   VMTVFLG1
VMTOPEN  EQU   VMTVFLG1
VMTUSECT EQU   VMTVOL
VMTDVTYP EQU   VMTDEV+1
VMTDVOPT EQU   VMTDEV
@NM00096 EQU   IDAVMT+10
VMTLEN   EQU   VMTHDR+2
@NM00095 EQU   VMTHDR+1
VMTID    EQU   VMTHDR
BIBVSRTP EQU   IDABIB+104
BIBASCB  EQU   IDABIB+100
BIBDDNM  EQU   IDABIB+92
BIBSTPNM EQU   IDABIB+84
BIBJOBNM EQU   IDABIB+76
BIBSIOAP EQU   BIBRTNS+12
BIBASYRT EQU   BIBRTNS+8
BIBCEAPP EQU   BIBRTNS+4
BIBINTRF EQU   BIBRTNS
BIBVGTT  EQU   IDABIB+56
BIBPSAB  EQU   IDABIB+52
BIBCSL   EQU   IDABIB+48
BIBWSHD  EQU   IDABIB+44
BIBVCRT  EQU   IDABIB+40
BIBHEBFQ EQU   IDABIB+36
BIBHEBPT EQU   IDABIB+32
BIBPRSPH EQU   IDABIB+28
BIBSPHPT EQU   IDABIB+24
BIBPAMBL EQU   IDABIB+20
BIBDACB  EQU   IDABIB+16
BIBUPT   EQU   IDABIB+8
@NM00094 EQU   IDABIB+5
BIBFLG2  EQU   IDABIB+4
BIBLEN   EQU   BIBHDR+2
@NM00093 EQU   BIBFLG1
BIBCKPT  EQU   BIBFLG1
BIBREST  EQU   BIBFLG1
BIBVIRT  EQU   BIBFLG1
BIBID    EQU   BIBHDR
IOBERRCT EQU   IOBSTDRD+30
IOBRSV19 EQU   IOBINCAM+1
IOBOLTST EQU   IOBBTAMF
IOBRFTMG EQU   IOBBTAMF
IOBRSV17 EQU   IOBBTAMF
IOBRSV16 EQU   IOBBTAMF
IOBRSV15 EQU   IOBBTAMF
IOBRSV14 EQU   IOBBTAMF
IOBINUSE EQU   IOBBTAMF
IOBPRMER EQU   IOBBTAMF
IOBRSTRB EQU   IOBRESTR+1
IOBREPOS EQU   IOBRESTR
IOBDCBPB EQU   IOBDCBPT+1
IOBRSV44 EQU   IOBFLAG4
IOBJES3I EQU   IOBFLAG4
IOBRSV42 EQU   IOBFLAG4
IOBRSV41 EQU   IOBFLAG4
IOBRSV40 EQU   IOBFLAG4
IOBPMERR EQU   IOBFLAG4
IOBCC3WE EQU   IOBFLAG4
IOBGDPOL EQU   IOBFLAG4
IOBSTRTB EQU   IOBSTART+1
IOBSIOCC EQU   IOBSTART
IOBCSB7  EQU   IOBCSTAT
IOBCSB6  EQU   IOBCSTAT
IOBCSB5  EQU   IOBCSTAT
IOBCSB4  EQU   IOBCSTAT
IOBCSB3  EQU   IOBCSTAT
IOBCSB2  EQU   IOBCSTAT
IOBCSB1  EQU   IOBCSTAT
IOBCSB0  EQU   IOBCSTAT
IOBUSB7  EQU   IOBUSTAT
IOBUSB6  EQU   IOBUSTAT
IOBUSB5  EQU   IOBUSTAT
IOBUSB4  EQU   IOBUSTAT
IOBUSB3  EQU   IOBUSTAT
IOBUSB2  EQU   IOBUSTAT
IOBUSB1  EQU   IOBUSTAT
IOBUSB0  EQU   IOBUSTAT
IOBCMDA  EQU   IOBIOCSW
IOBLOG   EQU   IOBFL3
IOBJAM   EQU   IOBICL
IOBMSG   EQU   IOBFL3
IOBSDR   EQU   IOBCNC
IOBACU   EQU   IOBFL3
IOBCDC   EQU   IOBFL3
IOBICC   EQU   IOBFL3
IOBCCC   EQU   IOBFL3
IOBECBPB EQU   IOBECBPT+1
IOBECBCC EQU   IOBECBPT
IOBS1B7  EQU   IOBSENS1
IOBS1B6  EQU   IOBSENS1
IOBS1B5  EQU   IOBSENS1
IOBS1B4  EQU   IOBSENS1
IOBS1B3  EQU   IOBSENS1
IOBS1B2  EQU   IOBSENS1
IOBS1B1  EQU   IOBSENS1
IOBS1B0  EQU   IOBSENS1
IOBSNSC9 EQU   IOBS0B7
IOBS0B6  EQU   IOBSENS0
IOBS0B5  EQU   IOBSENS0
IOBS0B4  EQU   IOBSENS0
IOBS0B3  EQU   IOBSENS0
IOBS0B2  EQU   IOBSENS0
IOBS0B1  EQU   IOBSENS0
IOBS0B0  EQU   IOBSENS0
IOBPNCH  EQU   IOBFLAG2
IOBSTATO EQU   IOBFLAG2
IOBSKUPD EQU   IOBFLAG2
IOBALTTR EQU   IOBFLAG2
IOBRRT2  EQU   IOBRDHA0
IOBRRT3  EQU   IOBPURGE
IOBSENSE EQU   IOBFLAG2
IOBHALT  EQU   IOBFLAG2
IOBSPSVC EQU   IOBRSTRT
IOBIOERR EQU   IOBFLAG1
IOBFCREX EQU   IOBCYCCK
IOBRPSTN EQU   IOBFLAG1
IOBERRTN EQU   IOBFLAG1
IOBCMDCH EQU   IOBFLAG1
IOBDATCH EQU   IOBFLAG1
IOBCNOPA EQU   IOBPREFX+12
IOBCICB  EQU   IOBPREFX+8
IOBCECB  EQU   IOBPREFX+4
IOBCONOP EQU   IOBPREFX+3
IOBCINOP EQU   IOBPREFX+2
IOBRSV05 EQU   IOBPREFX+1
IOBPCI   EQU   IOBCFLG1
IOBRSTCH EQU   IOBCFLG1
IOBABAPP EQU   IOBCFLG1
IOBPTST  EQU   IOBCFLG1
IOBRSV04 EQU   IOBCFLG1
IOBRSV03 EQU   IOBCFLG1
IOBRSV02 EQU   IOBCFLG1
IOBRSV01 EQU   IOBCFLG1
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00092 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00091 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
ARDKEYS  EQU   IDAARDB+29
@NM00090 EQU   ARDPRF
ARDPRFMT EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDRELNO EQU   IDAARDB+26
ARDVOLSR EQU   IDAARDB+20
ARDERBA  EQU   IDAARDB+16
ARDHKRBA EQU   IDAARDB+8
ARDLEN   EQU   IDAARDB+2
ARDUSED  EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDKR    EQU   ARDTYPE
ARDID    EQU   IDAARDB
AMDSTSP  EQU   AMDSTAT
@NM00089 EQU   IDAAMDSB+41
@NM00088 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
LPMBSST  EQU   IDALPMB+28
LPMBEXT  EQU   IDALPMB+24
@NM00087 EQU   IDALPMB+22
LPMBLKTR EQU   IDALPMB+20
LPMTPC   EQU   IDALPMB+18
LPMTRKAU EQU   IDALPMB+16
LPMBPTRK EQU   IDALPMB+8
LPMAUSZ  EQU   IDALPMB+4
LPMBLEN  EQU   IDALPMB+2
@NM00086 EQU   LPMBFLGS
LPMBSSTH EQU   LPMBFLGS
LPMBTOFL EQU   LPMBFLGS
LPMSS    EQU   LPMBFLGS
LPMREPL  EQU   LPMBFLGS
LPMBRPS  EQU   LPMBFLGS
LPMBID   EQU   IDALPMB
EDBTKBAL EQU   IDAEDB+20
EDBHIRBA EQU   IDAEDB+16
EDBLORBA EQU   IDAEDB+12
EDBSTTRK EQU   IDAEDB+8
EDBLPMBA EQU   IDAEDB+4
EDBM     EQU   IDAEDB+3
@NM00085 EQU   EDBFLG1
EDBPSDS  EQU   EDBFLG1
EDBTOFLW EQU   EDBFLG1
EDBLKR   EQU   EDBFLG1
@NM00084 EQU   IDAEDB
EDBLEN   EQU   IDAEDBHD+2
EDBNO    EQU   IDAEDBHD+1
EDBID    EQU   IDAEDBHD
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00083 EQU   AMBCSWD1+1
@NM00082 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00081 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00080 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00079 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00078 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00077 EQU   AMBINFL
@NM00076 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00075 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00074 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00073 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00072 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
AMBLCMB  EQU   IDAAMBL+64
AMBLIX   EQU   IDAAMBL+56
AMBLDTA  EQU   IDAAMBL+52
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00071 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00070 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00069 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00068 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00067 EQU   IDAAMBL+31
@NM00066 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00065 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00064 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00063 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00062 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00061 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00060 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00059 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00058 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00057 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00056 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00055 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00054 EQU   DEBACS08+12
@NM00053 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00052 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00051 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBBINUM EQU   DEBDASD+4
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00050
UCBHALI  EQU   @NM00050
UCBRSV09 EQU   @NM00050
UCBRSV08 EQU   @NM00050
UCBRSV07 EQU   @NM00050
UCBRSV06 EQU   @NM00050
UCBRSV05 EQU   @NM00050
UCBRSV04 EQU   @NM00050
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00047 EQU   UCB
JMRJCLCP EQU   JMR+72
JMRJCLP  EQU   JMR+68
JMRJOBP  EQU   JMR+64
@NM00046 EQU   JMR+62
JMRJCLCD EQU   JMR+61
JMRSYSOC EQU   JMR+56
@NM00045 EQU   JMR+55
JMRFIND  EQU   JMROPT
@NM00044 EQU   JMROPT
JMRXONLY EQU   JMROPT
JMREXITS EQU   JMROPT
JMRSTPSW EQU   JMROPT
JMRJOBSW EQU   JMROPT
JMRRDR   EQU   JMR+52
JMRJOBIN EQU   JMR+48
JMRDRSTP EQU   JMR+40
JMRUJVP  EQU   JMR+36
JMRUCOM  EQU   JMR+32
JMRCLASS EQU   JMR+31
@NM00043 EQU   JMRFLG
JMRWARM  EQU   JMRFLG
@NM00042 EQU   JMRFLG
JMRCNRS  EQU   JMRFLG
JMRCHRS  EQU   JMRFLG
JMRSTRS  EQU   JMRFLG
JMRINDC  EQU   JMR+29
JMRSTEP  EQU   JMR+28
JMRCPUID EQU   JMR+16
TCTRSV11 EQU   TCTTIOT+6
TCTSZLKP EQU   TCTTIOT+4
TCTSZEXT EQU   TCTPLEXT+2
@NM00041 EQU   TCTPLEXT
TCTLCS   EQU   TCTCORE+16
TCTRBA   EQU   TCTCORE+12
TCTRSZ   EQU   TCTCORE+10
TCTMINC  EQU   TCTCORE+8
TCTHWM   EQU   TCTCORE+4
TCTLWM   EQU   TCTCORE
TCTSOUT  EQU   TCTPGSMF+16
TCTSIN   EQU   TCTPGSMF+12
TCTATR   EQU   TCTRGNS
TCTACT   EQU   TCTPGOUT
TCTAJS   EQU   TCTPGIN
TCTPPST  EQU   SMFTCT+60
TCTAST   EQU   SMFTCT+56
TCTLOUT  EQU   SMFTCT+52
TCTLIN   EQU   SMFTCT+48
TCTWLMT  EQU   SMFTCT+44
TCTSACT  EQU   TCTTJLM
TCTSTOF  EQU   TCTJSTX
TCTRSV08 EQU   SMFTCT+32
TCTUDATA EQU   SMFTCT+24
TCTUTL   EQU   SMFTCT+20
TCTSZE   EQU   TCTPOOL+2
@NM00040 EQU   TCTPOOL
TCTTCB   EQU   SMFTCT+4
TCTRSV07 EQU   TCTSW
TCTRSV06 EQU   TCTSW
TCTRSV05 EQU   TCTSW
TCTRSV04 EQU   TCTSW
TCTRSV03 EQU   TCTSW
TCTRSV02 EQU   TCTSW
TCTIEX   EQU   TCTSW
TCTJSTI  EQU   TCTSW
TCTQA    EQU   SMFTCT
CDBMDSZA EQU   CDBMDSZ+1
CDBSUBPL EQU   CDBMDSZ
CDBMDADA EQU   CDBMDAD+1
CDBNLSZ  EQU   CDBMDAD
XSVRBEND EQU   XRB+152
@NM00039 EQU   XRB+96
XSIRBEND EQU   XRB+96
XIRBEND  EQU   XRB+96
@NM00038 EQU   XRB+32
XLPRBEND EQU   XRB+32
XPRBEND  EQU   XRB+32
@NM00037 EQU   @NM00035+1
@NM00036 EQU   @NM00035
XRBQ     EQU   XRB+24
XFRBEND  EQU   XRB+24
@NM00034 EQU   XRTLPRB+1
XRBWTIS  EQU   XRBFLAG1
@NM00033 EQU   XRBFLAG1
XRBSRSW  EQU   XRBFLAG1
XRBPFSW  EQU   XRBFLAG1
XRREQ    EQU   @NM00032
XLRBEND  EQU   XRB+16
XRBEPA   EQU   XRBEP+1
XRBUSE   EQU   XRBEP
@NM00031 EQU   @NM00027
@NM00030 EQU   @NM00027
XRBIRBBT EQU   @NM00027
XRBREUS  EQU   @NM00027
XRBRSREG EQU   @NM00027
XRBGTMAN EQU   @NM00029
XRBNRENT EQU   @NM00028
XRBREFR  EQU   @NM00025
XRBETXR  EQU   XRBLRBFX
@NM00026 EQU   @NM00025
XRBSVRES EQU   @NM00025
XRBTYPF  EQU   @NM00025
XRBSZY   EQU   XRB+9
XRBCDBPY EQU   XRB+8
XRBNM    EQU   XRB
XRBPFXND EQU   XRBPRFX1+8
XRBPRE   EQU   XRBPRFX1+4
XRBSUC   EQU   XRBPRFX1
XRBQMAJ  EQU   XRBPRFX+4
@NM00023 EQU   XRBPRFX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00022 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00021 EQU   RBOPSWB2
@NM00020 EQU   XRBPSW
@NM00019 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00018 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00017 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00016 EQU   XSTAB1
@NM00015 EQU   RBBASIC+8
@NM00014 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00013 EQU   RBPRFX
@NM00012 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00010 EQU   TCB+232
TCBRV190 EQU   TCB+229
TCBSVCA1 EQU   TCB+228
TCBJSONQ EQU   TCBTTQE
TCBARBA  EQU   TCBARB+1
TCBRSV85 EQU   TCBARB
TCBGQE   EQU   TCB+216
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSV84 EQU   TCBADMP
TCBRSV83 EQU   TCBRSTSK
TCBSVCS  EQU   TCBFLGS7
TCBFWDD  EQU   TCBSTACK
TCBFDDEI EQU   TCBRSV34
TCBFDDT  EQU   TCBRSV33
TCBFDD   EQU   TCBGPECB
TCBSTIJS EQU   TCBNTJS
TCBDSINQ EQU   TCBAPG
TCBRUNJB EQU   TCBMIGR
TCBRUNPN EQU   TCBRV303
TCBFPROT EQU   TCBSPVLK
TCBPANIC EQU   TCBCPU
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBNDGTF EQU   TCBNDSP5
TCBNDSPL EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00009 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBRSV28 EQU   TCBNDINT
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBNDSDA EQU   TCBSRBND
TCBABTER EQU   TCBRV302
TCBTERM  EQU   TCBLJSND
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBVALID
TCBRV301 EQU   TCBRETRY
TCBSYNCH EQU   TCBSUPER
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBSCAT
TCB33E   EQU   TCBXCTL
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBDDRTI EQU   TCBAQE
TCBRSV73 EQU   TCBFTFL3
TCBRSV72 EQU   TCBFTFL3
TCBFTDUM EQU   TCBFTFL3
TCBRSV71 EQU   TCBFTFL3
TCBRSV70 EQU   TCBFTFL3
TCBRSV69 EQU   TCBFTFL3
TCBRSV68 EQU   TCBFTFL3
TCBRSV67 EQU   TCBFTFL3
TCBRSV66 EQU   TCBFTFL2
TCBSYSAB EQU   TCBFTFL2
@NM00008 EQU   TCBFTFL2
TCBRSV65 EQU   TCBFTFL2
TCBLPAGE EQU   TCBFTFL2
TCBDDEN  EQU   TCBFTFL2
TCBRSV62 EQU   TCBFTFL2
TCBRSV61 EQU   TCBFTFL2
TCBENQ   EQU   TCBFTFL1
TCBFTCOM EQU   TCBFTFL1
TCBFTTOP EQU   TCBFTFL1
TCBRSV60 EQU   TCBFTFL1
TCBRSV59 EQU   TCBFTFL1
TCBRSV58 EQU   TCBFTFL1
TCBVTAM  EQU   TCBFTFL1
TCBTCAM  EQU   TCBFTFL1
TCBFTLMP EQU   TCBPQE
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBPIBA
TCBSCHED EQU   TCBPIBT
TCBWRITE EQU   TCBPIBT
TCBSCHTI EQU   TCBPIBT
TCBRSV54 EQU   TCBPIBT
TCBSTOP  EQU   TCBPIBT
TCBSIZE  EQU   TCBPIBT
TCBPART  EQU   TCBPIBT
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBIDF
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBFTJSA
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBRSV53 EQU   TCBDWSTA
TCBPKCHG EQU   TCBRSV08
TCBSCHAB EQU   TCBRSV07
TCBFLREG EQU   TCBRSV06
TCBRSV52 EQU   TCBABGM
TCBSYSER EQU   TCBABTRM
TCBRSV51 EQU   TCBADINP
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBRSV50 EQU   TCBFDSOP
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBSYSTK
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBPOOL  EQU   TCBFT
TCBDMPA  EQU   TCBPDUMP
TCBJSTE  EQU   TCBNONPR
@NM00007 EQU   TCBFERA
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00006 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
@NM00005 EQU   @NM00004
SMCASTCB EQU   SMCABASE+176
SMCAWTCB EQU   SMCABASE+172
SMCAU83  EQU   SMCABASE+168
SMCAPGM  EQU   SMCABASE+164
SMCARGNM EQU   SMCABASE+160
SMCASPOT EQU   SMCABASE+156
SMCASPIN EQU   SMCABASE+152
SMCARGNS EQU   SMCABASE+148
SMCAPGRL EQU   SMCABASE+144
SMCADOMY EQU   SMCAPGOT
SMCADOMX EQU   SMCAPGIN
SMCATEXP EQU   SMCABASE+132
SMCASAVE EQU   SMCABASE+128
SMCARS21 EQU   SMCABASE+124
SMCATJID EQU   SMCAASCB+2
SMCAPOST EQU   SMCAASCB
SMCADSCT EQU   SMCABASE+116
SMCADSTM EQU   SMCABASE+108
SMCASWD  EQU   SMCABASE+107
SMCASWC  EQU   SMCABASE+106
SMCASWB  EQU   SMCABASE+105
SMCADSSW EQU   SMCASWA
SMCADSSP EQU   SMCASWA
SMCAZEOD EQU   SMCASWA
SMCANAVL EQU   SMCASWA
SMCANADA EQU   SMCASWA
SMCAOPFL EQU   SMCASWA
SMCADSTR EQU   SMCASWA
SMCASWAR EQU   SMCASWA
SMCAXNAM EQU   SMCABASE+96
@NM00003 EQU   SMCABASE+92
SMCAXCTL EQU   SMCABASE+88
SMCAWRTP EQU   SMCABASE+84
SMCAENAL EQU   SMCABASE+83
SMCAFGN  EQU   SMCAFOPT
SMCAFTDS EQU   SMCAFOPT
SMCAFR01 EQU   SMCAFOPT
SMCAFVOL EQU   SMCAFOPT
SMCAFDSA EQU   SMCAFOPT
SMCAFEXT EQU   SMCAFOPT
SMCAFOP2 EQU   SMCAFOPT
SMCAFOP1 EQU   SMCAFOPT
SMCAENOP EQU   SMCAENTY+1
SMCADSNF EQU   SMCAENDI
SMCARS20 EQU   SMCAENDI
SMCARS19 EQU   SMCAENDI
SMCARS18 EQU   SMCAENDI
SMCARS17 EQU   SMCAENDI
SMCARS16 EQU   SMCAENDI
SMCARS15 EQU   SMCAENDI
SMCARS14 EQU   SMCAENDI
SMCAWAIT EQU   SMCABASE+72
SMCASGFT EQU   SMCABASE+68
SMCASGWR EQU   SMCABASE+64
SMCABECB EQU   SMCABASE+60
SMCAWECB EQU   SMCABASE+56
SMCAADCB EQU   SMCABASE+52
SMCAYORX EQU   SMCABASE+51
SMCAANL  EQU   SMCAALBL
SMCAASL  EQU   SMCAALBL
SMCAANSL EQU   SMCAALBL
SMCARS13 EQU   SMCAALBL
SMCARS12 EQU   SMCAALBL
SMCARS11 EQU   SMCAALBL
SMCARS10 EQU   SMCAALBL
SMCARS09 EQU   SMCAALBL
SMCAADAR EQU   SMCABASE+47
SMCAAVOL EQU   SMCASTA
SMCAAUNT EQU   SMCASTA
SMCARS08 EQU   SMCASTA
SMCAAMOD EQU   SMCASTA
SMCAAMTY EQU   SMCASTA
SMCAADA  EQU   SMCASTA
SMCAATAP EQU   SMCASTA
SMCAANAV EQU   SMCASTA
SMCAADEV EQU   SMCABASE+40
SMCAPDCB EQU   SMCABASE+36
SMCAXORY EQU   SMCABASE+35
SMCAPNL  EQU   SMCAPLBL
SMCAPSL  EQU   SMCAPLBL
SMCAPNSL EQU   SMCAPLBL
SMCARS07 EQU   SMCAPLBL
SMCARS06 EQU   SMCAPLBL
SMCARS05 EQU   SMCAPLBL
SMCARS04 EQU   SMCAPLBL
SMCARS03 EQU   SMCAPLBL
SMCAPDAR EQU   SMCABASE+31
SMCAPVOL EQU   SMCAPSTA
SMCAPUNT EQU   SMCAPSTA
SMCARS02 EQU   SMCAPSTA
SMCAMOD  EQU   SMCAPSTA
SMCAPMTY EQU   SMCAPSTA
SMCAPDA  EQU   SMCAPSTA
SMCAPTAP EQU   SMCAPSTA
SMCAPNAV EQU   SMCAPSTA
SMCAPDEV EQU   SMCABASE+24
SMCABUFP EQU   SMCABASE+20
SMCASID  EQU   SMCABASE+16
SMCABSIZ EQU   SMCABUF
SMCAJWT  EQU   SMCABASE+8
SMCATIOT EQU   SMCABASE+4
SMCATOFF EQU   SMCABASE+2
SMCADUMP EQU   SMCAMISC
SMCABSW  EQU   SMCAMISC
SMCADBSY EQU   SMCAMISC
SMCAPSDP EQU   SMCAMISC
SMCAFIRT EQU   SMCAMISC
SMCAOPI  EQU   SMCAMISC
SMCAMAN  EQU   SMCAMISC
SMCAUSER EQU   SMCAMISC
SMCAFGND EQU   SMCAOPT
SMCATDS  EQU   SMCAOPT
SMCARS01 EQU   SMCAOPT
SMCAVOL  EQU   SMCAOPT
SMCADSA  EQU   SMCAOPT
SMCAEXT  EQU   SMCAOPT
SMCAOPT2 EQU   SMCAOPT
SMCAOPT1 EQU   SMCAOPT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00212 EQU   @EL00002
@RC00264 EQU   @EL00005
@RF00371 EQU   @EL00007
@PB00007 EQU   @PB00008
@RF00376 EQU   @EL00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0192S,(C'PLS1434',0701,78144)
