         TITLE 'IDA0192V - MVM VOLUME MOUNT AND VERIFY                 *
                        '
IDA0192V CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192V  78.165'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  LA    @12,4095(,@03)                                      0001
         USING @PSTART,@03                                         0001
         USING @PSTART+4095,@12                                    0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL 0
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  0 THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR 0
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        0 IF THE GETMAIN WAS UNSUCCESSFUL.
*   IF RETCODE=0 THEN               /* IF GETMAIN UNSUCCESSFUL       */
         LTR   RETCODE,RETCODE                                     0238
         BNZ   @RF00238                                            0238
*     DO;                                                          0239
*       VVOLLERR=GMFAIL;            /* INIT PROB DET INFO    @Y30DSMD*/
         MVC   VVOLLERR(4,R1),GMFAIL                               0240
*       RETCODE=8;                  /* LOAD RETURN CODE OF 8 @Y30DSMD*/
         LA    RETCODE,8                                           0241
*     END;                                                         0242
*   ELSE                            /* IF GETMAIN SUCCESSFUL         */
*     DO;                                                          0243
         B     @RC00238                                            0243
@RF00238 DS    0H                                                  0244
*       GEN(ST R13,4(R15));         /* SAVE SAVE AREA ADDRESS        */
         ST R13,4(R15)
*       GEN( L R0,20(,R13));        /* IDAGMAIN USES R0, RESTORE IT.
*                                                            @Z30SSMD*/
          L R0,20(,R13)
*       GEN( L R1,24(,R13));        /* IDAGMAIN USES R1, RESTORE IT.
*                                                            @Z30SSMD*/
          L R1,24(,R13)
*       R13=R15;                    /* LOAD PTR TO AUTOMATIC CORE    */
         LR    R13,R15                                             0247
*       GEN(USING @DATD,R13);       /* GET ADDRESSING                */
         USING @DATD,R13
*       RESPECIFY                                                  0249
*         R6 RESTRICTED;                                           0249
*       R6=R1;                      /* COPY PARM PTR                 */
         LR    R6,R1                                               0250
*       RESPECIFY                                                  0251
*         IDAVVOLL BASED(R6);       /*                       @Y30LSPS*/
*       VVOLLFNC=VOLINIT;           /* SET FUNCTION CODE     @Y30LSPS*/
         MVI   VVOLLFNC(R6),X'14'                                  0252
*       RESPECIFY                                                  0253
*         IDAVUCBL BASED(R6);                                      0253
*       IF VUCBLID=ON THEN          /* IF USER PASSED UCB LIST       */
         TM    VUCBLID(R6),B'10000000'                             0254
         BNO   @RF00254                                            0254
*         DO;                       /* INIT LIST PTRS                */
*           UCBLPTR=R6;             /* INIT UCB LIST PTR             */
         ST    R6,UCBLPTR                                          0256
*           VOLLPTR=VUCBLVLA;       /* INIT VOLUME LIST PTR          */
         L     @14,VUCBLVLA(,R6)                                   0257
         ST    @14,VOLLPTR                                         0257
*         END;                                                     0258
*       ELSE                        /* IF USER PASSED VOLUME LIST    */
*         DO;                                                      0259
         B     @RC00254                                            0259
@RF00254 DS    0H                                                  0260
*           RESPECIFY                                              0260
*             IDAVVOLL BASED(R6);                                  0260
*           VOLLPTR=R6;             /* INIT VOLUME LIST PTR          */
         ST    R6,VOLLPTR                                          0261
*           CALL BLDUCBL;           /* BUILD UCB LIST                */
         BAL   @14,BLDUCBL                                         0262
*         END;                                                     0263
*       RESPECIFY                                                  0264
*        (R1,                                                      0264
*         R6,                                                      0264
*         RETCODE) UNRESTRICTED;    /*                       @ZA33246*/
@RC00254 DS    0H                                                  0265
*       RESPECIFY                                                  0265
*         IDAVUCBL BASED(UCBLPTR);                                 0265
*       RESPECIFY                                                  0266
*         IDAVVOLL BASED(VOLLPTR);                                 0266
*       DO C1=1 TO VVOLLNBR;        /* LOOP THRU VOLUME LIST         */
         LA    @11,1                                               0267
         B     @DE00267                                            0267
@DL00267 DS    0H                                                  0268
*         VVOLLMNT(C1)=OFF;         /* RESET MOUNTED BIT             */
*         VVOLLVFY(C1)=OFF;         /* RESET VERIFIED BIT            */
         LR    @05,@11                                             0269
         MH    @05,@CH00033                                        0269
         L     @01,VOLLPTR                                         0269
         ALR   @01,@05                                             0269
         NI    VVOLLMNT-12(@01),B'00111111'                        0269
*       END;                                                       0270
         AL    @11,@CF00062                                        0270
@DE00267 ST    @11,C1                                              0270
         L     @05,VOLLPTR                                         0270
         CH    @11,VVOLLNBR(,@05)                                  0270
         BNH   @DL00267                                            0270
*       MAINLEN=LENGTH(CCHHRF4)*VVOLLNBR;/* SET LENGTH OF CCHHR LIST */
         L     @11,VOLLPTR                                         0271
         LH    @11,VVOLLNBR(,@11)                                  0271
         MH    @11,@CH00882                                        0271
         STCM  @11,7,MAINLEN                                       0271
*       CALL GETMAIN;               /* GET CORE FOR CCHHR LIST       */
         BAL   @14,GETMAIN                                         0272
*       CCHHRCRE=ON;                /* INDICATE GETMAIN OK           */
         OI    CCHHRCRE,B'00100000'                                0273
*       CCHHRPTR=MAINADDR;          /* SET UP BASE FOR CCHHR LIST    */
         L     @11,MAINADDR                                        0274
         ST    @11,CCHHRPTR                                        0274
*       VVOLLFNC=PDF23;             /* SET FUNCTION CODE     @Y30DSMD*/
         L     @11,VOLLPTR                                         0275
         MVI   VVOLLFNC(@11),X'17'                                 0275
*       CALL DTMOUNT;               /* DETERMINE WHICH VOLUMES     0276
*                                      ALREADY MOUNTED               */
         BAL   @14,DTMOUNT                                         0276
*       IF MWAMTCNT^=0 THEN         /* CHECK IF ANY VOLUMES NEEDED 0277
*                                      MOUNTING              @ZA33246*/
         SLR   @11,@11                                             0277
         C     @11,MWAMTCNT                                        0277
         BE    @RF00277                                            0277
*         DO;                       /*                       @ZA33246*/
*           IF MWAJS3CT^=0 THEN     /* CHECK IF ANY OF THE UCB'S TO
*                                      BE MOUNTED ARE MANAGED BY JES3
*                                                            @ZA33246*/
         C     @11,MWAJS3CT                                        0279
         BE    @RF00279                                            0279
*             DO;                   /*                       @ZA33246*/
*               MAINLEN=LENGTH(SSOB)+LENGTH(SSMO);/* SSOB & SSOB EXT
*                                      LENGTH                @ZA33246*/
         MVC   MAINLEN(3),@CF00094+1                               0281
*               CALL GETMAIN;       /* ISSUE GETMAIN         @ZA33246*/
         BAL   @14,GETMAIN                                         0282
*               MWAJS3ID=ON;        /* INDICATE CORE GOTTEN FOR JES3
*                                      PROCESSING            @ZA33246*/
         OI    MWAJS3ID,B'10000000'                                0283
*               MWASSOB=MAINADDR;   /* POINT TO GOTTEN CORE  @ZA33246*/
         L     @11,MAINADDR                                        0284
         STCM  @11,7,MWASSOB                                       0284
*               SSOBLEN=LENGTH(SSOB);/* SET SSOB LENGTH      @ZA33246*/
         LA    @05,20                                              0285
         STH   @05,SSOBLEN(,@11)                                   0285
*               MWASSMO=MWASSOB+SSOBLEN;/* PT TO SSOB EXTENSION    0286
*                                                            @ZA33246*/
         ALR   @05,@11                                             0286
         ST    @05,MWASSMO                                         0286
*               SSOBID='SSOB';      /* SET SSOB ID           @ZA33246*/
         MVC   SSOBID(4,@11),@CC04458                              0287
*               SSOBFUNC=SSOBOEOV;  /* INDICATE MOUNT DISMOUNT     0288
*                                      FUNCTION              @ZA33246*/
         MVC   SSOBFUNC(2,@11),@CH01746                            0288
*               SSOBINDV=MWASSMO;   /* POINT TO THE MOUNT/DISMOUNT 0289
*                                      FUNCTION EXTENSION    @ZA33246*/
         ST    @05,SSOBINDV(,@11)                                  0289
*               SSMOPSTN=ADDR(SCTSNUMB);/* PTR TO STEP NUMBER      0290
*                                                            @ZA33246*/
         LA    @11,16                                              0290
         L     @01,CVTPTR                                          0290
         L     @01,CVTTCBP(,@01)                                   0290
         L     @01,TCBPTR(,@01)                                    0290
         L     @15,TCBJSCB(,@01)                                   0290
         L     @14,JSCSCT(,@15)                                    0290
         ALR   @14,@11                                             0290
         LA    @14,SCTSNUMB(,@14)                                  0290
         ST    @14,SSMOPSTN(,@05)                                  0290
*               SSMOLEN=LENGTH(SSMO);/* SIZE OF EXTENSION    @ZA33246*/
         MVC   SSMOLEN(2,@05),@CH00084                             0291
*               MWAFGFIN=ON;        /* INIT FINAL CALL BIT   @ZA33246*/
         OI    MWAFGFIN,B'01000000'                                0292
*               SSMOFLG1=MWAFLAG;   /* SET FLAG BYTE         @ZA33246*/
         MVC   SSMOFLG1(1,@05),MWAFLAG                             0293
*               SSMOPNAM=ADDR(JCTJNAME);/* PTR TO JOB NAME   @ZA33246*/
         AL    @11,JSCBJCT(,@15)                                   0294
         LA    @11,JCTJNAME(,@11)                                  0294
         ST    @11,SSMOPNAM(,@05)                                  0294
*             END;                  /*                       @ZA33246*/
*           CALL GOMOUNT;           /* MOUNT VOLUMES         @ZA33246*/
@RF00279 BAL   @14,GOMOUNT                                         0296
*         END;                      /*                       @ZA33246*/
*       CALL GOVERIFY;              /* VERIFY VOLUMES                */
@RF00277 BAL   @14,GOVERIFY                                        0298
*       IF VVOLLACB^=0 THEN         /* IF PTR TO CATALOG ACB EXISTS  */
         L     @11,VOLLPTR                                         0299
         L     @05,VVOLLACB(,@11)                                  0299
         LTR   @05,@05                                             0299
         BZ    @RF00299                                            0299
*         DO;                                                      0300
*           VVOLLFNC=PDF21;         /* SET FUNCTION CODE     @Y30DSMD*/
         MVI   VVOLLFNC(@11),X'15'                                 0301
*           CALL TSCHK;             /* DO TIMESTAMP CHECK            */
         BAL   @14,TSCHK                                           0302
*         END;                                                     0303
*                                                                  0304
*       /*************************************************************/
*       /*                                                           */
*       /* PERFORM TERMINATION PROCESSING                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0304
*EXIT:                                                             0304
*       RESPECIFY                                                  0304
*        (R0,                                                      0304
*         R1) RESTRICTED;                                          0304
@RF00299 DS    0H                                                  0304
EXIT     DS    0H                                                  0305
*       IF CAMCORE=ON THEN          /* IF CAMLST WKA TO FREE         */
         TM    CAMCORE,B'01000000'                                 0305
         BNO   @RF00305                                            0305
*         DO;                                                      0306
*           R0=LENGTH(CMLSTWKA);    /* LOAD LENGTH FOR FREEMAIN      */
         LA    R0,164                                              0307
*           R1=CMLSTWKP;            /* LOAD ADDRESS FOR FREEMAIN     */
         L     R1,CMLSTWKP                                         0308
*           IF ACVTDBUG=OFF THEN    /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0309
         TM    ACVTDBUG(@11),B'00000010'                           0309
         BNZ   @RF00309                                            0309
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE CAMLST WKA        */
         FREEMAIN R,LV=(0),A=(1)
*         END;                                                     0311
@RF00309 DS    0H                                                  0312
*       IF TSCORE=ON THEN           /* IF TIMESTAMP CORE TO FREE     */
@RF00305 TM    TSCORE,B'10000000'                                  0312
         BNO   @RF00312                                            0312
*         DO;                                                      0313
*           R0=TSCORELN;            /* LOAD LENGTH OF WORK AREA      */
         L     R0,TSCORELN                                         0314
*           R1=TSPT;                /* LOAD PTR TO WORK AREA         */
         L     R1,TSPT                                             0315
*           IF ACVTDBUG=OFF THEN    /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0316
         TM    ACVTDBUG(@11),B'00000010'                           0316
         BNZ   @RF00316                                            0316
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE THE WORK AREA     */
         FREEMAIN R,LV=(0),A=(1)
*         END;                                                     0318
@RF00316 DS    0H                                                  0319
*       IF FAEVUCBL=ON THEN         /* DOES UCB LIST NEED FREEMAIN   */
@RF00312 TM    FAEVUCBL,B'00000010'                                0319
         BNO   @RF00319                                            0319
*         DO;                       /* YES -                         */
*           R0=LENGTH(IDAVUCBL)+    /* FIND CORE LENGTH              */
*               VUCBLNBR*LENGTH(VUCBLENT);                         0321
         L     @11,UCBLPTR                                         0321
         LH    R0,VUCBLNBR(,@11)                                   0321
         SLA   R0,2                                                0321
         AL    R0,@CF00064                                         0321
*           R1=ADDR(IDAVUCBL);      /* POINT TO CORE                 */
         LR    R1,@11                                              0322
*           IF ACVTDBUG=OFF THEN    /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0323
         TM    ACVTDBUG(@11),B'00000010'                           0323
         BNZ   @RF00323                                            0323
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE THE WORK AREA     */
         FREEMAIN R,LV=(0),A=(1)
*         END;                                                     0325
@RF00323 DS    0H                                                  0326
*       IF JFCBREAD=ON THEN         /* IF JFCB WAS READ              */
@RF00319 TM    JFCBREAD,B'00000100'                                0326
         BNO   @RF00326                                            0326
*         DO;                                                      0327
*           R0=LENGTH(JFCBWRKA);    /* LOAD LENGTH OF WORK AREA      */
         LA    R0,476                                              0328
*           R1=JFCBWKAP;            /* LOAD PTR TO WORK AREA         */
         L     R1,JFCBWKAP                                         0329
*           IF ACVTDBUG=OFF THEN    /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0330
         TM    ACVTDBUG(@11),B'00000010'                           0330
         BNZ   @RF00330                                            0330
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE THE WORK AREA     */
         FREEMAIN R,LV=(0),A=(1)
*         END;                                                     0332
@RF00330 DS    0H                                                  0333
*       IF CCHHRCRE=ON THEN         /* IF CCHHR LIST TO FREE         */
@RF00326 TM    CCHHRCRE,B'00100000'                                0333
         BNO   @RF00333                                            0333
*         DO;                                                      0334
*           R0=LENGTH(CCHHRF4)*VVOLLNBR;/* SET LENGTH OF CCHHR LIST  */
         L     @11,VOLLPTR                                         0335
         LH    R0,VVOLLNBR(,@11)                                   0335
         MH    R0,@CH00882                                         0335
*           R1=CCHHRPTR;            /* SET POINTER TO CCHHR LIST     */
         L     R1,CCHHRPTR                                         0336
*           IF ACVTDBUG=OFF THEN    /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0337
         TM    ACVTDBUG(@11),B'00000010'                           0337
         BNZ   @RF00337                                            0337
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE THE WORK AREA     */
         FREEMAIN R,LV=(0),A=(1)
*         END;                                                     0339
@RF00337 DS    0H                                                  0340
*       IF DOMLISTP^=0 THEN         /* IF DOMLIST BUILT              */
@RF00333 L     @11,DOMLISTP                                        0340
         LTR   @11,@11                                             0340
         BZ    @RF00340                                            0340
*         DO;                                                      0341
*           R0=LENGTH(DOMLIST)*VVOLLNBR;/* LOAD LENGTH               */
         L     @05,VOLLPTR                                         0342
         LH    R0,VVOLLNBR(,@05)                                   0342
         SLA   R0,2                                                0342
*           R1=DOMLISTP;            /* POINT TO BLOCK                */
         LR    R1,@11                                              0343
*           IF ACVTDBUG=OFF THEN    /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0344
         TM    ACVTDBUG(@11),B'00000010'                           0344
         BNZ   @RF00344                                            0344
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE THE WORK AREA     */
         FREEMAIN R,LV=(0),A=(1)
*         END;                                                     0346
@RF00344 DS    0H                                                  0347
*       NOMOUNT=OFF;                /* SET ERROR SWITCH OFF          */
@RF00340 NI    NOMOUNT,B'11101111'                                 0347
*       IF VVOLLPDC=0 THEN          /* IF NO PREVIOUS ERROR  @Y30LSPS*/
         L     @11,VOLLPTR                                         0348
         CLI   VVOLLPDC(@11),0                                     0348
         BNE   @RF00348                                            0348
*         DO C1=1 TO VVOLLNBR;      /* LOOP THRU VOLUME LIST         */
         LA    @11,1                                               0349
         B     @DE00349                                            0349
@DL00349 DS    0H                                                  0350
*           IF VVOLLMNT(C1)=OFF THEN/* IF VOLUME NOT MOUNTED,        */
         MH    @11,@CH00033                                        0350
         L     @05,VOLLPTR                                         0350
         ALR   @05,@11                                             0350
         TM    VVOLLMNT-12(@05),B'10000000'                        0350
         BNZ   @RF00350                                            0350
*             NOMOUNT=ON;           /* THEN SET SWITCH               */
         OI    NOMOUNT,B'00010000'                                 0351
*         END;                                                     0352
@RF00350 LA    @11,1                                               0352
         AL    @11,C1                                              0352
@DE00349 ST    @11,C1                                              0352
         L     @05,VOLLPTR                                         0352
         CH    @11,VVOLLNBR(,@05)                                  0352
         BNH   @DL00349                                            0352
*       IF MWAJS3ID=ON THEN         /* IF JES3 SUPPORT CORE GOTTEN 0353
*                                                            @ZA33246*/
@RF00348 TM    MWAJS3ID,B'10000000'                                0353
         BNO   @RF00353                                            0353
*         DO;                       /*                       @ZA33246*/
*           R0=SSOBLEN+SSMOLEN;     /* CORE LENGTH           @ZA33246*/
         L     @11,MWASSOB-1                                       0355
         LA    @11,0(,@11)                                         0355
         LH    R0,SSOBLEN(,@11)                                    0355
         L     @05,MWASSMO                                         0355
         AH    R0,SSMOLEN(,@05)                                    0355
*           R1=MWASSOB;             /* PT TO ADDRESS OF CORE @ZA33246*/
         LR    R1,@11                                              0356
*           IF ACVTDBUG=OFF THEN    /* IF OKAY TO FREEMAIN   @ZA33246*/
         L     @11,CVTPTR                                          0357
         TM    ACVTDBUG(@11),B'00000010'                           0357
         BNZ   @RF00357                                            0357
*             GEN(FREEMAIN R,LV=(0),A=(1));/* FREE CORE      @ZA33246*/
         FREEMAIN R,LV=(0),A=(1)
*         END;                      /*                       @ZA33246*/
@RF00357 DS    0H                                                  0360
*       RESPECIFY                                                  0360
*        (R6,                                                      0360
*         R7) RESTRICTED;           /*                       @Y30LSPS*/
@RF00353 DS    0H                                                  0361
*       IF NOMOUNT=ON THEN          /* VOLUMES NOT MOUNTED   @Z30SSRL*/
         TM    NOMOUNT,B'00010000'                                 0361
         BNO   @RF00361                                            0361
*         R6=4;                     /* INDICATE POSSIBLE ERROR     0362
*                                                            @Y30LSPS*/
         LA    R6,4                                                0362
*       ELSE                        /* ALL VOLUMES MOUNTED   @Z30SSRL*/
*         R6=0;                     /* INDICATE NO ERROR     @Y30LSPS*/
*                                                                  0363
         B     @RC00361                                            0363
@RF00361 SLR   R6,R6                                               0363
*       /*************************************************************/
*       /*                                                           */
*       /* EXIT MODULE                                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0364
*       IF VVOLLPDC=0 THEN          /* IF NO ERRORS          @Y30LSPS*/
@RC00361 L     @11,VOLLPTR                                         0364
         CLI   VVOLLPDC(@11),0                                     0364
         BNE   @RF00364                                            0364
*         VVOLLFNC=0;               /* THEN ZERO FUNCTN CODE @Y30LSPS*/
         MVI   VVOLLFNC(@11),X'00'                                 0365
*       ELSE                                                       0366
*         R6=8;                     /* INDICATE MNT ERR      @Y30LSPS*/
         B     @RC00364                                            0366
@RF00364 LA    R6,8                                                0366
*       MAINPOOL=WKPOOL;            /* SET SUBPOOL FOR FREEMAIN      */
@RC00364 MVI   MAINPOOL,X'FC'                                      0367
*       GEN(L R7,@SIZDATD);         /* LOAD BLOCK SIZE               */
         L R7,@SIZDATD
*       MAINLEN=R7;                 /* SET LENGTH FOR FREEMAIN       */
         STCM  R7,7,MAINLEN                                        0369
*       R1=R13;                     /* POINT TO BLOCK ADDR           */
         LR    R1,R13                                              0370
*       R0=MAINR0;                  /* LOAD SUBPOOL/LENGTB           */
         L     R0,MAINR0                                           0371
*       GEN(L R13,4(R13));          /* POINT TO LAST SAVEAREA        */
         L R13,4(R13)
*       IF ACVTDBUG=OFF THEN        /* IF OK TO FREEMAIN             */
         L     @11,CVTPTR                                          0373
         TM    ACVTDBUG(@11),B'00000010'                           0373
         BNZ   @RF00373                                            0373
*         GEN(FREEMAIN R,LV=(0),A=(1));/* FREE AUTOMATICS            */
         FREEMAIN R,LV=(0),A=(1)
*       RESPECIFY                                                  0375
*         RETCODE RESTRICTED;       /*                       @ZA33246*/
@RF00373 DS    0H                                                  0376
*       RETCODE=R6;                 /* LOAD RETURN CODE REGISTER     */
         LR    RETCODE,R6                                          0376
*       RESPECIFY                                                  0377
*        (R6,                                                      0377
*         R7) UNRESTRICTED;                                        0377
*     END;                                                         0378
*   GEN(L RET,12(R13));             /* LOAD RETURN ADDRESS           */
@RC00238 DS    0H                                                  0379
         L RET,12(R13)
*   GEN(LM R0,R12,20(R13));         /* RESTORE REGISTERS 0-12        */
         LM R0,R12,20(R13)
*   GEN(BR RET);                    /* RETURN TO CALLER              */
         BR RET
*   RESPECIFY                                                      0382
*    (R0,                                                          0382
*     R1,                                                          0382
*     RETCODE) UNRESTRICTED;        /*                       @ZA33246*/
*DTMOUNT:                                                          0383
*                                                                  0383
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  DETERMINES WHICH VOLUMES ARE ALREADY MOUNTED ON    */
*/*               WHICH UCB'S.                                       */
*/*   INPUT -     1. ADDRESS OF UCB LIST IN UCBLPTR                  */
*/*               2. ADDRESS OF VOLUME LIST IN VOLLPTR               */
*/*   OUTPUT  -   1. BITS SET IN VOLUME LIST TO INDICATE WHETHER     */
*/*                  OR NOT VOLUMES ARE MOUNTED AND VERIFIED         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0383
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0383
DTMOUNT  DS    0H                                                  0384
*   RESPECIFY                                                      0384
*    (R6,                                                          0384
*     R7,                                                          0384
*     R8,                                                          0384
*     R9,                                                          0384
*     RET) RESTRICTED;              /*                       @ZA33246*/
*   RSAVLA=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLA                                          0385
*   RESPECIFY                                                      0386
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   MWAMTCNT=0;                     /* INIT COUNT OF UCB'S THAT    0387
*                                      NEEDED MOUNTING       @ZA33246*/
         SLR   @11,@11                                             0387
         ST    @11,MWAMTCNT                                        0387
*   MWAJS3CT=0;                     /* INIT COUNT OF VOLUMES       0388
*                                      CONTROLLED BY JES3    @ZA33246*/
         ST    @11,MWAJS3CT                                        0388
*   MWASWTCH=OFF;                   /* INIT SWITCH TO ZERO   @ZA33246*/
         NI    MWASWTCH,B'01111111'                                0389
*   IF VVOLLEOV=ON THEN             /* IS THIS AN EOV REQ    @Z30SSJH*/
         L     @11,VOLLPTR                                         0390
         TM    VVOLLEOV(@11),B'00001000'                           0390
         BNO   @RF00390                                            0390
*     CALL VMTSCAN;                 /* YES, SCAN THE VMT'S   @Z30SSJH*/
         BAL   @14,VMTSCAN                                         0391
*   ELSE                            /* NOT AN EOV REQUEST    @Z30SSJH*/
*     VMTHIT=OFF;                   /* IND VOLUME NOT IN VMT @Z30SSJH*/
         B     @RC00390                                            0392
@RF00390 NI    VMTHIT,B'10111111'                                  0392
*   IF VMTHIT=OFF THEN              /* IF VOLUME NOT IN VMT  @Z30SSJH*/
@RC00390 TM    VMTHIT,B'01000000'                                  0393
         BNZ   @RF00393                                            0393
*     DO C1=1 TO VVOLLNBR;          /* LOOP THRU VOLUME LIST         */
         LA    @11,1                                               0394
         B     @DE00394                                            0394
@DL00394 DS    0H                                                  0395
*       DO C2=1 TO VUCBLNBR WHILE MWASWTCH=OFF;/* LOOP THRU UCB LIST
*                                      LOOKING FOR THE VOLSER MOUNTED
*                                      ON A UCB              @ZA33246*/
         LA    @11,1                                               0395
         B     @DE00395                                            0395
@DL00395 TM    MWASWTCH,B'10000000'                                0395
         BNZ   @DC00395                                            0395
*         IF VUCBLALC(C2)=OFF THEN  /* IF UCB IS NOT ALLOCATED       */
         L     @05,UCBLPTR                                         0396
         SLA   @11,2                                               0396
         ST    @11,@TF00001                                        0396
         ALR   @11,@05                                             0396
         TM    VUCBLALC-4(@11),B'10000000'                         0396
         BNZ   @RF00396                                            0396
*           DO;                                                    0397
*             RUCB=VUCBLADR(C2);    /* LOAD POINTER TO UCB           */
         L     @01,@TF00001                                        0398
         L     RUCB,VUCBLADR-5(@01,@05)                            0398
         LA    RUCB,0(,RUCB)                                       0398
*             IF UCBVOLI=VVOLLVSR(C1) THEN/* IF VOLSER MATCH         */
         L     @11,C1                                              0399
         MH    @11,@CH00033                                        0399
         L     @05,VOLLPTR                                         0399
         ALR   @05,@11                                             0399
         CLC   UCBVOLI(6,RUCB),VVOLLVSR-12(@05)                    0399
         BNE   @RF00399                                            0399
*               DO;                                                0400
*                 CALL SETLOCK;     /* GET THE LOCAL LOCK    @Y021130*/
         BAL   @14,SETLOCK                                         0401
*                 IF UCBVOLI=VVOLLVSR(C1) THEN/* IF MATCH STILL      */
         L     @11,VOLLPTR                                         0402
         L     @05,C1                                              0402
         MH    @05,@CH00033                                        0402
         ST    @05,@TF00001                                        0402
         ALR   @05,@11                                             0402
         CLC   UCBVOLI(6,RUCB),VVOLLVSR-12(@05)                    0402
         BNE   @RF00402                                            0402
*                   DO;                                            0403
*                     IF UCBMOUNT=OFF THEN/* IS VOLUME MOUNTED       */
         TM    UCBMOUNT(RUCB),B'10000000'                          0404
         BNZ   @RF00404                                            0404
*                       VVOLLMNT(C1)=ON;/* YES INDICATE SUCH         */
         AL    @11,@TF00001                                        0405
         OI    VVOLLMNT-12(@11),B'10000000'                        0405
*                     ELSE          /* NO                            */
*                       VVOLLVFY(C1)=ON;/* INDIC VERIFY NEEDED       */
         B     @RC00404                                            0406
@RF00404 L     @11,C1                                              0406
         MH    @11,@CH00033                                        0406
         L     @05,VOLLPTR                                         0406
         ALR   @05,@11                                             0406
         OI    VVOLLVFY-12(@05),B'01000000'                        0406
*                     MWASWTCH=ON;  /* IND UCB FOUND         @ZA33246*/
*                                                                  0407
@RC00404 OI    MWASWTCH,B'10000000'                                0407
*                     /***********************************************/
*                     /*                                             */
*                     /* BUMP OPEN COUNT USING CS INST FOR INSURANCE */
*                     /*                                     @Y021130*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0408
*                     RFY                                          0408
*                      (R0,                                        0408
*                       R1,                                        0408
*                       R14) RSTD;                                 0408
*                     R14=(ADDR(UCBDMCT)/4)*4;/* ADDR ROUNDED BACK TO
*                                      WORD                          */
         LA    R14,UCBDMCT(,RUCB)                                  0409
         SRL   R14,2                                               0409
         SLA   R14,2                                               0409
*CSLOOP:                            /* LOOP ON CS INST       @Y021130*/
*                     GEN(L    R0,0(R14));/* LOAD COUNT      @Y021130*/
CSLOOP   L    R0,0(R14)
*                     R1=R0;        /* SET UP FOR CS         @Y021130*/
         LR    R1,R0                                               0411
*                     R1=R1+1;      /* BUMP OPEN COUNT       @Y021130*/
         AL    R1,@CF00062                                         0412
*                     GEN(CS   R0,R1,0(R14));/* COMPARE AND SWAP   0413
*                                                            @Y021130*/
         CS   R0,R1,0(R14)
*                     GEN(BNE  CSLOOP);/* BR NO COMPARE      @Y021130*/
         BNE  CSLOOP
*                     RFY                                          0415
*                      (R0,                                        0415
*                       R1,                                        0415
*                       R14) UNRSTD;/*                       @Y021130*/
*                     VVOLLUCB(C1)=RUCB;/* COPY POINTER TO UCB       */
         L     @11,C1                                              0416
         MH    @11,@CH00033                                        0416
         L     @05,VOLLPTR                                         0416
         ST    RUCB,VVOLLUCB-12(@11,@05)                           0416
*                     VUCBLALC(C2)=ON;/* NOTE UCB ALLOCATED          */
         L     @11,C2                                              0417
         SLA   @11,2                                               0417
         L     @05,UCBLPTR                                         0417
         ALR   @05,@11                                             0417
         OI    VUCBLALC-4(@05),B'10000000'                         0417
*                   END;                                           0418
*                 CALL FREELOCK;    /* FREE THE LOCAL LOCK           */
@RF00402 BAL   @14,FREELOCK                                        0419
*               END;                /* END OF VOLSER MATCH LOGIC.  0420
*                                                            @Y30DSMD*/
*           END;                    /* END OF UCB NOT ALLOCATED    0421
*                                      LOGIC.                @Y30DSMD*/
@RF00399 DS    0H                                                  0422
*       END;                        /* END OF UCB LIST LOOP. @Y30DSMD*/
@RF00396 LA    @11,1                                               0422
         AL    @11,C2                                              0422
@DE00395 ST    @11,C2                                              0422
         L     @05,UCBLPTR                                         0422
         CH    @11,VUCBLNBR(,@05)                                  0422
         BNH   @DL00395                                            0422
@DC00395 DS    0H                                                  0423
*       IF MWASWTCH=OFF THEN        /* UCB NOT FOUND         @ZA33246*/
         TM    MWASWTCH,B'10000000'                                0423
         BNZ   @RF00423                                            0423
*         DO;                       /*                       @ZA33246*/
*           MWAMTCNT=MWAMTCNT+1;    /* INCREMENT THE COUNT OF VOLUMES
*                                      THAT NEEDED MOUNTING  @ZA33246*/
         LA    @11,1                                               0425
         L     @05,MWAMTCNT                                        0425
         ALR   @05,@11                                             0425
         ST    @05,MWAMTCNT                                        0425
*           IF UCBJES3=ON&UCBVRDEV=ON THEN/* MSS JES3 UCB    @ZA33246*/
         TM    UCBJES3(RUCB),B'11000000'                           0426
         BNO   @RF00426                                            0426
*             MWAJS3CT=MWAJS3CT+1;  /* INCREMENT THE COUNT OF JES3 0427
*                                      CONTROLLER MOUNT      @ZA33246*/
         AL    @11,MWAJS3CT                                        0427
         ST    @11,MWAJS3CT                                        0427
*         END;                      /*                       @ZA33246*/
*       ELSE                        /* UCB FOUND             @ZA33246*/
*         MWASWTCH=OFF;             /* RESET WORK SWITCH     @ZA33246*/
         B     @RC00423                                            0429
@RF00423 NI    MWASWTCH,B'01111111'                                0429
*     END;                          /* END OF VOL LIST LOOP. @Y30DSMD*/
@RC00423 LA    @11,1                                               0430
         AL    @11,C1                                              0430
@DE00394 ST    @11,C1                                              0430
         L     @05,VOLLPTR                                         0430
         CH    @11,VVOLLNBR(,@05)                                  0430
         BNH   @DL00394                                            0430
*   RESPECIFY                                                      0431
*     RET RESTRICTED;               /*                       @ZA33246*/
@RF00393 DS    0H                                                  0432
*   RET=RSAVLA;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLA                                          0432
*   RESPECIFY                                                      0433
*    (R6,                                                          0433
*     R7,                                                          0433
*     R8,                                                          0433
*     R9,                                                          0433
*     RET) UNRESTRICTED;            /*                       @ZA33246*/
*   END DTMOUNT;                                                   0434
@EL00002 DS    0H                                                  0434
@EF00002 DS    0H                                                  0434
@ER00002 BR    @14                                                 0434
*GOMOUNT:                                                          0435
*                                                                  0435
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  SCANS UCB LIST FOR AVAILABLE UCB'S AND CALLS       */
*/*               ALOCUNIT TO MOUNT VOLUMES.                         */
*/*   INPUT -     1. ADDRESS OF UCB LIST IN VUCBLVLA                 */
*/*               2. ADDRESS OF UCB IN VUCBLADR                      */
*/*   OUTPUT  -   1. VOLUMES MOUNTED AND VERIFIED                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0435
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0435
GOMOUNT  DS    0H                                                  0436
*   RESPECIFY                                                      0436
*    (R11,                                                         0436
*     RET) RESTRICTED;              /*                       @ZA33246*/
*   RSAVLA=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLA                                          0437
*   RESPECIFY                                                      0438
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   DO C1=1 TO VVOLLNBR;            /* LOOP THRU VOLUME LIST         */
         LA    @05,1                                               0439
         B     @DE00439                                            0439
@DL00439 DS    0H                                                  0440
*     IF VVOLLMNT(C1)=OFF&VVOLLVFY(C1)=OFF THEN/* IF MOUNT MSG NEED  */
         MH    @05,@CH00033                                        0440
         L     @01,VOLLPTR                                         0440
         ALR   @01,@05                                             0440
         TM    VVOLLMNT-12(@01),B'11000000'                        0440
         BNZ   @RF00440                                            0440
*       DO C2=1 TO VUCBLNBR WHILE(VVOLLVFY(C1)=OFF);/* LOOP THRU UCBL*/
         LA    @05,1                                               0441
         B     @DE00441                                            0441
@DL00441 L     @14,VOLLPTR                                         0441
         L     @09,C1                                              0441
         MH    @09,@CH00033                                        0441
         ALR   @09,@14                                             0441
         TM    VVOLLVFY-12(@09),B'01000000'                        0441
         BNZ   @DC00441                                            0441
*         IF VUCBLALC(C2)=OFF&      /* SKIP IF UCB ALREADY USED OR   */
*             VUCBLBAD(C2)=OFF THEN /* IF UCB UNUSABLE               */
         L     @09,UCBLPTR                                         0442
         SLA   @05,2                                               0442
         ST    @05,@TF00001                                        0442
         ALR   @05,@09                                             0442
         TM    VUCBLALC-4(@05),B'11000000'                         0442
         BNZ   @RF00442                                            0442
*           DO;                                                    0443
*             RUCB=VUCBLADR(C2);    /* LOAD UCB ADDRESS FR UCB LIST  */
         L     @05,@TF00001                                        0444
         L     RUCB,VUCBLADR-5(@05,@09)                            0444
         LA    RUCB,0(,RUCB)                                       0444
*             IF VVOLLEOV=ON THEN   /* IF CALLER IS EOV      @Y30DSMD*/
         TM    VVOLLEOV(@14),B'00001000'                           0445
         BNO   @RF00445                                            0445
*               DO;                 /* CONTINUE              @Y30DSMD*/
*                 CALL EOVDMT;      /* EOV DISMOUNT CHK      @Y30DSMD*/
         BAL   @14,EOVDMT                                          0447
*                 R11=1;            /* COMPARE TO UCB USE CNT      0448
*                                                            @Y30DSMD*/
         LA    R11,1                                               0448
*               END;                /*                       @Y30DSMD*/
*             CALL SETLOCK;         /* SET THE LOCAL LOCK    @Y021130*/
@RF00445 BAL   @14,SETLOCK                                         0450
*             IF UCBVOLI^='000000000000'X THEN/* IF UCB USED         */
         CLC   UCBVOLI(6,RUCB),@CB04476                            0451
         BE    @RF00451                                            0451
*               IF UCBRESV=OFF&UCBPRES=OFF&UCBSYSR=OFF&UCBBSVL=ON&/*
*                                      IF VOLUME DISMOUNTABLE        */
*                   (EOVDM=ON|(VVOLLEOV=OFF&UCBDMCT=0)) THEN/* IS  0452
*                                      VOLUME UNUSED         @Z30SSJH*/
         TM    UCBRESV(RUCB),B'00100110'                           0452
         BNZ   @RF00452                                            0452
         TM    UCBBSVL(RUCB),B'10000000'                           0452
         BNO   @RF00452                                            0452
         TM    EOVDM,B'00100000'                                   0452
         BO    @RT00452                                            0452
         L     @05,VOLLPTR                                         0452
         TM    VVOLLEOV(@05),B'00001000'                           0452
         BNZ   @RF00452                                            0452
         CLI   UCBDMCT(RUCB),0                                     0452
         BNE   @RF00452                                            0452
@RT00452 DS    0H                                                  0453
*                 DO;               /* YES                           */
*                   DMSG=ON;        /* IND NEED FOR DISMOUNT MESSAGE */
         OI    DMSG,B'00000001'                                    0454
*                   CALL ALOCUNIT;  /* CALL FOR MOUNT OF VOLUME      */
         BAL   @14,ALOCUNIT                                        0455
*                 END;                                             0456
*               ELSE                /* VOLUME NOT DISMOUNTABLE     0457
*                                                            @Z30SSRL*/
*                 VUCBLBAD(C2)=ON;  /* UNIT IS UNUSABLE              */
         B     @RC00452                                            0457
@RF00452 L     @05,C2                                              0457
         SLA   @05,2                                               0457
         L     @01,UCBLPTR                                         0457
         ALR   @01,@05                                             0457
         OI    VUCBLBAD-4(@01),B'01000000'                         0457
*             ELSE                  /* UCB IS UNUSED                 */
*               DO;                                                0458
         B     @RC00451                                            0458
@RF00451 DS    0H                                                  0459
*                 DMSG=OFF;         /* NO DISMOUNT MSG               */
         NI    DMSG,B'11111110'                                    0459
*                 CALL ALOCUNIT;    /* CALL FOR MOUNT OF VOLUME      */
         BAL   @14,ALOCUNIT                                        0460
*               END;                                               0461
*             CALL FREELOCK;        /* FREE THE LOCAL LOCK           */
@RC00451 BAL   @14,FREELOCK                                        0462
*           END;                                                   0463
*       END;                                                       0464
@RF00442 LA    @05,1                                               0464
         AL    @05,C2                                              0464
@DE00441 ST    @05,C2                                              0464
         L     @01,UCBLPTR                                         0464
         CH    @05,VUCBLNBR(,@01)                                  0464
         BNH   @DL00441                                            0464
@DC00441 DS    0H                                                  0465
*   END;                                                           0465
@RF00440 LA    @05,1                                               0465
         AL    @05,C1                                              0465
@DE00439 ST    @05,C1                                              0465
         L     @01,VOLLPTR                                         0465
         CH    @05,VVOLLNBR(,@01)                                  0465
         BNH   @DL00439                                            0465
*   RESPECIFY                                                      0466
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RET=RSAVLA;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLA                                          0467
*   RESPECIFY                                                      0468
*    (R11,                                                         0468
*     RET) UNRESTRICTED;            /*                       @ZA33246*/
*   END GOMOUNT;                                                   0469
@EL00003 DS    0H                                                  0469
@EF00003 DS    0H                                                  0469
@ER00003 BR    @14                                                 0469
*GOVERIFY:                                                         0470
*                                                                  0470
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  VERIFY THE LABEL ON MOUNTED VOLUME.                */
*/*   OUTPUT  -   1. CONTROL BLOCK WORK AREA FOR I/O                 */
*/*   INPUT  -    1. VOLUME LABEL READ INTO DXCB                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0470
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0470
GOVERIFY DS    0H                                                  0471
*   RESPECIFY                                                      0471
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLA=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLA                                          0472
*   RESPECIFY                                                      0473
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   DXCB=DXCB&&DXCB;                /* ZERO CONTROL BLOCK AREA       */
*                                                                  0474
         XC    DXCB(200),DXCB                                      0474
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP CONTROL BLOCK BASES AND BUILD CHANNEL PROGRAMS         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0475
*   IOBSTPTR=ADDR(DXCB);            /* IOB IS FIRST IN CB            */
         LA    @11,DXCB                                            0475
         ST    @11,IOBSTPTR                                        0475
*   DEBPTR=IOBSTPTR+LENGTH(IOBSTDRD);/* DEB IS SECOND                */
         LA    @14,32                                              0476
         LR    @09,@11                                             0476
         ALR   @09,@14                                             0476
         ST    @09,DEBPTR                                          0476
*   DCBPTR=DEBPTR+LENGTH(DEBBASIC); /* DCB IS THIRD                  */
         ALR   @14,@09                                             0477
         LR    DCBPTR,@14                                          0477
*   DCBDEBAD=ADDR(DEBBASIC);        /* DCB POINTS TO DEB             */
         STCM  @09,15,DCBDEBAD(DCBPTR)                             0478
*   DEBAPPAD=CVTXAPG;               /* SET IOS APPENDAGE VECTOR TBL
*                                      ADDR                          */
         L     @01,CVTPTR                                          0479
         L     @08,CVTXAPG(,@01)                                   0479
         ST    @08,DEBAPPAD(,@09)                                  0479
*   DEBEXSCL='04'X;                 /* SET EXTENT SCALE              */
         MVI   DEBEXSCL(@09),X'04'                                 0480
*   DEBDCBB=ADDR(IHADCB);           /* DEB POINTS TO DCB             */
         STCM  DCBPTR,7,DEBDCBB(@09)                               0481
*   DEBDEBID=IDXDEB;                /* SET DEB ID                    */
         MVI   DEBDEBID(@09),B'00001111'                           0482
*   DEBNMEXT=1;                     /* SET EXTENT NUMBER             */
         MVI   DEBNMEXT(@09),X'01'                                 0483
*   IOBUNREL=ON;                    /* SET NON-SEQUENTIAL BIT        */
         OI    IOBUNREL(@11),B'00000010'                           0484
*   IOBDCBPT=ADDR(IHADCB);          /* IOB POINTS TO DCB             */
         ST    DCBPTR,IOBDCBPT(,@11)                               0485
*   IOBECBPT=ADDR(DXECB);           /* IOB POINTS TO ECB             */
         LA    @05,DXECB                                           0486
         ST    @05,IOBECBPT(,@11)                                  0486
*   IOBSTART=ADDR(DXCCW1);          /* IOB POINTS TO FIRST CCW       */
         LA    @05,DXCCW1                                          0487
         ST    @05,IOBSTART(,@11)                                  0487
*   DEBDAPTR=ADDR(DEBBASND);                                       0488
         LA    @11,DEBBASND(,@09)                                  0488
         ST    @11,DEBDAPTR                                        0488
*   DXCCW1=DXCCW1&&DXCCW1;          /* ZERO CCW1                     */
         XC    DXCCW1(8),DXCCW1                                    0489
*   DXCCW2=DXCCW1;                  /* ZERO CCW2                     */
         MVC   DXCCW2(8),DXCCW1                                    0490
*   DXCCW3=DXCCW2;                  /* ZERO CCW3                     */
         MVC   DXCCW3(8),DXCCW2                                    0491
*   DXCCW1(1:4)=ADDR(DXDADDR)+3;                                   0492
         LA    @05,DXDADDR                                         0492
         AL    @05,@CF00032                                        0492
         STCM  @05,15,DXCCW1                                       0492
*   DXCCW1(1)='31'X;                /* SET SEARCH ID COMMAND CODE    */
         MVI   DXCCW1,X'31'                                        0493
*   DXCCW1(5)='40'X;                /* SET COMMAND CHAIN BIT         */
         MVI   DXCCW1+4,X'40'                                      0494
*   DXCCW1(8)='05'X;                /* SET LENGTH                    */
         MVI   DXCCW1+7,X'05'                                      0495
*   DXCCW2(1:4)=ADDR(DXCCW1);                                      0496
         LA    @05,DXCCW1                                          0496
         STCM  @05,15,DXCCW2                                       0496
*   DXCCW2(1)='08'X;                /* SET TIC COMMAND CODE          */
         MVI   DXCCW2,X'08'                                        0497
*   DXCCW2(5)='40'X;                /* SET COMMAND CHAIN BIT         */
         MVI   DXCCW2+4,X'40'                                      0498
*   DXCCW3(1:4)=ADDR(DXLBL);        /* SET ADDRESS OF READ DATA      */
         LA    @05,DXLBL                                           0499
         STCM  @05,15,DXCCW3                                       0499
*   DXCCW3(1)='06'X;                /* SET READ COMMAND CODE         */
         MVI   DXCCW3,X'06'                                        0500
*   DXCCW3(8)='50'X;                /* SET LENGTH OF DATA            */
         MVI   DXCCW3+7,X'50'                                      0501
*   DEBSTRCC(1:2)='0000'X;          /* ZERO STARTING CYLINDER        */
         MVC   DEBSTRCC(2,@11),@CB04489                            0502
*   DEBSTRHH(1:2)='0000'X;          /* ZERO STARTING HEAD            */
         MVC   DEBSTRHH(2,@11),@CB04489                            0503
*   DEBENDHH(1:2)='0000'X;          /* ZERO ENDING HEAD              */
         MVC   DEBENDHH(2,@11),@CB04489                            0504
*   DEBENDCC(1:2)='7FFF'X;          /* SET END CYLINDER NUMBER       */
         MVC   DEBENDCC(2,@11),@CB04490                            0505
*   DEBNMTRK(1:2)='7FFF'X;          /* SET NUMBER OF TRACKS          */
         MVC   DEBNMTRK(2,@11),@CB04490                            0506
*                                                                  0507
*   /*****************************************************************/
*   /*                                                               */
*   /* VERIFY THE VOLUMES THAT HAVE BEEN MOUNTED                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0507
*   DO C1=1 TO VVOLLNBR;            /* LOOP THRU VOLUME LIST         */
         LA    @11,1                                               0507
         B     @DE00507                                            0507
@DL00507 DS    0H                                                  0508
*     IF VVOLLVFY(C1)=ON THEN       /* IF VOL NEEDS VERIFICATION     */
         L     @05,VOLLPTR                                         0508
         MH    @11,@CH00033                                        0508
         ST    @11,@TF00001                                        0508
         ALR   @11,@05                                             0508
         TM    VVOLLVFY-12(@11),B'01000000'                        0508
         BNO   @RF00508                                            0508
*       DO;                                                        0509
*         RUCB=VVOLLUCB(C1);        /* LOAD PTR TO UCB               */
         L     @01,@TF00001                                        0510
         L     RUCB,VVOLLUCB-12(@01,@05)                           0510
*         UCBAMV=OFF;               /* IND TIME STAMP CK     @Y30LSPS*/
         NI    UCBAMV(RUCB),B'10111111'                            0511
*         IF VVOLLOPE=ON THEN       /* IF CALL FROM OPEN     @Y30LSPS*/
         TM    VVOLLOPE(@05),B'00010000'                           0512
         BNO   @RF00512                                            0512
*           ERFLSAVE=ACBERFLG;      /* SAVE CURRENT ERR FLG  @Y30LSPS*/
         IC    @11,ACBERFLG(,RACB)                                 0513
         STC   @11,ERFLSAVE                                        0513
*         DO WHILE(VVOLLMNT(C1)=OFF);/* VERIFY VOL                   */
@RF00512 B     @DE00514                                            0514
@DL00514 DS    0H                                                  0515
*           DEBUCBA=RUCB;           /* INIT UCB ADDR IN WKA          */
         L     @11,DEBDAPTR                                        0515
         STCM  RUCB,7,DEBUCBA(@11)                                 0515
*           DXECB=DXECB&&DXECB;     /* ZERO ECB                      */
         XC    DXECB(4),DXECB                                      0516
*           DXDADDR(1:8)='0000000000000003'X;/* SET SEARCH ID        */
         MVC   DXDADDR(8),@CB04491                                 0517
*           RESPECIFY                                              0518
*             R1 RESTRICTED;                                       0518
*           R1=ADDR(IOBSTDRD);                                     0519
         L     R1,IOBSTPTR                                         0519
*           GEN(EXCP (1));          /* START THE I/O                 */
         EXCP (1)
*           GEN(WAIT ECB=DXECB);    /* WAIT FOR COMPLETION           */
         WAIT ECB=DXECB
*           RESPECIFY                                              0522
*             R1 UNRESTRICTED;                                     0522
*           IF DXECB(1)^='7F'X THEN /* IF ANY ERROR                  */
         CLI   DXECB,X'7F'                                         0523
         BE    @RF00523                                            0523
*             DO;                                                  0524
*               IF VVOLLOPE=ON THEN /* IF CALL FROM OPEN             */
         L     @11,VOLLPTR                                         0525
         TM    VVOLLOPE(@11),B'00010000'                           0525
         BNO   @RF00525                                            0525
*                 ACBERFLG=OPERR164;/* SET ERROR FLAG                */
         MVI   ACBERFLG(RACB),X'A4'                                0526
*               IF UCB2OPT4=ON THEN /* CK IF VIRTUAL DEV     @Y30LSPS*/
@RF00525 TM    UCB2OPT4(RUCB),B'00001000'                          0527
         BNO   @RF00527                                            0527
*                 DO;               /* SPECIAL IF VIRTUAL    @Y30LSPS*/
*                   MAINLEN=LENGTH(DMNTLST);/* GET CORE      @Y30LSPS*/
         MVC   MAINLEN(3),@CF00084+1                               0529
*                   CALL GETMAIN;   /* GO GET CORE           @Y30LSPS*/
         BAL   @14,GETMAIN                                         0530
*                   RESPECIFY                                      0531
*                    (R0,                                          0531
*                     R1,                                          0531
*                     R11,                                         0531
*                     R15) RESTRICTED;/*                     @Y30LSPS*/
*                   R1=MAINADDR;    /* POINT TO CORE         @Y30LSPS*/
         L     R1,MAINADDR                                         0532
*                   R15=ADDR(UCBVOLI);/* POINT TO VOLSER     @Y30LSPS*/
         LA    R15,UCBVOLI(,RUCB)                                  0533
*                   R11=ADDR(UCBCHA);/* POINT TO ADDRESS     @Y30LSPS*/
         LA    R11,UCBCHA(,RUCB)                                   0534
*                   GEN                                            0535
*(ICBMNTDE MF=(E,(R1)),TYPE=DMNT,VOLID=(R15),VUA=(R11));           0535
         ICBMNTDE MF=(E,(R1)),TYPE=DMNT,VOLID=(R15),VUA=(R11)
*                   R0=LENGTH(DMNTLST);/* GET LENGTH         @Y30LSPS*/
         LA    R0,28                                               0536
*                   R1=MAINADDR;    /* POINT TO LIST AGAIN   @Y30LSPS*/
         L     R1,MAINADDR                                         0537
*                   GEN(FREEMAIN R,LV=(0),A=(1));/*          @Y30LSPS*/
         FREEMAIN R,LV=(0),A=(1)
*                   RESPECIFY                                      0539
*                    (R0,                                          0539
*                     R1,                                          0539
*                     R11,                                         0539
*                     R15) UNRESTRICTED;/*                   @Y30LSPS*/
*                   VVOLLCNT=C1;    /* INDIC VOL NUMBER      @Y30LSPS*/
         L     @11,C1                                              0540
         L     @05,VOLLPTR                                         0540
         STC   @11,VVOLLCNT(,@05)                                  0540
*                   VVOLLPDC=PP116; /* I/O ERROR ON VOLID    @Y30LSPS*/
         MVI   VVOLLPDC(@05),X'74'                                 0541
*                   VVOLLVFY(C1)=OFF;/* INHIBIT VERIFICATON  @Y30LSPS*/
*                   VVOLLMNT(C1)=OFF;/* IND NOT MOUNTED      @Y30LSPS*/
         MH    @11,@CH00033                                        0543
         ALR   @05,@11                                             0543
         NI    VVOLLVFY-12(@05),B'00111111'                        0543
*                   UCBMOUNT=OFF;   /* NOT MOUNTED IN UCB    @Y30LSPS*/
         NI    UCBMOUNT(RUCB),B'01111111'                          0544
*                   UCBDMCT=0;      /* NO DATA MGT COUNT     @Y30LSPS*/
         MVI   UCBDMCT(RUCB),X'00'                                 0545
*                   UCBVOLI=UCBVOLI&&UCBVOLI;/* CLEAR VOL    @Y30LSPS*/
         XC    UCBVOLI(6,RUCB),UCBVOLI(RUCB)                       0546
*                   IF EOVDM=ON THEN/* VMT ENTRY FOUND       @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   0547
         BNO   @RF00547                                            0547
*                     DO;           /*                       @Y30DSMD*/
*                       VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* YES,
*                                      CLEAR                 @Y30DSMD*/
         L     @11,VMTPT                                           0549
         SLR   @05,@05                                             0549
         IC    @05,CTR                                             0549
         SLA   @05,4                                               0549
         ST    @05,@TF00001                                        0549
         ALR   @05,@11                                             0549
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    0549
*                       VMTUCB(CTR)=RUCB;/* INIT UCB PTR     @Y30DSMD*/
         L     @05,@TF00001                                        0550
         ST    RUCB,VMTUCB-16(@05,@11)                             0550
*                     END;          /*                       @Y30DSMD*/
*                   GOTO EXIT;      /* QUIT WITH ERROR       @Y30LSPS*/
         B     EXIT                                                0552
*                 END;              /* END IF VIRTUAL ERROR  @Y30LSPS*/
*               ELSE                /* IS NORMAL DEVICE ERR  @Y30LSPS*/
*                 DO;               /* NORMAL DEVICE MNT ER  @Y30LSPS*/
@RF00527 DS    0H                                                  0555
*                   MSGDPTR=ADDR(M14E);/* POINT TO SHORT DISMOUNT MSG*/
         LA    @11,M14E                                            0555
         ST    @11,MSGDPTR                                         0555
*                   CALL SEND;      /* SEND THE MESSAGE              */
         BAL   @14,SEND                                            0556
*                   UCBNOTRD=ON;    /* MASK UCB NOT READY            */
         OI    UCBNOTRD(RUCB),B'01000000'                          0557
*                   CALL MOUNT;     /* REISSUE MOUNT MSG             */
         BAL   @14,MOUNT                                           0558
*                 END;              /* END NORMAL DEVICE     @Y30LSPS*/
*             END;                                                 0560
*           ELSE                    /* IF NO I/O ERROR               */
*             DO;                                                  0561
         B     @RC00523                                            0561
@RF00523 DS    0H                                                  0562
*               IF VVOLLOPE=ON THEN /* IF CALL FROM OPEN             */
         L     @11,VOLLPTR                                         0562
         TM    VVOLLOPE(@11),B'00010000'                           0562
         BNO   @RF00562                                            0562
*                 DO;                                              0563
*                   ACBERFLG=ERFLSAVE;/* RESTORE ACB ERROR FLAG      */
         IC    @11,ERFLSAVE                                        0564
         STC   @11,ACBERFLG(,RACB)                                 0564
*                 END;                                             0565
*               IF VOLSERNO=UCBVOLI THEN/* IF VOL SER MATCH  @Z30SSRL*/
@RF00562 CLC   VOLSERNO(6),UCBVOLI(RUCB)                           0566
         BNE   @RF00566                                            0566
*                 DO;                                              0567
*                   VVOLLMNT(C1)=ON;/* MASK VOLUME AS MOUNTED        */
*                                                                  0568
         L     @11,C1                                              0568
         MH    @11,@CH00033                                        0568
         L     @05,VOLLPTR                                         0568
         ALR   @05,@11                                             0568
         OI    VVOLLMNT-12(@05),B'10000000'                        0568
*                   /*************************************************/
*                   /*                                               */
*                   /* CONVERT VTOC CCHHR TO TTR                     */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0569
*                   RESPECIFY                                      0569
*                     R11 RESTRICTED;                              0569
*                   R11=RACB;       /* SAVE POINTER TO ACB           */
         LR    R11,RACB                                            0570
*                   RESPECIFY                                      0571
*                    (R0,                                          0571
*                     R1,                                          0571
*                     R15) RESTRICTED;                             0571
*                   R15=ADDR(XRBESA(1));/* POINT TO A SAVE AREA      */
         L     @05,CVTPTR                                          0572
         L     @05,CVTTCBP(,@05)                                   0572
         L     @05,TCBPTR(,@05)                                    0572
         L     R15,TCBRBP(,@05)                                    0572
         LA    R15,XRBESA(,R15)                                    0572
*                   GEN(STM R9,R15,0(R15));/* SAVE REGISTERS 9-15    */
         STM R9,R15,0(R15)
*                   R1=ADDR(DEBBASIC);/* POINT TO WORK DEB           */
         L     R1,DEBPTR                                           0574
*                   RACB=ADDR(DXDADDR);/* POINT TO INPUT             */
         LA    RACB,DXDADDR                                        0575
*                   DXDADDR(4:8)=F4CCHHR;/* MOVE INPUT INTO INPUT  0576
*                                      AREA                          */
         MVC   DXDADDR+3(5),F4CCHHR                                0576
*                   R15=CVTPRLTV;   /* POINT TO CONVERION ROUTINE    */
         L     @05,CVTPTR                                          0577
         L     R15,CVTPRLTV(,@05)                                  0577
*                   GEN(BALR RET,R15);/* GO TO CONVERSION ROUTINE    */
         BALR RET,R15
*                   R15=ADDR(XRBESA(1));/* POINT TO REGISTER SAVE  0579
*                                      AREA                          */
         L     @05,CVTPTR                                          0579
         L     @05,CVTTCBP(,@05)                                   0579
         L     @05,TCBPTR(,@05)                                    0579
         L     R15,TCBRBP(,@05)                                    0579
         LA    R15,XRBESA(,R15)                                    0579
*                   GEN(LM R9,R15,0(R15));/* RESTORE REGISTERS 9-15  */
         LM R9,R15,0(R15)
*                   UCBVTOC=R0;     /* STORE RESULT                  */
         ST    R0,UCBVTOC(,RUCB)                                   0581
*                   RACB=R11;       /* RESTORE ACB ADDRESS           */
         LR    RACB,R11                                            0582
*                   RESPECIFY                                      0583
*                    (R0,                                          0583
*                     R1,                                          0583
*                     R11,                                         0583
*                     R15) UNRESTRICTED;                           0583
*                   UCBMOUNT=OFF;   /* SET MOUNT BIT OFF             */
         NI    UCBMOUNT(RUCB),B'01111111'                          0584
*                   CCHHRF4(C1)=F4CCHHR;/* COPY CCHHR FOR F4 FROM  0585
*                                      LABEL                         */
         L     @11,C1                                              0585
         MH    @11,@CH00882                                        0585
         L     @05,CCHHRPTR                                        0585
         ALR   @05,@11                                             0585
         AL    @05,@CF04580                                        0585
         MVC   CCHHRF4(5,@05),F4CCHHR                              0585
*                   CALL DOM;       /* DELETE WTO MESSAGE            */
         BAL   @14,DOM                                             0586
*                 END;                                             0587
*               ELSE                /* VOL SER DO NOT MATCH  @Z30SSRL*/
*                 DO;                                              0588
         B     @RC00566                                            0588
@RF00566 DS    0H                                                  0589
*                   IF UCB2OPT4=ON THEN/* CK IF VIRTUAL DEV  @Y30LSPS*/
         TM    UCB2OPT4(RUCB),B'00001000'                          0589
         BNO   @RF00589                                            0589
*                     DO;           /* NO RECOVERY IF VIRTL  @Y30LSPS*/
*                       MAINLEN=LENGTH(DMNTLST);/* GET LEN   @Y30LSPS*/
         MVC   MAINLEN(3),@CF00084+1                               0591
*                       CALL GETMAIN;/* GET CORE FOR DEMNT   @Y30LSPS*/
         BAL   @14,GETMAIN                                         0592
*                       RESPECIFY                                  0593
*                        (R0,                                      0593
*                         R1,                                      0593
*                         R11,                                     0593
*                         R15) RESTRICTED;                         0593
*                       R1=MAINADDR;/* POINT TO GOTTEN COR   @Y30LSPS*/
         L     R1,MAINADDR                                         0594
*                       R15=ADDR(UCBVOLI);/* POINT TO VOL    @Y30LSPS*/
         LA    R15,UCBVOLI(,RUCB)                                  0595
*                       R11=ADDR(UCBCHA);/* POINT TO ADDR    @Y30LSPS*/
         LA    R11,UCBCHA(,RUCB)                                   0596
*                       GEN                                        0597
*(ICBMNTDE MF=(E,(R1)),TYPE=DMNT,VOLID=(R15),VUA=(R11));           0597
         ICBMNTDE MF=(E,(R1)),TYPE=DMNT,VOLID=(R15),VUA=(R11)
*                       R0=LENGTH(DMNTLST);/* GET LENGTH     @Y30LSPS*/
         LA    R0,28                                               0598
*                       R1=MAINADDR;/* POINT TO CORE         @Y30LSPS*/
         L     R1,MAINADDR                                         0599
*                       GEN(FREEMAIN R,LV=(0),A=(1));/*      @Y30LSPS*/
         FREEMAIN R,LV=(0),A=(1)
*                       RESPECIFY                                  0601
*                        (R0,                                      0601
*                         R1,                                      0601
*                         R11,                                     0601
*                         R15) UNRESTRICTED;                       0601
*                       VVOLLCNT=C1;/* KEEP VOL IN ERROR     @Y30LSPS*/
         L     @11,C1                                              0602
         L     @05,VOLLPTR                                         0602
         STC   @11,VVOLLCNT(,@05)                                  0602
*                       VVOLLPDC=PP116;/* ERROR ON VOL LABEL @Y30LSPS*/
         MVI   VVOLLPDC(@05),X'74'                                 0603
*                       VVOLLVFY(C1)=OFF;/* INHIBIT VERIFTN  @Y30LSPS*/
*                       VVOLLMNT(C1)=OFF;/* IND NOT MOUNTED  @Y30LSPS*/
         MH    @11,@CH00033                                        0605
         ALR   @05,@11                                             0605
         NI    VVOLLVFY-12(@05),B'00111111'                        0605
*                       UCBMOUNT=OFF;/* NOT MOUNTED IN UCB   @Y30LSPS*/
         NI    UCBMOUNT(RUCB),B'01111111'                          0606
*                       UCBVOLI=UCBVOLI&&UCBVOLI;/* CLEAR V  @Y30LSPS*/
         XC    UCBVOLI(6,RUCB),UCBVOLI(RUCB)                       0607
*                       IF EOVDM=ON THEN/* VMT ENTRY FOUND   @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   0608
         BNO   @RF00608                                            0608
*                         DO;       /*                       @Y30DSMD*/
*                           VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/*
*                                      YES, CLEAR            @Y30DSMD*/
         L     @11,VMTPT                                           0610
         SLR   @05,@05                                             0610
         IC    @05,CTR                                             0610
         SLA   @05,4                                               0610
         ST    @05,@TF00001                                        0610
         ALR   @05,@11                                             0610
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    0610
*                           VMTUCB(CTR)=RUCB;/* INIT UCB PTR @Y30DSMD*/
         L     @05,@TF00001                                        0611
         ST    RUCB,VMTUCB-16(@05,@11)                             0611
*                         END;      /*                       @Y30DSMD*/
*                       UCBDMCT=0;  /* NO DATA MGT COUNT     @Y30LSPS*/
@RF00608 MVI   UCBDMCT(RUCB),X'00'                                 0613
*                       GOTO EXIT;  /* EXIT WITH ERROR       @Y30LSPS*/
         B     EXIT                                                0614
*                     END;          /* END IF WRONG VIRTUAL  @Y30LSPS*/
*                   ELSE            /* WRONG NORMAL VOLID    @Y30LSPS*/
*                     DO;           /* ASK AGAIN FOR THE VOL @Y30LSPS*/
@RF00589 DS    0H                                                  0617
*                       RVOL=VOLSERNO;/* SET VOL SER         @Z30SSRL*/
         MVC   RVOL(6),VOLSERNO                                    0617
*                       CALL DISMOUNT;/* TRY DISMOUNT VOLUME @Z30SSRL*/
         BAL   @14,DISMOUNT                                        0618
*                       CALL MOUNT; /* REMOUNT THE VOLUME    @Z30SSRL*/
         BAL   @14,MOUNT                                           0619
*                     END;          /* END TRY AGAIN         @Y30LSPS*/
*                 END;                                             0621
*             END;                                                 0622
@RC00566 DS    0H                                                  0623
*         END;                                                     0623
@RC00523 DS    0H                                                  0623
@DE00514 L     @11,C1                                              0623
         MH    @11,@CH00033                                        0623
         L     @05,VOLLPTR                                         0623
         ALR   @05,@11                                             0623
         TM    VVOLLMNT-12(@05),B'10000000'                        0623
         BZ    @DL00514                                            0623
*         IF UCBJES3=ON&UCBVRDEV=ON THEN/* MSS JES3 UCB      @ZA33246*/
         TM    UCBJES3(RUCB),B'11000000'                           0624
         BNO   @RF00624                                            0624
*           DO;                     /*                       @ZA33246*/
*             SSMOPUAD=ADDR(UCBNAME);/* GET UCB UNIT ADDRESS @ZA33246*/
         L     @11,MWASSMO                                         0626
         LA    @05,UCBNAME(,RUCB)                                  0626
         ST    @05,SSMOPUAD(,@11)                                  0626
*             SSMOPVOL=ADDR(UCBVOLI);/* GET NEW MOUNTED VOLID      0627
*                                                            @ZA33246*/
         LA    @05,UCBVOLI(,RUCB)                                  0627
         ST    @05,SSMOPVOL(,@11)                                  0627
*             RESPECIFY                                            0628
*              (R1,                                                0628
*               R15) RESTRICTED;    /*                       @ZA33246*/
*             R1=ADDR(MWAJS3PM);    /* PT TO ADDR PARM LIST  @ZA33246*/
         LA    R1,MWAJS3PM                                         0629
*             GEN(IEFSSREQ);        /* ISSUE MACRO REQUEST   @ZA33246*/
         IEFSSREQ
*             IF R15^=0|SSOBRETN^=0 THEN/* ERROR             @ZA33246*/
         SLR   @14,@14                                             0631
         CR    R15,@14                                             0631
         BNE   @RT00631                                            0631
         L     @11,MWASSOB-1                                       0631
         C     @14,SSOBRETN(,@11)                                  0631
         BE    @RF00631                                            0631
@RT00631 DS    0H                                                  0632
*               DO;                 /*                       @ZA33246*/
*                 VVOLLFNC=PDF24;   /* SET JES3 FUNCTION CODE      0633
*                                                            @ZA33246*/
         L     @14,VOLLPTR                                         0633
         MVI   VVOLLFNC(@14),X'18'                                 0633
*                 VVOLLSFC=R15;     /* SAVE RETURN CODE      @ZA33246*/
         STC   R15,VVOLLSFC(,@14)                                  0634
*                 VVOLLPDC=PP90;    /* SET PROBLEM CODE      @ZA33246*/
         MVI   VVOLLPDC(@14),X'5A'                                 0635
*                 GO TO EXIT;       /* ERROR EXIT            @ZA33246*/
         B     EXIT                                                0636
*               END;                /*                       @ZA33246*/
*             RESPECIFY                                            0638
*              (R1,                                                0638
*               R15) UNRESTRICTED;  /*                       @ZA33246*/
@RF00631 DS    0H                                                  0639
*           END;                    /*                       @ZA33246*/
*       END;                                                       0640
@RF00624 DS    0H                                                  0641
*   END;                                                           0641
@RF00508 LA    @11,1                                               0641
         AL    @11,C1                                              0641
@DE00507 ST    @11,C1                                              0641
         L     @05,VOLLPTR                                         0641
         CH    @11,VVOLLNBR(,@05)                                  0641
         BNH   @DL00507                                            0641
*   RESPECIFY                                                      0642
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RET=RSAVLA;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLA                                          0643
*   RESPECIFY                                                      0644
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END GOVERIFY;                                                  0645
@EL00004 DS    0H                                                  0645
@EF00004 DS    0H                                                  0645
@ER00004 BR    @14                                                 0645
*ALOCUNIT:                                                         0646
*                                                                  0646
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - MOVES VOLUME SERIAL NUMBER INTO UCB. CALLS         */
*/*               DISMOUNT TO ISSUE DISMOUNT MESSAGE IF NEEDED.      */
*/*               CALLS MOUNT TO ISSUE A MOUNT MESSAGE.              */
*/*   INPUT -     1. ADDRESS OF IDAVVOL IN VUCBLVLA                  */
*/*               2. ADDRESS OF UCB IN VUCBLADR                      */
*/*   OUTPUT  -   1. VOLUME MOUNTED ON SPINDLE                       */
*/*                                                                  */
*/* ENTERED WITH THE UCB GOBAL SPIN LOCK HELD                @Y021130*/
*/********************************************************************/
*                                                                  0646
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0646
ALOCUNIT DS    0H                                                  0647
*   RESPECIFY                                                      0647
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLB=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLB                                          0648
*   UCBDMCT=1;                      /* SET USE COUNT TO ONE          */
         MVI   UCBDMCT(RUCB),X'01'                                 0649
*   RVOL=UCBVOLI;                   /* SAVE VOLSER FOR DISMAOUNT MSG */
         MVC   RVOL(6),UCBVOLI(RUCB)                               0650
*   UCBMOUNT=ON;                    /* INDICATE VERIFY TO COME       */
         OI    UCBMOUNT(RUCB),B'10000000'                          0651
*   CALL FREELOCK;                  /* FREE THE LOCAL LOCK   @Y021130*/
         BAL   @14,FREELOCK                                        0652
*   IF DMSG=ON THEN                 /* IF DISMOUNT MESSAGE NEEDED    */
         TM    DMSG,B'00000001'                                    0653
         BNO   @RF00653                                            0653
*     CALL DISMOUNT;                /* ISSUE DISMOUNT MESSAGE        */
         BAL   @14,DISMOUNT                                        0654
*   UCBVOLI=VVOLLVSR(C1);           /* MOVE VOLSER TO MOUNT INTO UCB
*                                                            @XA02421*/
@RF00653 L     @15,C1                                              0655
         MH    @15,@CH00033                                        0655
         L     @11,VOLLPTR                                         0655
         ALR   @11,@15                                             0655
         MVC   UCBVOLI(6,RUCB),VVOLLVSR-12(@11)                    0655
*   CALL MOUNT;                     /* ISSUE MOUNT MESSAGE           */
         BAL   @14,MOUNT                                           0656
*   VVOLLVFY(C1)=ON;                /* INDICATE NEED FOR VERIFY      */
         L     @15,VOLLPTR                                         0657
         L     @11,C1                                              0657
         MH    @11,@CH00033                                        0657
         ST    @11,@TF00001                                        0657
         ALR   @11,@15                                             0657
         OI    VVOLLVFY-12(@11),B'01000000'                        0657
*   VVOLLUCB(C1)=RUCB;              /* COPY UCB ADDRESS              */
         L     @11,@TF00001                                        0658
         ST    RUCB,VVOLLUCB-12(@11,@15)                           0658
*   VUCBLALC(C2)=ON;                /* INDICATE UCB USED             */
         L     @15,C2                                              0659
         SLA   @15,2                                               0659
         L     @11,UCBLPTR                                         0659
         ALR   @11,@15                                             0659
         OI    VUCBLALC-4(@11),B'10000000'                         0659
*   RET=RSAVLB;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLB                                          0660
*   RESPECIFY                                                      0661
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END ALOCUNIT;                                                  0662
@EL00005 DS    0H                                                  0662
@EF00005 DS    0H                                                  0662
@ER00005 BR    @14                                                 0662
*VMTSCAN:                           /*                       @Z30SSJH*/
*/********************************************************************/
*/*                                                                  */
*/*    FUNCTION - DETERMINE FOR AN EOV REQUEST IF THE VOLUME SERIAL  */
*/*               NUMBER IS ALREADY IN THE VMT'S FOR THE SPHERE.     */
*/*                                                                  */
*/*    INPUT    - PTR TO BIB IN IDAVVOLL.                            */
*/*                                                                  */
*/*    OUTPUT   - IF VOLUME IS ALREADY MOUNTED, THEN UPDATE VMT      */
*/*               USE COUNT.                                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0663
*   PROC OPTIONS(NOSAVE);           /*                       @Z30SSJH*/
VMTSCAN  DS    0H                                                  0664
*   RFY                                                            0664
*     RET RSTD;                     /* RESTRICT RETURN REG   @Z30SSJH*/
*   RSAVLB=RET;                     /* SAVE RETURN ADDRESS   @Z30SSJH*/
         ST    RET,RSAVLB                                          0665
*   RFY                                                            0666
*     RET UNRSTD;                   /* DROP REG RESTRICTION  @Z30SSJH*/
*   VMTHIT=OFF;                     /* RESET ENTRY FOUND INDR@Z30SSJH*/
         NI    VMTHIT,B'10111111'                                  0667
*   VMTPT=BIBVMT;                   /* PT TO FIRST VMT       @Z30SSJH*/
         L     @11,VOLLPTR                                         0668
         L     @11,VVOLLBIB(,@11)                                  0668
         L     @11,BIBVMT(,@11)                                    0668
         ST    @11,VMTPT                                           0668
*   RUCB=VUCBLADR(1);               /* PT TO FIRST UCB       @Z30SSJH*/
         L     @05,UCBLPTR                                         0669
         L     RUCB,VUCBLADR-1(,@05)                               0669
         LA    RUCB,0(,RUCB)                                       0669
*   DO WHILE(VMTPT^=0&VMTHIT=OFF);  /* SCAN VMT'S            @Z30SSJH*/
         B     @DE00670                                            0670
@DL00670 DS    0H                                                  0671
*     IF VMTDVTYP=UCBTYP(3:4) THEN  /* CORRECT DEVICE TYPE ? @Z30SSJH*/
         L     @11,VMTPT                                           0671
         CLC   VMTDVTYP(2,@11),UCBTYP+2(RUCB)                      0671
         BNE   @RF00671                                            0671
*       DO;                         /* YES, SCAN THE VMT     @Z30SSJH*/
*         DO CTR=1 TO VMTNOVOL WHILE(VMTVLSER(CTR)^=VVOLLVSR(1));/*
*                                      SCAN THE VMT          @Z30SSJH*/
         LA    @11,1                                               0673
         B     @DE00673                                            0673
@DL00673 LR    @05,@11                                             0673
         SLA   @05,4                                               0673
         L     @01,VMTPT                                           0673
         ALR   @01,@05                                             0673
         L     @05,VOLLPTR                                         0673
         CLC   VMTVLSER-16(6,@01),VVOLLVSR(@05)                    0673
         BE    @DC00673                                            0673
*         END;                                                     0674
         AL    @11,@CF00062                                        0674
@DE00673 STC   @11,CTR                                             0674
         L     @05,VMTPT                                           0674
         CH    @11,VMTNOVOL(,@05)                                  0674
         BNH   @DL00673                                            0674
@DC00673 DS    0H                                                  0675
*         IF CTR<=VMTNOVOL THEN     /* WAS ENTRY FOUND       @Z30SSJH*/
         SLR   @11,@11                                             0675
         IC    @11,CTR                                             0675
         L     @05,VMTPT                                           0675
         CH    @11,VMTNOVOL(,@05)                                  0675
         BH    @RF00675                                            0675
*           DO;                     /* YES, IND VOL ALREADY MOUNTED
*                                                            @Z30SSJH*/
*             VMTHIT=ON;            /* IND VOL FOUND         @Z30SSJH*/
         OI    VMTHIT,B'01000000'                                  0677
*             VVOLLMNT(1)=ON;       /* IND VOL MOUNTED       @Z30SSJH*/
         L     @15,VOLLPTR                                         0678
         OI    VVOLLMNT(@15),B'10000000'                           0678
*             VVOLLUCB(1)=VMTUCB(CTR);/* INIT PTR TO UCB     @Z30SSJH*/
         SLA   @11,4                                               0679
         L     @14,VMTUCB-16(@11,@05)                              0679
         ST    @14,VVOLLUCB(,@15)                                  0679
*             IF VVOLLSWD=ON THEN   /* IS THIS SS/DATA       @Z30SSJH*/
         TM    VVOLLSWD(@15),B'00000010'                           0680
         BNO   @RF00680                                            0680
*               VMTUSECT(CTR)=VMTUSECT(CTR)+2;/* YES, INCR USE COUNT
*                                      BY 2                  @Z30SSJH*/
         LA    @15,2                                               0681
         AL    @15,VMTUSECT-16(@11,@05)                            0681
         ST    @15,VMTUSECT-16(@11,@05)                            0681
*             ELSE                  /* NOT SS/DATA           @Z30SSJH*/
*               VMTUSECT(CTR)=VMTUSECT(CTR)+1;/* INCR VMT USE COUNT
*                                      BY 1                  @Z30SSJH*/
         B     @RC00680                                            0682
@RF00680 L     @11,VMTPT                                           0682
         SLR   @05,@05                                             0682
         IC    @05,CTR                                             0682
         SLA   @05,4                                               0682
         LA    @15,1                                               0682
         AL    @15,VMTUSECT-16(@05,@11)                            0682
         ST    @15,VMTUSECT-16(@05,@11)                            0682
*           END;                    /*                       @Z30SSJH*/
@RC00680 DS    0H                                                  0684
*       END;                        /*                       @Z30SSJH*/
@RF00675 DS    0H                                                  0685
*     IF VMTHIT=OFF THEN            /* IF ENTRY NOT FOUND    @Z30SSJH*/
@RF00671 TM    VMTHIT,B'01000000'                                  0685
         BNZ   @RF00685                                            0685
*       VMTPT=VMTNXT;               /* THEN PT TO NEXT VMT   @Z30SSJH*/
         L     @11,VMTPT                                           0686
         L     @11,VMTNXT(,@11)                                    0686
         ST    @11,VMTPT                                           0686
*   END;                            /*                       @Z30SSJH*/
@RF00685 DS    0H                                                  0687
@DE00670 L     @11,VMTPT                                           0687
         LTR   @11,@11                                             0687
         BZ    @DC00670                                            0687
         TM    VMTHIT,B'01000000'                                  0687
         BZ    @DL00670                                            0687
@DC00670 DS    0H                                                  0688
*   RFY                                                            0688
*     RET RSTD;                     /* RESTRICT RETURN REG   @Z30SSJH*/
*   RET=RSAVLB;                     /* RESTORE RETURN ADDR   @Z30SSJH*/
         L     RET,RSAVLB                                          0689
*   RFY                                                            0690
*     RET UNRSTD;                   /* DROP REG RESTRICTION  @Z30SSJH*/
*   END VMTSCAN;                    /* RETRUN TO THE CALLER  @Z30SSJH*/
@EL00006 DS    0H                                                  0691
@EF00006 DS    0H                                                  0691
@ER00006 BR    @14                                                 0691
*EOVDMT:                                                           0692
*                                                                  0692
*/********************************************************************/
*/*  FUNCTION - DETERMINE FOR AN EOV REQUEST IF THE SELECTED @Y30DSMD*/
*/*             UCB IS ELIGIBLE FOR DISMOUNT                 @Y30DSMD*/
*/*                                                          @Y30DSMD*/
*/*  INPUT    - RUCB CONTAINS SELECTED UCB PTR.  VVOLL PARM  @Y30DSMD*/
*/*             LIST CONTAINS PTR TO DEB AND BIB.            @Y30DSMD*/
*/*                                                          @Y30DSMD*/
*/*  OUTPUT   - IF OK TO DISMOUNT THEN EOVDM IS TURNED ON    @Y30DSMD*/
*/*             AND VMTPT INDEXED BY CTR REFLECTS VMT ENTRY  @Y30DSMD*/
*/*             ASSOCIATED WITH RUCB                         @Y30DSMD*/
*/********************************************************************/
*                                                                  0692
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @Y30DSMD*/
EOVDMT   DS    0H                                                  0693
*   RESPECIFY                                                      0693
*     RET RESTRICTED;               /*                       @Y30DSMD*/
*   RSAVLB=RET;                     /* SAVE RETURN ADDRESS   @Y30DSMD*/
         ST    RET,RSAVLB                                          0694
*   RESPECIFY                                                      0695
*     RET UNRESTRICTED;             /*                       @Y30DSMD*/
*   DEBPTR=VVOLLDEB;                /* INIT BASE PTR FOR DEB @Y30DSMD*/
         L     @11,VOLLPTR                                         0696
         L     @05,VVOLLDEB(,@11)                                  0696
         ST    @05,DEBPTR                                          0696
*   VMTPT=BIBVMT;                   /* INIT BASE PTR FOR VMT @Y30DSMD*/
         L     @11,VVOLLBIB(,@11)                                  0697
         L     @11,BIBVMT(,@11)                                    0697
         ST    @11,VMTPT                                           0697
*   VMTHIT=OFF;                     /* CLEAR SWITCH          @Y30DSMD*/
*   EOVDM=OFF;                      /* CLEAR DISMOUNT OK BIT @Y30DSMD*/
         NI    VMTHIT,B'10011111'                                  0699
*   CTR=0;                          /* CLEAR VMT INDEX       @Y30DSMD*/
         MVI   CTR,X'00'                                           0700
*   DO WHILE VMTPT^=0&VMTHIT=OFF;   /* PROCESS VMT'S         @Y30DSMD*/
         B     @DE00701                                            0701
@DL00701 DS    0H                                                  0702
*     IF VMTDVTYP=UCBTYP(3:4) THEN  /* DEVICE TYPE MATCH     @Y30DSMD*/
         L     @11,VMTPT                                           0702
         CLC   VMTDVTYP(2,@11),UCBTYP+2(RUCB)                      0702
         BNE   @RF00702                                            0702
*       DO UNTIL(VMTHIT=ON|CTR=VMTNOVOL);/* YES, SCAN VMT    @Y30DSMD*/
@DL00703 DS    0H                                                  0704
*         CTR=CTR+1;                /* NXT OR FIRST VMT ENTRY      0704
*                                                            @Y30DSMD*/
         LA    @11,1                                               0704
         SLR   @05,@05                                             0704
         IC    @05,CTR                                             0704
         ALR   @05,@11                                             0704
         STC   @05,CTR                                             0704
*         IF RUCB=VMTUCB(CTR) THEN  /* UCB MATCH             @Y30DSMD*/
         SLA   @05,4                                               0705
         L     @01,VMTPT                                           0705
         C     RUCB,VMTUCB-16(@05,@01)                             0705
         BNE   @RF00705                                            0705
*           DO;                     /* YES, CONTINUE         @Y30DSMD*/
*             VMTHIT=ON;            /* BREAK LOOPS           @Y30DSMD*/
         OI    VMTHIT,B'01000000'                                  0707
*             DEBDAPTR=ADDR(DEBBASND);/* PT 1ST DEB EXTENT   @Y30DSMD*/
         L     @05,DEBPTR                                          0708
         LA    @05,DEBBASND(,@05)                                  0708
         ST    @05,DEBDAPTR                                        0708
*             DO CTR1=1 TO DEBNMEXT WHILE VMTUCB(CTR)^=DEBUCBA;/*  0709
*                                      SEARCH FOR UCB MATCH  @Y30DSMD*/
         LR    CTR1,@11                                            0709
         B     @DE00709                                            0709
@DL00709 SLR   @11,@11                                             0709
         IC    @11,CTR                                             0709
         SLA   @11,4                                               0709
         L     @15,DEBDAPTR                                        0709
         L     @01,VMTPT                                           0709
         L     @11,VMTUCB-16(@11,@01)                              0709
         L     @14,DEBUCBA-1(,@15)                                 0709
         LA    @14,0(,@14)                                         0709
         CR    @11,@14                                             0709
         BE    @DC00709                                            0709
*               DEBDAPTR=DEBDAPTR+LENGTH(DEBDASD);/*         @Y30DSMD
*                                      PT NEXT EXTENT        @Y30DSMD*/
         AL    @15,@CF00078                                        0710
         ST    @15,DEBDAPTR                                        0710
*             END;                  /*                       @Y30DSMD*/
         AL    CTR1,@CF00062                                       0711
@DE00709 L     @11,DEBPTR                                          0711
         SLR   @15,@15                                             0711
         IC    @15,DEBNMEXT(,@11)                                  0711
         CR    CTR1,@15                                            0711
         BNH   @DL00709                                            0711
@DC00709 DS    0H                                                  0712
*             IF VMTUCB(CTR)=DEBUCBA THEN/* DEB USING UCB    @Y30DSMD*/
         SLR   @11,@11                                             0712
         IC    @11,CTR                                             0712
         SLA   @11,4                                               0712
         L     @05,VMTPT                                           0712
         L     @11,VMTUCB-16(@11,@05)                              0712
         L     @05,DEBDAPTR                                        0712
         L     @05,DEBUCBA-1(,@05)                                 0712
         LA    @05,0(,@05)                                         0712
         CR    @11,@05                                             0712
         BNE   @RF00712                                            0712
*               IF VVOLLSWD=ON THEN /* YES, SEQ SET WITH DATA        */
         L     @11,VOLLPTR                                         0713
         TM    VVOLLSWD(@11),B'00000010'                           0713
         BNO   @RF00713                                            0713
*                 STCNT=2;          /* YES, USE COUNT IS 2   @Y30DSMD*/
         MVI   STCNT,X'02'                                         0714
*               ELSE                /* NOT SEQ SET WITH DATA @Y30DSMD*/
*                 STCNT=1;          /* USE COUNT IS 1        @Y30DSMD*/
         B     @RC00713                                            0715
@RF00713 MVI   STCNT,X'01'                                         0715
*             ELSE                  /* DEB NOT USING UCB     @Y30DSMD*/
*               STCNT=0;            /* USE COUNT IS 0        @Y30DSMD*/
         B     @RC00712                                            0716
@RF00712 MVI   STCNT,X'00'                                         0716
*             IF STCNT>=VMTUSECT(CTR) THEN/* OTHER STRUCTURES USING
*                                      UCB                           */
@RC00712 SLR   @11,@11                                             0717
         IC    @11,CTR                                             0717
         SLA   @11,4                                               0717
         SLR   @05,@05                                             0717
         IC    @05,STCNT                                           0717
         L     @01,VMTPT                                           0717
         C     @05,VMTUSECT-16(@11,@01)                            0717
         BL    @RF00717                                            0717
*               EOVDM=ON;           /* NO, OK TO DISMOUNT    @Y30DSMD*/
         OI    EOVDM,B'00100000'                                   0718
*           END;                    /*                       @Y30DSMD*/
@RF00717 DS    0H                                                  0720
*       END;                        /*                       @Y30DSMD*/
@RF00705 DS    0H                                                  0720
@DE00703 TM    VMTHIT,B'01000000'                                  0720
         BO    @DC00703                                            0720
         SLR   @11,@11                                             0720
         IC    @11,CTR                                             0720
         L     @05,VMTPT                                           0720
         CH    @11,VMTNOVOL(,@05)                                  0720
         BNE   @DL00703                                            0720
@DC00703 DS    0H                                                  0721
*     IF VMTHIT=OFF THEN            /* IF NOT FOUND IN THIS VMT THEN,
*                                                            @Z30SSMD*/
@RF00702 TM    VMTHIT,B'01000000'                                  0721
         BNZ   @RF00721                                            0721
*       VMTPT=VMTNXT;               /* ADDR NEXT VMT         @Y30DSMD*/
         L     @11,VMTPT                                           0722
         L     @11,VMTNXT(,@11)                                    0722
         ST    @11,VMTPT                                           0722
*   END;                            /*                       @Y30DSMD*/
@RF00721 DS    0H                                                  0723
@DE00701 L     @11,VMTPT                                           0723
         LTR   @11,@11                                             0723
         BZ    @DC00701                                            0723
         TM    VMTHIT,B'01000000'                                  0723
         BZ    @DL00701                                            0723
@DC00701 DS    0H                                                  0724
*   RESPECIFY                                                      0724
*     RET RESTRICTED;               /*                       @Y30DSMD*/
*   RET=RSAVLB;                     /* RESTORE RETURN REG    @Y30DSMD*/
         L     RET,RSAVLB                                          0725
*   RESPECIFY                                                      0726
*     RET UNRESTRICTED;             /*                       @Y30DSMD*/
*   END EOVDMT;                     /*                       @Y30DSMD*/
@EL00007 DS    0H                                                  0727
@EF00007 DS    0H                                                  0727
@ER00007 BR    @14                                                 0727
*MOUNT:                                                            0728
*                                                                  0728
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - SETS POINTER TO MOUNT MESSAGE AND CALLS SEND       */
*/*               TO ISSUE MESSAGE.                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0728
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0728
MOUNT    DS    0H                                                  0729
*   RESPECIFY                                                      0729
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLC=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLC                                          0730
*   RESPECIFY                                                      0731
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   IF EOVDM=ON THEN                /* ENTRY FOUND           @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   0732
         BNO   @RF00732                                            0732
*     DO;                           /* YES,                  @Y30DSMD*/
*       VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* CLEAR VMT ENTRY      */
         L     @11,VMTPT                                           0734
         SLR   @05,@05                                             0734
         IC    @05,CTR                                             0734
         SLA   @05,4                                               0734
         ST    @05,@TF00001                                        0734
         ALR   @05,@11                                             0734
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    0734
*       VMTUCB(CTR)=RUCB;           /* INIT UCB PTR          @Y30DSMD*/
         L     @05,@TF00001                                        0735
         ST    RUCB,VMTUCB-16(@05,@11)                             0735
*       VMTVLSER(CTR)=UCBVOLI;      /* INIT VOL SER          @Y30DSMD*/
         LR    @05,@11                                             0736
         AL    @05,@TF00001                                        0736
         MVC   VMTVLSER-16(6,@05),UCBVOLI(RUCB)                    0736
*       VMTUSECT(CTR)=STCNT;        /* INIT USE COUNT        @Y30DSMD*/
         SLR   @05,@05                                             0737
         IC    @05,STCNT                                           0737
         L     @01,@TF00001                                        0737
         ST    @05,VMTUSECT-16(@01,@11)                            0737
*     END;                          /*                       @Y30DSMD*/
*   IF UCB2OPT4=ON THEN             /* CHECK IF VIRTUAL DEV  @Y30LSPS*/
@RF00732 TM    UCB2OPT4(RUCB),B'00001000'                          0739
         BNO   @RF00739                                            0739
*     DO;                           /* SPECIAL MOUNT IF YES  @Y30LSPS*/
*       MAINLEN=LENGTH(VMNTLST);    /* LENGTH OF PARM LIST   @Y30LSPS*/
         MVC   MAINLEN(3),@CF00084+1                               0741
*       CALL GETMAIN;               /* GET CORE FOR LIST     @Y30LSPS*/
         BAL   @14,GETMAIN                                         0742
*       RESPECIFY                                                  0743
*        (R1,                                                      0743
*         R15,                                                     0743
*         R11) RESTRICTED;          /*                       @Y30LSPS*/
*       R1=MAINADDR;                /* POINT TO GOTTEN CORE  @Y30LSPS*/
         L     R1,MAINADDR                                         0744
*       R15=ADDR(UCBVOLI);          /* POINT TO VOLSER OF DE @Y30LSPS*/
         LA    R15,UCBVOLI(,RUCB)                                  0745
*       R11=ADDR(UCBCHA);           /* POINT TO UNIT ADDR    @Y30LSPS*/
         LA    R11,UCBCHA(,RUCB)                                   0746
*       GEN(ICBMNTDE MF=(E,(R1)),TYPE=MNT,VOLID=(R15),VUA=(R11));  0747
         ICBMNTDE MF=(E,(R1)),TYPE=MNT,VOLID=(R15),VUA=(R11)
*       IF RETCODE^=0 THEN          /* CHECK IF SUCCESSFUL   @Y30LSPS*/
         LTR   RETCODE,RETCODE                                     0748
         BZ    @RF00748                                            0748
*         DO;                       /* ERROR MSG IN NO MOUNT @Y30LSPS*/
*           VVOLLCNT=C1;            /* IND VOL NBR IN ERR    @Y30LSPS*/
         L     @14,C1                                              0750
         L     @05,VOLLPTR                                         0750
         STC   @14,VVOLLCNT(,@05)                                  0750
*           VVOLLSFC=RETCODE;       /* SAVE VIRTUAL DEV ERR  @Y30LSPS*/
         STC   RETCODE,VVOLLSFC(,@05)                              0751
*           VVOLLPDC=PP90;          /* ERROR ON SS/1 MNT     @Y30LSPS*/
         MVI   VVOLLPDC(@05),X'5A'                                 0752
*           VVOLLVFY(C1)=OFF;       /* DO NOT VERIFY VOLUME  @Y30LSPS*/
*           VVOLLMNT(C1)=OFF;       /* IND VOLUME NOT MNTED  @Y30LSPS*/
         MH    @14,@CH00033                                        0754
         ALR   @05,@14                                             0754
         NI    VVOLLVFY-12(@05),B'00111111'                        0754
*           UCBDMCT=0;              /* NO VOLUME NO COUNT    @Y30LSPS*/
         MVI   UCBDMCT(RUCB),X'00'                                 0755
*           UCBVOLI=UCBVOLI&&UCBVOLI;/* CLEAR VOLSER IN UCB  @Y30LSPS*/
         XC    UCBVOLI(6,RUCB),UCBVOLI(RUCB)                       0756
*           UCBMOUNT=OFF;           /* CLEAR VOL BEING MNTED @Y30LSPS*/
         NI    UCBMOUNT(RUCB),B'01111111'                          0757
*           IF EOVDM=ON THEN        /* VMT ENTRY FOUND       @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   0758
         BNO   @RF00758                                            0758
*             DO;                   /*                       @Y30DSMD*/
*               VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* YES, CLEAR 0760
*                                                            @Y30DSMD*/
         L     @14,VMTPT                                           0760
         SLR   @05,@05                                             0760
         IC    @05,CTR                                             0760
         SLA   @05,4                                               0760
         ST    @05,@TF00001                                        0760
         ALR   @05,@14                                             0760
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    0760
*               VMTUCB(CTR)=RUCB;   /* INIT UCB PTR          @Y30DSMD*/
         L     @05,@TF00001                                        0761
         ST    RUCB,VMTUCB-16(@05,@14)                             0761
*             END;                  /*                       @Y30DSMD*/
*         END;                      /* END IF VIRTUAL MNT ER #Y30LSPS*/
*       ELSE                        /* RELAX NO ERR NOTHING  @Y30LSPS*/
*         ;                                                        0764
@RF00748 DS    0H                                                  0765
*       RESPECIFY                                                  0765
*         R0 RESTRICTED;            /*                       @ZA33246*/
@RC00748 DS    0H                                                  0766
*       R0=LENGTH(VMNTLST);         /* GET LENGTH OF LIST    @Y30LSPS*/
         LA    R0,28                                               0766
*       R1=MAINADDR;                /* POINT TO LIST AGAIN   @Y30LSPS*/
         L     R1,MAINADDR                                         0767
*       GEN(FREEMAIN R,LV=(0),A=(1));/* FREE MNT LIST        @Y30LSPS*/
         FREEMAIN R,LV=(0),A=(1)
*       IF VVOLLPDC^=0 THEN         /* CK IF MOUNT OK        @Y30LSPS*/
         L     @14,VOLLPTR                                         0769
         CLI   VVOLLPDC(@14),0                                     0769
         BNE   @RT00769                                            0769
*         GOTO EXIT;                /* EXIT IF ERROR ON MNT  @Y30LSPS*/
*       RESPECIFY                                                  0771
*        (R0,                                                      0771
*         R1,                                                      0771
*         R15,                                                     0771
*         R11) UNRESTRICTED;        /*                       @ZA33246*/
*     END;                          /* END IF VIRTUAL MOUNT  @Y30LSPS*/
*   ELSE                            /* NORMAL DEVICE MOUNT   @Y30LSPS*/
*     DO;                           /* NORMAL MOUNT MSG      @Y30LSPS*/
         B     @RC00739                                            0773
@RF00739 DS    0H                                                  0774
*       MSGDPTR=ADDR(M01A);         /* PT TO MOUNT MSG DESCRIPTION   */
         LA    @11,M01A                                            0774
         ST    @11,MSGDPTR                                         0774
*       CALL SEND;                  /* WRITE IT TO OPERATOR  @Y30LSPS*/
         BAL   @14,SEND                                            0775
*     END;                          /* END IF NORMAL MOUNT   @Y30LSPS*/
*   RESPECIFY                                                      0777
*     RET RESTRICTED;               /*                       @ZA33246*/
@RC00739 DS    0H                                                  0778
*   RET=RSAVLC;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLC                                          0778
*   RESPECIFY                                                      0779
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END MOUNT;                                                     0780
@EL00008 DS    0H                                                  0780
@EF00008 DS    0H                                                  0780
@ER00008 BR    @14                                                 0780
*DISMOUNT:                                                         0781
*                                                                  0781
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - SETS POINTER TO DEMOUNT OR RETAIN MESSAGE          */
*/*               AND CALLS SEND TO ISSUE MESSAGE.                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0781
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0781
DISMOUNT DS    0H                                                  0782
*   RESPECIFY                                                      0782
*    (R0,                                                          0782
*     R1,                                                          0782
*     RET) RESTRICTED;              /*                       @XA02421*/
*   RSAVLC=RET;                     /* SAVE RETURN ADDRESS   @ZA33246*/
         ST    RET,RSAVLC                                          0783
*   R0=-RUCB;                       /* NEG UCB ADDR          @XA02421*/
         LCR   R0,RUCB                                             0784
*   R1=0;                           /* ZERO EOD FLAG         @XA02421*/
         SLR   R1,R1                                               0785
*   SVC(VOLSTAT);                   /* ISSUE VOLSTAT         @XA02421*/
         SVC   91                                                  0786
*   RESPECIFY                                                      0787
*    (R0,                                                          0787
*     RET) UNRESTRICTED;            /*                       @XA02421*/
*   IF UCB2OPT4=ON THEN             /* CHECK IF VIRTUAL DEV  @Y30LSPS*/
         TM    UCB2OPT4(RUCB),B'00001000'                          0788
         BNO   @RF00788                                            0788
*     DO;                           /* SPECIAL DMOUNT IF YES @Y30LSPS*/
*       IF VVOLLEOV=ON&             /* IF EOV CALLING        @Y30LSPS*/
*           AMDWAIT=ON&             /* IS A WAIT REQUEST     @Y30LSPS*/
*           AMDFAULT=OFF THEN       /* IS NOT CYL FAULT ACC  @Y30LSPS*/
         L     @11,VOLLPTR                                         0790
         TM    VVOLLEOV(@11),B'00001000'                           0790
         BNO   @RF00790                                            0790
         L     @11,AMBDSB(,RACB)                                   0790
         TM    AMDWAIT(@11),B'00010000'                            0790
         BNO   @RF00790                                            0790
         TM    AMDFAULT(@11),B'01000000'                           0790
         BNZ   @RF00790                                            0790
*         DO;                       /* SETUP TO DESTAGE DTA  @Y30LSPS*/
*           IDAVIRT=IDAVIRT&&IDAVIRT;/* CLEAR PARM LIST      @Y30LSPS*/
         LA    @11,VIRTPARM                                        0792
         XC    IDAVIRT(24,@11),IDAVIRT(@11)                        0792
*           VIRTUCB=RUCB;           /* PASS UCB TO STAGE     @Y30LSPS*/
         ST    RUCB,VIRTUCB(,@11)                                  0793
*           VIRTBUCB=ON;            /* DESTAGE BY UCB        @Y30LSPS*/
         OI    VIRTBUCB(@11),B'00001000'                           0794
*           VIRTACB=AMBLACB;        /* GET ACB FORM AMBL     @Y30LSPS*/
         L     @05,AMBPAMBL(,RACB)                                 0795
         L     @05,AMBLACB(,@05)                                   0795
         ST    @05,VIRTACB(,@11)                                   0795
*           R1=ADDR(IDAVIRT);       /* POINT TO PARM LIST    @Y30LSPS*/
         LR    R1,@11                                              0796
*           CALL IDA0192D;          /* DESTAGE DEMNTED VOL   @Y30LSPS*/
         L     @15,@CV04514                                        0797
         BALR  @14,@15                                             0797
*           RESPECIFY                                              0798
*             RETCODE RESTRICTED;   /*                       @ZA33246*/
*           IF RETCODE^=0 THEN      /* CK IF DEMNT OK        @Y30LSPS*/
         LTR   RETCODE,RETCODE                                     0799
         BZ    @RF00799                                            0799
*             DO;                   /* ERROR MSG AND QUIT    @Y30LSPS*/
*               VVOLLERR=RETCODE;   /* SAVE RETURN CODE      @Y30LSPS*/
         L     @14,VOLLPTR                                         0801
         ST    RETCODE,VVOLLERR(,@14)                              0801
*               VVOLLCNT=C1;        /* SAVE VOL COUNT        @Y30LSPS*/
         L     @11,C1                                              0802
         STC   @11,VVOLLCNT(,@14)                                  0802
*             END;                  /* END IF ERROR ON DESTG @Y30LSPS*/
*         END;                      /* END IF DESTAGE REQ    @Y30LSPS*/
@RF00799 DS    0H                                                  0805
*       MAINLEN=LENGTH(DMNTLST);    /* LENGTH OF PARM LIST   @Y30LSPS*/
@RF00790 MVC   MAINLEN(3),@CF00084+1                               0805
*       CALL GETMAIN;               /* GET CORE FOR LIST     @Y30LSPS*/
         BAL   @14,GETMAIN                                         0806
*       RESPECIFY                                                  0807
*         R11 RESTRICTED;           /*                       @ZA33246*/
*       R1=MAINADDR;                /* POINT TO GOTTEN CORE  @Y30LSPS*/
         L     R1,MAINADDR                                         0808
*       R15=ADDR(RVOL);             /* POINT TO VOLSER OF DE @Y30LSPS*/
         LA    R15,RVOL                                            0809
*       R11=ADDR(UCBCHA);           /* POINT TO UNIT ADDR    @Y30LSPS*/
         LA    R11,UCBCHA(,RUCB)                                   0810
*       GEN(ICBMNTDE MF=(E,(R1)),TYPE=DMNT,VOLID=(R15),VUA=(R11)); 0811
         ICBMNTDE MF=(E,(R1)),TYPE=DMNT,VOLID=(R15),VUA=(R11)
*       IF RETCODE^=0 THEN          /* CHECK IF SUCCESSFUL   @Y30LSPS*/
         LTR   RETCODE,RETCODE                                     0812
         BZ    @RF00812                                            0812
*         DO;                       /* ERROR MSG IN NO MOUNT @Y30LSPS*/
*           VVOLLCNT=C1;            /* IND VOL NBR IN ERR    @Y30LSPS*/
         L     @14,C1                                              0814
         L     @05,VOLLPTR                                         0814
         STC   @14,VVOLLCNT(,@05)                                  0814
*           VVOLLSFC=RETCODE;       /* SAVE VIRTUAL DEV ERR  @Y30LSPS*/
         STC   RETCODE,VVOLLSFC(,@05)                              0815
*           VVOLLPDC=PP91;          /* ERROR ON SS/1 DEMNT   @Y30LSPS*/
         MVI   VVOLLPDC(@05),X'5B'                                 0816
*           VVOLLVFY(C1)=OFF;       /* DO NOT VERIFY VOLUME  @Y30LSPS*/
*           VVOLLMNT(C1)=OFF;       /* IND VOLUME NOT MNTED  @Y30LSPS*/
         MH    @14,@CH00033                                        0818
         ALR   @05,@14                                             0818
         NI    VVOLLVFY-12(@05),B'00111111'                        0818
*           UCBDMCT=0;              /* NO VOLUME NO COUNT    @Y30LSPS*/
         MVI   UCBDMCT(RUCB),X'00'                                 0819
*           UCBVOLI=UCBVOLI&&UCBVOLI;/* CLEAR VOLSER IN UCB  @Y30LSPS*/
         XC    UCBVOLI(6,RUCB),UCBVOLI(RUCB)                       0820
*         END;                      /* END IF VIRTUAL DMT ER @Y30LSPS*/
*       ELSE                        /* RELAX NO ERR NOTHING  @Y30LSPS*/
*         ;                                                        0822
@RF00812 DS    0H                                                  0823
*       RESPECIFY                                                  0823
*         R0 RESTRICTED;            /*                       @ZA33246*/
*       R0=LENGTH(DMNTLST);         /* GET LENGTH OF LIST    @Y30LSPS*/
         LA    R0,28                                               0824
*       R1=MAINADDR;                /* POINT TO LIST AGAIN   @Y30LSPS*/
         L     R1,MAINADDR                                         0825
*       GEN(FREEMAIN R,LV=(0),A=(1));/* FREE DEMNT LIST      @Y30LSPS*/
         FREEMAIN R,LV=(0),A=(1)
*       IF VVOLLPDC^=0 THEN         /* CK IF DEMOUNT OK      @Y30LSPS*/
         L     @14,VOLLPTR                                         0827
         CLI   VVOLLPDC(@14),0                                     0827
         BNE   @RT00827                                            0827
*         GOTO EXIT;                /* EXIT IF ERROR ON DMNT @Y30LSPS*/
*       RESPECIFY                                                  0829
*        (R0,                                                      0829
*         R1,                                                      0829
*         R15,                                                     0829
*         R11) UNRESTRICTED;        /*                       @ZA33246*/
*     END;                          /* END IF VIRTUAL DMOUNT @Y30LSPS*/
*   ELSE                            /* NORMAL DEVICE DMOUNT  @Y30LSPS*/
*     DO;                           /* NORMAL DEMOUNT MSG    @Y30LSPS*/
         B     @RC00788                                            0831
@RF00788 DS    0H                                                  0832
*       UCBNOTRD=ON;                /* SET UCB NOT READY     @ZA16004*/
         OI    UCBNOTRD(RUCB),B'01000000'                          0832
*       IF VVOLLEOV=ON THEN         /* IF MESSAGE IS FOR EOV @Y30LSPS*/
         L     @14,VOLLPTR                                         0833
         TM    VVOLLEOV(@14),B'00001000'                           0833
         BNO   @RF00833                                            0833
*         MSGDPTR=ADDR(M03E);       /* POINT TO RETAIN MSG   @Y30LSPS*/
         LA    @14,M03E                                            0834
         ST    @14,MSGDPTR                                         0834
*       ELSE                        /* MESSAGE FOR OPEN/CAT          */
*         MSGDPTR=ADDR(M11E);       /* POINT TO SHORT RETAIN MESSAGE */
         B     @RC00833                                            0835
@RF00833 LA    @14,M11E                                            0835
         ST    @14,MSGDPTR                                         0835
*       CALL SEND;                  /* WRITE IT TO OPERATOR          */
@RC00833 BAL   @14,SEND                                            0836
*     END;                          /* END IF NORMAL DEMNT   @Y30LSPS*/
*   RESPECIFY                                                      0838
*     RET RESTRICTED;               /*                       @ZA33246*/
@RC00788 DS    0H                                                  0839
*   RET=RSAVLC;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLC                                          0839
*   RESPECIFY                                                      0840
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END DISMOUNT;                                                  0841
@EL00009 DS    0H                                                  0841
@EF00009 DS    0H                                                  0841
@ER00009 BR    @14                                                 0841
*TSCHK:                                                            0842
*                                                                  0842
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - COMPARES TIMESTAMP IN FORMAT 4 DSCB IN VTOC        */
*/*               WITH TIME STAMP IN CATALOG FOR THAT VOLUME.        */
*/*   INPUT -     1. ADDRESS OF VOLUME LIST IN VOLLPTR               */
*/*   OUTPUT  -   1. VOLUME TIME STAMPS CHECKED                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0842
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0842
TSCHK    DS    0H                                                  0843
*   RESPECIFY                                                      0843
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLA=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLA                                          0844
*   RESPECIFY                                                      0845
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   VVOLLFNC=PDF21;                 /* SET FUNCTION CODE     @Y30DSMD*/
         L     @14,VOLLPTR                                         0846
         MVI   VVOLLFNC(@14),X'15'                                 0846
*   C2=0;                           /* ZERO COUNTER                  */
         SLR   @14,@14                                             0847
         ST    @14,C2                                              0847
*   NOMOUNT=OFF;                    /* RESET WORK SWITCH             */
         NI    NOMOUNT,B'11101111'                                 0848
*   DO C1=1 TO VVOLLNBR;            /* LOOP THRU VOLUME LIST         */
         LA    @14,1                                               0849
         B     @DE00849                                            0849
@DL00849 DS    0H                                                  0850
*     IF VVOLLMNT(C1)=ON THEN       /* IF VOLUME WAS MOUNTED         */
         MH    @14,@CH00033                                        0850
         L     @11,VOLLPTR                                         0850
         ALR   @11,@14                                             0850
         TM    VVOLLMNT-12(@11),B'10000000'                        0850
         BNO   @RF00850                                            0850
*       C2=C2+1;                    /* BUMP COUNTER                  */
         LA    @14,1                                               0851
         AL    @14,C2                                              0851
         ST    @14,C2                                              0851
*   END;                                                           0852
@RF00850 LA    @14,1                                               0852
         AL    @14,C1                                              0852
@DE00849 ST    @14,C1                                              0852
         L     @11,VOLLPTR                                         0852
         CH    @14,VVOLLNBR(,@11)                                  0852
         BNH   @DL00849                                            0852
*   IF C2^=0 THEN                   /* IF AT LEAST ONE VOL WAS     0853
*                                      MOUNTED                       */
         L     @14,C2                                              0853
         LTR   @14,@14                                             0853
         BZ    @RF00853                                            0853
*     DO;                                                          0854
*       MAINLEN=LENGTH(VLSERTS)*C2+LENGTH(VOLSTS);/* LENGTH TIME   0855
*                                      STAMP LIST                    */
         MH    @14,@CH03571                                        0855
         LA    @14,12(,@14)                                        0855
         STCM  @14,7,MAINLEN                                       0855
*       TSCORELN=MAINLEN;           /* SAVE LENGTH FOR LATER         */
         ST    @14,TSCORELN                                        0856
*       CALL GETMAIN;               /* GET CORE FOR TIME STAMP LIST  */
         BAL   @14,GETMAIN                                         0857
*       TSCORE=ON;                  /* INDICATE LIST TO FREE AT END  */
         OI    TSCORE,B'10000000'                                  0858
*       TSPT=MAINADDR;              /* POINT TO CORE                 */
         L     @14,MAINADDR                                        0859
         ST    @14,TSPT                                            0859
*       VLID=GETSTMP;               /* SET ID FOR IDA0192C           */
         MVI   VLID(@14),X'14'                                     0860
*       VLSFI=ADDR(VVOLLSFI);       /* INIT SFI AREA PTR     @Y30DSMD*/
         L     @11,VOLLPTR                                         0861
         LA    @05,VVOLLSFI(,@11)                                  0861
         STCM  @05,7,VLSFI(@14)                                    0861
*       VLENTNO=C2;                 /* SET NUMBER OF ENTRIES         */
         L     @05,C2                                              0862
         STH   @05,VLENTNO(,@14)                                   0862
*       VLCATACB=VVOLLACB;          /* COPY CATALOG ACB PTR          */
         L     @11,VVOLLACB(,@11)                                  0863
         ST    @11,VLCATACB(,@14)                                  0863
*       C2=0;                       /* ZERO COUNTER                  */
         SLR   @14,@14                                             0864
         ST    @14,C2                                              0864
*       DO C1=1 TO VVOLLNBR;        /* LOOP THRU VOLUME LIST         */
         LA    @14,1                                               0865
         B     @DE00865                                            0865
@DL00865 DS    0H                                                  0866
*         IF VVOLLMNT(C1)=ON THEN   /* IF VOLUME WAS MOUNTED         */
         L     @11,VOLLPTR                                         0866
         MH    @14,@CH00033                                        0866
         ST    @14,@TF00001                                        0866
         ALR   @14,@11                                             0866
         TM    VVOLLMNT-12(@14),B'10000000'                        0866
         BNO   @RF00866                                            0866
*           DO;                                                    0867
*             C2=C2+1;              /* BUMP COUNTER                  */
         LA    @14,1                                               0868
         AL    @14,C2                                              0868
         ST    @14,C2                                              0868
*             VLSER(C2)=VVOLLVSR(C1);/* COPY VOLSER                  */
         MH    @14,@CH03571                                        0869
         L     @05,TSPT                                            0869
         ALR   @05,@14                                             0869
         BCTR  @05,0                                               0869
         BCTR  @05,0                                               0869
         AL    @11,@TF00001                                        0869
         MVC   VLSER-12(6,@05),VVOLLVSR-12(@11)                    0869
*           END;                                                   0870
*       END;                                                       0871
@RF00866 LA    @14,1                                               0871
         AL    @14,C1                                              0871
@DE00865 ST    @14,C1                                              0871
         L     @11,VOLLPTR                                         0871
         CH    @14,VVOLLNBR(,@11)                                  0871
         BNH   @DL00865                                            0871
*       RESPECIFY                                                  0872
*         R1 RESTRICTED;            /*                       @ZA33246*/
*       R1=TSPT;                    /* LOAD PTR FOR IDA0192C         */
         L     R1,TSPT                                             0873
*       CALL IDA0192C;              /* IDA0192C TO FILL TIMESTMPS    */
         L     @15,@CV04518                                        0874
         BALR  @14,@15                                             0874
*       RESPECIFY                                                  0875
*         R1 UNRESTRICTED;          /*                       @ZA33246*/
*       RESPECIFY                                                  0876
*         RETCODE RESTRICTED;                                      0876
*       IF RETCODE^=0 THEN          /* IF ANY ERROR                  */
         LTR   RETCODE,RETCODE                                     0877
         BZ    @RF00877                                            0877
*         DO;                                                      0878
*           VVOLLERR=RETCODE;       /* COPY RETCODE          @Y30LSPS*/
         L     @14,VOLLPTR                                         0879
         ST    RETCODE,VVOLLERR(,@14)                              0879
*           IF EOVDM=ON THEN        /* VMT ENTRY FOUND       @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   0880
         BNO   @RF00880                                            0880
*             DO;                   /* YES, CLEAR            @Y30DSMD*/
*               RUCB=VMTUCB(CTR);   /* SAVE UCB PTR          @Y30DSMD*/
         L     @14,VMTPT                                           0882
         SLR   @05,@05                                             0882
         IC    @05,CTR                                             0882
         SLA   @05,4                                               0882
         L     RUCB,VMTUCB-16(@05,@14)                             0882
*               VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* CLEAR ENTRY
*                                                            @Y30DSMD*/
         ST    @05,@TF00001                                        0883
         ALR   @05,@14                                             0883
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    0883
*               VMTUCB(CTR)=RUCB;   /* RESTORE UCB PTR       @Y30DSMD*/
         L     @11,@TF00001                                        0884
         ST    RUCB,VMTUCB-16(@11,@14)                             0884
*             END;                  /*                       @Y30DSMD*/
*           GOTO EXIT;              /* EXIT MODULE IMMEDIATELY       */
         B     EXIT                                                0886
*         END;                                                     0887
*       RESPECIFY                                                  0888
*         RETCODE UNRESTRICTED;                                    0888
@RF00877 DS    0H                                                  0889
*       MAINLEN=LENGTH(CMLSTWKA);   /* LOAD LENGTH FOR GETMAIN       */
         MVC   MAINLEN(3),@CF03622+1                               0889
*       CALL GETMAIN;               /* GET CORE FOR CAMLST WKA       */
         BAL   @14,GETMAIN                                         0890
*       CAMCORE=ON;                 /* INDICATE CAMLST WKA TO FREE   */
         OI    CAMCORE,B'01000000'                                 0891
*       CMLSTWKP=MAINADDR;          /* SET BASE FOR CAMLST WKA       */
         L     @11,MAINADDR                                        0892
         ST    @11,CMLSTWKP                                        0892
*       CAMFUNC=SEEK;               /* SET CAMLST FOR SEEK OBTAIN    */
         MVC   CAMFUNC(2,@11),SEEK                                 0893
*       CAMWKAP=ADDR(CAMWKA);       /* POINT TO OBTAIN WKA           */
         LA    @07,CAMWKA(,@11)                                    0894
         ST    @07,CAMWKAP(,@11)                                   0894
*       F4PTR=ADDR(CAMF4);          /* SET BASE FOR F4 DSCB          */
         LA    F4PTR,CAMF4(,@11)                                   0895
*       DO C1=1 TO VLENTNO WHILE VVOLLPDC=0;/* LOP THRU TIMESTAMP LST*/
         LA    @11,1                                               0896
         B     @DE00896                                            0896
@DL00896 L     @11,VOLLPTR                                         0896
         CLI   VVOLLPDC(@11),0                                     0896
         BNE   @DC00896                                            0896
*         DO C2=1 TO VVOLLNBR WHILE(VVOLLVSR(C2)^=VLSER(C1));/* FIND
*                                      MATCHING VOLSER               */
         LA    @11,1                                               0897
         B     @DE00897                                            0897
@DL00897 LR    @07,@11                                             0897
         MH    @07,@CH00033                                        0897
         L     @05,C1                                              0897
         MH    @05,@CH03571                                        0897
         L     @01,VOLLPTR                                         0897
         ALR   @01,@07                                             0897
         L     @07,TSPT                                            0897
         ALR   @07,@05                                             0897
         BCTR  @07,0                                               0897
         BCTR  @07,0                                               0897
         CLC   VVOLLVSR-12(6,@01),VLSER-12(@07)                    0897
         BE    @DC00897                                            0897
*         END;                                                     0898
         AL    @11,@CF00062                                        0898
@DE00897 ST    @11,C2                                              0898
         L     @07,VOLLPTR                                         0898
         CH    @11,VVOLLNBR(,@07)                                  0898
         BNH   @DL00897                                            0898
@DC00897 DS    0H                                                  0899
*         RUCB=VVOLLUCB(C2);        /* LOAD PTR TO UCB       @Y30LSPS*/
         L     @07,C2                                              0899
         LR    @05,@07                                             0899
         MH    @05,@CH00033                                        0899
         L     @01,VOLLPTR                                         0899
         L     RUCB,VVOLLUCB-12(@05,@01)                           0899
*         IF UCBAMV=OFF THEN        /* CK IF PREV VERIFIED   @Y30LSPS*/
         TM    UCBAMV(RUCB),B'01000000'                            0900
         BNZ   @RF00900                                            0900
*           DO;                     /* MUST READ F4 DSCB     @Y30LSPS*/
*             CAMDSNA=ADDR(CCHHRF4(C2));/* SET PTR TO CCHHR          */
         L     @11,CCHHRPTR                                        0902
         MH    @07,@CH00882                                        0902
         LA    @05,0(@07,@11)                                      0902
         AL    @05,@CF04580                                        0902
         L     @01,CMLSTWKP                                        0902
         ST    @05,CAMDSNA(,@01)                                   0902
*             IF CCHHRF4(C2)='0000000000'X THEN/* IF NO CCHHR        */
         ALR   @11,@07                                             0903
         AL    @11,@CF04580                                        0903
         CLC   CCHHRF4(5,@11),@CB04519                             0903
         BNE   @RF00903                                            0903
*               DO;                                                0904
*                                                                  0904
*                 /***************************************************/
*                 /*                                                 */
*                 /* CONVERT TTR FROM UCB TO CCHHR                   */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0905
*                 DEBUCBA=ADDR(UCBOB);/* POINT TO MODEL UCB          */
         L     @11,DEBDAPTR                                        0905
         STCM  RUCB,7,DEBUCBA(@11)                                 0905
*                 RESPECIFY                                        0906
*                   R11 RESTRICTED;                                0906
*                 R11=RACB;         /* SAVE POINTER TO ACB           */
         LR    R11,RACB                                            0907
*                 RESPECIFY                                        0908
*                  (R0,                                            0908
*                   R1,                                            0908
*                   R15) RESTRICTED;                               0908
*                 R15=ADDR(XRBESA(1));/* POINT TO REGISTER SAVE AREA */
         L     @07,CVTPTR                                          0909
         L     @07,CVTTCBP(,@07)                                   0909
         L     @07,TCBPTR(,@07)                                    0909
         L     R15,TCBRBP(,@07)                                    0909
         LA    R15,XRBESA(,R15)                                    0909
*                 GEN(STM R9,R15,0(R15));/* SAVE REGISTERS 9-15      */
         STM R9,R15,0(R15)
*                 R0=UCBVTOC;       /* LOAD TTR                      */
         L     R0,UCBVTOC(,RUCB)                                   0911
*                 R1=ADDR(DEBBASIC);/* POINT TO WORK DEB             */
         L     R1,DEBPTR                                           0912
*                 RACB=ADDR(DXDADDR(1));/* POINT TO OUTPUT AREA      */
         LA    RACB,DXDADDR                                        0913
*                 R15=CVTPCNVT;     /* LOAD ADDR OF CONVERSION ROUT  */
         L     @07,CVTPTR                                          0914
         L     R15,CVTPCNVT(,@07)                                  0914
*                 GEN(BALR RET,R15);/* GO TO CONVERSION ROUTINE      */
         BALR RET,R15
*                 R15=ADDR(XRBESA(1));/* POINT TO REGISTER SAVE AREA */
         L     @07,CVTPTR                                          0916
         L     @07,CVTTCBP(,@07)                                   0916
         L     @07,TCBPTR(,@07)                                    0916
         L     R15,TCBRBP(,@07)                                    0916
         LA    R15,XRBESA(,R15)                                    0916
*                 GEN(LM R9,R15,0(R15));/* RESTORE REGISTERS 9-15    */
         LM R9,R15,0(R15)
*                 RACB=R11;         /* RESTORE ACB POINTER           */
         LR    RACB,R11                                            0918
*                 CCHHRF4(C2)=DXDADDR(4:8);/* SAVE CCHHR OF F4       */
         L     @14,C2                                              0919
         MH    @14,@CH00882                                        0919
         L     @07,CCHHRPTR                                        0919
         ALR   @07,@14                                             0919
         AL    @07,@CF04580                                        0919
         MVC   CCHHRF4(5,@07),DXDADDR+3                            0919
*                 RESPECIFY                                        0920
*                  (R0,                                            0920
*                   R1,                                            0920
*                   R11,                                           0920
*                   R15) UNRESTRICTED;                             0920
*               END;                                               0921
*             CAMVOLSR=ADDR(VLSER(C1));/* POINT TO VOLSER FOR OBTAIN */
@RF00903 L     @11,CMLSTWKP                                        0922
         L     @07,C1                                              0922
         MH    @07,@CH03571                                        0922
         L     @05,TSPT                                            0922
         BCTR  @05,0                                               0922
         BCTR  @05,0                                               0922
         LA    @07,VLSER-12(@07,@05)                               0922
         ST    @07,CAMVOLSR(,@11)                                  0922
*             RESPECIFY                                            0923
*              (R1,                                                0923
*               RETCODE) RESTRICTED;                               0923
*             R1=ADDR(CAMFUNC);     /* LOAD PARM FOR OBTAIN          */
         LR    R1,@11                                              0924
*             GEN(OBTAIN (1));      /* OBTAIN F4 DSCB                */
         OBTAIN (1)
*             IF RETCODE^=0 THEN    /* IF ANY ERROR                  */
         LTR   RETCODE,RETCODE                                     0926
         BZ    @RF00926                                            0926
*               DO;                                                0927
*                 OBTERR=RETCODE;   /* SAVE RETURN CODE FOR LATER    */
         LR    OBTERR,RETCODE                                      0928
*                 VVOLLPDC=PP116;   /* SET ERROR CODE        @Y30LSPS*/
         L     @14,VOLLPTR                                         0929
         MVI   VVOLLPDC(@14),X'74'                                 0929
*                 VVOLLCNT=C2;      /* SET VOLUME NUMBER     @Y30LSPS*/
         L     @11,C2                                              0930
         STC   @11,VVOLLCNT(,@14)                                  0930
*                 IF EOVDM=ON THEN  /* WAS VMT ENTRY FOUND?  @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   0931
         BNO   @RF00931                                            0931
*                   DO;             /* YES, CLEAR            @Y30DSMD*/
*                     RUCB=VMTUCB(CTR);/* SAVE UCB PTR       @Y30DSMD*/
         L     @14,VMTPT                                           0933
         SLR   @05,@05                                             0933
         IC    @05,CTR                                             0933
         SLA   @05,4                                               0933
         L     RUCB,VMTUCB-16(@05,@14)                             0933
*                     VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* CLEAR
*                                      ENTRY                 @Y30DSMD*/
         ST    @05,@TF00001                                        0934
         ALR   @05,@14                                             0934
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    0934
*                     VMTUCB(CTR)=RUCB;/* RESTORE UCB PTR    @Y30DSMD*/
         L     @11,@TF00001                                        0935
         ST    RUCB,VMTUCB-16(@11,@14)                             0935
*                   END;            /*                       @Y30DSMD*/
*                 GOTO EXIT;        /* EXIT MODULE IMMEDIATELY       */
         B     EXIT                                                0937
*               END;                                               0938
*             RESPECIFY                                            0939
*              (R1,                                                0939
*               RETCODE) UNRESTRICTED;                             0939
@RF00926 DS    0H                                                  0940
*             IF DS4R2TIM^=TSZERO THEN/*                     @Y30DSMD*/
         CLC   DS4R2TIM(8,F4PTR),TSZERO                            0940
         BE    @RF00940                                            0940
*               DO;                 /*                       @Y30DSMD*/
*                 IF VLTS(C1)^=DS4R2TIM THEN/*               @Y30DSMD*/
         L     @11,C1                                              0942
         MH    @11,@CH03571                                        0942
         L     @07,TSPT                                            0942
         ALR   @07,@11                                             0942
         CLC   VLTS-14(8,@07),DS4R2TIM(F4PTR)                      0942
         BE    @RF00942                                            0942
*                   DO;             /*                       @Y30DSMD*/
*                     VVOLLCNT=C2;  /*                       @Y30DSMD*/
         L     @11,VOLLPTR                                         0944
         L     @07,C2                                              0944
         STC   @07,VVOLLCNT(,@11)                                  0944
*                     VVOLLPDC=PP59;/*                       @Y30DSMD*/
         MVI   VVOLLPDC(@11),X'3B'                                 0945
*                   END;            /*                       @Y30DSMD*/
*               END;                /*                       @Y30DSMD*/
*             ELSE                  /*                       @Y30DSMD*/
*               DO;                 /*                       @Y30DSMD*/
         B     @RC00940                                            0948
@RF00940 DS    0H                                                  0949
*                 IF VLTS(C1)>DS4AMTIM THEN/* IF TIMESTAMP MISMATCH
*                                                            @Y30LSPS*/
         L     @11,C1                                              0949
         MH    @11,@CH03571                                        0949
         L     @07,TSPT                                            0949
         ALR   @07,@11                                             0949
         CLC   VLTS-14(8,@07),DS4AMTIM(F4PTR)                      0949
         BNH   @RF00949                                            0949
*                   DO;                                            0950
*                     VVOLLCNT=C2;  /* SET VOLUME NUMBER     @Y30LSPS*/
         L     @11,VOLLPTR                                         0951
         L     @07,C2                                              0951
         STC   @07,VVOLLCNT(,@11)                                  0951
*                     VVOLLPDC=PP59;/* SET ERROR CODE        @Y30LSPS*/
         MVI   VVOLLPDC(@11),X'3B'                                 0952
*                   END;                                           0953
*               END;                /*                       @Y30DSMD*/
@RF00949 DS    0H                                                  0955
*             IF DS4VSBAD=ON THEN   /* CK IF BAD VOLUME      @Y30LSPS*/
@RC00940 TM    DS4VSBAD(F4PTR),B'01000000'                         0955
         BNO   @RF00955                                            0955
*               DO;                 /* INDICATE ERROR IF BAD @Y30LSPS*/
*                 VVOLLCNT=C2;      /* SET VOLUME NBR        @Y30LSPS*/
         L     @11,VOLLPTR                                         0957
         L     @07,C2                                              0957
         STC   @07,VVOLLCNT(,@11)                                  0957
*                 VVOLLPDC=PP172;   /* SET ERROR CODE        @Y30LSPS*/
         MVI   VVOLLPDC(@11),X'AC'                                 0958
*               END;                /* END IF DS4VSBAD ON    @Y30LSPS*/
*             IF VVOLLPDC=0 THEN    /* IF NO ERR THEN OK     @Y30LSPS*/
@RF00955 L     @11,VOLLPTR                                         0960
         CLI   VVOLLPDC(@11),0                                     0960
         BNE   @RF00960                                            0960
*               UCBAMV=ON;          /* INDICATE VERIF OK     @Y30LSPS*/
         OI    UCBAMV(RUCB),B'01000000'                            0961
*           END;                    /* END IF UCBAMV IS OFF  @Y30LSPS*/
@RF00960 DS    0H                                                  0963
*       END;                                                       0963
@RF00900 LA    @11,1                                               0963
         AL    @11,C1                                              0963
@DE00896 ST    @11,C1                                              0963
         L     @07,TSPT                                            0963
         CH    @11,VLENTNO(,@07)                                   0963
         BNH   @DL00896                                            0963
@DC00896 DS    0H                                                  0964
*     END;                                                         0964
*   RESPECIFY                                                      0965
*     RET RESTRICTED;               /*                       @ZA33246*/
@RF00853 DS    0H                                                  0966
*   RET=RSAVLA;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLA                                          0966
*   RESPECIFY                                                      0967
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END TSCHK;                                                     0968
@EL00010 DS    0H                                                  0968
@EF00010 DS    0H                                                  0968
@ER00010 BR    @14                                                 0968
*BLDUCBL:                                                          0969
*                                                                  0969
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - BUILDS A UCB LIST FROM THE TIOT ENTRY WHOSE        */
*/*               ADDRESS IS IN THE VOLUME LIST.                     */
*/*   INPUT -     1. ADDRESS OF VOLUME LIST IN VOLLPTR               */
*/*   OUTPUT  -   1. ADDRESS OF UCB LIST IN UCBLPTR                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0969
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0969
BLDUCBL  DS    0H                                                  0970
*   RESPECIFY                                                      0970
*    (RTIOT,                                                       0970
*     RET) RESTRICTED;              /*                       @ZA33246*/
*   RSAVLA=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLA                                          0971
*   RTIOT=VVOLLTAB;                 /* LOAD PTR TO TIOE              */
         L     @15,VOLLPTR                                         0972
         L     RTIOT,VVOLLTAB(,@15)                                0972
*   C1=(TIOELNGH-16)/FWORDLEN;      /* GET NUMBER OF UCBS            */
         SLR   @00,@00                                             0973
         IC    @00,TIOELNGH(,RTIOT)                                0973
         SL    @00,@CF00078                                        0973
         SRDA  @00,32                                              0973
         D     @00,@CF00066                                        0973
         ST    @01,C1                                              0973
*   MAINLEN=LENGTH(IDAVUCBL)+C1*LENGTH(VUCBLENT);/* FIND CORE NEEDED */
         SLA   @01,2                                               0974
         LA    @01,8(,@01)                                         0974
         STCM  @01,7,MAINLEN                                       0974
*   CALL GETMAIN;                   /* GET THE CORE FOR UCBL         */
         BAL   @14,GETMAIN                                         0975
*   UCBLPTR=MAINADDR;               /* SET PTR TO UCBL               */
         L     @15,MAINADDR                                        0976
         ST    @15,UCBLPTR                                         0976
*   RESPECIFY                                                      0977
*     IDAVUCBL BASED(UCBLPTR);                                     0977
*   VUCBLID=ON;                     /* SET ID BIT ON                 */
         OI    VUCBLID(@15),B'10000000'                            0978
*   FAEVUCBL=ON;                    /* INDIC FREEMAIN REQ'D          */
         OI    FAEVUCBL,B'00000010'                                0979
*   VUCBLNBR=C1;                    /* SET NUMBER OF UCBS            */
         L     @11,C1                                              0980
         STH   @11,VUCBLNBR(,@15)                                  0980
*   DO C2=1 TO C1;                  /* SET UP UCB POINTERS           */
         LA    @15,1                                               0981
         B     @DE00981                                            0981
@DL00981 DS    0H                                                  0982
*     VUCBLADR(C2)=TIOEFSRT;        /* MOVE UCB ADDR INTO LIST       */
         LR    @11,@15                                             0982
         SLA   @11,2                                               0982
         L     @08,UCBLPTR                                         0982
         ALR   @08,@11                                             0982
         MVC   VUCBLADR-4(3,@08),TIOEFSRT(RTIOT)                   0982
*     RTIOT=RTIOT+FWORDLEN;         /* BUMP TIOE BASE                */
         AL    RTIOT,@CF00066                                      0983
*   END;                                                           0984
         AL    @15,@CF00062                                        0984
@DE00981 ST    @15,C2                                              0984
         C     @15,C1                                              0984
         BNH   @DL00981                                            0984
*   RET=RSAVLA;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLA                                          0985
*   RESPECIFY                                                      0986
*    (RTIOT,                                                       0986
*     RET) UNRESTRICTED;            /*                       @ZA33246*/
*   END BLDUCBL;                                                   0987
@EL00011 DS    0H                                                  0987
@EF00011 DS    0H                                                  0987
@ER00011 BR    @14                                                 0987
*SEND:                                                             0988
*                                                                  0988
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - BUILDS MESSAGE AND CALLS WTO TO ISSUE MESSAGE      */
*/*   INPUT -     1. ADDRESS OF MESSAGE DESCRIPTION IN MSGDPTR       */
*/*   OUTPUT  -   1. MESSAGE ISSUED TO CONSOLE                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0988
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0988
SEND     DS    0H                                                  0989
*   RESPECIFY                                                      0989
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLD=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLD                                          0990
*   RESPECIFY                                                      0991
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   PPSAVE=VVOLLFNC;                /* SAVE CURRENT FUNCTION CODE    */
         L     @11,VOLLPTR                                         0992
         IC    @05,VVOLLFNC(,@11)                                  0992
         STC   @05,PPSAVE                                          0992
*   VVOLLFNC=PDF22;                 /* SET FUNCTION CODE     @Y30DSMD*/
         MVI   VVOLLFNC(@11),X'16'                                 0993
*   MESSAGEA(1:LENGTH(MESSAGEA))=' ';/* BLANK OUT MESSAGE AREA       */
         MVI   MESSAGEA+1,C' '                                     0994
         MVC   MESSAGEA+2(66),MESSAGEA+1                           0994
         MVI   MESSAGEA,C' '                                       0994
*   MSGID=OCEMID;                   /* SET MSG ID                    */
         MVC   MSGID(3),@CC04230                                   0995
*   MSGFID=OPENFID;                 /* SET FUNCTION ID               */
         MVI   MSGFID,C'1'                                         0996
*   IF VVOLLEOV=ON THEN             /* IF CALLER IS EOV              */
         TM    VVOLLEOV(@11),B'00001000'                           0997
         BNO   @RF00997                                            0997
*     MSGFID=EOVFID;                /* SET EOV FUNCTION ID           */
         MVI   MSGFID,C'0'                                         0998
*   MSGSER=MSGRID;                  /* SET MSG SERIAL ID             */
@RF00997 L     @11,MSGDPTR                                         0999
         MVC   MSGSER(5),MSGRID(@11)                               0999
*   CC=1;                           /* SET MSGTEXT COLUMN CTR TO 1   */
         LA    @05,1                                               1000
         ST    @05,CC                                              1000
*   IF MSGRUNIT=ON THEN             /* IF MSG NEEDS UNIT NAME        */
         TM    MSGRUNIT(@11),B'10000000'                           1001
         BNO   @RF01001                                            1001
*     DO;                                                          1002
*       MSGTEXT(CC:CC+2)=UCBNAME;   /* MOVE UCB NAME IN MSG NOTE - 1003
*                                      REQUIRES RUCB CORRECT         */
         LA    @11,MSGTEXT-1(@05)                                  1003
         MVC   0(3,@11),UCBNAME(RUCB)                              1003
*       CC=CC+LENGTH(UCBNAME);      /* BUMP COLUMN COUNTER           */
         AL    @05,@CF00032                                        1004
         ST    @05,CC                                              1004
*     END;                                                         1005
*   IF MSGRVSR=ON THEN              /* IF MSG NEEDS VOLSER           */
@RF01001 L     @11,MSGDPTR                                         1006
         TM    MSGRVSR(@11),B'01000000'                            1006
         BNO   @RF01006                                            1006
*     DO;                                                          1007
*       CALL COMMA;                 /* ADD COMMA                     */
         BAL   @14,COMMA                                           1008
*       MSGTEXT(CC:CC+5)=RVOL;      /* GET VOLSER FROM RVOL          */
         L     @11,CC                                              1009
         LA    @05,MSGTEXT-1(@11)                                  1009
         MVC   0(6,@05),RVOL                                       1009
*       IF MSGACT='M' THEN          /* IF MOUNT MESSAGE              */
         CLI   MSGACT,C'M'                                         1010
         BNE   @RF01010                                            1010
*         MSGTEXT(CC:CC+5)=VVOLLVSR(C1);/* GET VOLSER FR VOL LIST    */
         LA    @05,MSGTEXT-1(@11)                                  1011
         L     @11,C1                                              1011
         MH    @11,@CH00033                                        1011
         L     @01,VOLLPTR                                         1011
         ALR   @01,@11                                             1011
         MVC   0(6,@05),VVOLLVSR-12(@01)                           1011
*       CC=CC+LENGTH(RVOL);         /* BUMP COLUMN COUNTER           */
@RF01010 LA    @11,6                                               1012
         AL    @11,CC                                              1012
         ST    @11,CC                                              1012
*     END;                                                         1013
*   IF MSGRJOB=ON THEN              /* DOES MSG REQUIRES JOB NAME    */
@RF01006 L     @11,MSGDPTR                                         1014
         TM    MSGRJOB(@11),B'00100000'                            1014
         BNO   @RF01014                                            1014
*     DO;                                                          1015
*       CALL COMMA;                 /* ADD COMMA                     */
         BAL   @14,COMMA                                           1016
*       RESPECIFY                                                  1017
*         TIOT1 BASED(TCBTIO);                                     1017
*       MSGTEXT(CC:CC+LENGTH(TIOCNJOB)-1)=TIOCNJOB;/* GET JOB NAME   */
         L     @11,CC                                              1018
         LA    @05,MSGTEXT-1(@11)                                  1018
         L     @01,CVTPTR                                          1018
         L     @01,CVTTCBP(,@01)                                   1018
         L     @01,TCBPTR(,@01)                                    1018
         L     @01,TCBTIO(,@01)                                    1018
         MVC   0(8,@05),TIOCNJOB(@01)                              1018
*       CC=CC+LENGTH(TIOCNJOB);     /* BUMP COLUMN COUNTER           */
         AL    @11,@CF00064                                        1019
         ST    @11,CC                                              1019
*     END;                                                         1020
*   IF MSGRSTEP=ON THEN             /* IF STEP NAME REQD             */
@RF01014 L     @11,MSGDPTR                                         1021
         TM    MSGRSTEP(@11),B'00010000'                           1021
         BNO   @RF01021                                            1021
*     DO;                                                          1022
*       CALL COMMA;                 /* ADD COMMA                     */
         BAL   @14,COMMA                                           1023
*       MSGTEXT(CC:CC+7)=TIOCSTEP(1:8);/* MOVE STEP NAME INTO MSG    */
         L     @11,CC                                              1024
         LA    @05,MSGTEXT-1(@11)                                  1024
         L     @01,CVTPTR                                          1024
         L     @01,CVTTCBP(,@01)                                   1024
         L     @01,TCBPTR(,@01)                                    1024
         L     @01,TCBTIO(,@01)                                    1024
         MVC   0(8,@05),TIOCSTEP(@01)                              1024
*       CC=CC+8;                    /* BUMP COLUMN COUNTER           */
         AL    @11,@CF00064                                        1025
         ST    @11,CC                                              1025
*     END;                                                         1026
*   IF MSGRSP=ON&                   /* IF MESSAGE REQD SPACE PARM    */
*       MSSSPACE=ON&                /* IF DISPLAY SPACE REQD         */
*       CVTSMCA^=0&                 /* IF SMCA PRESENT (SMF ACTIVE)  */
*       SMCAVOL=ON THEN             /* IF VOLUME STISTICS KEPT       */
@RF01021 L     @11,MSGDPTR                                         1027
         TM    MSGRSP(@11),B'00001000'                             1027
         BNO   @RF01027                                            1027
         L     @11,CVTPTR                                          1027
         L     @05,CVTMSLT(,@11)                                   1027
         TM    MSSSPACE(@05),B'00000100'                           1027
         BNO   @RF01027                                            1027
         L     @11,CVTSMCA(,@11)                                   1027
         LTR   @11,@11                                             1027
         BZ    @RF01027                                            1027
         TM    SMCAVOL(@11),B'00001000'                            1027
         BNO   @RF01027                                            1027
*     DO;                                                          1028
*       CALL COMMA;                 /* ADD COMMA                     */
         BAL   @14,COMMA                                           1029
*       IF CC+SPACELEN>LENGTH(MSGTEXT) THEN/* IF NO ROOM FOR SPACE   */
         LA    @11,30                                              1030
         AL    @11,CC                                              1030
         C     @11,@CF03693                                        1030
         BNH   @RF01030                                            1030
*         CALL WTO;                 /* YES, WRITE LINE AS IS         */
         BAL   @14,WTO                                             1031
*       RESPECIFY                                                  1032
*        (R0,                                                      1032
*         R1) RESTRICTED;                                          1032
@RF01030 DS    0H                                                  1033
*       LSPAREQD=ON;                /* BUILD LSPACE PARM LIST        */
         OI    LSPAREQD,B'10000000'                                1033
*       LSPAPTR=ADDR(MSGTEXT(CC));  /* POINT TO LSPACE OUTPUT AREA   */
         L     @11,CC                                              1034
         LA    @11,MSGTEXT-1(@11)                                  1034
         STCM  @11,7,LSPAPTR                                       1034
*       R1=LSPAPARM;                /* LOAD R1                       */
         L     R1,LSPAPARM                                         1035
*       R0=RUCB;                    /* LOAD R0 PTR TO UCB            */
         LR    R0,RUCB                                             1036
*       GEN(SVC 78);                /* LSACE                         */
         SVC 78
*       RESPECIFY                                                  1038
*        (R0,                                                      1038
*         R1) UNRESTRICTED;                                        1038
*       CC=CC+SPACELEN;             /* BUMP COLUMN COUNTER           */
         LA    @11,30                                              1039
         AL    @11,CC                                              1039
         ST    @11,CC                                              1039
*     END;                                                         1040
*   IF MSGRDSN=ON&                  /* IF MESSAGE REQIRES DSN        */
*       MSSSDSN=ON THEN             /* IF DISPLAY JOBNAMES ACTIVE    */
@RF01027 L     @11,MSGDPTR                                         1041
         TM    MSGRDSN(@11),B'00000100'                            1041
         BNO   @RF01041                                            1041
         L     @11,CVTPTR                                          1041
         L     @11,CVTMSLT(,@11)                                   1041
         TM    MSSSDSN(@11),B'00001000'                            1041
         BNO   @RF01041                                            1041
*     DO;                                                          1042
*       CALL COMMA;                 /* ADD COMMA                     */
         BAL   @14,COMMA                                           1043
*       IF JFCBREAD=OFF THEN        /* IF JFCB HAS NOT BEEN READ     */
         TM    JFCBREAD,B'00000100'                                1044
         BNZ   @RF01044                                            1044
*         CALL READJFCB;            /* READ THE JFCB                 */
         BAL   @14,READJFCB                                        1045
*       DSNL=LENGTH(JFCBDSNM);      /* SET DSN LENGTH TO MAX         */
@RF01044 MVC   DSNL(4),@CF00092                                    1046
*       DO WHILE JFCBDSNM(DSNL)=' ';/* FIND FIRST NON-BLANK          */
         B     @DE01047                                            1047
@DL01047 DS    0H                                                  1048
*         DSNL=DSNL-1;              /* BACK UP LENGTH                */
         L     @11,DSNL                                            1048
         BCTR  @11,0                                               1048
         ST    @11,DSNL                                            1048
*       END;                                                       1049
@DE01047 L     @11,DSNL                                            1049
         L     @05,JFCBWKAP                                        1049
         ALR   @05,@11                                             1049
         CLI   JFCBDSNM-1(@05),C' '                                1049
         BE    @DL01047                                            1049
*       IF CC+DSNL>LENGTH(MSGTEXT) THEN/* ROOM FOR DSN               */
         AL    @11,CC                                              1050
         C     @11,@CF03693                                        1050
         BNH   @RF01050                                            1050
*         CALL WTO;                 /* NO, WRITE LINE THUS FAR       */
         BAL   @14,WTO                                             1051
*       MSGTEXT(CC:CC+DSNL)=JFCBDSNM(1:DSNL);/* MOVE DSN INTO LINE   */
@RF01050 L     @11,CC                                              1052
         LA    @05,MSGTEXT-1(@11)                                  1052
         L     @11,DSNL                                            1052
         L     @01,JFCBWKAP                                        1052
         EX    @11,@SM04582                                        1052
*     END;                                                         1053
*   CALL BACKBLNK;                  /* BACK OUT ENDING BLANKS        */
@RF01041 BAL   @14,BACKBLNK                                        1054
*   CALL WTO;                       /* WRITE THE MESSAGE             */
         BAL   @14,WTO                                             1055
*   VVOLLFNC=PPSAVE;                /* RESTORE CURRENT FUNCTION CODE */
         IC    @11,PPSAVE                                          1056
         L     @05,VOLLPTR                                         1056
         STC   @11,VVOLLFNC(,@05)                                  1056
*   RESPECIFY                                                      1057
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RET=RSAVLD;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLD                                          1058
*   RESPECIFY                                                      1059
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END SEND;                                                      1060
@EL00012 DS    0H                                                  1060
@EF00012 DS    0H                                                  1060
@ER00012 BR    @14                                                 1060
*WTO:                                                              1061
*                                                                  1061
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - INITIALIZES WTO PARAMETER LIST AND ISSUES          */
*/*               WTO SVC.                                           */
*/*   INPUT -     1. MESSAGE TO BE WRITTEN                           */
*/*   OUTPUT  -   1. MESSAGE WRITTEN TO CONSOLE                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  1061
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1061
WTO      DS    0H                                                  1062
*   RESPECIFY                                                      1062
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLE=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLE                                          1063
*   RESPECIFY                                                      1064
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   MSGLSTSZ=CC-1+LENGTH(MSGHDR)+LENGTH(MSGPTXT);/* SET MSG SIZE     */
         L     @11,CC                                              1065
         LA    @05,13(,@11)                                        1065
         STH   @05,MSGLSTSZ                                        1065
*   MCSFLAGS=FLAGMCS;               /* SET MCS FLAG                  */
         MVC   MCSFLAGS(2),@CB04222                                1066
*   MSGTEXT(CC:CC+3)=DESCROUT;      /* ADD ROUT/DESC CODE FOR MCS    */
         LA    @05,MSGTEXT-1(@11)                                  1067
         L     @11,MSGDPTR                                         1067
         MVC   0(4,@05),DESCROUT(@11)                              1067
*   IF DOMBIT=ON THEN               /* IF DESC CODE IND DOM          */
         TM    DOMBIT(@11),B'01000000'                             1068
         BNO   @RF01068                                            1068
*     DO;                                                          1069
*       IF DOMLISTP=0 THEN          /* IF DOMLIST NOT BUILT          */
         L     @11,DOMLISTP                                        1070
         LTR   @11,@11                                             1070
         BNZ   @RF01070                                            1070
*         DO;                                                      1071
*           MAINLEN=LENGTH(DOMLIST)*VVOLLNBR;/* ONE ENTRY PER VOLUME */
         L     @11,VOLLPTR                                         1072
         LH    @11,VVOLLNBR(,@11)                                  1072
         SLA   @11,2                                               1072
         STCM  @11,7,MAINLEN                                       1072
*           CALL GETMAIN;           /* GET CORE                      */
         BAL   @14,GETMAIN                                         1073
*           DOMLISTP=MAINADDR;      /* SET PTR                       */
         L     @11,MAINADDR                                        1074
         ST    @11,DOMLISTP                                        1074
*         END;                                                     1075
*       MAINLEN=LENGTH(DOMENT);     /* SET LENGTH FOR ONE DOM ENTRY  */
@RF01070 MVC   MAINLEN(3),@CF00064+1                               1076
*       CALL GETMAIN;               /* GET CORE FOR ENTRY            */
         BAL   @14,GETMAIN                                         1077
*       RESPECIFY                                                  1078
*         DOMENT BASED(MAINADDR);                                  1078
*       DOMLAST=DOMLIST(C1);        /* POINT TO LAST ENTRY           */
         L     @11,MAINADDR                                        1079
         L     @05,DOMLISTP                                        1079
         L     @15,C1                                              1079
         SLA   @15,2                                               1079
         LA    @01,0(@15,@05)                                      1079
         AL    @01,@CF04584                                        1079
         L     @14,DOMLIST(,@01)                                   1079
         ST    @14,DOMLAST(,@11)                                   1079
*       DOMLIST(C1)=ADDR(DOMENT);   /* POINT TO CURRENT ENTRY        */
         AL    @05,@CF04584                                        1080
         ST    @11,DOMLIST(@15,@05)                                1080
*     END;                                                         1081
*   CALL DOM;                       /* DELETE ANY MSG PERTAINING TO
*                                      THIS VOLUME                   */
@RF01068 BAL   @14,DOM                                             1082
*   RESPECIFY                                                      1083
*     R1 RESTRICTED;                                               1083
*   GEN(WTO MF=(E,MSGHDR));                                        1084
         WTO MF=(E,MSGHDR)
*   IF DOMBIT=ON THEN               /* IF DESC CODE IND DOM          */
         L     @11,MSGDPTR                                         1085
         TM    DOMBIT(@11),B'01000000'                             1085
         BNO   @RF01085                                            1085
*     DO;                                                          1086
*       DOMID=R1;                   /* SAVE ID FROM WTO              */
         L     @11,MAINADDR                                        1087
         ST    R1,DOMID(,@11)                                      1087
*     END;                                                         1088
*   RESPECIFY                                                      1089
*     R1 UNRESTRICTED;                                             1089
@RF01085 DS    0H                                                  1090
*   CC=1;                           /* RESET COLUMN COUNTER          */
         MVC   CC(4),@CF00062                                      1090
*   MSGTEXT(1:LENGTH(MSGTEXT))=' '; /* BLANK OUT LINE                */
         MVI   MSGTEXT+1,C' '                                      1091
         MVC   MSGTEXT+2(56),MSGTEXT+1                             1091
         MVI   MSGTEXT,C' '                                        1091
*   MSGACT=' ';                     /* BLANK OUT ACTION CHARACTER    */
         MVI   MSGACT,C' '                                         1092
*   RESPECIFY                                                      1093
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RET=RSAVLE;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLE                                          1094
*   RESPECIFY                                                      1095
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END WTO;                                                       1096
@EL00013 DS    0H                                                  1096
@EF00013 DS    0H                                                  1096
@ER00013 BR    @14                                                 1096
*DOM:                                                              1097
*                                                                  1097
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  -  DELETES OPERATOR MESSAGES FROM MESSAGE QUEUE      */
*/*   INPUT -   1. ADDRESS OF DOM LIST IN DOMLISTP                   */
*/*   OUTPUT  - 1. MESSAGES REMOVED FROM QUEUE                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  1097
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1097
DOM      DS    0H                                                  1098
*   RESPECIFY                                                      1098
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLF=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLF                                          1099
*   IF DOMLISTP^=0 THEN             /* IF DOMLIST EXISTS             */
         L     @15,DOMLISTP                                        1100
         LTR   @15,@15                                             1100
         BZ    @RF01100                                            1100
*     DO WHILE DOMLIST(C1)^=0;      /* LOOP THRU DOM CHAIN           */
         B     @DE01101                                            1101
@DL01101 DS    0H                                                  1102
*       RESPECIFY                                                  1102
*         DOMENT BASED(DOMLIST(C1));                               1102
*       RESPECIFY                                                  1103
*         R1 RESTRICTED;                                           1103
*       R1=DOMID;                   /* LOAD DOM ID FROM WTO          */
         L     @15,C1                                              1104
         SLA   @15,2                                               1104
         L     @11,DOMLISTP                                        1104
         AL    @11,@CF04584                                        1104
         L     @15,DOMLIST(@15,@11)                                1104
         L     R1,DOMID(,@15)                                      1104
*       GEN(DOM MSG=(1));           /* DELETE MESSAGE                */
         DOM MSG=(1)
*       RESPECIFY                                                  1106
*         R1 UNRESTRICTED;                                         1106
*       DOMLIST(C1)=DOMLAST;        /* POINT TO LAST ID ENTRY        */
         L     @15,DOMLISTP                                        1107
         L     @11,C1                                              1107
         SLA   @11,2                                               1107
         LA    @05,0(@11,@15)                                      1107
         AL    @05,@CF04584                                        1107
         L     @05,DOMLIST(,@05)                                   1107
         L     @05,DOMLAST(,@05)                                   1107
         AL    @15,@CF04584                                        1107
         ST    @05,DOMLIST(@11,@15)                                1107
*     END;                                                         1108
@DE01101 L     @15,C1                                              1108
         SLA   @15,2                                               1108
         L     @11,DOMLISTP                                        1108
         AL    @11,@CF04584                                        1108
         L     @15,DOMLIST(@15,@11)                                1108
         LTR   @15,@15                                             1108
         BNZ   @DL01101                                            1108
*   RET=RSAVLF;                     /* RESTORE RETURN ADDRESS        */
@RF01100 L     RET,RSAVLF                                          1109
*   RESPECIFY                                                      1110
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END DOM;                                                       1111
@EL00014 DS    0H                                                  1111
@EF00014 DS    0H                                                  1111
@ER00014 BR    @14                                                 1111
*COMMA:                                                            1112
*                                                                  1112
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - REMOVES BLANKS AND INSERTS COMMA INTO MESSAGE      */
*/*                                                                  */
*/********************************************************************/
*                                                                  1112
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1112
COMMA    DS    0H                                                  1113
*   RESPECIFY                                                      1113
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLE=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLE                                          1114
*   CALL BACKBLNK;                  /* BACK OUT BLANKS               */
         BAL   @14,BACKBLNK                                        1115
*   MSGTEXT(CC)=',';                /* MOVE COMMA INTO MSG           */
         L     @15,CC                                              1116
         LA    @11,MSGTEXT-1(@15)                                  1116
         MVI   0(@11),C','                                         1116
*   CC=CC+1;                        /* BUMP COLUMN COUNTER           */
         AL    @15,@CF00062                                        1117
         ST    @15,CC                                              1117
*   RET=RSAVLE;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLE                                          1118
*   RESPECIFY                                                      1119
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END COMMA;                                                     1120
@EL00015 DS    0H                                                  1120
@EF00015 DS    0H                                                  1120
@ER00015 BR    @14                                                 1120
*BACKBLNK:                                                         1121
*                                                                  1121
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - REMOVES TRAILING BLANKS FROM MESSAGE               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1121
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1121
BACKBLNK DS    0H                                                  1122
*   RESPECIFY                                                      1122
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLF=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLF                                          1123
*   DO WHILE MSGTEXT(CC-1)=' ';     /* FIND FIRST NON-BLANK CHARACTER*/
         B     @DE01124                                            1124
@DL01124 DS    0H                                                  1125
*     CC=CC-1;                      /* BACK UP COLUMN COUNTER        */
         L     @15,CC                                              1125
         BCTR  @15,0                                               1125
         ST    @15,CC                                              1125
*   END;                                                           1126
@DE01124 L     @15,CC                                              1126
         LA    @11,MSGTEXT-2(@15)                                  1126
         CLI   0(@11),C' '                                         1126
         BE    @DL01124                                            1126
*   RET=RSAVLF;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLF                                          1127
*   RESPECIFY                                                      1128
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   END BACKBLNK;                                                  1129
@EL00016 DS    0H                                                  1129
@EF00016 DS    0H                                                  1129
@ER00016 BR    @14                                                 1129
*READJFCB:                                                         1130
*                                                                  1130
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - OBTAINS A WORK AREA AND INVOKES THE QUEUE          */
*/*               MANAGER TO READ A JFCB INTO IT.                    */
*/*   INPUT -     1. TIOT                                            */
*/*   OUTPUT  -   1. JFCB READ INTO WORK AREA                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  1130
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1130
READJFCB DS    0H                                                  1131
*   RESPECIFY                                                      1131
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RSAVLE=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLE                                          1132
*   RESPECIFY                                                      1133
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   IF JFCBREAD=OFF THEN            /* IF WORK AREA NEEDED           */
         TM    JFCBREAD,B'00000100'                                1134
         BNZ   @RF01134                                            1134
*     DO;                                                          1135
*       MAINLEN=LENGTH(JFCBWRKA);   /* SET LEN OF WRKA REQD          */
         MVC   MAINLEN(3),@CF04564+1                               1136
*       CALL GETMAIN;               /* GET WORK AREA                 */
         BAL   @14,GETMAIN                                         1137
*       JFCBWKAP=MAINADDR;          /* SET WORK AREA ADDR            */
         L     @11,MAINADDR                                        1138
         ST    @11,JFCBWKAP                                        1138
*       JFCBREAD=ON;                /* INDICATE JFCBWRKA TO BE FREED */
         OI    JFCBREAD,B'00000100'                                1139
*       QMITCBAD=ADDR(TCB);         /* INIT PTR TO TCB               */
         L     @05,CVTPTR                                          1140
         L     @05,CVTTCBP(,@05)                                   1140
         L     @05,TCBPTR(,@05)                                    1140
         ST    @05,QMITCBAD                                        1140
*       QMIRECAD=ADDR(JFCB);        /* POINT TO RECORD AREA          */
         LA    @05,JFCB(,@11)                                      1141
         ST    @05,QMIRECAD                                        1141
*       QMIWRKAD=ADDR(JESWORK);     /* POINT TO JES WORK AREA        */
         ST    @11,QMIWRKAD                                        1142
*       QMIRECL=LENGTH(JFCB);       /* SET LENGTH OF RECORD          */
         MVC   QMIRECL(2),@CH03065                                 1143
*       QMIOREAD=ON;                /* INDICATE READ REQD            */
         OI    QMIOREAD,B'10000000'                                1144
*     END;                                                         1145
*   RESPECIFY                                                      1146
*     TIOENTRY BASED(VVOLLTAB);                                    1146
@RF01134 DS    0H                                                  1147
*   QMIDSKAD(1:3)=TIOEJFCB;         /* GET TTR FORM TIOE             */
         L     @11,VOLLPTR                                         1147
         L     @11,VVOLLTAB(,@11)                                  1147
         MVC   QMIDSKAD(3),TIOEJFCB(@11)                           1147
*   RESPECIFY                                                      1148
*    (R1,                                                          1148
*     RETCODE) RESTRICTED;                                         1148
*   R1=ADDR(QMIOP);                 /* POINT TO PARAMETER LIST       */
         LA    R1,QMIOP                                            1149
*   R15=JESRESQM;                   /* LOAD ADDR OF Q MANAGER        */
         L     @11,CVTPTR                                          1150
         L     @11,CVTJESCT(,@11)                                  1150
         L     R15,JESRESQM(,@11)                                  1150
*   GEN(BALR RET,R15);              /* READ JFCB                     */
         BALR RET,R15
*   IF RETCODE^=0 THEN              /* IF ANY ERROR                  */
         LTR   RETCODE,RETCODE                                     1152
         BZ    @RF01152                                            1152
*     DO;                                                          1153
*       VVOLLPDC=PP4;               /* SET ERROR CODE        @Y30LSPS*/
         L     @14,VOLLPTR                                         1154
         MVI   VVOLLPDC(@14),X'04'                                 1154
*       VVOLLCNT=C1;                /* SET VOLUME NUMBER     @Y30LSPS*/
         L     @11,C1                                              1155
         STC   @11,VVOLLCNT(,@14)                                  1155
*       IF EOVDM=ON THEN            /* VMT ENTRY FOUND       @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   1156
         BNO   @RF01156                                            1156
*         DO;                       /* YES, CLEAR            @Y30DSMD*/
*           RUCB=VMTUCB(CTR);       /* SAVE UCB PTR          @Y30DSMD*/
         L     @14,VMTPT                                           1158
         SLR   @05,@05                                             1158
         IC    @05,CTR                                             1158
         SLA   @05,4                                               1158
         L     RUCB,VMTUCB-16(@05,@14)                             1158
*           VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* CLEAR ENTRY    1159
*                                                            @Y30DSMD*/
         ST    @05,@TF00001                                        1159
         ALR   @05,@14                                             1159
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    1159
*           VMTUCB(CTR)=RUCB;       /* RESTORE UCB PTR       @Y30DSMD*/
         L     @11,@TF00001                                        1160
         ST    RUCB,VMTUCB-16(@11,@14)                             1160
*         END;                      /*                       @Y30DSMD*/
*       GOTO EXIT;                  /* EXIT MODULE IMMEDIATELY       */
         B     EXIT                                                1162
*     END;                                                         1163
*   RESPECIFY                                                      1164
*     RET RESTRICTED;               /*                       @ZA33246*/
@RF01152 DS    0H                                                  1165
*   RET=RSAVLE;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLE                                          1165
*   RESPECIFY                                                      1166
*    (R1,                                                          1166
*     RET,                                                         1166
*     R15) UNRESTRICTED;            /*                       @ZA33246*/
*   END READJFCB;                                                  1167
@EL00017 DS    0H                                                  1167
@EF00017 DS    0H                                                  1167
@ER00017 BR    @14                                                 1167
*GETMAIN:                                                          1168
*                                                                  1168
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION  - OBTAINS STORAGE                                    */
*/*   INPUT -     1. AMOUNT OF STORAGE REQUESTED IN MAINLEN          */
*/*   OUTPUT  -   1. ADDRESS OF AREA OBTAINED IN MAINADDR            */
*/*                                                                  */
*/********************************************************************/
*                                                                  1168
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1168
GETMAIN  DS    0H                                                  1169
*   RESPECIFY                                                      1169
*    (R0,                                                          1169
*     R1,                                                          1169
*     R6,                                                          1169
*     R7,                                                          1169
*     R8,                                                          1169
*     R9,                                                          1169
*     RET) RESTRICTED;              /*                       @ZA33246*/
*   RSAVLF=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLF                                          1170
*   RESPECIFY                                                      1171
*     RET UNRESTRICTED;             /*                       @ZA33246*/
*   GEN(STM R6,R9,MAINSAVE)                                        1172
*   NOSETS;                         /* SAVE REGISTERS                */
         STM R6,R9,MAINSAVE
*   R7=MAINLEN;                     /* LOAD NUMBER OF BYTES REQD     */
         L     R7,MAINLEN-1                                        1173
         LA    R7,0(,R7)                                           1173
*   RESPECIFY                                                      1174
*     RETCODE RESTRICTED;                                          1174
*   GEN(GETMAIN EC,LV=(R7),A=MAINADDR,SP=0,MF=(E,MAINWORK))        1175
*   SETS(RETCODE);                                                 1175
         GETMAIN EC,LV=(R7),A=MAINADDR,SP=0,MF=(E,MAINWORK)
*   IF RETCODE=0 THEN               /* IF GETMAIN SUCCESSFUL         */
         LTR   RETCODE,RETCODE                                     1176
         BNZ   @RF01176                                            1176
*     DO;                                                          1177
*       R6=MAINADDR;                /* POINT TO BLOCK                */
         L     R6,MAINADDR                                         1178
*       R9=0;                       /* ZERO PAD CHARACTER            */
         SLR   R9,R9                                               1179
*       GEN(MVCL R6,R8)                                            1180
*       NOSETS;                     /* ZERO BLOCK                    */
         MVCL R6,R8
*     END;                                                         1181
*   IF RETCODE^=0 THEN              /* IF GETMAIN FAILED             */
@RF01176 LTR   RETCODE,RETCODE                                     1182
         BZ    @RF01182                                            1182
*     DO;                                                          1183
*       COREFAIL=ON;                /* INDICATE GETMAIN FAILURE      */
         OI    COREFAIL,B'00001000'                                1184
*       VVOLLPDC=PP20;              /* SET ERROR CODE        @Y30LSPS*/
         L     @14,VOLLPTR                                         1185
         MVI   VVOLLPDC(@14),X'14'                                 1185
*       IF EOVDM=ON THEN            /* VMT ENTRY FOUND       @Y30DSMD*/
         TM    EOVDM,B'00100000'                                   1186
         BNO   @RF01186                                            1186
*         DO;                       /* YES, CLEAR            @Y30DSMD*/
*           RUCB=VMTUCB(CTR);       /* SAVE UCB PTR          @Y30DSMD*/
         L     @14,VMTPT                                           1188
         SLR   @05,@05                                             1188
         IC    @05,CTR                                             1188
         SLA   @05,4                                               1188
         L     RUCB,VMTUCB-16(@05,@14)                             1188
*           VMTVOL(CTR)=VMTVOL(CTR)&&VMTVOL(CTR);/* CLEAR ENTRY    1189
*                                                            @Y30DSMD*/
         ST    @05,@TF00001                                        1189
         ALR   @05,@14                                             1189
         XC    VMTVOL-16(16,@05),VMTVOL-16(@05)                    1189
*           VMTUCB(CTR)=RUCB;       /* RESTORE UCB PTR       @Y30DSMD*/
         L     @11,@TF00001                                        1190
         ST    RUCB,VMTUCB-16(@11,@14)                             1190
*         END;                      /*                       @Y30DSMD*/
*       GOTO EXIT;                  /* GET OUT OF NORMAL PROCESSING  */
         B     EXIT                                                1192
*     END;                                                         1193
*   GEN(LM R6,R9,MAINSAVE)                                         1194
*   NOSETS;                         /* RESTORE REGISTERS             */
@RF01182 DS    0H                                                  1194
         LM R6,R9,MAINSAVE
*   RESPECIFY                                                      1195
*     RET RESTRICTED;               /*                       @ZA33246*/
*   RET=RSAVLF;                     /* RESTORE RETURN ADDRESS        */
         L     RET,RSAVLF                                          1196
*   RESPECIFY                                                      1197
*    (R0,                                                          1197
*     R1,                                                          1197
*     R6,                                                          1197
*     R7,                                                          1197
*     R8,                                                          1197
*     R9,                                                          1197
*     RET,                                                         1197
*     RETCODE) UNRESTRICTED;        /*                       @ZA33246*/
*   END GETMAIN;                                                   1198
@EL00018 DS    0H                                                  1198
@EF00018 DS    0H                                                  1198
@ER00018 BR    @14                                                 1198
*SETLOCK:                                                          1199
*                                                                  1199
*   /*****************************************************************/
*   /*                                                               */
*   /* SET THE UCB GOBAL SPIN LOCK ROUTINE NEW FOR VS2-2             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1199
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1199
SETLOCK  DS    0H                                                  1200
*   RESPECIFY                                                      1200
*    (R1,                                                          1200
*     R11,                                                         1200
*     RET) RESTRICTED;              /*                       @ZA33246*/
*   RSAVLD=RET;                     /* SAVE RETURN ADDRESS           */
         ST    RET,RSAVLD                                          1201
*   LOCKSAVA=R11;                   /* SAVE R11              @Y021130*/
         ST    R11,LOCKSAVA                                        1202
*   LOCKSAVB=R12;                   /* SAVE R12              @Y021130*/
         ST    R12,LOCKSAVB                                        1203
*   LOCKSAVC=R1;                    /* SAVE R1               @Y021130*/
         ST    R1,LOCKSAVC                                         1204
*   R1=R13;                         /* SAVE R13              @Y021130*/
         LR    R1,R13                                              1205
*   GEN SETS(R11,R12,R13,RET) REFS(PSALITA,FLC);                   1206
*                                                          /*@Y002113*/
      SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                           *
               RELATED=(LOCAL,IDA0192V(GOMOUNT,ALOCUNIT))
*   R13=R1;                         /* RESTORE R13           @Y021130*/
         LR    R13,R1                                              1207
*   R1=LOCKSAVC;                    /* RESTORE R1            @Y021130*/
         L     R1,LOCKSAVC                                         1208
*   R12=LOCKSAVB;                   /* RESTORE R12           @Y021130*/
         L     R12,LOCKSAVB                                        1209
*   R11=LOCKSAVA;                   /* RESTORE R11           @Y021130*/
         L     R11,LOCKSAVA                                        1210
*   RET=RSAVLD;                                                    1211
         L     RET,RSAVLD                                          1211
*   RESPECIFY                                                      1212
*    (R1,                                                          1212
*     R11,                                                         1212
*     RET) UNRESTRICTED;            /*                       @ZA33246*/
*   END SETLOCK;                                                   1213
@EL00019 DS    0H                                                  1213
@EF00019 DS    0H                                                  1213
@ER00019 BR    @14                                                 1213
*FREELOCK:                                                         1214
*                                                                  1214
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE THE UCB GLOBAL LOCK NEW FOR VS2-2                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1214
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1214
FREELOCK DS    0H                                                  1215
*   RESPECIFY                                                      1215
*    (R1,                                                          1215
*     R11,                                                         1215
*     RET) RESTRICTED;              /*                       @ZA33246*/
*   RSAVLD=RET;                     /* SAVE RETURN                   */
         ST    RET,RSAVLD                                          1216
*   LOCKSAVA=R11;                   /* SAVE R11              @Y021130*/
         ST    R11,LOCKSAVA                                        1217
*   LOCKSAVB=R12;                   /* SAVE R12              @Y021130*/
         ST    R12,LOCKSAVB                                        1218
*   LOCKSAVC=R1;                    /* SAVE R1               @Y021130*/
         ST    R1,LOCKSAVC                                         1219
*   R1=R13;                         /* SAVE R13              @Y021130*/
         LR    R1,R13                                              1220
*   GEN SETS(R11,R12,R13,RET) REFS(PSALITA,FLC);                   1221
*                                                          /*@Y002113*/
      SETLOCK RELEASE,TYPE=LOCAL,                                      *
               RELATED=(LOCAL,IDA0192V(GOMOUNT))
*   R13=R1;                         /* RESTORE R13           @Y021130*/
         LR    R13,R1                                              1222
*   R1=LOCKSAVC;                    /* RESTORE R1            @Y021130*/
         L     R1,LOCKSAVC                                         1223
*   R12=LOCKSAVB;                   /* RESTORE R12           @Y021130*/
         L     R12,LOCKSAVB                                        1224
*   R11=LOCKSAVA;                   /* RESTORE R11           @Y021130*/
         L     R11,LOCKSAVA                                        1225
*   RET=RSAVLD;                                                    1226
         L     RET,RSAVLD                                          1226
*   RESPECIFY                                                      1227
*    (R1,                                                          1227
*     R11,                                                         1227
*     RET) UNRESTRICTED;            /*                       @ZA33246*/
*   END FREELOCK;                                                  1228
@EL00020 DS    0H                                                  1228
@EF00020 DS    0H                                                  1228
@ER00020 BR    @14                                                 1228
@PB00020 DS    0H                                                  1228
*   END IDA0192V                                                   1229
*                                                                  1229
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IDAIDXCB)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IEESMCA )                                       */
*/*%INCLUDE SYSLIB  (IEFJSSOB)                                       */
*/*%INCLUDE SYSLIB  (IEFJESCT)                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                       */
*/*%INCLUDE SYSLIB  (IEZIOB  )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IEFAJCTB)                                       */
*/*%INCLUDE SYSLIB  (IEFASCTB)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IECSDSL1)                                       */
*/*%INCLUDE SYSLIB  (IDAERRCD)                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAVMT  )                                       */
*/*%INCLUDE SYSLIB  (IDABIB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAVIRT )                                       */
*/*%INCLUDE SYSLIB  (IDAVUCBL)                                       */
*/*%INCLUDE SYSLIB  (IDAVVOLL)                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  1229
*       ;                                                          1229
@DATA    DS    0H
@CH00882 DC    H'5'
@CH00033 DC    H'12'
@CH03571 DC    H'14'
@CH01746 DC    H'37'
@CH03065 DC    H'176'
@SM04582 MVC   0(0,@05),JFCBDSNM(@01)
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
@TF00001 DS    F
IDA0192V CSECT
         DS    0F
@CF00062 DC    F'1'
@CF00032 DC    F'3'
@CF00066 DC    F'4'
@CF00064 DC    F'8'
@CF00078 DC    F'16'
@CF00084 DC    F'28'
@CH00084 EQU   @CF00084+2
@CF00092 DC    F'44'
@CF00094 DC    F'48'
@CF03693 DC    F'58'
@CF03622 DC    F'164'
@CF04564 DC    F'476'
@CF04580 DC    F'-5'
@CF04584 DC    F'-4'
@DATD    DSECT
         DS    0D
IOBSTPTR DS    A
DEBPTR   DS    A
DEBDAPTR DS    A
VMTPT    DS    A
RSAVLA   DS    A
RSAVLB   DS    A
RSAVLC   DS    A
RSAVLD   DS    A
RSAVLE   DS    A
RSAVLF   DS    A
JFCBWKAP DS    A
CC       DS    F
DSNL     DS    F
TSPT     DS    A
TSCORELN DS    F
MSGDPTR  DS    A
UCBLPTR  DS    A
VOLLPTR  DS    A
C1       DS    F
C2       DS    F
DOMLISTP DS    A
CMLSTWKP DS    A
CCHHRPTR DS    A
MWAMTCNT DS    A
MWAJS3CT DS    A
MWASSMO  DS    A
RSAVLG   DS    A
CTR      DS    FL1
STCNT    DS    FL1
PPSAVE   DS    FL1
ERFLSAVE DS    FL1
VIRTPARM DS    CL24
LOCKSAV  DS    CL12
         ORG   LOCKSAV
LOCKSAVA DS    AL4
LOCKSAVB DS    AL4
LOCKSAVC DS    AL4
         ORG   LOCKSAV+12
QMIOP    DS    CL19
         ORG   QMIOP
QMITCBAD DS    AL4
QMIRECAD DS    AL4
QMIWRKAD DS    AL4
QMIDSKAD DS    CL4
QMIRECL  DS    FL2
QMIFLAGS DS    BL1
         ORG   QMIFLAGS
QMIOREAD DS    BL1
QMIOWRTE EQU   QMIFLAGS+0
         ORG   QMIOP+19
         DS    CL1
DXCB     DS    CL200
@NM00169 DS    CL24
         ORG   @NM00169
DXCCW1   DS    CL8
DXCCW2   DS    CL8
DXCCW3   DS    CL8
         ORG   @NM00169+24
DXDADDR  DS    CL8
DXECB    DS    CL4
MESSAGE  DS    CL72
         ORG   MESSAGE
MSGHDR   DS    CL4
         ORG   MSGHDR
MSGLSTSZ DS    FL2
MCSFLAGS DS    BL2
         ORG   MESSAGE+4
MESSAGEA DS    CL68
         ORG   MESSAGEA
MSGPTXT  DS    CL10
         ORG   MSGPTXT
MSGID    DS    CL3
MSGFID   DS    CL1
MSGSER   DS    CL5
         ORG   MSGSER
@NM00170 DS    CL4
MSGACT   DS    CL1
         ORG   MSGPTXT+9
@NM00171 DS    CL1
         ORG   MESSAGEA+10
MSGTEXT  DS    CL58
         ORG   MESSAGE+72
DXLBL    DS    CL80
         ORG   DXLBL
@NM00172 DS    CL4
VOLSERNO DS    CL6
@NM00173 DS    CL1
F4CCHHR  DS    CL5
         ORG   DXLBL+80
LSPAPARM DS    CL4
         ORG   LSPAPARM
@NM00191 DS    BL1
         ORG   @NM00191
LSPAREQD DS    BL1
         ORG   LSPAPARM+1
LSPAPTR  DS    AL3
         ORG   LSPAPARM+4
RVOL     DS    CL6
BITBANK  DS    BL2
         ORG   BITBANK
@NM00196 DS    BL1
VMTHIT   EQU   BITBANK+0
EOVDM    EQU   BITBANK+0
NOMOUNT  EQU   BITBANK+0
COREFAIL EQU   BITBANK+0
JFCBREAD EQU   BITBANK+0
FAEVUCBL EQU   BITBANK+0
DMSG     EQU   BITBANK+0
TSCORE   DS    BL1
CAMCORE  EQU   BITBANK+1
CCHHRCRE EQU   BITBANK+1
MOUNTED  EQU   BITBANK+1
         ORG   BITBANK+2
MAINPARM DS    CL36
         ORG   MAINPARM
MAINSAVE DS    4F
MAINWORK DS    3F
MAINR0   DS    CL4
         ORG   MAINR0
MAINPOOL DS    FL1
MAINLEN  DS    FL3
         ORG   MAINPARM+32
MAINADDR DS    AL4
         ORG   MAINPARM+36
MWAJS3PM DS    CL4
         ORG   MWAJS3PM
MWAJS3ID DS    BL1
@NM00201 EQU   MWAJS3PM+0
MWASSOB  DS    AL3
         ORG   MWAJS3PM+4
MWASWTCH DS    BL1
MWAFLAG  DS    BL1
         ORG   MWAFLAG
@NM00202 DS    BL1
MWAFGFIN EQU   MWAFLAG+0
@NM00203 EQU   MWAFLAG+0
         ORG   MWAFLAG+1
@NM00167 DS    CL1
IDA0192V CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV04514 DC    V(IDA0192D)
@CV04518 DC    V(IDA0192C)
         DS    0D
@CC04458 DC    C'SSOB'
@CC04230 DC    C'IEC'
@CB04491 DC    X'0000000000000003'
@CB04476 EQU   @CB04491
@CB04519 EQU   @CB04491
@CB04489 EQU   @CB04491
@CB04490 DC    X'7FFF'
@CB04222 DC    B'1000000000000000'
GMFAIL   DC    X'14140000'
TSZERO   DC    X'0000000000000000'
MSGDESC  DS    CL40
         ORG   MSGDESC
M01A     DS    CL10
         ORG   M01A
@NM00176 DC    CL5'01A M'
@NM00177 DC    X'F440001000'
         ORG   MSGDESC+10
M03E     DS    CL10
         ORG   M03E
@NM00178 DC    CL5'03E R'
@NM00179 DC    X'FC20001000'
         ORG   MSGDESC+20
M11E     DS    CL10
         ORG   M11E
@NM00180 DC    CL5'11E D'
@NM00181 DC    X'C020001000'
         ORG   MSGDESC+30
M14E     DS    CL10
         ORG   M14E
@NM00182 DC    CL5'14E D'
@NM00183 DC    X'8020001000'
         ORG   MSGDESC+40
SEEK     DC    X'C080'
IDA0192V CSECT
         DS    0D                       START ON DOUBLE WORD BOUNDARY
PTCH192V DC    ((*-IDA0192V)/20)X'00'   PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192V CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
OBTERR   EQU   @06
DCBPTR   EQU   @05
CTR1     EQU   @05
F4PTR    EQU   @06
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
R13      EQU   @13
RCORE    EQU   @04
R4       EQU   @04
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
RTIOT    EQU   @09
R9       EQU   @09
RUCB     EQU   @10
R11      EQU   @11
RET      EQU   @14
RETCODE  EQU   @15
R15      EQU   @15
R14      EQU   @14
MDREG1   EQU   @01
RDEB     EQU   @11
R10      EQU   @10
R5       EQU   @05
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTXAPG  EQU   CVTMAP+20
CVTPCNVT EQU   CVTMAP+28
CVTPRLTV EQU   CVTMAP+32
CVTMSLT  EQU   CVTMAP+60
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTSMCA  EQU   CVTMAP+196
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTAMFF  EQU   CVTMAP+264
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTJESCT EQU   CVTMAP+296
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
@NM00003 EQU   0
TCBPTR   EQU   @NM00003+4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBTIO   EQU   TCB+12
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFERA  EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBSYSTK EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFLGS3 EQU   TCBFLGS+2
TCBADINP EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBDWSTA EQU   TCBFLGS3
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBFTJST EQU   TCB+44
TCBJPQ   EQU   TCBFTJST
TCBPURGE EQU   TCBJPQ
TCBFTJSA EQU   TCBJPQ+1
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBIDF   EQU   TCBFSA
TCBTME   EQU   TCB+120
TCBPIB   EQU   TCB+124
TCBJSTCB EQU   TCBPIB
TCBPIBT  EQU   TCBJSTCB
TCBPIBA  EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBPQE   EQU   TCB+152
TCBFTFLG EQU   TCBPQE+1
TCBFTFL1 EQU   TCBFTFLG
TCBFTFL2 EQU   TCBFTFLG+1
TCBFTFL3 EQU   TCBFTFLG+2
TCBAQE   EQU   TCB+156
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBXCTL  EQU   TCBNSTAE
TCBSCAT  EQU   TCBNSTAE
TCBSUPER EQU   TCBNSTAE
TCBRETRY EQU   TCBNSTAE
TCBVALID EQU   TCBNSTAE
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBLJSND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBNDINT EQU   TCBNDSP3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBCPU   EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBNTJS  EQU   TCBFLGS6
TCBFLGS7 EQU   TCBBITS+3
TCBGPECB EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBPCB   EQU   TCB+212
TCBARB   EQU   TCB+220
TCBTTQE  EQU   TCB+224
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00023 EQU   RBSECT+10
@NM00024 EQU   @NM00023
RBTRSVRB EQU   @NM00024
@NM00026 EQU   @NM00023+1
RBETXR   EQU   @NM00026
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00033 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00037 EQU   RBSECT+96
RBRSV138 EQU   @NM00037+7
RBRSV150 EQU   RBSECT+167
SMCABASE EQU   0
SMCAOPT  EQU   SMCABASE
SMCAVOL  EQU   SMCAOPT
SMCAMISC EQU   SMCABASE+1
SMCABUF  EQU   SMCABASE+12
SMCAPSTA EQU   SMCABASE+30
SMCAPLBL EQU   SMCABASE+34
SMCASTA  EQU   SMCABASE+46
SMCAALBL EQU   SMCABASE+50
SMCAENTY EQU   SMCABASE+80
SMCAENDI EQU   SMCAENTY
SMCAFOPT EQU   SMCABASE+82
SMCASWA  EQU   SMCABASE+104
SMCAASCB EQU   SMCABASE+120
SMCAPGIN EQU   SMCABASE+136
SMCAPGOT EQU   SMCABASE+140
SSOB     EQU   0
SSOBID   EQU   SSOB
SSOBLEN  EQU   SSOB+4
SSOBFUNC EQU   SSOB+6
SSOBRETN EQU   SSOB+12
SSOBINDV EQU   SSOB+16
SSMO     EQU   0
SSMOLEN  EQU   SSMO
SSMOFLG1 EQU   SSMO+2
SSMOPNAM EQU   SSMO+4
SSMOPSTN EQU   SSMO+8
SSMOPUAD EQU   SSMO+12
SSMOPVOL EQU   SSMO+16
JESCT    EQU   0
JESWAA   EQU   JESCT+8
JESRESQM EQU   JESCT+16
JESSSREQ EQU   JESCT+20
JESALLOC EQU   JESCT+32
JESUNALC EQU   JESCT+36
JESCATL  EQU   JESCT+40
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBVRDEV EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBSTAT  EQU   UCBOB+3
UCBRESV  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBCHA   EQU   UCBCHAN
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBNOTRD EQU   UCBNRY
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00045 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
TIOT1    EQU   0
TIOCNJOB EQU   TIOT1
TIOCSTEP EQU   TIOT1+8
TIOENTRY EQU   0
TIOELNGH EQU   TIOENTRY
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOEJFCB EQU   TIOENTRY+12
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
TIOEFSRT EQU   TIOENTRY+17
POOLSTAR EQU   TIOENTRY+20
IOBPREFX EQU   0
IOBCFLG1 EQU   IOBPREFX
IOBSTDRD EQU   0
IOBFLAG1 EQU   IOBSTDRD
IOBCYCCK EQU   IOBFLAG1
IOBUNREL EQU   IOBFLAG1
IOBRSTRT EQU   IOBFLAG1
IOBFLAG2 EQU   IOBSTDRD+1
IOBPURGE EQU   IOBFLAG2
IOBRDHA0 EQU   IOBFLAG2
IOBSENS0 EQU   IOBSTDRD+2
IOBS0B7  EQU   IOBSENS0
IOBSENS1 EQU   IOBSTDRD+3
IOBECBPT EQU   IOBSTDRD+4
IOBFLAG3 EQU   IOBSTDRD+8
IOBFL3   EQU   IOBFLAG3
IOBCNC   EQU   IOBFL3
IOBICL   EQU   IOBFL3
IOBCSW   EQU   IOBSTDRD+9
IOBIOCSW EQU   IOBCSW
IOBSTBYT EQU   IOBIOCSW+3
IOBUSTAT EQU   IOBSTBYT
IOBCSTAT EQU   IOBSTBYT+1
IOBSTART EQU   IOBSTDRD+16
IOBDCBPT EQU   IOBSTDRD+20
IOBFLAG4 EQU   IOBDCBPT
IOBRESTR EQU   IOBSTDRD+24
IOBINCAM EQU   IOBSTDRD+28
IOBBTAMF EQU   IOBINCAM
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBNMEXT EQU   DEBUSRPG
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBDEBID EQU   DEBPROTG
DEBDCBB  EQU   DEBDCBAD+1
DEBAPPAD EQU   DEBBASIC+28
DEBEXSCL EQU   DEBAPPAD
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBUCBA  EQU   DEBUCBAD+1
DEBSTRCC EQU   DEBDASD+6
DEBSTRHH EQU   DEBDASD+8
DEBENDCC EQU   DEBDASD+10
DEBENDHH EQU   DEBDASD+12
DEBNMTRK EQU   DEBDASD+14
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
INJMJCT  EQU   0
JCTJSTAT EQU   INJMJCT+5
INDMCTLG EQU   JCTJSTAT
JCTJBYTE EQU   INJMJCT+7
JCTJMGLV EQU   JCTJBYTE
JCTJNAME EQU   INJMJCT+8
JCTCCODE EQU   INJMJCT+54
JCTRSW1  EQU   INJMJCT+86
JCTRSW2  EQU   INJMJCT+87
JCTJSB   EQU   INJMJCT+111
JCTSTAT2 EQU   INJMJCT+116
IEFAACTB EQU   0
INSMSCT  EQU   0
SCTSSTAT EQU   INSMSCT+4
SCTSNUMB EQU   INSMSCT+64
SCTSTYPE EQU   INSMSCT+67
SCTSDPTY EQU   INSMSCT+94
SCTSTAT2 EQU   INSMSCT+104
SCTBCT   EQU   SCTSTAT2
SCTCDENT EQU   INSMSCT+118
SCTSTEND EQU   INSMSCT+172
@NM00095 EQU   0
SCTABCND EQU   @NM00095
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IECSDSF4 EQU   0
IECSDSL4 EQU   0
DS4DEVCT EQU   IECSDSL4+18
DS4DEVOV EQU   DS4DEVCT+6
DS4AMTIM EQU   IECSDSL4+32
DS4AMCAT EQU   IECSDSL4+40
DS4VSIND EQU   DS4AMCAT
DS4VSBAD EQU   DS4VSIND
DS4R2TIM EQU   IECSDSL4+43
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBPAMBL EQU   IDAAMB+76
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAVMT   EQU   0
VMTHDR   EQU   IDAVMT
VMTNXT   EQU   IDAVMT+4
VMTNOVOL EQU   IDAVMT+8
VMTDEV   EQU   IDAVMT+13
VMTDVTYP EQU   VMTDEV+1
VMTVOL   EQU   IDAVMT+16
VMTUSECT EQU   VMTVOL
VMTVFLG1 EQU   VMTVOL+4
VMTVLSER EQU   VMTVOL+6
VMTUCB   EQU   VMTVOL+12
IDABIB   EQU   0
BIBHDR   EQU   IDABIB
BIBFLG1  EQU   BIBHDR+1
BIBVMT   EQU   IDABIB+12
BIBRTNS  EQU   IDABIB+60
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDNEST  EQU   IDAAMDSB+4
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDFAULT EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDSTAT  EQU   IDAAMDSB+48
IDAAMBL  EQU   0
AMBLACB  EQU   IDAAMBL+8
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
IDAVIRT  EQU   0
VIRTFLAG EQU   IDAVIRT+1
VIRTBUCB EQU   VIRTFLAG
VIRTACB  EQU   IDAVIRT+4
VIRTUCB  EQU   IDAVIRT+8
JFCBWRKA EQU   0
JESWORK  EQU   JFCBWRKA
JFCB     EQU   JFCBWRKA+300
JFCBDSNM EQU   JFCB
IHADCB   EQU   0
DCBDEBAD EQU   IHADCB+44
VOLSTS   EQU   0
VLID     EQU   VOLSTS
VLSFI    EQU   VOLSTS+1
VLENTNO  EQU   VOLSTS+6
VLCATACB EQU   VOLSTS+8
VLSERTS  EQU   VOLSTS+12
VLSER    EQU   VLSERTS
VLTS     EQU   VLSERTS+6
MSGREQD  EQU   0
MSGRID   EQU   MSGREQD
MSGRDESC EQU   MSGREQD+5
MSGRUNIT EQU   MSGRDESC
MSGRVSR  EQU   MSGRDESC
MSGRJOB  EQU   MSGRDESC
MSGRSTEP EQU   MSGRDESC
MSGRSP   EQU   MSGRDESC
MSGRDSN  EQU   MSGRDESC
DESCROUT EQU   MSGREQD+6
DOMBIT   EQU   DESCROUT
IDAVUCBL EQU   0
@NM00184 EQU   IDAVUCBL
VUCBLID  EQU   @NM00184
VUCBLNBR EQU   IDAVUCBL+2
VUCBLVLA EQU   IDAVUCBL+4
VUCBLENT EQU   IDAVUCBL+8
@NM00187 EQU   VUCBLENT
VUCBLALC EQU   @NM00187
VUCBLBAD EQU   @NM00187
VUCBLADR EQU   VUCBLENT+1
MSLT     EQU   0
@NM00189 EQU   MSLT+136
MSSSDSN  EQU   @NM00189
MSSSPACE EQU   @NM00189
IDAVVOLL EQU   0
@NM00192 EQU   IDAVVOLL
VVOLLOPE EQU   @NM00192
VVOLLEOV EQU   @NM00192
VVOLLSWD EQU   @NM00192
VVOLLNBR EQU   IDAVVOLL+2
VVOLLTAB EQU   IDAVVOLL+4
VVOLLACB EQU   IDAVVOLL+8
VVOLLERR EQU   IDAVVOLL+12
VVOLLPDC EQU   VVOLLERR
VVOLLFNC EQU   VVOLLERR+1
VVOLLSFC EQU   VVOLLERR+2
VVOLLCNT EQU   VVOLLERR+3
VVOLLSFI EQU   IDAVVOLL+16
VVOLLBIB EQU   IDAVVOLL+28
VVOLLDEB EQU   IDAVVOLL+32
VVOLLENT EQU   IDAVVOLL+36
VVOLLUCB EQU   VVOLLENT
@NM00195 EQU   VVOLLENT+4
VVOLLMNT EQU   @NM00195
VVOLLVFY EQU   @NM00195
VVOLLVSR EQU   VVOLLENT+6
DOMLIST  EQU   0
DOMENT   EQU   0
DOMLAST  EQU   DOMENT
DOMID    EQU   DOMENT+4
CMLSTWKA EQU   0
CAMFUNC  EQU   CMLSTWKA
CAMDSNA  EQU   CMLSTWKA+4
CAMVOLSR EQU   CMLSTWKA+8
CAMWKAP  EQU   CMLSTWKA+12
CAMWKA   EQU   CMLSTWKA+16
CAMF4    EQU   CAMWKA+44
CCHHRF4  EQU   0
VMNTLST  EQU   0
MDFLG    EQU   VMNTLST+6
MNTEXTP  EQU   VMNTLST+24
DMNTLST  EQU   0
DMNTFLAG EQU   DMNTLST+6
IEFAB4F5 EQU   0
IEFBB410 EQU   0
IEFW21SD EQU   0
INDMDSNT EQU   0
SSREQ    EQU   0
SWAMGR   EQU   0
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
TCBS01   EQU   TCBPCB
TCBFOE   EQU   TCBS01+32
TCBESTAE EQU   TCBS01+52
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCBS01+64
TCBFBYT2 EQU   TCBS01+65
TCBRV124 EQU   TCBS01+66
TCBRV133 EQU   TCBS01+67
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
UCBOBS01 EQU   UCBDEV
UCBVTOC  EQU   UCBOBS01
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00044 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
IOBORG01 EQU   IOBPREFX+8
IOBNIOBA EQU   IOBORG01
IOBNFLG1 EQU   IOBNIOBA
IOBPRTOV EQU   IOBNFLG1
IOBORG02 EQU   IOBPREFX+8
IOBDQADA EQU   IOBORG02
IOBDEQIN EQU   IOBDQADA
IOBORG03 EQU   IOBPREFX+12
IOBORG04 EQU   IOBINCAM
IOBORG12 EQU   IOBINCAM
IOBFL4   EQU   IOBORG12
IOBEXTEN EQU   IOBSTDRD+32
IOBSEEK  EQU   IOBEXTEN
IOBBB    EQU   IOBSEEK+1
IOBCC    EQU   IOBSEEK+3
IOBHH    EQU   IOBSEEK+5
IOBORG05 EQU   IOBEXTEN
IOBORG06 EQU   IOBEXTEN
IOBNXTPT EQU   IOBORG06+4
IOBSTATA EQU   IOBNXTPT
IOBORG07 EQU   IOBEXTEN+8
W1IEXTEN EQU   IOBORG07
IOBORG08 EQU   IOBEXTEN+8
IOBINDCT EQU   IOBORG08+4
IOBUNSQR EQU   IOBORG08+5
IOBFCHAD EQU   IOBORG08+8
IOBORG09 EQU   IOBEXTEN+8
IOBDPLAD EQU   IOBORG09+4
IOBDTYPE EQU   IOBORG09+8
IOBDTYP2 EQU   IOBORG09+9
IOBDSTAT EQU   IOBORG09+10
IOBSTAT1 EQU   IOBDSTAT
IOBORG10 EQU   IOBEXTEN+8
IOBSEEK2 EQU   IOBORG10
IOBORG11 EQU   IOBEXTEN
IOBERCT  EQU   IOBORG11
IOBUCBXV EQU   IOBERCT
IOBNAME  EQU   IOBORG11+4
IOBORG13 EQU   IOBEXTEN
IOBSKADR EQU   IOBORG13
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
@NM00199 EQU   CVTAMFF
ACVTDBUG EQU   @NM00199+2
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00200 EQU   @NM00199
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00055 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00054 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
IOBSKSS  EQU   IOBSKADR+3
IOBSK0   EQU   IOBSKADR+2
IOBSKTT  EQU   IOBSKADR+1
IOBSKRV  EQU   IOBSKADR
IOBCSWSV EQU   IOBORG11+17
IOBSENSV EQU   IOBORG11+16
IOBRCD   EQU   IOBORG11+12
IOBMDREC EQU   IOBORG11+8
IOBNAMEA EQU   IOBNAME+1
IOBNAMSZ EQU   IOBNAME
IOBERCTA EQU   IOBERCT+1
IOBRTYPE EQU   IOBUCBXV
IOBRDCHP EQU   IOBORG10+20
IOBNEXTA EQU   IOBORG10+16
IOBREADA EQU   IOBORG10+12
IOBBUFC  EQU   IOBORG10+8
IOBSK2R  EQU   IOBSEEK2+7
IOBSK2HH EQU   IOBSEEK2+5
IOBSK2CC EQU   IOBSEEK2+3
IOBSK2BB EQU   IOBSEEK2+1
IOBSK2M  EQU   IOBSEEK2
IOBCHNPR EQU   IOBORG09+40
IOBDNCRF EQU   IOBORG09+32
IOBRSV35 EQU   IOBORG09+24
IOBDQPTR EQU   IOBORG09+20
IOBRSV34 EQU   IOBORG09+18
IOBDBYTN EQU   IOBORG09+16
IOBDCPND EQU   IOBORG09+12
IOBSTAT2 EQU   IOBDSTAT+1
IOBSIORT EQU   IOBSTAT1
IOBADDVU EQU   IOBSTAT1
IOBBUFF  EQU   IOBSTAT1
IOBENQUE EQU   IOBSTAT1
IOBPASS2 EQU   IOBSTAT1
IOBSYNCH EQU   IOBSTAT1
IOBNEWVL EQU   IOBSTAT1
IOBABNRM EQU   IOBSTAT1
IOBRELEX EQU   IOBDTYP2
IOBADDTY EQU   IOBDTYP2
IOBTYPE  EQU   IOBDTYP2
IOBRQUST EQU   IOBDTYP2
IOBSUFFX EQU   IOBDTYP2
IOBSBLKL EQU   IOBDTYP2
IOBSKEY  EQU   IOBDTYP2
IOBRELBL EQU   IOBDTYPE
IOBRDEXC EQU   IOBDTYPE
IOBDYNBF EQU   IOBDTYPE
IOBACTAD EQU   IOBDTYPE
IOBFDBCK EQU   IOBDTYPE
IOBEXTSC EQU   IOBDTYPE
IOBOVFLO EQU   IOBDTYPE
IOBVERFY EQU   IOBDTYPE
IOBDPLB  EQU   IOBDPLAD+1
IOBDAYLI EQU   IOBDPLAD
IOBDIOBS EQU   IOBORG09+2
IOBDBYTR EQU   IOBORG09
IOBBCHAD EQU   IOBORG08+12
IOBFCHNB EQU   IOBFCHAD+1
IOBCOUNT EQU   IOBFCHAD
IOBASYN  EQU   IOBORG08+7
IOBAPP   EQU   IOBORG08+6
IOBRSV32 EQU   IOBUNSQR
IOBRSV31 EQU   IOBUNSQR
IOBRSV30 EQU   IOBUNSQR
IOBKNRWR EQU   IOBUNSQR
IOBKNWR  EQU   IOBUNSQR
IOBNTAV2 EQU   IOBUNSQR
IOBNTAV1 EQU   IOBUNSQR
IOBCPBSY EQU   IOBUNSQR
IOBCHNNL EQU   IOBINDCT
IOBRSV29 EQU   IOBINDCT
IOBRSV28 EQU   IOBINDCT
IOBRSV27 EQU   IOBINDCT
IOBKEYAD EQU   IOBINDCT
IOBOVPTR EQU   IOBINDCT
IOBUNSCH EQU   IOBINDCT
IOBDEQCP EQU   IOBINDCT
IOBCCWAD EQU   IOBORG08
W1OEXTEN EQU   W1IEXTEN
IOBCCW   EQU   IOBORG06+8
IOBNXTPB EQU   IOBNXTPT+1
IOBRSV26 EQU   IOBSTATA
IOBRSV25 EQU   IOBSTATA
IOBRSV24 EQU   IOBSTATA
IOBRSV23 EQU   IOBSTATA
IOBRSV22 EQU   IOBSTATA
IOBRSV21 EQU   IOBSTATA
IOBRSV20 EQU   IOBSTATA
IOBAVLFL EQU   IOBSTATA
IOBRSV37 EQU   IOBORG06+1
IOBUCBXG EQU   IOBORG06
IOBCPA   EQU   IOBORG05+32
IOBERINF EQU   IOBORG05+16
IOBERCCW EQU   IOBORG05+8
IOBSNDPT EQU   IOBORG05+7
IOBRCVPT EQU   IOBORG05+6
IOBWORK  EQU   IOBORG05+1
IOBUCBX  EQU   IOBORG05
IOBR     EQU   IOBSEEK+7
IOBHH2   EQU   IOBHH+1
IOBHH1   EQU   IOBHH
IOBCC2   EQU   IOBCC+1
IOBCC1   EQU   IOBCC
IOBBB2   EQU   IOBBB+1
IOBBB1   EQU   IOBBB
IOBM     EQU   IOBSEEK
IOBRSV46 EQU   IOBFL4
IOBRSV47 EQU   IOBFL4
IOBENT   EQU   IOBFL4
IOBEQP   EQU   IOBFL4
IOBBUS   EQU   IOBFL4
IOBDCK   EQU   IOBFL4
IOBREJ   EQU   IOBFL4
IOBOVR   EQU   IOBFL4
IOBCRILC EQU   IOBORG04+1
IOBCRDCC EQU   IOBORG04
IOBGQECB EQU   IOBORG03
IOBSWAP  EQU   IOBORG02+4
IOBDQADB EQU   IOBDQADA+1
IOBRSV13 EQU   IOBDEQIN
IOBRSV12 EQU   IOBDEQIN
IOBRSV11 EQU   IOBDEQIN
IOBRSV10 EQU   IOBDEQIN
IOBRSV09 EQU   IOBDEQIN
IOBRSV08 EQU   IOBDEQIN
IOBRSV07 EQU   IOBDEQIN
IOBDEQ   EQU   IOBDEQIN
IOBNECB  EQU   IOBORG01+4
IOBNIOBB EQU   IOBNIOBA+1
IOBFIRST EQU   IOBNFLG1
IOBUPERR EQU   IOBNFLG1
IOBSPAN  EQU   IOBNFLG1
IOBBKSPC EQU   IOBNFLG1
IOBUPDAT EQU   IOBNFLG1
IOBREAD  EQU   IOBNFLG1
IOBWRITE EQU   IOBNFLG1
IOBSEGMT EQU   IOBPRTOV
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00044
UCBSKPFG EQU   @NM00044
UCBRIPND EQU   @NM00044
UCBRTIAC EQU   @NM00044
UCBRSV79 EQU   @NM00044
UCBRSV78 EQU   @NM00044
UCBRSV77 EQU   @NM00044
UCBOLTEP EQU   @NM00044
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00043 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00038 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBCDSAVE EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
@NM00010 EQU   TCBS01+84
TCBSVCA2 EQU   TCBS01+80
TCBSWASA EQU   TCBS01+76
TCBDBTB  EQU   TCBS01+72
TCBRPT   EQU   TCBS01+68
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCBS01+62
TCBCCPVI EQU   TCBS01+60
TCBUKYSP EQU   TCBS01+56
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCBS01+48
TCBTCBID EQU   TCBS01+44
TCBRSV96 EQU   TCBS01+40
TCBSWA   EQU   TCBS01+36
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCBS01+28
TCBRSV41 EQU   TCBS01+27
TCBTID   EQU   TCBS01+26
TCBRSVAA EQU   TCBS01+25
TCBABCUR EQU   TCBS01+24
TCBTMSAV EQU   TCBS01+20
TCBIOTIM EQU   TCBS01+16
TCBRTWA  EQU   TCBS01+12
TCBBACK  EQU   TCBS01+8
TCBTIRB  EQU   TCBS01+4
TCBAECB  EQU   TCBS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
DMNTVUA  EQU   DMNTLST+26
DMNTRES2 EQU   DMNTLST+25
DMHOST   EQU   DMNTLST+20
DMNTECB  EQU   DMNTLST+16
DMNTASID EQU   DMNTLST+14
DMVOL    EQU   DMNTLST+8
DMBITRES EQU   DMNTFLAG
DMVUAVAL EQU   DMNTFLAG
DMDELRSP EQU   DMNTFLAG
DMBITRE1 EQU   DMNTFLAG
DMNTRES1 EQU   DMNTLST+5
DMOPCD   EQU   DMNTLST+4
DMLEN    EQU   DMNTLST
MDJFCB   EQU   MNTEXTP
@NM00207 EQU   VMNTLST+21
MDHOST   EQU   VMNTLST+16
MDVUA    EQU   VMNTLST+14
MDVOL    EQU   VMNTLST+8
@NM00206 EQU   MDFLG
MDMEXT   EQU   MDFLG
MDSRTCH  EQU   MDFLG
MDVSVRQ  EQU   MDFLG
MDVISMNT EQU   MDFLG
@NM00205 EQU   MDFLG
@NM00204 EQU   VMNTLST+5
MDOPCD   EQU   VMNTLST+4
MDLEN    EQU   VMNTLST
@NM00198 EQU   CAMWKA
@NM00197 EQU   CMLSTWKA+2
@NM00194 EQU   IDAVVOLL+1
VVOLLCAT EQU   @NM00192
VVOLLTIO EQU   @NM00192
VVOLLID  EQU   @NM00192
@NM00193 EQU   @NM00192
@NM00190 EQU   @NM00189
@NM00188 EQU   MSLT
@NM00186 EQU   IDAVUCBL+1
VUCBLFAE EQU   @NM00184
@NM00185 EQU   @NM00184
@NM00175 EQU   DESCROUT
@NM00174 EQU   VOLSTS+4
@NM00168 EQU   IHADCB
@NM00166 EQU   IDAVIRT+22
VIRTLENG EQU   IDAVIRT+20
VIRTTIOE EQU   IDAVIRT+16
VIRTEXT  EQU   IDAVIRT+12
@NM00165 EQU   IDAVIRT+2
VIRTMNT  EQU   VIRTFLAG
VIRTBEXT EQU   VIRTFLAG
VIRTBACB EQU   VIRTFLAG
VIRTNOUN EQU   VIRTFLAG
VIRTINHB EQU   VIRTFLAG
VIRTACQ  EQU   VIRTFLAG
@NM00164 EQU   IDAVIRT
AMBLCMB  EQU   IDAAMBL+64
AMBLBIB  EQU   IDAAMBL+60
AMBLIX   EQU   IDAAMBL+56
AMBLDTA  EQU   IDAAMBL+52
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00163 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00162 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00161 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00160 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00159 EQU   IDAAMBL+31
@NM00158 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00157 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00156 EQU   IDAAMDSB+41
@NM00155 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDCINV  EQU   IDAAMDSB+20
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDKEYLN EQU   IDAAMDSB+8
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
BIBVSRTP EQU   IDABIB+104
BIBASCB  EQU   IDABIB+100
BIBDDNM  EQU   IDABIB+92
BIBSTPNM EQU   IDABIB+84
BIBJOBNM EQU   IDABIB+76
BIBSIOAP EQU   BIBRTNS+12
BIBASYRT EQU   BIBRTNS+8
BIBCEAPP EQU   BIBRTNS+4
BIBINTRF EQU   BIBRTNS
BIBVGTT  EQU   IDABIB+56
BIBPSAB  EQU   IDABIB+52
BIBCSL   EQU   IDABIB+48
BIBWSHD  EQU   IDABIB+44
BIBVCRT  EQU   IDABIB+40
BIBHEBFQ EQU   IDABIB+36
BIBHEBPT EQU   IDABIB+32
BIBPRSPH EQU   IDABIB+28
BIBSPHPT EQU   IDABIB+24
BIBPAMBL EQU   IDABIB+20
BIBDACB  EQU   IDABIB+16
BIBUPT   EQU   IDABIB+8
@NM00154 EQU   IDABIB+5
BIBFLG2  EQU   IDABIB+4
BIBLEN   EQU   BIBHDR+2
@NM00153 EQU   BIBFLG1
BIBCKPT  EQU   BIBFLG1
BIBREST  EQU   BIBFLG1
BIBVIRT  EQU   BIBFLG1
BIBID    EQU   BIBHDR
@NM00152 EQU   VMTVOL+5
@NM00151 EQU   VMTVFLG1
VMTOPEN  EQU   VMTVFLG1
VMTDVOPT EQU   VMTDEV
@NM00150 EQU   IDAVMT+10
VMTLEN   EQU   VMTHDR+2
@NM00149 EQU   VMTHDR+1
VMTID    EQU   VMTHDR
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00148 EQU   AMBCSWD1+1
@NM00147 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00146 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPIXP  EQU   IDAAMB+72
@NM00145 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00144 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00143 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00142 EQU   AMBINFL
@NM00141 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00140 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00139 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00138 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00137 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
DS4END   EQU   IECSDSL4+96
@NM00136 EQU   IECSDSL4+71
DS4VTOCE EQU   IECSDSL4+61
DS4F6PTR EQU   IECSDSL4+56
@NM00135 EQU   IECSDSL4+51
DS4VSCRA EQU   DS4AMCAT+1
@NM00134 EQU   DS4VSIND
DS4VSREF EQU   DS4VSIND
DS4DEVDB EQU   DS4DEVCT+13
DS4DEVDT EQU   DS4DEVCT+12
DS4DEVTL EQU   DS4DEVCT+10
DS4DEVFG EQU   DS4DEVCT+9
DS4DEVK  EQU   DS4DEVCT+8
DS4DEVL  EQU   DS4DEVOV+1
DS4DEVI  EQU   DS4DEVOV
DS4DEVTK EQU   DS4DEVCT+4
DS4DEVSZ EQU   DS4DEVCT
@NM00133 EQU   IECSDSL4+16
DS4NOEXT EQU   IECSDSL4+15
DS4VTOCI EQU   IECSDSL4+14
DS4NOATK EQU   IECSDSL4+12
DS4HCCHH EQU   IECSDSL4+8
DS4DSREC EQU   IECSDSL4+6
DS4HPCHR EQU   IECSDSL4+1
DS4IDFMT EQU   IECSDSL4
@NM00132 EQU   IECSDSF4
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00131 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00130 EQU   ACBINFLG
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00129 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00128 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00127 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00126 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00125 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00124 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00123 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00122 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
@NM00097 EQU   @NM00095+1
SCTONLY  EQU   SCTABCND
SCTEVEN  EQU   SCTABCND
SCTABEND EQU   SCTABCND
SCTONLYC EQU   SCTABCND
SCTABCAN EQU   SCTABCND
@NM00096 EQU   SCTABCND
@NM00094 EQU   INSMSCT+173
@NM00093 EQU   SCTSTEND
SCTSYSCK EQU   SCTSTEND
SCTSTPND EQU   SCTSTEND
SCTSTSRT EQU   SCTSTEND
@NM00092 EQU   INSMSCT+168
SCTCATCT EQU   INSMSCT+166
SCTSDPSA EQU   SCTCDENT+3
SCTSDPOP EQU   SCTCDENT+2
SCTSDPCD EQU   SCTCDENT
@NM00091 EQU   INSMSCT+117
SCTPRFMF EQU   INSMSCT+116
SCTPGMNM EQU   INSMSCT+108
SCTTIOT  EQU   INSMSCT+105
@NM00090 EQU   SCTBCT
SCTJBEND EQU   SCTBCT
SCTSPSYS EQU   SCTBCT
SCTSTPLB EQU   SCTBCT
@NM00089 EQU   SCTBCT
SCTMCVOL EQU   SCTBCT
@NM00088 EQU   SCTBCT
SCTGOTTR EQU   INSMSCT+100
SCTSMF   EQU   INSMSCT+96
@NM00087 EQU   SCTSDPTY+1
SCTSDP   EQU   SCTSDPTY
SCTFSTEP EQU   SCTSDPTY
@NM00086 EQU   SCTSDPTY
@NM00085 EQU   SCTSDPTY
SCTNIUSL EQU   INSMSCT+92
@NM00084 EQU   INSMSCT+90
SCTMSSZE EQU   INSMSCT+88
SCTPCAT  EQU   INSMSCT+84
SCTLDSTB EQU   INSMSCT+80
SCTSRBT  EQU   INSMSCT+76
SCTMSADR EQU   INSMSCT+72
@NM00083 EQU   INSMSCT+71
SCTXBTTR EQU   INSMSCT+68
SCTJSCAT EQU   SCTSTYPE
SCTINITB EQU   SCTSTYPE
SCTSJFHK EQU   SCTSTYPE
SCTOUTMC EQU   SCTSTYPE
SCTINPUT EQU   SCTSTYPE
SCTGOSTP EQU   SCTSTYPE
@NM00082 EQU   INSMSCT+66
SCTNSMSG EQU   INSMSCT+65
@NM00081 EQU   INSMSCT+62
SCTRPACT EQU   INSMSCT+60
SCTSNAME EQU   INSMSCT+52
SCTSCLPC EQU   INSMSCT+44
@NM00080 EQU   INSMSCT+43
SCTADSTB EQU   INSMSCT+40
@NM00079 EQU   INSMSCT+36
@NM00078 EQU   INSMSCT+35
SCTAFACT EQU   INSMSCT+32
SCTDDNT  EQU   INSMSCT+28
@NM00077 EQU   INSMSCT+27
SCTLSIOT EQU   INSMSCT+24
@NM00076 EQU   INSMSCT+23
SCTANSCT EQU   INSMSCT+20
@NM00075 EQU   INSMSCT+19
SCTAALOC EQU   INSMSCT+16
@NM00074 EQU   INSMSCT+15
SCTFSIOT EQU   INSMSCT+12
SCTLALOC EQU   INSMSCT+10
SCTSEXEC EQU   INSMSCT+8
SCTSTIME EQU   INSMSCT+5
INCMSSTS EQU   SCTSSTAT
SCTGRPH  EQU   SCTSSTAT
SCTKEY0  EQU   SCTSSTAT
SCTDORST EQU   SCTSSTAT
SCTNOCKP EQU   SCTSSTAT
SCTNORST EQU   SCTSSTAT
EACAUSER EQU   SCTSSTAT
EAADDRBT EQU   SCTSSTAT
SCTTBLID EQU   INSMSCT+3
SCTDISKA EQU   INSMSCT
ACTACCNT EQU   IEFAACTB+32
ACTJNFLD EQU   IEFAACTB+31
ACTJTIME EQU   IEFAACTB+28
ACTPRGNM EQU   IEFAACTB+8
@NM00073 EQU   IEFAACTB+7
ACTNEXT  EQU   IEFAACTB+4
ACTIDENT EQU   IEFAACTB+3
ACTDSKAD EQU   IEFAACTB
@NM00072 EQU   INJMJCT+175
JCTVULDP EQU   INJMJCT+172
JCTACODE EQU   INJMJCT+168
JCTPRFMF EQU   INJMJCT+167
JCTUSER  EQU   INJMJCT+160
JCTSSD   EQU   INJMJCT+157
@NM00071 EQU   INJMJCT+156
JCTSRBT  EQU   INJMJCT+152
JCTJMRJD EQU   INJMJCT+149
JCTJMRJT EQU   INJMJCT+146
JCTJMRSS EQU   INJMJCT+143
JCTJMRTL EQU   INJMJCT+140
JCTJMRCL EQU   INJMJCT+139
JCTJMROP EQU   INJMJCT+138
JCTJMRD  EQU   INJMJCT+137
JCTJMR   EQU   INJMJCT+134
JCTCKIDT EQU   INJMJCT+118
JCTCKIDL EQU   INJMJCT+117
@NM00070 EQU   JCTSTAT2
JCTBLP   EQU   JCTSTAT2
JCTPERFM EQU   JCTSTAT2
JCTSWSM  EQU   JCTSTAT2
JCTENDIT EQU   JCTSTAT2
JCTADSPC EQU   JCTSTAT2
JCTSPSYS EQU   JCTSTAT2
@NM00069 EQU   INJMJCT+115
JCTSSTR  EQU   INJMJCT+112
JCTJSBTM EQU   JCTJSB
JCTJSBEX EQU   JCTJSB
JCTJSBAL EQU   JCTJSB
JCTJSBIN EQU   JCTJSB
@NM00068 EQU   JCTJSB
JCTVOLSQ EQU   INJMJCT+110
JCTNRCKP EQU   INJMJCT+108
JCTNTRK  EQU   INJMJCT+107
JCTCKTTR EQU   INJMJCT+104
JCTDEVT  EQU   INJMJCT+100
@NM00067 EQU   INJMJCT+99
JCTSTIOT EQU   INJMJCT+96
JCTSNUMB EQU   INJMJCT+95
JCTQIDNT EQU   INJMJCT+94
JCTEQREG EQU   INJMJCT+92
@NM00066 EQU   INJMJCT+91
JCTDETDA EQU   INJMJCT+88
JCTDSDRA EQU   JCTRSW2
JCTDSOJB EQU   JCTRSW2
JCTDSOCR EQU   JCTRSW2
JCTRESTT EQU   JCTRSW2
JCTNOCKP EQU   JCTRSW2
JCTNORST EQU   JCTRSW2
JCTNARST EQU   JCTRSW2
JCTSYSCK EQU   JCTRSW2
@NM00065 EQU   JCTRSW1
JCTSTEPR EQU   JCTRSW1
JCTCKPTR EQU   JCTRSW1
JCTCKFT  EQU   JCTRSW1
JCTCONTR EQU   JCTRSW1
JCTSTERM EQU   JCTRSW1
JCTWARMS EQU   JCTRSW1
@NM00064 EQU   JCTCCODE+3
JCTJDPOP EQU   JCTCCODE+2
JCTJDPCD EQU   JCTCCODE
@NM00063 EQU   INJMJCT+53
JCTSCT   EQU   INJMJCT+52
JCTSMRBA EQU   INJMJCT+44
@NM00062 EQU   INJMJCT+43
JCTACTAD EQU   INJMJCT+40
@NM00061 EQU   INJMJCT+39
JCTJCTX  EQU   INJMJCT+36
@NM00060 EQU   INJMJCT+35
JCTSDKAD EQU   INJMJCT+32
JCTJCSMF EQU   INJMJCT+31
JCTGDGNT EQU   INJMJCT+28
@NM00059 EQU   INJMJCT+27
JCTPDIP  EQU   INJMJCT+24
JCTJTPTN EQU   INJMJCT+16
JCTJPRTY EQU   JCTJBYTE
INCMMGL1 EQU   JCTJMGLV
INCMMGL2 EQU   JCTJMGLV
@NM00058 EQU   JCTJMGLV
INCMALL  EQU   JCTJMGLV
JCTJMGPO EQU   INJMJCT+6
INCMNSET EQU   JCTJSTAT
INCMCAT  EQU   INDMCTLG
INCMSTS  EQU   JCTJSTAT
JCTABEND EQU   JCTJSTAT
@NM00057 EQU   JCTJSTAT
JCTJSTPC EQU   JCTJSTAT
@NM00056 EQU   JCTJSTAT
JCTJBLBS EQU   JCTJSTAT
JCTJSRNO EQU   INJMJCT+4
JCTIDENT EQU   INJMJCT+3
JCTDSKAD EQU   INJMJCT
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00053 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00052 EQU   IEZJSCB
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00051 EQU   DEBACS08+12
@NM00050 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00049 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00048 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBBINUM EQU   DEBDASD+4
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
IOBERRCT EQU   IOBSTDRD+30
IOBRSV19 EQU   IOBINCAM+1
IOBOLTST EQU   IOBBTAMF
IOBRFTMG EQU   IOBBTAMF
IOBRSV17 EQU   IOBBTAMF
IOBRSV16 EQU   IOBBTAMF
IOBRSV15 EQU   IOBBTAMF
IOBRSV14 EQU   IOBBTAMF
IOBINUSE EQU   IOBBTAMF
IOBPRMER EQU   IOBBTAMF
IOBRSTRB EQU   IOBRESTR+1
IOBREPOS EQU   IOBRESTR
IOBDCBPB EQU   IOBDCBPT+1
IOBRSV44 EQU   IOBFLAG4
IOBJES3I EQU   IOBFLAG4
IOBRSV42 EQU   IOBFLAG4
IOBRSV41 EQU   IOBFLAG4
IOBRSV40 EQU   IOBFLAG4
IOBPMERR EQU   IOBFLAG4
IOBCC3WE EQU   IOBFLAG4
IOBGDPOL EQU   IOBFLAG4
IOBSTRTB EQU   IOBSTART+1
IOBSIOCC EQU   IOBSTART
IOBCSB7  EQU   IOBCSTAT
IOBCSB6  EQU   IOBCSTAT
IOBCSB5  EQU   IOBCSTAT
IOBCSB4  EQU   IOBCSTAT
IOBCSB3  EQU   IOBCSTAT
IOBCSB2  EQU   IOBCSTAT
IOBCSB1  EQU   IOBCSTAT
IOBCSB0  EQU   IOBCSTAT
IOBUSB7  EQU   IOBUSTAT
IOBUSB6  EQU   IOBUSTAT
IOBUSB5  EQU   IOBUSTAT
IOBUSB4  EQU   IOBUSTAT
IOBUSB3  EQU   IOBUSTAT
IOBUSB2  EQU   IOBUSTAT
IOBUSB1  EQU   IOBUSTAT
IOBUSB0  EQU   IOBUSTAT
IOBCMDA  EQU   IOBIOCSW
IOBLOG   EQU   IOBFL3
IOBJAM   EQU   IOBICL
IOBMSG   EQU   IOBFL3
IOBSDR   EQU   IOBCNC
IOBACU   EQU   IOBFL3
IOBCDC   EQU   IOBFL3
IOBICC   EQU   IOBFL3
IOBCCC   EQU   IOBFL3
IOBECBPB EQU   IOBECBPT+1
IOBECBCC EQU   IOBECBPT
IOBS1B7  EQU   IOBSENS1
IOBS1B6  EQU   IOBSENS1
IOBS1B5  EQU   IOBSENS1
IOBS1B4  EQU   IOBSENS1
IOBS1B3  EQU   IOBSENS1
IOBS1B2  EQU   IOBSENS1
IOBS1B1  EQU   IOBSENS1
IOBS1B0  EQU   IOBSENS1
IOBSNSC9 EQU   IOBS0B7
IOBS0B6  EQU   IOBSENS0
IOBS0B5  EQU   IOBSENS0
IOBS0B4  EQU   IOBSENS0
IOBS0B3  EQU   IOBSENS0
IOBS0B2  EQU   IOBSENS0
IOBS0B1  EQU   IOBSENS0
IOBS0B0  EQU   IOBSENS0
IOBPNCH  EQU   IOBFLAG2
IOBSTATO EQU   IOBFLAG2
IOBSKUPD EQU   IOBFLAG2
IOBALTTR EQU   IOBFLAG2
IOBRRT2  EQU   IOBRDHA0
IOBRRT3  EQU   IOBPURGE
IOBSENSE EQU   IOBFLAG2
IOBHALT  EQU   IOBFLAG2
IOBSPSVC EQU   IOBRSTRT
IOBIOERR EQU   IOBFLAG1
IOBFCREX EQU   IOBCYCCK
IOBRPSTN EQU   IOBFLAG1
IOBERRTN EQU   IOBFLAG1
IOBCMDCH EQU   IOBFLAG1
IOBDATCH EQU   IOBFLAG1
IOBCNOPA EQU   IOBPREFX+12
IOBCICB  EQU   IOBPREFX+8
IOBCECB  EQU   IOBPREFX+4
IOBCONOP EQU   IOBPREFX+3
IOBCINOP EQU   IOBPREFX+2
IOBRSV05 EQU   IOBPREFX+1
IOBPCI   EQU   IOBCFLG1
IOBRSTCH EQU   IOBCFLG1
IOBABAPP EQU   IOBCFLG1
IOBPTST  EQU   IOBCFLG1
IOBRSV04 EQU   IOBCFLG1
IOBRSV03 EQU   IOBCFLG1
IOBRSV02 EQU   IOBCFLG1
IOBRSV01 EQU   IOBCFLG1
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00047 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00046 EQU   POOLSTAR
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00045
UCBHALI  EQU   @NM00045
UCBRSV09 EQU   @NM00045
UCBRSV08 EQU   @NM00045
UCBRSV07 EQU   @NM00045
UCBRSV06 EQU   @NM00045
UCBRSV05 EQU   @NM00045
UCBRSV04 EQU   @NM00045
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBDADI  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00042 EQU   UCB
JESPJESN EQU   JESCT+28
JESSSCT  EQU   JESCT+24
JESQMGR  EQU   JESCT+12
JESUNITS EQU   JESCT+4
@NM00041 EQU   JESCT
SSMOPRPN EQU   SSMO+24
SSMOPDDN EQU   SSMO+20
SSMORSV0 EQU   SSMO+3
@NM00040 EQU   SSMOFLG1
SSMOMNTD EQU   SSMOFLG1
SSMORUSE EQU   SSMOFLG1
SSMOSCR  EQU   SSMOFLG1
SSMOFINL EQU   SSMOFLG1
SSMOOPEN EQU   SSMOFLG1
SSOBSSIB EQU   SSOB+8
SMCASTCB EQU   SMCABASE+176
SMCAWTCB EQU   SMCABASE+172
SMCAU83  EQU   SMCABASE+168
SMCAPGM  EQU   SMCABASE+164
SMCARGNM EQU   SMCABASE+160
SMCASPOT EQU   SMCABASE+156
SMCASPIN EQU   SMCABASE+152
SMCARGNS EQU   SMCABASE+148
SMCAPGRL EQU   SMCABASE+144
SMCADOMY EQU   SMCAPGOT
SMCADOMX EQU   SMCAPGIN
SMCATEXP EQU   SMCABASE+132
SMCASAVE EQU   SMCABASE+128
SMCARS21 EQU   SMCABASE+124
SMCATJID EQU   SMCAASCB+2
SMCAPOST EQU   SMCAASCB
SMCADSCT EQU   SMCABASE+116
SMCADSTM EQU   SMCABASE+108
SMCASWD  EQU   SMCABASE+107
SMCASWC  EQU   SMCABASE+106
SMCASWB  EQU   SMCABASE+105
SMCADSSW EQU   SMCASWA
SMCADSSP EQU   SMCASWA
SMCAZEOD EQU   SMCASWA
SMCANAVL EQU   SMCASWA
SMCANADA EQU   SMCASWA
SMCAOPFL EQU   SMCASWA
SMCADSTR EQU   SMCASWA
SMCASWAR EQU   SMCASWA
SMCAXNAM EQU   SMCABASE+96
@NM00039 EQU   SMCABASE+92
SMCAXCTL EQU   SMCABASE+88
SMCAWRTP EQU   SMCABASE+84
SMCAENAL EQU   SMCABASE+83
SMCAFGN  EQU   SMCAFOPT
SMCAFTDS EQU   SMCAFOPT
SMCAFR01 EQU   SMCAFOPT
SMCAFVOL EQU   SMCAFOPT
SMCAFDSA EQU   SMCAFOPT
SMCAFEXT EQU   SMCAFOPT
SMCAFOP2 EQU   SMCAFOPT
SMCAFOP1 EQU   SMCAFOPT
SMCAENOP EQU   SMCAENTY+1
SMCADSNF EQU   SMCAENDI
SMCARS20 EQU   SMCAENDI
SMCARS19 EQU   SMCAENDI
SMCARS18 EQU   SMCAENDI
SMCARS17 EQU   SMCAENDI
SMCARS16 EQU   SMCAENDI
SMCARS15 EQU   SMCAENDI
SMCARS14 EQU   SMCAENDI
SMCAWAIT EQU   SMCABASE+72
SMCASGFT EQU   SMCABASE+68
SMCASGWR EQU   SMCABASE+64
SMCABECB EQU   SMCABASE+60
SMCAWECB EQU   SMCABASE+56
SMCAADCB EQU   SMCABASE+52
SMCAYORX EQU   SMCABASE+51
SMCAANL  EQU   SMCAALBL
SMCAASL  EQU   SMCAALBL
SMCAANSL EQU   SMCAALBL
SMCARS13 EQU   SMCAALBL
SMCARS12 EQU   SMCAALBL
SMCARS11 EQU   SMCAALBL
SMCARS10 EQU   SMCAALBL
SMCARS09 EQU   SMCAALBL
SMCAADAR EQU   SMCABASE+47
SMCAAVOL EQU   SMCASTA
SMCAAUNT EQU   SMCASTA
SMCARS08 EQU   SMCASTA
SMCAAMOD EQU   SMCASTA
SMCAAMTY EQU   SMCASTA
SMCAADA  EQU   SMCASTA
SMCAATAP EQU   SMCASTA
SMCAANAV EQU   SMCASTA
SMCAADEV EQU   SMCABASE+40
SMCAPDCB EQU   SMCABASE+36
SMCAXORY EQU   SMCABASE+35
SMCAPNL  EQU   SMCAPLBL
SMCAPSL  EQU   SMCAPLBL
SMCAPNSL EQU   SMCAPLBL
SMCARS07 EQU   SMCAPLBL
SMCARS06 EQU   SMCAPLBL
SMCARS05 EQU   SMCAPLBL
SMCARS04 EQU   SMCAPLBL
SMCARS03 EQU   SMCAPLBL
SMCAPDAR EQU   SMCABASE+31
SMCAPVOL EQU   SMCAPSTA
SMCAPUNT EQU   SMCAPSTA
SMCARS02 EQU   SMCAPSTA
SMCAMOD  EQU   SMCAPSTA
SMCAPMTY EQU   SMCAPSTA
SMCAPDA  EQU   SMCAPSTA
SMCAPTAP EQU   SMCAPSTA
SMCAPNAV EQU   SMCAPSTA
SMCAPDEV EQU   SMCABASE+24
SMCABUFP EQU   SMCABASE+20
SMCASID  EQU   SMCABASE+16
SMCABSIZ EQU   SMCABUF
SMCAJWT  EQU   SMCABASE+8
SMCATIOT EQU   SMCABASE+4
SMCATOFF EQU   SMCABASE+2
SMCADUMP EQU   SMCAMISC
SMCABSW  EQU   SMCAMISC
SMCADBSY EQU   SMCAMISC
SMCAPSDP EQU   SMCAMISC
SMCAFIRT EQU   SMCAMISC
SMCAOPI  EQU   SMCAMISC
SMCAMAN  EQU   SMCAMISC
SMCAUSER EQU   SMCAMISC
SMCAFGND EQU   SMCAOPT
SMCATDS  EQU   SMCAOPT
SMCARS01 EQU   SMCAOPT
SMCADSA  EQU   SMCAOPT
SMCAEXT  EQU   SMCAOPT
SMCAOPT2 EQU   SMCAOPT
SMCAOPT1 EQU   SMCAOPT
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00037+8
PRBEND   EQU   @NM00037+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00037+6
RBRSV136 EQU   @NM00037+4
RBRSV135 EQU   @NM00037
@NM00036 EQU   RBSECT+32
@NM00035 EQU   @NM00033+1
@NM00034 EQU   @NM00033
RBPGMQ1  EQU   RBPGMQ+1
@NM00032 EQU   RBPGMQ
@NM00031 EQU   RBSECT+16
@NM00030 EQU   @NM00026
@NM00029 EQU   @NM00026
RBIQETP  EQU   @NM00026
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00026
@NM00028 EQU   @NM00026
@NM00027 EQU   @NM00026
RBPMSVRB EQU   @NM00024
RBATNXIT EQU   @NM00024
@NM00025 EQU   @NM00024
RBWAITP  EQU   @NM00024
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00024
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00022 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00021 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00020 EQU   RBOPSWB2
@NM00019 EQU   XRBPSW
@NM00018 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00017 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00016 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00015 EQU   XSTAB1
@NM00014 EQU   RBBASIC+8
@NM00013 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00012 EQU   RBPRFX
@NM00011 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00009 EQU   TCB+232
TCBRV190 EQU   TCB+229
TCBSVCA1 EQU   TCB+228
TCBJSONQ EQU   TCBTTQE
TCBARBA  EQU   TCBARB+1
TCBRSV85 EQU   TCBARB
TCBGQE   EQU   TCB+216
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSV84 EQU   TCBADMP
TCBRSV83 EQU   TCBRSTSK
TCBSVCS  EQU   TCBFLGS7
TCBFWDD  EQU   TCBSTACK
TCBFDDEI EQU   TCBRSV34
TCBFDDT  EQU   TCBRSV33
TCBFDD   EQU   TCBGPECB
TCBSTIJS EQU   TCBNTJS
TCBDSINQ EQU   TCBAPG
TCBRUNJB EQU   TCBMIGR
TCBRUNPN EQU   TCBRV303
TCBFPROT EQU   TCBSPVLK
TCBPANIC EQU   TCBCPU
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBNDGTF EQU   TCBNDSP5
TCBNDSPL EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00008 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBRSV28 EQU   TCBNDINT
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBNDSDA EQU   TCBSRBND
TCBABTER EQU   TCBRV302
TCBTERM  EQU   TCBLJSND
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBVALID
TCBRV301 EQU   TCBRETRY
TCBSYNCH EQU   TCBSUPER
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBSCAT
TCB33E   EQU   TCBXCTL
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBDDRTI EQU   TCBAQE
TCBRSV73 EQU   TCBFTFL3
TCBRSV72 EQU   TCBFTFL3
TCBFTDUM EQU   TCBFTFL3
TCBRSV71 EQU   TCBFTFL3
TCBRSV70 EQU   TCBFTFL3
TCBRSV69 EQU   TCBFTFL3
TCBRSV68 EQU   TCBFTFL3
TCBRSV67 EQU   TCBFTFL3
TCBRSV66 EQU   TCBFTFL2
TCBSYSAB EQU   TCBFTFL2
@NM00007 EQU   TCBFTFL2
TCBRSV65 EQU   TCBFTFL2
TCBLPAGE EQU   TCBFTFL2
TCBDDEN  EQU   TCBFTFL2
TCBRSV62 EQU   TCBFTFL2
TCBRSV61 EQU   TCBFTFL2
TCBENQ   EQU   TCBFTFL1
TCBFTCOM EQU   TCBFTFL1
TCBFTTOP EQU   TCBFTFL1
TCBRSV60 EQU   TCBFTFL1
TCBRSV59 EQU   TCBFTFL1
TCBRSV58 EQU   TCBFTFL1
TCBVTAM  EQU   TCBFTFL1
TCBTCAM  EQU   TCBFTFL1
TCBFTLMP EQU   TCBPQE
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBPIBA
TCBSCHED EQU   TCBPIBT
TCBWRITE EQU   TCBPIBT
TCBSCHTI EQU   TCBPIBT
TCBRSV54 EQU   TCBPIBT
TCBSTOP  EQU   TCBPIBT
TCBSIZE  EQU   TCBPIBT
TCBPART  EQU   TCBPIBT
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBIDF
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBFTJSA
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBRSV53 EQU   TCBDWSTA
TCBPKCHG EQU   TCBRSV08
TCBSCHAB EQU   TCBRSV07
TCBFLREG EQU   TCBRSV06
TCBRSV52 EQU   TCBABGM
TCBSYSER EQU   TCBABTRM
TCBRSV51 EQU   TCBADINP
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBRSV50 EQU   TCBFDSOP
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBSYSTK
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBPOOL  EQU   TCBFT
TCBDMPA  EQU   TCBPDUMP
TCBJSTE  EQU   TCBNONPR
@NM00006 EQU   TCBFERA
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00005 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
@NM00004 EQU   @NM00003
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVT0VL00 EQU   CVTMAP+24
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
@NM00121 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00120 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00119 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00118 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00117 EQU   FLCFSA
@NM00116 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00115 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00114 EQU   FLCIOA
@NM00113 EQU   FLCMCLA+15
@NM00112 EQU   FLCMCLA+14
@NM00111 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00110 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00109 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00108 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00107 EQU   FLCPER
@NM00106 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00105 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00104 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00103 EQU   FLCPIILC
@NM00102 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00101 EQU   FLCSVILC
@NM00100 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00099 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00098 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00426 EQU   @RC00423
@RC00452 EQU   @RC00451
@RF00547 EQU   EXIT
@RC00713 EQU   @RC00712
@RF00758 EQU   @RC00748
@RT00769 EQU   EXIT
@RT00827 EQU   EXIT
@RF00880 EQU   EXIT
@RF00931 EQU   EXIT
@RF00942 EQU   @RC00940
@RF01156 EQU   EXIT
@RF01186 EQU   EXIT
@PB00019 EQU   @PB00020
@PB00018 EQU   @PB00019
@PB00017 EQU   @PB00018
@PB00016 EQU   @PB00017
@PB00015 EQU   @PB00016
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0192V,(C'PLS1355',0701,78165)
