         TITLE 'IDA0192W - VS2 VSAM CHANNEL PROGRAM AREA BUILD         *
                        '
IDA0192W CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192W  75.057'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@03                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
*                                                                  0246
*   /*****************************************************************/
*   /*                                                               */
*   /* IDA0192W MODULE INITIALIZATION                        @Z30SSDT*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0246
*   RSTATRTN=IDAR192W;              /* NOTE 192W IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0246
         MVC   RSTATRTN(4,@05),@CC03972                            0246
*/********************************************************************/
*/*           IDAGMAIN - GETS CORE STORAGE FOR AUTOMATICS.           */
*/*                      FOR VS2 IDAGMAIN WILL MOVE THE      @Z30SSRL*/
*/*                      ID AND DATE OF THE MODULE TO A      @Z30SSRL*/
*/*                      LOCATION DIRECTLY AFTER THE PLS     @Z30SSRL*/
*/*                      GENERATED SAVE AREA.                @Z30SSRL*/
*/*           DATE OF LAST CHANGE = 3 DECEMBER 74            @Z30SSRL*/
*/********************************************************************/
*                                                                  0247
*   GEN;                                                           0247
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL ZERO
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  ZERO THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR ZERO
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        ZERO IF THE GETMAIN WAS UNSUCCESSFUL.
*   RESPECIFY                                                      0248
*    (R15,                                                         0248
*     R1,                                                          0248
*     R0,                                                          0248
*     R7) RSTD;                     /*                       @Z30SSDT*/
*   IF R15^=K0 THEN                 /* IF WORKING STORAGE OBTAINED   */
         LTR   R15,R15                                             0249
         BZ    @RF00249                                            0249
*     DO;                                                          0250
*       R15->SABWRD=R13;            /* SAVE SAVEREG          @Z30SSDT*/
         ST    R13,SABWRD(,R15)                                    0251
*       R7=ADDR(SACODE);            /* SAVE POINTER TO CALLERS R15   */
         LA    R7,SACODE(,R13)                                     0252
*       R13=R15;                    /* LOAD CORE PTR                 */
         LR    R13,R15                                             0253
*       GEN(USING @DATD,R13);                                      0254
         USING @DATD,R13
*       PDPTR=R7;                   /* LOAD POINTER TO R15   @X04SVCJ*/
         ST    R7,PDPTR                                            0255
*       PD=K0;                      /* SET RETURN TO ZERO    @Z30SSRL*/
         L     @14,PDPTR                                           0256
         SLR   @06,@06                                             0256
         ST    @06,PD(,@14)                                        0256
*       PPFUNC=PDF71;               /* FUNCTION ID           @X04SVCJ*/
         MVI   PPFUNC(@14),X'47'                                   0257
*       CALL BLDCPA;                /* BUILD CHANNEL PROGRAM AREA    */
         BAL   @14,BLDCPA                                          0258
*     END;                                                         0259
*   ELSE                            /* NO CORE AVAILABLE             */
*     DO;                                                          0260
         B     @RC00249                                            0260
@RF00249 DS    0H                                                  0261
*       RESPECIFY                                                  0261
*         PD BASED(ADDR(SACODE));   /* CALLERS REG15         @Z30SSDT*/
*       PD=K0;                      /* ZERO PD               @Z30SSRL*/
         LA    @14,16                                              0262
         ALR   @14,R13                                             0262
         SLR   @06,@06                                             0262
         ST    @06,PD(,@14)                                        0262
*       PPFUNC=PDF70;               /* SET FUNCTION CODE     @X04SVCJ*/
         MVI   PPFUNC(@14),X'46'                                   0263
*       PPCODE=PP20;                /* GETMAIN FAILURE       @X04SVCJ*/
         MVI   PPCODE(@14),X'14'                                   0264
*       LM(RET,R12,SAREGS);         /* LOAD R14-R12          @Z30SSDT*/
         LM    RET,R12,SAREGS(R13)                                 0265
*       GEN(BR RET);                                               0266
         BR RET
*     END;                                                         0267
*   RESPECIFY                                                      0268
*     PD BASED(PDPTR);              /*                       @X04SVCJ*/
@RC00249 DS    0H                                                  0269
*EXIT:                                                             0269
*   IF PPCODE=K0 THEN               /* ERRORS                @Z30SSRL*/
EXIT     L     @14,PDPTR                                           0269
         CLI   PPCODE(@14),0                                       0269
         BNE   @RF00269                                            0269
*     PD=K0;                        /* NO, ZERO RETURN CODE  @Z30SSRL*/
         SLR   @06,@06                                             0270
         ST    @06,PD(,@14)                                        0270
*   GEN(L R0,@SIZDATD);             /* LOAD BLOCK SIZE       @Z30SSDT*/
@RF00269 DS    0H                                                  0271
         L R0,@SIZDATD
*   R1=R13;                         /* SET ADDRESS           @Z30SSDT*/
         LR    R1,R13                                              0272
*   R13=SABWRD;                     /* POINT TO LAST SAVEAREA      0273
*                                                            @Z30SSDT*/
         L     R13,SABWRD(,R13)                                    0273
*   GEN(FREEMAIN R,LV=(0),A=(1));   /* FREE AUTOMATICS               */
         FREEMAIN R,LV=(0),A=(1)
*   LM(RET,R12,SAREGS);             /* RESTORE REGISTERS 14-12     0275
*                                                            @Z30SSDT*/
         LM    RET,R12,SAREGS(R13)                                 0275
*   GEN(BR RET);                    /* RETURN TO CALLER              */
         BR RET
*   RESPECIFY                                                      0277
*    (R15,                                                         0277
*     R1,                                                          0277
*     R0,                                                          0277
*     R7,                                                          0277
*     R12) UNRSTD;                  /*                       @Z30SSDT*/
*BLDCPA:                                                           0278
*                                                                  0278
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD CHANNEL PROGRAM AREA                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0278
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0278
BLDCPA   DS    0H                                                  0279
*   RESPECIFY                                                      0279
*    (R6,                                                          0279
*     R8,                                                          0279
*     R9,                                                          0279
*     RET) RESTRICTED;              /*                       @X04SVCJ*/
*   RSAVL(K1)=RET;                  /* SAVE RETURN ADDRESS   @X04SVCJ*/
         ST    RET,RSAVL                                           0280
*   RESPECIFY                                                      0281
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   PARMPTR=SABWRD->SAREG0;         /* LOAD POINTER TO PARMS @Z30SSDT*/
         L     @07,SABWRD(,R13)                                    0282
         L     PARMPTR,SAREG0(,@07)                                0282
*   RESPECIFY                                                      0283
*     IDABUFC BASED(R9);            /*                       @X04SVCJ*/
*   R9=BUFCPTR;                     /* LOAD POINTER TO BUFC  @X04SVCJ*/
         L     R9,BUFCPTR(,PARMPTR)                                0284
*   DO WHILE R9^=0;                 /* LOOP THROUGH BUFCS    @X04SVCJ*/
         B     @DE00285                                            0285
@DL00285 DS    0H                                                  0286
*     IF BUFCFMT=ON&                /* IF PREFORMAT SPEC &           */
*         BUFCPFCP=ON THEN          /* IF PREF COMPLETE              */
         TM    BUFCFMT(R9),B'01000010'                             0286
         BNO   @RF00286                                            0286
*       IF AMBTYPE=AMBINDEX&        /* IF INDEX AMB PASS     @Z30SSDT*/
*           AMDSDT=ON THEN          /* AND SS WITH DATA      @Z30SSDT*/
         L     @07,AMBPTR(,PARMPTR)                                0287
         TM    AMBTYPE(@07),B'01000000'                            0287
         BNO   @RF00287                                            0287
         L     @01,AMBDSB(,@07)                                    0287
         TM    AMDSDT(@01),B'00100000'                             0287
         BNO   @RF00287                                            0287
*         R6=MAX(LPMBLKTR,(ADDR(IDALPMB)+LPMBLEN)->LPMBLKTR);/* SET
*                                      MAX BLOCKS PER TRACK  @Z30SSDT*/
         L     @01,AMBEDB(,@07)                                    0288
         L     @15,EDBLPMBC(,@01)                                  0288
         LH    @14,LPMBLEN(,@15)                                   0288
         ALR   @14,@15                                             0288
         LH    R6,LPMBLKTR(,@15)                                   0288
         LH    @07,LPMBLKTR(,@14)                                  0288
         CR    R6,@07                                              0288
         BNL   *+6
         LR    R6,@07                                              0288
*       ELSE                        /* NOT INDEX & SS W/DATA @Z30SSDT*/
*         R6=LPMBLKTR;              /* FIND BLKS/TRK         @Z30SSDT*/
         B     @RC00287                                            0289
@RF00287 L     @01,AMBPTR(,PARMPTR)                                0289
         L     @01,AMBEDB(,@01)                                    0289
         L     @01,EDBLPMBC(,@01)                                  0289
         LH    R6,LPMBLKTR(,@01)                                   0289
*     ELSE                          /* NOT PREFORMAT & PREF NOT    0290
*                                                            @Z30SSRL*/
*       R6=AMDCINV/LPMBLKSZ;        /* FIND BLKS/CINV        @X04SVCJ*/
         B     @RC00286                                            0290
@RF00286 L     @15,AMBPTR(,PARMPTR)                                0290
         L     @01,AMBDSB(,@15)                                    0290
         L     @15,AMBEDB(,@15)                                    0290
         L     @15,EDBLPMBC(,@15)                                  0290
         L     @00,AMDCINV(,@01)                                   0290
         SRDA  @00,32                                              0290
         D     @00,LPMBLKSZ(,@15)                                  0290
         LR    R6,@01                                              0290
*     IF LPMBLKSZ>IOPAGESZ THEN     /* IF PHYSICAL BLKSIZE>PAGE    0291
*                                                            @Z30SSDT*/
@RC00286 L     @07,AMBPTR(,PARMPTR)                                0291
         L     @07,AMBEDB(,@07)                                    0291
         L     @07,EDBLPMBC(,@07)                                  0291
         L     @07,LPMBLKSZ(,@07)                                  0291
         C     @07,@CF00039                                        0291
         BNH   @RF00291                                            0291
*       R8=K12;                     /* SET IDAL ENTRY SIZE   @Z30SSRL*/
         LA    R8,12                                               0292
*     ELSE                          /* IF PHYSICAL BLKSIZE<=PAGE     */
*       R8=K8;                      /* SET IDAL ENTRY SIZE   @Z30SSRL*/
         B     @RC00291                                            0293
@RF00291 LA    R8,8                                                0293
*     R8=(R8*(R6+K7)&(-K8));        /* GET SIZE OF IDAL AND VPL    0294
*                                                            @X04SVCJ*/
@RC00291 LA    @01,7                                               0294
         ALR   @01,R6                                              0294
         MR    @00,R8                                              0294
         N     @01,@CF04051                                        0294
         LR    R8,@01                                              0294
*     CALL BLDCPAAR;                /* BUILD THE CHANNEL PROGRAM AREA
*                                                            @X04SVCJ*/
         BAL   @14,BLDCPAAR                                        0295
*     CALL INITCPAH;                /* BUILD CPA HEADER      @X04SVCJ*/
         BAL   @14,INITCPAH                                        0296
*     IF BUFCFMT=ON THEN            /* IF PREFORMAT SPEC     @X04SVCJ*/
         TM    BUFCFMT(R9),B'01000000'                             0297
         BNO   @RF00297                                            0297
*       CALL INITFMTW;              /* INITIALIZE FORMAT WRITE     0298
*                                      CHANNEL PROGRAM               */
         BAL   @14,INITFMTW                                        0298
*     ELSE                          /* NOT PREFORMAT         @X04SVCJ*/
*       CALL INITUWCP;              /* INITIALIZE UPDATE CHANNEL   0299
*                                      PROGRAM               @X04SVCJ*/
         B     @RC00297                                            0299
@RF00297 BAL   @14,INITUWCP                                        0299
*     IF BUFCWC=ON THEN             /* IF BUFC SPECIFIED WRITE CHECK
*                                                            @X04SVCJ*/
@RC00297 TM    BUFCWC(R9),B'00001000'                              0300
         BNO   @RF00300                                            0300
*       CALL BLDWCCP;               /* BUILD WRITE CHECK CHANNEL   0301
*                                      PROGRAM               @X04SVCJ*/
         BAL   @14,BLDWCCP                                         0301
*     IF CPAVPLV=ON THEN            /* IS VIRTUAL PAGE LIST REQUIRED
*                                                            @X04SVCJ*/
@RF00300 L     @07,BUFCCPA(,R9)                                    0302
         TM    CPAVPLV(@07),B'10000000'                            0302
         BNO   @RF00302                                            0302
*       CALL BLDVPL;                /* BUILD VIRTUAL PAGE LIST     0303
*                                                            @X04SVCJ*/
         BAL   @14,BLDVPL                                          0303
*     IF RCCWN^=K0 THEN             /* READ CHANNEL PROGRAM REQUIRED
*                                                            @X04SVCJ*/
@RF00302 L     @07,RCCWN                                           0304
         LTR   @07,@07                                             0304
         BZ    @RF00304                                            0304
*       CALL BLDRCP;                /* BUILD READ CHANNEL PROGRAM  0305
*                                                            @X04SVCJ*/
         BAL   @14,BLDRCP                                          0305
*     RCCWN=K0;                     /* CLEAR READ CCW COUNT  @X04SVCJ*/
@RF00304 SLR   @07,@07                                             0306
         ST    @07,RCCWN                                           0306
*     IF PREFRMAT=OFF               /* PREFORMAT PASS YET    @X04SVCJ*/
*         &BUFCHAIN=K0 THEN         /* LAST IN CHAIN         @X04SVCJ*/
         TM    PREFRMAT,B'10000000'                                0307
         BNZ   @RF00307                                            0307
         C     @07,BUFCHAIN(,R9)                                   0307
         BNE   @RF00307                                            0307
*       DO;                         /* LAST NORMAL           @X04SVCJ*/
*         R9=PREFBUFC;              /* LOAD POINTER TO PREFORMAT   0309
*                                                            @X04SVCJ*/
         L     R9,PREFBUFC(,PARMPTR)                               0309
*         PREFRMAT=ON;              /* SET PREFORMAT SWITCH  @X04SVCJ*/
         OI    PREFRMAT,B'10000000'                                0310
*       END;                        /*                       @X04SVCJ*/
*     ELSE                          /* NO STILL NORMAL PASS  @X04SVCJ*/
*       R9=BUFCHAIN;                /* POINT TO NEXT BUFC    @X04SVCJ*/
         B     @RC00307                                            0312
@RF00307 L     R9,BUFCHAIN(,R9)                                    0312
*   END;                            /*                       @X04SVCJ*/
@RC00307 DS    0H                                                  0313
@DE00285 LTR   R9,R9                                               0313
         BNZ   @DL00285                                            0313
*   RESPECIFY                                                      0314
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RSAVL(K1);                  /* LOAD RETURN ADDRESS   @X04SVCJ*/
         L     RET,RSAVL                                           0315
*   RESPECIFY                                                      0316
*    (RET) UNRSTD;                  /*                       @X04SVCJ*/
*   END BLDCPA;                     /*                       @X04SVCJ*/
@EL00002 DS    0H                                                  0317
@EF00002 DS    0H                                                  0317
@ER00002 BR    @14                                                 0317
*BLDCPAAR:                                                         0318
*                                                                  0318
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD THE CHANNEL PROGRAM AREA                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0318
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
BLDCPAAR DS    0H                                                  0319
*   RESPECIFY                                                      0319
*    (R7,                                                          0319
*     RET) RSTD;                    /*                       @X04SVCJ*/
*   RSAVL(K2)=RET;                  /* SAVE RETURN ADDRESS   @X04SVCJ*/
         ST    RET,RSAVL+4                                         0320
*   RESPECIFY                                                      0321
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   IF BUFCFMT=ON THEN              /* IF PREFORMAT IS REQD          */
         TM    BUFCFMT(R9),B'01000000'                             0322
         BNO   @RF00322                                            0322
*     DO;                                                          0323
*       IF BUFCPFCP=ON THEN         /* IF PREF COMPLETE              */
         TM    BUFCPFCP(R9),B'00000010'                            0324
         BNO   @RF00324                                            0324
*         R7=CCWSFWC*R6+CCWCFWC;    /* CCWS FOR FORMAT WRITE COMPLETE*/
         LR    R7,R6                                               0325
         ALR   R7,R7                                               0325
         AL    R7,@CF00047                                         0325
*       ELSE                        /* PREF NOT COMPLETE     @Z30SSRL*/
*         DO;                       /*                       @Z30SSDT*/
         B     @RC00324                                            0326
@RF00324 DS    0H                                                  0327
*           IF LPMBTOFL=ON THEN     /* TRACK OVERFLOW        @Z30SSDT*/
         L     @01,AMBPTR(,PARMPTR)                                0327
         L     @01,AMBEDB(,@01)                                    0327
         L     @01,EDBLPMBC(,@01)                                  0327
         TM    LPMBTOFL(@01),B'00010000'                           0327
         BNO   @RF00327                                            0327
*             R6=R6+K1;             /* YES, ADD FOR OVERFLOW @Z30SSDT*/
         AL    R6,@CF00043                                         0328
*           R7=CCWSFW*R6+CCWCFW;    /* NUMBER OF CCWS FOR FORMAT   0329
*                                      WRITE                         */
@RF00327 LR    R7,R6                                               0329
         SLA   R7,2                                                0329
         AL    R7,@CF00032                                         0329
*         END;                      /*                       @Z30SSDT*/
*     END;                                                         0331
*   ELSE                            /* PREFORMAT NOT REQD    @Z30SSRL*/
*     R7=CCWSUW*R6+CCWCUW;          /* CCWS FOR UPDATE WRITE         */
         B     @RC00322                                            0332
@RF00322 LA    @15,3                                               0332
         LR    @01,R6                                              0332
         MR    @00,@15                                             0332
         ALR   @01,@15                                             0332
         LR    R7,@01                                              0332
*   WCCWN=R7;                                                      0333
@RC00322 LR    WCCWN,R7                                            0333
*   IF BUFCWC=ON THEN               /* IF WRITE CHECK SPEC           */
         TM    BUFCWC(R9),B'00001000'                              0334
         BNO   @RF00334                                            0334
*     R7=R7+(CCWSWC*R6+CCWCWC);     /* ADD CCWS FOR WRITE CHECK      */
         LA    @10,5                                               0335
         ALR   @10,R6                                              0335
         ALR   R7,@10                                              0335
*   IF PREFRMAT=OFF THEN            /* DETERMINE IF READ CCWS      0336
*                                                            @X04SVCJ*/
@RF00334 TM    PREFRMAT,B'10000000'                                0336
         BNZ   @RF00336                                            0336
*     RCCWN=CCWSRD*R6+CCWCRD;       /* ADD CCWS FOR READ CCW         */
         LA    @10,5                                               0337
         ALR   @10,R6                                              0337
         ST    @10,RCCWN                                           0337
*   R7=R7+RCCWN;                    /* ADD FOR READ CCWS             */
@RF00336 AL    R7,RCCWN                                            0338
*   OPWVMLNG=((LENGTH(IDACPA)+K7)&(-K8))+/* BASIC SECTION    @X04SVCJ*/
*       R7*DWORDLEN+                /* CCWS SPACE PLUS-              */
*       R8+                         /* REAL PAGE LIST PLUS-          */
*       R8+                         /* VIRTUAL PAGE LIST PLUS-       */
*       (R6*(LENGTH(SEARCHID)+K7&(-K8)));/* SEARCHID AREA    @X04SVCJ*/
         LR    @10,R7                                              0339
         SLA   @10,3                                               0339
         AL    @10,@CF01959                                        0339
         ALR   @10,R8                                              0339
         ALR   @10,R8                                              0339
         LR    @15,R6                                              0339
         SLA   @15,3                                               0339
         ALR   @10,@15                                             0339
         STCM  @10,7,OPWVMLNG(RCORE)                               0339
*   IF BUFCFMT=ON THEN              /* IF PREFORMAT REQD     @Z30SSRL*/
         TM    BUFCFMT(R9),B'01000000'                             0340
         BNO   @RF00340                                            0340
*     OPWVMLNG=OPWVMLNG+R6*DWORDLEN;/* ROOM FOR FWCNT        @X04SVCJ*/
         ALR   @10,@15                                             0341
         STCM  @10,7,OPWVMLNG(RCORE)                               0341
*   OPWVMFLG=K0;                    /* SET FLAGS TO ZERO     @X04SVCJ*/
@RF00340 MVI   OPWVMFLG(RCORE),X'00'                               0342
*   IF OPWUPGR=ON THEN              /* UPGRADE               @X04SVCJ*/
         L     @10,OPWCURPT(,RCORE)                                0343
         TM    OPWUPGR(@10),B'00100000'                            0343
         BNO   @RF00343                                            0343
*     OPWVMTYP=PRUSTRBK;            /* INDICATE PROTECTED    @Z30SSDT
*                                      @ UPGRADE STRING BLOCK      0344
*                                                            @Z30SSDT*/
         MVI   OPWVMTYP(RCORE),X'0C'                               0344
*   ELSE                            /* STRING BLOCK          @X04SVCJ*/
*     OPWVMTYP=PRSTRBLK;            /* PROTECTED STRING BLK  @Z30SSDT*/
         B     @RC00343                                            0345
@RF00343 MVI   OPWVMTYP(RCORE),X'0B'                               0345
*   OPWVMANC=ADDR(IDACMB);          /* LOAD ADDR OF ANCHOR BLOCK   0346
*                                                            @X04SVCJ*/
@RC00343 L     @10,ACBAMBL(,RACB)                                  0346
         L     @10,AMBLCMB(,@10)                                   0346
         ST    @10,OPWVMANC(,RCORE)                                0346
*   CALL IDA0192M;                  /* GETCORE FOR CPA       @X04SVCJ*/
         L     @15,@CV00122                                        0347
         BALR  @14,@15                                             0347
*   IF OPWVMADR=K0 THEN             /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @10,OPWVMADR(,RCORE)                                0348
         LTR   @10,@10                                             0348
         BNZ   @RF00348                                            0348
*     DO;                           /*                       @X04SVCJ*/
*       PPCODE=PP20;                /* SET ERROR CODE        @X04SVCJ*/
         L     @05,PDPTR                                           0350
         MVI   PPCODE(@05),X'14'                                   0350
*       RETURN TO EXIT;             /* TERMINATE             @X04SVCJ*/
         LA    @14,EXIT                                            0351
@EL00003 DS    0H                                                  0351
@EF00003 DS    0H                                                  0351
@ER00003 BR    @14                                                 0351
*     END;                          /*                       @X04SVCJ*/
*   BUFCCPA=OPWVMADR;               /* SET CPA ADDR IN BUFC  @X04SVCJ*/
@RF00348 L     @10,OPWVMADR(,RCORE)                                0353
         ST    @10,BUFCCPA(,R9)                                    0353
*   CPANXT1=AMBCPA;                 /* CHAIN THIS CPA        @Z30SSDT*/
         L     @15,AMBPTR(,PARMPTR)                                0354
         L     @14,AMBCPA(,@15)                                    0354
         ST    @14,CPANXT1(,@10)                                   0354
*   AMBCPA=OPWVMADR;                /* SET CPA ADDR IN AMB   @Z30SSDT*/
         ST    @10,AMBCPA(,@15)                                    0355
*   CPALEN=OPWVMLNG;                /* SET LENGTH IN HEADER  @X04SVCJ*/
         L     @15,OPWVMLNG-1(,RCORE)                              0356
         LA    @15,0(,@15)                                         0356
         STH   @15,CPALEN(,@10)                                    0356
*   IF AMBLFSTP=ON THEN             /* IF ICI PROCESSING     @Z30SSDT*/
         L     @01,ACBAMBL(,RACB)                                  0357
         TM    AMBLFSTP(@01),B'00010000'                           0357
         BNO   @RF00357                                            0357
*     IOMCPA=OPWVMADR;              /* SET CPA ADDR IN IOMB  @Z30SSDT*/
         L     @01,BUFCPLH(,R9)                                    0358
         L     @01,PLHDIOB(,@01)                                   0358
         ST    @10,IOMCPA(,@01)                                    0358
*   RESPECIFY                                                      0359
*     RET RSTD;                     /*                       @X04SVCJ*/
@RF00357 DS    0H                                                  0360
*   RET=RSAVL(K2);                  /* LOAD RETURN ADDRESS   @X04SVCJ*/
         L     RET,RSAVL+4                                         0360
*   RESPECIFY                                                      0361
*    (RET,                                                         0361
*     R7) UNRSTD;                   /*                       @X04SVCJ*/
*   END BLDCPAAR;                   /*                       @X04SVCJ*/
         B     @EL00003                                            0362
*INITCPAH:                          /*                       @X04SVCJ*/
*                                                                  0363
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE CHANNEL PROGRAM AREA HEADER                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0363
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
INITCPAH DS    0H                                                  0364
*   RESPECIFY                                                      0364
*    (RET,                                                         0364
*     R10) RSTD;                    /*                       @X04SVCJ*/
*   CPAID=IDXCPA;                   /* SET ID                        */
         L     @15,BUFCCPA(,R9)                                    0365
         MVI   CPAID(@15),B'01110001'                              0365
*   CPABCINV=R6;                    /* SET BLOCKS/CONTROL INTERV     */
         STH   R6,CPABCINV(,@15)                                   0366
*   R10=(ADDR(IDACPA)+(LENGTH(IDACPA)+K7)&(-K8));/* ADDR CCW 1     0367
*                                                            @X04SVCJ*/
         LA    R10,103                                             0367
         ALR   R10,@15                                             0367
         N     R10,@CF04051                                        0367
*   IF BUFCWC=ON THEN               /* IF WRITE CHECK SPEC           */
         TM    BUFCWC(R9),B'00001000'                              0368
         BNO   @RF00368                                            0368
*     DO;                                                          0369
*       CPAWCKS=R10;                /* WRITE CHECK CCWS FIRST        */
         ST    R10,CPAWCKS(,@15)                                   0370
*       CPAWCKE=CPAWCKS+(CCWSWC*R6+CCWCWC-K1)*LENGTH(CCW);/* PT TO 0371
*                                      LAST WRITE CHECK CCW          */
         L     @07,BUFCCPA(,R9)                                    0371
         L     @07,CPAWCKS(,@07)                                   0371
         LR    @01,R6                                              0371
         SL    @01,@CF04052                                        0371
         SLA   @01,3                                               0371
         ALR   @07,@01                                             0371
         ST    @07,CPAWCKE(,@15)                                   0371
*       CPAWCPS=CPAWCKE+LENGTH(CCW);/* WRITE CCWS NEXT               */
         AL    @07,@CF00051                                        0372
         ST    @07,CPAWCPS(,@15)                                   0372
*     END;                                                         0373
*   ELSE                            /* IF WRITE CHECK NOT SPEC       */
*     CPAWCPS=R10;                  /* WRITE CCWS FIRST              */
         B     @RC00368                                            0374
@RF00368 L     @15,BUFCCPA(,R9)                                    0374
         ST    R10,CPAWCPS(,@15)                                   0374
*   CPAWCPE=CPAWCPS+(WCCWN-K1)*LENGTH(CCW);/* SET ADDR OF LAST WCP 0375
*                                      CCW                           */
@RC00368 L     @15,BUFCCPA(,R9)                                    0375
         L     @07,CPAWCPS(,@15)                                   0375
         LR    @01,WCCWN                                           0375
         BCTR  @01,0                                               0375
         SLA   @01,3                                               0375
         ALR   @01,@07                                             0375
         ST    @01,CPAWCPE(,@15)                                   0375
*   CPAWREAL=CPAWCPS;               /* SET VIRTUAL ADDR OF WRITE CP  */
         ST    @07,CPAWREAL(,@15)                                  0376
*   CPAIDAL=CPAWCPE+LENGTH(CCW);    /* SET ADDR OF REAL PAGE LIST    */
         AL    @01,@CF00051                                        0377
         ST    @01,CPAIDAL(,@15)                                   0377
*   CPAVPL=CPAIDAL+R8;              /* SET ADDR OF VIRTUAL PAGE LIST */
         ALR   @01,R8                                              0378
         ST    @01,CPAVPL(,@15)                                    0378
*   IF AMBLFSTP=ON THEN             /* ICI SPECIFIED         @X04SVCJ*/
         L     @11,ACBAMBL(,RACB)                                  0379
         TM    AMBLFSTP(@11),B'00010000'                           0379
         BNO   @RF00379                                            0379
*     CPABLKSZ=LPMBLKSZ;            /* SET BLOCKSIZE         @X04SVCJ*/
         L     @11,AMBPTR(,PARMPTR)                                0380
         L     @11,AMBEDB(,@11)                                    0380
         L     @11,EDBLPMBC(,@11)                                  0380
         L     @11,LPMBLKSZ(,@11)                                  0380
         ST    @11,CPABLKSZ(,@15)                                  0380
*   IF BUFCFMT=ON THEN              /* IF PREFORMAT THEN             */
@RF00379 TM    BUFCFMT(R9),B'01000000'                             0381
         BNO   @RF00381                                            0381
*     CPAFWCNT=CPAVPL+R8;           /* FORMAT WRITE CNT AREA FOLLOWS
*                                      VPL                           */
         L     @15,BUFCCPA(,R9)                                    0382
         LR    @11,R8                                              0382
         AL    @11,CPAVPL(,@15)                                    0382
         ST    @11,CPAFWCNT(,@15)                                  0382
*   IF BUFCFMT=ON THEN              /* IF PREFORMAT THEN             */
@RF00381 TM    BUFCFMT(R9),B'01000000'                             0383
         BNO   @RF00383                                            0383
*     CPAWSID=CPAFWCNT+R6*DWORDLEN; /* SEARCH IDS FOLLOW FWCNT       */
         L     @15,BUFCCPA(,R9)                                    0384
         LR    @11,R6                                              0384
         SLA   @11,3                                               0384
         AL    @11,CPAFWCNT(,@15)                                  0384
         ST    @11,CPAWSID(,@15)                                   0384
*   ELSE                            /* NOT PREFORMAT         @Z30SSRL*/
*     CPAWSID=CPAVPL+R8;            /* SET ADDR OF SEARCH ID TABLE   */
         B     @RC00383                                            0385
@RF00383 L     @15,BUFCCPA(,R9)                                    0385
         LR    @11,R8                                              0385
         AL    @11,CPAVPL(,@15)                                    0385
         ST    @11,CPAWSID(,@15)                                   0385
*   IF RCCWN^=K0 THEN               /* IF NUMBER OF READ CCW NOT ZERO
*                                                            @Z30SSRL*/
@RC00383 L     @15,RCCWN                                           0386
         LTR   @15,@15                                             0386
         BZ    @RF00386                                            0386
*     DO;                                                          0387
*       CPARCPS=CPAWSID+(LENGTH(SEARCHID)*R6+K7)&(-K8);/* SET ADDR OF
*                                      READ CHANNEL PROGRAM SEGMENT
*                                                            @X04SVCJ*/
         L     @15,BUFCCPA(,R9)                                    0388
         LR    @11,R6                                              0388
         MH    @11,@CH00047                                        0388
         AL    @11,@CF00049                                        0388
         AL    @11,CPAWSID(,@15)                                   0388
         N     @11,@CF04051                                        0388
         ST    @11,CPARCPS(,@15)                                   0388
*       CPARREAL=CPARCPS;           /* SET VIRTUAL ADDR OF READ CP   */
         ST    @11,CPARREAL(,@15)                                  0389
*       CPARCPE=CPARCPS+(CCWCRD+R6-K1)*LENGTH(CCW);/* SET ADDR LAST
*                                      READ CCW              @Z30SSDT*/
         LR    @07,R6                                              0390
         SL    @07,@CF04052                                        0390
         SLA   @07,3                                               0390
         ALR   @11,@07                                             0390
         ST    @11,CPARCPE(,@15)                                   0390
*     END;                                                         0391
*   CPAVPLV=ON;                     /* SET VPL VALID ON FOR NOW      */
@RF00386 L     @15,BUFCCPA(,R9)                                    0392
         OI    CPAVPLV(@15),B'10000000'                            0392
*   IF BUFCFMT=ON THEN              /* IF PREFORMAT          @Z30SSRL*/
         TM    BUFCFMT(R9),B'01000000'                             0393
         BNO   @RF00393                                            0393
*     CPAVPLV=OFF;                  /* VPL INVALID           @Z30SSRL*/
         NI    CPAVPLV(@15),B'01111111'                            0394
*   ELSE                            /* NOT PREFORMAT         @Z30SSRL*/
*     IF AMBUBF=ON&                 /* IF USER PROVIDING BUFRS       */
*         BUFCINS=OFF THEN          /* IF NOT INSERT BUFR            */
         B     @RC00393                                            0395
@RF00393 L     @15,AMBPTR(,PARMPTR)                                0395
         TM    AMBUBF(@15),B'00000100'                             0395
         BNO   @RF00395                                            0395
         TM    BUFCINS(R9),B'00100000'                             0395
         BNZ   @RF00395                                            0395
*       CPAVPLV=OFF;                /* BUFR ADDR NOT VALID           */
         L     @15,BUFCCPA(,R9)                                    0396
         NI    CPAVPLV(@15),B'01111111'                            0396
*   RESPECIFY                                                      0397
*     R8 UNRSTD;                    /*                       @X04SVCJ*/
*   END INITCPAH;                   /*                       @X04SVCJ*/
@EL00004 DS    0H                                                  0398
@EF00004 DS    0H                                                  0398
@ER00004 BR    @14                                                 0398
*INITUWCP:                                                         0399
*                                                                  0399
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE UPDATE WRITE CHANNEL PROGRAM SEGMENT               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0399
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0399
INITUWCP DS    0H                                                  0400
*   RESPECIFY                                                      0400
*    (R11,                                                         0400
*     R12) RSTD;                    /*                       @X04SVCJ*/
*   R10=CPAWCPS;                    /* POINT TO FIRST CCW            */
         L     @15,BUFCCPA(,R9)                                    0401
         L     R10,CPAWCPS(,@15)                                   0401
*   RESPECIFY                                                      0402
*     CCW BASED(R10);               /* SET UP SEEK HEAD CCW          */
*   CCWCODE=CCSEEKH;                /* SET COMMAND CODE              */
         MVI   CCWCODE(R10),X'1B'                                  0403
*   CCWAREA=ADDR(CPAWSEEK);         /* POINT BACK TO HEADER          */
         LA    @08,CPAWSEEK(,@15)                                  0404
         STCM  @08,7,CCWAREA(R10)                                  0404
*   CCWCC=ON;                       /* SET COMMAND CHAINING BIT      */
         OI    CCWCC(R10),B'01000000'                              0405
*   CCWLEN=LENGTH(CPAWSEEK);        /* SET LENGTH OF SEEK ARG SET UP
*                                      SID EQ, TIC, WD CCWS          */
         MVC   CCWLEN(2,R10),@CH00105                              0406
*   R10=R10+LENGTH(CCW);            /* UPDATE POINTER        @X04SVCJ*/
         LA    @08,8                                               0407
         ALR   R10,@08                                             0407
*   CCWCODE=CCSS;                   /* SET SET SECTOR COMMAND CODE 0408
*                                                            @X04SVCJ*/
         MVI   CCWCODE(R10),X'23'                                  0408
*   CCWCC=ON;                       /* SET COMMAND CHAINING  @X04SVCJ*/
*   CCWSLI=ON;                      /* SET SLI               @X04SVCJ*/
         OI    CCWCC(R10),B'01100000'                              0410
*   CCWLEN=K1;                      /* SET LENGTH            @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00043                              0411
*   CCWAREA=ADDR(CPAWSECT);         /* SET ADDRESS           @X04SVCJ*/
         LA    @07,CPAWSECT(,@15)                                  0412
         STCM  @07,7,CCWAREA(R10)                                  0412
*   R10=R10+LENGTH(CCW);            /* UPDATE POINTER        @X04SVCJ*/
         ALR   R10,@08                                             0413
*   R11=CPAWSID;                    /* POINT TO SEARCH ID ARGS       */
         L     R11,CPAWSID(,@15)                                   0414
*   RESPECIFY                                                      0415
*     SEARCHID BASED(R11);                                         0415
*   R12=CPAIDAL;                    /* POINT TO REAL PAGE LIST       */
         L     R12,CPAIDAL(,@15)                                   0416
*   DO C3=R6 TO K1 BY-K1;           /* BUILD 3 CCW/BLKSIZE OR 2K   0417
*                                                            @X04SVCJ
*                                      BUILD SEARCH ID EQ CCW        */
         LR    C3,R6                                               0417
         B     @DE00417                                            0417
@DL00417 DS    0H                                                  0418
*     IF C3=R6 THEN                 /* IF FIRST SET OF 3 CCWS, THEN  */
         CR    C3,R6                                               0418
         BNE   @RF00418                                            0418
*       CCWCODE=CCSIDEQ;            /* NO MT ON              @X04SVCJ*/
         MVI   CCWCODE(R10),X'31'                                  0419
*     ELSE                          /* NOT FIRST             @X04SVCJ*/
*       CCWCODE=CCMTSIDE;           /* IF NOT FIRST, MT ON   @X04SVCJ*/
         B     @RC00418                                            0420
@RF00418 MVI   CCWCODE(R10),X'B1'                                  0420
*     CCWAREA=ADDR(SEARCHID);       /* AREA IS IN SEARCH ID ARG TABLE*/
@RC00418 STCM  R11,7,CCWAREA(R10)                                  0421
*     R11=R11+LENGTH(SEARCHID);     /* POINT TO NEXT SEARCH ID ARG   */
         LA    @15,5                                               0422
         ALR   R11,@15                                             0422
*     CCWCC=ON;                     /* SET COMMAND CHAINING BIT      */
         OI    CCWCC(R10),B'01000000'                              0423
*     CCWLEN=LENGTH(SEARCHID);      /* SET SEARCH LENGTH BUILD TIC   */
         STH   @15,CCWLEN(,R10)                                    0424
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         LA    @15,8                                               0425
         ALR   R10,@15                                             0425
*     CCWCODE=CCTIC;                /* SET COMMAND CODE TO TIC       */
         MVI   CCWCODE(R10),X'08'                                  0426
*     CCWAREA=ADDR(CCW)-LENGTH(CCW);/* TIC TO CCW-1 BUILD WRITE DATA
*                                      CCW                           */
         LR    @08,R10                                             0427
         SLR   @08,@15                                             0427
         STCM  @08,7,CCWAREA(R10)                                  0427
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         ALR   R10,@15                                             0428
*     CCWCODE=CCWD;                 /* SET COMMAND CODE              */
         MVI   CCWCODE(R10),X'05'                                  0429
*     CCWAREA=R12;                  /* AREA IN IDAL                  */
         STCM  R12,7,CCWAREA(R10)                                  0430
*     IF AMBLFSTP=OFF               /* ICI SPECIFIED         @X04SVCJ*/
*         |BUFCWC=ON THEN           /* WRITE CHECK           @X04SVCJ*/
         L     @15,ACBAMBL(,RACB)                                  0431
         TM    AMBLFSTP(@15),B'00010000'                           0431
         BZ    @RT00431                                            0431
         TM    BUFCWC(R9),B'00001000'                              0431
         BNO   @RF00431                                            0431
@RT00431 DS    0H                                                  0432
*       CCWCC=ON;                   /* SET COMMAND CHAINING BIT ON   */
         OI    CCWCC(R10),B'01000000'                              0432
*     CCWIDAL=ON;                   /* SET IDAL BIT ON               */
@RF00431 OI    CCWIDAL(R10),B'00000100'                            0433
*     IF LPMBLKSZ>IOPAGESZ THEN     /* IF PHYSICAL BLKSIZE>PAGE    0434
*                                                            @X04SVCJ*/
         L     @15,AMBPTR(,PARMPTR)                                0434
         L     @15,AMBEDB(,@15)                                    0434
         L     @15,EDBLPMBC(,@15)                                  0434
         L     @15,LPMBLKSZ(,@15)                                  0434
         C     @15,@CF00039                                        0434
         BNH   @RF00434                                            0434
*       R12=R12+K12;                /* POINT TO NEXT IDAL ENTRY    0435
*                                                            @Z30SSRL*/
         AL    R12,@CF00053                                        0435
*     ELSE                          /* IF PHYSICAL BLKSIZE<=PAGE     */
*       R12=R12+K8;                 /* POINT TO NEXT IDAL ENTRY    0436
*                                                            @Z30SSRL*/
         B     @RC00434                                            0436
@RF00434 AL    R12,@CF00051                                        0436
*     CCWLEN=LPMBLKSZ;              /* SET LENGTH            @X04SVCJ*/
@RC00434 L     @15,AMBPTR(,PARMPTR)                                0437
         L     @15,AMBEDB(,@15)                                    0437
         L     @15,EDBLPMBC(,@15)                                  0437
         L     @15,LPMBLKSZ(,@15)                                  0437
         STH   @15,CCWLEN(,R10)                                    0437
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         AL    R10,@CF00051                                        0438
*   END;                            /* BUILD NOP                     */
         BCTR  C3,0                                                0439
@DE00417 LTR   C3,C3                                               0439
         BP    @DL00417                                            0439
*   CCWCODE=CCNOP;                  /* SET COMMAND CODE ONLY         */
         MVI   CCWCODE(R10),X'03'                                  0440
*   CCWSLI=ON;                                                     0441
         OI    CCWSLI(R10),B'00100000'                             0441
*   CCWLEN=K2;                      /* SET DUMMY LENGTH      @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00037                              0442
*   END INITUWCP;                   /*                       @X04SVCJ*/
@EL00005 DS    0H                                                  0443
@EF00005 DS    0H                                                  0443
@ER00005 BR    @14                                                 0443
*INITFMTW:                                                         0444
*                                                                  0444
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE FORMAT WRITE CHANNEL PROGRAM SEGMENT               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0444
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
INITFMTW DS    0H                                                  0445
*   R10=CPAWCPS;                    /* POINT TO FIRST CCW            */
         L     @15,BUFCCPA(,R9)                                    0445
         L     R10,CPAWCPS(,@15)                                   0445
*   RESPECIFY                                                      0446
*     CCW BASED(R10);               /* SET UP SEEK HEAD CCW          */
*   CCWCODE=CCSEEKH;                /* SET COMMAND CODE              */
         MVI   CCWCODE(R10),X'1B'                                  0447
*   CCWAREA=ADDR(CPAWSEEK);         /* POINT BACK TO HEADER          */
         LA    @08,CPAWSEEK(,@15)                                  0448
         STCM  @08,7,CCWAREA(R10)                                  0448
*   CCWCC=ON;                       /* SET COMMAND CHAINING BIT      */
         OI    CCWCC(R10),B'01000000'                              0449
*   CCWLEN=LENGTH(CPAWSEEK);        /* SET LENGTH OF SEEK ARG SET UP
*                                      SID EQ, TIC, WD CCWS          */
         MVC   CCWLEN(2,R10),@CH00105                              0450
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         LA    @08,8                                               0451
         ALR   R10,@08                                             0451
*   CCWCODE=CCSS;                   /* SET SET SECTOR COMMAND CODE 0452
*                                                            @X04SVCJ*/
         MVI   CCWCODE(R10),X'23'                                  0452
*   CCWCC=ON;                       /* SET COMMAND CHAINING  @X04SVCJ*/
*   CCWSLI=ON;                      /* SET SLI               @X04SVCJ*/
         OI    CCWCC(R10),B'01100000'                              0454
*   CCWLEN=K1;                      /* SET LENGTH            @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00043                              0455
*   CCWAREA=ADDR(CPAWSECT);         /* SET ADDRESS           @X04SVCJ*/
         LA    @07,CPAWSECT(,@15)                                  0456
         STCM  @07,7,CCWAREA(R10)                                  0456
*   R10=R10+LENGTH(CCW);            /* UPDATE POINTER        @X04SVCJ*/
         ALR   R10,@08                                             0457
*   CCWCODE=CCSIDEQ;                /* BUILD SEARCH ID EQU CCW       */
         MVI   CCWCODE(R10),X'31'                                  0458
*   CCWAREA=CPAWSID;                /* ADDRESS OF SEARCH ID  @Z30SSDT*/
         MVC   CCWAREA(3,R10),CPAWSID+1(@15)                       0459
*   CCWCC=ON;                       /* COMMAND CHAINING              */
         OI    CCWCC(R10),B'01000000'                              0460
*   CCWLEN=K5;                      /* LENGTH OF SEARCH ID   @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00047                              0461
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         ALR   R10,@08                                             0462
*   CCWCODE=CCTIC;                  /* BUILD TIC CCW                 */
         MVI   CCWCODE(R10),X'08'                                  0463
*   CCWAREA=R10-LENGTH(CCW);        /* ADDR OF PREVIOUS CCW          */
         LCR   @08,@08                                             0464
         ALR   @08,R10                                             0464
         STCM  @08,7,CCWAREA(R10)                                  0464
*   R11=CPAFWCNT;                   /* POINT TO FW COUNT AREA        */
         L     R11,CPAFWCNT(,@15)                                  0465
*   IF BUFCPFCP=ON THEN             /* IF PREFORMAT COMPLETE         */
         TM    BUFCPFCP(R9),B'00000010'                            0466
         BNO   @RF00466                                            0466
*     C3=R6;                        /* THEN MANY CCW SETS            */
         LR    C3,R6                                               0467
*   ELSE                            /* ONLY ONE              @X04SVCJ*/
*     C3=K1;                        /* IF NOT PREF COMP 1 SET CCWS 0468
*                                                            @X04SVCJ*/
         B     @RC00466                                            0468
@RF00466 LA    C3,1                                                0468
*   DO C3=C3 TO K1 BY-K1;           /* COMPLETE CCWS         @X04SVCJ*/
@RC00466 B     @DE00469                                            0469
@DL00469 DS    0H                                                  0470
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         LA    @15,8                                               0470
         ALR   R10,@15                                             0470
*     CCWCODE=CCWCKD;               /* BUILD WCKD CCW                */
         MVI   CCWCODE(R10),X'1D'                                  0471
*     CCWAREA=R11;                  /* POINT TO FW COUNT AREA        */
         STCM  R11,7,CCWAREA(R10)                                  0472
*     R11=R11+DWORDLEN;             /* POINT TO NEXT FW COUNT AREA   */
         ALR   R11,@15                                             0473
*     CCWDC=ON;                     /* DATA CHAINING                 */
         OI    CCWDC(R10),B'10000000'                              0474
*     CCWLEN=K8;                    /* LENGTH OF DATA        @X04SVCJ*/
         STH   @15,CCWLEN(,R10)                                    0475
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         ALR   R10,@15                                             0476
*     CCWCODE=CCWCKD;               /* BUILD 2ND WCKD CCW            */
         MVI   CCWCODE(R10),X'1D'                                  0477
*     CCWAREA=CPAIDAL;              /* ADDR OF REAL PAGE LIST        */
         L     @15,BUFCCPA(,R9)                                    0478
         MVC   CCWAREA(3,R10),CPAIDAL+1(@15)                       0478
*     IF AMBLFSTP=OFF               /* ICI SPECIFIED         @X04SVCJ*/
*         |BUFCWC=ON THEN           /* WRITE CHECK           @X04SVCJ*/
         L     @15,ACBAMBL(,RACB)                                  0479
         TM    AMBLFSTP(@15),B'00010000'                           0479
         BZ    @RT00479                                            0479
         TM    BUFCWC(R9),B'00001000'                              0479
         BNO   @RF00479                                            0479
@RT00479 DS    0H                                                  0480
*       CCWCC=ON;                   /* COMMAND CHAINING              */
         OI    CCWCC(R10),B'01000000'                              0480
*     CCWIDAL=ON;                   /* INDIRECT ADDRESSING           */
@RF00479 OI    CCWIDAL(R10),B'00000100'                            0481
*     CCWLEN=LPMBLKSZ;              /* DATA LENGTH EQUAL PHYSICAL  0482
*                                      BLOCK SIZE            @X04SVCJ*/
         L     @15,AMBPTR(,PARMPTR)                                0482
         L     @15,AMBEDB(,@15)                                    0482
         L     @15,EDBLPMBC(,@15)                                  0482
         L     @15,LPMBLKSZ(,@15)                                  0482
         STH   @15,CCWLEN(,R10)                                    0482
*   END;                                                           0483
         BCTR  C3,0                                                0483
@DE00469 LTR   C3,C3                                               0483
         BP    @DL00469                                            0483
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         AL    R10,@CF00051                                        0484
*   CCWCODE=CCNOP;                  /* SET COMMAND CODE ONLY         */
         MVI   CCWCODE(R10),X'03'                                  0485
*   CCWSLI=ON;                      /* SUPPRESS LENGTH ERROR         */
         OI    CCWSLI(R10),B'00100000'                             0486
*   CCWLEN=K2;                      /* SET DUMMY LENGTH      @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00037                              0487
*   END INITFMTW;                   /*                       @X04SVCJ*/
@EL00006 DS    0H                                                  0488
@EF00006 DS    0H                                                  0488
@ER00006 BR    @14                                                 0488
*BLDWCCP:                                                          0489
*                                                                  0489
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD WRITE CHECK CHANNEL PROGRAM                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0489
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
BLDWCCP  DS    0H                                                  0490
*   R10=CPAWCKS;                    /* POINT TO FIRST CCW AREA       */
         L     @15,BUFCCPA(,R9)                                    0490
         L     R10,CPAWCKS(,@15)                                   0490
*   R12=CPAIDAL;                    /* POINT TO IDAL AREA SET UP SEEK
*                                      HEAD CCW                      */
         L     R12,CPAIDAL(,@15)                                   0491
*   CCWCODE=CCSEEKH;                /* COMMAND CODE IS SEEK HEAD     */
         MVI   CCWCODE(R10),X'1B'                                  0492
*   CCWAREA=ADDR(CPAWSEEK);         /* SEEK ARG IN CPA HEADER        */
         LA    @08,CPAWSEEK(,@15)                                  0493
         STCM  @08,7,CCWAREA(R10)                                  0493
*   CCWCC=ON;                       /* COMMAND CHAINING              */
         OI    CCWCC(R10),B'01000000'                              0494
*   CCWLEN=LENGTH(CPAWSEEK);        /* SET CCW LENGTH                */
         MVC   CCWLEN(2,R10),@CH00105                              0495
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         LA    @08,8                                               0496
         ALR   R10,@08                                             0496
*   CCWCODE=CCSS;                   /* SET SET SECTOR COMMAND CODE 0497
*                                                            @X04SVCJ*/
         MVI   CCWCODE(R10),X'23'                                  0497
*   CCWCC=ON;                       /* SET COMMAND CHAINING  @X04SVCJ*/
*   CCWSLI=ON;                      /* SET SLI               @X04SVCJ*/
         OI    CCWCC(R10),B'01100000'                              0499
*   CCWLEN=K1;                      /* SET LENGTH            @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00043                              0500
*   CCWAREA=ADDR(CPAWSECT);         /* SET ADDRESS           @X04SVCJ*/
         LA    @07,CPAWSECT(,@15)                                  0501
         STCM  @07,7,CCWAREA(R10)                                  0501
*   R10=R10+LENGTH(CCW);            /* UPDATE POINTER        @X04SVCJ
*                                      SET UP SRCH ID EQ CCW         */
         ALR   R10,@08                                             0502
*   CCWCODE=CCSIDEQ;                /* COMMAND CODE IS SRCH ID EQ    */
         MVI   CCWCODE(R10),X'31'                                  0503
*   IF BUFCFMT=ON THEN              /* IF PREFORMAT THEN     @Z30SSDT*/
         TM    BUFCFMT(R9),B'01000000'                             0504
         BNO   @RF00504                                            0504
*     CCWAREA=CPAFWCNT;             /* LOAD ADDR OF FORMAT WRITE   0505
*                                      COUNT FIELD                   */
         MVC   CCWAREA(3,R10),CPAFWCNT+1(@15)                      0505
*   ELSE                            /* IF NOT PREFORMAT      @Z30SSDT*/
*     CCWAREA=CPAWSID;              /* INIT AREA             @Z30SSDT*/
         B     @RC00504                                            0506
@RF00504 L     @15,BUFCCPA(,R9)                                    0506
         MVC   CCWAREA(3,R10),CPAWSID+1(@15)                       0506
*   CCWCC=ON;                       /* COMMAND CHAINING              */
@RC00504 OI    CCWCC(R10),B'01000000'                              0507
*   CCWLEN=LENGTH(SEARCHID);        /* SET CCW LENGTH                */
         MVC   CCWLEN(2,R10),@CH00047                              0508
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW SET UP TIC
*                                      CCW                           */
         LA    @15,8                                               0509
         ALR   R10,@15                                             0509
*   CCWCODE=CCTIC;                  /* COMMAND CODE IS TIC           */
         MVI   CCWCODE(R10),X'08'                                  0510
*   CCWAREA=R10-LENGTH(CCW);        /* POINT BACK LAST CCW           */
         LR    @08,R10                                             0511
         SLR   @08,@15                                             0511
         STCM  @08,7,CCWAREA(R10)                                  0511
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW SET UP READ
*                                      NT CCWS                       */
         ALR   R10,@15                                             0512
*   DO C3=R6 TO K1 BY-K1;           /* CREATE RL CCWS        @X04SVCJ*/
         LR    C3,R6                                               0513
         B     @DE00513                                            0513
@DL00513 DS    0H                                                  0514
*     IF C3=R6 THEN                 /* IF THIS IS FIRST CCW          */
         CR    C3,R6                                               0514
         BNE   @RF00514                                            0514
*       CCWCODE=CCRD;               /* NO MT FOR FIRST CCW RD        */
         MVI   CCWCODE(R10),X'06'                                  0515
*     ELSE                          /* IF NOT THE FIRST CCW          */
*       CCWCODE=CCMTRD;             /* CCW CODE IS MT READ           */
         B     @RC00514                                            0516
@RF00514 MVI   CCWCODE(R10),X'86'                                  0516
*     CCWAREA=R12;                  /* AREA IS IN IDAL               */
@RC00514 STCM  R12,7,CCWAREA(R10)                                  0517
*     IF AMBLFSTP=OFF THEN          /* ICI SPECIFIED         @X04SVCJ*/
         L     @15,ACBAMBL(,RACB)                                  0518
         TM    AMBLFSTP(@15),B'00010000'                           0518
         BNZ   @RF00518                                            0518
*       CCWCC=ON;                   /* COMMAND CHAINING              */
         OI    CCWCC(R10),B'01000000'                              0519
*     CCWST=ON;                     /* SUPPRESS DATA TRANSFER        */
@RF00518 OI    CCWST(R10),B'00010000'                              0520
*     IF LPMBLKSZ>IOPAGESZ THEN     /* IF PHYSICAL BLKSIZE>PAGE    0521
*                                                            @Z30SSDT*/
         L     @15,AMBPTR(,PARMPTR)                                0521
         L     @15,AMBEDB(,@15)                                    0521
         L     @15,EDBLPMBC(,@15)                                  0521
         L     @15,LPMBLKSZ(,@15)                                  0521
         C     @15,@CF00039                                        0521
         BNH   @RF00521                                            0521
*       DO;                                                        0522
*         IF BUFCPFCP=OFF THEN      /* IF PREFORMAT CP COMPLETE      */
         TM    BUFCPFCP(R9),B'00000010'                            0523
         BNZ   @RF00523                                            0523
*           R12=R12+K12;            /* BUMP IDAL POINTER     @Z30SSRL*/
         AL    R12,@CF00053                                        0524
*       END;                                                       0525
*     ELSE                          /* IF PHYSICAL BLKSIZE<=PAGE     */
*       DO;                                                        0526
         B     @RC00521                                            0526
@RF00521 DS    0H                                                  0527
*         IF BUFCPFCP=OFF THEN      /* IF PREFORMAT CP COMPLETE      */
         TM    BUFCPFCP(R9),B'00000010'                            0527
         BNZ   @RF00527                                            0527
*           R12=R12+K8;             /* BUMP POINTER TO IDAL  @Z30SSRL*/
         AL    R12,@CF00051                                        0528
*       END;                                                       0529
@RF00527 DS    0H                                                  0530
*     CCWLEN=LPMBLKSZ;              /* SET LENGTH AS BLOCKSIZE     0530
*                                                            @X04SVCJ*/
@RC00521 L     @15,AMBPTR(,PARMPTR)                                0530
         L     @15,AMBEDB(,@15)                                    0530
         L     @15,EDBLPMBC(,@15)                                  0530
         L     @15,LPMBLKSZ(,@15)                                  0530
         STH   @15,CCWLEN(,R10)                                    0530
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         AL    R10,@CF00051                                        0531
*   END;                            /* SET UP NOP                    */
         BCTR  C3,0                                                0532
@DE00513 LTR   C3,C3                                               0532
         BP    @DL00513                                            0532
*   CCWCODE=CCNOP;                  /* SET COMMAND CODE              */
         MVI   CCWCODE(R10),X'03'                                  0533
*   CCWSLI=ON;                      /* SUPPRESS LENGTH ERROR         */
         OI    CCWSLI(R10),B'00100000'                             0534
*   CCWLEN=K2;                      /* SET DUMMY LENGTH      @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00037                              0535
*   END BLDWCCP;                    /*                       @X04SVCJ*/
@EL00007 DS    0H                                                  0536
@EF00007 DS    0H                                                  0536
@ER00007 BR    @14                                                 0536
*BLDVPL:                                                           0537
*                                                                  0537
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD VIRTUAL PAGE LIST                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0537
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
BLDVPL   DS    0H                                                  0538
*   R10=CPAVPL;                     /* POINT TO VIRTUAL PAGE LIST    */
         L     @15,BUFCCPA(,R9)                                    0538
         L     R10,CPAVPL(,@15)                                    0538
*   R11=BUFCBAD;                    /* POINT TO BUFFER               */
         L     R11,BUFCBAD(,R9)                                    0539
*   C3=R6;                          /* INIT NO. OF VPL'S     @Z30SSRL*/
         LR    C3,R6                                               0540
*   IF LPMBLKSZ>IOPAGESZ THEN       /* IF PHYSICAL BLKSIZE>PAGE    0541
*                                                            @Z30SSDT*/
         LA    @15,2048                                            0541
         L     @08,AMBPTR(,PARMPTR)                                0541
         L     @08,AMBEDB(,@08)                                    0541
         L     @08,EDBLPMBC(,@08)                                  0541
         C     @15,LPMBLKSZ(,@08)                                  0541
         BNL   @RF00541                                            0541
*     DO;                                                          0542
*       R12=IOPAGESZ;               /* SET INCR              @Z30SSDT*/
         LR    R12,@15                                             0543
*       DO C3=C3 TO K1 BY-K1;       /* INIT VPL ENTRIES      @Z30SSRL*/
         B     @DE00544                                            0544
@DL00544 DS    0H                                                  0545
*         R10->VPLENT=R11;          /* POINT VPL TO PART OF BUFFER 0545
*                                                            @Z30SSRL*/
         STCM  R11,15,VPLENT(R10)                                  0545
*         R11=R11+R12;              /* BUMP BUFFER POINTER   @Z30SSRL*/
         ALR   R11,R12                                             0546
*         R10=R10+LENGTH(VPLENT);   /* BUMP VPL POINTER      @Z30SSRL*/
         AL    R10,@CF00080                                        0547
*         R10->VPLENT=R11;          /* POINT TO PART OF BFR  @Z30SSRL*/
         STCM  R11,15,VPLENT(R10)                                  0548
*         R11=R11+R12;              /* BUMP BUFFER POINTER   @Z30SSRL*/
         ALR   R11,R12                                             0549
*         R10=R10+LENGTH(VPLENT)*K2;/* SKIP ONE ENTRY        @Z30SSRL*/
         AL    R10,@CF00051                                        0550
*       END;                        /*                       @Z30SSRL*/
         BCTR  C3,0                                                0551
@DE00544 LTR   C3,C3                                               0551
         BP    @DL00544                                            0551
*     END;                                                         0552
*   ELSE                            /* IF PHYSICAL BLKSIZE<=PAGE     */
*     DO;                                                          0553
         B     @RC00541                                            0553
@RF00541 DS    0H                                                  0554
*       R12=LPMBLKSZ;               /* SET INCR              @X04SVCJ*/
         L     @15,AMBPTR(,PARMPTR)                                0554
         L     @15,AMBEDB(,@15)                                    0554
         L     @15,EDBLPMBC(,@15)                                  0554
         L     R12,LPMBLKSZ(,@15)                                  0554
*       DO C3=C3 TO K1 BY-K1;       /* INIT VPL ENTRIES      @Z30SSRL*/
         B     @DE00555                                            0555
@DL00555 DS    0H                                                  0556
*         R10->VPLENT=R11;          /* POINT TO PART OF BFR  @Z30SSRL*/
         STCM  R11,15,VPLENT(R10)                                  0556
*         R11=R11+R12;              /* BUMP BUFFER POINTER   @Z30SSRL*/
         ALR   R11,R12                                             0557
*         R10=R10+LENGTH(VPLENT)*K2;/* SKIP NEXT ENTRY       @Z30SSRL*/
         AL    R10,@CF00051                                        0558
*       END;                        /*                       @Z30SSRL*/
         BCTR  C3,0                                                0559
@DE00555 LTR   C3,C3                                               0559
         BP    @DL00555                                            0559
*     END;                                                         0560
*   END BLDVPL;                     /*                       @X04SVCJ*/
@EL00008 DS    0H                                                  0561
@EF00008 DS    0H                                                  0561
@ER00008 BR    @14                                                 0561
*BLDRCP:                                                           0562
*                                                                  0562
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD READ CHANNEL PROGRAM SEGMENT                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0562
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
BLDRCP   DS    0H                                                  0563
*   R10=CPARCPS;                    /* POINT TO FIRST CCW BUILD SEEK
*                                      HEAD CCW                      */
         L     @15,BUFCCPA(,R9)                                    0563
         L     R10,CPARCPS(,@15)                                   0563
*   CCWCODE=CCSEEKH;                /* SET COMMAND CODE SEEK HEAD    */
         MVI   CCWCODE(R10),X'1B'                                  0564
*   CCWAREA=ADDR(CPARSEEK);         /* POINT AREA TO HEADER          */
         LA    @08,CPARSEEK(,@15)                                  0565
         STCM  @08,7,CCWAREA(R10)                                  0565
*   CCWCC=ON;                       /* SET COMMAND CHAINING BIT      */
         OI    CCWCC(R10),B'01000000'                              0566
*   CCWLEN=LENGTH(CPARSEEK);        /* SET SEEK ARG LENGTH BUILD   0567
*                                      SEARCH ID EQ CCW              */
         MVC   CCWLEN(2,R10),@CH00105                              0567
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         LA    @08,8                                               0568
         ALR   R10,@08                                             0568
*   CCWCODE=CCSS;                   /* SET SET SECTOR COMMAND CODE 0569
*                                                            @X04SVCJ*/
         MVI   CCWCODE(R10),X'23'                                  0569
*   CCWCC=ON;                       /* SET COMMAND CHAINING  @X04SVCJ*/
*   CCWSLI=ON;                      /* SET SLI               @X04SVCJ*/
         OI    CCWCC(R10),B'01100000'                              0571
*   CCWLEN=K1;                      /* SET LENGTH            @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00043                              0572
*   CCWAREA=ADDR(CPARSECT);         /* SET ADDRESS           @Z30SSDT*/
         LA    @07,CPARSECT(,@15)                                  0573
         STCM  @07,7,CCWAREA(R10)                                  0573
*   R10=R10+LENGTH(CCW);            /* UPDATE POINTER        @X04SVCJ*/
         ALR   R10,@08                                             0574
*   CCWCODE=CCSIDEQ;                /* SET COMMAND CODE              */
         MVI   CCWCODE(R10),X'31'                                  0575
*   CCWAREA=ADDR(CPARSID);          /* POINT BACK TO HEADER  @Z30SSDT*/
         LA    @07,CPARSID(,@15)                                   0576
         STCM  @07,7,CCWAREA(R10)                                  0576
*   CCWCC=ON;                       /* COMMAND CHAINING BIT          */
*   CCWSLI=ON;                      /* SUPRESS INCORRECT LENGTH      */
         OI    CCWCC(R10),B'01100000'                              0578
*   CCWLEN=LENGTH(CPARSID);         /* SET SEARCH ID ARG LENGTH BUILD
*                                      TIC                           */
         MVC   CCWLEN(2,R10),@CH00047                              0579
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         ALR   R10,@08                                             0580
*   CCWCODE=CCTIC;                  /* SET COMMAND CODE              */
         MVI   CCWCODE(R10),X'08'                                  0581
*   CCWAREA=ADDR(CCW)-LENGTH(CCW);  /* AREA IS CCW-1 BUILD READ DATA
*                                      CCWS                          */
         LR    @07,R10                                             0582
         SLR   @07,@08                                             0582
         STCM  @07,7,CCWAREA(R10)                                  0582
*   R10=R10+LENGTH(CCW);            /* POINT TO NEXT CCW             */
         ALR   R10,@08                                             0583
*   R12=CPAIDAL;                    /* POINT TO FIRST OF IDAL        */
         L     R12,CPAIDAL(,@15)                                   0584
*   DO C3=R6 TO 1 BY-1;             /* 1 RD CCW/BLK/CINV             */
         LR    C3,R6                                               0585
         B     @DE00585                                            0585
@DL00585 DS    0H                                                  0586
*     IF C3=R6 THEN                 /* FIRST READ            @Z30SSRL*/
         CR    C3,R6                                               0586
         BNE   @RF00586                                            0586
*       CCWCODE=CCRD;               /* NO MT FOR FIRST READ DATA     */
         MVI   CCWCODE(R10),X'06'                                  0587
*     ELSE                          /* NOT FIRST READ        @Z30SSRL*/
*       CCWCODE=CCMTRD;             /* MOUNT ON              @Z30SSRL*/
         B     @RC00586                                            0588
@RF00586 MVI   CCWCODE(R10),X'86'                                  0588
*     CCWAREA=R12;                  /* CCW AREA IN IDAL              */
@RC00586 STCM  R12,7,CCWAREA(R10)                                  0589
*     IF AMBLFSTP=OFF THEN          /* ICI PROCESSING        @X04SVCJ*/
         L     @15,ACBAMBL(,RACB)                                  0590
         TM    AMBLFSTP(@15),B'00010000'                           0590
         BNZ   @RF00590                                            0590
*       CCWCC=ON;                   /* CC ON AS USUAL                */
         OI    CCWCC(R10),B'01000000'                              0591
*     CCWIDAL=ON;                   /* SET IDAL BIT ON               */
@RF00590 OI    CCWIDAL(R10),B'00000100'                            0592
*     IF LPMBLKSZ>IOPAGESZ THEN     /* IF PHYSICAL BLKSIZE>PAGE    0593
*                                                            @X04SVCJ*/
         L     @15,AMBPTR(,PARMPTR)                                0593
         L     @15,AMBEDB(,@15)                                    0593
         L     @15,EDBLPMBC(,@15)                                  0593
         L     @15,LPMBLKSZ(,@15)                                  0593
         C     @15,@CF00039                                        0593
         BNH   @RF00593                                            0593
*       R12=R12+K12;                /* BUMP IDAL POINTER     @Z30SSRL*/
         AL    R12,@CF00053                                        0594
*     ELSE                          /* IF PHYSICAL BLKSIZE<=PAGE     */
*       R12=R12+K8;                 /* BUMP POINTER TO IDAL  @Z30SSRL*/
         B     @RC00593                                            0595
@RF00593 AL    R12,@CF00051                                        0595
*     CCWLEN=LPMBLKSZ;              /* SET CCW LENGTH        @X04SVCJ*/
@RC00593 L     @15,AMBPTR(,PARMPTR)                                0596
         L     @15,AMBEDB(,@15)                                    0596
         L     @15,EDBLPMBC(,@15)                                  0596
         L     @15,LPMBLKSZ(,@15)                                  0596
         STH   @15,CCWLEN(,R10)                                    0596
*     R10=R10+LENGTH(CCW);          /* POINT TO NEXT CCW             */
         AL    R10,@CF00051                                        0597
*   END;                            /* BUILD LAST NOP CCW            */
         BCTR  C3,0                                                0598
@DE00585 LTR   C3,C3                                               0598
         BP    @DL00585                                            0598
*   CCWCODE=CCNOP;                  /* LAST CCW IS NOP               */
         MVI   CCWCODE(R10),X'03'                                  0599
*   CCWSLI=ON;                      /* SUPPRESS LENGTH ERROR         */
         OI    CCWSLI(R10),B'00100000'                             0600
*   CCWLEN=K2;                      /* SET DUMMY LENGTH      @X04SVCJ*/
         MVC   CCWLEN(2,R10),@CH00037                              0601
*   END BLDRCP;                     /*                       @X04SVCJ*/
@EL00009 DS    0H                                                  0602
@EF00009 DS    0H                                                  0602
@ER00009 BR    @14                                                 0602
@PB00009 DS    0H                                                  0602
*   END IDA0192W                                                   0603
*                                                                  0603
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDABUFC )                                       */
*/*%INCLUDE SYSLIB  (IDACMB  )                                       */
*/*%INCLUDE SYSLIB  (IDACPA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IDAEDB  )                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IDAIDXCB)                                       */
*/*%INCLUDE SYSLIB  (IDAIOMB )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IDALPMB )                                       */
*/*%INCLUDE SYSLIB  (IDAOPWRK)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IDAFOREC)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                       */
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                       */
*/*%INCLUDE SYSLIB  (IDARTMAC)                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  0603
*       ;                                                          0603
@DATA    DS    0H
@CH00037 DC    H'2'
@CH00105 DC    H'6'
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
IDA0192W CSECT
         DS    0F
@CF00043 DC    F'1'
@CH00043 EQU   @CF00043+2
@CF00032 DC    F'3'
@CF00080 DC    F'4'
@CF00047 DC    F'5'
@CH00047 EQU   @CF00047+2
@CF00049 DC    F'7'
@CF00051 DC    F'8'
@CF00053 DC    F'12'
@CF01959 DC    F'96'
@CF00039 DC    F'2048'
@CF04051 DC    F'-8'
@CF04052 DC    F'-4'
@DATD    DSECT
         DS    0D
PDPTR    DS    A
RCCWN    DS    F
PREFRMAT DS    BL1
         DS    CL3
RSAVL    DS    2A
IDA0192W CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00122 DC    V(IDA0192M)
         DS    0D
@CC03972 DC    C'192W'
IDA0192W CSECT
         DS    0D                       START ON DOUBLE WORD BOUNDARY
PTCH192W DC    ((*-IDA0192W)/20)X'00'   PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192W CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
WCCWN    EQU   @11
PARMPTR  EQU   @05
C3       EQU   @07
R13      EQU   @13
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
RCORE    EQU   @04
R4       EQU   @04
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
RET      EQU   @14
R15      EQU   @15
RDEB     EQU   @11
RETCODE  EQU   @15
RTIOT    EQU   @09
RUCB     EQU   @10
R5       EQU   @05
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
SAVAREA  EQU   0
SABWRD   EQU   SAVAREA+4
SAREGS   EQU   SAVAREA+12
SACODE   EQU   SAREGS+4
SAREG0   EQU   SAREGS+8
PD       EQU   0
PPCODE   EQU   PD
PPFUNC   EQU   PD+1
PARM192W EQU   0
PREFBUFC EQU   PARM192W
BUFCPTR  EQU   PARM192W+4
AMBPTR   EQU   PARM192W+8
SEARCHID EQU   0
VPLENT   EQU   0
CCW      EQU   0
CCWCODE  EQU   CCW
CCWAREA  EQU   CCW+1
CCWFLGS  EQU   CCW+4
CCWDC    EQU   CCWFLGS
CCWCC    EQU   CCWFLGS
CCWSLI   EQU   CCWFLGS
CCWST    EQU   CCWFLGS
CCWIDAL  EQU   CCWFLGS
CCWLEN   EQU   CCW+6
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBTYPE  EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEDB   EQU   IDAAMB+52
AMBEOVPT EQU   IDAAMB+56
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
AMBCPA   EQU   IDAAMB+92
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLFSTP EQU   AMBLQ
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLCMB  EQU   IDAAMBL+64
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDSDT   EQU   AMDATTR
AMDNEST  EQU   IDAAMDSB+4
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
IDABUFDR EQU   0
BUFDRCIX EQU   IDABUFDR+9
BUFDRFLG EQU   IDABUFDR+11
IDABUFC  EQU   0
BUFCAVL  EQU   IDABUFC
BUFCFLG1 EQU   IDABUFC+1
BUFCINS  EQU   BUFCFLG1
BUFCIOFL EQU   IDABUFC+2
BUFCFMT  EQU   BUFCIOFL
BUFCWC   EQU   BUFCIOFL
BUFCPFCP EQU   BUFCIOFL
BUFCFLG2 EQU   IDABUFC+3
BUFCPLH  EQU   IDABUFC+4
BUFCCPA  EQU   IDABUFC+16
BUFCBAD  EQU   IDABUFC+20
BUFCINV  EQU   IDABUFC+28
BUFCHAIN EQU   IDABUFC+48
IDACMB   EQU   0
CMBFLGS  EQU   IDACMB+4
CMBPTRS  EQU   IDACMB+8
IDACPA   EQU   0
CPAID    EQU   IDACPA
CPALEN   EQU   IDACPA+2
CPAWREAL EQU   IDACPA+4
CPAWCPS  EQU   IDACPA+8
CPAWCPE  EQU   IDACPA+12
CPAWCKS  EQU   IDACPA+16
CPAWCKE  EQU   IDACPA+20
CPARREAL EQU   IDACPA+24
CPARCPS  EQU   IDACPA+28
CPARCPE  EQU   IDACPA+32
CPAWPHAD EQU   IDACPA+36
CPAWSEEK EQU   CPAWPHAD+1
CPAWSID  EQU   IDACPA+44
CPAFWCNT EQU   IDACPA+48
CPARPHAD EQU   IDACPA+52
CPARSEEK EQU   CPARPHAD+1
CPARSID  EQU   CPARSEEK+2
CPAIDAL  EQU   IDACPA+60
CPAVPL   EQU   IDACPA+64
CPABLKSZ EQU   IDACPA+76
CPABCINV EQU   IDACPA+80
CPASTAT1 EQU   IDACPA+83
CPAVPLV  EQU   CPASTAT1
CPAFLAGS EQU   IDACPA+84
CPAFLAG1 EQU   CPAFLAGS
CPAFLAG2 EQU   CPAFLAGS+1
CPARSECT EQU   IDACPA+86
CPAWSECT EQU   IDACPA+87
CPANXT1  EQU   IDACPA+88
CPACCW   EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IDAEDBHD EQU   0
EDBLPMBC EQU   IDAEDBHD+4
IDAEDB   EQU   0
EDBFLG1  EQU   IDAEDB+2
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLSYNF  EQU   EXLCOMN+10
EXLLERF  EQU   EXLCOMN+15
EXLSCIPF EQU   EXLCOMN+20
EXLLGNF  EQU   EXLCOMN+25
EXLJRNF  EQU   EXLCOMN+30
EXLOPNF  EQU   EXLCOMN+35
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLEXITP EQU   EXLENTRY+1
IDAIOMB  EQU   0
IOMCPA   EQU   IDAIOMB+8
IOMIOSB  EQU   IDAIOMB+36
IOMFLAGS EQU   IDAIOMB+40
IOMFL    EQU   IOMFLAGS
IOMAPEND EQU   IOMFL
IOMSTIND EQU   IOMFLAGS+2
IOMSAVER EQU   IDAIOMB+52
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00060 EQU   IOSB+20
IOSCSW   EQU   @NM00060+1
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
IDALPMB  EQU   0
LPMBFLGS EQU   IDALPMB+1
LPMBTOFL EQU   LPMBFLGS
LPMBLEN  EQU   IDALPMB+2
LPMBLKSZ EQU   IDALPMB+12
LPMBLKTR EQU   IDALPMB+20
IDAOPWRK EQU   0
OPW2MVS1 EQU   IDAOPWRK
OPW2MVS2 EQU   OPW2MVS1
OPWFLGS1 EQU   OPW2MVS2+12
OPWFLGS2 EQU   OPW2MVS2+13
OPWFLGS3 EQU   OPW2MVS2+14
OPWFLGS4 EQU   OPW2MVS2+15
OPWCOMWA EQU   OPW2MVS2+20
OPWIDF   EQU   OPW2MVS2+24
OPWQ     EQU   OPWIDF+7
OPWVSMPL EQU   OPW2MVS2+32
OPWVMANC EQU   OPWVSMPL
OPWVMLNG EQU   OPWVSMPL+5
OPWVMADR EQU   OPWVSMPL+8
OPWVMTYP EQU   OPWVSMPL+12
OPWVMFLG EQU   OPWVSMPL+13
OPWVMTCB EQU   OPWVMFLG
OPWVSMWA EQU   OPW2MVS2+48
OPWVGSPL EQU   OPWVSMWA+40
OPWVGMPL EQU   OPWVSMWA+76
OPWVFMPL EQU   OPWVSMWA+88
OPWSAVE  EQU   OPW2MVS2+144
OPWCURPT EQU   IDAOPWRK+164
OPWCATTR EQU   IDAOPWRK+199
OPWBSECL EQU   IDAOPWRK+568
OPWPTAIX EQU   IDAOPWRK+576
OPWUPAIX EQU   IDAOPWRK+588
OPWCURCL EQU   0
OPWCFLG1 EQU   OPWCURCL
OPWUPGR  EQU   OPWCFLG1
OPWFLG2  EQU   OPWCURCL+4
IDAPLHDR EQU   0
IDAPLH   EQU   0
PLHFLG1  EQU   IDAPLH+2
PLHFLG2  EQU   IDAPLH+3
PLHEFLGS EQU   IDAPLH+4
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHCRBA  EQU   IDAPLH+28
PLHDIOB  EQU   IDAPLH+76
PLHEOVPT EQU   IDAPLH+180
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHKEYPT EQU   IDAPLH+248
PLHEND   EQU   IDAPLH+280
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00126 EQU   RBSECT+10
@NM00127 EQU   @NM00126
RBTRSVRB EQU   @NM00127
@NM00129 EQU   @NM00126+1
RBETXR   EQU   @NM00129
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00136 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00140 EQU   RBSECT+96
RBRSV138 EQU   @NM00140+7
RBRSV150 EQU   RBSECT+167
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXJBF    EQU   FORCORE+100
DXIOB    EQU   FORCORE+280
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXB1 EQU   DXATEXC1
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECWTGTB EQU   IECEXTPR+72
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
IDAPDPRM EQU   0
PDPMSGFL EQU   IDAPDPRM+34
IDAVGTT  EQU   0
VGTTTYPE EQU   IDAVGTT+4
PLHKEY   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+5
PSARSVTE EQU   PSARSVT
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00174 EQU   DXXCTL
DXSAVMOD EQU   @NM00174+2
@NM00175 EQU   DXRESSW
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCRSV23 EQU   JFCOPTCD
JFCREORG EQU   JFCRSV23
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
PDWLIST  EQU   FORCORE
PDWWORK  EQU   DXDCB
IDARRPL  EQU   DXATCOM1
IDARRFLG EQU   IDARRPL+1
IDARSTAT EQU   DXATEXC1
RSTAT    EQU   IDARSTAT
RSTATCRO EQU   RSTAT+1
RSTATOP2 EQU   RSTAT+2
IDARRTN  EQU   DXATEXC2
RSTATRTN EQU   IDARRTN
BUFCRSC1 EQU   BUFCAVL
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
FLC      EQU   PSA
IDAESPL  EQU   DXATCOM1
IDARTSA  EQU   DXJBF
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00192 EQU   RSTAT+3
@NM00191 EQU   RSTATOP2
RSTATCSA EQU   RSTATOP2
IDARCURS EQU   RSTATCRO
IDARCRCU EQU   RSTATCRO
IDARRSTR EQU   RSTATCRO
IDARCKPT EQU   RSTATCRO
RSTATOPT EQU   RSTAT
@NM00190 EQU   IDARRPL+2
@NM00189 EQU   IDARRFLG
RRPLVSAM EQU   IDARRFLG
@NM00188 EQU   IDARRFLG
@NM00187 EQU   IDARRPL
PDWORKSP EQU   PDWWORK+88
PDWERRCD EQU   PDWWORK+84
PDWMSGPT EQU   PDWWORK+80
PDWSAVED EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBSPNM EQU   JFCBS001+45
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCRSV41 EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00179 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCRSV24 EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00178 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00177 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
DXRESIND EQU   @NM00175
DXSAVOFF EQU   @NM00174+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00174
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00159 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00158 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00157 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00141 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
PLHBMSV5 EQU   PLHEXTEN+24
PLHBMSV4 EQU   PLHEXTEN+20
PLHBMSV3 EQU   PLHEXTEN+16
PLHBMSV2 EQU   PLHEXTEN+12
PLHBMSV1 EQU   PLHEXTEN+8
PLHRDCNT EQU   PLHEXTEN+6
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00092 EQU   PLHEXTEN+4
PLHRESR1 EQU   PLHEXTEN
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00065 EQU   IOSPCISC+4
@NM00064 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00063 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTRV610 EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTRV608 EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
VGTTCORE EQU   IDAVGTT+32
VGTTOPWA EQU   IDAVGTT+28
VGTTPSB  EQU   IDAVGTT+24
VGTTVUSE EQU   IDAVGTT+20
VGTTBIB  EQU   IDAVGTT+16
VGTTNEXT EQU   IDAVGTT+12
VGTTSIZE EQU   IDAVGTT+8
VGTTSP   EQU   IDAVGTT+7
@NM00186 EQU   IDAVGTT+6
@NM00185 EQU   IDAVGTT+5
@NM00184 EQU   VGTTTYPE
VGTTOPEN EQU   VGTTTYPE
VGTTCTLG EQU   VGTTTYPE
VGTTLSR  EQU   VGTTTYPE
VGTTGSR  EQU   VGTTTYPE
VGTTRSTR EQU   VGTTTYPE
VGTTID   EQU   IDAVGTT
PDPSFI   EQU   IDAPDPRM+36
@NM00183 EQU   IDAPDPRM+35
PDPNOMSG EQU   PDPMSGFL
PDPNOTRC EQU   PDPMSGFL
PDPSPACE EQU   PDPMSGFL
PDPNOTFC EQU   PDPMSGFL
PDPDSTYP EQU   IDAPDPRM+33
PDPKEY   EQU   IDAPDPRM+32
PDPCTACB EQU   IDAPDPRM+28
PDPDSN   EQU   IDAPDPRM+24
PDPCLSNM EQU   IDAPDPRM+20
PDPVLSER EQU   IDAPDPRM+16
PDPTIOT  EQU   IDAPDPRM+12
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPSFC   EQU   IDAPDPRM+3
PDPFUNC  EQU   IDAPDPRM+2
PDPCODE  EQU   IDAPDPRM+1
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00182 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00181 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00180 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00176 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00173 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00172 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00171 EQU   WTGAREA+20
@NM00170 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00169 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00168 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00167 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00166 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00165 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00164 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00163 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00162 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00161 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00160 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
DXATEXB2 EQU   DXATEXC2
DXEXHASP EQU   DXATEXB1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00156 EQU   DXATCOM2+3
@NM00155 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00154 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00153 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
DXPACBAD EQU   DXPDCBAD+1
@NM00152 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00151 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00150 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDEBXAD EQU   FORCORE+552
DXDSAB   EQU   FORCORE+548
DXDSABAD EQU   FORCORE+544
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXUKEY   EQU   FORCORE+526
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00149 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
@NM00148 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00147 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00146 EQU   DXDAADDR
DXECB    EQU   FORCORE+276
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
@NM00145 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBRSV48 EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00144 EQU   TCB+296
TCBSCBQ  EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBRSV36 EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBRSV35 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00143 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBRSV04 EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00142 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00140+8
PRBEND   EQU   @NM00140+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00140+6
RBRSV136 EQU   @NM00140+4
RBRSV135 EQU   @NM00140
@NM00139 EQU   RBSECT+32
@NM00138 EQU   @NM00136+1
@NM00137 EQU   @NM00136
RBPGMQ1  EQU   RBPGMQ+1
@NM00135 EQU   RBPGMQ
@NM00134 EQU   RBSECT+16
@NM00133 EQU   @NM00129
@NM00132 EQU   @NM00129
RBIQETP  EQU   @NM00129
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00129
@NM00131 EQU   @NM00129
@NM00130 EQU   @NM00129
RBRSV007 EQU   @NM00127
RBATNXIT EQU   @NM00127
@NM00128 EQU   @NM00127
RBWAITP  EQU   @NM00127
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00127
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00125 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00124 EQU   RBBASIC+24
XRBPSW   EQU   RBOPSW
@NM00123 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00122 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00121 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00120 EQU   XSTAB1
@NM00119 EQU   RBBASIC+8
@NM00118 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00117 EQU   RBPRFX
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00091 EQU   IDAPLH+265
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHRRN   EQU   PLHKEYPT
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHNOSEG EQU   IDAPLH+240
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00090 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHIBUFC EQU   IDAPLH+188
PLHNRBA  EQU   IDAPLH+184
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00089 EQU   IDAPLH+172
@NM00088 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHRET1  EQU   IDAPLH+120
@NM00087 EQU   IDAPLH+118
PLHRETO  EQU   IDAPLH+116
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHSAVE1 EQU   IDAPLH+84
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHRDFC  EQU   IDAPLH+72
PLHRDFP  EQU   IDAPLH+68
PLHFSP   EQU   IDAPLH+64
PLHRECP  EQU   IDAPLH+60
PLHNBUFC EQU   IDAPLH+56
PLHDBUFC EQU   IDAPLH+52
PLHLRECL EQU   IDAPLH+48
PLHARDB  EQU   IDAPLH+44
@NM00086 EQU   IDAPLH+43
PLHEOVR  EQU   IDAPLH+42
PLHRCODE EQU   IDAPLH+41
PLHJCODE EQU   IDAPLH+40
PLHJNRBA EQU   IDAPLH+36
PLHJRNLL EQU   IDAPLH+32
PLHJORBA EQU   PLHCRBA
PLHDSIDA EQU   IDAPLH+24
PLHCRPL  EQU   IDAPLH+20
PLHMRPL  EQU   IDAPLH+16
PLHBFRNO EQU   IDAPLH+15
PLHFRCNT EQU   IDAPLH+14
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHDBDC  EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
@NM00085 EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00084 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHINVAL EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLHSKPER EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHNOSPC EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHKRE   EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHKEYMD EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
@NM00083 EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHRDEXC EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHENDRQ EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHAVL   EQU   IDAPLH
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRCUR EQU   IDAPLHDR+10
PLHDRMAX EQU   IDAPLHDR+8
PLHDRREQ EQU   IDAPLHDR+4
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
OPWCIXCI EQU   OPWCURCL+5
OPWIOPEN EQU   OPWFLG2
OPWERR2B EQU   OPWFLG2
OPWEMPUP EQU   OPWFLG2
OPWMODWK EQU   OPWFLG2
OPWDOPEN EQU   OPWFLG2
OPWCDTCI EQU   OPWCURCL+1
OPWPRTBL EQU   OPWCFLG1
OPWSVWRK EQU   OPWCFLG1
OPWPATH  EQU   OPWCFLG1
OPWBASE  EQU   OPWCFLG1
OPWUIXCI EQU   OPWUPAIX+5
@NM00082 EQU   OPWUPAIX+4
OPWUDTCI EQU   OPWUPAIX+1
@NM00081 EQU   OPWUPAIX
OPW2YPLH EQU   IDAOPWRK+585
OPWNOUPG EQU   IDAOPWRK+584
OPWPIXCI EQU   OPWPTAIX+5
@NM00080 EQU   OPWPTAIX+4
OPWPDTCI EQU   OPWPTAIX+1
@NM00079 EQU   OPWPTAIX
OPWBIXCI EQU   OPWBSECL+5
@NM00078 EQU   OPWBSECL+4
OPWBDTCI EQU   OPWBSECL+1
@NM00077 EQU   OPWBSECL
OPWSAVEA EQU   IDAOPWRK+564
OPWERMAP EQU   IDAOPWRK+308
OPWSFI   EQU   IDAOPWRK+296
OPWDACB  EQU   IDAOPWRK+244
@NM00076 EQU   IDAOPWRK+243
OPWBSTRN EQU   IDAOPWRK+242
OPWSTRNO EQU   IDAOPWRK+241
OPWCSTRN EQU   IDAOPWRK+240
OPWBUFNI EQU   IDAOPWRK+236
OPWBUFND EQU   IDAOPWRK+232
OPWTIOT  EQU   IDAOPWRK+228
OPWJSTCB EQU   IDAOPWRK+224
OPWCTCB  EQU   IDAOPWRK+220
OPWIXWRK EQU   IDAOPWRK+216
OPWDTWRK EQU   IDAOPWRK+212
OPWWRKPT EQU   IDAOPWRK+208
OPWUACB  EQU   IDAOPWRK+204
OPWUPT   EQU   IDAOPWRK+200
OPWPSDS  EQU   OPWCATTR
@NM00075 EQU   OPWCATTR
@NM00074 EQU   IDAOPWRK+198
OPWCRA   EQU   IDAOPWRK+192
OPWPAMBL EQU   IDAOPWRK+188
OPWBAMBL EQU   IDAOPWRK+184
OPWPCON  EQU   IDAOPWRK+180
OPWBCON  EQU   IDAOPWRK+176
OPWCAMBL EQU   IDAOPWRK+172
OPWXAMBL EQU   IDAOPWRK+168
OPWSSL   EQU   OPWSAVE+16
OPWDSL   EQU   OPWSAVE+12
OPWPSL   EQU   OPWSAVE+8
OPWESL   EQU   OPWSAVE+4
OPWCSL   EQU   OPWSAVE
OPWVFMPT EQU   OPWVFMPL+4
OPWVFMLN EQU   OPWVFMPL+1
OPWVFMSP EQU   OPWVFMPL
@NM00073 EQU   OPWVGMPL+4
OPWVANCS EQU   OPWVGMPL
OPWVREQL EQU   OPWVGSPL+9
OPWVGFLG EQU   OPWVGSPL+8
OPWVGSPT EQU   OPWVGSPL+4
OPWVGETL EQU   OPWVGSPL+1
OPWVGSSP EQU   OPWVGSPL
OPWVSAVE EQU   OPWVSMWA+24
OPWVR13  EQU   OPWVSMWA+20
OPWVHDRE EQU   OPWVSMWA+16
OPWVCSLE EQU   OPWVSMWA+12
OPWVCSLP EQU   OPWVSMWA+8
OPWVTBLP EQU   OPWVSMWA+4
OPWVANCP EQU   OPWVSMWA
@NM00072 EQU   OPWVSMPL+14
OPWVMDIR EQU   OPWVMTCB
OPWVMNSL EQU   OPWVMFLG
OPWVMSRB EQU   OPWVMFLG
OPWVMKE7 EQU   OPWVMFLG
OPWVMKE5 EQU   OPWVMFLG
OPWVMPGB EQU   OPWVMFLG
OPWVMSP  EQU   OPWVSMPL+4
OPWDFR   EQU   OPWQ
OPWESDS  EQU   OPWQ
OPWKSDS  EQU   OPWQ
OPWUBF   EQU   OPWQ
OPWFSTP  EQU   OPWQ
OPWLSR   EQU   OPWQ
OPWGSR   EQU   OPWQ
OPWDDC   EQU   OPWQ
OPWDCI   EQU   OPWIDF+4
OPWCACB  EQU   OPWIDF
OPWBIB   EQU   OPW2MVS2+16
@NM00071 EQU   OPWFLGS4
OPWUPD   EQU   OPWFLGS4
OPWCINV  EQU   OPWFLGS4
OPWFULL  EQU   OPWFLGS4
@NM00070 EQU   OPWFLGS3
OPWRSTRT EQU   OPWFLGS3
OPWNOWRK EQU   OPWFLGS3
OPWUPGOP EQU   OPWFLGS3
OPWPUPGR EQU   OPWFLGS3
OPWDAVAT EQU   OPWFLGS3
@NM00069 EQU   OPWFLGS2
OPWDUMMY EQU   OPWFLGS2
OPWAIXDT EQU   OPWFLGS2
OPWIXDT  EQU   OPWFLGS2
OPWUCRA  EQU   OPWFLGS2
@NM00068 EQU   OPWFLGS1
OPWVVIC  EQU   OPWFLGS1
OPWSCRA  EQU   OPWFLGS1
OPWCAT   EQU   OPWFLGS1
OPWID    EQU   OPW2MVS2+4
OPWLENTH EQU   OPW2MVS2+1
OPWSUBPL EQU   OPW2MVS2
LPMBSST  EQU   IDALPMB+28
LPMBEXT  EQU   IDALPMB+24
@NM00067 EQU   IDALPMB+22
LPMTPC   EQU   IDALPMB+18
LPMTRKAU EQU   IDALPMB+16
LPMBPTRK EQU   IDALPMB+8
LPMAUSZ  EQU   IDALPMB+4
@NM00066 EQU   LPMBFLGS
LPMBSSTH EQU   LPMBFLGS
LPMSS    EQU   LPMBFLGS
LPMREPL  EQU   LPMBFLGS
LPMBRPS  EQU   LPMBFLGS
LPMBID   EQU   IDALPMB
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00062 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00061 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00060
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00059 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSFLC6  EQU   IOSFLC
IOSGLC5  EQU   IOSFLC
IOSFLC4  EQU   IOSFLC
IOSFLC3  EQU   IOSFLC
IOSFLC2  EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSFLB2  EQU   IOSFLB
IOSFLB1  EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSFLA6  EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
IOMUFLD  EQU   IDAIOMB+120
IOMNXT1  EQU   IDAIOMB+116
IOMSAVEF EQU   IOMSAVER+60
IOMSAVEE EQU   IOMSAVER+56
IOMSAVED EQU   IOMSAVER+52
IOMSAVEC EQU   IOMSAVER+48
IOMSAVEB EQU   IOMSAVER+44
IOMSAVEA EQU   IOMSAVER+40
IOMSAVE9 EQU   IOMSAVER+36
IOMSAVE8 EQU   IOMSAVER+32
IOMSAVE7 EQU   IOMSAVER+28
IOMSAVE6 EQU   IOMSAVER+24
IOMSAVE5 EQU   IOMSAVER+20
IOMSAVE4 EQU   IOMSAVER+16
IOMSAVE3 EQU   IOMSAVER+12
IOMSAVE2 EQU   IOMSAVER+8
IOMSAVE1 EQU   IOMSAVER+4
IOMSAVE0 EQU   IOMSAVER
IOMNSEG  EQU   IDAIOMB+50
IOMNBUF  EQU   IDAIOMB+48
IOMNMOD  EQU   IDAIOMB+46
IOMLOCK  EQU   IDAIOMB+45
IOMPFERR EQU   IDAIOMB+44
IOMCKEY  EQU   IDAIOMB+43
@NM00058 EQU   IOMSTIND
IOMSRBM  EQU   IOMSTIND
IOMSLOC  EQU   IOMSTIND
IOMLLOCK EQU   IOMSTIND
IOMEOVXC EQU   IOMSTIND
IOMEOVTS EQU   IOMSTIND
IOMEOVW  EQU   IOMSTIND
IOMAMUSE EQU   IOMSTIND
@NM00057 EQU   IOMFL+1
IOMDDR   EQU   IOMFL+1
IOMCSW   EQU   IOMFL
IOMPGFIX EQU   IOMFL
IOMADERR EQU   IOMFL
IOMCBERR EQU   IOMFL
@NM00056 EQU   IOMFL
IOMPURGE EQU   IOMFL
IOMAE    EQU   IOMAPEND
IOMNE    EQU   IOMAPEND
IOMPGAD  EQU   IDAIOMB+32
IOMVSL   EQU   IDAIOMB+28
IOMECBPT EQU   IDAIOMB+24
IOMIQE   EQU   IDAIOMB+20
IOMAMB   EQU   IDAIOMB+16
IOMPLH   EQU   IDAIOMB+12
IOMBUFC  EQU   IDAIOMB+4
IOMBID   EQU   IDAIOMB
EXLEADDR EQU   EXLEXITP
@NM00055 EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLSPEC  EQU   EXLENFL
EXLOPNP  EQU   EXLCOMN+36
@NM00054 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
EXLJRNP  EQU   EXLCOMN+31
@NM00053 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
EXLLGNP  EQU   EXLCOMN+26
@NM00052 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLSCIPP EQU   EXLCOMN+21
@NM00051 EQU   EXLSCIPF
EXLSCIPK EQU   EXLSCIPF
EXLSCIPA EQU   EXLSCIPF
EXLSCIPS EQU   EXLSCIPF
EXLLERP  EQU   EXLCOMN+16
@NM00050 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
EXLSYNP  EQU   EXLCOMN+11
@NM00049 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
EXLEODP  EQU   EXLCOMN+6
@NM00048 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00047 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
EXLSTYP  EQU   EXLCOMN+1
EXLID    EQU   EXLCOMN
EDBTKBAL EQU   IDAEDB+20
EDBHIRBA EQU   IDAEDB+16
EDBLORBA EQU   IDAEDB+12
EDBSTTRK EQU   IDAEDB+8
EDBLPMBA EQU   IDAEDB+4
EDBM     EQU   IDAEDB+3
@NM00046 EQU   EDBFLG1
EDBPSDS  EQU   EDBFLG1
EDBTOFLW EQU   EDBFLG1
EDBLKR   EQU   EDBFLG1
@NM00045 EQU   IDAEDB
EDBLEN   EQU   IDAEDBHD+2
EDBNO    EQU   IDAEDBHD+1
EDBID    EQU   IDAEDBHD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00044 EQU   CVTFIX+248
@NM00043 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
CPACCWTC EQU   CPACCW+24
CPACCWSI EQU   CPACCW+16
CPACCWSS EQU   CPACCW+8
CPACCWSK EQU   CPACCW
CPACPCHN EQU   IDACPA+92
CPATKOFL EQU   CPAFLAG2
CPAPFENT EQU   CPAFLAG2
CPAXLRA  EQU   CPAFLAG2
CPARREPL EQU   CPAFLAG2
CPAWREPL EQU   CPAFLAG2
@NM00042 EQU   CPAFLAG1
CPACHNED EQU   CPAFLAG1
CPARRPS  EQU   CPAFLAG1
CPAWRPS  EQU   CPAFLAG1
CPARV    EQU   CPAFLAG1
CPAWCV   EQU   CPAFLAG1
CPAWV    EQU   CPAFLAG1
CPASSECT EQU   IDACPA+82
CPAWORK2 EQU   IDACPA+72
CPAWORK1 EQU   IDACPA+68
@NM00041 EQU   CPARPHAD+7
CPARBB   EQU   CPARSEEK
@NM00040 EQU   CPARPHAD
CPAWPHR  EQU   CPAWPHAD+7
CPAWCHR  EQU   CPAWSEEK+2
CPAWBB   EQU   CPAWSEEK
@NM00039 EQU   CPAWPHAD
@NM00038 EQU   IDACPA+1
CMBPUSPT EQU   CMBPTRS+44
CMBPSTPT EQU   CMBPTRS+40
CMBEDBPT EQU   CMBPTRS+36
CMBDEBPT EQU   CMBPTRS+32
CMBUBFPT EQU   CMBPTRS+28
CMBBFRPT EQU   CMBPTRS+24
CMBUFSPT EQU   CMBPTRS+20
CMBFSTPT EQU   CMBPTRS+16
CMBUSPTR EQU   CMBPTRS+12
CMBSTPTR EQU   CMBPTRS+8
CMBPRPTR EQU   CMBPTRS+4
CMBUSRPT EQU   CMBPTRS
CMBCNT   EQU   IDACMB+6
CMBNST   EQU   IDACMB+5
CMBOUT   EQU   CMBFLGS
CMBLEN   EQU   IDACMB+2
@NM00037 EQU   IDACMB+1
CMBID    EQU   IDACMB
BUFCEND  EQU   IDABUFC+64
BUFCUCDN EQU   IDABUFC+60
BUFCUCUP EQU   IDABUFC+56
BUFCMDBT EQU   IDABUFC+52
BUFXORBA EQU   IDABUFC+44
BUFXIRBA EQU   IDABUFC+40
BUFCNXT2 EQU   IDABUFC+37
BUFCIDXL EQU   IDABUFC+36
BUFCDSPC EQU   IDABUFC+32
BUFCWLEN EQU   BUFCINV
BUFCNXT1 EQU   IDABUFC+24
BUFCORBA EQU   IDABUFC+12
BUFCDDDD EQU   IDABUFC+8
BUFCAMB  EQU   BUFCPLH
@NM00036 EQU   BUFCFLG2
BUFCBSYW EQU   BUFCFLG2
BUFCBSYR EQU   BUFCFLG2
BUFCNLAS EQU   BUFCFLG2
BUFCXDDR EQU   BUFCFLG2
BUFCFIX  EQU   BUFCIOFL
BUFCXEDB EQU   BUFCIOFL
BUFCREAL EQU   BUFCIOFL
BUFCRRD  EQU   BUFCIOFL
BUFCMW   EQU   BUFCIOFL
BUFCEPT  EQU   BUFCFLG1
BUFCEXC  EQU   BUFCFLG1
BUFCVAL  EQU   BUFCFLG1
BUFCER2  EQU   BUFCFLG1
BUFCER1  EQU   BUFCFLG1
BUFCSEG  EQU   BUFCFLG1
BUFCUPG  EQU   BUFCFLG1
BUFCUCNT EQU   BUFCAVL
@NM00035 EQU   IDABUFDR+16
BUFDBUFC EQU   IDABUFDR+12
@NM00034 EQU   BUFDRFLG
BUFDRAVL EQU   BUFDRFLG
BUFDRREL EQU   BUFDRFLG
BUFDRTSB EQU   IDABUFDR+10
BUFDRMAX EQU   BUFDRCIX
BUFDRPFN EQU   IDABUFDR+8
BUFDRPFB EQU   IDABUFDR+4
BUFDRLEN EQU   IDABUFDR+2
BUFDRNO  EQU   IDABUFDR+1
BUFDRID  EQU   IDABUFDR
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00033 EQU   IDAAMDSB+41
@NM00032 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDKEYLN EQU   IDAAMDSB+8
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLBIB  EQU   IDAAMBL+60
AMBLIX   EQU   IDAAMBL+56
AMBLDTA  EQU   IDAAMBL+52
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00031 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00030 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00029 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00028 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00027 EQU   IDAAMBL+31
@NM00026 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00025 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00024 EQU   AMBCSWD1+1
@NM00023 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00022 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
AMBIOBA  EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00021 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00020 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00019 EQU   AMBINFL
@NM00018 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00017 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00016 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00015 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00014 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00013 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00012 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00011 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00010 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00009 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00008 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00007 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00006 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00005 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00004 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
@NM00003 EQU   CCW+5
CCWPCI   EQU   CCWFLGS
@NM00002 EQU   PD+3
PPSFC    EQU   PD+2
SAREG    EQU   SAREGS+12
SARTRN   EQU   SAREGS
SAFWRD   EQU   SAVAREA+8
@NM00001 EQU   SAVAREA
@NM00116 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00115 EQU   PSA+1040
PSAUSEND EQU   PSA+1040
PSARV062 EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00114 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00113 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00112 EQU   FLCFSA
@NM00111 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00110 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00109 EQU   FLCIOA
@NM00108 EQU   FLCMCLA+15
@NM00107 EQU   FLCMCLA+14
@NM00106 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00105 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00104 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00103 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00102 EQU   FLCPER
@NM00101 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00100 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00099 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00098 EQU   FLCPIILC
@NM00097 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00096 EQU   FLCSVILC
@NM00095 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00094 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00093 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00287 EQU   @RC00286
@RC00324 EQU   @RC00322
@RF00395 EQU   @EL00004
@RC00393 EQU   @EL00004
@RF00523 EQU   @RC00521
@RC00541 EQU   @EL00008
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0192W,(C'PLS2228',0602,75057)
