         TITLE 'IDA0192Z - VS2 VSAM CONTROL BLOCK BUILD                *
                        '
IDA0192Z CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192Z  78.199'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  LA    @12,4095(,@03)                                      0001
         USING @PSTART,@03                                         0001
         USING @PSTART+4095,@12                                    0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0224
*   /*****************************************************************/
*   /*                                                               */
*   /* IDA0192Z - INITIALIZATION                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0224
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0224
         MVC   RSTATRTN(4,@05),@CC05338                            0224
*/********************************************************************/
*/*           IDAGMAIN - GETS CORE STORAGE FOR AUTOMATICS.           */
*/*                      FOR VS2 IDAGMAIN WILL MOVE THE      @Z30SSRL*/
*/*                      ID AND DATE OF THE MODULE TO A      @Z30SSRL*/
*/*                      LOCATION DIRECTLY AFTER THE PLS     @Z30SSRL*/
*/*                      GENERATED SAVE AREA.                @Z30SSRL*/
*/*           DATE OF LAST CHANGE = 3 DECEMBER 74            @Z30SSRL*/
*/********************************************************************/
*                                                                  0225
*   GEN;                                                           0225
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL ZERO
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  ZERO THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR ZERO
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        ZERO IF THE GETMAIN WAS UNSUCCESSFUL.
*   RESPECIFY                                                      0226
*    (R15,                                                         0226
*     R13) RSTD;                    /*                       @X04SVCJ*/
*   PD=ZERO;                        /* ZERO RETURN CODE      @X04SVCJ*/
         SLR   @14,@14                                             0227
         ST    @14,PD(,R13)                                        0227
*   IF R15=ZERO THEN                /* IF NO CORE AVAILABLE  @X04SVCJ*/
         CR    R15,@14                                             0228
         BNE   @RF00228                                            0228
*     DO;                           /* ERROR                 @X04SVCJ*/
*       OPWMODWK=OFF;               /* NO MODULE WORK AREA   @Z30SSDT*/
         L     @14,OPWCURPT(,RCORE)                                0230
         NI    OPWMODWK(@14),B'10111111'                           0230
*       PPCODE=PP20;                /* SET PROBLEM CODE      @X04SVCJ*/
         MVI   PPCODE(R13),X'14'                                   0231
*       PPFUNC=PDF50;               /* SET FUNCTION CODE     @X04SVCJ*/
         MVI   PPFUNC(R13),X'32'                                   0232
*     END;                          /*                       @X04SVCJ*/
*   ELSE                            /* NO ERROR              @X04SVCJ*/
*     DO;                           /* MAINLINE              @X04SVCJ*/
         B     @RC00228                                            0234
@RF00228 DS    0H                                                  0235
*       PPFUNC=PDF53;               /* SET FUNCTION CODE     @Z30SSDT*/
         MVI   PPFUNC(R13),X'35'                                   0235
*       R15->SABWRD=R13;            /* SAVE SAVE AREA ADDR   @Z30SSDT*/
         ST    R13,SABWRD(,R15)                                    0236
*       R13=R15;                    /* LOAD PTR TO AUTOMATICS      0237
*                                                            @Z30SSDT*/
         LR    R13,R15                                             0237
*       GEN(USING @DATD,R13);       /* GET BASE FOR AUTOMATICS       */
         USING @DATD,R13
*       RETCONT=ZERO;               /* INIT ARRAY CONTROL    @Z30SSDT*/
         SLR   @14,@14                                             0239
         ST    @14,RETCONT                                         0239
*       RESPECIFY                                                  0240
*         R15 UNRESTRICTED;         /*                       @Z30SSDT*/
*       IF CVTSMCA^=ZERO&           /* IF SMCA EXIST AND     @OZ04709*/
*           SMCADSA=ON&             /* DATA SET INFORMATION REQUIRED
*                                      AND                   @OZ04709*/
*           SMCAUSER=ON&SMCAMAN=ON& /* SMF RECORDING AND     @OZ04709*/
*           TCBTCT^=ZERO THEN       /* THE TCT EXIST         @OZ04709*/
         L     @05,FLCCVT                                          0241
         L     @05,CVTSMCA(,@05)                                   0241
         CR    @05,@14                                             0241
         BE    @RF00241                                            0241
         TM    SMCADSA(@05),B'00010000'                            0241
         BNO   @RF00241                                            0241
         TM    SMCAUSER(@05),B'11000000'                           0241
         BNO   @RF00241                                            0241
         L     @05,PSATOLD                                         0241
         C     @14,TCBTCT(,@05)                                    0241
         BE    @RF00241                                            0241
*         SMFACTV=ON;               /* INDICATE SMF ACTIVE   @OZ04709*/
         OI    SMFACTV,B'00001000'                                 0242
*       DO C1=AMBLNUM TO 1 BY-1;    /* LOOP THRU AMB LIST            */
*                                                                  0243
@RF00241 L     @05,ACBAMBL(,RACB)                                  0243
         LH    @05,AMBLNUM(,@05)                                   0243
         ST    @05,C1                                              0243
         B     @DE00243                                            0243
@DL00243 DS    0H                                                  0244
*         /***********************************************************/
*         /*                                                         */
*         /* BUILD BLOCKS PER AMB                                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0244
*         IF C1=AMBLNUM THEN        /* IF DATA PASS          @X04SVCJ*/
         L     @01,ACBAMBL(,RACB)                                  0244
         CH    @05,AMBLNUM(,@01)                                   0244
         BNE   @RF00244                                            0244
*           OPWWRKPT=OPWDTWRK;      /* INIT AMB WORK POINTER @X04SVCJ*/
         L     @05,OPWDTWRK(,RCORE)                                0245
         ST    @05,OPWWRKPT(,RCORE)                                0245
*         ELSE                      /* INDEX PASS            @X04SVCJ*/
*           OPWWRKPT=OPWIXWRK;      /* INIT AMB WORK POINTER @X04SVCJ*/
         B     @RC00244                                            0246
@RF00244 L     @05,OPWIXWRK(,RCORE)                                0246
         ST    @05,OPWWRKPT(,RCORE)                                0246
*         IF OPWRSTRT=ON THEN       /* IF A RESTART          @Z30SSDT*/
@RC00244 TM    OPWRSTRT(RCORE),B'00001000'                         0247
         BNO   @RF00247                                            0247
*           CALL RESTINIT;          /* SETUP FOR RESTART     @Z30SSDT*/
         BAL   @14,RESTINIT                                        0248
*         ELSE                      /* IF NOT A RESTART      @Z30SSDT*/
*           DO;                     /* NORMAL OPEN PATH      @Z30SSDT*/
         B     @RC00247                                            0249
@RF00247 DS    0H                                                  0250
*             CALL BLDAMB;          /* BUILD AN AMB          @Z30SSDT*/
         BAL   @14,BLDAMB                                          0250
*             CALL BLDRMEXT;        /* BUILD RECORD MGT EXT  @Z30SSDT*/
         BAL   @14,BLDRMEXT                                        0251
*             CALL BLDAMDSB;        /* BUILD AN AMDSB        @Z30SSDT*/
         BAL   @14,BLDAMDSB                                        0252
*             CALL BLDIWA;          /* BUILD INSERT WORK AREA        */
         BAL   @14,BLDIWA                                          0253
*             CALL BLDARDB;         /* BUILD ARDB            @Z30SSDT*/
         BAL   @14,BLDARDB                                         0254
*             CALL BLDLPMB;         /* BUILD LPMB            @Z30SSDT*/
         BAL   @14,BLDLPMB                                         0255
*           END;                    /*                       @Z30SSDT*/
*         CALL BLDEDB;              /* BUILD EDB             @Z30SSDT*/
@RC00247 BAL   @14,BLDEDB                                          0257
*         CALL BLDRDEB;             /* BUILD THE REAL DEB            */
         BAL   @14,BLDRDEB                                         0258
*         IF OPWLSR=OFF&OPWGSR=OFF THEN/* NOT SHRD RESOURCES @Z30SSDT*/
         TM    OPWLSR(RCORE),B'01100000'                           0259
         BNZ   @RF00259                                            0259
*           CALL BLDSTRBK;          /* BUILD STRING BLOCKS   @X04SVCJ*/
         BAL   @14,BLDSTRBK                                        0260
*         ELSE                      /* SHARED RESOURCES      @Z30SSDT*/
*           IF OPWRSTRT=OFF THEN    /* IF NOT A RESTART      @Z30SSDT*/
         B     @RC00259                                            0261
@RF00259 TM    OPWRSTRT(RCORE),B'00001000'                         0261
         BNZ   @RF00261                                            0261
*             CALL CHNBLKS;         /* CHAIN CONTROL BLOCKS  @Z30SSDT*/
         BAL   @14,CHNBLKS                                         0262
*       END;                                                       0263
*                                                                  0263
@RF00261 DS    0H                                                  0263
@RC00259 SLR   @05,@05                                             0263
         BCTR  @05,0                                               0263
         AL    @05,C1                                              0263
         ST    @05,C1                                              0263
@DE00243 LTR   @05,@05                                             0263
         BP    @DL00243                                            0263
*       /*************************************************************/
*       /*                                                           */
*       /* IDA0192Z - FINAL PROCESSING                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0264
*       RESPECIFY                                                  0264
*         RDEB RESTRICTED;                                         0264
*       IF AMBLCAT=OFF THEN         /* CAT, SCRA OR VVIC     @Z30SSDT*/
         L     @10,ACBAMBL(,RACB)                                  0265
         TM    AMBLCAT(@10),B'00000010'                            0265
         BNZ   @RF00265                                            0265
*         DO C1=AMBLNUM TO 1 BY-1;  /* LOOP THRU AMB LIST            */
         LH    @10,AMBLNUM(,@10)                                   0266
         ST    @10,C1                                              0266
         B     @DE00266                                            0266
@DL00266 DS    0H                                                  0267
*           AMBP=(ACBAMBL+(C1-K1)*LENGTH(AMBLDTA))->AMBLDTA;/* GET 0267
*                                      AMB                           */
         BCTR  @10,0                                               0267
         SLA   @10,2                                               0267
         AL    @10,ACBAMBL(,RACB)                                  0267
         L     @10,AMBLDTA(,@10)                                   0267
         ST    @10,AMBP                                            0267
*           RDEB=AMBDEBAD;          /* LOAD PTR TO DEB               */
         L     RDEB,AMBDEBAD-1(,@10)                               0268
         LA    RDEB,0(,RDEB)                                       0268
*           CALL HOOKDEB;           /* CHAIN THE DEB                 */
         BAL   @14,HOOKDEB                                         0269
*         END;                                                     0270
         SLR   @10,@10                                             0270
         BCTR  @10,0                                               0270
         AL    @10,C1                                              0270
         ST    @10,C1                                              0270
@DE00266 LTR   @10,@10                                             0270
         BP    @DL00266                                            0270
*       RESPECIFY                                                  0271
*         RDEB UNRESTRICTED;                                       0271
@RF00265 DS    0H                                                  0272
*                                                                  0272
*       /*************************************************************/
*       /*                                                           */
*       /* EXIT FROM IDA0192Z                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0272
*EXIT:                                                             0272
*       RESPECIFY                                                  0272
*        (R0,                                                      0272
*         R1) RSTD;                 /*                       @Z30SSDT*/
EXIT     DS    0H                                                  0273
*       GEN(L R0,@SIZDATD);         /* LOAD BLOCK SIZE       @Z30SSDT*/
         L R0,@SIZDATD
*       R1=R13;                     /* SET ADDRESS           @Z30SSDT*/
         LR    R1,R13                                              0274
*       R13=SABWRD;                 /* POINT TO LAST SAVE AREA     0275
*                                                            @Z30SSDT*/
         L     R13,SABWRD(,R13)                                    0275
*       IF PPCODE=K0 THEN           /* ERRORS                @Z30SSRL*/
         CLI   PPCODE(R13),0                                       0276
         BNE   @RF00276                                            0276
*         PPFUNC=K0;                /* NO, ZERO RETURN CODE  @Z30SSRL*/
         MVI   PPFUNC(R13),X'00'                                   0277
*       GEN(FREEMAIN R,LV=(0),A=(1));/*                      @X04SVCJ*/
@RF00276 DS    0H                                                  0278
         FREEMAIN R,LV=(0),A=(1)
*       RESPECIFY                                                  0279
*        (R0,                                                      0279
*         R1) UNRESTRICTED;         /*                       @Z30SSDT*/
*     END;                          /*                       @X04SVCJ*/
*   LM(RET,R12,SAREGS);             /* RESTORE REGISTERS 14-12     0281
*                                                            @Z30SSDT*/
@RC00228 LM    RET,R12,SAREGS(R13)                                 0281
*   GEN(BR RET);                    /* RETURN TO CALLER              */
         BR RET
*   RESPECIFY                                                      0283
*     SAVAREA BASED(R13->SABWRD);   /* ADDRESSIBILITY FOR PD @Z30SSDT*/
*BLDAMB:                                                           0284
*                                                                  0284
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS AN AMB                         */
*/*   INPUT -     1. CATALOG WORKAREA FOR COMPONENT DATA SET         */
*/*               2. ACB                                             */
*/*               3. AMBL                                            */
*/*   OUTPUT -    1. AMB IS BUILT IN PROTECT BLOCK           @Z30SSDT*/
*/*               2. FIELDS ARE INITIALIZED TO REFLECT               */
*/*                  CURRENT PROCESSING                              */
*/*               3. AMBP IS LOADED WITH AMB ADDRESS         @X04SVCJ*/
*/*               4. AMBAD IS SET TO AMB ADDRESS IN AUTOMATICS       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0284
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0284
BLDAMB   DS    0H                                                  0285
*   RESPECIFY                                                      0285
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RFY                                                            0286
*     IDAAMDSB BASED(ADDR(CTAMDSB));/* NOT IN AMB YET        @ZA18252*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0287
         AL    @15,RETCONT                                         0287
         ST    @15,RETCONT                                         0287
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0288
         ST    RET,RETSAVE-4(@15)                                  0288
*   RESPECIFY                                                      0289
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   OPWVMLNG=LENGTH(IDAAMB);        /* INIT FOR GET CORE REQUEST   0290
*                                                            @Z30SSDT*/
         MVC   OPWVMLNG(3,RCORE),@CF02849+1                        0290
*   OPWVMTYP=PROTBLK;               /* INDICATE PROTECT BLOCK      0291
*                                                            @Z30SSDT*/
         MVI   OPWVMTYP(RCORE),X'02'                               0291
*   OPWVMANC=ADDR(IDACMB);          /* SET ADDRESS OF ANCHOR BLOCK 0292
*                                                            @X04SVCJ*/
         L     @05,ACBAMBL(,RACB)                                  0292
         L     @05,AMBLCMB(,@05)                                   0292
         ST    @05,OPWVMANC(,RCORE)                                0292
*   OPWVMFLG=ZERO;                  /* RESET FLAG FIELD      @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0293
*   CALL IDA0192M;                  /* GET CORE FOR AMB      @Z30SSDT*/
         L     @15,@CV05525                                        0294
         BALR  @14,@15                                             0294
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0295
         MVC   RSTATRTN(4,@05),@CC05338                            0295
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @05,OPWVMADR(,RCORE)                                0296
         LTR   @05,@05                                             0296
         BNZ   @RF00296                                            0296
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* SET ERROR CODE        @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0298
         MVI   PPCODE(@05),X'14'                                   0298
*       RETURN TO EXIT;             /* TERMINATE             @Z30SSDT*/
         LA    @14,EXIT                                            0299
@EL00002 DS    0H                                                  0299
@EF00002 DS    0H                                                  0299
@ER00002 BR    @14                                                 0299
*     END;                          /*                       @X04SVCJ*/
*   AMBAD=OPWVMADR;                 /* SAVE AMB ADDRESS      @X04SVCJ*/
@RF00296 L     @05,OPWVMADR(,RCORE)                                0301
         ST    @05,AMBAD                                           0301
*   AMBP=AMBAD;                     /* LOAD AMB POINTER      @X04SVCJ*/
         ST    @05,AMBP                                            0302
*   AMBDORGA=ON;                    /* DSORG INDICATES AM/0          */
         OI    AMBDORGA(@05),B'00001000'                           0303
*   AMBEXFG=AMBEXOFF;               /* SET LOCK BIT OFF              */
         OI    AMBEXFG(@05),B'00000010'                            0304
*   AMBCDSN=CTHSHCAT;               /* INIT CATALOG NAME, HASHED     */
         L     @15,OPWWRKPT(,RCORE)                                0305
         L     @14,CTHSHCAT(,@15)                                  0305
         STCM  @14,7,AMBCDSN(@05)                                  0305
*   AMBCACB=CTHSHCAT;               /* SAVE CATL ACB PTR             */
         ST    @14,AMBCACB(,@05)                                   0306
*   AMBDDSN=CTHSHDSN;               /* INIT AMD DATA SET NAME        */
         MVC   AMBDDSN(3,@05),CTHSHDSN(@15)                        0307
*   IF CTEXEX^=NOEXEXIT THEN        /* EXCEPTION EXIT EXIST  @Z30SSDT*/
         CLC   CTEXEX(8,@15),NOEXEXIT                              0308
         BE    @RF00308                                            0308
*     AMBEXEX=CTEXEX;               /* INITIALIZE EXIT NAME  @Z30SSDT*/
         MVC   AMBEXEX(8,@05),CTEXEX(@15)                          0309
*   IF AMBLCAT=OFF THEN             /* IF NOT SYSTEM DS      @Z30SSDT*/
@RF00308 L     @05,ACBAMBL(,RACB)                                  0310
         TM    AMBLCAT(@05),B'00000010'                            0310
         BNZ   @RF00310                                            0310
*     CALL TIOTSRCH;                /* THEN DETERMINE OFFSET OF TIOT
*                                      ENTRY                 @X04SVRP*/
         BAL   @14,TIOTSRCH                                        0311
*   ELSE                            /* ELSE SYSTEM DATA SET  @X04SVRP*/
*     AMBTIOT=ACBTIOT;              /* INIT TIOT OFFSET      @X04SVRP*/
         B     @RC00310                                            0312
@RF00310 LH    @05,ACBTIOT(,RACB)                                  0312
         L     @01,AMBP                                            0312
         STH   @05,AMBTIOT(,@01)                                   0312
*   AMBID=IDXAMB;                   /* INIT AMB ID                   */
@RC00310 L     @05,AMBP                                            0313
         MVI   AMBID(@05),B'01000000'                              0313
*   AMBLEN=LENGTH(IDAAMB);          /* INIT AMB LENGTH               */
         MVC   AMBLEN(2,@05),@CH02849                              0314
*   IF ACBCAT=ON THEN               /* IF CATALOG INDICATED  @Z30SSRL*/
         TM    ACBCAT(RACB),B'00010000'                            0315
         BNO   @RF00315                                            0315
*     AMBCAT=ON;                    /* SET CATALOG BIT ON    @Z30SSRL*/
         OI    AMBCAT(@05),B'00010000'                             0316
*   IF ACBSCRA=ON THEN              /* IF SCRA INDICATED     @Z30SSRL*/
@RF00315 TM    ACBSCRA(RACB),B'00001000'                           0317
         BNO   @RF00317                                            0317
*     AMBSCRA=ON;                   /* SET SCRA BIT ON       @Z30SSRL*/
         L     @05,AMBP                                            0318
         OI    AMBSCRA(@05),B'00001000'                            0318
*   IF ACBUCRA=ON THEN              /* IF UCRA INDICATED     @Z30SSRL*/
@RF00317 TM    ACBUCRA(RACB),B'00000100'                           0319
         BNO   @RF00319                                            0319
*     AMBUCRA=ON;                   /* SET UCRA BIT ON       @Z30SSRL*/
         L     @05,AMBP                                            0320
         OI    AMBUCRA(@05),B'00000100'                            0320
*   IF ACBSDS=ON THEN               /* IF SYSTEM DATA SET    @Z40WSRL*/
@RF00319 TM    ACBSDS(RACB),B'00000010'                            0321
         BNO   @RF00321                                            0321
*     AMBSDS=ON;                    /* INDICATE IN AMB       @Z40WSRL*/
         L     @05,AMBP                                            0322
         OI    AMBSDS(@05),B'00000001'                             0322
*   AMBAMETH=ACBAMETH;              /* COPY AMETH FIELD FROM ACB     */
@RF00321 L     @05,AMBP                                            0323
         IC    @15,ACBAMETH(,RACB)                                 0323
         STC   @15,AMBAMETH(,@05)                                  0323
*   AMBBUSY=ON;                     /* SET IOS FLAG ON               */
         OI    AMBBUSY(@05),B'00000001'                            0324
*   AMBWKA=OPWWRKPT;                /* INIT PTR TO OPW       @X04SVRP*/
         L     @15,OPWWRKPT(,RCORE)                                0325
         ST    @15,AMBWKA(,@05)                                    0325
*   IF OPWFSTP=ON THEN              /* IF ICI SPECIFIED      @Z30SSDT*/
         TM    OPWFSTP(RCORE),B'00010000'                          0326
         BNO   @RF00326                                            0326
*     AMBICI=ON;                    /* SET ICI INDICATOR ON  @Z30SSDT*/
         OI    AMBICI(@05),B'00010000'                             0327
*   IF AMBLNUM=C1 THEN              /* IS AMB FOR DATA -             */
@RF00326 L     @05,ACBAMBL(,RACB)                                  0328
         LH    @15,AMBLNUM(,@05)                                   0328
         C     @15,C1                                              0328
         BNE   @RF00328                                            0328
*     DO;                           /*                       @Z30SSDT*/
*       AMBTYPE=AMBDATA;            /* YES, INDICATE SUCH            */
         L     @15,AMBP                                            0330
         NI    AMBTYPE(@15),B'10111111'                            0330
*       IF JFCTRACE=ON&AMBLUPGR=OFF THEN/* IF AMP=TRACE AND NOT    0331
*                                      UPGRADE THEN          @ZA29388*/
         L     @01,OPWCOMWA(,RCORE)                                0331
         TM    JFCTRACE+100(@01),B'00000100'                       0331
         BNO   @RF00331                                            0331
         TM    AMBLUPGR(@05),B'01000000'                           0331
         BNZ   @RF00331                                            0331
*         DO;                       /*                       @ZA29388*/
*           IF AMBLPATH=ON&AMBLXPT^=ZERO THEN/* IF PATH AMBL AND BASE
*                                      OPEN THEN             @ZA29388*/
         TM    AMBLPATH(@05),B'10000000'                           0333
         BNO   @RF00333                                            0333
         L     @05,AMBLXPT(,@05)                                   0333
         LTR   @05,@05                                             0333
         BZ    @RF00333                                            0333
*             AMBTRACE=AMBLXPT->AMBLACB->ACBAMBL->AMBLDTA->AMBTRACE;
*                                                                  0334
         L     @05,AMBLACB(,@05)                                   0334
         L     @05,ACBAMBL(,@05)                                   0334
         L     @05,AMBLDTA(,@05)                                   0334
         L     @05,AMBTRACE(,@05)                                  0334
         ST    @05,AMBTRACE(,@15)                                  0334
*           /*********************************************************/
*           /*                                                       */
*           /* USE BASE AMBTRACE ADDR                        @ZA29388*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0335
*           ELSE                    /*                       @ZA29388*/
*             DO;                   /*                       @ZA29388*/
         B     @RC00333                                            0335
@RF00333 DS    0H                                                  0336
*               OPWVMLNG=LENGTH(IDATRACE);/* GET LEN OF W/A  @ZA29388*/
         MVC   OPWVMLNG(3,RCORE),@CF05646+1                        0336
*               OPWVMTYP=USERBLK;   /* GET USER CORE         @ZA29388*/
         MVI   OPWVMTYP(RCORE),X'01'                               0337
*               CALL IDA0192M;      /* GET WORKAREA          @ZA29388*/
         L     @15,@CV05525                                        0338
         BALR  @14,@15                                             0338
*               RSTATRTN=IDAR192Z;  /* NOTE 192Z IN CONTROL  @ZA29388*/
         L     @05,OPWCOMWA(,RCORE)                                0339
         MVC   RSTATRTN(4,@05),@CC05338                            0339
*               IF OPWVMADR=ZERO THEN/* WAS STORAGE OBTAINED @ZA29388*/
         L     @05,OPWVMADR(,RCORE)                                0340
         LTR   @05,@05                                             0340
         BNZ   @RF00340                                            0340
*                 DO;               /* ERROR                 @ZA29388*/
*                   PPCODE=PP20;    /* SET ERROR CODE        @ZA29388*/
         L     @05,SABWRD(,R13)                                    0342
         MVI   PPCODE(@05),X'14'                                   0342
*                   RETURN TO EXIT; /* NO, TERMINATE         @ZA29388*/
         LA    @14,EXIT                                            0343
         BR    @14                                                 0343
*                 END;              /*                       @ZA29388*/
*               AMBTRACE=OPWVMADR;  /* SAVE WORKAREA IN AMB  @ZA29388*/
@RF00340 L     @05,OPWVMADR(,RCORE)                                0345
         L     @01,AMBP                                            0345
         ST    @05,AMBTRACE(,@01)                                  0345
*               R1=CVTSVDCB;        /* LOAD TRACE MODULE     @ZA29388*/
         L     @05,FLCCVT                                          0346
         L     R1,CVTSVDCB(,@05)                                   0346
*               GEN(LOAD EP=IDA019ST,DCB=((1)));/*           @ZA29388*/
         LOAD EP=IDA019ST,DCB=((1))
*               AMBTRACE->TRAENTRY=R0;/* SAVE ENTRY PT ADDR IN FIRST
*                                      WORD OF WORKAREA      @ZA29388*/
         L     @05,AMBP                                            0348
         L     @01,AMBTRACE(,@05)                                  0348
         ST    R0,TRAENTRY(,@01)                                   0348
*               R1=CVTSVDCB;        /* DELETE TRACE MODULE   @ZA29388*/
         L     @05,FLCCVT                                          0349
         L     R1,CVTSVDCB(,@05)                                   0349
*               GEN(DELETE EP=IDA019ST);/*                   @ZA29388*/
         DELETE EP=IDA019ST
*             END;                  /*                       @ZA29388*/
*         END;                      /* END TRACE CODE        @ZA29388*/
@RC00333 DS    0H                                                  0353
*       IF OPWPSDS=ON THEN          /* IF FOR PAGE SPACE     @Z30SSRL*/
@RF00331 TM    OPWPSDS(RCORE),B'00000001'                          0353
         BNO   @RF00353                                            0353
*         AMBPSDS=ON;               /* INDICATE THAT ALSO    @Z30SSDT*/
         L     @05,AMBP                                            0354
         OI    AMBPSDS(@05),B'10000000'                            0354
*       IF OPWSWSP=ON THEN          /* IF FOR SWAP SPACE     @Z40WSRL*/
@RF00353 TM    OPWSWSP(RCORE),B'00000010'                          0355
         BNO   @RF00355                                            0355
*         AMBSWSP=ON;               /* INDICATE SWAP SPACE   @Z40WSRL*/
         L     @05,AMBP                                            0356
         OI    AMBSWSP(@05),B'01000000'                            0356
*     END;                          /*                       @Z30SSDT*/
*   ELSE                            /* IF AMB NOT FOR DATA   @Z30SSRL*/
*     DO;                                                          0358
         B     @RC00328                                            0358
@RF00328 DS    0H                                                  0359
*       AMBTYPE=AMBINDEX;           /* NO, INDICATE AMB FOR INDEX    */
         L     @05,AMBP                                            0359
         OI    AMBTYPE(@05),B'01000000'                            0359
*       AMBLDTA->AMBLINK=ADDR(IDAAMB);/* DATA AMB PTS TO INDX AMB    */
         L     @01,ACBAMBL(,RACB)                                  0360
         L     @15,AMBLDTA(,@01)                                   0360
         ST    @05,AMBLINK(,@15)                                   0360
*       AMBLDTA->AMBPIXP=ADDR(IDAAMB);/* DATA AMB PTS TO INDX AMB    */
         ST    @05,AMBPIXP(,@15)                                   0361
*       AMBPH=AMBLDTA->AMBPH;       /* COPY PLH POINTER      @X04SVCJ*/
         L     @14,AMBPH(,@15)                                     0362
         ST    @14,AMBPH(,@05)                                     0362
*       AMBIOMB=AMBLDTA->AMBIOMB;   /* COPY IOMB POINTER     @Z30SSDT*/
         L     @14,AMBIOMB(,@15)                                   0363
         ST    @14,AMBIOMB(,@05)                                   0363
*       AMBUPLH=AMBLDTA->AMBUPLH;   /* COPY UPG PLH POINTER  @Z30SSDT*/
         L     @14,AMBUPLH(,@15)                                   0364
         ST    @14,AMBUPLH(,@05)                                   0364
*       AMBTRACE=AMBLDTA->AMBTRACE; /* COPY TRACE WORKAREA   @ZA29388*/
         L     @15,AMBTRACE(,@15)                                  0365
         ST    @15,AMBTRACE(,@05)                                  0365
*     END;                                                         0366
*   IF CTHURBA=K0|                  /* IS DATA SET EMPTY OR  @ZA14781*/
*       (AMDNLR=K0&                 /* LOGICAL RECORD NUMBER = 0 AND
*                                                            @ZA14781*/
*       AMDDELR=K0&                 /* NUMBER OF DELETED RECORDS=0 0367
*                                      AND                   @ZA14781*/
*       AMDRANGE=ON&                /* NOT A KEYRANGE DATA SET     0367
*                                                            @ZA14799*/
*       ACBCAT=OFF&ACBSCRA=OFF&ACBUCRA=OFF) THEN/* NOT SYSTEM DS     */
@RC00328 SLR   @05,@05                                             0367
         L     @15,OPWWRKPT(,RCORE)                                0367
         CL    @05,CTHURBA(,@15)                                   0367
         BE    @RT00367                                            0367
         AL    @15,@CF02632                                        0367
         C     @05,AMDNLR(,@15)                                    0367
         BNE   @RF00367                                            0367
         C     @05,AMDDELR(,@15)                                   0367
         BNE   @RF00367                                            0367
         TM    AMDRANGE(@15),B'00000100'                           0367
         BNO   @RF00367                                            0367
         TM    ACBCAT(RACB),B'00011100'                            0367
         BNZ   @RF00367                                            0367
@RT00367 DS    0H                                                  0368
*     DO;                                                          0368
*       IF ACBOUT=ON|ACBRST=ON THEN /* IF USER SPECIFIED OUTPUT      */
         TM    ACBOUT(RACB),B'00000010'                            0369
         BO    @RT00369                                            0369
         TM    ACBRST(RACB),B'00000100'                            0369
         BNO   @RF00369                                            0369
@RT00369 DS    0H                                                  0370
*         DO;                                                      0370
*           AMBCREAT=ON;            /* IF YES, INDICATE CREATE       */
         L     @05,AMBP                                            0371
         OI    AMBCREAT(@05),B'10000000'                           0371
*           IF CTAMDSPD=ON THEN     /* IF CAT AMDSB INDICATES SPEED  */
         L     @01,OPWWRKPT(,RCORE)                                0372
         TM    CTAMDSPD(@01),B'10000000'                           0372
         BNO   @RF00372                                            0372
*             AMBSPEED=ON;          /* SET SPEED BIT IN AMB          */
         OI    AMBSPEED(@05),B'00001000'                           0373
*           IF DXUKEY>=KEY8 THEN    /* CODE FOR ASM BYPASS   @Z30SSDT*/
@RF00372 L     @05,OPWCOMWA(,RCORE)                                0374
         CLI   DXUKEY(@05),X'80'                                   0374
         BL    @RF00374                                            0374
*             IF CMBNST>K1&AMBLCAT=OFF THEN/* IF NO. OF STRINGS > 1
*                                      AND DATA SET IS NOT CATALOG 0375
*                                                            @Z30SSRL*/
         L     @05,ACBAMBL(,RACB)                                  0375
         L     @01,AMBLCMB(,@05)                                   0375
         CLI   CMBNST(@01),1                                       0375
         BNH   @RF00375                                            0375
         TM    AMBLCAT(@05),B'00000010'                            0375
         BNZ   @RF00375                                            0375
*               DO;                 /* OPEN FOR CREATE TERMINATED  0376
*                                                            @XA02415*/
*                 PPCODE=PP80;      /* SET ERROR CODE        @XA02415*/
         L     @05,SABWRD(,R13)                                    0377
         MVI   PPCODE(@05),X'50'                                   0377
*                 RETURN TO EXIT;   /* EXIT MODULE           @X04SVCJ*/
         LA    @14,EXIT                                            0378
         BR    @14                                                 0378
*               END;                /*                       @XA02415*/
*         END;                      /*                       @Z30SSDT*/
*       ELSE                        /* IF NOT OUTPUT                 */
*         DO;                       /* INPUT ONLY CREATE NOT ALLOWED */
         B     @RC00369                                            0381
@RF00369 DS    0H                                                  0382
*           PPCODE=PP72;            /* SET ERROR CODE                */
         L     @05,SABWRD(,R13)                                    0382
         MVI   PPCODE(@05),X'48'                                   0382
*           RETURN TO EXIT;         /* GET OUT OF MODULE     @X04SVCJ*/
         LA    @14,EXIT                                            0383
         BR    @14                                                 0383
*         END;                                                     0384
*     END;                                                         0385
@RC00369 DS    0H                                                  0386
*   RESPECIFY                                                      0386
*     RUCB RESTRICTED;                                             0386
@RF00367 DS    0H                                                  0387
*   RUCB=OPWTIOT->TIOEFSRT;         /* LOAD UCB ADDRESS      @Z30TSDT*/
         L     @05,OPWTIOT(,RCORE)                                 0387
         L     RUCB,TIOEFSRT-1(,@05)                               0387
         LA    RUCB,0(,RUCB)                                       0387
*   IF(CTHELP=ON|                   /* IF FORCE INVALIDATE BUFFERS 0388
*                                      REQUIRED OR           @ZA18302*/
*       ((AMBLCAT=ON|               /* CATALOG OR            @ZA33581*/
*       CTSDHELP=ON)&               /* FORCE INVALIDATE BUFFERS AND
*                                                            @ZA33581*/
*       (RUCB->UCBRR=ON|RUCB->UCBEXTPT->UCBSHRUP=ON))) THEN/* SHARED
*                                      DASDI                 @ZA30753*/
         L     @11,OPWWRKPT(,RCORE)                                0388
         TM    CTHELP(@11),B'00010000'                             0388
         BO    @RT00388                                            0388
         L     @05,ACBAMBL(,RACB)                                  0388
         TM    AMBLCAT(@05),B'00000010'                            0388
         BO    @GL00013                                            0388
         TM    CTSDHELP(@11),B'00001000'                           0388
         BNO   @RF00388                                            0388
@GL00013 TM    UCBRR(RUCB),B'00100000'                             0388
         BO    @RT00388                                            0388
         L     @11,UCBEXTPT(,RUCB)                                 0388
         TM    UCBSHRUP(@11),B'01000000'                           0388
         BNO   @RF00388                                            0388
@RT00388 DS    0H                                                  0389
*     AMBINBUF=ON;                  /* SET INVALIDATE BUFFERS        */
         L     @11,AMBP                                            0389
         OI    AMBINBUF(@11),B'00000001'                           0389
*   RESPECIFY                                                      0390
*     RUCB UNRESTRICTED;                                           0390
@RF00388 DS    0H                                                  0391
*   RESPECIFY                                                      0391
*     IFGEXLST BASED(ACBEXLST);                                    0391
*   IF ACBEXLST>K1&                 /* IF EXLST EXISTS       @Z30SSRL*/
*       EXLLEN>=35&                 /* IF EXLST BIG ENOUGH FOR JRNAD */
*       EXLJRNF(2)=ON THEN          /* IF JRN EXIT ACTIVE            */
         L     @05,ACBEXLST(,RACB)                                 0392
         C     @05,@CF00053                                        0392
         BNH   @RF00392                                            0392
         LH    @15,EXLLEN(,@05)                                    0392
         C     @15,@CF02794                                        0392
         BL    @RF00392                                            0392
         TM    EXLJRNF(@05),B'01000000'                            0392
         BNO   @RF00392                                            0392
*     AMBJRN=ON;                    /* SET JRN BIT ON                */
         L     @05,AMBP                                            0393
         OI    AMBJRN(@05),B'00000010'                             0393
*   IF ACBUBF=ON&                   /* IF UBF SPECIFIED,             */
*       AMBTYPE=AMBDATA THEN        /* IF AMB FOR DATA,              */
@RF00392 TM    ACBUBF(RACB),B'00000001'                            0394
         BNO   @RF00394                                            0394
         L     @05,AMBP                                            0394
         TM    AMBTYPE(@05),B'01000000'                            0394
         BNZ   @RF00394                                            0394
*     AMBUBF=ON;                    /* SET BIT FOR AMB               */
         OI    AMBUBF(@05),B'00000100'                             0395
*   AMBPAMBL=ADDR(IDAAMBL);         /* COPY PTR TO AMBL              */
@RF00394 L     @05,AMBP                                            0396
         L     @15,ACBAMBL(,RACB)                                  0396
         ST    @15,AMBPAMBL(,@05)                                  0396
*   IF ACBSIS=ON THEN               /* SEQ INSERT STRATEDGY  @X04SVGP*/
         TM    ACBSIS(RACB),B'00000100'                            0397
         BNO   @RF00397                                            0397
*     AMBSIS=ON;                    /* YES, SET ON IN AMB    @X04SVGP*/
         OI    AMBSIS(@05),B'00000100'                             0398
*   IF AMBTYPE=AMBDATA THEN         /* IF AMB FOR DATA       @X04SVCJ*/
@RF00397 L     @05,AMBP                                            0399
         TM    AMBTYPE(@05),B'01000000'                            0399
         BNZ   @RF00399                                            0399
*     AMBLDTA=ADDR(IDAAMB);         /* SET AMBL DATA AMB POINTER   0400
*                                                            @X04SVCJ*/
         L     @01,ACBAMBL(,RACB)                                  0400
         ST    @05,AMBLDTA(,@01)                                   0400
*   ELSE                            /* IF AMB FOR INDEX      @X04SVCJ*/
*     AMBLIX=ADDR(IDAAMB);          /* AMBL INDEX AMB PTR    @X04SVCJ*/
         B     @RC00399                                            0401
@RF00399 L     @05,ACBAMBL(,RACB)                                  0401
         L     @15,AMBP                                            0401
         ST    @15,AMBLIX(,@05)                                    0401
*   RESPECIFY                                                      0402
*     RET RSTD;                     /*                       @X04SVCJ*/
@RC00399 DS    0H                                                  0403
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @05,RETCONT                                         0403
         LR    @15,@05                                             0403
         SLA   @15,2                                               0403
         L     RET,RETSAVE-4(@15)                                  0403
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @05,0                                               0404
         ST    @05,RETCONT                                         0404
*   RESPECIFY                                                      0405
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   RFY                                                            0406
*     IDAAMDSB BASED(AMBDSB);       /* RESET                 @ZA18252*/
*   END BLDAMB;                                                    0407
         B     @EL00002                                            0407
*TIOTSRCH:                                                         0408
*                                                                  0408
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE SEARCHES THE CONCATENATED ENTRIES IN  */
*/*               THE TIOT ENTRY FOR THE SPHERE TO DETERMINE WHICH   */
*/*               ENTRY CORRESPONDES TO THE DEVICE TYPE FOR THE      */
*/*               ELEMENTARY DATA SET BEING PROCESSED.  WHEN THE     */
*/*               CORRECT ENTRY IS FOUND, THE OFFSET TO IT IS        */
*/*               CALCULATED AND SET IN THE AMB.                     */
*/*   INPUT -     ADDRESS OF TIOT ENTRY IN OPWTIOT.                  */
*/*   OUTPUT -    AMBTIOT INITIALIZED TO CORRECT OFFSET.             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0408
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVRP*/
TIOTSRCH DS    0H                                                  0409
*   RFY                                                            0409
*    (RET,                                                         0409
*     RTIOT) RSTD;                  /*                       @X04SVRP*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0410
         AL    @15,RETCONT                                         0410
         ST    @15,RETCONT                                         0410
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0411
         ST    RET,RETSAVE-4(@15)                                  0411
*   RFY                                                            0412
*     RET UNRSTD;                   /*                       @X04SVRP*/
*   RTIOT=OPWTIOT;                  /* LD ADDR OF TIOT ENTRY @XO4SVRP*/
         L     RTIOT,OPWTIOT(,RCORE)                               0413
*   DSABPTR=DXDSABAD;               /* INIT DSAB POINTER     @Z30SSDT*/
         L     @08,OPWCOMWA(,RCORE)                                0414
         L     @08,DXDSABAD(,@08)                                  0414
         ST    @08,DSABPTR                                         0414
*   DO UNTIL AMBTIOT^=0;            /* SCAN CONCATENTED TIOT ENTRIES
*                                                            @Z30SSDT*/
@DL00415 DS    0H                                                  0416
*     IF(UCBTYP(3:4)=CTDEVTYP(3:4)& /* IF DEV TYPES MATCH    @X04SVRP*/
*         (CTVIRT=ON&UCB2OPT4=ON|   /* AND BOTH VIRTUAL      @X04SVRP*/
*         CTVIRT=OFF&UCB2OPT4=OFF)) THEN/* OR BOTH NOT VIRTUAL     0416
*                                                            @X04SVRP*/
         L     @08,TIOEFSRT-1(,RTIOT)                              0416
         LA    @08,0(,@08)                                         0416
         L     @05,OPWWRKPT(,RCORE)                                0416
         CLC   UCBTYP+2(2,@08),CTDEVTYP+2(@05)                     0416
         BNE   @RF00416                                            0416
         TM    CTVIRT(@05),B'00001000'                             0416
         BNO   @GL00020                                            0416
         TM    UCB2OPT4(@08),B'00001000'                           0416
         BO    @RT00416                                            0416
@GL00020 L     @08,OPWWRKPT(,RCORE)                                0416
         TM    CTVIRT(@08),B'00001000'                             0416
         BNZ   @RF00416                                            0416
         L     @08,TIOEFSRT-1(,RTIOT)                              0416
         TM    UCB2OPT4(@08),B'00001000'                           0416
         BNZ   @RF00416                                            0416
@RT00416 DS    0H                                                  0417
*       AMBTIOT=RTIOT-TCBTIO;       /* THEN SET TIOT OFFSET  @X04SVRP*/
         LR    @08,RTIOT                                           0417
         L     @05,PSATOLD                                         0417
         SL    @08,TCBTIO(,@05)                                    0417
         L     @05,AMBP                                            0417
         STH   @08,AMBTIOT(,@05)                                   0417
*     ELSE                          /* ELSE PT TO NEXT ENTRY @Z30SSDT*/
*       DSABPTR=DSABFCHN;           /* PT TO NEXT DSAB       @Z30SSDT*/
         B     @RC00416                                            0418
@RF00416 L     @08,DSABPTR                                         0418
         L     @08,DSABFCHN(,@08)                                  0418
         ST    @08,DSABPTR                                         0418
*     RTIOT=DSABTIOT;               /* PT TO NEXT ENTRY      @Z30SSDT*/
@RC00416 L     @05,DSABPTR                                         0419
         L     RTIOT,DSABTIOT(,@05)                                0419
*   END;                            /*                       @X04SVRP*/
@DE00415 L     @08,AMBP                                            0420
         LH    @08,AMBTIOT(,@08)                                   0420
         LTR   @08,@08                                             0420
         BZ    @DL00415                                            0420
*   RFY                                                            0421
*     RET RSTD;                     /*                       @X04SVRP*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @08,RETCONT                                         0422
         LR    @05,@08                                             0422
         SLA   @05,2                                               0422
         L     RET,RETSAVE-4(@05)                                  0422
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @08,0                                               0423
         ST    @08,RETCONT                                         0423
*   RFY                                                            0424
*    (RET,                                                         0424
*     RTIOT) UNRSTD;                /*                       @X04SVRP*/
*   END TIOTSRCH;                   /*                       @X04SVRP*/
@EL00003 DS    0H                                                  0425
@EF00003 DS    0H                                                  0425
@ER00003 BR    @14                                                 0425
*BLDRMEXT:                                                         0426
*                                                                  0426
*/********************************************************************/
*/*                                                                 **/
*/*   FUNCTION - BUILD THE AMB EXTENSION FOR RECORD MANAGEMENT      **/
*/*   INPUT    - THE CURRENT AMB                                    **/
*/*   OUTPUT   - THE ADDRESS OF THE EXTENSION IS PLACED IN THE AMB  **/
*/*                                                                 **/
*/********************************************************************/
*                                                                  0426
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @Z30SSDT*/
BLDRMEXT DS    0H                                                  0427
*   RFY                                                            0427
*     RET RSTD;                     /*                       @Z30SSDT*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0428
         AL    @15,RETCONT                                         0428
         ST    @15,RETCONT                                         0428
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0429
         ST    RET,RETSAVE-4(@15)                                  0429
*   RFY                                                            0430
*     RET UNRSTD;                   /*                       @Z30SSDT*/
*   OPWVMLNG=LENGTH(IDAAMBXN);      /* INIT AMOUNT OF CORE   @Z30SSDT*/
         MVC   OPWVMLNG(3,RCORE),@CF00118+1                        0431
*   OPWVMTYP=USERBLK;               /* INDICATE USER BLOCK   @Z30SSDT*/
         MVI   OPWVMTYP(RCORE),X'01'                               0432
*   OPWVMANC=ADDR(IDACMB);          /* SET ADDRESS OF ANCHOR BLOCK 0433
*                                                            @Z30SSDT*/
         L     @05,ACBAMBL(,RACB)                                  0433
         L     @05,AMBLCMB(,@05)                                   0433
         ST    @05,OPWVMANC(,RCORE)                                0433
*   OPWVMFLG=ZERO;                  /* RESET FLAG FIELD      @Z30SSDT*/
         MVI   OPWVMFLG(RCORE),X'00'                               0434
*   CALL IDA0192M;                  /* GET CORE FOR AMB EXT  @Z30SSDT*/
         L     @15,@CV05525                                        0435
         BALR  @14,@15                                             0435
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0436
         MVC   RSTATRTN(4,@05),@CC05338                            0436
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @Z30SSDT*/
         L     @05,OPWVMADR(,RCORE)                                0437
         LTR   @05,@05                                             0437
         BNZ   @RF00437                                            0437
*     DO;                           /* ERROR                 @Z30SSDT*/
*       PPCODE=PP20;                /* SET ERROR CODE        @Z30SSDT*/
         L     @05,SABWRD(,R13)                                    0439
         MVI   PPCODE(@05),X'14'                                   0439
*       RETURN TO EXIT;             /* TERMINATE             @Z30SSDT*/
         LA    @14,EXIT                                            0440
@EL00004 DS    0H                                                  0440
@EF00004 DS    0H                                                  0440
@ER00004 BR    @14                                                 0440
*     END;                          /*                       @Z30SSDT*/
*   AMBEOVPT=OPWVMADR;              /* SAVE POINTER          @Z30SSDT*/
@RF00437 L     @05,OPWVMADR(,RCORE)                                0442
         L     @01,AMBP                                            0442
         ST    @05,AMBEOVPT(,@01)                                  0442
*   RFY                                                            0443
*     RET RSTD;                     /*                       @Z30SSDT*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @05,RETCONT                                         0444
         LR    @15,@05                                             0444
         SLA   @15,2                                               0444
         L     RET,RETSAVE-4(@15)                                  0444
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @05,0                                               0445
         ST    @05,RETCONT                                         0445
*   RFY                                                            0446
*     RET UNRSTD;                   /*                       @Z30SSDT*/
*   END BLDRMEXT;                   /* END MVM RECORD MGT EXTENTION
*                                      BUILD                 @Z30SSDT*/
         B     @EL00004                                            0447
*BLDAMDSB:                                                         0448
*                                                                  0448
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS THE AMDSB                      */
*/*   INPUT -     AMDSB FROM CATALOG IN CATALOG WORK AREA            */
*/*   OUTPUT -    1. AMDSB IS BUILT (COPIED FROM CATALOG WORK AREA)  */
*/*               2. AMDSBAD IS SET TO AMDSB ADDRESS IN AUTOMATICS   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0448
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0448
BLDAMDSB DS    0H                                                  0449
*   RESPECIFY                                                      0449
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0450
         AL    @15,RETCONT                                         0450
         ST    @15,RETCONT                                         0450
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0451
         ST    RET,RETSAVE-4(@15)                                  0451
*   RESPECIFY                                                      0452
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   OPWVMLNG=(LENGTH(IDAAMDSB)+LENGTH(AMDSTAT));/* BYTES FOR @X04SVCJ
*                                      AMDSB                 @X04SVCJ*/
         LA    @05,144                                             0453
         STCM  @05,7,OPWVMLNG(RCORE)                               0453
*   IF SMFACTV=ON THEN              /* IF SMF ACTIVE         @OZ04709*/
         TM    SMFACTV,B'00001000'                                 0454
         BNO   @RF00454                                            0454
*     OPWVMLNG=OPWVMLNG+LENGTH(AMDSTAT);/* ADD LENGTH TO SAVE OPEN 0455
*                                      STATISTICS            @OZ04709*/
         AL    @05,@CF02810                                        0455
         STCM  @05,7,OPWVMLNG(RCORE)                               0455
*   OPWVMTYP=USERBLK;               /* RESET REQUEST TYPE    @X04SVCJ*/
@RF00454 MVI   OPWVMTYP(RCORE),X'01'                               0456
*   OPWVMANC=ADDR(IDACMB);          /* SET ADDRESS OF ANCHOR BLOCK 0457
*                                                            @X04SVCJ*/
         L     @05,ACBAMBL(,RACB)                                  0457
         L     @05,AMBLCMB(,@05)                                   0457
         ST    @05,OPWVMANC(,RCORE)                                0457
*   OPWVMFLG=ZERO;                  /* ZERO FLAG FIELD       @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0458
*   IF OPWRSTRT=ON THEN             /* IF A RESTART          @Z30SSDT*/
         TM    OPWRSTRT(RCORE),B'00001000'                         0459
         BNO   @RF00459                                            0459
*     OPWVMADR=AMDSBAD;             /* GET ADDRESS PASSED    @Z30SSDT*/
         L     @05,AMDSBAD                                         0460
         ST    @05,OPWVMADR(,RCORE)                                0460
*   ELSE                            /* OTHERWISE,            @Z30SSDT*/
*     CALL IDA0192M;                /* GET CORE FOR AMDSB    @Z30SSDT*/
         B     @RC00459                                            0461
@RF00459 L     @15,@CV05525                                        0461
         BALR  @14,@15                                             0461
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
@RC00459 L     @05,OPWCOMWA(,RCORE)                                0462
         MVC   RSTATRTN(4,@05),@CC05338                            0462
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @05,OPWVMADR(,RCORE)                                0463
         LTR   @05,@05                                             0463
         BNZ   @RF00463                                            0463
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* SET ERROR CODE        @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0465
         MVI   PPCODE(@05),X'14'                                   0465
*       RETURN TO EXIT;             /* NO, TERMINATE         @X04SVCJ*/
         LA    @14,EXIT                                            0466
@EL00005 DS    0H                                                  0466
@EF00005 DS    0H                                                  0466
@ER00005 BR    @14                                                 0466
*     END;                          /*                       @X04SVCJ*/
*   AMDSBAD=OPWVMADR;               /* SAVE AMDSB ADDR       @X04SVCJ*/
@RF00463 L     @05,OPWVMADR(,RCORE)                                0468
         ST    @05,AMDSBAD                                         0468
*   RESPECIFY                                                      0469
*     IDAAMDSB BASED(AMDSBAD);      /* ADDRESSING FOR AMDSB          */
*   IDAAMDSB=CTAMDSB;               /* INIT AMDSB FR CATALOG INFO    */
         L     @01,OPWWRKPT(,RCORE)                                0470
         MVC   IDAAMDSB(96,@05),CTAMDSB(@01)                       0470
*   RESPECIFY                                                      0471
*     R6 RSTD;                      /*                       @X04SVCJ*/
*   R6=AMDSBAD+LENGTH(AMDSTAT);                                    0472
         LA    @15,48                                              0472
         LR    R6,@05                                              0472
         ALR   R6,@15                                              0472
*   R6->AMDSTAT=AMDSTAT;            /* SAVE STATISTICS FROM LAST   0473
*                                      CATALOG UPDATE        @OZ04709*/
         MVC   AMDSTAT(48,R6),AMDSTAT(@05)                         0473
*   IF SMFACTV=ON THEN              /* IF SMF IS ACTIVE      @OZ04709*/
         TM    SMFACTV,B'00001000'                                 0474
         BNO   @RF00474                                            0474
*     DO;                           /*                       @OZ04709*/
*       R6=R6+LENGTH(AMDSTAT);      /* PT TO OPEN STATISTICS @OZ04709*/
         ALR   R6,@15                                              0476
*       R6->AMDSTAT=AMDSTAT;        /* SAVE OPEN STATISTICS  @OZ04709*/
         MVC   AMDSTAT(48,R6),AMDSTAT(@05)                         0477
*     END;                          /*                       @OZ04709*/
*   RESPECIFY                                                      0479
*     R6 UNRSTD;                    /*                       @X04SVCJ*/
@RF00474 DS    0H                                                  0480
*   AMDSBID=IDXAMDSB;               /* INITIALIZE AMDSB ID   @OZ04709*/
         L     @05,AMDSBAD                                         0480
         MVI   AMDSBID(@05),B'01100000'                            0480
*   AMDLEN=OPWVMLNG;                /* INITIALIZE LENGTH     @X04SVCJ*/
         L     @15,OPWVMLNG-1(,RCORE)                              0481
         LA    @15,0(,@15)                                         0481
         STH   @15,AMDLEN(,@05)                                    0481
*   AMBDSB=AMDSBAD;                 /* CHAIN AMDSB OFF OF AMB        */
         L     @01,AMBP                                            0482
         ST    @05,AMBDSB(,@01)                                    0482
*   RESPECIFY                                                      0483
*     IDAAMDSB BASED(AMDSBAD);      /*                       @Z30SSDT*/
*   RESPECIFY                                                      0484
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @05,RETCONT                                         0485
         LR    @15,@05                                             0485
         SLA   @15,2                                               0485
         L     RET,RETSAVE-4(@15)                                  0485
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @05,0                                               0486
         ST    @05,RETCONT                                         0486
*   RESPECIFY                                                      0487
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   END BLDAMDSB;                                                  0488
         B     @EL00005                                            0488
*BLDIWA:                                                           0489
*                                                                  0489
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS THE ICWA, DIWA, OR THE         */
*/*               IMWA                                               */
*/*   INPUT -     AMB PREVIOUSLY CREATED                             */
*/*   OUTPUT -    1. IF AMB FOR DATA, AN DIWA IS BUILT               */
*/*               2. IF AMB FOR INDEX AND CREATE MODE, THEN          */
*/*                  THREE IWCAS ARE BUILT                           */
*/*               3. IF AMB FOR INDEX AND NOT CREATE MODE, THEN      */
*/*                  AN IMWA AND AN ICWA IS BUILT                    */
*/*               4. IWAAD IS SET WITH THE ADDRESS OF THE FIRST      */
*/*                  UNIT BUILT                                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0489
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0489
BLDIWA   DS    0H                                                  0490
*   RESPECIFY                                                      0490
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0491
         AL    @15,RETCONT                                         0491
         ST    @15,RETCONT                                         0491
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0492
         ST    RET,RETSAVE-4(@15)                                  0492
*   RESPECIFY                                                      0493
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   IF AMBTYPE=AMBDATA THEN         /* IS THIS AMB FOR DATA -        */
         L     @05,AMBP                                            0494
         TM    AMBTYPE(@05),B'01000000'                            0494
         BNZ   @RF00494                                            0494
*     DO;                           /* IF YES, THEN DO:              */
*       OPWVMLNG=LENGTH(IDADIWA);   /* INIT GETCORE REQUEST  @Z30SSDT*/
         MVC   OPWVMLNG(3,RCORE),@CF02710+1                        0496
*       OPWVMTYP=USERBLK;           /* RESET REQUEST TYPE    @Z30SSDT*/
         MVI   OPWVMTYP(RCORE),X'01'                               0497
*       OPWVMANC=ADDR(IDACMB);      /* ADDRESS ANCHOR BLOCK  @Z30SSDT*/
         L     @05,ACBAMBL(,RACB)                                  0498
         L     @05,AMBLCMB(,@05)                                   0498
         ST    @05,OPWVMANC(,RCORE)                                0498
*       OPWVMFLG=ZERO;              /* RESET FLAG FIELD      @Z30SSDT*/
         MVI   OPWVMFLG(RCORE),X'00'                               0499
*       CALL IDA0192M;              /* GETCORE FOR DIWA      @X04SVCJ*/
         L     @15,@CV05525                                        0500
         BALR  @14,@15                                             0500
*       RSTATRTN=IDAR192Z;          /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0501
         MVC   RSTATRTN(4,@05),@CC05338                            0501
*       IF OPWVMADR=ZERO THEN       /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @05,OPWVMADR(,RCORE)                                0502
         LTR   @05,@05                                             0502
         BNZ   @RF00502                                            0502
*         DO;                       /* ERROR                 @X04SVCJ*/
*           PPCODE=PP20;            /* SET ERROR CODE        @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0504
         MVI   PPCODE(@05),X'14'                                   0504
*           RETURN TO EXIT;         /* NO, TERMINATE         @X04SVCJ*/
         LA    @14,EXIT                                            0505
@EL00006 DS    0H                                                  0505
@EF00006 DS    0H                                                  0505
@ER00006 BR    @14                                                 0505
*         END;                      /*                       @X04SVCJ*/
*       IWAAD=OPWVMADR;             /* SAVE DIWA ADDRESS     @X04SVCJ*/
@RF00502 L     @05,OPWVMADR(,RCORE)                                0507
         ST    @05,IWAAD                                           0507
*       RESPECIFY                                                  0508
*         IDADIWA BASED(IWAAD);     /* ADDRESSING FOR DIWA           */
*       DIWID=IDXDIWA;              /* SET ID FOR DIWA               */
         MVI   DIWID(@05),B'01000001'                              0509
*       DIWLEN=OPWVMLNG;            /* INIT DIWA LENGTH      @X04SVCJ*/
         L     @15,OPWVMLNG-1(,RCORE)                              0510
         LA    @15,0(,@15)                                         0510
         STH   @15,DIWLEN(,@05)                                    0510
*       IF AMBCREAT=OFF THEN        /* IF NOT CREATE MODE            */
         L     @01,AMBP                                            0511
         TM    AMBCREAT(@01),B'10000000'                           0511
         BNZ   @RF00511                                            0511
*         DIWCISPL=ON;              /* SET BIT FOR DIWA              */
         OI    DIWCISPL(@05),B'01000000'                           0512
*     END;                                                         0513
*   ELSE                            /* IF AMB FOR INDEX, THEN DO     */
*     IF AMBCREAT=ON THEN           /* IS THIS CREATE MODE -         */
         B     @RC00494                                            0514
@RF00494 L     @05,AMBP                                            0514
         TM    AMBCREAT(@05),B'10000000'                           0514
         BNO   @RF00514                                            0514
*       DO C3=1 TO 3;               /* CREATE 3 ICWA                 */
         LA    C3,1                                                0515
@DL00515 DS    0H                                                  0516
*         OPWVMLNG=LENGTH(IDAICWA)+K3*AMDKEYLN;/* ENOUGH FOR ICWA + 3
*                                      KEYS                  @Z30SSRL*/
         L     @11,AMDSBAD                                         0516
         LH    @11,AMDKEYLN(,@11)                                  0516
         MH    @11,@CH00032                                        0516
         AL    @11,@CF00428                                        0516
         STCM  @11,7,OPWVMLNG(RCORE)                               0516
*         OPWVMTYP=USERBLK;         /* SET REQUEST TYPE      @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'01'                               0517
*         OPWVMANC=ADDR(IDACMB);    /* SET ADDRESS OF ANCHOR BLOCK 0518
*                                                            @X04SVCJ*/
         L     @11,ACBAMBL(,RACB)                                  0518
         L     @11,AMBLCMB(,@11)                                   0518
         ST    @11,OPWVMANC(,RCORE)                                0518
*         OPWVMFLG=ZERO;            /* RESET FLAG FIELD      @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0519
*         CALL IDA0192M;            /* GET CORE FOR 1 ICWA   @X04SVCJ*/
         L     @15,@CV05525                                        0520
         BALR  @14,@15                                             0520
*         RSTATRTN=IDAR192Z;        /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @11,OPWCOMWA(,RCORE)                                0521
         MVC   RSTATRTN(4,@11),@CC05338                            0521
*         IF OPWVMADR=ZERO THEN     /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @11,OPWVMADR(,RCORE)                                0522
         LTR   @11,@11                                             0522
         BNZ   @RF00522                                            0522
*           DO;                     /* ERROR                 @X04SVCJ*/
*             PPCODE=PP20;          /* SET ERROR CODE        @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0524
         MVI   PPCODE(@05),X'14'                                   0524
*             RETURN TO EXIT;       /* NO, TERMINATE         @X04SVCJ*/
         LA    @14,EXIT                                            0525
         BR    @14                                                 0525
*           END;                    /*                       @X04SVCJ*/
*         RESPECIFY                                                0527
*           IDAICWA BASED(OPWVMADR);/*                       @X04SVCJ*/
@RF00522 DS    0H                                                  0528
*         ICWID=IDXICWA;            /* INIT ICWA ID                  */
         L     @11,OPWVMADR(,RCORE)                                0528
         MVI   ICWID(@11),B'01000011'                              0528
*         IF C3=K1 THEN             /* IF FIRST ICWA         @Z30SSRL*/
         C     C3,@CF00053                                         0529
         BNE   @RF00529                                            0529
*           IWAAD=ADDR(IDAICWA);    /* SAVE POINTER FOR CHAINING     */
         ST    @11,IWAAD                                           0530
*         ELSE                      /* IF NOT THE FIRST ICWA         */
*           LASTICWA->ICWCHN=ADDR(IDAICWA);/* INIT CHAIN OF LAST ICWA*/
         B     @RC00529                                            0531
@RF00529 L     @11,OPWVMADR(,RCORE)                                0531
         L     @05,LASTICWA                                        0531
         ST    @11,ICWCHN(,@05)                                    0531
*         LASTICWA=ADDR(IDAICWA);   /* SAVE PTR TO THIS ICWA TO INIT
*                                      CHAIN POINTER LATER           */
@RC00529 L     @11,OPWVMADR(,RCORE)                                0532
         ST    @11,LASTICWA                                        0532
*         ICWLEN=OPWVMLNG;          /* SET ICWA LENGTH       @X04SVCJ*/
         L     @05,OPWVMLNG-1(,RCORE)                              0533
         LA    @05,0(,@05)                                         0533
         STH   @05,ICWLEN(,@11)                                    0533
*       END;                                                       0534
         AL    C3,@CF00053                                         0534
         C     C3,@CF00032                                         0534
         BNH   @DL00515                                            0534
*     ELSE                          /* IF NOT CREATE MODE            */
*       DO;                         /* THEN DO:              @Z30SSDT*/
         B     @RC00514                                            0535
@RF00514 DS    0H                                                  0536
*         OPWVMLNG=LENGTH(IDAIMWA)+K3*AMDKEYLN;/* FOR GETCORE REQUEST
*                                                            @Z30SSRL*/
         L     @05,AMDSBAD                                         0536
         LH    @05,AMDKEYLN(,@05)                                  0536
         MH    @05,@CH00032                                        0536
         AL    @05,@CF02827                                        0536
         STCM  @05,7,OPWVMLNG(RCORE)                               0536
*         OPWVMTYP=USERBLK;         /* SET REQUEST TYPE      @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'01'                               0537
*         OPWVMANC=ADDR(IDACMB);    /* SET ADDRESS OF ANCHOR BLOCK 0538
*                                                            @X04SVCJ*/
         L     @05,ACBAMBL(,RACB)                                  0538
         L     @05,AMBLCMB(,@05)                                   0538
         ST    @05,OPWVMANC(,RCORE)                                0538
*         OPWVMFLG=ZERO;            /* RESET FLAG FIELD      @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0539
*         CALL IDA0192M;            /* GETCORE FOR IMWA      @X04SVCJ*/
         L     @15,@CV05525                                        0540
         BALR  @14,@15                                             0540
*         RSTATRTN=IDAR192Z;        /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0541
         MVC   RSTATRTN(4,@05),@CC05338                            0541
*         IF OPWVMADR=ZERO THEN     /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @05,OPWVMADR(,RCORE)                                0542
         LTR   @05,@05                                             0542
         BNZ   @RF00542                                            0542
*           DO;                     /* ERROR                 @X04SVCJ*/
*             PPCODE=PP20;          /* SET ERROR CODE        @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0544
         MVI   PPCODE(@05),X'14'                                   0544
*             RETURN TO EXIT;       /* NO, TERMINATE         @X04SVCJ*/
         LA    @14,EXIT                                            0545
         BR    @14                                                 0545
*           END;                    /*                       @X04SVCJ*/
*         IWAAD=OPWVMADR;           /* SAVE IMWA ADDRESS     @X04SVCJ*/
@RF00542 L     @05,OPWVMADR(,RCORE)                                0547
         ST    @05,IWAAD                                           0547
*         RESPECIFY                                                0548
*           IDAIMWA BASED(IWAAD);   /* ADDRESSING FOR IMWA           */
*         IMWID=IDXIMWA;            /* INIT IMWA ID                  */
         MVI   IMWID(@05),B'01000010'                              0549
*         IMWLEN=OPWVMLNG;          /* INIT IMWA LENGTH      @X04SVCJ*/
         L     @15,OPWVMLNG-1(,RCORE)                              0550
         LA    @15,0(,@15)                                         0550
         STH   @15,IMWLEN(,@05)                                    0550
*         OPWVMLNG=LENGTH(IDAICWA)+K3*AMDKEYLN;/* SET LENGTH FOR   0551
*                                      GETCORE               @Z30SSRL*/
         L     @05,AMDSBAD                                         0551
         LH    @05,AMDKEYLN(,@05)                                  0551
         MH    @05,@CH00032                                        0551
         AL    @05,@CF00428                                        0551
         STCM  @05,7,OPWVMLNG(RCORE)                               0551
*         OPWVMTYP=USERBLK;         /* SET REQUEST TYPE      @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'01'                               0552
*         OPWVMANC=ADDR(IDACMB);    /* SET ADDRESS OF ANCHOR BLOCK 0553
*                                                            @X04SVCJ*/
         L     @05,ACBAMBL(,RACB)                                  0553
         L     @05,AMBLCMB(,@05)                                   0553
         ST    @05,OPWVMANC(,RCORE)                                0553
*         OPWVMFLG=ZERO;            /* RESET FLAG FIELD      @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0554
*         CALL IDA0192M;            /* GET CORE FOR ICWA     @X04SVCJ*/
         L     @15,@CV05525                                        0555
         BALR  @14,@15                                             0555
*         RSTATRTN=IDAR192Z;        /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @05,OPWCOMWA(,RCORE)                                0556
         MVC   RSTATRTN(4,@05),@CC05338                            0556
*         IF OPWVMADR=ZERO THEN     /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @05,OPWVMADR(,RCORE)                                0557
         LTR   @05,@05                                             0557
         BNZ   @RF00557                                            0557
*           DO;                     /* ERROR                 @X04SVCJ*/
*             PPCODE=PP20;          /* SET ERROR CODE        @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0559
         MVI   PPCODE(@05),X'14'                                   0559
*             RETURN TO EXIT;       /* NO, TERMINATE         @X04SVCJ*/
         LA    @14,EXIT                                            0560
         BR    @14                                                 0560
*           END;                    /*                       @X04SVCJ*/
*         OPWVMADR->ICWCHN=IWAAD;   /* CHN IMWA OFF ICWA     @X04SVCJ*/
@RF00557 L     @05,OPWVMADR(,RCORE)                                0562
         L     @15,IWAAD                                           0562
         ST    @15,ICWCHN(,@05)                                    0562
*         IWAAD=OPWVMADR;           /* SAVE PTR TO ICWA      @X04SVCJ*/
         ST    @05,IWAAD                                           0563
*         ICWLEN=OPWVMLNG;          /* SET LENGTH            @X04SVCJ*/
         L     @15,OPWVMLNG-1(,RCORE)                              0564
         LA    @15,0(,@15)                                         0564
         STH   @15,ICWLEN(,@05)                                    0564
*         ICWID=IDXICWA;            /* SET ID                        */
         MVI   ICWID(@05),B'01000011'                              0565
*       END;                                                       0566
*   AMBIWA=IWAAD;                   /* COPY WORK AREA ADDRESS        */
@RC00514 DS    0H                                                  0567
@RC00494 L     @05,IWAAD                                           0567
         L     @01,AMBP                                            0567
         ST    @05,AMBIWA(,@01)                                    0567
*   RESPECIFY                                                      0568
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @05,RETCONT                                         0569
         LR    @15,@05                                             0569
         SLA   @15,2                                               0569
         L     RET,RETSAVE-4(@15)                                  0569
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @05,0                                               0570
         ST    @05,RETCONT                                         0570
*   RESPECIFY                                                      0571
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   END BLDIWA;                                                    0572
         B     @EL00006                                            0572
*BLDARDB:                                                          0573
*                                                                  0573
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS THE ARDBS REQD FOR PROCESSING  */
*/*   INPUT -     1. CATALOG WORK AREA (AMBWKA) FOR THIS AMB         */
*/*   OUTPUT -    1. ARDBS ARE BUILT                                 */
*/*               2. ARDBAD IS SET TO ADDRESS OF FIRST ARDB          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0573
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0573
BLDARDB  DS    0H                                                  0574
*   RESPECIFY                                                      0574
*    (R6,                                                          0574
*     R7,                                                          0574
*     R9,                                                          0574
*     RET) RSTD;                    /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0575
         AL    @15,RETCONT                                         0575
         ST    @15,RETCONT                                         0575
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0576
         ST    RET,RETSAVE-4(@15)                                  0576
*   RESPECIFY                                                      0577
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   RESPECIFY                                                      0578
*     CTVOLENT BASED(R6);                                          0578
*   RESPECIFY                                                      0579
*     CTKEYENT BASED(R7);                                          0579
*   RESPECIFY                                                      0580
*     IDAAMDSB BASED(AMDSBAD);                                     0580
*   IF AMDRANGE=OFF THEN            /* IF NOT KEY RANGE DATA SET     */
         L     @08,AMDSBAD                                         0581
         TM    AMDRANGE(@08),B'00000100'                           0581
         BNZ   @RF00581                                            0581
*     CALL OFLOWSET;                /* RESOLVE KEY ENTRIES           */
         BAL   @14,OFLOWSET                                        0582
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);/* PT TO FIRST VOLUME ENTRY     */
@RF00581 LA    R6,232                                              0583
         AL    R6,OPWWRKPT(,RCORE)                                 0583
*   CURKEYNO=K0;                    /* ZERO KEY RANGE COUNT  @Z30SSRL*/
         SLR   CURKEYNO,CURKEYNO                                   0584
*   DO C2=1 TO VOLENTNO;            /* PROCESS ALL VOLUME ENTRIES    */
         LA    @05,1                                               0585
         B     @DE00585                                            0585
@DL00585 DS    0H                                                  0586
*     IF CTOFLOW=OFF THEN           /* IF NOT OVERFLOW VOLUME,       */
         TM    CTOFLOW(R6),B'01000000'                             0586
         BNZ   @RF00586                                            0586
*       CURKEYNO=CURKEYNO+CTNOKEY;  /* ADD KEY RANGE ENTRIES         */
         AH    CURKEYNO,CTNOKEY(,R6)                               0587
*     R6=R6+LENGTH(CTVOLENT)+(LENGTH(CTKEYENT)+CTKEYLEN*K2)*CTNOKEY+
*         LENGTH(CTEXTENT)*CTNOEXT; /* COMPUTE ADDR NXT VOL ENTRY    */
@RF00586 LA    @05,20                                              0588
         LR    @15,R6                                              0588
         ALR   @15,@05                                             0588
         LH    @01,CTKEYLEN(,R6)                                   0588
         ALR   @01,@01                                             0588
         AL    @01,@CF00050                                        0588
         MH    @01,CTNOKEY(,R6)                                    0588
         ALR   @15,@01                                             0588
         LR    @01,@05                                             0588
         SLR   @05,@05                                             0588
         IC    @05,CTNOEXT(,R6)                                    0588
         MR    @00,@05                                             0588
         ALR   @15,@01                                             0588
         LR    R6,@15                                              0588
*   END;                                                           0589
         LA    @05,1                                               0589
         AL    @05,C2                                              0589
@DE00585 ST    @05,C2                                              0589
         L     @01,OPWWRKPT(,RCORE)                                0589
         CH    @05,VOLENTNO(,@01)                                  0589
         BNH   @DL00585                                            0589
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);/* PT TO FIRST KEY RANGE ENTRY  */
         LA    R6,232                                              0590
         AL    R6,OPWWRKPT(,RCORE)                                 0590
*   ARDBSIZE=LENGTH(IDAARDB)+CTKEYLEN*K2;/* SIZE OF 1 ARDB   @Z30SSRL*/
         LH    ARDBSIZE,CTKEYLEN(,R6)                              0591
         ALR   ARDBSIZE,ARDBSIZE                                   0591
         AL    ARDBSIZE,@CF04848                                   0591
*   ARDBSIZE=(ARDBSIZE+FWORDLEN-K1)/FWORDLEN*FWORDLEN;/* ROUND UP TO
*                                      FULL WORD BOUNDARY    @Z30SSRL*/
         LR    @00,ARDBSIZE                                        0592
         SL    @00,@CF05648                                        0592
         SRDA  @00,32                                              0592
         D     @00,@CF00095                                        0592
         SLA   @01,2                                               0592
         LR    ARDBSIZE,@01                                        0592
*   OPWVMLNG=ARDBSIZE*CURKEYNO;     /* CORE LEN FOR ALL      @X04SVCJ
*                                      ARDBS                 @X04SVCJ*/
         LR    @01,CURKEYNO                                        0593
         MR    @00,ARDBSIZE                                        0593
         STCM  @01,7,OPWVMLNG(RCORE)                               0593
*   OPWVMTYP=USERBLK;               /* SET REQUEST TYPE      @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'01'                               0594
*   OPWVMANC=ADDR(IDACMB);          /* SET ADDRESS OF ANCHOR BLOCK 0595
*                                                            @X04SVCJ*/
         L     @01,ACBAMBL(,RACB)                                  0595
         L     @15,AMBLCMB(,@01)                                   0595
         ST    @15,OPWVMANC(,RCORE)                                0595
*   OPWVMFLG=ZERO;                  /* RESET FLAG FIELD      @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0596
*   IF OPWRSTRT=ON THEN             /* IF THIS IS A RESTART  @Z30SSDT*/
         TM    OPWRSTRT(RCORE),B'00001000'                         0597
         BNO   @RF00597                                            0597
*     OPWVMADR=ARDBAD;              /* USE THE EXISTING ARDB @Z30SSDT*/
         L     @15,ARDBAD                                          0598
         ST    @15,OPWVMADR(,RCORE)                                0598
*   ELSE                            /* NOT A RESTART         @Z30SSDT*/
*     CALL IDA0192M;                /* GET THE CORE          @Z30SSDT*/
         B     @RC00597                                            0599
@RF00597 L     @15,@CV05525                                        0599
         BALR  @14,@15                                             0599
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
@RC00597 L     @01,OPWCOMWA(,RCORE)                                0600
         MVC   RSTATRTN(4,@01),@CC05338                            0600
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @15,OPWVMADR(,RCORE)                                0601
         LTR   @15,@15                                             0601
         BNZ   @RF00601                                            0601
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* SET ERROR CODE        @X04SVCJ*/
         L     @08,SABWRD(,R13)                                    0603
         MVI   PPCODE(@08),X'14'                                   0603
*       RETURN TO EXIT;             /* NO, TERMINATE         @X04SVCJ*/
         LA    @14,EXIT                                            0604
@EL00007 DS    0H                                                  0604
@EF00007 DS    0H                                                  0604
@ER00007 BR    @14                                                 0604
*     END;                          /*                       @X04SVCJ*/
*   R9=OPWVMADR;                    /* LOAD POINTER TO CORE  @X04SVCJ*/
@RF00601 L     R9,OPWVMADR(,RCORE)                                 0606
*   DO C2=1 TO VOLENTNO;            /* PROCESS ALL VOLUME ENTRIES    */
         LA    @15,1                                               0607
         B     @DE00607                                            0607
@DL00607 DS    0H                                                  0608
*     R7=R6+LENGTH(CTVOLENT);       /* PT TO 1ST KEY RANGE ENTRY     */
         LA    R7,20                                               0608
         ALR   R7,R6                                               0608
*     IF CTOFLOW=OFF THEN           /* IF NOT OVERFLOW VOLUME,       */
         TM    CTOFLOW(R6),B'01000000'                             0609
         BNZ   @RF00609                                            0609
*       DO C3=1 TO CTNOKEY;         /* PROCESS ALL KEY ENTRIES       */
         LA    C3,1                                                0610
         B     @DE00610                                            0610
@DL00610 DS    0H                                                  0611
*         RESPECIFY                                                0611
*           IDAARDB BASED(R9);                                     0611
*         ARDLEN=ARDBSIZE;          /* SET LENGTH OF ARDB            */
         STH   ARDBSIZE,ARDLEN(,R9)                                0612
*         IF C2=K1&                 /* IF 1ST VOLUME ENTRY   @Z30SSRL*/
*             C3=K1 THEN            /* AND 1ST KEY ENTRY (1ST ARDB)  */
         LA    @11,1                                               0613
         C     @11,C2                                              0613
         BNE   @RF00613                                            0613
         CR    C3,@11                                              0613
         BNE   @RF00613                                            0613
*           ARDBAD=ADDR(IDAARDB);   /* SET POINTER TO 1ST ARDB       */
         ST    R9,ARDBAD                                           0614
*         ELSE                      /* IF NOT 1ST ARDB               */
*           LASTARDB->ARDNPTR=ADDR(IDAARDB);/* POINT LAST ARDB TO  0615
*                                      THIS ARDB                     */
         B     @RC00613                                            0615
@RF00613 L     @11,LASTARDB                                        0615
         ST    R9,ARDNPTR(,@11)                                    0615
*         LASTARDB=ADDR(IDAARDB);   /* SAVE PTR TO ARDB FOR LATER    */
@RC00613 ST    R9,LASTARDB                                         0616
*         ARDID=IDXARDB;            /* SET ID                        */
         MVI   ARDID(R9),B'01100001'                               0617
*         IF CTINDX=ON THEN         /* IF INDEX SET                  */
         L     @11,OPWWRKPT(,RCORE)                                0618
         TM    CTINDX(@11),B'00010000'                             0618
         BNO   @RF00618                                            0618
*           IF CTSSWDTA=ON THEN     /* SEQ SET W/DATA THIS KEY RNGE  */
         TM    CTSSWDTA(R7),B'10000000'                            0619
         BNO   @RF00619                                            0619
*             ARDSS=ON;             /* INDICATE SS/W DATA IN ARDB    */
         OI    ARDSS(R9),B'00100000'                               0620
*           ELSE                    /* NOT SEQ SET W/DATA    @Z30SSRL*/
*             ARDHLI=ON;            /* HIGH LEVEL INDEX ARDB         */
         B     @RC00619                                            0621
@RF00619 OI    ARDHLI(R9),B'01000000'                              0621
*         IF AMDRANGE=ON&ARDHLI=OFF THEN/* USING KEY RANGE           */
@RC00619 DS    0H                                                  0622
@RF00618 L     @11,AMDSBAD                                         0622
         TM    AMDRANGE(@11),B'00000100'                           0622
         BNO   @RF00622                                            0622
         TM    ARDHLI(R9),B'01000000'                              0622
         BNZ   @RF00622                                            0622
*           ARDKR=ON;               /* YES, KEY RANGE ARDB           */
         OI    ARDKR(R9),B'10000000'                               0623
*         ARDRELNO=CTKRELNO;        /* VOL OCCURENCE NBR             */
@RF00622 LH    @11,CTKRELNO(,R7)                                   0624
         STH   @11,ARDRELNO(,R9)                                   0624
*         ARDPRF=CTKEYFLG;          /* INIT PREFORMAT INDICATOR      */
         MVC   ARDPRF(1,R9),CTKEYFLG(R7)                           0625
*         IF OPWCAT=ON THEN         /* IF PROCESSING CATALOG @X04SVCJ*/
         TM    OPWCAT(RCORE),B'10000000'                           0626
         BNO   @RF00626                                            0626
*           ARDPRFMT=ON;            /* INDICATE PREFORMAT REQD       */
         OI    ARDPRFMT(R9),B'01000000'                            0627
*         ARDHKRBA=CTKHKRBA;        /* INIT HI KEY RBA               */
@RF00626 L     @11,CTKHKRBA(,R7)                                   0628
         ST    @11,ARDHKRBA(,R9)                                   0628
*         ARDHRBA=CTKHURBA;         /* INIT HI USED RBA THIS KEY   0629
*                                      RANGE                         */
         L     @11,CTKHURBA(,R7)                                   0629
         ST    @11,ARDHRBA(,R9)                                    0629
*         ARDERBA=CTKHARBA;         /* INIT HI ALLOCATED RBA         */
         L     @11,CTKHARBA(,R7)                                   0630
         ST    @11,ARDERBA(,R9)                                    0630
*         ARDKEYS(1:CTKEYLEN)=CTKEY(1:CTKEYLEN);/* INIT KEY  @ZA18531*/
         LH    @11,CTKEYLEN(,R6)                                   0631
         LR    @15,@11                                             0631
         BCTR  @15,0                                               0631
         EX    @15,@SM05664                                        0631
*         ARDKEYS(CTKEYLEN+1:CTKEYLEN*K2)=CTKEY(CTKEYLEN+1:CTKEYLEN*K2)
*             ;                     /* INIT KEY              @ZA18531*/
         ALR   @11,R9                                              0632
         LH    @15,CTKEYLEN(,R6)                                   0632
         LR    @14,@15                                             0632
         ALR   @14,@14                                             0632
         LR    @01,@14                                             0632
         SLR   @01,@15                                             0632
         BCTR  @01,0                                               0632
         ALR   @15,R7                                              0632
         EX    @01,@SM05666                                        0632
*         ARDVOLSR=CTVOLSER;        /* INIT VOL SER IN ARDB          */
         MVC   ARDVOLSR(6,R9),CTVOLSER(R6)                         0633
*         R9=R9+ARDBSIZE;           /* POINT TO NEXT ARDB POINT R7 TO
*                                      NEXT KEY ENTRY                */
         ALR   R9,ARDBSIZE                                         0634
*         R7=R7+LENGTH(CTEXTENT)*CTNOKEXT+LENGTH(CTKEYENT)+CTKEYLEN*K2;
         SLR   @11,@11                                             0635
         IC    @11,CTNOKEXT(,R7)                                   0635
         MH    @11,@CH00443                                        0635
         ALR   @11,R7                                              0635
         AL    @11,@CF00050                                        0635
         ALR   @11,@14                                             0635
         LR    R7,@11                                              0635
*       END;                                                       0636
*                                                                  0636
         AL    C3,@CF00053                                         0636
@DE00610 CH    C3,CTNOKEY(,R6)                                     0636
         BNH   @DL00610                                            0636
*     /***************************************************************/
*     /*                                                             */
*     /* POINT R6 TO NEXT VOLUME ENTRY                       @Z30SSDT*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0637
*     R6=LENGTH(CTVOLENT)+(LENGTH(CTKEYENT)+CTKEYLEN*K2)*CTNOKEY+LENGTH
*         (CTEXTENT)*CTNOEXT+R6;    /*                       @Z30SSDT*/
@RF00609 LA    @15,20                                              0637
         LH    @01,CTKEYLEN(,R6)                                   0637
         ALR   @01,@01                                             0637
         AL    @01,@CF00050                                        0637
         MH    @01,CTNOKEY(,R6)                                    0637
         ALR   @01,@15                                             0637
         SLR   @00,@00                                             0637
         IC    @00,CTNOEXT(,R6)                                    0637
         MR    @14,@00                                             0637
         ALR   @01,@15                                             0637
         ALR   R6,@01                                              0637
*   END;                                                           0638
         LA    @15,1                                               0638
         AL    @15,C2                                              0638
@DE00607 ST    @15,C2                                              0638
         L     @14,OPWWRKPT(,RCORE)                                0638
         CH    @15,VOLENTNO(,@14)                                  0638
         BNH   @DL00607                                            0638
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);                              0639
         LA    R6,232                                              0639
         AL    R6,OPWWRKPT(,RCORE)                                 0639
*   R9=ARDBAD;                      /* POINT TO 1ST ARDB             */
         L     R9,ARDBAD                                           0640
*   DO C2=1 TO VOLENTNO;            /* PROCESS ALL VOLUME ENTRIES    */
         LA    @05,1                                               0641
         B     @DE00641                                            0641
@DL00641 DS    0H                                                  0642
*     R7=R6+LENGTH(CTVOLENT);       /* PT TO 1ST KEY ENT THIS VOL    */
         LA    R7,20                                               0642
         ALR   R7,R6                                               0642
*     IF CTOFLOW=ON THEN            /* OVERFLOW VOLUME -             */
         TM    CTOFLOW(R6),B'01000000'                             0643
         BNO   @RF00643                                            0643
*       DO C3=1 TO CTNOKEY;         /* PROCESS ALL KEY ENTRIES       */
         LA    C3,1                                                0644
         B     @DE00644                                            0644
@DL00644 DS    0H                                                  0645
*         DO C4=1 TO CURKEYNO;      /* PROCESS ALL ARDBS             */
         LA    @11,1                                               0645
         B     @DE00645                                            0645
@DL00645 DS    0H                                                  0646
*           IF(AMBLNUM=1|           /* IF NO KEYS            @ZA14572*/
*               (ARDKEYS(K1:CTKEYLEN)=CTKEY(K1:CTKEYLEN)&/* KEY    0646
*                                                            @ZA18531*/
*               ARDKEYS(CTKEYLEN+K1:CTKEYLEN*K2)=CTKEY(CTKEYLEN+K1:
*               CTKEYLEN*K2)&       /* KEY                   @ZA18531*/
*               ((CTSSWDTA=ON&ARDSS=ON)|/* IF OVERFLOW FOR SEQ SET 0646
*                                                            @ZA14572*/
*               CTINDX=OFF|         /* IF NOT INDEX          @ZA14572*/
*               (CTSSWDTA=OFF&ARDHLI=ON))))&/* IF FOR HILEVEL INDEX
*                                                            @ZA14572*/
*               CTKHARBA>ARDERBA THEN/* RBA>ARDBRBA          @ZA14572*/
         L     @11,ACBAMBL(,RACB)                                  0646
         CLC   AMBLNUM(2,@11),@CH00053                             0646
         BE    @GL00025                                            0646
         LH    @11,CTKEYLEN(,R6)                                   0646
         LR    @05,@11                                             0646
         BCTR  @05,0                                               0646
         EX    @05,@SC05668                                        0646
         BNE   @RF00646                                            0646
         LR    @05,@11                                             0646
         ALR   @05,@05                                             0646
         SLR   @05,@11                                             0646
         BCTR  @05,0                                               0646
         ST    @11,@TF00001                                        0646
         ALR   @11,R9                                              0646
         LR    @01,R7                                              0646
         AL    @01,@TF00001                                        0646
         EX    @05,@SC05670                                        0646
         BNE   @RF00646                                            0646
         TM    CTSSWDTA(R7),B'10000000'                            0646
         BNO   @GL00030                                            0646
         TM    ARDSS(R9),B'00100000'                               0646
         BO    @GL00025                                            0646
@GL00030 L     @11,OPWWRKPT(,RCORE)                                0646
         TM    CTINDX(@11),B'00010000'                             0646
         BZ    @GL00025                                            0646
         TM    CTSSWDTA(R7),B'10000000'                            0646
         BNZ   @RF00646                                            0646
         TM    ARDHLI(R9),B'01000000'                              0646
         BNO   @RF00646                                            0646
@GL00025 L     @11,CTKHARBA(,R7)                                   0646
         CL    @11,ARDERBA(,R9)                                    0646
         BNH   @RF00646                                            0646
*             DO;                   /* YES, -                        */
*               ARDHRBA=CTKHURBA;   /* REPLACE ARDB RBAS             */
         L     @05,CTKHURBA(,R7)                                   0648
         ST    @05,ARDHRBA(,R9)                                    0648
*               ARDERBA=CTKHARBA;   /* COPY HIGH ALLOCATED RBA       */
         ST    @11,ARDERBA(,R9)                                    0649
*               ARDHKRBA=CTKHKRBA;  /* RBA OF HIGH KEY CI            */
         L     @11,CTKHKRBA(,R7)                                   0650
         ST    @11,ARDHKRBA(,R9)                                   0650
*               ARDPRF=CTKEYFLG;    /* REPLACE PREFORMAT INDICATOR   */
         MVC   ARDPRF(1,R9),CTKEYFLG(R7)                           0651
*               ARDRELNO=CTKRELNO;  /* REPLACE VOL OCCURENCE NBR     */
         LH    @11,CTKRELNO(,R7)                                   0652
         STH   @11,ARDRELNO(,R9)                                   0652
*               ARDVOLSR=CTVOLSER;  /* REPLACE WITH OVRFLOW VOL SER  */
         MVC   ARDVOLSR(6,R9),CTVOLSER(R6)                         0653
*               IF ARDKR=ON THEN    /* IF KEY RANGE ENTRY            */
         TM    ARDKR(R9),B'10000000'                               0654
         BNO   @RF00654                                            0654
*                 ARDUOVFL=ON;      /* INDICATE KEY RANGE USING    0655
*                                      OVERFLOW IF SO                */
         OI    ARDUOVFL(R9),B'00010000'                            0655
*             END;                                                 0656
@RF00654 DS    0H                                                  0657
*           R9=ARDNPTR;             /* PT TO NEXT ARDB               */
@RF00646 L     R9,ARDNPTR(,R9)                                     0657
*         END;                                                     0658
         LA    @11,1                                               0658
         AL    @11,C4                                              0658
@DE00645 ST    @11,C4                                              0658
         CR    @11,CURKEYNO                                        0658
         BNH   @DL00645                                            0658
*         R7=R7+LENGTH(CTEXTENT)*CTNOKEXT+LENGTH(CTKEYENT)+CTKEYLEN*K2;
         SLR   @11,@11                                             0659
         IC    @11,CTNOKEXT(,R7)                                   0659
         MH    @11,@CH00443                                        0659
         ALR   @11,R7                                              0659
         AL    @11,@CF00050                                        0659
         LH    @05,CTKEYLEN(,R6)                                   0659
         ALR   @05,@05                                             0659
         ALR   @11,@05                                             0659
         LR    R7,@11                                              0659
*                                   /* PT TO NEXT KEY RANGE ENTRY    */
*         R9=ARDBAD;                /* PT TO 1ST ARDB                */
         L     R9,ARDBAD                                           0660
*       END;                                                       0661
         AL    C3,@CF00053                                         0661
@DE00644 CH    C3,CTNOKEY(,R6)                                     0661
         BNH   @DL00644                                            0661
*     R6=R6+LENGTH(CTVOLENT)+(LENGTH(CTKEYENT)+CTKEYLEN*K2)*CTNOKEY+
*         LENGTH(CTEXTENT)*CTNOEXT; /* PT TO NEXT VOLUME ENTRY       */
@RF00643 LA    @05,20                                              0662
         LR    @15,R6                                              0662
         ALR   @15,@05                                             0662
         LH    @01,CTKEYLEN(,R6)                                   0662
         ALR   @01,@01                                             0662
         AL    @01,@CF00050                                        0662
         MH    @01,CTNOKEY(,R6)                                    0662
         ALR   @15,@01                                             0662
         LR    @01,@05                                             0662
         SLR   @05,@05                                             0662
         IC    @05,CTNOEXT(,R6)                                    0662
         MR    @00,@05                                             0662
         ALR   @15,@01                                             0662
         LR    R6,@15                                              0662
*     R9=ARDBAD;                    /* PT TO 1ST ARDB                */
         L     R9,ARDBAD                                           0663
*   END;                                                           0664
         LA    @05,1                                               0664
         AL    @05,C2                                              0664
@DE00641 ST    @05,C2                                              0664
         L     @01,OPWWRKPT(,RCORE)                                0664
         CH    @05,VOLENTNO(,@01)                                  0664
         BNH   @DL00641                                            0664
*   R9=ARDBAD;                      /* POINT TO 1ST ARDB             */
         L     R9,ARDBAD                                           0665
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);/* PT TO FIRST VOL ENTRY@ZA12182*/
         LA    R6,232                                              0666
         AL    R6,OPWWRKPT(,RCORE)                                 0666
*   ARDRBA=ARDRBA&&ARDRBA;          /* INIT HIGH RBA TO ZERO         */
         L     @15,ARDRBA                                          0667
         LR    @14,@15                                             0667
         XR    @14,@15                                             0667
         ST    @14,ARDRBA                                          0667
*   LOKYAD=ADDR(ARDKEYS);           /* INIT ADDR OF LOW KEY          */
         LA    LOKYAD,ARDKEYS(,R9)                                 0668
*   LOKYARDB=R9;                    /* INIT ADDR OF LOW KEY ARDB     */
         ST    R9,LOKYARDB                                         0669
*   DO C2=1 TO CURKEYNO;            /* PROCESS ALL ARDBS             */
         LA    @15,1                                               0670
         B     @DE00670                                            0670
@DL00670 DS    0H                                                  0671
*     IF ARDERBA>ARDRBA THEN        /* IS HIGHEST RBA STILL HIGH     */
         L     @15,ARDERBA(,R9)                                    0671
         CL    @15,ARDRBA                                          0671
         BNH   @RF00671                                            0671
*       DO;                                                        0672
*         ARDRBA=ARDERBA;           /* REPLACE RBA WITH HIGHER RBA   */
         ST    @15,ARDRBA                                          0673
*         HARDBAD=R9;               /* SAVE ADDRESS OF ARDB          */
         ST    R9,HARDBAD                                          0674
*       END;                                                       0675
*     IF ARDKEYS(1:CTKEYLEN)<LOKY(1:CTKEYLEN) THEN/* LT CURRENT LOW
*                                      KEY                           */
@RF00671 LH    @15,CTKEYLEN(,R6)                                   0676
         BCTR  @15,0                                               0676
         EX    @15,@SC05672                                        0676
         BNL   @RF00676                                            0676
*       DO;                                                        0677
*         LOKYARDB=R9;              /* SAVE ADDR OF LOW KEY ARDB     */
         ST    R9,LOKYARDB                                         0678
*         LOKYAD=ADDR(ARDKEYS);     /* SAVE ADDR OF KEY              */
         LA    LOKYAD,ARDKEYS(,R9)                                 0679
*       END;                                                       0680
*     R9=ARDNPTR;                   /* POINT TO NEXT ARDB            */
@RF00676 L     R9,ARDNPTR(,R9)                                     0681
*   END;                                                           0682
         LA    @15,1                                               0682
         AL    @15,C2                                              0682
@DE00670 ST    @15,C2                                              0682
         CR    @15,CURKEYNO                                        0682
         BNH   @DL00670                                            0682
*   R9=HARDBAD;                     /* PT TO ARDB W/ HI RBA          */
         L     R9,HARDBAD                                          0683
*   ARDEOD=ON;                      /* IND ARDB HAS EOD              */
*                                                                  0684
         OI    ARDEOD(R9),B'00001000'                              0684
*   /*****************************************************************/
*   /*                                                               */
*   /* CHAIN ARDB'S IN ASCENDING KEY ORDER                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0685
*   IF CTINDX=OFF THEN              /* IF AMB FOR DATA SET           */
         L     @05,OPWWRKPT(,RCORE)                                0685
         TM    CTINDX(@05),B'00010000'                             0685
         BNZ   @RF00685                                            0685
*     DO;                                                          0686
*       R7=ARDBAD;                  /* R7 PTS TO FIRST ARDB          */
         L     R7,ARDBAD                                           0687
*       DO C2=1 TO CURKEYNO;        /* PROCESS ALL ARDB'S            */
         LA    @05,1                                               0688
         B     @DE00688                                            0688
@DL00688 DS    0H                                                  0689
*         R9=ARDBAD;                /* R9 PTS TO FIRST ARDB          */
         L     R9,ARDBAD                                           0689
*         TEMPLKAR=K0;              /* ZERO TEMP ARDB PTR    @Z30SSRL*/
         SLR   TEMPLKAR,TEMPLKAR                                   0690
*         DO C3=1 TO CURKEYNO;      /* MAKE INNER PASS THRU ARDB'S   */
         LA    C3,1                                                0691
         B     @DE00691                                            0691
@DL00691 DS    0H                                                  0692
*           IF R9^=R7 THEN          /* BYPASS CURRENT ARDB           */
         CR    R9,R7                                               0692
         BE    @RF00692                                            0692
*             DO;                                                  0693
*               IF R9->ARDKEYS(1:CTKEYLEN)>/* IF THIS ARDB   @Z30SSRL*/
*                   R7->ARDKEYS(1:CTKEYLEN) THEN/* HAS HIGHER KEY  0694
*                                      THAN THE CURRENT ARDB @Z30SSRL*/
         LH    @11,CTKEYLEN(,R6)                                   0694
         BCTR  @11,0                                               0694
         EX    @11,@SC05674                                        0694
         BNH   @RF00694                                            0694
*                 DO;               /* YES                   @Z30SSRL*/
*                   IF TEMPLKAR=K0 THEN/* POTENTIAL NXT ALREADY    0696
*                                      EXIST?                @Z30SSRL*/
         LTR   TEMPLKAR,TEMPLKAR                                   0696
         BNZ   @RF00696                                            0696
*                     TEMPLKAR=R9;  /* NO, ESTABLISH POTENTIAL NXT   */
         LR    TEMPLKAR,R9                                         0697
*                   ELSE            /* YES, DO:                      */
*                     DO;                                          0698
         B     @RC00696                                            0698
@RF00696 DS    0H                                                  0699
*                       IF R9->ARDKEYS(1:CTKEYLEN)<TEMPLKAR->ARDKEYS(1:
*                           CTKEYLEN) THEN/* ARDB KEY LESS THAN    0699
*                                      EXISTING NXT POTENTIAL ARDB 0699
*                                      KEY?                          */
         LH    @11,CTKEYLEN(,R6)                                   0699
         BCTR  @11,0                                               0699
         EX    @11,@SC05676                                        0699
         BNL   @RF00699                                            0699
*                         TEMPLKAR=R9;/* YES,THIS ARDB BECOMES NEW 0700
*                                      NXT POTENTIAL ARDB            */
         LR    TEMPLKAR,R9                                         0700
*                     END;                                         0701
*                 END;                                             0702
*               ELSE                /* ARDB KEY LESS OR EQUAL TO   0703
*                                      CURRENT ARDB                  */
*                 DO;                                              0703
         B     @RC00694                                            0703
@RF00694 DS    0H                                                  0704
*                   IF R9->ARDKEYS(1:CTKEYLEN)=R7->ARDKEYS(1:CTKEYLEN)&
*                                   /* IS IT EQUAL?                  */
*                       R9>R7 THEN  /* YES, IS IT FORWARD CHAIN?     */
         LH    @11,CTKEYLEN(,R6)                                   0704
         BCTR  @11,0                                               0704
         EX    @11,@SC05674                                        0704
         BNE   @RF00704                                            0704
         CR    R9,R7                                               0704
         BNH   @RF00704                                            0704
*                     TEMPLKAR=R9;  /* YES, ESTABLISH NEW NEXT     0705
*                                      POTENTIAL ARDB                */
         LR    TEMPLKAR,R9                                         0705
*                 END;                                             0706
@RF00704 DS    0H                                                  0707
*             END;                                                 0707
@RC00694 DS    0H                                                  0708
*           R9=R9+ARDLEN;           /* NEXT ARDB FOR INNER LOOP      */
@RF00692 AH    R9,ARDLEN(,R9)                                      0708
*         END;                                                     0709
         AL    C3,@CF00053                                         0709
@DE00691 CR    C3,CURKEYNO                                         0709
         BNH   @DL00691                                            0709
*         R7->ARDNPTR=TEMPLKAR;     /* PT TO NEXT ASCENDING ARDB     */
         ST    TEMPLKAR,ARDNPTR(,R7)                               0710
*         R7=R7+R7->ARDLEN;         /* NEXT ARDB FOR OUTER LOOP    0711
*                                                            @YA03778*/
         AH    R7,ARDLEN(,R7)                                      0711
*       END;                                                       0712
         LA    @05,1                                               0712
         AL    @05,C2                                              0712
@DE00688 ST    @05,C2                                              0712
         CR    @05,CURKEYNO                                        0712
         BNH   @DL00688                                            0712
*       ARDBAD=LOKYARDB;            /* PT TO LOWEST ARDB             */
         L     @08,LOKYARDB                                        0713
         ST    @08,ARDBAD                                          0713
*     END;                          /*                       @X04SVCJ*/
*   AMDPARDB=ARDBAD;                /* COPY PTR TO ARDB      @X04SVCJ*/
@RF00685 L     @08,ARDBAD                                          0715
         L     @05,AMDSBAD                                         0715
         ST    @08,AMDPARDB(,@05)                                  0715
*   RESPECIFY                                                      0716
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @08,RETCONT                                         0717
         LR    @05,@08                                             0717
         SLA   @05,2                                               0717
         L     RET,RETSAVE-4(@05)                                  0717
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @08,0                                               0718
         ST    @08,RETCONT                                         0718
*   RESPECIFY                                                      0719
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   END BLDARDB;                    /*                       @X04SVCJ*/
         B     @EL00007                                            0720
*OFLOWSET:                                                         0721
*                                                                  0721
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE SCANS AN AMB CATALOG WORK AREA,       */
*/*               AMBWKA, TO DETERMINE WHICH VOLUME ENTRIES,         */
*/*               CTVOLENT, ARE FOR OVERFLOW VOLUMES                 */
*/*   INPUT -     AMB CATALOG WORK AREA                              */
*/*   OUTPUT -    OVERFLOW VOLUMES ARE MARKED (CTOFLOW)              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0721
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0721
OFLOWSET DS    0H                                                  0722
*   RESPECIFY                                                      0722
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0723
         L     @08,RETCONT                                         0723
         ALR   @08,@15                                             0723
         ST    @08,RETCONT                                         0723
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @08,2                                               0724
         ST    RET,RETSAVE-4(@08)                                  0724
*   RESPECIFY                                                      0725
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   HITHL=OFF;                      /* RESET HI LEVEL HIT BIT        */
*   HITSS=OFF;                      /* RESET SS HIT BIT              */
         NI    HITHL,B'11001111'                                   0727
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);/* PT TO 1ST VOL ENTRY          */
         LA    R6,232                                              0728
         AL    R6,OPWWRKPT(,RCORE)                                 0728
*   DO C2=1 TO VOLENTNO;            /* PROCESS ALL VOL ENTRIES       */
         B     @DE00729                                            0729
@DL00729 DS    0H                                                  0730
*     IF CTINDX=ON THEN             /* AMB FOR INDEX SET             */
         L     @08,OPWWRKPT(,RCORE)                                0730
         TM    CTINDX(@08),B'00010000'                             0730
         BNO   @RF00730                                            0730
*       DO;                         /* YES, DO                       */
*         R7=R6+LENGTH(CTVOLENT);   /* PT FIRST KEY ENTRY            */
         LA    R7,20                                               0732
         ALR   R7,R6                                               0732
*         DO C3=1 TO CTNOKEY;       /* PROCESS ALL KEY ENTRIES       */
         LA    C3,1                                                0733
         B     @DE00733                                            0733
@DL00733 DS    0H                                                  0734
*           IF CTSSWDTA=OFF THEN    /* HIGH LEVEL INDX ENTRY         */
         TM    CTSSWDTA(R7),B'10000000'                            0734
         BNZ   @RF00734                                            0734
*             DO;                   /* YES,                          */
*               IF HITHL=OFF THEN   /* ENCOUNTERED HI LEVEL BEFORE   */
         TM    HITHL,B'00100000'                                   0736
         BNZ   @RF00736                                            0736
*                 HITHL=ON;         /* NO, SET HI LEVEL ON           */
         OI    HITHL,B'00100000'                                   0737
*               ELSE                /* YES,                  @Z30SSRL*/
*                 CTOFLOW=ON;       /* INDICATE OVERFLOW VOL @Z30SSRL*/
         B     @RC00736                                            0738
@RF00736 OI    CTOFLOW(R6),B'01000000'                             0738
*             END;                                                 0739
*           ELSE                    /* SEQ SET INDEX ENTRY   @Z30SSRL*/
*             DO;                                                  0740
         B     @RC00734                                            0740
@RF00734 DS    0H                                                  0741
*               IF HITSS=OFF THEN   /* ENCOUNTERED SEQ SET BEFORE    */
         TM    HITSS,B'00010000'                                   0741
         BNZ   @RF00741                                            0741
*                 HITSS=ON;         /* NO, SET SEQ SET ON            */
         OI    HITSS,B'00010000'                                   0742
*               ELSE                /* YES,                  @Z30SSRL*/
*                 CTOFLOW=ON;       /* INDICATE OVERFLOW VOL @Z30SSRL*/
         B     @RC00741                                            0743
@RF00741 OI    CTOFLOW(R6),B'01000000'                             0743
*             END;                                                 0744
@RC00741 DS    0H                                                  0745
*           R7=R7+LENGTH(CTEXTENT)*CTNOKEXT+LENGTH(CTKEYENT)+CTKEYLEN*
*               K2;                 /* PT TO NEXT KEY ENTRY  @Z30SSRL*/
@RC00734 SLR   @11,@11                                             0745
         IC    @11,CTNOKEXT(,R7)                                   0745
         MH    @11,@CH00443                                        0745
         ALR   @11,R7                                              0745
         AL    @11,@CF00050                                        0745
         LH    @08,CTKEYLEN(,R6)                                   0745
         ALR   @08,@08                                             0745
         ALR   @11,@08                                             0745
         LR    R7,@11                                              0745
*         END;                                                     0746
         AL    C3,@CF00053                                         0746
@DE00733 CH    C3,CTNOKEY(,R6)                                     0746
         BNH   @DL00733                                            0746
*       END;                                                       0747
*     ELSE                          /* AMB NOT FOR INDEX SET @Z30SSRL*/
*       DO;                                                        0748
         B     @RC00730                                            0748
@RF00730 DS    0H                                                  0749
*         IF C2^=K1 THEN            /* 1ST VOL ENTRY         @Z30SSRL*/
         CLC   C2(4),@CF00053                                      0749
         BE    @RF00749                                            0749
*           CTOFLOW=ON;             /* NO, INDICATE OVERFLOW VOL     */
         OI    CTOFLOW(R6),B'01000000'                             0750
*       END;                                                       0751
@RF00749 DS    0H                                                  0752
*     R6=R6+LENGTH(CTVOLENT)+(LENGTH(CTKEYENT)+CTKEYLEN*K2)*CTNOKEY+
*         LENGTH(CTEXTENT)*CTNOEXT; /* PT TO NEXT VOL ENTRY          */
@RC00730 LA    @08,20                                              0752
         LR    @05,R6                                              0752
         ALR   @05,@08                                             0752
         LH    @01,CTKEYLEN(,R6)                                   0752
         ALR   @01,@01                                             0752
         AL    @01,@CF00050                                        0752
         MH    @01,CTNOKEY(,R6)                                    0752
         ALR   @05,@01                                             0752
         LR    @01,@08                                             0752
         SLR   @08,@08                                             0752
         IC    @08,CTNOEXT(,R6)                                    0752
         MR    @00,@08                                             0752
         ALR   @05,@01                                             0752
         LR    R6,@05                                              0752
*   END;                                                           0753
         LA    @15,1                                               0753
         AL    @15,C2                                              0753
@DE00729 ST    @15,C2                                              0753
         L     @08,OPWWRKPT(,RCORE)                                0753
         CH    @15,VOLENTNO(,@08)                                  0753
         BNH   @DL00729                                            0753
*   RESPECIFY                                                      0754
*    (R6,                                                          0754
*     R7,                                                          0754
*     R9) UNRSTD;                   /*                       @X04SVCJ*/
*   RESPECIFY                                                      0755
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @05,RETCONT                                         0756
         LR    @15,@05                                             0756
         SLA   @15,2                                               0756
         L     RET,RETSAVE-4(@15)                                  0756
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @05,0                                               0757
         ST    @05,RETCONT                                         0757
*   RESPECIFY                                                      0758
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   END OFLOWSET;                                                  0759
@EL00008 DS    0H                                                  0759
@EF00008 DS    0H                                                  0759
@ER00008 BR    @14                                                 0759
*CHNBLKS:                                                          0760
*                                                                  0760
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE CHAINS ALL THE CONTROL BLOCKS TOGETHER*/
*/*   INPUT -     1. CONTROL BLOCK ADDRESSES IN CBTAB                */
*/*               2. ACB ADDRESS IN RACB                             */
*/*   OUTPUT -    ALL REMAINING CHAINING IS DONE                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0760
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0760
CHNBLKS  DS    0H                                                  0761
*   RESPECIFY                                                      0761
*    (RET,                                                         0761
*     R7,                           /*                       @ZA27961*/
*     R8,                           /*                       @ZA27961*/
*     R6) RSTD;                     /*                       @ZA03933*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0762
         AL    @15,RETCONT                                         0762
         ST    @15,RETCONT                                         0762
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0763
         ST    RET,RETSAVE-4(@15)                                  0763
*   RESPECIFY                                                      0764
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   RESPECIFY                                                      0765
*     IDADIWA BASED(AMBIWA);                                       0765
*   RESPECIFY                                                      0766
*     IDAAMDSB BASED(AMBDSB);                                      0766
*   RESPECIFY                                                      0767
*     IDABSPH BASED(R6);            /*                       @X04SVGP*/
*   RESPECIFY                                                      0768
*     IDAVAT BASED(JSCBSHR);        /*                       @Z30SSDT*/
*   RESPECIFY                                                      0769
*     IDAVSRT BASED(VSRTAD);        /*                       @Z30SSDT*/
*   RESPECIFY                                                      0770
*     IDALPMB BASED(LPMBAD);        /*                       @ZA27961*/
*   IF ACBLSR=ON THEN               /* LOCAL SHARED RESOURCES      0771
*                                                            @Z30SSDT*/
         TM    ACBLSR(RACB),B'01000000'                            0771
         BNO   @RF00771                                            0771
*     DO;                           /*                       @Z30SSDT*/
*       VSRTAD=VATVPTR;             /* GET ADDRESS OF VSRT   @Z30SSDT*/
         L     @09,PSATOLD                                         0773
         L     @09,TCBJSCB(,@09)                                   0773
         L     @09,JSCBSHR(,@09)                                   0773
         L     VSRTAD,VATVPTR(,@09)                                0773
*       AMBLSR=ON;                  /* INDICATE LSR          @Z30SSDT*/
         L     @09,AMBP                                            0774
         OI    AMBLSR(@09),B'01000000'                             0774
*     END;                          /*                       @Z30SSDT*/
*   ELSE                            /* GLOBAL SHARED RESOURCES     0776
*                                                            @Z30SSDT*/
*     DO;                           /*                       @Z30SSDT*/
         B     @RC00771                                            0776
@RF00771 DS    0H                                                  0777
*       VSRTAD=CBSVPTR((DXUKEY/K16)+K1);/* GET ADDR OF VSRT  @Z40ESSR*/
         L     @09,OPWCOMWA(,RCORE)                                0777
         SLR   @15,@15                                             0777
         IC    @15,DXUKEY(,@09)                                    0777
         SRL   @15,4                                               0777
         SLA   @15,3                                               0777
         L     @09,FLCCVT                                          0777
         L     @09,CVTCBSP(,@09)                                   0777
         L     VSRTAD,CBSVPTR(@15,@09)                             0777
*       AMBGSR=ON;                  /* INDICATE GSR          @Z30SSDT*/
         L     @09,AMBP                                            0778
         OI    AMBGSR(@09),B'00100000'                             0778
*     END;                          /*                       @Z30SSDT*/
*   IF AMBTYPE=AMBINDEX             /* INDEX AMB             @ZA27961*/
*       &AMDSDT=ON THEN             /* SEQUENCE SET W/DATA   @ZA27961*/
@RC00771 L     @09,AMBP                                            0780
         TM    AMBTYPE(@09),B'01000000'                            0780
         BNO   @RF00780                                            0780
         L     @09,AMBDSB(,@09)                                    0780
         TM    AMDSDT(@09),B'00100000'                             0780
         BNO   @RF00780                                            0780
*     DO;                           /* FIND MAX SIZE         @ZA27961*/
*       R7=MIN(LPMBLKSZ,(ADDR(IDALPMB)+LPMBLEN)->LPMBLKSZ);/* GET  0782
*                                      MINIMUM INDEX BLKSIZE @ZA27961*/
         L     @15,LPMBAD                                          0782
         L     @14,LPMBLKSZ(,@15)                                  0782
         LH    @11,LPMBLEN(,@15)                                   0782
         ALR   @11,@15                                             0782
         L     @15,LPMBLKSZ(,@11)                                  0782
         LR    R7,@15                                              0782
         CR    R7,@14                                              0782
         BNH   *+6
         LR    R7,@14                                              0782
*       R7=AMDCINV/R7;              /* ESTABLISH BLOCKS/CI   @ZA27961*/
         L     @00,AMDCINV(,@09)                                   0783
         SRDA  @00,32                                              0783
         DR    @00,R7                                              0783
         LR    R7,@01                                              0783
*       R6=MAX(CTSBLKTR,CTBLKTR,R7);/* MAXIMUM NO. BLOCKS    @ZA27961*/
         L     @09,OPWWRKPT(,RCORE)                                0784
         L     R6,CTSBLKTR(,@09)                                   0784
         L     @09,CTBLKTR(,@09)                                   0784
         CR    R6,@09                                              0784
         BNL   *+6
         LR    R6,@09                                              0784
         CR    R6,R7                                               0784
         BNL   *+6
         LR    R6,R7                                               0784
*       R8=MAX(LPMBLKSZ,            /* GREATER OF BLOCKSIZES @ZA27961*/
*           (ADDR(IDALPMB)+LPMBLEN)->LPMBLKSZ);/* - INDEX    @ZA27961*/
         CR    @14,@15                                             0785
         BNL   *+6
         LR    @14,@15                                             0785
         LR    R8,@14                                              0785
*     END;                          /*                       @ZA27961*/
*   ELSE                            /* NORMAL PATH           @ZA27961*/
*     DO;                           /* FIND MAX VALUE        @ZA27961*/
         B     @RC00780                                            0787
@RF00780 DS    0H                                                  0788
*       R7=AMDCINV/LPMBLKSZ;        /* ESTABLISH BLOCKS/CI   @ZA27961*/
         L     @09,AMBP                                            0788
         L     @09,AMBDSB(,@09)                                    0788
         L     @15,LPMBAD                                          0788
         L     @14,LPMBLKSZ(,@15)                                  0788
         L     @00,AMDCINV(,@09)                                   0788
         SRDA  @00,32                                              0788
         DR    @00,@14                                             0788
         LR    R7,@01                                              0788
*       R6=MAX(LPMBLKTR,R7);        /* MAXIMUM NO. BLOCKS    @ZA27961*/
         LH    R6,LPMBLKTR(,@15)                                   0789
         CR    R6,R7                                               0789
         BNL   *+6
         LR    R6,R7                                               0789
*       R8=LPMBLKSZ;                /* GET BLOCKSIZE         @ZA27961*/
         LR    R8,@14                                              0790
*     END;                          /* END - NORMAL PATH     @ZA27961*/
*                                                                  0791
*   /*****************************************************************/
*   /*                                                               */
*   /* GET MAXIMUM SIZE OF VPL (OR IDAL) REQUIRED            @ZA27961*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0792
*   R8=(R8+IOPAGESZ-1)&-IOPAGESZ;   /* ROUND UP              @ZA27961*/
@RC00780 LR    @09,R8                                              0792
         SL    @09,@CF05649                                        0792
         N     @09,@CF05650                                        0792
         LR    R8,@09                                              0792
*   R8=(R8/IOPAGESZ+1)*K4;          /* VPL/IDAL SIZE/BLOCK   @ZA27961*/
         LR    @09,R8                                              0793
         SRL   @09,11                                              0793
         AL    @09,@CF00053                                        0793
         SLA   @09,2                                               0793
         LR    R8,@09                                              0793
*   R8=(R8*R7);                     /* VPL/IDAL TOTAL SIZE   @ZA27961*/
*                                                                  0794
         LR    @01,R7                                              0794
         MR    @00,R8                                              0794
         LR    R8,@01                                              0794
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SIZE FOR THE CHANNEL PROGRAM HEADER INCLUDES THE MAXIMUM  */
*   /* SIZE REQUIRED FOR IDAL(S), VPL(S), AND THE SEARCH ID EQUAL    */
*   /* ARGUMENTS AND COUNT FIELDS FOR THE FORMAT WRITE.      @ZA27961*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0795
*   AMBSZCP=LENGTH(IDACPA)          /* SET LENGTH OF BASE SECTION  0795
*                                                            @ZA27961*/
*       +(K2*R8)                    /* ADD IDAL PLUS VPL     @ZA27961*/
*       +((R7*K5+K4-1)&-K4)         /* ADD SEARCH ID ARGUMENT FOR  0795
*                                      WORST CASE FMT WRITE  @ZA27961*/
*       +(R6*K8);                   /* ADD COUNT FIELDS FOR FORMAT-
*                                      WRITE CHANNEL PROGRAM @ZA27961*/
*                                                                  0795
         L     @09,AMBP                                            0795
         LR    @15,R8                                              0795
         ALR   @15,@15                                             0795
         AL    @15,@CF02710                                        0795
         LA    @14,5                                               0795
         LR    @01,R7                                              0795
         MR    @00,@14                                             0795
         SL    @01,@CF05648                                        0795
         N     @01,@CF05651                                        0795
         ALR   @15,@01                                             0795
         LR    @11,R6                                              0795
         SLA   @11,3                                               0795
         ALR   @15,@11                                             0795
         STH   @15,AMBSZCP(,@09)                                   0795
*   /*****************************************************************/
*   /*                                                               */
*   /* SIZE OF THE READ CHANNEL PROGRAM (AMBSZRD) . . . . . . . . . .*/
*   /* FIVE BASE CCWS (SEEK, SET SECTOR, SID, TIC, AND NOP           */
*   /* REPRESENTED BY K5) PLUS ONE READ PER BLOCK (R6). THE MAXIMUM  */
*   /* NUMBER OF BLOCKS IS USED SINCE THE READ CHANNEL PROGRAM SIZE  */
*   /* IS USED FOR THE WRITE CHECK CHANNEL PROGRAM FOR WRITE AND     */
*   /* FORMAT WRITE REQUESTS.                                @ZA27961*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0796
*   AMBSZRD=(R6+K5)*K8;             /* SET LENGTH OF READ CCWS     0796
*                                                            @ZA27961*/
*                                                                  0796
         ALR   @14,R6                                              0796
         SLA   @14,3                                               0796
         STH   @14,AMBSZRD(,@09)                                   0796
*   /*****************************************************************/
*   /*                                                               */
*   /* SIZE OF THE UPDATE WRITE CHANNEL PROGRAM (AMBSZWR) . . . . . .*/
*   /* THREE BASE CCWS (SEEK, SET SECTOR, AND NOP REPRESENTED BY K3) */
*   /* PLUS A SID, TIC, WRITE DATA FOR EACH BLOCK IN A CI.   @ZA27961*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0797
*   AMBSZWR=(K3*R7+K3)*K8;          /* SET LENGTH            @ZA27961*/
*                                                                  0797
         LA    @15,3                                               0797
         LR    @01,R7                                              0797
         MR    @00,@15                                             0797
         ALR   @01,@15                                             0797
         SLA   @01,3                                               0797
         STH   @01,AMBSZWR(,@09)                                   0797
*   /*****************************************************************/
*   /*                                                               */
*   /* SIZE OF THE FORMAT WRITE CHANNEL PROGRAM (AMBSZFW) . . . . . .*/
*   /* THREE BASE CCWS (SEEK, SET SECTOR, AND NOP REPRESENTED BY K3) */
*   /* PLUS TWO WCKD CCWS PER BLOCK, THE FIRST DATA CHAINED TO THE   */
*   /* SECOND (K2*R6). ADDITIONAL SPACE IS ALLOWED FOR A WORST CASE  */
*   /* SITUATION OF A SID AND TIC PER BLOCK FOR A CONTROL INTERVAL   */
*   /* WITH MULTIPLE PHYSICAL BLOCKS (K2*R7).                @ZA27961*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0798
*   AMBSZFW=(K2*(R6+R7)+K3)*K8;     /* SET LENGTH WORST CASE @ZA27961*/
         LR    @14,R6                                              0798
         ALR   @14,R7                                              0798
         ALR   @14,@14                                             0798
         ALR   @14,@15                                             0798
         SLA   @14,3                                               0798
         STH   @14,AMBSZFW(,@09)                                   0798
*   RESPECIFY                                                      0799
*     R7 UNRESTRICTED;              /* RELEASE WORK REGISTER @ZA27961*/
*   R6=VSRTBUFH;                    /* PT 1ST BFR SP HDR     @X04SVGP*/
         L     R6,VSRTBUFH(,VSRTAD)                                0800
*   DO WHILE BSPHBSZ<AMDCINV&R6^=K0;/* FIND BFR SP           @Z30SSDT*/
         B     @DE00801                                            0801
@DL00801 DS    0H                                                  0802
*     R6=BSPHNBSP;                  /* CHAIN NXT BFR SP      @X04SVGP*/
         L     R6,BSPHNBSP(,R6)                                    0802
*   END;                            /*                       @X04SVGP*/
@DE00801 L     @09,AMBP                                            0803
         L     @09,AMBDSB(,@09)                                    0803
         L     @07,BSPHBSZ(,R6)                                    0803
         C     @07,AMDCINV(,@09)                                   0803
         BNL   @DC00801                                            0803
         LTR   R6,R6                                               0803
         BNZ   @DL00801                                            0803
@DC00801 DS    0H                                                  0804
*   IF R6=K0 THEN                   /* FIND BFR SP           @Z30SSDT*/
         LTR   R6,R6                                               0804
         BNZ   @RF00804                                            0804
*     DO;                           /*                       @X04SVGP*/
*       PPCODE=PP120;               /* NO, SET PROB CODE     @X04SVGP*/
         L     @09,SABWRD(,R13)                                    0806
         MVI   PPCODE(@09),X'78'                                   0806
*       RETURN TO EXIT;             /* EXIT MODULE           @X04SVCJ*/
         LA    @14,EXIT                                            0807
@EL00009 DS    0H                                                  0807
@EF00009 DS    0H                                                  0807
@ER00009 BR    @14                                                 0807
*     END;                          /*                       @X04SVGP*/
*   AMBBUFC=R6;                     /* AMB PTS TO BFR SP HDR @X04SVGP*/
@RF00804 L     @09,AMBP                                            0809
         ST    R6,AMBBUFC(,@09)                                    0809
*   IF ACBDFR=ON THEN               /* DEFER SPECIFIED       @Z30SSDT*/
         TM    ACBDFR(RACB),B'00001000'                            0810
         BNO   @RF00810                                            0810
*     AMBDFR=ON;                    /* YES, SET ON IN AMB    @Z30SSDT*/
         OI    AMBDFR(@09),B'00001000'                             0811
*   AMBCPA=VSRTCPAH;                /* AMB PTS TO CPA HDR    @Z30SSDT*/
@RF00810 L     @09,AMBP                                            0812
         L     @07,VSRTCPAH(,VSRTAD)                               0812
         ST    @07,AMBCPA(,@09)                                    0812
*   AMBWSHD=VSRTWAH;                /* AMB PTS TO WS HDR     @Z30SSDT*/
         L     @07,VSRTWAH(,VSRTAD)                                0813
         ST    @07,AMBWSHD(,@09)                                   0813
*   AMBUPLH=VSRTPLHH;               /* INIT UPGRADE PLH PTR  @Z30SSDT*/
         L     @07,VSRTPLHH(,VSRTAD)                               0814
         ST    @07,AMBUPLH(,@09)                                   0814
*   AMBPH=VSRTPLHH;                 /* AMB PTS TO PLH POOL   @Z30SSDT*/
         ST    @07,AMBPH(,@09)                                     0815
*   RESPECIFY                                                      0816
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @09,RETCONT                                         0817
         LR    @07,@09                                             0817
         SLA   @07,2                                               0817
         L     RET,RETSAVE-4(@07)                                  0817
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @09,0                                               0818
         ST    @09,RETCONT                                         0818
*   RESPECIFY                                                      0819
*    (RET,                                                         0819
*     R8,                           /*                       @ZA27961*/
*     R6) UNRSTD;                   /*                       @X04SVCJ*/
*   END CHNBLKS;                                                   0820
         B     @EL00009                                            0820
*BLDEDB:                                                           0821
*                                                                  0821
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS THE EDBS                       */
*/*   INPUT -        CATALOG WORK AREA (AMBWKA)                      */
*/*   OUTPUT -    1. EDBS ARE BUILT                          @Z30SSDT*/
*/*               2. EDBAD IS SET TO ADDRESS OF EDB HEADER   @Z30SSDT*/
*/*               3. CUREXTNO IS SET TO NUMBER OF EXTENTS            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0821
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0821
BLDEDB   DS    0H                                                  0822
*   RESPECIFY                                                      0822
*    (RET,                                                         0822
*     R6,                                                          0822
*     R7,                                                          0822
*     R8,                                                          0822
*     R9) RSTD;                     /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0823
         L     @11,RETCONT                                         0823
         ALR   @11,@15                                             0823
         ST    @11,RETCONT                                         0823
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @11,2                                               0824
         ST    RET,RETSAVE-4(@11)                                  0824
*   RESPECIFY                                                      0825
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);                              0826
         LA    R6,232                                              0826
         AL    R6,OPWWRKPT(,RCORE)                                 0826
*   RESPECIFY                                                      0827
*     CTVOLENT BASED(R6);           /* BASE FOR VOL ENT              */
*   RESPECIFY                                                      0828
*     CTKEYENT BASED(R7);           /* BASE FOR KEY ENT              */
*   RESPECIFY                                                      0829
*     CTEXTENT BASED(R8);           /* BASE FOR EXTENT ENT           */
*   CUREXTNO=K0;                    /* ZERO EXTENT COUNT     @Z30SSRL*/
         SLR   CUREXTNO,CUREXTNO                                   0830
*   DO C2=1 TO VOLENTNO;            /* CALC NBR OF EXTS IN EDB       */
         B     @DE00831                                            0831
@DL00831 DS    0H                                                  0832
*     IF CTVOLMT=ON THEN            /* IS VOLUME MOUNTED             */
         TM    CTVOLMT(R6),B'10000000'                             0832
         BNO   @RF00832                                            0832
*       CUREXTNO=CUREXTNO+CTNOEXT;  /* INCLUDE EXTENTS THIS VOLUME   */
         SLR   @15,@15                                             0833
         IC    @15,CTNOEXT(,R6)                                    0833
         ALR   CUREXTNO,@15                                        0833
*     R6=R6+LENGTH(CTVOLENT)+(LENGTH(CTKEYENT)+CTKEYLEN*K2)*CTNOKEY+
*         LENGTH(CTEXTENT)*CTNOEXT; /* POINT TO NEXT VOLENT          */
@RF00832 LA    @15,20                                              0834
         LR    @14,R6                                              0834
         ALR   @14,@15                                             0834
         LH    @01,CTKEYLEN(,R6)                                   0834
         ALR   @01,@01                                             0834
         AL    @01,@CF00050                                        0834
         MH    @01,CTNOKEY(,R6)                                    0834
         ALR   @14,@01                                             0834
         ST    @14,@TF00001                                        0834
         SLR   @11,@11                                             0834
         IC    @11,CTNOEXT(,R6)                                    0834
         MR    @14,@11                                             0834
         AL    @15,@TF00001                                        0834
         LR    R6,@15                                              0834
*   END;                                                           0835
*                                                                  0835
         LA    @15,1                                               0835
         AL    @15,C2                                              0835
@DE00831 ST    @15,C2                                              0835
         L     @14,OPWWRKPT(,RCORE)                                0835
         CH    @15,VOLENTNO(,@14)                                  0835
         BNH   @DL00831                                            0835
*   /*****************************************************************/
*   /*                                                               */
*   /* SET SIZE OF EDB = EDB HEADER PLUS EXTENTS             @Z30SSDT*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0836
*   OPWVMLNG=LENGTH(IDAEDBHD)+LENGTH(IDAEDB)*CUREXTNO;/*     @Z30SSDT*/
         LR    @15,CUREXTNO                                        0836
         MH    @15,@CH00118                                        0836
         AL    @15,@CF00038                                        0836
         STCM  @15,7,OPWVMLNG(RCORE)                               0836
*   OPWVMFLG=ZERO;                  /* ZERO FLAG FIELD       @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0837
*   OPWVMTYP=EDBBLK;                /* SET BLOCK TYPE        @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'0A'                               0838
*   OPWVMANC=ADDR(IDACMB);          /* SET ANCHOR BLOCK ADDR @X04SVCJ*/
         L     @01,ACBAMBL(,RACB)                                  0839
         L     @15,AMBLCMB(,@01)                                   0839
         ST    @15,OPWVMANC(,RCORE)                                0839
*   CALL IDA0192M;                  /* GET CORE FOR EDB      @X04SVCJ*/
         L     @15,@CV05525                                        0840
         BALR  @14,@15                                             0840
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @01,OPWCOMWA(,RCORE)                                0841
         MVC   RSTATRTN(4,@01),@CC05338                            0841
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @15,OPWVMADR(,RCORE)                                0842
         LTR   @15,@15                                             0842
         BNZ   @RF00842                                            0842
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* INDICATE GETMAIN FAIL @X04SVCJ*/
         L     @05,SABWRD(,R13)                                    0844
         MVI   PPCODE(@05),X'14'                                   0844
*       RETURN TO EXIT;             /* TERMINATE             @X04SVCJ*/
         LA    @14,EXIT                                            0845
@EL00010 DS    0H                                                  0845
@EF00010 DS    0H                                                  0845
@ER00010 BR    @14                                                 0845
*     END;                          /*                       @X04SVCJ*/
*   EDBAD=OPWVMADR;                 /* SAVE PTR TO EDB       @X04SVCJ*/
@RF00842 L     @10,OPWVMADR(,RCORE)                                0847
         ST    @10,EDBAD                                           0847
*   R9=EDBAD;                       /* LOAD PTR TO EDB               */
         LR    R9,@10                                              0848
*   RESPECIFY                                                      0849
*     IDAEDBHD BASED(R9);           /* BASE FOR EDB HEADER           */
*   EDBID=IDXEDB;                   /* SET ID                        */
         MVI   EDBID(R9),X'90'                                     0850
*   EDBNO=CUREXTNO;                 /* INIT NO EXTS FOR THE EDB      */
         STC   CUREXTNO,EDBNO(,R9)                                 0851
*   EDBLEN=LENGTH(IDAEDB);          /* INIT EDB LENGTH               */
         MVC   EDBLEN(2,R9),@CH00118                               0852
*   EDBLPMBC=LPMBAD;                /* POINT TO LPMB         @X04SVCJ*/
         L     @10,LPMBAD                                          0853
         ST    @10,EDBLPMBC(,R9)                                   0853
*   R9=R9+LENGTH(IDAEDBHD);         /* POINT TO 1ST EDB              */
         AL    R9,@CF00038                                         0854
*   RESPECIFY                                                      0855
*     IDAEDB BASED(R9);                                            0855
*   RESPECIFY                                                      0856
*     IDALPMB BASED(CURLPMB);                                      0856
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);/* PTS TO 1ST VOLUME ENTRY      */
         LA    R6,232                                              0857
         AL    R6,OPWWRKPT(,RCORE)                                 0857
*   C5=K0;                          /* INIT EDB COUNTER      @Z30SSDT*/
         SLR   C5,C5                                               0858
*   DO C2=K1 TO VOLENTNO;           /* PROCESS ALL VOLUME ENTRIES    */
         LA    @10,1                                               0859
         B     @DE00859                                            0859
@DL00859 DS    0H                                                  0860
*     R7=R6+LENGTH(CTVOLENT);       /* R7 PTS TO 1ST KEY RANGE ENTRY
*                                      FOR THIS VOLUME ENTRY         */
         LA    R7,20                                               0860
         ALR   R7,R6                                               0860
*     DO C3=K1 TO CTNOKEY;          /* PROCESS ALL KEY RANGES        */
         LA    C3,1                                                0861
         B     @DE00861                                            0861
@DL00861 DS    0H                                                  0862
*       IF CTINDXSS=ON&             /* IF SS/D FOR INDEX AND @Z30SSDT*/
*           CTSSWDTA=ON THEN        /* SEQ SET EXTENT        @Z30SSDT*/
         L     @01,OPWWRKPT(,RCORE)                                0862
         TM    CTINDXSS(@01),B'00100000'                           0862
         BNO   @RF00862                                            0862
         TM    CTSSWDTA(R7),B'10000000'                            0862
         BNO   @RF00862                                            0862
*         CURLPMB=LPMBAD+LPMBLEN;   /* YES, PT TO SS LPMB    @Z30SSDT*/
         L     @01,CURLPMB                                         0863
         LH    @15,LPMBLEN(,@01)                                   0863
         AL    @15,LPMBAD                                          0863
         ST    @15,CURLPMB                                         0863
*       ELSE                        /* NO,                   @Z30SSRL*/
*         CURLPMB=LPMBAD;           /* PT TO NON SS LPMB     @Z30SSRL*/
         B     @RC00862                                            0864
@RF00862 L     @15,LPMBAD                                          0864
         ST    @15,CURLPMB                                         0864
*       R8=ADDR(CTKEY)+CTKEYLEN*K2; /* R8 PTS TO 1ST EXT ENTRY       */
@RC00862 LA    R8,CTKEY(,R7)                                       0865
         LH    @15,CTKEYLEN(,R6)                                   0865
         ALR   @15,@15                                             0865
         ALR   R8,@15                                              0865
*       DO C4=K1 TO CTNOKEXT;       /* PROCESS ALL EXTENT ENTRIES    */
         LA    @15,1                                               0866
         B     @DE00866                                            0866
@DL00866 DS    0H                                                  0867
*         IF CTVOLMT=ON THEN        /* IF VOLUME IS MOUNTED  @Z30SSDT*/
         TM    CTVOLMT(R6),B'10000000'                             0867
         BNO   @RF00867                                            0867
*           DO;                     /*                       @Z30SSDT*/
*             EDBM=C5;              /* SET EDB NUMBER                */
         STC   C5,EDBM(,R9)                                        0869
*             C5=C5+K1;             /* BUMB EDB COUNTER      @Z30SSDT*/
         AL    C5,@CF00053                                         0870
*             EDBLPMBA=CURLPMB;     /* INIT LPMB PTR                 */
         L     @15,CURLPMB                                         0871
         ST    @15,EDBLPMBA(,R9)                                   0871
*             EDBLORBA=CTRBABEG;    /* INIT LOW RBA THIS EXTENT      */
         MVC   EDBLORBA(4,R9),CTRBABEG(R8)                         0872
*             EDBHIRBA=CTRBAEND;    /* INIT HI RBA THIS EXTENT       */
         MVC   EDBHIRBA(4,R9),CTRBAEND(R8)                         0873
*             EDBSTTRK=CTCCBEG*LPMTPC+CTHHBEG;/* INIT REL TRK ADDR   */
         SLR   @14,@14                                             0874
         ICM   @14,3,CTCCBEG(R8)                                   0874
         MH    @14,LPMTPC(,@15)                                    0874
         SLR   @15,@15                                             0874
         ICM   @15,3,CTHHBEG(R8)                                   0874
         ALR   @14,@15                                             0874
         ST    @14,EDBSTTRK(,R9)                                   0874
*             IF CTTOVFL=ON THEN    /* IF TRACK OVERFLOW     @Z30SSRL*/
         L     @15,OPWWRKPT(,RCORE)                                0875
         TM    CTTOVFL(@15),B'00000001'                            0875
         BNO   @RF00875                                            0875
*               DO;                                                0876
*                 EDBTKBAL=CTBYTTRK;/* RECORD TRK BALANCE    @Z30SSRL*/
         L     @15,CTBYTTRK(,@15)                                  0877
         ST    @15,EDBTKBAL(,R9)                                   0877
*                 EDBTOFLW=ON;      /* INDICATE TRK OVERFLOW @Z30SSRL*/
         OI    EDBTOFLW(R9),B'01000000'                            0878
*               END;                                               0879
*             IF OPWPSDS=ON THEN    /* PAGE SPACE DATA SET   @Z30SSRL*/
@RF00875 TM    OPWPSDS(RCORE),B'00000001'                          0880
         BNO   @RF00880                                            0880
*               EDBPSDS=ON;         /* INDICATE PSDS IN EDB  @Z30SSRL*/
         OI    EDBPSDS(R9),B'00100000'                             0881
*             IF LOKYARDB->ARDKEYS(1:CTKEYLEN)/* IF ARDB LOW KEY   0882
*                                      RANGE                 @Z30SSRL*/
*                 =CTKEY(1:CTKEYLEN) THEN/* EQUALS CURRENT KEY RANGE
*                                                            @Z30SSRL*/
@RF00880 LH    @15,CTKEYLEN(,R6)                                   0882
         BCTR  @15,0                                               0882
         L     @01,LOKYARDB                                        0882
         EX    @15,@SC05678                                        0882
         BNE   @RF00882                                            0882
*               EDBLKR=ON;          /* INDICATE LOW KEY RANGE      0883
*                                                            @Z30SSRL*/
         OI    EDBLKR(R9),B'10000000'                              0883
*             ELSE                  /* NOT LOW KEY RANGE     @Z30SSRL*/
*               EDBLKR=OFF;         /* IND NOT LOW KEY RANGE @Z30SSRL*/
         B     @RC00882                                            0884
@RF00882 NI    EDBLKR(R9),B'01111111'                              0884
*             IF AMDSDT=ON&         /* IF SS/DATA                    */
*                 CTINDX^=ON THEN   /* IF DATA AMB                   */
@RC00882 L     @01,AMBP                                            0885
         L     @01,AMBDSB(,@01)                                    0885
         TM    AMDSDT(@01),B'00100000'                             0885
         BNO   @RF00885                                            0885
         L     @01,OPWWRKPT(,RCORE)                                0885
         TM    CTINDX(@01),B'00010000'                             0885
         BO    @RF00885                                            0885
*               EDBSTTRK=EDBSTTRK+K1;/* DATA STARTS ON NEXT TRACK    */
         LA    @15,1                                               0886
         AL    @15,EDBSTTRK(,R9)                                   0886
         ST    @15,EDBSTTRK(,R9)                                   0886
*             R9=R9+LENGTH(IDAEDB); /* PT TO NEXT EDB                */
@RF00885 AL    R9,@CF00118                                         0887
*           END;                                                   0888
*         R8=R8+LENGTH(CTEXTENT);   /* PT TO NEXT ENTRY      @Z30SSDT*/
@RF00867 AL    R8,@CF00443                                         0889
*       END;                        /*                       @Z30SSDT*/
         LA    @15,1                                               0890
         AL    @15,C4                                              0890
@DE00866 ST    @15,C4                                              0890
         SLR   @14,@14                                             0890
         IC    @14,CTNOKEXT(,R7)                                   0890
         CR    @15,@14                                             0890
         BNH   @DL00866                                            0890
*       R7=R8;                      /* R7 PTS TO NEXT KEY RANGE ENT  */
         LR    R7,R8                                               0891
*     END;                          /*                       @Z30SSDT*/
         AL    C3,@CF00053                                         0892
@DE00861 CH    C3,CTNOKEY(,R6)                                     0892
         BNH   @DL00861                                            0892
*     R6=R8;                        /* PT TO NEXT VOL ENT            */
         LR    R6,R8                                               0893
*   END;                                                           0894
         LA    @10,1                                               0894
         AL    @10,C2                                              0894
@DE00859 ST    @10,C2                                              0894
         L     @01,OPWWRKPT(,RCORE)                                0894
         CH    @10,VOLENTNO(,@01)                                  0894
         BNH   @DL00859                                            0894
*   AMBEDB=EDBAD;                   /* COPY EDB ADDRESS      @X04SVCJ*/
         L     @15,EDBAD                                           0895
         L     @14,AMBP                                            0895
         ST    @15,AMBEDB(,@14)                                    0895
*   RESPECIFY                                                      0896
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @15,RETCONT                                         0897
         LR    @11,@15                                             0897
         SLA   @11,2                                               0897
         L     RET,RETSAVE-4(@11)                                  0897
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @15,0                                               0898
         ST    @15,RETCONT                                         0898
*   RESPECIFY                                                      0899
*    (RET,                                                         0899
*     R6,                                                          0899
*     R7,                                                          0899
*     R8,                                                          0899
*     R9) UNRSTD;                   /*                       @Z30SSDT*/
*   END BLDEDB;                                                    0900
         B     @EL00010                                            0900
*BLDRDEB:                                                          0901
*                                                                  0901
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS DEBS FOR AMBS                  */
*/*   INPUT -     1. CUREXTNO FROM BLDEDB                            */
*/*               2. EXTENT INFORMATION FOR CATALOG WORK AREA        */
*/*   OUTPUT -    1. DEB IS BUILT                                    */
*/*               2. ADDRESS OF DEB IS SET IN DEBAD                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0901
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0901
BLDRDEB  DS    0H                                                  0902
*   RESPECIFY                                                      0902
*    (RET,                                                         0902
*     RDEB,                                                        0902
*     R6,                                                          0902
*     R7,                                                          0902
*     R8,                                                          0902
*     R9) RSTD;                     /*                       @Z30SSDT*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0903
         AL    @15,RETCONT                                         0903
         ST    @15,RETCONT                                         0903
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0904
         ST    RET,RETSAVE-4(@15)                                  0904
*   RESPECIFY                                                      0905
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*                                                                  0905
*   /*****************************************************************/
*   /*                                                               */
*   /* CALCULATE LENGTH OF DEB PROPER PLUS AVT AND PREFIX    @Z30SSDT*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0906
*   R6=LENGTH(DEBAVT)+LENGTH(DEBPREFX)+/* AVT & PREFIX PLUS  @Z30SSJH*/
*       LENGTH(DEBBASIC)+LENGTH(DEBDASD)*CUREXTNO;/* DEB PROPER      */
         LR    R6,CUREXTNO                                         0906
         SLA   R6,4                                                0906
         AL    R6,@CF02824                                         0906
*   R6=(R6+K7)&-DWORDLEN;           /* ROUND TO A DBL WORD   @Z30SSRL*/
         LA    @10,7                                               0907
         ALR   @10,R6                                              0907
         N     @10,@CF05652                                        0907
         LR    R6,@10                                              0907
*   OPWVMLNG=R6+(DXDEBXAD->DEBXLNGH);/* ADD EXTENSION LNGTH  @Z30SSJH*/
         L     @10,OPWCOMWA(,RCORE)                                0908
         L     @10,DXDEBXAD(,@10)                                  0908
         LR    @15,R6                                              0908
         AH    @15,DEBXLNGH(,@10)                                  0908
         STCM  @15,7,OPWVMLNG(RCORE)                               0908
*   OPWVMTYP=DEBBLK;                /* SET BLOCK TYPE        @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'09'                               0909
*   OPWVMANC=ADDR(IDACMB);          /* SET ADDR OF ANCHOR BLOCK    0910
*                                                            @X04SVCJ*/
         L     @10,ACBAMBL(,RACB)                                  0910
         L     @10,AMBLCMB(,@10)                                   0910
         ST    @10,OPWVMANC(,RCORE)                                0910
*   OPWVMFLG=ZERO;                  /* RESET FLAGS           @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               0911
*   CALL IDA0192M;                  /* GET CORE FOR DEB      @X04SVCJ*/
         L     @15,@CV05525                                        0912
         BALR  @14,@15                                             0912
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSDT*/
         L     @10,OPWCOMWA(,RCORE)                                0913
         MVC   RSTATRTN(4,@10),@CC05338                            0913
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @10,OPWVMADR(,RCORE)                                0914
         LTR   @10,@10                                             0914
         BNZ   @RF00914                                            0914
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* INDICATE GETMAIN FAIL @X04SVCJ*/
         L     @10,SABWRD(,R13)                                    0916
         MVI   PPCODE(@10),X'14'                                   0916
*       RETURN TO EXIT;             /* TERMINATE             @X04SVCJ*/
         LA    @14,EXIT                                            0917
@EL00011 DS    0H                                                  0917
@EF00011 DS    0H                                                  0917
@ER00011 BR    @14                                                 0917
*     END;                          /*                       @X04SVCJ*/
*   RDEB=OPWVMADR+LENGTH(DEBAVT)+LENGTH(DEBPREFX);/* PT TO DEB PROPER*/
@RF00914 L     @15,OPWVMADR(,RCORE)                                0919
         LA    RDEB,36                                             0919
         ALR   RDEB,@15                                            0919
*   DEBAD=RDEB;                     /* SAVE POINTER TO DEB           */
         ST    RDEB,DEBAD                                          0920
*   DEBTCBAD=TCBJSTCB;              /* COPY FIRST TCB ADDR   @Z30SSDT*/
         L     @10,PSATOLD                                         0921
         L     @10,TCBJSTCB(,@10)                                  0921
         ST    @10,DEBTCBAD(,RDEB)                                 0921
*   DEBNMEXT=CUREXTNO;              /* INIT NUMBER OF EXTENTS        */
         STC   CUREXTNO,DEBNMEXT(,RDEB)                            0922
*   RESPECIFY                                                      0923
*     TCB BASED(DEBTCBB);           /* BASE FOR TCB                  */
*   DEBPRIOR=TCBDSP;                /* INIT DEB TCB PRIORITY         */
         L     @10,DEBTCBB-1(,RDEB)                                0924
         IC    @05,TCBDSP(,@10)                                    0924
         STC   @05,DEBPRIOR(,RDEB)                                 0924
*   DEBPROTG=DXUKEY;                /* INIT DEB PROTECT KEY  @Z30SSDT*/
         L     @10,OPWCOMWA(,RCORE)                                0925
         MVC   DEBPROTG(1,RDEB),DXUKEY(@10)                        0925
*   DEBDEBID=DEBDEBID|IDXDEB;       /* INIT DEB ID IN LO ORDER BITS  */
         OI    DEBDEBID(RDEB),B'00001111'                          0926
*   DEBEXSCL=EXSCALE;               /* INIT EXTENT SCALE FOR DASD    */
         MVI   DEBEXSCL(RDEB),B'00000100'                          0927
*   DEBAPPB=OPWVMADR;               /* POINT TO APPENDAGE VECTOR   0928
*                                      TABLE                 @Z30SSDT*/
         STCM  @15,7,DEBAPPB(RDEB)                                 0928
*   DEBXTNP=OPWVMADR+R6;            /* PT TO DEB EXTENSION   @Z30SSJH*/
         L     @10,DEBAPPAD(,RDEB)                                 0929
         ALR   @15,R6                                              0929
         ST    @15,DEBXTNP(,@10)                                   0929
*   DEBLNGTH=R6/DWORDLEN;           /* SET DEB LENGTH IN DOUBLEWORDS
*                                                            @Z30SSJH*/
         LR    @05,R6                                              0930
         SRL   @05,3                                               0930
         STC   @05,DEBLNGTH(,@10)                                  0930
*   DEBEOEAD=ADDR(CVTBRET);         /* LD ADDR OF BR 14      @X04SVRP*/
         L     @05,FLCCVT                                          0931
         LA    @05,CVTBRET(,@05)                                   0931
         STCM  @05,7,DEBEOEAD(@10)                                 0931
*   DEBPCIAD=ADDR(CVTBRET);         /* LD ADDR OF BR 14      @X04SVRP*/
         STCM  @05,7,DEBPCIAD(@10)                                 0932
*   DEBSIOAD=ADDR(CVTBRET);         /* LD ADDR OF BR 14      @Z30SSDT*/
         STCM  @05,7,DEBSIOAD(@10)                                 0933
*   DEBCEAD=ADDR(CVTBRET);          /* LD ADDR OF BR 14      @Z30SSDT*/
         STCM  @05,7,DEBCEAD(@10)                                  0934
*   DEBXCEAD=ADDR(CVTBRET);         /* LD ADDR OF BR 14      @Z30SSDT*/
*                                                                  0935
         STCM  @05,7,DEBXCEAD(@10)                                 0935
*   /*****************************************************************/
*   /*                                                               */
*   /* INDICATE PAGE FIX ROUTINE IS PRESENT                  @Z30SSDT*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0936
*   DEBPGFX=ON;                     /*                       @Z30SSDT*/
         OI    DEBPGFX(@10),B'10000000'                            0936
*   R9=ADDR(DEBBASND);              /* PT TO DASD SECT OF DEB        */
         LA    R9,DEBBASND(,RDEB)                                  0937
*   RESPECIFY                                                      0938
*     DEBDASD BASED(R9);            /* BASE FOR DASD SECT OF DEB     */
*   R6=ADDR(AMBWORK)+LENGTH(AMBWORK);                              0939
         LA    R6,232                                              0939
         AL    R6,OPWWRKPT(,RCORE)                                 0939
*   RESPECIFY                                                      0940
*     CTVOLENT BASED(R6);           /* BASE FOR VOL ENT              */
*   RESPECIFY                                                      0941
*     CTKEYENT BASED(R7);           /* BASE FOR KEY ENT              */
*   RESPECIFY                                                      0942
*     CTEXTENT BASED(R8);           /* BASE FOR EXT ENT              */
*   DO C2=K1 TO VOLENTNO;           /* PROCESS ALL VOLUME ENTRIES    */
         LA    @10,1                                               0943
         B     @DE00943                                            0943
@DL00943 DS    0H                                                  0944
*     IF CTVOLMT=ON THEN            /* VOLUME MOUNTED _              */
         TM    CTVOLMT(R6),B'10000000'                             0944
         BNO   @RF00944                                            0944
*       DO;                         /* YES, PROCEED:                 */
*         R7=R6+LENGTH(CTVOLENT);   /* R7 PTS TO 1ST KEY RANGE ENT   */
         LA    R7,20                                               0946
         ALR   R7,R6                                               0946
*         DO C3=1 TO CTNOKEY;       /* PROCESS ALL KEY RANGES        */
         LA    C3,1                                                0947
         B     @DE00947                                            0947
@DL00947 DS    0H                                                  0948
*           R8=ADDR(CTKEY)+CTKEYLEN*K2;/* R8 PTS TO 1ST EXT ENTRY    */
         LA    R8,CTKEY(,R7)                                       0948
         LH    @05,CTKEYLEN(,R6)                                   0948
         ALR   @05,@05                                             0948
         ALR   R8,@05                                              0948
*           DO C4=K1 TO CTNOKEXT;   /* PROCESS ALL EXTENT ENTRIES    */
         LA    @05,1                                               0949
         B     @DE00949                                            0949
@DL00949 DS    0H                                                  0950
*             DEBUCBA=CTVOLUCB;     /* INIT UCB PTR                  */
         MVC   DEBUCBA(3,R9),CTVOLUCB+1(R6)                        0950
*             GEN SETS(DEBSTRCC);                                  0951
*                                                          /*@Z30SSDT*/
         MVC   DEBSTRCC(10,R9),CTABSBEG(R8)    COPY EXTENT FIELDS
*             IF CMBOUT=OFF THEN    /* READ ONLY             @ZA02295*/
         L     @05,ACBAMBL(,RACB)                                  0952
         L     @05,AMBLCMB(,@05)                                   0952
         TM    CMBOUT(@05),B'10000000'                             0952
         BNZ   @RF00952                                            0952
*               DEBDVMOD=FMSKRD;    /* SET READ ONLY FILE MASK       */
         MVI   DEBDVMOD(R9),B'01010000'                            0953
*             ELSE                  /* WRITE                 @Z30SSRL*/
*               DEBDVMOD=FMSKWR;    /* SET FILE MASK FOR WRITES      */
         B     @RC00952                                            0954
@RF00952 MVI   DEBDVMOD(R9),B'00010000'                            0954
*             IF CTCYL=OFF THEN     /* CYLINDER ALLOCATION           */
@RC00952 L     @05,OPWWRKPT(,RCORE)                                0955
         TM    CTCYL(@05),B'01000000'                              0955
         BNZ   @RF00955                                            0955
*               DEBDVMOD=DEBDVMOD|FMNOSEEK;/* NO HEAD SEEKS          */
         SLR   @05,@05                                             0956
         IC    @05,DEBDVMOD(,R9)                                   0956
         O     @05,@CF00038                                        0956
         STC   @05,DEBDVMOD(,R9)                                   0956
*             R9=R9+LENGTH(DEBDASD);/* PT TO NEX DEB EXTENT          */
@RF00955 AL    R9,@CF00050                                         0957
*             R8=R8+LENGTH(CTEXTENT);/* PT TO NXT EXTENT ENTRY       */
         AL    R8,@CF00443                                         0958
*           END;                                                   0959
         LA    @05,1                                               0959
         AL    @05,C4                                              0959
@DE00949 ST    @05,C4                                              0959
         SLR   @15,@15                                             0959
         IC    @15,CTNOKEXT(,R7)                                   0959
         CR    @05,@15                                             0959
         BNH   @DL00949                                            0959
*           R7=R8;                  /* R7 PTS NXT KEY RANGE ENT      */
         LR    R7,R8                                               0960
*         END;                                                     0961
         AL    C3,@CF00053                                         0961
@DE00947 CH    C3,CTNOKEY(,R6)                                     0961
         BNH   @DL00947                                            0961
*         R6=R8;                    /* PT TO NEXT VOL ENT    @ZA02295*/
         LR    R6,R8                                               0962
*       END;                                                       0963
*     ELSE                                                         0964
*       R6=R6+LENGTH(CTVOLENT)+(LENGTH(CTKEYENT)+CTKEYLEN*K2)*CTNOKEY+
*           LENGTH(CTEXTENT)*CTNOEXT;/* POINT TO NEXT VOLENT @ZA02295*/
         B     @RC00944                                            0964
@RF00944 LA    @10,20                                              0964
         LR    @05,R6                                              0964
         ALR   @05,@10                                             0964
         LH    @01,CTKEYLEN(,R6)                                   0964
         ALR   @01,@01                                             0964
         AL    @01,@CF00050                                        0964
         MH    @01,CTNOKEY(,R6)                                    0964
         ALR   @05,@01                                             0964
         LR    @01,@10                                             0964
         SLR   @10,@10                                             0964
         IC    @10,CTNOEXT(,R6)                                    0964
         MR    @00,@10                                             0964
         ALR   @05,@01                                             0964
         LR    R6,@05                                              0964
*   END;                                                           0965
*                                                                  0965
@RC00944 LA    @10,1                                               0965
         AL    @10,C2                                              0965
@DE00943 ST    @10,C2                                              0965
         L     @05,OPWWRKPT(,RCORE)                                0965
         CH    @10,VOLENTNO(,@05)                                  0965
         BNH   @DL00943                                            0965
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD THE DEB EXTENSION USING THE MODEL EXTENSION IN THE O/C/E*/
*   /* WORK AREA AND CHAIN IT TO THE DEB.                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0966
*   DEBXTNIN=ON;                    /* SET EXTENSION INDR    @Z30SSJH*/
         OI    DEBXTNIN(RDEB),B'00000001'                          0966
*   R6=DXDEBXAD->DEBXLNGH;          /* GET LNG OF EXTENSION  @Z30SSJH*/
         L     @10,OPWCOMWA(,RCORE)                                0967
         L     @10,DXDEBXAD(,@10)                                  0967
         LH    R6,DEBXLNGH(,@10)                                   0967
*   DEBXTN(1:R6)=DXDEBXAD->DEBXTN(1:R6);/* COPY MODEL EXTN   @Z30SSJH*/
         L     @05,DEBAPPAD(,RDEB)                                 0968
         L     @05,DEBXTNP(,@05)                                   0968
         LR    @15,R6                                              0968
         BCTR  @15,0                                               0968
         EX    @15,@SM05681                                        0968
*   DEBXDBPR=RDEB;                  /* CHAIN EXTNSION TO DEB @Z30SSJH*/
         ST    RDEB,DEBXDBPR(,@05)                                 0969
*   DEBXDSAB=DSABPTR;               /* POINT EXT TO DSAB     @Z30SSJH*/
         L     @10,DSABPTR                                         0970
         ST    @10,DEBXDSAB(,@05)                                  0970
*   AMBDEBAD=DEBAD;                 /* CHAIN THE DEB         @X04SVCJ*/
         L     @10,DEBAD                                           0971
         L     @05,AMBP                                            0971
         STCM  @10,7,AMBDEBAD(@05)                                 0971
*   DEBAD->DEBDCBB=ADDR(IDAAMB);    /* POINT BACK TO AMB     @X04SVCJ*/
         STCM  @05,7,DEBDCBB(@10)                                  0972
*   RESPECIFY                                                      0973
*     TCB BASED(PSATOLD);           /* BASE FOR TCB          @Z30SSDT*/
*   RESPECIFY                                                      0974
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @10,RETCONT                                         0975
         LR    @05,@10                                             0975
         SLA   @05,2                                               0975
         L     RET,RETSAVE-4(@05)                                  0975
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @10,0                                               0976
         ST    @10,RETCONT                                         0976
*   RESPECIFY                                                      0977
*    (RET,                                                         0977
*     RDEB,                                                        0977
*     R6,                                                          0977
*     R7,                                                          0977
*     R8,                                                          0977
*     R9) UNRESTRICTED;             /*                       @X04SVCJ*/
*   END BLDRDEB;                                                   0978
         B     @EL00011                                            0978
*HOOKDEB:                                                          0979
*                                                                  0979
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE ISSUES DEBCHK MACRO PER DEB AND       */
*/*               ADDS DEBS TO PROPER DEB CHAIN                      */
*/*   INPUT -     CONTROL BLOCK STRUCTURE                            */
*/*   OUTPUT -    1. DEB ADDED TO JOB STEP TCB DEB CHAIN TO ISSUE    */
*/*                  DEBCHK                                          */
*/*               2. IF DEB IS FOR PATH OR UPGRADE, IT IS ADDED TO   */
*/*                  THE DEB FOR THE DATA AMB OF THE BASE CLUSTER    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0979
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0979
HOOKDEB  DS    0H                                                  0980
*   RESPECIFY                                                      0980
*    (RET,                                                         0980
*     RDEB) RSTD;                   /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               0981
         AL    @15,RETCONT                                         0981
         ST    @15,RETCONT                                         0981
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               0982
         ST    RET,RETSAVE-4(@15)                                  0982
*   RESPECIFY                                                      0983
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   RESPECIFY                                                      0984
*     TCB BASED(DEBTCBB);                                          0984
*   CSWORD1=K0;                     /* INIT LINK ADDR        @Z30SSDT*/
         SLR   CSWORD1,CSWORD1                                     0985
*   CSWORD2=ADDR(DEBBASIC);         /* INIT ADDR OF DEB      @X04SVCJ*/
         LR    CSWORD2,RDEB                                        0986
*   DO UNTIL(CSWORD1=DEBDEBB);      /* LOOP ADDS DEB TO CHN  @Z30SSDT*/
@DL00987 DS    0H                                                  0988
*     DEBDEBAD=CSWORD1;             /* INIT FIRST WORD       @Z30SSDT*/
         ST    CSWORD1,DEBDEBAD(,RDEB)                             0988
*     IF OPWPATH=ON|OPWUPGR=ON THEN /* IF PATH OR UPGRADE    @Z30SSDT*/
         L     @10,OPWCURPT(,RCORE)                                0989
         TM    OPWPATH(@10),B'01100000'                            0989
         BZ    @RF00989                                            0989
*       CS(CSWORD1,CSWORD2,OPWBAMBL->AMBLDTA->AMBDEBAD->DEBDEBAD);/*
*                                      ADD AFTER BASE DEB    @Z30SSDT*/
         L     @07,OPWBAMBL(,RCORE)                                0990
         L     @07,AMBLDTA(,@07)                                   0990
         L     @07,AMBDEBAD-1(,@07)                                0990
         CS    CSWORD1,@06,DEBDEBAD(@07)                           0990
*     ELSE                          /* NOT PATH OR UPGRADE   @Z30SSDT*/
*       CS(CSWORD1,CSWORD2,TCBDEB); /* ADD DEB TO HEAD OF CHAIN      */
         B     @RC00989                                            0991
@RF00989 L     @07,DEBTCBB-1(,RDEB)                                0991
         CS    CSWORD1,@06,TCBDEB(@07)                             0991
*   END;                            /*                       @X04SVCJ*/
@RC00989 DS    0H                                                  0992
@DE00987 L     @10,DEBDEBB-1(,RDEB)                                0992
         LA    @10,0(,@10)                                         0992
         CR    CSWORD1,@10                                         0992
         BNE   @DL00987                                            0992
*   IF OPWDSL=ZERO                  /* DSL EXIST             @X04SVCJ*/
*       |DSLACTEN=DIM(DSLENTRY) THEN/* EMPTY ENTRIES         @X04SVCJ*/
         L     @10,OPWDSL(,RCORE)                                  0993
         LTR   @10,@10                                             0993
         BZ    @RT00993                                            0993
         CLC   DSLACTEN(2,@10),@CH00050                            0993
         BNE   @RF00993                                            0993
@RT00993 DS    0H                                                  0994
*     CALL GETDSL;                  /* NO, GET ANOTHER DSL   @X04SVCJ*/
         BAL   @14,GETDSL                                          0994
*   DSLACTEN=DSLACTEN+K1;           /* BUMP COUNT BY ONE     @Z30SSRL*/
@RF00993 L     @10,OPWDSL(,RCORE)                                  0995
         LA    @05,1                                               0995
         AH    @05,DSLACTEN(,@10)                                  0995
         STH   @05,DSLACTEN(,@10)                                  0995
*   DSLDEBAD(DSLACTEN)=ADDR(DEBBASIC);/* SET ADDR OF DEB     @Z30SSDT*/
         SLA   @05,2                                               0996
         ALR   @10,@05                                             0996
         STCM  RDEB,7,DSLDEBAD-4(@10)                              0996
*   RESPECIFY                                                      0997
*     R8 RESTRICTED;                /*                       @Z30SSDT*/
*   R8=DEBDCBB;                     /* LOAD ACB/AMB POINTER  @Z30SSDT*/
         L     R8,DEBDCBB-1(,RDEB)                                 0998
         LA    R8,0(,R8)                                           0998
*   GEN(DEBCHK (R8),TYPE=ADD,AM=VSAM);/* ADD TO DEB TABLE    @Z30SSDT*/
         DEBCHK (R8),TYPE=ADD,AM=VSAM
*   RESPECIFY                                                      1000
*     TCB BASED(PSATOLD);           /*                       @Z30SSDT*/
*   RESPECIFY                                                      1001
*     RET RSTD;                     /*                       @Z30SSDT*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @10,RETCONT                                         1002
         LR    @09,@10                                             1002
         SLA   @09,2                                               1002
         L     RET,RETSAVE-4(@09)                                  1002
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @10,0                                               1003
         ST    @10,RETCONT                                         1003
*   RESPECIFY                                                      1004
*    (RET,                                                         1004
*     R8,                                                          1004
*     RDEB) UNRSTD;                 /*                       @Z30SSDT*/
*   END HOOKDEB;                    /*                       @Z30SSDT*/
@EL00012 DS    0H                                                  1005
@EF00012 DS    0H                                                  1005
@ER00012 BR    @14                                                 1005
*GETDSL:                                                           1006
*                                                                  1006
*/****************************************************************** */
*/*                                                          @X04SVCJ*/
*/*  FUNCTION -  THIS ROUTINE BUILDS DSL'S AND CHAINS THEM ON        */
*/*              OPWDSL.                                     @X04SVCJ*/
*/*  INPUT - NONE.                                           @X04SVCJ*/
*/*                                                          @X04SVCJ*/
*/*  OUTPUT -  DEB SAVE LISTS(DSL)                           @X04SVCJ*/
*/*                                                          @X04SVCJ*/
*/****************************************************************** */
*                                                                  1006
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
GETDSL   DS    0H                                                  1007
*   RESPECIFY                                                      1007
*    (RDEB,                                                        1007
*     RET) RSTD;                    /*                       @Z30SSDT*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               1008
         AL    @15,RETCONT                                         1008
         ST    @15,RETCONT                                         1008
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               1009
         ST    RET,RETSAVE-4(@15)                                  1009
*   RESPECIFY                                                      1010
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   OPWVSMPL=OPWVSMPL&&OPWVSMPL;    /* ZERO 192M PARM LIST   @Z30SSRL*/
         XC    OPWVSMPL(16,RCORE),OPWVSMPL(RCORE)                  1011
*   OPWVMSP=WKPOOL;                 /* SET PROTECTED SUBPOOL @X04SVCJ*/
         MVI   OPWVMSP(RCORE),X'FC'                                1012
*   OPWVMLNG=LENGTH(IDADSL);        /* SET LENGTH            @X04SVCJ*/
         MVC   OPWVMLNG(3,RCORE),@CF02684+1                        1013
*   OPWVMTYP=DIRCTREQ;              /* IND DIRECT REQUEST    @Z30SSRL*/
         MVI   OPWVMTYP(RCORE),X'85'                               1014
*   OPWVMNSL=ON;                    /* DO NOT REFLECT STORAGE IN CSL
*                                                            @Z30SSRL*/
         OI    OPWVMNSL(RCORE),B'00001000'                         1015
*   CALL IDA0192M;                  /* GET STORAGE           @X04SVCJ*/
         L     @15,@CV05525                                        1016
         BALR  @14,@15                                             1016
*   IF OPWVMADR=K0 THEN             /* WAS STORAGE OPTAINED  @Z30SSRL*/
         L     @10,OPWVMADR(,RCORE)                                1017
         LTR   @10,@10                                             1017
         BNZ   @RF01017                                            1017
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* INDICATE GETMAIN FAIL @X04SVCJ*/
         L     @10,SABWRD(,R13)                                    1019
         MVI   PPCODE(@10),X'14'                                   1019
*       RETURN TO EXIT;             /* TERMINATE             @X04SVCJ*/
         LA    @14,EXIT                                            1020
@EL00013 DS    0H                                                  1020
@EF00013 DS    0H                                                  1020
@ER00013 BR    @14                                                 1020
*     END;                          /*                       @X04SVCJ*/
*   OPWVMADR->DSLNXPTR=OPWDSL;      /* CHAIN DSL             @X04SVCJ*/
@RF01017 L     @10,OPWVMADR(,RCORE)                                1022
         L     @05,OPWDSL(,RCORE)                                  1022
         ST    @05,DSLNXPTR(,@10)                                  1022
*   OPWDSL=OPWVMADR;                /* SET POINTER IN OPEN WORK    1023
*                                                            @X04SVCJ*/
         ST    @10,OPWDSL(,RCORE)                                  1023
*   DSLSUBPL=WKPOOL;                /* SET SUBPOOL           @X04SVCJ*/
         MVI   DSLSUBPL(@10),X'FC'                                 1024
*   DSLLENTH=LENGTH(IDADSL);        /* SET LENGTH            @X04SVCJ*/
         MVC   DSLLENTH(3,@10),@CF02684+1                          1025
*   DSLID=IDADSLID;                 /* SET BLOCK ID          @X04SVCJ*/
         MVC   DSLID(8,@10),@CC02110                               1026
*   RESPECIFY                                                      1027
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @10,RETCONT                                         1028
         LR    @05,@10                                             1028
         SLA   @05,2                                               1028
         L     RET,RETSAVE-4(@05)                                  1028
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @10,0                                               1029
         ST    @10,RETCONT                                         1029
*   RESPECIFY                                                      1030
*    (RDEB,                                                        1030
*     RET) UNRSTD;                  /*                       @Z30SSDT*/
*   END GETDSL;                     /*                       @X04SVCJ*/
         B     @EL00013                                            1031
*BLDLPMB:                                                          1032
*                                                                  1032
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION -  THIS ROUTINE BUILDS THE LPMBS                      */
*/*   INPUT -     1. CATALOG WORK AREA                               */
*/*               2. AMDSB                                           */
*/*               3. UCB ADDRESS FROM TIOT                           */
*/*   OUTPUT -    1. THE LPMBS ARE BUILT                             */
*/*               2. LPMBAD IS SET TO FIRST LPMB ADDRESS             */
*/*                                                                  */
*/********************************************************************/
*                                                                  1032
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1032
BLDLPMB  DS    0H                                                  1033
*   RESPECIFY                                                      1033
*     IDAAMDSB BASED(AMDSBAD);                                     1033
*   RESPECIFY                                                      1034
*    (RET,                                                         1034
*     RTIOT,                                                       1034
*     R6) RSTD;                     /*                       @Z30SSDT*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               1035
         L     @08,RETCONT                                         1035
         ALR   @08,@15                                             1035
         ST    @08,RETCONT                                         1035
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @08,2                                               1036
         ST    RET,RETSAVE-4(@08)                                  1036
*   RESPECIFY                                                      1037
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   R6=K1;                          /* INIT NBR LPMBS USUALLY      1038
*                                                            @Z30SSRL*/
         LR    R6,@15                                              1038
*   IF CTINDXSS=ON THEN             /* IF INDEX AMB AND SS/W DATA    */
         L     @08,OPWWRKPT(,RCORE)                                1039
         TM    CTINDXSS(@08),B'00100000'                           1039
         BNO   @RF01039                                            1039
*     DO;                           /*                       @Z30SSDT*/
*       R6=K2;                      /* IF SEQ SET W DATA 2 LPMBS     */
         LA    R6,2                                                1041
*       LENGLPMB=(LENGTH(IDALPMB)+MAX(CTBLKTR,CTSBLKTR)+K7)&-K8;/* 1042
*                                      SET LENGTH            @Z30SSDT*/
         L     LENGLPMB,CTBLKTR(,@08)                              1042
         L     @08,CTSBLKTR(,@08)                                  1042
         CR    LENGLPMB,@08                                        1042
         BNL   *+6
         LR    LENGLPMB,@08                                        1042
         AL    LENGLPMB,@CF02794                                   1042
         N     LENGLPMB,@CF05652                                   1042
*     END;                          /* END OF DO GROUP IF INDEX AND
*                                      SS W/DATA.            @Z30SSMD*/
*   ELSE                            /* NOT INDEX & SS W/DATA @Z30SSRL*/
*     LENGLPMB=(LENGTH(IDALPMB)+CTBLKTR+K7)&-K8;/* SET SIZE  @Z30SSDT*/
*                                                                  1044
         B     @RC01039                                            1044
@RF01039 L     @08,OPWWRKPT(,RCORE)                                1044
         LA    LENGLPMB,35                                         1044
         AL    LENGLPMB,CTBLKTR(,@08)                              1044
         N     LENGLPMB,@CF05652                                   1044
*   /*****************************************************************/
*   /*                                                               */
*   /* GET STORAGE FOR LPMB(S)                               @Z30SSDT*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1045
*   OPWVMLNG=LENGLPMB*R6;           /* INIT AMT CORE REQUIRED        */
@RC01039 LR    @01,R6                                              1045
         MR    @00,LENGLPMB                                        1045
         STCM  @01,7,OPWVMLNG(RCORE)                               1045
*   OPWVMFLG=ZERO;                  /* RESET FLAGS           @X04SVCJ*/
         MVI   OPWVMFLG(RCORE),X'00'                               1046
*   OPWVMANC=ADDR(IDACMB);          /* SET ADDR OF ANCHOR BLOCK    1047
*                                                            @X04SVCJ*/
         L     @08,ACBAMBL(,RACB)                                  1047
         L     @08,AMBLCMB(,@08)                                   1047
         ST    @08,OPWVMANC(,RCORE)                                1047
*   OPWVMTYP=PROTBLK;               /* INDICATE PROTECT BLOCK      1048
*                                                            @X04SVCJ*/
         MVI   OPWVMTYP(RCORE),X'02'                               1048
*   CALL IDA0192M;                  /* GET AND CLEAR CORE    @X04SVCJ*/
         L     @15,@CV05525                                        1049
         BALR  @14,@15                                             1049
*   IF OPWVMADR=ZERO THEN           /* WAS STORAGE OBTAINED  @X04SVCJ*/
         L     @08,OPWVMADR(,RCORE)                                1050
         LTR   @08,@08                                             1050
         BNZ   @RF01050                                            1050
*     DO;                           /* ERROR                 @X04SVCJ*/
*       PPCODE=PP20;                /* INDICATE GETMAIN FAIL @X04SVCJ*/
         L     @08,SABWRD(,R13)                                    1052
         MVI   PPCODE(@08),X'14'                                   1052
*       RETURN TO EXIT;             /* TERMINATE             @X04SVCJ*/
         LA    @14,EXIT                                            1053
@EL00014 DS    0H                                                  1053
@EF00014 DS    0H                                                  1053
@ER00014 BR    @14                                                 1053
*     END;                          /*                       @X04SVCJ*/
*   LPMBAD=OPWVMADR;                /* INIT TABLE POINTER    @X04SVCJ*/
@RF01050 L     @08,OPWVMADR(,RCORE)                                1055
         ST    @08,LPMBAD                                          1055
*   RESPECIFY                                                      1056
*     IDALPMB BASED(LPMBAD+LENGLPMB*(R6-K1));/*              @Z30SSDT*/
*                                                                  1056
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE FIELDS OF THE LPMB(S)                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1057
*   DO R6=R6 TO 1 BY-1;                                            1057
         B     @DE01057                                            1057
@DL01057 DS    0H                                                  1058
*     LPMBID=IDXLPMB;               /* SET ID FOR CONTROL BLOCK      */
         LR    @01,R6                                              1058
         BCTR  @01,0                                               1058
         MR    @00,LENGLPMB                                        1058
         AL    @01,LPMBAD                                          1058
         MVI   LPMBID(@01),B'10010001'                             1058
*     LPMBLEN=LENGLPMB;             /* SET LENGTH OF LPMB    @Z30SSDT*/
         STH   LENGLPMB,LPMBLEN(,@01)                              1059
*     IF AMDREPL=ON THEN            /* REPLICATION IN AMDSB          */
         L     @08,AMDSBAD                                         1060
         TM    AMDREPL(@08),B'00010000'                            1060
         BNO   @RF01060                                            1060
*       LPMREPL=ON;                 /* SET REPLICATION BIT           */
*                                                                  1061
         OI    LPMREPL(@01),B'01000000'                            1061
*     /***************************************************************/
*     /*                                                             */
*     /*                                                     @Z30SSDT*/
*     /* INIT FIELDS FROM CATALOG                            @Z30SSDT*/
*     /*                                                     @Z30SSDT*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1062
*     LPMBLKSZ=CTBLKSZ;             /* INIT BLKSIZE FROM CATALOG     */
@RF01060 LR    @01,R6                                              1062
         BCTR  @01,0                                               1062
         MR    @00,LENGLPMB                                        1062
         AL    @01,LPMBAD                                          1062
         L     @08,OPWWRKPT(,RCORE)                                1062
         L     @05,CTBLKSZ(,@08)                                   1062
         ST    @05,LPMBLKSZ(,@01)                                  1062
*     IF R6=K2 THEN                 /* SS W/DTA LPMB ?       @Z30SSRL*/
         C     R6,@CF00092                                         1063
         BNE   @RF01063                                            1063
*       DO;                         /* SS W/DTA LPMB         @Z30SSDT*/
*         LPMTRKAU=CTSTRKAU;        /* COPY TRKS PER AU      @Z30SSDT*/
         L     @05,CTSTRKAU(,@08)                                  1065
         STH   @05,LPMTRKAU(,@01)                                  1065
*         LPMBLKTR=CTSBLKTR;        /* COPY BLKS PER TRACK   @Z30SSDT*/
         L     @08,CTSBLKTR(,@08)                                  1066
         STH   @08,LPMBLKTR(,@01)                                  1066
*       END;                        /*                       @Z30SSDT*/
*     ELSE                          /* NOT SS W/DATA LPMB    @Z30SSRL*/
*       DO;                                                        1068
         B     @RC01063                                            1068
@RF01063 DS    0H                                                  1069
*         LPMTRKAU=CTTRKAU;         /* INIT TRK/ALLOCATION UNIT FR 1069
*                                      CATALOG               @Z30SSDT*/
         LR    @01,R6                                              1069
         BCTR  @01,0                                               1069
         MR    @00,LENGLPMB                                        1069
         AL    @01,LPMBAD                                          1069
         L     @08,OPWWRKPT(,RCORE)                                1069
         L     @05,CTTRKAU(,@08)                                   1069
         STH   @05,LPMTRKAU(,@01)                                  1069
*         LPMBLKTR=CTBLKTR;         /* INIT BLKS/TRK FR CATALOG      */
         L     @08,CTBLKTR(,@08)                                   1070
         STH   @08,LPMBLKTR(,@01)                                  1070
*       END;                        /*                       @Z30SSDT*/
*                                                                  1071
*     /***************************************************************/
*     /*                                                             */
*     /* INIT RPS BIT                                                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1072
*     RESPECIFY                                                    1072
*       RUCB RESTRICTED;                                           1072
@RC01063 DS    0H                                                  1073
*     IF R6=K2 THEN                 /* IF SS LPMB            @Z30SSRL*/
         C     R6,@CF00092                                         1073
         BNE   @RF01073                                            1073
*       DO;                         /* YES TO ALL OF ABOVE           */
*         LPMSS=ON;                 /* SET SS W/DTA INDICATOR        */
*         LPMREPL=ON;               /* FORCE REPLICATION             */
         LR    @01,R6                                              1076
         BCTR  @01,0                                               1076
         MR    @00,LENGLPMB                                        1076
         AL    @01,LPMBAD                                          1076
         OI    LPMSS(@01),B'01100000'                              1076
*         RTIOT=TCBTIO+AMBLDTA->AMBTIOT;/* DATA MIGHT BE DIFF DEVICE */
         L     @11,ACBAMBL(,RACB)                                  1077
         L     @11,AMBLDTA(,@11)                                   1077
         LH    RTIOT,AMBTIOT(,@11)                                 1077
         L     @11,PSATOLD                                         1077
         AL    RTIOT,TCBTIO(,@11)                                  1077
*       END;                                                       1078
*     ELSE                          /* NOT SS LPMB           @Z30SSRL*/
*       RTIOT=TCBTIO+AMBTIOT;       /* POINT TO TIOT ENTRY   @Z30SSDT*/
         B     @RC01073                                            1079
@RF01073 L     @11,AMBP                                            1079
         LH    RTIOT,AMBTIOT(,@11)                                 1079
         L     @11,PSATOLD                                         1079
         AL    RTIOT,TCBTIO(,@11)                                  1079
*     IF AMBLCAT=ON THEN            /* IF CATALOG ACB BEING PROCESSED
*                                                            @X04SVCJ*/
@RC01073 L     @11,ACBAMBL(,RACB)                                  1080
         TM    AMBLCAT(@11),B'00000010'                            1080
         BNO   @RF01080                                            1080
*       RTIOT=OPWTIOT;              /* POINT TO TIOT ENTRY   @X04SVCJ*/
         L     RTIOT,OPWTIOT(,RCORE)                               1081
*     RUCB=TIOEFSRT;                /* LOAD UCB ADDRESS              */
@RF01080 L     @08,TIOEFSRT-1(,RTIOT)                              1082
         LA    @08,0(,@08)                                         1082
         LR    RUCB,@08                                            1082
*     LPMTPC=DEVTABTC;              /* COPY TRACKS PER CYLINDER      */
         LR    @01,R6                                              1083
         BCTR  @01,0                                               1083
         MR    @00,LENGLPMB                                        1083
         AL    @01,LPMBAD                                          1083
         L     @11,FLCCVT                                          1083
         L     @11,CVTZDTAB(,@11)                                  1083
         SLR   @05,@05                                             1083
         IC    @05,UCBTBYT4(,@08)                                  1083
         ALR   @05,@11                                             1083
         SLR   @15,@15                                             1083
         IC    @15,DEVTABOF(,@05)                                  1083
         ALR   @11,@15                                             1083
         LH    @11,DEVTABTC(,@11)                                  1083
         STH   @11,LPMTPC(,@01)                                    1083
*     IF UCB2OPT3=ON THEN           /* UCB IND RPS DEVICE    @Z30SSRL*/
         TM    UCB2OPT3(@08),B'00010000'                           1084
         BNO   @RF01084                                            1084
*       DO;                         /*                       @Z30SSDT*/
*         LPMBRPS=ON;               /* SET IN LPMB                   */
         OI    LPMBRPS(@01),B'10000000'                            1086
*         IF OPWPSDS=OFF|OPWSWSP=ON THEN/* IF NOT PAGE SPACE DS OR IF
*                                      SWAPABLE SPACE        @Z40WSRL*/
         TM    OPWSWSP(RCORE),B'00000010'                          1087
         BNZ   @RT01087                                            1087
         TM    OPWPSDS(RCORE),B'00000001'                          1087
         BO    @RF01087                                            1087
@RT01087 DS    0H                                                  1088
*           DO;                     /*                       @Z30SSRL*/
*             LPMBSSTH=ON;          /* LPMB SET SECTOR TABLE @Z30SSDT*/
*                                                                  1089
         LR    @01,R6                                              1089
         BCTR  @01,0                                               1089
         MR    @00,LENGLPMB                                        1089
         AL    @01,LPMBAD                                          1089
         OI    LPMBSSTH(@01),B'00001000'                           1089
*             /*******************************************************/
*             /*                                                     */
*             /* BUILD SET SECTOR TABLE                      @Z30SSDT*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1090
*             RETSAVE(RETCONT+K1)=RACB;/* SAVE ACB ADDRESS   @Z30SSRL*/
         L     @11,RETCONT                                         1090
         SLA   @11,2                                               1090
         ST    RACB,RETSAVE(@11)                                   1090
*             RETSAVE(RETCONT+K2)=RTIOT;/* SAVE TIOT ADDRESS @Z30SSRL*/
         ST    RTIOT,RETSAVE+4(@11)                                1091
*             DD=LPMBLKSZ;          /* SET BLKSIZE           @Z30SSDT*/
         L     @11,LPMBLKSZ(,@01)                                  1092
         STH   @11,DD                                              1092
*             K=KEY0;               /* KEY IS ALWAYS ZERO    @Z30SSDT*/
         MVI   K,X'00'                                             1093
*             U=UCBTBYT4;           /* SET DEVICE TYPE       @Z30SSDT*/
         L     @11,TIOEFSRT-1(,RTIOT)                              1094
         IC    @08,UCBTBYT4(,@11)                                  1094
         STC   @08,U                                               1094
*             DO C2=1 TO LPMBLKTR BY 1;/* LOOP THROUGH BLOCKS      1095
*                                                            @Z30SSDT*/
         LA    @11,1                                               1095
         ST    @11,C2                                              1095
         B     @DE01095                                            1095
@DL01095 DS    0H                                                  1096
*               R=C2;               /* SET BLOCK NUMBER      @Z30SSDT*/
         STC   @11,R                                               1096
*               SSA=ADDR(LPMBSST(C2));/* SET ADDRESS OF SECTOR LIST
*                                                            @Z30SSDT*/
         LR    @01,R6                                              1097
         BCTR  @01,0                                               1097
         MR    @00,LENGLPMB                                        1097
         AL    @01,LPMBAD                                          1097
         LA    @11,LPMBSST-1(@11,@01)                              1097
         STCM  @11,7,SSA                                           1097
*               RESPECIFY                                          1098
*                (R0,                                              1098
*                 R9,                                              1098
*                 R10,                                             1098
*                 R11,                                             1098
*                 RET,                                             1098
*                 R15) RSTD;        /*                       @Z30SSDT*/
*               R0=DDKR;            /* LOAD REG ZERO         @Z30SSDT*/
         L     R0,DDKR                                             1099
*               RACB=USSA;          /* LOAD DEVICE TYPE AND ADDRESS
*                                                            @Z30SSDT*/
         L     RACB,USSA                                           1100
*               CALL CVT0SCR1;      /* CALL CONVERT ROUTINE  @Z30SSDT*/
         L     @08,FLCCVT                                          1101
         L     @15,CVT0SCR1(,@08)                                  1101
         BALR  @14,@15                                             1101
*               RESPECIFY                                          1102
*                (R0,                                              1102
*                 R9,                                              1102
*                 R10,                                             1102
*                 R11,                                             1102
*                 RET,                                             1102
*                 R15) UNRSTD;      /*                       @Z30SSDT*/
*             END;                  /*                       @Z30SSMD*/
         LA    @11,1                                               1103
         AL    @11,C2                                              1103
         ST    @11,C2                                              1103
@DE01095 LR    @01,R6                                              1103
         BCTR  @01,0                                               1103
         MR    @00,LENGLPMB                                        1103
         AL    @01,LPMBAD                                          1103
         CH    @11,LPMBLKTR(,@01)                                  1103
         BNH   @DL01095                                            1103
*             RACB=RETSAVE(RETCONT+K1);/* LOAD ACB ADDRESS   @Z30SSMD*/
         L     @11,RETCONT                                         1104
         SLA   @11,2                                               1104
         L     RACB,RETSAVE(@11)                                   1104
*             RTIOT=RETSAVE(RETCONT+K2);/* LOAD TIOT ADDRESS @Z30SSMD*/
         L     RTIOT,RETSAVE+4(@11)                                1105
*           END;                    /*                       @Z30SSMD*/
*       END;                        /*                       @Z30SSDT*/
@RF01087 DS    0H                                                  1108
*     RESPECIFY                                                    1108
*       RUCB UNRESTRICTED;          /*                       @Z30SSDT*/
*                                                                  1108
@RF01084 DS    0H                                                  1109
*     /***************************************************************/
*     /*                                                             */
*     /* DERIVE THE BYTES/ALLOCATION UNIT FIELD (LPMAUSZ)            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1109
*     IF CTINDX^=ON THEN            /* IF AMB IS FOR DATA            */
         L     @08,OPWWRKPT(,RCORE)                                1109
         TM    CTINDX(@08),B'00010000'                             1109
         BO    @RF01109                                            1109
*       IF CTTOVFL=ON THEN          /* IF TRACK OVERFLOW USED      1110
*                                                            @Z30SSDT*/
         TM    CTTOVFL(@08),B'00000001'                            1110
         BNO   @RF01110                                            1110
*         DO;                       /*                       @Z30SSDT*/
*           LPMAUSZ=CTBYTAU;        /* RECORD BYTES PER CA   @Z30SSDT*/
         LR    @01,R6                                              1112
         BCTR  @01,0                                               1112
         MR    @00,LENGLPMB                                        1112
         AL    @01,LPMBAD                                          1112
         L     @08,CTBYTAU(,@08)                                   1112
         ST    @08,LPMAUSZ(,@01)                                   1112
*           LPMBTOFL=ON;            /* INDICATE TRK OVERFLOW @Z30SSDT*/
         OI    LPMBTOFL(@01),B'00010000'                           1113
*         END;                      /*                       @Z30SSDT*/
*       ELSE                        /* TRACK OVERFLOW NOT USED       */
*         DO;                       /*                       @Z40WSRL*/
         B     @RC01110                                            1115
@RF01110 DS    0H                                                  1116
*           LPMAUSZ=AMDCINV*AMDCIPCA;/* THEN INIT FIELD              */
         LR    @01,R6                                              1116
         BCTR  @01,0                                               1116
         MR    @00,LENGLPMB                                        1116
         AL    @01,LPMBAD                                          1116
         L     @08,AMDSBAD                                         1116
         L     @05,AMDCINV(,@08)                                   1116
         MH    @05,AMDCIPCA(,@08)                                  1116
         ST    @05,LPMAUSZ(,@01)                                   1116
*           CTBYTAU=LPMAUSZ;        /* SET BYTES PER CA      @Z40WSRL*/
         L     @08,OPWWRKPT(,RCORE)                                1117
         ST    @05,CTBYTAU(,@08)                                   1117
*         END;                      /*                       @Z40WSRL*/
*     ELSE                          /* IF AMB IS FOR INDEX           */
*       DO;                                                        1119
         B     @RC01109                                            1119
@RF01109 DS    0H                                                  1120
*         IF R6=K2 THEN             /* AND WORKING ON FIRST LPMB-    */
         C     R6,@CF00092                                         1120
         BNE   @RF01120                                            1120
*           LPMAUSZ=AMDCINV;        /* INIT BYTES/ ALL UNIT          */
         LR    @01,R6                                              1121
         BCTR  @01,0                                               1121
         MR    @00,LENGLPMB                                        1121
         AL    @01,LPMBAD                                          1121
         L     @08,AMDSBAD                                         1121
         L     @08,AMDCINV(,@08)                                   1121
         ST    @08,LPMAUSZ(,@01)                                   1121
*         ELSE                      /* IF NO SEQ SEQ W DATA OR     1122
*                                      WORKING ON SECOND LPMB -      */
*           DO;                                                    1122
         B     @RC01120                                            1122
@RF01120 DS    0H                                                  1123
*             IF LPMREPL=ON THEN    /* IF REPLICATION                */
         LR    @01,R6                                              1123
         BCTR  @01,0                                               1123
         MR    @00,LENGLPMB                                        1123
         AL    @01,LPMBAD                                          1123
         TM    LPMREPL(@01),B'01000000'                            1123
         BNO   @RF01123                                            1123
*               LPMAUSZ=AMDCINV;    /* INIT BYTES/ALL UNIT           */
         L     @08,AMDSBAD                                         1124
         L     @08,AMDCINV(,@08)                                   1124
         ST    @08,LPMAUSZ(,@01)                                   1124
*             ELSE                  /* NOT REPLICATION       @Z30SSRL*/
*               LPMAUSZ=AMDCINV*LPMBLKTR;/* INIT BYTES/ALL UNIT      */
         B     @RC01123                                            1125
@RF01123 LR    @01,R6                                              1125
         BCTR  @01,0                                               1125
         MR    @00,LENGLPMB                                        1125
         AL    @01,LPMBAD                                          1125
         L     @08,AMDSBAD                                         1125
         L     @08,AMDCINV(,@08)                                   1125
         MH    @08,LPMBLKTR(,@01)                                  1125
         ST    @08,LPMAUSZ(,@01)                                   1125
*           END;                                                   1126
@RC01123 DS    0H                                                  1127
*       END;                                                       1127
*                                                                  1127
@RC01120 DS    0H                                                  1128
*     /***************************************************************/
*     /*                                                             */
*     /* DERIVE THE RBA BYTES/TRK FIELD (LPMBPTRK)                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1128
*     IF CTINDX^=ON THEN            /* IF AMB FOR DATA               */
@RC01109 L     @08,OPWWRKPT(,RCORE)                                1128
         TM    CTINDX(@08),B'00010000'                             1128
         BO    @RF01128                                            1128
*       IF CTTOVFL=ON THEN          /* IF TRACK OVERFLOW USED      1129
*                                                            @Z30SSDT*/
         TM    CTTOVFL(@08),B'00000001'                            1129
         BNO   @RF01129                                            1129
*         LPMBPTRK=CTBYTTRK;        /* RECORD BYTES PER TRACK      1130
*                                                            @Z30SSDT*/
         LR    @01,R6                                              1130
         BCTR  @01,0                                               1130
         MR    @00,LENGLPMB                                        1130
         AL    @01,LPMBAD                                          1130
         L     @08,CTBYTTRK(,@08)                                  1130
         ST    @08,LPMBPTRK(,@01)                                  1130
*       ELSE                        /* TRACK OVERFLOW NOT USED       */
*         LPMBPTRK=LPMBLKSZ*LPMBLKTR;/* INIT BYTES/TRK               */
         B     @RC01129                                            1131
@RF01129 LR    @01,R6                                              1131
         BCTR  @01,0                                               1131
         MR    @00,LENGLPMB                                        1131
         AL    @01,LPMBAD                                          1131
         L     @08,LPMBLKSZ(,@01)                                  1131
         MH    @08,LPMBLKTR(,@01)                                  1131
         ST    @08,LPMBPTRK(,@01)                                  1131
*     ELSE                          /* IF AMB IS FOR INDEX -         */
*       LPMBPTRK=LPMAUSZ;           /* INIT BYTES/TRK                */
         B     @RC01128                                            1132
@RF01128 LR    @01,R6                                              1132
         BCTR  @01,0                                               1132
         MR    @00,LENGLPMB                                        1132
         AL    @01,LPMBAD                                          1132
         L     @08,LPMAUSZ(,@01)                                   1132
         ST    @08,LPMBPTRK(,@01)                                  1132
*   END;                                                           1133
@RC01128 BCTR  R6,0                                                1133
@DE01057 LTR   R6,R6                                               1133
         BP    @DL01057                                            1133
*   RESPECIFY                                                      1134
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @08,RETCONT                                         1135
         LR    @07,@08                                             1135
         SLA   @07,2                                               1135
         L     RET,RETSAVE-4(@07)                                  1135
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @08,0                                               1136
         ST    @08,RETCONT                                         1136
*   RESPECIFY                                                      1137
*    (RET,                                                         1137
*     RTIOT,                                                       1137
*     R6) UNRSTD;                   /*                       @Z30SSDT*/
*   END BLDLPMB;                                                   1138
         B     @EL00014                                            1138
*BLDSTRBK:                                                         1139
*                                                                  1139
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - THIS ROUTINE BUILDS STRING BLOCKS VIA A CALL TO     */
*/*              IDA0192Y. THIS ROUTINE BUILDS THE PARAMETER LIST    */
*/*              REQUIRED BY 192Y.                                   */
*/*   INPUT    - DIAOPWRK, ACB, AMB                                  */
*/*   OUTPUT   - PARAMETER LIST FOR IDA0192Y AND STRING BLOCKS BUILT */
*/*              BY 192Y                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  1139
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVCJ*/
BLDSTRBK DS    0H                                                  1140
*   RESPECIFY                                                      1140
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               1141
         AL    @15,RETCONT                                         1141
         ST    @15,RETCONT                                         1141
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               1142
         ST    RET,RETSAVE-4(@15)                                  1142
*   RESPECIFY                                                      1143
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   IDABLPRM=IDABLPRM&&IDABLPRM;    /* ZERO PARAMETER LIST   @Z30SSDT*/
         LA    @05,PARM192Y                                        1144
         XC    IDABLPRM(52,@05),IDABLPRM(@05)                      1144
*   AMBWSHD=BIBWSHD;                /* INIT PTR TO WSHD      @X04SVRP*/
         L     @05,ACBAMBL(,RACB)                                  1145
         L     @05,AMBLBIB(,@05)                                   1145
         L     @05,BIBWSHD(,@05)                                   1145
         L     @01,AMBP                                            1145
         ST    @05,AMBWSHD(,@01)                                   1145
*   IF OPWPATH=ON THEN              /* PATH FLAG ON          @X04SVCJ*/
         L     @05,OPWCURPT(,RCORE)                                1146
         TM    OPWPATH(@05),B'01000000'                            1146
         BNO   @RF01146                                            1146
*     BLPFPATH=ON;                  /* SET PATH FLAG         @X04SVCJ*/
         LA    @05,PARM192Y                                        1147
         OI    BLPFPATH(@05),B'00100000'                           1147
*   IF OPWUPGR=ON THEN              /* UPGRADE               @X04SVCJ*/
@RF01146 L     @05,OPWCURPT(,RCORE)                                1148
         TM    OPWUPGR(@05),B'00100000'                            1148
         BNO   @RF01148                                            1148
*     BLPFUPGR=ON;                  /* SET UPGR FLAG         @X04SVCJ*/
         LA    @05,PARM192Y                                        1149
         OI    BLPFUPGR(@05),B'01000000'                           1149
*   BLPFPRIM=ON;                    /* SET PRIM BIT ON       @X04SVCJ*/
@RF01148 LA    @05,PARM192Y                                        1150
         OI    BLPFPRIM(@05),B'00010000'                           1150
*   IF AMBTYPE=AMBDATA THEN         /* DATA AMB              @X04SVCJ*/
         L     @01,AMBP                                            1151
         TM    AMBTYPE(@01),B'01000000'                            1151
         BNZ   @RF01151                                            1151
*     BLPFDATA=ON;                  /* SET DATA FLAG         @X04SVCJ*/
         OI    BLPFDATA(@05),B'00001000'                           1152
*   ELSE                            /* NOT DATA AMB          @X04SVCJ*/
*     BLPFINDX=ON;                  /* SET INDEX FLAG        @X04SVCJ*/
         B     @RC01151                                            1153
@RF01151 LA    @05,PARM192Y                                        1153
         OI    BLPFINDX(@05),B'00000100'                           1153
*   BLPUACB=RACB;                   /* SET ACB ADDRESS       @X04SVCJ*/
@RC01151 LA    @05,PARM192Y                                        1154
         ST    RACB,BLPUACB(,@05)                                  1154
*   RACB=ADDR(IDABLPRM);            /* LOAD POINTER TO LIST  @Z30SSDT*/
         LR    RACB,@05                                            1155
*   CALL IDA0192Y;                  /* BUILD STRING BLOCKS   @X04SVCJ*/
         L     @15,@CV05524                                        1156
         BALR  @14,@15                                             1156
*   RESPECIFY                                                      1157
*     RETCODE RESTRICTED;           /*                       @Z30SSRL*/
*   RSTATRTN=IDAR192Z;              /* NOTE 192Z IN CONTROL  @Z30SSRL*/
         L     @14,OPWCOMWA(,RCORE)                                1158
         MVC   RSTATRTN(4,@14),@CC05338                            1158
*   RACB=BLPUACB;                   /* RELOAD ACB ADDRESS    @X04SVCJ*/
         LA    @14,PARM192Y                                        1159
         L     RACB,BLPUACB(,@14)                                  1159
*   IF RETCODE^=K0 THEN             /* BUILD NOT SUCCESSFUL  @Z30SSRL*/
         LTR   RETCODE,RETCODE                                     1160
         BZ    @RF01160                                            1160
*     DO;                           /* ERROR OCCURED         @X04SVCJ*/
*       PD=RETCODE;                 /* STORE RETURN CODE     @X04SVCJ*/
         L     @14,SABWRD(,R13)                                    1162
         ST    RETCODE,PD(,@14)                                    1162
*       RETURN TO EXIT;             /* TERMINATE             @X04SVCJ*/
         LA    @14,EXIT                                            1163
@EL00015 DS    0H                                                  1163
@EF00015 DS    0H                                                  1163
@ER00015 BR    @14                                                 1163
*     END;                          /*                       @X04SVCJ*/
*   RESPECIFY                                                      1165
*     RETCODE UNRSTD;               /*                       @X04SVCJ*/
@RF01160 DS    0H                                                  1166
*   RESPECIFY                                                      1166
*     RET RSTD;                     /*                       @X04SVCJ*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @05,RETCONT                                         1167
         LR    @15,@05                                             1167
         SLA   @15,2                                               1167
         L     RET,RETSAVE-4(@15)                                  1167
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @05,0                                               1168
         ST    @05,RETCONT                                         1168
*   RESPECIFY                                                      1169
*     RET UNRSTD;                   /*                       @X04SVCJ*/
*   END BLDSTRBK;                   /*                       @X04SVCJ*/
         B     @EL00015                                            1170
*RESTINIT:                                                         1171
*                                                                  1171
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - INITIALIZE POINTERS IN THE MODULE WORK AREA WITH    */
*/*              ADDRESSES OF CONTROL BLOCKS THAT ALREADY EXIST AT   */
*/*              AT THE TIME OF A RESTART                            */
*/*   INPUT    - POINTER TO THE ACB IN RACB                          */
*/*   OUTPUT   - MODULE WORK AREA POINTERS INITIALIZED               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1171
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @Z30SSDT*/
RESTINIT DS    0H                                                  1172
*   RESPECIFY                                                      1172
*     RET RSTD;                     /*                       @Z30SSDT*/
*   RETCONT=RETCONT+K1;             /* BUMP CONTROL BY ONE   @Z30SSRL*/
         LA    @15,1                                               1173
         AL    @15,RETCONT                                         1173
         ST    @15,RETCONT                                         1173
*   RETSAVE(RETCONT)=RET;           /* SAVE RETURN ADDRESS   @Z30SSDT*/
         SLA   @15,2                                               1174
         ST    RET,RETSAVE-4(@15)                                  1174
*   RESPECIFY                                                      1175
*     RET UNRSTD;                   /*                       @Z30SSDT*/
*   IF C1=AMBLNUM THEN              /* IS AMB FOR DATA       @Z30SSDT*/
         L     @05,ACBAMBL(,RACB)                                  1176
         L     @15,C1                                              1176
         CH    @15,AMBLNUM(,@05)                                   1176
         BNE   @RF01176                                            1176
*     AMBAD=AMBLDTA;                /* YES, GET DATA AMB PTR @Z30SSDT*/
         L     @05,AMBLDTA(,@05)                                   1177
         ST    @05,AMBAD                                           1177
*   ELSE                            /* AMB IS FOR INDEX      @Z30SSDT*/
*     AMBAD=AMBLIX;                 /* GET INDEX AMB PTR     @Z30SSDT*/
         B     @RC01176                                            1178
@RF01176 L     @05,ACBAMBL(,RACB)                                  1178
         L     @05,AMBLIX(,@05)                                    1178
         ST    @05,AMBAD                                           1178
*   AMBP=AMBAD;                     /* AMB ADDRESSIBILITY    @Z30SSDT*/
@RC01176 L     @05,AMBAD                                           1179
         ST    @05,AMBP                                            1179
*   AMBWKA=OPWWRKPT;                /* POINTER TO AMB WORK   @Z30SSDT*/
         L     @15,OPWWRKPT(,RCORE)                                1180
         ST    @15,AMBWKA(,@05)                                    1180
*   RESPECIFY                                                      1181
*     RTIOT RESTRICTED;                                            1181
*   RTIOT=TCBTIO+AMBTIOT;           /* ADDRESS OF TIOT ENTRY @Z30SSDT*/
         L     @15,PSATOLD                                         1182
         LH    RTIOT,AMBTIOT(,@05)                                 1182
         AL    RTIOT,TCBTIO(,@15)                                  1182
*   DSABPTR=QDBFELMP;               /* GET PTR TO FIRST DSAB @Z30SSDT*/
         L     @08,TCBJSCB(,@15)                                   1183
         L     @08,JSCDSABQ(,@08)                                  1183
         L     @08,QDBFELMP(,@08)                                  1183
         ST    @08,DSABPTR                                         1183
*   DO WHILE RTIOT^=DSABTIOT;       /* GET CORRECT DSAB      @Z30SSDT*/
         B     @DE01184                                            1184
@DL01184 DS    0H                                                  1185
*     IF DSABPTR=ZERO THEN          /* CHECK FOR END OF CHN  @Z30SSDT*/
         L     @08,DSABPTR                                         1185
         LTR   @08,@08                                             1185
         BNZ   @RF01185                                            1185
*       DO;                         /* IF NO DSAB FOR AMB,   @Z30SSDT*/
*         PPCODE=PP78;              /* SET ERROR CODE AND    @Z30SSDT*/
         L     @08,SABWRD(,R13)                                    1187
         MVI   PPCODE(@08),X'4E'                                   1187
*         RETURN TO EXIT;           /* EXIT MODULE           @Z30SSDT*/
         LA    @14,EXIT                                            1188
@EL00016 DS    0H                                                  1188
@EF00016 DS    0H                                                  1188
@ER00016 BR    @14                                                 1188
*       END;                        /*                       @Z30SSDT*/
*     DSABPTR=DSABFCHN;             /* POINT TO NEXT DSAB    @Z30SSDT*/
@RF01185 L     @08,DSABPTR                                         1190
         L     @08,DSABFCHN(,@08)                                  1190
         ST    @08,DSABPTR                                         1190
*   END;                            /*                       @Z30SSDT*/
@DE01184 L     @08,DSABPTR                                         1191
         C     RTIOT,DSABTIOT(,@08)                                1191
         BNE   @DL01184                                            1191
*   AMDSBAD=AMBDSB;                 /* INIT AMDSB PTR        @Z30SSDT*/
         L     @08,AMBP                                            1192
         L     @05,AMBDSB(,@08)                                    1192
         ST    @05,AMDSBAD                                         1192
*   ARDBAD=AMDPARDB;                /* INIT PTR FIRST ARDB   @Z30SSDT*/
         L     @05,AMDPARDB(,@05)                                  1193
         ST    @05,ARDBAD                                          1193
*   LPMBAD=AMBEDB->EDBLPMBC;        /* GET PTR TO FIRST LPMB @Z30SSDT*/
         L     @08,AMBEDB(,@08)                                    1194
         L     @08,EDBLPMBC(,@08)                                  1194
         ST    @08,LPMBAD                                          1194
*   CALL BLDAMDSB;                  /* BUILD AN AMDSB        @Z30SSDT*/
         BAL   @14,BLDAMDSB                                        1195
*   CALL BLDARDB;                   /* BUILD ARDBS           @Z30SSDT*/
         BAL   @14,BLDARDB                                         1196
*   RESPECIFY                                                      1197
*     RET RSTD;                     /*                       @Z30SSDT*/
*   RET=RETSAVE(RETCONT);           /* LOAD RETURN ADDRESS   @Z30SSDT*/
         L     @08,RETCONT                                         1198
         LR    @05,@08                                             1198
         SLA   @05,2                                               1198
         L     RET,RETSAVE-4(@05)                                  1198
*   RETCONT=RETCONT-K1;             /* DECR CONTROL BY ONE   @Z30SSRL*/
         BCTR  @08,0                                               1199
         ST    @08,RETCONT                                         1199
*   RESPECIFY                                                      1200
*    (RTIOT,                                                       1200
*     RET) UNRSTD;                  /*                       @Z30SSDT*/
*   END RESTINIT;                   /*                       @Z30SSDT*/
         B     @EL00016                                            1201
@PB00016 DS    0H                                                  1201
*   END IDA0192Z                    /*                       @X04SVCJ*/
*                                                                  1202
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBXN)                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDATRACE)                                       */
*/*%INCLUDE SYSLIB  (AMCBS   )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IDABIB  )                                       */
*/*%INCLUDE SYSLIB  (IDABLPRM)                                       */
*/*%INCLUDE SYSLIB  (IDABSPH )                                       */
*/*%INCLUDE SYSLIB  (IDACMB  )                                       */
*/*%INCLUDE SYSLIB  (IDACPA  )                                       */
*/*%INCLUDE SYSLIB  (IDACTREC)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IDADIWA )                                       */
*/*%INCLUDE SYSLIB  (IHADSAB )                                       */
*/*%INCLUDE SYSLIB  (IDADSL  )                                       */
*/*%INCLUDE SYSLIB  (IDAEDB  )                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IDAICWA )                                       */
*/*%INCLUDE SYSLIB  (IDAIDXCB)                                       */
*/*%INCLUDE SYSLIB  (IDAIMWA )                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IDALPMB )                                       */
*/*%INCLUDE SYSLIB  (IDAOPWRK)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAQDB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IEESMCA )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IDAVAT  )                                       */
*/*%INCLUDE SYSLIB  (IDAVSRT )                                       */
*/*%INCLUDE SYSLIB  (IDAWSHD )                                       */
*/*%INCLUDE SYSLIB  (IDAFOREC)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                       */
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                       */
*/*%INCLUDE SYSLIB  (IDARTMAC)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  1202
*       ;                                                          1202
@DATA    DS    0H
@SM05664 MVC   ARDKEYS(0,R9),CTKEY(R7)
@SM05666 MVC   ARDKEYS(0,@11),CTKEY(@15)
@SC05668 CLC   ARDKEYS(0,R9),CTKEY(R7)
@SC05670 CLC   ARDKEYS(0,@11),CTKEY(@01)
@SC05672 CLC   ARDKEYS(0,R9),LOKY(LOKYAD)
@SC05674 CLC   ARDKEYS(0,R9),ARDKEYS(R7)
@SC05676 CLC   ARDKEYS(0,R9),ARDKEYS(TEMPLKAR)
@SC05678 CLC   ARDKEYS(0,@01),CTKEY(R7)
@SM05681 MVC   DEBXTN(0,@05),DEBXTN(@10)
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
@TF00001 DS    F
IDA0192Z CSECT
         DS    0F
@CF00053 DC    F'1'
@CH00053 EQU   @CF00053+2
@CF00092 DC    F'2'
@CF00032 DC    F'3'
@CH00032 EQU   @CF00032+2
@CF00095 DC    F'4'
@CF00038 DC    F'8'
@CF00050 DC    F'16'
@CH00050 EQU   @CF00050+2
@CF00443 DC    F'20'
@CH00443 EQU   @CF00443+2
@CF00118 DC    F'24'
@CH00118 EQU   @CF00118+2
@CF04848 DC    F'29'
@CF02794 DC    F'35'
@CF02810 DC    F'48'
@CF00428 DC    F'60'
@CF02824 DC    F'68'
@CF02827 DC    F'76'
@CF02684 DC    F'84'
@CF02710 DC    F'96'
@CF02849 DC    F'124'
@CH02849 EQU   @CF02849+2
@CF02632 DC    F'132'
@CF05646 DC    F'55640'
@CF05650 DC    F'-2048'
@CF05649 DC    F'-2047'
@CF05652 DC    F'-8'
@CF05651 DC    F'-4'
@CF05648 DC    F'-3'
@DATD    DSECT
         DS    0D
DSABPTR  DS    A
RETCONT  DS    F
C1       DS    F
C2       DS    F
C4       DS    F
AMBP     DS    A
CURLPMB  DS    A
HARDBAD  DS    A
LASTICWA DS    A
LASTARDB DS    A
LOKYARDB DS    A
ARDRBA   DS    F
DDKR     DS    AL4
         ORG   DDKR
DD       DS    FL2
K        DS    FL1
R        DS    FL1
         ORG   DDKR+4
USSA     DS    AL4
         ORG   USSA
U        DS    FL1
SSA      DS    AL3
         ORG   USSA+4
WRK1     DS    F
BITBANK  DS    CL1
         ORG   BITBANK
SSONHIT  DS    BL1
SSOFHIT  EQU   BITBANK+0
HITHL    EQU   BITBANK+0
HITSS    EQU   BITBANK+0
SMFACTV  EQU   BITBANK+0
         ORG   BITBANK+1
         DS    CL3
LOCKSAVE DS    CL8
         ORG   LOCKSAVE
@NM00251 DS    2A
         ORG   LOCKSAVE+8
CBTAB    DS    CL28
         ORG   CBTAB
AMBAD    DS    AL4
AMDSBAD  DS    AL4
ARDBAD   DS    AL4
DEBAD    DS    AL4
EDBAD    DS    AL4
IWAAD    DS    AL4
LPMBAD   DS    AL4
         ORG   CBTAB+28
PARM192Y DS    CL52
RETSAVE  DS    8A
IDA0192Z CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV05524 DC    V(IDA0192Y)
@CV05525 DC    V(IDA0192M)
         DS    0D
@CC02110 DC    C' IDADSL '
@CC05338 DC    C'192Z'
NOEXEXIT DS    CL8
         ORG   NOEXEXIT
@NM00254 DC    8X'FF'
         ORG   NOEXEXIT+8
IDA0192Z CSECT
*                                                          /*@Z30SSDT*/
         DS    0D                   START ON DOUBLE WORD BOUNDARY
PTCH192Z DC    ((*-IDA0192Z)/20)X'00' PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192Z CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
VSRTAD   EQU   @05
TEMPLKAR EQU   @05
LOKYAD   EQU   @05
CURKEYNO EQU   @08
CUREXTNO EQU   @05
LENGLPMB EQU   @07
ARDBSIZE EQU   @05
C5       EQU   @11
C3       EQU   @10
CSWORD2  EQU   @06
CSWORD1  EQU   @05
RDEB     EQU   @11
RCORE    EQU   @04
RTIOT    EQU   @09
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
R13      EQU   @13
R4       EQU   @04
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
RUCB     EQU   @10
R10      EQU   @10
R11      EQU   @11
RET      EQU   @14
RETCODE  EQU   @15
R15      EQU   @15
R5       EQU   @05
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBUBF   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBRST   EQU   ACBMACR2
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBLSR   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBTIOT  EQU   ACBDDNM
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBINFL1 EQU   ACBINFLG
ACBCAT   EQU   ACBINFL1
ACBSCRA  EQU   ACBINFL1
ACBUCRA  EQU   ACBINFL1
ACBVVIC  EQU   ACBINFL1
ACBSDS   EQU   ACBVVIC
ACBINFL2 EQU   ACBINFLG+1
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAMB   EQU   0
AMBID    EQU   IDAAMB
AMBLEN   EQU   IDAAMB+2
AMBLINK  EQU   IDAAMB+4
AMBBUFC  EQU   IDAAMB+8
AMBPH    EQU   IDAAMB+12
AMBCACB  EQU   IDAAMB+16
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBPSDS  EQU   AMBFLG0
AMBSWSP  EQU   AMBFLG0
AMBFLG1  EQU   IDAAMB+25
AMBCREAT EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBINBUF EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBDORGA EQU   AMBDSORG+1
AMBIOBAD EQU   IDAAMB+28
AMBIOMB  EQU   AMBIOBAD
AMBCDSN  EQU   IDAAMB+32
AMBDDSN  EQU   IDAAMB+35
AMBTIOT  EQU   IDAAMB+40
AMBINFL  EQU   IDAAMB+42
AMBCAT   EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSDS   EQU   AMBINFL
AMBAMETH EQU   IDAAMB+43
AMBDEBPT EQU   IDAAMB+44
AMBDEBAD EQU   AMBDEBPT+1
AMBOFLGS EQU   IDAAMB+48
AMBEXFG  EQU   AMBOFLGS
AMBBUSY  EQU   AMBOFLGS
AMBFLG2  EQU   IDAAMB+49
AMBEDB   EQU   IDAAMB+52
AMBEOVPT EQU   IDAAMB+56
AMBWKA   EQU   IDAAMB+60
AMBIWA   EQU   IDAAMB+64
AMBPIXP  EQU   IDAAMB+72
AMBPAMBL EQU   IDAAMB+76
AMBUPLH  EQU   IDAAMB+80
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
AMBLSR   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBCPA   EQU   IDAAMB+92
AMBWSHD  EQU   IDAAMB+96
AMBEXEX  EQU   IDAAMB+100
AMBSZRD  EQU   IDAAMB+108
AMBSZWR  EQU   IDAAMB+110
AMBSZFW  EQU   IDAAMB+112
AMBSZCP  EQU   IDAAMB+114
AMBTRACE EQU   IDAAMB+120
IDAAMBXN EQU   0
AMBXEOV  EQU   IDAAMBXN
AMBXCSWD EQU   IDAAMBXN+16
IDAIOMBX EQU   0
IOMXFLGS EQU   IDAIOMBX+1
IOMXPDET EQU   IDAIOMBX+4
IOMXRECB EQU   IDAIOMBX+20
IOMXECB  EQU   IOMXRECB
IOMXRSLT EQU   IOMXECB
IDAAMBL  EQU   0
AMBLACB  EQU   IDAAMBL+8
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLXPT  EQU   IDAAMBL+24
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLPATH EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLQ2   EQU   IDAAMBL+31
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLVVIC EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLFLG2 EQU   IDAAMBL+36
AMBLNUM  EQU   IDAAMBL+38
AMBLDTA  EQU   IDAAMBL+52
AMBLIX   EQU   IDAAMBL+56
AMBLBIB  EQU   IDAAMBL+60
AMBLCMB  EQU   IDAAMBL+64
IDATRACE EQU   0
SAVE1X   EQU   IDATRACE
TRAENTRY EQU   SAVE1X
REPLY@   EQU   IDATRACE+180
REPLYMSG EQU   REPLY@+16
OUTLINE  EQU   IDATRACE+208
MESSAGES EQU   OUTLINE
HEADER   EQU   MESSAGES
STATUS   EQU   IDATRACE+496
STATUS2  EQU   IDATRACE+497
SAVEIN1  EQU   IDATRACE+500
SAVE2X   EQU   IDATRACE+560
SAVE3X   EQU   IDATRACE+1120
FLAG0    EQU   IDATRACE+1740
FLAG1    EQU   IDATRACE+1741
FLAG2    EQU   IDATRACE+1742
FLAG3    EQU   IDATRACE+1743
FLAG4    EQU   IDATRACE+1744
FLAG5    EQU   IDATRACE+1745
AIXOPT   EQU   IDATRACE+1750
AMCBS    EQU   0
CBSCMP   EQU   AMCBS+16
CBSVSRT  EQU   AMCBS+32
CBSVPTR  EQU   CBSVSRT+4
IDAAMDSB EQU   0
AMDSBID  EQU   IDAAMDSB
AMDATTR  EQU   IDAAMDSB+1
AMDSDT   EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDLEN   EQU   IDAAMDSB+2
AMDNEST  EQU   IDAAMDSB+4
AMDKEYLN EQU   IDAAMDSB+8
AMDCIPCA EQU   IDAAMDSB+12
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDPARDB EQU   IDAAMDSB+36
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
AMDNLR   EQU   AMDSTAT+12
AMDDELR  EQU   AMDSTAT+16
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
IDAARDB  EQU   0
ARDID    EQU   IDAARDB
ARDTYPE  EQU   IDAARDB+1
ARDKR    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDEOD   EQU   ARDTYPE
ARDLEN   EQU   IDAARDB+2
ARDNPTR  EQU   IDAARDB+4
ARDHKRBA EQU   IDAARDB+8
ARDHRBA  EQU   IDAARDB+12
ARDERBA  EQU   IDAARDB+16
ARDVOLSR EQU   IDAARDB+20
ARDRELNO EQU   IDAARDB+26
ARDPRF   EQU   IDAARDB+28
ARDPRFMT EQU   ARDPRF
ARDKEYS  EQU   IDAARDB+29
IDABIB   EQU   0
BIBHDR   EQU   IDABIB
BIBFLG1  EQU   BIBHDR+1
BIBWSHD  EQU   IDABIB+44
BIBRTNS  EQU   IDABIB+60
IDABLPRM EQU   0
BLPBUFLP EQU   IDABLPRM+4
BLPUACB  EQU   BLPBUFLP
BLPFLAGS EQU   IDABLPRM+10
BLPFLAG1 EQU   BLPFLAGS
BLPFLAG2 EQU   BLPFLAGS+1
BLPFUPGR EQU   BLPFLAG2
BLPFPATH EQU   BLPFLAG2
BLPFPRIM EQU   BLPFLAG2
BLPFDATA EQU   BLPFLAG2
BLPFINDX EQU   BLPFLAG2
BLPCORE  EQU   IDABLPRM+16
BLPGFLG  EQU   BLPCORE
BLPIOACB EQU   IDABLPRM+24
BLPBUFL  EQU   0
BLPBRLFG EQU   BLPBUFL+4
IDABSPH  EQU   0
BSPHFLG1 EQU   IDABSPH+1
BSPHNBSP EQU   IDABSPH+8
BSPHBSZ  EQU   IDABSPH+24
BSPHCSRC EQU   IDABSPH+28
BSPHFLG2 EQU   BSPHCSRC
IDACMB   EQU   0
CMBFLGS  EQU   IDACMB+4
CMBOUT   EQU   CMBFLGS
CMBNST   EQU   IDACMB+5
CMBPTRS  EQU   IDACMB+8
IDACPA   EQU   0
CPAWPHAD EQU   IDACPA+36
CPAWSEEK EQU   CPAWPHAD+1
CPARPHAD EQU   IDACPA+52
CPARSEEK EQU   CPARPHAD+1
CPASTAT1 EQU   IDACPA+83
CPAFLAGS EQU   IDACPA+84
CPAFLAG1 EQU   CPAFLAGS
CPAFLAG2 EQU   CPAFLAGS+1
CPACCW   EQU   0
AMBWORK  EQU   0
AMACATLG EQU   AMBWORK
VOLENTNO EQU   AMBWORK+12
CTINFO   EQU   AMBWORK+14
CTATTRA  EQU   CTINFO
CTAMDSPD EQU   CTATTRA
CTTOVFL  EQU   CTATTRA
CTATTRB  EQU   CTINFO+1
CTCYL    EQU   CTATTRB
CTINDXSS EQU   CTATTRB
CTINDX   EQU   CTATTRB
CTSHROP  EQU   CTINFO+2
CTHELP   EQU   CTSHROP
CTSDHELP EQU   CTSHROP
CTAUTH   EQU   CTINFO+3
CTBLKSZ  EQU   CTINFO+6
CTDEVTYP EQU   CTINFO+10
CTDEV2   EQU   CTDEVTYP+1
CTVIRT   EQU   CTDEV2
CTTRKAU  EQU   CTINFO+14
CTSTRKAU EQU   CTINFO+18
CTBLKTR  EQU   CTINFO+22
CTSBLKTR EQU   CTINFO+26
CTBYTAU  EQU   CTINFO+30
CTBYTTRK EQU   CTINFO+38
CTHSHDSN EQU   CTINFO+46
CTHSHCAT EQU   CTINFO+50
CTHURBA  EQU   CTINFO+54
CTEXEX   EQU   CTINFO+66
CTAMDSB  EQU   CTINFO+118
CTVOLENT EQU   0
CTVOLFLG EQU   CTVOLENT
CTVOLMT  EQU   CTVOLFLG
CTOFLOW  EQU   CTVOLFLG
CTNOEXT  EQU   CTVOLENT+1
CTVOLUCB EQU   CTVOLENT+4
CTNOKEY  EQU   CTVOLENT+8
CTKEYLEN EQU   CTVOLENT+10
CTVOLSER EQU   CTVOLENT+12
CTKEYENT EQU   0
CTKEYFLG EQU   CTKEYENT
CTSSWDTA EQU   CTKEYFLG
CTNOKEXT EQU   CTKEYENT+1
CTKRELNO EQU   CTKEYENT+2
CTKHKRBA EQU   CTKEYENT+4
CTKHURBA EQU   CTKEYENT+8
CTKHARBA EQU   CTKEYENT+12
CTKEY    EQU   CTKEYENT+16
CTEXTENT EQU   0
CTABSBEG EQU   CTEXTENT+2
CTCCBEG  EQU   CTABSBEG
CTHHBEG  EQU   CTABSBEG+2
CTABSEND EQU   CTEXTENT+6
CTRBABEG EQU   CTEXTENT+12
CTRBAEND EQU   CTEXTENT+16
CVTMAP   EQU   0
CVTZDTAB EQU   CVTMAP+64
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTBRET  EQU   CVTMAP+82
CVTSVDCB EQU   CVTMAP+84
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTSMCA  EQU   CVTMAP+196
CVT0SCR1 EQU   CVTMAP+232
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTCBSP  EQU   CVTMAP+256
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBTCBB  EQU   DEBTCBAD+1
DEBDEBAD EQU   DEBBASIC+4
DEBDEBB  EQU   DEBDEBAD+1
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBXTNIN EQU   DEBFLGS1
DEBUSRPG EQU   DEBBASIC+16
DEBNMEXT EQU   DEBUSRPG
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBPRIOR EQU   DEBECBAD
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBDEBID EQU   DEBPROTG
DEBDCBB  EQU   DEBDCBAD+1
DEBAPPAD EQU   DEBBASIC+28
DEBEXSCL EQU   DEBAPPAD
DEBAPPB  EQU   DEBAPPAD+1
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBDVMOD EQU   DEBUCBAD
DEBUCBA  EQU   DEBUCBAD+1
DEBSTRCC EQU   DEBDASD+6
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBEOEAD EQU   DEBEOEA+1
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPGFX  EQU   DEBSIOAB
DEBSIOAD EQU   DEBSIOA+1
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBPCIAD EQU   DEBPCIA+1
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBCEAD  EQU   DEBCEA+1
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBXCEAD EQU   DEBXCEA+1
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBLNGTH EQU   DEBPREFX+12
DEBXTN   EQU   0
DEBXLNGH EQU   DEBXTN
DEBXFLG1 EQU   DEBXTN+2
DEBXDSAB EQU   DEBXTN+4
DEBXDBPR EQU   DEBXTN+12
IDADIWA  EQU   0
DIWID    EQU   IDADIWA
DIWLEN   EQU   IDADIWA+2
DIWFLG1  EQU   IDADIWA+4
DIWCISPL EQU   DIWFLG1
DIWFLG2  EQU   IDADIWA+5
DIWSAVE  EQU   IDADIWA+28
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABANMI EQU   0
DSABGIDL EQU   0
IDADSL   EQU   0
DSLSUBPL EQU   IDADSL
DSLLENTH EQU   IDADSL+1
DSLID    EQU   IDADSL+4
DSLNXPTR EQU   IDADSL+12
DSLACTEN EQU   IDADSL+16
DSLENTRY EQU   IDADSL+20
DSLFLG   EQU   DSLENTRY
DSLDEBAD EQU   DSLENTRY+1
IDAEDBHD EQU   0
EDBID    EQU   IDAEDBHD
EDBNO    EQU   IDAEDBHD+1
EDBLEN   EQU   IDAEDBHD+2
EDBLPMBC EQU   IDAEDBHD+4
IDAEDB   EQU   0
EDBFLG1  EQU   IDAEDB+2
EDBLKR   EQU   EDBFLG1
EDBTOFLW EQU   EDBFLG1
EDBPSDS  EQU   EDBFLG1
EDBM     EQU   IDAEDB+3
EDBLPMBA EQU   IDAEDB+4
EDBSTTRK EQU   IDAEDB+8
EDBLORBA EQU   IDAEDB+12
EDBHIRBA EQU   IDAEDB+16
EDBTKBAL EQU   IDAEDB+20
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLSYNF  EQU   EXLCOMN+10
EXLLERF  EQU   EXLCOMN+15
EXLSCIPF EQU   EXLCOMN+20
EXLUPADF EQU   EXLSCIPF
EXLSCIPS EQU   EXLUPADF
EXLSCIPA EQU   EXLUPADF
EXLSCIPK EQU   EXLUPADF
EXLSCIPP EQU   EXLCOMN+21
EXLLGNF  EQU   EXLCOMN+25
EXLJRNF  EQU   EXLCOMN+30
EXLOPNF  EQU   EXLCOMN+35
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLEXITP EQU   EXLENTRY+1
IDAICWA  EQU   0
ICWID    EQU   IDAICWA
ICWFLG1  EQU   IDAICWA+1
ICWLEN   EQU   IDAICWA+2
ICWCHN   EQU   IDAICWA+4
IDAIMWA  EQU   0
IMWID    EQU   IDAIMWA
IMWFLAGS EQU   IDAIMWA+1
IMWLEN   EQU   IDAIMWA+2
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBSHR  EQU   JSCBSEC1+8
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
IDALPMB  EQU   0
LPMBID   EQU   IDALPMB
LPMBFLGS EQU   IDALPMB+1
LPMBRPS  EQU   LPMBFLGS
LPMREPL  EQU   LPMBFLGS
LPMSS    EQU   LPMBFLGS
LPMBTOFL EQU   LPMBFLGS
LPMBSSTH EQU   LPMBFLGS
LPMBLEN  EQU   IDALPMB+2
LPMAUSZ  EQU   IDALPMB+4
LPMBPTRK EQU   IDALPMB+8
LPMBLKSZ EQU   IDALPMB+12
LPMTRKAU EQU   IDALPMB+16
LPMTPC   EQU   IDALPMB+18
LPMBLKTR EQU   IDALPMB+20
LPMBSST  EQU   IDALPMB+28
IDAOPWRK EQU   0
OPWFLGS1 EQU   IDAOPWRK+12
OPWCAT   EQU   OPWFLGS1
OPWVVIC  EQU   OPWFLGS1
OPWFLGS2 EQU   IDAOPWRK+13
OPWFLGS3 EQU   IDAOPWRK+14
OPWRSTRT EQU   OPWFLGS3
OPWFLGS4 EQU   IDAOPWRK+15
OPWCOMWA EQU   IDAOPWRK+20
OPWIDF   EQU   IDAOPWRK+24
OPWQ     EQU   OPWIDF+7
OPWGSR   EQU   OPWQ
OPWLSR   EQU   OPWQ
OPWFSTP  EQU   OPWQ
OPWVSMPL EQU   IDAOPWRK+32
OPWVMANC EQU   OPWVSMPL
OPWVMSP  EQU   OPWVSMPL+4
OPWVMLNG EQU   OPWVSMPL+5
OPWVMADR EQU   OPWVSMPL+8
OPWVMTYP EQU   OPWVSMPL+12
OPWVMFLG EQU   OPWVSMPL+13
OPWVMNSL EQU   OPWVMFLG
OPWVSMWA EQU   IDAOPWRK+48
OPWVGSPL EQU   OPWVSMWA+40
OPWVLSAV EQU   OPWVSMWA+80
OPWVFMPL EQU   OPWVSMWA+88
OPWSAVE  EQU   IDAOPWRK+144
OPWDSL   EQU   OPWSAVE+12
OPWCURPT EQU   IDAOPWRK+164
OPWBAMBL EQU   IDAOPWRK+184
OPWQ2    EQU   IDAOPWRK+198
OPWCATTR EQU   IDAOPWRK+199
OPWSWSP  EQU   OPWCATTR
OPWPSDS  EQU   OPWCATTR
OPWWRKPT EQU   IDAOPWRK+208
OPWDTWRK EQU   IDAOPWRK+212
OPWIXWRK EQU   IDAOPWRK+216
OPWTIOT  EQU   IDAOPWRK+228
OPWBSECL EQU   IDAOPWRK+568
OPWPTAIX EQU   IDAOPWRK+576
OPWUPAIX EQU   IDAOPWRK+588
OPWCURCL EQU   0
OPWCFLG1 EQU   OPWCURCL
OPWPATH  EQU   OPWCFLG1
OPWUPGR  EQU   OPWCFLG1
OPWFLG2  EQU   OPWCURCL+4
OPWMODWK EQU   OPWFLG2
QDB      EQU   0
QDBFELMP EQU   QDB+12
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00172 EQU   RBSECT+10
@NM00173 EQU   @NM00172
RBTRSVRB EQU   @NM00173
@NM00175 EQU   @NM00172+1
RBETXR   EQU   @NM00175
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00182 EQU   RBSECT+28
@NM00183 EQU   @NM00182
IRBEND   EQU   RBSECT+96
@NM00186 EQU   RBSECT+96
RBRSV138 EQU   @NM00186+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
SMCABASE EQU   0
SMCAOPT  EQU   SMCABASE
SMCADSA  EQU   SMCAOPT
SMCAMISC EQU   SMCABASE+1
SMCAUSER EQU   SMCAMISC
SMCAMAN  EQU   SMCAMISC
SMCABUF  EQU   SMCABASE+12
SMCAPSTA EQU   SMCABASE+30
SMCAPLBL EQU   SMCABASE+34
SMCASTA  EQU   SMCABASE+46
SMCAALBL EQU   SMCABASE+50
SMCAENTY EQU   SMCABASE+80
SMCAENDI EQU   SMCAENTY
SMCAFOPT EQU   SMCABASE+82
SMCASWA  EQU   SMCABASE+104
SMCAASCB EQU   SMCABASE+120
SMCAPGIN EQU   SMCABASE+136
SMCAPGOT EQU   SMCABASE+140
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBDEB   EQU   TCB+8
TCBTIO   EQU   TCB+12
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBDSP   EQU   TCB+35
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
TIOEFSRT EQU   TIOENTRY+17
POOLSTAR EQU   TIOENTRY+20
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCBRR    EQU   UCBDUDN1
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00198 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBSHRUP EQU   UCBFLP1
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
IDAVAT   EQU   0
VATHDR   EQU   IDAVAT
VATVSRT  EQU   IDAVAT+8
VATVPTR  EQU   VATVSRT+4
VATVC    EQU   IDAVAT+20
IDAVSRT  EQU   0
VSRTFLGS EQU   IDAVSRT+12
VSRTPLHH EQU   IDAVSRT+16
VSRTBUFH EQU   IDAVSRT+20
VSRTCPAH EQU   IDAVSRT+24
VSRTWAH  EQU   IDAVSRT+28
VSRTCSL  EQU   IDAVSRT+44
VSRTCSLF EQU   VSRTCSL
VSRTCSBF EQU   VSRTCSLF
VSRTCSPF EQU   VSRTCSLF
IDAWSHD  EQU   0
WSHDACHN EQU   IDAWSHD+4
WSHDSLT  EQU   IDAWSHD+28
WSHDSAD  EQU   WSHDSLT
@NM00202 EQU   WSHDSAD
WSHDSGMW EQU   WSHDSLT+4
WSHDSFM  EQU   WSHDSGMW
WSHDSFLG EQU   WSHDSGMW+10
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXJBF    EQU   FORCORE+100
DXIOB    EQU   FORCORE+280
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUKEY   EQU   FORCORE+526
DXDSABAD EQU   FORCORE+544
DXDEBXAD EQU   FORCORE+552
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXB1 EQU   DXATEXC1
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECWTGTB EQU   IECEXTPR+72
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
IDAPDPRM EQU   0
PDPMSGFL EQU   IDAPDPRM+34
IDAVGTT  EQU   0
VGTTTYPE EQU   IDAVGTT+4
LOKY     EQU   0
SAVAREA  EQU   0
SABWRD   EQU   SAVAREA+4
SAREGS   EQU   SAVAREA+12
SACODE   EQU   SAREGS+4
CTCOMMON EQU   0
DEVTABOF EQU   0
DEVTAB   EQU   0
DEVTABTC EQU   DEVTAB+2
ICWKEY2  EQU   0
ICWKEY3  EQU   0
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCDSABQ EQU   JSCBSEC3+60
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
PSARSVTE EQU   PSARSVT
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00197 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00232 EQU   DXXCTL
DXSAVMOD EQU   @NM00232+2
@NM00233 EQU   DXRESSW
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
PDWLIST  EQU   FORCORE
PDWWORK  EQU   DXDCB
IDARRPL  EQU   DXATCOM1
IDARRFLG EQU   IDARRPL+1
IDARSTAT EQU   DXATEXC1
RSTAT    EQU   IDARSTAT
RSTATCRO EQU   RSTAT+1
RSTATOP2 EQU   RSTAT+2
IDARRTN  EQU   DXATEXC2
RSTATRTN EQU   IDARRTN
PD       EQU   SACODE
PPCODE   EQU   PD
PPFUNC   EQU   PD+1
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
FLC      EQU   PSA
IDAESPL  EQU   DXATCOM1
IDARTSA  EQU   DXJBF
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00252 EQU   PD+3
PPSFC    EQU   PD+2
@NM00250 EQU   RSTAT+3
@NM00249 EQU   RSTATOP2
RSTATCSA EQU   RSTATOP2
IDARCURS EQU   RSTATCRO
IDARCRCU EQU   RSTATCRO
IDARRSTR EQU   RSTATCRO
IDARCKPT EQU   RSTATCRO
RSTATOPT EQU   RSTAT
@NM00248 EQU   IDARRPL+2
@NM00247 EQU   IDARRFLG
RRPLVSAM EQU   IDARRFLG
@NM00246 EQU   IDARRFLG
@NM00245 EQU   IDARRPL
PDWORKSP EQU   PDWWORK+88
PDWERRCD EQU   PDWWORK+84
PDWMSGPT EQU   PDWWORK+80
PDWSAVED EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00237 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00236 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00235 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
DXRESIND EQU   @NM00233
DXSAVOFF EQU   @NM00232+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00232
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00217 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00216 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00215 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00197
UCBSKPFG EQU   @NM00197
UCBRIPND EQU   @NM00197
UCBRTIAC EQU   @NM00197
UCBRSV79 EQU   @NM00197
UCBRSV78 EQU   @NM00197
UCBRSV77 EQU   @NM00197
UCBOLTEP EQU   @NM00197
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00196 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00187 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBCDSAVE EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00120 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00119 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00253 EQU   DEVTAB
CTCISIZI EQU   CTCOMMON+4
CTCISIZD EQU   CTCOMMON
SAREG    EQU   SAREGS+8
SARTRN   EQU   SAREGS
SAFWRD   EQU   SAVAREA+8
SABWRD0  EQU   SAVAREA
VGTTCORE EQU   IDAVGTT+32
@NM00244 EQU   IDAVGTT+28
VGTTPSB  EQU   IDAVGTT+24
VGTTVUSE EQU   IDAVGTT+20
VGTTBIB  EQU   IDAVGTT+16
VGTTNEXT EQU   IDAVGTT+12
VGTTSIZE EQU   IDAVGTT+8
VGTTSP   EQU   IDAVGTT+7
VGTTGSRK EQU   IDAVGTT+6
@NM00243 EQU   IDAVGTT+5
@NM00242 EQU   VGTTTYPE
VGTTCBIC EQU   VGTTTYPE
VGTTOPEN EQU   VGTTTYPE
VGTTCTLG EQU   VGTTTYPE
VGTTLSR  EQU   VGTTTYPE
VGTTGSR  EQU   VGTTTYPE
VGTTSDS  EQU   VGTTTYPE
VGTTID   EQU   IDAVGTT
PDPSFI   EQU   IDAPDPRM+36
@NM00241 EQU   IDAPDPRM+35
PDPNOMSG EQU   PDPMSGFL
PDPNOTRC EQU   PDPMSGFL
PDPSPACE EQU   PDPMSGFL
PDPNOTFC EQU   PDPMSGFL
PDPDSTYP EQU   IDAPDPRM+33
PDPKEY   EQU   IDAPDPRM+32
PDPCTACB EQU   IDAPDPRM+28
PDPDSN   EQU   IDAPDPRM+24
PDPCLSNM EQU   IDAPDPRM+20
PDPVLSER EQU   IDAPDPRM+16
PDPTIOT  EQU   IDAPDPRM+12
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPSFC   EQU   IDAPDPRM+3
PDPFUNC  EQU   IDAPDPRM+2
PDPCODE  EQU   IDAPDPRM+1
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00240 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00239 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00238 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00234 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00231 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00230 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00229 EQU   WTGAREA+20
@NM00228 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00227 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00226 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00225 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00224 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00223 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00222 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00221 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00220 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00219 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00218 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
DXATEXB2 EQU   DXATEXC2
DXEXHASP EQU   DXATEXB1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00214 EQU   DXATCOM2+3
@NM00213 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00212 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00211 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
DXPACBAD EQU   DXPDCBAD+1
@NM00210 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00209 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00208 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDSAB   EQU   FORCORE+548
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00207 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
@NM00206 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00205 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00204 EQU   DXDAADDR
DXECB    EQU   FORCORE+276
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
WSHDSBM  EQU   WSHDSGMW+11
WSHDSFNO EQU   WSHDSFLG
WSHDSBV  EQU   WSHDSGMW+8
WSHDSONX EQU   WSHDSGMW+4
WSHDSFLN EQU   WSHDSFM+1
WSHDSFSP EQU   WSHDSFM
WSHDGSR  EQU   @NM00202
@NM00203 EQU   @NM00202
WSHDOCHN EQU   IDAWSHD+24
WSHDGMRA EQU   IDAWSHD+20
WSHDNUS  EQU   IDAWSHD+18
WSHDGMWA EQU   IDAWSHD+8
WSHDNEXT EQU   WSHDACHN+1
WSHDGMTB EQU   WSHDACHN
WSHDLEN  EQU   IDAWSHD+2
WSHDPOOL EQU   IDAWSHD+1
WSHDID   EQU   IDAWSHD
VSRTCSLN EQU   VSRTCSL+5
VSRTCSSP EQU   VSRTCSL+4
VSRTCSAD EQU   VSRTCSL+1
VSRTCSBH EQU   VSRTCSLF
VSRTCSIO EQU   VSRTCSLF
VSRTCSPL EQU   VSRTCSLF
VSRTCSWS EQU   VSRTCSLF
VSRTCSVG EQU   VSRTCSPF
VSRTCSGT EQU   VSRTCSBF
VSRTCSVS EQU   VSRTCSLF
VSRTCSFX EQU   VSRTCSLF
VSRTNEXT EQU   IDAVSRT+40
VSRTASCB EQU   IDAVSRT+36
VSRTVIOT EQU   IDAVSRT+32
VSRTSTRN EQU   IDAVSRT+15
VSRTKL   EQU   IDAVSRT+14
@NM00201 EQU   VSRTFLGS
VSRTBFRF EQU   VSRTFLGS
VSRTIOBF EQU   VSRTFLGS
VSRTLSRF EQU   VSRTFLGS
VSRTGSRF EQU   VSRTFLGS
VSRTEOV  EQU   IDAVSRT+8
VSRTID   EQU   IDAVSRT+4
VSRTLEN  EQU   IDAVSRT+2
VSRTKEY  EQU   IDAVSRT+1
VSRTBKID EQU   IDAVSRT
VATAMBL  EQU   IDAVAT+28
VATNAE   EQU   IDAVAT+24
@NM00200 EQU   IDAVAT+22
VATENO   EQU   VATVC+1
VATVRT   EQU   VATVC
VATPAMBL EQU   IDAVAT+16
VATVUSE  EQU   VATVSRT
VATNEXT  EQU   IDAVAT+4
VATLEN   EQU   VATHDR+2
@NM00199 EQU   VATHDR+1
VATID    EQU   VATHDR
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00198
UCBHALI  EQU   @NM00198
UCBRSV09 EQU   @NM00198
UCBRSV08 EQU   @NM00198
UCBRSV07 EQU   @NM00198
UCBRSV06 EQU   @NM00198
UCBRSV05 EQU   @NM00198
UCBRSV04 EQU   @NM00198
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00195 EQU   UCB
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00194 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00193 EQU   POOLSTAR
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
@NM00192 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00191 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBSTAFX EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00190 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00189 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
SMCASTCB EQU   SMCABASE+176
SMCAWTCB EQU   SMCABASE+172
SMCAU83  EQU   SMCABASE+168
SMCAPGM  EQU   SMCABASE+164
SMCARGNM EQU   SMCABASE+160
SMCASPOT EQU   SMCABASE+156
SMCASPIN EQU   SMCABASE+152
SMCARGNS EQU   SMCABASE+148
SMCAPGRL EQU   SMCABASE+144
SMCADOMY EQU   SMCAPGOT
SMCADOMX EQU   SMCAPGIN
SMCATEXP EQU   SMCABASE+132
SMCASAVE EQU   SMCABASE+128
SMCARS21 EQU   SMCABASE+124
SMCATJID EQU   SMCAASCB+2
SMCAPOST EQU   SMCAASCB
SMCADSCT EQU   SMCABASE+116
SMCADSTM EQU   SMCABASE+108
SMCASWD  EQU   SMCABASE+107
SMCASWC  EQU   SMCABASE+106
SMCASWB  EQU   SMCABASE+105
SMCADSSW EQU   SMCASWA
SMCADSSP EQU   SMCASWA
SMCAZEOD EQU   SMCASWA
SMCANAVL EQU   SMCASWA
SMCANADA EQU   SMCASWA
SMCAOPFL EQU   SMCASWA
SMCADSTR EQU   SMCASWA
SMCASWAR EQU   SMCASWA
SMCAXNAM EQU   SMCABASE+96
@NM00188 EQU   SMCABASE+92
SMCAXCTL EQU   SMCABASE+88
SMCAWRTP EQU   SMCABASE+84
SMCAENAL EQU   SMCABASE+83
SMCAFGN  EQU   SMCAFOPT
SMCAFTDS EQU   SMCAFOPT
SMCAFR01 EQU   SMCAFOPT
SMCAFVOL EQU   SMCAFOPT
SMCAFDSA EQU   SMCAFOPT
SMCAFEXT EQU   SMCAFOPT
SMCAFOP2 EQU   SMCAFOPT
SMCAFOP1 EQU   SMCAFOPT
SMCAENOP EQU   SMCAENTY+1
SMCADSNF EQU   SMCAENDI
SMCARS20 EQU   SMCAENDI
SMCARS19 EQU   SMCAENDI
SMCARS18 EQU   SMCAENDI
SMCARS17 EQU   SMCAENDI
SMCARS16 EQU   SMCAENDI
SMCARS15 EQU   SMCAENDI
SMCARS14 EQU   SMCAENDI
SMCAWAIT EQU   SMCABASE+72
SMCASGFT EQU   SMCABASE+68
SMCASGWR EQU   SMCABASE+64
SMCABECB EQU   SMCABASE+60
SMCAWECB EQU   SMCABASE+56
SMCAADCB EQU   SMCABASE+52
SMCAYORX EQU   SMCABASE+51
SMCAANL  EQU   SMCAALBL
SMCAASL  EQU   SMCAALBL
SMCAANSL EQU   SMCAALBL
SMCARS13 EQU   SMCAALBL
SMCARS12 EQU   SMCAALBL
SMCARS11 EQU   SMCAALBL
SMCARS10 EQU   SMCAALBL
SMCARS09 EQU   SMCAALBL
SMCAADAR EQU   SMCABASE+47
SMCAAVOL EQU   SMCASTA
SMCAAUNT EQU   SMCASTA
SMCARS08 EQU   SMCASTA
SMCAAMOD EQU   SMCASTA
SMCAAMTY EQU   SMCASTA
SMCAADA  EQU   SMCASTA
SMCAATAP EQU   SMCASTA
SMCAANAV EQU   SMCASTA
SMCAADEV EQU   SMCABASE+40
SMCAPDCB EQU   SMCABASE+36
SMCAXORY EQU   SMCABASE+35
SMCAPNL  EQU   SMCAPLBL
SMCAPSL  EQU   SMCAPLBL
SMCAPNSL EQU   SMCAPLBL
SMCARS07 EQU   SMCAPLBL
SMCARS06 EQU   SMCAPLBL
SMCARS05 EQU   SMCAPLBL
SMCARS04 EQU   SMCAPLBL
SMCARS03 EQU   SMCAPLBL
SMCAPDAR EQU   SMCABASE+31
SMCAPVOL EQU   SMCAPSTA
SMCAPUNT EQU   SMCAPSTA
SMCARS02 EQU   SMCAPSTA
SMCAMOD  EQU   SMCAPSTA
SMCAPMTY EQU   SMCAPSTA
SMCAPDA  EQU   SMCAPSTA
SMCAPTAP EQU   SMCAPSTA
SMCAPNAV EQU   SMCAPSTA
SMCAPDEV EQU   SMCABASE+24
SMCABUFP EQU   SMCABASE+20
SMCASID  EQU   SMCABASE+16
SMCABSIZ EQU   SMCABUF
SMCAJWT  EQU   SMCABASE+8
SMCATIOT EQU   SMCABASE+4
SMCATOFF EQU   SMCABASE+2
SMCADUMP EQU   SMCAMISC
SMCABSW  EQU   SMCAMISC
SMCADBSY EQU   SMCAMISC
SMCAPSDP EQU   SMCAMISC
SMCAFIRT EQU   SMCAMISC
SMCAOPI  EQU   SMCAMISC
SMCAFGND EQU   SMCAOPT
SMCATDS  EQU   SMCAOPT
SMCARS01 EQU   SMCAOPT
SMCAVOL  EQU   SMCAOPT
SMCAEXT  EQU   SMCAOPT
SMCAOPT2 EQU   SMCAOPT
SMCAOPT1 EQU   SMCAOPT
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00186+8
PRBEND   EQU   @NM00186+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00186+6
RBRSV136 EQU   @NM00186+4
RBRSV135 EQU   @NM00186
@NM00185 EQU   RBSECT+32
@NM00184 EQU   @NM00182+1
RBSCF    EQU   @NM00183
RBPGMQ1  EQU   RBPGMQ+1
@NM00181 EQU   RBPGMQ
@NM00180 EQU   RBSECT+16
@NM00179 EQU   @NM00175
@NM00178 EQU   @NM00175
RBIQETP  EQU   @NM00175
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00175
@NM00177 EQU   @NM00175
@NM00176 EQU   @NM00175
RBPMSVRB EQU   @NM00173
RBATNXIT EQU   @NM00173
@NM00174 EQU   @NM00173
RBWAITP  EQU   @NM00173
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00173
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00171 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00170 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00169 EQU   RBOPSWB2
@NM00168 EQU   XRBPSW
@NM00167 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00166 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00165 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00164 EQU   XSTAB1
@NM00163 EQU   RBBASIC+8
@NM00162 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00161 EQU   RBPRFX
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
OPWCIXCI EQU   OPWCURCL+5
OPWIOPEN EQU   OPWFLG2
OPWERR2B EQU   OPWFLG2
OPWEMPUP EQU   OPWFLG2
OPWDOPEN EQU   OPWFLG2
OPWCDTCI EQU   OPWCURCL+1
OPWPRTBL EQU   OPWCFLG1
OPWSVWRK EQU   OPWCFLG1
OPWBASE  EQU   OPWCFLG1
OPWUIXCI EQU   OPWUPAIX+5
@NM00136 EQU   OPWUPAIX+4
OPWUDTCI EQU   OPWUPAIX+1
@NM00135 EQU   OPWUPAIX
OPW2YPLH EQU   IDAOPWRK+585
OPWNOUPG EQU   IDAOPWRK+584
OPWPIXCI EQU   OPWPTAIX+5
@NM00134 EQU   OPWPTAIX+4
OPWPDTCI EQU   OPWPTAIX+1
@NM00133 EQU   OPWPTAIX
OPWBIXCI EQU   OPWBSECL+5
@NM00132 EQU   OPWBSECL+4
OPWBDTCI EQU   OPWBSECL+1
@NM00131 EQU   OPWBSECL
OPWSAVEA EQU   IDAOPWRK+564
OPWERMAP EQU   IDAOPWRK+308
OPWSFI   EQU   IDAOPWRK+296
OPWDACB  EQU   IDAOPWRK+244
@NM00130 EQU   IDAOPWRK+243
OPWBSTRN EQU   IDAOPWRK+242
OPWSTRNO EQU   IDAOPWRK+241
OPWCSTRN EQU   IDAOPWRK+240
OPWBUFNI EQU   IDAOPWRK+236
OPWBUFND EQU   IDAOPWRK+232
OPWJSTCB EQU   IDAOPWRK+224
OPWCTCB  EQU   IDAOPWRK+220
OPWUACB  EQU   IDAOPWRK+204
OPWUPT   EQU   IDAOPWRK+200
@NM00129 EQU   OPWCATTR
@NM00128 EQU   OPWQ2
OPWCBIC  EQU   OPWQ2
OPWCRA   EQU   IDAOPWRK+192
OPWPAMBL EQU   IDAOPWRK+188
OPWPCON  EQU   IDAOPWRK+180
OPWBCON  EQU   IDAOPWRK+176
OPWCAMBL EQU   IDAOPWRK+172
OPWXAMBL EQU   IDAOPWRK+168
OPWSSL   EQU   OPWSAVE+16
OPWPSL   EQU   OPWSAVE+8
OPWESL   EQU   OPWSAVE+4
OPWCSL   EQU   OPWSAVE
OPWVFMPT EQU   OPWVFMPL+4
OPWVFMLN EQU   OPWVFMPL+1
OPWVFMSP EQU   OPWVFMPL
OPWVRG13 EQU   OPWVLSAV+4
OPWVRG12 EQU   OPWVLSAV
OPWVANCS EQU   OPWVSMWA+76
OPWVREQL EQU   OPWVGSPL+9
OPWVGFLG EQU   OPWVGSPL+8
OPWVGSPT EQU   OPWVGSPL+4
OPWVGETL EQU   OPWVGSPL+1
OPWVGSSP EQU   OPWVGSPL
OPWVSAVE EQU   OPWVSMWA+24
OPWVR13  EQU   OPWVSMWA+20
OPWVHDRE EQU   OPWVSMWA+16
OPWVCSLE EQU   OPWVSMWA+12
OPWVCSLP EQU   OPWVSMWA+8
OPWVTBLP EQU   OPWVSMWA+4
OPWVANCP EQU   OPWVSMWA
@NM00127 EQU   OPWVSMPL+14
OPWVMTCB EQU   OPWVMFLG
OPWVMSRB EQU   OPWVMFLG
OPWVMDXK EQU   OPWVMFLG
OPWVMKE5 EQU   OPWVMFLG
OPWVMPGB EQU   OPWVMFLG
OPWDFR   EQU   OPWQ
OPWESDS  EQU   OPWQ
OPWKSDS  EQU   OPWQ
OPWUBF   EQU   OPWQ
OPWDDC   EQU   OPWQ
OPWDCI   EQU   OPWIDF+4
OPWCACB  EQU   OPWIDF
OPWBIB   EQU   IDAOPWRK+16
@NM00126 EQU   OPWFLGS4
OPWUPD   EQU   OPWFLGS4
OPWCINV  EQU   OPWFLGS4
OPWFULL  EQU   OPWFLGS4
@NM00125 EQU   OPWFLGS3
OPWNOWRK EQU   OPWFLGS3
OPWUPGOP EQU   OPWFLGS3
OPWPUPGR EQU   OPWFLGS3
OPWDAVAT EQU   OPWFLGS3
@NM00124 EQU   OPWFLGS2
OPWDUMMY EQU   OPWFLGS2
OPWAIXDT EQU   OPWFLGS2
OPWIXDT  EQU   OPWFLGS2
OPWUCRA  EQU   OPWFLGS2
@NM00123 EQU   OPWFLGS1
OPWSDS   EQU   OPWVVIC
OPWSCRA  EQU   OPWFLGS1
OPWID    EQU   IDAOPWRK+4
OPWLENTH EQU   IDAOPWRK+1
OPWSUBPL EQU   IDAOPWRK
LPMBEXT  EQU   IDALPMB+24
@NM00122 EQU   IDALPMB+22
@NM00121 EQU   LPMBFLGS
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00118 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00117 EQU   IEZJSCB
IMWKEY1  EQU   IDAIMWA+76
@NM00116 EQU   IDAIMWA+72
IMWNSOFF EQU   IDAIMWA+70
IMWCIMVN EQU   IDAIMWA+68
@NM00115 EQU   IDAIMWA+67
IMWSVIEL EQU   IDAIMWA+66
IMWIEL   EQU   IDAIMWA+65
IMWFGAIN EQU   IDAIMWA+64
IMWBUFP  EQU   IDAIMWA+60
IMWLBUFC EQU   IDAIMWA+56
IMWIPTR  EQU   IDAIMWA+52
IMWXPTR  EQU   IDAIMWA+48
IMWIKEYP EQU   IDAIMWA+44
IMWXKEYP EQU   IDAIMWA+40
IMWISWKA EQU   IDAIMWA+8
IMWIXSP  EQU   IDAIMWA+4
IMWBSE   EQU   IMWFLAGS
IMWRIPL  EQU   IMWFLAGS
IMWNEWHL EQU   IMWFLAGS
ICWKEY1  EQU   IDAICWA+60
ICWCERP  EQU   IDAICWA+59
ICWCEL   EQU   IDAICWA+58
ICWCEF   EQU   IDAICWA+57
ICWCER   EQU   IDAICWA+56
ICWPTL   EQU   IDAICWA+55
ICWREQ   EQU   IDAICWA+54
ICWCRSEG EQU   IDAICWA+52
ICWNOSEG EQU   IDAICWA+50
ICWNEST  EQU   IDAICWA+48
ICWKEY3L EQU   IDAICWA+46
ICWKEY2L EQU   IDAICWA+44
ICWKEY1L EQU   IDAICWA+42
ICWLN    EQU   IDAICWA+40
ICWARDBP EQU   IDAICWA+36
ICWTPTR  EQU   IDAICWA+32
ICWTBASE EQU   IDAICWA+28
ICWADD   EQU   IDAICWA+24
ICWSCNT  EQU   IDAICWA+22
ICWPSEO  EQU   IDAICWA+20
ICWPRBA  EQU   IDAICWA+16
ICWCRBA  EQU   IDAICWA+12
ICWBUFC  EQU   IDAICWA+8
ICWENDRQ EQU   ICWFLG1
ICWSPLIT EQU   ICWFLG1
ICWKRDS  EQU   ICWFLG1
ICWVNE   EQU   ICWFLG1
ICWVSE   EQU   ICWFLG1
ICWRBAOK EQU   ICWFLG1
ICWWAGM  EQU   ICWFLG1
ICWWNF   EQU   ICWFLG1
EXLEADDR EQU   EXLEXITP
@NM00114 EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLSPEC  EQU   EXLENFL
EXLOPNP  EQU   EXLCOMN+36
@NM00113 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
EXLJRNP  EQU   EXLCOMN+31
@NM00112 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
EXLLGNP  EQU   EXLCOMN+26
@NM00111 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLUPADP EQU   EXLSCIPP
@NM00110 EQU   EXLUPADF
EXLUPADK EQU   EXLSCIPK
EXLUPADA EQU   EXLSCIPA
EXLUPADS EQU   EXLSCIPS
EXLLERP  EQU   EXLCOMN+16
@NM00109 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
EXLSYNP  EQU   EXLCOMN+11
@NM00108 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
EXLEODP  EQU   EXLCOMN+6
@NM00107 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00106 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
EXLSTYP  EQU   EXLCOMN+1
EXLID    EQU   EXLCOMN
@NM00105 EQU   EDBFLG1
@NM00104 EQU   IDAEDB
DSLFDDEB EQU   DSLFLG
@NM00103 EQU   DSLFLG
@NM00102 EQU   IDADSL+18
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABSIOT EQU   DSAB+64
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00101 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00100 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00099 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00098 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00097 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABID   EQU   DSAB
@NM00096 EQU   IDADIWA+92
@NM00095 EQU   IDADIWA+88
@NM00094 EQU   IDADIWA+84
@NM00093 EQU   IDADIWA+80
@NM00092 EQU   IDADIWA+76
@NM00091 EQU   IDADIWA+72
@NM00090 EQU   IDADIWA+68
@NM00089 EQU   IDADIWA+64
@NM00088 EQU   IDADIWA+60
@NM00087 EQU   IDADIWA+56
DIWINRBA EQU   IDADIWA+52
DIWRKCT  EQU   IDADIWA+48
DIWSAVE5 EQU   DIWSAVE+16
DIWSAVE4 EQU   DIWSAVE+12
DIWSAVE3 EQU   DIWSAVE+8
DIWSAVE2 EQU   DIWSAVE+4
DIWSAVE1 EQU   DIWSAVE
DIWSPLTP EQU   IDADIWA+24
DIWBUFC  EQU   IDADIWA+20
DIWPLH   EQU   IDADIWA+16
DIWHRBA  EQU   IDADIWA+12
DIWLRBA  EQU   IDADIWA+8
@NM00086 EQU   IDADIWA+6
DIWFSPF  EQU   DIWFLG2
DIW1ST   EQU   DIWFLG1
DIWNOT1  EQU   DIWFLG1
DIWSHIFT EQU   DIWFLG1
DIWGSPC  EQU   DIWFLG1
DIWEOKR  EQU   DIWFLG1
DIWPFERR EQU   DIWFLG1
DIWCAS   EQU   DIWFLG1
DIWATV   EQU   IDADIWA+1
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDCBM EQU   DEBXTN+8
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00085 EQU   DEBACS08+12
@NM00084 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00083 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00082 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBBINUM EQU   DEBDASD+4
DEBECBB  EQU   DEBECBAD+1
DEBUSRPB EQU   DEBUSRPG+1
DEBRSV05 EQU   DEBBASIC+15
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBAMLNG EQU   DEBDEBAD
DEBNMSUB EQU   DEBTCBAD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00081 EQU   CVTFIX+248
@NM00080 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00079 EQU   CTEXTENT+20
CTNOTRKS EQU   CTEXTENT+10
CTHHEND  EQU   CTABSEND+2
CTCCEND  EQU   CTABSEND
@NM00078 EQU   CTEXTENT+1
CTEXTFLG EQU   CTEXTENT
CTPRFMT  EQU   CTKEYFLG
CTKEYEN1 EQU   CTVOLENT+20
@NM00077 EQU   CTVOLENT+18
@NM00076 EQU   CTVOLENT+2
@NM00075 EQU   CTINFO+214
CTDATANM EQU   CTINFO+74
CTCISIZ  EQU   CTINFO+62
CTBUFSIZ EQU   CTINFO+58
@NM00074 EQU   CTINFO+49
CTSBYTRK EQU   CTINFO+42
CTSBYTAU EQU   CTINFO+34
CTBRPS   EQU   CTDEV2
@NM00073 EQU   CTDEV2
@NM00072 EQU   CTDEVTYP
@NM00071 EQU   CTINFO+4
CTUPD    EQU   CTAUTH
CTCINV   EQU   CTAUTH
CTFULL   EQU   CTAUTH
CTUNUSE  EQU   CTSHROP
CTINTDS  EQU   CTSHROP
@NM00070 EQU   CTSHROP
CTSHRF   EQU   CTSHROP
CTSHRW   EQU   CTSHROP
CTSHARE  EQU   CTSHROP
CTOPEN   EQU   CTATTRB
CTTEMPEX EQU   CTATTRA
CTRDONLY EQU   CTATTRA
@NM00069 EQU   CTATTRA
CTERASE  EQU   CTATTRA
CTRELOP  EQU   CTATTRA
CTUNIQ   EQU   CTATTRA
AMATIOE  EQU   AMBWORK+8
AMALEN   EQU   AMBWORK+6
AMATIOT  EQU   AMBWORK+4
CPACCWTC EQU   CPACCW+24
CPACCWSI EQU   CPACCW+16
CPACCWSS EQU   CPACCW+8
CPACCWSK EQU   CPACCW
CPACPCHN EQU   IDACPA+92
CPANXT1  EQU   IDACPA+88
CPAWSECT EQU   IDACPA+87
CPARSECT EQU   IDACPA+86
CPATKOFL EQU   CPAFLAG2
CPAPFENT EQU   CPAFLAG2
CPAXLRA  EQU   CPAFLAG2
CPARREPL EQU   CPAFLAG2
CPAWREPL EQU   CPAFLAG2
@NM00068 EQU   CPAFLAG1
CPACHNED EQU   CPAFLAG1
CPARRPS  EQU   CPAFLAG1
CPAWRPS  EQU   CPAFLAG1
CPARV    EQU   CPAFLAG1
CPAWCV   EQU   CPAFLAG1
CPAWV    EQU   CPAFLAG1
CPAVPLV  EQU   CPASTAT1
CPASSECT EQU   IDACPA+82
CPABCINV EQU   IDACPA+80
CPABLKSZ EQU   IDACPA+76
CPAWORK2 EQU   IDACPA+72
CPAWORK1 EQU   IDACPA+68
CPAVPL   EQU   IDACPA+64
CPAIDAL  EQU   IDACPA+60
@NM00067 EQU   CPARPHAD+7
CPARSID  EQU   CPARSEEK+2
CPARBB   EQU   CPARSEEK
@NM00066 EQU   CPARPHAD
CPAFWCNT EQU   IDACPA+48
CPAWSID  EQU   IDACPA+44
CPAWPHR  EQU   CPAWPHAD+7
CPAWCHR  EQU   CPAWSEEK+2
CPAWBB   EQU   CPAWSEEK
@NM00065 EQU   CPAWPHAD
CPARCPE  EQU   IDACPA+32
CPARCPS  EQU   IDACPA+28
CPARREAL EQU   IDACPA+24
CPAWCKE  EQU   IDACPA+20
CPAWCKS  EQU   IDACPA+16
CPAWCPE  EQU   IDACPA+12
CPAWCPS  EQU   IDACPA+8
CPAWREAL EQU   IDACPA+4
CPALEN   EQU   IDACPA+2
@NM00064 EQU   IDACPA+1
CPAID    EQU   IDACPA
@NM00063 EQU   CMBPTRS+52
CMBFXDPT EQU   CMBPTRS+48
CMBPUSPT EQU   CMBPTRS+44
CMBPSTPT EQU   CMBPTRS+40
CMBEDBPT EQU   CMBPTRS+36
CMBDEBPT EQU   CMBPTRS+32
CMBUBFPT EQU   CMBPTRS+28
CMBBFRPT EQU   CMBPTRS+24
CMBUFSPT EQU   CMBPTRS+20
CMBFSTPT EQU   CMBPTRS+16
CMBUSPTR EQU   CMBPTRS+12
CMBSTPTR EQU   CMBPTRS+8
CMBPRPTR EQU   CMBPTRS+4
CMBUSRPT EQU   CMBPTRS
CMBCNT   EQU   IDACMB+6
CMBLEN   EQU   IDACMB+2
@NM00062 EQU   IDACMB+1
CMBID    EQU   IDACMB
BSPH1ST  EQU   IDABSPH+60
BSPHUBTM EQU   IDABSPH+56
BSPHUTOP EQU   IDABSPH+52
BSPHNUIW EQU   IDABSPH+48
BSPHUIW  EQU   IDABSPH+44
BSPHFND  EQU   IDABSPH+40
BSPHRDS  EQU   IDABSPH+36
BSPHCPLH EQU   IDABSPH+32
BSPHPSUC EQU   BSPHCSRC+2
@NM00061 EQU   BSPHCSRC+1
BSPHPCUC EQU   BSPHFLG2
BSPHAPRT EQU   BSPHFLG2
BSPHMDBT EQU   IDABSPH+20
BSPHBUFC EQU   IDABSPH+16
BSPHERCT EQU   IDABSPH+14
BSPHBFNO EQU   IDABSPH+12
BSPHNM   EQU   IDABSPH+4
BSPHLEN  EQU   IDABSPH+2
BSPHBFRF EQU   BSPHFLG1
BSPHIOBF EQU   BSPHFLG1
BSPHID   EQU   IDABSPH
BLPBFLCT EQU   BLPBUFL+6
@NM00060 EQU   BLPBUFL+5
@NM00059 EQU   BLPBRLFG
BLPBFLST EQU   BLPBRLFG
BLPBUFSZ EQU   BLPBUFL
BLPERFLG EQU   IDABLPRM+51
@NM00058 EQU   IDABLPRM+49
BLPOFLGS EQU   IDABLPRM+48
@NM00057 EQU   IDABLPRM+28
BLPDSORG EQU   BLPIOACB+3
@NM00056 EQU   BLPIOACB
BLPGAD   EQU   BLPCORE+5
BLPGSP   EQU   BLPCORE+4
BLPGSZ   EQU   BLPCORE+1
BLPGPG   EQU   BLPGFLG
BLPGREQ  EQU   BLPGFLG
BLPOACB  EQU   IDABLPRM+13
BLPOCODE EQU   IDABLPRM+12
BLPFRSTR EQU   BLPFLAG2
BLPFIOSR EQU   BLPFLAG2
BLPFPART EQU   BLPFLAG2
BLPFSTAD EQU   BLPFLAG1
BLPFBFRF EQU   BLPFLAG1
BLPFIOBF EQU   BLPFLAG1
BLPFGSR  EQU   BLPFLAG1
BLPFLSR  EQU   BLPFLAG1
BLPFDEL  EQU   BLPFLAG1
BLPFBLD  EQU   BLPFLAG1
BLPFDBDC EQU   BLPFLAG1
BLPSTRNO EQU   IDABLPRM+9
BLPKEYLN EQU   IDABLPRM+8
BLPIOPLH EQU   BLPUACB
@NM00055 EQU   IDABLPRM+2
BLPACBST EQU   IDABLPRM+1
BLPACBID EQU   IDABLPRM
BIBVSRTP EQU   IDABIB+104
BIBASCB  EQU   IDABIB+100
BIBDDNM  EQU   IDABIB+92
BIBSTPNM EQU   IDABIB+84
BIBJOBNM EQU   IDABIB+76
BIBSIOAP EQU   BIBRTNS+12
BIBASYRT EQU   BIBRTNS+8
BIBCEAPP EQU   BIBRTNS+4
BIBINTRF EQU   BIBRTNS
BIBVGTT  EQU   IDABIB+56
BIBPSAB  EQU   IDABIB+52
BIBCSL   EQU   IDABIB+48
BIBVCRT  EQU   IDABIB+40
BIBHEBFQ EQU   IDABIB+36
BIBHEBPT EQU   IDABIB+32
BIBPRSPH EQU   IDABIB+28
BIBSPHPT EQU   IDABIB+24
BIBPAMBL EQU   IDABIB+20
BIBDACB  EQU   IDABIB+16
BIBVMT   EQU   IDABIB+12
BIBUPT   EQU   IDABIB+8
@NM00054 EQU   IDABIB+5
BIBFLG2  EQU   IDABIB+4
BIBLEN   EQU   BIBHDR+2
@NM00053 EQU   BIBFLG1
BIBCKPT  EQU   BIBFLG1
BIBREST  EQU   BIBFLG1
BIBVIRT  EQU   BIBFLG1
BIBID    EQU   BIBHDR
@NM00052 EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDUSED  EQU   ARDTYPE
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00051 EQU   IDAAMDSB+41
@NM00050 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
CBSVUSE  EQU   CBSVSRT
CBSCRTCB EQU   AMCBS+28
CBSCRACA EQU   AMCBS+24
CBSCAXCN EQU   AMCBS+20
CBSMCUCB EQU   CBSCMP
CBSCBP   EQU   AMCBS+12
CBSACB   EQU   AMCBS+8
CBSMCSTA EQU   AMCBS+4
CBSSIZ   EQU   AMCBS+2
CBSID    EQU   AMCBS
BUFFER0  EQU   IDATRACE+2440
DECB0    EQU   IDATRACE+2040
TRACE    EQU   IDATRACE+1952
ZEROLINE EQU   IDATRACE+1912
CURDECBT EQU   IDATRACE+1908
CURREC   EQU   IDATRACE+1904
OPENLST  EQU   IDATRACE+1896
DECB@0   EQU   IDATRACE+1816
COUNT    EQU   IDATRACE+1812
COUNT2   EQU   IDATRACE+1808
COUNTE   EQU   IDATRACE+1804
COUNTS   EQU   IDATRACE+1800
DDNAME   EQU   IDATRACE+1792
STEPNAME EQU   IDATRACE+1784
JOBNAME  EQU   IDATRACE+1776
HOOK     EQU   IDATRACE+1772
DBUFFLEN EQU   IDATRACE+1768
IBUFFLEN EQU   IDATRACE+1764
LPMBADR  EQU   IDATRACE+1760
ECB@     EQU   IDATRACE+1756
PSWKEY   EQU   IDATRACE+1752
UPGCOUNT EQU   IDATRACE+1751
AIXUPG   EQU   AIXOPT
AIXNOBSE EQU   AIXOPT
AIXNOAIX EQU   AIXOPT
ONLYCALL EQU   AIXOPT
@NM00049 EQU   AIXOPT
AIXIN    EQU   IDATRACE+1747
FLAG6    EQU   IDATRACE+1746
ERRCDPMT EQU   FLAG5
COUNTX   EQU   FLAG5
AIXX     EQU   FLAG5
NOTE1    EQU   FLAG5
PAPSAVE  EQU   FLAG5
DLL      EQU   FLAG5
IICBX    EQU   FLAG5
REGX     EQU   FLAG5
KEYX     EQU   FLAG4
RECDX    EQU   FLAG4
VSRTX    EQU   FLAG4
VATX     EQU   FLAG4
HEBX     EQU   FLAG4
BIBX     EQU   FLAG4
UPTX     EQU   FLAG4
BSPHX    EQU   FLAG4
DEBX     EQU   FLAG3
ARDBX    EQU   FLAG3
AMDSBX   EQU   FLAG3
AMBX     EQU   FLAG3
ICWAX    EQU   FLAG3
CPAX     EQU   FLAG3
IOBX     EQU   FLAG3
BUFFX    EQU   FLAG3
AMBLX    EQU   FLAG2
BUFFCX   EQU   FLAG2
ALLCB    EQU   FLAG2
PLHX     EQU   FLAG2
ACBX     EQU   FLAG2
RPLX     EQU   FLAG2
INDEXCB  EQU   FLAG2
DATACB   EQU   FLAG2
COUNTING EQU   FLAG1
RMERRCD  EQU   FLAG1
@NM00048 EQU   FLAG1
PARMS    EQU   FLAG1
ADDRONLY EQU   FLAG1
MVS      EQU   FLAG1
COUNTOLY EQU   FLAG1
STOP     EQU   FLAG1
NODDNAME EQU   FLAG0
CISPLIT  EQU   FLAG0
CASPLIT  EQU   FLAG0
NOSAVE   EQU   FLAG0
NOCORE   EQU   FLAG0
INDEXOFF EQU   FLAG0
@NM00047 EQU   FLAG0
SWAPED   EQU   FLAG0
SAVE6X   EQU   IDATRACE+1720
SAVE5X   EQU   IDATRACE+1700
SAVE4X   EQU   IDATRACE+1680
SAVEIN3  EQU   SAVE3X
SAVEIN2  EQU   SAVE2X
R14IN    EQU   SAVEIN1+56
R13IN    EQU   SAVEIN1+52
@NM00046 EQU   SAVEIN1+16
AMBIN    EQU   SAVEIN1+12
PLHIN    EQU   SAVEIN1+8
RPLIN    EQU   SAVEIN1+4
@NM00045 EQU   SAVEIN1
HOOKCALL EQU   IDATRACE+498
@NM00044 EQU   STATUS2
UNSWAP   EQU   STATUS2
UPGDONE  EQU   STATUS
BASEDONE EQU   STATUS
PATHDONE EQU   STATUS
UPGSHORT EQU   STATUS
HEADOUT  EQU   STATUS
INDXPROC EQU   STATUS
GOOD     EQU   STATUS
WTOR     EQU   STATUS
BUFFLEN  EQU   IDATRACE+492
VATADDR  EQU   IDATRACE+488
PLH      EQU   IDATRACE+484
RPL      EQU   IDATRACE+480
DAMB     EQU   IDATRACE+476
IAMB     EQU   IDATRACE+472
AMBL     EQU   IDATRACE+468
INLENGTH EQU   IDATRACE+464
UPGPTR   EQU   IDATRACE+460
CPLH     EQU   IDATRACE+456
IRBNUM   EQU   IDATRACE+452
WORK6    EQU   IDATRACE+448
WORK5    EQU   IDATRACE+444
WORK3    EQU   IDATRACE+440
WORK2    EQU   IDATRACE+436
WORK1    EQU   IDATRACE+432
UNPACK   EQU   IDATRACE+420
DBUFFC   EQU   IDATRACE+416
IBUFFC   EQU   IDATRACE+412
OUTREG   EQU   IDATRACE+408
DLLLINE  EQU   IDATRACE+341
@NM00043 EQU   HEADER+124
ENGLISH  EQU   HEADER+90
LINE2    EQU   HEADER+52
LINE1    EQU   HEADER+13
@NM00042 EQU   HEADER+11
DISPLACE EQU   HEADER+8
@NM00041 EQU   HEADER+7
ADDRESS  EQU   HEADER+1
@NM00040 EQU   HEADER
MSGLNG   EQU   IDATRACE+204
RELYECB  EQU   REPLY@+20
REPLYIN  EQU   REPLYMSG+1
REPLYLYL EQU   REPLYMSG
@NM00039 EQU   REPLY@
ROUTCDE  EQU   IDATRACE+176
OLDSAVE  EQU   IDATRACE+172
HOLDREGS EQU   IDATRACE+140
PRTSAVE  EQU   IDATRACE+76
@NM00038 EQU   SAVE1X+4
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00037 EQU   IDAAMBL+40
AMBLNST  EQU   IDAAMBL+37
@NM00036 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00035 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLSDS  EQU   AMBLVVIC
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00034 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00033 EQU   AMBLQ2
AMBLCBIC EQU   AMBLQ2
@NM00032 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00031 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
IOMXRBPT EQU   IOMXECB+1
IOMXIOCC EQU   IOMXRSLT
IOMXPOST EQU   IOMXRSLT
IOMXWAIT EQU   IOMXECB
IOMXR14  EQU   IDAIOMBX+16
IOMXRPL  EQU   IOMXPDET+8
IOMXR13S EQU   IOMXPDET+4
@NM00030 EQU   IOMXPDET+2
IOMXBFLG EQU   IOMXPDET
@NM00029 EQU   IDAIOMBX+2
@NM00028 EQU   IOMXFLGS
IOMXSCAN EQU   IOMXFLGS
IOMXEOVW EQU   IOMXFLGS
IOMXUSE  EQU   IOMXFLGS
IOMXLOCK EQU   IDAIOMBX
AMBXBM2S EQU   IDAAMBXN+20
AMBXRDCT EQU   AMBXCSWD+2
@NM00027 EQU   AMBXCSWD
AMBXECB  EQU   IDAAMBXN+12
AMBXASCB EQU   IDAAMBXN+8
@NM00026 EQU   AMBXEOV+7
AMBXEVRC EQU   AMBXEOV+6
AMBXEOVR EQU   AMBXEOV+5
AMBXRSC  EQU   AMBXEOV+4
AMBXEVPT EQU   AMBXEOV
AMBVIOT  EQU   IDAAMB+116
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00025 EQU   AMBCSWD1+1
@NM00024 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
@NM00023 EQU   AMBAFLG
@NM00022 EQU   IDAAMB+68
AMBAMBXN EQU   AMBEOVPT
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
@NM00021 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00020 EQU   AMBOFLGS
AMBIFLGS EQU   AMBDEBPT
AMBUPX   EQU   AMBINFL
@NM00019 EQU   AMBINFL
@NM00018 EQU   AMBINFL
@NM00017 EQU   IDAAMB+38
@NM00016 EQU   AMBDSORG+1
@NM00015 EQU   AMBDSORG
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
@NM00014 EQU   AMBFLG0
AMBRSC   EQU   IDAAMB+1
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00013 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00012 EQU   ACBINFL2
ACBCBIC  EQU   ACBINFL2
@NM00011 EQU   ACBINFL2
ACBBYPSS EQU   ACBINFL1
ACBIJRQE EQU   ACBINFL1
ACBJEPS  EQU   ACBINFL1
@NM00010 EQU   ACBINFL1
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00009 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00008 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00007 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00006 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00005 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00004 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00003 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
@NM00002 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00001 EQU   ACBMACR2
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
@NM00160 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00159 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00158 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00157 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00156 EQU   FLCFSA
@NM00155 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00154 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00153 EQU   FLCIOA
@NM00152 EQU   FLCMCLA+15
@NM00151 EQU   FLCMCLA+14
@NM00150 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00149 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00148 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00147 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00146 EQU   FLCPER
@NM00145 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00144 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00143 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00142 EQU   FLCPIILC
@NM00141 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00140 EQU   FLCSVILC
@NM00139 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00138 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00137 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00355 EQU   @RC00328
@RF00375 EQU   @RC00369
@RF00374 EQU   @RC00369
@RF00511 EQU   @RC00494
@RC00696 EQU   @RC00694
@RF00699 EQU   @RC00694
@RC00736 EQU   @RC00734
@RC01110 EQU   @RC01109
@RC01129 EQU   @RC01128
@PB00015 EQU   @PB00016
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0192Z,(C'PLS1130',0701,78199)
