         TITLE 'IDA019C1: CONTROL BLOCK MANIPULATION ROUTINE           *
                        '
IDA019C1 CSECT
         USING *,@15                    BASE REGISTER 1
         USING *+4095,@12               BASE REGISTER 2
@PSTART EQU *
*   BC(15,DECODE);                  /* GO DECODE REQUEST             */
         BC    15,DECODE                                           0320
*PROCBRTB:                                                         0321
*                                                                  0321
*   /*****************************************************************/
*   /*                                                               */
*   /* FUNCTION/BLOCK TYPE BRANCH TABLE                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0321
*PRFUNCER:                                                         0321
*   BC(15,FUNCERRR);                /* FUNCTION ERROR                */
PROCBRTB DS    0H                                                  0321
PRFUNCER BC    15,FUNCERRR                                         0321
*PRACBGEN:                                                         0322
*   BC(15,ACBGEN);                  /* GENCB/ACB                     */
PRACBGEN BC    15,ACBGEN                                           0322
*PRRPLGEN:                                                         0323
*   BC(15,RPLGENCB);                /* GENCB/RPL                     */
PRRPLGEN BC    15,RPLGENCB                                         0323
*PREXLSTG:                                                         0324
*   BC(15,EXLSTGEN);                /* GENCB/EXLST                   */
PREXLSTG BC    15,EXLSTGEN                                         0324
*PRNIBGEN:                                                         0325
*   BC(15,NIBGEN);                  /* GENCB/NIB                     */
PRNIBGEN BC    15,NIBGEN                                           0325
*PRACBMOD:                                                         0326
*   BC(15,ACBMOD);                  /* MODCB/ACB                     */
PRACBMOD BC    15,ACBMOD                                           0326
*PRRPLMOD:                                                         0327
*   BC(15,RPLMOD);                  /* MODCB/RPL                     */
PRRPLMOD BC    15,RPLMOD                                           0327
*PREXLSTM:                                                         0328
*   BC(15,EXLSTMOD);                /* MODCB/EXLST                   */
PREXLSTM BC    15,EXLSTMOD                                         0328
*PRNIBMOD:                                                         0329
*   BC(15,NIBMOD);                  /* MODCB/NIB                     */
PRNIBMOD BC    15,NIBMOD                                           0329
*PRACBSHO:                                                         0330
*   BC(15,ACBSHOW);                 /* SHOWCB/ACB                    */
PRACBSHO BC    15,ACBSHOW                                          0330
*PRRPLSHO:                                                         0331
*   BC(15,RPLSHOW);                 /* SHOWCB/RPL                    */
PRRPLSHO BC    15,RPLSHOW                                          0331
*PREXLSTS:                                                         0332
*   BC(15,EXLSSHOW);                /* SHOWCB/EXLST                  */
PREXLSTS BC    15,EXLSSHOW                                         0332
*PRNIBSHO:                                                         0333
*   BC(15,NIBSHOW);                 /* SHOWCB/EXLST                  */
PRNIBSHO BC    15,NIBSHOW                                          0333
*PRACBTES:                                                         0334
*   BC(15,ACBTEST);                 /* TESTCB/ACB                    */
PRACBTES BC    15,ACBTEST                                          0334
*PRRPLTES:                                                         0335
*   BC(15,RPLTEST);                 /* TESTCB/RPL                    */
PRRPLTES BC    15,RPLTEST                                          0335
*PREXLSTT:                                                         0336
*   BC(15,EXLSTEST);                /* TESTCB/EXLST                  */
PREXLSTT BC    15,EXLSTEST                                         0336
*PRNIBTES:                                                         0337
*   BC(15,NIBTEST);                 /* TESTCB/NIB                    */
PRNIBTES BC    15,NIBTEST                                          0337
*PRBLKLEN:                                                         0338
*   BC(15,BLKLNKW);                 /* BLOCK LENGTH                  */
PRBLKLEN BC    15,BLKLNKW                                          0338
*   BC(15,REGSHORL);                /* REGISTER SHOWCB               */
         BC    15,REGSHORL                                         0339
*REGMODRL:                                                         0340
*                                                                  0340
*   /*****************************************************************/
*   /*                                                               */
*   /* REGISTER FORM OF MODCB/BLOCK TYPE OF RPL. THE ONLY FUNCTION   */
*   /* ALLOWED IS MODIFICATION OF THE RECLEN FIELD INPUT CONSISTS OF */
*   /* A POINTER TO THE RPL IN REGISTER 1 AND THE VALUE TO BE STORED */
*   /* IN REGISTER 0. ENTRY IS VIA DIRECT BRANCH INTO THIS SECTION BY*/
*   /* THE USER. THE BRANCH INSTRUCTION SHOULD BE BAL 14,80(,15) OR  */
*   /* SOME FUNCTIONAL EQUIVLANT. OUTPUT IS THE MODIFIED BLOCK AND   */
*   /* REGISTER 15 IS SET TO 0 IF SUCCESSFUL. ERRORS CONSIST OF      */
*   /* REGISTER 1 NOT POINTING TO A RPL OR THE RPL BEING ACTIVE.     */
*   /* STANDARD CODES ARE RETURNED IN REGISTERS 0 AND 15 IN ERROR    */
*   /* CONDITIONS. THIS IS HIGH PERFORMANCE CODE AND CARE MUST BE    */
*   /* TAKEN NOT TO EXTEND PATH LENGTH OR CROSS PAGE BOUNDRIES.      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0340
*   RESPECIFY                                                      0340
*     IFGRPL BASED(REG1);                                          0340
REGMODRL DS    0H                                                  0341
*   IF RPLID^=IDXRPL THEN           /* POINTING TO RPL               */
         CLI   RPLID(REG1),X'00'                                   0341
         BE    @RF00341                                            0341
*     DO;                           /* PROCESS ERROR                 */
*       REG0=BLKERR;                /* INDICATE NOT POINTING TO RPL  */
         LA    @09,4                                               0343
         LR    REG0,@09                                            0343
*       REG15=NOTOKRET;             /* LOAD BAD RETURN CODE          */
         LR    REG15,@09                                           0344
*       GEN(BR REG14);              /* RETURN                        */
         BR REG14
*     END;                                                         0346
*   TS(RPLACTIV);                   /* SET RPL ACTIVE ON             */
@RF00341 TS    RPLACTIV(REG1)                                      0347
*   BC(8,RNOTACT);                  /* BRANCH NOT ACTIVE             */
         BC    8,RNOTACT                                           0348
*   REG0=RPLISACT;                  /* LOAD ACTIVE RETURN CODE       */
         LA    REG0,11                                             0349
*   REG15=NOTOKRET;                 /* LOAD BAD RETURN CODE          */
         LA    REG15,4                                             0350
*   GEN(BR REG14);                  /* RETURN                        */
         BR REG14
*RNOTACT:                                                          0352
*   RPLRLEN=REG0;                   /* SET RECORD LENGTH             */
RNOTACT  ST    REG0,RPLRLEN(,REG1)                                 0352
*   RPLACTIV=ZERO;                  /* RESET ACTIVE BYTE             */
         MVI   RPLACTIV(REG1),X'00'                                0353
*   REG15=ZERO;                     /* SET RETURN CODE               */
         SLR   REG15,REG15                                         0354
*   GEN(BR REG14);                  /* RETURN TO USER                */
         BR REG14
*   RESPECIFY                                                      0356
*     IFGRPL BASED(RBLKPTR);                                       0356
*   GEN(DC C'IDA019C1 &SYSDATE');   /* ID FIELD                      */
         DC C'IDA019C1 &SYSDATE'
*REGSHORL:                                                         0358
*                                                                  0358
*   /*****************************************************************/
*   /*                                                               */
*   /* REGISTER FORM OF SHOWCB FOR BLOCK TYPE OF RPL. THE ONLY       */
*   /* FUNCTION ALLOWED IS TO SHOW RECLEN FIELD FROM RPL. INPUT      */
*   /* CONSISTS OF THE ADDRESS OF A RPL IN REGISTER 1. ENTRY IS VIA A*/
*   /* BRANCH TO PROCBRTB AND A SECOND BRANCH TO THIS ROUTINE. THE   */
*   /* BRANCH INSTRUCTION SHOULD BE BAL 14,76(,15) OR SOME FUNCTIONAL*/
*   /* EQUIVLANT. OUTPUT IS THE CONTENTS OF RECLEN FIELD LOADED IN   */
*   /* REGISTER 0. REGISTER 15 IS SET TO ZERO IF SUCCESSFUL. ERROR   */
*   /* DETECTED IS REGISTER 15 NOT POINTING TO A RPL. STANDARD CODES */
*   /* WILL BE SET IN REGISTER 0 AND 15 WHEN ERROR IS DETECTED. THIS */
*   /* IS CONSIDERED HIGH PERFORMANCE CODE AND CARE MUST BE EXERCISED*/
*   /* NOT TO EXTEND PATH LENGTH OR CROSS PAGE BOUNDRIES.            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0358
*   RESPECIFY                                                      0358
*     IFGRPL BASED(REG1);                                          0358
REGSHORL DS    0H                                                  0359
*   IF RPLID^=IDXRPL THEN           /* POINTING TO RPL               */
         CLI   RPLID(REG1),X'00'                                   0359
         BE    @RF00359                                            0359
*     DO;                           /* PROCESS ERROR                 */
*       REG0=BLKERR;                /* INDICATE NOT POINTING TO RPL  */
         LA    @09,4                                               0361
         LR    REG0,@09                                            0361
*       REG15=NOTOKRET;             /* LOAD BAD RETURN CODE          */
         LR    REG15,@09                                           0362
*       GEN(BR REG14);              /* RETURN                        */
         BR REG14
*     END;                                                         0364
*   REG0=RPLRLEN;                   /* SET RECORD LENGTH             */
@RF00359 L     REG0,RPLRLEN(,REG1)                                 0365
*   REG15=ZERO;                     /* SET RETURN CODE               */
         SLR   REG15,REG15                                         0366
*   GEN(BR REG14);                  /* RETURN TO USER                */
         BR REG14
*   RESPECIFY                                                      0368
*     IFGRPL BASED(RBLKPTR);                                       0368
*                                                                  0369
*   /*****************************************************************/
*   /*                                                               */
*   /* DECODE- TRANSLATES FUNCTIONAL REQUEST AND BLOCK TYPE TO AN    */
*   /* OFFSET TO A BRANCH INSTRUCTION IN PROCBRTB AND EXECUTES THAT  */
*   /* INSTRUCTION. CONTROL IS NOT RETURNED HERE .                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0369
*DECODE:                                                           0369
*                                                                  0369
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0369
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
DECODE   STM   REG2,REG12,REGSAVE(REG13)                           0369
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
*                                                                  0370
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0371
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0371
*   RBLKPTR=GENUSA;                 /* LOAD ADDRESS OF USER BLOCK    */
*                                                                  0372
         L     RBLKPTR,GENUSA(,RHDRPTR)                            0372
*   /*****************************************************************/
*   /*                                                               */
*   /* HASH TOGETHER FUNCTION AND BLOCK CODES IGNORING THE VTAM      */
*   /* INDICATOR.                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0373
*   RESPECIFY                                                      0373
*     REG5 RSTD;                                                   0373
*   REG5=FTCBTC&FUNCMASK;           /* LOOK FOR BAD CODES            */
         LH    REG5,FTCBTC(,RHDRPTR)                               0374
         N     REG5,@CF02126                                       0374
*   BC(7,FUNCERR);                  /* GO EXIT                       */
         BC    7,FUNCERR                                           0375
*   GEN(IC REG5,GENBTC(,RHDRPTR))                                  0376
*   REFS(GENBTC) SETS(REG5);        /* PICK UP BLOCK CODE            */
         IC REG5,GENBTC(,RHDRPTR)
*   REG8=(FTCBTC&VTAMCORR)|REG5;    /* GET FUNCTION/BLOCK CODE       */
         LH    REG8,FTCBTC(,RHDRPTR)                               0377
         N     REG8,@CF00034                                       0377
         OR    REG8,REG5                                           0377
*   RESPECIFY                                                      0378
*     REG5 UNRSTD;                                                 0378
*                                                                  0378
*   /*****************************************************************/
*   /*                                                               */
*   /* RETRIEVE PROCESSING OFFSET FROM PROCTAB USING THE HASHED      */
*   /* FUNCTION BLOCK CODE AS INDEX VALUE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0379
*   GEN(IC REG8,PROCTAB(REG8))                                     0379
*   REFS(PROCTAB);                  /* GET FUNCTION OFFSET           */
*                                                                  0379
         IC REG8,PROCTAB(REG8)
*   /*****************************************************************/
*   /*                                                               */
*   /* GO TO FUNCTION ROUTINE VIA PROCBRTAB INDEXED BY THE PROCESSING*/
*   /* OFFSET. RETURN TO THIS LEVEL DOES NOT OCCUR. NOTE: FUNCTIONAL */
*   /* ROUTINE PROLOG INSTRUCTIONS MUST BE EXACTLY 18 BYTES LONG FOR */
*   /* THE FOLLOWING INSTRUCTION TO EXCUTE CORRECTLY.                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0380
*   REG2=BROFFSET;                  /* BYPASS PROLOG INSTRUCTIONS    */
         LA    REG2,18                                             0380
*   GEN(EX REG2,PROCBRTB(REG8))                                    0381
*   FLOWS(PROCBRTB);                /* GO TO FUNCTION                */
         EX REG2,PROCBRTB(REG8)
*                                                                  0382
*   /*****************************************************************/
*   /*                                                               */
*   /* GENCB/ACB ROUTINE BUILDS ACB'S AS REQUESTED BY USER. INPUT IS */
*   /* AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESS     */
*   /* POINTING TO A HEADER AND ELEMENTS THAT REPRESENT KEYWORDS     */
*   /* SPECIFIED BY THE CALLER IN HIS GENCB MACRO INSTRUCTION. OUTPUT*/
*   /* IS INITIALIZED ACB'S THAT ARE COPIED FROM A MODEL AND         */
*   /* CUSTOMIZED AS REQUESTED BY KEYWORDS. THE NUMBER OF ACB'S BUILT*/
*   /* ARE SPECIFIED BY THE FIELD GENCOP IN THE HEADER. IF THE USER  */
*   /* DOES NOT SUPPLY A STORAGE LOCATION IN WHICH THE ACB'S ARE TO  */
*   /* BUILT STORAGE IS OBTAINED VIA A CALL TO GM19C1. STORAGE       */
*   /* SUPPLIED BY THE USER MUST BE ON A FULLWORD BOUNDRY AND CHECKS */
*   /* ARE MADE TO INSURE THAT IT IS. RETURN TO THE USER IS FROM THIS*/
*   /* ROUTINE EXCEPT WHEN AN ERROR IS DETECTED AND THE ERROR EXIT IS*/
*   /* TAKEN.                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0382
*ACBGEN:                                                           0382
*                                                                  0382
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0382
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
ACBGEN   STM   REG2,REG12,REGSAVE(REG13)                           0382
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
         LA REG12,4095(REG15)
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0384
*   RBLKPTR=GENUSA;                 /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,GENUSA(,RHDRPTR)                            0385
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0386
         SLR   REG8,REG8                                           0386
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG INSTRUCTIONS                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0387
*   RESPECIFY                                                      0387
*    (REG5,                                                        0387
*     REG9) RESTRICTED;             /*                       @G40AKCM*/
*   IF VTAMSW=YES THEN              /* VTAM SPECIFIED                */
*                                                                  0388
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       0388
         BNO   @RF00388                                            0388
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS VTAM ACB                                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0389
*     DO;                                                          0389
*       REG5=LENGTH(IFGACB)+LENGTH(IFGACBVT);/* SET VTAM LENGTH    0390
*                                                            @G40KSCM*/
         LA    REG5,88                                             0390
*       REG9=ADDR(DVTAMACB)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY   0391
*                                      ROUTINE               @G40AKCM*/
         LA    REG9,DVTAMACB                                       0391
         LA    @07,DEFCBRTN                                        0391
         SLR   REG9,@07                                            0391
*       GEN(BAL REG10,GM19C1)                                      0392
*       FLOWS(GM19C1);              /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*       ACBINRTN=ADDR(ACBRTN);      /* SET ADDRESS OF VTAM ROUTINE   */
         LA    @07,76                                              0393
         ALR   @07,RBLKPTR                                         0393
         ST    @07,ACBINRTN(,RBLKPTR)                              0393
*     END;                                                         0394
*   ELSE                            /* VSAM                          */
*                                                                  0395
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS VSAM ACB                                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0395
*     DO;                                                          0395
         B     @RC00388                                            0395
@RF00388 DS    0H                                                  0396
*       REG5=LENGTH(ACBCOMN);       /* SET LENGTH            @G40AKCM*/
         LA    REG5,76                                             0396
*       REG9=ADDR(DVSAMACB)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY RTN
*                                                            @G40AKCM*/
         LA    REG9,DVSAMACB                                       0397
         LA    @07,DEFCBRTN                                        0397
         SLR   REG9,@07                                            0397
*       GEN(BAL REG10,GM19C1)                                      0398
*       FLOWS(GM19C1);              /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*     END;                                                         0399
*   RESPECIFY                                                      0400
*    (REG5,                                                        0400
*     REG9) UNRESTRICTED;           /*                       @G40AKCM*/
*                                                                  0400
@RC00388 DS    0H                                                  0401
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0401
*   IF EOL=ON THEN                                                 0401
         TM    EOL(PLEPTR),B'10000000'                             0401
         BO    @RT00401                                            0401
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* YES                           */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00403 DS    0H                                                  0404
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP TO NEXT ENTRY         */
         AL    PLEPTR,@CF00256                                     0404
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0405
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0405
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0406
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0406
         MH    REG11,@CH00984                                      0406
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0407
         BH    @RT00407                                            0407
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*       GEN(IC REG8,MACB(REG11))                                   0409
*       REFS(MACB);                 /* LOAD OFFSET TO KEYWORD ROUTINE*/
*                                                                  0409
         IC REG8,MACB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0410
*       GEN(EX REG0,MACBKWTB(REG8))                                0410
*       FLOWS(MACBKWTB);                                           0410
         EX REG0,MACBKWTB(REG8)
*     END;                                                         0411
@DE00403 TM    EOL(PLEPTR),B'10000000'                             0411
         BNO   @DL00403                                            0411
*   REG1=RBLKPTR;                   /* SET ADDRESS OF FIRST ACB      */
@RT00401 LR    REG1,RBLKPTR                                        0412
*   REG0=GMLEN;                     /* SET RESISTER 0 TO RETURN VALUE*/
*                                                                  0413
         L     REG0,GMLEN(,REG13)                                  0413
*   /*****************************************************************/
*   /*                                                               */
*   /* MAKE ADDITIONAL COPIES AS REQUIRED                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0414
*   IF GENCOP>1 THEN                /* MORE THAN ONE COPY]           */
         LA    @09,1                                               0414
         CH    @09,GENCOP(,RHDRPTR)                                0414
         BNL   @RF00414                                            0414
*     DO;                           /* YES, MAKE THEM                */
*       RESPECIFY                                                  0416
*         REG5 RSTD;                                               0416
*       REG5=RBLKPTR+REG0;          /* SET STOPPER                   */
         LR    REG5,RBLKPTR                                        0417
         ALR   REG5,REG0                                           0417
*       IF VTAMSW=OFF THEN          /* VTAM SPECIFIED                */
         ALR   @09,RHDRPTR                                         0418
         TM    VTAMSW(@09),B'00010000'                             0418
         BNZ   @RF00418                                            0418
*         DO RBLKPTR=RBLKPTR BY ACBLENG WHILE RBLKPTR<REG5;/*      0419
*                                                            @ZA07550*/
         B     @DE00419                                            0419
@DL00419 DS    0H                                                  0420
*           NEWACB=REG1->NEWACB;    /* COPY BLOCK                    */
         MVC   NEWACB(76,RBLKPTR),NEWACB(REG1)                     0420
*         END;                                                     0421
         AH    RBLKPTR,ACBLENG(,RBLKPTR)                           0421
@DE00419 CR    RBLKPTR,REG5                                        0421
         BL    @DL00419                                            0421
*       ELSE                        /* VTAM                          */
*         DO RBLKPTR=RBLKPTR BY ACBLENG WHILE RBLKPTR<REG5;/*      0422
*                                                            @ZA07550*/
         B     @RC00418                                            0422
@RF00418 B     @DE00422                                            0422
@DL00422 DS    0H                                                  0423
*           NEWVTACB=REG1->NEWVTACB;/* COPY BLOCK                    */
         MVC   NEWVTACB(88,RBLKPTR),NEWVTACB(REG1)                 0423
*           ACBINRTN=ADDR(ACBRTN);  /* SET ADDRESS OF VTAM ROUTINE   */
         LA    @09,76                                              0424
         ALR   @09,RBLKPTR                                         0424
         ST    @09,ACBINRTN(,RBLKPTR)                              0424
*         END;                                                     0425
         AH    RBLKPTR,ACBLENG(,RBLKPTR)                           0425
@DE00422 CR    RBLKPTR,REG5                                        0425
         BL    @DL00422                                            0425
*       RESPECIFY                                                  0426
*         REG5 UNRSTD;                                             0426
@RC00418 DS    0H                                                  0427
*     END;                                                         0427
*                                                                  0427
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO USER                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0428
*   RETCODER=ZERO;                  /* SET ZERO RETURN CODE          */
@RF00414 SLR   RETCODER,RETCODER                                   0428
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0429
*   GEN(BR REG14);                  /* RETURN TO USER                */
         BR REG14
*                                                                  0431
*   /*****************************************************************/
*   /*                                                               */
*   /* GENCB/RPL ROUTINE BUILDS RPL'S AS REQUESTED BY USER. INPUT IS */
*   /* AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESS     */
*   /* POINTING TO A HEADER AND ELEMENTS THAT REPRESENT KEYWORDS     */
*   /* SPECIFIED BY THE CALLER IN HIS GENCB MACRO INSTRUCTION. OUTPUT*/
*   /* IS INITIALIZED RPL'S THAT ARE COPIED FROM A MODEL AND         */
*   /* CUSTOMIZED AS REQUESTED BY KEYWORDS. THE NUMBER OF RPL'S BUILT*/
*   /* ARE SPECIFIED BY THE FIELD GENCOP IN THE HEADER. IF THE USER  */
*   /* DOES NOT SUPPLY A STORAGE LOCATION IN WHICH THE RPL'S ARE TO  */
*   /* BUILT STORAGE IS OBTAINED VIA A CALL TO GM19C1. STORAGE       */
*   /* SUPPLIED BY THE USER MUST BE ON A FULLWORD BOUNDRY AND CHECKS */
*   /* ARE MADE TO INSURE THAT IT IS. RETURN TO THE USER IS FROM THIS*/
*   /* ROUTINE EXCEPT WHEN AN ERROR IS DETECTED AND THE ERROR EXIT IS*/
*   /* TAKEN.                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0431
*RPLGENCB:                                                         0431
*                                                                  0431
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0431
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
RPLGENCB STM   REG2,REG12,REGSAVE(REG13)                           0431
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
*                                                                  0432
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0433
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0433
*   RBLKPTR=GENUSA;                 /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,GENUSA(,RHDRPTR)                            0434
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0435
         SLR   REG8,REG8                                           0435
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG INSTRUCTIONS                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0436
*   RESPECIFY                                                      0436
*    (REG5,                                                        0436
*     REG9) RESTRICTED;             /*                       @G40AKCM*/
*   IF VTAMSW=YES THEN              /* VTAM SPECIFIED                */
*                                                                  0437
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       0437
         BNO   @RF00437                                            0437
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS VTAM RPL                                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0438
*     DO;                                                          0438
*       REG5=LENGTH(IFGRPL)+LENGTH(IFGRPLVT);/* SET VTAM LENG.     0439
*                                                            @G40AKCM*/
         LA    REG5,112                                            0439
*       REG9=ADDR(DVTAMRPL)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY   0440
*                                      ROUTINE               @G40AKCM*/
         LA    REG9,DVTAMRPL                                       0440
         LA    @07,DEFCBRTN                                        0440
         SLR   REG9,@07                                            0440
*       GEN(BAL REG10,GM19C1)                                      0441
*       FLOWS(GM19C1);              /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*     END;                                                         0442
*   ELSE                            /* VSAM                          */
*                                                                  0443
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS VSAM RPL                                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0443
*     DO;                                                          0443
         B     @RC00437                                            0443
@RF00437 DS    0H                                                  0444
*       REG5=LENGTH(RPLCOMN);       /* SET LENGTH            @G40AKCM*/
         LA    REG5,76                                             0444
*       REG9=ADDR(DVSAMRPL)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY   0445
*                                      ROUTINE               @G40AKCM*/
         LA    REG9,DVSAMRPL                                       0445
         LA    @07,DEFCBRTN                                        0445
         SLR   REG9,@07                                            0445
*       GEN(BAL REG10,GM19C1)                                      0446
*       FLOWS(GM19C1);              /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*     END;                                                         0447
*   RESPECIFY                                                      0448
*    (REG5,                                                        0448
*     REG9) UNRESTRICTED;           /*                       @G40AKCM*/
*                                                                  0448
@RC00437 DS    0H                                                  0449
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0449
*   IF EOL=ON THEN                                                 0449
         TM    EOL(PLEPTR),B'10000000'                             0449
         BO    @RT00449                                            0449
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* YES                           */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00451 DS    0H                                                  0452
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* POINT TO NEW LIST          */
         AL    PLEPTR,@CF00256                                     0452
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0453
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0453
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0454
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0454
         MH    REG11,@CH00984                                      0454
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0455
         BH    @RT00455                                            0455
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*       GEN(IC REG8,MRPL(REG11))                                   0457
*       REFS(MRPL);                 /* LOAD OFFSET TO KEYWORD ROUTINE*/
*                                                                  0457
         IC REG8,MRPL(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0458
*       GEN(EX REG0,MRPLKWTB(REG8))                                0458
*       FLOWS(MRPLKWTB);                                           0458
         EX REG0,MRPLKWTB(REG8)
*     END;                                                         0459
@DE00451 TM    EOL(PLEPTR),B'10000000'                             0459
         BNO   @DL00451                                            0459
*   REG1=RBLKPTR;                   /* SET ADDRESS OF FIRST ACB      */
@RT00449 LR    REG1,RBLKPTR                                        0460
*   REG0=GMLEN;                     /* SET RESISTER 0 TO RETURN VALUE*/
*                                                                  0461
         L     REG0,GMLEN(,REG13)                                  0461
*   /*****************************************************************/
*   /*                                                               */
*   /* MAKE ADDITIONAL COPIES AS REQUIRED                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0462
*   IF GENCOP>1 THEN                /* MORE THAN ONE COPY            */
         LA    @09,1                                               0462
         CH    @09,GENCOP(,RHDRPTR)                                0462
         BNL   @RF00462                                            0462
*     DO;                           /* YES, MAKE COPIES              */
*       RESPECIFY                                                  0464
*         REG5 RSTD;                                               0464
*       REG5=RBLKPTR+REG0;          /* SET STOPPER VALUE             */
         LR    REG5,RBLKPTR                                        0465
         ALR   REG5,REG0                                           0465
*       IF VTAMSW=ON THEN           /* VTAM SPECIFIED                */
         ALR   @09,RHDRPTR                                         0466
         TM    VTAMSW(@09),B'00010000'                             0466
         BNO   @RF00466                                            0466
*         DO RBLKPTR=RBLKPTR BY RPLLEN WHILE RBLKPTR<REG5;/* @ZA07550*/
         B     @DE00467                                            0467
@DL00467 DS    0H                                                  0468
*           NEWVTRPL=REG1->NEWVTRPL;/* COPY BLOCK                    */
         MVC   NEWVTRPL(112,RBLKPTR),NEWVTRPL(REG1)                0468
*         END;                                                     0469
         SLR   @09,@09                                             0469
         IC    @09,RPLLEN(,RBLKPTR)                                0469
         ALR   RBLKPTR,@09                                         0469
@DE00467 CR    RBLKPTR,REG5                                        0469
         BL    @DL00467                                            0469
*       ELSE                        /* VSAM                          */
*         DO RBLKPTR=RBLKPTR BY RPLLEN WHILE RBLKPTR<REG5;/* @ZA07550*/
         B     @RC00466                                            0470
@RF00466 B     @DE00470                                            0470
@DL00470 DS    0H                                                  0471
*           NEWRPL=REG1->NEWRPL;    /* COPY BLOCK                    */
         MVC   NEWRPL(76,RBLKPTR),NEWRPL(REG1)                     0471
*         END;                                                     0472
         SLR   @09,@09                                             0472
         IC    @09,RPLLEN(,RBLKPTR)                                0472
         ALR   RBLKPTR,@09                                         0472
@DE00470 CR    RBLKPTR,REG5                                        0472
         BL    @DL00470                                            0472
*       RESPECIFY                                                  0473
*         REG5 UNRSTD;                                             0473
@RC00466 DS    0H                                                  0474
*     END;                                                         0474
*                                                                  0474
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO USER                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0475
*   RETCODER=ZERO;                  /* SET ZERO RETURN CODE          */
@RF00462 SLR   RETCODER,RETCODER                                   0475
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0476
*   GEN(BR REG14);                  /* RETURN TO USER                */
         BR REG14
*                                                                  0478
*   /*****************************************************************/
*   /*                                                               */
*   /* GENCB/EXLST- ROUTINE BUILDS EXLST'S AS REQUESTED BY USER.     */
*   /* INPUT IS AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF    */
*   /* ADDRESS POINTING TO A HEADER AND ELEMENTS THAT REPRESENT      */
*   /* KEYWORDS SPECIFIED BY THE CALLER IN HIS GENCB MACRO           */
*   /* INSTRUCTION. OUTPUT IS INITIALIZED EXLST'S THAT ARE COPIED    */
*   /* FROM A MODEL AND CUSTOMIZED AS REQUESTED BY KEYWORDS. THE     */
*   /* NUMBER OF EXLST'S BUILT ARE SPECIFIED BY THE FIELD GENCOP IN  */
*   /* THE HEADER. IF THE USER DOES NOT SUPPLY A STORAGE LOCATION IN */
*   /* WHICH THE EXLST'S ARE TO BUILT STORAGE IS OBTAINED VIA A CALL */
*   /* TO GM19C1. STORAGE SUPPLIED BY THE USER MUST BE ON A FULLWORD */
*   /* BOUNDRY AND CHECKS ARE MADE TO INSURE THAT IT IS. RETURN TO   */
*   /* THE USER IS FROM THIS ROUTINE EXCEPT WHEN AN ERROR IS DETECTED*/
*   /* AND THE ERROR EXIT IS TAKEN.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0478
*EXLSTGEN:                                                         0478
*                                                                  0478
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0478
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
EXLSTGEN STM   REG2,REG12,REGSAVE(REG13)                           0478
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
         LA REG12,4095(REG15)
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0480
*   RBLKPTR=GENUSA;                 /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,GENUSA(,RHDRPTR)                            0481
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0482
         SLR   REG8,REG8                                           0482
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG INSTRUCTIONS                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0483
*   RESPECIFY                                                      0483
*    (REG5,                                                        0483
*     REG9) RESTRICTED;             /*                       @G40AKCM*/
*   RESPECIFY                                                      0484
*    (REG6) RSTD;                                                  0484
*                                                                  0484
*   /*****************************************************************/
*   /*                                                               */
*   /* GENCB/EXLST PROCESS KEYWORDS IF ANY                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0485
*   IF EOL=ON THEN                  /* KEWORDS NOT SPECIFIED         */
         TM    EOL(PLEPTR),B'10000000'                             0485
         BNO   @RF00485                                            0485
*     IF VTAMSW=YES THEN            /* VTAM SPECIFIED                */
*                                                                  0486
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       0486
         BNO   @RF00486                                            0486
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS VTAM DEFAULT EXLST                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0487
*       DO;                                                        0487
*         REG5=LENGTH(IFGEXLST)+LENGTH(IFGEXLVT);/* SET VTAM LEN.  0488
*                                                            @G40AKCM*/
         LA    REG5,70                                             0488
*         REG9=ADDR(DVTAMEXL)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY 0489
*                                      ROUTINE               @G40AKCM*/
         LA    REG9,DVTAMEXL                                       0489
         LA    @07,DEFCBRTN                                        0489
         SLR   REG9,@07                                            0489
*         GEN(BAL REG10,GM19C1)                                    0490
*         FLOWS(GM19C1);            /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*       END;                                                       0491
*     ELSE                          /* VSAM                          */
*                                                                  0492
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS VSAM DEFAULT EXLST                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0492
*       DO;                                                        0492
         B     @RC00486                                            0492
@RF00486 DS    0H                                                  0493
*         REG5=LENGTH(EXLCOMN);     /* SET TOTAL LENGTH      @G40AKCM*/
         LA    REG5,40                                             0493
*         REG9=ADDR(DVSAMEXL)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY 0494
*                                      ROUTINE               @G40AKCM*/
         LA    REG9,DVSAMEXL                                       0494
         LA    @07,DEFCBRTN                                        0494
         SLR   REG9,@07                                            0494
*         GEN(BAL REG10,GM19C1)                                    0495
*         FLOWS(GM19C1);            /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*       END;                                                       0496
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO;                           /* FIND MAX LENGTH AND PROCESS   */
         B     @RC00485                                            0497
@RF00485 DS    0H                                                  0498
*       REG5=ZERO;                  /* ZERO LENGTH REGISTER          */
         SLR   REG5,REG5                                           0498
*       REG6=ZERO;                  /* ZERO WORK REGISTER            */
         SLR   REG6,REG6                                           0499
*GEXLLOOP:                                                         0500
*       DO UNTIL(EOL=ON);           /* LOOK FOR END OF LIST          */
GEXLLOOP DS    0H                                                  0500
@DL00500 DS    0H                                                  0501
*         PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP TO NEXT ENTRY       */
         AL    PLEPTR,@CF00256                                     0501
*         RELEMPTR=PLEMPTR;         /* SET POINTER TO NEW KEYWORD    */
*                                                                  0502
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0502
*         /***********************************************************/
*         /*                                                         */
*         /* SET INDEX TO KEYWDTAB                                   */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0503
*         REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD    */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0503
         MH    REG11,@CH00984                                      0503
*         IF REG11>MAXKEYWD THEN    /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0504
         BH    @RT00504                                            0504
*           GO TO INVKEYWD;         /* EXIT WITH ERROR               */
*                                                                  0505
*         /***********************************************************/
*         /*                                                         */
*         /* SET INDEX TO KEYWORD ROUTINE                            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0506
*         GEN(IC REG8,MEXLST(REG11))                               0506
*         REFS(MEXLST);             /* LOAD ADDRESS OFF KEYWORD    0506
*                                      ROUTINE                       */
*                                                                  0506
         IC REG8,MEXLST(REG11)
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS KEYWORD                                         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0507
*         GEN(BAL REG10,GEXLBRTB(REG8));                           0507
         BAL REG10,GEXLBRTB(REG8)
*       END;                                                       0508
@DE00500 TM    EOL(PLEPTR),B'10000000'                             0508
         BNO   @DL00500                                            0508
*       IF REG5=ZERO THEN           /* VALID OFFSET KEYWORD          */
         LTR   REG5,REG5                                           0509
         BNZ   @RF00509                                            0509
*         IF VTAMSW=ON THEN         /* VTAM SPECIFIED                */
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       0510
         BNO   @RF00510                                            0510
*           DO;                                                    0511
*             REG5=LENGTH(IFGEXLST)+LENGTH(IFGEXLVT);/* SET VTAM LENG
*                                                            @G40AKCM*/
         LA    REG5,70                                             0512
*             REG9=ADDR(DVTAMEXL)-ADDR(DEFCBRTN);/* SET OFFSET TO  0513
*                                      COPY ROUTINE          @G40AKCM*/
         LA    REG9,DVTAMEXL                                       0513
         LA    @07,DEFCBRTN                                        0513
         SLR   REG9,@07                                            0513
*             GEN(BAL REG10,GM19C1)                                0514
*             FLOWS(GM19C1);        /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*           END;                                                   0515
*         ELSE                      /* VSAM SPECIFIED                */
*           DO;                                                    0516
         B     @RC00510                                            0516
@RF00510 DS    0H                                                  0517
*             REG5=LENGTH(EXLCOMN); /* SET TOTAL LENGTH      @G40AKCM*/
         LA    REG5,40                                             0517
*             REG9=ADDR(DVSAMEXL)-ADDR(DEFCBRTN);/* SET OFFSET TO  0518
*                                      COPY ROUTINE          @G40AKCM*/
         LA    REG9,DVSAMEXL                                       0518
         LA    @07,DEFCBRTN                                        0518
         SLR   REG9,@07                                            0518
*             GEN(BAL REG10,GM19C1)                                0519
*             FLOWS(GM19C1);        /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*           END;                                                   0520
*       ELSE                        /* VALID LENGTH                  */
*         DO;                       /* PROCESS VARIABLE LENGTH EXLST */
         B     @RC00509                                            0521
@RF00509 DS    0H                                                  0522
*           REG5=REG5+LENGTH(IFGEXLEF);/* SET LENGTH                 */
         AL    REG5,@CF00240                                       0522
*           REG9=ADDR(DVSNOP)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY 0523
*                                      ROUTINE               @G40AKCM*/
         LA    REG9,DVSNOP                                         0523
         LA    @07,DEFCBRTN                                        0523
         SLR   REG9,@07                                            0523
*           RESPECIFY                                              0524
*             REG7 RSTD;                                           0524
*           REG7=REG5;              /* SAVE LENGTH                   */
         LR    REG7,REG5                                           0525
*           GEN(BAL REG10,GM19C1)                                  0526
*           FLOWS(GM19C1);          /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*           EXLID=IDXEXLST;         /* SET ID IN HEADER              */
         MVI   EXLID(RBLKPTR),X'81'                                0527
*           EXLLEN=REG7;            /* SET LENGTH                    */
         STH   REG7,EXLLEN(,RBLKPTR)                               0528
*           REG7=REG7-FIVE;         /* SET LENGTH FOR CLEAR          */
         SL    REG7,@CF00240                                       0529
*           GEN(EX REG7,GEXLXC);    /* CLEAR STORAGE                 */
         EX REG7,GEXLXC
*           RESPECIFY                                              0531
*             REG7 UNRSTD;                                         0531
*           IF VTAMSW=ON THEN       /* VTAM SPECIFIED                */
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       0532
         BNO   @RF00532                                            0532
*             EXLSTYP=VTAMCODE;     /* SET VTAM AM CODE              */
         MVI   EXLSTYP(RBLKPTR),X'20'                              0533
*           ELSE                    /* VSAM SPECIFIED                */
*             EXLSTYP=VSAMCODE;     /* SET VSAM AM CODE              */
         B     @RC00532                                            0534
@RF00532 MVI   EXLSTYP(RBLKPTR),X'10'                              0534
*         END;                                                     0535
@RC00532 DS    0H                                                  0536
*       REG5=ZERO;                  /* ZERO POINTER REGISTER         */
@RC00509 SLR   REG5,REG5                                           0536
*       DO UNTIL(RELEMPTR=RHDRPTR); /* LOOK FOR BEGINING OF LIST     */
*                                                                  0537
@DL00537 DS    0H                                                  0538
*         /***********************************************************/
*         /*                                                         */
*         /* SET INDEX TO KEYWDTAB                                   */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0538
*         REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD    */
*                                                                  0538
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0538
         MH    REG11,@CH00984                                      0538
*         /***********************************************************/
*         /*                                                         */
*         /* SET INDEX TO KEYWORD ROUTINE                            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0539
*         GEN(IC REG8,MEXLST(REG11))                               0539
*         REFS(MEXLST);             /* LOAD ADDRESS OFF KEYWORD    0539
*                                      ROUTINE                       */
*                                                                  0539
         IC REG8,MEXLST(REG11)
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS KEYWORD                                         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0540
*         GEN(BAL REG10,G2EXBRTB(REG8));                           0540
*                                                                  0540
         BAL REG10,G2EXBRTB(REG8)
*         /***********************************************************/
*         /*                                                         */
*         /* SET PARAMETER POINTERS                                  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0541
*         PLEPTR=PLEPTR-LENGTH(PARMLIST);/* SET POINTER TO NEXT    0541
*                                      PARAMETER                     */
         SL    PLEPTR,@CF00256                                     0541
*         RELEMPTR=PLEMPTR;         /* SET POINTER TO ELEMENT        */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0542
*       END;                                                       0543
@DE00537 CR    RELEMPTR,RHDRPTR                                    0543
         BNE   @DL00537                                            0543
*     END;                                                         0544
*   REG1=RBLKPTR;                   /* SET ADDRESS OF FIRST ACB      */
@RC00485 LR    REG1,RBLKPTR                                        0545
*   REG0=GMLEN;                     /* SET RESISTER 0 TO RETURN VALUE*/
*                                                                  0546
         L     REG0,GMLEN(,REG13)                                  0546
*   /*****************************************************************/
*   /*                                                               */
*   /* MAKE ADDITIONAL COPIES AS REQUIRED                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0547
*   IF GENCOP>1 THEN                /* MORE THAN ONE COPY            */
         LH    @07,GENCOP(,RHDRPTR)                                0547
         C     @07,@CF00081                                        0547
         BNH   @RF00547                                            0547
*     DO;                           /* YES, MAKE THEM                */
*       REG5=RBLKPTR+REG0;          /* SET STOPPER VALUE             */
         LR    REG5,RBLKPTR                                        0549
         ALR   REG5,REG0                                           0549
*       REG6=EXLLEN-ONE;            /* SET LENGTH FOR MOVE           */
         LH    REG6,EXLLEN(,RBLKPTR)                               0550
         BCTR  REG6,0                                              0550
*       DO RBLKPTR=RBLKPTR BY EXLLEN WHILE RBLKPTR<REG5;/*   @ZA07550*/
         B     @DE00551                                            0551
@DL00551 DS    0H                                                  0552
*         GEN FLOWS(GEXLMVC)(EX REG6,GEXLMVC);/* MAKE COPY           */
         EX REG6,GEXLMVC
*       END;                                                       0553
         AH    RBLKPTR,EXLLEN(,RBLKPTR)                            0553
@DE00551 CR    RBLKPTR,REG5                                        0553
         BL    @DL00551                                            0553
*     END;                                                         0554
*   RESPECIFY                                                      0555
*    (REG5,                                                        0555
*     REG6,                                                        0555
*     REG9) UNRESTRICTED;           /*                       @G40AKCM*/
*                                                                  0555
@RF00547 DS    0H                                                  0556
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO USER                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0556
*   RETCODER=ZERO;                  /* SET ZERO RETURN CODE          */
         SLR   RETCODER,RETCODER                                   0556
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0557
*   GEN(BR REG14);                  /* RETURN TO USER                */
         BR REG14
*GEXLMVC:                                                          0559
*   GEN(MVC 0(0,RBLKPTR),0(REG1));  /* MOVE CHAR FOR EXTRA COPIES    */
GEXLMVC  MVC 0(0,RBLKPTR),0(REG1)
*GEXLXC:                                                           0560
*   GEN(XC 4(0,RBLKPTR),4(RBLKPTR));/* INSTRUCTION TO CLEAR STORAGE  */
GEXLXC   XC 4(0,RBLKPTR),4(RBLKPTR)
*                                                                  0561
*   /*****************************************************************/
*   /*                                                               */
*   /* GENCB/NIB ROUTINE BUILDS NIB'S AS REQUESTED BY USER. INPUT IS */
*   /* AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESS     */
*   /* POINTING TO A HEADER AND ELEMENTS THAT REPRESENT KEYWORDS     */
*   /* SPECIFIED BY THE CALLER IN HIS GENCB MACRO INSTRUCTION. OUTPUT*/
*   /* IS INITIALIZED NIB'S THAT ARE COPIED FROM A MODEL AND         */
*   /* CUSTOMIZED AS REQUESTED BY KEYWORDS. THE NUMBER OF NIB'S BUILT*/
*   /* ARE SPECIFIED BY THE FIELD GENCOP IN THE HEADER. IF THE USER  */
*   /* DOES NOT SUPPLY A STORAGE LOCATION IN WHICH THE NIB'S ARE TO  */
*   /* BUILT STORAGE IS OBTAINED VIA A CALL TO GM19C1. STORAGE       */
*   /* SUPPLIED BY THE USER MUST BE ON A FULLWORD BOUNDRY AND CHECKS */
*   /* ARE MADE TO INSURE THAT IT IS. RETURN TO THE USER IS FROM THIS*/
*   /* ROUTINE EXCEPT WHEN AN ERROR IS DETECTED AND THE ERROR EXIT IS*/
*   /* TAKEN.                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0561
*NIBGEN:                                                           0561
*                                                                  0561
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE   */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0561
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
NIBGEN   STM   REG2,REG12,REGSAVE(REG13)                           0561
*   GEN(LA REG12,4095(REG15))   ;   /* SET UP SECOND BASE            */
*                                                                  0562
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0563
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0563
*   RBLKPTR=GENUSA;                 /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,GENUSA(,RHDRPTR)                            0564
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0565
         SLR   REG8,REG8                                           0565
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG INSTRUCTIONS                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0566
*   RESPECIFY                                                      0566
*    (REG5,                                                        0566
*     REG9) RESTRICTED;             /*                       @G40AKCM*/
*   REG5=LENGTH(ISTNIB);            /* SET TOTAL LENGTH OF NIB     0567
*                                                            @G40AKCM*/
         LA    REG5,64                                             0567
*   REG9=ADDR(DVTAMNIB)-ADDR(DEFCBRTN);/* SET OFFSET TO COPY ROUTINE
*                                                            @G40AKCM*/
         LA    REG9,DVTAMNIB                                       0568
         LA    @07,DEFCBRTN                                        0568
         SLR   REG9,@07                                            0568
*   GEN(BAL REG10,GM19C1)                                          0569
*   FLOWS(GM19C1);                  /* CALL GETMAIN                  */
         BAL REG10,GM19C1
*   RESPECIFY                                                      0570
*    (REG5,                                                        0570
*     REG9) UNRESTRICTED;           /*                       @G40AKCM*/
*                                                                  0570
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0571
*   IF EOL=ON THEN                                                 0571
         TM    EOL(PLEPTR),B'10000000'                             0571
         BO    @RT00571                                            0571
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00573 DS    0H                                                  0574
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0574
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0575
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0575
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0576
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0576
         MH    REG11,@CH00984                                      0576
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0577
         BH    @RT00577                                            0577
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0578
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0579
*       GEN(IC REG8,MNIB(REG11))                                   0579
*       REFS(MNIB);                 /* LOAD ADDRESS OFF KEYWORD    0579
*                                      ROUTINE                       */
*                                                                  0579
         IC REG8,MNIB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0580
*       GEN(EX REG0,MNIBKWTB(REG8))                                0580
*       FLOWS(MNIBKWTB);                                           0580
         EX REG0,MNIBKWTB(REG8)
*     END;                                                         0581
@DE00573 TM    EOL(PLEPTR),B'10000000'                             0581
         BNO   @DL00573                                            0581
*   REG1=RBLKPTR;                   /* SET ADDRESS OF FIRST ACB      */
@RT00571 LR    REG1,RBLKPTR                                        0582
*   REG0=GMLEN;                     /* SET RESISTER 0 TO RETURN VALUE*/
*                                                                  0583
         L     REG0,GMLEN(,REG13)                                  0583
*   /*****************************************************************/
*   /*                                                               */
*   /* MAKE ADDITIONAL COPIES AS REQUIRED                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0584
*   IF GENCOP>1 THEN                /* MORE COPIES TO MAKE           */
         LH    @09,GENCOP(,RHDRPTR)                                0584
         C     @09,@CF00081                                        0584
         BNH   @RF00584                                            0584
*     DO;                           /* YES, MAKE THEM                */
*       RESPECIFY                                                  0586
*         REG5 RSTD;                                               0586
*       REG5=RBLKPTR+REG0;          /* SET STOPPER VALUE             */
         LR    REG5,RBLKPTR                                        0587
         ALR   REG5,REG0                                           0587
*       DO RBLKPTR=RBLKPTR BY NIBLEN WHILE RBLKPTR<REG5;/*   @ZA07550*/
         B     @DE00588                                            0588
@DL00588 DS    0H                                                  0589
*         NEWNIB=REG1->NEWNIB;      /* COPY BLOCK                    */
         MVC   NEWNIB(64,RBLKPTR),NEWNIB(REG1)                     0589
*       END;                                                       0590
         SLR   @09,@09                                             0590
         IC    @09,NIBLEN(,RBLKPTR)                                0590
         ALR   RBLKPTR,@09                                         0590
@DE00588 CR    RBLKPTR,REG5                                        0590
         BL    @DL00588                                            0590
*       RESPECIFY                                                  0591
*         REG5 UNRSTD;                                             0591
*     END;                                                         0592
*                                                                  0592
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO USER                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0593
*   RETCODER=ZERO;                  /* SET ZERO RETURN CODE          */
@RF00584 SLR   RETCODER,RETCODER                                   0593
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0594
*   GEN(BR REG14);                  /* RETURN TO USER                */
         BR REG14
*                                                                  0596
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB/ACB- ROUTINE MODIFIES EXISTING ACB'S AS REQUESTED BY THE*/
*   /* USER. INPUT IS AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST */
*   /* OF ADDRESSES THAT POINT TO A HEADER AND ELEMENTS THAT         */
*   /* REPRESENT KEYWORDS SPECIFIED BY THE USER IN THE MODCB MACRO.  */
*   /* THE HEADER CONTAINS A POINTER TO THE ACB TO BE MODIFIED IN THE*/
*   /* FIELD MODBLAD. THIS MUST POINT TO A ACB OR AN ERROR WILL BE   */
*   /* INDICATED TO THE USER. OUTPUT IS THE MODIFIED ACB. ACB'S ARE  */
*   /* MODIFIED AS REQUESTED BY THE USER BY EXECUTING THE            */
*   /* INSTRUCTIONS THAT ACCOMPLISHED THE DESIRED MODIFICATION. VTAM */
*   /* ONLY KEYWORDS ARE CHECKED TO INSURE THAT THE RPL IS LONG      */
*   /* ENOUGTH TO CONTAIN THE TARGET FIELD AND THAT AM=VTAM WAS      */
*   /* SPECIFIED BY THE USER.                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0596
*ACBMOD:                                                           0596
*                                                                  0596
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0596
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
ACBMOD   STM   REG2,REG12,REGSAVE(REG13)                           0596
*   GEN(LA REG12,4095(REG15))  ;    /* SET UP SECOND BASE            */
         LA REG12,4095(REG15)
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0598
*   RBLKPTR=MODBLAD;                /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,MODBLAD(,RHDRPTR)                           0599
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0600
         SLR   REG8,REG8                                           0600
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG INSTRUCTIONS                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0601
*   IF ACBID^=IDXACB THEN           /* IF NOT POINTING TO ACB        */
         CLI   ACBID(RBLKPTR),160                                  0601
         BE    @RF00601                                            0601
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0603
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0604
*     END;                                                         0605
*   IF ACBOPEN=ON THEN              /* ACB IS OPEN                   */
@RF00601 TM    ACBOPEN(RBLKPTR),B'00010000'                        0606
         BNO   @RF00606                                            0606
*     DO;                           /* ERROR PROCESS                 */
*       REG0=ACBISOPN;              /* SET REASON CODE               */
         LA    REG0,12                                             0608
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0609
*     END;                                                         0610
*                                                                  0610
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0611
*   IF EOL=ON THEN                                                 0611
@RF00606 TM    EOL(PLEPTR),B'10000000'                             0611
         BO    @RT00611                                            0611
*     ;                             /* KEWORDS SPECIFIED             */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00613 DS    0H                                                  0614
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP TO NEXT ENTRY         */
         AL    PLEPTR,@CF00256                                     0614
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0615
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0615
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEWDTAB                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0616
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0616
         MH    REG11,@CH00984                                      0616
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0617
         BH    @RT00617                                            0617
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*       GEN(IC REG8,MACB(REG11))                                   0619
*       REFS(MACB);                 /* LOAD ADDRESS OFF KEYWORD    0619
*                                      ROUTINE                       */
*                                                                  0619
         IC REG8,MACB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0620
*       GEN(EX REG0,MACBKWTB(REG8))                                0620
*       FLOWS(MACBKWTB);            /* CALL KEYWORD ROUTINE          */
         EX REG0,MACBKWTB(REG8)
*     END;                                                         0621
*                                                                  0621
@DE00613 TM    EOL(PLEPTR),B'10000000'                             0621
         BNO   @DL00613                                            0621
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0622
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00611 SLR   RETCODER,RETCODER                                   0622
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0623
*   GEN(BR REG14) ;                 /* GO BACK TO USER               */
         BR REG14
*                                                                  0625
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB/RPL- ROUTINE MODIFIES EXISTING RPL'S AS REQUESTED BY THE*/
*   /* USER. INPUT IS AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST */
*   /* OF ADDRESSES THAT POINT TO A HEADER AND ELEMENTS THAT         */
*   /* REPRESENT KEYWORDS SPECIFIED BY THE USER IN THE MODCB MACRO.  */
*   /* THE HEADER CONTAINS A POINTER TO THE RPL TO BE MODIFIED IN THE*/
*   /* FIELD MODBLAD. THIS MUST POINT TO A RPL OR AN ERROR WILL BE   */
*   /* INDICATED TO THE USER. OUTPUT IS THE MODIFIED RPL. RPL'S ARE  */
*   /* MODIFIED AS REQUESTED BY THE USER BY EXECUTING THE            */
*   /* INSTRUCTIONS THAT ACCOMPLISHED THE DESIRED MODIFICATION. VTAM */
*   /* ONLY KEYWORDS ARE CHECKED TO INSURE THAT THE RPL IS LONG      */
*   /* ENOUGTH TO CONTAIN THE TARGET FIELD AND THAT AM=VTAM WAS      */
*   /* SPECIFIED BY THE USER.                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0625
*RPLMOD:                                                           0625
*                                                                  0625
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0625
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
RPLMOD   STM   REG2,REG12,REGSAVE(REG13)                           0625
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
         LA REG12,4095(REG15)
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0627
*   RBLKPTR=MODBLAD;                /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,MODBLAD(,RHDRPTR)                           0628
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0629
         SLR   REG8,REG8                                           0629
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0630
*   IF RPLID^=IDXRPL THEN           /* IF NOT POINTING TO RPL        */
         CLI   RPLID(RBLKPTR),X'00'                                0630
         BE    @RF00630                                            0630
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0632
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0633
*     END;                                                         0634
*                                                                  0634
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR RPL ACTIVE                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0635
*   TS(RPLACTIV);                   /* TEST ACTIVE BYTE              */
@RF00630 TS    RPLACTIV(RBLKPTR)                                   0635
*   BC(8,NOTACT);                   /* BRANCH NOT ACTIVE             */
         BC    8,NOTACT                                            0636
*   REG0=RPLISACT;                  /* SET ERROR CODE                */
         LA    REG0,11                                             0637
*   GO TO EXITBAD;                  /* EXIT WITH ERROR               */
         B     EXITBAD                                             0638
*NOTACT:                                                           0639
*                                                                  0639
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0639
*   IF EOL=ON THEN                                                 0639
NOTACT   TM    EOL(PLEPTR),B'10000000'                             0639
         BO    @RT00639                                            0639
*     ;                             /* KEWORDS SPECIFIED             */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00641 DS    0H                                                  0642
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0642
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0643
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0643
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0644
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0644
         MH    REG11,@CH00984                                      0644
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0645
         BH    @RT00645                                            0645
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0646
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0647
*       GEN(IC REG8,MRPL(REG11))                                   0647
*       REFS(MRPL);                 /* LOAD ADDRESS OFF KEYWORD    0647
*                                      ROUTINE                       */
*                                                                  0647
         IC REG8,MRPL(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0648
*       GEN(EX REG0,MRPLKWTB(REG8))                                0648
*       FLOWS(MRPLKWTB);                                           0648
         EX REG0,MRPLKWTB(REG8)
*     END;                                                         0649
*                                                                  0649
@DE00641 TM    EOL(PLEPTR),B'10000000'                             0649
         BNO   @DL00641                                            0649
*   /*****************************************************************/
*   /*                                                               */
*   /* RESET ACTIVE BYTE                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0650
*   RPLACTIV=ZERO;                  /* RESET ACTIVE BYTE             */
*                                                                  0650
@RT00639 MVI   RPLACTIV(RBLKPTR),X'00'                             0650
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0651
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
         SLR   RETCODER,RETCODER                                   0651
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0652
*   GEN(BR REG14) ;                 /* GO BACK TO USER               */
         BR REG14
*                                                                  0654
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB/EXLST- ROUTINE MODIFIES EXISTING EXLST'S AS REQUESTED BY*/
*   /* THE USER. INPUT IS AN ADDRESS IN REGISTER 1 THAT POINTS TO A  */
*   /* LIST OF ADDRESSES THAT POINT TO A HEADER AND ELEMENTS THAT    */
*   /* REPRESENT KEYWORDS SPECIFIED BY THE USER IN THE MODCB MACRO.  */
*   /* THE HEADER CONTAINS A POINTER TO THE EXLST TO BE MODIFIED IN  */
*   /* THE FIELD MODBLAD. THIS MUST POINT TO A EXLST OR AN ERROR WILL*/
*   /* BE INDICATED TO THE USER. OUTPUT IS THE MODIFIED EXLST.       */
*   /* EXLST'S ARE MODIFIED AS REQUESTED BY THE USER BY EXECUTING    */
*   /* THE INSTRUCTIONS THAT ACCOMPLISHED THE DESIRED MODIFICATION.  */
*   /* KEYWORDS ARE CHECKED TO INSURE THAT THE EXLST IS LONG ENOUGTH */
*   /* TO CONTAIN THE TARGET FIELD AND THAT FOR VTAM ONLY KEYWORDS   */
*   /* AM=VTAM WAS SPECIFIED BY THE USER.                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0654
*EXLSTMOD:                                                         0654
*                                                                  0654
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0654
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
EXLSTMOD STM   REG2,REG12,REGSAVE(REG13)                           0654
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
*                                                                  0655
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0656
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0656
*   RBLKPTR=MODBLAD;                /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,MODBLAD(,RHDRPTR)                           0657
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0658
         SLR   REG8,REG8                                           0658
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0659
*   IF EXLID^=IDXEXLST THEN         /* IF NOT POINTING TO EXLST      */
         CLI   EXLID(RBLKPTR),129                                  0659
         BE    @RF00659                                            0659
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0661
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0662
*     END;                                                         0663
*                                                                  0663
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0664
*   IF EOL=ON THEN                                                 0664
@RF00659 TM    EOL(PLEPTR),B'10000000'                             0664
         BO    @RT00664                                            0664
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00666 DS    0H                                                  0667
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0667
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0668
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0668
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0669
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0669
         MH    REG11,@CH00984                                      0669
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0670
         BH    @RT00670                                            0670
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0671
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0672
*       GEN(IC REG8,MEXLST(REG11))                                 0672
*       REFS(MEXLST);               /* LOAD ADDRESS OFF KEYWORD    0672
*                                      ROUTINE                       */
*                                                                  0672
         IC REG8,MEXLST(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS KEYWORD                                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0673
*       GEN(BAL REG10,MEXLBRTB(REG8))                              0673
*       FLOWS(MEXLBRTB);            /* CALL KEYWORD ROUTINE          */
         BAL REG10,MEXLBRTB(REG8)
*     END;                                                         0674
*                                                                  0674
@DE00666 TM    EOL(PLEPTR),B'10000000'                             0674
         BNO   @DL00666                                            0674
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0675
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00664 SLR   RETCODER,RETCODER                                   0675
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0676
*   GEN(BR REG14) ;                 /* GO BACK TO USER               */
         BR REG14
*                                                                  0678
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB/NIB- ROUTINE MODIFIES EXISTING NIB'S AS REQUESTED BY THE*/
*   /* USER. INPUT IS AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST */
*   /* OF ADDRESSES THAT POINT TO A HEADER AND ELEMENTS THAT         */
*   /* REPRESENT KEYWORDS SPECIFIED BY THE USER IN THE MODCB MACRO.  */
*   /* THE HEADER CONTAINS A POINTER TO THE NIB TO BE MODIFIED IN THE*/
*   /* FIELD MODBLAD. THIS MUST POINT TO A NIB OR AN ERROR WILL BE   */
*   /* INDICATED TO THE USER. OUTPUT IS THE MODIFIED NIB. NIB'S ARE  */
*   /* MODIFIED AS REQUESTED BY THE USER BY EXECUTING THE            */
*   /* INSTRUCTIONS THAT ACCOMPLISHED THE DESIRED MODIFICATION.      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0678
*NIBMOD:                                                           0678
*                                                                  0678
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0678
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
NIBMOD   STM   REG2,REG12,REGSAVE(REG13)                           0678
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
         LA REG12,4095(REG15)
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0680
*   RBLKPTR=MODBLAD;                /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,MODBLAD(,RHDRPTR)                           0681
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0682
         SLR   REG8,REG8                                           0682
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0683
*   IF NIBID^=NIBIDD THEN           /* IF NOT POINTING TO RPL        */
         CLI   NIBID(RBLKPTR),X'D0'                                0683
         BE    @RF00683                                            0683
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0685
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0686
*     END;                                                         0687
*                                                                  0687
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0688
*   IF EOL=ON THEN                                                 0688
@RF00683 TM    EOL(PLEPTR),B'10000000'                             0688
         BO    @RT00688                                            0688
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00690 DS    0H                                                  0691
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0691
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0692
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0692
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0693
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0693
         MH    REG11,@CH00984                                      0693
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0694
         BH    @RT00694                                            0694
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0695
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0696
*       GEN(IC REG8,MNIB(REG11))                                   0696
*       REFS(MNIB);                 /* LOAD ADDRESS OFF KEYWORD    0696
*                                      ROUTINE                       */
*                                                                  0696
         IC REG8,MNIB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0697
*       GEN(EX REG0,MNIBKWTB(REG8))                                0697
*       FLOWS(MNIBKWTB);                                           0697
         EX REG0,MNIBKWTB(REG8)
*     END;                                                         0698
*                                                                  0698
@DE00690 TM    EOL(PLEPTR),B'10000000'                             0698
         BNO   @DL00690                                            0698
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0699
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00688 SLR   RETCODER,RETCODER                                   0699
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0700
*   GEN(BR REG14) ;                 /* GO BACK TO USER               */
         BR REG14
*                                                                  0702
*   /*****************************************************************/
*   /*                                                               */
*   /* SHOW/ACB- ROUTINE DISPLAYS IN AN AREA SUPPLIED BY THE USER    */
*   /* FIELDS FROM AN ACB AND IT'S RELATED CONTROL BLOCKS. INPUT IS  */
*   /* AN ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESS THAT*/
*   /* POINT TO A HEADER AND ELEMENTS THAT REPRESENT SHOWCB KEYWORDS */
*   /* SPECIFIED BY THE USER. THE HEADER HAS A POINTER TO THE ACB TO */
*   /* BE DISPLAYED IN THE SHOWBLAD FIELD. SHOWBLAD MUST POINT TO AN */
*   /* ACB OR AN ERROR IS RETURNED TO THE USER. FIELDS THAT ARE IN   */
*   /* ACB RELATED BLOCKS REQUIRE THE ACB TO BE OPEN. FIELDS ARE     */
*   /* DISPLAYED UNTIL ALL ELEMENTS ARE PROCESSED OR THE STORAGE     */
*   /* SUPPLIED BY THE USER RUNS OUT.                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0702
*ACBSHOW:                                                          0702
*                                                                  0702
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOG CODE MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS */
*   /* AND DECODE ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE    */
*   /* INSTRUCTIONS                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0702
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
ACBSHOW  STM   REG2,REG12,REGSAVE(REG13)                           0702
*   GEN(LA REG12,4095(REG15)) ;     /* SET UP SECOND BASE            */
*                                                                  0703
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0704
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0704
*   RBLKPTR=SHOWBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          0705
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0706
         SLR   REG8,REG8                                           0706
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0707
*   IF ACBID^=IDXACB THEN           /* IF NOT POINTING TO ACB        */
         CLI   ACBID(RBLKPTR),160                                  0707
         BE    @RF00707                                            0707
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0709
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0710
*     END;                                                         0711
*   SHOWUSE=ZERO;                   /* ZERO USED COUNT               */
*                                                                  0712
@RF00707 SLR   @09,@09                                             0712
         STH   @09,SHOWUSE(,REG13)                                 0712
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0713
*   IF EOL=ON THEN                                                 0713
         TM    EOL(PLEPTR),B'10000000'                             0713
         BO    @RT00713                                            0713
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00715 DS    0H                                                  0716
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0716
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0717
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0717
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0718
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0718
         MH    REG11,@CH00984                                      0718
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0719
         BH    @RT00719                                            0719
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*       GEN(IC REG8,SACB(REG11))                                   0721
*       REFS(SACB);                 /* LOAD ADDRESS OFF KEYWORD    0721
*                                      ROUTINE                       */
*                                                                  0721
         IC REG8,SACB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0722
*       GEN(BAL REG10,KWBRTAB(REG8))                               0722
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0723
*                                                                  0723
@DE00715 TM    EOL(PLEPTR),B'10000000'                             0723
         BNO   @DL00715                                            0723
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0724
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00713 SLR   RETCODER,RETCODER                                   0724
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0725
*   GEN(BR REG14)                                                  0726
*   EXIT;                           /* GO BACK TO USER               */
         BR REG14
*                                                                  0727
*   /*****************************************************************/
*   /*                                                               */
*   /* SHOWCB/RPL- ROUTINE DISPLAYS IN AN AREA SUPPLIED BY THE USER  */
*   /* FIELDS FROM AN RPL. INPUT IS AN ADDRESS IN REGISTER 1 THAT    */
*   /* POINTS TO A LIST OF ADDRESS THAT POINT TO A HEADER AND        */
*   /* ELEMENTS THAT REPRESENT SHOWCB KEYWORDS SPECIFIED BY THE USER.*/
*   /* THE HEADER HAS A POINTER TO THE RPL TO BE DISPLAYED IN THE    */
*   /* SHOWBLAD FIELD. SHOWBLAD MUST POINT TO AN RPL OR AN ERROR IS  */
*   /* RETURNED TO THE USER. FIELDS ARE DISPLAYED UNTIL ALL ELEMENTS */
*   /* ARE PROCESSED OR THE STORAGE SUPPLIED BY THE USER RUNS OUT.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0727
*RPLSHOW:                                                          0727
*                                                                  0727
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE   */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0727
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
RPLSHOW  STM   REG2,REG12,REGSAVE(REG13)                           0727
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0728
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0729
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0729
*   RBLKPTR=SHOWBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          0730
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0731
         SLR   REG8,REG8                                           0731
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0732
*   IF RPLID^=IDXRPL THEN           /* IF NOT POINTING TO RPL        */
         CLI   RPLID(RBLKPTR),X'00'                                0732
         BE    @RF00732                                            0732
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0734
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0735
*     END;                                                         0736
*   SHOWUSE=ZERO;                   /* ZERO USED COUNT               */
*                                                                  0737
@RF00732 SLR   @09,@09                                             0737
         STH   @09,SHOWUSE(,REG13)                                 0737
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0738
*   IF EOL=ON THEN                                                 0738
         TM    EOL(PLEPTR),B'10000000'                             0738
         BO    @RT00738                                            0738
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00740 DS    0H                                                  0741
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0741
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0742
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0742
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYEDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0743
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0743
         MH    REG11,@CH00984                                      0743
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0744
         BH    @RT00744                                            0744
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0745
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0746
*       GEN(IC REG8,SRPL(REG11))                                   0746
*       REFS(SRPL);                 /* LOAD ADDRESS OFF KEYWORD    0746
*                                      ROUTINE                       */
*                                                                  0746
         IC REG8,SRPL(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0747
*       GEN(BAL REG10,KWBRTAB(REG8))                               0747
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0748
*                                                                  0748
@DE00740 TM    EOL(PLEPTR),B'10000000'                             0748
         BNO   @DL00740                                            0748
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0749
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00738 SLR   RETCODER,RETCODER                                   0749
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0750
*   GEN(BR REG14)                                                  0751
*   EXIT;                           /* GO BACK TO USER               */
         BR REG14
*                                                                  0752
*   /*****************************************************************/
*   /*                                                               */
*   /* SHOWCB/EXLST ROUTINE DISPLAYS IN AN AREA SUPPLIED BY THE USER */
*   /* FIELDS FROM AN EXLST. INPUT IS AN ADDRESS IN REGISTER 1 THAT  */
*   /* POINTS TO A LIST OF ADDRESS THAT POINT TO A HEADER AND        */
*   /* ELEMENTS THAT REPRESENT SHOWCB KEYWORDS SPECIFIED BY THE USER.*/
*   /* THE HEADER HAS A POINTER TO THE EXLST TO BE DISPLAYED IN THE  */
*   /* SHOWBLAD FIELD. SHOWBLAD MUST POINT TO AN EXLST OR AN ERROR IS*/
*   /* RETURNED TO THE USER. FIELDS ARE DISPLAYED UNTIL ALL ELEMENTS */
*   /* ARE PROCESSED OR THE STORAGE SUPPLIED BY THE USER RUNS OUT.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0752
*EXLSSHOW:                                                         0752
*                                                                  0752
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE   */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0752
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
EXLSSHOW STM   REG2,REG12,REGSAVE(REG13)                           0752
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0753
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0754
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0754
*   RBLKPTR=SHOWBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          0755
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0756
         SLR   REG8,REG8                                           0756
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0757
*   IF EXLID^=IDXEXLST THEN         /* IF NOT POINTING TO RPL        */
         CLI   EXLID(RBLKPTR),129                                  0757
         BE    @RF00757                                            0757
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0759
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0760
*     END;                                                         0761
*   SHOWUSE=ZERO;                   /* ZERO USED COUNT               */
*                                                                  0762
@RF00757 SLR   @09,@09                                             0762
         STH   @09,SHOWUSE(,REG13)                                 0762
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0763
*   IF EOL=ON THEN                                                 0763
         TM    EOL(PLEPTR),B'10000000'                             0763
         BO    @RT00763                                            0763
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00765 DS    0H                                                  0766
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0766
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0767
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0767
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0768
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0768
         MH    REG11,@CH00984                                      0768
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0769
         BH    @RT00769                                            0769
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0770
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0771
*       GEN(IC REG8,SEXLST(REG11))                                 0771
*       REFS(SEXLST);               /* LOAD ADDRESS OFF KEYWORD    0771
*                                      ROUTINE                       */
*                                                                  0771
         IC REG8,SEXLST(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0772
*       GEN(BAL REG10,KWBRTAB(REG8))                               0772
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0773
*                                                                  0773
@DE00765 TM    EOL(PLEPTR),B'10000000'                             0773
         BNO   @DL00765                                            0773
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0774
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00763 SLR   RETCODER,RETCODER                                   0774
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0775
*   GEN(BR REG14)                                                  0776
*   EXIT;                           /* GO BACK TO USER               */
         BR REG14
*                                                                  0777
*   /*****************************************************************/
*   /*                                                               */
*   /* SHOWCB/NIB ROUTINE DISPLAYS IN AN AREA SUPPLIED BY THE USER   */
*   /* FIELDS FROM AN NIB. INPUT IS AN ADDRESS IN REGISTER 1 THAT    */
*   /* POINTS TO A LIST OF ADDRESS THAT POINT TO A HEADER AND        */
*   /* ELEMENTS THAT REPRESENT SHOWCB KEYWORDS SPECIFIED BY THE USER.*/
*   /* THE HEADER HAS A POINTER TO THE NIB TO BE DISPLAYED IN THE    */
*   /* SHOWBLAD FIELD. SHOWBLAD MUST POINT TO AN NIB OR AN ERROR IS  */
*   /* RETURNED TO THE USER. FIELDS ARE DISPLAYED UNTIL ALL ELEMENTS */
*   /* ARE PROCESSED OR THE STORAGE SUPPLIED BY THE USER RUNS OUT.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0777
*NIBSHOW:                                                          0777
*                                                                  0777
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE   */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0777
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
NIBSHOW  STM   REG2,REG12,REGSAVE(REG13)                           0777
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0778
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0779
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0779
*   RBLKPTR=SHOWBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          0780
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0781
         SLR   REG8,REG8                                           0781
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0782
*   IF NIBID^=NIBIDD THEN           /* IF NOT POINTING TO NIB        */
         CLI   NIBID(RBLKPTR),X'D0'                                0782
         BE    @RF00782                                            0782
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0784
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0785
*     END;                                                         0786
*   SHOWUSE=ZERO;                   /* ZERO USED COUNT               */
*                                                                  0787
@RF00782 SLR   @09,@09                                             0787
         STH   @09,SHOWUSE(,REG13)                                 0787
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0788
*   IF EOL=ON THEN                                                 0788
         TM    EOL(PLEPTR),B'10000000'                             0788
         BO    @RT00788                                            0788
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00790 DS    0H                                                  0791
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0791
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0792
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0792
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0793
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0793
         MH    REG11,@CH00984                                      0793
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0794
         BH    @RT00794                                            0794
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0795
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0796
*       GEN(IC REG8,SNIB(REG11))                                   0796
*       REFS(SNIB);                 /* LOAD ADDRESS OFF KEYWORD    0796
*                                      ROUTINE                       */
*                                                                  0796
         IC REG8,SNIB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0797
*       GEN(BAL REG10,KWBRTAB(REG8))                               0797
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0798
*                                                                  0798
@DE00790 TM    EOL(PLEPTR),B'10000000'                             0798
         BNO   @DL00790                                            0798
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0799
*   RETCODER=ZERO;                  /* SET GOOD RETURN CODE          */
@RT00788 SLR   RETCODER,RETCODER                                   0799
*   LM(REG2,REG12,REGSAVE);         /* RELOAD REGISTERS              */
         LM    REG2,REG12,REGSAVE(REG13)                           0800
*   GEN(BR REG14)                                                  0801
*   EXIT;                           /* GO BACK TO USER               */
         BR REG14
*                                                                  0802
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTCB/ACB ROUTINE TESTS FIELDS IN AN ACB OR ACB RELATED      */
*   /* BLOCKS. INPUT IS AN ADDRESS IN REGISTER 1 THAT POINTS TO A    */
*   /* LIST OF ADDRESS THAT POINT TO A HEADER AND ELEMENTS THAT      */
*   /* REPRESENT TESTCB KEYWORDS SPECIFIED BY THE USER. THE HEADER   */
*   /* HAS A POINTER TO THE ACB TO BE DISPLAYED IN THE TESTBLAD      */
*   /* FIELD. TESTBLAD MUST POINT TO AN ACB OR AN ERROR IS RETURNED  */
*   /* TO THE USER. TO TEST FIELDS IN ACB RELATED BLOCKS THE ACB MUST*/
*   /* BE OPEN OR AN ERROR IS RETURNED. FIELDS ARE TESTED UNTIL ALL  */
*   /* ELEMENTS ARE PROCESSED OR AN ERROR OCCURS. THE CONDITION CODE */
*   /* IS SET JUST PRIOR TO EXIT AND IS PRESERVED FOR THE NEXT       */
*   /* SEQUENTAL INSTRUCTION AFTER THE TESTCB.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0802
*ACBTEST:                                                          0802
*                                                                  0802
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE   */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0802
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
ACBTEST  STM   REG2,REG12,REGSAVE(REG13)                           0802
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0803
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0804
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0804
*   RBLKPTR=TESTBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          0805
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0806
         SLR   REG8,REG8                                           0806
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0807
*   IF ACBID^=IDXACB THEN           /* IF NOT POINTING TO ACB        */
         CLI   ACBID(RBLKPTR),160                                  0807
         BE    @RF00807                                            0807
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0809
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0810
*     END;                                                         0811
*   TESTCC=ZERO;                    /* ZERO CONDITION CODE           */
*                                                                  0812
@RF00807 SLR   @09,@09                                             0812
         STH   @09,TESTCC(,REG13)                                  0812
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0813
*   IF EOL=ON THEN                                                 0813
         TM    EOL(PLEPTR),B'10000000'                             0813
         BO    @RT00813                                            0813
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00815 DS    0H                                                  0816
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP TO NEXT ENTRY         */
         AL    PLEPTR,@CF00256                                     0816
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0817
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0817
*       /*************************************************************/
*       /*                                                           */
*       /* SET POINTER TO KEYWDTAB                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0818
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0818
         MH    REG11,@CH00984                                      0818
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0819
         BH    @RT00819                                            0819
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0820
*       /*************************************************************/
*       /*                                                           */
*       /* SET POINTER TO KEYWORD ROUTINE                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0821
*       GEN(IC REG8,TACB(REG11))                                   0821
*       REFS(TACB);                 /* LOAD ADDRESS OFF KEYWORD    0821
*                                      ROUTINE                       */
*                                                                  0821
         IC REG8,TACB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0822
*       GEN(BAL REG10,KWBRTAB(REG8))                               0822
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0823
*                                                                  0823
@DE00815 TM    EOL(PLEPTR),B'10000000'                             0823
         BNO   @DL00815                                            0823
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0824
*   RETCODER=ZERO;                  /* ZERO RETURN CODE              */
@RT00813 SLR   RETCODER,RETCODER                                   0824
*   RESPECIFY                                                      0825
*     REG5 RSTD;                                                   0825
*   REG5=TESTCC;                    /* PICKUP UP TESTCC              */
         LH    REG5,TESTCC(,REG13)                                 0826
*   GEN(LTR REG5,REG5);             /* SET CONDITION CODE            */
         LTR REG5,REG5
*   RESPECIFY                                                      0828
*     REG5 UNRSTD;                                                 0828
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0829
*   GEN(BR REG14)                                                  0830
*   EXIT;                           /* RETURN TO USER                */
         BR REG14
*                                                                  0831
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTCB/RPL- ROUTINE TESTS FIELDS IN AN RPL. INPUT IS AN       */
*   /* ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESSES THAT */
*   /* POINT TO A HEADER AND ELEMENTS THAT REPRESENT TESTCB KEYWORDS */
*   /* SPECIFIED BY THE USER. THE HEADER HAS A POINTER TO THE RPL TO */
*   /* BE DISPLAYED IN THE TESTBLAD FIELD. TESTBLAD MUST POINT TO AN */
*   /* RPL OR AN ERROR IS RETURNED TO THE USER. FIELDS ARE TESTED    */
*   /* UNTIL ALL ELEMENTS ARE PROCESSED OR AN ERROR OCCURS. THE      */
*   /* CONDITION CODE IS SET JUST PRIOR TO EXIT AND IS PRESERVED FOR */
*   /* THE NEXT SEQUENTAL INSTRUCTION AFTER THE TESTCB.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0831
*RPLTEST:                                                          0831
*                                                                  0831
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE   */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0831
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
RPLTEST  STM   REG2,REG12,REGSAVE(REG13)                           0831
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0832
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0833
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0833
*   RBLKPTR=TESTBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          0834
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0835
         SLR   REG8,REG8                                           0835
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0836
*   IF RPLID^=IDXRPL THEN           /* IF NOT POINTING TO RPL        */
         CLI   RPLID(RBLKPTR),X'00'                                0836
         BE    @RF00836                                            0836
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0838
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0839
*     END;                                                         0840
*   TESTCC=ZERO;                    /* ZERO CONDITION CODE           */
*                                                                  0841
@RF00836 SLR   @09,@09                                             0841
         STH   @09,TESTCC(,REG13)                                  0841
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORD IF ANY                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0842
*   IF EOL=ON THEN                                                 0842
         TM    EOL(PLEPTR),B'10000000'                             0842
         BO    @RT00842                                            0842
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00844 DS    0H                                                  0845
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0845
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0846
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0846
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0847
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0847
         MH    REG11,@CH00984                                      0847
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0848
         BH    @RT00848                                            0848
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0849
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0850
*       GEN(IC REG8,TRPL(REG11))                                   0850
*       REFS(TRPL);                 /* LOAD ADDRESS OFF KEYWORD    0850
*                                      ROUTINE                       */
*                                                                  0850
         IC REG8,TRPL(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0851
*       GEN(BAL REG10,KWBRTAB(REG8))                               0851
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0852
*                                                                  0852
@DE00844 TM    EOL(PLEPTR),B'10000000'                             0852
         BNO   @DL00844                                            0852
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0853
*   RETCODER=ZERO;                  /* ZERO RETURN CODE              */
@RT00842 SLR   RETCODER,RETCODER                                   0853
*   RESPECIFY                                                      0854
*     REG5 RSTD;                                                   0854
*   REG5=TESTCC;                    /* PICKUP UP TESTCC              */
         LH    REG5,TESTCC(,REG13)                                 0855
*   GEN(LTR REG5,REG5);             /* SET CONDITION CODE            */
         LTR REG5,REG5
*   RESPECIFY                                                      0857
*     REG5 UNRSTD;                                                 0857
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0858
*   GEN(BR REG14)                                                  0859
*   EXIT;                           /* RETURN TO USER                */
         BR REG14
*                                                                  0860
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTCB/EXLST- ROUTINE TESTS FIELDS IN AN EXLST. INPUT IS AN   */
*   /* ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESSES THAT */
*   /* POINT TO A HEADER AND ELEMENTS THAT REPRESENT TESTCB KEYWORDS */
*   /* SPECIFIED BY THE USER. THE HEADER HAS A POINTER TO THE EXLST  */
*   /* TO BE DISPLAYED IN THE TESTBLAD FIELD. TESTBLAD MUST POINT TO */
*   /* AN EXLST OR AN ERROR IS RETURNED TO THE USER. FIELDS ARE      */
*   /* TESTED UNTIL ALL ELEMENTS ARE PROCESSED OR AN ERROR OCCURS.   */
*   /* THE CONDITION CODE IS SET JUST PRIOR TO EXIT AND IS PRESERVED */
*   /* FOR THE NEXT SEQUENTAL INSTRUCTION AFTER THE TESTCB.          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0860
*EXLSTEST:                                                         0860
*                                                                  0860
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE. PROLOG CODE  */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0860
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
EXLSTEST STM   REG2,REG12,REGSAVE(REG13)                           0860
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0861
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0862
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0862
*   RBLKPTR=TESTBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          0863
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0864
         SLR   REG8,REG8                                           0864
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0865
*   IF EXLID^=IDXEXLST THEN         /* IF NOT POINTING TO EXLST      */
         CLI   EXLID(RBLKPTR),129                                  0865
         BE    @RF00865                                            0865
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0867
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0868
*     END;                                                         0869
*   TESTCC=ZERO;                    /* ZERO CONDITION CODE           */
*                                                                  0870
@RF00865 SLR   @09,@09                                             0870
         STH   @09,TESTCC(,REG13)                                  0870
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0871
*   IF EOL=ON THEN                                                 0871
         TM    EOL(PLEPTR),B'10000000'                             0871
         BO    @RT00871                                            0871
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00873 DS    0H                                                  0874
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP TO NEXT ENTRY         */
         AL    PLEPTR,@CF00256                                     0874
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0875
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0875
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0876
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0876
         MH    REG11,@CH00984                                      0876
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0877
         BH    @RT00877                                            0877
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0878
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0879
*       GEN(IC REG8,TEXLST(REG11))                                 0879
*       REFS(TEXLST);               /* LOAD ADDRESS OFF KEYWORD    0879
*                                      ROUTINE                       */
*                                                                  0879
         IC REG8,TEXLST(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0880
*       GEN(BAL REG10,KWBRTAB(REG8))                               0880
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0881
*                                                                  0881
@DE00873 TM    EOL(PLEPTR),B'10000000'                             0881
         BNO   @DL00873                                            0881
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0882
*   RETCODER=ZERO;                  /* ZERO RETURN CODE              */
@RT00871 SLR   RETCODER,RETCODER                                   0882
*   RESPECIFY                                                      0883
*     REG5 RSTD;                                                   0883
*   REG5=TESTCC;                    /* PICKUP UP TESTCC              */
         LH    REG5,TESTCC(,REG13)                                 0884
*   GEN(LTR REG5,REG5);             /* SET CONDITION CODE            */
         LTR REG5,REG5
*   RESPECIFY                                                      0886
*     REG5 UNRSTD;                                                 0886
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0887
*   GEN(BR REG14)                                                  0888
*   EXIT;                           /* RETURN TO USER                */
         BR REG14
*                                                                  0889
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTCB/NIB- ROUTINE TESTS FIELDS IN AN NIB. INPUT IS AN       */
*   /* ADDRESS IN REGISTER 1 THAT POINTS TO A LIST OF ADDRESSES THAT */
*   /* POINT TO A HEADER AND ELEMENTS THAT REPRESENT TESTCB KEYWORDS */
*   /* SPECIFIED BY THE USER. THE HEADER HAS A POINTER TO THE NIB TO */
*   /* BE DISPLAYED IN THE TESTBLAD FIELD. TESTBLAD MUST POINT TO AN */
*   /* NIB OR AN ERROR IS RETURNED TO THE USER. FIELDS ARE TESTED    */
*   /* UNTIL ALL ELEMENTS ARE PROCESSED OR AN ERROR OCCURS. THE      */
*   /* CONDITION CODE IS SET JUST PRIOR TO EXIT AND IS PRESERVED FOR */
*   /* THE NEXT SEQUENTAL INSTRUCTION AFTER THE TESTCB.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0889
*NIBTEST:                                                          0889
*                                                                  0889
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE USER'S REGISTER'S 2-12 AND SET SECOND BASE. PROLOG CODE  */
*   /* MUST NOT BE ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE  */
*   /* ROUTINE AS EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0889
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
NIBTEST  STM   REG2,REG12,REGSAVE(REG13)                           0889
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0890
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0891
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0891
*   RBLKPTR=TESTBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          0892
*   REG8=ZERO;                      /* SET INDEX REGISTER TO ZERO    */
*                                                                  0893
         SLR   REG8,REG8                                           0893
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0894
*   IF NIBID^=NIBIDD THEN           /* IF NOT POINTING TO NIB        */
         CLI   NIBID(RBLKPTR),X'D0'                                0894
         BE    @RF00894                                            0894
*     DO;                           /* ERROR PROCESSING              */
*       REG0=BLKERR;                /* SET REASON CODE               */
         LA    REG0,4                                              0896
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             0897
*     END;                                                         0898
*   TESTCC=ZERO;                    /* ZERO CONDITION CODE           */
*                                                                  0899
@RF00894 SLR   @09,@09                                             0899
         STH   @09,TESTCC(,REG13)                                  0899
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS KEYWORDS IF ANY                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0900
*   IF EOL=ON THEN                                                 0900
         TM    EOL(PLEPTR),B'10000000'                             0900
         BO    @RT00900                                            0900
*     ;                             /* KEYWORDS SPECIFIED            */
*   ELSE                            /* PROCESS KEYWORDS              */
*     DO UNTIL(EOL=ON);             /* LOOK FOR END OF LIST          */
@DL00902 DS    0H                                                  0903
*       PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP THRU LIST             */
         AL    PLEPTR,@CF00256                                     0903
*       RELEMPTR=PLEMPTR;           /* SET POINTER TO NEW KEYWORD    */
*                                                                  0904
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0904
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWDTAB                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0905
*       REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD      */
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0905
         MH    REG11,@CH00984                                      0905
*       IF REG11>MAXKEYWD THEN      /* RANGE CHECK KEYWORD           */
         CL    REG11,MAXKEYWD                                      0906
         BH    @RT00906                                            0906
*         GO TO INVKEYWD;           /* EXIT WITH ERROR               */
*                                                                  0907
*       /*************************************************************/
*       /*                                                           */
*       /* SET INDEX TO KEYWORD ROUTINE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0908
*       GEN(IC REG8,TNIB(REG11))                                   0908
*       REFS(TNIB);                 /* LOAD ADDRESS OFF KEYWORD    0908
*                                      ROUTINE                       */
*                                                                  0908
         IC REG8,TNIB(REG11)
*       /*************************************************************/
*       /*                                                           */
*       /* EXECUTE KEYWORD ROUTINE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0909
*       GEN(BAL REG10,KWBRTAB(REG8))                               0909
*       FLOWS(KWBRTAB);             /* CALL KEYWORD ROUTINE          */
         BAL REG10,KWBRTAB(REG8)
*     END;                                                         0910
*                                                                  0910
@DE00902 TM    EOL(PLEPTR),B'10000000'                             0910
         BNO   @DL00902                                            0910
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0911
*   RETCODER=ZERO;                  /* SET ZERO RETURN CODE          */
@RT00900 SLR   RETCODER,RETCODER                                   0911
*   RESPECIFY                                                      0912
*     REG5 RSTD;                                                   0912
*   REG5=TESTCC;                    /* PICKUP UP TESTCC              */
         LH    REG5,TESTCC(,REG13)                                 0913
*   GEN(LTR REG5,REG5);             /* SET CONDITION CODE            */
         LTR REG5,REG5
*   RESPECIFY                                                      0915
*     REG5 UNRSTD;                                                 0915
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0916
*   GEN(BR REG14)                                                  0917
*   EXIT;                           /* RETURN TO USER                */
         BR REG14
*BLKLNKW:                                                          0918
*                                                                  0918
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESSES STANDALONE BLOCK LENGTH KEYWORDS SAVE USER'S        */
*   /* REGISTER'S 2-12 AND SET SECOND BASE PROLOG CODE MUST NOT BE   */
*   /* ALTERED WITH OUT MODIFING ALL PROLOGS AND DECODE ROUTINE AS   */
*   /* EXECUTE INSTRUCTION STEPS OVER THESE INSTRUCTIONS             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0918
*   STM(REG2,REG12,REGSAVE);        /* STORE USERS REGISTERS         */
BLKLNKW  STM   REG2,REG12,REGSAVE(REG13)                           0918
*   GEN(LA REG12,4095(REG15));      /* SET UP SECOND BASE            */
*                                                                  0919
         LA REG12,4095(REG15)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTERS USED THROUGHOUT MODULE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0920
*   RHDRPTR=PHDRPTR;                /* LOAD POINTER TO HEADER        */
         L     RHDRPTR,PHDRPTR(,PLEPTR)                            0920
*   RBLKPTR=TESTBLAD;               /* LOAD ADDRESS OF USER BLOCK    */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          0921
*   REG8=ZERO;                      /* ZERO INDEX REGISTER           */
*                                                                  0922
         SLR   REG8,REG8                                           0922
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROLOG CODE                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0923
*   SHOWUSE=ZERO;                   /* ZERO SHOW USE                 */
         SLR   @09,@09                                             0923
         STH   @09,SHOWUSE(,REG13)                                 0923
*   TESTCC=EQ;                      /* SET TESTCB TESTCODE EQUAL     */
         STH   @09,TESTCC(,REG13)                                  0924
*   IF EOL=ON THEN                  /* KEWORDS SPECIFIED             */
         TM    EOL(PLEPTR),B'10000000'                             0925
         BO    @RT00925                                            0925
*     GO TO FUNCERR;                /* MUST BE REAL ERROR            */
*   DO UNTIL(EOL=ON);               /* PROCESS TO END OF LIST        */
@DL00927 DS    0H                                                  0928
*     PLEPTR=PLEPTR+LENGTH(PARMLIST);/* STEP TO NEXT ADDRESS         */
         AL    PLEPTR,@CF00256                                     0928
*     RELEMPTR=PLEMPTR;             /* SET POINTER TO NEW KEYWORD    */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           0929
*     RESPECIFY                                                    0930
*       REG6 RESTRICTED;            /*                       @G40AKCM*/
*     REG6=ADDR(IDA019C1)+8190;     /* SET UP TEMP BASE AREG TO    0931
*                                      ADDRESS STORAGE OUTSIDE 2ND 0931
*                                      BASE REG              @G40AKCM*/
         L     REG6,@CA00028                                       0931
         AL    REG6,@CF03362                                       0931
*     GEN(USING IDA019C1+8190,REG6);/* REG6 IS TEMP BASE REG @G40AKCM*/
         USING IDA019C1+8190,REG6
*     IF ELEMKWTC=VSAMACBL THEN     /* LENGTH OF ACB                 */
         CLC   ELEMKWTC(2,RELEMPTR),@CH00102                       0933
         BNE   @RF00933                                            0933
*       RBLKPTR=ADDR(DEFACB);       /* SET DEFAULT BLOCK ADDR        */
         LA    RBLKPTR,DEFACB                                      0934
*     ELSE                          /* NOT ACB                       */
*       IF ELEMKWTC=VSAMRPLL THEN   /* LENGTH OF RPL                 */
         B     @RC00933                                            0935
@RF00933 CLC   ELEMKWTC(2,RELEMPTR),@CH02061                       0935
         BNE   @RF00935                                            0935
*         RBLKPTR=ADDR(DEFRPL);     /* SET DEFAULT BLOCK ADDR        */
         LA    RBLKPTR,DEFRPL                                      0936
*       ELSE                        /* NOT RPL                       */
*         IF ELEMKWTC=VTAMACBL THEN /* LENGTH OF VTAM ACB            */
         B     @RC00935                                            0937
@RF00935 CLC   ELEMKWTC(2,RELEMPTR),@CH02065                       0937
         BNE   @RF00937                                            0937
*           RBLKPTR=ADDR(DEFVTACB); /* SET DEFAULT BLOCK ADDR        */
         LA    RBLKPTR,DEFVTACB                                    0938
*         ELSE                      /* NOT VTAM ACB                  */
*           IF ELEMKWTC=VTAMRPLL THEN/* LENGTH OF VTAM RPL           */
         B     @RC00937                                            0939
@RF00937 CLC   ELEMKWTC(2,RELEMPTR),@CH02067                       0939
         BNE   @RF00939                                            0939
*             RBLKPTR=ADDR(DEFVTRPL);/* SET DEFAULT BLOCK ADDR       */
         LA    RBLKPTR,DEFVTRPL                                    0940
*           ELSE                    /* NOT VTAM RPL                  */
*             IF ELEMKWTC=VTAMNIBL THEN/* LENGTH OF NIB              */
         B     @RC00939                                            0941
@RF00939 CLC   ELEMKWTC(2,RELEMPTR),@CH02071                       0941
         BNE   @RF00941                                            0941
*               RBLKPTR=ADDR(DEFNIB);/* SET DEFAULT BLOCK ADDR       */
         LA    RBLKPTR,DEFNIB                                      0942
*             ELSE                  /* NOT NIB                       */
*               IF ELEMKWTC=VSAMEXLL THEN/* LENGTH OF EXLST          */
         B     @RC00941                                            0943
@RF00941 CLC   ELEMKWTC(2,RELEMPTR),@CH02063                       0943
         BNE   @RF00943                                            0943
*                 RBLKPTR=ADDR(DEFEXLST);/* SET DEFAULT BLOCK ADDR   */
         LA    RBLKPTR,DEFEXLST                                    0944
*               ELSE                /* NOT VSAM EXLST                */
*                 IF ELEMKWTC=VTAMEXLL THEN/* LENGTH OF VTAM EXLST   */
         B     @RC00943                                            0945
@RF00943 CLC   ELEMKWTC(2,RELEMPTR),@CH02069                       0945
         BNE   @RF00945                                            0945
*                   RBLKPTR=ADDR(DEFVTEXL);/* SET DEFAULT BLOCK ADDR */
         LA    RBLKPTR,DEFVTEXL                                    0946
*                 ELSE              /* ERROR                         */
*                   GO TO INVKEYWD; /* PROCESS INVALID KEYWORD       */
*     GEN(DROP REG6);               /* DROP TEMP BASE REG    @G40AKCM*/
@RC00943 DS    0H                                                  0948
@RC00941 DS    0H                                                  0948
@RC00939 DS    0H                                                  0948
@RC00937 DS    0H                                                  0948
@RC00935 DS    0H                                                  0948
@RC00933 DS    0H                                                  0948
         DROP REG6
*     RESPECIFY                                                    0949
*       REG6 UNRESTRICTED;          /*                       @G40AKCM*/
*                                                                  0949
*     /***************************************************************/
*     /*                                                             */
*     /* SET INDEX TO KEYWDTAB                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0950
*     REG11=ELEMKWTC*LENGTH(TYPECD);/* SET POINTER TO KEYWORD        */
*                                                                  0950
         LH    REG11,ELEMKWTC(,RELEMPTR)                           0950
         MH    REG11,@CH00984                                      0950
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS KEYWORD                                             */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0951
*     IF(FTCBTC&VTAMCORR)=SHOWCB THEN/* SHOWCB                       */
         LH    @09,FTCBTC(,RHDRPTR)                                0951
         N     @09,@CF00034                                        0951
         C     @09,@CF00102                                        0951
         BNE   @RF00951                                            0951
*       GEN FLOWS(DSPFIELD)(BAL REG10,DSPFIELD);/* CALL DISP FLD     */
         BAL REG10,DSPFIELD
*     ELSE                          /* MUST BE TESTCB                */
*       GEN FLOWS(TSTFIELD)(BAL REG10,TSTFIELD);/* TEST FIELD        */
         B     @RC00951                                            0953
@RF00951 DS    0H                                                  0953
         BAL REG10,TSTFIELD
*   END;                                                           0954
@RC00951 DS    0H                                                  0954
@DE00927 TM    EOL(PLEPTR),B'10000000'                             0954
         BNO   @DL00927                                            0954
*   IF(FTCBTC&VTAMCORR)=TESTCB THEN /* SHOWCB                        */
         LH    @09,FTCBTC(,RHDRPTR)                                0955
         N     @09,@CF00034                                        0955
         C     @09,@CF00256                                        0955
         BNE   @RF00955                                            0955
*     DO;                           /* EXIT FOR TESTCB               */
*       RESPECIFY                                                  0957
*         REG5 RSTD;                                               0957
*       REG5=TESTCC;                /* PICKUP UP TESTCC              */
         LH    REG5,TESTCC(,REG13)                                 0958
*       RETCODER=ZERO;              /* ZERO RETURN CODE REGISTER     */
         SLR   RETCODER,RETCODER                                   0959
*       GEN(LTR REG5,REG5);         /* SET CONDITION CODE            */
         LTR REG5,REG5
*       RESPECIFY                                                  0961
*         REG5 UNRSTD;                                             0961
*       LM(REG2,REG12,REGSAVE);     /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0962
*       GEN(BR REG14);                                             0963
         BR REG14
*     END;                                                         0964
*   RETCODER=ZERO;                  /* ZERO RETURN CODE REGISTER     */
@RF00955 SLR   RETCODER,RETCODER                                   0965
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           0966
*   GEN(BR REG14)                                                  0967
*   EXIT;                           /* RETURN TO USER                */
         BR REG14
*                                                                  0968
*   /*****************************************************************/
*   /*                                                               */
*   /* ERROR EXITS                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0968
*INVKEYWD:                                                         0968
*                                                                  0968
*   /*****************************************************************/
*   /*                                                               */
*   /* INVKEYWD - INVALID KEYWORD EXIT. BRANCH TO THIS ROUTINE OCCURS*/
*   /* WHEN AN INVALID KEYWORD IS SPECIIFIED. ERROR CODE IS SET AND  */
*   /* RETURN TO THE USER IS VIA EXITBAD.                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0968
*   REG0=KEYWDINV;                  /* SET REASON CODE               */
INVKEYWD LA    REG0,3                                              0968
*   GO TO EXITBAD;                  /* EXIT WITH ERROR               */
*                                                                  0969
         B     EXITBAD                                             0969
*   /*****************************************************************/
*   /*                                                               */
*   /* FUNCERR- INVALID BLOCK OR REQUEST TYPE. BRANCH TO THIS ROUTINE*/
*   /* OCCURS FROM THE DECODE ROUTINE IF AN INVALID FUNCTION REQUEST */
*   /* OR BLOCK TYPE IS SPECIFIED BY USER. ERROR CODES ARE SET AND   */
*   /* CONTROL IS RETURNED TO THE USER VIA EXITBAD.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0970
*FUNCERRR:                          /* BRANCH POINT FOR PROCTAB      */
*                                                                  0970
*   /*****************************************************************/
*   /*                                                               */
*   /* SETS ERROR CODE FOR DECODE ROUTINE. RETURNS CONTROL TO CALLER */
*   /* VIA EXITBAD                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0970
*   GEN(  DC 9H'00');               /* SPACE FOR PROLOG BYPASS CODE  */
FUNCERRR   DC 9H'00'
*FUNCERR:                           /* BRANCH POINT FOR ERROR      0971
*                                      PROCESSING                    */
*   RESPECIFY                                                      0971
*     REG5 RSTD;                                                   0971
FUNCERR  DS    0H                                                  0972
*   REG5=FTCBTC&VTAMCORR;           /* GET FUNCTION CODE             */
         LH    REG5,FTCBTC(,RHDRPTR)                               0972
         N     REG5,@CF00034                                       0972
*   IF REG5^=GENCB                  /* GENCB                         */
*       &REG5^=MODCB                /* MODCB                         */
*       &REG5^=SHOWCB               /* SHOWCB                        */
*       &REG5^=TESTCB THEN          /* TESTCB                        */
         LA    @09,1                                               0973
         CR    REG5,@09                                            0973
         BE    @RF00973                                            0973
         C     REG5,@CF00112                                       0973
         BE    @RF00973                                            0973
         C     REG5,@CF00102                                       0973
         BE    @RF00973                                            0973
         C     REG5,@CF00256                                       0973
         BE    @RF00973                                            0973
*     REG0=FUNBLKER;                /* SET FUNCTION ERROR            */
         LR    REG0,@09                                            0974
*   ELSE                            /* BLKERR                        */
*     REG0=BLKBTCER;                /* NO BLOCK SPECIFIED            */
         B     @RC00973                                            0975
@RF00973 LA    REG0,2                                              0975
*   GO TO EXITBAD;                                                 0976
         B     EXITBAD                                             0976
*   RESPECIFY                                                      0977
*     REG5 UNRSTD;                                                 0977
*                                                                  0978
*   /*****************************************************************/
*   /*                                                               */
*   /* EXITBAD- ERROR EXIT ROUTINE PROVIDES EXIT CODE FOR ERROR      */
*   /* CONDITIONS. ISSUES FREEMAIN TO FREE GOTTON STORAGE. FOR TESTCB*/
*   /* LOADS REGISTER 14 WITH ERROR ADDRESS IF ERET KEYWORD WAS      */
*   /* SPECIFIED.                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0978
*EXITBAD:                                                          0978
*   RESPECIFY                                                      0978
*    (REG5,                                                        0978
*     REG6) RSTD;                                                  0978
EXITBAD  DS    0H                                                  0979
*   REG5=FTCBTC&VTAMCORR;           /* PICK UP FUNCTION CODE         */
         LH    REG5,FTCBTC(,RHDRPTR)                               0979
         N     REG5,@CF00034                                       0979
*   IF REG5=GENCB&                  /* GENCB                         */
*       GENUSA=ZERO                 /* USER DID NOT SUPPLY AREA      */
*       &RBLKPTR^=ZERO THEN         /* AND I GOT ONE                 */
         C     REG5,@CF00081                                       0980
         BNE   @RF00980                                            0980
         SLR   @09,@09                                             0980
         C     @09,GENUSA(,RHDRPTR)                                0980
         BNE   @RF00980                                            0980
         CR    RBLKPTR,@09                                         0980
         BE    @RF00980                                            0980
*     DO;                           /* FREE IT                       */
*       REG5=REG0;                  /* SAVE REASON CODE              */
         LR    REG5,REG0                                           0982
*       REG0=ACBLENG*GENCOP;        /* SET LENGTH/SUBPOOL ZERO       */
         LH    REG0,ACBLENG(,RBLKPTR)                              0983
         MH    REG0,GENCOP(,RHDRPTR)                               0983
*       REG6=REG1;                  /* SAVE REG1                     */
         LR    REG6,REG1                                           0984
*       REG1=RBLKPTR;               /* SET FREEMAIN ADDRESS          */
         LR    REG1,RBLKPTR                                        0985
*       RESPECIFY                                                  0986
*         REG7 RSTD;                                               0986
*       REG7=REG15;                 /* SAVE BASE REGISTER            */
         LR    REG7,REG15                                          0987
*       GEN(FREEMAIN R,LV=(0),A=(1));/* FREEMAIN                     */
         FREEMAIN R,LV=(0),A=(1)
*       REG15=REG7;                 /* RESTORE BASE REGISTER         */
         LR    REG15,REG7                                          0989
*       RESPECIFY                                                  0990
*         REG7 UNRSTD;                                             0990
*       REG0=REG5;                  /* REASON TO REGISTER 0          */
         LR    REG0,REG5                                           0991
*       REG1=REG6;                  /* RETURN PARM LIST ADDRESS      */
         LR    REG1,REG6                                           0992
*     END;                                                         0993
*   ELSE                            /* NOT GENCB/FREEMAIN            */
*     DO;                           /* NOT GENCB                     */
         B     @RC00980                                            0994
@RF00980 DS    0H                                                  0995
*       IF REG5=TESTCB THEN         /* TESTCB                        */
         C     REG5,@CF00256                                       0995
         BNE   @RF00995                                            0995
*         IF TESTERET^=ZERO THEN    /* ERROR RETURN SPECIFIED        */
         L     @09,TESTERET(,RHDRPTR)                              0996
         LTR   @09,@09                                             0996
         BZ    @RF00996                                            0996
*           RETURNR=TESTERET;       /* SET RETURN ADDRESS            */
         LR    RETURNR,@09                                         0997
*         ELSE                                                     0998
*           ;                       /* ZERO RETURN ADDRESS           */
@RF00996 DS    0H                                                  0999
*       ELSE                        /* NOT TESTCB                    */
*         IF REG5=MODCB THEN        /* MODCB SPECIFIED               */
         B     @RC00995                                            0999
@RF00995 C     REG5,@CF00112                                       0999
         BNE   @RF00999                                            0999
*           IF GENBTC=RPL THEN      /* RPL                           */
         CLI   GENBTC(RHDRPTR),192                                 1000
         BNE   @RF01000                                            1000
*             IF REG0^=RPLISACT     /* ERROR IS ACTIVE               */
*                 &REG0^=BLKERR THEN/* AND POINTING TO AN RPL        */
         C     REG0,@CF00529                                       1001
         BE    @RF01001                                            1001
         C     REG0,@CF00256                                       1001
         BE    @RF01001                                            1001
*               RPLACTIV=ZERO;      /* RESET ACTIVE BYTE             */
         MVI   RPLACTIV(RBLKPTR),X'00'                             1002
*     END;                                                         1003
@RF01001 DS    0H                                                  1003
@RF01000 DS    0H                                                  1003
@RF00999 DS    0H                                                  1003
@RC00995 DS    0H                                                  1004
*   RETCODER=NOTOKRET;              /* SET BAD RETURN CODE           */
@RC00980 LA    RETCODER,4                                          1004
*   LM(REG2,REG12,REGSAVE);         /* RELOAD USERS REGISTERS        */
         LM    REG2,REG12,REGSAVE(REG13)                           1005
*   GEN(BR REG14)                                                  1006
*   EXIT;                           /* RETURN TO USER                */
         BR REG14
*   RESPECIFY                                                      1007
*    (REG5,                                                        1007
*     REG6) UNRSTD;                                                1007
*GM19C1:                                                           1008
*                                                                  1008
*   /*****************************************************************/
*   /*                                                               */
*   /* GETMAIN ROUTINE DOES GETMAIN FOR STORAGE IF USER DIS NOT      */
*   /* SUPPLY AREA. OTHERWISE INSURES USER AREA IS LONG ENOUGH AND ON*/
*   /* FULLWORD BOUNDRY. LENGTH OF 1 BLOCK IS PASSED IN REG5 AS      */
*   /* INPUT. OUTPUT IS RBLKPTR LOADED WITH THE ADDRESS OF THE GOTTEN*/
*   /* STORAGE. GMLEN FIELD IS SET FOR USE AT EXIT TIME.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1008
*   RESPECIFY                                                      1008
*    (REG5,                                                        1008
*     REG7,                                                        1008
*     REG9) RSTD;                   /*                       @G40AKCM*/
GM19C1   DS    0H                                                  1009
*   GEN REFS(GENCOP)(MH REG5,GENCOP(,RHDRPTR));/* FIND TOTAL LENGTH
*                                      REQUIRED                      */
         MH REG5,GENCOP(,RHDRPTR)
*   GMLEN=REG5;                     /* SET LENGTH FOR GETMAIN        */
         ST    REG5,GMLEN(,REG13)                                  1010
*   IF GENUSA=ZERO THEN             /* USER SUPPLY AREA              */
*                                                                  1011
         L     @06,GENUSA(,RHDRPTR)                                1011
         LTR   @06,@06                                             1011
         BNZ   @RF01011                                            1011
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN STORAGE FOR USER                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1012
*     DO;                           /* NO GET HIM ONE                */
*       GMAPTR=ADDR(GMANS);         /* SET ANSWER AREA ADDRESS       */
         LA    @06,GMANS(,REG13)                                   1013
         ST    @06,GMAPTR(,REG13)                                  1013
*       GMMODE=ECMODE;              /* SET ECMODE                    */
         MVI   GMMODE(REG13),X'20'                                 1014
*       GMSP=SUBPOOL0;              /* SET SUBPOOL 0                 */
         MVI   GMSP(REG13),X'00'                                   1015
*       RESPECIFY                                                  1016
*        (REG6) RSTD;                                              1016
*       REG5=REG1;                  /* SAVE PARM LIST ADDRESS        */
         LR    REG5,REG1                                           1017
*       REG1=ADDR(GMPL);            /* POINT TO LIST                 */
         LA    REG1,GMPL(,REG13)                                   1018
*       REG6=REG15;                 /* SAVE BASE REG                 */
         LR    REG6,REG15                                          1019
*       GEN(GETMAIN MF=(E,(1)));    /* GET VIRTUAL STORAGE           */
         GETMAIN MF=(E,(1))
*       REG1=REG15;                 /* SAVE RETURN CODE              */
         LR    REG1,REG15                                          1021
*       REG15=REG6;                 /* RESTORE BASE REG              */
*                                                                  1022
         LR    REG15,REG6                                          1022
*       /*************************************************************/
*       /*                                                           */
*       /* GETMAIN OK?                                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1023
*       IF REG1^=OK THEN            /* GETMAIN OK                    */
         LTR   REG1,REG1                                           1023
         BZ    @RF01023                                            1023
*         DO;                       /* ERROR PROCESS                 */
*           REG0=NOSTOR;            /* SET ERROR CODE                */
         LA    REG0,8                                              1025
*           GO TO EXITBAD;          /* EXIT WITH ERROR               */
         B     EXITBAD                                             1026
*         END;                                                     1027
*       RBLKPTR=GMANS;              /* LOAD ADDRESS OF GOTTEN STORAGE*/
@RF01023 L     RBLKPTR,GMANS(,REG13)                               1028
*       REG1=REG5;                  /* RELOAD PARM LIST ADDR         */
         LR    REG1,REG5                                           1029
*       RESPECIFY                                                  1030
*        (REG6) UNRSTD;                                            1030
*     END;                                                         1031
*                                                                  1031
*   /*****************************************************************/
*   /*                                                               */
*   /* INSURE USER AREA LONG ENOUGTH AND ON FULL WORD BOUNDRY        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1032
*   ELSE                            /* USER SUPPLIED ONE             */
*     DO;                           /* CHECK IT                      */
         B     @RC01011                                            1032
@RF01011 DS    0H                                                  1033
*       IF REG5>GENUSL THEN         /* IS IT LONG ENOUGH             */
         CH    REG5,GENUSL(,RHDRPTR)                               1033
         BNH   @RF01033                                            1033
*         DO;                       /* NO, SET ERROR                 */
*           REG0=NTENSTOR;          /* SET ERROR CODE                */
         LA    REG0,9                                              1035
*           GO TO EXITBAD;          /* EXIT WITH ERROR               */
         B     EXITBAD                                             1036
*         END;                                                     1037
*       IF(RBLKPTR&FWRDMASK)^=ZERO THEN/* ON FULLWORD BDY            */
@RF01033 LR    @06,RBLKPTR                                         1038
         N     @06,@CF00102                                        1038
         LTR   @06,@06                                             1038
         BZ    @RF01038                                            1038
*         DO;                       /* PROCESS ERROR                 */
*           REG0=NTFWDBDY;          /* SET ERROR CODE                */
         LA    REG0,15                                             1040
*           GO TO EXITBAD;          /* EXIT WITH ERROR               */
         B     EXITBAD                                             1041
*         END;                                                     1042
*     END;                                                         1043
*                                                                  1043
@RF01038 DS    0H                                                  1044
*   /*****************************************************************/
*   /*                                                               */
*   /* SET ADDRESSIBILITY TO DEFAULT CONTROL BLOCKS          @G40AKCM*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1044
*   RESPECIFY                                                      1044
*     REG6 RSTD;                                                   1044
@RC01011 DS    0H                                                  1045
*   REG6=ADDR(IDA019C1)+8190;       /* SET UP TEMP BASE REG  @G40AKCM*/
         L     REG6,@CA00028                                       1045
         AL    REG6,@CF03362                                       1045
*   GEN;                                                           1046
*                                                                  1046
        USING IDA019C1+8190,REG6   USE REG6 AS TEMP BASE REG
        EX  REG0,DEFCBRTN(REG9)    COPY DEFAULT CONTROL BLK
        BR REG10                    RETURN TO CALLER
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING TABLE CONTAINS THE COPY STATEMENTS FOR THE      */
*   /* VARIOUS DEFAULT CONTROL BLOCKS. REG9 SHOULD HAVE THE INDEX    */
*   /* INTO THIS TABLE WHICH SELECTS THE CORRECT STATEMENT TO BE     */
*   /* EXECUTED                                              @G40KSCM*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1047
*DEFCBRTN:                                                         1047
*DVSAMACB:                                                         1047
*   NEWACB=DEFACB;                                                 1047
DEFCBRTN DS    0H                                                  1047
DVSAMACB MVC   NEWACB(76,RBLKPTR),DEFACB                           1047
*DVTAMACB:                                                         1048
*   NEWVTACB=DEFVTACB;                                             1048
DVTAMACB MVC   NEWVTACB(88,RBLKPTR),DEFVTACB                       1048
*DVSAMEXL:                                                         1049
*   NEWEXLST=DEFEXLST;                                             1049
DVSAMEXL MVC   NEWEXLST(40,RBLKPTR),DEFEXLST                       1049
*DVTAMEXL:                                                         1050
*   NEWVTEXL=DEFVTEXL;                                             1050
DVTAMEXL MVC   NEWVTEXL(70,RBLKPTR),DEFVTEXL                       1050
*DVSAMRPL:                                                         1051
*   NEWRPL=DEFRPL;                                                 1051
DVSAMRPL MVC   NEWRPL(76,RBLKPTR),DEFRPL                           1051
*DVTAMRPL:                                                         1052
*   NEWVTRPL=DEFVTRPL;                                             1052
DVTAMRPL MVC   NEWVTRPL(112,RBLKPTR),DEFVTRPL                      1052
*DVTAMNIB:                                                         1053
*   NEWNIB=DEFNIB;                                                 1053
DVTAMNIB MVC   NEWNIB(64,RBLKPTR),DEFNIB                           1053
*DVSNOP:                                                           1054
*   GEN(NOP 0);                                                    1054
*                                                                  1054
DVSNOP   NOP 0
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF COPY ROUTINE                                   @G40KSCM*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1055
*   GEN(DROP REG6);                                                1055
         DROP REG6
*   RESPECIFY                                                      1056
*    (REG5,                                                        1056
*     REG7,                                                        1056
*     REG6,                                                        1056
*     REG9) UNRSTD;                 /*                       @G40KSCM*/
*                                                                  1057
*   /*****************************************************************/
*   /*                                                               */
*   /* BRANCH TABLE FOR KEYWORD PROCESSING                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1057
*KWBRTAB:                                                          1057
*KWTYPERR:                                                         1057
*   BC(15,INVKEYWD);                /* INVALID KEYWORD               */
KWBRTAB  DS    0H                                                  1057
KWTYPERR BC    15,INVKEYWD                                         1057
*KWTYP01:                                                          1058
*   BC(15,TSTAMDSB);                /* KEYWORD TYPE 1                */
KWTYP01  BC    15,TSTAMDSB                                         1058
*KWTYP02:                                                          1059
*   BC(15,DSPAMDSB);                /* KEYWORD TYPE 2                */
KWTYP02  BC    15,DSPAMDSB                                         1059
*KWTYP03:                                                          1060
*   BC(15,TSTAMDFD);                /* KEYWORD TYPE 3                */
KWTYP03  BC    15,TSTAMDFD                                         1060
*KWTYP04:                                                          1061
*   BC(15,DSPFIELD);                /* KEYWORD TYPE 4                */
KWTYP04  BC    15,DSPFIELD                                         1061
*KWTYP05:                                                          1062
*   BC(15,TSTFIELD);                /* KEYWORD TYPE 5                */
KWTYP05  BC    15,TSTFIELD                                         1062
*KWTYP06:                                                          1063
*   BC(15,MODVTWRD);                /* KEYWORD TYPE 6                */
KWTYP06  BC    15,MODVTWRD                                         1063
*KWTYP07:                                                          1064
*   BC(15,DSPBUFDF);                /* KEYWORD TYPE 7                */
KWTYP07  BC    15,DSPBUFDF                                         1064
*KWTYP08:                                                          1065
*   BC(15,TSTBUFDF);                /* KEYWORD TYPE 8                */
KWTYP08  BC    15,TSTBUFDF                                         1065
*KWTYP09:                                                          1066
*   BC(15,DISPHRBA);                /* KEYWORD TYPE 9                */
KWTYP09  BC    15,DISPHRBA                                         1066
*KWTYP0A:                                                          1067
*   BC(15,TESTHRBA);                /* KEYWORD TYPE A                */
KWTYP0A  BC    15,TESTHRBA                                         1067
*KWTYP0B:                                                          1068
*   BC(15,MODBITST);                /* KEYWORD TYPE B                */
KWTYP0B  BC    15,MODBITST                                         1068
*KWTYP0C:                                                          1069
*   BC(15,MODVTHWD);                /* KEYWORD TYPE C                */
KWTYP0C  BC    15,MODVTHWD                                         1069
*KWTYP0D:                                                          1070
*   BC(15,MODECBFD);                /* KEYWORD TYPE D                */
KWTYP0D  BC    15,MODECBFD                                         1070
*KWTYP0E:                                                          1071
*   BC(15,TSTBITST);                /* KEYWORD TYPE E                */
KWTYP0E  BC    15,TSTBITST                                         1071
*KWTYP0F:                                                          1072
*   BC(15,MODVTBYT);                /* KEYWORD TYPE F                */
KWTYP0F  BC    15,MODVTBYT                                         1072
*KWTYP10:                                                          1073
*   BC(15,DSPPLHFD);                /* KEYWORD TYPE 10               */
KWTYP10  BC    15,DSPPLHFD                                         1073
*KWTYP12:                                                          1074
*   BC(15,TSTAMBLB);                /* KEYWORD TYPE 12               */
KWTYP12  BC    15,TSTAMBLB                                         1074
*KWTYP13:                                                          1075
*   BC(15,DSPEXLFD);                /* KEYWORD TYPE 13               */
KWTYP13  BC    15,DSPEXLFD                                         1075
*KWTYP14:                                                          1076
*   BC(15,TSTEXLFD);                /* KEYWORD TYPE 14               */
KWTYP14  BC    15,TSTEXLFD                                         1076
*KWTYP15:                                                          1077
*   BC(15,MODEXITF);                /* KEYWORD TYPE 15               */
KWTYP15  BC    15,MODEXITF                                         1077
*KWTYP16:                                                          1078
*   BC(15,TSTIOBIT);                /* KEYWORD TYPE 16               */
KWTYP16  BC    15,TSTIOBIT                                         1078
*KWTYP17:                                                          1079
*   BC(15,GENAMTYP);                /* KEYWORD TYPE 17               */
KWTYP17  BC    15,GENAMTYP                                         1079
*KWTYP18:                                                          1080
*   BC(15,DSPVTFLD);                /* KEYWORD TYPE 18               */
KWTYP18  BC    15,DSPVTFLD                                         1080
*KWTYP19:                                                          1081
*   BC(15,TSTVTFLD);                /* KEYWORD TYPE 19               */
KWTYP19  BC    15,TSTVTFLD                                         1081
*KWTYP20:                                                          1082
*   BC(15,TSTVTBIT);                /* KEYWORD TYPE 20               */
KWTYP20  BC    15,TSTVTBIT                                         1082
*KWTYP21:                                                          1083
*   BC(15,DSPBSPHF);                /* KEYWORD TYPE 21               */
KWTYP21  BC    15,DSPBSPHF                                         1083
*KWTYP22:                                                          1084
*   BC(15,TSTBSPHF);                /* KEYWORD TYPE 22               */
KWTYP22  BC    15,TSTBSPHF                                         1084
*KWTYP23:                                                          1085
*   BC(15,MODVTBIT);                /* KEYWORD TYPE 23               */
KWTYP23  BC    15,MODVTBIT                                         1085
*KWTYP24:                                                          1086
*   BC(15,TSTPLHFD);                /* KEYWORD TYPE 24               */
KWTYP24  BC    15,TSTPLHFD                                         1086
*KWTYP26:                                                          1087
*   BC(15,TSTOPTBT);                /* KEYWORD TYPE 26               */
KWTYP26  BC    15,TSTOPTBT                                         1087
*KWTYP28:                                                          1088
*   BC(15,TSTPROCB);                /* KEYWORD TYPE 28               */
KWTYP28  BC    15,TSTPROCB                                         1088
*KWTYP30:                                                          1089
*   BC(15,DSPVTEXL);                /* KEYWORD TYPE 30               */
KWTYP30  BC    15,DSPVTEXL                                         1089
*KWTYP31:                                                          1090
*   BC(15,TSTVTEXL);                /* KEYWORD TYPE 31               */
KWTYP31  BC    15,TSTVTEXL                                         1090
*KWTYP38:                                                          1091
*   BC(15,DSPDDNM);                 /* KEYWORD TYPE 38               */
KWTYP38  BC    15,DSPDDNM                                          1091
*KWTYP39:                                                          1092
*   BC(15,TSTDDNM);                 /* KEYWORD TYPE 39               */
KWTYP39  BC    15,TSTDDNM                                          1092
*KWTYP3A:                                                          1093
*   BC(15,DSPRKPF);                 /* KEYWORD TYPE 3A               */
KWTYP3A  BC    15,DSPRKPF                                          1093
*KWTYP3B:                                                          1094
*   BC(15,TSTRKPF);                 /* KEYWORD TYPE 3B               */
KWTYP3B  BC    15,TSTRKPF                                          1094
*MACBKWTB:                                                         1095
*                                                                  1095
*   /*****************************************************************/
*   /*                                                               */
*   /* MODACB- HIGH PERFORMANCE KEYWORDS THESE INSTRUCTIONS ARE NOT  */
*   /* INSTRUCTION SEQUENCES. THESE INSTRUCTIONS ARE EXECUTE TARGETS */
*   /* AND MUST NEVER CAUSE MULTIPLE ASSEMBLER STATEMENTS TO BE      */
*   /* GENERATED THIS TABLE HAS ONLY 1 INSTRUCTION TO BE EXECUTED FOR*/
*   /* EACH KEYWORD SPECIFIED FOR MODCB/GENCB OF AN ACB              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1095
*MAINVKW:                                                          1095
*   BC(15,INVKEYWD);                /* ERROR BRANCH                  */
MACBKWTB DS    0H                                                  1095
MAINVKW  BC    15,INVKEYWD                                         1095
*MABITSTR:                                                         1096
*   GEN(BAL REG10,MODBITST)                                        1096
*   FLOWS(MODBITST);                /* BIT STRING                    */
MABITSTR BAL REG10,MODBITST
*MAVTWORD:                                                         1097
*   GEN(BAL REG10,MODVTWRD)                                        1097
*   FLOWS(MODVTWRD);                /* VTAM FWORD                    */
MAVTWORD BAL REG10,MODVTWRD
*MAVTHWRD:                                                         1098
*   GEN(BAL REG10,MODVTHWD)                                        1098
*   FLOWS(MODVTHWD);                /* VTAM HMORD                    */
MAVTHWRD BAL REG10,MODVTHWD
*MAVTCHAR:                                                         1099
*   GEN(BAL REG10,MODVTBYT)                                        1099
*   FLOWS(MODVTBYT);                /* VTAM CHAR                     */
MAVTCHAR BAL REG10,MODVTBYT
*MABUFND:                                                          1100
*   ACBBUFND=USERHWRD;              /* SET BUFND TO USER VALUE       */
MABUFND  MVC   ACBBUFND(2,RBLKPTR),USERHWRD+4(RELEMPTR)            1100
*MABUFNI:                                                          1101
*   ACBBUFNI=USERHWRD;              /* SET BUFNI TO USER VALUE       */
MABUFNI  MVC   ACBBUFNI(2,RBLKPTR),USERHWRD+4(RELEMPTR)            1101
*MABUFSP:                                                          1102
*   ACBBUFSP=USERWORD;              /* SET BUFSP TO USER VALUE       */
MABUFSP  MVC   ACBBUFSP(4,RBLKPTR),USERWORD+4(RELEMPTR)            1102
*MADDNAME:                                                         1103
*   ACBDDNM=USERDWRD;               /* SET DDNAME TO USER NAME       */
MADDNAME MVC   ACBDDNM(8,RBLKPTR),USERDWRD+4(RELEMPTR)             1103
*MAEXLST:                                                          1104
*   ACBUEL=USERWORD;                /* SET EXLST ADDRESS TO USER   1104
*                                      VALUE                         */
MAEXLST  MVC   ACBUEL(4,RBLKPTR),USERWORD+4(RELEMPTR)              1104
*MAMAREA:                                                          1105
*   ACBMSGAR=USERWORD;              /* SET MSG AREA TO USER VALUE    */
MAMAREA  MVC   ACBMSGAR(4,RBLKPTR),USERWORD+4(RELEMPTR)            1105
*MAMLEN:                                                           1106
*   ACBMSGLN=USERHWRD;              /* SET MSG AREA LENGTH           */
MAMLEN   MVC   ACBMSGLN(2,RBLKPTR),USERHWRD+4(RELEMPTR)            1106
*MAPASSWD:                                                         1107
*   ACBPASSW=USERWORD;              /* SET PASSWORD ADDRESS TO USER
*                                      VALUE                         */
MAPASSWD MVC   ACBPASSW(4,RBLKPTR),USERWORD+4(RELEMPTR)            1107
*MASTRNO:                                                          1108
*   GEN(MVC ACBSTRNO(1,RBLKPTR),USERCHAR+4(RELEMPTR))              1108
*   SETS(ACBSTRNO) REFS(USERCHAR);  /* SET STRNO TO USER VALUE       */
MASTRNO  MVC ACBSTRNO(1,RBLKPTR),USERCHAR+4(RELEMPTR)
*MABSTRNO:                                                         1109
*   GEN(MVC ACBBSTNO(1,RBLKPTR),USERCHAR+4(RELEMPTR))              1109
*   SETS(ACBBSTNO) REFS(USERCHAR);  /* SET BSTRNO TO USER VALUE      */
MABSTRNO MVC ACBBSTNO(1,RBLKPTR),USERCHAR+4(RELEMPTR)
*MAUSERPT:                                                         1110
*   ACBUAPTR=USERWORD;              /* SET USER PTR TO USER VALUE    */
MAUSERPT MVC   ACBUAPTR(4,RBLKPTR),USERWORD+4(RELEMPTR)            1110
*MAJFCB:                                                           1111
*   ACBUJFCB=USERWORD;              /* SET POINTER TO JFCB TO USER 1111
*                                      VALUE                         */
MAJFCB   MVC   ACBUJFCB(4,RBLKPTR),USERWORD+4(RELEMPTR)            1111
*MAAM:                                                             1112
*   GEN(BAL REG10,GENAMTYP)                                        1112
*   FLOWS(GENAMTYP);                /* AM                            */
MAAM     BAL REG10,GENAMTYP
*MRPLKWTB:                                                         1113
*                                                                  1113
*   /*****************************************************************/
*   /*                                                               */
*   /* MODRPL-HIGH PERFORMANCE KEYWORDS THESE INSTRUCTIONS ARE NOT   */
*   /* INSTRUCTION SEQUENCES. THESE INSTRUCTIONS ARE EXECUTE TARGETS */
*   /* AND MUST NEVER CAUSE MULTIPLE ASSEMBLER STATEMENTS TO BE      */
*   /* GENERATED THIS TABLE HAS ONLY 1 INSTRUCTION TO BE EXECUTED FOR*/
*   /* EACH KEYWORD SPECIFIED FOR MODCB/GENCB OF AN ACB              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1113
*MRINVKW:                                                          1113
*   BC(15,INVKEYWD);                /* ERROR BRANCH                  */
MRPLKWTB DS    0H                                                  1113
MRINVKW  BC    15,INVKEYWD                                         1113
*MRBITSTR:                                                         1114
*   GEN FLOWS(MODBITST)(BAL REG10,MODBITST);/* BIT STRING            */
MRBITSTR BAL REG10,MODBITST
*MRVTBITS:                                                         1115
*   GEN FLOWS(MODVTBIT)(BAL REG10,MODVTBIT);/* VTAM BIT STRING       */
MRVTBITS BAL REG10,MODVTBIT
*MRVTWORD:                                                         1116
*   GEN FLOWS(MODVTWRD)(BAL REG10,MODVTWRD);/* VTAM FWORD            */
MRVTWORD BAL REG10,MODVTWRD
*MRVTHWRD:                                                         1117
*   GEN FLOWS(MODVTHWD)(BAL REG10,MODVTHWD);/* VTAM HMORD            */
MRVTHWRD BAL REG10,MODVTHWD
*MRVTCHAR:                                                         1118
*   GEN FLOWS(MODVTBYT)(BAL REG10,MODVTBYT);/* VTAM CHAR             */
MRVTCHAR BAL REG10,MODVTBYT
*MRACB:                                                            1119
*   RPLDACB=USERWORD;               /* SET POINTER TO USER VALUE     */
MRACB    MVC   RPLDACB(4,RBLKPTR),USERWORD+4(RELEMPTR)             1119
*MRAREA:                                                           1120
*   RPLAREA=USERWORD;               /* SET POINTER TO USER VALUE     */
MRAREA   MVC   RPLAREA(4,RBLKPTR),USERWORD+4(RELEMPTR)             1120
*MRAREALN:                                                         1121
*   RPLBUFL=USERWORD;               /* SET BUFFER LENGTH TO USER   1121
*                                      VALUE                         */
MRAREALN MVC   RPLBUFL(4,RBLKPTR),USERWORD+4(RELEMPTR)             1121
*MRARG:                                                            1122
*   GEN(BAL REG10,MODARG);          /* SET POINTER TO USER ARGUMENT  */
MRARG    BAL REG10,MODARG
*MRNIB:                                                            1123
*   GEN(BAL REG10,MODNIB);          /* SET POINTER TO NIB            */
MRNIB    BAL REG10,MODNIB
*MRECB:                                                            1124
*   GEN FLOWS(MODECBFD)(BAL REG10,MODECBFD);/* SET POINTER TO USER 1124
*                                      ECB                           */
MRECB    BAL REG10,MODECBFD
*MRKEYLN:                                                          1125
*   RPLKEYL=USERHWRD;               /* SET KEYLENGTH TO USER VALUE   */
MRKEYLN  MVC   RPLKEYL(2,RBLKPTR),USERHWRD+4(RELEMPTR)             1125
*MRMSGARE:                                                         1126
*   RPLERMSA=USERWORD;              /* SET POINTER TO USER MSG AREA  */
MRMSGARE MVC   RPLERMSA(4,RBLKPTR),USERWORD+4(RELEMPTR)            1126
*MRMSGLEN:                                                         1127
*   RPLEMLEN=USERHWRD;              /* SET MSG AREA LENGTH TO USER 1127
*                                      VALUE                         */
MRMSGLEN MVC   RPLEMLEN(2,RBLKPTR),USERHWRD+4(RELEMPTR)            1127
*MRRPLCHA:                                                         1128
*   RPLCHAIN=USERWORD;              /* SET CHAIN FIELD               */
MRRPLCHA MVC   RPLCHAIN(4,RBLKPTR),USERWORD+4(RELEMPTR)            1128
*MRRECLEN:                                                         1129
*   RPLRLEN=USERWORD;               /* SET RECORD LENGTH FIELD       */
MRRECLEN MVC   RPLRLEN(4,RBLKPTR),USERWORD+4(RELEMPTR)             1129
*MRTRANSI:                                                         1130
*   RPLSTRID=USERHWRD;              /* SET TRANS ID                  */
MRTRANSI MVC   RPLSTRID(2,RBLKPTR),USERHWRD+4(RELEMPTR)            1130
*MRAM:                                                             1131
*   GEN FLOWS(GENAMTYP)(BAL REG10,GENAMTYP);/* AM                    */
MRAM     BAL REG10,GENAMTYP
*MREXIT:                                                           1132
*   GEN FLOWS(MODEXITF)(BAL REG10,MODEXITF);/* PROCESS EXIT KEYWORD  */
MREXIT   BAL REG10,MODEXITF
*MROPTCD:                                                          1133
*   GEN FLOWS(MODOPTBT)(BAL REG10,MODOPTBT);/* PROCESS OPTCD KEYWORD */
MROPTCD  BAL REG10,MODOPTBT
*MNIBKWTB:                                                         1134
*                                                                  1134
*   /*****************************************************************/
*   /*                                                               */
*   /* MODNIB-HIGH PERFORMANCE KEYWORDS THESE INSTRUCTIONS ARE NOT   */
*   /* INSTRUCTION SEQUENCES. THESE INSTRUCTIONS ARE EXECUTE TARGETS */
*   /* AND MUST NEVER CAUSE MULTIPLE ASSEMBLER STATEMENTS TO BE      */
*   /* GENERATED THIS TABLE HAS ONLY 1 INSTRUCTION TO BE EXECUTED FOR*/
*   /* EACH KEYWORD SPECIFIED FOR MODCB/GENCB OF AN ACB              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1134
*MNINVKW:                                                          1134
*   BC(15,INVKEYWD);                /* ERROR BRANCH                  */
MNIBKWTB DS    0H                                                  1134
MNINVKW  BC    15,INVKEYWD                                         1134
*MNBITSTR:                                                         1135
*   GEN(BAL REG10,MODBITST)                                        1135
*   FLOWS(MODBITST);                /* BIT STRING                    */
MNBITSTR BAL REG10,MODBITST
*MNUSERFI:                                                         1136
*   NIBUSER=USERWORD;               /* SET POINTER TO USER FIELD     */
MNUSERFI MVC   NIBUSER(4,RBLKPTR),USERWORD+4(RELEMPTR)             1136
*MNMODE:                                                           1137
*   NIBMODE=USERDWRD;               /* COPY FILED TO NIB             */
MNMODE   MVC   NIBMODE(8,RBLKPTR),USERDWRD+4(RELEMPTR)             1137
*MNCONDN:                                                          1138
*   NIBCONDN=USERCHAR;              /* COPY CHAR                     */
MNCONDN  MVC   NIBCONDN(1,RBLKPTR),USERCHAR+4(RELEMPTR)            1138
*MNNAME:                                                           1139
*   NIBSYM=USERDWRD;                /* COPY FIELD TO NIB             */
MNNAME   MVC   NIBSYM(8,RBLKPTR),USERDWRD+4(RELEMPTR)              1139
*MNEXLST:                                                          1140
*   NIBEXLST=USERWORD;              /* SET POINTER TO USER VALUE     */
MNEXLST  MVC   NIBEXLST(4,RBLKPTR),USERWORD+4(RELEMPTR)            1140
*MNRESPLI:                                                         1141
*   NIBLIMIT=USERHWRD;              /* SET LIMIT TO USER VALUE       */
MNRESPLI MVC   NIBLIMIT(2,RBLKPTR),USERHWRD+4(RELEMPTR)            1141
*MNPROC:                                                           1142
*   GEN FLOWS(MODPROCB)(BAL REG10,MODPROCB);/* PROCESS PROC KEYWORD  */
MNPROC   BAL REG10,MODPROCB
*MNLOGMOD:                                                         1143
*   NIBLMODE=USERDWRD;              /* SET LOGMODE FIELD             */
MNLOGMOD MVC   NIBLMODE(8,RBLKPTR),USERDWRD+4(RELEMPTR)            1143
*MNBNDAR:                                                          1144
*   NIBNDAR=USERWORD;               /* SET BNDAREA                   */
MNBNDAR  MVC   NIBNDAR(4,RBLKPTR),USERWORD+4(RELEMPTR)             1144
*MEXLBRTB:                                                         1145
*                                                                  1145
*   /*****************************************************************/
*   /*                                                               */
*   /* BRANCH FOR MODCB FOR EXLST                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1145
*   BC(15,INVKEYWD);                /* INVALID KEYWORD               */
MEXLBRTB BC    15,INVKEYWD                                         1145
*MEAM:                                                             1146
*   BC(15,GENAMTYP);                                               1146
MEAM     BC    15,GENAMTYP                                         1146
*   ;                               /* SET AM SUB TYPE AS REQUESTED  */
*MEVT:                                                             1148
*   BC(15,MODVTEXL);                /* TEST FOR VTAM                 */
MEVT     BC    15,MODVTEXL                                         1148
*MENRM:                                                            1149
*   BC(15,MODEXLKW);                /* PROCESS KEYWORDS              */
MENRM    BC    15,MODEXLKW                                         1149
*MEXLLEN:                                                          1150
*   BC(15,MODEXLEN);                /* SET EXLST LENGTH              */
MEXLLEN  BC    15,MODEXLEN                                         1150
*MEXLVTLN:                                                         1151
*   BC(15,MODVTELN);                /* SET VTAM EXLST LENGTH         */
MEXLVTLN BC    15,MODVTELN                                         1151
*GEXLBRTB:                                                         1152
*                                                                  1152
*   /*****************************************************************/
*   /*                                                               */
*   /* BRANCH FOR GENCB FOR EXLST FOR OFFSET PASS                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1152
*   BC(15,INVKEYWD);                /* INVALID KEYWORD               */
GEXLBRTB BC    15,INVKEYWD                                         1152
*   GEN(B 0(,REG10));               /* RETURN AS NO ACTION FOR AM  1153
*                                      KEYW0RD                       */
         B 0(,REG10)
*   BC(15,GEXLVTOF);                /* CHECK FOR VTAM SPECIFIED      */
         BC    15,GEXLVTOF                                         1154
*   BC(15,GEXLKWOF);                /* PROCESS KEYWORDS FOR OFFSET   */
         BC    15,GEXLKWOF                                         1155
*   BC(15,INVKEYWD);                /* EXLLEN KEYWORD                */
         BC    15,INVKEYWD                                         1156
*   BC(15,INVKEYWD);                /* SET VTAM EXLST LENGTH         */
         BC    15,INVKEYWD                                         1157
*G2EXBRTB:                                                         1158
*                                                                  1158
*   /*****************************************************************/
*   /*                                                               */
*   /* BRANCH FOR GENCB FOR EXLST FOR ACTION PASS                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1158
*   BC(15,INVKEYWD);                /* INVALID KEYWORD               */
G2EXBRTB BC    15,INVKEYWD                                         1158
*   BC(15,GENAMTYP);                /* AM KEYW0RD                    */
         BC    15,GENAMTYP                                         1159
*   BC(15,GEXLKWAC);                /* PROCESS KEYWORDS FOR ACTION   */
         BC    15,GEXLKWAC                                         1160
*   BC(15,GEXLKWAC);                /* PROCESS KEYWORDS FOR ACTION   */
         BC    15,GEXLKWAC                                         1161
*   GEN(B 0(,REG10));               /* EXLLEN KEYW0RD                */
         B 0(,REG10)
*   GEN(B 0(,REG10));               /* VTAM EXLLEN KEYW0RD           */
         B 0(,REG10)
*TSTAMDSB:                                                         1164
*                                                                  1164
*   /*****************************************************************/
*   /*                                                               */
*   /* TSTAMDSB- TEST BITS IN AMDSB. POINTS RBLKPTR TO THE AMDSB AND */
*   /* GOES TO TSTBITST TO TEST BIT STRINGS.                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1164
*   REG0=REG10;                     /* SAVE RETURN ADD               */
TSTAMDSB LR    REG0,REG10                                          1164
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* SET POINTER TO AMDSB          */
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1166
*   GEN FLOWS(TSTBITST)(BAL REG10,TSTBITST);/* TESTBIT S             */
         BAL REG10,TSTBITST
*   RBLKPTR=TESTBLAD;               /* RELOAD BLOCK PTR              */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1168
*   REG10=REG0;                     /* RELOAD RETURN REGISTER        */
         LR    REG10,REG0                                          1169
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*DSPAMDSB:                                                         1171
*                                                                  1171
*   /*****************************************************************/
*   /*                                                               */
*   /* DSPAMDSB-DISPLAY FIELDS IN THE AMDSB                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1171
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
*                                                                  1171
DSPAMDSB LR    REG0,REG10                                          1171
*   /*****************************************************************/
*   /*                                                               */
*   /* POINT TO THE AMDSB                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1172
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* SET POINTER TO AMDSB          */
*                                                                  1173
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1173
*   /*****************************************************************/
*   /*                                                               */
*   /* DISPLAY REQUESTED FIELD                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1174
*   GEN(BAL REG10,DSPFIELD)                                        1174
*   FLOWS(DSPFIELD);                                               1174
         BAL REG10,DSPFIELD
*   RBLKPTR=SHOWBLAD;               /* RELOAD BLOCK PTR              */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          1175
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1176
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*TSTAMDFD:                                                         1178
*                                                                  1178
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FIELDS IN THE AMDSB                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1178
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
TSTAMDFD LR    REG0,REG10                                          1178
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* SET POINTER TO AMDSB          */
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1180
*   GEN FLOWS(TSTFIELD)(BAL REG10,TSTFIELD);/* TEST FLD              */
         BAL REG10,TSTFIELD
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1182
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*DSPVTFLD:                                                         1184
*                                                                  1184
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM FIRST- THEN DISPLAY FIELDS IN BLOCKS            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1184
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
DSPVTFLD TM    VTAMSW+1(RHDRPTR),B'00010000'                       1184
         BNZ   @RF01184                                            1184
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1186
*       GO TO EXITBAD;                                             1187
         B     EXITBAD                                             1187
*     END;                                                         1188
*DSPFIELD:                                                         1189
*                                                                  1189
*   /*****************************************************************/
*   /*                                                               */
*   /* DSPFIELD-DISPLAY FIELDS                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1189
*   RESPECIFY                                                      1189
*    (REG5) RSTD;                                                  1189
*                                                                  1189
@RF01184 DS    0H                                                  1189
DSPFIELD DS    0H                                                  1190
*   /*****************************************************************/
*   /*                                                               */
*   /* SEE IF ROOM IN SHOWAREA                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1190
*   REG5=ZERO;                      /* ZERO WORK REGISTER            */
         SLR   REG5,REG5                                           1190
*   GEN REFS(FLDLEN,REG11)(IC REG5,FLDLEN(REG11));/* LOAD LENGTH     */
         IC REG5,FLDLEN(REG11)
*   RESPECIFY                                                      1192
*     REG6 RSTD;                                                   1192
*                                                                  1192
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE IF ROOM IN SHOWAREA                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1193
*   REG6=SHOWUSE;                   /* GET USED BYTES                */
         LH    REG6,SHOWUSE(,REG13)                                1193
*   RESPECIFY                                                      1194
*     REG7 RSTD;                                                   1194
*   REG7=SHOWUSA+REG6;              /* SET ADDRESS OF FIELD          */
         LR    REG7,REG6                                           1195
         AL    REG7,SHOWUSA(,RHDRPTR)                              1195
*   IF REG5>FWORDL THEN             /* GREATER THAN FOUR BYTES       */
         C     REG5,@CF00256                                       1196
         BNH   @RF01196                                            1196
*     REG6=REG6+DWORDL;             /* ADD LENGTH                    */
         AL    REG6,@CF00037                                       1197
*   ELSE                            /* LESS THAN FOUR                */
*     REG6=REG6+FWORDL;             /* ADD LENGTH                    */
         B     @RC01196                                            1198
@RF01196 AL    REG6,@CF00256                                       1198
*   IF REG6>SHOWUSL THEN            /* ROOM LEFT                     */
@RC01196 CH    REG6,SHOWUSL(,RHDRPTR)                              1199
         BNH   @RF01199                                            1199
*     DO;                           /* NO ROOM                       */
*       REG0=NTENSTOR;              /* SET ERROR CODE                */
         LA    REG0,9                                              1201
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1202
*     END;                                                         1203
*                                                                  1203
*   /*****************************************************************/
*   /*                                                               */
*   /* UPDATE NUMBER OF BYTES USED                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1204
*   SHOWUSE=REG6;                   /* SAVE USED BYTES               */
@RF01199 STH   REG6,SHOWUSE(,REG13)                                1204
*   SHOWWORD=REG8;                  /* ZERO RECEIVING FIELD          */
         STCM  REG8,15,SHOWWORD(REG7)                              1205
*   REG7=SHOWUSA+REG6-REG5;         /* SET ADDRESS OF RECEIVING FIELD*/
*                                                                  1206
         LR    REG7,REG6                                           1206
         AL    REG7,SHOWUSA(,RHDRPTR)                              1206
         SLR   REG7,REG5                                           1206
*   /*****************************************************************/
*   /*                                                               */
*   /* CALCULATE ADDRESS OF FIELD                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1207
*   GEN REFS(FLDOFF)(IC REG8,FLDOFF(REG11));/* PICK FIELD OFFSET     */
         IC REG8,FLDOFF(REG11)
*   REG6=RBLKPTR+REG8;              /* SET ADDRESS OF FIELD          */
*                                                                  1208
         LR    REG6,RBLKPTR                                        1208
         ALR   REG6,REG8                                           1208
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE FIELD                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1209
*   SHOWAREA(ONE:REG5)=SHOWFLD(ONE:REG5);/* DISPLAY FIELD            */
         LR    @09,REG5                                            1209
         BCTR  @09,0                                               1209
         EX    @09,@SM04276                                        1209
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1211
*    (REG5,                                                        1211
*     REG6,                                                        1211
*     REG7) UNRSTD;                                                1211
*TSTVTFLD:                                                         1212
*                                                                  1212
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM FIRST- THEN COMPARE FIELDS IN BLOCKS            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1212
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
TSTVTFLD TM    VTAMSW+1(RHDRPTR),B'00010000'                       1212
         BNZ   @RF01212                                            1212
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1214
*       GO TO EXITBAD;                                             1215
         B     EXITBAD                                             1215
*     END;                                                         1216
*TSTFIELD:                                                         1217
*                                                                  1217
*   /*****************************************************************/
*   /*                                                               */
*   /* TSTFIELD- COMPARE CHARACTER STRINGS                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1217
*   RESPECIFY                                                      1217
*    (REG5) RSTD;                                                  1217
@RF01212 DS    0H                                                  1217
TSTFIELD DS    0H                                                  1218
*   REG5=ZERO;                      /* ZERO WORK REGISTER            */
         SLR   REG5,REG5                                           1218
*   GEN REFS(FLDLEN)(IC REG5,FLDLEN(REG11));/* PICK UP FLDLEN        */
         IC REG5,FLDLEN(REG11)
*   RESPECIFY                                                      1220
*     REG7 RSTD;                                                   1220
*                                                                  1220
*   /*****************************************************************/
*   /*                                                               */
*   /* CALCULATE ADDRESS FOR COMPARE                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1221
*   IF REG5>FWORDL THEN             /* FIELD GREATER THAN FOUR BYTES */
         C     REG5,@CF00256                                       1221
         BNH   @RF01221                                            1221
*     REG7=DWORDL;                  /* SET FIELD LENGTH TO DOUBLE  1222
*                                      WORD                          */
         LA    REG7,8                                              1222
*   ELSE                            /* FOUR OR LESS                  */
*     REG7=FWORDL;                  /* SET FIELD LENGTH TO FULL WORD */
         B     @RC01221                                            1223
@RF01221 LA    REG7,4                                              1223
*   RESPECIFY                                                      1224
*     REG6 RSTD;                                                   1224
@RC01221 DS    0H                                                  1225
*   REG6=ADDR(ELEMCSTR)+REG7-REG5;  /* SET ADDRESS OF USER FIELD     */
         LA    REG6,ELEMCSTR(,RELEMPTR)                            1225
         ALR   REG6,REG7                                           1225
         SLR   REG6,REG5                                           1225
*   GEN REFS(FLDOFF)(IC REG7,FLDOFF(REG11));/* PICK UP OFFSET        */
         IC REG7,FLDOFF(REG11)
*   REG7=REG7+RBLKPTR;              /* SET FIELD ADDRESS             */
*                                                                  1227
         ALR   REG7,RBLKPTR                                        1227
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPARE AND SET CONDITION CODES                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1228
*   IF USTSFLD(ONE:REG5)<TESTAREA(ONE:REG5) THEN/* TEST FIELDS       */
         LR    @09,REG5                                            1228
         BCTR  @09,0                                               1228
         EX    @09,@SC04278                                        1228
         BNL   @RF01228                                            1228
*     DO;                                                          1229
*       TESTCC=GT;                  /* SET COND CODE                 */
         MVC   TESTCC(2,REG13),@CH00081                            1230
*       GEN(BR REG10);              /* RETURN TO CALLER              */
         BR REG10
*     END;                                                         1232
*   GEN(BER REG10);                 /* BRANCH CC0                    */
@RF01228 DS    0H                                                  1233
         BER REG10
*   TESTCC=LT;                      /* SET LESS THAN CODE            */
         MVC   TESTCC(2,REG13),@CH02114                            1234
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1236
*    (REG5,                                                        1236
*     REG6,                                                        1236
*     REG7) UNRSTD;                                                1236
*MODVTWRD:                                                         1237
*                                                                  1237
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB-VTAM ONLY-FIELD LENGTH OF WORD                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1237
*   IF VTAMSW=OFF THEN              /* NOT VTAM REQUEST              */
MODVTWRD TM    VTAMSW+1(RHDRPTR),B'00010000'                       1237
         BNZ   @RF01237                                            1237
*     DO;                           /* PROCESS ERROR                 */
*       REG0=VTAMONLY;              /* SET REASON CODE               */
         LA    REG0,16                                             1239
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1240
*     END;                                                         1241
*   RESPECIFY                                                      1242
*    (REG5) RSTD;                                                  1242
@RF01237 DS    0H                                                  1243
*   GEN REFS(FLDOFF)(IC REG8,FLDOFF(REG11));/* PICK UP FIELD OFFSET  */
*                                                                  1243
         IC REG8,FLDOFF(REG11)
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK LENGTH OF BLOCK                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1244
*   IF REG8>RPLLEN THEN             /* OFFSET TOO LARGE FOR BLOCK    */
         SLR   @09,@09                                             1244
         IC    @09,RPLLEN(,RBLKPTR)                                1244
         CR    REG8,@09                                            1244
         BNH   @RF01244                                            1244
*     DO;                           /* PROCESS ERROR                 */
*       REG0=BLKNTLG;               /* SET ERROR CODE                */
         LA    REG0,19                                             1246
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1247
*     END;                                                         1248
*                                                                  1248
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE FIELD                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1249
*   REG5=ELEMFIX;                   /* PICK UP REPLACEMENT FIELD     */
@RF01244 L     REG5,ELEMFIX(,RELEMPTR)                             1249
*   GEN(ST REG5,FWORDFLD(REG8,RBLKPTR))                            1250
*   SETS(FWORDFLD);                 /* STORE NEW FIELD               */
         ST REG5,FWORDFLD(REG8,RBLKPTR)
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1252
*     REG5 UNRSTD;                                                 1252
*                                                                  1253
*   /*****************************************************************/
*   /*                                                               */
*   /* POINT TO IDABSPH FOR DBDC BUFFER INFORMATION KEYWORDS FOR LSR */
*   /* AND GSR SHARED RESOURCE POOLS                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1253
*DSPBSPHF:                                                         1253
*   IF ACBLSR=OFF                   /* NOT CONNECTED TO LSR POOL     */
*       &ACBGSR=OFF THEN            /* AND NOT CONNECTED TO GSR    1253
*                                      POOL(MVS ONLY)                */
DSPBSPHF TM    ACBLSR(RBLKPTR),B'01100000'                         1253
         BNZ   @RF01253                                            1253
*     DO;                           /* ERROR SO PROCESS              */
*       REG0=NOTSR;                 /* SET ERROR CODE                */
         LA    REG0,20                                             1255
*       GO TO EXITBAD;              /* RETURN WITH ERROR             */
         B     EXITBAD                                             1256
*     END;                                                         1257
*DSPBUFDF:                                                         1258
*                                                                  1258
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE POINTS TO BSPH OR BUFHDR AND DISPLAYS FIELDS FROM THEM*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1258
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
@RF01253 DS    0H                                                  1258
DSPBUFDF LR    REG0,REG10                                          1258
*   GEN(BAL REG10,PTAMB)                                           1259
*   FLOWS(PTAMB);                                                  1259
         BAL REG10,PTAMB
*   RBLKPTR=AMBBUFC;                /* POINT TO BUFFER HEADER        */
         L     RBLKPTR,AMBBUFC(,RBLKPTR)                           1260
*   GEN(BAL REG10,DSPFIELD)                                        1261
*   FLOWS(DSPFIELD);                /* DISPLAY FIELD                 */
         BAL REG10,DSPFIELD
*   RBLKPTR=SHOWBLAD;               /* RESTORE BLOCK PTR             */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          1262
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1263
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*TSTBSPHF:                                                         1265
*                                                                  1265
*   /*****************************************************************/
*   /*                                                               */
*   /* POINT TO IDABSPH FOR DBDC BUFFER INFORMATION KEYWORDS FOR LSR */
*   /* AND GSR SHARED RESOURCE POOLS                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1265
*   IF ACBLSR=OFF                   /* NOT CONNECTED TO LSR POOL     */
*       &ACBGSR=OFF THEN            /* AND NOT CONNECTED TO GSR    1265
*                                      POOL(MVS ONLY)                */
TSTBSPHF TM    ACBLSR(RBLKPTR),B'01100000'                         1265
         BNZ   @RF01265                                            1265
*     DO;                           /* ERROR SO PROCESS              */
*       REG0=NOTSR;                 /* SET ERROR CODE                */
         LA    REG0,20                                             1267
*       GO TO EXITBAD;              /* RETURN WITH ERROR             */
         B     EXITBAD                                             1268
*     END;                                                         1269
*TSTBUFDF:                                                         1270
*                                                                  1270
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE POINTS TO BSPH OR BUFDR AND TESTS FIELDS FROM THEM    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1270
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
@RF01265 DS    0H                                                  1270
TSTBUFDF LR    REG0,REG10                                          1270
*   GEN(BAL REG10,PTAMB)                                           1271
*   FLOWS(PTAMB);                   /* POINT TO BLOCK                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBBUFC;                /* POINT TO BUFFER HEADER        */
         L     RBLKPTR,AMBBUFC(,RBLKPTR)                           1272
*   GEN(BAL REG10,TSTFIELD)                                        1273
*   FLOWS(TSTFIELD);                /* TEST FIELD                    */
         BAL REG10,TSTFIELD
*   RBLKPTR=TESTBLAD;               /* RESTORE BLOCK PTR             */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1274
*   REG10=REG0;                     /* RESTORE RETURN ADDRESS        */
         LR    REG10,REG0                                          1275
*   GEN(BR REG10);                  /* RETURN TO USER                */
         BR REG10
*DISPHRBA:                                                         1277
*                                                                  1277
*   /*****************************************************************/
*   /*                                                               */
*   /* DISPLAY HIGHRBA LOCATES ARDB WITH THE HIGHEST USED RBA AND    */
*   /* DISPLAYS THAT RBA IN SHOWAREA                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1277
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
*                                                                  1277
DISPHRBA LR    REG0,REG10                                          1277
*   /*****************************************************************/
*   /*                                                               */
*   /* POINT TO THE AMB                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1278
*   GEN(BAL REG10,PTAMB)                                           1278
*   FLOWS(PTAMB);                   /* POINT TO AMB                  */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* POINT TO BLOCK                */
*                                                                  1279
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1279
*   /*****************************************************************/
*   /*                                                               */
*   /* FIND HIGEST RBA                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1280
*   GEN(BAL REG10,FNDHRBA)                                         1280
*   FLOWS(FNDHRBA);                 /* FIND HIGH RBA                 */
*                                                                  1280
         BAL REG10,FNDHRBA
*   /*****************************************************************/
*   /*                                                               */
*   /* SHOWIT                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1281
*   GEN(BAL REG10,DSPFIELD)                                        1281
*   FLOWS(DSPFIELD);                /* DISPLAY FIELD                 */
         BAL REG10,DSPFIELD
*   RBLKPTR=SHOWBLAD;               /* RESTORE BLOCK POINTER         */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          1282
*   REG10=REG0;                     /* RESTORE RETURN ADDRESS        */
         LR    REG10,REG0                                          1283
*   GEN(BR REG10);                  /* RETURN TO USER                */
         BR REG10
*TESTHRBA:                                                         1285
*                                                                  1285
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST HIGHRBA                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1285
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
*                                                                  1285
TESTHRBA LR    REG0,REG10                                          1285
*   /*****************************************************************/
*   /*                                                               */
*   /* POINT TO AMDSB                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1286
*   GEN(BAL REG10,PTAMB)                                           1286
*   FLOWS(PTAMB);                   /* POINT TO AMB                  */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* POINT TO AMDSB                */
*                                                                  1287
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1287
*   /*****************************************************************/
*   /*                                                               */
*   /* LOCATE ARDB WITH HIGHEST RBA                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1288
*   GEN(BAL REG10,FNDHRBA)                                         1288
*   FLOWS(FNDHRBA);                 /* FIND HIGH RBA                 */
         BAL REG10,FNDHRBA
*   GEN(BAL REG10,TSTFIELD)                                        1289
*                                                                  1289
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPARE IT                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1289
*   FLOWS(TSTFIELD);                /* TEST FIELD                    */
         BAL REG10,TSTFIELD
*   RBLKPTR=TESTBLAD;               /* RESTORE BLOCK POINTER         */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1290
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1291
*   GEN(BR REG10);                  /* RETURN TO USER                */
         BR REG10
*MODVTBIT:                                                         1293
*                                                                  1293
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM BEFORE SETING BIT STRINGS                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1293
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
MODVTBIT TM    VTAMSW+1(RHDRPTR),B'00010000'                       1293
         BNZ   @RF01293                                            1293
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1295
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1296
*     END;                                                         1297
*MODBITST:                                                         1298
*                                                                  1298
*   /*****************************************************************/
*   /*                                                               */
*   /* MODBITST- SET BIT STRINGS FOR MODCB/GENCB                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1298
*   RESPECIFY                                                      1298
*    (REG5,                                                        1298
*     REG6,                                                        1298
*     REG7) RSTD;                                                  1298
@RF01293 DS    0H                                                  1298
MODBITST DS    0H                                                  1299
*   RESPECIFY                                                      1299
*     REG9 UNRSTD;                                                 1299
*   REG5=BATPTR;                    /* LOAD ADDRESS TO BATTAB        */
         L     REG5,BATPTR                                         1300
*   GEN(AH REG5,FLDLEN(REG11))                                     1301
*   REFS(FLDLEN);                   /* PICK UP OFFSET TO BATTAB      */
*                                                                  1301
         AH REG5,FLDLEN(REG11)
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD POINTER REGISTERS                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1302
*   GEN(LM REG5,REG8,0(REG5));      /* LOAD REGISTERS                */
         LM REG5,REG8,0(REG5)
*   RESPECIFY                                                      1303
*    (REG8,                                                        1303
*     REG9) RSTD;                                                  1303
*                                                                  1303
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR EXTRA BITS                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1304
*   REG9=ELEMFIX;                   /* LOAD BITS                     */
         L     REG9,ELEMFIX(,RELEMPTR)                             1304
*   REG8=REG9&REG8;                 /* TEST FOR EXTRA BITS           */
         NR    REG8,REG9                                           1305
*   BC(8,NOTOMANY);                 /* GO AROUND ERROR CODE          */
         BC    8,NOTOMANY                                          1306
*   DO;                             /* PROCESS ERROR                 */
*     REG0=BITEXER;                 /* SET ERROR CODE                */
         LA    REG0,14                                             1308
*     GO TO EXITBAD;                /* EXIT WITH ERROR               */
         B     EXITBAD                                             1309
*   END;                                                           1310
*NOTOMANY:                                                         1311
*   RESPECIFY                                                      1311
*     REG11 UNRSTD;                                                1311
NOTOMANY DS    0H                                                  1312
*   EXBITABL=REG8;                  /* TURN OFF EXCLUSIVE DETECTORS  */
         ST    REG8,EXBITABL(,REG13)                               1312
*BITSET:                            /* LOOK FOR FUNCTION SPECIFIED   */
*   IF REG9^=ZERO THEN              /* ANY BITS ON                   */
*                                                                  1313
BITSET   LTR   REG9,REG9                                           1313
         BZ    @RF01313                                            1313
*     /***************************************************************/
*     /*                                                             */
*     /* REG9 ZERO INDICATES ALL REQUESTS DONE                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1314
*     DO UNTIL(REG9=ZERO);          /* LOOP UNTIL WORD DONE          */
@DL01314 DS    0H                                                  1315
*       BC(4,HOBITON);              /* HIGH ORDER BIT ON             */
*                                                                  1315
         BC    4,HOBITON                                           1315
*       /*************************************************************/
*       /*                                                           */
*       /* REG8 INDICATES REQUEST DETECTED                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1316
*       DO UNTIL(REG9<ZERO);        /* LOOP UNTIL BIT FOUND          */
@DL01316 DS    0H                                                  1317
*         REG5=REG5+LENGTH(BATOFFTB);/* STEP TO NEXT BIT             */
         AL    REG5,@CF00102                                       1317
*         SLL(REG9,ONE);            /* SHIFT BITS ONE AT A TIME      */
         SLL   REG9,1                                              1318
*       END;                                                       1319
*                                                                  1319
@DE01316 LTR   REG9,REG9                                           1319
         BNM   @DL01316                                            1319
*       /*************************************************************/
*       /*                                                           */
*       /* BIT FOUND ON                                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1320
*HOBITON:                                                          1320
*       REG5=REG5+LENGTH(BATOFFTB); /* STEP TO NEXT BIT              */
HOBITON  AL    REG5,@CF00102                                       1320
*       GEN(IC REG8,BATEX(,REG5))   /* LOAD OFFSET FOR EXCLUSIVE TEST*/
*       REFS(BATEX);                                               1321
*                                                                  1321
         IC REG8,BATEX(,REG5)
*       /*************************************************************/
*       /*                                                           */
*       /* CONFLICTING BITS SPECIFIED?                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1322
*       GEN(EX REG0,EXTSTAB(REG8)); /* TEST FOR EXCLUSIVE BIT ERROR  */
         EX REG0,EXTSTAB(REG8)
*       BC(8,EXBITOK);              /* BRANCH GOOD                   */
         BC    8,EXBITOK                                           1323
*       REG0=BITEXER;               /* SET ERROR CODE                */
         LA    REG0,14                                             1324
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
*                                                                  1325
         B     EXITBAD                                             1325
*       /*************************************************************/
*       /*                                                           */
*       /* NO, SET INDICATOR TO SHOW WE WERE HERE                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1326
*EXBITOK:                                                          1326
*       GEN(EX REG0,EXBITAB(REG8)); /* SET EXCLUSIVE BIT             */
*                                                                  1326
EXBITOK  EX REG0,EXBITAB(REG8)
*       /*************************************************************/
*       /*                                                           */
*       /* TURN OFF CONFLICTING BITS IN CONTROL BLOCK                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1327
*       GEN(IC REG8,BATOFF(,REG5))                                 1327
*       REFS(BATOFF);               /* LOAD OFFSET FOR TURN OFF      */
         IC REG8,BATOFF(,REG5)
*       GEN(EX REG0,0(REG8,REG7));  /* TURN OFF EXCLUSIVE BITS       */
*                                                                  1328
         EX REG0,0(REG8,REG7)
*       /*************************************************************/
*       /*                                                           */
*       /* SET ON DESIRED BIT                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1329
*       REG8=BATON;                 /* LOAD OFFSET TO TURN ON        */
         SLR   REG8,REG8                                           1329
         IC    REG8,BATON(,REG5)                                   1329
*       GEN(EX REG0,0(REG8,REG6));  /* TURN ON BIT                   */
         EX REG0,0(REG8,REG6)
*       SLL(REG9,ONE);              /* SHIFT BITS ONE AT A TIME      */
         SLL   REG9,1                                              1331
*     END;                          /* END OF INNER LOOP             */
@DE01314 LTR   REG9,REG9                                           1332
         BNZ   @DL01314                                            1332
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01313 DS    0H                                                  1333
         BR REG10
*   RESPECIFY                                                      1334
*    (REG5,                                                        1334
*     REG6,                                                        1334
*     REG7,                                                        1334
*     REG9) UNRSTD;                                                1334
*   RESPECIFY                                                      1335
*     REG11 RSTD;                                                  1335
*                                                                  1336
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB-VTAM ONLY-FIELD LENGTH HALFWORD                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1336
*MODVTHWD:                                                         1336
*   IF VTAMSW=OFF THEN              /* NOT VTAM REQUEST              */
MODVTHWD TM    VTAMSW+1(RHDRPTR),B'00010000'                       1336
         BNZ   @RF01336                                            1336
*     DO;                           /* PROCESS ERROR                 */
*       REG0=VTAMONLY;              /* SET REASON CODE               */
         LA    REG0,16                                             1338
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1339
*     END;                                                         1340
*   RESPECIFY                                                      1341
*    (REG5) RSTD;                                                  1341
@RF01336 DS    0H                                                  1342
*   REG5=ELEMFIX;                   /* PICK UP REPLACEMENT FIELD     */
         L     REG5,ELEMFIX(,RELEMPTR)                             1342
*   GEN(IC REG8,FLDOFF(REG11));     /* PICK UP FIELD OFFSET          */
         IC REG8,FLDOFF(REG11)
*   IF REG8>RPLLEN THEN             /* OFFSET TOO LARGE FOR BLOCK    */
         SLR   @09,@09                                             1344
         IC    @09,RPLLEN(,RBLKPTR)                                1344
         CR    REG8,@09                                            1344
         BNH   @RF01344                                            1344
*     DO;                           /* PROCESS ERROR                 */
*       REG0=BLKNTLG;               /* SET ERROR CODE                */
         LA    REG0,19                                             1346
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1347
*     END;                                                         1348
*   GEN(STH REG5,FWORDFLD(REG8,RBLKPTR));/* STORE NEW FIELD          */
@RF01344 DS    0H                                                  1349
         STH REG5,FWORDFLD(REG8,RBLKPTR)
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1351
*     REG5 UNRSTD;                                                 1351
*                                                                  1352
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB-RPL-ECB KEYWORD                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1352
*MODECBFD:                                                         1352
*   RPLECBSW=OFF;                   /* NO EXTERNAL ECB               */
MODECBFD NI    RPLECBSW(RBLKPTR),B'11111110'                       1352
*   RPLEXIT=OFF;                    /* NO EXIT                       */
         NI    RPLEXIT(RBLKPTR),B'11011111'                        1353
*   RPLECB=ELEMPTR;                 /* MOVE THE POINTER              */
         L     @09,ELEMPTR(,RELEMPTR)                              1354
         ST    @09,RPLECB(,RBLKPTR)                                1354
*   IF RPLECB^=ZERO THEN            /* VALID POINTER                 */
         LTR   @09,@09                                             1355
         BZ    @RF01355                                            1355
*     DO;                                                          1356
*       RPLECBSW=ON;                /* SET EXTERNAL FLAG             */
         OI    RPLECBSW(RBLKPTR),B'00000001'                       1357
*       RPLNEXIT=ON;                /* SET NO EXIT SPECIFIED         */
         OI    RPLNEXIT(RBLKPTR),B'01000000'                       1358
*     END;                                                         1359
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01355 DS    0H                                                  1360
         BR REG10
*TSTVTBIT:                                                         1361
*                                                                  1361
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM SPECIFIED BEFORE TESTING BITS                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1361
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
TSTVTBIT TM    VTAMSW+1(RHDRPTR),B'00010000'                       1361
         BNZ   @RF01361                                            1361
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1363
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1364
*     END;                                                         1365
*                                                                  1365
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST BITS AND SET CONDITION CODE                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1366
*TSTBITST:                                                         1366
*                                                                  1366
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTCB-BITSTRINGS                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1366
*   RESPECIFY                                                      1366
*    (REG5) RSTD;                                                  1366
@RF01361 DS    0H                                                  1366
TSTBITST DS    0H                                                  1367
*   RESPECIFY                                                      1367
*    (REG8,                                                        1367
*     REG9) UNRSTD;                                                1367
*   REG5=BATPTR;                    /* SET ADDRESS OF BATTAB         */
         L     REG5,BATPTR                                         1368
*   GEN(AH REG5,FLDLEN(REG11))                                     1369
*   REFS(FLDLEN);                   /* PICK UP OFFSET INTO BATTAB    */
         AH REG5,FLDLEN(REG11)
*   RESPECIFY                                                      1370
*    (REG6,                                                        1370
*     REG7,                                                        1370
*     REG8) RSTD;                                                  1370
*   RESPECIFY                                                      1371
*     REG11 UNRSTD;                                                1371
*   GEN(LM REG5,REG8,0(REG5));      /* LOAD REGISTERS                */
         LM REG5,REG8,0(REG5)
*   RESPECIFY                                                      1373
*    (REG9) RSTD;                                                  1373
*   REG9=ELEMFIX;                   /* LOAD BITS                     */
         L     REG9,ELEMFIX(,RELEMPTR)                             1374
*   REG8=REG9&REG8;                 /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1375
*   IF REG8^=ZERO THEN              /* EXTRA BITS ON                 */
         LTR   REG8,REG8                                           1376
         BZ    @RF01376                                            1376
*     DO;                           /* PROCESS ERROR                 */
*       REG0=BITEXER;               /* SET ERROR CODE                */
         LA    REG0,14                                             1378
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1379
*     END;                                                         1380
*   EXBITABL=REG8;                  /* TURN OFF EXCLUSIVE DETECTORS  */
@RF01376 ST    REG8,EXBITABL(,REG13)                               1381
*   IF REG9^=ZERO THEN              /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1382
         BZ    @RF01382                                            1382
*     DO UNTIL(REG9=ZERO);          /* LOOP UNTIL WORD DONE          */
@DL01383 DS    0H                                                  1384
*TSTBIT:                                                           1384
*       DO UNTIL(REG8^=ZERO);       /* LOOK FOR BITS ON              */
TSTBIT   DS    0H                                                  1384
@DL01384 DS    0H                                                  1385
*         REG5=REG5+LENGTH(BATOFFTB);/* STEP TO NEXT BIT             */
         AL    REG5,@CF00102                                       1385
*         SLDL(REG8,ONE);           /* SHIFT BITS ONE AT A TIME      */
         SLDL  REG8,1                                              1386
*       END;                                                       1387
@DE01384 LTR   REG8,REG8                                           1387
         BZ    @DL01384                                            1387
*       GEN(IC REG8,BATEX(REG5))    /* LOAD OFFSET FOR EXCLUSIVE TEST*/
*       REFS(BATEX);                                               1388
         IC REG8,BATEX(REG5)
*       GEN(EX REG0,EXTSTAB(REG8)); /* TEST FOR EXCLUSIVE BIT ERROR  */
         EX REG0,EXTSTAB(REG8)
*       BC(8,EXTBITOK);             /* BRANCH GOOD                   */
         BC    8,EXTBITOK                                          1390
*       REG0=BITEXER;               /* SET ERROR CODE                */
         LA    REG0,14                                             1391
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1392
*EXTBITOK:                                                         1393
*       GEN(EX REG0,EXBITAB(REG8)); /* SET EXCLUSIVE BIT             */
EXTBITOK EX REG0,EXBITAB(REG8)
*       GEN(IC REG8,BATON(REG5))                                   1394
*       REFS(BATON);                /* LOAD OFFSET TO TURN ON      1394
*                                      INSTRUCTION                   */
         IC REG8,BATON(REG5)
*       GEN(L REG8,0(REG8,REG6));   /* PICK UP INSTRUCTION           */
         L REG8,0(REG8,REG6)
*       BITSTINS=REG8;              /* STORE INSTRUCTION IN WORK AREA*/
         ST    REG8,BITSTINS(,REG13)                               1396
*       IF TSTOP=OICODE THEN        /* NORMALLY ON                   */
         CLI   TSTOP(REG13),150                                    1397
         BNE   @RF01397                                            1397
*         DO;                       /* PROCESS NORMAL                */
*           TSTOP=TMCODE;           /* SET OP CODE                   */
         MVI   TSTOP(REG13),X'91'                                  1399
*           GEN(EX REG0,BITSTINS(REG13));/* TEST SPECIFIED BIT       */
         EX REG0,BITSTINS(REG13)
*           BC(7,BITON);            /* SET EQUAL CODE                */
         BC    7,BITON                                             1401
*         END;                                                     1402
*       ELSE                        /* NOT NORMALLY ON               */
*         DO;                       /* PROCESS NORMALLY OFF          */
         B     @RC01397                                            1403
@RF01397 DS    0H                                                  1404
*           TSTOP=TMCODE;           /* SET OPCODE                    */
         MVI   TSTOP(REG13),X'91'                                  1404
*           GEN(XI MASK(REG13),X'FF')                              1405
*           REFS(MASK);             /* FLIP MASK BITS                */
         XI MASK(REG13),X'FF'
*           GEN(EX REG0,BITSTINS(REG13));/* TEST SPECIFIED BIT       */
         EX REG0,BITSTINS(REG13)
*           BC(8,BITON);            /* SET NOT EQUAL CODE            */
         BC    8,BITON                                             1407
*         END;                                                     1408
*       RESPECIFY                                                  1409
*         REG8 UNRSTD;                                             1409
@RC01397 DS    0H                                                  1410
*BITOFF:                                                           1410
*       TESTCC=ON;                  /* SET NOT EQUAL CODE            */
BITOFF   LA    @11,1                                               1410
         STH   @11,TESTCC(,REG13)                                  1410
*       RESPECIFY                                                  1411
*         REG8 RSTD;                                               1411
*BITON:                                                            1412
*       REG8=ZERO;                  /* ZERO BIT DETECTOR             */
BITON    SLR   REG8,REG8                                           1412
*     END;                                                         1413
@DE01383 LTR   REG9,REG9                                           1413
         BNZ   @DL01383                                            1413
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01382 DS    0H                                                  1414
         BR REG10
*   RESPECIFY                                                      1415
*     REG11 RSTD;                                                  1415
*   RESPECIFY                                                      1416
*    (REG5,                                                        1416
*     REG6,                                                        1416
*     REG7,                                                        1416
*     REG9) UNRSTD;                                                1416
*                                                                  1417
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB/RPL- FIELD LENGTH BYTE                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1417
*MODVTBYT:                                                         1417
*                                                                  1417
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR VTAM SPECIFIED FIRST                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1417
*   IF VTAMSW=OFF THEN              /* NOT VTAM REQUEST              */
MODVTBYT TM    VTAMSW+1(RHDRPTR),B'00010000'                       1417
         BNZ   @RF01417                                            1417
*     DO;                           /* PROCESS ERROR                 */
*       REG0=VTAMONLY;              /* SET REASON CODE               */
         LA    REG0,16                                             1419
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1420
*     END;                                                         1421
*   RESPECIFY                                                      1422
*    (REG5) RSTD;                                                  1422
*                                                                  1422
@RF01417 DS    0H                                                  1423
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE BYTE FIELD                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1423
*   REG5=ELEMFIX;                   /* PICK UP REPLACEMENT FIELD     */
         L     REG5,ELEMFIX(,RELEMPTR)                             1423
*   GEN(IC REG8,FLDOFF(REG11));     /* PICK UP FIELD OFFSET          */
         IC REG8,FLDOFF(REG11)
*   IF REG8>RPLLEN THEN             /* OFFSET TOO LARGE FOR BLOCK    */
         SLR   @09,@09                                             1425
         IC    @09,RPLLEN(,RBLKPTR)                                1425
         CR    REG8,@09                                            1425
         BNH   @RF01425                                            1425
*     DO;                           /* PROCESS ERROR                 */
*       REG0=BLKNTLG;               /* SET ERROR CODE                */
         LA    REG0,19                                             1427
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1428
*     END;                                                         1429
*   GEN(STC REG5,FWORDFLD(REG8,RBLKPTR));/* STORE NEW FIELD          */
@RF01425 DS    0H                                                  1430
         STC REG5,FWORDFLD(REG8,RBLKPTR)
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1432
*     REG5 UNRSTD;                                                 1432
*DSPPLHFD:                                                         1433
*                                                                  1433
*   /*****************************************************************/
*   /*                                                               */
*   /* POINTS TO PLHDHR AND DISPLAYS OR TESTS FIELDS FROM THEM       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1433
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
DSPPLHFD LR    REG0,REG10                                          1433
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBPH;                  /* SET BLOCK PTR                 */
*                                                                  1435
         L     RBLKPTR,AMBPH(,RBLKPTR)                             1435
*   /*****************************************************************/
*   /*                                                               */
*   /* DISPLAY FIELD                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1436
*   GEN FLOWS(DSPFIELD)(BAL REG10,DSPFIELD);                       1436
         BAL REG10,DSPFIELD
*   RBLKPTR=SHOWBLAD;               /* RESET RBLKPTR                 */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          1437
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1438
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*TSTAMBLB:                                                         1440
*                                                                  1440
*   /*****************************************************************/
*   /*                                                               */
*   /* OPENOBJ- POINT TO THE OPEN AMBL                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1440
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
TSTAMBLB LR    REG0,REG10                                          1440
*   IF ACBOPEN=OFF THEN             /* IS ACB OPEN                   */
         TM    ACBOPEN(RBLKPTR),B'00010000'                        1441
         BNZ   @RF01441                                            1441
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=ACBNTOPN;              /* SET ERROR CODE                */
         LA    REG0,5                                              1443
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1444
*     END;                                                         1445
*   RBLKPTR=ACBAMBL;                /* SET BLOCK POINTER             */
@RF01441 L     RBLKPTR,ACBAMBL(,RBLKPTR)                           1446
*   GEN(BAL REG10,TSTBITST)                                        1447
*   FLOWS(TSTBITST);                /* TEST BIT STRING               */
         BAL REG10,TSTBITST
*   RBLKPTR=TESTBLAD;               /* RELOAD BLKPTR                 */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1448
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1449
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*DSPVTEXL:                                                         1451
*                                                                  1451
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM FIRST                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1451
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
DSPVTEXL TM    VTAMSW+1(RHDRPTR),B'00010000'                       1451
         BNZ   @RF01451                                            1451
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1453
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1454
*     END;                                                         1455
*DSPEXLFD:                                                         1456
*                                                                  1456
*   /*****************************************************************/
*   /*                                                               */
*   /* SHOW EXLST                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1456
*   REG0=REG10;                     /* SAVE CALLERS RETURN ADDRESS   */
@RF01451 DS    0H                                                  1456
DSPEXLFD LR    REG0,REG10                                          1456
*   GEN REFS(FLDOFF)(IC REG8,FLDOFF(REG11));/* PICK FIELD OFFSET   1457
*                                                            @ZA19552*/
         IC REG8,FLDOFF(REG11)
*   IF REG8=>EXLLEN THEN            /* EXLST LONG ENOUGH?    @ZA19552*/
         CH    REG8,EXLLEN(,RBLKPTR)                               1458
         BL    @RF01458                                            1458
*     DO;                           /* NO, PROCESS ERROR     @ZA19552*/
*       REG0=EXLTOSHT;              /* SET REASON CODE       @ZA19552*/
         LA    REG0,7                                              1460
*       GO TO EXITBAD;              /* EXIT WITH ERROR       @ZA19552*/
         B     EXITBAD                                             1461
*     END;                          /*                       @ZA19552*/
*   RBLKPTR=RBLKPTR+ONE;            /* BUMP ADDRESS BY ONE TO STEP 1463
*                                      OVER FLAGS                    */
@RF01458 AL    RBLKPTR,@CF00081                                    1463
*   GEN(BAL REG10,DSPFIELD)                                        1464
*   FLOWS(DSPFIELD);                /* SHOW POINTER FIELD            */
         BAL REG10,DSPFIELD
*   RBLKPTR=RBLKPTR-ONE;            /* RESET BLOCK POINTER           */
         BCTR  RBLKPTR,0                                           1465
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1466
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*TSTVTEXL:                                                         1468
*                                                                  1468
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM FIRST                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1468
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
TSTVTEXL TM    VTAMSW+1(RHDRPTR),B'00010000'                       1468
         BNZ   @RF01468                                            1468
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1470
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1471
*     END;                                                         1472
*TSTEXLFD:                                                         1473
*                                                                  1473
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTCB/EXLST                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1473
*   RESPECIFY                                                      1473
*     REG5 RSTD;                                                   1473
@RF01468 DS    0H                                                  1473
TSTEXLFD DS    0H                                                  1474
*   REG5=ZERO;                      /* ZERO WORK REGISTER            */
         SLR   REG5,REG5                                           1474
*   GEN REFS(FLDOFF)(IC REG5,FLDOFF(REG11));/* PICK UP FIELD OFFSET  */
         IC REG5,FLDOFF(REG11)
*   IF REG5>EXLLEN THEN             /* EXLST LIST LONG ENOUGTH       */
         CH    REG5,EXLLEN(,RBLKPTR)                               1476
         BNH   @RF01476                                            1476
*     TESTCC=NE;                    /* SET NOT EQUAL CODE            */
         MVC   TESTCC(2,REG13),@CH02114                            1477
*   ELSE                            /* WAS LONG ENOUGTH              */
*     DO;                           /* PROCESS KEYWORD               */
         B     @RC01476                                            1478
@RF01476 DS    0H                                                  1479
*       REG5=RBLKPTR+REG5;          /* SET POINTER                   */
         ALR   REG5,RBLKPTR                                        1479
*       IF REG5->EXLSPEC=OFF THEN   /* EXIT NOT PRESENT              */
         TM    EXLSPEC(REG5),B'10000000'                           1480
         BNZ   @RF01480                                            1480
*         TESTCC=NE;                /* SET NOT EQUAL CODE            */
         MVC   TESTCC(2,REG13),@CH02114                            1481
*       ELSE                        /* ENTRY WAS PRESENT             */
*         DO;                       /* PROCESS FLAGS                 */
         B     @RC01480                                            1482
@RF01480 DS    0H                                                  1483
*           IF ELEMXFLG(1)=ON       /* ACTIVE SPECIFIED              */
*               &REG5->EXLACTM=OFF THEN/* ACTIVE ON                  */
         TM    ELEMXFLG(RELEMPTR),B'10000000'                      1483
         BNO   @RF01483                                            1483
         TM    EXLACTM(REG5),B'01000000'                           1483
         BNZ   @RF01483                                            1483
*             TESTCC=NE;            /* SET NOT EQUAL CODE            */
         MVC   TESTCC(2,REG13),@CH02114                            1484
*           IF ELEMXFLG(2)=ON       /* INACTIVE SPECIFIED            */
*               &REG5->EXLACTM=ON THEN/* ACTIVE ON                   */
@RF01483 TM    ELEMXFLG(RELEMPTR),B'01000000'                      1485
         BNO   @RF01485                                            1485
         TM    EXLACTM(REG5),B'01000000'                           1485
         BNO   @RF01485                                            1485
*             TESTCC=NE;            /* SET NOT EQUAL ON              */
         MVC   TESTCC(2,REG13),@CH02114                            1486
*           IF ELEMXFLG(3)=ON       /* LINK SPECIFIED                */
*               &REG5->EXLLNK=OFF THEN/* LINK ON                     */
@RF01485 TM    ELEMXFLG(RELEMPTR),B'00100000'                      1487
         BNO   @RF01487                                            1487
         TM    EXLLNK(REG5),B'00100000'                            1487
         BNZ   @RF01487                                            1487
*             TESTCC=NE;            /* SET NOT EQUAL                 */
         MVC   TESTCC(2,REG13),@CH02114                            1488
*           IF ELEMXFLG(4)=ON THEN  /* POINTER SUPPLIED              */
@RF01487 TM    ELEMXFLG(RELEMPTR),B'00010000'                      1489
         BNO   @RF01489                                            1489
*             IF REG5->EXLEXITP>ELEMPTR THEN/* POINTER GREATER THAN  */
         CLC   EXLEXITP(4,REG5),ELEMPTR(RELEMPTR)                  1490
         BNH   @RF01490                                            1490
*               TESTCC=GT;          /* SET GREATER THAN CODE         */
         MVC   TESTCC(2,REG13),@CH00081                            1491
*             ELSE                  /* NOT GREATER THAN              */
*               IF REG5->EXLEXITP<ELEMPTR THEN/* POINTER LESS THAN   */
         B     @RC01490                                            1492
@RF01490 CLC   EXLEXITP(4,REG5),ELEMPTR(RELEMPTR)                  1492
         BNL   @RF01492                                            1492
*                 TESTCC=LT;        /* SET LESS THAN                 */
         MVC   TESTCC(2,REG13),@CH02114                            1493
*         END;                                                     1494
@RF01492 DS    0H                                                  1494
@RC01490 DS    0H                                                  1494
@RF01489 DS    0H                                                  1495
*     END;                                                         1495
@RC01480 DS    0H                                                  1496
*   RESPECIFY                                                      1496
*     REG5 UNRSTD;                                                 1496
@RC01476 DS    0H                                                  1497
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*MODEXITF:                                                         1498
*                                                                  1498
*   /*****************************************************************/
*   /*                                                               */
*   /* MODCB/RPL-EXIT KEYWORD-VTAM ONLY                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1498
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
MODEXITF TM    VTAMSW+1(RHDRPTR),B'00010000'                       1498
         BNZ   @RF01498                                            1498
*     DO;                           /* NO, PROCESS ERROR             */
*       REG0=VTAMONLY;              /* LOAD ERROR CODE               */
         LA    REG0,16                                             1500
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1501
*     END;                                                         1502
*   RPLECB=ELEMPTR;                 /* SET POINTER VALUE             */
@RF01498 L     @09,ELEMPTR(,RELEMPTR)                              1503
         ST    @09,RPLECB(,RBLKPTR)                                1503
*   RPLECBSW=OFF;                   /* SET ECB OFF                   */
         NI    RPLECBSW(RBLKPTR),B'11111110'                       1504
*   RPLNEXIT=OFF;                   /* SET NO EXIT OFF               */
         NI    RPLNEXIT(RBLKPTR),B'10111111'                       1505
*   IF ELEMPTR^=ZERO THEN           /* VALID POINTER                 */
         LTR   @09,@09                                             1506
         BZ    @RF01506                                            1506
*     RPLEXIT=ON;                   /* INDICATE EXIT                 */
         OI    RPLEXIT(RBLKPTR),B'00100000'                        1507
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01506 DS    0H                                                  1508
         BR REG10
*TSTIOBIT:                                                         1509
*                                                                  1509
*   /*****************************************************************/
*   /*                                                               */
*   /* IO                                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1509
*   IF RPLECBSW=OFF                 /* NO EXTERNAL ECB               */
*     THEN                                                         1509
TSTIOBIT TM    RPLECBSW(RBLKPTR),B'00000001'                       1509
         BNZ   @RF01509                                            1509
*     IF RPLPOST=OFF THEN           /* POST OFF                      */
         TM    RPLPOST(RBLKPTR),B'01000000'                        1510
         BNZ   @RF01510                                            1510
*       TESTCC=NE;                  /* SET NOT EQUAL INDICATOR       */
         MVC   TESTCC(2,REG13),@CH02114                            1511
*     ELSE                                                         1512
*       ;                           /* NULL PATH                     */
@RF01510 DS    0H                                                  1513
*   ELSE                            /* NOT EXTERNAL                  */
*     IF ECBPOST=OFF THEN           /* POST OFF                      */
         B     @RC01509                                            1513
@RF01509 L     @09,RPLECB(,RBLKPTR)                                1513
         TM    ECBPOST(@09),B'01000000'                            1513
         BNZ   @RF01513                                            1513
*       TESTCC=NE;                  /* SET NOT EQUAL INDICATOR       */
         MVC   TESTCC(2,REG13),@CH02114                            1514
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01513 DS    0H                                                  1515
@RC01509 DS    0H                                                  1515
         BR REG10
*GENAMTYP:                                                         1516
*                                                                  1516
*   /*****************************************************************/
*   /*                                                               */
*   /* GENCB-AM KEYWORD. SETS ACB/RPL/EXL STYP FIELD                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1516
*   IF(FTCBTC&VTAMCORR)^=GENCB      /* GENCB ONLY PLEASE             */
*     THEN                          /* NO, ERROR                     */
GENAMTYP LA    @09,1                                               1516
         LH    @05,FTCBTC(,RHDRPTR)                                1516
         N     @05,@CF00034                                        1516
         CR    @05,@09                                             1516
         BNE   @RT01516                                            1516
*     GO TO INVKEYWD;               /* EXIT WITH ERROR               */
*   IF ELEMBSTR(2)=ON THEN          /* VTAM SPECIFIED                */
         TM    ELEMBSTR(RELEMPTR),B'01000000'                      1518
         BNO   @RF01518                                            1518
*     DO;                           /* PROCESS VTAM                  */
*       IF VTAMSW=OFF THEN          /* VSAM SPECIFIED                */
         ALR   @09,RHDRPTR                                         1520
         TM    VTAMSW(@09),B'00010000'                             1520
         BNZ   @RF01520                                            1520
*         DO;                       /* PROCESS ERROR                 */
*           REG0=VTAMONLY;          /* SET ERROR CODE                */
         LA    REG0,16                                             1522
*           GO TO EXITBAD;          /* EXIT WITH ERROR               */
         B     EXITBAD                                             1523
*         END;                                                     1524
*       ACBSTYP=VTAMCODE;           /* SAME OFFSET FOR RPL&EXLST     */
@RF01520 MVI   ACBSTYP(RBLKPTR),X'20'                              1525
*       IF MODBTC=ACBTC THEN        /* ACB?                          */
         CLI   MODBTC(RHDRPTR),160                                 1526
         BNE   @RF01526                                            1526
*         ACBDDNM=VTAMDDNM;         /* SET SPECIAL VTAM DDNAME, HAS
*                                      TO BE CHANGED WHEN DEFAULT  1527
*                                      ACBDDNM CHANGES       @G40AKCM*/
         MVC   ACBDDNM(8,RBLKPTR),VTAMDDNM                         1527
*     END;                                                         1528
*   ELSE                            /* VASM                          */
*     ACBSTYP=VSAMCODE;             /* SET VSAM SUBTYPE              */
         B     @RC01518                                            1529
@RF01518 MVI   ACBSTYP(RBLKPTR),X'10'                              1529
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RC01518 DS    0H                                                  1530
         BR REG10
*TSTPLHFD:                                                         1531
*                                                                  1531
*   /*****************************************************************/
*   /*                                                               */
*   /* POINTS TO PLHDHR AND TESTS FIELDS FROM IT.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1531
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
TSTPLHFD LR    REG0,REG10                                          1531
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBPH;                  /* SET BLOCK PTR                 */
*                                                                  1533
         L     RBLKPTR,AMBPH(,RBLKPTR)                             1533
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FIELD                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1534
*   GEN FLOWS(TSTFIELD)(BAL REG10,DSPFIELD);                       1534
         BAL REG10,DSPFIELD
*   REG10=REG0;                     /* LOAD RETURN ADDRESS           */
         LR    REG10,REG0                                          1535
*   RBLKPTR=TESTBLAD;               /* RESET RBLKPTR                 */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1536
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*MODOPTBT:                                                         1538
*                                                                  1538
*   /*****************************************************************/
*   /*                                                               */
*   /* SPECIAL ROUTINE FOR MODCB FOR KEYWORD OPTCD. CALLS BITSET 3   */
*   /* TIMES FOR 90 BITS.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1538
*   IF ELEMBLEN=ZERO                /* SECOND WORD PRESENT           */
*       |VTAMSW=OFF THEN            /* OR VTAM                       */
MODOPTBT LH    @09,ELEMBLEN(,RELEMPTR)                             1538
         LTR   @09,@09                                             1538
         BZ    @RT01538                                            1538
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       1538
         BZ    @RT01538                                            1538
*     GO TO MODBITST;               /* NO, SO PROCESS NORMALLY       */
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
         LR    REG0,REG10                                          1540
*   GEN FLOWS(MODBITST)(BAL REG10,MODBITST);/* INITIAL CALL TO BITSET
*                                      BUT PICKING UP REGISTERS FIRST*/
         BAL REG10,MODBITST
*   RESPECIFY                                                      1542
*     REG9 RSTD;                                                   1542
*   RELEMPTR=PLEMPTR;               /* RELOAD ELEMPTR                */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           1543
*   REG9=ELEMXFLG;                  /* RELOAD BITS                   */
         L     REG9,ELEMXFLG(,RELEMPTR)                            1544
*   IF REG9^=ZERO THEN              /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1545
         BZ    @RF01545                                            1545
*     DO;                           /* PROCESS SECOND WORD           */
*       RESPECIFY                                                  1547
*        (REG5,                                                    1547
*         REG6,                                                    1547
*         REG7,                                                    1547
*         REG8) RSTD;                                              1547
*       LM(REG5,REG8,OPTBIT02);     /* RELOAD REGISTERS              */
         LM    REG5,REG8,OPTBIT02                                  1548
*       REG8=REG9&REG8;             /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1549
*       BC(8,OK2NDWRD);             /* EXIT IF TOO MANY BITS         */
         BC    8,OK2NDWRD                                          1550
*       REG0=BITEXER;               /* SET ERROR CODE                */
         LA    REG0,14                                             1551
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1552
*OK2NDWRD:                          /* CONTINUE PROCESSING           */
*       GEN FLOWS(BITSET)(BAL REG10,BITSET);/* CALL BIT SET SECOND 1553
*                                      TIME                          */
OK2NDWRD BAL REG10,BITSET
*       RESPECIFY                                                  1554
*        (REG5,                                                    1554
*         REG6,                                                    1554
*         REG7,                                                    1554
*         REG8) UNRSTD;                                            1554
*       RELEMPTR=PLEMPTR;           /* LOAD ELEMPTR                  */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           1555
*     END;                                                         1556
*   REG10=REG0;                     /* RELOAD RETURN REGISTER        */
@RF01545 LR    REG10,REG0                                          1557
*   IF ELEMBLEN=ONE THEN            /* THIRD WORD PRESENT            */
         CLC   ELEMBLEN(2,RELEMPTR),@CH00081                       1558
         BNE   @RF01558                                            1558
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   RELEMPTR=RELEMPTR+FWORDL;       /* STEP TO THIRD WORD OF BITS    */
@RF01558 AL    RELEMPTR,@CF00256                                   1560
*   REG9=ELEMXFLG;                  /* PICK UP LAST OF BITS          */
         L     REG9,ELEMXFLG(,RELEMPTR)                            1561
*   IF REG9=ZERO THEN               /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1562
         BNZ   @RF01562                                            1562
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1564
*    (REG5,                                                        1564
*     REG6,                                                        1564
*     REG7,                                                        1564
*     REG8) RSTD;                                                  1564
@RF01562 DS    0H                                                  1565
*   LM(REG5,REG8,OPTBIT03);         /* RELOAD REGISTERS              */
         LM    REG5,REG8,OPTBIT03                                  1565
*   REG8=REG9&REG8;                 /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1566
*   BC(8,BITSET);                   /* GO MOD LAST BITS IF OK        */
         BC    8,BITSET                                            1567
*   REG0=BITEXER;                   /* SET ERROR CODE                */
         LA    REG0,14                                             1568
*   GO TO EXITBAD;                  /* EXIT WITH ERROR               */
         B     EXITBAD                                             1569
*   RESPECIFY                                                      1570
*    (REG5,                                                        1570
*     REG6,                                                        1570
*     REG7,                                                        1570
*     REG8,                                                        1570
*     REG9) UNRSTD;                                                1570
*TSTOPTBT:                                                         1571
*                                                                  1571
*   /*****************************************************************/
*   /*                                                               */
*   /* SPECIAL ROUTINE FOR TESTCB FOR KEYWORD OPTCD. CALLS TSTBIT 3  */
*   /* TIMES FOR 90 BITS.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1571
*   IF ELEMBLEN=ZERO                /* SECOND WORD PRESENT           */
*       |VTAMSW=OFF THEN            /* VTAM                          */
TSTOPTBT LH    @05,ELEMBLEN(,RELEMPTR)                             1571
         LTR   @05,@05                                             1571
         BZ    @RT01571                                            1571
         TM    VTAMSW+1(RHDRPTR),B'00010000'                       1571
         BZ    @RT01571                                            1571
*     GO TO TSTBITST;               /* NO, PROCESS NORMALLY          */
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
         LR    REG0,REG10                                          1573
*   GEN FLOWS(TSTBITST)(BAL REG10,TSTBITST);/* INITIAL CALL TO BITSET
*                                      BUT PICKING UP REGISTERS FIRST*/
         BAL REG10,TSTBITST
*   RESPECIFY                                                      1575
*     REG9 RSTD;                                                   1575
*   RELEMPTR=PLEMPTR;               /* RELOAD ELEMPTR                */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           1576
*   REG9=ELEMXFLG;                  /* RELOAD BITS                   */
         L     REG9,ELEMXFLG(,RELEMPTR)                            1577
*   IF REG9^=ZERO THEN              /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1578
         BZ    @RF01578                                            1578
*     DO;                           /* PROCESS SECOND WORD           */
*       RESPECIFY                                                  1580
*        (REG5,                                                    1580
*         REG6,                                                    1580
*         REG7,                                                    1580
*         REG8) RSTD;                                              1580
*       LM(REG5,REG8,OPTBIT02);     /* RELOAD REGISTERS              */
         LM    REG5,REG8,OPTBIT02                                  1581
*       REG8=REG9&REG8;             /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1582
*       BC(8,TOK2WRD);              /* EXIT IF TO MANY BITS          */
         BC    8,TOK2WRD                                           1583
*       REG0=BITEXER;               /* SET ERROR CODE                */
         LA    REG0,14                                             1584
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1585
*TOK2WRD:                           /* CONTINUE IF NOT TO MANY BITS  */
*       GEN FLOWS(TSTBIT)(BAL REG10,TSTBIT);/* CALL TSTBIT SECOND  1586
*                                      TIME                          */
TOK2WRD  BAL REG10,TSTBIT
*       RESPECIFY                                                  1587
*        (REG5,                                                    1587
*         REG6,                                                    1587
*         REG7,                                                    1587
*         REG8) UNRSTD;                                            1587
*       RELEMPTR=PLEMPTR;           /* RELOAD ELEMPTR                */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           1588
*     END;                                                         1589
*   REG10=REG0;                     /* RELOAD RETURN REGISTER        */
@RF01578 LR    REG10,REG0                                          1590
*   IF ELEMBLEN=ONE THEN            /* THIRD WORD PRESENT            */
         CLC   ELEMBLEN(2,RELEMPTR),@CH00081                       1591
         BNE   @RF01591                                            1591
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   RELEMPTR=RELEMPTR+FWORDL;       /* STEP THIRD WORD OF BITS       */
@RF01591 AL    RELEMPTR,@CF00256                                   1593
*   REG9=ELEMXFLG;                  /* PICK UP LAST OF BITS          */
         L     REG9,ELEMXFLG(,RELEMPTR)                            1594
*   IF REG9=ZERO THEN               /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1595
         BNZ   @RF01595                                            1595
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1597
*    (REG5,                                                        1597
*     REG6,                                                        1597
*     REG7,                                                        1597
*     REG8) RSTD;                                                  1597
@RF01595 DS    0H                                                  1598
*   LM(REG5,REG8,OPTBIT03);         /* RELOAD REGISTERS              */
         LM    REG5,REG8,OPTBIT03                                  1598
*   REG8=REG9&REG8;                 /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1599
*   BC(8,TSTBIT);                   /* GO TEST LAST BITS             */
         BC    8,TSTBIT                                            1600
*   REG0=BITEXER;                   /* SET ERROR CODE                */
         LA    REG0,14                                             1601
*   GO TO EXITBAD;                  /* EXIT WITH ERROR               */
         B     EXITBAD                                             1602
*   RESPECIFY                                                      1603
*    (REG5,                                                        1603
*     REG6,                                                        1603
*     REG7,                                                        1603
*     REG8,                                                        1603
*     REG9) UNRSTD;                                                1603
*MODPROCB:                                                         1604
*                                                                  1604
*   /*****************************************************************/
*   /*                                                               */
*   /* SPECIAL ROUTINE FOR MODCB FOR KEYWORD PROC. CALLS BITSET 2    */
*   /* TIMES FOR 34 BITS.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1604
*   IF ELEMBLEN=ZERO THEN           /* SECOND WORD PRESENT           */
MODPROCB LH    @05,ELEMBLEN(,RELEMPTR)                             1604
         LTR   @05,@05                                             1604
         BZ    @RT01604                                            1604
*     GO TO MODBITST;               /* NO, PROCESS NORMALLY          */
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
         LR    REG0,REG10                                          1606
*   GEN FLOWS(MODBITST)(BAL REG10,MODBITST);/* INITIAL CALL TO BITSET
*                                      BUT PICKING UP REGISTERS FIRST*/
         BAL REG10,MODBITST
*   RESPECIFY                                                      1608
*    (REG5,                                                        1608
*     REG6,                                                        1608
*     REG7,                                                        1608
*     REG8,                                                        1608
*     REG9) RSTD;                                                  1608
*   RELEMPTR=PLEMPTR;               /* RELOAD ELEMENT PTR            */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           1609
*   REG9=ELEMXFLG;                  /* PICK UP LAST OF BITS          */
         L     REG9,ELEMXFLG(,RELEMPTR)                            1610
*   REG10=REG0;                     /* NOT COMING BACK               */
         LR    REG10,REG0                                          1611
*   IF REG9=ZERO THEN               /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1612
         BNZ   @RF01612                                            1612
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   LM(REG5,REG8,PROBIT02);         /* RELOAD REGISTERS              */
@RF01612 LM    REG5,REG8,PROBIT02                                  1614
*   REG8=REG9&REG8;                 /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1615
*   BC(8,BITSET);                   /* GO MOD LAST BITS              */
         BC    8,BITSET                                            1616
*   REG0=BITEXER;                   /* SET ERROR CODE                */
         LA    REG0,14                                             1617
*   GO TO EXITBAD;                  /* EXIT WITH ERROR               */
         B     EXITBAD                                             1618
*   RESPECIFY                                                      1619
*    (REG5,                                                        1619
*     REG6,                                                        1619
*     REG7,                                                        1619
*     REG8,                                                        1619
*     REG9) UNRSTD;                                                1619
*TSTPROCB:                                                         1620
*                                                                  1620
*   /*****************************************************************/
*   /*                                                               */
*   /* SPECIAL ROUTINE FOR TESTCB FOR KEYWORD PROC. CALLS TSTBIT 2   */
*   /* TIMES FOR 34 BITS.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1620
*   IF ELEMBLEN=ZERO THEN           /* SECOND WORD PRESENT           */
TSTPROCB LH    @05,ELEMBLEN(,RELEMPTR)                             1620
         LTR   @05,@05                                             1620
         BZ    @RT01620                                            1620
*     GO TO TSTBITST;               /* NO, PROCESS NORMALLY          */
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
         LR    REG0,REG10                                          1622
*   GEN FLOWS(TSTBITST)(BAL REG10,TSTBITST);/* INITIAL CALL TO BITSET
*                                      BUT PICKING UP REGISTERS FIRST*/
         BAL REG10,TSTBITST
*   RESPECIFY                                                      1624
*    (REG5,                                                        1624
*     REG6,                                                        1624
*     REG7,                                                        1624
*     REG8,                                                        1624
*     REG9) RSTD;                                                  1624
*   RELEMPTR=PLEMPTR;               /* RELOAD ELEMENT PTR            */
         L     RELEMPTR,PLEMPTR(,PLEPTR)                           1625
*   REG9=ELEMXFLG;                  /* PICK UP LAST OF BITS          */
         L     REG9,ELEMXFLG(,RELEMPTR)                            1626
*   REG10=REG0;                     /* NOT COMING BACK               */
         LR    REG10,REG0                                          1627
*   IF REG9=ZERO THEN               /* ANY BITS ON                   */
         LTR   REG9,REG9                                           1628
         BNZ   @RF01628                                            1628
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   LM(REG5,REG8,PROBIT02);         /* RELOAD REGISTERS              */
@RF01628 LM    REG5,REG8,PROBIT02                                  1630
*   REG8=REG9&REG8;                 /* CHECK FOR EXTRA BITS          */
         NR    REG8,REG9                                           1631
*   BC(8,TSTBIT);                   /* GO TEST LAST BITS             */
         BC    8,TSTBIT                                            1632
*   REG0=BITEXER;                   /* SET ERROR CODE                */
         LA    REG0,14                                             1633
*   GO TO EXITBAD;                  /* EXIT WITH ERROR               */
         B     EXITBAD                                             1634
*   RESPECIFY                                                      1635
*    (REG5,                                                        1635
*     REG6,                                                        1635
*     REG7,                                                        1635
*     REG8,                                                        1635
*     REG9) UNRSTD;                                                1635
*MODVTEXL:                                                         1636
*                                                                  1636
*   /*****************************************************************/
*   /*                                                               */
*   /* TESTS VTAM SW FOR EXLST (GENCB&MODCB)                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1636
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
MODVTEXL TM    VTAMSW+1(RHDRPTR),B'00010000'                       1636
         BNZ   @RF01636                                            1636
*     DO;                           /* PROCCESS ERROR                */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1638
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1639
*     END;                                                         1640
*MODEXLKW:                                                         1641
*                                                                  1641
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS AS REQUIRED BY USER                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1641
*   RESPECIFY                                                      1641
*     REG5 RSTD;                                                   1641
@RF01636 DS    0H                                                  1641
MODEXLKW DS    0H                                                  1642
*   REG5=ZERO;                      /* ZERO WORK REGISTER            */
         SLR   REG5,REG5                                           1642
*   GEN REFS(FLDOFF)(IC REG5,FLDOFF(REG11));/* PICK UP OFFSET INTO 1643
*                                      BLOCK                         */
         IC REG5,FLDOFF(REG11)
*   IF REG5=>EXLLEN THEN            /* EXLST LONG ENOUGTH            */
         CH    REG5,EXLLEN(,RBLKPTR)                               1644
         BL    @RF01644                                            1644
*     DO;                           /* PROCESS ERROR                 */
*       REG0=EXLTOSHT;              /* SET REASON CODE               */
         LA    REG0,7                                              1646
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1647
*     END;                                                         1648
*   REG5=RBLKPTR+REG5;              /* SET BLOCK PLUS OFFSET         */
@RF01644 ALR   REG5,RBLKPTR                                        1649
*   IF ELEMXFLG(4)=ON THEN          /* EXIT ADDRESS SUPPLIED         */
         TM    ELEMXFLG(RELEMPTR),B'00010000'                      1650
         BNO   @RF01650                                            1650
*     REG5->EXLEXITP=ELEMPTR;       /* MOVE POINTER                  */
         MVC   EXLEXITP(4,REG5),ELEMPTR(RELEMPTR)                  1651
*   ELSE                            /* NOEXIT ADDRESS SUPPLIED       */
*     IF(ELEMXFLG(1)=OFF&           /* A OFF                         */
*         ELEMXFLG(2)=OFF)|         /* N OFF                         */
*         ELEMXFLG(3)=ON THEN       /* LINK SPECIFIED                */
         B     @RC01650                                            1652
@RF01650 TM    ELEMXFLG(RELEMPTR),B'11000000'                      1652
         BZ    @RT01652                                            1652
         TM    ELEMXFLG(RELEMPTR),B'00100000'                      1652
         BNO   @RF01652                                            1652
@RT01652 DS    0H                                                  1653
*       DO;                         /* PROCESS ERROR                 */
*         REG0=NOEXITAD;            /* SET REASON CODE               */
         LA    REG0,10                                             1654
*         GO TO EXITBAD;            /* EXIT WITH ERROR               */
         B     EXITBAD                                             1655
*       END;                                                       1656
*   IF ELEMKWTC>SYNADKW THEN        /* NOT EODAD,JRNAD,LERAD OR SYNAD*/
@RF01652 DS    0H                                                  1657
@RC01650 LH    @09,ELEMKWTC(,RELEMPTR)                             1657
         C     @09,@CF02056                                        1657
         BNH   @RF01657                                            1657
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   IF ELEMXFLG(1)=ON&              /* ACTIVATE ON                   */
*       REG5->EXLEXITP=ZERO THEN    /* VALID ADDRESS                 */
@RF01657 TM    ELEMXFLG(RELEMPTR),B'10000000'                      1659
         BNO   @RF01659                                            1659
         ICM   @09,15,EXLEXITP(REG5)                               1659
         BNZ   @RF01659                                            1659
*     DO;                           /* PROCESS ERROR                 */
*       REG0=NOEXADAT;              /* SET REASON CODE               */
         LA    REG0,13                                             1661
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1662
*     END;                                                         1663
*   ELSE                            /* ADDRESS GOOD                  */
*     REG5->EXLACTM=ON;             /* SET ACTIVE FLAG               */
@RF01659 OI    EXLACTM(REG5),B'01000000'                           1664
*   IF ELEMXFLG(2)=ON THEN          /* INACTIVATE ON                 */
         TM    ELEMXFLG(RELEMPTR),B'01000000'                      1665
         BNO   @RF01665                                            1665
*     REG5->EXLACTM=OFF;            /* SET FLAG OFF                  */
         NI    EXLACTM(REG5),B'10111111'                           1666
*   IF ELEMXFLG(3)=ON THEN          /* LINK SPECIFIED                */
@RF01665 TM    ELEMXFLG(RELEMPTR),B'00100000'                      1667
         BNO   @RF01667                                            1667
*     REG5->EXLLNK=ON;              /* SET LINK FLAG                 */
         OI    EXLLNK(REG5),B'00100000'                            1668
*   RESPECIFY                                                      1669
*     REG5 UNRSTD;                                                 1669
@RF01667 DS    0H                                                  1670
*   GEN(BR REG10);                  /* RETURN AND PROCESS            */
         BR REG10
*MODVTELN:                                                         1671
*                                                                  1671
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR VTAM FIRST                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1671
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
MODVTELN TM    VTAMSW+1(RHDRPTR),B'00010000'                       1671
         BNZ   @RF01671                                            1671
*     DO;                           /* NO, ERROR                     */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1673
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1674
*     END;                                                         1675
*MODEXLEN:                                                         1676
*                                                                  1676
*   /*****************************************************************/
*   /*                                                               */
*   /* SETS EXLLEN FOR MODCB                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1676
*   EXLLEN=USERHWRD;                /* SET LENGTH                    */
@RF01671 DS    0H                                                  1676
MODEXLEN MVC   EXLLEN(2,RBLKPTR),USERHWRD+4(RELEMPTR)              1676
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*GEXLVTOF:                                                         1678
*                                                                  1678
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR VTAM FIRST                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1678
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
GEXLVTOF TM    VTAMSW+1(RHDRPTR),B'00010000'                       1678
         BNZ   @RF01678                                            1678
*     DO;                           /* PROCESS ERROR                 */
*       REG0=VTAMONLY;              /* LOAD ERROR CODE               */
         LA    REG0,16                                             1680
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1681
*     END;                                                         1682
*GEXLKWOF:                                                         1683
*                                                                  1683
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE IS USED BY GENEXLST TO FIND LARGEST OFFSET AMONG      */
*   /* KEYWORDS                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1683
*   RESPECIFY                                                      1683
*    (REG5,                                                        1683
*     REG8) RSTD;                                                  1683
@RF01678 DS    0H                                                  1683
GEXLKWOF DS    0H                                                  1684
*   GEN(IC REG8,FLDOFF(REG11))                                     1684
*   REFS(FLDOFF);                   /* LOAD ADDRESS OFF KEYWORD    1684
*                                      ROUTINE                       */
         IC REG8,FLDOFF(REG11)
*   IF REG5<REG8 THEN               /* KEEP LARGER OFFSET            */
         CR    REG5,REG8                                           1685
         BNL   @RF01685                                            1685
*     REG5=REG8;                    /* NEW ONE IS LARGER             */
         LR    REG5,REG8                                           1686
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01685 DS    0H                                                  1687
         BR REG10
*   RESPECIFY                                                      1688
*    (REG5,                                                        1688
*     REG8) UNRSTD;                                                1688
*GEXLKWAC:                                                         1689
*                                                                  1689
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS EXLST KEYWORDS FOR GENCB                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1689
*   RESPECIFY                                                      1689
*    (REG5,                                                        1689
*     REG8) RSTD;                                                  1689
GEXLKWAC DS    0H                                                  1690
*   GEN REFS(FLDOFF)(IC REG8,FLDOFF(REG11));/* PICK UP OFFSET        */
         IC REG8,FLDOFF(REG11)
*   REG5=RBLKPTR+REG8;              /* SET POINTER TO ENTRY          */
         LR    REG5,RBLKPTR                                        1691
         ALR   REG5,REG8                                           1691
*   IF ELEMPTR=ZERO THEN            /* POINTER SUPPLIED              */
         L     @09,ELEMPTR(,RELEMPTR)                              1692
         LTR   @09,@09                                             1692
         BNZ   @RF01692                                            1692
*     DO;                           /* NO PROCESS ERROR              */
*       REG0=NOEXITAD;              /* SET REASON CODE               */
         LA    REG0,10                                             1694
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1695
*     END;                                                         1696
*   REG5->EXLEXITP=ELEMPTR;         /* MOVE POINTER                  */
@RF01692 MVC   EXLEXITP(4,REG5),ELEMPTR(RELEMPTR)                  1697
*   REG5->EXLSPEC=ON;               /* MARK ACTIVE ENTRIES           */
         OI    EXLSPEC(REG5),B'10000000'                           1698
*   IF ELEMKWTC>SYNADKW THEN        /* NOT EODAD,JRNAD,LERAD OR SYNAD*/
         LH    @09,ELEMKWTC(,RELEMPTR)                             1699
         C     @09,@CF02056                                        1699
         BNH   @RF01699                                            1699
*     GEN(BR REG10);                /* RETURN TO CALLER              */
         BR REG10
*   IF ELEMXFLG(2)=OFF THEN         /* INACTIVATE OFF                */
@RF01699 TM    ELEMXFLG(RELEMPTR),B'01000000'                      1701
         BNZ   @RF01701                                            1701
*     REG5->EXLACTM=ON;             /* SET ACTIVATE FLAG             */
         OI    EXLACTM(REG5),B'01000000'                           1702
*   IF ELEMXFLG(3)=ON THEN          /* LINK SPECIFIED                */
@RF01701 TM    ELEMXFLG(RELEMPTR),B'00100000'                      1703
         BNO   @RF01703                                            1703
*     REG5->EXLLNK=ON;              /* SET LINK FLAG                 */
         OI    EXLLNK(REG5),B'00100000'                            1704
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RF01703 DS    0H                                                  1705
         BR REG10
*   RESPECIFY                                                      1706
*    (REG5,                                                        1706
*     REG8) UNRSTD;                                                1706
*MODARG:                                                           1707
*                                                                  1707
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE PROCESSES SPECIAL ARG KEYWORD                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1707
*   RPLARG=USERWORD;                /* SET FIELD TO USER VALUE       */
MODARG   MVC   RPLARG(4,RBLKPTR),USERWORD+4(RELEMPTR)              1707
*   RPLNIB=OFF;                     /* SET NIB FLAG TO ARG           */
         NI    RPLNIB(RBLKPTR),B'11111011'                         1708
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*MODNIB:                                                           1710
*                                                                  1710
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE PROCESSES NIB KEYWORD                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1710
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
MODNIB   TM    VTAMSW+1(RHDRPTR),B'00010000'                       1710
         BNZ   @RF01710                                            1710
*     DO;                           /* PROCESS ERROR                 */
*       REG0=VTAMONLY;              /* SET ERROR CODE                */
         LA    REG0,16                                             1712
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1713
*     END;                                                         1714
*   RPLARG=USERWORD;                /* SET FIELD TO USER VALUE       */
@RF01710 MVC   RPLARG(4,RBLKPTR),USERWORD+4(RELEMPTR)              1715
*   RPLNIB=ON;                      /* INDICATE NIB NOT ARG          */
         OI    RPLNIB(RBLKPTR),B'00000100'                         1716
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*                                                                  1718
*   /*****************************************************************/
*   /*                                                               */
*   /* DISPLAY DDNAME                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1718
*DSPDDNM:                                                          1718
*   RESPECIFY                                                      1718
*     REG8 RSTD;                                                   1718
DSPDDNM  DS    0H                                                  1719
*   IF ACBOPEN=NO THEN              /* ACB OPEN                      */
         TM    ACBOPEN(RBLKPTR),B'00010000'                        1719
         BZ    @RT01719                                            1719
*     GO TO DSPFIELD;               /* DISPLAY FIELD FROM ACB        */
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
         LR    REG0,REG10                                          1721
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   GEN FLOWS(PTTIOT)(BAL REG10,PTTIOT);/* POINT TO TIOT             */
         BAL REG10,PTTIOT
*   GEN(IC REG8,FLDOFF(REG11));     /* SET OFFSET OF ACBDDNM @ZA10005*/
         IC REG8,FLDOFF(REG11)
*   RBLKPTR=RBLKPTR-REG8;           /* BACK UP SO DSPFIELD WORKS     */
         SLR   RBLKPTR,REG8                                        1725
*   GEN FLOWS(DSPFIELD)(BAL REG10,DSPFIELD);/* DISPLAY FIELD         */
         BAL REG10,DSPFIELD
*   RESPECIFY                                                      1727
*     REG8 UNRSTD;                                                 1727
*   RBLKPTR=SHOWBLAD;               /* RESET BLOCK PTR               */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          1728
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1729
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*                                                                  1731
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST DDNAME                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1731
*TSTDDNM:                                                          1731
*   RESPECIFY                                                      1731
*     REG8 RSTD;                                                   1731
TSTDDNM  DS    0H                                                  1732
*   IF ACBOPEN=NO THEN              /* ACB OPEN                      */
         TM    ACBOPEN(RBLKPTR),B'00010000'                        1732
         BZ    @RT01732                                            1732
*     GO TO TSTFIELD;               /* TEST FIELD FROM ACB           */
*   REG0=REG10;                     /* SAVE RETURN ADDRESS           */
         LR    REG0,REG10                                          1734
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   GEN FLOWS(PTTIOT)(BAL REG10,PTTIOT);/* POINT TO TIOT             */
         BAL REG10,PTTIOT
*   GEN(IC REG8,FLDOFF(REG11));     /* SET OFFSET OF ACBDDNM @ZA10005*/
         IC REG8,FLDOFF(REG11)
*   RBLKPTR=RBLKPTR-REG8;           /* BACK UP SO TSTFIELD WORKS     */
         SLR   RBLKPTR,REG8                                        1738
*   GEN FLOWS(TSTFIELD)(BAL REG10,TSTFIELD);/* TEST FIELD            */
         BAL REG10,TSTFIELD
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1740
*   RBLKPTR=TESTBLAD;               /* RESET BLOCK PTR               */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1741
*   RESPECIFY                                                      1742
*     REG8 UNRSTD;                                                 1742
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*DSPRKPF:                                                          1744
*                                                                  1744
*   /*****************************************************************/
*   /*                                                               */
*   /* DISPLAY RELATIVE KEY POSITION                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1744
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
DSPRKPF  LR    REG0,REG10                                          1744
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* SET POINTER TO AMDSB          */
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1746
*   RESPECIFY                                                      1747
*     REG5 RSTD;                                                   1747
*   IF MODBLAD->ACBAMBL->AMBLPATH=ON THEN/* PATH                     */
*                                                                  1748
         L     @09,MODBLAD(,RHDRPTR)                               1748
         L     @09,ACBAMBL(,@09)                                   1748
         TM    AMBLPATH(@09),B'10000000'                           1748
         BNO   @RF01748                                            1748
*     /***************************************************************/
*     /*                                                             */
*     /* GET ADDRESS OF AMDAXRKP                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1749
*     DO;                                                          1749
*       REG5=ADDR(AMDRKP)-ADDR(AMDAXRKP);/* SET ADDRESS OF RKP       */
         LA    REG5,2                                              1750
*       RBLKPTR=RBLKPTR-REG5;       /* BACK UP REQUIRED BYTES        */
         SLR   RBLKPTR,REG5                                        1751
*     END;                                                         1752
*   RESPECIFY                                                      1753
*     REG5 UNRSTD;                                                 1753
*                                                                  1753
@RF01748 DS    0H                                                  1754
*   /*****************************************************************/
*   /*                                                               */
*   /* DISPLAY REQUESTED FIELD                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1754
*   GEN(BAL REG10,DSPFIELD)                                        1754
*   FLOWS(DSPFIELD);                                               1754
         BAL REG10,DSPFIELD
*   RBLKPTR=SHOWBLAD;               /* RELOAD BLOCK PTR              */
         L     RBLKPTR,SHOWBLAD(,RHDRPTR)                          1755
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1756
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*TSTRKPF:                                                          1758
*                                                                  1758
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE TESTS RELATIVE KEY POSTION                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1758
*   REG0=REG10;                     /* SAVE RETURN ADDR              */
TSTRKPF  LR    REG0,REG10                                          1758
*   GEN FLOWS(PTAMB)(BAL REG10,PTAMB);/* POINT TO AMB                */
         BAL REG10,PTAMB
*   RBLKPTR=AMBDSB;                 /* SET POINTER TO AMDSB          */
         L     RBLKPTR,AMBDSB(,RBLKPTR)                            1760
*   RESPECIFY                                                      1761
*     REG5 RSTD;                                                   1761
*   IF MODBLAD->ACBAMBL->AMBLPATH=ON THEN/* PATH                     */
*                                                                  1762
         L     @09,MODBLAD(,RHDRPTR)                               1762
         L     @09,ACBAMBL(,@09)                                   1762
         TM    AMBLPATH(@09),B'10000000'                           1762
         BNO   @RF01762                                            1762
*     /***************************************************************/
*     /*                                                             */
*     /* GET ADDRESS OF AMDAXRKP                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1763
*     DO;                                                          1763
*       REG5=ADDR(AMDRKP)-ADDR(AMDAXRKP);/* SET ADDRESS OF RKP       */
         LA    REG5,2                                              1764
*       RBLKPTR=RBLKPTR-REG5;       /* BACK UP REQUIRED BYTES        */
         SLR   RBLKPTR,REG5                                        1765
*     END;                                                         1766
*   RESPECIFY                                                      1767
*     REG5 UNRSTD;                                                 1767
*                                                                  1767
@RF01762 DS    0H                                                  1768
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST REQUESTED FIELD                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1768
*   GEN(BAL REG10,TSTFIELD)                                        1768
*   FLOWS(TSTFIELD);                                               1768
         BAL REG10,TSTFIELD
*   RBLKPTR=TESTBLAD;               /* RELOAD BLOCK PTR              */
         L     RBLKPTR,TESTBLAD(,RHDRPTR)                          1769
*   REG10=REG0;                     /* RELOAD RETURN ADDRESS         */
         LR    REG10,REG0                                          1770
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*PTTIOT:                                                           1772
*                                                                  1772
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE POINTS TO TIOT ENTRY                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1772
*   RBLKPTR=ADDR(TIOEDDNM);         /* SET ADDRESS OF TIOT ENTRY     */
PTTIOT   L     @05,AMBDEBPT(,RBLKPTR)                              1772
         L     @05,DEBTCBAD(,@05)                                  1772
         L     @09,SHOWBLAD(,RHDRPTR)                              1772
         LH    @09,ACBTIOT(,@09)                                   1772
         AL    @09,TCBTIO(,@05)                                    1772
         LA    @05,TIOEDDNM(,@09)                                  1772
         LR    RBLKPTR,@05                                         1772
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
         BR REG10
*                                                                  1774
*   /*****************************************************************/
*   /*                                                               */
*   /* PTAMB- POINT TO IDAAMB. ROUTINE LOADS RBLKPTR WITH THE ADDRESS*/
*   /* OF THE AMB. AT ENTRY TO THIS ROUTINE REGISTER 10 CONTAINS THE */
*   /* RETURN ADDRESS AND RBLKPTR CONTAINS THE ADDRESS OF THE ACB    */
*   /* SUPPLIED BY THE USER. THE ACB MUST BE OPEN OR AN ERROR IS     */
*   /* RETURNED TO THE USER. RETURN TO THE CALLER OF THIS ROUTINE IS */
*   /* VIA A BRANCH REGISTER 10. THIS ROUTINE IS EXERCISED ONLY FOR  */
*   /* SHOWCB/TESTCB FOR AN ACB.                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1774
*PTAMB:                                                            1774
*   IF ACBOPEN=NO THEN              /* ACB OPEN                      */
PTAMB    TM    ACBOPEN(RBLKPTR),B'00010000'                        1774
         BNZ   @RF01774                                            1774
*     DO;                           /* PROCESS ERROR CONDITION       */
*       REG0=ACBNTOPN;              /* SET REASON CODE               */
         LA    REG0,5                                              1776
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1777
*     END;                                                         1778
*   RBLKPTR=ACBAMBL;                /* POINT TO AMBL                 */
*                                                                  1779
@RF01774 L     RBLKPTR,ACBAMBL(,RBLKPTR)                           1779
*   /*****************************************************************/
*   /*                                                               */
*   /* DUMMY ACB                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1780
*   IF AMBLDUMY=ON THEN             /* DUMMY ACB                     */
         TM    AMBLDUMY(RBLKPTR),B'00000001'                       1780
         BNO   @RF01780                                            1780
*     DO;                           /* PROCESS ERROR CONDITION       */
*       REG0=DUMYDSET;              /* SET REASON CODE               */
         LA    REG0,21                                             1782
*       GO TO EXITBAD;              /* EXIT WITH ERROR               */
         B     EXITBAD                                             1783
*     END;                                                         1784
*                                                                  1784
*   /*****************************************************************/
*   /*                                                               */
*   /* PATH                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1785
*   IF AMBLPATH=YES THEN            /* PATH ENTRY                    */
@RF01780 TM    AMBLPATH(RBLKPTR),B'10000000'                       1785
         BNO   @RF01785                                            1785
*     IF^(ELEMKWTC=16|ELEMKWTC=31   /*                       @ZA10846*/
*                                                                  1786
*     /***************************************************************/
*     /*                                                             */
*     /* NOT KEYLEN OR RKP                                   @ZA10846*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1786
*         |(ELEMKWTC=1&ELEMBSTR='01000000'X)) THEN                 1786
*                                                                  1786
         LH    @05,ELEMKWTC(,RELEMPTR)                             1786
         C     @05,@CF00097                                        1786
         BE    @RF01786                                            1786
         C     @05,@CF00039                                        1786
         BE    @RF01786                                            1786
         C     @05,@CF00081                                        1786
         BNE   @RT01786                                            1786
         CLC   ELEMBSTR(4,RELEMPTR),@CB03619                       1786
         BE    @RF01786                                            1786
@RT01786 DS    0H                                                  1787
*       /*************************************************************/
*       /*                                                           */
*       /* NOT UNIQUE ATTRIBUTE                              @ZA10576*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1787
*       RBLKPTR=AMBLXPT;            /* POINT TO BASE AMBL            */
         L     RBLKPTR,AMBLXPT(,RBLKPTR)                           1787
*   IF SHOWOBJ=INDEX THEN           /* INDEX                         */
@RF01786 DS    0H                                                  1788
@RF01785 CLC   SHOWOBJ(2,RHDRPTR),@CH00081                         1788
         BNE   @RF01788                                            1788
*     DO;                           /* PROCESS INDEX         @XM08933*/
*       RBLKPTR=AMBLIX;             /* POINT TO AMB                  */
         L     RBLKPTR,AMBLIX(,RBLKPTR)                            1790
*       IF RBLKPTR=ZERO THEN        /* IS INDEX PRESENT      @XM08933*/
         LTR   RBLKPTR,RBLKPTR                                     1791
         BNZ   @RF01791                                            1791
*         DO;                       /* PROCESS ERROR CONDITION     1792
*                                                            @XM08933*/
*           REG0=NOINDEX;           /* LOAD ERROR CODE FOR NO INDEX
*                                                            @XM08933*/
         LA    REG0,6                                              1793
*           GO TO EXITBAD;          /* EXIT WITH ERROR CONDITION   1794
*                                                            @XM08933*/
         B     EXITBAD                                             1794
*         END;                      /* END OF ERROR PATH     @XM08933*/
*     END;                          /* END OF INDEX PATH     @XM08933*/
*   ELSE                            /* DATA                          */
*     RBLKPTR=AMBLDTA;              /* POINT TO AMB                  */
         B     @RC01788                                            1797
@RF01788 L     RBLKPTR,AMBLDTA(,RBLKPTR)                           1797
*   GEN(BR REG10);                  /* RETURN TO CALLER              */
@RC01788 DS    0H                                                  1798
         BR REG10
*                                                                  1799
*   /*****************************************************************/
*   /*                                                               */
*   /* FNDHRBA-POINT TO THE IDAARDB WITH THE HIGHEST USED RBA.       */
*   /* ROUTINE LOADS RBLKPTR WITH THE ADDRESS OF THE ARDB WITH HIGH  */
*   /* USED RBA. AT ENTRY TO THIS ROUTINE REGISTER 10 CONTAINS THE   */
*   /* RETURN ADDRESS AND RBLKPTR POINTS TO THE AMDSB. CONTROL IS    */
*   /* RETURNED TO THE CALLER VIA A BRANCH REGISTER 10. ROUTINE IS   */
*   /* ONLY EXERCISED FOR SHOWCB/TESTCB FOR AN ACB.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1799
*FNDHRBA:                                                          1799
*   RESPECIFY                                                      1799
*    (REG5) RSTD;                                                  1799
FNDHRBA  DS    0H                                                  1800
*   REG5=AMDPARDB;                  /* POINT TO FIRST ARDB           */
         L     REG5,AMDPARDB(,RBLKPTR)                             1800
*   RBLKPTR=REG5;                   /* SET BOTH EQUAL                */
         LR    RBLKPTR,REG5                                        1801
*   DO WHILE(REG5^=ZERO);           /* LOOP THRU CHAIN               */
         B     @DE01802                                            1802
@DL01802 DS    0H                                                  1803
*     IF ARDHRBA<REG5->ARDHRBA THEN /* STORE ADDR OF LARGER          */
         CLC   ARDHRBA(4,RBLKPTR),ARDHRBA(REG5)                    1803
         BNL   @RF01803                                            1803
*       RBLKPTR=REG5;               /* SAVE ADDR OF LARGER           */
         LR    RBLKPTR,REG5                                        1804
*     REG5=REG5->ARDNPTR;           /* POINT TO NEXT ARDB            */
@RF01803 L     REG5,ARDNPTR(,REG5)                                 1805
*   END;                                                           1806
@DE01802 LTR   REG5,REG5                                           1806
         BNZ   @DL01802                                            1806
*   GEN(BR REG10) ;                 /* RETURN TO CALLER              */
         BR REG10
*   RESPECIFY                                                      1808
*    (REG5,                                                        1808
*     REG9) UNRSTD;                                                1808
*ATRONTAB:                          /* ATRB-TURN BIT ON TABLE        */
*ATKSDSON:                                                         1809
*   AMDDST=ON;                      /* KSDS                          */
ATRONTAB DS    0H                                                  1809
ATKSDSON OI    AMDDST(RBLKPTR),B'10000000'                         1809
*ATESDSON:                                                         1810
*   AMDDST=OFF;                     /* ESDS                          */
ATESDSON DS    0H                                                  1811
*   AMDRRDS=OFF;                    /* MAKE SURE NOT RRDS            */
         NI    AMDDST(RBLKPTR),B'01111101'                         1811
*ATWCKON:                                                          1812
*   AMDWCK=ON;                      /* WCK                           */
ATWCKON  OI    AMDWCK(RBLKPTR),B'01000000'                         1812
*ATSSWDON:                                                         1813
*   AMDSDT=ON;                      /* SSWD                          */
ATSSWDON OI    AMDSDT(RBLKPTR),B'00100000'                         1813
*ATREPLON:                                                         1814
*   AMDREPL=ON;                     /* REPL                          */
ATREPLON OI    AMDREPL(RBLKPTR),B'00010000'                        1814
*ATRRDSON:                                                         1815
*   AMDRRDS=ON;                     /* RRDS                          */
ATRRDSON OI    AMDRRDS(RBLKPTR),B'00000010'                        1815
*ATSPANON:                                                         1816
*   AMDSPAN=ON;                     /* SPAN                          */
ATSPANON OI    AMDSPAN(RBLKPTR),B'00000001'                        1816
*ATUNQON:                                                          1817
*   AMDUNQ=OFF;                     /* UNQ                   @ZA10576*/
ATUNQON  NI    AMDUNQ(RBLKPTR),B'01111111'                         1817
*MACONTAB:                          /* MACRF-TURN ON BIT TABLE       */
*MAKEYON:                                                          1818
*   ACBKEY=ON;                      /* KEY                           */
MACONTAB DS    0H                                                  1818
MAKEYON  OI    ACBKEY(RBLKPTR),B'10000000'                         1818
*MAADRON:                                                          1819
*   ACBADR=ON;                      /* ADR                           */
MAADRON  OI    ACBADR(RBLKPTR),B'01000000'                         1819
*MACNVON:                                                          1820
*   ACBCNV=ON;                      /* CNV                           */
MACNVON  OI    ACBCNV(RBLKPTR),B'00100000'                         1820
*MASEQON:                                                          1821
*   ACBSEQ=ON;                      /* SEQ                           */
MASEQON  OI    ACBSEQ(RBLKPTR),B'00010000'                         1821
*MASKPON:                                                          1822
*   ACBSKP=ON;                      /* SKP                           */
MASKPON  OI    ACBSKP(RBLKPTR),B'00010000'                         1822
*MADIRON:                                                          1823
*   ACBDIR=ON;                      /* DIR                           */
MADIRON  OI    ACBDIR(RBLKPTR),B'00001000'                         1823
*MAINON:                                                           1824
*   ACBIN=ON;                       /* IN                            */
MAINON   OI    ACBIN(RBLKPTR),B'00000100'                          1824
*MAOUTON:                                                          1825
*   ACBOUT=ON;                      /* OUT                           */
MAOUTON  OI    ACBOUT(RBLKPTR),B'00000010'                         1825
*MANUBON:                                                          1826
*   ACBUBF=OFF;                     /* NUB                           */
MANUBON  NI    ACBUBF(RBLKPTR),B'11111110'                         1826
*MAUBFON:                                                          1827
*   ACBUBF=ON;                      /* UBF                           */
MAUBFON  OI    ACBUBF(RBLKPTR),B'00000001'                         1827
*MALOGON:                                                          1828
*   ACBLOGON=OFF;                   /* LOGON                         */
MALOGON  NI    ACBLOGON(RBLKPTR),B'11110111'                       1828
*MANLOGON:                                                         1829
*   ACBLOGON=ON;                    /* NLOGON                        */
MANLOGON OI    ACBLOGON(RBLKPTR),B'00001000'                       1829
*MADDNON:                                                          1830
*   ACBDSN=OFF;                     /* DDN                           */
MADDNON  NI    ACBDSN(RBLKPTR),B'11111101'                         1830
*MADSNON:                                                          1831
*   ACBDSN=ON;                      /* DSN                           */
MADSNON  OI    ACBDSN(RBLKPTR),B'00000010'                         1831
*MANRMON:                                                          1832
*   ACBAIX=OFF;                     /* NRM                           */
MANRMON  NI    ACBAIX(RBLKPTR),B'11111110'                         1832
*MAAIXON:                                                          1833
*   ACBAIX=ON;                      /* AIX                           */
MAAIXON  OI    ACBAIX(RBLKPTR),B'00000001'                         1833
*MANSRON:                                                          1834
*   ACBLSR=OFF;                     /* NSR                           */
MANSRON  DS    0H                                                  1835
*   ACBGSR=OFF;                     /* GSR                           */
         NI    ACBLSR(RBLKPTR),B'10011111'                         1835
*MALSRON:                                                          1836
*   ACBLSR=ON;                      /* LSR                           */
MALSRON  OI    ACBLSR(RBLKPTR),B'01000000'                         1836
*MAGSRON:                                                          1837
*   ACBGSR=ON;                      /* GSR                           */
MAGSRON  OI    ACBGSR(RBLKPTR),B'00100000'                         1837
*MANCION:                                                          1838
*   ACBICI=OFF;                     /* NCI                           */
MANCION  NI    ACBICI(RBLKPTR),B'11101111'                         1838
*MAICION:                                                          1839
*   ACBICI=ON;                      /* ICI                           */
MAICION  OI    ACBICI(RBLKPTR),B'00010000'                         1839
*MANDFON:                                                          1840
*   ACBDFR=OFF;                     /* NDF                           */
MANDFON  NI    ACBDFR(RBLKPTR),B'11110111'                         1840
*MADFRON:                                                          1841
*   ACBDFR=ON;                      /* DFR                           */
MADFRON  OI    ACBDFR(RBLKPTR),B'00001000'                         1841
*MANISON:                                                          1842
*   ACBSIS=OFF;                     /* NIS                           */
MANISON  NI    ACBSIS(RBLKPTR),B'11111011'                         1842
*MASISON:                                                          1843
*   ACBSIS=ON;                      /* SIS                           */
MASISON  OI    ACBSIS(RBLKPTR),B'00000100'                         1843
*MANFXON:                                                          1844
*   ACBNCFX=OFF;                    /* NFX                           */
MANFXON  NI    ACBNCFX(RBLKPTR),B'11111101'                        1844
*MACFXON:                                                          1845
*   ACBNCFX=ON;                     /* CFX                           */
MACFXON  OI    ACBNCFX(RBLKPTR),B'00000010'                        1845
*MARSTON:                                                          1846
*   ACBRST=ON;                      /* RST                           */
MARSTON  OI    ACBRST(RBLKPTR),B'00000100'                         1846
*MANRSON:                                                          1847
*   ACBRST=OFF;                     /* NRS                           */
MANRSON  NI    ACBRST(RBLKPTR),B'11111011'                         1847
*BRHONTAB:                          /* BRANCH TURN ON BIT TABLE      */
*BRYESON:                                                          1848
*   RPLBRANC=ON;                    /* YES                           */
BRHONTAB DS    0H                                                  1848
BRYESON  OI    RPLBRANC(RBLKPTR),B'00000010'                       1848
*BRNOON:                                                           1849
*   RPLBRANC=OFF;                   /* NO                            */
BRNOON   NI    RPLBRANC(RBLKPTR),B'11111101'                       1849
*CATONTAB:                          /* CATALOG-TURN ON BIT TABLE     */
*CATYESON:                                                         1850
*   ACBCAT=ON;                      /* YES                           */
CATONTAB DS    0H                                                  1850
CATYESON OI    ACBCAT(RBLKPTR),B'00010000'                         1850
*CATNOON:                                                          1851
*   ACBCAT=OFF;                     /* NO                            */
CATNOON  NI    ACBCAT(RBLKPTR),B'11101111'                         1851
*CRAONTAB:                          /* CRA-TURN ON BIT TABLE         */
*CRSCRAON:                                                         1852
*   ACBSCRA=ON;                     /* SCRA                          */
CRAONTAB DS    0H                                                  1852
CRSCRAON OI    ACBSCRA(RBLKPTR),B'00001000'                        1852
*CRUCRAON:                                                         1853
*   ACBUCRA=ON;                     /* UCRA                          */
CRUCRAON OI    ACBUCRA(RBLKPTR),B'00000100'                        1853
*OFLONTAB:                          /* OFLAGS-TURN ON TABLE          */
*OFOPENON:                                                         1854
*   ACBOPEN=ON;                     /* OPEN                          */
OFLONTAB DS    0H                                                  1854
OFOPENON OI    ACBOPEN(RBLKPTR),B'00010000'                        1854
*OPEONTAB:                          /* OPENOBJ- TURN ON FLAGS        */
*OPAIXON:                                                          1855
*   AMBLAIX=ON;                     /* AIX                           */
OPEONTAB DS    0H                                                  1855
OPAIXON  OI    AMBLAIX(RBLKPTR),B'00100000'                        1855
*OPPATHON:                                                         1856
*   AMBLPATH=ON;                    /* PATH                          */
OPPATHON OI    AMBLPATH(RBLKPTR),B'10000000'                       1856
*OPBASEON:                                                         1857
*   AMBLBASE=ON;                    /* BASE                          */
OPBASEON OI    AMBLBASE(RBLKPTR),B'00010000'                       1857
*DATONTAB:                          /* DATAFLAGS- BIT TURN ON TABLE  */
*DAUNSOON:                                                         1858
*   RPLUINPT=ON;                    /* UNSOL                         */
DATONTAB DS    0H                                                  1858
DAUNSOON OI    RPLUINPT(RBLKPTR),B'10000000'                       1858
*DAEOBON:                                                          1859
*   RPLREOB=ON;                     /* EOB                           */
DAEOBON  OI    RPLREOB(RBLKPTR),B'00100000'                        1859
*DAEOMON:                                                          1860
*   RPLREOM=ON;                     /* EOM                           */
DAEOMON  OI    RPLREOM(RBLKPTR),B'00010000'                        1860
*DAEOTON:                                                          1861
*   RPLREOT=ON;                     /* EOT                           */
DAEOTON  OI    RPLREOT(RBLKPTR),B'00001000'                        1861
*DALOGOON:                                                         1862
*   RPLLGFRC=ON;                    /* LOGOFF                        */
DALOGOON OI    RPLLGFRC(RBLKPTR),B'00000100'                       1862
*DALGON:                                                           1863
*   RPLRLG=ON;                      /* LG                            */
DALGON   OI    RPLRLG(RBLKPTR),B'00000010'                         1863
*DASOHON:                                                          1864
*   RPLRDSOH=ON;                    /* SOH                           */
DASOHON  OI    RPLRDSOH(RBLKPTR),B'00000001'                       1864
*OPTONTAB:                          /* OPTCD- BIT TURN ON TABLE      */
*OPKEYON:                                                          1865
*   RPLKEY=ON;                      /* KEY                           */
OPTONTAB DS    0H                                                  1865
OPKEYON  OI    RPLKEY(RBLKPTR),B'10000000'                         1865
*OPADRON:                                                          1866
*   RPLADR=ON;                      /* ADR                           */
OPADRON  OI    RPLADR(RBLKPTR),B'01000000'                         1866
*OPCNVON:                                                          1867
*   RPLCNV=ON;                      /* CNV                           */
OPCNVON  OI    RPLCNV(RBLKPTR),B'00100000'                         1867
*OPSEQON:                                                          1868
*   RPLSEQ=ON;                      /* SEQ                           */
OPSEQON  OI    RPLSEQ(RBLKPTR),B'00100000'                         1868
*OPDIRON:                                                          1869
*   RPLDIR=ON;                      /* DIR                           */
OPDIRON  OI    RPLDIR(RBLKPTR),B'01000000'                         1869
*OPSKPON:                                                          1870
*   RPLSKP=ON;                      /* SKP                           */
OPSKPON  OI    RPLSKP(RBLKPTR),B'00010000'                         1870
*OPSYNON:                                                          1871
*   RPLASY=OFF;                     /* SYN                           */
OPSYNON  NI    RPLASY(RBLKPTR),B'11110111'                         1871
*OPASYON:                                                          1872
*   RPLASY=ON;                      /* ASY                           */
OPASYON  OI    RPLASY(RBLKPTR),B'00001000'                         1872
*OPNUPON:                                                          1873
*   RPLUPD=OFF;                     /* NUP                           */
OPNUPON  NI    RPLUPD(RBLKPTR),B'11111101'                         1873
*OPUPDON:                                                          1874
*   RPLUPD=ON;                      /* UPD                           */
OPUPDON  OI    RPLUPD(RBLKPTR),B'00000010'                         1874
*OPNSPON:                                                          1875
*   RPLNSP=ON;                      /* NSP                           */
OPNSPON  OI    RPLNSP(RBLKPTR),B'00000001'                         1875
*OPKEQON:                                                          1876
*   RPLKGE=OFF;                     /* KEQ                           */
OPKEQON  NI    RPLKGE(RBLKPTR),B'11111011'                         1876
*OPKGEON:                                                          1877
*   RPLKGE=ON;                      /* KGE                           */
OPKGEON  OI    RPLKGE(RBLKPTR),B'00000100'                         1877
*OPFKSON:                                                          1878
*   RPLGEN=OFF;                     /* FKS                           */
OPFKSON  NI    RPLGEN(RBLKPTR),B'11111101'                         1878
*OPGENON:                                                          1879
*   RPLGEN=ON;                      /* GEN                           */
OPGENON  OI    RPLGEN(RBLKPTR),B'00000010'                         1879
*OPMVEON:                                                          1880
*   RPLLOC=OFF;                     /* MVE                           */
OPMVEON  NI    RPLLOC(RBLKPTR),B'01111111'                         1880
*OPLOCON:                                                          1881
*   RPLLOC=ON;                      /* LOC                           */
OPLOCON  OI    RPLLOC(RBLKPTR),B'10000000'                         1881
*OPFWDON:                                                          1882
*   RPLBWD=OFF;                     /* FWD                           */
OPFWDON  NI    RPLBWD(RBLKPTR),B'11101111'                         1882
*OPBWDON:                                                          1883
*   RPLBWD=ON;                      /* BWD                           */
OPBWDON  OI    RPLBWD(RBLKPTR),B'00010000'                         1883
*OPARDON:                                                          1884
*   RPLLRD=OFF;                     /* ARD                           */
OPARDON  NI    RPLLRD(RBLKPTR),B'11110111'                         1884
*OPLRDON:                                                          1885
*   RPLLRD=ON;                      /* LRD                           */
OPLRDON  OI    RPLLRD(RBLKPTR),B'00001000'                         1885
*OPTONTB2:                          /* SECOND PART OF TABLE          */
*OPCAON:                                                           1886
*   RPLDLGIN=OFF;                   /* CA                            */
OPTONTB2 DS    0H                                                  1886
OPCAON   NI    RPLDLGIN(RBLKPTR),B'01111111'                       1886
*OPCSON:                                                           1887
*   RPLDLGIN=ON;                    /* CS                            */
OPCSON   OI    RPLDLGIN(RBLKPTR),B'10000000'                       1887
*OPRELEON:                                                         1888
*   RPLPSOPT=OFF;                   /* RELEASE                       */
OPRELEON NI    RPLPSOPT(RBLKPTR),B'11011111'                       1888
*OPPASSON:                                                         1889
*   RPLPSOPT=ON;                    /* PASS                          */
OPPASSON OI    RPLPSOPT(RBLKPTR),B'00100000'                       1889
*OPNERAON:                                                         1890
*   RPLNERAS=ON;                    /* NERASE                        */
OPNERAON OI    RPLNERAS(RBLKPTR),B'00010000'                       1890
*OPEAUON:                                                          1891
*   RPLEAU=ON;                      /* EAU                           */
OPEAUON  OI    RPLEAU(RBLKPTR),B'00001000'                         1891
*OPERASON:                                                         1892
*   RPLERACE=ON;                    /* ERASE                         */
OPERASON OI    RPLERACE(RBLKPTR),B'00000100'                       1892
*OPSPECON:                                                         1893
*   RPLNODE=OFF;                    /* SPEC                          */
OPSPECON NI    RPLNODE(RBLKPTR),B'11111101'                        1893
*OPANYON:                                                          1894
*   RPLNODE=ON;                     /* ANY                           */
OPANYON  OI    RPLNODE(RBLKPTR),B'00000010'                        1894
*OPNCONON:                                                         1895
*   RPLWROPT=OFF;                   /* NCONV                         */
OPNCONON NI    RPLWROPT(RBLKPTR),B'11111110'                       1895
*OPCONVON:                                                         1896
*   RPLWROPT=ON;                    /* CONV                          */
OPCONVON OI    RPLWROPT(RBLKPTR),B'00000001'                       1896
*OPLBTON:                                                          1897
*   RPLEOT=ON;                      /* LBT                           */
OPLBTON  OI    RPLEOT(RBLKPTR),B'00100000'                         1897
*OPLBMON:                                                          1898
*   RPLEOM=ON;                      /* LBM                           */
OPLBMON  OI    RPLEOM(RBLKPTR),B'01000000'                         1898
*OPBLKON:                                                          1899
*   RPLEOB=ON;                      /* BLK                           */
OPBLKON  OI    RPLEOB(RBLKPTR),B'10000000'                         1899
*OPCONDON:                                                         1900
*   RPLCOND=ON;                     /* COND                          */
OPCONDON OI    RPLCOND(RBLKPTR),B'00010000'                        1900
*OPUNCOON:                                                         1901
*   RPLNCOND=ON;                    /* UNCOND                        */
OPUNCOON OI    RPLNCOND(RBLKPTR),B'00001000'                       1901
*OPLOCKON:                                                         1902
*   RPLLOCK=ON;                     /* LOCK                          */
OPLOCKON OI    RPLLOCK(RBLKPTR),B'00000100'                        1902
*OPLOGOON:                                                         1903
*   RPLLOGON=ON;                    /* LOGONMSG                      */
OPLOGOON OI    RPLLOGON+76(RBLKPTR),B'10000000'                    1903
*OPDEVCON:                                                         1904
*   RPLDEVCH=ON;                    /* DEVCHAR                       */
OPDEVCON OI    RPLDEVCH+76(RBLKPTR),B'01000000'                    1904
*OPTERMON:                                                         1905
*   RPLTERMS=ON;                    /* TERMS                         */
OPTERMON OI    RPLTERMS+76(RBLKPTR),B'00100000'                    1905
*OPAPPSON:                                                         1906
*   RPLAPPST=ON;                    /* APPSTAT                       */
OPAPPSON OI    RPLAPPST+76(RBLKPTR),B'00001000'                    1906
*OPCOUNON:                                                         1907
*   RPLCOUNT=ON;                    /* COUNTS                        */
OPCOUNON OI    RPLCOUNT+76(RBLKPTR),B'00010000'                    1907
*OPRNNAON:                                                         1908
*   RPLRNNM=ON;                     /* RNNAME                        */
OPRNNAON OI    RPLRNNM+76(RBLKPTR),B'00000100'                     1908
*OPCIDXON:                                                         1909
*   RPLCIDE=ON;                     /* CIDXLATE                      */
OPCIDXON OI    RPLCIDE+76(RBLKPTR),B'00000010'                     1909
*OPTOPLON:                                                         1910
*   RPLTOPL=ON;                     /* TOPLOGON                      */
OPTOPLON OI    RPLTOPL+76(RBLKPTR),B'00000001'                     1910
*OPBSCION:                                                         1911
*   RPLBSCID=ON;                    /* BSCID                         */
OPBSCION OI    RPLBSCID+76(RBLKPTR),B'10000000'                    1911
*OPDISPON:                                                         1912
*   RPLDSPLY=ON;                    /* DISPLAY                       */
OPDISPON OI    RPLDSPLY+76(RBLKPTR),B'01000000'                    1912
*OPRELRON:                                                         1913
*   RPLRLSOP=ON;                    /* RELRQ                         */
OPRELRON OI    RPLRLSOP(RBLKPTR),B'00000100'                       1913
*OPTONTB3:                          /* THIRD PART OF TABLE           */
*OPNRELON:                                                         1914
*   RPLRLSOP=OFF;                   /* NRELRQ                        */
OPTONTB3 DS    0H                                                  1914
OPNRELON NI    RPLRLSOP(RBLKPTR),B'11111011'                       1914
*OPQON:                                                            1915
*   RPLQOPT=ON;                     /* Q                             */
OPQON    OI    RPLQOPT(RBLKPTR),B'00010000'                        1915
*OPNQON:                                                           1916
*   RPLQOPT=OFF;                    /* NQ                            */
OPNQON   NI    RPLQOPT(RBLKPTR),B'11101111'                        1916
*OPPENDON:                                                         1917
*   RPLPEND=ON;                     /* PEND                          */
OPPENDON OI    RPLPEND(RBLKPTR),B'00010000'                        1917
*OPSESSON:                                                         1918
*   RPLSESS=ON;                     /* SESSION                       */
OPSESSON OI    RPLSESS(RBLKPTR),B'00001000'                        1918
*OPACTION:                                                         1919
*   RPLACTV=ON;                     /* ACTIVE                        */
OPACTION OI    RPLACTV(RBLKPTR),B'00000100'                        1919
*OPUNCLON:                                                         1920
*   RPLUNCON=ON;                    /* UNCONDL                       */
OPUNCLON OI    RPLUNCON(RBLKPTR),B'00000010'                       1920
*OPQUIEON:                                                         1921
*   RPLQUIES=ON;                    /* QUIESCE                       */
OPQUIEON OI    RPLQUIES+76(RBLKPTR),B'10000000'                    1921
*OPSTARON:                                                         1922
*   RPLSTART=ON;                    /* START                         */
OPSTARON OI    RPLSTART+76(RBLKPTR),B'01000000'                    1922
*OPSTOPON:                                                         1923
*   RPLSTOP=ON;                     /* STOP                          */
OPSTOPON OI    RPLSTOP+76(RBLKPTR),B'00100000'                     1923
*OPACCEON:                                                         1924
*   RPLODACP=ON;                    /* ACCEPT                        */
OPACCEON OI    RPLODACP(RBLKPTR),B'01000000'                       1924
*OPACQUON:                                                         1925
*   RPLODACQ=ON;                    /* ACQUIRE                       */
OPACQUON OI    RPLODACQ(RBLKPTR),B'10000000'                       1925
*OPCALLON:                                                         1926
*   RPLCNALL=ON;                    /* CONALL                        */
OPCALLON OI    RPLCNALL(RBLKPTR),B'10000000'                       1926
*OPCANYON:                                                         1927
*   RPLCNANY=ON;                    /* CONANY                        */
OPCANYON OI    RPLCNANY(RBLKPTR),B'01000000'                       1927
*OPKEEPON:                                                         1928
*   RPLKEEP=ON;                     /* KEEP                          */
OPKEEPON OI    RPLKEEP+76(RBLKPTR),B'01000000'                     1928
*OPTRUNON:                                                         1929
*   RPLTRUNC=ON;                    /* TRUNC                         */
OPTRUNON OI    RPLTRUNC+76(RBLKPTR),B'00100000'                    1929
*OPNIBTON:                                                         1930
*   RPLNIBTK=ON;                    /* NIBTK                         */
OPNIBTON OI    RPLNIBTK+76(RBLKPTR),B'00010000'                    1930
*OPFMHDON:                                                         1931
*   RPLFMHDR=ON;                    /* FMHDR                         */
OPFMHDON OI    RPLFMHDR+76(RBLKPTR),B'00000001'                    1931
*OPNFMHON:                                                         1932
*   RPLFMHDR=OFF;                   /* NFMHDR                        */
OPNFMHON NI    RPLFMHDR+76(RBLKPTR),B'11111110'                    1932
*OPSESPON:                                                         1933
*   RPLSPARM=ON;                    /* SESSPARM                      */
OPSESPON OI    RPLSPARM+76(RBLKPTR),B'00100000'                    1933
*OPSESKON:                                                         1934
*   RPLTSKY=ON;                     /* SESSKEY               @G40KSCM*/
OPSESKON OI    RPLTSKY+76(RBLKPTR),B'00010000'                     1934
*LISONTAB:                          /* LISTEND-BIT TURN ON TABLE     */
*LIYESON:                                                          1935
*   NIBLAST=OFF;                    /* YES                           */
LISONTAB DS    0H                                                  1935
LIYESON  NI    NIBLAST(RBLKPTR),B'01111111'                        1935
*LINOON:                                                           1936
*   NIBLAST=ON;                     /* NO                            */
LINOON   OI    NIBLAST(RBLKPTR),B'10000000'                        1936
*CONONTAB:                          /* CON-BIT TURN ON TABLE         */
*COYESON:                                                          1937
*   NIBCON=ON;                      /* YES                           */
CONONTAB DS    0H                                                  1937
COYESON  OI    NIBCON(RBLKPTR),B'01000000'                         1937
*CONOON:                                                           1938
*   NIBCON=OFF;                     /* NO                            */
CONOON   NI    NIBCON(RBLKPTR),B'10111111'                         1938
*PROONTAB:                          /* PROC-BIT TURN ON TABLE        */
*PRMSGON:                                                          1939
*   PROMODM=ON;                     /* MSG                           */
PROONTAB DS    0H                                                  1939
PRMSGON  OI    PROMODM+36(RBLKPTR),B'00000100'                     1939
*PRTRANON:                                                         1940
*   PROMODT=ON;                     /* TRANS                         */
PRTRANON OI    PROMODT+36(RBLKPTR),B'00000010'                     1940
*PRCONTON:                                                         1941
*   PROMODC=ON;                     /* CONT                          */
PRCONTON OI    PROMODC+36(RBLKPTR),B'00000001'                     1941
*PRBLOCON:                                                         1942
*   PROMODB=ON;                     /* BLOCK                         */
PRBLOCON OI    PROMODB+36(RBLKPTR),B'00001000'                     1942
*PRLGINON:                                                         1943
*   PROLGIN=OFF;                    /* LGIN                          */
PRLGINON NI    PROLGIN+36(RBLKPTR),B'11011111'                     1943
*PRNLGION:                                                         1944
*   PROLGIN=ON;                     /* NLGIN                         */
PRNLGION OI    PROLGIN+36(RBLKPTR),B'00100000'                     1944
*PRLGOUON:                                                         1945
*   PROLGOT=OFF;                    /* LGOUT                         */
PRLGOUON NI    PROLGOT+36(RBLKPTR),B'11011111'                     1945
*PRNLGOON:                                                         1946
*   PROLGOT=ON;                     /* NLGOUT                        */
PRNLGOON OI    PROLGOT+36(RBLKPTR),B'00100000'                     1946
*PRCONFON:                                                         1947
*   PROCFTX=ON;                     /* CONFTXT                       */
PRCONFON OI    PROCFTX+36(RBLKPTR),B'00000001'                     1947
*PRNCONON:                                                         1948
*   PROCFTX=OFF;                    /* NCONFTXT                      */
PRNCONON NI    PROCFTX+36(RBLKPTR),B'11111110'                     1948
*PRTMFLON:                                                         1949
*   PRONTFL=OFF;                    /* TMFLL                         */
PRTMFLON NI    PRONTFL+36(RBLKPTR),B'11111011'                     1949
*PRNTMFON:                                                         1950
*   PRONTFL=ON;                     /* NTMFLL                        */
PRNTMFON OI    PRONTFL+36(RBLKPTR),B'00000100'                     1950
*PRERPION:                                                         1951
*   PROERPI=OFF;                    /* ERPIN                         */
PRERPION NI    PROERPI+36(RBLKPTR),B'10111111'                     1951
*PRNERION:                                                         1952
*   PROERPI=ON;                     /* NERPIN                        */
PRNERION OI    PROERPI+36(RBLKPTR),B'01000000'                     1952
*PRERPOON:                                                         1953
*   PROERPO=OFF;                    /* ERPOUT                        */
PRERPOON NI    PROERPO+36(RBLKPTR),B'10111111'                     1953
*PRNEROON:                                                         1954
*   PROERPO=ON;                     /* NERPOUT                       */
PRNEROON OI    PROERPO+36(RBLKPTR),B'01000000'                     1954
*PRMONION:                                                         1955
*   PROMONIT=ON;                    /* MONITOR                       */
PRMONION OI    PROMONIT+36(RBLKPTR),B'00000100'                    1955
*PRNMONON:                                                         1956
*   PROMONIT=OFF;                   /* NMONITOR                      */
PRNMONON NI    PROMONIT+36(RBLKPTR),B'11111011'                    1956
*PRELCON:                                                          1957
*   PROEMLC=ON;                     /* ELC                           */
PRELCON  OI    PROEMLC+36(RBLKPTR),B'00000010'                     1957
*PRNELCON:                                                         1958
*   PROEMLC=OFF;                    /* NELC                          */
PRNELCON NI    PROEMLC+36(RBLKPTR),B'11111101'                     1958
*PRNEIBON:                                                         1959
*   PROEIB=OFF;                     /* NEIB                          */
PRNEIBON NI    PROEIB+36(RBLKPTR),B'01111111'                      1959
*PREIBON:                                                          1960
*   PROEIB=ON;                      /* EIB                           */
PREIBON  OI    PROEIB+36(RBLKPTR),B'10000000'                      1960
*PRTIMEON:                                                         1961
*   PRONTO=OFF;                     /* TIMEOUT                       */
PRTIMEON NI    PRONTO+36(RBLKPTR),B'11101111'                      1961
*PRNTIMON:                                                         1962
*   PRONTO=ON;                      /* NTIMEOUT                      */
PRNTIMON OI    PRONTO+36(RBLKPTR),B'00010000'                      1962
*PRNORDON:                                                         1963
*   PROFIFOR=OFF;                   /* NORDRESP              @G40KSCM*/
PRNORDON NI    PROFIFOR+36(RBLKPTR),B'11110111'                    1963
*PRORDON:                                                          1964
*   PROFIFOR=ON;                    /* ORDRESP               @G40KSCM*/
PRORDON  OI    PROFIFOR+36(RBLKPTR),B'00001000'                    1964
*PRKEEPON:                                                         1965
*   PROTRUNC=OFF;                   /* KEEP                          */
PRKEEPON NI    PROTRUNC+36(RBLKPTR),B'10111111'                    1965
*PRTRUNON:                                                         1966
*   PROTRUNC=ON;                    /* TRUNC                         */
PRTRUNON OI    PROTRUNC+36(RBLKPTR),B'01000000'                    1966
*PRNBINON:                                                         1967
*   PROXPOPT=OFF;                   /* NBINARY                       */
PRNBINON NI    PROXPOPT+36(RBLKPTR),B'11011111'                    1967
*PRBINAON:                                                         1968
*   PROXPOPT=ON;                    /* BINARY                        */
PRBINAON OI    PROXPOPT+36(RBLKPTR),B'00100000'                    1968
*PRNDFAON:                                                         1969
*   PRODFASY=OFF;                   /* NDFASYX                       */
PRNDFAON NI    PRODFASY+36(RBLKPTR),B'11101111'                    1969
*PRDFASON:                                                         1970
*   PRODFASY=ON;                    /* DFASYX                        */
PRDFASON OI    PRODFASY+36(RBLKPTR),B'00010000'                    1970
*PROONTB2:                          /* SECOND PART OF TABLE          */
*PRNRESON:                                                         1971
*   PRORESPX=OFF;                   /* NRESPX                        */
PROONTB2 DS    0H                                                  1971
PRNRESON NI    PRORESPX+36(RBLKPTR),B'11110111'                    1971
*PRRESPON:                                                         1972
*   PRORESPX=ON;                    /* RESPX                         */
PRRESPON OI    PRORESPX+36(RBLKPTR),B'00001000'                    1972
*PRCAON:                                                           1973
*   PROCA=ON;                       /* CA                            */
PRCAON   OI    PROCA+36(RBLKPTR),B'00000100'                       1973
*PRCSON:                                                           1974
*   PROCS=ON;                       /* CS                            */
PRCSON   OI    PROCS+36(RBLKPTR),B'00000010'                       1974
*PRRPLCON:                                                         1975
*   PRORPLC=ON;                     /* RPLC                          */
PRRPLCON OI    PRORPLC+36(RBLKPTR),B'00000001'                     1975
*PRSYSON:                                                          1976
*   PROSYSR=OFF;                    /* SYSRESP               @G40KSCM*/
PRSYSON  NI    PROSYSR+36(RBLKPTR),B'11101111'                     1976
*PRAPPLON:                                                         1977
*   PROSYSR=ON;                     /* APPLRESP              @G40KSCM*/
PRAPPLON OI    PROSYSR+36(RBLKPTR),B'00010000'                     1977
*SDTONTAB:                          /* SDT-BIT TURN ON TABLE         */
*SDSYSON:                                                          1978
*   NIBSDAPP=OFF;                   /* SYS                           */
SDTONTAB DS    0H                                                  1978
SDSYSON  NI    NIBSDAPP(RBLKPTR),B'11011111'                       1978
*SDAPPLON:                                                         1979
*   NIBSDAPP=ON;                    /* APPL                          */
SDAPPLON OI    NIBSDAPP(RBLKPTR),B'00100000'                       1979
*BRAONTAB:                          /* BRACKET-BIT TURN ON TABLE     */
*BRBBON:                                                           1980
*   RPLBB=ON;                       /* BB                            */
BRAONTAB DS    0H                                                  1980
BRBBON   OI    RPLBB+16(RBLKPTR),B'10000000'                       1980
*BRNBBON:                                                          1981
*   RPLBB=OFF;                      /* NBB                           */
BRNBBON  NI    RPLBB+16(RBLKPTR),B'01111111'                       1981
*BREBON:                                                           1982
*   RPLEB=ON;                       /* EB                            */
BREBON   OI    RPLEB+16(RBLKPTR),B'01000000'                       1982
*BRNEBON:                                                          1983
*   RPLEB=OFF;                      /* NEB                           */
BRNEBON  NI    RPLEB+16(RBLKPTR),B'10111111'                       1983
*CHNONTAB:                          /* CHNGDIR-BIT TURN ON TABLE     */
*CHNCMDON:                                                         1984
*   RPLCMD=OFF;                     /* NCMD                          */
CHNONTAB DS    0H                                                  1984
CHNCMDON NI    RPLCMD+16(RBLKPTR),B'11011111'                      1984
*CHCMDON:                                                          1985
*   RPLCMD=ON;                      /* CMD                           */
CHCMDON  OI    RPLCMD+16(RBLKPTR),B'00100000'                      1985
*CHNREQON:                                                         1986
*   RPLCHREQ=OFF;                   /* NREQ                          */
CHNREQON NI    RPLCHREQ+16(RBLKPTR),B'11101111'                    1986
*CHREQON:                                                          1987
*   RPLCHREQ=ON;                    /* REQ                           */
CHREQON  OI    RPLCHREQ+16(RBLKPTR),B'00010000'                    1987
*STYONTAB:                          /* STYPE-BIT TURN ON TABLE       */
*STREQON:                                                          1988
*   RPLSRESP=OFF;                   /* REQ                           */
STYONTAB DS    0H                                                  1988
STREQON  NI    RPLSRESP+16(RBLKPTR),B'01111111'                    1988
*STRESPON:                                                         1989
*   RPLSRESP=ON;                    /* RESP                          */
STRESPON OI    RPLSRESP+16(RBLKPTR),B'10000000'                    1989
*RTYONTAB:                          /* RTYPE- BIT TURN ON TABLE      */
*RTNRESON:                                                         1990
*   RPLRRESP=OFF;                   /* NRESP                         */
RTYONTAB DS    0H                                                  1990
RTNRESON NI    RPLRRESP+16(RBLKPTR),B'11110111'                    1990
*RTRESPON:                                                         1991
*   RPLRRESP=ON;                    /* RESP                          */
RTRESPON OI    RPLRRESP+16(RBLKPTR),B'00001000'                    1991
*RTDFSYON:                                                         1992
*   RPLNFSYN=OFF;                   /* DFSYN                         */
RTDFSYON NI    RPLNFSYN+16(RBLKPTR),B'11111011'                    1992
*RTNDFSON:                                                         1993
*   RPLNFSYN=ON;                    /* NDFSYN                        */
RTNDFSON OI    RPLNFSYN+16(RBLKPTR),B'00000100'                    1993
*RTNDFAON:                                                         1994
*   RPLDFASY=OFF;                   /* NDFASY                        */
RTNDFAON NI    RPLDFASY+16(RBLKPTR),B'11111101'                    1994
*RTDFASON:                                                         1995
*   RPLDFASY=ON;                    /* DFASY                         */
RTDFASON OI    RPLDFASY+16(RBLKPTR),B'00000010'                    1995
*CHAONTAB:                          /* CHAIN-BIT TURN ON TABLE       */
*CHFIRSON:                                                         1996
*   RPLFIRST=ON;                    /* FIRST                         */
CHAONTAB DS    0H                                                  1996
CHFIRSON OI    RPLFIRST+16(RBLKPTR),B'10000000'                    1996
*CHMIDDON:                                                         1997
*   RPLMIDLE=ON;                    /* MIDDLE                        */
CHMIDDON OI    RPLMIDLE+16(RBLKPTR),B'01000000'                    1997
*CHLASTON:                                                         1998
*   RPLLAST=ON;                     /* LAST                          */
CHLASTON OI    RPLLAST+16(RBLKPTR),B'00100000'                     1998
*CHONLYON:                                                         1999
*   RPLONLY=ON;                     /* ONLY                          */
CHONLYON OI    RPLONLY+16(RBLKPTR),B'00010000'                     1999
*POSONTAB:                          /* POST-BIT TURN ON TABLE        */
*PORESPON:                                                         2000
*   RPLSCHED=OFF;                   /* RESP                          */
POSONTAB DS    0H                                                  2000
PORESPON NI    RPLSCHED+16(RBLKPTR),B'01111111'                    2000
*POSCHEON:                                                         2001
*   RPLSCHED=ON;                    /* SCHE                          */
POSCHEON OI    RPLSCHED+16(RBLKPTR),B'10000000'                    2001
*RESONTAB:                          /* RESPOND-BIT TURN ON TABLE     */
*RENEXON:                                                          2002
*   RPLEX=OFF;                      /* NEX                           */
RESONTAB DS    0H                                                  2002
RENEXON  NI    RPLEX+16(RBLKPTR),B'11111011'                       2002
*REEXON:                                                           2003
*   RPLEX=ON;                       /* EX                            */
REEXON   OI    RPLEX+16(RBLKPTR),B'00000100'                       2003
*REFMEON:                                                          2004
*   RPLNFME=OFF;                    /* FME                           */
REFMEON  NI    RPLNFME+16(RBLKPTR),B'11111101'                     2004
*RENFMEON:                                                         2005
*   RPLNFME=ON;                     /* NFME                          */
RENFMEON OI    RPLNFME+16(RBLKPTR),B'00000010'                     2005
*RENRRNON:                                                         2006
*   RPLRRN=OFF;                     /* NRRN                          */
RENRRNON NI    RPLRRN+16(RBLKPTR),B'11111110'                      2006
*RERRNON:                                                          2007
*   RPLRRN=ON;                      /* RRN                           */
RERRNON  OI    RPLRRN+16(RBLKPTR),B'00000001'                      2007
*REQREON:                                                          2008
*   RPLQRI=ON;                      /* QRESP                 @G40KSCM*/
REQREON  OI    RPLQRI+16(RBLKPTR),B'00001000'                      2008
*RENQREON:                                                         2009
*   RPLQRI=OFF;                     /* NQRESP                @G40KSCM*/
RENQREON NI    RPLQRI+16(RBLKPTR),B'11110111'                      2009
*CNTONTAB:                          /* CONTROL-BIT TURN ON TABLE     */
*CNDATAON:                                                         2010
*   RPLDATA=ON;                     /* DATA                          */
CNTONTAB DS    0H                                                  2010
CNDATAON OI    RPLDATA+16(RBLKPTR),B'10000000'                     2010
*CNCANCON:                                                         2011
*   RPLCNCEL=ON;                    /* CANCEL                        */
CNCANCON OI    RPLCNCEL+16(RBLKPTR),B'01000000'                    2011
*CNQCON:                                                           2012
*   RPLQC=ON;                       /* QC                            */
CNQCON   OI    RPLQC+16(RBLKPTR),B'00100000'                       2012
*CNQECON:                                                          2013
*   RPLQEC=ON;                      /* QEC                           */
CNQECON  OI    RPLQEC+16(RBLKPTR),B'00010000'                      2013
*CNCHASON:                                                         2014
*   RPLCHASE=ON;                    /* CHASE                         */
CNCHASON OI    RPLCHASE+16(RBLKPTR),B'00001000'                    2014
*CNRELQON:                                                         2015
*   RPLRELQ=ON;                     /* RELQ                          */
CNRELQON OI    RPLRELQ+16(RBLKPTR),B'00000100'                     2015
*CNBIDON:                                                          2016
*   RPLBID=ON;                      /* BID                           */
CNBIDON  OI    RPLBID+16(RBLKPTR),B'10000000'                      2016
*CNRTRON:                                                          2017
*   RPLRTR=ON;                      /* RTR                           */
CNRTRON  OI    RPLRTR+16(RBLKPTR),B'01000000'                      2017
*CNLUSON:                                                          2018
*   RPLLUS=ON;                      /* LUS                           */
CNLUSON  OI    RPLLUS+16(RBLKPTR),B'00100000'                      2018
*CNSIGNON:                                                         2019
*   RPLSIGNL=ON;                    /* SIGNAL                        */
CNSIGNON OI    RPLSIGNL+16(RBLKPTR),B'00010000'                    2019
*CNSDTON:                                                          2020
*   RPLSDT=ON;                      /* SDT                           */
CNSDTON  OI    RPLSDT+16(RBLKPTR),B'10000000'                      2020
*CNCLEAON:                                                         2021
*   RPLCLEAR=ON;                    /* CLEAR                         */
CNCLEAON OI    RPLCLEAR+16(RBLKPTR),B'01000000'                    2021
*CNSTSNON:                                                         2022
*   RPLSTSN=ON;                     /* STSN                          */
CNSTSNON OI    RPLSTSN+16(RBLKPTR),B'00100000'                     2022
*CNSHUTON:                                                         2023
*   RPLSHUTD=ON;                    /* SHUTD                         */
CNSHUTON OI    RPLSHUTD+16(RBLKPTR),B'00010000'                    2023
*CNRQRON:                                                          2024
*   RPLRQR=ON;                      /* RQR                           */
CNRQRON  OI    RPLRQR+16(RBLKPTR),B'00000100'                      2024
*CNRSHUON:                                                         2025
*   RPLRSHUT=ON;                    /* RSHUT                         */
CNRSHUON OI    RPLRSHUT+16(RBLKPTR),B'00000010'                    2025
*CNSHTCON:                                                         2026
*   RPLSHUTC=ON;                    /* SHUTC                 @ZA07554*/
CNSHTCON OI    RPLSHUTC+16(RBLKPTR),B'00001000'                    2026
*CNBINDON:                                                         2027
*   RPLTBIND=ON;                    /* BIND                  @G40KSCM*/
CNBINDON OI    RPLTBIND+16(RBLKPTR),B'00001000'                    2027
*CNUNBDON:                                                         2028
*   RPLTUNBD=ON;                    /* UNBIND                @G40KSCM*/
CNUNBDON OI    RPLTUNBD+16(RBLKPTR),B'00000100'                    2028
*CNSBION:                                                          2029
*   RPLSBI=ON;                      /* SBI                   @G40KSCM*/
CNSBION  OI    RPLSBI+16(RBLKPTR),B'00000010'                      2029
*CNBISON:                                                          2030
*   RPLBIS=ON;                      /* BIS                   @G40KSCM*/
CNBISON  OI    RPLBIS+16(RBLKPTR),B'00000001'                      2030
*QBSONTAB:                          /* QBSQAC-BIT TURN ON TABLE      */
*QBSETON:                                                          2031
*   RPLOSET=ON;                     /* SET                           */
QBSONTAB DS    0H                                                  2031
QBSETON  OI    RPLOSET+60(RBLKPTR),B'10000000'                     2031
*QBTESTON:                                                         2032
*   RPLOTST=ON;                     /* TESTSET                       */
QBTESTON OI    RPLOTST+60(RBLKPTR),B'01000000'                     2032
*QBRESEON:                                                         2033
*   RPLORSET=ON;                    /* RESET                         */
QBRESEON OI    RPLORSET+60(RBLKPTR),B'00100000'                    2033
*QBIGNOON:                                                         2034
*   RPLOIGN=ON;                     /* IGNORE                        */
QBIGNOON OI    RPLOIGN+60(RBLKPTR),B'00010000'                     2034
*QBTSTPON:                                                         2035
*   RPLOPOS=ON;                     /* TESTPOS                       */
QBTSTPON OI    RPLOPOS+60(RBLKPTR),B'00001000'                     2035
*QBTSTNON:                                                         2036
*   RPLONEG=ON;                     /* TESTNEG                       */
QBTSTNON OI    RPLONEG+60(RBLKPTR),B'00000100'                     2036
*QBINVAON:                                                         2037
*   RPLOINV=ON;                     /* INVALID                       */
QBINVAON OI    RPLOINV+60(RBLKPTR),B'00000010'                     2037
*IBSONTAB:                          /* IBSQAC-BIT TURN ON TABLE      */
*IBSETON:                                                          2038
*   RPLISET=ON;                     /* SET                           */
IBSONTAB DS    0H                                                  2038
IBSETON  OI    RPLISET+60(RBLKPTR),B'10000000'                     2038
*IBTESTON:                                                         2039
*   RPLITST=ON;                     /* TESTSET                       */
IBTESTON OI    RPLITST+60(RBLKPTR),B'01000000'                     2039
*IBRESEON:                                                         2040
*   RPLIRSET=ON;                    /* RESET                         */
IBRESEON OI    RPLIRSET+60(RBLKPTR),B'00100000'                    2040
*IBIGNOON:                                                         2041
*   RPLIIGN=ON;                     /* IGNORE                        */
IBIGNOON OI    RPLIIGN+60(RBLKPTR),B'00010000'                     2041
*IBTSTPON:                                                         2042
*   RPLIPOS=ON;                     /* TESTPOS                       */
IBTSTPON OI    RPLIPOS+60(RBLKPTR),B'00001000'                     2042
*IBTSTNON:                                                         2043
*   RPLINEG=ON;                     /* TESTNEG                       */
IBTSTNON OI    RPLINEG+60(RBLKPTR),B'00000100'                     2043
*IBINVAON:                                                         2044
*   RPLIINV=ON;                     /* INVALID                       */
IBINVAON OI    RPLIINV+60(RBLKPTR),B'00000010'                     2044
*SSOONTAB:                          /* SSENSEO-BIT TURN ON TABLE     */
*SOCPMON:                                                          2045
*   RPLCPMO=ON;                     /* CPM                           */
SSOONTAB DS    0H                                                  2045
SOCPMON  OI    RPLCPMO+76(RBLKPTR),B'01000000'                     2045
*SOSTATON:                                                         2046
*   RPLSTATO=ON;                    /* STATE                         */
SOSTATON OI    RPLSTATO+76(RBLKPTR),B'00100000'                    2046
*SOFION:                                                           2047
*   RPLFIO=ON;                      /* FI                            */
SOFION   OI    RPLFIO+76(RBLKPTR),B'00010000'                      2047
*SORRON:                                                           2048
*   RPLRRO=ON;                      /* RR                            */
SORRON   OI    RPLRRO+76(RBLKPTR),B'00001000'                      2048
*SSIONTAB:                          /* SSENSEI-BIT TURN ON TABLE     */
*SIPATHON:                                                         2049
*   RPLPATHI=ON;                    /* PATH                          */
SSIONTAB DS    0H                                                  2049
SIPATHON OI    RPLPATHI+76(RBLKPTR),B'10000000'                    2049
*SICPMON:                                                          2050
*   RPLCPMI=ON;                     /* CPM                           */
SICPMON  OI    RPLCPMI+76(RBLKPTR),B'01000000'                     2050
*SISTATON:                                                         2051
*   RPLSTATI=ON;                    /* STATE                         */
SISTATON OI    RPLSTATI+76(RBLKPTR),B'00100000'                    2051
*SIFION:                                                           2052
*   RPLFII=ON;                      /* FI                            */
SIFION   OI    RPLFII+76(RBLKPTR),B'00010000'                      2052
*SIRRON:                                                           2053
*   RPLRRI=ON;                      /* RR                            */
SIRRON   OI    RPLRRI+76(RBLKPTR),B'00001000'                      2053
*AIXONTAB:                          /* AIXFLAG-BIT TURN ON TABLE     */
*AIAIXON:                                                          2054
*   RPLAXPKP=ON;                    /* AIXPKP                        */
AIXONTAB DS    0H                                                  2054
AIAIXON  OI    RPLAXPKP(RBLKPTR),B'10000000'                       2054
*CODONTAB:                          /* CODESEL BIT TURN ON TABLE     */
*CODSTDON:                                                         2055
*   RPLCSI=OFF;                     /* STANDARD                      */
CODONTAB DS    0H                                                  2055
CODSTDON NI    RPLCSI+16(RBLKPTR),B'11110111'                      2055
*CODALTON:                                                         2056
*   RPLCSI=ON;                      /* ALT                           */
CODALTON OI    RPLCSI+16(RBLKPTR),B'00001000'                      2056
*CRONTAB:                           /* CRYPT BIT TURN ON TABLE     2057
*                                                            @G40KSCM*/
*CRYESON:                                                          2057
*   RPLTCRYP=ON;                    /* YES                   @G40KSCM*/
CRONTAB  DS    0H                                                  2057
CRYESON  OI    RPLTCRYP(RBLKPTR),B'00001000'                       2057
*CRNOON:                                                           2058
*   RPLTCRYP=OFF;                   /* NO                    @G40KSCM*/
CRNOON   NI    RPLTCRYP(RBLKPTR),B'11110111'                       2058
*ERONTAB:                           /* ENCR BIT TURN ON TABLE      2059
*                                                            @G40KSCM*/
*ERSELON:                                                          2059
*   NIBTSEL=ON;                     /* TURN ON SEL           @G40KSCM*/
ERONTAB  DS    0H                                                  2059
ERSELON  OI    NIBTSEL(RBLKPTR),B'00000100'                        2059
*ERREQON:                                                          2060
*   NIBTREQ=ON;                     /* TURN ON REQ           @G40KSCM*/
ERREQON  OI    NIBTREQ(RBLKPTR),B'00000010'                        2060
*ERNONON:                                                          2061
*   GEN(NOP 0);                     /* NO ACTION FOR NONE    @G40KSCM*/
ERNONON  NOP 0
*ATOFTAB:                           /* ATRB- BIT TURN OFF TABLE      */
*ATNOACT:                           /* NOACTION                      */
*MACOFTAB:                          /* MACRF-BIT TURN OFF TABLE      */
*MANOACT:                                                          2062
*   GEN(NOP 0);                     /* NOACTION                      */
ATOFTAB  DS    0H                                                  2062
ATNOACT  DS    0H                                                  2062
MACOFTAB DS    0H                                                  2062
MANOACT  NOP 0
*MAKEYOFF:                                                         2063
*   EXMAKEY=ON;                     /* MACRF(KEY)                    */
MAKEYOFF OI    EXMAKEY(REG13),B'00000100'                          2063
*MAADROFF:                          /* MACRF(ADR)                    */
*MACNVOFF:                                                         2064
*   GEN(BAL REG8,MAADREX);          /* MACRF(CNV)                    */
MAADROFF DS    0H                                                  2064
MACNVOFF BAL REG8,MAADREX
*MASEQOFF:                                                         2065
*   EXMASEQ=ON;                     /* MACRF(SEQ)                    */
MASEQOFF OI    EXMASEQ(REG13),B'00000010'                          2065
*MASKPOFF:                          /* MACRF(SKP)                    */
*MADIROFF:                                                         2066
*   GEN(BAL REG8,MASKPEX);          /* MACRF(DIR)                    */
MASKPOFF DS    0H                                                  2066
MADIROFF BAL REG8,MASKPEX
*MAINOFF:                                                          2067
*   EXMAIN=ON;                      /* MACRF(IN)                     */
MAINOFF  OI    EXMAIN(REG13),B'00001000'                           2067
*MAOUTOFF:                                                         2068
*   GEN(BAL REG8,MAOUTEX);          /* MACRF(OUT)                    */
MAOUTOFF BAL REG8,MAOUTEX
*MALSROFF:                          /* MACRF(LSR)                    */
*MAGSROFF:                          /* MACRF(GSR)                    */
*MANSROFF:                                                         2069
*   ACBLSR=OFF;                     /* MACRF(NSR)                    */
MALSROFF DS    0H                                                  2069
MAGSROFF DS    0H                                                  2069
MANSROFF DS    0H                                                  2070
*   ACBGSR=OFF;                                                    2070
         NI    ACBLSR(RBLKPTR),B'10011111'                         2070
*MALOGOFF:                                                         2071
*MANLOOFF:                                                         2071
*   GEN(BAL REG8,VTAMTEST);                                        2071
MALOGOFF DS    0H                                                  2071
MANLOOFF BAL REG8,VTAMTEST
*BRHOFTAB:                          /* BRANCH - BIT TURN OFF TABLE   */
*BRNOACT:                           /* NO ACTION                     */
*CATOFTAB:                          /* CATALOG- BIT TURN OFF TABLE   */
*CATNOACT:                          /* NOACTION                      */
*CRAOFTAB:                          /* CRA BIT TURN OFF TABLE      2072
*                                                            @G40KSCM*/
*CROFTAB:                           /* CRA/CRYPT BIT TURN OFF TABLE
*                                                            @G40KSCM*/
*CRNOACT:                                                          2072
*   GEN(NOP 0);                     /* NOACTION                      */
BRHOFTAB DS    0H                                                  2072
BRNOACT  DS    0H                                                  2072
CATOFTAB DS    0H                                                  2072
CATNOACT DS    0H                                                  2072
CRAOFTAB DS    0H                                                  2072
CROFTAB  DS    0H                                                  2072
CRNOACT  NOP 0
*CRSCROFF:                          /* CRA(SCRA)                     */
*CRUCROFF:                                                         2073
*   ACBSCRA=OFF;                    /* CRA(UCRA)                     */
CRSCROFF DS    0H                                                  2073
CRUCROFF DS    0H                                                  2074
*   ACBUCRA=OFF;                                                   2074
         NI    ACBSCRA(RBLKPTR),B'11110011'                        2074
*OFLOFTAB:                          /* OFLAGS BIT TURN OFF TABLE     */
*OFOPEOFF:                          /* NOACTION                      */
*OPEOFTAB:                          /* OPENOBJ BIT TURN OFF TABLE    */
*OPENOACT:                          /* NOACTION                      */
*DATOFTAB:                          /* DATAFLAGS BIT TURN OFF TABLE  */
*DANOACT:                           /* NOACTION                      */
*OPTOFTAB:                                                         2075
*OPNOACT:                                                          2075
*   GEN(NOP 0);                     /* NOACTION                      */
OFLOFTAB DS    0H                                                  2075
OFOPEOFF DS    0H                                                  2075
OPEOFTAB DS    0H                                                  2075
OPENOACT DS    0H                                                  2075
DATOFTAB DS    0H                                                  2075
DANOACT  DS    0H                                                  2075
OPTOFTAB DS    0H                                                  2075
OPNOACT  NOP 0
*OPKEYOFF:                          /* OPTCD(KEY)                    */
*OPADROFF:                          /* OPTCD(ADR)                    */
*OPCNVOFF:                                                         2076
*   RPLKEY=OFF;                     /* OPTCD(CNV)                    */
OPKEYOFF DS    0H                                                  2076
OPADROFF DS    0H                                                  2076
OPCNVOFF DS    0H                                                  2077
*   RPLADR=OFF;                                                    2077
*   RPLCNV=OFF;                                                    2078
         NI    RPLKEY(RBLKPTR),B'00011111'                         2078
*OPSEQOFF:                          /* OPTCD(SEQ)                    */
*OPDIROFF:                          /* OPTCD(DIR)                    */
*OPSKPOFF:                          /* OPTCD(SKP)                    */
*   RPLSEQ=OFF;                                                    2079
OPSEQOFF DS    0H                                                  2079
OPDIROFF DS    0H                                                  2079
OPSKPOFF DS    0H                                                  2080
*   RPLDIR=OFF;                                                    2080
*   RPLSKP=OFF;                                                    2081
         NI    RPLSEQ(RBLKPTR),B'10001111'                         2081
*OPUPDOFF:                          /* OPTCD(UPD)                    */
*OPNUPOFF:                          /* OPTCD(NUP)                    */
*OPNSPOFF:                          /* OPTCD(NSP)                    */
*   RPLUPD=OFF;                                                    2082
OPUPDOFF DS    0H                                                  2082
OPNUPOFF DS    0H                                                  2082
OPNSPOFF DS    0H                                                  2083
*   RPLNSP=OFF;                                                    2083
         NI    RPLUPD(RBLKPTR),B'11111100'                         2083
*OPNEROFF:                          /* OPTCD(NERAS)                  */
*OPEAUOFF:                          /* OPTCD(EAU)                    */
*OPERAOFF:                          /* OPTCD(ERASE)                  */
*   RPLNERAS=OFF;                                                  2084
OPNEROFF DS    0H                                                  2084
OPEAUOFF DS    0H                                                  2084
OPERAOFF DS    0H                                                  2085
*   RPLEAU=OFF;                                                    2085
*   RPLERACE=OFF;                                                  2086
         NI    RPLNERAS(RBLKPTR),B'11100011'                       2086
*OPLBTOFF:                          /* OPTCD(LBT)                    */
*OPLBMOFF:                          /* OPTCD(LBM)                    */
*OPBLKOFF:                          /* OPTCD(BLK)                    */
*   RPLEOT=OFF;                                                    2087
OPLBTOFF DS    0H                                                  2087
OPLBMOFF DS    0H                                                  2087
OPBLKOFF DS    0H                                                  2088
*   RPLEOB=OFF;                                                    2088
*   RPLEOM=OFF;                                                    2089
         NI    RPLEOT(RBLKPTR),B'00011111'                         2089
*OPCONOFF:                          /* OPTCD(COND)                   */
*OPUCOOFF:                          /* OPTCD(UNCOND)                 */
*OPLOCOFF:                          /* DPTCD(LOCK)                   */
*   RPLCOND=OFF;                                                   2090
OPCONOFF DS    0H                                                  2090
OPUCOOFF DS    0H                                                  2090
OPLOCOFF DS    0H                                                  2091
*   RPLNCOND=OFF;                                                  2091
*   RPLLOCK=OFF;                                                   2092
         NI    RPLCOND(RBLKPTR),B'11100011'                        2092
*OPLOGOFF:                          /* OPTCD(LOGONMSG)               */
*OPDEVOFF:                          /* OPTCD(DEVCHAR)                */
*OPTEROFF:                          /* OPTCD(TERMS)                  */
*OPAPPOFF:                          /* OPTCD(APPSTAT)                */
*OPCOUOFF:                          /* OPTCD(COUNTS)                 */
*OPRNNOFF:                          /* OPTCD(RNNAME)                 */
*OPCIDOFF:                          /* OPTCD(CIDXLATE)               */
*OPTOPOFF:                          /* OPTCD(TOPLOGON)               */
*OPBSCOFF:                          /* OPTCD(BSCID)                  */
*OPDISOFF:                          /* OPTCD(DISPLAY)                */
*OPSEPOFF:                          /* OPTCD(SESSPARM)       @ZA07555*/
*OPSEKOFF:                          /* OPTCD(SESSKEY)        @G40KSCM*/
*   GEN(BAL REG8,OPLOGEX);          /* SPECIAL CASE                  */
OPLOGOFF DS    0H                                                  2093
OPDEVOFF DS    0H                                                  2093
OPTEROFF DS    0H                                                  2093
OPAPPOFF DS    0H                                                  2093
OPCOUOFF DS    0H                                                  2093
OPRNNOFF DS    0H                                                  2093
OPCIDOFF DS    0H                                                  2093
OPTOPOFF DS    0H                                                  2093
OPBSCOFF DS    0H                                                  2093
OPDISOFF DS    0H                                                  2093
OPSEPOFF DS    0H                                                  2093
OPSEKOFF BAL REG8,OPLOGEX
*OPPENOFF:                          /* OPTCD(PEND)                   */
*OPSESOFF:                          /* OPTCD(SESSION)                */
*OPACTOFF:                          /* OPTCD(ACTIVE)                 */
*OPUNCOFF:                          /* OPTCD(UNCONDL)                */
*   RPLPEND=OFF;                                                   2094
OPPENOFF DS    0H                                                  2094
OPSESOFF DS    0H                                                  2094
OPACTOFF DS    0H                                                  2094
OPUNCOFF DS    0H                                                  2095
*   RPLSESS=OFF;                                                   2095
*   RPLACTV=OFF;                                                   2096
*   RPLUNCON=OFF;                                                  2097
         NI    RPLPEND(RBLKPTR),B'11100001'                        2097
*OPQUIOFF:                          /* OPTCD(QUIESE)                 */
*OPSTAOFF:                          /* OPTCD(START)                  */
*OPSTOOFF:                          /* OPTCD(STOP)                   */
*   RPLQUIES=OFF;                                                  2098
OPQUIOFF DS    0H                                                  2098
OPSTAOFF DS    0H                                                  2098
OPSTOOFF DS    0H                                                  2099
*   RPLSTART=OFF;                                                  2099
*   RPLSTOP=OFF;                                                   2100
         NI    RPLQUIES+76(RBLKPTR),B'00011111'                    2100
*OPACCOFF:                          /* OPTCD(ACCEPT)                 */
*OPACQOFF:                          /* OPTCD(ACQUIRE)                */
*   RPLODACP=OFF;                                                  2101
OPACCOFF DS    0H                                                  2101
OPACQOFF DS    0H                                                  2102
*   RPLODACQ=OFF;                                                  2102
         NI    RPLODACP(RBLKPTR),B'00111111'                       2102
*OPCALOFF:                          /* OPTCD(CONALL)                 */
*OPCANOFF:                          /* OPTCD(CONANY)                 */
*   RPLCNALL=OFF;                                                  2103
OPCALOFF DS    0H                                                  2103
OPCANOFF DS    0H                                                  2104
*   RPLCNANY=OFF;                                                  2104
         NI    RPLCNALL(RBLKPTR),B'00111111'                       2104
*OPKEEOFF:                          /* OPTCD(KEEP)                   */
*OPTRUOFF:                          /* OPTCD(TRUNC)                  */
*OPNIBOFF:                          /* OPTCD(NIBTK)                  */
*   RPLKEEP=OFF;                                                   2105
OPKEEOFF DS    0H                                                  2105
OPTRUOFF DS    0H                                                  2105
OPNIBOFF DS    0H                                                  2106
*   RPLTRUNC=OFF;                                                  2106
*   RPLNIBTK=OFF;                                                  2107
         NI    RPLKEEP+76(RBLKPTR),B'10001111'                     2107
*LISOFTAB:                          /* LISTEND BIT TURN OFF TABLE    */
*LINOACT:                           /* NOACTION                      */
*CONOFTAB:                          /* CON BIT TURN OFF TABLE        */
*CONOACT:                           /* NOACTION                      */
*PROOFTAB:                                                         2108
*PRNOACT:                                                          2108
*   GEN(NOP 0);                     /* NOACTION                      */
LISOFTAB DS    0H                                                  2108
LINOACT  DS    0H                                                  2108
CONOFTAB DS    0H                                                  2108
CONOACT  DS    0H                                                  2108
PROOFTAB DS    0H                                                  2108
PRNOACT  NOP 0
*PRMSGOFF:                          /* PROC(MSG)                     */
*PRTRAOFF:                          /* PROC(TRANS)                   */
*PRCONOFF:                          /* PROC(CONT)                    */
*PRBLOOFF:                          /* PROC(BLOCK)                   */
*   PROMODM=OFF;                                                   2109
PRMSGOFF DS    0H                                                  2109
PRTRAOFF DS    0H                                                  2109
PRCONOFF DS    0H                                                  2109
PRBLOOFF DS    0H                                                  2110
*   PROMODT=OFF;                                                   2110
*   PROMODC=OFF;                                                   2111
*   PROMODB=OFF;                                                   2112
         NI    PROMODM+36(RBLKPTR),B'11110000'                     2112
*PRCAOFF:                           /* CA                            */
*PRCSOFF:                           /* CS                            */
*PRRPLCOF:                          /* RPLC                          */
*   PROCA=OFF;                                                     2113
PRCAOFF  DS    0H                                                  2113
PRCSOFF  DS    0H                                                  2113
PRRPLCOF DS    0H                                                  2114
*   PROCS=OFF;                                                     2114
*   PRORPLC=OFF;                                                   2115
         NI    PROCA+36(RBLKPTR),B'11111000'                       2115
*EROFTAB:                           /* ENCR BIT TURN OFF TABLE     2116
*                                                            @G40KSCM*/
*ERSELOF:                           /* SEL                   @G40KSCM*/
*ERREQOF:                           /* REQ                   @G40KSCM*/
*ERNONOF:                           /* NONE                  @G40KSCM*/
*   NIBTSEL=OFF;                    /* TURN OFF SEL          @G40KSCM*/
EROFTAB  DS    0H                                                  2116
ERSELOF  DS    0H                                                  2116
ERREQOF  DS    0H                                                  2116
ERNONOF  DS    0H                                                  2117
*   NIBTREQ=OFF;                    /* TURN OFF REQ          @G40KSCM*/
         NI    NIBTSEL(RBLKPTR),B'11111001'                        2117
*SDTOFTAB:                          /* SDT- BIT TURN OFF TABLE       */
*SDNOACT:                           /* NOACTION                      */
*BRAOFTAB:                          /* BRACKET- BIT TURN OF TABLE    */
*BRANOACT:                          /* NOACTION                      */
*CHGOFTAB:                          /* CHNGDIR- BIT TURN OFF TABLE   */
*CHGNOACT:                          /* NOACTION                      */
*STYOFTAB:                          /* STYPE- BIT TURN OFF TABLE     */
*STNOACT:                           /* NOACTION                      */
*RTYOFTAB:                          /* RTYPE- BIT TURN OFF TABLE     */
*RTNOACT:                           /* NOACTION                      */
*CHAOFTAB:                                                         2118
*CHNOACT:                                                          2118
*   GEN(NOP 0);                     /* NOACTION                      */
SDTOFTAB DS    0H                                                  2118
SDNOACT  DS    0H                                                  2118
BRAOFTAB DS    0H                                                  2118
BRANOACT DS    0H                                                  2118
CHGOFTAB DS    0H                                                  2118
CHGNOACT DS    0H                                                  2118
STYOFTAB DS    0H                                                  2118
STNOACT  DS    0H                                                  2118
RTYOFTAB DS    0H                                                  2118
RTNOACT  DS    0H                                                  2118
CHAOFTAB DS    0H                                                  2118
CHNOACT  NOP 0
*CHFIROFF:                          /* CHAIN(FIRST)                  */
*CHMIDOFF:                          /* CHAIN(MIDDLE)                 */
*CHLASOFF:                          /* CHAIN(LAST)                   */
*CHONLOFF:                          /* CHAIN(ONLY)                   */
*   RPLFIRST=OFF;                                                  2119
CHFIROFF DS    0H                                                  2119
CHMIDOFF DS    0H                                                  2119
CHLASOFF DS    0H                                                  2119
CHONLOFF DS    0H                                                  2120
*   RPLMIDLE=OFF;                                                  2120
*   RPLLAST=OFF;                                                   2121
*   RPLONLY=OFF;                                                   2122
         NI    RPLFIRST+16(RBLKPTR),B'00001111'                    2122
*POSOFTAB:                          /* POST- BIT TURN OF TABLE       */
*PONOACT:                           /* NOACTION                      */
*RESOFTAB:                          /* RESPOND- BIT TURN OFF TABLE   */
*RENOACT:                           /* NOACTION                      */
*CNTOFTAB:                          /* CONTROL BIT TURN OFF TABLE    */
*CNNOACT:                                                          2123
*   GEN(NOP 0);                     /* NOACTION                      */
POSOFTAB DS    0H                                                  2123
PONOACT  DS    0H                                                  2123
RESOFTAB DS    0H                                                  2123
RENOACT  DS    0H                                                  2123
CNTOFTAB DS    0H                                                  2123
CNNOACT  NOP 0
*CNDATOFF:                                                         2124
*CNCANOFF:                                                         2124
*CNQCOFF:                                                          2124
*CNQECOFF:                                                         2124
*CNCHAOFF:                                                         2124
*CNRELOFF:                                                         2124
*CNBIDOFF:                                                         2124
*CNRTROFF:                                                         2124
*CNLUSOFF:                                                         2124
*CNSIGOFF:                                                         2124
*CNSDTOFF:                                                         2124
*CNCLEOFF:                                                         2124
*CNSTSOFF:                                                         2124
*CNSHUOFF:                                                         2124
*CNRQROFF:                                                         2124
*CNRSHOFF:                                                         2124
*CNSHCOFF:                          /*                       @ZA07554*/
*CNBINOFF:                          /*                       @G40KSCM*/
*CNUNBOFF:                          /*                       @G40KSCM*/
*CNSBIOFF:                          /*                       @G40KSCM*/
*CNBISOFF:                          /*                       @G40KSCM*/
*   GEN(BAL REG8,CNDATEX);          /* SPECIAL CASE                  */
CNDATOFF DS    0H                                                  2124
CNCANOFF DS    0H                                                  2124
CNQCOFF  DS    0H                                                  2124
CNQECOFF DS    0H                                                  2124
CNCHAOFF DS    0H                                                  2124
CNRELOFF DS    0H                                                  2124
CNBIDOFF DS    0H                                                  2124
CNRTROFF DS    0H                                                  2124
CNLUSOFF DS    0H                                                  2124
CNSIGOFF DS    0H                                                  2124
CNSDTOFF DS    0H                                                  2124
CNCLEOFF DS    0H                                                  2124
CNSTSOFF DS    0H                                                  2124
CNSHUOFF DS    0H                                                  2124
CNRQROFF DS    0H                                                  2124
CNRSHOFF DS    0H                                                  2124
CNSHCOFF DS    0H                                                  2124
CNBINOFF DS    0H                                                  2124
CNUNBOFF DS    0H                                                  2124
CNSBIOFF DS    0H                                                  2124
CNBISOFF BAL REG8,CNDATEX
*QBSOFTAB:                                                         2125
*QBSETOFF:                          /* QBSQAC(SET)                   */
*QBTESOFF:                          /* QBSQAC(TESTSET)               */
*QBRESOFF:                          /* QBSQAC(RESET)                 */
*QBIGNOFF:                          /* QBSQAC(IGNORE)                */
*QBTSPOFF:                          /* QBSQAC(TESTPOS)               */
*QBTSNOFF:                          /* QBSQAC(TESTNEG)               */
*QBINVOFF:                          /* QBSQAC(INVALID)               */
*   RPLOSET=OFF;                                                   2125
QBSOFTAB DS    0H                                                  2125
QBSETOFF DS    0H                                                  2125
QBTESOFF DS    0H                                                  2125
QBRESOFF DS    0H                                                  2125
QBIGNOFF DS    0H                                                  2125
QBTSPOFF DS    0H                                                  2125
QBTSNOFF DS    0H                                                  2125
QBINVOFF DS    0H                                                  2126
*   RPLOTST=OFF;                                                   2126
*   RPLORSET=OFF;                                                  2127
*   RPLOIGN=OFF;                                                   2128
*   RPLOPOS=OFF;                                                   2129
*   RPLONEG=OFF;                                                   2130
*   RPLOINV=OFF;                                                   2131
         NI    RPLOSET+60(RBLKPTR),B'00000001'                     2131
*IBSOFTAB:                                                         2132
*IBSETOFF:                          /* IBSQAC(SET)                   */
*IBTESOFF:                          /* IBSQAC(TESTSET)               */
*IBRESOFF:                          /* IBSQAC(RESET)                 */
*IBIGNOFF:                          /* IBSQAC(IGNORE)                */
*IBTSPOFF:                          /* IBSQAC(TESTPOS)               */
*IBTSNOFF:                          /* IBSQAC(TESTNEG)               */
*IBINVOFF:                          /* IBSQAC(INVALID)               */
*   RPLISET=OFF;                                                   2132
IBSOFTAB DS    0H                                                  2132
IBSETOFF DS    0H                                                  2132
IBTESOFF DS    0H                                                  2132
IBRESOFF DS    0H                                                  2132
IBIGNOFF DS    0H                                                  2132
IBTSPOFF DS    0H                                                  2132
IBTSNOFF DS    0H                                                  2132
IBINVOFF DS    0H                                                  2133
*   RPLITST=OFF;                                                   2133
*   RPLIRSET=OFF;                                                  2134
*   RPLIIGN=OFF;                                                   2135
*   RPLIPOS=OFF;                                                   2136
*   RPLINEG=OFF;                                                   2137
*   RPLIINV=OFF;                                                   2138
         NI    RPLISET+60(RBLKPTR),B'00000001'                     2138
*SSOOFTAB:                                                         2139
*SOCPMOFF:                          /* SSENSEO(CPM)                  */
*SOSTAOFF:                          /* SSENSEO(STATE)                */
*SOFIOFF:                           /* SSENSEO(FI)                   */
*SORROFF:                           /* SSENSEO(RR)                   */
*   RPLCPMO=OFF;                                                   2139
SSOOFTAB DS    0H                                                  2139
SOCPMOFF DS    0H                                                  2139
SOSTAOFF DS    0H                                                  2139
SOFIOFF  DS    0H                                                  2139
SORROFF  DS    0H                                                  2140
*   RPLSTATO=OFF;                                                  2140
*   RPLFIO=OFF;                                                    2141
*   RPLRRO=OFF;                                                    2142
         NI    RPLCPMO+76(RBLKPTR),B'10000111'                     2142
*SSIOFTAB:                                                         2143
*SIPATOFF:                          /* SSENSEI(PATH)                 */
*SICPMOFF:                          /* SSENSEI(CPM)                  */
*SISTAOFF:                          /* SSENSEI(STATE)                */
*SIFIOFF:                           /* SSENSEI(FI)                   */
*SIRROFF:                           /* SSENSEI(RR)                   */
*   RPLPATHI=OFF;                                                  2143
SSIOFTAB DS    0H                                                  2143
SIPATOFF DS    0H                                                  2143
SICPMOFF DS    0H                                                  2143
SISTAOFF DS    0H                                                  2143
SIFIOFF  DS    0H                                                  2143
SIRROFF  DS    0H                                                  2144
*   RPLCPMI=OFF;                                                   2144
*   RPLSTATI=OFF;                                                  2145
*   RPLFII=OFF;                                                    2146
*   RPLRRI=OFF;                                                    2147
         NI    RPLPATHI+76(RBLKPTR),B'00000111'                    2147
*AIXOFTAB:                          /* AIXFLAG- BIT UTRN OFF TABLE   */
*AINOACT:                           /* NOACTION                      */
*CODOFTAB:                          /* CODSEL BIT TURN OFF TABLE     */
*CODNOACT:                          /* NOACTION                      */
*   GEN(NOP 0);                                                    2148
AIXOFTAB DS    0H                                                  2148
AINOACT  DS    0H                                                  2148
CODOFTAB DS    0H                                                  2148
CODNOACT NOP 0
*   RESPECIFY                                                      2149
*    (REG5,                                                        2149
*     REG6,                                                        2149
*     REG7,                                                        2149
*     REG8) RSTD;                                                  2149
*                                                                  2149
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR VTAM ONLY BITS                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2150
*VTAMTEST:                                                         2150
*   IF VTAMSW=OFF THEN              /* VTAM SPECIFIED                */
VTAMTEST TM    VTAMSW+1(RHDRPTR),B'00010000'                       2150
         BNZ   @RF02150                                            2150
*     DO;                           /* PROCESS ERROR                 */
*       REG0=VTAMONLY;              /* LOAD ERROR CODE               */
         LA    REG0,16                                             2152
*       GOTO EXITBAD;               /* EXIT WITH ERROR               */
         B     EXITBAD                                             2153
*     END;                                                         2154
*   GEN(BR REG8);                   /* RETURN TO CALLER              */
@RF02150 DS    0H                                                  2155
         BR REG8
*MAADREX:                           /* MACRF(ADR,CNV)                */
*   RESPECIFY                                                      2156
*     REG9 RSTD;                                                   2156
MAADREX  DS    0H                                                  2157
*   RELEMPTR=REG9;                  /* SAVE FLAGS                    */
         LR    RELEMPTR,REG9                                       2157
*   RESPECIFY                                                      2158
*     REG9 UNRSTD;                                                 2158
*   IF((FTCBTC&VTAMCORR)=GENCB)     /* GENCB                         */
*       &(KEYEXON=OFF) THEN         /* KEY DEFAULTED                 */
         LH    @09,FTCBTC(,RHDRPTR)                                2159
         N     @09,@CF00034                                        2159
         C     @09,@CF00081                                        2159
         BNE   @RF02159                                            2159
         TM    KEYEXON(REG13),B'00000100'                          2159
         BNZ   @RF02159                                            2159
*     ACBKEY=OFF;                   /* TURN OFF UNWANTED KEY FLAG    */
         NI    ACBKEY(RBLKPTR),B'01111111'                         2160
*   RESPECIFY                                                      2161
*     REG9 RSTD;                                                   2161
@RF02159 DS    0H                                                  2162
*   REG9=RELEMPTR;                  /* RESTORE FLAGS                 */
         LR    REG9,RELEMPTR                                       2162
*   RESPECIFY                                                      2163
*     REG9 UNRSTD;                                                 2163
*   GEN(BR REG8);                   /* RETURN TO CALLER              */
         BR REG8
*MASKPEX:                           /* MACRF(SKP,DIR)                */
*   RESPECIFY                                                      2165
*     REG9 RSTD;                                                   2165
MASKPEX  DS    0H                                                  2166
*   RELEMPTR=REG9;                  /* SAVE FLAGS                    */
         LR    RELEMPTR,REG9                                       2166
*   RESPECIFY                                                      2167
*     REG9 UNRSTD;                                                 2167
*   IF((FTCBTC&VTAMCORR)=GENCB)     /* GENCB                         */
*       &(EXMASEQ=OFF) THEN         /* SEQ DEFAULTED                 */
         LH    @09,FTCBTC(,RHDRPTR)                                2168
         N     @09,@CF00034                                        2168
         C     @09,@CF00081                                        2168
         BNE   @RF02168                                            2168
         TM    EXMASEQ(REG13),B'00000010'                          2168
         BNZ   @RF02168                                            2168
*     ACBSEQ=OFF;                   /* TURN OFF UNWANTED SEQ FLAG    */
         NI    ACBSEQ(RBLKPTR),B'11101111'                         2169
*   RESPECIFY                                                      2170
*     REG9 RSTD;                                                   2170
@RF02168 DS    0H                                                  2171
*   REG9=RELEMPTR;                  /* RESTORE FLAGS                 */
         LR    REG9,RELEMPTR                                       2171
*   RESPECIFY                                                      2172
*     REG9 UNRSTD;                                                 2172
*   GEN(BR REG8);                   /* RETURN TO CALLER              */
         BR REG8
*MAOUTEX:                           /* MACRF(OUT)                    */
*   RESPECIFY                                                      2174
*     REG9 RSTD;                                                   2174
MAOUTEX  DS    0H                                                  2175
*   RELEMPTR=REG9;                  /* SAVE FLAGS                    */
         LR    RELEMPTR,REG9                                       2175
*   RESPECIFY                                                      2176
*     REG9 UNRSTD;                                                 2176
*   IF((FTCBTC&VTAMCORR)=GENCB)     /* GENCB                         */
*       &(INEXON=OFF) THEN          /* IN DEFAUTED                   */
         LH    @09,FTCBTC(,RHDRPTR)                                2177
         N     @09,@CF00034                                        2177
         C     @09,@CF00081                                        2177
         BNE   @RF02177                                            2177
         TM    INEXON(REG13),B'00001000'                           2177
         BNZ   @RF02177                                            2177
*     ACBIN=OFF;                    /* TURN OFF UNWANTED IN FLAG     */
         NI    ACBIN(RBLKPTR),B'11111011'                          2178
*   RESPECIFY                                                      2179
*     REG9 RSTD;                                                   2179
@RF02177 DS    0H                                                  2180
*   REG9=RELEMPTR;                  /* RESTORE FLAGS                 */
         LR    REG9,RELEMPTR                                       2180
*   RESPECIFY                                                      2181
*     REG9 UNRSTD;                                                 2181
*   GEN(BR REG8);                   /* RETURN TO CALLER              */
         BR REG8
*OPLOGEX:                           /* OPTCD(                        */
*   RESPECIFY                                                      2183
*     REG9 RSTD;                                                   2183
OPLOGEX  DS    0H                                                  2184
*   RELEMPTR=REG9;                  /* SAVE FLAGS                    */
         LR    RELEMPTR,REG9                                       2184
*   RESPECIFY                                                      2185
*     REG9 UNRSTD;                                                 2185
*   RPLLOGON=OFF;                   /* LOGONMSG                      */
*   RPLDEVCH=OFF;                   /* DEVCHAR                       */
*   RPLTERMS=OFF;                   /* TERMS                         */
*   RPLAPPST=OFF;                   /* APPSTAT                       */
*   RPLCOUNT=OFF;                   /* COUNTS                        */
*   RPLRNNM=OFF;                    /* RNNAME                        */
*   RPLCIDE=OFF;                    /* CIDXLATE                      */
*   RPLTOPL=OFF;                    /* TOPLOGON                      */
         LA    @09,76                                              2193
         ALR   @09,RBLKPTR                                         2193
         NI    RPLLOGON(@09),B'00000000'                           2193
*   RPLBSCID=OFF;                   /* BSCID                         */
*   RPLDSPLY=OFF;                   /* DISPLAY                       */
*   RPLSPARM=OFF;                   /* SESSPARM              @ZA07555*/
*   RPLTSKY=OFF;                    /* SESSKEY               @G40AKCM*/
         NI    RPLBSCID(@09),B'00001111'                           2197
*   RESPECIFY                                                      2198
*     REG9 RSTD;                                                   2198
*   REG9=RELEMPTR;                  /* RESTORE FLAGS                 */
         LR    REG9,RELEMPTR                                       2199
*   RESPECIFY                                                      2200
*     REG9 UNRSTD;                                                 2200
*   GEN(BR REG8);                   /* RETURN TO CALLER              */
         BR REG8
*CNDATEX:                           /* CONTROL                       */
*   RESPECIFY                                                      2202
*     REG9 RSTD;                                                   2202
CNDATEX  DS    0H                                                  2203
*   RELEMPTR=REG9;                  /* SAVE FLAGS                    */
         LR    RELEMPTR,REG9                                       2203
*   RESPECIFY                                                      2204
*     REG9 UNRSTD;                                                 2204
*   RPLDATA=OFF;                    /* DATA                          */
*   RPLCNCEL=OFF;                   /* CANCEL                        */
*   RPLQC=OFF;                      /* QC                            */
*   RPLQEC=OFF;                     /* QEC                           */
*   RPLCHASE=OFF;                   /* CHASE                         */
*   RPLRELQ=OFF;                    /* RELQ                          */
         LA    @09,16                                              2210
         ALR   @09,RBLKPTR                                         2210
         NI    RPLDATA(@09),B'00000011'                            2210
*   RPLBID=OFF;                     /* BID                           */
*   RPLRTR=OFF;                     /* RTR                           */
*   RPLLUS=OFF;                     /* LUS                           */
*   RPLSIGNL=OFF;                   /* SIGNAL                        */
         NI    RPLBID(@09),B'00001111'                             2214
*   RPLSDT=OFF;                     /* SDT                           */
*   RPLCLEAR=OFF;                   /* CLEAR                         */
*   RPLSTSN=OFF;                    /* STSN                          */
*   RPLSHUTD=OFF;                   /* SHUTD                         */
*   RPLRQR=OFF;                     /* RQR                           */
*   RPLRSHUT=OFF;                   /* RSHUT                         */
*   RPLSHUTC=OFF;                   /* SHUTC                 @ZA07554*/
         NI    RPLSDT(@09),B'00000001'                             2221
*   RPLTBIND=OFF;                   /* BIND                  @G40AKCM*/
*   RPLTUNBD=OFF;                   /* UNBIND                @G40AKCM*/
*   RPLSBI=OFF;                     /* SBI                   @G40AKCM*/
*   RPLBIS=OFF;                     /* BIS                   @G40AKCM*/
         NI    RPLTBIND(@09),B'11110000'                           2225
*   RESPECIFY                                                      2226
*     REG9 RSTD;                                                   2226
*   REG9=RELEMPTR;                  /* RESTORE FLAGS                 */
         LR    REG9,RELEMPTR                                       2227
*   RESPECIFY                                                      2228
*     REG9 UNRSTD;                                                 2228
*   GEN(BR REG8);                   /* RETURN TO CALLER              */
         BR REG8
*EXBITAB:                           /* EXCLUSIVE-BIT TURN ON TABLE   */
*EXGRP1:                                                           2230
*   EXBIT1=ON;                      /* BIT 1                         */
EXBITAB  DS    0H                                                  2230
EXGRP1   OI    EXBIT1(REG13),B'10000000'                           2230
*EXGRP2:                                                           2231
*   EXBIT2=ON;                      /* BIT 2                         */
EXGRP2   OI    EXBIT2(REG13),B'01000000'                           2231
*EXGRP3:                                                           2232
*   EXBIT3=ON;                      /* BIT 3                         */
EXGRP3   OI    EXBIT3(REG13),B'00100000'                           2232
*EXGRP4:                                                           2233
*   EXBIT4=ON;                      /* BIT 4                         */
EXGRP4   OI    EXBIT4(REG13),B'00010000'                           2233
*EXGRP5:                                                           2234
*   EXBIT5=ON;                      /* BIT 5                         */
EXGRP5   OI    EXBIT5(REG13),B'00001000'                           2234
*EXGRP6:                                                           2235
*   EXBIT6=ON;                      /* BIT 6                         */
EXGRP6   OI    EXBIT6(REG13),B'00000100'                           2235
*EXGRP7:                                                           2236
*   EXBIT7=ON;                      /* BIT 7                         */
EXGRP7   OI    EXBIT7(REG13),B'00000010'                           2236
*EXGRP8:                                                           2237
*   EXBIT8=ON;                      /* BIT 8                         */
EXGRP8   OI    EXBIT8(REG13),B'00000001'                           2237
*EXGRP9:                                                           2238
*   EXBIT9=ON;                      /* BIT 9                         */
EXGRP9   OI    EXBIT9(REG13),B'10000000'                           2238
*EXGRP10:                                                          2239
*   EXBIT10=ON;                     /* BIT 10                        */
EXGRP10  OI    EXBIT10(REG13),B'01000000'                          2239
*EXGRP11:                                                          2240
*   EXBIT11=ON;                     /* BIT 11                        */
EXGRP11  OI    EXBIT11(REG13),B'00100000'                          2240
*EXGRP12:                                                          2241
*   EXBIT12=ON;                     /* BIT 12                        */
EXGRP12  OI    EXBIT12(REG13),B'00010000'                          2241
*EXGRP13:                                                          2242
*   EXBIT13=ON;                     /* BIT 13                        */
EXGRP13  OI    EXBIT13(REG13),B'00001000'                          2242
*EXGRP14:                                                          2243
*   EXBIT14=ON;                     /* BIT 14                        */
EXGRP14  OI    EXBIT14(REG13),B'00000100'                          2243
*EXGRP15:                                                          2244
*   EXBIT15=ON;                     /* BIT 15                        */
EXGRP15  OI    EXBIT15(REG13),B'00000010'                          2244
*EXGRP16:                                                          2245
*   EXBIT16=ON;                     /* BIT 16                        */
EXGRP16  OI    EXBIT16(REG13),B'00000001'                          2245
*EXGRP17:                                                          2246
*   EXBIT17=ON;                     /* BIT 17                        */
EXGRP17  OI    EXBIT17(REG13),B'10000000'                          2246
*EXGRP18:                                                          2247
*   EXBIT18=ON;                     /* BIT 18                        */
EXGRP18  OI    EXBIT18(REG13),B'01000000'                          2247
*EXGRP19:                                                          2248
*   EXBIT19=ON;                     /* BIT 19                        */
EXGRP19  OI    EXBIT19(REG13),B'00100000'                          2248
*EXGRP20:                                                          2249
*   EXBIT20=ON;                     /* BIT 20                        */
EXGRP20  OI    EXBIT20(REG13),B'00010000'                          2249
*EXGRP21:                                                          2250
*   EXBIT21=ON;                     /* BIT 21                        */
EXGRP21  OI    EXBIT21(REG13),B'00001000'                          2250
*EXGRP22:                                                          2251
*   EXBIT22=ON;                     /* BIT 22                        */
EXGRP22  OI    EXBIT22(REG13),B'00000100'                          2251
*EXGRP23:                                                          2252
*   EXBIT23=ON;                     /* BIT 23                        */
EXGRP23  OI    EXBIT23(REG13),B'00000010'                          2252
*EXGRP24:                                                          2253
*   EXBIT24=ON;                     /* BIT 24                        */
EXGRP24  OI    EXBIT24(REG13),B'00000001'                          2253
*EXGRP25:                                                          2254
*   EXBIT25=ON;                     /* BIT 25                        */
EXGRP25  OI    EXBIT25(REG13),B'10000000'                          2254
*EXGRP26:                                                          2255
*   EXBIT26=ON;                     /* BIT 26                        */
EXGRP26  OI    EXBIT26(REG13),B'01000000'                          2255
*EXGRP27:                                                          2256
*   EXBIT27=ON;                     /* BIT 27                        */
EXGRP27  OI    EXBIT27(REG13),B'00100000'                          2256
*EXGRP28:                                                          2257
*   EXBIT28=ON;                     /* BIT 28                        */
EXGRP28  OI    EXBIT28(REG13),B'00010000'                          2257
*EXGRP29:                                                          2258
*   EXBIT29=ON;                     /* BIT 29                        */
EXGRP29  OI    EXBIT29(REG13),B'00001000'                          2258
*EXGRP30:                                                          2259
*   EXBIT30=ON;                     /* BIT 30                        */
EXGRP30  OI    EXBIT30(REG13),B'00000100'                          2259
*EXGRP31:                                                          2260
*   EXBIT31=ON;                     /* BIT 31                        */
EXGRP31  OI    EXBIT31(REG13),B'00000010'                          2260
*EXGRP32:                                                          2261
*   GEN( NOP 0);                    /* NOACTION                      */
EXGRP32   NOP 0
*                                                                  2262
*   /*****************************************************************/
*   /*                                                               */
*   /* EXCLUSIVE-BIT TEST TABLE                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2262
*EXTSTAB:                                                          2262
*EXTGRP1:                                                          2262
*   EXBIT1=ON;                      /* BIT 1                         */
EXTSTAB  DS    0H                                                  2262
EXTGRP1  OI    EXBIT1(REG13),B'10000000'                           2262
*   GEN(ORG EXTGRP1);               /* BACK UP TO OP CODE            */
         ORG EXTGRP1
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP2:                                                          2266
*   EXBIT2=ON;                      /* BIT 2                         */
EXTGRP2  OI    EXBIT2(REG13),B'01000000'                           2266
*   GEN(ORG EXTGRP2);               /* BACK UP TO OP CODE            */
         ORG EXTGRP2
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP3:                                                          2270
*   EXBIT3=ON;                      /* BIT 3                         */
EXTGRP3  OI    EXBIT3(REG13),B'00100000'                           2270
*   GEN(ORG EXTGRP3);               /* BACK UP TO OP CODE            */
         ORG EXTGRP3
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP4:                                                          2274
*   EXBIT4=ON;                      /* BIT 4                         */
EXTGRP4  OI    EXBIT4(REG13),B'00010000'                           2274
*   GEN(ORG EXTGRP4);               /* BACK UP TO OP CODE            */
         ORG EXTGRP4
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP5:                                                          2278
*   EXBIT5=ON;                      /* BIT 5                         */
EXTGRP5  OI    EXBIT5(REG13),B'00001000'                           2278
*   GEN(ORG EXTGRP5);               /* BACK UP TO OP CODE            */
         ORG EXTGRP5
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP6:                                                          2282
*   EXBIT6=ON;                      /* BIT 6                         */
EXTGRP6  OI    EXBIT6(REG13),B'00000100'                           2282
*   GEN(ORG EXTGRP6);               /* BACK UP TO OP CODE            */
         ORG EXTGRP6
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP7:                                                          2286
*   EXBIT7=ON;                      /* BIT 7                         */
EXTGRP7  OI    EXBIT7(REG13),B'00000010'                           2286
*   GEN(ORG EXTGRP7);               /* BACK UP TO OP CODE            */
         ORG EXTGRP7
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP8:                                                          2290
*   EXBIT8=ON;                      /* BIT 8                         */
EXTGRP8  OI    EXBIT8(REG13),B'00000001'                           2290
*   GEN(ORG EXTGRP8);               /* BACK UP TO OP CODE            */
         ORG EXTGRP8
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP9:                                                          2294
*   EXBIT9=ON;                      /* BIT 9                         */
EXTGRP9  OI    EXBIT9(REG13),B'10000000'                           2294
*   GEN(ORG EXTGRP9);               /* BACK UP TO OP CODE            */
         ORG EXTGRP9
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP10:                                                         2298
*   EXBIT10=ON;                     /* BIT 10                        */
EXTGRP10 OI    EXBIT10(REG13),B'01000000'                          2298
*   GEN(ORG EXTGRP10);              /* BACK UP TO OP CODE            */
         ORG EXTGRP10
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP11:                                                         2302
*   EXBIT11=ON;                     /* BIT 11                        */
EXTGRP11 OI    EXBIT11(REG13),B'00100000'                          2302
*   GEN(ORG EXTGRP11);              /* BACK UP TO OP CODE            */
         ORG EXTGRP11
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP12:                                                         2306
*   EXBIT12=ON;                     /* BIT 12                        */
EXTGRP12 OI    EXBIT12(REG13),B'00010000'                          2306
*   GEN(ORG EXTGRP12);              /* BACK UP TO OP CODE            */
         ORG EXTGRP12
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP13:                                                         2310
*   EXBIT13=ON;                     /* BIT 13                        */
EXTGRP13 OI    EXBIT13(REG13),B'00001000'                          2310
*   GEN(ORG EXTGRP13);              /* BACK UP TO OP CODE            */
         ORG EXTGRP13
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP14:                                                         2314
*   EXBIT14=ON;                     /* BIT 14                        */
EXTGRP14 OI    EXBIT14(REG13),B'00000100'                          2314
*   GEN(ORG EXTGRP14);              /* BACK UP TO OP CODE            */
         ORG EXTGRP14
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP15:                                                         2318
*   EXBIT15=ON;                     /* BIT 15                        */
EXTGRP15 OI    EXBIT15(REG13),B'00000010'                          2318
*   GEN(ORG EXTGRP15);              /* BACK UP TO OP CODE            */
         ORG EXTGRP15
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP16:                                                         2322
*   EXBIT16=ON;                     /* BIT 16                        */
EXTGRP16 OI    EXBIT16(REG13),B'00000001'                          2322
*   GEN(ORG EXTGRP16);              /* BACK UP TO OP CODE            */
         ORG EXTGRP16
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP17:                                                         2326
*   EXBIT17=ON;                     /* BIT 17                        */
EXTGRP17 OI    EXBIT17(REG13),B'10000000'                          2326
*   GEN(ORG EXTGRP17);              /* BACK UP TO OP CODE            */
         ORG EXTGRP17
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP18:                                                         2330
*   EXBIT18=ON;                     /* BIT 18                        */
EXTGRP18 OI    EXBIT18(REG13),B'01000000'                          2330
*   GEN(ORG EXTGRP18);              /* BACK UP TO OP CODE            */
         ORG EXTGRP18
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP19:                                                         2334
*   EXBIT19=ON;                     /* BIT 19                        */
EXTGRP19 OI    EXBIT19(REG13),B'00100000'                          2334
*   GEN(ORG EXTGRP19);              /* BACK UP TO OP CODE            */
         ORG EXTGRP19
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP20:                                                         2338
*   EXBIT20=ON;                     /* BIT 20                        */
EXTGRP20 OI    EXBIT20(REG13),B'00010000'                          2338
*   GEN(ORG EXTGRP20);              /* BACK UP TO OP CODE            */
         ORG EXTGRP20
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP21:                                                         2342
*   EXBIT21=ON;                     /* BIT 21                        */
EXTGRP21 OI    EXBIT21(REG13),B'00001000'                          2342
*   GEN(ORG EXTGRP21);              /* BACK UP TO OP CODE            */
         ORG EXTGRP21
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP22:                                                         2346
*   EXBIT22=ON;                     /* BIT 22                        */
EXTGRP22 OI    EXBIT22(REG13),B'00000100'                          2346
*   GEN(ORG EXTGRP22);              /* BACK UP TO OP CODE            */
         ORG EXTGRP22
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP23:                                                         2350
*   EXBIT23=ON;                     /* BIT 23                        */
EXTGRP23 OI    EXBIT23(REG13),B'00000010'                          2350
*   GEN(ORG EXTGRP23);              /* BACK UP TO OP CODE            */
         ORG EXTGRP23
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP24:                                                         2354
*   EXBIT24=ON;                     /* BIT 24                        */
EXTGRP24 OI    EXBIT24(REG13),B'00000001'                          2354
*   GEN(ORG EXTGRP24);              /* BACK UP TO OP CODE            */
         ORG EXTGRP24
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP25:                                                         2358
*   EXBIT25=ON;                     /* BIT 25                        */
EXTGRP25 OI    EXBIT25(REG13),B'10000000'                          2358
*   GEN(ORG EXTGRP25);              /* BACK UP TO OP CODE            */
         ORG EXTGRP25
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP26:                                                         2362
*   EXBIT26=ON;                     /* BIT 26                        */
EXTGRP26 OI    EXBIT26(REG13),B'01000000'                          2362
*   GEN(ORG EXTGRP26);              /* BACK UP TO OP CODE            */
         ORG EXTGRP26
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP27:                                                         2366
*   EXBIT27=ON;                     /* BIT 27                        */
EXTGRP27 OI    EXBIT27(REG13),B'00100000'                          2366
*   GEN(ORG EXTGRP27);              /* BACK UP TO OP CODE            */
         ORG EXTGRP27
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP28:                                                         2370
*   EXBIT28=ON;                     /* BIT 28                        */
EXTGRP28 OI    EXBIT28(REG13),B'00010000'                          2370
*   GEN(ORG EXTGRP28);              /* BACK UP TO OP CODE            */
         ORG EXTGRP28
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP29:                                                         2374
*   EXBIT29=ON;                     /* BIT 29                        */
EXTGRP29 OI    EXBIT29(REG13),B'00001000'                          2374
*   GEN(ORG EXTGRP29);              /* BACK UP TO OP CODE            */
         ORG EXTGRP29
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP30:                                                         2378
*   EXBIT30=ON;                     /* BIT 30                        */
EXTGRP30 OI    EXBIT30(REG13),B'00000100'                          2378
*   GEN(ORG EXTGRP30);              /* BACK UP TO OP CODE            */
         ORG EXTGRP30
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP31:                                                         2382
*   EXBIT31=ON;                     /* BIT 31                        */
EXTGRP31 OI    EXBIT31(REG13),B'00000010'                          2382
*   GEN(ORG EXTGRP31);              /* BACK UP TO OP CODE            */
         ORG EXTGRP31
*   GEN(DC X'91');                  /* CHANGE OP CODE TO TM          */
         DC X'91'
*   GEN(ORG);                       /* RESET INSTRUCTION COUNTER     */
         ORG
*EXTGRP32:                                                         2386
*   GEN( CR REG9,REG9);             /* NOACTION                      */
EXTGRP32  CR REG9,REG9
*   END IDA019C1                                                   2387
*                                                                  2387
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IDAELEM )                                       */
*/*%INCLUDE SYSLIB  (IDAGENC )                                       */
*/*%INCLUDE SYSLIB  (IDAMODC )                                       */
*/*%INCLUDE SYSLIB  (IDASHOW )                                       */
*/*%INCLUDE SYSLIB  (IDATEST )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IDABSPH )                                       */
*/*%INCLUDE SYSLIB  (IDABUFC )                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IFGACBVT)                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IFGEXLVT)                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                       */
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                       */
*/*%INCLUDE SYSLIB  (ISTPROCD)                                       */
*/*%INCLUDE SYSLIB  (ISTDEVCH)                                       */
*/*%INCLUDE SYSLIB  (ISTNIB  )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                       */
*                                                                  2387
*       ;                                                          2387
@DATA    DS    0H
@CH00984 DC    H'14'
@CH02063 DC    H'42'
@CH02061 DC    H'55'
@CH02065 DC    H'61'
@CH02067 DC    H'62'
@CH02069 DC    H'63'
@CH02071 DC    H'83'
@CH02114 DC    H'-1'
@SM04276 MVC   SHOWAREA(0,REG7),SHOWFLD(REG6)
@SC04278 CLC   USTSFLD(0,REG6),TESTAREA(REG7)
@DATD    DSECT
         DS    0F
IDA019C1 CSECT
         DS    0F
@CF00081 DC    F'1'
@CH00081 EQU   @CF00081+2
@CF00112 DC    F'2'
@CF00102 DC    F'3'
@CH00102 EQU   @CF00102+2
@CF00256 DC    F'4'
@CF00240 DC    F'5'
@CF00037 DC    F'8'
@CF00529 DC    F'11'
@CF00034 DC    F'15'
@CF00097 DC    F'16'
@CF00039 DC    F'31'
@CF02056 DC    F'41'
@CF02126 DC    F'4072'
@CF03362 DC    F'8190'
@DATD    DSECT
         DS    0D
DEBPTR   DS    A
DEBDAPTR DS    A
DEBEXPTR DS    A
DEBSBPTR DS    A
TCBPTR   DS    A
IDA019C1 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CA00028 DC    A(IDA019C1)
         DS    0D
BATPTR   DC    AL4(BATTAB)
@CB03619 DC    X'01000000'
@NM00113 DS    CL4
         ORG   @NM00113
@NM00114 DC    AL4(ENDKWTAB-KEYWDTAB)
         ORG   @NM00114
MAXKEYWD DS    CL4
         ORG   @NM00113+4
VTAMDDNM DC    X'FF00000000000000'
MASTERTB DS    CL3703
         ORG   MASTERTB
PROCTAB  DS    CL256
         ORG   PROCTAB
@NM00131 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(PRBLKLEN-PROCBRTB)
         DC    AL1(PRBLKLEN-PROCBRTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00132 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00133 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00134 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00135 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00136 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00137 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00138 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00139 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00140 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00141 DC    AL1(0)
         DC    AL1(PRACBGEN-PROCBRTB)
         DC    AL1(PRACBMOD-PROCBRTB)
         DC    AL1(PRACBSHO-PROCBRTB)
         DC    AL1(PRACBTES-PROCBRTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00142 DC    AL1(0)
         DC    AL1(PREXLSTG-PROCBRTB)
         DC    AL1(PREXLSTM-PROCBRTB)
         DC    AL1(PREXLSTS-PROCBRTB)
         DC    AL1(PREXLSTT-PROCBRTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00143 DC    AL1(0)
         DC    AL1(PRRPLGEN-PROCBRTB)
         DC    AL1(PRRPLMOD-PROCBRTB)
         DC    AL1(PRRPLSHO-PROCBRTB)
         DC    AL1(PRRPLTES-PROCBRTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00144 DC    AL1(0)
         DC    AL1(PRNIBGEN-PROCBRTB)
         DC    AL1(PRNIBMOD-PROCBRTB)
         DC    AL1(PRNIBSHO-PROCBRTB)
         DC    AL1(PRNIBTES-PROCBRTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00145 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00146 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   MASTERTB+256
OPTBIT02 DS    CL16
         ORG   OPTBIT02
@NM00147 DC    AL4(OPTBITAB+31*3)
@NM00148 DC    AL4(OPTONTB2)
@NM00149 DC    AL4(OPTOFTAB)
@NM00150 DC    XL4'00000000'
         ORG   MASTERTB+272
OPTBIT03 DS    CL16
         ORG   OPTBIT03
@NM00151 DC    AL4(OPTBITAB+63*3)
@NM00152 DC    AL4(OPTONTB3)
@NM00153 DC    AL4(OPTOFTAB)
@NM00154 DC    XL4'00000000'
         ORG   MASTERTB+288
PROBIT02 DS    CL16
         ORG   PROBIT02
@NM00155 DC    AL4(PROBITAB+31*3)
@NM00156 DC    AL4(PROONTB2)
@NM00157 DC    AL4(PROOFTAB)
@NM00158 DC    XL4'0000FFFF'
         ORG   MASTERTB+304
KEYWDTAB DS    CL2115
         ORG   KEYWDTAB
KW00     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW01     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP01-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00159 DC    AL2(0*16)
KW02     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDASPA-IDAAMDSB)
KW03     DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(ACBLENG-ACBCOMN)
KW04     DC    AL1(MABUFND-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(ACBBUFND-IFGACB)
KW05     DC    AL1(MABUFNI-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(ACBBUFNI-IFGACB)
KW06     DC    AL1(0)
         DC    AL1(KWTYP07-KWBRTAB)
         DC    AL1(KWTYP08-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(BUFDRNO-IDABUFDR)
KW07     DC    AL1(MABUFSP-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBBUFSP-IFGACB)
KW08     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDCINV-IDAAMDSB)
KW09     DC    AL1(MADDNAME-MACBKWTB)
         DC    AL1(KWTYP38-KWBRTAB)
         DC    AL1(KWTYP39-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(8)
         DC    AL1(ACBDDNM-IFGACB)
KW10     DC    AL1(0)
         DC    AL1(KWTYP09-KWBRTAB)
         DC    AL1(KWTYP0A-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ARDHRBA-IDAARDB)
KW11     DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(ACBERFLG-IFGACB)
KW12     DC    AL1(MAEXLST-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBUEL-IFGACB)
KW13     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(AMDFSCA-IDAAMDSB)
KW14     DC    AL1(MAMAREA-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBMSGAR-IFGACB)
KW15     DC    AL1(MAMLEN-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(ACBMSGLN-IFGACB)
KW16     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(AMDKEYLN-IDAAMDSB)
KW17     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDLRECL-IDAAMDSB)
KW18     DC    AL1(MABITSTR-MACBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00160 DC    AL2(1*16)
KW19     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDNCIS-IDAAMDSB)
KW20     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDDELR-IDAAMDSB)
KW21     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDEXCP-IDAAMDSB)
KW22     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(AMDNEXT-IDAAMDSB)
KW23     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDIREC-IDAAMDSB)
KW24     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(AMDNIL-IDAAMDSB)
KW25     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDNLR-IDAAMDSB)
KW26     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDRETR-IDAAMDSB)
KW27     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDNCAS-IDAAMDSB)
KW28     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(AMDUPR-IDAAMDSB)
KW29     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00161 DC    AL2(5*16)
KW30     DC    AL1(MAPASSWD-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBPASSW-IFGACB)
KW31     DC    AL1(0)
         DC    AL1(KWTYP3A-KWBRTAB)
         DC    AL1(KWTYP3B-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(AMDRKP-IDAAMDSB)
KW32     DC    AL1(MASTRNO-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(ACBSTRNO-IFGACB)
KW33     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP12-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00162 DC    AL2(6*16)
KW34     DC    AL1(MABITSTR-MACBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00163 DC    AL2(3*16)
KW35     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(8)
         DC    AL1(AMDSTSP-IDAAMDSB)
KW36     DC    AL1(MABSTRNO-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(ACBBSTNO-IFGACB)
KW37     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MENRM-MEXLBRTB)
         DC    AL1(KWTYP13-KWBRTAB)
         DC    AL1(KWTYP14-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLEODF-IFGEXLST)
KW38     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW39     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MENRM-MEXLBRTB)
         DC    AL1(KWTYP13-KWBRTAB)
         DC    AL1(KWTYP14-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLJRNF-IFGEXLST)
KW40     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MENRM-MEXLBRTB)
         DC    AL1(KWTYP13-KWBRTAB)
         DC    AL1(KWTYP14-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLLERF-IFGEXLST)
KW41     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MENRM-MEXLBRTB)
         DC    AL1(KWTYP13-KWBRTAB)
         DC    AL1(KWTYP14-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLSYNF-IFGEXLST)
KW42     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEXLLEN-MEXLBRTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(EXLLEN-EXLCOMN)
KW43     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRACB-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLDACB-IFGRPL)
KW44     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRAREA-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLAREA-IFGRPL)
KW45     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRAREALN-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLBUFL-IFGRPL)
KW46     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRARG-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLARG-IFGRPL)
KW47     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRECB-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLECB-IFGRPL)
KW48     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRKEYLN-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLKEYL-IFGRPL)
KW49     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRMSGARE-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLERMSA-IFGRPL)
KW50     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRMSGLEN-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLEMLEN-IFGRPL)
KW51     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRRPLCHA-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLCHAIN-IFGRPL)
KW52     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MROPTCD-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP26-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00164 DC    AL2(8*16)
KW53     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRRECLEN-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLRLEN-IFGRPL)
KW54     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP16-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW55     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLLEN-IFGRPL)
KW56     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLERRCD-IFGRPL)
KW57     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLDDDD-IFGRPL)
KW58     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLAIXPC-IFGRPL)
KW59     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00165 DC    AL2(25*16)
KW60     DC    AL1(0)
         DC    AL1(KWTYP02-KWBRTAB)
         DC    AL1(KWTYP03-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(AMDAXRKP-IDAAMDSB)
KW61     DC    AL1(0)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(ACBLENG-ACBCOMN)
KW62     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLLEN-IFGRPL)
KW63     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEXLVTLN-MEXLBRTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(EXLLEN-EXLCOMN)
KW64     DC    AL1(MAAM-MACBKWTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEAM-MEXLBRTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRAM-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW65     DC    AL1(MAVTWORD-MACBKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBAPID-IFGACB)
KW66     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLTPNDF-IFGEXLST+40)
KW67     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLLGNF-IFGEXLST)
KW68     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLNLGNF-EXLVTEXT+40)
KW69     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLATTNF-EXLVTEXT+40)
KW70     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLRLRQF-EXLVTEXT+40)
KW71     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW72     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW73     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTWORD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLAARLN-RPLVTEXT+76)
KW74     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTWORD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLARCLN-RPLVTEXT+76)
KW75     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MREXIT-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLECB-IFGRPL)
KW76     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW77     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW78     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLUSFLD-RPLVTEXT+76)
KW79     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRNIB-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLARG-IFGRPL)
KW80     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNPROC-MNIBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP28-KWBRTAB)
@NM00166 DC    AL2(11*16)
@NM00167 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNUSERFI-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(4)
         DC    AL1(NIBUSER-ISTNIB)
KW82     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNBITSTR-MNIBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
@NM00168 DC    AL2(9*16)
KW83     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(1)
         DC    AL1(NIBLEN-ISTNIB)
KW84     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNMODE-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(8)
         DC    AL1(NIBMODE-ISTNIB)
KW85     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNCONDN-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(1)
         DC    AL1(NIBCONDN-ISTNIB)
KW86     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(8)
         DC    AL1(NIBDEVCH-ISTNIB)
KW87     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTWORD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLAAREA-RPLVTEXT+76)
KW88     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00169 DC    AL2(2*16)
KW89     DC    AL1(MABITSTR-MACBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00170 DC    AL2(4*16)
KW90     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(4)
         DC    AL1(NIBCID-ISTNIB)
KW91     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNNAME-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(8)
         DC    AL1(NIBSYM-ISTNIB)
KW92     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
@NM00171 DC    AL2(10*16)
KW93     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00172 DC    AL2(7*16)
KW94     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLRTNCD-IFGRPL)
KW95     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRTRANSI-MRPLKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLSTRID-IFGRPL)
KW96     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLFDB2-IFGRPL)
KW97     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLDSB-RPLVTEXT+76)
KW98     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLREQ-IFGRPL)
KW99     DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLFDB2-IFGRPL)
KW100    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW101    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00173 DC    AL2(14*16)
KW102    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00174 DC    AL2(15*16)
KW103    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00175 DC    AL2(16*16)
KW104    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00176 DC    AL2(17*16)
KW105    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00177 DC    AL2(18*16)
KW106    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00178 DC    AL2(19*16)
KW107    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00179 DC    AL2(20*16)
KW108    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00180 DC    AL2(21*16)
KW109    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00181 DC    AL2(22*16)
KW110    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTHWRD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLOBSQV-RPLOF60+RPLRBAR-IFGRPL)
KW111    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTHWRD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLIBSQV-RPLOF60+RPLRBAR-IFGRPL)
KW112    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTHWRD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLSEQNO-RPLOF60+RPLRBAR-IFGRPL)
KW113    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00182 DC    AL2(23*16)
KW114    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00183 DC    AL2(24*16)
KW115    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTHWRD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLUSNSO-RPLVTEXT+76)
@NM00184 DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(RPLUSNSI-RPLVTEXT+76)
KW117    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW118    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW119    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW120    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLSCIPF-IFGEXLST)
KW121    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLDFASF-EXLDFAS+EXLJRNF-IFGEXLST)
KW122    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLRESPF-EXLRESP+EXLOPNF-IFGEXLST)
KW123    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW124    DC    AL1(0)
         DC    AL1(KWTYP21-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(BSPHFND-IDABSPH)
KW125    DC    AL1(0)
         DC    AL1(KWTYP21-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(BSPHRDS-IDABSPH)
KW126    DC    AL1(0)
         DC    AL1(KWTYP21-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(BSPHNUIW-IDABSPH)
KW127    DC    AL1(0)
         DC    AL1(KWTYP21-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(BSPHUIW-IDABSPH)
KW128    DC    AL1(0)
         DC    AL1(KWTYP10-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(2)
         DC    AL1(PLHDRMAX-IDAPLH)
KW129    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW130    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNEXLST-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(4)
         DC    AL1(NIBEXLST-ISTNIB)
KW131    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNRESPLI-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(2)
         DC    AL1(NIBLIMIT-ISTNIB)
KW132    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNBITSTR-MNIBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
@NM00185 DC    AL2(12*16)
KW133    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00186 DC    AL2(13*16)
KW134    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTCHAR-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLSSMO-RPLVTEXT+76)
KW135    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(1)
         DC    AL1(RPLSSMI-RPLVTEXT+76)
KW136    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTWORD-MRPLKWTB)
         DC    AL1(KWTYP18-KWBRTAB)
         DC    AL1(KWTYP19-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(RPLSIGDA-RPLVTEXT+76)
KW137    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW138    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW139    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW140    DC    AL1(MAUSERPT-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBUAPTR-IFGACB)
KW141    DC    AL1(MAJFCB-MACBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ACBUJFCB-IFGACB)
KW142    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNLOGMOD-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(8)
         DC    AL1(NIBLMODE-ISTNIB)
KW143    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNBNDAR-MNIBKWTB)
         DC    AL1(KWTYP04-KWBRTAB)
         DC    AL1(KWTYP05-KWBRTAB)
         DC    AL1(4)
         DC    AL1(NIBNDAR-ISTNIB)
KW144    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW145    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00187 DC    AL2(26*16)
KW146    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
KW147    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MEVT-MEXLBRTB)
         DC    AL1(KWTYP30-KWBRTAB)
         DC    AL1(KWTYP31-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(EXLTNSEF-EXLVTEXT+40)
KW148    DC    AL1(0)
         DC    AL1(KWTYP09-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(4)
         DC    AL1(ARDERBA-IDAARDB)
KW149    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MRVTBITS-MRPLKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP20-KWBRTAB)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
@NM00188 DC    AL2(27*16)
KW150    DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(MNBITSTR-MNIBKWTB)
         DC    AL1(0)
         DC    AL1(KWTYP0E-KWBRTAB)
@NM00189 DC    AL2(28*16)
ENDKWTAB DS    AL1
         ORG   MASTERTB+2420
BATTAB   DS    CL16
         ORG   BATTAB+0
BITTAB   DC    AL4(ATRBITAB-3)
ONTAB    DC    AL4(ATRONTAB)
OFFTAB   DC    AL4(ATOFTAB)
BITCKMSK DC    XL4'00FFFFFF'
         ORG   BATTAB+16
         ORG   BATTAB+16
         DC    AL4(MACBITAB-3)
         DC    AL4(MACONTAB)
         DC    AL4(MACOFTAB)
         DC    XL4'00080003'
         ORG   BATTAB+32
         ORG   BATTAB+32
         DC    AL4(BRHBITAB-3)
         DC    AL4(BRHONTAB)
         DC    AL4(BRHOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+48
         ORG   BATTAB+48
         DC    AL4(CATBITAB-3)
         DC    AL4(CATONTAB)
         DC    AL4(CATOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+64
         ORG   BATTAB+64
         DC    AL4(CRABITAB-3)
         DC    AL4(CRAONTAB)
         DC    AL4(CRAOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+80
         ORG   BATTAB+80
         DC    AL4(OFLBITAB-3)
         DC    AL4(OFLONTAB)
         DC    AL4(OFLOFTAB)
         DC    XL4'7FFFFFFF'
         ORG   BATTAB+96
         ORG   BATTAB+96
         DC    AL4(OPEBITAB-3)
         DC    AL4(OPEONTAB)
         DC    AL4(OPEOFTAB)
         DC    XL4'1FFFFFFF'
         ORG   BATTAB+112
         ORG   BATTAB+112
         DC    AL4(DATBITAB-3)
         DC    AL4(DATONTAB)
         DC    AL4(DATOFTAB)
         DC    XL4'01FFFFFF'
         ORG   BATTAB+128
         ORG   BATTAB+128
         DC    AL4(OPTBITAB-3)
         DC    AL4(OPTONTAB)
         DC    AL4(OPTOFTAB)
         DC    XL4'00000000'
         ORG   BATTAB+144
         ORG   BATTAB+144
         DC    AL4(LISBITAB-3)
         DC    AL4(LISONTAB)
         DC    AL4(LISOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+160
         ORG   BATTAB+160
         DC    AL4(CONBITAB-3)
         DC    AL4(CONONTAB)
         DC    AL4(CONOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+176
         ORG   BATTAB+176
         DC    AL4(PROBITAB-3)
         DC    AL4(PROONTAB)
         DC    AL4(PROOFTAB)
         DC    XL4'00000000'
         ORG   BATTAB+192
         ORG   BATTAB+192
         DC    AL4(SDTBITAB-3)
         DC    AL4(SDTONTAB)
         DC    AL4(SDTOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+208
         ORG   BATTAB+208
         DC    AL4(BRABITAB-3)
         DC    AL4(BRAONTAB)
         DC    AL4(BRAOFTAB)
         DC    XL4'0FFFFFFF'
         ORG   BATTAB+224
         ORG   BATTAB+224
         DC    AL4(CHNBITAB-3)
         DC    AL4(CHNONTAB)
         DC    AL4(CHGOFTAB)
         DC    XL4'0FFFFFFF'
         ORG   BATTAB+240
         ORG   BATTAB+240
         DC    AL4(STYBITAB-3)
         DC    AL4(STYONTAB)
         DC    AL4(STYOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+256
         ORG   BATTAB+256
         DC    AL4(RTYBITAB-3)
         DC    AL4(RTYONTAB)
         DC    AL4(RTYOFTAB)
         DC    XL4'03FFFFFF'
         ORG   BATTAB+272
         ORG   BATTAB+272
         DC    AL4(CHABITAB-3)
         DC    AL4(CHAONTAB)
         DC    AL4(CHAOFTAB)
         DC    XL4'0FFFFFFF'
         ORG   BATTAB+288
         ORG   BATTAB+288
         DC    AL4(POSBITAB-3)
         DC    AL4(POSONTAB)
         DC    AL4(POSOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+304
         ORG   BATTAB+304
         DC    AL4(RESBITAB-3)
         DC    AL4(RESONTAB)
         DC    AL4(RESOFTAB)
         DC    XL4'00FFFFFF'
         ORG   BATTAB+320
         ORG   BATTAB+320
         DC    AL4(CNTBITAB-3)
         DC    AL4(CNTONTAB)
         DC    AL4(CNTOFTAB)
         DC    XL4'00000FFF'
         ORG   BATTAB+336
         ORG   BATTAB+336
         DC    AL4(QBSBITAB-3)
         DC    AL4(QBSONTAB)
         DC    AL4(QBSOFTAB)
         DC    XL4'01FFFFFF'
         ORG   BATTAB+352
         ORG   BATTAB+352
         DC    AL4(IBSBITAB-3)
         DC    AL4(IBSONTAB)
         DC    AL4(IBSOFTAB)
         DC    XL4'01FFFFFF'
         ORG   BATTAB+368
         ORG   BATTAB+368
         DC    AL4(SSOBITAB-3)
         DC    AL4(SSOONTAB)
         DC    AL4(SSOOFTAB)
         DC    XL4'0FFFFFFF'
         ORG   BATTAB+384
         ORG   BATTAB+384
         DC    AL4(SSIBITAB-3)
         DC    AL4(SSIONTAB)
         DC    AL4(SSIOFTAB)
         DC    XL4'07FFFFFF'
         ORG   BATTAB+400
         ORG   BATTAB+400
         DC    AL4(AIXBITAB-3)
         DC    AL4(AIXONTAB)
         DC    AL4(AIXOFTAB)
         DC    XL4'7FFFFFFF'
         ORG   BATTAB+416
         ORG   BATTAB+416
         DC    AL4(CODBITAB-3)
         DC    AL4(CODONTAB)
         DC    AL4(CODOFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+432
         ORG   BATTAB+432
         DC    AL4(CRBITAB-3)
         DC    AL4(CRONTAB)
         DC    AL4(CROFTAB)
         DC    XL4'3FFFFFFF'
         ORG   BATTAB+448
         ORG   BATTAB+448
         DC    AL4(ERBITAB-3)
         DC    AL4(ERONTAB)
         DC    AL4(EROFTAB)
         DC    XL4'1FFFFFFF'
         ORG   MASTERTB+2884
ATRBITAB DS    CL3
         ORG   ATRBITAB+0
@NM00190 DC    AL1(ATKSDSON-ATRONTAB)
@NM00191 DC    AL1(ATNOACT-ATOFTAB)
@NM00192 DC    AL1(EXGRP1-EXBITAB)
         ORG   ATRBITAB+3
         ORG   ATRBITAB+3
         DC    AL1(ATESDSON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   ATRBITAB+6
         ORG   ATRBITAB+6
         DC    AL1(ATWCKON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   ATRBITAB+9
         ORG   ATRBITAB+9
         DC    AL1(ATSSWDON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   ATRBITAB+12
         ORG   ATRBITAB+12
         DC    AL1(ATREPLON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   ATRBITAB+15
         ORG   ATRBITAB+15
         DC    AL1(ATRRDSON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   ATRBITAB+18
         ORG   ATRBITAB+18
         DC    AL1(ATSPANON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   ATRBITAB+21
         ORG   ATRBITAB+21
         DC    AL1(ATUNQON-ATRONTAB)
         DC    AL1(ATNOACT-ATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MASTERTB+2908
MACBITAB DS    CL3
         ORG   MACBITAB+0
@NM00193 DC    AL1(MAKEYON-MACONTAB)
@NM00194 DC    AL1(MAKEYOFF-MACOFTAB)
@NM00195 DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+3
         ORG   MACBITAB+3
         DC    AL1(MAADRON-MACONTAB)
         DC    AL1(MAADROFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+6
         ORG   MACBITAB+6
         DC    AL1(MACNVON-MACONTAB)
         DC    AL1(MACNVOFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+9
         ORG   MACBITAB+9
         DC    AL1(MASEQON-MACONTAB)
         DC    AL1(MASEQOFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+12
         ORG   MACBITAB+12
         DC    AL1(MASKPON-MACONTAB)
         DC    AL1(MASKPOFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+15
         ORG   MACBITAB+15
         DC    AL1(MADIRON-MACONTAB)
         DC    AL1(MADIROFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+18
         ORG   MACBITAB+18
         DC    AL1(MAINON-MACONTAB)
         DC    AL1(MAINOFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+21
         ORG   MACBITAB+21
         DC    AL1(MAOUTON-MACONTAB)
         DC    AL1(MAOUTOFF-MACOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MACBITAB+24
         ORG   MACBITAB+24
         DC    AL1(MANUBON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   MACBITAB+27
         ORG   MACBITAB+27
         DC    AL1(MAUBFON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   MACBITAB+30
         ORG   MACBITAB+30
         DC    AL1(MALOGON-MACONTAB)
         DC    AL1(MALOGOFF-MACOFTAB)
         DC    AL1(EXGRP5-EXBITAB)
         ORG   MACBITAB+33
         ORG   MACBITAB+33
         DC    AL1(MANLOGON-MACONTAB)
         DC    AL1(MANLOOFF-MACOFTAB)
         DC    AL1(EXGRP5-EXBITAB)
         ORG   MACBITAB+36
         ORG   MACBITAB+36
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   MACBITAB+39
         ORG   MACBITAB+39
         DC    AL1(MADDNON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP6-EXBITAB)
         ORG   MACBITAB+42
         ORG   MACBITAB+42
         DC    AL1(MADSNON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP6-EXBITAB)
         ORG   MACBITAB+45
         ORG   MACBITAB+45
         DC    AL1(MANRMON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP7-EXBITAB)
         ORG   MACBITAB+48
         ORG   MACBITAB+48
         DC    AL1(MAAIXON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP7-EXBITAB)
         ORG   MACBITAB+51
         ORG   MACBITAB+51
         DC    AL1(MANSRON-MACONTAB)
         DC    AL1(MANSROFF-MACOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   MACBITAB+54
         ORG   MACBITAB+54
         DC    AL1(MALSRON-MACONTAB)
         DC    AL1(MALSROFF-MACOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   MACBITAB+57
         ORG   MACBITAB+57
         DC    AL1(MAGSRON-MACONTAB)
         DC    AL1(MAGSROFF-MACOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   MACBITAB+60
         ORG   MACBITAB+60
         DC    AL1(MANCION-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP9-EXBITAB)
         ORG   MACBITAB+63
         ORG   MACBITAB+63
         DC    AL1(MAICION-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP9-EXBITAB)
         ORG   MACBITAB+66
         ORG   MACBITAB+66
         DC    AL1(MANDFON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP10-EXBITAB)
         ORG   MACBITAB+69
         ORG   MACBITAB+69
         DC    AL1(MADFRON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP10-EXBITAB)
         ORG   MACBITAB+72
         ORG   MACBITAB+72
         DC    AL1(MANISON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP11-EXBITAB)
         ORG   MACBITAB+75
         ORG   MACBITAB+75
         DC    AL1(MASISON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP11-EXBITAB)
         ORG   MACBITAB+78
         ORG   MACBITAB+78
         DC    AL1(MANFXON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP12-EXBITAB)
         ORG   MACBITAB+81
         ORG   MACBITAB+81
         DC    AL1(MACFXON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP12-EXBITAB)
         ORG   MACBITAB+84
         ORG   MACBITAB+84
         DC    AL1(MARSTON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   MACBITAB+87
         ORG   MACBITAB+87
         DC    AL1(MANRSON-MACONTAB)
         DC    AL1(MANOACT-MACOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   MASTERTB+2998
BRHBITAB DS    CL3
         ORG   BRHBITAB+0
@NM00196 DC    AL1(BRYESON-BRHONTAB)
@NM00197 DC    AL1(BRNOACT-BRHOFTAB)
@NM00198 DC    AL1(EXGRP1-EXBITAB)
         ORG   BRHBITAB+3
         ORG   BRHBITAB+3
         DC    AL1(BRNOON-BRHONTAB)
         DC    AL1(BRNOACT-BRHOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3004
CATBITAB DS    CL3
         ORG   CATBITAB+0
@NM00199 DC    AL1(CATYESON-CATONTAB)
@NM00200 DC    AL1(CATNOACT-CATOFTAB)
@NM00201 DC    AL1(EXGRP1-EXBITAB)
         ORG   CATBITAB+3
         ORG   CATBITAB+3
         DC    AL1(CATNOON-CATONTAB)
         DC    AL1(CATNOACT-CATOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3010
CRABITAB DS    CL3
         ORG   CRABITAB+0
@NM00202 DC    AL1(CRSCRAON-CRAONTAB)
@NM00203 DC    AL1(CRSCROFF-CRAOFTAB)
@NM00204 DC    AL1(EXGRP1-EXBITAB)
         ORG   CRABITAB+3
         ORG   CRABITAB+3
         DC    AL1(CRUCRAON-CRAONTAB)
         DC    AL1(CRUCROFF-CRAOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3016
OFLBITAB DS    CL3
         ORG   OFLBITAB+0
@NM00205 DC    AL1(OFOPENON-OFLONTAB)
@NM00206 DC    AL1(OFOPEOFF-OFLOFTAB)
@NM00207 DC    AL1(EXGRP32-EXBITAB)
         ORG   MASTERTB+3019
OPEBITAB DS    CL3
         ORG   OPEBITAB+0
@NM00208 DC    AL1(OPAIXON-OPEONTAB)
@NM00209 DC    AL1(OPENOACT-OPEOFTAB)
@NM00210 DC    AL1(EXGRP1-EXBITAB)
         ORG   OPEBITAB+3
         ORG   OPEBITAB+3
         DC    AL1(OPPATHON-OPEONTAB)
         DC    AL1(OPENOACT-OPEOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   OPEBITAB+6
         ORG   OPEBITAB+6
         DC    AL1(OPBASEON-OPEONTAB)
         DC    AL1(OPENOACT-OPEOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3028
DATBITAB DS    CL3
         ORG   DATBITAB+0
@NM00211 DC    AL1(DAUNSOON-DATONTAB)
@NM00212 DC    AL1(DANOACT-DATOFTAB)
@NM00213 DC    AL1(EXGRP32-EXBITAB)
         ORG   DATBITAB+3
         ORG   DATBITAB+3
         DC    AL1(DAEOBON-DATONTAB)
         DC    AL1(DANOACT-DATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   DATBITAB+6
         ORG   DATBITAB+6
         DC    AL1(DAEOMON-DATONTAB)
         DC    AL1(DANOACT-DATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   DATBITAB+9
         ORG   DATBITAB+9
         DC    AL1(DAEOTON-DATONTAB)
         DC    AL1(DANOACT-DATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   DATBITAB+12
         ORG   DATBITAB+12
         DC    AL1(DALOGOON-DATONTAB)
         DC    AL1(DANOACT-DATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   DATBITAB+15
         ORG   DATBITAB+15
         DC    AL1(DALGON-DATONTAB)
         DC    AL1(DANOACT-DATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   DATBITAB+18
         ORG   DATBITAB+18
         DC    AL1(DASOHON-DATONTAB)
         DC    AL1(DANOACT-DATOFTAB)
         DC    AL1(EXGRP32-EXBITAB)
         ORG   MASTERTB+3049
OPTBITAB DS    CL3
         ORG   OPTBITAB+0
@NM00214 DC    AL1(OPKEYON-OPTONTAB)
@NM00215 DC    AL1(OPKEYOFF-OPTOFTAB)
@NM00216 DC    AL1(EXGRP1-EXBITAB)
         ORG   OPTBITAB+3
         ORG   OPTBITAB+3
         DC    AL1(OPADRON-OPTONTAB)
         DC    AL1(OPADROFF-OPTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   OPTBITAB+6
         ORG   OPTBITAB+6
         DC    AL1(OPCNVON-OPTONTAB)
         DC    AL1(OPCNVOFF-OPTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   OPTBITAB+9
         ORG   OPTBITAB+9
         DC    AL1(OPSEQON-OPTONTAB)
         DC    AL1(OPSEQOFF-OPTOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   OPTBITAB+12
         ORG   OPTBITAB+12
         DC    AL1(OPDIRON-OPTONTAB)
         DC    AL1(OPDIROFF-OPTOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   OPTBITAB+15
         ORG   OPTBITAB+15
         DC    AL1(OPSKPON-OPTONTAB)
         DC    AL1(OPSKPOFF-OPTOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   OPTBITAB+18
         ORG   OPTBITAB+18
         DC    AL1(OPSYNON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   OPTBITAB+21
         ORG   OPTBITAB+21
         DC    AL1(OPASYON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   OPTBITAB+24
         ORG   OPTBITAB+24
         DC    AL1(OPNUPON-OPTONTAB)
         DC    AL1(OPNUPOFF-OPTOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   OPTBITAB+27
         ORG   OPTBITAB+27
         DC    AL1(OPUPDON-OPTONTAB)
         DC    AL1(OPUPDOFF-OPTOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   OPTBITAB+30
         ORG   OPTBITAB+30
         DC    AL1(OPNSPON-OPTONTAB)
         DC    AL1(OPNSPOFF-OPTOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   OPTBITAB+33
         ORG   OPTBITAB+33
         DC    AL1(OPKEQON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP5-EXBITAB)
         ORG   OPTBITAB+36
         ORG   OPTBITAB+36
         DC    AL1(OPKGEON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP5-EXBITAB)
         ORG   OPTBITAB+39
         ORG   OPTBITAB+39
         DC    AL1(OPFKSON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP6-EXBITAB)
         ORG   OPTBITAB+42
         ORG   OPTBITAB+42
         DC    AL1(OPGENON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP6-EXBITAB)
         ORG   OPTBITAB+45
         ORG   OPTBITAB+45
         DC    AL1(OPMVEON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP7-EXBITAB)
         ORG   OPTBITAB+48
         ORG   OPTBITAB+48
         DC    AL1(OPLOCON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP7-EXBITAB)
         ORG   OPTBITAB+51
         ORG   OPTBITAB+51
         DC    AL1(OPFWDON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   OPTBITAB+54
         ORG   OPTBITAB+54
         DC    AL1(OPBWDON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   OPTBITAB+57
         ORG   OPTBITAB+57
         DC    AL1(OPARDON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP9-EXBITAB)
         ORG   OPTBITAB+60
         ORG   OPTBITAB+60
         DC    AL1(OPLRDON-OPTONTAB)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP9-EXBITAB)
         ORG   OPTBITAB+63
         ORG   OPTBITAB+63
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+66
         ORG   OPTBITAB+66
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+69
         ORG   OPTBITAB+69
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+72
         ORG   OPTBITAB+72
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+75
         ORG   OPTBITAB+75
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+78
         ORG   OPTBITAB+78
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+81
         ORG   OPTBITAB+81
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+84
         ORG   OPTBITAB+84
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+87
         ORG   OPTBITAB+87
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+90
         ORG   OPTBITAB+90
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+93
         ORG   OPTBITAB+93
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+96
         ORG   OPTBITAB+96
         DC    AL1(OPCAON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP10-EXBITAB)
         ORG   OPTBITAB+99
         ORG   OPTBITAB+99
         DC    AL1(OPCSON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP10-EXBITAB)
         ORG   OPTBITAB+102
         ORG   OPTBITAB+102
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+105
         ORG   OPTBITAB+105
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+108
         ORG   OPTBITAB+108
         DC    AL1(OPRELEON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP12-EXBITAB)
         ORG   OPTBITAB+111
         ORG   OPTBITAB+111
         DC    AL1(OPPASSON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP12-EXBITAB)
         ORG   OPTBITAB+114
         ORG   OPTBITAB+114
         DC    AL1(OPNERAON-OPTONTB2)
         DC    AL1(OPNEROFF-OPTOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   OPTBITAB+117
         ORG   OPTBITAB+117
         DC    AL1(OPEAUON-OPTONTB2)
         DC    AL1(OPEAUOFF-OPTOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   OPTBITAB+120
         ORG   OPTBITAB+120
         DC    AL1(OPERASON-OPTONTB2)
         DC    AL1(OPERAOFF-OPTOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   OPTBITAB+123
         ORG   OPTBITAB+123
         DC    AL1(OPSPECON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP14-EXBITAB)
         ORG   OPTBITAB+126
         ORG   OPTBITAB+126
         DC    AL1(OPANYON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP14-EXBITAB)
         ORG   OPTBITAB+129
         ORG   OPTBITAB+129
         DC    AL1(OPNCONON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP15-EXBITAB)
         ORG   OPTBITAB+132
         ORG   OPTBITAB+132
         DC    AL1(OPCONVON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP15-EXBITAB)
         ORG   OPTBITAB+135
         ORG   OPTBITAB+135
         DC    AL1(OPLBTON-OPTONTB2)
         DC    AL1(OPLBTOFF-OPTOFTAB)
         DC    AL1(EXGRP16-EXBITAB)
         ORG   OPTBITAB+138
         ORG   OPTBITAB+138
         DC    AL1(OPLBMON-OPTONTB2)
         DC    AL1(OPLBMOFF-OPTOFTAB)
         DC    AL1(EXGRP16-EXBITAB)
         ORG   OPTBITAB+141
         ORG   OPTBITAB+141
         DC    AL1(OPBLKON-OPTONTB2)
         DC    AL1(OPBLKOFF-OPTOFTAB)
         DC    AL1(EXGRP16-EXBITAB)
         ORG   OPTBITAB+144
         ORG   OPTBITAB+144
         DC    AL1(OPCONDON-OPTONTB2)
         DC    AL1(OPCONOFF-OPTOFTAB)
         DC    AL1(EXGRP17-EXBITAB)
         ORG   OPTBITAB+147
         ORG   OPTBITAB+147
         DC    AL1(OPUNCOON-OPTONTB2)
         DC    AL1(OPUCOOFF-OPTOFTAB)
         DC    AL1(EXGRP17-EXBITAB)
         ORG   OPTBITAB+150
         ORG   OPTBITAB+150
         DC    AL1(OPLOCKON-OPTONTB2)
         DC    AL1(OPLOCOFF-OPTOFTAB)
         DC    AL1(EXGRP17-EXBITAB)
         ORG   OPTBITAB+153
         ORG   OPTBITAB+153
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+156
         ORG   OPTBITAB+156
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+159
         ORG   OPTBITAB+159
         DC    AL1(OPLOGOON-OPTONTB2)
         DC    AL1(OPLOGOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+162
         ORG   OPTBITAB+162
         DC    AL1(OPDEVCON-OPTONTB2)
         DC    AL1(OPDEVOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+165
         ORG   OPTBITAB+165
         DC    AL1(OPTERMON-OPTONTB2)
         DC    AL1(OPTEROFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+168
         ORG   OPTBITAB+168
         DC    AL1(OPAPPSON-OPTONTB2)
         DC    AL1(OPAPPOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+171
         ORG   OPTBITAB+171
         DC    AL1(OPCOUNON-OPTONTB2)
         DC    AL1(OPCOUOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+174
         ORG   OPTBITAB+174
         DC    AL1(OPRNNAON-OPTONTB2)
         DC    AL1(OPRNNOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+177
         ORG   OPTBITAB+177
         DC    AL1(OPCIDXON-OPTONTB2)
         DC    AL1(OPCIDOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+180
         ORG   OPTBITAB+180
         DC    AL1(OPTOPLON-OPTONTB2)
         DC    AL1(OPTOPOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+183
         ORG   OPTBITAB+183
         DC    AL1(OPBSCION-OPTONTB2)
         DC    AL1(OPBSCOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+186
         ORG   OPTBITAB+186
         DC    AL1(OPDISPON-OPTONTB2)
         DC    AL1(OPDISOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+189
         ORG   OPTBITAB+189
         DC    AL1(OPRELRON-OPTONTB2)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP19-EXBITAB)
         ORG   OPTBITAB+192
         ORG   OPTBITAB+192
         DC    AL1(OPNRELON-OPTONTB3)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP19-EXBITAB)
         ORG   OPTBITAB+195
         ORG   OPTBITAB+195
         DC    AL1(OPQON-OPTONTB3)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP20-EXBITAB)
         ORG   OPTBITAB+198
         ORG   OPTBITAB+198
         DC    AL1(OPNQON-OPTONTB3)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP20-EXBITAB)
         ORG   OPTBITAB+201
         ORG   OPTBITAB+201
         DC    AL1(OPPENDON-OPTONTB3)
         DC    AL1(OPPENOFF-OPTOFTAB)
         DC    AL1(EXGRP21-EXBITAB)
         ORG   OPTBITAB+204
         ORG   OPTBITAB+204
         DC    AL1(OPSESSON-OPTONTB3)
         DC    AL1(OPSESOFF-OPTOFTAB)
         DC    AL1(EXGRP21-EXBITAB)
         ORG   OPTBITAB+207
         ORG   OPTBITAB+207
         DC    AL1(OPACTION-OPTONTB3)
         DC    AL1(OPACTOFF-OPTOFTAB)
         DC    AL1(EXGRP21-EXBITAB)
         ORG   OPTBITAB+210
         ORG   OPTBITAB+210
         DC    AL1(OPUNCLON-OPTONTB3)
         DC    AL1(OPUNCOFF-OPTOFTAB)
         DC    AL1(EXGRP21-EXBITAB)
         ORG   OPTBITAB+213
         ORG   OPTBITAB+213
         DC    AL1(OPQUIEON-OPTONTB3)
         DC    AL1(OPQUIOFF-OPTOFTAB)
         DC    AL1(EXGRP22-EXBITAB)
         ORG   OPTBITAB+216
         ORG   OPTBITAB+216
         DC    AL1(OPSTARON-OPTONTB3)
         DC    AL1(OPSTAOFF-OPTOFTAB)
         DC    AL1(EXGRP22-EXBITAB)
         ORG   OPTBITAB+219
         ORG   OPTBITAB+219
         DC    AL1(OPSTOPON-OPTONTB3)
         DC    AL1(OPSTOOFF-OPTOFTAB)
         DC    AL1(EXGRP22-EXBITAB)
         ORG   OPTBITAB+222
         ORG   OPTBITAB+222
         DC    AL1(OPACCEON-OPTONTB3)
         DC    AL1(OPACCOFF-OPTOFTAB)
         DC    AL1(EXGRP23-EXBITAB)
         ORG   OPTBITAB+225
         ORG   OPTBITAB+225
         DC    AL1(OPACQUON-OPTONTB3)
         DC    AL1(OPACQOFF-OPTOFTAB)
         DC    AL1(EXGRP23-EXBITAB)
         ORG   OPTBITAB+228
         ORG   OPTBITAB+228
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+231
         ORG   OPTBITAB+231
         DC    AL1(OPCALLON-OPTONTB3)
         DC    AL1(OPCALOFF-OPTOFTAB)
         DC    AL1(EXGRP24-EXBITAB)
         ORG   OPTBITAB+234
         ORG   OPTBITAB+234
         DC    AL1(OPCANYON-OPTONTB3)
         DC    AL1(OPCANOFF-OPTOFTAB)
         DC    AL1(EXGRP24-EXBITAB)
         ORG   OPTBITAB+237
         ORG   OPTBITAB+237
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+240
         ORG   OPTBITAB+240
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+243
         ORG   OPTBITAB+243
         DC    AL1(OPKEEPON-OPTONTB3)
         DC    AL1(OPKEEOFF-OPTOFTAB)
         DC    AL1(EXGRP26-EXBITAB)
         ORG   OPTBITAB+246
         ORG   OPTBITAB+246
         DC    AL1(OPTRUNON-OPTONTB3)
         DC    AL1(OPTRUOFF-OPTOFTAB)
         DC    AL1(EXGRP26-EXBITAB)
         ORG   OPTBITAB+249
         ORG   OPTBITAB+249
         DC    AL1(OPNIBTON-OPTONTB3)
         DC    AL1(OPNIBOFF-OPTOFTAB)
         DC    AL1(EXGRP26-EXBITAB)
         ORG   OPTBITAB+252
         ORG   OPTBITAB+252
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+255
         ORG   OPTBITAB+255
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   OPTBITAB+258
         ORG   OPTBITAB+258
         DC    AL1(OPSESKON-OPTONTB3)
         DC    AL1(OPSEKOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   OPTBITAB+261
         ORG   OPTBITAB+261
         DC    AL1(OPFMHDON-OPTONTB3)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP27-EXBITAB)
         ORG   OPTBITAB+264
         ORG   OPTBITAB+264
         DC    AL1(OPNFMHON-OPTONTB3)
         DC    AL1(OPNOACT-OPTOFTAB)
         DC    AL1(EXGRP27-EXBITAB)
         ORG   OPTBITAB+267
         ORG   OPTBITAB+267
         DC    AL1(OPSESPON-OPTONTB3)
         DC    AL1(OPSEPOFF-OPTOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   MASTERTB+3319
LISBITAB DS    CL3
         ORG   LISBITAB+0
@NM00217 DC    AL1(LIYESON-LISONTAB)
@NM00218 DC    AL1(LINOACT-LISOFTAB)
@NM00219 DC    AL1(EXGRP1-EXBITAB)
         ORG   LISBITAB+3
         ORG   LISBITAB+3
         DC    AL1(LINOON-LISONTAB)
         DC    AL1(LINOACT-LISOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3325
CONBITAB DS    CL6
         ORG   CONBITAB
@NM00220 DC    AL1(COYESON-CONONTAB)
         DC    AL1(CONOON-CONONTAB)
@NM00221 DC    AL1(CONOACT-CONOFTAB)
         DC    AL1(CONOACT-CONOFTAB)
@NM00222 DC    AL1(EXGRP1-EXBITAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3331
PROBITAB DS    CL3
         ORG   PROBITAB+0
@NM00223 DC    AL1(PRMSGON-PROONTAB)
@NM00224 DC    AL1(PRMSGOFF-PROOFTAB)
@NM00225 DC    AL1(EXGRP1-EXBITAB)
         ORG   PROBITAB+3
         ORG   PROBITAB+3
         DC    AL1(PRTRANON-PROONTAB)
         DC    AL1(PRTRAOFF-PROOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   PROBITAB+6
         ORG   PROBITAB+6
         DC    AL1(PRCONTON-PROONTAB)
         DC    AL1(PRCONOFF-PROOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   PROBITAB+9
         ORG   PROBITAB+9
         DC    AL1(PRBLOCON-PROONTAB)
         DC    AL1(PRBLOOFF-PROOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   PROBITAB+12
         ORG   PROBITAB+12
         DC    AL1(PRNLGION-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   PROBITAB+15
         ORG   PROBITAB+15
         DC    AL1(PRLGINON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   PROBITAB+18
         ORG   PROBITAB+18
         DC    AL1(PRLGOUON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   PROBITAB+21
         ORG   PROBITAB+21
         DC    AL1(PRNLGOON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   PROBITAB+24
         ORG   PROBITAB+24
         DC    AL1(PRNCONON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   PROBITAB+27
         ORG   PROBITAB+27
         DC    AL1(PRCONFON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   PROBITAB+30
         ORG   PROBITAB+30
         DC    AL1(PRTMFLON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP5-EXBITAB)
         ORG   PROBITAB+33
         ORG   PROBITAB+33
         DC    AL1(PRNTMFON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP5-EXBITAB)
         ORG   PROBITAB+36
         ORG   PROBITAB+36
         DC    AL1(PRERPION-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP6-EXBITAB)
         ORG   PROBITAB+39
         ORG   PROBITAB+39
         DC    AL1(PRNERION-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP6-EXBITAB)
         ORG   PROBITAB+42
         ORG   PROBITAB+42
         DC    AL1(PRERPOON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP7-EXBITAB)
         ORG   PROBITAB+45
         ORG   PROBITAB+45
         DC    AL1(PRNEROON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP7-EXBITAB)
         ORG   PROBITAB+48
         ORG   PROBITAB+48
         DC    AL1(PRNMONON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   PROBITAB+51
         ORG   PROBITAB+51
         DC    AL1(PRMONION-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP8-EXBITAB)
         ORG   PROBITAB+54
         ORG   PROBITAB+54
         DC    AL1(PRNELCON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP9-EXBITAB)
         ORG   PROBITAB+57
         ORG   PROBITAB+57
         DC    AL1(PRELCON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP9-EXBITAB)
         ORG   PROBITAB+60
         ORG   PROBITAB+60
         DC    AL1(PRNEIBON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP10-EXBITAB)
         ORG   PROBITAB+63
         ORG   PROBITAB+63
         DC    AL1(PREIBON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP10-EXBITAB)
         ORG   PROBITAB+66
         ORG   PROBITAB+66
         DC    AL1(PRTIMEON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP11-EXBITAB)
         ORG   PROBITAB+69
         ORG   PROBITAB+69
         DC    AL1(PRNTIMON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP11-EXBITAB)
         ORG   PROBITAB+72
         ORG   PROBITAB+72
         DC    AL1(PRNORDON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP12-EXBITAB)
         ORG   PROBITAB+75
         ORG   PROBITAB+75
         DC    AL1(PRORDON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP12-EXBITAB)
         ORG   PROBITAB+78
         ORG   PROBITAB+78
         DC    AL1(PRKEEPON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   PROBITAB+81
         ORG   PROBITAB+81
         DC    AL1(PRTRUNON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP13-EXBITAB)
         ORG   PROBITAB+84
         ORG   PROBITAB+84
         DC    AL1(PRNBINON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP14-EXBITAB)
         ORG   PROBITAB+87
         ORG   PROBITAB+87
         DC    AL1(PRBINAON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP14-EXBITAB)
         ORG   PROBITAB+90
         ORG   PROBITAB+90
         DC    AL1(PRNDFAON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP15-EXBITAB)
         ORG   PROBITAB+93
         ORG   PROBITAB+93
         DC    AL1(PRDFASON-PROONTAB)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP15-EXBITAB)
         ORG   PROBITAB+96
         ORG   PROBITAB+96
         DC    AL1(PRNRESON-PROONTB2)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP16-EXBITAB)
         ORG   PROBITAB+99
         ORG   PROBITAB+99
         DC    AL1(PRRESPON-PROONTB2)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP16-EXBITAB)
         ORG   PROBITAB+102
         ORG   PROBITAB+102
         DC    AL1(PRCAON-PROONTB2)
         DC    AL1(PRCAOFF-PROOFTAB)
         DC    AL1(EXGRP17-EXBITAB)
         ORG   PROBITAB+105
         ORG   PROBITAB+105
         DC    AL1(PRCSON-PROONTB2)
         DC    AL1(PRCSOFF-PROOFTAB)
         DC    AL1(EXGRP17-EXBITAB)
         ORG   PROBITAB+108
         ORG   PROBITAB+108
         DC    AL1(PRRPLCON-PROONTB2)
         DC    AL1(PRRPLCOF-PROOFTAB)
         DC    AL1(EXGRP17-EXBITAB)
         ORG   PROBITAB+111
         ORG   PROBITAB+111
         DC    AL1(PRSYSON-PROONTB2)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   PROBITAB+114
         ORG   PROBITAB+114
         DC    AL1(PRAPPLON-PROONTB2)
         DC    AL1(PRNOACT-PROOFTAB)
         DC    AL1(EXGRP18-EXBITAB)
         ORG   PROBITAB+117
         ORG   PROBITAB+117
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         ORG   MASTERTB+3451
SDTBITAB DS    CL3
         ORG   SDTBITAB+0
@NM00226 DC    AL1(SDSYSON-SDTONTAB)
@NM00227 DC    AL1(SDNOACT-SDTOFTAB)
@NM00228 DC    AL1(EXGRP1-EXBITAB)
         ORG   SDTBITAB+3
         ORG   SDTBITAB+3
         DC    AL1(SDAPPLON-SDTONTAB)
         DC    AL1(SDNOACT-SDTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3457
BRABITAB DS    CL3
         ORG   BRABITAB+0
@NM00229 DC    AL1(BRBBON-BRAONTAB)
@NM00230 DC    AL1(BRANOACT-BRAOFTAB)
@NM00231 DC    AL1(EXGRP1-EXBITAB)
         ORG   BRABITAB+3
         ORG   BRABITAB+3
         DC    AL1(BRNBBON-BRAONTAB)
         DC    AL1(BRANOACT-BRAOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   BRABITAB+6
         ORG   BRABITAB+6
         DC    AL1(BREBON-BRAONTAB)
         DC    AL1(BRANOACT-BRAOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   BRABITAB+9
         ORG   BRABITAB+9
         DC    AL1(BRNEBON-BRAONTAB)
         DC    AL1(BRANOACT-BRAOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   MASTERTB+3469
CHNBITAB DS    CL3
         ORG   CHNBITAB+0
@NM00232 DC    AL1(CHNCMDON-CHNONTAB)
@NM00233 DC    AL1(CHGNOACT-CHGOFTAB)
@NM00234 DC    AL1(EXGRP1-EXBITAB)
         ORG   CHNBITAB+3
         ORG   CHNBITAB+3
         DC    AL1(CHCMDON-CHNONTAB)
         DC    AL1(CHGNOACT-CHGOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CHNBITAB+6
         ORG   CHNBITAB+6
         DC    AL1(CHNREQON-CHNONTAB)
         DC    AL1(CHGNOACT-CHGOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   CHNBITAB+9
         ORG   CHNBITAB+9
         DC    AL1(CHREQON-CHNONTAB)
         DC    AL1(CHGNOACT-CHGOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   MASTERTB+3481
STYBITAB DS    CL3
         ORG   STYBITAB+0
@NM00235 DC    AL1(STREQON-STYONTAB)
@NM00236 DC    AL1(STNOACT-STYOFTAB)
@NM00237 DC    AL1(EXGRP1-EXBITAB)
         ORG   STYBITAB+3
         ORG   STYBITAB+3
         DC    AL1(STRESPON-STYONTAB)
         DC    AL1(STNOACT-STYOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3487
RTYBITAB DS    CL3
         ORG   RTYBITAB+0
@NM00238 DC    AL1(RTNRESON-RTYONTAB)
@NM00239 DC    AL1(RTNOACT-RTYOFTAB)
@NM00240 DC    AL1(EXGRP1-EXBITAB)
         ORG   RTYBITAB+3
         ORG   RTYBITAB+3
         DC    AL1(RTRESPON-RTYONTAB)
         DC    AL1(RTNOACT-RTYOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   RTYBITAB+6
         ORG   RTYBITAB+6
         DC    AL1(RTDFSYON-RTYONTAB)
         DC    AL1(RTNOACT-RTYOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   RTYBITAB+9
         ORG   RTYBITAB+9
         DC    AL1(RTNDFSON-RTYONTAB)
         DC    AL1(RTNOACT-RTYOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   RTYBITAB+12
         ORG   RTYBITAB+12
         DC    AL1(RTNDFAON-RTYONTAB)
         DC    AL1(RTNOACT-RTYOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   RTYBITAB+15
         ORG   RTYBITAB+15
         DC    AL1(RTDFASON-RTYONTAB)
         DC    AL1(RTNOACT-RTYOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   MASTERTB+3505
CHABITAB DS    CL3
         ORG   CHABITAB+0
@NM00241 DC    AL1(CHFIRSON-CHAONTAB)
@NM00242 DC    AL1(CHFIROFF-CHAOFTAB)
@NM00243 DC    AL1(EXGRP1-EXBITAB)
         ORG   CHABITAB+3
         ORG   CHABITAB+3
         DC    AL1(CHMIDDON-CHAONTAB)
         DC    AL1(CHMIDOFF-CHAOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CHABITAB+6
         ORG   CHABITAB+6
         DC    AL1(CHLASTON-CHAONTAB)
         DC    AL1(CHLASOFF-CHAOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CHABITAB+9
         ORG   CHABITAB+9
         DC    AL1(CHONLYON-CHAONTAB)
         DC    AL1(CHONLOFF-CHAOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3517
POSBITAB DS    CL3
         ORG   POSBITAB+0
@NM00244 DC    AL1(PORESPON-POSONTAB)
@NM00245 DC    AL1(PONOACT-POSOFTAB)
@NM00246 DC    AL1(EXGRP1-EXBITAB)
         ORG   POSBITAB+3
         ORG   POSBITAB+3
         DC    AL1(POSCHEON-POSONTAB)
         DC    AL1(PONOACT-POSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3523
RESBITAB DS    CL3
         ORG   RESBITAB+0
@NM00247 DC    AL1(RENEXON-RESONTAB)
@NM00248 DC    AL1(RENOACT-RESOFTAB)
@NM00249 DC    AL1(EXGRP1-EXBITAB)
         ORG   RESBITAB+3
         ORG   RESBITAB+3
         DC    AL1(REEXON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   RESBITAB+6
         ORG   RESBITAB+6
         DC    AL1(REFMEON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   RESBITAB+9
         ORG   RESBITAB+9
         DC    AL1(RENFMEON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP2-EXBITAB)
         ORG   RESBITAB+12
         ORG   RESBITAB+12
         DC    AL1(RENRRNON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   RESBITAB+15
         ORG   RESBITAB+15
         DC    AL1(RERRNON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP3-EXBITAB)
         ORG   RESBITAB+18
         ORG   RESBITAB+18
         DC    AL1(REQREON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   RESBITAB+21
         ORG   RESBITAB+21
         DC    AL1(RENQREON-RESONTAB)
         DC    AL1(RENOACT-RESOFTAB)
         DC    AL1(EXGRP4-EXBITAB)
         ORG   MASTERTB+3547
CNTBITAB DS    CL3
         ORG   CNTBITAB+0
@NM00250 DC    AL1(CNDATAON-CNTONTAB)
@NM00251 DC    AL1(CNDATOFF-CNTOFTAB)
@NM00252 DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+3
         ORG   CNTBITAB+3
         DC    AL1(CNCANCON-CNTONTAB)
         DC    AL1(CNCANOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+6
         ORG   CNTBITAB+6
         DC    AL1(CNQCON-CNTONTAB)
         DC    AL1(CNQCOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+9
         ORG   CNTBITAB+9
         DC    AL1(CNQECON-CNTONTAB)
         DC    AL1(CNQECOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+12
         ORG   CNTBITAB+12
         DC    AL1(CNCHASON-CNTONTAB)
         DC    AL1(CNCHAOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+15
         ORG   CNTBITAB+15
         DC    AL1(CNRELQON-CNTONTAB)
         DC    AL1(CNRELOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+18
         ORG   CNTBITAB+18
         DC    AL1(CNBIDON-CNTONTAB)
         DC    AL1(CNBIDOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+21
         ORG   CNTBITAB+21
         DC    AL1(CNRTRON-CNTONTAB)
         DC    AL1(CNRTROFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+24
         ORG   CNTBITAB+24
         DC    AL1(CNLUSON-CNTONTAB)
         DC    AL1(CNLUSOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+27
         ORG   CNTBITAB+27
         DC    AL1(CNSIGNON-CNTONTAB)
         DC    AL1(CNSIGOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+30
         ORG   CNTBITAB+30
         DC    AL1(CNSDTON-CNTONTAB)
         DC    AL1(CNSDTOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+33
         ORG   CNTBITAB+33
         DC    AL1(CNCLEAON-CNTONTAB)
         DC    AL1(CNCLEOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+36
         ORG   CNTBITAB+36
         DC    AL1(CNSTSNON-CNTONTAB)
         DC    AL1(CNSTSOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+39
         ORG   CNTBITAB+39
         DC    AL1(CNSHUTON-CNTONTAB)
         DC    AL1(CNSHUOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+42
         ORG   CNTBITAB+42
         DC    AL1(CNRQRON-CNTONTAB)
         DC    AL1(CNRQROFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+45
         ORG   CNTBITAB+45
         DC    AL1(CNRSHUON-CNTONTAB)
         DC    AL1(CNRSHOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+48
         ORG   CNTBITAB+48
         DC    AL1(CNSHTCON-CNTONTAB)
         DC    AL1(CNSHCOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+51
         ORG   CNTBITAB+51
         DC    AL1(CNBINDON-CNTONTAB)
         DC    AL1(CNBINOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+54
         ORG   CNTBITAB+54
         DC    AL1(CNUNBDON-CNTONTAB)
         DC    AL1(CNUNBOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+57
         ORG   CNTBITAB+57
         DC    AL1(CNSBION-CNTONTAB)
         DC    AL1(CNSBIOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   CNTBITAB+60
         ORG   CNTBITAB+60
         DC    AL1(CNBISON-CNTONTAB)
         DC    AL1(CNBISOFF-CNTOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3610
QBSBITAB DS    CL3
         ORG   QBSBITAB+0
@NM00253 DC    AL1(QBSETON-QBSONTAB)
@NM00254 DC    AL1(QBSETOFF-QBSOFTAB)
@NM00255 DC    AL1(EXGRP1-EXBITAB)
         ORG   QBSBITAB+3
         ORG   QBSBITAB+3
         DC    AL1(QBTESTON-QBSONTAB)
         DC    AL1(QBTESOFF-QBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   QBSBITAB+6
         ORG   QBSBITAB+6
         DC    AL1(QBRESEON-QBSONTAB)
         DC    AL1(QBRESOFF-QBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   QBSBITAB+9
         ORG   QBSBITAB+9
         DC    AL1(QBIGNOON-QBSONTAB)
         DC    AL1(QBIGNOFF-QBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   QBSBITAB+12
         ORG   QBSBITAB+12
         DC    AL1(QBTSTPON-QBSONTAB)
         DC    AL1(QBTSPOFF-QBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   QBSBITAB+15
         ORG   QBSBITAB+15
         DC    AL1(QBTSTNON-QBSONTAB)
         DC    AL1(QBTSNOFF-QBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   QBSBITAB+18
         ORG   QBSBITAB+18
         DC    AL1(QBINVAON-QBSONTAB)
         DC    AL1(QBINVOFF-QBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3631
IBSBITAB DS    CL3
         ORG   IBSBITAB+0
@NM00256 DC    AL1(IBSETON-IBSONTAB)
@NM00257 DC    AL1(IBSETOFF-IBSOFTAB)
@NM00258 DC    AL1(EXGRP1-EXBITAB)
         ORG   IBSBITAB+3
         ORG   IBSBITAB+3
         DC    AL1(IBTESTON-IBSONTAB)
         DC    AL1(IBTESOFF-IBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   IBSBITAB+6
         ORG   IBSBITAB+6
         DC    AL1(IBRESEON-IBSONTAB)
         DC    AL1(IBRESOFF-IBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   IBSBITAB+9
         ORG   IBSBITAB+9
         DC    AL1(IBIGNOON-IBSONTAB)
         DC    AL1(IBIGNOFF-IBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   IBSBITAB+12
         ORG   IBSBITAB+12
         DC    AL1(IBTSTPON-IBSONTAB)
         DC    AL1(IBTSPOFF-IBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   IBSBITAB+15
         ORG   IBSBITAB+15
         DC    AL1(IBTSTNON-IBSONTAB)
         DC    AL1(IBTSNOFF-IBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   IBSBITAB+18
         ORG   IBSBITAB+18
         DC    AL1(IBINVAON-IBSONTAB)
         DC    AL1(IBINVOFF-IBSOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3652
SSOBITAB DS    CL3
         ORG   SSOBITAB+0
@NM00259 DC    AL1(SOCPMON-SSOONTAB)
@NM00260 DC    AL1(SOCPMOFF-SSOOFTAB)
@NM00261 DC    AL1(EXGRP1-EXBITAB)
         ORG   SSOBITAB+3
         ORG   SSOBITAB+3
         DC    AL1(SOSTATON-SSOONTAB)
         DC    AL1(SOSTAOFF-SSOOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   SSOBITAB+6
         ORG   SSOBITAB+6
         DC    AL1(SOFION-SSOONTAB)
         DC    AL1(SOFIOFF-SSOOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   SSOBITAB+9
         ORG   SSOBITAB+9
         DC    AL1(SORRON-SSOONTAB)
         DC    AL1(SORROFF-SSOOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3664
SSIBITAB DS    CL3
         ORG   SSIBITAB+0
@NM00262 DC    AL1(SIPATHON-SSIONTAB)
@NM00263 DC    AL1(SIPATOFF-SSIOFTAB)
@NM00264 DC    AL1(EXGRP1-EXBITAB)
         ORG   SSIBITAB+3
         ORG   SSIBITAB+3
         DC    AL1(SICPMON-SSIONTAB)
         DC    AL1(SICPMOFF-SSIOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   SSIBITAB+6
         ORG   SSIBITAB+6
         DC    AL1(SISTATON-SSIONTAB)
         DC    AL1(SISTAOFF-SSIOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   SSIBITAB+9
         ORG   SSIBITAB+9
         DC    AL1(SIFION-SSIONTAB)
         DC    AL1(SIFIOFF-SSIOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   SSIBITAB+12
         ORG   SSIBITAB+12
         DC    AL1(SIRRON-SSIONTAB)
         DC    AL1(SIRROFF-SSIOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3679
AIXBITAB DS    CL3
         ORG   AIXBITAB+0
@NM00265 DC    AL1(AIAIXON-AIXONTAB)
@NM00266 DC    AL1(AINOACT-AIXOFTAB)
@NM00267 DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3682
CODBITAB DS    CL3
         ORG   CODBITAB+0
@NM00268 DC    AL1(CODSTDON-CODONTAB)
@NM00269 DC    AL1(CODNOACT-CODOFTAB)
@NM00270 DC    AL1(EXGRP1-EXBITAB)
         ORG   CODBITAB+3
         ORG   CODBITAB+3
         DC    AL1(CODALTON-CODONTAB)
         DC    AL1(CODNOACT-CODOFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3688
CRBITAB  DS    CL3
         ORG   CRBITAB+0
@NM00271 DC    AL1(CRYESON-CRONTAB)
@NM00272 DC    AL1(CRNOACT-CROFTAB)
@NM00273 DC    AL1(EXGRP1-EXBITAB)
         ORG   CRBITAB+3
         ORG   CRBITAB+3
         DC    AL1(CRNOON-CRONTAB)
         DC    AL1(CRNOACT-CROFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3694
ERBITAB  DS    CL3
         ORG   ERBITAB+0
@NM00274 DC    AL1(ERSELON-ERONTAB)
@NM00275 DC    AL1(ERSELOF-EROFTAB)
@NM00276 DC    AL1(EXGRP1-EXBITAB)
         ORG   ERBITAB+3
         ORG   ERBITAB+3
         DC    AL1(ERREQON-ERONTAB)
         DC    AL1(ERREQOF-EROFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   ERBITAB+6
         ORG   ERBITAB+6
         DC    AL1(ERNONON-ERONTAB)
         DC    AL1(ERNONOF-EROFTAB)
         DC    AL1(EXGRP1-EXBITAB)
         ORG   MASTERTB+3703
IDA019C1 CSECT
*                                 /*@G40AKCM*/
         DS 0F
DEFACB   EQU *
         ACB
IDA019C1 CSECT
*                                 /*@G40AKCM*/
         DS 0F
DEFVTACB EQU *
         ACB AM=VTAM
IDA019C1 CSECT
*                               /*@G40AKCM*/
         DS 0F
DEFRPL  EQU *
         RPL
IDA019C1 CSECT
*                               /*@G40AKCM*/
         DS 0F
DEFVTRPL EQU *
         RPL AM=VTAM
IDA019C1 CSECT
*                               /*@G40AKCM*/
         DS 0F
DEFEXLST EQU *
         EXLST EODAD=(0,N),LERAD=(0,N),JRNAD=(0,N),SYNAD=(0,N)
*
*/********************************************************************/
*/*                                                                  */
*/* OPENAD EXIT DUMMY ENTRY                                          */
*/*                                                                  */
*/********************************************************************/
*
         DC AL1(0)
         DC AL4(0)
         DS 0F
*
*/********************************************************************/
*/*                                                                  */
*/* CORRECT LENGTH GENERATED                                         */
*/*                                                                  */
*/********************************************************************/
*
         ORG DEFEXLST+2
         DC   H'40'
         ORG
IDA019C1 CSECT
*                                 /*@G40AKCM*/
DEFVTEXL EQU *
         EXLST AM=VTAM,EODAD=(0,N),LERAD=(0,N),JRNAD=(0,N),SYNAD=(0,N),*
               LOGON=(0,N),RELREQ=(0,N),ATTN=(0,N),LOSTERM=(0,N),      *
               TPEND=(0,N),NSEXIT=(0,N)
IDA019C1 CSECT
*                                /*@G40AKCM*/
            DS 0F
*/********************************************************************/
*/*                                                                  */
*/*      DEFAULT NIB                                                 */
*/*                                                                  */
*/********************************************************************/
DEFNIB EQU *
        NIB
IDA019C1 CSECT
*                           /*@G40AKCM*/
*
*  AMCBS CONTROL BLOCK - LOCATED HERE FOR VS1 ONLY, OBTAINED AND
*        BUILT DYNAMICALLY BY CATALOG FOR NON-VS1.  REFERENCED BY
*        EXTERNAL SYMBOL IDA019C2 DURING NUCLEUS LINK EDIT.
*
         ENTRY IDA019C2                AMCBS SYMBOLIC REFERENCE
IDA019C2 DS    0D                      AMCBS SYMBOLIC REFERENCE
AMCBS    DS    0CL32                   AMCBS CONTROL BLOCK
*        AMCBS
CBSEND   DS    0F                      END OF AMCBS
IDA019C1 CSECT
*                          /*@G40AKCM*/
         IDAPATCH      PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA019C1 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
REG13    EQU   @13
RHDRPTR  EQU   @03
PLEPTR   EQU   @01
REG5     EQU   @05
RBLKPTR  EQU   @04
REG7     EQU   @07
REG6     EQU   @06
REG8     EQU   @08
RELEMPTR EQU   @02
RETURNR  EQU   @14
RETCODER EQU   @15
REG0     EQU   @00
REG1     EQU   @01
REG2     EQU   @02
REG9     EQU   @09
REG10    EQU   @10
REG11    EQU   @11
REG12    EQU   @12
REG15    EQU   @15
REG14    EQU   @14
REG3     EQU   @03
REG4     EQU   @04
ELEM     EQU   0
ELEMKWTC EQU   ELEM
ELEMBLEN EQU   ELEM+2
ELEMCSTR EQU   ELEM+4
ELEMFIX  EQU   ELEMCSTR
ELEMPTR  EQU   ELEMFIX
ELEMBSTR EQU   ELEMPTR
ELEMXFLG EQU   ELEMCSTR+4
GENC     EQU   0
GENBTC   EQU   GENC
GENFTC   EQU   GENC+1
GENCOP   EQU   GENC+2
GENUSA   EQU   GENC+4
GENUSL   EQU   GENC+8
MODC     EQU   0
MODBTC   EQU   MODC
MODBLAD  EQU   MODC+4
SHOW     EQU   0
SHOWOBJ  EQU   SHOW+2
SHOWBLAD EQU   SHOW+4
SHOWUSA  EQU   SHOW+8
SHOWUSL  EQU   SHOW+12
TEST     EQU   0
TESTBLAD EQU   TEST+4
TESTERET EQU   TEST+8
IDAAMB   EQU   0
AMBBUFC  EQU   IDAAMB+8
AMBPH    EQU   IDAAMB+12
AMBDSB   EQU   IDAAMB+20
@NM00006 EQU   IDAAMB+24
AMBFLG0  EQU   @NM00006
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
@NM00017 EQU   IDAAMB+56
AMBAMBXN EQU   @NM00017
@NM00018 EQU   IDAAMB+68
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAAMBXN EQU   0
AMBXEOV  EQU   IDAAMBXN
AMBXFLGS EQU   AMBXEOV+7
AMBXCSWD EQU   IDAAMBXN+16
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLXPT  EQU   IDAAMBL+24
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLPATH EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLQ2   EQU   IDAAMBL+31
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLVVIC EQU   AMBLFLG1
AMBLDUMY EQU   AMBLFLG1
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
AMBLIX   EQU   IDAAMBL+56
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDDST   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDSPAN  EQU   AMDATTR
AMDNEST  EQU   IDAAMDSB+4
AMDAXRKP EQU   AMDNEST
AMDRKP   EQU   IDAAMDSB+6
AMDKEYLN EQU   IDAAMDSB+8
AMDFSCA  EQU   IDAAMDSB+14
AMDCINV  EQU   IDAAMDSB+20
AMDLRECL EQU   IDAAMDSB+24
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDPARDB EQU   IDAAMDSB+36
AMDATTR3 EQU   IDAAMDSB+40
AMDUNQ   EQU   AMDATTR3
AMDSTAT  EQU   IDAAMDSB+48
AMDSTSP  EQU   AMDSTAT
AMDNIL   EQU   AMDSTAT+8
AMDNEXT  EQU   AMDSTAT+10
AMDNLR   EQU   AMDSTAT+12
AMDDELR  EQU   AMDSTAT+16
AMDIREC  EQU   AMDSTAT+20
AMDUPR   EQU   AMDSTAT+24
AMDRETR  EQU   AMDSTAT+28
AMDASPA  EQU   AMDSTAT+32
AMDNCIS  EQU   AMDSTAT+36
AMDNCAS  EQU   AMDSTAT+40
AMDEXCP  EQU   AMDSTAT+44
IDAARDB  EQU   0
ARDTYPE  EQU   IDAARDB+1
ARDNPTR  EQU   IDAARDB+4
ARDHRBA  EQU   IDAARDB+12
ARDERBA  EQU   IDAARDB+16
ARDPRF   EQU   IDAARDB+36
IDABSPH  EQU   0
BSPHFLG1 EQU   IDABSPH+1
BSPHCSRC EQU   IDABSPH+28
BSPHFLG2 EQU   BSPHCSRC
BSPHRDS  EQU   IDABSPH+36
BSPHFND  EQU   IDABSPH+40
BSPHUIW  EQU   IDABSPH+44
BSPHNUIW EQU   IDABSPH+48
IDABUFDR EQU   0
BUFDRNO  EQU   IDABUFDR+1
BUFDRCIX EQU   IDABUFDR+9
BUFDRFLG EQU   IDABUFDR+11
IDABUFC  EQU   0
BUFCAVL  EQU   IDABUFC
BUFCFLG1 EQU   IDABUFC+1
BUFCIOFL EQU   IDABUFC+2
BUFCFLG2 EQU   IDABUFC+3
BUFCPLH  EQU   IDABUFC+4
BUFCINV  EQU   IDABUFC+28
IDAPLHDR EQU   0
PLHDRMAX EQU   IDAPLHDR+8
IDAPLH   EQU   0
PLHFLG1  EQU   IDAPLH+2
PLHFLG2  EQU   IDAPLH+3
PLHEFLGS EQU   IDAPLH+4
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHCRBA  EQU   IDAPLH+28
PLHJORBA EQU   PLHCRBA
PLHJRNLL EQU   IDAPLH+32
PLHJCODE EQU   IDAPLH+40
PLHDIOB  EQU   IDAPLH+76
PLHEOVPT EQU   IDAPLH+180
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHKEYPT EQU   IDAPLH+248
PLHEND   EQU   IDAPLH+292
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBID    EQU   ACBCOMN
ACBSTYP  EQU   ACBCOMN+1
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBIBCT  EQU   ACBJWA
ACBINRTN EQU   ACBCOMN+8
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBKEY   EQU   ACBMACR1
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBUBF   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBSKP   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBAIX   EQU   ACBMACR2
ACBBSTNO EQU   ACBCOMN+14
ACBSTRNO EQU   ACBCOMN+15
ACBBUFND EQU   ACBCOMN+16
ACBBUFNI EQU   ACBCOMN+18
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBLSR   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBMSGAR EQU   ACBCOMN+28
ACBPASSW EQU   ACBCOMN+32
ACBEXLST EQU   ACBCOMN+36
ACBUEL   EQU   ACBEXLST
ACBDDNM  EQU   ACBCOMN+40
ACBTIOT  EQU   ACBDDNM
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBOPEN  EQU   ACBOFLGS
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBCAT   EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBUFSP EQU   ACBCOMN+56
ACBBLKSZ EQU   ACBCOMN+60
ACBMSGLN EQU   ACBBLKSZ
ACBUAPTR EQU   ACBCOMN+64
ACBAPID  EQU   ACBCOMN+72
IFGACBVT EQU   0
ACBVTEXT EQU   IFGACBVT
ACBRTN   EQU   ACBVTEXT
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLID    EQU   EXLCOMN
EXLSTYP  EQU   EXLCOMN+1
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLEODP  EQU   EXLCOMN+6
EXLSYNF  EQU   EXLCOMN+10
EXLSYNP  EQU   EXLCOMN+11
EXLLERF  EQU   EXLCOMN+15
EXLLERP  EQU   EXLCOMN+16
EXLSCIPF EQU   EXLCOMN+20
EXLUPADF EQU   EXLSCIPF
EXLSCIPS EQU   EXLUPADF
EXLSCIPA EQU   EXLUPADF
EXLSCIPK EQU   EXLUPADF
EXLSCIPP EQU   EXLCOMN+21
EXLLGNF  EQU   EXLCOMN+25
EXLLGNP  EQU   EXLCOMN+26
EXLJRNF  EQU   EXLCOMN+30
EXLJRNP  EQU   EXLCOMN+31
EXLOPNF  EQU   EXLCOMN+35
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLSPEC  EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLEXITP EQU   EXLENTRY+1
IFGEXLVT EQU   0
EXLVTEXT EQU   IFGEXLVT
EXLNLGNF EQU   EXLVTEXT
EXLNLGNP EQU   EXLVTEXT+1
EXLRLRQF EQU   EXLVTEXT+5
EXLRLRQP EQU   EXLVTEXT+6
EXLATTNF EQU   EXLVTEXT+15
EXLATTNP EQU   EXLVTEXT+16
EXLTPNDF EQU   EXLVTEXT+20
EXLTPNDP EQU   EXLVTEXT+21
EXLTNSEF EQU   EXLVTEXT+25
EXLTNSEP EQU   EXLVTEXT+26
EXLDFAS  EQU   0
EXLDFASF EQU   EXLDFAS
EXLDFASP EQU   EXLDFAS+1
EXLRESP  EQU   0
EXLRESPF EQU   EXLRESP
EXLRESPP EQU   EXLRESP+1
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLID    EQU   RPLIDWD
RPLREQ   EQU   RPLIDWD+2
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLPOST  EQU   RPLECB
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLUINPT EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLRDSOH EQU   RPLFDB3
RPLKEYLE EQU   RPLCOMN+16
RPLKEYL  EQU   RPLKEYLE
RPLSTRID EQU   RPLCOMN+18
RPLDACB  EQU   RPLCOMN+24
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLLOC   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLGEN   EQU   RPLOPT1
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLKEY   EQU   RPLOPT2
RPLADR   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLNSP   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLCHAIN EQU   RPLNXTRP
RPLRLEN  EQU   RPLCOMN+48
RPLBUFL  EQU   RPLCOMN+52
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLDLGIN EQU   RPLOPT5
RPLPSOPT EQU   RPLOPT5
RPLWRTYP EQU   RPLOPT5
RPLNERAS EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLERACE EQU   RPLWRTYP
RPLNODE  EQU   RPLOPT5
RPLWROPT EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLEOB   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOT   EQU   RPLUNTYP
RPLCOND  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLCNALL EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLQOPT  EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLODACQ EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLRBAR  EQU   RPLCOMN+60
RPLAIXPC EQU   RPLRBAR
RPLAIXID EQU   RPLRBAR+2
RPLAXPKP EQU   RPLAIXID
RPLDDDD  EQU   RPLRBAR+4
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLNEXIT EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLTCRYP EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
RPLBRANC EQU   RPLEXTD1
RPLACTIV EQU   RPLCOMN+69
RPLEMLEN EQU   RPLCOMN+70
RPLERMSA EQU   RPLCOMN+72
IFGRPLVT EQU   0
RPLVTEXT EQU   IFGRPLVT
RPLAAREA EQU   RPLVTEXT
RPLAARLN EQU   RPLVTEXT+4
RPLARCLN EQU   RPLVTEXT+8
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLPATHI EQU   RPLSSEI
RPLCPMI  EQU   RPLSSEI
RPLSTATI EQU   RPLSSEI
RPLFII   EQU   RPLSSEI
RPLRRI   EQU   RPLSSEI
RPLDSB2  EQU   RPLDSB+1
RPLSSMI  EQU   RPLDSB2
RPLUSNSI EQU   RPLFDBK2+2
RPLUSFLD EQU   RPLVTEXT+16
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLLOGON EQU   RPLOPT9
RPLDEVCH EQU   RPLOPT9
RPLTERMS EQU   RPLOPT9
RPLCOUNT EQU   RPLOPT9
RPLAPPST EQU   RPLOPT9
RPLRNNM  EQU   RPLOPT9
RPLCIDE  EQU   RPLOPT9
RPLTOPL  EQU   RPLOPT9
RPLOPT10 EQU   RPLOPTC3+1
RPLBSCID EQU   RPLOPT10
RPLDSPLY EQU   RPLOPT10
RPLSPARM EQU   RPLOPT10
RPLTSKY  EQU   RPLOPT10
RPLOPT11 EQU   RPLOPTC3+2
RPLQUIES EQU   RPLOPT11
RPLSTART EQU   RPLOPT11
RPLSTOP  EQU   RPLOPT11
RPLOPT12 EQU   RPLOPTC3+3
RPLKEEP  EQU   RPLOPT12
RPLTRUNC EQU   RPLOPT12
RPLNIBTK EQU   RPLOPT12
RPLFMHDR EQU   RPLOPT12
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLCPMO  EQU   RPLSSEO
RPLSTATO EQU   RPLSSEO
RPLFIO   EQU   RPLSSEO
RPLRRO   EQU   RPLSSEO
RPLSSMO  EQU   RPLSSNSO+1
RPLUSNSO EQU   RPLOSENS+2
RPLSIGDA EQU   RPLVTEXT+32
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLBB    EQU   RPLRH3
RPLEB    EQU   RPLRH3
RPLCMD   EQU   RPLRH3
RPLCHREQ EQU   RPLRH3
RPLCSI   EQU   RPLRH3
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLSRESP EQU   RPLSTYPE
RPLRTYPE EQU   RPLSRTYP
RPLRRESP EQU   RPLRTYPE
RPLNFSYN EQU   RPLRTYPE
RPLDFASY EQU   RPLRTYPE
RPLCHN   EQU   RPLOF16+2
RPLFIRST EQU   RPLCHN
RPLMIDLE EQU   RPLCHN
RPLLAST  EQU   RPLCHN
RPLONLY  EQU   RPLCHN
RPLVTFL1 EQU   RPLOF16+3
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLSCHED EQU   RPLPOSTV
RPLRESP  EQU   RPLVTFL2
RPLQRI   EQU   RPLRESP
RPLEX    EQU   RPLRESP
RPLNFME  EQU   RPLRESP
RPLRRN   EQU   RPLRESP
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLDATA  EQU   RPLCNTDF
RPLCNCEL EQU   RPLCNTDF
RPLQC    EQU   RPLCNTDF
RPLQEC   EQU   RPLCNTDF
RPLCHASE EQU   RPLCNTDF
RPLRELQ  EQU   RPLCNTDF
RPLCNTDC EQU   RPLCNTRL+1
RPLBID   EQU   RPLCNTDC
RPLRTR   EQU   RPLCNTDC
RPLLUS   EQU   RPLCNTDC
RPLSIGNL EQU   RPLCNTDC
RPLTBIND EQU   RPLCNTDC
RPLTUNBD EQU   RPLCNTDC
RPLSBI   EQU   RPLCNTDC
RPLBIS   EQU   RPLCNTDC
RPLCNTSC EQU   RPLCNTRL+2
RPLSDT   EQU   RPLCNTSC
RPLCLEAR EQU   RPLCNTSC
RPLSTSN  EQU   RPLCNTSC
RPLSHUTD EQU   RPLCNTSC
RPLSHUTC EQU   RPLCNTSC
RPLRQR   EQU   RPLCNTSC
RPLRSHUT EQU   RPLCNTSC
RPLOF60  EQU   0
RPLOBSQV EQU   RPLOF60
RPLIBSQV EQU   RPLOF60+2
RPLOBSQ  EQU   RPLOF60+4
RPLOSET  EQU   RPLOBSQ
RPLOTST  EQU   RPLOBSQ
RPLORSET EQU   RPLOBSQ
RPLOIGN  EQU   RPLOBSQ
RPLOPOS  EQU   RPLOBSQ
RPLONEG  EQU   RPLOBSQ
RPLOINV  EQU   RPLOBSQ
RPLIBSQ  EQU   RPLOF60+5
RPLISET  EQU   RPLIBSQ
RPLITST  EQU   RPLIBSQ
RPLIRSET EQU   RPLIBSQ
RPLIIGN  EQU   RPLIBSQ
RPLIPOS  EQU   RPLIBSQ
RPLINEG  EQU   RPLIBSQ
RPLIINV  EQU   RPLIBSQ
RPLSEQNO EQU   RPLOF60+6
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROTRUNC EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PRODFASY EQU   PROPROC1
PRORESPX EQU   PROPROC1
PROCA    EQU   PROPROC1
PROCS    EQU   PROPROC1
PRORPLC  EQU   PROPROC1
PROPROC2 EQU   PROPROC+1
PROERPO  EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROSYSR  EQU   PROPROC2
PROFIFOR EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PROCFTX  EQU   PROPROC2
PROPROC3 EQU   PROPROC+2
PROERPI  EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROPROC4 EQU   PROPROC+3
PROEIB   EQU   PROPROC4
PROMODB  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODC  EQU   PROPROC4
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTNIB   EQU   0
NIBID    EQU   ISTNIB
NIBCONDN EQU   ISTNIB+2
NIBLEN   EQU   ISTNIB+3
NIBCID   EQU   ISTNIB+4
NIBUSER  EQU   ISTNIB+8
NIBSYM   EQU   ISTNIB+12
NIBMODE  EQU   ISTNIB+20
NIBDEVCH EQU   ISTNIB+28
NIBPROCD EQU   ISTNIB+36
NIBFLGS  EQU   ISTNIB+40
NIBFLG1  EQU   NIBFLGS
NIBLAST  EQU   NIBFLG1
NIBCON   EQU   NIBFLG1
NIBSDAPP EQU   NIBFLG1
NIBTSEL  EQU   NIBFLG1
NIBTREQ  EQU   NIBFLG1
NIBLIMIT EQU   ISTNIB+42
NIBEXLST EQU   ISTNIB+44
NIBLMODE EQU   ISTNIB+48
NIBNDAR  EQU   ISTNIB+56
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBTIO   EQU   TCB+12
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBFTJST EQU   TCB+44
TCBPURGE EQU   TCBFTJST
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBPIB   EQU   TCB+124
TCBPIBT  EQU   TCBPIB
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBFTFLG EQU   TCB+153
TCBFTFL1 EQU   TCBFTFLG
TCBFTFL2 EQU   TCBFTFLG+1
TCBFTFL3 EQU   TCBFTFLG+2
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBARB   EQU   TCB+220
TCBTTQE  EQU   TCB+224
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOEDDNM EQU   TIOENTRY+4
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
USERAREA EQU   0
RETADDR  EQU   USERAREA+12
GMANS    EQU   RETADDR
TESTCC   EQU   GMANS
GMPL     EQU   USERAREA+16
GMLEN    EQU   GMPL
GMAPTR   EQU   GMPL+4
BITSTINS EQU   GMAPTR
SHOWUSE  EQU   BITSTINS
TSTOP    EQU   SHOWUSE
MASK     EQU   SHOWUSE+1
REG1SAVE EQU   GMPL+8
EXBITABL EQU   REG1SAVE
GMMODE   EQU   EXBITABL
EXBIT1   EQU   GMMODE
EXBIT2   EQU   GMMODE
EXBIT3   EQU   GMMODE
EXBIT4   EQU   GMMODE
EXBIT5   EQU   GMMODE
EXBIT6   EQU   GMMODE
EXBIT7   EQU   GMMODE
EXBIT8   EQU   GMMODE
GMSP     EQU   EXBITABL+1
EXBIT9   EQU   GMSP
EXBIT10  EQU   GMSP
EXBIT11  EQU   GMSP
EXBIT12  EQU   GMSP
EXBIT13  EQU   GMSP
EXBIT14  EQU   GMSP
EXBIT15  EQU   GMSP
EXBIT16  EQU   GMSP
EXBIT17  EQU   EXBITABL+2
EXBIT18  EQU   EXBITABL+2
EXBIT19  EQU   EXBITABL+2
EXBIT20  EQU   EXBITABL+2
EXBIT21  EQU   EXBITABL+2
EXBIT22  EQU   EXBITABL+2
EXBIT23  EQU   EXBITABL+2
EXBIT24  EQU   EXBITABL+2
EXBIT25  EQU   EXBITABL+3
EXBIT26  EQU   EXBITABL+3
EXBIT27  EQU   EXBITABL+3
EXBIT28  EQU   EXBITABL+3
EXBIT29  EQU   EXBITABL+3
EXMAIN   EQU   EXBIT29
INEXON   EQU   EXMAIN
EXBIT30  EQU   EXBITABL+3
EXMAKEY  EQU   EXBIT30
KEYEXON  EQU   EXMAKEY
EXBIT31  EQU   EXBITABL+3
EXMASEQ  EQU   EXBIT31
REGSAVE  EQU   REG1SAVE+4
FTCBTC   EQU   0
VTAMFLG  EQU   0
VTAMSW   EQU   VTAMFLG
PARMLIST EQU   0
PARMPTR  EQU   PARMLIST
PLEMPTR  EQU   PARMPTR
PHDRPTR  EQU   PLEMPTR
PARMFLG  EQU   PHDRPTR
EOL      EQU   PARMFLG
BATOFFTB EQU   0
BATON    EQU   BATOFFTB
BATOFF   EQU   BATOFFTB+1
BATEX    EQU   BATOFFTB+2
FWORDFLD EQU   0
USERFLD  EQU   0
USERDWRD EQU   USERFLD
USERWORD EQU   USERDWRD
USERHWRD EQU   USERWORD+2
USERCHAR EQU   USERHWRD+1
TESTAREA EQU   0
USTSFLD  EQU   0
SHOWAREA EQU   0
SHOWWORD EQU   0
SHOWFLD  EQU   0
EXTECB   EQU   0
ECBPOST  EQU   EXTECB
NEWACB   EQU   0
NEWVTACB EQU   0
NEWRPL   EQU   0
NEWVTRPL EQU   0
NEWEXLST EQU   0
NEWVTEXL EQU   0
NEWNIB   EQU   0
ISTACB   EQU   0
ISTRPL   EQU   0
MODFLD   EQU   0
NEWBLK   EQU   0
PLHKEY   EQU   0
PLHRRN   EQU   0
STFLDLEN EQU   0
STFLDOFF EQU   0
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+13
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
@NM00128 EQU   KEYWDTAB
TYPECD   EQU   @NM00128
MACB     EQU   TYPECD
SACB     EQU   TYPECD+1
TACB     EQU   TYPECD+2
MEXLST   EQU   TYPECD+3
SEXLST   EQU   TYPECD+4
TEXLST   EQU   TYPECD+5
MRPL     EQU   TYPECD+6
SRPL     EQU   TYPECD+7
TRPL     EQU   TYPECD+8
MNIB     EQU   TYPECD+9
SNIB     EQU   TYPECD+10
TNIB     EQU   TYPECD+11
FLDLEN   EQU   TYPECD+12
FLDOFF   EQU   TYPECD+13
BUFCRSC1 EQU   BUFCAVL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
PLHBMSV5 EQU   PLHEXTEN+32
PLHBMSV4 EQU   PLHEXTEN+28
PLHBMSV3 EQU   PLHEXTEN+24
PLHBMSV2 EQU   PLHEXTEN+20
PLHBMSV1 EQU   PLHEXTEN+16
PLHRDCNT EQU   PLHEXTEN+14
@NM00048 EQU   PLHBMWRK
PLHBMWF  EQU   PLHBMWRK
PLHBRBAF EQU   PLHBMWRK
PLHBEXCF EQU   PLHBMWRK
PLHBINVF EQU   PLHBMWRK
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00047 EQU   PLHEXTEN+12
PLHRESR1 EQU   PLHEXTEN+8
@NM00046 EQU   PLHEXTEN
ECBWAIT  EQU   EXTECB
@NM00130 EQU   USERHWRD
@NM00129 EQU   USERWORD
@NM00127 EQU   VTAMFLG
@NM00126 EQU   REGSAVE+40
@NM00125 EQU   REGSAVE+36
@NM00124 EQU   REGSAVE+32
@NM00123 EQU   REGSAVE+28
@NM00122 EQU   REGSAVE+24
@NM00121 EQU   REGSAVE+20
@NM00120 EQU   REGSAVE+16
@NM00119 EQU   REGSAVE+12
@NM00118 EQU   REGSAVE+8
@NM00117 EQU   REGSAVE+4
@NM00116 EQU   REGSAVE
LSROFF   EQU   EXBIT8
@NM00115 EQU   USERAREA
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00112 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00111 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
@NM00110 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00109 EQU   TCB+232
TCBRV190 EQU   TCB+229
TCBSVCA1 EQU   TCB+228
TCBJSONQ EQU   TCBTTQE
TCBARBA  EQU   TCBARB+1
TCBRSV85 EQU   TCBARB
TCBGQE   EQU   TCB+216
TCBPCB   EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSV84 EQU   TCBFLGS7
TCBRSV83 EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBFWDD  EQU   TCBFLGS7
TCBFDDEI EQU   TCBFLGS7
TCBFDDT  EQU   TCBFLGS7
TCBFDD   EQU   TCBFLGS7
TCBSTIJS EQU   TCBFLGS6
TCBDSINQ EQU   TCBFLGS6
TCBRUNJB EQU   TCBFLGS6
TCBRUNPN EQU   TCBFLGS6
TCBFPROT EQU   TCBFLGS6
TCBPANIC EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBNDGTF EQU   TCBNDSP5
TCBNDSPL EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00108 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBRSV28 EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBNDSDA EQU   TCBNDSP3
TCBABTER EQU   TCBNDSP3
TCBTERM  EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBVALID EQU   TCBNSTAE
TCBRETRY EQU   TCBNSTAE
TCBSUPER EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBSCAT  EQU   TCBNSTAE
TCBXCTL  EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBDDRTI EQU   TCB+156
TCBRSV73 EQU   TCBFTFL3
TCBRSV72 EQU   TCBFTFL3
TCBFTDUM EQU   TCBFTFL3
TCBRSV71 EQU   TCBFTFL3
TCBRSV70 EQU   TCBFTFL3
TCBRSV69 EQU   TCBFTFL3
TCBRSV68 EQU   TCBFTFL3
TCBRSV67 EQU   TCBFTFL3
TCBRSV66 EQU   TCBFTFL2
TCBSYSAB EQU   TCBFTFL2
TCBFDSOP EQU   TCBFTFL2
TCBRSV65 EQU   TCBFTFL2
TCBLPAGE EQU   TCBFTFL2
TCBDDEN  EQU   TCBFTFL2
TCBRSV62 EQU   TCBFTFL2
TCBRSV61 EQU   TCBFTFL2
TCBENQ   EQU   TCBFTFL1
TCBFTCOM EQU   TCBFTFL1
TCBFTTOP EQU   TCBFTFL1
TCBRSV60 EQU   TCBFTFL1
TCBRSV59 EQU   TCBFTFL1
TCBRWTOR EQU   TCBFTFL1
TCBVTAM  EQU   TCBFTFL1
TCBTCAM  EQU   TCBFTFL1
TCBFTLMP EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBPIBA  EQU   TCBPIB+1
TCBSCHED EQU   TCBPIBT
TCBWRITE EQU   TCBPIBT
TCBSCHTI EQU   TCBPIBT
TCBRSV54 EQU   TCBPIBT
TCBSTOP  EQU   TCBPIBT
TCBSIZE  EQU   TCBPIBT
TCBPART  EQU   TCBPIBT
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBIDF   EQU   TCBFSA
TCBGRS9  EQU   TCBGRS+60
TCBGRS8  EQU   TCBGRS+56
TCBGRS7  EQU   TCBGRS+52
TCBGRS6  EQU   TCBGRS+48
TCBGRS5  EQU   TCBGRS+44
TCBGRS4  EQU   TCBGRS+40
TCBGRS3  EQU   TCBGRS+36
TCBGRS2  EQU   TCBGRS+32
TCBGRS1  EQU   TCBGRS+28
TCBGRS0  EQU   TCBGRS+24
TCBGRS15 EQU   TCBGRS+20
TCBGRS14 EQU   TCBGRS+16
TCBGRS13 EQU   TCBGRS+12
TCBGRS12 EQU   TCBGRS+8
TCBGRS11 EQU   TCBGRS+4
TCBGRS10 EQU   TCBGRS
TCBFTJSA EQU   TCBFTJST+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBRSV53 EQU   TCBFLGS3
TCBPKCHG EQU   TCBFLGS3
TCBSCHAB EQU   TCBFLGS3
TCBFLREG EQU   TCBFLGS3
TCBRSV52 EQU   TCBFLGS3
TCBSYSER EQU   TCBFLGS3
TCBRSV51 EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBRSV50 EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBSYSTK EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBPOOL  EQU   TCBFLGS1
TCBDMPA  EQU   TCBFLGS1
TCBJSTE  EQU   TCBFLGS1
TCBABTRM EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00107 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00106 EQU   DEBACS08+12
@NM00105 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00104 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00103 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
NIBRESV  EQU   ISTNIB+60
@NM00102 EQU   ISTNIB+41
@NM00101 EQU   NIBFLG1
NIBNACLQ EQU   NIBFLG1
NIBSHLTP EQU   NIBFLG1
NIBRSV01 EQU   ISTNIB+1
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PRORSV11 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PRORSV03 EQU   PROPROC2
PROASYIP EQU   PROPROC1
@NM00100 EQU   RPLIBSQ
@NM00099 EQU   RPLOBSQ
@NM00098 EQU   RPLCNTSC
@NM00097 EQU   RPLCNTDF
RPLQI    EQU   RPLCNTDF
@NM00096 EQU   RPLPOSTV
@NM00095 EQU   RPLVTFL1
RPLTLGAC EQU   RPLVTFL1
RPLTNDSP EQU   RPLVTFL1
RPLAUTUS EQU   RPLVTFL1
RPLVTUSE EQU   RPLVTFL1
@NM00094 EQU   RPLVTFL1
@NM00093 EQU   RPLCHN
@NM00092 EQU   RPLRTYPE
@NM00091 EQU   RPLSTYPE
@NM00090 EQU   RPLRH3
RPLSAV13 EQU   RPLVTEXT+28
@NM00089 EQU   RPLSSEO
@NM00088 EQU   RPLSSEO
@NM00087 EQU   RPLOPT12
@NM00086 EQU   RPLOPT12
@NM00085 EQU   RPLOPT12
@NM00084 EQU   RPLOPT12
RPLRSVE8 EQU   RPLOPT11
RPLRSVE7 EQU   RPLOPT11
RPLRSVE6 EQU   RPLOPT11
RPLRSVE5 EQU   RPLOPT11
RPLRSVE4 EQU   RPLOPT11
RPLRSVI6 EQU   RPLOPT10
RPLRSVI5 EQU   RPLOPT10
RPLRSVI4 EQU   RPLOPT10
RPLRSVI3 EQU   RPLOPT10
RPLESR2  EQU   RPLUSNSI+1
RPLESR1  EQU   RPLUSNSI
@NM00083 EQU   RPLSSEI
@NM00082 EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
@NM00081 EQU   RPLRBAR+3
@NM00080 EQU   RPLAIXID
RPLRSV88 EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
@NM00079 EQU   RPLOPT5
@NM00078 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLWAITX EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLECBIN EQU   RPLECBSW
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSV32  EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLSTYP  EQU   RPLIDWD+1
@NM00077 EQU   EXLRESPF
EXLRESPK EQU   EXLRESPF
EXLRESPA EQU   EXLRESPF
EXLRESPS EQU   EXLRESPF
@NM00076 EQU   EXLDFASF
EXLDFASK EQU   EXLDFASF
EXLDFASA EQU   EXLDFASF
EXLDFASS EQU   EXLDFASF
@NM00075 EQU   EXLTNSEF
EXLTNSEK EQU   EXLTNSEF
EXLTNSEA EQU   EXLTNSEF
EXLTNSES EQU   EXLTNSEF
@NM00074 EQU   EXLTPNDF
EXLTPNDK EQU   EXLTPNDF
EXLTPNDA EQU   EXLTPNDF
EXLTPNDS EQU   EXLTPNDF
@NM00073 EQU   EXLATTNF
EXLATTNK EQU   EXLATTNF
EXLATTNA EQU   EXLATTNF
EXLATTNS EQU   EXLATTNF
@NM00072 EQU   EXLVTEXT+10
@NM00071 EQU   EXLRLRQF
EXLRLRQK EQU   EXLRLRQF
EXLRLRQA EQU   EXLRLRQF
EXLRLRQS EQU   EXLRLRQF
@NM00070 EQU   EXLNLGNF
EXLNLGNK EQU   EXLNLGNF
EXLNLGNA EQU   EXLNLGNF
EXLNLGNS EQU   EXLNLGNF
EXLEADDR EQU   EXLEXITP
@NM00069 EQU   EXLENFL
EXLOPNP  EQU   EXLCOMN+36
@NM00068 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
@NM00067 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
@NM00066 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLUPADP EQU   EXLSCIPP
@NM00065 EQU   EXLUPADF
EXLUPADK EQU   EXLSCIPK
EXLUPADA EQU   EXLSCIPA
EXLUPADS EQU   EXLSCIPS
@NM00064 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
@NM00063 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
@NM00062 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00061 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
@NM00060 EQU   ACBVTEXT+8
@NM00059 EQU   ACBVTEXT+6
ACBAMAX  EQU   ACBAPID
ACBCBMWA EQU   ACBCOMN+68
ACBLRECL EQU   ACBCOMN+62
@NM00058 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00057 EQU   ACBINFLG
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00056 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00055 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
@NM00054 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00053 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00052 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00051 EQU   ACBMACR3
@NM00050 EQU   ACBMACR3
@NM00049 EQU   ACBMACR2
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBAMWAP EQU   ACBIBCT
ACBLEN2  EQU   ACBLENG2
PLHRET1X EQU   IDAPLH+280
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00045 EQU   IDAPLH+265
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHNOSEG EQU   IDAPLH+240
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00044 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHIBUFC EQU   IDAPLH+188
PLHNRBA  EQU   IDAPLH+184
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00043 EQU   IDAPLH+172
@NM00042 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHRET1  EQU   IDAPLH+120
PLHRETOX EQU   IDAPLH+118
PLHRETO  EQU   IDAPLH+116
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHSAVE1 EQU   IDAPLH+84
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHRDFC  EQU   IDAPLH+72
PLHRDFP  EQU   IDAPLH+68
PLHFSP   EQU   IDAPLH+64
PLHRECP  EQU   IDAPLH+60
PLHNBUFC EQU   IDAPLH+56
PLHDBUFC EQU   IDAPLH+52
PLHLRECL EQU   IDAPLH+48
PLHARDB  EQU   IDAPLH+44
@NM00041 EQU   IDAPLH+43
PLHEOVR  EQU   IDAPLH+42
PLHRCODE EQU   IDAPLH+41
PLHUCODE EQU   PLHJCODE
PLHJNRBA EQU   IDAPLH+36
PLHCNCL1 EQU   PLHJRNLL
PLHUPECB EQU   PLHJORBA
PLHDSIDA EQU   IDAPLH+24
PLHCRPL  EQU   IDAPLH+20
PLHMRPL  EQU   IDAPLH+16
PLHBFRNO EQU   IDAPLH+15
PLHFRCNT EQU   IDAPLH+14
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRAE   EQU   PLHAFLGS
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHDBDC  EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
PLHIOSRQ EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHEOVDF EQU   PLHFLG3
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00040 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHINVAL EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLHSKPER EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHNOSPC EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHKRE   EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHKEYMD EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
PLHSR    EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHRDEXC EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHENDRQ EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHAVL   EQU   IDAPLH
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRCUR EQU   IDAPLHDR+10
PLHDRREQ EQU   IDAPLHDR+4
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
BUFCEND  EQU   IDABUFC+64
BUFCUCDN EQU   IDABUFC+60
BUFCUCUP EQU   IDABUFC+56
BUFCMDBT EQU   IDABUFC+52
BUFCHAIN EQU   IDABUFC+48
BUFXORBA EQU   IDABUFC+44
BUFXIRBA EQU   IDABUFC+40
BUFCNXT2 EQU   IDABUFC+37
BUFCIDXL EQU   IDABUFC+36
BUFCDSPC EQU   IDABUFC+32
BUFCWLEN EQU   BUFCINV
BUFCNXT1 EQU   IDABUFC+24
BUFCBAD  EQU   IDABUFC+20
BUFCCPA  EQU   IDABUFC+16
BUFCORBA EQU   IDABUFC+12
BUFCDDDD EQU   IDABUFC+8
BUFCAMB  EQU   BUFCPLH
@NM00039 EQU   BUFCFLG2
BUFCEOD  EQU   BUFCFLG2
BUFCBSYW EQU   BUFCFLG2
BUFCBSYR EQU   BUFCFLG2
BUFCNLAS EQU   BUFCFLG2
BUFCXDDR EQU   BUFCFLG2
BUFCFIX  EQU   BUFCIOFL
BUFCPFCP EQU   BUFCIOFL
BUFCXEDB EQU   BUFCIOFL
BUFCWC   EQU   BUFCIOFL
BUFCREAL EQU   BUFCIOFL
BUFCRRD  EQU   BUFCIOFL
BUFCFMT  EQU   BUFCIOFL
BUFCMW   EQU   BUFCIOFL
BUFCEPT  EQU   BUFCFLG1
BUFCEXC  EQU   BUFCFLG1
BUFCVAL  EQU   BUFCFLG1
BUFCER2  EQU   BUFCFLG1
BUFCER1  EQU   BUFCFLG1
BUFCINS  EQU   BUFCFLG1
BUFCSEG  EQU   BUFCFLG1
BUFCUPG  EQU   BUFCFLG1
BUFCUCNT EQU   BUFCAVL
@NM00038 EQU   IDABUFDR+16
BUFDBUFC EQU   IDABUFDR+12
@NM00037 EQU   BUFDRFLG
BUFDRAVL EQU   BUFDRFLG
BUFDRREL EQU   BUFDRFLG
BUFDRTSB EQU   IDABUFDR+10
BUFDRMAX EQU   BUFDRCIX
BUFDRPFN EQU   IDABUFDR+8
BUFDRPFB EQU   IDABUFDR+4
BUFDRLEN EQU   IDABUFDR+2
BUFDRID  EQU   IDABUFDR
BSPH1ST  EQU   IDABSPH+60
BSPHUBTM EQU   IDABSPH+56
BSPHUTOP EQU   IDABSPH+52
BSPHCPLH EQU   IDABSPH+32
BSPHPSUC EQU   BSPHCSRC+2
@NM00036 EQU   BSPHCSRC+1
BSPHPCUC EQU   BSPHFLG2
BSPHAPRT EQU   BSPHFLG2
BSPHBSZ  EQU   IDABSPH+24
BSPHMDBT EQU   IDABSPH+20
BSPHBUFC EQU   IDABSPH+16
BSPHERCT EQU   IDABSPH+14
BSPHBFNO EQU   IDABSPH+12
BSPHNBSP EQU   IDABSPH+8
BSPHNM   EQU   IDABSPH+4
BSPHLEN  EQU   IDABSPH+2
BSPHBFRF EQU   BSPHFLG1
BSPHIOBF EQU   BSPHFLG1
BSPHID   EQU   IDABSPH
ARDKEYS  EQU   IDAARDB+37
@NM00035 EQU   ARDPRF
ARDPRRC  EQU   ARDPRF
ARDPRFMT EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDRCLST EQU   IDAARDB+32
ARDRCFST EQU   IDAARDB+28
ARDRELNO EQU   IDAARDB+26
ARDVOLSR EQU   IDAARDB+20
ARDHKRBA EQU   IDAARDB+8
ARDLEN   EQU   IDAARDB+2
ARDUPD   EQU   ARDTYPE
ARDUSED  EQU   ARDTYPE
ARDEOD   EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDKR    EQU   ARDTYPE
ARDID    EQU   IDAARDB
@NM00034 EQU   IDAAMDSB+41
@NM00033 EQU   AMDATTR3
AMDSPACE EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDFSCI  EQU   IDAAMDSB+16
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDLEN   EQU   IDAAMDSB+2
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLCMB  EQU   IDAAMBL+64
AMBLBIB  EQU   IDAAMBL+60
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00032 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00031 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00030 EQU   AMBLFLG2
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLSDS  EQU   AMBLVVIC
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00029 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00028 EQU   AMBLQ2
AMBLCBIC EQU   AMBLQ2
@NM00027 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00026 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBXLVL  EQU   IDAAMBXN+24
AMBXBM2S EQU   IDAAMBXN+20
AMBXRDCT EQU   AMBXCSWD+2
@NM00025 EQU   AMBXCSWD
AMBXECB  EQU   IDAAMBXN+12
AMBXASCB EQU   IDAAMBXN+8
@NM00024 EQU   AMBXFLGS
AMBXUPD  EQU   AMBXFLGS
AMBXEVRC EQU   AMBXEOV+6
AMBXEOVR EQU   AMBXEOV+5
AMBXRSC  EQU   AMBXEOV+4
AMBXEVPT EQU   AMBXEOV
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
@NM00023 EQU   IDAAMB+88
@NM00022 EQU   AMBCSWD1+2
@NM00021 EQU   AMBCSWD1+1
@NM00020 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00019 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
AMBVSI   EQU   @NM00018
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBEDB   EQU   IDAAMB+52
@NM00016 EQU   IDAAMB+50
@NM00015 EQU   AMBFLG2
AMBSHR   EQU   AMBFLG2
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00014 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00013 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBSDS   EQU   AMBINFL
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00012 EQU   AMBINFL
@NM00011 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00010 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00009 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00008 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00007 EQU   AMBFLG0
AMBSWSP  EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
@NM00005 EQU   IDAAMB+1
AMBID    EQU   IDAAMB
@NM00004 EQU   TEST+12
TESTOBJ  EQU   TEST+2
TESTFTC  EQU   TEST+1
TESTBTC  EQU   TEST
@NM00003 EQU   SHOW+14
SHOWFTC  EQU   SHOW+1
SHOWBTC  EQU   SHOW
@NM00002 EQU   MODC+2
MODFTC   EQU   MODC+1
@NM00001 EQU   GENC+10
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00407 EQU   INVKEYWD
@RT00455 EQU   INVKEYWD
@RC00486 EQU   @RC00485
@RT00504 EQU   INVKEYWD
@RC00510 EQU   @RC00509
@RT00577 EQU   INVKEYWD
@RT00617 EQU   INVKEYWD
@RT00645 EQU   INVKEYWD
@RT00670 EQU   INVKEYWD
@RT00694 EQU   INVKEYWD
@RT00719 EQU   INVKEYWD
@RT00744 EQU   INVKEYWD
@RT00769 EQU   INVKEYWD
@RT00794 EQU   INVKEYWD
@RT00819 EQU   INVKEYWD
@RT00848 EQU   INVKEYWD
@RT00877 EQU   INVKEYWD
@RT00906 EQU   INVKEYWD
@RT00925 EQU   FUNCERR
@RF00945 EQU   INVKEYWD
@RC00973 EQU   EXITBAD
@RT01516 EQU   INVKEYWD
@RF01526 EQU   @RC01518
@RT01538 EQU   MODBITST
@RT01571 EQU   TSTBITST
@RT01604 EQU   MODBITST
@RT01620 EQU   TSTBITST
@RT01719 EQU   DSPFIELD
@RT01732 EQU   TSTFIELD
@RF01791 EQU   @RC01788
@ENDDATA EQU   *
         END   IDA019C1,(C'PLS1729',0701,77308)
