         TITLE 'IDA0231B - VS2 VSAM TCLOSE CLUSTER                     *
                        '
IDA0231B CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0231B  78.144'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@03                                         0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
*                                      USE                           */
*   RSTATRTN=IDAR231B;              /* NOTE 231B IN CONTROL          */
         L     @05,CLWCOMWK(,RCORE)                                0240
         MVC   RSTATRTN(4,@05),@CC04131                            0240
*   PDPFUNC=PDF157;                 /* TCLOSE AMBL                   */
         MVI   PDPFUNC+280(@05),X'9D'                              0241
*/********************************************************************/
*/*           IDAGMAIN - GETS CORE STORAGE FOR AUTOMATICS.           */
*/*                      FOR VS2 IDAGMAIN WILL MOVE THE      @Z30SSRL*/
*/*                      ID AND DATE OF THE MODULE TO A      @Z30SSRL*/
*/*                      LOCATION DIRECTLY AFTER THE PLS     @Z30SSRL*/
*/*                      GENERATED SAVE AREA.                @Z30SSRL*/
*/*           DATE OF LAST CHANGE = 3 DECEMBER 74            @Z30SSRL*/
*/********************************************************************/
*                                                                  0242
*   GEN;                                                           0242
         L     @00,@SIZDATD             LOAD LENGTH OF AUTOMATICS
         GETMAIN RC,LV=(0),SP=0         ISSUE GETMAIN IN SUBPOOL ZERO
         LTR   @15,@15                  TEST RETURN CODE FOR ERROR
         BNZ   GMN00100                 BRANCH IF ERROR ENCOUNTERED
*                                       IF NO ERROR WAS ENCOUNTERED
         LR    @00,@01                  ADDRESS OF GOTTEN AREA IN R0
         LR    @14,@01                  SAVE THE ADDRESS IN REGISTER 14
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         MVCL  @00,@14                  ZERO THE GOTTEN AREA, R15=0
         LR    @15,@14                  ADDRESS OF AREA IN REGISTER 15
         ST    @15,8(,@13)              FORWARD CHAIN THIS SAVE AREA
         L     @01,@SIZDATD             LENGTH OF GOTTEN AREA
         ST    @01,88(,@15)             STORE LENGTH OF AREA
         LR    @14,@03                  LOAD BASE REGISTER OF MODULE
         LA    @01,23                   LOAD NEGATIVE OFFSET BYTE NO.
         SR    @14,@01                  NEGITIVE OFFSET 23 BYTES
         MVC   72(16,@15),0(@14)        GET MODULE NAME AND DATE
         B     GMN00200                 BYPASS SETTING ERROR
GMN00100 SR    @15,@15                  REGISTER 15 = 0 INDICATES ERROR
GMN00200 EQU   *                        R15 CONTAINS ADDRESS OR ZERO
*        REGISTER 15 CONTAINS EITHER THE ADDRESS OF GOTTEN CORE OR
*        ZERO IF THE GETMAIN WAS UNSUCCESSFUL.
*   RESPECIFY                                                      0243
*     RETCODE RESTRICTED;                                          0243
*   IF RETCODE=ZERO THEN            /* GETMAIN FAILED                */
         LTR   RETCODE,RETCODE                                     0244
         BNZ   @RF00244                                            0244
*     DO;                                                          0245
*       PDPCODE=PP20;               /* SET PROBLEM CODE              */
         L     @14,CLWCOMWK(,RCORE)                                0246
         MVI   PDPCODE+280(@14),X'14'                              0246
*       ACBERFLG=OPERR136;          /* SET ACB ERROR FLAG            */
         MVI   ACBERFLG(RACB),X'88'                                0247
*       CLWTERM=ON;                 /* INDICATE TERMINATING ERROR    */
         OI    CLWTERM(RCORE),B'00010000'                          0248
*       CALL PROBDT;                /* PROBLEM DETERMINATION         */
         BAL   @14,PROBDT                                          0249
*     END;                                                         0250
*   ELSE                            /* GETMAIN SUCCESSFUL            */
*     DO;                                                          0251
         B     @RC00244                                            0251
@RF00244 DS    0H                                                  0252
*       CLWGMAIN=ON;                /* INDICATE MODULE WORK AREA   0252
*                                      BUILT                         */
         OI    CLWGMAIN(RCORE),B'00100000'                         0252
*       RETCODE->SABWRD=R13;        /* PUT SAVE AREA ADDRESS IN MWA  */
         ST    R13,SABWRD(,RETCODE)                                0253
*       R13=RETCODE;                /* MWA ADDRESS INTO REGISTER 13  */
         LR    R13,RETCODE                                         0254
*       GEN(USING @DATD,R13);       /* ADDRESSABILITY FOR AUTOMATICS */
         USING @DATD,R13
*       CALL VALCHECK;              /* VALIDITY CHECK AMBL AND DEB'S */
         BAL   @14,VALCHECK                                        0256
*       IF CLWNWRIT=OFF THEN        /* NOT SUPPRESS WRTBFR           */
         TM    CLWNWRIT(RCORE),B'00100000'                         0257
         BNZ   @RF00257                                            0257
*         DO;                                                      0258
*           CALL WRITBUFR;          /* WRITE OUT DATA SET BUFFERS    */
         BAL   @14,WRITBUFR                                        0259
*           IF MWAPCODE^=ZERO THEN  /* ERROR IN WRTBFR       @Z30SSRL*/
         CLI   MWAPCODE,0                                          0260
         BE    @RF00260                                            0260
*             CLWCNOUP=ON;          /* SUPPRESS CATALOG UPDATE       */
         OI    CLWCNOUP(RCORE),B'01000000'                         0261
*         END;                                                     0262
@RF00260 DS    0H                                                  0263
*       CLWAMBPT=AMBLDTA;           /* POINT TO DATA AMB             */
@RF00257 L     @14,ACBAMBL(,RACB)                                  0263
         L     @05,AMBLDTA(,@14)                                   0263
         ST    @05,CLWAMBPT(,RCORE)                                0263
*       IF BIBVIRT=ON&AMDWAIT=ON THEN/* CHECK FOR VIRTUAL DEVICE     */
         L     @14,AMBLBIB(,@14)                                   0264
         TM    BIBVIRT(@14),B'10000000'                            0264
         BNO   @RF00264                                            0264
         L     @14,AMBDSB(,@05)                                    0264
         TM    AMDWAIT(@14),B'00010000'                            0264
         BNO   @RF00264                                            0264
*         CALL VIRTPROC;            /* FORCE DESTAGE IF VIRTUAL    0265
*                                      DEVICE                        */
         BAL   @14,VIRTPROC                                        0265
*       CLWAMBPT=ZERO;              /* ZERO AMB POINTER IN CLW       */
@RF00264 SLR   @14,@14                                             0266
         ST    @14,CLWAMBPT(,RCORE)                                0266
*       IF CLWCNOUP=OFF THEN        /* NOT SUPPRESS CATALOG UPDATE   */
         TM    CLWCNOUP(RCORE),B'01000000'                         0267
         BNZ   @RF00267                                            0267
*         CALL UPCATACB;            /* UPDATE CATALOG                */
         BAL   @14,UPCATACB                                        0268
*       IF CVTSMCA^=ZERO&           /* SMCA EXIST                    */
*           SMCADSA=ON&             /* DATA SET INFORMATION REQUIRED */
*           (SMCAUSER=ON&SMCAMAN=ON)&/* SMF RECORDING                */
*           TCBTCT^=ZERO THEN       /* TCT EXIST                     */
@RF00267 SLR   @14,@14                                             0269
         L     @05,FLCCVT                                          0269
         L     @05,CVTSMCA(,@05)                                   0269
         CR    @05,@14                                             0269
         BE    @RF00269                                            0269
         TM    SMCADSA(@05),B'00010000'                            0269
         BNO   @RF00269                                            0269
         TM    SMCAUSER(@05),B'11000000'                           0269
         BNO   @RF00269                                            0269
         L     @05,PSATOLD                                         0269
         C     @14,TCBTCT(,@05)                                    0269
         BE    @RF00269                                            0269
*         CALL UPSMF;               /* WRITE SMF RECORD 64           */
         BAL   @14,UPSMF                                           0270
*TERM231B:                          /* TERMINATION PROCESSING        */
*       RESPECIFY                                                  0271
*        (R0,                                                      0271
*         R1) RESTRICTED;                                          0271
@RF00269 DS    0H                                                  0271
TERM231B DS    0H                                                  0272
*       GEN(L R0,@SIZDATD);         /* MODULE WORK AREA SIZE AND SP  */
         L R0,@SIZDATD
*       R1=R13;                     /* ADDRESS OF MODULE WORK AREA   */
         LR    R1,R13                                              0273
*       R13=SABWRD;                 /* ADDRESS OF PREVIOUS SAVEAREA  */
         L     R13,SABWRD(,R13)                                    0274
*       GEN(FREEMAIN R,LV=(0),A=(1));/* FREE MODULE WORK AREA        */
         FREEMAIN R,LV=(0),A=(1)
*       RESPECIFY                                                  0276
*        (R0,                                                      0276
*         R1) UNRESTRICTED;                                        0276
*     END;                                                         0277
*   IF CLWTERM=ON THEN              /* TERMINATING ERROR             */
@RC00244 TM    CLWTERM(RCORE),B'00010000'                          0278
         BNO   @RF00278                                            0278
*     RETCODE=FOUR;                 /* RETURN TO IDA0231T WITH R15=4 */
         LA    RETCODE,4                                           0279
*   ELSE                            /* NO TERMINATING ERROR          */
*     RETCODE=ZERO;                 /* RETURN TO IDA0231T WITH R15=0 */
         B     @RC00278                                            0280
@RF00278 SLR   RETCODE,RETCODE                                     0280
*   SACODE=RETCODE;                 /* SET RETURN CODE IN SAVE AREA  */
@RC00278 ST    RETCODE,SACODE(,R13)                                0281
*   LM(RET,R12,SAREGS);             /* RELOAD CALLERS REGISTERS      */
         LM    RET,R12,SAREGS(R13)                                 0282
*   GEN(RETURN);                    /* RETURN TO CALLER              */
         RETURN
*VALCHECK:                                                         0284
*                                                                  0284
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - VALIDITY CHECK AMBL AND AMB DEB.              */
*/*      01 INPUTS   - POINTER TO AMBL IN MWAMBLPT.                  */
*/*      01 OUTPUTS -  AMBL AND AMB DEB'S WERE CHECKED TO BE VALID   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0284
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0284
VALCHECK DS    0H                                                  0285
*   RESPECIFY                                                      0285
*     RET RESTRICTED;                                              0285
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0286
*   RESPECIFY                                                      0287
*     RET UNRESTRICTED;                                            0287
*   MWAPFUNC=PDF111;                /* SET FUNCTION CODE             */
         MVI   MWAPFUNC,X'6F'                                      0288
*   MWAVATPT=JSCBSHR;               /* POINT TO THE VAT              */
         L     @14,PSATOLD                                         0289
         L     @14,TCBJSCB(,@14)                                   0289
         L     @14,JSCBSHR(,@14)                                   0289
         ST    @14,MWAVATPT                                        0289
*   DO WHILE AMBLVRT^=VATVRT&VATNEXT^=0;/* FIND CORRECT VAT EXTENSION*/
         B     @DE00290                                            0290
@DL00290 DS    0H                                                  0291
*     MWAVATPT=VATNEXT;             /* POINT TO NEXT EXTENSION       */
         L     @14,MWAVATPT                                        0291
         L     @14,VATNEXT(,@14)                                   0291
         ST    @14,MWAVATPT                                        0291
*   END;                                                           0292
@DE00290 L     @14,ACBAMBL(,RACB)                                  0292
         L     @05,MWAVATPT                                        0292
         CLC   AMBLVRT(1,@14),VATVRT(@05)                          0292
         BE    @DC00290                                            0292
         L     @14,VATNEXT(,@05)                                   0292
         LTR   @14,@14                                             0292
         BNZ   @DL00290                                            0292
@DC00290 DS    0H                                                  0293
*   IF AMBLENO<=VATENO&             /* VALID USER AMBL               */
*       ACBAMBL=VATAMBL(AMBLENO) THEN/* CHECK AMBL AGAINST VAT       */
         L     @14,ACBAMBL(,RACB)                                  0293
         L     @05,MWAVATPT                                        0293
         CLC   AMBLENO(1,@14),VATENO(@05)                          0293
         BH    @RF00293                                            0293
         SLR   @11,@11                                             0293
         IC    @11,AMBLENO(,@14)                                   0293
         SLA   @11,2                                               0293
         C     @14,VATAMBL-4(@11,@05)                              0293
         BNE   @RF00293                                            0293
*     DO;                           /* IF AMBL IS VALID              */
*       RESPECIFY                                                  0295
*         R1 RESTRICTED;                                           0295
*       R1=AMBLDTA;                 /* POINT TO DATA AMB             */
         L     R1,AMBLDTA(,@14)                                    0296
*       GEN(DEBCHK (1),TYPE=VERIFY,AM=VSAM);/* VERIFY DATA DEB       */
         DEBCHK (1),TYPE=VERIFY,AM=VSAM
*       IF AMBLIX^=ZERO THEN        /* IF KSDS                       */
         L     @14,ACBAMBL(,RACB)                                  0298
         L     @14,AMBLIX(,@14)                                    0298
         LTR   @14,@14                                             0298
         BZ    @RF00298                                            0298
*         DO;                                                      0299
*           R1=AMBLIX;              /* POINT TO INDEX AMB            */
         LR    R1,@14                                              0300
*           GEN(DEBCHK (1),TYPE=VERIFY,AM=VSAM);/* VERIFY INDEX DEB  */
         DEBCHK (1),TYPE=VERIFY,AM=VSAM
*         END;                                                     0302
*       RESPECIFY                                                  0303
*         R1 UNRESTRICTED;                                         0303
@RF00298 DS    0H                                                  0304
*     END;                                                         0304
*   ELSE                            /* IF AMBL IS INVALID            */
*     DO;                                                          0305
         B     @RC00293                                            0305
@RF00293 DS    0H                                                  0306
*       CLWTERM=ON;                 /* INDICATE TERMINATING ERROR    */
         OI    CLWTERM(RCORE),B'00010000'                          0306
*       MWAPCODE=PP78;              /* PROBLEM CODE FOR INVALID AMBL */
         MVI   MWAPCODE,X'4E'                                      0307
*       CALL PROBDT;                /* GET PROBLEM MESSAGE           */
         BAL   @14,PROBDT                                          0308
*       RETURN TO TERM231B;         /* GO TO TERM231B                */
         LA    @14,TERM231B                                        0309
@EL00002 DS    0H                                                  0309
@EF00002 DS    0H                                                  0309
@ER00002 BR    @14                                                 0309
*     END;                                                         0310
*   MWAVATPT=JSCBSHR;               /* RESTORE POINTER TO VAT        */
@RC00293 L     @14,PSATOLD                                         0311
         L     @14,TCBJSCB(,@14)                                   0311
         L     @14,JSCBSHR(,@14)                                   0311
         ST    @14,MWAVATPT                                        0311
*   RESPECIFY                                                      0312
*     RET RESTRICTED;                                              0312
*   RET=MWASAVEA;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEA                                        0313
*   RESPECIFY                                                      0314
*     RET UNRESTRICTED;                                            0314
*   END VALCHECK;                                                  0315
         B     @EL00002                                            0315
*WRITBUFR:                                                         0316
*                                                                  0316
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - INTERFACE WITH RECORD MANAGEMENT TO WRITE OUT */
*/*                    BUFFERS. IF WRTBFR FAILS FOR PLH NOT AVAIL-   */
*/*                    ABLE, THEN INTERFACE WITH IDA0192Y TO OBTAIN  */
*/*                    AND RELEASE A DISCONNECTED PLH FOR THIS       */
*/*                    REQUEST, AND REISSUE THE WRTBFR.  PROBLEM     */
*/*                    DETERMINATION IS CALLED IF ANY ERRORS OCCUR.  */
*/*      01 INPUTS -   POINTER TO VAT IN JSCBSHR                     */
*/*      01 OUTPUTS -  BUFFERS FOR AMBL WRITTEN OUT                  */
*/*                    MWAPCODE IS SET                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0316
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0316
WRITBUFR DS    0H                                                  0317
*   RESPECIFY                                                      0317
*     RET RESTRICTED;                                              0317
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0318
*   RESPECIFY                                                      0319
*     RET UNRESTRICTED;                                            0319
*   PDPFUNC=PDF161;                 /* SET FUNCTION CODE             */
         L     @14,CLWCOMWK(,RCORE)                                0320
         MVI   PDPFUNC+280(@14),X'A1'                              0320
*   CLWAMBPT=AMBLDTA;               /* POINT TO DATA AMB     @Z30SSRL*/
         L     @14,ACBAMBL(,RACB)                                  0321
         L     @14,AMBLDTA(,@14)                                   0321
         ST    @14,CLWAMBPT(,RCORE)                                0321
*   MWAPCODE=ZERO;                  /* CLEAR MWAPCODE        @Z30SSRL*/
         MVI   MWAPCODE,X'00'                                      0322
*   MWABYTES=LENGTH(IFGRPL)+LENGTH(MWABUFSA);/* BUILD DUMMY RPL AND
*                                      REGISTER SAVE AREA            */
         MVC   MWABYTES(3),@CF04163+1                              0323
*   MWASPOOL=USERPOOL;              /* UNPROTECTED SUBPOOL FOR SYNCH */
         MVI   MWASPOOL,X'FA'                                      0324
*   CALL GETCORE;                   /* CALL ROUTINE TO GET STORAGE   */
         BAL   @14,GETCORE                                         0325
*   IF RETCODE=ZERO THEN            /* BUILD DUMMY RPL SUCCESSFUL  0326
*                                                            @Z30SSRL*/
         LTR   RETCODE,RETCODE                                     0326
         BNZ   @RF00326                                            0326
*     DO;                                                          0327
*       MWARPLPT=MWADDRES+LENGTH(MWABUFSA);/* ADDRESSABILITY FOR RPL */
         LA    @14,72                                              0328
         AL    @14,MWADDRES                                        0328
         ST    @14,MWARPLPT                                        0328
*       IF RACB=DXPACBAD THEN       /* IF THIS IS THE COPIED ACB     */
         L     @05,CLWCOMWK(,RCORE)                                0329
         L     @11,DXPACBAD-1(,@05)                                0329
         LA    @11,0(,@11)                                         0329
         CR    RACB,@11                                            0329
         BNE   @RF00329                                            0329
*         RPLDACB=DXUACBAD;         /* POINT RPL TO THE USERS ACB    */
         L     @05,DXUACBAD-1(,@05)                                0330
         LA    @05,0(,@05)                                         0330
         ST    @05,RPLDACB(,@14)                                   0330
*       ELSE                        /* IF NOT THE COPY               */
*         RPLDACB=RACB;             /* USE THE DUMMY OR UPGRADE ACB  */
         B     @RC00329                                            0331
@RF00329 L     @14,MWARPLPT                                        0331
         ST    RACB,RPLDACB(,@14)                                  0331
*       CALL WRBUFFER;              /* CALL ROUTINE TO ISSUE WRTBFR  */
@RC00329 BAL   @14,WRBUFFER                                        0332
*       IF RETCODE=MWALERR&RPLFDBK=MWANOPLH THEN/* IF PLH NOT      0333
*                                      AVAILABLE                     */
         C     RETCODE,@CF00049                                    0333
         BNE   @RF00333                                            0333
         L     @14,MWARPLPT                                        0333
         CLC   RPLFDBK(3,@14),@CF00115+1                           0333
         BNE   @RF00333                                            0333
*         DO;                       /* GET ONE FROM IDA0192Y         */
*           MWACLWRK=RCORE;         /* SAVE POINTER TO ACB WORKAREA  */
         LR    MWACLWRK,RCORE                                      0335
*           RCORE=ADDR(FORCORE);    /* GET POINTER TO COMMON WORKAREA*/
         L     RCORE,CLWCOMWK(,RCORE)                              0336
*           BLPFLAGS=ZERO;          /* CLEAR PARM LIST FLAGS @Z30SSRL*/
         SLR   @07,@07                                             0337
         STH   @07,BLPFLAGS(,@14)                                  0337
*           BLPFLSR=ON;             /* INDICATE LSR REQUEST          */
*           BLPFBLD=ON;             /* INDICATE BUILD REQUEST        */
         OI    BLPFLSR(@14),B'01010000'                            0339
*           IF VSRTIOBF=ON THEN     /* IF IOMBS FIXED THEN           */
         L     @07,MWAVATPT                                        0340
         L     @07,VATVPTR(,@07)                                   0340
         TM    VSRTIOBF(@07),B'00100000'                           0340
         BNO   @RF00340                                            0340
*             BLPFIOBF=ON;          /* INDICATE IOMBS ARE FIXED      */
         OI    BLPFIOBF(@14),B'00000100'                           0341
*           IF VSRTBFRF=ON THEN     /* IF BUFFERS FIXED THEN         */
@RF00340 L     @14,MWAVATPT                                        0342
         L     @14,VATVPTR(,@14)                                   0342
         TM    VSRTBFRF(@14),B'00010000'                           0342
         BNO   @RF00342                                            0342
*             BLPFBFRF=ON;          /* INDICATE BUFFERS ARE FIXED    */
         L     @14,MWARPLPT                                        0343
         OI    BLPFBFRF(@14),B'00000010'                           0343
*           BLPFIOSR=ON;            /* INDICATE I/O SUPPORT REQUEST  */
@RF00342 L     @14,MWARPLPT                                        0344
         OI    BLPFIOSR(@14),B'00000010'                           0344
*           MWAACBPT=RACB;          /* SAVE CURRENT ACB ADDRESS      */
         LR    MWAACBPT,RACB                                       0345
*           RACB=MWARPLPT;          /* ADDRESS OF PSUEDO PARM LIST   */
         LR    RACB,@14                                            0346
*           CALL IDA0192Y;          /* CALL BLDVRP ROUTINE           */
         L     @15,@CV04560                                        0347
         BALR  @14,@15                                             0347
*           RCORE->RSTATRTN=IDAR231B;/* NOTE 231B IN CONTROL         */
         MVC   RSTATRTN(4,RCORE),@CC04131                          0348
*           RCORE=MWACLWRK;         /* RESTORE ADDRESS OF CLOSE W.A. */
         LR    RCORE,MWACLWRK                                      0349
*           RACB=MWAACBPT;          /* RESTORE POINTER TO CURRENT ACB*/
         LR    RACB,MWAACBPT                                       0350
*           IF RETCODE^=ZERO THEN   /* IF ERROR FROM BUILD   @Z30SSRL*/
         LTR   RETCODE,RETCODE                                     0351
         BZ    @RF00351                                            0351
*             DO;                                                  0352
*               MWAPCODE=PP20;      /* SET PROBLEM CODE              */
         MVI   MWAPCODE,X'14'                                      0353
*               CALL PROBDT;        /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0354
*             END;                                                 0355
*           ELSE                    /* IF NO ERROR FROM BUILD      0356
*                                                            @Z30SSRL*/
*             DO;                   /* CONTINUE WITH WRTBFR  @Z30SSRL*/
         B     @RC00351                                            0356
@RF00351 DS    0H                                                  0357
*               BLPFLAGS=ZERO;      /* CLEAR PARM LIST FLAGS @Z30SSRL*/
         L     @14,MWARPLPT                                        0357
         SLR   @05,@05                                             0357
         STH   @05,BLPFLAGS(,@14)                                  0357
*               RPLPLHPT=BLPIOPLH;  /* POINT TO PLH FROM 192Y      0358
*                                                            @Z30SSRL*/
         L     @05,BLPIOPLH(,@14)                                  0358
         ST    @05,RPLPLHPT(,@14)                                  0358
*               CALL WRBUFFER;      /* CALL ROUTINE TO ISSUE WRTBFR  */
         BAL   @14,WRBUFFER                                        0359
*               IF RETCODE^=ZERO THEN/* IF ERROR FROM WRTBFR @Z30SSRL*/
         LTR   RETCODE,RETCODE                                     0360
         BZ    @RF00360                                            0360
*                 DO;                                              0361
*                   MWAPCODE=PP128; /* SET PROBLEM CODE              */
         MVI   MWAPCODE,X'80'                                      0362
*                   CALL PROBDT;    /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0363
*                 END;                                             0364
*               MWACLWRK=RCORE;     /* SAVE POINTER TO ACB WORKAREA  */
@RF00360 LR    MWACLWRK,RCORE                                      0365
*               RCORE=ADDR(FORCORE);/* GET POINTER TO COMMON WORKAREA*/
         L     RCORE,CLWCOMWK(,RCORE)                              0366
*               BLPFLAGS=ZERO;      /* CLEAR PARM LIST FLAGS @Z30SSRL*/
         L     @14,MWARPLPT                                        0367
         SLR   @07,@07                                             0367
         STH   @07,BLPFLAGS(,@14)                                  0367
*               BLPFLSR=ON;         /* INDICATE LSR REQUEST          */
*               BLPFDEL=ON;         /* INDICATE DELETE REQUEST       */
         OI    BLPFLSR(@14),B'00110000'                            0369
*               BLPFIOSR=ON;        /* INDICATE I/O SUPPORT REQUEST  */
         OI    BLPFIOSR(@14),B'00000010'                           0370
*               MWAACBPT=RACB;      /* SAVE CURRENT ACB ADDRESS      */
         LR    MWAACBPT,RACB                                       0371
*               RACB=MWARPLPT;      /* ADDRESS OF PSUEDO PARM LIST   */
         LR    RACB,@14                                            0372
*               CALL IDA0192Y;      /* CALL DELVRP ROUTINE           */
         L     @15,@CV04560                                        0373
         BALR  @14,@15                                             0373
*               RCORE->RSTATRTN=IDAR231B;/* NOTE 231B IN CONTROL     */
         MVC   RSTATRTN(4,RCORE),@CC04131                          0374
*               RCORE=MWACLWRK;     /* RESTORE ADDRESS OF CLOSE W.A. */
         LR    RCORE,MWACLWRK                                      0375
*               RACB=MWAACBPT;      /* RESTORE POINTER TO CURRENT ACB*/
         LR    RACB,MWAACBPT                                       0376
*             END;                                                 0377
*         END;                                                     0378
*       ELSE                        /* IF PLH AVAILABLE      @Z30SSRL*/
*         DO;                                                      0379
         B     @RC00333                                            0379
@RF00333 DS    0H                                                  0380
*           IF RETCODE^=ZERO THEN   /* IF ERROR FROM WRTBFR  @Z30SSRL*/
         LTR   RETCODE,RETCODE                                     0380
         BZ    @RF00380                                            0380
*             DO;                                                  0381
*               MWAPCODE=PP128;     /* SET PROBLEM CODE              */
         MVI   MWAPCODE,X'80'                                      0382
*               CALL PROBDT;        /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0383
*             END;                                                 0384
*         END;                                                     0385
@RF00380 DS    0H                                                  0386
*       MWADDRES=MWARPLPT-LENGTH(MWABUFSA);/* POINT TO SAVEAREA      */
@RC00333 L     @14,MWARPLPT                                        0386
         SL    @14,@CF00106                                        0386
         ST    @14,MWADDRES                                        0386
*       MWASPOOL=USERPOOL;          /* SUBPOOL NUMBER                */
         MVI   MWASPOOL,X'FA'                                      0387
*       MWABYTES=LENGTH(IFGRPL)+LENGTH(MWABUFSA);/* SIZE OF DUMMY RPL
*                                      AND SAVEAREA                  */
         MVC   MWABYTES(3),@CF04163+1                              0388
*       CALL FREECORE;              /* FREE DUMMY RPL AND RELATED  0389
*                                      CORE                          */
         BAL   @14,FREECORE                                        0389
*     END;                                                         0390
*   CLWAMBPT=ZERO;                  /* ZERO AMB POINTER IN CLW     0391
*                                                            @Z30SSRL*/
@RF00326 SLR   @14,@14                                             0391
         ST    @14,CLWAMBPT(,RCORE)                                0391
*   RESPECIFY                                                      0392
*     RET RESTRICTED;                                              0392
*   RET=MWASAVEA;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEA                                        0393
*   RESPECIFY                                                      0394
*    (RET,                                                         0394
*     RETCODE) UNRESTRICTED;                                       0394
*   END WRITBUFR;                                                  0395
@EL00003 DS    0H                                                  0395
@EF00003 DS    0H                                                  0395
@ER00003 BR    @14                                                 0395
*WRBUFFER:                                                         0396
*                                                                  0396
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - INTERFACE WITH RECORD MANAGEMENT TO WRITE OUT */
*/*                    BUFFERS                                       */
*/*      01 INPUTS -   ADDRESS OF DUMMY RPL IN MWARPLPT              */
*/*      01 OUTPUTS -  WRTBFR PERFORMED                              */
*/*                    RETURN CODE PASSED BACK IN REGISTER 15        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0396
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0396
WRBUFFER DS    0H                                                  0397
*   RESPECIFY                                                      0397
*    (R0,                                                          0397
*     R1,                                                          0397
*     R6,                                                          0397
*     RET,                                                         0397
*     RETCODE) RESTRICTED;                                         0397
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        0398
*   RESPECIFY                                                      0399
*     RET UNRESTRICTED;                                            0399
*   STM(RACB,R13,XRBESA);           /* SAVE REGISTERS IN RB SAVE AREA*/
         L     @14,PSATOLD                                         0400
         L     @14,TCBRBP(,@14)                                    0400
         STM   RACB,R13,XRBESA(@14)                                0400
*   R6=R13;                         /* GET CURRENT ADDRESSABILITY    */
         LR    R6,R13                                              0401
*   GEN(DROP R13);                  /* DROP R13 AS BASE REGISTER     */
         DROP R13
*   GEN(USING @DATD,R6);            /* TEMPORORY ADDRESSABILITY      */
         USING @DATD,R6
*   R0=RPLWRTB;                     /* INDICATE WRTBFR REQUEST       */
         LA    R0,15                                               0404
*   R1=MWARPLPT;                    /* POINT TO DUMMY RPL            */
         L     @14,MWARPLPT                                        0405
         LR    R1,@14                                              0405
*   R13=MWARPLPT-LENGTH(MWABUFSA);  /* POINT TO REGISTER SAVE AREA   */
         SL    @14,@CF00106                                        0406
         LR    R13,@14                                             0406
*   R15=BIBINTRF;                   /* ADDRESS OF INTERFACE ROUTINE  */
         L     @07,ACBAMBL(,RACB)                                  0407
         L     @07,AMBLBIB(,@07)                                   0407
         L     R15,BIBINTRF(,@07)                                  0407
*   R6=ADDR(RBGRS2);                /* POINT TO USER REGISTER SAVE 0408
*                                      AREA                          */
         L     @14,PSATOLD                                         0408
         L     R6,TCBRBP(,@14)                                     0408
         LA    R6,RBGRS2(,R6)                                      0408
*   GEN(LM RACB,R12,0(R6));         /* RESTORE USER'S REGISTERS      */
         LM RACB,R12,0(R6)
*   GEN(SYNCH (15));                /* GO TO WRTBFR IN USER KEY      */
         SYNCH (15)
*   LM(RACB,R13,XRBESA);            /* RESTORE REGISTERS             */
         L     @14,PSATOLD                                         0411
         L     @14,TCBRBP(,@14)                                    0411
         LM    RACB,R13,XRBESA(@14)                                0411
*   GEN(DROP R6);                   /* DROP TEMPORORY ADDRESSABILITY */
         DROP R6
*   GEN(USING @DATD,R13);           /* REESTABLISH ADDRESSABILITY    */
         USING @DATD,R13
*   RESPECIFY                                                      0414
*     RET RESTRICTED;                                              0414
*   RET=MWASAVEB;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEB                                        0415
*   RESPECIFY                                                      0416
*    (R0,                                                          0416
*     R1,                                                          0416
*     R6,                                                          0416
*     RET,                                                         0416
*     RETCODE) UNRESTRICTED;                                       0416
*   END WRBUFFER;                                                  0417
@EL00004 DS    0H                                                  0417
@EF00004 DS    0H                                                  0417
@ER00004 BR    @14                                                 0417
*VIRTPROC:                                                         0418
*                                                                  0418
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - FORCE DESTAGE IF VIRTUAL DEVICE               */
*/*      01 INPUTS -   1. PARAMETER LIST FOR IDA0192D MWAVIRT        */
*/*                    2. THE AMDSB CONNECTED WITH THE DATA AMB      */
*/*      01 OUTPUTS -  1. DESTAGE OR RESTAGE PERFORMED               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0418
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0418
VIRTPROC DS    0H                                                  0419
*   RESPECIFY                                                      0419
*    (R1,                                                          0419
*     RET,                                                         0419
*     RETCODE) RESTRICTED;                                         0419
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0420
*   RESPECIFY                                                      0421
*     RET UNRESTRICTED;                                            0421
*   VIRTACB=RACB;                   /* ACB ADDRESS INTO PARAMETER  0422
*                                      LIST                          */
         LA    @14,MWAVIRT                                         0422
         ST    RACB,VIRTACB(,@14)                                  0422
*   VIRTBACB=ON;                    /* INDICATE CALL BY ACB  @Z30SSRL*/
         OI    VIRTBACB(@14),B'00010000'                           0423
*   VIRTTIOE=PDPTIOT;               /* TIOT ADDRESS INTO PARAMETER 0424
*                                      LIST                          */
         L     @05,CLWCOMWK(,RCORE)                                0424
         L     @05,PDPTIOT+280(,@05)                               0424
         ST    @05,VIRTTIOE(,@14)                                  0424
*   VIRTNOUN=ON;                    /* DO NOT UNBIND IF BOUND        */
         OI    VIRTNOUN(@14),B'00100000'                           0425
*   R1=ADDR(IDAVIRT);               /* POINT TO PARAMETER LIST       */
         LR    R1,@14                                              0426
*   CALL IDA0192D;                  /* DESTAGE AND WAIT              */
         L     @15,@CV04569                                        0427
         BALR  @14,@15                                             0427
*   RSTATRTN=IDAR231B;              /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0428
         MVC   RSTATRTN(4,@14),@CC04131                            0428
*   IF RETCODE^=ZERO THEN           /* ERROR FROM IDA0192D           */
         LTR   RETCODE,RETCODE                                     0429
         BZ    @RF00429                                            0429
*     DO;                                                          0430
*       MWAPDPRM=RETCODE;           /* SAVE RETURN CODE              */
         ST    RETCODE,MWAPDPRM                                    0431
*       CALL PROBDT;                /* PROBLEM DETERMINATION         */
         BAL   @14,PROBDT                                          0432
*     END;                                                         0433
*   ELSE                            /* IF NO ERROR                   */
*     IF AMDBIND=OFF THEN           /* RESTAGE IF NOT BOUND          */
         B     @RC00429                                            0434
@RF00429 L     @14,CLWAMBPT(,RCORE)                                0434
         L     @14,AMBDSB(,@14)                                    0434
         TM    AMDBIND(@14),B'00100000'                            0434
         BNZ   @RF00434                                            0434
*       DO;                                                        0435
*         VIRTNOUN=OFF;             /* TURN OFF RELINGQUISH OPTION   */
*         VIRTACQ=ON;               /* INDICATE ACQUIRE OPTION       */
         LA    @14,MWAVIRT                                         0437
         OI    VIRTACQ(@14),B'10000000'                            0437
         NI    VIRTNOUN(@14),B'11011111'                           0437
*         R1=ADDR(IDAVIRT);         /* POINT TO PARAMETER LIST       */
         LR    R1,@14                                              0438
*         CALL IDA0192D;            /* RE-ACQUIRE DATA               */
         L     @15,@CV04569                                        0439
         BALR  @14,@15                                             0439
*         RSTATRTN=IDAR231B;        /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0440
         MVC   RSTATRTN(4,@14),@CC04131                            0440
*         IF RETCODE^=ZERO THEN     /* IF ERROR ENCOUNTERED          */
         LTR   RETCODE,RETCODE                                     0441
         BZ    @RF00441                                            0441
*           DO;                                                    0442
*             MWAPDPRM=RETCODE;     /* SAVE RETURN CODE              */
         ST    RETCODE,MWAPDPRM                                    0443
*             CALL PROBDT;          /* PROBLEM DETERMINATION         */
         BAL   @14,PROBDT                                          0444
*           END;                                                   0445
*       END;                                                       0446
@RF00441 DS    0H                                                  0447
*   RESPECIFY                                                      0447
*     RET RESTRICTED;                                              0447
@RF00434 DS    0H                                                  0447
@RC00429 DS    0H                                                  0448
*   RET=MWASAVEA;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEA                                        0448
*   RESPECIFY                                                      0449
*    (R1,                                                          0449
*     RET,                                                         0449
*     RETCODE) UNRESTRICTED;                                       0449
*   END VIRTPROC;                                                  0450
@EL00005 DS    0H                                                  0450
@EF00005 DS    0H                                                  0450
@ER00005 BR    @14                                                 0450
*UPCATACB:                                                         0451
*                                                                  0451
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - UPDATE CATALOG                                */
*/*      01 INPUTS -   CATALOG'S ACB AND DEB                         */
*/*      01 OUTPUTS -  CATALOG UPDATED                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0451
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0451
UPCATACB DS    0H                                                  0452
*   RESPECIFY                                                      0452
*     RET RESTRICTED;                                              0452
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0453
*   RESPECIFY                                                      0454
*     RET UNRESTRICTED;                                            0454
*   MWAPFUNC=PDF113;                /* SET FUNCTION CODE             */
         MVI   MWAPFUNC,X'71'                                      0455
*   GEN(STCK MWATIMES);             /* GET TIMESTAMP FROM SYSTEM     */
         STCK MWATIMES
*   MWADEBPT=AMBLDTA->AMBCACB;      /* POINT TO CATALOG ACB          */
         L     @09,ACBAMBL(,RACB)                                  0457
         L     @09,AMBLDTA(,@09)                                   0457
         L     MWADEBPT,AMBCACB(,@09)                              0457
*   MWADEBPT=MWADEBPT->ACBAMBL->AMBLDTA->AMBDEBPT;/* GET POINTER TO
*                                      CATALOG'S DEB                 */
         L     @06,ACBAMBL(,MWADEBPT)                              0458
         L     @06,AMBLDTA(,@06)                                   0458
         L     @06,AMBDEBPT(,@06)                                  0458
         LR    MWADEBPT,@06                                        0458
*   MWAUCBPT=DEBUCBA;               /* GET UCB ADDRRESS              */
         L     MWAUCBPT,DEBUCBA+31(,MWADEBPT)                      0459
         LA    MWAUCBPT,0(,MWAUCBPT)                               0459
*   CLWAMBPT=AMBLDTA;               /* POINT TO DATA AMB             */
         ST    @09,CLWAMBPT(,RCORE)                                0460
*   AMBWKA=ADDR(MWAMBDTA);          /* INITIALIZE POINTER TO PARM  0461
*                                      LIST                          */
         LA    @06,MWAMBDTA                                        0461
         ST    @06,AMBWKA(,@09)                                    0461
*   CALL UPCATDEQ;                  /* UPDATE CATALOG FOR DATA AMB   */
         BAL   @14,UPCATDEQ                                        0462
*   IF AMBLIX^=ZERO THEN            /* IF KSDS                       */
         L     @09,ACBAMBL(,RACB)                                  0463
         L     @09,AMBLIX(,@09)                                    0463
         LTR   @09,@09                                             0463
         BZ    @RF00463                                            0463
*     DO;                                                          0464
*       CLWAMBPT=AMBLIX;            /* POINT TO INDEX AMB            */
         ST    @09,CLWAMBPT(,RCORE)                                0465
*       AMBWKA=ADDR(MWAMBIDX);      /* POINTER TO CATALOG PARM LIST  */
         LA    @06,MWAMBIDX                                        0466
         ST    @06,AMBWKA(,@09)                                    0466
*       CALL UPCATDEQ;              /* UPDATE CATALOG FOR INDEX AMB  */
         BAL   @14,UPCATDEQ                                        0467
*     END;                                                         0468
*   RESPECIFY                                                      0469
*     RET RESTRICTED;                                              0469
@RF00463 DS    0H                                                  0470
*   RET=MWASAVEA;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEA                                        0470
*   RESPECIFY                                                      0471
*     RET UNRESTRICTED;                                            0471
*   END UPCATACB;                                                  0472
@EL00006 DS    0H                                                  0472
@EF00006 DS    0H                                                  0472
@ER00006 BR    @14                                                 0472
*UPCATDEQ:                                                         0473
*                                                                  0473
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - UPDATE CATALOG FOR AN AMB                     */
*/*      01 INPUTS -   POINTER TO AMB IN CLWAMBPT                    */
*/*      01 OUTPUTS -  AMB DATA SET UPDATED IN CATALOG               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0473
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0473
UPCATDEQ DS    0H                                                  0474
*   RESPECIFY                                                      0474
*     IDAAMDSB BASED(AMBDSB);                                      0474
*   RESPECIFY                                                      0475
*    (RET,                                                         0475
*     RETCODE) RESTRICTED;                                         0475
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        0476
*   RESPECIFY                                                      0477
*     RET UNRESTRICTED;                                            0477
*   IF AMBLWRIT=ON THEN             /* IF ACB IS OPENNED FOR OUTPUT  */
         L     @14,ACBAMBL(,RACB)                                  0478
         TM    AMBLWRIT(@14),B'00100000'                           0478
         BNO   @RF00478                                            0478
*     DO;                                                          0479
*       AMDSTSP=MWATIMES;           /* UPDATE TIMESTAMP IN AMDSB     */
         L     @14,CLWAMBPT(,RCORE)                                0480
         L     @09,AMBDSB(,@14)                                    0480
         MVC   AMDSTSP(8,@09),MWATIMES                             0480
*       MWAOUTBT=ON;                /* INDICATE OUTPUT TO CATALOG    */
         L     @14,AMBWKA(,@14)                                    0481
         OI    MWAOUTBT(@14),B'10000000'                           0481
*       MWAOPEN='80'X;              /* SET OPEN INDICATOR            */
         MVI   MWAOPEN(@14),X'80'                                  0482
*     END;                                                         0483
*   MWACATID=CLM;                   /* INDICATE CLOSE                */
@RF00478 MVI   MWACATID,X'08'                                      0484
*   MWASFIPT=ADDR(CLWSFI);          /* POINT TO SFI AREA IN CLW      */
         LA    @14,CLWSFI(,RCORE)                                  0485
         STCM  @14,7,MWASFIPT                                      0485
*   MWAQNAME='SYSVSAM ';            /* SET QNAME                     */
         MVC   MWAQNAME(8),@CC04578                                0486
*   ENQRLEN=LENGTH(MWARNAME);       /* LENGTH OF RNAME               */
         MVI   ENQRLEN,X'08'                                       0487
*   ENQEND=ON;                      /* INDICATE LAST ENTRY           */
         OI    ENQEND,B'10000000'                                  0488
*   ENQRNCI=AMBDDSN;                /* CI NUMBER FOR RNAME           */
         L     @14,CLWAMBPT(,RCORE)                                0489
         MVC   ENQRNCI(3),AMBDDSN(@14)                             0489
*   ENQRNACB=AMBCACB;               /* ACB ADDRESS IN RNAME          */
         MVC   ENQRNACB(4),AMBCACB(@14)                            0490
*   ENQQNADR=ADDR(MWAQNAME);        /* GET ADDRESS OF QNAME          */
         LA    @14,MWAQNAME                                        0491
         ST    @14,ENQQNADR                                        0491
*   ENQRNADR=ADDR(MWARNAME);        /* GET ADDRESS OF RNAME          */
         LA    @14,MWARNAME                                        0492
         ST    @14,ENQRNADR                                        0492
*   IF UCB2OPT2=ON THEN             /* CATALOG ON SHARE DEVICE       */
         TM    UCB2OPT2(MWAUCBPT),B'00100000'                      0493
         BNO   @RF00493                                            0493
*     DO;                                                          0494
*       ENQRNIND='R';               /* INDICATE RESERVE IN RNAME     */
         MVI   ENQRNIND,C'R'                                       0495
*       ENQDIR=OFF;                 /* NOT ENQ DIRECT                */
         NI    ENQDIR,B'11111110'                                  0496
*       ENQOPT2=ENQOPT2&&ENQOPT2;   /* ZERO UNUSED OPTION BYTE       */
         XC    ENQOPT2(1),ENQOPT2                                  0497
*       ENQUCADR=ADDR(DEBUCBAD);    /* GET UCB ADDRESS               */
         LA    @14,32                                              0498
         ALR   @14,MWADEBPT                                        0498
         ST    @14,ENQUCADR                                        0498
*       GEN(RESERVE (,,E,,SYSTEMS),MF=(E,ENQENTRY));/* ISSUE RESERVE */
         RESERVE (,,E,,SYSTEMS),MF=(E,ENQENTRY)
*     END;                                                         0500
*   RESPECIFY                                                      0501
*    (R1,                                                          0501
*     R5) RESTRICTED;                                              0501
@RF00493 DS    0H                                                  0502
*   R1=ADDR(MWACATPM);              /* POINT TO IDA0192C PARAMETER 0502
*                                      LIST                          */
         LA    R1,MWACATPM                                         0502
*   R5=CLWAMBPT;                    /* ADDRESS OF AMB                */
         L     R5,CLWAMBPT(,RCORE)                                 0503
*   RSTATRTN=IDAR192C;              /* NOTE CALL TO 192C             */
         L     @14,CLWCOMWK(,RCORE)                                0504
         MVC   RSTATRTN(4,@14),@CC04105                            0504
*   CALL IDA0192C;                  /* UPDATE CATALOG FOR AMB        */
         L     @15,@CV04580                                        0505
         BALR  @14,@15                                             0505
*   RSTATRTN=IDAR231B;              /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0506
         MVC   RSTATRTN(4,@14),@CC04131                            0506
*   IF RETCODE^=ZERO THEN           /* IF ERROR DURING CATALOG UPDATE*/
         LTR   RETCODE,RETCODE                                     0507
         BZ    @RF00507                                            0507
*     DO;                                                          0508
*       PDPSFI=MWASFIPT;            /* POINT TO SFI AREA             */
         L     @09,MWASFIPT-1                                      0509
         LA    @09,0(,@09)                                         0509
         ST    @09,PDPSFI+280(,@14)                                0509
*       MWAPDPRM=RETCODE;           /* SAVE RETURN CODE              */
         ST    RETCODE,MWAPDPRM                                    0510
*       CALL PROBDT;                /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0511
*     END;                                                         0512
*   RESPECIFY                                                      0513
*    (R1,                                                          0513
*     R5) UNRESTRICTED;                                            0513
@RF00507 DS    0H                                                  0514
*   IF UCB2OPT2=ON THEN             /* CATALOG ON SHARE DEVICE       */
         TM    UCB2OPT2(MWAUCBPT),B'00100000'                      0514
         BNO   @RF00514                                            0514
*     DO;                                                          0515
*       ENQOPT2=ENQOPT2&&ENQOPT2;   /* ZERO OPTION BYTE              */
         XC    ENQOPT2(1),ENQOPT2                                  0516
*       GEN(DEQ (,,,SYSTEMS),MF=(E,ENQENTRY));/* ISSUE DEQ           */
         DEQ (,,,SYSTEMS),MF=(E,ENQENTRY)
*     END;                                                         0518
*   RESPECIFY                                                      0519
*     RET RESTRICTED;                                              0519
@RF00514 DS    0H                                                  0520
*   RET=MWASAVEB;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEB                                        0520
*   RESPECIFY                                                      0521
*    (RET,                                                         0521
*     RETCODE) UNRESTRICTED;                                       0521
*   END UPCATDEQ;                                                  0522
@EL00007 DS    0H                                                  0522
@EF00007 DS    0H                                                  0522
@ER00007 BR    @14                                                 0522
*UPSMF:                                                            0523
*                                                                  0523
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - WRITE SMF RECORD TYPE 64                      */
*/*      01 INPUTS -   CATALOG WORK AREA IN IGGCAXWA DSECT           */
*/*      01 OUTPUTS -  SMF RECORD 64 WRITTEN                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0523
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0523
UPSMF    DS    0H                                                  0524
*   RESPECIFY                                                      0524
*    (R1,                                                          0524
*     R6,                                                          0524
*     RET,                                                         0524
*     RETCODE) RESTRICTED;                                         0524
*   MWASAVEA=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEA                                        0525
*   RESPECIFY                                                      0526
*     RET UNRESTRICTED;                                            0526
*   RESPECIFY                                                      0527
*     IGGCAXWA BASED(R6);           /* ADDRESSABILITY FOR CATALOG  0527
*                                      WORK AREA                     */
*   MWARCNBR=MWACLOSE;              /* SET RECORD NUMBER             */
         MVI   MWARCNBR,X'40'                                      0528
*   MWARCLOS=ON;                    /* INDICATE CALL FROM CLOSE      */
         OI    MWARCLOS,B'10000000'                                0529
*   R6=AMBLDTA->AMBCACB->ACBUAPTR;  /* GET ADDRESS OF CAXWA          */
         L     @14,ACBAMBL(,RACB)                                  0530
         L     @14,AMBLDTA(,@14)                                   0530
         L     @05,AMBCACB(,@14)                                   0530
         L     R6,ACBUAPTR(,@05)                                   0530
*   MWARCCSN=ADDR(CAXCNAM);         /* POINT TO CATALOG DATA SET NAME*/
         LA    @07,CAXCNAM(,R6)                                    0531
         ST    @07,MWARCCSN                                        0531
*   R1=ADDR(MWARCD64);              /* GET ADDRESS OF PARAMETER LIST */
         LA    R1,MWARCD64                                         0532
*   MWARCAMB=AMBLDTA;               /* DATA AMB ADDRESS FOR SMF      */
         ST    @14,MWARCAMB                                        0533
*   CLWAMBPT=AMBLDTA;               /* POINT TO DATA AMB             */
         ST    @14,CLWAMBPT(,RCORE)                                0534
*   MWARCDSN=ADDR(MWADSN);          /* POINT TO DATA SET NAME        */
         L     @14,AMBWKA(,@14)                                    0535
         ST    @14,MWARCDSN                                        0535
*   MWARCTIO=PDPTIOT;               /* POINT TO TIOT ENTRY   @OZ04708*/
         L     @14,CLWCOMWK(,RCORE)                                0536
         L     @07,PDPTIOT+280(,@14)                               0536
         ST    @07,MWARCTIO                                        0536
*   RSTATRTN=IDAR192S;              /* NOTE CALL TO 192S             */
         MVC   RSTATRTN(4,@14),@CC04117                            0537
*   CALL IDA0192S;                  /* WRITE SMF RECORD              */
         L     @15,@CV04585                                        0538
         BALR  @14,@15                                             0538
*   RSTATRTN=IDAR231B;              /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0539
         MVC   RSTATRTN(4,@14),@CC04131                            0539
*   IF RETCODE^=ZERO THEN           /* IF ERROR ENCOUNTERED          */
         LTR   RETCODE,RETCODE                                     0540
         BZ    @RF00540                                            0540
*     DO;                                                          0541
*       MWAPDPRM=RETCODE;           /* SAVE RETURN CODE              */
         ST    RETCODE,MWAPDPRM                                    0542
*       CALL PROBDT;                /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0543
*     END;                                                         0544
*   ELSE                            /* NO ERROR ENCOUNTERED          */
*     DO;                                                          0545
         B     @RC00540                                            0545
@RF00540 DS    0H                                                  0546
*       IF AMBLIX^=ZERO THEN        /* IF KSDS                       */
         L     @14,ACBAMBL(,RACB)                                  0546
         L     @14,AMBLIX(,@14)                                    0546
         LTR   @14,@14                                             0546
         BZ    @RF00546                                            0546
*         DO;                                                      0547
*           MWARCAMB=AMBLIX;        /* INDEX AMB ADDRESS FOR SMF     */
         ST    @14,MWARCAMB                                        0548
*           CLWAMBPT=AMBLIX;        /* POINT TO INDEX AMB            */
         ST    @14,CLWAMBPT(,RCORE)                                0549
*           MWARCDSN=ADDR(MWADSN);  /* POINT TO DATA SET NAME        */
         L     @14,AMBWKA(,@14)                                    0550
         ST    @14,MWARCDSN                                        0550
*           RSTATRTN=IDAR192S;      /* NOTE CALL TO 192S             */
         L     @14,CLWCOMWK(,RCORE)                                0551
         MVC   RSTATRTN(4,@14),@CC04117                            0551
*           CALL IDA0192S;          /* WRITE SMF RECORDS             */
         L     @15,@CV04585                                        0552
         BALR  @14,@15                                             0552
*           RSTATRTN=IDAR231B;      /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0553
         MVC   RSTATRTN(4,@14),@CC04131                            0553
*           IF RETCODE^=ZERO THEN   /* IF ERROR ENCOUNTED            */
         LTR   RETCODE,RETCODE                                     0554
         BZ    @RF00554                                            0554
*             DO;                                                  0555
*               MWAPDPRM=RETCODE;   /* SAVE RETURN CODE              */
         ST    RETCODE,MWAPDPRM                                    0556
*               CALL PROBDT;        /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0557
*             END;                                                 0558
*         END;                                                     0559
@RF00554 DS    0H                                                  0560
*     END;                                                         0560
@RF00546 DS    0H                                                  0561
*   RESPECIFY                                                      0561
*     IGGCAXWA BASED(ACBUAPTR);                                    0561
@RC00540 DS    0H                                                  0562
*   RESPECIFY                                                      0562
*     RET RESTRICTED;                                              0562
*   RET=MWASAVEA;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEA                                        0563
*   RESPECIFY                                                      0564
*    (R1,                                                          0564
*     R6,                                                          0564
*     RET,                                                         0564
*     RETCODE) UNRESTRICTED;                                       0564
*   END UPSMF;                                                     0565
@EL00008 DS    0H                                                  0565
@EF00008 DS    0H                                                  0565
@ER00008 BR    @14                                                 0565
*PROBDT:                                                           0566
*                                                                  0566
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - PROBLEM DETERMINATION AND WRITE ERROR MESSAGES*/
*/*      01 INPUTS -   PROBLEM DETERMINATION PARAMETER LIST          */
*/*      01 OUTPUTS -  PROBLEM MESSAGES WRITTEN BY IDA0192P          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0566
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0566
PROBDT   DS    0H                                                  0567
*   RESPECIFY                                                      0567
*    (R6,                                                          0567
*     RET) RESTRICTED;                                             0567
*   R6=RET;                         /* SAVE RETURN ADDRESS           */
         LR    R6,RET                                              0568
*   RESPECIFY                                                      0569
*     RET UNRESTRICTED;                                            0569
*   IF CLWGMAIN=ON THEN             /* MODULE WORK AREA EXIST        */
         TM    CLWGMAIN(RCORE),B'00100000'                         0570
         BNO   @RF00570                                            0570
*     DO;                                                          0571
*       MWASAVED=R6;                /* SAVE RETURN CODE              */
         LR    MWASAVED,R6                                         0572
*       MWACATID=CLC;               /* SET-UP CALLER ID              */
         MVI   MWACATID,X'30'                                      0573
*       MWACI=AMBLDTA->AMBDDSN;     /* CI NUMBER OF DATA AMB         */
         L     @11,ACBAMBL(,RACB)                                  0574
         L     @11,AMBLDTA(,@11)                                   0574
         MVC   MWACI(3),AMBDDSN(@11)                               0574
*       MWACACB=AMBLDTA->AMBCACB;   /* CATALOG ACB ADDRESS           */
         L     @11,AMBCACB(,@11)                                   0575
         ST    @11,MWACACB                                         0575
*       RESPECIFY                                                  0576
*        (R1,                                                      0576
*         RETCODE) RESTRICTED;                                     0576
*       R1=ADDR(MWACATPM);          /* R1 PT TO PARM LIST FOR      0577
*                                      IDA0192C                      */
         LA    R1,MWACATPM                                         0577
*       RSTATRTN=IDAR192C;          /* NOTE CALL TO 192C             */
         L     @14,CLWCOMWK(,RCORE)                                0578
         MVC   RSTATRTN(4,@14),@CC04105                            0578
*       CALL IDA0192C;              /* OBTAIN CLUSTER NAME FOR CI IN
*                                      DATA AMB                      */
         L     @15,@CV04580                                        0579
         BALR  @14,@15                                             0579
*       RSTATRTN=IDAR231B;          /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0580
         MVC   RSTATRTN(4,@14),@CC04131                            0580
*       IF RETCODE=ZERO THEN        /* NO ERROR                      */
         LTR   RETCODE,RETCODE                                     0581
         BNZ   @RF00581                                            0581
*         PDPCLSNM=ADDR(MWACLSNM);  /* GET ADDRESS OF CLUSTER NAME   */
         LA    @11,MWACLSNM                                        0582
         ST    @11,PDPCLSNM+280(,@14)                              0582
*       ELSE                        /* IF ERROR ENCOUNTERED          */
*         PDPDSTYP=PDPDDNM;         /* INDICATE DDNAME USED INSTEAD  */
         B     @RC00581                                            0583
@RF00581 L     @14,CLWCOMWK(,RCORE)                                0583
         MVI   PDPDSTYP+280(@14),X'01'                             0583
*       IF CLWAMBPT^=ZERO THEN      /* IF ERROR RELATED TO A DATA SET*/
@RC00581 L     @14,CLWAMBPT(,RCORE)                                0584
         LTR   @14,@14                                             0584
         BZ    @RF00584                                            0584
*         DO;                                                      0585
*           MWACATID=CLD;           /* SET CALLER ID                 */
         MVI   MWACATID,X'28'                                      0586
*           MWACI=CLWAMBPT->AMBDDSN;/* GET DATA SET CI NUMBER        */
         MVC   MWACI(3),AMBDDSN(@14)                               0587
*           R1=ADDR(MWACATPM);      /* R1 PT TO PARM LIST FOR      0588
*                                      IDA0192C                      */
         LA    R1,MWACATPM                                         0588
*           RSTATRTN=IDAR192C;      /* NOTE CALL TO 192C             */
         L     @14,CLWCOMWK(,RCORE)                                0589
         MVC   RSTATRTN(4,@14),@CC04105                            0589
*           CALL IDA0192C;          /* GET DATA SET NAME             */
         L     @15,@CV04580                                        0590
         BALR  @14,@15                                             0590
*           RSTATRTN=IDAR231B;      /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0591
         MVC   RSTATRTN(4,@14),@CC04131                            0591
*           IF RETCODE=ZERO THEN    /* DATA SET OBTAINED             */
         LTR   RETCODE,RETCODE                                     0592
         BNZ   @RF00592                                            0592
*             DO;                                                  0593
*               MWADSN=MWACLSNM;    /* MOVE DATA SET NAME TO AMB WORK
*                                      AREA                          */
         L     @11,CLWAMBPT(,RCORE)                                0594
         L     @11,AMBWKA(,@11)                                    0594
         MVC   MWADSN(44,@11),MWACLSNM                             0594
*               PDPDSN=ADDR(MWADSN);/* INITIALIZE DATA SET NAME    0595
*                                      ADDRESS IN PROBLEM          0595
*                                      DETERMINATION PARM LIST       */
         ST    @11,PDPDSN+280(,@14)                                0595
*             END;                                                 0596
*         END;                                                     0597
@RF00592 DS    0H                                                  0598
*       CALL ERRORFLG;              /* DETERMINE CORRECT ACBERFLG    */
@RF00584 BAL   @14,ERRORFLG                                        0598
*       R6=MWASAVED;                /* GET RETURN ADDRESS            */
         LR    R6,MWASAVED                                         0599
*     END;                                                         0600
*   R1=CLWCOMWK;                    /* POINT TO COMMON WORK AREA     */
@RF00570 L     @14,CLWCOMWK(,RCORE)                                0601
         LR    R1,@14                                              0601
*   RSTATRTN=IDAR192P;              /* NOTE CALL TO 192P             */
         MVC   RSTATRTN(4,@14),@CC04115                            0602
*   CALL IDA0192P;                  /* CALL PROBLEM DETERMINATION    */
         L     @15,@CV04591                                        0603
         BALR  @14,@15                                             0603
*   RSTATRTN=IDAR231B;              /* NOTE 231B IN CONTROL          */
         L     @14,CLWCOMWK(,RCORE)                                0604
         MVC   RSTATRTN(4,@14),@CC04131                            0604
*   PDPSFI=ZERO;                    /* ZERO POINTER TO CATALOG SFI   */
         SLR   @11,@11                                             0605
         LA    @09,280                                             0605
         ALR   @09,@14                                             0605
         ST    @11,PDPSFI(,@09)                                    0605
*   PDPCLSNM=ADDR(JFCBDSNM);        /* RESET CLUSTER NAME TO DDNAME  */
         AL    @14,@CF04149                                        0606
         ST    @14,PDPCLSNM(,@09)                                  0606
*   PDPDSN=ZERO;                    /* RESET DATA SET NAME TO ZERO   */
         ST    @11,PDPDSN(,@09)                                    0607
*   RESPECIFY                                                      0608
*     RET RESTRICTED;                                              0608
*   RET=R6;                         /* GET RETURN ADDRESS            */
         LR    RET,R6                                              0609
*   RESPECIFY                                                      0610
*    (R1,                                                          0610
*     R6,                                                          0610
*     RET,                                                         0610
*     RETCODE) UNRESTRICTED;                                       0610
*   END PROBDT;                                                    0611
@EL00009 DS    0H                                                  0611
@EF00009 DS    0H                                                  0611
@ER00009 BR    @14                                                 0611
*ERRORFLG:                                                         0612
*                                                                  0612
*/********************************************************************/
*/*                                                                  */
*/*    01 FUNCTION - THIS ROUTINE SELECT THE CORRECT ERROR FLAG FOR  */
*/*                  THE ACBERFLG                                    */
*/*    01 INPUT -    1. PROBLEM DETERMINATION PROBLEM CODE (MWAPCODE)*/
*/*                  2. PROBLEM DETERMINATION FUNCTION CODE(MWAPFUNC)*/
*/*                  3. PROBLEM DET SUB FUNCTION CODE (MWAPSFC)      */
*/*    01 OUTPUT -   1. CURRENT ERROR IS SET                         */
*/*                  2. ACBERFLG IS SET IF CURRENT ERROR IS GREATER  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0612
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0612
ERRORFLG DS    0H                                                  0613
*   RESPECIFY                                                      0613
*     RET RESTRICTED;                                              0613
*   MWASAVEE=RET;                   /* SAVE RETURN ADDRESS           */
         LR    MWASAVEE,RET                                        0614
*   RESPECIFY                                                      0615
*     RET UNRESTRICTED;                                            0615
*   PDPFUNC=MWAPFUNC;               /* GET FUNCTION CODE             */
         LA    @11,280                                             0616
         AL    @11,CLWCOMWK(,RCORE)                                0616
         IC    @06,MWAPFUNC                                        0616
         STC   @06,PDPFUNC(,@11)                                   0616
*   PDPCODE=MWAPCODE;               /* GET PROBLEM CODE              */
         SLR   @06,@06                                             0617
         IC    @06,MWAPCODE                                        0617
         STC   @06,PDPCODE(,@11)                                   0617
*   PDPSFC=MWAPSFC;                 /* GET SUB FUNCTION CODE         */
         IC    @15,MWAPSFC                                         0618
         STC   @15,PDPSFC(,@11)                                    0618
*   IF ACBERFLG<IDAERMAP(PDPCODE) THEN/* IF CURRENT ERROR IS GREATER */
         SLR   @11,@11                                             0619
         IC    @11,IDAERMAP-1(@06)                                 0619
         SLR   @06,@06                                             0619
         IC    @06,ACBERFLG(,RACB)                                 0619
         CR    @11,@06                                             0619
         BNH   @RF00619                                            0619
*     ACBERFLG=IDAERMAP(PDPCODE);   /* SET HIGHEST ERROR CODE        */
         STC   @11,ACBERFLG(,RACB)                                 0620
*   RESPECIFY                                                      0621
*     RET RESTRICTED;                                              0621
@RF00619 DS    0H                                                  0622
*   RET=MWASAVEE;                   /* RESTORE RETURN ADDRESS        */
         LR    RET,MWASAVEE                                        0622
*   RESPECIFY                                                      0623
*     RET UNRESTRICTED;                                            0623
*   END ERRORFLG;                                                  0624
@EL00010 DS    0H                                                  0624
@EF00010 DS    0H                                                  0624
@ER00010 BR    @14                                                 0624
*GETCORE:                                                          0625
*                                                                  0625
*/********************************************************************/
*/*                                                                  */
*/*      01   FUNCTION-ISSUE GETMAIN'S TO OBTAIN CORE STORAGE        */
*/*      01   INPUTS-  SUBPOOL NUMBER IN MWASPOOL                    */
*/*                    NUMBER OF BYTES REQUIRED IN MWABYTES          */
*/*      01   OUTPUTS- ADDRESS OF GOTTEN CORE IN MWADDRES            */
*/*                    IF GETMAIN FAILED, PROBLEM DETERM IS CALLED   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0625
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0625
GETCORE  DS    0H                                                  0626
*   RESPECIFY                                                      0626
*    (R0,                                                          0626
*     R1,                                                          0626
*     R6,                                                          0626
*     R7,                                                          0626
*     RET,                                                         0626
*     RETCODE) RESTRICTED;                                         0626
*   MWASAVEC=RET;                   /* SAVE RETURN ADDRESS           */
         LR    MWASAVEC,RET                                        0627
*   R6=MWASPOOL;                    /* SUBPOOL NUMBER                */
         SLR   R6,R6                                               0628
         IC    R6,MWASPOOL                                         0628
*   R7=MWABYTES;                    /* NUMBER OF BYTES REQUIRED      */
         L     R7,MWABYTES-1                                       0629
         LA    R7,0(,R7)                                           0629
*   GEN(GETMAIN RC,LV=(R7),SP=(R6)) /* REGISTER CONDITIONAL GETMAIN  */
*   SETS(R1,RETCODE);                                              0630
         GETMAIN RC,LV=(R7),SP=(R6)
*   IF RETCODE=ZERO THEN            /* GETMAIN SUCCESSFUL            */
         LTR   RETCODE,RETCODE                                     0631
         BNZ   @RF00631                                            0631
*     DO;                                                          0632
*       MWADDRES=R1;                /* ADDRESS OF GOTTEN CORE        */
         ST    R1,MWADDRES                                         0633
*       R6=R1;                      /* ADDRESS OF GOTTEN CORE FOR  0634
*                                      MVCL                          */
         LR    R6,R1                                               0634
*       R1=ZERO;                    /* ZERO PAD BYTE                 */
         SLR   R1,R1                                               0635
*       GEN(MVCL R6,R0)                                            0636
*       NOSETS;                     /* ZERO GOTTEN CORE              */
         MVCL R6,R0
*     END;                                                         0637
*   ELSE                            /* IF GETMAIN FAILED             */
*     DO;                                                          0638
         B     @RC00631                                            0638
@RF00631 DS    0H                                                  0639
*       MWAPCODE=PP20;              /* SET PROBLEM CODE              */
         MVI   MWAPCODE,X'14'                                      0639
*       CALL PROBDT;                /* CALL PROBLEM DETERMINATION    */
         BAL   @14,PROBDT                                          0640
*     END;                                                         0641
*   RET=MWASAVEC;                   /* GET RETURN ADDRESS            */
@RC00631 LR    RET,MWASAVEC                                        0642
*   RESPECIFY                                                      0643
*    (R0,                                                          0643
*     R1,                                                          0643
*     R6,                                                          0643
*     R7,                                                          0643
*     RET,                                                         0643
*     RETCODE) UNRESTRICTED;                                       0643
*   END GETCORE;                                                   0644
@EL00011 DS    0H                                                  0644
@EF00011 DS    0H                                                  0644
@ER00011 BR    @14                                                 0644
*FREECORE:                                                         0645
*                                                                  0645
*/********************************************************************/
*/*                                                                  */
*/*      01 FUNCTION - FREE MODULE WORK AREA                         */
*/*      01 INPUTS -   ADDRESS OF MWA IN MWADDRES                    */
*/*                    NUMBER OF BYTES TO BE FREED IN MWABYTES       */
*/*                    SUBPOOL NUMBER IN MWASPOOL                    */
*/*      01 OUTPUTS -  CORE STORAGE FREED                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0645
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0645
FREECORE DS    0H                                                  0646
*   RESPECIFY                                                      0646
*    (R0,                                                          0646
*     R1,                                                          0646
*     RET) RESTRICTED;                                             0646
*   MWASAVEB=RET;                   /* SAVE RETURN ADDRESS           */
         ST    RET,MWASAVEB                                        0647
*   LM(R0,R1,MWAMNPRM);             /* SUBPOOL NO., LENGTH, AND    0648
*                                      ADDRESS OF CORE TO BE FREED   */
         LM    R0,R1,MWAMNPRM                                      0648
*   GEN(FREEMAIN R,LV=(0),A=(1));   /* FREEMAIN                      */
         FREEMAIN R,LV=(0),A=(1)
*   RET=MWASAVEB;                   /* GET RETURN ADDRESS            */
         L     RET,MWASAVEB                                        0650
*   RESPECIFY                                                      0651
*    (R0,                                                          0651
*     R1,                                                          0651
*     RET) UNRESTRICTED;                                           0651
*   END FREECORE;                                                  0652
@EL00012 DS    0H                                                  0652
@EF00012 DS    0H                                                  0652
@ER00012 BR    @14                                                 0652
@PB00012 DS    0H                                                  0652
*   END IDA0231B                                                   0653
*                                                                  0653
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDABIB  )                                       */
*/*%INCLUDE SYSLIB  (IDABLPRM)                                       */
*/*%INCLUDE SYSLIB  (IGGCAXWA)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IEESMCA )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IDAVAT  )                                       */
*/*%INCLUDE SYSLIB  (IDAVSRT )                                       */
*/*%INCLUDE SYSLIB  (IDAFOREC)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                       */
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                       */
*/*%INCLUDE SYSLIB  (IDARTMAC)                                       */
*/*%INCLUDE SYSLIB  (IDAERRCD)                                       */
*/*%INCLUDE SYSLIB  (IDAERMAP)                                       */
*/*%INCLUDE SYSLIB  (IDAPDFCD)                                       */
*/*%INCLUDE SYSLIB  (IDAPPCDE)                                       */
*/*%INCLUDE SYSLIB  (IDAOCECN)                                       */
*/*%INCLUDE SYSLIB  (IDAVIRT )                                       */
*/*%INCLUDE SYSLIB  (IDACLWRK)                                       */
*/*%INCLUDE SYSLIB  (IDAGMAIN)                                       */
*                                                                  0653
*       ;                                                          0653
@DATA    DS    0H
@DATD    DSECT
         DS    0F
@SA00001 DS    23F
IDA0231B CSECT
         DS    0F
@CF00049 DC    F'8'
@CF00115 DC    F'64'
@CF00106 DC    F'72'
@CF04149 DC    F'100'
@CF04163 DC    F'148'
@DATD    DSECT
         DS    0D
MWASAVEA DS    A
MWASAVEB DS    A
MWARPLPT DS    A
MWAVATPT DS    A
MWAMNPRM DS    CL8
         ORG   MWAMNPRM
MWAMNWRD DS    FL4
         ORG   MWAMNWRD
MWASPOOL DS    FL1
MWABYTES DS    AL3
         ORG   MWAMNPRM+4
MWADDRES DS    AL4
         ORG   MWAMNPRM+8
MWAENQPM DS    CL20
         ORG   MWAENQPM
ENQTCB   DS    AL4
ENQENTRY DS    CL16
         ORG   ENQENTRY
ENQOPT1  DS    BL1
         ORG   ENQOPT1
ENQEND   DS    BL1
ENQNEW   EQU   ENQOPT1+0
@NM00001 EQU   ENQOPT1+0
ENQDIR   EQU   ENQOPT1+0
         ORG   ENQENTRY+1
ENQRLEN  DS    FL1
ENQOPT2  DS    BL1
         ORG   ENQOPT2
ENQSHR   DS    BL1
         ORG   ENQENTRY+3
ENQRETC  DS    FL1
ENQQNADR DS    AL4
ENQRNADR DS    AL4
ENQUCADR DS    AL4
         ORG   MWAENQPM+20
MWARNAME DS    CL8
         ORG   MWARNAME
ENQRNCI  DS    CL3
ENQRNACB DS    CL4
ENQRNIND DS    CL1
         ORG   MWARNAME+8
MWACATPM DS    CL56
         ORG   MWACATPM
MWACATID DS    CL1
MWASFIPT DS    AL3
@NM00002 DS    CL1
MWACI    DS    CL3
MWACACB  DS    AL4
MWACLSNM DS    CL44
         ORG   MWACATPM+56
MWARCD64 DS    CL24
         ORG   MWARCD64
MWARCNBR DS    FL1
MWARCIN  DS    BL1
         ORG   MWARCIN
MWARCLOS DS    BL1
         ORG   MWARCD64+2
@NM00003 DS    CL2
MWARCAMB DS    AL4
MWARCDSN DS    AL4
MWARCNTR DS    FL4
MWARCCSN DS    AL4
MWARCTIO DS    AL4
         ORG   MWARCD64+24
MWAPDPRM DS    CL4
         ORG   MWAPDPRM
MWAPCODE DS    FL1
MWAPFUNC DS    FL1
MWAPSFC  DS    FL1
@NM00004 DS    CL1
         ORG   MWAPDPRM+4
MWAQNAME DS    CL8
MWAVIRT  DS    CL24
MWATIMES DS    CL8
MWAMBDTA DS    CL46
MWAMBIDX DS    CL46
IDA0231B CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV04560 DC    V(IDA0192Y)
@CV04569 DC    V(IDA0192D)
@CV04580 DC    V(IDA0192C)
@CV04585 DC    V(IDA0192S)
@CV04591 DC    V(IDA0192P)
         DS    0D
@CC04578 DC    C'SYSVSAM '
@CC04105 DC    C'192C'
@CC04115 DC    C'192P'
@CC04117 DC    C'192S'
@CC04131 DC    C'231B'
IDAERMAP DC    3AL1(0)
         DC    AL1(132)
         DC    15AL1(0)
         DC    AL1(136)
         DC    AL1(0)
         DC    AL1(184)
         DC    5AL1(0)
         DC    AL1(180)
         DC    3AL1(0)
         DC    AL1(148)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(144)
         DC    AL1(148)
         DC    AL1(196)
         DC    AL1(100)
         DC    AL1(152)
         DC    AL1(160)
         DC    2AL1(0)
         DC    AL1(160)
         DC    AL1(96)
         DC    AL1(192)
         DC    AL1(160)
         DC    AL1(160)
         DC    AL1(224)
         DC    AL1(176)
         DC    AL1(0)
         DC    AL1(168)
         DC    AL1(0)
         DC    AL1(160)
         DC    AL1(0)
         DC    AL1(116)
         DC    AL1(0)
         DC    AL1(108)
         DC    AL1(104)
         DC    AL1(240)
         DC    7AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(160)
         DC    AL1(0)
         DC    AL1(188)
         DC    AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(232)
         DC    3AL1(0)
         DC    AL1(160)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(0)
         DC    AL1(236)
         DC    AL1(236)
         DC    AL1(0)
         DC    5AL1(0)
         DC    AL1(0)
         DC    3AL1(0)
         DC    AL1(0)
         DC    3AL1(0)
         DC    AL1(0)
         DC    3AL1(0)
         DC    AL1(0)
         DC    3AL1(0)
         DC    AL1(164)
         DC    3AL1(0)
         DC    AL1(220)
         DC    3AL1(0)
         DC    AL1(228)
         DC    3AL1(0)
         DC    AL1(184)
         DC    3AL1(0)
         DC    AL1(208)
         DC    3AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(204)
         DC    3AL1(0)
         DC    AL1(212)
         DC    3AL1(0)
         DC    AL1(216)
         DC    7AL1(0)
         DC    AL1(160)
         DC    3AL1(0)
         DC    AL1(244)
         DC    3AL1(0)
         DC    AL1(200)
         DC    3AL1(0)
         DC    AL1(0)
         DC    3AL1(0)
         DC    AL1(0)
         DC    3AL1(0)
         DC    AL1(0)
         DC    72AL1(0)
IDA0231B CSECT
         DS    0D                        DOUBLE WORD BOUNDARY
PTCH231B DC    ((*-IDA0231B)/20)X'00'    PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0231B CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
MWACLWRK EQU   @06
MWAUCBPT EQU   @08
MWADEBPT EQU   @07
MWAACBPT EQU   @05
MWASAVEE EQU   @05
MWASAVED EQU   @09
MWASAVEC EQU   @10
R13      EQU   @13
RCORE    EQU   @04
R0       EQU   @00
R1       EQU   @01
RACB     EQU   @02
RBASEA   EQU   @03
RBASEB   EQU   @12
R12      EQU   @12
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
RET      EQU   @14
RETCODE  EQU   @15
R15      EQU   @15
RDEB     EQU   @11
RTIOT    EQU   @09
RUCB     EQU   @10
R10      EQU   @10
R11      EQU   @11
R8       EQU   @08
R9       EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
MWABUFSA EQU   0
MWACATWK EQU   0
MWADSN   EQU   MWACATWK
MWACLFLG EQU   MWACATWK+44
MWAOUTBT EQU   MWACLFLG
MWAOPEN  EQU   MWACATWK+45
SAVAREA  EQU   0
SABWRD   EQU   SAVAREA+4
SAREGS   EQU   SAVAREA+12
SACODE   EQU   SAREGS+4
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBUAPTR EQU   ACBCOMN+64
IDAAMB   EQU   0
AMBCACB  EQU   IDAAMB+16
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBDDSN  EQU   IDAAMB+35
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBWKA   EQU   IDAAMB+60
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLVRT  EQU   AMBLVC
AMBLENO  EQU   AMBLVC+1
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLWRIT EQU   AMBLSHAR
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
AMBLIX   EQU   IDAAMBL+56
AMBLBIB  EQU   IDAAMBL+60
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDNEST  EQU   IDAAMDSB+4
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDBIND  EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDSTAT  EQU   IDAAMDSB+48
AMDSTSP  EQU   AMDSTAT
IDABIB   EQU   0
BIBHDR   EQU   IDABIB
BIBFLG1  EQU   BIBHDR+1
BIBVIRT  EQU   BIBFLG1
BIBRTNS  EQU   IDABIB+60
BIBINTRF EQU   BIBRTNS
IDABLPRM EQU   0
BLPBUFLP EQU   IDABLPRM+4
BLPUACB  EQU   BLPBUFLP
BLPIOPLH EQU   BLPUACB
BLPFLAGS EQU   IDABLPRM+10
BLPFLAG1 EQU   BLPFLAGS
BLPFBLD  EQU   BLPFLAG1
BLPFDEL  EQU   BLPFLAG1
BLPFLSR  EQU   BLPFLAG1
BLPFIOBF EQU   BLPFLAG1
BLPFBFRF EQU   BLPFLAG1
BLPFLAG2 EQU   BLPFLAGS+1
BLPFIOSR EQU   BLPFLAG2
BLPCORE  EQU   IDABLPRM+16
BLPGFLG  EQU   BLPCORE
BLPIOACB EQU   IDABLPRM+24
BLPBUFL  EQU   0
BLPBRLFG EQU   BLPBUFL+4
IGGCAXWA EQU   0
CAXFLGS  EQU   IGGCAXWA+8
CAXFLG2  EQU   IGGCAXWA+9
CAXFLG3  EQU   IGGCAXWA+10
CAXCCR   EQU   IGGCAXWA+32
CAXCNAM  EQU   IGGCAXWA+52
CAXOPLST EQU   IGGCAXWA+96
COPTS    EQU   CAXOPLST
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTSMCA  EQU   CVTMAP+196
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBUCBA  EQU   DEBUCBAD+1
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBSHR  EQU   JSCBSEC1+8
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00095 EQU   RBSECT+10
@NM00096 EQU   @NM00095
RBTRSVRB EQU   @NM00096
@NM00098 EQU   @NM00095+1
RBETXR   EQU   @NM00098
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00105 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00109 EQU   RBSECT+96
RBRSV138 EQU   @NM00109+7
RBRSV150 EQU   RBSECT+167
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLPLHPT EQU   RPLCOMN+4
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
SMCABASE EQU   0
SMCAOPT  EQU   SMCABASE
SMCADSA  EQU   SMCAOPT
SMCAMISC EQU   SMCABASE+1
SMCAUSER EQU   SMCAMISC
SMCAMAN  EQU   SMCAMISC
SMCABUF  EQU   SMCABASE+12
SMCAPSTA EQU   SMCABASE+30
SMCAPLBL EQU   SMCABASE+34
SMCASTA  EQU   SMCABASE+46
SMCAALBL EQU   SMCABASE+50
SMCAENTY EQU   SMCABASE+80
SMCAENDI EQU   SMCAENTY
SMCAFOPT EQU   SMCABASE+82
SMCASWA  EQU   SMCABASE+104
SMCAASCB EQU   SMCABASE+120
SMCAPGIN EQU   SMCABASE+136
SMCAPGOT EQU   SMCABASE+140
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00122 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
IDAVAT   EQU   0
VATHDR   EQU   IDAVAT
VATNEXT  EQU   IDAVAT+4
VATVSRT  EQU   IDAVAT+8
VATVPTR  EQU   VATVSRT+4
VATVC    EQU   IDAVAT+20
VATVRT   EQU   VATVC
VATENO   EQU   VATVC+1
VATAMBL  EQU   IDAVAT+28
IDAVSRT  EQU   0
VSRTFLGS EQU   IDAVSRT+12
VSRTIOBF EQU   VSRTFLGS
VSRTBFRF EQU   VSRTFLGS
VSRTCSL  EQU   IDAVSRT+40
VSRTCSLF EQU   VSRTCSL
VSRTCSBF EQU   VSRTCSLF
VSRTCSPF EQU   VSRTCSLF
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXJBF    EQU   FORCORE+100
DXIOB    EQU   FORCORE+280
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXUACBAD EQU   DXUDCBAD+1
DXPDCBAD EQU   FORCORE+572
DXPACBAD EQU   DXPDCBAD+1
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXB1 EQU   DXATEXC1
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECWTGTB EQU   IECEXTPR+72
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
IDAPDPRM EQU   0
PDPCODE  EQU   IDAPDPRM+1
PDPFUNC  EQU   IDAPDPRM+2
PDPSFC   EQU   IDAPDPRM+3
PDPTIOT  EQU   IDAPDPRM+12
PDPCLSNM EQU   IDAPDPRM+20
PDPDSN   EQU   IDAPDPRM+24
PDPDSTYP EQU   IDAPDPRM+33
PDPMSGFL EQU   IDAPDPRM+34
PDPSFI   EQU   IDAPDPRM+36
IDAVGTT  EQU   0
VGTTTYPE EQU   IDAVGTT+4
IDAVIRT  EQU   0
VIRTFLAG EQU   IDAVIRT+1
VIRTACQ  EQU   VIRTFLAG
VIRTNOUN EQU   VIRTFLAG
VIRTBACB EQU   VIRTFLAG
VIRTACB  EQU   IDAVIRT+4
VIRTTIOE EQU   IDAVIRT+16
IDACLWRK EQU   0
CLWCOMWK EQU   IDACLWRK+8
CLWAMBPT EQU   IDACLWRK+12
CLWSFI   EQU   IDACLWRK+16
CLWCNOUP EQU   IDACLWRK+28
CLWNWRIT EQU   IDACLWRK+28
CLWGMAIN EQU   IDACLWRK+29
CLWTERM  EQU   IDACLWRK+29
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
PSARSVTE EQU   PSARSVT
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00121 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00155 EQU   DXXCTL
DXSAVMOD EQU   @NM00155+2
@NM00156 EQU   DXRESSW
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
PDWLIST  EQU   FORCORE
PDWWORK  EQU   DXDCB
IDARRPL  EQU   DXATCOM1
IDARRFLG EQU   IDARRPL+1
IDARSTAT EQU   DXATEXC1
RSTAT    EQU   IDARSTAT
RSTATCRO EQU   RSTAT+1
RSTATOP2 EQU   RSTAT+2
IDARRTN  EQU   DXATEXC2
RSTATRTN EQU   IDARRTN
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
FLC      EQU   PSA
IDAESPL  EQU   DXATCOM1
IDARTSA  EQU   DXJBF
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00173 EQU   RSTAT+3
@NM00172 EQU   RSTATOP2
RSTATCSA EQU   RSTATOP2
IDARCURS EQU   RSTATCRO
IDARCRCU EQU   RSTATCRO
IDARRSTR EQU   RSTATCRO
IDARCKPT EQU   RSTATCRO
RSTATOPT EQU   RSTAT
@NM00171 EQU   IDARRPL+2
@NM00170 EQU   IDARRFLG
RRPLVSAM EQU   IDARRFLG
@NM00169 EQU   IDARRFLG
@NM00168 EQU   IDARRPL
PDWORKSP EQU   PDWWORK+88
PDWERRCD EQU   PDWWORK+84
PDWMSGPT EQU   PDWWORK+80
PDWSAVED EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00160 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00159 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00158 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
DXRESIND EQU   @NM00156
DXSAVOFF EQU   @NM00155+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00155
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00140 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00139 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00138 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00121
UCBSKPFG EQU   @NM00121
UCBRIPND EQU   @NM00121
UCBRTIAC EQU   @NM00121
UCBRSV79 EQU   @NM00121
UCBRSV78 EQU   @NM00121
UCBRSV77 EQU   @NM00121
UCBOLTEP EQU   @NM00121
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00120 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00110 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBCDSAVE EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00059 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00058 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
CLWSECCL EQU   IDACLWRK+29
CLWPRMCL EQU   IDACLWRK+29
CLWPARCL EQU   IDACLWRK+28
CLWOUTPT EQU   IDACLWRK+28
CLWDUMMY EQU   IDACLWRK+28
CLWSPHCL EQU   IDACLWRK+28
CLWPATH  EQU   IDACLWRK+28
CLWBNOFL EQU   IDACLWRK+28
CLWID    EQU   IDACLWRK
@NM00176 EQU   IDAVIRT+22
VIRTLENG EQU   IDAVIRT+20
VIRTEXT  EQU   IDAVIRT+12
VIRTUCB  EQU   IDAVIRT+8
@NM00175 EQU   IDAVIRT+2
VIRTMNT  EQU   VIRTFLAG
VIRTBEXT EQU   VIRTFLAG
VIRTBUCB EQU   VIRTFLAG
VIRTINHB EQU   VIRTFLAG
@NM00174 EQU   IDAVIRT
VGTTCORE EQU   IDAVGTT+32
@NM00167 EQU   IDAVGTT+28
VGTTPSB  EQU   IDAVGTT+24
VGTTVUSE EQU   IDAVGTT+20
VGTTBIB  EQU   IDAVGTT+16
VGTTNEXT EQU   IDAVGTT+12
VGTTSIZE EQU   IDAVGTT+8
VGTTSP   EQU   IDAVGTT+7
VGTTGSRK EQU   IDAVGTT+6
@NM00166 EQU   IDAVGTT+5
@NM00165 EQU   VGTTTYPE
VGTTOPEN EQU   VGTTTYPE
VGTTCTLG EQU   VGTTTYPE
VGTTLSR  EQU   VGTTTYPE
VGTTGSR  EQU   VGTTTYPE
VGTTRSTR EQU   VGTTTYPE
VGTTID   EQU   IDAVGTT
@NM00164 EQU   IDAPDPRM+35
PDPNOMSG EQU   PDPMSGFL
PDPNOTRC EQU   PDPMSGFL
PDPSPACE EQU   PDPMSGFL
PDPNOTFC EQU   PDPMSGFL
PDPKEY   EQU   IDAPDPRM+32
PDPCTACB EQU   IDAPDPRM+28
PDPVLSER EQU   IDAPDPRM+16
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00163 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00162 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00161 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00157 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00154 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00153 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00152 EQU   WTGAREA+20
@NM00151 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00150 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00149 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00148 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00147 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00146 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00145 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00144 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00143 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00142 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00141 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
DXATEXB2 EQU   DXATEXC2
DXEXHASP EQU   DXATEXB1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00137 EQU   DXATCOM2+3
@NM00136 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00135 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00134 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
@NM00133 EQU   DXPDCBAD
@NM00132 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00131 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDEBXAD EQU   FORCORE+552
DXDSAB   EQU   FORCORE+548
DXDSABAD EQU   FORCORE+544
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXUKEY   EQU   FORCORE+526
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00130 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
@NM00129 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00128 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00127 EQU   DXDAADDR
DXECB    EQU   FORCORE+276
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
VSRTCSLN EQU   VSRTCSL+5
VSRTCSSP EQU   VSRTCSL+4
VSRTCSAD EQU   VSRTCSL+1
VSRTCSBH EQU   VSRTCSLF
VSRTCSIO EQU   VSRTCSLF
VSRTCSPL EQU   VSRTCSLF
VSRTCSWS EQU   VSRTCSLF
VSRTCSVG EQU   VSRTCSPF
VSRTCSK7 EQU   VSRTCSBF
VSRTCSVS EQU   VSRTCSLF
VSRTCSFX EQU   VSRTCSLF
VSRTASCB EQU   IDAVSRT+36
VSRTVIOT EQU   IDAVSRT+32
VSRTWAH  EQU   IDAVSRT+28
VSRTCPAH EQU   IDAVSRT+24
VSRTBUFH EQU   IDAVSRT+20
VSRTPLHH EQU   IDAVSRT+16
VSRTSTRN EQU   IDAVSRT+15
VSRTKL   EQU   IDAVSRT+14
@NM00126 EQU   VSRTFLGS
VSRTLSRF EQU   VSRTFLGS
VSRTGSRF EQU   VSRTFLGS
VSRTEOV  EQU   IDAVSRT+8
VSRTID   EQU   IDAVSRT+4
VSRTLEN  EQU   IDAVSRT+2
@NM00125 EQU   IDAVSRT+1
VSRTBKID EQU   IDAVSRT
VATNAE   EQU   IDAVAT+24
@NM00124 EQU   IDAVAT+22
VATPAMBL EQU   IDAVAT+16
VATVUSE  EQU   VATVSRT
VATLEN   EQU   VATHDR+2
@NM00123 EQU   VATHDR+1
VATID    EQU   VATHDR
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00122
UCBHALI  EQU   @NM00122
UCBRSV09 EQU   @NM00122
UCBRSV08 EQU   @NM00122
UCBRSV07 EQU   @NM00122
UCBRSV06 EQU   @NM00122
UCBRSV05 EQU   @NM00122
UCBRSV04 EQU   @NM00122
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00119 EQU   UCB
@NM00118 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00117 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00116 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00115 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
SMCASTCB EQU   SMCABASE+176
SMCAWTCB EQU   SMCABASE+172
SMCAU83  EQU   SMCABASE+168
SMCAPGM  EQU   SMCABASE+164
SMCARGNM EQU   SMCABASE+160
SMCASPOT EQU   SMCABASE+156
SMCASPIN EQU   SMCABASE+152
SMCARGNS EQU   SMCABASE+148
SMCAPGRL EQU   SMCABASE+144
SMCADOMY EQU   SMCAPGOT
SMCADOMX EQU   SMCAPGIN
SMCATEXP EQU   SMCABASE+132
SMCASAVE EQU   SMCABASE+128
SMCARS21 EQU   SMCABASE+124
SMCATJID EQU   SMCAASCB+2
SMCAPOST EQU   SMCAASCB
SMCADSCT EQU   SMCABASE+116
SMCADSTM EQU   SMCABASE+108
SMCASWD  EQU   SMCABASE+107
SMCASWC  EQU   SMCABASE+106
SMCASWB  EQU   SMCABASE+105
SMCADSSW EQU   SMCASWA
SMCADSSP EQU   SMCASWA
SMCAZEOD EQU   SMCASWA
SMCANAVL EQU   SMCASWA
SMCANADA EQU   SMCASWA
SMCAOPFL EQU   SMCASWA
SMCADSTR EQU   SMCASWA
SMCASWAR EQU   SMCASWA
SMCAXNAM EQU   SMCABASE+96
@NM00114 EQU   SMCABASE+92
SMCAXCTL EQU   SMCABASE+88
SMCAWRTP EQU   SMCABASE+84
SMCAENAL EQU   SMCABASE+83
SMCAFGN  EQU   SMCAFOPT
SMCAFTDS EQU   SMCAFOPT
SMCAFR01 EQU   SMCAFOPT
SMCAFVOL EQU   SMCAFOPT
SMCAFDSA EQU   SMCAFOPT
SMCAFEXT EQU   SMCAFOPT
SMCAFOP2 EQU   SMCAFOPT
SMCAFOP1 EQU   SMCAFOPT
SMCAENOP EQU   SMCAENTY+1
SMCADSNF EQU   SMCAENDI
SMCARS20 EQU   SMCAENDI
SMCARS19 EQU   SMCAENDI
SMCARS18 EQU   SMCAENDI
SMCARS17 EQU   SMCAENDI
SMCARS16 EQU   SMCAENDI
SMCARS15 EQU   SMCAENDI
SMCARS14 EQU   SMCAENDI
SMCAWAIT EQU   SMCABASE+72
SMCASGFT EQU   SMCABASE+68
SMCASGWR EQU   SMCABASE+64
SMCABECB EQU   SMCABASE+60
SMCAWECB EQU   SMCABASE+56
SMCAADCB EQU   SMCABASE+52
SMCAYORX EQU   SMCABASE+51
SMCAANL  EQU   SMCAALBL
SMCAASL  EQU   SMCAALBL
SMCAANSL EQU   SMCAALBL
SMCARS13 EQU   SMCAALBL
SMCARS12 EQU   SMCAALBL
SMCARS11 EQU   SMCAALBL
SMCARS10 EQU   SMCAALBL
SMCARS09 EQU   SMCAALBL
SMCAADAR EQU   SMCABASE+47
SMCAAVOL EQU   SMCASTA
SMCAAUNT EQU   SMCASTA
SMCARS08 EQU   SMCASTA
SMCAAMOD EQU   SMCASTA
SMCAAMTY EQU   SMCASTA
SMCAADA  EQU   SMCASTA
SMCAATAP EQU   SMCASTA
SMCAANAV EQU   SMCASTA
SMCAADEV EQU   SMCABASE+40
SMCAPDCB EQU   SMCABASE+36
SMCAXORY EQU   SMCABASE+35
SMCAPNL  EQU   SMCAPLBL
SMCAPSL  EQU   SMCAPLBL
SMCAPNSL EQU   SMCAPLBL
SMCARS07 EQU   SMCAPLBL
SMCARS06 EQU   SMCAPLBL
SMCARS05 EQU   SMCAPLBL
SMCARS04 EQU   SMCAPLBL
SMCARS03 EQU   SMCAPLBL
SMCAPDAR EQU   SMCABASE+31
SMCAPVOL EQU   SMCAPSTA
SMCAPUNT EQU   SMCAPSTA
SMCARS02 EQU   SMCAPSTA
SMCAMOD  EQU   SMCAPSTA
SMCAPMTY EQU   SMCAPSTA
SMCAPDA  EQU   SMCAPSTA
SMCAPTAP EQU   SMCAPSTA
SMCAPNAV EQU   SMCAPSTA
SMCAPDEV EQU   SMCABASE+24
SMCABUFP EQU   SMCABASE+20
SMCASID  EQU   SMCABASE+16
SMCABSIZ EQU   SMCABUF
SMCAJWT  EQU   SMCABASE+8
SMCATIOT EQU   SMCABASE+4
SMCATOFF EQU   SMCABASE+2
SMCADUMP EQU   SMCAMISC
SMCABSW  EQU   SMCAMISC
SMCADBSY EQU   SMCAMISC
SMCAPSDP EQU   SMCAMISC
SMCAFIRT EQU   SMCAMISC
SMCAOPI  EQU   SMCAMISC
SMCAFGND EQU   SMCAOPT
SMCATDS  EQU   SMCAOPT
SMCARS01 EQU   SMCAOPT
SMCAVOL  EQU   SMCAOPT
SMCAEXT  EQU   SMCAOPT
SMCAOPT2 EQU   SMCAOPT
SMCAOPT1 EQU   SMCAOPT
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00113 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00112 EQU   RPLRBAR+3
@NM00111 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00109+8
PRBEND   EQU   @NM00109+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00109+6
RBRSV136 EQU   @NM00109+4
RBRSV135 EQU   @NM00109
@NM00108 EQU   RBSECT+32
@NM00107 EQU   @NM00105+1
@NM00106 EQU   @NM00105
RBPGMQ1  EQU   RBPGMQ+1
@NM00104 EQU   RBPGMQ
@NM00103 EQU   RBSECT+16
@NM00102 EQU   @NM00098
@NM00101 EQU   @NM00098
RBIQETP  EQU   @NM00098
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00098
@NM00100 EQU   @NM00098
@NM00099 EQU   @NM00098
RBPMSVRB EQU   @NM00096
RBATNXIT EQU   @NM00096
@NM00097 EQU   @NM00096
RBWAITP  EQU   @NM00096
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00096
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00094 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00093 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00092 EQU   RBOPSWB2
@NM00091 EQU   XRBPSW
@NM00090 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00089 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00088 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00087 EQU   XSTAB1
@NM00086 EQU   RBBASIC+8
@NM00085 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00084 EQU   RBPRFX
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00057 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00056 EQU   IEZJSCB
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00055 EQU   DEBACS08+12
@NM00054 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00053 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00052 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00051 EQU   CVTFIX+248
@NM00050 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
CAXCRACB EQU   IGGCAXWA+112
CAXJDE   EQU   IGGCAXWA+108
CAXCCA   EQU   IGGCAXWA+104
CAXOPEWA EQU   IGGCAXWA+100
COPACB   EQU   CAXOPLST+1
@NM00049 EQU   COPTS
CENLST   EQU   COPTS
@NM00048 EQU   CAXCNAM+22
CAXRADDN EQU   CAXCNAM+14
CAXRATEP EQU   CAXCNAM+10
CAXRACTS EQU   CAXCNAM+6
CAXVOLID EQU   CAXCNAM
CAXRPL   EQU   IGGCAXWA+48
CAXRPLCT EQU   IGGCAXWA+46
CAXASID  EQU   IGGCAXWA+44
CAXFDCI  EQU   CAXCCR+9
CAXCDCI  EQU   CAXCCR+6
CAXNFCI  EQU   CAXCCR+3
CAXHACI  EQU   CAXCCR
CAXUCB   EQU   IGGCAXWA+28
CAXACB   EQU   IGGCAXWA+24
CAXDRWP  EQU   IGGCAXWA+20
CAXSCHWA EQU   IGGCAXWA+16
CAXATIOT EQU   IGGCAXWA+12
CAXACT   EQU   IGGCAXWA+11
@NM00047 EQU   CAXFLG3
CAXF3B6  EQU   CAXFLG3
CAXF3B5  EQU   CAXFLG3
@NM00046 EQU   CAXFLG3
CAXF3ANE EQU   CAXFLG3
CAXF3AT  EQU   CAXFLG3
CAXF2VTU EQU   CAXFLG2
CAXF2REC EQU   CAXFLG2
CAXF2CA  EQU   CAXFLG2
CAXF2CLR EQU   CAXFLG2
CAXF2IOE EQU   CAXFLG2
CAXF2NCR EQU   CAXFLG2
CAXF2NDD EQU   CAXFLG2
CAXF2DT  EQU   CAXFLG2
CAXSCR   EQU   CAXFLGS
CAXCMR   EQU   CAXFLGS
CAXMCT   EQU   CAXFLGS
CAXCMP   EQU   CAXFLGS
CAXEOV   EQU   CAXFLGS
CAXCLS   EQU   CAXFLGS
CAXOPN   EQU   CAXFLGS
CAXBLD   EQU   CAXFLGS
CAXCHN   EQU   IGGCAXWA+4
@NM00045 EQU   IGGCAXWA+1
CAXID    EQU   IGGCAXWA
BLPBFLCT EQU   BLPBUFL+6
@NM00044 EQU   BLPBUFL+5
@NM00043 EQU   BLPBRLFG
BLPBFLST EQU   BLPBRLFG
BLPBUFSZ EQU   BLPBUFL
BLPERFLG EQU   IDABLPRM+51
@NM00042 EQU   IDABLPRM+49
BLPOFLGS EQU   IDABLPRM+48
@NM00041 EQU   IDABLPRM+28
BLPDSORG EQU   BLPIOACB+3
@NM00040 EQU   BLPIOACB
BLPGAD   EQU   BLPCORE+5
BLPGSP   EQU   BLPCORE+4
BLPGSZ   EQU   BLPCORE+1
BLPGPG   EQU   BLPGFLG
BLPGREQ  EQU   BLPGFLG
BLPOACB  EQU   IDABLPRM+13
BLPOCODE EQU   IDABLPRM+12
BLPFRSTR EQU   BLPFLAG2
BLPFINDX EQU   BLPFLAG2
BLPFDATA EQU   BLPFLAG2
BLPFPRIM EQU   BLPFLAG2
BLPFPATH EQU   BLPFLAG2
BLPFUPGR EQU   BLPFLAG2
BLPFPART EQU   BLPFLAG2
BLPFSTAD EQU   BLPFLAG1
BLPFGSR  EQU   BLPFLAG1
BLPFDBDC EQU   BLPFLAG1
BLPSTRNO EQU   IDABLPRM+9
BLPKEYLN EQU   IDABLPRM+8
@NM00039 EQU   IDABLPRM+2
BLPACBST EQU   IDABLPRM+1
BLPACBID EQU   IDABLPRM
BIBVSRTP EQU   IDABIB+104
BIBASCB  EQU   IDABIB+100
BIBDDNM  EQU   IDABIB+92
BIBSTPNM EQU   IDABIB+84
BIBJOBNM EQU   IDABIB+76
BIBSIOAP EQU   BIBRTNS+12
BIBASYRT EQU   BIBRTNS+8
BIBCEAPP EQU   BIBRTNS+4
BIBVGTT  EQU   IDABIB+56
BIBPSAB  EQU   IDABIB+52
BIBCSL   EQU   IDABIB+48
BIBWSHD  EQU   IDABIB+44
BIBVCRT  EQU   IDABIB+40
BIBHEBFQ EQU   IDABIB+36
BIBHEBPT EQU   IDABIB+32
BIBPRSPH EQU   IDABIB+28
BIBSPHPT EQU   IDABIB+24
BIBPAMBL EQU   IDABIB+20
BIBDACB  EQU   IDABIB+16
BIBVMT   EQU   IDABIB+12
BIBUPT   EQU   IDABIB+8
@NM00038 EQU   IDABIB+5
BIBFLG2  EQU   IDABIB+4
BIBLEN   EQU   BIBHDR+2
@NM00037 EQU   BIBFLG1
BIBCKPT  EQU   BIBFLG1
BIBREST  EQU   BIBFLG1
BIBID    EQU   BIBHDR
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
@NM00036 EQU   IDAAMDSB+41
@NM00035 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDCINV  EQU   IDAAMDSB+20
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDKEYLN EQU   IDAAMDSB+8
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLCMB  EQU   IDAAMBL+64
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00034 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00033 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00032 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00031 EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00030 EQU   IDAAMBL+31
@NM00029 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00028 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00027 EQU   AMBCSWD1+1
@NM00026 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00025 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00024 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00023 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00022 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00021 EQU   AMBINFL
@NM00020 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00019 EQU   IDAAMB+38
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00018 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00017 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00016 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00015 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00014 EQU   ACBINFLG
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00013 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00012 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00011 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00010 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00009 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00008 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00007 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00006 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
SAREG    EQU   SAREGS+8
SARTRN   EQU   SAREGS
SAFWRD   EQU   SAVAREA+8
@NM00005 EQU   SAVAREA
@NM00083 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00082 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00081 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00080 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00079 EQU   FLCFSA
@NM00078 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00077 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00076 EQU   FLCIOA
@NM00075 EQU   FLCMCLA+15
@NM00074 EQU   FLCMCLA+14
@NM00073 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00072 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00071 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00070 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00069 EQU   FLCPER
@NM00068 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00067 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00066 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00065 EQU   FLCPIILC
@NM00064 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00063 EQU   FLCSVILC
@NM00062 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00061 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00060 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00351 EQU   @RC00333
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA0231B,(C'PLS1502',0701,78144)
