         TITLE '************* IDCCH02:  CHECKMSS MSC/SA CHECK ROUTINE **
               *********'
        MACRO
        GETMAIN &R,&LV=
        L     REG15,0(REG1)           GDTTBL ADDRESS
        L     REG15,GDTPRL(REG15)     PROL ROUTINE ADDRESS
        CNOP  2,4                     BOUNDARY ALIGNMENT
        LA    REG14,*+14              RETURN ADDRESS
        BALR  REG1,REG15              LINKAGE TO PROL ROUTINE
        DC    A(MODID)                MODULE ID ADDRESS
        DC    A(@SIZDATD)             AUTOMATIC STORAGE SIZE ADDRESS
        MEND
IDCCH02  CSECT ,                                                   0002
@MAINENT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL1(16)                                             0002
         DC    C'IDCCH02   77.297'                                 0002
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0002
         BALR  @12,0                                               0002
@PSTART  LA    @10,4095(,@12)                                      0002
         LA    @09,4095(,@10)                                      0002
         LA    @08,4095(,@09)                                      0002
         LA    @07,4095(,@08)                                      0002
         LA    @06,4095(,@07)                                      0002
         USING @PSTART,@12                                         0002
         USING @PSTART+4095,@10                                    0002
         USING @PSTART+8190,@09                                    0002
         USING @PSTART+12285,@08                                   0002
         USING @PSTART+16380,@07                                   0002
         USING @PSTART+20475,@06                                   0002
         L     @00,@SIZDATD                                        0002
         GETMAIN  R,LV=(0)
         LR    @11,@01                                             0002
         USING @DATD,@11                                           0002
         ST    @13,@SA00001+4                                      0002
         LM    @00,@01,20(@13)                                     0002
         ST    @11,8(,@13)                                         0002
         LR    @13,@11                                             0002
         MVC   @PC00001(12),0(@01)                                 0002
*                                                                  0385
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - IDCCH02                                 @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUCNTION - THIS ROUTINE PRIMARILY ROUTES CONTROL TO      @Z40LB61*/
*/*            SUBROUTINES WHICH CHECK MSC AND SA TABLES     @Z40LB61*/
*/*            FOR CONSISTENCY.  MSC TABLES ARE COMPARED     @Z40LB61*/
*/*            WITH SA TABLES (IF REQUESTED) AND MSC TABLES  @Z40LB61*/
*/*            ARE COMPARED TO EACH OTHER (IF REQUESTED).    @Z40LB61*/
*/*                                                          @Z40LB61*/
*/*            THIS ROUTINE ALSO INITIALLY READS THE MSC     @Z40LB61*/
*/*            CONFIGURATION INDEX AND MSC VIRTUAL VOLUME    @Z40LB61*/
*/*            ADDRESS TABLE INTO IN-STORAGE LOCATIONS       @Z40LB61*/
*/*            IN PREPARATION FOR SUBSEQUENT CHECKING.       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) MSC CONFIGURATION INDEX                       @Z40LB61*/
*/*        (2) MSC VIRTUAL VOLUME ADDRESS TABLE              @Z40LB61*/
*/*        (3) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  0385
*   /*****************************************************************/
*   /*                                                               */
*   /* IF INTERNAL MSC TABLE CHECKING WAS REQUESTED,         @Z40LB61*/
*   /* COMPARE THE MSC CELL MAP AGAINST RELATED TABLES.      @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0385
*   IF MSCCHK=ON THEN                                              0385
         L     @15,@PC00001+4                                      0385
         TM    MSCCHK(@15),B'10000000'                             0385
         BNO   @RF00385                                            0385
*     DO;                           /*                       @Z40LB61*/
*       CALL CELLMAP;               /*                       @Z40LB61*/
         BAL   @14,CELLMAP                                         0387
*       IF LASTCOND^=0 THEN                                        0388
         L     @15,@PC00001+8                                      0388
         ICM   @14,3,LASTCOND(@15)                                 0388
         BNZ   @RT00388                                            0388
*         RETURN;                   /*                       @Z40LB61*/
*                                                                  0389
*       /*************************************************************/
*       /*                                                           */
*       /* OBTAIN THE CONFIGURATION INDEX AND MOVE IT TO WHERE       */
*       /*                                                   @Z40LB61*/
*       /* IT WILL RESIDE IN STORAGE DURING SUBSEQUENT CHECKING      */
*       /*                                                   @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0390
*       TABLEID=CFGTBLID;           /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0390
         L     @14,EARGPTR(,@15)                                   0390
         MVC   TABLEID(1,@14),CFGTBLID                             0390
*       CIFLAG=ON;                  /*                       @Z40LB61*/
         OI    CIFLAG(@14),B'00001000'                             0391
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB61*/
         L     @14,@PC00001                                        0392
         ST    @14,@AL00001                                        0392
         ST    @15,@AL00001+4                                      0392
         L     @15,@CV01494                                        0392
         LA    @01,@AL00001                                        0392
         BALR  @14,@15                                             0392
*       IF GETRC^=0 THEN                                           0393
         L     @15,@PC00001+4                                      0393
         L     @01,EARGPTR(,@15)                                   0393
         ICM   @00,3,GETRC(@01)                                    0393
         BZ    @RF00393                                            0393
*         DO;                       /*                       @Z40LB61*/
*           LASTCOND=LASTCC12;      /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      0395
         MVC   LASTCOND(2,@15),@CH00567                            0395
*           RETURN;                 /*                       @Z40LB61*/
@EL00001 L     @13,4(,@13)                                         0396
@EF00001 L     @00,@SIZDATD                                        0396
         LR    @01,@11                                             0396
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0396
         BR    @14                                                 0396
*         END;                      /*                       @Z40LB61*/
*       CIADDR->MOVEAREA(1:MICOFFST)=TBLADDR->MOVEAREA(1:MICOFFST);/*
*                                                            @Z40LB61*/
@RF00393 L     @15,@PC00001+4                                      0398
         L     @14,CIADDR(,@15)                                    0398
         L     @15,EARGPTR(,@15)                                   0398
         L     @01,TBLADDR(,@15)                                   0398
         MVC   MOVEAREA(128,@14),MOVEAREA(@01)                     0398
*       CIENTPTR=CIADDR;            /*                       @Z40LB61*/
         ST    @14,CIENTPTR                                        0399
*       CICHR=PREVCHR;              /*                       @Z40LB61*/
         MVC   CICHR(5),PREVCHR(@15)                               0400
*     END;                          /*                       @Z40LB61*/
*                                                                  0401
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN THE VIRTUAL VOLUME ADDRESS TABLE AND MOVE IT   @Z40LB61*/
*   /* TO WHERE IT WILL RESIDE IN STORAGE DURING SUBSEQUENT  @Z40LB61*/
*   /* CHECKING.                                             @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0402
*   TABLEID=VVATBLID;               /*                       @Z40LB61*/
@RF00385 L     @15,@PC00001+4                                      0402
         L     @14,EARGPTR(,@15)                                   0402
         MVC   TABLEID(1,@14),VVATBLID                             0402
*   TBLADDR=NULLPTR;                /*                       @Z40LB61*/
         SLR   @05,@05                                             0403
         ST    @05,TBLADDR(,@14)                                   0403
*   MOVEPTR=VVATADDR;               /*                       @Z40LB61*/
         MVC   MOVEPTR(4),VVATADDR(@15)                            0404
*   DO TBLBLK#=1 TO RECSVVAT;       /*                       @Z40LB61*/
         LA    @15,1                                               0405
         STH   @15,TBLBLK#                                         0405
@DL00405 DS    0H                                                  0406
*     GETNEXT=ON;                   /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0406
         L     @01,EARGPTR(,@15)                                   0406
         OI    GETNEXT(@01),B'10000000'                            0406
*     CALL IDCCH03(GDTTBL,CDALIST); /*                       @Z40LB61*/
         L     @14,@PC00001                                        0407
         ST    @14,@AL00001                                        0407
         ST    @15,@AL00001+4                                      0407
         L     @15,@CV01494                                        0407
         LA    @01,@AL00001                                        0407
         BALR  @14,@15                                             0407
*     IF GETRC^=0 THEN                                             0408
         L     @15,@PC00001+4                                      0408
         L     @01,EARGPTR(,@15)                                   0408
         ICM   @00,3,GETRC(@01)                                    0408
         BZ    @RF00408                                            0408
*       DO;                         /*                       @Z40LB61*/
*         LASTCOND=LASTCC12;        /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      0410
         MVC   LASTCOND(2,@15),@CH00567                            0410
*         RETURN;                   /*                       @Z40LB61*/
         B     @EL00001                                            0411
*       END;                        /*                       @Z40LB61*/
*     MOVEAREA(1:SECTRLEN)=TBLADDR->MOVEAREA(1:SECTRLEN);/*  @Z40LB61*/
@RF00408 L     @15,MOVEPTR                                         0413
         L     @14,@PC00001+4                                      0413
         L     @14,EARGPTR(,@14)                                   0413
         L     @01,TBLADDR(,@14)                                   0413
         MVC   MOVEAREA(256,@15),MOVEAREA(@01)                     0413
*     MOVEPTR=MOVEPTR+SECTRLEN;     /*                       @Z40LB61*/
         AH    @15,@CH00606                                        0414
         ST    @15,MOVEPTR                                         0414
*     VVATCHR(TBLBLK#)=PREVCHR;     /*                       @Z40LB61*/
         LH    @15,TBLBLK#                                         0415
         LR    @05,@15                                             0415
         MH    @05,@CH00290                                        0415
         LA    @04,VVATCHR-5(@05)                                  0415
         MVC   0(5,@04),PREVCHR(@14)                               0415
*   END;                            /*                       @Z40LB61*/
*                                                                  0416
         AH    @15,@CH00223                                        0416
         STH   @15,TBLBLK#                                         0416
         CH    @15,@CH00157                                        0416
         BNH   @DL00405                                            0416
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK EACH MOUNTED VOLUME TABLE ENTRY AGAINST         @Z40LB61*/
*   /* CORRESPONDING INFORMATION IN RELATED MSC AND SA       @Z40LB61*/
*   /* TABLES                                                @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0417
*   CALL MVTLOOP;                   /*                       @Z40LB61*/
         BAL   @14,MVTLOOP                                         0417
*   IF LASTCOND^=0 THEN                                            0418
         L     @15,@PC00001+8                                      0418
         ICM   @14,3,LASTCOND(@15)                                 0418
         BNZ   @RT00418                                            0418
*     RETURN;                       /*                       @Z40LB61*/
*                                                                  0419
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN SELECTED TABLES, CHECKING FOR CONSISTENCY AND    @Z40LB61*/
*   /* CHECKING THAT ACCUMULATED SUMS OF VALUES MATCH THE    @Z40LB61*/
*   /* CORRESPONDING TOTALS KEPT FOR THOSE VALUES.           @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0420
*   CALL SCANSUMS;                  /*                       @Z40LB61*/
         BAL   @14,SCANSUMS                                        0420
*   IF LASTCOND^=0 THEN                                            0421
         L     @15,@PC00001+8                                      0421
         ICM   @14,3,LASTCOND(@15)                                 0421
         BNZ   @RT00421                                            0421
*     RETURN;                       /*                       @Z40LB61*/
*                                                                  0422
*   /*****************************************************************/
*   /*                                                               */
*   /* RESCAN SELECTED MSC AND SA TABLES, CHECKING THAT ALL  @Z40LB61*/
*   /* VALID TABLE ENTRIES HAVE BEEN REFERENCED BY RELATED   @Z40LB61*/
*   /* MSC TABLES.                                           @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0423
*   CALL RESCAN;                    /*                       @Z40LB61*/
         BAL   @14,RESCAN                                          0423
*                                                                  0424
*/*  ******************************************************* @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*   PROCEDURE NAME - CELLMAP                               @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*   FUNCTION - COMPARES THE MSC VOLUME INVENTORY,          @Z40LB64*/
*/*              TRANSIENT VOLUME LIST, AND SCRATCH          @Z40LB64*/
*/*              CARTRIDGE LIST ENTRIES AGAINST THE CELL     @Z40LB64*/
*/*              MAP.                                        @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*              THE CELL MAP FOR EACH VALID MSF IS READ     @Z40LB64*/
*/*              INTO STORAGE FROM THE WORK DATA SET.        @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*              ALL MSC VOLUME INVENTORY ENTRIES, FOLLOWED  @Z40LB64*/
*/*              BY ALL MSC TRANSIENT VOLUME LIST ENTRIES,   @Z40LB64*/
*/*              AND FINALLY ALL MSC SCRATCH CARTRIDGE LIST  @Z40LB64*/
*/*              ENTRIES RE OBTAINED INDIVIDUALLY VIA THE    @Z40LB64*/
*/*              'IDCCH03' PROCEDURE, AND THE SEQUENCE #1    @Z40LB64*/
*/*              AND SEQUENCE #2 CELL LOCATIONS ARE CHECKED  @Z40LB64*/
*/*              FOR VALIDITY IN THE CELL MAP.               @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*              IF THE CELL MAP INDICIATES THAT A           @Z40LB64*/
*/*              PARTICULAR CELL LOCATIONS IS INVALID,       @Z40LB64*/
*/*              EMPTY, OR MULTIPLY REFERENCED, AN ERROR     @Z40LB64*/
*/*              MESSAGE IS PRINTED.                         @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*              WHEN ALL VI, TVL, AND SCL ENTRIES HAVE      @Z40LB64*/
*/*              BEEN COMPARED AGAINST THE CELL MAP, ALL     @Z40LB64*/
*/*              CELL LOCATIONS THAT ARE VALID AND FULL      @Z40LB64*/
*/*              SHOULD HAVE BEEN ACCOUNTED FOR.             @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*   INPUT - (1) THE MSC CELL MAP FOR EACH VALID MSF        @Z40LB64*/
*/*               (INCLUDING THE ORIGINAL STATE CELL MAP     @Z40LB64*/
*/*               DISTINQUISHING VALID/INVALID LOCATIONS)    @Z40LB64*/
*/*           (2) THE MSC VOLUME INVENTORY                   @Z40LB64*/
*/*           (3) THE MSC TRANSIENT VOLUME LIST              @Z40LB64*/
*/*           (4) THE MSC SCRATCH CARTRIDGE LIST             @Z40LB64*/
*/*                                                          @Z40LB64*/
*/*   OUTPUT -                                               @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB64*/
*/*  *****************************************************************/
*                                                                  0424
*CELLMAP:                                                          0424
*   PROCEDURE;                      /*                       @Z40LB64*/
         B     @PB00002                                            0424
CELLMAP  STM   @14,@12,@SA00002                                    0424
*   OLDERID2=NEWERID2;                                             0425
         L     @15,@PC00001                                        0425
         L     @15,GDTTR2(,@15)                                    0425
         MVC   @TS00001(95),NEWERID2(@15)                          0425
         MVC   OLDERID2(95,@15),@TS00001                           0425
*   NEWID2='CH2A';                  /*                       @Z40LB61*/
*                                                                  0426
         MVC   NEWID2(4,@15),@CC01503                              0426
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE THE LOW X-VALUE FOR EACH VALID MSF BY       @Z40LB64*/
*   /* SCANNING THE CELL MAP CONTROL BLOCK OF EACH MSF       @Z40LB64*/
*   /* UNTIL A CUBE ADDRESS OF 'FF'X IS FOUND.               @Z40LB64*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0427
*LOWXLOOP:                                                         0427
*   DO MSF#=1 TO MSFVLCNT;          /*                       @Z40LB64*/
*                                                                  0427
LOWXLOOP LA    @15,1                                               0427
         B     @DE00427                                            0427
@DL00427 DS    0H                                                  0428
*     /***************************************************************/
*     /*                                                             */
*     /* READ THE CELL MAP CONTROL BLOCK FOR EACH            @Z40LB64*/
*     /* VALID MSF.                                          @Z40LB64*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0428
*     TABLEID=CMTBLID;              /*                       @Z40LB64*/
         L     @14,@PC00001+4                                      0428
         L     @05,EARGPTR(,@14)                                   0428
         MVC   TABLEID(1,@05),CMTBLID                              0428
*     CELLBLK=(BLKSMSF+1)*VLDMSFID(MSF#)+1;/*                @Z40LB64*/
         ALR   @15,@15                                             0429
         LH    @04,VLDMSFID-2(@15,@14)                             0429
         MH    @04,@CH00290                                        0429
         AH    @04,@CH00223                                        0429
         STH   @04,CELLBLK(,@05)                                   0429
*     CALL IDCCH03(GDTTBL,CDALIST); /*                       @Z40LB64*/
         L     @15,@PC00001                                        0430
         ST    @15,@AL00001                                        0430
         ST    @14,@AL00001+4                                      0430
         L     @15,@CV01494                                        0430
         LA    @01,@AL00001                                        0430
         BALR  @14,@15                                             0430
*     IF GETRC=0 THEN                                              0431
         L     @15,@PC00001+4                                      0431
         L     @15,EARGPTR(,@15)                                   0431
         ICM   @14,3,GETRC(@15)                                    0431
         BNZ   @RF00431                                            0431
*       DO;                         /*                       @Z40LB64*/
*                                                                  0432
*         /***********************************************************/
*         /*                                                         */
*         /* DETERMINE THE LOW X VALUE FOR THIS MSF          @Z40LB64*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0433
*         CMCBPTR=TBLADDR;          /*                       @Z40LB64*/
         MVC   CMCBPTR(4),TBLADDR(@15)                             0433
*         CUBE#=1;                  /*                       @Z40LB64*/
         MVC   CUBE#(2),@CH00223                                   0434
*         ENDFLAG=OFF;              /*                       @Z40LB64*/
         NI    ENDFLAG,B'01111111'                                 0435
*         DO WHILE ENDFLAG=OFF;     /*                       @Z40LB64*/
         B     @DE00436                                            0436
@DL00436 DS    0H                                                  0437
*           IF CMCPTRS(CUBE#)=LASTCUBE THEN                        0437
         LH    @15,CUBE#                                           0437
         L     @01,CMCBPTR                                         0437
         SLR   @14,@14                                             0437
         IC    @14,CMCPTRS-1(@15,@01)                              0437
         SLR   @05,@05                                             0437
         IC    @05,LASTCUBE                                        0437
         CR    @14,@05                                             0437
         BNE   @RF00437                                            0437
*             DO;                   /*                       @Z40LB64*/
*                                                                  0438
*               /*****************************************************/
*               /*                                                   */
*               /* THE END OF THE CUBE ADDRESSES IN THE      @Z40LB64*/
*               /* CELL MAP CONTROL BLOCK HAS BEEN FOUND.    @Z40LB64*/
*               /* THE LOW X VALUE IS CALCULATED BY THE      @Z40LB64*/
*               /* FOLLOWING FORMULA: X = MAXIMUM RELATIVE X @Z40LB64*/
*               /* - (NUMBER OF CUBE PTRS/NUMBER OF CUBE     @Z40LB64*/
*               /* PTRS PER CHUNK) * RANGE OF X PER CHUNK) - @Z40LB64*/
*               /* RANGE OF X PER CHUNK/2. THE LATTER        @Z40LB64*/
*               /* SUBTRACTION ACCOUNTS FOR THE FACT THAT    @Z40LB64*/
*               /* THE LAST CHUNK IS ONLY HALF FULL.         @Z40LB64*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0439
*               MSFXLOW(MSF#)=MSFXMAX-(((CUBE#/CUBESCNK)*XRNGCNK)- 0439
*                   XRNGCNK/2);     /*                       @Z40LB64*/
         LH    @14,MSF#                                            0439
         ALR   @14,@14                                             0439
         LR    @00,@15                                             0439
         SRDA  @00,32                                              0439
         D     @00,@CF00769                                        0439
         SLA   @01,2                                               0439
         LCR   @01,@01                                             0439
         AH    @01,@CH00157                                        0439
         AH    @01,@CH01472                                        0439
         STH   @01,MSFXLOW-2(@14)                                  0439
*               ENDFLAG=ON;         /*                       @Z40LB64*/
         OI    ENDFLAG,B'10000000'                                 0440
*             END;                  /*                       @Z40LB64*/
*           ELSE                                                   0442
*             CUBE#=CUBE#+1;        /*                       @Z40LB64*/
         B     @RC00437                                            0442
@RF00437 LA    @15,1                                               0442
         AH    @15,CUBE#                                           0442
         STH   @15,CUBE#                                           0442
*         END;                      /*                       @Z40LB64*/
@RC00437 DS    0H                                                  0443
@DE00436 TM    ENDFLAG,B'10000000'                                 0443
         BZ    @DL00436                                            0443
*       END;                        /*                       @Z40LB64*/
*     IF GETRC=TABLERR THEN                                        0445
@RF00431 LA    @15,12                                              0445
         L     @14,@PC00001+4                                      0445
         L     @01,EARGPTR(,@14)                                   0445
         CH    @15,GETRC(,@01)                                     0445
         BNE   @RF00445                                            0445
*       DO;                         /*                       @Z40LB64*/
*                                                                  0446
*         /***********************************************************/
*         /*                                                         */
*         /* AN ERROR WAS ENCOUNTERED WHILE TRYING           @Z40LB64*/
*         /* TO OBTAIN A CELL MAP CONTROL BLOCK.             @Z40LB64*/
*         /* TERMINATE CHECKMSS PROCESSING.                  @Z40LB64*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0447
*         LASTCOND=LASTCC12;        /*                       @Z40LB64*/
         L     @14,@PC00001+8                                      0447
         STH   @15,LASTCOND(,@14)                                  0447
*         RETURN;                   /*                       @Z40LB64*/
@EL00002 DS    0H                                                  0448
@EF00002 DS    0H                                                  0448
@ER00002 LM    @14,@12,@SA00002                                    0448
         BR    @14                                                 0448
*       END;                        /*                       @Z40LB64*/
*   END LOWXLOOP;                   /*                       @Z40LB64*/
*                                                                  0450
@RF00445 LA    @15,1                                               0450
         AH    @15,MSF#                                            0450
@DE00427 STH   @15,MSF#                                            0450
         L     @14,@PC00001+4                                      0450
         CH    @15,MSFVLCNT(,@14)                                  0450
         BNH   @DL00427                                            0450
*   /*****************************************************************/
*   /*                                                               */
*   /* READ THE CELL MAP DATA BLOCKS FOR EACH VALID MSF      @Z40LB64*/
*   /* AND THE ORGINAL STATE CELL MAP INTO THE CELL MAP      @Z40LB64*/
*   /* BUFFERS.                                              @Z40LB64*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0451
*CMREAD:                                                           0451
*   DO MSF#=1 TO MSFVLCNT+1;        /*                       @Z40LB64*/
*                                                                  0451
CMREAD   LA    @15,1                                               0451
         B     @DE00451                                            0451
@DL00451 DS    0H                                                  0452
*     /***************************************************************/
*     /*                                                             */
*     /* READ EACH CELL MAP ONE BLOCK AT A TIME              @Z40LB64*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0452
*BLKREAD:                                                          0452
*     DO CMBLK#=1 TO BLKSMSF;       /*                       @Z40LB64*/
BLKREAD  LA    @15,1                                               0452
         STH   @15,CMBLK#                                          0452
@DL00452 DS    0H                                                  0453
*       TABLEID=CMTBLID;            /*                       @Z40LB64*/
         L     @14,@PC00001+4                                      0453
         L     @05,EARGPTR(,@14)                                   0453
         MVC   TABLEID(1,@05),CMTBLID                              0453
*       IF MSF#<=MSFVLCNT THEN                                     0454
         LH    @04,MSF#                                            0454
         CH    @04,MSFVLCNT(,@14)                                  0454
         BH    @RF00454                                            0454
*         CELLBLK=((BLKSMSF+1)*VLDMSFID(MSF#))+CMBLK#+1;/*   @Z40LB64*/
         ALR   @04,@04                                             0455
         LH    @14,VLDMSFID-2(@04,@14)                             0455
         MH    @14,@CH00290                                        0455
         ALR   @14,@15                                             0455
         AH    @14,@CH00223                                        0455
         STH   @14,CELLBLK(,@05)                                   0455
*       ELSE                                                       0456
*         CELLBLK=ORGCMBLK+CMBLK#-1;/*                       @Z40LB64*/
         B     @RC00454                                            0456
@RF00454 L     @15,@PC00001+4                                      0456
         L     @01,EARGPTR(,@15)                                   0456
         LH    @00,CMBLK#                                          0456
         SH    @00,@CH01723                                        0456
         STH   @00,CELLBLK(,@01)                                   0456
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB64*/
@RC00454 L     @15,@PC00001                                        0457
         ST    @15,@AL00001                                        0457
         L     @15,@PC00001+4                                      0457
         ST    @15,@AL00001+4                                      0457
         L     @15,@CV01494                                        0457
         LA    @01,@AL00001                                        0457
         BALR  @14,@15                                             0457
*       IF GETRC=0 THEN                                            0458
         L     @15,@PC00001+4                                      0458
         L     @14,EARGPTR(,@15)                                   0458
         ICM   @05,3,GETRC(@14)                                    0458
         BNZ   @RF00458                                            0458
*         DO;                       /*                       @Z40LB64*/
*                                                                  0459
*           /*********************************************************/
*           /*                                                       */
*           /* CELL MAP BLOCK SUCCESSFULLY OBTAINED.         @Z40LB64*/
*           /* MOVE THE CELL MAP BLOCK FROM THE I/O          @Z40LB64*/
*           /* BUFFER INTO THE CELL MAP BUFFER, SAVE         @Z40LB64*/
*           /* THE CCHHR INFORMATION, AND ZERO THE           @Z40LB64*/
*           /* CORRESPONDING CHECK-OFF TABLE BLOCK.          @Z40LB64*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0460
*           CMBLOCK=TBLADDR->MOVEAREA(1:LENGTH(CMBLOCK));/*  @Z40LB64*/
         LH    @05,MSF#                                            0460
         LR    @04,@05                                             0460
         SLA   @04,2                                               0460
         AH    @04,CMBLK#                                          0460
         LR    @03,@04                                             0460
         SLA   @03,2                                               0460
         L     @01,CMBUFPTR-20(@03,@15)                            0460
         L     @02,TBLADDR(,@14)                                   0460
         MVC   CMBLOCK(256,@01),MOVEAREA(@02)                      0460
*           CMCHR(MSF#,CMBLK#)=PREVCHR;/*                    @Z40LB64*/
         MH    @04,@CH00290                                        0461
         LA    @01,CMCHR-25(@04)                                   0461
         MVC   0(5,@01),PREVCHR(@14)                               0461
*           IF MSF#<=MSFVLCNT THEN                                 0462
         CH    @05,MSFVLCNT(,@15)                                  0462
         BH    @RF00462                                            0462
*             CMCOBLK=''B;          /*                       @Z40LB64*/
         L     @01,CMCOPTR-20(@03,@15)                             0463
         XC    CMCOBLK(256,@01),CMCOBLK(@01)                       0463
*         END;                      /*                       @Z40LB64*/
@RF00462 DS    0H                                                  0465
*       IF GETRC=TABLERR THEN                                      0465
@RF00458 LA    @15,12                                              0465
         L     @14,@PC00001+4                                      0465
         L     @01,EARGPTR(,@14)                                   0465
         CH    @15,GETRC(,@01)                                     0465
         BNE   @RF00465                                            0465
*         DO;                       /*                       @Z40LB64*/
*                                                                  0466
*           /*********************************************************/
*           /*                                                       */
*           /* AN ERROR WAS ENCOUNTERED WHILE TRYING TO      @Z40LB64*/
*           /* OBTAIN A CELL MAP BLOCK. TERMINATE            @Z40LB64*/
*           /* CHECKMSS PROCESSING.                          @Z40LB64*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0467
*           LASTCOND=LASTCC12;      /*                       @Z40LB64*/
         L     @14,@PC00001+8                                      0467
         STH   @15,LASTCOND(,@14)                                  0467
*           RETURN;                 /*                       @Z40LB64*/
         B     @EL00002                                            0468
*         END;                      /*                       @Z40LB64*/
*     END BLKREAD;                  /*                       @Z40LB64*/
@RF00465 LA    @15,1                                               0470
         AH    @15,CMBLK#                                          0470
         STH   @15,CMBLK#                                          0470
         CH    @15,@CH00046                                        0470
         BNH   @DL00452                                            0470
*   END CMREAD;                     /*                       @Z40LB64*/
*                                                                  0471
         LA    @15,1                                               0471
         AH    @15,MSF#                                            0471
@DE00451 STH   @15,MSF#                                            0471
         L     @14,@PC00001+4                                      0471
         LA    @05,1                                               0471
         AH    @05,MSFVLCNT(,@14)                                  0471
         CR    @15,@05                                             0471
         BNH   @DL00451                                            0471
*   /*****************************************************************/
*   /*                                                               */
*   /* READ EACH MSC VOLUME INVENTORY ENTRY, THEN EACH       @Z40LB64*/
*   /* MSC TRANSIENT VOLUME LIST ENTRY, AND FINALLY EACH     @Z40LB64*/
*   /* SCRATCH CARTRIDGE LIST ENTRY FOR COMPARISON WITH      @Z40LB64*/
*   /* THE CELL MAP.                                         @Z40LB64*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0472
*   SCLMSF#=1;                      /*                       @Z40LB64*/
         MVC   SCLMSF#(2),@CH00223                                 0472
*MSCTBLS:                                                          0473
*   DO MSCTBL=1 TO MSCTYPES;        /*                       @Z40LB64*/
MSCTBLS  LA    @15,1                                               0473
         STH   @15,MSCTBL                                          0473
@DL00473 DS    0H                                                  0474
*     ENDFLAG=OFF;                  /*                       @Z40LB64*/
         NI    ENDFLAG,B'01111111'                                 0474
*     TBLADDR=0;                    /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      0475
         L     @01,EARGPTR(,@15)                                   0475
         SLR   @00,@00                                             0475
         ST    @00,TBLADDR(,@01)                                   0475
*TBLREAD:                                                          0476
*     DO WHILE ENDFLAG=OFF;         /*                       @Z40LB64*/
TBLREAD  B     @DE00476                                            0476
@DL00476 DS    0H                                                  0477
*       GETNEXT=ON;                 /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      0477
         L     @15,EARGPTR(,@15)                                   0477
         OI    GETNEXT(@15),B'10000000'                            0477
*       IF MSCTBL=VITYPE THEN                                      0478
         CLC   MSCTBL(2),@CH00223                                  0478
         BNE   @RF00478                                            0478
*         TABLEID=VITBLID;          /*                       @Z40LB64*/
         MVC   TABLEID(1,@15),VITBLID                              0479
*       IF MSCTBL=TVLTYPE THEN                                     0480
@RF00478 CLC   MSCTBL(2),@CH00157                                  0480
         BNE   @RF00480                                            0480
*         TABLEID=TVLTBLID;         /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      0481
         L     @01,EARGPTR(,@15)                                   0481
         MVC   TABLEID(1,@01),TVLTBLID                             0481
*       IF MSCTBL=SCLTYPE THEN                                     0482
@RF00480 CLC   MSCTBL(2),@CH00166                                  0482
         BNE   @RF00482                                            0482
*         DO;                       /*                       @Z40LB64*/
*           TABLEID=SCLTBLID;       /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      0484
         L     @14,EARGPTR(,@15)                                   0484
         MVC   TABLEID(1,@14),SCLTBLID                             0484
*           MSFID=VLDMSFID(SCLMSF#);/*                       @Z40LB64*/
         LH    @05,SCLMSF#                                         0485
         ALR   @05,@05                                             0485
         LH    @15,VLDMSFID-2(@05,@15)                             0485
         STH   @15,MSFID(,@14)                                     0485
*         END;                      /*                       @Z40LB64*/
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB64*/
@RF00482 L     @15,@PC00001                                        0487
         ST    @15,@AL00001                                        0487
         L     @15,@PC00001+4                                      0487
         ST    @15,@AL00001+4                                      0487
         L     @15,@CV01494                                        0487
         LA    @01,@AL00001                                        0487
         BALR  @14,@15                                             0487
*       IF GETRC=0 THEN                                            0488
         L     @15,@PC00001+4                                      0488
         L     @01,EARGPTR(,@15)                                   0488
         ICM   @00,3,GETRC(@01)                                    0488
         BNZ   @RF00488                                            0488
*CMCHK:                                                            0489
*         DO;                       /*                       @Z40LB64*/
*                                                                  0489
CMCHK    DS    0H                                                  0490
*           /*********************************************************/
*           /*                                                       */
*           /* MSC TABLE (VI, TVL, OR SCL) ENTRY WAS         @Z40LB64*/
*           /* SUCCESSFULLY OBTAINED.                        @Z40LB64*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0490
*           IF MSCTBL=VITYPE THEN                                  0490
         CLC   MSCTBL(2),@CH00223                                  0490
         BNE   @RF00490                                            0490
*             VIENTPTR=TBLADDR;     /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      0491
         L     @01,EARGPTR(,@15)                                   0491
         MVC   VIENTPTR(4),TBLADDR(@01)                            0491
*           IF MSCTBL=TVLTYPE THEN                                 0492
@RF00490 CLC   MSCTBL(2),@CH00157                                  0492
         BNE   @RF00492                                            0492
*             TVENTPTR=TBLADDR;     /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      0493
         L     @01,EARGPTR(,@15)                                   0493
         MVC   TVENTPTR(4),TBLADDR(@01)                            0493
*           IF MSCTBL=SCLTYPE THEN                                 0494
@RF00492 CLC   MSCTBL(2),@CH00166                                  0494
         BNE   @RF00494                                            0494
*             SCENTPTR=TBLADDR;     /*                       @Z40LB64*/
*                                                                  0495
         L     @15,@PC00001+4                                      0495
         L     @01,EARGPTR(,@15)                                   0495
         MVC   SCENTPTR(4),TBLADDR(@01)                            0495
*           /*********************************************************/
*           /*                                                       */
*           /* IF THE VOLUME INVENTORY AND TRANSIENT         @Z40LB64*/
*           /* VOLUME LIST TABLES WERE CHECKED-OFF           @Z40LB64*/
*           /* DURING MSVI VS. MSC TABLE CHECKING,           @Z40LB64*/
*           /* VERIFY THAT THE MSVI ACCOUNTED FOR ALL        @Z40LB64*/
*           /* VOLUME INVENTORY AND TRANSIENT VOLUME LIST    @Z40LB64*/
*           /* ENTRIES.                                      @Z40LB64*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0496
*           IF MSVICHK=ON THEN                                     0496
@RF00494 L     @15,@PC00001+4                                      0496
         TM    MSVICHK(@15),B'00100000'                            0496
         BNO   @RF00496                                            0496
*MSVICHKF:                                                         0497
*             DO;                   /*                       @Z40LB64*/
MSVICHKF DS    0H                                                  0498
*               IF MSCTBL=VITYPE THEN                              0498
         CLC   MSCTBL(2),@CH00223                                  0498
         BNE   @RF00498                                            0498
*                 DO;               /*                       @Z40LB64*/
*                                                                  0499
*                   /*************************************************/
*                   /*                                               */
*                   /* VERIFY THAT THE VOLUME                @Z40LB64*/
*                   /* INVENTORY ENTRY IS CHECKED-OFF        @Z40LB64*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  0500
*                   IF(VICHKFF(BYTE#)&BITMASK(BIT#))=0 THEN        0500
         L     @15,@PC00001+4                                      0500
         L     @14,EARGPTR(,@15)                                   0500
         LH    @01,BYTE#(,@14)                                     0500
         L     @05,VICOPTR(,@15)                                   0500
         LH    @04,BIT#(,@14)                                      0500
         AL    @05,@CF01340                                        0500
         SLR   @00,@00                                             0500
         IC    @00,VICHKFF(@01,@05)                                0500
         SLR   @05,@05                                             0500
         IC    @05,BITMASK-1(@04)                                  0500
         NR    @00,@05                                             0500
         LTR   @00,@00                                             0500
         BNZ   @RF00500                                            0500
*                     DO;           /*                       @Z40LB64*/
*                                                                  0501
*                       /*********************************************/
*                       /*                                           */
*                       /* VOLUME INVENTORY ENTRY            @Z40LB64*/
*                       /* WAS NOT CHECKED-OFF.              @Z40LB64*/
*                       /* PRINT ERROR MESSAGE.              @Z40LB64*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  0502
*                       MTCHMSG=ON; /*                       @Z40LB64*/
         L     @05,MARGPTR(,@15)                                   0502
         OI    MTCHMSG(@05),B'00010000'                            0502
*                       MSVITBL(1)=ON;/*                     @Z40LB64*/
         OI    MSVITBL(@05),B'00001000'                            0503
*                       VITBL(2)=ON;/*                       @Z40LB64*/
         OI    VITBL+4(@05),B'01000000'                            0504
*                       VSNFLD=ON;  /*                       @Z40LB64*/
         OI    VSNFLD(@05),B'00000001'                             0505
*                       FLDCHAR(1)=VIVOLID;/*                @Z40LB64*/
         MVI   FLDCHAR+6(@05),C' '                                 0506
         MVC   FLDCHAR+7(5,@05),FLDCHAR+6(@05)                     0506
         L     @04,VIENTPTR                                        0506
         MVC   FLDCHAR(6,@05),VIVOLID(@04)                         0506
*                       VSNINDEX(2)=VIVOLID;/*               @Z40LB64*/
         MVC   VSNINDEX+24(6,@05),VIVOLID(@04)                     0507
*                       CHRINDEX(2)=PREVCHR;/*               @Z40LB64*/
         MVC   CHRINDEX+24(5,@05),PREVCHR(@14)                     0508
*                       CALL IDCCH04(GDTTBL,CDALIST);              0509
         L     @14,@PC00001                                        0509
         ST    @14,@AL00001                                        0509
         ST    @15,@AL00001+4                                      0509
         L     @15,@CV01495                                        0509
         LA    @01,@AL00001                                        0509
         BALR  @14,@15                                             0509
*                     END;          /*                       @Z40LB64*/
*                 END;              /*                       @Z40LB64*/
@RF00500 DS    0H                                                  0512
*               IF MSCTBL=TVLTYPE THEN                             0512
@RF00498 CLC   MSCTBL(2),@CH00157                                  0512
         BNE   @RF00512                                            0512
*                 DO;               /*                       @Z40LB64*/
*                                                                  0513
*                   /*************************************************/
*                   /*                                               */
*                   /* VERIFY THAT THE TRANSIENT             @Z40LB64*/
*                   /* VOLUME LIST ENTRY IS                  @Z40LB64*/
*                   /* CHECKED-OFF.                          @Z40LB64*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  0514
*                   IF(TVLCHKFF(BYTE#)&BITMASK(BIT#))=0 THEN       0514
         L     @15,@PC00001+4                                      0514
         L     @14,EARGPTR(,@15)                                   0514
         LH    @01,BYTE#(,@14)                                     0514
         L     @05,TVLCOPTR(,@15)                                  0514
         LH    @04,BIT#(,@14)                                      0514
         AL    @05,@CF01340                                        0514
         SLR   @00,@00                                             0514
         IC    @00,TVLCHKFF(@01,@05)                               0514
         SLR   @05,@05                                             0514
         IC    @05,BITMASK-1(@04)                                  0514
         NR    @00,@05                                             0514
         LTR   @00,@00                                             0514
         BNZ   @RF00514                                            0514
*                     DO;           /*                       @Z40LB64*/
*                                                                  0515
*                       /*********************************************/
*                       /*                                           */
*                       /* TRANSIENT VOLUME LIST             @Z40LB64*/
*                       /* ENTRY WAS NOT CHECKED             @Z40LB64*/
*                       /* OFF. PRINT ERROR MESSAGE          @Z40LB64*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  0516
*                       MTCHMSG=ON; /*                       @Z40LB64*/
         L     @05,MARGPTR(,@15)                                   0516
         OI    MTCHMSG(@05),B'00010000'                            0516
*                       MSVITBL(1)=ON;/*                     @Z40LB64*/
         OI    MSVITBL(@05),B'00001000'                            0517
*                       TVLTBL(2)=ON;/*                      @Z40LB64*/
         OI    TVLTBL+4(@05),B'00100000'                           0518
*                       CSNFLD=ON;  /*                       @Z40LB64*/
         OI    CSNFLD(@05),B'10000000'                             0519
*                       FLDCHAR(1)=TVCSN;/*                  @Z40LB64*/
         L     @04,TVENTPTR                                        0520
         MVC   FLDCHAR(12,@05),TVCSN(@04)                          0520
*                       CSNINDEX(2)=TVCSN;/*                 @Z40LB64*/
         MVC   CSNINDEX+24(12,@05),TVCSN(@04)                      0521
*                       VSNINDEX(2)=TVVOLID;/*               @Z40LB64*/
         MVC   VSNINDEX+24(6,@05),TVVOLID(@04)                     0522
*                       CHRINDEX(2)=PREVCHR;/*               @Z40LB64*/
         MVC   CHRINDEX+24(5,@05),PREVCHR(@14)                     0523
*                       CALL IDCCH04(GDTTBL,CDALIST);              0524
         L     @14,@PC00001                                        0524
         ST    @14,@AL00001                                        0524
         ST    @15,@AL00001+4                                      0524
         L     @15,@CV01495                                        0524
         LA    @01,@AL00001                                        0524
         BALR  @14,@15                                             0524
*                     END;          /*                       @Z40LB64*/
*                 END;              /*                       @Z40LB64*/
@RF00514 DS    0H                                                  0527
*             END MSVICHKF;         /*                       @Z40LB64*/
*                                                                  0527
@RF00512 DS    0H                                                  0528
*           /*********************************************************/
*           /*                                                       */
*           /* FIND THE MATCHING CELL ADDRESSES IN THE       @Z40LB64*/
*           /* CELL MAP FOR THE SEQUENCE #1 AND SEQUENCE     @Z40LB64*/
*           /* #2 CARTRIDGES (EXCEPT FOR THE SCRATCH         @Z40LB64*/
*           /* CARTRIDGE LIST WHICH CONTAINS ONLY ONE        @Z40LB64*/
*           /* CARTRIDGE ADDRESS PER ENTRY).                 @Z40LB64*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0528
*CTGCHK:                                                           0528
*           DO CTGSEQ#=1 TO CTGSVOL;/*                       @Z40LB64*/
@RF00496 DS    0H                                                  0528
CTGCHK   LA    @15,1                                               0528
         STH   @15,CTGSEQ#                                         0528
@DL00528 DS    0H                                                  0529
*             ERRFLAG=OFF;          /*                       @Z40LB64*/
*                                                                  0529
         NI    ERRFLAG,B'01111111'                                 0529
*             /*******************************************************/
*             /*                                                     */
*             /* SEPARATE THE 'LZYX' ADDRESS INTO ITS        @Z40LB64*/
*             /* INDIVIDUAL L, X, Y, AND Z COMPONENTS.       @Z40LB64*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0530
*             IF MSCTBL=VITYPE THEN                                0530
         LA    @14,1                                               0530
         CH    @14,MSCTBL                                          0530
         BNE   @RF00530                                            0530
*               IF CTGSEQ#=1 THEN                                  0531
         CR    @15,@14                                             0531
         BNE   @RF00531                                            0531
*                 LZYXADDR=VILZYX1; /*                       @Z40LB64*/
         L     @01,VIENTPTR                                        0532
         MVC   LZYXADDR(2),VILZYX1(@01)                            0532
*               ELSE                                               0533
*                 LZYXADDR=VILZYX2; /*                       @Z40LB64*/
         B     @RC00531                                            0533
@RF00531 L     @01,VIENTPTR                                        0533
         MVC   LZYXADDR(2),VILZYX2(@01)                            0533
*             IF MSCTBL=TVLTYPE THEN                               0534
@RC00531 DS    0H                                                  0534
@RF00530 CLC   MSCTBL(2),@CH00157                                  0534
         BNE   @RF00534                                            0534
*               IF CTGSEQ#=1 THEN                                  0535
         CLC   CTGSEQ#(2),@CH00223                                 0535
         BNE   @RF00535                                            0535
*                 LZYXADDR=TVLZYX1; /*                       @Z40LB64*/
         L     @01,TVENTPTR                                        0536
         MVC   LZYXADDR(2),TVLZYX1(@01)                            0536
*               ELSE                                               0537
*                 LZYXADDR=TVLZYX2; /*                       @Z40LB64*/
         B     @RC00535                                            0537
@RF00535 L     @01,TVENTPTR                                        0537
         MVC   LZYXADDR(2),TVLZYX2(@01)                            0537
*             IF MSCTBL=SCLTYPE THEN                               0538
@RC00535 DS    0H                                                  0538
@RF00534 CLC   MSCTBL(2),@CH00166                                  0538
         BNE   @RF00538                                            0538
*               IF CTGSEQ#=1 THEN                                  0539
         CLC   CTGSEQ#(2),@CH00223                                 0539
         BNE   @RF00539                                            0539
*                 LZYXADDR=SCLZYX;  /*                       @Z40LB64*/
         L     @01,SCENTPTR                                        0540
         MVC   LZYXADDR(2),SCLZYX(@01)                             0540
*               ELSE                                               0541
*                 ERRFLAG=ON;       /*                       @Z40LB64*/
         B     @RC00539                                            0541
@RF00539 OI    ERRFLAG,B'10000000'                                 0541
*             MSFL#=LZYXADDR/LVALSHFT;/*                     @Z40LB64*/
@RC00539 DS    0H                                                  0542
@RF00538 SLR   @15,@15                                             0542
         ICM   @15,3,LZYXADDR                                      0542
         LR    @14,@15                                             0542
         SRL   @14,14                                              0542
         STH   @14,MSFL#                                           0542
*             MSFZ#=(LZYXADDR&ZVALMASK)/ZVALSHFT;/*          @Z40LB64*/
         SLR   @00,@00                                             0543
         ICM   @00,3,ZVALMASK                                      0543
         NR    @00,@15                                             0543
         SRL   @00,13                                              0543
         STH   @00,MSFZ#                                           0543
*             MSFY#=(LZYXADDR&YVALMASK)/YVALSHFT;/*          @Z40LB64*/
         SLR   @02,@02                                             0544
         ICM   @02,3,YVALMASK                                      0544
         NR    @02,@15                                             0544
         SRL   @02,8                                               0544
         STH   @02,MSFY#                                           0544
*             MSFX#=(LZYXADDR&XVALMASK);/*                   @Z40LB64*/
*                                                                  0545
         SLR   @14,@14                                             0545
         ICM   @14,3,XVALMASK                                      0545
         NR    @15,@14                                             0545
         STH   @15,MSFX#                                           0545
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE L-VALUE DOES NOT SPECIFY A           @Z40LB64*/
*             /* VALID MSF, PRINT AN ERROR                   @Z40LB61*/
*             /* MESSAGE. NO COMPARISON TO THE CELL MAP      @Z40LB64*/
*             /* IS POSSIBLE.                                @Z40LB64*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0546
*             MSFFLAG=OFF;          /*                       @Z40LB64*/
         NI    MSFFLAG,B'01111111'                                 0546
*             DO MSF#=1 TO MSFVLCNT WHILE MSFFLAG=OFF;/*     @Z40LB64*/
         LA    @02,1                                               0547
         B     @DE00547                                            0547
@DL00547 TM    MSFFLAG,B'10000000'                                 0547
         BNZ   @DC00547                                            0547
*               IF MSFL#=VLDMSFID(MSF#) THEN                       0548
         ALR   @02,@02                                             0548
         L     @15,@PC00001+4                                      0548
         LH    @14,MSFL#                                           0548
         CH    @14,VLDMSFID-2(@02,@15)                             0548
         BNE   @RF00548                                            0548
*                 MSFFLAG=ON;       /*                       @Z40LB64*/
         OI    MSFFLAG,B'10000000'                                 0549
*             END;                  /*                       @Z40LB64*/
@RF00548 LA    @02,1                                               0550
         AH    @02,MSF#                                            0550
@DE00547 STH   @02,MSF#                                            0550
         L     @15,@PC00001+4                                      0550
         CH    @02,MSFVLCNT(,@15)                                  0550
         BNH   @DL00547                                            0550
@DC00547 DS    0H                                                  0551
*             IF MSFFLAG=OFF&ERRFLAG=OFF THEN                      0551
         TM    MSFFLAG,B'10000000'                                 0551
         BNZ   @RF00551                                            0551
         TM    ERRFLAG,B'10000000'                                 0551
         BNZ   @RF00551                                            0551
*               DO;                 /*                       @Z40LB64*/
*                 MTCHMSG=ON;       /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0553
         L     @02,MARGPTR(,@02)                                   0553
         OI    MTCHMSG(@02),B'00010000'                            0553
*                 CMTBL(1)=ON;      /*                       @Z40LB64*/
         OI    CMTBL(@02),B'00000100'                              0554
*                 IF MSCTBL=VITYPE THEN                            0555
         CLC   MSCTBL(2),@CH00223                                  0555
         BNE   @RF00555                                            0555
*                   DO;             /*                       @Z40LB64*/
*                     VITBL(2)=ON;  /*                       @Z40LB64*/
         OI    VITBL+4(@02),B'01000000'                            0557
*                     VSNINDEX(2)=VIVOLID;/*                 @Z40LB64*/
         L     @15,VIENTPTR                                        0558
         MVC   VSNINDEX+24(6,@02),VIVOLID(@15)                     0558
*                   END;            /*                       @Z40LB64*/
*                 IF MSCTBL=TVLTYPE THEN                           0560
@RF00555 CLC   MSCTBL(2),@CH00157                                  0560
         BNE   @RF00560                                            0560
*                   DO;             /*                       @Z40LB64*/
*                     TVLTBL(2)=ON; /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0562
         L     @02,MARGPTR(,@02)                                   0562
         OI    TVLTBL+4(@02),B'00100000'                           0562
*                     CSNINDEX(2)=TVCSN;/*                   @Z40LB64*/
         L     @15,TVENTPTR                                        0563
         MVC   CSNINDEX+24(12,@02),TVCSN(@15)                      0563
*                     VSNINDEX(2)=TVVOLID;/*                 @Z40LB64*/
         MVC   VSNINDEX+24(6,@02),TVVOLID(@15)                     0564
*                   END;            /*                       @Z40LB64*/
*                 IF MSCTBL=SCLTYPE THEN                           0566
@RF00560 CLC   MSCTBL(2),@CH00166                                  0566
         BNE   @RF00566                                            0566
*                   DO;             /*                       @Z40LB64*/
*                     SCLTBL(2)=ON; /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0568
         L     @02,MARGPTR(,@02)                                   0568
         OI    SCLTBL+4(@02),B'00010000'                           0568
*                     CSNINDEX(2)=SCCSN;/*                   @Z40LB64*/
         L     @15,SCENTPTR                                        0569
         MVC   CSNINDEX+24(12,@02),SCCSN(@15)                      0569
*                     MSFINDEX(2)=MSFL#;/*                   @Z40LB64*/
         MVC   MSFINDEX+24(1,@02),MSFL#+1                          0570
*                   END;            /*                       @Z40LB64*/
*                 MSFFLD=ON;        /*                       @Z40LB64*/
@RF00566 L     @02,@PC00001+4                                      0572
         L     @15,MARGPTR(,@02)                                   0572
         OI    MSFFLD(@15),B'00000010'                             0572
*                 FLDNUM(1)=MSFL#;  /*                       @Z40LB64*/
         LH    @14,MSFL#                                           0573
         ST    @14,FLDNUM(,@15)                                    0573
*                 CHRINDEX(2)=PREVCHR;/*                     @Z40LB64*/
         L     @14,EARGPTR(,@02)                                   0574
         MVC   CHRINDEX+24(5,@15),PREVCHR(@14)                     0574
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @Z40LB64*/
         L     @00,@PC00001                                        0575
         LR    @15,@00                                             0575
         ST    @15,@AL00001                                        0575
         ST    @02,@AL00001+4                                      0575
         L     @15,@CV01495                                        0575
         LA    @01,@AL00001                                        0575
         BALR  @14,@15                                             0575
*                 ERRFLAG=ON;       /*                       @Z40LB64*/
         OI    ERRFLAG,B'10000000'                                 0576
*               END;                /*                       @Z40LB64*/
*             MSF#=MSF#-1;          /*                       @Z40LB64*/
*                                                                  0578
@RF00551 LH    @02,MSF#                                            0578
         BCTR  @02,0                                               0578
         STH   @02,MSF#                                            0578
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE X-VALUE OR Y-VALUE IF NOT WITHIN     @Z40LB64*/
*             /* THEIR ALLOWABLE RANGE, PRINT AN ERROR       @Z40LB64*/
*             /* MESSAGE. NO COMPARISON TO THE CELL MAP      @Z40LB64*/
*             /* IS POSSIBLE.                                @Z40LB64*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0579
*             IF((MSFX#<(MSFXLOW(MSF#)+MSFXSTRT))|(MSFX#>=MSFXSTRT+
*                 MSFXMAX)|(MSFY#>=MSFYMAX))&ERRFLAG=OFF THEN      0579
         LH    @15,MSFX#                                           0579
         ALR   @02,@02                                             0579
         LA    @14,150                                             0579
         AH    @14,MSFXLOW-2(@02)                                  0579
         CR    @15,@14                                             0579
         BL    @GL00002                                            0579
         CH    @15,@CH01726                                        0579
         BNL   @GL00002                                            0579
         LH    @02,MSFY#                                           0579
         CH    @02,@CH01474                                        0579
         BL    @RF00579                                            0579
@GL00002 TM    ERRFLAG,B'10000000'                                 0579
         BNZ   @RF00579                                            0579
*               DO;                 /*                       @Z40LB64*/
*                 MTCHMSG=ON;       /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0581
         L     @02,MARGPTR(,@02)                                   0581
         OI    MTCHMSG(@02),B'00010000'                            0581
*                 CMTBL(1)=ON;      /*                       @Z40LB64*/
         OI    CMTBL(@02),B'00000100'                              0582
*                 IF MSCTBL=VITYPE THEN                            0583
         CLC   MSCTBL(2),@CH00223                                  0583
         BNE   @RF00583                                            0583
*                   DO;             /*                       @Z40LB64*/
*                     VITBL(2)=ON;  /*                       @Z40LB64*/
         OI    VITBL+4(@02),B'01000000'                            0585
*                     VSNINDEX(2)=VIVOLID;/*                 @Z40LB64*/
         L     @15,VIENTPTR                                        0586
         MVC   VSNINDEX+24(6,@02),VIVOLID(@15)                     0586
*                   END;            /*                       @Z40LB64*/
*                 IF MSCTBL=TVLTYPE THEN                           0588
@RF00583 CLC   MSCTBL(2),@CH00157                                  0588
         BNE   @RF00588                                            0588
*                   DO;             /*                       @Z40LB64*/
*                     TVLTBL(2)=ON; /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0590
         L     @02,MARGPTR(,@02)                                   0590
         OI    TVLTBL+4(@02),B'00100000'                           0590
*                     CSNINDEX(2)=TVCSN;/*                   @Z40LB64*/
         L     @15,TVENTPTR                                        0591
         MVC   CSNINDEX+24(12,@02),TVCSN(@15)                      0591
*                     VSNINDEX(2)=TVVOLID;/*                 @Z40LB64*/
         MVC   VSNINDEX+24(6,@02),TVVOLID(@15)                     0592
*                   END;            /*                       @Z40LB64*/
*                 IF MSCTBL=SCLTYPE THEN                           0594
@RF00588 CLC   MSCTBL(2),@CH00166                                  0594
         BNE   @RF00594                                            0594
*                   DO;             /*                       @Z40LB64*/
*                     SCLTBL(2)=ON; /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0596
         L     @02,MARGPTR(,@02)                                   0596
         OI    SCLTBL+4(@02),B'00010000'                           0596
*                     CSNINDEX(2)=SCCSN;/*                   @Z40LB64*/
         L     @15,SCENTPTR                                        0597
         MVC   CSNINDEX+24(12,@02),SCCSN(@15)                      0597
*                     MSFINDEX(2)=MSFL#;/*                   @Z40LB64*/
         MVC   MSFINDEX+24(1,@02),MSFL#+1                          0598
*                   END;            /*                       @Z40LB64*/
*                 CAFLD=ON;         /*                       @Z40LB64*/
@RF00594 L     @02,@PC00001+4                                      0600
         L     @15,MARGPTR(,@02)                                   0600
         OI    CAFLD(@15),B'00010000'                              0600
*                 FLDNUM(1)=LZYXADDR;/*                      @Z40LB64*/
         SLR   @14,@14                                             0601
         ICM   @14,3,LZYXADDR                                      0601
         ST    @14,FLDNUM(,@15)                                    0601
*                 CHRINDEX(2)=PREVCHR;/*                     @Z40LB64*/
         L     @14,EARGPTR(,@02)                                   0602
         MVC   CHRINDEX+24(5,@15),PREVCHR(@14)                     0602
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @Z40LB64*/
         L     @00,@PC00001                                        0603
         LR    @15,@00                                             0603
         ST    @15,@AL00001                                        0603
         ST    @02,@AL00001+4                                      0603
         L     @15,@CV01495                                        0603
         LA    @01,@AL00001                                        0603
         BALR  @14,@15                                             0603
*                 ERRFLAG=ON;       /*                       @Z40LB64*/
         OI    ERRFLAG,B'10000000'                                 0604
*               END;                /*                       @Z40LB64*/
*                                                                  0605
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE CARTRIDGE ADDRESS IS WITHIN THE      @Z40LB64*/
*             /* ALLOWABLE RANGE, DETERMINE THE CELL MAP     @Z40LB64*/
*             /* MSF, BLOCK, CHUNK, AND CUBE OF THE          @Z40LB64*/
*             /* CARTRIDGE ADDRESS.                          @Z40LB64*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0606
*             IF ERRFLAG=OFF THEN                                  0606
@RF00579 TM    ERRFLAG,B'10000000'                                 0606
         BNZ   @RF00606                                            0606
*LZYXOKAY:                                                         0607
*               DO;                 /*                       @Z40LB64*/
LZYXOKAY DS    0H                                                  0608
*                 CMBLK#=(MSFX#-MSFXSTRT)/XRNGBLK+1;/*       @Z40LB64*/
         LA    @02,1                                               0608
         LH    @15,MSFX#                                           0608
         SH    @15,@CH01476                                        0608
         LR    @04,@15                                             0608
         SRDA  @04,32                                              0608
         D     @04,@CF00225                                        0608
         ALR   @05,@02                                             0608
         STH   @05,CMBLK#                                          0608
*                 CHUNK#=((MSFX#-MSFXSTRT)-((CMBLK#-1)*XRNGBLK))/  0609
*                     XRNGCNK+1;    /*                       @Z40LB64*/
         LA    @14,4                                               0609
         BCTR  @05,0                                               0609
         SLA   @05,5                                               0609
         SLR   @15,@05                                             0609
         LR    @04,@15                                             0609
         SRDA  @04,32                                              0609
         DR    @04,@14                                             0609
         ALR   @05,@02                                             0609
         STH   @05,CHUNK#                                          0609
*                 XPOSCUBE=((MSFX#-MSFXSTRT)-((CMBLK#-1)*XRNGBLK))//
*                     XRNGCNK+1;    /*                       @Z40LB64*/
         LR    @00,@15                                             0610
         SRDA  @00,32                                              0610
         D     @00,@CF00046                                        0610
         ALR   @00,@02                                             0610
         STH   @00,XPOSCUBE                                        0610
*                 CUBE#=MSFY#/YRNGCUBE+1;/*                  @Z40LB64*/
         LH    @15,MSFY#                                           0611
         LR    @00,@15                                             0611
         SRDA  @00,32                                              0611
         DR    @00,@14                                             0611
         ALR   @01,@02                                             0611
         STH   @01,CUBE#                                           0611
*                 YPOSCUBE=MSFY#//YRNGCUBE+1;/*              @Z40LB64*/
*                                                                  0612
         LR    @00,@15                                             0612
         SRDA  @00,32                                              0612
         D     @00,@CF00046                                        0612
         ALR   @00,@02                                             0612
         STH   @00,YPOSCUBE                                        0612
*                 /***************************************************/
*                 /*                                                 */
*                 /* INDEX INTO THE CELL MAP AND TEST        @Z40LB64*/
*                 /* THE SELECTED BIT (CELL LOCATION)        @Z40LB64*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0613
*                 BLKPOS#=((CHUNK#-1)*CHUNKLEN)+((CUBE#-1)*CUBELEN)+(
*                     YPOSCUBE-1);  /*                       @Z40LB64*/
         BCTR  @05,0                                               0613
         SLA   @05,5                                               0613
         LH    @04,CUBE#                                           0613
         BCTR  @04,0                                               0613
         SLA   @04,2                                               0613
         ALR   @05,@04                                             0613
         BCTR  @00,0                                               0613
         ALR   @05,@00                                             0613
         STH   @05,BLKPOS#                                         0613
*                 CMENTPTR=CMBUFPTR(MSF#,CMBLK#)+BLKPOS#;/*  @Z40LB64*/
         LH    @04,CMBLK#                                          0614
         LH    @15,MSF#                                            0614
         SLA   @15,2                                               0614
         ALR   @15,@04                                             0614
         SLA   @15,2                                               0614
         L     @14,@PC00001+4                                      0614
         L     @15,CMBUFPTR-20(@15,@14)                            0614
         ALR   @15,@05                                             0614
         ST    @15,CMENTPTR                                        0614
*                 CMENTMSK=2*(XPOSCUBE-1)+MSFZ#+1;/*         @Z40LB64*/
         LH    @01,XPOSCUBE                                        0615
         BCTR  @01,0                                               0615
         ALR   @01,@01                                             0615
         AH    @01,MSFZ#                                           0615
         ALR   @01,@02                                             0615
         STH   @01,CMENTMSK                                        0615
*                 CMENTVAL=CMENTRY&BITMASK(CMENTMSK);/*      @Z40LB64*/
*                                                                  0616
         SLR   @02,@02                                             0616
         IC    @02,BITMASK-1(@01)                                  0616
         SLR   @01,@01                                             0616
         IC    @01,CMENTRY(,@15)                                   0616
         NR    @01,@02                                             0616
         STH   @01,CMENTVAL                                        0616
*                 /***************************************************/
*                 /*                                                 */
*                 /* OBTAIN THE SAME CELL LOCATION           @Z40LB64*/
*                 /* THE ORIGINAL STATE CELL MAP TO          @Z40LB64*/
*                 /* DETERMINE IF THE CELL IS AN             @Z40LB64*/
*                 /* ALLOWABLE CELL.                         @Z40LB64*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0617
*                 CMENTPTR=CMBUFPTR(MSFVLCNT+1,CMBLK#)+BLKPOS#;/*  0617
*                                                            @Z40LB64*/
         LH    @15,MSFVLCNT(,@14)                                  0617
         SLA   @15,2                                               0617
         ALR   @15,@04                                             0617
         SLA   @15,2                                               0617
         AL    @05,CMBUFPTR-4(@15,@14)                             0617
         ST    @05,CMENTPTR                                        0617
*                 CMORGVAL=CMENTRY&BITMASK(CMENTMSK);/*      @Z40LB64*/
*                                                                  0618
         SLR   @04,@04                                             0618
         IC    @04,CMENTRY(,@05)                                   0618
         NR    @02,@04                                             0618
         STH   @02,CMORGVAL                                        0618
*                 /***************************************************/
*                 /*                                                 */
*                 /* DETERMINE IF THE ORIGINAL STATE         @Z40LB64*/
*                 /* CELL MAP LOCATION SPECIFIES A           @Z40LB64*/
*                 /* VALID CELL LOCATION.                    @Z40LB64*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0619
*                 IF CMORGVAL^=0 THEN                              0619
         LTR   @02,@02                                             0619
         BZ    @RF00619                                            0619
*CELLOKAY:                                                         0620
*                   DO;             /*                       @Z40LB64*/
*                                                                  0620
CELLOKAY DS    0H                                                  0621
*                     /***********************************************/
*                     /*                                             */
*                     /* ORIGINAL STATE CELL MAP             @Z40LB64*/
*                     /* INDICATES THAT THE CELL             @Z40LB64*/
*                     /* LOCATION IS VALID. DETERMINE        @Z40LB64*/
*                     /* IF THE CELL LOCATION IS             @Z40LB64*/
*                     /* ALREADY CHECKED-OFF.                @Z40LB64*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0621
*                     CMCOEPTR=CMCOPTR(MSF#,CMBLK#)+BLKPOS#;/*     0621
*                                                            @Z40LB64*/
         LH    @02,MSF#                                            0621
         SLA   @02,2                                               0621
         AH    @02,CMBLK#                                          0621
         SLA   @02,2                                               0621
         L     @15,@PC00001+4                                      0621
         LH    @14,BLKPOS#                                         0621
         AL    @14,CMCOPTR-20(@02,@15)                             0621
         ST    @14,CMCOEPTR                                        0621
*                     CMCOVAL=CMCOENT&BITMASK(CMENTMSK);/*   @Z40LB64*/
         SLR   @15,@15                                             0622
         IC    @15,CMCOENT(,@14)                                   0622
         LH    @01,CMENTMSK                                        0622
         SLR   @02,@02                                             0622
         IC    @02,BITMASK-1(@01)                                  0622
         LR    @05,@15                                             0622
         NR    @05,@02                                             0622
         STH   @05,CMCOVAL                                         0622
*                     IF CMCOVAL=0 THEN                            0623
*                                                                  0623
         LTR   @05,@05                                             0623
         BNZ   @RF00623                                            0623
*                       /*********************************************/
*                       /*                                           */
*                       /* CELL MAP CELL LOCATION            @Z40LB64*/
*                       /* IS NOT CHECKED-OFF.               @Z40LB64*/
*                       /* CHECK-OFF THE LOCATION            @Z40LB64*/
*                       /* AT THIS TIME.                     @Z40LB64*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  0624
*                       CMCOENT=CMCOENT|BITMASK(CMENTMSK);         0624
         OR    @15,@02                                             0624
         STC   @15,CMCOENT(,@14)                                   0624
*                     ELSE                                         0625
*                                                                  0625
*                       /*********************************************/
*                       /*                                           */
*                       /* CELL MAP LOCATION IS              @Z40LB64*/
*                       /* ALREADY CHECKED-OFF.              @Z40LB64*/
*                       /* PRINT ERROR MESSAGE.              @Z40LB64*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  0625
*                       DO;         /*                       @Z40LB64*/
         B     @RC00623                                            0625
@RF00623 DS    0H                                                  0626
*                         DUPLMSG=ON;/*                      @Z40LB64*/
         L     @02,@PC00001+4                                      0626
         L     @02,MARGPTR(,@02)                                   0626
         OI    DUPLMSG(@02),B'01000000'                            0626
*                         CAFLD=ON; /*                       @Z40LB64*/
         OI    CAFLD(@02),B'00010000'                              0627
*                         FLDNUM(1)=LZYXADDR;/*              @Z40LB64*/
         SLR   @15,@15                                             0628
         ICM   @15,3,LZYXADDR                                      0628
         ST    @15,FLDNUM(,@02)                                    0628
*                         IF MSCTBL=VITYPE THEN                    0629
         CLC   MSCTBL(2),@CH00223                                  0629
         BNE   @RF00629                                            0629
*                           DO;     /*                       @Z40LB64*/
*                             VITBL(1)=ON;/*                 @Z40LB64*/
         OI    VITBL(@02),B'01000000'                              0631
*                             VSNINDEX(1)=VIVOLID;                 0632
         L     @01,VIENTPTR                                        0632
         MVC   VSNINDEX(6,@02),VIVOLID(@01)                        0632
*                           END;    /*                       @Z40LB64*/
*                         IF MSCTBL=TVLTYPE THEN                   0634
@RF00629 CLC   MSCTBL(2),@CH00157                                  0634
         BNE   @RF00634                                            0634
*                           DO;     /*                       @Z40LB64*/
*                             TVLTBL(1)=ON;/*                @Z40LB64*/
         L     @02,@PC00001+4                                      0636
         L     @02,MARGPTR(,@02)                                   0636
         OI    TVLTBL(@02),B'00100000'                             0636
*                             CSNINDEX(1)=TVCSN;                   0637
         L     @15,TVENTPTR                                        0637
         MVC   CSNINDEX(12,@02),TVCSN(@15)                         0637
*                             VSNINDEX(1)=TVVOLID;                 0638
         MVC   VSNINDEX(6,@02),TVVOLID(@15)                        0638
*                           END;    /*                       @Z40LB64*/
*                         IF MSCTBL=SCLTYPE THEN                   0640
@RF00634 CLC   MSCTBL(2),@CH00166                                  0640
         BNE   @RF00640                                            0640
*                           DO;     /*                       @Z40LB64*/
*                             SCLTBL(1)=ON;/*                @Z40LB64*/
         L     @02,@PC00001+4                                      0642
         L     @02,MARGPTR(,@02)                                   0642
         OI    SCLTBL(@02),B'00010000'                             0642
*                             CSNINDEX(1)=SCCSN;                   0643
         L     @01,SCENTPTR                                        0643
         MVC   CSNINDEX(12,@02),SCCSN(@01)                         0643
*                             MSFINDEX(1)=MSFL#;                   0644
         MVC   MSFINDEX(1,@02),MSFL#+1                             0644
*                           END;    /*                       @Z40LB64*/
*                         CHRINDEX(1)=PREVCHR;/*             @Z40LB64*/
@RF00640 L     @02,@PC00001+4                                      0646
         L     @01,MARGPTR(,@02)                                   0646
         L     @15,EARGPTR(,@02)                                   0646
         MVC   CHRINDEX(5,@01),PREVCHR(@15)                        0646
*                         CALL IDCCH04(GDTTBL,/*             @Z40LB64*/
*                             CDALIST,LASTCOND);/*           @Z40LB64*/
         L     @15,@PC00001                                        0647
         ST    @15,@AL00001                                        0647
         ST    @02,@AL00001+4                                      0647
         L     @02,@PC00001+8                                      0647
         ST    @02,@AL00001+8                                      0647
         L     @15,@CV01495                                        0647
         LA    @01,@AL00001                                        0647
         BALR  @14,@15                                             0647
*                         IF LASTCOND^=0 THEN                      0648
         L     @02,@PC00001+8                                      0648
         ICM   @15,3,LASTCOND(@02)                                 0648
         BNZ   @RT00648                                            0648
*                           RETURN; /*                       @Z40LB64*/
*                       END;        /*                       @Z40LB64*/
*                                                                  0650
*                     /***********************************************/
*                     /*                                             */
*                     /* IF THE CELL MAP SPECIFIES           @Z40LB64*/
*                     /* THAT THE CELL LOCATION IS           @Z40LB64*/
*                     /* EMPTY, PRINT ERROR MESSAGE.         @Z40LB64*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0651
*                     IF CMENTVAL^=0 THEN                          0651
@RC00623 ICM   @02,3,CMENTVAL                                      0651
         BZ    @RF00651                                            0651
*                       DO;         /*                       @Z40LB64*/
*                         INCNMSG=ON;/*                      @Z40LB64*/
         L     @02,@PC00001+4                                      0653
         L     @02,MARGPTR(,@02)                                   0653
         OI    INCNMSG(@02),B'10000000'                            0653
*                         CMTBL(1)=ON;/*                     @Z40LB64*/
         OI    CMTBL(@02),B'00000100'                              0654
*                         IF MSCTBL=VITYPE THEN                    0655
         CLC   MSCTBL(2),@CH00223                                  0655
         BNE   @RF00655                                            0655
*                           DO;     /*                       @Z40LB64*/
*                             VITBL(2)=ON;/*                 @Z40LB64*/
         OI    VITBL+4(@02),B'01000000'                            0657
*                             VSNINDEX(2)=VIVOLID;                 0658
         L     @01,VIENTPTR                                        0658
         MVC   VSNINDEX+24(6,@02),VIVOLID(@01)                     0658
*                           END;    /*                       @Z40LB64*/
*                         IF MSCTBL=TVLTYPE THEN                   0660
@RF00655 CLC   MSCTBL(2),@CH00157                                  0660
         BNE   @RF00660                                            0660
*                           DO;     /*                       @Z40LB64*/
*                             TVLTBL(2)=ON;/*                @Z40LB64*/
         L     @02,@PC00001+4                                      0662
         L     @02,MARGPTR(,@02)                                   0662
         OI    TVLTBL+4(@02),B'00100000'                           0662
*                             CSNINDEX(2)=TVCSN;                   0663
         L     @15,TVENTPTR                                        0663
         MVC   CSNINDEX+24(12,@02),TVCSN(@15)                      0663
*                             VSNINDEX(2)=TVVOLID;                 0664
         MVC   VSNINDEX+24(6,@02),TVVOLID(@15)                     0664
*                           END;    /*                       @Z40LB64*/
*                         IF MSCTBL=SCLTYPE THEN                   0666
@RF00660 CLC   MSCTBL(2),@CH00166                                  0666
         BNE   @RF00666                                            0666
*                           DO;     /*                       @Z40LB64*/
*                             SCLTBL(2)=ON;/*                @Z40LB64*/
         L     @02,@PC00001+4                                      0668
         L     @02,MARGPTR(,@02)                                   0668
         OI    SCLTBL+4(@02),B'00010000'                           0668
*                             CSNINDEX(2)=SCCSN;                   0669
         L     @01,SCENTPTR                                        0669
         MVC   CSNINDEX+24(12,@02),SCCSN(@01)                      0669
*                             MSFINDEX(2)=MSFL#;                   0670
         MVC   MSFINDEX+24(1,@02),MSFL#+1                          0670
*                           END;    /*                       @Z40LB64*/
*                         COSFLD=ON;/*                       @Z40LB64*/
@RF00666 L     @02,@PC00001+4                                      0672
         L     @15,MARGPTR(,@02)                                   0672
         OI    COSFLD(@15),B'00001000'                             0672
*                         FLDCHAR(1)=STATNO;/*               @Z40LB64*/
         MVI   FLDCHAR+3(@15),C' '                                 0673
         MVC   FLDCHAR+4(8,@15),FLDCHAR+3(@15)                     0673
         MVC   FLDCHAR(3,@15),@CC01345                             0673
*                         FLDCHAR(2)=STATYES;/*              @Z40LB64*/
         MVI   FLDCHAR+15(@15),C' '                                0674
         MVC   FLDCHAR+16(8,@15),FLDCHAR+15(@15)                   0674
         MVC   FLDCHAR+12(3,@15),@CC01343                          0674
*                         MSFINDEX(1)=MSFL#;/*               @Z40LB64*/
         MVC   MSFINDEX(1,@15),MSFL#+1                             0675
*                         XYZINDEX(1)=LZYXADDR;/*            @Z40LB64*/
         MVC   XYZINDEX(2,@15),LZYXADDR                            0676
*                         CHRINDEX(1)=CMCHR(MSF#,CMBLK#);          0677
         LH    @14,MSF#                                            0677
         SLA   @14,2                                               0677
         AH    @14,CMBLK#                                          0677
         MH    @14,@CH00290                                        0677
         LA    @01,CMCHR-25(@14)                                   0677
         MVC   CHRINDEX(5,@15),0(@01)                              0677
*                         CHRINDEX(2)=PREVCHR;/*             @Z40LB64*/
         L     @01,EARGPTR(,@02)                                   0678
         MVC   CHRINDEX+24(5,@15),PREVCHR(@01)                     0678
*                         CALL IDCCH04(GDTTBL,CDALIST);            0679
         L     @15,@PC00001                                        0679
         ST    @15,@AL00001                                        0679
         ST    @02,@AL00001+4                                      0679
         L     @15,@CV01495                                        0679
         LA    @01,@AL00001                                        0679
         BALR  @14,@15                                             0679
*                       END;        /*                       @Z40LB64*/
*                   END CELLOKAY;   /*                       @Z40LB64*/
*                 ELSE                                             0682
*CELLBAD:                                                          0682
*                   DO;             /*                       @Z40LB64*/
*                                                                  0682
         B     @RC00619                                            0682
@RF00619 DS    0H                                                  0682
CELLBAD  DS    0H                                                  0683
*                     /***********************************************/
*                     /*                                             */
*                     /* ORIGINAL CELL MAP INDICATES         @Z40LB64*/
*                     /* THAT THE CELL LOCATION IS           @Z40LB64*/
*                     /* NOT AN ALLOWABLE LOCATION.          @Z40LB64*/
*                     /* PRINT AN ERROR MESSAGE.             @Z40LB64*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0683
*                     MTCHMSG=ON;   /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0683
         L     @02,MARGPTR(,@02)                                   0683
         OI    MTCHMSG(@02),B'00010000'                            0683
*                     CMTBL(1)=ON;  /*                       @Z40LB64*/
         OI    CMTBL(@02),B'00000100'                              0684
*                     IF MSCTBL=VITYPE THEN                        0685
         CLC   MSCTBL(2),@CH00223                                  0685
         BNE   @RF00685                                            0685
*                       DO;         /*                       @Z40LB64*/
*                         VITBL(2)=ON;/*                     @Z40LB64*/
         OI    VITBL+4(@02),B'01000000'                            0687
*                         VSNINDEX(2)=VIVOLID;/*             @Z40LB64*/
         L     @01,VIENTPTR                                        0688
         MVC   VSNINDEX+24(6,@02),VIVOLID(@01)                     0688
*                       END;        /*                       @Z40LB64*/
*                     IF MSCTBL=TVLTYPE THEN                       0690
@RF00685 CLC   MSCTBL(2),@CH00157                                  0690
         BNE   @RF00690                                            0690
*                       DO;         /*                       @Z40LB64*/
*                         TVLTBL(2)=ON;/*                    @Z40LB64*/
         L     @02,@PC00001+4                                      0692
         L     @02,MARGPTR(,@02)                                   0692
         OI    TVLTBL+4(@02),B'00100000'                           0692
*                         CSNINDEX(2)=TVCSN;/*               @Z40LB64*/
         L     @15,TVENTPTR                                        0693
         MVC   CSNINDEX+24(12,@02),TVCSN(@15)                      0693
*                         VSNINDEX(2)=TVVOLID;/*             @Z40LB64*/
         MVC   VSNINDEX+24(6,@02),TVVOLID(@15)                     0694
*                       END;        /*                       @Z40LB64*/
*                     IF MSCTBL=SCLTYPE THEN                       0696
@RF00690 CLC   MSCTBL(2),@CH00166                                  0696
         BNE   @RF00696                                            0696
*                       DO;         /*                       @Z40LB64*/
*                         SCLTBL(2)=ON;/*                    @Z40LB64*/
         L     @02,@PC00001+4                                      0698
         L     @02,MARGPTR(,@02)                                   0698
         OI    SCLTBL+4(@02),B'00010000'                           0698
*                         CSNINDEX(2)=SCCSN;/*               @Z40LB64*/
         L     @01,SCENTPTR                                        0699
         MVC   CSNINDEX+24(12,@02),SCCSN(@01)                      0699
*                         MSFINDEX(2)=MSFL#;/*               @Z40LB64*/
         MVC   MSFINDEX+24(1,@02),MSFL#+1                          0700
*                       END;        /*                       @Z40LB64*/
*                     CAFLD=ON;     /*                       @Z40LB64*/
@RF00696 L     @02,@PC00001+4                                      0702
         L     @15,MARGPTR(,@02)                                   0702
         OI    CAFLD(@15),B'00010000'                              0702
*                     FLDNUM(1)=LZYXADDR;/*                  @Z40LB64*/
         SLR   @14,@14                                             0703
         ICM   @14,3,LZYXADDR                                      0703
         ST    @14,FLDNUM(,@15)                                    0703
*                     CHRINDEX(2)=PREVCHR;/*                 @Z40LB64*/
         L     @01,EARGPTR(,@02)                                   0704
         MVC   CHRINDEX+24(5,@15),PREVCHR(@01)                     0704
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB64*/
         L     @15,@PC00001                                        0705
         ST    @15,@AL00001                                        0705
         ST    @02,@AL00001+4                                      0705
         L     @15,@CV01495                                        0705
         LA    @01,@AL00001                                        0705
         BALR  @14,@15                                             0705
*                   END CELLBAD;    /*                       @Z40LB64*/
*               END LZYXOKAY;       /*                       @Z40LB64*/
@RC00619 DS    0H                                                  0708
*           END CTGCHK;             /*                       @Z40LB64*/
@RF00606 LA    @15,1                                               0708
         AH    @15,CTGSEQ#                                         0708
         STH   @15,CTGSEQ#                                         0708
         CH    @15,@CH00157                                        0708
         BNH   @DL00528                                            0708
*         END CMCHK;                /*                       @Z40LB64*/
*                                                                  0709
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE END OF ONE OF THE MSC TABLES (VI, TVL,     @Z40LB64*/
*       /* SCL) WAS REACHED, PREPARE TO SCAN THE NEXT        @Z40LB64*/
*       /* MSC TABLE. IN THE CASE OF THE SCRATCH CARTRIDGE   @Z40LB64*/
*       /* LIST, AN INDIVIDUAL SCAN IS PERFORMED FOR EACH    @Z40LB64*/
*       /* VALID MSF.                                        @Z40LB64*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0710
*       IF GETRC=ENDOFTBL THEN                                     0710
@RF00488 L     @02,@PC00001+4                                      0710
         L     @01,EARGPTR(,@02)                                   0710
         CLC   GETRC(2,@01),@CH00046                               0710
         BNE   @RF00710                                            0710
*         DO;                       /*                       @Z40LB64*/
*           IF MSCTBL=SCLTYPE THEN                                 0712
         CLC   MSCTBL(2),@CH00166                                  0712
         BNE   @RF00712                                            0712
*             IF SCLMSF#=MSFVLCNT THEN                             0713
         CLC   SCLMSF#(2),MSFVLCNT(@02)                            0713
         BNE   @RF00713                                            0713
*               ENDFLAG=ON;         /*                       @Z40LB64*/
         OI    ENDFLAG,B'10000000'                                 0714
*             ELSE                                                 0715
*               DO;                 /*                       @Z40LB64*/
         B     @RC00713                                            0715
@RF00713 DS    0H                                                  0716
*                 SCLMSF#=SCLMSF#+1;/*                       @Z40LB64*/
         LA    @02,1                                               0716
         AH    @02,SCLMSF#                                         0716
         STH   @02,SCLMSF#                                         0716
*                 TBLADDR=0;        /*                       @Z40LB64*/
         L     @02,@PC00001+4                                      0717
         L     @01,EARGPTR(,@02)                                   0717
         SLR   @00,@00                                             0717
         ST    @00,TBLADDR(,@01)                                   0717
*               END;                /*                       @Z40LB64*/
*           ELSE                                                   0719
*             ENDFLAG=ON;           /*                       @Z40LB64*/
         B     @RC00712                                            0719
@RF00712 OI    ENDFLAG,B'10000000'                                 0719
*         END;                      /*                       @Z40LB64*/
*                                                                  0720
@RC00712 DS    0H                                                  0721
*       /*************************************************************/
*       /*                                                           */
*       /* IF AN ERROR WAS ENCOUNTERED WHILE TRYING TO       @Z40LB64*/
*       /* OBTAIN AN ENTRY FROM ONE OF THE MSC TABLES,       @Z40LB64*/
*       /* TERMINATE CHECKMSS PROCESSING.                    @Z40LB64*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0721
*       IF GETRC=TABLERR THEN                                      0721
@RF00710 LA    @02,12                                              0721
         L     @15,@PC00001+4                                      0721
         L     @01,EARGPTR(,@15)                                   0721
         CH    @02,GETRC(,@01)                                     0721
         BNE   @RF00721                                            0721
*         DO;                       /*                       @Z40LB64*/
*           LASTCOND=LASTCC12;      /*                       @Z40LB64*/
         L     @15,@PC00001+8                                      0723
         STH   @02,LASTCOND(,@15)                                  0723
*           RETURN;                 /*                       @Z40LB64*/
         B     @EL00002                                            0724
*         END;                      /*                       @Z40LB64*/
*     END TBLREAD;                  /*                       @Z40LB64*/
@RF00721 DS    0H                                                  0726
@DE00476 TM    ENDFLAG,B'10000000'                                 0726
         BZ    @DL00476                                            0726
*   END MSCTBLS;                    /*                       @Z40LB64*/
*                                                                  0727
         LA    @15,1                                               0727
         AH    @15,MSCTBL                                          0727
         STH   @15,MSCTBL                                          0727
         CH    @15,@CH00166                                        0727
         BNH   @DL00473                                            0727
*   /*****************************************************************/
*   /*                                                               */
*   /* THE MSC VOLUME INVENTORY, TRANSIENT VOLUME LIST, AND  @Z40LB64*/
*   /* SCRATCH CARTRIDGE LIST SHOULD HAVE ACCOUNTED FOR      @Z40LB64*/
*   /* EVERY FULL CELL LOCATION IN THE CELL MAP. SCAN THE    @Z40LB64*/
*   /* ENTIRE CELL MAP TO VERIFY THAT ALL ALLOWABLE FULL     @Z40LB64*/
*   /* CELL LOCATIONS HAVE BEEN CHECKED-OFF.                 @Z40LB64*/
*   /* SCAN THE CELL MAP OF EACH VALID MSF.                  @Z40LB64*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0728
*MSFSCAN:                                                          0728
*   DO MSF#=1 TO MSFVLCNT;          /*                       @Z40LB64*/
MSFSCAN  LA    @02,1                                               0728
         B     @DE00728                                            0728
@DL00728 DS    0H                                                  0729
*     MSFL#=VLDMSFID(MSF#);         /*                       @Z40LB64*/
         ALR   @02,@02                                             0729
         L     @15,@PC00001+4                                      0729
         LH    @02,VLDMSFID-2(@02,@15)                             0729
         STH   @02,MSFL#                                           0729
*     MSFX#=1;                      /*                       @Z40LB64*/
*                                                                  0730
         MVC   MSFX#(2),@CH00223                                   0730
*     /***************************************************************/
*     /*                                                             */
*     /* FOR EACH VALID MSF, SCAN EACH DATA BLOCK            @Z40LB64*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0731
*BLKSCAN:                                                          0731
*     DO CMBLK#=1 TO BLKSMSF;       /*                       @Z40LB64*/
*                                                                  0731
BLKSCAN  LA    @02,1                                               0731
         STH   @02,CMBLK#                                          0731
@DL00731 DS    0H                                                  0732
*       /*************************************************************/
*       /*                                                           */
*       /* FOR EACH DATA BLOCK, SCAN EACH CELL MAP CHUNK     @Z40LB64*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0732
*CHNKSCAN:                                                         0732
*       DO CHUNK#=1 TO CNKSBLK;     /*                       @Z40LB64*/
CHNKSCAN LA    @02,1                                               0732
         STH   @02,CHUNK#                                          0732
@DL00732 DS    0H                                                  0733
*         MSFY#=0;                  /*                       @Z40LB64*/
         SLR   @02,@02                                             0733
         STH   @02,MSFY#                                           0733
*         XINCREAS=0;               /*                       @Z40LB64*/
*                                                                  0734
         STH   @02,XINCREAS                                        0734
*         /***********************************************************/
*         /*                                                         */
*         /* FOR EACH CELL MAP CHUNK, SCAN EACH CUBE         @Z40LB64*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0735
*CUBESCAN:                                                         0735
*         DO CUBE#=1 TO CUBESCNK;   /*                       @Z40LB64*/
*                                                                  0735
CUBESCAN LA    @02,1                                               0735
         STH   @02,CUBE#                                           0735
@DL00735 DS    0H                                                  0736
*           /*********************************************************/
*           /*                                                       */
*           /* FOR EACH CELL MAP CUBE, SCAN EACH BYTE        @Z40LB64*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0736
*BYTESCAN:                                                         0736
*           DO CUBEBYTE=1 TO CUBELEN;/*                      @Z40LB64*/
BYTESCAN LA    @02,1                                               0736
         STH   @02,CUBEBYTE                                        0736
@DL00736 DS    0H                                                  0737
*             MSFY#=MSFY#+1;        /*                       @Z40LB64*/
         LA    @15,1                                               0737
         AH    @15,MSFY#                                           0737
         STH   @15,MSFY#                                           0737
*             BLKPOS#=((CHUNK#-1)*CHUNKLEN)+((CUBE#-1)*CUBELEN)+(  0738
*                 CUBEBYTE-1);      /*                       @Z40LB64*/
*                                                                  0738
         LH    @15,CHUNK#                                          0738
         BCTR  @15,0                                               0738
         SLA   @15,5                                               0738
         LH    @14,CUBE#                                           0738
         BCTR  @14,0                                               0738
         SLA   @14,2                                               0738
         ALR   @15,@14                                             0738
         BCTR  @02,0                                               0738
         ALR   @15,@02                                             0738
         STH   @15,BLKPOS#                                         0738
*             /*******************************************************/
*             /*                                                     */
*             /* IF X-VALUE IS WITHIN THE ALLOWABLE RANGE    @Z40LB64*/
*             /* FOR THIS MSF, SCAN EACH BIT IN THE BYTE     @Z40LB64*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0739
*             IF MSFX#+XINCREAS-1>=MSFXLOW(MSF#) THEN              0739
         LH    @02,MSFX#                                           0739
         AH    @02,XINCREAS                                        0739
         BCTR  @02,0                                               0739
         LH    @15,MSF#                                            0739
         ALR   @15,@15                                             0739
         CH    @02,MSFXLOW-2(@15)                                  0739
         BL    @RF00739                                            0739
*BITSCAN:                                                          0740
*               DO CUBEBIT=(2*XINCREAS)+1 TO BITSBYTE;/*     @Z40LB64*/
BITSCAN  LH    @02,XINCREAS                                        0740
         ALR   @02,@02                                             0740
         AH    @02,@CH00223                                        0740
         B     @DE00740                                            0740
@DL00740 DS    0H                                                  0741
*                 MSFZ#=(CUBEBIT+1)//2;/*                    @Z40LB64*/
*                                                                  0741
         LA    @00,1                                               0741
         ALR   @00,@02                                             0741
         SRDA  @00,32                                              0741
         D     @00,@CF00157                                        0741
         STH   @00,MSFZ#                                           0741
*                 /***************************************************/
*                 /*                                                 */
*                 /* DETERMINE IF THE ORIGINAL STATE         @Z40LB64*/
*                 /* CELL MAP SPECIFIES THAT THE CELL        @Z40LB64*/
*                 /* LOCATION IS AN ALLOWABLE LOCATION.      @Z40LB64*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0742
*                 CMENTPTR=CMBUFPTR(MSFVLCNT+1,CMBLK#)+BLKPOS#;/*  0742
*                                                            @Z40LB64*/
         L     @15,@PC00001+4                                      0742
         LH    @14,MSFVLCNT(,@15)                                  0742
         SLA   @14,2                                               0742
         AH    @14,CMBLK#                                          0742
         SLA   @14,2                                               0742
         LH    @05,BLKPOS#                                         0742
         AL    @05,CMBUFPTR-4(@14,@15)                             0742
         ST    @05,CMENTPTR                                        0742
*                 IF(CMENTRY&BITMASK(CUBEBIT))^=0 THEN             0743
         SLR   @04,@04                                             0743
         IC    @04,CMENTRY(,@05)                                   0743
         SLR   @05,@05                                             0743
         IC    @05,BITMASK-1(@02)                                  0743
         NR    @04,@05                                             0743
         LTR   @04,@04                                             0743
         BZ    @RF00743                                            0743
*CELLVLD:                                                          0744
*                   DO;             /*                       @Z40LB64*/
*                                                                  0744
CELLVLD  DS    0H                                                  0745
*                     /***********************************************/
*                     /*                                             */
*                     /* CELL LOCATION IS AN ALLOWABLE       @Z40LB64*/
*                     /* LOCATION. IF CELL LOCATION IS       @Z40LB64*/
*                     /* FOR THE LOW X VALUE, Y=0, Z=0       @Z40LB64*/
*                     /* THE CELL IS A RESERVED CELL,        @Z40LB64*/
*                     /* AND IS TREATED AS EMTPY.            @Z40LB64*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0745
*                     CMENTPTR=CMBUFPTR(MSF#,CMBLK#)+BLKPOS#;/*    0745
*                                                            @Z40LB64*/
         LH    @02,MSF#                                            0745
         LR    @15,@02                                             0745
         SLA   @15,2                                               0745
         AH    @15,CMBLK#                                          0745
         SLA   @15,2                                               0745
         L     @14,@PC00001+4                                      0745
         LH    @05,BLKPOS#                                         0745
         AL    @05,CMBUFPTR-20(@15,@14)                            0745
         ST    @05,CMENTPTR                                        0745
*                     IF(MSFX#-1=MSFXLOW(MSF#))&(MSFY#=1)&(MSFZ#=0)
*                       THEN                                       0746
         LH    @04,MSFX#                                           0746
         BCTR  @04,0                                               0746
         ALR   @02,@02                                             0746
         CH    @04,MSFXLOW-2(@02)                                  0746
         BNE   @RF00746                                            0746
         CLC   MSFY#(2),@CH00223                                   0746
         BNE   @RF00746                                            0746
         ICM   @04,3,MSFZ#                                         0746
         BNZ   @RF00746                                            0746
*                       CMENTRY=CMENTRY|BITMASK(CUBEBIT);          0747
*                                                                  0747
         LH    @01,CUBEBIT                                         0747
         LA    @04,BITMASK-1(@01)                                  0747
         OC    CMENTRY(1,@05),0(@04)                               0747
*                     /***********************************************/
*                     /*                                             */
*                     /* DETERMINE IF THE CELL MAP           @Z40LB64*/
*                     /* SPECIFIES THAT THE CELL IS          @Z40LB64*/
*                     /* OCCUPIED.                           @Z40LB64*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0748
*                     IF(CMENTRY&BITMASK(CUBEBIT))=0 THEN          0748
@RF00746 LH    @01,CUBEBIT                                         0748
         L     @02,CMENTPTR                                        0748
         SLR   @00,@00                                             0748
         IC    @00,CMENTRY(,@02)                                   0748
         SLR   @02,@02                                             0748
         IC    @02,BITMASK-1(@01)                                  0748
         NR    @00,@02                                             0748
         LTR   @00,@00                                             0748
         BNZ   @RF00748                                            0748
*CELLFULL:                                                         0749
*                       DO;         /*                       @Z40LB64*/
*                                                                  0749
CELLFULL DS    0H                                                  0750
*                         /*******************************************/
*                         /*                                         */
*                         /* CELL IS OCCUPIED. VERIFY        @Z40LB64*/
*                         /* THAT THE CELL LOCATION          @Z40LB64*/
*                         /* IS CHECKED-OFF. IF NOT          @Z40LB64*/
*                         /* CHECKED-OFF, PRINT AN           @Z40LB64*/
*                         /* ERROR MESSAGE.                  @Z40LB64*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  0750
*                         CMCOEPTR=CMCOPTR(MSF#,CMBLK#)+BLKPOS#;/* 0750
*                                                            @Z40LB64*/
         LH    @02,MSF#                                            0750
         SLA   @02,2                                               0750
         AH    @02,CMBLK#                                          0750
         SLA   @02,2                                               0750
         L     @15,@PC00001+4                                      0750
         LH    @14,BLKPOS#                                         0750
         AL    @14,CMCOPTR-20(@02,@15)                             0750
         ST    @14,CMCOEPTR                                        0750
*                         IF(CMCOENT&BITMASK(CUBEBIT))=0 THEN      0751
         LH    @01,CUBEBIT                                         0751
         SLR   @15,@15                                             0751
         IC    @15,CMCOENT(,@14)                                   0751
         SLR   @14,@14                                             0751
         IC    @14,BITMASK-1(@01)                                  0751
         NR    @15,@14                                             0751
         LTR   @15,@15                                             0751
         BNZ   @RF00751                                            0751
*CELLNCHK:                                                         0752
*                           DO;     /*                       @Z40LB64*/
CELLNCHK DS    0H                                                  0753
*                             MTCHMSG=ON;/*                  @Z40LB64*/
         L     @02,@PC00001+4                                      0753
         L     @15,MARGPTR(,@02)                                   0753
         OI    MTCHMSG(@15),B'00010000'                            0753
*                             CAFLD=ON;/*                    @Z40LB64*/
         OI    CAFLD(@15),B'00010000'                              0754
*                             VTSTBL(1)=ON;/*                @Z40LB64*/
         OI    VTSTBL(@15),B'00000100'                             0755
*                             CMTBL(2)=ON;/*                 @Z40LB64*/
         OI    CMTBL+4(@15),B'00000100'                            0756
*                             FLDNUM(1)=MSFL#*LVALSHFT+MSFZ#*ZVALSHFT+(
*                                 MSFY#-1)*YVALSHFT+MSFX#+(MSFXSTRT-1)+
*                                 (CUBEBIT-1)/2;/*           @Z40LB64*/
         LH    @14,MSFL#                                           0757
         LR    @05,@14                                             0757
         SLA   @05,14                                              0757
         LH    @04,MSFZ#                                           0757
         SLA   @04,13                                              0757
         ALR   @05,@04                                             0757
         LH    @04,MSFY#                                           0757
         BCTR  @04,0                                               0757
         SLA   @04,8                                               0757
         ALR   @05,@04                                             0757
         AH    @05,MSFX#                                           0757
         AH    @05,@CH01727                                        0757
         LH    @00,CUBEBIT                                         0757
         BCTR  @00,0                                               0757
         SRDA  @00,32                                              0757
         D     @00,@CF00157                                        0757
         ALR   @05,@01                                             0757
         ST    @05,FLDNUM(,@15)                                    0757
*                             MSFINDEX(2)=MSFL#;/*           @Z40LB64*/
         STC   @14,MSFINDEX+24(,@15)                               0758
*                             XYZINDEX(2)=FLDNUM(1);               0759
         MVC   XYZINDEX+24(2,@15),FLDNUM+2(@15)                    0759
*                             CHRINDEX(2)=CMCHR(MSF#,CMBLK#);      0760
         LH    @14,MSF#                                            0760
         SLA   @14,2                                               0760
         AH    @14,CMBLK#                                          0760
         MH    @14,@CH00290                                        0760
         LA    @01,CMCHR-25(@14)                                   0760
         MVC   CHRINDEX+24(5,@15),0(@01)                           0760
*                             CALL IDCCH04(GDTTBL,CDALIST);/*      0761
*                                                            @Z40LB61*/
         L     @15,@PC00001                                        0761
         ST    @15,@AL00001                                        0761
         ST    @02,@AL00001+4                                      0761
         L     @15,@CV01495                                        0761
         LA    @01,@AL00001                                        0761
         BALR  @14,@15                                             0761
*                           END CELLNCHK;/*                  @Z40LB64*/
*                       END CELLFULL;/*                      @Z40LB64*/
@RF00751 DS    0H                                                  0764
*                   END CELLVLD;    /*                       @Z40LB64*/
@RF00748 DS    0H                                                  0765
*               END BITSCAN;        /*                       @Z40LB64*/
@RF00743 LA    @02,1                                               0765
         AH    @02,CUBEBIT                                         0765
@DE00740 STH   @02,CUBEBIT                                         0765
         CH    @02,@CH00183                                        0765
         BNH   @DL00740                                            0765
*             ELSE                                                 0766
*                                                                  0766
*               /*****************************************************/
*               /*                                                   */
*               /* LOW X VALUE HAS NOT BEEN REACHED.         @Z40LB64*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0766
*               XINCREAS=XINCREAS+1;/*                       @Z40LB64*/
         B     @RC00739                                            0766
@RF00739 LA    @02,1                                               0766
         AH    @02,XINCREAS                                        0766
         STH   @02,XINCREAS                                        0766
*           END BYTESCAN;           /*                       @Z40LB64*/
@RC00739 LA    @02,1                                               0767
         AH    @02,CUBEBYTE                                        0767
         STH   @02,CUBEBYTE                                        0767
         CH    @02,@CH00046                                        0767
         BNH   @DL00736                                            0767
*           XINCREAS=0;             /*                       @Z40LB64*/
         SLR   @02,@02                                             0768
         STH   @02,XINCREAS                                        0768
*         END CUBESCAN;             /*                       @Z40LB64*/
*                                                                  0769
         LA    @02,1                                               0769
         AH    @02,CUBE#                                           0769
         STH   @02,CUBE#                                           0769
         CH    @02,@CH00769                                        0769
         BNH   @DL00735                                            0769
*         /***********************************************************/
*         /*                                                         */
*         /* TEST IF THIS IS THE LAST DATA BLOCK IN THE      @Z40LB64*/
*         /* MSF. IF SO, THERE WILL BE ONLY ONE CHUNK        @Z40LB64*/
*         /* IN THIS BLOCK AND THE SCAN IS TERMINATED.       @Z40LB64*/
*         /* OTHERWISE CONTINUE WITH THE CHUNK SCAN.         @Z40LB64*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0770
*         IF CMBLK#=BLKSMSF THEN                                   0770
         CLC   CMBLK#(2),@CH00046                                  0770
         BNE   @RF00770                                            0770
*           CHUNK#=CNKSBLK;         /*                       @Z40LB64*/
         MVC   CHUNK#(2),@CH00183                                  0771
*         MSFX#=MSFX#+XRNGCNK;      /*                       @Z40LB64*/
@RF00770 LA    @02,4                                               0772
         AH    @02,MSFX#                                           0772
         STH   @02,MSFX#                                           0772
*       END CHNKSCAN;               /*                       @Z40LB64*/
         LA    @02,1                                               0773
         AH    @02,CHUNK#                                          0773
         STH   @02,CHUNK#                                          0773
         CH    @02,@CH00183                                        0773
         BNH   @DL00732                                            0773
*     END BLKSCAN;                  /*                       @Z40LB64*/
         LA    @02,1                                               0774
         AH    @02,CMBLK#                                          0774
         STH   @02,CMBLK#                                          0774
         CH    @02,@CH00046                                        0774
         BNH   @DL00731                                            0774
*   END MSFSCAN;                    /*                       @Z40LB64*/
         LA    @02,1                                               0775
         AH    @02,MSF#                                            0775
@DE00728 STH   @02,MSF#                                            0775
         L     @15,@PC00001+4                                      0775
         CH    @02,MSFVLCNT(,@15)                                  0775
         BNH   @DL00728                                            0775
*   IF GDTDBG=NULLPTR THEN                                         0776
         L     @02,@PC00001                                        0776
         ICM   @15,15,GDTDBG(@02)                                  0776
         BZ    @RT00776                                            0776
*     ;                                                            0777
*   ELSE                                                           0778
*     CALL IDCDB010(GDTTBL,'CH2X'); /*                       @Z40LB64*/
         L     @02,@PC00001                                        0778
         ST    @02,@AL00001                                        0778
         LA    @15,@CC01546                                        0778
         ST    @15,@AL00001+4                                      0778
         MVI   @AL00001+4,X'80'                                    0778
         L     @15,GDTDBG(,@02)                                    0778
         LA    @01,@AL00001                                        0778
         BALR  @14,@15                                             0778
*   END CELLMAP;                    /*                       @Z40LB64*/
         B     @EL00002                                            0779
*                                                                  0780
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - MVTLOOP                                 @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE OBTAINS EACH MVT ENTRY AND THEN  @Z40LB61*/
*/*            ROUTES CONTROL TO SUBROUTINES WHICH COMPARE   @Z40LB61*/
*/*            MVT ENTRY INFORMATION AGAINST CORRESPONDING   @Z40LB61*/
*/*            DATA IN SA TABLES AND OTHER MSC TABLES.       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*        (2) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  0780
*MVTLOOP:                                                          0780
*   PROCEDURE;                      /*                       @Z40LB61*/
MVTLOOP  STM   @14,@12,@SA00003                                    0780
*   OLDERID2=NEWERID2;                                             0781
         L     @02,@PC00001                                        0781
         L     @02,GDTTR2(,@02)                                    0781
         MVC   @TS00001(95),NEWERID2(@02)                          0781
         MVC   OLDERID2(95,@02),@TS00001                           0781
*   NEWID2='CH2E';                  /*                       @Z40LB61*/
*                                                                  0782
         MVC   NEWID2(4,@02),@CC01550                              0782
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE POINTER AND COUNT VARIABLES AND            @Z40LB61*/
*   /* CHECK-OFF TABLES                                      @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0783
*   TBLADDR=NULLPTR;                /*                       @Z40LB61*/
         L     @02,@PC00001+4                                      0783
         L     @01,EARGPTR(,@02)                                   0783
         SLR   @00,@00                                             0783
         ST    @00,TBLADDR(,@01)                                   0783
*   DO SDG#=1 TO SDGMAX;            /*                       @Z40LB61*/
         LA    @02,1                                               0784
         STH   @02,SDG#                                            0784
@DL00784 DS    0H                                                  0785
*     MNTCOUNT(SDG#)=0;             /*                       @Z40LB61*/
         LR    @15,@02                                             0785
         ALR   @15,@15                                             0785
         SLR   @14,@14                                             0785
         STH   @14,MNTCOUNT-2(@15)                                 0785
*     RPMCOT(SDG#)=''B;             /*                       @Z40LB61*/
         LR    @15,@02                                             0786
         MH    @15,@CH01728                                        0786
         L     @14,@PC00001+4                                      0786
         L     @01,RPMCOPTR(,@14)                                  0786
         ALR   @01,@15                                             0786
         AL    @01,@CF01755                                        0786
         XC    RPMCOT(56,@01),RPMCOT(@01)                          0786
*     DVBCOT(SDG#)=''B;             /*                       @Z40LB61*/
         LR    @15,@02                                             0787
         SLA   @15,4                                               0787
         L     @01,DVBCOPTR(,@14)                                  0787
         ALR   @01,@15                                             0787
         AL    @01,@CF01756                                        0787
         XC    DVBCOT(16,@01),DVBCOT(@01)                          0787
*     LPBCOT(SDG#)=''B;             /*                       @Z40LB61*/
         L     @01,LPBCOPTR(,@14)                                  0788
         ALR   @01,@15                                             0788
         AL    @01,@CF01756                                        0788
         XC    LPBCOT(16,@01),LPBCOT(@01)                          0788
*   END;                            /*                       @Z40LB61*/
         AH    @02,@CH00223                                        0789
         STH   @02,SDG#                                            0789
         CH    @02,@CH00781                                        0789
         BNH   @DL00784                                            0789
*   DO SA#=1 TO SAMAX;              /*                       @Z40LB61*/
         LA    @02,1                                               0790
         STH   @02,SA#                                             0790
@DL00790 DS    0H                                                  0791
*     IF IVVITPTR(SA#)^=NULLPTR&    /*                       @ZA27324*/
*         IVVITPTR(SA#)^=DUMMYPTR THEN/*                     @ZA27324*/
         LR    @15,@02                                             0791
         SLA   @15,2                                               0791
         L     @14,@PC00001+4                                      0791
         L     @05,IVVITPTR-4(@15,@14)                             0791
         LTR   @05,@05                                             0791
         BZ    @RF00791                                            0791
         C     @05,DUMMYPTR                                        0791
         BE    @RF00791                                            0791
*       DO;                         /*                       @Z40LB61*/
*         CDBCOT(SA#)=''B;          /*                       @Z40LB61*/
         MH    @02,@CH00314                                        0793
         L     @01,CDBCOPTR(,@14)                                  0793
         ALR   @01,@02                                             0793
         AL    @01,@CF01757                                        0793
         XC    CDBCOT(24,@01),CDBCOT(@01)                          0793
*         VVACOT(SA#)=''B;          /*                       @Z40LB61*/
         L     @01,VVACOPTR(,@14)                                  0794
         ALR   @01,@02                                             0794
         AL    @01,@CF01757                                        0794
         XC    VVACOT(24,@01),VVACOT(@01)                          0794
*         VMXCOT(SA#)=''B;          /*                       @Z40LB61*/
         L     @01,VMXCOPTR(,@14)                                  0795
         ALR   @01,@02                                             0795
         AL    @01,@CF01757                                        0795
         XC    VMXCOT(24,@01),VMXCOT(@01)                          0795
*         IF SACHK=ON THEN                                         0796
         TM    SACHK(@14),B'01000000'                              0796
         BNO   @RF00796                                            0796
*           DO;                     /*                       @Z40LB61*/
*             VVICOT=''B;           /*                       @Z40LB61*/
         L     @01,VVICOPTR-4(@15,@14)                             0798
         XC    VVICOT(24,@01),VVICOT(@01)                          0798
*             VADCOT=''B;           /*                       @Z40LB61*/
         L     @01,VADCOPTR-4(@15,@14)                             0799
         XC    VADCOT(24,@01),VADCOT(@01)                          0799
*             PSTCOT=''B;           /*                       @Z40LB61*/
         L     @01,PSTCOPTR-4(@15,@14)                             0800
         XC    PSTCOT(112,@01),PSTCOT(@01)                         0800
*           END;                    /*                       @Z40LB61*/
*       END;                        /*                       @Z40LB61*/
@RF00796 DS    0H                                                  0803
*   END;                            /*                       @Z40LB61*/
*                                                                  0803
@RF00791 LA    @02,1                                               0803
         AH    @02,SA#                                             0803
         STH   @02,SA#                                             0803
         CH    @02,@CH00478                                        0803
         BNH   @DL00790                                            0803
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS EVERY MOUNTED VOLUME TABLE (MVT) ENTRY,       @Z40LB61*/
*   /* CHECKING THE FIELDS AGAINST RELATED IN CORRESPONDING  @Z40LB61*/
*   /* MSC AND/OR SA TABLES.                                 @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0804
*MVTLOOP1:                                                         0804
*   DO WHILE(LASTCOND=0);           /*                       @Z40LB61*/
*                                                                  0804
MVTLOOP1 B     @DE00804                                            0804
@DL00804 DS    0H                                                  0805
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN THE NEXT MVT ENTRY. CHECK FOR A NON-ZERO     @Z40LB61*/
*     /* RETURN CODE WHICH INDICATES EITHER AN ERROR OR      @Z40LB61*/
*     /* THE END OF THE TABLE.                               @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0805
*     TABLEID=MVTBLID;              /*                       @Z40LB61*/
         L     @02,@PC00001+4                                      0805
         L     @15,EARGPTR(,@02)                                   0805
         MVC   TABLEID(1,@15),MVTBLID                              0805
*     GETNEXT=ON;                   /*                       @Z40LB61*/
*     BUFFER2=ON;                   /*                       @Z40LB61*/
         OI    GETNEXT(@15),B'11000000'                            0807
*     CALL IDCCH03(GDTTBL,CDALIST); /*                       @Z40LB61*/
         L     @15,@PC00001                                        0808
         ST    @15,@AL00001                                        0808
         ST    @02,@AL00001+4                                      0808
         L     @15,@CV01494                                        0808
         LA    @01,@AL00001                                        0808
         BALR  @14,@15                                             0808
*     IF GETRC^=0 THEN                                             0809
         L     @02,@PC00001+4                                      0809
         L     @01,EARGPTR(,@02)                                   0809
         LH    @02,GETRC(,@01)                                     0809
         LTR   @02,@02                                             0809
         BZ    @RF00809                                            0809
*       DO;                         /*                       @Z40LB61*/
*         IF GETRC=TABLERR THEN                                    0811
         LA    @15,12                                              0811
         CR    @02,@15                                             0811
         BNE   @RF00811                                            0811
*           LASTCOND=LASTCC12;      /*                       @Z40LB61*/
         L     @14,@PC00001+8                                      0812
         STH   @15,LASTCOND(,@14)                                  0812
*         RETURN;                   /*                       @Z40LB61*/
@EL00003 DS    0H                                                  0813
@EF00003 DS    0H                                                  0813
@ER00003 LM    @14,@12,@SA00003                                    0813
         BR    @14                                                 0813
*       END;                        /*                       @Z40LB61*/
*     MVENTPTR=TBLADDR;             /*                       @Z40LB61*/
@RF00809 L     @02,@PC00001+4                                      0815
         L     @15,EARGPTR(,@02)                                   0815
         L     @14,TBLADDR(,@15)                                   0815
         ST    @14,MVENTPTR                                        0815
*     SAVEID=ENTRYID;               /*                       @Z40LB61*/
*                                                                  0816
         MVC   SAVEID(12),ENTRYID(@15)                             0816
*     /***************************************************************/
*     /*                                                             */
*     /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES        @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0817
*     VSNINDEX(2)=MVVOLID;          /*                       @Z40LB61*/
         L     @15,MARGPTR(,@02)                                   0817
         MVC   VSNINDEX+24(6,@15),MVVOLID(@14)                     0817
*     CHRINDEX(2)=SAVECHR;          /*                       @Z40LB61*/
         MVC   CHRINDEX+24(5,@15),SAVECHR                          0818
*     MV3333=MV3333&MASK3333;       /*                       @Z40LB61*/
*                                                                  0819
         SLR   @15,@15                                             0819
         IC    @15,MV3333(,@14)                                    0819
         SLR   @05,@05                                             0819
         IC    @05,MASK3333                                        0819
         NR    @15,@05                                             0819
         STC   @15,MV3333(,@14)                                    0819
*     /***************************************************************/
*     /*                                                             */
*     /* IF MSC-MSC TABLE CHECKING WAS REQUESTED, COMPARE    @Z40LB61*/
*     /* THE MVT TO THE MSC VOLUME INVENTORY (VI).           @Z40LB61*/
*     /* DO NOT COMPARE THE TABLES IF THE MVT ENTRY IS       @ZA11666*/
*     /* FLAGGED AS REMOUNTED SINCE THERE IS NO GUARANTEE    @ZA11666*/
*     /* THAT A VI ENTRY EXISTS.                             @ZA11666*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0820
*     IF MSCCHK=ON&MVREMNT=OFF THEN /*                       @ZA11666*/
         TM    MSCCHK(@02),B'10000000'                             0820
         BNO   @RF00820                                            0820
         TM    MVREMNT(@14),B'00010000'                            0820
         BNZ   @RF00820                                            0820
*       DO;                         /*                       @Z40LB61*/
*         CALL CHKMVTVI;            /*                       @Z40LB61*/
         BAL   @14,CHKMVTVI                                        0822
*         IF LASTCOND^=0 THEN                                      0823
         L     @02,@PC00001+8                                      0823
         ICM   @15,3,LASTCOND(@02)                                 0823
         BNZ   @RT00823                                            0823
*           RETURN;                 /*                       @Z40LB61*/
*       END;                        /*                       @Z40LB61*/
*                                                                  0825
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE MVT ENTRY INDICATES THAT THE VOLUME IS       @Z40LB61*/
*     /* MOUNTED, CHECK INFORMATION IN RELATED TABLES        @Z40LB61*/
*     /* THAT CORRESPONDS TO THE VVA AND VUA FIELDS OF       @Z40LB61*/
*     /* THE MVT ENTRY.                                      @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0826
*     IF MVMNTVOL=ON THEN                                          0826
@RF00820 L     @01,MVENTPTR                                        0826
         TM    MVMNTVOL(@01),B'10000000'                           0826
         BNO   @RF00826                                            0826
*MNTDMVT:                                                          0827
*       DO;                         /*                       @Z40LB61*/
MNTDMVT  DS    0H                                                  0828
*         CALL MVTVVAS;             /*                       @Z40LB61*/
         BAL   @14,MVTVVAS                                         0828
*         IF LASTCOND^=0 THEN                                      0829
         L     @02,@PC00001+8                                      0829
         ICM   @15,3,LASTCOND(@02)                                 0829
         BNZ   @RT00829                                            0829
*           RETURN;                 /*                       @Z40LB61*/
*         CALL MVTVUAS;             /*                       @Z40LB61*/
         BAL   @14,MVTVUAS                                         0831
*         IF LASTCOND^=0 THEN                                      0832
         L     @02,@PC00001+8                                      0832
         ICM   @15,3,LASTCOND(@02)                                 0832
         BNZ   @RT00832                                            0832
*           RETURN;                 /*                       @Z40LB61*/
*                                                                  0833
*         /***********************************************************/
*         /*                                                         */
*         /* SET UP TO CHECK THE MVT CHECK-OFF TABLE. IF     @Z40LB61*/
*         /* MSVI CHECKING WAS REQUESTED AND THIS MVT ENTRY  @Z40LB61*/
*         /* HAS NOT BEEN CHECKED OFF, THEN THE MVT AND      @Z40LB61*/
*         /* MSVI DIFFER AS TO THE MOUNTED STATUS OF THIS    @Z40LB61*/
*         /* VOLUME. IF SO, PRINT AN ERROR MESSAGE.          @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0834
*         BYTE#=(SAVEREC#-1)/8+1;   /*                       @Z40LB61*/
         L     @02,@PC00001+4                                      0834
         L     @15,EARGPTR(,@02)                                   0834
         LA    @14,1                                               0834
         LH    @05,SAVEREC#                                        0834
         BCTR  @05,0                                               0834
         LR    @00,@05                                             0834
         SRDA  @00,32                                              0834
         D     @00,@CF00183                                        0834
         ALR   @01,@14                                             0834
         STH   @01,BYTE#(,@15)                                     0834
*         BIT#=(SAVEREC#-1)//8+1;   /*                       @Z40LB61*/
         LR    @02,@05                                             0835
         SRDA  @02,32                                              0835
         D     @02,@CF00183                                        0835
         ALR   @02,@14                                             0835
         STH   @02,BIT#(,@15)                                      0835
*         IF MSVICHK=ON THEN                                       0836
         L     @03,@PC00001+4                                      0836
         TM    MSVICHK(@03),B'00100000'                            0836
         BNO   @RF00836                                            0836
*           IF(MVTCHKFF(BYTE#)&BITMASK(BIT#))='00'X THEN           0837
         L     @15,MVTCOPTR(,@03)                                  0837
         ALR   @15,@01                                             0837
         AL    @15,@CF01340                                        0837
         MVC   @TS00001(1),MVTCHKFF(@15)                           0837
         LA    @01,BITMASK-1(@02)                                  0837
         NC    @TS00001(1),0(@01)                                  0837
         CLI   @TS00001,X'00'                                      0837
         BNE   @RF00837                                            0837
*             DO;                   /*                       @Z40LB61*/
*               MTCHMSG=ON;         /*                       @Z40LB61*/
         L     @02,MARGPTR(,@03)                                   0839
         OI    MTCHMSG(@02),B'00010000'                            0839
*               MSVITBL(1)=ON;      /*                       @Z40LB61*/
         OI    MSVITBL(@02),B'00001000'                            0840
*               MVTTBL(2)=ON;       /*                       @Z40LB61*/
         OI    MVTTBL+4(@02),B'10000000'                           0841
*               VSNFLD=ON;          /*                       @Z40LB61*/
         OI    VSNFLD(@02),B'00000001'                             0842
*               FLDCHAR(1)=MVVOLID; /*                       @Z40LB61*/
         MVI   FLDCHAR+6(@02),C' '                                 0843
         MVC   FLDCHAR+7(5,@02),FLDCHAR+6(@02)                     0843
         L     @01,MVENTPTR                                        0843
         MVC   FLDCHAR(6,@02),MVVOLID(@01)                         0843
*               CALL IDCCH04(GDTTBL,CDALIST);/*              @Z40LB61*/
         L     @02,@PC00001                                        0844
         ST    @02,@AL00001                                        0844
         ST    @03,@AL00001+4                                      0844
         L     @15,@CV01495                                        0844
         LA    @01,@AL00001                                        0844
         BALR  @14,@15                                             0844
*             END;                  /*                       @Z40LB61*/
*       END MNTDMVT;                /*                       @Z40LB61*/
*                                                                  0846
*     /***************************************************************/
*     /*                                                             */
*     /* FOR A DEMOUNTED VOLUME'S MVT ENTRY, MAKE SURE NO    @VS41105*/
*     /* SPECIAL CHECKING IS DONE IF IT'S A BOUND VOLUME     @VS41105*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0847
*     ELSE                                                         0847
*       MVBNDVOL=OFF;               /*                       @VS41105*/
*                                                                  0847
         B     @RC00826                                            0847
@RF00826 L     @01,MVENTPTR                                        0847
         NI    MVBNDVOL(@01),B'11111011'                           0847
*     /***************************************************************/
*     /*                                                             */
*     /* CHECK PAGE ALLOCATION INFORMATION FOR CONSISTENCY   @Z40LB61*/
*     /* AMONG RELATED TABLES.                               @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0848
*     CALL MVTPAGES;                /*                       @Z40LB61*/
@RC00826 BAL   @14,MVTPAGES                                        0848
*     ENTRYID=SAVEID;               /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0849
         L     @01,EARGPTR(,@15)                                   0849
         MVC   ENTRYID(12,@01),SAVEID                              0849
*   END MVTLOOP1;                   /*                       @Z40LB61*/
@DE00804 SLR   @15,@15                                             0850
         L     @14,@PC00001+8                                      0850
         CH    @15,LASTCOND(,@14)                                  0850
         BE    @DL00804                                            0850
*   IF GDTDBG=NULLPTR THEN                                         0851
         L     @14,@PC00001                                        0851
         C     @15,GDTDBG(,@14)                                    0851
         BE    @RT00851                                            0851
*     ;                                                            0852
*   ELSE                                                           0853
*     CALL IDCDB010(GDTTBL,'CH2Y'); /*                       @Z40LB61*/
         L     @15,@PC00001                                        0853
         ST    @15,@AL00001                                        0853
         LA    @14,@CC01559                                        0853
         ST    @14,@AL00001+4                                      0853
         MVI   @AL00001+4,X'80'                                    0853
         L     @15,GDTDBG(,@15)                                    0853
         LA    @01,@AL00001                                        0853
         BALR  @14,@15                                             0853
*   END MVTLOOP;                    /*                       @Z40LB61*/
         B     @EL00003                                            0854
*                                                                  0855
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - CHKMVTVI                                @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES INFORMATION BETWEEN     @Z40LB61*/
*/*            AN MSC MOUNTED VOLUME TABLE ENTRY AND ITS     @Z40LB61*/
*/*            CORRESPONDING MSC VOLUME INVENTORY ENTRY.     @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*        (2) MSC VOLUME INVENTORY TABLE                    @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  0855
*CHKMVTVI:                                                         0855
*   PROCEDURE;                      /*                       @Z40LB61*/
CHKMVTVI STM   @14,@12,@SA00004                                    0855
*   OLDERID2=NEWERID2;                                             0856
         L     @15,@PC00001                                        0856
         L     @14,GDTTR2(,@15)                                    0856
         MVC   @TS00001(95),NEWERID2(@14)                          0856
         MVC   OLDERID2(95,@14),@TS00001                           0856
*   NEWID2='CH2F';                  /*                       @Z40LB61*/
*                                                                  0857
         MVC   NEWID2(4,@14),@CC01563                              0857
*   /*****************************************************************/
*   /*                                                               */
*   /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES.         @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0858
*   VITBL(1)=ON;                    /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      0858
         L     @05,MARGPTR(,@14)                                   0858
         OI    VITBL(@05),B'01000000'                              0858
*   MVTTBL(2)=ON;                   /*                       @Z40LB61*/
*                                                                  0859
         OI    MVTTBL+4(@05),B'10000000'                           0859
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN THE VOLUME INVENTORY ENTRY CORRESPONDING       @Z40LB61*/
*   /* TO THE VOLUME IN THE MVT.                             @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0860
*   TABLEID=VITBLID;                /*                       @Z40LB61*/
         L     @05,EARGPTR(,@14)                                   0860
         MVC   TABLEID(1,@05),VITBLID                              0860
*   VOLID=MVVOLID;                  /*                       @Z40LB61*/
         L     @04,MVENTPTR                                        0861
         MVC   VOLID(6,@05),MVVOLID(@04)                           0861
*   CALL IDCCH03(GDTTBL,CDALIST);   /*                       @Z40LB61*/
         ST    @15,@AL00001                                        0862
         ST    @14,@AL00001+4                                      0862
         L     @15,@CV01494                                        0862
         LA    @01,@AL00001                                        0862
         BALR  @14,@15                                             0862
*   IF GETRC=TABLERR THEN                                          0863
         LA    @15,12                                              0863
         L     @14,@PC00001+4                                      0863
         L     @01,EARGPTR(,@14)                                   0863
         CH    @15,GETRC(,@01)                                     0863
         BNE   @RF00863                                            0863
*     DO;                           /*                       @Z40LB61*/
*       LASTCOND=LASTCC12;          /*                       @Z40LB61*/
         L     @14,@PC00001+8                                      0865
         STH   @15,LASTCOND(,@14)                                  0865
*       RETURN;                     /*                       @Z40LB61*/
@EL00004 DS    0H                                                  0866
@EF00004 DS    0H                                                  0866
@ER00004 LM    @14,@12,@SA00004                                    0866
         BR    @14                                                 0866
*     END;                          /*                       @Z40LB61*/
*   ELSE                                                           0868
*                                                                  0868
*     /***************************************************************/
*     /*                                                             */
*     /* IF NO MATCHING VI ENTRY WAS FOUND, PRINT AN         @Z40LB61*/
*     /* ERROR MESSAGE.                                      @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0868
*     IF GETRC=NOTFOUND THEN                                       0868
@RF00863 L     @15,@PC00001+4                                      0868
         L     @01,EARGPTR(,@15)                                   0868
         CLC   GETRC(2,@01),@CH00183                               0868
         BNE   @RF00868                                            0868
*       DO;                         /*                       @Z40LB61*/
*         MTCHMSG=ON;               /*                       @Z40LB61*/
         L     @14,MARGPTR(,@15)                                   0870
         OI    MTCHMSG(@14),B'00010000'                            0870
*         VSNFLD=ON;                /*                       @Z40LB61*/
         OI    VSNFLD(@14),B'00000001'                             0871
*         FLDCHAR(1)=MVVOLID;       /*                       @Z40LB61*/
         MVI   FLDCHAR+6(@14),C' '                                 0872
         MVC   FLDCHAR+7(5,@14),FLDCHAR+6(@14)                     0872
         L     @01,MVENTPTR                                        0872
         MVC   FLDCHAR(6,@14),MVVOLID(@01)                         0872
*         CALL IDCCH04(GDTTBL,CDALIST);/*                    @Z40LB61*/
         L     @14,@PC00001                                        0873
         ST    @14,@AL00001                                        0873
         ST    @15,@AL00001+4                                      0873
         L     @15,@CV01495                                        0873
         LA    @01,@AL00001                                        0873
         BALR  @14,@15                                             0873
*       END;                        /*                       @Z40LB61*/
*     ELSE                                                         0875
*                                                                  0875
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE VI ENTRY WAS FOUND, PREPARE TO CHECK       @Z40LB61*/
*       /* FOR CONSISTENCY OF COMMON INFORMATION.            @Z40LB61*/
*       /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES.     @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0875
*MVTVIM:                                                           0875
*       DO;                         /*                       @Z40LB61*/
         B     @RC00868                                            0875
@RF00868 DS    0H                                                  0875
MVTVIM   DS    0H                                                  0876
*         VIENTPTR=TBLADDR;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0876
         L     @14,EARGPTR(,@15)                                   0876
         L     @05,TBLADDR(,@14)                                   0876
         ST    @05,VIENTPTR                                        0876
*         INCNMSG=ON;               /*                       @Z40LB61*/
         L     @04,MARGPTR(,@15)                                   0877
         OI    INCNMSG(@04),B'10000000'                            0877
*         CHRINDEX(1)=PREVCHR;      /*                       @Z40LB61*/
         MVC   CHRINDEX(5,@04),PREVCHR(@14)                        0878
*         VSNINDEX(1)=VOLID;        /*                       @Z40LB61*/
         MVC   VSNINDEX(6,@04),VOLID(@14)                          0879
*         MSGNRSET=ON;              /*                       @Z40LB61*/
         OI    MSGNRSET(@04),B'00000001'                           0880
*         TBLNRSET(1)=ON;           /*                       @Z40LB61*/
         OI    TBLNRSET(@04),B'00000001'                           0881
*         TBLNRSET(2)=ON;           /*                       @Z40LB61*/
*                                                                  0882
         OI    TBLNRSET+4(@04),B'00000001'                         0882
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK FOR MATCHING 'SECURE VOLUME' STATUS.      @Z40LB61*/
*         /* IF INCONSISTENT, PRINT AN ERROR MESSAGE.        @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0883
*         IF VISECVOL=ON&MVSECVOL=OFF THEN                         0883
         TM    VISECVOL(@05),B'00100000'                           0883
         BNO   @RF00883                                            0883
         L     @01,MVENTPTR                                        0883
         TM    MVSECVOL(@01),B'00100000'                           0883
         BNZ   @RF00883                                            0883
*           DO;                     /*                       @Z40LB61*/
*             VSSFLD=ON;            /*                       @Z40LB61*/
         OI    VSSFLD(@04),B'01000000'                             0885
*             FLDCHAR(1)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@04),C' '                                 0886
         MVC   FLDCHAR+4(8,@04),FLDCHAR+3(@04)                     0886
         MVC   FLDCHAR(3,@04),@CC01343                             0886
*             FLDCHAR(2)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@04),C' '                                0887
         MVC   FLDCHAR+16(8,@04),FLDCHAR+15(@04)                   0887
         MVC   FLDCHAR+12(3,@04),@CC01345                          0887
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0888
         ST    @14,@AL00001                                        0888
         ST    @15,@AL00001+4                                      0888
         L     @15,@CV01495                                        0888
         LA    @01,@AL00001                                        0888
         BALR  @14,@15                                             0888
*           END;                    /*                       @Z40LB61*/
*         IF VISECVOL=OFF&MVSECVOL=ON THEN                         0890
@RF00883 L     @01,VIENTPTR                                        0890
         TM    VISECVOL(@01),B'00100000'                           0890
         BNZ   @RF00890                                            0890
         L     @01,MVENTPTR                                        0890
         TM    MVSECVOL(@01),B'00100000'                           0890
         BNO   @RF00890                                            0890
*           DO;                     /*                       @Z40LB61*/
*             VSSFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0892
         L     @14,MARGPTR(,@15)                                   0892
         OI    VSSFLD(@14),B'01000000'                             0892
*             FLDCHAR(1)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0893
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0893
         MVC   FLDCHAR(3,@14),@CC01345                             0893
*             FLDCHAR(2)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0894
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0894
         MVC   FLDCHAR+12(3,@14),@CC01343                          0894
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0895
         ST    @14,@AL00001                                        0895
         ST    @15,@AL00001+4                                      0895
         L     @15,@CV01495                                        0895
         LA    @01,@AL00001                                        0895
         BALR  @14,@15                                             0895
*           END;                    /*                       @Z40LB61*/
*                                                                  0896
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK FOR MATCHING 'EXCLUSIVE VOLUME' STATUS.   @Z40LB61*/
*         /* IF INCONSISTENT, PRINT AN ERROR MESSAGE.        @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0897
*         IF VIEXCVOL=ON&MVEXCVOL=OFF THEN                         0897
@RF00890 L     @01,VIENTPTR                                        0897
         TM    VIEXCVOL(@01),B'00010000'                           0897
         BNO   @RF00897                                            0897
         L     @01,MVENTPTR                                        0897
         TM    MVEXCVOL(@01),B'00010000'                           0897
         BNZ   @RF00897                                            0897
*           DO;                     /*                       @Z40LB61*/
*             VESFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0899
         L     @14,MARGPTR(,@15)                                   0899
         OI    VESFLD(@14),B'00100000'                             0899
*             FLDCHAR(1)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0900
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0900
         MVC   FLDCHAR(3,@14),@CC01343                             0900
*             FLDCHAR(2)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0901
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0901
         MVC   FLDCHAR+12(3,@14),@CC01345                          0901
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0902
         ST    @14,@AL00001                                        0902
         ST    @15,@AL00001+4                                      0902
         L     @15,@CV01495                                        0902
         LA    @01,@AL00001                                        0902
         BALR  @14,@15                                             0902
*           END;                    /*                       @Z40LB61*/
*         IF VIEXCVOL=OFF&MVEXCVOL=ON THEN                         0904
@RF00897 L     @01,VIENTPTR                                        0904
         TM    VIEXCVOL(@01),B'00010000'                           0904
         BNZ   @RF00904                                            0904
         L     @01,MVENTPTR                                        0904
         TM    MVEXCVOL(@01),B'00010000'                           0904
         BNO   @RF00904                                            0904
*           DO;                     /*                       @Z40LB61*/
*             VESFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0906
         L     @14,MARGPTR(,@15)                                   0906
         OI    VESFLD(@14),B'00100000'                             0906
*             FLDCHAR(1)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0907
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0907
         MVC   FLDCHAR(3,@14),@CC01345                             0907
*             FLDCHAR(2)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0908
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0908
         MVC   FLDCHAR+12(3,@14),@CC01343                          0908
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0909
         ST    @14,@AL00001                                        0909
         ST    @15,@AL00001+4                                      0909
         L     @15,@CV01495                                        0909
         LA    @01,@AL00001                                        0909
         BALR  @14,@15                                             0909
*           END;                    /*                       @Z40LB61*/
*                                                                  0910
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK FOR MATCHING 'BOUND VOLUME' STATUS.       @Z40LB61*/
*         /* IF INCONSISTENT, PRINT AN ERROR MESSAGE.        @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0911
*         IF VIBNDVOL=ON&MVBNDVOL=OFF THEN                         0911
@RF00904 L     @01,VIENTPTR                                        0911
         TM    VIBNDVOL(@01),B'00000100'                           0911
         BNO   @RF00911                                            0911
         L     @01,MVENTPTR                                        0911
         TM    MVBNDVOL(@01),B'00000100'                           0911
         BNZ   @RF00911                                            0911
*           DO;                     /*                       @Z40LB61*/
*             VBSFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0913
         L     @14,MARGPTR(,@15)                                   0913
         OI    VBSFLD(@14),B'00010000'                             0913
*             FLDCHAR(1)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0914
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0914
         MVC   FLDCHAR(3,@14),@CC01343                             0914
*             FLDCHAR(2)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0915
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0915
         MVC   FLDCHAR+12(3,@14),@CC01345                          0915
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0916
         ST    @14,@AL00001                                        0916
         ST    @15,@AL00001+4                                      0916
         L     @15,@CV01495                                        0916
         LA    @01,@AL00001                                        0916
         BALR  @14,@15                                             0916
*           END;                    /*                       @Z40LB61*/
*         IF VIBNDVOL=OFF&MVBNDVOL=ON THEN                         0918
@RF00911 L     @01,VIENTPTR                                        0918
         TM    VIBNDVOL(@01),B'00000100'                           0918
         BNZ   @RF00918                                            0918
         L     @01,MVENTPTR                                        0918
         TM    MVBNDVOL(@01),B'00000100'                           0918
         BNO   @RF00918                                            0918
*           DO;                     /*                       @Z40LB61*/
*             VBSFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0920
         L     @14,MARGPTR(,@15)                                   0920
         OI    VBSFLD(@14),B'00010000'                             0920
*             FLDCHAR(1)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0921
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0921
         MVC   FLDCHAR(3,@14),@CC01345                             0921
*             FLDCHAR(2)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0922
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0922
         MVC   FLDCHAR+12(3,@14),@CC01343                          0922
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0923
         ST    @14,@AL00001                                        0923
         ST    @15,@AL00001+4                                      0923
         L     @15,@CV01495                                        0923
         LA    @01,@AL00001                                        0923
         BALR  @14,@15                                             0923
*           END;                    /*                       @Z40LB61*/
*                                                                  0924
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK FOR MATCHING 'WRITE INHIBIT' STATUS.      @Z40LB61*/
*         /* IF INCONSISTENT, PRINT AN ERROR MESSAGE.        @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0925
*         IF VIWRTINH=ON&MVWRTINH=OFF THEN                         0925
@RF00918 L     @01,VIENTPTR                                        0925
         TM    VIWRTINH(@01),B'00000010'                           0925
         BNO   @RF00925                                            0925
         L     @01,MVENTPTR                                        0925
         TM    MVWRTINH(@01),B'00000010'                           0925
         BNZ   @RF00925                                            0925
*           DO;                     /*                       @Z40LB61*/
*             WISFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0927
         L     @14,MARGPTR(,@15)                                   0927
         OI    WISFLD(@14),B'00000100'                             0927
*             FLDCHAR(1)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0928
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0928
         MVC   FLDCHAR(3,@14),@CC01343                             0928
*             FLDCHAR(2)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0929
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0929
         MVC   FLDCHAR+12(3,@14),@CC01345                          0929
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0930
         ST    @14,@AL00001                                        0930
         ST    @15,@AL00001+4                                      0930
         L     @15,@CV01495                                        0930
         LA    @01,@AL00001                                        0930
         BALR  @14,@15                                             0930
*           END;                    /*                       @Z40LB61*/
*         IF VIWRTINH=OFF&MVWRTINH=ON THEN                         0932
@RF00925 L     @01,VIENTPTR                                        0932
         TM    VIWRTINH(@01),B'00000010'                           0932
         BNZ   @RF00932                                            0932
         L     @01,MVENTPTR                                        0932
         TM    MVWRTINH(@01),B'00000010'                           0932
         BNO   @RF00932                                            0932
*           DO;                     /*                       @Z40LB61*/
*             WISFLD=ON;            /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0934
         L     @14,MARGPTR(,@15)                                   0934
         OI    WISFLD(@14),B'00000100'                             0934
*             FLDCHAR(1)=STATNO;    /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 0935
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     0935
         MVC   FLDCHAR(3,@14),@CC01345                             0935
*             FLDCHAR(2)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                0936
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   0936
         MVC   FLDCHAR+12(3,@14),@CC01343                          0936
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        0937
         ST    @14,@AL00001                                        0937
         ST    @15,@AL00001+4                                      0937
         L     @15,@CV01495                                        0937
         LA    @01,@AL00001                                        0937
         BALR  @14,@15                                             0937
*           END;                    /*                       @Z40LB61*/
*                                                                  0938
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK FOR MATCHING CELL ADDRESSES. IF           @Z40LB61*/
*         /* INCONSISTENT, PRINT AN ERROR MESSAGE.           @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0939
*         IF VILZYX1^=MVLZYX1 THEN                                 0939
@RF00932 L     @15,VIENTPTR                                        0939
         L     @14,MVENTPTR                                        0939
         CLC   VILZYX1(2,@15),MVLZYX1(@14)                         0939
         BE    @RF00939                                            0939
*           DO;                     /*                       @Z40LB61*/
*             CAFLD=ON;             /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      0941
         L     @04,MARGPTR(,@05)                                   0941
         OI    CAFLD(@04),B'00010000'                              0941
*             FLDNUM(1)=VILZYX1;    /*                       @Z40LB61*/
         SLR   @03,@03                                             0942
         ICM   @03,3,VILZYX1(@15)                                  0942
         ST    @03,FLDNUM(,@04)                                    0942
*             FLDNUM(2)=MVLZYX1;    /*                       @Z40LB61*/
         SLR   @15,@15                                             0943
         ICM   @15,3,MVLZYX1(@14)                                  0943
         ST    @15,FLDNUM+12(,@04)                                 0943
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @04,@PC00001                                        0944
         ST    @04,@AL00001                                        0944
         ST    @05,@AL00001+4                                      0944
         L     @15,@CV01495                                        0944
         LA    @01,@AL00001                                        0944
         BALR  @14,@15                                             0944
*           END;                    /*                       @Z40LB61*/
*         IF VILZYX2^=MVLZYX2 THEN                                 0946
@RF00939 L     @15,VIENTPTR                                        0946
         L     @14,MVENTPTR                                        0946
         CLC   VILZYX2(2,@15),MVLZYX2(@14)                         0946
         BE    @RF00946                                            0946
*           DO;                     /*                       @Z40LB61*/
*             CAFLD=ON;             /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      0948
         L     @04,MARGPTR(,@05)                                   0948
         OI    CAFLD(@04),B'00010000'                              0948
*             FLDNUM(1)=VILZYX2;    /*                       @Z40LB61*/
         SLR   @03,@03                                             0949
         ICM   @03,3,VILZYX2(@15)                                  0949
         ST    @03,FLDNUM(,@04)                                    0949
*             FLDNUM(2)=MVLZYX2;    /*                       @Z40LB61*/
         SLR   @15,@15                                             0950
         ICM   @15,3,MVLZYX2(@14)                                  0950
         ST    @15,FLDNUM+12(,@04)                                 0950
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @04,@PC00001                                        0951
         ST    @04,@AL00001                                        0951
         ST    @05,@AL00001+4                                      0951
         L     @15,@CV01495                                        0951
         LA    @01,@AL00001                                        0951
         BALR  @14,@15                                             0951
*           END;                    /*                       @Z40LB61*/
*                                                                  0952
*         /***********************************************************/
*         /*                                                         */
*         /* RESET THE 'IDCCH04' OPTION FLAGS                @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0953
*         MSGTYPE=''B;              /*                       @Z40LB61*/
@RF00946 L     @15,@PC00001+4                                      0953
         L     @15,MARGPTR(,@15)                                   0953
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         0953
*         TBLTYPE(1)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         0954
*         TBLTYPE(2)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     0955
*       END MVTVIM;                 /*                       @Z40LB61*/
*   END CHKMVTVI;                   /*                       @Z40LB61*/
         B     @EL00004                                            0957
*                                                                  0958
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - MVTVVAS                                 @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES MVT VVA-RELATED DATA    @Z40LB61*/
*/*            AGAINST VVA-RELATED DATA IN CORRESPONDING     @Z40LB61*/
*/*            MSC AND SA TABLES.                            @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*        (2) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*        (3) MSC VIRTUAL VOLUME ADDRESS TABLE              @Z40LB61*/
*/*        (4) MSC VVA/MVT CROSS REFERENCE TABLE             @Z40LB61*/
*/*        (5) SA VIRTUAL VOLUME INFORMATION TABLE           @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*        (3) VVAT CHECK-OFF TABLE                          @Z40LB61*/
*/*        (4) VVA/MVT XREF CHECK-OFF TABLE                  @Z40LB61*/
*/*        (5) VVIT CHECK-OFF TABLE                          @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  0958
*MVTVVAS:                                                          0958
*   PROCEDURE;                      /*                       @Z40LB61*/
MVTVVAS  STM   @14,@12,@SA00005                                    0958
*   OLDERID2=NEWERID2;                                             0959
         L     @15,@PC00001                                        0959
         L     @15,GDTTR2(,@15)                                    0959
         MVC   @TS00001(95),NEWERID2(@15)                          0959
         MVC   OLDERID2(95,@15),@TS00001                           0959
*   NEWID2='CH2G';                  /*                       @Z40LB61*/
*                                                                  0960
         MVC   NEWID2(4,@15),@CC01569                              0960
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE THE MOUNTED STATUS OF THE VOLUME WITH       @Z40LB61*/
*   /* RESPECT TO SA PATHS. FOR CHECKING PURPOSES,           @Z40LB61*/
*   /* A VALID SA PATH IS OF NO INTEREST IF NONE OF          @Z40LB61*/
*   /* ITS INTERFACES ARE ACTIVE.                            @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0961
*   DO MVPATH#=1 TO SASSDG;         /*                       @Z40LB61*/
         LA    @15,1                                               0961
         STH   @15,MVPATH#                                         0961
@DL00961 DS    0H                                                  0962
*     IF MVVLDSA(MVPATH#)=ON&(MVACTB(MVPATH#)=ON|MVACTC(MVPATH#)=ON|
*         MVACTD(MVPATH#)=ON) THEN                                 0962
         L     @14,MVENTPTR                                        0962
         LR    @05,@15                                             0962
         SLA   @05,3                                               0962
         ST    @05,@TF00001                                        0962
         ALR   @05,@14                                             0962
         TM    MVVLDSA-8(@05),B'10000000'                          0962
         BNO   @RF00962                                            0962
         AL    @14,@TF00001                                        0962
         TM    MVACTB-8(@14),B'01110000'                           0962
         BZ    @RF00962                                            0962
*       ACTIVSA(MVPATH#)=ON;        /*                       @Z40LB61*/
         LA    @14,ACTIVSA-1(@15)                                  0963
         OI    0(@14),B'10000000'                                  0963
*     ELSE                                                         0964
*       ACTIVSA(MVPATH#)=OFF;       /*                       @Z40LB61*/
         B     @RC00962                                            0964
@RF00962 LH    @01,MVPATH#                                         0964
         LA    @15,ACTIVSA-1(@01)                                  0964
         NI    0(@15),B'01111111'                                  0964
*   END;                            /*                       @Z40LB61*/
@RC00962 LA    @15,1                                               0965
         AH    @15,MVPATH#                                         0965
         STH   @15,MVPATH#                                         0965
         CH    @15,@CH00157                                        0965
         BNH   @DL00961                                            0965
*   IF ACTIVSA(1)=ON&ACTIVSA(2)=ON THEN                            0966
         TM    ACTIVSA,B'10000000'                                 0966
         BNO   @RF00966                                            0966
         TM    ACTIVSA+1,B'10000000'                               0966
         BNO   @RF00966                                            0966
*     MVSHARED=ON;                  /*                       @Z40LB61*/
         OI    MVSHARED,B'10000000'                                0967
*   ELSE                                                           0968
*     MVSHARED=OFF;                 /*                       @Z40LB61*/
*                                                                  0968
         B     @RC00966                                            0968
@RF00966 NI    MVSHARED,B'01111111'                                0968
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FIELDS RELATED TO EACH VALID SA PATH            @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0969
*SALOOP1:                                                          0969
*   DO MVPATH#=1 TO SASSDG;         /*                       @Z40LB61*/
@RC00966 DS    0H                                                  0969
SALOOP1  LA    @15,1                                               0969
         STH   @15,MVPATH#                                         0969
@DL00969 DS    0H                                                  0970
*     IF ACTIVSA(MVPATH#)=ON THEN                                  0970
*                                                                  0970
         LA    @14,ACTIVSA-1(@15)                                  0970
         TM    0(@14),B'10000000'                                  0970
         BNO   @RF00970                                            0970
*       /*************************************************************/
*       /*                                                           */
*       /* FOR AN SA WITH AT LEAST ONE ACTIVE INTERFACE,     @Z40LB61*/
*       /* CHECK RELATED FIELDS.                             @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0971
*ACTIVESA:                                                         0971
*       DO;                         /*                       @Z40LB61*/
ACTIVESA DS    0H                                                  0972
*         MVSA#=MVSA(MVPATH#)&MASK15;/*                      @Z40LB61*/
         LH    @15,MVPATH#                                         0972
         SLA   @15,3                                               0972
         L     @01,MVENTPTR                                        0972
         SLR   @14,@14                                             0972
         IC    @14,MVSA-8(@15,@01)                                 0972
         SLR   @15,@15                                             0972
         IC    @15,MASK15                                          0972
         NR    @14,@15                                             0972
         STH   @14,MVSA#                                           0972
*         SA#=MVSA#+1;              /*                       @Z40LB61*/
*                                                                  0973
         AH    @14,@CH00223                                        0973
         STH   @14,SA#                                             0973
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SA# OR VVA# FROM THE MVT ENTRY IS        @Z40LB61*/
*         /* INVALID, PRINT AN ERROR MESSAGE. DON'T DO ANY   @Z40LB61*/
*         /* FURTHER CHECKING INVOLVING THIS SA.             @Z40LB61*/
*         /* IF THE SA# IS OFFLINE OR SUU THEN SKIP PROCESS- @ZA27324*/
*         /* ING THIS PARTICULAR SA.                         @ZA27324*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0974
*         IF IVVITPTR(SA#)=NULLPTR| /*                       @ZA27324*/
*             IVVITPTR(SA#)=DUMMYPTR THEN/*                  @ZA27324*/
         SLA   @14,2                                               0974
         L     @15,@PC00001+4                                      0974
         L     @15,IVVITPTR-4(@14,@15)                             0974
         LTR   @15,@15                                             0974
         BZ    @RT00974                                            0974
         C     @15,DUMMYPTR                                        0974
         BNE   @RF00974                                            0974
@RT00974 DS    0H                                                  0975
*           DO;                     /*                       @ZA27324*/
*             IF IVVITPTR(SA#)=DUMMYPTR THEN                       0976
         LH    @15,SA#                                             0976
         SLA   @15,2                                               0976
         L     @14,@PC00001+4                                      0976
         L     @15,IVVITPTR-4(@15,@14)                             0976
         C     @15,DUMMYPTR                                        0976
         BE    @RT00976                                            0976
*               ;                   /*                       @ZA27324*/
*             ELSE                  /*                       @ZA27324*/
*               DO;                 /*                       @ZA27324*/
*                 MTCHMSG=ON;       /*                       @ZA27324*/
         L     @15,@PC00001+4                                      0979
         L     @14,MARGPTR(,@15)                                   0979
         OI    MTCHMSG(@14),B'00010000'                            0979
*                 CBMTBL(1)=ON;     /*                       @ZA27324*/
         OI    CBMTBL(@14),B'00001000'                             0980
*                 MVTTBL(2)=ON;     /*                       @ZA27324*/
         OI    MVTTBL+4(@14),B'10000000'                           0981
*                 SAFLD=ON;         /*                       @ZA27324*/
         OI    SAFLD(@14),B'00001000'                              0982
*                 FLDNUM(1)=MVSA#;  /*                       @ZA27324*/
         LH    @05,MVSA#                                           0983
         ST    @05,FLDNUM(,@14)                                    0983
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @ZA27324*/
         L     @14,@PC00001                                        0984
         ST    @14,@AL00001                                        0984
         ST    @15,@AL00001+4                                      0984
         L     @15,@CV01495                                        0984
         LA    @01,@AL00001                                        0984
         BALR  @14,@15                                             0984
*               END;                /*                       @ZA27324*/
*           END;                    /*                       @Z40LB61*/
*         ELSE                                                     0987
*           IF MVVVA(MVPATH#)<LOWVVA THEN                          0987
         B     @RC00974                                            0987
@RF00974 LH    @15,MVPATH#                                         0987
         SLA   @15,3                                               0987
         L     @01,MVENTPTR                                        0987
         SLR   @14,@14                                             0987
         IC    @14,MVVVA-8(@15,@01)                                0987
         CH    @14,@CH00580                                        0987
         BNL   @RF00987                                            0987
*             DO;                   /*                       @Z40LB61*/
*               MTCHMSG=ON;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      0989
         L     @05,MARGPTR(,@15)                                   0989
         OI    MTCHMSG(@05),B'00010000'                            0989
*               VVATTBL(1)=ON;      /*                       @Z40LB61*/
         OI    VVATTBL(@05),B'10000000'                            0990
*               MVTTBL(2)=ON;       /*                       @Z40LB61*/
         OI    MVTTBL+4(@05),B'10000000'                           0991
*               VVAFLD=ON;          /*                       @Z40LB61*/
         OI    VVAFLD(@05),B'01000000'                             0992
*               FLDNUM(1)=MVVVA(MVPATH#);/*                  @Z40LB61*/
         ST    @14,FLDNUM(,@05)                                    0993
*               CALL IDCCH04(GDTTBL,CDALIST);/*              @Z40LB61*/
         L     @14,@PC00001                                        0994
         ST    @14,@AL00001                                        0994
         ST    @15,@AL00001+4                                      0994
         L     @15,@CV01495                                        0994
         LA    @01,@AL00001                                        0994
         BALR  @14,@15                                             0994
*             END;                  /*                       @Z40LB61*/
*           ELSE                                                   0996
*                                                                  0996
*             /*******************************************************/
*             /*                                                     */
*             /* IF SA AND VVA ARE VALID, PREPARE TO COMPARE @Z40LB61*/
*             /* WITH VVA-RELATED SA AND MSC TABLES.         @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0996
*SAVVAOK:                                                          0996
*             DO;                   /*                       @Z40LB61*/
         B     @RC00987                                            0996
@RF00987 DS    0H                                                  0996
SAVVAOK  DS    0H                                                  0997
*               OLDERID2=NEWERID2;                                 0997
         L     @15,@PC00001                                        0997
         L     @15,GDTTR2(,@15)                                    0997
         MVC   @TS00001(95),NEWERID2(@15)                          0997
         MVC   OLDERID2(95,@15),@TS00001                           0997
*               NEWID2='CH2H';      /*                       @Z40LB61*/
         MVC   NEWID2(4,@15),@CC01576                              0998
*               WORKVVA=MVVVA(MVPATH#)-LOWVVA+1;/*           @Z40LB61*/
         LH    @15,MVPATH#                                         0999
         SLA   @15,3                                               0999
         L     @01,MVENTPTR                                        0999
         SLR   @14,@14                                             0999
         IC    @14,MVVVA-8(@15,@01)                                0999
         AH    @14,@CH01729                                        0999
         STH   @14,WORKVVA                                         0999
*               BYTE#=(WORKVVA-1)/8+1;/*                     @Z40LB61*/
         L     @15,@PC00001+4                                      1000
         L     @05,EARGPTR(,@15)                                   1000
         LA    @04,1                                               1000
         BCTR  @14,0                                               1000
         LR    @00,@14                                             1000
         SRDA  @00,32                                              1000
         D     @00,@CF00183                                        1000
         ALR   @01,@04                                             1000
         STH   @01,BYTE#(,@05)                                     1000
*               BIT#=(WORKVVA-1)//8+1;/*                     @Z40LB61*/
*                                                                  1001
         SRDA  @14,32                                              1001
         D     @14,@CF00183                                        1001
         ALR   @14,@04                                             1001
         STH   @14,BIT#(,@05)                                      1001
*               /*****************************************************/
*               /*                                                   */
*               /* CHECK THAT THE BIT IN THE MSC VIRTUAL     @Z40LB61*/
*               /* VOLUME ADDRESS TABLE THAT CORRESPONDS TO  @Z40LB61*/
*               /* CURRENT VVA IS 'IN USE'.                  @ZD00043*/
*               /* IF 'IN USE', CHECK-OFF THAT VVA. IF NOT,  @Z40LB61*/
*               /* PRINT AN ERROR MESSAGE.                   @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1002
*               VVATPTR=VVATADDR+LENGTH(VVAT)*MVSA#;/*       @Z40LB61*/
         L     @15,@PC00001+4                                      1002
         LH    @00,MVSA#                                           1002
         SLA   @00,5                                               1002
         AL    @00,VVATADDR(,@15)                                  1002
         ST    @00,VVATPTR                                         1002
*               IF(VVATVVA(BYTE#)&BITMASK(BIT#))^=0 THEN           1003
         LR    @05,@00                                             1003
         AL    @05,@CF01340                                        1003
         SLR   @04,@04                                             1003
         IC    @04,VVATVVA(@01,@05)                                1003
         SLR   @05,@05                                             1003
         IC    @05,BITMASK-1(@14)                                  1003
         NR    @04,@05                                             1003
         LTR   @04,@04                                             1003
         BZ    @RF01003                                            1003
*                 VVACHKFF(SA#,BYTE#)=VVACHKFF(SA#,BYTE#)|BITMASK(BIT#)
*                   ;               /*                       @Z40LB61*/
         LH    @05,SA#                                             1004
         MH    @05,@CH00314                                        1004
         ALR   @05,@01                                             1004
         L     @01,VVACOPTR(,@15)                                  1004
         ALR   @01,@05                                             1004
         AL    @01,@CF01759                                        1004
         LA    @15,BITMASK-1(@14)                                  1004
         OC    VVACHKFF(1,@01),0(@15)                              1004
*               ELSE                                               1005
*                 DO;               /*                       @Z40LB61*/
         B     @RC01003                                            1005
@RF01003 DS    0H                                                  1006
*                   INCNMSG=ON;     /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1006
         L     @15,MARGPTR(,@15)                                   1006
         OI    INCNMSG(@15),B'10000000'                            1006
*                   VVATTBL(1)=ON;  /*                       @Z40LB61*/
         OI    VVATTBL(@15),B'10000000'                            1007
*                   MVTTBL(2)=ON;   /*                       @Z40LB61*/
         OI    MVTTBL+4(@15),B'10000000'                           1008
*                   IUSFLD=ON;      /*                       @Z40LB61*/
         OI    IUSFLD(@15),B'00000001'                             1009
*                   FLDCHAR(1)=STATNO;/*                     @Z40LB61*/
         MVI   FLDCHAR+3(@15),C' '                                 1010
         MVC   FLDCHAR+4(8,@15),FLDCHAR+3(@15)                     1010
         MVC   FLDCHAR(3,@15),@CC01345                             1010
*                   FLDCHAR(2)=STATYES;/*                    @Z40LB61*/
         MVI   FLDCHAR+15(@15),C' '                                1011
         MVC   FLDCHAR+16(8,@15),FLDCHAR+15(@15)                   1011
         MVC   FLDCHAR+12(3,@15),@CC01343                          1011
*                   IF MVSA#<SAMAX/2 THEN                          1012
         LH    @14,MVSA#                                           1012
         CH    @14,@CH00183                                        1012
         BNL   @RF01012                                            1012
*                     CHRINDEX(1)=VVATCHR(1);/*              @Z40LB61*/
         MVC   CHRINDEX(5,@15),VVATCHR                             1013
*                   ELSE                                           1014
*                     CHRINDEX(1)=VVATCHR(2);/*              @Z40LB61*/
         B     @RC01012                                            1014
@RF01012 L     @15,@PC00001+4                                      1014
         L     @01,MARGPTR(,@15)                                   1014
         MVC   CHRINDEX(5,@01),VVATCHR+5                           1014
*                   SAINDEX(1)=MVSA#;/*                      @Z40LB61*/
@RC01012 L     @15,@PC00001+4                                      1015
         L     @14,MARGPTR(,@15)                                   1015
         MVC   SAINDEX(1,@14),MVSA#+1                              1015
*                   VVAINDEX(1)=MVVVA(MVPATH#);/*            @Z40LB61*/
         LH    @05,MVPATH#                                         1016
         SLA   @05,3                                               1016
         L     @01,MVENTPTR                                        1016
         SLR   @04,@04                                             1016
         IC    @04,MVVVA-8(@05,@01)                                1016
         STC   @04,VVAINDEX(,@14)                                  1016
*                   CALL IDCCH04(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @14,@PC00001                                        1017
         ST    @14,@AL00001                                        1017
         ST    @15,@AL00001+4                                      1017
         L     @15,@CV01495                                        1017
         LA    @01,@AL00001                                        1017
         BALR  @14,@15                                             1017
*                 END;              /*                       @Z40LB61*/
*                                                                  1018
*               /*****************************************************/
*               /*                                                   */
*               /* IF MSC-MSC CHECKING WAS REQUESTED, CHECK  @Z40LB61*/
*               /* FOR A VVA MATCH WITH THE MSC VVA/MVT XREF @Z40LB61*/
*               /* (VMX) TABLE.                              @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1019
*               IF MSCCHK=ON THEN                                  1019
@RC01003 L     @15,@PC00001+4                                      1019
         TM    MSCCHK(@15),B'10000000'                             1019
         BNO   @RF01019                                            1019
*VMXCHK:                                                           1020
*                 DO;               /*                       @Z40LB61*/
*                                                                  1020
VMXCHK   DS    0H                                                  1021
*                   /*************************************************/
*                   /*                                               */
*                   /* OBTAIN THE PART OF THE VMX TABLE THAT @Z40LB61*/
*                   /* SHOULD CONTAIN A VALID ENTRY FOR THE  @Z40LB61*/
*                   /* CURRENT VVA.                          @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1021
*                   TABLEID=VMXTBLID;/*                      @Z40LB61*/
         L     @15,@PC00001+4                                      1021
         L     @14,EARGPTR(,@15)                                   1021
         MVC   TABLEID(1,@14),VMXTBLID                             1021
*                   SANUM=MVSA#;    /*                       @Z40LB61*/
         MVC   SANUM(2,@14),MVSA#                                  1022
*                   VVADDR=MVVVA(MVPATH#);/*                 @Z40LB61*/
         LH    @05,MVPATH#                                         1023
         SLA   @05,3                                               1023
         L     @01,MVENTPTR                                        1023
         SLR   @04,@04                                             1023
         IC    @04,MVVVA-8(@05,@01)                                1023
         STH   @04,VVADDR(,@14)                                    1023
*                   CALL IDCCH03(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @14,@PC00001                                        1024
         ST    @14,@AL00001                                        1024
         ST    @15,@AL00001+4                                      1024
         L     @15,@CV01494                                        1024
         LA    @01,@AL00001                                        1024
         BALR  @14,@15                                             1024
*                   IF GETRC^=0 THEN                               1025
         L     @15,@PC00001+4                                      1025
         L     @01,EARGPTR(,@15)                                   1025
         ICM   @00,3,GETRC(@01)                                    1025
         BZ    @RF01025                                            1025
*                     DO;           /*                       @Z40LB61*/
*                       LASTCOND=LASTCC12;/*                 @Z40LB61*/
         L     @15,@PC00001+8                                      1027
         MVC   LASTCOND(2,@15),@CH00567                            1027
*                       RETURN;     /*                       @Z40LB61*/
@EL00005 DS    0H                                                  1028
@EF00005 DS    0H                                                  1028
@ER00005 LM    @14,@12,@SA00005                                    1028
         BR    @14                                                 1028
*                     END;          /*                       @Z40LB61*/
*                   VMXPTR=TBLADDR; /*                       @Z40LB61*/
*                                                                  1030
@RF01025 L     @15,@PC00001+4                                      1030
         L     @14,EARGPTR(,@15)                                   1030
         L     @05,TBLADDR(,@14)                                   1030
         ST    @05,VMXPTR                                          1030
*                   /*************************************************/
*                   /*                                               */
*                   /* DO COMMON SET-UP FOR POSSIBLE         @Z40LB61*/
*                   /* ERROR MESSAGES.                       @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1031
*                   SAINDEX(1)=MVSA#;/*                      @Z40LB61*/
         L     @04,MARGPTR(,@15)                                   1031
         MVC   SAINDEX(1,@04),MVSA#+1                              1031
*                   VVAINDEX(1)=VVADDR;/*                    @Z40LB61*/
         MVC   VVAINDEX(1,@04),VVADDR+1(@14)                       1032
*                   CHRINDEX(1)=PREVCHR;/*                   @Z40LB61*/
*                                                                  1033
         MVC   CHRINDEX(5,@04),PREVCHR(@14)                        1033
*                   /*************************************************/
*                   /*                                               */
*                   /* IF THE CORRESPONDING VMX ENTRY FOR    @Z40LB61*/
*                   /* THE CURRENT VVA IS NOT VALID, PRINT   @Z40LB61*/
*                   /* AN ERROR MESSAGE.                     @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1034
*                   IF VMXVALID=OFF THEN                           1034
         TM    VMXVALID(@05),B'10000000'                           1034
         BNZ   @RF01034                                            1034
*                     DO;           /*                       @Z40LB61*/
*                       VMXTBL(1)=ON;/*                      @Z40LB61*/
         OI    VMXTBL(@04),B'00000001'                             1036
*                       MVTTBL(2)=ON;/*                      @Z40LB61*/
         OI    MVTTBL+4(@04),B'10000000'                           1037
*                       INCNMSG=ON; /*                       @Z40LB61*/
         OI    INCNMSG(@04),B'10000000'                            1038
*                       IUSFLD=ON;  /*                       @Z40LB61*/
         OI    IUSFLD(@04),B'00000001'                             1039
*                       FLDCHAR(1)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+3(@04),C' '                                 1040
         MVC   FLDCHAR+4(8,@04),FLDCHAR+3(@04)                     1040
         MVC   FLDCHAR(3,@04),@CC01345                             1040
*                       FLDCHAR(2)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+15(@04),C' '                                1041
         MVC   FLDCHAR+16(8,@04),FLDCHAR+15(@04)                   1041
         MVC   FLDCHAR+12(3,@04),@CC01343                          1041
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @14,@PC00001                                        1042
         ST    @14,@AL00001                                        1042
         ST    @15,@AL00001+4                                      1042
         L     @15,@CV01495                                        1042
         LA    @01,@AL00001                                        1042
         BALR  @14,@15                                             1042
*                     END;          /*                       @Z40LB61*/
*                   ELSE                                           1044
*                                                                  1044
*                     /***********************************************/
*                     /*                                             */
*                     /* IF A VALID VMX ENTRY WAS FOUND,     @Z40LB61*/
*                     /* CHECK-OFF THAT VMX ENTRY AND CHECK  @Z40LB61*/
*                     /* THAT IT CONTAINS THE MVT POINTER    @Z40LB61*/
*                     /* TO THE CURRENT MVT ENTRY.           @Z40LB61*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  1044
*MVTVMXM:                                                          1044
*                     DO;           /*                       @Z40LB61*/
         B     @RC01034                                            1044
@RF01034 DS    0H                                                  1044
MVTVMXM  DS    0H                                                  1045
*                       VMXCHKFF(SA#,BYTE#)=VMXCHKFF(SA#,BYTE#)|BITMASK
*                           (BIT#); /*                       @Z40LB61*/
         LH    @15,SA#                                             1045
         MH    @15,@CH00314                                        1045
         L     @14,@PC00001+4                                      1045
         L     @05,EARGPTR(,@14)                                   1045
         AH    @15,BYTE#(,@05)                                     1045
         L     @01,VMXCOPTR(,@14)                                  1045
         ALR   @01,@15                                             1045
         AL    @01,@CF01759                                        1045
         LH    @15,BIT#(,@05)                                      1045
         LA    @05,BITMASK-1(@15)                                  1045
         OC    VMXCHKFF(1,@01),0(@05)                              1045
*                       IF VMXMVT^=(SAVEREC#-1) THEN               1046
         L     @01,VMXPTR                                          1046
         SLR   @15,@15                                             1046
         ICM   @15,3,VMXMVT(@01)                                   1046
         LH    @05,SAVEREC#                                        1046
         BCTR  @05,0                                               1046
         CR    @15,@05                                             1046
         BE    @RF01046                                            1046
*                         DO;       /*                       @Z40LB61*/
*                           VMXTBL(1)=ON;/*                  @Z40LB61*/
         L     @04,MARGPTR(,@14)                                   1048
         OI    VMXTBL(@04),B'00000001'                             1048
*                           MVTTBL(2)=ON;/*                  @Z40LB61*/
         OI    MVTTBL+4(@04),B'10000000'                           1049
*                           INCNMSG=ON;/*                    @Z40LB61*/
         OI    INCNMSG(@04),B'10000000'                            1050
*                           MVTPFLD=ON;/*                    @Z40LB61*/
         OI    MVTPFLD(@04),B'00100000'                            1051
*                           FLDNUM(1)=VMXMVT;/*              @Z40LB61*/
         ST    @15,FLDNUM(,@04)                                    1052
*                           FLDNUM(2)=SAVEREC#-1;/*          @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 1053
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @Z40LB61*/
         L     @15,@PC00001                                        1054
         ST    @15,@AL00001                                        1054
         ST    @14,@AL00001+4                                      1054
         L     @15,@CV01495                                        1054
         LA    @01,@AL00001                                        1054
         BALR  @14,@15                                             1054
*                         END;      /*                       @Z40LB61*/
*                     END MVTVMXM;  /*                       @Z40LB61*/
@RF01046 DS    0H                                                  1057
*                 END VMXCHK;       /*                       @Z40LB61*/
*                                                                  1057
@RC01034 DS    0H                                                  1058
*               /*****************************************************/
*               /*                                                   */
*               /* IF SA CHECKING WAS REQUESTED, CHECK THE   @Z40LB61*/
*               /* SA VIRTUAL VOLUME INFORMATION TABLE (VVIT)        */
*               /*                                           @Z40LB61*/
*               /* FOR CONSISTENCY WITH THE MVT ENTRY.       @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1058
*               IF SACHK=ON THEN                                   1058
@RF01019 L     @15,@PC00001+4                                      1058
         TM    SACHK(@15),B'01000000'                              1058
         BNO   @RF01058                                            1058
*VVITCHK:                                                          1059
*                 DO;               /*                       @Z40LB61*/
*                                                                  1059
VVITCHK  DS    0H                                                  1060
*                   /*************************************************/
*                   /*                                               */
*                   /* DO COMMON SET-UP FOR POSSIBLE ERROR   @Z40LB61*/
*                   /* MESSAGES                              @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1060
*                   VVITTBL(1)=ON;  /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1060
         L     @14,MARGPTR(,@15)                                   1060
         OI    VVITTBL(@14),B'00100000'                            1060
*                   MVTTBL(2)=ON;   /*                       @Z40LB61*/
         OI    MVTTBL+4(@14),B'10000000'                           1061
*                   INCNMSG=ON;     /*                       @Z40LB61*/
         OI    INCNMSG(@14),B'10000000'                            1062
*                   SAINDEX(1)=MVSA#;/*                      @Z40LB61*/
         MVC   SAINDEX(1,@14),MVSA#+1                              1063
*                   VVAINDEX(1)=MVVVA(MVPATH#);/*            @Z40LB61*/
         L     @05,MVENTPTR                                        1064
         LH    @04,MVPATH#                                         1064
         SLA   @04,3                                               1064
         SLR   @03,@03                                             1064
         IC    @03,MVVVA-8(@04,@05)                                1064
         STC   @03,VVAINDEX(,@14)                                  1064
*                   MSGNRSET=ON;    /*                       @Z40LB61*/
         OI    MSGNRSET(@14),B'00000001'                           1065
*                   TBLNRSET(1)=ON; /*                       @Z40LB61*/
         OI    TBLNRSET(@14),B'00000001'                           1066
*                   TBLNRSET(2)=ON; /*                       @Z40LB61*/
*                                                                  1067
         OI    TBLNRSET+4(@14),B'00000001'                         1067
*                   /*************************************************/
*                   /*                                               */
*                   /* FOR CORRESPONDING VVIT ENTRY, CHECK-OFF       */
*                   /*                                       @Z40LB61*/
*                   /* THE ENTRY AND PREPARE TO CHECK FOR    @Z40LB61*/
*                   /* CONSISTENCY IN CORRESPONDING FIELDS   @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1068
*                   VVICHKFF(BYTE#)=VVICHKFF(BYTE#)|BITMASK(BIT#);/*
*                                                            @Z40LB61*/
*                                                                  1068
         L     @04,EARGPTR(,@15)                                   1068
         LH    @01,BYTE#(,@04)                                     1068
         LH    @03,SA#                                             1068
         SLA   @03,2                                               1068
         L     @02,VVICOPTR-4(@03,@15)                             1068
         ALR   @02,@01                                             1068
         AL    @02,@CF01340                                        1068
         LH    @01,BIT#(,@04)                                      1068
         LA    @04,BITMASK-1(@01)                                  1068
         OC    VVICHKFF(1,@02),0(@04)                              1068
*                   /*************************************************/
*                   /*                                               */
*                   /* CHECK FOR MATCHING 'WRITE INHIBIT'    @Z40LB61*/
*                   /* STATUS                                @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1069
*                   IF IVVIWI(WORKVVA)=ON&MVWRTINH=OFF THEN        1069
         LH    @02,WORKVVA                                         1069
         ALR   @02,@02                                             1069
         L     @01,IVVITPTR-4(@03,@15)                             1069
         ALR   @01,@02                                             1069
         AL    @01,@CF01760                                        1069
         TM    IVVIWI(@01),B'00000010'                             1069
         BNO   @RF01069                                            1069
         TM    MVWRTINH(@05),B'00000010'                           1069
         BNZ   @RF01069                                            1069
*                     DO;           /*                       @Z40LB61*/
*                       WISFLD=ON;  /*                       @Z40LB61*/
         OI    WISFLD(@14),B'00000100'                             1071
*                       FLDCHAR(1)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1072
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1072
         MVC   FLDCHAR(3,@14),@CC01343                             1072
*                       FLDCHAR(2)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1073
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1073
         MVC   FLDCHAR+12(3,@14),@CC01345                          1073
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @14,@PC00001                                        1074
         ST    @14,@AL00001                                        1074
         ST    @15,@AL00001+4                                      1074
         L     @15,@CV01495                                        1074
         LA    @01,@AL00001                                        1074
         BALR  @14,@15                                             1074
*                     END;          /*                       @Z40LB61*/
*                   IF IVVIWI(WORKVVA)=OFF&MVWRTINH=ON THEN        1076
@RF01069 LH    @15,WORKVVA                                         1076
         ALR   @15,@15                                             1076
         LH    @14,SA#                                             1076
         SLA   @14,2                                               1076
         L     @05,@PC00001+4                                      1076
         L     @01,IVVITPTR-4(@14,@05)                             1076
         ALR   @01,@15                                             1076
         AL    @01,@CF01760                                        1076
         TM    IVVIWI(@01),B'00000010'                             1076
         BNZ   @RF01076                                            1076
         L     @01,MVENTPTR                                        1076
         TM    MVWRTINH(@01),B'00000010'                           1076
         BNO   @RF01076                                            1076
*                     DO;           /*                       @Z40LB61*/
*                       WISFLD=ON;  /*                       @Z40LB61*/
         L     @04,MARGPTR(,@05)                                   1078
         OI    WISFLD(@04),B'00000100'                             1078
*                       FLDCHAR(1)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+3(@04),C' '                                 1079
         MVC   FLDCHAR+4(8,@04),FLDCHAR+3(@04)                     1079
         MVC   FLDCHAR(3,@04),@CC01345                             1079
*                       FLDCHAR(2)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+15(@04),C' '                                1080
         MVC   FLDCHAR+16(8,@04),FLDCHAR+15(@04)                   1080
         MVC   FLDCHAR+12(3,@04),@CC01343                          1080
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @04,@PC00001                                        1081
         ST    @04,@AL00001                                        1081
         ST    @05,@AL00001+4                                      1081
         L     @15,@CV01495                                        1081
         LA    @01,@AL00001                                        1081
         BALR  @14,@15                                             1081
*                     END;          /*                       @Z40LB61*/
*                                                                  1082
*                   /*************************************************/
*                   /*                                               */
*                   /* CHECK FOR MATCHING 'SHARED VOLUME'    @Z40LB61*/
*                   /* STATUS                                @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1083
*                   IF IVVISHR(WORKVVA)=ON&MVSHARED=OFF THEN       1083
@RF01076 LH    @15,WORKVVA                                         1083
         ALR   @15,@15                                             1083
         LH    @14,SA#                                             1083
         SLA   @14,2                                               1083
         L     @05,@PC00001+4                                      1083
         L     @01,IVVITPTR-4(@14,@05)                             1083
         ALR   @01,@15                                             1083
         AL    @01,@CF01760                                        1083
         TM    IVVISHR(@01),B'00000001'                            1083
         BNO   @RF01083                                            1083
         TM    MVSHARED,B'10000000'                                1083
         BNZ   @RF01083                                            1083
*                     DO;           /*                       @Z40LB61*/
*                       VSHSFLD=ON; /*                       @Z40LB61*/
         L     @04,MARGPTR(,@05)                                   1085
         OI    VSHSFLD(@04),B'01000000'                            1085
*                       FLDCHAR(1)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+3(@04),C' '                                 1086
         MVC   FLDCHAR+4(8,@04),FLDCHAR+3(@04)                     1086
         MVC   FLDCHAR(3,@04),@CC01343                             1086
*                       FLDCHAR(2)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+15(@04),C' '                                1087
         MVC   FLDCHAR+16(8,@04),FLDCHAR+15(@04)                   1087
         MVC   FLDCHAR+12(3,@04),@CC01345                          1087
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @04,@PC00001                                        1088
         ST    @04,@AL00001                                        1088
         ST    @05,@AL00001+4                                      1088
         L     @15,@CV01495                                        1088
         LA    @01,@AL00001                                        1088
         BALR  @14,@15                                             1088
*                     END;          /*                       @Z40LB61*/
*                   IF IVVISHR(WORKVVA)=OFF&MVSHARED=ON THEN       1090
@RF01083 LH    @15,WORKVVA                                         1090
         ALR   @15,@15                                             1090
         LH    @14,SA#                                             1090
         SLA   @14,2                                               1090
         L     @05,@PC00001+4                                      1090
         L     @01,IVVITPTR-4(@14,@05)                             1090
         ALR   @01,@15                                             1090
         AL    @01,@CF01760                                        1090
         TM    IVVISHR(@01),B'00000001'                            1090
         BNZ   @RF01090                                            1090
         TM    MVSHARED,B'10000000'                                1090
         BNO   @RF01090                                            1090
*                     DO;           /*                       @Z40LB61*/
*                       VSHSFLD=ON; /*                       @Z40LB61*/
         L     @04,MARGPTR(,@05)                                   1092
         OI    VSHSFLD(@04),B'01000000'                            1092
*                       FLDCHAR(1)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+3(@04),C' '                                 1093
         MVC   FLDCHAR+4(8,@04),FLDCHAR+3(@04)                     1093
         MVC   FLDCHAR(3,@04),@CC01345                             1093
*                       FLDCHAR(2)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+15(@04),C' '                                1094
         MVC   FLDCHAR+16(8,@04),FLDCHAR+15(@04)                   1094
         MVC   FLDCHAR+12(3,@04),@CC01343                          1094
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @04,@PC00001                                        1095
         ST    @04,@AL00001                                        1095
         ST    @05,@AL00001+4                                      1095
         L     @15,@CV01495                                        1095
         LA    @01,@AL00001                                        1095
         BALR  @14,@15                                             1095
*                     END;          /*                       @Z40LB61*/
*                                                                  1096
*                   /*************************************************/
*                   /*                                               */
*                   /* IN PREPARATION FOR COMPARING RESERVED-        */
*                   /*                                       @Z40LB61*/
*                   /* VOLUME STATUS BETWEEN MVT AND VVIT,   @Z40LB61*/
*                   /* ADJUST THE INTERFACE ID'S FROM THE    @Z40LB61*/
*                   /* VVIT AND MVT SO AS TO COMPARE THEM    @Z40LB61*/
*                   /* NUMERICALLY                           @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1097
*                   WORKVAL1=IVVI2(WORKVVA)/SHIFT4;/*        @Z40LB61*/
@RF01090 LH    @15,WORKVVA                                         1097
         ALR   @15,@15                                             1097
         LH    @14,SA#                                             1097
         SLA   @14,2                                               1097
         L     @05,@PC00001+4                                      1097
         L     @01,IVVITPTR-4(@14,@05)                             1097
         AL    @01,@CF01340                                        1097
         SLR   @14,@14                                             1097
         IC    @14,IVVI2-1(@15,@01)                                1097
         SRL   @14,4                                               1097
         STH   @14,WORKVAL1                                        1097
*                   WORKVAL1=(WORKVAL1&&FLIPMASK)&MASK3;/*   @Z40LB61*/
         SLR   @15,@15                                             1098
         IC    @15,MASK3                                           1098
         SLR   @05,@05                                             1098
         IC    @05,FLIPMASK                                        1098
         XR    @14,@05                                             1098
         NR    @14,@15                                             1098
         STH   @14,WORKVAL1                                        1098
*                   WORKVAL2=MVRESRVE&MASK3;/*               @Z40LB61*/
         L     @14,MVENTPTR                                        1099
         SLR   @05,@05                                             1099
         IC    @05,MVRESRVE(,@14)                                  1099
         NR    @15,@05                                             1099
         STH   @15,WORKVAL2                                        1099
*                   ERRTYPE=0;      /*                       @Z40LB61*/
*                                                                  1100
         SLR   @14,@14                                             1100
         STH   @14,ERRTYPE                                         1100
*                   /*************************************************/
*                   /*                                               */
*                   /* A VOLUME SHOULD NOT INDICATE IT IS    @Z40LB61*/
*                   /* RESERVED UNLESS THE VOLUME IS SHARED. @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1101
*                   IF MVSHARED=OFF THEN                           1101
         TM    MVSHARED,B'10000000'                                1101
         BNZ   @RF01101                                            1101
*                     IF WORKVAL2^=0 THEN                          1102
         CR    @15,@14                                             1102
         BE    @RF01102                                            1102
*                       ERRTYPE=2;  /*                       @Z40LB61*/
         MVC   ERRTYPE(2),@CH00157                                 1103
*                     ELSE                                         1104
*                       ;           /*                       @Z40LB61*/
@RF01102 DS    0H                                                  1105
*                   ELSE                                           1105
*                                                                  1105
*                     /***********************************************/
*                     /*                                             */
*                     /* FOR A SHARED VOLUME, RESERVED STATUS        */
*                     /*                                     @Z40LB61*/
*                     /* SHOULD MATCH BETWEEN MVT AND VVIT.  @Z40LB61*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  1105
*                     IF WORKVAL2=0 THEN                           1105
         B     @RC01101                                            1105
@RF01101 ICM   @15,3,WORKVAL2                                      1105
         BNZ   @RF01105                                            1105
*                       IF IVVIRSVD(WORKVVA)=ON THEN               1106
         LH    @15,WORKVVA                                         1106
         ALR   @15,@15                                             1106
         LH    @14,SA#                                             1106
         SLA   @14,2                                               1106
         L     @05,@PC00001+4                                      1106
         L     @01,IVVITPTR-4(@14,@05)                             1106
         ALR   @01,@15                                             1106
         AL    @01,@CF01340                                        1106
         TM    IVVIRSVD-1(@01),B'00001000'                         1106
         BNO   @RF01106                                            1106
*                         ERRTYPE=1;/*                       @Z40LB61*/
         MVC   ERRTYPE(2),@CH00223                                 1107
*                       ELSE                                       1108
*                         ;         /*                       @Z40LB61*/
@RF01106 DS    0H                                                  1109
*                     ELSE                                         1109
*                       IF IVVIRSVD(WORKVVA)=OFF THEN              1109
         B     @RC01105                                            1109
@RF01105 LH    @15,WORKVVA                                         1109
         ALR   @15,@15                                             1109
         LH    @14,SA#                                             1109
         SLA   @14,2                                               1109
         L     @05,@PC00001+4                                      1109
         L     @01,IVVITPTR-4(@14,@05)                             1109
         ALR   @01,@15                                             1109
         AL    @01,@CF01340                                        1109
         TM    IVVIRSVD-1(@01),B'00001000'                         1109
         BNZ   @RF01109                                            1109
*                         ERRTYPE=2;/*                       @Z40LB61*/
*                                                                  1110
         MVC   ERRTYPE(2),@CH00157                                 1110
*                   /*************************************************/
*                   /*                                               */
*                   /* IF RESERVED STATUS FLAGS MATCH, THEN  @Z40LB61*/
*                   /* CHECK FOR MATCHING DATA AS TO THE     @Z40LB61*/
*                   /* INTERFACES RESERVED.                  @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1111
*                       ELSE                                       1111
*                                                                  1111
*                         /*******************************************/
*                         /*                                         */
*                         /* IF WE'RE CURRENTLY EXAMINING THE        */
*                         /*                                 @Z40LB61*/
*                         /* SA THAT HAS THE VOLUME RESERVED,        */
*                         /*                                 @Z40LB61*/
*                         /* THE INTERFACE ID'S SHOULD MATCH.        */
*                         /*                                 @Z40LB61*/
*                         /* IF WE'RE EXAMINING THE OTHER SA @Z40LB61*/
*                         /* SHARING THE VOLUME, IT SHOULD BE        */
*                         /*                                 @Z40LB61*/
*                         /* RESERVED TO THE MSC (INTERFACE 0).      */
*                         /*                                 @Z40LB61*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  1111
*                         IF MVPATH#=1 THEN                        1111
         B     @RC01109                                            1111
@RF01109 CLC   MVPATH#(2),@CH00223                                 1111
         BNE   @RF01111                                            1111
*                           IF MVSA2RSV=OFF THEN                   1112
         L     @01,MVENTPTR                                        1112
         TM    MVSA2RSV(@01),B'00001000'                           1112
         BNZ   @RF01112                                            1112
*                             IF WORKVAL1^=WORKVAL2 THEN           1113
         CLC   WORKVAL1(2),WORKVAL2                                1113
         BE    @RF01113                                            1113
*                               ERRTYPE=2;/*                 @Z40LB61*/
         MVC   ERRTYPE(2),@CH00157                                 1114
*                             ELSE                                 1115
*                               ;   /*                       @Z40LB61*/
@RF01113 DS    0H                                                  1116
*                           ELSE                                   1116
*                             IF WORKVAL1^=0 THEN                  1116
         B     @RC01112                                            1116
@RF01112 ICM   @15,3,WORKVAL1                                      1116
         BZ    @RF01116                                            1116
*                               ERRTYPE=2;/*                 @Z40LB61*/
         MVC   ERRTYPE(2),@CH00157                                 1117
*                             ELSE                                 1118
*                               ;   /*                       @Z40LB61*/
@RF01116 DS    0H                                                  1119
*                         ELSE                                     1119
*                           IF MVSA2RSV=ON THEN                    1119
         B     @RC01111                                            1119
@RF01111 L     @01,MVENTPTR                                        1119
         TM    MVSA2RSV(@01),B'00001000'                           1119
         BNO   @RF01119                                            1119
*                             IF WORKVAL1^=WORKVAL2 THEN           1120
         CLC   WORKVAL1(2),WORKVAL2                                1120
         BE    @RF01120                                            1120
*                               ERRTYPE=2;/*                 @Z40LB61*/
         MVC   ERRTYPE(2),@CH00157                                 1121
*                             ELSE                                 1122
*                               ;   /*                       @Z40LB61*/
@RF01120 DS    0H                                                  1123
*                           ELSE                                   1123
*                             IF WORKVAL1^=0 THEN                  1123
         B     @RC01119                                            1123
@RF01119 ICM   @15,3,WORKVAL1                                      1123
         BZ    @RF01123                                            1123
*                               ERRTYPE=2;/*                 @Z40LB61*/
*                                                                  1124
         MVC   ERRTYPE(2),@CH00157                                 1124
*                   /*************************************************/
*                   /*                                               */
*                   /* PRINT AN ERROR MESSAGE BASED UPON     @Z40LB61*/
*                   /* THE TYPE OF INCONSISTENCY, IF ANY     @Z40LB61*/
*                   /* INCONSISTENCY WAS FOUND.              @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1125
*                   IF ERRTYPE=1 THEN                              1125
@RF01123 DS    0H                                                  1125
@RC01119 DS    0H                                                  1125
@RC01111 DS    0H                                                  1125
@RC01109 DS    0H                                                  1125
@RC01105 DS    0H                                                  1125
@RC01101 CLC   ERRTYPE(2),@CH00223                                 1125
         BNE   @RF01125                                            1125
*                     DO;           /*                       @Z40LB61*/
*                       VRSFLD=ON;  /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1127
         L     @14,MARGPTR(,@15)                                   1127
         OI    VRSFLD(@14),B'00001000'                             1127
*                       FLDCHAR(1)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1128
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1128
         MVC   FLDCHAR(3,@14),@CC01343                             1128
*                       FLDCHAR(2)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1129
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1129
         MVC   FLDCHAR+12(3,@14),@CC01345                          1129
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @14,@PC00001                                        1130
         ST    @14,@AL00001                                        1130
         ST    @15,@AL00001+4                                      1130
         L     @15,@CV01495                                        1130
         LA    @01,@AL00001                                        1130
         BALR  @14,@15                                             1130
*                     END;          /*                       @Z40LB61*/
*                   ELSE                                           1132
*                     IF ERRTYPE=2 THEN                            1132
         B     @RC01125                                            1132
@RF01125 CLC   ERRTYPE(2),@CH00157                                 1132
         BNE   @RF01132                                            1132
*                       DO;         /*                       @Z40LB61*/
*                         VRSFLD=ON;/*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1134
         L     @14,MARGPTR(,@15)                                   1134
         OI    VRSFLD(@14),B'00001000'                             1134
*                         FLDCHAR(1)=STATNO;/*               @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1135
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1135
         MVC   FLDCHAR(3,@14),@CC01345                             1135
*                         FLDCHAR(2)=STATYES;/*              @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1136
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1136
         MVC   FLDCHAR+12(3,@14),@CC01343                          1136
*                         CALL IDCCH04(GDTTBL,CDALIST);/*    @Z40LB61*/
         L     @14,@PC00001                                        1137
         ST    @14,@AL00001                                        1137
         ST    @15,@AL00001+4                                      1137
         L     @15,@CV01495                                        1137
         LA    @01,@AL00001                                        1137
         BALR  @14,@15                                             1137
*                       END;        /*                       @Z40LB61*/
*                                                                  1138
*                   /*************************************************/
*                   /*                                               */
*                   /* RESET THE 'IDCCH04' OPTION FLAGS      @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1139
*                   MSGTYPE=''B;    /*                       @Z40LB61*/
@RF01132 DS    0H                                                  1139
@RC01125 L     @15,@PC00001+4                                      1139
         L     @15,MARGPTR(,@15)                                   1139
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1139
*                   TBLTYPE(1)=''B; /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1140
*                   TBLTYPE(2)=''B; /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1141
*                 END VVITCHK;      /*                       @Z40LB61*/
*             END SAVVAOK;          /*                       @Z40LB61*/
@RF01058 DS    0H                                                  1144
*       END ACTIVESA;               /*                       @Z40LB61*/
@RC00987 DS    0H                                                  1144
@RC00974 DS    0H                                                  1145
*   END SALOOP1;                    /*                       @Z40LB61*/
@RF00970 LA    @15,1                                               1145
         AH    @15,MVPATH#                                         1145
         STH   @15,MVPATH#                                         1145
         CH    @15,@CH00157                                        1145
         BNH   @DL00969                                            1145
*   END MVTVVAS;                    /*                       @Z40LB61*/
         B     @EL00005                                            1146
*                                                                  1147
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - MVTVUAS                                @Z40LB61 */
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES MVT VUA-RELATED DATA    @Z40LB61*/
*/*            AGAINST VUA-RELATED DATA IN CORRESPONDING     @Z40LB61*/
*/*            MSC AND SA TABLES.                            @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*        (2) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*        (3) MSC CONFIGURATION INDEX                       @Z40LB61*/
*/*        (4) MSC CONFIGURATION DATA BLOCK                  @Z40LB61*/
*/*        (5) SA VIRTUAL ADDRESS DIRECTORY                  @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*        (3) CDB CHECK-OFF TABLE                           @Z40LB61*/
*/*        (4) COUNT OF MOUNTED VOLUMES PER SDG              @Z40LB61*/
*/*        (5) VAD CHECK-OFF TABLE                           @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1147
*MVTVUAS:                                                          1147
*   PROCEDURE;                      /*                       @Z40LB61*/
MVTVUAS  STM   @14,@12,@SA00006                                    1147
*   OLDERID2=NEWERID2;                                             1148
         L     @15,@PC00001                                        1148
         L     @15,GDTTR2(,@15)                                    1148
         MVC   @TS00001(95),NEWERID2(@15)                          1148
         MVC   OLDERID2(95,@15),@TS00001                           1148
*   NEWID2='CH2J';                  /*                       @Z40LB61*/
*                                                                  1149
         MVC   NEWID2(4,@15),@CC01586                              1149
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP INDICATORS POINTING TO ACTIVE INTERFACES       @Z40LB61*/
*   /* OF VALID SA PATHS                                     @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1150
*   INTARRAY=''B;                   /*                       @Z40LB61*/
         XC    INTARRAY(6),INTARRAY                                1150
*   DO MVPATH#=1 TO SASSDG;         /*                       @Z40LB61*/
         LA    @15,1                                               1151
         STH   @15,MVPATH#                                         1151
@DL01151 DS    0H                                                  1152
*     IF MVVLDSA(MVPATH#)=ON THEN                                  1152
         L     @14,MVENTPTR                                        1152
         LR    @05,@15                                             1152
         SLA   @05,3                                               1152
         ST    @05,@TF00001                                        1152
         ALR   @05,@14                                             1152
         TM    MVVLDSA-8(@05),B'10000000'                          1152
         BNO   @RF01152                                            1152
*       DO;                         /*                       @Z40LB61*/
*         IF MVACTB(MVPATH#)=ON THEN                               1154
         AL    @14,@TF00001                                        1154
         TM    MVACTB-8(@14),B'01000000'                           1154
         BNO   @RF01154                                            1154
*           ACTINTF(MVPATH#,1)=ON;  /*                       @Z40LB61*/
         MH    @15,@CH00166                                        1155
         LA    @14,ACTINTF-3(@15)                                  1155
         OI    0(@14),B'10000000'                                  1155
*         IF MVACTC(MVPATH#)=ON THEN                               1156
@RF01154 LH    @15,MVPATH#                                         1156
         LR    @14,@15                                             1156
         SLA   @14,3                                               1156
         L     @01,MVENTPTR                                        1156
         ALR   @01,@14                                             1156
         TM    MVACTC-8(@01),B'00100000'                           1156
         BNO   @RF01156                                            1156
*           ACTINTF(MVPATH#,2)=ON;  /*                       @Z40LB61*/
         MH    @15,@CH00166                                        1157
         LA    @14,ACTINTF-2(@15)                                  1157
         OI    0(@14),B'10000000'                                  1157
*         IF MVACTD(MVPATH#)=ON THEN                               1158
@RF01156 LH    @15,MVPATH#                                         1158
         LR    @14,@15                                             1158
         SLA   @14,3                                               1158
         L     @01,MVENTPTR                                        1158
         ALR   @01,@14                                             1158
         TM    MVACTD-8(@01),B'00010000'                           1158
         BNO   @RF01158                                            1158
*           ACTINTF(MVPATH#,3)=ON;  /*                       @Z40LB61*/
         MH    @15,@CH00166                                        1159
         LA    @14,ACTINTF-1(@15)                                  1159
         OI    0(@14),B'10000000'                                  1159
*       END;                        /*                       @Z40LB61*/
@RF01158 DS    0H                                                  1161
*   END;                            /*                       @Z40LB61*/
*                                                                  1161
@RF01152 LA    @15,1                                               1161
         AH    @15,MVPATH#                                         1161
         STH   @15,MVPATH#                                         1161
         CH    @15,@CH00157                                        1161
         BNH   @DL01151                                            1161
*   /*****************************************************************/
*   /*                                                               */
*   /* EXAMINE THE MVT FIELDS ASSOCIATED WITH ALL POSSIBLE   @Z40LB61*/
*   /* VALID SA PATHS                                        @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1162
*SALOOP2:                                                          1162
*   DO MVPATH#=1 TO SASSDG;         /*                       @Z40LB61*/
SALOOP2  LA    @15,1                                               1162
         STH   @15,MVPATH#                                         1162
@DL01162 DS    0H                                                  1163
*     MVSA#=MVSA(MVPATH#)&MASK15;   /*                       @Z40LB61*/
         SLA   @15,3                                               1163
         L     @01,MVENTPTR                                        1163
         SLR   @14,@14                                             1163
         IC    @14,MVSA-8(@15,@01)                                 1163
         SLR   @15,@15                                             1163
         IC    @15,MASK15                                          1163
         NR    @14,@15                                             1163
         STH   @14,MVSA#                                           1163
*     SA#=MVSA#+1;                  /*                       @Z40LB61*/
*                                                                  1164
         AH    @14,@CH00223                                        1164
         STH   @14,SA#                                             1164
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE SA# FROM THE MVT IS INVALID, PRINT AN        @Z40LB61*/
*     /* ERROR MESSAGE AND DON'T DO FURTHER CHECKING THAT    @Z40LB61*/
*     /* INVOLVES THAT SA.                                   @Z40LB61*/
*     /* IF THE SA# IS OFFLINE OR SUU THEN SKIP PROCESS-     @ZA27324*/
*     /* ING THIS PARTICULAR SA.                             @ZA27324*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1165
*     IF IVADPTR(SA#)=NULLPTR|      /*                       @ZA27324*/
*         IVADPTR(SA#)=DUMMYPTR THEN/*                       @ZA27324*/
         SLA   @14,2                                               1165
         L     @15,@PC00001+4                                      1165
         AL    @15,@CF01761                                        1165
         L     @15,IVADPTR(@14,@15)                                1165
         LTR   @15,@15                                             1165
         BZ    @RT01165                                            1165
         C     @15,DUMMYPTR                                        1165
         BNE   @RF01165                                            1165
@RT01165 DS    0H                                                  1166
*       DO;                         /*                       @ZA27324*/
*         IF IVADPTR(SA#)=DUMMYPTR THEN                            1167
         LH    @15,SA#                                             1167
         SLA   @15,2                                               1167
         L     @14,@PC00001+4                                      1167
         AL    @14,@CF01761                                        1167
         L     @15,IVADPTR(@15,@14)                                1167
         C     @15,DUMMYPTR                                        1167
         BE    @RT01167                                            1167
*           ;                       /*                       @ZA27324*/
*         ELSE                      /*                       @ZA27324*/
*           DO;                     /*                       @ZA27324*/
*             MTCHMSG=ON;           /*                       @ZA27324*/
         L     @15,@PC00001+4                                      1170
         L     @14,MARGPTR(,@15)                                   1170
         OI    MTCHMSG(@14),B'00010000'                            1170
*             CBMTBL(1)=ON;         /*                       @ZA27324*/
         OI    CBMTBL(@14),B'00001000'                             1171
*             MVTTBL(2)=ON;         /*                       @ZA27324*/
         OI    MVTTBL+4(@14),B'10000000'                           1172
*             SAFLD=ON;             /*                       @ZA27324*/
         OI    SAFLD(@14),B'00001000'                              1173
*             FLDNUM(1)=MVSA#;      /*                       @ZA27324*/
         LH    @05,MVSA#                                           1174
         ST    @05,FLDNUM(,@14)                                    1174
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @ZA27324*/
         L     @14,@PC00001                                        1175
         ST    @14,@AL00001                                        1175
         ST    @15,@AL00001+4                                      1175
         L     @15,@CV01495                                        1175
         LA    @01,@AL00001                                        1175
         BALR  @14,@15                                             1175
*           END;                    /*                       @ZA27324*/
*       END;                        /*                       @Z40LB61*/
*     ELSE                                                         1178
*                                                                  1178
*       /*************************************************************/
*       /*                                                           */
*       /* DO TABLE CHECKING FOR EACH ACTIVE INTERFACE       @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1178
*INTFLOOP:                                                         1178
*       DO INTF#=1 TO INTFSSA;      /*                       @Z40LB61*/
         B     @RC01165                                            1178
@RF01165 DS    0H                                                  1178
INTFLOOP LA    @15,1                                               1178
         STH   @15,INTF#                                           1178
@DL01178 DS    0H                                                  1179
*         IF ACTINTF(MVPATH#,INTF#)=ON THEN                        1179
         LH    @14,MVPATH#                                         1179
         MH    @14,@CH00166                                        1179
         ALR   @14,@15                                             1179
         LA    @15,ACTINTF-4(@14)                                  1179
         TM    0(@15),B'10000000'                                  1179
         BNO   @RF01179                                            1179
*GOODINTF:                                                         1180
*           DO;                     /*                       @Z40LB61*/
GOODINTF DS    0H                                                  1181
*             OLDERID2=NEWERID2;                                   1181
         L     @15,@PC00001                                        1181
         L     @15,GDTTR2(,@15)                                    1181
         MVC   @TS00001(95),NEWERID2(@15)                          1181
         MVC   OLDERID2(95,@15),@TS00001                           1181
*             NEWID2='CH2K';        /*                       @Z40LB61*/
         MVC   NEWID2(4,@15),@CC01593                              1182
*             WRKCPUID=MVCPUID(INTF#)&MASK15;/*              @Z40LB61*/
         LH    @15,INTF#                                           1183
         L     @14,MVENTPTR                                        1183
         LH    @05,MVPATH#                                         1183
         SLA   @05,3                                               1183
         LA    @04,MVCPUIDS-8(@05,@14)                             1183
         AL    @04,@CF01340                                        1183
         SLR   @03,@03                                             1183
         IC    @03,MVCPUID(@15,@04)                                1183
         SLR   @02,@02                                             1183
         IC    @02,MASK15                                          1183
         NR    @03,@02                                             1183
         STH   @03,WRKCPUID                                        1183
*             WORKVUA=MVVUA(INTF#)&MASK63;/*                 @Z40LB61*/
         LA    @14,MVVUAS-8(@05,@14)                               1184
         AL    @14,@CF01340                                        1184
         SLR   @05,@05                                             1184
         IC    @05,MVVUA(@15,@14)                                  1184
         SLR   @04,@04                                             1184
         IC    @04,MASK63                                          1184
         NR    @05,@04                                             1184
         STH   @05,WORKVUA                                         1184
*             BYTE#=WORKVUA/8+1;    /*                       @Z40LB61*/
         L     @04,@PC00001+4                                      1185
         L     @15,EARGPTR(,@04)                                   1185
         LA    @14,1                                               1185
         LR    @00,@05                                             1185
         SRDA  @00,32                                              1185
         D     @00,@CF00183                                        1185
         ALR   @01,@14                                             1185
         STH   @01,BYTE#(,@15)                                     1185
*             BIT#=WORKVUA//8+1;    /*                       @Z40LB61*/
*                                                                  1186
         LR    @00,@05                                             1186
         SRDA  @00,32                                              1186
         D     @00,@CF00183                                        1186
         ALR   @00,@14                                             1186
         STH   @00,BIT#(,@15)                                      1186
*             /*******************************************************/
*             /*                                                     */
*             /* IF SA CHECKING WAS REQUESTED, PREPARE TO    @Z40LB61*/
*             /* COMPARE THE SA VIRTUAL ADDRESS DIRECTORY    @Z40LB61*/
*             /* (VAD) AGAINST THE MVT ENTRY.                @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1187
*             IF SACHK=ON THEN                                     1187
         TM    SACHK(@04),B'01000000'                              1187
         BNO   @RF01187                                            1187
*VADCHK:                                                           1188
*               DO;                 /*                       @Z40LB61*/
*                                                                  1188
VADCHK   DS    0H                                                  1189
*                 /***************************************************/
*                 /*                                                 */
*                 /* DO COMMON SET-UP FOR POSSIBLE ERROR     @Z40LB61*/
*                 /* MESSAGES                                @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1189
*                 VADTBL(1)=ON;     /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1189
         L     @14,MARGPTR(,@15)                                   1189
         OI    VADTBL(@14),B'00000001'                             1189
*                 MVTTBL(2)=ON;     /*                       @Z40LB61*/
         OI    MVTTBL+4(@14),B'10000000'                           1190
*                 INCNMSG=ON;       /*                       @Z40LB61*/
         OI    INCNMSG(@14),B'10000000'                            1191
*                 SAINDEX(1)=MVSA#; /*                       @Z40LB61*/
         MVC   SAINDEX(1,@14),MVSA#+1                              1192
*                 INFINDEX(1)=INTF#;/*                       @Z40LB61*/
         LH    @05,INTF#                                           1193
         STC   @05,INFINDEX(,@14)                                  1193
*                 VUAINDEX(1)=WORKVUA;/*                     @Z40LB61*/
*                                                                  1194
         LH    @04,WORKVUA                                         1194
         STC   @04,VUAINDEX(,@14)                                  1194
*                 /***************************************************/
*                 /*                                                 */
*                 /* IF THE CORRESPONDING VAD ENTRY FOR THE  @Z40LB61*/
*                 /* CURRENT INTERFACE'S VUA IS NOT VALID,   @Z40LB61*/
*                 /* PRINT AN ERROR MESSAGE.                 @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1195
*                 IF IVADVVA(INTF#,WORKVUA+1)=0 THEN               1195
         SLA   @05,6                                               1195
         ALR   @05,@04                                             1195
         ALR   @05,@05                                             1195
         LH    @04,SA#                                             1195
         SLA   @04,2                                               1195
         AL    @04,@CF01761                                        1195
         L     @01,IVADPTR(@04,@15)                                1195
         AL    @01,@CF01762                                        1195
         SLR   @04,@04                                             1195
         IC    @04,IVADVVA(@05,@01)                                1195
         CH    @04,@CH00119                                        1195
         BNE   @RF01195                                            1195
*                   DO;             /*                       @Z40LB61*/
*                     IUSFLD=ON;    /*                       @Z40LB61*/
         OI    IUSFLD(@14),B'00000001'                             1197
*                     FLDCHAR(1)=STATNO;/*                   @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1198
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1198
         MVC   FLDCHAR(3,@14),@CC01345                             1198
*                     FLDCHAR(2)=STATYES;/*                  @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1199
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1199
         MVC   FLDCHAR+12(3,@14),@CC01343                          1199
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB61*/
         L     @14,@PC00001                                        1200
         ST    @14,@AL00001                                        1200
         ST    @15,@AL00001+4                                      1200
         L     @15,@CV01495                                        1200
         LA    @01,@AL00001                                        1200
         BALR  @14,@15                                             1200
*                   END;            /*                       @Z40LB61*/
*                 ELSE                                             1202
*                                                                  1202
*                   /*************************************************/
*                   /*                                               */
*                   /* FOR A VALID VAD ENTRY, CHECK-OFF      @Z40LB61*/
*                   /* THE ENTRY AND PREPARE TO CHECK FOR    @Z40LB61*/
*                   /* CONSISTENCY IN CORRESPONDING FIELDS   @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1202
*MVTVADM:                                                          1202
*                   DO;             /*                       @Z40LB61*/
         B     @RC01195                                            1202
@RF01195 DS    0H                                                  1202
MVTVADM  DS    0H                                                  1203
*                     VADCHKFF(INTF#,BYTE#)=VADCHKFF(INTF#,BYTE#)| 1203
*                         BITMASK(BIT#);/*                   @Z40LB61*/
*                                                                  1203
         LH    @15,INTF#                                           1203
         LR    @14,@15                                             1203
         SLA   @14,3                                               1203
         L     @05,@PC00001+4                                      1203
         L     @04,EARGPTR(,@05)                                   1203
         AH    @14,BYTE#(,@04)                                     1203
         LH    @03,SA#                                             1203
         SLA   @03,2                                               1203
         L     @01,VADCOPTR-4(@03,@05)                             1203
         ALR   @01,@14                                             1203
         AL    @01,@CF01763                                        1203
         LH    @02,BIT#(,@04)                                      1203
         LA    @14,BITMASK-1(@02)                                  1203
         OC    VADCHKFF(1,@01),0(@14)                              1203
*                     /***********************************************/
*                     /*                                             */
*                     /* CHECK FOR MATCHING VVA FIELDS. IF   @Z40LB61*/
*                     /* INCONSISTENT, PRINT AN ERROR MESSAGE.       */
*                     /*                                     @Z40LB61*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  1204
*                     IF IVADVVA(INTF#,WORKVUA+1)^=MVVVA(MVPATH#) THEN
         SLA   @15,6                                               1204
         AH    @15,WORKVUA                                         1204
         ALR   @15,@15                                             1204
         AL    @03,@CF01761                                        1204
         L     @01,IVADPTR(@03,@05)                                1204
         AL    @01,@CF01762                                        1204
         SLR   @14,@14                                             1204
         IC    @14,IVADVVA(@15,@01)                                1204
         LH    @15,MVPATH#                                         1204
         SLA   @15,3                                               1204
         L     @01,MVENTPTR                                        1204
         SLR   @04,@04                                             1204
         IC    @04,MVVVA-8(@15,@01)                                1204
         CR    @14,@04                                             1204
         BE    @RF01204                                            1204
*                       DO;         /*                       @Z40LB61*/
*                         VVAFLD=ON;/*                       @Z40LB61*/
         L     @15,MARGPTR(,@05)                                   1206
         OI    VVAFLD(@15),B'01000000'                             1206
*                         FLDNUM(1)=IVADVVA(INTF#,WORKVUA+1);/*    1207
*                                                            @Z40LB61*/
         ST    @14,FLDNUM(,@15)                                    1207
*                         FLDNUM(2)=MVVVA(MVPATH#);/*        @Z40LB61*/
         ST    @04,FLDNUM+12(,@15)                                 1208
*                         CALL IDCCH04(GDTTBL,CDALIST);/*    @Z40LB61*/
         L     @04,@PC00001                                        1209
         ST    @04,@AL00001                                        1209
         ST    @05,@AL00001+4                                      1209
         L     @15,@CV01495                                        1209
         LA    @01,@AL00001                                        1209
         BALR  @14,@15                                             1209
*                       END;        /*                       @Z40LB61*/
*                   END MVTVADM;    /*                       @Z40LB61*/
@RF01204 DS    0H                                                  1212
*               END VADCHK;         /*                       @Z40LB61*/
*                                                                  1212
@RC01195 DS    0H                                                  1213
*             /*******************************************************/
*             /*                                                     */
*             /* IF MSC-MSC CHECKING WAS REQUESTED, CHECK    @Z40LB61*/
*             /* THAT THE CPUID FROM THE CONFIGURATION       @Z40LB61*/
*             /* INDEX (CI) MATCHES WITH THE MVT CPUID FOR   @Z40LB61*/
*             /* THE CURRENT SA AND INTERFACE NUMBER.        @Z40LB61*/
*             /* IF NOT, PRINT AN ERROR MESSAGE.             @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1213
*             IF MSCCHK=ON THEN                                    1213
@RF01187 L     @15,@PC00001+4                                      1213
         TM    MSCCHK(@15),B'10000000'                             1213
         BNO   @RF01213                                            1213
*CICHK:                                                            1214
*               DO;                 /*                       @Z40LB61*/
CICHK    DS    0H                                                  1215
*                 CISA#=SA#;        /*                       @Z40LB61*/
         LH    @15,SA#                                             1215
         STH   @15,CISA#                                           1215
*                 IF CICPUID(INTF#)^=WRKCPUID THEN                 1216
         LH    @14,WRKCPUID                                        1216
         LH    @05,INTF#                                           1216
         LR    @04,@05                                             1216
         ALR   @04,@04                                             1216
         SLA   @15,3                                               1216
         L     @01,CIENTPTR                                        1216
         AL    @01,@CF01764                                        1216
         LA    @15,CISACHNL-2(@15,@01)                             1216
         AL    @15,@CF01760                                        1216
         SLR   @03,@03                                             1216
         IC    @03,CICPUID(@04,@15)                                1216
         CR    @03,@14                                             1216
         BE    @RF01216                                            1216
*                   DO;             /*                       @Z40LB61*/
*                     INCNMSG=ON;   /*                       @Z40LB61*/
         L     @02,@PC00001+4                                      1218
         L     @15,MARGPTR(,@02)                                   1218
         OI    INCNMSG(@15),B'10000000'                            1218
*                     CITBL(1)=ON;  /*                       @Z40LB61*/
         OI    CITBL(@15),B'01000000'                              1219
*                     MVTTBL(2)=ON; /*                       @Z40LB61*/
         OI    MVTTBL+4(@15),B'10000000'                           1220
*                     CPUFLD=ON;    /*                       @Z40LB61*/
         OI    CPUFLD(@15),B'00000100'                             1221
*                     FLDNUM(1)=CICPUID(INTF#);/*            @Z40LB61*/
         ST    @03,FLDNUM(,@15)                                    1222
*                     FLDNUM(2)=WRKCPUID;/*                  @Z40LB61*/
         ST    @14,FLDNUM+12(,@15)                                 1223
*                     SAINDEX(1)=MVSA#;/*                    @Z40LB61*/
         MVC   SAINDEX(1,@15),MVSA#+1                              1224
*                     INFINDEX(1)=INTF#;/*                   @Z40LB61*/
         STC   @05,INFINDEX(,@15)                                  1225
*                     CHRINDEX(1)=CICHR;/*                   @Z40LB61*/
         MVC   CHRINDEX(5,@15),CICHR                               1226
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB61*/
         L     @03,@PC00001                                        1227
         ST    @03,@AL00001                                        1227
         ST    @02,@AL00001+4                                      1227
         L     @15,@CV01495                                        1227
         LA    @01,@AL00001                                        1227
         BALR  @14,@15                                             1227
*                   END;            /*                       @Z40LB61*/
*               END CICHK;          /*                       @Z40LB61*/
*                                                                  1229
@RF01216 DS    0H                                                  1230
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE CURRENT ACTIVE INTERFACE HAS NOT     @Z40LB61*/
*             /* ALREADY BEEN FOUND TO BE AN ALTERNATE       @Z40LB61*/
*             /* PATH, OBTAIN THE CONFIGURATION DATA BLOCK   @Z40LB61*/
*             /* (CDB) CORRESPONDING TO THE CURRENT VUA      @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1230
*             IF DONEINTF(MVPATH#,INTF#)=OFF THEN                  1230
@RF01213 LH    @15,MVPATH#                                         1230
         MH    @15,@CH00166                                        1230
         AH    @15,INTF#                                           1230
         LA    @14,DONEINTF-4(@15)                                 1230
         TM    0(@14),B'01000000'                                  1230
         BNZ   @RF01230                                            1230
*CDBCHK:                                                           1231
*               DO;                 /*                       @Z40LB61*/
CDBCHK   DS    0H                                                  1232
*                 DONEINTF(MVPATH#,INTF#)=ON;/*              @Z40LB61*/
         LH    @15,INTF#                                           1232
         LH    @14,MVPATH#                                         1232
         MH    @14,@CH00166                                        1232
         ALR   @14,@15                                             1232
         LA    @01,DONEINTF-4(@14)                                 1232
         OI    0(@01),B'01000000'                                  1232
*                 TABLEID=CFGTBLID; /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1233
         L     @05,EARGPTR(,@14)                                   1233
         MVC   TABLEID(1,@05),CFGTBLID                             1233
*                 CDBFLAG=ON;       /*                       @Z40LB61*/
         OI    CDBFLAG(@05),B'00000010'                            1234
*                 SANUM=MVSA#;      /*                       @Z40LB61*/
         MVC   SANUM(2,@05),MVSA#                                  1235
*                 INTFID=INTF#;     /*                       @Z40LB61*/
         STH   @15,INTFID(,@05)                                    1236
*                 CALL IDCCH03(GDTTBL,CDALIST);/*            @Z40LB61*/
         L     @15,@PC00001                                        1237
         ST    @15,@AL00001                                        1237
         ST    @14,@AL00001+4                                      1237
         L     @15,@CV01494                                        1237
         LA    @01,@AL00001                                        1237
         BALR  @14,@15                                             1237
*                 IF GETRC^=0 THEN                                 1238
         L     @15,@PC00001+4                                      1238
         L     @01,EARGPTR(,@15)                                   1238
         ICM   @00,3,GETRC(@01)                                    1238
         BZ    @RF01238                                            1238
*                   DO;             /*                       @Z40LB61*/
*                     LASTCOND=LASTCC12;/*                   @Z40LB61*/
         L     @15,@PC00001+8                                      1240
         MVC   LASTCOND(2,@15),@CH00567                            1240
*                     RETURN;       /*                       @Z40LB61*/
@EL00006 DS    0H                                                  1241
@EF00006 DS    0H                                                  1241
@ER00006 LM    @14,@12,@SA00006                                    1241
         BR    @14                                                 1241
*                   END;            /*                       @Z40LB61*/
*                 CDBPTR=TBLADDR;   /*                       @Z40LB61*/
@RF01238 L     @15,@PC00001+4                                      1243
         L     @14,EARGPTR(,@15)                                   1243
         L     @05,TBLADDR(,@14)                                   1243
         ST    @05,CDBPTR                                          1243
*                 CDBVUA#=WORKVUA+1;/*                       @Z40LB61*/
*                                                                  1244
         LH    @04,WORKVUA                                         1244
         LA    @03,1                                               1244
         ALR   @03,@04                                             1244
         STH   @03,CDBVUA#                                         1244
*                 /***************************************************/
*                 /*                                                 */
*                 /* DO COMMON SET-UP FOR POSSIBLE ERROR     @Z40LB61*/
*                 /* MESSAGES                                @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1245
*                 CDBTBL(1)=ON;     /*                       @Z40LB61*/
         L     @15,MARGPTR(,@15)                                   1245
         OI    CDBTBL(@15),B'00100000'                             1245
*                 MVTTBL(2)=ON;     /*                       @Z40LB61*/
         OI    MVTTBL+4(@15),B'10000000'                           1246
*                 INCNMSG=ON;       /*                       @Z40LB61*/
         OI    INCNMSG(@15),B'10000000'                            1247
*                 SAINDEX(1)=MVSA#; /*                       @Z40LB61*/
         MVC   SAINDEX(1,@15),MVSA#+1                              1248
*                 INFINDEX(1)=INTF#;/*                       @Z40LB61*/
         MVC   INFINDEX(1,@15),INTF#+1                             1249
*                 VUAINDEX(1)=WORKVUA;/*                     @Z40LB61*/
         STC   @04,VUAINDEX(,@15)                                  1250
*                 CHRINDEX(1)=PREVCHR;/*                     @Z40LB61*/
         MVC   CHRINDEX(5,@15),PREVCHR(@14)                        1251
*                 TBLNRSET(1)=ON;   /*                       @Z40LB61*/
         OI    TBLNRSET(@15),B'00000001'                           1252
*                 TBLNRSET(2)=ON;   /*                       @Z40LB61*/
         OI    TBLNRSET+4(@15),B'00000001'                         1253
*                 MSGNRSET=ON;      /*                       @Z40LB61*/
*                                                                  1254
         OI    MSGNRSET(@15),B'00000001'                           1254
*                 /***************************************************/
*                 /*                                                 */
*                 /* IF THE CDB ENTRY INDICATES THIS VUA IS  @Z40LB61*/
*                 /* AN ALTERNATE PATH, NO FURTHER CHECKING  @Z40LB61*/
*                 /* IS DONE.                                @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1255
*                 IF CDBCNFIG(CDBVUA#)='FF'X THEN                  1255
         SLA   @03,2                                               1255
         ALR   @05,@03                                             1255
         AL    @05,@CF01761                                        1255
         CLI   CDBCNFIG(@05),X'FF'                                 1255
         BE    @RT01255                                            1255
*                   ;               /*                       @Z40LB61*/
*                 ELSE                                             1257
*                                                                  1257
*                   /*************************************************/
*                   /*                                               */
*                   /* IF THE CDB ENTRY INDICATES THAT THIS  @Z40LB61*/
*                   /* VUA IS NOT IN USE, PRINT AN ERROR MSG @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1257
*                   IF CDBINUSE(CDBVUA#)=OFF THEN                  1257
         LH    @15,CDBVUA#                                         1257
         SLA   @15,2                                               1257
         L     @01,CDBPTR                                          1257
         ALR   @01,@15                                             1257
         AL    @01,@CF01761                                        1257
         TM    CDBINUSE(@01),B'01000000'                           1257
         BNZ   @RF01257                                            1257
*                     DO;           /*                       @Z40LB61*/
*                       IUSFLD=ON;  /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1259
         L     @14,MARGPTR(,@15)                                   1259
         OI    IUSFLD(@14),B'00000001'                             1259
*                       FLDCHAR(1)=STATNO;/*                 @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1260
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1260
         MVC   FLDCHAR(3,@14),@CC01345                             1260
*                       FLDCHAR(2)=STATYES;/*                @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1261
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1261
         MVC   FLDCHAR+12(3,@14),@CC01343                          1261
*                       CALL IDCCH04(GDTTBL,CDALIST);/*      @Z40LB61*/
         L     @14,@PC00001                                        1262
         ST    @14,@AL00001                                        1262
         ST    @15,@AL00001+4                                      1262
         L     @15,@CV01495                                        1262
         LA    @01,@AL00001                                        1262
         BALR  @14,@15                                             1262
*                     END;          /*                       @Z40LB61*/
*                   ELSE                                           1264
*                                                                  1264
*                     /***********************************************/
*                     /*                                             */
*                     /* IF A MATCHING, IN-USE CDB ENTRY WAS @Z40LB61*/
*                     /* FOUND, CHECK-OFF THE ENTRY AND SET UP       */
*                     /*                                     @Z40LB61*/
*                     /* TO CHECK CORRESPONDING FIELDS FOR   @Z40LB61*/
*                     /* CONSISTENCY.                        @Z40LB61*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  1264
*MVTCDBM:                                                          1264
*                     DO;           /*                       @Z40LB61*/
         B     @RC01257                                            1264
@RF01257 DS    0H                                                  1264
MVTCDBM  DS    0H                                                  1265
*                       OLDERID2=NEWERID2;                         1265
         L     @15,@PC00001                                        1265
         L     @15,GDTTR2(,@15)                                    1265
         MVC   @TS00001(95),NEWERID2(@15)                          1265
         MVC   OLDERID2(95,@15),@TS00001                           1265
*                       NEWID2='CH2L';/*                     @Z40LB61*/
         MVC   NEWID2(4,@15),@CC01604                              1266
*                       CDBCHKFF(SA#,INTF#,BYTE#)=CDBCHKFF(SA#,INTF#,
*                           BYTE#)|BITMASK(BIT#);                  1267
*                                                                  1267
         LH    @15,SA#                                             1267
         MH    @15,@CH00166                                        1267
         AH    @15,INTF#                                           1267
         SLA   @15,3                                               1267
         L     @14,@PC00001+4                                      1267
         L     @05,EARGPTR(,@14)                                   1267
         AH    @15,BYTE#(,@05)                                     1267
         L     @01,CDBCOPTR(,@14)                                  1267
         ALR   @01,@15                                             1267
         AL    @01,@CF01765                                        1267
         LH    @15,BIT#(,@05)                                      1267
         LA    @14,BITMASK-1(@15)                                  1267
         OC    CDBCHKFF(1,@01),0(@14)                              1267
*                       /*********************************************/
*                       /*                                           */
*                       /* IF THE SDG# IS VALID, ADD ONE TO  @Z40LB61*/
*                       /* THE MOUNT COUNT (ACTIVE INTERFACES)       */
*                       /*                                   @Z40LB61*/
*                       /* FOR THE SDG FOR THIS VOLUME       @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1268
*                       IF MVSDG<SDGMAX THEN                       1268
         L     @15,MVENTPTR                                        1268
         CLI   MVSDG(@15),30                                       1268
         BNL   @RF01268                                            1268
*                         MNTCOUNT(MVSDG+1)=MNTCOUNT(MVSDG+1)+1;/* 1269
*                                                            @Z40LB61*/
*                                                                  1269
         SLR   @14,@14                                             1269
         IC    @14,MVSDG(,@15)                                     1269
         ALR   @14,@14                                             1269
         LA    @15,1                                               1269
         AH    @15,MNTCOUNT(@14)                                   1269
         STH   @15,MNTCOUNT(@14)                                   1269
*                       /*********************************************/
*                       /*                                           */
*                       /* CHECK FOR MATCHING 3333 ADDRESS.  @Z40LB61*/
*                       /* IF INCONSISTENT, PRINT AN ERROR MSG       */
*                       /*                                   @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1270
*                       WORK3333=MV3333/SHIFT3;/*            @Z40LB61*/
@RF01268 L     @01,MVENTPTR                                        1270
         SLR   @00,@00                                             1270
         IC    @00,MV3333(,@01)                                    1270
         SRL   @00,3                                               1270
         STC   @00,WORK3333                                        1270
*                       IF CDB3333(CDBVUA#)=OFF&WORK3333=1 THEN    1271
         LH    @15,CDBVUA#                                         1271
         SLA   @15,2                                               1271
         L     @01,CDBPTR                                          1271
         ALR   @01,@15                                             1271
         AL    @01,@CF01761                                        1271
         TM    CDB3333(@01),B'00100000'                            1271
         BNZ   @RF01271                                            1271
         CLI   WORK3333,1                                          1271
         BNE   @RF01271                                            1271
*                         DO;       /*                       @Z40LB61*/
*                           L3AFLD=ON;/*                     @Z40LB61*/
         L     @15,@PC00001+4                                      1273
         L     @14,MARGPTR(,@15)                                   1273
         OI    L3AFLD(@14),B'00000001'                             1273
*                           FLDNUM(1)=0;/*                   @Z40LB61*/
         SLR   @05,@05                                             1274
         ST    @05,FLDNUM(,@14)                                    1274
*                           FLDNUM(2)=1;/*                   @Z40LB61*/
         MVC   FLDNUM+12(4,@14),@CF00223                           1275
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @Z40LB61*/
         L     @14,@PC00001                                        1276
         ST    @14,@AL00001                                        1276
         ST    @15,@AL00001+4                                      1276
         L     @15,@CV01495                                        1276
         LA    @01,@AL00001                                        1276
         BALR  @14,@15                                             1276
*                         END;      /*                       @Z40LB61*/
*                       IF CDB3333(CDBVUA#)=ON&WORK3333=0 THEN     1278
@RF01271 LH    @15,CDBVUA#                                         1278
         SLA   @15,2                                               1278
         L     @01,CDBPTR                                          1278
         ALR   @01,@15                                             1278
         AL    @01,@CF01761                                        1278
         TM    CDB3333(@01),B'00100000'                            1278
         BNO   @RF01278                                            1278
         CLI   WORK3333,0                                          1278
         BNE   @RF01278                                            1278
*                         DO;       /*                       @Z40LB61*/
*                           L3AFLD=ON;/*                     @Z40LB61*/
         L     @15,@PC00001+4                                      1280
         L     @14,MARGPTR(,@15)                                   1280
         OI    L3AFLD(@14),B'00000001'                             1280
*                           FLDNUM(1)=1;/*                   @Z40LB61*/
         MVC   FLDNUM(4,@14),@CF00223                              1281
*                           FLDNUM(2)=0;/*                   @Z40LB61*/
         SLR   @05,@05                                             1282
         ST    @05,FLDNUM+12(,@14)                                 1282
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @Z40LB61*/
         L     @14,@PC00001                                        1283
         ST    @14,@AL00001                                        1283
         ST    @15,@AL00001+4                                      1283
         L     @15,@CV01495                                        1283
         LA    @01,@AL00001                                        1283
         BALR  @14,@15                                             1283
*                         END;      /*                       @Z40LB61*/
*                                                                  1284
*                       /*********************************************/
*                       /*                                           */
*                       /* CHECK FOR MATCHING SDG#. IF       @Z40LB61*/
*                       /* INCONSISTENT, PRINT AN ERROR MSG  @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1285
*                       SDG#=CDBSDG(CDBVUA#)&MASK31;/*       @Z40LB61*/
@RF01278 LH    @15,CDBVUA#                                         1285
         SLA   @15,2                                               1285
         L     @01,CDBPTR                                          1285
         AL    @01,@CF01761                                        1285
         SLR   @14,@14                                             1285
         IC    @14,CDBSDG(@15,@01)                                 1285
         SLR   @15,@15                                             1285
         IC    @15,MASK31                                          1285
         NR    @14,@15                                             1285
         STH   @14,SDG#                                            1285
*                       IF SDG#^=MVSDG THEN                        1286
         L     @01,MVENTPTR                                        1286
         SLR   @15,@15                                             1286
         IC    @15,MVSDG(,@01)                                     1286
         CR    @14,@15                                             1286
         BE    @RF01286                                            1286
*                         DO;       /*                       @Z40LB61*/
*                           SDGFLD=ON;/*                     @Z40LB61*/
         L     @05,@PC00001+4                                      1288
         L     @04,MARGPTR(,@05)                                   1288
         OI    SDGFLD(@04),B'00000010'                             1288
*                           FLDNUM(1)=SDG#;/*                @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    1289
*                           FLDNUM(2)=MVSDG;/*               @Z40LB61*/
         ST    @15,FLDNUM+12(,@04)                                 1290
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @Z40LB61*/
         L     @04,@PC00001                                        1291
         ST    @04,@AL00001                                        1291
         ST    @05,@AL00001+4                                      1291
         L     @15,@CV01495                                        1291
         LA    @01,@AL00001                                        1291
         BALR  @14,@15                                             1291
*                         END;      /*                       @Z40LB61*/
*                                                                  1292
*                       /*********************************************/
*                       /*                                           */
*                       /* CHECK FOR MATCHING MVT POINTER.   @ZD00051*/
*                       /* IF INCONSISTENT, PRINT AN ERROR MSG       */
*                       /*                                   @ZD00051*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1293
*                       IF CDBMVTP(CDBVUA#)^=SAVEREC#-1 THEN       1293
@RF01286 LH    @15,CDBVUA#                                         1293
         SLA   @15,2                                               1293
         L     @01,CDBPTR                                          1293
         ALR   @01,@15                                             1293
         AL    @01,@CF01760                                        1293
         SLR   @15,@15                                             1293
         ICM   @15,3,CDBMVTP-2(@01)                                1293
         LH    @14,SAVEREC#                                        1293
         BCTR  @14,0                                               1293
         CR    @15,@14                                             1293
         BE    @RF01293                                            1293
*                         DO;       /*                       @ZD00051*/
*                           MVTPFLD=ON;/*                    @ZD00051*/
         L     @05,@PC00001+4                                      1295
         L     @04,MARGPTR(,@05)                                   1295
         OI    MVTPFLD(@04),B'00100000'                            1295
*                           FLDNUM(1)=CDBMVTP(CDBVUA#);/*    @ZD00051*/
         ST    @15,FLDNUM(,@04)                                    1296
*                           FLDNUM(2)=SAVEREC#-1;/*          @ZD00051*/
         ST    @14,FLDNUM+12(,@04)                                 1297
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @ZD00051*/
         L     @04,@PC00001                                        1298
         ST    @04,@AL00001                                        1298
         ST    @05,@AL00001+4                                      1298
         L     @15,@CV01495                                        1298
         LA    @01,@AL00001                                        1298
         BALR  @14,@15                                             1298
*                         END;      /*                       @ZD00051*/
*                                                                  1299
*                       /*********************************************/
*                       /*                                           */
*                       /* CHECK FOR ALTERNATE PATH VALIDITY @ZD00051*/
*                       /* FOR EACH INTERFACE OF EACH SA FOR @ZD00051*/
*                       /* THIS VUA ENTRY. TEMPORARILY SAVE  @ZD00051*/
*                       /* THE 'PATH#' INDEX VARIABLE.       @ZD00051*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1300
*                       TBLSECT#=MVPATH#;/*                  @ZD00051*/
@RF01293 MVC   TBLSECT#(2),MVPATH#                                 1300
*ALTPATH:                                                          1301
*                       DO MVPATH#=1 TO SASSDG;/*            @ZD00051*/
ALTPATH  LA    @15,1                                               1301
         STH   @15,MVPATH#                                         1301
@DL01301 DS    0H                                                  1302
*                         DO SAINTF#=1 TO INTFSSA;/*         @ZD00051*/
         LA    @15,1                                               1302
         STH   @15,SAINTF#                                         1302
@DL01302 DS    0H                                                  1303
*                           IF(BITMASK((MVPATH#-1)*4+SAINTF#+1)&   1303
*                               CDBPATHS(CDBVUA#))^=0 THEN         1303
*                                                                  1303
         LH    @14,MVPATH#                                         1303
         LR    @05,@14                                             1303
         BCTR  @05,0                                               1303
         SLA   @05,2                                               1303
         ALR   @05,@15                                             1303
         LH    @04,CDBVUA#                                         1303
         SLA   @04,2                                               1303
         SLR   @03,@03                                             1303
         IC    @03,BITMASK(@05)                                    1303
         L     @02,CDBPTR                                          1303
         AL    @02,@CF01766                                        1303
         SLR   @05,@05                                             1303
         IC    @05,CDBPATHS-1(@04,@02)                             1303
         NR    @03,@05                                             1303
         LTR   @03,@03                                             1303
         BZ    @RF01303                                            1303
*                             /***************************************/
*                             /*                                     */
*                             /* IF THE CDB INDICATES A VALID        */
*                             /*                             @ZD00051*/
*                             /* PATH, CHECK IN THE MVT ENTRY        */
*                             /*                             @ZD00051*/
*                             /* THAT THE INTERFACE IS ACTIVE        */
*                             /*                             @ZD00051*/
*                             /* AND HAS THE SAME CPUID AND  @Z40LB61*/
*                             /* VUA AS THE PRIMARY PATH.    @Z40LB61*/
*                             /* FOR ANY INCONSISTENCY,      @Z40LB61*/
*                             /* PRINT AN ERROR MESSAGE.     @Z40LB61*/
*                             /*                                     */
*                             /***************************************/
*                                                                  1304
*                             DO;   /*                       @Z40LB61*/
*                               IF ACTINTF(MVPATH#,SAINTF#)=OFF|(MVVUA(
*                                   SAINTF#)&MASK63)^=WORKVUA|(MVCPUID(
*                                   SAINTF#)&MASK15)^=WRKCPUID THEN
         LR    @05,@14                                             1305
         MH    @05,@CH00166                                        1305
         ALR   @05,@15                                             1305
         LA    @04,ACTINTF-4(@05)                                  1305
         TM    0(@04),B'10000000'                                  1305
         BZ    @RT01305                                            1305
         L     @05,MVENTPTR                                        1305
         SLA   @14,3                                               1305
         LA    @04,MVVUAS-8(@14,@05)                               1305
         AL    @04,@CF01340                                        1305
         SLR   @03,@03                                             1305
         IC    @03,MVVUA(@15,@04)                                  1305
         SLR   @02,@02                                             1305
         IC    @02,MASK63                                          1305
         NR    @03,@02                                             1305
         CH    @03,WORKVUA                                         1305
         BNE   @RT01305                                            1305
         LA    @14,MVCPUIDS-8(@14,@05)                             1305
         AL    @14,@CF01340                                        1305
         SLR   @05,@05                                             1305
         IC    @05,MVCPUID(@15,@14)                                1305
         SLR   @04,@04                                             1305
         IC    @04,MASK15                                          1305
         NR    @05,@04                                             1305
         CH    @05,WRKCPUID                                        1305
         BE    @RF01305                                            1305
@RT01305 DS    0H                                                  1306
*                                 DO;/*                      @Z40LB61*/
*                                   APSFLD=ON;/*             @Z40LB61*/
         L     @15,@PC00001+4                                      1307
         L     @14,MARGPTR(,@15)                                   1307
         OI    APSFLD(@14),B'10000000'                             1307
*                                   FLDCHAR(1)=STATYES;/*    @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1308
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1308
         MVC   FLDCHAR(3,@14),@CC01343                             1308
*                                   FLDCHAR(2)=STATNO;/*     @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1309
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1309
         MVC   FLDCHAR+12(3,@14),@CC01345                          1309
*                                   CALL IDCCH04(GDTTBL,CDALIST);/*
*                                                            @Z40LB61*/
         L     @14,@PC00001                                        1310
         ST    @14,@AL00001                                        1310
         ST    @15,@AL00001+4                                      1310
         L     @15,@CV01495                                        1310
         LA    @01,@AL00001                                        1310
         BALR  @14,@15                                             1310
*                                 END;/*                     @Z40LB61*/
*                               DONEINTF(MVPATH#,SAINTF#)=ON;/*    1312
*                                                            @Z40LB61*/
@RF01305 LH    @15,MVPATH#                                         1312
         MH    @15,@CH00166                                        1312
         AH    @15,SAINTF#                                         1312
         LA    @14,DONEINTF-4(@15)                                 1312
         OI    0(@14),B'01000000'                                  1312
*                             END;  /*                       @Z40LB61*/
*                         END;      /*                       @Z40LB61*/
@RF01303 LA    @15,1                                               1314
         AH    @15,SAINTF#                                         1314
         STH   @15,SAINTF#                                         1314
         CH    @15,@CH00166                                        1314
         BNH   @DL01302                                            1314
*                       END ALTPATH;/*                       @Z40LB61*/
*                                                                  1315
         LA    @15,1                                               1315
         AH    @15,MVPATH#                                         1315
         STH   @15,MVPATH#                                         1315
         CH    @15,@CH00157                                        1315
         BNH   @DL01301                                            1315
*                       /*********************************************/
*                       /*                                           */
*                       /* RESTORE 'PATH#' VARIABLE          @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1316
*                       MVPATH#=TBLSECT#;/*                  @Z40LB61*/
         MVC   MVPATH#(2),TBLSECT#                                 1316
*                     END MVTCDBM;  /*                       @Z40LB61*/
*                                                                  1317
*                 /***************************************************/
*                 /*                                                 */
*                 /* RESET 'IDCCH04' OPTION FLAGS            @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1318
*                 MSGTYPE=''B;      /*                       @Z40LB61*/
@RC01257 DS    0H                                                  1318
@RT01255 L     @15,@PC00001+4                                      1318
         L     @15,MARGPTR(,@15)                                   1318
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1318
*                 TBLTYPE(1)=''B;   /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1319
*                 TBLTYPE(2)=''B;   /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1320
*               END CDBCHK;         /*                       @Z40LB61*/
*           END GOODINTF;           /*                       @Z40LB61*/
@RF01230 DS    0H                                                  1323
*       END INTFLOOP;               /*                       @Z40LB61*/
@RF01179 LA    @15,1                                               1323
         AH    @15,INTF#                                           1323
         STH   @15,INTF#                                           1323
         CH    @15,@CH00166                                        1323
         BNH   @DL01178                                            1323
*   END SALOOP2;                    /*                       @Z40LB61*/
@RC01165 LA    @15,1                                               1324
         AH    @15,MVPATH#                                         1324
         STH   @15,MVPATH#                                         1324
         CH    @15,@CH00157                                        1324
         BNH   @DL01162                                            1324
*   END MVTVUAS;                    /*                       @Z40LB61*/
         B     @EL00006                                            1325
*                                                                  1326
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - MVTPAGES                                @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE PRIMARILY ROUTES CONTROL TO      @Z40LB61*/
*/*            SUBROUTINES WHICH COMPARE PAGE ALLOCATION     @Z40LB61*/
*/*            DATA IN THE MVT AGAINST PAGE ALLOCATION       @Z40LB61*/
*/*            DATA IN CORRESPONDING MSC AND SA TABLES.      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1326
*MVTPAGES:                                                         1326
*   PROCEDURE;                      /*                       @Z40LB61*/
MVTPAGES STM   @14,@12,@SA00007                                    1326
*   OLDERID2=NEWERID2;                                             1327
         L     @15,@PC00001                                        1327
         L     @14,GDTTR2(,@15)                                    1327
         MVC   @TS00001(95),NEWERID2(@14)                          1327
         MVC   OLDERID2(95,@14),@TS00001                           1327
*   NEWID2='CH2M';                  /*                       @Z40LB61*/
*                                                                  1328
         MVC   NEWID2(4,@14),@CC01610                              1328
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE STAGING DRIVE GROUP (SDG) NUMBER FROM THE      @Z40LB61*/
*   /* MVT ENTRY IS NOT WITHIN THE ALLOWABLE RANGE, PRINT    @Z40LB61*/
*   /* AN ERROR MESSAGE.                                     @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1329
*   IF MVSDG>=SDGMAX THEN                                          1329
         L     @14,MVENTPTR                                        1329
         CLI   MVSDG(@14),30                                       1329
         BL    @RF01329                                            1329
*     DO;                           /*                       @Z40LB61*/
*       MTCHMSG=ON;                 /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      1331
         L     @04,MARGPTR(,@05)                                   1331
         OI    MTCHMSG(@04),B'00010000'                            1331
*       PABTBL(1)=ON;               /*                       @Z40LB61*/
         OI    PABTBL(@04),B'00010000'                             1332
*       MVTTBL(2)=ON;               /*                       @Z40LB61*/
         OI    MVTTBL+4(@04),B'10000000'                           1333
*       SDGFLD=ON;                  /*                       @Z40LB61*/
         OI    SDGFLD(@04),B'00000010'                             1334
*       FLDNUM(1)=MVSDG;            /*                       @Z40LB61*/
         SLR   @03,@03                                             1335
         IC    @03,MVSDG(,@14)                                     1335
         ST    @03,FLDNUM(,@04)                                    1335
*       CALL IDCCH04(GDTTBL,CDALIST);/*                      @Z40LB61*/
         ST    @15,@AL00001                                        1336
         ST    @05,@AL00001+4                                      1336
         L     @15,@CV01495                                        1336
         LA    @01,@AL00001                                        1336
         BALR  @14,@15                                             1336
*     END;                          /*                       @Z40LB61*/
*   ELSE                                                           1338
*                                                                  1338
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE SDG# IS VALID, PERFORM CHECKING ASSOCIATED   @Z40LB61*/
*     /* WITH PAGES ALLOCATED TO THE STAGING DRIVE GROUP     @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1338
*     DO;                           /*                       @Z40LB61*/
*                                                                  1338
         B     @RC01329                                            1338
@RF01329 DS    0H                                                  1339
*       /*************************************************************/
*       /*                                                           */
*       /* PERFORM CONSISTENCY CHECKING FOR ALLOCATED PAGES  @Z40LB61*/
*       /* AS DESCRIBED IN THE SDG PAGE AVAILABILITY BLOCK   @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1339
*       CALL MVTPAB;                /*                       @Z40LB61*/
         BAL   @14,MVTPAB                                          1339
*       IF LASTCOND^=0 THEN                                        1340
         L     @15,@PC00001+8                                      1340
         ICM   @14,3,LASTCOND(@15)                                 1340
         BNZ   @RT01340                                            1340
*         RETURN;                   /*                       @Z40LB61*/
*                                                                  1341
*       /*************************************************************/
*       /*                                                           */
*       /* PERFORM CONSISTENCY CHECKING FOR ALLOCATED PAGES  @Z40LB61*/
*       /* AS DESCRIBED IN THE SDG REAL PAGE MAP             @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1342
*       CALL MVTRPM;                /*                       @Z40LB61*/
         BAL   @14,MVTRPM                                          1342
*       IF LASTCOND^=0 THEN                                        1343
         L     @15,@PC00001+8                                      1343
         ICM   @14,3,LASTCOND(@15)                                 1343
         BNZ   @RT01343                                            1343
*         RETURN;                   /*                       @Z40LB61*/
*                                                                  1344
*       /*************************************************************/
*       /*                                                           */
*       /* IF MSC-MSC CHECKING WAS REQUESTED, PERFORM        @Z40LB61*/
*       /* CONSISTENCY CHECKING INVOLVING PAGES WHICH ARE    @Z40LB61*/
*       /* ALLOCATED BUT INACTIVE.                           @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1345
*       IF MSCCHK=ON THEN                                          1345
         L     @15,@PC00001+4                                      1345
         TM    MSCCHK(@15),B'10000000'                             1345
         BNO   @RF01345                                            1345
*         CALL INACTIVE;            /*                       @Z40LB61*/
         BAL   @14,INACTIVE                                        1346
*     END;                          /*                       @Z40LB61*/
*   END MVTPAGES;                   /*                       @Z40LB61*/
@EL00007 DS    0H                                                  1348
@EF00007 DS    0H                                                  1348
@ER00007 LM    @14,@12,@SA00007                                    1348
         BR    @14                                                 1348
*                                                                  1349
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - MVTPAB                                  @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES MVT PAGE ALLOCATION     @Z40LB61*/
*/*            DATA AGAINST RELATED INFORMATION IN THE       @Z40LB61*/
*/*            ASSOCIATED SDG PAGE AVAILABILITY BLOCK        @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*        (2) MSC SDG PAGE AVAILABILITY BLOCK               @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*        (3) COUNT OF INACTIVE PAGES FOR THIS VOLUME       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1349
*MVTPAB:                                                           1349
*   PROCEDURE;                      /*                       @Z40LB61*/
MVTPAB   STM   @14,@12,@SA00008                                    1349
*   OLDERID2=NEWERID2;                                             1350
         L     @15,@PC00001                                        1350
         L     @14,GDTTR2(,@15)                                    1350
         MVC   @TS00001(95),NEWERID2(@14)                          1350
         MVC   OLDERID2(95,@14),@TS00001                           1350
*   NEWID2='CH2N';                  /*                       @Z40LB61*/
*                                                                  1351
         MVC   NEWID2(4,@14),@CC01617                              1351
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN THE PAGE AVAILABILITY BLOCK (PAB) FOR THE      @Z40LB61*/
*   /* SDG ASSOCIATED WITH THE CURRENT MVT ENTRY.            @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1352
*   TABLEID=SDGTBLID;               /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1352
         L     @05,EARGPTR(,@14)                                   1352
         MVC   TABLEID(1,@05),SDGTBLID                             1352
*   PABFLAG=ON;                     /*                       @Z40LB61*/
         OI    PABFLAG(@05),B'01000000'                            1353
*   SDGNUM=MVSDG;                   /*                       @Z40LB61*/
         L     @01,MVENTPTR                                        1354
         SLR   @00,@00                                             1354
         IC    @00,MVSDG(,@01)                                     1354
         STH   @00,SDGNUM(,@05)                                    1354
*   CALL IDCCH03(GDTTBL,CDALIST);   /*                       @Z40LB61*/
         ST    @15,@AL00001                                        1355
         ST    @14,@AL00001+4                                      1355
         L     @15,@CV01494                                        1355
         LA    @01,@AL00001                                        1355
         BALR  @14,@15                                             1355
*   IF GETRC^=0 THEN                                               1356
         L     @15,@PC00001+4                                      1356
         L     @01,EARGPTR(,@15)                                   1356
         ICM   @00,3,GETRC(@01)                                    1356
         BZ    @RF01356                                            1356
*     DO;                           /*                       @Z40LB61*/
*       LASTCOND=LASTCC12;          /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      1358
         MVC   LASTCOND(2,@15),@CH00567                            1358
*       RETURN;                     /*                       @Z40LB61*/
@EL00008 DS    0H                                                  1359
@EF00008 DS    0H                                                  1359
@ER00008 LM    @14,@12,@SA00008                                    1359
         BR    @14                                                 1359
*     END;                          /*                       @Z40LB61*/
*   PABPTR=TBLADDR;                 /*                       @Z40LB61*/
*                                                                  1361
@RF01356 L     @15,@PC00001+4                                      1361
         L     @01,EARGPTR(,@15)                                   1361
         MVC   PABPTR(4),TBLADDR(@01)                              1361
*   /*****************************************************************/
*   /*                                                               */
*   /* EXAMINE THE DEVICE ATTRIBUTE FLAGS OF THE PAB TO      @Z40LB61*/
*   /* DETERMINE WHICH DEVICES ARE STAGING DEVICES           @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1362
*   STAGEDEV=''B;                   /*                       @Z40LB61*/
         MVI   STAGEDEV,X'00'                                      1362
*   DO DEV#=1 TO DEVSSDG;           /*                       @Z40LB61*/
         LA    @15,1                                               1363
         STH   @15,DEV#                                            1363
@DL01363 DS    0H                                                  1364
*     IF PABDEX(DEV#)=ON&(PABVARV(DEV#)=ON|PABVARN(DEV#)=ON) THEN  1364
         L     @14,PABPTR                                          1364
         LR    @05,@15                                             1364
         SLA   @05,2                                               1364
         ST    @05,@TF00001                                        1364
         ALR   @05,@14                                             1364
         TM    PABDEX-4(@05),B'10000000'                           1364
         BNO   @RF01364                                            1364
         AL    @14,@TF00001                                        1364
         TM    PABVARV-4(@14),B'01000010'                          1364
         BZ    @RF01364                                            1364
*       STAGEDEV=STAGEDEV|BITMASK(DEV#);/*                   @Z40LB61*/
         LA    @14,BITMASK-1(@15)                                  1365
         OC    STAGEDEV(1),0(@14)                                  1365
*   END;                            /*                       @Z40LB61*/
*                                                                  1366
@RF01364 LA    @15,1                                               1366
         AH    @15,DEV#                                            1366
         STH   @15,DEV#                                            1366
         CH    @15,@CH00183                                        1366
         BNH   @DL01363                                            1366
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK MVT INFORMATION PERTAINING TO BOTH POSSIBLE     @Z40LB61*/
*   /* SA PATHS                                              @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1367
*   PABABOX=L3333SSA;               /*                       @Z40LB61*/
         MVC   PABABOX(2),@CH00157                                 1367
*MVTPABM1:                                                         1368
*   DO MVPATH#=1 TO SASSDG;         /*                       @Z40LB61*/
MVTPABM1 LA    @15,1                                               1368
         STH   @15,MVPATH#                                         1368
@DL01368 DS    0H                                                  1369
*     MVSA#=MVSA(MVPATH#)&MASK15;   /*                       @Z40LB61*/
*                                                                  1369
         L     @14,MVENTPTR                                        1369
         SLA   @15,3                                               1369
         SLR   @05,@05                                             1369
         IC    @05,MVSA-8(@15,@14)                                 1369
         SLR   @04,@04                                             1369
         IC    @04,MASK15                                          1369
         NR    @05,@04                                             1369
         STH   @05,MVSA#                                           1369
*     /***************************************************************/
*     /*                                                             */
*     /* CHECK WHETHER THE SA PATH IS VALID                  @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1370
*     IF MVVLDSA(MVPATH#)=ON&       /*                       @ZA27324*/
*         VLDSSID(MVSA#)^=NULLSSID THEN/*                    @ZA27324*/
         ALR   @14,@15                                             1370
         TM    MVVLDSA-8(@14),B'10000000'                          1370
         BNO   @RF01370                                            1370
         ALR   @05,@05                                             1370
         L     @04,@PC00001+4                                      1370
         LH    @15,VLDSSID-2(@05,@04)                              1370
         CH    @15,@CH01340                                        1370
         BE    @RF01370                                            1370
*MVTPABM2:                                                         1371
*       DO;                         /*                       @Z40LB61*/
MVTPABM2 DS    0H                                                  1372
*         MATCHED=OFF;              /*                       @Z40LB61*/
*                                                                  1372
         NI    MATCHED,B'01111111'                                 1372
*         /***********************************************************/
*         /*                                                         */
*         /* FOR A VALID SA PATH BASED ON THE MVT ENTRY,     @Z40LB61*/
*         /* CHECK EACH POSSIBLE SA PATH IN THE PAB FOR      @Z40LB61*/
*         /* MATCHING INFORMATION                            @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1373
*         DO PABPATH#=1 TO SASSDG;  /*                       @Z40LB61*/
         LA    @15,1                                               1373
         STH   @15,PABPATH#                                        1373
@DL01373 DS    0H                                                  1374
*           WORKSA=PABSA(PABPATH#)&MASK15;/*                 @Z40LB61*/
*                                                                  1374
         L     @14,PABPTR                                          1374
         SLR   @05,@05                                             1374
         IC    @05,PABSA-1(@15,@14)                                1374
         SLR   @04,@04                                             1374
         IC    @04,MASK15                                          1374
         NR    @05,@04                                             1374
         STH   @05,WORKSA                                          1374
*           /*********************************************************/
*           /*                                                       */
*           /* IF A MATCHING SA IS FOUND IN THE PAB, NOTE IT @Z40LB61*/
*           /* HAS BEEN MATCHED. CONVERT THE 3333 ADDRESS    @Z40LB61*/
*           /* ASSOCIATED WITH IT INTO A NUMERIC VALUE.      @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1375
*           IF PABVLDSA(PABPATH#)=ON&WORKSA=MVSA# THEN             1375
         ALR   @15,@14                                             1375
         TM    PABVLDSA-1(@15),B'10000000'                         1375
         BNO   @RF01375                                            1375
         CH    @05,MVSA#                                           1375
         BNE   @RF01375                                            1375
*             DO;                   /*                       @Z40LB61*/
*               MATCHED=ON;         /*                       @Z40LB61*/
         OI    MATCHED,B'10000000'                                 1377
*               PABVLDSA(PABPATH#)=OFF;/*                    @Z40LB61*/
         LH    @15,PABPATH#                                        1378
         ALR   @15,@14                                             1378
         NI    PABVLDSA-1(@15),B'01111111'                         1378
*               IF PAB3333(PABPATH#)=OFF THEN                      1379
         LH    @15,PABPATH#                                        1379
         ALR   @14,@15                                             1379
         TM    PAB3333-1(@14),B'00010000'                          1379
         BNZ   @RF01379                                            1379
*                 PABABOX=0;        /*                       @Z40LB61*/
         SLR   @15,@15                                             1380
         STH   @15,PABABOX                                         1380
*               ELSE                                               1381
*                 PABABOX=1;        /*                       @Z40LB61*/
         B     @RC01379                                            1381
@RF01379 MVC   PABABOX(2),@CH00223                                 1381
*             END;                  /*                       @Z40LB61*/
@RC01379 DS    0H                                                  1383
*         END;                      /*                       @Z40LB61*/
*                                                                  1383
@RF01375 LA    @15,1                                               1383
         AH    @15,PABPATH#                                        1383
         STH   @15,PABPATH#                                        1383
         CH    @15,@CH00157                                        1383
         BNH   @DL01373                                            1383
*         /***********************************************************/
*         /*                                                         */
*         /* IF NO MATCH IS FOUND IN THE PAB FOR A VALID MVT @Z40LB61*/
*         /* SA#, PRINT AN ERROR MESSAGE                     @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1384
*         IF MATCHED=OFF THEN                                      1384
         TM    MATCHED,B'10000000'                                 1384
         BNZ   @RF01384                                            1384
*           DO;                     /*                       @Z40LB61*/
*             PABTBL(1)=ON;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1386
         L     @14,MARGPTR(,@15)                                   1386
         OI    PABTBL(@14),B'00010000'                             1386
*             MVTTBL(2)=ON;         /*                       @Z40LB61*/
         OI    MVTTBL+4(@14),B'10000000'                           1387
*             MTCHMSG=ON;           /*                       @Z40LB61*/
         OI    MTCHMSG(@14),B'00010000'                            1388
*             SAFLD=ON;             /*                       @Z40LB61*/
         OI    SAFLD(@14),B'00001000'                              1389
*             FLDNUM(1)=MVSA#;      /*                       @Z40LB61*/
         LH    @05,MVSA#                                           1390
         ST    @05,FLDNUM(,@14)                                    1390
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1391
         ST    @14,@AL00001                                        1391
         ST    @15,@AL00001+4                                      1391
         L     @15,@CV01495                                        1391
         LA    @01,@AL00001                                        1391
         BALR  @14,@15                                             1391
*           END;                    /*                       @Z40LB61*/
*       END MVTPABM2;               /*                       @Z40LB61*/
@RF01384 DS    0H                                                  1394
*   END MVTPABM1;                   /*                       @Z40LB61*/
*                                                                  1394
@RF01370 LA    @15,1                                               1394
         AH    @15,MVPATH#                                         1394
         STH   @15,MVPATH#                                         1394
         CH    @15,@CH00157                                        1394
         BNH   @DL01368                                            1394
*   /*****************************************************************/
*   /*                                                               */
*   /* NOW CHECK THAT EACH POSSIBLE SA PATH IN THE PAB       @Z40LB61*/
*   /* MATCHED WITH AN MVT SA                                @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1395
*MVTPABM3:                                                         1395
*   DO PABPATH#=1 TO SASSDG;        /*                       @Z40LB61*/
MVTPABM3 LA    @15,1                                               1395
         STH   @15,PABPATH#                                        1395
@DL01395 DS    0H                                                  1396
*     PABSA#=PABSA(PABPATH#)&MASK15;/*                       @ZA27324*/
*                                                                  1396
         L     @14,PABPTR                                          1396
         SLR   @05,@05                                             1396
         IC    @05,PABSA-1(@15,@14)                                1396
         SLR   @04,@04                                             1396
         IC    @04,MASK15                                          1396
         NR    @05,@04                                             1396
         STH   @05,PABSA#                                          1396
*     /***************************************************************/
*     /*                                                             */
*     /* IF AN SA IS UNMATCHED, PRINT AN ERROR MESSAGE       @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1397
*     IF PABVLDSA(PABPATH#)=ON&     /*                       @ZA27324*/
*         VLDSSID(PABSA#)^=NULLSSID THEN/*                   @ZA27324*/
         ALR   @14,@15                                             1397
         TM    PABVLDSA-1(@14),B'10000000'                         1397
         BNO   @RF01397                                            1397
         LR    @04,@05                                             1397
         ALR   @04,@04                                             1397
         L     @15,@PC00001+4                                      1397
         LH    @14,VLDSSID-2(@04,@15)                              1397
         CH    @14,@CH01340                                        1397
         BE    @RF01397                                            1397
*       DO;                         /*                       @Z40LB61*/
*         MTCHMSG=ON;               /*                       @Z40LB61*/
         L     @14,MARGPTR(,@15)                                   1399
         OI    MTCHMSG(@14),B'00010000'                            1399
*         MVTTBL(1)=ON;             /*                       @Z40LB61*/
         OI    MVTTBL(@14),B'10000000'                             1400
*         PABTBL(2)=ON;             /*                       @Z40LB61*/
         OI    PABTBL+4(@14),B'00010000'                           1401
*         SAFLD=ON;                 /*                       @Z40LB61*/
         OI    SAFLD(@14),B'00001000'                              1402
*         FLDNUM(1)=PABSA#;         /*                       @ZA27324*/
         ST    @05,FLDNUM(,@14)                                    1403
*         SDGINDEX(2)=MVSDG;        /*                       @Z40LB61*/
         L     @05,MVENTPTR                                        1404
         MVC   SDGINDEX+24(1,@14),MVSDG(@05)                       1404
*         LUAINDEX(2)=MV3333;       /*                       @Z40LB61*/
         MVC   LUAINDEX+24(1,@14),MV3333(@05)                      1405
*         CHRINDEX(2)=PREVCHR;      /*                       @Z40LB61*/
         L     @01,EARGPTR(,@15)                                   1406
         MVC   CHRINDEX+24(5,@14),PREVCHR(@01)                     1406
*         CALL IDCCH04(GDTTBL,CDALIST);/*                    @Z40LB61*/
         L     @14,@PC00001                                        1407
         ST    @14,@AL00001                                        1407
         ST    @15,@AL00001+4                                      1407
         L     @15,@CV01495                                        1407
         LA    @01,@AL00001                                        1407
         BALR  @14,@15                                             1407
*       END;                        /*                       @Z40LB61*/
*   END MVTPABM3;                   /*                       @Z40LB61*/
*                                                                  1409
@RF01397 LA    @15,1                                               1409
         AH    @15,PABPATH#                                        1409
         STH   @15,PABPATH#                                        1409
         CH    @15,@CH00157                                        1409
         BNH   @DL01395                                            1409
*   /*****************************************************************/
*   /*                                                               */
*   /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES          @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1410
*   PABTBL(1)=ON;                   /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1410
         L     @14,MARGPTR(,@15)                                   1410
         OI    PABTBL(@14),B'00010000'                             1410
*   MVTTBL(2)=ON;                   /*                       @Z40LB61*/
         OI    MVTTBL+4(@14),B'10000000'                           1411
*   INCNMSG=ON;                     /*                       @Z40LB61*/
         OI    INCNMSG(@14),B'10000000'                            1412
*   SDGINDEX(1)=MVSDG;              /*                       @Z40LB61*/
         L     @05,MVENTPTR                                        1413
         MVC   SDGINDEX(1,@14),MVSDG(@05)                          1413
*   LUAINDEX(1)=MV3333;             /*                       @Z40LB61*/
         SLR   @04,@04                                             1414
         IC    @04,MV3333(,@05)                                    1414
         STC   @04,LUAINDEX(,@14)                                  1414
*   CHRINDEX(1)=PREVCHR;            /*                       @Z40LB61*/
         L     @01,EARGPTR(,@15)                                   1415
         MVC   CHRINDEX(5,@14),PREVCHR(@01)                        1415
*   VSNINDEX(2)=MVVOLID;            /*                       @Z40LB61*/
         MVC   VSNINDEX+24(6,@14),MVVOLID(@05)                     1416
*   CHRINDEX(2)=SAVECHR;            /*                       @Z40LB61*/
         MVC   CHRINDEX+24(5,@14),SAVECHR                          1417
*   MSGNRSET=ON;                    /*                       @Z40LB61*/
         OI    MSGNRSET(@14),B'00000001'                           1418
*   TBLNRSET(1)=ON;                 /*                       @Z40LB61*/
         OI    TBLNRSET(@14),B'00000001'                           1419
*   TBLNRSET(2)=ON;                 /*                       @Z40LB61*/
*                                                                  1420
         OI    TBLNRSET+4(@14),B'00000001'                         1420
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK THAT THE LOGICAL 3333 ADDRESS FROM THE PAB      @Z40LB61*/
*   /* MATCHES THE 3333 ADDRESS FROM THE MVT ENTRY           @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1421
*   WORK3333=MV3333/SHIFT3;         /*                       @Z40LB61*/
         SRL   @04,3                                               1421
         STC   @04,WORK3333                                        1421
*   IF PABABOX^=L3333SSA&PABABOX^=WORK3333 THEN                    1422
         LH    @05,PABABOX                                         1422
         CH    @05,@CH00157                                        1422
         BE    @RF01422                                            1422
         CR    @05,@04                                             1422
         BE    @RF01422                                            1422
*     DO;                           /*                       @Z40LB61*/
*       L3AFLD=ON;                  /*                       @Z40LB61*/
         OI    L3AFLD(@14),B'00000001'                             1424
*       FLDNUM(1)=PABABOX;          /*                       @Z40LB61*/
         ST    @05,FLDNUM(,@14)                                    1425
*       FLDNUM(2)=WORK3333;         /*                       @Z40LB61*/
         ST    @04,FLDNUM+12(,@14)                                 1426
*       CALL IDCCH04(GDTTBL,CDALIST);/*                      @Z40LB61*/
         L     @14,@PC00001                                        1427
         ST    @14,@AL00001                                        1427
         ST    @15,@AL00001+4                                      1427
         L     @15,@CV01495                                        1427
         LA    @01,@AL00001                                        1427
         BALR  @14,@15                                             1427
*     END;                          /*                       @Z40LB61*/
*                                                                  1428
*   /*****************************************************************/
*   /*                                                               */
*   /* EXAMINE EACH VIRTUAL PAGE ENTRY OF THE CURRENT MVT    @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1429
*   INACTCNT=0;                     /*                       @Z40LB61*/
@RF01422 SLR   @15,@15                                             1429
         STH   @15,INACTCNT                                        1429
*VPLOOP1:                                                          1430
*   DO MVVP#=1 TO VPMAX;            /*                       @Z40LB61*/
*                                                                  1430
VPLOOP1  LA    @15,1                                               1430
         STH   @15,MVVP#                                           1430
@DL01430 DS    0H                                                  1431
*     /***************************************************************/
*     /*                                                             */
*     /* FOR VIRTUAL PAGES THAT ARE ALLOCATED, PREPARE TO    @Z40LB61*/
*     /* CHECK FOR CONSISTENCY WITH THE PAB                  @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1431
*     IF MVRPNUM(MVVP#)^=0 THEN                                    1431
         SLA   @15,2                                               1431
         L     @01,MVENTPTR                                        1431
         SLR   @14,@14                                             1431
         IC    @14,MVRPNUM-4(@15,@01)                              1431
         CH    @14,@CH00119                                        1431
         BE    @RF01431                                            1431
*PGALLOC:                                                          1432
*       DO;                         /*                       @Z40LB61*/
PGALLOC  DS    0H                                                  1433
*         OLDERID2=NEWERID2;                                       1433
         L     @15,@PC00001                                        1433
         L     @15,GDTTR2(,@15)                                    1433
         MVC   @TS00001(95),NEWERID2(@15)                          1433
         MVC   OLDERID2(95,@15),@TS00001                           1433
*         NEWID2='CH2P';            /*                       @Z40LB61*/
         MVC   NEWID2(4,@15),@CC01628                              1434
*         DEV#=(MVLOGDEV(MVVP#)&MASK7)+1;/*                  @Z40LB61*/
         LA    @15,1                                               1435
         L     @14,MVENTPTR                                        1435
         LH    @05,MVVP#                                           1435
         SLA   @05,2                                               1435
         SLR   @04,@04                                             1435
         IC    @04,MVLOGDEV-4(@05,@14)                             1435
         SLR   @03,@03                                             1435
         IC    @03,MASK7                                           1435
         NR    @04,@03                                             1435
         ALR   @04,@15                                             1435
         STH   @04,DEV#                                            1435
*         LUAINDEX(1)=DEV#+MV3333-1;/*                       @Z40LB61*/
*                                                                  1436
         L     @03,@PC00001+4                                      1436
         L     @01,MARGPTR(,@03)                                   1436
         SLR   @00,@00                                             1436
         IC    @00,MV3333(,@14)                                    1436
         ALR   @04,@00                                             1436
         BCTR  @04,0                                               1436
         STC   @04,LUAINDEX(,@01)                                  1436
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE VIRTUAL PAGE IS INACTIVE, ADD 1 TO THE   @Z40LB61*/
*         /* COUNT OF INACTIVE PAGES FOR THIS MVT ENTRY      @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1437
*         IF MVPINACT(MVVP#)=ON THEN                               1437
         ALR   @14,@05                                             1437
         TM    MVPINACT-4(@14),B'10000000'                         1437
         BNO   @RF01437                                            1437
*           INACTCNT=INACTCNT+1;    /*                       @Z40LB61*/
*                                                                  1438
         AH    @15,INACTCNT                                        1438
         STH   @15,INACTCNT                                        1438
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK THAT THE DEVICE# FROM THE VIRTUAL PAGE    @Z40LB61*/
*         /* ENTRY IS A VALID STAGING DEVICE IN THE PAB      @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1439
*         IF(STAGEDEV&BITMASK(DEV#))^=0 THEN                       1439
@RF01437 LH    @01,DEV#                                            1439
         SLR   @00,@00                                             1439
         IC    @00,STAGEDEV                                        1439
         SLR   @15,@15                                             1439
         IC    @15,BITMASK-1(@01)                                  1439
         NR    @00,@15                                             1439
         LTR   @00,@00                                             1439
         BZ    @RF01439                                            1439
*VALIDDEV:                                                         1440
*           DO;                     /*                       @Z40LB61*/
*                                                                  1440
VALIDDEV DS    0H                                                  1441
*             /*******************************************************/
*             /*                                                     */
*             /* CHECK FOR CONSISTENT 'VOLUME BOUND' STATUS. @Z40LB61*/
*             /* IF INCONSISTENT, PRINT AN ERROR MESSAGE     @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1441
*             IF PABVBND(DEV#)=ON&MVBNDVOL=OFF THEN                1441
         LH    @15,DEV#                                            1441
         SLA   @15,2                                               1441
         L     @01,PABPTR                                          1441
         ALR   @01,@15                                             1441
         TM    PABVBND-4(@01),B'00000100'                          1441
         BNO   @RF01441                                            1441
         L     @01,MVENTPTR                                        1441
         TM    MVBNDVOL(@01),B'00000100'                           1441
         BNZ   @RF01441                                            1441
*               DO;                 /*                       @Z40LB61*/
*                 VBSFLD=ON;        /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1443
         L     @14,MARGPTR(,@15)                                   1443
         OI    VBSFLD(@14),B'00010000'                             1443
*                 FLDCHAR(1)=STATYES;/*                      @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1444
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1444
         MVC   FLDCHAR(3,@14),@CC01343                             1444
*                 FLDCHAR(2)=STATNO;/*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1445
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1445
         MVC   FLDCHAR+12(3,@14),@CC01345                          1445
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @Z40LB61*/
         L     @14,@PC00001                                        1446
         ST    @14,@AL00001                                        1446
         ST    @15,@AL00001+4                                      1446
         L     @15,@CV01495                                        1446
         LA    @01,@AL00001                                        1446
         BALR  @14,@15                                             1446
*               END;                /*                       @Z40LB61*/
*             IF PABVBND(DEV#)=OFF&MVBNDVOL=ON THEN                1448
@RF01441 LH    @15,DEV#                                            1448
         SLA   @15,2                                               1448
         L     @01,PABPTR                                          1448
         ALR   @01,@15                                             1448
         TM    PABVBND-4(@01),B'00000100'                          1448
         BNZ   @RF01448                                            1448
         L     @01,MVENTPTR                                        1448
         TM    MVBNDVOL(@01),B'00000100'                           1448
         BNO   @RF01448                                            1448
*               DO;                 /*                       @Z40LB61*/
*                 VBSFLD=ON;        /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1450
         L     @14,MARGPTR(,@15)                                   1450
         OI    VBSFLD(@14),B'00010000'                             1450
*                 FLDCHAR(1)=STATNO;/*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1451
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1451
         MVC   FLDCHAR(3,@14),@CC01345                             1451
*                 FLDCHAR(2)=STATYES;/*                      @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1452
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1452
         MVC   FLDCHAR+12(3,@14),@CC01343                          1452
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @Z40LB61*/
         L     @14,@PC00001                                        1453
         ST    @14,@AL00001                                        1453
         ST    @15,@AL00001+4                                      1453
         L     @15,@CV01495                                        1453
         LA    @01,@AL00001                                        1453
         BALR  @14,@15                                             1453
*               END;                /*                       @Z40LB61*/
*           END VALIDDEV;           /*                       @Z40LB61*/
*         ELSE                                                     1456
*                                                                  1456
*           /*********************************************************/
*           /*                                                       */
*           /* IF THE PAB INDICATES THAT THE DEVICE IS NOT   @Z40LB61*/
*           /* VALID OR IS NOT ONLINE, PRINT AN ERROR MESSAGE        */
*           /*                                               @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1456
*           DO;                     /*                       @Z40LB61*/
         B     @RC01439                                            1456
@RF01439 DS    0H                                                  1457
*             IF PABDEX(DEV#)=OFF THEN                             1457
         LH    @15,DEV#                                            1457
         SLA   @15,2                                               1457
         L     @01,PABPTR                                          1457
         ALR   @01,@15                                             1457
         TM    PABDEX-4(@01),B'10000000'                           1457
         BNZ   @RF01457                                            1457
*               DVSFLD=ON;          /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1458
         L     @01,MARGPTR(,@15)                                   1458
         OI    DVSFLD(@01),B'00000100'                             1458
*             ELSE                                                 1459
*               DOSFLD=ON;          /*                       @Z40LB61*/
         B     @RC01457                                            1459
@RF01457 L     @15,@PC00001+4                                      1459
         L     @01,MARGPTR(,@15)                                   1459
         OI    DOSFLD(@01),B'00000010'                             1459
*             FLDCHAR(1)=STATNO;    /*                       @Z40LB61*/
@RC01457 L     @15,@PC00001+4                                      1460
         L     @14,MARGPTR(,@15)                                   1460
         MVI   FLDCHAR+3(@14),C' '                                 1460
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1460
         MVC   FLDCHAR(3,@14),@CC01345                             1460
*             FLDCHAR(2)=STATYES;   /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1461
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1461
         MVC   FLDCHAR+12(3,@14),@CC01343                          1461
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1462
         ST    @14,@AL00001                                        1462
         ST    @15,@AL00001+4                                      1462
         L     @15,@CV01495                                        1462
         LA    @01,@AL00001                                        1462
         BALR  @14,@15                                             1462
*           END;                    /*                       @Z40LB61*/
*       END PGALLOC;                /*                       @Z40LB61*/
@RC01439 DS    0H                                                  1465
*   END VPLOOP1;                    /*                       @Z40LB61*/
*                                                                  1465
@RF01431 LA    @15,1                                               1465
         AH    @15,MVVP#                                           1465
         STH   @15,MVVP#                                           1465
         CH    @15,@CH00868                                        1465
         BNH   @DL01430                                            1465
*   /*****************************************************************/
*   /*                                                               */
*   /* RESET 'IDCCH04' OPTION FLAGS                          @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1466
*   MSGTYPE=''B;                    /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1466
         L     @15,MARGPTR(,@15)                                   1466
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1466
*   TBLTYPE(1)=''B;                 /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1467
*   TBLTYPE(2)=''B;                 /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1468
*   END MVTPAB;                     /*                       @Z40LB61*/
         B     @EL00008                                            1469
*                                                                  1470
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - MVTRPM                                  @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES MVT PAGE ALLOCATION     @Z40LB61*/
*/*            DATA AGAINST RELATED DATA IN THE ASSOCIATED   @Z40LB61*/
*/*            SDG REAL PAGE MAPS AND ASSOCIATED SA PAGE     @Z40LB61*/
*/*            STATUS TABLE(S).                              @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*        (2) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*        (3) MSC SDG REAL PAGE MAPS                        @Z40LB61*/
*/*        (4) SA PAGE STATUS TABLE                          @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*        (3) SDG RPM CHECK-OFF TABLE                       @Z40LB61*/
*/*        (4) PST CHECK-OFF TABLE                           @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1470
*MVTRPM:                                                           1470
*   PROCEDURE;                      /*                       @Z40LB61*/
MVTRPM   STM   @14,@12,@SA00009                                    1470
*   OLDERID2=NEWERID2;                                             1471
         L     @15,@PC00001                                        1471
         L     @15,GDTTR2(,@15)                                    1471
         MVC   @TS00001(95),NEWERID2(@15)                          1471
         MVC   OLDERID2(95,@15),@TS00001                           1471
*   NEWID2='CH2Q';                  /*                       @Z40LB61*/
*                                                                  1472
         MVC   NEWID2(4,@15),@CC01634                              1472
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR THE STAGING DRIVE GROUP OF THE CURRENT MVT ENTRY  @Z40LB61*/
*   /* EXAMINE DATA FOR EACH LOGICAL STAGING DEVICE          @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1473
*   SDG#=MVSDG+1;                   /*                       @Z40LB61*/
         LA    @15,1                                               1473
         L     @14,MVENTPTR                                        1473
         SLR   @05,@05                                             1473
         IC    @05,MVSDG(,@14)                                     1473
         ALR   @15,@05                                             1473
         STH   @15,SDG#                                            1473
*DEVLOOP1:                                                         1474
*   DO DEV#=1 TO DEVSSDG;           /*                       @Z40LB61*/
DEVLOOP1 LA    @15,1                                               1474
         STH   @15,DEV#                                            1474
@DL01474 DS    0H                                                  1475
*     VP1STHIT=OFF;                 /*                       @Z40LB61*/
         NI    VP1STHIT,B'01111111'                                1475
*     IF(STAGEDEV&BITMASK(DEV#))^=0 THEN                           1476
*                                                                  1476
         SLR   @14,@14                                             1476
         IC    @14,STAGEDEV                                        1476
         SLR   @05,@05                                             1476
         IC    @05,BITMASK-1(@15)                                  1476
         NR    @14,@05                                             1476
         LTR   @14,@14                                             1476
         BZ    @RF01476                                            1476
*       /*************************************************************/
*       /*                                                           */
*       /* SCAN ALL THE VIRTUAL PAGES ALLOCATED TO THE       @Z40LB61*/
*       /* MVT ENTRY, SEARCHING FOR THOSE ALLOCATED TO       @Z40LB61*/
*       /* THE STAGING DEVICE CURRENTLY BEING EXAMINED.      @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1477
*VPLOOP2:                                                          1477
*       DO MVVP#=1 TO VPMAX;        /*                       @Z40LB61*/
*                                                                  1477
VPLOOP2  LA    @15,1                                               1477
         STH   @15,MVVP#                                           1477
@DL01477 DS    0H                                                  1478
*         /***********************************************************/
*         /*                                                         */
*         /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES    @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1478
*         RPMTBL(1)=ON;             /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1478
         L     @05,MARGPTR(,@14)                                   1478
         OI    RPMTBL(@05),B'00000010'                             1478
*         MVTTBL(2)=ON;             /*                       @Z40LB61*/
         OI    MVTTBL+4(@05),B'10000000'                           1479
*         TBLNRSET(1)=ON;           /*                       @Z40LB61*/
         OI    TBLNRSET(@05),B'00000001'                           1480
*         TBLNRSET(2)=ON;           /*                       @Z40LB61*/
         OI    TBLNRSET+4(@05),B'00000001'                         1481
*         WORKDEV=(MVLOGDEV(MVVP#)&MASK7)+1;/*               @Z40LB61*/
         LA    @04,1                                               1482
         L     @03,MVENTPTR                                        1482
         SLA   @15,2                                               1482
         SLR   @02,@02                                             1482
         IC    @02,MVLOGDEV-4(@15,@03)                             1482
         SLR   @01,@01                                             1482
         IC    @01,MASK7                                           1482
         NR    @02,@01                                             1482
         ALR   @02,@04                                             1482
         STH   @02,WORKDEV                                         1482
*         WORKRP=MVRPNUM(MVVP#)+1;  /*                       @Z40LB61*/
*                                                                  1483
         SLR   @01,@01                                             1483
         IC    @01,MVRPNUM-4(@15,@03)                              1483
         ALR   @01,@04                                             1483
         STH   @01,WORKRP                                          1483
*         /***********************************************************/
*         /*                                                         */
*         /* FOR A VALID VIRTUAL PAGE ENTRY WHOSE DEVICE     @Z40LB61*/
*         /* MATCHES, CHECK THAT THE REAL PAGE# FROM THE     @Z40LB61*/
*         /* VP ENTRY IS WITHIN THE VALID RANGE. IF NOT,     @Z40LB61*/
*         /* PRINT AN ERROR MESSAGE.                         @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1484
*         IF WORKDEV=DEV#&WORKRP^=1 THEN                           1484
         CH    @02,DEV#                                            1484
         BNE   @RF01484                                            1484
         CR    @01,@04                                             1484
         BE    @RF01484                                            1484
*           IF WORKRP>RPMAX THEN                                   1485
         CH    @01,@CH00684                                        1485
         BNH   @RF01485                                            1485
*             DO;                   /*                       @Z40LB61*/
*               MTCHMSG=ON;         /*                       @Z40LB61*/
         OI    MTCHMSG(@05),B'00010000'                            1487
*               RPFLD=ON;           /*                       @Z40LB61*/
         OI    RPFLD(@05),B'00100000'                              1488
*               FLDNUM(1)=WORKRP-1; /*                       @Z40LB61*/
         BCTR  @01,0                                               1489
         ST    @01,FLDNUM(,@05)                                    1489
*               CALL IDCCH04(GDTTBL,CDALIST);/*              @Z40LB61*/
         L     @15,@PC00001                                        1490
         ST    @15,@AL00001                                        1490
         ST    @14,@AL00001+4                                      1490
         L     @15,@CV01495                                        1490
         LA    @01,@AL00001                                        1490
         BALR  @14,@15                                             1490
*             END;                  /*                       @Z40LB61*/
*           ELSE                                                   1492
*                                                                  1492
*             /*******************************************************/
*             /*                                                     */
*             /* FOR A VALID VP ENTRY WITH A GOOD REAL       @Z40LB61*/
*             /* PAGE#, FIRST DO COMMON SET-UP FOR           @Z40LB61*/
*             /* POSSIBLE ERROR MESSAGES.                    @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1492
*GOODPAGE:                                                         1492
*             DO;                   /*                       @Z40LB61*/
         B     @RC01485                                            1492
@RF01485 DS    0H                                                  1492
GOODPAGE DS    0H                                                  1493
*               OLDERID2=NEWERID2;                                 1493
         L     @15,@PC00001                                        1493
         L     @14,GDTTR2(,@15)                                    1493
         MVC   @TS00001(95),NEWERID2(@14)                          1493
         MVC   OLDERID2(95,@14),@TS00001                           1493
*               NEWID2='CH2R';      /*                       @Z40LB61*/
         MVC   NEWID2(4,@14),@CC01641                              1494
*               INCNMSG=ON;         /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1495
         L     @05,MARGPTR(,@14)                                   1495
         OI    INCNMSG(@05),B'10000000'                            1495
*               SDGINDEX(1)=MVSDG;  /*                       @Z40LB61*/
         L     @04,MVENTPTR                                        1496
         SLR   @03,@03                                             1496
         IC    @03,MVSDG(,@04)                                     1496
         STC   @03,SDGINDEX(,@05)                                  1496
*               LUAINDEX(1)=DEV#+MV3333-1;/*                 @Z40LB61*/
         LH    @02,DEV#                                            1497
         SLR   @01,@01                                             1497
         IC    @01,MV3333(,@04)                                    1497
         ALR   @01,@02                                             1497
         BCTR  @01,0                                               1497
         STC   @01,LUAINDEX(,@05)                                  1497
*               RPINDEX(1)=WORKRP-1;/*                       @Z40LB61*/
         LH    @04,WORKRP                                          1498
         BCTR  @04,0                                               1498
         STC   @04,RPINDEX(,@05)                                   1498
*               MSGNRSET=ON;        /*                       @Z40LB61*/
*                                                                  1499
         OI    MSGNRSET(@05),B'00000001'                           1499
*               /*****************************************************/
*               /*                                                   */
*               /* WHEN THE FIRST VIRTUAL PAGE ENTRY IS      @Z40LB61*/
*               /* FOUND CORRESPONDING TO THE CURRENT        @Z40LB61*/
*               /* DEVICE, OBTAIN THE REAL PAGE MAP (RPM)    @Z40LB61*/
*               /* FOR THAT DEVICE.                          @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1500
*               IF VP1STHIT=OFF THEN                               1500
         TM    VP1STHIT,B'10000000'                                1500
         BNZ   @RF01500                                            1500
*                 DO;               /*                       @Z40LB61*/
*                   VP1STHIT=ON;    /*                       @Z40LB61*/
         OI    VP1STHIT,B'10000000'                                1502
*                   TABLEID=SDGTBLID;/*                      @Z40LB61*/
         L     @05,EARGPTR(,@14)                                   1503
         MVC   TABLEID(1,@05),SDGTBLID                             1503
*                   RPMFLAG=ON;     /*                       @Z40LB61*/
         OI    RPMFLAG(@05),B'10000000'                            1504
*                   SDGNUM=MVSDG;   /*                       @Z40LB61*/
         STH   @03,SDGNUM(,@05)                                    1505
*                   DEVICEID=DEV#-1;/*                       @Z40LB61*/
         BCTR  @02,0                                               1506
         STH   @02,DEVICEID(,@05)                                  1506
*                   CALL IDCCH03(GDTTBL,CDALIST);/*          @Z40LB61*/
         ST    @15,@AL00001                                        1507
         ST    @14,@AL00001+4                                      1507
         L     @15,@CV01494                                        1507
         LA    @01,@AL00001                                        1507
         BALR  @14,@15                                             1507
*                   IF GETRC^=0 THEN                               1508
         L     @15,@PC00001+4                                      1508
         L     @01,EARGPTR(,@15)                                   1508
         ICM   @00,3,GETRC(@01)                                    1508
         BZ    @RF01508                                            1508
*                     DO;           /*                       @Z40LB61*/
*                       LASTCOND=LASTCC12;/*                 @Z40LB61*/
         L     @15,@PC00001+8                                      1510
         MVC   LASTCOND(2,@15),@CH00567                            1510
*                       RETURN;     /*                       @Z40LB61*/
@EL00009 DS    0H                                                  1511
@EF00009 DS    0H                                                  1511
@ER00009 LM    @14,@12,@SA00009                                    1511
         BR    @14                                                 1511
*                     END;          /*                       @Z40LB61*/
*                   RPMPTR=TBLADDR; /*                       @Z40LB61*/
@RF01508 L     @15,@PC00001+4                                      1513
         L     @14,EARGPTR(,@15)                                   1513
         MVC   RPMPTR(4),TBLADDR(@14)                              1513
*                   CHRINDEX(1)=PREVCHR;/*                   @Z40LB61*/
         L     @01,MARGPTR(,@15)                                   1514
         MVC   CHRINDEX(5,@01),PREVCHR(@14)                        1514
*                 END;              /*                       @Z40LB61*/
*                                                                  1515
*               /*****************************************************/
*               /*                                                   */
*               /* CHECK-OFF THE REAL PAGE MAP ENTRY THAT    @Z40LB61*/
*               /* CORRESPONDS TO THE REAL PAGE#             @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1516
*               BYTE#=(WORKRP-1)/8+1;/*                      @Z40LB61*/
@RF01500 L     @15,@PC00001+4                                      1516
         L     @14,EARGPTR(,@15)                                   1516
         LA    @05,1                                               1516
         LH    @04,WORKRP                                          1516
         LR    @03,@04                                             1516
         BCTR  @03,0                                               1516
         LR    @00,@03                                             1516
         SRDA  @00,32                                              1516
         D     @00,@CF00183                                        1516
         ALR   @01,@05                                             1516
         STH   @01,BYTE#(,@14)                                     1516
*               BIT#=(WORKRP-1)//8+1;/*                      @Z40LB61*/
         LR    @00,@03                                             1517
         ST    @01,@TF00001                                        1517
         SRDA  @00,32                                              1517
         D     @00,@CF00183                                        1517
         ALR   @00,@05                                             1517
         STH   @00,BIT#(,@14)                                      1517
*               RPMCHKFF(SDG#,DEV#,BYTE#)=RPMCHKFF(SDG#,DEV#,BYTE#)|
*                   BITMASK(BIT#);  /*                       @Z40LB61*/
*                                                                  1518
         LH    @01,SDG#                                            1518
         SLA   @01,3                                               1518
         AH    @01,DEV#                                            1518
         MH    @01,@CH00769                                        1518
         AL    @01,@TF00001                                        1518
         L     @14,RPMCOPTR(,@15)                                  1518
         ALR   @14,@01                                             1518
         AL    @14,@CF01767                                        1518
         LR    @01,@00                                             1518
         LA    @05,BITMASK-1(@01)                                  1518
         OC    RPMCHKFF(1,@14),0(@05)                              1518
*               /*****************************************************/
*               /*                                                   */
*               /* CHECK VIRTUAL PAGE#'S FOR CONSISTENCY.    @Z40LB61*/
*               /* IF INCONSISTENT, PRINT AN ERROR MESSAGE   @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1519
*               IF RPMVPNUM(WORKRP)^=MVVP#-1 THEN                  1519
         SLA   @04,2                                               1519
         L     @01,RPMPTR                                          1519
         AL    @01,@CF01766                                        1519
         SLR   @05,@05                                             1519
         IC    @05,RPMVPNUM-1(@04,@01)                             1519
         LH    @04,MVVP#                                           1519
         BCTR  @04,0                                               1519
         CR    @05,@04                                             1519
         BE    @RF01519                                            1519
*                 DO;               /*                       @Z40LB61*/
*                   VPFLD=ON;       /*                       @Z40LB61*/
         L     @14,MARGPTR(,@15)                                   1521
         OI    VPFLD(@14),B'00100000'                              1521
*                   FLDNUM(1)=RPMVPNUM(WORKRP);/*            @Z40LB61*/
         ST    @05,FLDNUM(,@14)                                    1522
*                   FLDNUM(2)=MVVP#-1;/*                     @Z40LB61*/
         ST    @04,FLDNUM+12(,@14)                                 1523
*                   CALL IDCCH04(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @14,@PC00001                                        1524
         ST    @14,@AL00001                                        1524
         ST    @15,@AL00001+4                                      1524
         L     @15,@CV01495                                        1524
         LA    @01,@AL00001                                        1524
         BALR  @14,@15                                             1524
*                 END;              /*                       @Z40LB61*/
*                                                                  1525
*               /*****************************************************/
*               /*                                                   */
*               /* CHECK MVT POINTERS FOR CONSISTENCY.       @Z40LB61*/
*               /* IF INCONSISTENT, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1526
*               IF RPMMVT(WORKRP)^=SAVEREC#-1 THEN                 1526
@RF01519 LH    @15,WORKRP                                          1526
         SLA   @15,2                                               1526
         L     @01,RPMPTR                                          1526
         ALR   @01,@15                                             1526
         AL    @01,@CF01760                                        1526
         SLR   @15,@15                                             1526
         ICM   @15,3,RPMMVT-2(@01)                                 1526
         LH    @14,SAVEREC#                                        1526
         BCTR  @14,0                                               1526
         CR    @15,@14                                             1526
         BE    @RF01526                                            1526
*                 DO;               /*                       @Z40LB61*/
*                   MVTPFLD=ON;     /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      1528
         L     @04,MARGPTR(,@05)                                   1528
         OI    MVTPFLD(@04),B'00100000'                            1528
*                   FLDNUM(1)=RPMMVT(WORKRP);/*              @Z40LB61*/
         ST    @15,FLDNUM(,@04)                                    1529
*                   FLDNUM(2)=SAVEREC#-1;/*                  @Z40LB61*/
         ST    @14,FLDNUM+12(,@04)                                 1530
*                   CALL IDCCH04(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @04,@PC00001                                        1531
         ST    @04,@AL00001                                        1531
         ST    @05,@AL00001+4                                      1531
         L     @15,@CV01495                                        1531
         LA    @01,@AL00001                                        1531
         BALR  @14,@15                                             1531
*                 END;              /*                       @Z40LB61*/
*                                                                  1532
*               /*****************************************************/
*               /*                                                   */
*               /* CHECK 'BOUND VOLUME' STATUS CONSISTENCY.  @Z40LB61*/
*               /* IF INCONSISTENT, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1533
*               IF RPMVBND(WORKRP)=ON THEN                         1533
@RF01526 LH    @15,WORKRP                                          1533
         SLA   @15,2                                               1533
         L     @01,RPMPTR                                          1533
         ALR   @01,@15                                             1533
         AL    @01,@CF01761                                        1533
         TM    RPMVBND(@01),B'00010000'                            1533
         BNO   @RF01533                                            1533
*                 IF MVBNDVOL=OFF THEN                             1534
         L     @01,MVENTPTR                                        1534
         TM    MVBNDVOL(@01),B'00000100'                           1534
         BNZ   @RF01534                                            1534
*                   DO;             /*                       @Z40LB61*/
*                     VBSFLD=ON;    /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1536
         L     @14,MARGPTR(,@15)                                   1536
         OI    VBSFLD(@14),B'00010000'                             1536
*                     FLDCHAR(1)=STATYES;/*                  @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1537
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1537
         MVC   FLDCHAR(3,@14),@CC01343                             1537
*                     FLDCHAR(2)=STATNO;/*                   @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1538
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1538
         MVC   FLDCHAR+12(3,@14),@CC01345                          1538
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB61*/
         L     @14,@PC00001                                        1539
         ST    @14,@AL00001                                        1539
         ST    @15,@AL00001+4                                      1539
         L     @15,@CV01495                                        1539
         LA    @01,@AL00001                                        1539
         BALR  @14,@15                                             1539
*                   END;            /*                       @Z40LB61*/
*                 ELSE                                             1541
*                   ;               /*                       @Z40LB61*/
@RF01534 DS    0H                                                  1542
*               ELSE                                               1542
*                 IF MVBNDVOL=ON THEN                              1542
         B     @RC01533                                            1542
@RF01533 L     @01,MVENTPTR                                        1542
         TM    MVBNDVOL(@01),B'00000100'                           1542
         BNO   @RF01542                                            1542
*                   DO;             /*                       @Z40LB61*/
*                     VBSFLD=ON;    /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1544
         L     @14,MARGPTR(,@15)                                   1544
         OI    VBSFLD(@14),B'00010000'                             1544
*                     FLDCHAR(1)=STATNO;/*                   @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1545
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1545
         MVC   FLDCHAR(3,@14),@CC01345                             1545
*                     FLDCHAR(2)=STATYES;/*                  @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1546
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1546
         MVC   FLDCHAR+12(3,@14),@CC01343                          1546
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB61*/
         L     @14,@PC00001                                        1547
         ST    @14,@AL00001                                        1547
         ST    @15,@AL00001+4                                      1547
         L     @15,@CV01495                                        1547
         LA    @01,@AL00001                                        1547
         BALR  @14,@15                                             1547
*                   END;            /*                       @Z40LB61*/
*                 ELSE                                             1549
*                                                                  1549
*                   /*************************************************/
*                   /*                                               */
*                   /* IF BOTH TABLES INDICATE THAT THIS     @Z40LB61*/
*                   /* PAGE ISN'T FOR A BOUND VOLUME, CHECK  @Z40LB61*/
*                   /* FOR INCONSISTENT PAGE ATTRIBUTES.     @Z40LB61*/
*                   /* IF INCONSISTENT, PRINT AN ERROR MSG   @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1549
*PGSTATUS:                                                         1549
*                   DO;             /*                       @Z40LB61*/
         B     @RC01542                                            1549
@RF01542 DS    0H                                                  1549
PGSTATUS DS    0H                                                  1550
*                     MATCHED=OFF;  /*                       @Z40LB61*/
         NI    MATCHED,B'01111111'                                 1550
*                     IF MVPINACT(MVVP#)=ON THEN                   1551
         LH    @15,MVVP#                                           1551
         SLA   @15,2                                               1551
         L     @01,MVENTPTR                                        1551
         ALR   @01,@15                                             1551
         TM    MVPINACT-4(@01),B'10000000'                         1551
         BNO   @RF01551                                            1551
*                       IF RPMINACT(WORKRP)=OFF THEN               1552
         LH    @15,WORKRP                                          1552
         SLA   @15,2                                               1552
         L     @01,RPMPTR                                          1552
         ALR   @01,@15                                             1552
         AL    @01,@CF01761                                        1552
         TM    RPMINACT(@01),B'01000000'                           1552
         BNZ   @RF01552                                            1552
*                         IPASFLD=ON;/*                      @Z40LB61*/
         L     @15,@PC00001+4                                      1553
         L     @01,MARGPTR(,@15)                                   1553
         OI    IPASFLD(@01),B'00001000'                            1553
*                       ELSE                                       1554
*                         MATCHED=ON;/*                      @Z40LB61*/
         B     @RC01552                                            1554
@RF01552 OI    MATCHED,B'10000000'                                 1554
*                     ELSE                                         1555
*                       IF MVBNDCNT(MVVP#)>0 THEN                  1555
         B     @RC01551                                            1555
@RF01551 LH    @15,MVVP#                                           1555
         SLA   @15,2                                               1555
         L     @01,MVENTPTR                                        1555
         SLR   @14,@14                                             1555
         IC    @14,MVBNDCNT-4(@15,@01)                             1555
         CH    @14,@CH00119                                        1555
         BNH   @RF01555                                            1555
*                         IF RPMBND(WORKRP)=OFF THEN               1556
         LH    @15,WORKRP                                          1556
         SLA   @15,2                                               1556
         L     @01,RPMPTR                                          1556
         ALR   @01,@15                                             1556
         AL    @01,@CF01761                                        1556
         TM    RPMBND(@01),B'00100000'                             1556
         BNZ   @RF01556                                            1556
*                           BPASFLD=ON;/*                    @Z40LB61*/
         L     @15,@PC00001+4                                      1557
         L     @01,MARGPTR(,@15)                                   1557
         OI    BPASFLD(@01),B'00001000'                            1557
*                         ELSE                                     1558
*                           MATCHED=ON;/*                    @Z40LB61*/
         B     @RC01556                                            1558
@RF01556 OI    MATCHED,B'10000000'                                 1558
*                       ELSE                                       1559
*                         IF RPMACT(WORKRP)=OFF THEN               1559
         B     @RC01555                                            1559
@RF01555 LH    @15,WORKRP                                          1559
         SLA   @15,2                                               1559
         L     @01,RPMPTR                                          1559
         ALR   @01,@15                                             1559
         AL    @01,@CF01761                                        1559
         TM    RPMACT(@01),B'10000000'                             1559
         BNZ   @RF01559                                            1559
*                           APASFLD=ON;/*                    @Z40LB61*/
         L     @15,@PC00001+4                                      1560
         L     @01,MARGPTR(,@15)                                   1560
         OI    APASFLD(@01),B'00010000'                            1560
*                         ELSE                                     1561
*                           MATCHED=ON;/*                    @Z40LB61*/
         B     @RC01559                                            1561
@RF01559 OI    MATCHED,B'10000000'                                 1561
*                     IF MATCHED=OFF THEN                          1562
@RC01559 DS    0H                                                  1562
@RC01555 DS    0H                                                  1562
@RC01551 TM    MATCHED,B'10000000'                                 1562
         BNZ   @RF01562                                            1562
*                       DO;         /*                       @Z40LB61*/
*                         FLDCHAR(1)=STATNO;/*               @Z40LB61*/
         L     @15,@PC00001+4                                      1564
         L     @14,MARGPTR(,@15)                                   1564
         MVI   FLDCHAR+3(@14),C' '                                 1564
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1564
         MVC   FLDCHAR(3,@14),@CC01345                             1564
*                         FLDCHAR(2)=STATYES;/*              @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1565
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1565
         MVC   FLDCHAR+12(3,@14),@CC01343                          1565
*                         CALL IDCCH04(GDTTBL,CDALIST);/*    @Z40LB61*/
         L     @14,@PC00001                                        1566
         ST    @14,@AL00001                                        1566
         ST    @15,@AL00001+4                                      1566
         L     @15,@CV01495                                        1566
         LA    @01,@AL00001                                        1566
         BALR  @14,@15                                             1566
*                       END;        /*                       @Z40LB61*/
*                   END PGSTATUS;   /*                       @Z40LB61*/
*                                                                  1568
@RF01562 DS    0H                                                  1569
*               /*****************************************************/
*               /*                                                   */
*               /* RESET 'IDCCH04' OPTION FLAGS              @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1569
*               MSGTYPE=''B;        /*                       @Z40LB61*/
@RC01542 DS    0H                                                  1569
@RC01533 L     @15,@PC00001+4                                      1569
         L     @14,MARGPTR(,@15)                                   1569
         XC    MSGTYPE(4,@14),MSGTYPE(@14)                         1569
*               TBLTYPE(1)=''B;     /*                       @Z40LB61*/
         XC    TBLTYPE(4,@14),TBLTYPE(@14)                         1570
*               TBLTYPE(2)=''B;     /*                       @Z40LB61*/
*                                                                  1571
         XC    TBLTYPE+4(4,@14),TBLTYPE+4(@14)                     1571
*               /*****************************************************/
*               /*                                                   */
*               /* IF SA CHECKING WAS REQUESTED, THE MVT IS  @Z40LB61*/
*               /* FOR A MOUNTED VOLUME, THE VIRTUAL PAGE    @Z40LB61*/
*               /* IS NOT AN INACTIVE PAGE, AND THE MVT      @Z40LB61*/
*               /* VP ENTRY SHOWS THAT THERE ARE SOME VALID  @Z40LB61*/
*               /* CYLINDERS ALLOCATED, THEN COMPARE PAGE    @Z40LB61*/
*               /* DATA WITH THE PAGE STATUS TABLE (PST)     @Z40LB61*/
*               /* FOR EACH VALID SA FOR THIS MVT ENTRY.     @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1572
*               IF SACHK=ON&MVMNTVOL=ON&MVPINACT(MVVP#)=OFF&MVCYLMAP(
*                   MVVP#)^=0 THEN                                 1572
         TM    SACHK(@15),B'01000000'                              1572
         BNO   @RF01572                                            1572
         L     @15,MVENTPTR                                        1572
         TM    MVMNTVOL(@15),B'10000000'                           1572
         BNO   @RF01572                                            1572
         LH    @14,MVVP#                                           1572
         SLA   @14,2                                               1572
         ST    @14,@TF00001                                        1572
         ALR   @14,@15                                             1572
         TM    MVPINACT-4(@14),B'10000000'                         1572
         BNZ   @RF01572                                            1572
         L     @14,@TF00001                                        1572
         SLR   @05,@05                                             1572
         IC    @05,MVCYLMAP-4(@14,@15)                             1572
         CH    @05,@CH00119                                        1572
         BE    @RF01572                                            1572
*PSTCHK:                                                           1573
*                 DO MVPATH#=1 TO SASSDG;/*                  @Z40LB61*/
PSTCHK   LA    @15,1                                               1573
         STH   @15,MVPATH#                                         1573
@DL01573 DS    0H                                                  1574
*                   MVSA#=MVSA(MVPATH#)&MASK15;/*            @Z40LB61*/
         L     @14,MVENTPTR                                        1574
         SLA   @15,3                                               1574
         SLR   @05,@05                                             1574
         IC    @05,MVSA-8(@15,@14)                                 1574
         SLR   @04,@04                                             1574
         IC    @04,MASK15                                          1574
         NR    @05,@04                                             1574
         STH   @05,MVSA#                                           1574
*                   SA#=MVSA#+1;    /*                       @Z40LB61*/
         LA    @04,1                                               1575
         ALR   @05,@04                                             1575
         STH   @05,SA#                                             1575
*                   WORK3333=MV3333/SHIFT3+1;/*              @Z40LB61*/
*                                                                  1576
         SLR   @03,@03                                             1576
         IC    @03,MV3333(,@14)                                    1576
         SRL   @03,3                                               1576
         ALR   @03,@04                                             1576
         STC   @03,WORK3333                                        1576
*                   /*************************************************/
*                   /*                                               */
*                   /* FOR A VALID SA WITH A NON-ZERO VVA    @ZA13059*/
*                   /* IN THE PST, CHECK OFF THE PST         @ZA13059*/
*                   /* ENTRY FOR THE CURRENT REAL PAGE#      @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1577
*                   IF MVVLDSA(MVPATH#)=ON&IPSTPTR(SA#)^=NULLPTR&/*
*                                                            @ZA13059*/
*                       IPSTPTR(SA#)^=DUMMYPTR&/*            @ZA27324*/
*                       IPSTVVA(WORK3333,DEV#,WORKRP)^=0/*   @ZA13059*/
*                     THEN          /*                       @ZA13059*/
         ALR   @14,@15                                             1577
         TM    MVVLDSA-8(@14),B'10000000'                          1577
         BNO   @RF01577                                            1577
         SLR   @04,@04                                             1577
         SLA   @05,2                                               1577
         L     @02,@PC00001+4                                      1577
         L     @05,IPSTPTR-4(@05,@02)                              1577
         CR    @05,@04                                             1577
         BE    @RF01577                                            1577
         C     @05,DUMMYPTR                                        1577
         BE    @RF01577                                            1577
         SLA   @03,3                                               1577
         AH    @03,DEV#                                            1577
         MH    @03,@CH00684                                        1577
         AH    @03,WORKRP                                          1577
         ALR   @03,@03                                             1577
         AL    @05,@CF01768                                        1577
         SLR   @02,@02                                             1577
         IC    @02,IPSTVVA(@03,@05)                                1577
         CR    @04,@02                                             1577
         BE    @RF01577                                            1577
*MVTPSTM:                                                          1578
*                     DO;           /*                       @Z40LB61*/
MVTPSTM  DS    0H                                                  1579
*                       PSTCHKFF(WORK3333,DEV#,BYTE#)=PSTCHKFF(WORK3333
*                           ,DEV#,BYTE#)|BITMASK(BIT#);/*    @Z40LB61*/
*                                                                  1579
         LH    @15,DEV#                                            1579
         SLR   @14,@14                                             1579
         IC    @14,WORK3333                                        1579
         SLA   @14,3                                               1579
         ALR   @14,@15                                             1579
         LR    @05,@14                                             1579
         MH    @05,@CH00769                                        1579
         L     @04,@PC00001+4                                      1579
         L     @03,EARGPTR(,@04)                                   1579
         AH    @05,BYTE#(,@03)                                     1579
         LH    @02,SA#                                             1579
         SLA   @02,2                                               1579
         L     @01,PSTCOPTR-4(@02,@04)                             1579
         ALR   @01,@05                                             1579
         AL    @01,@CF01767                                        1579
         LH    @03,BIT#(,@03)                                      1579
         LA    @05,BITMASK-1(@03)                                  1579
         OC    PSTCHKFF(1,@01),0(@05)                              1579
*                       /*********************************************/
*                       /*                                           */
*                       /* DO COMMON SET-UP FOR POSSIBLE     @Z40LB61*/
*                       /* ERROR MESSAGES                    @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1580
*                       PSTTBL(1)=ON;/*                      @Z40LB61*/
         L     @03,MARGPTR(,@04)                                   1580
         OI    PSTTBL(@03),B'10000000'                             1580
*                       MVTTBL(2)=ON;/*                      @Z40LB61*/
         OI    MVTTBL+4(@03),B'10000000'                           1581
*                       INCNMSG=ON; /*                       @Z40LB61*/
         OI    INCNMSG(@03),B'10000000'                            1582
*                       SAINDEX(1)=MVSA#;/*                  @Z40LB61*/
         MVC   SAINDEX(1,@03),MVSA#+1                              1583
*                       LUAINDEX(1)=DEV#+MV3333-1;/*         @Z40LB61*/
         L     @05,MVENTPTR                                        1584
         SLR   @01,@01                                             1584
         IC    @01,MV3333(,@05)                                    1584
         ALR   @15,@01                                             1584
         BCTR  @15,0                                               1584
         STC   @15,LUAINDEX(,@03)                                  1584
*                       RPINDEX(1)=WORKRP-1;/*               @Z40LB61*/
         LH    @15,WORKRP                                          1585
         LR    @01,@15                                             1585
         BCTR  @01,0                                               1585
         STC   @01,RPINDEX(,@03)                                   1585
*                       MSGNRSET=ON;/*                       @Z40LB61*/
         OI    MSGNRSET(@03),B'00000001'                           1586
*                       TBLNRSET(1)=ON;/*                    @Z40LB61*/
         OI    TBLNRSET(@03),B'00000001'                           1587
*                       TBLNRSET(2)=ON;/*                    @Z40LB61*/
*                                                                  1588
         OI    TBLNRSET+4(@03),B'00000001'                         1588
*                       /*********************************************/
*                       /*                                           */
*                       /* THE VVA'S SHOULD MATCH BETWEEN    @Z40LB61*/
*                       /* MVT AND PST FOR ACTIVE SA'S.      @Z40LB61*/
*                       /* IF NOT, PRINT AN ERROR MESSAGE.   @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1589
*                       IF ACTIVSA(MVPATH#)=ON&IPSTVVA(WORK3333,DEV#,
*                           WORKRP)^=MVVVA(MVPATH#) THEN           1589
         LH    @01,MVPATH#                                         1589
         LA    @15,ACTIVSA-1(@01)                                  1589
         TM    0(@15),B'10000000'                                  1589
         BNO   @RF01589                                            1589
         LH    @15,WORKRP                                          1589
         MH    @14,@CH00684                                        1589
         ALR   @14,@15                                             1589
         ALR   @14,@14                                             1589
         L     @15,IPSTPTR-4(@02,@04)                              1589
         AL    @15,@CF01768                                        1589
         SLR   @02,@02                                             1589
         IC    @02,IPSTVVA(@14,@15)                                1589
         SLA   @01,3                                               1589
         SLR   @15,@15                                             1589
         IC    @15,MVVVA-8(@01,@05)                                1589
         CR    @02,@15                                             1589
         BE    @RF01589                                            1589
*                         DO;       /*                       @Z40LB61*/
*                           VVAFLD=ON;/*                     @Z40LB61*/
         OI    VVAFLD(@03),B'01000000'                             1591
*                           FLDNUM(1)=IPSTVVA(WORK3333,DEV#,WORKRP);
         ST    @02,FLDNUM(,@03)                                    1592
*                                   /*                       @Z40LB61*/
*                           FLDNUM(2)=MVVVA(MVPATH#);/*      @Z40LB61*/
         ST    @15,FLDNUM+12(,@03)                                 1593
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @Z40LB61*/
         L     @05,@PC00001                                        1594
         ST    @05,@AL00001                                        1594
         ST    @04,@AL00001+4                                      1594
         L     @15,@CV01495                                        1594
         LA    @01,@AL00001                                        1594
         BALR  @14,@15                                             1594
*                         END;      /*                       @Z40LB61*/
*                                                                  1595
*                       /*********************************************/
*                       /*                                           */
*                       /* CHECK FOR MATCHING VIRTUAL PAGE#. @Z40LB61*/
*                       /* IF INCONSISTENT, PRINT ERROR MSG  @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1596
*                       IF IPSTVP(WORK3333,DEV#,WORKRP)^=MVVP#-1 THEN
@RF01589 SLR   @15,@15                                             1596
         IC    @15,WORK3333                                        1596
         SLA   @15,3                                               1596
         AH    @15,DEV#                                            1596
         MH    @15,@CH00684                                        1596
         AH    @15,WORKRP                                          1596
         ALR   @15,@15                                             1596
         LH    @14,SA#                                             1596
         SLA   @14,2                                               1596
         L     @05,@PC00001+4                                      1596
         L     @01,IPSTPTR-4(@14,@05)                              1596
         AL    @01,@CF01769                                        1596
         SLR   @14,@14                                             1596
         IC    @14,IPSTVP-1(@15,@01)                               1596
         LH    @15,MVVP#                                           1596
         BCTR  @15,0                                               1596
         CR    @14,@15                                             1596
         BE    @RF01596                                            1596
*                         DO;       /*                       @Z40LB61*/
*                           VPFLD=ON;/*                      @Z40LB61*/
         L     @04,MARGPTR(,@05)                                   1598
         OI    VPFLD(@04),B'00100000'                              1598
*                           FLDNUM(1)=IPSTVP(WORK3333,DEV#,WORKRP);/*
*                                                            @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    1599
*                           FLDNUM(2)=MVVP#-1;/*             @ZA13477*/
         ST    @15,FLDNUM+12(,@04)                                 1600
*                           CALL IDCCH04(GDTTBL,CDALIST);/*  @Z40LB61*/
         L     @04,@PC00001                                        1601
         ST    @04,@AL00001                                        1601
         ST    @05,@AL00001+4                                      1601
         L     @15,@CV01495                                        1601
         LA    @01,@AL00001                                        1601
         BALR  @14,@15                                             1601
*                         END;      /*                       @Z40LB61*/
*                     END MVTPSTM;  /*                       @Z40LB61*/
*                                                                  1603
@RF01596 DS    0H                                                  1604
*                   /*************************************************/
*                   /*                                               */
*                   /* RESET 'IDCCH04' OPTION FLAGS          @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1604
*                   MSGTYPE=''B;    /*                       @Z40LB61*/
@RF01577 L     @15,@PC00001+4                                      1604
         L     @15,MARGPTR(,@15)                                   1604
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1604
*                   TBLTYPE(1)=''B; /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1605
*                   TBLTYPE(2)=''B; /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1606
*                 END PSTCHK;       /*                       @Z40LB61*/
         LA    @15,1                                               1607
         AH    @15,MVPATH#                                         1607
         STH   @15,MVPATH#                                         1607
         CH    @15,@CH00157                                        1607
         BNH   @DL01573                                            1607
*             END GOODPAGE;         /*                       @Z40LB61*/
*                                                                  1608
@RF01572 DS    0H                                                  1609
*         /***********************************************************/
*         /*                                                         */
*         /* RESET 'IDCCH04' OPTION FLAGS                    @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1609
*         MSGTYPE=''B;              /*                       @Z40LB61*/
@RC01485 DS    0H                                                  1609
@RF01484 L     @15,@PC00001+4                                      1609
         L     @15,MARGPTR(,@15)                                   1609
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1609
*         TBLTYPE(1)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1610
*         TBLTYPE(2)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1611
*       END VPLOOP2;                /*                       @Z40LB61*/
         LA    @15,1                                               1612
         AH    @15,MVVP#                                           1612
         STH   @15,MVVP#                                           1612
         CH    @15,@CH00868                                        1612
         BNH   @DL01477                                            1612
*   END DEVLOOP1;                   /*                       @Z40LB61*/
@RF01476 LA    @15,1                                               1613
         AH    @15,DEV#                                            1613
         STH   @15,DEV#                                            1613
         CH    @15,@CH00183                                        1613
         BNH   @DL01474                                            1613
*   END MVTRPM;                     /*                       @Z40LB61*/
         B     @EL00009                                            1614
*                                                                  1615
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - INACTIVE                                @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES MVT DATA RELATED TO     @Z40LB61*/
*/*            INACTIVE ALLOCATED PAGES WITH ASSOCIATED      @Z40LB61*/
*/*            DATA IN OTHER MSC TABLES.                     @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) MSC MOUNTED VOLUME TABLE                      @Z40LB61*/
*/*        (2) INACTIVE PAGE COUNT FOR THIS VOLUME           @Z40LB61*/
*/*        (3) MSC SDG DEMOUNTED VOLUME BLOCK                @Z40LB61*/
*/*        (4) MSC SDG LRU PAGES BLOCK                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*        (3) DVB CHECK-OFF TABLE                           @Z40LB61*/
*/*        (4) LPB CHECK-OFF TABLE                           @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1615
*INACTIVE:                                                         1615
*   PROCEDURE;                      /*                       @Z40LB61*/
INACTIVE STM   @14,@12,@SA00010                                    1615
*   OLDERID2=NEWERID2;                                             1616
         L     @15,@PC00001                                        1616
         L     @14,GDTTR2(,@15)                                    1616
         MVC   @TS00001(95),NEWERID2(@14)                          1616
         MVC   OLDERID2(95,@14),@TS00001                           1616
*   NEWID2='CH2S';                  /*                       @Z40LB61*/
*                                                                  1617
         MVC   NEWID2(4,@14),@CC01651                              1617
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPARE THE SUM OF INACTIVE PAGES ACCUMULATED FROM    @Z40LB61*/
*   /* MVT VIRTUAL PAGE ENTRIES TO THE MVT INACTIVE PAGE     @Z40LB61*/
*   /* TOTAL FIELD. IF INCONSISTENT, PRINT AN ERROR MSG.     @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1618
*   IF INACTCNT^=MVPINCNT THEN                                     1618
         LH    @14,INACTCNT                                        1618
         L     @01,MVENTPTR                                        1618
         SLR   @05,@05                                             1618
         IC    @05,MVPINCNT(,@01)                                  1618
         CR    @14,@05                                             1618
         BE    @RF01618                                            1618
*     DO;                           /*                       @Z40LB61*/
*       SUMSMSG=ON;                 /*                       @Z40LB61*/
         L     @04,@PC00001+4                                      1620
         L     @03,MARGPTR(,@04)                                   1620
         OI    SUMSMSG(@03),B'00100000'                            1620
*       MVTTBL(1)=ON;               /*                       @Z40LB61*/
         OI    MVTTBL(@03),B'10000000'                             1621
*       MVTTBL(2)=ON;               /*                       @Z40LB61*/
         OI    MVTTBL+4(@03),B'10000000'                           1622
*       IPFLD=ON;                   /*                       @Z40LB61*/
         OI    IPFLD(@03),B'00000001'                              1623
*       FLDNUM(1)=INACTCNT;         /*                       @Z40LB61*/
         ST    @14,FLDNUM(,@03)                                    1624
*       FLDNUM(2)=MVPINCNT;         /*                       @Z40LB61*/
         ST    @05,FLDNUM+12(,@03)                                 1625
*       CALL IDCCH04(GDTTBL,CDALIST);/*                      @Z40LB61*/
         ST    @15,@AL00001                                        1626
         ST    @04,@AL00001+4                                      1626
         L     @15,@CV01495                                        1626
         LA    @01,@AL00001                                        1626
         BALR  @14,@15                                             1626
*     END;                          /*                       @Z40LB61*/
*                                                                  1627
*   /*****************************************************************/
*   /*                                                               */
*   /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES          @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1628
*   FLDNUM(1)=SAVEREC#-1;           /*                       @Z40LB61*/
*                                                                  1628
@RF01618 L     @15,@PC00001+4                                      1628
         L     @01,MARGPTR(,@15)                                   1628
         LH    @00,SAVEREC#                                        1628
         BCTR  @00,0                                               1628
         ST    @00,FLDNUM(,@01)                                    1628
*   /*****************************************************************/
*   /*                                                               */
*   /* PREPARE TO ACCESS TABLES, CHECKING WHETHER THE        @Z40LB61*/
*   /* CURRENT MVT ENTRY HAS ANY INACTIVE PAGES.             @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1629
*   SDG#=MVSDG+1;                   /*                       @Z40LB61*/
         L     @14,MVENTPTR                                        1629
         SLR   @05,@05                                             1629
         IC    @05,MVSDG(,@14)                                     1629
         LA    @04,1                                               1629
         ALR   @04,@05                                             1629
         STH   @04,SDG#                                            1629
*   SDGNUM=MVSDG;                   /*                       @Z40LB61*/
         L     @01,EARGPTR(,@15)                                   1630
         STH   @05,SDGNUM(,@01)                                    1630
*   IF MVMNTVOL=ON THEN             /*                       @ZA13049*/
*                                                                  1631
         TM    MVMNTVOL(@14),B'10000000'                           1631
         BNO   @RF01631                                            1631
*     /***************************************************************/
*     /*                                                             */
*     /* A MOUNTED VOLUME WITH INACTIVE PAGES SHOULD BE      @Z40LB61*/
*     /* REFERENCED IN THE LRU PAGES BLOCK, SO OBTAIN        @Z40LB61*/
*     /* THE LPB FOR THIS VOLUME'S SDG.                      @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1632
*LPBCHK:                                                           1632
*     DO;                           /*                       @Z40LB61*/
LPBCHK   DS    0H                                                  1633
*       TABLEID=SDGTBLID;           /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1633
         L     @14,EARGPTR(,@15)                                   1633
         MVC   TABLEID(1,@14),SDGTBLID                             1633
*       LPBFLAG=ON;                 /*                       @Z40LB61*/
         OI    LPBFLAG(@14),B'00010000'                            1634
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB61*/
         L     @14,@PC00001                                        1635
         ST    @14,@AL00001                                        1635
         ST    @15,@AL00001+4                                      1635
         L     @15,@CV01494                                        1635
         LA    @01,@AL00001                                        1635
         BALR  @14,@15                                             1635
*       IF GETRC^=0 THEN                                           1636
         L     @15,@PC00001+4                                      1636
         L     @01,EARGPTR(,@15)                                   1636
         ICM   @00,3,GETRC(@01)                                    1636
         BZ    @RF01636                                            1636
*         DO;                       /*                       @Z40LB61*/
*           LASTCOND=LASTCC12;      /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      1638
         MVC   LASTCOND(2,@15),@CH00567                            1638
*           RETURN;                 /*                       @Z40LB61*/
@EL00010 DS    0H                                                  1639
@EF00010 DS    0H                                                  1639
@ER00010 LM    @14,@12,@SA00010                                    1639
         BR    @14                                                 1639
*         END;                      /*                       @Z40LB61*/
*       LPBPTR=TBLADDR;             /*                       @Z40LB61*/
*                                                                  1641
@RF01636 L     @15,@PC00001+4                                      1641
         L     @01,EARGPTR(,@15)                                   1641
         MVC   LPBPTR(4),TBLADDR(@01)                              1641
*       /*************************************************************/
*       /*                                                           */
*       /* SEARCH EACH VALID ENTRY IN THE LPB FOR THE MVT    @Z40LB61*/
*       /* POINTER TO THE CURRENT MVT ENTRY                  @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1642
*       MATCHED=OFF;                /*                       @Z40LB61*/
         NI    MATCHED,B'01111111'                                 1642
*       DO ENTRY#=1 TO DVLPMAX WHILE(MATCHED=OFF&((ENTRY#*LENGTH(LPBMVT
*             )<=(LPBNEXT-4))|      /*                       @ZA16115*/
*             LPBNEXT=0));          /*                       @ZA16115*/
         LA    @15,1                                               1643
         STH   @15,ENTRY#                                          1643
@DL01643 TM    MATCHED,B'10000000'                                 1643
         BNZ   @DC01643                                            1643
         ALR   @15,@15                                             1643
         L     @14,LPBPTR                                          1643
         SLR   @05,@05                                             1643
         IC    @05,LPBNEXT(,@14)                                   1643
         SH    @05,@CH00046                                        1643
         CR    @15,@05                                             1643
         BNH   @DB01643                                            1643
         CLI   LPBNEXT(@14),0                                      1643
         BNE   @DC01643                                            1643
@DB01643 DS    0H                                                  1644
*         IF(SAVEREC#-1)=(LPBMVT(ENTRY#)&MASK8191) THEN            1644
*                                                                  1644
         LH    @15,SAVEREC#                                        1644
         BCTR  @15,0                                               1644
         LH    @14,ENTRY#                                          1644
         LR    @05,@14                                             1644
         ALR   @05,@05                                             1644
         SLR   @04,@04                                             1644
         ICM   @04,3,MASK8191                                      1644
         L     @01,LPBPTR                                          1644
         ALR   @01,@05                                             1644
         SLR   @05,@05                                             1644
         ICM   @05,3,LPBMVT-2(@01)                                 1644
         NR    @04,@05                                             1644
         CR    @15,@04                                             1644
         BNE   @RF01644                                            1644
*           /*********************************************************/
*           /*                                                       */
*           /* FOR A MATCHING MVT POINTER, CHECK-OFF THE     @Z40LB61*/
*           /* ENTRY AND NOTE THE MATCH                      @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1645
*           DO;                     /*                       @Z40LB61*/
*             BYTE#=(ENTRY#-1)/8+1; /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1646
         L     @05,EARGPTR(,@15)                                   1646
         LA    @04,1                                               1646
         BCTR  @14,0                                               1646
         LR    @00,@14                                             1646
         SRDA  @00,32                                              1646
         D     @00,@CF00183                                        1646
         ALR   @01,@04                                             1646
         STH   @01,BYTE#(,@05)                                     1646
*             BIT#=(ENTRY#-1)//8+1; /*                       @Z40LB61*/
         SRDA  @14,32                                              1647
         D     @14,@CF00183                                        1647
         ALR   @14,@04                                             1647
         STH   @14,BIT#(,@05)                                      1647
*             LPBCHKFF(SDG#,BYTE#)=LPBCHKFF(SDG#,BYTE#)|BITMASK(BIT#);
         LH    @15,SDG#                                            1648
         SLA   @15,4                                               1648
         ALR   @15,@01                                             1648
         L     @05,@PC00001+4                                      1648
         L     @01,LPBCOPTR(,@05)                                  1648
         ALR   @01,@15                                             1648
         AL    @01,@CF01770                                        1648
         LA    @15,BITMASK-1(@14)                                  1648
         OC    LPBCHKFF(1,@01),0(@15)                              1648
*                                   /*                       @Z40LB61*/
*             MATCHED=ON;           /*                       @Z40LB61*/
         OI    MATCHED,B'10000000'                                 1649
*           END;                    /*                       @Z40LB61*/
*       END;                        /*                       @Z40LB61*/
*                                                                  1651
@RF01644 LA    @15,1                                               1651
         AH    @15,ENTRY#                                          1651
         STH   @15,ENTRY#                                          1651
         CH    @15,@CH00753                                        1651
         BNH   @DL01643                                            1651
@DC01643 DS    0H                                                  1652
*       /*************************************************************/
*       /*                                                           */
*       /* IF NO MATCHING MVT POINTER WAS FOUND IN THE LPB,  @Z40LB61*/
*       /* FOR AN MVT ENTRY W/INACTIVE PAGES GREATER THAN 0  @ZA13049*/
*       /* PRINT AN ERROR MESSAGE.                           @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1652
*       IF MATCHED=OFF&MVPINCNT>0 THEN/*                     @ZA13049*/
         TM    MATCHED,B'10000000'                                 1652
         BNZ   @RF01652                                            1652
         L     @01,MVENTPTR                                        1652
         CLI   MVPINCNT(@01),0                                     1652
         BNH   @RF01652                                            1652
*         DO;                       /*                       @Z40LB61*/
*           MTCHMSG=ON;             /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1654
         L     @14,MARGPTR(,@15)                                   1654
         OI    MTCHMSG(@14),B'00010000'                            1654
*           MVTTBL(2)=ON;           /*                       @Z40LB61*/
         OI    MVTTBL+4(@14),B'10000000'                           1655
*           MVTPFLD=ON;             /*                       @Z40LB61*/
         OI    MVTPFLD(@14),B'00100000'                            1656
*           LPBTBL(1)=ON;           /*                       @Z40LB61*/
         OI    LPBTBL(@14),B'00000100'                             1657
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        1658
         ST    @14,@AL00001                                        1658
         ST    @15,@AL00001+4                                      1658
         L     @15,@CV01495                                        1658
         LA    @01,@AL00001                                        1658
         BALR  @14,@15                                             1658
*         END;                      /*                       @Z40LB61*/
*     END LPBCHK;                   /*                       @Z40LB61*/
*   ELSE                                                           1661
*                                                                  1661
*     /***************************************************************/
*     /*                                                             */
*     /* A DEMOUNTED VOLUME WITH INACTIVE PAGES,             @Z40LB61*/
*     /* SHOULD BE                                           @Z40LB61*/
*     /* REFERENCED IN THE DEMOUNTED VOLUME BLOCK (DVB)      @Z40LB61*/
*     /* SO OBTAIN THE DVB FOR THIS VOLUME'S SDG.            @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1661
*DVBCHK:                                                           1661
*     DO;                           /*                       @Z40LB61*/
         B     @RC01631                                            1661
@RF01631 DS    0H                                                  1661
DVBCHK   DS    0H                                                  1662
*       TABLEID=SDGTBLID;           /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1662
         L     @14,EARGPTR(,@15)                                   1662
         MVC   TABLEID(1,@14),SDGTBLID                             1662
*       DVBFLAG=ON;                 /*                       @Z40LB61*/
         OI    DVBFLAG(@14),B'00100000'                            1663
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB61*/
         L     @14,@PC00001                                        1664
         ST    @14,@AL00001                                        1664
         ST    @15,@AL00001+4                                      1664
         L     @15,@CV01494                                        1664
         LA    @01,@AL00001                                        1664
         BALR  @14,@15                                             1664
*       IF GETRC^=0 THEN                                           1665
         L     @15,@PC00001+4                                      1665
         L     @01,EARGPTR(,@15)                                   1665
         ICM   @00,3,GETRC(@01)                                    1665
         BZ    @RF01665                                            1665
*         DO;                       /*                       @Z40LB61*/
*           LASTCOND=LASTCC12;      /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      1667
         MVC   LASTCOND(2,@15),@CH00567                            1667
*           RETURN;                 /*                       @Z40LB61*/
         B     @EL00010                                            1668
*         END;                      /*                       @Z40LB61*/
*       DVBPTR=TBLADDR;             /*                       @Z40LB61*/
*                                                                  1670
@RF01665 L     @15,@PC00001+4                                      1670
         L     @01,EARGPTR(,@15)                                   1670
         MVC   DVBPTR(4),TBLADDR(@01)                              1670
*       /*************************************************************/
*       /*                                                           */
*       /* SEARCH EACH VALID ENTRY IN THE DVB FOR THE MVT    @Z40LB61*/
*       /* POINTER TO THE CURRENT MVT ENTRY                  @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1671
*       MATCHED=OFF;                /*                       @Z40LB61*/
         NI    MATCHED,B'01111111'                                 1671
*       DO ENTRY#=1 TO DVLPMAX WHILE(MATCHED=OFF&((ENTRY#*LENGTH(DVBMVT
*             )<=(DVBNEXT-4))       /*                       @ZA16115*/
*             |DVBNEXT=0));         /*                       @ZA16115*/
         LA    @15,1                                               1672
         STH   @15,ENTRY#                                          1672
@DL01672 TM    MATCHED,B'10000000'                                 1672
         BNZ   @DC01672                                            1672
         ALR   @15,@15                                             1672
         L     @14,DVBPTR                                          1672
         SLR   @05,@05                                             1672
         IC    @05,DVBNEXT(,@14)                                   1672
         SH    @05,@CH00046                                        1672
         CR    @15,@05                                             1672
         BNH   @DB01672                                            1672
         CLI   DVBNEXT(@14),0                                      1672
         BNE   @DC01672                                            1672
@DB01672 DS    0H                                                  1673
*         IF(SAVEREC#-1)=(DVBMVT(ENTRY#)&MASK8191) THEN            1673
*                                                                  1673
         LH    @15,SAVEREC#                                        1673
         BCTR  @15,0                                               1673
         LH    @14,ENTRY#                                          1673
         LR    @05,@14                                             1673
         ALR   @05,@05                                             1673
         SLR   @04,@04                                             1673
         ICM   @04,3,MASK8191                                      1673
         L     @01,DVBPTR                                          1673
         ALR   @01,@05                                             1673
         SLR   @05,@05                                             1673
         ICM   @05,3,DVBMVT-2(@01)                                 1673
         NR    @04,@05                                             1673
         CR    @15,@04                                             1673
         BNE   @RF01673                                            1673
*           /*********************************************************/
*           /*                                                       */
*           /* FOR A MATCHING MVT POINTER, CHECK-OFF THE     @Z40LB61*/
*           /* ENTRY AND NOTE THE MATCH                      @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1674
*           DO;                     /*                       @Z40LB61*/
*             BYTE#=(ENTRY#-1)/8+1; /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1675
         L     @05,EARGPTR(,@15)                                   1675
         LA    @04,1                                               1675
         BCTR  @14,0                                               1675
         LR    @00,@14                                             1675
         SRDA  @00,32                                              1675
         D     @00,@CF00183                                        1675
         ALR   @01,@04                                             1675
         STH   @01,BYTE#(,@05)                                     1675
*             BIT#=(ENTRY#-1)//8+1; /*                       @Z40LB61*/
         SRDA  @14,32                                              1676
         D     @14,@CF00183                                        1676
         ALR   @14,@04                                             1676
         STH   @14,BIT#(,@05)                                      1676
*             DVBCHKFF(SDG#,BYTE#)=DVBCHKFF(SDG#,BYTE#)|BITMASK(BIT#);
         LH    @15,SDG#                                            1677
         SLA   @15,4                                               1677
         ALR   @15,@01                                             1677
         L     @05,@PC00001+4                                      1677
         L     @01,DVBCOPTR(,@05)                                  1677
         ALR   @01,@15                                             1677
         AL    @01,@CF01770                                        1677
         LA    @15,BITMASK-1(@14)                                  1677
         OC    DVBCHKFF(1,@01),0(@15)                              1677
*                                   /*                       @Z40LB61*/
*             MATCHED=ON;           /*                       @Z40LB61*/
         OI    MATCHED,B'10000000'                                 1678
*           END;                    /*                       @Z40LB61*/
*       END;                        /*                       @Z40LB61*/
*                                                                  1680
@RF01673 LA    @15,1                                               1680
         AH    @15,ENTRY#                                          1680
         STH   @15,ENTRY#                                          1680
         CH    @15,@CH00753                                        1680
         BNH   @DL01672                                            1680
@DC01672 DS    0H                                                  1681
*       /*************************************************************/
*       /*                                                           */
*       /* IF NO MATCHING MVT POINTER WAS FOUND IN THE DVB,  @Z40LB61*/
*       /* FOR AN MVT ENTRY W/INACTIVE PAGES GREATER THAN 0  @ZA13049*/
*       /* PRINT AN ERROR MESSAGE.                           @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1681
*       IF MATCHED=OFF&MVPINCNT>0 THEN/*                     @ZA13049*/
         TM    MATCHED,B'10000000'                                 1681
         BNZ   @RF01681                                            1681
         L     @01,MVENTPTR                                        1681
         CLI   MVPINCNT(@01),0                                     1681
         BNH   @RF01681                                            1681
*         DO;                       /*                       @Z40LB61*/
*           MTCHMSG=ON;             /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1683
         L     @14,MARGPTR(,@15)                                   1683
         OI    MTCHMSG(@14),B'00010000'                            1683
*           MVTTBL(2)=ON;           /*                       @Z40LB61*/
         OI    MVTTBL+4(@14),B'10000000'                           1684
*           MVTPFLD=ON;             /*                       @Z40LB61*/
         OI    MVTPFLD(@14),B'00100000'                            1685
*           DVBTBL(1)=ON;           /*                       @Z40LB61*/
         OI    DVBTBL(@14),B'00001000'                             1686
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        1687
         ST    @14,@AL00001                                        1687
         ST    @15,@AL00001+4                                      1687
         L     @15,@CV01495                                        1687
         LA    @01,@AL00001                                        1687
         BALR  @14,@15                                             1687
*         END;                      /*                       @Z40LB61*/
*     END DVBCHK;                   /*                       @Z40LB61*/
*   END INACTIVE;                   /*                       @Z40LB61*/
         B     @EL00010                                            1690
*                                                                  1691
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - SCANSUMS                                @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE OBTAINS AND COMPARES TOTALS      @Z40LB61*/
*/*            RELATED TO ALL VOLUMES COLLECTIVELY WITH      @Z40LB61*/
*/*            SUM TOTALS ACCUMULATED DURING PROCESSING OF   @Z40LB61*/
*/*            ALL INDIVIDUAL VOLUMES.                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) COUNTS OF MOUNTED VOLUMES PER SDG             @Z40LB61*/
*/*        (2) MSC MOUNT EQUALIZATION TABLE                  @Z40LB61*/
*/*        (3) MSC SDG PAGE AVAILABILITY BLOCKS              @Z40LB61*/
*/*        (4) MSC SDG REAL PAGE MAPS                        @Z40LB61*/
*/*        (5) SDG RPM CHECK-OFF TABLE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*        (3) REAL PAGE MAP PAGE STATUS SUM TOTALS          @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1691
*SCANSUMS:                                                         1691
*   PROCEDURE;                      /*                       @Z40LB61*/
SCANSUMS STM   @14,@12,@SA00011                                    1691
*   OLDERID2=NEWERID2;                                             1692
         L     @15,@PC00001                                        1692
         L     @15,GDTTR2(,@15)                                    1692
         MVC   @TS00001(95),NEWERID2(@15)                          1692
         MVC   OLDERID2(95,@15),@TS00001                           1692
*   NEWID2='CH2T';                  /*                       @Z40LB61*/
*                                                                  1693
         MVC   NEWID2(4,@15),@CC01659                              1693
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM VARIOUS CONSISTENCY CHECKING FOR EACH         @Z40LB61*/
*   /* STAGING DRIVE GROUP                                   @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1694
*   MERPTR=IMERPTR;                 /*                       @Z40LB64*/
         L     @15,@PC00001+4                                      1694
         MVC   MERPTR(4),IMERPTR(@15)                              1694
*SDGLOOP:                                                          1695
*   DO SDG#=1 TO SDGMAX;            /*                       @Z40LB61*/
*                                                                  1695
SDGLOOP  LA    @15,1                                               1695
         STH   @15,SDG#                                            1695
@DL01695 DS    0H                                                  1696
*     /***************************************************************/
*     /*                                                             */
*     /* IF MSC VS. MSC CHECKING WAS REQUESTED,              @Z40LB61*/
*     /* CHECK THAT THE SUM OF MOUNTED VOLUMES ACCUMULATED   @Z40LB61*/
*     /* FROM SCANNING THE MVT MATCHES THE MOUNTED TOTAL     @Z40LB61*/
*     /* FOR THE SDG IN THE MOUNT EQUALIZATION TABLE. IF     @Z40LB61*/
*     /* INCONSISTENT, PRINT AN ERROR MESSAGE.               @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1696
*     IF MSCCHK=ON&MEMNTCNT(SDG#)^=MNTCOUNT(SDG#) THEN             1696
         L     @14,@PC00001+4                                      1696
         TM    MSCCHK(@14),B'10000000'                             1696
         BNO   @RF01696                                            1696
         LR    @05,@15                                             1696
         SLA   @05,2                                               1696
         L     @01,MERPTR                                          1696
         ALR   @01,@05                                             1696
         AL    @01,@CF01760                                        1696
         SLR   @05,@05                                             1696
         ICM   @05,3,MEMNTCNT-2(@01)                               1696
         LR    @04,@15                                             1696
         ALR   @04,@04                                             1696
         LH    @04,MNTCOUNT-2(@04)                                 1696
         CR    @05,@04                                             1696
         BE    @RF01696                                            1696
*       DO;                         /*                       @Z40LB61*/
*         SUMSMSG=ON;               /*                       @Z40LB61*/
         L     @03,MARGPTR(,@14)                                   1698
         OI    SUMSMSG(@03),B'00100000'                            1698
*         MVTTBL(1)=ON;             /*                       @Z40LB61*/
         OI    MVTTBL(@03),B'10000000'                             1699
*         METBL(2)=ON;              /*                       @Z40LB61*/
         OI    METBL+4(@03),B'00010000'                            1700
*         MVFLD=ON;                 /*                       @Z40LB61*/
         OI    MVFLD(@03),B'00100000'                              1701
*         FLDNUM(1)=MNTCOUNT(SDG#); /*                       @Z40LB61*/
         ST    @04,FLDNUM(,@03)                                    1702
*         FLDNUM(2)=MEMNTCNT(SDG#); /*                       @Z40LB61*/
         ST    @05,FLDNUM+12(,@03)                                 1703
*         SDGINDEX(2)=SDG#-1;       /*                       @Z40LB61*/
         BCTR  @15,0                                               1704
         STC   @15,SDGINDEX+24(,@03)                               1704
*         CALL IDCCH04(GDTTBL,CDALIST);/*                    @Z40LB61*/
         L     @15,@PC00001                                        1705
         ST    @15,@AL00001                                        1705
         ST    @14,@AL00001+4                                      1705
         L     @15,@CV01495                                        1705
         LA    @01,@AL00001                                        1705
         BALR  @14,@15                                             1705
*       END;                        /*                       @Z40LB61*/
*                                                                  1706
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN THE PAGE AVAILABILITY BLOCK FOR THIS SDG     @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1707
*     TABLEID=SDGTBLID;             /*                       @Z40LB61*/
@RF01696 L     @15,@PC00001+4                                      1707
         L     @14,EARGPTR(,@15)                                   1707
         MVC   TABLEID(1,@14),SDGTBLID                             1707
*     PABFLAG=ON;                   /*                       @Z40LB61*/
         OI    PABFLAG(@14),B'01000000'                            1708
*     SDGNUM=SDG#-1;                /*                       @Z40LB61*/
         LH    @05,SDG#                                            1709
         BCTR  @05,0                                               1709
         STH   @05,SDGNUM(,@14)                                    1709
*     BUFFER2=ON;                   /*                       @Z40LB61*/
         OI    BUFFER2(@14),B'01000000'                            1710
*     CALL IDCCH03(GDTTBL,CDALIST); /*                       @Z40LB61*/
         L     @14,@PC00001                                        1711
         ST    @14,@AL00001                                        1711
         ST    @15,@AL00001+4                                      1711
         L     @15,@CV01494                                        1711
         LA    @01,@AL00001                                        1711
         BALR  @14,@15                                             1711
*     IF GETRC^=0 THEN                                             1712
         L     @15,@PC00001+4                                      1712
         L     @01,EARGPTR(,@15)                                   1712
         ICM   @00,3,GETRC(@01)                                    1712
         BZ    @RF01712                                            1712
*       DO;                         /*                       @Z40LB61*/
*         LASTCOND=LASTCC12;        /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      1714
         MVC   LASTCOND(2,@15),@CH00567                            1714
*         RETURN;                   /*                       @Z40LB61*/
@EL00011 DS    0H                                                  1715
@EF00011 DS    0H                                                  1715
@ER00011 LM    @14,@12,@SA00011                                    1715
         BR    @14                                                 1715
*       END;                        /*                       @Z40LB61*/
*     PABPTR=TBLADDR;               /*                       @Z40LB61*/
@RF01712 L     @15,@PC00001+4                                      1717
         L     @15,EARGPTR(,@15)                                   1717
         MVC   PABPTR(4),TBLADDR(@15)                              1717
*     SAVEID=ENTRYID;               /*                       @Z40LB61*/
*                                                                  1718
         MVC   SAVEID(12),ENTRYID(@15)                             1718
*     /***************************************************************/
*     /*                                                             */
*     /* PREPARE TO CHECK CONSISTENCY AND ACCUMULATE COUNTS  @Z40LB61*/
*     /* RELATED TO EACH DEVICE OF THE SDG.                  @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1719
*     FPTOTAL=0;                    /*                       @Z40LB61*/
         SLR   @15,@15                                             1719
         STH   @15,FPTOTAL                                         1719
*     APTOTAL=0;                    /*                       @Z40LB61*/
         STH   @15,APTOTAL                                         1720
*     IPTOTAL=0;                    /*                       @Z40LB61*/
         STH   @15,IPTOTAL                                         1721
*     BPTOTAL=0;                    /*                       @Z40LB61*/
         STH   @15,BPTOTAL                                         1722
*DEVLOOP2:                                                         1723
*     DO DEV#=1 TO DEVSSDG;         /*                       @Z40LB61*/
*                                                                  1723
DEVLOOP2 LA    @15,1                                               1723
         STH   @15,DEV#                                            1723
@DL01723 DS    0H                                                  1724
*       /*************************************************************/
*       /*                                                           */
*       /* INITIALIZE DEVICE COUNT VARIABLES                 @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1724
*       FPCOUNT(DEV#)=0;            /*                       @Z40LB61*/
         SLR   @14,@14                                             1724
         LR    @05,@15                                             1724
         ALR   @05,@05                                             1724
         STH   @14,FPCOUNT-2(@05)                                  1724
*       APCOUNT(DEV#)=0;            /*                       @Z40LB61*/
         STH   @14,APCOUNT-2(@05)                                  1725
*       IPCOUNT(DEV#)=0;            /*                       @Z40LB61*/
         STH   @14,IPCOUNT-2(@05)                                  1726
*       BPCOUNT(DEV#)=0;            /*                       @Z40LB61*/
*                                                                  1727
         STH   @14,BPCOUNT-2(@05)                                  1727
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE DEVICE EXISTS, OBTAIN THE REAL PAGE MAP    @Z40LB61*/
*       /* DESCRIBING ITS PAGES.                             @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1728
*       IF PABDEX(DEV#)=ON THEN                                    1728
         SLA   @15,2                                               1728
         L     @01,PABPTR                                          1728
         ALR   @01,@15                                             1728
         TM    PABDEX-4(@01),B'10000000'                           1728
         BNO   @RF01728                                            1728
*GOODDEV2:                                                         1729
*         DO;                       /*                       @Z40LB61*/
GOODDEV2 DS    0H                                                  1730
*           TABLEID=SDGTBLID;       /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1730
         L     @14,EARGPTR(,@15)                                   1730
         MVC   TABLEID(1,@14),SDGTBLID                             1730
*           RPMFLAG=ON;             /*                       @Z40LB61*/
         OI    RPMFLAG(@14),B'10000000'                            1731
*           SDGNUM=SDG#-1;          /*                       @Z40LB61*/
         LH    @05,SDG#                                            1732
         BCTR  @05,0                                               1732
         STH   @05,SDGNUM(,@14)                                    1732
*           DEVICEID=DEV#-1;        /*                       @Z40LB61*/
         LH    @05,DEV#                                            1733
         BCTR  @05,0                                               1733
         STH   @05,DEVICEID(,@14)                                  1733
*           CALL IDCCH03(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        1734
         ST    @14,@AL00001                                        1734
         ST    @15,@AL00001+4                                      1734
         L     @15,@CV01494                                        1734
         LA    @01,@AL00001                                        1734
         BALR  @14,@15                                             1734
*           IF GETRC^=0 THEN                                       1735
         L     @15,@PC00001+4                                      1735
         L     @01,EARGPTR(,@15)                                   1735
         ICM   @00,3,GETRC(@01)                                    1735
         BZ    @RF01735                                            1735
*             DO;                   /*                       @Z40LB61*/
*               LASTCOND=LASTCC12;  /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      1737
         MVC   LASTCOND(2,@15),@CH00567                            1737
*               RETURN;             /*                       @Z40LB61*/
         B     @EL00011                                            1738
*             END;                  /*                       @Z40LB61*/
*           RPMPTR=TBLADDR;         /*                       @Z40LB61*/
*                                                                  1740
@RF01735 L     @15,@PC00001+4                                      1740
         L     @01,EARGPTR(,@15)                                   1740
         MVC   RPMPTR(4),TBLADDR(@01)                              1740
*           /*********************************************************/
*           /*                                                       */
*           /* 'BUILD' A LOGICAL UNIT ADDRESS FROM DEVICE    @Z40LB61*/
*           /* NUMBER AND 3333 ADDRESS.                      @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1741
*           IF PAB3333(1)=ON THEN                                  1741
         L     @01,PABPTR                                          1741
         TM    PAB3333(@01),B'00010000'                            1741
         BNO   @RF01741                                            1741
*             LUA#=DEV#+DEVSSDG-1;  /*                       @Z40LB61*/
         LH    @15,DEV#                                            1742
         SH    @15,@CH01733                                        1742
         STH   @15,LUA#                                            1742
*           ELSE                                                   1743
*             LUA#=DEV#-1;          /*                       @Z40LB61*/
*                                                                  1743
         B     @RC01741                                            1743
@RF01741 LH    @15,DEV#                                            1743
         BCTR  @15,0                                               1743
         STH   @15,LUA#                                            1743
*           /*********************************************************/
*           /*                                                       */
*           /* CHECK EACH REAL PAGE ENTRY OF THE RPM. THE    @Z40LB61*/
*           /* SECOND HALF OF A 3330 MOD 11 HAS ONE FEWER    @Z40LB61*/
*           /* ALLOCATABLE PAGE THAN OTHER DEVICES.          @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1744
*           IF PAB2M11(DEV#)=ON THEN                               1744
@RC01741 LH    @15,DEV#                                            1744
         SLA   @15,2                                               1744
         L     @01,PABPTR                                          1744
         ALR   @01,@15                                             1744
         TM    PAB2M11-4(@01),B'00000001'                          1744
         BNO   @RF01744                                            1744
*             PGLIMIT=RPMAX-1;      /*                       @Z40LB61*/
         MVC   PGLIMIT(2),@CH00868                                 1745
*           ELSE                                                   1746
*             PGLIMIT=RPMAX;        /*                       @Z40LB61*/
         B     @RC01744                                            1746
@RF01744 MVC   PGLIMIT(2),@CH00684                                 1746
*RPLOOP:                                                           1747
*           DO RP#=2 TO PGLIMIT;    /*                       @Z40LB61*/
*                                                                  1747
@RC01744 DS    0H                                                  1747
RPLOOP   LA    @15,2                                               1747
         B     @DE01747                                            1747
@DL01747 DS    0H                                                  1748
*             /*******************************************************/
*             /*                                                     */
*             /* DO COMMON SET-UP FOR POSSIBLE ERROR MSG'S   @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1748
*             SDGINDEX(2)=SDG#-1;   /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1748
         L     @05,MARGPTR(,@14)                                   1748
         LH    @04,SDG#                                            1748
         LR    @03,@04                                             1748
         BCTR  @03,0                                               1748
         STC   @03,SDGINDEX+24(,@05)                               1748
*             LUAINDEX(2)=LUA#;     /*                       @Z40LB61*/
         MVC   LUAINDEX+24(1,@05),LUA#+1                           1749
*             RPINDEX(2)=RP#-1;     /*                       @Z40LB61*/
         LR    @03,@15                                             1750
         BCTR  @03,0                                               1750
         STC   @03,RPINDEX+24(,@05)                                1750
*             CHRINDEX(2)=PREVCHR;  /*                       @Z40LB61*/
*                                                                  1751
         L     @02,EARGPTR(,@14)                                   1751
         MVC   CHRINDEX+24(5,@05),PREVCHR(@02)                     1751
*             /*******************************************************/
*             /*                                                     */
*             /* CHECK THAT VALID REAL PAGE ENTRIES HAVE     @Z40LB61*/
*             /* BEEN CHECKED-OFF. IF NOT,PRINT AN ERROR     @Z40LB61*/
*             /* MESSAGE.                                    @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1752
*             BYTE#=(RP#-1)/8+1;    /*                       @Z40LB61*/
         LA    @01,1                                               1752
         LR    @04,@03                                             1752
         SRDA  @04,32                                              1752
         D     @04,@CF00183                                        1752
         ALR   @05,@01                                             1752
         STH   @05,BYTE#(,@02)                                     1752
*             BIT#=(RP#-1)//8+1;    /*                       @Z40LB61*/
         LR    @14,@03                                             1753
         SRDA  @14,32                                              1753
         D     @14,@CF00183                                        1753
         ALR   @14,@01                                             1753
         STH   @14,BIT#(,@02)                                      1753
*             IF(RPMACT(RP#)=ON|RPMINACT(RP#)=ON|RPMBND(RP#)=ON|RPMVBND
*                 (RP#)=ON)&RPMIOERR(RP#)=OFF&(RPMCHKFF(SDG#,DEV#,BYTE#
*                 )&BITMASK(BIT#))=0 THEN                          1754
         L     @15,RPMPTR                                          1754
         LH    @04,RP#                                             1754
         SLA   @04,2                                               1754
         ST    @04,@TF00001                                        1754
         ALR   @04,@15                                             1754
         AL    @04,@CF01761                                        1754
         TM    RPMACT(@04),B'11110000'                             1754
         BZ    @RF01754                                            1754
         AL    @15,@TF00001                                        1754
         AL    @15,@CF01761                                        1754
         TM    RPMIOERR(@15),B'00001000'                           1754
         BNZ   @RF01754                                            1754
         LH    @15,SDG#                                            1754
         SLA   @15,3                                               1754
         AH    @15,DEV#                                            1754
         MH    @15,@CH00769                                        1754
         ALR   @15,@05                                             1754
         L     @02,@PC00001+4                                      1754
         L     @01,RPMCOPTR(,@02)                                  1754
         AL    @01,@CF01767                                        1754
         SLR   @00,@00                                             1754
         IC    @00,RPMCHKFF(@15,@01)                               1754
         SLR   @15,@15                                             1754
         IC    @15,BITMASK-1(@14)                                  1754
         NR    @00,@15                                             1754
         LTR   @00,@00                                             1754
         BNZ   @RF01754                                            1754
*               DO;                 /*                       @Z40LB61*/
*                 MTCHMSG=ON;       /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1756
         L     @15,MARGPTR(,@15)                                   1756
         OI    MTCHMSG(@15),B'00010000'                            1756
*                 MVTTBL(1)=ON;     /*                       @Z40LB61*/
         OI    MVTTBL(@15),B'10000000'                             1757
*                 RPMTBL(2)=ON;     /*                       @Z40LB61*/
         OI    RPMTBL+4(@15),B'00000010'                           1758
*                 RPFLD=ON;         /*                       @Z40LB61*/
         OI    RPFLD(@15),B'00100000'                              1759
*                 FLDNUM(1)=RP#-1;  /*                       @Z40LB61*/
         ST    @03,FLDNUM(,@15)                                    1760
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @Z40LB61*/
         L     @03,@PC00001                                        1761
         ST    @03,@AL00001                                        1761
         ST    @02,@AL00001+4                                      1761
         L     @15,@CV01495                                        1761
         LA    @01,@AL00001                                        1761
         BALR  @14,@15                                             1761
*               END;                /*                       @Z40LB61*/
*                                                                  1762
*             /*******************************************************/
*             /*                                                     */
*             /* IF MSC VS. MSC CHECKING WAS REQUESTED,      @Z40LB61*/
*             /* AND THE RPM ENTRY DOES NOT INDICATE THE     @Z40LB61*/
*             /* PAGE IS NOT AVAILABLE OR PART OF A BOUND    @Z40LB61*/
*             /* VOLUME, THEN FIRST DO COMMON SET-UP FOR     @Z40LB61*/
*             /* POSSIBLE ERROR MESSAGES.                    @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1763
*             IF MSCCHK=ON&RPMNA(RP#)=OFF&RPMVBND(RP#)=OFF THEN    1763
@RF01754 L     @15,@PC00001+4                                      1763
         TM    MSCCHK(@15),B'10000000'                             1763
         BNO   @RF01763                                            1763
         LH    @15,RP#                                             1763
         SLA   @15,2                                               1763
         L     @01,RPMPTR                                          1763
         ALR   @01,@15                                             1763
         AL    @01,@CF01761                                        1763
         TM    RPMNA(@01),B'00010001'                              1763
         BNZ   @RF01763                                            1763
*RPMPABM:                                                          1764
*               DO;                 /*                       @Z40LB61*/
RPMPABM  DS    0H                                                  1765
*                 INCNMSG=ON;       /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1765
         L     @14,MARGPTR(,@15)                                   1765
         OI    INCNMSG(@14),B'10000000'                            1765
*                 PABTBL(1)=ON;     /*                       @Z40LB61*/
         OI    PABTBL(@14),B'00010000'                             1766
*                 RPMTBL(2)=ON;     /*                       @Z40LB61*/
         OI    RPMTBL+4(@14),B'00000010'                           1767
*                 SDGINDEX(1)=SDG#-1;/*                      @Z40LB61*/
         LH    @05,SDG#                                            1768
         BCTR  @05,0                                               1768
         STC   @05,SDGINDEX(,@14)                                  1768
*                 LUAINDEX(1)=LUA#; /*                       @Z40LB61*/
         MVC   LUAINDEX(1,@14),LUA#+1                              1769
*                 CHRINDEX(1)=SAVECHR;/*                     @Z40LB61*/
         MVC   CHRINDEX(5,@14),SAVECHR                             1770
*                 MSGNRSET=ON;      /*                       @Z40LB61*/
         OI    MSGNRSET(@14),B'00000001'                           1771
*                 TBLNRSET(1)=ON;   /*                       @Z40LB61*/
         OI    TBLNRSET(@14),B'00000001'                           1772
*                 TBLNRSET(2)=ON;   /*                       @Z40LB61*/
*                                                                  1773
         OI    TBLNRSET+4(@14),B'00000001'                         1773
*                 /***************************************************/
*                 /*                                                 */
*                 /* IF THE PAGE IS ACTIVE, ADD 1 TO THE     @Z40LB61*/
*                 /* COUNT OF ACTIVE PAGES FOR THIS DEVICE   @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1774
*                 IF RPMACT(RP#)=ON THEN                           1774
         LH    @05,RP#                                             1774
         SLA   @05,2                                               1774
         L     @01,RPMPTR                                          1774
         ALR   @01,@05                                             1774
         AL    @01,@CF01761                                        1774
         TM    RPMACT(@01),B'10000000'                             1774
         BNO   @RF01774                                            1774
*                   DO;             /*                       @Z40LB61*/
*                     APCOUNT(DEV#)=APCOUNT(DEV#)+1;/*       @Z40LB61*/
*                                                                  1776
         LH    @05,DEV#                                            1776
         LR    @04,@05                                             1776
         ALR   @04,@04                                             1776
         LA    @03,1                                               1776
         AH    @03,APCOUNT-2(@04)                                  1776
         STH   @03,APCOUNT-2(@04)                                  1776
*                     /***********************************************/
*                     /*                                             */
*                     /* IF THIS ACTIVE PAGE IS NOT REFLECTED        */
*                     /*                                     @Z40LB61*/
*                     /* IN THE PAB ACTIVE PAGE BIT MAP, THEN        */
*                     /*                                     @Z40LB61*/
*                     /* PRINT AN ERROR MESSAGE.             @Z40LB61*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  1777
*                     IF(PABAMAP(DEV#,BYTE#)&BITMASK(BIT#))=0 THEN 1777
         SLA   @05,3                                               1777
         L     @04,EARGPTR(,@15)                                   1777
         AH    @05,BYTE#(,@04)                                     1777
         LH    @01,BIT#(,@04)                                      1777
         L     @04,PABPTR                                          1777
         SLR   @00,@00                                             1777
         IC    @00,PABAMAP-9(@05,@04)                              1777
         SLR   @05,@05                                             1777
         IC    @05,BITMASK-1(@01)                                  1777
         NR    @00,@05                                             1777
         LTR   @00,@00                                             1777
         BNZ   @RF01777                                            1777
*                       DO;         /*                       @Z40LB61*/
*                         APASFLD=ON;/*                      @Z40LB61*/
         OI    APASFLD(@14),B'00010000'                            1779
*                         FLDCHAR(1)=STATNO;/*               @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1780
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1780
         MVC   FLDCHAR(3,@14),@CC01345                             1780
*                         FLDCHAR(2)=STATYES;/*              @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1781
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1781
         MVC   FLDCHAR+12(3,@14),@CC01343                          1781
*                         CALL IDCCH04(GDTTBL,CDALIST);/*    @Z40LB61*/
         L     @14,@PC00001                                        1782
         ST    @14,@AL00001                                        1782
         ST    @15,@AL00001+4                                      1782
         L     @15,@CV01495                                        1782
         LA    @01,@AL00001                                        1782
         BALR  @14,@15                                             1782
*                       END;        /*                       @Z40LB61*/
*                   END;            /*                       @Z40LB61*/
*                 ELSE                                             1785
*                                                                  1785
*                   /*************************************************/
*                   /*                                               */
*                   /* IF THE PAGE IS INACTIVE, ADD 1 TO     @Z40LB61*/
*                   /* THE COUNT OF INACTIVE PAGES FOR THIS  @Z40LB61*/
*                   /* DEVICE                                @Z40LB61*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  1785
*                   IF RPMINACT(RP#)=ON THEN                       1785
         B     @RC01774                                            1785
@RF01774 LH    @15,RP#                                             1785
         SLA   @15,2                                               1785
         L     @01,RPMPTR                                          1785
         ALR   @01,@15                                             1785
         AL    @01,@CF01761                                        1785
         TM    RPMINACT(@01),B'01000000'                           1785
         BNO   @RF01785                                            1785
*                     IPCOUNT(DEV#)=IPCOUNT(DEV#)+1;/*       @Z40LB61*/
         LH    @15,DEV#                                            1786
         ALR   @15,@15                                             1786
         LA    @14,1                                               1786
         AH    @14,IPCOUNT-2(@15)                                  1786
         STH   @14,IPCOUNT-2(@15)                                  1786
*                   ELSE                                           1787
*                                                                  1787
*                     /***********************************************/
*                     /*                                             */
*                     /* IF THE PAGE IS BOUND, ADD 1 TO THE  @Z40LB61*/
*                     /* COUNT OF BOUND PAGES FOR THIS       @Z40LB61*/
*                     /* DEVICE.                             @Z40LB61*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  1787
*                     IF RPMBND(RP#)=ON|RPMMSCT(RP#)=ON THEN       1787
         B     @RC01785                                            1787
@RF01785 LH    @15,RP#                                             1787
         SLA   @15,2                                               1787
         L     @01,RPMPTR                                          1787
         ALR   @01,@15                                             1787
         AL    @01,@CF01761                                        1787
         TM    RPMBND(@01),B'00100010'                             1787
         BZ    @RF01787                                            1787
*                       BPCOUNT(DEV#)=BPCOUNT(DEV#)+1;/*     @Z40LB61*/
         LH    @15,DEV#                                            1788
         ALR   @15,@15                                             1788
         LA    @14,1                                               1788
         AH    @14,BPCOUNT-2(@15)                                  1788
         STH   @14,BPCOUNT-2(@15)                                  1788
*                     ELSE                                         1789
*                                                                  1789
*                       /*********************************************/
*                       /*                                           */
*                       /* THE PAGE MUST BE FREE, SO ADD 1   @Z40LB61*/
*                       /* TO THE COUNT OF FREE PAGES FOR    @Z40LB61*/
*                       /* THIS DEVICE. IF THIS FREE PAGE    @Z40LB61*/
*                       /* IS NOT REFLECTED IN THE PAB FREE  @Z40LB61*/
*                       /* PAGE BIT MAP, PRINT AN ERROR MSG  @Z40LB61*/
*                       /*                                           */
*                       /*********************************************/
*                                                                  1789
*                       DO;         /*                       @Z40LB61*/
         B     @RC01787                                            1789
@RF01787 DS    0H                                                  1790
*                         FPCOUNT(DEV#)=FPCOUNT(DEV#)+1;/*   @Z40LB61*/
         LH    @15,DEV#                                            1790
         LR    @14,@15                                             1790
         ALR   @14,@14                                             1790
         LA    @05,1                                               1790
         AH    @05,FPCOUNT-2(@14)                                  1790
         STH   @05,FPCOUNT-2(@14)                                  1790
*                         IF(PABFMAP(DEV#,BYTE#)&BITMASK(BIT#))=0 THEN
         SLA   @15,3                                               1791
         L     @14,@PC00001+4                                      1791
         L     @05,EARGPTR(,@14)                                   1791
         AH    @15,BYTE#(,@05)                                     1791
         LH    @01,BIT#(,@05)                                      1791
         L     @05,PABPTR                                          1791
         SLR   @04,@04                                             1791
         IC    @04,PABFMAP-9(@15,@05)                              1791
         SLR   @05,@05                                             1791
         IC    @05,BITMASK-1(@01)                                  1791
         NR    @04,@05                                             1791
         LTR   @04,@04                                             1791
         BNZ   @RF01791                                            1791
*                           DO;     /*                       @Z40LB61*/
*                             FPASFLD=ON;/*                  @Z40LB61*/
         L     @15,MARGPTR(,@14)                                   1793
         OI    FPASFLD(@15),B'00000100'                            1793
*                             FLDCHAR(1)=STATNO;/*           @Z40LB61*/
         MVI   FLDCHAR+3(@15),C' '                                 1794
         MVC   FLDCHAR+4(8,@15),FLDCHAR+3(@15)                     1794
         MVC   FLDCHAR(3,@15),@CC01345                             1794
*                             FLDCHAR(2)=STATYES;/*          @Z40LB61*/
         MVI   FLDCHAR+15(@15),C' '                                1795
         MVC   FLDCHAR+16(8,@15),FLDCHAR+15(@15)                   1795
         MVC   FLDCHAR+12(3,@15),@CC01343                          1795
*                             CALL IDCCH04(GDTTBL,CDALIST);/*      1796
*                                                            @Z40LB61*/
         L     @15,@PC00001                                        1796
         ST    @15,@AL00001                                        1796
         ST    @14,@AL00001+4                                      1796
         L     @15,@CV01495                                        1796
         LA    @01,@AL00001                                        1796
         BALR  @14,@15                                             1796
*                           END;    /*                       @Z40LB61*/
*                       END;        /*                       @Z40LB61*/
*                                                                  1798
@RF01791 DS    0H                                                  1799
*                 /***************************************************/
*                 /*                                                 */
*                 /* RESET THE 'IDCCH04' OPTION FLAGS        @Z40LB61*/
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1799
*                 MSGTYPE=''B;      /*                       @Z40LB61*/
@RC01787 DS    0H                                                  1799
@RC01785 DS    0H                                                  1799
@RC01774 L     @15,@PC00001+4                                      1799
         L     @15,MARGPTR(,@15)                                   1799
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1799
*                 TBLTYPE(1)=''B;   /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1800
*                 TBLTYPE(2)=''B;   /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1801
*               END RPMPABM;        /*                       @Z40LB61*/
*           END RPLOOP;             /*                       @Z40LB61*/
@RF01763 LA    @15,1                                               1803
         AH    @15,RP#                                             1803
@DE01747 STH   @15,RP#                                             1803
         CH    @15,PGLIMIT                                         1803
         BNH   @DL01747                                            1803
*         END GOODDEV2;             /*                       @Z40LB61*/
*     END DEVLOOP2;                 /*                       @Z40LB61*/
*                                                                  1805
@RF01728 LA    @15,1                                               1805
         AH    @15,DEV#                                            1805
         STH   @15,DEV#                                            1805
         CH    @15,@CH00183                                        1805
         BNH   @DL01723                                            1805
*     /***************************************************************/
*     /*                                                             */
*     /* GO PERFORM FURTHER CHECKING INVOLVING SUMS,         @Z40LB61*/
*     /* COUNTS, AND TOTALS FOR THE PAGES OF THIS SDG.       @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1806
*     CALL CHKSUMS;                 /*                       @Z40LB61*/
         BAL   @14,CHKSUMS                                         1806
*   END SDGLOOP;                    /*                       @Z40LB61*/
         LA    @15,1                                               1807
         AH    @15,SDG#                                            1807
         STH   @15,SDG#                                            1807
         CH    @15,@CH00781                                        1807
         BNH   @DL01695                                            1807
*   END SCANSUMS;                   /*                       @Z40LB61*/
         B     @EL00011                                            1808
*                                                                  1809
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - CHKSUMS                                 @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE COMPARES SDG PAGE ALLOCATION     @Z40LB61*/
*/*            TOTALS WITH SUM TOTALS ACCUMULATED DURING     @Z40LB61*/
*/*            INDIVIDUAL PAGE ANALYSIS.                     @Z40LB61*/
*/*                                                          @Z40LB61*/
*/*            ALSO CHECKED IS DEVICE DATA ASSOCIATED WITH   @Z40LB61*/
*/*            THE STAGING DEVICES OF EACH SDG.              @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*        (2) MSC CONFIGURATION BIT MAP                     @Z40LB61*/
*/*        (3) MSC SDG PAGE AVAILABILITY BLOCK               @Z40LB61*/
*/*        (4) REAL PAGE MAP PAGE STATUS SUM TOTALS          @Z40LB61*/
*/*        (5) SA LOGICAL-TO-REAL TABLE                      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  1809
*CHKSUMS:                                                          1809
*   PROCEDURE;                      /*                       @Z40LB61*/
CHKSUMS  STM   @14,@12,@SA00012                                    1809
*   OLDERID2=NEWERID2;                                             1810
         L     @15,@PC00001                                        1810
         L     @15,GDTTR2(,@15)                                    1810
         MVC   @TS00001(95),NEWERID2(@15)                          1810
         MVC   OLDERID2(95,@15),@TS00001                           1810
*   NEWID2='CH2U';                  /*                       @Z40LB61*/
*                                                                  1811
         MVC   NEWID2(4,@15),@CC01674                              1811
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM CHECKING FOR EACH DEVICE OF THIS SDG.         @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1812
*   LRUDCNT=0;                      /*                       @Z40LB61*/
         SLR   @15,@15                                             1812
         STH   @15,LRUDCNT                                         1812
*DEVLOOP3:                                                         1813
*   DO DEV#=1 TO DEVSSDG;           /*                       @Z40LB61*/
*                                                                  1813
DEVLOOP3 LA    @15,1                                               1813
         STH   @15,DEV#                                            1813
@DL01813 DS    0H                                                  1814
*     /***************************************************************/
*     /*                                                             */
*     /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES        @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1814
*     SDGINDEX(2)=SDG#-1;           /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1814
         L     @14,MARGPTR(,@14)                                   1814
         LH    @05,SDG#                                            1814
         BCTR  @05,0                                               1814
         STC   @05,SDGINDEX+24(,@14)                               1814
*     IF PAB3333(1)=ON THEN                                        1815
         L     @01,PABPTR                                          1815
         TM    PAB3333(@01),B'00010000'                            1815
         BNO   @RF01815                                            1815
*       LUAINDEX(2)=DEV#+DEVSSDG-1; /*                       @Z40LB61*/
         SH    @15,@CH01733                                        1816
         STC   @15,LUAINDEX+24(,@14)                               1816
*     ELSE                                                         1817
*       LUAINDEX(2)=DEV#-1;         /*                       @Z40LB61*/
         B     @RC01815                                            1817
@RF01815 L     @15,@PC00001+4                                      1817
         L     @01,MARGPTR(,@15)                                   1817
         LH    @00,DEV#                                            1817
         BCTR  @00,0                                               1817
         STC   @00,LUAINDEX+24(,@01)                               1817
*     CHRINDEX(2)=SAVECHR;          /*                       @Z40LB61*/
*                                                                  1818
@RC01815 L     @15,@PC00001+4                                      1818
         L     @01,MARGPTR(,@15)                                   1818
         MVC   CHRINDEX+24(5,@01),SAVECHR                          1818
*     /***************************************************************/
*     /*                                                             */
*     /* IF MSC-MSC CHECKING WAS REQUESTED, PERFORM          @Z40LB61*/
*     /* CHECKING BETWEEN THE PAB AND REAL PAGE MAPS         @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1819
*     IF MSCCHK=ON THEN                                            1819
         TM    MSCCHK(@15),B'10000000'                             1819
         BNO   @RF01819                                            1819
*CHKSUMS1:                                                         1820
*       DO;                         /*                       @Z40LB61*/
*                                                                  1820
CHKSUMS1 DS    0H                                                  1821
*         /***********************************************************/
*         /*                                                         */
*         /* COUNT UP ALL THE BITS SET 'ON' IN THE PAB FREE  @Z40LB61*/
*         /* PAGE BIT MAP AND PAB ACTIVE PAGE BIT MAP        @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1821
*         FPBITCNT=0;               /*                       @Z40LB61*/
         SLR   @15,@15                                             1821
         STH   @15,FPBITCNT                                        1821
*         APBITCNT=0;               /*                       @Z40LB61*/
         STH   @15,APBITCNT                                        1822
*         WORKVAL1=1;               /*                       @Z40LB61*/
         LA    @15,1                                               1823
         STH   @15,WORKVAL1                                        1823
*         DO BYTE#=1 TO(RPMAX-1)/8+1;/*                      @Z40LB61*/
         L     @14,@PC00001+4                                      1824
         L     @14,EARGPTR(,@14)                                   1824
         STH   @15,BYTE#(,@14)                                     1824
@DL01824 DS    0H                                                  1825
*           DO BIT#=1 TO 8 WHILE(WORKVAL1<=RPMAX);/*         @Z40LB61*/
         LA    @15,1                                               1825
         L     @14,@PC00001+4                                      1825
         L     @14,EARGPTR(,@14)                                   1825
         STH   @15,BIT#(,@14)                                      1825
@DL01825 LH    @15,WORKVAL1                                        1825
         CH    @15,@CH00684                                        1825
         BH    @DC01825                                            1825
*             IF(PABFMAP(DEV#,BYTE#)&BITMASK(BIT#))^=0 THEN        1826
         LH    @15,DEV#                                            1826
         SLA   @15,3                                               1826
         L     @14,@PC00001+4                                      1826
         L     @14,EARGPTR(,@14)                                   1826
         AH    @15,BYTE#(,@14)                                     1826
         LH    @01,BIT#(,@14)                                      1826
         L     @14,PABPTR                                          1826
         SLR   @00,@00                                             1826
         IC    @00,PABFMAP-9(@15,@14)                              1826
         SLR   @15,@15                                             1826
         IC    @15,BITMASK-1(@01)                                  1826
         NR    @00,@15                                             1826
         LTR   @00,@00                                             1826
         BZ    @RF01826                                            1826
*               FPBITCNT=FPBITCNT+1;/*                       @Z40LB61*/
         LA    @15,1                                               1827
         AH    @15,FPBITCNT                                        1827
         STH   @15,FPBITCNT                                        1827
*             IF(PABAMAP(DEV#,BYTE#)&BITMASK(BIT#))^=0 THEN        1828
@RF01826 LH    @15,DEV#                                            1828
         SLA   @15,3                                               1828
         L     @14,@PC00001+4                                      1828
         L     @14,EARGPTR(,@14)                                   1828
         AH    @15,BYTE#(,@14)                                     1828
         LH    @01,BIT#(,@14)                                      1828
         L     @14,PABPTR                                          1828
         SLR   @00,@00                                             1828
         IC    @00,PABAMAP-9(@15,@14)                              1828
         SLR   @15,@15                                             1828
         IC    @15,BITMASK-1(@01)                                  1828
         NR    @00,@15                                             1828
         LTR   @00,@00                                             1828
         BZ    @RF01828                                            1828
*               APBITCNT=APBITCNT+1;/*                       @Z40LB61*/
         LA    @15,1                                               1829
         AH    @15,APBITCNT                                        1829
         STH   @15,APBITCNT                                        1829
*             WORKVAL1=WORKVAL1+1;  /*                       @Z40LB61*/
@RF01828 LA    @15,1                                               1830
         AH    @15,WORKVAL1                                        1830
         STH   @15,WORKVAL1                                        1830
*           END;                    /*                       @Z40LB61*/
         L     @14,@PC00001+4                                      1831
         L     @01,EARGPTR(,@14)                                   1831
         LA    @15,1                                               1831
         AH    @15,BIT#(,@01)                                      1831
         L     @14,@PC00001+4                                      1831
         L     @14,EARGPTR(,@14)                                   1831
         STH   @15,BIT#(,@14)                                      1831
         CH    @15,@CH00183                                        1831
         BNH   @DL01825                                            1831
@DC01825 DS    0H                                                  1832
*         END;                      /*                       @Z40LB61*/
*                                                                  1832
         L     @14,@PC00001+4                                      1832
         L     @01,EARGPTR(,@14)                                   1832
         LA    @15,1                                               1832
         AH    @15,BYTE#(,@01)                                     1832
         L     @14,@PC00001+4                                      1832
         L     @14,EARGPTR(,@14)                                   1832
         STH   @15,BYTE#(,@14)                                     1832
         CH    @15,@CH00769                                        1832
         BNH   @DL01824                                            1832
*         /***********************************************************/
*         /*                                                         */
*         /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES    @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1833
*         PABTBL(2)=ON;             /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1833
         L     @14,MARGPTR(,@15)                                   1833
         OI    PABTBL+4(@14),B'00010000'                           1833
*         SUMSMSG=ON;               /*                       @Z40LB61*/
         OI    SUMSMSG(@14),B'00100000'                            1834
*         MSGNRSET=ON;              /*                       @Z40LB61*/
         OI    MSGNRSET(@14),B'00000001'                           1835
*         TBLNRSET(2)=ON;           /*                       @Z40LB61*/
*                                                                  1836
         OI    TBLNRSET+4(@14),B'00000001'                         1836
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SUM OF FREE PAGES FROM THE PAB FREE PAGE @Z40LB61*/
*         /* BIT MAP DOES NOT EQUAL THE PAB FREE PAGE COUNT  @Z40LB61*/
*         /* FIELD FOR THIS DEVICE, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1837
*         IF FPBITCNT^=PABFCNT(DEV#) THEN                          1837
         LH    @05,FPBITCNT                                        1837
         LH    @04,DEV#                                            1837
         SLA   @04,2                                               1837
         L     @01,PABPTR                                          1837
         SLR   @03,@03                                             1837
         IC    @03,PABFCNT-4(@04,@01)                              1837
         CR    @05,@03                                             1837
         BE    @RF01837                                            1837
*           DO;                     /*                       @Z40LB61*/
*             PABTBL(1)=ON;         /*                       @Z40LB61*/
         OI    PABTBL(@14),B'00010000'                             1839
*             FPFLD=ON;             /*                       @Z40LB61*/
         OI    FPFLD(@14),B'00000100'                              1840
*             FLDNUM(1)=FPBITCNT;   /*                       @Z40LB61*/
         ST    @05,FLDNUM(,@14)                                    1841
*             FLDNUM(2)=PABFCNT(DEV#);/*                     @Z40LB61*/
         ST    @03,FLDNUM+12(,@14)                                 1842
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1843
         ST    @14,@AL00001                                        1843
         ST    @15,@AL00001+4                                      1843
         L     @15,@CV01495                                        1843
         LA    @01,@AL00001                                        1843
         BALR  @14,@15                                             1843
*           END;                    /*                       @Z40LB61*/
*                                                                  1844
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SUM OF ACTIVE PAGES FROM PAB ACTIVE PAGE @Z40LB61*/
*         /* BIT MAP DOES NOT EQUAL THE PAB ACTIVE PAGE COUNT        */
*         /*                                                 @Z40LB61*/
*         /* FIELD FOR THIS DEVICE, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1845
*         IF APBITCNT^=PABACNT(DEV#) THEN                          1845
@RF01837 LH    @15,APBITCNT                                        1845
         LH    @14,DEV#                                            1845
         SLA   @14,2                                               1845
         L     @01,PABPTR                                          1845
         SLR   @05,@05                                             1845
         IC    @05,PABACNT-4(@14,@01)                              1845
         CR    @15,@05                                             1845
         BE    @RF01845                                            1845
*           DO;                     /*                       @Z40LB61*/
*             PABTBL(1)=ON;         /*                       @Z40LB61*/
         L     @04,@PC00001+4                                      1847
         L     @14,MARGPTR(,@04)                                   1847
         OI    PABTBL(@14),B'00010000'                             1847
*             APFLD=ON;             /*                       @Z40LB61*/
         OI    APFLD(@14),B'00000010'                              1848
*             FLDNUM(1)=APBITCNT;   /*                       @Z40LB61*/
         ST    @15,FLDNUM(,@14)                                    1849
*             FLDNUM(2)=PABACNT(DEV#);/*                     @Z40LB61*/
         ST    @05,FLDNUM+12(,@14)                                 1850
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @05,@PC00001                                        1851
         ST    @05,@AL00001                                        1851
         ST    @04,@AL00001+4                                      1851
         L     @15,@CV01495                                        1851
         LA    @01,@AL00001                                        1851
         BALR  @14,@15                                             1851
*           END;                    /*                       @Z40LB61*/
*                                                                  1852
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SUM OF FREE PAGES FROM THE REAL PAGE MAP @Z40LB61*/
*         /* ENTRIES DOES NOT EQUAL THE PAB FREE PAGE COUNT  @Z40LB61*/
*         /* FIELD FOR THIS DEVICE, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1853
*         IF FPCOUNT(DEV#)^=PABFCNT(DEV#) THEN                     1853
@RF01845 LH    @15,DEV#                                            1853
         LR    @14,@15                                             1853
         ALR   @14,@14                                             1853
         LH    @14,FPCOUNT-2(@14)                                  1853
         SLA   @15,2                                               1853
         L     @01,PABPTR                                          1853
         SLR   @05,@05                                             1853
         IC    @05,PABFCNT-4(@15,@01)                              1853
         CR    @14,@05                                             1853
         BE    @RF01853                                            1853
*           DO;                     /*                       @Z40LB61*/
*             RPMTBL(1)=ON;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1855
         L     @04,MARGPTR(,@15)                                   1855
         OI    RPMTBL(@04),B'00000010'                             1855
*             FPFLD=ON;             /*                       @Z40LB61*/
         OI    FPFLD(@04),B'00000100'                              1856
*             FLDNUM(1)=FPCOUNT(DEV#);/*                     @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    1857
*             FLDNUM(2)=PABFCNT(DEV#);/*                     @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 1858
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1859
         ST    @14,@AL00001                                        1859
         ST    @15,@AL00001+4                                      1859
         L     @15,@CV01495                                        1859
         LA    @01,@AL00001                                        1859
         BALR  @14,@15                                             1859
*           END;                    /*                       @Z40LB61*/
*                                                                  1860
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SUM OF ACTIVE PAGES FROM THE RPM         @Z40LB61*/
*         /* ENTRIES DOES NOT EQUAL THE PAB ACTIVE PAGE COUNT        */
*         /*                                                 @Z40LB61*/
*         /* FIELD FOR THIS DEVICE, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1861
*         IF APCOUNT(DEV#)^=PABACNT(DEV#) THEN                     1861
@RF01853 LH    @15,DEV#                                            1861
         LR    @14,@15                                             1861
         ALR   @14,@14                                             1861
         LH    @14,APCOUNT-2(@14)                                  1861
         SLA   @15,2                                               1861
         L     @01,PABPTR                                          1861
         SLR   @05,@05                                             1861
         IC    @05,PABACNT-4(@15,@01)                              1861
         CR    @14,@05                                             1861
         BE    @RF01861                                            1861
*           DO;                     /*                       @Z40LB61*/
*             RPMTBL(1)=ON;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1863
         L     @04,MARGPTR(,@15)                                   1863
         OI    RPMTBL(@04),B'00000010'                             1863
*             APFLD=ON;             /*                       @Z40LB61*/
         OI    APFLD(@04),B'00000010'                              1864
*             FLDNUM(1)=APCOUNT(DEV#);/*                     @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    1865
*             FLDNUM(2)=PABACNT(DEV#);/*                     @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 1866
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1867
         ST    @14,@AL00001                                        1867
         ST    @15,@AL00001+4                                      1867
         L     @15,@CV01495                                        1867
         LA    @01,@AL00001                                        1867
         BALR  @14,@15                                             1867
*           END;                    /*                       @Z40LB61*/
*                                                                  1868
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SUM OF INACTIVE PAGES FROM RPM ENTRIES   @Z40LB61*/
*         /* DOES NOT EQUAL THE PAB INACTIVE PAGE COUNT      @Z40LB61*/
*         /* FIELD FOR THIS DEVICE, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1869
*         IF IPCOUNT(DEV#)^=PABICNT(DEV#) THEN                     1869
@RF01861 LH    @15,DEV#                                            1869
         LR    @14,@15                                             1869
         ALR   @14,@14                                             1869
         LH    @14,IPCOUNT-2(@14)                                  1869
         SLA   @15,2                                               1869
         L     @01,PABPTR                                          1869
         SLR   @05,@05                                             1869
         IC    @05,PABICNT-4(@15,@01)                              1869
         CR    @14,@05                                             1869
         BE    @RF01869                                            1869
*           DO;                     /*                       @Z40LB61*/
*             RPMTBL(1)=ON;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1871
         L     @04,MARGPTR(,@15)                                   1871
         OI    RPMTBL(@04),B'00000010'                             1871
*             IPFLD=ON;             /*                       @Z40LB61*/
         OI    IPFLD(@04),B'00000001'                              1872
*             FLDNUM(1)=IPCOUNT(DEV#);/*                     @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    1873
*             FLDNUM(2)=PABICNT(DEV#);/*                     @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 1874
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1875
         ST    @14,@AL00001                                        1875
         ST    @15,@AL00001+4                                      1875
         L     @15,@CV01495                                        1875
         LA    @01,@AL00001                                        1875
         BALR  @14,@15                                             1875
*           END;                    /*                       @Z40LB61*/
*                                                                  1876
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE SUM OF BOUND PAGES FROM THE RPM          @Z40LB61*/
*         /* ENTRIES DOES NOT EQUAL THE PAB BOUND PAGE COUNT @Z40LB61*/
*         /* FIELD FOR THIS DEVICE, PRINT AN ERROR MESSAGE.  @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1877
*         IF BPCOUNT(DEV#)^=PABBCNT(DEV#) THEN                     1877
@RF01869 LH    @15,DEV#                                            1877
         LR    @14,@15                                             1877
         ALR   @14,@14                                             1877
         LH    @14,BPCOUNT-2(@14)                                  1877
         SLA   @15,2                                               1877
         L     @01,PABPTR                                          1877
         SLR   @05,@05                                             1877
         IC    @05,PABBCNT-4(@15,@01)                              1877
         CR    @14,@05                                             1877
         BE    @RF01877                                            1877
*           DO;                     /*                       @Z40LB61*/
*             RPMTBL(1)=ON;         /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1879
         L     @04,MARGPTR(,@15)                                   1879
         OI    RPMTBL(@04),B'00000010'                             1879
*             BPFLD=ON;             /*                       @Z40LB61*/
         OI    BPFLD(@04),B'10000000'                              1880
*             FLDNUM(1)=BPCOUNT(DEV#);/*                     @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    1881
*             FLDNUM(2)=PABBCNT(DEV#);/*                     @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 1882
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @14,@PC00001                                        1883
         ST    @14,@AL00001                                        1883
         ST    @15,@AL00001+4                                      1883
         L     @15,@CV01495                                        1883
         LA    @01,@AL00001                                        1883
         BALR  @14,@15                                             1883
*           END;                    /*                       @Z40LB61*/
*                                                                  1884
*         /***********************************************************/
*         /*                                                         */
*         /* RESET THE 'IDCCH04' OPTION FLAGS                @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1885
*         MSGTYPE=''B;              /*                       @Z40LB61*/
@RF01877 L     @15,@PC00001+4                                      1885
         L     @15,MARGPTR(,@15)                                   1885
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1885
*         TBLTYPE(1)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1886
*         TBLTYPE(2)=''B;           /*                       @Z40LB61*/
*                                                                  1887
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1887
*         /***********************************************************/
*         /*                                                         */
*         /* ADD THE PAGE COUNTS FOR THE CURRENT DEVICE OF   @Z40LB61*/
*         /* THIS SDG TO THE SUM TOTAL BEING ACCUMULATED     @Z40LB61*/
*         /* IF THIS DEVICE IS VARIED ON VIRTUAL.            @Z40LB64*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1888
*         IF PABVARV(DEV#)=ON THEN                                 1888
         L     @15,PABPTR                                          1888
         LH    @14,DEV#                                            1888
         SLA   @14,2                                               1888
         ST    @14,@TF00001                                        1888
         ALR   @14,@15                                             1888
         TM    PABVARV-4(@14),B'01000000'                          1888
         BNO   @RF01888                                            1888
*           DO;                     /*                       @Z40LB64*/
*             FPTOTAL=FPTOTAL+PABFCNT(DEV#);/*               @Z40LB61*/
         L     @14,@TF00001                                        1890
         SLR   @05,@05                                             1890
         IC    @05,PABFCNT-4(@14,@15)                              1890
         AH    @05,FPTOTAL                                         1890
         STH   @05,FPTOTAL                                         1890
*             APTOTAL=APTOTAL+PABACNT(DEV#);/*               @Z40LB61*/
         L     @14,@TF00001                                        1891
         SLR   @05,@05                                             1891
         IC    @05,PABACNT-4(@14,@15)                              1891
         AH    @05,APTOTAL                                         1891
         STH   @05,APTOTAL                                         1891
*             IPTOTAL=IPTOTAL+PABICNT(DEV#);/*               @Z40LB61*/
         L     @14,@TF00001                                        1892
         SLR   @05,@05                                             1892
         IC    @05,PABICNT-4(@14,@15)                              1892
         AH    @05,IPTOTAL                                         1892
         STH   @05,IPTOTAL                                         1892
*             BPTOTAL=BPTOTAL+PABBCNT(DEV#);/*               @Z40LB61*/
         L     @14,@TF00001                                        1893
         SLR   @05,@05                                             1893
         IC    @05,PABBCNT-4(@14,@15)                              1893
         AH    @05,BPTOTAL                                         1893
         STH   @05,BPTOTAL                                         1893
*           END;                    /*                       @Z40LB64*/
*                                                                  1894
*         /***********************************************************/
*         /*                                                         */
*         /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES    @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1895
*         INCNMSG=ON;               /*                       @Z40LB61*/
@RF01888 L     @15,@PC00001+4                                      1895
         L     @14,MARGPTR(,@15)                                   1895
         OI    INCNMSG(@14),B'10000000'                            1895
*         CBMTBL(1)=ON;             /*                       @Z40LB61*/
         OI    CBMTBL(@14),B'00001000'                             1896
*         PABTBL(2)=ON;             /*                       @Z40LB61*/
         OI    PABTBL+4(@14),B'00010000'                           1897
*         SDGINDEX(1)=SDGINDEX(2);  /*                       @Z40LB61*/
         MVC   SDGINDEX(1,@14),SDGINDEX+24(@14)                    1898
*         LUAINDEX(1)=LUAINDEX(2);  /*                       @Z40LB61*/
         MVC   LUAINDEX(1,@14),LUAINDEX+24(@14)                    1899
*         MSGNRSET=ON;              /*                       @Z40LB61*/
         OI    MSGNRSET(@14),B'00000001'                           1900
*         TBLNRSET(1)=ON;           /*                       @Z40LB61*/
         OI    TBLNRSET(@14),B'00000001'                           1901
*         TBLNRSET(2)=ON;           /*                       @Z40LB61*/
*                                                                  1902
         OI    TBLNRSET+4(@14),B'00000001'                         1902
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK 'DEVICE VALID' STATUS BETWEEN THE PAB AND @Z40LB61*/
*         /* THE CONFIGURATION BIT MAP. IF INCONSISTENT,     @Z40LB61*/
*         /* PRINT AN ERROR MESSAGE.                         @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1903
*         CBMPTR=CBMADDR;           /*                       @Z40LB61*/
         L     @05,CBMADDR(,@15)                                   1903
         ST    @05,CBMPTR                                          1903
*         IF PABDEX(DEV#)=OFF THEN                                 1904
         LH    @04,DEV#                                            1904
         LR    @03,@04                                             1904
         SLA   @03,2                                               1904
         L     @01,PABPTR                                          1904
         ALR   @01,@03                                             1904
         TM    PABDEX-4(@01),B'10000000'                           1904
         BNZ   @RF01904                                            1904
*           IF(CBMDRIVE(SDG#)&BITMASK(DEV#))^=0 THEN               1905
         LH    @01,SDG#                                            1905
         SLR   @00,@00                                             1905
         IC    @00,CBMDRIVE-1(@01,@05)                             1905
         SLR   @05,@05                                             1905
         IC    @05,BITMASK-1(@04)                                  1905
         NR    @00,@05                                             1905
         LTR   @00,@00                                             1905
         BZ    @RF01905                                            1905
*             DO;                   /*                       @Z40LB61*/
*               DVSFLD=ON;          /*                       @Z40LB61*/
         OI    DVSFLD(@14),B'00000100'                             1907
*               FLDCHAR(1)=STATYES; /*                       @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1908
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1908
         MVC   FLDCHAR(3,@14),@CC01343                             1908
*               FLDCHAR(2)=STATNO;  /*                       @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1909
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1909
         MVC   FLDCHAR+12(3,@14),@CC01345                          1909
*               CALL IDCCH04(GDTTBL,CDALIST);/*              @Z40LB61*/
         L     @14,@PC00001                                        1910
         ST    @14,@AL00001                                        1910
         ST    @15,@AL00001+4                                      1910
         L     @15,@CV01495                                        1910
         LA    @01,@AL00001                                        1910
         BALR  @14,@15                                             1910
*             END;                  /*                       @Z40LB61*/
*           ELSE                                                   1912
*             ;                     /*                       @Z40LB61*/
@RF01905 DS    0H                                                  1913
*         ELSE                                                     1913
*                                                                  1913
*           /*********************************************************/
*           /*                                                       */
*           /* IF THE DEVICE EXISTS AND IS NOT THE 2ND HALF  @Z40LB61*/
*           /* OF A 3330 MOD 11, CONTINUE STATUS CHECKING.   @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1913
*           IF PAB2M11(DEV#)=OFF THEN                              1913
         B     @RC01904                                            1913
@RF01904 LH    @15,DEV#                                            1913
         SLA   @15,2                                               1913
         L     @01,PABPTR                                          1913
         ALR   @01,@15                                             1913
         TM    PAB2M11-4(@01),B'00000001'                          1913
         BNZ   @RF01913                                            1913
*GOODDEV1:                                                         1914
*             DO;                   /*                       @Z40LB61*/
GOODDEV1 DS    0H                                                  1915
*               IF(CBMDRIVE(SDG#)&BITMASK(DEV#))=0 THEN            1915
         LH    @01,SDG#                                            1915
         LH    @15,DEV#                                            1915
         L     @14,CBMPTR                                          1915
         SLR   @00,@00                                             1915
         IC    @00,CBMDRIVE-1(@01,@14)                             1915
         SLR   @14,@14                                             1915
         IC    @14,BITMASK-1(@15)                                  1915
         NR    @00,@14                                             1915
         LTR   @00,@00                                             1915
         BNZ   @RF01915                                            1915
*                 DO;               /*                       @Z40LB61*/
*                   DVSFLD=ON;      /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1917
         L     @14,MARGPTR(,@15)                                   1917
         OI    DVSFLD(@14),B'00000100'                             1917
*                   FLDCHAR(1)=STATNO;/*                     @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1918
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1918
         MVC   FLDCHAR(3,@14),@CC01345                             1918
*                   FLDCHAR(2)=STATYES;/*                    @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1919
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1919
         MVC   FLDCHAR+12(3,@14),@CC01343                          1919
*                   CALL IDCCH04(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @14,@PC00001                                        1920
         ST    @14,@AL00001                                        1920
         ST    @15,@AL00001+4                                      1920
         L     @15,@CV01495                                        1920
         LA    @01,@AL00001                                        1920
         BALR  @14,@15                                             1920
*                 END;              /*                       @Z40LB61*/
*                                                                  1921
*               /*****************************************************/
*               /*                                                   */
*               /* FOR A VALID DEVICE, CHECK 'ONLINE' STATUS @Z40LB61*/
*               /* BETWEEN PAB AND CBM. IF INCONSISTENT,     @Z40LB61*/
*               /* PRINT AN ERROR MESSAGE.                   @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1922
*               CBMPTR=CBMADDR+LENGTH(CBMAP);/*              @Z40LB61*/
@RF01915 L     @15,@PC00001+4                                      1922
         LA    @14,40                                              1922
         AL    @14,CBMADDR(,@15)                                   1922
         ST    @14,CBMPTR                                          1922
*               IF PABVARV(DEV#)=ON|PABVARR(DEV#)=ON THEN          1923
         LH    @05,DEV#                                            1923
         LR    @04,@05                                             1923
         SLA   @04,2                                               1923
         L     @01,PABPTR                                          1923
         ALR   @01,@04                                             1923
         TM    PABVARV-4(@01),B'01100000'                          1923
         BZ    @RF01923                                            1923
*                 IF(CBMDRIVE(SDG#)&BITMASK(DEV#))=0 THEN          1924
         LH    @01,SDG#                                            1924
         SLR   @00,@00                                             1924
         IC    @00,CBMDRIVE-1(@01,@14)                             1924
         SLR   @04,@04                                             1924
         IC    @04,BITMASK-1(@05)                                  1924
         NR    @00,@04                                             1924
         LTR   @00,@00                                             1924
         BNZ   @RF01924                                            1924
*                   DO;             /*                       @Z40LB61*/
*                     DOSFLD=ON;    /*                       @Z40LB61*/
         L     @14,MARGPTR(,@15)                                   1926
         OI    DOSFLD(@14),B'00000010'                             1926
*                     FLDCHAR(1)=STATNO;/*                   @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1927
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1927
         MVC   FLDCHAR(3,@14),@CC01345                             1927
*                     FLDCHAR(2)=STATYES;/*                  @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1928
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1928
         MVC   FLDCHAR+12(3,@14),@CC01343                          1928
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB61*/
         L     @14,@PC00001                                        1929
         ST    @14,@AL00001                                        1929
         ST    @15,@AL00001+4                                      1929
         L     @15,@CV01495                                        1929
         LA    @01,@AL00001                                        1929
         BALR  @14,@15                                             1929
*                   END;            /*                       @Z40LB61*/
*                 ELSE                                             1931
*                   ;               /*                       @Z40LB61*/
@RF01924 DS    0H                                                  1932
*               ELSE                                               1932
*                 IF(CBMDRIVE(SDG#)&BITMASK(DEV#))^=0 THEN         1932
         B     @RC01923                                            1932
@RF01923 LH    @01,SDG#                                            1932
         LH    @15,DEV#                                            1932
         L     @14,CBMPTR                                          1932
         SLR   @00,@00                                             1932
         IC    @00,CBMDRIVE-1(@01,@14)                             1932
         SLR   @14,@14                                             1932
         IC    @14,BITMASK-1(@15)                                  1932
         NR    @00,@14                                             1932
         LTR   @00,@00                                             1932
         BZ    @RF01932                                            1932
*                   DO;             /*                       @Z40LB61*/
*                     DOSFLD=ON;    /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1934
         L     @14,MARGPTR(,@15)                                   1934
         OI    DOSFLD(@14),B'00000010'                             1934
*                     FLDCHAR(1)=STATYES;/*                  @Z40LB61*/
         MVI   FLDCHAR+3(@14),C' '                                 1935
         MVC   FLDCHAR+4(8,@14),FLDCHAR+3(@14)                     1935
         MVC   FLDCHAR(3,@14),@CC01343                             1935
*                     FLDCHAR(2)=STATNO;/*                   @Z40LB61*/
         MVI   FLDCHAR+15(@14),C' '                                1936
         MVC   FLDCHAR+16(8,@14),FLDCHAR+15(@14)                   1936
         MVC   FLDCHAR+12(3,@14),@CC01345                          1936
*                     CALL IDCCH04(GDTTBL,CDALIST);/*        @Z40LB61*/
         L     @14,@PC00001                                        1937
         ST    @14,@AL00001                                        1937
         ST    @15,@AL00001+4                                      1937
         L     @15,@CV01495                                        1937
         LA    @01,@AL00001                                        1937
         BALR  @14,@15                                             1937
*                   END;            /*                       @Z40LB61*/
*             END GOODDEV1;         /*                       @Z40LB61*/
*                                                                  1939
@RF01932 DS    0H                                                  1939
@RC01923 DS    0H                                                  1940
*         /***********************************************************/
*         /*                                                         */
*         /* FOR A DEVICE VARIED ON VIRTUAL AND NOT FOR A    @Z40LB61*/
*         /* BOUND VOLUME, ADD 1 TO THE COUNT OF DEVICES     @Z40LB61*/
*         /* ASSOCIATED WITH THE LRU THRESHOLD VALUES.       @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1940
*         IF PABVARV(DEV#)=ON&PABVBND(DEV#)=OFF THEN               1940
@RF01913 DS    0H                                                  1940
@RC01904 LH    @15,DEV#                                            1940
         SLA   @15,2                                               1940
         L     @01,PABPTR                                          1940
         ALR   @01,@15                                             1940
         TM    PABVARV-4(@01),B'01000000'                          1940
         BNO   @RF01940                                            1940
         TM    PABVBND-4(@01),B'00000100'                          1940
         BNZ   @RF01940                                            1940
*           LRUDCNT=LRUDCNT+1;      /*                       @Z40LB61*/
*                                                                  1941
         LA    @15,1                                               1941
         AH    @15,LRUDCNT                                         1941
         STH   @15,LRUDCNT                                         1941
*         /***********************************************************/
*         /*                                                         */
*         /* RESET THE 'IDCCH04' OPTION FLAGS                @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  1942
*         MSGTYPE=''B;              /*                       @Z40LB61*/
@RF01940 L     @15,@PC00001+4                                      1942
         L     @15,MARGPTR(,@15)                                   1942
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         1942
*         TBLTYPE(1)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         1943
*         TBLTYPE(2)=''B;           /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     1944
*       END CHKSUMS1;               /*                       @Z40LB61*/
*                                                                  1945
*     /***************************************************************/
*     /*                                                             */
*     /* IF SA CHECKING WAS REQUESTED AND THE CURRENT        @Z40LB61*/
*     /* DEVICE IS VARIED ON VIRTUAL OR REAL (IF REAL,       @ZD00047*/
*     /* A REAL INTERFACE FLAG MUST BE SET) OR VARIED        @ZD00047*/
*     /* OFF NEUTRAL, THEN DO THE FOLLOWING FOR EACH         @Z40LB61*/
*     /* VALID SA PATH INDICATED IN THE PAB.                 @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  1946
*     IF SACHK=ON&(PABVARV(DEV#)=ON|PABVARR(DEV#)=ON|PABVARN(DEV#)=ON)
*       THEN                                                       1946
@RF01819 L     @15,@PC00001+4                                      1946
         TM    SACHK(@15),B'01000000'                              1946
         BNO   @RF01946                                            1946
         LH    @15,DEV#                                            1946
         SLA   @15,2                                               1946
         L     @01,PABPTR                                          1946
         ALR   @01,@15                                             1946
         TM    PABVARV-4(@01),B'01100010'                          1946
         BZ    @RF01946                                            1946
*LTRCHK:                                                           1947
*       DO PABPATH#=1 TO SASSDG;    /*                       @Z40LB61*/
LTRCHK   LA    @15,1                                               1947
         STH   @15,PABPATH#                                        1947
@DL01947 DS    0H                                                  1948
*         IF PABPATH#=1 THEN                                       1948
         CH    @15,@CH00223                                        1948
         BNE   @RF01948                                            1948
*           WORKVAL2=SHIFT4;        /*                       @ZD00047*/
         MVC   WORKVAL2(2),@CH00478                                1949
*         ELSE                                                     1950
*           WORKVAL2=1;             /*                       @ZD00047*/
         B     @RC01948                                            1950
@RF01948 MVC   WORKVAL2(2),@CH00223                                1950
*         IF PABVLDSA(PABPATH#)=ON THEN                            1951
@RC01948 L     @15,PABPTR                                          1951
         LH    @01,PABPATH#                                        1951
         ALR   @01,@15                                             1951
         TM    PABVLDSA-1(@01),B'10000000'                         1951
         BNO   @RF01951                                            1951
*           IF PABVARR(DEV#)=ON&((PABRINTF(DEV#)/WORKVAL2)&MASK7)=0
*             THEN                                                 1952
         LH    @14,DEV#                                            1952
         SLA   @14,2                                               1952
         ST    @14,@TF00001                                        1952
         ALR   @14,@15                                             1952
         TM    PABVARR-4(@14),B'00100000'                          1952
         BNO   @RF01952                                            1952
         L     @14,@TF00001                                        1952
         SLR   @01,@01                                             1952
         IC    @01,PABRINTF-4(@14,@15)                             1952
         SLR   @00,@00                                             1952
         LH    @15,WORKVAL2                                        1952
         DR    @00,@15                                             1952
         SLR   @00,@00                                             1952
         IC    @00,MASK7                                           1952
         NR    @01,@00                                             1952
         LTR   @01,@01                                             1952
         BZ    @RT01952                                            1952
*             ;                     /*                       @ZD00047*/
*           ELSE                                                   1954
*PABLTRM:                                                          1954
*             DO;                   /*                       @Z40LB61*/
*                                                                  1954
@RF01952 DS    0H                                                  1954
PABLTRM  DS    0H                                                  1955
*               /*****************************************************/
*               /*                                                   */
*               /* SET UP INDICES TO SA LOGICAL-TO-REAL TABLE        */
*               /*                                           @Z40LB61*/
*               /* ENTRY FOR CURRENT SA AND DEVICE           @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1955
*               SA#=(PABSA(PABPATH#)&MASK15)+1;/*            @Z40LB61*/
         L     @15,PABPTR                                          1955
         LH    @14,PABPATH#                                        1955
         SLR   @05,@05                                             1955
         IC    @05,PABSA-1(@14,@15)                                1955
         SLR   @04,@04                                             1955
         IC    @04,MASK15                                          1955
         NR    @05,@04                                             1955
         AH    @05,@CH00223                                        1955
         STH   @05,SA#                                             1955
*               IF PAB3333(PABPATH#)=ON THEN                       1956
         ALR   @15,@14                                             1956
         TM    PAB3333-1(@15),B'00010000'                          1956
         BNO   @RF01956                                            1956
*                 ENTRY#=DEV#+DEVSSDG;/*                     @Z40LB61*/
         LA    @15,8                                               1957
         AH    @15,DEV#                                            1957
         STH   @15,ENTRY#                                          1957
*               ELSE                                               1958
*                 ENTRY#=DEV#;      /*                       @Z40LB61*/
*                                                                  1958
         B     @RC01956                                            1958
@RF01956 MVC   ENTRY#(2),DEV#                                      1958
*               /*****************************************************/
*               /*                                                   */
*               /* IF THE REAL UNIT ADDRESS FROM THE LTR DOES        */
*               /*                                           @Z40LB61*/
*               /* NOT MATCH THE RUA FROM THE PAB, PRINT AN  @Z40LB61*/
*               /* ERROR MESSAGE.                            @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  1959
*               IF ILTRPTR(SA#)^=NULLPTR&ILTRPTR(SA#)^=DUMMYPTR&/* 1959
*                                                            @ZA27324*/
*                   (ILTRRUA(ENTRY#)&MASK31)^=/*             @ZA27324*/
*                   (PABRUA(DEV#)&MASK31) THEN/*             @ZA27324*/
@RC01956 LH    @15,SA#                                             1959
         LR    @14,@15                                             1959
         SLA   @14,2                                               1959
         L     @05,@PC00001+4                                      1959
         L     @14,ILTRPTR-4(@14,@05)                              1959
         LTR   @14,@14                                             1959
         BZ    @RF01959                                            1959
         C     @14,DUMMYPTR                                        1959
         BE    @RF01959                                            1959
         SLR   @04,@04                                             1959
         IC    @04,MASK31                                          1959
         LH    @01,ENTRY#                                          1959
         AL    @14,@CF01340                                        1959
         SLR   @00,@00                                             1959
         IC    @00,ILTRRUA(@01,@14)                                1959
         NR    @00,@04                                             1959
         LH    @01,DEV#                                            1959
         SLA   @01,2                                               1959
         L     @14,PABPTR                                          1959
         SLR   @03,@03                                             1959
         IC    @03,PABRUA-4(@01,@14)                               1959
         NR    @04,@03                                             1959
         CR    @00,@04                                             1959
         BE    @RF01959                                            1959
*                 DO;               /*                       @ZA27324*/
*                   INCNMSG=ON;     /*                       @Z40LB61*/
         L     @01,MARGPTR(,@05)                                   1961
         OI    INCNMSG(@01),B'10000000'                            1961
*                   LTRTBL(1)=ON;   /*                       @Z40LB61*/
         OI    LTRTBL(@01),B'01000000'                             1962
*                   PABTBL(2)=ON;   /*                       @Z40LB61*/
         OI    PABTBL+4(@01),B'00010000'                           1963
*                   LUAINDEX(1)=LUAINDEX(2);/*               @Z40LB61*/
         MVC   LUAINDEX(1,@01),LUAINDEX+24(@01)                    1964
*                   SAINDEX(1)=SA#-1;/*                      @Z40LB61*/
         BCTR  @15,0                                               1965
         STC   @15,SAINDEX(,@01)                                   1965
*                   RUAFLD=ON;      /*                       @Z40LB61*/
         OI    RUAFLD(@01),B'00010000'                             1966
*                   FLDNUM(1)=ILTRRUA(ENTRY#)&MASK31;/*      @Z40LB61*/
         ST    @00,FLDNUM(,@01)                                    1967
*                   FLDNUM(2)=PABRUA(DEV#)&MASK31;/*         @Z40LB61*/
         ST    @04,FLDNUM+12(,@01)                                 1968
*                   CALL IDCCH04(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @04,@PC00001                                        1969
         ST    @04,@AL00001                                        1969
         ST    @05,@AL00001+4                                      1969
         L     @15,@CV01495                                        1969
         LA    @01,@AL00001                                        1969
         BALR  @14,@15                                             1969
*                 END;              /*                       @Z40LB61*/
*             END PABLTRM;          /*                       @Z40LB61*/
@RF01959 DS    0H                                                  1972
*       END LTRCHK;                 /*                       @Z40LB61*/
@RT01952 DS    0H                                                  1972
@RF01951 LA    @15,1                                               1972
         AH    @15,PABPATH#                                        1972
         STH   @15,PABPATH#                                        1972
         CH    @15,@CH00157                                        1972
         BNH   @DL01947                                            1972
*   END DEVLOOP3;                   /*                       @Z40LB61*/
*                                                                  1973
@RF01946 LA    @15,1                                               1973
         AH    @15,DEV#                                            1973
         STH   @15,DEV#                                            1973
         CH    @15,@CH00183                                        1973
         BNH   @DL01813                                            1973
*   /*****************************************************************/
*   /*                                                               */
*   /* IF MSC-MSC CHECKING WAS REQUESTED, THEN COUNTS AND    @Z40LB61*/
*   /* SUMS INTERNAL TO THE PAB MUST BE CHECKED. FIRST,      @Z40LB61*/
*   /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES.         @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1974
*   IF MSCCHK=ON THEN                                              1974
         L     @15,@PC00001+4                                      1974
         TM    MSCCHK(@15),B'10000000'                             1974
         BNO   @RF01974                                            1974
*PABSUMS:                                                          1975
*     DO;                           /*                       @Z40LB61*/
PABSUMS  DS    0H                                                  1976
*       SUMSMSG=ON;                 /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      1976
         L     @14,MARGPTR(,@15)                                   1976
         OI    SUMSMSG(@14),B'00100000'                            1976
*       PABTBL(1)=ON;               /*                       @Z40LB61*/
         OI    PABTBL(@14),B'00010000'                             1977
*       PABTBL(2)=ON;               /*                       @Z40LB61*/
         OI    PABTBL+4(@14),B'00010000'                           1978
*       MSGNRSET=ON;                /*                       @Z40LB61*/
         OI    MSGNRSET(@14),B'00000001'                           1979
*       TBLNRSET(1)=ON;             /*                       @Z40LB61*/
         OI    TBLNRSET(@14),B'00000001'                           1980
*       TBLNRSET(2)=ON;             /*                       @Z40LB61*/
*                                                                  1981
         OI    TBLNRSET+4(@14),B'00000001'                         1981
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE SUM TOTAL OF FREE PAGES ACCUMULATED FOR    @Z40LB61*/
*       /* ALL DEVICES OF THE SDG DOES NOT MATCH THE TOTAL   @Z40LB61*/
*       /* FIELD IN THE PAB, PRINT AN ERROR MESSAGE.         @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1982
*       IF FPTOTAL^=PABFTOT THEN                                   1982
         LH    @05,FPTOTAL                                         1982
         L     @01,PABPTR                                          1982
         SLR   @04,@04                                             1982
         ICM   @04,3,PABFTOT(@01)                                  1982
         CR    @05,@04                                             1982
         BE    @RF01982                                            1982
*         DO;                       /*                       @Z40LB61*/
*           FPCFLD=ON;              /*                       @Z40LB61*/
         OI    FPCFLD(@14),B'00000010'                             1984
*           FLDNUM(1)=FPTOTAL;      /*                       @Z40LB61*/
         ST    @05,FLDNUM(,@14)                                    1985
*           FLDNUM(2)=PABFTOT;      /*                       @Z40LB61*/
         ST    @04,FLDNUM+12(,@14)                                 1986
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        1987
         ST    @14,@AL00001                                        1987
         ST    @15,@AL00001+4                                      1987
         L     @15,@CV01495                                        1987
         LA    @01,@AL00001                                        1987
         BALR  @14,@15                                             1987
*         END;                      /*                       @Z40LB61*/
*                                                                  1988
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE SUM TOTAL OF ACTIVE PAGES ACCUMULATED FOR  @Z40LB61*/
*       /* ALL DEVICES OF THE SDG DOES NOT MATCH THE TOTAL   @Z40LB61*/
*       /* FIELD IN THE PAB, PRINT AN ERROR MESSAGE.         @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1989
*       IF APTOTAL^=PABATOT THEN                                   1989
@RF01982 LH    @15,APTOTAL                                         1989
         L     @01,PABPTR                                          1989
         SLR   @14,@14                                             1989
         ICM   @14,3,PABATOT(@01)                                  1989
         CR    @15,@14                                             1989
         BE    @RF01989                                            1989
*         DO;                       /*                       @Z40LB61*/
*           APCFLD=ON;              /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      1991
         L     @04,MARGPTR(,@05)                                   1991
         OI    APCFLD(@04),B'00000001'                             1991
*           FLDNUM(1)=APTOTAL;      /*                       @Z40LB61*/
         ST    @15,FLDNUM(,@04)                                    1992
*           FLDNUM(2)=PABATOT;      /*                       @Z40LB61*/
         ST    @14,FLDNUM+12(,@04)                                 1993
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @04,@PC00001                                        1994
         ST    @04,@AL00001                                        1994
         ST    @05,@AL00001+4                                      1994
         L     @15,@CV01495                                        1994
         LA    @01,@AL00001                                        1994
         BALR  @14,@15                                             1994
*         END;                      /*                       @Z40LB61*/
*                                                                  1995
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE SUM TOTAL OF INACTIVE PAGES ACCUMULATED FOR        */
*       /*                                                   @Z40LB61*/
*       /* ALL DEVICES OF THE SDG DOES NOT MATCH THE TOTAL   @Z40LB61*/
*       /* FIELD IN THE PAB, PRINT AN ERROR MESSAGE.         @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1996
*       IF IPTOTAL^=PABITOT THEN                                   1996
@RF01989 LH    @15,IPTOTAL                                         1996
         L     @01,PABPTR                                          1996
         SLR   @14,@14                                             1996
         ICM   @14,3,PABITOT(@01)                                  1996
         CR    @15,@14                                             1996
         BE    @RF01996                                            1996
*         DO;                       /*                       @Z40LB61*/
*           IPCFLD=ON;              /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      1998
         L     @04,MARGPTR(,@05)                                   1998
         OI    IPCFLD(@04),B'10000000'                             1998
*           FLDNUM(1)=IPTOTAL;      /*                       @Z40LB61*/
         ST    @15,FLDNUM(,@04)                                    1999
*           FLDNUM(2)=PABITOT;      /*                       @Z40LB61*/
         ST    @14,FLDNUM+12(,@04)                                 2000
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @04,@PC00001                                        2001
         ST    @04,@AL00001                                        2001
         ST    @05,@AL00001+4                                      2001
         L     @15,@CV01495                                        2001
         LA    @01,@AL00001                                        2001
         BALR  @14,@15                                             2001
*         END;                      /*                       @Z40LB61*/
*                                                                  2002
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE SUM TOTAL OF BOUND PAGES ACCUMULATED FOR   @Z40LB61*/
*       /* ALL DEVICES OF THE SDG DOES NOT MATCH THE TOTAL   @Z40LB61*/
*       /* FIELD IN THE PAB, PRINT AN ERROR MESSAGE.         @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2003
*       IF BPTOTAL^=PABBTOT THEN                                   2003
@RF01996 LH    @15,BPTOTAL                                         2003
         L     @01,PABPTR                                          2003
         SLR   @14,@14                                             2003
         ICM   @14,3,PABBTOT(@01)                                  2003
         CR    @15,@14                                             2003
         BE    @RF02003                                            2003
*         DO;                       /*                       @Z40LB61*/
*           BPCFLD=ON;              /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      2005
         L     @04,MARGPTR(,@05)                                   2005
         OI    BPCFLD(@04),B'01000000'                             2005
*           FLDNUM(1)=BPTOTAL;      /*                       @Z40LB61*/
         ST    @15,FLDNUM(,@04)                                    2006
*           FLDNUM(2)=PABBTOT;      /*                       @Z40LB61*/
         ST    @14,FLDNUM+12(,@04)                                 2007
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @04,@PC00001                                        2008
         ST    @04,@AL00001                                        2008
         ST    @05,@AL00001+4                                      2008
         L     @15,@CV01495                                        2008
         LA    @01,@AL00001                                        2008
         BALR  @14,@15                                             2008
*         END;                      /*                       @Z40LB61*/
*                                                                  2009
*       /*************************************************************/
*       /*                                                           */
*       /* THE LRU DELTA VALUES MULTIPLIED BY THE COUNT OF   @Z40LB61*/
*       /* STAGING DEVICES THAT ARE NOT BOUND VOLUMES SHOULD @Z40LB61*/
*       /* MATCH THEIR RESPECTIVE LRU THRESHOLD VALUES.      @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2010
*       IF(LRUDCNT*PABUPDEL)^=PABUPTH THEN                         2010
@RF02003 L     @15,PABPTR                                          2010
         SLR   @14,@14                                             2010
         IC    @14,PABUPDEL(,@15)                                  2010
         MH    @14,LRUDCNT                                         2010
         SLR   @05,@05                                             2010
         ICM   @05,3,PABUPTH(@15)                                  2010
         CR    @14,@05                                             2010
         BE    @RF02010                                            2010
*         DO;                       /*                       @Z40LB61*/
*           LRUDFLD=ON;             /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2012
         L     @04,MARGPTR(,@15)                                   2012
         OI    LRUDFLD(@04),B'01000000'                            2012
*           FLDNUM(1)=LRUDCNT*PABUPDEL;/*                    @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    2013
*           FLDNUM(2)=PABUPTH;      /*                       @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 2014
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        2015
         ST    @14,@AL00001                                        2015
         ST    @15,@AL00001+4                                      2015
         L     @15,@CV01495                                        2015
         LA    @01,@AL00001                                        2015
         BALR  @14,@15                                             2015
*         END;                      /*                       @Z40LB61*/
*       IF(LRUDCNT*PABLODEL)^=PABLOTH THEN                         2017
@RF02010 L     @15,PABPTR                                          2017
         SLR   @14,@14                                             2017
         IC    @14,PABLODEL(,@15)                                  2017
         MH    @14,LRUDCNT                                         2017
         SLR   @05,@05                                             2017
         ICM   @05,3,PABLOTH(@15)                                  2017
         CR    @14,@05                                             2017
         BE    @RF02017                                            2017
*         DO;                       /*                       @Z40LB61*/
*           LRUDFLD=ON;             /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2019
         L     @04,MARGPTR(,@15)                                   2019
         OI    LRUDFLD(@04),B'01000000'                            2019
*           FLDNUM(1)=LRUDCNT*PABLODEL;/*                    @Z40LB61*/
         ST    @14,FLDNUM(,@04)                                    2020
*           FLDNUM(2)=PABLOTH;      /*                       @Z40LB61*/
         ST    @05,FLDNUM+12(,@04)                                 2021
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        2022
         ST    @14,@AL00001                                        2022
         ST    @15,@AL00001+4                                      2022
         L     @15,@CV01495                                        2022
         LA    @01,@AL00001                                        2022
         BALR  @14,@15                                             2022
*         END;                      /*                       @Z40LB61*/
*                                                                  2023
*       /*************************************************************/
*       /*                                                           */
*       /* RESET THE 'IDCCH04' OPTION FLAGS                  @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2024
*       MSGTYPE=''B;                /*                       @Z40LB61*/
@RF02017 L     @15,@PC00001+4                                      2024
         L     @15,MARGPTR(,@15)                                   2024
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         2024
*       TBLTYPE(1)=''B;             /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         2025
*       TBLTYPE(2)=''B;             /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     2026
*     END PABSUMS;                  /*                       @Z40LB61*/
*   END CHKSUMS;                    /*                       @Z40LB61*/
@EL00012 DS    0H                                                  2028
@EF00012 DS    0H                                                  2028
@ER00012 LM    @14,@12,@SA00012                                    2028
         BR    @14                                                 2028
*                                                                  2029
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - RESCAN                                  @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE ROUTES CONTROL TO SUBROUTINES    @Z40LB61*/
*/*            WHICH RESCAN SA AND MSC TABLES TOGETHER WITH  @Z40LB61*/
*/*            THEIR CORRESPONDING CHECK-OFF TABLES TO SEE   @Z40LB61*/
*/*            IF ANY VALID TABLE ENTRIES WERE NOT MATCHED   @Z40LB61*/
*/*            UP WITH MOUNTED VOLUME TABLE ENTRIES.         @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) CHECKMSS REQUEST OPTIONS                      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  2029
*RESCAN:                                                           2029
*   PROCEDURE;                      /*                       @Z40LB61*/
RESCAN   STM   @14,@12,@SA00013                                    2029
*   OLDERID2=NEWERID2;                                             2030
         L     @15,@PC00001                                        2030
         L     @15,GDTTR2(,@15)                                    2030
         MVC   @TS00001(95),NEWERID2(@15)                          2030
         MVC   OLDERID2(95,@15),@TS00001                           2030
*   NEWID2='CH2V';                  /*                       @Z40LB61*/
*                                                                  2031
         MVC   NEWID2(4,@15),@CC01690                              2031
*   /*****************************************************************/
*   /*                                                               */
*   /* IF SA CHECKING WAS REQUESTED, RESCAN SA TABLES IN     @Z40LB61*/
*   /* CONJUNCTION WITH THEIR RESPECTIVE CHECK-OFF TABLES    @Z40LB61*/
*   /* TO CHECK THAT EVERY VALID ENTRY HAS BEEN MATCHED.     @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2032
*   IF SACHK=ON THEN                                               2032
         L     @15,@PC00001+4                                      2032
         TM    SACHK(@15),B'01000000'                              2032
         BNO   @RF02032                                            2032
*     CALL SCANSA;                  /*                       @Z40LB61*/
         BAL   @14,SCANSA                                          2033
*   IF LASTCOND^=0 THEN                                            2034
@RF02032 L     @15,@PC00001+8                                      2034
         ICM   @14,3,LASTCOND(@15)                                 2034
         BNZ   @RT02034                                            2034
*     RETURN;                       /*                       @Z40LB61*/
*                                                                  2035
*   /*****************************************************************/
*   /*                                                               */
*   /* IF MSC CHECKING WAS REQUESTED, RESCAN MSC TABLES IN   @Z40LB61*/
*   /* CONJUNCTION WITH THEIR RESPECTIVE CHECK-OFF TABLES    @Z40LB61*/
*   /* TO CHECK THAT EVERY VALID ENTRY HAS BEEN MATCHED.     @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2036
*   IF MSCCHK=ON THEN                                              2036
         L     @15,@PC00001+4                                      2036
         TM    MSCCHK(@15),B'10000000'                             2036
         BNO   @RF02036                                            2036
*     CALL SCANMSC;                 /*                       @Z40LB61*/
         BAL   @14,SCANMSC                                         2037
*   END RESCAN;                     /*                       @Z40LB61*/
@EL00013 DS    0H                                                  2038
@EF00013 DS    0H                                                  2038
@ER00013 LM    @14,@12,@SA00013                                    2038
         BR    @14                                                 2038
*                                                                  2039
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - SCANSA                                  @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE RESCANS SA TABLES IN CONJUNCTION @Z40LB61*/
*/*            WITH THEIR RESPECTIVE CHECK-OFF TABLES,       @Z40LB61*/
*/*            CHECKING FOR VALID SA TABLE ENTRIES WHICH     @Z40LB61*/
*/*            DID NOT MATCH UP WITH ANY MVT ENTRY.          @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) SA VIRTUAL VOLUME INFORMATION TABLE           @Z40LB61*/
*/*        (2) VVIT CHECK-OFF TABLE                          @Z40LB61*/
*/*        (3) SA VIRTUAL ADDRESS DIRECTORY                  @Z40LB61*/
*/*        (4) VAD CHECK-OFF TABLE                           @Z40LB61*/
*/*        (5) SA PAGE STATUS TABLE                          @Z40LB61*/
*/*        (6) PST CHECK-OFF TABLE                           @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  2039
*SCANSA:                                                           2039
*   PROCEDURE;                      /*                       @Z40LB61*/
SCANSA   STM   @14,@12,@SA00014                                    2039
*   OLDERID2=NEWERID2;                                             2040
         L     @15,@PC00001                                        2040
         L     @15,GDTTR2(,@15)                                    2040
         MVC   @TS00001(95),NEWERID2(@15)                          2040
         MVC   OLDERID2(95,@15),@TS00001                           2040
*   NEWID2='CH2W';                  /*                       @Z40LB61*/
*                                                                  2041
         MVC   NEWID2(4,@15),@CC01696                              2041
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM RESCANNING OF SA TABLES AND THEIR CHECK-OFF   @Z40LB61*/
*   /* TABLES FOR EACH VALID SA                              @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2042
*SALOOP3:                                                          2042
*   DO SA#=1 TO SAMAX;              /*                       @Z40LB61*/
SALOOP3  LA    @15,1                                               2042
         STH   @15,SA#                                             2042
@DL02042 DS    0H                                                  2043
*     IF IVVITPTR(SA#)^=NULLPTR&    /*                       @ZA27324*/
*         IVVITPTR(SA#)^=DUMMYPTR THEN/*                     @ZA27324*/
         SLA   @15,2                                               2043
         L     @14,@PC00001+4                                      2043
         L     @15,IVVITPTR-4(@15,@14)                             2043
         LTR   @15,@15                                             2043
         BZ    @RF02043                                            2043
         C     @15,DUMMYPTR                                        2043
         BE    @RF02043                                            2043
*VALIDSA:                                                          2044
*       DO;                         /*                       @ZA27324*/
VALIDSA  DS    0H                                                  2045
*         SAINDEX(2)=SA#-1;         /*                       @Z40LB61*/
*                                                                  2045
         L     @15,@PC00001+4                                      2045
         L     @01,MARGPTR(,@15)                                   2045
         LH    @00,SA#                                             2045
         BCTR  @00,0                                               2045
         STC   @00,SAINDEX+24(,@01)                                2045
*         /***********************************************************/
*         /*                                                         */
*         /* RESCAN THE ENTRIES FOR EACH VVA OF THE VVIT     @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  2046
*SCANVVIT:                                                         2046
*         DO VVA#=LOWVVA TO HIGHVVA;/*                       @Z40LB61*/
*                                                                  2046
SCANVVIT LA    @15,64                                              2046
         STH   @15,VVA#                                            2046
@DL02046 DS    0H                                                  2047
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP INDICES TO THE CURRENT VVIT ENTRY AND  @Z40LB61*/
*           /* CORRESPONDING BIT OF THE CHECK-OFF TABLE      @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  2047
*           WORKVVA=VVA#-LOWVVA+1;  /*                       @Z40LB61*/
         LH    @14,@CH01729                                        2047
         ALR   @14,@15                                             2047
         STH   @14,WORKVVA                                         2047
*           BYTE#=(WORKVVA-1)/8+1;  /*                       @Z40LB61*/
         L     @05,@PC00001+4                                      2048
         L     @04,EARGPTR(,@05)                                   2048
         LA    @03,1                                               2048
         LR    @02,@14                                             2048
         BCTR  @02,0                                               2048
         LR    @00,@02                                             2048
         SRDA  @00,32                                              2048
         D     @00,@CF00183                                        2048
         ALR   @01,@03                                             2048
         STH   @01,BYTE#(,@04)                                     2048
*           BIT#=(WORKVVA-1)//8+1;  /*                       @Z40LB61*/
*                                                                  2049
         ST    @03,@TF00001                                        2049
         SRDA  @02,32                                              2049
         D     @02,@CF00183                                        2049
         AL    @02,@TF00001                                        2049
         STH   @02,BIT#(,@04)                                      2049
*           /*********************************************************/
*           /*                                                       */
*           /* IF THE VVIT ENTRY IS VALID BUT THE CHECK-OFF  @Z40LB61*/
*           /* BIT IS OFF, PRINT AN ERROR MESSAGE.           @Z40LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  2050
*           WORKVAL1=VVICHKFF(BYTE#)&BITMASK(BIT#);/*        @Z40LB61*/
         LH    @03,SA#                                             2050
         SLA   @03,2                                               2050
         L     @04,VVICOPTR-4(@03,@05)                             2050
         AL    @04,@CF01340                                        2050
         SLR   @00,@00                                             2050
         IC    @00,VVICHKFF(@01,@04)                               2050
         SLR   @01,@01                                             2050
         IC    @01,BITMASK-1(@02)                                  2050
         NR    @00,@01                                             2050
         STH   @00,WORKVAL1                                        2050
*           IF IVVIT(WORKVVA)^='0000'X&WORKVAL1=0 THEN             2051
         ALR   @14,@14                                             2051
         L     @01,IVVITPTR-4(@03,@05)                             2051
         ALR   @01,@14                                             2051
         AL    @01,@CF01760                                        2051
         CLC   IVVIT(2,@01),@CB01703                               2051
         BE    @RF02051                                            2051
         LTR   @00,@00                                             2051
         BNZ   @RF02051                                            2051
*             DO;                   /*                       @Z40LB61*/
*               MTCHMSG=ON;         /*                       @Z40LB61*/
         L     @14,MARGPTR(,@05)                                   2053
         OI    MTCHMSG(@14),B'00010000'                            2053
*               MVTTBL(1)=ON;       /*                       @Z40LB61*/
         OI    MVTTBL(@14),B'10000000'                             2054
*               VVITTBL(2)=ON;      /*                       @Z40LB61*/
         OI    VVITTBL+4(@14),B'00100000'                          2055
*               VVAFLD=ON;          /*                       @Z40LB61*/
         OI    VVAFLD(@14),B'01000000'                             2056
*               FLDNUM(1)=VVA#;     /*                       @Z40LB61*/
         ST    @15,FLDNUM(,@14)                                    2057
*               VVAINDEX(2)=VVA#;   /*                       @Z40LB61*/
         STC   @15,VVAINDEX+24(,@14)                               2058
*               CALL IDCCH04(GDTTBL,CDALIST);/*              @Z40LB61*/
         L     @04,@PC00001                                        2059
         ST    @04,@AL00001                                        2059
         ST    @05,@AL00001+4                                      2059
         L     @15,@CV01495                                        2059
         LA    @01,@AL00001                                        2059
         BALR  @14,@15                                             2059
*             END;                  /*                       @Z40LB61*/
*         END SCANVVIT;             /*                       @Z40LB61*/
*                                                                  2061
@RF02051 LA    @15,1                                               2061
         AH    @15,VVA#                                            2061
         STH   @15,VVA#                                            2061
         CH    @15,@CH01333                                        2061
         BNH   @DL02046                                            2061
*         /***********************************************************/
*         /*                                                         */
*         /* RESCAN THE ENTRIES FOR EACH INTERFACE AND VUA   @Z40LB61*/
*         /* WITHIN INTERFACE OF THE VAD                     @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  2062
*SCANVAD:                                                          2062
*         DO INTF#=1 TO INTFSSA;    /*                       @Z40LB61*/
SCANVAD  LA    @15,1                                               2062
         STH   @15,INTF#                                           2062
@DL02062 DS    0H                                                  2063
*           DO WORKVUA=1 TO HIGHVUA+1;/*                     @Z40LB61*/
*                                                                  2063
         LA    @15,1                                               2063
         STH   @15,WORKVUA                                         2063
@DL02063 DS    0H                                                  2064
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE VAD ENTRY IS VALID BUT THE CHECK-    @Z40LB61*/
*             /* OFF BIT IS OFF, PRINT AN ERROR MESSAGE.     @Z40LB61*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  2064
*             BYTE#=(WORKVUA-1)/8+1;/*                       @Z40LB61*/
         L     @14,@PC00001+4                                      2064
         L     @05,EARGPTR(,@14)                                   2064
         LA    @04,1                                               2064
         LR    @03,@15                                             2064
         BCTR  @03,0                                               2064
         LR    @00,@03                                             2064
         SRDA  @00,32                                              2064
         D     @00,@CF00183                                        2064
         ALR   @01,@04                                             2064
         STH   @01,BYTE#(,@05)                                     2064
*             BIT#=(WORKVUA-1)//8+1;/*                       @Z40LB61*/
         LR    @14,@03                                             2065
         SRDA  @14,32                                              2065
         D     @14,@CF00183                                        2065
         ALR   @14,@04                                             2065
         STH   @14,BIT#(,@05)                                      2065
*             WORKVAL1=VADCHKFF(INTF#,BYTE#)&BITMASK(BIT#);/*      2066
*                                                            @Z40LB61*/
         LH    @15,INTF#                                           2066
         LR    @02,@15                                             2066
         SLA   @02,3                                               2066
         ALR   @02,@01                                             2066
         LH    @05,SA#                                             2066
         SLA   @05,2                                               2066
         L     @04,@PC00001+4                                      2066
         L     @01,VADCOPTR-4(@05,@04)                             2066
         AL    @01,@CF01763                                        2066
         SLR   @00,@00                                             2066
         IC    @00,VADCHKFF(@02,@01)                               2066
         SLR   @01,@01                                             2066
         IC    @01,BITMASK-1(@14)                                  2066
         NR    @00,@01                                             2066
         STH   @00,WORKVAL1                                        2066
*             IF IVADVVA(INTF#,WORKVUA)>=LOWVVA&WORKVAL1=0 THEN    2067
         LH    @02,WORKVUA                                         2067
         LR    @14,@15                                             2067
         SLA   @14,6                                               2067
         ALR   @14,@02                                             2067
         ALR   @14,@14                                             2067
         AL    @05,@CF01761                                        2067
         L     @01,IVADPTR(@05,@04)                                2067
         AL    @01,@CF01771                                        2067
         SLR   @02,@02                                             2067
         IC    @02,IVADVVA(@14,@01)                                2067
         CH    @02,@CH00580                                        2067
         BL    @RF02067                                            2067
         LTR   @00,@00                                             2067
         BNZ   @RF02067                                            2067
*               DO;                 /*                       @Z40LB61*/
*                 MTCHMSG=ON;       /*                       @Z40LB61*/
         L     @02,MARGPTR(,@04)                                   2069
         OI    MTCHMSG(@02),B'00010000'                            2069
*                 MVTTBL(1)=ON;     /*                       @Z40LB61*/
         OI    MVTTBL(@02),B'10000000'                             2070
*                 VADTBL(2)=ON;     /*                       @Z40LB61*/
         OI    VADTBL+4(@02),B'00000001'                           2071
*                 VUAFLD=ON;        /*                       @Z40LB61*/
         OI    VUAFLD(@02),B'00010000'                             2072
*                 FLDNUM(1)=WORKVUA-1;/*                     @Z40LB61*/
         ST    @03,FLDNUM(,@02)                                    2073
*                 VUAINDEX(2)=WORKVUA-1;/*                   @Z40LB61*/
         STC   @03,VUAINDEX+24(,@02)                               2074
*                 INFINDEX(2)=INTF#;/*                       @Z40LB61*/
         STC   @15,INFINDEX+24(,@02)                               2075
*                 CALL IDCCH04(GDTTBL,CDALIST);/*            @Z40LB61*/
         L     @05,@PC00001                                        2076
         ST    @05,@AL00001                                        2076
         ST    @04,@AL00001+4                                      2076
         L     @15,@CV01495                                        2076
         LA    @01,@AL00001                                        2076
         BALR  @14,@15                                             2076
*               END;                /*                       @Z40LB61*/
*           END;                    /*                       @Z40LB61*/
@RF02067 LA    @15,1                                               2078
         AH    @15,WORKVUA                                         2078
         STH   @15,WORKVUA                                         2078
         CH    @15,@CH00580                                        2078
         BNH   @DL02063                                            2078
*         END SCANVAD;              /*                       @Z40LB61*/
*                                                                  2079
         LA    @15,1                                               2079
         AH    @15,INTF#                                           2079
         STH   @15,INTF#                                           2079
         CH    @15,@CH00166                                        2079
         BNH   @DL02062                                            2079
*         /***********************************************************/
*         /*                                                         */
*         /* RESCAN THE ENTRIES FOR EACH LOGICAL UNIT        @Z40LB61*/
*         /* ADDRESS AND REAL PAGE WITHIN LUA OF THE PST     @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  2080
*SCANPST:                                                          2080
*         DO L3333#=1 TO L3333SSA;  /*                       @Z40LB61*/
SCANPST  LA    @15,1                                               2080
         STH   @15,L3333#                                          2080
@DL02080 DS    0H                                                  2081
*           DO DEV#=1 TO DEVSSDG;   /*                       @Z40LB61*/
         LA    @15,1                                               2081
         STH   @15,DEV#                                            2081
@DL02081 DS    0H                                                  2082
*             DO WORKRP=2 TO RPMAX; /*                       @Z40LB61*/
*                                                                  2082
         LA    @15,2                                               2082
         STH   @15,WORKRP                                          2082
@DL02082 DS    0H                                                  2083
*               /*****************************************************/
*               /*                                                   */
*               /* IF THE PST ENTRY IS VALID BUT THE CHECK-  @Z40LB61*/
*               /* OFF BIT IS OFF, PRINT AN ERROR MESSAGE.   @Z40LB61*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  2083
*               BYTE#=(WORKRP-1)/8+1;/*                      @Z40LB61*/
         L     @14,@PC00001+4                                      2083
         L     @05,EARGPTR(,@14)                                   2083
         LA    @04,1                                               2083
         LR    @03,@15                                             2083
         BCTR  @03,0                                               2083
         LR    @00,@03                                             2083
         SRDA  @00,32                                              2083
         D     @00,@CF00183                                        2083
         ALR   @01,@04                                             2083
         STH   @01,BYTE#(,@05)                                     2083
*               BIT#=(WORKRP-1)//8+1;/*                      @Z40LB61*/
         LR    @14,@03                                             2084
         SRDA  @14,32                                              2084
         D     @14,@CF00183                                        2084
         ALR   @14,@04                                             2084
         STH   @14,BIT#(,@05)                                      2084
*               WORKVAL1=PSTCHKFF(L3333#,DEV#,BYTE#)&BITMASK(BIT#);/*
*                                                            @Z40LB61*/
         LH    @15,DEV#                                            2085
         LH    @02,L3333#                                          2085
         LR    @05,@02                                             2085
         SLA   @05,3                                               2085
         ALR   @05,@15                                             2085
         LR    @04,@05                                             2085
         MH    @04,@CH00769                                        2085
         ALR   @04,@01                                             2085
         LH    @01,SA#                                             2085
         SLA   @01,2                                               2085
         L     @00,@PC00001+4                                      2085
         LR    @15,@00                                             2085
         L     @15,PSTCOPTR-4(@01,@15)                             2085
         AL    @15,@CF01767                                        2085
         SLR   @02,@02                                             2085
         IC    @02,PSTCHKFF(@04,@15)                               2085
         SLR   @15,@15                                             2085
         IC    @15,BITMASK-1(@14)                                  2085
         NR    @02,@15                                             2085
         STH   @02,WORKVAL1                                        2085
*               IF IPSTVVA(L3333#,DEV#,WORKRP)>=LOWVVA&WORKVAL1=0 THEN
         LH    @04,WORKRP                                          2086
         MH    @05,@CH00684                                        2086
         ALR   @05,@04                                             2086
         ALR   @05,@05                                             2086
         LR    @04,@00                                             2086
         L     @04,IPSTPTR-4(@01,@04)                              2086
         AL    @04,@CF01768                                        2086
         SLR   @01,@01                                             2086
         IC    @01,IPSTVVA(@05,@04)                                2086
         CH    @01,@CH00580                                        2086
         BL    @RF02086                                            2086
         LTR   @02,@02                                             2086
         BNZ   @RF02086                                            2086
*                 DO;               /*                       @Z40LB61*/
*                   MTCHMSG=ON;     /*                       @Z40LB61*/
         LR    @01,@00                                             2088
         L     @02,MARGPTR(,@01)                                   2088
         OI    MTCHMSG(@02),B'00010000'                            2088
*                   MVTTBL(1)=ON;   /*                       @Z40LB61*/
         OI    MVTTBL(@02),B'10000000'                             2089
*                   PSTTBL(2)=ON;   /*                       @Z40LB61*/
         OI    PSTTBL+4(@02),B'10000000'                           2090
*                   RPFLD=ON;       /*                       @Z40LB61*/
         OI    RPFLD(@02),B'00100000'                              2091
*                   FLDNUM(1)=WORKRP-1;/*                    @Z40LB61*/
         ST    @03,FLDNUM(,@02)                                    2092
*                   LUAINDEX(2)=DEV#+(L3333#-1)*DEVSSDG-1;/* @Z40LB61*/
         LH    @01,DEV#                                            2093
         LH    @15,L3333#                                          2093
         BCTR  @15,0                                               2093
         SLA   @15,3                                               2093
         ALR   @01,@15                                             2093
         BCTR  @01,0                                               2093
         STC   @01,LUAINDEX+24(,@02)                               2093
*                   RPINDEX(2)=WORKRP-1;/*                   @Z40LB61*/
         STC   @03,RPINDEX+24(,@02)                                2094
*                   CALL IDCCH04(GDTTBL,CDALIST);/*          @Z40LB61*/
         L     @01,@PC00001                                        2095
         ST    @01,@AL00001                                        2095
         LR    @01,@00                                             2095
         ST    @01,@AL00001+4                                      2095
         L     @15,@CV01495                                        2095
         LA    @01,@AL00001                                        2095
         BALR  @14,@15                                             2095
*                 END;              /*                       @Z40LB61*/
*             END;                  /*                       @Z40LB61*/
@RF02086 LA    @15,1                                               2097
         AH    @15,WORKRP                                          2097
         STH   @15,WORKRP                                          2097
         CH    @15,@CH00684                                        2097
         BNH   @DL02082                                            2097
*           END;                    /*                       @Z40LB61*/
         LA    @15,1                                               2098
         AH    @15,DEV#                                            2098
         STH   @15,DEV#                                            2098
         CH    @15,@CH00183                                        2098
         BNH   @DL02081                                            2098
*         END SCANPST;              /*                       @Z40LB61*/
         LA    @15,1                                               2099
         AH    @15,L3333#                                          2099
         STH   @15,L3333#                                          2099
         CH    @15,@CH00157                                        2099
         BNH   @DL02080                                            2099
*       END VALIDSA;                /*                       @Z40LB61*/
*   END SALOOP3;                    /*                       @Z40LB61*/
@RF02043 LA    @15,1                                               2101
         AH    @15,SA#                                             2101
         STH   @15,SA#                                             2101
         CH    @15,@CH00478                                        2101
         BNH   @DL02042                                            2101
*   END SCANSA;                     /*                       @Z40LB61*/
@EL00014 DS    0H                                                  2102
@EF00014 DS    0H                                                  2102
@ER00014 LM    @14,@12,@SA00014                                    2102
         BR    @14                                                 2102
*                                                                  2103
*/********************************************************************/
*/*                                                          @Z40LB61*/
*/* PROCEDURE NAME - SCANMSC                                 @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* FUNCTION - THIS ROUTINE SCANS MSC TABLES IN CONJUNCTION  @Z40LB61*/
*/*            WITH THEIR RESPECTIVE CHECK-OFF TABLES,       @Z40LB61*/
*/*            CHECKING FOR VALID MSC TABLE ENTRIES WHICH    @Z40LB61*/
*/*            DID NOT MATCH UP WITH ANY MVT ENTRY.          @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* INPUT -                                                  @Z40LB61*/
*/*        (1) MSC SDG DEMOUNTED VOLUME BLOCKS               @Z40LB61*/
*/*        (2) MSC SDG DVB CHECK-OFF TABLE                   @Z40LB61*/
*/*        (3) MSC SDG LRU PAGES BLOCKS                      @Z40LB61*/
*/*        (4) MSC SDG LPB CHECK-OFF TABLE                   @Z40LB61*/
*/*        (5) MSC VIRTUAL VOLUME ADDRESS TABLE              @Z40LB61*/
*/*        (6) MSC VVAT CHECK-OFF TABLE                      @Z40LB61*/
*/*        (7) MSC VVA/MVT CROSS REFERENCE TABLE             @Z40LB61*/
*/*        (8) MSC VVA/MVT XREF CHECK-OFF TABLE              @Z40LB61*/
*/*        (9) MSC CONFIGURATION DATA BLOCKS                 @Z40LB61*/
*/*        (10) MSC CDB CHECK-OFF TABLE                      @Z40LB61*/
*/*                                                          @Z40LB61*/
*/* OUTPUT -                                                 @Z40LB61*/
*/*        (1) ERROR MESSAGES DESCRIBING ANY INCONSISTENCIES @Z40LB61*/
*/*        (2) FUNCTION CONDITION CODE                       @Z40LB61*/
*/*                                                          @Z40LB61*/
*/********************************************************************/
*                                                                  2103
*SCANMSC:                                                          2103
*   PROCEDURE;                      /*                       @Z40LB61*/
SCANMSC  STM   @14,@12,@SA00015                                    2103
*   OLDERID2=NEWERID2;                                             2104
         L     @15,@PC00001                                        2104
         L     @15,GDTTR2(,@15)                                    2104
         MVC   @TS00001(95),NEWERID2(@15)                          2104
         MVC   OLDERID2(95,@15),@TS00001                           2104
*   NEWID2='CH2X';                  /*                       @Z40LB61*/
*                                                                  2105
         MVC   NEWID2(4,@15),@CC01546                              2105
*   /*****************************************************************/
*   /*                                                               */
*   /* DO COMMON SET-UP FOR POSSIBLE ERROR MESSAGES          @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2106
*   MTCHMSG=ON;                     /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2106
         L     @15,MARGPTR(,@15)                                   2106
         OI    MTCHMSG(@15),B'00010000'                            2106
*   MVTTBL(1)=ON;                   /*                       @Z40LB61*/
         OI    MVTTBL(@15),B'10000000'                             2107
*   MSGNRSET=ON;                    /*                       @Z40LB61*/
         OI    MSGNRSET(@15),B'00000001'                           2108
*   TBLNRSET(1)=ON;                 /*                       @Z40LB61*/
*                                                                  2109
         OI    TBLNRSET(@15),B'00000001'                           2109
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM RESCANNING OF MSC TABLES ORGANIZED BY SDG     @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2110
*SCANSDG:                                                          2110
*   DO SDG#=1 TO SDGMAX;            /*                       @Z40LB61*/
SCANSDG  LA    @15,1                                               2110
         STH   @15,SDG#                                            2110
@DL02110 DS    0H                                                  2111
*     SDGINDEX(2)=SDG#-1;           /*                       @Z40LB61*/
*                                                                  2111
         L     @14,@PC00001+4                                      2111
         L     @01,MARGPTR(,@14)                                   2111
         BCTR  @15,0                                               2111
         STC   @15,SDGINDEX+24(,@01)                               2111
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN THE LPB FOR THE CURRENT SDG                  @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2112
*     TABLEID=SDGTBLID;             /*                       @Z40LB61*/
         L     @05,EARGPTR(,@14)                                   2112
         MVC   TABLEID(1,@05),SDGTBLID                             2112
*     LPBFLAG=ON;                   /*                       @Z40LB61*/
         OI    LPBFLAG(@05),B'00010000'                            2113
*     SDGNUM=SDG#-1;                /*                       @Z40LB61*/
         STH   @15,SDGNUM(,@05)                                    2114
*     CALL IDCCH03(GDTTBL,CDALIST); /*                       @Z40LB61*/
         L     @15,@PC00001                                        2115
         ST    @15,@AL00001                                        2115
         ST    @14,@AL00001+4                                      2115
         L     @15,@CV01494                                        2115
         LA    @01,@AL00001                                        2115
         BALR  @14,@15                                             2115
*     IF GETRC^=0 THEN                                             2116
         L     @15,@PC00001+4                                      2116
         L     @01,EARGPTR(,@15)                                   2116
         ICM   @00,3,GETRC(@01)                                    2116
         BZ    @RF02116                                            2116
*       DO;                         /*                       @Z40LB61*/
*         LASTCOND=LASTCC12;        /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      2118
         MVC   LASTCOND(2,@15),@CH00567                            2118
*         RETURN;                   /*                       @Z40LB61*/
@EL00015 DS    0H                                                  2119
@EF00015 DS    0H                                                  2119
@ER00015 LM    @14,@12,@SA00015                                    2119
         BR    @14                                                 2119
*       END;                        /*                       @Z40LB61*/
*     LPBPTR=TBLADDR;               /*                       @Z40LB61*/
*                                                                  2121
@RF02116 L     @15,@PC00001+4                                      2121
         L     @01,EARGPTR(,@15)                                   2121
         MVC   LPBPTR(4),TBLADDR(@01)                              2121
*     /***************************************************************/
*     /*                                                             */
*     /* RESCAN THE LPB CHECK-OFF TABLE, CHECKING AS MANY    @Z40LB61*/
*     /* BITS AS THERE ARE VALID LPB ENTRIES. IF ANY OF      @Z40LB61*/
*     /* THE BITS ARE OFF, PRINT AN ERROR MESSAGE.           @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2122
*SCANLPB:                                                          2122
*     DO ENTRY#=1 TO DVLPMAX WHILE((ENTRY#*LENGTH(LPBMVT)<=LPBNEXT-4)
*                                   /*                       @ZA16115*/
*           |LPBNEXT=0);            /*                       @ZA16115*/
SCANLPB  LA    @15,1                                               2122
         STH   @15,ENTRY#                                          2122
@DL02122 ALR   @15,@15                                             2122
         L     @14,LPBPTR                                          2122
         SLR   @05,@05                                             2122
         IC    @05,LPBNEXT(,@14)                                   2122
         SH    @05,@CH00046                                        2122
         CR    @15,@05                                             2122
         BNH   @DB02122                                            2122
         CLI   LPBNEXT(@14),0                                      2122
         BNE   @DC02122                                            2122
@DB02122 DS    0H                                                  2123
*       BYTE#=(ENTRY#-1)/8+1;       /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2123
         L     @14,EARGPTR(,@15)                                   2123
         LA    @05,1                                               2123
         LH    @04,ENTRY#                                          2123
         LR    @03,@04                                             2123
         BCTR  @03,0                                               2123
         LR    @00,@03                                             2123
         SRDA  @00,32                                              2123
         D     @00,@CF00183                                        2123
         ALR   @01,@05                                             2123
         STH   @01,BYTE#(,@14)                                     2123
*       BIT#=(ENTRY#-1)//8+1;       /*                       @Z40LB61*/
         LR    @00,@03                                             2124
         ST    @01,@TF00001                                        2124
         SRDA  @00,32                                              2124
         D     @00,@CF00183                                        2124
         ALR   @00,@05                                             2124
         STH   @00,BIT#(,@14)                                      2124
*       IF(LPBCHKFF(SDG#,BYTE#)&BITMASK(BIT#))=0 THEN              2125
         LH    @01,SDG#                                            2125
         SLA   @01,4                                               2125
         AL    @01,@TF00001                                        2125
         L     @05,LPBCOPTR(,@15)                                  2125
         AL    @05,@CF01770                                        2125
         SLR   @03,@03                                             2125
         IC    @03,LPBCHKFF(@01,@05)                               2125
         LR    @02,@00                                             2125
         SLR   @05,@05                                             2125
         IC    @05,BITMASK-1(@02)                                  2125
         NR    @03,@05                                             2125
         LTR   @03,@03                                             2125
         BNZ   @RF02125                                            2125
*         DO;                       /*                       @Z40LB61*/
*           LPBTBL(2)=ON;           /*                       @Z40LB61*/
         L     @05,MARGPTR(,@15)                                   2127
         OI    LPBTBL+4(@05),B'00000100'                           2127
*           MVTPFLD=ON;             /*                       @Z40LB61*/
         OI    MVTPFLD(@05),B'00100000'                            2128
*           FLDNUM(1)=LPBMVT(ENTRY#)&MASK8191;/*             @Z40LB61*/
         ALR   @04,@04                                             2129
         SLR   @03,@03                                             2129
         ICM   @03,3,MASK8191                                      2129
         L     @02,LPBPTR                                          2129
         ALR   @02,@04                                             2129
         SLR   @04,@04                                             2129
         ICM   @04,3,LPBMVT-2(@02)                                 2129
         NR    @03,@04                                             2129
         ST    @03,FLDNUM(,@05)                                    2129
*           CHRINDEX(2)=PREVCHR;    /*                       @Z40LB61*/
         MVC   CHRINDEX+24(5,@05),PREVCHR(@14)                     2130
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        2131
         ST    @14,@AL00001                                        2131
         ST    @15,@AL00001+4                                      2131
         L     @15,@CV01495                                        2131
         LA    @01,@AL00001                                        2131
         BALR  @14,@15                                             2131
*         END;                      /*                       @Z40LB61*/
*     END SCANLPB;                  /*                       @Z40LB61*/
*                                                                  2133
@RF02125 LA    @15,1                                               2133
         AH    @15,ENTRY#                                          2133
         STH   @15,ENTRY#                                          2133
         CH    @15,@CH00753                                        2133
         BNH   @DL02122                                            2133
@DC02122 DS    0H                                                  2134
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN THE DVB FOR THE CURRENT SDG                  @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2134
*     TABLEID=SDGTBLID;             /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2134
         L     @14,EARGPTR(,@15)                                   2134
         MVC   TABLEID(1,@14),SDGTBLID                             2134
*     DVBFLAG=ON;                   /*                       @Z40LB61*/
         OI    DVBFLAG(@14),B'00100000'                            2135
*     CALL IDCCH03(GDTTBL,CDALIST); /*                       @Z40LB61*/
         L     @14,@PC00001                                        2136
         ST    @14,@AL00001                                        2136
         ST    @15,@AL00001+4                                      2136
         L     @15,@CV01494                                        2136
         LA    @01,@AL00001                                        2136
         BALR  @14,@15                                             2136
*     IF GETRC^=0 THEN                                             2137
         L     @15,@PC00001+4                                      2137
         L     @01,EARGPTR(,@15)                                   2137
         ICM   @00,3,GETRC(@01)                                    2137
         BZ    @RF02137                                            2137
*       DO;                         /*                       @Z40LB61*/
*         LASTCOND=LASTCC12;        /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      2139
         MVC   LASTCOND(2,@15),@CH00567                            2139
*         RETURN;                   /*                       @Z40LB61*/
         B     @EL00015                                            2140
*       END;                        /*                       @Z40LB61*/
*     DVBPTR=TBLADDR;               /*                       @Z40LB61*/
*                                                                  2142
@RF02137 L     @15,@PC00001+4                                      2142
         L     @01,EARGPTR(,@15)                                   2142
         MVC   DVBPTR(4),TBLADDR(@01)                              2142
*     /***************************************************************/
*     /*                                                             */
*     /* RESCAN THE DVB CHECK-OFF TABLE, CHECKING AS MANY    @Z40LB61*/
*     /* BITS AS THERE WERE VALID DVB ENTRIES. IF ANY OF     @Z40LB61*/
*     /* THE BITS ARE OFF, PRINT AN ERROR MESSAGE.           @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2143
*SCANDVB:                                                          2143
*     DO ENTRY#=1 TO DVLPMAX WHILE((ENTRY#*LENGTH(DVBMVT)<=DVBNEXT-4)
*                                   /*                       @ZA16115*/
*           |DVBNEXT=0);            /*                       @ZA16115*/
SCANDVB  LA    @15,1                                               2143
         STH   @15,ENTRY#                                          2143
@DL02143 ALR   @15,@15                                             2143
         L     @14,DVBPTR                                          2143
         SLR   @05,@05                                             2143
         IC    @05,DVBNEXT(,@14)                                   2143
         SH    @05,@CH00046                                        2143
         CR    @15,@05                                             2143
         BNH   @DB02143                                            2143
         CLI   DVBNEXT(@14),0                                      2143
         BNE   @DC02143                                            2143
@DB02143 DS    0H                                                  2144
*       BYTE#=(ENTRY#-1)/8+1;       /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2144
         L     @14,EARGPTR(,@15)                                   2144
         LA    @05,1                                               2144
         LH    @04,ENTRY#                                          2144
         LR    @03,@04                                             2144
         BCTR  @03,0                                               2144
         LR    @00,@03                                             2144
         SRDA  @00,32                                              2144
         D     @00,@CF00183                                        2144
         ALR   @01,@05                                             2144
         STH   @01,BYTE#(,@14)                                     2144
*       BIT#=(ENTRY#-1)//8+1;       /*                       @Z40LB61*/
         LR    @00,@03                                             2145
         ST    @01,@TF00001                                        2145
         SRDA  @00,32                                              2145
         D     @00,@CF00183                                        2145
         ALR   @00,@05                                             2145
         STH   @00,BIT#(,@14)                                      2145
*       IF(DVBCHKFF(SDG#,BYTE#)&BITMASK(BIT#))=0 THEN              2146
         LH    @01,SDG#                                            2146
         SLA   @01,4                                               2146
         AL    @01,@TF00001                                        2146
         L     @05,DVBCOPTR(,@15)                                  2146
         AL    @05,@CF01770                                        2146
         SLR   @03,@03                                             2146
         IC    @03,DVBCHKFF(@01,@05)                               2146
         LR    @02,@00                                             2146
         SLR   @05,@05                                             2146
         IC    @05,BITMASK-1(@02)                                  2146
         NR    @03,@05                                             2146
         LTR   @03,@03                                             2146
         BNZ   @RF02146                                            2146
*         DO;                       /*                       @Z40LB61*/
*           DVBTBL(2)=ON;           /*                       @Z40LB61*/
         L     @05,MARGPTR(,@15)                                   2148
         OI    DVBTBL+4(@05),B'00001000'                           2148
*           MVTPFLD=ON;             /*                       @Z40LB61*/
         OI    MVTPFLD(@05),B'00100000'                            2149
*           FLDNUM(1)=DVBMVT(ENTRY#)&MASK8191;/*             @Z40LB61*/
         ALR   @04,@04                                             2150
         SLR   @03,@03                                             2150
         ICM   @03,3,MASK8191                                      2150
         L     @02,DVBPTR                                          2150
         ALR   @02,@04                                             2150
         SLR   @04,@04                                             2150
         ICM   @04,3,DVBMVT-2(@02)                                 2150
         NR    @03,@04                                             2150
         ST    @03,FLDNUM(,@05)                                    2150
*           CHRINDEX(2)=PREVCHR;    /*                       @Z40LB61*/
         MVC   CHRINDEX+24(5,@05),PREVCHR(@14)                     2151
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        2152
         ST    @14,@AL00001                                        2152
         ST    @15,@AL00001+4                                      2152
         L     @15,@CV01495                                        2152
         LA    @01,@AL00001                                        2152
         BALR  @14,@15                                             2152
*         END;                      /*                       @Z40LB61*/
*     END SCANDVB;                  /*                       @Z40LB61*/
@RF02146 LA    @15,1                                               2154
         AH    @15,ENTRY#                                          2154
         STH   @15,ENTRY#                                          2154
         CH    @15,@CH00753                                        2154
         BNH   @DL02143                                            2154
@DC02143 DS    0H                                                  2155
*   END SCANSDG;                    /*                       @Z40LB61*/
*                                                                  2155
         LA    @15,1                                               2155
         AH    @15,SDG#                                            2155
         STH   @15,SDG#                                            2155
         CH    @15,@CH00781                                        2155
         BNH   @DL02110                                            2155
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM RESCANNING OF MSC TABLES ORGANIZED BY SA      @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2156
*SALOOP4:                                                          2156
*   DO SA#=1 TO SAMAX;              /*                       @Z40LB61*/
SALOOP4  LA    @15,1                                               2156
         STH   @15,SA#                                             2156
@DL02156 DS    0H                                                  2157
*     SAINDEX(2)=SA#-1;             /*                       @Z40LB61*/
*                                                                  2157
         L     @14,@PC00001+4                                      2157
         L     @01,MARGPTR(,@14)                                   2157
         BCTR  @15,0                                               2157
         STC   @15,SAINDEX+24(,@01)                                2157
*     /***************************************************************/
*     /*                                                             */
*     /* COMPUTE POINTER TO VVAT SECTION FOR CURRENT SA      @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2158
*     VVATPTR=VVATADDR+(SA#-1)*LENGTH(VVAT);/*               @Z40LB61*/
*                                                                  2158
         SLA   @15,5                                               2158
         AL    @15,VVATADDR(,@14)                                  2158
         ST    @15,VVATPTR                                         2158
*     /***************************************************************/
*     /*                                                             */
*     /* RESCAN THE ENTRIES FOR EACH VVA OF THE VVAT AND     @Z40LB61*/
*     /* VMX TABLES                                          @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2159
*SCANVVAS:                                                         2159
*     DO VVA#=LOWVVA TO HIGHVVA     /*                       @ZA27324*/
*           WHILE VLDSSID(SA#)^=NULLSSID;/*                  @ZA27324*/
*                                                                  2159
SCANVVAS LA    @15,64                                              2159
         STH   @15,VVA#                                            2159
@DL02159 LH    @14,SA#                                             2159
         LR    @05,@14                                             2159
         ALR   @05,@05                                             2159
         L     @04,@PC00001+4                                      2159
         LH    @05,VLDSSID-2(@05,@04)                              2159
         CH    @05,@CH01340                                        2159
         BE    @DC02159                                            2159
*       /*************************************************************/
*       /*                                                           */
*       /* DO COMMON SET-UP OF INDICES TO THE CURRENT VVA    @Z40LB61*/
*       /* AND SET-UP FOR POSSIBLE ERROR MESSAGES.           @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2160
*       WORKVVA=VVA#-LOWVVA+1;      /*                       @Z40LB61*/
         LH    @05,@CH01729                                        2160
         ALR   @05,@15                                             2160
         STH   @05,WORKVVA                                         2160
*       BYTE#=(WORKVVA-1)/8+1;      /*                       @Z40LB61*/
         L     @03,EARGPTR(,@04)                                   2161
         LA    @02,1                                               2161
         BCTR  @05,0                                               2161
         LR    @00,@05                                             2161
         SRDA  @00,32                                              2161
         D     @00,@CF00183                                        2161
         ALR   @01,@02                                             2161
         STH   @01,BYTE#(,@03)                                     2161
*       BIT#=(WORKVVA-1)//8+1;      /*                       @Z40LB61*/
         LR    @14,@05                                             2162
         SRDA  @14,32                                              2162
         D     @14,@CF00183                                        2162
         ALR   @14,@02                                             2162
         STH   @14,BIT#(,@03)                                      2162
*       VVAINDEX(2)=VVA#;           /*                       @Z40LB61*/
         LH    @15,VVA#                                            2163
         L     @05,MARGPTR(,@04)                                   2163
         STC   @15,VVAINDEX+24(,@05)                               2163
*       FLDNUM(1)=VVA#;             /*                       @Z40LB61*/
*                                                                  2164
         ST    @15,FLDNUM(,@05)                                    2164
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE VVAT ENTRY IS VALID BUT THE CHECK-OFF      @Z40LB61*/
*       /* BIT IS OFF, PRINT AN ERROR MESSAGE.               @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2165
*       WORKVAL1=VVATVVA(BYTE#)&BITMASK(BIT#);/*             @Z40LB61*/
         SLR   @15,@15                                             2165
         IC    @15,BITMASK-1(@14)                                  2165
         L     @14,VVATPTR                                         2165
         AL    @14,@CF01340                                        2165
         SLR   @00,@00                                             2165
         IC    @00,VVATVVA(@01,@14)                                2165
         NR    @00,@15                                             2165
         STH   @00,WORKVAL1                                        2165
*       WORKVAL2=VVACHKFF(SA#,BYTE#)&BITMASK(BIT#);/*        @Z40LB61*/
         LH    @14,SA#                                             2166
         LR    @03,@14                                             2166
         MH    @03,@CH00314                                        2166
         ALR   @03,@01                                             2166
         L     @01,VVACOPTR(,@04)                                  2166
         AL    @01,@CF01759                                        2166
         SLR   @02,@02                                             2166
         IC    @02,VVACHKFF(@03,@01)                               2166
         NR    @15,@02                                             2166
         STH   @15,WORKVAL2                                        2166
*       IF WORKVAL1^=0&WORKVAL2=0 THEN                             2167
         SLR   @01,@01                                             2167
         CR    @00,@01                                             2167
         BE    @RF02167                                            2167
         CR    @15,@01                                             2167
         BNE   @RF02167                                            2167
*         DO;                       /*                       @Z40LB61*/
*           VVATTBL(2)=ON;          /*                       @Z40LB61*/
         OI    VVATTBL+4(@05),B'10000000'                          2169
*           VVAFLD=ON;              /*                       @Z40LB61*/
         OI    VVAFLD(@05),B'01000000'                             2170
*           IF SA#>SAMAX/2 THEN                                    2171
         CH    @14,@CH00183                                        2171
         BNH   @RF02171                                            2171
*             CHRINDEX(2)=VVATCHR(2);/*                      @Z40LB61*/
         MVC   CHRINDEX+24(5,@05),VVATCHR+5                        2172
*           ELSE                                                   2173
*             CHRINDEX(2)=VVATCHR(1);/*                      @Z40LB61*/
         B     @RC02171                                            2173
@RF02171 L     @15,@PC00001+4                                      2173
         L     @01,MARGPTR(,@15)                                   2173
         MVC   CHRINDEX+24(5,@01),VVATCHR                          2173
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
@RC02171 L     @15,@PC00001                                        2174
         ST    @15,@AL00001                                        2174
         L     @15,@PC00001+4                                      2174
         ST    @15,@AL00001+4                                      2174
         L     @15,@CV01495                                        2174
         LA    @01,@AL00001                                        2174
         BALR  @14,@15                                             2174
*         END;                      /*                       @Z40LB61*/
*                                                                  2175
*       /*************************************************************/
*       /*                                                           */
*       /* OBTAIN THE VVA/MVT XREF TABLE ENTRY FOR THE       @Z40LB61*/
*       /* CURRENT VVA                                       @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2176
*       TABLEID=VMXTBLID;           /*                       @Z40LB61*/
@RF02167 L     @15,@PC00001+4                                      2176
         L     @14,EARGPTR(,@15)                                   2176
         MVC   TABLEID(1,@14),VMXTBLID                             2176
*       SANUM=SA#-1;                /*                       @Z40LB61*/
         LH    @05,SA#                                             2177
         BCTR  @05,0                                               2177
         STH   @05,SANUM(,@14)                                     2177
*       VVADDR=VVA#;                /*                       @Z40LB61*/
         MVC   VVADDR(2,@14),VVA#                                  2178
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB61*/
         L     @14,@PC00001                                        2179
         ST    @14,@AL00001                                        2179
         ST    @15,@AL00001+4                                      2179
         L     @15,@CV01494                                        2179
         LA    @01,@AL00001                                        2179
         BALR  @14,@15                                             2179
*       IF GETRC^=0 THEN                                           2180
         L     @15,@PC00001+4                                      2180
         L     @01,EARGPTR(,@15)                                   2180
         ICM   @00,3,GETRC(@01)                                    2180
         BZ    @RF02180                                            2180
*         DO;                       /*                       @Z40LB61*/
*           LASTCOND=LASTCC12;      /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      2182
         MVC   LASTCOND(2,@15),@CH00567                            2182
*           RETURN;                 /*                       @Z40LB61*/
         B     @EL00015                                            2183
*         END;                      /*                       @Z40LB61*/
*       VMXPTR=TBLADDR;             /*                       @Z40LB61*/
*                                                                  2185
@RF02180 L     @15,@PC00001+4                                      2185
         L     @14,EARGPTR(,@15)                                   2185
         L     @05,TBLADDR(,@14)                                   2185
         ST    @05,VMXPTR                                          2185
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE VMX ENTRY IS VALID BUT THE CHECK-OFF       @Z40LB61*/
*       /* BIT IS OFF, PRINT AN ERROR MESSAGE.               @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2186
*       WORKVAL1=VMXCHKFF(SA#,BYTE#)&BITMASK(BIT#);/*        @Z40LB61*/
         LH    @04,SA#                                             2186
         MH    @04,@CH00314                                        2186
         AH    @04,BYTE#(,@14)                                     2186
         L     @01,VMXCOPTR(,@15)                                  2186
         LH    @03,BIT#(,@14)                                      2186
         AL    @01,@CF01759                                        2186
         SLR   @00,@00                                             2186
         IC    @00,VMXCHKFF(@04,@01)                               2186
         SLR   @02,@02                                             2186
         IC    @02,BITMASK-1(@03)                                  2186
         NR    @00,@02                                             2186
         STH   @00,WORKVAL1                                        2186
*       IF VMXVALID=ON&WORKVAL1=0 THEN                             2187
         TM    VMXVALID(@05),B'10000000'                           2187
         BNO   @RF02187                                            2187
         LTR   @00,@00                                             2187
         BNZ   @RF02187                                            2187
*         DO;                       /*                       @Z40LB61*/
*           VMXTBL(2)=ON;           /*                       @Z40LB61*/
         L     @05,MARGPTR(,@15)                                   2189
         OI    VMXTBL+4(@05),B'00000001'                           2189
*           VVAFLD=ON;              /*                       @Z40LB61*/
         OI    VVAFLD(@05),B'01000000'                             2190
*           CHRINDEX(2)=PREVCHR;    /*                       @Z40LB61*/
         MVC   CHRINDEX+24(5,@05),PREVCHR(@14)                     2191
*           CALL IDCCH04(GDTTBL,CDALIST);/*                  @Z40LB61*/
         L     @14,@PC00001                                        2192
         ST    @14,@AL00001                                        2192
         ST    @15,@AL00001+4                                      2192
         L     @15,@CV01495                                        2192
         LA    @01,@AL00001                                        2192
         BALR  @14,@15                                             2192
*         END;                      /*                       @Z40LB61*/
*     END SCANVVAS;                 /*                       @Z40LB61*/
*                                                                  2194
@RF02187 LA    @15,1                                               2194
         AH    @15,VVA#                                            2194
         STH   @15,VVA#                                            2194
         CH    @15,@CH01333                                        2194
         BNH   @DL02159                                            2194
@DC02159 DS    0H                                                  2195
*     /***************************************************************/
*     /*                                                             */
*     /* RESCAN THE ENTRIES FOR EACH INTERFACE OF THE CDB    @Z40LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  2195
*SCANCDB:                                                          2195
*     DO INTF#=1 TO INTFSSA         /*                       @ZA27324*/
*           WHILE VLDSSID(SA#)^=NULLSSID;/*                  @ZA27324*/
*                                                                  2195
SCANCDB  LA    @15,1                                               2195
         STH   @15,INTF#                                           2195
@DL02195 LH    @14,SA#                                             2195
         ALR   @14,@14                                             2195
         L     @05,@PC00001+4                                      2195
         LH    @14,VLDSSID-2(@14,@05)                              2195
         CH    @14,@CH01340                                        2195
         BE    @DC02195                                            2195
*       /*************************************************************/
*       /*                                                           */
*       /* OBTAIN THE CDB TABLE BLOCK FOR THE CURRENT SA     @Z40LB61*/
*       /* INTERFACE                                         @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2196
*       BUFFER2=ON;                 /*                       @Z40LB61*/
         L     @14,EARGPTR(,@05)                                   2196
         OI    BUFFER2(@14),B'01000000'                            2196
*       TABLEID=CFGTBLID;           /*                       @Z40LB61*/
         MVC   TABLEID(1,@14),CFGTBLID                             2197
*       CDBFLAG=ON;                 /*                       @Z40LB61*/
         OI    CDBFLAG(@14),B'00000010'                            2198
*       INTFID=INTF#;               /*                       @Z40LB61*/
         STH   @15,INTFID(,@14)                                    2199
*       CALL IDCCH03(GDTTBL,CDALIST);/*                      @Z40LB61*/
         L     @04,@PC00001                                        2200
         ST    @04,@AL00001                                        2200
         ST    @05,@AL00001+4                                      2200
         L     @15,@CV01494                                        2200
         LA    @01,@AL00001                                        2200
         BALR  @14,@15                                             2200
*       IF GETRC^=0 THEN                                           2201
         L     @15,@PC00001+4                                      2201
         L     @01,EARGPTR(,@15)                                   2201
         ICM   @00,3,GETRC(@01)                                    2201
         BZ    @RF02201                                            2201
*         DO;                       /*                       @Z40LB61*/
*           LASTCOND=LASTCC12;      /*                       @Z40LB61*/
         L     @15,@PC00001+8                                      2203
         MVC   LASTCOND(2,@15),@CH00567                            2203
*           RETURN;                 /*                       @Z40LB61*/
         B     @EL00015                                            2204
*         END;                      /*                       @Z40LB61*/
*       CDBPTR=TBLADDR;             /*                       @Z40LB61*/
*                                                                  2206
@RF02201 L     @15,@PC00001+4                                      2206
         L     @01,EARGPTR(,@15)                                   2206
         MVC   CDBPTR(4),TBLADDR(@01)                              2206
*       /*************************************************************/
*       /*                                                           */
*       /* RESCAN THE CDB ENTRY FOR EACH VIRTUAL UNIT ADDR   @Z40LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2207
*       DO WORKVUA=1 TO HIGHVUA+1   /*                       @ZA27324*/
*             WHILE VLDSSID(SA#)^=NULLSSID;/*                @ZA27324*/
*                                                                  2207
         LA    @15,1                                               2207
         STH   @15,WORKVUA                                         2207
@DL02207 LH    @14,SA#                                             2207
         LR    @05,@14                                             2207
         ALR   @05,@05                                             2207
         L     @04,@PC00001+4                                      2207
         LH    @05,VLDSSID-2(@05,@04)                              2207
         CH    @05,@CH01340                                        2207
         BE    @DC02207                                            2207
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE CDB ENTRY IS VALID BUT THE CHECK-OFF     @Z40LB61*/
*         /* BIT IS OFF, PRINT AN ERROR MESSAGE.             @Z40LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  2208
*         BYTE#=(WORKVUA-1)/8+1;    /*                       @Z40LB61*/
         L     @05,EARGPTR(,@04)                                   2208
         LA    @03,1                                               2208
         LR    @02,@15                                             2208
         BCTR  @02,0                                               2208
         LR    @00,@02                                             2208
         SRDA  @00,32                                              2208
         D     @00,@CF00183                                        2208
         ALR   @01,@03                                             2208
         STH   @01,BYTE#(,@05)                                     2208
*         BIT#=(WORKVUA-1)//8+1;    /*                       @Z40LB61*/
         LR    @14,@02                                             2209
         SRDA  @14,32                                              2209
         D     @14,@CF00183                                        2209
         ALR   @14,@03                                             2209
         STH   @14,BIT#(,@05)                                      2209
*         WORKVAL1=CDBCHKFF(SA#,INTF#,BYTE#)&BITMASK(BIT#);/*      2210
*                                                            @Z40LB61*/
         LH    @15,INTF#                                           2210
         LH    @03,SA#                                             2210
         MH    @03,@CH00166                                        2210
         ALR   @03,@15                                             2210
         SLA   @03,3                                               2210
         ALR   @03,@01                                             2210
         L     @01,CDBCOPTR(,@04)                                  2210
         AL    @01,@CF01765                                        2210
         SLR   @00,@00                                             2210
         IC    @00,CDBCHKFF(@03,@01)                               2210
         SLR   @01,@01                                             2210
         IC    @01,BITMASK-1(@14)                                  2210
         NR    @00,@01                                             2210
         STH   @00,WORKVAL1                                        2210
*         IF CDBCNFIG(WORKVUA)^='FF'X&CDBINUSE(WORKVUA)=ON&WORKVAL1=0
*           THEN                                                   2211
         L     @03,CDBPTR                                          2211
         LH    @14,WORKVUA                                         2211
         SLA   @14,2                                               2211
         ST    @14,@TF00001                                        2211
         ALR   @14,@03                                             2211
         AL    @14,@CF01761                                        2211
         CLI   CDBCNFIG(@14),X'FF'                                 2211
         BE    @RF02211                                            2211
         AL    @03,@TF00001                                        2211
         AL    @03,@CF01761                                        2211
         TM    CDBINUSE(@03),B'01000000'                           2211
         BNO   @RF02211                                            2211
         LTR   @00,@00                                             2211
         BNZ   @RF02211                                            2211
*           DO;                     /*                       @Z40LB61*/
*             CDBTBL(2)=ON;         /*                       @Z40LB61*/
         L     @03,MARGPTR(,@04)                                   2213
         OI    CDBTBL+4(@03),B'00100000'                           2213
*             VUAFLD=ON;            /*                       @Z40LB61*/
         OI    VUAFLD(@03),B'00010000'                             2214
*             FLDNUM(1)=WORKVUA-1;  /*                       @Z40LB61*/
         ST    @02,FLDNUM(,@03)                                    2215
*             INFINDEX(2)=INTF#;    /*                       @Z40LB61*/
         STC   @15,INFINDEX+24(,@03)                               2216
*             VUAINDEX(2)=WORKVUA-1;/*                       @Z40LB61*/
         STC   @02,VUAINDEX+24(,@03)                               2217
*             CHRINDEX(2)=PREVCHR;  /*                       @Z40LB61*/
         MVC   CHRINDEX+24(5,@03),PREVCHR(@05)                     2218
*             CALL IDCCH04(GDTTBL,CDALIST);/*                @Z40LB61*/
         L     @05,@PC00001                                        2219
         ST    @05,@AL00001                                        2219
         ST    @04,@AL00001+4                                      2219
         L     @15,@CV01495                                        2219
         LA    @01,@AL00001                                        2219
         BALR  @14,@15                                             2219
*           END;                    /*                       @Z40LB61*/
*       END;                        /*                       @Z40LB61*/
@RF02211 LA    @15,1                                               2221
         AH    @15,WORKVUA                                         2221
         STH   @15,WORKVUA                                         2221
         CH    @15,@CH00580                                        2221
         BNH   @DL02207                                            2221
@DC02207 DS    0H                                                  2222
*     END SCANCDB;                  /*                       @Z40LB61*/
         LA    @15,1                                               2222
         AH    @15,INTF#                                           2222
         STH   @15,INTF#                                           2222
         CH    @15,@CH00166                                        2222
         BNH   @DL02195                                            2222
@DC02195 DS    0H                                                  2223
*   END SALOOP4;                    /*                       @Z40LB61*/
*                                                                  2223
         LA    @15,1                                               2223
         AH    @15,SA#                                             2223
         STH   @15,SA#                                             2223
         CH    @15,@CH00478                                        2223
         BNH   @DL02156                                            2223
*   /*****************************************************************/
*   /*                                                               */
*   /* RESET THE 'IDCCH04' OPTION FLAGS                      @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2224
*   MSGTYPE=''B;                    /*                       @Z40LB61*/
         L     @15,@PC00001+4                                      2224
         L     @15,MARGPTR(,@15)                                   2224
         XC    MSGTYPE(4,@15),MSGTYPE(@15)                         2224
*   TBLTYPE(1)=''B;                 /*                       @Z40LB61*/
         XC    TBLTYPE(4,@15),TBLTYPE(@15)                         2225
*   TBLTYPE(2)=''B;                 /*                       @Z40LB61*/
         XC    TBLTYPE+4(4,@15),TBLTYPE+4(@15)                     2226
*   END SCANMSC;                    /*                       @Z40LB61*/
         B     @EL00015                                            2227
@PB00015 DS    0H                                                  2228
*   CALL IDCSAEP0(GDTTBL,MODID);                                   2228
*                                                                  2228
         L     @15,@PC00001                                        2228
         ST    @15,@AL00001                                        2228
         LA    @14,MODID                                           2228
         ST    @14,@AL00001+4                                      2228
         MVI   @AL00001+4,X'80'                                    2228
         L     @15,GDTEPL(,@15)                                    2228
         LA    @01,@AL00001                                        2228
         BALR  @14,@15                                             2228
*   /*****************************************************************/
*   /*                                                               */
*   /*                                                       @Z40LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2229
*   END IDCCH02                     /*                       @Z40LB61*/
*                                                                  2229
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (AMSDF01 )                                       */
*/*%INCLUDE SYSLIB  (AMSDF00 )                                       */
*/*@INCLUDE SYSLIB  (AMSDF02 )                                       */
*/*%INCLUDE SYSLIB  (IDCDF11 )                                       */
*/*%INCLUDE SYSLIB  (IDCDF56 )                                       */
*                                                                  2229
*       ;                                                          2229
         B     @EL00001                                            2229
@DATA    DS    0H
@CH00119 DC    H'0'
@CH00166 DC    H'3'
@CH00290 DC    H'5'
@CH00567 DC    H'12'
@CH00478 DC    H'16'
@CH00314 DC    H'24'
@CH01474 DC    H'28'
@CH00781 DC    H'30'
@CH00868 DC    H'51'
@CH00684 DC    H'52'
@CH01728 DC    H'56'
@CH00580 DC    H'64'
@CH01472 DC    H'98'
@CH00753 DC    H'126'
@CH01727 DC    H'149'
@CH01476 DC    H'150'
@CH01726 DC    H'248'
@CH01333 DC    H'255'
@CH00606 DC    H'256'
@CH01729 DC    H'-63'
@CH01723 DC    H'-20'
@CH01733 DC    H'-7'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    3F
@SA00002 DS    15F
@SA00003 DS    15F
@SA00011 DS    15F
@SA00013 DS    15F
@SA00007 DS    15F
@SA00015 DS    0F
@SA00014 DS    0F
@SA00012 DS    0F
@SA00010 DS    0F
@SA00009 DS    0F
@SA00008 DS    0F
@SA00006 DS    0F
@SA00005 DS    0F
@SA00004 DS    0F
         DS    15F
@AL00001 DS    3A
@TF00001 DS    F
IDCCH02  CSECT
         DS    0F
@CF00223 DC    F'1'
@CH00223 EQU   @CF00223+2
@CF00157 DC    F'2'
@CH00157 EQU   @CF00157+2
@CF00046 DC    F'4'
@CH00046 EQU   @CF00046+2
@CF00769 DC    F'7'
@CH00769 EQU   @CF00769+2
@CF00183 DC    F'8'
@CH00183 EQU   @CF00183+2
@CF00225 DC    F'32'
@CF01768 DC    F'-938'
@CF01769 DC    F'-937'
@CF01771 DC    F'-130'
@CF01762 DC    F'-128'
@CF01767 DC    F'-64'
@CF01755 DC    F'-56'
@CF01765 DC    F'-33'
@CF01759 DC    F'-25'
@CF01757 DC    F'-24'
@CF01770 DC    F'-17'
@CF01756 DC    F'-16'
@CF01763 DC    F'-9'
@CF01764 DC    F'-6'
@CF01761 DC    F'-4'
@CF01766 DC    F'-3'
@CF01760 DC    F'-2'
@CF01340 DC    F'-1'
@CH01340 EQU   @CF01340+2
@DATD    DSECT
         DS    0D
LISTSCAN DS    A
IOCSPTR  DS    A
OPNPTR   DS    A
DDSTRU   DS    A
FSADDR   DS    A
ERCNVADR DS    A
DMPINDEX DS    A
VADPTR1  DS    A
VADPTR2  DS    A
VVITPTR1 DS    A
VVITPTR2 DS    A
PSTPTR   DS    A
LTRPTR   DS    A
VTR1PTR  DS    A
RPMPTR   DS    A
PABPTR   DS    A
DVBPTR   DS    A
LPBPTR   DS    A
VMXPTR   DS    A
VVATPTR  DS    A
CBMPTR   DS    A
MERPTR   DS    A
MVCBPTR  DS    A
MVIBPTR  DS    A
MVENTPTR DS    A
SCCFPTR  DS    A
SCENTPTR DS    A
VICFPTR  DS    A
VIENTPTR DS    A
TVCFPTR  DS    A
TVENTPTR DS    A
CIENTPTR DS    A
MICPTR   DS    A
CDBPTR   DS    A
CMCBPTR  DS    A
CMENTPTR DS    A
MOVEPTR  DS    A
CMCOEPTR DS    A
LISTPTR  DS    A
MVPATH#  DS    H
CISA#    DS    H
CDBVUA#  DS    H
SA#      DS    H
TBLBLK#  DS    H
INTF#    DS    H
SDG#     DS    H
ENTRY#   DS    H
DEV#     DS    H
LUA#     DS    H
MVVP#    DS    H
RP#      DS    H
PABPATH# DS    H
VVA#     DS    H
L3333#   DS    H
TBLSECT# DS    H
SAINTF#  DS    H
WORKSA   DS    H
WRKCPUID DS    H
WORKVUA  DS    H
WORKVVA  DS    H
WORKDEV  DS    H
WORKRP   DS    H
PABABOX  DS    H
ERRTYPE  DS    H
MVSA#    DS    H
PABSA#   DS    H
WORKVAL1 DS    H
WORKVAL2 DS    H
PGLIMIT  DS    H
INACTCNT DS    H
LRUDCNT  DS    H
FPBITCNT DS    H
APBITCNT DS    H
FPTOTAL  DS    H
APTOTAL  DS    H
IPTOTAL  DS    H
BPTOTAL  DS    H
MSF#     DS    H
CMBLK#   DS    H
CMENTVAL DS    H
CMORGVAL DS    H
CMCOVAL  DS    H
CMENTMSK DS    H
MSCTBL   DS    H
SCLMSF#  DS    H
MSFL#    DS    H
MSFX#    DS    H
MSFY#    DS    H
MSFZ#    DS    H
CTGSEQ#  DS    H
LZYXADDR DS    H
CHUNK#   DS    H
CUBE#    DS    H
XPOSCUBE DS    H
YPOSCUBE DS    H
CUBEBIT  DS    H
CUBEBYTE DS    H
BLKPOS#  DS    H
XINCREAS DS    H
SETRC    DS    H
TESTRC   DS    H
WORK3333 DS    FL1
LISTLN   DS    FL1
@TS00001 DS    CL95
CICHR    DS    CL5
         DS    CL2
SAVEID   DS    CL12
         ORG   SAVEID
SAVEADDR DS    AL4
SAVECHR  DS    CL5
SAVEENT# DS    FL1
SAVEREC# DS    FL2
         ORG   SAVEID+12
INTARRAY DS    BL6
         ORG   INTARRAY
@NM00119 DS    BL1
         ORG   @NM00119+0
ACTINTF  DS    BL1
DONEINTF EQU   @NM00119+0
@NM00120 EQU   @NM00119+0
         ORG   INTARRAY+6
STAGEDEV DS    BL1
VP1STHIT DS    BL1
MATCHED  DS    BL1
MVSHARED DS    BL1
ENDFLAG  DS    BL1
ERRFLAG  DS    BL1
MSFFLAG  DS    BL1
VVATCHR  DS    2CL5
ACTIVSA  DS    2BL1
         DS    CL1
MNTCOUNT DS    30H
FPCOUNT  DS    8H
APCOUNT  DS    8H
IPCOUNT  DS    8H
BPCOUNT  DS    8H
CMCHR    DS    16CL5
MSFXLOW  DS    4H
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDCCH02  CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV01494 DC    V(IDCCH03)
@CV01495 DC    V(IDCCH04)
         DS    0D
DUMMYPTR DC    F'-1'
MASK8191 DC    XL2'1FFF'
XVALMASK DC    XL2'00FF'
YVALMASK DC    XL2'1F00'
ZVALMASK DC    XL2'2000'
SDGTBLID DC    XL1'10'
MVTBLID  DC    XL1'20'
SCLTBLID DC    XL1'30'
VITBLID  DC    XL1'40'
TVLTBLID DC    XL1'50'
VMXTBLID DC    XL1'60'
CFGTBLID DC    XL1'70'
CMTBLID  DC    XL1'90'
VVATBLID DC    XL1'A0'
MASK3    DC    XL1'03'
MASK7    DC    XL1'07'
MASK15   DC    XL1'0F'
MASK31   DC    XL1'1F'
MASK63   DC    XL1'3F'
MASK3333 DC    XL1'08'
FLIPMASK DC    XL1'FF'
LASTCUBE DC    XL1'FF'
@CC01503 DC    C'CH2A'
@CC01546 DC    C'CH2X'
@CC01550 DC    C'CH2E'
@CC01559 DC    C'CH2Y'
@CC01563 DC    C'CH2F'
@CC01569 DC    C'CH2G'
@CC01576 DC    C'CH2H'
@CC01586 DC    C'CH2J'
@CC01593 DC    C'CH2K'
@CC01604 DC    C'CH2L'
@CC01610 DC    C'CH2M'
@CC01617 DC    C'CH2N'
@CC01628 DC    C'CH2P'
@CC01634 DC    C'CH2Q'
@CC01641 DC    C'CH2R'
@CC01651 DC    C'CH2S'
@CC01659 DC    C'CH2T'
@CC01674 DC    C'CH2U'
@CC01690 DC    C'CH2V'
@CC01696 DC    C'CH2W'
@CC01343 DC    C'YES'
@CC01345 DC    C'NO '
@CB01703 DC    X'0000'
ALL      DC    CL3'ALL'
FORMAT   DC    CL4'FORM'
HSECOND  DC    CL4'HSEC'
CLOCK    DC    CL4'KLOK'
SETZERO  DC    CL4'ZERO'
SETBLANK DC    CL4'BLNK'
NOSET    DC    CL4'NSET'
OVERRIDE DC    CL4'OVRD'
ACQUIRE  DC    CL8'ACQUIRE '
RELINQ   DC    CL8'RELINQ  '
MOUNT    DC    CL8'MOUNT   '
DEMOUNT  DC    CL8'DEMOUNT '
DEFINE   DC    CL8'DEFINE  '
MOVE     DC    CL8'MOVE    '
TRACEQ   DC    CL8'TRACEQ  '
COPYTABL DC    CL8'COPYTABL'
COPYCRTG DC    CL8'COPYCRTG'
COPYVOL  DC    CL8'COPYVOL '
VVIC     DC    CL8'VVIC    '
TUNE     DC    CL8'TUNE    '
NAMES    DC    CL4'NAME'
UNIT     DC    CL4'UNIT'
SHR      DC    CL4'SHR '
EXCL     DC    CL4'EXCL'
NOWAIT   DC    CL4'NWAI'
WAIT     DC    CL4'WAIT'
MODID    DC    CL4'CH02'
FIXAREA  DS    CL1024
         ORG   FIXAREA
@NM00111 DS    CL256
         ORG   @NM00111
@NM00112 DC    256X'00'
         ORG   FIXAREA+256
@NM00113 DS    CL256
         ORG   @NM00113
@NM00114 DC    256X'00'
         ORG   FIXAREA+512
@NM00115 DS    CL256
         ORG   @NM00115
@NM00116 DC    256X'00'
         ORG   FIXAREA+768
@NM00117 DS    CL256
         ORG   @NM00117
@NM00118 DC    256X'00'
         ORG   FIXAREA+1024
BITMASK  DC    X'80'
         DC    X'40'
         DC    X'20'
         DC    X'10'
         DC    X'08'
         DC    X'04'
         DC    X'02'
         DC    X'01'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
REG11    EQU   @11
REG12    EQU   @12
REG10    EQU   @10
REG9     EQU   @09
REG8     EQU   @08
REG7     EQU   @07
REG6     EQU   @06
REG0     EQU   @00
REG1     EQU   @01
REG13    EQU   @13
REG14    EQU   @14
REG15    EQU   @15
REG2     EQU   @02
REG3     EQU   @03
REG4     EQU   @04
REG5     EQU   @05
RTNREG   EQU   @15
IDCSAEP0 EQU   0
TRACE1   EQU   0
OLDERID1 EQU   TRACE1
TRACE2   EQU   0
OLDERID2 EQU   TRACE2
NEWID2   EQU   TRACE2+95
NEWERID2 EQU   5
CIRAGL   EQU   0
CIRTYPE  EQU   CIRAGL
ALLAGL   EQU   0
ALLSTS   EQU   ALLAGL+24
ALLDSP   EQU   ALLAGL+25
ALLORG   EQU   ALLAGL+26
ALLOPT   EQU   ALLAGL+28
UNITABL  EQU   0
UNITADR  EQU   UNITABL+4
@NM00010 EQU   UNITADR
UNITSTAT EQU   UNITABL+6
IOCSTR   EQU   0
IOCDSO   EQU   IOCSTR+16
IOCRFM   EQU   IOCSTR+17
IOCMAC   EQU   IOCSTR+18
IOCMAC2  EQU   IOCSTR+19
IOCCHP   EQU   IOCSTR+20
IOCMSG   EQU   IOCSTR+21
IOCRBA   EQU   IOCSTR+40
IOCTTR   EQU   IOCRBA
IOCMEM   EQU   IOCSTR+44
IOCNWM   EQU   IOCSTR+48
OPNAGL   EQU   0
OPNOPT   EQU   OPNAGL
OPNRFM   EQU   OPNAGL+1
OPNTYP   EQU   OPNAGL+2
OPNMOD   EQU   OPNAGL+3
OPNDEV   EQU   OPNAGL+24
OPNDSO   EQU   OPNAGL+41
OPNOPT2  EQU   OPNAGL+42
IOINFOPT EQU   0
UVOLLIST EQU   0
UVOLENT  EQU   UVOLLIST+2
DARGLIST EQU   0
DARGSTID EQU   DARGLIST+8
DARGARY  EQU   DARGLIST+20
DARGINS  EQU   DARGARY
DARGINL  EQU   DARGARY+2
FMTLIST  EQU   0
FMTFLGS  EQU   FMTLIST
FMTSPF   EQU   FMTLIST+2
FMTRFNO  EQU   FMTSPF
FMTILEN  EQU   FMTRFNO
FMTIOFF  EQU   FMTLIST+4
FMTTRBC  EQU   FMTIOFF
FMTSTO   EQU   FMTTRBC
FMTOCOL  EQU   FMTLIST+6
FMTCNVF  EQU   FMTLIST+10
ERCNVTAB EQU   0
ERTYPE   EQU   ERCNVTAB
EROPER   EQU   ERCNVTAB+1
EROSOPER EQU   ERCNVTAB+2
IDCDB010 EQU   0
DMPITM   EQU   0
DMPARY   EQU   0
VADWORD1 EQU   0
VADRUA   EQU   VADWORD1+2
VADWORD2 EQU   0
VADRPNUM EQU   VADWORD2
VADLUA   EQU   VADWORD2+1
VADFLAGS EQU   VADWORD2+3
VVITBYT1 EQU   0
VVITBYT2 EQU   0
PST      EQU   0
LTR      EQU   0
LTRRUA   EQU   LTR
VTABLER1 EQU   0
@NM00038 EQU   VTABLER1+8
VTTBLCHR EQU   VTABLER1+16
VTSDGID  EQU   VTABLER1+80
VTUCB    EQU   VTABLER1+144
VTFLAGS  EQU   VTUCB
VTTRCCHR EQU   VTABLER1+220
VTLRUCW  EQU   VTABLER1+236
VTRVPAGE EQU   VTABLER1+240
RPM      EQU   0
RPMFLAGS EQU   RPM
RPMACT   EQU   RPMFLAGS
RPMINACT EQU   RPMFLAGS
RPMBND   EQU   RPMFLAGS
RPMVBND  EQU   RPMFLAGS
RPMIOERR EQU   RPMFLAGS
RPMMSCT  EQU   RPMFLAGS
RPMNA    EQU   RPMFLAGS
RPMVPNUM EQU   RPM+1
RPMMVT   EQU   RPM+2
PAB      EQU   0
PABFTOT  EQU   PAB
PABATOT  EQU   PAB+2
PABITOT  EQU   PAB+4
PABBTOT  EQU   PAB+6
PABUPDEL EQU   PAB+9
PABUPTH  EQU   PAB+10
PABLODEL EQU   PAB+13
PABLOTH  EQU   PAB+14
PABSA    EQU   PAB+16
PABVLDSA EQU   PABSA
PAB3333  EQU   PABSA
@NM00048 EQU   PAB+32
PABFCNT  EQU   @NM00048
PABACNT  EQU   @NM00048+1
PABICNT  EQU   @NM00048+2
PABBCNT  EQU   @NM00048+3
PABFMAP  EQU   PAB+64
PABAMAP  EQU   PAB+128
@NM00049 EQU   PAB+192
PABFLAGS EQU   @NM00049
PABDEX   EQU   PABFLAGS
PABVARV  EQU   PABFLAGS
PABVARR  EQU   PABFLAGS
PABVBND  EQU   PABFLAGS
PABVARN  EQU   PABFLAGS
PAB2M11  EQU   PABFLAGS
PABRINTF EQU   @NM00049+1
PABORUA  EQU   @NM00049+2
PABRUA   EQU   @NM00049+3
DVB      EQU   0
DVBNEXT  EQU   DVB
DVBMVT   EQU   DVB+4
LPB      EQU   0
LPBNEXT  EQU   LPB
LPBMVT   EQU   LPB+4
VMX      EQU   0
VMXFLAGS EQU   VMX
VMXVALID EQU   VMXFLAGS
VMXMVT   EQU   VMX+2
VVAT     EQU   0
VVATVVA  EQU   VVAT
CBMAP    EQU   0
CBMDRIVE EQU   CBMAP+8
MERECORD EQU   0
@NM00055 EQU   MERECORD
MEFLAGS  EQU   @NM00055
MEMNTCNT EQU   @NM00055+2
@NM00057 EQU   MERECORD+128
MVCTLBLK EQU   0
MVIDXBLK EQU   0
MVIFLAGS EQU   MVIDXBLK
@NM00060 EQU   MVIDXBLK+8
MVENTRY  EQU   0
MVVOLID  EQU   MVENTRY
MVVFLAGS EQU   MVENTRY+6
MVSECVOL EQU   MVVFLAGS
MVEXCVOL EQU   MVVFLAGS
MVBNDVOL EQU   MVVFLAGS
MVWRTINH EQU   MVVFLAGS
MVLZYX1  EQU   MVENTRY+8
MVLZYX2  EQU   MVENTRY+10
MVMFLAGS EQU   MVENTRY+12
MVMNTVOL EQU   MVMFLAGS
MVREMNT  EQU   MVMFLAGS
MVPINCNT EQU   MVENTRY+13
MVRESRVE EQU   MVENTRY+14
MVSA2RSV EQU   MVRESRVE
MVSDG    EQU   MVENTRY+15
MV3333   EQU   MVENTRY+16
MVVAMSG  EQU   MVENTRY+17
@NM00069 EQU   MVENTRY+20
MVSA     EQU   @NM00069
MVVLDSA  EQU   MVSA
MVACTB   EQU   MVSA
MVACTC   EQU   MVSA
MVACTD   EQU   MVSA
MVCPUIDS EQU   @NM00069+1
MVVVA    EQU   @NM00069+4
MVVUAS   EQU   @NM00069+5
@NM00071 EQU   MVENTRY+52
MVLOGDEV EQU   @NM00071
MVPINACT EQU   MVLOGDEV
MVBNDCNT EQU   @NM00071+1
MVRPNUM  EQU   @NM00071+2
MVCYLMAP EQU   @NM00071+3
MVCPUID  EQU   0
MVVUA    EQU   0
SCCTLFLD EQU   0
SCCOMLEN EQU   SCCTLFLD
SCCFLAGS EQU   SCCOMLEN
SCTRKPTR EQU   SCCTLFLD+4
SCENTRY  EQU   0
SCCSN    EQU   SCENTRY+4
SCLZYX   EQU   SCENTRY+16
VICTLFLD EQU   0
VICFLAGS EQU   VICTLFLD
VITRKPTR EQU   VICTLFLD+4
VIENTRY  EQU   0
VIVOLID  EQU   VIENTRY
VIVFLAGS EQU   VIENTRY+6
VISECVOL EQU   VIVFLAGS
VIEXCVOL EQU   VIVFLAGS
VIBNDVOL EQU   VIVFLAGS
VIWRTINH EQU   VIVFLAGS
VILZYX1  EQU   VIENTRY+8
VILZYX2  EQU   VIENTRY+10
TVCTLFLD EQU   0
TVCOMLEN EQU   TVCTLFLD
TVCFLAGS EQU   TVCOMLEN
TVTRKPTR EQU   TVCTLFLD+4
TVENTRY  EQU   0
TVLZYX1  EQU   TVENTRY
TVLZYX2  EQU   TVENTRY+2
TVCSN    EQU   TVENTRY+4
TVVOLID  EQU   TVENTRY+16
TVVFLAGS EQU   TVENTRY+22
CIENTRY  EQU   0
CICSCNCT EQU   CIENTRY
CISACHNL EQU   CIENTRY+2
@NM00086 EQU   0
CICPUID  EQU   @NM00086
CICUCHL  EQU   @NM00086+1
MICTABLE EQU   0
@NM00088 EQU   MICTABLE
MICFLAG1 EQU   @NM00088+6
MICFLAG2 EQU   @NM00088+7
CDBLOCK  EQU   0
@NM00092 EQU   CDBLOCK
CDBSDG   EQU   @NM00092
CDBCNFIG EQU   CDBSDG
CDBINUSE EQU   CDBCNFIG
CDB3333  EQU   CDBCNFIG
CDBPATHS EQU   @NM00092+1
CDBMVTP  EQU   @NM00092+2
CMCTLBLK EQU   0
CMCPTRS  EQU   CMCTLBLK+22
CMENTRY  EQU   0
IVAD     EQU   0
IVADVVA  EQU   IVAD
IVADFLG  EQU   IVAD+1
IVVIT    EQU   0
IVVI1    EQU   IVVIT
IVVIWI   EQU   IVVI1
IVVISHR  EQU   IVVI1
IVVI2    EQU   IVVIT+1
IVVIRSVD EQU   IVVI2
IPST     EQU   0
IPSTVVA  EQU   IPST
IPSTVP   EQU   IPST+1
ILTR     EQU   0
ILTRRUA  EQU   ILTR
CCHHRTBL EQU   0
TBLCCHHR EQU   CCHHRTBL+2
MVTDBCHR EQU   CCHHRTBL+62
ENTRYARG EQU   0
RDOPTION EQU   ENTRYARG
GETNEXT  EQU   RDOPTION
BUFFER2  EQU   RDOPTION
TABLEID  EQU   ENTRYARG+1
TBLFLAGS EQU   ENTRYARG+2
TBLPARTS EQU   ENTRYARG+3
RPMFLAG  EQU   TBLPARTS
PABFLAG  EQU   TBLPARTS
DVBFLAG  EQU   TBLPARTS
LPBFLAG  EQU   TBLPARTS
CIFLAG   EQU   TBLPARTS
CDBFLAG  EQU   TBLPARTS
ENTRYID  EQU   ENTRYARG+4
TBLADDR  EQU   ENTRYID
PREVCHR  EQU   ENTRYID+4
SANUM    EQU   ENTRYARG+16
SDGNUM   EQU   ENTRYARG+18
INTFID   EQU   ENTRYARG+20
VVADDR   EQU   ENTRYARG+22
DEVICEID EQU   ENTRYARG+24
CELLBLK  EQU   ENTRYARG+26
MSFID    EQU   ENTRYARG+28
VOLID    EQU   ENTRYARG+30
BYTE#    EQU   ENTRYARG+48
BIT#     EQU   ENTRYARG+50
GETRC    EQU   ENTRYARG+52
MSGARG   EQU   0
MSGTYPE  EQU   MSGARG
INCNMSG  EQU   MSGTYPE
DUPLMSG  EQU   MSGTYPE
SUMSMSG  EQU   MSGTYPE
MTCHMSG  EQU   MSGTYPE
MSGNRSET EQU   MSGTYPE+3
TBLTYPE  EQU   MSGARG+4
MVTTBL   EQU   TBLTYPE
VITBL    EQU   TBLTYPE
TVLTBL   EQU   TBLTYPE
SCLTBL   EQU   TBLTYPE
MSVITBL  EQU   TBLTYPE
CMTBL    EQU   TBLTYPE
VADTBL   EQU   TBLTYPE
PSTTBL   EQU   TBLTYPE+1
LTRTBL   EQU   TBLTYPE+1
VVITTBL  EQU   TBLTYPE+1
PABTBL   EQU   TBLTYPE+1
DVBTBL   EQU   TBLTYPE+1
LPBTBL   EQU   TBLTYPE+1
RPMTBL   EQU   TBLTYPE+1
VMXTBL   EQU   TBLTYPE+1
VVATTBL  EQU   TBLTYPE+2
CITBL    EQU   TBLTYPE+2
CDBTBL   EQU   TBLTYPE+2
METBL    EQU   TBLTYPE+2
CBMTBL   EQU   TBLTYPE+2
VTSTBL   EQU   TBLTYPE+2
TBLNRSET EQU   TBLTYPE+3
FLDTYPE1 EQU   MSGARG+12
VSSFLD   EQU   FLDTYPE1
VESFLD   EQU   FLDTYPE1
VBSFLD   EQU   FLDTYPE1
VRSFLD   EQU   FLDTYPE1
WISFLD   EQU   FLDTYPE1
MSFFLD   EQU   FLDTYPE1
VSNFLD   EQU   FLDTYPE1
VVAFLD   EQU   FLDTYPE1+1
VPFLD    EQU   FLDTYPE1+1
RUAFLD   EQU   FLDTYPE1+1
SAFLD    EQU   FLDTYPE1+1
FPASFLD  EQU   FLDTYPE1+1
FPCFLD   EQU   FLDTYPE1+1
APCFLD   EQU   FLDTYPE1+1
IPCFLD   EQU   FLDTYPE1+2
BPCFLD   EQU   FLDTYPE1+2
MVTPFLD  EQU   FLDTYPE1+2
CAFLD    EQU   FLDTYPE1+2
COSFLD   EQU   FLDTYPE1+2
CPUFLD   EQU   FLDTYPE1+2
SDGFLD   EQU   FLDTYPE1+2
L3AFLD   EQU   FLDTYPE1+2
CSNFLD   EQU   FLDTYPE1+3
LRUDFLD  EQU   FLDTYPE1+3
MVFLD    EQU   FLDTYPE1+3
VUAFLD   EQU   FLDTYPE1+3
BPASFLD  EQU   FLDTYPE1+3
DVSFLD   EQU   FLDTYPE1+3
DOSFLD   EQU   FLDTYPE1+3
IUSFLD   EQU   FLDTYPE1+3
FLDTYPE2 EQU   MSGARG+16
APSFLD   EQU   FLDTYPE2
VSHSFLD  EQU   FLDTYPE2
RPFLD    EQU   FLDTYPE2
APASFLD  EQU   FLDTYPE2
IPASFLD  EQU   FLDTYPE2
FPFLD    EQU   FLDTYPE2
APFLD    EQU   FLDTYPE2
IPFLD    EQU   FLDTYPE2
BPFLD    EQU   FLDTYPE2+1
TBLINDEX EQU   MSGARG+20
KEYINDEX EQU   TBLINDEX
CSNINDEX EQU   KEYINDEX
XYZINDEX EQU   CSNINDEX
SAINDEX  EQU   CSNINDEX+3
INFINDEX EQU   CSNINDEX+4
VUAINDEX EQU   CSNINDEX+5
VVAINDEX EQU   CSNINDEX+6
LUAINDEX EQU   CSNINDEX+7
RPINDEX  EQU   CSNINDEX+8
SDGINDEX EQU   CSNINDEX+9
MSFINDEX EQU   KEYINDEX+12
VSNINDEX EQU   TBLINDEX+13
CHRINDEX EQU   TBLINDEX+19
FLDVALUE EQU   MSGARG+68
FLDCHAR  EQU   FLDVALUE
FLDNUM   EQU   FLDCHAR
VICHKFF  EQU   0
TVLCHKFF EQU   0
MVTCHKFF EQU   0
CDBCOT   EQU   0
CDBCHKFF EQU   0
VVACOT   EQU   0
VVACHKFF EQU   0
VMXCOT   EQU   0
VMXCHKFF EQU   0
RPMCOT   EQU   0
RPMCHKFF EQU   0
DVBCOT   EQU   0
DVBCHKFF EQU   0
LPBCOT   EQU   0
LPBCHKFF EQU   0
VVICOT   EQU   0
VVICHKFF EQU   VVICOT
VADCOT   EQU   0
VADCHKFF EQU   VADCOT
PSTCOT   EQU   0
PSTCHKFF EQU   PSTCOT
MOVEAREA EQU   0
CMBLOCK  EQU   0
CMCOBLK  EQU   0
CMCOENT  EQU   0
AMSTP011 EQU   0
AMSTP041 EQU   0
AMSTP042 EQU   0
AMSTP043 EQU   0
AMSTP044 EQU   0
DMPTRM   EQU   0
IDCIOCL0 EQU   0
IDCIOCO0 EQU   0
IDCIOGT0 EQU   0
IDCIOIT0 EQU   0
IDCIOOP0 EQU   0
IDCIOPO0 EQU   0
IDCIOPT0 EQU   0
IDCIOSI0 EQU   0
IDCIOST0 EQU   0
IDCIOTM0 EQU   0
IDCIOVY0 EQU   0
IDCIO050 EQU   0
IDCSAAL0 EQU   0
IDCSACA0 EQU   0
IDCSACL0 EQU   0
IDCSACR0 EQU   0
IDCSADE0 EQU   0
IDCSADL0 EQU   0
IDCSADQ0 EQU   0
IDCSAFP0 EQU   0
IDCSAFS0 EQU   0
IDCSAGP0 EQU   0
IDCSAGS0 EQU   0
IDCSAID0 EQU   0
IDCSALC0 EQU   0
IDCSALD0 EQU   0
IDCSALK0 EQU   0
IDCSANQ0 EQU   0
IDCSAPR0 EQU   0
IDCSAPT0 EQU   0
IDCSAQL0 EQU   0
IDCSARC0 EQU   0
IDCSARV0 EQU   0
IDCSASC0 EQU   0
IDCSASI0 EQU   0
IDCSASN0 EQU   0
IDCSASS0 EQU   0
IDCSAST0 EQU   0
IDCSATI0 EQU   0
IDCSAUC0 EQU   0
IDCSAWO0 EQU   0
IDCSA060 EQU   0
IDCST010 EQU   0
IDCTPER0 EQU   0
LISTTEST EQU   0
NEWERID1 EQU   5
GDTTBL   EQU   0
GDTTR1   EQU   GDTTBL+8
GDTTR2   EQU   GDTTBL+12
GDTDBG   EQU   GDTTBL+40
GDTSTC   EQU   GDTTBL+44
GDTPRT   EQU   GDTTBL+48
GDTESS   EQU   GDTTBL+52
GDTESA   EQU   GDTTBL+56
GDTRST   EQU   GDTTBL+60
GDTRES   EQU   GDTTBL+64
GDTCAL   EQU   GDTTBL+68
GDTGSP   EQU   GDTTBL+72
GDTFSP   EQU   GDTTBL+76
GDTGPL   EQU   GDTTBL+80
GDTFPL   EQU   GDTTBL+84
GDTLOD   EQU   GDTTBL+88
GDTDEL   EQU   GDTTBL+92
GDTPRL   EQU   GDTTBL+96
GDTEPL   EQU   GDTTBL+100
GDTTIM   EQU   GDTTBL+104
GDTIIO   EQU   GDTTBL+108
GDTTIO   EQU   GDTTBL+112
GDTOPN   EQU   GDTTBL+124
GDTCLS   EQU   GDTTBL+128
GDTGET   EQU   GDTTBL+132
GDTPUT   EQU   GDTTBL+136
GDTPOS   EQU   GDTTBL+140
GDTCPY   EQU   GDTTBL+144
GDTCAT   EQU   GDTTBL+148
GDTSNP   EQU   GDTTBL+164
GDTVFY   EQU   GDTTBL+172
GDTUID   EQU   GDTTBL+192
GDTPMT   EQU   GDTTBL+196
GDTCIR   EQU   GDTTBL+200
GDTLNK   EQU   GDTTBL+204
GDTALC   EQU   GDTTBL+208
GDTDLC   EQU   GDTTBL+212
GDTQAL   EQU   GDTTBL+216
GDTSTW   EQU   GDTTBL+220
GDTSSC   EQU   GDTTBL+224
GDTENQ   EQU   GDTTBL+228
GDTRSV   EQU   GDTTBL+232
GDTDEQ   EQU   GDTTBL+236
GDTSFO   EQU   GDTTBL+240
GDTWTO   EQU   GDTTBL+244
GDTSCR   EQU   GDTTBL+248
GDTUNT   EQU   GDTTBL+252
GDTRCT   EQU   GDTTBL+256
GDTIFO   EQU   GDTTBL+260
GDTEXP   EQU   GDTTBL+264
GDTSTA   EQU   GDTTBL+268
GDTERR   EQU   GDTTBL+272
GDTUNC   EQU   GDTTBL+276
GDTLOC   EQU   GDTTBL+280
CDALIST  EQU   0
IVADPTR  EQU   CDALIST
IVVITPTR EQU   CDALIST+64
IPSTPTR  EQU   CDALIST+128
ILTRPTR  EQU   CDALIST+192
IMERPTR  EQU   CDALIST+256
CCHHRPTR EQU   CDALIST+260
EARGPTR  EQU   CDALIST+264
MARGPTR  EQU   CDALIST+268
VICOPTR  EQU   CDALIST+272
TVLCOPTR EQU   CDALIST+276
MVTCOPTR EQU   CDALIST+280
CMCOPTR  EQU   CDALIST+284
CDBCOPTR EQU   CDALIST+348
VVACOPTR EQU   CDALIST+352
VMXCOPTR EQU   CDALIST+356
RPMCOPTR EQU   CDALIST+360
DVBCOPTR EQU   CDALIST+364
LPBCOPTR EQU   CDALIST+368
VVICOPTR EQU   CDALIST+372
VADCOPTR EQU   CDALIST+436
PSTCOPTR EQU   CDALIST+500
VVATADDR EQU   CDALIST+564
CBMADDR  EQU   CDALIST+568
CIADDR   EQU   CDALIST+572
CMBUFPTR EQU   CDALIST+580
VLDSSID  EQU   CDALIST+738
MSFVLCNT EQU   CDALIST+770
VLDMSFID EQU   CDALIST+772
@NM00109 EQU   CDALIST+780
MSCCHK   EQU   @NM00109
SACHK    EQU   @NM00109
MSVICHK  EQU   @NM00109
LASTCOND EQU   0
*                                      START UNREFERENCED COMPONENTS
@NM00110 EQU   @NM00109
VLDSAID  EQU   CDALIST+706
SAVLDCNT EQU   CDALIST+704
BDATAPTR EQU   CDALIST+700
FMTAPTR  EQU   CDALIST+696
TEXTAPTR EQU   CDALIST+692
MSGAPTR  EQU   CDALIST+688
MSVIAPTR EQU   CDALIST+684
RVVIPTR  EQU   CDALIST+680
CHRADDR2 EQU   CDALIST+676
CHRADDR1 EQU   CDALIST+672
WCSBFPTR EQU   CDALIST+668
EXARGPTR EQU   CDALIST+664
RWCSPTR  EQU   CDALIST+660
MVCBADDR EQU   CDALIST+576
GDTECT   EQU   GDTTBL+188
GDTPSB   EQU   GDTTBL+184
GDTUPT   EQU   GDTTBL+180
GDTCMB   EQU   GDTTBL+176
GDTSPR   EQU   GDTTBL+168
@NM00001 EQU   GDTTBL+160
GDTABH   EQU   GDTTBL+156
GDTABT   EQU   GDTTBL+152
GDTTOH   EQU   GDTTBL+120
GDTRIP   EQU   GDTTBL+116
GDTIOH   EQU   GDTTBL+36
GDTSAH   EQU   GDTTBL+32
GDTTPH   EQU   GDTTBL+28
GDTRIH   EQU   GDTTBL+24
GDTSTH   EQU   GDTTBL+20
GDTDBH   EQU   GDTTBL+16
GDTPRM   EQU   GDTTBL+4
GDTHDR   EQU   GDTTBL
@NM00108 EQU   CSNINDEX+11
@NM00107 EQU   CSNINDEX+10
CPUINDEX EQU   CSNINDEX+2
@NM00106 EQU   FLDTYPE2+1
MIFLD    EQU   FLDTYPE1+1
VMSFLD   EQU   FLDTYPE1
@NM00105 EQU   TBLTYPE+2
MICTTBL  EQU   TBLTYPE
@NM00104 EQU   MSGTYPE
SEQ1CSN  EQU   ENTRYARG+36
RECNUM   EQU   ENTRYID+10
ENTNUM   EQU   ENTRYID+9
RECREC   EQU   PREVCHR+4
RECHEAD  EQU   PREVCHR+2
RECCYL   EQU   PREVCHR
@NM00103 EQU   TBLPARTS
MICTFLAG EQU   TBLPARTS
@NM00102 EQU   TBLFLAGS
TCHRFLAG EQU   TBLFLAGS
CBMFLAG  EQU   TBLFLAGS
MEFLAG   EQU   TBLFLAGS
@NM00101 EQU   RDOPTION
MVTDBR   EQU   MVTDBCHR+4
MVTDBHH  EQU   MVTDBCHR+2
MVTDBCC  EQU   MVTDBCHR
@NM00100 EQU   TBLCCHHR+5
TBLR     EQU   TBLCCHHR+4
TBLHH    EQU   TBLCCHHR+2
TBLCC    EQU   TBLCCHHR
CCOFFSET EQU   CCHHRTBL
ILTRM11  EQU   ILTRRUA
@NM00099 EQU   IVVI2
IVVIINTF EQU   IVVI2
@NM00098 EQU   IVVI2
IVVI1STR EQU   IVVI1
@NM00097 EQU   IVVI1
@NM00096 EQU   IVADFLG
IVADWI   EQU   IVADFLG
@NM00095 EQU   IVADFLG
CMX3Z1   EQU   CMENTRY
CMX3Z0   EQU   CMENTRY
CMX2Z1   EQU   CMENTRY
CMX2Z0   EQU   CMENTRY
CMX1Z1   EQU   CMENTRY
CMX1Z0   EQU   CMENTRY
CMX0Z1   EQU   CMENTRY
CMX0Z0   EQU   CMENTRY
CMCFLAGS EQU   CMCTLBLK
CDBSA2D  EQU   CDBPATHS
CDBSA2C  EQU   CDBPATHS
CDBSA2B  EQU   CDBPATHS
@NM00094 EQU   CDBPATHS
CDBSA1D  EQU   CDBPATHS
CDBSA1C  EQU   CDBPATHS
CDBSA1B  EQU   CDBPATHS
@NM00093 EQU   CDBPATHS
CDBNOSHR EQU   CDBCNFIG
MICAINTF EQU   MICFLAG2
@NM00091 EQU   MICFLAG2
MICCMB   EQU   MICFLAG2
MICCURMP EQU   MICFLAG2
MICVALID EQU   MICFLAG2
MICINTF  EQU   MICFLAG1
@NM00090 EQU   MICFLAG1
MICAPATH EQU   MICFLAG1
MICPOTMP EQU   MICFLAG1
@NM00089 EQU   MICFLAG1
MICMPCPU EQU   @NM00088+5
MICMFID  EQU   @NM00088
CICHL    EQU   CICUCHL
@NM00087 EQU   CICUCHL
CICU     EQU   CICUCHL
@NM00085 EQU   CIENTRY+1
CIMSF3   EQU   CICSCNCT
CIMSF2   EQU   CICSCNCT
CIMSF1   EQU   CICSCNCT
CIMSF0   EQU   CICSCNCT
@NM00084 EQU   CICSCNCT
CIMSF    EQU   CICSCNCT
@NM00083 EQU   TVENTRY+23
@NM00082 EQU   TVVFLAGS
TVWRTINH EQU   TVVFLAGS
TVBNDVOL EQU   TVVFLAGS
TVSCRCTG EQU   TVVFLAGS
TVEXCVOL EQU   TVVFLAGS
TVSECVOL EQU   TVVFLAGS
@NM00081 EQU   TVVFLAGS
TVCECTG  EQU   TVVFLAGS
TVREC    EQU   TVTRKPTR+3
TVHEAD   EQU   TVTRKPTR+2
TVCYL    EQU   TVTRKPTR+1
@NM00080 EQU   TVTRKPTR
TVENTNUM EQU   TVCTLFLD+3
TVENTMAX EQU   TVCTLFLD+2
TVENTLEN EQU   TVCTLFLD+1
TVLSTTRK EQU   TVCFLAGS
TVENDTRK EQU   TVCFLAGS
TVLSTACT EQU   TVCFLAGS
TVLSTBLK EQU   TVCFLAGS
@NM00079 EQU   VIENTRY+7
@NM00078 EQU   VIVFLAGS
VISCRCTG EQU   VIVFLAGS
@NM00077 EQU   VIVFLAGS
VICECTG  EQU   VIVFLAGS
VIREC    EQU   VITRKPTR+3
VIHEAD   EQU   VITRKPTR+2
VICYL    EQU   VITRKPTR+1
@NM00076 EQU   VITRKPTR
VIENTNUM EQU   VICTLFLD+3
VIENTMAX EQU   VICTLFLD+2
VIENTLEN EQU   VICTLFLD+1
VIOFBLK  EQU   VICFLAGS
VIAREA   EQU   VICFLAGS
VIUSEBLK EQU   VICFLAGS
VILSTTRK EQU   VICFLAGS
VIENDTRK EQU   VICFLAGS
VILSTACT EQU   VICFLAGS
VILSTBLK EQU   VICFLAGS
@NM00075 EQU   SCENTRY+18
@NM00074 EQU   SCENTRY
SCREC    EQU   SCTRKPTR+3
SCHEAD   EQU   SCTRKPTR+2
SCCYL    EQU   SCTRKPTR+1
@NM00073 EQU   SCTRKPTR
SCENTNUM EQU   SCCTLFLD+3
SCENTMAX EQU   SCCTLFLD+2
SCENTLEN EQU   SCCTLFLD+1
SCLSTTRK EQU   SCCFLAGS
SCENDTRK EQU   SCCFLAGS
SCLSTACT EQU   SCCFLAGS
SCLSTBLK EQU   SCCFLAGS
MVVUAI#  EQU   MVVUA
@NM00072 EQU   MVLOGDEV
MVDSTGC2 EQU   MVLOGDEV
MVDSTGC1 EQU   MVLOGDEV
@NM00070 EQU   MVENTRY+44
MVPFI    EQU   MVENTRY+36
@NM00068 EQU   MVENTRY+18
@NM00067 EQU   MVVAMSG
MVINTFD  EQU   MVVAMSG
MVINTFC  EQU   MVVAMSG
MVINTFB  EQU   MVVAMSG
MVINTFA  EQU   MVVAMSG
@NM00066 EQU   MVRESRVE
@NM00065 EQU   MVRESRVE
@NM00064 EQU   MVMFLAGS
MVMNTBND EQU   MVMFLAGS
MVMNTEXC EQU   MVMFLAGS
@NM00063 EQU   MVENTRY+7
@NM00062 EQU   MVVFLAGS
MVSCRCTG EQU   MVVFLAGS
@NM00061 EQU   MVVFLAGS
MVCECTG  EQU   MVVFLAGS
MVMVTPTR EQU   @NM00060+6
MVIVOLID EQU   @NM00060
@NM00059 EQU   MVIDXBLK+4
MVENTNUM EQU   MVIDXBLK+3
MVENTMAX EQU   MVIDXBLK+2
MVENTLEN EQU   MVIDXBLK+1
@NM00058 EQU   MVIFLAGS
MVLSTBLK EQU   MVIFLAGS
MVOFBLK  EQU   MVIFLAGS
MVOFOUT  EQU   MVIFLAGS
MVCTLBIT EQU   MVCTLBLK
MEUCBCNT EQU   @NM00057+2
MEDRVCNT EQU   @NM00057+1
MELRUCNT EQU   @NM00057
@NM00056 EQU   MERECORD+120
MEVOCNT  EQU   @NM00055+1
MEMVD2   EQU   MEFLAGS
MEMVI2   EQU   MEFLAGS
MEMVD1   EQU   MEFLAGS
MEMVI1   EQU   MEFLAGS
MEVOD2   EQU   MEFLAGS
MEVOI2   EQU   MEFLAGS
MEVOD1   EQU   MEFLAGS
MEVOI1   EQU   MEFLAGS
CBMMSF   EQU   CBMAP+39
CBMFLAGS EQU   CBMAP+38
CBMDRC   EQU   CBMAP+6
CBMSA    EQU   CBMAP+4
CBMDRD   EQU   CBMAP
@NM00054 EQU   VMX+1
@NM00053 EQU   VMXFLAGS
LPBPFI   EQU   LPBMVT
LPBMSFID EQU   LPBMVT
@NM00052 EQU   LPB+2
LPBCURR  EQU   LPB+1
DVBPFI   EQU   DVBMVT
DVBMSFID EQU   DVBMVT
@NM00051 EQU   DVB+2
DVBCURR  EQU   DVB+1
PABORUAV EQU   PABORUA
PABSA2D  EQU   PABRINTF
PABSA2C  EQU   PABRINTF
PABSA2B  EQU   PABRINTF
@NM00050 EQU   PABRINTF
PABSA1D  EQU   PABRINTF
PABSA1C  EQU   PABRINTF
PABSA1B  EQU   PABRINTF
PABRAI   EQU   PABRINTF
PABMSCT  EQU   PABFLAGS
PABMOD11 EQU   PABFLAGS
@NM00047 EQU   PAB+24
PABSRZ   EQU   PAB+23
PABSRY   EQU   PAB+22
PABSRX   EQU   PAB+21
PABSRW   EQU   PAB+20
@NM00046 EQU   PAB+18
@NM00045 EQU   PABSA
@NM00044 EQU   PAB+12
PABPPD   EQU   PAB+8
@NM00043 EQU   RPMFLAGS
VTVOLPFX EQU   VTABLER1+252
@NM00042 EQU   VTRVPAGE+4
VT20TO27 EQU   VTRVPAGE+3
VT18TO1F EQU   VTRVPAGE+2
VT10TO17 EQU   VTRVPAGE+1
VT08TO0F EQU   VTRVPAGE
VTLRUIOS EQU   VTLRUCW+2
VTLRUTIM EQU   VTLRUCW+1
VTLRUCLK EQU   VTLRUCW
VTTRCR   EQU   VTTRCCHR+3
VTTRCH   EQU   VTTRCCHR+2
VTTRCC   EQU   VTTRCCHR+1
VTXY     EQU   VTTRCCHR
@NM00041 EQU   VTABLER1+160
VTSADDR  EQU   VTUCB+6
VTPADDR  EQU   VTUCB+4
VTPOST   EQU   VTUCB+3
VTACTIVE EQU   VTUCB+2
VTWORK   EQU   VTUCB+1
VTSBUSY  EQU   VTFLAGS
VTSREADY EQU   VTFLAGS
VTSONLIN EQU   VTFLAGS
VTSVALID EQU   VTFLAGS
VTPBUSY  EQU   VTFLAGS
VTPREADY EQU   VTFLAGS
VTPONLIN EQU   VTFLAGS
VTPVALID EQU   VTFLAGS
VTLRU1   EQU   VTSDGID+3
VTLRU0   EQU   VTSDGID+2
VTL33331 EQU   VTSDGID+1
VTL33330 EQU   VTSDGID
VTTBLR   EQU   VTTBLCHR+3
VTTBLH   EQU   VTTBLCHR+2
VTTBLC   EQU   VTTBLCHR+1
@NM00040 EQU   VTTBLCHR
@NM00039 EQU   @NM00038+2
VTIMPLS  EQU   @NM00038
VTPACKID EQU   VTABLER1
LTRMOD11 EQU   LTRRUA
PSTCYLW  EQU   PST+3
PSTCYLV  EQU   PST+2
PSTVPNUM EQU   PST+1
PSTVVA   EQU   PST
VVITPCDD EQU   VVITBYT2
VVITPCDC EQU   VVITBYT2
VVITPCDB EQU   VVITBYT2
VVITRSVD EQU   VVITBYT2
VVITINTF EQU   VVITBYT2
VVITVVB  EQU   VVITBYT2
VVITCC   EQU   VVITBYT2
VVITVVS  EQU   VVITBYT1
VVITVVWI EQU   VVITBYT1
VVITFR   EQU   VVITBYT1
VVITNBM  EQU   VVITBYT1
VVITDEDD EQU   VVITBYT1
VVITDEDC EQU   VVITBYT1
VVITDEDB EQU   VVITBYT1
VVITDEDA EQU   VVITBYT1
VADRM    EQU   VADFLAGS
VADVSI   EQU   VADFLAGS
VADRDED  EQU   VADFLAGS
VADRB    EQU   VADFLAGS
VADRR    EQU   VADFLAGS
VADVWI   EQU   VADFLAGS
VADVWG   EQU   VADFLAGS
VADVRW   EQU   VADFLAGS
VADPOH   EQU   VADWORD2+2
VADUDE   EQU   VADLUA
VADMOD11 EQU   VADRPNUM
VADLINK  EQU   VADWORD1+3
VADUCS   EQU   VADRUA
VADCCR   EQU   VADRUA
VADEDI   EQU   VADRUA
VADVVA   EQU   VADWORD1+1
VADVFM   EQU   VADWORD1
@NM00037 EQU   DMPARY+15
DMPARYTP EQU   DMPARY+14
DMPARYEX EQU   DMPARY+12
DMPARYIC EQU   DMPARY+10
DMPARYSZ EQU   DMPARY+8
DMPARYNM EQU   DMPARY
@NM00036 EQU   DMPITM+15
DMPITMTP EQU   DMPITM+14
DMPITMLN EQU   DMPITM+12
DMPITMPT EQU   DMPITM+8
DMPITMNM EQU   DMPITM
@NM00035 EQU   ERCNVTAB+24
ERCPLPT  EQU   ERCNVTAB+20
ERCATRC  EQU   ERCNVTAB+16
ERDSNM   EQU   ERCNVTAB+12
@NM00034 EQU   ERCNVTAB+4
@NM00033 EQU   ERCNVTAB+3
@NM00032 EQU   EROSOPER
EROSUCDX EQU   EROSOPER
EROSCATL EQU   EROSOPER
@NM00031 EQU   EROPER
ERCATAL  EQU   EROPER
ERCATDL  EQU   EROPER
ERCATDE  EQU   EROPER
ERCATLC  EQU   EROPER
@NM00030 EQU   ERTYPE
EROSCAT  EQU   ERTYPE
ERCATLG  EQU   ERTYPE
@NM00029 EQU   FMTCNVF+1
FMTAR    EQU   FMTCNVF+1
FMTBS    EQU   FMTCNVF+1
FMTSS    EQU   FMTCNVF+1
FMTAL    EQU   FMTCNVF+1
FMTZS    EQU   FMTCNVF+1
@NM00028 EQU   FMTCNVF
FMTPU    EQU   FMTCNVF
FMTBD    EQU   FMTCNVF
FMTBHD   EQU   FMTCNVF
FMTBHA   EQU   FMTCNVF
FMTBH    EQU   FMTCNVF
FMTOLEN  EQU   FMTLIST+8
FMTRIO   EQU   FMTOCOL
FMTSPT   EQU   FMTSTO
FMTSTL   EQU   FMTILEN
@NM00027 EQU   FMTFLGS+1
FMTHDF   EQU   FMTFLGS
FMTDFF   EQU   FMTFLGS
FMTSTF   EQU   FMTFLGS
FMTREPF  EQU   FMTFLGS
FMTBDF   EQU   FMTFLGS
FMTIDF   EQU   FMTFLGS
FMTSCF   EQU   FMTFLGS
FMTEOLF  EQU   FMTFLGS
DARGDTM  EQU   DARGARY+4
DARGPCT  EQU   DARGINL
DARGREP  EQU   DARGINS
@NM00026 EQU   DARGLIST+19
DARGIND  EQU   DARGLIST+18
DARGRETL EQU   DARGLIST+16
DARGCNT  EQU   DARGLIST+14
DARGILP  EQU   DARGLIST+12
DARGSENT EQU   DARGSTID+3
DARGSMOD EQU   DARGSTID
DARGRETP EQU   DARGLIST+4
DARGDBP  EQU   DARGLIST
UVOLVOL  EQU   UVOLENT+4
UVOLDEV  EQU   UVOLENT
UVOLCNT  EQU   UVOLLIST
@NM00025 EQU   IOINFOPT
IOINFTMS EQU   IOINFOPT
IOINFSUP EQU   IOINFOPT
IOINFDSN EQU   IOINFOPT
IOINFVOL EQU   IOINFOPT
IOINFDVT EQU   IOINFOPT
OPNVOL   EQU   OPNAGL+44
@NM00024 EQU   OPNAGL+43
@NM00023 EQU   OPNOPT2
OPNOPTJM EQU   OPNOPT2
@NM00022 EQU   OPNOPT2
OPNOPTAS EQU   OPNOPT2
@NM00021 EQU   OPNDSO
OPNDSOPO EQU   OPNDSO
OPNDSOIS EQU   OPNDSO
OPNDSOPS EQU   OPNDSO
OPNDSOAM EQU   OPNDSO
OPNKYL   EQU   OPNAGL+40
OPNBLK   EQU   OPNAGL+36
OPNREC   EQU   OPNAGL+32
OPNDEVIX EQU   OPNDEV+4
OPNDEVDT EQU   OPNDEV
OPNCBP   EQU   OPNAGL+20
OPNDSN   EQU   OPNAGL+16
OPNPWA   EQU   OPNAGL+12
OPNDDN   EQU   OPNAGL+8
OPNIOC   EQU   OPNAGL+4
OPNMODRP EQU   OPNMOD
OPNMODUB EQU   OPNMOD
OPNMODRS EQU   OPNMOD
OPNMODAX EQU   OPNMOD
OPNMODRR EQU   OPNMOD
OPNMODRC EQU   OPNMOD
OPNMODAC EQU   OPNMOD
OPNMODPD EQU   OPNMOD
@NM00020 EQU   OPNTYP
OPNTYPRV EQU   OPNTYP
OPNTYPEX EQU   OPNTYP
OPNTYPRA EQU   OPNTYP
OPNTYPXM EQU   OPNTYP
OPNTYPCI EQU   OPNTYP
OPNTYPSO EQU   OPNTYP
OPNTYPSI EQU   OPNTYP
@NM00019 EQU   OPNRFM
OPNRFMBK EQU   OPNRFM
OPNRFMSF EQU   OPNRFM
OPNRFMUN EQU   OPNRFM
OPNRFMVR EQU   OPNRFM
OPNRFMFX EQU   OPNRFM
OPNOPTSK EQU   OPNOPT
OPNOPTDR EQU   OPNOPT
OPNOPTCR EQU   OPNOPT
OPNOPTKS EQU   OPNOPT
OPNOPTBK EQU   OPNOPT
OPNOPTUP EQU   OPNOPT
OPNOPTOT EQU   OPNOPT
OPNOPTIN EQU   OPNOPT
IOCEXT   EQU   IOCSTR+64
IOCREL   EQU   IOCSTR+60
IOCWORK  EQU   IOCSTR+56
IOCRRN   EQU   IOCSTR+52
IOCPNM   EQU   IOCNWM+2
IOCPTL   EQU   IOCNWM
IOCKYA   EQU   IOCMEM
IOCVRC   EQU   IOCTTR
IOCCBP   EQU   IOCSTR+36
IOCDSN   EQU   IOCSTR+32
IOCHURBA EQU   IOCSTR+28
IOCVOLSR EQU   IOCSTR+22
@NM00018 EQU   IOCMSG
IOCMSGAE EQU   IOCMSG
IOCMSGCE EQU   IOCMSG
IOCMSGOE EQU   IOCMSG
IOCMSGOP EQU   IOCMSG
@NM00017 EQU   IOCMSG
IOCCHPSY EQU   IOCCHP
IOCCHPAS EQU   IOCCHP
IOCCHPBK EQU   IOCCHP
IOCCHPCR EQU   IOCCHP
IOCCHPKS EQU   IOCCHP
IOCCHPSK EQU   IOCCHP
IOCCHPDR EQU   IOCCHP
IOCCHPSQ EQU   IOCCHP
@NM00016 EQU   IOCMAC2
IOCMACPA EQU   IOCMAC2
@NM00015 EQU   IOCMAC2
IOCMACCP EQU   IOCMAC2
IOCMACRR EQU   IOCMAC2
IOCMACAS EQU   IOCMAC2
IOCMACSK EQU   IOCMAC2
@NM00014 EQU   IOCMAC
IOCMACCC EQU   IOCMAC
IOCMACDR EQU   IOCMAC
IOCMACBK EQU   IOCMAC
IOCMACCR EQU   IOCMAC
IOCMACUP EQU   IOCMAC
IOCMACOT EQU   IOCMAC
IOCMACIN EQU   IOCMAC
@NM00013 EQU   IOCRFM
IOCRFMBK EQU   IOCRFM
IOCRFMSF EQU   IOCRFM
IOCRFMUN EQU   IOCRFM
IOCRFMVR EQU   IOCRFM
IOCRFMFX EQU   IOCRFM
@NM00012 EQU   IOCDSO
IOCDSOPO EQU   IOCDSO
IOCDSOIS EQU   IOCDSO
IOCDSOPS EQU   IOCDSO
IOCDSOAM EQU   IOCDSO
IOCRKP   EQU   IOCSTR+13
IOCKYL   EQU   IOCSTR+12
IOCTRN   EQU   IOCSTR+8
IOCDLN   EQU   IOCSTR+4
IOCDAD   EQU   IOCSTR
UNITVTOC EQU   UNITABL+7
@NM00011 EQU   UNITSTAT
UNITUSHR EQU   UNITSTAT
UNITXSHR EQU   UNITSTAT
UNITISHR EQU   UNITSTAT
UNITUA   EQU   @NM00010+1
UNITCHA  EQU   @NM00010
UNITUCB  EQU   UNITABL
ALLUNCNT EQU   ALLAGL+30
ALLVLCNT EQU   ALLAGL+29
@NM00009 EQU   ALLOPT
ALLOPTUN EQU   ALLOPT
ALLOPTPV EQU   ALLOPT
ALLOPTDS EQU   ALLOPT
ALLOPTVL EQU   ALLOPT
@NM00008 EQU   ALLORG+1
ALLORGVS EQU   ALLORG+1
@NM00007 EQU   ALLORG+1
ALLORGGS EQU   ALLORG+1
ALLORGUN EQU   ALLORG
ALLORGPO EQU   ALLORG
ALLORGMQ EQU   ALLORG
ALLORGCQ EQU   ALLORG
ALLORGCX EQU   ALLORG
ALLORGDA EQU   ALLORG
ALLORGPS EQU   ALLORG
ALLORGIS EQU   ALLORG
ALLDSPUN EQU   ALLDSP
ALLDSPCG EQU   ALLDSP
ALLDSPDE EQU   ALLDSP
ALLDSPKP EQU   ALLDSP
@NM00006 EQU   ALLDSP
ALLSTSOD EQU   ALLSTS
ALLSTSMD EQU   ALLSTS
ALLSTSNW EQU   ALLSTS
ALLSTSSR EQU   ALLSTS
@NM00005 EQU   ALLSTS
ALLPWD   EQU   ALLAGL+20
ALLVLP   EQU   ALLAGL+16
ALLULP   EQU   ALLAGL+12
ALLDDN   EQU   ALLAGL+4
ALLDSN   EQU   ALLAGL
CIRPID   EQU   CIRAGL+28
CIRPWD   EQU   CIRAGL+24
CIRCAT   EQU   CIRAGL+20
CIRWKP   EQU   CIRAGL+16
CIRTLR   EQU   CIRAGL+12
CIRHDR   EQU   CIRAGL+8
CIRTLN   EQU   CIRAGL+6
CIRHLN   EQU   CIRAGL+4
@NM00004 EQU   CIRAGL+1
@NM00003 EQU   CIRTYPE
CIRTYPAQ EQU   CIRTYPE
CIRTYP1Q EQU   CIRTYPE
NEWID1   EQU   TRACE1+95
CALLID   EQU   OLDERID1+90
@NM00002 EQU   OLDERID1
*                                      END UNREFERENCED COMPONENTS
@RT00388 EQU   @EL00001
@RT00418 EQU   @EL00001
@RT00421 EQU   @EL00001
@RT00648 EQU   @EL00002
@RF00651 EQU   @RC00619
@RC00713 EQU   @RC00712
@RT00776 EQU   @EL00002
@RF00811 EQU   @EL00003
@RT00823 EQU   @EL00003
@RT00829 EQU   @EL00003
@RT00832 EQU   @EL00003
@RF00837 EQU   @RC00826
@RF00836 EQU   @RC00826
@RT00851 EQU   @EL00003
@RC00868 EQU   @EL00004
@RT00976 EQU   @RC00974
@RC01112 EQU   @RC01111
@RT01167 EQU   @RC01165
@RT01340 EQU   @EL00007
@RT01343 EQU   @EL00007
@RC01329 EQU   @EL00007
@RF01345 EQU   @EL00007
@RF01448 EQU   @RC01439
@RC01552 EQU   @RC01551
@RC01556 EQU   @RC01555
@RC01631 EQU   @EL00010
@RF01681 EQU   @EL00010
@RF01777 EQU   @RC01774
@RF01974 EQU   @EL00012
@RT02034 EQU   @EL00013
@RF02036 EQU   @EL00013
@PB00014 EQU   @PB00015
@RF01652 EQU   @RC01631
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDCCH02,(C'PLS1411',0603,77297)
