         TITLE 'IEAFTRT2-RTM2WA-ESA-SDWA FORMAT MODULE                 *
                        '
IEAFTRT2 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'IEAFTRT2  77.091'                                 0001
IEAFTESA DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00536-IEAFTESA)
         ENTRY IEAFTESA
IEAFTSDW DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00636-IEAFTSDW)
         ENTRY IEAFTSDW
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @10,0                                               0001
@PSTART  LA    @11,4095(,@10)                                      0001
         LA    @12,4095(,@11)                                      0001
         USING @PSTART,@10                                         0001
         USING @PSTART+4095,@11                                    0001
         USING @PSTART+8190,@12                                    0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @09,@01                                             0001
         USING @DATD,@09                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @15,@01,16(@13)                                     0001
         ST    @09,8(,@13)                                         0001
         LR    @13,@09                                             0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0189
*/********************************************************************/
*/* FUNCTION -                                                     0189
*      ROUTINE WHICH FORMATS THE RTM2 WORK AREA.                   0189
*      IT SETS UP THE NEEDED POINTERS TO BE PASSED TO THE FORMAT   0189
*      ROUTINE SENT IN THE PARAMETER LIST.  FOR ANY ERROR ACCESSING
*      A NEEDED FIELD IN THE RTM2WA OR FOR NON-ZERO RETURN CODE    0189
*      FROM THE FORMATTING SERVICE, THE FOLLOWING MESSAGE WILL BE  0189
*      PRINTED:                                                    0189
*               *** FORMATTING SERVICE ROUTINE ERROR DURING        0189
*               RTM2WA FORMATTING(POSSIBLE CAUSE:  DATA NOT IN     0189
*               DUMP) ***                                          0189
*      AT THIS POINT PROCESSING WOULD TERMINATE. IF THE RTM2WA IS  0189
*      FORMATTED WITHOUT ERROR, A SUMMARY OF THE RTM2WA IMPORTANT  0189
*      AREA IS PRINTED. IF THIS COMPLETES SUCCESSFULLY, A BIT SUMMARY
*      IS PRINTED USING THE ANALYZE PROC.                          0189
*                                                                  0189
*   INPUT -                                                        0189
*      REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE        0189
*      ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2.   0189
*      ADPLFMT1 ALSO DEFINES AS START, CONTAINS THE OFFSET TO BE   0189
*      PLACED ALONG SIDE THE FIRST FIELD IN THE CONTROL BLOCK, AND 0189
*      ADPLCOM1 CONTAINS THE ADDRESS OF THE ESTAE PARAMETER LIST.  0189
*                                                                  0189
*   CALLS -                                                        0189
*      CALLS ACCESRTN, CONVERT, FMTRTN, PRINT, RT2SUM, AND SPECIAL 0189
*                                                                  0189
*   CALLED BY -                                                    0189
*      IEAVTFMT TO FORMAT RTM2WA                                   0189
*                                                                  0189
*   RETURNS TO -                                                   0189
*      IEAVTFMT WITH RETURN CODE SET BY ACCESS OR FORMAT           0189
*      SERVICE ROUTINES                                              */
*/********************************************************************/
*                                                                  0189
*   ESTAPTR=ADPLCOM1;               /* SAVE PTR TO ESTAE PARM LIST   */
         L     @14,ADPLCOM1(,ABDPLPTR)                             0189
         ST    @14,ESTAPTR                                         0189
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR RETRY           */
         STM   VADR,RCREG,LCALREGS(@14)                            0190
*   ADPLCOM1=ADDR(RT2FMT);          /* FORMAT ERROR MSG              */
         LA    @14,RT2FMT                                          0191
         ST    @14,ADPLCOM1(,ABDPLPTR)                             0191
*   RTM2PTR=ADPLFMT2;               /* PTR TO RTM2 WORK AREA         */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0192
         LR    RTM2PTR,@14                                         0192
*   SAVEPTR=ADPLFMT2-START;         /* VALUE FOR OFFSET              */
         SL    @14,START(,ABDPLPTR)                                0193
         ST    @14,SAVEPTR                                         0193
*   BITS=BITS&&BITS;                /* TURN OFF THE SUBIT FLAGS AND
*                                      ERROR                   SWITCH*/
*                                                                  0194
         XC    BITS(1),BITS                                        0194
*   /*****************************************************************/
*   /*                                                               */
*   /* IN RELEASE 2, THE POINTER TO THE SUBITS WAS NOT DEFINED.      */
*   /* THEREFORE, BEFORE ACCESSING THE SUBIT POINTER, CHECK FOR      */
*   /* RELEASE 2                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0195
*   VADR=ADDR(CVTNUMB);             /* RELEASE NUMBER                */
         L     @14,CVTPTR(,ABDPLPTR)                               0195
         AL    @14,@CF03887                                        0195
         LR    VADR,@14                                            0195
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0196
*   IF RCREG^=ZERO THEN             /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0197
         BZ    @RF00197                                            0197
*     BUFFER(1:LENGTH(RT2FMT))=RT2FMT;                             0198
         L     @14,ADPLBUF(,ABDPLPTR)                              0198
         MVC   BUFFER(120,@14),RT2FMT                              0198
*   ELSE                            /* FOUND RELEASE NUMBER          */
*     DO;                                                          0199
         B     @RC00197                                            0199
@RF00197 DS    0H                                                  0200
*       IF DATAHALF^=REL2 THEN      /* NOT A RELEASE 2 SYSTEM        */
         CLC   DATAHALF(2,DATAPTR),REL2                            0200
         BE    @RF00200                                            0200
*         DO;                                                      0201
*                                                                  0201
*           /*********************************************************/
*           /*                                                       */
*           /* FIND WHICH SUS ARE ON THE SYSTEM                      */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0202
*           VADR=ADDR(CVTIHASU);    /* SU BIT PTR                    */
         L     @14,CVTPTR(,ABDPLPTR)                               0202
         LA    VADR,CVTIHASU(,@14)                                 0202
*           CALL ACCESRTN;          /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0203
*           IF RCREG^=ZERO THEN     /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0204
         BZ    @RF00204                                            0204
*             DO;                                                  0205
*               BUFFER(1:LENGTH(RT2FMT))=RT2FMT;/* ERROR MSG         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0206
         MVC   BUFFER(120,@14),RT2FMT                              0206
*               ERRSW=ON;           /* INDICATE ACCESS ERROR         */
         OI    ERRSW,B'00100000'                                   0207
*             END;                  /* END ACCESS ERROR              */
*           ELSE                                                   0209
*             DO;                   /* FOUND SU BIT PTR              */
         B     @RC00204                                            0209
@RF00204 DS    0H                                                  0210
*               IF DATAWORD^=ZERO THEN/* IF PTR TO SUBITS NOT ZERO-SU
*                                                              SYSTEM*/
         L     @14,DATAWORD(,DATAPTR)                              0210
         LTR   @14,@14                                             0210
         BZ    @RF00210                                            0210
*                 DO;                                              0211
*                   VADR=DATAWORD;  /* SU BITS                       */
         LR    VADR,@14                                            0212
*                   CALL ACCESRTN;  /* ACCESS BITS-THEY ARE ON A   0213
*                                      DWORD BDY SO 2 WORDS CAN BE 0213
*                                      GUARENTEED                    */
         BAL   @14,ACCESRTN                                        0213
*                   IF RCREG^=ZERO THEN/* ACCESS ERROR               */
         LTR   RCREG,RCREG                                         0214
         BZ    @RF00214                                            0214
*                     DO;                                          0215
*                       BUFFER(1:LENGTH(RT2FMT))=RT2FMT;           0216
         L     @14,ADPLBUF(,ABDPLPTR)                              0216
         MVC   BUFFER(120,@14),RT2FMT                              0216
*                       ERRSW=ON;   /* ERROR INDICATOR TO STOP     0217
*                                      PROCESSING                    */
         OI    ERRSW,B'00100000'                                   0217
*                     END;          /* END ACCESS ERROR              */
*                   ELSE                                           0219
*                     DO;           /* FOUND SU BIT STRING           */
         B     @RC00214                                            0219
@RF00214 DS    0H                                                  0220
*                       IF SU17BIT=ON THEN                         0220
         TM    SU17BIT(DATAPTR),B'01000000'                        0220
         BNO   @RF00220                                            0220
*                         SU17SAVE=ON;/* SU 17 ON SYSTEM             */
         OI    SU17SAVE,B'10000000'                                0221
*                       ELSE                                       0222
*                         ;         /* SU17 NOT ON SYSTEM            */
@RF00220 DS    0H                                                  0223
*                       IF SU33BIT=ON THEN                         0223
         TM    SU33BIT(DATAPTR),B'01000000'                        0223
         BNO   @RF00223                                            0223
*                         SU33SAVE=ON;/* SU 33 ON SYSTEM             */
         OI    SU33SAVE,B'01000000'                                0224
*                       ELSE                                       0225
*                         ;         /* SU33 NOT ON SYSTEM            */
@RF00223 DS    0H                                                  0226
*                     END;          /* END SU BIT STRING FOUND       */
*                 END;              /* END SU SYSTEM                 */
*               ELSE                                               0228
*                 ;                 /* PRE SU SYSTEM-NO SU BITS TO 0228
*                                      SET                           */
@RF00210 DS    0H                                                  0229
*             END;                  /* END FOUND SUBIT POINTER       */
*         END;                      /* END NOT A RELEASE 2 SYSTEM    */
*       ELSE                                                       0231
*         ;                         /* IS A RELEASE 2 SYSTEM, NO SUS */
@RF00200 DS    0H                                                  0232
*       IF ERRSW=OFF THEN           /* CONTINUE IF FOUND SYSTEM OK   */
@RC00200 TM    ERRSW,B'00100000'                                   0232
         BNZ   @RF00232                                            0232
*         DO;                                                      0233
*           BUFFER(1:LENGTH(RT2HDR))=RT2HDR;/* TITLE                 */
         L     @14,ADPLBUF(,ABDPLPTR)                              0234
         MVC   BUFFER(54,@14),RT2HDR                               0234
*           PACKAREA=RTM2PTR;       /* PLACE PTR INTO CHAR AREA      */
         ST    RTM2PTR,PACKAREA                                    0235
*           GARBAGE='04'X;          /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0236
*           UNPK(ADDRESS,UNPACK);   /* PLACE IN BUFFER               */
         UNPK  ADDRESS(9,@14),UNPACK(5)                            0237
*           TR(ADDRESS,TRANS);      /* TRANSLATE TO PRINTABLE HEX    */
         TR    ADDRESS(9,@14),TRANS                                0238
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0239
         BALR  @14,@15                                             0239
*           BUFFER(1:LENGTH(RT2US))=RT2US;/* UNDERSCORE              */
         L     @14,ADPLBUF(,ABDPLPTR)                              0240
         MVC   BUFFER(7,@14),RT2US                                 0240
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0241
         BALR  @14,@15                                             0241
*           CALL PRINT;             /* BLANK                         */
*                                                                  0242
         L     @15,ADPLPRNT(,ABDPLPTR)                             0242
         BALR  @14,@15                                             0242
*           /*********************************************************/
*           /*                                                       */
*           /* FORMAT RTM2WA                                         */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0243
*           DO ARRAYCNT=1 TO ARRAYMAX WHILE(ERRSW=OFF);/* FORMAT LOOP*/
         LA    ARRAYCNT,1                                          0243
@DL00243 TM    ERRSW,B'00100000'                                   0243
         BNZ   @DC00243                                            0243
*             IF RT2ARRAY(ARRAYCNT)>=SPEC THEN                     0244
         LR    @14,ARRAYCNT                                        0244
         SLA   @14,2                                               0244
         L     @14,RT2ARRAY-4(@14)                                 0244
         CH    @14,@CH01675                                        0244
         BL    @RF00244                                            0244
*               CALL SPECIAL;       /* ROUTINE TO DIFFERENCIATE SU'S */
         BAL   @14,SPECIAL                                         0245
*             ELSE                                                 0246
*               IF RT2ARRAY(ARRAYCNT)=BLANK THEN                   0246
         B     @RC00244                                            0246
@RF00244 LR    @14,ARRAYCNT                                        0246
         SLA   @14,2                                               0246
         L     @14,RT2ARRAY-4(@14)                                 0246
         CH    @14,@CH02753                                        0246
         BNE   @RF00246                                            0246
*                 CALL PRINT;       /* PRINT A BLANK LINE            */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0247
         BALR  @14,@15                                             0247
*               ELSE                                               0248
*                 DO;               /* LINE TO BE OUTPUT             */
         B     @RC00246                                            0248
@RF00246 DS    0H                                                  0249
*                   LINEPTR=RTM2NAME(RT2ARRAY(ARRAYCNT));/* FORMAT 0249
*                                      PATTERN PTR                   */
         LR    @14,ARRAYCNT                                        0249
         SLA   @14,2                                               0249
         L     @14,RT2ARRAY-4(@14)                                 0249
         LR    @07,@14                                             0249
         SLA   @07,2                                               0249
         L     LINEPTR,RTM2NAME-4(@07)                             0249
*                   IF RT2ARRAY(ARRAYCNT)>=9 THEN/* TITLE LINE OR  0250
*                                      HEADER TEXT                   */
         CH    @14,@CH01564                                        0250
         BL    @RF00250                                            0250
*                     DO;                                          0251
*                       BUFFER=TITLE;/* PUT IN BUFFER                */
         L     @14,ADPLBUF(,ABDPLPTR)                              0252
         MVI   BUFFER+31(@14),C' '                                 0252
         MVC   BUFFER+32(88,@14),BUFFER+31(@14)                    0252
         LR    @07,LINEPTR                                         0252
         MVC   BUFFER(31,@14),TITLE(@07)                           0252
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0253
         BALR  @14,@15                                             0253
*                     END;          /* END A TITLE LINE              */
*                   ELSE                                           0255
*                     DO;           /* FORMATTED LINE                */
         B     @RC00250                                            0255
@RF00250 DS    0H                                                  0256
*                       CALL CONVERT;/* GEN OFFSET                   */
         BAL   @14,CONVERT                                         0256
*                       CALL FMTRTN;/* FORMAT                        */
         BAL   @14,FMTRTN                                          0257
*                     END;          /* END FORMAT LINE               */
*                 END;              /* END LINE TO BE OUTPUT         */
@RC00250 DS    0H                                                  0260
*           END;                    /* END FORMAT LOOP               */
@RC00246 DS    0H                                                  0260
@RC00244 AH    ARRAYCNT,@CH00042                                   0260
         CH    ARRAYCNT,@CH03443                                   0260
         BNH   @DL00243                                            0260
@DC00243 DS    0H                                                  0261
*           IF ERRSW=OFF THEN       /* FORMATTED WITHOUT PROBLEM     */
         TM    ERRSW,B'00100000'                                   0261
         BNZ   @RF00261                                            0261
*             DO;                                                  0262
*               CALL RT2SUM;        /* FORMAT RTM2WA SUMMARY         */
*                                                                  0263
         BAL   @14,RT2SUM                                          0263
*               /*****************************************************/
*               /*                                                   */
*               /* IF RTM2WA FORMATTED ALL PARTS WITHOUT ANY         */
*               /* PROBLEMS, SEND THE SVRB ADDRESS TO THE MAIN       */
*               /* ROUTINE FOR THE ESA BIT SUMMARY                   */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0264
*               IF RCREG=ZERO THEN  /* SUMMARIES OK                  */
         LTR   RCREG,RCREG                                         0264
         BNZ   @RF00264                                            0264
*                 DO;                                              0265
*                   VADR=ADDR(RTM2VRBC);/* GET ADDR OF RELATED SVRB  */
         LA    VADR,RTM2VRBC(,RTM2PTR)                             0266
*                   CALL ACCESRTN;  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0267
*                   IF RCREG=ZERO THEN/* PASS BACK SVRB ADR TO MAIN
*                                      PROCEDURE                     */
         SLR   @14,@14                                             0268
         CR    RCREG,@14                                           0268
         BNE   @RF00268                                            0268
*                     DO;                                          0269
*                       ADPLFMT2=DATAWORD;/* PUT SVRB ADDR IN      0270
*                                      PARMLIST                      */
         MVC   ADPLFMT2(4,ABDPLPTR),DATAWORD(DATAPTR)              0270
*                       START=ZERO; /* OFFSET FOR CONTROL BLOCK      */
         ST    @14,START(,ABDPLPTR)                                0271
*                     END;          /* FOUND SVRB                    */
*                   ELSE                                           0273
*                     ;             /* ACCESS ERROR -BAD RC WILL BE
*                                      PASSED TO MAIN PROC INHIBITING
*                                      ESA PROCESSING                */
@RF00268 DS    0H                                                  0274
*                 END;              /* END SUMMARIES OK              */
*               ELSE                                               0275
*                 ;                 /* SUMMARIES HAD ERROR           */
@RF00264 DS    0H                                                  0276
*             END;                  /* END FORMATTED WITHOUT PROBLEM */
*           ELSE                                                   0277
*             ;                     /* ERROR FORMATTING              */
@RF00261 DS    0H                                                  0278
*         END;                      /* END FOUND SYSTEM              */
*       ELSE                                                       0279
*         ;                         /* COULD NOT FIND SYSTEM         */
@RF00232 DS    0H                                                  0280
*     END;                          /* END FOUND RELEASE NUMBER      */
*   CALL PRINT;                     /* ERROR MSG OR BLANK            */
@RC00197 L     @15,ADPLPRNT(,ABDPLPTR)                             0281
         BALR  @14,@15                                             0281
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS EXPECTED RETRY
*                                      REGS                          */
         L     @14,ESTAPTR                                         0282
         MVC   LCALREGS(64,@14),RTYREGS(@14)                       0282
*   RETURN CODE(RCCODE);            /* TO PREVENT ENTERING ESA CODE  */
         L     @08,RCCODE                                          0283
         L     @13,4(,@13)                                         0283
         L     @00,@SIZDATD                                        0283
         LR    @01,@09                                             0283
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@08                                             0283
         L     @14,12(,@13)                                        0283
         LM    @00,@12,20(@13)                                     0283
         BR    @14                                                 0283
*RT2SUM:                                                           0284
*   PROC OPTIONS(SAVE(14));                                        0284
*                                                                  0284
RT2SUM   ST    @14,@SA00002                                        0284
*/********************************************************************/
*/* FUNCTION -                                                     0285
*      ROUTINE WHICH FORMATS THE RTM2 WORK AREA SUMMARY.           0285
*      IT SETS UP THE NEEDED POINTERS TO BE PASSED TO THE FORMAT   0285
*      ROUTINE SENT IN THE PARAMETER LIST.  FOR ANY ERROR ACCESSING
*      A NEEDED FIELD IN THE RTM2WA OR FOR NON-ZERO RETURN CODE    0285
*      FROM THE FORMATTING SERVICE, THE FOLLOWING MESSAGE WILL BE  0285
*      PRINTED:                                                    0285
*               *** FORMATTING SERVICE ROUTINE ERROR DURING        0285
*               RTM2WA FORMATTING(POSSIBLE CAUSE:  DATA NOT IN     0285
*               DUMP) ***                                          0285
*      AT THIS POINT PROCESSING WOULD TERMINATE. IF THE RTM2WA IS  0285
*      FORMATTED WITHOUT ERROR, A BIT SUMMARY OF THE RTM2WA IMPORTANT
*      AREA IS PRINTED.                                            0285
*                                                                  0285
*   INPUT -                                                        0285
*      THIS ROUTINE EXPECTS THE PARAMETER LIST ADDRESS IN REGISTER 1,
*      THE ADDRESS OF THE RTM2WA IN RTM2PTR, AND THE SUSAVE BITS FILLED
*      IN.                                                         0285
*                                                                  0285
*   CALLS -                                                        0285
*      CALLS CONVERT, FMTRTN, PRINT,AND RT2BITS                    0285
*                                                                  0285
*   CALLED BY -                                                    0285
*      IEAFTRT2 TO FORMAT THE RTM2WA SUMMARY                       0285
*                                                                  0285
*   RETURNS TO -                                                   0285
*      IEAFTRT2 WITH RETURN CODE SET BY FORMAT                     0285
*      SERVICE ROUTINES                                              */
*/********************************************************************/
*                                                                  0285
*   CALL PRINT;                     /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0285
         BALR  @14,@15                                             0285
*   BUFFER(31:(LENGTH(RT2SMHDR)+30))=RT2SMHDR;/* SUMMARY HEADER      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0286
         MVC   BUFFER+30(14,@14),RT2SMHDR                          0286
*   CALL PRINT;                     /* PRINT HDR                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0287
         BALR  @14,@15                                             0287
*   BUFFER(31:(LENGTH(RT2SMUS)+30))=RT2SMUS;/* UNDERSCORE            */
         L     @14,ADPLBUF(,ABDPLPTR)                              0288
         MVC   BUFFER+30(14,@14),RT2SMUS                           0288
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0289
         BALR  @14,@15                                             0289
*   CALL PRINT;                     /* BLANK                         */
*                                                                  0290
         L     @15,ADPLPRNT(,ABDPLPTR)                             0290
         BALR  @14,@15                                             0290
*   /*****************************************************************/
*   /*                                                               */
*   /* FIRST GROUP OF SUMMARY OUTPUT - ABEND INFORMATION             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0291
*   DO ARRAYCNT=1 TO GROUP1 WHILE(ERRSW=OFF);/* FORMAT GROUP 1       */
         LA    ARRAYCNT,1                                          0291
@DL00291 TM    ERRSW,B'00100000'                                   0291
         BNZ   @DC00291                                            0291
*     FIELDADR=FIELDARY(ARRAYCNT);  /* ADDRESS OF FIELD IS INAN ARRAY*/
         LR    @14,ARRAYCNT                                        0292
         SLA   @14,2                                               0292
         L     FIELDADR,FIELDARY-4(@14)                            0292
*     ADPLFMT2=FIELDADR+RTM2PTR;    /* ADR OF FIELD TO BE FORMATTED  */
         LR    @04,FIELDADR                                        0293
         ALR   @04,RTM2PTR                                         0293
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0293
*     LINEPTR=SUMNAMES(ARRAYCNT);   /* FORMAT PATTERN WHICH MATCHES
*                                      FIELD                         */
         L     LINEPTR,SUMNAMES-4(@14)                             0294
*     CALL CONVERT;                 /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0295
*     CALL FMTRTN;                  /* FORMAT THE LINE MACRO TO SET
*                                      UP FOR SUMMARY                */
         BAL   @14,FMTRTN                                          0296
*   END;                                                           0297
*                                                                  0297
         AH    ARRAYCNT,@CH00042                                   0297
         CH    ARRAYCNT,@CH00312                                   0297
         BNH   @DL00291                                            0297
@DC00291 DS    0H                                                  0298
*   /*****************************************************************/
*   /*                                                               */
*   /* SECOND GROUP OF OUTPUT - REGS, PSW, AND SDWA COMPLETION CODE  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0298
*   IF ERRSW=OFF THEN               /* FORMATTED FIRST SECTION OK    */
         TM    ERRSW,B'00100000'                                   0298
         BNZ   @RF00298                                            0298
*     DO;                                                          0299
*       CALL PRINT;                 /* BLANK TO SEPARATE SECTIONS    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0300
         BALR  @14,@15                                             0300
*       DO ARRAYCNT=ARRAYCNT TO GROUP2 WHILE(ERRSW=OFF);/* FORMAT  0301
*                                      NEXT SECTION(2)               */
         B     @DE00301                                            0301
@DL00301 TM    ERRSW,B'00100000'                                   0301
         BNZ   @DC00301                                            0301
*         FIELDADR=FIELDARY(ARRAYCNT);/* ADDRESS OF FIELD IS INAN  0302
*                                      ARRAY                         */
         LR    @14,ARRAYCNT                                        0302
         SLA   @14,2                                               0302
         L     FIELDADR,FIELDARY-4(@14)                            0302
*         ADPLFMT2=FIELDADR+RTM2PTR;/* ADR OF FIELD TO BE FORMATTED  */
         LR    @04,FIELDADR                                        0303
         ALR   @04,RTM2PTR                                         0303
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0303
*         LINEPTR=SUMNAMES(ARRAYCNT);/* FORMAT PATTERN WHICH MATCHES
*                                      FIELD                         */
         L     LINEPTR,SUMNAMES-4(@14)                             0304
*         CALL CONVERT;             /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0305
*         CALL FMTRTN;              /* FORMAT THE LINE MACRO TO    0306
*                                      FORMAT                        */
         BAL   @14,FMTRTN                                          0306
*       END;                        /* END FORMAT SECTION 2          */
*                                                                  0307
         AH    ARRAYCNT,@CH00042                                   0307
@DE00301 CH    ARRAYCNT,@CH00778                                   0307
         BNH   @DL00301                                            0307
@DC00301 DS    0H                                                  0308
*       /*************************************************************/
*       /*                                                           */
*       /* THIRD GROUP - RETRY INFORMATION                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0308
*       IF ERRSW=OFF THEN           /* FORMATTED SECTION 2 WITHOUT 0308
*                                      PROBLEM                       */
         TM    ERRSW,B'00100000'                                   0308
         BNZ   @RF00308                                            0308
*         DO;                                                      0309
*           CALL PRINT;             /* SEPARATE GROUPS WITH A BLANK  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0310
         BALR  @14,@15                                             0310
*           VADR=ADDR(RTM2RCDE);    /* RETURN CODE FROM RETRY        */
         LA    VADR,RTM2RCDE(,RTM2PTR)                             0311
*           CALL ACCESRTN;          /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0312
*           IF RCREG^=ZERO THEN                                    0313
         LTR   RCREG,RCREG                                         0313
         BZ    @RF00313                                            0313
*             BUFFER(1:LENGTH(RT2FMT))=RT2FMT;                     0314
         L     @14,ADPLBUF(,ABDPLPTR)                              0314
         MVC   BUFFER(120,@14),RT2FMT                              0314
*           ELSE                                                   0315
*             DO;                   /* FOUND RETURN CODE             */
         B     @RC00313                                            0315
@RF00313 DS    0H                                                  0316
*               ADPLFMT2=ADDR(RTM2RCDE);/* RETURN CODE FROM RETRY    */
         LA    @14,RTM2RCDE(,RTM2PTR)                              0316
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0316
*               CALL CONVERT;       /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0317
*               OFFSET=CONVERTD;    /* PLACE IN BUFFER               */
         L     @14,ADPLBUF(,ABDPLPTR)                              0318
         MVC   OFFSET(6,@14),CONVERTD                              0318
*               BUFFER(9:(LENGTH(RCMSG)+8))=RCMSG;/* PLACE MESSAGE IN
*                                      BUFFER                        */
         MVC   BUFFER+8(34,@14),RCMSG                              0319
*               PACKAREA(4:4)=DATABYTE;/* RETURN CODE FROM RETRY     */
         MVC   PACKAREA+3(1),DATABYTE(DATAPTR)                     0320
*               GARBAGE='04'X;      /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0321
*               UNPK(BUFFER(LENGTH(RCMSG)+9:LENGTH(RCMSG)+11),UNPACK(4:
*                   5));            /* PLACE IN BUFFER               */
         UNPK  BUFFER+42(3,@14),UNPACK+3(2)                        0322
*               TR(BUFFER(LENGTH(RCMSG)+9:LENGTH(RCMSG)+11),TRANS);/*
*                                      TRANSLATE TO PRINTABLE HEX    */
         TR    BUFFER+42(3,@14),TRANS                              0323
*               RFY                                                0324
*                 ENDMSG BASED(ADDR(BUFFER)+(LENGTH(RCMSG)+10));/* 0324
*                                      REBASE END OF MESSAGE         */
*               IF DATABYTE=ZEROBYTE THEN                          0325
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0325
         BNE   @RF00325                                            0325
*                 ENDMSG(1:LENGTH(RCEND1))=RCEND1;/* PROPER ENDING   */
         MVC   ENDMSG+44(46,@14),RCEND1                            0326
*               ELSE                                               0327
*                 IF DATABYTE='04'X|DATABYTE='08'X|DATABYTE='0C'X THEN
         B     @RC00325                                            0327
@RF00325 CLI   DATABYTE(DATAPTR),4                                 0327
         BE    @RT00327                                            0327
         CLI   DATABYTE(DATAPTR),8                                 0327
         BE    @RT00327                                            0327
         CLI   DATABYTE(DATAPTR),12                                0327
         BNE   @RF00327                                            0327
@RT00327 DS    0H                                                  0328
*                   ENDMSG(1:LENGTH(RCEND2))=RCEND2;/* RETRY ENDING  */
         L     @14,ADPLBUF(,ABDPLPTR)                              0328
         MVC   ENDMSG+44(6,@14),RCEND2                             0328
*                 ELSE                                             0329
*                   IF DATABYTE='10'X THEN                         0329
         B     @RC00327                                            0329
@RF00327 CLI   DATABYTE(DATAPTR),16                                0329
         BNE   @RF00329                                            0329
*                     ENDMSG(1:LENGTH(RCEND3))=RCEND3;/* PROPER    0330
*                                      ENDING-PREVENT FURTHER      0330
*                                      PROCESSING                    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0330
         MVC   ENDMSG+44(64,@14),RCEND3                            0330
*                   ELSE                                           0331
*                     ENDMSG(1:LENGTH(RCEND4))=RCEND4;/* UNKNOWN     */
         B     @RC00329                                            0331
@RF00329 L     @14,ADPLBUF(,ABDPLPTR)                              0331
         MVC   ENDMSG+44(14,@14),RCEND4                            0331
*               CALL PRINT;         /* PRINT LINE                    */
@RC00329 DS    0H                                                  0332
@RC00327 DS    0H                                                  0332
@RC00325 L     @15,ADPLPRNT(,ABDPLPTR)                             0332
         BALR  @14,@15                                             0332
*               DO ARRAYCNT=ARRAYCNT TO GROUP3 WHILE(ERRSW=OFF);/* 0333
*                                      NEXT GROUP                    */
         B     @DE00333                                            0333
@DL00333 TM    ERRSW,B'00100000'                                   0333
         BNZ   @DC00333                                            0333
*                 FIELDADR=FIELDARY(ARRAYCNT);/* ADDRESS OF FIELD IS
*                                      INAN ARRAY                    */
         LR    @14,ARRAYCNT                                        0334
         SLA   @14,2                                               0334
         L     FIELDADR,FIELDARY-4(@14)                            0334
*                 ADPLFMT2=FIELDADR+RTM2PTR;/* ADR OF FIELD TO BE  0335
*                                      FORMATTED                     */
         LR    @04,FIELDADR                                        0335
         ALR   @04,RTM2PTR                                         0335
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0335
*                 LINEPTR=SUMNAMES(ARRAYCNT);/* FORMAT PATTERN WHICH
*                                      MATCHES FIELD                 */
         L     LINEPTR,SUMNAMES-4(@14)                             0336
*                 CALL CONVERT;     /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0337
*                 CALL FMTRTN;      /* FORMAT THE LINE MACRO TO    0338
*                                      FORMAT                        */
         BAL   @14,FMTRTN                                          0338
*               END;                /* END GROUP3                    */
*                                                                  0339
         AH    ARRAYCNT,@CH00042                                   0339
@DE00333 CH    ARRAYCNT,@CH01564                                   0339
         BNH   @DL00333                                            0339
@DC00333 DS    0H                                                  0340
*               /*****************************************************/
*               /*                                                   */
*               /* FOURTH GROUP - CONTROL BLOCK POINTERS             */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0340
*               IF ERRSW=OFF THEN   /* FORMATTED GROUP 3 OK          */
         TM    ERRSW,B'00100000'                                   0340
         BNZ   @RF00340                                            0340
*                 DO;                                              0341
*                   CALL PRINT;     /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0342
         BALR  @14,@15                                             0342
*                   DO ARRAYCNT=ARRAYCNT TO GROUP4 WHILE(ERRSW=OFF);
         B     @DE00343                                            0343
@DL00343 TM    ERRSW,B'00100000'                                   0343
         BNZ   @DC00343                                            0343
*                                   /* FORMAT FOURTH GROUP           */
*                     FIELDADR=FIELDARY(ARRAYCNT);/* ADDRESS OF FIELD
*                                      IS INAN ARRAY                 */
         LR    @14,ARRAYCNT                                        0344
         SLA   @14,2                                               0344
         L     FIELDADR,FIELDARY-4(@14)                            0344
*                     ADPLFMT2=FIELDADR+RTM2PTR;/* ADR OF FIELD TO BE
*                                      FORMATTED                     */
         LR    @04,FIELDADR                                        0345
         ALR   @04,RTM2PTR                                         0345
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0345
*                     LINEPTR=SUMNAMES(ARRAYCNT);/* FORMAT PATTERN 0346
*                                      WHICH MATCHES FIELD           */
         L     LINEPTR,SUMNAMES-4(@14)                             0346
*                     CALL CONVERT; /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0347
*                     CALL FMTRTN;  /* FORMAT THE LINE MACRO TO    0348
*                                      FORMAT                        */
         BAL   @14,FMTRTN                                          0348
*                   END;            /* END GROUP 4                   */
*                                                                  0349
         AH    ARRAYCNT,@CH00042                                   0349
@DE00343 CH    ARRAYCNT,@CH00781                                   0349
         BNH   @DL00343                                            0349
@DC00343 DS    0H                                                  0350
*                   /*************************************************/
*                   /*                                               */
*                   /* FIFTH GROUP - ASID INFORMATION                */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0350
*                   IF ERRSW=OFF THEN/* FORMATTED GROUP 4 OK         */
         TM    ERRSW,B'00100000'                                   0350
         BNZ   @RF00350                                            0350
*                     DO;                                          0351
*                       CALL PRINT; /* SEPERATE SECTIONS WITH A BLANK
*                                      LINE                          */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0352
         BALR  @14,@15                                             0352
*                       DO ARRAYCNT=ARRAYCNT TO GROUP5 WHILE(ERRSW=OFF)
*                             ;                                    0353
         B     @DE00353                                            0353
@DL00353 TM    ERRSW,B'00100000'                                   0353
         BNZ   @DC00353                                            0353
*                         FIELDADR=FIELDARY(ARRAYCNT);/* ADDRESS OF
*                                      FIELD IS INAN ARRAY           */
         LR    @14,ARRAYCNT                                        0354
         SLA   @14,2                                               0354
         L     FIELDADR,FIELDARY-4(@14)                            0354
*                         ADPLFMT2=FIELDADR+RTM2PTR;/* ADR OF FIELD
*                                      TO BE FORMATTED               */
         LR    @04,FIELDADR                                        0355
         ALR   @04,RTM2PTR                                         0355
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0355
*                         LINEPTR=SUMNAMES(ARRAYCNT);/* FORMAT     0356
*                                      PATTERN WHICH MATCHES FIELD   */
         L     LINEPTR,SUMNAMES-4(@14)                             0356
*                         CALL CONVERT;/* GENERATE OFFSET            */
         BAL   @14,CONVERT                                         0357
*                         CALL FMTRTN;/* FORMAT THE LINE FORMAT ERROR
*                                      ID                            */
         BAL   @14,FMTRTN                                          0358
*                       END;        /* END GROUP 5                   */
         AH    ARRAYCNT,@CH00042                                   0359
@DE00353 CH    ARRAYCNT,@CH01707                                   0359
         BNH   @DL00353                                            0359
@DC00353 DS    0H                                                  0360
*                       IF SU17SAVE=ON THEN/* ERROR ID TO BE       0360
*                                      FORMATTED                     */
         TM    SU17SAVE,B'10000000'                                0360
         BNO   @RF00360                                            0360
*                         DO;                                      0361
*                           FIELDADR=FIELDARY(ARRAYCNT);/* ADDRESS OF
*                                      FIELD IS INAN ARRAY           */
         LR    @14,ARRAYCNT                                        0362
         SLA   @14,2                                               0362
         L     FIELDADR,FIELDARY-4(@14)                            0362
*                           ADPLFMT2=FIELDADR+RTM2PTR;/* ADR OF FIELD
*                                      TO BE FORMATTED               */
         LR    @04,FIELDADR                                        0363
         ALR   @04,RTM2PTR                                         0363
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0363
*                           LINEPTR=SUMNAMES(ARRAYCNT);/* FORMAT   0364
*                                      PATTERN WHICH MATCHES FIELD   */
         L     LINEPTR,SUMNAMES-4(@14)                             0364
*                           CALL CONVERT;/* GENERATE OFFSET          */
         BAL   @14,CONVERT                                         0365
*                           CALL FMTRTN;/* FORMAT THE LINE FORMAT  0366
*                                      ERROR ID                      */
         BAL   @14,FMTRTN                                          0366
*                         END;      /* END FORMAT ERROR ID           */
*                       ELSE                                       0368
*                         ;         /* ERRID NOT TO BE FORMATTED     */
*                                                                  0368
@RF00360 DS    0H                                                  0369
*                       /*********************************************/
*                       /*                                           */
*                       /* SIXTH GROUP - TRACE TABLE ENTRY PTRS FOR  */
*                       /* SU33                                      */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0369
*                       IF ERRSW=OFF&SU33SAVE=ON THEN/* GROUP 5    0369
*                                      FORMATTED OK AND SU33 TRACE 0369
*                                      ENTRIES ARE TO BE FORMATTED   */
         TM    SU33SAVE,B'01000000'                                0369
         BNO   @RF00369                                            0369
         TM    ERRSW,B'00100000'                                   0369
         BNZ   @RF00369                                            0369
*                         DO;                                      0370
*                           CALL PRINT;/* SEPERATE SECTIONS WITH A 0371
*                                      BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0371
         BALR  @14,@15                                             0371
*                           DO ARRAYCNT=ARRAYCNT+1 TO GROUP6 WHILE(
*                                 ERRSW=OFF);                      0372
         LA    @14,1                                               0372
         ALR   @14,ARRAYCNT                                        0372
         LR    ARRAYCNT,@14                                        0372
         B     @DE00372                                            0372
@DL00372 TM    ERRSW,B'00100000'                                   0372
         BNZ   @DC00372                                            0372
*                             FIELDADR=FIELDARY(ARRAYCNT);/* ADDRESS
*                                      OF FIELD IS INAN ARRAY        */
         LR    @14,ARRAYCNT                                        0373
         SLA   @14,2                                               0373
         L     FIELDADR,FIELDARY-4(@14)                            0373
*                             ADPLFMT2=FIELDADR+RTM2PTR;/* ADR OF  0374
*                                      FIELD TO BE FORMATTED         */
         LR    @04,FIELDADR                                        0374
         ALR   @04,RTM2PTR                                         0374
         ST    @04,ADPLFMT2(,ABDPLPTR)                             0374
*                             LINEPTR=SUMNAMES(ARRAYCNT);/* FORMAT 0375
*                                      PATTERN WHICH MATCHES FIELD   */
         L     LINEPTR,SUMNAMES-4(@14)                             0375
*                             CALL CONVERT;/* GENERATE OFFSET        */
         BAL   @14,CONVERT                                         0376
*                             CALL FMTRTN;/* FORMAT THE LINE FORMAT
*                                      ERROR ID                      */
         BAL   @14,FMTRTN                                          0377
*                           END;    /* END FORMAT ERROR ID           */
         AH    ARRAYCNT,@CH00042                                   0378
@DE00372 CH    ARRAYCNT,@CH02753                                   0378
         BNH   @DL00372                                            0378
@DC00372 DS    0H                                                  0379
*                           IF ERRSW=OFF THEN                      0379
         TM    ERRSW,B'00100000'                                   0379
         BNZ   @RF00379                                            0379
*                             CALL RT2BITS;/* DO BIT SUMMARY IF    0380
*                                      FORMATTED FULL SUMMARY WITHOUT
*                                      ERROR                         */
         BAL   @14,RT2BITS                                         0380
*                           ELSE                                   0381
*                             ;     /* ERROR DURING SUMMARY        0381
*                                      FORMATTING                    */
@RF00379 DS    0H                                                  0382
*                         END;      /* END NO ERROR FORMATTING GROUP
*                                      5                             */
*                       ELSE                                       0383
*                         ;         /* ERROR IN FORMATTING GROUP 5   */
@RF00369 DS    0H                                                  0384
*                     END;          /* END NO ERROR FORMATTING GROUP
*                                      4                             */
*                   ELSE                                           0385
*                     ;             /* ERROR IN FORMATTING GROUP 4   */
@RF00350 DS    0H                                                  0386
*                 END;              /* END NO ERROR FORMATTING GROUP
*                                      3                             */
*               ELSE                                               0387
*                 ;                 /* ERROR IN FORMATTING GROUP 3   */
@RF00340 DS    0H                                                  0388
*             END;                  /* END FOUND RETURN CODE FROM  0388
*                                      RETRY                         */
*         END;                      /* END NO ERROR FORMATTING     0389
*                                      SECTION 2                     */
*       ELSE                                                       0390
*         ;                         /* ERROR IN FORMATTING GROUP 2   */
@RF00308 DS    0H                                                  0391
*     END;                          /* END NO ERROR FORMATTING     0391
*                                      SECTION 1                     */
*   ELSE                                                           0392
*     ;                             /* ERROR IN FORMATTING GROUP 1   */
@RF00298 DS    0H                                                  0393
*   RETURN CODE(RCCODE);                                           0393
@RC00298 L     @15,RCCODE                                          0393
@EL00002 DS    0H                                                  0393
@EF00002 DS    0H                                                  0393
@ER00002 L     @14,@SA00002                                        0393
         BR    @14                                                 0393
*   END RT2SUM;                                                    0394
*RT2BITS:                                                          0395
*   PROC OPTIONS(SAVE(14));                                        0395
*                                                                  0395
RT2BITS  ST    @14,@SA00003                                        0395
*/********************************************************************/
*/* FUNCTION -                                                     0396
*      ROUTINE WHICH FORMATS THE RTM2 WORK AREA BIT SUMMARY.       0396
*      IT SETS UP THE NEEDED POINTERS TO BE PASSED TO THE ANALYZE  0396
*      ROUTINE.  IF THERE IS AN ACCESS ERROR LOCATING A NEEDED FIELD
*      IN THE RTM2WA THE BIT ANALYZING FOR THAT BYTE IS BYPASSED.  0396
*                                                                  0396
*   CALLS -                                                        0396
*      CALLS ANALYZE, ACCESRTN, CONVERT, HDROUT, AND PRINT         0396
*                                                                  0396
*   INPUT -                                                        0396
*      THIS ROUTINE EXPECTS THE PARAMETER LIST ADDRESS IN REGISTER 1,
*      THE ADDRESS OF THE RTM2WA IN RTM2PTR, AND THE SUSAVE BITS FILLED
*      IN.                                                         0396
*                                                                  0396
*   CALLED BY -                                                    0396
*      RT2SUM TO FORMAT THE RTM2WA BIT FLAG SUMMARY                0396
*                                                                  0396
*   RETURNS TO -                                                   0396
*      RT2SUM WITH RETURN CODE SET BY ACCESS SERVICE               0396
*      ROUTINE                                                       */
*/********************************************************************/
*                                                                  0396
*   HDRBIT=OFF;                     /* HEADER INDICATOR              */
         NI    HDRBIT,B'11101111'                                  0396
*   CALL PRINT;                     /* BLANK TO SEPARATE SECTION     */
*                                                                  0397
         L     @15,ADPLPRNT(,ABDPLPTR)                             0397
         BALR  @14,@15                                             0397
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE COMMUNICATIONS FLAG BYTE                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0398
*   VADR=ADDR(RTM2CTLR);            /* COMMUNICATIONS FLAG           */
         LA    VADR,RTM2CTLR(,RTM2PTR)                             0398
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0399
*   IF DATABYTE^=ZEROBYTE&RCREG=ZERO THEN/* IT NEEDS TO BE ANALYZED  */
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0400
         BE    @RF00400                                            0400
         LTR   RCREG,RCREG                                         0400
         BNZ   @RF00400                                            0400
*     DO;                                                          0401
*       CALL HDROUT;                /* PUT OUT SUMMARY HEADER        */
         BAL   @14,HDROUT                                          0402
*       ADPLFMT2=ADDR(RTM2CTLR);    /* NEEDED TO GENERAT OFFSET      */
         LA    @14,RTM2CTLR(,RTM2PTR)                              0403
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0403
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0404
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0404
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0405
*       MSGADDR=ADDR(CTLRMSG);      /* MESSAGE ARRAY                 */
         LA    @14,CTLRMSG                                         0406
         ST    @14,MSGADDR                                         0406
*       MSGLNGTH=LENGTH(CTLRMSG);   /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF01628                                0407
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0408
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0409
         MVC   OFFSET(6,@14),CONVERTD                              0409
*       COLNUM=DEFAULT;             /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF00087                                  0410
*       CALL ANALYZE;               /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0411
*     END;                          /* END BYTE NEEDS TO BE ANALYZED */
*   ELSE                                                           0413
*     ;                             /* BYTE DOES NOT NEED ANALYZED   */
*                                                                  0413
@RF00400 DS    0H                                                  0414
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE TYPE OF TERMINATION BYTE                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0414
*   VADR=ADDR(RTM2RMPL);            /* TERMINATION BYTE              */
         LA    VADR,RTM2RMPL(,RTM2PTR)                             0414
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0415
*   IF RCREG=ZERO THEN              /* BYTE NEEDS ANALYZED           */
         LTR   RCREG,RCREG                                         0416
         BNZ   @RF00416                                            0416
*     DO;                                                          0417
*       CALL HDROUT;                /* PUT OUT SUMMARY HEADER IF   0418
*                                      NEEDED                        */
         BAL   @14,HDROUT                                          0418
*       ADPLFMT2=ADDR(RTM2RMPL);                                   0419
         LA    @14,RTM2RMPL(,RTM2PTR)                              0419
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0419
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0420
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0420
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0421
*       MSGADDR=ADDR(RMPLMSG);      /* MESSAGE ARRAY                 */
         LA    @14,RMPLMSG                                         0422
         ST    @14,MSGADDR                                         0422
*       MSGLNGTH=LENGTH(RMPLMSG);   /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF03634                                0423
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0424
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0425
         MVC   OFFSET(6,@14),CONVERTD                              0425
*       COLNUM=DEFAULT;             /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF00087                                  0426
*       IF(DATABYTE&TASKBIT)=ZEROBYTE THEN/* TASK TERMINATION BIT    */
         LA    @07,64                                              0427
         SLR   @05,@05                                             0427
         IC    @05,DATABYTE(,DATAPTR)                              0427
         NR    @07,@05                                             0427
         SLR   @05,@05                                             0427
         IC    @05,ZEROBYTE                                        0427
         CR    @07,@05                                             0427
         BNE   @RF00427                                            0427
*         DO;                                                      0428
*           BUFFER(8:LENGTH(RMPLMSG1)+7)=RMPLMSG1;                 0429
         MVC   BUFFER+7(16,@14),RMPLMSG1                           0429
*           CALL PRINT;             /* PRINT BIT INDICATOR           */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0430
         BALR  @14,@15                                             0430
*         END;                      /* END TASK TERMINATION BIT      */
*       ELSE                                                       0432
*         ;                                                        0432
@RF00427 DS    0H                                                  0433
*       CALL ANALYZE;               /* ANALYZE THE BYTE              */
         BAL   @14,ANALYZE                                         0433
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0435
*     ;                             /* BYTE DOES NOT NEED ANALYZE    */
*                                                                  0435
@RF00416 DS    0H                                                  0436
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE ERROR BYTE A                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0436
*   VADR=ADDR(RTM2ERRA);            /* ERROR BYTE A                  */
         LA    VADR,RTM2ERRA(,RTM2PTR)                             0436
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0437
*   IF RCREG=ZERO&DATABYTE^=ZEROBYTE THEN/* NEEDS RESOLVING          */
         LTR   RCREG,RCREG                                         0438
         BNZ   @RF00438                                            0438
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0438
         BE    @RF00438                                            0438
*     DO;                                                          0439
*       CALL HDROUT;                /* PUT OUT SUMMARY HEADER IF   0440
*                                      NEEDED                        */
         BAL   @14,HDROUT                                          0440
*       ADPLFMT2=ADDR(RTM2ERRA);                                   0441
         LA    @14,RTM2ERRA(,RTM2PTR)                              0441
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0441
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0442
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0442
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0443
*       MSGADDR=ADDR(ERRAMSG);      /* MESSAGE ARRAY                 */
         LA    @14,ERRAMSG                                         0444
         ST    @14,MSGADDR                                         0444
*       MSGLNGTH=LENGTH(ERRAMSG);   /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF01641                                0445
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0446
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0447
         MVC   OFFSET(6,@14),CONVERTD                              0447
*       COLNUM=DEFAULT;             /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF00087                                  0448
*       CALL ANALYZE;               /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0449
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0451
*     ;                             /* BYTE DOES NOT NEED ANALYZED   */
*                                                                  0451
@RF00438 DS    0H                                                  0452
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE ERROR BYTE B                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0452
*   VADR=ADDR(RTM2ERRB);            /* ERROR BYTE B                  */
         LA    VADR,RTM2ERRB(,RTM2PTR)                             0452
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0453
*   IF RCREG=ZERO&DATABYTE^=ZEROBYTE THEN/* NEEDS RESOLVING          */
         LTR   RCREG,RCREG                                         0454
         BNZ   @RF00454                                            0454
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0454
         BE    @RF00454                                            0454
*     DO;                                                          0455
*       CALL HDROUT;                /* PUT OUT SUMMARY HEADER IF   0456
*                                      NEEDED                        */
         BAL   @14,HDROUT                                          0456
*       ADPLFMT2=ADDR(RTM2ERRB);                                   0457
         LA    @14,RTM2ERRB(,RTM2PTR)                              0457
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0457
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0458
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0458
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0459
*       MSGADDR=ADDR(ERRBMSG);      /* MESSAGE ARRAY                 */
         LA    @14,ERRBMSG                                         0460
         ST    @14,MSGADDR                                         0460
*       MSGLNGTH=LENGTH(ERRBMSG);   /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF03558                                0461
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0462
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0463
         MVC   OFFSET(6,@14),CONVERTD                              0463
*       COLNUM=DEFAULT;             /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF00087                                  0464
*       CALL ANALYZE;               /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0465
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0467
*     ;                             /* BYTE DOES NOT NEED ANALYZED   */
*                                                                  0467
@RF00454 DS    0H                                                  0468
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE ERROR BYTE D                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0468
*   VADR=ADDR(RTM2ERRD);            /* ERROR BYTE A                  */
         LA    VADR,RTM2ERRD(,RTM2PTR)                             0468
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0469
*   IF RCREG=ZERO&DATABYTE^=ZEROBYTE THEN/* NEEDS RESOLVING          */
         LTR   RCREG,RCREG                                         0470
         BNZ   @RF00470                                            0470
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0470
         BE    @RF00470                                            0470
*     DO;                                                          0471
*       ADPLFMT2=ADDR(RTM2ERRD);                                   0472
         LA    @14,RTM2ERRD(,RTM2PTR)                              0472
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0472
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0473
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0473
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0474
*       MSGADDR=ADDR(ERRDMSG);      /* MESSAGE ARRAY                 */
         LA    @14,ERRDMSG                                         0475
         ST    @14,MSGADDR                                         0475
*       MSGLNGTH=LENGTH(ERRDMSG);   /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF03574                                0476
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0477
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0478
         MVC   OFFSET(6,@14),CONVERTD                              0478
*       COLNUM=DEFAULT;             /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF00087                                  0479
*       CALL ANALYZE;               /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0480
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0482
*     ;                             /* BYTE DOES NOT NEED ANALYZED   */
@RF00470 DS    0H                                                  0483
*   RETURN CODE(RCCODE);                                           0483
         L     @15,RCCODE                                          0483
@EL00003 DS    0H                                                  0483
@EF00003 DS    0H                                                  0483
@ER00003 L     @14,@SA00003                                        0483
         BR    @14                                                 0483
*   END RT2BITS;                                                   0484
*HDROUT:                                                           0485
*   PROC OPTIONS(SAVE(14));                                        0485
*                                                                  0485
HDROUT   ST    @14,@SA00004                                        0485
*/********************************************************************/
*/* FUNCTION -                                                     0486
*      ROUTINE WHICH PRINTS THE BIT SUMMARY HEADER AND UNDERSCORE  0486
*      FOR THE RTM2WA BIT FLAG SUMMARY.                            0486
*                                                                  0486
*   CALLS -                                                        0486
*      PRINT                                                       0486
*                                                                  0486
*   INPUT -                                                        0486
*      EXPECTS REGISTER 1 TO POINT TO THE PARMLIST PASSED BY THE CALLER
*                                                                  0486
*   CALLED BY -                                                    0486
*      RT2BITS TO PRINT THE BIT SUMMARY HEADER IF NEEDED           0486
*                                                                  0486
*   RETURNS TO -                                                   0486
*      RT2BITS WITHOUT SETTING A RETURN CODE                         */
*/********************************************************************/
*                                                                  0486
*   IF HDRBIT=OFF THEN              /* NEEDS HEADER                  */
         TM    HDRBIT,B'00010000'                                  0486
         BNZ   @RF00486                                            0486
*     DO;                                                          0487
*       HDRBIT=ON;                  /* HEADER PUT OUT                */
         OI    HDRBIT,B'00010000'                                  0488
*       BUFFER(31:(LENGTH(RT2BSUM)+30))=RT2BSUM;/* SECTION HEADER    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0489
         MVC   BUFFER+30(23,@14),RT2BSUM                           0489
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0490
         BALR  @14,@15                                             0490
*       BUFFER(31:(LENGTH(RT2BSUS)+30))=RT2BSUS;/* UNDERSCORE        */
         L     @14,ADPLBUF(,ABDPLPTR)                              0491
         MVC   BUFFER+30(23,@14),RT2BSUS                           0491
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0492
         BALR  @14,@15                                             0492
*       CALL PRINT;                 /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0493
         BALR  @14,@15                                             0493
*     END;                          /* END NEEDS HEADER              */
*   ELSE                                                           0495
*     ;                             /* DOES NOT NEED HEADER          */
@RF00486 DS    0H                                                  0496
*   END HDROUT;                                                    0496
@EL00004 DS    0H                                                  0496
@EF00004 DS    0H                                                  0496
@ER00004 L     @14,@SA00004                                        0496
         BR    @14                                                 0496
*SPECIAL:                                                          0497
*   PROC OPTIONS(SAVE(14));                                        0497
*                                                                  0497
SPECIAL  ST    @14,@SA00005                                        0497
*/********************************************************************/
*/* FUNCTION -                                                     0498
*      ROUTINE WHICH FORMATS THE PART OF THE RTM2 WORK AREA THAT   0498
*      CHANGES FOR DIFFERENT SU CHANGES. IT CHECKS THE ARRAY NUMBER
*      TO DETERMINE WHAT DECISION HAS TO BE MADE AND FORMATS THE OUTPUT
*      LINE ACCORDINGLY.                                           0498
*                                                                  0498
*   CALLS -                                                        0498
*      CALLS CONVERT AND FMTRTN                                    0498
*                                                                  0498
*   INPUT -                                                        0498
*      EXPECTS SUSAVE BITS AND THE ARRAYCNT FILLED IN.             0498
*                                                                  0498
*   CALLED BY -                                                    0498
*      IEAFTRT2 TO FORMAT THE RTM2WA FIELDS CHANGED BY AN SU       0498
*                                                                  0498
*   RETURNS TO -                                                   0498
*      IEAFTRT2 WITH RETURN CODE SET BY FORMAT SERVICE             0498
*      ROUTINE                                                       */
*/********************************************************************/
*                                                                  0498
*   IF RT2ARRAY(ARRAYCNT)=102 THEN  /* FIELDS ADDED AT END FOR BOTH
*                                      SU17 & SU33                   */
         LR    @14,ARRAYCNT                                        0498
         SLA   @14,2                                               0498
         L     @14,RT2ARRAY-4(@14)                                 0498
         CH    @14,@CH01679                                        0498
         BNE   @RF00498                                            0498
*     DO;                                                          0499
*       IF SU33SAVE=ON THEN         /* SU33 ADDED 25 WORDS OVER SU0
*                                      BASE(3 OF WHICH WERE ADDED BY
*                                      SU17                          */
         TM    SU33SAVE,B'01000000'                                0500
         BNO   @RF00500                                            0500
*         DO;                                                      0501
*           LINEPTR=RTM2NAME(8);    /* SINCE 25 WORDS OF OUTPUT ARE
*                                      NEEDED AND 8 IS MAXIMUM LIMIT
*                                      FOR A LINE-NEED FOUR LINES OF
*                                      OUTPUT                @ZM45190*/
         L     LINEPTR,RTM2NAME+28                                 0502
*           CALL CONVERT;           /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0503
*           CALL FMTRTN;            /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0504
*           IF ERRSW=OFF THEN       /* NO PROBLEM PUTTING OUT LINE 1 */
         TM    ERRSW,B'00100000'                                   0505
         BNZ   @RF00505                                            0505
*             DO;                                                  0506
*               CALL CONVERT;       /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0507
*               CALL FMTRTN;        /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0508
*               IF ERRSW=OFF THEN   /* NO PROBLEM PUTTING OUT LINE 2 */
         TM    ERRSW,B'00100000'                                   0509
         BNZ   @RF00509                                            0509
*                 DO;                                              0510
*                   CALL CONVERT;   /* OFFSET                        */
         BAL   @14,CONVERT                                         0511
*                   CALL FMTRTN;    /* FORMAT                        */
         BAL   @14,FMTRTN                                          0512
*                   IF ERRSW=OFF THEN/* NO PROBLEM PUTTING OUT LINE 3
*                                                            @ZM45190*/
         TM    ERRSW,B'00100000'                                   0513
         BNZ   @RF00513                                            0513
*                     DO;           /*                       @ZM45190*/
*                       LINEPTR=RTM2NAME(1);/* ONE WORD OF DATA    0515
*                                                            @ZM45190*/
         L     LINEPTR,RTM2NAME                                    0515
*                       CALL CONVERT;/* OFFSET               @ZM95190*/
         BAL   @14,CONVERT                                         0516
*                       CALL FMTRTN;/* FORMAT                @ZM45190*/
         BAL   @14,FMTRTN                                          0517
*                     END;          /* END NO PROBLEM WITH LINE 3  0518
*                                                            @ZM45190*/
*                   ELSE                                           0519
*                     ;             /* PROBLEM FORMATTING THIRD LINE
*                                                            @ZM45190*/
@RF00513 DS    0H                                                  0520
*                 END;              /* END NO PROBLEM WITH LINE 2    */
*               ELSE                                               0521
*                 ;                 /* PROBLEM FORMATTING SECOND LINE*/
@RF00509 DS    0H                                                  0522
*             END;                  /* FORMATTED LINE 1 OK           */
*           ELSE                                                   0523
*             ;                     /* PROBLEM FORMATTING FIRST LINE */
@RF00505 DS    0H                                                  0524
*         END;                      /* END SU33 ENDING               */
*       ELSE                                                       0525
*         IF SU17SAVE=ON THEN       /* SU17 ADDED ONLY 3 WORDS TO THE
*                                      END                           */
         B     @RC00500                                            0525
@RF00500 TM    SU17SAVE,B'10000000'                                0525
         BNO   @RF00525                                            0525
*           DO;                                                    0526
*             LINEPTR=RTM2NAME(3);                                 0527
         L     LINEPTR,RTM2NAME+8                                  0527
*             CALL CONVERT;         /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0528
*             CALL FMTRTN;          /* FORMAT                        */
         BAL   @14,FMTRTN                                          0529
*           END;                    /* END SU17 ENDING               */
*         ELSE                                                     0531
*           ;                       /* NO NEED TO ADD ANY MORE-BASE
*                                      TYPE CONTROL BLOCK            */
@RF00525 DS    0H                                                  0532
*     END;                          /* END FIELDS AT END CHECK       */
*   ELSE                                                           0533
*     ;                             /* UNKNOWN CHECK VALUE           */
@RF00498 DS    0H                                                  0534
*   RETURN CODE(RCCODE);                                           0534
@RC00498 L     @15,RCCODE                                          0534
@EL00005 DS    0H                                                  0534
@EF00005 DS    0H                                                  0534
@ER00005 L     @14,@SA00005                                        0534
         BR    @14                                                 0534
*   END SPECIAL;                                                   0535
*IEAFTESA:                                                         0536
*   ENTRY;                                                         0536
*                                                                  0536
@EP00536 DS    0H                                                  0537
*/********************************************************************/
*/* FUNCTION -                                                     0537
*      ROUTINE WHICH FORMATS THE BIT FLAGS FROM THE ESA RELATED TO 0537
*      THE RTM2WA JUST FORMATTED.                                  0537
*                                                                  0537
*   INPUT -                                                        0537
*      REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE        0537
*      ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2    0537
*      AND THE ADDRESS OF THE ESTAE PARAMETER LIST IN ADPLCOM1.    0537
*                                                                  0537
*   CALLS -                                                        0537
*      CALLS ACCESRTN, ANALYZE, BYTEMODE, CONVERT, AND PRINT       0537
*                                                                  0537
*   CALLED BY -                                                    0537
*      IEAVTFMT TO FORMAT ESA BIT SUMMARY                          0537
*                                                                  0537
*   RETURNS TO -                                                   0537
*      IEAVTFMT WITH RETURN CODE SET BY ACCESS SERVICE             0537
*      ROUTINES                                                      */
*/********************************************************************/
*                                                                  0537
*   ESTAPTR=ADPLCOM1;               /* SAVE PTR TO ESTAE PARM LIST   */
         L     @14,ADPLCOM1(,ABDPLPTR)                             0537
         ST    @14,ESTAPTR                                         0537
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR RETRY           */
         STM   VADR,RCREG,LCALREGS(@14)                            0538
*   SAVEPTR=ADPLFMT2-START;         /* USED IN GENERATING OFFSETS    */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0539
         LR    @08,@14                                             0539
         SL    @08,START(,ABDPLPTR)                                0539
         ST    @08,SAVEPTR                                         0539
*   RBSECPTR=ADPLFMT2;              /* PTR TO SVRB RELATED TO RTM2WA */
         LR    RBSECPTR,@14                                        0540
*   HDRBIT=OFF;                     /* HEADER INDICATOR              */
         NI    HDRBIT,B'11101111'                                  0541
*   HDR(1:LENGTH(ESAHDR))=ESAHDR;   /* PLACE STATIC HDR IN HDR       */
         MVC   HDR(61),ESAHDR                                      0542
*   PACKAREA=RBSECPTR;              /* CHAR AREA FOR ADDRESS TO UNPK */
         ST    RBSECPTR,PACKAREA                                   0543
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0544
*   UNPK(SVRBADR,UNPACK);           /* PLACE IN HEADER               */
         UNPK  SVRBADR(9),UNPACK(5)                                0545
*   TR(SVRBADR,TRANS);              /* TRANSLATE TO PRINTABLE HEX    */
         TR    SVRBADR(9),TRANS                                    0546
*   ESAPTR=ADDR(RBEXSAVE);          /* ESA EMBEDDED IN SVRB          */
*                                                                  0547
         LA    @14,RBEXSAVE(,RBSECPTR)                             0547
         ST    @14,ESAPTR                                          0547
*   /*****************************************************************/
*   /*                                                               */
*   /* ENTRY RTM2 REASON                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0548
*   VADR=ADDR(ESAFLAGS);            /* FIRST BYTE OF FLAGS           */
         LA    VADR,ESAFLAGS(,@14)                                 0548
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0549
*   IF(RCREG=ZERO)&(DATABYTE^=ZEROBYTE) THEN/* BYTE NEEDS TO BE    0550
*                                      ANALYZED                      */
         LTR   RCREG,RCREG                                         0550
         BNZ   @RF00550                                            0550
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0550
         BE    @RF00550                                            0550
*     DO;                                                          0551
*       HDRBIT=ON;                  /* HEADR BEING PUT OUT           */
         OI    HDRBIT,B'00010000'                                  0552
*       BUFFER(31:(LENGTH(DUMMYHDR)+30))=DUMMYHDR;/* PLACE HDR INTO
*                                      BUFFER                        */
         L     @14,ADPLBUF(,ABDPLPTR)                              0553
         MVC   BUFFER+30(70,@14),DUMMYHDR                          0553
*       CALL PRINT;                 /* PRINT TITLE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0554
         BALR  @14,@15                                             0554
*       BUFFER(31:(LENGTH(ESAUS)+30))=ESAUS;/* UNDER SCORE           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0555
         MVC   BUFFER+30(60,@14),ESAUS                             0555
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0556
         BALR  @14,@15                                             0556
*       CALL PRINT;                 /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0557
         BALR  @14,@15                                             0557
*       BUFFER(8:(LENGTH(ESASTART)+7))=ESASTART;/* BEGINNING OF    0558
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0558
         MVC   BUFFER+7(13,@14),ESASTART                           0558
*       ADPLFMT2=ADDR(ESAFLAGS);    /* ADDRESS FOR GENING OFFSET     */
         L     @14,ESAPTR                                          0559
         LA    @14,ESAFLAGS(,@14)                                  0559
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0559
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0560
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0560
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0561
*       MSGADDR=ADDR(FLAGSMSG);     /* MESSAGE ARRAY                 */
         LA    @14,FLAGSMSG                                        0562
         ST    @14,MSGADDR                                         0562
*       MSGLNGTH=LENGTH(FLAGSMSG);  /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF03617                                0563
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0564
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0565
         MVC   OFFSET(6,@14),CONVERTD                              0565
*       COLNUM=21;                  /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF02753                                  0566
*       CALL ANALYZE;               /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0567
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0569
*     ;                             /* BYTE DID NOT NEED TO BE     0569
*                                      ANALYZED                      */
*                                                                  0569
@RF00550 DS    0H                                                  0570
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE RECURSION FLAGS                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0570
*   VADR=ADDR(ESARFLAG);            /* RECURSION FLAGS               */
         L     @14,ESAPTR                                          0570
         LA    VADR,ESARFLAG(,@14)                                 0570
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0571
*   IF(RCREG=ZERO)&(DATABYTE^=ZEROBYTE) THEN/* ANALYZE BYTE          */
         LTR   RCREG,RCREG                                         0572
         BNZ   @RF00572                                            0572
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0572
         BE    @RF00572                                            0572
*     DO;                                                          0573
*       IF HDRBIT=OFF THEN          /* NEEDS A HDR                   */
         TM    HDRBIT,B'00010000'                                  0574
         BNZ   @RF00574                                            0574
*         DO;                                                      0575
*           HDRBIT=ON;              /* HEADR BEING PUT OUT           */
         OI    HDRBIT,B'00010000'                                  0576
*           BUFFER(31:(LENGTH(DUMMYHDR)+30))=DUMMYHDR;/* PLACE HDR 0577
*                                      INTO BUFFER                   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0577
         MVC   BUFFER+30(70,@14),DUMMYHDR                          0577
*           CALL PRINT;             /* PRINT TITLE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0578
         BALR  @14,@15                                             0578
*           BUFFER(31:(LENGTH(ESAUS)+30))=ESAUS;/* UNDER SCORE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0579
         MVC   BUFFER+30(60,@14),ESAUS                             0579
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0580
         BALR  @14,@15                                             0580
*           CALL PRINT;             /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0581
         BALR  @14,@15                                             0581
*         END;                      /* END PUT OUT HDR               */
*       ELSE                                                       0583
*         ;                         /* NO NEED FOR ANOTHER HDR       */
@RF00574 DS    0H                                                  0584
*       BUFFER(8:(LENGTH(RECUR)+7))=RECUR;/* MESSAGE START           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0584
         MVC   BUFFER+7(17,@14),RECUR                              0584
*       ADPLFMT2=ADDR(ESARFLAG);    /* ADDRESS FOR GETTING OFFSET    */
         L     @14,ESAPTR                                          0585
         LA    @14,ESARFLAG(,@14)                                  0585
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0585
*       ADPLCOM2=ADDR(SUMMARY);     /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0586
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0586
*       BYTEADDR=ADDR(DATABYTE);    /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0587
*       MSGADDR=ADDR(RECURMSG);     /* MESSAGE ARRAY                 */
         LA    @14,RECURMSG                                        0588
         ST    @14,MSGADDR                                         0588
*       MSGLNGTH=LENGTH(RECURMSG);  /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF00038                                0589
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0590
*       OFFSET=CONVERTD;            /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0591
         MVC   OFFSET(6,@14),CONVERTD                              0591
*       COLNUM=25;                  /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF02675                                  0592
*       CALL ANALYZE;               /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0593
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0595
*     ;                             /* BYTE DID NOT NEED ANALYZED    */
*                                                                  0595
@RF00572 DS    0H                                                  0596
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE RTM1 ENTRY REASON                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0596
*   VADR=ADDR(ESAERTYP);            /* ENTRY REASON                  */
         L     @14,ESAPTR                                          0596
         LA    VADR,ESAERTYP(,@14)                                 0596
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0597
*   IF(RCREG=ZERO)&(DATABYTE^=ZEROBYTE) THEN/* ANALYZE BYTE          */
         LTR   RCREG,RCREG                                         0598
         BNZ   @RF00598                                            0598
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0598
         BE    @RF00598                                            0598
*     DO;                                                          0599
*       IF HDRBIT=OFF THEN          /* NEEDS A HDR                   */
         TM    HDRBIT,B'00010000'                                  0600
         BNZ   @RF00600                                            0600
*         DO;                                                      0601
*           HDRBIT=ON;              /* HEADR BEING PUT OUT           */
         OI    HDRBIT,B'00010000'                                  0602
*           BUFFER(31:(LENGTH(DUMMYHDR)+30))=DUMMYHDR;/* PLACE HDR 0603
*                                      INTO BUFFER                   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0603
         MVC   BUFFER+30(70,@14),DUMMYHDR                          0603
*           CALL PRINT;             /* PRINT TITLE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0604
         BALR  @14,@15                                             0604
*           BUFFER(31:(LENGTH(ESAUS)+30))=ESAUS;/* UNDER SCORE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0605
         MVC   BUFFER+30(60,@14),ESAUS                             0605
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0606
         BALR  @14,@15                                             0606
*           CALL PRINT;             /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0607
         BALR  @14,@15                                             0607
*         END;                      /* END PUT OUT HDR               */
*       ELSE                                                       0609
*         ;                         /* NO NEED FOR ANOTHER HDR       */
@RF00600 DS    0H                                                  0610
*       ADPLFMT2=ADDR(ESAERTYP);    /* FOR FINDING OFFSET            */
         L     @14,ESAPTR                                          0610
         LA    @14,ESAERTYP(,@14)                                  0610
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0610
*       CALL ENTRYRT1;              /* ROUTINE TO ANALYZE BYTE       */
         BAL   @14,ENTRYRT1                                        0611
*       CALL PRINT;                 /* PRINT OUTPUT LINE             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0612
         BALR  @14,@15                                             0612
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0614
*     ;                             /* BYTE DID NOT NEED TO BE     0614
*                                      ANALYZED                      */
*                                                                  0614
@RF00598 DS    0H                                                  0615
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE MODE BYTE                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0615
*   VADR=ADDR(ESAMODE);             /* MODE BYTE                     */
         L     @14,ESAPTR                                          0615
         LA    VADR,ESAMODE(,@14)                                  0615
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0616
*   IF(RCREG=ZERO)&(DATABYTE^=ZEROBYTE) THEN/* ANALYZE BYTE          */
         LTR   RCREG,RCREG                                         0617
         BNZ   @RF00617                                            0617
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0617
         BE    @RF00617                                            0617
*     DO;                                                          0618
*       IF HDRBIT=OFF THEN          /* NEEDS A HDR                   */
         TM    HDRBIT,B'00010000'                                  0619
         BNZ   @RF00619                                            0619
*         DO;                                                      0620
*           HDRBIT=ON;              /* HEADR BEING PUT OUT           */
         OI    HDRBIT,B'00010000'                                  0621
*           BUFFER(31:(LENGTH(DUMMYHDR)+30))=DUMMYHDR;/* PLACE HDR 0622
*                                      INTO BUFFER                   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0622
         MVC   BUFFER+30(70,@14),DUMMYHDR                          0622
*           CALL PRINT;             /* PRINT TITLE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0623
         BALR  @14,@15                                             0623
*           BUFFER(31:(LENGTH(ESAUS)+30))=ESAUS;/* UNDER SCORE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0624
         MVC   BUFFER+30(60,@14),ESAUS                             0624
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0625
         BALR  @14,@15                                             0625
*           CALL PRINT;             /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0626
         BALR  @14,@15                                             0626
*         END;                      /* END PUT OUT HDR               */
*       ELSE                                                       0628
*         ;                         /* NO NEED FOR ANOTHER HDR       */
@RF00619 DS    0H                                                  0629
*       ADPLFMT2=ADDR(ESAMODE);     /* FOR GETTING OFFSET            */
         L     @14,ESAPTR                                          0629
         LA    @14,ESAMODE(,@14)                                   0629
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0629
*       CALL BYTEMODE;              /* ROUTINE TO ANALYZE MODE BYTE  */
         BAL   @14,BYTEMODE                                        0630
*     END;                          /* END ANALYZE BYTE              */
*   ELSE                                                           0632
*     ;                             /* NO NEED TO ANALYZE BYTE       */
@RF00617 DS    0H                                                  0633
*   DUMMYHDR=BLANKS(1:LENGTH(DUMMYHDR));/* CLEAR DUMMY HDR FOR NEXT
*                                      USER                          */
         MVC   DUMMYHDR(70),BLANKS                                 0633
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS EXPECTED RETRY
*                                      REGS                          */
         L     @14,ESTAPTR                                         0634
         MVC   LCALREGS(64,@14),RTYREGS(@14)                       0634
*   RETURN CODE(RCCODE);            /* END OF IEAFTESA               */
         L     @08,RCCODE                                          0635
         L     @13,4(,@13)                                         0635
         L     @00,@SIZDATD                                        0635
         LR    @01,@09                                             0635
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@08                                             0635
         L     @14,12(,@13)                                        0635
         LM    @00,@12,20(@13)                                     0635
         BR    @14                                                 0635
*IEAFTSDW:                                                         0636
*   ENTRY;                                                         0636
*                                                                  0636
@EP00636 DS    0H                                                  0637
*/********************************************************************/
*/* FUNCTION -                                                     0637
*      ROUTINE WHICH FORMATS THE REGISTERS AT TIME OF ERROR TAKEN  0637
*      FROM THE SDWA ASSOCIATED WITH THE RTM2WA JUST FORMATTED.    0637
*                                                                  0637
*   INPUT -                                                        0637
*      REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE        0637
*      ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2,   0637
*      THE OFFSET TO BE PLACED ALONG SIDE THE FIRST FIELD IN ADPLFMT1
*      ALSO DEFINED AS START,AND THE ADDRESS OF THE ESTAE PARAMETER LIS
*      IN ADPLCOM1.                                                0637
*                                                                  0637
*   CALLS -                                                        0637
*      CALLS CONVERT, FMTRTN, AND PRINT                            0637
*                                                                  0637
*   CALLED BY -                                                    0637
*      IEAVTFMT TO FORMAT REGS FROM SDWA                           0637
*                                                                  0637
*   RETURNS TO -                                                   0637
*      IEAVTFMT WITH RETURN CODE SET BY FORMAT SERVICE             0637
*      ROUTINES                                                      */
*/********************************************************************/
*                                                                  0637
*   ESTAPTR=ADPLCOM1;               /* SAVE PTR TO ESTAE PARM LIST   */
         L     @14,ADPLCOM1(,ABDPLPTR)                             0637
         ST    @14,ESTAPTR                                         0637
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR RETRY           */
         STM   VADR,RCREG,LCALREGS(@14)                            0638
*   ADPLCOM1=ADDR(SDWAFMT);         /* ERROR MESSAGE                 */
         LA    @14,SDWAFMT                                         0639
         ST    @14,ADPLCOM1(,ABDPLPTR)                             0639
*   SAVEPTR=ADPLFMT2-START;         /* BEGINNING OF SDWA             */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0640
         LR    @08,@14                                             0640
         SL    @08,START(,ABDPLPTR)                                0640
         ST    @08,SAVEPTR                                         0640
*   SDWAPTR=ADPLFMT2;               /* PTR TO THE SDWA               */
         LR    SDWAPTR,@14                                         0641
*   ERRSW=OFF;                      /* INITIALIZE ERROR INDICATOR    */
*                                                                  0642
         NI    ERRSW,B'11011111'                                   0642
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP HEADER                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0643
*   PACKAREA=SDWAPTR;               /* CHAR AREA FOR ADDRESS TO UNPK */
         ST    SDWAPTR,PACKAREA                                    0643
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0644
*   UNPK(SVRBADR,UNPACK);           /* PLACE IN HEADER               */
         UNPK  SVRBADR(9),UNPACK(5)                                0645
*   TR(SVRBADR,TRANS);              /* TRANSLATE TO PRINTABLE HEX    */
         TR    SVRBADR(9),TRANS                                    0646
*   HDR(1:LENGTH(SDWAHDR))=SDWAHDR; /* HEADER LINE                   */
         MVC   HDR(42),SDWAHDR                                     0647
*   BUFFER(31:(LENGTH(DUMMYHDR)+30))=DUMMYHDR;/* FILL IN HDR         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0648
         MVC   BUFFER+30(70,@14),DUMMYHDR                          0648
*   CALL PRINT;                     /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0649
         BALR  @14,@15                                             0649
*   BUFFER(31:(LENGTH(SDWAUS)+30))=SDWAUS;/* UNDER SCORE             */
         L     @14,ADPLBUF(,ABDPLPTR)                              0650
         MVC   BUFFER+30(42,@14),SDWAUS                            0650
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0651
         BALR  @14,@15                                             0651
*   CALL PRINT;                     /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0652
         BALR  @14,@15                                             0652
*   CALL PRINT;                     /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0653
         BALR  @14,@15                                             0653
*   ADPLFMT2=ADDR(SDWAGRSV);        /* REGISTERS AT ERROR            */
         LA    @14,SDWAGRSV(,SDWAPTR)                              0654
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0654
*   LINEPTR=SUMNAMES(4);            /* FORMAT PATTERN FOR REGS PART 1*/
         L     LINEPTR,SUMNAMES+12                                 0655
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0656
*   CALL FMTRTN;                    /* FORMAT                        */
         BAL   @14,FMTRTN                                          0657
*   IF ERRSW=OFF THEN               /* FORMATTED PART1 OK            */
         TM    ERRSW,B'00100000'                                   0658
         BNZ   @RF00658                                            0658
*     DO;                                                          0659
*       LINEPTR=SUMNAMES(5);        /* FORMAT PATTERN FOR REGS PART2 */
         L     LINEPTR,SUMNAMES+16                                 0660
*       CALL CONVERT;               /* GEN OFFSET                    */
         BAL   @14,CONVERT                                         0661
*       CALL FMTRTN;                /* FORMAT                        */
         BAL   @14,FMTRTN                                          0662
*     END;                          /* END FORMATTED PART1 OK        */
*   ELSE                                                           0664
*     ;                             /* ERROR FORMATTING PART1        */
@RF00658 DS    0H                                                  0665
*   DUMMYHDR=BLANKS(1:LENGTH(DUMMYHDR));/* CLEAR DUMMY HDR FOR NEXT
*                                      USER                          */
         MVC   DUMMYHDR(70),BLANKS                                 0665
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS EXPECTED RETRY
*                                      REGS                          */
         L     @14,ESTAPTR                                         0666
         MVC   LCALREGS(64,@14),RTYREGS(@14)                       0666
*   RETURN CODE(RCCODE);            /* END IEAFTSDW                  */
         L     @08,RCCODE                                          0667
         L     @13,4(,@13)                                         0667
         L     @00,@SIZDATD                                        0667
         LR    @01,@09                                             0667
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@08                                             0667
         L     @14,12(,@13)                                        0667
         LM    @00,@12,20(@13)                                     0667
         BR    @14                                                 0667
*                                                                  0668
*/********************************************************************/
*/*                                                                  */
*/*         THE FOLLOWING CODE HAS BEEN INCLUDED FROM SYSLIB MEMBER  */
*/*     IHAFTCD1 INTO THE MODULE. THE CODE IS INCLUDED ONLY FROM     */
*/*     THE EED FORMATTER AND THE IHSA-FRRS FORMATTER. THE INCLUDED  */
*/*     CODE CONSISTS OF THE BYTEMODE AND ENTRYRT1 ROUTINES.         */
*/*         THE CODE HAS BEEN INCLUDED IN ORDER TO SIMPLIFY          */
*/*     MAINTENANCE BY HAVING THE CODE IN ONLY ONE PLACE INSTEAD     */
*/*     OF DUPLICATING IT IN EACH MODULE.                            */
*/********************************************************************/
*                                                                  0668
*                                                                  0668
*   /*****************************************************************/
*   /*                                                               */
*   /* WORK AREAS UNIQUE TO THE INCLUDED CODE FROM IHAFTCD1          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0668
*   DCL                                                            0668
*     ENDMSG CHAR(70) BASED;        /* AREA TO FINISH MSG IN         */
*                                                                  0668
*   /*****************************************************************/
*   /*                                                               */
*   /* MESSAGES UNIQUE TO THE INCLUDED CODE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0669
*   DCL                                                            0669
*     EXITMSG CHAR(34) INIT('FIELD CONTAINS INTERNAL EXIT FLAGS'); 0669
*   DCL                                                            0670
*     MODEMSG(8) CHAR(25) INIT('SUPERVISOR CONTROL MODE',          0670
*         'PHYSICALLY DISABLED STATE','GLOBAL SPIN LOCK HELD',     0670
*         'GLOBAL SUSPEND LOCK HELD','LOCALLY LOCKED MODE',        0670
*         'TYPE 1 SVC MODE','SRB MODE','TASK MODE');               0670
*   DCL                                                            0671
*     RTARRAY(14) CHAR(50) INIT('PROGRAM CHECK','RESTART','SVC ERROR',
*         'DAT ERROR','MACHINE CHECK REENTRY',                     0671
*         'RESCHEDULE OF PAGE I/O ERROR',                          0671
*         'RESCHEDULE OF ABNORMAL TERMINATION',                    0671
*         'RESCHEDULE OF ABNORMAL TERMINATION THROUGH CVTBTRM',    0671
*         'RESCHEDULE OF CROSS MEMORY ABNORMAL TERMINATION',       0671
*         'RESCHEDULE OF ABNORMAL TERMINATION OF CURRENT TCB',     0671
*         'MEMORY TERMINATION','CROSS MEMORY ABNORMAL TERMINATION',
*         'RESCHEDULE OF RTM1 ON OTHER CPU','MACHINE CHECK');      0671
*   DCL                                                            0672
*     RTSTART CHAR(17) INIT('RTM1 ENTERED FOR ');                  0672
*   DCL                                                            0673
*     SYSTATE CHAR(13) INIT('SYSTEM STATE:');                      0673
*BYTEMODE:                                                         0674
*   PROC OPTIONS(SAVE(14));                                        0674
*                                                                  0674
BYTEMODE ST    @14,@SA00006                                        0674
*/********************************************************************/
*/* FUNCTION-                                                      0675
*       ROUTINE TO ANALYZE THE SYSTEM MODE BYTE AND PLACE THE      0675
*     CORRESPONDING MESSAGE IN THE BUFFER AND PRINT OUT THE DATA.  0675
*                                                                  0675
*                                                                  0675
*   INPUT -                                                        0675
*       DATAPTR MUST CONTAIN THE ADDRESS OF THE BYTE TO BE ANALYZED
*     AND REGISTER 1 POINTS TO THE PARMLIST.                       0675
*                                                                  0675
*    CALLS-                                                        0675
*       ANALYZE AND CONVERT                                        0675
*                                                                  0675
*    CALLED BY -                                                   0675
*        EEDBITS, IEAFTESA, RT1BITS TO ANALYZE THE MODE BYTE       0675
*                                                                  0675
*    RETURNS TO -                                                  0675
*        CALLER WITHOUT SETTING A RETURN CODE                      0675
*                                                                  0675
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCD1) ------  0675
*                                                                    */
*/********************************************************************/
*                                                                  0675
*   BUFFER(8:(LENGTH(SYSTATE)+7))=SYSTATE;/* BEGINNING OF MESSAGE    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0675
         MVC   BUFFER+7(13,@14),SYSTATE                            0675
*   ADPLCOM2=ADDR(SUMMARY);         /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0676
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0676
*   BYTEADDR=ADDR(DATABYTE);        /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0677
*   MSGADDR=ADDR(MODEMSG);          /* MESSAGE ARRAY                 */
         LA    @14,MODEMSG                                         0678
         ST    @14,MSGADDR                                         0678
*   MSGLNGTH=LENGTH(MODEMSG);       /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF02675                                0679
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0680
*   OFFSET=CONVERTD;                /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0681
         MVC   OFFSET(6,@14),CONVERTD                              0681
*   COLNUM=22;                      /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF03228                                  0682
*   CALL ANALYZE;                   /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0683
*   END BYTEMODE;                                                  0684
@EL00006 DS    0H                                                  0684
@EF00006 DS    0H                                                  0684
@ER00006 L     @14,@SA00006                                        0684
         BR    @14                                                 0684
*ENTRYRT1:                                                         0685
*   PROC OPTIONS(SAVE(14));                                        0685
*                                                                  0685
ENTRYRT1 ST    @14,@SA00007                                        0685
*/********************************************************************/
*/* FUNCTION-                                                      0686
*       ROUTINE TO ANALYZE THE RTM1 ENTRY POINT CODE AND FILL IN   0686
*     THE BUFFER WITH THE APPROPRIATE MESSAGE. IT ALSO FILLS IN    0686
*     THE OFFSET TO BE PLACED ALONG SIDE THE MESSAGE.              0686
*                                                                  0686
*                                                                  0686
*   INPUT -                                                        0686
*       DATAPTR MUST CONTAIN THE ADDRESS OF THE BYTE TO BE ANALYZED
*     AND REGISTER 1 POINTS TO THE PARMLIST PASSED BY THE CALLER.  0686
*                                                                  0686
*    CALLS-                                                        0686
*       CONVERT                                                    0686
*                                                                  0686
*    CALLED BY -                                                   0686
*        EEDBITS, RT1BITS TO ANALYZE ENTRY TO RT1 REASON BYTE      0686
*                                                                  0686
*    RETURNS TO -                                                  0686
*        CALLER WITHOUT SETTING A RETURN CODE                      0686
*                                                                  0686
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCD1) ------  0686
*                                                                    */
*/********************************************************************/
*                                                                  0686
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0686
*   OFFSET=CONVERTD;                /* PLACE IN BUFFER               */
         L     @14,ADPLBUF(,ABDPLPTR)                              0687
         MVC   OFFSET(6,@14),CONVERTD                              0687
*   IF DATABYTE>RT1WMACH THEN       /* FIELD CONTAINS EXIT FLAGS     */
         CLI   DATABYTE(DATAPTR),20                                0688
         BNH   @RF00688                                            0688
*     BUFFER(8:(LENGTH(EXITMSG)+7))=EXITMSG;                       0689
         MVC   BUFFER+7(34,@14),EXITMSG                            0689
*   ELSE                                                           0690
*     DO;                           /* WAS NOT EXIT FLAGS            */
         B     @RC00688                                            0690
@RF00688 DS    0H                                                  0691
*       BUFFER(8:(LENGTH(RTSTART)+7))=RTSTART;/* FILL IN BEGINNING OF
*                                      BUFFER                        */
         L     @14,ADPLBUF(,ABDPLPTR)                              0691
         MVC   BUFFER+7(17,@14),RTSTART                            0691
*       RFY                                                        0692
*         ENDMSG BASED(ADDR(BUFFER)+LENGTH(RTSTART)+8);            0692
*       IF DATABYTE<=RT1WMCHR THEN  /* FIRST 5 CORRESPOND TO ARRAY   */
         CLI   DATABYTE(DATAPTR),5                                 0693
         BH    @RF00693                                            0693
*         ENDMSG=RTARRAY(DATABYTE); /* END OF MESSAGE                */
         MVI   ENDMSG+75(@14),C' '                                 0694
         MVC   ENDMSG+76(19,@14),ENDMSG+75(@14)                    0694
         SLR   @08,@08                                             0694
         IC    @08,DATABYTE(,DATAPTR)                              0694
         MH    @08,@CH03793                                        0694
         LA    @07,RTARRAY-50(@08)                                 0694
         MVC   ENDMSG+25(50,@14),0(@07)                            0694
*       ELSE                        /* NOT OF FIRST 5                */
*         IF DATABYTE<=RSCHDCPU THEN/* NEXT BATCH OF VALUES          */
         B     @RC00693                                            0695
@RF00693 CLI   DATABYTE(DATAPTR),17                                0695
         BH    @RF00695                                            0695
*           ENDMSG=RTARRAY(DATABYTE-'04'X);/* CORRESPONDING ARRAY  0696
*                                      VALUE                         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0696
         MVI   ENDMSG+75(@14),C' '                                 0696
         MVC   ENDMSG+76(19,@14),ENDMSG+75(@14)                    0696
         SLR   @08,@08                                             0696
         IC    @08,DATABYTE(,DATAPTR)                              0696
         MH    @08,@CH03793                                        0696
         LA    @07,RTARRAY-250(@08)                                0696
         MVC   ENDMSG+25(50,@14),0(@07)                            0696
*         ELSE                                                     0697
*           ENDMSG=RTARRAY(DIM(RTARRAY));/* LAST MESSAGE             */
         B     @RC00695                                            0697
@RF00695 L     @14,ADPLBUF(,ABDPLPTR)                              0697
         MVI   ENDMSG+75(@14),C' '                                 0697
         MVC   ENDMSG+76(19,@14),ENDMSG+75(@14)                    0697
         MVC   ENDMSG+25(50,@14),RTARRAY+650                       0697
*     END;                          /* END DID NOT CONTAIN EXIT FLAGS*/
*   END ENTRYRT1;                                                  0699
@EL00007 DS    0H                                                  0699
@EF00007 DS    0H                                                  0699
@ER00007 L     @14,@SA00007                                        0699
         BR    @14                                                 0699
*                                                                  0700
*/********************************************************************/
*/*                                                                  */
*/*         THE FOLLOWING CODE HAS BEEN INCLUDED FROM SYSLIB MEMBER  */
*/*     IHAFTCDE INTO THE MODULE. THE CODE IS COMMON AMONG ALL THE   */
*/*     CONTROL BLOCK FORMAT MODULES FOR THE RTM FORMATTER. THE      */
*/*     INCLUDED CODE CONSISTS OF THE ACCESS, FORMAT, CONVERT,       */
*/*     AND ANALYZE ROUTINES USED BY ALL THE MODULES.                */
*/*         THE CODE HAS BEEN INCLUDED IN ORDER TO SIMPLIFY          */
*/*     MAINTENANCE BY HAVING THE CODE IN ONLY ONE PLACE INSTEAD     */
*/*     OF DUPLICATING IT IN EACH MODULE.                            */
*/********************************************************************/
*                                                                  0700
*                                                                  0700
*   /*****************************************************************/
*   /*                                                               */
*   /* WORK AREAS UNIQUE TO THE INCLUDED CODE FROM IHAFTCDE          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0700
*   DCL                                                            0700
*     BITSTR BIT(8) BASED(BYTEADDR);/* BYTE TO BE ANALYZED           */
*   DCL                                                            0701
*     BLANKS CHAR(120) INIT(' ');   /* USED TO BLANK OUT DIGIT FIELD
*                                      OR TO COMPARE WITH THE MESSAGE
*                                      ARRAYS FOR BLANK LINES        */
*   DCL                                                            0702
*     BYTELNTH FIXED(31) CONSTANT(8);/* NUM BITS IN A BYTE           */
*   DCL                                                            0703
*     CONVRT FIXED(31);             /* VALUE OF OFFSET               */
*   DCL                                                            0704
*     INDEX FIXED(31);              /* LOOP COUNTER FOR ANALYZE    0704
*                                      ROUTINE                       */
*   DCL                                                            0705
*     LNGTHEQU FIXED(31);           /* CALCULATE SUBSTRING ADR FOR 0705
*                                      PROPER MSG                    */
*   DCL                                                            0706
*     MSG CHAR(120) BASED(ADPLCOM1);/* ERROR MSG TO BE PUT OUT BY  0706
*                                      FORMAT ROUTINE ERROR          */
*   DCL                                                            0707
*     MSGARY CHAR(*) BASED(MSGADDR);/* MESSAGES PASSED TO BE OUTPUT  */
*   DCL                                                            0708
*     NEGBIT BIT(1);                /* FLAG TO INDICATE NEG OFFSET   */
*   DCL                                                            0709
*     NEGCHAR CHAR(1) CONSTANT('-');/* CONSTANT '-' TO BE PUT IN   0709
*                                      OFFSET                        */
*   DCL                                                            0710
*     PLUSCHAR CHAR(1) CONSTANT('+');/* CONSTANT '+' TO BE PUT IN  0710
*                                      OFFSET                        */
*   DCL                                                            0711
*     TESTBITS(8) BIT(8) INIT('80'X,'40'X,'20'X,'10'X,'08'X,'04'X,'02'X
*         ,'01'X);                  /* TO TELL WHICH BIT IS ON       */
*   DCL                                                            0712
*     TWODGT FIXED(31) CONSTANT(16);/* FIRST OF 2 HEX DIGITS         */
*   DCL                                                            0713
*     THREDGT FIXED(31) CONSTANT(256);/* FIRST OF 3 HEX DIGITS       */
*   DCL                                                            0714
*     FOURDGT FIXED(31) CONSTANT(4096);/* FIRST OF 4 HEX DIGITS      */
*CONVERT:                                                          0715
*   PROC OPTIONS(SAVE(14));                                        0715
*                                                                  0715
CONVERT  ST    @14,12(,@13)                                        0715
*/********************************************************************/
*/* FUNCTION -                                                     0716
*      ROUTINE TO DYNAMICALLY GENERATE THE OFFSETS TO BE PUT ALONGSIDE
*      THE CONTROL BLOCK LINE.  IT FIGURES THE OFFSET FROM THE     0716
*      BEGINNING OF THE CONTROL BLOCK, CONVERTS IT TO PRINTABLE HEX,
*      PLACES IT INTO A BUFFER AREA AND PUTS THE ADDRESS OF THIS   0716
*      BUFFER AREA INTO THE PARAMETER LIST TO BE PICKED UP IN THE  0716
*      FORMAT PATTERNS BY THE FORMAT SERVICE ROUTINE.              0716
*                                                                  0716
*   INPUT -                                                        0716
*      SAVEPTR MUST HAVE THE ADDRESS OF THE BEGINNING OF THE CONTROL
*      BLOCK, REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE 0716
*      CURRENT CONTROL BLOCK ADDRESS IN ADPLFMT2.                  0716
*                                                                  0716
*   CALLS -                                                        0716
*      MAKES NO OUTSIDE CALLS                                      0716
*                                                                  0716
*   CALLED BY -                                                    0716
*      BYTEMODE, EEDBITS, ENTRYRT1, IEAFTEED, IEAFTESA, IEAFTFRR,  0716
*      IEAFTIHS, IEAFTRTC, IEAFTRT2, IEAFTSCB, IEAFTSDW, RT1BITS,  0716
*      RT2BITS, RT2SUM, AND SPECIAL                                0716
*                                                                  0716
*   RETURNS TO -                                                   0716
*      CALLER.                                                     0716
*                                                                  0716
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE) ------  0716
*                                                                    */
*/********************************************************************/
*                                                                  0716
*   IF SAVEPTR>ADPLFMT2 THEN        /* THIS WILL OCCUR FOR A PREFIX
*                                      WITH A NEGATIVE OFFSET        */
         L     @14,SAVEPTR                                         0716
         L     @07,ADPLFMT2(,ABDPLPTR)                             0716
         CR    @14,@07                                             0716
         BNH   @RF00716                                            0716
*     DO;                                                          0717
*       NEGBIT=ON;                  /* INDICATE NEGATIVE OFFSET      */
         OI    NEGBIT,B'10000000'                                  0718
*       CONVRT=SAVEPTR-ADPLFMT2;    /* NEGATIVE OFFSET VALUE         */
         L     @04,ADPLFMT2(,ABDPLPTR)                             0719
         SLR   @14,@04                                             0719
         LR    CONVRT,@14                                          0719
*     END;                          /* END NEGATIVE OFFSET           */
*   ELSE                            /* POSITIVE OR ZERO OFFSET       */
*     DO;                                                          0721
         B     @RC00716                                            0721
@RF00716 DS    0H                                                  0722
*       NEGBIT=OFF;                 /* INDICATE POS VALUE            */
         NI    NEGBIT,B'01111111'                                  0722
*       CONVRT=ADPLFMT2-SAVEPTR;    /* RELATIVE OFFSET IN CONTROL  0723
*                                      BLOCK                         */
         L     CONVRT,ADPLFMT2(,ABDPLPTR)                          0723
         SL    CONVRT,SAVEPTR                                      0723
*     END;                          /* END POS VALUE                 */
*   DIGIT=BLANKS(1:5);              /* BLANK OUT DIGITS              */
@RC00716 MVC   DIGIT(5),BLANKS                                     0725
*   PACKAREA=CONVRT;                /* PLACE OFFSET INTO CHAR AREA 0726
*                                      FOR THE UNPACK                */
         ST    CONVRT,PACKAREA                                     0726
*   GARBAGE='04'X;                  /* GARBAGE BYTE SO OFFSET WILL 0727
*                                      UNPACK OK                     */
*                                                                  0727
         MVI   GARBAGE,X'04'                                       0727
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR AN ODD NUMBER OF DIGITS THE OUTPUT SHOULD LOOK LIKE +C OR */
*   /* +13C. IF THE VALUE WAS UNPACKED DIRECTLY INTO DIGITS THE      */
*   /* OUTPUT WOULD HAVE UNWANTED LEADING ZEROS SUCH AS +0C. TO      */
*   /* ELIMINATE THIS(ONLY FOR AN ODD NUMBER OF DIGITS) UNPACK ODD   */
*   /* NUMBER OF DIGITS INTO CONVERTD WHERE THE LEADING ZERO WILL BE */
*   /* OVERWRITTEN BY THE '+' OR '-' SIGN                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0728
*   IF CONVRT<TWODGT THEN           /* ONLY 1 DIGIT TO OFFSET        */
         CH    CONVRT,@CH00781                                     0728
         BNL   @RF00728                                            0728
*     UNPK(CONVERTD(1:3),UNPACK(4:5));/* UNPACK ONLY 1 DIGIT AND   0729
*                                      DUMMY                         */
         UNPK  CONVERTD(3),UNPACK+3(2)                             0729
*   ELSE                                                           0730
*     IF CONVRT<THREDGT THEN        /* 2 DIGITS TO OFFSET            */
         B     @RC00728                                            0730
@RF00728 CH    CONVRT,@CH00704                                     0730
         BNL   @RF00730                                            0730
*       UNPK(DIGIT(1:3),UNPACK(4:5));/* UNPACK LAST 2 DIGITS & DUMMY */
         UNPK  DIGIT(3),UNPACK+3(2)                                0731
*     ELSE                                                         0732
*       IF CONVRT<FOURDGT THEN      /* 3 DIGITS TO OFFSET            */
         B     @RC00730                                            0732
@RF00730 CH    CONVRT,@CH03858                                     0732
         BNL   @RF00732                                            0732
*         UNPK(CONVERTD(1:5),UNPACK(3:5));/* UNPACK LAST 3 DIGITS &
*                                      DUMMY                         */
         UNPK  CONVERTD(5),UNPACK+2(3)                             0733
*       ELSE                        /* 4 DIGITS (MAX)                */
*         UNPK(DIGIT(1:5),UNPACK(3:5));/* LAST 4 DIGITS & DUMMY BYTE */
         B     @RC00732                                            0734
@RF00732 UNPK  DIGIT(5),UNPACK+2(3)                                0734
*   TR(DIGIT,TRANS);                /* MAKE PRINTABLE                */
@RC00732 DS    0H                                                  0735
@RC00730 DS    0H                                                  0735
@RC00728 TR    DIGIT(5),TRANS                                      0735
*   IF NEGBIT=ON THEN               /* WAS A NEGATIVE OFFSET         */
         TM    NEGBIT,B'10000000'                                  0736
         BNO   @RF00736                                            0736
*     PLUS=NEGCHAR;                 /* MINUS SIGN                    */
         MVI   PLUS,C'-'                                           0737
*   ELSE                            /* POSITIVE OFFSET               */
*     PLUS=PLUSCHAR;                /* MOVE IN PLUS SIGN             */
         B     @RC00736                                            0738
@RF00736 MVI   PLUS,C'+'                                           0738
*   ADPLFMT1=ADDR(CONVERTD);        /* SET UP FOR FORMAT             */
@RC00736 LA    @14,CONVERTD                                        0739
         ST    @14,ADPLFMT1(,ABDPLPTR)                             0739
*   END CONVERT;                                                   0740
@EL00008 DS    0H                                                  0740
@EF00008 DS    0H                                                  0740
@ER00008 L     @14,12(,@13)                                        0740
         BR    @14                                                 0740
*FMTRTN:                                                           0741
*   PROC OPTIONS(SAVE(14));                                        0741
*                                                                  0741
FMTRTN   ST    @14,@SA00009                                        0741
*/****************************************************************** */
*/* FUNCTION                                                       0742
*       ROUTINE TO SET UP CALLING OF THE FORMAT SERVICE ROUTINE PASSED
*     IN THE PARMLIST AND CHECKS RETURN CODE.  IF A RETURN CODE IS BAD
*     IT TAKES THE MESSAGE WHOSE ADDRESS IS IN ADPLCOM1. AND PUTS IT
*     IN THE BUFFER AND PRINTS IT. IT SETS THE ERRSW TO INDICATE BAD
*     RETURN CODE AND RETURNS. IF THE RETURN CODE WAS GOOD, IT PRINTS
*     THE FORMATTED LINE.                                          0742
*                                                                  0742
*   CALLS-                                                         0742
*       CALLS FORMAT AND PRINT                                     0742
*                                                                  0742
*   INPUT -                                                        0742
*     LINEPTR(REGISTER 0) HAS THE ADDRESS OF THE FORMAT PATTERN TO BE
*    PASSED TO THE FORMAT SERVICE ROUTINE. ADPLFMT2 CONTAINS THE CURREN
*    ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED AND ,IN MOST CASES,
*    ADPLFMT1 CONTAINS THE ADDRESS OF THE FIELD 'CONVERTD' WHICH IS
*    THE EBCDIC REPRESENTATION OF THE OFFSET TO BE PLACED ALONG SIDE
*    THE OUTPUT LINE.                                              0742
*                                                                  0742
*   CALLED BY -                                                    0742
*     IEAFTEED,IEAFTFRR,IEAFTIHS,IEAFTRTC,IEAFTRT2,IEAFTSCB,       0742
*     IEAFTSDW, RT2SUM,AND SPECIAL                                 0742
*                                                                  0742
*   RETURNS CONTROL TO -                                           0742
*     CALLER WITH RETURN CODE RECIEVED FROM FORMAT                 0742
*     SERVICE ROUTINE                                              0742
*                                                                  0742
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE) ------  0742
*                                                                    */
*/****************************************************************** */
*                                                                  0742
*   IF ADPLSNPR=OFF THEN            /* IF SNAP IS THE CALLER, AN   0742
*                                      ACCESS ERROR CAN BE EXPECTED  */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0742
         BNZ   @RF00742                                            0742
*     DO;                                                          0743
*       RTYADR=ADDR(FMTRTY);        /* WHERE TO RETRY                */
         L     @14,ESTAPTR                                         0744
         LA    @07,FMTRTY                                          0744
         ST    @07,RTYADR(,@14)                                    0744
*       ERREXP=ON;                  /* INDICATE AN ERROR IS EXPECTED */
         OI    ERREXP(@14),B'10000000'                             0745
*     END;                          /* END SNAP IS THE CALLER        */
*   ELSE                                                           0747
*     ;                             /* SNAP WAS NOT INVOKER          */
@RF00742 DS    0H                                                  0748
*   CALL FORMAT;                    /* FORMAT ROUTINE PASSED BY    0748
*                                      CALLER                        */
         L     @15,ADPLFRMT(,ABDPLPTR)                             0748
         BALR  @14,@15                                             0748
*   ERREXP=OFF;                     /* ERROR IS NO LONGER EXPECTED   */
         L     @14,ESTAPTR                                         0749
         NI    ERREXP(@14),B'01111111'                             0749
*   IF RCREG^=ZERO THEN                                            0750
         LTR   RCREG,RCREG                                         0750
         BZ    @RF00750                                            0750
*     DO;                           /* FORMAT ROUTINE ERROR          */
*FMTRTY:                            /* RETRY POINT FROM ERROR        */
*       ERRSW=ON;                   /* SET ERROR INDICATOR           */
FMTRTY   OI    ERRSW,B'00100000'                                   0752
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0753
         BALR  @14,@15                                             0753
*       BUFFER=MSG;                 /* ERROR MSG PASSED BY CALLER  0754
*                                      WHOSE ADDR IS PLACED IN     0754
*                                      ADPLCOM1                      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0754
         L     @07,ADPLCOM1(,ABDPLPTR)                             0754
         MVC   BUFFER(120,@14),MSG(@07)                            0754
*       RCREG=4;                    /* INDICATE BAD RETURN CODE FROM
*                                      FORMATTER                     */
         LA    RCREG,4                                             0755
*     END;                          /* END FORMAT ROUTINE ERROR      */
*   ELSE                                                           0757
*     ;                             /* FORMATTED LINE IS IN BUFFER   */
@RF00750 DS    0H                                                  0758
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM FORMAT
*                                      SERVICE ROUTINE               */
         ST    RCREG,RCCODE                                        0758
*   CALL PRINT;                     /* PRINT THE ERROR MSG OR      0759
*                                      FORMATTED LINE                */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0759
         BALR  @14,@15                                             0759
*   RETURN CODE(RCCODE);                                           0760
         L     @15,RCCODE                                          0760
@EL00009 DS    0H                                                  0760
@EF00009 DS    0H                                                  0760
@ER00009 L     @14,@SA00009                                        0760
         BR    @14                                                 0760
*   END FMTRTN;                                                    0761
*ANALYZE:                                                          0762
*   PROC OPTIONS(SAVE(14));                                        0762
*                                                                  0762
ANALYZE  ST    @14,@SA00010                                        0762
*/****************************************************************** */
*/* FUNCTION                                                       0763
*     ROUTINE TO ANALYZE THE BITS IN THE BYTE PASSED AND PRINT OUT 0763
*     THE MESSAGE THAT CORRESPONDS TO THE BITS THAT ARE ON. IF A BLANK
*     LINE IS PASSED IN THE MESSAGE ARRAY (INDICATING A RESERVED BIT)
*     NO OUTPUT WILL CORRESPOND TO THAT BIT.                       0763
*                                                                  0763
*   INPUT-                                                         0763
*     AN ARRAY (SUMMARY) POINTED TO BY THE PARMLIST FIELD          0763
*     ADPLCOM2 WHICH CONTAINS THE ADDRESS OF THE BYTE TO BE        0763
*     ANALYZED, THE ADDRESS OF THE ARRAY OF CORRESPONDING          0763
*     MESSAGES, THE COLUMN NUMBER THE MESSAGE IS TO BEGIN IN,      0763
*     AND THE LENGTH OF THE MESSAGE ARRAY PASSED.                  0763
*                                                                  0763
*   NOTE- COLNUM + MSGLNGTH MUST BE LESS THAN OR EQUAL TO 120 BYTES
*         WHICH IS THE OUTPUT BUFFER LENGTH.                       0763
*                                                                  0763
*                                                                  0763
*   CALLS-                                                         0763
*       CALLS PRINT                                                0763
*                                                                  0763
*   CALLED BY -                                                    0763
*       BYTEMODE,EEDBITS,IEAFTESA,IEAFTSCB,RT2BITS                 0763
*                                                                  0763
*   RETURNS CONTROL TO -                                           0763
*       CALLER WITHOUT SETTING A RETURN CODE                       0763
*                                                                  0763
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE)-------  0763
*                                                                    */
*/****************************************************************** */
*                                                                  0763
*   DO INDEX=1 TO BYTELNTH;         /* LOOP TO FIND WHICH BITS ARE ON*/
         LA    INDEX,1                                             0763
@DL00763 DS    0H                                                  0764
*     LNGTHEQU=((INDEX-1)*(MSGLNGTH)+1);/* OFFSET INTO MSGARY OF   0764
*                                      CORRESPONDING MESSAGE         */
         L     @14,MSGLNGTH                                        0764
         LR    @03,INDEX                                           0764
         BCTR  @03,0                                               0764
         MR    @02,@14                                             0764
         AH    @03,@CH00042                                        0764
         LR    LNGTHEQU,@03                                        0764
*     IF(BITSTR&TESTBITS(INDEX))^=ZEROBYTE&/* FOUND A BIT ON         */
*         MSGARY(LNGTHEQU:MSGLNGTH+LNGTHEQU-1)^=BLANKS(1:MSGLNGTH) THEN
         L     @04,BYTEADDR                                        0765
         SLR   @03,@03                                             0765
         IC    @03,BITSTR(,@04)                                    0765
         SLR   @04,@04                                             0765
         IC    @04,TESTBITS-1(INDEX)                               0765
         NR    @03,@04                                             0765
         SLR   @04,@04                                             0765
         IC    @04,ZEROBYTE                                        0765
         CR    @03,@04                                             0765
         BE    @RF00765                                            0765
         L     @04,MSGADDR                                         0765
         LR    @03,@14                                             0765
         BCTR  @03,0                                               0765
         LR    @02,@04                                             0765
         ALR   @02,LNGTHEQU                                        0765
         BCTR  @02,0                                               0765
         EX    @03,@SC03895                                        0765
         BE    @RF00765                                            0765
*       DO;                         /* CORRESPONDING MESSAGE WAS NOT
*                                      BLANK(RESERVED)               */
*         BUFFER(COLNUM:(MSGLNGTH+COLNUM-1))=MSGARY(LNGTHEQU:LNGTHEQU+
*             MSGLNGTH-1);          /* PLACE MSG IN BUFFER           */
         L     @03,COLNUM                                          0767
         L     @02,ADPLBUF(,ABDPLPTR)                              0767
         ALR   @02,@03                                             0767
         BCTR  @02,0                                               0767
         ALR   @14,@03                                             0767
         SLR   @14,@03                                             0767
         BCTR  @14,0                                               0767
         ALR   @04,LNGTHEQU                                        0767
         BCTR  @04,0                                               0767
         EX    @14,@SM03897                                        0767
*         CALL PRINT;               /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0768
         BALR  @14,@15                                             0768
*       END;                        /* END FOUND THE MESSAGE         */
*     ELSE                                                         0770
*       ;                           /* EITHER BIT NOT ON OR RESERVED
*                                      BIT-NO MESSAGE                */
@RF00765 DS    0H                                                  0771
*   END;                            /* END SEARCH LOOP               */
         AH    INDEX,@CH00042                                      0771
         CH    INDEX,@CH00087                                      0771
         BNH   @DL00763                                            0771
*   END ANALYZE;                                                   0772
@EL00010 DS    0H                                                  0772
@EF00010 DS    0H                                                  0772
@ER00010 L     @14,@SA00010                                        0772
         BR    @14                                                 0772
*ACCESRTN:                                                         0773
*   PROC OPTIONS(SAVE(14));                                        0773
*                                                                  0773
ACCESRTN ST    @14,@SA00011                                        0773
*/********************************************************************/
*/* FUNCTION-                                                      0774
*       ROUTINE WHICH CALLS THE ACCESS SERVICE ROUTINE AND MOVES THE
*     VALUE RETURNED IN R0 INTO DATAPTR.                           0774
*                                                                  0774
*                                                                  0774
*   INPUT -                                                        0774
*         VADR(REGISTER 0) CONTAINS THE VIRTUAL ADDRESS OF THE FIELD
*         TO BE ACCESSED.                                          0774
*                                                                  0774
*    CALLS-                                                        0774
*         ACCESS SERVICE ROUTINE PASSED IN PARMLIST                0774
*                                                                  0774
*    CALLED BY -                                                   0774
*         EEDBITS, IEAFTEED, IEAFTFRR, IEAFTRTC, IEAFTRT2,         0774
*         IEAFTSCB, RT1BITS, AND RT2BITS                           0774
*                                                                  0774
*    RETURNS TO -                                                  0774
*         CALLER WITH THE RETURN CODE SET BY THE ACCESS            0774
*         SERVICE ROUTINE.                                         0774
*                                                                  0774
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE) ------  0774
*                                                                    */
*/********************************************************************/
*                                                                  0774
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS INVOKER              */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0774
         BNZ   @RF00774                                            0774
*     DO;                                                          0775
*       RTYADR=ADDR(RETRY);         /* RETRY ADDR FOR ESTAE IN THE 0776
*                                      CASE OF EXPECTED ERRORS       */
         L     @14,ESTAPTR                                         0776
         LA    @07,RETRY                                           0776
         ST    @07,RTYADR(,@14)                                    0776
*       DATAPTR=VADR;               /* USED TO BASE THE STORAGE ON   */
         LR    DATAPTR,VADR                                        0777
*       RCREG=ZERO;                 /* SUCCESS UNLESS AN ABEND OCCURS
*                                      DURING THE MOVE INTO A BUFFER */
         SLR   RCREG,RCREG                                         0778
*       ERREXP=ON;                  /* AN ERROR IS EXPECTED          */
         OI    ERREXP(@14),B'10000000'                             0779
*       VERIFY=DATADWRD;            /* MOVE A DOUBLE WORD INTO     0780
*                                      INTERNAL BUFFER               */
*                                                                  0780
         MVC   VERIFY(8),DATADWRD(DATAPTR)                         0780
*       /*************************************************************/
*       /*                                                           */
*       /* THIS MOVE WILL CAUSE AN ABEND IF THE DUMP DOES NOT CONTAIN*/
*       /* THE AREA REFERENCED OR IF THE AREA IS PROTECTED. IF AN    */
*       /* ABEND OCCURS, THE ESTAE WILL GET CONTROL AND RETRY AT THE */
*       /* POINT WHICH SETS A BAD RETURN CODE AND RETURNS TO THE     */
*       /* CALLER. THIS THEN SIMULATES THE PRINT DUMP ACCESS ROUTINE.*/
*       /* IF THE AREA ASKED FOR IS IN THE DUMP, A DOUBLE WORD IS    */
*       /* MOVED INTO AN INTERNAL BUFFER TO PREVENT AN UNEXPECTED    */
*       /* ERROR WHEN REFERENCING THE AREA AGAIN                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0781
*       ERREXP=OFF;                 /* AN ERROR IS NO LONGER EXPECTED*/
         NI    ERREXP(@14),B'01111111'                             0781
*       DATAPTR=ADDR(VERIFY);       /* REBASE DATA OFF INTERNAL    0782
*                                      BUFFER                        */
         LA    DATAPTR,VERIFY                                      0782
*     END;                          /* END SNAP WAS THE INVOKER      */
*   ELSE                            /* CALLER HAS OWN ACCESS ROUTINE
*                                      LIKE PRINT DUMP               */
*     DO;                                                          0784
         B     @RC00774                                            0784
@RF00774 DS    0H                                                  0785
*       CALL ACCESS;                /* ACCESS SERVICE ROUTINE PASSED
*                                      BY CALLER                     */
         L     @15,ADPLMEMA(,ABDPLPTR)                             0785
         BALR  @14,@15                                             0785
*       IF RCREG=ZERO THEN                                         0786
         LTR   RCREG,RCREG                                         0786
         BNZ   @RF00786                                            0786
*         DATAPTR=VADR;             /* SAVE PTR RETURNED BY ACCESS 0787
*                                      SERVICE ROUTINE               */
         LR    DATAPTR,VADR                                        0787
*       ELSE                        /* BAD RETURN CODE               */
*RETRY:                             /* RETRY ADDR FOR THE ESTAE      */
*         RCREG=4;                  /* SET A BAD RETURN CODE         */
         B     @RC00786                                            0788
@RF00786 DS    0H                                                  0788
RETRY    LA    RCREG,4                                             0788
*     END;                          /* END CALLER WAS NOT SNAP       */
@RC00786 DS    0H                                                  0790
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM ACCESS
*                                      SERVICE RTN                   */
@RC00774 ST    RCREG,RCCODE                                        0790
*   RETURN CODE(RCCODE);                                           0791
         L     @07,RCCODE                                          0791
         LR    @15,@07                                             0791
@EL00011 DS    0H                                                  0791
@EF00011 DS    0H                                                  0791
@ER00011 L     @14,@SA00011                                        0791
         BR    @14                                                 0791
*   END ACCESRTN;                                                  0792
*   DCL                                                            0793
*     RT2PATCH CHAR(200) INIT(                                     0793
*         'PATCH AREA FOR IEAFTRT2 - IT IS 200 BYTES LONG');       0793
*   END IEAFTRT2                                                   0794
*                                                                  0794
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (RTM2ESA )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IHARTM2A)                                       */
*/*%INCLUDE SYSLIB  (IHASNP  )                                       */
*/*%INCLUDE SYSLIB  (IHARMPL )                                       */
*/*%INCLUDE SYSLIB  (IHART1W )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASUBIT)                                       */
*/*%INCLUDE SYSLIB  (IHAFTCD1)                                       */
*/*%INCLUDE SYSLIB  (IHAFTCDE)                                       */
*                                                                  0794
*       ;                                                          0794
@DATA    DS    0H
@CH00042 DC    H'1'
@CH00312 DC    H'3'
@CH00778 DC    H'7'
@CH01564 DC    H'9'
@CH00781 DC    H'16'
@CH01707 DC    H'17'
@CH03793 DC    H'50'
@CH03443 DC    H'68'
@CH01675 DC    H'100'
@CH01679 DC    H'102'
@CH00704 DC    H'256'
@CH03858 DC    H'4096'
@SC03895 CLC   MSGARY(0,@02),BLANKS
@SM03897 MVC   BUFFER(0,@02),MSGARY(@04)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@SA00011 DS    1F
@SA00005 DS    1F
@SA00009 DS    1F
@SA00002 DS    1F
@SA00003 DS    1F
@SA00004 DS    1F
@SA00010 DS    1F
@SA00007 DS    1F
@SA00006 DS    1F
IEAFTRT2 CSECT
         DS    0F
@CF00087 DC    F'8'
@CH00087 EQU   @CF00087+2
@CF02753 DC    F'21'
@CH02753 EQU   @CF02753+2
@CF03228 DC    F'22'
@CF02675 DC    F'25'
@CF01628 DC    F'29'
@CF00038 DC    F'31'
@CF01641 DC    F'37'
@CF03617 DC    F'40'
@CF03634 DC    F'46'
@CF03574 DC    F'47'
@CF03558 DC    F'57'
@CF03887 DC    F'-4'
@DATD    DSECT
         DS    0D
FRRSRTMW DS    A
ESTAPTR  DS    A
RCCODE   DS    F
ESAPTR   DS    A
SAVEPTR  DS    A
BITS     DS    BL1
         ORG   BITS
SU17SAVE DS    BL1
SU33SAVE EQU   BITS+0
ERRSW    EQU   BITS+0
HDRBIT   EQU   BITS+0
@NM01064 EQU   BITS+0
         ORG   BITS+1
CONVERTD DS    CL6
         ORG   CONVERTD
PLUS     DS    CL1
DIGIT    DS    CL5
         ORG   CONVERTD+6
DUMMYHDR DS    CL70
         ORG   DUMMYHDR
HDR      DS    CL61
SVRBADR  DS    CL9
         ORG   DUMMYHDR+70
         DS    CL3
SUMMARY  DS    CL16
         ORG   SUMMARY
BYTEADDR DS    AL4
MSGADDR  DS    AL4
COLNUM   DS    FL4
MSGLNGTH DS    FL4
         ORG   SUMMARY+16
UNPACK   DS    CL5
         ORG   UNPACK
PACKAREA DS    CL4
GARBAGE  DS    CL1
         ORG   UNPACK+5
         DS    CL7
VERIFY   DS    CL8
NEGBIT   DS    BL1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAFTRT2 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
ZEROBYTE DC    XL1'00'
         DS    CL3
RTM2FMT1 DS    CL12
         ORG   RTM2FMT1
@NM00129 DS    CL4
         ORG   @NM00129
@NM00130 DC    X'01'
@NM00131 DC    X'40'
@NM00132 DC    AL1(0)
@NM00133 DC    AL1(0)
         ORG   RTM2FMT1+4
@NM00134 DS    CL4
         ORG   @NM00134
@NM00135 DC    X'04'
@NM00136 DC    X'03'
@NM00137 DC    AL1(0)
@NM00138 DC    AL1(8)
         ORG   RTM2FMT1+8
@NM00139 DS    CL4
         ORG   @NM00139
@NM00140 DC    F'0'
         ORG   RTM2FMT1+12
RTM2FMT2 DS    CL16
         ORG   RTM2FMT2
@NM00141 DS    CL4
         ORG   @NM00141
@NM00142 DC    X'01'
@NM00143 DC    X'40'
@NM00144 DC    AL1(0)
@NM00145 DC    AL1(0)
         ORG   RTM2FMT2+4
@NM00146 DS    CL4
         ORG   @NM00146
@NM00147 DC    X'04'
@NM00148 DC    X'03'
@NM00149 DC    AL1(0)
@NM00150 DC    AL1(8)
         ORG   RTM2FMT2+8
@NM00151 DS    CL4
         ORG   @NM00151
@NM00152 DC    X'04'
@NM00153 DC    X'03'
@NM00154 DC    AL1(0)
@NM00155 DC    AL1(17)
         ORG   RTM2FMT2+12
@NM00156 DS    CL4
         ORG   @NM00156
@NM00157 DC    F'0'
         ORG   RTM2FMT2+16
RTM2FMT3 DS    CL20
         ORG   RTM2FMT3
@NM00158 DS    CL4
         ORG   @NM00158
@NM00159 DC    X'01'
@NM00160 DC    X'40'
@NM00161 DC    AL1(0)
@NM00162 DC    AL1(0)
         ORG   RTM2FMT3+4
@NM00163 DS    CL4
         ORG   @NM00163
@NM00164 DC    X'04'
@NM00165 DC    X'03'
@NM00166 DC    AL1(0)
@NM00167 DC    AL1(8)
         ORG   RTM2FMT3+8
@NM00168 DS    CL4
         ORG   @NM00168
@NM00169 DC    X'04'
@NM00170 DC    X'03'
@NM00171 DC    AL1(0)
@NM00172 DC    AL1(17)
         ORG   RTM2FMT3+12
@NM00173 DS    CL4
         ORG   @NM00173
@NM00174 DC    X'04'
@NM00175 DC    X'03'
@NM00176 DC    AL1(0)
@NM00177 DC    AL1(26)
         ORG   RTM2FMT3+16
@NM00178 DS    CL4
         ORG   @NM00178
@NM00179 DC    F'0'
         ORG   RTM2FMT3+20
RTM2FMT4 DS    CL24
         ORG   RTM2FMT4
@NM00180 DS    CL4
         ORG   @NM00180
@NM00181 DC    X'01'
@NM00182 DC    X'40'
@NM00183 DC    AL1(0)
@NM00184 DC    AL1(0)
         ORG   RTM2FMT4+4
@NM00185 DS    CL4
         ORG   @NM00185
@NM00186 DC    X'04'
@NM00187 DC    X'03'
@NM00188 DC    AL1(0)
@NM00189 DC    AL1(8)
         ORG   RTM2FMT4+8
@NM00190 DS    CL4
         ORG   @NM00190
@NM00191 DC    X'04'
@NM00192 DC    X'03'
@NM00193 DC    AL1(0)
@NM00194 DC    AL1(17)
         ORG   RTM2FMT4+12
@NM00195 DS    CL4
         ORG   @NM00195
@NM00196 DC    X'04'
@NM00197 DC    X'03'
@NM00198 DC    AL1(0)
@NM00199 DC    AL1(26)
         ORG   RTM2FMT4+16
@NM00200 DS    CL4
         ORG   @NM00200
@NM00201 DC    X'04'
@NM00202 DC    X'03'
@NM00203 DC    AL1(0)
@NM00204 DC    AL1(35)
         ORG   RTM2FMT4+20
@NM00205 DS    CL4
         ORG   @NM00205
@NM00206 DC    F'0'
         ORG   RTM2FMT4+24
RTM2FMT5 DS    CL28
         ORG   RTM2FMT5
@NM00207 DS    CL4
         ORG   @NM00207
@NM00208 DC    X'01'
@NM00209 DC    X'40'
@NM00210 DC    AL1(0)
@NM00211 DC    AL1(0)
         ORG   RTM2FMT5+4
@NM00212 DS    CL4
         ORG   @NM00212
@NM00213 DC    X'04'
@NM00214 DC    X'03'
@NM00215 DC    AL1(0)
@NM00216 DC    AL1(8)
         ORG   RTM2FMT5+8
@NM00217 DS    CL4
         ORG   @NM00217
@NM00218 DC    X'04'
@NM00219 DC    X'03'
@NM00220 DC    AL1(0)
@NM00221 DC    AL1(17)
         ORG   RTM2FMT5+12
@NM00222 DS    CL4
         ORG   @NM00222
@NM00223 DC    X'04'
@NM00224 DC    X'03'
@NM00225 DC    AL1(0)
@NM00226 DC    AL1(26)
         ORG   RTM2FMT5+16
@NM00227 DS    CL4
         ORG   @NM00227
@NM00228 DC    X'04'
@NM00229 DC    X'03'
@NM00230 DC    AL1(0)
@NM00231 DC    AL1(35)
         ORG   RTM2FMT5+20
@NM00232 DS    CL4
         ORG   @NM00232
@NM00233 DC    X'04'
@NM00234 DC    X'03'
@NM00235 DC    AL1(0)
@NM00236 DC    AL1(44)
         ORG   RTM2FMT5+24
@NM00237 DS    CL4
         ORG   @NM00237
@NM00238 DC    F'0'
         ORG   RTM2FMT5+28
RTM2FMT6 DS    CL32
         ORG   RTM2FMT6
@NM00239 DS    CL4
         ORG   @NM00239
@NM00240 DC    X'01'
@NM00241 DC    X'40'
@NM00242 DC    AL1(0)
@NM00243 DC    AL1(0)
         ORG   RTM2FMT6+4
@NM00244 DS    CL4
         ORG   @NM00244
@NM00245 DC    X'04'
@NM00246 DC    X'03'
@NM00247 DC    AL1(0)
@NM00248 DC    AL1(8)
         ORG   RTM2FMT6+8
@NM00249 DS    CL4
         ORG   @NM00249
@NM00250 DC    X'04'
@NM00251 DC    X'03'
@NM00252 DC    AL1(0)
@NM00253 DC    AL1(17)
         ORG   RTM2FMT6+12
@NM00254 DS    CL4
         ORG   @NM00254
@NM00255 DC    X'04'
@NM00256 DC    X'03'
@NM00257 DC    AL1(0)
@NM00258 DC    AL1(26)
         ORG   RTM2FMT6+16
@NM00259 DS    CL4
         ORG   @NM00259
@NM00260 DC    X'04'
@NM00261 DC    X'03'
@NM00262 DC    AL1(0)
@NM00263 DC    AL1(35)
         ORG   RTM2FMT6+20
@NM00264 DS    CL4
         ORG   @NM00264
@NM00265 DC    X'04'
@NM00266 DC    X'03'
@NM00267 DC    AL1(0)
@NM00268 DC    AL1(44)
         ORG   RTM2FMT6+24
@NM00269 DS    CL4
         ORG   @NM00269
@NM00270 DC    X'04'
@NM00271 DC    X'03'
@NM00272 DC    AL1(0)
@NM00273 DC    AL1(53)
         ORG   RTM2FMT6+28
@NM00274 DS    CL4
         ORG   @NM00274
@NM00275 DC    F'0'
         ORG   RTM2FMT6+32
RTM2FMT7 DS    CL36
         ORG   RTM2FMT7
@NM00276 DS    CL4
         ORG   @NM00276
@NM00277 DC    X'01'
@NM00278 DC    X'40'
@NM00279 DC    AL1(0)
@NM00280 DC    AL1(0)
         ORG   RTM2FMT7+4
@NM00281 DS    CL4
         ORG   @NM00281
@NM00282 DC    X'04'
@NM00283 DC    X'03'
@NM00284 DC    AL1(0)
@NM00285 DC    AL1(8)
         ORG   RTM2FMT7+8
@NM00286 DS    CL4
         ORG   @NM00286
@NM00287 DC    X'04'
@NM00288 DC    X'03'
@NM00289 DC    AL1(0)
@NM00290 DC    AL1(17)
         ORG   RTM2FMT7+12
@NM00291 DS    CL4
         ORG   @NM00291
@NM00292 DC    X'04'
@NM00293 DC    X'03'
@NM00294 DC    AL1(0)
@NM00295 DC    AL1(26)
         ORG   RTM2FMT7+16
@NM00296 DS    CL4
         ORG   @NM00296
@NM00297 DC    X'04'
@NM00298 DC    X'03'
@NM00299 DC    AL1(0)
@NM00300 DC    AL1(35)
         ORG   RTM2FMT7+20
@NM00301 DS    CL4
         ORG   @NM00301
@NM00302 DC    X'04'
@NM00303 DC    X'03'
@NM00304 DC    AL1(0)
@NM00305 DC    AL1(44)
         ORG   RTM2FMT7+24
@NM00306 DS    CL4
         ORG   @NM00306
@NM00307 DC    X'04'
@NM00308 DC    X'03'
@NM00309 DC    AL1(0)
@NM00310 DC    AL1(53)
         ORG   RTM2FMT7+28
@NM00311 DS    CL4
         ORG   @NM00311
@NM00312 DC    X'04'
@NM00313 DC    X'03'
@NM00314 DC    AL1(0)
@NM00315 DC    AL1(62)
         ORG   RTM2FMT7+32
@NM00316 DS    CL4
         ORG   @NM00316
@NM00317 DC    F'0'
         ORG   RTM2FMT7+36
RTM2FMT8 DS    CL40
         ORG   RTM2FMT8
@NM00318 DS    CL4
         ORG   @NM00318
@NM00319 DC    X'01'
@NM00320 DC    X'40'
@NM00321 DC    AL1(0)
@NM00322 DC    AL1(0)
         ORG   RTM2FMT8+4
@NM00323 DS    CL4
         ORG   @NM00323
@NM00324 DC    X'04'
@NM00325 DC    X'03'
@NM00326 DC    AL1(0)
@NM00327 DC    AL1(8)
         ORG   RTM2FMT8+8
@NM00328 DS    CL4
         ORG   @NM00328
@NM00329 DC    X'04'
@NM00330 DC    X'03'
@NM00331 DC    AL1(0)
@NM00332 DC    AL1(17)
         ORG   RTM2FMT8+12
@NM00333 DS    CL4
         ORG   @NM00333
@NM00334 DC    X'04'
@NM00335 DC    X'03'
@NM00336 DC    AL1(0)
@NM00337 DC    AL1(26)
         ORG   RTM2FMT8+16
@NM00338 DS    CL4
         ORG   @NM00338
@NM00339 DC    X'04'
@NM00340 DC    X'03'
@NM00341 DC    AL1(0)
@NM00342 DC    AL1(35)
         ORG   RTM2FMT8+20
@NM00343 DS    CL4
         ORG   @NM00343
@NM00344 DC    X'04'
@NM00345 DC    X'03'
@NM00346 DC    AL1(0)
@NM00347 DC    AL1(44)
         ORG   RTM2FMT8+24
@NM00348 DS    CL4
         ORG   @NM00348
@NM00349 DC    X'04'
@NM00350 DC    X'03'
@NM00351 DC    AL1(0)
@NM00352 DC    AL1(53)
         ORG   RTM2FMT8+28
@NM00353 DS    CL4
         ORG   @NM00353
@NM00354 DC    X'04'
@NM00355 DC    X'03'
@NM00356 DC    AL1(0)
@NM00357 DC    AL1(62)
         ORG   RTM2FMT8+32
@NM00358 DS    CL4
         ORG   @NM00358
@NM00359 DC    X'04'
@NM00360 DC    X'03'
@NM00361 DC    AL1(0)
@NM00362 DC    AL1(71)
         ORG   RTM2FMT8+36
@NM00363 DS    CL4
         ORG   @NM00363
@NM00364 DC    F'0'
         ORG   RTM2FMT8+40
RTM2FT9  DC    CL31'-EED TYPE1 REGS AND PSW'
RTM2FT10 DC    CL31'-----'
RTM2FT11 DC    CL31'-EED TYPE3 MACHINE CHECK'
RTM2FT12 DC    CL31'-SNPPARMS'
RTM2FT13 DC    CL31'-DUMP STORAGE RANGES'
RTM2FT14 DC    CL31'-SUBFUNCTION REGISTER SAVE AREA'
RTM2FT15 DC    CL31'-RECURSION REGISTERS'
RTM2FT16 DC    CL31'-SAVE AREA FOR VTRT2'
RTM2FT17 DC    CL31'-SAVE AREA FOR TAS2/TAS3'
RTM2FT18 DC    CL31'-RMPL'
RTM2FT19 DC    CL31'-WORK AREA FOR RESOURCE MANAGER'
RTM2FT20 DC    CL31'-SAVE AREA FOR RESOURCE MANAGER'
SUML1    DS    CL14
         ORG   SUML1
@NM00365 DC    CL10'COMPLETION'
@NM00366 DC    CL4'CODE'
         ORG   SUML1+14
         DS    CL2
SUMFMT1  DS    CL20
         ORG   SUMFMT1
@NM00367 DS    CL4
         ORG   @NM00367
@NM00368 DC    X'01'
@NM00369 DC    X'40'
@NM00370 DC    AL1(0)
@NM00371 DC    AL1(0)
         ORG   SUMFMT1+4
@NM00372 DS    CL8
         ORG   @NM00372
@NM00373 DC    X'07'
@NM00374 DC    X'93'
@NM00375 DC    AL1(8)
@NM00376 DC    AL1(33)
@NM00377 DC    AL4(SUML1)
         ORG   SUMFMT1+12
@NM00378 DS    CL4
         ORG   @NM00378
@NM00379 DC    X'01'
@NM00380 DC    X'30'
@NM00381 DC    AL1(19)
@NM00382 DC    AL1(0)
         ORG   SUMFMT1+16
@NM00383 DS    CL4
         ORG   @NM00383
@NM00384 DC    F'0'
         ORG   SUMFMT1+20
SUML2    DS    CL19
         ORG   SUML2
@NM00385 DC    CL8'ABENDING'
@NM00386 DC    CL7'PROGRAM'
@NM00387 DC    CL4'NAME'
         ORG   SUML2+19
         DS    CL1
SUMFMT2  DS    CL24
         ORG   SUMFMT2
@NM00388 DS    CL4
         ORG   @NM00388
@NM00389 DC    X'01'
@NM00390 DC    X'40'
@NM00391 DC    AL1(0)
@NM00392 DC    AL1(0)
         ORG   SUMFMT2+4
@NM00393 DS    CL8
         ORG   @NM00393
@NM00394 DC    X'27'
@NM00395 DC    X'77'
@NM00396 DC    AL1(8)
@NM00397 DC    AL1(33)
@NM00398 DC    AL4(SUML2)
         ORG   SUMFMT2+12
@NM00399 DS    CL4
         ORG   @NM00399
@NM00400 DC    X'01'
@NM00401 DC    X'60'
@NM00402 DC    AL1(17)
@NM00403 DC    AL1(0)
         ORG   SUMFMT2+16
@NM00404 DS    CL4
         ORG   @NM00404
@NM00405 DC    X'01'
@NM00406 DC    X'30'
@NM00407 DC    AL1(25)
@NM00408 DC    AL1(0)
         ORG   SUMFMT2+20
@NM00409 DS    CL4
         ORG   @NM00409
@NM00410 DC    F'0'
         ORG   SUMFMT2+24
SUML3    DS    CL19
         ORG   SUML3
@NM00411 DC    CL8'ABENDING'
@NM00412 DC    CL7'PROGRAM'
@NM00413 DC    CL4'ADDR'
         ORG   SUML3+19
         DS    CL1
SUMFMT3  DS    CL24
         ORG   SUMFMT3
@NM00414 DS    CL4
         ORG   @NM00414
@NM00415 DC    X'01'
@NM00416 DC    X'40'
@NM00417 DC    AL1(0)
@NM00418 DC    AL1(0)
         ORG   SUMFMT3+4
@NM00419 DS    CL8
         ORG   @NM00419
@NM00420 DC    X'07'
@NM00421 DC    X'73'
@NM00422 DC    AL1(8)
@NM00423 DC    AL1(33)
@NM00424 DC    AL4(SUML3)
         ORG   SUMFMT3+12
@NM00425 DS    CL4
         ORG   @NM00425
@NM00426 DC    X'01'
@NM00427 DC    X'60'
@NM00428 DC    AL1(17)
@NM00429 DC    AL1(0)
         ORG   SUMFMT3+16
@NM00430 DS    CL4
         ORG   @NM00430
@NM00431 DC    X'01'
@NM00432 DC    X'30'
@NM00433 DC    AL1(25)
@NM00434 DC    AL1(0)
         ORG   SUMFMT3+20
@NM00435 DS    CL4
         ORG   @NM00435
@NM00436 DC    F'0'
         ORG   SUMFMT3+24
SUML4    DS    CL22
         ORG   SUML4
@NM00437 DC    CL4'REGS'
@NM00438 DC    CL2'AT'
@NM00439 DC    CL4'TIME'
@NM00440 DC    CL2'OF'
@NM00441 DC    CL5'ERROR'
@NM00442 DC    CL5'(0-7)'
         ORG   SUML4+22
         DS    CL2
SUMFMT4  DS    CL44
         ORG   SUMFMT4
@NM00443 DS    CL4
         ORG   @NM00443
@NM00444 DC    X'01'
@NM00445 DC    X'40'
@NM00446 DC    AL1(0)
@NM00447 DC    AL1(0)
         ORG   SUMFMT4+4
@NM00448 DS    CL8
         ORG   @NM00448
@NM00449 DC    X'07'
@NM00450 DC    X'33'
@NM00451 DC    AL1(8)
@NM00452 DC    AL1(33)
@NM00453 DC    AL4(SUML4)
         ORG   SUMFMT4+12
@NM00454 DS    CL4
         ORG   @NM00454
@NM00455 DC    X'05'
@NM00456 DC    X'13'
@NM00457 DC    AL1(13)
@NM00458 DC    AL1(42)
         ORG   SUMFMT4+16
@NM00459 DS    CL4
         ORG   @NM00459
@NM00460 DC    X'05'
@NM00461 DC    X'33'
@NM00462 DC    AL1(16)
@NM00463 DC    AL1(51)
         ORG   SUMFMT4+20
@NM00464 DS    CL4
         ORG   @NM00464
@NM00465 DC    X'05'
@NM00466 DC    X'13'
@NM00467 DC    AL1(21)
@NM00468 DC    AL1(60)
         ORG   SUMFMT4+24
@NM00469 DS    CL4
         ORG   @NM00469
@NM00470 DC    X'05'
@NM00471 DC    X'43'
@NM00472 DC    AL1(24)
@NM00473 DC    AL1(69)
         ORG   SUMFMT4+28
@NM00474 DS    CL4
         ORG   @NM00474
@NM00475 DC    X'05'
@NM00476 DC    X'43'
@NM00477 DC    AL1(107)
@NM00478 DC    AL1(78)
         ORG   SUMFMT4+32
@NM00479 DS    CL4
         ORG   @NM00479
@NM00480 DC    X'04'
@NM00481 DC    X'03'
@NM00482 DC    AL1(0)
@NM00483 DC    AL1(87)
         ORG   SUMFMT4+36
@NM00484 DS    CL4
         ORG   @NM00484
@NM00485 DC    X'04'
@NM00486 DC    X'03'
@NM00487 DC    AL1(0)
@NM00488 DC    AL1(96)
         ORG   SUMFMT4+40
@NM00489 DS    CL4
         ORG   @NM00489
@NM00490 DC    F'0'
         ORG   SUMFMT4+44
SUML5    DS    CL5
         ORG   SUML5
@NM00491 DC    CL5'(8-F)'
         ORG   SUML5+5
         DS    CL3
SUMFMT5  DS    CL44
         ORG   SUMFMT5
@NM00492 DS    CL4
         ORG   @NM00492
@NM00493 DC    X'01'
@NM00494 DC    X'40'
@NM00495 DC    AL1(0)
@NM00496 DC    AL1(0)
         ORG   SUMFMT5+4
@NM00497 DS    CL8
         ORG   @NM00497
@NM00498 DC    X'07'
@NM00499 DC    X'43'
@NM00500 DC    AL1(107)
@NM00501 DC    AL1(33)
@NM00502 DC    AL4(SUML5)
         ORG   SUMFMT5+12
@NM00503 DS    CL4
         ORG   @NM00503
@NM00504 DC    X'04'
@NM00505 DC    X'03'
@NM00506 DC    AL1(0)
@NM00507 DC    AL1(42)
         ORG   SUMFMT5+16
@NM00508 DS    CL4
         ORG   @NM00508
@NM00509 DC    X'04'
@NM00510 DC    X'03'
@NM00511 DC    AL1(0)
@NM00512 DC    AL1(51)
         ORG   SUMFMT5+20
@NM00513 DS    CL4
         ORG   @NM00513
@NM00514 DC    X'04'
@NM00515 DC    X'03'
@NM00516 DC    AL1(0)
@NM00517 DC    AL1(60)
         ORG   SUMFMT5+24
@NM00518 DS    CL4
         ORG   @NM00518
@NM00519 DC    X'04'
@NM00520 DC    X'03'
@NM00521 DC    AL1(0)
@NM00522 DC    AL1(69)
         ORG   SUMFMT5+28
@NM00523 DS    CL4
         ORG   @NM00523
@NM00524 DC    X'04'
@NM00525 DC    X'03'
@NM00526 DC    AL1(0)
@NM00527 DC    AL1(78)
         ORG   SUMFMT5+32
@NM00528 DS    CL4
         ORG   @NM00528
@NM00529 DC    X'04'
@NM00530 DC    X'03'
@NM00531 DC    AL1(0)
@NM00532 DC    AL1(87)
         ORG   SUMFMT5+36
@NM00533 DS    CL4
         ORG   @NM00533
@NM00534 DC    X'04'
@NM00535 DC    X'03'
@NM00536 DC    AL1(0)
@NM00537 DC    AL1(96)
         ORG   SUMFMT5+40
@NM00538 DS    CL4
         ORG   @NM00538
@NM00539 DC    F'0'
         ORG   SUMFMT5+44
SUML6    DS    CL18
         ORG   SUML6
@NM00540 DC    CL2'EC'
@NM00541 DC    CL3'PSW'
@NM00542 DC    CL2'AT'
@NM00543 DC    CL4'TIME'
@NM00544 DC    CL2'OF'
@NM00545 DC    CL5'ERROR'
         ORG   SUML6+18
         DS    CL2
SUMFMT6  DS    CL36
         ORG   SUMFMT6
@NM00546 DS    CL4
         ORG   @NM00546
@NM00547 DC    X'01'
@NM00548 DC    X'40'
@NM00549 DC    AL1(0)
@NM00550 DC    AL1(0)
         ORG   SUMFMT6+4
@NM00551 DS    CL8
         ORG   @NM00551
@NM00552 DC    X'07'
@NM00553 DC    X'13'
@NM00554 DC    AL1(8)
@NM00555 DC    AL1(33)
@NM00556 DC    AL4(SUML6)
         ORG   SUMFMT6+12
@NM00557 DS    CL4
         ORG   @NM00557
@NM00558 DC    X'05'
@NM00559 DC    X'23'
@NM00560 DC    AL1(11)
@NM00561 DC    AL1(42)
         ORG   SUMFMT6+16
@NM00562 DS    CL4
         ORG   @NM00562
@NM00563 DC    X'05'
@NM00564 DC    X'13'
@NM00565 DC    AL1(15)
@NM00566 DC    AL1(51)
         ORG   SUMFMT6+20
@NM00567 DS    CL4
         ORG   @NM00567
@NM00568 DC    X'05'
@NM00569 DC    X'33'
@NM00570 DC    AL1(18)
@NM00571 DC    AL1(60)
         ORG   SUMFMT6+24
@NM00572 DS    CL4
         ORG   @NM00572
@NM00573 DC    X'01'
@NM00574 DC    X'10'
@NM00575 DC    AL1(23)
@NM00576 DC    AL1(0)
         ORG   SUMFMT6+28
@NM00577 DS    CL4
         ORG   @NM00577
@NM00578 DC    X'01'
@NM00579 DC    X'40'
@NM00580 DC    AL1(26)
@NM00581 DC    AL1(0)
         ORG   SUMFMT6+32
@NM00582 DS    CL4
         ORG   @NM00582
@NM00583 DC    F'0'
         ORG   SUMFMT6+36
SUML7    DS    CL8
         ORG   SUML7
@NM00584 DC    CL8'SDWACOMP'
         ORG   SUML7+8
SUMFMT7  DS    CL16
         ORG   SUMFMT7
@NM00585 DS    CL4
         ORG   @NM00585
@NM00586 DC    X'01'
@NM00587 DC    X'40'
@NM00588 DC    AL1(0)
@NM00589 DC    AL1(0)
         ORG   SUMFMT7+4
@NM00590 DS    CL8
         ORG   @NM00590
@NM00591 DC    X'07'
@NM00592 DC    X'73'
@NM00593 DC    AL1(8)
@NM00594 DC    AL1(33)
@NM00595 DC    AL4(SUML7)
         ORG   SUMFMT7+12
@NM00596 DS    CL4
         ORG   @NM00596
@NM00597 DC    F'0'
         ORG   SUMFMT7+16
SUML8    DS    CL33
         ORG   SUML8
@NM00598 DC    CL5'RETRY'
@NM00599 DC    CL4'ADDR'
@NM00600 DC    CL8'RETURNED'
@NM00601 DC    CL4'FROM'
@NM00602 DC    CL8'RECOVERY'
@NM00603 DC    CL4'EXIT'
         ORG   SUML8+33
         DS    CL3
SUMFMT8  DS    CL36
         ORG   SUMFMT8
@NM00604 DS    CL4
         ORG   @NM00604
@NM00605 DC    X'01'
@NM00606 DC    X'40'
@NM00607 DC    AL1(0)
@NM00608 DC    AL1(0)
         ORG   SUMFMT8+4
@NM00609 DS    CL8
         ORG   @NM00609
@NM00610 DC    X'07'
@NM00611 DC    X'43'
@NM00612 DC    AL1(8)
@NM00613 DC    AL1(48)
@NM00614 DC    AL4(SUML8)
         ORG   SUMFMT8+12
@NM00615 DS    CL4
         ORG   @NM00615
@NM00616 DC    X'01'
@NM00617 DC    X'30'
@NM00618 DC    AL1(14)
@NM00619 DC    AL1(0)
         ORG   SUMFMT8+16
@NM00620 DS    CL4
         ORG   @NM00620
@NM00621 DC    X'01'
@NM00622 DC    X'70'
@NM00623 DC    AL1(19)
@NM00624 DC    AL1(0)
         ORG   SUMFMT8+20
@NM00625 DS    CL4
         ORG   @NM00625
@NM00626 DC    X'01'
@NM00627 DC    X'30'
@NM00628 DC    AL1(28)
@NM00629 DC    AL1(0)
         ORG   SUMFMT8+24
@NM00630 DS    CL4
         ORG   @NM00630
@NM00631 DC    X'01'
@NM00632 DC    X'70'
@NM00633 DC    AL1(33)
@NM00634 DC    AL1(0)
         ORG   SUMFMT8+28
@NM00635 DS    CL4
         ORG   @NM00635
@NM00636 DC    X'01'
@NM00637 DC    X'30'
@NM00638 DC    AL1(42)
@NM00639 DC    AL1(0)
         ORG   SUMFMT8+32
@NM00640 DS    CL4
         ORG   @NM00640
@NM00641 DC    F'0'
         ORG   SUMFMT8+36
SUML9    DS    CL14
         ORG   SUML9
@NM00642 DC    CL2'RB'
@NM00643 DC    CL4'ADDR'
@NM00644 DC    CL3'FOR'
@NM00645 DC    CL5'RETRY'
         ORG   SUML9+14
         DS    CL2
SUMFMT9  DS    CL28
         ORG   SUMFMT9
@NM00646 DS    CL4
         ORG   @NM00646
@NM00647 DC    X'01'
@NM00648 DC    X'40'
@NM00649 DC    AL1(0)
@NM00650 DC    AL1(0)
         ORG   SUMFMT9+4
@NM00651 DS    CL8
         ORG   @NM00651
@NM00652 DC    X'07'
@NM00653 DC    X'13'
@NM00654 DC    AL1(8)
@NM00655 DC    AL1(48)
@NM00656 DC    AL4(SUML9)
         ORG   SUMFMT9+12
@NM00657 DS    CL4
         ORG   @NM00657
@NM00658 DC    X'01'
@NM00659 DC    X'30'
@NM00660 DC    AL1(11)
@NM00661 DC    AL1(0)
         ORG   SUMFMT9+16
@NM00662 DS    CL4
         ORG   @NM00662
@NM00663 DC    X'01'
@NM00664 DC    X'20'
@NM00665 DC    AL1(16)
@NM00666 DC    AL1(0)
         ORG   SUMFMT9+20
@NM00667 DS    CL4
         ORG   @NM00667
@NM00668 DC    X'01'
@NM00669 DC    X'40'
@NM00670 DC    AL1(20)
@NM00671 DC    AL1(0)
         ORG   SUMFMT9+24
@NM00672 DS    CL4
         ORG   @NM00672
@NM00673 DC    F'0'
         ORG   SUMFMT9+28
SUML10   DS    CL7
         ORG   SUML10
@NM00674 DC    CL3'CVT'
@NM00675 DC    CL4'ADDR'
         ORG   SUML10+7
         DS    CL1
SUMFMT10 DS    CL20
         ORG   SUMFMT10
@NM00676 DS    CL4
         ORG   @NM00676
@NM00677 DC    X'01'
@NM00678 DC    X'40'
@NM00679 DC    AL1(0)
@NM00680 DC    AL1(0)
         ORG   SUMFMT10+4
@NM00681 DS    CL8
         ORG   @NM00681
@NM00682 DC    X'07'
@NM00683 DC    X'23'
@NM00684 DC    AL1(8)
@NM00685 DC    AL1(36)
@NM00686 DC    AL4(SUML10)
         ORG   SUMFMT10+12
@NM00687 DS    CL4
         ORG   @NM00687
@NM00688 DC    X'01'
@NM00689 DC    X'30'
@NM00690 DC    AL1(13)
@NM00691 DC    AL1(0)
         ORG   SUMFMT10+16
@NM00692 DS    CL4
         ORG   @NM00692
@NM00693 DC    F'0'
         ORG   SUMFMT10+20
SUML11   DS    CL8
         ORG   SUML11
@NM00694 DC    CL4'RTCT'
@NM00695 DC    CL4'ADDR'
         ORG   SUML11+8
SUMFMT11 DS    CL20
         ORG   SUMFMT11
@NM00696 DS    CL4
         ORG   @NM00696
@NM00697 DC    X'01'
@NM00698 DC    X'40'
@NM00699 DC    AL1(0)
@NM00700 DC    AL1(0)
         ORG   SUMFMT11+4
@NM00701 DS    CL8
         ORG   @NM00701
@NM00702 DC    X'07'
@NM00703 DC    X'33'
@NM00704 DC    AL1(8)
@NM00705 DC    AL1(36)
@NM00706 DC    AL4(SUML11)
         ORG   SUMFMT11+12
@NM00707 DS    CL4
         ORG   @NM00707
@NM00708 DC    X'01'
@NM00709 DC    X'30'
@NM00710 DC    AL1(13)
@NM00711 DC    AL1(0)
         ORG   SUMFMT11+16
@NM00712 DS    CL4
         ORG   @NM00712
@NM00713 DC    F'0'
         ORG   SUMFMT11+20
SUML12   DS    CL7
         ORG   SUML12
@NM00714 DC    CL3'SCB'
@NM00715 DC    CL4'ADDR'
         ORG   SUML12+7
         DS    CL1
SUMFMT12 DS    CL20
         ORG   SUMFMT12
@NM00716 DS    CL4
         ORG   @NM00716
@NM00717 DC    X'01'
@NM00718 DC    X'40'
@NM00719 DC    AL1(0)
@NM00720 DC    AL1(0)
         ORG   SUMFMT12+4
@NM00721 DS    CL8
         ORG   @NM00721
@NM00722 DC    X'07'
@NM00723 DC    X'23'
@NM00724 DC    AL1(8)
@NM00725 DC    AL1(36)
@NM00726 DC    AL4(SUML12)
         ORG   SUMFMT12+12
@NM00727 DS    CL4
         ORG   @NM00727
@NM00728 DC    X'01'
@NM00729 DC    X'30'
@NM00730 DC    AL1(13)
@NM00731 DC    AL1(0)
         ORG   SUMFMT12+16
@NM00732 DS    CL4
         ORG   @NM00732
@NM00733 DC    F'0'
         ORG   SUMFMT12+20
SUML13   DS    CL8
         ORG   SUML13
@NM00734 DC    CL4'SDWA'
@NM00735 DC    CL4'ADDR'
         ORG   SUML13+8
SUMFMT13 DS    CL20
         ORG   SUMFMT13
@NM00736 DS    CL4
         ORG   @NM00736
@NM00737 DC    X'01'
@NM00738 DC    X'40'
@NM00739 DC    AL1(0)
@NM00740 DC    AL1(0)
         ORG   SUMFMT13+4
@NM00741 DS    CL8
         ORG   @NM00741
@NM00742 DC    X'07'
@NM00743 DC    X'33'
@NM00744 DC    AL1(8)
@NM00745 DC    AL1(36)
@NM00746 DC    AL4(SUML13)
         ORG   SUMFMT13+12
@NM00747 DS    CL4
         ORG   @NM00747
@NM00748 DC    X'01'
@NM00749 DC    X'30'
@NM00750 DC    AL1(13)
@NM00751 DC    AL1(0)
         ORG   SUMFMT13+16
@NM00752 DS    CL4
         ORG   @NM00752
@NM00753 DC    F'0'
         ORG   SUMFMT13+20
SUML14   DS    CL8
         ORG   SUML14
@NM00754 DC    CL4'SVRB'
@NM00755 DC    CL4'ADDR'
         ORG   SUML14+8
SUMFMT14 DS    CL20
         ORG   SUMFMT14
@NM00756 DS    CL4
         ORG   @NM00756
@NM00757 DC    X'01'
@NM00758 DC    X'40'
@NM00759 DC    AL1(0)
@NM00760 DC    AL1(0)
         ORG   SUMFMT14+4
@NM00761 DS    CL8
         ORG   @NM00761
@NM00762 DC    X'07'
@NM00763 DC    X'33'
@NM00764 DC    AL1(8)
@NM00765 DC    AL1(36)
@NM00766 DC    AL4(SUML14)
         ORG   SUMFMT14+12
@NM00767 DS    CL4
         ORG   @NM00767
@NM00768 DC    X'01'
@NM00769 DC    X'30'
@NM00770 DC    AL1(13)
@NM00771 DC    AL1(0)
         ORG   SUMFMT14+16
@NM00772 DS    CL4
         ORG   @NM00772
@NM00773 DC    F'0'
         ORG   SUMFMT14+20
SUML15   DS    CL20
         ORG   SUML15
@NM00774 DC    CL4'PREV'
@NM00775 DC    CL6'RTM2WA'
@NM00776 DC    CL3'FOR'
@NM00777 DC    CL3'THE'
@NM00778 DC    CL4'TASK'
         ORG   SUML15+20
SUMFMT15 DS    CL32
         ORG   SUMFMT15
@NM00779 DS    CL4
         ORG   @NM00779
@NM00780 DC    X'01'
@NM00781 DC    X'40'
@NM00782 DC    AL1(0)
@NM00783 DC    AL1(0)
         ORG   SUMFMT15+4
@NM00784 DS    CL8
         ORG   @NM00784
@NM00785 DC    X'07'
@NM00786 DC    X'33'
@NM00787 DC    AL1(8)
@NM00788 DC    AL1(36)
@NM00789 DC    AL4(SUML15)
         ORG   SUMFMT15+12
@NM00790 DS    CL4
         ORG   @NM00790
@NM00791 DC    X'01'
@NM00792 DC    X'50'
@NM00793 DC    AL1(13)
@NM00794 DC    AL1(0)
         ORG   SUMFMT15+16
@NM00795 DS    CL4
         ORG   @NM00795
@NM00796 DC    X'01'
@NM00797 DC    X'20'
@NM00798 DC    AL1(20)
@NM00799 DC    AL1(0)
         ORG   SUMFMT15+20
@NM00800 DS    CL4
         ORG   @NM00800
@NM00801 DC    X'01'
@NM00802 DC    X'20'
@NM00803 DC    AL1(24)
@NM00804 DC    AL1(0)
         ORG   SUMFMT15+24
@NM00805 DS    CL4
         ORG   @NM00805
@NM00806 DC    X'01'
@NM00807 DC    X'30'
@NM00808 DC    AL1(28)
@NM00809 DC    AL1(0)
         ORG   SUMFMT15+28
@NM00810 DS    CL4
         ORG   @NM00810
@NM00811 DC    F'0'
         ORG   SUMFMT15+32
SUML16   DS    CL22
         ORG   SUML16
@NM00812 DC    CL4'PREV'
@NM00813 DC    CL6'RTM2WA'
@NM00814 DC    CL3'FOR'
@NM00815 DC    CL9'RECURSION'
         ORG   SUML16+22
         DS    CL2
SUMFMT16 DS    CL28
         ORG   SUMFMT16
@NM00816 DS    CL4
         ORG   @NM00816
@NM00817 DC    X'01'
@NM00818 DC    X'40'
@NM00819 DC    AL1(0)
@NM00820 DC    AL1(0)
         ORG   SUMFMT16+4
@NM00821 DS    CL8
         ORG   @NM00821
@NM00822 DC    X'07'
@NM00823 DC    X'33'
@NM00824 DC    AL1(8)
@NM00825 DC    AL1(36)
@NM00826 DC    AL4(SUML16)
         ORG   SUMFMT16+12
@NM00827 DS    CL4
         ORG   @NM00827
@NM00828 DC    X'01'
@NM00829 DC    X'50'
@NM00830 DC    AL1(13)
@NM00831 DC    AL1(0)
         ORG   SUMFMT16+16
@NM00832 DS    CL4
         ORG   @NM00832
@NM00833 DC    X'01'
@NM00834 DC    X'20'
@NM00835 DC    AL1(20)
@NM00836 DC    AL1(0)
         ORG   SUMFMT16+20
@NM00837 DS    CL4
         ORG   @NM00837
@NM00838 DC    X'01'
@NM00839 DC    X'80'
@NM00840 DC    AL1(24)
@NM00841 DC    AL1(0)
         ORG   SUMFMT16+24
@NM00842 DS    CL4
         ORG   @NM00842
@NM00843 DC    F'0'
         ORG   SUMFMT16+28
SUML17   DS    CL30
         ORG   SUML17
@NM00844 DC    CL4'ASID'
@NM00845 DC    CL2'OF'
@NM00846 DC    CL5'ERROR'
@NM00847 DC    CL2'IF'
@NM00848 DC    CL5'CROSS'
@NM00849 DC    CL6'MEMORY'
@NM00850 DC    CL6'ABTERM'
         ORG   SUML17+30
         DS    CL2
SUMFMT17 DS    CL40
         ORG   SUMFMT17
@NM00851 DS    CL4
         ORG   @NM00851
@NM00852 DC    X'01'
@NM00853 DC    X'40'
@NM00854 DC    AL1(0)
@NM00855 DC    AL1(0)
         ORG   SUMFMT17+4
@NM00856 DS    CL8
         ORG   @NM00856
@NM00857 DC    X'07'
@NM00858 DC    X'31'
@NM00859 DC    AL1(8)
@NM00860 DC    AL1(51)
@NM00861 DC    AL4(SUML17)
         ORG   SUMFMT17+12
@NM00862 DS    CL4
         ORG   @NM00862
@NM00863 DC    X'01'
@NM00864 DC    X'10'
@NM00865 DC    AL1(13)
@NM00866 DC    AL1(0)
         ORG   SUMFMT17+16
@NM00867 DS    CL4
         ORG   @NM00867
@NM00868 DC    X'01'
@NM00869 DC    X'40'
@NM00870 DC    AL1(16)
@NM00871 DC    AL1(0)
         ORG   SUMFMT17+20
@NM00872 DS    CL4
         ORG   @NM00872
@NM00873 DC    X'01'
@NM00874 DC    X'10'
@NM00875 DC    AL1(22)
@NM00876 DC    AL1(0)
         ORG   SUMFMT17+24
@NM00877 DS    CL4
         ORG   @NM00877
@NM00878 DC    X'01'
@NM00879 DC    X'40'
@NM00880 DC    AL1(25)
@NM00881 DC    AL1(0)
         ORG   SUMFMT17+28
@NM00882 DS    CL4
         ORG   @NM00882
@NM00883 DC    X'01'
@NM00884 DC    X'50'
@NM00885 DC    AL1(31)
@NM00886 DC    AL1(0)
         ORG   SUMFMT17+32
@NM00887 DS    CL4
         ORG   @NM00887
@NM00888 DC    X'01'
@NM00889 DC    X'50'
@NM00890 DC    AL1(38)
@NM00891 DC    AL1(0)
         ORG   SUMFMT17+36
@NM00892 DS    CL4
         ORG   @NM00892
@NM00893 DC    F'0'
         ORG   SUMFMT17+40
SUML18   DS    CL9
         ORG   SUML18
@NM00894 DC    CL5'ERROR'
@NM00895 DC    CL4'ASID'
         ORG   SUML18+9
         DS    CL3
SUMFMT18 DS    CL20
         ORG   SUMFMT18
@NM00896 DS    CL4
         ORG   @NM00896
@NM00897 DC    X'01'
@NM00898 DC    X'40'
@NM00899 DC    AL1(0)
@NM00900 DC    AL1(0)
         ORG   SUMFMT18+4
@NM00901 DS    CL8
         ORG   @NM00901
@NM00902 DC    X'07'
@NM00903 DC    X'41'
@NM00904 DC    AL1(8)
@NM00905 DC    AL1(33)
@NM00906 DC    AL4(SUML18)
         ORG   SUMFMT18+12
@NM00907 DS    CL4
         ORG   @NM00907
@NM00908 DC    X'01'
@NM00909 DC    X'30'
@NM00910 DC    AL1(14)
@NM00911 DC    AL1(0)
         ORG   SUMFMT18+16
@NM00912 DS    CL4
         ORG   @NM00912
@NM00913 DC    F'0'
         ORG   SUMFMT18+20
SUML19   DS    CL35
         ORG   SUML19
@NM00914 DC    CL7'CURRENT'
@NM00915 DC    CL5'TRACE'
@NM00916 DC    CL5'ENTRY'
@NM00917 DC    CL3'FOR'
@NM00918 DC    CL5'SAVED'
@NM00919 DC    CL5'TRACE'
@NM00920 DC    CL5'TABLE'
         ORG   SUML19+35
         DS    CL1
SUMFMT19 DS    CL40
         ORG   SUMFMT19
@NM00921 DS    CL4
         ORG   @NM00921
@NM00922 DC    X'01'
@NM00923 DC    X'40'
@NM00924 DC    AL1(0)
@NM00925 DC    AL1(0)
         ORG   SUMFMT19+4
@NM00926 DS    CL8
         ORG   @NM00926
@NM00927 DC    X'07'
@NM00928 DC    X'63'
@NM00929 DC    AL1(8)
@NM00930 DC    AL1(51)
@NM00931 DC    AL4(SUML19)
         ORG   SUMFMT19+12
@NM00932 DS    CL4
         ORG   @NM00932
@NM00933 DC    X'01'
@NM00934 DC    X'40'
@NM00935 DC    AL1(16)
@NM00936 DC    AL1(0)
         ORG   SUMFMT19+16
@NM00937 DS    CL4
         ORG   @NM00937
@NM00938 DC    X'01'
@NM00939 DC    X'40'
@NM00940 DC    AL1(22)
@NM00941 DC    AL1(0)
         ORG   SUMFMT19+20
@NM00942 DS    CL4
         ORG   @NM00942
@NM00943 DC    X'01'
@NM00944 DC    X'20'
@NM00945 DC    AL1(28)
@NM00946 DC    AL1(0)
         ORG   SUMFMT19+24
@NM00947 DS    CL4
         ORG   @NM00947
@NM00948 DC    X'01'
@NM00949 DC    X'40'
@NM00950 DC    AL1(32)
@NM00951 DC    AL1(0)
         ORG   SUMFMT19+28
@NM00952 DS    CL4
         ORG   @NM00952
@NM00953 DC    X'01'
@NM00954 DC    X'40'
@NM00955 DC    AL1(38)
@NM00956 DC    AL1(0)
         ORG   SUMFMT19+32
@NM00957 DS    CL4
         ORG   @NM00957
@NM00958 DC    X'01'
@NM00959 DC    X'40'
@NM00960 DC    AL1(44)
@NM00961 DC    AL1(0)
         ORG   SUMFMT19+36
@NM00962 DS    CL4
         ORG   @NM00962
@NM00963 DC    F'0'
         ORG   SUMFMT19+40
SUML20   DS    CL33
         ORG   SUML20
@NM00964 DC    CL5'FIRST'
@NM00965 DC    CL5'TRACE'
@NM00966 DC    CL5'ENTRY'
@NM00967 DC    CL3'FOR'
@NM00968 DC    CL5'SAVED'
@NM00969 DC    CL5'TRACE'
@NM00970 DC    CL5'TABLE'
         ORG   SUML20+33
         DS    CL3
SUMFMT20 DS    CL40
         ORG   SUMFMT20
@NM00971 DS    CL4
         ORG   @NM00971
@NM00972 DC    X'01'
@NM00973 DC    X'40'
@NM00974 DC    AL1(0)
@NM00975 DC    AL1(0)
         ORG   SUMFMT20+4
@NM00976 DS    CL8
         ORG   @NM00976
@NM00977 DC    X'07'
@NM00978 DC    X'43'
@NM00979 DC    AL1(8)
@NM00980 DC    AL1(51)
@NM00981 DC    AL4(SUML20)
         ORG   SUMFMT20+12
@NM00982 DS    CL4
         ORG   @NM00982
@NM00983 DC    X'01'
@NM00984 DC    X'40'
@NM00985 DC    AL1(14)
@NM00986 DC    AL1(0)
         ORG   SUMFMT20+16
@NM00987 DS    CL4
         ORG   @NM00987
@NM00988 DC    X'01'
@NM00989 DC    X'40'
@NM00990 DC    AL1(20)
@NM00991 DC    AL1(0)
         ORG   SUMFMT20+20
@NM00992 DS    CL4
         ORG   @NM00992
@NM00993 DC    X'01'
@NM00994 DC    X'20'
@NM00995 DC    AL1(26)
@NM00996 DC    AL1(0)
         ORG   SUMFMT20+24
@NM00997 DS    CL4
         ORG   @NM00997
@NM00998 DC    X'01'
@NM00999 DC    X'40'
@NM01000 DC    AL1(30)
@NM01001 DC    AL1(0)
         ORG   SUMFMT20+28
@NM01002 DS    CL4
         ORG   @NM01002
@NM01003 DC    X'01'
@NM01004 DC    X'40'
@NM01005 DC    AL1(36)
@NM01006 DC    AL1(0)
         ORG   SUMFMT20+32
@NM01007 DS    CL4
         ORG   @NM01007
@NM01008 DC    X'01'
@NM01009 DC    X'40'
@NM01010 DC    AL1(42)
@NM01011 DC    AL1(0)
         ORG   SUMFMT20+36
@NM01012 DS    CL4
         ORG   @NM01012
@NM01013 DC    F'0'
         ORG   SUMFMT20+40
SUML21   DS    CL32
         ORG   SUML21
@NM01014 DC    CL4'LAST'
@NM01015 DC    CL5'TRACE'
@NM01016 DC    CL5'ENTRY'
@NM01017 DC    CL3'FOR'
@NM01018 DC    CL5'SAVED'
@NM01019 DC    CL5'TRACE'
@NM01020 DC    CL5'TABLE'
         ORG   SUML21+32
SUMFMT21 DS    CL40
         ORG   SUMFMT21
@NM01021 DS    CL4
         ORG   @NM01021
@NM01022 DC    X'01'
@NM01023 DC    X'40'
@NM01024 DC    AL1(0)
@NM01025 DC    AL1(0)
         ORG   SUMFMT21+4
@NM01026 DS    CL8
         ORG   @NM01026
@NM01027 DC    X'07'
@NM01028 DC    X'33'
@NM01029 DC    AL1(8)
@NM01030 DC    AL1(51)
@NM01031 DC    AL4(SUML21)
         ORG   SUMFMT21+12
@NM01032 DS    CL4
         ORG   @NM01032
@NM01033 DC    X'01'
@NM01034 DC    X'40'
@NM01035 DC    AL1(13)
@NM01036 DC    AL1(0)
         ORG   SUMFMT21+16
@NM01037 DS    CL4
         ORG   @NM01037
@NM01038 DC    X'01'
@NM01039 DC    X'40'
@NM01040 DC    AL1(19)
@NM01041 DC    AL1(0)
         ORG   SUMFMT21+20
@NM01042 DS    CL4
         ORG   @NM01042
@NM01043 DC    X'01'
@NM01044 DC    X'20'
@NM01045 DC    AL1(25)
@NM01046 DC    AL1(0)
         ORG   SUMFMT21+24
@NM01047 DS    CL4
         ORG   @NM01047
@NM01048 DC    X'01'
@NM01049 DC    X'40'
@NM01050 DC    AL1(29)
@NM01051 DC    AL1(0)
         ORG   SUMFMT21+28
@NM01052 DS    CL4
         ORG   @NM01052
@NM01053 DC    X'01'
@NM01054 DC    X'40'
@NM01055 DC    AL1(35)
@NM01056 DC    AL1(0)
         ORG   SUMFMT21+32
@NM01057 DS    CL4
         ORG   @NM01057
@NM01058 DC    X'01'
@NM01059 DC    X'40'
@NM01060 DC    AL1(41)
@NM01061 DC    AL1(0)
         ORG   SUMFMT21+36
@NM01062 DS    CL4
         ORG   @NM01062
@NM01063 DC    F'0'
         ORG   SUMFMT21+40
REL2     DC    CL2'02'
TRANS    DS    CL256
         ORG   TRANS
@NM01068 DS    CL64
BL       DC    CL1' '
@NM01069 DS    CL175
NUMS     DC    CL16'0123456789ABCDEF'
         ORG   TRANS+256
ESAHDR   DC    CL61'ESA BIT FLAG SUMMARY (RTM1 RELATED INFORMATION) FROC
               M SVRB AT '
ESASTART DC    CL13'RTM2 ENTERED '
ESAUS    DC    CL60'---------------------------------------------------C
               ---------'
RCEND1   DC    CL46',CONTINUE WITH TERMINATION-IMPLIES PERCOLATION'
RCEND2   DC    CL6',RETRY'
RCEND3   DC    CL64',CONTINUE WITH TERMINATION-PREVENT FURTHER STAI/ESTC
               AI PROCESSING'
RCEND4   DC    CL14',UNKNOWN VALUE'
RCMSG    DC    CL34'RETURN CODE FROM RECOVERY ROUTINE-'
RECUR    DC    CL17'RECURSION DURING '
RMPLMSG1 DC    CL16'TASK TERMINATION'
RT2BSUM  DC    CL23'RTM2WA BIT FLAG SUMMARY'
RT2FMT   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING RTM2WAC
                FORMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
RT2HDR   DC    CL54'-RTM2WA-----------------------------------AT LOCATIC
               ON '
RT2SMHDR DC    CL14'RTM2WA SUMMARY'
RT2US    DC    CL7' ------'
SDWAFMT  DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING SDWA FC
               ORMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
SDWAHDR  DC    CL42'REGISTERS TAKEN FROM THE SDWA AT LOCATION '
BLANKS   DC    CL120' '
EXITMSG  DC    CL34'FIELD CONTAINS INTERNAL EXIT FLAGS'
RTSTART  DC    CL17'RTM1 ENTERED FOR '
SYSTATE  DC    CL13'SYSTEM STATE:'
RT2PATCH DC    CL200'PATCH AREA FOR IEAFTRT2 - IT IS 200 BYTES LONG'
         DS    CL3
RTM2NAME DC    AL4(RTM2FMT1)
         DC    AL4(RTM2FMT2)
         DC    AL4(RTM2FMT3)
         DC    AL4(RTM2FMT4)
         DC    AL4(RTM2FMT5)
         DC    AL4(RTM2FMT6)
         DC    AL4(RTM2FMT7)
         DC    AL4(RTM2FMT8)
         DC    AL4(RTM2FT9)
         DC    AL4(RTM2FT10)
         DC    AL4(RTM2FT11)
         DC    AL4(RTM2FT12)
         DC    AL4(RTM2FT13)
         DC    AL4(RTM2FT14)
         DC    AL4(RTM2FT15)
         DC    AL4(RTM2FT16)
         DC    AL4(RTM2FT17)
         DC    AL4(RTM2FT18)
         DC    AL4(RTM2FT19)
         DC    AL4(RTM2FT20)
SUMNAMES DC    AL4(SUMFMT1)
         DC    AL4(SUMFMT2)
         DC    AL4(SUMFMT3)
         DC    AL4(SUMFMT4)
         DC    AL4(SUMFMT5)
         DC    AL4(SUMFMT6)
         DC    AL4(SUMFMT7)
         DC    AL4(SUMFMT8)
         DC    AL4(SUMFMT9)
         DC    AL4(SUMFMT10)
         DC    AL4(SUMFMT11)
         DC    AL4(SUMFMT12)
         DC    AL4(SUMFMT13)
         DC    AL4(SUMFMT14)
         DC    AL4(SUMFMT15)
         DC    AL4(SUMFMT16)
         DC    AL4(SUMFMT17)
         DC    AL4(SUMFMT18)
         DC    AL4(SUMFMT19)
         DC    AL4(SUMFMT20)
         DC    AL4(SUMFMT21)
FIELDARY DC    AL4(RTM2CODE)
         DC    AL4(RTM2ABNM)
         DC    AL4(RTM2ABEP)
         DC    AL4(RTM2EREG)
         DC    AL4(RTM2EREG+32)
         DC    AL4(RTM2APSW)
         DC    AL4(RTM2COMP)
         DC    AL4(RTM2RTYA)
         DC    AL4(RTM2RYRB)
         DC    AL4(RTM2CVT)
         DC    AL4(RTM2CT)
         DC    AL4(RTM2SCBS)
         DC    AL4(RTM2RTCA)
         DC    AL4(RTM2VRBC)
         DC    AL4(RTM2PREV)
         DC    AL4(RTM2PRWA)
         DC    AL4(RTM2FMID)
         DC    AL4(RTM2ERAS)
         DC    AL4(RTM2TRCU)
         DC    AL4(RTM2TRFS)
         DC    AL4(RTM2TRLS)
RT2ARRAY DC    F'8'
         DC    F'7'
         DC    F'21'
         DC    F'9'
         DC    F'8'
         DC    F'8'
         DC    F'4'
         DC    F'10'
         DC    F'21'
         DC    F'3'
         DC    F'21'
         DC    F'11'
         DC    F'7'
         DC    F'10'
         DC    F'21'
         DC    F'8'
         DC    F'8'
         DC    F'3'
         DC    F'21'
         DC    F'12'
         DC    F'5'
         DC    F'21'
         DC    F'13'
         DC    F'8'
         DC    F'10'
         DC    F'21'
         DC    F'8'
         DC    F'8'
         DC    F'21'
         DC    F'14'
         DC    F'8'
         DC    F'8'
         DC    F'2'
         DC    F'10'
         DC    F'21'
         DC    F'8'
         DC    F'6'
         DC    F'21'
         DC    F'15'
         DC    F'8'
         DC    F'8'
         DC    F'21'
         DC    F'16'
         DC    F'8'
         DC    F'8'
         DC    F'2'
         DC    F'21'
         DC    F'17'
         DC    F'8'
         DC    F'8'
         DC    F'2'
         DC    F'10'
         DC    F'21'
         DC    F'1'
         DC    F'21'
         DC    F'18'
         DC    F'6'
         DC    F'21'
         DC    F'19'
         DC    F'8'
         DC    F'8'
         DC    F'21'
         DC    F'20'
         DC    F'8'
         DC    F'8'
         DC    F'2'
         DC    F'21'
         DC    F'102'
CTLRMSG  DC    CL29'RECURSIVE ENTRY'
         DC    CL29'RETRY REQUESTED BY EXIT'
         DC    CL29'LAST TASK ENDED'
         DC    CL29'STORAGE RANGES WRAPPED AROUND'
         DC    CL29' '
         DC    CL29' '
         DC    CL29' '
         DC    CL29' '
ERRAMSG  DC    CL37'MACHINE CHECK'
         DC    CL37'PROGRAM CHECK'
         DC    CL37'CONSOLE RESTART'
         DC    CL37'TASK ISSUED SVC 13'
         DC    CL37'ENTRY TO RTM2 VIA ABTERM'
         DC    CL37'SVC ISSUED BY A LOCKED OR SRB ROUTINE'
         DC    CL37'UNRECOVERABLE TRANSLATION FAILURE'
         DC    CL37'PAGE I/O ERROR'
ERRBMSG  DC    CL57' '
         DC    CL57' '
         DC    CL57' '
         DC    CL57' '
         DC    CL57'TYPE 1 SVC IN CONTROL AT ERROR'
         DC    CL57'ENABLED RB IN CONTROL AT ERROR'
         DC    CL57'LOCKED OR PHYSICALLY DISABLED ROUTINE IN CONTROL ATC
                ERROR'
         DC    CL57'SYSTEM IN SRB MODE AT ERROR'
ERRDMSG  DC    CL47'ONLY CLEAN UP-NOT RETRY'
         DC    CL47'RB OF THIS ESTA NOT IN CONTROL AT ERROR'
         DC    CL47'THIS ESTA EXIT ENTERED FOR PREVIOUS ABEND'
         DC    CL47'ANOTHER TASK IN JOBSTEP REQUESTED STEP ABEND'
         DC    CL47'ANCESTOR OF THIS TASK ABENDED'
         DC    CL47'REGS AND PSW AT TIME OF ERROR ARE NOT AVAILABLE'
         DC    CL47'MACHINE CHECK INFORMATION UNAVAILABLE'
         DC    CL47'ERROR ID INFORMATION AVAILABLE'
FLAGSMSG DC    CL40'FOR RECURSION'
         DC    CL40'VIA ABTERM'
         DC    CL40'FOR PURGE ONLY(ANCESTOR OF TASK ABENDED)'
         DC    CL40'FOR CONVERT TO STEP'
         DC    CL40'FOR NORMAL END OF TASK'
         DC    CL40'FOR TASK TERMINATION'
         DC    CL40'FOR VALID END OF MEMORY'
         DC    CL40' '
RECURMSG DC    CL31'GETMAIN'
         DC    CL31'SDUMP'
         DC    CL31'INITIALIZATION'
         DC    CL31'ACQUIRING LOCK'
         DC    CL31'RTM2 TO STOP FURTHER PROCESSING'
         DC    CL31'CHECK FOR RECURSION'
         DC    CL31'SLIP PROCESSING'
         DC    CL31' '
RMPLMSG  DC    CL46'ABNORMAL TERMINATION'
         DC    CL46'MEMORY TERMINATION'
         DC    CL46'RB RELATED PURGE'
         DC    CL46'INHIBITING PAGE UNFIXES'
         DC    CL46'TASK RECOVERY OF RTM2 IS CALLER'
         DC    CL46'TERMINATING TASK IS JOBSTEP'
         DC    CL46'TYPE 1 MESSAGE TABLE ENTRIES ARE TO BE WRITTEN'
         DC    CL46' '
MODEMSG  DC    CL25'SUPERVISOR CONTROL MODE'
         DC    CL25'PHYSICALLY DISABLED STATE'
         DC    CL25'GLOBAL SPIN LOCK HELD'
         DC    CL25'GLOBAL SUSPEND LOCK HELD'
         DC    CL25'LOCALLY LOCKED MODE'
         DC    CL25'TYPE 1 SVC MODE'
         DC    CL25'SRB MODE'
         DC    CL25'TASK MODE'
RTARRAY  DC    CL50'PROGRAM CHECK'
         DC    CL50'RESTART'
         DC    CL50'SVC ERROR'
         DC    CL50'DAT ERROR'
         DC    CL50'MACHINE CHECK REENTRY'
         DC    CL50'RESCHEDULE OF PAGE I/O ERROR'
         DC    CL50'RESCHEDULE OF ABNORMAL TERMINATION'
         DC    CL50'RESCHEDULE OF ABNORMAL TERMINATION THROUGH CVTBTRM'
         DC    CL50'RESCHEDULE OF CROSS MEMORY ABNORMAL TERMINATION'
         DC    CL50'RESCHEDULE OF ABNORMAL TERMINATION OF CURRENT TCB'
         DC    CL50'MEMORY TERMINATION'
         DC    CL50'CROSS MEMORY ABNORMAL TERMINATION'
         DC    CL50'RESCHEDULE OF RTM1 ON OTHER CPU'
         DC    CL50'MACHINE CHECK'
TESTBITS DC    X'80'
         DC    X'40'
         DC    X'20'
         DC    X'10'
         DC    X'08'
         DC    X'04'
         DC    X'02'
         DC    X'01'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LNGTHEQU EQU   @05
INDEX    EQU   @07
CONVRT   EQU   @07
FIELDADR EQU   @07
DATAPTR  EQU   @06
ARRAYCNT EQU   @05
SDWAPTR  EQU   @05
RTM2PTR  EQU   @08
RBSECPTR EQU   @05
ABDPLPTR EQU   @01
LINEPTR  EQU   @00
VADR     EQU   @00
RCREG    EQU   @15
ABDPL    EQU   0
ADPLFLAG EQU   ABDPL+7
ADPLSNPR EQU   ADPLFLAG
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLCVT  EQU   ABDPL+16
ADPLMEMA EQU   ABDPL+20
ADPLFRMT EQU   ABDPL+24
ADPLCOM1 EQU   ABDPL+28
ADPLCOM2 EQU   ABDPL+32
ADPLFMT1 EQU   ABDPL+44
ADPLFMT2 EQU   ABDPL+48
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
CVTNUMB  EQU   CVTRELNO
RTM2ESA  EQU   0
ESAREGS  EQU   RTM2ESA
ESAR1    EQU   ESAREGS+4
ESACCF1  EQU   ESAR1
ESART2D  EQU   RTM2ESA+36
ESAFLAGS EQU   RTM2ESA+40
ESARFLAG EQU   RTM2ESA+41
ESAERTYP EQU   RTM2ESA+42
ESAMODE  EQU   RTM2ESA+43
ESACMP   EQU   RTM2ESA+44
ESACCF   EQU   ESACMP
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBEXSAVE EQU   XRBESA
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00019 EQU   RBSECT+10
@NM00020 EQU   @NM00019
RBTRSVRB EQU   @NM00020
@NM00022 EQU   @NM00019+1
RBETXR   EQU   @NM00022
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00029 EQU   RBSECT+28
@NM00030 EQU   @NM00029
IRBEND   EQU   RBSECT+96
@NM00033 EQU   RBSECT+96
RBRSV138 EQU   @NM00033+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
SNPPARMS EQU   0
SNPFLAG  EQU   SNPPARMS+1
SNPSDATA EQU   SNPPARMS+4
SNPSDAT0 EQU   SNPSDATA
SNPSDAT1 EQU   SNPSDATA+1
SNPPDATA EQU   SNPPARMS+6
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RTM2WA   EQU   0
RTM2DESC EQU   RTM2WA
RTM2RT2D EQU   RTM2DESC+8
RTM2CVT  EQU   RTM2WA+12
RTM2VRBC EQU   RTM2WA+20
RTM2CODE EQU   RTM2WA+28
RTM2CCF  EQU   RTM2CODE
RTM2CT   EQU   RTM2WA+56
RTM2PGCY EQU   RTM2WA+60
RTM2TRRY EQU   RTM2PGCY
RTM2EEDR EQU   RTM2TRRY
RTM2EREG EQU   RTM2EEDR
RTM2APSW EQU   RTM2EEDR+64
RTM2EPSW EQU   RTM2APSW
RTM2EMK1 EQU   RTM2EPSW
RTM2MWP1 EQU   RTM2EPSW+1
RTM2INT1 EQU   RTM2EPSW+2
RTM2NXT1 EQU   RTM2EPSW+4
RTM2AEC1 EQU   RTM2APSW+8
RTM2ILC1 EQU   RTM2AEC1+1
RTM2INC1 EQU   RTM2AEC1+2
RTM2ICD1 EQU   RTM2INC1+1
RTM2ABNM EQU   RTM2TRRY+80
RTM2ABEP EQU   RTM2TRRY+88
RTM2EEDH EQU   RTM2TRRY+92
RTM2STCK EQU   RTM2EEDH
RTM2MCHI EQU   RTM2EEDH+8
RTM2MCHS EQU   RTM2MCHI
RTM2MCHD EQU   RTM2MCHI+1
RTM2RSR1 EQU   RTM2EEDH+12
RTM2RSR2 EQU   RTM2EEDH+13
RTM2FLGS EQU   RTM2TRRY+120
RTM2ERRA EQU   RTM2FLGS
RTM2ERRB EQU   RTM2FLGS+1
RTM2ERRC EQU   RTM2FLGS+2
RTM2ERRD EQU   RTM2FLGS+3
RTM2FMID EQU   RTM2TRRY+124
RTM2CVER EQU   RTM2WA+186
RTM2TRRC EQU   RTM2CVER
RTM2IOFS EQU   RTM2TRRC
RTM2IOBP EQU   RTM2TRRC+2
RTM2SCBS EQU   RTM2TRRC+14
RTM2RTCD EQU   RTM2TRRC+26
RTM2RTCA EQU   RTM2RTCD
RTM2SPLL EQU   RTM2RTCD+4
RTM2COMP EQU   RTM2TRRC+34
RTM2RTYA EQU   RTM2TRRC+38
RTM2RYRB EQU   RTM2TRRC+42
RTM2PARQ EQU   RTM2TRRC+46
RTM2RCDE EQU   RTM2PARQ
RTM2CTL1 EQU   RTM2CVER+50
RTM2CMKA EQU   RTM2CTL1
RTM2MWPA EQU   RTM2CTL1+1
RTM2PMKA EQU   RTM2CTL1+4
RTM2CTL2 EQU   RTM2CVER+58
RTM2CMKP EQU   RTM2CTL2
RTM2MWPP EQU   RTM2CTL2+1
RTM2PMKP EQU   RTM2CTL2+4
RTM2SNAP EQU   RTM2CVER+66
RTM2SPRM EQU   RTM2SNAP+4
RTM2DPSL EQU   RTM2SNAP+24
RTM2FRM1 EQU   RTM2DPSL
RTM2TO1  EQU   RTM2DPSL+4
RTM2FRM2 EQU   RTM2DPSL+8
RTM2TO2  EQU   RTM2DPSL+12
RTM2FRM3 EQU   RTM2DPSL+16
RTM2TO3  EQU   RTM2DPSL+20
RTM2FRM4 EQU   RTM2DPSL+24
RTM2TO4  EQU   RTM2DPSL+28
RTM2SECB EQU   RTM2CVER+138
RTM2ECBA EQU   RTM2SECB
RTM2PREV EQU   RTM2CVER+178
RTM2PRWA EQU   RTM2CVER+182
RTM2SFRG EQU   RTM2CVER+186
RTM2SCTL EQU   RTM2CVER+259
RTM2CCTL EQU   RTM2SCTL
RTM2ABDR EQU   RTM2SCTL+4
RTM2ABID EQU   RTM2ABDR
RTM2ABND EQU   RTM2ABDR+1
RTM2RCTL EQU   RTM2SCTL+6
RTM2INTF EQU   RTM2CVER+266
RTM2CTLR EQU   RTM2INTF
RTM2TSKT EQU   RTM2INTF+2
RTM2ABDP EQU   RTM2INTF+4
RTM2ASIR EQU   RTM2INTF+5
RTM2FLX  EQU   RTM2INTF+6
RTM2FLX1 EQU   RTM2FLX
RTM2FLX2 EQU   RTM2FLX+1
RTM2RECL EQU   RTM2CVER+274
RTM2DCTL EQU   RTM2RECL+12
RTM2ECTL EQU   RTM2RECL+13
RTM2TRYR EQU   RTM2RECL+16
RTM2TRF1 EQU   RTM2TRYR
RTM2TRF2 EQU   RTM2TRYR+2
RTM2RECH EQU   RTM2CVER+294
RTM2RRG  EQU   RTM2CVER+314
RTM2CRG  EQU   RTM2CVER+378
RTM2RMIN EQU   RTM2WA+708
RTM2RMPL EQU   RTM2RMIN+4
RTM2RMWA EQU   RTM2RMIN+28
RTM2ERID EQU   RTM2WA+872
RTM2ERAS EQU   RTM2ERID+4
RTM2ENSN EQU   RTM2WA+884
RTM2SNLN EQU   RTM2ENSN
RTM2TRCU EQU   RTM2ENSN+8
RTM2TRFS EQU   RTM2ENSN+12
RTM2TRLS EQU   RTM2ENSN+16
RTM2RYRG EQU   RTM2WA+904
STORAGE  EQU   0
STORFRM  EQU   STORAGE
STORTO   EQU   STORAGE+4
RT1TRACK EQU   0
RT1TRECC EQU   RT1TRACK
RT1TACQR EQU   RT1TRECC+3
RTMBRTAB EQU   0
RTMBTERM EQU   RTMBRTAB
MODEBYTE EQU   0
EED      EQU   0
EEDDES   EQU   EED+4
EEDFLAGS EQU   EEDDES+1
EEDERROR EQU   EED+8
EEDVARBL EQU   EED+12
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SU17BIT  EQU   SUBYTE3
SUBYTE4  EQU   SUBITS+3
SUBYTE5  EQU   SUBITS+4
SU33BIT  EQU   SUBYTE5
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
ACCESS   EQU   0
FORMAT   EQU   0
PRINT    EQU   0
BUFFER   EQU   0
OFFSET   EQU   BUFFER
ADDRESS  EQU   BUFFER+55
DATABYTE EQU   0
DATADWRD EQU   0
DATAHALF EQU   0
DATAWORD EQU   0
ESTAPARM EQU   0
ESTAERR  EQU   ESTAPARM
ERREXP   EQU   ESTAERR
RTYADR   EQU   ESTAPARM+4
RTYREGS  EQU   ESTAPARM+8
LCALREGS EQU   ESTAPARM+72
TITLE    EQU   0
ENDMSG   EQU   0
BITSTR   EQU   0
MSG      EQU   0
MSGARY   EQU   0
CVTPTR   EQU   ADPLCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
RT1W     EQU   FRRSRTMW
RT1WNPRS EQU   RT1W
RT1WPRSV EQU   RT1W+52
RT1WENTR EQU   RT1WPRSV+12
RT1WCOVR EQU   RT1WENTR+2
RT1RTRN  EQU   FRRSRTMW
RT1RTRRG EQU   RT1RTRN+4
EEDREGSP EQU   EEDVARBL
EEDREGS  EQU   EEDREGSP
EEDPSW   EQU   EEDREGSP+64
EEDPSW1  EQU   EEDPSW
EEDPSW2  EQU   EEDPSW+8
EEDINILC EQU   EEDPSW2
EEDDUMPO EQU   EEDVARBL
EEDSCDMP EQU   EEDDUMPO
EEDSDDAT EQU   EEDSCDMP+4
EEDHWREP EQU   EEDVARBL
EEDHMCHS EQU   EEDHWREP+8
EEDHMCHD EQU   EEDHWREP+9
EEDHRSRS EQU   EEDHWREP+12
EEDHRSR1 EQU   EEDHRSRS
EEDHRSR2 EQU   EEDHRSRS+1
EEDERMAP EQU   EEDVARBL
EEDERRID EQU   EEDERMAP+70
START    EQU   ADPLFMT1
RT2BSUS  EQU   ESAUS
RT2SMUS  EQU   ESAUS
SDWAUS   EQU   ESAUS
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
EEDETIME EQU   EEDERRID+6
EEDEASID EQU   EEDERRID+4
EEDECPUI EQU   EEDERRID+2
EEDESEQ# EQU   EEDERRID
@NM00085 EQU   EEDERMAP
EEDHTIME EQU   EEDHWREP+20
EEDHRFSA EQU   EEDHWREP+16
@NM00084 EQU   EEDHWREP+14
EEDHVERQ EQU   EEDHRSR2
EEDHPGFX EQU   EEDHRSR2
EEDHFLSQ EQU   EEDHRSR2
EEDHFSQA EQU   EEDHRSR2
EEDHNUCL EQU   EEDHRSR2
EEDHSPER EQU   EEDHRSR2
EEDHINTC EQU   EEDHRSR2
EEDHOFLN EQU   EEDHRSR2
EEDHCHNG EQU   EEDHRSR1
EEDHMSER EQU   EEDHRSR1
@NM00083 EQU   EEDHRSR1
EEDHCPID EQU   EEDHWREP+10
EEDHTERR EQU   EEDHMCHD
EEDHSOFT EQU   EEDHMCHD
EEDHINSF EQU   EEDHMCHD
EEDHACR  EQU   EEDHMCHD
EEDHSCK  EQU   EEDHMCHD
EEDHPSWU EQU   EEDHMCHD
EEDHREGU EQU   EEDHMCHD
EEDHSKYF EQU   EEDHMCHD
@NM00082 EQU   EEDHMCHS
@NM00081 EQU   EEDHMCHS
EEDHRSRF EQU   EEDHMCHS
EEDRSRC  EQU   EEDHMCHS
EEDINVP  EQU   EEDHMCHS
EEDHTSVL EQU   EEDHMCHS
EEDHRCDF EQU   EEDHMCHS
EEDHSRVL EQU   EEDHMCHS
EEDHSCKE EQU   EEDHWREP+4
EEDHSCKB EQU   EEDHWREP
EEDSDPSL EQU   EEDDUMPO+8
EEDSPDAT EQU   EEDSDDAT+2
EEDSSDAT EQU   EEDSDDAT
EEDSDUMP EQU   EEDSCDMP
EEDTRANS EQU   EEDPSW2+4
EEDINTCD EQU   EEDINILC+2
EEDILC   EQU   EEDINILC+1
@NM00080 EQU   EEDINILC
EEDPSWIC EQU   EEDPSW1+4
EEDPSWMK EQU   EEDPSW1
EEDREG15 EQU   EEDREGS+60
EEDREG14 EQU   EEDREGS+56
EEDREG13 EQU   EEDREGS+52
EEDREG12 EQU   EEDREGS+48
EEDREG11 EQU   EEDREGS+44
EEDREG10 EQU   EEDREGS+40
EEDREG9  EQU   EEDREGS+36
EEDREG8  EQU   EEDREGS+32
EEDREG7  EQU   EEDREGS+28
EEDREG6  EQU   EEDREGS+24
EEDREG5  EQU   EEDREGS+20
EEDREG4  EQU   EEDREGS+16
EEDREG3  EQU   EEDREGS+12
EEDREG2  EQU   EEDREGS+8
EEDREG1  EQU   EEDREGS+4
EEDREG0  EQU   EEDREGS
RT1RTYAD EQU   RT1RTRRG+60
RT1R0R14 EQU   RT1RTRRG
@NM00077 EQU   RT1RTRN
@NM00076 EQU   RT1WENTR+3
@NM00075 EQU   RT1WCOVR
RT1NODMP EQU   RT1WCOVR
RT1WEREX EQU   RT1WCOVR
RT1TRTCA EQU   RT1WCOVR
RT1TLOCL EQU   RT1WCOVR
RT1WRTM  EQU   RT1WCOVR
RT1WCLUP EQU   RT1WCOVR
RT1WSRMD EQU   RT1WENTR+1
RT1WMODE EQU   RT1WENTR
RT1WEED  EQU   RT1WPRSV+8
RT1WSRBR EQU   RT1WPRSV+4
RT1WRTCA EQU   RT1WPRSV
RT1WVARI EQU   RT1WNPRS+32
RT1WPSW2 EQU   RT1WNPRS+28
RT1WPSW1 EQU   RT1WNPRS+24
RT1WLPTA EQU   RT1WNPRS
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00034 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM01067 EQU   ESTAERR
UNEXP2   EQU   ESTAERR
LOCKHELD EQU   ESTAERR
@NM01066 EQU   BUFFER+64
@NM01065 EQU   BUFFER+6
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
@NM00128 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00127 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00126 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00125 EQU   SDWADDAT+3
@NM00124 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00123 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00122 EQU   SDWADUMP+2
@NM00121 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00120 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00119 EQU   SDWAACF3
@NM00118 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00117 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00116 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00115 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
SDWACPUI EQU   SDWA+239
@NM00114 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00113 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00112 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00111 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00110 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00109 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00108 EQU   SDWAINC2
@NM00107 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00106 EQU   SDWAILC2
@NM00105 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00104 EQU   SDWANXT2
@NM00103 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00102 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00101 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00100 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00099 EQU   SDWAINC1
@NM00098 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00097 EQU   SDWAILC1
@NM00096 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00095 EQU   SDWANXT1
@NM00094 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00093 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00092 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00091 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00090 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00089 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00088 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00087 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00086 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
EEDASID  EQU   EEDERROR+2
EEDERTYP EQU   EEDERROR+1
EEDMODE  EQU   EEDERROR
@NM00079 EQU   EEDDES+2
@NM00078 EQU   EEDFLAGS
EEDNODMP EQU   EEDFLAGS
EEDERFL  EQU   EEDFLAGS
EEDID    EQU   EEDDES
EEDFWRDP EQU   EED
MODETCB  EQU   MODEBYTE
MODESRB  EQU   MODEBYTE
MODETYP1 EQU   MODEBYTE
MODELOC  EQU   MODEBYTE
MODEGSUS EQU   MODEBYTE
MODEGSPN EQU   MODEBYTE
MODEDIS  EQU   MODEBYTE
MODESUPR EQU   MODEBYTE
RTMBXABT EQU   RTMBRTAB+44
RTMBACR  EQU   RTMBRTAB+40
RTMBPROG EQU   RTMBRTAB+36
RTMBMEMT EQU   RTMBRTAB+32
RTMBCABT EQU   RTMBRTAB+28
RTMBPGIO EQU   RTMBRTAB+24
RTMBSVC  EQU   RTMBRTAB+20
RTMBMACH EQU   RTMBRTAB+16
RTMBREST EQU   RTMBRTAB+12
RTMBDAT  EQU   RTMBRTAB+8
RTMBPAD2 EQU   RTMBTERM+6
RTMBBRAN EQU   RTMBTERM+2
RTMBBALR EQU   RTMBTERM
RT1TREGS EQU   RT1TRACK+4
RT1TRETY EQU   RT1TACQR
RT1TLLCK EQU   RT1TACQR
RT1TDISP EQU   RT1TACQR
RT1TENPT EQU   RT1TRECC+2
RT1TLPID EQU   RT1TRECC+1
RT1TLPN  EQU   RT1TRECC
STORBTO  EQU   STORTO
STORB    EQU   STORFRM
RTM2TECB EQU   RTM2RYRG+64
RTM2RYRS EQU   RTM2RYRG
RTM2TRTB EQU   RTM2ENSN+4
@NM00074 EQU   RTM2SNLN+2
RTM2TRLN EQU   RTM2SNLN
@NM00073 EQU   RTM2WA+882
RTM2ERTM EQU   RTM2ERID+6
RTM2CPUI EQU   RTM2ERID+2
RTM2SEQ# EQU   RTM2ERID
RTM2RMSA EQU   RTM2RMIN+92
RTM2RMWS EQU   RTM2RMWA
RTM2RMPS EQU   RTM2RMIN
RTM2TRSA EQU   RTM2CVER+450
RTM2CREG EQU   RTM2CRG
RTM2RREG EQU   RTM2RRG
RTM2RBRG EQU   RTM2CVER+313
RTM2WARG EQU   RTM2CVER+312
@NM00072 EQU   RTM2CVER+310
RTM2CTRA EQU   RTM2RECH+12
RTM2STRA EQU   RTM2RECH+8
RTM2SKRA EQU   RTM2RECH+4
RTM2TRRA EQU   RTM2RECH
@NM00071 EQU   RTM2TRYR+3
@NM00070 EQU   RTM2TRF2
RTM2TREC EQU   RTM2TRF2
RTM2GMR  EQU   RTM2TRF2
RTM2PPR  EQU   RTM2TRF2
RTM2IOR  EQU   RTM2TRF2
RTM2AS3R EQU   RTM2TRF1+1
RTM2AS2R EQU   RTM2TRF1+1
RTM2AS1R EQU   RTM2TRF1+1
RTM2XFLG EQU   RTM2TRF1+1
RTM2XABD EQU   RTM2TRF1+1
RTM2XIP  EQU   RTM2TRF1+1
RTM2RTYS EQU   RTM2TRF1+1
RTM2RCD  EQU   RTM2TRF1+1
RTM2FMS  EQU   RTM2TRF1
RTM2VLDY EQU   RTM2TRF1
RTM2HOOK EQU   RTM2TRF1
RTM2PPS  EQU   RTM2TRF1
RTM2GMS  EQU   RTM2TRF1
RTM2IORS EQU   RTM2TRF1
RTM2IOHS EQU   RTM2TRF1
RTM2IOQS EQU   RTM2TRF1
RTM2TMER EQU   RTM2RECL+14
RTM2EQMN EQU   RTM2ECTL
RTM2EDEQ EQU   RTM2ECTL
RTM2EFRM EQU   RTM2ECTL
RTM2ECLS EQU   RTM2ECTL
RTM2ESNP EQU   RTM2ECTL
RTM2EOPN EQU   RTM2ECTL
RTM2EGET EQU   RTM2ECTL
RTM2EENQ EQU   RTM2ECTL
RTM2DFTK EQU   RTM2DCTL
RTM2DDEQ EQU   RTM2DCTL
RTM2DFRM EQU   RTM2DCTL
RTM2DCLS EQU   RTM2DCTL
RTM2DSNP EQU   RTM2DCTL
RTM2DOPN EQU   RTM2DCTL
RTM2DGET EQU   RTM2DCTL
RTM2DENQ EQU   RTM2DCTL
RTM2SCTX EQU   RTM2RECL+8
RTM2SCTR EQU   RTM2RECL+4
RTM2SCTC EQU   RTM2RECL
@NM00069 EQU   RTM2FLX2
RTM2CERX EQU   RTM2FLX2
RTM2RCRX EQU   RTM2FLX2
RTM2RTRX EQU   RTM2FLX1
RTM2LTX  EQU   RTM2FLX1
RTM2PRX  EQU   RTM2FLX1
RTM2CVX  EQU   RTM2FLX1
RTM2DWX  EQU   RTM2FLX1
RTM2ABX  EQU   RTM2FLX1
RTM2EOTX EQU   RTM2FLX1
RTM2MTX  EQU   RTM2FLX1
@NM00068 EQU   RTM2ASIR
RTM2UPRG EQU   RTM2ASIR
RTM2TRME EQU   RTM2ASIR
@NM00067 EQU   RTM2ABDP
RTM2SMDP EQU   RTM2ABDP
RTM2DMP1 EQU   RTM2ABDP
RTM2MEMT EQU   RTM2INTF+3
@NM00066 EQU   RTM2TSKT
RTM2PURG EQU   RTM2TSKT
@NM00065 EQU   RTM2INTF+1
@NM00064 EQU   RTM2CTLR
RTM2WRAP EQU   RTM2CTLR
RTM2TMEM EQU   RTM2CTLR
RTM2RETR EQU   RTM2CTLR
RTM2RECR EQU   RTM2CTLR
@NM00063 EQU   RTM2RCTL
RTM2JPAQ EQU   RTM2RCTL
RTM2LPAQ EQU   RTM2RCTL
RTM2BFTL EQU   RTM2RCTL
RTM2TRSW EQU   RTM2RCTL
RTM2WANA EQU   RTM2RCTL
RTM2WAIN EQU   RTM2RCTL
RTM2STA2 EQU   RTM2RCTL
RTM2STAT EQU   RTM2ABND
RTM2NDMP EQU   RTM2ABND
@NM00062 EQU   RTM2ABID
RTM2OERR EQU   RTM2ABID
RTM2SAV2 EQU   RTM2ABID
RTM2SAVE EQU   RTM2ABID
RTM2REG  EQU   RTM2ABID
RTM2PSW  EQU   RTM2ABID
RTM2ENQ  EQU   RTM2ABID
RTM2CB   EQU   RTM2ABID
RTM2MCTL EQU   RTM2SCTL+3
RTM2TCTL EQU   RTM2SCTL+2
@NM00061 EQU   RTM2CCTL+1
RTM2NODP EQU   RTM2CCTL+1
RTM2RGEB EQU   RTM2CCTL+1
RTM2DEND EQU   RTM2CCTL+1
RTM2RSCN EQU   RTM2CCTL+1
RTM2CONT EQU   RTM2CCTL
RTM2SLIP EQU   RTM2CCTL
RTM2HEED EQU   RTM2CCTL
RTM2REED EQU   RTM2CCTL
RTM2ISPC EQU   RTM2CCTL
RTM2SQS  EQU   RTM2CCTL
RTM2CNCL EQU   RTM2CCTL
RTM2STPT EQU   RTM2CCTL
RTM2PKEY EQU   RTM2CVER+258
RTM2SFSA EQU   RTM2SFRG
RTM2SPWA EQU   RTM2CVER+174
RTM2DCBA EQU   RTM2CVER+170
RTM2ECBS EQU   RTM2SECB+16
RTM2LECB EQU   RTM2ECBA
RTM2DTCB EQU   RTM2SNAP+68
RTM2SNCC EQU   RTM2SNAP+64
RTM2DD   EQU   RTM2SNAP+56
RTM2LTO4 EQU   RTM2TO4
RTM2LFR4 EQU   RTM2FRM4
RTM2LTO3 EQU   RTM2TO3
RTM2LFR3 EQU   RTM2FRM3
RTM2LTO2 EQU   RTM2TO2
RTM2LFR2 EQU   RTM2FRM2
RTM2LTO1 EQU   RTM2TO1
RTM2LFR1 EQU   RTM2FRM1
RTM2DPLA EQU   RTM2SNAP
RTM2NXTP EQU   RTM2CTL2+5
RTM2SGP  EQU   RTM2PMKP
RTM2EUP  EQU   RTM2PMKP
RTM2DOP  EQU   RTM2PMKP
RTM2FPP  EQU   RTM2PMKP
RTM2CCP  EQU   RTM2PMKP
RTM2ILP  EQU   RTM2PMKP
RTM2INTP EQU   RTM2CTL2+2
RTM2SPVP EQU   RTM2MWPP
RTM2WATP EQU   RTM2MWPP
RTM2MCKP EQU   RTM2MWPP
@NM00060 EQU   RTM2MWPP
RTM2KEYP EQU   RTM2MWPP
RTM2EXTP EQU   RTM2CMKP
RTM2IOP  EQU   RTM2CMKP
RTM2NXTA EQU   RTM2CTL1+5
RTM2SGA  EQU   RTM2PMKA
RTM2EUA  EQU   RTM2PMKA
RTM2DOA  EQU   RTM2PMKA
RTM2FPA  EQU   RTM2PMKA
RTM2CCA  EQU   RTM2PMKA
RTM2ILA  EQU   RTM2PMKA
RTM2INTA EQU   RTM2CTL1+2
RTM2SPVA EQU   RTM2MWPA
RTM2WATA EQU   RTM2MWPA
RTM2MCKA EQU   RTM2MWPA
@NM00059 EQU   RTM2MWPA
RTM2KEYA EQU   RTM2MWPA
RTM2EXTA EQU   RTM2CMKA
RTM2IOA  EQU   RTM2CMKA
@NM00058 EQU   RTM2PARQ+1
RTM2SIZE EQU   RTM2SPLL+1
RTM2SUBP EQU   RTM2SPLL
RTM2SCBO EQU   RTM2SCBS+8
RTM2SCBN EQU   RTM2SCBS+4
RTM2SCBC EQU   RTM2SCBS
RTM2STAR EQU   RTM2TRRC+10
RTM2RBST EQU   RTM2TRRC+6
RTM2FIOB EQU   RTM2IOBP+1
@NM00057 EQU   RTM2IOBP
@NM00056 EQU   RTM2TRRC+1
@NM00055 EQU   RTM2IOFS
RTM2NIOP EQU   RTM2IOFS
RTM2NOIO EQU   RTM2IOFS
RTM2IOHT EQU   RTM2IOFS
RTM2IOQR EQU   RTM2IOFS
RTM2ERFL EQU   RTM2ERRD
RTM2MCIV EQU   RTM2ERRD
RTM2RPIV EQU   RTM2ERRD
RTM2MABD EQU   RTM2ERRD
RTM2CTS  EQU   RTM2ERRD
RTM2STAE EQU   RTM2ERRD
RTM2NRBE EQU   RTM2ERRD
RTM2CLUP EQU   RTM2ERRD
@NM00054 EQU   RTM2ERRC
RTM2EAS  EQU   RTM2ERRC
RTM2PERC EQU   RTM2ERRC
RTM2IRB  EQU   RTM2ERRC
RTM2STAI EQU   RTM2ERRC
RTM2STAF EQU   RTM2ERRC
RTM2SRBM EQU   RTM2ERRB
RTM2LDIS EQU   RTM2ERRB
RTM2ENRB EQU   RTM2ERRB
RTM2TYP1 EQU   RTM2ERRB
@NM00053 EQU   RTM2ERRB
RTM2PGIO EQU   RTM2ERRA
RTM2TEXC EQU   RTM2ERRA
RTM2SVCE EQU   RTM2ERRA
RTM2ABTM EQU   RTM2ERRA
RTM2SVCD EQU   RTM2ERRA
RTM2RKEY EQU   RTM2ERRA
RTM2PCHK EQU   RTM2ERRA
RTM2MCHK EQU   RTM2ERRA
RTM2TIME EQU   RTM2EEDH+20
RTM2RFSA EQU   RTM2EEDH+16
@NM00052 EQU   RTM2EEDH+14
RTM2VEQR EQU   RTM2RSR2
RTM2PGFX EQU   RTM2RSR2
RTM2FLSQ EQU   RTM2RSR2
RTM2FSQA EQU   RTM2RSR2
RTM2NUCL EQU   RTM2RSR2
RTM2SPER EQU   RTM2RSR2
RTM2INTC EQU   RTM2RSR2
RTM2OFLN EQU   RTM2RSR2
RTM2CHNG EQU   RTM2RSR1
RTM2MSER EQU   RTM2RSR1
@NM00051 EQU   RTM2RSR1
RTM2CPID EQU   RTM2EEDH+10
RTM2TERR EQU   RTM2MCHD
RTM2SOFT EQU   RTM2MCHD
RTM2INSF EQU   RTM2MCHD
RTM2ACR  EQU   RTM2MCHD
RTM2SCK  EQU   RTM2MCHD
RTM2PSWU EQU   RTM2MCHD
RTM2REGU EQU   RTM2MCHD
RTM2SKYF EQU   RTM2MCHD
@NM00050 EQU   RTM2MCHS
RTM2RSRF EQU   RTM2MCHS
RTM2RSRC EQU   RTM2MCHS
RTM2INVP EQU   RTM2MCHS
RTM2TSVL EQU   RTM2MCHS
RTM2RCDF EQU   RTM2MCHS
RTM2SRVL EQU   RTM2MCHS
RTM2SCKE EQU   RTM2STCK+4
RTM2SCKB EQU   RTM2STCK
RTM2TRAN EQU   RTM2AEC1+4
RTM2IPC1 EQU   RTM2ICD1
RTM2IMC1 EQU   RTM2ICD1
RTM2IPR1 EQU   RTM2ICD1
@NM00049 EQU   RTM2INC1
@NM00048 EQU   RTM2ILC1
RTM2IL1  EQU   RTM2ILC1
@NM00047 EQU   RTM2ILC1
@NM00046 EQU   RTM2AEC1
RTM2ADD1 EQU   RTM2NXT1+1
@NM00045 EQU   RTM2NXT1
@NM00044 EQU   RTM2EPSW+3
RTM2SGN1 EQU   RTM2INT1
RTM2EXP1 EQU   RTM2INT1
RTM2DEC1 EQU   RTM2INT1
RTM2FPO1 EQU   RTM2INT1
RTM2CC1  EQU   RTM2INT1
@NM00043 EQU   RTM2INT1
RTM2PGM1 EQU   RTM2MWP1
RTM2WAT1 EQU   RTM2MWP1
RTM2MCK1 EQU   RTM2MWP1
RTM2ECT1 EQU   RTM2MWP1
RTM2KEY1 EQU   RTM2MWP1
RTM2EXT1 EQU   RTM2EMK1
RTM2AIO1 EQU   RTM2EMK1
RTM2TRM1 EQU   RTM2EMK1
RTM2EAM1 EQU   RTM2EMK1
@NM00042 EQU   RTM2EMK1
RTM2PER1 EQU   RTM2EMK1
@NM00041 EQU   RTM2EMK1
RTM2ER15 EQU   RTM2EREG+60
RTM2ER14 EQU   RTM2EREG+56
RTM2ER13 EQU   RTM2EREG+52
RTM2ER12 EQU   RTM2EREG+48
RTM2ER11 EQU   RTM2EREG+44
RTM2ER10 EQU   RTM2EREG+40
RTM2ER9  EQU   RTM2EREG+36
RTM2ER8  EQU   RTM2EREG+32
RTM2ER7  EQU   RTM2EREG+28
RTM2ER6  EQU   RTM2EREG+24
RTM2ER5  EQU   RTM2EREG+20
RTM2ER4  EQU   RTM2EREG+16
RTM2ER3  EQU   RTM2EREG+12
RTM2ER2  EQU   RTM2EREG+8
RTM2ER1  EQU   RTM2EREG+4
RTM2ER0  EQU   RTM2EREG
RTM2VRBT EQU   RTM2WA+52
RTM2TCBT EQU   RTM2WA+48
RTM2SFWA EQU   RTM2WA+32
RTM2CC   EQU   RTM2CODE+1
@NM00040 EQU   RTM2CCF
RTM2EOT  EQU   RTM2CCF
RTM2EOM  EQU   RTM2CCF
RTM2R0DP EQU   RTM2CCF
RTM2STEP EQU   RTM2CCF
RTM2DREQ EQU   RTM2CCF
RTM2ASC  EQU   RTM2WA+24
RTM2TCBC EQU   RTM2WA+16
RTM2LGTH EQU   RTM2RT2D+1
RTM2SPID EQU   RTM2RT2D
RTM2ADDR EQU   RTM2DESC+4
RTM2ID   EQU   RTM2DESC
RMPLDCBL EQU   RMPL+20
RMPLRMWA EQU   RMPL+16
RMPLRBPA EQU   RMPL+12
RMPLTCBA EQU   RMPL+8
RMPLASCB EQU   RMPL+4
RMPLASID EQU   RMPL+2
RMPLFLG2 EQU   RMPL+1
@NM00039 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLIPUF EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
RMPLTERM EQU   RMPLFLG1
RMPLTYPE EQU   RMPLFLG1
SNPHDRA  EQU   SNPPARMS+20
SNPSTOR  EQU   SNPPARMS+16
SNPTCBA  EQU   SNPPARMS+12
SNPDCB   EQU   SNPPARMS+8
@NM00038 EQU   SNPPARMS+7
@NM00037 EQU   SNPPDATA
SNPSPLS  EQU   SNPPDATA
SNPPSW   EQU   SNPPDATA
SNPJPA   EQU   SNPPDATA
SNPLPA   EQU   SNPPDATA
SNPREGS  EQU   SNPPDATA
SNPSAVE2 EQU   SNPPDATA
SNPSAVE  EQU   SNPPDATA
@NM00036 EQU   SNPSDAT1
SNPERR   EQU   SNPSDAT1
SNPIO    EQU   SNPSDAT1
SNPDM    EQU   SNPSDAT0
SNPQCB   EQU   SNPSDAT0
SNPCB    EQU   SNPSDAT0
SNPTRT   EQU   SNPSDAT0
SNPSWA   EQU   SNPSDAT0
SNPLSQA  EQU   SNPSDAT0
SNPSQA   EQU   SNPSDAT0
SNPNUC   EQU   SNPSDAT0
@NM00035 EQU   SNPPARMS+2
SNPHDR   EQU   SNPFLAG
SNPSLIST EQU   SNPFLAG
SNPTCB   EQU   SNPFLAG
SNPID    EQU   SNPFLAG
SNPABEND EQU   SNPFLAG
SNPVS2EN EQU   SNPFLAG
SNPVS2   EQU   SNPFLAG
SNPSNAP  EQU   SNPFLAG
SNPIDENT EQU   SNPPARMS
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00033+8
PRBEND   EQU   @NM00033+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00033+6
RBRSV136 EQU   @NM00033+4
RBRSV135 EQU   @NM00033
@NM00032 EQU   RBSECT+32
@NM00031 EQU   @NM00029+1
RBSCF    EQU   @NM00030
RBPGMQ1  EQU   RBPGMQ+1
@NM00028 EQU   RBPGMQ
@NM00027 EQU   RBSECT+16
@NM00026 EQU   @NM00022
@NM00025 EQU   @NM00022
RBIQETP  EQU   @NM00022
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00022
@NM00024 EQU   @NM00022
@NM00023 EQU   @NM00022
RBPMSVRB EQU   @NM00020
RBATNXIT EQU   @NM00020
@NM00021 EQU   @NM00020
RBWAITP  EQU   @NM00020
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00020
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00018 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00017 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00016 EQU   RBOPSWB2
@NM00015 EQU   XRBPSW
@NM00014 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00013 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00012 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00011 EQU   XSTAB1
@NM00010 EQU   RBBASIC+8
@NM00009 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00008 EQU   RBPRFX
ESACC    EQU   ESACMP+1
@NM00007 EQU   ESACCF
ESAASID  EQU   ESACCF
ESANOCC  EQU   ESACCF
ESAR0DP  EQU   ESACCF
ESASTEP  EQU   ESACCF
ESADREQ  EQU   ESACCF
@NM00006 EQU   ESARFLAG
ESASLIPR EQU   ESARFLAG
ESARTCR  EQU   ESARFLAG
ESAFERR  EQU   ESARFLAG
ESAGLREC EQU   ESARFLAG
ESAINREC EQU   ESARFLAG
ESASDREC EQU   ESARFLAG
ESAGMREC EQU   ESARFLAG
@NM00005 EQU   ESAFLAGS
ESAVEOM  EQU   ESAFLAGS
ESAEOT   EQU   ESAFLAGS
ESANEOT  EQU   ESAFLAGS
ESACTS   EQU   ESAFLAGS
ESAPGNLY EQU   ESAFLAGS
ESAABTRM EQU   ESAFLAGS
ESARTM2  EQU   ESAFLAGS
ESAWLEN  EQU   ESART2D+1
ESAWSPID EQU   ESART2D
ESART2WA EQU   RTM2ESA+32
ESAEEDQ  EQU   RTM2ESA+28
ESAR14   EQU   ESAREGS+24
ESAR7    EQU   ESAREGS+20
ESAR5    EQU   ESAREGS+16
ESAR4    EQU   ESAREGS+12
ESAR3    EQU   ESAREGS+8
ESACC1   EQU   ESAR1+1
@NM00004 EQU   ESACCF1
ESAEOT1  EQU   ESACCF1
ESAEOM1  EQU   ESACCF1
ESAR0DP1 EQU   ESACCF1
ESASTEP1 EQU   ESACCF1
ESADREQ1 EQU   ESACCF1
ESAR0    EQU   ESAREGS
CVTLEVL  EQU   CVTRELNO+2
CVTMDL   EQU   CVTFIX+250
@NM00003 EQU   CVTFIX+248
@NM00002 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ADPLABDA EQU   ABDPL+56
ADPLEXT  EQU   ABDPL+52
ADPLCOM4 EQU   ABDPL+40
ADPLCOM3 EQU   ABDPL+36
@NM00001 EQU   ADPLFLAG
ADPLDMGT EQU   ADPLFLAG
ADPLSYTM EQU   ADPLFLAG
ADPLSBPL EQU   ABDPL+6
ADPLASID EQU   ABDPL+4
ADPLTCB  EQU   ABDPL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00204 EQU   @RC00200
@RC00210 EQU   @RC00200
@RC00308 EQU   @RC00298
@RC00500 EQU   @RC00498
@RC00688 EQU   @EL00007
@RC00695 EQU   @EL00007
@RC00693 EQU   @EL00007
@RC00214 EQU   @RC00210
@RC00313 EQU   @RC00308
@ENDDATA EQU   *
         END   IEAFTRT2,(C'PLS1147',0701,77091)
