         TITLE 'IEAVAMSI -- VIO SERVICES INTERFACE (ASSIGN/MOVE-OUT)   *
                        '
IEAVAMSI CSECT
         USING *,15
         MODID
        L     R15,PSAAOLD(,R0)      ADDRESS OF ASCB
        L     R15,ASCBASXB(,R15)   ADDRESS OF ASXB
        L     R15,ASXBSPSA(,R15)   ADDRESS OF WSAVT
        L     R15,WSALRSM(,R15)    ADDRESS OF SAVE AREA
        STM   R0,R14,0(R15)        STORE CALLERS REGS
        BALR  R9,R0                ESTABLISH ADDRESSABILITY
        USING *,R9
*   PVTPTR=CVTPVTP;                 /* LOAD THE PVT ADDRESS          */
         L     @14,CVTPTR                                          0112
         L     PVTPTR,CVTPVTP(,@14)                                0112
*   R4=R15;                         /* HOLD SAVEAREA POINTER ACROSS
*                                      MACROS                        */
*                                                                  0113
         LR    R4,R15                                              0113
*   /*****************************************************************/
*   /*                                                               */
*   /* LOAD FRR STACK                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0114
*   FADDR=PVTPRCV;                  /* LOAD THE RECOVERY ADDRESS     */
         L     FADDR,PVTPRCV(,PVTPTR)                              0114
*   GENERATE REFS(FADDR) SETS(FADDR,WRK1R,WRK2R);                  0115
SETSTK SETFRR A,FRRAD=(FADDR),PARMAD=(FADDR),WRKREGS=(WRK1R,WRK2R),   **
               RELATED=(RSM,IEAVAMSI(RELSTK))
*   FADDR->RCAVAMSI='1'B;           /* SET ENTRY POINT FLAG          */
         OI    RCAVAMSI(FADDR),B'10000000'                         0116
*   FADDR->RCACSECT=RCACVAM;        /* SET MODULE ID                 */
*                                                                  0117
         MVI   RCACSECT(FADDR),X'18'                               0117
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN SALLOC                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0118
*   GENERATE SETS(R11,R12,LOCKRCR,R14);                            0118
SETSLK SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                        **
               RELATED=(RSM,IEAVAMSI(RELSLK))
*   FADDR->RCASAL='1'B;             /* SET THE LOCK HELD FLAG        */
         OI    RCASAL(FADDR),B'10000000'                           0119
*   PVTPRCA=FADDR;                  /* STORE THE RSMRCA POINTER      */
         ST    FADDR,PVTPRCA(,PVTPTR)                              0120
*   RSTADDWD=R4;                    /* SET UP AS SAVE AREA POINTER   */
         ST    R4,RSTADDWD(,PVTPTR)                                0121
*   RFY                                                            0122
*     REGSAVER BASED(RSTADDWD);                                    0122
*   REG15WD=0;                      /* INITIALIZE REG15 SAVE AREA    */
         SLR   @14,@14                                             0123
         L     @11,RSTADDWD(,PVTPTR)                               0123
         ST    @14,REG15WD(,@11)                                   0123
*   VAMAIAQ=0;                      /* INITIALIZE AIA QUEUE HEADER   */
         ST    @14,VAMAIAQ(,PVTPTR)                                0124
*   VCBPTR=INVCBR;                  /* LOAD THE VCB POINTER          */
         LR    VCBPTR,INVCBR                                       0125
*   RSMHDPTR=ASCBRSM;               /* LOAD THE RSM HEADER PTR FOR 0126
*                                      PROCESSING                    */
         L     @14,ASCBPTR                                         0126
         L     RSMHDPTR,ASCBRSM(,@14)                              0126
*   RFY                                                            0127
*    (FADDR,                                                       0127
*     WRK1R,                                                       0127
*     WRK2R,                                                       0127
*     INVCBR) UNRSTD;                                              0127
*                                                                  0128
*   /*****************************************************************/
*   /*                                                               */
*   /* LOOPVCB -- THIS IS THE VIO PROCESSOR LOOP AND SUB-ROUTINE     */
*   /* CONTROL CODE. THE LOOP WILL BE BROKEN AS SOON AS THE LAST VCB */
*   /* HAS BEEN PROCESSED, OR AN ERROR IS ENCOUNTERED. TESTS ARE MADE*/
*   /* TO INSURE THAT THE ENTIRE VCB IS IN REAL STORAGE. THE ASSIGN  */
*   /* OR MOVEOUT ROUTINES ARE CALLED AS APPLICABLE, AND IF NEITHER  */
*   /* ASSIGN NOR MOVEOUT WAS REQUESTED, AN ERROR IS DETECTED. ALSO, */
*   /* IF EITHER OF THE SUB-ROUTINES RETURNS A CODE OF NON-ZERO, AN  */
*   /* ERROR IS SIGNALED. A CALL IS MADE TO THE I/O REQUEST (IOREQ)  */
*   /* SUB-ROUTINE PRIOR TO PROCESSING A VCB WITH THE ASSIGN FLAG SET*/
*   /* IF THERE ARE AIA'S QUEUED FOR PAGE-OUTS, AND AFTER ALL VCB'S  */
*   /* ARE PROCESSED IF THERE ARE AIA'S QUEUED FOR PAGE-OUTS.        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0128
*LOOPVCB:                                                          0128
*   DO WHILE VCBPTR^=0;             /* LOOP HERE TO PROCESS ALL VCBS */
*                                                                  0128
LOOPVCB  B     @DE00128                                            0128
@DL00128 DS    0H                                                  0129
*     /***************************************************************/
*     /*                                                             */
*     /* INSURE THAT VCB IS IN STORAGE                               */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0129
*     RFY                                                          0129
*      (TESTPTR) RSTD;                                             0129
*     GENERATE REFS(VCBPTR) SETS(TESTPTR);                         0130
      LRA   TESTPTR,0(VCBPTR)      CHECK VALIDITY OF VCB
*     BC(7,ERRSET);                 /* TRANSLATION NOT AVAILABLE, OR
*                                      INVALID                       */
         BC    7,ERRSET                                            0131
*     GENERATE REFS(VCBPTR) SETS(TESTPTR);                         0132
      LRA   TESTPTR,VCBDSPID+3-VCB(VCBPTR)  CHECK LAST BYTE OF VCB
*     BC(8,NOERR);                  /* TRANSLATION OK                */
         BC    8,NOERR                                             0133
*     RFY                                                          0134
*      (TESTPTR) UNRSTD;                                           0134
*ERRSET:                                                           0135
*     REG15WD=8;                    /* VCB IS NOT VALID IN STORAGE   */
ERRSET   L     @14,RSTADDWD(,PVTPTR)                               0135
         MVC   REG15WD(4,@14),@CF00059                             0135
*     REG2WD=VCBPTR;                /* LOAD PARM FOR RETURN          */
         ST    VCBPTR,REG2WD(,@14)                                 0136
*     GOTO ASMCK;                   /* TO SEE IF ANY AIA'S ARE QUEUED*/
         B     ASMCK                                               0137
*                                                                  0138
*     /***************************************************************/
*     /*                                                             */
*     /* CHECK FOR ASSIGN FLAG IN VCB                                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0138
*NOERR:                                                            0138
*     CURVSNR=CURVSN;               /* LOAD CURRENT VSN INTO A REG   */
NOERR    SLR   CURVSNR,CURVSNR                                     0138
         ICM   CURVSNR,3,CURVSN(VCBPTR)                            0138
*     IF VCBASIGN='1'B THEN         /* IF THIS IS AN ASSIGN REQUEST  */
         TM    VCBASIGN(VCBPTR),B'00100000'                        0139
         BNO   @RF00139                                            0139
*       DO;                                                        0140
*         IF VAMAIAQ^=0 THEN        /* IF THERE ARE AIA'S TO PROCESS */
*                                                                  0141
         L     @14,VAMAIAQ(,PVTPTR)                                0141
         LTR   @14,@14                                             0141
         BZ    @RF00141                                            0141
*           /*********************************************************/
*           /*                                                       */
*           /* CALL FOR PAGEOUT OF VCB GROUP                         */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0142
*           DO;                                                    0142
*             CALL IOREQ;           /* CALL I/O SUB-PROC             */
         BAL   @14,IOREQ                                           0143
*             IF REG15WD^=0 THEN    /* IF ANY I/O FAILED             */
         L     @14,RSTADDWD(,PVTPTR)                               0144
         L     @14,REG15WD(,@14)                                   0144
         LTR   @14,@14                                             0144
         BNZ   @RT00144                                            0144
*               GOTO EXIT;          /* CAN'T CONTINUE                */
*           END;                                                   0146
*         CALL ASSIGN;              /* CALL ASSIGN SUB-PROC          */
@RF00141 BAL   @14,ASSIGN                                          0147
*       END;                                                       0148
*     ELSE                          /* IF ASSIGN FLAG NOT SET        */
*                                                                  0149
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK FOR MOVEOUT FLAG IN VCB                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0149
*       IF VCBMVOUT='1'B THEN       /* IF THIS IS A MOVE REQUEST     */
         B     @RC00139                                            0149
@RF00139 TM    VCBMVOUT(VCBPTR),B'10000000'                        0149
         BNO   @RF00149                                            0149
*         CALL MOVEOUT;             /* CALL MOVEOUT SUB-PROC         */
         BAL   @14,MOVEOUT                                         0150
*       ELSE                        /* IF NEITHER ASSIGN NOR MOVEOUT
*                                      FLAGS SET                     */
*                                                                  0151
*         /***********************************************************/
*         /*                                                         */
*         /* ERROR -- NO VALID REQUEST IN VCB                        */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0151
*         DO;                                                      0151
         B     @RC00149                                            0151
@RF00149 DS    0H                                                  0152
*           REG15WD=12;             /* NO VALID REQUEST IN VCB       */
         L     @14,RSTADDWD(,PVTPTR)                               0152
         MVC   REG15WD(4,@14),@CF02086                             0152
*           REG2WD=VCBPTR;          /* LOAD PARM FOR RETURN          */
         ST    VCBPTR,REG2WD(,@14)                                 0153
*           GOTO ASMCK;             /* CAN'T CONTINUE                */
         B     ASMCK                                               0154
*         END;                                                     0155
*                                                                  0156
*     /***************************************************************/
*     /*                                                             */
*     /* CHECK RETURN CODE FROM ASSIGN, MOVEOUT, AND OUTOFSTG        */
*     /* SUB-ROUTINES                                                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0156
*     IF RETCODR^=0 THEN            /* IF THE RETURN CODE IS BAD     */
@RC00149 DS    0H                                                  0156
@RC00139 LTR   RETCODR,RETCODR                                     0156
         BZ    @RF00156                                            0156
*       DO;                                                        0157
*         REG15WD=RETCODR;          /* LOAD RETURN CODE AS SET BY  0158
*                                      SUB-PROC                      */
         L     @14,RSTADDWD(,PVTPTR)                               0158
         ST    RETCODR,REG15WD(,@14)                               0158
*         REG2WD=VCBPTR;            /* LOAD THE ERROR PARAMETER      */
*                                                                  0159
         ST    VCBPTR,REG2WD(,@14)                                 0159
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK FOR ABEND SITUATION                               */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0160
*         IF RETCODR=16 THEN        /* IF THIS IS AN ABEND SITUATION */
         C     RETCODR,@CF00713                                    0160
         BNE   @RF00160                                            0160
*           DO;                                                    0161
*             RFY                                                  0162
*              (R0,                                                0162
*               R1,                                                0162
*               PCBPTR,                                            0162
*               PFTEPTR) RSTD;                                     0162
*                                                                  0162
*             /*******************************************************/
*             /*                                                     */
*             /* THE IOREQ SUBROUTINE WILL RETURN TO THIS POINT IF IT*/
*             /* CANNOT LOCATE THE PROPER VCB FOR BACKOUT AFTER AN   */
*             /* ASM ERROR.                                          */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0163
*RC16ADJ:                                                          0163
*             DO WHILE VAMAIAQ^=0;  /* PROCESS EACH AIA ON QUEUE     */
RC16ADJ  B     @DE00163                                            0163
@DL00163 DS    0H                                                  0164
*               PCBPTR=VAMAIAQ-LENGTH(PCB)+LENGTH(PCBAIA);/* LOAD THE
*                                      PCB POINTER WITH ADJUSTED   0164
*                                      VALUE                         */
         L     PCBPTR,@CF02275                                     0164
         AL    PCBPTR,VAMAIAQ(,PVTPTR)                             0164
*               PVTVAMO=PVTVAMO-1;  /* DECREMENT THE VIO OUT COUNT   */
         L     @14,PVTVAMO(,PVTPTR)                                0165
         BCTR  @14,0                                               0165
         ST    @14,PVTVAMO(,PVTPTR)                                0165
*               OUXBVAMO=OUXBVAMO-1;/* DECREMENT THE LOCAL COUNT     */
         L     @14,ASCBPTR                                         0166
         L     @14,OUXBPTR(,@14)                                   0166
         L     @12,OUXBVAMO(,@14)                                  0166
         BCTR  @12,0                                               0166
         ST    @12,OUXBVAMO(,@14)                                  0166
*               PFTEPTR=PVTPFTP+PCBRBN;/* LOAD THE PFTE POINTER      */
         LH    PFTEPTR,PCBRBN(,PCBPTR)                             0167
         N     PFTEPTR,@CF02294                                    0167
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0167
*               PFTPCBSI='0'B;      /* RESET THE PCB DEFINED FLAG    */
         NI    PFTPCBSI(PFTEPTR),B'11110111'                       0168
*               VAMAIAQ=AIANXAIA;   /* GET NEXT AIA ON CHAIN         */
         L     @14,AIANXAIA(,PCBPTR)                               0169
         ST    @14,VAMAIAQ(,PVTPTR)                                0169
*               R0=PCBFREQN;        /* SEND PCB TO FREE QUEUE        */
         LA    R0,16                                               0170
*               R1=PCBPTR;          /* PARM FOR PCB MANAGER          */
         LR    R1,PCBPTR                                           0171
*               CALL IEAVPCB;       /* CALL PCB MANAGER TO MOVE PCB  */
         L     @15,PVTPCB(,PVTPTR)                                 0172
         BALR  @14,@15                                             0172
*             END;                                                 0173
@DE00163 L     @14,VAMAIAQ(,PVTPTR)                                0173
         LTR   @14,@14                                             0173
         BNZ   @DL00163                                            0173
*             GOTO EXIT;            /* CAN'T CONTINUE, WILL ABEND    */
         B     EXIT                                                0174
*             RFY                                                  0175
*              (R0,                                                0175
*               R1,                                                0175
*               PCBPTR,                                            0175
*               PFTEPTR) UNRSTD;                                   0175
*           END;                                                   0176
*         GOTO ASMCK;               /* CAN'T CONTINUE, WILL RETURN   */
         B     ASMCK                                               0177
*       END;                                                       0178
*     LASTVCB=VCBPTR;               /* SAVE POINTER IN CASE IOREQ  0179
*                                      DETECTS AN ERROR              */
@RF00156 ST    VCBPTR,LASTVCB(,PVTPTR)                             0179
*     VCBPTR=VCBLINK;               /* PICK UP NEXT VCB ADDRESS      */
         L     VCBPTR,VCBLINK(,VCBPTR)                             0180
*   END;                            /* LOOP TO PROCESS NEXT VCB      */
@DE00128 LTR   VCBPTR,VCBPTR                                       0181
         BNZ   @DL00128                                            0181
*                                                                  0182
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL FOR PAGEOUT AFTER ALL VCB'S HAVE PROCESSED, OR IF AN     */
*   /* ERROR WAS ENCOUNTERED                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0182
*ASMCK:                                                            0182
*   IF VAMAIAQ^=0 THEN              /* IF THERE ANY AIA'S TO PROCESS */
ASMCK    L     @14,VAMAIAQ(,PVTPTR)                                0182
         LTR   @14,@14                                             0182
         BZ    @RF00182                                            0182
*     CALL IOREQ;                   /* CALL THE I/O SUB-PROC         */
         BAL   @14,IOREQ                                           0183
*                                                                  0184
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT -- THIS IS THE EXIT CODE FOR IEAVAMSI. BOTH NORMAL AND   */
*   /* ERROR EXIT ARE THROUGH THIS CODE. THE RETURN CODE IS SET PRIOR*/
*   /* TO GETTING TO THIS POINT. HERE, THE GLOBAL LOCK IS RELEASED,  */
*   /* THE FRR STACK IS UNLOADED, AND THE ENTRY POINT FLAG IS RESET. */
*   /* IF MOVEOUT PASSED BACK A RETURN CODE OF 16, AN ABEND OCCURS   */
*   /* PRIOR TO REGISTER RESTORATION; OTHERWISE REGISTER 15 CONTAINS */
*   /* THE RETURN CODE, AND FOR RETURN CODE ZERO ALL OTHER REGS ARE  */
*   /* RESTORED. FOR NON-ZERO RETURN CODES, REG 2 WILL CONTAIN THE   */
*   /* ADDRESS OF THE LAST VCB PROCESSED.                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0184
*   RFY                                                            0184
*    (RESTPTR,                                                     0184
*     LOCKRCR,                                                     0184
*     WRK1R,                                                       0184
*     WRK2R) RSTD;                                                 0184
@RF00182 DS    0H                                                  0185
*EXIT:                              /* IF NO ERRORS WERE ENCOUNTERED,
*                                      THE SUB-ROUTINES HAVE SET THE
*                                      R.C. TO 0                     */
*   RESTPTR=RSTADDWD;               /* LOAD ADDRESS OF SAVE AREA     */
*                                                                  0185
EXIT     L     RESTPTR,RSTADDWD(,PVTPTR)                           0185
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE SALLOC                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0186
*   GENERATE SETS(R11,R12,LOCKRCR,R14);                            0186
RELSLK SETLOCK RELEASE,TYPE=SALLOC,RELATED=(RSM,IEAVAMSI(SETSLK))
*   IF LOCKRCR^=0 THEN              /* IF SETLOCK FAILED TO RELEASE  */
         LTR   LOCKRCR,LOCKRCR                                     0187
         BZ    @RF00187                                            0187
*     DO;                                                          0188
*       RCARCRD='06'X;              /* SET RECOVERY CODE             */
         L     @14,RCAPTR(,PVTPTR)                                 0189
         MVI   RCARCRD(@14),X'06'                                  0189
*       GENERATE SETS(R1);                                         0190
      ABEND X'C0D',,,SYSTEM        RECORD THE ERROR
*     END;                                                         0191
*   RFY                                                            0192
*    (LOCKRCR) UNRSTD;                                             0192
*                                                                  0192
@RF00187 DS    0H                                                  0193
*   /*****************************************************************/
*   /*                                                               */
*   /* UNLOAD FRR STACK                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0193
*   GENERATE SETS(WRK1R,WRK2R);                                    0193
RELSTK SETFRR D,WRKREGS=(WRK1R,WRK2R) RELEASE THE FRR
*                                                                  0194
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR ABEND SITUATION                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0194
*VAMEXIT:                                                          0194
*   IF RESTPTR->REG15WD=16 THEN     /* IF AN ABEND CONDITION @YA00053*/
VAMEXIT  CLC   REG15WD(4,RESTPTR),@CF00713                         0194
         BNE   @RF00194                                            0194
*     DO;                                                          0195
*       GENERATE SETS(R1);                                         0196
      ABEND X'028',DUMP,,SYSTEM    ABEND FORM OF EXIT FROM THIS POINT
*     END;                                                         0197
*   GENERATE;                                                      0198
@RF00194 DS    0H                                                  0198
      LM   R0,R15,0(RESTPTR)       RESTORE REGISTERS
*   RFY                                                            0199
*    (RESTPTR,                                                     0199
*     WRK1R,                                                       0199
*     WRK2R) UNRSTD;                                               0199
*   GENERATE NOFLOWS NOSEQFLOW EXIT;                               0200
      BR    R14                    NO ABEND, RETURNING TO CALLER
*                                                                  0201
*   /*****************************************************************/
*   /*                                                               */
*   /* ASSIGN -- THIS IS THE ASSIGN SUB-ROUTINE OF VAMSI. FINDPAGE IS*/
*   /* CALLED TO GET THE PTEPTR AND XPTEPTR. IF AN ERROR IS SIGNALED */
*   /* BY FINDPAGE, AN ERROR CODE IS RETURNED. TESTS ARE THEN MADE   */
*   /* FOR GETMAIN ASSIGNMENT, EXISTANCE OF A RSN, THE DEFER FLAG    */
*   /* BEING ON, AND AUXILIARY STORAGE ASSIGNMENT. IF ANY PROBLEMS   */
*   /* ARE ENCOUNTERED, AN ERROR CODE IS RETURNED. ALL ERRORS CAUSE A*/
*   /* RETURN CODE OF 4 TO BE SET. IF A NULL ASSIGN REQUEST WAS MADE,*/
*   /* THE VIO WINDOW FLAG AND SAVE AUX FLAG ARE SET AND ASSIGN      */
*   /* PROCESSING IS COMPLETE AT THIS POINT; OTHERWISE, IF NO REAL   */
*   /* STORAGE IS ASSIGNED, OR IF THE PAGE I D IS NOT EQUAL TO THE   */
*   /* VIO RECLAIM I D, CONTROL TRANSFERS TO THE REGULAR ASSIGN      */
*   /* (REGASIGN) ROUTINE FOR PAGE ASSIGNMENT. THE VCB ADDRESS AND   */
*   /* CURRENT VSN ARE PASSED TO THIS ROUTINE BY THE CALLER IN THE   */
*   /* VCBPTR AND CURVSNR REGISTERS.                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0201
*ASSIGN:                                                           0201
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0201
ASSIGN   DS    0H                                                  0202
*   RFY                                                            0202
*    (R0,                                                          0202
*     R1,                                                          0202
*     TESTPTR,                                                     0202
*     XPTEPTR,                                                     0202
*     PTEPTR,                                                      0202
*     R14) RSTD;                                                   0202
*   SUBRETWD=R14;                   /* SAVE THE RETURN ADDRESS       */
*                                                                  0203
         ST    R14,SUBRETWD(,PVTPTR)                               0203
*   /*****************************************************************/
*   /*                                                               */
*   /* GET PGTE AND XPTE ADDRESSES                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0204
*FPAGE:                                                            0204
*   R1=VCBVSA;                      /* LOAD THE PARAMETER FOR      0204
*                                      FINDPAGE                      */
FPAGE    L     R1,VCBVSA(,VCBPTR)                                  0204
*   CALL IEAVFP2;                   /* CALL FINDPAGE TO GET PTEPTR 0205
*                                      AND XPTEPTR                   */
         L     @15,PVTPFP2(,PVTPTR)                                0205
         BALR  @14,@15                                             0205
*   IF RETCODR^=0 THEN              /* IF FINDPAGE FAILED            */
         LTR   RETCODR,RETCODR                                     0206
         BZ    @RF00206                                            0206
*     DO;                                                          0207
*       IF RETCODR=8 THEN           /* IF AN INTERNAL RSM ERROR      */
         C     RETCODR,@CF00059                                    0208
         BNE   @RF00208                                            0208
*         DO;                                                      0209
*           RCARCRD='01'X;          /* SET RECOVERY CODE             */
         L     @08,RCAPTR(,PVTPTR)                                 0210
         MVI   RCARCRD(@08),X'01'                                  0210
*           GENERATE SETS(R1);                                     0211
      ABEND X'C0D',,,SYSTEM        RECORD THE ERROR
*         END;                                                     0212
*       VCBINVSA='1'B;              /* MARK THE VCB INVALID          */
@RF00208 OI    VCBINVSA(VCBPTR),B'01000000'                        0213
*       RETCODR=4;                  /* SET THE RETURN CODE           */
         LA    RETCODR,4                                           0214
*       GOTO ERRRTN;                /* HANDLE THE ERROR              */
         B     ERRRTN                                              0215
*     END;                                                         0216
*   PTEPTR=R0;                      /* LOAD PAGE TABLE POINTER     0217
*                                      RETURNED BY FINDPAGE          */
@RF00206 LR    PTEPTR,R0                                           0217
*   XPTEPTR=R1;                     /* LOAD THE EXTERNAL PAGE TABLE
*                                      POINTER RETURNED BY FINDPAGE  */
         LR    XPTEPTR,R1                                          0218
*   RFY                                                            0219
*    (R0,                                                          0219
*     R1) UNRSTD;                                                  0219
*                                                                  0219
*   /*****************************************************************/
*   /*                                                               */
*   /* INSURE THAT PAGE IS GETMAIN ASSIGNED AND EMPTY                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0220
*   IF PGTRSA^=CLRPG THEN           /* IF PAGE TABLE ENTRY IS NOT  0220
*                                      CLEAR                         */
         CLC   PGTRSA(2,PTEPTR),@CB02048                           0220
         BE    @RF00220                                            0220
*     DO;                                                          0221
*       IF PGTPAM='0'B THEN         /* IF THE PAGE IS NOT GETMAIN  0222
*                                      ASSIGNED                      */
         TM    PGTPAM(PTEPTR),B'00000001'                          0222
         BNZ   @RF00222                                            0222
*         VCBINVSA='1'B;            /* NOT ASSIGNED, MARK VCB INVALID*/
         OI    VCBINVSA(VCBPTR),B'01000000'                        0223
*       ELSE                        /* IF THE PAGE IS GETMAIN      0224
*                                      ASSIGNED                      */
*         VCBNOVAC='1'B;            /* PAGE VALID, MARK VCB NOT    0224
*                                      VACANT                        */
         B     @RC00222                                            0224
@RF00222 OI    VCBNOVAC(VCBPTR),B'10000000'                        0224
*       RETCODR=4;                  /* SET THE RETURN CODE           */
@RC00222 LA    RETCODR,4                                           0225
*       GOTO ERRRTN;                /* HANDLE THE ERROR              */
         B     ERRRTN                                              0226
*     END;                                                         0227
*                                                                  0227
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR DEFER, OR AUX ASSIGNMENT FLAGS                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0228
*   IF XPTDEFER='1'B|XPTXAV='1'B THEN/* IF THE DEFER FLAGE IS ON, OR
*                                      IF AUX STOR IS ASSIGNED     0228
*                                                            @Z40WPYC*/
@RF00220 TM    XPTDEFER(XPTEPTR),B'01000010'                       0228
         BZ    @RF00228                                            0228
*     DO;                                                          0229
*       VCBNOVAC='1'B;              /* SET THE NOT VACANT FLAG       */
         OI    VCBNOVAC(VCBPTR),B'10000000'                        0230
*       RETCODR=4;                  /* SET THE FAILURE RETURN CODE   */
         LA    RETCODR,4                                           0231
*       GOTO ERRRTN;                /* RETURN TO CALLER              */
         B     ERRRTN                                              0232
*     END;                                                         0233
*                                                                  0234
*   /*****************************************************************/
*   /*                                                               */
*   /* THE ACTUAL CODE FOR ASSIGNMENT STARTS HERE. PRIOR TO THIS     */
*   /* POINT THE VSA WAS CHECKED FOR VALIDITY, ABILITY TO BE ASSIGNED*/
*   /* ETC. CHECKS ARE MADE FOR NULL ASSIGNMENT AND POSSIBLE RECLAIM.*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0234
*   IF MYVCBLGN=0&MYVCBLPN=0 THEN   /* IF NO LPID WAS PASSED - A NULL
*                                      ASSIGN WAS REQUESTED          */
@RF00228 SLR   @08,@08                                             0234
         CL    @08,MYVCBLGN(,VCBPTR)                               0234
         BNE   @RF00234                                            0234
         CL    @08,MYVCBLPN(,VCBPTR)                               0234
         BNE   @RF00234                                            0234
*     DO;                                                          0235
*       IF CURVSNR<PVTLCSA THEN     /* PRIVATE AREA          @Z40WPYC*/
         LH    @08,PVTLCSA(,PVTPTR)                                0236
         N     @08,@CF02294                                        0236
         CLR   CURVSNR,@08                                         0236
         BNL   @RF00236                                            0236
*         DO;                       /* YES-START NULL PROCESSING   0237
*                                                            @Z40WPYC*/
*           XPTVIO='1'B;            /* SET THE VIO WINDOW BIT ON   0238
*                                                            @Z40WPYC*/
*           XPTVIOLP='0'B;          /* RESET THE SAVE PAGE FLAG    0239
*                                                            @Z40WPYC*/
         OI    XPTVIO(XPTEPTR),B'00001000'                         0239
         NI    XPTVIOLP(XPTEPTR),B'01111111'                       0239
*           GOTO ASIGNRTN;          /* GOING TO RETURN - NO FURTHER
*                                      PROCESSING REQUIRED           */
         B     ASIGNRTN                                            0240
*         END;                      /* END NULL PROCESSING   @Z40WPYC*/
*       ELSE                        /* COMMON AREA REQUEST   @Z40WPYC*/
*         DO;                       /* PROCESS ERROR         @Z40WPYC*/
@RF00236 DS    0H                                                  0243
*           VCBINVSA='1'B;          /* MARK VSA INVALID      @Z40WPYC*/
         OI    VCBINVSA(VCBPTR),B'01000000'                        0243
*           RETCODR=4;              /* SET ERROR RETURN CODE @Z40WPYC*/
         LA    RETCODR,4                                           0244
*           GOTO ERRRTN;            /* PROCESS THE ERROR     @Z40WPYC*/
         B     ERRRTN                                              0245
*         END;                      /* END ERROR PROCESSING  @Z40WPYC*/
*     END;                                                         0247
*   IF VCBRSN=0 THEN                /* IF NO REAL STORAGE NUMBER   0248
*                                      ASSOCIATED                    */
@RF00234 LH    @08,VCBRSN(,VCBPTR)                                 0248
         N     @08,@CF02294                                        0248
         LTR   @08,@08                                             0248
         BZ    @RT00248                                            0248
*     GOTO REGASIGN;                /* ASSIGNMENT MUST BE MADE       */
*   RFY                                                            0250
*    (PFTEPTR) RSTD;                                               0250
*   PFTEPTR=PVTPFTP+VCBRSN;         /* LOAD PFTEPTR AND INDEX        */
         LH    @11,VCBRSN(,VCBPTR)                                 0251
         N     @11,@CF02294                                        0251
         AL    @11,PVTPFTP(,PVTPTR)                                0251
         LR    PFTEPTR,@11                                         0251
*   IF PFTOFINT='1'B|PFTVRINT='1'B|PFTIRRG='0'B|PFTPGID^=VCBDSPID THEN
         TM    PFTOFINT(PFTEPTR),B'01000001'                       0252
         BNZ   @RT00252                                            0252
         TM    PFTIRRG(PFTEPTR),B'00010000'                        0252
         BZ    @RT00252                                            0252
         CLC   PFTPGID(4,PFTEPTR),VCBDSPID(VCBPTR)                 0252
         BE    @RF00252                                            0252
@RT00252 DS    0H                                                  0253
*                                   /* IF THE FRAME HAS BEEN       0253
*                                      INTERCEPTED FOR OFFLINE OR FOR
*                                      V=R, OR IF FRAME IS NOT A VIO
*                                      FRAME, OR IF FRAME PAGE ID NOT
*                                      EQUAL TO VCB RECLAIM ID     0253
*                                                            @ZA10767*/
*     DO;                                                          0253
*       VCBRSN=0;                   /* CLEAR THE REAL STORAGE NUMBER */
         SLR   @11,@11                                             0254
         STH   @11,VCBRSN(,VCBPTR)                                 0254
*       GOTO REGASIGN;              /* ASSIGNMENT MUST BE MADE EVEN
*                                      THOUGH THERE WAS A REAL     0255
*                                      STORAGE NUMBER                */
         B     REGASIGN                                            0255
*     END;                                                         0256
*                                                                  0257
*   /*****************************************************************/
*   /*                                                               */
*   /* IF RECLAIM IS POSSIBLE, THIS CODE GAINS CONTROL. IF THE PAGE  */
*   /* CAN BE RECLAIMED, A PAGE FAULT MAY BE PREVENTED FOR THIS PAGE.*/
*   /* IF A PAGEOUT IS IN PROGRESS FOR THE PAGE, THE PCB MUST BE     */
*   /* LOCATED. THE APPROPRIATE QUEUE IS SEARCHED, AND UPON FINDING  */
*   /* THE PCB THE VBN IS SET, PAGE TABLE AND EXTERNAL PAGE TABLE    */
*   /* POINTERS LOADED, FREE REAL FLAG RESET AND THE REAL STORAGE    */
*   /* NUMBER LOADED. CONTROL THEN PASSES TO THE RECLAIM ROUTINE. IF */
*   /* NO PCB IS FOUND AN ERROR IS RECORDED AND REGASIGN WILL BE     */
*   /* GIVEN CONTROL.                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0257
*   IF PFTPCBSI='1'B THEN           /* IF A PCB IS DEFINED FOR THIS
*                                      FRAME                         */
@RF00252 TM    PFTPCBSI(PFTEPTR),B'00001000'                       0257
         BNO   @RF00257                                            0257
*     DO;                                                          0258
*       RFY                                                        0259
*        (PCBPTR) RSTD;                                            0259
*FINDPCB:                                                          0260
*       PCBPTR=RSMLIOQF;            /* LOAD ADDRESS OF LOCAL PCB'S   */
FINDPCB  L     PCBPTR,RSMLIOQF(,RSMHDPTR)                          0260
*       DO WHILE PCBPTR^=0;         /* SEARCH THE QUE                */
         B     @DE00261                                            0261
@DL00261 DS    0H                                                  0262
*         IF VCBRSN^=PCBRBN|PCBVIO='0'B THEN/* LOOK FOR CORRECT PCB -
*                                      IF RBN MISMATCH OR PCBVIO NOT
*                                      SET, NOT THE CORRECT PCB    0262
*                                                            @Z40WPYC*/
         CLC   VCBRSN(2,VCBPTR),PCBRBN(PCBPTR)                     0262
         BNE   @RT00262                                            0262
         TM    PCBVIO(PCBPTR),B'00000100'                          0262
         BNZ   @RF00262                                            0262
@RT00262 DS    0H                                                  0263
*           PCBPTR=PCBFQPA;         /* GET NEXT ON CHAIN             */
         L     @11,PCBFQPA-1(,PCBPTR)                              0263
         LA    @11,0(,@11)                                         0263
         LR    PCBPTR,@11                                          0263
*         ELSE                      /* IF THE CORRECT PCB WAS FOUND  */
*           DO;                     /* IF PCB WAS FOUND              */
*                                                                  0264
         B     @RC00262                                            0264
@RF00262 DS    0H                                                  0265
*             /*******************************************************/
*             /*                                                     */
*             /* THIS PCB CAN ONLY BE A VIO MOVEOUT PCB BECAUSE THE  */
*             /* PCBVIO FLAG IS ON. IT IS CONVERTED INTO WHAT APPEARS*/
*             /* TO BE A PGOUT WITH KEEPREAL OPTION. THE PCBVIO FLAG */
*             /* REMAINS ON. THE PAGE WILL BE VALIDATED WHEN THE I/O */
*             /* COMPLETES.                                          */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0265
*             PCBVBN=CURVSNR;       /* STORE VBN OF PAGE IN PCB      */
         STH   CURVSNR,PCBVBN(,PCBPTR)                             0265
*             PCBPGTA=PTEPTR;       /* LOAD ADDRESS OF PGTE          */
         STCM  PTEPTR,7,PCBPGTA(PCBPTR)                            0266
*             PCBXPTA=XPTEPTR;      /* LOAD ADDRESS OF XPGT          */
         STCM  XPTEPTR,7,PCBXPTA(PCBPTR)                           0267
*             PCBFREAL='0'B;        /* RESET THE FREE REAL BIT       */
         NI    PCBFREAL(PCBPTR),B'01111111'                        0268
*             PGTRSA=PGTRSA|VCBRSN; /* LOAD RSN, RETAIN FLAGS        */
         LH    @11,VCBRSN(,VCBPTR)                                 0269
         N     @11,@CF02294                                        0269
         SLR   @01,@01                                             0269
         ICM   @01,3,PGTRSA(PTEPTR)                                0269
         OR    @11,@01                                             0269
         STCM  @11,3,PGTRSA(PTEPTR)                                0269
*             PFTASID=ASCBASID;     /* SET CURRENT ASID IN PFTE      */
         L     @11,ASCBPTR                                         0270
         LH    @11,ASCBASID(,@11)                                  0270
         N     @11,@CF02294                                        0270
         STH   @11,PFTASID(,PFTEPTR)                               0270
*             PFTVBN=CURVSNR;       /* SET VBN OF PAGE IN PFTE       */
         STH   CURVSNR,PFTVBN(,PFTEPTR)                            0271
*             PFTIRRG='0'B;         /* RESET THE VIO FRAME FLAG      */
         NI    PFTIRRG(PFTEPTR),B'11101111'                        0272
*             PFTUIC=0;             /* RESET THE INTERVAL COUNT      */
         MVI   PFTUIC(PFTEPTR),X'00'                               0273
*             GOTO RCLMCNTS;        /* KEEPING THE PAGE              */
         B     RCLMCNTS                                            0274
*           END;                                                   0275
*       END;                                                       0276
@RC00262 DS    0H                                                  0276
@DE00261 LTR   PCBPTR,PCBPTR                                       0276
         BNZ   @DL00261                                            0276
*       RCARCRD='07'X;              /* SET RECOVERY CODE , NO PCB    */
         L     @11,RCAPTR(,PVTPTR)                                 0277
         MVI   RCARCRD(@11),X'07'                                  0277
*       GENERATE SETS(R1);                                         0278
      ABEND X'C0D',,,SYSTEM        RECORD THE ERROR
*       PFTIRRG='0'B;               /* PREVENT A RECLAIM ATTEMPT     */
         NI    PFTIRRG(PFTEPTR),B'11101111'                        0279
*       VCBRSN=0;                   /* CLEAR THE REAL STORAGE NUMBER */
         SLR   @11,@11                                             0280
         STH   @11,VCBRSN(,VCBPTR)                                 0280
*       GOTO REGASIGN;              /* PCB DEFINED, NOT FOUND        */
         B     REGASIGN                                            0281
*       RFY                                                        0282
*        (PCBPTR) UNRSTD;                                          0282
*     END;                                                         0283
*                                                                  0284
*   /*****************************************************************/
*   /*                                                               */
*   /* ELSE - IF NO PAGEOUT IS IN PROGRESS, THE PFTE IS UPDATED WITH */
*   /* THE ASID AND VBN. THE VIO FRAME FLAG IS RESET. IF THE PFTE IS */
*   /* ON THE AVAILABLE FRAME QUEUE IT IS MOVED TO THE APPROPRIATE   */
*   /* I/O QUEUE AND THE PAGE TABLE ENTRY VALIDATED.                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0284
*   ELSE                            /* NO PCB EXISTS FOR THIS FRAME  */
*     DO;                                                          0284
@RF00257 DS    0H                                                  0285
*       IF PFTQNDX=PFTNQN THEN      /* IF PFTE IS UNQUEUED, NO     0285
*                                      RECLAIM                       */
         CLI   PFTQNDX(PFTEPTR),X'FF'                              0285
         BNE   @RF00285                                            0285
*         DO;                       /* PREVENT RECLAIM               */
*           PFTIRRG='0'B;           /* TURN OFF IRREGULAR FLAG       */
         NI    PFTIRRG(PFTEPTR),B'11101111'                        0287
*           VCBRSN=0;               /* ZERO RSN IN VCB               */
         SLR   @11,@11                                             0288
         STH   @11,VCBRSN(,VCBPTR)                                 0288
*           GOTO REGASIGN;          /* GO TO NORMAL ASSIGN PROCESSING*/
         B     REGASIGN                                            0289
*         END;                                                     0290
*       ELSE                                                       0291
*         ;                         /* CONTINUE RECLAIM PROCESSING   */
@RF00285 DS    0H                                                  0292
*       PFTASID=ASCBASID;           /* SET CURRENT ASID IN PFTE      */
         L     @11,ASCBPTR                                         0292
         LH    @10,ASCBASID(,@11)                                  0292
         N     @10,@CF02294                                        0292
         STH   @10,PFTASID(,PFTEPTR)                               0292
*       PFTVBN=CURVSNR;             /* SET VBN OF PAGE IN PFTE       */
         STH   CURVSNR,PFTVBN(,PFTEPTR)                            0293
*       PFTUIC=0;                   /* RESET THE UNREFERANCED      0294
*                                      INTERVAL COUNT                */
         MVI   PFTUIC(PFTEPTR),X'00'                               0294
*       PFTIRRG='0'B;               /* RESET THE VIO FRAME FLAG      */
*                                                                  0295
         NI    PFTIRRG(PFTEPTR),B'11101111'                        0295
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK FOR PFTE BEING ON AVAILABLE FRAME QUEUE             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0296
*       IF PFTQNDX=PFTAFQN THEN     /* IF THE PFTE IS ON AVAILABLE 0296
*                                      FRAME QUE                     */
         CLI   PFTQNDX(PFTEPTR),X'00'                              0296
         BNE   @RF00296                                            0296
*         DO;                                                      0297
*           QINDEX=PFTLFQN;         /* SEND PFTE TO LOCAL FRAME QUE  */
         MVI   QINDEX(PVTPTR),X'80'                                0298
*           RFY                                                    0299
*            (R0,                                                  0299
*             R1) RSTD;                                            0299
*           QRBN=VCBRSN;            /* STORE THE RSN                 */
         LH    @10,VCBRSN(,VCBPTR)                                 0300
         N     @10,@CF02294                                        0300
         STH   @10,QRBN(,PVTPTR)                                   0300
*           QHEADFLG=0;             /* SEND PFTE TO REAR OF QUEUE    */
         MVI   QHEADFLG(PVTPTR),X'00'                              0301
*           R0=PARMBLD;             /* LOAD FLAG, INDEX AND RBN FOR
*                                      IEAVPFTE                      */
         L     R0,PARMBLD(,PVTPTR)                                 0302
*           R1=ASCBPTR;             /* LOAD ASCB ADDRESS FOR IEAVPFTE*/
         LR    R1,@11                                              0303
*           CALL IEAVPFTE;          /* CALL PFTE MANAGER TO MOVE PFTE*/
         L     @15,PVTPFTE(,PVTPTR)                                0304
         BALR  @14,@15                                             0304
*           RFY                                                    0305
*            (R0,                                                  0305
*             R1) UNRSTD;                                          0305
*         END;                                                     0306
*                                                                  0307
*       /*************************************************************/
*       /*                                                           */
*       /* RESET THE CHANGE BITS                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0307
*       RFY                                                        0307
*        (WRK1R,                                                   0307
*         WRK2R) RSTD;                                             0307
@RF00296 DS    0H                                                  0308
*       WRK2R=VCBRSN;               /* LOAD THE RBN FOR THE SSK    0308
*                                      INSTRUCTION                   */
         LH    WRK2R,VCBRSN(,VCBPTR)                               0308
         N     WRK2R,@CF02294                                      0308
*       WRK1R=XPTPROT;              /* LOAD THE KEY FOR SSK        0309
*                                      INSTRUCTION                   */
         SLR   WRK1R,WRK1R                                         0309
         IC    WRK1R,XPTPROT(,XPTEPTR)                             0309
*       GENERATE REFS(WRK1R,WRK2R);                                0310
      SLL    WRK2R,8(0)            MAKE RBN A REAL ADDRESS
      SSK    WRK1R,WRK2R           RESET THE CHANGE BIT
      LA     WRK2R,2048(,WRK2R)    UPDATE TO SECOND HALF PAGE
      SSK    WRK1R,WRK2R           RESET THE CHANGE BIT
*       RFY                                                        0311
*        (WRK1R,                                                   0311
*         WRK2R) UNRSTD;                                           0311
*       PGTRSA=VCBRSN;              /* LOAD REAL STORAGE NUMBER AND
*                                      MARK PAGE VALID               */
         MVC   PGTRSA(2,PTEPTR),VCBRSN(VCBPTR)                     0312
*       PGTPAM='1'B;                /* SET GETMAIN ASSIGNED BIT BACK
*                                      ON                            */
         OI    PGTPAM(PTEPTR),B'00000001'                          0313
*     END;                                                         0314
*                                                                  0314
*   /*****************************************************************/
*   /*                                                               */
*   /* RCLMCNTS - THE FRAME IS BEING RECLAIMED, SO THE VIO COUNT IS  */
*   /* UPDATED AND THE LOCAL RECLAIM COUNT IS UPDATED                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0315
*RCLMCNTS:                                                         0315
*   PVTVAMR=PVTVAMR+1;              /* UPDATE THE VIO COUNT, PAGE WAS
*                                      RECLAIMED                     */
RCLMCNTS LA    @11,1                                               0315
         L     @10,PVTVAMR(,PVTPTR)                                0315
         ALR   @10,@11                                             0315
         ST    @10,PVTVAMR(,PVTPTR)                                0315
*   OUXBVAMR=OUXBVAMR+1;            /* UPDATE THE LOCAL VIO RECLAIM
*                                      COUNT                         */
         L     @01,ASCBPTR                                         0316
         L     @10,OUXBPTR(,@01)                                   0316
         AL    @11,OUXBVAMR(,@10)                                  0316
         ST    @11,OUXBVAMR(,@10)                                  0316
*   RFY                                                            0317
*    (PFTEPTR) UNRSTD;                                             0317
*                                                                  0318
*   /*****************************************************************/
*   /*                                                               */
*   /* REGASIGN-- THIS IS CODE FOR REGULAR ASSIGNMENT. THE EXTERNAL  */
*   /* PAGE TABLE IS UPDATED AND A CHECK MADE TO SEE IF A LOAD WAS   */
*   /* REQUESTED. IF A LOAD WAS REQUESTED AND THE PAGE IS NOT VALID, */
*   /* PAGE SERVICES INTERFACE (PSI) MUST BE CALLED TO DO A PAGELOAD */
*   /* BEFORE RETURNING TO VAMSI.                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0318
*REGASIGN:                                                         0318
*   XPTLPID=VCBLPID;                /* LOAD THE LOGICAL PAGE I D     */
REGASIGN MVC   XPTLPID(8,XPTEPTR),VCBLPID(VCBPTR)                  0318
*   XPTXAV='1'B;                    /* MARK EXTERNAL STG VALID       */
*   XPTVIOLP='1'B;                  /* SET THE SAVE AUX FLAG @Z40WPYC*/
*   XPTVIO='1'B;                    /* SET VIO WINDOW PAGE FLAG    0321
*                                                            @Z40WPYC*/
*                                                                  0321
         OI    XPTXAV(XPTEPTR),B'11001000'                         0321
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR PAGE LOAD REQUEST                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0322
*   IF VCBLOAD='1'B THEN            /* IF LOAD IS REQUESTED          */
         TM    VCBLOAD(VCBPTR),B'00000100'                         0322
         BNO   @RF00322                                            0322
*     DO;                                                          0323
*       RFY                                                        0324
*        (TESTPTR) RSTD;                                           0324
*       TESTPTR=VCBVSA;             /* LOAD ADDRESS FOR LRA TEST     */
         L     TESTPTR,VCBVSA(,VCBPTR)                             0325
*       GENERATE REFS(TESTPTR) SETS(TESTPTR);                      0326
      LRA   TESTPTR,0(TESTPTR)     IS VSN VALID IN REAL STORAGE
*       BC(8,ASIGNRTN);             /* IF TRANSLATION WAS SUCCESSFUL,
*                                      RETURN TRANSLATION WILL BE  0327
*                                      SUCCESSFUL HERE IF RECLAIM WAS
*                                      SUCCESSFUL ABOVE.             */
         BC    8,ASIGNRTN                                          0327
*       RFY                                                        0328
*        (TESTPTR) UNRSTD;                                         0328
*                                                                  0328
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE PAGE IS NOT VALID IN REAL STORAGE AND A LOAD WAS   */
*       /* REQUESTED, PSI MUST BE CALLED TO INITIATE THE LOAD        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0329
*       RFY                                                        0329
*        (R0,                                                      0329
*         R1,                                                      0329
*         R12,                                                     0329
*         R13) RSTD;                                               0329
*       PARMBLD2=VCBVSA;            /* SET PAGE VSA                  */
         L     @08,VCBVSA(,VCBPTR)                                 0330
         ST    @08,PARMBLD2(,PVTPTR)                               0330
*       PARMFLGS=PGLOAD;            /* SET LOAD REQUEST FLAG         */
         MVI   PARMFLGS(PVTPTR),X'10'                              0331
*       R0=0;                       /* CLEAR FOR PSI CALL            */
         SLR   R0,R0                                               0332
*       R1=PARMBLD2;                /* LOAD FOR PSI CALL             */
         L     R1,PARMBLD2(,PVTPTR)                                0333
*       R12=R2;                     /* SAVE ACROSS CALL              */
         LR    R12,R2                                              0334
*       R13=R4;                     /* SAVE ACROSS CALL              */
         LR    R13,R4                                              0335
*       R2=VCBVSA+BLOCKSIZ;         /* LOAD FOR PSI CALL--END ADDRESS*/
         AL    @08,@CF02045                                        0336
         LR    R2,@08                                              0336
*       R4=REG0WD;                  /* LOAD FOR PSI CALL--TCB ADDRESS*/
         L     @08,RSTADDWD(,PVTPTR)                               0337
         L     R4,REG0WD(,@08)                                     0337
*       CALL IEAVPSII;              /* CALL PSI FOR PAGE LOAD        */
         L     @15,PVTPSINT(,PVTPTR)                               0338
         BALR  @14,@15                                             0338
*       RCACSECT=RCACVAM;           /* RESTORE CSECT NAME AFTER CALL */
         L     @08,RCAPTR(,PVTPTR)                                 0339
         MVI   RCACSECT(@08),X'18'                                 0339
*       R2=R12;                     /* RESTORE AFTER CALL            */
         LR    R2,R12                                              0340
*       R4=R13;                     /* RESTORE AFTER CALL            */
         LR    R4,R13                                              0341
*     END;                                                         0342
*                                                                  0342
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN POINT FOR THE ASSIGN SUB-ROUTINE                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0343
*ASIGNRTN:                                                         0343
*   RETCODR=0;                      /* SUCCESSFUL ASSIGN             */
*                                                                  0343
@RF00322 DS    0H                                                  0343
ASIGNRTN SLR   RETCODR,RETCODR                                     0343
*   /*****************************************************************/
*   /*                                                               */
*   /* ERROR RETURN POINT FOR ASSIGN SUB-ROUTINE                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0344
*ERRRTN:                                                           0344
*   RFY                                                            0344
*    (R14) RSTD;                                                   0344
ERRRTN   DS    0H                                                  0345
*   R14=SUBRETWD;                   /* LOAD RETURN ADDRESS           */
         L     R14,SUBRETWD(,PVTPTR)                               0345
*   RFY                                                            0346
*    (R0,                                                          0346
*     R1,                                                          0346
*     PTEPTR,                                                      0346
*     XPTEPTR,                                                     0346
*     R12,                                                         0346
*     R13,                                                         0346
*     R14) UNRSTD;                                                 0346
*   END ASSIGN;                                                    0347
@EL00002 DS    0H                                                  0347
@EF00002 DS    0H                                                  0347
@ER00002 BR    @14                                                 0347
*                                                                  0348
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVEOUT -- THIS IS THE MOVE OUT SUB-ROUTINE OF VAMSI. FINDPAGE*/
*   /* IS CALLED TO SUPPLY PAGE TABLE AND EXTERNAL PAGE TABLE        */
*   /* ADDRESSES. IF THE PAGE IS NOT GETMAIN ASSIGNED, IF IT IS IN   */
*   /* THE NUCLEUS, IF IT IS IN SQA OR IF IT IS NOT A VIO WINDOW     */
*   /* PAGE, AN ERROR IS SIGNALED. IF THE PAGE IS MARKED INVALID, THE*/
*   /* OUTOFSTG SUB-ROUTINE IS CALLED. IF NO LPID WAS SUPPLIED, THIS */
*   /* IS A NULL MOVEOUT REQUEST AND CONTROL WILL PASS TO THE        */
*   /* NULLMOVE ROUTINE. IF AUX STORAGE IS NOT ASSIGNED OR THE SAVE  */
*   /* AUX BIT IS NOT SET, CONTROL IS PASSED TO TEST CHANGE BIT      */
*   /* (TCHGBIT), OTHERWISE THE PAGEOUT ROUTINE WILL NOW EXECUTE.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0348
*MOVEOUT:                                                          0348
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0348
MOVEOUT  DS    0H                                                  0349
*   RFY                                                            0349
*    (R0,                                                          0349
*     R1,                                                          0349
*     PTEPTR,                                                      0349
*     XPTEPTR,                                                     0349
*     R14) RSTD;                                                   0349
*   SUBRETWD=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,SUBRETWD(,PVTPTR)                               0350
*   POINPROC='0'B;                  /* CLEAR PAGEOUT IN PROCESS FLAG
*                                                            @Z40WPYC*/
*   PIINPROC='0'B;                  /* CLEAR PAGEIN IN PROCESS FLAG
*                                                            @Z40WPYC*/
         NI    POINPROC(PVTPTR),B'11111100'                        0352
*   IOSVAIA=0;                      /* CLEAR I/O SAVE AREA FOR AIA 0353
*                                                            @Z40WPYC*/
*                                                                  0353
         SLR   @12,@12                                             0353
         STCM  @12,7,IOSVAIA(PVTPTR)                               0353
*   /*****************************************************************/
*   /*                                                               */
*   /* GET PGTE AND XPTE ADDRESSES                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0354
*   R1=VCBVSA;                      /* LOAD PARM REG FOR FINDPAGE    */
         L     R1,VCBVSA(,VCBPTR)                                  0354
*   CALL IEAVFP2;                   /* REQUEST PGTE AND XPTE ADDRESS */
         L     @15,PVTPFP2(,PVTPTR)                                0355
         BALR  @14,@15                                             0355
*   IF RETCODR^=0 THEN              /* IF FINDPAGE FAILED            */
         LTR   RETCODR,RETCODR                                     0356
         BZ    @RF00356                                            0356
*     DO;                                                          0357
*       IF RETCODR=8 THEN           /* IF AN INTERNAL RSM ERROR      */
         C     RETCODR,@CF00059                                    0358
         BNE   @RF00358                                            0358
*         DO;                                                      0359
*           RCARCRD='01'X;          /* SET RECOVERY CODE             */
         L     @12,RCAPTR(,PVTPTR)                                 0360
         MVI   RCARCRD(@12),X'01'                                  0360
*           GENERATE SETS(R1);                                     0361
      ABEND X'C0D',,,SYSTEM        RECORD THE ERROR
*         END;                                                     0362
*       VCBINVSA='1'B;              /* SET INVALID VSA FLAG IN VCB   */
@RF00358 OI    VCBINVSA(VCBPTR),B'01000000'                        0363
*       RETCODR=4;                  /* SET THE RETURN CODE           */
         LA    RETCODR,4                                           0364
*       GOTO MOERRTN;               /* GOING TO RETURN TO VAMSI WITH
*                                      ERROR CODE                    */
         B     MOERRTN                                             0365
*     END;                                                         0366
*   PTEPTR=R0;                      /* LOAD POINTERS AS RETURNED BY
*                                      FINDPAGE                      */
@RF00356 LR    PTEPTR,R0                                           0367
*   XPTEPTR=R1;                     /* LOAD POINTERS AS RETURNED BY
*                                      FINDPAGE                      */
         LR    XPTEPTR,R1                                          0368
*   RFY                                                            0369
*    (R0,                                                          0369
*     R1) UNRSTD;                                                  0369
*                                                                  0369
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR ERROR CONDITIONS                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0370
*   IF CURVSNR<PVTLPRIV THEN        /* IF A NUCLEUS PAGE             */
         LH    @12,PVTLPRIV(,PVTPTR)                               0370
         N     @12,@CF02294                                        0370
         CLR   CURVSNR,@12                                         0370
         BNL   @RF00370                                            0370
*     DO;                                                          0371
*EFIX:                                                             0372
*       VCBEFIX='1'B;               /* SET THE FIXED ERROR FLAG      */
EFIX     OI    VCBEFIX(VCBPTR),B'00001000'                         0372
*       RETCODR=4;                  /* SET THE ERROR RETURN CODE     */
         LA    RETCODR,4                                           0373
*       GOTO MOERRTN;               /* GOING TO RETURN               */
         B     MOERRTN                                             0374
*     END;                                                         0375
*   IF PGTPAM='0'B|XPTVIO='0'B THEN /* IF PAGE IS NOT GETMAINED OR 0376
*                                      PAGE IS NOT A VIO WINDOW PAGE
*                                                            @Z40WPYC*/
@RF00370 TM    PGTPAM(PTEPTR),B'00000001'                          0376
         BZ    @RT00376                                            0376
         TM    XPTVIO(XPTEPTR),B'00001000'                         0376
         BNZ   @RF00376                                            0376
@RT00376 DS    0H                                                  0377
*     DO;                                                          0377
*       VCBINVSA='1'B;              /* SET INVALID VSA FLAG IN VCB   */
         OI    VCBINVSA(VCBPTR),B'01000000'                        0378
*       RETCODR=4;                  /* SET THE RETURN CODE           */
         LA    RETCODR,4                                           0379
*       GOTO MOERRTN;               /* GOING TO RETURN               */
         B     MOERRTN                                             0380
*     END;                                                         0381
*                                                                  0381
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR PAGE VALIDITY, NULLMOVE, ETC.                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0382
*   IF PGTPVM='1'B THEN             /* IF PAGE IS INVALID            */
@RF00376 TM    PGTPVM(PTEPTR),B'00001000'                          0382
         BNO   @RF00382                                            0382
*     DO;                           /* PROCESS OUT OF STORAGE CASE 0383
*                                                            @Z40WPYC*/
*       IF XPTPOINP='1'B THEN       /* IF A PAGEOUT IS IN PROCESS FOR
*                                      THIS VSA LOCATE THE OUTPUT PCB
*                                                            @Z40WPYC*/
         TM    XPTPOINP(XPTEPTR),B'00100000'                       0384
         BNO   @RF00384                                            0384
*         DO;                       /* START SEARCH OF LIOQ  @Z40WPYC*/
*           RESPECIFY                                              0386
*            (PCBPTR) RESTRICTED;   /*                       @Z40WPYC*/
*           PCBPTR=RSMLIOQF;        /* LOCATE START OF CHAIN @Z40WPYC*/
         L     PCBPTR,RSMLIOQF(,RSMHDPTR)                          0387
*           DO WHILE PCBPTR^=0;     /* SEARCH ENTIRE LOCAL I/O QUEUE
*                                      FOR THE OUTPUT PCB    @Z40WPYC*/
         B     @DE00388                                            0388
@DL00388 DS    0H                                                  0389
*             IF PCBVBN^=CURVSNR THEN/* IF NOT CORRECT PCB   @Z40WPYC*/
         LH    @12,PCBVBN(,PCBPTR)                                 0389
         N     @12,@CF02294                                        0389
         CLR   CURVSNR,@12                                         0389
         BE    @RF00389                                            0389
*               PCBPTR=PCBFQPA;     /* GET NEXT PTR          @Z40WPYC*/
         L     @12,PCBFQPA-1(,PCBPTR)                              0390
         LA    @12,0(,@12)                                         0390
         LR    PCBPTR,@12                                          0390
*             ELSE                  /* MATCH FOUND           @Z40WPYC*/
*               DO;                 /* SET INDICATORS FOR TRANSFER 0391
*                                      PAGE (XFERP)          @Z40WPYC*/
         B     @RC00389                                            0391
@RF00389 DS    0H                                                  0392
*                 POINPROC='1'B;    /* INDICATE PAGEOUT IN PROCESS 0392
*                                                            @Z40WPYC*/
         OI    POINPROC(PVTPTR),B'00000010'                        0392
*                 IOSVAIA=ADDR(PCBAIA);/* SAVE AIA ADDR FOR THIS   0393
*                                      OUTPUT PCB            @Z40WPYC*/
         LA    @12,PCBAIA(,PCBPTR)                                 0393
         STCM  @12,7,IOSVAIA(PVTPTR)                               0393
*                 IF VCBNDISC='0'B&PCBNOREC='1'B THEN/* IF THE     0394
*                                      NON-DISC OPTION WAS NOT     0394
*                                      SPECIFIED AND THE OUTPUT PCB
*                                      HAS BEEN MARKED             0394
*                                      NON-RECLAIMABLE, I.E, A     0394
*                                      PAGEOUT IS IN PROCESS FOR AN
*                                      INTERCEPTED FRAME, NOP THE  0394
*                                      OUTPUT PCB. THIS IS REQUIRED
*                                      BECAUSE A SUBSEQUENT ASSIGN 0394
*                                      THEN PAGE FAULT WHILE THE   0394
*                                      OUTPUT I/O IS STILL IN PROCESS
*                                      WILL RESULT IN DUPLICATE    0394
*                                      PCBVBNS (ONE INPUT THE OTHER
*                                      OUTPUT).              @Z40WPYC*/
         TM    VCBNDISC(VCBPTR),B'00001000'                        0394
         BNZ   @RF00394                                            0394
         TM    PCBNOREC(PCBPTR),B'00000100'                        0394
         BNO   @RF00394                                            0394
*                   DO;             /* PERFORM SPECIAL PROCESSING  0395
*                                                            @Z40WPYC*/
*                     PCBVBN=0;     /* NOP THE PCB           @Z40WPYC*/
         SLR   @12,@12                                             0396
         STH   @12,PCBVBN(,PCBPTR)                                 0396
*                     PCBFREAL='1'B;/* ENSURE FRAME IS FREED WHEN I/O
*                                      COMPETES              @Z40WPYC*/
         OI    PCBFREAL(PCBPTR),B'10000000'                        0397
*                   END;            /* END NO-RECLAIM PROCESSING   0398
*                                                            @Z40WPYC*/
*                 ELSE                                             0399
*                   ;               /* NORMAL PROCESSING     @Z40WPYC*/
@RF00394 DS    0H                                                  0400
*                 GOTO SRCHCOMP;    /* BRANCH OUT OF LOOP    @Z40WPYC*/
         B     SRCHCOMP                                            0400
*               END;                /* END OF PAGEOUT FOUND        0401
*                                      PROCESSING            @Z40WPYC*/
*           END;                    /* END OF SEARCH LOOP    @Z40WPYC*/
@RC00389 DS    0H                                                  0402
@DE00388 LTR   PCBPTR,PCBPTR                                       0402
         BNZ   @DL00388                                            0402
*         END;                      /* END PAGEOUT PROCESSING      0403
*                                                            @Z40WPYC*/
*SRCHCOMP:                                                         0404
*       CALL OUTOFSTG;              /* CALL THE OUT OF STORAGE     0404
*                                      ROUTINE -- CONTROL WILL NOT 0404
*                                      RETURN TO THIS SUB-PROC -- BUT
*                                      WILL BE TO VAMSI              */
@RF00384 DS    0H                                                  0404
SRCHCOMP BAL   @14,OUTOFSTG                                        0404
*     END;                          /* END INVALID PAGE PROCESSING 0405
*                                                            @Z40WPYC*/
*   ELSE                                                           0406
*     ;                             /* PAGE IS VALID IN STORAGE    0406
*                                                            @Z40WPYC*/
@RF00382 DS    0H                                                  0407
*   RFY                                                            0407
*    (PFTEPTR) RSTD;                                               0407
*   PFTEPTR=PVTPFTP+(PGTRSA&RSNMASK);/* LOAD PFTE POINTER            */
         L     PFTEPTR,@CF02042                                    0408
         SLR   @12,@12                                             0408
         ICM   @12,3,PGTRSA(PTEPTR)                                0408
         NR    PFTEPTR,@12                                         0408
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0408
*   IF PFTLSQA='1'B|PFTBADPG='1'B THEN/* IF AN L/SQA FRAME OR FRAME
*                                      CONTAINS A STORAGE ERROR    0409
*                                                            @ZA19960*/
         TM    PFTLSQA(PFTEPTR),B'00100100'                        0409
         BNZ   @RT00409                                            0409
*     GOTO EFIX;                    /* THIS IS A FIXED PAGE          */
*   IF MYVCBLGN=0&MYVCBLPN=0 THEN   /* IF LPID WAS SPECIFIED AS ZERO,
*                                      A NULL MOVE WAS REQUESTED     */
         SLR   @12,@12                                             0411
         CL    @12,MYVCBLGN(,VCBPTR)                               0411
         BNE   @RF00411                                            0411
         CL    @12,MYVCBLPN(,VCBPTR)                               0411
         BE    @RT00411                                            0411
*     GOTO NULLMOVE;                /* GOING TO NULLMOVE CODE        */
*   IF XPTXAV='0'B|XPTVIOLP='0'B THEN/* IF AUX STORAGE IS NOT      0413
*                                      ASSIGNED, OR IF THE SAVE AUX
*                                      FLAG IS NOT SET       @Z40WPYC*/
@RF00411 TM    XPTXAV(XPTEPTR),B'11000000'                         0413
         BNO   @RT00413                                            0413
*     GOTO TCHGBIT;                 /* GOING TO SEE IF PAGE HAS    0414
*                                      CHANGED                       */
*                                                                  0415
*   /*****************************************************************/
*   /*                                                               */
*   /* PAGEOUT -- THIS IS THE PAGE OUT CODE OF THE MOVEOUT           */
*   /* SUB-ROUTINE. IEAVINV IS CALLED TO INVALIDATE THE PAGE, AND A  */
*   /* PCB IS OBTAINED FOR THE PAGEOUT. IF THE PCB MANAGER CANNOT    */
*   /* SUPPLY A PCB, AN ABEND WILL BE ISSUED WHEN CONTROL RETURNS TO */
*   /* THE MAINLINE; OTHERWISE THE PCB IS FILLED IN AND THE PCB      */
*   /* DEFINED FLAG TURNED ON IN PFTE. IF NEITHER THE NON-DISCONNECT */
*   /* NOR THE IN-STORAGE OPTIONS WERE REQUESTED, THE FREE REAL FLAG */
*   /* IS TURNED ON IN THE PCB. THE PAGEOUT AIA IS CHAINED TO THE    */
*   /* INTERNAL QUEUE (VAMAIAQ) FOR LATER CALL TO ASM. THE PROPER    */
*   /* COUNTS ARE UPDATED AND THE PCB SENT TO THE PROPER IO QUEUE. IF*/
*   /* THE NON-DISCONNECT OPTION WAS SPECIFIED THE SAVE AUX AND AUX  */
*   /* ASSIGNED FLAGS ARE SET, THE XPTLPID IS SET TO THE VCBLPID     */
*   /* VALUE AND THE RSN IN THE VCB IS CLEARED. RETURN IS THEN MADE  */
*   /* TO THE CALLER. IF A RECLAIM I D WAS NOT SUPPLIED THE VCBRSN IS*/
*   /* ZEROED, ELSE THE VCBRSN IS SET, THE PAGE FRAME IRREGULAR BIT  */
*   /* IS SET ON, AND THE I D IS SET IN THE PFTE.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0415
*PAGEOUT:                                                          0415
*   RFY                                                            0415
*    (R0,                                                          0415
*     R1,                                                          0415
*     PCBPTR) RSTD;                                                0415
*                                                                  0415
PAGEOUT  DS    0H                                                  0416
*   /*****************************************************************/
*   /*                                                               */
*   /* INVALIDATE THE PAGE                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0416
*   R1=PTEPTR;                      /* LOAD PAGE TABLE POINTER FOR 0416
*                                      INVALIDATE                    */
         LR    R1,PTEPTR                                           0416
*   CALL IEAVINV;                   /* CALL FOR INVALIDATION         */
*                                                                  0417
         L     @15,PVTPINV(,PVTPTR)                                0417
         BALR  @14,@15                                             0417
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN A PCB FOR PAGEOUT                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0418
*   R0=1;                           /* REQUEST ONE PCB FROM PCB    0418
*                                      MANAGER                       */
         LA    R0,1                                                0418
*   R1=0;                           /* SPECIFY A BUILD REQUEST       */
         SLR   R1,R1                                               0419
*   CALL IEAVPCB;                   /* CALL PCB MANAGER FOR A BUILD  */
         L     @15,PVTPCB(,PVTPTR)                                 0420
         BALR  @14,@15                                             0420
*   IF RETCODR^=0 THEN              /* IF NO PCBS ARE AVAILABLE      */
         LTR   RETCODR,RETCODR                                     0421
         BZ    @RF00421                                            0421
*     DO;                                                          0422
*       RETCODR=16;                 /* RETURN CODE OF 16 FOR ABEND 0423
*                                      SITUATION                     */
         LA    RETCODR,16                                          0423
*       GOTO MOERRTN;               /* GOING TO RETURN TO CALLER WITH
*                                      ERROR                         */
         B     MOERRTN                                             0424
*     END;                                                         0425
*   PCBPTR=R1;                      /* LOAD PCB POINTER AS RETURNED
*                                      BY MANAGER                    */
@RF00421 LR    PCBPTR,R1                                           0426
*   PCBRTPA=REG0WD;                 /* LOAD THE TCB ADDRESS          */
         L     @12,RSTADDWD(,PVTPTR)                               0427
         MVC   PCBRTPA(3,PCBPTR),REG0WD+1(@12)                     0427
*   PCBVIO='1'B;                    /* THIS IS A PAGEOUT FOR VIO   0428
*                                                            @Z40WPYC*/
         OI    PCBVIO(PCBPTR),B'00000100'                          0428
*   PCBIOI='1'B;                    /* MARK A PAGEOUT OPERATION      */
         OI    PCBIOI(PCBPTR),B'00000010'                          0429
*   PCBASCB=RSMASCB;                /* LOAD ADDRESS SPACE IN PCB     */
         L     @12,RSMASCB(,RSMHDPTR)                              0430
         ST    @12,PCBASCB(,PCBPTR)                                0430
*   PCBXPTA=XPTEPTR;                /* LOAD XPTE ADDRESS             */
         STCM  XPTEPTR,7,PCBXPTA(PCBPTR)                           0431
*   PCBPGTA=PTEPTR;                 /* LOAD PGTE ADDRESS             */
         STCM  PTEPTR,7,PCBPGTA(PCBPTR)                            0432
*   PCBRBN=PGTRSA&RSNMASK;          /* LOAD REAL ADDRESS             */
         MVC   PCBRBN(2,PCBPTR),PGTRSA(PTEPTR)                     0433
         NC    PCBRBN(2,PCBPTR),@CB02042                           0433
*   PFTPCBSI='1'B;                  /* SET PCB DEFINED FLAG IN PAGE
*                                      FRAME TABLE                   */
*                                                                  0434
         OI    PFTPCBSI(PFTEPTR),B'00001000'                       0434
*   /*****************************************************************/
*   /*                                                               */
*   /* CHAIN AIA TO INTERNAL QUEUE                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0435
*   AIANXAIA=VAMAIAQ;               /* TAG ONTO CHAIN                */
         L     @12,VAMAIAQ(,PVTPTR)                                0435
         ST    @12,AIANXAIA(,PCBPTR)                               0435
*   VAMAIAQ=ADDR(PCBAIA);           /* UPDATE THE HEADER             */
         LA    @12,PCBAIA(,PCBPTR)                                 0436
         ST    @12,VAMAIAQ(,PVTPTR)                                0436
*   AIAWRITE='1'B;                  /* MARK WRITE OPERATION  @Z40WPYC*/
         OI    AIAWRITE(PCBPTR),B'10000000'                        0437
*   AIALPID=VCBLPID;                /* LOAD THE LOGICAL PAGE ID      */
         MVC   AIALPID(8,PCBPTR),VCBLPID(VCBPTR)                   0438
*   AIAPRIV='1'B;                   /* INDICATE PRIVATE AREA PAGE  0439
*                                                            @Z40WPYC*/
*   AIAVIO='1'B;                    /* INDICATE VIO PAGEOUT  @Z40WPYC*/
*                                                                  0440
         OI    AIAPRIV(PCBPTR),B'01100000'                         0440
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR NON-DISCONNECT OPTION                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0441
*   IF VCBNDISC='1'B THEN           /* IF THE NON-DISCONNECT OPTION
*                                      IS SPECIFIED                  */
         TM    VCBNDISC(VCBPTR),B'00001000'                        0441
         BNO   @RF00441                                            0441
*     PCBVBN=CURVSNR;               /* LOAD THE VIRTUAL BLOCK NUMBER */
         STH   CURVSNR,PCBVBN(,PCBPTR)                             0442
*   ELSE                            /* IF NON-DISCONNECT IS NOT    0443
*                                      SPECIFIED                     */
*     IF VCBINSTG='0'B THEN         /* IF THE IN-STORAGE OPTION NOT
*                                      SPECIFIED                     */
         B     @RC00441                                            0443
@RF00441 TM    VCBINSTG(VCBPTR),B'00010000'                        0443
         BNZ   @RF00443                                            0443
*       PCBFREAL='1'B;              /* SET THE FREE REAL BIT         */
*                                                                  0444
         OI    PCBFREAL(PCBPTR),B'10000000'                        0444
*   /*****************************************************************/
*   /*                                                               */
*   /* PCB TRACE                                             @Z40WPYC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0445
*   GEN REFS(R1,PCBPTR,VAMSIMO) SETS(R1,PCB);                      0445
*                                                                  0445
@RF00443 DS    0H                                                  0445
@RC00441 DS    0H                                                  0445
*                                               /* @Z40WPYC*/
TRACEZV1 EQU   *         INDICATE MOVEOUT PCB @Z40WPYC
         B     *+16      BRANCH AROUND PCB TRACE @Z40WPYC
         L     R1,68(PCBPTR) GET CURRENT COUNT @Z40WPYC
         AL    R1,VAMSIMO INCREMENT BY 1 @Z40WPYC
         ST    R1,68(PCBPTR) STORE NEW COUNT @Z40WPYC
*   /*****************************************************************/
*   /*                                                               */
*   /* UPDATE COUNTS, AND SEND PCB TO PROPER QUEUE                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0446
*   PVTVAMO=PVTVAMO+1;              /* UPDATE VIO PAGE OUT COUNT     */
         LA    @12,1                                               0446
         L     @11,PVTVAMO(,PVTPTR)                                0446
         ALR   @11,@12                                             0446
         ST    @11,PVTVAMO(,PVTPTR)                                0446
*   OUXBVAMO=OUXBVAMO+1;            /* UPDATE LOCAL AREA VIO PAGE OUT
*                                      COUNT                         */
         L     @11,ASCBPTR                                         0447
         L     @11,OUXBPTR(,@11)                                   0447
         AL    @12,OUXBVAMO(,@11)                                  0447
         ST    @12,OUXBVAMO(,@11)                                  0447
*   R0=PCBLIOQN;                    /* SEND PCB TO LOCAL QUEUE       */
         LA    R0,136                                              0448
*   R1=PCBPTR;                      /* LOAD PCB ADDRESS FOR PCB    0449
*                                      MANAGER                       */
         LR    R1,PCBPTR                                           0449
*   CALL IEAVPCB;                   /* SEND PCB TO PROPER QUEUE      */
         L     @15,PVTPCB(,PVTPTR)                                 0450
         BALR  @14,@15                                             0450
*   RFY                                                            0451
*    (R0,                                                          0451
*     R1,                                                          0451
*     PCBPTR) UNRSTD;                                              0451
*                                                                  0451
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR NON-DISCONNECT OPTION                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0452
*   IF VCBNDISC='1'B THEN           /* IF THE NON-DISCONNECT OPTION
*                                      WAS SPECIFIED                 */
         TM    VCBNDISC(VCBPTR),B'00001000'                        0452
         BNO   @RF00452                                            0452
*     DO;                                                          0453
*CONNECT:                                                          0454
*       XPTLPID=VCBLPID;            /* LOAD THE LOGICAL PAGE ID      */
CONNECT  MVC   XPTLPID(8,XPTEPTR),VCBLPID(VCBPTR)                  0454
*       XPTXAV='1'B;                /* SET THE AUX ASSIGNED FLAG     */
*       XPTVIOLP='1'B;              /* SET THE SAVE AUX FLAG @Z40WPYC*/
*                                                                  0456
         OI    XPTXAV(XPTEPTR),B'11000000'                         0456
*       /*************************************************************/
*       /*                                                           */
*       /* CLEAR FLAGS NORMALLY CLEARED BY ASM BUT NOT FOR MOVEOUTS  */
*       /* OR TRANSFER PAGE OPERATIONS.                      @Z40WPYC*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0457
*       XPTPOINP='0'B;              /* CLEAR PAGEOUT IN PROCESS FLAG
*                                                            @Z40WPYC*/
*       XPTIOERR='0'B;              /* CLEAR I/O ERROR FLAG  @Z40WPYC*/
*       XPTVALID='0'B;              /* CLEAR LSID VALID FLAG @Z40WPYC*/
         NI    XPTPOINP(XPTEPTR),B'01001111'                       0459
*       VCBRSN=0;                   /* CLEAR THE RSN                 */
         SLR   @12,@12                                             0460
         STH   @12,VCBRSN(,VCBPTR)                                 0460
*       GOTO MORRTN;                /* GOING BACK TO CALLER, MOVE OUT
*                                      COMPLETE                      */
         B     MORRTN                                              0461
*     END;                                                         0462
*   IF VCBDSPID=0 THEN              /* IF NO RECLAIM I D WAS SUPPLIED*/
@RF00452 SLR   @12,@12                                             0463
         CL    @12,VCBDSPID(,VCBPTR)                               0463
         BNE   @RF00463                                            0463
*     VCBRSN=0;                     /* RESET THE RSN                 */
         STH   @12,VCBRSN(,VCBPTR)                                 0464
*   ELSE                            /* IF RECLAIM ID WAS SUPPLIED    */
*     DO;                           /* IF RECLAIM I D WAS SUPPLIED   */
         B     @RC00463                                            0465
@RF00463 DS    0H                                                  0466
*       PFTIRRG='1'B;               /* INDICATE A VIO FRAME          */
         OI    PFTIRRG(PFTEPTR),B'00010000'                        0466
*       PFTPGID=VCBDSPID;           /* STORE DATASET I D IN PFTE     */
         L     @12,VCBDSPID(,VCBPTR)                               0467
         ST    @12,PFTPGID(,PFTEPTR)                               0467
*       VCBRSN=PGTRSA&RSNMASK;      /* STORE THE REAL STORAGE NUMBER */
         L     @12,@CF02042                                        0468
         SLR   @11,@11                                             0468
         ICM   @11,3,PGTRSA(PTEPTR)                                0468
         NR    @12,@11                                             0468
         STH   @12,VCBRSN(,VCBPTR)                                 0468
*     END;                                                         0469
*   GOTO CLRPGTE;                   /* GOING TO CLEAN UP TABLES AND
*                                      RETURN                        */
         B     CLRPGTE                                             0470
*                                                                  0471
*   /*****************************************************************/
*   /*                                                               */
*   /* TCHGBIT -- THIS CODE TESTS THE CHANGE BIT TO SEE IF A PAGE HAS*/
*   /* BEEN CHANGED IN REAL STORAGE. IF A CHANGE HAS TAKEN PLACE AND */
*   /* AUX IS ASSIGNED, RELEASE PAGE MUST BE CALLED AND CONTROL      */
*   /* TRANSFERED TO PAGEOUT. IF NO CHANGE IS INDICATED AND THE AUX  */
*   /* ASSIGNED BIT IS OFF, THE VCBNOAUX FLAG IS SET. IF THE         */
*   /* NON-DISCONNECT OPTION WAS SPECIFIED THE VCBRSN IS CLEARED AND */
*   /* CONTROL RETURNS TO THE CALLER. IF NON-DISCONNECT WAS NOT SET, */
*   /* INVALIDATION MUST TAKE PLACE AND CONTROL XFERS TO NORECLM. -- */
*   /* ELSE -- IF AUX STORAGE WAS ASSIGNED THE PAGE IS TRANSFERED BY */
*   /* THE ILRCALL MACRO. IF THE NON-DISCONNECT OPTION IS IN EFFECT  */
*   /* CONTROL IS TRANSFERED TO THE LABEL CONNECT IN THE PAGEOUT     */
*   /* CODE. IF NOT THE NON-DISCONNECT OPTION IEAVINV IS CALLED TO   */
*   /* INVALIDATE THE PAGE. IF THE DATASET PAGE I D IN THE VCB IS    */
*   /* ZERO, CONTROL TRANSFERS TO NORECLM, BUT IF A PAGE I D WAS     */
*   /* SUPPLIED CONTROL TRANSFERS TO RECLAIM.                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0471
*TCHGBIT:                                                          0471
*   RFY                                                            0471
*    (TESTPTR) RSTD;                                               0471
TCHGBIT  DS    0H                                                  0472
*   TESTPTR=PGTRSA;                 /* LOAD TEST POINTER FOR CHANGE
*                                      BIT TEST                      */
         SLR   TESTPTR,TESTPTR                                     0472
         ICM   TESTPTR,3,PGTRSA(PTEPTR)                            0472
*   GENERATE REFS(TESTPTR);                                        0473
      SRL   TESTPTR,4(0)           CLEAR THE FLAGS
      SLL   TESTPTR,12(0)          ADJUST TO A REAL ADDRESS
      RRB   0(TESTPTR)             TEST CHANGE BIT
*   BC(5,CKAUX);                    /* IF PAGE CHANGED, GOING TO   0474
*                                      CHECK AUX                     */
         BC    5,CKAUX                                             0474
*   GENERATE REFS(TESTPTR);                                        0475
      RRB   2048(TESTPTR)          TEST CHANGE BIT IN 2ND HALF BLOCK
*   BC(10,NOCHG);                   /* IF PAGE DID NOT CHANGE, GOING
*                                      TO NO CHANGE                  */
         BC    10,NOCHG                                            0476
*   RFY                                                            0477
*    (TESTPTR) UNRSTD;                                             0477
*                                                                  0477
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS CODE EXECUTES WHEN IT IS FOUND THAT A CHANGE OCCURED     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0478
*CKAUX:                                                            0478
*   IF XPTXAV='1'B THEN             /* IF AUX STORAGE IS ASSIGNED  0478
*                                      FREE THE LSID. GOT HERE     0478
*                                      BECAUSE XPTXAV=0 OR         0478
*                                      XPTVIOLP=0. THEREFORE IF    0478
*                                      XPTXAV=1 THEN XPTVIOLP=0 AND
*                                      CURRENT OCCUPANT OF XPTE IS AN
*                                      LSID.                 @Z40WPYC*/
CKAUX    TM    XPTXAV(XPTEPTR),B'01000000'                         0478
         BNO   @RF00478                                            0478
*     CALL RELEASEP;                /* CALL FOR AUX RELEASE          */
         BAL   @14,RELEASEP                                        0479
*   GOTO PAGEOUT;                   /* GOING TO THE PAGE OUT ROUTINE */
         B     PAGEOUT                                             0480
*                                                                  0481
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS CODE EXECUTES WHEN IT IS FOUND THAT NO CHANGE OCCURED.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0481
*NOCHG:                                                            0481
*   IF XPTXAV='0'B THEN             /* IF AUX STORAGE IS NOT ASSIGNED*/
NOCHG    TM    XPTXAV(XPTEPTR),B'01000000'                         0481
         BNZ   @RF00481                                            0481
*     DO;                                                          0482
*       VCBNOAUX='1'B;              /* SET NO AUX ASSIGNED BIT IN VCB*/
         OI    VCBNOAUX(VCBPTR),B'00010000'                        0483
*       IF VCBNDISC='1'B THEN       /* IF THE NON-DISCONNECT OPTION
*                                      WAS SET                       */
         TM    VCBNDISC(VCBPTR),B'00001000'                        0484
         BNO   @RF00484                                            0484
*         DO;                                                      0485
*           VCBRSN=0;               /* SET REAL STORAGE NUMBER TO  0486
*                                      ZERO                          */
         SLR   @12,@12                                             0486
         STH   @12,VCBRSN(,VCBPTR)                                 0486
*           GOTO MORRTN;            /* GOING TO RETUTN               */
         B     MORRTN                                              0487
*         END;                                                     0488
*       RFY                                                        0489
*        (R1) RSTD;                                                0489
@RF00484 DS    0H                                                  0490
*       R1=PTEPTR;                  /* LOAD PAGE TABLE POINTER FOR 0490
*                                      INVALIDATE CALL               */
         LR    R1,PTEPTR                                           0490
*       CALL IEAVINV;               /* CALL FOR INVALIDATION         */
         L     @15,PVTPINV(,PVTPTR)                                0491
         BALR  @14,@15                                             0491
*       RFY                                                        0492
*        (R1) UNRSTD;                                              0492
*     END;                                                         0493
*                                                                  0493
*   /*****************************************************************/
*   /*                                                               */
*   /* ELSE -- NO CHANGE OCCURED AND AUX STORAGE WAS ASSIGNED.       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0494
*   ELSE                                                           0494
*     DO;                                                          0494
         B     @RC00481                                            0494
@RF00481 DS    0H                                                  0495
*       CALL XFERP;                 /* CALL FOR AUX TRANSFER         */
         BAL   @14,XFERP                                           0495
*       IF RETCODR^=0 THEN          /* IF PAGE TRANSFER WAS NOT    0496
*                                      SUCCESSFUL                    */
         LTR   RETCODR,RETCODR                                     0496
         BZ    @RF00496                                            0496
*         DO;                                                      0497
*           IF RETCODR=4 THEN       /* IF THE SOURCE WAS INVALID     */
         C     RETCODR,@CF00053                                    0498
         BNE   @RF00498                                            0498
*             DO;                                                  0499
*               RCARCRD='04'X;      /* SET RECOVERY CODE             */
         L     @12,RCAPTR(,PVTPTR)                                 0500
         MVI   RCARCRD(@12),X'04'                                  0500
*               GENERATE SETS(R1);                                 0501
      ABEND X'C0D',,,SYSTEM        LOG THE ERROR
*               GOTO PAGEOUT;       /* GOING TO DO A PAGEOUT         */
         B     PAGEOUT                                             0502
*             END;                                                 0503
*           VCBELPID='1'B;          /* SET THE LPID ERROR FLAG IN THE
*                                      VCB                           */
@RF00498 OI    VCBELPID(VCBPTR),B'00100000'                        0504
*           RETCODR=4;              /* SET THE ERROR CODE            */
         LA    RETCODR,4                                           0505
*           GOTO MOERRTN;           /* GOING TO ERROR HANDLING     0506
*                                      ROUTINE                       */
         B     MOERRTN                                             0506
*         END;                                                     0507
*       IF VCBNDISC='1'B THEN       /* IF THE NON-DISCONNECT OPTION
*                                      IS SET                        */
@RF00496 TM    VCBNDISC(VCBPTR),B'00001000'                        0508
         BO    @RT00508                                            0508
*         GOTO CONNECT;             /* GOING TO SET UP XPTE          */
*       RFY                                                        0510
*        (R1) RSTD;                                                0510
*       R1=PTEPTR;                  /* LOAD PAGE TABLE ADDRESS FOR 0511
*                                      INVALIDATE                    */
         LR    R1,PTEPTR                                           0511
*       CALL IEAVINV;               /* CALL FOR INVALIDATION         */
         L     @15,PVTPINV(,PVTPTR)                                0512
         BALR  @14,@15                                             0512
*       RFY                                                        0513
*        (R1) UNRSTD;                                              0513
*       IF VCBDSPID^=0 THEN         /* IF DATASET PAGE I D WAS     0514
*                                      SUPPLIED                      */
         L     @12,VCBDSPID(,VCBPTR)                               0514
         LTR   @12,@12                                             0514
         BNZ   @RT00514                                            0514
*         GOTO RECLAIM;             /* GO TO RECLAIM IN THE NULLMOVE
*                                      CODE                          */
*     END;                                                         0516
*   GOTO NORECLM;                   /* GO TO NORECLM IN THE NULLMOVE
*                                      CODE                          */
         B     NORECLM                                             0517
*                                                                  0518
*   /*****************************************************************/
*   /*                                                               */
*   /* NULLMOVE -- THIS IS THE NULLMOVE CODE FOR THE MOVEOUT         */
*   /* SUB-ROUTINE. THE PAGE IS IMMEDIATELY INVALIDATED. IF SAVE AUX */
*   /* IS NOT SET AND AUX IS ASSIGNED, THE PAGE MUST BE RELEASED, AND*/
*   /* NO RECLAIM IS ATTEMPTED. IF SAVE AUX IS SET AND A PAGE I D WAS*/
*   /* SUPPLIED A TEST IS MADE TO SEE IF THE PAGE HAS CHANGED, AND IF*/
*   /* NOT, A RECLAIM IS MADE. IF THE IN-STORAGE OPTION WAS SPECIFIED*/
*   /* CONTROL TRANSFERS TO CLRPGTE, OTHERWISE THE PFTE MUST FIRST BE*/
*   /* SENT TO THE AFQ. IF NO PAGE I D WAS SUPPLIED, NO RECLAIM IS   */
*   /* POSSIBLE, AND THE FRAME IS SENT TO THE AFQ. FOR ALL CASES     */
*   /* WHERE THE PFTE IS MOVED, THE APPROPRIATE FRAME COUNT IS       */
*   /* DECREMENTED AND CONTROL TRANSFERS TO CLRPGTE FOR CLEANUP      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0518
*NULLMOVE:                                                         0518
*   RFY                                                            0518
*    (R1) RSTD;                                                    0518
NULLMOVE DS    0H                                                  0519
*   R1=PTEPTR;                      /* LOAD PARAMETER FOR INVALIDATE
*                                      ROUTINE                       */
         LR    R1,PTEPTR                                           0519
*   CALL IEAVINV;                   /* CALL FOR INVALIDATION         */
         L     @15,PVTPINV(,PVTPTR)                                0520
         BALR  @14,@15                                             0520
*   RFY                                                            0521
*    (R1) UNRSTD;                                                  0521
*   IF XPTVIOLP='0'B THEN           /* IF SAVE AUX FLAG IS NOT SET 0522
*                                                            @Z40WPYC*/
         TM    XPTVIOLP(XPTEPTR),B'10000000'                       0522
         BNZ   @RF00522                                            0522
*     DO;                                                          0523
*       IF XPTXAV='1'B THEN         /* IF AUX IS ASSIGNED            */
         TM    XPTXAV(XPTEPTR),B'01000000'                         0524
         BNO   @RF00524                                            0524
*         CALL RELEASEP;            /* CALL FOR PAGE RELEASE         */
         BAL   @14,RELEASEP                                        0525
*       GOTO NORECLM;               /* RECLAIM IS NOT POSSIBLE       */
         B     NORECLM                                             0526
*     END;                                                         0527
*   IF VCBDSPID^=0 THEN             /* IF A PAGE I D WAS SUPPLIED    */
@RF00522 L     @12,VCBDSPID(,VCBPTR)                               0528
         LTR   @12,@12                                             0528
         BZ    @RF00528                                            0528
*     DO;                                                          0529
*       RFY                                                        0530
*        (TESTPTR) RSTD;                                           0530
*       TESTPTR=PGTRSA;             /* LOAD FOR CHANGE BIT TEST      */
         SLR   TESTPTR,TESTPTR                                     0531
         ICM   TESTPTR,3,PGTRSA(PTEPTR)                            0531
*       GENERATE REFS(TESTPTR);                                    0532
      SRL   TESTPTR,4(0)           CLEAR THE FLAGS
      SLL   TESTPTR,12(0)          ADJUST TO A REAL ADDRESS
      RRB   0(TESTPTR)             TEST CHANGE BIT
*       BC(5,NORECLM);              /* IF PAGE CHANGED, GOING TO NO
*                                      RECLAIM CODE                  */
         BC    5,NORECLM                                           0533
*       GENERATE REFS(TESTPTR);                                    0534
      RRB   2048(TESTPTR)          TEST CHANGE BIT IN 2ND HALF BLOCK
*       BC(5,NORECLM);              /* IF PAGE CHANGED, GOING TO NO
*                                      RECLAIM CODE                  */
         BC    5,NORECLM                                           0535
*                                                                  0536
*       /*************************************************************/
*       /*                                                           */
*       /* A DATA SET I D WAS SUPPLIED, SAVE AUX WAS SPECIFIED, AND  */
*       /* THE PAGE HAS NOT CHANGED, SO THE FRAME WILL BE MARKED AS A*/
*       /* VIO FRAME (PFTIRRG). IF THE IN-STORAGE OPTION WAS NOT     */
*       /* REQUESTED, THE FRAME WILL THEN GO TO THE END OF THE       */
*       /* AVAILABLE FRAME QUEUE.                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0536
*RECLAIM:                                                          0536
*       RFY                                                        0536
*        (TESTPTR) UNRSTD;                                         0536
RECLAIM  DS    0H                                                  0537
*       PFTIRRG='1'B;               /* SET THE VIO FRAME FLAG        */
         OI    PFTIRRG(PFTEPTR),B'00010000'                        0537
*       PFTPGID=VCBDSPID;           /* SET PFTE PAGE I D             */
         L     @12,VCBDSPID(,VCBPTR)                               0538
         ST    @12,PFTPGID(,PFTEPTR)                               0538
*       VCBRSN=PGTRSA&RSNMASK;      /* SET REAL STORAGE NUMBER IN  0539
*                                      VCB, STRIPPING FLAG BITS      */
         L     @12,@CF02042                                        0539
         SLR   @11,@11                                             0539
         ICM   @11,3,PGTRSA(PTEPTR)                                0539
         NR    @12,@11                                             0539
         STH   @12,VCBRSN(,VCBPTR)                                 0539
*       IF VCBINSTG='1'B THEN       /* IF IN STORAGE OPTION WAS    0540
*                                      SPECIFIED                     */
         TM    VCBINSTG(VCBPTR),B'00010000'                        0540
         BO    @RT00540                                            0540
*         GOTO CLRPGTE;             /* GOING TO CLEAN UP TABLES AND
*                                      RETURN                        */
*       RFY                                                        0542
*        (R0,                                                      0542
*         R1) RSTD;                                                0542
*                                                                  0542
*       /*************************************************************/
*       /*                                                           */
*       /* --NOTE-- THIS PARAMETER IS VALID ONLY AS LONG AS THE AFQ  */
*       /* NUMBER REMAINS EQUAL TO X 00.                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0543
*       R0=PGTRSA&RSNMASK;          /* LOAD THE PARM REG FOR PFTE MGR
*                                      -NOTE-                        */
         LR    R0,@12                                              0543
*       R1=ASCBPTR;                 /* LOAD FOR PFTE CALL            */
         L     R1,ASCBPTR                                          0544
*       CALL IEAVPFTE;              /* CALL PFTE MGR TO QUE PFTE     */
         L     @15,PVTPFTE(,PVTPTR)                                0545
         BALR  @14,@15                                             0545
*     END;                                                         0546
*   ELSE                            /* IF NO PAGE I D WAS SUPPLIED   */
*     DO;                                                          0547
*                                                                  0547
         B     @RC00528                                            0547
@RF00528 DS    0H                                                  0548
*       /*************************************************************/
*       /*                                                           */
*       /* NO DATA SET PAGE I D WAS SUPPLIED, SAVE AUX WAS NOT       */
*       /* SPECIFIED, OR THE PAGE CHANGED, SO THE FRAME WILL GO TO   */
*       /* THE FRONT OF THE AVAILABLE FRAME QUEUE.                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0548
*NORECLM:                                                          0548
*       VCBRSN=0;                   /* SET VCBRSN TO ZERO TO INDICATE
*                                      RECLAIM OF THIS FRAME IS NOT
*                                      POSSIBLE.                     */
NORECLM  SLR   @12,@12                                             0548
         STH   @12,VCBRSN(,VCBPTR)                                 0548
*       QRBN=PGTRSA&RSNMASK;        /* REAL STORAGE NUMBER FOR PFTE
*                                      MGR                           */
         L     @12,@CF02042                                        0549
         SLR   @11,@11                                             0549
         ICM   @11,3,PGTRSA(PTEPTR)                                0549
         NR    @12,@11                                             0549
         STH   @12,QRBN(,PVTPTR)                                   0549
*       QHEADFLG=QHEADBIT;          /* INDICATE FRONT OF QUE         */
         MVI   QHEADFLG(PVTPTR),X'80'                              0550
*       QINDEX=PFTAFQN;             /* SEND PFTE TO AVAILABLE FRAME
*                                      QUE                           */
         MVI   QINDEX(PVTPTR),X'00'                                0551
*       R0=PARMBLD;                 /* LOAD THE PARM REG FOR PFTE MGR*/
         L     R0,PARMBLD(,PVTPTR)                                 0552
*       R1=ASCBPTR;                 /* LOAD FOR PSI CALL             */
         L     R1,ASCBPTR                                          0553
*       CALL IEAVPFTE;              /* CALL PFTE MGR TO QUE PFTE     */
         L     @15,PVTPFTE(,PVTPTR)                                0554
         BALR  @14,@15                                             0554
*       RFY                                                        0555
*        (R0,                                                      0555
*         R1,                                                      0555
*         R13) UNRSTD;                                             0555
*     END;                                                         0556
*   RFY                                                            0557
*    (PFTEPTR) UNRSTD;                                             0557
@RC00528 DS    0H                                                  0558
*                                                                  0558
*   /*****************************************************************/
*   /*                                                               */
*   /* CLRPGTE -- THIS CODE CLEARS THE PAGE TABLE ENTRY WITH THE     */
*   /* EXCEPTION OF THE GETMAIN ASSIGNED BIT AND THE INVALID BIT. THE*/
*   /* AUX ASSIGNED AND SAVE AUX BITS ARE RESET AND THE LPID IS      */
*   /* CLEARED. CONTROL THEN RETURNS TO THE CALLER OF THE MOVEOUT    */
*   /* SUB-ROUTINE, VAMSI.                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0558
*CLRPGTE:                                                          0558
*   PGTPTE=RESETHWD;                /* CLEAR THE PAGE TABLE ENTRY  0558
*                                      LEAVING GETMAIN ASSIGNED AND
*                                      INVALID BITS ON               */
CLRPGTE  MVC   PGTPTE(2,PTEPTR),@CB02048                           0558
*   XPTXAV='0'B;                    /* RESET THE AUX ASSIGNED FLAG   */
*   XPTVIOLP='0'B;                  /* RESET THE SAVE AUX FLAG     0560
*                                                            @Z40WPYC*/
         NI    XPTXAV(XPTEPTR),B'00111111'                         0560
*   XPTLPID=''B;                    /* CLEAR THE LPID        @Z40WPYC*/
         XC    XPTLPID(8,XPTEPTR),XPTLPID(XPTEPTR)                 0561
*   XPTVALID='0'B;                  /* MARK LSID AS INVALID  @Z40WPYC*/
*   XPTIOERR='0'B;                  /* CLEAR I/O ERROR FLAG IN CASE
*                                      WAS SET ON DURING LAST PAGE-IN
*                                      BY ASM. THIS IS NORMALLY DONE
*                                      BY ASM EXCEPT FOR VIO       0563
*                                      MOVEOUTS.             @Z40WPYC*/
*   XPTPOINP='0'B;                  /* CLEAR PAGEOUT IN PROCESS FLAG.
*                                      AGAIN THIS WOULD NORMALLY BE
*                                      DONE BY ASM           @Z40WPYC*/
*                                                                  0564
         NI    XPTVALID(XPTEPTR),B'01001111'                       0564
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVEOUT SUB-ROUTINE RETURN POINT                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0565
*   RFY                                                            0565
*    (R14) RSTD;                                                   0565
*MORRTN:                                                           0566
*   RETCODR=0;                      /* SET THE RETURN CODE,        0566
*                                      SUCCESSFUL MOVE OUT           */
MORRTN   SLR   RETCODR,RETCODR                                     0566
*MOERRTN:                                                          0567
*   R14=SUBRETWD;                   /* RESTORE THE RETURN ADDRESS    */
MOERRTN  L     R14,SUBRETWD(,PVTPTR)                               0567
*   RFY                                                            0568
*    (PTEPTR,                                                      0568
*     XPTEPTR,                                                     0568
*     R14) UNRSTD;                                                 0568
*   END MOVEOUT;                                                   0569
@EL00003 DS    0H                                                  0569
@EF00003 DS    0H                                                  0569
@ER00003 BR    @14                                                 0569
*                                                                  0570
*   /*****************************************************************/
*   /*                                                               */
*   /* OUTOFSTG -- THE OUT OF STORAGE SUB-ROUTINE OF VAMSI. THIS     */
*   /* ROUTINE IS CALLED BY THE MOVEOUT SUB-ROUTINE IF A PAGE IS     */
*   /* INVALID WHEN A MOVEOUT WAS REQUESTED, AND RETURNS DIRECTLY TO */
*   /* VAMSI. THE PTEPTR AND XPTEPTR ARE PASSED TO THIS ROUTINE WHEN */
*   /* ENTRY IS MADE. IF THE NON-DISCONNECT OPTION WAS REQUESTED AND */
*   /* A LOGICAL PAGE I D WAS SUPPLIED THE AUX ASSIGNED BIT IS TESTED*/
*   /* FOR BEING ON. IF SET THE SAVE AUX BIT IS TESTED FOR BEING OFF.*/
*   /* WHEN THESE TWO CONDITIONS ARE MET THE PAGE IS TRANSFERED VIA  */
*   /* THE ILRCALL MACRO. IF SAVE AUX WAS REQUESTED, THE VCB AND XPTE*/
*   /* LOGICAL PAGE I D'S ARE TESTED FOR BEING EQUAL. IF THEY DO NOT */
*   /* MATCH AN ERROR IS SIGNALED AND AN ERROR RETURN MADE. IF EQUAL,*/
*   /* THE VCBRSN IS RESET AND A NORMAL RETURN IS MADE.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0570
*OUTOFSTG:                                                         0570
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0570
*                                                                  0570
OUTOFSTG DS    0H                                                  0571
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR NON-DISCONNECT OPTION                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0571
*   RFY                                                            0571
*    (PTEPTR,                                                      0571
*     XPTEPTR) RSTD;                                               0571
*   IF VCBNDISC='1'B&(MYVCBLGN^=0|MYVCBLPN^=0) THEN/* IF LPID WAS  0572
*                                      SUPPLIED AND THE            0572
*                                      NON-DISCONNECT OPTION IS    0572
*                                      SPECIFIED                     */
         TM    VCBNDISC(VCBPTR),B'00001000'                        0572
         BNO   @RF00572                                            0572
         SLR   @14,@14                                             0572
         CL    @14,MYVCBLGN(,VCBPTR)                               0572
         BNE   @RT00572                                            0572
         CL    @14,MYVCBLPN(,VCBPTR)                               0572
         BE    @RF00572                                            0572
@RT00572 DS    0H                                                  0573
*     DO;                                                          0573
*       IF XPTXAV='1'B THEN         /* IF AUX STORAGE IS ASSIGNED    */
         TM    XPTXAV(XPTEPTR),B'01000000'                         0574
         BNO   @RF00574                                            0574
*         DO;                                                      0575
*           IF XPTVIOLP='0'B THEN   /* IF THE SAVE AUX FLAG IS NOT 0576
*                                      SET                   @Z40WPYC*/
         TM    XPTVIOLP(XPTEPTR),B'10000000'                       0576
         BNZ   @RF00576                                            0576
*             DO;                                                  0577
*               CALL XFERP;         /* CALL FOR AUX TRANSFER         */
         BAL   @14,XFERP                                           0578
*               IF RETCODR^=0 THEN  /* IF TRANSFER WAS UNSUCCESSFUL  */
         LTR   RETCODR,RETCODR                                     0579
         BNZ   @RT00579                                            0579
*                 GOTO IDERROR;     /* GOING TO RETURN FOR ERROR     */
*               XPTLPID=VCBLPID;    /* UPDATE THE LOGICAL PAGE I D   */
         MVC   XPTLPID(8,XPTEPTR),VCBLPID(VCBPTR)                  0581
*               XPTVIOLP='1'B;      /* MARK THE XPTE AS SAVE AUX   0582
*                                                            @Z40WPYC*/
*                                                                  0582
         OI    XPTVIOLP(XPTEPTR),B'10000000'                       0582
*               /*****************************************************/
*               /*                                                   */
*               /* CLEAR FLAGS NORMALLY CLEARED BY ASM BUT NOT FOR   */
*               /* VIO MOVEOUTS OR TRANSFER PAGE OPERATIONS. @Z40WPYC*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0583
*               XPTVALID='0'B;      /* CLEAR LSID VALID FLAG @Z40WPYC*/
*               XPTIOERR='0'B;      /* CLEAR I/O ERROR FLAG  @Z40WPYC*/
*               XPTPOINP='0'B;      /* CLEAR PAGEOUT IN OPER FLAG  0585
*                                                            @Z40WPYC*/
         NI    XPTVALID(XPTEPTR),B'01001111'                       0585
*             END;                                                 0586
*           ELSE                    /* IF SAVE AUX WAS SPECIFIED     */
*             IF VCBLPID^=XPTLPID THEN/* IF NO LOGICAL PAGE MATCH    */
         B     @RC00576                                            0587
@RF00576 CLC   VCBLPID(8,VCBPTR),XPTLPID(XPTEPTR)                  0587
         BE    @RF00587                                            0587
*               DO;                                                0588
*IDERROR:                                                          0589
*                 VCBELPID='1'B;    /* MARK THE VCB AS AN LPID ERROR */
IDERROR  OI    VCBELPID(VCBPTR),B'00100000'                        0589
*                 RETCODR=4;        /* SET THE ERROR RETURN CODE     */
         LA    RETCODR,4                                           0590
*                 GOTO OUTERRTN;    /* GOING TO THE ERROR RETURN CODE*/
         B     OUTERRTN                                            0591
*               END;                                               0592
*         END;                                                     0593
*       ELSE                        /* IF NO AUX STORAGE WAS ASSIGNED*/
*         VCBNOAUX='1'B;            /* SET THE VCB NO AUX FLAG       */
         B     @RC00574                                            0594
@RF00574 OI    VCBNOAUX(VCBPTR),B'00010000'                        0594
*       VCBRSN=0;                   /* NO REAL STORAGE EXISTS        */
@RC00574 SLR   @14,@14                                             0595
         STH   @14,VCBRSN(,VCBPTR)                                 0595
*       GOTO OUTRTN;                /* FINISHED PROCESSING, GOING  0596
*                                      BACK                          */
         B     OUTRTN                                              0596
*     END;                                                         0597
*                                                                  0598
*   /*****************************************************************/
*   /*                                                               */
*   /* PCBSRCH -- THIS CODE CONSTITUTES THE PCB SEARCH CODE OF THE   */
*   /* OUTOFSTG SUB-ROUTINE. IF THE NON-DISCONNECT OPTION WAS NOT    */
*   /* SPECIFIED, OR IF NO LOGICAL PAGE I D WAS SUPPLIED, THIS CODE  */
*   /* WILL SEARCH THE QUEUES FOR THE PCB FOR THE PAGE TO BE MOVED   */
*   /* OUT. IF THE DEFER OR FORCE RELATE FLAGS ARE ON, THE GFA DEFER */
*   /* QUEUE IS SEARCHED FIRST. IF THE CORRECT PCB IS NOT FOUND THE  */
*   /* IO QUEUE WILL THEN BE SEARCHED. IF BOTH DEFER AND FREE REAL   */
*   /* WERE OFF, THE GFA QUEUE IS NOT SEARCHED. IF THE CORRECT PCB   */
*   /* CANNOT BE FOUND, CONTROL WILL TRANSFER TO THE AUXTEST CODE,   */
*   /* ELSE WHEN THE PCB IS FOUND (VBN MATCH AND IF A LOCAL PAGE AN  */
*   /* ADDRESS SPACE MATCH) A CHECK IS MADE TO DETERMINE WHICH QUEUE */
*   /* THE PCB IS ON. IF ON THE GFA QUEUE, CONTROL PASSES TO GFADEFR,*/
*   /* OTHERWISE THE VBN IS ZEROED AND THE FREE REAL FLAG IS TURNED  */
*   /* ON IN ALL THE PCBS (REGULAR AND ALL RELATEDS).                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0598
*PCBSRCH:                                                          0598
*   IF XPTDEFER='1'B THEN           /* IF THE DEFER FLAG IS ON     0598
*                                                            @Z40WPYC*/
@RF00572 DS    0H                                                  0598
PCBSRCH  TM    XPTDEFER(XPTEPTR),B'00000010'                       0598
         BNO   @RF00598                                            0598
*     DO;                                                          0599
*       RFY                                                        0600
*        (GFASW,                                                   0600
*         PCBPTR) RSTD;                                            0600
*       GFASW='01'X;                /* INDICATE SEARCHING GFAQ-A   0601
*                                      SWITCH                        */
         LA    GFASW,1                                             0601
*       PCBPTR=PVTGFADF;            /* GET PCB FROM DEFER QUE        */
         L     PCBPTR,PVTGFADF(,PVTPTR)                            0602
*     END;                                                         0603
*   ELSE                                                           0604
*     DO;                                                          0604
         B     @RC00598                                            0604
@RF00598 DS    0H                                                  0605
*IOQSRCH:                                                          0605
*       PCBPTR=RSMLIOQF;            /* GET FIRST PCB ON LOCAL QUE    */
IOQSRCH  L     PCBPTR,RSMLIOQF(,RSMHDPTR)                          0605
*       GFASW='00'X;                /* INDICATE SEARCHING I0 QUE - A
*                                      SWITCH                        */
         SLR   GFASW,GFASW                                         0606
*     END;                                                         0607
*PCBLOOP:                                                          0608
*   IF PCBPTR=0 THEN                /* IF AT THE END OF THE CHAIN,   */
@RC00598 DS    0H                                                  0608
PCBLOOP  LTR   PCBPTR,PCBPTR                                       0608
         BNZ   @RF00608                                            0608
*     IF GFASW='01'X THEN           /* AND WE JUST SEARCHED THE GFA
*                                      QUE                           */
         C     GFASW,@CF01765                                      0609
         BE    @RT00609                                            0609
*       GOTO IOQSRCH;               /* SEARCH THE IO QUE             */
*     ELSE                          /* IF WE JUST SEARCHED THE IO QUE*/
*       GOTO AUXTEST;               /* LEAVE THE ROUTINE, GOING TO 0611
*                                      AUX STORAGE TEST ROUTINE      */
         B     AUXTEST                                             0611
*   IF PCBVBN^=CURVSNR|PCBASCB^=PSAAOLD THEN/* IF VBNS DO NOT MATCH,
*                                      OR IF PAGE IS NOT FOR THIS  0612
*                                      ADDRESS SPACE         @Z40WPYC*/
@RF00608 LH    @14,PCBVBN(,PCBPTR)                                 0612
         N     @14,@CF02294                                        0612
         CLR   CURVSNR,@14                                         0612
         BNE   @RT00612                                            0612
         CLC   PCBASCB(4,PCBPTR),PSAAOLD                           0612
         BE    @RF00612                                            0612
@RT00612 DS    0H                                                  0613
*     DO;                                                          0613
*       PCBPTR=PCBFQPA;             /* GET NEXT PCB ON CHAIN         */
         L     @14,PCBFQPA-1(,PCBPTR)                              0614
         LA    @14,0(,@14)                                         0614
         LR    PCBPTR,@14                                          0614
*       GOTO PCBLOOP;               /* TEST NEXT PCB                 */
         B     PCBLOOP                                             0615
*     END;                                                         0616
*                                                                  0616
*   /*****************************************************************/
*   /*                                                               */
*   /* FOUND THE PCB, DETERMINE QUEUE AND TRANSFER CONTROL IF ON THE */
*   /* GFA DEFER QUEUE                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0617
*   IF GFASW='01'X THEN             /* IF PCB WAS ON GFA QUE         */
@RF00612 C     GFASW,@CF01765                                      0617
         BE    @RT00617                                            0617
*     GOTO GFADEFR;                 /* GO TO THE GFA HANDLING ROUTINE*/
*   IF PCBIOI='0'B THEN             /* IF FOUND PCB IS INPUT @Z40WPYC*/
         TM    PCBIOI(PCBPTR),B'00000010'                          0619
         BNZ   @RF00619                                            0619
*     DO;                           /* DETERMINE STATE OF I/O      0620
*                                                            @Z40WPYC*/
*       IF PCBIOCMP='0'B THEN       /* IF INPUT NOT COMPLETE, SET BIT
*                                      SO AUXTEST SUBR. CAN SET    0621
*                                      AIAFRAUX              @Z40WPYC*/
         TM    PCBIOCMP(PCBPTR),B'00000001'                        0621
         BNZ   @RF00621                                            0621
*         PIINPROC='1'B;            /* SET BIT INDICATING PAGE-IN  0622
*                                                            @Z40WPYC*/
         OI    PIINPROC(PVTPTR),B'00000001'                        0622
*       ELSE                        /* I/O IS COMPLETE.      @Z40WPYC*/
*         GOTO SRCHRLTE;            /* BYPASS I/O IN PROCESS       0623
*                                      PROCESSING            @Z40WPYC*/
*     END;                          /* END OF INPUT PCB PROCESSING 0624
*                                                            @Z40WPYC*/
*   ELSE                            /* NOT PAGE-IN           @Z40WPYC*/
*     POINPROC='1'B;                /* INDICATE PAGE-OUT IN PROCESS
*                                                            @Z40WPYC*/
         B     @RC00619                                            0625
@RF00619 OI    POINPROC(PVTPTR),B'00000010'                        0625
*   IOSVAIA=ADDR(PCBAIA);           /* SAVE THE ADDRESS OF THE AIA 0626
*                                      FOR WHICH I/O IS OUTSTANDING
*                                                            @Z40WPYC*/
@RC00619 LA    @14,PCBAIA(,PCBPTR)                                 0626
         STCM  @14,7,IOSVAIA(PVTPTR)                               0626
*SRCHRLTE:                          /*                       @Z40WPYC*/
*   DO WHILE PCBPTR^=0;             /* LOOP DOWN RELATED CHAIN,    0627
*                                      RESETING THE VBN AND FREAL  0627
*                                      FLAG IN THE REGULAR PCB AND 0627
*                                      ALL THE RELATED PCBS          */
SRCHRLTE B     @DE00627                                            0627
@DL00627 DS    0H                                                  0628
*     PCBVBN=0;                     /* RESET THE VBN                 */
         SLR   @14,@14                                             0628
         STH   @14,PCBVBN(,PCBPTR)                                 0628
*     PCBFREAL='1'B;                /* SET THE FREE REAL FLAG        */
         OI    PCBFREAL(PCBPTR),B'10000000'                        0629
*     PCBPTR=PCBRLPA;               /* GET NEXT RELATED PCB          */
         L     @14,PCBRLPA-1(,PCBPTR)                              0630
         LA    @14,0(,@14)                                         0630
         LR    PCBPTR,@14                                          0630
*   END;                                                           0631
@DE00627 LTR   PCBPTR,PCBPTR                                       0631
         BNZ   @DL00627                                            0631
*   RFY                                                            0632
*    (GFASW) UNRSTD;                                               0632
*                                                                  0633
*   /*****************************************************************/
*   /*                                                               */
*   /* AUXTEST -- THIS IS THE AUXILIARY STORAGE ASSIGNMENT TEST OF   */
*   /* THE OUTOFSTG SUB-ROUTINE. IF NO AUX STORAGE IS ASSIGNED THE   */
*   /* VCBNOAUX FLAG IS SET AND PROCESSING CONTINUES AT THE LABEL    */
*   /* FINAL. IF AUX STORAGE IS ASSIGNED AND NO LOGICAL PAGE I D IS  */
*   /* SUPPLIED, THE PAGE WILL BE RELEASED UNLESS THE SAVE AUX FLAG  */
*   /* IS ON. IF A LPID IS SUPPLIED AND THE SAVE AUX FLAG IS NOT ON, */
*   /* THE PAGE WILL BE TRANSFERED (ILRCALL MACRO). IF THE SAVE AUX  */
*   /* FLAG IS ON (AND LPID GIVEN) A CHECK IS MADE TO INSURE THAT THE*/
*   /* VCBLPID AND XPTLPID MATCH. IF THEY DO NOT AN ERROR IS SIGNALED*/
*   /* AND RETURN MADE TO VAMSI. -- FINAL -- THE PAGE TABLE ENTRY IS */
*   /* CLEARED WITH THE EXCEPTION OF THE GETMAIN ASSIGNED AND INVALID*/
*   /* BITS. THE XPTE IS UPDATED AND RETURN MADE TO THE CALLER.      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0633
*AUXTEST:                                                          0633
*   IF XPTXAV='0'B THEN             /* IF AUX IS NOT ASSIGNED        */
AUXTEST  TM    XPTXAV(XPTEPTR),B'01000000'                         0633
         BNZ   @RF00633                                            0633
*     VCBNOAUX='1'B;                /* SET THE NO AUX FLAG IN THE VCB*/
         OI    VCBNOAUX(VCBPTR),B'00010000'                        0634
*   ELSE                                                           0635
*     DO;                                                          0635
         B     @RC00633                                            0635
@RF00633 DS    0H                                                  0636
*       IF MYVCBLGN=0&MYVCBLPN=0 THEN/* IF NO LOGICAL PAGE I D       */
         SLR   @14,@14                                             0636
         CL    @14,MYVCBLGN(,VCBPTR)                               0636
         BNE   @RF00636                                            0636
         CL    @14,MYVCBLPN(,VCBPTR)                               0636
         BNE   @RF00636                                            0636
*         DO;                                                      0637
*           IF XPTVIOLP='0'B THEN   /* IF SAVE AUX IS NOT REQUESTED
*                                                            @Z40WPYC*/
         TM    XPTVIOLP(XPTEPTR),B'10000000'                       0638
         BNZ   @RF00638                                            0638
*             DO;                   /* DETERMINE IF I/O IS         0639
*                                      OUTSTANDING           @Z40WPYC*/
*               IF POINPROC='1'B|PIINPROC='1'B THEN/* IF PAGEOUT OR
*                                      PAGEIN IS IN PROCESS  @Z40WPYC*/
         TM    POINPROC(PVTPTR),B'00000011'                        0640
         BZ    @RF00640                                            0640
*                 DO;               /* SET INFO FOR ASM      @Z40WPYC*/
*                   PCBPTR=IOSVAIA-(LENGTH(PCB)-LENGTH(PCBAIA));/* 0642
*                                      RECOMPUTE ADDRESS OF PCB    0642
*                                                            @Z40WPYC*/
         L     PCBPTR,IOSVAIA-1(,PVTPTR)                           0642
         LA    PCBPTR,0(,PCBPTR)                                   0642
         SL    PCBPTR,@CF02276                                     0642
*                   AIAFRAUX='1'B;  /* TELL ASM TO FREE THE AUX STOR
*                                      SLOT WHEN THE I/O COMPLETES.
*                                                            @Z40WPYC*/
         OI    AIAFRAUX(PCBPTR),B'10000000'                        0643
*                 END;              /* END I/O PROCESSING    @Z40WPYC*/
*               ELSE                /* NO I/O IS IN PROCESS  @Z40WPYC*/
*                 CALL RELEASEP;    /* FREE AUX STOR NOW     @Z40WPYC*/
         B     @RC00640                                            0645
@RF00640 BAL   @14,RELEASEP                                        0645
*             END;                  /* END OF LSID IN XPTE         0646
*                                      PROCESSING. NOTE THAT IF PCB
*                                      WAS ON GFA DEFER QUEUE, THE 0646
*                                      PCB WAS PREVIOUSLY FREED.   0646
*                                                            @Z40WPYC*/
*         END;                                                     0647
*       ELSE                        /* IF THERE IS A LOGICAL PAGE    */
*         IF XPTVIOLP='0'B THEN     /* AND SAVE AUX IS NOT REQUESTED
*                                                            @Z40WPYC*/
         B     @RC00636                                            0648
@RF00636 TM    XPTVIOLP(XPTEPTR),B'10000000'                       0648
         BNZ   @RF00648                                            0648
*           DO;                                                    0649
*             CALL XFERP;           /* CALL FOR AUX TRANSFER         */
         BAL   @14,XFERP                                           0650
*             IF RETCODR^=0 THEN    /* IF THE TRANSFER FAILED        */
         LTR   RETCODR,RETCODR                                     0651
         BNZ   @RT00651                                            0651
*               GOTO IDERROR;       /* GOING TO LOGICAL PAGE I D   0652
*                                      ERROR ROUTINE                 */
*           END;                                                   0653
*         ELSE                      /* IF SAVE AUX IS REQUESTED CHECK
*                                      LOGICAL PAGE MATCH            */
*           IF VCBLPID^=XPTLPID THEN/* IF LOGICAL PAGES DO NOT MATCH */
         B     @RC00648                                            0654
@RF00648 CLC   VCBLPID(8,VCBPTR),XPTLPID(XPTEPTR)                  0654
         BNE   @RT00654                                            0654
*             GOTO IDERROR;         /* GOING TO LOGICAL PAGE I D   0655
*                                      ERROR ROUTINE                 */
*     END;                                                         0656
@RC00648 DS    0H                                                  0656
@RC00636 DS    0H                                                  0657
*                                                                  0657
*   /*****************************************************************/
*   /*                                                               */
*   /* CLEAN UP CONTROL BLOCKS BEFORE RETURN.                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0657
*FINAL:                                                            0657
*   PGTPTE=RESETHWD;                /* ZERO THE PGTE, KEEP GM ASSIGN
*                                      AND INVALID BITS ON           */
@RC00633 DS    0H                                                  0657
FINAL    MVC   PGTPTE(2,PTEPTR),@CB02048                           0657
*   VCBRSN=0;                       /* CLEAR THE RSN - NO REAL     0658
*                                      STORAGE                       */
         SLR   @14,@14                                             0658
         STH   @14,VCBRSN(,VCBPTR)                                 0658
*   XPTXAV='0'B;                    /* RESET THE AUX ASSIGNED FLAG   */
*   XPTVIOLP='0'B;                  /* RESET THE LPID VALID FLAG   0660
*                                                            @Z40WPYC*/
         NI    XPTXAV(XPTEPTR),B'00111111'                         0660
*   XPTVALID='0'B;                  /* RESET THE LSID VALID FLAG   0661
*                                                            @Z40WPYC*/
*   XPTPOINP='0'B;                  /* TURN OFF PAGEOUT IN PROCESS 0662
*                                      FLAG. ASM WILL NOT TURN OFF 0662
*                                      WHEN FRAUX IS SET OR OUTPUT 0662
*                                      OPERATION IS A VIO MOVEOUT. 0662
*                                                            @Z40WPYC*/
*   XPTIOERR='0'B;                  /* TURN OFF I/O ERROR FLAG. ASM
*                                      WILL NOT TURN OFF WHEN FRAUX
*                                      IS SET OR OR OUTPUT OPERATION
*                                      IS A VIO MOVEOUT.     @Z40WPYC*/
         NI    XPTVALID(XPTEPTR),B'01001111'                       0663
*   XPTLPID=''B;                    /* CLEAR THE LPID        @Z40WPYC*/
         XC    XPTLPID(8,XPTEPTR),XPTLPID(XPTEPTR)                 0664
*   GOTO OUTRTN;                    /* GOING TO RETURN               */
         B     OUTRTN                                              0665
*                                                                  0666
*   /*****************************************************************/
*   /*                                                               */
*   /* GFADEFR -- THIS CODE HANDLES ALL PCBS THAT WERE FOUND TO BE ON*/
*   /* THE GFA DEFER QUEUE. THE DEFER FLAG IS IMMEDIATELY RESET. IF  */
*   /* RESET NEED NOT BE ACCOMPLISHED (PCB RESET FLAG OFF), THE ROOT */
*   /* BIT IS TESTED. IF A ROOT EXISTS, THE COUNT IS DECREMENTED BY  */
*   /* 1. IF THE COUNT IS NOW ZERO AND THIS IS A COMMON AREA PAGE,   */
*   /* THE COUNT IS FORCED TO 1. IF NOT A COMMON AREA PAGE, THE ROOT */
*   /* EXIT ROUTINE IS CALLED TO PROCESS THAT ROOT PCB. IF THE RESET */
*   /* FLAG WAS ON, A TEST IS MADE TO SEE IF THE PCB IS NOT IN SRB   */
*   /* MODE AND THAT THE PAGE IS A COMMON PAGE. IF THIS IS TRUE THE  */
*   /* FREE REAL, VBN AND RBN FIELDS ARE SET IN THE PCB, AND THE IO  */
*   /* COMPLETE FLAG IS TURNED ON. THE SCHEDULE FUNCTION OF PIOP IS  */
*   /* THEN CALLED TO SCHEDULE AN SRB. IF THE ABOVE TEST WAS NOT     */
*   /* TRUE, RESET MUST BE CALLED TO MAKE ROUTINE DISPATCHABLE AGAIN.*/
*   /* AT LABEL SAVRELAT, THE PCB DEFER BIT IS RESET, AND THE PCBS   */
*   /* SENT TO THE CIO OR FREE QUEUE AS APPROPRIATE. IF THERE IS ONE */
*   /* OR MORE RELATED PCBS, THE ENTIRE LOOP IS REPEATED FOR EACH    */
*   /* ONE.                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0666
*GFADEFR:                                                          0666
*   XPTDEFER='0'B;                  /* RESET THE DEFER FLAG          */
*                                                                  0666
GFADEFR  NI    XPTDEFER(XPTEPTR),B'11111101'                       0666
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR PCB RESET BIT                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0667
*RELTEST:                                                          0667
*   IF PCBRESET='0'B THEN           /* IF RESET IS NOT SPECIFIED     */
RELTEST  TM    PCBRESET(PCBPTR),B'00010000'                        0667
         BNZ   @RF00667                                            0667
*     DO;                                                          0668
*       IF PCBROOT='1'B THEN        /* IF A ROOT PCB EXISTS          */
         TM    PCBROOT(PCBPTR),B'00000100'                         0669
         BNO   @RF00669                                            0669
*         DO;                                                      0670
*           PCBRCNT=PCBRCNT-1;      /* DECREMENT COUNT IN ROOT PCB   */
         L     @14,PCBRPTR-1(,PCBPTR)                              0671
         LA    @14,0(,@14)                                         0671
         LH    @12,PCBRCNT(,@14)                                   0671
         BCTR  @12,0                                               0671
         STH   @12,PCBRCNT(,@14)                                   0671
*           IF PCBRCNT=0 THEN       /* IF THE ROOT COUNT = 0 THEN    */
         LTR   @12,@12                                             0672
         BNZ   @RF00672                                            0672
*             DO;                                                  0673
*               RFY                                                0674
*                (R0,                                              0674
*                 R1) RSTD;                                        0674
*               R1=PCBRTPA;         /* LOAD THE ROOT PCB ADDRESS     */
         L     R1,PCBRTPA-1(,PCBPTR)                               0675
         LA    R1,0(,R1)                                           0675
*               CALL ROOTEXIT;      /* CALL THE ROOT EXIT ROUTINE FOR
*                                      LOCAL PAGES                   */
         L     @15,PCBRGOTO(,@14)                                  0676
         BALR  @14,@15                                             0676
*               RCACSECT=RCACVAM;   /* RESTORE AFTER CALL            */
         L     @14,RCAPTR(,PVTPTR)                                 0677
         MVI   RCACSECT(@14),X'18'                                 0677
*             END;                                                 0678
*         END;                                                     0679
*     END;                                                         0680
*                                                                  0681
*   /*****************************************************************/
*   /*                                                               */
*   /* ELSE - THIS CODE EXECUTES IF RESET (PCBRESET=1) WAS SET.      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0681
*   ELSE                            /* IF RESET IS SPECIFIED         */
*     DO;                                                          0681
         B     @RC00667                                            0681
@RF00667 DS    0H                                                  0682
*       RFY                                                        0682
*        (R13) RSTD;                                               0682
*       RSETSV4=R4;                 /* SAVE ACROSS CALL              */
         ST    R4,RSETSV4(,PVTPTR)                                 0683
*       RSETSV5=R5;                 /* SAVE ACROSS CALL              */
         ST    R5,RSETSV5(,PVTPTR)                                 0684
*       RSETSV6=R6;                 /* SAVE ACROSS CALL              */
         ST    R6,RSETSV6(,PVTPTR)                                 0685
*       IF PCBSRBMD='1'B THEN       /* IF PCB IS IN SRB MODE         */
         TM    PCBSRBMD(PCBPTR),B'00100000'                        0686
         BNO   @RF00686                                            0686
*         DO;                                                      0687
*           R4=PCBSRB;              /* LOAD THE SRB ADDRESS FOR CALL */
         L     R4,PCBSRB(,PCBPTR)                                  0688
*           R5=0;                   /* CLEAR PARAMETER               */
         SLR   R5,R5                                               0689
*         END;                                                     0690
*       ELSE                        /* IF PCB IS NOT IN SRB MODE     */
*         DO;                                                      0691
         B     @RC00686                                            0691
@RF00686 DS    0H                                                  0692
*           R4=PCBRTPA;             /* LOAD TCB ADDRESS              */
         L     R4,PCBRTPA-1(,PCBPTR)                               0692
         LA    R4,0(,R4)                                           0692
*           R5=PCBSRB;              /* LOAD RB FOR CALL              */
         L     R5,PCBSRB(,PCBPTR)                                  0693
*         END;                                                     0694
*       R13=ADDR(PVTSAVE);          /* SUPPLY A SAVE AREA            */
@RC00686 LA    R13,PVTSAVE(,PVTPTR)                                0695
*       R6=0;                       /* CLEAR PARAMETER               */
         SLR   R6,R6                                               0696
*       CALL IEAVRSET;              /* CALL FOR RESET                */
         L     @15,PVTPRSET(,PVTPTR)                               0697
         BALR  @14,@15                                             0697
*       R4=RSETSV4;                 /* RESTORE AFTER CALL            */
         L     R4,RSETSV4(,PVTPTR)                                 0698
*       R5=RSETSV5;                 /* RESTORE AFTER CALL            */
         L     R5,RSETSV5(,PVTPTR)                                 0699
*       R6=RSETSV6;                 /* RESTORE AFTER CALL            */
         L     R6,RSETSV6(,PVTPTR)                                 0700
*       RFY                                                        0701
*        (R11,                                                     0701
*         R12,                                                     0701
*         R13) UNRSTD;                                             0701
*     END;                                                         0702
*                                                                  0703
*   /*****************************************************************/
*   /*                                                               */
*   /* SEND THE PCB TO THE FREE QUEUE, THEN HANDLE ANY RELATED PCBS  */
*   /* THAT MAY EXIST.                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0703
*FREETQN:                                                          0703
*   R0=PCBFREQN;                    /* LOAD THE QUE NUMBER FOR PCB 0703
*                                      MANAGER                       */
@RC00667 DS    0H                                                  0703
FREETQN  LA    R0,16                                               0703
*   R1=PCBPTR;                      /* LOAD THE PCB ADDRESS FOR PCB
*                                      MANAGER                       */
         LR    R1,PCBPTR                                           0704
*   PCBPTR=PCBRLPA;                 /* GET RELATED PCB BEFORE      0705
*                                      RETURNING IT                  */
         L     @14,PCBRLPA-1(,PCBPTR)                              0705
         LA    @14,0(,@14)                                         0705
         LR    PCBPTR,@14                                          0705
*   R1->PCBRLPA=0;                  /* CLEAR THE RELATED FIELD       */
         SLR   @14,@14                                             0706
         STCM  @14,7,PCBRLPA(R1)                                   0706
*   CALL IEAVPCB;                   /* CALL MANAGER TO MOVE PCB      */
         L     @15,PVTPCB(,PVTPTR)                                 0707
         BALR  @14,@15                                             0707
*   RFY                                                            0708
*    (R0,                                                          0708
*     R1) UNRSTD;                                                  0708
*   IF PCBPTR^=0 THEN               /* IF THERE IS A RELATED         */
         SLR   @14,@14                                             0709
         CR    PCBPTR,@14                                          0709
         BE    @RF00709                                            0709
*     DO;                                                          0710
*       PCBFQPA=0;                  /* MAKE THE RELATED PCB A REGULAR
*                                      PCB                           */
         STCM  @14,7,PCBFQPA(PCBPTR)                               0711
*       PCBBQP=0;                   /* CLEAR THE BACK POINTER        */
         ST    @14,PCBBQP(,PCBPTR)                                 0712
*       GOTO RELTEST;               /* LOOP TO HANDLE THE RELATED PCB*/
         B     RELTEST                                             0713
*     END;                                                         0714
*   GOTO AUXTEST;                   /* IF NO MORE PCBS, GOING TO AUX
*                                      TEST ROUTINE                  */
         B     AUXTEST                                             0715
*                                                                  0716
*   /*****************************************************************/
*   /*                                                               */
*   /* OUTRTN -- THIS IS THE RETURN POINT FOR THE OUTOFSTG           */
*   /* SUB-ROUTINE. BOTH NORMAL AND ERROR RETURNS TO VAMSI ARE MADE  */
*   /* FROM THIS POINT.                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0716
*OUTRTN:                                                           0716
*   RETCODR=0;                      /* SET THE NORMAL RETURN CODE    */
OUTRTN   SLR   RETCODR,RETCODR                                     0716
*   RFY                                                            0717
*    (R14) RSTD;                                                   0717
*OUTERRTN:                                                         0718
*   R14=SUBRETWD;                   /* LOAD THE RETURN ADDRESS       */
OUTERRTN L     R14,SUBRETWD(,PVTPTR)                               0718
*   RFY                                                            0719
*    (PCBPTR,                                                      0719
*     PTEPTR,                                                      0719
*     XPTEPTR,                                                     0719
*     R14) UNRSTD;                                                 0719
*   END OUTOFSTG;                                                  0720
@EL00004 DS    0H                                                  0720
@EF00004 DS    0H                                                  0720
@ER00004 BR    @14                                                 0720
*                                                                  0721
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASEP -- THIS IS THE RELEASE AUX SUB-ROUTINE OF VAMSI. IT  */
*   /* IS CALLED BY THE MOVEOUT AND OUTOFSTG SUB-ROUTINES TO RELEASE */
*   /* AUX VIA A CALL TO ASM FREE SLOT ROUTINE. THE XPTEPTR MUST BE  */
*   /* VALID WHEN THE CALL IS MADE.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0721
*RELEASEP:                                                         0721
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0721
RELEASEP DS    0H                                                  0722
*   RFY                                                            0722
*    (PTEPTR,                                                      0722
*     PFTEPTR,                                                     0722
*     XPTEPTR,                                                     0722
*     PCBPTR,                                                      0722
*     R13,                                                         0722
*     R14) RSTD;                                                   0722
*   SUBSUBWD=R14;                   /* SAVE THE RETURN REG           */
*                                                                  0723
         ST    R14,SUBSUBWD(,PVTPTR)                               0723
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH INTERFACE TO ILRFRSLT                       @Z40WPYC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0724
*   R13=ADDR(PVTWSA4);              /* GIVE MACRO A SAVE AREA        */
         LA    R13,PVTWSA4(,PVTPTR)                                0724
*   R0=4;                           /* INDICATE PRIVATE AREA PAGE  0725
*                                                            @Z40WPYC*/
         LA    R0,4                                                0725
*   R1=XPTEPTR;                     /* SET PTR TO XPTE - NOTE THAT R2
*                                      (RSMHDPTR), ALSO INPUT TO FREE
*                                      SLOT HAS PREVIOUSLY BEEN    0726
*                                      ESTABLISHED.          @Z40WPYC*/
         LR    R1,XPTEPTR                                          0726
*   CALL ILRFRSLT;                  /* CALL FREE SLOT        @Z40WPYC*/
         L     @15,PVTFRSLT(,PVTPTR)                               0727
         BALR  @14,@15                                             0727
*   R14=SUBSUBWD;                   /* RESTORE THE RETURN REG        */
         L     R14,SUBSUBWD(,PVTPTR)                               0728
*   RFY                                                            0729
*    (PTEPTR,                                                      0729
*     PFTEPTR,                                                     0729
*     XPTEPTR,                                                     0729
*     PCBPTR,                                                      0729
*     R13,                                                         0729
*     R14) UNRSTD;                                                 0729
*   END RELEASEP;                   /* END OF SUB-PROC               */
@EL00005 DS    0H                                                  0730
@EF00005 DS    0H                                                  0730
@ER00005 BR    @14                                                 0730
*                                                                  0731
*   /*****************************************************************/
*   /*                                                               */
*   /* XFERP -- THIS IS THE TRANSFER AUX SUB-ROUTINE OF VAMSI. IT IS */
*   /* CALLED BY THE MOVEOUT AND OUTOFSTG SUB-ROUTINES TO TRANSFER   */
*   /* AUX VIA THE ILRCALL TRPAGE MACRO. THE XPTEPTR MUST BE VALID   */
*   /* WHEN THE CALL IS MADE.                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0731
*XFERP:                                                            0731
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0731
XFERP    DS    0H                                                  0732
*   RFY                                                            0732
*    (PTEPTR,                                                      0732
*     PFTEPTR,                                                     0732
*     XPTEPTR,                                                     0732
*     PCBPTR,                                                      0732
*     R13,                                                         0732
*     R14) RSTD;                                                   0732
*   SUBSUBWD=R14;                   /* SAVE THE RETURN REG           */
         ST    R14,SUBSUBWD(,PVTPTR)                               0733
*   R13=ADDR(PVTWSA4);              /* GIVE ASM A SAVEAREA. NOTE THAT
*                                      IT IS POSSIBLE GETMAIN COULD
*                                      BE CALLED THRU THIS INTERFACE
*                                      SO SAVEAREA MUST NOT BE ONE 0734
*                                      THAT RSM WOULD USE ON THIS  0734
*                                      CPU.                  @Z40WPYC*/
         LA    R13,PVTWSA4(,PVTPTR)                                0734
*   ACAOP=0;                        /* ZERO OPERATION FIELD  @Z40WPYC*/
         MVI   ACAOP(PVTPTR),X'00'                                 0735
*   ACAFLG1=0;                      /* ZERO FLAG BYTE        @Z40WPYC*/
         MVI   ACAFLG1(PVTPTR),X'00'                               0736
*   IF POINPROC='1'B THEN           /* IF PAGEOUT IN PROCESS @Z40WPYC*/
         TM    POINPROC(PVTPTR),B'00000010'                        0737
         BNO   @RF00737                                            0737
*     DO;                           /* SET AIA ADDR, NOT LSID IN ACA
*                                                            @Z40WPYC*/
*       ACAAIAP=IOSVAIA;            /* SET AIA IN ACA        @Z40WPYC*/
         L     @12,IOSVAIA-1(,PVTPTR)                              0739
         LA    @12,0(,@12)                                         0739
         ST    @12,ACAAIAP(,PVTPTR)                                0739
*       ACAFLSID=0;                 /* ZERO FROM LSID FIELD AS I/O IS
*                                      NOT COMPLETE AND LSID HAS NOT
*                                      YET BEEN ASSIGNED     @Z40WPYC*/
         SLR   @12,@12                                             0740
         ST    @12,ACAFLSID(,PVTPTR)                               0740
*     END;                          /* END PAGEOUT-IN-PROCESS      0741
*                                      PROCESSNG             @Z40WPYC*/
*   ELSE                            /* NOT PAGEOUT I/O IN PROCESS  0742
*                                                            @Z40WPYC*/
*     DO;                           /* SETUP FOR NO I/O      @Z40WPYC*/
         B     @RC00737                                            0742
@RF00737 DS    0H                                                  0743
*       ACAAIAP=0;                  /* INDICATE NOT PAGEOUT IN     0743
*                                      PROCESS               @Z40WPYC*/
         SLR   @12,@12                                             0743
         ST    @12,ACAAIAP(,PVTPTR)                                0743
*       ACAFLSID=XPTLSID;           /* SET FROM LSID         @Z40WPYC*/
         L     @12,XPTLSID(,XPTEPTR)                               0744
         ST    @12,ACAFLSID(,PVTPTR)                               0744
*     END;                          /* END NO PAGEOUT PROCESSING   0745
*                                                            @Z40WPYC*/
*   ACAASID=RSMASCB->ASCBASID;      /* SET ASID OF REQUESTING A.S. 0746
*                                                            @Z40WPYC*/
@RC00737 L     @12,RSMASCB(,RSMHDPTR)                              0746
         LH    @12,ASCBASID(,@12)                                  0746
         N     @12,@CF02294                                        0746
         STH   @12,ACAASID(,PVTPTR)                                0746
*   ACATOLP=VCBLPID;                /* SET LPID TO TRANSFER LSID TO
*                                                            @Z40WPYC*/
         MVC   ACATOLP(8,PVTPTR),VCBLPID(VCBPTR)                   0747
*   DO;                             /* ILRCALL                     0748
*                                      ACA(ADDR(PVTACA))OP(TRPAGE)   */
*     RESPECIFY                                                    0749
*       R1 RSTD;                                                   0749
*     DECLARE                       /* ILRGOS ENTRY POINT    @Z40WPWG*/
*       ILRGOS ENTRY BASED(ASMGOS) VALRG(0);                       0750
*     DECLARE                       /* ILRTRPAG ENTRY POINT  @Z40WPWG*/
*       ILRTRPAG ENTRY BASED(ASMTRPAG) VALRG(0);                   0751
*     DCL                                                          0752
*       ILRACAOP FIXED(8) BASED(R1);                               0752
*     R1=ADDR(PVTACA);              /* SET OPCODE            @Z40WPWG*/
         LA    R1,PVTACA(,PVTPTR)                                  0753
*     ILRACAOP=4;                                                  0754
         MVI   ILRACAOP(R1),X'04'                                  0754
*     CALL ILRTRPAG;                /*                       @Z40WPWG*/
         L     @12,CVTPTR                                          0755
         L     @12,ASMVTPTR(,@12)                                  0755
         L     @15,ASMTRPAG(,@12)                                  0755
         BALR  @14,@15                                             0755
*     RESPECIFY                                                    0756
*       R1 UNRSTD;                                                 0756
*   END;                            /* ILRCALL                     0757
*                                      ACA(ADDR(PVTACA))OP(TRPAGE) 0757
*                                      TRANS PAGE            @Z40WPYC*/
*   R14=SUBSUBWD;                   /* RESTORE THE RETURN REG        */
         L     R14,SUBSUBWD(,PVTPTR)                               0758
*   RFY                                                            0759
*    (PTEPTR,                                                      0759
*     PFTEPTR,                                                     0759
*     XPTEPTR,                                                     0759
*     PCBPTR,                                                      0759
*     R13,                                                         0759
*     R14) UNRSTD;                                                 0759
*   END XFERP;                      /* END OF SUB-PROC               */
@EL00006 DS    0H                                                  0760
@EF00006 DS    0H                                                  0760
@ER00006 BR    @14                                                 0760
*                                                                  0761
*   /*****************************************************************/
*   /*                                                               */
*   /* IOREQ - THIS IS THE I/O REQUEST SUB-ROUTINE OF VAMSI. PAGES   */
*   /* THAT REQUIRE PAGEOUTS (AS EVIDENCED BY HAVING AN AIA ON THE   */
*   /* INTERNAL QUEUE) ARE PROCESSED HERE. ILRPAGIO IS INVOKED TO    */
*   /* INITIATE THE ACTUAL PAGEOUT. IF THE RETURN CODE FROM ASM IS   */
*   /* ZERO, RETURN IS MADE TO VAMSI. FOR NON-ZERO RETURN CODES, THE */
*   /* FAILING PAGE'S VCB IS LOCATED AND MARKED AS BEING IN ERROR.   */
*   /* THE PFTE AND PGTE ARE REBUILT AND THE PCB RETURNED TO THE FREE*/
*   /* QUEUE. ANY AIA'S REMAINING ON THE QUEUE ARE THEN PROCESSED AS */
*   /* ABOVE, BUT REG15 SAVE AREA WILL BE LOADED IF THERE WERE NO    */
*   /* PREVIOUS ERRORS. IF THE PROPER VCB CANNOT BE FOUND FOR        */
*   /* BACKOUT, THE RETURN CODE WILL BE SET TO 16 TO FORCE AN ABEND, */
*   /* AND RETURN IS MADE TO THE MAINLINE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0761
*IOREQ:                                                            0761
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0761
IOREQ    DS    0H                                                  0762
*   RFY                                                            0762
*    (R13,                                                         0762
*     R14) RSTD;                                                   0762
*   SUBSUBWD=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,SUBSUBWD(,PVTPTR)                               0763
*CALLIO:                                                           0764
*   RFY                                                            0764
*    (R1) RSTD;                                                    0764
*                                                                  0764
CALLIO   DS    0H                                                  0765
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL ASM FOR PAGEOUT                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0765
*   R1=VAMAIAQ;                     /* SET PTR TO FIRST PAGEOUT AIA
*                                                            @Z40WPYC*/
         L     R1,VAMAIAQ(,PVTPTR)                                 0765
*   CALL ILRPAGIO;                  /* CALL ASM TO INITIATE PAGEOUT
*                                                            @Z40WPYC*/
         L     @15,PVTPAGIO(,PVTPTR)                               0766
         BALR  @14,@15                                             0766
*   RFY                                                            0767
*    (R13,                                                         0767
*     R14) UNRSTD;                                                 0767
*                                                                  0767
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK RETURN CODE FROM ASM                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0768
*   IF RETCODR=0 THEN               /* IF THE I/O WAS SUCCESSFUL     */
         SLR   @14,@14                                             0768
         CR    RETCODR,@14                                         0768
         BNE   @RF00768                                            0768
*     VAMAIAQ=0;                    /* RESET THE AIA QUEUE FOR NEXT
*                                      GROUP                         */
         ST    @14,VAMAIAQ(,PVTPTR)                                0769
*   ELSE                            /* IF THE I/O WAS UNSUCCESSFUL   */
*     DO;                                                          0770
         B     @RC00768                                            0770
@RF00768 DS    0H                                                  0771
*       VCBPTR=REG1WD;              /* LOAD VCB POINTER TO SEARCH FOR
*                                      FAILING VCB                   */
*                                                                  0771
         L     @14,RSTADDWD(,PVTPTR)                               0771
         L     VCBPTR,REG1WD(,@14)                                 0771
*       /*************************************************************/
*       /*                                                           */
*       /* LOCATE PROPER VCB                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0772
*       RFY                                                        0772
*        (PCBPTR) RSTD;                                            0772
*       PCBPTR=R1-LENGTH(PCB)+LENGTH(PCBAIA);/* LOAD THE PCB POINTER */
         LR    PCBPTR,R1                                           0773
         AL    PCBPTR,@CF02275                                     0773
*VCBCK:                                                            0774
*       IF VCBMVOUT='0'B|MYVCBLGN^=AIALGID|MYVCBLPN^=AIARPN THEN/* IF
*                                      NOT THE CORRECT VCB           */
VCBCK    TM    VCBMVOUT(VCBPTR),B'10000000'                        0774
         BZ    @RT00774                                            0774
         CLC   MYVCBLGN(4,VCBPTR),AIALGID(PCBPTR)                  0774
         BNE   @RT00774                                            0774
         CLC   MYVCBLPN(4,VCBPTR),AIARPN(PCBPTR)                   0774
         BE    @RF00774                                            0774
@RT00774 DS    0H                                                  0775
*         DO;                                                      0775
*           VCBPTR=VCBLINK;         /* UPDATE THE VCB POINTER        */
         L     VCBPTR,VCBLINK(,VCBPTR)                             0776
*           IF VCBPTR^=0 THEN       /* IF THERE IS ANOTHER VCB       */
         LTR   VCBPTR,VCBPTR                                       0777
         BNZ   @RT00777                                            0777
*             GOTO VCBCK;           /* SEE IF THIS IS THE CORRECT VCB*/
*           REG15WD=16;             /* SET RETURN CODE TO CAUSE ABEND*/
         L     @14,RSTADDWD(,PVTPTR)                               0779
         MVC   REG15WD(4,@14),@CF00713                             0779
*           VAMAIAQ=R1;             /* STORE ADDRESS OF FAILING AIA
*                                      IN QUEUE                      */
         ST    R1,VAMAIAQ(,PVTPTR)                                 0780
*           RETURN TO RC16ADJ;      /* RETURN TO MAINLINE FOR ABEND  */
         LA    @14,RC16ADJ                                         0781
@EL00007 DS    0H                                                  0781
@EF00007 DS    0H                                                  0781
@ER00007 BR    @14                                                 0781
*         END;                                                     0782
*       RFY                                                        0783
*        (R1) UNRSTD;                                              0783
@RF00774 DS    0H                                                  0784
*       VCBELPID='1'B;              /* SET THE ERROR LPID FLAG       */
         OI    VCBELPID(VCBPTR),B'00100000'                        0784
*       PVTVAMO=PVTVAMO-1;          /* DECREMENT THE VIO OUT COUNT   */
         L     @14,PVTVAMO(,PVTPTR)                                0785
         BCTR  @14,0                                               0785
         ST    @14,PVTVAMO(,PVTPTR)                                0785
*       OUXBVAMO=OUXBVAMO-1;        /* DECREMENT THE LOCAL COUNT     */
         L     @14,ASCBPTR                                         0786
         L     @14,OUXBPTR(,@14)                                   0786
         L     @12,OUXBVAMO(,@14)                                  0786
         BCTR  @12,0                                               0786
         ST    @12,OUXBVAMO(,@14)                                  0786
*       IF VCBNDISC='1'B THEN       /* IF THE NON-DISCONNECT OPTION
*                                      WAS SPECIFIED                 */
         TM    VCBNDISC(VCBPTR),B'00001000'                        0787
         BNO   @RF00787                                            0787
*         DO;                                                      0788
*           PCBXPTA->XPTXAV='0'B;   /* RESET THE AUX ASSIGNED FLAG   */
*           PCBXPTA->XPTVIOLP='0'B; /* RESET THE SAVE AUX FLAG     0790
*                                                            @Z40WPYC*/
         L     @14,PCBXPTA-1(,PCBPTR)                              0790
         LA    @14,0(,@14)                                         0790
         NI    XPTXAV(@14),B'00111111'                             0790
*           PCBXPTA->XPTPOINP='0'B; /* CLEAR PAGEOUT IN PROC @Z40WPYC*/
*           PCBXPTA->XPTIOERR='0'B; /* CLEAR I/O ERROR FLAG  @Z40WPYC*/
*           PCBXPTA->XPTVALID='0'B; /* CLEAR LSID VALID FLAG @Z40WPYC*/
         NI    XPTPOINP(@14),B'01001111'                           0793
*           PCBXPTA->XPTLPID=''B;   /* CLEAR THE LPID        @Z40WPYC*/
         XC    XPTLPID(8,@14),XPTLPID(@14)                         0794
*         END;                                                     0795
*                                                                  0795
*       /*************************************************************/
*       /*                                                           */
*       /* RE-ADJUST PGTE AND PFTE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0796
*ADJPGTE:                                                          0796
*       PCBPGTA->PGTRSA=PCBRBN;     /* LOAD THE PAGE TABLE           */
@RF00787 DS    0H                                                  0796
ADJPGTE  L     @14,PCBPGTA-1(,PCBPTR)                              0796
         LA    @14,0(,@14)                                         0796
         MVC   PGTRSA(2,@14),PCBRBN(PCBPTR)                        0796
*       PCBPGTA->PGTPAM='1'B;       /* SET THE GETMAINED BIT IN PGTE */
         OI    PGTPAM(@14),B'00000001'                             0797
*       RFY                                                        0798
*        (PFTEPTR) RSTD;                                           0798
*       PFTEPTR=PVTPFTP+PCBRBN;     /* LOAD THE PFTE POINTER         */
         LH    PFTEPTR,PCBRBN(,PCBPTR)                             0799
         N     PFTEPTR,@CF02294                                    0799
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0799
*       PFTIRRG='0'B;               /* RESET THE IRREGULAR BIT       */
         NI    PFTIRRG(PFTEPTR),B'11101111'                        0800
*       PFTPCBSI='0'B;              /* RESET THE PCB DEFINED FLAG    */
         NI    PFTPCBSI(PFTEPTR),B'11110111'                       0801
*       PFTASID=ASCBASID;           /* LOAD THE ASID                 */
         L     @14,ASCBPTR                                         0802
         LH    @14,ASCBASID(,@14)                                  0802
         N     @14,@CF02294                                        0802
         STH   @14,PFTASID(,PFTEPTR)                               0802
*       PFTVBN=CURVSN;              /* LOAD THE PROPER VSN           */
         MVC   PFTVBN(2,PFTEPTR),CURVSN(VCBPTR)                    0803
*       RFY                                                        0804
*        (PFTEPTR) UNRSTD;                                         0804
*       RFY                                                        0805
*        (R0,                                                      0805
*         R1,                                                      0805
*         TESTPTR) RSTD;                                           0805
*                                                                  0805
*       /*************************************************************/
*       /*                                                           */
*       /* FORCE THE CHANGE BIT ON FOR PAGE RECOVERY. IF THE COMPARE */
*       /* AND SWAP IS SUCESSFUL THE CHANGE BIT WILL BE SET ON. IF IT*/
*       /* IS NOT (CC NOT ZERO) SOMEONE ELSE HAS FORCED CHANGE BIT ON*/
*       /* AND THE OBJECTIVE IS STILL MET                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0806
*       TESTPTR=VCBVSA;             /* LOAD ADDRESS OF WORD IN STG   */
         L     TESTPTR,VCBVSA(,VCBPTR)                             0806
*       GENERATE REFS(TESTPTR) SETS(R1);                           0807
      L  R1,0(TESTPTR)             LOAD FIRST WORD
      CS R1,R1,0(TESTPTR)          COMPARE AND SWAP TO SET CHANGE BIT
*       VAMAIAQ=AIANXAIA;           /* LOAD HEADER TO POINT TO NEXT
*                                      AIA                           */
*                                                                  0808
         L     @14,AIANXAIA(,PCBPTR)                               0808
         ST    @14,VAMAIAQ(,PVTPTR)                                0808
*       /*************************************************************/
*       /*                                                           */
*       /* SEND PCB TO FREE QUEUE                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0809
*       R0=PCBFREQN;                /* SEND PCB TO FREE QUEUE        */
         LA    R0,16                                               0809
*       R1=PCBPTR;                  /* LOAD PARM FOR PCB MANAGER     */
         LR    R1,PCBPTR                                           0810
*       CALL IEAVPCB;               /* CALL PCB MANAGER              */
         L     @15,PVTPCB(,PVTPTR)                                 0811
         BALR  @14,@15                                             0811
*       RFY                                                        0812
*        (R0,                                                      0812
*         R1,                                                      0812
*         TESTPTR,                                                 0812
*         PCBPTR) UNRSTD;                                          0812
*       IF REG15WD=0 THEN           /* IF THIS IS THE FIRST ERROR  0813
*                                      ENCOUNTERED                   */
         L     @14,RSTADDWD(,PVTPTR)                               0813
         L     @12,REG15WD(,@14)                                   0813
         LTR   @12,@12                                             0813
         BNZ   @RF00813                                            0813
*         DO;                                                      0814
*           REG15WD=4;              /* LOAD A RETURN CODE            */
         MVC   REG15WD(4,@14),@CF00053                             0815
*           REG2WD=LASTVCB;         /* LOAD ADDRESS OF LAST VCB    0816
*                                      PROCESSED                     */
         L     @12,LASTVCB(,PVTPTR)                                0816
         ST    @12,REG2WD(,@14)                                    0816
*         END;                                                     0817
*                                                                  0817
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK FOR MORE AIA'S ON QUEUE                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0818
*       IF VAMAIAQ^=0 THEN          /* IF THERE ARE MORE AIA'S       */
@RF00813 L     @14,VAMAIAQ(,PVTPTR)                                0818
         LTR   @14,@14                                             0818
         BNZ   @RT00818                                            0818
*         GOTO CALLIO;              /* PROCESS REST OF AIA GROUP     */
*     END;                                                         0820
*   RFY                                                            0821
*    (R14) RSTD;                                                   0821
@RC00768 DS    0H                                                  0822
*   R14=SUBSUBWD;                   /* RESTORE RETURN ADDRESS        */
         L     R14,SUBSUBWD(,PVTPTR)                               0822
*   RFY                                                            0823
*    (R14) UNRSTD;                                                 0823
*   END IOREQ;                      /* END OF SUB-PROC, RETURNING TO
*                                      CALLER                        */
         B     @EL00007                                            0824
*   END IEAVAMSI                    /* END OF IEAVAMSI               */
*                                                                  0825
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (IHAOUXB )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAVCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARSMHD)                                       */
*/*%INCLUDE SYSLIB  (IHAPFTE )                                       */
*/*%INCLUDE SYSLIB  (IHAPCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCBR )                                       */
*/*%INCLUDE SYSLIB  (IHAXPTE )                                       */
*/*%INCLUDE SYSLIB  (IHAPGTE )                                       */
*/*%INCLUDE SYSLIB  (IHARCA  )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (ILRASMVT)                                       */
*/*%INCLUDE SYSLIB  (ILRACA  )                                       */
*/*%INCLUDE SYSLIB  (ILRAIA  )                                       */
*                                                                  0825
*       ;                                                          0825
@DATA    DS    0H
         DS    0F
         DS    0F
@CF00053 DC    F'4'
@CF00059 DC    F'8'
@CF02086 DC    F'12'
@CF00713 DC    F'16'
@CF02276 DC    F'36'
@CF02045 DC    F'4096'
@CF02275 DC    F'-36'
@CF02294 DC    XL4'0000FFFF'
@CF02042 DC    XL4'FFF0'
@CF01765 DC    XL4'01'
         DS    0D
VAMSIMO  DC    XL4'00001000'
@CB02042 DC    X'FFF0'
@CB02048 DC    X'0009'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PVTPTR   EQU   @03
VCBPTR   EQU   @04
RSMHDPTR EQU   @02
PFTEPTR  EQU   @08
PCBPTR   EQU   @10
XPTEPTR  EQU   @07
PTEPTR   EQU   @06
R0       EQU   @00
R1       EQU   @01
INVCBR   EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
CURVSNR  EQU   @05
R6       EQU   @06
RESTPTR  EQU   @08
R9       EQU   @09
FADDR    EQU   @10
R11      EQU   @11
R12      EQU   @12
WRK1R    EQU   @12
TESTPTR  EQU   @12
R13      EQU   @13
WRK2R    EQU   @13
GFASW    EQU   @13
LOCKRCR  EQU   @13
R14      EQU   @14
R15      EQU   @15
RETCODR  EQU   @15
R10      EQU   @10
R7       EQU   @07
R8       EQU   @08
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTFLAG2 EQU   PVT+1
PVTPFTP  EQU   PVT+12
PVTLPRIV EQU   PVT+24
PVTLCSA  EQU   PVT+26
PVTPRCA  EQU   PVT+52
PVTPSINT EQU   PVT+76
PVTPCB   EQU   PVT+104
PVTPFTE  EQU   PVT+108
PVTPFP2  EQU   PVT+116
PVTPRCV  EQU   PVT+156
PVTPINV  EQU   PVT+172
PVTPOPBR EQU   PVT+220
PVTPAGIO EQU   PVT+236
PVTFRSLT EQU   PVT+240
PVTPRSET EQU   PVT+244
PVTVAMO  EQU   PVT+260
PVTVAMR  EQU   PVT+264
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
PVTWSA4  EQU   PVTWSAX+216
PVTWSA15 EQU   PVTWSAX+1040
PVTSAVE  EQU   PVTWSAX+1328
PVTACA   EQU   PVTWSAX+1400
PVTPCBQS EQU   PVT+1852
PVTGFADF EQU   PVTPCBQS+24
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBOUXB EQU   ASCB+148
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ASXB     EQU   0
ASXBSPSA EQU   ASXB+112
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
OUXB     EQU   0
OUXBVAMO EQU   OUXB+32
OUXBVAMR EQU   OUXB+36
WSAL     EQU   0
WSALRSM  EQU   WSAL+52
WSAG     EQU   0
WSAC     EQU   0
LCCACPUS EQU   0
VCB      EQU   0
VCBLINK  EQU   VCB
VCBVSA   EQU   VCB+4
VCBLPID  EQU   VCB+8
VCBOPFLG EQU   VCB+16
VCBMVOUT EQU   VCBOPFLG
VCBASIGN EQU   VCBOPFLG
VCBINSTG EQU   VCBOPFLG
VCBNDISC EQU   VCBOPFLG
VCBLOAD  EQU   VCBOPFLG
VCBCPFLG EQU   VCB+17
VCBNOVAC EQU   VCBCPFLG
VCBINVSA EQU   VCBCPFLG
VCBELPID EQU   VCBCPFLG
VCBNOAUX EQU   VCBCPFLG
VCBEFIX  EQU   VCBCPFLG
VCBRSN   EQU   VCB+18
VCBDSPID EQU   VCB+20
RSMHD    EQU   0
RSMASCB  EQU   RSMHD+8
RSMFLG1  EQU   RSMHD+12
RSMQS    EQU   RSMHD+20
RSMLFQ   EQU   RSMQS
RSMLSQA  EQU   RSMQS+4
RSMLIOQ  EQU   RSMQS+8
RSMLIOQF EQU   RSMLIOQ
PFTE     EQU   0
PFTPGID  EQU   PFTE
PFTASID  EQU   PFTPGID
PFTVBN   EQU   PFTPGID+2
PFTQPTRS EQU   PFTE+4
PFTFLAGS EQU   PFTE+12
PFTFLAG1 EQU   PFTFLAGS
PFTVRINT EQU   PFTFLAG1
PFTLSQA  EQU   PFTFLAG1
PFTPCBSI EQU   PFTFLAG1
PFTBADPG EQU   PFTFLAG1
PFTOFINT EQU   PFTFLAG1
PFTFLAG2 EQU   PFTFLAGS+1
PFTIRRG  EQU   PFTFLAG2
PFTQNDX  EQU   PFTE+14
PFTUIC   EQU   PFTE+15
PCB      EQU   0
PCBFQP   EQU   PCB
PCBFQPA  EQU   PCBFQP+1
PCBBQP   EQU   PCB+4
PCBRTP   EQU   PCB+8
PCBFL1   EQU   PCBRTP
PCBSRBMD EQU   PCBFL1
PCBROOT  EQU   PCBFL1
PCBIOI   EQU   PCBFL1
PCBIOCMP EQU   PCBFL1
PCBRTPA  EQU   PCBRTP+1
PCBRLP   EQU   PCB+12
PCBRLPA  EQU   PCBRLP+1
PCBXPT   EQU   PCB+16
PCBFL2   EQU   PCBXPT
PCBFREAL EQU   PCBFL2
PCBRESET EQU   PCBFL2
PCBVIO   EQU   PCBFL2
PCBXPTA  EQU   PCBXPT+1
PCBPGT   EQU   PCB+20
PCBFL3   EQU   PCBPGT
PCBNOREC EQU   PCBFL3
PCBPGTA  EQU   PCBPGT+1
PCBRBN   EQU   PCB+24
PCBVBN   EQU   PCB+26
PCBBLOCK EQU   PCB+28
PCBSRB   EQU   PCBBLOCK
PCBRB    EQU   PCBSRB
PCBASCB  EQU   PCB+32
PCBAIA   EQU   PCB+36
PCBR     EQU   0
PCBRTCB  EQU   PCBR
PCBRFLAG EQU   PCBRTCB
PCBRGOTO EQU   PCBR+4
PCBRCNT  EQU   PCBR+16
XPTE     EQU   0
XPTPROT  EQU   XPTE
XPTFLAGS EQU   XPTE+2
XPTVIOLP EQU   XPTFLAGS
XPTXAV   EQU   XPTFLAGS
XPTVIO   EQU   XPTFLAGS
XPTDEFER EQU   XPTFLAGS
XPTFLAG2 EQU   XPTE+3
XPTVALID EQU   XPTFLAG2
XPTPOINP EQU   XPTFLAG2
XPTIOERR EQU   XPTFLAG2
XPTLPID  EQU   XPTE+4
XPTLGN   EQU   XPTLPID
XPTLSID  EQU   XPTLGN
XPTLPN   EQU   XPTLPID+4
PGTPTE   EQU   0
PGTRSA   EQU   PGTPTE
PGTBITS  EQU   PGTRSA+1
PGTPVM   EQU   PGTBITS
PGTPAM   EQU   PGTBITS
RCA      EQU   0
RCANAME7 EQU   RCA+8
RCACSECT EQU   RCA+9
RCAFLAGS EQU   RCA+10
RCASAL   EQU   RCAFLAGS
RCARCRD  EQU   RCA+11
RCANAMES EQU   RCA+12
RCANAME1 EQU   RCANAMES
RCAVAMSI EQU   RCANAME1
RCANAME2 EQU   RCANAMES+1
RCANAME3 EQU   RCANAMES+2
RCANAME4 EQU   RCANAMES+3
RCANAME5 EQU   RCANAMES+4
RCANAME6 EQU   RCANAMES+5
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRREPTR  EQU   0
ASMVT    EQU   0
ASMFLAG1 EQU   ASMVT
ASMFLAG2 EQU   ASMVT+1
ASMGOS   EQU   ASMVT+12
ASMTRPAG EQU   ASMVT+16
ASMSTAGQ EQU   ASMVT+32
ASMPCCWQ EQU   ASMVT+64
ASMLSAI  EQU   ASMVT+144
ASMGOSQS EQU   ASMVT+152
ASMWKSA1 EQU   ASMVT+368
ASMWKSA2 EQU   ASMVT+448
ASMWKSA3 EQU   ASMVT+528
ASMWKSA4 EQU   ASMVT+608
ASMWKSA5 EQU   ASMVT+688
ASMPOOLS EQU   0
ASMCPAVQ EQU   ASMPOOLS+8
ASMCPRSQ EQU   ASMPOOLS+16
REGSAVER EQU   0
REG0WD   EQU   REGSAVER
REG1WD   EQU   REGSAVER+4
REG2WD   EQU   REGSAVER+8
REG15WD  EQU   REGSAVER+60
IEAVFP2  EQU   0
IEAVPCB  EQU   0
IEAVPSII EQU   0
IEAVPFTE EQU   0
IEAVINV  EQU   0
IEAVRSET EQU   0
ROOTEXIT EQU   0
ILRFRSLT EQU   0
ILRPAGIO EQU   0
ILRTRPAG EQU   0
ILRACAOP EQU   0
IEAVOPBR EQU   0
ILRGOS   EQU   0
PGTEND   EQU   0
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSPSA  EQU   CVTS01+336
CVTASMVT EQU   CVTS01+356
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
ASCBPTR  EQU   PSAAOLD
ASXBPTR  EQU   ASCBASXB
OUXBPTR  EQU   ASCBOUXB
PCBRPTR  EQU   PCBRTPA
RCAPTR   EQU   PVTPRCA
FRRSPTR  EQU   PSACSTK
ASMVTPTR EQU   CVTASMVT
ASM1WKSV EQU   ASMWKSA1
ASM1RGSV EQU   ASM1WKSV
ASM1WRKA EQU   ASM1WKSV+60
ASM2WKSV EQU   ASMWKSA2
ASM2WRKA EQU   ASM2WKSV+52
ASM2FLGS EQU   ASM2WRKA+12
ASM3WKSV EQU   ASMWKSA3
ASM4WKSV EQU   ASMWKSA4
ASM4RGSV EQU   ASM4WKSV
ASM5WKSV EQU   ASMWKSA5
ASM5RGSV EQU   ASM5WKSV
THEACA   EQU   PVTACA
ACA      EQU   THEACA
ACAOP    EQU   ACA
ACAFLG1  EQU   ACA+1
ACAASID  EQU   ACA+2
ACALGN   EQU   ACA+8
ACALPID  EQU   ACALGN
ACALGID  EQU   ACALPID
ACAFLSID EQU   ACALGID
ACARPN   EQU   ACALPID+4
ACAAIAP  EQU   ACARPN
ACASYM   EQU   ACA+16
ACATOLP  EQU   ACASYM
ACATOLGI EQU   ACATOLP
MYLPID   EQU   VCBLPID
MYVCBLGN EQU   MYLPID
MYVCBLPN EQU   MYLPID+4
@NM00055 EQU   VCBVSA
CURVSN   EQU   @NM00055+1
@NM00058 EQU   PVTWSA15
RSTADDWD EQU   @NM00058
SUBRETWD EQU   @NM00058+4
SUBSUBWD EQU   @NM00058+8
PARMBLD  EQU   @NM00058+12
QHEADFLG EQU   PARMBLD
QINDEX   EQU   PARMBLD+1
QRBN     EQU   PARMBLD+2
PARMBLD2 EQU   @NM00058+16
PARMFLGS EQU   PARMBLD2
RSETWDS  EQU   @NM00058+20
RSETSV4  EQU   RSETWDS
RSETSV5  EQU   RSETWDS+4
RSETSV6  EQU   RSETWDS+8
VAMAIAQ  EQU   @NM00058+32
LASTVCB  EQU   @NM00058+36
LIOQPCB  EQU   @NM00058+40
@NM00059 EQU   LIOQPCB
POINPROC EQU   @NM00059
PIINPROC EQU   @NM00059
IOSVAIA  EQU   LIOQPCB+1
RSMAIA   EQU   PCBAIA
AIA      EQU   RSMAIA
AIAFLG1  EQU   AIA+9
AIAWRITE EQU   AIAFLG1
AIAPRIV  EQU   AIAFLG1
AIAVIO   EQU   AIAFLG1
AIAFLG2  EQU   AIA+10
AIAFRAUX EQU   AIAFLG2
AIAFLG3  EQU   AIA+11
AIANXAIA EQU   AIA+12
AIAID    EQU   AIA+16
AIALPID  EQU   AIAID
AIALGID  EQU   AIALPID
AIALSID  EQU   AIALGID
AIASSID  EQU   AIALSID+1
AIARPN   EQU   AIALPID+4
AIALSID2 EQU   AIARPN
AIALPMEP EQU   AIALSID2
AIAGRPSZ EQU   AIA+24
AIALGE   EQU   AIAGRPSZ
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
AIADPXCT EQU   AIALGE
AIACEPTR EQU   AIALPMEP
AIASLOT  EQU   AIASSID+1
@NM00062 EQU   AIASSID
@NM00061 EQU   AIALSID
AIARCSN  EQU   AIANXAIA+2
AIACYL   EQU   AIANXAIA
AIARSV9  EQU   AIAFLG3
AIARSV8  EQU   AIAFLG3
AIARSV7  EQU   AIAFLG3
AIALPMEC EQU   AIAFLG3
AIARSV6  EQU   AIAFLG3
AIATRPSP EQU   AIAFLG3
AIAPRINO EQU   AIAFLG3
AIARSV5  EQU   AIAFLG3
AIABADID EQU   AIAFLG2
AIAERROR EQU   AIAFLG2
AIASECER EQU   AIAFLG2
AIAPRIER EQU   AIAFLG2
AIARSV4  EQU   AIAFLG2
AIAIORTY EQU   AIAFLG2
AIATERMR EQU   AIAFLG2
AIARSV1  EQU   AIAFLG1
AIASWPFX EQU   AIAFLG1
AIAPAGDS EQU   AIAFLG1
AIALSQA  EQU   AIAFLG1
AIADUPLX EQU   AIAFLG1
AIAOP    EQU   AIA+8
AIABQPA  EQU   AIA+4
AIAFQPA  EQU   AIA
@NM00060 EQU   @NM00059
PARMVSA  EQU   PARMBLD2+1
@NM00057 EQU   @NM00055+3
@NM00056 EQU   @NM00055
ACATORPN EQU   ACATOLP+4
ACAMAXPN EQU   ACATOLGI
ACARSV4  EQU   ACA+4
ACARSV3  EQU   ACAFLG1
ACARSV2  EQU   ACAFLG1
ACARSV1  EQU   ACAFLG1
ACAFSYM  EQU   ACAFLG1
ACAFSPL  EQU   ACAFLG1
ACAFFIX  EQU   ACAFLG1
ACARSV5  EQU   ACAFLG1
ACAFMEM  EQU   ACAFLG1
ASM5FLGS EQU   ASM5WKSV+64
ASM5AIA  EQU   ASM5WKSV+60
ASM5GCTR EQU   ASM5WKSV+56
ASM5SR14 EQU   ASM5WKSV+52
@NM00054 EQU   ASM5RGSV+4
ASM5RG2  EQU   ASM5RGSV
@NM00053 EQU   ASM4RGSV+4
ASM4RG2  EQU   ASM4RGSV
ASM3SR13 EQU   ASM3WKSV+28
ASM3R14B EQU   ASM3WKSV+24
ASM3R14A EQU   ASM3WKSV+20
ASM3GRPA EQU   ASM3WKSV+16
ASM3TMPA EQU   ASM3WKSV+12
ASM3PIOP EQU   ASM3WKSV+8
ASM3GENQ EQU   ASM3WKSV+4
ASM3SWPQ EQU   ASM3WKSV
ASM2SR14 EQU   ASM2WRKA+16
@NM00052 EQU   ASM2WRKA+13
ASM2WFLG EQU   ASM2FLGS
ASM2RFLG EQU   ASM2FLGS
ASM2DUPQ EQU   ASM2WRKA+8
ASM2CAQ  EQU   ASM2WRKA+4
ASM2PAQ  EQU   ASM2WRKA
ASM2RGSV EQU   ASM2WKSV
ASM1NXTA EQU   ASM1WRKA+4
ASM1ASCB EQU   ASM1WRKA
ASM1RG15 EQU   ASM1RGSV+56
@NM00051 EQU   ASM1RGSV+4
ASM1RG1  EQU   ASM1RGSV
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
REG14WD  EQU   REGSAVER+56
REG13WD  EQU   REGSAVER+52
REG12WD  EQU   REGSAVER+48
REG11WD  EQU   REGSAVER+44
REG10WD  EQU   REGSAVER+40
REG9WD   EQU   REGSAVER+36
REG8WD   EQU   REGSAVER+32
REG7WD   EQU   REGSAVER+28
REG6WD   EQU   REGSAVER+24
REG5WD   EQU   REGSAVER+20
REG4WD   EQU   REGSAVER+16
REG3WD   EQU   REGSAVER+12
ASMCPRES EQU   ASMCPRSQ+4
ASMCPTAK EQU   ASMCPRSQ
ASMCPCNT EQU   ASMCPAVQ+4
ASMCPAVL EQU   ASMCPAVQ
ASMCPEXT EQU   ASMPOOLS+6
ASMCPSIZ EQU   ASMPOOLS+4
ASMCPID  EQU   ASMPOOLS
ASMRSV12 EQU   ASMVT+1000
ASMSAVE  EQU   ASMVT+928
ASMWKSA7 EQU   ASMVT+848
ASMWKSA6 EQU   ASMVT+768
ASMACEPC EQU   ASMVT+344
ASMSWKPC EQU   ASMVT+328
ASMBWKPC EQU   ASMVT+312
ASMIOEPC EQU   ASMVT+296
ASMRSV10 EQU   ASMVT+280
ASMPVACE EQU   ASMVT+276
ASMPIOFR EQU   ASMVT+272
ASMPVACQ EQU   ASMVT+268
ASMPMSGS EQU   ASMVT+264
ASMPMSG0 EQU   ASMVT+260
ASMPFRLG EQU   ASMVT+256
ASMPRLG  EQU   ASMVT+252
ASMPACT  EQU   ASMVT+248
ASMPSAV  EQU   ASMVT+244
ASMPCMP  EQU   ASMVT+240
ASMPCMPA EQU   ASMVT+236
ASMPCMPN EQU   ASMVT+232
ASMPCMPD EQU   ASMVT+228
ASMPEX   EQU   ASMVT+224
ASMVRMTR EQU   ASMVT+220
ASMPSRBC EQU   ASMVT+216
ASMPSRMT EQU   ASMVT+212
ASMPSWPD EQU   ASMVT+208
ASMPTM   EQU   ASMVT+204
ASMPFRSW EQU   ASMVT+200
ASMPFRSL EQU   ASMVT+196
ASMPQIOE EQU   ASMVT+192
ASMRSV8  EQU   ASMVT+188
ASMVSAMW EQU   ASMVT+184
ASMTASCB EQU   ASMVT+180
ASMRLGWQ EQU   ASMVT+176
ASMRLGRQ EQU   ASMVT+172
ASMTMECB EQU   ASMVT+168
ASMTCBPT EQU   ASMVT+164
ASMREQCT EQU   ASMVT+160
ASMGOSWK EQU   ASMGOSQS+4
ASMGOSWT EQU   ASMGOSQS
ASMLSAIH EQU   ASMLSAI+4
ASMLSAIL EQU   ASMLSAI
ASMCINV  EQU   ASMVT+140
ASMSTGXA EQU   ASMVT+136
ASMLGVT  EQU   ASMVT+132
ASMSLOTV EQU   ASMVT+128
ASMERRS  EQU   ASMVT+124
ASMNVSC  EQU   ASMVT+120
ASMVSC   EQU   ASMVT+116
ASMSLOTS EQU   ASMVT+112
ASMBKSLT EQU   ASMVT+108
ASMRSV7  EQU   ASMVT+92
ASMPSRB  EQU   ASMVT+88
ASMSRBCT EQU   ASMVT+84
ASMIOCNT EQU   ASMVT+80
ASMBURST EQU   ASMVT+76
ASMPCCWN EQU   ASMVT+72
ASMPCCWC EQU   ASMPCCWQ+4
ASMPCCWA EQU   ASMPCCWQ
ASMRSV6  EQU   ASMVT+48
ASMIORQC EQU   ASMVT+44
ASMIORQR EQU   ASMVT+40
ASMSTAGL EQU   ASMSTAGQ+4
ASMSTAGF EQU   ASMSTAGQ
ASMRSV5  EQU   ASMVT+28
ASMMSGBF EQU   ASMVT+24
ASMEREC  EQU   ASMVT+20
ASMPART  EQU   ASMVT+8
ASMSART  EQU   ASMVT+4
ASMDSSFS EQU   ASMVT+2
ASMWARM  EQU   ASMFLAG2
ASMQUICK EQU   ASMFLAG2
ASMNOTPT EQU   ASMFLAG2
ASMNOTMR EQU   ASMFLAG2
ASMNOSAV EQU   ASMFLAG2
ASMCALLQ EQU   ASMFLAG2
ASMPLPAS EQU   ASMFLAG1
ASMCOMMF EQU   ASMFLAG1
ASMPLPAF EQU   ASMFLAG1
ASMNODPX EQU   ASMFLAG1
ASMRSV1  EQU   ASMFLAG1
ASMNOLCL EQU   ASMFLAG1
ASMNOCWQ EQU   ASMFLAG1
ASMDUPLX EQU   ASMFLAG1
FRRSPARM EQU   FRRSENTR+8
@NM00050 EQU   FRRSFLGS+1
@NM00049 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSCURR EQU   FRRSHEAD+12
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
RCARETAD EQU   RCA+20
RCATASID EQU   RCA+18
RCAREP1  EQU   RCANAME6
RCAPSIF  EQU   RCANAME6
RCAPSIX  EQU   RCANAME6
RCAVEQRP EQU   RCANAME6
RCARCFC  EQU   RCANAME6
RCACSGB  EQU   RCANAME6
RCAFXL   EQU   RCANAME6
RCAPS113 EQU   RCANAME6
RCAFREE  EQU   RCANAME5
RCARFR2  EQU   RCANAME5
RCACPBR  EQU   RCANAME5
RCAOPBR  EQU   RCANAME5
RCASORT  EQU   RCANAME5
RCASIRT  EQU   RCANAME5
RCARELV  EQU   RCANAME5
RCARELF  EQU   RCANAME5
RCAGFAD  EQU   RCANAME4
RCAVEQRI EQU   RCANAME4
RCAVEQRF EQU   RCANAME4
RCAVEQRC EQU   RCANAME4
RCATERM  EQU   RCANAME4
RCASQA   EQU   RCANAME4
RCASWIN  EQU   RCANAME4
RCASOUT  EQU   RCANAME4
RCARFR   EQU   RCANAME3
RCARELS  EQU   RCANAME3
RCARCFI  EQU   RCANAME3
RCARCF   EQU   RCANAME3
RCAPSII  EQU   RCANAME3
RCAPSIB  EQU   RCANAME3
RCAPS112 EQU   RCANAME3
RCAPIX   EQU   RCANAME3
RCAPIOP  EQU   RCANAME2
RCASWPC  EQU   RCANAME2
RCASWPP  EQU   RCANAME2
RCAPFTE  EQU   RCANAME2
RCAPCB   EQU   RCANAME2
RCAOUT   EQU   RCANAME2
RCAITAS  EQU   RCANAME2
RCAIOCP  EQU   RCANAME2
RCAINV   EQU   RCANAME1
RCAGFA   EQU   RCANAME1
RCAFXLD  EQU   RCANAME1
RCAVEQR  EQU   RCANAME1
RCADSEG  EQU   RCANAME1
RCADLAS  EQU   RCANAME1
RCACSEG  EQU   RCANAME1
@NM00048 EQU   RCAFLAGS
RCADISP  EQU   RCAFLAGS
@NM00047 EQU   RCAFLAGS
RCAQS    EQU   RCAFLAGS
RCAPSIER EQU   RCAFLAGS
RCAABEND EQU   RCAFLAGS
RCALL    EQU   RCAFLAGS
@NM00046 EQU   RCANAME7
RCAPRSS  EQU   RCANAME7
RCAPRSR  EQU   RCANAME7
RCAPRSB  EQU   RCANAME7
RCAPSIY  EQU   RCANAME7
RCAPIOI  EQU   RCANAME7
RCAPARM1 EQU   RCA+4
RCAPARM0 EQU   RCA
@NM00045 EQU   PGTBITS
@NM00044 EQU   PGTBITS
@NM00043 EQU   PGTBITS
@NM00042 EQU   PGTBITS
@NM00041 EQU   PGTBITS
@NM00040 EQU   PGTBITS
PGTREAL  EQU   PGTRSA
XPTLSID2 EQU   XPTLPN
@NM00039 EQU   XPTFLAG2
XPTRES1  EQU   XPTFLAG2
XPTRSV4  EQU   XPTFLAGS
XPTRES2  EQU   XPTFLAGS
@NM00038 EQU   XPTFLAGS
XPTCKF   EQU   XPTFLAGS
XPTRSV1  EQU   XPTE+1
PCBRWRKB EQU   PCBR+60
PCBRWRKA EQU   PCBR+56
PCBRWRK9 EQU   PCBR+52
PCBRWRK8 EQU   PCBR+48
PCBRWRK7 EQU   PCBR+44
PCBRWRK6 EQU   PCBR+40
PCBRWRK5 EQU   PCBR+36
PCBRWRK4 EQU   PCBR+32
PCBRWRK3 EQU   PCBR+28
PCBRWRK2 EQU   PCBR+24
PCBRWRK1 EQU   PCBR+20
PCBRRSV1 EQU   PCBR+18
PCBRASCB EQU   PCBR+12
PCBRECB  EQU   PCBR+8
PCBRTCBA EQU   PCBRTCB+1
PCBRPOF  EQU   PCBRFLAG
PCBRFECB EQU   PCBRFLAG
PCBRLOAD EQU   PCBRFLAG
PCBRFAIL EQU   PCBRFLAG
PCBRFPCB EQU   PCBRFLAG
PCBRPB   EQU   PCBRFLAG
PCBRETRY EQU   PCBRFLAG
PCBRINT  EQU   PCBRFLAG
PCBEND   EQU   PCB+64
PCBSPCTE EQU   PCBRB
PCBSWPS2 EQU   PCBFL3
@NM00037 EQU   PCBFL3
PCBDFRLS EQU   PCBFL3
PCBSWPLS EQU   PCBFL3
PCBSWPS1 EQU   PCBFL3
PCBSWPIN EQU   PCBFL3
PCBSWPOT EQU   PCBFL3
@NM00036 EQU   PCBFL2
@NM00035 EQU   PCBFL2
PCBSUPRS EQU   PCBFL2
PCBIOERR EQU   PCBFL2
PCBGFAD  EQU   PCBFL2
PCBFXC   EQU   PCBRLP
PCBLFR   EQU   PCBFL1
PCBLLHLD EQU   PCBFL1
PCBPEX   EQU   PCBFL1
@NM00034 EQU   PCBFL1
PCBBQPA  EQU   PCBBQP
PCBCQN   EQU   PCBFQP
@NM00033 EQU   PFTFLAG2
@NM00032 EQU   PFTFLAG2
PFTPREF  EQU   PFTFLAG2
PFTSTEAL EQU   PFTFLAG2
PFTVR    EQU   PFTFLAG2
PFTOFFLN EQU   PFTFLAG2
PFTDFRLS EQU   PFTFLAG2
PFTVRALC EQU   PFTFLAG1
PFTVRPLT EQU   PFTFLAG1
PFTONAVQ EQU   PFTFLAG1
PFTRSV1  EQU   PFTE+10
PFTFXCT  EQU   PFTE+8
PFTBQPTR EQU   PFTQPTRS+2
PFTFQPTR EQU   PFTQPTRS
RSMASMHD EQU   RSMHD+40
RSMFOEQ  EQU   RSMHD+36
RSMLIOQL EQU   RSMLIOQ+4
RSMLSQAL EQU   RSMLSQA+2
RSMLSQAF EQU   RSMLSQA
RSMLFQL  EQU   RSMLFQ+2
RSMLFQF  EQU   RSMLFQ
RSMRSV2  EQU   RSMHD+16
RSMCNTFX EQU   RSMHD+14
RSMRSV1  EQU   RSMHD+13
@NM00031 EQU   RSMFLG1
RSMFAIL  EQU   RSMFLG1
RSMGFADD EQU   RSMFLG1
RSMCPNC  EQU   RSMFLG1
RSMCPNU  EQU   RSMFLG1
RSMGFAD  EQU   RSMFLG1
RSMIOCPC EQU   RSMFLG1
RSMIOCPU EQU   RSMFLG1
RSMSPCT  EQU   RSMHD+4
RSMVSTO  EQU   RSMHD
@NM00030 EQU   VCBCPFLG
@NM00029 EQU   VCBCPFLG
@NM00028 EQU   VCBCPFLG
VCBRSV3  EQU   VCBOPFLG
VCBRSV2  EQU   VCBOPFLG
VCBRSV1  EQU   VCBOPFLG
WSACASMS EQU   WSAC+60
WSACASMD EQU   WSAC+56
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACACR  EQU   WSAC+16
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACGTF  EQU   WSAC+4
WSACCWSA EQU   WSAC
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGGMFM EQU   WSAG+4
WSAGPGIO EQU   WSAG
WSALACHP EQU   WSAL+56
WSALEVNT EQU   WSAL+48
WSALSTAE EQU   WSAL+44
WSALSTAT EQU   WSAL+40
WSALWAIT EQU   WSAL+36
WSALPOST EQU   WSAL+32
WSALEXIT EQU   WSAL+28
WSALS2EE EQU   WSAL+24
WSALCIRB EQU   WSAL+20
WSALABTM EQU   WSAL+16
WSALSDMP EQU   WSAL+12
WSALRTM2 EQU   WSAL+8
WSALVALC EQU   WSAL+4
WSALCWSA EQU   WSAL
OUXBEND  EQU   OUXB+144
OUXBTSW  EQU   OUXB+140
OUXBFIXC EQU   OUXB+138
OUXBNVC  EQU   OUXB+136
OUXBUIC  EQU   OUXB+134
OUXBVSC  EQU   OUXB+132
OUXBILS  EQU   OUXB+128
OUXBRSV1 EQU   OUXB+126
OUXBWCT  EQU   OUXB+124
OUXBPRS  EQU   OUXB+120
OUXBSTD  EQU   OUXB+116
OUXBITD  EQU   OUXB+112
OUXBMSS  EQU   OUXB+104
OUXBCPS  EQU   OUXB+96
OUXBAET  EQU   OUXB+92
OUXBTRR  EQU   OUXB+88
OUXBJBR  EQU   OUXB+84
OUXBTRT  EQU   OUXB+80
OUXBTRS  EQU   OUXB+76
OUXBJBT  EQU   OUXB+72
OUXBJBS  EQU   OUXB+68
OUXBTRC  EQU   OUXB+64
OUXBNQT  EQU   OUXB+60
OUXBIOSM EQU   OUXB+56
OUXBSTC  EQU   OUXB+54
OUXBIOS  EQU   OUXB+52
OUXBSTCT EQU   OUXB+48
OUXBCAPR EQU   OUXB+44
OUXBCAPI EQU   OUXB+40
OUXBVAMI EQU   OUXB+28
OUXBPREC EQU   OUXB+24
OUXBPOUT EQU   OUXB+20
OUXBPIN  EQU   OUXB+16
OUXBRSW  EQU   OUXB+12
OUXBMET  EQU   OUXB+8
OUXBPET  EQU   OUXB+4
OUXBNAME EQU   OUXB
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
PVTEND   EQU   PVT+1944
PVTTASID EQU   PVT+1942
PVTXXXXX EQU   PVT+1940
PVTMVCLC EQU   PVT+1936
PVTVCONS EQU   PVT+1896
PVTPRSB  EQU   PVT+1892
PVTCIOQL EQU   PVTPCBQS+36
PVTCIOQF EQU   PVTPCBQS+32
PVTGFADL EQU   PVTPCBQS+28
PVTFPCBL EQU   PVTPCBQS+20
PVTFPCBF EQU   PVTPCBQS+16
PVTPCBQR EQU   PVTPCBQS
PVTLPAFX EQU   PVT+1850
PVTLSQAF EQU   PVT+1848
PVTLPAR  EQU   PVT+1844
PVTLPAI  EQU   PVT+1840
PVTLPAFC EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTCOMFX EQU   PVT+1834
PVTSQAFX EQU   PVT+1832
PVTCNTFX EQU   PVT+1830
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTMAXFX EQU   PVT+1822
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA7  EQU   PVTWSAX+432
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTPFTQR EQU   PVTQS+20
PVTRSBQL EQU   PVTQS+18
PVTRSBQF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPRELF EQU   PVT+216
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPSRBP EQU   PVT+188
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP   EQU   PVT+112
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPGFA  EQU   PVT+84
PVTPSQA  EQU   PVT+80
PVTPSIB  EQU   PVT+72
PVTSRBID EQU   PVT+68
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTREUS  EQU   PVT+48
PVTSQNPC EQU   PVT+47
PVTSQVRC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTPCBLO EQU   PVT+38
PVTPCBCT EQU   PVT+36
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
@NM00003 EQU   PVTFLAG2
PVTRSMGM EQU   PVTFLAG2
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTAPREF EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00027 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00026 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00025 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00024 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00023 EQU   FLCFSA
@NM00022 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00021 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00020 EQU   FLCIOA
@NM00019 EQU   FLCMCLA+15
@NM00018 EQU   FLCMCLA+14
@NM00017 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00016 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00015 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00014 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00013 EQU   FLCPER
@NM00012 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00011 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00010 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00009 EQU   FLCPIILC
@NM00008 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00007 EQU   FLCSVILC
@NM00006 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00005 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00004 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RT00144 EQU   EXIT
@RF00160 EQU   ASMCK
@RT00248 EQU   REGASIGN
@RT00409 EQU   EFIX
@RT00411 EQU   NULLMOVE
@RT00413 EQU   TCHGBIT
@RC00463 EQU   CLRPGTE
@RF00478 EQU   PAGEOUT
@RT00508 EQU   CONNECT
@RT00514 EQU   RECLAIM
@RC00481 EQU   NORECLM
@RF00524 EQU   NORECLM
@RT00540 EQU   CLRPGTE
@RT00579 EQU   IDERROR
@RF00587 EQU   @RC00574
@RC00576 EQU   @RC00574
@RT00609 EQU   IOQSRCH
@RF00609 EQU   AUXTEST
@RT00617 EQU   GFADEFR
@RF00621 EQU   SRCHRLTE
@RF00638 EQU   @RC00636
@RC00640 EQU   @RC00636
@RT00651 EQU   IDERROR
@RT00654 EQU   IDERROR
@RF00669 EQU   @RC00667
@RF00672 EQU   @RC00667
@RF00709 EQU   AUXTEST
@RT00777 EQU   VCBCK
@RT00818 EQU   CALLIO
@ENDDATA EQU   *
         END   IEAVAMSI,(C'PLS1146',0701,78164)
