         TITLE 'IEAVFXLD: PAGE FIX/LOAD'
IEAVFXLD CSECT
         USING *,15
         MODID BR=NO
         ENTRY IEAVFXL2
IEAVFXL2 DS    0H
         ST    @14,CIWRETRN(CIWAPTR)        SAVE RETURN REGISTER
         BALR  @09,@00                      ESTABLISH ADDRESSABILITY
         USING *,@09
*   RCAFXLD='1'B;                   /* SET ENTRY POINT FLAG          */
         L     @14,RCAPTR(,PVTPTR)                                 0096
         OI    RCAFXLD(@14),B'00000100'                            0096
*   RCACSECT=RCACPGFL;              /* SET MODULE ID                 */
         MVI   RCACSECT(@14),X'16'                                 0097
*                                                                  0098
*   /*****************************************************************/
*   /*                                                               */
*   /* LOOPVSL --- THIS IS THE LARGEST LOOP OF FIX/LOAD. THE FIRST   */
*   /* VSL ENTRY TO BE PROCESSED IS IN THE CIWVSL. THE START AND END */
*   /* ADDRESSES ARE COMPARED, AND THE LOOP BROKEN WHEN START IS     */
*   /* GREATER THAN END. THE LAST PAGE TO BE PROCESSED, CIWLSTPG, IS */
*   /* CALCULATED BY TRUNCATING CIWEND1A - 1 TO A PAGE BOUNDRY. THE  */
*   /* START ADDRESS IS TRUNCATED TO A PAGE BOUNDRY AND STORED IN    */
*   /* CIWCURPG. CONTROL THEN FALLS TO NEXTPGLP. CONTROL WILL RETURN */
*   /* TO VSLLOOP WHEN THE NEXTVSL MODULE IS CALLED AND RETURNS A    */
*   /* CODE OF ZERO.                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0098
*LOOPVSL:                                                          0098
*   IF CIWSTRTA>=CIWEND1A THEN      /* IF STARTING ADDRESS IS GREATER
*                                      THEN ENDING ADDRESS           */
LOOPVSL  CLC   CIWSTRTA(3,CIWAPTR),CIWEND1A(CIWAPTR)               0098
         BL    @RF00098                                            0098
*     DO;                                                          0099
*       CIWRETC=16;                 /* SET CIW RETURN CODE TO 16     */
         MVI   CIWRETC(CIWAPTR),X'10'                              0100
*       GOTO ERREXITA;              /* ERROR-START GREATER THEN END  */
         B     ERREXITA                                            0101
*     END;                                                         0102
*   RFY                                                            0103
*    (WORKREG,                                                     0103
*     TESTADDR,                                                    0103
*     REALPGR) RSTD;                                               0103
@RF00098 DS    0H                                                  0104
*   WORKREG=CIWEND1A-1;             /* LOAD THE LAST PAGE POINTER    */
         SLR   WORKREG,WORKREG                                     0104
         ICM   WORKREG,7,CIWEND1A(CIWAPTR)                         0104
         BCTR  WORKREG,0                                           0104
*   WORKREG=WORKREG&TRUNCWD;        /* TRUNCATE TO PAGE BOUNDRY      */
         L     @14,@CF02248                                        0105
         NR    WORKREG,@14                                         0105
*   CIWLSTPG=WORKREG;               /* STORE ROUNDED PAGE ADDRESS    */
         ST    WORKREG,CIWLSTPG(,CIWAPTR)                          0106
*   TESTADDR=CIWSTRTA;              /* LOAD START ADDRESS OF PAGE    */
         SLR   TESTADDR,TESTADDR                                   0107
         ICM   TESTADDR,7,CIWSTRTA(CIWAPTR)                        0107
*   TESTADDR=TESTADDR&TRUNCWD;      /* TRUNCATE TO PAGE BOUNDRY      */
         NR    TESTADDR,@14                                        0108
*                                                                  0109
*   /*****************************************************************/
*   /*                                                               */
*   /* NEXTPGLP --- THIS LOOP PROCESSES THE PAGE ADDRESSED IN        */
*   /* CIWCURPG. AFTER THE CURRENT PAGE IS PROCESSED, CONTROL WILL   */
*   /* RETURN TO THIS POINT FROM PAGELOOP IF THERE IS ANOTHER PAGE TO*/
*   /* PROCESS. NEXTPGLP PROCESSING FIRST DETERMINES IF THE PAGE IS  */
*   /* RESIDENT IN STOREAGE OR NOT, THE LRA INSTRUCTION PERFORMING   */
*   /* THIS TEST. IF THE PAGE IS IN AN INVALID SEGMENT, A USER ERROR */
*   /* IS INDICATED. IF NOT INVALID, FINDPAGE IS CALLED TO OBTAIN    */
*   /* PGTE AND XPTE ADDRESSES. THE PGTPAM FLAG IS TESTED TO INSURE  */
*   /* THAT THE PAGE IS GETMAINED. THE RESIDENCY OF THE PAGE IS THEN */
*   /* TESTED. IF AN IN STORAGE PAGE, ( PGTPVM=0 ), PROCESSING FALLS */
*   /* THROUGH TO THE IN STORAGE CODE, ELSE CONTROL IS PASSED TO THE */
*   /* OUTOFSTG ROUTINE.                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0109
*NEXTPGLP:                                                         0109
*   CIWCURPG=TESTADDR;              /* STORE CURRENT PAGE ADDRESS    */
NEXTPGLP ST    TESTADDR,CIWCURPG(,CIWAPTR)                         0109
*   GENERATE REFS(TESTADDR) SETS(REALPGR);                         0110
         LRA    REALPGR,0(TESTADDR)    DETERMINE IF SEGMENT IS VALID
*   RFY                                                            0111
*    (WORKREG,                                                     0111
*     REALPGR) UNRSTD;                                             0111
*   BC(5,ERREXIT);                  /* PAGE RESIDES IN INVALID     0112
*                                      SEGMENT OR SEGMENT LENGTH   0112
*                                      VIOLATION                     */
         BC    5,ERREXIT                                           0112
*   RFY                                                            0113
*    (R0,                                                          0113
*     R1) RSTD;                                                    0113
*   R1=TESTADDR;                    /* LOAD ADDRESS FOR FINDPAGE. REG
*                                      1 IS A CONVENTION AND MUST NOT
*                                      CHANGE                        */
         LR    R1,TESTADDR                                         0114
*   CALL IEAVFP2;                   /* GET PGTBL AND XPGTBL PTRS     */
         L     @15,PVTPFP2(,PVTPTR)                                0115
         BALR  @14,@15                                             0115
*   IF RETCODR^=0 THEN              /* IF FINDPAGE RETURNS A NONZERO
*                                      RETURN CODE                   */
         LTR   RETCODR,RETCODR                                     0116
         BZ    @RF00116                                            0116
*     DO;                                                          0117
*       RCARCRD='01'X;              /* SET RECOVERY CODE             */
         L     @14,RCAPTR(,PVTPTR)                                 0118
         MVI   RCARCRD(@14),X'01'                                  0118
*       GENERATE SETS(R1);                                         0119
         ABEND  X'C0D',,,SYSTEM        ISSUE ABEND FOR FINDPAGE FAIL
*       GOTO ERREXIT;               /* ERROR-FINDPAGE FAILED         */
         B     ERREXIT                                             0120
*     END;                                                         0121
*   RFY                                                            0122
*    (PTEPTR,                                                      0122
*     XPTEPTR) RSTD;                                               0122
@RF00116 DS    0H                                                  0123
*   PTEPTR=R0;                      /* LOAD PAGE TABLE PTR AS      0123
*                                      RETURNED BY FINDPAGE          */
         LR    PTEPTR,R0                                           0123
*   XPTEPTR=R1;                     /* LOAD EXT PAGE TABLE PTR AS  0124
*                                      RETURNED BY FINDPAGE          */
         LR    XPTEPTR,R1                                          0124
*   RFY                                                            0125
*    (R0,                                                          0125
*     R1) UNRSTD;                                                  0125
*   IF PGTPAM='0'B THEN             /* IF PAGE IS NOT GM ASSIGNED    */
         TM    PGTPAM(PTEPTR),B'00000001'                          0126
         BZ    @RT00126                                            0126
*     GOTO ERREXIT;                 /* ERROR-PAGE NOT GM ASSIGNED    */
*   IF PGTPVM='1'B THEN             /* IF PAGE IS NOT IN REAL CORE   */
         TM    PGTPVM(PTEPTR),B'00001000'                          0128
         BO    @RT00128                                            0128
*     GOTO OUTOFSTG;                /* GO TO THE OUT OF STG ROUTINE  */
*                                                                  0130
*   /*****************************************************************/
*   /*                                                               */
*   /* IN STORAGE PROCESSING --- AN IMMEDIATE TEST IS MADE TO        */
*   /* DETERMINE IF A FIX OR A LOAD IS REQUESTED. FOR LOAD REQUESTS, */
*   /* NO IN-STORAGE PROCESSING IS REQUIRED. FOR FIX REQUESTS, THE   */
*   /* PAGE MUST BE MADE NON-PAGEABLE. IF THE VIRTUAL ADDRESS IS     */
*   /* BELOW THE PRIVATE AREA IT IS ASSUMED TO BE IN THE NUCLEUS AND */
*   /* IS ALREADY FIXED, OTHERWISE THE PFTE MUST BE LOCATED TO       */
*   /* DETERMINE IF THE PAGE IS IN SQA, LSQA, OR IF IT IS A V=R      */
*   /* ALLOCATED PAGE. IF SO, IT IS NON-PAGEABLE AND FIXING IS NOT   */
*   /* REQUIRED. IF A FIX IS REQUESTED FOR A VAM PAGE, AN ERROR      */
*   /* CONDITION EXISTS. IF THE PAGE IS FIXABLE AND NOT ALREADY FIXED*/
*   /* AND BACKED BY A NON-PREFERRED PAGE FURTHER CHECKS ARE MADE TO */
*   /* DETERMINE IF THE PAGE SHOULD BE FIXED IN THE PREFERRED AREA.  */
*   /* PAGES SHOULD BE FIXED IN THE PREFERRED AREA IF IT IS (1) A    */
*   /* COMMON AREA PAGE OR (2) IT IS A PRIVATE AREA PAGE AND THE USER*/
*   /* IS A SECOND LEVEL PREFERRED USER OR (3) THE REQUEST IS FOR A  */
*   /* LONG-TERM PRIVATE AREA FIX AND USER IS A FIRST LEVEL PREFERRED*/
*   /* USER.                                                 @ZA16816*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0130
*   IF CIWFIX='1'B THEN             /* IF THIS IS A FIX REQUEST, IN
*                                      STORAGE PROCESSING IS REQUIRED*/
         TM    CIWFIX(CIWAPTR),B'01000000'                         0130
         BNO   @RF00130                                            0130
*     DO;                                                          0131
*       IF CURVBN<PVTLPRIV THEN     /* IF PAGE IS WITHIN NUCLEUS     */
         CLC   CURVBN(2,CIWAPTR),PVTLPRIV(PVTPTR)                  0132
         BL    @RT00132                                            0132
*         GOTO PAGELOOP;            /* NO FIXING REQUIRED            */
*       RFY                                                        0134
*        (PFTEPTR) RSTD;                                           0134
*       PFTEPTR=PGTRSA;             /* LOAD INDEX FOR PFTE           */
         SLR   PFTEPTR,PFTEPTR                                     0135
         ICM   PFTEPTR,3,PGTRSA(PTEPTR)                            0135
*       PFTEPTR=PFTEPTR&ANDWORD;    /* FORCE LOW FOUR BITS TO ZERO   */
         N     PFTEPTR,@CF02250                                    0136
*       SAVWRK2=PFTEPTR;            /* SAVE RBN                      */
         ST    PFTEPTR,SAVWRK2(,PVTPTR)                            0137
*       PFTEPTR=PFTEPTR+PVTPFTP;    /* CALCULATE FULL ADDRESS OF PFTE*/
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0138
*       IF PFTLSQA='1'B|PFTVRALC='1'B THEN/* IF THE PAGE IS IN SQA OR
*                                      LSQA, OR IF THE PAGE IS A V=R
*                                      ALLOCATED PAGE                */
         TM    PFTLSQA(PFTEPTR),B'00100010'                        0139
         BNZ   @RT00139                                            0139
*         GOTO PAGELOOP;            /* NO FIXING REQUIRED            */
*       IF XPTVIO='1'B THEN         /* VIO WINDOW PAGES CANNOT BE  0141
*                                      FIXED                 @Z40WPYD*/
         TM    XPTVIO(XPTEPTR),B'00001000'                         0141
         BO    @RT00141                                            0141
*         GOTO ERREXIT;             /* ERROR - CANT FIX VIO PAGES    */
*       IF PFTPREF='0'B&            /* FRAME IS NON-PREFERRED      0143
*                                                            @ZA16816*/
*           PFTFXCT=0 THEN          /* AND NOT ALREADY FIXED @ZA16816*/
         TM    PFTPREF(PFTEPTR),B'00000100'                        0143
         BNZ   @RF00143                                            0143
         ICM   @14,3,PFTFXCT(PFTEPTR)                              0143
         BNZ   @RF00143                                            0143
*         DO;                       /* CHECK FURTHER---      @ZA16816*/
*           IF CURVBN>=PVTLCSA THEN /* IF COMMON AREA, THEN  @ZA16816*/
         CLC   CURVBN(2,CIWAPTR),PVTLCSA(PVTPTR)                   0145
         BNL   @RT00145                                            0145
*             GOTO OUTOFSTG;        /* FIX IN PREFERRED AREA @ZA16816*/
*           IF ASCB1LPU='1'B THEN   /* IF LEV 1 USER, FIX IN @ZA16816*/
         L     @14,ASCBPTR                                         0147
         TM    ASCB1LPU(@14),B'01000000'                           0147
         BNO   @RF00147                                            0147
*             IF CIWLONG='1'B|      /* PREF AREA IF LONG-FIX @ZA16816*/
*                 ASCB2LPU='1'B THEN/* OR IF LEV 2 USER, ANY @ZA16816*/
         TM    CIWLONG(CIWAPTR),B'00000010'                        0148
         BO    @RT00148                                            0148
         TM    ASCB2LPU(@14),B'10000000'                           0148
         BO    @RT00148                                            0148
*               GOTO OUTOFSTG;      /* FIX GOES IN PREFERRED @ZA16816*/
*         END;                      /*                       @ZA16816*/
@RF00147 DS    0H                                                  0151
*       PFTFXCT=PFTFXCT+1;          /* INCREMENT FXCT        @ZA16816*/
@RF00143 LA    @14,1                                               0151
         AH    @14,PFTFXCT(,PFTEPTR)                               0151
         STH   @14,PFTFXCT(,PFTEPTR)                               0151
*       RFY                                                        0152
*        (INPUTVBN) RSTD;                                          0152
*       INPUTVBN=CURVBN;            /* LOAD PARM FOR FOEADD          */
         SLR   INPUTVBN,INPUTVBN                                   0153
         ICM   INPUTVBN,3,CURVBN(CIWAPTR)                          0153
*       CALL FOEADD;                /* CALL ROUTINE TO ADD FOE TO  0154
*                                      LIST                          */
         BAL   @14,FOEADD                                          0154
*       IF RETCODR^=0 THEN          /* IF FOEADD HAD GETMAIN FAILURE */
         LTR   RETCODR,RETCODR                                     0155
         BZ    @RF00155                                            0155
*         DO;                                                      0156
*           PFTFXCT=PFTFXCT-1;      /* RESTORE FIX COUNT     @ZA16816*/
         LH    @14,PFTFXCT(,PFTEPTR)                               0157
         BCTR  @14,0                                               0157
         STH   @14,PFTFXCT(,PFTEPTR)                               0157
*           CIWRETC=20;             /* MARK ENVIRONMENTAL ERROR      */
         MVI   CIWRETC(CIWAPTR),X'14'                              0158
*           GOTO ERREXITA;          /* ERROR-FOE GETMAIN FAILED      */
         B     ERREXITA                                            0159
*         END;                                                     0160
*       IF PFTFXCT=1 THEN           /*                       @YA01572*/
@RF00155 LA    @14,1                                               0161
         CH    @14,PFTFXCT(,PFTEPTR)                               0161
         BNE   @RF00161                                            0161
*         DO;                       /*                       @YA01572*/
*           IF PFTQNDX<PFTLFQN THEN /* IS IT A GLOBAL Q      @YA01572*/
         CLI   PFTQNDX(PFTEPTR),X'80'                              0163
         BNL   @RF00163                                            0163
*             PVTCOMFX=PVTCOMFX+1;  /* INCREMENT COUNT       @YA01572*/
         AH    @14,PVTCOMFX(,PVTPTR)                               0164
         STH   @14,PVTCOMFX(,PVTPTR)                               0164
*           ELSE                    /* NO, IT IS LOCAL Q     @YA01572*/
*             RSMCNTFX=RSMCNTFX+1;  /* INCREMENT COUNT       @YA01572*/
         B     @RC00163                                            0165
@RF00163 LA    @14,1                                               0165
         AH    @14,RSMCNTFX(,RSMHDPTR)                             0165
         STH   @14,RSMCNTFX(,RSMHDPTR)                             0165
*           PVTCNTFX=PVTCNTFX+1;    /* INCREMENT PVTCNTFX    @YA01572*/
@RC00163 LA    @14,1                                               0166
         AH    @14,PVTCNTFX(,PVTPTR)                               0166
         STH   @14,PVTCNTFX(,PVTPTR)                               0166
*           IF PVTCNTFX=PVTMAXFX THEN/* CHECK THRESHOLD      @YA01572*/
         CH    @14,PVTMAXFX(,PVTPTR)                               0167
         BNE   @RF00167                                            0167
*             DO;                   /*                       @YA01572*/
*               RESPECIFY                                          0169
*                (R1,                                              0169
*                 R13) RESTRICTED;                                 0169
*               R13=ADDR(PVTSAVE);  /* SAVE AREA FOR SRM     @YA01572*/
         LA    R13,PVTSAVE(,PVTPTR)                                0170
*               R1=MAXSYS;          /* CODE FOR MAX FIX-COUNT      0171
*                                      THRESHOLD REACHED     @YA01572*/
         LA    R1,4                                                0171
*               GENERATE NODEFS REFS(CVTPTR,CVTOPTE,CVT) NOSETS NOFLOWS
*                   ;                                              0172
              SYSEVENT  AVQLOW,ENTRY=BRANCH
*               RESPECIFY                                          0173
*                (R1,                                              0173
*                 R13) UNRESTRICTED;                               0173
*             END;                  /* THRESHOLD REACHED     @YA01572*/
*           ELSE                                                   0175
*             ;                     /* NOT REACHED           @YA01572*/
@RF00167 DS    0H                                                  0176
*         END;                      /* END PFTFXCT= 0        @YA01572*/
*       ELSE                                                       0177
*         ;                         /* PFTFXCT NOT ZERO      @YA01572*/
@RF00161 DS    0H                                                  0178
*       RFY                                                        0178
*        (PFTEPTR,                                                 0178
*         INPUTVBN) UNRSTD;                                        0178
*     END;                                                         0179
*                                                                  0180
*   /*****************************************************************/
*   /*                                                               */
*   /* PAGELOOP --- THIS ROUTINE IS NOT REALLY A LOOP, BUT A         */
*   /* CALCULATION AND TEST THAT EITHER RETURNS TO LOOPVSL OR        */
*   /* NEXTPGLP AS REQUIRED, OR PASSES CONTROL TO THE ERREXIT OR     */
*   /* NORMEXIT AS REQUIRED. IF ONE PAGE PAST THE CURRENT PAGE IS NOT*/
*   /* GREATER THAN CIWLSTPG, THEN NEXTPGLP IS GIVEN CONTROL TO      */
*   /* PROCESS THE NEXT PAGE. OTHERWISE THE NEXTVSL ROUTINE IS       */
*   /* CALLED. IF NEXTVSL RETURNS ANOTHER VSL LIST CONTROL IS PASSED */
*   /* TO VSLLOOP. IF NEXTVSL RETURNS AN ERROR CODE THE ERREXITA     */
*   /* ROUTINE IS CALLED. IF NO ERROR AND NO VSL LIST IS RETURNED,   */
*   /* THE NORMEXIT ROUTINE IS CALLED.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0180
*PAGELOOP:                                                         0180
*   TESTADDR=CIWCURPG+BLOCKSIZ;     /* UPDATE TO NEXT PAGE           */
@RF00130 DS    0H                                                  0180
PAGELOOP LH    TESTADDR,@CH02252                                   0180
         AL    TESTADDR,CIWCURPG(,CIWAPTR)                         0180
*   IF TESTADDR^>CIWLSTPG THEN      /* IF THIS PAGE IS TO BE       0181
*                                      PROCESSED                     */
         C     TESTADDR,CIWLSTPG(,CIWAPTR)                         0181
         BNH   @RT00181                                            0181
*     GOTO NEXTPGLP;                /* GO TO PAGE PROCESSING LOOP    */
*   IF CIWINVSL^=0 THEN             /* IF NOT A REGISTER FORM ENTRY  */
         SLR   @14,@14                                             0183
         C     @14,CIWINVSL(,CIWAPTR)                              0183
         BE    @RF00183                                            0183
*     DO;                                                          0184
*       CIWCURPG=0;                 /* CLEAR                         */
         ST    @14,CIWCURPG(,CIWAPTR)                              0185
*       CIWLSTPG=0;                 /* CLEAR                         */
         ST    @14,CIWLSTPG(,CIWAPTR)                              0186
*       CALL NEXTVSL;               /* CALL TO GET A NEW VSL ENTRY   */
         L     @15,@CV02299                                        0187
         BALR  @14,@15                                             0187
*       IF RETCODR=0 THEN           /* IF NEXTVSL RETURNED A ZERO  0188
*                                      R.C.                          */
         LTR   RETCODR,RETCODR                                     0188
         BZ    @RT00188                                            0188
*         GOTO LOOPVSL;             /* PROCESS A NEW GROUP           */
*       IF RETCODR^=8 THEN          /* R.C. FROM NEXTVSL WAS NOT 0,
*                                      AND IS NOT 8                  */
         CH    RETCODR,@CH00059                                    0190
         BE    @RF00190                                            0190
*         DO;                                                      0191
*           CIWRETC=16;             /* SET RETURN CODE TO 16         */
         MVI   CIWRETC(CIWAPTR),X'10'                              0192
*           GOTO ERREXITA;          /* ERROR-BAD RETURN CODE FROM  0193
*                                      NEXTVSL                       */
         B     ERREXITA                                            0193
*         END;                                                     0194
*     END;                                                         0195
*   GOTO NORMEXIT;                  /* NO MORE TO PROCESS, GO TO EXIT*/
         B     NORMEXIT                                            0196
*                                                                  0197
*   /*****************************************************************/
*   /*                                                               */
*   /* OUTOFSTG --- THIS ROUTINE IS PERFORMED FOR BOTH PGFIX AND     */
*   /* PGLOAD IF THE REQUESTED PAGES ARE NOT IN REAL STOREAGE. IF A  */
*   /* FIX HAS BEEN REQUESTED FOR A VIO WINDOW PAGE, CONTROL PASSES  */
*   /* TO THE ERROR ROUTINE, AS WINDOW PAGES CANNOT BE FIXED. IF A   */
*   /* PCB EXISTS ON THE INTERNAL QUEUE (CIWWRK1), CONTROL PASSES TO */
*   /* PAGELOOP FOR LOAD REQUESTS. FOR FIX REQUESTS, AN FOE IS ADDED */
*   /* TO THE LIST BEFORE GOING TO PAGELOOP. IF NO PCB EXISTS, ONE   */
*   /* MUST BE CREATED. A CHECK IS MADE TO DETERMINE IF A LONG FIX   */
*   /* WAS REQUESTED, AS THIS CODE IS USED FOR PCB CREATION FOR PAGES*/
*   /* ALREADY IN REAL CORE BUT IN POTENTIAL V=R FRAMES. THE PCB IS  */
*   /* ASSOCIATED WITH A ROOT PCB IF THE REQUESTOR SUPPLIED AN ECB.  */
*   /* IN THE CASE OF USER REQUESTED LOADS, PROCESSING WILL TERMINATE*/
*   /* IF THE PCB FREE QUEUE BECOMES CRITICALLY LOW (REACHES         */
*   /* THRESHOLD), AND PREVIOUSLY PROCESSED PCBS WILL BE BACKED OUT. */
*   /* IN CASE THE PCB MANAGER RETURNS AN ERROR CODE, THIS ROUTINE   */
*   /* WILL SET RETURN CODE OF 20 FOR FIX REQUESTS, OR ZERO FOR LOAD */
*   /* REQUESTS. OTHERWISE THE PCB IS ADDED TO THE QUEUE             */
*   /* (CIWWRK1-CIWWRK2).                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0197
*   RFY                                                            0197
*    (PCBPTR) RSTD;                                                0197
*OUTOFSTG:                                                         0198
*   IF CIWFIX='1'B&XPTVIO='1'B THEN /* VIO WINDOW PAGES CANT BE FIXED
*                                                            @Z40WPYD*/
OUTOFSTG TM    CIWFIX(CIWAPTR),B'01000000'                         0198
         BNO   @RF00198                                            0198
         TM    XPTVIO(XPTEPTR),B'00001000'                         0198
         BO    @RT00198                                            0198
*     GOTO ERREXIT;                 /* ERROR - CANT FIX WINDOW PAGES */
*   PCBPTR=CIWWRK1;                 /* SET PCBPTR TO FIRST ON QUE    */
*                                                                  0200
@RF00198 L     PCBPTR,CIWWRK1(,CIWAPTR)                            0200
*   /*****************************************************************/
*   /*                                                               */
*   /* TRY TO FIND THE ASSOCIATED PCB                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0201
*   DO WHILE PCBPTR^=0;             /* LOOP AS LONG AS THERE IS A PCB*/
         B     @DE00201                                            0201
@DL00201 DS    0H                                                  0202
*     IF PCBVBN=CURVBN THEN         /* IF THIS PCB IS FOR CURRENT  0202
*                                      PAGE                          */
         CLC   PCBVBN(2,PCBPTR),CURVBN(CIWAPTR)                    0202
         BNE   @RF00202                                            0202
*       DO;                                                        0203
*         IF CIWFIX='0'B THEN       /* IF THIS IS A LOAD REQUEST     */
         TM    CIWFIX(CIWAPTR),B'01000000'                         0204
         BZ    @RT00204                                            0204
*           GOTO PAGELOOP;          /* NO FURTHER OUT OF PAGE      0205
*                                      PROCESSING IS REQUIRED, RETURN
*                                      TO PAGELOOP                   */
*         PCBFXC=PCBFXC+1;          /* INCREMENT FIX COUNT IN PCB    */
         LA    @14,1                                               0206
         SLR   @12,@12                                             0206
         IC    @12,PCBFXC(,PCBPTR)                                 0206
         ALR   @14,@12                                             0206
         STC   @14,PCBFXC(,PCBPTR)                                 0206
*         RFY                                                      0207
*          (INPUTVBN) RSTD;                                        0207
*         INPUTVBN=CURVBN;          /* LOAD PARM FOR FOEADD          */
         SLR   INPUTVBN,INPUTVBN                                   0208
         ICM   INPUTVBN,3,CURVBN(CIWAPTR)                          0208
*         CALL FOEADD;              /* CALL TO ADD FOE TO CHAIN      */
         BAL   @14,FOEADD                                          0209
*         RFY                                                      0210
*          (INPUTVBN) UNRSTD;                                      0210
*         IF RETCODR^=0 THEN        /* IF FOEADD HAD GETMAIN FAILURE */
         LTR   RETCODR,RETCODR                                     0211
         BZ    @RF00211                                            0211
*           DO;                                                    0212
*             CIWRETC=20;           /* MARK ENVIRONMENTAL ERROR      */
         MVI   CIWRETC(CIWAPTR),X'14'                              0213
*             GOTO ERREXITA;        /* ERROR-FOE GETMAIN FAILED      */
         B     ERREXITA                                            0214
*           END;                                                   0215
*         GOTO PAGELOOP;            /* NO FURTHER OUT OF STG       0216
*                                      PROCESSING REQUIRED           */
         B     PAGELOOP                                            0216
*       END;                                                       0217
*     PCBPTR=PCBFQPA;               /* PICK UP NEXT PCB ON CHAIN     */
@RF00202 SLR   @14,@14                                             0218
         ICM   @14,7,PCBFQPA(PCBPTR)                               0218
         LR    PCBPTR,@14                                          0218
*   END;                                                           0219
*                                                                  0219
@DE00201 LTR   PCBPTR,PCBPTR                                       0219
         BNZ   @DL00201                                            0219
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR USER REQUESTED PAGE LOAD, AND GET A PCB AND A ROOT   */
*   /* PCB IF REQUIRED                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0220
*   IF CIWFIX='0'B&CIWKEY>SUPERKEY&PVTPCBCT<=PVTPCBLO THEN/* IF THIS
*                                      IS A LOAD REQUEST FROM A    0220
*                                      NON-SUPERVISOR FUNCTION AND 0220
*                                      THE PCB FREE QUEUE IS       0220
*                                      CRITICALLY LOW                */
         TM    CIWFIX(CIWAPTR),B'01000000'                         0220
         BNZ   @RF00220                                            0220
         CLI   CIWKEY(CIWAPTR),112                                 0220
         BNH   @RF00220                                            0220
         LH    @14,PVTPCBCT(,PVTPTR)                               0220
         CH    @14,PVTPCBLO(,PVTPTR)                               0220
         BH    @RF00220                                            0220
*     DO;                                                          0221
*       CIWRETC=0;                  /* NO ERROR HAS OCCURED          */
         MVI   CIWRETC(CIWAPTR),X'00'                              0222
*       GOTO ERREXITA;              /* STOP PROCESSING AND BACK OUT
*                                      ANY PCBS PREVIOUSLY QUEUED    */
         B     ERREXITA                                            0223
*     END;                                                         0224
*   RFY                                                            0225
*    (R0,                                                          0225
*     R1) RSTD;                                                    0225
@RF00220 DS    0H                                                  0226
*   R1=0;                           /* SPECIFY BUILD OPTION TO PCB 0226
*                                      MGR                           */
         SLR   R1,R1                                               0226
*   IF CIWECB^=0&CIWWRK2=0 THEN     /* IF AN ECB WAS SUPPLIED BY THE
*                                      REQUESTOR AND NO ROOT PCB   0227
*                                      EXISTS                        */
         SLR   @14,@14                                             0227
         C     @14,CIWECB(,CIWAPTR)                                0227
         BE    @RF00227                                            0227
         C     @14,CIWWRK2(,CIWAPTR)                               0227
         BNE   @RF00227                                            0227
*     R0=2;                         /* SET PARM REG FOR PCB MGR TO 0228
*                                      INCLUDE ROOT PCB              */
         LA    R0,2                                                0228
*   ELSE                            /* IF NO ECB, OR IF A ROOT PCB 0229
*                                      EXISTS                        */
*     R0=1;                         /* SET PARM FOR PCB MGR          */
         B     @RC00227                                            0229
@RF00227 LA    R0,1                                                0229
*   CALL IEAVPCB;                   /* CALL PCB MANAGER FOR PCB BUILD*/
@RC00227 L     @15,PVTPCB(,PVTPTR)                                 0230
         BALR  @14,@15                                             0230
*   IF RETCODR^=0 THEN              /* IF PCB MANAGER COULDN'T SUPPLY
*                                      THE REQUIRED PCBS             */
         LTR   RETCODR,RETCODR                                     0231
         BZ    @RF00231                                            0231
*     DO;                                                          0232
*       RCARCRD='0E'X;              /* SET RECOVERY CODE             */
         L     @14,RCAPTR(,PVTPTR)                                 0233
         MVI   RCARCRD(@14),X'0E'                                  0233
*       GENERATE SETS(R1);                                         0234
         ABEND  X'C0D',,,SYSTEM        ABEND TO RECORD INTERNAL ERROR
*       IF CIWFIX='1'B THEN         /* IF THIS IS A FIX REQUEST      */
         TM    CIWFIX(CIWAPTR),B'01000000'                         0235
         BNO   @RF00235                                            0235
*         DO;                                                      0236
*           CIWRETC=20;             /* MARK ENVIRONMENTAL ERROR      */
         MVI   CIWRETC(CIWAPTR),X'14'                              0237
*           GOTO ERREXITA;          /* ERROR-PCB MGR FAILED          */
         B     ERREXITA                                            0238
*         END;                                                     0239
*       ELSE                        /* IF THIS IS A LOAD REQUEST     */
*         GOTO NORMEXIT;            /* STOP PROCESSING AND RETURN    */
*     END;                                                         0241
*   PCBPTR=R1;                      /* LOAD PCB ADDRESS AS RETURNED
*                                      BY PCB MANAGER                */
@RF00231 LR    PCBPTR,R1                                           0242
*   RFY                                                            0243
*    (R0,                                                          0243
*     R1) UNRSTD;                                                  0243
*                                                                  0244
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE PCB AND ROOT PCB IF REQUIRED                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0244
*   RFY                                                            0244
*    (WORKADDR) RSTD;                                              0244
*   IF PCBFQPA^=0 THEN              /* IF A ROOT PCB WAS REQUIRED    */
         SLR   @14,@14                                             0245
         ICM   @14,7,PCBFQPA(PCBPTR)                               0245
         LTR   @14,@14                                             0245
         BZ    @RF00245                                            0245
*     DO;                                                          0246
*       WORKADDR=PCBFQPA;           /* SAVE NEXT PCB POINTER         */
         LR    WORKADDR,@14                                        0247
*       PCBRTCB=CIWTCB;             /* SET ROOT PCB TCB FIELD        */
         MVC   PCBRTCB(4,PCBRPTR),CIWTCB(CIWAPTR)                  0248
*       PCBRECB=CIWECB;             /* SET ROOT PCB ECB FIELD        */
         MVC   PCBRECB(4,PCBRPTR),CIWECB(CIWAPTR)                  0249
*       PCBRASCB=PSAAOLD;           /* SET ROOT PCB ASCB FIELD       */
         MVC   PCBRASCB(4,PCBRPTR),PSAAOLD                         0250
*       PCBRGOTO=ADDR(IEAVFXL);     /* SET ROOT PCB GOTO FIELD TO  0251
*                                      ADDRESS OF IEAVFXL            */
         L     @14,@CA02317                                        0251
         ST    @14,PCBRGOTO(,PCBRPTR)                              0251
*       PCBRFLAG='0'B;              /* SET PCB ROOT FLAGS OFF        */
         MVI   PCBRFLAG(PCBRPTR),B'00000000'                       0252
*       CIWWRK2=PCBRPTR;            /* STORE ADDRESS OF ROOT PCB     */
         ST    PCBRPTR,CIWWRK2(,CIWAPTR)                           0253
*       IF CIWFIX='0'B THEN         /* IF THIS IS A LOAD REQUEST     */
         TM    CIWFIX(CIWAPTR),B'01000000'                         0254
         BNZ   @RF00254                                            0254
*         PCBRLOAD='1'B;            /* SET PAGE LOAD FLAG IN ROOT PCB*/
         OI    PCBRLOAD(PCBRPTR),B'00000100'                       0255
*       PCBPTR=WORKADDR;            /* SET UP PCBPTR FOR REGULAR PCB */
@RF00254 LR    PCBPTR,WORKADDR                                     0256
*     END;                                                         0257
*   RFY                                                            0258
*    (WORKADDR) UNRSTD;                                            0258
@RF00245 DS    0H                                                  0259
*   PCBXPTA=XPTEPTR;                /* LOAD EXTERNAL PAGE TABLE    0259
*                                      ADDRESS                       */
         STCM  XPTEPTR,7,PCBXPTA(PCBPTR)                           0259
*   PCBPGTA=PTEPTR;                 /* LOAD PAGE TABLE ADDRESS       */
         STCM  PTEPTR,7,PCBPGTA(PCBPTR)                            0260
*   PCBVBN=CURVBN;                  /* LOAD VIRTUAL BLOCK NUMBER OF
*                                      PAGE                          */
         MVC   PCBVBN(2,PCBPTR),CURVBN(CIWAPTR)                    0261
*   PCBASCB=PSAAOLD;                /* LOAD ASCB FROM PSA            */
         MVC   PCBASCB(4,PCBPTR),PSAAOLD                           0262
*   IF PCBVBN<PVTLCSA THEN                                         0263
         CLC   PCBVBN(2,PCBPTR),PVTLCSA(PVTPTR)                    0263
         BNL   @RF00263                                            0263
*     PCBPTR->AIAPRIV='1'B;         /* SET PRIVATE AREA FLAG IN AIA
*                                                            @Z40WPYD*/
*                                                                  0264
         OI    AIAPRIV(PCBPTR),B'01000000'                         0264
*   /*****************************************************************/
*   /*                                                               */
*   /* ASSOCIATE ROOT PCB WITH PCB IF REQUIRED, AND CHAIN PCB        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0265
*   IF CIWECB=0 THEN                /* IF NO ECB WAS SUPPLIED BY   0265
*                                      REQUESTER                     */
@RF00263 ICM   @14,15,CIWECB(CIWAPTR)                              0265
         BNZ   @RF00265                                            0265
*     PCBRTPA=CIWTCB;               /* LOAD TCB ADDRESS IN PCB       */
         MVC   PCBRTPA(3,PCBPTR),CIWTCB+1(CIWAPTR)                 0266
*   ELSE                                                           0267
*     DO;                                                          0267
         B     @RC00265                                            0267
@RF00265 DS    0H                                                  0268
*       PCBRTPA=CIWWRK2;            /* LOAD THE ADDRESS OF THE ROOT
*                                      PCB                           */
         L     @14,CIWWRK2(,CIWAPTR)                               0268
         STCM  @14,7,PCBRTPA(PCBPTR)                               0268
*       PCBROOT='1'B;               /* SET THE ROOT POINTER BIT      */
         OI    PCBROOT(PCBPTR),B'00000100'                         0269
*       CIWWRK2->PCBRCNT=CIWWRK2->PCBRCNT+1;/* INCREMENT ROOT COUNT  */
         LA    @12,1                                               0270
         AH    @12,PCBRCNT(,@14)                                   0270
         STH   @12,PCBRCNT(,@14)                                   0270
*     END;                                                         0271
*   PCBFQPA=CIWWRK1;                /* PCB FORWARD POINTER POINTS TO
*                                      FIRST PCB NOW ON QUE          */
@RC00265 MVC   PCBFQPA(3,PCBPTR),CIWWRK1+1(CIWAPTR)                0272
*   CIWWRK1=PCBPTR;                 /* SET QUE HEADER TO POINT TO  0273
*                                      FIRST PCB                     */
         ST    PCBPTR,CIWWRK1(,CIWAPTR)                            0273
*                                                                  0274
*   /*****************************************************************/
*   /*                                                               */
*   /* IF A FIX REQUEST, UPDATE FIX COUNT AND CALL FOEADD            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0274
*   IF CIWFIX='1'B THEN             /* IF THIS IS A FIX REQUEST      */
         TM    CIWFIX(CIWAPTR),B'01000000'                         0274
         BNO   @RF00274                                            0274
*     DO;                                                          0275
*                                                                  0275
*       /*************************************************************/
*       /*                                                           */
*       /* INDICATE A PREFERRED AREA FIX REQUEST TO GFA (PCBPREFR=1) */
*       /* IF THE FIX IS A (1) COMMON AREA FIX, (2) PRIVATE LONG-FIX */
*       /* FOR A LEVEL 1 USER, OR (3) PRIVATE FIX FOR A LEVEL 2 USER */
*       /*                                                   @ZA16816*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0276
*       IF CURVBN>=PVTLCSA|         /* IF COMMON AREA OR     @ZA16816*/
*           (ASCB1LPU='1'B&         /* LEVEL 1 USER AND      @ZA16816*/
*           (CIWLONG='1'B|          /* FIX IS LONG-TERM OR   @ZA16816*/
*           ASCB2LPU='1'B)) THEN    /* LEVEL 2 USER ALSO THEN      0276
*                                                            @ZA16816*/
         CLC   CURVBN(2,CIWAPTR),PVTLCSA(PVTPTR)                   0276
         BNL   @RT00276                                            0276
         L     @14,ASCBPTR                                         0276
         TM    ASCB1LPU(@14),B'01000000'                           0276
         BNO   @RF00276                                            0276
         TM    CIWLONG(CIWAPTR),B'00000010'                        0276
         BO    @RT00276                                            0276
         TM    ASCB2LPU(@14),B'10000000'                           0276
         BNO   @RF00276                                            0276
@RT00276 DS    0H                                                  0277
*         PCBPREFR='1'B;            /* REQUEST A PREF FRAME  @ZA16816*/
         OI    PCBPREFR(PCBPTR),B'00001000'                        0277
*       PCBFXC=1;                   /* SET FIX COUNT TO 1            */
@RF00276 MVI   PCBFXC(PCBPTR),X'01'                                0278
*       RFY                                                        0279
*        (INPUTVBN) RSTD;                                          0279
*       INPUTVBN=CURVBN;            /* LOAD PARM FOR FOEADD          */
         SLR   INPUTVBN,INPUTVBN                                   0280
         ICM   INPUTVBN,3,CURVBN(CIWAPTR)                          0280
*       CALL FOEADD;                /* CALL TO ADD FOE TO CHAIN      */
         BAL   @14,FOEADD                                          0281
*       RFY                                                        0282
*        (INPUTVBN) UNRSTD;                                        0282
*       IF RETCODR^=0 THEN          /* IF FOEADD HAD GETMAIN FAILURE */
         LTR   RETCODR,RETCODR                                     0283
         BZ    @RF00283                                            0283
*         DO;                                                      0284
*           CIWRETC=20;             /* MARK ENVIRONMENTAL ERROR      */
         MVI   CIWRETC(CIWAPTR),X'14'                              0285
*           GOTO ERREXITA;          /* ERROR-FOE GETMAIN FAILED      */
         B     ERREXITA                                            0286
*         END;                                                     0287
*     END;                                                         0288
*   GOTO PAGELOOP;                  /* END OF OUTOFSTG ROUTINE, GO 0289
*                                      BACK TO PAGELOOP              */
         B     PAGELOOP                                            0289
*   RFY                                                            0290
*    (PTEPTR,                                                      0290
*     XPTEPTR,                                                     0290
*     PCBPTR,                                                      0290
*     TESTADDR) UNRSTD;                                            0290
*                                                                  0291
*   /*****************************************************************/
*   /*                                                               */
*   /* NORMEXIT --- THIS ROUTINE PASSES ANY PCBS ON THE INTERNAL     */
*   /* QUEUE (CIWWRK1) TO THE GFA MODULE. GFA RETURNS A CODE         */
*   /* INDICATING IMMEDIATE ALLOCATION OR NOT. IF SATISFIED, A RETURN*/
*   /* TO THE CALLER IS MADE WITH A ZERO RETURN CODE, OTHERWISE      */
*   /* RETURN IS MADE TO THE CALLER WITH A RETURN CODE OF EIGHT (8). */
*   /* RETURN IS VIA BRANCH TO REG 14.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0291
*   RFY                                                            0291
*    (R1) RSTD;                                                    0291
*NORMEXIT:                                                         0292
*   CIWRETC=0;                      /* SET THE RETURN CODE TO 0, THE
*                                      NORMAL CONDITION CODE         */
NORMEXIT MVI   CIWRETC(CIWAPTR),X'00'                              0292
*   IF CIWWRK1^=0 THEN              /* IF THE INTERNAL QUEUE HAS A 0293
*                                      PCB                           */
         L     @14,CIWWRK1(,CIWAPTR)                               0293
         LTR   @14,@14                                             0293
         BZ    @RF00293                                            0293
*     DO;                                                          0294
*       R1=CIWWRK1;                 /* LOAD REG 1 WITH ADDRESS OF  0295
*                                      FIRST PCB                     */
         LR    R1,@14                                              0295
*       CALL IEAVGFA;               /* CALL GENERAL FRAME ALLOCATION */
         L     @15,PVTPGFA(,PVTPTR)                                0296
         BALR  @14,@15                                             0296
*       RCACSECT=RCACPGFL;          /* RESTORE CSECT ID AFTER CALL   */
         L     @14,RCAPTR(,PVTPTR)                                 0297
         MVI   RCACSECT(@14),X'16'                                 0297
*       RFY                                                        0298
*        (R1) UNRSTD;                                              0298
*       IF RETCODR=0 THEN           /* IF GFA PERFORMED IMMEDIATE  0299
*                                      ALLOCATION, AND RETURNED PCBS
*                                      TO FREE QUEUE                 */
         LTR   RETCODR,RETCODR                                     0299
         BNZ   @RF00299                                            0299
*         CIWNOPST='1'B;            /* SET THE CIW POST FLAG         */
         OI    CIWNOPST(CIWAPTR),B'00000001'                       0300
*       ELSE                        /* IF GFA DID NOT IMMEDIATELY  0301
*                                      ALLOCATE                      */
*         IF CIWECB^=0 THEN         /* IF ECB WAS SUPPLIED BY      0301
*                                      REQUESTER                     */
         B     @RC00299                                            0301
@RF00299 ICM   @14,15,CIWECB(CIWAPTR)                              0301
         BZ    @RF00301                                            0301
*           CIWRETC=8;              /* RETURN CODE IS NOW 8 TO     0302
*                                      INDICATE ASSYNCHRONOUS      0302
*                                      COMPLETION                    */
         MVI   CIWRETC(CIWAPTR),X'08'                              0302
*     END;                                                         0303
@RF00301 DS    0H                                                  0303
@RC00299 DS    0H                                                  0304
*   RCAFXLD='0'B;                   /* RESET THE ENTRY POINT FLAG    */
@RF00293 L     @14,RCAPTR(,PVTPTR)                                 0304
         NI    RCAFXLD(@14),B'11111011'                            0304
*   GENERATE;                                                      0305
         L     @14,CIWRETRN(CIWAPTR)       RESTORE RETURN ADDRESS
         BR    @14                         UNCONDITIONAL RETURN
*                                                                  0306
*   /*****************************************************************/
*   /*                                                               */
*   /* ERREXIT - ERREXITA --- THIS ROUTINE IS THE ERROR EXIT CLEANUP */
*   /* ROUTINE. ENTRY IS AT ERREXIT FOR ALL RETURN CODE 4 ERRORS, AND*/
*   /* AT ERREXITA FOR ALL OTHER RETURN CODE ERRORS. FOR RETURN CODE */
*   /* 4 ERRORS, THE RETURN CODE IS SET HERE TO PRECLUDE REDUNDANT   */
*   /* CODE. ALL OTHER RETURN CODES MUST SET THE CODE BEFORE PASSING */
*   /* CONTROL TO THIS POINT. ANY PCBS THAT ARE ON THE QUEUE WILL BE */
*   /* FREED AT THIS TIME AS NO FURTHER PROCESSING WILL TAKE PLACE.  */
*   /* HOWEVER, FOE PROCESSING IS PERFORMED FIRST IF NECESSARY.      */
*   /* PGFREE IS CALLED TO BACK OUT PAGES IN REAL STOREAGE THAT WERE */
*   /* PROCESSED PRIOR TO THE ERROR. AFTER PGFREE RETURNS CONTROL,   */
*   /* RETURN IS MADE TO PSI. CALLS MADE IN THIS ROUTINE ARE TO      */
*   /* FOEDEL, IEAVPCB, AND IEAVFREE. - NOTE - ENTRY AT ERREXITA MAY */
*   /* BE MADE WITH A RETURN CODE OF ZERO WHEN THIS MODULE FINDS IT  */
*   /* NECESSARY TO QUIT PROCESSING AND BACK OUT OF A STARTED REQUEST*/
*   /* BECAUSE OF LOW PCB AVAILABILITY ON A NON-SUPERVISOR LOAD      */
*   /* REQUEST                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0306
*ERREXIT:                                                          0306
*   CIWRETC=4;                      /* ALWAYS SET RETURN CODE TO 4 ON
*                                      ON THIS ENTRY                 */
*                                                                  0306
ERREXIT  MVI   CIWRETC(CIWAPTR),X'04'                              0306
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THERE ARE PCBS ON THE INTERNAL QUEUE, FREE THEM            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0307
*ERREXITA:                                                         0307
*   IF CIWWRK1^=0 THEN              /* IF THE INTERNAL PCB QUEUE IS
*                                      NOT EMPTY                     */
ERREXITA L     @14,CIWWRK1(,CIWAPTR)                               0307
         LTR   @14,@14                                             0307
         BZ    @RF00307                                            0307
*     DO;                                                          0308
*       RFY                                                        0309
*        (PCBPTR,                                                  0309
*         BACKPTR) RSTD;                                           0309
*       PCBPTR=CIWWRK1;             /* GET ADDRESS OF FIRST PCB ON 0310
*                                      QUE                           */
         LR    PCBPTR,@14                                          0310
*       BACKPTR=0;                  /* FIRST BACKWARD PTR = 0        */
         SLR   BACKPTR,BACKPTR                                     0311
*       DO WHILE PCBPTR^=0;         /* LOOP HERE UNTIL ALL PCBS ON 0312
*                                      THE QUEUE ARE PROCESSED       */
         B     @DE00312                                            0312
@DL00312 DS    0H                                                  0313
*         RFY                                                      0313
*          (INPUTVBN) RSTD;                                        0313
*         PCBBQPA=BACKPTR;          /* CHAIN BACKWARDS               */
         ST    BACKPTR,PCBBQPA(,PCBPTR)                            0314
*         INPUTVBN=PCBVBN;          /* LOAD PARAMETER FOR FOEDEL     */
         SLR   INPUTVBN,INPUTVBN                                   0315
         ICM   INPUTVBN,3,PCBVBN(PCBPTR)                           0315
*         DO WHILE PCBFXC^=0;       /* LOOP HERE UNTIL PCB FIX COUNT
*                                      EQUALS ZERO. FOR LOAD REQUESTS
*                                      PCBFXC SHOULD BE ZERO TO START*/
         B     @DE00316                                            0316
@DL00316 DS    0H                                                  0317
*           CALL FOEDEL;            /* CALL FOE DELETE ROUTINE       */
         BAL   @14,FOEDEL                                          0317
*           PCBFXC=PCBFXC-1;        /* DECREMENT THE PCB FIX COUNT   */
         SLR   @14,@14                                             0318
         IC    @14,PCBFXC(,PCBPTR)                                 0318
         BCTR  @14,0                                               0318
         STC   @14,PCBFXC(,PCBPTR)                                 0318
*         END;                                                     0319
@DE00316 CLI   PCBFXC(PCBPTR),0                                    0319
         BNE   @DL00316                                            0319
*         RFY                                                      0320
*          (INPUTVBN) UNRSTD;                                      0320
*         BACKPTR=PCBPTR;           /* KEEP POINTER FOR NEXT       0321
*                                      BACKCHAIN                     */
         LR    BACKPTR,PCBPTR                                      0321
*         PCBPTR=PCBFQPA;           /* PICK UP NEXT PCB ON THE CHAIN */
         SLR   @14,@14                                             0322
         ICM   @14,7,PCBFQPA(PCBPTR)                               0322
         LR    PCBPTR,@14                                          0322
*       END;                                                       0323
@DE00312 SLR   @14,@14                                             0323
         CR    PCBPTR,@14                                          0323
         BNE   @DL00312                                            0323
*       RFY                                                        0324
*        (R0,                                                      0324
*         R1) RSTD;                                                0324
*       IF CIWWRK2^=0 THEN          /* IF A ROOT PCB EXISTS          */
         L     @12,CIWWRK2(,CIWAPTR)                               0325
         CR    @12,@14                                             0325
         BE    @RF00325                                            0325
*         DO;                                                      0326
*           PCBPTR=CIWWRK2;         /* LOAD ADDRESS OF ROOT PCB      */
         LR    PCBPTR,@12                                          0327
*           PCBFQP=CIWWRK1;         /* POINT FORWARD POINTER AT FIRST*/
         L     @12,CIWWRK1(,CIWAPTR)                               0328
         ST    @12,PCBFQP(,PCBPTR)                                 0328
*           PCBBQPA=0;              /* SET BACKWARD POINTER TO 0     */
         ST    @14,PCBBQPA(,PCBPTR)                                0329
*           PCBCQN=PCBDEQN;         /* SET CQN TO INDICATE DEQUEUED  */
         MVI   PCBCQN(PCBPTR),X'FF'                                0330
*           CIWWRK1->PCBBQPA=PCBPTR;/* BACK CHAIN THE PCBS           */
         ST    PCBPTR,PCBBQPA(,@12)                                0331
*           R1=PCBPTR;              /* LOAD THE PARM FOR PCB MGR CALL*/
         LR    R1,PCBPTR                                           0332
*         END;                                                     0333
*       ELSE                        /* IF NO ROOT PCB EXISTS         */
*         R1=CIWWRK1;               /* LOAD PARM FOR PCB MGR CALL    */
         B     @RC00325                                            0334
@RF00325 L     R1,CIWWRK1(,CIWAPTR)                                0334
*       R0=PCBFREQN;                /* LOAD FREE QUEUE NUMBER IN PARM
*                                      REG                           */
@RC00325 LA    R0,16                                               0335
*       CALL IEAVPCB;               /* CALL PCB MANAGER TO RETURN  0336
*                                      PCBS TO FREE QUEUE            */
         L     @15,PVTPCB(,PVTPTR)                                 0336
         BALR  @14,@15                                             0336
*       RFY                                                        0337
*        (BACKPTR,                                                 0337
*         PCBPTR,                                                  0337
*         R0,                                                      0337
*         R1) UNRSTD;                                              0337
*     END;                                                         0338
*                                                                  0339
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE THE TYPE OF ERROR, AND CALL PGFREE IF REQUIRED      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0339
*   IF CIWRETC=4&CIWINVSL^=0 THEN   /* IF NOT AN INPUT PARAMETER   0339
*                                      ERROR, AND THIS IS NOT A    0339
*                                      REGISTER FORM ENTRY           */
@RF00307 CLI   CIWRETC(CIWAPTR),4                                  0339
         BNE   @RF00339                                            0339
         ICM   @14,15,CIWINVSL(CIWAPTR)                            0339
         BZ    @RF00339                                            0339
*     DO;                                                          0340
*       CIWIERR='1'B;               /* SET ERROR FLAG ON NON REG   0341
*                                      ENTRIES                       */
         OI    CIWIERR(CIWAPTR),B'00010000'                        0341
*       CIWCUVSL->VSL=CIWVSL;       /* LOAD CURRENT VSL INTO LIST    */
         L     @14,CIWCUVSL(,CIWAPTR)                              0342
         MVC   VSL(8,@14),CIWVSL(CIWAPTR)                          0342
*     END;                                                         0343
*   IF CIWFIX='1'B THEN             /* IF THIS IS A FIX REQUEST      */
@RF00339 TM    CIWFIX(CIWAPTR),B'01000000'                         0344
         BNO   @RF00344                                            0344
*     DO;                                                          0345
*       IF CIWINVSL^=0 THEN         /* IF NOT A REGISTER FORM ENTRY  */
         L     @14,CIWINVSL(,CIWAPTR)                              0346
         LTR   @14,@14                                             0346
         BZ    @RF00346                                            0346
*         CIWVSL=CIWINVSL->VSL;     /* LOAD FIRST VSL ENTRY          */
         MVC   CIWVSL(8,CIWAPTR),VSL(@14)                          0347
*       CIWWRK1=CIWCUVSL;           /* LOAD CURRENT VSL ADDRESS OR 0348
*                                      ZEROS FOR REG ENTRIES         */
@RF00346 MVC   CIWWRK1(4,CIWAPTR),CIWCUVSL(CIWAPTR)                0348
*       CIWCUVSL=CIWINVSL;          /* LOAD CURRENT FROM FIRST       */
         MVC   CIWCUVSL(4,CIWAPTR),CIWINVSL(CIWAPTR)               0349
*       CIWWRK2=CIWCURPG;           /* LOAD CURRENT PAGE POINTER     */
         MVC   CIWWRK2(4,CIWAPTR),CIWCURPG(CIWAPTR)                0350
*       CIWSAVRC=CIWRETC;           /* SAVE RETURN CODE ACROSS CALL  */
         MVC   CIWSAVRC(1,CIWAPTR),CIWRETC(CIWAPTR)                0351
*       CIWWRK3=CIWRETRN;           /* SAVE RETURN ADDRESS ACROSS  0352
*                                      CALL                          */
         MVC   CIWWRK3(4,CIWAPTR),CIWRETRN(CIWAPTR)                0352
*       CIWCURPG=0;                 /* CONVENTION FOR IEAVFREE       */
         SLR   @14,@14                                             0353
         ST    @14,CIWCURPG(,CIWAPTR)                              0353
*       CIWLSTPG=0;                 /* CONVENTION FOR IEAVFREE       */
         ST    @14,CIWLSTPG(,CIWAPTR)                              0354
*       CIWFIXC='1'B;               /* SET THE FIX CALLING FREE FLAG */
         OI    CIWFIXC(CIWAPTR),B'00000010'                        0355
*       CALL IEAVFREE;              /* CALL PGFREE FOR BACKOUT       */
         L     @15,PVTPFREE(,PVTPTR)                               0356
         BALR  @14,@15                                             0356
*       RCACSECT=RCACPGFL;          /* RESTORE MODULE ID AFTER CALL  */
         L     @14,RCAPTR(,PVTPTR)                                 0357
         MVI   RCACSECT(@14),X'16'                                 0357
*       IF CIWRETC^=0 THEN          /* IF PGFREE FAILED TO BACK OUT  */
         CLI   CIWRETC(CIWAPTR),0                                  0358
         BE    @RF00358                                            0358
*         DO;                                                      0359
*           RCARCRD='14'X;          /* SET RECOVERY CODE             */
         MVI   RCARCRD(@14),X'14'                                  0360
*           GENERATE SETS(R1);                                     0361
         ABEND X'C0D',,,SYSTEM         LOG THE ERROR
*         END;                                                     0362
*       CIWRETC=CIWSAVRC;           /* RESTORE RETURN CODE AFTER CALL*/
@RF00358 MVC   CIWRETC(1,CIWAPTR),CIWSAVRC(CIWAPTR)                0363
*       CIWRETRN=CIWWRK3;           /* RESTORE RETURN ADDR AFTER CALL*/
         MVC   CIWRETRN(4,CIWAPTR),CIWWRK3(CIWAPTR)                0364
*     END;                                                         0365
*   RCAFXLD='0'B;                   /* RESET ENTRY POINT FLAG        */
@RF00344 L     @14,RCAPTR(,PVTPTR)                                 0366
         NI    RCAFXLD(@14),B'11111011'                            0366
*   GENERATE;                                                      0367
         L      @14,CIWRETRN(CIWAPTR)       RESTORE RETURN ADDRESS
         BR     @14                         RETURN TO CALLER
*                                                                  0368
*   /*****************************************************************/
*   /*                                                               */
*   /* FOEADD --- THIS SUBROUTINE IS USED ONLY BY THIS MODULE. IT    */
*   /* SEARCHES FOR AN FOE FOR THE PAGE BEING PROCESSED (INPUTVBN) AS*/
*   /* SUPPLIED BY THE CALLER. IF AN FOE EXISTS, THE FIX COUNT IS    */
*   /* UPDATED BY ONE. IF NO FOE EXISTS, THE ROUTINE WILL GET AND    */
*   /* INITIALIZE A POOL OF 4. THE QUEUE IS HEADED AT RSMFOEQ. THE   */
*   /* FOES ARE MAINTAINED ON A SINGLE THREADED QUEUE, IN ASCENDING  */
*   /* ORDER OF THEIR VIRTUAL ADDRESSES. THIS ROUTINE USES NO CIWWRK */
*   /* AREAS. IF THE GETMAIN MACRO SHOULD FAIL, AN R.C. OF 4 IS      */
*   /* RETURNED TO THE CALLER                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0368
*FOEADD:                                                           0368
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0368
         B     @PB00002                                            0368
FOEADD   DS    0H                                                  0369
*   RFY                                                            0369
*    (AFOEPTR,                                                     0369
*     CURFOE,                                                      0369
*     OLDFOE,                                                      0369
*     INPUTVBN,                                                    0369
*     PTRSAVR,                                                     0369
*     AOLDFOE) RSTD;                                               0369
*   GEN(STM @00,@15,PVTWSA2(PVTPTR));/* SAVE CALLERS REGS            */
         STM @00,@15,PVTWSA2(PVTPTR)
*   SAV15=0;                        /* LOAD THE NORMAL RETURN CODE   */
         SLR   @14,@14                                             0371
         ST    @14,SAV15(,PVTPTR)                                  0371
*   IF CIWTCB^=0 THEN               /* IF THERE IS A TCB, PROCESS    */
         C     @14,CIWTCB(,CIWAPTR)                                0372
         BE    @RF00372                                            0372
*     DO;                                                          0373
*       OLDFOE=ADDR(TCBFOE);        /* SET BACKWARD SRCH PTR @Z30CNYC*/
         L     @14,TCBPTR(,CIWAPTR)                                0374
         LA    OLDFOE,TCBFOE(,@14)                                 0374
*       CURFOE=TCBFOEA;             /* SET FORWARD SRCH PTR  @Z30CNYC*/
         SLR   CURFOE,CURFOE                                       0375
         ICM   CURFOE,7,TCBFOEA(@14)                               0375
*LASTFOE:                                                          0376
*       IF CURFOE=0|FOEVINDX>INPUTVBN THEN/* IS              @Z30CNYC
*                                      THIS CORRECT SLOT ON CHAIN    */
LASTFOE  LTR   CURFOE,CURFOE                                       0376
         BZ    @RT00376                                            0376
         SLR   @14,@14                                             0376
         ICM   @14,3,FOEVINDX(FOEPTR)                              0376
         CR    INPUTVBN,@14                                        0376
         BNL   @RF00376                                            0376
@RT00376 DS    0H                                                  0377
*         DO;                       /* YES - QUEUE FOE       @Z30CNYC*/
*           AFOEPTR=RSMFOEQ;        /* GET ADDRESS OF AVAIL  @Z30CNYC
*                                      FOE QUEUE HEAD                */
         L     AFOEPTR,RSMFOEQ(,RSMHDPTR)                          0378
*           IF AFOEPTR^=0 THEN      /* IS GETMAIN NECESSARY  @Z30CNYC*/
         LTR   AFOEPTR,AFOEPTR                                     0379
         BZ    @RF00379                                            0379
*             DO;                   /* NO                    @Z30CNYC*/
*               RSMFOEQ=AFOEPTR->FOEFLINK;/* RESET Q HEAD    @Z30CNYC*/
         SLR   @14,@14                                             0381
         ICM   @14,7,FOEFLINK(AFOEPTR)                             0381
         ST    @14,RSMFOEQ(,RSMHDPTR)                              0381
*               GOTO SLTFOUND;      /* INSERT FOE ON TCBFOE  @Z30CNYC*/
         B     SLTFOUND                                            0382
*             END;                                                 0383
*           ELSE                                                   0384
*             ;                     /* SET UP TO GETMAIN FOES      0384
*                                                            @Z30CNYC*/
@RF00379 DS    0H                                                  0385
*           RFY                                                    0385
*            (R0,                                                  0385
*             R1,                                                  0385
*             R4,                                                  0385
*             R7) RSTD;                                            0385
*           SAVWRK1=PVTPRCA;        /* SAVE ACROSS MACRO             */
         MVC   SAVWRK1(4,PVTPTR),PVTPRCA(PVTPTR)                   0386
*           R0=LENGTH(FOE)*4;       /* LOAD PARM FOR GETMAIN @Z30CNYC*/
         LA    R0,32                                               0387
*           R4=TCBPTR;              /* LOAD PARM FOR GETMAIN         */
         L     R4,TCBPTR(,CIWAPTR)                                 0388
*           R7=PSAAOLD;             /* LOAD PARM FOR GETMAIN         */
         L     R7,PSAAOLD                                          0389
*           PTRSAVR=PVTPTR;         /* SAVE ACROSS MACRO             */
*                                                                  0390
         LR    PTRSAVR,PVTPTR                                      0390
*           /*********************************************************/
*           /*                                                       */
*           /* GET 4 FOES FROM SUBPOOL 255                   @Z30CNYC*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0391
*           GENERATE REFS(R0,R4,R7) SETS(R1,R3,R14,R15);           0391
         GETMAIN RC,LV=(0),BNDRY=DBLWD,BRANCH=YES,SP=255,KEY=0
*           RESPECIFY                                              0392
*            (R15) RESTRICTED;                                     0392
*           PVTPTR=PTRSAVR;         /* RESTORE AFTER MACRO           */
         LR    PVTPTR,PTRSAVR                                      0393
*           CIWAPTR=SAV4;           /* RESTORE AFTER MACRO           */
         L     CIWAPTR,SAV4(,PVTPTR)                               0394
*           PVTPRCA=SAVWRK1;        /* RESTORE AFTER MACRO           */
         MVC   PVTPRCA(4,PVTPTR),SAVWRK1(PVTPTR)                   0395
*           RFY                                                    0396
*            (R0,                                                  0396
*             R4,                                                  0396
*             R7) UNRSTD;                                          0396
*           IF RETCODR^=0 THEN      /* IF THE GETMAIN MACRO FAILED   */
         LTR   RETCODR,RETCODR                                     0397
         BZ    @RF00397                                            0397
*             DO;                                                  0398
*               SAV15=4;            /* SET RETURN CODE FOR GETMAIN 0399
*                                      FAILURE                       */
         MVC   SAV15(4,PVTPTR),@CF00053                            0399
*               GOTO ENDADD;        /* ERROR-GOING BACK TO CALLER    */
         B     ENDADD                                              0400
*             END;                                                 0401
*           ELSE                                                   0402
*             ;                     /* GETMAIN SUCCESSFUL    @Z30CNYC*/
@RF00397 DS    0H                                                  0403
*           RESPECIFY                                              0403
*            (R15) UNRESTRICTED;                                   0403
*           RESPECIFY                                              0404
*            (CNTRREG,                                             0404
*             AOLDFOE) RESTRICTED;                                 0404
*           AFOEPTR=R1;             /* SET PTR TO AVAIL. Q.  @Z30CNYC*/
         LR    AFOEPTR,R1                                          0405
*           RESPECIFY                                              0406
*            (R1) UNRESTRICTED;                                    0406
*           FOEQUE=FOEQUE&&FOEQUE;  /* CLEAR THE 4 FOES      @Z30CNYC*/
         XC    FOEQUE(32,AFOEPTR),FOEQUE(AFOEPTR)                  0407
*           CNTRREG=3;              /* SET COUNTER TO NO.    @Z30CNYC
*                                      OF FOES TO BE INITIALIZED     */
         LA    CNTRREG,3                                           0408
*           AOLDFOE=ADDR(RSMFOEQ);  /* SET BACKWARD PTR      @Z30CNYC*/
         LA    AOLDFOE,RSMFOEQ(,RSMHDPTR)                          0409
*           DO WHILE CNTRREG^=0;    /* INITIALIZE FOE CHAIN  @Z30CNYC*/
         B     @DE00410                                            0410
@DL00410 DS    0H                                                  0411
*             AOLDFOE->FOEFLINK=AFOEPTR;/* CHAIN PREVIOUS    @Z30CNYC
*                                      FOE TO NEXT FOE.              */
         STCM  AFOEPTR,7,FOEFLINK(AOLDFOE)                         0411
*             AOLDFOE=AFOEPTR;      /* RESET BACK PTR        @Z30CNYC*/
         LR    AOLDFOE,AFOEPTR                                     0412
*             AFOEPTR=AFOEPTR+8;    /* POINT TO NEXT FOE     @Z30CNYC*/
         AH    AFOEPTR,@CH00059                                    0413
*             CNTRREG=CNTRREG-1;    /* DECREMENT COUNTER     @Z30CNYC*/
         BCTR  CNTRREG,0                                           0414
*           END;                    /* END OF INIT. LOOP     @Z30CNYC*/
@DE00410 LTR   CNTRREG,CNTRREG                                     0415
         BNZ   @DL00410                                            0415
*           RESPECIFY                                              0416
*            (CNTRREG,                                             0416
*             AOLDFOE) RESTRICTED;  /*                       @Z30CNYC*/
*                                                                  0416
*           /*********************************************************/
*           /*                                                       */
*           /* NOTE - ENTRIES ON TCBFOE ARE QUEUED IN ASCENDING ORDER*/
*           /* OF THEIR VIRTUAL ADDRESS. FOLLOWING CODE WILL INSERT  */
*           /* AND INITIALIZE FOE ON TCBFOE.                         */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0417
*SLTFOUND:                                                         0417
*           AFOEPTR->FOEVINDX=SAVVBN;/* INITVIRT ADDR        @Z30CNYC*/
SLTFOUND MVC   FOEVINDX(2,AFOEPTR),SAVVBN(PVTPTR)                  0417
*           AFOEPTR->FOEFXCT=1;     /* SET FIX COUNT TO 1    @Z30CNYC*/
         MVC   FOEFXCT(2,AFOEPTR),@CH00061                         0418
*           AFOEPTR->FOEFLINK=CURFOE;/* CHAIN FORWARD        @Z30CNYC*/
         STCM  CURFOE,7,FOEFLINK(AFOEPTR)                          0419
*           AFOEPTR->FOEFLAG=0;     /* CLEAR THE FLAG BYTE   @Z30CNYC*/
         MVI   FOEFLAG(AFOEPTR),X'00'                              0420
*           OLDFOE->FOEFLINK=AFOEPTR;/* CHAIN FORWARD TO     @Z30CNYC
*                                      NEW FOE.                      */
         STCM  AFOEPTR,7,FOEFLINK(OLDFOE)                          0421
*           GOTO ENDADD;            /* RETURN TO CALLER      @Z30CNYC*/
         B     ENDADD                                              0422
*         END;                      /* END OF FIND FOE SRCH  @Z30CNYC*/
*       ELSE                        /* CONT SRCH TO FIND SLT @Z30CNYC*/
*         DO;                                                      0424
@RF00376 DS    0H                                                  0425
*           IF FOEVINDX^=INPUTVBN THEN/* IF FOE NOT          @Z30CNYC
*                                      FOR THIS PAGE, CONT SEARCH    */
         SLR   @14,@14                                             0425
         ICM   @14,3,FOEVINDX(FOEPTR)                              0425
         CR    INPUTVBN,@14                                        0425
         BE    @RF00425                                            0425
*             DO;                                                  0426
*               OLDFOE=CURFOE;      /* MOVE DOWN THE CHAIN   @Z30CNYC*/
         LR    OLDFOE,CURFOE                                       0427
*               CURFOE=FOEFLINK;    /* PICK UP NEXT FOE      @Z30CNYC*/
         SLR   @14,@14                                             0428
         ICM   @14,7,FOEFLINK(FOEPTR)                              0428
         LR    CURFOE,@14                                          0428
*               GOTO LASTFOE;       /* LOOP TO TEST NEXT FOE @Z30CNYC*/
         B     LASTFOE                                             0429
*             END;                                                 0430
*           ELSE                                                   0431
*             ;                     /* FOE FOR THIS PAGE     @Z30CNYC*/
@RF00425 DS    0H                                                  0432
*           FOEFXCT=FOEFXCT+1;      /* UPDATE THE FIX COUNT  @Z30CNYC*/
         LA    @14,1                                               0432
         AH    @14,FOEFXCT(,FOEPTR)                                0432
         STH   @14,FOEFXCT(,FOEPTR)                                0432
*         END;                      /* END OF CONTNUE SRCH   @Z30CNYC*/
*     END;                          /* NO TCB - RETURN       @Z30CNYC*/
*ENDADD:                                                           0435
*   GEN(LM @00,@15,PVTWSA2(PVTPTR));/* RESTORE REGISTERS             */
@RF00372 DS    0H                                                  0435
ENDADD   LM @00,@15,PVTWSA2(PVTPTR)
*   RFY                                                            0436
*    (OLDFOE,                                                      0436
*     CURFOE,                                                      0436
*     INPUTVBN,                                                    0436
*     PTRSAVR) UNRSTD;                                             0436
*   END FOEADD;                     /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0437
@EF00002 DS    0H                                                  0437
@ER00002 BR    @14                                                 0437
*                                                                  0438
*   /*****************************************************************/
*   /*                                                               */
*   /* FOEDEL --- THIS SUBROUTINE IS USED BY THIS MODULE AND BY      */
*   /* PGFREE. IT SEARCHES FOR AN FOE FOR THE PAGE BEING PROCESSED,  */
*   /* AND DECREMENTS THE FIX COUNT BY 1 IF NOT ALREADY ZERO. IF     */
*   /* ALREADY ZERO, THE FOE IS DEQUEUED FROM THE TCB AND INSERTED ON*/
*   /* THE AVAILABLE QUEUE (RSMFOEQ). THE RETURN CODE IS THEN SET TO */
*   /* 4. IF THE FIX COUNT IS ZERO AS A RESULT OF DECREMENTING, THE  */
*   /* FOE IS DEQUEUED AND INSERTED ON RSMFOEQ BUT THE RETURN CODE IS*/
*   /* SET TO ZERO. INPUT TO THIS ROUTINE IS THE VBN SUPPLIED BY THE */
*   /* CALLER IN REG 1. REGISTERS ARE SAVED AND RESTORED FOR THE     */
*   /* CALLER. IF NO FOE IS FOUND, A RETURN CODE OF 4 IS ISSUED. RSM */
*   /* POINTERS ARE NOT MAINTAINED IN THIS ROUTINE, BUT ARE RESTORED */
*   /* PRIOR TO RETURN TO THE CALLER.                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0438
*FOEDEL:                                                           0438
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0438
FOEDEL   DS    0H                                                  0439
*   RFY                                                            0439
*    (OLDFOE,                                                      0439
*     CURFOE,                                                      0439
*     INPUTVBN,                                                    0439
*     PTRSAVR) RSTD;                                               0439
*   GENERATE;                                                      0440
         ENTRY  FOEDEL
         STM    @00,@14,PVTWSA2(PVTPTR)   STORE CALLERS REGS
         BALR   @09,@00                   ESTABLISH ADDRESSABILITY
         USING  *,@09
*   SAV15=0;                        /* CLEAR THE RET CODE FOR LATER  */
         SLR   @14,@14                                             0441
         ST    @14,SAV15(,PVTPTR)                                  0441
*   IF CIWTCB=0 THEN                /* IF THERE IS NO TCB            */
         C     @14,CIWTCB(,CIWAPTR)                                0442
         BNE   @RF00442                                            0442
*     DO;                                                          0443
*       SAV15=4;                    /* SET RETURN CODE TO 4          */
         MVC   SAV15(4,PVTPTR),@CF00053                            0444
*       GOTO ENDDEL;                /* GOING BACK TO CALLER          */
         B     ENDDEL                                              0445
*     END;                                                         0446
*   OLDFOE=ADDR(TCBFOE);            /* GET THE QUEUE POINTER ADDRESS */
@RF00442 L     @14,TCBPTR(,CIWAPTR)                                0447
         LA    OLDFOE,TCBFOE(,@14)                                 0447
*   CURFOE=TCBFOEA;                 /* GET POINTER TO FIRST FOE      */
         SLR   CURFOE,CURFOE                                       0448
         ICM   CURFOE,7,TCBFOEA(@14)                               0448
*LASTCK:                                                           0449
*   IF CURFOE=0|FOEVINDX>INPUTVBN THEN/* IF CHAIN IS EMPTY, OR IF NO
*                                      FOE FOR THIS PAGE             */
LASTCK   LTR   CURFOE,CURFOE                                       0449
         BZ    @RT00449                                            0449
         SLR   @14,@14                                             0449
         ICM   @14,3,FOEVINDX(FOEPTR)                              0449
         CR    INPUTVBN,@14                                        0449
         BNL   @RF00449                                            0449
@RT00449 DS    0H                                                  0450
*     DO;                                                          0450
*       SAV15=4;                    /* NO VALID FOE RESULTS IN R.C.4 */
         MVC   SAV15(4,PVTPTR),@CF00053                            0451
*       GOTO ENDDEL;                /* GOING BACK TO CALLER          */
         B     ENDDEL                                              0452
*     END;                                                         0453
*   IF FOEVINDX^=INPUTVBN THEN      /* IF VBNS DO NOT MATCH          */
@RF00449 SLR   @14,@14                                             0454
         ICM   @14,3,FOEVINDX(FOEPTR)                              0454
         CR    INPUTVBN,@14                                        0454
         BE    @RF00454                                            0454
*     DO;                                                          0455
*       OLDFOE=CURFOE;              /* MOVE DOWN THE CHAIN           */
         LR    OLDFOE,CURFOE                                       0456
*       CURFOE=FOEFLINK;            /* GET NEXT FOE POINTER          */
         SLR   @14,@14                                             0457
         ICM   @14,7,FOEFLINK(FOEPTR)                              0457
         LR    CURFOE,@14                                          0457
*       GOTO LASTCK;                /* REPEAT TESTS FOR THIS FOE     */
         B     LASTCK                                              0458
*     END;                                                         0459
*   IF FOEFXCT=0 THEN               /* IF THE FOE INDICATES NOT FIXED
*                                      UPON ENTRY                    */
@RF00454 ICM   @14,3,FOEFXCT(FOEPTR)                               0460
         BNZ   @RF00460                                            0460
*     SAV15=4;                      /* SET THR RETURN CODE INDICATING
*                                      ALREADY 0                     */
         MVC   SAV15(4,PVTPTR),@CF00053                            0461
*   ELSE                            /* IF THE FIX COUNT IS NOT ZERO  */
*     DO;                                                          0462
         B     @RC00460                                            0462
@RF00460 DS    0H                                                  0463
*       FOEFXCT=FOEFXCT-1;          /* DECREMENT FIX COUNT           */
         LH    @14,FOEFXCT(,FOEPTR)                                0463
         BCTR  @14,0                                               0463
         STH   @14,FOEFXCT(,FOEPTR)                                0463
*       IF FOEFXCT^=0 THEN          /* IF FRAME IS STILL FIXED       */
         LTR   @14,@14                                             0464
         BNZ   @RT00464                                            0464
*         GOTO ENDDEL;              /* DO NOT DEQUEUE                */
*     END;                                                         0466
*   OLDFOE->FOEFLINK=FOEFLINK;      /* REMOVE FOE FROM CHAIN         */
@RC00460 MVC   FOEFLINK(3,OLDFOE),FOEFLINK(FOEPTR)                 0467
*   FOEFLINK=RSMFOEQ;               /* CHAIN EXISTING        @Z30CNYC
*                                      AVAILABLE FOES TO THIS FOE    */
         MVC   FOEFLINK(3,FOEPTR),RSMFOEQ+1(RSMHDPTR)              0468
*   RSMFOEQ=CURFOE;                 /* CHAIN TO HEAD OF QUEUE      0469
*                                                            @Z30CNYC*/
         ST    CURFOE,RSMFOEQ(,RSMHDPTR)                           0469
*ENDDEL:                                                           0470
*   GEN(LM @00,@15,PVTWSA2(PVTPTR));/* RESTORE REGISTERS             */
ENDDEL   LM @00,@15,PVTWSA2(PVTPTR)
*   RFY                                                            0471
*    (OLDFOE,                                                      0471
*     CURFOE,                                                      0471
*     INPUTVBN,                                                    0471
*     PTRSAVR) UNRSTD;                                             0471
*   END FOEDEL;                     /* RETURN TO CALLER              */
@EL00003 DS    0H                                                  0472
@EF00003 DS    0H                                                  0472
@ER00003 BR    @14                                                 0472
*                                                                  0473
*   /*****************************************************************/
*   /*                                                               */
*   /* IEAVFXL --- PG FIX/LOAD ROOT EXIT ROUTINE. THIS ENTRY TO      */
*   /* FIX/LOAD IS CALLED BY OTHER RSM ROUTINES IF THEY FORCE THE PCB*/
*   /* COUNT IN PGFIX OR PGLOAD ROOT PCBS TO ZERO. THIS ROUTINE USES */
*   /* THE PVT ROOT EXIT SAVE AREA. IF THE ROOT PCB IS MARKED AS     */
*   /* INTERCEPTED, SOME OTHER MODULE HAS CANCELED THE REQUEST FOR   */
*   /* WHICH THE ROOT PCB EXISTS. IN THIS CASE THE ECB IS FREED AND  */
*   /* THE PCB RETURNED TO THE FREE QUEUE. IF A PAGE FAILURE OCCURED */
*   /* FOR THIS PCB A POST CODE OF 4 IS SET, OTHERWISE A POST CODE OF*/
*   /* 0 IS SET. IF THIS WAS A FIX REQUEST AND THERE IS A TCB, AN    */
*   /* ABEND IS ISSUED VIA CALLRTM (ABTERM). FOR LOAD REQUESTS NO    */
*   /* ABEND IS ISSUED AS THE PAGE SUFFERING THE FAULT MAY NEVER BE  */
*   /* REFERENCED. IF ALL IS WELL THE REQUESTORS ECB IS POSTED WITH A*/
*   /* ZERO POST CODE. THE ECB IS FREED AND THE PCB RETURNED TO THE  */
*   /* FREE QUEUE. THIS ROUTINE DOES NOT MAINTAIN RSM PTRS, BUT THEY */
*   /* ARE RESTORED PRIOR TO RETURN                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0473
*IEAVFXL:                                                          0473
*   ENTRY;                          /* START OF IEAVFXL-DO NOT REMOVE*/
@EC00473 DS    0H                                                  0474
*   RFY                                                            0474
*    (PCBPTR,                                                      0474
*     R0,                                                          0474
*     R1) RSTD;                                                    0474
*   GENERATE;                                                      0475
         ENTRY    IEAVFXL
IEAVFXL  STM      @00,@15,PVTWSA7(PVTPTR)   STORE CALLERS REGS
         BALR     @09,@00                   ESTABLISH ADDRESSABILITY
         USING    *,@09
*   RCACSECT=RCACPGFL;              /* SET MODULE ID                 */
         L     @14,RCAPTR(,PVTPTR)                                 0476
         MVI   RCACSECT(@14),X'16'                                 0476
*   RCAFXL='1'B;                    /* SET ENTRY POINT FLAG          */
         OI    RCAFXL(@14),B'01000000'                             0477
*   PCBRPTR=R1;                     /* PICK UP ROOT POINTER FROM PARM*/
         LR    PCBRPTR,R1                                          0478
*   IF PCBRINT='0'B THEN            /* IF PCB IS NOT INTERCEPTED     */
         TM    PCBRINT(PCBRPTR),B'10000000'                        0479
         BNZ   @RF00479                                            0479
*     DO;                                                          0480
*       RFY                                                        0481
*        (TESTADDR,                                                0481
*         R10,                                                     0481
*         R11,                                                     0481
*         R12,                                                     0481
*         RTTCBR,                                                  0481
*         R13) RSTD;                                               0481
*       IF PCBRFAIL='1'B THEN       /* IF I/O FOR ROOT FAILED        */
         TM    PCBRFAIL(PCBRPTR),B'00001000'                       0482
         BNO   @RF00482                                            0482
*         DO;                                                      0483
*           R10=4;                  /* SET POST CODE 4               */
         LA    R10,4                                               0484
*           IF PCBRLOAD='0'B&PCBRTCBA^=0 THEN/* IF THIS IS A FIX   0485
*                                      REQUEST AND THERE IS A TCB    */
         TM    PCBRLOAD(PCBRPTR),B'00000100'                       0485
         BNZ   @RF00485                                            0485
         SLR   @14,@14                                             0485
         ICM   @14,7,PCBRTCBA(PCBRPTR)                             0485
         LTR   @14,@14                                             0485
         BZ    @RF00485                                            0485
*             DO;                                                  0486
*               RTTCBR=PCBRTCBA;    /* LOAD TCB POINTER FOR CALLRTM  */
         LR    RTTCBR,@14                                          0487
*               GENERATE REFS(RTTCBR) SETS(R0,R1,R2,R14,R15);      0488
         CALLRTM TYPE=ABTERM,TCB=(RTTCBR),COMPCOD=X'028'
*             END;                                                 0489
*           TESTADDR=PCBRECB;       /* LOAD ADDRESS OF ECB           */
@RF00485 L     TESTADDR,PCBRECB(,PCBRPTR)                          0490
*           GENERATE REFS(TESTADDR) SETS(TESTADDR);                0491
      LRA   TESTADDR,0(TESTADDR)     DO LRA ON ECB
*           BC(7,FREEBLKS);         /* IF ECB IS NOT IN STORAGE,   0492
*                                      BRANCH                        */
         BC    7,FREEBLKS                                          0492
*         END;                                                     0493
*       ELSE                        /* IF I/O FOR ROOT WAS SUCCESSFUL*/
*         R10=0;                    /* SET POST CODE 0               */
         B     @RC00482                                            0494
@RF00482 SLR   R10,R10                                             0494
*       R11=PCBRECB;                /* LOAD ECB ADDRESS FOR POST - 0495
*                                      R11 IS A CONVENTION           */
@RC00482 L     R11,PCBRECB(,PCBRPTR)                               0495
*       R12=0;                      /* CLEAR FOR POST                */
         SLR   R12,R12                                             0496
*       R13=0;                      /* CLEAR FOR POST                */
         SLR   R13,R13                                             0497
*       CALL IEA0PT01;              /* CALL FOR ECB POSTING          */
         L     @14,CVTPTR                                          0498
         L     @15,CVT0PT01(,@14)                                  0498
         BALR  @14,@15                                             0498
*       RFY                                                        0499
*        (TESTADDR,                                                0499
*         R10,                                                     0499
*         R11,                                                     0499
*         R12,                                                     0499
*         RTTCBR,                                                  0499
*         R13) UNRSTD;                                             0499
*     END;                                                         0500
*                                                                  0501
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE THE ECB AND ROOT PCB                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0501
*FREEBLKS:                                                         0501
*   IF PCBRFECB='1'B THEN           /* IF ECB IS TO BE FREED         */
@RF00479 DS    0H                                                  0501
FREEBLKS TM    PCBRFECB(PCBRPTR),B'00000010'                       0501
         BNO   @RF00501                                            0501
*     DO;                                                          0502
*       RFY                                                        0503
*        (VSLPTR) RSTD;                                            0503
*       R0=0;                       /* CLEAR - PSI PARM              */
         SLR   R0,R0                                               0504
*       VSLPTR=ADDR(WORKZONE);      /* SET UP POINTER TO MAP WORK  0505
*                                      AREA                          */
         LA    VSLPTR,WORKZONE(,PVTPTR)                            0505
*       VSLFLAG1=0;                 /* CLEAR THE FLAGS               */
         MVI   VSLFLAG1(VSLPTR),X'00'                              0506
*       VSLFREE='1'B;               /* SET PGFREE FLAG FOR PSI       */
         OI    VSLFREE(VSLPTR),B'00100000'                         0507
*       VSLSTRTA=PCBRECB;           /* SET UP START ADDRESS FOR PSI  */
         L     @14,PCBRECB(,PCBRPTR)                               0508
         STCM  @14,7,VSLSTRTA(VSLPTR)                              0508
*       R1=VSLSTRT;                 /* LOAD START ADDRESS AND FLAG 0509
*                                      FOR PSI                       */
         L     R1,VSLSTRT(,VSLPTR)                                 0509
*       R2=VSLSTRTA+LENGTH(ECB);    /* LOAD END ADDRESS FOR PSI      */
         AL    @14,@CF00053                                        0510
         LR    R2,@14                                              0510
*       R4=0;                       /* CLEAR FOR PSI - R4 IS A     0511
*                                      CONVENTION                    */
         SLR   R4,R4                                               0511
*       CALL IEAVPSII;              /* CALL PSI WITH PGFREE REQUEST  */
         L     @15,PVTPSINT(,PVTPTR)                               0512
         BALR  @14,@15                                             0512
*       RCACSECT=RCACPGFL;          /* RESTORE AFTER CALL            */
         L     @14,RCAPTR(,PVTPTR)                                 0513
         MVI   RCACSECT(@14),X'16'                                 0513
*       RFY                                                        0514
*        (VSLPTR) UNRSTD;                                          0514
*     END;                                                         0515
*   PCBFQP=0;                       /* SET FORWARD POINTER           */
@RF00501 SLR   @14,@14                                             0516
         ST    @14,PCBFQP(,PCBPTR)                                 0516
*   PCBBQP=0;                       /* SET THE BACKWARD POINTER      */
         ST    @14,PCBBQP(,PCBPTR)                                 0517
*   PCBCQN=PCBDEQN;                 /* MARK PCB AS DEQUEUED          */
         MVI   PCBCQN(PCBPTR),X'FF'                                0518
*   R0=PCBFREQN;                    /* LOAD TQN FOR PCB MANAGER      */
         LA    R0,16                                               0519
*   R1=PCBPTR;                      /* LOAD POINTER FOR PCB MANAGER  */
         LR    R1,PCBPTR                                           0520
*   CALL IEAVPCB;                   /* CALL PCB MANAGER TO PUT PCB ON
*                                      THE FREE QUEUE                */
         L     @15,PVTPCB(,PVTPTR)                                 0521
         BALR  @14,@15                                             0521
*   RCAFXL='0'B;                    /* TURN OFF THE ENTRY POINT FLAG */
         L     @14,RCAPTR(,PVTPTR)                                 0522
         NI    RCAFXL(@14),B'10111111'                             0522
*   RFY                                                            0523
*    (R14) RSTD;                                                   0523
*   GEN(LM @00,@15,PVTWSA7(PVTPTR));/* RESTORE CALLERS REGS          */
         LM @00,@15,PVTWSA7(PVTPTR)
*   GOTO R14;                       /* END IEAVFXL-RETURN TO CALLER  */
         BR    R14                                                 0525
*   RFY                                                            0526
*    (PCBPTR,                                                      0526
*     R0,                                                          0526
*     R1,                                                          0526
*     R14) UNRSTD;                                                 0526
*   END IEAVFXLD                                                   0527
*                                                                  0527
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IEACIWA )                                       */
*/*%INCLUDE SYSLIB  (IHAVSL  )                                       */
*/*%INCLUDE SYSLIB  (IHAPFTE )                                       */
*/*%INCLUDE SYSLIB  (IHAFOE  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCBR )                                       */
*/*%INCLUDE SYSLIB  (IHAPCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPGTE )                                       */
*/*%INCLUDE SYSLIB  (IHAXPTE )                                       */
*/*%INCLUDE SYSLIB  (IHARCA  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAECB  )                                       */
*/*%INCLUDE SYSLIB  (IHARSMHD)                                       */
*/*%INCLUDE SYSLIB  (ILRAIA  )                                       */
*                                                                  0527
*       ;                                                          0527
@DATA    DS    0H
@CH00061 DC    H'1'
@CH00059 DC    H'8'
@CH02252 DC    H'4096'
         DS    0F
         DS    0F
@CF00053 DC    F'4'
@CF02248 DC    XL4'00FFF000'
@CF02250 DC    XL4'0000FFF0'
@CA02317 DC    A(IEAVFXL)
@CV02299 DC    V(NEXTVSL)
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PVTPTR   EQU   @03
CIWAPTR  EQU   @04
VSLPTR   EQU   @13
PFTEPTR  EQU   @07
FOEPTR   EQU   @11
PCBRPTR  EQU   @07
PCBPTR   EQU   @07
PTEPTR   EQU   @05
XPTEPTR  EQU   @06
RSMHDPTR EQU   @02
R0       EQU   @00
R1       EQU   @01
WORKADDR EQU   @01
INPUTVBN EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
AOLDFOE  EQU   @05
AFOEPTR  EQU   @06
R7       EQU   @07
CNTRREG  EQU   @07
WORKREG  EQU   @07
REALPGR  EQU   @07
TESTADDR EQU   @08
PTRSAVR  EQU   @08
R9       EQU   @09
R10      EQU   @10
BACKPTR  EQU   @10
OLDFOE   EQU   @10
R11      EQU   @11
CURFOE   EQU   @11
R12      EQU   @12
R13      EQU   @13
RTTCBR   EQU   @13
R14      EQU   @14
R15      EQU   @15
RETCODR  EQU   @15
NEWFOEP  EQU   @01
R5       EQU   @05
R6       EQU   @06
R8       EQU   @08
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVT      EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVT0PT01 EQU   CVTMAP+152
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBFOEA  EQU   TCBFOE+1
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTFLAG2 EQU   PVT+1
PVTPFTP  EQU   PVT+12
PVTLPRIV EQU   PVT+24
PVTLCSA  EQU   PVT+26
PVTPCBCT EQU   PVT+36
PVTPCBLO EQU   PVT+38
PVTPRCA  EQU   PVT+52
PVTPSINT EQU   PVT+76
PVTPGFA  EQU   PVT+84
PVTPCB   EQU   PVT+104
PVTPFP2  EQU   PVT+116
PVTPFREE EQU   PVT+208
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
PVTWSA2  EQU   PVTWSAX+72
PVTWSA7  EQU   PVTWSAX+432
PVTSAVE  EQU   PVTWSAX+1328
PVTMAXFX EQU   PVT+1822
PVTCNTFX EQU   PVT+1830
PVTCOMFX EQU   PVT+1834
CIWA     EQU   0
CIWFLG1  EQU   CIWA
CIWFIXC  EQU   CIWFLG1
CIWNOPST EQU   CIWFLG1
CIWOPFL1 EQU   CIWA+2
CIWFIX   EQU   CIWOPFL1
CIWLONG  EQU   CIWOPFL1
CIWOPFL2 EQU   CIWA+3
CIWRETC  EQU   CIWA+4
CIWSAVRC EQU   CIWA+5
CIWKEY   EQU   CIWA+6
CIWINVSL EQU   CIWA+8
CIWCUVSL EQU   CIWA+12
CIWVSL   EQU   CIWA+16
CIWSTRT  EQU   CIWVSL
CIWIFLG1 EQU   CIWSTRT
CIWSTRTA EQU   CIWSTRT+1
CIWEND1  EQU   CIWVSL+4
CIWIFLG2 EQU   CIWEND1
CIWIERR  EQU   CIWIFLG2
CIWEND1A EQU   CIWEND1+1
CIWTCB   EQU   CIWA+24
CIWECB   EQU   CIWA+28
CIWCURPG EQU   CIWA+32
CIWLSTPG EQU   CIWA+36
CIWRETRN EQU   CIWA+40
CIWWRK1  EQU   CIWA+44
CIWWRK2  EQU   CIWA+48
CIWWRK3  EQU   CIWA+52
VSL      EQU   0
VSLSTRT  EQU   VSL
VSLFLAG1 EQU   VSLSTRT
VSLFREE  EQU   VSLFLAG1
VSLSTRTA EQU   VSLSTRT+1
VSLEND   EQU   VSL+4
VSLFLAG2 EQU   VSLEND
PFTE     EQU   0
PFTPGID  EQU   PFTE
PFTQPTRS EQU   PFTE+4
PFTFXCT  EQU   PFTE+8
PFTFLAG1 EQU   PFTE+12
PFTLSQA  EQU   PFTFLAG1
PFTVRALC EQU   PFTFLAG1
PFTFLAG2 EQU   PFTE+13
PFTPREF  EQU   PFTFLAG2
PFTQNDX  EQU   PFTE+14
FOE      EQU   0
FOEFLNKF EQU   FOE
FOEFLAG  EQU   FOEFLNKF
FOEFLINK EQU   FOEFLNKF+1
FOEVINDX EQU   FOE+4
FOEFXCT  EQU   FOE+6
PCBR     EQU   0
PCBRTCB  EQU   PCBR
PCBRFLAG EQU   PCBRTCB
PCBRINT  EQU   PCBRFLAG
PCBRFAIL EQU   PCBRFLAG
PCBRLOAD EQU   PCBRFLAG
PCBRFECB EQU   PCBRFLAG
PCBRTCBA EQU   PCBRTCB+1
PCBRGOTO EQU   PCBR+4
PCBRECB  EQU   PCBR+8
PCBRASCB EQU   PCBR+12
PCBRCNT  EQU   PCBR+16
PCB      EQU   0
PCBFQP   EQU   PCB
PCBCQN   EQU   PCBFQP
PCBFQPA  EQU   PCBFQP+1
PCBBQP   EQU   PCB+4
PCBBQPA  EQU   PCBBQP
PCBRTP   EQU   PCB+8
PCBFL1   EQU   PCBRTP
PCBROOT  EQU   PCBFL1
PCBRTPA  EQU   PCBRTP+1
PCBRLP   EQU   PCB+12
PCBFXC   EQU   PCBRLP
PCBXPT   EQU   PCB+16
PCBFL2   EQU   PCBXPT
PCBXPTA  EQU   PCBXPT+1
PCBPGT   EQU   PCB+20
PCBFL3   EQU   PCBPGT
PCBPGTA  EQU   PCBPGT+1
PCBVBN   EQU   PCB+26
PCBBLOCK EQU   PCB+28
PCBSRB   EQU   PCBBLOCK
PCBRB    EQU   PCBSRB
PCBASCB  EQU   PCB+32
PCBAIA   EQU   PCB+36
PGTPTE   EQU   0
PGTRSA   EQU   PGTPTE
PGTBITS  EQU   PGTRSA+1
PGTPVM   EQU   PGTBITS
PGTPAM   EQU   PGTBITS
XPTE     EQU   0
XPTFLAGS EQU   XPTE+2
XPTVIO   EQU   XPTFLAGS
XPTFLAG2 EQU   XPTE+3
XPTLPID  EQU   XPTE+4
XPTLGN   EQU   XPTLPID
XPTLPN   EQU   XPTLPID+4
RCA      EQU   0
RCACSECT EQU   RCA+9
RCAFLAGS EQU   RCA+10
RCARCRD  EQU   RCA+11
RCANAMES EQU   RCA+12
RCANAME1 EQU   RCANAMES
RCAFXLD  EQU   RCANAME1
RCANAME2 EQU   RCANAMES+1
RCANAME3 EQU   RCANAMES+2
RCANAME4 EQU   RCANAMES+3
RCANAME5 EQU   RCANAMES+4
RCANAME6 EQU   RCANAMES+5
RCAFXL   EQU   RCANAME6
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCB2LPU EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ECB      EQU   0
ECBRB    EQU   ECB
ECBEVTB  EQU   ECBRB
ECBEXTB  EQU   ECBEVTB
ECBCC    EQU   ECBEXTB
ECBCCCNT EQU   ECBEXTB+1
ECBRBA   EQU   ECBCCCNT
ECBEVTBA EQU   ECBRBA
ECBEXTBA EQU   ECBEVTBA
ECBBYTE3 EQU   ECBEXTBA+2
ECBEXTND EQU   ECBBYTE3
RSMHD    EQU   0
RSMFLG1  EQU   RSMHD+12
RSMCNTFX EQU   RSMHD+14
RSMQS    EQU   RSMHD+20
RSMLFQ   EQU   RSMQS
RSMLSQA  EQU   RSMQS+4
RSMLIOQ  EQU   RSMQS+8
RSMFOEQ  EQU   RSMHD+36
FOEQUE   EQU   0
IEAVFP2  EQU   0
IEAVPCB  EQU   0
IEAVGFA  EQU   0
IEAVFREE EQU   0
IEAVPSII EQU   0
IEA0PT01 EQU   0
FOEEND   EQU   0
PGTEND   EQU   0
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTOPTE  EQU   CVTS01+188
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
TCBPTR   EQU   CIWTCB
RCAPTR   EQU   PVTPRCA
ASCBPTR  EQU   PSAAOLD
ECBPTR   EQU   PCBRECB
RSMAIA   EQU   PCBAIA
AIA      EQU   RSMAIA
AIAFLG1  EQU   AIA+9
AIAPRIV  EQU   AIAFLG1
AIAFLG2  EQU   AIA+10
AIAFLG3  EQU   AIA+11
AIANXAIA EQU   AIA+12
AIAID    EQU   AIA+16
AIALPID  EQU   AIAID
AIALGID  EQU   AIALPID
AIALSID  EQU   AIALGID
AIASSID  EQU   AIALSID+1
AIARPN   EQU   AIALPID+4
AIALSID2 EQU   AIARPN
AIALPMEP EQU   AIALSID2
AIAGRPSZ EQU   AIA+24
AIALGE   EQU   AIAGRPSZ
CURNUM   EQU   CIWCURPG
CURVBN   EQU   CURNUM+1
SAVBOX   EQU   PVTWSA2
SAV1     EQU   SAVBOX+4
SAVVBN   EQU   SAV1+2
SAV4     EQU   SAVBOX+16
SAV15    EQU   SAVBOX+60
SAVWRK1  EQU   SAVBOX+64
SAVWRK2  EQU   SAVBOX+68
FXLSMAP  EQU   PVTWSA7
WORKZONE EQU   FXLSMAP+64
@NM00078 EQU   PCBFL1
PCBPREFR EQU   @NM00078
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
@NM00080 EQU   @NM00078
@NM00079 EQU   @NM00078
@NM00077 EQU   FXLSMAP+12
SAVRSMHD EQU   FXLSMAP+8
@NM00076 EQU   FXLSMAP
RBN      EQU   SAVWRK2+2
@NM00075 EQU   SAVWRK2
SAV14    EQU   SAVBOX+56
SAV13    EQU   SAVBOX+52
SAV12    EQU   SAVBOX+48
SAV11    EQU   SAVBOX+44
SAV10    EQU   SAVBOX+40
SAV9     EQU   SAVBOX+36
SAV8     EQU   SAVBOX+32
SAV7     EQU   SAVBOX+28
SAV6     EQU   SAVBOX+24
SAV5     EQU   SAVBOX+20
SAV3     EQU   SAVBOX+12
SAV2     EQU   SAVBOX+8
@NM00074 EQU   SAV1
SAV0     EQU   SAVBOX
@NM00073 EQU   CURNUM+3
@NM00072 EQU   CURNUM
AIADPXCT EQU   AIALGE
AIACEPTR EQU   AIALPMEP
AIASLOT  EQU   AIASSID+1
@NM00071 EQU   AIASSID
@NM00070 EQU   AIALSID
AIARCSN  EQU   AIANXAIA+2
AIACYL   EQU   AIANXAIA
AIARSV9  EQU   AIAFLG3
AIARSV8  EQU   AIAFLG3
AIARSV7  EQU   AIAFLG3
AIALPMEC EQU   AIAFLG3
AIARSV6  EQU   AIAFLG3
AIATRPSP EQU   AIAFLG3
AIAPRINO EQU   AIAFLG3
AIARSV5  EQU   AIAFLG3
AIABADID EQU   AIAFLG2
AIAERROR EQU   AIAFLG2
AIASECER EQU   AIAFLG2
AIAPRIER EQU   AIAFLG2
AIARSV4  EQU   AIAFLG2
AIAIORTY EQU   AIAFLG2
AIATERMR EQU   AIAFLG2
AIAFRAUX EQU   AIAFLG2
AIARSV1  EQU   AIAFLG1
AIASWPFX EQU   AIAFLG1
AIAPAGDS EQU   AIAFLG1
AIALSQA  EQU   AIAFLG1
AIADUPLX EQU   AIAFLG1
AIAVIO   EQU   AIAFLG1
AIAWRITE EQU   AIAFLG1
AIAOP    EQU   AIA+8
AIABQPA  EQU   AIA+4
AIAFQPA  EQU   AIA
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
RSMASMHD EQU   RSMHD+40
RSMLIOQL EQU   RSMLIOQ+4
RSMLIOQF EQU   RSMLIOQ
RSMLSQAL EQU   RSMLSQA+2
RSMLSQAF EQU   RSMLSQA
RSMLFQL  EQU   RSMLFQ+2
RSMLFQF  EQU   RSMLFQ
RSMRSV2  EQU   RSMHD+16
RSMRSV1  EQU   RSMHD+13
@NM00069 EQU   RSMFLG1
RSMFAIL  EQU   RSMFLG1
RSMGFADD EQU   RSMFLG1
RSMCPNC  EQU   RSMFLG1
RSMCPNU  EQU   RSMFLG1
RSMGFAD  EQU   RSMFLG1
RSMIOCPC EQU   RSMFLG1
RSMIOCPU EQU   RSMFLG1
RSMASCB  EQU   RSMHD+8
RSMSPCT  EQU   RSMHD+4
RSMVSTO  EQU   RSMHD
ECBEVNT  EQU   ECBEXTND
@NM00068 EQU   ECBEXTND
@NM00067 EQU   ECBBYTE3
@NM00066 EQU   ECBEXTBA
@NM00065 EQU   ECBCC
ECBPOSTB EQU   ECBCC
ECBWAITB EQU   ECBCC
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
RCARETAD EQU   RCA+20
RCARES9  EQU   RCA+19
@NM00064 EQU   RCA+18
RCAPIOI  EQU   RCA+18
RCANAME7 EQU   RCANAMES+6
RCAREP1  EQU   RCANAME6
RCAPSIF  EQU   RCANAME6
RCAPSIX  EQU   RCANAME6
RCAVEQRP EQU   RCANAME6
RCARCFC  EQU   RCANAME6
RCACSGB  EQU   RCANAME6
RCAPS113 EQU   RCANAME6
RCAFREE  EQU   RCANAME5
RCARFR2  EQU   RCANAME5
RCACPBR  EQU   RCANAME5
RCAOPBR  EQU   RCANAME5
RCASORT  EQU   RCANAME5
RCASIRT  EQU   RCANAME5
RCARELV  EQU   RCANAME5
RCARELF  EQU   RCANAME5
RCAGFAD  EQU   RCANAME4
RCAVEQRI EQU   RCANAME4
RCAVEQRF EQU   RCANAME4
RCAVEQRC EQU   RCANAME4
RCATERM  EQU   RCANAME4
RCASQA   EQU   RCANAME4
RCASWIN  EQU   RCANAME4
RCASOUT  EQU   RCANAME4
RCARFR   EQU   RCANAME3
RCARELS  EQU   RCANAME3
RCARCFI  EQU   RCANAME3
RCARCF   EQU   RCANAME3
RCAPSII  EQU   RCANAME3
RCAPSIB  EQU   RCANAME3
RCAPS112 EQU   RCANAME3
RCAPIX   EQU   RCANAME3
RCAPIOP  EQU   RCANAME2
RCASWPC  EQU   RCANAME2
RCASWPP  EQU   RCANAME2
RCAPFTE  EQU   RCANAME2
RCAPCB   EQU   RCANAME2
RCAOUT   EQU   RCANAME2
RCAITAS  EQU   RCANAME2
RCAIOCP  EQU   RCANAME2
RCAINV   EQU   RCANAME1
RCAGFA   EQU   RCANAME1
RCAVEQR  EQU   RCANAME1
RCADSEG  EQU   RCANAME1
RCADLAS  EQU   RCANAME1
RCACSEG  EQU   RCANAME1
RCAVAMSI EQU   RCANAME1
@NM00063 EQU   RCAFLAGS
RCADISP  EQU   RCAFLAGS
@NM00062 EQU   RCAFLAGS
RCAQS    EQU   RCAFLAGS
RCAPSIER EQU   RCAFLAGS
RCAABEND EQU   RCAFLAGS
RCALL    EQU   RCAFLAGS
RCASAL   EQU   RCAFLAGS
RCARES7  EQU   RCA+8
RCAPARM1 EQU   RCA+4
RCAPARM0 EQU   RCA
XPTLSID2 EQU   XPTLPN
XPTLSID  EQU   XPTLGN
@NM00061 EQU   XPTFLAG2
XPTIOERR EQU   XPTFLAG2
XPTPOINP EQU   XPTFLAG2
XPTRES1  EQU   XPTFLAG2
XPTVALID EQU   XPTFLAG2
XPTRSV4  EQU   XPTFLAGS
XPTDEFER EQU   XPTFLAGS
XPTRES2  EQU   XPTFLAGS
@NM00060 EQU   XPTFLAGS
XPTCKF   EQU   XPTFLAGS
XPTXAV   EQU   XPTFLAGS
XPTVIOLP EQU   XPTFLAGS
XPTRSV1  EQU   XPTE+1
XPTPROT  EQU   XPTE
@NM00059 EQU   PGTBITS
@NM00058 EQU   PGTBITS
@NM00057 EQU   PGTBITS
@NM00056 EQU   PGTBITS
@NM00055 EQU   PGTBITS
@NM00054 EQU   PGTBITS
PGTREAL  EQU   PGTRSA
PCBEND   EQU   PCB+64
PCBSPCTE EQU   PCBRB
PCBRBN   EQU   PCB+24
PCBSWPS2 EQU   PCBFL3
@NM00053 EQU   PCBFL3
PCBNOREC EQU   PCBFL3
PCBDFRLS EQU   PCBFL3
PCBSWPLS EQU   PCBFL3
PCBSWPS1 EQU   PCBFL3
PCBSWPIN EQU   PCBFL3
PCBSWPOT EQU   PCBFL3
@NM00052 EQU   PCBFL2
@NM00051 EQU   PCBFL2
PCBVIO   EQU   PCBFL2
PCBSUPRS EQU   PCBFL2
PCBRESET EQU   PCBFL2
PCBIOERR EQU   PCBFL2
PCBGFAD  EQU   PCBFL2
PCBFREAL EQU   PCBFL2
PCBRLPA  EQU   PCBRLP+1
PCBIOCMP EQU   PCBFL1
PCBIOI   EQU   PCBFL1
PCBLFR   EQU   PCBFL1
PCBLLHLD EQU   PCBFL1
PCBSRBMD EQU   PCBFL1
PCBPEX   EQU   PCBFL1
@NM00050 EQU   PCBFL1
PCBRWRKB EQU   PCBR+60
PCBRWRKA EQU   PCBR+56
PCBRWRK9 EQU   PCBR+52
PCBRWRK8 EQU   PCBR+48
PCBRWRK7 EQU   PCBR+44
PCBRWRK6 EQU   PCBR+40
PCBRWRK5 EQU   PCBR+36
PCBRWRK4 EQU   PCBR+32
PCBRWRK3 EQU   PCBR+28
PCBRWRK2 EQU   PCBR+24
PCBRWRK1 EQU   PCBR+20
PCBRRSV1 EQU   PCBR+18
PCBRPOF  EQU   PCBRFLAG
PCBRFPCB EQU   PCBRFLAG
PCBRPB   EQU   PCBRFLAG
PCBRETRY EQU   PCBRFLAG
@NM00049 EQU   FOEFLAG
@NM00048 EQU   FOEFLAG
@NM00047 EQU   FOEFLAG
@NM00046 EQU   FOEFLAG
@NM00045 EQU   FOEFLAG
@NM00044 EQU   FOEFLAG
@NM00043 EQU   FOEFLAG
FOEINT   EQU   FOEFLAG
PFTUIC   EQU   PFTE+15
@NM00042 EQU   PFTFLAG2
@NM00041 EQU   PFTFLAG2
PFTSTEAL EQU   PFTFLAG2
PFTIRRG  EQU   PFTFLAG2
PFTVR    EQU   PFTFLAG2
PFTOFFLN EQU   PFTFLAG2
PFTDFRLS EQU   PFTFLAG2
PFTOFINT EQU   PFTFLAG1
PFTBADPG EQU   PFTFLAG1
PFTPCBSI EQU   PFTFLAG1
PFTVRPLT EQU   PFTFLAG1
PFTVRINT EQU   PFTFLAG1
PFTONAVQ EQU   PFTFLAG1
PFTRSV1  EQU   PFTE+10
PFTBQPTR EQU   PFTQPTRS+2
PFTFQPTR EQU   PFTQPTRS
PFTVBN   EQU   PFTPGID+2
PFTASID  EQU   PFTPGID
VSLEND1A EQU   VSLEND+1
VSLEXTRS EQU   VSLFLAG2
VSLKEPRL EQU   VSLFLAG2
VSLPGOUT EQU   VSLFLAG2
VSLRSV3  EQU   VSLFLAG2
VSLERR   EQU   VSLFLAG2
VSLRAO   EQU   VSLFLAG2
VSLNULL  EQU   VSLFLAG2
VSLAST   EQU   VSLFLAG2
VSLRSV2  EQU   VSLFLAG1
VSLONG   EQU   VSLFLAG1
VSLRSV1  EQU   VSLFLAG1
VSLRLS   EQU   VSLFLAG1
VSLOAD   EQU   VSLFLAG1
VSLFIX   EQU   VSLFLAG1
VSLCONT  EQU   VSLFLAG1
CIWWRK5  EQU   CIWA+60
CIWWRK4  EQU   CIWA+56
@NM00040 EQU   CIWIFLG2
CIWIKPRL EQU   CIWIFLG2
CIWIOUT  EQU   CIWIFLG2
@NM00039 EQU   CIWIFLG2
CIWIRAO  EQU   CIWIFLG2
CIWINULL EQU   CIWIFLG2
CIWILAST EQU   CIWIFLG2
@NM00038 EQU   CIWIFLG1
CIWILONG EQU   CIWIFLG1
@NM00037 EQU   CIWIFLG1
CIWIRLS  EQU   CIWIFLG1
CIWILOAD EQU   CIWIFLG1
CIWIFREE EQU   CIWIFLG1
CIWIFIX  EQU   CIWIFLG1
CIWICONT EQU   CIWIFLG1
@NM00036 EQU   CIWA+7
CIWEXTRS EQU   CIWOPFL2
CIWKEPRL EQU   CIWOPFL2
CIWPGOUT EQU   CIWOPFL2
@NM00035 EQU   CIWOPFL2
CIWERR   EQU   CIWOPFL2
CIWRAO   EQU   CIWOPFL2
CIWNULL  EQU   CIWOPFL2
CIWLAST  EQU   CIWOPFL2
@NM00034 EQU   CIWOPFL1
@NM00033 EQU   CIWOPFL1
CIWRLS   EQU   CIWOPFL1
CIWLOAD  EQU   CIWOPFL1
CIWFREE  EQU   CIWOPFL1
CIWCONT  EQU   CIWOPFL1
CIWFLG2  EQU   CIWA+1
CIWOUTKR EQU   CIWFLG1
CIWBRIN  EQU   CIWFLG1
CIWBREX  EQU   CIWFLG1
@NM00032 EQU   CIWFLG1
CIWSVC3  EQU   CIWFLG1
CIWSVC2  EQU   CIWFLG1
PVTEND   EQU   PVT+1848
PVTTASID EQU   PVT+1846
PVTXXXXX EQU   PVT+1844
PVTMVCLC EQU   PVT+1840
PVTSPARE EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTSQAFX EQU   PVT+1832
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA1  EQU   PVTWSAX
PVTCIOQL EQU   PVTQS+36
PVTCIOQF EQU   PVTQS+32
PVTGFADL EQU   PVTQS+28
PVTGFADF EQU   PVTQS+24
PVTFPCBL EQU   PVTQS+20
PVTFPCBF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTPRSET EQU   PVT+244
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPOPBR EQU   PVT+220
PVTPRELF EQU   PVT+216
PVTPRELV EQU   PVT+212
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPSRBP EQU   PVT+188
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPINV  EQU   PVT+172
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCV  EQU   PVT+156
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP   EQU   PVT+112
PVTPFTE  EQU   PVT+108
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPSQA  EQU   PVT+80
PVTPSIB  EQU   PVT+72
PVTSRBID EQU   PVT+68
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTREUS  EQU   PVT+48
PVTSQNPC EQU   PVT+47
PVTSQVRC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
@NM00031 EQU   PVTFLAG2
PVTRSMGM EQU   PVTFLAG2
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTAPREF EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
@NM00030 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00029 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBSTAFX EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00028 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00027 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
@NM00026 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00025 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00024 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00023 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00022 EQU   FLCFSA
@NM00021 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00020 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00019 EQU   FLCIOA
@NM00018 EQU   FLCMCLA+15
@NM00017 EQU   FLCMCLA+14
@NM00016 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00015 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00014 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00013 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00012 EQU   FLCPER
@NM00011 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00010 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00009 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00008 EQU   FLCPIILC
@NM00007 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00006 EQU   FLCSVILC
@NM00005 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00004 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00003 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RT00126 EQU   ERREXIT
@RT00128 EQU   OUTOFSTG
@RT00132 EQU   PAGELOOP
@RT00139 EQU   PAGELOOP
@RT00141 EQU   ERREXIT
@RT00145 EQU   OUTOFSTG
@RT00148 EQU   OUTOFSTG
@RT00181 EQU   NEXTPGLP
@RT00188 EQU   LOOPVSL
@RF00183 EQU   NORMEXIT
@RF00190 EQU   NORMEXIT
@RT00198 EQU   ERREXIT
@RT00204 EQU   PAGELOOP
@RF00211 EQU   PAGELOOP
@RF00235 EQU   NORMEXIT
@RF00274 EQU   PAGELOOP
@RF00283 EQU   PAGELOOP
@RT00464 EQU   ENDDEL
@PB00003 EQU   @EC00473
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IEAVFXLD,(C'PLS2054',0801,78221)
