         TITLE 'IEAVSWIN - SWAP IN PROCESSOR                           *
                        '
*                               /*  @Z40WPYC*/
IEAVSWIN CSECT                      @Z40WPYC
         USING *,R15                @Z40WPYC
         MODID                      @Z40WPYC
         DROP  R15                  @Z40WPYC
         ENTRY IEAVSWI2             @Z40WPYC
IEAVSWI2 DS    0H                   @Z40WPYC
@PROLOG  BALR  R9,0                 @Z40WPYC
@PSTART  DS    0H                   @Z40WPYC
         USING *,R9                 @Z40WPYC
*   PVTPTR=CVTPVTP;                 /* INITIALIZE THE PVT POINTER    */
         L     @12,CVTPTR                                          0100
         L     PVTPTR,CVTPVTP(,@12)                                0100
*   RFY                                                            0101
*    (ASCBPTR,                                                     0101
*     R1) RSTD;                                                    0101
*   ASCBPTR=R1;                     /* SAVE INPUT ASCB ADDR          */
         LR    ASCBPTR,R1                                          0102
*   RFY                                                            0103
*    (R0,                                                          0103
*     R13) RSTD;                                                   0103
*   R5=R0;                          /* SAVE THE SRB ADDRESS  @VS08619*/
         LR    R5,R0                                               0104
*   RFY                                                            0105
*    (R11,                                                         0105
*     R12,                                                         0105
*     R8) RSTD;                                                    0105
*                                                                  0105
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH THE RSM FRR ENVIRONMENT AND INITIALIZE THE RCA      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0106
*   GEN REFS(PSACSTK,PSA,FRRS,PVTPTR,PVTPRCV,FRRSCURR,FRRSLAST,PSALSFCC
*       ,FRRSELEN,FRRSFRRA,FRRSENTR,FRRSPARM) SETS(R11,R12,R8);    0106
         SETFRR A,FRRAD=PVTPRCV(PVTPTR),PARMAD=(R8),                  **
               WRKREGS=(R11,R12)
*   RFY                                                            0107
*     RCA BASED(R8);                                               0107
*   RCACSECT=RCACSPIN;              /* SET THE MODULE ID FLAG        */
         MVI   RCACSECT(R8),X'19'                                  0108
*   RCAPARM1=ASCBPTR;               /* SET ASCB FOR FRR ROUTINE    0109
*                                                            @Z40WPYC*/
         ST    ASCBPTR,RCAPARM1(,R8)                               0109
*   RCASWIN='1'B;                   /* SET THE ENTRY POINT BIT ON    */
         OI    RCASWIN(R8),B'01000000'                             0110
*                                                                  0111
*   /*****************************************************************/
*   /*                                                               */
*   /* REQUEST THE SALLOC LOCK UNCONDITIONALLY FROM LOCK MANAGER     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0111
*GETLOCK:                                                          0111
*   GEN CODE REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);              0111
GETLOCK  DS    0H                                                  0111
         SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(RSM,IEAVSWIN(FREELOCK,FREELOC))
*   RFY                                                            0112
*    (R0,                                                          0112
*     R1,                                                          0112
*     R11,                                                         0112
*     R12,                                                         0112
*     R13) UNRSTD;                                                 0112
*   PVTPRCA=R8;                     /* SAVE THE RCA ADDRESS          */
         ST    R8,PVTPRCA(,PVTPTR)                                 0113
*   RCASAL='1'B;                    /* INDICATE SALLOC HELD          */
*                                                                  0114
         OI    RCASAL(R8),B'10000000'                              0114
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE THE VALIDITY OF THE SWAP-IN REQUEST                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0115
*   RSMHDPTR=ASCBRSM;               /* ESTABLISH POINTER TO THE    0115
*                                      HEADER                        */
         L     RSMHDPTR,ASCBRSM(,ASCBPTR)                          0115
*   SPCTPTR=RSMSPCT;                /* ESTABLISH SPCT PTR            */
         L     SPCTPTR,RSMSPCT(,RSMHDPTR)                          0116
*   IF SPCTSWIN='1'B THEN           /* CHECK FOR A SWAP-IN ALREADY IN
*                                      PROGRESS                      */
         TM    SPCTSWIN(SPCTPTR),B'10000000'                       0117
         BNO   @RF00117                                            0117
*     DO;                           /* INVOKE THE FRR ROUTINE        */
*       RCARCRD='12'X;              /* SET REASON CODE AND           */
         MVI   RCARCRD(R8),X'12'                                   0119
*       CALL SWAPC0D;               /* RECORD ERROR VIA FRR ROUTINE  */
*                                                                  0120
         BAL   @14,SWAPC0D                                         0120
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SUBROUTINE FREES THE SRB AREA ADDRESSED BY REGISTER  */
*       /* ZERO WHEN THE ROUTINE IS ENTERED.                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0121
*       RESPECIFY                                                  0121
*        (R0,                                                      0121
*         R1) RESTRICTED;                                          0121
*       R1=R5;                      /* PUT THE SRB ADDRESS IN R1   0122
*                                                            @VS08619*/
         LR    R1,R5                                               0122
*       R0=PVTSRBID;                /* PUT THE CELL POOL ID IN R0  0123
*                                                            @VS08619*/
         L     R0,PVTSRBID(,PVTPTR)                                0123
*       GEN REFS(CVTPTR,CVTFRECL,CVTMAP,R13) SETS(R14,R15);        0124
*                                                        /* @VS08619*/
         FREECELL CPID=(0),CELL=(1),BRANCH=YES,SAVE=NO
*       RESPECIFY                                                  0125
*        (R0,                                                      0125
*         R1) UNRESTRICTED;                                        0125
*       PVTPTR=CVTPVTP;             /* RESET PVT ADDRESS     @VS08619*/
         L     @12,CVTPTR                                          0126
         L     PVTPTR,CVTPVTP(,@12)                                0126
*       GOTO SWINLOCK;              /* GO RELEASE LOCK AND EXIT      */
         B     SWINLOCK                                            0127
*     END;                                                         0128
*   RFY                                                            0129
*     RCA BASED(PVTPRCA);                                          0129
@RF00117 DS    0H                                                  0130
*   RFY                                                            0130
*     R8 UNRSTD;                                                   0130
*                                                                  0131
*   /*****************************************************************/
*   /*                                                               */
*   /* ONCE IT HAS BEEN DETERMINED THAT THE SWAP-IN IS VALID THE     */
*   /* SYSEVENT INDICATING THAT SWAP-IN HAS STARTED CAN BE ISSUED.   */
*   /*                                                       @Z40FPYL*/
*   /* SWAP-IN IS VALID. GO TO THE PCB MANAGER WITH A REQUEST FOR A  */
*   /* SUFFICIENT NUMBER OF PCBS TO COMPLETE THE SWAP-IN.            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0131
*   RFY                                                            0131
*    (R0,                                                          0131
*     R13,                                                         0131
*     R1) RESTRICTED;                                              0131
*   R0=ASCBASID;                    /* ASID FOR SWAPPED-IN A.S.    0132
*                                                            @Z40FPYL*/
         LH    R0,ASCBASID(,ASCBPTR)                               0132
         N     R0,@CF02051                                         0132
*   R1=STARTS;                      /* CODE FOR SWAP-IN STARTED    0133
*                                                            @Z40FPYL*/
         LA    R1,1                                                0133
*   R13=ADDR(PVTSAVE);              /* SAVE AREA ADDRESS     @Z40FPYL*/
         LA    R13,PVTSAVE(,PVTPTR)                                0134
*   GENERATE NODEFS REFS(CVTPTR,CVTOPTE,CVT) NOSETS NOFLOWS;       0135
    SYSEVENT SWINSTAT,ASID=(0),ENTRY=BRANCH
*   RESPECIFY                                                      0136
*    (R13) UNRESTRICTED;                                           0136
*   R0=SPCTWSSZ+1;                  /* NUMBER REQUESTED = WORKING SET
*                                      SIZE PLUS 1 TO USE AS THE ROOT*/
         LA    R0,1                                                0137
         AH    R0,SPCTWSSZ(,SPCTPTR)                               0137
*   R1=0;                           /* INDICATE A BUILD OPTION       */
         SLR   R1,R1                                               0138
*   CALL PCBMGR;                    /* CALL THE PCB MANAGER          */
*                                                                  0139
         L     @15,PVTPCB(,PVTPTR)                                 0139
         BALR  @14,@15                                             0139
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK THE RETURN CODE FROM THE PCB MANAGER. IF AN ERROR HAS   */
*   /* OCCURRED, NOTIFY SRM VIA A SYSEVENT THAT THE SWAP-IN CANNOT   */
*   /* COMPLETE AT THIS TIME AND EXIT.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0140
*   IF R15^=0 THEN                  /* A NON-ZERO R15 ON RETURN      */
         LTR   R15,R15                                             0140
         BZ    @RF00140                                            0140
*     DO;                           /* INDICATES AN ERROR            */
*                                                                  0141
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SUBROUTINE FREES THE SRB AREA ADDRESSED BY REGISTER  */
*       /* ZERO WHEN THE ROUTINE IS ENTERED.                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0142
*       R1=R5;                      /* PUT THE SRB ADDRESS IN R1   0142
*                                                            @VS08619*/
         LR    R1,R5                                               0142
*       R0=PVTSRBID;                /* PUT THE CELL POOL ID IN R0  0143
*                                                            @VS08619*/
         L     R0,PVTSRBID(,PVTPTR)                                0143
*       GEN REFS(CVTPTR,CVTFRECL,CVTMAP,R13) SETS(R14,R15);        0144
*                                                        /* @VS08619*/
         FREECELL CPID=(0),CELL=(1),BRANCH=YES,SAVE=NO
*       PVTPTR=CVTPVTP;             /* RESET PVT ADDRESS     @VS08619*/
         L     @12,CVTPTR                                          0145
         L     PVTPTR,CVTPVTP(,@12)                                0145
*       R0=ASCBASID;                /* SET ASID FOR EVENT            */
         LH    R0,ASCBASID(,ASCBPTR)                               0146
         N     R0,@CF02051                                         0146
*       GOTO SWINSYS;               /* GO TO ISSUE SYSEVENT AND EXIT */
         B     SWINSYS                                             0147
*     END;                                                         0148
*                                                                  0148
*/*                                                                  */
*                                                                  0149
*   SPCTSWIN='1'B;                  /* OTHERWISE, SET THE SWAP-IN IN
*                                      PROGRESS FLAG                 */
@RF00140 DS    0H                                                  0150
*   SPCTVROT='0'B;                  /* CLEAR THE VEQRP REQUESTED   0150
*                                      SWAP-OUT FLAG         @ZA10767*/
         OI    SPCTSWIN(SPCTPTR),B'10000000'                       0150
         NI    SPCTVROT(SPCTPTR),B'11111011'                       0150
*                                                                  0151
*   /*****************************************************************/
*   /*                                                               */
*   /* USE THE FIRST PCB ADDRESS RETURNED AS THE ROOT PCB            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0151
*   PCBRPTR=R1;                     /* ESTABLISH ADDRESS OF THE ROOT */
         LR    PCBRPTR,R1                                          0151
*   SPCTSWRT=R1;                    /* PUT ROOT ADDRESS IN SPCT      */
         ST    R1,SPCTSWRT(,SPCTPTR)                               0152
*   SRBPTR=R5;                      /* SAVE THE SRB PTR IN THE ROOT
*                                      PCB. IT IS PASSED TO THE SWAP
*                                      IN ROOT EXIT ROUTINE. @VS08619*/
         ST    R5,SRBPTR(,PCBRPTR)                                 0153
*   PCBPTR=R1->PCBFQPA;             /* ESTABLISH POINTER TO THE FIRST
*                                      TRUE PCB                      */
         L     PCBPTR,PCBFQPA-1(,R1)                               0154
         LA    PCBPTR,0(,PCBPTR)                                   0154
*   RFY                                                            0155
*    (R0,                                                          0155
*     R1) UNRSTD;                                                  0155
*   PCBRTCB=0;                      /* ZERO THE TCB PTR IN THE ROOT  */
         SLR   @12,@12                                             0156
         ST    @12,PCBRTCB(,PCBRPTR)                               0156
*   PCBRGOTO=ADDR(IEAVSIRT);        /* SET ADDR OF EXIT PROCESSOR IN
*                                      ROOT                          */
         LA    @08,IEAVSIRT                                        0157
         ST    @08,PCBRGOTO(,PCBRPTR)                              0157
*   PCBRASCB=ASCBPTR;               /* PUT THE ASCB ADDRESS IN ROOT  */
         ST    ASCBPTR,PCBRASCB(,PCBRPTR)                          0158
*   PCBRWRK1=PCBPTR;                /* SAVE PTR TO 1ST PCB TO PASS TO
*                                      GFA                           */
         ST    PCBPTR,PCBRWRK1(,PCBRPTR)                           0159
*   PCBBQPA=0;                      /* MAKE IT LOOK LIKE 1ST ON CHAIN*/
         ST    @12,PCBBQPA(,PCBPTR)                                0160
*   RFY                                                            0161
*     ASCBPTR UNRSTD;                                              0161
*   RFY                                                            0162
*     ASCB BASED(PCBRASCB);                                        0162
*                                                                  0163
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS FIXED AND LSQA ENTRIES.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0163
*/*  SET UP CONTROL VARIABLES FOR THE LOOP WHICH FOLLOWS             */
*                                                                  0163
*   RFY                                                            0163
*     START RSTD;                   /* RESERVE REG 8                 */
*   RFY                                                            0164
*     FINISH RSTD;                  /* RESERVE REG 10                */
*   RFY                                                            0165
*     SWAPPTR RSTD;                 /* RESERVE REG 11                */
*   RFY                                                            0166
*     R13 RSTD;                     /* RESERVE REG 13                */
*   RFY                                                            0167
*     SPCTEXTM BASED(SWAPPTR);      /* ESTABLISH BASE PTR FOR      0167
*                                      EXTENSION                     */
*   LSQACOMP='0'B;                  /* INITIALIZE LSQA COMPLETE BIT
*                                      TO 0                          */
         NI    LSQACOMP(PCBRPTR),B'01111111'                       0168
*   R13=R13&&R13;                   /* R13 WILL KEEP TRACK OF ANY  0169
*                                      PCBS WHICH MAY BE RETURNED AT
*                                      THE END OF THE PROCESSING     */
         XR    R13,R13                                             0169
*   START=SPCTLSQA;                 /* SET TOTAL NUMBER OF LSQA    0170
*                                      ENTRIES TO BE PROCESSED       */
         LH    START,SPCTLSQA(,SPCTPTR)                            0170
*   SWAPPTR=ADDR(SPCTSWAP);         /* INITIALIZE SWAPPTR TO START 0171
*                                      WITH ENTRIES WITHIN SPCT      */
         LA    SWAPPTR,SPCTSWAP(,SPCTPTR)                          0171
*   FINISH=ADDR(SPCTXEND);          /* FINISH IS JUST BEYOND THE   0172
*                                      FIXED AND LSQA ENTRIES AREA   */
         LA    FINISH,SPCTXEND(,SWAPPTR)                           0172
*   SWAPPTR=ADDR(SPCTENT);          /* POINT TO FIRST LSQA ENTRY     */
         LA    @12,SPCTENT(,SWAPPTR)                               0173
         LR    SWAPPTR,@12                                         0173
*                                                                  0174
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS THE START OF THE BIG LOOP THROUGH THE FIXED AND LSQA  */
*   /* ENTRIES OF THE SPCT                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0174
*SWINFIX:                                                          0174
*   DO WHILE START^=0;              /* START OF BIG LOOP             */
SWINFIX  B     @DE00174                                            0174
@DL00174 DS    0H                                                  0175
*     IF SWAPPTR=FINISH THEN        /* SHOULD WE GO TO THE EXTENSION */
         CR    SWAPPTR,FINISH                                      0175
         BNE   @RF00175                                            0175
*       DO;                         /* YES-MAKE EXTENSION ADJUSTMENTS*/
*         SWAPPTR=SWAPPTR-LENGTH(SPCTSWAP);/* POINT BACK TO START OF
*                                      THIS EXTENSION                */
         SL    SWAPPTR,@CF01288                                    0177
*         SWAPPTR=SPCTEXT;          /* GET ADDRESS OF NEW EXTENSION  */
         L     SWAPPTR,SPCTEXT(,SWAPPTR)                           0178
*         IF SWAPPTR^=0 THEN        /* CHECK POINTER TO NEXT FOR 0   */
         LTR   SWAPPTR,SWAPPTR                                     0179
         BZ    @RF00179                                            0179
*           DO;                                                    0180
*             FINISH=ADDR(SPCTXEND);/* SET END OF EXTENSION VALUE    */
         LA    FINISH,SPCTXEND(,SWAPPTR)                           0181
*             SWAPPTR=ADDR(SPCTENT);/* POINT TO FIRST ENTRY IN NEW 0182
*                                      EXTENSION                     */
         LA    @12,SPCTENT(,SWAPPTR)                               0182
         LR    SWAPPTR,@12                                         0182
*           END;                                                   0183
*         ELSE                      /* IF THERE IS NO EXTENSION BUT  */
*           DO;                     /* ARE SUPPOSED TO BE MORE     0184
*                                      ENTRIES, AN ERROR MUST HAVE 0184
*                                      OCCURRED WHILE CONSTRUCTING 0184
*                                      THE SPCT.                     */
*                                                                  0184
         B     @RC00179                                            0184
@RF00179 DS    0H                                                  0185
*             /*******************************************************/
*             /*                                                     */
*             /* CALL RESOURCE TERMINATION MANAGER TO TERMINATE THE  */
*             /* MEMORY.                                             */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0185
*             RSMFAIL='1'B;         /* TELL ASM LSQA INVALID @Z40WPYC*/
         OI    RSMFAIL(RSMHDPTR),B'00000010'                       0185
*             R2=ASCBASID;          /* SET THE ASID VALUE            */
         L     @12,PCBRASCB(,PCBRPTR)                              0186
         LH    R2,ASCBASID(,@12)                                   0186
         N     R2,@CF02051                                         0186
*             CALL SWAPRTM;         /* CALL INTERNAL SUBROUTINE TO 0187
*                                      TERMINATE THE MEMORY          */
*                                                                  0187
         BAL   @14,SWAPRTM                                         0187
*             /*******************************************************/
*             /*                                                     */
*             /* FREE THE ROOT PCB AND EXISTING PCB CHAIN.           */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0188
*             CALL SWAPPCB;         /* CALL PCB FREE SUBROUTINE      */
         BAL   @14,SWAPPCB                                         0188
*             GOTO SWINLOCK;        /* GO TO EXIT PROCESSING         */
         B     SWINLOCK                                            0189
*           END;                    /* END OF ERROR PROCESSING       */
*       END;                        /* END OF EXTENSION ADJUSTMENTS  */
@RC00179 DS    0H                                                  0192
*     RFY                                                          0192
*      (R0,                                                        0192
*       R1) RSTD;                                                  0192
@RF00175 DS    0H                                                  0193
*     R1=SPCTVBN;                   /* GET THE VBN FROM THE ENTRY  0193
*                                                            @Z40WPYC*/
         LH    R1,SPCTVBN(,SWAPPTR)                                0193
         N     R1,@CF02051                                         0193
*     IF SPCTLSQ='0'B THEN          /* DETERMINE IF ENTRY IS FIXED OR
*                                      LSQA                          */
*                                                                  0194
         TM    SPCTLSQ(SWAPPTR),B'01000000'                        0194
         BNZ   @RF00194                                            0194
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SECTION HANDLES FIXED ENTRIES IN THE SPCT            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0195
*       DO;                         /* START OF FIXED ENTRY PROCESS  */
*         IF SPCTCOMM='0'B THEN     /* DETERMINE IF PAGE IS IN       */
         TM    SPCTCOMM(SWAPPTR),B'00100000'                       0196
         BNZ   @RF00196                                            0196
*           DO;                     /* THE PRIVATE OR COMMON AREA    */
*                                                                  0197
*             /*******************************************************/
*             /*                                                     */
*             /* PRIVATE AREA PCB INITIALIZATION FOR A FIXED ENTRY   */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0198
*             PCBASCB=PCBRASCB;     /* STORE INPUT ASCB ADDRESS      */
         L     @12,PCBRASCB(,PCBRPTR)                              0198
         ST    @12,PCBASCB(,PCBPTR)                                0198
*             PCBSWPIN='1'B;        /* SET SWAP-IN FLAG              */
*             PCBSWPS1='1'B;        /* SET STAGE 1 FLAG              */
         OI    PCBSWPIN(PCBPTR),B'01100000'                        0200
*             PCBSPCTE=SWAPPTR;     /* POINT TO FIX ENTRY    @Z40WPYC*/
         ST    SWAPPTR,PCBSPCTE(,PCBPTR)                           0201
*             IF PCBASCB->ASCB1LPU='1'B THEN/* IF LEVEL 1 USER,    0202
*                                                            @ZA16816*/
         TM    ASCB1LPU(@12),B'01000000'                           0202
         BNO   @RF00202                                            0202
*               PCBPREFR='1'B;      /* BACK WITH PREFERRED FRAME   0203
*                                                            @ZA16816*/
         OI    PCBPREFR(PCBPTR),B'00001000'                        0203
*             AIASWPFX='1'B;        /* INDICATE P.A. FIX PAGE      0204
*                                                            @Z40WPYC*/
@RF00202 DS    0H                                                  0205
*             AIAPRIV='1'B;         /* INDICATE P.A. PAGE    @Z40WPYC*/
         OI    AIASWPFX(PCBPTR),B'01000010'                        0205
*             AIALSID=SPCTSSID;     /* SET THE LSID FOR ASM  @Z40WPYC*/
         SLR   @12,@12                                             0206
         ICM   @12,7,SPCTSSID(SWAPPTR)                             0206
         ST    @12,AIALSID(,PCBPTR)                                0206
*             IF SPCTDEFR='1'B THEN /* IF DEFERRED RELEASE=1         */
         TM    SPCTDEFR(SWAPPTR),B'00010000'                       0207
         BNO   @RF00207                                            0207
*               PCBDFRLS='1'B;      /* SET BIT IN PRIV AREA PCB      */
         OI    PCBDFRLS(PCBPTR),B'00001000'                        0208
*           END;                                                   0209
*         ELSE                      /* SPCTCOMM = 1                  */
*                                                                  0210
*           /*********************************************************/
*           /*                                                       */
*           /* COMMON AREA FIXED ENTRY PROCESSING                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0210
*           DO;                                                    0210
         B     @RC00196                                            0210
@RF00196 DS    0H                                                  0211
*             IF SPCTDEFR='1'B THEN /* IF DEFERRED RELEASE           */
         TM    SPCTDEFR(SWAPPTR),B'00010000'                       0211
         BO    @RT00211                                            0211
*               GOTO SWINCOM1;      /* IS ON IN COMMON AREA ENTRY, 0212
*                                      IGNORE ENTRY AND CONTINUE     */
*/*   REG 1 STILL CONTAINS THE SSP0 PORTION OF THE VBN AT THIS POINT */
*                                                                  0213
*             GEN SETS(R0,R1) FLOWS(SWINCOM2);                     0213
*                                                                  0213
         SLL   R1,8                  CONVERT VBN TO VSA @Z40WPYC
         LRA   R0,0(R1)              ISSUE LOAD REAL ADDRESS INSTR
         BNZ   SWINCOM2              BRANCH IF NOT IN STORAGE
         SRL   R0,8                  LEAVE ONLY RBN IN REG 0
*             /*******************************************************/
*             /*                                                     */
*             /* COMMON AREA IN-CORE FIX COUNT MANIPULATIONS         */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0214
*             RFY                                                  0214
*               PFTEPTR RSTD;                                      0214
*             PFTEPTR=PVTPFTP+R0;   /* GET THE PFTE ADDRESS          */
         LR    PFTEPTR,R0                                          0215
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0215
*             IF PFTFXCT^=0|PFTPREF='1'B THEN/* IF THE FIX CT IS NOT
*                                      ZERO OR THE FRAME IS IN THE 0216
*                                      PREFERRED AREA ALREADY, THEN
*                                      ADD THE FIX CT IN THE SPCT TO
*                                      THE FIX CT IN THE PFTE AND DO
*                                      NOT SET UP A PCB      @ZA16816*/
         LH    @12,PFTFXCT(,PFTEPTR)                               0216
         LTR   @12,@12                                             0216
         BNZ   @RT00216                                            0216
         TM    PFTPREF(PFTEPTR),B'00000100'                        0216
         BNO   @RF00216                                            0216
@RT00216 DS    0H                                                  0217
*               DO;                 /* START OF IN-CORE PROCESS      */
*                 IF PFTFXCT=0 THEN /*                       @YA01572*/
         LH    @12,PFTFXCT(,PFTEPTR)                               0218
         LTR   @12,@12                                             0218
         BNZ   @RF00218                                            0218
*                   DO;             /* WHEN FXCT OF          @YA01572*/
*                     PVTCNTFX=PVTCNTFX+1;/* IN-CORE C.A.    @YA01572*/
         LA    @12,1                                               0220
         LH    @07,PVTCNTFX(,PVTPTR)                               0220
         ALR   @07,@12                                             0220
         STH   @07,PVTCNTFX(,PVTPTR)                               0220
*                     PVTCOMFX=PVTCOMFX+1;/* FX=0, INCREMENT @YA01572*/
         AH    @12,PVTCOMFX(,PVTPTR)                               0221
         STH   @12,PVTCOMFX(,PVTPTR)                               0221
*                     IF PVTCNTFX=PVTMAXFX THEN/* BOTH       @YA01572*/
         CH    @07,PVTMAXFX(,PVTPTR)                               0222
         BNE   @RF00222                                            0222
*                       DO;         /* COUNTS; TEST          @YA01572*/
*                         RESPECIFY /* PVTCNTFX VS PVTMAXFX  @YA01572*/
*                          (R7,                                    0224
*                           R12) RESTRICTED;/*               @ZA25147*/
*                         R12=PFTEPTR;/* SAVE PFTE ADDRESS OVER    0225
*                                      SYSEVENT              @ZA25147*/
         LR    R12,PFTEPTR                                         0225
*                         R7=R13;   /* SAVE R13 OVER THE SYSEVENT  0226
*                                                            @YA01572*/
         LR    R7,R13                                              0226
*                         R13=ADDR(PVTSAVE);/* SAVE AREA ADDRESS FOR
*                                      SRM TO USE            @YA01572*/
         LA    R13,PVTSAVE(,PVTPTR)                                0227
*                         R1=MAXSYS;/* CODE FOR MAXIMUM HAS BEEN   0228
*                                      REACHED               @YA01572*/
         LA    R1,4                                                0228
*                         GENERATE NODEFS REFS(CVTPTR,CVTOPTE,CVT) 0229
*                             NOSETS NOFLOWS;                      0229
       SYSEVENT AVQLOW,ENTRY=BRANCH
*                         PFTEPTR=R12;/* RESTORE PFTE ADDRESS      0230
*                                                            @ZA25147*/
         LR    PFTEPTR,R12                                         0230
*                         R13=R7;   /* RESTORE R13           @YA01572*/
         LR    R13,R7                                              0231
*                         RESPECIFY                                0232
*                          (R7,                                    0232
*                           R12) UNRESTRICTED;/*             @ZA25147*/
*                       END;        /* END SYSEVENT          @YA01572*/
*                     ELSE                                         0234
*                       ;           /* END MAX TEST          @YA01572*/
@RF00222 DS    0H                                                  0235
*                   END;            /* END IN-CORE C.A. FIX ENTRY  0235
*                                      TEST                  @YA01572*/
*                 ELSE                                             0236
*                   ;               /* PFTFXCT ^0            @YA01572*/
@RF00218 DS    0H                                                  0237
*                 IF SPCTTFIX=0 THEN/* IF ITS NOT A BIG FIX          */
         CLI   SPCTTFIX(SWAPPTR),0                                 0237
         BNE   @RF00237                                            0237
*                   PFTFXCT=PFTFXCT+SPCTFIXC;/* ADD THE FULL FIX   0238
*                                      COUNT                         */
         LH    @12,PFTFXCT(,PFTEPTR)                               0238
         AH    @12,SPCTFIXC(,SWAPPTR)                              0238
         STH   @12,PFTFXCT(,PFTEPTR)                               0238
*                 ELSE              /* IF IT IS A BIG FIX,           */
*                   DO;             /* ADD ONLY ONE TO THE PRESENT   */
         B     @RC00237                                            0239
@RF00237 DS    0H                                                  0240
*                     PFTFXCT=PFTFXCT+1;/* COUNT AND INDICATE THAT 0240
*                                      THE ROOT MUST PROCESS IT      */
         LA    @12,1                                               0240
         AH    @12,PFTFXCT(,PFTEPTR)                               0240
         STH   @12,PFTFXCT(,PFTEPTR)                               0240
*                     SPCTBIG='1'B; /* BY SETTING SPCTBIG            */
         OI    SPCTBIG(SPCTPTR),B'00010000'                        0241
*                   END;            /* END IN-CORE BIG FIX PROCESS   */
*SWINCOM1:                                                         0243
*                 R13=R13+1;        /* ADD 1 TO COUNT OF PCBS TO   0243
*                                      RETURN AT END                 */
@RC00237 DS    0H                                                  0243
SWINCOM1 AL    R13,@CF00062                                        0243
*                 SWAPPTR=SWAPPTR+LENGTH(SPCTSWPE);/* GET NEXT FIX 0244
*                                      ENTRY                         */
         AL    SWAPPTR,@CF00055                                    0244
*                 GOTO SWINEND;     /* GO TO END OF LOOP TO HAVE CTRS
*                                      ADJUSTED                      */
         B     SWINEND                                             0245
*               END;                /* END IN-CORE PROCESS           */
*             ELSE                  /* FIX CT = 0 OR IN V=R AREA     */
*                                                                  0247
*               /*****************************************************/
*               /*                                                   */
*               /* OUT-OF-CORE COMMON AREA PCB INITIALIZATION. A PCB */
*               /* IS INITIALIZED FOR OUT OF STORAGE PAGES AS WELL AS*/
*               /* THOSE IN STORAGE PAGES THAT ARE NOT FIXED AND NOT */
*               /* IN A PREFERRED AREA FRAME.                        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0247
*SWINCOM2:                                                         0247
*               PCBASCB=PSAAOLD;    /* SET CURRENT ASCB ADDRESS FOR
*                                      COMMON AREA FRAMES WHICH    0247
*                                      REQUIRE I-O                   */
@RF00216 DS    0H                                                  0247
SWINCOM2 L     @12,PSAAOLD                                         0247
         ST    @12,PCBASCB(,PCBPTR)                                0247
*             PCBPREFR='1'B;        /* BACK WITH PREFERRED FRAMES. 0248
*                                                            @ZA16816*/
*                                                                  0248
         OI    PCBPREFR(PCBPTR),B'00001000'                        0248
*             /*******************************************************/
*             /*                                                     */
*             /* IT IS IMPORTANT THAT MASTER'S ASCB (CURRENT) BE     */
*             /* STORED IN PCBASCB FOR COMMON AREA SWAPIN FIXES. IF  */
*             /* THIS PCB WERE TO BE RELATED BY IEAVGFA TO A PREVIOUS*/
*             /* REQUEST FOR THE PAGE AND THIS REQUEST RECEIVED AN   */
*             /* I/O ERROR, IEAVIOCP SCHEDULES EACH RELATED TO THE   */
*             /* PCBASCB. IN THIS CASE THE SWAPIN WOULD HANG AND     */
*             /* POSSIBLY THE SYSTEM IF OTHER PCB'S WERE RELATED, IF */
*             /* THE SWAPIN ASCB WAS USED.                           */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0249
*             RSMHDPTR=PSAAOLD->ASCBRSM;/* SET CURRENT RSM HEADER  0249
*                                      ADDRESS FOR USE BY FINDPAGE   */
*                                                                  0249
         L     RSMHDPTR,ASCBRSM(,@12)                              0249
*             /*******************************************************/
*             /*                                                     */
*             /* REG 1 STILL CONTAINS THE VSA AT THIS POINT          */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0250
*             CALL FINDPAGE;        /* CALL IEAVFP2 TO GET PGTE AND
*                                      XPTE ADDRESSES FOR COMMON AREA
*                                      PAGES                         */
         L     @15,PVTPFP2(,PVTPTR)                                0250
         BALR  @14,@15                                             0250
*             RSMHDPTR=ASCBRSM;     /* RESET RSM HEADER POINTER FOR
*                                      A.S. BEING SWAPPED IN         */
         L     @12,PCBRASCB(,PCBRPTR)                              0251
         L     RSMHDPTR,ASCBRSM(,@12)                              0251
*             IF R15^=0 THEN        /* IGNORE THIS ENTRY IF FP       */
         LTR   R15,R15                                             0252
         BZ    @RF00252                                            0252
*               DO;                 /* RETURNS AN ERROR CODE         */
*                                                                  0253
*                 /***************************************************/
*                 /*                                                 */
*                 /* INDICATES PAGE HAS BEEN FREEMAINED              */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0254
*                 RCARCRD='01'X;    /* SET REASON CODE               */
         L     @12,PVTPRCA(,PVTPTR)                                0254
         MVI   RCARCRD(@12),X'01'                                  0254
*SWINABND:                                                         0255
*                 CALL SWAPC0D;     /* RECORD ERROR VIA THE FRR      */
SWINABND BAL   @14,SWAPC0D                                         0255
*                 PCBFLDS=PCBFLDS&&PCBFLDS;/* ZERO FIELDS USED IN  0256
*                                      PRESENT PCB                   */
         XC    PCBFLDS(56,PCBPTR),PCBFLDS(PCBPTR)                  0256
*                 GOTO SWINCOM1;    /* CONTINUE PROCESS WITH NEXT FIX
*                                      ENTRY                         */
         B     SWINCOM1                                            0257
*               END;                                               0258
*             PTEPTR=R0;            /* ELSE, CHECK ASSIGNED BIT      */
@RF00252 LR    PTEPTR,R0                                           0259
*             IF PGTPAM='0'B THEN   /* IF NOT ASSIGNED,              */
         TM    PGTPAM(PTEPTR),B'00000001'                          0260
         BNZ   @RF00260                                            0260
*               DO;                                                0261
*                 RCARCRD='1A'X;    /* SET REASON CODE               */
         L     @12,PVTPRCA(,PVTPTR)                                0262
         MVI   RCARCRD(@12),X'1A'                                  0262
*                 GOTO SWINABND;    /* RECORD ERROR AND CONTINUE WITH
*                                      NEXT ENTRY                    */
         B     SWINABND                                            0263
*               END;                                               0264
*                                                                  0264
*             /*******************************************************/
*             /*                                                     */
*             /* NOT NECESSARY TO PROVIDE ASM WITH LSID AS ASM CAN   */
*             /* OBTAIN THIS FROM XPTE IN SQA. ALSO, SPCT ADDRESS IS */
*             /* NOT REQUIRED SINCE XPTE IS IN SQA.          @Z40WPYC*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0265
*             PCBPGTA=PTEPTR;       /* PUT PGTE ADDR IN PCB          */
@RF00260 STCM  PTEPTR,7,PCBPGTA(PCBPTR)                            0265
*             PCBXPTA=R1;           /* PUT XPTE ADDR IN PCB          */
         STCM  R1,7,PCBXPTA(PCBPTR)                                0266
*             PCBSWPS1='1'B;        /* SET STAGE 1 FLAG              */
         OI    PCBSWPS1(PCBPTR),B'00100000'                        0267
*           END;                    /* END OF UNIQUE COMMON AREA   0268
*                                      PROCESS                       */
*         RFY                                                      0269
*          (R0,                                                    0269
*           R1,                                                    0269
*           PFTEPTR) UNRSTD;                                       0269
@RC00196 DS    0H                                                  0270
*                                                                  0270
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SECTION EXECUTES FOR ALL FIXED ENTRIES WHICH ARE TO*/
*         /* BE PASSED TO GENERAL FRAME ALLOCATION, REGARDLESS OF    */
*         /* WHETHER THE PAGE IS IN THE COMMON OR PRIVATE AREA.      */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0270
*SWINNCOM:                                                         0270
*         IF SPCTTFIX=0 THEN        /* IF FIX CT IS NOT OVER 255,    */
SWINNCOM CLI   SPCTTFIX(SWAPPTR),0                                 0270
         BNE   @RF00270                                            0270
*           PCBFXC=SPCTFIXC;        /* MOVE FIX COUNT FROM ENTRY     */
         LH    @12,SPCTFIXC(,SWAPPTR)                              0271
         STC   @12,PCBFXC(,PCBPTR)                                 0271
*         ELSE                                                     0272
*           DO;                     /* IF FIX CT IS TOO LARGE TO FIT
*                                      IN THE PCB                    */
         B     @RC00270                                            0272
@RF00270 DS    0H                                                  0273
*             PCBFXC=1;             /* SET IT TO ONE FOR NOW AND LET
*                                      THE ROOT UPDATE THE PFTE COUNT
*                                      LATER                         */
         MVI   PCBFXC(PCBPTR),X'01'                                0273
*             SPCTBIG='1'B;         /* SET INDICATOR SO ROOT WILL  0274
*                                      KNOW THERE ARE SOME BIG FIXES
*                                      TO PROCESS                    */
         OI    SPCTBIG(SPCTPTR),B'00010000'                        0274
*           END;                                                   0275
*         PCBVBN=SPCTVBN;           /* MOVE VBN INTO PCB     @Z40WPYC*/
@RC00270 MVC   PCBVBN(2,PCBPTR),SPCTVBN(SWAPPTR)                   0276
*         SWAPPTR=SWAPPTR+LENGTH(SPCTSWPE);/* POSITION SWAPPTR TO  0277
*                                      NEXT FIX ENTRY                */
         AL    SWAPPTR,@CF00055                                    0277
*       END;                        /* END OF FIXED ENTRY PROCESS    */
*     ELSE                          /* SPCTLSQ = 1                   */
*SWINLSQA:                                                         0279
*                                                                  0279
*       /*************************************************************/
*       /*                                                           */
*       /* THE FOLLOWING IS DONE FOR ALL LSQA ENTRIES                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0279
*       DO;                         /* START OF UNIQUE LSQA        0279
*                                      PROCESSING                    */
         B     @RC00194                                            0279
@RF00194 DS    0H                                                  0279
SWINLSQA DS    0H                                                  0280
*         PCBSPCTE=SWAPPTR;         /* POINT TO LSQA ENTRY   @Z40WPYC*/
         ST    SWAPPTR,PCBSPCTE(,PCBPTR)                           0280
*         PCBASCB=PCBRASCB;         /* STORE ASCB ADDR OF ADDR SPACE
*                                      BEING SWAPPED IN              */
         L     @12,PCBRASCB(,PCBRPTR)                              0281
         ST    @12,PCBASCB(,PCBPTR)                                0281
*         PCBSWPIN='1'B;            /* SET THE SWAP - IN FLAG        */
*         PCBSWPS1='1'B;            /* SET THE STAGE 1 FLAG          */
*         PCBSWPLS='1'B;            /* SET THE LSQA FLAG             */
         OI    PCBSWPIN(PCBPTR),B'01110000'                        0284
*         PCBVBN=SPCTVBN;           /* PUT VBN FROM ENTRY IN @Z40WPYC*/
         MVC   PCBVBN(2,PCBPTR),SPCTVBN(SWAPPTR)                   0285
*         IF PCBASCB->ASCB1LPU='1'B THEN/* IF LEVEL 1 USER,  @ZA16816*/
         TM    ASCB1LPU(@12),B'01000000'                           0286
         BNO   @RF00286                                            0286
*           PCBPREFR='1'B;          /* BACK WITH PREFERRED FRAME   0287
*                                                            @ZA16816*/
         OI    PCBPREFR(PCBPTR),B'00001000'                        0287
*         AIALSQA='1'B;             /* INDICATE LSQA FOR ASM @Z40WPYC*/
@RF00286 OI    AIALSQA(PCBPTR),B'00001000'                         0288
*         IF SPCTPSET='1'B THEN     /* LSQA TO PAGE DATASET  @Z40WPYC*/
         TM    SPCTPSET(SPCTPTR),B'00001000'                       0289
         BNO   @RF00289                                            0289
*           AIAPAGDS='1'B;          /* YES - TELL ASM        @Z40WPYC*/
         OI    AIAPAGDS(PCBPTR),B'00000100'                        0290
*         ELSE                                                     0291
*           ;                       /* NO - TO NORMAL DATASET      0291
*                                                            @Z40WPYC*/
@RF00289 DS    0H                                                  0292
*         AIALSID=SPCTSSID;         /* SET LSID FOR ASM      @Z40WPYC*/
         SLR   @12,@12                                             0292
         ICM   @12,7,SPCTSSID(SWAPPTR)                             0292
         ST    @12,AIALSID(,PCBPTR)                                0292
*         SWAPPTR=SWAPPTR+LENGTH(SPCTLS);/* POSITION SWAPPTR TO NEXT
*                                      LSQA ENTRY                    */
         AL    SWAPPTR,@CF00925                                    0293
*       END;                        /* END OF UNIQUE LSQA PROCESSING */
*                                                                  0295
*     /***************************************************************/
*     /*                                                             */
*     /* THIS SECTION SETS UP FIELDS IN THE PCB WHICH ARE REQUIRED   */
*     /* FOR EITHER FIXED OR LSQA REQUESTS                           */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0295
*     PCBROOT='1'B;                 /* SET ROOT BIT ON IN PCB        */
@RC00194 OI    PCBROOT(PCBPTR),B'00000100'                         0295
*     PCBRTPA=PCBRPTR;              /* STORE ADDR OF ROOT IN PCB     */
         STCM  PCBRPTR,7,PCBRTPA(PCBPTR)                           0296
*     PCBRCNT=PCBRCNT+1;            /* INCREMENT ROOT COMPLETION CT  */
         LA    @12,1                                               0297
         AH    @12,PCBRCNT(,PCBRPTR)                               0297
         STH   @12,PCBRCNT(,PCBRPTR)                               0297
*     GEN REFS(PCBPTR,PCBFQPA) SETS(PCBPTR);                       0298
        ICM   PCBPTR,@07,PCBFQPA(PCBPTR)  POINT TO NEXT AVAILABLE PCB
*SWINEND:                                                          0299
*     START=START-1;                /* DECREMENT CT OF ENTRIES TO  0299
*                                      PROCESS                       */
SWINEND  BCTR  START,0                                             0299
*   END;                            /* END OF THE BIG DO LOOP        */
@DE00174 LTR   START,START                                         0300
         BNZ   @DL00174                                            0300
*   RFY                                                            0301
*    (START,                                                       0301
*     FINISH) UNRSTD;                                              0301
*                                                                  0301
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN ALL LSQA ENTRIES HAVE BEEN PROCESSED, THE LOOP CONTROLS  */
*   /* ARE RESET AND THE PROCESS REPEATED FOR FIX ENTRIES            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0302
*   IF LSQACOMP='0'B THEN           /* RESTART BIG LOOP FOR          */
         TM    LSQACOMP(PCBRPTR),B'10000000'                       0302
         BNZ   @RF00302                                            0302
*     DO;                           /* FIX ENTRIES                   */
*       LSQACOMP='1'B;              /* TURN ON LSQA COMPLETE BIT     */
         OI    LSQACOMP(PCBRPTR),B'10000000'                       0304
*       GEN REFS(SWAPPTR) SETS(SWAPPTR);                           0305
        LA    SWAPPTR,7(,SWAPPTR)     DOUBLE-WORD BNDRY @Z40WPYC
        SRL   SWAPPTR,3               DIVIDE BY EIGHT   @Z40WPYC
        SLL   SWAPPTR,3               MULTIPLY BY EIGHT @Z40WPYC
*       RFY                                                        0306
*         START RSTD;                                              0306
*       START=SPCTFIX;              /* RESET COUNT TO PROCESS        */
         LH    START,SPCTFIX(,SPCTPTR)                             0307
*       GOTO SWINFIX;               /* RESTART BIG DO LOOP           */
         B     SWINFIX                                             0308
*     END;                                                         0309
*   ELSE                                                           0310
*     ;                                                            0310
@RF00302 DS    0H                                                  0311
*   IF(PVTAFC-PVTDEFFX)<(SPCTLSQA+SPCTFIX-R13)&ASCBNSWP='0'B THEN/*
*                                      IF THE NUMBER OF FRAMES THAT
*                                      ARE AVAILABLE TO THIS SWAPIN
*                                      REQUEST IS LESS THAN THE    0311
*                                      MAXIMUM REQUIRED, I.E., LSQA
*                                      PLUS FIXES NOT ALREADY IN   0311
*                                      STORAGE-AND-THE ADDRESS SPACE
*                                      IS SWAPPABLE-          @ZM0138*/
         LH    @12,PVTAFC(,PVTPTR)                                 0311
         SH    @12,PVTDEFFX(,PVTPTR)                               0311
         LH    @10,SPCTLSQA(,SPCTPTR)                              0311
         AH    @10,SPCTFIX(,SPCTPTR)                               0311
         SLR   @10,R13                                             0311
         CR    @12,@10                                             0311
         BNL   @RF00311                                            0311
         L     @12,PCBRASCB(,PCBRPTR)                              0311
         TM    ASCBNSWP(@12),B'00000001'                           0311
         BNZ   @RF00311                                            0311
*     DO;                                                          0312
*       PCBRPB='1'B;                /* SET THE FREE ROOT FLAG @ZM0138*/
*       PCBRETRY='1'B;              /* SET THE RETRY FLAG IN THE ROOT
*                                                             @ZM0138*/
         OI    PCBRPB(PCBRPTR),B'01100000'                         0314
*       CALL SWAPFIX;               /* BACK-OUT THE COMMON AREA FIXES
*                                                             @ZM0138*/
         BAL   @14,SWAPFIX                                         0315
*       R11=ASCBASID;               /* SAVE THE ASID FOR THE SYEVENT
*                                                             @ZM0138*/
         L     @12,PCBRASCB(,PCBRPTR)                              0316
         LH    R11,ASCBASID(,@12)                                  0316
         N     R11,@CF02051                                        0316
*       CALL SWAPPCB;               /* FREE THE SWIN SRB AND PCBS  0317
*                                                             @ZM0138*/
*                                                                  0317
         BAL   @14,SWAPPCB                                         0317
*       /*************************************************************/
*       /*                                                           */
*       /* AVQLOW SYSEVENT HAS BEEN DELETED                  @ZA25086*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0318
*       R0=R11;                     /* SET ASID FOR SYSEVENT  @ZM0138*/
         LR    R0,R11                                              0318
*       GOTO SWINSYS;               /* ISSUE SWAPIN FAIL SYSEVENT  0319
*                                                             @ZM0138*/
         B     SWINSYS                                             0319
*     END;                          /* AND EXIT               @ZM0138*/
*   ELSE                                                           0321
*     ;                             /* ALLOW THE SWAP-IN TO CONTINUE
*                                      - IT IS POSSIBLE THAT A     0321
*                                      NONSWAPPABLE ADDRESS SPACE IS
*                                      BEING SWAPPED- IN AND GFA WILL
*                                      STEAL IN ORDER TO GET FRAMES
*                                      FOR IT                 @ZM0138*/
*                                                                  0321
@RF00311 DS    0H                                                  0322
*   /*****************************************************************/
*   /*                                                               */
*   /* LSQA/FIX PCB'S WILL BE SEPARATED FROM THE PRIVATE AREA UNFIXED*/
*   /* PCB'S. THE PRIVATE AREA UNFIXED PCB'S WILL BE PASSED TO GFA IN*/
*   /* IEAVSWPP AFTER SWIN ROOT EXIT (IEAVSIRT) PROCESSES THE        */
*   /* LSQA/FIX                                              @Z40WPYC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0322
*   RFY                                                            0322
*    (START,                                                       0322
*     SWAPPTR) UNRSTD;              /* FREE UP REGS 8 AND 11         */
*   IF PCBPTR^=0 THEN               /* THIS END OF CHAIN     @Z40WPYC*/
         SLR   @12,@12                                             0323
         CR    PCBPTR,@12                                          0323
         BE    @RF00323                                            0323
*     DO;                           /* NO - MORE PCB'S EXIST @Z40WPYC*/
*       PCBRWRKA=PCBPTR;            /* START OF PRIVATE AREA PCB'S 0325
*                                                            @Z40WPYC*/
         ST    PCBPTR,PCBRWRKA(,PCBRPTR)                           0325
*       PCBBQPA->PCBFQPA=0;         /* ZERO FORWARD POINTER IN LAST
*                                      LSQA/FIX PCB          @Z40WPYC*/
         L     @08,PCBBQPA(,PCBPTR)                                0326
         STCM  @12,7,PCBFQPA(@08)                                  0326
*       PCBBQPA=0;                  /* ZERO BACK POINTER IN FIRST  0327
*                                      PRIVATE AREA PCB      @Z40WPYC*/
         ST    @12,PCBBQPA(,PCBPTR)                                0327
*     END;                          /* END P.A. UNFIXED PCB        0328
*                                      PROCESSING            @Z40WPYC*/
*   ELSE                                                           0329
*     ;                             /* NO MORE PCB'S EXIST - FALL  0329
*                                      THROUGH SEGMENT ENTRY       0329
*                                      PROCESSING            @Z40WPYC*/
@RF00323 DS    0H                                                  0330
*                                                                  0330
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN ALL FIXED AND LSQA ENTRIES HAVE BEEN PROCESSED, STAGE 2  */
*   /* PCBS ARE SET UP FOR THE REMAINING ACTIVE SEGMENTS. NOTE THAT  */
*   /* PCBPGTA AND PCBXPTA CANNOT BE INITIALIZED IN THIS ROUTINE AS  */
*   /* THE PAGE MAY BE FREEMAIND OR FREEMAIND/GETMAIND BEFORE        */
*   /* IEAVSWPP RUNS IN THE SWAPPED IN ADDRESS SPACE. IN ANY EVENT,  */
*   /* THE ADDRESS OF THE PGTE/XPTE MAY NOT BE THE SAME OR VALID WHEN*/
*   /* IEAVSWPP RECEIVES CONTROL. IEAVSWPP WILL SET PCBPGTA AND      */
*   /* PCBXPTA.                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0330
*SWINSEG:                                                          0330
*   RFY                                                            0330
*    (SEGSPTR,                                                     0330
*     ACTIVE,                                                      0330
*     BITMASK,                                                     0330
*     MASK) RSTD;                   /* RESERVE REGS 10, 8, 12 AND 1  */
SWINSEG  DS    0H                                                  0331
*   SEGSPTR=ADDR(SPCTSEGS);         /* INITIALIZE PTR TO SEGMENT   0331
*                                      ENTRIES                       */
         LA    SEGSPTR,SPCTSEGS(,SPCTPTR)                          0331
*   DO ACTIVE=SPCTSSEG TO 1 BY-1;   /* START STAGE 2 PROCESSING      */
         SLR   ACTIVE,ACTIVE                                       0332
         IC    ACTIVE,SPCTSSEG(,SPCTPTR)                           0332
         B     @DE00332                                            0332
@DL00332 DS    0H                                                  0333
*     BITMASK=SPCTBITM;             /* PUT BIT MASK FROM ENTRY IN REG*/
         LH    BITMASK,SPCTBITM(,SEGSPTR)                          0333
         N     BITMASK,@CF02051                                    0333
*     MASK='7FFF'X;                 /* INITIALIZE BIT MASK           */
         L     MASK,@CF01961                                       0334
*     DO R14=0 TO 15;               /* START OF BIT SCAN LOOP        */
         SLR   R14,R14                                             0335
@DL00335 DS    0H                                                  0336
*       IF BITMASK>MASK THEN        /* IF BIT IS ON, START ACTIVE  0336
*                                      SEGMENT PROCESS               */
         CR    BITMASK,MASK                                        0336
         BNH   @RF00336                                            0336
*         DO;                                                      0337
*           PCBASCB=PCBRASCB;       /* SET THE INPUT ASCB POINTER    */
         L     @11,PCBRASCB(,PCBRPTR)                              0338
         ST    @11,PCBASCB(,PCBPTR)                                0338
*           PCBSWPS2='1'B;          /* SET THE STAGE2 BIT    @Z40WPYC*/
*                                                                  0339
         OI    PCBSWPS2(PCBPTR),B'00000001'                        0339
*           /*********************************************************/
*           /*                                                       */
*           /* CALCULATE THE PAGE VBN BY CONCATENATING THE PAGE INDEX*/
*           /* VALUE (IN R14) AND A ZERO TO THE THE SEGMENT INDEX    */
*           /* STORED IN THE SEGMENT ENTRY.                          */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0340
*           RFY                                                    0340
*             R11 RSTD;                                            0340
*           R11=SPCTSEGX;           /* GET THE SEGMENT INDEX         */
         SLR   R11,R11                                             0341
         IC    R11,SPCTSEGX(,SEGSPTR)                              0341
*           GEN SETS(R11);                                         0342
         SLL   R11,@04                SHIFT SS VALUE OVER 4 BITS
*           R11=R11+R14;            /* ADD THE PAGE INDEX VALUE      */
         ALR   R11,R14                                             0343
*           AIAPRIV='1'B;           /* INDICATE PRIVATE AREA FRAME 0344
*                                                            @Z40WPYC*/
         OI    AIAPRIV(PCBPTR),B'01000000'                         0344
*           GEN SETS(R11);                                         0345
         SLL   R11,@04                ADD FOUR BITS OF ZEROS
*           PCBVBN=R11;             /* STORE THE VBN IN THE PCB      */
         STH   R11,PCBVBN(,PCBPTR)                                 0346
*           RFY                                                    0347
*             R11 UNRSTD;                                          0347
*           GEN REFS(PCBPTR,PCBFQPA) SETS(PCBPTR);                 0348
        ICM   PCBPTR,@07,PCBFQPA(PCBPTR)  POINT TO NEXT PCB
*           BITMASK=BITMASK&MASK;   /* AND OFF THE BIT WHICH WAS JUST
*                                      PROCESSED                     */
         NR    BITMASK,MASK                                        0349
*         END;                      /* END OF ACTIVE SEG PROCESS     */
*/*                                  ALWAYS EXECUTE NEXT INSTRUCTION */
*                                                                  0351
*       ELSE                                                       0351
*         ;                                                        0351
@RF00336 DS    0H                                                  0352
*       GEN SETS(R1);                                              0352
        SRL   MASK,@01                SHIFT MASK FOR NEXT INSTRUCTION
*     END;                          /* END OF BIT SCAN LOOP          */
         AL    R14,@CF00062                                        0353
         C     R14,@CF00052                                        0353
         BNH   @DL00335                                            0353
*     SEGSPTR=SEGSPTR+LENGTH(SPCTSEGE);/* POINT TO NEXT ENTRY        */
         AL    SEGSPTR,@CF00925                                    0354
*   END;                            /* END OF STAGE 2 PROCESSING     */
         BCTR  ACTIVE,0                                            0355
@DE00332 LTR   ACTIVE,ACTIVE                                       0355
         BP    @DL00332                                            0355
*   RFY                                                            0356
*    (SEGSPTR,                                                     0356
*     ACTIVE,                                                      0356
*     BITMASK,                                                     0356
*     MASK) UNRSTD;                 /* FREE REGS 10, 8, 12 AND 1     */
*                                                                  0357
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ANY COMMON AREA FIXED ENTRIES HAVE BEEN FOUND IN REAL      */
*   /* STORAGE, THERE ARE SOME EXTRA PCBS STILL CHAINED IN WHICH     */
*   /* SHOULD BE RETURNED TO THE AVAILABLE PCB QUEUE. THIS SECTION OF*/
*   /* CODE CALLS IEAVPCB TO FREE THE EXTRA PCBS OBTAINED.           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0357
*SWINPCB:                                                          0357
*   IF PCBPTR=0 THEN                /* ARE THERE PCBS TO FREE        */
SWINPCB  SLR   @12,@12                                             0357
         CR    PCBPTR,@12                                          0357
         BE    @RT00357                                            0357
*     GOTO SWINGFA;                 /* NO - SKIP CALL TO PCB MANAGER */
*   ELSE                                                           0359
*     DO;                                                          0359
*       RFY                                                        0360
*        (R0,                                                      0360
*         R1) RSTD;                                                0360
*       IF PCBRWRKA=PCBPTR THEN     /* IF NO P.A. UNFIXED PCB'S    0361
*                                                            @Z40WPYC*/
         C     PCBPTR,PCBRWRKA(,PCBRPTR)                           0361
         BNE   @RF00361                                            0361
*         PCBRWRKA=0;               /* ZERO P.A. UNFIXED PCB PTR   0362
*                                                            @Z40WPYC*/
         ST    @12,PCBRWRKA(,PCBRPTR)                              0362
*       ELSE                        /* RETAIN PTR TO P.A. PCBS     0363
*                                                            @Z40WPYC*/
*         PCBBQPA->PCBFQPA=0;       /* ZERO FORWARD POINTER IN     0363
*                                      PREVIOUS PCB.NOTE THAT IF P.A.
*                                      UNFIXED PCBS EXIST, PCBBQPA 0363
*                                      HAS PREVIOUSLY BEEN CLEARED.
*                                                            @Z40WPYC*/
         B     @RC00361                                            0363
@RF00361 L     @12,PCBBQPA(,PCBPTR)                                0363
         SLR   @08,@08                                             0363
         STCM  @08,7,PCBFQPA(@12)                                  0363
*       R1=PCBPTR;                  /* SAVE POINTER TO THE 1ST PCB 0364
*                                      WHICH WILL BE FREED           */
@RC00361 LR    R1,PCBPTR                                           0364
*       R0=PCBFREQN;                /* SET TQN FOR AVAILABLE QUEUE   */
         LA    R0,16                                               0365
*       CALL PCBMGR;                /* CALL PCB MANAGER TO ENQ EXTRAS*/
         L     @15,PVTPCB(,PVTPTR)                                 0366
         BALR  @14,@15                                             0366
*     END;                                                         0367
*                                                                  0368
*   /*****************************************************************/
*   /*                                                               */
*   /* ALL THE PCB INITIALIZATION IS NOT COMPLETE. PASS THE CHAIN OF */
*   /* LSQA AND FIXED PCBS TO GFA TO HAVE THE FRAMES ASSIGNED AND I/O*/
*   /* INITIATED                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0368
*SWINGFA:                                                          0368
*   RFY                                                            0368
*     R11 RSTD;                                                    0368
SWINGFA  DS    0H                                                  0369
*   R1=PCBRWRK1;                    /* SET REG 1 TO START OF CHAIN   */
         L     R1,PCBRWRK1(,PCBRPTR)                               0369
*   PCBRWRK1=0;                     /* CLEAR THE FIELD USED          */
         SLR   @12,@12                                             0370
         ST    @12,PCBRWRK1(,PCBRPTR)                              0370
*   R11=ASCBASID;                   /* SAVE ASID FOR POSSIBLE      0371
*                                      SYSEVENT                      */
         L     @12,PCBRASCB(,PCBRPTR)                              0371
         LH    R11,ASCBASID(,@12)                                  0371
         N     R11,@CF02051                                        0371
*   CALL GFA;                       /* CALL GENERAL FRAME ALLOCATION */
         L     @15,PVTPGFA(,PVTPTR)                                0372
         BALR  @14,@15                                             0372
*   RCACSECT=RCACSPIN;              /* RESET THE MODULE ID ON RETURN */
         L     @12,PVTPRCA(,PVTPTR)                                0373
         MVI   RCACSECT(@12),X'19'                                 0373
*   IF R15=8 THEN                   /* IF FRAMES WERE UNAVAILABLE    */
         C     R15,@CF00055                                        0374
         BNE   @RF00374                                            0374
*     DO;                           /* NOTIFY THE SRM TO RETRY THE 0375
*                                      SWAP-IN LATER                 */
*       SPCTSWIN='0'B;              /* TURN OFF THE SWAP-IN FLAG     */
         NI    SPCTSWIN(SPCTPTR),B'01111111'                       0376
*       R0=R11;                     /* PUT ASID IN REG 0             */
         LR    R0,R11                                              0377
*       GOTO SWINSYS;               /* GO ISSUE SYSEVENT AND EXIT    */
         B     SWINSYS                                             0378
*     END;                                                         0379
*   PVTSPIN=PVTSPIN+((SPCTFIX+SPCTLSQA)-R13);/* ADD NUMBER OF FRAMES
*                                      TO BE SWAPPED IN AS STAGE1  0380
*                                      PAGES, MINUS THE NUMBER OF  0380
*                                      IN-CORE COMMON AREA FIXES NOT
*                                      REQUIRING I/O, TO THE CURRENT
*                                      SWAPIN COUNT. NOTE THAT     0380
*                                      IEAVGFA WILL UPDATE PVTSPIN 0380
*                                      FOR THE STAGE2 PAGES. @Z40WPYC*/
@RF00374 LH    @12,SPCTFIX(,SPCTPTR)                               0380
         AH    @12,SPCTLSQA(,SPCTPTR)                              0380
         SLR   @12,R13                                             0380
         AL    @12,PVTSPIN(,PVTPTR)                                0380
         ST    @12,PVTSPIN(,PVTPTR)                                0380
*   PVTNSWPS=PVTNSWPS+1;            /* INCREMENT SWAP SEQUENCE COUNT */
         LA    @12,1                                               0381
         AL    @12,PVTNSWPS(,PVTPTR)                               0381
         ST    @12,PVTNSWPS(,PVTPTR)                               0381
*   RFY                                                            0382
*    (R1,                                                          0382
*     R11) UNRSTD;                                                 0382
*                                                                  0383
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SALLOC IS RELEASED BY THIS SECTION OF CODE.               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0383
*SWINLOCK:                                                         0383
*   RFY                                                            0383
*     R11 RSTD;                                                    0383
SWINLOCK DS    0H                                                  0384
*   RFY                                                            0384
*     R12 RSTD;                                                    0384
*FREELOCK:                          /* ISSUE SETLOCK                 */
*   GEN CODE REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);              0385
*                                                                  0385
FREELOCK DS    0H                                                  0385
         SETLOCK RELEASE,TYPE=SALLOC,RELATED=(RSM,IEAVSWIN(GETLOCK))
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS THE FINAL EXIT FROM THE ROUTINE. THE FRR ROUTINE IS   */
*   /* DELETED FROM THE STACK AND REGISTER 14 IS SET TO THE SRB EXIT */
*   /* ADDRESS IN THE CVT. RETURN IS MADE TO THE DISPATCHER.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0386
*SWINEXIT:                                                         0386
*   GEN REFS(PSACSTK,FRRSEMP,FRRSELEN) SETS(R11,R12,FRRSCURR);     0386
SWINEXIT DS    0H                                                  0386
         SETFRR D,WRKREGS=(R11,R12)
*   R14=CVTSRBRT;                   /* RESTORE R14                   */
         L     @10,CVTPTR                                          0387
         L     R14,CVTSRBRT(,@10)                                  0387
*   GOTO R14;                       /* RETURN TO DISPATCHER          */
         BR    R14                                                 0388
*   RFY                                                            0389
*    (R11,                                                         0389
*     R12,                                                         0389
*     R14) UNRSTD;                                                 0389
*                                                                  0390
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SECTION ISSUES A SYSEVENT TO THE SRM WHEN THE SWAP-IN IS */
*   /* UNABLE TO BE PERFORMED AT THIS TIME. REGISTER ZERO MUST       */
*   /* CONTAIN THE ASID BEFORE COMING HERE.                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0390
*SWINSYS:                                                          0390
*   RFY                                                            0390
*    (R11,                                                         0390
*     R12,                                                         0390
*     R13) RSTD;                                                   0390
SWINSYS  DS    0H                                                  0391
*FREELOC:                           /* RELEASE SALLOC, OBTAIN LOCAL
*                                      LOCK                          */
*   GEN CODE DEFS(SWINGET) REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);
FREELOC  DS    0H                                                  0391
         SETLOCK RELEASE,TYPE=SALLOC,RELATED=(RSM,IEAVSWIN(GETLOCK))
SWINGET  SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                       **
               RELATED=(SYSEVENT,IEAVSWIN(SWINFREE))
*   RFY                                                            0392
*     ASCB BASED(PSAAOLD);                                         0392
*   R13=WSALRSM;                    /* PASS SAVE AREA FOR SYSEVENT   */
*                                                                  0393
         L     @14,PSAAOLD                                         0393
         L     @01,ASXBPTR(,@14)                                   0393
         L     @01,ASXBSPSA(,@01)                                  0393
         L     R13,WSALRSM(,@01)                                   0393
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE SYSEVENT AND RELEASE LOCAL LOCK                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0394
*   GEN CODE REFS(CVTPTR,CVTOPTE,CVT,PSALITA,FLC) DEFS(SWINFREE) SETS(
*       R0,R11,R12,R13,R14,R15);                                   0394
         SYSEVENT SWINFL,ASID=(0),ENTRY=BRANCH
SWINFREE SETLOCK RELEASE,TYPE=LOCAL,                                  **
               RELATED=(SYSEVENT,IEAVSWIN(SWINGET))
*   GOTO SWINEXIT;                  /* GO TO THE EXIT ROUTINE        */
         B     SWINEXIT                                            0395
*   RFY                                                            0396
*    (R11,                                                         0396
*     R12,                                                         0396
*     R13) UNRSTD;                                                 0396
*                                                                  0397
*   /*****************************************************************/
*   /*                                                               */
*   /* SWAP IN ROOT EXIT ROUTINE                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0397
*IEAVSIRT:                                                         0397
*   GEN REFS(R15,PVTPTR) SETS(PVTWSA7,R9,R15);                     0397
*                                                                  0397
IEAVSIRT DS    0H                                                  0397
         STM   R0,R15,PVTWSA7(PVTPTR) SAVE REGISTERS IN PVT
         LA    R15,ROOTEXIT-@PSTART   GET OFFSET FROM MODULE START
         BALR  R9,@00                 ESTABLISH ADRRESSABILITY
ROOTEXIT SR    R9,R15                 ADJUST BY PROPER OFFSET
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE BASIC CONTROL BLOCK POINTERS AND SET RECOVERY      */
*   /* FOOTPRINT.                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0398
*   RFY                                                            0398
*     ASCB BASED(PCBRASCB);                                        0398
*   PCBRPTR=R1;                     /* ESTABLISH ROOT PCB POINTER  0399
*                                      PASSED AS INPUT               */
         LR    PCBRPTR,R1                                          0399
*   RCACSECT=RCACSPIN;              /* SET MODULE ID FOR IEAVSWIN    */
         L     @14,PVTPRCA(,PVTPTR)                                0400
         MVI   RCACSECT(@14),X'19'                                 0400
*   RCASIRT='1'B;                   /* SET ENTRY POINT FLAG IN THE 0401
*                                      RCA                           */
         OI    RCASIRT(@14),B'00100000'                            0401
*   FRRASCB=0;                      /* ZERO H.O. TWO BYTES OF ASID 0402
*                                      FIELD                         */
         SLR   @14,@14                                             0402
         STH   @14,FRRASCB(,PVTPTR)                                0402
*   FRRASID=ASCBASID;               /* SAVE ASID FOR FRR ROUTINE     */
         L     @14,PCBRASCB(,PCBRPTR)                              0403
         MVC   FRRASID(2,PVTPTR),ASCBASID(@14)                     0403
*   RSMHDPTR=ASCBRSM;               /* SET RSM HEADER PTR FROM ASCB  */
         L     RSMHDPTR,ASCBRSM(,@14)                              0404
*   FRRRSMHD=RSMHDPTR;              /* RSMHD ADDR FOR FRR. FRR WILL
*                                      SET RSMFAIL FLAG IF SWIN ROOT
*                                      PC'S                  @Z40WPYC*/
         ST    RSMHDPTR,FRRRSMHD(,PVTPTR)                          0405
*   SPCTPTR=RSMSPCT;                /* SET SPCT POINTER FROM RSM   0406
*                                      HEADER                        */
*                                                                  0406
         L     SPCTPTR,RSMSPCT(,RSMHDPTR)                          0406
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE ROOT FREE FLAG HAS BEEN SET AND LSQA IS UNAVAILABLE    */
*   /* THEN GO TO ERROR PROCESSING. ALSO IF GFA HAS INDICATED THAT   */
*   /* THE SWAPIN SHOULD BE RETRIED, GO TO ERROR PROCESSING TO BACK  */
*   /* OUT COMMON AREA FIXES.                                @Z40WPYC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0407
*   IF((PCBRPB='1'B)&RSMFAIL='1'B)|PCBRETRY='1'B THEN/* IF AN ERROR
*                                      HAS BEEN INDICATED, GO TO   0407
*                                      ERROR PROCESSOR.      @Z40WPYC*/
         TM    PCBRPB(PCBRPTR),B'00100000'                         0407
         BNO   @GL00003                                            0407
         TM    RSMFAIL(RSMHDPTR),B'00000010'                       0407
         BO    @RT00407                                            0407
@GL00003 TM    PCBRETRY(PCBRPTR),B'01000000'                       0407
         BO    @RT00407                                            0407
*     GOTO SIRTERR0;                /* GO TO THE ERROR ROUTINE       */
*   IF SPCTBIG='1'B THEN            /* IF THERE ARE SOME BIG FIX   0409
*                                      COUNTS, I.E. OVER 255, IN THE
*                                      SPCT ENTRIES                  */
         TM    SPCTBIG(SPCTPTR),B'00010000'                        0409
         BNO   @RF00409                                            0409
*     DO;                                                          0410
*       IF PCBRFAIL='1'B THEN       /* IF IEAVPIOP HAS INDICATED AN
*                                      ERROR OCCURRED TO A FIX'D   0411
*                                      PAGE, BYPASS BIG FIX        0411
*                                      PROCESSING. FOR FIX'D PAGE  0411
*                                      SWAPIN ERRORS, THE SEGMENT AND
*                                      PAGE TABLES WILL BE VALIDATED
*                                      FOR THE ADDRESS SPACE, (ONLY
*                                      IF THE LSQA I/O WAS         0411
*                                      SUCCESSFUL, RSMFAIL = 0).   0411
*                                      AFTER THE SEGMENT AND PAGE  0411
*                                      TABLES ARE RECONSTRUCTED, THE
*                                      MEMORY WILL BE TERMINATED.  0411
*                                      THIS PROCESSING WILL ENSURE 0411
*                                      THAT AS MANY AUXILIARY SLOTS
*                                      AS POSSIBLE WILL BE FREED   0411
*                                                            @Z40WPYC*/
         TM    PCBRFAIL(PCBRPTR),B'00001000'                       0411
         BO    @RT00411                                            0411
*         GO TO REBUILD;            /* SKIP BIG FIX PROCESSING IF AN
*                                      ERROR OCCURRED        @Z40WPYC*/
*       CALL SWAPFIX;               /* THEN CALL SUBROUTINE TO UPDATE
*                                      THE PFTE FIX COUNTS. IF     0413
*                                      PCBRFAIL IS SET BY SWAPFIX THE
*                                      MEMORY WILL BE TERMINATED   0413
*                                      AFTER THE ADDRESS SPACE IS  0413
*                                      RECONSTRUCTED.                */
         BAL   @14,SWAPFIX                                         0413
*     END;                                                         0414
*                                                                  0415
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING ROUTINE WILL LOCATE THE PCB WHICH DEFINES THE   */
*   /* FIRST PAGE OF LSQA FOR THE ADDRESS SPACE BEING SWAPPED IN.    */
*   /* THIS PAGE CONTAINS THE SEGMENT TABLE FOR THE MEMORY. IT IS    */
*   /* ASSUMED THAT THE FIRST SEGMENT TABLE ENTRY IN THE SPCT WILL   */
*   /* CONTAIN THE VIRTUAL PAGE TABLE ADDRESS FOR THIS PAGE.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0415
*REBUILD:                           /*                       @Z40WPYC*/
*   RFY                                                            0415
*    (R8,                                                          0415
*     R12,                                                         0415
*     SEGSPTR) RSTD;                                               0415
@RF00409 DS    0H                                                  0415
REBUILD  DS    0H                                                  0416
*   PCBPTR=PCBRWRK1;                /* GET 1ST PCB POINTER FROM ROOT */
         L     PCBPTR,PCBRWRK1(,PCBRPTR)                           0416
*   SEGSPTR=ADDR(SPCTSEGS);         /* GET THE ADDRESS OF 1ST SEGMENT
*                                      TABLE ENTRY                   */
         LA    SEGSPTR,SPCTSEGS(,SPCTPTR)                          0417
*   R12=SPCTPGT;                    /* PUT VSA OF PAGE TABLE FROM SEG
*                                      ENTRY IN REG 12               */
         SLR   R12,R12                                             0418
         ICM   R12,7,SPCTPGT(SEGSPTR)                              0418
*   GEN REFS(R12) SETS(R12);                                       0419
        SRL   R12,12                LEAVE ONLY VBN PORTION OF PGT ADDR
*   DO WHILE PCBPTR^=0;             /* PERFORM THIS LOOP UNTIL A   0420
*                                      MATCH IS FOUND BETWEEN THE  0420
*                                      VBNS IN THE SEGMENT ENTRY AND
*                                      A PCB, OR UNTIL THERE ARE NO
*                                      MORE PCBS WHICH IS AN ERROR 0420
*                                      CONDITION.                    */
         B     @DE00420                                            0420
@DL00420 DS    0H                                                  0421
*     R8=PCBVBN;                    /* PUT VBN FROM PCB IN REG 8     */
         LH    R8,PCBVBN(,PCBPTR)                                  0421
         N     R8,@CF02051                                         0421
*     GEN REFS(R8) SETS(R8);                                       0422
        SRL   R8,4                  SHIFT OUT L.O. 4 BITS OF PCBVBN
*     IF R8=R12 THEN                /* DETERMINE IF THE SSP VALUES 0423
*                                      ARE EQUAL                     */
         CR    R8,R12                                              0423
         BNE   @RF00423                                            0423
*       DO;                         /* CREATE THE REAL ADDRESS OF THE
*                                      SEGMENT TABLE BY CONCATENATING
*                                      THE L.O. 12 BITS OF THE SGT 0424
*                                      VIRTUAL ADDRESS IN THE RSM  0424
*                                      HEADER TO THE RBN CONTAINED IN
*                                      THE PCB.                      */
*         R8=PCBRBN*256;            /* PUT THE RSA VALUE IN REG 8    */
         LH    R8,PCBRBN(,PCBPTR)                                  0425
         N     R8,@CF02051                                         0425
         SLA   R8,8                                                0425
*         R12=RSMVSTO;              /* PUT THE VIRTUAL ADDR OF THE 0426
*                                      SEGMENT TABLE IN R12          */
         L     R12,RSMVSTO(,RSMHDPTR)                              0426
*         GEN REFS(R12) SETS(R12);                                 0427
        SLL   R12,20                LEAVE ONLY THE NNN PORTION OF
        SRL   R12,20                THE SEG TABLE VSA IN REG 12
*         RFY                                                      0428
*           STEPTR RSTD;                                           0428
*         STEPTR=R8|R12;            /* OR THE TWO VALUES TOGETHER    */
         LR    STEPTR,R8                                           0429
         OR    STEPTR,R12                                          0429
*         ASCBSTO=STEPTR;           /* STORE THE REAL SEGMENT TABLE
*                                      ADDRESS IN THE ASCB (24 BITS) */
         L     @01,PCBRASCB(,PCBRPTR)                              0430
         STCM  STEPTR,7,ASCBSTO(@01)                               0430
*         GOTO SIRTPCB1;            /* EXIT FROM THIS LOOP           */
         B     SIRTPCB1                                            0431
*       END;                                                       0432
*     ELSE                          /* IF THE VBNS DO NOT MATCH, GET
*                                      NEXT PCB AND CONTINUE SCAN    */
*       GEN REFS(PCBPTR,PCBFQPA) SETS(PCBPTR);                     0433
@RF00423 DS    0H                                                  0433
        ICM   PCBPTR,@07,PCBFQPA(PCBPTR)  GET FORWARD PCB POINTER
*   END;                            /* END OF SEARCH FOR LSQA PAGE   */
@DE00420 LTR   PCBPTR,PCBPTR                                       0434
         BNZ   @DL00420                                            0434
*   RFY                                                            0435
*    (R8,                                                          0435
*     R12,                                                         0435
*     STEPTR) UNRSTD;                                              0435
*   GOTO SIRTERR;                   /* IF ALL PCBS HAVE BEEN EXAMINED
*                                      AND A MATCH NOT FOUND, GO   0436
*                                      RECORD THE ERROR AND SET THE
*                                      ROOT FAIL FLAG TO TERMINATE 0436
*                                      THE MEMORY                    */
*                                                                  0436
         B     SIRTERR                                             0436
*   /*****************************************************************/
*   /*                                                               */
*   /* THE NEXT PROCESS WILL UPDATE THE SEGMENT TABLE (IN            */
*   /* NON-TRANSLATE MODE) WITH THE REAL ADDRESSES OF THE PAGE       */
*   /* TABLES.                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0437
*SIRTPCB1:                                                         0437
*   R15=SPCTSSEG;                   /* GET THE COUNT OF SEGMENT    0437
*                                      ENTRIES TO PROCESS.   @ZA10769*/
SIRTPCB1 SLR   R15,R15                                             0437
         IC    R15,SPCTSSEG(,SPCTPTR)                              0437
*   SEGSPTR=ADDR(SPCTSEGS);         /* GET ADDRESS OF FIRST SEGMENT
*                                      ENTRY                 @ZA10769*/
         LA    SEGSPTR,SPCTSEGS(,SPCTPTR)                          0438
*   RFY                                                            0439
*    (R0,                                                          0439
*     R13) RSTD;                    /*                       @ZA10769*/
*   R0=PVTLCSA/16;                  /* GET SSP OF LOWEST COMMON AREA
*                                      PAGE                  @ZA10769*/
         LH    R0,PVTLCSA(,PVTPTR)                                 0440
         N     R0,@CF02051                                         0440
         SRL   R0,4                                                0440
*   DO R13=R15 TO 1 BY-1;           /* DECREMENT THE NUMBER OF     0441
*                                      SEGMENT ENTRIES TO PROCESS BY
*                                      1 FOR EVERY SEGMENT WHOSE PAGE
*                                      TABLES WERE BUILT IN SQA.   0441
*                                                            @ZA10769*/
         LR    R13,R15                                             0441
         B     @DE00441                                            0441
@DL00441 DS    0H                                                  0442
*     IF SPCTPGT/4096>=R0 THEN      /* PAGE TABLES IN SQA?   @ZA10769*/
         SLR   @14,@14                                             0442
         ICM   @14,7,SPCTPGT(SEGSPTR)                              0442
         SRL   @14,12                                              0442
         CR    @14,R0                                              0442
         BL    @RF00442                                            0442
*       R15=R15-1;                  /* YES. DECREMENT COUNT OF     0443
*                                      ENTRIES TO PROCESS.   @ZA10769*/
         BCTR  R15,0                                               0443
*     SEGSPTR=SEGSPTR+LENGTH(SPCTSEGE);/* POINT TO NEXT SEGMENT ENTRY
*                                                            @ZA10769*/
@RF00442 AL    SEGSPTR,@CF00925                                    0444
*   END;                            /* ON EXIT FROM LOOP, R15      0445
*                                      CONTAINS THE NUMBER OF SEGMENT
*                                      ENTRIES FOR WHOSE SEGMENTS  0445
*                                      PAGE TABLES WERE BUILT IN   0445
*                                      LSQA.                 @ZA10769*/
         BCTR  R13,0                                               0445
@DE00441 LTR   R13,R13                                             0445
         BP    @DL00441                                            0445
*   PCBPTR=PCBRWRK1;                /* START SCAN AT TOP OF PCB Q    */
         L     PCBPTR,PCBRWRK1(,PCBRPTR)                           0446
*   DO WHILE PCBPTR^=0;             /* DO THIS LOOP FOR ALL PCBS     */
         B     @DE00447                                            0447
@DL00447 DS    0H                                                  0448
*     IF PCBSWPLS='0'B THEN         /* SINCE THE PAGE TABLES CAN     */
         TM    PCBSWPLS(PCBPTR),B'00010000'                        0448
         BZ    @RT00448                                            0448
*       GOTO SIRTPCBF;              /* ONLY BE IN LSQA PAGES, DO NOT
*                                      LOOK AT NON-LSQA PCBS HERE.   */
*     RFY                                                          0450
*      (R8,                                                        0450
*       R12) RSTD;                  /*                       @ZA10769*/
*     R8=PCBVBN;                    /* PUT VBN FROM PCB IN REG 8     */
         LH    R8,PCBVBN(,PCBPTR)                                  0451
         N     R8,@CF02051                                         0451
*     GEN REFS(R8) SETS(R8);                                       0452
         SRL   R8,4                   SHIFT OUT L.O. 4 BITS OF PCBVBN
*                                                                  0453
*     /***************************************************************/
*     /*                                                             */
*     /* EXAMINE ALL SEGMENT ENTRIES FOR A MATCH TO THE VBN IN THE   */
*     /* PCB CURRENTLY BEING ADDRESSED                               */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0453
*     SEGSPTR=ADDR(SPCTSEGS);       /* GET ADDRESS OF FIRST SEGMENT
*                                      ENTRY                 @ZA10769*/
         LA    SEGSPTR,SPCTSEGS(,SPCTPTR)                          0453
*     DO R13=SPCTSSEG TO 1 BY-1;                                   0454
         SLR   R13,R13                                             0454
         IC    R13,SPCTSSEG(,SPCTPTR)                              0454
         B     @DE00454                                            0454
@DL00454 DS    0H                                                  0455
*       R12=SPCTPGT;                /* PUT VSA OF PAGE TABLE FROM SEG
*                                      ENTRY IN REG 12               */
         SLR   R12,R12                                             0455
         ICM   R12,7,SPCTPGT(SEGSPTR)                              0455
*       GEN REFS(R12) SETS(R12);                                   0456
         SRL   R12,12               LEAVE ONLY VBN PORTION OF PGT ADDR
*       IF R12<R0 THEN              /* PAGE TABLES IN SQA?   @ZA10769*/
         CR    R12,R0                                              0457
         BNL   @RF00457                                            0457
*         IF R8=R12 THEN            /* WHEN THE VBNS MATCH,          */
         CR    R8,R12                                              0458
         BNE   @RF00458                                            0458
*           DO;                     /* UPDATE THE SEGMENT TABLE.     */
*             RFY                                                  0460
*              (R1,                                                0460
*               STEPTR) RSTD;                                      0460
*             STEPTR=ASCBSTO+(SPCTSEGX*4);/* GET REAL ADDR OF SGTE   */
         L     @14,PCBRASCB(,PCBRPTR)                              0461
         SLR   STEPTR,STEPTR                                       0461
         IC    STEPTR,SPCTSEGX(,SEGSPTR)                           0461
         SLA   STEPTR,2                                            0461
         L     @14,ASCBSTO-1(,@14)                                 0461
         LA    @14,0(,@14)                                         0461
         ALR   STEPTR,@14                                          0461
*             R1=ADDR(PCBRWRK5);    /* GET ADDR OF WORK WORD FOR   0462
*                                      STOSM                         */
         LA    R1,PCBRWRK5(,PCBRPTR)                               0462
*             RFY                                                  0463
*               R14 RSTD;                                          0463
*             R14=PCBRBN*256;       /* PUT THE RSA VALUE IN R14      */
         LH    R14,PCBRBN(,PCBPTR)                                 0464
         N     R14,@CF02051                                        0464
         SLA   R14,8                                               0464
*             R12=SPCTPGT;          /* PUT THE VSA OF THE PAGE TABLE
*                                      FROM THE SEGMENT ENTRY IN REG
*                                      12                            */
         SLR   R12,R12                                             0465
         ICM   R12,7,SPCTPGT(SEGSPTR)                              0465
*             GEN REFS(R12) SETS(R12);                             0466
        SLL   R12,20                LEAVE ONLY THE NNN PORTION OF
        SRL   R12,20                THE PAGE TABLE VSA IN REG 12
*             R14=R14|R12;          /* OR THE TWO VALUES TOGETHER TO
*                                      GET THE REAL PAGE TABLE     0467
*                                      ADDRESS                       */
         OR    R14,R12                                             0467
*             RFY                                                  0468
*               R12 UNRSTD;                                        0468
*             GEN REFS(R1,PCBRWRK5,R14,STEPTR) SETS(R1,PCBRWRK5,SGTPTO)
*                 ;                                                0469
        LRA   R1,0(,R1)                LOAD REAL ADDR OF WORK WORD
        STNSM PCBRWRK5(PCBRPTR),X'FB'  ZERO THE TRANSLATE BIT
        STCM  R14,@07,SGTPTO(STEPTR)   STORE REAL PAGE TABLE ADDRESS
        STOSM 0(R1),X'04'              TURN DAT BIT BACK ON
*             R15=R15-1;            /* DECREMENT COUNT OF ENTRIES TO
*                                      PROCESS                       */
         BCTR  R15,0                                               0470
*           END;                                                   0471
*       RFY                                                        0472
*        (R1,                                                      0472
*         STEPTR,                                                  0472
*         R14) UNRSTD;                                             0472
@RF00458 DS    0H                                                  0472
@RF00457 DS    0H                                                  0473
*                                                                  0473
*/*   DETERMINE IF ALL SEGMENT ENTRIES HAVE BEEN CHECKED             */
*                                                                  0473
*       IF R15^=0 THEN              /* IF NOT,                       */
         LTR   R15,R15                                             0473
         BZ    @RF00473                                            0473
*         SEGSPTR=SEGSPTR+LENGTH(SPCTSEGE);/* POINT TO NEXT SEGMENT
*                                      ENTRY                         */
         AL    SEGSPTR,@CF00925                                    0474
*       ELSE                        /* IF ALL HAVE BEEN DONE,        */
*         GOTO SIRTPCB2;            /* GO UPDATE THE PAGE TABLE    0475
*                                      ENTRIES                       */
*     END;                          /* END OF SEGMENT ENTRY LOOP FOR
*                                      EACH PCB                      */
         BCTR  R13,0                                               0476
@DE00454 LTR   R13,R13                                             0476
         BP    @DL00454                                            0476
*     RFY                                                          0477
*      (R8,                                                        0477
*       R13) UNRSTD;                                               0477
*                                                                  0477
*     /***************************************************************/
*     /*                                                             */
*     /* EACH TIME A NEW PCB IS ADDRESSED, THE SEGMENT ENTRY LOOP IS */
*     /* RESTARTED WITH THE FIRST ENTRY IN THE SPCT                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0478
*SIRTPCBF:                                                         0478
*     GEN REFS(PCBPTR,PCBFQPA) SETS(PCBPTR);                       0478
SIRTPCBF DS    0H                                                  0478
        ICM   PCBPTR,@07,PCBFQPA(PCBPTR)  POINT TO NEXT PCB ON CHAIN
*     SEGSPTR=ADDR(SPCTSEGS);       /* POINT TO 1ST SEGMENT ENTRY    */
         LA    SEGSPTR,SPCTSEGS(,SPCTPTR)                          0479
*   END;                            /* END OF LOOP FOLLOWING PCB   0480
*                                      CHAIN. WILL FALL OUT HERE IF
*                                      PCBPTR HAS GONE TO ZERO.      */
@DE00447 SLR   @14,@14                                             0480
         CR    PCBPTR,@14                                          0480
         BNE   @DL00447                                            0480
*   RFY                                                            0481
*    (R0) UNRSTD;                   /*                       @ZA10769*/
*   IF R15^=0 THEN                  /* IF ALL PCBS HAVE BEEN CHECKED
*                                      BUT NOT ALL SEGMENT ENTRIES 0482
*                                      HAVE BEEN PROCESSED, AN ERROR
*                                      HAS OCCURRED                  */
         CR    R15,@14                                             0482
         BNE   @RT00482                                            0482
*     GOTO SIRTERR;                 /* TERMINATE THE MEMORY AND EXIT */
*   RFY                                                            0484
*     SEGSPTR UNRSTD;               /* FREE REG 10                   */
*                                                                  0485
*   /*****************************************************************/
*   /*                                                               */
*   /* UPDATE THE PAGE TABLES (IN NON-TRANSLATE MODE) WITH THE RBN   */
*   /* VALUES FROM THE PCBS. SET THE STORAGE AND FETCH PROTECT KEYS. */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0485
*SIRTPCB2:                                                         0485
*   PCBPTR=PCBRWRK1;                /* START WITH 1ST PCB ON CHAIN   */
SIRTPCB2 L     PCBPTR,PCBRWRK1(,PCBRPTR)                           0485
*   DO WHILE PCBPTR^=0;             /* PERFORM LOOP FOR ALL PCBS     */
         B     @DE00486                                            0486
@DL00486 DS    0H                                                  0487
*     RFY                                                          0487
*      (R8,                                                        0487
*       R12) RSTD;                                                 0487
*     R8=VBN;                       /* PUT PAGE NUMBER FROM PCBVBN IN
*                                      REG 8                         */
         SLR   R8,R8                                               0488
         IC    R8,VBN(,PCBPTR)                                     0488
*     GEN REFS(R8) SETS(R8);                                       0489
        SRL   R8,3                   LEAVE (2 X P) IN REG 8
*     R12=(5*R8);                   /* CALCULATE AN OFFSET WHICH WHEN
*                                      ADDED TO A PGTE ADDRESS PLUS
*                                      32 WILL GIVE THE XPTE ADDRESS */
         LR    R12,R8                                              0490
         MH    R12,@CH00224                                        0490
*     RFY                                                          0491
*       STEPTR RSTD;                                               0491
*     STEPTR=ASCBSTO+(4*PCBSS);     /* GET THE REAL ADDRESS OF THE 0492
*                                      SEGMENT TABLE ENTRY           */
         L     @14,PCBRASCB(,PCBRPTR)                              0492
         SLR   STEPTR,STEPTR                                       0492
         IC    STEPTR,PCBSS(,PCBPTR)                               0492
         SLA   STEPTR,2                                            0492
         L     @14,ASCBSTO-1(,@14)                                 0492
         LA    @14,0(,@14)                                         0492
         ALR   STEPTR,@14                                          0492
*     RFY                                                          0493
*       R1 RSTD;                                                   0493
*     R1=ADDR(PCBRWRK5);            /* SET UP TO GET REAL ADDRESS OF
*                                      THE WORK WORD                 */
         LA    R1,PCBRWRK5(,PCBRPTR)                               0494
*     R15=PCBRBN;                   /* GET RBN FOR THE PAGE          */
         LH    R15,PCBRBN(,PCBPTR)                                 0495
         N     R15,@CF02051                                        0495
*     IF PCBDFRLS='0'B THEN         /* IF NOT DEFERRED RELEASE,      */
         TM    PCBDFRLS(PCBPTR),B'00001000'                        0496
         BNZ   @RF00496                                            0496
*       R15=R15+1;                  /* TURN ON ASSIGNED BIT          */
         AL    R15,@CF00062                                        0497
*     ELSE                          /* OTHERWISE,                    */
*       DO;                         /* TURN ON DFRLS IN PFTE TOO     */
         B     @RC00496                                            0498
@RF00496 DS    0H                                                  0499
*         RFY                                                      0499
*           PFTEPTR RSTD;                                          0499
*         PFTEPTR=PVTPFTP+R15;      /* GET ADDR OF PFTE              */
         LR    PFTEPTR,R15                                         0500
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0500
*         PFTDFRLS='1'B;            /* TURN ON DFRLS BIT             */
         OI    PFTDFRLS(PFTEPTR),B'10000000'                       0501
*       END;                                                       0502
*     RFY                                                          0503
*       PFTEPTR UNRSTD;                                            0503
@RC00496 DS    0H                                                  0504
*     RFY                                                          0504
*      (PTEPTR,                                                    0504
*       R13) RSTD;                  /*                       @Z40WPYC*/
*                                                                  0505
*     /***************************************************************/
*     /*                                                             */
*     /* DROP OUT OF TRANSLATE MODE TO DO THE STORE INTO THE PGTES   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0505
*     GEN REFS(R1,PCBRWRK5,R15,XPTPROT,R8,PCBRPTR,STEPTR,SGTPTO,R12,
*         PCBPTR,PCBFQPA) SETS(R1,PCBRWRK5,PTEPTR,R15,PGTPAM,PGTRSA,R8,
*         PCBPTR,R13,XPTEPTR,XPTFLAGS,XPTLPN);                     0505
        LRA   R13,0(,PCBPTR)           LOAD REAL ADDR OF PCB @Z40WPYC
        LRA   R1,0(,R1)                LOAD REAL ADDR OF WORK WORD
        STNSM PCBRWRK5(PCBRPTR),X'FB'  ZERO THE TRANSLATE BIT
        ICM   PTEPTR,@07,SGTPTO(STEPTR) GET REAL ADDRESS OF PAGE TABLE
        AR    PTEPTR,R8                ADD (2 X P) TO GET PGTE ADDRESS
        STH   R15,PGTRSA(,PTEPTR)      STORE THE RBN IN THE ENTRY
        LA    XPTEPTR,32(R12,PTEPTR)   GET ADDRESS OF XPTE
        IC    R8,XPTPROT(,XPTEPTR)     PICK UP STORAGE KEY
        TM    PCBIOERR(R13),X'20'      I/O ERROR FOR P.A. FIX @Z40WPYC
        BZ    NOIOERR                  NO - CONTINUE @Z40WPYC
        OI    XPTIOERR(XPTEPTR),X'10'  INDICATE I/O ERROR @Z40WPYC
NOIOERR STOSM 0(R1),X'04'              TURN DAT BIT BACK ON @Z40WPYC
        SRL   R15,@01                  SHIFT OUT ASSIGNED BIT IN RBN
        SLL   R15,@09                  LEAVE FULL RSA VALUE IN REG 15
        SSK   R8,R15                   SET STORAGE KEY IN 1ST 2K BLOCK
        LA    R15,2048(,R15)           GET RSA FOR 2ND HALF OF PAGE
        SSK   R8,R15                   SET STORAGE KEY IN 2ND 2K AREA
        ICM   PCBPTR,@07,PCBFQPA(PCBPTR) PROCESS NEXT PCB ON CHAIN
*   END;                                                           0506
@DE00486 LTR   PCBPTR,PCBPTR                                       0506
         BNZ   @DL00486                                            0506
*   RFY                                                            0507
*    (R1,                                                          0507
*     STEPTR,                                                      0507
*     PTEPTR,                                                      0507
*     R8,                                                          0507
*     R12,                                                         0507
*     R13) UNRSTD;                  /*                       @Z40WPYC*/
*   IF PCBRFAIL='1'B THEN           /* IF IEAVPIOP INDICATED AN ERROR
*                                      OCCURRED ON A FIX'D PAGE, GO
*                                      TO THE ERROR ROUTINE. @Z40WPYC*/
         TM    PCBRFAIL(PCBRPTR),B'00001000'                       0508
         BO    @RT00508                                            0508
*     GO TO SIRTERR0;               /* PROCESS THE ERROR     @Z40WPYC*/
*                                                                  0510
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE THE ASCBCHAP MACRO TO HAVE THIS ADDRESS SPACE ASCB ADDED*/
*   /* TO THE READY QUEUE.                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0510
*   RFY                                                            0510
*    (R0,                                                          0510
*     R1,                                                          0510
*     R13) RSTD;                                                   0510
*   R1=PCBRASCB;                    /* PUT ASCB ADDRESS IN REG 1     */
         L     R1,PCBRASCB(,PCBRPTR)                               0511
*   R13=ADDR(PVTSAVE);              /* PASS A SAVE AREA IN R13       */
         LA    R13,PVTSAVE(,PVTPTR)                                0512
*   GEN REFS(CVTVEAC0,CVTMAP) SETS(R0,R15);                        0513
*                                                                  0513
        ASCBCHAP ADD
*   /*****************************************************************/
*   /*                                                               */
*   /* STATUS START SRBS IN THE ADDRESS SPACE.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0514
*   R0=ASCBASID;                    /* PUT THE ASID IN REG 0         */
         L     @14,PCBRASCB(,PCBRPTR)                              0514
         LH    R0,ASCBASID(,@14)                                   0514
         N     R0,@CF02051                                         0514
*   GEN REFS(R0) SETS(R0);                                         0515
        SLL   R0,16                   SHIFT TO THE HIGH ORDER POSITION
*   R1=13;                          /* SET ENTRY CODE TO START SRBS  */
         LA    R1,13                                               0516
*   R0=R0|R1;                       /* OR THE CODE INTO REG 0        */
         OR    R0,R1                                               0517
*   R1=SIGNBIT;                     /* SET HIGH ORDER BIT ON IN REG 1*/
         LA    R1,128                                              0518
*   GEN REFS(R1) SETS(R1);                                         0519
        SLL   R1,24
*   CALL STATUS;                    /* BRANCH TO STATUS ROUTINE      */
         L     @12,CVTPTR                                          0520
         L     @15,CVTSSRB(,@12)                                   0520
         BALR  @14,@15                                             0520
*/********************************************************************/
*/*                                                                  */
*/* THE I/O HAS COMPLETED FOR STAGE 1; SEGMENT AND PAGES TABLES      */
*/* HAVE BEEN UPDATED; ASCBCHAP HAS BEEN ISSUED; STATUS HAS BEEN     */
*/* CALLED. NOW SYSEVENT INDICATING STAGE 1 COMPLETE IS ISSUED.      */
*/*                                                          @Z40FPYL*/
*/********************************************************************/
*                                                                  0521
*   R0=ASCBASID;                    /* ASID FOR A.S.         @Z40FPYL*/
         L     @14,PCBRASCB(,PCBRPTR)                              0521
         LH    R0,ASCBASID(,@14)                                   0521
         N     R0,@CF02051                                         0521
*   R1=STGONE;                      /* CODE FOR STAGE 1 DONE @Z40FPYL*/
         LA    R1,2                                                0522
*   R13=ADDR(PVTSAVE);              /* SAVE AREA ADDRESS     @Z40FPYL*/
         LA    R13,PVTSAVE(,PVTPTR)                                0523
*   GENERATE NODEFS REFS(CVTPTR,CVTOPTE,CVT) NOSETS NOFLOWS;       0524
*                                                                  0524
     SYSEVENT SWINSTAT,ASID=(0),ENTRY=BRANCH
*   /*****************************************************************/
*   /*                                                               */
*   /* SCHEDULE ROUTINE TO POST RCT IN THE ADDRESS SPACE AND TO START*/
*   /* THE I/O FOR THE PRIVATE AREA UNFIXED PAGES.                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0525
*   SRB=SRB&&SRB;                   /* CLEAR THE SRB         @VS08619*/
         L     @14,SRBPTR(,PCBRPTR)                                0525
         XC    SRB(44,@14),SRB(@14)                                0525
*   SRBASCB=PCBRASCB;               /* SET ASCB TO SCHED INTO.     0526
*                                                            @VS08619*/
         L     @12,PCBRASCB(,PCBRPTR)                              0526
         ST    @12,SRBASCB(,@14)                                   0526
*   SRBEP=ADDR(IEAVSWPP);           /* GET ENTRY POINT       @Z40WPYC*/
         LA    @12,IEAVSWPP                                        0527
         ST    @12,SRBEP(,@14)                                     0527
*   SRBID='SRB ';                   /* GET ID OF A SRG.      @VS08619*/
         MVC   SRBID(4,@14),@CC01994                               0528
*   SRBRMTR=PVTPSRBP;               /* GET SRB PURGE ROUTINE E.P.  0529
*                                                            @VS08619*/
         L     @12,PVTPSRBP(,PVTPTR)                               0529
         ST    @12,SRBRMTR(,@14)                                   0529
*   SRBPARM=PCBRWRKA;               /* PASS PRIVATE AREA PCB'S     0530
*                                                            @Z40WPYC*/
         L     @12,PCBRWRKA(,PCBRPTR)                              0530
         ST    @12,SRBPARM(,@14)                                   0530
*   PCBRWRKA=0;                     /* CLEAR STAGE2 PTR      @Z40WPYC*/
         SLR   @12,@12                                             0531
         ST    @12,PCBRWRKA(,PCBRPTR)                              0531
*   R1=SRBPTR;                      /* GET PTR TO THE SRB    @VS08619*/
         LR    R1,@14                                              0532
*   GENERATE CODE;                                                 0533
*                  /*SCHEDULE THE POST OF RCT.              @VS08619*/
         SCHEDULE SRB=(1),SCOPE=LOCAL
*   SRBPTR=0;                       /* ZERO SRB PTR.         @VS08619*/
*                                                                  0534
         SLR   @14,@14                                             0534
         ST    @14,SRBPTR(,PCBRPTR)                                0534
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE THE ROOT PCB AND THE PCB CHAIN                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0535
*   CALL SWAPPCB;                   /* CALL THE PCB FREE SUBROUTINE  */
         BAL   @14,SWAPPCB                                         0535
*   RFY                                                            0536
*    (R0,                                                          0536
*     R1,                                                          0536
*     R13) UNRSTD;                                                 0536
*                                                                  0537
*   /*****************************************************************/
*   /*                                                               */
*   /* RESET THE ENTRY FLAG IN THE RCA, RESTORE THE INPUT REGISTERS, */
*   /* AND RETURN TO CALLER.                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0537
*SIRTEXIT:                                                         0537
*   PVTPTR=CVTPVTP;                 /* GET PVT BASE BACK             */
SIRTEXIT L     @14,CVTPTR                                          0537
         L     PVTPTR,CVTPVTP(,@14)                                0537
*   RCASIRT='0'B;                   /* RESET RCA FLAG                */
         L     @14,PVTPRCA(,PVTPTR)                                0538
         NI    RCASIRT(@14),B'11011111'                            0538
*   GEN REFS(PVTWSA7,PVTPTR);                                      0539
        LM    R0,R15,PVTWSA7(PVTPTR)  RESTORE INPUT REGISTERS
*   GOTO R14;                       /* RETURN TO CALLER              */
         BR    R14                                                 0540
*SIRTERR:                                                          0541
*   RCARCRD='13'X;                  /* SET THE REASON CODE           */
SIRTERR  L     @14,PVTPRCA(,PVTPTR)                                0541
         MVI   RCARCRD(@14),X'13'                                  0541
*   CALL SWAPC0D;                   /* INVOKE THE FRR ROUTINE        */
         BAL   @14,SWAPC0D                                         0542
*   PCBRFAIL='1'B;                  /* SET ROOT FAIL BIT WHEN AN   0543
*                                      INTERNAL ERROR IS FOUND BY THE
*                                      ROOT EXIT                     */
         OI    PCBRFAIL(PCBRPTR),B'00001000'                       0543
*   RSMFAIL='1'B;                   /* INDICATE THAT LSQA SHOULD NOT
*                                      BE EXAMINED BY ASM    @Z40WPYC*/
         OI    RSMFAIL(RSMHDPTR),B'00000010'                       0544
*/********************************************************************
*                                                                    */
*/*  THIS IS THE MAJOR ERROR HANDLING ROUTINE FOR THE ROOT EXIT.     */
*/*  IT PERFORMS THE FOLLOWING FUNCTIONS:                            */
*/*  (1) IF THE RPB BIT IS ON, DECREMENT THE FIX COUNTS FOR COMMON   */
*/*                                AREA FRAMES VALID IN STORAGE AND  */
*/*                                DEFERRED RELEASE FRAMES UNLESS    */
*/*                                PCBRETRY IS SET                   */
*/*                            CALL IEAVRELF FOR ANY DEFERRED RELEASE*/
*/*                                FRAMES WHOSE FIX COUNTS GO TO ZERO*/
*/*                            FREE THE ROOT PCB                     */
*/*                            FREE THE PCB CHAIN OFF ROOT           */
*/*  (2) IF THE PCBRFAIL BIT IS ON, CALL RTM TO MEMTERM ADDRESS SPACE*/
*/*  (3) EXIT                                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0545
*SIRTERR0:                                                         0545
*   CALL SWAPFIX;                   /* CALL SUBROUTINE TO DECREMENT
*                                      THE FIX COUNTS IN THE PFTES 0545
*                                      FOR VALID COMMON AREA FRAMES  */
*                                                                  0545
SIRTERR0 BAL   @14,SWAPFIX                                         0545
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE ROOT FAIL FLAG IS SET, CALL RTM TO TERMINATE THE MEMORY*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0546
*   RFY                                                            0546
*     ASCB BASED(PCBRASCB);                                        0546
*   IF PCBRFAIL='1'B THEN           /* CHECK THE FAIL BIT IN ROOT PCB*/
         TM    PCBRFAIL(PCBRPTR),B'00001000'                       0547
         BNO   @RF00547                                            0547
*     DO;                           /* IF ON,                        */
*       R2=ASCBASID;                /* PUT THE ASID IN REGISTER 2    */
         L     @14,PCBRASCB(,PCBRPTR)                              0549
         LH    R2,ASCBASID(,@14)                                   0549
         N     R2,@CF02051                                         0549
*       CALL SWAPRTM;               /* GO TO INTERNAL CALLRTM ROUTINE*/
         BAL   @14,SWAPRTM                                         0550
*     END;                                                         0551
*   CALL SWAPPCB;                   /* FREE THE PCB CHAIN            */
@RF00547 BAL   @14,SWAPPCB                                         0552
*   GOTO SIRTEXIT;                  /* GO TO EXIT FROM ROOT ROUTINE  */
         B     SIRTEXIT                                            0553
*                                                                  0554
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS INTERNAL SUBROUTINE IS INVOKED DURING A SWAP-IN TO RECORD*/
*   /* INTERNAL ERRORS VIA THE FRR ROUTINE. THE FRR ROUTINE RECEIVES */
*   /* CONTROL FROM RTM WHEN THE C0D COMPLETION CODE IS SET. THE     */
*   /* REASON CODE MUST BE SET IN THE RCA BY THE CALLER OF THIS      */
*   /* ROUTINE.                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0554
*SWAPC0D:                                                          0554
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0554
SWAPC0D  DS    0H                                                  0555
*   RFY                                                            0555
*    (R1,                                                          0555
*     R14) RSTD;                                                   0555
*   RFY                                                            0556
*     RCA BASED(PVTPRCA);                                          0556
*   GEN SETS(R1);                                                  0557
        ABEND X'C0D',,,SYSTEM     INVOKE THE FRR ROUTINE
*   GOTO R14;                       /* RETURN TO CALLER              */
         BR    R14                                                 0558
*   RFY                                                            0559
*    (R1,                                                          0559
*     R14) UNRSTD;                                                 0559
*C0D:                               /* END SWAPC0D                   */
*   END SWAPC0D;                                                   0560
@EL00002 DS    0H                                                  0560
@EF00002 DS    0H                                                  0560
@ER00002 BR    @14                                                 0560
*                                                                  0561
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS INTERNAL SUBROUTINE CREATES A SINGLE CHAIN OF PCBS FROM  */
*   /* THE EXISTING ROOT PCB AND PCB CHAINS ANCHORED IN THE PCBRWRK1 */
*   /* AND PCBRWRK3 FIELDS. THIS CHAIN IS PASSED TO THE PCB MANAGER  */
*   /* TO HAVE THEM RETURNED TO THE AVAILABLE PCB QUEUE. THE SWAP-IN */
*   /* IN-PROGRESS BIT IN THE SPCT AND THE PCB ROOT ADDRESS ARE ALSO */
*   /* ZEROED BY THIS ROUTINE.                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0561
*SWAPPCB:                                                          0561
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0561
SWAPPCB  DS    0H                                                  0562
*   RFY                                                            0562
*    (R0,                                                          0562
*     R1,                                                          0562
*     R7,                                                          0562
*     R14) RSTD;                                                   0562
*   R7=R14;                         /* SAVE THE CALLERS RETURN     0563
*                                      ADDRESS                       */
         LR    R7,R14                                              0563
*   IF SRBPTR^=0 THEN               /* IS THERE A SRB TO FREE      0564
*                                                            @VS08619*/
         L     @12,SRBPTR(,PCBRPTR)                                0564
         LTR   @12,@12                                             0564
         BZ    @RF00564                                            0564
*     DO;                           /* FREE THE SRB          @VS08619*/
*                                                                  0565
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SUBROUTINE FREES THE SRB AREA ADDRESSED BY REGISTER  */
*       /* ZERO WHEN THE ROUTINE IS ENTERED.                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0566
*       R1=SRBPTR;                  /* PUT THE SRB ADDRESS IN R1   0566
*                                                            @VS08619*/
         LR    R1,@12                                              0566
*       R0=PVTSRBID;                /* PUT THE CELL POOL ID IN R0  0567
*                                                            @VS08619*/
         L     R0,PVTSRBID(,PVTPTR)                                0567
*       GEN REFS(CVTPTR,CVTFRECL,CVTMAP,R13) SETS(R14,R15);        0568
*                                                        /* @VS08619*/
         FREECELL CPID=(0),CELL=(1),BRANCH=YES,SAVE=NO
*       PVTPTR=CVTPVTP;             /* RESET PVT ADDRESS     @VS08619*/
         L     @12,CVTPTR                                          0569
         L     PVTPTR,CVTPVTP(,@12)                                0569
*       RSMHDPTR=ASCBRSM;           /* RESTORE THE RSM HDR PTR.    0570
*                                                            @VS08619*/
         L     @12,PCBRASCB(,PCBRPTR)                              0570
         L     RSMHDPTR,ASCBRSM(,@12)                              0570
*       SPCTPTR=RSMSPCT;            /* RESTORE THE SPCT PTR  @VS08619*/
         L     SPCTPTR,RSMSPCT(,RSMHDPTR)                          0571
*     END;                                                         0572
*   SPCTSWIN='0'B;                  /* TURN OFF THE SWAP-IN        0573
*                                      IN-PROGRESS BIT               */
@RF00564 NI    SPCTSWIN(SPCTPTR),B'01111111'                       0573
*   SPCTSWRT=0;                     /* ZERO POINTER TO ROOT IN THE 0574
*                                      SPCT                          */
         SLR   @12,@12                                             0574
         ST    @12,SPCTSWRT(,SPCTPTR)                              0574
*   IF PCBRWRKA^=0 THEN             /* SWAPIN ERROR AND STAGE2'S THAT
*                                      NEED TO BE FREED      @Z40WPYC*/
         L     @08,PCBRWRKA(,PCBRPTR)                              0575
         CR    @08,@12                                             0575
         BE    @RF00575                                            0575
*     DO;                           /* YES - ENQUEUE TO PCBRWRK1   0576
*                                                            @Z40WPYC*/
*       PCBPTR=PCBRWRKA;            /* GET START OF UNPROCESSED    0577
*                                      STAGE2'S              @Z40WPYC*/
         LR    PCBPTR,@08                                          0577
*       DO WHILE PCBFQPA^=0;        /* LOCATE THE LAST STAGE2 PCB  0578
*                                                            @Z40WPYC*/
         B     @DE00578                                            0578
@DL00578 DS    0H                                                  0579
*         PCBPTR=PCBFQPA;           /* GET NEXT PCB PTR      @Z40WPYC*/
         L     @12,PCBFQPA-1(,PCBPTR)                              0579
         LA    @12,0(,@12)                                         0579
         LR    PCBPTR,@12                                          0579
*       END;                        /* END LOOP              @Z40WPYC*/
@DE00578 L     @12,PCBFQPA-1(,PCBPTR)                              0580
         LA    @12,0(,@12)                                         0580
         LTR   @12,@12                                             0580
         BNZ   @DL00578                                            0580
*       IF PCBRWRK1=0 THEN          /* IF NO STAGE1 PCBS     @Z40WPYC*/
         L     @12,PCBRWRK1(,PCBRPTR)                              0581
         LTR   @12,@12                                             0581
         BNZ   @RF00581                                            0581
*         DO;                       /* THEN                  @Z40WPYC*/
*           PCBRWRK1=PCBRWRKA;      /* CHAIN STAGE2 PCBS TO HEAD OF
*                                      CHAIN TO BE FREED.    @Z40WPYC*/
         L     @12,PCBRWRKA(,PCBRPTR)                              0583
         ST    @12,PCBRWRK1(,PCBRPTR)                              0583
*           PCBRWRK2=PCBPTR;        /* SET PTR TO LAST PCB   @Z40WPYC*/
         ST    PCBPTR,PCBRWRK2(,PCBRPTR)                           0584
*         END;                      /* PCBRWRK1-PCBRWRK2 INITIALIZED
*                                                            @Z40WPYC*/
*       ELSE                        /* STAGE1 PCBS EXIST     @Z40WPYC*/
*         DO;                       /* CHAIN STAGE1 PCBS TO STAGE2 0586
*                                      PCBS                  @Z40WPYC*/
         B     @RC00581                                            0586
@RF00581 DS    0H                                                  0587
*           PCBFQPA=PCBRWRK1;       /* CHAIN FIRST STAG1 TO LAST   0587
*                                      STAGE2                @Z40WPYC*/
         L     @12,PCBRWRK1(,PCBRPTR)                              0587
         STCM  @12,7,PCBFQPA(PCBPTR)                               0587
*           PCBRWRK1->PCBBQPA=PCBPTR;/* CHAIN FIRST STAGE1 TO LAST 0588
*                                      STAGE2 (BACK PTR)     @Z40WPYC*/
         ST    PCBPTR,PCBBQPA(,@12)                                0588
*           PCBRWRK1=PCBRWRKA;      /* CHAIN FIRST STAGE2 PCB TO HEAD
*                                      OF CHAIN              @Z40WPYC*/
         L     @12,PCBRWRKA(,PCBRPTR)                              0589
         ST    @12,PCBRWRK1(,PCBRPTR)                              0589
*         END;                      /* END OF RECHAINING     @Z40WPYC*/
*     END;                          /* END OF STAGE2 PCB PROCESSING
*                                                            @Z40WPYC*/
*   ELSE                                                           0592
*     ;                             /* NO STAGE2 PCB'S EXISTS OR   0592
*                                      SWAPIN SUCCESSFUL     @Z40WPYC*/
@RF00575 DS    0H                                                  0593
*   IF PCBRWRK3^=0 THEN             /* CHECK FOR EXISTENCE OF A    0593
*                                      COMMON AREA PCB CHAIN         */
@RC00575 SLR   @12,@12                                             0593
         L     @08,PCBRWRK3(,PCBRPTR)                              0593
         CR    @08,@12                                             0593
         BE    @RF00593                                            0593
*     DO;                           /* CHAIN IT INTO THE NORMAL IF IT
*                                      EXISTS                        */
*       IF PCBRWRK1^=0 THEN         /* MAKE SURE NORMAL EXISTS TOO   */
         C     @12,PCBRWRK1(,PCBRPTR)                              0595
         BE    @RF00595                                            0595
*         DO;                                                      0596
*           PCBPTR=PCBRWRK2;        /* SET PCB PTR TO END OF NORMAL
*                                      CHAIN                         */
         L     @12,PCBRWRK2(,PCBRPTR)                              0597
         LR    PCBPTR,@12                                          0597
*           PCBFQPA=PCBRWRK3;       /* SET FORWARD PTR TO 1ST ON   0598
*                                      COMMON                        */
         STCM  @08,7,PCBFQPA(PCBPTR)                               0598
*           PCBPTR=PCBRWRK3;        /* SET PCB PTR TO 1ST OF COMMON
*                                      CHAIN                         */
         LR    PCBPTR,@08                                          0599
*           PCBBQPA=PCBRWRK2;       /* SET BACKWARD PTR TO LAST OF 0600
*                                      NORMAL                        */
         ST    @12,PCBBQPA(,PCBPTR)                                0600
*         END;                                                     0601
*       ELSE                        /* IF COMMON AREA PCBS ARE THE   */
*         PCBRWRK1=PCBRWRK3;        /* ONLY CHAIN OFF THE ROOT, PUT
*                                      START ADDRESS IN WRK1 POSITION
*                                      SO THAT THE REST OF THIS    0602
*                                      ROUTINE CAN FUNCTION NORMALLY */
         B     @RC00595                                            0602
@RF00595 L     @12,PCBRWRK3(,PCBRPTR)                              0602
         ST    @12,PCBRWRK1(,PCBRPTR)                              0602
*     END;                                                         0603
@RC00595 DS    0H                                                  0604
*                                                                  0604
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPLETE THE OPERATION BY CHAINING THE ROOT INTO THE CHAIN    */
*   /* ANCHORED IN PCBRWRK1.                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0604
*   IF PCBRWRK1=0 THEN              /* IF THERE ARE NO CHAINS TO FREE*/
@RF00593 L     @12,PCBRWRK1(,PCBRPTR)                              0604
         LTR   @12,@12                                             0604
         BNZ   @RF00604                                            0604
*     PCBRTCB=ROOTNOTQ;             /* PREPARE TO FREE ONLY THE ROOT
*                                                            @YM08229*/
         MVC   PCBRTCB(4,PCBRPTR),@CF01927                         0605
*   ELSE                            /* PREPARE TO FREE ALL PCBS    0606
*                                                            @YM08229*/
*     DO;                           /*                       @YM08229*/
         B     @RC00604                                            0606
@RF00604 DS    0H                                                  0607
*       PCBPTR=PCBRWRK1;            /* SET START OF CHAIN PTR        */
         L     PCBPTR,PCBRWRK1(,PCBRPTR)                           0607
*       PCBRTCB=PCBPTR;             /* MAKE THE ROOT PCB APPEAR TO   */
         ST    PCBPTR,PCBRTCB(,PCBRPTR)                            0608
*       PCBRFLAG=PCBCQN;            /* BE FIRST ON CHAIN BY ADJUSTING*/
         IC    @12,PCBCQN(,PCBPTR)                                 0609
         STC   @12,PCBRFLAG(,PCBRPTR)                              0609
*       PCBBQPA=PCBRPTR;            /* THE FORWARD AND BACKWARD    0610
*                                      POINTERS                      */
         ST    PCBRPTR,PCBBQPA(,PCBPTR)                            0610
*     END;                          /*                       @YM08229*/
*   R1=PCBRPTR;                     /* POINT TO ROOT AS START OF   0612
*                                      CHAIN                         */
@RC00604 LR    R1,PCBRPTR                                          0612
*   R0=PCBFREQN;                    /* SET TQN FOR AVAILABLE QUEUE   */
         LA    R0,16                                               0613
*   CALL PCBMGR;                    /* GO TO PCB MANAGER - IEAVPCB   */
         L     @15,PVTPCB(,PVTPTR)                                 0614
         BALR  @14,@15                                             0614
*   GOTO R7;                        /* RETURN TO CALLER              */
         BR    R7                                                  0615
*   RFY                                                            0616
*    (R0,                                                          0616
*     R1,                                                          0616
*     R7,                                                          0616
*     R14) UNRSTD;                                                 0616
*SPCB:                              /* END SWAPPCB                   */
*   END SWAPPCB;                                                   0617
@EL00003 DS    0H                                                  0617
@EF00003 DS    0H                                                  0617
@ER00003 BR    @14                                                 0617
*                                                                  0618
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS AN INTERNAL SUBROUTINE WHICH IS INVOKED BY THE ROOT   */
*   /* EXIT IF THE SPCT INDICATES THAT THERE IS A FIX ENTRY WITH A   */
*   /* COUNT GREATER THAN 255 OR WHEN THE SWAP-IN HAS FAILED. IN THE */
*   /* BIG FIX CASE, BOTH PRIVATE AND COMMON AREA ENTRIES ARE        */
*   /* SCANNED, AND ANY WITH A BIG FIX COUNT HAVE THEIR CORRESPONDING*/
*   /* PFTE FIX COUNTS INCREMENTED. FOR AN ERROR SITUATION, THIS     */
*   /* ROUTINE WILL PERFORM BACK-OUT FOR COMMON AREA FRAMES WHICH ARE*/
*   /* VALID IN CORE. SHOULD ANY PFTES MARKED DEFERRED RELEASE REACH */
*   /* A ZERO FIX COUNT, IEAVRELF IS CALLED TO POSSIBLY FREE THE     */
*   /* FRAME.                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0618
*SWAPFIX:                                                          0618
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0618
SWAPFIX  DS    0H                                                  0619
*   RFY                                                            0619
*    (SWAPPTR,                                                     0619
*     R7,                                                          0619
*     R14) RSTD;                                                   0619
*                                                                  0619
*   /*****************************************************************/
*   /*                                                               */
*   /* LOCATE THE START OF THE FIXED ENTRIES                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0620
*   PCBRSAVE=R14;                   /* SAVE CALLERS RETURN REGISTER  */
         STCM  R14,7,PCBRSAVE(PCBRPTR)                             0620
*   CALLTERM='0'B;                  /* MAKE SURE CALL RTM BIT IS OFF */
         NI    CALLTERM(PCBRPTR),B'10111111'                       0621
*   SWAPPTR=ADDR(SPCTSWAP);         /* INITIALIZE SWAPPTR VALUE      */
         LA    SWAPPTR,SPCTSWAP(,SPCTPTR)                          0622
*   R7=SPCTLSQA;                    /* SET COUNT OF LSQA ENTRIES     */
         LH    R7,SPCTLSQA(,SPCTPTR)                               0623
*   RFY                                                            0624
*     R14 UNRSTD;                                                  0624
*SWAPCOMP:                                                         0625
*   IF R7-8>=0 THEN                 /* DETERMINE IF THE LSQA ENTRIES
*                                      END WITHIN THIS EXTENSION.  0625
*                                      NOTE THAT 8 IS USED BECAUSE IT
*                                      IS THE MAXIMUM NO. OF LSQA  0625
*                                      ENTRIES THAT WILL FIT IN THE
*                                      SPCT OR AN EXTENSION. @Z40WPYC*/
SWAPCOMP LA    @14,8                                               0625
         LR    @12,R7                                              0625
         SLR   @12,@14                                             0625
         LTR   @12,@12                                             0625
         BM    @RF00625                                            0625
*     DO;                                                          0626
*       SWAPPTR=SPCTEXT;            /* END IS NOT IN THIS AREA       */
         L     SWAPPTR,SPCTEXT(,SWAPPTR)                           0627
*       R7=R7-8;                    /* DECREMENT TO GET NEW COUNT TO
*                                      LOOK FOR IN NEXT              */
         SLR   R7,@14                                              0628
*       GOTO SWAPCOMP;              /* GO TRY AGAIN                  */
         B     SWAPCOMP                                            0629
*     END;                                                         0630
*   RFY                                                            0631
*     FINISH RSTD;                                                 0631
@RF00625 DS    0H                                                  0632
*   FINISH=ADDR(SPCTXEND);          /* SET END OF EXTENSION ADDR     */
         LA    FINISH,SPCTXEND(,SWAPPTR)                           0632
*   SWAPPTR=ADDR(SPCTENT);          /* GET ADDR OF 1ST ENTRY         */
         LA    @14,SPCTENT(,SWAPPTR)                               0633
         LR    SWAPPTR,@14                                         0633
*   SWAPPTR=SWAPPTR+(R7*LENGTH(SPCTLS));/* COMPUTE ADDRESS OF FIRST
*                                      FIX ENTRY             @Z40WPYC*/
         LR    @14,R7                                              0634
         MH    @14,@CH00925                                        0634
         ALR   SWAPPTR,@14                                         0634
*   RFY                                                            0635
*     R7 UNRSTD;                                                   0635
*   RFY                                                            0636
*     START RSTD;                                                  0636
*   START=SPCTFIX;                  /* SET COUNT OF FIXED ENTRIES    */
         LH    START,SPCTFIX(,SPCTPTR)                             0637
*   GEN REFS(SWAPPTR) SETS(SWAPPTR);                               0638
*                                                                  0638
        LA    SWAPPTR,7(SWAPPTR)     DOUBLE-WORD BNDRY @Z40WPYC
        SRL   SWAPPTR,3              DIVIDE BY EIGHT   @Z40WPYC
        SLL   SWAPPTR,3              MULTIPLY BY EIGHT  @Z40WPYC
*   /*****************************************************************/
*   /*                                                               */
*   /* EXAMINE EACH FIX ENTRY. IF PCBRPB OR PCBRFAIL IS SET ON ENTRY */
*   /* TO THIS ROUTINE, DO BACK-OUT PROCESSING, I.E. DECREMENT FIX   */
*   /* COUNTS FOR COMMON AREA FRAMES WHICH ARE VALID IN CORE. IF THIS*/
*   /* IS A CALL TO HANDLE BIG FIX ENTRIES, INCREMENT ANY FIX COUNTS */
*   /* FOR FRAMES WHOSE SPCT ENTRY HAS A COUNT OVER 255.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0639
*   DO WHILE START^=0;              /* CHECK ALL FIX ENTRIES         */
         B     @DE00639                                            0639
@DL00639 DS    0H                                                  0640
*     IF SWAPPTR=FINISH THEN        /* MAY HAVE TO GO TO EXTENSION   */
         CR    SWAPPTR,FINISH                                      0640
         BNE   @RF00640                                            0640
*       DO;                         /* ADJUST POINTERS IF SO         */
*         SWAPPTR=SWAPPTR-LENGTH(SPCTSWAP);                        0642
         SL    SWAPPTR,@CF01288                                    0642
*         SWAPPTR=SPCTEXT;          /* GET 1ST ENTRY IN              */
         L     SWAPPTR,SPCTEXT(,SWAPPTR)                           0643
*         FINISH=ADDR(SPCTXEND);    /* POINT TO END OF THIS EXTENSION*/
         LA    FINISH,SPCTXEND(,SWAPPTR)                           0644
*         SWAPPTR=ADDR(SPCTENT);    /* GET 1ST ENTRY IN NEW EXTENSION*/
         LA    @14,SPCTENT(,SWAPPTR)                               0645
         LR    SWAPPTR,@14                                         0645
*       END;                                                       0646
*                                                                  0646
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS COMMON AREA FIX ENTRIES                             */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0647
*     IF SPCTCOMM='1'B THEN                                        0647
@RF00640 TM    SPCTCOMM(SWAPPTR),B'00100000'                       0647
         BNO   @RF00647                                            0647
*       DO;                                                        0648
*         RFY                                                      0649
*           R1 RSTD;                                               0649
*         R1=SPCTVBN;               /* CREATE THE VIRTUAL STORAGE  0650
*                                      ADDR                  @Z40WPYC*/
         LH    R1,SPCTVBN(,SWAPPTR)                                0650
         N     R1,@CF02051                                         0650
*         GEN SETS(R1) FLOWS(SWAPCOMM);                            0651
        SLL   R1,8                     CREATE FULL VSA     @Z40WPYC
        LRA   R1,0(R1)                 GET REAL ADDRESS IF IN CORE
        BNZ   SWAPCOMM                 BRANCH IF OUT OF CORE
        SRL   R1,8                     LEAVE ONLY RBN IN REGISTER
*         RFY                                                      0652
*           PFTEPTR RSTD;                                          0652
*         PFTEPTR=PVTPFTP+R1;       /* CALCULATE PFTE ADDR           */
         LR    PFTEPTR,R1                                          0653
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0653
*                                                                  0654
*         /***********************************************************/
*         /*                                                         */
*         /* COMMON AREA BACK-OUT PROCESS                            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0654
*         IF PCBRPB='1'B|PCBRFAIL='1'B THEN/* CHECK FOR BACK-OUT     */
         TM    PCBRPB(PCBRPTR),B'00101000'                         0654
         BZ    @RF00654                                            0654
*           DO;                                                    0655
*             IF SPCTDEFR='1'B THEN /* IF THE DEFERRED RELEASE FLAG
*                                      IS SET, SWAP-OUT DID NOT    0656
*                                      DECREMENT THE FIX COUNT IN THE
*                                      PFTE                          */
         TM    SPCTDEFR(SWAPPTR),B'00010000'                       0656
         BNO   @RF00656                                            0656
*               DO;                 /* IF GFA DID NOT INDICATE THAT
*                                      THIS SWAP-IN IS RETRIABLE,  0657
*                                      THEN DECREMENT THE FIX COUNT
*                                      NOW                           */
*                 IF PCBRETRY='0'B THEN/* CHECK FOR NO RETRY         */
         TM    PCBRETRY(PCBRPTR),B'01000000'                       0658
         BZ    @RT00658                                            0658
*                   GOTO SWAPDECR;  /* AND GO DECREMENT IF ITS A   0659
*                                      PERMANENT FAILURE             */
*                 ELSE              /* OTHERWISE, IGNORE ENTRY IF THE*/
*                   GOTO SWAPCOMM;  /* SWAP-IN MAY GO NEXT TIME      */
         B     SWAPCOMM                                            0660
*               END;                                               0661
*             PCBPTR=PCBRWRK3;      /* IF THE FRAME IS NOT DEFERRED
*                                      RELEASE, CHECK THE CHAIN OF 0662
*                                      PCBS WHICH DID NOT HAVE I-O 0662
*                                      STARTED                       */
@RF00656 L     PCBPTR,PCBRWRK3(,PCBRPTR)                           0662
*             RFY                                                  0663
*               R0 RSTD;                                           0663
*             R0=SPCTVBN;           /* PUT VBN FROM ENTRY IN REG 0 0664
*                                                            @Z40WPYC*/
         LH    R0,SPCTVBN(,SWAPPTR)                                0664
         N     R0,@CF02051                                         0664
*             DO WHILE PCBPTR^=0;   /* LOOK AT ALL PCBS ON CHAIN     */
         B     @DE00665                                            0665
@DL00665 DS    0H                                                  0666
*               R1=PCBVBN;          /* PUT VBN FROM PCB IN REG 1     */
         LH    R1,PCBVBN(,PCBPTR)                                  0666
         N     R1,@CF02051                                         0666
*               IF R0=R1 THEN       /* IF MATCH IS FOUND, DO NOT     */
         CR    R0,R1                                               0667
         BE    @RT00667                                            0667
*                 GOTO SWAPCOMM;    /* DECREMENT FIX COUNT           */
*               ELSE                /* OTHERWISE,                    */
*                 PCBPTR=PCBFQPA;   /* CHECK NEXT PCB                */
         L     @12,PCBFQPA-1(,PCBPTR)                              0669
         LA    @12,0(,@12)                                         0669
         LR    PCBPTR,@12                                          0669
*             END;                  /* END OF PCB SCAN               */
@DE00665 SLR   @12,@12                                             0670
         CR    PCBPTR,@12                                          0670
         BNE   @DL00665                                            0670
*             IF PFTFXCT=0 THEN                                    0671
         CH    @12,PFTFXCT(,PFTEPTR)                               0671
         BE    @RT00671                                            0671
*               GOTO SWAPCOMM;      /*                       @ZA08771*/
*                                                                  0672
*             /*******************************************************/
*             /*                                                     */
*             /* IF MATCH IS NOT FOUND MUST DECREMENT THE COMMON AREA*/
*             /* FIX COUNT IN THE PFTE BY THE SPCTFIXC               */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0673
*                                                                  0673
*             /*******************************************************/
*             /*                                                     */
*             /* DECREMENT THE FIX COUNT IN THE PFTE FOR THIS ENTRY  */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0673
*             IF SPCTBIG='0'B THEN  /* IF THIS BIT IS ZERO, EITHER 0673
*                                      THERE WERE NO BIG FIXES     0673
*                                      ORIGINALLY OR ALL THE BIG   0673
*                                      FIXES HAVE HAD THEIR FIX    0673
*                                      COUNTS ADJUSTED               */
         TM    SPCTBIG(SPCTPTR),B'00010000'                        0673
         BNZ   @RF00673                                            0673
*SWAPDECR:                                                         0674
*               PFTFXCT=PFTFXCT-SPCTFIXC;/* IN EITHER CASE, OR IF  0674
*                                      THIS IS A DEFERRED RELEASE  0674
*                                      FRAME, DECREMENT BY THE ENTIRE
*                                      VALUE IN IN THE SPCT ENTRY    */
SWAPDECR LH    @12,PFTFXCT(,PFTEPTR)                               0674
         SH    @12,SPCTFIXC(,SWAPPTR)                              0674
         STH   @12,PFTFXCT(,PFTEPTR)                               0674
*             ELSE                  /* SPCTBIG IS STILL = 1          */
*               DO;                 /* DETERMINE IF THIS IS A BIG FIX*/
         B     @RC00673                                            0675
@RF00673 DS    0H                                                  0676
*                 IF SPCTTFIX=0 THEN/* FOR A NORMAL FIX              */
         CLI   SPCTTFIX(SWAPPTR),0                                 0676
         BNE   @RF00676                                            0676
*                   PFTFXCT=PFTFXCT-SPCTFIXC;/* SUBTRACT FULL VALUE  */
         LH    @12,PFTFXCT(,PFTEPTR)                               0677
         SH    @12,SPCTFIXC(,SWAPPTR)                              0677
         STH   @12,PFTFXCT(,PFTEPTR)                               0677
*                 ELSE              /* FOR A BIG FIX STILL PENDING   */
*                   PFTFXCT=PFTFXCT-1;/* SUBTRACT ONLY ONE SINCE   0678
*                                      SWAP-IN MAINLINE OR GFA WOULD
*                                      HAVE ONLY INCREMENTED IT BY 1 */
         B     @RC00676                                            0678
@RF00676 LH    @12,PFTFXCT(,PFTEPTR)                               0678
         BCTR  @12,0                                               0678
         STH   @12,PFTFXCT(,PFTEPTR)                               0678
*               END;                /* END OF BIG FIX BACK-OUT       */
@RC00676 DS    0H                                                  0680
*             IF PFTFXCT=0 THEN     /* WHEN BACKING OUT      @YA01572*/
@RC00673 LH    @12,PFTFXCT(,PFTEPTR)                               0680
         LTR   @12,@12                                             0680
         BNZ   @RF00680                                            0680
*               DO;                 /* C.A. FIXES MUST       @YA01572*/
*                 PVTCNTFX=PVTCNTFX-1;/* TEST IF FXCNT =0    @YA01572*/
         LH    @12,PVTCNTFX(,PVTPTR)                               0682
         BCTR  @12,0                                               0682
         STH   @12,PVTCNTFX(,PVTPTR)                               0682
*                 PVTCOMFX=PVTCOMFX-1;/* WHEN =0,MUST        @YA01572*/
         LH    @12,PVTCOMFX(,PVTPTR)                               0683
         BCTR  @12,0                                               0683
         STH   @12,PVTCOMFX(,PVTPTR)                               0683
*               END;                /* DECREMENT THE COUNTS  @YA01572*/
*             ELSE                                                 0685
*               ;                   /*                       @YA01572*/
*                                                                  0685
@RF00680 DS    0H                                                  0686
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE FIX COUNT GOES TO ZERO FOR A DEFERRED RELEASE*/
*             /* PFTE, CALL IEAVRELF TO POSSIBLY FREE THE FRAME      */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0686
*SWAPDEFR:                                                         0686
*             IF PFTDFRLS='1'B THEN /* CHECK DEFERRED RELEASE        */
SWAPDEFR TM    PFTDFRLS(PFTEPTR),B'10000000'                       0686
         BNO   @RF00686                                            0686
*               DO;                                                0687
*                 IF PFTFXCT=0 THEN /* CHECK FOR 0 FIX COUNT         */
         LH    @12,PFTFXCT(,PFTEPTR)                               0688
         LTR   @12,@12                                             0688
         BNZ   @RF00688                                            0688
*                   DO;                                            0689
*                     R1=PFTVBN*256;/* SET FULL VSA VALUE            */
         LH    R1,PFTVBN(,PFTEPTR)                                 0690
         N     R1,@CF02051                                         0690
         SLA   R1,8                                                0690
*                     RSMHDPTR=PSAAOLD->ASCBRSM;/* SET CURRENT RSM 0691
*                                      HEADER ADDRESS                */
         L     @12,PSAAOLD                                         0691
         L     RSMHDPTR,ASCBRSM(,@12)                              0691
*                     CALL RELF;    /* CALL IEAVRELF                 */
         L     @15,PVTPRELF(,PVTPTR)                               0692
         BALR  @14,@15                                             0692
*                     RSMHDPTR=ASCBRSM;/* RESET RSM HEADER TO      0693
*                                      ORIGINAL VALUE                */
         L     @12,PCBRASCB(,PCBRPTR)                              0693
         L     RSMHDPTR,ASCBRSM(,@12)                              0693
*                     IF R15^=0 THEN/* RECORD ANY ERRORS             */
         LTR   R15,R15                                             0694
         BZ    @RF00694                                            0694
*                       DO;                                        0695
*                         RCARCRD='0F'X;/* SET REASON CODE           */
         L     @12,PVTPRCA(,PVTPTR)                                0696
         MVI   RCARCRD(@12),X'0F'                                  0696
*                         CALL SWAPC0D;/* GO TO FRR ROUTINE          */
         BAL   @14,SWAPC0D                                         0697
*                       END;                                       0698
*                   END;                                           0699
@RF00694 DS    0H                                                  0700
*               END;                /* END DEFERRED RLSE PROCESS     */
@RF00688 DS    0H                                                  0701
*             RFY                                                  0701
*               R1 UNRSTD;                                         0701
@RF00686 DS    0H                                                  0702
*           END;                    /* END COMMON AREA BACK-OUT      */
*         ELSE                      /* PCBRPB AND PCBRFAIL BOTH = 0  */
*           DO;                                                    0703
*                                                                  0703
         B     @RC00654                                            0703
@RF00654 DS    0H                                                  0704
*             /*******************************************************/
*             /*                                                     */
*             /* NORMAL BIG FIX PROCESSING FOR A COMMON AREA FRAME   */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0704
*             IF SPCTTFIX=0 THEN    /* IF THIS IS NOT A BIG FIX ENTRY*/
         CLI   SPCTTFIX(SWAPPTR),0                                 0704
         BE    @RT00704                                            0704
*               GOTO SWAPCOMM;      /* GO CHECK NEXT SPCT ENTRY      */
*             ELSE                  /* THIS IS A BIG FIX             */
*               DO;                 /* IF IT IS NOT MARKED AS A      */
*                 IF SPCTDEFR='0'B THEN/* DEFERRED RELEASE FRAME,    */
         TM    SPCTDEFR(SWAPPTR),B'00010000'                       0707
         BNZ   @RF00707                                            0707
*                   PFTFXCT=PFTFXCT+SPCTFIXC-1;/* INCREMENT THE PFTE
*                                      COUNT BY THE SPCT FIX COUNT 0708
*                                      MINUS THE 1 THAT IS ADDED BY
*                                      EITHER SWAP-IN MAINLINE OR BY
*                                      GFA AT THE TIME THE FRAME IS
*                                      ALLOCATED                     */
         LH    @12,PFTFXCT(,PFTEPTR)                               0708
         AH    @12,SPCTFIXC(,SWAPPTR)                              0708
         BCTR  @12,0                                               0708
         STH   @12,PFTFXCT(,PFTEPTR)                               0708
*                 ELSE                                             0709
*                   ;               /* IF IT IS DEFERRED RELEASE, THE
*                                      ORIGINAL FIX COUNT WAS LEFT IN
*                                      THE PFTE AT SWAP-OUT TIME SO
*                                      IT NEED NOT BE ALTERED NOW    */
@RF00707 DS    0H                                                  0710
*               END;                /* END OF DEFERRED RELEASE     0710
*                                      CHECKING                      */
*             RFY                                                  0711
*               PFTEPTR UNRSTD;                                    0711
*           END;                    /* END COMMON AREA BIG FIX     0712
*                                      PROCESS                       */
*       END;                        /* END OF COMMON AREA PROCESSING */
*     ELSE                          /* SPCTCOMM = 0                  */
*       DO;                                                        0714
*                                                                  0714
         B     @RC00647                                            0714
@RF00647 DS    0H                                                  0715
*         /***********************************************************/
*         /*                                                         */
*         /* PRIVATE AREA BIG FIX PROCESSING                         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0715
*         IF PCBRPB='1'B|PCBRFAIL='1'B THEN/* IF THIS IS A BACK-OUT
*                                      CALL,                         */
         TM    PCBRPB(PCBRPTR),B'00101000'                         0715
         BNZ   @RT00715                                            0715
*           GOTO SWAPCOMM;          /* IGNORE PRIVATE AREA ENTRIES   */
*         IF SPCTTFIX=0 THEN        /* IF THIS IS NOT A BIG FIX      */
         CLI   SPCTTFIX(SWAPPTR),0                                 0717
         BE    @RT00717                                            0717
*           GOTO SWAPCOMM;          /* IGNORE ENTRY                  */
*         RFY                                                      0719
*          (R0,                                                    0719
*           R1) RSTD;                                              0719
*         PCBPTR=PCBRWRK1;          /* LOCATE PCB THAT MATCHES THIS  */
         L     PCBPTR,PCBRWRK1(,PCBRPTR)                           0720
*         R0=SPCTVBN;               /* GET VBN FROM SPCT FIX ENTRY 0721
*                                                            @Z40WPYC*/
         LH    R0,SPCTVBN(,SWAPPTR)                                0721
         N     R0,@CF02051                                         0721
*         DO WHILE PCBPTR^=0;       /* LOOP THRU THE PCB CHAIN       */
         B     @DE00722                                            0722
@DL00722 DS    0H                                                  0723
*           R1=PCBVBN;              /* GET VBN FROM PCB              */
         LH    R1,PCBVBN(,PCBPTR)                                  0723
         N     R1,@CF02051                                         0723
*           IF R0=R1 THEN           /* WHEN THE VBNS MATCH,          */
         CR    R0,R1                                               0724
         BNE   @RF00724                                            0724
*             DO;                   /* GET THE PFTE ADDRESS          */
*               RFY                                                0726
*                (R0,                                              0726
*                 R1) UNRSTD;                                      0726
*               RFY                                                0727
*                 PFTEPTR RSTD;                                    0727
*               PFTEPTR=PVTPFTP+PCBRBN;/* ADD THE RBN IN THE PCB TO
*                                      THE PFTE ORIGIN               */
         LH    PFTEPTR,PCBRBN(,PCBPTR)                             0728
         N     PFTEPTR,@CF02051                                    0728
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0728
*               PFTFXCT=PFTFXCT+SPCTFIXC-1;/* UPDATE THE PFTE CT     */
         LH    @12,PFTFXCT(,PFTEPTR)                               0729
         AH    @12,SPCTFIXC(,SWAPPTR)                              0729
         BCTR  @12,0                                               0729
         STH   @12,PFTFXCT(,PFTEPTR)                               0729
*               GOTO SWAPCOMM;      /* GO CHECK NEXT ENTRY           */
         B     SWAPCOMM                                            0730
*               RFY                                                0731
*                 PFTEPTR UNRSTD;                                  0731
*             END;                  /* END OF PRIVATE AREA PFTE    0732
*                                      UPDATE                        */
*           ELSE                    /* IF THE VBNS DO NOT MATCH      */
*             GEN REFS(PCBPTR,PCBFQPA) SETS(PCBPTR);               0733
@RF00724 DS    0H                                                  0733
        ICM   PCBPTR,@07,PCBFQPA(PCBPTR)  GO CHECK THE NEXT PCB
*         END;                      /* END OF PCB CHAIN              */
@DE00722 LTR   PCBPTR,PCBPTR                                       0734
         BNZ   @DL00722                                            0734
*         CALLTERM='1'B;            /* IF THE PCB CANNOT BE FOUND, 0735
*                                      SET BIT TO INDICATE THAT THE
*                                      MEMORY MUST BE TERMINATED WHEN
*                                      ALL THE FIX COUNTS HAVE BEEN
*                                      ADJUSTED                      */
         OI    CALLTERM(PCBRPTR),B'01000000'                       0735
*         RCARCRD='13'X;            /* SET REASON CODE               */
         L     @14,PVTPRCA(,PVTPTR)                                0736
         MVI   RCARCRD(@14),X'13'                                  0736
*         CALL SWAPC0D;             /* RECORD ERROR VIA THE FRR    0737
*                                      ROUTINE                       */
         BAL   @14,SWAPC0D                                         0737
*       END;                        /* END PRIVATE AREA PROCESSING   */
*                                                                  0738
*     /***************************************************************/
*     /*                                                             */
*     /* DECREMENT COUNT OF ENTRIES TO BE PROCESSED AND SET SWAPPTR  */
*     /* TO POINT TO NEXT FIX ENTRY                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0739
*SWAPCOMM:                                                         0739
*     START=START-1;                /* SUBTRACT 1 FROM COUNT         */
@RC00647 DS    0H                                                  0739
SWAPCOMM BCTR  START,0                                             0739
*     SWAPPTR=SWAPPTR+LENGTH(SPCTSWPE);/* ADD LENGTH OF A FIX ENTRY  */
         AL    SWAPPTR,@CF00055                                    0740
*   END;                            /* END OF FIX ENTRIES            */
@DE00639 LTR   START,START                                         0741
         BNZ   @DL00639                                            0741
*   RFY                                                            0742
*    (START,                                                       0742
*     FINISH,                                                      0742
*     SWAPPTR) UNRSTD;                                             0742
*   SPCTBIG='0'B;                   /* TURN OFF BIG FIX BIT          */
         NI    SPCTBIG(SPCTPTR),B'11101111'                        0743
*   IF CALLTERM='1'B THEN           /* IF AN ERROR WAS FOUND IN THIS
*                                      PROCESS                       */
         TM    CALLTERM(PCBRPTR),B'01000000'                       0744
         BNO   @RF00744                                            0744
*     PCBRFAIL='1'B;                /* SET BIT TO TERMINATE THE    0745
*                                      MEMORY                        */
         OI    PCBRFAIL(PCBRPTR),B'00001000'                       0745
*   RFY                                                            0746
*     R14 RSTD;                                                    0746
@RF00744 DS    0H                                                  0747
*   R14=PCBRSAVE;                   /* RESTORE RETURN REGISTER       */
         L     R14,PCBRSAVE-1(,PCBRPTR)                            0747
         LA    R14,0(,R14)                                         0747
*   GOTO R14;                       /* EXIT                          */
         BR    R14                                                 0748
*FIX:                               /* END SWAPFIX                   */
*   END SWAPFIX;                                                   0749
@EL00004 DS    0H                                                  0749
@EF00004 DS    0H                                                  0749
@ER00004 BR    @14                                                 0749
*                                                                  0750
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS AN INTERNAL SUBROUTINE WHICH PROVIDES A COMMON POINT  */
*   /* IN SWAP-IN PROCESSING TO CALL RTM WITH A MEMTERM REQUEST FOR  */
*   /* THE ADDRESS SPACE BEING BROUGHT IN. THE CALLER MUST SET THE   */
*   /* ASID IN REGISTER 2 BEFORE INVOKING THIS ROUTINE.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0750
*SWAPRTM:                                                          0750
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0750
SWAPRTM  DS    0H                                                  0751
*   RFY                                                            0751
*    (R1,                                                          0751
*     R7,                                                          0751
*     R13,                                                         0751
*     R14) RSTD;                                                   0751
*   R7=R14;                         /* SAVE RETURN ADDRESS           */
         LR    R7,R14                                              0752
*   R1='028'X;                      /* SET COMPLETION CODE           */
         LA    R1,40                                               0753
*   R13=ADDR(PVTSAVE);              /* PASS SAVE AREA IN PVT         */
         LA    R13,PVTSAVE(,PVTPTR)                                0754
*   GEN REFS(R1,CVTBTERM,CVTMAP) SETS(R0,R1,R14,R15);              0755
        CALLRTM TYPE=MEMTERM,COMPCOD=(1),ASID=(2)  CALL RTM
*   GOTO R7;                        /* RETURN TO CALLER              */
         BR    R7                                                  0756
*   RFY                                                            0757
*    (R1,                                                          0757
*     R7,                                                          0757
*     R13,                                                         0757
*     R14) UNRSTD;                                                 0757
*RTM:                                                              0758
*   END SWAPRTM;                    /* END SWAPRTM                   */
@EL00005 DS    0H                                                  0758
@EF00005 DS    0H                                                  0758
@ER00005 BR    @14                                                 0758
*                                                                  0759
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE IS SCHEDULED BY THE SWAP IN ROOT EXIT TO POST RCT*/
*   /* IN THE MEMORY BEING SWAPPED IN. XMPOST CANNOT BE USED BECAUSE */
*   /* OF RECURSION PROBLEMS WITH THE SALLOC LOCK            @VS08619*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0759
*IEAVSWPP:                          /*                       @Z40WPYC*/
*   GEN REFS(R15) SETS(R9);                                        0759
IEAVSWPP DS    0H                                                  0759
*                                /*  @Z40WPYC*/
        ENTRY IEAVSWPP               @Z40WPYC
        LA     R15,SWINPST-@PSTART  GET OFFSET START  @Z40WPYC
        BALR   R9,@00               EST. ADDRESSABILITY @Z40WPYC
SWINPST SR     R9,R15               ADJUST BY PROPER OFFSET @Z40WPYC
*   PVTPTR=CVTPVTP;                 /* OBTAIN PVT ADDRESS    @VS08619*/
*                                                                  0760
         L     @14,CVTPTR                                          0760
         L     PVTPTR,CVTPVTP(,@14)                                0760
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SUBROUTINE FREES THE SRB AREA ADDRESSED BY REGISTER ZERO */
*   /* WHEN THE ROUTINE IS ENTERED.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0761
*   RESPECIFY                                                      0761
*    (R0,                                                          0761
*     R1,                                                          0761
*     R7,                                                          0761
*     PCBPTR) RESTRICTED;           /*                       @Z40WPYC*/
*   R7=R1;                          /* SAVE ADDRESS OF P.A. UNFIXED
*                                      PCB'S                 @Z40WPYC*/
         LR    R7,R1                                               0762
*   R1=R0;                          /* PUT THE SRB ADDRESS IN R1   0763
*                                                            @VS08619*/
         LR    R1,R0                                               0763
*   R0=PVTSRBID;                    /* PUT THE CELL POOL ID IN R0  0764
*                                                            @VS08619*/
         L     R0,PVTSRBID(,PVTPTR)                                0764
*   GEN REFS(CVTPTR,CVTFRECL,CVTMAP,R13) SETS(R14,R15);            0765
*                                                        /* @VS08619*/
         FREECELL CPID=(0),CELL=(1),BRANCH=YES,SAVE=NO
*   PVTPTR=CVTPVTP;                 /* RESET PVT ADDRESS     @VS08619*/
         L     @14,CVTPTR                                          0766
         L     PVTPTR,CVTPVTP(,@14)                                0766
*   RFY                                                            0767
*     ASCB BASED(PSAAOLD);          /* SET BASE TO ASCB              */
*   RFY                                                            0768
*    (R8,                                                          0768
*     R11,                                                         0768
*     R12) RSTD;                                                   0768
*                                                                  0768
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH THE FRR ROUTINE TO RECORD ANY ERRORS                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0769
*   GEN CODE REFS(PSACSTK,PSA,FRRS,PVTPTR,PVTPRCV,FRRSCURR,FRRSLAST,
*       PSALSFCC,FRRSELEN,FRRSFRRA,FRRSENTR,FRRSPARM) SETS(R11,R12,R8);
         SETFRR A,FRRAD=PVTPRCV(PVTPTR),PARMAD=(R8),                  **
               WRKREGS=(R11,R12)
*   RFY                                                            0770
*     RCA BASED(R8);                                               0770
*   RCACSECT=RCACSPIN;              /* SET MODULE ID IN RCA          */
         MVI   RCACSECT(R8),X'19'                                  0771
*   RCARETAD=ADDR(SWPPRTRY);        /* SET RETRY ADDRES      @Z40WPYC*/
         LA    @14,SWPPRTRY                                        0772
         ST    @14,RCARETAD(,R8)                                   0772
*   RCASWPP='1'B;                   /* INDICATE IEAVSWPP     @Z40WPYC*/
         OI    RCASWPP(R8),B'00000100'                             0773
*   RSMHDPTR=ASCBRSM;               /* LOCATE RSMHD PTR      @Z40WPYC*/
         L     @14,PSAAOLD                                         0774
         L     RSMHDPTR,ASCBRSM(,@14)                              0774
*   IF R7^=0 THEN                   /* IF STAGE2 PCB'S       @Z40WPYC*/
         LTR   R7,R7                                               0775
         BZ    @RF00775                                            0775
*     DO;                           /* SET UP TO ALLOCATE FRAMES   0776
*                                                            @Z40WPYC*/
*       RESPECIFY                                                  0777
*        (R13,                                                     0777
*         R14) RESTRICTED;          /*                       @Z40WPYC*/
*                                                                  0777
*       /*************************************************************/
*       /*                                                           */
*       /* REQUEST SALLOC UNCONDITIONALLY                    @Z40WPYC*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0778
*GETLOCK2:                                                         0778
*       GEN CODE REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);          0778
GETLOCK2 DS    0H                                                  0778
*                                                        /* @Z40WPYC*/
         SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(RSM,IEAVSWPP(FREELCK2))
*       PVTPRCA=R8;                 /* SAVE ADDRESS OF RCA   @Z40WPYC*/
         ST    R8,PVTPRCA(,PVTPTR)                                 0779
*       RCASAL='1'B;                /* INDICATE SALLOC HELD  @Z40WPYC*/
         OI    RCASAL(R8),B'10000000'                              0780
*       PCBPTR=R7;                  /* SET PTR TO FIRST PCB  @Z40WPYC*/
         LR    PCBPTR,R7                                           0781
*       DO WHILE PCBPTR^=0;         /* PROCESS STAGE2 PCB'S  @Z40WPYC*/
         B     @DE00782                                            0782
@DL00782 DS    0H                                                  0783
*         R1=PCBVBN*256;            /* SET INPUT VSA FOR IEAVFP2   0783
*                                                            @Z40WPYC*/
         LH    R1,PCBVBN(,PCBPTR)                                  0783
         N     R1,@CF02051                                         0783
         SLA   R1,8                                                0783
*         CALL FINDPAGE;            /* CALL IEAVFP2 TO OBTAIN THE  0784
*                                      PGTE AND XPTE ADDRESSES.    0784
*                                                            @Z40WPYC*/
         L     @15,PVTPFP2(,PVTPTR)                                0784
         BALR  @14,@15                                             0784
*         PTEPTR=R0;                /* POINT TO PAGE TABLE   @Z40WPYC*/
         LR    PTEPTR,R0                                           0785
*         IF R15^=0|PGTPVM='0'B|PGTPAM='0'B THEN/* IF PAGE TABLE HAS
*                                      BEEN FREEMAIND OR PAGE DOES 0786
*                                      NOT REQUIRE I/O, THEN ...   0786
*                                                            @Z40WPYC*/
         LTR   R15,R15                                             0786
         BNZ   @RT00786                                            0786
         TM    PGTPVM(PTEPTR),B'00001001'                          0786
         BO    @RF00786                                            0786
@RT00786 DS    0H                                                  0787
*           DO;                     /* REMOVE PCB FROM QUEUE @Z40WPYC*/
*             IF PCBBQPA^=0 THEN    /* NOT FIRST PCB         @Z40WPYC*/
         L     @10,PCBBQPA(,PCBPTR)                                0788
         LTR   @10,@10                                             0788
         BZ    @RF00788                                            0788
*               PCBBQPA->PCBFQPA=PCBFQPA;/* CHAIN PREVIOUS TO NEW  0789
*                                      NEXT                  @Z40WPYC*/
         MVC   PCBFQPA(3,@10),PCBFQPA(PCBPTR)                      0789
*             ELSE                  /* FIRST PCB             @Z40WPYC*/
*               R7=PCBFQPA;         /* ESTABLISH NEW HEAD    @Z40WPYC*/
         B     @RC00788                                            0790
@RF00788 L     R7,PCBFQPA-1(,PCBPTR)                               0790
         LA    R7,0(,R7)                                           0790
*             IF PCBFQPA^=0 THEN    /* MORE PCB'S            @Z40WPYC*/
@RC00788 L     @10,PCBFQPA-1(,PCBPTR)                              0791
         LA    @10,0(,@10)                                         0791
         LTR   @10,@10                                             0791
         BZ    @RF00791                                            0791
*               PCBFQPA->PCBBQPA=PCBBQPA;/* BACK CHAIN THE NEXT TO 0792
*                                      THE PREVIOUS          @Z40WPYC*/
         MVC   PCBBQPA(4,@10),PCBBQPA(PCBPTR)                      0792
*             ELSE                                                 0793
*               ;                   /* LAST PCB              @Z40WPYC*/
@RF00791 DS    0H                                                  0794
*             R1=PCBPTR;            /* SET PCB ADDR          @Z40WPYC*/
         LR    R1,PCBPTR                                           0794
*             PCBPTR=PCBFQPA;       /* SET PTR TO NEXT PCB   @Z40WPYC*/
         L     @10,PCBFQPA-1(,PCBPTR)                              0795
         LA    @10,0(,@10)                                         0795
         LR    PCBPTR,@10                                          0795
*             R1->PCBFQPA=0;        /* CLEAR FORWARD PTR OF PCB TO BE
*                                      DEQUEUED              @Z40WPYC*/
         SLR   @10,@10                                             0796
         STCM  @10,7,PCBFQPA(R1)                                   0796
*             R1->PCBBQPA=0;        /* CLEAR BACK PTR OF PCB TO BE 0797
*                                      DEQUEUED              @Z40WPYC*/
         ST    @10,PCBBQPA(,R1)                                    0797
*             R0=PCBFREQN;          /* INDICATE PCB TO FREE Q      0798
*                                                            @Z40WPYC*/
         LA    R0,16                                               0798
*             CALL PCBMGR;          /* PCB TO FREE QUEUE     @Z40WPYC*/
         L     @15,PVTPCB(,PVTPTR)                                 0799
         BALR  @14,@15                                             0799
*           END;                    /* END IN CORE PROCESSING      0800
*                                                            @Z40WPYC*/
*         ELSE                      /* OUT OF CORE PCB       @Z40WPYC*/
*           DO;                     /* INIT PGTE AND XPTE IN PCB   0801
*                                                            @Z40WPYC*/
         B     @RC00786                                            0801
@RF00786 DS    0H                                                  0802
*             PCBXPTA=R1;           /* STORE XPTE ADDRESS    @Z40WPYC*/
         STCM  R1,7,PCBXPTA(PCBPTR)                                0802
*             PCBPGTA=R0;           /* STORE PGTE ADDRESS    @Z40WPYC*/
         STCM  R0,7,PCBPGTA(PCBPTR)                                0803
*             PCBPTR=PCBFQPA;       /* SET PTR TO NEXT PCB   @Z40WPYC*/
         L     @10,PCBFQPA-1(,PCBPTR)                              0804
         LA    @10,0(,@10)                                         0804
         LR    PCBPTR,@10                                          0804
*           END;                    /* END OUT OF CORE PROCESSING  0805
*                                                            @Z40WPYC*/
*       END;                        /* END CHECK PGTPVM      @Z40WPYC*/
@RC00786 DS    0H                                                  0806
@DE00782 SLR   @10,@10                                             0806
         CR    PCBPTR,@10                                          0806
         BNE   @DL00782                                            0806
*       IF R7^=0 THEN               /* IF STAGE2 SWAPPING REQUIRED 0807
*                                                            @Z40WPYC*/
         CR    R7,@10                                              0807
         BE    @RF00807                                            0807
*         DO;                       /* INITIATE THE STAGE2 SWAPIN  0808
*                                                            @Z40WPYC*/
*                                                                  0808
*           /*********************************************************/
*           /*                                                       */
*           /* PASS THE CHAIN OF PRIVATE AREA UNFIXED PCB'S TO GFA TO*/
*           /* HAVE THE FRAMES ASSIGNED AND THE I/O INITIATED        */
*           /*                                               @Z40WPYC*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0809
*           R1=R7;                  /* POINT TO FIRST PRIVATE AREA 0809
*                                      PCB                   @Z40WPYC*/
         LR    R1,R7                                               0809
*           R2=PSAAOLD->ASCBRSM;    /* GET CURRENT RSMHD PTR @Z40WPYC*/
         L     @10,PSAAOLD                                         0810
         L     R2,ASCBRSM(,@10)                                    0810
*           CALL GFA;               /* CALL GENERAL FRAME ALLOCATION
*                                                            @Z40WPYC*/
         L     @15,PVTPGFA(,PVTPTR)                                0811
         BALR  @14,@15                                             0811
*           RCACSECT=RCACSPIN;      /* RESET MODULE ID       @Z40WPYC*/
         MVI   RCACSECT(R8),X'19'                                  0812
*         END;                      /* END GFA PROCESSING    @Z40WPYC*/
*       ELSE                                                       0814
*         ;                         /* NO STAGE2 PCBS REQUIRING I/O
*                                                            @Z40WPYC*/
@RF00807 DS    0H                                                  0815
*FREELCK2:                                                         0815
*       GEN CODE REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);          0815
FREELCK2 DS    0H                                                  0815
         SETLOCK RELEASE,TYPE=SALLOC,RELATED=(RSM,IEAVSWPP(GETLOCK2))
*       RCASAL='0'B;                /* NO LONGER HOLD SALLOC @Z40WPYC*/
         NI    RCASAL(R8),B'01111111'                              0816
*     END;                          /* END STAGE2 PROCESSING @Z40WPYC*/
*   ELSE                                                           0818
*     ;                             /* NO STAGE2 PCBS TO PROCESS   0818
*                                                            @Z40WPYC*/
*                                                                  0818
@RF00775 DS    0H                                                  0819
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN THE LOCAL LOCK TO POST RCT                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0819
*SWPPRTRY:                          /* FRR RETRY ADDR        @Z40WPYC*/
*   GEN CODE REFS(PSALITA,FLC) DEFS(SIRTGET) SETS(R11,R12,R13,R14);
SWPPRTRY DS    0H                                                  0819
SIRTGET  SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                       **
               RELATED=(PSTRCT,IEAVSWIN(SIRTFREE))
*   RESPECIFY                                                      0820
*    (R10) RESTRICTED;                                             0820
*   RCALL='1'B;                     /* INDICATE LOCAL LOCK OBTAINED
*                                                            @Z40WPYC*/
         OI    RCALL(R8),B'01000000'                               0821
*   R10=0;                          /* SET POST CODE FOR POST OF RCT.
*                                                            @VS08619*/
         SLR   R10,R10                                             0822
*   R11=ADDR(ASCBQECB);             /* GET THE ADDRESS OF RCT QUIESCE
*                                      ECB FOR THE POST.     @VS08619*/
         L     R11,PSAAOLD                                         0823
         LA    R11,ASCBQECB(,R11)                                  0823
*   CALL POSTRCT;                   /* BRANCH ENTER POST TO POST THE
*                                      QUIESCE ECB           @VS08619*/
         L     @15,CVTPTR                                          0824
         L     @15,CVT0PT02(,@15)                                  0824
         BALR  @14,@15                                             0824
*   GENERATE CODE;                                                 0825
SIRTFREE SETLOCK RELEASE,TYPE=LOCAL,                                  **
               RELATED=(POSTRCT,IEAVSWIN(SIRTGET))
         SETFRR D,WRKREGS=(R11,R12)
*   R14=CVTSRBRT;                   /* GET THE DISPATCHER RETURN   0826
*                                      ADDRESS.              @VS08619*/
         L     R14,CVTPTR                                          0826
         L     R14,CVTSRBRT(,R14)                                  0826
*   GOTO R14;                       /* RETURN TO CALLER      @VS08619*/
         BR    R14                                                 0827
*   RFY                                                            0828
*    (R0,                                                          0828
*     R1,                                                          0828
*     R8,                                                          0828
*     R10,                                                         0828
*     R11,                                                         0828
*     R12,                                                         0828
*     R13,                                                         0828
*     R7) UNRESTRICTED;             /*                       @Z40WPYC*/
*   RFY                                                            0829
*     ASCB BASED(PCBRASCB);                                        0829
*SWIN:                                                             0830
*   END IEAVSWIN                    /* END SWAP IN                   */
*                                                                  0830
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAPCB  )                                       */
*/*%INCLUDE SYSLIB  (ILRAIA  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCBR )                                       */
*/*%INCLUDE SYSLIB  (IHAPFTE )                                       */
*/*%INCLUDE SYSLIB  (IHAPGTE )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IHARCA  )                                       */
*/*%INCLUDE SYSLIB  (IHARSMHD)                                       */
*/*%INCLUDE SYSLIB  (IHASGTE )                                       */
*/*%INCLUDE SYSLIB  (IHASPCT )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAXPTE )                                       */
*                                                                  0830
*       ;                                                          0830
SWIN     DS    0H                                                  0830
@DATA    DS    0H
@CH00224 DC    H'5'
         DS    0F
         DS    0F
@CF00062 DC    F'1'
@CF00925 DC    F'6'
@CH00925 EQU   @CF00925+2
@CF00055 DC    F'8'
@CF00052 DC    F'15'
@CF01288 DC    F'56'
@CF01927 DC    XL4'FF000000'
@CF02051 DC    XL4'0000FFFF'
@CF01961 DC    XL4'7FFF'
         DS    0D
@CC01994 DC    C'SRB '
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ASCBPTR  EQU   @07
PCBPTR   EQU   @05
PCBRPTR  EQU   @06
PFTEPTR  EQU   @14
PTEPTR   EQU   @14
PVTPTR   EQU   @03
RSMHDPTR EQU   @02
STEPTR   EQU   @11
SPCTPTR  EQU   @04
SWAPPTR  EQU   @11
SEGSPTR  EQU   @10
XPTEPTR  EQU   @12
R0       EQU   @00
R1       EQU   @01
MASK     EQU   @01
R2       EQU   @02
R5       EQU   @05
R7       EQU   @07
R8       EQU   @08
START    EQU   @08
ACTIVE   EQU   @08
R9       EQU   @09
R10      EQU   @10
FINISH   EQU   @10
R11      EQU   @11
R12      EQU   @12
BITMASK  EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
R3       EQU   @03
R4       EQU   @04
R6       EQU   @06
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBSTOR EQU   ASCB+44
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCB1LPU EQU   ASCBRSMF
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBNSWP EQU   ASCBFLG1
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBQECB EQU   ASCB+136
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ASXB     EQU   0
ASXBSPSA EQU   ASXB+112
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
CVTMAP   EQU   0
CVT      EQU   CVTMAP
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
PCB      EQU   0
PCBFQP   EQU   PCB
PCBCQN   EQU   PCBFQP
PCBFQPA  EQU   PCBFQP+1
PCBBQP   EQU   PCB+4
PCBBQPA  EQU   PCBBQP
PCBRTP   EQU   PCB+8
PCBFL1   EQU   PCBRTP
PCBROOT  EQU   PCBFL1
PCBRTPA  EQU   PCBRTP+1
PCBRLP   EQU   PCB+12
PCBFXC   EQU   PCBRLP
PCBXPT   EQU   PCB+16
PCBFL2   EQU   PCBXPT
PCBXPTA  EQU   PCBXPT+1
PCBPGT   EQU   PCB+20
PCBFL3   EQU   PCBPGT
PCBSWPIN EQU   PCBFL3
PCBSWPS1 EQU   PCBFL3
PCBSWPLS EQU   PCBFL3
PCBDFRLS EQU   PCBFL3
PCBSWPS2 EQU   PCBFL3
PCBPGTA  EQU   PCBPGT+1
PCBRBN   EQU   PCB+24
PCBVBN   EQU   PCB+26
PCBBLOCK EQU   PCB+28
PCBSRB   EQU   PCBBLOCK
PCBRB    EQU   PCBSRB
PCBSPCTE EQU   PCBRB
PCBASCB  EQU   PCB+32
PCBAIA   EQU   PCB+36
PCBR     EQU   0
PCBRTCB  EQU   PCBR
PCBRFLAG EQU   PCBRTCB
PCBRETRY EQU   PCBRFLAG
PCBRPB   EQU   PCBRFLAG
PCBRFAIL EQU   PCBRFLAG
PCBRGOTO EQU   PCBR+4
PCBRASCB EQU   PCBR+12
PCBRCNT  EQU   PCBR+16
PCBRWRK1 EQU   PCBR+20
PCBRWRK2 EQU   PCBR+24
PCBRWRK3 EQU   PCBR+28
PCBRWRK5 EQU   PCBR+36
PCBRWRK8 EQU   PCBR+48
PCBRWRKA EQU   PCBR+56
PFTE     EQU   0
PFTPGID  EQU   PFTE
PFTVBN   EQU   PFTPGID+2
PFTQPTRS EQU   PFTE+4
PFTFXCT  EQU   PFTE+8
PFTFLAGS EQU   PFTE+12
PFTFLAG1 EQU   PFTFLAGS
PFTFLAG2 EQU   PFTFLAGS+1
PFTDFRLS EQU   PFTFLAG2
PFTPREF  EQU   PFTFLAG2
PGTPTE   EQU   0
PGTRSA   EQU   PGTPTE
PGTBITS  EQU   PGTRSA+1
PGTPVM   EQU   PGTBITS
PGTPAM   EQU   PGTBITS
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTFLAG2 EQU   PVT+1
PVTAFC   EQU   PVT+2
PVTPFTP  EQU   PVT+12
PVTLCSA  EQU   PVT+26
PVTPRCA  EQU   PVT+52
PVTSRBID EQU   PVT+68
PVTPGFA  EQU   PVT+84
PVTPCB   EQU   PVT+104
PVTPFTE  EQU   PVT+108
PVTPFP2  EQU   PVT+116
PVTPRCV  EQU   PVT+156
PVTPSRBP EQU   PVT+188
PVTPRELF EQU   PVT+216
PVTSPIN  EQU   PVT+268
PVTNSWPS EQU   PVT+280
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
PVTWSA7  EQU   PVTWSAX+432
PVTSAVE  EQU   PVTWSAX+1328
PVTMAXFX EQU   PVT+1822
PVTDEFFX EQU   PVT+1828
PVTCNTFX EQU   PVT+1830
PVTCOMFX EQU   PVT+1834
PVTPCBQS EQU   PVT+1852
RCA      EQU   0
RCAPARM1 EQU   RCA+4
RCANAME7 EQU   RCA+8
RCACSECT EQU   RCA+9
RCAFLAGS EQU   RCA+10
RCASAL   EQU   RCAFLAGS
RCALL    EQU   RCAFLAGS
RCARCRD  EQU   RCA+11
RCANAMES EQU   RCA+12
RCANAME1 EQU   RCANAMES
RCANAME2 EQU   RCANAMES+1
RCASWPP  EQU   RCANAME2
RCANAME3 EQU   RCANAMES+2
RCANAME4 EQU   RCANAMES+3
RCASWIN  EQU   RCANAME4
RCANAME5 EQU   RCANAMES+4
RCASIRT  EQU   RCANAME5
RCANAME6 EQU   RCANAMES+5
RCARETAD EQU   RCA+20
RSMHD    EQU   0
RSMVSTO  EQU   RSMHD
RSMSPCT  EQU   RSMHD+4
RSMFLG1  EQU   RSMHD+12
RSMFAIL  EQU   RSMFLG1
RSMQS    EQU   RSMHD+20
RSMLFQ   EQU   RSMQS
RSMLSQA  EQU   RSMQS+4
RSMLIOQ  EQU   RSMQS+8
SGTSTE   EQU   0
SGTLK    EQU   SGTSTE
SGTPTO   EQU   SGTSTE+1
SGTBYTE  EQU   SGTPTO+2
SPCT     EQU   0
SPCTSWRT EQU   SPCT
SPCTFIX  EQU   SPCT+4
SPCTLSQA EQU   SPCT+6
SPCTSSEG EQU   SPCT+9
SPCTFLG1 EQU   SPCT+10
SPCTSWIN EQU   SPCTFLG1
SPCTBIG  EQU   SPCTFLG1
SPCTPSET EQU   SPCTFLG1
SPCTVROT EQU   SPCTFLG1
SPCTWSSZ EQU   SPCT+12
SPCTSWAP EQU   SPCT+16
SPCTSEGS EQU   SPCT+72
SPCTSEGE EQU   0
SPCTSEGX EQU   SPCTSEGE
SPCTPGT  EQU   SPCTSEGE+1
SPCTBITM EQU   SPCTSEGE+4
SPCTSWPE EQU   0
SPCTLS   EQU   SPCTSWPE
SPCTFLAG EQU   SPCTLS
SPCTLSQ  EQU   SPCTFLAG
SPCTCOMM EQU   SPCTFLAG
SPCTDEFR EQU   SPCTFLAG
SPCTSSID EQU   SPCTLS+1
SPCTVBN  EQU   SPCTLS+4
SPCTFIXC EQU   SPCTSWPE+6
SPCTEXTM EQU   0
SPCTEXT  EQU   SPCTEXTM
SPCTENT  EQU   SPCTEXTM+8
SPCTXEND EQU   SPCTENT+48
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBID    EQU   SRB
SRBASCB  EQU   SRB+8
SRBFLC   EQU   SRB+12
SRBEP    EQU   SRB+20
SRBRMTR  EQU   SRB+24
SRBPARM  EQU   SRB+28
WSAL     EQU   0
WSALRSM  EQU   WSAL+52
XPTE     EQU   0
XPTPROT  EQU   XPTE
XPTFLAGS EQU   XPTE+2
XPTFLAG2 EQU   XPTE+3
XPTLPID  EQU   XPTE+4
XPTLGN   EQU   XPTLPID
XPTLPN   EQU   XPTLPID+4
FINDPAGE EQU   0
PCBMGR   EQU   0
GFA      EQU   0
RELF     EQU   0
STATUS   EQU   0
POSTRCT  EQU   0
PFTENQ   EQU   0
PGTEND   EQU   0
SGTEND   EQU   0
ASXBPTR  EQU   ASCBASXB
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSRBRT EQU   CVTS01+100
CVTFRECL EQU   CVTS01+148
CVTOPTE  EQU   CVTS01+188
CVTVEAC0 EQU   CVTS01+328
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVT0PT02 EQU   CVTS01+532
CVTSSRB  EQU   CVTS01+580
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
FRRSPTR  EQU   PSACSTK
FRREPTR  EQU   FRRSCURR
RSMAIA   EQU   PCBAIA
AIA      EQU   RSMAIA
AIAFLG1  EQU   AIA+9
AIAPRIV  EQU   AIAFLG1
AIALSQA  EQU   AIAFLG1
AIAPAGDS EQU   AIAFLG1
AIASWPFX EQU   AIAFLG1
AIAFLG2  EQU   AIA+10
AIAFLG3  EQU   AIA+11
AIANXAIA EQU   AIA+12
AIAID    EQU   AIA+16
AIALPID  EQU   AIAID
AIALGID  EQU   AIALPID
AIALSID  EQU   AIALGID
AIASSID  EQU   AIALSID+1
AIARPN   EQU   AIALPID+4
AIALSID2 EQU   AIARPN
AIALPMEP EQU   AIALSID2
AIAGRPSZ EQU   AIA+24
AIALGE   EQU   AIAGRPSZ
FLC      EQU   PSA
RCAPTR   EQU   PVTPRCA
SRBPTR   EQU   PCBRWRK8
VBNPCB   EQU   PCBVBN
PCBSS    EQU   VBNPCB
VBN      EQU   VBNPCB+1
ASCBSGT  EQU   ASCBSTOR
ASCBSTO  EQU   ASCBSGT+1
FIXCT    EQU   SPCTFIXC
SPCTTFIX EQU   FIXCT
NEWPCB   EQU   PCB
PCBFLDS  EQU   NEWPCB+8
BIT      EQU   PCBFL1
PCBPREFR EQU   BIT
WORK     EQU   PCBRWRK5
LSQACOMP EQU   WORK
CALLTERM EQU   WORK
PCBRSAVE EQU   WORK+1
SAVAREA  EQU   PVTWSA7
FRRASCB  EQU   SAVAREA+64
FRRASID  EQU   SAVAREA+66
FRRRSMHD EQU   SAVAREA+68
*                                      START UNREFERENCED COMPONENTS
@NM00066 EQU   SAVAREA
@NM00065 EQU   WORK
@NM00064 EQU   BIT
@NM00063 EQU   BIT
@NM00062 EQU   NEWPCB
@NM00061 EQU   FIXCT+1
@NM00060 EQU   ASCBSGT
AIADPXCT EQU   AIALGE
AIACEPTR EQU   AIALPMEP
AIASLOT  EQU   AIASSID+1
@NM00010 EQU   AIASSID
@NM00009 EQU   AIALSID
AIARCSN  EQU   AIANXAIA+2
AIACYL   EQU   AIANXAIA
AIARSV9  EQU   AIAFLG3
AIARSV8  EQU   AIAFLG3
AIARSV7  EQU   AIAFLG3
AIALPMEC EQU   AIAFLG3
AIARSV6  EQU   AIAFLG3
AIATRPSP EQU   AIAFLG3
AIAPRINO EQU   AIAFLG3
AIARSV5  EQU   AIAFLG3
AIABADID EQU   AIAFLG2
AIAERROR EQU   AIAFLG2
AIASECER EQU   AIAFLG2
AIAPRIER EQU   AIAFLG2
AIARSV4  EQU   AIAFLG2
AIAIORTY EQU   AIAFLG2
AIATERMR EQU   AIAFLG2
AIAFRAUX EQU   AIAFLG2
AIARSV1  EQU   AIAFLG1
AIADUPLX EQU   AIAFLG1
AIAVIO   EQU   AIAFLG1
AIAWRITE EQU   AIAFLG1
AIAOP    EQU   AIA+8
AIABQPA  EQU   AIA+4
AIAFQPA  EQU   AIA
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
XPTLSID2 EQU   XPTLPN
XPTLSID  EQU   XPTLGN
@NM00059 EQU   XPTFLAG2
XPTIOERR EQU   XPTFLAG2
XPTPOINP EQU   XPTFLAG2
XPTRES1  EQU   XPTFLAG2
XPTVALID EQU   XPTFLAG2
XPTRSV4  EQU   XPTFLAGS
XPTDEFER EQU   XPTFLAGS
XPTRES2  EQU   XPTFLAGS
XPTVIO   EQU   XPTFLAGS
@NM00058 EQU   XPTFLAGS
XPTCKF   EQU   XPTFLAGS
XPTXAV   EQU   XPTFLAGS
XPTVIOLP EQU   XPTFLAGS
XPTRSV1  EQU   XPTE+1
WSALACHP EQU   WSAL+56
WSALEVNT EQU   WSAL+48
WSALSTAE EQU   WSAL+44
WSALSTAT EQU   WSAL+40
WSALWAIT EQU   WSAL+36
WSALPOST EQU   WSAL+32
WSALEXIT EQU   WSAL+28
WSALS2EE EQU   WSAL+24
WSALCIRB EQU   WSAL+20
WSALABTM EQU   WSAL+16
WSALSDMP EQU   WSAL+12
WSALRTM2 EQU   WSAL+8
WSALVALC EQU   WSAL+4
WSALCWSA EQU   WSAL
@NM00057 EQU   SRB+40
@NM00056 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBFLNK  EQU   SRB+4
SPCTENTS EQU   SPCTENT
@NM00055 EQU   SPCTEXTM+4
@NM00054 EQU   SPCTFLAG
SPCTLVAL EQU   SPCTFLAG
SPCTSIZE EQU   SPCT+14
SPCTIDEN EQU   SPCT+11
@NM00053 EQU   SPCTFLG1
SPCTPURG EQU   SPCTFLG1
SPCTOUT  EQU   SPCTFLG1
SPCTNSEG EQU   SPCT+8
SGTPAM   EQU   SGTBYTE
SGTEAC   EQU   SGTBYTE
@NM00052 EQU   SGTBYTE
@NM00051 EQU   SGTBYTE
@NM00050 EQU   SGTBYTE
@NM00049 EQU   SGTBYTE
@NM00048 EQU   SGTBYTE
SGTORG   EQU   SGTPTO
SGTKEY   EQU   SGTLK
SGTPTL   EQU   SGTLK
RSMASMHD EQU   RSMHD+40
RSMFOEQ  EQU   RSMHD+36
RSMLIOQL EQU   RSMLIOQ+4
RSMLIOQF EQU   RSMLIOQ
RSMLSQAL EQU   RSMLSQA+2
RSMLSQAF EQU   RSMLSQA
RSMLFQL  EQU   RSMLFQ+2
RSMLFQF  EQU   RSMLFQ
RSMRSV2  EQU   RSMHD+16
RSMCNTFX EQU   RSMHD+14
RSMRSV1  EQU   RSMHD+13
@NM00047 EQU   RSMFLG1
RSMGFADD EQU   RSMFLG1
RSMCPNC  EQU   RSMFLG1
RSMCPNU  EQU   RSMFLG1
RSMGFAD  EQU   RSMFLG1
RSMIOCPC EQU   RSMFLG1
RSMIOCPU EQU   RSMFLG1
RSMASCB  EQU   RSMHD+8
RCATASID EQU   RCA+18
RCAREP1  EQU   RCANAME6
RCAPSIF  EQU   RCANAME6
RCAPSIX  EQU   RCANAME6
RCAVEQRP EQU   RCANAME6
RCARCFC  EQU   RCANAME6
RCACSGB  EQU   RCANAME6
RCAFXL   EQU   RCANAME6
RCAPS113 EQU   RCANAME6
RCAFREE  EQU   RCANAME5
RCARFR2  EQU   RCANAME5
RCACPBR  EQU   RCANAME5
RCAOPBR  EQU   RCANAME5
RCASORT  EQU   RCANAME5
RCARELV  EQU   RCANAME5
RCARELF  EQU   RCANAME5
RCAGFAD  EQU   RCANAME4
RCAVEQRI EQU   RCANAME4
RCAVEQRF EQU   RCANAME4
RCAVEQRC EQU   RCANAME4
RCATERM  EQU   RCANAME4
RCASQA   EQU   RCANAME4
RCASOUT  EQU   RCANAME4
RCARFR   EQU   RCANAME3
RCARELS  EQU   RCANAME3
RCARCFI  EQU   RCANAME3
RCARCF   EQU   RCANAME3
RCAPSII  EQU   RCANAME3
RCAPSIB  EQU   RCANAME3
RCAPS112 EQU   RCANAME3
RCAPIX   EQU   RCANAME3
RCAPIOP  EQU   RCANAME2
RCASWPC  EQU   RCANAME2
RCAPFTE  EQU   RCANAME2
RCAPCB   EQU   RCANAME2
RCAOUT   EQU   RCANAME2
RCAITAS  EQU   RCANAME2
RCAIOCP  EQU   RCANAME2
RCAINV   EQU   RCANAME1
RCAGFA   EQU   RCANAME1
RCAFXLD  EQU   RCANAME1
RCAVEQR  EQU   RCANAME1
RCADSEG  EQU   RCANAME1
RCADLAS  EQU   RCANAME1
RCACSEG  EQU   RCANAME1
RCAVAMSI EQU   RCANAME1
@NM00046 EQU   RCAFLAGS
RCADISP  EQU   RCAFLAGS
@NM00045 EQU   RCAFLAGS
RCAQS    EQU   RCAFLAGS
RCAPSIER EQU   RCAFLAGS
RCAABEND EQU   RCAFLAGS
@NM00044 EQU   RCANAME7
RCAPRSS  EQU   RCANAME7
RCAPRSR  EQU   RCANAME7
RCAPRSB  EQU   RCANAME7
RCAPSIY  EQU   RCANAME7
RCAPIOI  EQU   RCANAME7
RCAPARM0 EQU   RCA
PVTEND   EQU   PVT+1944
PVTTASID EQU   PVT+1942
PVTXXXXX EQU   PVT+1940
PVTMVCLC EQU   PVT+1936
PVTVCONS EQU   PVT+1896
PVTPRSB  EQU   PVT+1892
PVTCIOQL EQU   PVTPCBQS+36
PVTCIOQF EQU   PVTPCBQS+32
PVTGFADL EQU   PVTPCBQS+28
PVTGFADF EQU   PVTPCBQS+24
PVTFPCBL EQU   PVTPCBQS+20
PVTFPCBF EQU   PVTPCBQS+16
PVTPCBQR EQU   PVTPCBQS
PVTLPAFX EQU   PVT+1850
PVTLSQAF EQU   PVT+1848
PVTLPAR  EQU   PVT+1844
PVTLPAI  EQU   PVT+1840
PVTLPAFC EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTSQAFX EQU   PVT+1832
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTPFTQR EQU   PVTQS+20
PVTRSBQL EQU   PVTQS+18
PVTRSBQF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTPRSET EQU   PVT+244
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPOPBR EQU   PVT+220
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPINV  EQU   PVT+172
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP   EQU   PVT+112
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPSQA  EQU   PVT+80
PVTPSINT EQU   PVT+76
PVTPSIB  EQU   PVT+72
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTREUS  EQU   PVT+48
PVTSQNPC EQU   PVT+47
PVTSQVRC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTPCBLO EQU   PVT+38
PVTPCBCT EQU   PVT+36
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLPRIV EQU   PVT+24
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
@NM00043 EQU   PVTFLAG2
PVTRSMGM EQU   PVTFLAG2
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTAPREF EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
@NM00018 EQU   PGTBITS
@NM00017 EQU   PGTBITS
@NM00016 EQU   PGTBITS
@NM00015 EQU   PGTBITS
@NM00014 EQU   PGTBITS
@NM00013 EQU   PGTBITS
PGTREAL  EQU   PGTRSA
PFTUIC   EQU   PFTE+15
PFTQNDX  EQU   PFTE+14
@NM00012 EQU   PFTFLAG2
@NM00011 EQU   PFTFLAG2
PFTSTEAL EQU   PFTFLAG2
PFTIRRG  EQU   PFTFLAG2
PFTVR    EQU   PFTFLAG2
PFTOFFLN EQU   PFTFLAG2
PFTOFINT EQU   PFTFLAG1
PFTVRALC EQU   PFTFLAG1
PFTBADPG EQU   PFTFLAG1
PFTPCBSI EQU   PFTFLAG1
PFTVRPLT EQU   PFTFLAG1
PFTLSQA  EQU   PFTFLAG1
PFTVRINT EQU   PFTFLAG1
PFTONAVQ EQU   PFTFLAG1
PFTRSV1  EQU   PFTE+10
PFTBQPTR EQU   PFTQPTRS+2
PFTFQPTR EQU   PFTQPTRS
PFTASID  EQU   PFTPGID
PCBRWRKB EQU   PCBR+60
PCBRWRK9 EQU   PCBR+52
PCBRWRK7 EQU   PCBR+44
PCBRWRK6 EQU   PCBR+40
PCBRWRK4 EQU   PCBR+32
PCBRRSV1 EQU   PCBR+18
PCBRECB  EQU   PCBR+8
PCBRTCBA EQU   PCBRTCB+1
PCBRPOF  EQU   PCBRFLAG
PCBRFECB EQU   PCBRFLAG
PCBRLOAD EQU   PCBRFLAG
PCBRFPCB EQU   PCBRFLAG
PCBRINT  EQU   PCBRFLAG
PCBEND   EQU   PCB+64
@NM00008 EQU   PCBFL3
PCBNOREC EQU   PCBFL3
PCBSWPOT EQU   PCBFL3
@NM00007 EQU   PCBFL2
@NM00006 EQU   PCBFL2
PCBVIO   EQU   PCBFL2
PCBSUPRS EQU   PCBFL2
PCBRESET EQU   PCBFL2
PCBIOERR EQU   PCBFL2
PCBGFAD  EQU   PCBFL2
PCBFREAL EQU   PCBFL2
PCBRLPA  EQU   PCBRLP+1
PCBIOCMP EQU   PCBFL1
PCBIOI   EQU   PCBFL1
PCBLFR   EQU   PCBFL1
PCBLLHLD EQU   PCBFL1
PCBSRBMD EQU   PCBFL1
PCBPEX   EQU   PCBFL1
@NM00005 EQU   PCBFL1
@NM00004 EQU   FRRSFLGS+1
@NM00003 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00042 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00041 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00040 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00039 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00038 EQU   FLCFSA
@NM00037 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00036 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00035 EQU   FLCIOA
@NM00034 EQU   FLCMCLA+15
@NM00033 EQU   FLCMCLA+14
@NM00032 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00031 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00030 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00029 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00028 EQU   FLCPER
@NM00027 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00026 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00025 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00024 EQU   FLCPIILC
@NM00023 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00022 EQU   FLCSVILC
@NM00021 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00020 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00019 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RF00207 EQU   @RC00196
@RT00211 EQU   SWINCOM1
@RT00357 EQU   SWINGFA
@RT00407 EQU   SIRTERR0
@RT00411 EQU   REBUILD
@RT00448 EQU   SIRTPCBF
@RF00473 EQU   SIRTPCB2
@RT00482 EQU   SIRTERR
@RT00508 EQU   SIRTERR0
C0D      EQU   @EL00002
@RC00581 EQU   @RC00575
SPCB     EQU   @EL00003
@RT00658 EQU   SWAPDECR
@RF00658 EQU   SWAPCOMM
@RT00667 EQU   SWAPCOMM
@RT00671 EQU   SWAPCOMM
@RT00704 EQU   SWAPCOMM
@RC00654 EQU   @RC00647
@RT00715 EQU   SWAPCOMM
@RT00717 EQU   SWAPCOMM
FIX      EQU   @EL00004
RTM      EQU   @EL00005
@ENDDATA EQU   *
         END   IEAVSWIN,(C'PLS2104',0701,78164)
