         TITLE 'IEAVTACR                                               *
                        '
IEAVTACR CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(15)                                             0001
         DC    C'IEAVTACR 77129 '                                  0001
         DROP  @15
@PROLOG  BALR  @05,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@05                                         0001
*   DO;                                                            0170
*                                                                  0170
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME   ACRINIT1                                      */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     ACR INITIALIZATION SEGMENT FOR ALL ENTRIES VIA CALLRTM       */
*/*                                                                  */
*/* 02* INPUT= ENTCDREG(REG 0) - ENTRY TYPE - IDENTIFIER CODE        */
*/*                            * TYPE=ACR           8                */
*/*                            * TYPE=ACRLM         4                */
*/*                            * TYPE=ACRDISP       2                */
*/*            LRBPTR (REG 1) - ENTRY TYPE  -    CONTENTS            */
*/*                           * TYPE=ACR       LOGREC BUFFER ADDRESS */
*/*                           * TYPE=ACRLM     UNKNOWN               */
*/*                           * TYPE=ACRDISP   UNKNOWN               */
*/*            IHRETPTR(REG 2) - ENTRY TYPE  -    CONTENTS           */
*/*                           * TYPE=ACR ONLY  RETURN PT             */
*/*            R14 (REG 14) -  ENTRY TYPE                            */
*/*                           * TYPE=ACRLM AND ACRDISP -RETURN PT    */
*/*                                                                  */
*/* 02* OUTPUT= PSAPTR (REG 4) - CURRENT PSA ADDRESS (BASED ZERO)    */
*/*             RRPLPTR (REG 6) - RECOVERY RTN PARM LIST ADDRESS     */
*/*             LCCAPTR (REG 10) - CURRENT LCCA ADDRESS              */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0171
*ACRSTART:                                                         0171
*     R4=0;                         /* SET BASE FOR PSA              */
ACRSTART SLR   R4,R4                                               0171
*     R10=PSALCCAV;                 /* INITIALIZE CURRENT LCCA BASE  */
         L     R10,PSALCCAV(,R4)                                   0172
*     LCCACREX=R0;                  /* SET THE ACR ENTRY FLAGS       */
         STC   R0,LCCACREX(,R10)                                   0173
*     RESPECIFY                                                    0174
*      (R6) RSTD;                                                  0174
*     R6=ADDR(ACRRRPL);             /* SET THE RECOVERY PARM ADDRESS */
         L     @15,LCCACPUS(,R10)                                  0175
         L     @15,WSACACR(,@15)                                   0175
         LA    R6,ACRRRPL(,@15)                                    0175
*     IF LCCACRIN='1'B THEN         /* IS THIS PRE-PROCESSING        */
         TM    LCCACRIN(R10),B'00001000'                           0176
         BNO   @RF00176                                            0176
*       DO;                         /* YES, PRE-PROCESSING           */
*         ACRRRPLP=R6;              /* YES, SET RRPL ADDR IN CURRENT
*                                      CPUS ACRSA                    */
         ST    R6,ACRRRPLP(,@15)                                   0178
*         ACRENTR1=R1;              /* TEMP SAVE AREA FOR LRB        */
         ST    R1,ACRENTR1(,@15)                                   0179
*       END;                                                       0180
*     ELSE                          /* NOT PRE-PROCESSING PHASE      */
*       LCCARCPU->LCCACPUS->WSACACR->ACRRRPLP=R6;/* SET RRPL ADDR IN
*                                      RECOVERY CPUS ACRSA           */
         B     @RC00176                                            0181
@RF00176 L     @15,LCCARCPU(,R10)                                  0181
         L     @15,LCCACPUS(,@15)                                  0181
         L     @15,WSACACR(,@15)                                   0181
         ST    R6,ACRRRPLP(,@15)                                   0181
*     RRPL=''B;                     /* CLEAR THE RRPL                */
@RC00176 XC    RRPL(64,R6),RRPL(R6)                                0182
*     GEN REFS(RRPLREGS)(STM 0,14,RRPLREGS(R6));/* SAVE REGS FOR   0183
*                                      RECURSION                     */
         STM 0,14,RRPLREGS(R6)
*     PSAACR='1'B;                  /* SET ACR SUPER BIT TO CAUSE RTM
*                                      TO DIRECT BRANCH TO ACR     0184
*                                      RECOVERY ROUTINE              */
         OI    PSAACR(R4),B'00000100'                              0184
*     RESPECIFY                                                    0185
*      (R0,                                                        0185
*       R1,                                                        0185
*       R2,                                                        0185
*       R14) UNRESTRICTED;                                         0185
*                                                                  0185
*/* ******************************************************************/
*/*  END OF  INITIALIZATION SEGMENT - ACRINIT1                       */
*/* ******************************************************************/
*                                                                  0186
*   END;                                                           0186
*RSTRT00:                           /* RETRY ENTRY FOR LOGICAL PHASE
*                                      IDS (00,01,02,03,04)          */
*   R10->LCCACPUS->WSACACR->ACRRTNPT=RRPLRRGS(14+1);/* SAVE LOCK MGR
*                                      AND SPIN RETURN POINT (REG 14
*                                      ON ENTRY)                     */
RSTRT00  L     @12,LCCACPUS(,R10)                                  0187
         L     @12,WSACACR(,@12)                                   0187
         L     @08,RRPLRRGS+56(,R6)                                0187
         ST    @08,ACRRTNPT(,@12)                                  0187
*   IF LCCACRIN='1'B THEN           /* IS ENTRY FROM THE EMS OR MFA
*                                      SLIH?                         */
         TM    LCCACRIN(R10),B'00001000'                           0188
         BNO   @RF00188                                            0188
*     DO;                                                          0189
*       R10->LCCACPUS->WSACACR->ACRRTNPT=RRPLRRGS(2+1);/* IN THE CASE
*                                      OF SLIH ENTRY SAVE REG 2 FOR
*                                      THE RETURN POINT              */
         L     @08,RRPLRRGS+8(,R6)                                 0190
         ST    @08,ACRRTNPT(,@12)                                  0190
*/* ******************************************************************/
*/* ******************************************************************/
*/* *********************    ACR PRE-PROCESSING     ******************/
*/* ******************************************************************/
*/* ******************************************************************/
*                                                                  0191
*       DO;                         /* EMS/MFA SLIH ENTRY            */
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRPREP                                        */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THE ACR PREPROCESSOR PHASE IS ENTERED VIA THE MFA OR EMS     */
*/*     EXTERNAL SLIH AS A RESULT OF A CPU MALFUNCTION.  REGISTER 1  */
*/*     CONTAINS THE LOGREC BUFFER ADDRESS ASSOCIATED WITH THE DEAD  */
*/*     CPU'S FAILURE.  THE ACR PREPROCESSOR IS AN EXTERNAL INTERRUPT*/
*/*     ROUTINE WHICH WILL MAKE THE ACR CONDITION KNOWN TO THE SYSTEM*/
*/*     AND PRESERVE THE NECESSARY DATA FOR ACR RECOVERY DURING LATER*/
*/*     PROCESSING.  THIS PHASE WILL RETURN CONTROL TO THE EMS SLIH, */
*/*     OR TO THE EXTERNAL FLIH IN CASES OF AN MFA.  WHEN THE        */
*/*     INTERRUPTED PROCESS RELINQUISHES CONTROL AGAIN, EITHER ON ITS*/
*/*     OWN ACCORD, OR DUE TO SOME CONTROL PROGRAM ACTION, ACR'S     */
*/*     INTERMEDIATE PROCESSING WILL GAIN CONTROL TO INITIATE SYSTEM */
*/*     RECOVERY.                                                    */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*                                                                  */
*/* 02* OUTPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO         */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            PSAPTR2 (REG 9) -  ADDR OF THE DEAD PSA               */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            LCCAPTR2 (REG 11) - ADDR OF THE DEAD LCCA             */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0192
*         DO;                                                      0192
*                                                                  0192
*           /*********************************************************/
*           /*                                                       */
*           /* RECOVERY NOTE: POSSIBLE PHASE IDS AT THIS POINT ARE   */
*           /* (00,01). AN ERROR IN THIS PHASE IS RETRIED AT LABEL   */
*           /* RSTRT00.                                              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0193
*           IF LOGPHID<'01'X THEN   /* IS ENTRY DUE TO A RETRY FOR AN
*                                      ERROR IN THIS PHASE           */
         CLI   LOGPHID(R6),X'01'                                   0193
         BNL   @RF00193                                            0193
*             RRPLFLGS='0'B;        /* NO,RESET ANY PREVIOUS PHASE 0194
*                                      ERROR INDICATIONS             */
         MVI   RRPLFLGS(R6),B'00000000'                            0194
*           LOGPHID='01'X;          /* SET LOGICAL PHASE ID 01       */
@RF00193 MVI   LOGPHID(R6),X'01'                                   0195
*         END;                                                     0196
*                                                                  0196
*         /***********************************************************/
*         /*                                                         */
*         /* SET THE DEAD CPU OFFLINE TO THE SYSTEM                  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0197
*         RESPECIFY                                                0197
*          (CSD) BASED(R7);         /* TEMP BASE FOR CSD             */
*         RESPECIFY                                                0198
*          (R7) RSTD;                                              0198
*         R7=CVTCSD;                /* SET CSD ADDR IN CSDPTR        */
         L     @12,CVTPTR(,R4)                                     0199
         L     R7,CVTCSD(,@12)                                     0199
*         IF RRPLOL='0'B            /* HAS THE CPU ALREADY BEEN    0200
*                                      MARKED NOT ALIVE BY ACR?      */
*           THEN                                                   0200
         TM    RRPLOL(R6),B'01000000'                              0200
         BNZ   @RF00200                                            0200
*           DO;                     /* NO, MARK THE CPU DEAD         */
*             RESPECIFY                                            0202
*              (R2,                                                0202
*               R3) RSTD;                                          0202
*                                                                  0202
*             /*******************************************************/
*             /*                                                     */
*             /* PREVENT FURTHER JOB SCHEDULING TO THE DEAD CPU      */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0203
*             R2=SKEDMSK;           /* PICK UP THE CURR JS MASK      */
         L     R2,SKEDMSK(,R7)                                     0203
*SWAPSKED:                          /* RETRY PT IF CS FAILS          */
*             SWAPWORD='FFFFFFFF'X; /* SET ALL BITS ON IN WORD       */
SWAPSKED L     @12,LCCACPUS(,R10)                                  0204
         L     @12,WSACACR(,@12)                                   0204
         MVC   SWAPWORD(4,@12),@CF03111                            0204
*             SWAPJS=SWAPJS&&BITS(PSASPAD+1);/* TURN OFF THE DEAD CPU
*                                      BIT                           */
         LH    @08,PSASPAD(,R4)                                    0205
         ALR   @08,@08                                             0205
         LA    @01,BITS(@08)                                       0205
         XC    SWAPJS(2,@12),0(@01)                                0205
*             R3=SWAPWORD&R2;       /* BLD NEW MSK LESS DEAD CPU     */
         L     R3,SWAPWORD(,@12)                                   0206
         NR    R3,R2                                               0206
*             CS(R2,R3,SKEDMSK);    /* CHANGE THE CSD JS MASK        */
         CS    R2,@03,SKEDMSK(R7)                                  0207
*             BC(7,SWAPSKED);       /* MASK CHANGED BEFORE SWAP      */
*                                                                  0208
         BC    7,SWAPSKED                                          0208
*             /*******************************************************/
*             /*                                                     */
*             /* PREVENT FURTHER SYSTEM REFERENCE TO THE DEAD CPU    */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0209
*             R2=ALIVEMSK;          /* PICK UP CURR ALIVE MASK       */
         L     R2,ALIVEMSK(,R7)                                    0209
*SWAPALIV:                          /* RETRY PT IF CS FAILS          */
*             SWAPWORD='FFFFFFFF'X; /* SET ALL BITS ON IN SWAPWORD   */
SWAPALIV L     @12,LCCACPUS(,R10)                                  0210
         L     @12,WSACACR(,@12)                                   0210
         MVC   SWAPWORD(4,@12),@CF03111                            0210
*             SWAPAL=SWAPAL&&BITS(PSASPAD+1);/* RESET THE DEAD CPU'S
*                                      ALIVE MASK INDICATOR          */
         LH    @08,PSASPAD(,R4)                                    0211
         ALR   @08,@08                                             0211
         LA    @01,BITS(@08)                                       0211
         XC    SWAPAL(2,@12),0(@01)                                0211
*             SWAPWORD=SWAPWORD&R2; /* CHANGE MASK FOR COMP&SWAP     */
         L     @08,SWAPWORD(,@12)                                  0212
         NR    @08,R2                                              0212
         ST    @08,SWAPWORD(,@12)                                  0212
*             SWAPOL=R2-1;          /* DECREMENT THE ONLINE CPU CT   */
         LR    @08,R2                                              0213
         BCTR  @08,0                                               0213
         STH   @08,SWAPOL(,@12)                                    0213
*             R3=SWAPWORD;          /* LOAD SWAP REGISTER            */
         L     R3,SWAPWORD(,@12)                                   0214
*             CS(R2,R3,ALIVEMSK);   /* CHANGE THE CSD ALIVE MSK      */
         CS    R2,@03,ALIVEMSK(R7)                                 0215
*             BC(7,SWAPALIV);       /* MASK CHANGED BEFORE SWAP      */
         BC    7,SWAPALIV                                          0216
*             RRPLOL='1'B;          /* SET CT UPDATED BIT FOR FRR    */
         OI    RRPLOL(R6),B'01000000'                              0217
*             RESPECIFY                                            0218
*              (R2,                                                0218
*               R3) UNRSTD;                                        0218
*           END;                                                   0219
*                                                                  0219
*         /***********************************************************/
*         /*                                                         */
*         /* OBTAIN THE DEAD CPU'S SYSTEM CONTROL BLOCKS             */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0220
*         R9=PCCAT00P(PSASPAD+1)->PCCAPSAV;/* GET THE DEAD PSA ADDR  */
@RF00200 LH    @12,PSASPAD(,R4)                                    0220
         SLA   @12,2                                               0220
         L     @01,CVTPTR(,R4)                                     0220
         L     @01,CVTPCCAT(,@01)                                  0220
         L     @12,PCCAT00P(@12,@01)                               0220
         L     R9,PCCAPSAV(,@12)                                   0220
*         R11=R9->PSALCCAV;         /* GET THE DEAD LCCA ADDRESS     */
*                                                                  0221
         L     R11,PSALCCAV(,R9)                                   0221
*         /***********************************************************/
*         /*                                                         */
*         /* SET THE SYSTEM ACR IN PROGRESS INDICATOR IN THE CSD     */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0222
*         IF RRPLCSD='0'B THEN      /* HAS ACR ALREADY SET SYSTEM ACR
*                                      INDICATOR BYTE                */
         TM    RRPLCSD(R6),B'00100000'                             0222
         BNZ   @RF00222                                            0222
*           DO;                     /* NO                            */
*             R9->PSAPCCAV->PCCARMS='0'B;/* MARK RMS EMS RECEIVED    */
         L     @12,PSAPCCAV(,R9)                                   0224
         NI    PCCARMS(@12),B'11111110'                            0224
*             TS(CSDACR);           /* TEST AND SET THE SYSTEM ACR 0225
*                                      INDICATION                    */
         TS    CSDACR(R7)                                          0225
*             BC(7,STERM);          /* IF ACR IS ALREADY IN PROG-  0226
*                                      RESS WITHIN THE 'SYSTEM',   0226
*                                      TERMINATE THE 'SYSTEM'        */
         BC    7,STERM                                             0226
*             RRPLCSD='1'B;         /* SET THE ACR SET BIT FOR FRR   */
         OI    RRPLCSD(R6),B'00100000'                             0227
*           END;                                                   0228
*         RESPECIFY                                                0229
*          (CSD) BASED(CVTCSD);                                    0229
@RF00222 DS    0H                                                  0230
*         RESPECIFY                                                0230
*          (R7) UNRSTD;                                            0230
*                                                                  0230
*         /***********************************************************/
*         /*                                                         */
*         /* INITIALIZE THE LCCA ACR FIELDS OF THE RECOVERY CPU      */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0231
*         LCCARCPU=R10;             /* SET THE RECOVERING CPU FIELD
*                                      IN THE RECOVERY CPU'S LCCA    */
         ST    R10,LCCARCPU(,R10)                                  0231
*         LCCADCPU=R11;             /* SET THE 'DEAD' CPU FIELD IN 0232
*                                      THE RECOVER CPU'S LCCA        */
         ST    R11,LCCADCPU(,R10)                                  0232
*         LCCACRFL=LCCACRFL&'01'X;  /* CLEAR THE ACR FLAGS IN THE  0233
*                                      RECOVERY CPU LCCA             */
         NI    LCCACRFL(R10),X'01'                                 0233
*         LCCAACR='1'B;             /* SET THE ACR IN PROGRESS FLAG
*                                      IN THE RECOVERY LCCA          */
*                                                                  0234
         OI    LCCAACR(R10),B'10000000'                            0234
*         /***********************************************************/
*         /*                                                         */
*         /* INITIALIZE THE LCCA ACR FIELDS OF THE DEAD CPU'S LCCA   */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0235
*         R11->LCCARCPU=R10;        /* SET THE RECOVERING CPU FIELD
*                                      IN THE DEAD CPU'S LCCA        */
         ST    R10,LCCARCPU(,R11)                                  0235
*         R11->LCCADCPU=R11;        /* SET THE 'DEAD' CPU FIELD IN 0236
*                                      THE DEAD CPU'S LCCA           */
         ST    R11,LCCADCPU(,R11)                                  0236
*         R11->LCCACREX=LCCACREX;   /* PROPAGATE THE ENTRY FLAGS     */
         MVC   LCCACREX(1,R11),LCCACREX(R10)                       0237
*         R11->LCCACRFL=LCCACRFL;   /* CLEAR THE ACR FLAGS IN THE  0238
*                                      DEAD CPU'S LCCA               */
         MVC   LCCACRFL(1,R11),LCCACRFL(R10)                       0238
*         R11->LCCAACR='1'B;        /* SET ACR IN PROGRESS FLAG IN 0239
*                                      THE DEAD CPU'S LCCA           */
*                                                                  0239
         OI    LCCAACR(R11),B'10000000'                            0239
*         /***********************************************************/
*         /*                                                         */
*         /* SAVE THE MACHINE CHECK LOGREC ERROR BUFFER PASSED AS    */
*         /* INPUT                                                   */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0240
*         R11->LCCACPUS->WSACACR->ACRMCHEB=LCCACPUS->WSACACR->ACRENTR1;
*                                                                  0240
         L     @12,LCCACPUS(,R11)                                  0240
         L     @12,WSACACR(,@12)                                   0240
         L     @08,LCCACPUS(,R10)                                  0240
         L     @08,WSACACR(,@08)                                   0240
         L     @07,ACRENTR1(,@08)                                  0240
         ST    @07,ACRMCHEB(,@12)                                  0240
*         /***********************************************************/
*         /*                                                         */
*         /* OBTAIN THE DEAD CPU'S PSA ENVIRONMENT AT TIME OF ERROR  */
*         /* AND SAVE IT IN THE CPU RELATED ACR WORK SAVE AREA OF THE*/
*         /* DEAD CPU                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0241
*         RESPECIFY                                                0241
*          (R13) RSTD;                                             0241
*         R13=WSACACR;              /* SET ACR SAVE AREA ADDRESS     */
         LR    R13,@08                                             0242
*         CALL ACRPROSW;                                           0243
         BAL   @14,ACRPROSW                                        0243
*         RESPECIFY                                                0244
*          (R13) UNRSTD;                                           0244
*                                                                  0244
*         /***********************************************************/
*         /*                                                         */
*         /* SET THE RETURN PATH TO THE EXTERNAL FLIH OR SLIH        */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0245
*         LCCACREF='1'B;            /* SET THE EXTERNAL EXIT FLAG    */
         OI    LCCACREF(R10),B'10000000'                           0245
*STERM:                                                            0246
*                                                                  0246
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SECTION WILL ROUTE CONTROL TO THE SYSTEM           */
*         /* TERMINATION ROUTINE IF ACR HAS DETECTED A CONDITION     */
*         /* WHERE ANOTHER ACR PROCESS IS ALREADY IN PROGRESS WHEN AN*/
*         /* MFA OR EMS WAS RECEIVED TO INITIATE ACR RECOVERY FOR A  */
*         /* CPU.                                                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0246
*         IF LCCACREF='0'B THEN     /* IS THE EXTERNAL EXIT FLG SET  */
STERM    TM    LCCACREF(R10),B'10000000'                           0246
         BNZ   @RF00246                                            0246
*           DO;                     /* EXTERNAL EXIT FLAG NOT SET    */
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRSTERM                                       */
*/*                                                                  */
*/* 02*  FUNCTION:                                                   */
*/*     ACR SYSTEM TERMINATION INTERFACE ROUTINE - PREPARES THE      */
*/*     NECESSARY INTERFACE TO THE SYSTEM TERMINATION FACILITY.  IT  */
*/*     BUILDS THE WTO MESSAGE AND A TWO WORD PARAMETER LIST.  WORD 1*/
*/*     OF THE PARAMETER LIST CONTAINS THE REAL ADDRESS OF THE MSG   */
*/*     AREA, WORD 2 CONTAINS THE REAL ADDRESS OF THE LOGREC BUFFER  */
*/*     PASSED TO ACR BY RMS.  THIS ROUTINE WILL ALSO PLACE THE WAIT */
*/*     STATE CODE OF 050 INTO THE LOGREC BUFFER TO BE USED BY THE   */
*/*     SYSTEM TERMINATION FACILITY WAIT STATE.                      */
*/*                                                                  */
*/* 02* INPUT= RRPLPTR (REG 6) - RRPL PARAMETER LIST ADDRESS         */
*/*            PSAPTR  (REG 4) - RECOVERY CPU PSA PTR                */
*/*            PSAPTR2 (REG 9) - DEAD CPU PSA PTR                    */
*/*            LCCAPTR (REG 10) - RECOVERY CPU LCCA ADDRESS          */
*/*            LCCAPTR2 (REG 11) - DEAD CPU LCCA ADDRESS             */
*/*                                                                  */
*/* 02* USAGE= WPLPTR (REG 8),WRKPTR (REG 7)                         */
*/*                                                                  */
*/* 02* OUTPUT= SYSTEM TERMINATION PARAMETER LIST ADDRESS (REAL)HAS  */
*/*             BEEN PLACED IN THE RRPL FOR THE EXIT PROCESSOR       */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0248
*             RESPECIFY                                            0248
*              (R8,                                                0248
*               R7,                                                0248
*               R1,                                                0248
*               R2) RESTRICTED;                                    0248
*                                                                  0248
*             /*******************************************************/
*             /*                                                     */
*             /* SET WAIT STATE CODE 050 IN THE LOGREC BUFFER FOR    */
*             /* SYSTERM                                             */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0249
*             R1=LCCACPUS->WSACACR->ACRENTR1;/* GET LOGREC BUFFER  0249
*                                      ADDR                          */
         L     @12,LCCACPUS(,R10)                                  0249
         L     @12,WSACACR(,@12)                                   0249
         L     R1,ACRENTR1(,@12)                                   0249
*             LRBMWSC=COD050;       /* PLACE WAIT CODE IN LRB        */
         MVC   LRBMWSC(4,R1),@CF02839                              0250
*             LRBHTYPE='81'X;       /* INDICATE SYSTEM TERMINATION 0251
*                                      RECORD TYPE           @YM04283*/
*                                                                  0251
         MVI   LRBHTYPE(R1),X'81'                                  0251
*             /*******************************************************/
*             /*                                                     */
*             /* BUILD THE OUTPUT MESSAGE -- IEA856W                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0252
*             R8=R11->LCCACPUS->WSACACR;/* SET DEAD CPU ACRSA BASE   */
         L     @12,LCCACPUS(,R11)                                  0252
         L     R8,WSACACR(,@12)                                    0252
*             R7=ADDR(R8->ACRACRWA);/* POINT TO PARM LIST AREA       */
         LA    R7,ACRACRWA(,R8)                                    0253
*             R8->TXT856W(1:LENGTH(MSG856W))=MSG856W;/* MOVE MSG     */
         MVC   TXT856W(49,R8),MSG856W                              0254
*             R2=PSASPAD;           /* GET DEAD CPU ADDRESS          */
         LH    R2,PSASPAD(,R4)                                     0255
*             GENERATE REFS(R2,CVDDWD,R7);                         0256
    CVD R2,CVDDWD(R7)             CONVERT DEAD CPU ADDRESS
*             UNPK(R8->CPUADDRZ,CVDDWD(7:8));/* DEAD CPU ADDR TO MSG */
         UNPK  CPUADDRZ(2,R8),CVDDWD+6(2,R7)                       0257
*             R8->CPUADDRZ(2)=R8->CPUADDRZ(2)|'F0'X;/* MAKE PRINTABLE*/
*                                                                  0258
         OI    CPUADDRZ+1(R8),X'F0'                                0258
*             /*******************************************************/
*             /*                                                     */
*             /* BUILD SYSTERM PARAMETER LIST                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0259
*             GENERATE REFS(R8,TXT856W,R1);                        0259
        LRA R8,TXT856W(R8)       OBTAIN REAL ADDRESS OF MSG
        LRA R1,0(R1)             OBTAIN REAL LRB ADDRESS
*             STWPL=R8;             /* PLACE REAL MSG PTR IN LIST    */
         ST    R8,STWPL(,R7)                                       0260
*             STLRB=R1;             /* PLACE REAL LRB PTR IN LIST    */
         ST    R1,STLRB(,R7)                                       0261
*             RESPECIFY                                            0262
*              (R1) UNRSTD;                                        0262
*             GENERATE REFS(R7,STRMPARM);                          0263
        LRA R7,STRMPARM(R7)      OBTAIN REAL ADDRESS OF LIST
*             LCCACRST='1'B;        /* SET THE TERMINATION EXIT SW   */
         OI    LCCACRST(R10),B'00000001'                           0264
*             LCCACPUS->WSACACR->ACRENTR1=R7;/* PLACE REAL PARAMETER
*                                      LIST ADDRESS IN RRPL FOR EXIT
*                                      PROCESSOR                     */
         L     @12,LCCACPUS(,R10)                                  0265
         L     @12,WSACACR(,@12)                                   0265
         ST    R7,ACRENTR1(,@12)                                   0265
*             RESPECIFY                                            0266
*              (R8,                                                0266
*               R7,                                                0266
*               R2) UNRESTRICTED;                                  0266
*                                                                  0266
*/* ******************************************************************/
*/*   END OF SEGMENT ACRSTERM                                        */
*/* ******************************************************************/
*                                                                  0267
*           END;                                                   0267
*                                                                  0267
*/* ******************************************************************/
*/*   END OF SEGMENT ACRPREP                                         */
*/* ******************************************************************/
*                                                                  0268
*       END;                                                       0268
@RF00246 DS    0H                                                  0269
*     END;                                                         0269
*   ELSE                                                           0270
*                                                                  0270
*/* ******************************************************************/
*/* ******************************************************************/
*/* ****************    ACR INTERMEDIATE PROCESSING     **************/
*/* ******************************************************************/
*/* ******************************************************************/
*                                                                  0270
*     DO;                           /* NOT SLIH ENTRY                */
         B     @RC00188                                            0270
@RF00188 DS    0H                                                  0271
*       DO;                                                        0271
*                                                                  0271
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACRINIT2                                       */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*                                                                  */
*/*     ACR INITIALIZATION FOR ENTRIES TO THE INTERMEDIATE PHASE     */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - CURRENT PSA ADDRESS (BASED ZERO)     */
*/*            RRPLPTR (REG 6) - RECOVERY RTN PARM LIST ADDRESS      */
*/*            LCCAPTR (REG 10) - CURRENT LCCA ADDRESS               */
*/*                                                                  */
*/* 02* OUTPUT= PSAPTR (REG 4) - CURRENT PSA ADDRESS (BASED ZERO)    */
*/*            RRPLPTR (REG 6) - RECOVERY RTN PARM LIST ADDRESS      */
*/*            PSAPTR2 (REG 9) - ADDR OF THE OTHER PSA               */
*/*            LCCAPTR (REG 10) - CURRENT LCCA ADDRESS               */
*/*            LCCAPTR2 (REG 11) - ADDR OF THE OTHER LCCA            */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0272
*         IF R10=LCCADCPU THEN      /* IF THE DEAD CPU IN CONTROL    */
         C     R10,LCCADCPU(,R10)                                  0272
         BNE   @RF00272                                            0272
*           R11=LCCARCPU;           /* SET OTHER LCCA BASE ADDRESS TO
*                                      THE RECOVERY LCCA ADDRESS     */
         L     R11,LCCARCPU(,R10)                                  0273
*         ELSE                      /* RECOVERY CPU IS IN CONTROL    */
*           R11=LCCADCPU;           /* SET OTHER LCCA BASE TO THE  0274
*                                      DEAD LCCA ADDRESS             */
         B     @RC00272                                            0274
@RF00272 L     R11,LCCADCPU(,R10)                                  0274
*         R11->LCCACREX=LCCACREX;   /* PROPOGATE ENTRY FLAGS TO LCCA2*/
@RC00272 MVC   LCCACREX(1,R11),LCCACREX(R10)                       0275
*         R9=                       /* OBTAIN OTHER CPU PHYSICAL ADDR*/
*             R11->LCCACPUS->WSACACR->ACRCPUAD;                    0276
         L     @12,LCCACPUS(,R11)                                  0276
         L     @12,WSACACR(,@12)                                   0276
         LH    R9,ACRCPUAD(,@12)                                   0276
         N     R9,@CF03159                                         0276
*         R9=                       /* OBTAIN OTHER PSA VIRTUAL ADDR */
*             PCCAT00P(R9+1)->PCCAPSAV;                            0277
*                                                                  0277
         LR    @12,R9                                              0277
         SLA   @12,2                                               0277
         L     @08,CVTPTR(,R4)                                     0277
         L     @08,CVTPCCAT(,@08)                                  0277
         L     @12,PCCAT00P(@12,@08)                               0277
         L     @12,PCCAPSAV(,@12)                                  0277
         LR    R9,@12                                              0277
*/* ******************************************************************/
*/*  END OF INTERMEDIATE PHASE INITIALIZATION SEGMENT - ACRINIT2     */
*/* ******************************************************************/
*                                                                  0278
*       END;                                                       0278
*       IF LCCACRLM='1'B THEN       /* IS ENTRY FROM ,LCK MGR, OR A
*                                      GLOBAL SPIN ROUTINE?          */
         TM    LCCACRLM(R10),B'00000100'                           0279
         BNO   @RF00279                                            0279
*         LCCACLMS='1'B;            /* SET THE CURRENT LCCA SUSPENDED*/
         OI    LCCACLMS(R10),B'01000000'                           0280
*       IF LCCACRTM^='1'B THEN      /* IS ENTRY FIRST ENTRY TO THE 0281
*                                      ACR INTERMEDIATE PROCESSING 0281
*                                      PHASE.                        */
@RF00279 TM    LCCACRTM(R10),B'10000000'                           0281
         BO    @RF00281                                            0281
*         DO;                       /* 1ST ENTRY TO INTERMEDIATE   0282
*                                      PROCESSING                    */
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRRTM                                         */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     ACR RTM INTERFACE ROUTINE - ENTERED ONLY AFTER THE ACR       */
*/*     PREPROCESSOR HAS RETURNED CONTROL TO THE RECOVERY CPU PROCESS*/
*/*     INTERRUPTED BY THE MFA OR EMS, AND THAT PROCESS HAS REACHED A*/
*/*     POINT WHERE IT IS RELINQUISHING CONTROL FOR THE FIRST TIME.  */
*/*     THIS RELINQUISHING OF CONTROL, EITHER BY THE PROCESS ITSELF  */
*/*     OR AS THE RESULT OF A SUPERVISORY ACTION, WILL CAUSE ACR TO  */
*/*     BE RE-ENTERED IN ITS INTERMEDIATE PROCESSING PHASE TO INITIATE
*                                                                    */
*/*     THE SOFTWARE RECOVERY PROCESS OF THE DEAD CPU WORK. THE FIRST*/
*/*     ENTRY TO INTERMEDIATE ACR PROCESSING WILL INVOKE THIS ROUTINE*/
*/*     WHICH WILL SWITCH THE DEAD CPU'S PROCESS UNDER CONTROL OF THE*/
*/*     RECOVERY CPU, AND ROUTE THAT PROCESS TO RTM FOR RECOVERY.    */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            PSAPTR2 (REG 9) - ADDR OF DEAD CPU PSA                */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            LCCAPTR2 (REG 11) - ADDR OF THE DEAD LCCA             */
*/*                                                                  */
*/* 02* OUTPUT= LCCAPTR (REG 11) - CONTAINS THE ADDR OF THE NEW LCCA */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0283
*           DO;                                                    0283
*                                                                  0283
*             /*******************************************************/
*             /*                                                     */
*             /* RECOVERY NOTE: POSSIBLE PHASE IDS AT THIS POINT ARE */
*             /* (00,02). AN ERROR IN THIS PHASE IS RETRIED AT LABEL */
*             /* RSTRT00.                                            */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0284
*             IF LOGPHID<'02'X THEN /* IS ENTRY DUE TO A RETRY FOR AN
*                                      ERROR IN THIS PHASE           */
         CLI   LOGPHID(R6),X'02'                                   0284
         BNL   @RF00284                                            0284
*               RRPLFLGS='0'B;      /* NO, RESET ANY PREVIOUS PHASE
*                                      ERROR INDICATIONS             */
         MVI   RRPLFLGS(R6),B'00000000'                            0285
*             LOGPHID='02'X;        /* SET THIS LOGICAL PHASE ID     */
@RF00284 MVI   LOGPHID(R6),X'02'                                   0286
*           END;                                                   0287
*                                                                  0287
*           /*********************************************************/
*           /*                                                       */
*           /* SET THE RTM INVOKED INDICATION FOR LATER PROCESSING   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0288
*           LCCACRTM='1'B;          /* SET THE RTM INVOKED SWITCH IN
*                                      BOTH THE RECOVERY,            */
         OI    LCCACRTM(R10),B'10000000'                           0288
*           R11->LCCACRTM='1'B;     /* DEAD LCCAS.                   */
*                                                                  0289
         OI    LCCACRTM(R11),B'10000000'                           0289
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS SWITCH TO THE DEAD CPU'S PROCESS              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0290
*           RESPECIFY                                              0290
*            (R13) RSTD;                                           0290
*           R13=WSACACR;            /* SET BASE TO ACR WORK AREA     */
         L     @08,LCCACPUS(,R10)                                  0291
         L     R13,WSACACR(,@08)                                   0291
*           CALL ACRPROSW;          /* PROCESS SWITCH SUBRTN         */
         BAL   @14,ACRPROSW                                        0292
*           RESPECIFY                                              0293
*            (R13) UNRSTD;                                         0293
*                                                                  0293
*           /*********************************************************/
*           /*                                                       */
*           /* SEND THE DEAD PROCESS TO RTM FOR RECOVERY. THE        */
*           /* RECOVERY ENVIRONMENT IS MADE TO LOOK AS IF A MACHINE  */
*           /* CHECK HAS OCURRED BY ENTERING RTM WITH THE MCH STACK  */
*           /* CURRENT, AND SET TO LOOK AS IF A MACHINE CHECK HAS    */
*           /* OCURRED. MACHINE CHECKS ARE DISABLED TEMPORARILY      */
*           /* ACROSS THE RTM HARDWARE RECOVERY PROCESS. RTM WILL    */
*           /* RETURN TO THIS ROUTINE FOR MACHINE CHECK ENABLEMENT   */
*           /* BEFORE STARTING SOFTWARE RECOVERY. DISABLE MACHINE    */
*           /* CHECKS                                                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0294
*           GENERATE REFS(MCDSPSW);                                0294
        LPSW  MCDSPSW                     DISABLE MACHINE CHECKS
*MCDSABL:                           /* LPSW RETURN POINT             */
*           PSAACR='0'B;            /* REMOVE PROTECTION DURING RTM
*                                      MCHK PROCESSING               */
MCDSABL  NI    PSAACR(R4),B'11111011'                              0295
*           RESPECIFY                                              0296
*            (R1,                                                  0296
*             R13) RSTD;                                           0296
*           R1=ACRMCHEB;            /* INSURE LOGREC BUFFER ADDRESS  */
         L     @12,LCCACPUS(,R10)                                  0297
         L     @12,WSACACR(,@12)                                   0297
         L     R1,ACRMCHEB(,@12)                                   0297
*           R13=ADDR(ACRACRSV);     /* PASS SAVE AREA ADDRESS        */
*                                                                  0298
         LA    R13,ACRACRSV(,@12)                                  0298
*           /*********************************************************/
*           /*                                                       */
*           /* ADJUST THE FRR STACK TO SIMULATE MCH IN CONTROL       */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0299
*           IF PSACSTK^=PSAMSTK     /* IF MCH STACK NOT ALREADY THE
*                                      CURRENT STACK         @ZA15778*/
*             THEN                                                 0299
         L     @12,PSACSTK(,R4)                                    0299
         L     @08,PSAMSTK(,R4)                                    0299
         CR    @12,@08                                             0299
         BE    @RF00299                                            0299
*             DO;                   /*                       @ZA15778*/
*               PSAMSAV=PSACSTK;    /* PLACE CURRENT STACK AT TIME OF
*                                      ERROR AS THE INTERRUPTED STACK
*                                      OF MCH.                       */
         ST    @12,PSAMSAV(,R4)                                    0301
*               PSACSTK=PSAMSTK;    /* SET THE CURRENT STACK TO THE
*                                      MCH STACK                     */
         ST    @08,PSACSTK(,R4)                                    0302
*             END;                  /*                       @ZA15778*/
*           ELSE                                                   0304
*             ;                     /* IF MCH ALREADY CURRENT LEAVE
*                                      STACK PTRS ALONE      @ZA15778*/
*                                                                  0304
@RF00299 DS    0H                                                  0305
*           /*********************************************************/
*           /*                                                       */
*           /* LOAD FLOATING POINT REGS PRIOR TO GOING TO RTM        */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0305
*           GEN REFS(LOGFLOAT);                                    0305
*                                                                  0305
        LD 0,LOGFLOAT(R1)
        LD 2,LOGFLOAT+8(R1)
        LD 4,LOGFLOAT+16(R1)
        LD 6,LOGFLOAT+24(R1)
*           /*********************************************************/
*           /*                                                       */
*           /* ROUTE CONTROL TO RTM FOR HARDWARE RECORDING AND       */
*           /* RECOVERY                                              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0306
*           GENERATE;                                              0306
        CALLRTM TYPE=MACHCK             INITIATE HARDWARE RECOVERY
*           RESPECIFY                                              0307
*            (R13) UNRESTRICTED;                                   0307
*                                                                  0307
*           /*********************************************************/
*           /*                                                       */
*           /* RTM WILL RETURN TO ACR AT THIS POINT TO ALLOW ENABLING*/
*           /* OF MACHINE CHECKS, AND WILL PASS IN REG 1 A POINTER TO*/
*           /* AN AREA WHICH CONTAINS THE REGISTERS AND PSW TO BE    */
*           /* LOADED TO RE-ENTER RTM FOR IT TO CONTINUE FURTHER     */
*           /* SOFTWARE RECOVERY (FRR PROCESSING). RE-ESTABLISH THE  */
*           /* STACK AT TIME OF ERROR AS CURRENT                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0308
*           PSACSTK=PSAMSAV;        /* RESTORE CURRENT STACK         */
         L     @12,PSAMSAV(,R4)                                    0308
         ST    @12,PSACSTK(,R4)                                    0308
*           IF RRPLRTRY='0'B        /* IS ENTRY DUE TO A RETRY?      */
*             THEN                  /* NOT RETRY                     */
         TM    RRPLRTRY(R6),B'10000000'                            0309
         BNZ   @RF00309                                            0309
*             RRPLFLGS=''B;         /* CLEAR ANY PREVIOUS ERROR    0310
*                                      INDICATIONS                   */
         MVI   RRPLFLGS(R6),X'00'                                  0310
*           LOGPHID='06'X;          /* SET THIS LOGICAL PHASE ID     */
@RF00309 MVI   LOGPHID(R6),X'06'                                   0311
*           ACRENTR1=R1;            /* SAVE REG 1 FOR RTM RETURN USED
*                                      IN EXIT SEG.                  */
         L     @12,LCCACPUS(,R10)                                  0312
         L     @12,WSACACR(,@12)                                   0312
         ST    R1,ACRENTR1(,@12)                                   0312
*           GEN REFS(RRPLREGS)(STM 0,14,RRPLREGS(R6));/* SAVE REGS 0313
*                                      FOR RECURSION.                */
         STM 0,14,RRPLREGS(R6)
*           PSAACR='1'B;            /* SET PROTECTION AGAIN BEFORE 0314
*                                      ENABLING FOR MACHINE CHECKS   */
         OI    PSAACR(R4),B'00000100'                              0314
*RSTRT06:                           /* REENTRY POINT FROM MACH CHK 0315
*                                      ENABLEMENT OR FRR RETRY       */
*                                                                  0315
*           /*********************************************************/
*           /*                                                       */
*           /* ENABLE MACHINE CHECKS                                 */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0315
*           LPSW(MCENPSW);                                         0315
RSTRT06  LPSW  MCENPSW                                             0315
*MCENABL:                           /* LPSW RETURN POINT             */
*           LCCACRRT='1'B;          /* SET THE RTM EXIT INDICATOR    */
MCENABL  OI    LCCACRRT(R10),B'00010000'                           0316
*           RESPECIFY                                              0317
*            (R1) UNRESTRICTED;                                    0317
*                                                                  0317
*/* ******************************************************************/
*/*  END OF SEGMENT ACRRTM                                           */
*/* ******************************************************************/
*                                                                  0318
*         END;                                                     0318
*       ELSE                        /* NOT INITIAL INTERMEDIATE PHASE
*                                      ENTRY CHECK FOR SUSPENSION    */
*         IF                        /* IS THE OTHER PROCESS SUSPENDED*/
*             R11->LCCACLMS='1'B THEN/* YES, SETLOCK INTERFACE     0319
*                                      ROUTINE                       */
         B     @RC00281                                            0319
@RF00281 TM    LCCACLMS(R11),B'01000000'                           0319
         BNO   @RF00319                                            0319
*           DO;                     /* OTHER PROCESS IS SUSPENDED    */
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRLKSPI                                       */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     ACR LOCK MANAGER-GLOBAL SPIN INTERFACE ROUTINE-- THIS        */
*/*     ROUTINE IS ENTERED WHEN THE LOCK MANAGER HAS ENCOUNTERED A   */
*/*     LOCK CONFLICT, OR WHEN AUTHORIZED GLOBAL SPIN ROUTINES HAVE  */
*/*     DISCOVERED A DEPENDENCY ON THE DEAD CPU.  THIS ROUTINE WILL  */
*/*     CAUSE A SWITCH OF PROCESSES TO THE OTHER PROCESS TO REMOVE   */
*/*     THE CONFLICT OR DEPENDENCY.  THIS ROUTINE IS ALSO ENTERED    */
*/*     IF A PROCESS ENTERS ACR VIA THE DISPATCHER, AND THE OTHER    */
*/*     PROCESS IS IN A SUSPENDED STATE AS DESCRIBED IN THE PREVIOUS */
*/*     SENTENCE.  THIS ROUTINE CONTROLS THE PING-PONG ACTION OF ACR */
*/*     IN RESOLVING CONFLICTS BETWEEN THE TWO PROCESSES.            */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            PSAPTR2 (REG 9) - ADDR OF THE OTHER CPU PSA           */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            LCCAPTR2 (REG 11) - ADDR OF THE OTHER LCCA            */
*/*                                                                  */
*/* 02* OUTPUT= LCCAPTR (REG 10) - CONTAINS THE ADDR OF THE NEW LCCA */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0321
*             DO;                                                  0321
*                                                                  0321
*               /*****************************************************/
*               /*                                                   */
*               /* RECOVERY NOTE: POSSIBLE PHASE IDS AT THIS POINT   */
*               /* ARE (00,03). AN ERROR IN THIS PHASE IS RETRIED AT */
*               /* LABEL RSTRT00.                                    */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0322
*               IF LOGPHID<'03'X THEN/* IS ENTRY DUE TO A RETRY FOR
*                                      AN ERROR IN THIS PHASE        */
         CLI   LOGPHID(R6),X'03'                                   0322
         BNL   @RF00322                                            0322
*                 RRPLFLGS='0'B;    /* NO, RESET ANY PREVIOUS PHASE
*                                      ERROR INDICATIONS             */
         MVI   RRPLFLGS(R6),B'00000000'                            0323
*               LOGPHID='03'X;      /* SET THIS LOGICAL PHASE ID     */
@RF00322 MVI   LOGPHID(R6),X'03'                                   0324
*             END;                                                 0325
*                                                                  0325
*             /*******************************************************/
*             /*                                                     */
*             /* SWITCH TO THE OTHER CPUS PROCESSING                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0326
*             RESPECIFY                                            0326
*              (R13) RSTD;                                         0326
*             R13=WSACACR;          /* SET BASE TO ACR WORK AREA     */
         L     @08,LCCACPUS(,R10)                                  0327
         L     R13,WSACACR(,@08)                                   0327
*             CALL ACRPROSW;        /* SWITCH TO SUSPENDED PROCESS   */
         BAL   @14,ACRPROSW                                        0328
*             RESPECIFY                                            0329
*              (R13) UNRSTD;                                       0329
*             GEN REFS(RRPLREGS)(STM 0,14,RRPLREGS(R6));/* SAVE REGS
*                                      FOR RECURSION                 */
         STM 0,14,RRPLREGS(R6)
*RSTRT05:                           /* REENTRY POINT FOR RECURSION   */
*             IF LOGPHID^='05'X THEN/* IS THIS A RETRY?              */
RSTRT05  CLI   LOGPHID(R6),X'05'                                   0331
         BE    @RF00331                                            0331
*               RRPLFLGS='0'B;      /* RESET ANY FLGS FROM PREVIOUS
*                                      PHASE                         */
         MVI   RRPLFLGS(R6),B'00000000'                            0332
*             LOGPHID='05'X;        /* SET LOGICAL PHASEID 05 FOR FRR*/
@RF00331 MVI   LOGPHID(R6),X'05'                                   0333
*             LCCACLMS='0'B;        /* RESET THE NEW LCCA SUSPEND BIT*/
         NI    LCCACLMS(R10),B'10111111'                           0334
*             LCCACRLE='1'B;        /* SET THE LOCK & SPIN EXIT FLAG */
         OI    LCCACRLE(R10),B'00100000'                           0335
*/* ******************************************************************/
*/*  END OF SEGMENT ACRLKSPI                                         */
*/* ******************************************************************/
*                                                                  0336
*           END;                                                   0336
*       IF LOGPHID='00'X THEN       /* IF THE LOGICAL PHASE ID IS  0337
*                                      STILL X'00' AT THIS POINT,  0337
*                                      THEN BOTH PROCESSES ARE AT A
*                                      LOGICALLY ENABLED STATE AND 0337
*                                      THE POST PROCESS PHASE IS   0337
*                                      ENTERED.                      */
@RF00319 DS    0H                                                  0337
@RC00281 CLI   LOGPHID(R6),X'00'                                   0337
         BNE   @RF00337                                            0337
*         DO;                       /* BOTH CPUS ARE ENABLED         */
*/* ******************************************************************/
*/* ******************************************************************/
*/* ****************       ACR POST PROCESSING        ****************/
*/* ******************************************************************/
*/* ******************************************************************/
*                                                                  0339
*           DO;                                                    0339
*                                                                  0339
*             /*******************************************************/
*             /*                                                     */
*             /* INSURE THE RECOVERY CPU IS IN CONTROL BEFORE        */
*             /* ENTERING THE POST PROCESSOR SEGMENT                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0340
*             IF R10^=LCCARCPU THEN /* IS THE REC CPU IN CONTROL?    */
         C     R10,LCCARCPU(,R10)                                  0340
         BE    @RF00340                                            0340
*               DO;                 /* DEAD CPU IN CONTROL           */
*                 GEN REFS(RRPLREGS,R6)(STM 0,14,RRPLREGS(R6));/*  0342
*                                      SAVE REGS FOR RECURSION       */
         STM 0,14,RRPLREGS(R6)
*                 RRPLFLGS='0'B;    /* CLEAR ERROR FLAGS             */
         MVI   RRPLFLGS(R6),B'00000000'                            0343
*RSTRT04:                                                          0344
*                 LOGPHID='04'X;    /* SET LOGICAL PHASE ID FOR    0344
*                                      RECOVERY RTN                  */
RSTRT04  MVI   LOGPHID(R6),X'04'                                   0344
*                 RESPECIFY                                        0345
*                  (R13) RSTD;                                     0345
*                 R13=WSACACR;      /* SET BASE TO ACR WORK SAVE AREA*/
         L     @08,LCCACPUS(,R10)                                  0346
         L     R13,WSACACR(,@08)                                   0346
*                 CALL ACRPROSW;    /* MAKE RECOVERY CPU CURRENT     */
         BAL   @14,ACRPROSW                                        0347
*                 RESPECIFY                                        0348
*                  (R13) UNRSTD;                                   0348
*               END;                                               0349
*           END;                                                   0350
@RF00340 DS    0H                                                  0351
*           DO;                                                    0351
*                                                                  0351
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACRPOSTP                                       */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THE ACR POST PROCESSOR IS ENTERED ONLY WHEN BOTH CPUS HAVE   */
*/*     ATTAINED THE LOGICALLY ENABLED STATE,(BOTH DISPATCHABLE, NO  */
*/*     GLOBAL LOCKS HELD,AND NON SRB MODE). THIS PHASE OF PROCESSING*/
*/*     WILL ALLOW THE RECOVERY CPU TO CLEAN UP THE SYSTEM SO IT CAN */
*/*     RESUME NORMAL DISPATCHING WITHOUT THE USE OF THE DEAD CPU.   */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*                                                                  */
*/* 02* OUTPUT= SAME AS INPUT                                        */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0352
*             RFY                                                  0352
*              (R3,                                                0352
*               R2,                                                0352
*               R1) RSTD;                                          0352
*                                                                  0352
*             /*******************************************************/
*             /*                                                     */
*             /* SET UP FRR PROTECTION FOR THE POST-PROCESSING PHASE */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0353
*             R3=ADDR(IEAVTCR1);                                   0353
         L     R3,@CA02845                                         0353
*             GEN(SETFRR A,FRRAD=(R3),WRKREGS=(R1,R2));            0354
         SETFRR A,FRRAD=(R3),WRKREGS=(R1,R2)
*             RFY                                                  0355
*              (R3,                                                0355
*               R2,                                                0355
*               R1) UNRSTD;                                        0355
*             PSAACR='0'B;          /* TURN OFF SUPER BIT AND BE   0356
*                                      PROTECTED BY CONVENTIONAL FRR */
         NI    PSAACR(R4),B'11111011'                              0356
*             GEN REFS(RRPLREGS)(STM 0,14,RRPLREGS(R6));/* SAVE    0357
*                                                            @YM08185
*                                      REGS FOR RECURSION.   @YM08185*/
         STM 0,14,RRPLREGS(R6)
*             RRPLFLGS='0'B;        /* RESET ANY PREVIOUS PHASE ERROR
*                                      INDICATORS                    */
         MVI   RRPLFLGS(R6),B'00000000'                            0358
*RSTRT07:                           /* FRR RETRY ENTRY PT            */
*             IF RRPLRTRY='0'B THEN /* IS ENTRY DUE TO A RETRY?      */
RSTRT07  TM    RRPLRTRY(R6),B'10000000'                            0359
         BNZ   @RF00359                                            0359
*               LOGPHID='07'X;      /* YES, SET PHASE ID 07          */
*                                                                  0360
         MVI   LOGPHID(R6),X'07'                                   0360
*             /*******************************************************/
*             /*                                                     */
*             /* SET REGISTER 13 TO THE ADDR OF AN 18 WORD SAVE AREA */
*             /* FOR USE BY ROUTINES CALLED BY THE ACR POST PROCESSOR*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0361
*             RESPECIFY                                            0361
*              (R13) RSTD;                                         0361
@RF00359 DS    0H                                                  0362
*             R13=ADDR(ACRACRSV);   /* SAVE AREA ADDR IN CURR ACRSA  */
*                                                                  0362
         L     @08,LCCACPUS(,R10)                                  0362
         L     R13,WSACACR(,@08)                                   0362
         LA    R13,ACRACRSV(,R13)                                  0362
*             /*******************************************************/
*             /*                                                     */
*             /* SEE IF VARY CPU WAS TAKING CHANNELS OFF THE RECOVERY*/
*             /* CPU                                                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0363
*             DO;                                                  0363
*                                                                  0363
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACRVARY                                        */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THIS SEGMENT TESTS TO SEE IF VARY CPU OFFLINE                */
*/*     WAS IN THE PROCESS OF MARKING CHANNELS OFFLINE ON THE        */
*/*     RECOVERY CPU WHEN THE MALFUNCTION OCCURRED ON THE CPU        */
*/*     WHICH IS NOW DEAD.  IF THIS WAS THE CASE, ACR WILL           */
*/*     INTERFACE TO THE VARY WAKE UP ROUTINE TO INSURE THAT         */
*/*     THE RECOVERY CPU HAS ITS CHANNELS ONLINE BEFORE GOING        */
*/*     TO I/O RESTART.                                              */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            R13 (REG 13) - ADDR OF AN 18 WORD SAVE AREA           */
*/*                                                                  */
*/* 02* OUTPUT= SAME AS INPUT                                        */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0364
*               IF LCCAVARY='1'B THEN/* WAS VARY MARKING CHANNELS  0364
*                                      OFFLINE ON THE RECOVERY CPU   */
         TM    LCCAVARY(R10),B'00000001'                           0364
         BNO   @RF00364                                            0364
*                 DO;               /* YES                           */
*                   RESPECIFY                                      0366
*                    (R15) RSTD;                                   0366
*                   R15=CVTVACR;    /* OBTAIN WAKE UP RTN ADDRESS    */
         L     @12,CVTPTR(,R4)                                     0367
         L     R15,CVTVACR(,@12)                                   0367
*                   GENERATE REFS(R0,R14,R13,R15);                 0368
              STM R0,R15,0(R13)   SAVE REGS ACROSS WAKE UP ROUTINE
              BALR R14,R15        BRANCH TO WAKE UP RTN
              LM R0,R15,0(R13)     RESTORE REGS
*                   RESPECIFY                                      0369
*                    (R15) UNRSTD;                                 0369
*                 END;                                             0370
*                                                                  0370
*/* ******************************************************************/
*/*  END OF SEGMENT ACRVARY                                          */
*/* ******************************************************************/
*                                                                  0371
*             END;                                                 0371
*                                                                  0371
@RF00364 DS    0H                                                  0372
*             /*******************************************************/
*             /*                                                     */
*             /* CALL THE I/O RESTART ROUTINE TO CLEAN UP I/O        */
*             /* REQUESTS,DEVICES                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0372
*             DO;                                                  0372
*               DO UCBLKPTR=CVTILK2 BY 2 WHILE(UCBTAB^='FFFF'X);/* 0373
*                                                            @ZA00805*/
         L     @12,CVTPTR(,R4)                                     0373
         L     @12,CVTILK2(,@12)                                   0373
         ST    @12,UCBLKPTR                                        0373
         B     @DE00373                                            0373
@DL00373 DS    0H                                                  0374
*                 IF UCBTAB^='0000'X THEN/* IF NOT A DUMMY UCB     0374
*                                                            @ZA00805*/
         L     @12,UCBLKPTR                                        0374
         LH    @12,UCBTAB(,@12)                                    0374
         N     @12,@CF03159                                        0374
         LTR   @12,@12                                             0374
         BZ    @RF00374                                            0374
*                   DO;             /* THEN GEN AN IOSGEN    @ZA00805*/
*                     RFY                                          0376
*                      (R12,                                       0376
*                       R1,                                        0376
*                       R15) RSTD;  /* DECTECTOR MACRO TO    @ZA00805*/
*                     R1=UCBTAB;    /* RESET UCBS FOR SHARED @ZA00805*/
         L     @14,UCBLKPTR                                        0377
         LH    @14,UCBTAB(,@14)                                    0377
         N     @14,@CF03159                                        0377
         LR    R1,@14                                              0377
*                     GEN REFS(UCBOB,UCBTBYT2,UCBTBYT3,UCBSTAT,UCBSQC,
*                         UCBFLP1)                                 0378
*                         (IOSGEN DETECTOR,UCB=(1),REG=(12,15),VAR=2);
         IOSGEN DETECTOR,UCB=(1),REG=(12,15),VAR=2
*                                   /* DEV                   @ZA00805*/
*                     RFY                                          0379
*                      (R1,                                        0379
*                       R12,                                       0379
*                       R15) UNRSTD;/* UNRESTRICT WORK REGS  @ZA00805*/
*                   END;            /* END UCB PROCESSING    @ZA00805*/
*               END;                /* END UCB LOOP PROCESS  @ZA00805*/
@RF00374 LA    @12,2                                               0381
         AL    @12,UCBLKPTR                                        0381
         ST    @12,UCBLKPTR                                        0381
@DE00373 L     @12,UCBLKPTR                                        0381
         CLC   UCBTAB(2,@12),@CH03134                              0381
         BNE   @DL00373                                            0381
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME   ACRIORST                                      */
*/*                                                                  */
*/* 02* FUNCTION    ACR I/O RESTART INTERFACE                        */
*/*     IF THE DEAD CPU HAS ANY CHANNELS ONLINE            @G47AN2O  */
*/*     THIS ROUTINE SETS UP THE INTERFACE AND CALLS THE             */
*/*     I/O RESTART MODULE TO HANDLE ANY OUTSTANDING I/O FOR THE     */
*/*     DEAD CPU, AND RESCHEDULING OF ANY I/O WHICH MAY HAVE         */
*/*     A PATH STILL OPEN TO A DEVICE.  THE I/O RESTART ROUTINE WILL */
*/*     ALSO MARK OFFLINE FOR JOB SCHEDULING ANY DEVICE TO WHICH NO  */
*/*     PATH STILL EXISTS.                                           */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            R13 (REG 13) - ADDR OF AN 18 WORD SAVE AREA           */
*/*                                                                  */
*/* 02* OUTPUT= SAME AS INPUT                                        */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0382
*               IF PCCAT00P(PSASPAD+1)->/* DEAD CPU PCCA ADDR      0382
*                                                            @G47AN2O*/
*                   PCCAIO=HASIO    /* DEAD CPU HAS          @G47AN2O
*                                      CHANNELS ONLINE       @G47AN2O*/
*                 THEN                                             0382
         LH    @12,PSASPAD(,R4)                                    0382
         SLA   @12,2                                               0382
         L     @08,CVTPTR(,R4)                                     0382
         L     @08,CVTPCCAT(,@08)                                  0382
         L     @12,PCCAT00P(@12,@08)                               0382
         TM    PCCAIO(@12),B'01000000'                             0382
         BNO   @RF00382                                            0382
*                 DO;               /*                       @G47AN2O*/
*                   RESPECIFY                                      0384
*                    (R1) RESTRICTED;                              0384
*                   R1=R11->LCCACPUS->WSACACR->ACRCPUAD;/* SET PARM
*                                      REGISTER                      */
         L     @12,LCCACPUS(,R11)                                  0385
         L     @12,WSACACR(,@12)                                   0385
         LH    R1,ACRCPUAD(,@12)                                   0385
         N     R1,@CF03159                                         0385
*                   CALL IECVRSTI;                                 0386
         L     @15,@CV02846                                        0386
         BALR  @14,@15                                             0386
*                   RESPECIFY                                      0387
*                    (R1) UNRSTD;                                  0387
*                 END;              /*                       @G47AN2O*/
*/* ******************************************************************/
*/*  END OF SEGMENT ACRIORST                                         */
*/* ******************************************************************/
*                                                                  0389
*             END;                                                 0389
@RF00382 DS    0H                                                  0390
*             RRPLFLGS='0'B;        /* RESET ERROR INDICATORS        */
*                                                                  0390
         MVI   RRPLFLGS(R6),B'00000000'                            0390
*             /*******************************************************/
*             /*                                                     */
*             /* POST THE UCM TO CAUSE A CONSOLE SWITCH FROM THE DEAD*/
*             /* CPU                                                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0391
*RSTRT08:                           /* FRR RETRY ENTRY PT            */
*             IF RRPLRTRY='0'B THEN /* IS ENTRY DUE TO A RETRY       */
RSTRT08  TM    RRPLRTRY(R6),B'10000000'                            0391
         BNZ   @RF00391                                            0391
*               LOGPHID='08'X;      /* NO, SET PHASE ID 08           */
         MVI   LOGPHID(R6),X'08'                                   0392
*             ELSE                                                 0393
*               DO;                                                0393
         B     @RC00391                                            0393
@RF00391 DS    0H                                                  0394
*                 LOGPHID='09'X;    /* YES, SET PHASE ID 09          */
         MVI   LOGPHID(R6),X'09'                                   0394
*                 RRPLRTRY='0'B;    /* INDICATE THAT ANOTHER RETRY IS
*                                      PERMITTED.                    */
         NI    RRPLRTRY(R6),B'01111111'                            0395
*               END;                                               0396
*             DO;                                                  0397
*                                                                  0397
@RC00391 DS    0H                                                  0398
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACRCONSW                                       */
*/*                                                                  */
*/* 02* FUNCTION     ACR CONSOLE SWITCH INTERFACE                    */
*/*     ACR INVOKES THE CONSOLE SWITCH ROUTINE VIA THE COMPARE AND   */
*/*     SWAP POSTING OF THE DEAD CPU'S ADDRESS TO THE UCMARECB IN    */
*/*     THE UNIT CONTROL MODULE(UCM).  THIS IS DONE TO INSURE THE    */
*/*     SYSTEM A MASTER CONSOLE, AND TO CONSOLIDATE THE RE-ROUTING   */
*/*     OF ANY LOST COSOLE'S MESSAGES TO ANOTHER AVAILABLE DEVICE.   */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*                                                                  */
*/* 02* OUTPUT= SAME AS INPUT                                        */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0398
*               RESPECIFY                                          0398
*                (R2,                                              0398
*                 R3) RSTD;                                        0398
*               R2=CONSWECB;        /* PICK UP THE ACR ECB IN UCM    */
         L     @12,CVTPTR(,R4)                                     0399
         L     @12,UCMBASPT(,@12)                                  0399
         L     R2,CONSWECB(,@12)                                   0399
*CONSWAP:                           /* RETRY IF CS FAILS             */
*               IF CONSWCOD='40'X THEN/* IS THERE A CPU ALREADY    0400
*                                      POSTED TO THE CONSOLE SW    0400
*                                      ROUTINE                       */
CONSWAP  L     @12,CVTPTR(,R4)                                     0400
         L     @12,UCMBASPT(,@12)                                  0400
         CLI   CONSWCOD(@12),X'40'                                 0400
         BNE   @RF00400                                            0400
*                 CONSPARM=R2;      /* PLACE ECB VALUE IN WORKAREA   */
         L     @12,LCCACPUS(,R10)                                  0401
         L     @12,WSACACR(,@12)                                   0401
         ST    R2,CONSPARM(,@12)                                   0401
*               ELSE                                               0402
*                 CONSPARM=''B;     /* BUILD SINGLE MASK VALUE       */
*                                                                  0402
         B     @RC00400                                            0402
@RF00400 L     @12,LCCACPUS(,R10)                                  0402
         L     @12,WSACACR(,@12)                                   0402
         SLR   @08,@08                                             0402
         ST    @08,CONSPARM(,@12)                                  0402
*               /*****************************************************/
*               /*                                                   */
*               /* OR THE DEAD CPU MASK INTO THE ECB VALUE           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0403
*               SWMASK=SWMASK|R11->LCCACPUS->WSACACR->ACRCAFM;     0403
@RC00400 L     @12,LCCACPUS(,R10)                                  0403
         L     @12,WSACACR(,@12)                                   0403
         L     @08,LCCACPUS(,R11)                                  0403
         L     @08,WSACACR(,@08)                                   0403
         OC    SWMASK(2,@12),ACRCAFM(@08)                          0403
*               POSTCDE='40'X;      /* SET THE POST CODE ON          */
         MVI   POSTCDE(@12),X'40'                                  0404
*               R3=CONSPARM;        /* SET THE SWAP REGISTER         */
         L     R3,CONSPARM(,@12)                                   0405
*               CS(R2,R3,CONSWECB); /* POST THE UCMARECB             */
         L     @12,CVTPTR(,R4)                                     0406
         L     @12,UCMBASPT(,@12)                                  0406
         CS    R2,@03,CONSWECB(@12)                                0406
*               BC(7,CONSWAP);      /* NOT SUCESSFUL,ALREADY PSTD    */
         BC    7,CONSWAP                                           0407
*               RESPECIFY                                          0408
*                (R2,                                              0408
*                 R3) UNRSTD;                                      0408
*                                                                  0408
*/* ******************************************************************/
*/*  END OF SEGMENT ACRCONSW                                         */
*/* ******************************************************************/
*                                                                  0409
*             END;                                                 0409
*             RRPLFLGS='0'B;        /* RESET ERROR INDICATORS        */
*                                                                  0410
         MVI   RRPLFLGS(R6),B'00000000'                            0410
*             /*******************************************************/
*             /*                                                     */
*             /* INFORM THE SYSTEM RESOURCES MGR OF THE LOSS OF THE  */
*             /* DEAD CPU                                            */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0411
*RSTRT09:                           /* FRR RETRY ENTRY PT            */
*             IF RRPLRTRY='0'B THEN /* IS ENTRY DUE TO A RETRY?      */
RSTRT09  TM    RRPLRTRY(R6),B'10000000'                            0411
         BNZ   @RF00411                                            0411
*               LOGPHID='09'X;      /* NO, SET PHASE ID 09           */
         MVI   LOGPHID(R6),X'09'                                   0412
*             ELSE                                                 0413
*               DO;                                                0413
         B     @RC00411                                            0413
@RF00411 DS    0H                                                  0414
*                 LOGPHID='0A'X;    /* YES, SET PHASE ID 0A          */
         MVI   LOGPHID(R6),X'0A'                                   0414
*                 RRPLRTRY='0'B;    /* INDICATE THAT ANOTHER RETRY IS
*                                      PERMITTED.                    */
         NI    RRPLRTRY(R6),B'01111111'                            0415
*               END;                                               0416
*             DO;                                                  0417
*                                                                  0417
@RC00411 DS    0H                                                  0418
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACROPTEV                                       */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THIS SEGMENT INTERFACES WITH THE SYSTEM RESOURCES MANAGER    */
*/*     VIA A BRANCH ENTRY TO INFORM IT OF THE LOSS OF A CPU         */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            R13 (REG 13) - ADDR OF AN 18 WORD SAVE AREA           */
*/*                                                                  */
*/* 02* OUTPUT= SAME AS INPUT                                        */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0418
*               RESPECIFY                                          0418
*                (R0,                                              0418
*                 R1,                                              0418
*                 R14,                                             0418
*                 R15) RESTRICTED;                                 0418
*               R1=R11->LCCACPUS->WSACACR->ACRCPUAD;/* SET THE CPU 0419
*                                      ADDR                          */
         L     @12,LCCACPUS(,R11)                                  0419
         L     @12,WSACACR(,@12)                                   0419
         LH    R1,ACRCPUAD(,@12)                                   0419
         N     R1,@CF03159                                         0419
*               GENERATE;                                          0420
      SYSEVENT ALTCPREC,ENTRY=BRANCH
*               RESPECIFY                                          0421
*                (R0,                                              0421
*                 R1,                                              0421
*                 R14,                                             0421
*                 R15) UNRESTRICTED;                               0421
*                                                                  0421
*/* ******************************************************************/
*/*  END OF SEGMENT ACROPTEV                                         */
*/* ******************************************************************/
*                                                                  0422
*             END;                                                 0422
*             RRPLFLGS='0'B;        /* RESET ANY ERROR INDICATORS    */
*                                                                  0423
         MVI   RRPLFLGS(R6),B'00000000'                            0423
*             /*******************************************************/
*             /*                                                     */
*             /* SEND ACR COMPLETE MSG VIA THE ASYNCHRONOUS MSG      */
*             /* WRITER                                              */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0424
*RSTRT0A:                           /* FRR RETRY ENTRY PT            */
*             IF RRPLRTRY='0'B THEN /* IS ENTRY DUE TO A RETRY?      */
RSTRT0A  TM    RRPLRTRY(R6),B'10000000'                            0424
         BNZ   @RF00424                                            0424
*               LOGPHID='0A'X;      /* NO, SET PHASE ID 0A           */
         MVI   LOGPHID(R6),X'0A'                                   0425
*             ELSE                                                 0426
*               DO;                                                0426
         B     @RC00424                                            0426
@RF00424 DS    0H                                                  0427
*                 LOGPHID='0B'X;    /* YES, SET PHASE ID 0B          */
         MVI   LOGPHID(R6),X'0B'                                   0427
*                 RRPLRTRY='0'B;    /* INDICATE THAT ANOTHER RETRY IS
*                                      PERMITTED                     */
         NI    RRPLRTRY(R6),B'01111111'                            0428
*               END;                                               0429
*             DO;                                                  0430
*                                                                  0430
@RC00424 DS    0H                                                  0431
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACRMSG                                         */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THIS SEGMENT INTERFACES WITH THE ASYNCHRONOUS RECORDING      */
*/*      FUNCTION TO WRITE THE ACR COMPLETE MSG TO THE OPERATOR.     */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            R13 (REG 13) - ADDR OF AN 18 WORD SAVE AREA           */
*/*                                                                  */
*/* 02* OUTPUT= SAME AS INPUT                                        */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0431
*               RESPECIFY                                          0431
*                 R8 RSTD;          /*                       @G55DP2M*/
*               R8=R11->LCCACPUS->WSACACR;/* SET BASE TO WORK AREA   */
*                                                                  0432
         L     @12,LCCACPUS(,R11)                                  0432
         L     R8,WSACACR(,@12)                                    0432
*               /*****************************************************/
*               /*                                                   */
*               /* SET UP 'ACR COMPLETE' MESSAGE IN MCH BUFFER FOR   */
*               /* ASYNCHRONOUS OUTPUT TO OPERATOR VIA RECORDER'S MCH*/
*               /* INTERFACE                                 @G55DP2M*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0433
*               DO MSGPTR=RVTMSGPT BY LENGTH(MSG) WHILE MSGPTR<RVTMSGPT
*                     +RVTMSGLN;    /* SEARCH MCH BUFFER     @G55DP2M*/
         L     @12,CVTPTR(,R4)                                     0433
         L     @12,RVTPTR(,@12)                                    0433
         L     @12,RVTMSGPT(,@12)                                  0433
         ST    @12,MSGPTR                                          0433
         B     @DE00433                                            0433
@DL00433 DS    0H                                                  0434
*                 IF MSGNUM='58'X THEN                             0434
         L     @12,MSGPTR                                          0434
         CLI   MSGNUM(@12),X'58'                                   0434
         BNE   @RF00434                                            0434
*                   DO;             /* IS THIS ACR BUFFER    @G55DP2M*/
*                     MSGVAR1(3:4)=R8->ACRCPUAD;/* GET DEAD CPU ADDR
*                                                            @ZM45600*/
         MVC   MSGVAR1+2(2,@12),ACRCPUAD(R8)                       0436
*                     MSGTAB1='FF'X;/* INDICATE FOR MCH      @G55DP2M
*                                      RECORD FACILITY MSG   @G55DP2M
*                                      READY TO PRINT        @G55DP2M*/
         MVI   MSGTAB1(@12),X'FF'                                  0437
*                   END;            /*                       @G55DP2M*/
*               END;                /*                       @G55DP2M*/
@RF00434 LA    @12,12                                              0439
         AL    @12,MSGPTR                                          0439
         ST    @12,MSGPTR                                          0439
@DE00433 L     @12,CVTPTR(,R4)                                     0439
         L     @12,RVTPTR(,@12)                                    0439
         L     @07,RVTMSGPT(,@12)                                  0439
         AL    @07,RVTMSGLN(,@12)                                  0439
         C     @07,MSGPTR                                          0439
         BH    @DL00433                                            0439
*               RESPECIFY                                          0440
*                 R8 UNRSTD;        /*                       @G55DP2M*/
*/* ******************************************************************/
*/*  END OF SEGMENT ACRMSG                                           */
*/* ******************************************************************/
*                                                                  0441
*             END;                                                 0441
*             RRPLFLGS='0'B;        /* RESET ANY ERROR INDICATORS    */
*                                                                  0442
         MVI   RRPLFLGS(R6),B'00000000'                            0442
*             /*******************************************************/
*             /*                                                     */
*             /* RESET THE ACR ENVIRONMENT - RETURN TO NORMAL SYSTEM */
*             /* OPERATION                                           */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0443
*RSTRT0B:                           /* FRR RETRY ENTRY PT            */
*             IF RRPLRTRY='0'B THEN /* IS ENTRY DUE TO A RETRY?      */
RSTRT0B  TM    RRPLRTRY(R6),B'10000000'                            0443
         BNZ   @RF00443                                            0443
*               LOGPHID='0B'X;      /* NO, SET PHASE ID 0B           */
         MVI   LOGPHID(R6),X'0B'                                   0444
*             LCCAACR='0'B;         /* SET THE ACR BIT OFF IN LCCA   */
@RF00443 NI    LCCAACR(R10),B'01111111'                            0445
*             CSDACR='0'B;          /* SET THE CSD ACR BYTE TO 0     */
         L     @12,CVTPTR(,R4)                                     0446
         L     @12,CVTCSD(,@12)                                    0446
         MVI   CSDACR(@12),B'00000000'                             0446
*             LCCACRRM='1'B;        /* SET EXIT FLAG FOR FINAL RTN   */
         OI    LCCACRRM(R10),B'01000000'                           0447
*             RESPECIFY                                            0448
*              (R13) UNRSTD;                                       0448
*                                                                  0448
*/* ******************************************************************/
*/*  END OF SEGMENT ACRPOSTP                                         */
*/* ******************************************************************/
*                                                                  0449
*           END;                                                   0449
*         END;                                                     0450
*     END;                                                         0451
*                                                                  0451
@RF00337 DS    0H                                                  0452
*/* ******************************************************************/
*/* ******************************************************************/
*/* ****************       ACR EXIT PROCESSING        ****************/
*/* ******************************************************************/
*/* ******************************************************************/
*                                                                  0452
*   DO;                                                            0452
*                                                                  0452
@RC00188 DS    0H                                                  0453
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACREXPR                                        */
*/*                                                                  */
*/* 02* FUNCTION    ACR EXIT PROCESSOR                               */
*/*                                                                  */
*/* 02* INPUT= PSAPTR (REG 4) - ADDR OF CURR PSA BASED ZERO          */
*/*            RRPLPTR (REG 6) - ADDR OF RECOVERY RTN PARAMETER LIST */
*/*            LCCAPTR (REG 10) - ADDR OF THE CURRENT LCCA           */
*/*            LCCAPTR2(REG 11)- ADDR OF OTHER LCCA                  */
*/*                                                                  */
*/* 02* OUTPUT= SEE EXIT SECTION OF MAIN PROLOGUE                    */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0453
*     RESPECIFY                                                    0453
*      (R1,                                                        0453
*       R2,                                                        0453
*       R14) RSTD;                                                 0453
*                                                                  0453
*     /***************************************************************/
*     /*                                                             */
*     /* EXIT ACR VIA THE SPECIFIC INTERFACE REQUIRED(SEE PROLOGUE)  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0454
*     IF LCCACRLE='0'B              /* IS IT A LOCK MGR OR SPIN    0454
*                                      ROUTINE EXIT?                 */
*       THEN                                                       0454
         TM    LCCACRLE(R10),B'00100000'                           0454
         BNZ   @RF00454                                            0454
*       DO;                         /* NOT LOCK MGR-SPIN EXIT        */
*         IF LCCACRRM='0'B          /* IS IT A DISPATCHER EXIT?      */
*           THEN                                                   0456
         TM    LCCACRRM(R10),B'01000000'                           0456
         BNZ   @RF00456                                            0456
*           DO;                     /* NOT DISPATCHER EXIT           */
*             IF LCCACREF='0'B      /* IS IT AN EXT FLIH OR SLIH   0458
*                                      EXIT?                         */
*               THEN                                               0458
         TM    LCCACREF(R10),B'10000000'                           0458
         BNZ   @RF00458                                            0458
*               DO;                 /* NOT SLIH OR FLIH EXIT         */
*                 IF LCCACRRT='0'B  /* IS IT A RETURN TO RTM?        */
*                   THEN                                           0460
         TM    LCCACRRT(R10),B'00010000'                           0460
         BNZ   @RF00460                                            0460
*                   DO;             /* NO, RTM EXIT, IT MUST BE A  0461
*                                      REQUEST FOR SYSTERM           */
*                     R1=LCCACPUS->WSACACR->ACRENTR1;/* GET REAL   0462
*                                      ADDRESS OF SYSTEM TERMINATION
*                                      PARAMETER LIST                */
         L     @15,LCCACPUS(,R10)                                  0462
         L     @15,WSACACR(,@15)                                   0462
         L     R1,ACRENTR1(,@15)                                   0462
*                     PSAACR='0'B;  /* TURN OFF SUPER                */
         NI    PSAACR(R4),B'11111011'                              0463
*                     DO;           /* SYSTERM EXIT INDICATED        */
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRTRMEX                                       */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THIS SEGMENT PASSES CONTROL TO THE SYSTEM TERMINATION        */
*/*     FACILITY BY EXECUTING A LPSW WITH THE FOLLOWING ATTRIBUTES. -*/
*/*     DISABLED, KEY 0, DAT OFF, EC MODE, SUPERVISOR STATE.         */
*/*     REGISTER 1 CONTAINS THE REAL ADDRESS OF A 2 WORD PARAMETER   */
*/*     LIST WHICH CONTAINS THE REAL ADDRESS OF A MESSAGE BUFFER IN  */
*/*     THE FIRST WORD, AND THE REAL ADDRESS OF THE LOGREC BUFFER IN */
*/*     THE SECOND WORD.                                             */
*/*                                                                  */
*/* 02* INPUT= REGISTER 1 - ADDR OF SYSTERM PARAMETER LIST (REAL)    */
*/*                                                                  */
*/* 02* OUTPUT= REGISTER 1 - PASSED TO SYSTEM TERMINATION (IGFPTERM) */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0465
*                       GENERATE REFS(TRMPSW);                     0465
*                                                                  0465
        LPSW  TRMPSW                    GO TO SYSTEM TERMINATION
*/* ******************************************************************/
*/*   END OF SEGMENT ACRTERMEX                                       */
*/* ******************************************************************/
*                                                                  0466
*                     END;                                         0466
*                   END;                                           0467
*                 ELSE              /* RTM EXIT SET RETURN TO RTM    */
*                   DO;                                            0468
         B     @RC00460                                            0468
@RF00460 DS    0H                                                  0469
*                     R1=ACRENTR1;  /* GET ADDRESS OF RTM REENTRY PSW*/
         L     @15,LCCACPUS(,R10)                                  0469
         L     @15,WSACACR(,@15)                                   0469
         L     R1,ACRENTR1(,@15)                                   0469
*                     PSAPSWSV=R1->RTPSW;/* PLACE PASSED PSW IN PSA
*                                      FOR LPSW                      */
         MVC   PSAPSWSV(8,R4),RTPSW(R1)                            0470
*                     PSAACR='0'B;  /* TURN OFF SUPER BIT            */
         NI    PSAACR(R4),B'11111011'                              0471
*                     GENERATE REFS(R1,R0,R15,PSAPSWSV);           0472
                           LM R0,R15,0(R1)  LOAD PASSED REGISTERS
                           LPSW PSAPSWSV    RETURN TO RTM
*                   END;                                           0473
*               END;                                               0474
*             ELSE                                                 0475
*               DO;                                                0475
         B     @RC00458                                            0475
@RF00458 DS    0H                                                  0476
*                 R2=LCCACPUS->WSACACR->ACRRTNPT;                  0476
         L     @15,LCCACPUS(,R10)                                  0476
         L     @15,WSACACR(,@15)                                   0476
         L     R2,ACRRTNPT(,@15)                                   0476
*                 PSAACR='0'B;      /* TURN OFF SUPER BIT            */
         NI    PSAACR(R4),B'11111011'                              0477
*                 GO TO R2;         /* RETURN TO EXT FLIH OR SLIH    */
         BR    R2                                                  0478
*               END;                                               0479
*           END;                                                   0480
*         ELSE                      /* EXIT TO DISPATCHER          0481
*                                      (POST-PROCESSING PHASE      0481
*                                      COMPLETE)                     */
*           DO;                                                    0481
         B     @RC00456                                            0481
@RF00456 DS    0H                                                  0482
*             R14=CVT0DS;           /* YES,SET UP DISPATCHER RETRN   */
         L     @12,CVTPTR(,R4)                                     0482
         L     R14,CVT0DS(,@12)                                    0482
*             PSAANEW=0;            /* FORCE DISPATCHER TO NEW SEARCH*/
         SLR   @15,@15                                             0483
         ST    @15,PSAANEW(,R4)                                    0483
*             GEN(SETFRR D,WRKREGS=(R1,R2));/* DELETE FRR            */
         SETFRR D,WRKREGS=(R1,R2)
*             GOTO R14;             /* GO TO DISPATCHER              */
         BR    R14                                                 0485
*           END;                                                   0486
*       END;                                                       0487
*     ELSE                          /* YES, LOCK MGR-SPIN EXIT       */
*       DO;                                                        0488
         B     @RC00454                                            0488
@RF00454 DS    0H                                                  0489
*         R14=LCCACPUS->WSACACR->ACRRTNPT;/* PICK UP RESUME POINT  0489
*                                      FROM NOW CURRENT CPU'S ACRSA  */
         L     @12,LCCACPUS(,R10)                                  0489
         L     @12,WSACACR(,@12)                                   0489
         L     R14,ACRRTNPT(,@12)                                  0489
*         PSAACR='0'B;              /* TURN OFF SUPER BIT            */
         NI    PSAACR(R4),B'11111011'                              0490
*         RETURN;                   /* RETURN TO THE LOCK MGR OR   0491
*                                      GLOBAL SPIN ROUTINE, OR THE 0491
*                                      DISPATCHER                    */
@EL00001 DS    0H                                                  0491
@EF00001 DS    0H                                                  0491
@ER00001 BR    @14                                                 0491
*       END;                                                       0492
*     RESPECIFY                                                    0493
*      (R1,                                                        0493
*       R2,                                                        0493
*       R14) UNRESTRICTED;                                         0493
*                                                                  0493
@RC00454 DS    0H                                                  0494
*/* ******************************************************************/
*/*  END OF SEGMENT ACREXPR                                          */
*/* ******************************************************************/
*                                                                  0494
*   END;                                                           0494
*                                                                  0495
*/* ******************************************************************/
*/* ******************************************************************/
*/* ****************       ACR PROCESS SWITCHING      ****************/
*/* ******************************************************************/
*/* ******************************************************************/
*                                                                  0495
*ACRPROSW:                                                         0495
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0495
*                                                                  0495
         B     @EL00001                                            0495
ACRPROSW DS    0H                                                  0496
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT NAME  ACRPROSW                                       */
*/*                                                                  */
*/* 02* FUNCTION   ACR PROCESS SWITCH ROUTINE                        */
*/*     THE ACR PROCESS SWITCH ROUTINE IS THE KEY FUNCTION WHICH     */
*/*     ALLOWS THE SWITCHING OF PROCESSES RUNNING ON TWO CPUS TO BE  */
*/*     SWITCHED INTO ONE CPU TO SHARE IT'S HARDWARE CHARACTERISTICS.*/
*/*     THIS FUNCTION IS NECESSARY AND ACCOMPLISHED BY THIS ROUTINE, */
*/*     TO REMOVE POSSIBLE INTERLOCKS BETWEEN SOFTWARE PROCESSES     */
*/*     WHEN ONE CPU MALFUNCTIONS.  THE PROCESS SWITCH ROUTINE       */
*/*     PROVIDES THE FOLLOWING FUNCTIONS TO THE CALLING ACR ROUTINES.*/
*/*            PREPROCESSOR ENTRY: THE LOGICAL DATA OF THE DEAD CPU  */
*/*                                IS SAVED IN ITS ASSOCIATED ACR    */
*/*                                WORK SAVE AREA.                   */
*/*            OTHER ENTRIES (RTM INTERFACE ROUTINE, LOCK-SPIN INTER-*/
*/*                  FACE ROUTINE, POST PROCESSOR):                  */
*/*                                THE LOGICAL DATA OF THE CURRENT   */
*/*                                CPU PSA IS SAVED IN ITS ASSOCIATED*/
*/*                                ACR WORK SAVE AREA, AND REPLACED  */
*/*                                WITH THE LOGICAL DATA OF THE OTHER*/
*/*                                CPU IN THE ACR UNION, FROM ITS    */
*/*                                ASSOCIATED ACR WORK SAVE AREA.    */
*/*                                                                  */
*/* 02*  INPUT = RRPLPTR (REG 6) - RRPL ADDRESS                      */
*/*              R13     - ADDRESS OF CURRENT ACR WORK SAVE AREA     */
*/*              R14     - RETURN ADDRESS                            */
*/*              PSAPTR2 (REG 9) - DEAD PSA ADDRESS (PREP. ONLY)     */
*/*                      - OTHER ACR PSA ADDRESS ' CPU TO            */
*/*                        BE GAINING CONTROL' (ALL OTHER ENTRIES)   */
*/*              LCCAPTR (REG 10) - CURRENT LCCA ADDRESS(ALL ENTRIES)*/
*/*              LCCAPTR2 (REG 11) - DEAD LCCA ADDRESS (PREP. ONLY)  */
*/*                      - OTHER ACR LCCA ADDRESS 'CPU TO BE         */
*/*                        GAINING CONTROL' (ALL OTHER ENTRIES)      */
*/*                                                                  */
*/* 02*  OUTPUT = RRPLPTR (REG 6) - RRPL ADDRESS  (ALL ENTRIES)      */
*/*               PSAPTR2 (REG 9) - DEAD PSA ADDRESS (PREP. ONLY)    */
*/*                      - OTHER ACR PSA ADDRESS 'NEW CPU NOW        */
*/*                        GAINING CONTROL' (ALL OTHER ENTRIES)      */
*/*              LCCAPTR (REG 10) - CURRENT LCCA ADDRESS(ALL ENTRIES)*/
*/*              LCCAPTR2 (REG 11) - DEAD LCCA ADDRESS (PREP. ONLY)  */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0496
*   DO;                                                            0496
*                                                                  0496
*     /***************************************************************/
*     /*                                                             */
*     /* SAVE THE ENTRY ENVIRONMENT                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0497
*     RESPECIFY                                                    0497
*      (R13,                                                       0497
*       R8,                                                        0497
*       R7) RESTRICTED;                                            0497
*     GENERATE REFS(R0,R15,ACRACRSV,R13);                          0498
         STM R0,R15,ACRACRSV(R13)        SAVE ENTRY REGS            */
*     RRPLFLGS='0'B;                /* RESET ANY PREVIOUS PHASE ERROR
*                                      INDICATIONS.                  */
         MVI   RRPLFLGS(R6),B'00000000'                            0499
*     GEN REFS(RRPLREGS,R6)(STM 0,14,RRPLREGS(R6));/* SAVE REGS FOR
*                                      RECURSION                     */
         STM 0,14,RRPLREGS(R6)
*RSTRTX0:                           /* FRR RETRY ENTRY POINT         */
*     IF RRPLRTRY='0'B THEN         /* IS ENTRY FROM THE FRR         */
*                                                                  0501
RSTRTX0  TM    RRPLRTRY(R6),B'10000000'                            0501
         BNZ   @RF00501                                            0501
*       /*************************************************************/
*       /*                                                           */
*       /* BUILD THE PROCESS SWITCH LOGICAL PHASE ID                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0502
*       LOGPHID=LOGPHID*16;         /* NO, SHIFT THE PHASE ID TO   0502
*                                      PRODUCE A RESULTING PHASE ID
*                                      OF 10, 20, 30, OR 40,       0502
*                                      CORRESPONDING WITH ENTRY      */
         SLR   @12,@12                                             0502
         IC    @12,LOGPHID(,R6)                                    0502
         SLA   @12,4                                               0502
         STC   @12,LOGPHID(,R6)                                    0502
*     IF LCCACRIN='1'B THEN         /* PREPROCESSOR ENTRY?           */
@RF00501 TM    LCCACRIN(R10),B'00001000'                           0503
         BNO   @RF00503                                            0503
*       DO;                         /* PREPROCESSOR ENTRY            */
*         R13=R11->LCCACPUS->WSACACR;/* SET BASE TO DEAD CPU ACR WORK
*                                      SAVE AREA                     */
         L     @01,LCCACPUS(,R11)                                  0505
         L     R13,WSACACR(,@01)                                   0505
*         R7=R9;                    /* SET BASE TO DEAD PSA FOR THE
*                                      MOVE SECTION                  */
*                                                                  0506
         LR    R7,R9                                               0506
*         /***********************************************************/
*         /*                                                         */
*         /* OBTAIN AND SAVE THE DEAD CPU'S SEGMENT TABLE ORIGIN     */
*         /* REGISTER                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0507
*         R13->ACRCTRG1=R9->PSAAOLD->ASCBSTOR;                     0507
         L     @12,PSAAOLD(,R9)                                    0507
         L     @12,ASCBSTOR(,@12)                                  0507
         ST    @12,ACRCTRG1(,R13)                                  0507
*       END;                                                       0508
*     ELSE                                                         0509
*       DO;                         /* NOT PREPROCESSOR              */
         B     @RC00503                                            0509
@RF00503 DS    0H                                                  0510
*         R7=0;                     /* SET CURRENT PSA FOR MOVES     */
*                                                                  0510
         SLR   R7,R7                                               0510
*         /***********************************************************/
*         /*                                                         */
*         /* THE SEGMENT TABLE ORIGIN REGISTER IS SAVED IN THE ACR   */
*         /* WORK AREA                                               */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0511
*         GENERATE REFS(R1,R13,ACRCTRG1);                          0511
           STCTL R1,R1,ACRCTRG1(R13)    SAVE CONT REG 1
*       END;                                                       0512
*     DO;                                                          0513
*                                                                  0513
@RC00503 DS    0H                                                  0514
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRMVPSA                                       */
*/*                                                                  */
*/*     FUNCTION                                                     */
*/*     THIS SEGMENT MOVES LOGICAL DATA FROM A PSA (DESIGNATED BY    */
*/*     AMVPTR) TO ITS ASSOCIATED ACR WORK SAVE AREA (DESIGNATED BY  */
*/*     AWSAPTR).  THE MOVE IS BROKEN INTO THREE LOGICAL SECTIONS-   */
*/*     1- MOVE OF LOGICAL DATA FROM HARDWARE FLC LOCATIONS TO THE   */
*/*         ACR WORK SAVE AREA                                       */
*/*      2- MOVE OF THE ENTIRE SOFTWARE SECTION OF THE PSA TO THE    */
*/*         ACR WORK SAVE AREA.  (FOR THIS MOVE THE PSA MAPPING IS   */
*/*        PLACED OVER THE WORK AREA SO THAT THE SOFTWARE PSA SECTION*/
*/*        (PSAPSA) IS POSITIONED FOLLOWING THE PREVIOUSLY MOVED     */
*/*         FLC LOCATIONS.                                           */
*/*    3-MOVE OF THE NORMAL STACK FROM ITS PSA LOCATION(PSASTAK)     */
*/*                                                                  */
*/* 02* INPUT = AWSAPTR - PTR TO ACR WORK SAVE AREA TO WHICH         */
*/*                       DATA IS TO BE MOVED                        */
*/*             AMVPTR  - ADDRESS OF THE PSA TO MOVE FROM            */
*/*             LCCAPTR2- ADDRESS OF THE LCCA ASSOCIATED             */
*/*                       WITH THE ACR WORK SAVE AREA PASSED         */
*/*                                                                  */
*/* 02* OUTPUT=                                                      */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0514
*       RESPECIFY                                                  0514
*        (R2,                                                      0514
*         R3,                                                      0514
*         R14,                                                     0514
*         R15) RESTRICTED;                                         0514
*                                                                  0514
*       /*************************************************************/
*       /*                                                           */
*       /* MOVE FLC HARDWARE LOCATIONS TO THE ACR WORK SAVE AREA     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0515
*       R13->ACRRPSW=R7->FLCROPSW;  /* SAVE THE RESTART OPSW         */
         MVC   ACRRPSW(8,R13),FLCROPSW(R7)                         0515
*       R13->ACROPSW=R7->APSWSTRT;  /* SAVE THE OLD PSWS             */
         MVC   ACROPSW(64,R13),APSWSTRT(R7)                        0516
*       R13->ACREPSWS=R7->AECSTRT;  /* SAVE THE PSW EXTENSIONS       */
*                                                                  0517
         MVC   ACREPSWS(28,R13),AECSTRT(R7)                        0517
*       /*************************************************************/
*       /*                                                           */
*       /* PLACE CPU MASK AND ADDRESS IN SAVE AREA FOR EASE OF ACCESS*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0518
*       R13->ACRCPUAD=R7->PSACPUPA; /* OBTAIN AND SAVE CPU ADDR      */
         LH    @12,PSACPUPA(,R7)                                   0518
         STH   @12,ACRCPUAD(,R13)                                  0518
*       R13->ACRCAFM=BITS(R7->PSACPUPA+1);/* DEVELOPE MASK & SAV     */
*                                                                  0519
         ALR   @12,@12                                             0519
         LA    @01,BITS(@12)                                       0519
         MVC   ACRCAFM(2,R13),0(@01)                               0519
*       /*************************************************************/
*       /*                                                           */
*       /* SET BASE TO ALLOW PSA MAPPING FOR THE SOFTWARE SECTION OF */
*       /* THE PSA IN THE ACR WORK SAVE AREA                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0520
*       R13=ADDR(R13->AWSAEND)-512;                                0520
*                                                                  0520
         LA    @12,AWSAEND(,R13)                                   0520
         SL    @12,@CF02412                                        0520
         LR    R13,@12                                             0520
*       /*************************************************************/
*       /*                                                           */
*       /* MOVE THE SOFTWARE SECTION OF THE PSA TO THE ACR WORK      */
*       /* SAVEAREA                                                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0521
*       R3=ADDR(R13->ACRPSEND)-ADDR(R13->ACRPSA);/* DETERMINE THE  0521
*                                      LENGTH TO MOVE                */
         LA    R3,536                                              0521
*       R15=R3;                     /* SET LENGTH FOR MOVE           */
         LR    R15,R3                                              0522
*       R2=ADDR(R13->ACRPSA);       /* DEFINE TO ADDRESS             */
         LA    R2,ACRPSA(,R13)                                     0523
*       R14=ADDR(R7->PSAPSA);       /* DEFINE FROM ADDRESS           */
         LA    R14,PSAPSA(,R7)                                     0524
*       GENERATE REFS(R2,R14);                                     0525
        MVCL R2,R14                    MOVE ENTIRE PSA SOFTWARE AREA
*       R13->PSAACR='1'B;           /* SET ACR SUPER BIT ON IN     0526
*                                      'SAVED' PSA SO THAT IT WILL BE
*                                      ON WHEN THE SAVED PSA DATA IS
*                                      MOVED INTO THE PSA            */
         OI    PSAACR(R13),B'00000100'                             0526
*       R3=LENGTH(PSASTAK);         /* GET LENGTH OF THE CURRENT   0527
*                                      STACK                         */
         LA    R3,596                                              0527
*       R15=R3;                     /* SET LENGTH FOR MOVE           */
         LR    R15,R3                                              0528
*       R2=ADDR(R13->PSAUSEND);     /* DEFINE TO ADDRESS             */
         LA    R2,PSAUSEND(,R13)                                   0529
*       R14=ADDR(R7->PSASTAK);      /* DEFINE FROM ADDRESS           */
         LA    R14,PSASTAK(,R7)                                    0530
*       GENERATE REFS(R2,R14);                                     0531
       MVCL R2,R14                MOVE STACK TO SAVE AREA
*       RESPECIFY                                                  0532
*        (R2,                                                      0532
*         R3,                                                      0532
*         R14,                                                     0532
*         R15) UNRESTRICTED;                                       0532
*                                                                  0532
*       /*************************************************************/
*       /*                                                           */
*       /* PLACE THE CPU HIGHEST LOCK HELD INDICATOR IN THE          */
*       /* ASSOCIATED LCCA FOR THE SETLOCK MANAGER                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0533
*       R7->PSALCCAV->LCCACRLC=R7->PSAHLHI;                        0533
*                                                                  0533
         L     @12,PSALCCAV(,R7)                                   0533
         L     @15,PSAHLHI(,R7)                                    0533
         ST    @15,LCCACRLC(,@12)                                  0533
*/* ******************************************************************/
*/*  END OF SEGMENT ACRMVPSA                                         */
*/* ******************************************************************/
*                                                                  0534
*     END;                                                         0534
*     IF LCCACRIN='0'B THEN         /* IS IT A PREPROCESSOR ENTRY?   */
         TM    LCCACRIN(R10),B'00001000'                           0535
         BNZ   @RF00535                                            0535
*       DO;                         /* NOT PREPROCESSOR ENTRY        */
*         GEN REFS(RRPLREGS,R6)(STM 0,14,RRPLREGS(R6));/* SAVE REGS
*                                      FOR RECURSION                 */
         STM 0,14,RRPLREGS(R6)
*         RRPLFLGS='0'B;            /* CLEAR ERROR FLAGS             */
         MVI   RRPLFLGS(R6),B'00000000'                            0538
*         LOGPHID=LOGPHID|'01'X;    /* SET PHASE ID TO X1            */
         OI    LOGPHID(R6),X'01'                                   0539
*RSTRTX1:                           /* FRR RETRY ENTRY PT            */
*         R7=WSACACR;               /* SET BASE TO CURRENT ACR WORK
*                                      AREA                          */
RSTRTX1  L     @12,LCCACPUS(,R10)                                  0540
         L     R7,WSACACR(,@12)                                    0540
*         R13=R11->LCCACPUS->WSACACR;/* SET BASE TO OTHER CPU ACR  0541
*                                      WORK SAVE AREA                */
         L     @01,LCCACPUS(,R11)                                  0541
         L     R13,WSACACR(,@01)                                   0541
*         R8=ADDR(R7->ACRACRWA);    /* SET BASE TO NEXT PHASES RRPL
*                                      BUILD AREA                    */
         LA    R8,ACRACRWA(,R7)                                    0542
*         GENERATE REFS(ACRCTRG1,R13,R1);                          0543
              LCTL R1,R1,ACRCTRG1(R13)   SET CONTROL REGISTER 1
*         DO;                                                      0544
*                                                                  0544
*/* ******************************************************************/
*/*                                                                  */
*/* 01* SEGMENT-NAME  ACRMVSVA                                       */
*/*                                                                  */
*/* 02* FUNCTION                                                     */
*/*     THIS SEGMENT MOVES LOGICAL DATA FROM AN ACR WORK SAVE AREA   */
*/*    (DESIGNATED BY AWSAPTR) TO THE CURRENT PSA.  THE MOVE IS      */
*/*     BROKEN INTO THREE LOGICAL SECTIONS.                          */
*/*    1- MOVE OF THE HARDWARE FLC FIELDS SAVED IN THE ACR WORK SAVE */
*/*       AREA TO THE CURRENT PSA FLC AREA OF THE PSA.               */
*/*    2- MOVE OF ENTIRE PSA SOFTWARE SECTION OF THE PSA SAVED IN THE*/
*/*        ACR WORK SAVE AREA, WITH THE EXCEPTION OF THE PSAPCCA REAL*/
*/*        AND VIRTUAL ADRESSES(PSAPCCAR,PSAPCCAV).                  */
*/*    3-MOVE OF THE NORMAL STACK TO ITS PROPER PSA LOCATION.        */
*/*                                                                  */
*/* 02* INPUT = AWSAPTR - ADDRESS OF THE ACR WORK SAVE TO MOVE       */
*/*                                                                  */
*/* 02* OUTPUT=                                                      */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0545
*           RESPECIFY                                              0545
*            (R2,                                                  0545
*             R3,                                                  0545
*             R14,                                                 0545
*             R15) RESTRICTED;                                     0545
*                                                                  0545
*           /*********************************************************/
*           /*                                                       */
*           /* MOVE DATA TO THE PSA FLC FROM THE ACR WORK SAVE AREA  */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0546
*           FLCROPSW=R13->ACRRPSW;  /* RESTORE THE RESTART OLD PSW   */
         MVC   FLCROPSW(8,R4),ACRRPSW(R13)                         0546
*           APSWSTRT=R13->ACROPSW;  /* RESTORE THE OLD PSWS          */
         MVC   APSWSTRT(64,R4),ACROPSW(R13)                        0547
*           AECSTRT=R13->ACREPSWS;  /* RESTORE THE PSW EXTENSIONS    */
*                                                                  0548
         MVC   AECSTRT(28,R4),ACREPSWS(R13)                        0548
*           /*********************************************************/
*           /*                                                       */
*           /* SET BASE TO ALLOW PSA MAPPING FOR THE SOFTWARE SECTION*/
*           /* OF THE PSA IN THE ACR WORK SAVE AREA.                 */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0549
*           R13=ADDR(R13->AWSAEND)-512;                            0549
*                                                                  0549
         LA    @12,AWSAEND(,R13)                                   0549
         SL    @12,@CF02412                                        0549
         LR    R13,@12                                             0549
*           /*********************************************************/
*           /*                                                       */
*           /* MOVE FIRST AREA TO PSA (PSAPSA TO PSAPCCAV)           */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0550
*           R2=ADDR(PSAPCCAV);      /* DETERMINE END OF MOVE         */
         LA    R2,PSAPCCAV(,R4)                                    0550
*           R3=ADDR(PSAPSA);        /* DETERMINE START OF MOVE       */
         LA    R3,PSAPSA(,R4)                                      0551
*           R2=R2-R3;               /* DETERMINE LENGTH TO MOVE      */
         SLR   R2,R3                                               0552
*           PSAPSA(1:R2)=R13->ACRPSA(1:R2);/* MOVE DATA TO PSA       */
*                                                                  0553
         LR    @12,R2                                              0553
         BCTR  @12,0                                               0553
         EX    @12,@SM03164                                        0553
*           /*********************************************************/
*           /*                                                       */
*           /* MOVE SECOND AREA TO PSA (PSALCCAV TO PSAUSEND)        */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0554
*           R3=ADDR(PSAUSEND)-ADDR(PSALCCAV);/* DETERMINE LENGTH TO
*                                      MOVE                          */
         LA    R3,520                                              0554
*           R15=R3;                 /* SET LENGTH TO MOVE            */
         LR    R15,R3                                              0555
*           R2=ADDR(PSALCCAV);      /* SET START ADDRESS             */
         LA    R2,PSALCCAV(,R4)                                    0556
*           R14=ADDR(R13->ACRLCCAV);/* SET FROM ADDRESS              */
         LA    R14,ACRLCCAV(,R13)                                  0557
*           GENERATE REFS(R2,R14);                                 0558
*                                                                  0558
        MVCL R2,R14                 MOVE TO PSA
*           /*********************************************************/
*           /*                                                       */
*           /* MOVE THIRD AREA TO PSA (SAVED CURRENT STACK)          */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0559
*           R3=LENGTH(PSASTAK);     /* DETERMINE LENGTH TO MOVE      */
         LA    R3,596                                              0559
*           R15=R3;                 /* SET MOVE LENGTH               */
         LR    R15,R3                                              0560
*           R2=ADDR(PSASTAK);       /* SET PSA START ADDRESS         */
         LA    R2,PSASTAK(,R4)                                     0561
*           R14=ADDR(R13->PSAUSEND);/* SET FROM ADDRESS              */
         LA    R14,PSAUSEND(,R13)                                  0562
*           GENERATE REFS(R2,R14);                                 0563
        MVCL R2,R14                    MOVE TO PSA
*           PSACPUSA=PSAPCCAV->PCCACPUA;/* RE-SET CPU STATIC PHYSICAL
*                                      ADDRESS TO CORRESPOND TO THE
*                                      PCCA FOR THIS CPU     @YM03489*/
         L     @12,PSAPCCAV(,R4)                                   0564
         LH    @12,PCCACPUA(,@12)                                  0564
         STH   @12,PSACPUSA(,R4)                                   0564
*           RESPECIFY                                              0565
*            (R2,                                                  0565
*             R3,                                                  0565
*             R14,                                                 0565
*             R15) UNRESTRICTED;                                   0565
*                                                                  0565
*/* ******************************************************************/
*/*  END OF SEGMENT ACRMVSVA                                         */
*/* ******************************************************************/
*                                                                  0566
*         END;                                                     0566
*                                                                  0566
*         /***********************************************************/
*         /*                                                         */
*         /* SWAP LCCA POINTERS (LCCAPTR2,LCCAPTR)                   */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0567
*         RFY                                                      0567
*           R15 RSTD;                                              0567
*         R15=R11;                  /* TEMP SAVE OTHER LCCA PTR      */
         LR    R15,R11                                             0568
*         R11=R10;                  /* SET OTHER LCCA PTR AS THE PTR
*                                      TO THE ORIGINAL CURRENT       */
         LR    R11,R10                                             0569
*         R10=R15;                  /* SET CURRENT LCCA PTR TO THE 0570
*                                      ONE THAT WAS THE 'OTHER' LCCA */
         LR    R10,R15                                             0570
*         RFY                                                      0571
*           R15 UNRSTD;                                            0571
*         RESPECIFY                                                0572
*          (R14) RSTD;                                             0572
*         R14=R7->ACRSVR14;         /* PICK UP RETAURN ADDRESS       */
         L     R14,ACRSVR14(,R7)                                   0573
*       END;                                                       0574
*     ELSE                                                         0575
*       DO;                         /* PREPROCESSOR RETURN           */
*                                                                  0575
         B     @RC00535                                            0575
@RF00535 DS    0H                                                  0576
*         /***********************************************************/
*         /*                                                         */
*         /* RESET MCH FLAGS IN THE PSA JUST SAVED(DEAD) SO THAT MCH */
*         /* CODE CALLED BY RTM(DURING INTERMEDIATE PHASE) WORKS     */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0576
*         R13->PSAMCHFL='00'X;      /* RESET MCH RECURSION BYTE      */
         MVI   PSAMCHFL(R13),X'00'                                 0576
*         R13->PSAMCHIC='00'X;      /* RESET MCH INIT. BYTE          */
         MVI   PSAMCHIC(R13),X'00'                                 0577
*         R13=WSACACR;              /* RESET PTR TO ACR WORK AREA    */
         L     @15,LCCACPUS(,R10)                                  0578
         L     R13,WSACACR(,@15)                                   0578
*         GENERATE REFS(R0,R15,ACRACRSV,R13);                      0579
           LM R0,R15,ACRACRSV(R13)      RESTORE ENTRY REGS          */
*       END;                                                       0580
*     RESPECIFY                                                    0581
*      (R13,                                                       0581
*       R14,                                                       0581
*       R13,                                                       0581
*       R7) UNRESTRICTED;                                          0581
*     RETURN;                                                      0582
@EL00002 DS    0H                                                  0582
@EF00002 DS    0H                                                  0582
@ER00002 BR    @14                                                 0582
*   END;                                                           0583
*                                                                  0583
*/* ******************************************************************/
*/*  END OF SEGMENT ACRPROSW                                         */
*/* ******************************************************************/
*                                                                  0584
*   END ACRPROSW;                                                  0584
         B     @EL00002                                            0584
*   END IEAVTACR                                                   0585
*                                                                  0585
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (ACRSPEC )                                       */
*/*%INCLUDE SYSLIB  (ACRDCL  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHACSD  )                                       */
*/*%INCLUDE SYSLIB  (IHALRB  )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (IHALCCAT)                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHARVT  )                                       */
*/*%INCLUDE SYSLIB  (IGFMSG  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCAT)                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (IECDIOCM)                                       */
*/*%INCLUDE SYSLIB  (IECDIOCX)                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IEECUCM )                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (ACRINIT1)                                       */
*/*%INCLUDE SYSLIB  (ACRPREP )                                       */
*/*%INCLUDE SYSLIB  (ACRSTERM)                                       */
*/*%INCLUDE SYSLIB  (ACRINIT2)                                       */
*/*%INCLUDE SYSLIB  (ACRRTM  )                                       */
*/*%INCLUDE SYSLIB  (ACRLKSPI)                                       */
*/*%INCLUDE SYSLIB  (ACRPOSTP)                                       */
*/*%INCLUDE SYSLIB  (ACRVARY )                                       */
*/*%INCLUDE SYSLIB  (ACRIORST)                                       */
*/*%INCLUDE SYSLIB  (ACRCONSW)                                       */
*/*%INCLUDE SYSLIB  (ACROPTEV)                                       */
*/*%INCLUDE SYSLIB  (ACRMSG  )                                       */
*/*%INCLUDE SYSLIB  (ACREXPR )                                       */
*/*%INCLUDE SYSLIB  (ACRTRMEX)                                       */
*/*%INCLUDE SYSLIB  (ACRPROSW)                                       */
*/*%INCLUDE SYSLIB  (ACRMVPSA)                                       */
*/*%INCLUDE SYSLIB  (ACRMVSVA)                                       */
*                                                                  0585
*       ;                                                          0585
@DATA    DS    0H
@CH03134 DC    XL2'FFFF'
@SM03164 MVC   PSAPSA(0,R4),ACRPSA(R13)
@DATD    DSECT
         DS    0F
IEAVTACR CSECT
         DS    0F
@CF02839 DC    F'80'
@CF02412 DC    F'512'
@CF03111 DC    XL4'FFFFFFFF'
@CF03159 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
IEAVTACR CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CA02844 DC    A(IGFPTERM)
@CA02845 DC    A(IEAVTCR1)
@CV02846 DC    V(IECVRSTI)
         DS    0D
MSGPTR   DS    A
UCBPTR   DS    A
UCBLKPTR DS    A
         DS    CL4
PSWMODEL DC    X'040C000000000000'
TRMPSW   DS    CL8
         ORG   TRMPSW
TRMIMSK  DC    X'00'
TRMKYMWP DC    X'0C'
TRMCCPMK DC    X'00'
@NM00082 DC    X'00'
TRMPSWIC DC    AL4(IGFPTERM)
         ORG   TRMPSW+8
MCDSPSW  DS    CL8
         ORG   MCDSPSW
MCDIMSK  DC    X'04'
MCDKYWMP DC    X'08'
MCDCCPMK DC    X'00'
@NM00083 DC    X'00'
MCDPSWIC DC    AL4(MCDSABL)
         ORG   MCDSPSW+8
MCENPSW  DS    CL8
         ORG   MCENPSW
MCEIMSK  DC    X'04'
MCEKYWMP DC    X'0C'
MCECCPMK DC    X'00'
@NM00084 DC    X'00'
MCEPSWIC DC    AL4(MCENABL)
         ORG   MCENPSW+8
BITS     DC    X'8000'
         ORG   BITS+0
BITZ     DS    CL1
@NM00077 DS    CL1
         ORG   BITS+2
         DC    X'4000'
         ORG   BITS+4
         DC    X'2000'
         ORG   BITS+6
         DC    X'1000'
         ORG   BITS+8
         DC    X'0800'
         ORG   BITS+10
         DC    X'0400'
         ORG   BITS+12
         DC    X'0200'
         ORG   BITS+14
         DC    X'0100'
         ORG   BITS+16
         DC    X'0080'
         ORG   BITS+18
         DC    X'0040'
         ORG   BITS+20
         DC    X'0020'
         ORG   BITS+22
         DC    X'0010'
         ORG   BITS+24
         DC    X'0008'
         ORG   BITS+26
         DC    X'0004'
         ORG   BITS+28
         DC    X'0002'
         ORG   BITS+30
         DC    X'0001'
         ORG   BITS+32
IEAVTACR CSECT
MSG856W  WTO   'IEA856W ACR RECURSIVELY INVOKED BY CPU XX',           **
               ROUTCDE=(1,10),DESC=(1),MF=L
MSG858I  WTO   'IEA858I ACR COMPLETE, CPU XX NOW OFFLINE',            **
               ROUTCDE=(2,10),DESC=(2),MF=L                   @ZA01876
@DATD    DSECT
@ENDDATD EQU   *
IEAVTACR CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
R5       EQU   @05
         ENTRY ACRSTART
         ENTRY RSTRT0A
         ENTRY RSTRT0B
         ENTRY RSTRT04
         ENTRY RSTRT05
         ENTRY RSTRT06
         ENTRY RSTRT07
         ENTRY RSTRT08
         ENTRY RSTRT09
         ENTRY RSTRT00
         ENTRY RSTRTX0
         ENTRY RSTRTX1
         EXTRN IGFPTERM
         EXTRN IEAVTCR1
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
FLCEOPSW EQU   PSA+24
FLCENPSW EQU   PSA+88
PSAEEPSW EQU   PSA+132
PSASPAD  EQU   PSAEEPSW
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMTRCD EQU   PSA+157
FLCMCLA  EQU   PSA+168
FLCCHNID EQU   FLCMCLA
FLCCHTM  EQU   FLCCHNID
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
PSAMEDC  EQU   FLCMCLA+76
FLCFSA   EQU   FLCMCLA+80
PSAPSA   EQU   PSA+512
PSACPUPA EQU   PSA+516
PSAPCCAV EQU   PSA+520
PSALCCAV EQU   PSA+528
PSAANEW  EQU   PSA+544
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSAACR   EQU   PSASUP2
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSAPSWSV EQU   PSA+768
PSAMCHFL EQU   PSA+780
PSAMCHIC EQU   PSA+783
PSACPUSA EQU   PSA+794
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSAUSEND EQU   PSA+1048
PSASTAK  EQU   PSA+3072
CVTMAP   EQU   0
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTCUCB  EQU   CVTMAP+100
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIXAVL EQU   CVTMAP+124
CVT0DS   EQU   CVTMAP+136
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTRMS   EQU   CVTMAP+224
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
CSD      EQU   0
CSDCPUJS EQU   CSD+4
CSDCPUAL EQU   CSD+8
CSDSCWRD EQU   CSD+12
CSDSCFL1 EQU   CSDSCWRD
CSDSCFL2 EQU   CSDSCWRD+1
CSDSCFL3 EQU   CSDSCWRD+2
CSDSCFL4 EQU   CSDSCWRD+3
CSDACR   EQU   CSD+22
CSDFLAGS EQU   CSD+23
LRB      EQU   0
LRBHTYPE EQU   LRB
LRBHREL  EQU   LRB+1
LRBHSYS  EQU   LRBHREL
LRBHSW0  EQU   LRB+2
LRBHSW1  EQU   LRB+3
LRBHSW2  EQU   LRB+4
LRBMACT  EQU   LRBHSW2
LRBHSW3  EQU   LRB+5
LRBHCPID EQU   LRB+16
LRBBASE  EQU   LRB+24
LRBCVAR  EQU   0
LRBCMP   EQU   LRBCVAR+8
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCACPUS EQU   LCCA+536
LCCADSF1 EQU   LCCA+540
LCCAACR  EQU   LCCADSF1
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCADCPU EQU   LCCA+676
LCCARCPU EQU   LCCA+680
LCCACRLC EQU   LCCA+684
LCCACRFL EQU   LCCA+692
LCCACRTM EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCAVARY EQU   LCCACRFL
LCCACREX EQU   LCCA+693
LCCACREF EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRST EQU   LCCACREX
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
LCCAVT   EQU   0
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBSTOR EQU   ASCB+44
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
RVT      EQU   0
RVTMSGPT EQU   RVT+88
RVTMSGLN EQU   RVT+92
MSG      EQU   0
MSGNUM   EQU   MSG+1
MSGTAB1  EQU   MSG+2
MSGCHAR  EQU   MSG+4
MSGVAR1  EQU   MSGCHAR
PCCAVT   EQU   0
PCCAT00P EQU   PCCAVT
PCCA     EQU   0
PCCACPUA EQU   PCCA+16
PCCAPSAV EQU   PCCA+24
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCARMS  EQU   PCCARMSB
PCCACHAN EQU   PCCA+224
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCAATTR EQU   PCCA+376
PCCAIO   EQU   PCCAATTR
IOCOM    EQU   0
IOCOMEX  EQU   IOCOM+64
IOCX     EQU   0
IOX      EQU   IOCX
WSAG     EQU   0
WSAC     EQU   0
WSACACR  EQU   WSAC+16
UCM2EXT  EQU   0
UCM2STA  EQU   UCM2EXT+8
UCM2SFLG EQU   UCM2STA
UCM2FEXT EQU   UCM2EXT+12
UCMPRFX  EQU   0
UCMSAVE0 EQU   UCMPRFX+4
UCMSFLGS EQU   UCMPRFX+84
UCMSFLG1 EQU   UCMSFLGS
UCMSFLG2 EQU   UCMSFLGS+1
UCMUEXIT EQU   UCMPRFX+97
UCMXSA   EQU   UCMPRFX+104
UCMSDS1  EQU   UCMPRFX+156
UCM2PTR  EQU   0
UCMPRFXP EQU   0
UCM      EQU   0
UCMDECB  EQU   UCM+12
UCMARECB EQU   UCM+16
UCMLSTP  EQU   UCM+20
UCMRPYI  EQU   UCM+32
UCMPXB   EQU   UCM+68
UCMMODE  EQU   UCMPXB
UCMVDATA EQU   UCM+72
UCMRSV42 EQU   UCM+300
UCMRSV51 EQU   UCM+301
UCMEIL   EQU   0
UCMRECBA EQU   UCMEIL+24
UCMLIST  EQU   0
UCMSTS   EQU   UCMLIST+24
UCMATR   EQU   UCMLIST+25
UCMXA    EQU   UCMLIST+26
UCMAUTH  EQU   UCMLIST+40
UCMAUTHA EQU   UCMAUTH
UCMDISP  EQU   UCMLIST+42
UCMDISP1 EQU   UCMDISP
UCMDISP2 EQU   UCMDISP+1
UCMMSG   EQU   UCMLIST+60
UCMMSG1  EQU   UCMMSG
UCMDEVC  EQU   UCMLIST+63
UCMRCT   EQU   UCMLIST+68
UCMSDS5  EQU   UCMRCT
UCMFEXTP EQU   UCMLIST+72
UCMDVEPT EQU   0
UCMEXIT  EQU   0
UCMFEXTA EQU   0
UCMFPPTR EQU   UCMFEXTA+4
UCMFMGFS EQU   UCMFEXTA+8
UCMFFLG1 EQU   UCMFMGFS
UCMFECBL EQU   UCMFEXTA+28
UCMFRECB EQU   UCMFECBL+4
UCMFRBYT EQU   UCMFRECB
UCMPEXTA EQU   0
UCMPDM1  EQU   UCMPEXTA+4
UCMEFEXT EQU   0
UCMEFLG1 EQU   UCMEFEXT
UCMEFPEX EQU   UCMEFEXT+4
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00070 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSPTR  EQU   0
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRREPTR  EQU   0
UCBTAB   EQU   0
CVDDWD   EQU   8
STRMPARM EQU   0
STWPL    EQU   STRMPARM
STLRB    EQU   STRMPARM+4
RRPL     EQU   0
LOGPHID  EQU   RRPL
RRPLFLGS EQU   RRPL+1
RRPLRTRY EQU   RRPLFLGS
RRPLOL   EQU   RRPLFLGS
RRPLCSD  EQU   RRPLFLGS
RRPLCNTS EQU   RRPL+2
RRPLREGS EQU   RRPL+4
RRPLRRGS EQU   RRPLREGS
RTMPARM  EQU   0
RTPSW    EQU   RTMPARM+64
ACRSA    EQU   0
ACRSVBSE EQU   ACRSA
ACRLMFSV EQU   ACRSVBSE
ACRLMGSV EQU   ACRSVBSE+32
ACRMCHEB EQU   ACRSVBSE+96
ACRRRPLP EQU   ACRMCHEB
ACRCTRG1 EQU   ACRSVBSE+100
ACRACRSV EQU   ACRSVBSE+104
ACRSVR14 EQU   ACRACRSV+56
ACRRRPL  EQU   ACRSVBSE+176
ACRRTNPT EQU   ACRSVBSE+240
ACRENTR1 EQU   ACRSVBSE+244
ACRACRWA EQU   ACRSVBSE+248
ACRFLCSV EQU   ACRSVBSE+272
ACRRPSW  EQU   ACRFLCSV
ACROPSW  EQU   ACRFLCSV+8
ACREPSWS EQU   ACRFLCSV+72
ACRCPIDS EQU   ACRSA+376
ACRCAFM  EQU   ACRCPIDS
ACRCPUAD EQU   ACRCPIDS+2
AWSAEND  EQU   ACRSA+380
UCBBGN   EQU   0
UCMEPEXT EQU   0
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
PSAMSTK  EQU   PSARSVTE+16
PSAMSAV  EQU   PSARSVTE+20
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTCSD   EQU   CVTS01+312
CVTSPSA  EQU   CVTS01+336
CVTPCCAT EQU   CVTS01+416
CVTLCCAT EQU   CVTS01+420
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTVACR  EQU   CVTS01+544
CVTGSDA  EQU   CVTS01+600
LRBHRSW1 EQU   LRBHSW1
LRBHCSW1 EQU   LRBHSW1
LRBHMSW1 EQU   LRBHSW1
LRBMMCH  EQU   LRBBASE
LRBMWSC  EQU   LRBMMCH+4
LRBMCEIA EQU   LRBMMCH+8
LRBMTERM EQU   LRBMCEIA
LRBMHARD EQU   LRBMCEIA+1
LRBMINTM EQU   LRBMCEIA+2
LRBMSOFT EQU   LRBMCEIA+3
LRBMPDAR EQU   LRBMMCH+12
LRBMRSR1 EQU   LRBMMCH+13
LRBMRSR2 EQU   LRBMMCH+14
LRBMFLO  EQU   LRBMMCH+24
LRBMCIC  EQU   LRBMFLO
@NM00047 EQU   LRBMCIC
@NM00049 EQU   LRBMCIC+1
@NM00051 EQU   LRBMCIC+2
@NM00053 EQU   LRBMCIC+3
@NM00055 EQU   LRBMCIC+5
LRBMEDC  EQU   LRBMFLO+12
LRBRDDR  EQU   LRBBASE
LRBCCCH  EQU   LRBBASE
LRBCCUA  EQU   LRBCCCH+49
LRBDMDR  EQU   LRBBASE
LRBNMIH  EQU   LRBBASE
LRBTTER  EQU   LRBBASE
ASCBPTR  EQU   PSAAOLD
RVTPTR   EQU   CVTRMS
PCCAPTR  EQU   PSAPCCAV
UCMEXTPT EQU   UCM2PTR
UCMMCSPT EQU   UCMPRFXP
UCMBASPT EQU   CVTCUCB
UCMEILPT EQU   UCMLSTP
UCMIECBA EQU   UCMRECBA+4
UCMUEWPT EQU   UCMUEXIT
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBSQC   EQU   UCBOBS01+12
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00069 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
LOGMCH   EQU   LRBMFLO
LOGFLOAT EQU   LOGMCH+120
SWAPWORD EQU   ACRACRWA
SWAPAL   EQU   SWAPWORD
SWAPJS   EQU   SWAPAL
SWAPOL   EQU   SWAPWORD+2
ALIVEMSK EQU   CSDCPUAL
SKEDMSK  EQU   CSDCPUJS
CONSPARM EQU   ACRACRWA
POSTCDE  EQU   CONSPARM
SWMASK   EQU   CONSPARM+2
CONSWECB EQU   UCMARECB
CONSWCOD EQU   CONSWECB
PSW      EQU   PSAPSWSV
PSWIMASK EQU   PSW
PSWKYMWP EQU   PSW+1
PSWCCPMK EQU   PSW+2
ACRPSA   EQU   PSAPSA
ACRLCCAV EQU   PSALCCAV
ACRPSEND EQU   PSAUSEND
APSWSTRT EQU   FLCEOPSW
AECSTRT  EQU   PSAEEPSW
TXT856W  EQU   ACRACRSV
CPUADDRZ EQU   TXT856W+43
TXT858I  EQU   ACRACRSV
ACRCPUPA EQU   PSACPUPA
ACRPCCAV EQU   PSAPCCAV
AECEND   EQU   FLCMTRCD+3
APSWEND  EQU   FLCENPSW
FLC      EQU   PSA
IOPARM   EQU   ACRACRWA
*                                      START UNREFERENCED COMPONENTS
RTECDEY  EQU   TXT858I+46
DESCCDEY EQU   TXT858I+44
@NM00093 EQU   TXT858I+32
CPUADDRY EQU   TXT858I+30
@NM00092 EQU   TXT858I+4
MCSFLGY  EQU   TXT858I+2
TXTLNY   EQU   TXT858I
RTECDEZ  EQU   TXT856W+47
DESCCDEZ EQU   TXT856W+45
@NM00091 EQU   TXT856W+4
MCSFLGZ  EQU   TXT856W+2
TXTLNZ   EQU   TXT856W
PSWIC    EQU   PSW+4
@NM00081 EQU   PSW+3
PSWSIGNF EQU   PSWCCPMK
PSWEXPON EQU   PSWCCPMK
PSWDECIM EQU   PSWCCPMK
PSWFIXPT EQU   PSWCCPMK
PSWCONCD EQU   PSWCCPMK
@NM00080 EQU   PSWCCPMK
PSWPRBLM EQU   PSWKYMWP
PSWWAIT  EQU   PSWKYMWP
PSWMCHCK EQU   PSWKYMWP
PSWECTM  EQU   PSWKYMWP
PSWKEY   EQU   PSWKYMWP
PSWEXT   EQU   PSWIMASK
PSWIO    EQU   PSWIMASK
PSWDAT   EQU   PSWIMASK
PSWEAM   EQU   PSWIMASK
@NM00079 EQU   PSWIMASK
PSWPER   EQU   PSWIMASK
@NM00078 EQU   PSWIMASK
CONSCPUA EQU   CONSWECB+2
@NM00076 EQU   CONSWECB+1
@NM00075 EQU   CONSPARM+1
@NM00073 EQU   LOGMCH
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00069
UCBSKPFG EQU   @NM00069
UCBRIPND EQU   @NM00069
UCBRTIAC EQU   @NM00069
UCBRSV79 EQU   @NM00069
UCBRSV78 EQU   @NM00069
UCBRSV77 EQU   @NM00069
UCBOLTEP EQU   @NM00069
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00068 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
UCMIECBP EQU   UCMIECBA+1
UCMIECBF EQU   UCMIECBA
LRBTUSR  EQU   LRBTTER+8
LRBTWSC  EQU   LRBTTER+4
LRBTLNH  EQU   LRBTTER
LRBNINT  EQU   LRBNMIH+24
LRBNDEVT EQU   LRBNMIH+20
LRBNVOL  EQU   LRBNMIH+14
LRBNCUA1 EQU   LRBNMIH+11
LRBNCUA2 EQU   LRBNMIH+8
LRBNJOB  EQU   LRBNMIH
LRBDSENS EQU   LRBDMDR+8
LRBDVOL  EQU   LRBDMDR+2
LRBDCUA1 EQU   LRBDMDR
LRBCCLOG EQU   LRBCCCH+56
LRBCLOGL EQU   LRBCCCH+54
LRBCHCUA EQU   LRBCCCH+52
LRBCCUA2 EQU   LRBCCUA+1
@NM00061 EQU   LRBCCUA
LRBCCHID EQU   LRBCCCH+48
LRBCDEVT EQU   LRBCCCH+44
LRBCECSW EQU   LRBCCCH+40
LRBCFCSW EQU   LRBCCCH+32
LRBCFCCW EQU   LRBCCCH+24
LRBCAIO  EQU   LRBCCCH+8
LRBCJOB  EQU   LRBCCCH
LRBRDEV2 EQU   LRBRDDR+32
LRBRCUA2 EQU   LRBRDDR+29
LRBRPH2  EQU   LRBRDDR+28
LRBRDEV1 EQU   LRBRDDR+24
LRBRCUA1 EQU   LRBRDDR+21
LRBRPH1  EQU   LRBRDDR+20
LRBRVOL2 EQU   LRBRDDR+14
LRBRVOL1 EQU   LRBRDDR+8
LRBRJOB  EQU   LRBRDDR
LRBMCEL  EQU   LRBMMCH+304
@NM00060 EQU   LRBMFLO+20
LRBMFSA  EQU   LRBMFLO+16
@NM00059 EQU   LRBMFLO+13
LRBMDISC EQU   LRBMEDC
LRBMINTR EQU   LRBMEDC
LRBMINST EQU   LRBMEDC
LRBMCCF  EQU   LRBMEDC
LRBMCNOP EQU   LRBMEDC
LRBMEXSR EQU   LRBMEDC
LRBMCOPR EQU   LRBMEDC
@NM00058 EQU   LRBMEDC
@NM00057 EQU   LRBMFLO+8
LRBMCELL EQU   LRBMCIC+6
LRBMVCC  EQU   @NM00055
LRBMVPT  EQU   @NM00055
@NM00056 EQU   @NM00055
@NM00054 EQU   LRBMCIC+4
LRBMVST  EQU   @NM00053
LRBMVLG  EQU   @NM00053
LRBMVCR  EQU   @NM00053
LRBMVGR  EQU   @NM00053
LRBMVFP  EQU   @NM00053
LRBMVED  EQU   @NM00053
LRBMVRC  EQU   @NM00053
LRBMVFA  EQU   @NM00053
LRBMVIA  EQU   @NM00051
LRBMVPM  EQU   @NM00051
LRBMVMS  EQU   @NM00051
LRBMVWP  EQU   @NM00051
@NM00052 EQU   @NM00051
LRBMFKE  EQU   @NM00051
LRBMFSC  EQU   @NM00051
LRBMFSE  EQU   @NM00051
LRBMIDY  EQU   @NM00049
LRBMIBU  EQU   @NM00049
@NM00050 EQU   @NM00049
LRBMFWN  EQU   @NM00049
LRBMFDG  EQU   @NM00047
@NM00048 EQU   @NM00047
LRBMFED  EQU   @NM00047
LRBMFCD  EQU   @NM00047
LRBMFTD  EQU   @NM00047
LRBMFSR  EQU   @NM00047
LRBMFPD  EQU   @NM00047
LRBMFSD  EQU   @NM00047
LRBMMOSW EQU   LRBMMCH+16
LRBMPWL  EQU   LRBMMCH+15
LRBMVEQR EQU   LRBMRSR2
LRBMPGFX EQU   LRBMRSR2
LRBMLSQA EQU   LRBMRSR2
LRBMFSQA EQU   LRBMRSR2
LRBMNUCL EQU   LRBMRSR2
LRBMSPER EQU   LRBMRSR2
LRBMINTC EQU   LRBMRSR2
LRBMOFLN EQU   LRBMRSR2
LRBMCHNG EQU   LRBMRSR1
LRBMSER  EQU   LRBMRSR1
@NM00046 EQU   LRBMRSR1
@NM00045 EQU   LRBMPDAR
LRBMRSRF EQU   LRBMPDAR
LRBMRSRC EQU   LRBMPDAR
LRBMINVP EQU   LRBMPDAR
@NM00044 EQU   LRBMPDAR
LRBMSBUF EQU   LRBMSOFT
LRBMSHIR EQU   LRBMSOFT
LRBMSECC EQU   LRBMSOFT
LRBMSEXD EQU   LRBMSOFT
@NM00043 EQU   LRBMSOFT
LRBMSSFT EQU   LRBMSOFT
LRBMIL80 EQU   LRBMINTM
LRBMICTM EQU   LRBMINTM
LRBMICKC EQU   LRBMINTM
LRBMITOD EQU   LRBMINTM
@NM00042 EQU   LRBMINTM
LRBMHIPD EQU   LRBMHARD
LRBMHSPF EQU   LRBMHARD
LRBMHSTO EQU   LRBMHARD
LRBMHINV EQU   LRBMHARD
LRBMHSD  EQU   LRBMHARD
@NM00041 EQU   LRBMHARD
LRBMHHRD EQU   LRBMHARD
LRBMTINV EQU   LRBMTERM
LRBMTDMG EQU   LRBMTERM
LRBMTWRN EQU   LRBMTERM
LRBMTCKS EQU   LRBMTERM
LRBMTSEC EQU   LRBMTERM
LRBMTTHR EQU   LRBMTERM
@NM00040 EQU   LRBMTERM
LRBMLNH  EQU   LRBMMCH
@NM00039 EQU   LRBHMSW1
LRBMSYST EQU   LRBHMSW1
@NM00038 EQU   LRBHMSW1
@NM00037 EQU   LRBHCSW1
LRBCERPP EQU   LRBHCSW1
LRBCDATA EQU   LRBHCSW1
LRBCICUA EQU   LRBHCSW1
LRBCNOSP EQU   LRBHCSW1
@NM00036 EQU   LRBHCSW1
LRBCINCO EQU   LRBHCSW1
LRBCMESG EQU   LRBHCSW1
@NM00035 EQU   LRBHRSW1
LRBRSYSI EQU   LRBHRSW1
LRBROPER EQU   LRBHRSW1
LRBRSEC  EQU   LRBHRSW1
LRBRPRIM EQU   LRBHRSW1
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
ACRMTRCD EQU   ACREPSWS+25
@NM00090 EQU   ACREPSWS+24
ACRPER   EQU   ACREPSWS+20
@NM00089 EQU   ACREPSWS+19
ACRPERCD EQU   ACREPSWS+18
ACRMCNUM EQU   ACREPSWS+17
@NM00088 EQU   ACREPSWS+16
ACRTEA   EQU   ACREPSWS+12
ACRPICOD EQU   ACREPSWS+10
ACRPIILC EQU   ACREPSWS+9
@NM00087 EQU   ACREPSWS+8
ACRSVCN  EQU   ACREPSWS+6
ACRSVILC EQU   ACREPSWS+5
@NM00086 EQU   ACREPSWS+4
ACREICOD EQU   ACREPSWS+2
ACRSPAD  EQU   ACREPSWS
ACRTRACE EQU   ACROPSW+60
ACRTIMER EQU   ACROPSW+56
ACRCVT2  EQU   ACROPSW+52
ACRCAW   EQU   ACROPSW+48
ACRCSW   EQU   ACROPSW+40
ACRIOPSW EQU   ACROPSW+32
ACRMOPSW EQU   ACROPSW+24
ACRPOPSW EQU   ACROPSW+16
ACRSOPSW EQU   ACROPSW+8
ACREOPSW EQU   ACROPSW
@NM00085 EQU   ACRACRSV+68
ACRSVLMR EQU   ACRACRSV+64
ACRSVR15 EQU   ACRACRSV+60
ACRSVR13 EQU   ACRACRSV+52
ACRSVR12 EQU   ACRACRSV+48
ACRSVR11 EQU   ACRACRSV+44
ACRSVR10 EQU   ACRACRSV+40
ACRSVR9  EQU   ACRACRSV+36
ACRSVR8  EQU   ACRACRSV+32
ACRSVR7  EQU   ACRACRSV+28
ACRSVR6  EQU   ACRACRSV+24
ACRSVR5  EQU   ACRACRSV+20
ACRSVR4  EQU   ACRACRSV+16
ACRSVR3  EQU   ACRACRSV+12
ACRSVR2  EQU   ACRACRSV+8
ACRSVR1  EQU   ACRACRSV+4
ACRSVR0  EQU   ACRACRSV
ACRGPR15 EQU   ACRLMGSV+60
ACRGPR14 EQU   ACRLMGSV+56
ACRGPR13 EQU   ACRLMGSV+52
ACRGPR12 EQU   ACRLMGSV+48
ACRGPR11 EQU   ACRLMGSV+44
ACRGPR10 EQU   ACRLMGSV+40
ACRGPR9  EQU   ACRLMGSV+36
ACRGPR8  EQU   ACRLMGSV+32
ACRGPR7  EQU   ACRLMGSV+28
ACRGPR6  EQU   ACRLMGSV+24
ACRGPR5  EQU   ACRLMGSV+20
ACRGPR4  EQU   ACRLMGSV+16
ACRGPR3  EQU   ACRLMGSV+12
ACRGPR2  EQU   ACRLMGSV+8
ACRGPR1  EQU   ACRLMGSV+4
ACRGPR0  EQU   ACRLMGSV
ACRFLPT6 EQU   ACRLMFSV+24
ACRFLPT4 EQU   ACRLMFSV+16
ACRFLPT2 EQU   ACRLMFSV+8
ACRFLPT0 EQU   ACRLMFSV
RTREGS   EQU   RTMPARM
RRPLRF   EQU   RRPLCNTS+1
RRPLRE   EQU   RRPLCNTS+1
RRPLRD   EQU   RRPLCNTS+1
RRPLRC   EQU   RRPLCNTS+1
RRPLRB   EQU   RRPLCNTS+1
RRPLRA   EQU   RRPLCNTS+1
RRPLR9   EQU   RRPLCNTS+1
RRPLR8   EQU   RRPLCNTS+1
RRPLR7   EQU   RRPLCNTS
RRPLR6   EQU   RRPLCNTS
RRPLR5   EQU   RRPLCNTS
RRPLR4   EQU   RRPLCNTS
RRPLR3   EQU   RRPLCNTS
RRPLR2   EQU   RRPLCNTS
RRPLR1   EQU   RRPLCNTS
RRPLR0   EQU   RRPLCNTS
@NM00074 EQU   RRPLFLGS
FRRSPARM EQU   FRRSENTR+8
@NM00072 EQU   FRRSFLGS+1
@NM00071 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSCURR EQU   FRRSHEAD+12
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00070
UCBHALI  EQU   @NM00070
UCBRSV09 EQU   @NM00070
UCBRSV08 EQU   @NM00070
UCBRSV07 EQU   @NM00070
UCBRSV06 EQU   @NM00070
UCBRSV05 EQU   @NM00070
UCBRSV04 EQU   @NM00070
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00067 EQU   UCB
UCMEFRV1 EQU   UCMEFEXT+8
UCMEFSA1 EQU   UCMEFEXT+3
UCMEFATT EQU   UCMEFEXT+2
UCMEFLG2 EQU   UCMEFEXT+1
UCMEFLGH EQU   UCMEFLG1
UCMEFLGG EQU   UCMEFLG1
UCMEFLGF EQU   UCMEFLG1
UCMEFLGE EQU   UCMEFLG1
UCMEFLGD EQU   UCMEFLG1
UCMEFLGC EQU   UCMEFLG1
UCMEFLGB EQU   UCMEFLG1
UCMEFLGA EQU   UCMEFLG1
UCMPEDUM EQU   UCMPEXTA+60
UCMPELST EQU   UCMPEXTA+56
UCMPELEN EQU   UCMPEXTA+52
UCMPE1ST EQU   UCMPEXTA+48
UCMPRSV2 EQU   UCMPEXTA+20
UCMPRSV1 EQU   UCMPDM1+12
UCMPNCC  EQU   UCMPDM1+8
UCMPNMCC EQU   UCMPDM1+4
UCMPWQE  EQU   UCMPDM1
UCMPUCMP EQU   UCMPEXTA
UCMFELST EQU   UCMFEXTA+48
UCMFELEN EQU   UCMFEXTA+44
UCMFE1ST EQU   UCMFEXTA+40
UCMFATCN EQU   UCMFEXTA+36
UCMFRAD  EQU   UCMFRECB+1
UCMFRB0  EQU   UCMFRBYT
UCMFXECB EQU   UCMFECBL
UCMFRSV3 EQU   UCMFEXTA+20
UCMF80WQ EQU   UCMFEXTA+18
UCMF60WQ EQU   UCMFEXTA+16
UCMFRSV2 EQU   UCMFMGFS+4
UCMFRSV1 EQU   UCMFMGFS+2
UCMFFLG2 EQU   UCMFMGFS+1
UCMFBR07 EQU   UCMFFLG1
UCMFBR06 EQU   UCMFFLG1
UCMFBR05 EQU   UCMFFLG1
UCMFBR04 EQU   UCMFFLG1
UCMFBR03 EQU   UCMFFLG1
UCMFMSGN EQU   UCMFFLG1
UCMFMSGA EQU   UCMFFLG1
UCMFMSGE EQU   UCMFFLG1
UCMFUCMF EQU   UCMFEXTA
UCMDESCD EQU   UCMEXIT+132
UCMROUTC EQU   UCMEXIT+128
UCMMSTXT EQU   UCMEXIT
UCMRSV64 EQU   UCMLIST+76
UCMRCTA  EQU   UCMRCT+1
UCMRSV31 EQU   UCMSDS5
UCMSDS5G EQU   UCMSDS5
UCMSDS5F EQU   UCMSDS5
UCMRSV30 EQU   UCMSDS5
UCMRSV29 EQU   UCMSDS5
UCMSDS5C EQU   UCMSDS5
UCMSDS5B EQU   UCMSDS5
UCMSDS5A EQU   UCMSDS5
UCMMLAST EQU   UCMLIST+64
UCMVHRSN EQU   UCMDEVC
UCMDEVG  EQU   UCMDEVC
UCMDEVF  EQU   UCMDEVC
UCMDEVE  EQU   UCMDEVC
UCMDEVD  EQU   UCMDEVC
UCMDEVCC EQU   UCMDEVC
UCMDEVB  EQU   UCMDEVC
UCMDEVA  EQU   UCMDEVC
UCMXOR   EQU   UCMLIST+62
UCMMSG2  EQU   UCMMSG+1
UCMRSV27 EQU   UCMMSG1
UCMRSV26 EQU   UCMMSG1
UCMMSGF  EQU   UCMMSG1
UCMRSV71 EQU   UCMMSG1
UCMMSGD  EQU   UCMMSG1
UCMRSV70 EQU   UCMMSG1
UCMMSGB  EQU   UCMMSG1
UCMMSGA  EQU   UCMMSG1
UCMCOMPC EQU   UCMLIST+56
UCMWLAST EQU   UCMLIST+52
UCMOAOEN EQU   UCMLIST+48
UCMALTEN EQU   UCMLIST+44
UCMRV007 EQU   UCMDISP2
UCMRV006 EQU   UCMDISP2
UCMRV005 EQU   UCMDISP2
UCMRV004 EQU   UCMDISP2
UCMRV003 EQU   UCMDISP2
UCMDISPK EQU   UCMDISP2
UCMDISPJ EQU   UCMDISP2
UCMDISPI EQU   UCMDISP2
UCMDISPH EQU   UCMDISP1
UCMDISPG EQU   UCMDISP1
UCMDISPF EQU   UCMDISP1
UCMDISPE EQU   UCMDISP1
UCMDISPD EQU   UCMDISP1
UCMDISPC EQU   UCMDISP1
UCMDISPB EQU   UCMDISP1
UCMDISPA EQU   UCMDISP1
UCMAUTHB EQU   UCMAUTH+1
UCMRSV23 EQU   UCMAUTHA
UCMRSV22 EQU   UCMAUTHA
UCMRSV21 EQU   UCMAUTHA
UCMRSV20 EQU   UCMAUTHA
UCMRSV19 EQU   UCMAUTHA
UCMAUTH3 EQU   UCMAUTHA
UCMAUTH2 EQU   UCMAUTHA
UCMAUTH1 EQU   UCMAUTHA
UCMOUTQ  EQU   UCMLIST+36
UCMRSV18 EQU   UCMLIST+34
UCMRTCD  EQU   UCMLIST+32
UCMXB    EQU   UCMLIST+28
@NM00066 EQU   UCMXA+1
UCMID    EQU   UCMXA
UCMRSV17 EQU   UCMATR
UCMRSV16 EQU   UCMATR
UCMAT04  EQU   UCMATR
UCMLF    EQU   UCMATR
UCMUF    EQU   UCMATR
UCMXF    EQU   UCMATR
UCMIF    EQU   UCMATR
UCMOF    EQU   UCMATR
UCMTC    EQU   UCMSTS
UCMTD    EQU   UCMSTS
UCMTB    EQU   UCMSTS
UCMTA    EQU   UCMSTS
UCMCF    EQU   UCMSTS
UCMBF    EQU   UCMSTS
UCMPF    EQU   UCMSTS
UCMAF    EQU   UCMSTS
UCMNAME  EQU   UCMLIST+16
UCMUCB   EQU   UCMLIST+12
UCMDCB   EQU   UCMLIST+8
UCMSBR   EQU   UCMLIST+4
UCMECB   EQU   UCMLIST
UCMDECBA EQU   UCMEIL+20
UCMOECBA EQU   UCMEIL+16
UCMAECBA EQU   UCMEIL+12
UCMXECBA EQU   UCMEIL+8
UCMNIPTR EQU   UCMEIL+4
UCMRSV15 EQU   UCMEIL+3
UCMRTCT  EQU   UCMEIL+2
UCMRPYL  EQU   UCMEIL+1
@NM00065 EQU   UCMEIL
UCMRSV62 EQU   UCM+304
UCMRSV60 EQU   UCM+302
UCMRSV59 EQU   UCMRSV51
UCMRSV58 EQU   UCMRSV51
UCMRSV57 EQU   UCMRSV51
UCMRSV56 EQU   UCMRSV51
UCMRSV55 EQU   UCMRSV51
UCMRSV54 EQU   UCMRSV51
UCMRSV53 EQU   UCMRSV51
UCMRSV52 EQU   UCMRSV51
UCMRSV50 EQU   UCMRSV42
UCMRSV49 EQU   UCMRSV42
UCMRSV48 EQU   UCMRSV42
UCMRSV47 EQU   UCMRSV42
UCMRSV46 EQU   UCMRSV42
UCMRSV45 EQU   UCMRSV42
UCMRSV44 EQU   UCMRSV42
UCMRSV43 EQU   UCMRSV42
UCMJES3T EQU   UCM+296
UCMWAKUP EQU   UCM+292
UCMFRRAD EQU   UCM+288
UCMSWCH  EQU   UCM+284
UCMASCB  EQU   UCM+280
UCMWQECP EQU   UCM+276
UCMORECP EQU   UCM+272
UCMOECBT EQU   UCM+268
UCMOECBH EQU   UCM+264
UCMWECBT EQU   UCM+260
UCMWECBH EQU   UCM+256
UCMMBEND EQU   UCM+252
UCMCTID  EQU   UCM+250
UCMRSV61 EQU   UCM+248
UCMRP2AD EQU   UCM+244
UCMBFEXT EQU   UCM+240
UCMWQLM1 EQU   UCM+238
UCMRV001 EQU   UCM+237
UCMRQLM1 EQU   UCM+236
UCMMBPTR EQU   UCM+232
UCMMQNXT EQU   UCM+228
UCMMQEND EQU   UCM+224
UCMMQPTR EQU   UCM+220
UCMTRECB EQU   UCM+216
UCMMNECB EQU   UCM+212
UCMMNTR  EQU   UCM+208
UCMR9SV  EQU   UCM+204
UCMSAVE4 EQU   UCM+140
UCMRSV77 EQU   UCM+84
UCMVEL   EQU   UCMVDATA+8
UCMVEZ   EQU   UCMVDATA+4
UCMVEA   EQU   UCMVDATA
UCMRSV76 EQU   UCM+71
UCMRSV67 EQU   UCM+70
UCMRSV75 EQU   UCM+69
UCMFIX   EQU   UCMMODE
UCMMCS   EQU   UCMMODE
UCMOGCE  EQU   UCMMODE
UCMAMFA  EQU   UCMMODE
UCMRSV14 EQU   UCMMODE
UCMTPUTA EQU   UCMMODE
UCMRSV66 EQU   UCMMODE
UCMRSV11 EQU   UCMMODE
UCMPXA   EQU   UCM+64
UCMWQEND EQU   UCM+60
UCMWQNR  EQU   UCM+58
UCMRQNR  EQU   UCM+56
UCMWQECB EQU   UCM+52
UCMRQECB EQU   UCM+48
UCMWQLM  EQU   UCM+46
UCMRQLM  EQU   UCM+45
@NM00064 EQU   UCMRPYI
UCMRPYQ  EQU   UCM+28
UCMWTOQ  EQU   UCM+24
UCMLECB  EQU   UCMDECB
UCMOECB  EQU   UCM+8
UCMAECB  EQU   UCM+4
UCMXECB  EQU   UCM
UCMRSV65 EQU   UCMPRFX+158
UCMSDS2  EQU   UCMPRFX+157
UCMRSV09 EQU   UCMSDS1
UCMRSV08 EQU   UCMSDS1
UCMRSV07 EQU   UCMSDS1
UCMRSV06 EQU   UCMSDS1
UCMRSV05 EQU   UCMSDS1
UCMRSV04 EQU   UCMSDS1
UCMSDS1B EQU   UCMSDS1
UCMSDS1A EQU   UCMSDS1
UCMRSV72 EQU   UCMPRFX+152
UCMLOGAD EQU   UCMPRFX+148
UCMNPECB EQU   UCMPRFX+144
UCMRSV69 EQU   UCMPRFX+140
UCMSWSA2 EQU   UCMPRFX+136
UCMSWSA1 EQU   UCMPRFX+132
UCMQRTN  EQU   UCMPRFX+128
UCM6WD   EQU   UCMXSA+20
UCM5WD   EQU   UCMXSA+16
UCM4WD   EQU   UCMXSA+12
UCM3WD   EQU   UCMXSA+8
UCM2WD   EQU   UCMXSA+4
UCM1WD   EQU   UCMXSA
UCMRSV03 EQU   UCMPRFX+102
UCMHRDRT EQU   UCMPRFX+100
UCMXCT   EQU   UCMPRFX+96
UCMHCUCM EQU   UCMPRFX+92
UCMCMID  EQU   UCMPRFX+88
UCMOWTOR EQU   UCMPRFX+86
UCMSYSP  EQU   UCMSFLG2
UCMSYSO  EQU   UCMSFLG2
UCMSYSN  EQU   UCMSFLG2
UCMSYSM  EQU   UCMSFLG2
UCMSYSL  EQU   UCMSFLG2
UCMSYSK  EQU   UCMSFLG2
UCMSYSJ  EQU   UCMSFLG2
UCMSYSI  EQU   UCMSFLG2
UCMRSV35 EQU   UCMSFLG1
UCMSYSG  EQU   UCMSFLG1
UCMSYSF  EQU   UCMSFLG1
UCMSYSE  EQU   UCMSFLG1
UCMSYSD  EQU   UCMSFLG1
UCMSYSC  EQU   UCMSFLG1
UCMSYSB  EQU   UCMSFLG1
UCMRSV01 EQU   UCMSFLG1
UCMWTOX  EQU   UCMPRFX+80
UCMDOME  EQU   UCMPRFX+76
UCMSVR0  EQU   UCMSAVE0+68
UCMSVQ0  EQU   UCMSAVE0+64
UCMSVP0  EQU   UCMSAVE0+60
UCMSVO0  EQU   UCMSAVE0+56
UCMSVN0  EQU   UCMSAVE0+52
UCMSVM0  EQU   UCMSAVE0+48
UCMSVL0  EQU   UCMSAVE0+44
UCMSVK0  EQU   UCMSAVE0+40
UCMSVJ0  EQU   UCMSAVE0+36
UCMSVI0  EQU   UCMSAVE0+32
UCMSVH0  EQU   UCMSAVE0+28
UCMSVG0  EQU   UCMSAVE0+24
UCMSVF0  EQU   UCMSAVE0+20
UCMSVE0  EQU   UCMSAVE0+16
UCMSVD0  EQU   UCMSAVE0+12
UCMSVC0  EQU   UCMSAVE0+8
UCMSVB0  EQU   UCMSAVE0+4
UCMSVA0  EQU   UCMSAVE0
UCMMCENT EQU   UCMPRFX
UCMRSV74 EQU   UCM2EXT+20
UCMRSV73 EQU   UCM2EXT+16
UCM2STAA EQU   UCM2STA+1
UCMRV008 EQU   UCM2SFLG
UCMRSV34 EQU   UCM2SFLG
UCMRSV33 EQU   UCM2SFLG
UCM2WTOI EQU   UCM2SFLG
UCM2DSTR EQU   UCM2SFLG
UCM2DTAK EQU   UCM2SFLG
UCM2SENT EQU   UCM2SFLG
UCM2SDWA EQU   UCM2SFLG
UCM2PST  EQU   UCM2EXT+4
UCM2RID  EQU   UCM2EXT+2
UCM2WID  EQU   UCM2EXT
WSACASMS EQU   WSAC+60
WSACASMD EQU   WSAC+56
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACGTF  EQU   WSAC+4
WSACCWSA EQU   WSAC
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGGMFM EQU   WSAG+4
WSAGPGIO EQU   WSAG
IOXEND   EQU   IOCX+32
IOXPSIF  EQU   IOCX+28
IOXPSIX  EQU   IOCX+24
IOXSTIDC EQU   IOCX+20
IOXCRHD  EQU   IOCX+16
IOXCRHA  EQU   IOCX+12
IOXTCQSC EQU   IOCX+8
@NM00063 EQU   IOCX+6
IOXLCHCT EQU   IOCX+5
IOXHICH  EQU   IOCX+4
IOXCHMSK EQU   IOCX+2
IOXOFSET EQU   IOX
IOCOEND  EQU   IOCOM+128
IOCPATCH EQU   IOCOM+124
IOCUCBBM EQU   IOCOM+120
IOCQCNT  EQU   IOCOM+116
IOCIOSDQ EQU   IOCOM+112
IOCIOSEQ EQU   IOCOM+108
IOCSVCF  EQU   IOCOM+104
IOCTCCW  EQU   IOCOM+100
IOCRSVTB EQU   IOCOM+96
IOCMFCNT EQU   IOCOM+92
IOCMFHK  EQU   IOCOM+88
IOCGENA  EQU   IOCOM+84
IOCCCH   EQU   IOCOM+80
IOCASYNQ EQU   IOCOM+76
IOCLCHTB EQU   IOCOM+72
IOCATTBL EQU   IOCOM+68
IOCSYNCH EQU   IOCOM+56
IOCCATLK EQU   IOCOM+48
IOCPRGID EQU   IOCOM+44
IOCIOSCP EQU   IOCOM+40
IOCORMGT EQU   IOCOM+36
IOCVOID  EQU   IOCOM+32
IOCSTIO  EQU   IOCOM+28
IOCSCOMP EQU   IOCOM+24
IOCHD160 EQU   IOCOM+20
IOCINT   EQU   IOCOM+16
IOCCTBL  EQU   IOCOM+12
IOCHIO   EQU   IOCOM+8
IOCPST   EQU   IOCOM+4
IOCPGCT  EQU   IOCOM+2
IOCVOICT EQU   IOCOM
@NM00062 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCAR105 EQU   PCCAATTR
PCCAR104 EQU   PCCAATTR
PCCAR103 EQU   PCCAATTR
PCCAR102 EQU   PCCAATTR
PCCAR101 EQU   PCCAATTR
PCCAR100 EQU   PCCAATTR
PCCACPUM EQU   PCCAATTR
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCASLCK EQU   PCCACHF3
PCCAISRB EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+307
PCCACHPB EQU   PCCA+306
PCCALGP2 EQU   PCCA+305
PCCALGP1 EQU   PCCA+304
PCCACELL EQU   PCCA+302
PCCALOGL EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCAR106 EQU   PCCA+228
PCCAR113 EQU   PCCA+226
PCCASRBL EQU   PCCA+225
PCCAR112 EQU   PCCACHAN
PCCAR111 EQU   PCCACHAN
PCCAR110 EQU   PCCACHAN
PCCAR109 EQU   PCCACHAN
PCCAR108 EQU   PCCACHAN
PCCAR107 EQU   PCCACHAN
PCCAEXDM EQU   PCCACHAN
PCCAIRST EQU   PCCACHAN
PCCASRB  EQU   PCCA+180
PCCACCHM EQU   PCCA+176
PCCAELBA EQU   PCCA+172
PCCAELAD EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPID EQU   PCCA+4
PCCAPCCA EQU   PCCA
MSGVAR2  EQU   MSGCHAR+4
MSGTAB2  EQU   MSG+3
MSGCTL   EQU   MSG
RVTMIH2  EQU   RVT+108
RVTMIH   EQU   RVT+104
RVTCCHCR EQU   RVT+100
RVTCCHDA EQU   RVT+96
RVTLRBPT EQU   RVT+84
RVTRWAPT EQU   RVT+80
RVT01MMM EQU   RVT+76
RVT00MMM EQU   RVT+72
RVTPEXIT EQU   RVT+68
RVTPKREF EQU   RVT+64
RVTPBUCR EQU   RVT+60
RVTPXMFA EQU   RVT+56
RVTPTAIM EQU   RVT+52
RVTPTCON EQU   RVT+48
RVTPTREC EQU   RVT+44
RVTPTSIG EQU   RVT+40
RVTPTERM EQU   RVT+36
RVTPMKTA EQU   RVT+32
RVTPMMSG EQU   RVT+28
RVTPMTHA EQU   RVT+24
RVTPMPFX EQU   RVT+20
RVTPMSCA EQU   RVT+16
RVTPMHCA EQU   RVT+12
RVTPMFRS EQU   RVT+8
RVTPMRTM EQU   RVT+4
RVTPMCIH EQU   RVT
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
LCCAT00P EQU   LCCAVT
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCASGPR EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCAASID EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRDP EQU   LCCACREX
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCAR133 EQU   LCCA+444
LCCAR132 EQU   LCCA+440
LCCAR131 EQU   LCCA+436
LCCAR130 EQU   LCCA+432
LCCAR129 EQU   LCCA+428
LCCAR128 EQU   LCCA+424
LCCAR127 EQU   LCCA+420
LCCAR126 EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
LRBCMPCS EQU   LRBCMP+2
LRBCMPPA EQU   LRBCMP
LRBCMPNO EQU   LRBCVAR+6
LRBCMPF2 EQU   LRBCVAR+5
LRBCMPF1 EQU   LRBCVAR+4
LRBCRESD EQU   LRBCVAR+2
LRBCFT   EQU   LRBCVAR
LRBHMCEL EQU   LRBHCPID+6
LRBHMDL  EQU   LRBHCPID+4
LRBHCSER EQU   LRBHCPID+1
@NM00034 EQU   LRBHCPID
LRBHTIME EQU   LRB+12
LRBHDATE EQU   LRB+8
@NM00033 EQU   LRB+7
LRBHCNT  EQU   LRB+6
LRBMCLB  EQU   LRBHSW3
LRBNDEM  EQU   LRBMACT
LRBNCEM  EQU   LRBMACT
@NM00032 EQU   LRBHSW0
LRBHTMC  EQU   LRBHSW0
@NM00031 EQU   LRBHSW0
LRBHNS   EQU   LRBHSW0
LRBHMORE EQU   LRBHSW0
@NM00030 EQU   LRBHSYS
LRBHSYSB EQU   LRBHSYS
@NM00029 EQU   CSD+160
CSDMASK  EQU   CSD+128
CSDUCNT  EQU   CSD+124
CSDTCNT  EQU   CSD+120
CSDGDTOD EQU   CSD+116
CSDGDINT EQU   CSD+112
CSDGDCC  EQU   CSD+108
CSDDDRCT EQU   CSD+106
CSDRV044 EQU   CSD+104
CSDMAFF  EQU   CSD+24
CSDRV038 EQU   CSDFLAGS
CSDRV037 EQU   CSDFLAGS
CSDRV036 EQU   CSDFLAGS
CSDRV035 EQU   CSDFLAGS
CSDRV034 EQU   CSDFLAGS
CSDRV033 EQU   CSDFLAGS
CSDRV032 EQU   CSDFLAGS
CSDMP    EQU   CSDFLAGS
CSDMF1CP EQU   CSD+20
CSDRV043 EQU   CSD+16
CSDRV030 EQU   CSDSCFL4
CSDRV029 EQU   CSDSCFL4
CSDRV028 EQU   CSDSCFL4
CSDRV027 EQU   CSDSCFL4
CSDRV026 EQU   CSDSCFL4
CSDRV025 EQU   CSDSCFL4
CSDRV024 EQU   CSDSCFL4
CSDRV023 EQU   CSDSCFL4
CSDRV022 EQU   CSDSCFL3
CSDRV021 EQU   CSDSCFL3
CSDRV020 EQU   CSDSCFL3
CSDRV019 EQU   CSDSCFL3
CSDRV018 EQU   CSDSCFL3
CSDRV017 EQU   CSDSCFL3
CSDRV016 EQU   CSDSCFL3
CSDRV015 EQU   CSDSCFL3
CSDRV014 EQU   CSDSCFL2
CSDRV013 EQU   CSDSCFL2
CSDRV012 EQU   CSDSCFL2
CSDRV011 EQU   CSDSCFL2
CSDRV010 EQU   CSDSCFL2
CSDRV009 EQU   CSDSCFL2
CSDRV008 EQU   CSDSCFL2
CSDRV007 EQU   CSDSCFL2
CSDRV006 EQU   CSDSCFL1
CSDRV005 EQU   CSDSCFL1
CSDRV004 EQU   CSDSCFL1
CSDRV003 EQU   CSDSCFL1
CSDRV002 EQU   CSDSCFL1
CSDRV001 EQU   CSDSCFL1
CSDSYSND EQU   CSDSCFL1
CSDRV042 EQU   CSDSCFL1
CSDCPUOL EQU   CSD+10
CSDSAFF  EQU   CSDCPUAL
CSDCHAD  EQU   CSD+6
CSDCSD   EQU   CSD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00028 EQU   CVTFIX+248
@NM00027 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00026 EQU   PSA+3668
@NM00025 EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAACTCD EQU   PSA+782
PSASYMSK EQU   PSA+781
PSACR0   EQU   PSA+776
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00024 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00023 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSACPULA EQU   PSA+518
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00022 EQU   FLCFSA
@NM00021 EQU   FLCMCLA+77
PSAMDISC EQU   PSAMEDC
PSAMINTR EQU   PSAMEDC
PSAMINST EQU   PSAMEDC
PSAMCCF  EQU   PSAMEDC
PSAMCNOP EQU   PSAMEDC
PSAMEXSR EQU   PSAMEDC
PSAMCOPR EQU   PSAMEDC
@NM00020 EQU   PSAMEDC
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHIL  EQU   FLCCHNID+2
FLCCHMOD EQU   FLCCHTM
FLCCHTYP EQU   FLCCHTM
@NM00012 EQU   PSA+160
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RC00456 EQU   @RC00454
@RC00535 EQU   @EL00002
@PB00002 EQU   @EL00001
@RC00458 EQU   @RC00456
@RC00460 EQU   @RC00458
@ENDDATA EQU   *
         END   IEAVTACR,(C'PLS1517',0701,77129)
