         TITLE 'IEAVTAS1 - PRE EXIT PROCESSING                         *
                        '
IEAVTAS1 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVTAS1  77.327'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @10,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@10                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0098
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT IEAVTAS1 IS THE TOP TASK RECOVERY SEGMENT. IT INCLUDES*/
*   /* FINDSCB TO LOCATE THE SCB TO BE SCHEDULED, WKUPDAT TO         */
*   /* INITIALIZE RTM2 WORKAREA WITH APPLICABLE DATA AND SDWAINIT TO */
*   /* ACQUIRE AND INITIALIZE THE SDWA(RTCA) FOR THE USER EXIT. IT   */
*   /* ALSO PERFORMS USER I/O OPTIONS (USEROPTS), HANDLES RECURSION  */
*   /* (RECURSE) AND SETS UP THE INTERFACE TO THE USER EXIT ROUTINE  */
*   /* (EXITINTR). WHEN CONTROL RETURNS TO IEAVTAS1 FROM THE USER    */
*   /* EXIT IEAVTAS2 IS CALLED TO PERFORM USER RECOVERY REQUESTS, I.E*/
*   /* RETRY OR CONTINUE WITH TERMINATION.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0099
*   RTM2PTR=INPUTREG;               /* SAVE INPUT PTR TO RTM2      0099
*                                      WORKAREA                      */
         LR    RTM2PTR,INPUTREG                                    0099
*   IF RTM2RETR=ON THEN             /* THIS CALL TO SETUP RBS FOR  0100
*                                      RETRY                 @G33SPHW*/
         TM    RTM2RETR(RTM2PTR),B'01000000'                       0100
         BNO   @RF00100                                            0100
*     DO;                           /* INVOKE TAS3 TO DO ACTUAL SETUP
*                                                            @G33SPHW*/
*       SCBPTR=RTM2SCBC;            /* USE SCB FOUND IN LAST PASS  0102
*                                                            @G33SPHW*/
         L     SCBPTR,RTM2SCBC(,RTM2PTR)                           0102
*       R13=ADDR(RTM2TRSA);         /* SAVEAREA FOR IEAVTAS3 @G33SPHW*/
         LA    R13,RTM2TRSA(,RTM2PTR)                              0103
*       CALL IEAVTAS3;              /* INVOKE IEAVTAS3 FOR SETUP   0104
*                                                            @G33SPHW*/
         L     @15,@CV03262                                        0104
         BALR  @14,@15                                             0104
*     END;                          /* END OF RETRY SETUP    @G33SPHW*/
*   RESPECIFY                                                      0106
*     INPUTREG UNRESTRICTED;                                       0106
@RF00100 DS    0H                                                  0107
*   RTM2WARG=R3INDEX;               /* INDICATE REGISTER FOR RTM2PTR
*                                      DURING RECURSION              */
         MVI   RTM2WARG(RTM2PTR),X'04'                             0107
*TOP:                                                              0108
*   DO WHILE(RTM2RETR=OFF&RTM2SCBC^=ZERO);                         0108
*                                                                  0108
TOP      B     @DE00108                                            0108
@DL00108 DS    0H                                                  0109
*     /***************************************************************/
*     /*                                                             */
*     /* SEGMENT FINDSCB WILL SEARCH THE SCB QUEUE WITHIN THE LIMITS */
*     /* DEFINED IN THE RTM2 WORKAREA FIELDS RTM2SCBO AND RTM2SCBN   */
*     /* UNITIL AN ELIGIBLE SCB ( SCHEDULEABLE USER EXIT) IS FOUND.  */
*     /* THE SCB ADDRESS IS PUT IN RTM2SCBC UNLESS THERE IS NO       */
*     /* ELIGIBLE SCB, IN WHICH CASE RTM2SCBC IS ZEROED              */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0109
*     DO;                           /* BEGIN SEGMENT FINSCB          */
*       IF RTM2SCBC=SCBSTART THEN   /* TEST FOR INITIAL ENTRY        */
         CLC   RTM2SCBC(4,RTM2PTR),@CF00057                        0110
         BNE   @RF00110                                            0110
*         RTM2SCBC=RTM2SCBN;        /* INITIALIZE RTM2SCBC           */
         L     @12,RTM2SCBN(,RTM2PTR)                              0111
         ST    @12,RTM2SCBC(,RTM2PTR)                              0111
*       ELSE                                                       0112
*         RTM2SCBC=RTM2SCBC->SCBCHAIN;/* ACCESS CHAIN FIELD POINTER  */
         B     @RC00110                                            0112
@RF00110 L     @12,RTM2SCBC(,RTM2PTR)                              0112
         L     @12,SCBCHAIN(,@12)                                  0112
         ST    @12,RTM2SCBC(,RTM2PTR)                              0112
*       RTM2TRSW=OFF;               /* INITIALIZE FOR LOOP CONTROL   */
*                                                                  0113
@RC00110 NI    RTM2TRSW(RTM2PTR),B'11101111'                       0113
*       /*************************************************************/
*       /*                                                           */
*       /* SEARCH FOR AN ELIGIBLE SCB                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0114
*       DO WHILE(RTM2TRSW=OFF);     /* SWITCH WILL BE TURNED ON WHEN
*                                      AN ELIGIBLE SCB IS FOUND OR 0114
*                                      THE END OF THE SCB Q IS     0114
*                                      ENCOUNTERED                   */
         B     @DE00114                                            0114
@DL00114 DS    0H                                                  0115
*         IF RTM2SCBO^=RTM2SCBC&RTM2SCBC->SCBID=SCBDB THEN/* TEST FOR
*                                      END OF QUEUE AND VALID SCB    */
         L     @12,RTM2SCBC(,RTM2PTR)                              0115
         C     @12,RTM2SCBO(,RTM2PTR)                              0115
         BE    @RF00115                                            0115
         CLI   SCBID(@12),X'DB'                                    0115
         BNE   @RF00115                                            0115
*           IF RTM2SCBC->SCBINUSE^=ON THEN/* IF INUSE BIT IS ON, SCB
*                                      HAS BEEN PREVIOUSLY SCHEDULED */
         TM    SCBINUSE(@12),B'00010000'                           0116
         BO    @RF00116                                            0116
*             IF RTM2TRME=ON THEN   /* TEST IF TERM PROCESSING IS IN
*                                      PROGRESS                      */
         TM    RTM2TRME(RTM2PTR),B'10000000'                       0117
         BNO   @RF00117                                            0117
*               IF RTM2SCBC->SCBTERMI^=ON THEN/* TEST IF TERM SCB    */
         TM    SCBTERMI(@12),B'01000000'                           0118
         BO    @RF00118                                            0118
*                 RTM2SCBC=RTM2SCBC->SCBCHAIN;/* NOT A TERM SCB - SO
*                                      GET NEXT SCB                  */
         L     @12,SCBCHAIN(,@12)                                  0119
         ST    @12,RTM2SCBC(,RTM2PTR)                              0119
*               ELSE                                               0120
*                 RTM2TRSW=ON;      /* ELIGIBLE SCB FOUND            */
         B     @RC00118                                            0120
@RF00118 OI    RTM2TRSW(RTM2PTR),B'00010000'                       0120
*             ELSE                                                 0121
*               IF RTM2STA2=ON THEN /* IF ON THEN ONLY AN ESTAE SCB
*                                      IS ELIGIBLE                   */
         B     @RC00117                                            0121
@RF00117 TM    RTM2STA2(RTM2PTR),B'10000000'                       0121
         BNO   @RF00121                                            0121
*                 IF RTM2SCBC->SCBSTAI=OFF&RTM2SCBC->SCBESTAE=OFF THEN
         L     @12,RTM2SCBC(,RTM2PTR)                              0122
         TM    SCBSTAI(@12),B'10010000'                            0122
         BNZ   @RF00122                                            0122
*                                   /* INELIGIBLE IF THIS IS NOT AN
*                                      ESTAE                         */
*                   RTM2SCBC=RTM2SCBC->SCBCHAIN;/* GET NEXT SCB      */
         L     @12,SCBCHAIN(,@12)                                  0123
         ST    @12,RTM2SCBC(,RTM2PTR)                              0123
*                 ELSE              /* ESTAE TYPE SCB                */
*                   RTM2TRSW=ON;    /* ELIGIBLE SCB FOUND            */
         B     @RC00122                                            0124
@RF00122 OI    RTM2TRSW(RTM2PTR),B'00010000'                       0124
*               ELSE                                               0125
*                 RTM2TRSW=ON;      /* STAE SCB IS ELIGIBLE          */
         B     @RC00121                                            0125
@RF00121 OI    RTM2TRSW(RTM2PTR),B'00010000'                       0125
*           ELSE                    /* IN USE FLAG ON                */
*             RTM2SCBC=RTM2SCBC->SCBCHAIN;/* GET NEXT SCB            */
         B     @RC00116                                            0126
@RF00116 L     @12,RTM2SCBC(,RTM2PTR)                              0126
         L     @12,SCBCHAIN(,@12)                                  0126
         ST    @12,RTM2SCBC(,RTM2PTR)                              0126
*         ELSE                      /* END OF SCB QUEUE              */
*           DO;                                                    0127
         B     @RC00115                                            0127
@RF00115 DS    0H                                                  0128
*             RTM2SCBC=ZERO;        /* INDICATE END OF QUEUE         */
         SLR   @12,@12                                             0128
         ST    @12,RTM2SCBC(,RTM2PTR)                              0128
*             RTM2TRSW=ON;          /* INDICATE END OF SEARCH        */
         OI    RTM2TRSW(RTM2PTR),B'00010000'                       0129
*           END;                                                   0130
*       END;                                                       0131
@RC00115 DS    0H                                                  0131
@DE00114 TM    RTM2TRSW(RTM2PTR),B'00010000'                       0131
         BZ    @DL00114                                            0131
*       SCBPTR=RTM2SCBC;            /* INITIALIZE CURRENT SCB PTR    */
         L     SCBPTR,RTM2SCBC(,RTM2PTR)                           0132
*       IF SCBPTR^=0 THEN                                          0133
         LTR   SCBPTR,SCBPTR                                       0133
         BZ    @RF00133                                            0133
*         IF SCBSTAI=OFF&SCBSTAR=OFF THEN/* TEST FOR (E)STAE SCB     */
         TM    SCBSTAI(SCBPTR),B'11000000'                         0134
         BNZ   @RF00134                                            0134
*           DO;                     /* VALIDITY SCBOWNRA FIELD       */
*             RFY                                                  0136
*               RBSECPTR RSTD;                                     0136
*             RBSECPTR=RTM2VRBC;    /* START RB QUEUE SEARCH WITH  0137
*                                      ABEND SVRB                    */
         L     RBSECPTR,RTM2VRBC(,RTM2PTR)                         0137
*             DO WHILE(RBTCBNXT^=ON&SCBOWNRA^=RBSECPTR);/* SEARCH FOR
*                                      RB MATCH                      */
         B     @DE00138                                            0138
@DL00138 DS    0H                                                  0139
*               RBSECPTR=RBLINKB;   /* UPDATE RB POINTER             */
         L     @12,RBLINKB-1(,RBSECPTR)                            0139
         LA    @12,0(,@12)                                         0139
         LR    RBSECPTR,@12                                        0139
*             END;                  /* END RB SEARCH                 */
@DE00138 TM    RBTCBNXT(RBSECPTR),B'10000000'                      0140
         BO    @DC00138                                            0140
         L     @12,SCBOWNRA-1(,SCBPTR)                             0140
         LA    @12,0(,@12)                                         0140
         CR    RBSECPTR,@12                                        0140
         BNE   @DL00138                                            0140
@DC00138 DS    0H                                                  0141
*             IF SCBOWNRA^=RBSECPTR THEN                           0141
         L     @12,SCBOWNRA-1(,SCBPTR)                             0141
         LA    @12,0(,@12)                                         0141
         CR    RBSECPTR,@12                                        0141
         BE    @RF00141                                            0141
*               RTM2SCBC=ZERO;      /* TEST IF RB MATCH FOUND        */
         SLR   @12,@12                                             0142
         ST    @12,RTM2SCBC(,RTM2PTR)                              0142
*             RFY                                                  0143
*               RBSECPTR UNRSTD;                                   0143
@RF00141 DS    0H                                                  0144
*           END;                                                   0144
*     END;                          /* END FINDSCB                   */
@RF00134 DS    0H                                                  0145
@RF00133 DS    0H                                                  0146
*     IF RTM2SCBC^=ZERO THEN        /* TEST IF ELIGIBLE SCB FOUND    */
         SLR   @12,@12                                             0146
         C     @12,RTM2SCBC(,RTM2PTR)                              0146
         BE    @RF00146                                            0146
*       DO;                         /* ELIGIBLE SCB FOUND            */
*                                                                  0147
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT WKUPDAT WILL UPDATE RTM2 WORKAREA FOR THE USER  */
*         /* EXIT. IT FIRST INCLUDES IRBSRCH WHICH WILL DETERMINE IF */
*         /* THERE IS AN IRB PRECEDING THE RB WHOSE (E)STAE EXIT IS  */
*         /* NOW IN CONTROL. FLAG RTM2IRB IS TURNED ON IF THERE IS   */
*         /* ONE. NEXT IT IS DETERMINED IF THE RB ASSOCIATED WITH THE*/
*         /* CURRENT SCB WAS IN CONTROL AT THE TIME OF ERROR. IF IT  */
*         /* WAS NOT IN CONTROL FLAG RTM2NRBE IS SET. THE RB ADDRESS */
*         /* OF THE FAILING PROGRAM IS PUT IN RTM2 WORKAREA IF IT IS */
*         /* SUPERVISOR MODE. IF IT IS PP MODE THE NAME AND ENTRY    */
*         /* POINT OF THE ABENDING PROGRAM IS ENTERED IN RTM2        */
*         /* WORKAREA                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0148
*         ;                         /* BEGIN WKUPDAT                 */
*         IF RTM2IRB=OFF THEN       /* TEST IF INTERVENING IRB     0149
*                                      PREVIOUSLY ENCOUNTERD         */
*                                                                  0149
         TM    RTM2IRB(RTM2PTR),B'00100000'                        0149
         BNZ   @RF00149                                            0149
*           /*********************************************************/
*           /*                                                       */
*           /* SEGMENT IRBSRCH DETERMINES IF THERE IS AN IRB         */
*           /* PRECEDING THE RB WHOSE (E)STA EXIT IS NOW IN CONTROL. */
*           /* IT ACCOMPLISHES THIS BY TESTING EACH RB UP TO THE     */
*           /* CURRENT RB TO SEE IF IT IS AN IRB. FOR (E)STAE EXITS  */
*           /* THE CURRENT RB IS THE RB ADDRESS IN THE CURRENT SCB.  */
*           /* FOR (E)STAI/ESTAR EXITS THE CURRENT RB IS DEFINED AS  */
*           /* THE ONE WITH THE RBTCBNXT FLAG ON.                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0150
*           DO;                     /* BEGIN IRBSRCH                 */
*             IF RTM2RBST=ZERO THEN /* RTM2RBST IS THE STARTING    0151
*                                      ADDRESS FOR THE RB QUEUE    0151
*                                      SEARCH. IF IT IS ZERO,        */
         C     @12,RTM2RBST(,RTM2PTR)                              0151
         BNE   @RF00151                                            0151
*               RTM2RBST=RTM2VRBC;  /* INITIALIZE IT WITH THE TOP RB
*                                      ON THE QUEUE RESUME SEARCH  0152
*                                      WITH NEXT RB ON THE QUEUE     */
         L     @12,RTM2VRBC(,RTM2PTR)                              0152
         ST    @12,RTM2RBST(,RTM2PTR)                              0152
*             RESPECIFY                                            0153
*               RBSECPTR RESTRICTED;                               0153
@RF00151 DS    0H                                                  0154
*             RBSECPTR=RTM2RBST;    /* MAKE RTM2RBST CURRENT         */
         L     RBSECPTR,RTM2RBST(,RTM2PTR)                         0154
*             IF(SCBSTAI=ON|SCBSTAR=ON) THEN/* TEST IF (E)STAI OR  0155
*                                      ESTAR                         */
         TM    SCBSTAI(SCBPTR),B'11000000'                         0155
         BZ    @RF00155                                            0155
*               DO WHILE(RTM2IRB^=ON&/* SEARCH FOR AN IRB UNTIL THE  */
*                     RBTCBNXT^=ON);/* END OF THE RB QUEUE IS REACHED*/
         B     @DE00156                                            0156
@DL00156 DS    0H                                                  0157
*                 IF RBFTP='010'B THEN/* DETERMINE IF IRB            */
         TM    RBFTP(RBSECPTR),B'01000000'                         0157
         BNO   @RF00157                                            0157
         TM    RBFTP(RBSECPTR),B'10100000'                         0157
         BNZ   @RF00157                                            0157
*                   RTM2IRB=ON;     /* INDICATE IRB IN RTM2 WORKAREA */
         OI    RTM2IRB(RTM2PTR),B'00100000'                        0158
*                 ELSE                                             0159
*                   RBSECPTR=RBLINKB;/* UPDATE CURRENT RB POINTER    */
         B     @RC00157                                            0159
@RF00157 L     @12,RBLINKB-1(,RBSECPTR)                            0159
         LA    @12,0(,@12)                                         0159
         LR    RBSECPTR,@12                                        0159
*               END;                /* END IRB SEARCH                */
@RC00157 DS    0H                                                  0160
@DE00156 TM    RTM2IRB(RTM2PTR),B'00100000'                        0160
         BO    @DC00156                                            0160
         TM    RBTCBNXT(RBSECPTR),B'10000000'                      0160
         BNO   @DL00156                                            0160
@DC00156 DS    0H                                                  0161
*             ELSE                                                 0161
*               DO WHILE(RTM2IRB^=ON&/* SEARCH FOR AN IRB UNTIL THE  */
*                     SCBOWNRA^=RBSECPTR);/* RB RELATED TO CURRENT 0161
*                                      SCB IS ENCOUNTERED            */
         B     @RC00155                                            0161
@RF00155 B     @DE00161                                            0161
@DL00161 DS    0H                                                  0162
*                 IF RBFTP='010'B THEN/* DETERMINE IF IRB            */
         TM    RBFTP(RBSECPTR),B'01000000'                         0162
         BNO   @RF00162                                            0162
         TM    RBFTP(RBSECPTR),B'10100000'                         0162
         BNZ   @RF00162                                            0162
*                   RTM2IRB=ON;     /* INDICATE IRB IN RTM2 WKAREA   */
         OI    RTM2IRB(RTM2PTR),B'00100000'                        0163
*                 ELSE                                             0164
*                   RBSECPTR=RBLINKB;/* UPDATE CURRENT RB POINTER    */
         B     @RC00162                                            0164
@RF00162 L     @12,RBLINKB-1(,RBSECPTR)                            0164
         LA    @12,0(,@12)                                         0164
         LR    RBSECPTR,@12                                        0164
*               END;                                               0165
@RC00162 DS    0H                                                  0165
@DE00161 TM    RTM2IRB(RTM2PTR),B'00100000'                        0165
         BO    @DC00161                                            0165
         L     @12,SCBOWNRA-1(,SCBPTR)                             0165
         LA    @12,0(,@12)                                         0165
         CR    RBSECPTR,@12                                        0165
         BNE   @DL00161                                            0165
@DC00161 DS    0H                                                  0166
*             RTM2RBST=RBSECPTR;                                   0166
@RC00155 ST    RBSECPTR,RTM2RBST(,RTM2PTR)                         0166
*             RESPECIFY                                            0167
*               RBSECPTR UNRESTRICTED;                             0167
*           END;                                                   0168
*                                                                  0168
*/*  DETERMINE IF CURRENT RB WAS IN CONTROL AT TIME OF ERROR         */
*                                                                  0169
*         RESPECIFY                                                0169
*           RBSECPTR RESTRICTED;                                   0169
@RF00149 DS    0H                                                  0170
*         IF SCBSTAR=OFF&SCBSTAI=OFF THEN/* TEST FOR (E)STAE         */
         TM    SCBSTAR(SCBPTR),B'11000000'                         0170
         BNZ   @RF00170                                            0170
*           IF SCBOWNRA^=RTM2VRBC->RBLINKB THEN                    0171
         L     @12,RTM2VRBC(,RTM2PTR)                              0171
         CLC   SCBOWNRA(3,SCBPTR),RBLINKB(@12)                     0171
         BE    @RF00171                                            0171
*             RTM2NRBE=ON;          /* CURRENT RB NOT IN CONTROL     */
         OI    RTM2NRBE(RTM2PTR),B'01000000'                       0172
*           ELSE                                                   0173
*             ;                     /* TEST FOR ESTAR OR (E)STAI     */
@RF00171 DS    0H                                                  0174
*         ELSE                                                     0174
*           IF SCBSTAR=ON THEN      /* TEST FOR ESTAR                */
         B     @RC00170                                            0174
@RF00170 TM    SCBSTAR(SCBPTR),B'01000000'                         0174
         BNO   @RF00174                                            0174
*             DO;                                                  0175
*               RBSECPTR=RTM2VRBC;  /* INITIALIZE WITH CURRENT RB    */
         L     RBSECPTR,RTM2VRBC(,RTM2PTR)                         0176
*               DO WHILE(RBTCBNXT^=ON);/* BEGIN SEARCH FOR OLDEST RB */
         B     @DE00177                                            0177
@DL00177 DS    0H                                                  0178
*                 RBSECPTR=RBLINKB; /* GET NEXT RB                   */
         L     @12,RBLINKB-1(,RBSECPTR)                            0178
         LA    @12,0(,@12)                                         0178
         LR    RBSECPTR,@12                                        0178
*               END;                /* END OF RB SEARCH              */
@DE00177 TM    RBTCBNXT(RBSECPTR),B'10000000'                      0179
         BNO   @DL00177                                            0179
*               RTM2STAR=RBSECPTR;  /* PUT RB ADDRESS IN RTM2      0180
*                                      WORKAREA                      */
         ST    RBSECPTR,RTM2STAR(,RTM2PTR)                         0180
*               IF RTM2STAR^=RTM2VRBC->RBLINKB THEN                0181
         L     @12,RTM2STAR(,RTM2PTR)                              0181
         L     @11,RTM2VRBC(,RTM2PTR)                              0181
         L     @11,RBLINKB-1(,@11)                                 0181
         LA    @11,0(,@11)                                         0181
         CR    @12,@11                                             0181
         BE    @RF00181                                            0181
*                 RTM2NRBE=ON;                                     0182
         OI    RTM2NRBE(RTM2PTR),B'01000000'                       0182
*             END;                                                 0183
*           ELSE                                                   0184
*             RTM2NRBE=ON;          /* (E)STAI IS TCB RELATED        */
         B     @RC00174                                            0184
@RF00174 OI    RTM2NRBE(RTM2PTR),B'01000000'                       0184
*         IF RTM2BFTL=OFF THEN      /* TEST IF RTM2ABNM PREVIOUSLY 0185
*                                      INITIALIZED                   */
@RC00174 DS    0H                                                  0185
@RC00170 TM    RTM2BFTL(RTM2PTR),B'00001000'                       0185
         BNZ   @RF00185                                            0185
*           DO;                     /* IF NOT BEGIN SEARCH           */
*             RBSECPTR=RTM2VRBC->RBLINKB;                          0187
         L     @12,RTM2VRBC(,RTM2PTR)                              0187
         L     RBSECPTR,RBLINKB-1(,@12)                            0187
         LA    RBSECPTR,0(,RBSECPTR)                               0187
*             IF ADDR(RBOPSW)->PSWPPSUP^=ON THEN/* TEST FOR SUPRVSOR
*                                      MODE                          */
         TM    PSWPPSUP+16(RBSECPTR),B'00000001'                   0188
         BO    @RF00188                                            0188
*               RTM2ABNM(1:4)=RBSECPTR;/* SUPERVISOR MODE - ACCESS 0189
*                                      ABENDING RB ADDRESS           */
         STCM  RBSECPTR,15,RTM2ABNM(RTM2PTR)                       0189
*             ELSE                                                 0190
*                                                                  0190
*               /*****************************************************/
*               /*                                                   */
*               /* SEGMENT CDESRCH IS ENTERED IF THE USER IS IN PP   */
*               /* MODE. IF THE ABENDING RB IS A PRB THE NAME AND    */
*               /* ENTRY POINT OF THE PROGRAM ARE OBTAINED FROM THE  */
*               /* RELATED CDE IF ONE EXISTS. IF THE ABENDING RB IS  */
*               /* AN SIRB NO NAME IS PROVIDED AND THE ENTRY POINT IS*/
*               /* OBTAINED FROM THE FAILING IQE. IF THE ABENDING RB */
*               /* IS AN SVRB THE NAME FIELD IS SET TO ZEROES. IF THE*/
*               /* ABENDING RB IS AN IRB THE CDE CHAIN OF THE JOB    */
*               /* PACK AREA QUEUE AND THE LINK PACK AREA QUEUE ARE  */
*               /* SEARCHED IN AN ATTEMPT TO RELATE AN ENTRY POINT   */
*               /* ADDRESS IN THE IRB TO THE STORAGE DESCRIBED BY A  */
*               /* CDE.                                              */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0190
*               ;                   /* BEGIN CDE SEARCH              */
@RF00188 DS    0H                                                  0191
*             IF RBFTP='000'B THEN  /* TEST FOR PRB                  */
         TM    RBFTP(RBSECPTR),B'11100000'                         0191
         BNZ   @RF00191                                            0191
*               IF RBCDE1^=NULL THEN/* TEST IF A CDE EXISTS FOR PRB  */
         L     @12,RBCDE1-1(,RBSECPTR)                             0192
         LA    @12,0(,@12)                                         0192
         LTR   @12,@12                                             0192
         BZ    @RF00192                                            0192
*                 DO;               /* A CDE EXISTS                  */
*                   RTM2ABNM=RBCDE1->CDNAME;/* ACCESS PROGRAM NAME   */
         MVC   RTM2ABNM(8,RTM2PTR),CDNAME(@12)                     0194
*                   RTM2ABEP=RBCDE1->CDENTPT;/* ACCESS ENTRY POINT   */
         L     @12,CDENTPT(,@12)                                   0195
         ST    @12,RTM2ABEP(,RTM2PTR)                              0195
*                 END;                                             0196
*               ELSE                                               0197
*                 ;                                                0197
@RF00192 DS    0H                                                  0198
*             ELSE                                                 0198
*               DO;                                                0198
         B     @RC00191                                            0198
@RF00191 DS    0H                                                  0199
*                 IF RBFTP='010'B|RBFTP='100'B THEN/* TEST IF THIS IS
*                                      AN IRB OR SIRB                */
         TM    RBFTP(RBSECPTR),B'01000000'                         0199
         BNO   @GL00005                                            0199
         TM    RBFTP(RBSECPTR),B'10100000'                         0199
         BZ    @RT00199                                            0199
@GL00005 TM    RBFTP(RBSECPTR),B'10000000'                         0199
         BNO   @RF00199                                            0199
         TM    RBFTP(RBSECPTR),B'01100000'                         0199
         BNZ   @RF00199                                            0199
@RT00199 DS    0H                                                  0200
*                   RTM2ABEP=RBEP;  /* ACCESS EP OF SIRB OR IRB      */
*                                                                  0200
         L     @12,RBEP(,RBSECPTR)                                 0200
         ST    @12,RTM2ABEP(,RTM2PTR)                              0200
*                 /***************************************************/
*                 /*                                                 */
*                 /* FOR AN IRB, ATTEMPT TO RELATE THE ENTRY POINT TO*/
*                 /* THE STORAGE DESCRIBED BY A CDE.                 */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0201
*                 IF RBFTP='010'B THEN                             0201
@RF00199 TM    RBFTP(RBSECPTR),B'01000000'                         0201
         BNO   @RF00201                                            0201
         TM    RBFTP(RBSECPTR),B'10100000'                         0201
         BNZ   @RF00201                                            0201
*                   DO;                                            0202
*                     RTM2LPAQ=OFF; /* INITIALIZE LPAQ SEARCH SWITCH */
*                     RTM2JPAQ=OFF; /* INITIALIZE JPAQ SEARCH SWITCH */
*                     RTM2TRSW=OFF; /* INITIALIZE END OF SEARCH    0205
*                                                              SWITCH*/
         NI    RTM2LPAQ(RTM2PTR),B'11101001'                       0205
*                     RESPECIFY                                    0206
*                       CDENTPTR RESTRICTED;                       0206
*                     DO WHILE(RTM2LPAQ^=ON/* SEARCH UNTIL BOTH LPAQ
*                                      AND                           */
*                           &RTM2TRSW^=ON);/* JPAQ HAVE BEEN       0207
*                                      EXHAUSTED OR A RELATED CDE IS
*                                      FOUND                         */
         B     @DE00207                                            0207
@DL00207 DS    0H                                                  0208
*                       IF RTM2JPAQ=OFF THEN/* TEST IF JPAQ SEARCHED
*                                      YET                           */
         TM    RTM2JPAQ(RTM2PTR),B'00000010'                       0208
         BNZ   @RF00208                                            0208
*                         DO;       /* SEARCH JPAQ FIRST             */
*                           RTM2JPAQ=ON;                           0210
         OI    RTM2JPAQ(RTM2PTR),B'00000010'                       0210
*                           ESAGLREC=ON;/* SET UP RECURSION        0211
*                                      ENVIRONMENT           @YM01819*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0211
         OI    ESAGLREC+96(@12),B'00010000'                        0211
*                           DO;     /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(JPAQ,IEAVT
*                                      AS1(CDESRCH))                 */
*                             RFY                                  0213
*                              (GPR11P,                            0213
*                               GPR12P,                            0213
*                               GPR13P,                            0213
*                               GPR14P) RSTD;                      0213
*                             GPR13P=PSALITA;/* ADDRESS OF LOCK    0214
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0214
*                             GEN(LM GPR11P,GPR13P,576(GPR13P));/* 0215
*                                      LOAD LOCKWORD, CLHT AND ENTRY
*                                      ADRS.                         */
         LM GPR11P,GPR13P,576(GPR13P)
*                             GEN(BALR GPR14P,GPR13P);/* BALR TO   0216
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                             RFY                                  0217
*                              (GPR11P,                            0217
*                               GPR12P,                            0217
*                               GPR13P,                            0217
*                               GPR14P) UNRSTD;                    0217
*                           END;    /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(JPAQ,IEAVT
*                                      AS1(CDESRCH))         @YM01819*/
*                           ESAGLREC=OFF;/* TURN OFF RECURSION FLAG
*                                                            @YM01819*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0219
         NI    ESAGLREC+96(@12),B'11101111'                        0219
*                           CDENTPTR=RTM2TCBC->TCBJSTCB->TCBJPQB;/*
*                                      INITIALIZE POINTER FOR BEGIN
*                                      OF JPAQ SEARCH INSIDE LOCAL 0220
*                                      LOCK                  @ZA24479*/
         L     @12,RTM2TCBC(,RTM2PTR)                              0220
         L     @12,TCBJSTCB(,@12)                                  0220
         L     CDENTPTR,TCBJPQB-1(,@12)                            0220
         LA    CDENTPTR,0(,CDENTPTR)                               0220
*                         END;                                     0221
*                       ELSE        /* INITIALIZE SEARCH OF LPAQ     */
*                         DO;                                      0222
         B     @RC00208                                            0222
@RF00208 DS    0H                                                  0223
*                           RTM2LPAQ=ON;/* SEARCH LPAQ INDICATOR     */
         OI    RTM2LPAQ(RTM2PTR),B'00000100'                       0223
*                           ESAGLREC=ON;/* SET UP RECURSION        0224
*                                      ENVIRONMENT           @YM01819*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0224
         OI    ESAGLREC+96(@12),B'00010000'                        0224
*                           DO;     /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(CMS) RELATED(LPAQ,IEAVTAS
*                                      1(CDESRCH))                   */
*                             RFY                                  0226
*                              (GPR11P,                            0226
*                               GPR12P,                            0226
*                               GPR13P,                            0226
*                               GPR14P) RSTD;                      0226
*                             GPR13P=PSALITA;/* ADDRESS OF LOCK    0227
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0227
*                             GEN(LM GPR11P,GPR13P,540(GPR13P));/* 0228
*                                      LOAD LOCKWORD, CLHT AND ENTRY
*                                      ADRS.                         */
         LM GPR11P,GPR13P,540(GPR13P)
*                             GEN(BALR GPR14P,GPR13P);/* BALR TO   0229
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                             RFY                                  0230
*                              (GPR11P,                            0230
*                               GPR12P,                            0230
*                               GPR13P,                            0230
*                               GPR14P) UNRSTD;                    0230
*                           END;    /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(CMS) RELATED(LPAQ,IEAVTAS
*                                      1(CDESRCH))           @YM01819*/
*                           ESAGLREC=OFF;/* TURN OFF RECURSION FLAG
*                                                            @YM01819*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0232
         NI    ESAGLREC+96(@12),B'11101111'                        0232
*                           CDENTPTR=RTM2CVT->CVTQLPAQ->PTRCDE;/*  0233
*                                      INITIALIZE POINTER FOR BEGIN
*                                      OF LPAQ SEARCH NOW INSIDE CMS
*                                      LOCK                  @ZA24479*/
         L     @12,RTM2CVT(,RTM2PTR)                               0233
         L     @12,CVTQLPAQ(,@12)                                  0233
         L     CDENTPTR,PTRCDE(,@12)                               0233
*                         END;                                     0234
*                                                                  0234
*                       /*********************************************/
*                       /*                                           */
*                       /* SEGMENT JLPASRCH SEARCHES THE CDE CHAIN OF*/
*                       /* THE JOB PACK AREA QUEUE (JPAQ) AND THE    */
*                       /* LINK PACK AREA QUEUE IN AN ATTEMPT TO     */
*                       /* RELATE AN ENTRY POINT ADDRESS IN THE IRB  */
*                       /* TO THE STORAGE DESCRIBED BY A CDE.        */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0235
*                       DO WHILE(CDENTPTR^=NULL&RTM2TRSW^=ON);/* THIS
*                                      SEARCH WILL CONTINUE UNTIL A
*                                      CDE IS FOUND OR THE CDE QUEUE
*                                      IS EXHAUSTED                  */
@RC00208 B     @DE00235                                            0235
@DL00235 DS    0H                                                  0236
*                         RESPECIFY                                0236
*                          (XTLSTPTR,                              0236
*                           I) RESTRICTED;                         0236
*                         XTLSTPTR=CDXLMJP;/* INITIALIZE XTENT LIST
*                                      POINTER                       */
         L     XTLSTPTR,CDXLMJP(,CDENTPTR)                         0237
*                         IF CDENTPT^=RBEP THEN/* TEST IF PROGRAM-S
*                                      ENTRY POINT IS EQUAL TO IRB 0238
*                                      ENTRY POINT                   */
         CLC   CDENTPT(4,CDENTPTR),RBEP(RBSECPTR)                  0238
         BE    @RF00238                                            0238
*                           IF CDMIN^=ON THEN/* A MINOR CDE DOES NOT
*                                      CONTAIN AN XTENT LIST POINTER */
         TM    CDMIN(CDENTPTR),B'00000100'                         0239
         BO    @RF00239                                            0239
*                             IF XTLSTPTR^=ZERO THEN/* TEST IF XTENT
*                                      LIST EXISTS                   */
         LTR   XTLSTPTR,XTLSTPTR                                   0240
         BZ    @RF00240                                            0240
*                               DO I=1 TO XTLNRFAC WHILE(RTM2TRSW^=ON);
         LA    I,1                                                 0241
         B     @DE00241                                            0241
@DL00241 TM    RTM2TRSW(RTM2PTR),B'00010000'                       0241
         BO    @DC00241                                            0241
*                                   /* THIS SEARCH WILL CONTINUE   0242
*                                      UNTIL A MATCH IS FOUND OR   0242
*                                      THERE IS NO MATCH FOR THIS CDE*/
*                                 IF XTLMSBAA(I)+XTLMSBLN(I)>RBCDE1&
*                                   /* IF EP BELOW TOP       @ZA24479*/
*                                     XTLMSBAA(I)^>RBCDE1 THEN/* AND
*                                      IF EP IS ABOVE THE BOTTOM OF
*                                      THE MODULE DESCRIBED BY THIS
*                                      CDE THEN THIS IS THE CDE    0242
*                                                            @ZA24479*/
         LR    @12,I                                               0242
         SLA   @12,2                                               0242
         LA    @11,XTLMSBLA(,XTLSTPTR)                             0242
         L     @04,XTLNRFAC(,XTLSTPTR)                             0242
         SLA   @04,2                                               0242
         ALR   @11,@04                                             0242
         AL    @11,@CF03334                                        0242
         L     @11,XTLMSBAA(@12,@11)                               0242
         L     @12,XTLMSBLN-5(@12,XTLSTPTR)                        0242
         LA    @12,0(,@12)                                         0242
         ALR   @12,@11                                             0242
         L     @04,RBCDE1-1(,RBSECPTR)                             0242
         LA    @04,0(,@04)                                         0242
         CR    @12,@04                                             0242
         BNH   @RF00242                                            0242
         CR    @11,@04                                             0242
         BH    @RF00242                                            0242
*                                   DO;/* MATCH FOUND                */
*                                    RTM2ABNM=CDNAME;/* ACCESS     0244
*                                      PROGRAM NAME                  */
         MVC   RTM2ABNM(8,RTM2PTR),CDNAME(CDENTPTR)                0244
*                                    RTM2TRSW=ON;/* TRIGGER END OF 0245
*                                                              SEARCH*/
         OI    RTM2TRSW(RTM2PTR),B'00010000'                       0245
*                                   END;/* END MATCH FOUND           */
*                                 ELSE                             0247
*                                   CDENTPTR=CDCHAIN;/* GET NEXT CDE */
         B     @RC00242                                            0247
@RF00242 L     CDENTPTR,CDCHAIN(,CDENTPTR)                         0247
*                               END;/* END XTENT LIST SEARCH         */
@RC00242 AL    I,@CF00057                                          0248
@DE00241 C     I,XTLNRFAC(,XTLSTPTR)                               0248
         BNH   @DL00241                                            0248
@DC00241 DS    0H                                                  0249
*                             ELSE  /* THERE IS NO XTENT LIST        */
*                               CDENTPTR=CDCHAIN;/* GET NEXT CDE     */
         B     @RC00240                                            0249
@RF00240 L     CDENTPTR,CDCHAIN(,CDENTPTR)                         0249
*                           ELSE    /* CDE IS A MINOR CDE            */
*                             CDENTPTR=CDCHAIN;/* GET NEXT CDE       */
         B     @RC00239                                            0250
@RF00239 L     CDENTPTR,CDCHAIN(,CDENTPTR)                         0250
*                         ELSE      /* MATCH FOUND                   */
*                           DO;     /* INITIALIZE RTM2 WORKAREA      */
         B     @RC00238                                            0251
@RF00238 DS    0H                                                  0252
*                             IF CDMIN=ON THEN/* TEST IF MINOR CDE   */
         TM    CDMIN(CDENTPTR),B'00000100'                         0252
         BNO   @RF00252                                            0252
*                               CDENTPTR=CDXLMJP;/* GET MAJOR CDE    */
         L     CDENTPTR,CDXLMJP(,CDENTPTR)                         0253
*                             RTM2ABNM=CDNAME;/* ACCESS PROGRAM NAME */
@RF00252 MVC   RTM2ABNM(8,RTM2PTR),CDNAME(CDENTPTR)                0254
*                             RTM2TRSW=ON;/* TRIGGER END OF SEARCH   */
         OI    RTM2TRSW(RTM2PTR),B'00010000'                       0255
*                           END;    /* END RTM2 WKAREA INITIALIZATION*/
*                         RESPECIFY                                0257
*                          (XTLSTPTR,                              0257
*                           I) UNRESTRICTED;                       0257
@RC00238 DS    0H                                                  0258
*                       END;        /* END JLPASRCH                  */
@DE00235 LTR   CDENTPTR,CDENTPTR                                   0258
         BZ    @DC00235                                            0258
         TM    RTM2TRSW(RTM2PTR),B'00010000'                       0258
         BNO   @DL00235                                            0258
@DC00235 DS    0H                                                  0259
*                     END;          /* IF RTM2LPAQ IS ON -I.E. THE 0259
*                                      LPAQ & JPAQ HAVE BOTH BEEN  0259
*                                      SEARCHED OR IF RTM2TRSW IS ON-
*                                      I.E. A CDE MATCH WAS FOUND, 0259
*                                      THE SEARCH WILL END           */
@DE00207 TM    RTM2LPAQ(RTM2PTR),B'00010100'                       0259
         BZ    @DL00207                                            0259
*                     ESAGLREC=ON;  /* SET RECURSION ENVIRONMENT   0260
*                                                            @YM01819*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0260
         OI    ESAGLREC+96(@12),B'00010000'                        0260
*                     IF RTM2LPAQ=ON THEN/* TEST IF CMS LOCK OBTAINED
*                                                            @YM01819*/
         TM    RTM2LPAQ(RTM2PTR),B'00000100'                       0261
         BNO   @RF00261                                            0261
*                       DO;         /* RELEASE CMS LOCK      @YM01819*/
*                         DO;       /* SETLOCK (RELEASE) TYPE(CMS) RE
*                                      LATED(LPAQ,IEAVTAS1(CDESRCH)) */
*                           RFY                                    0264
*                            (GPR11P,                              0264
*                             GPR12P,                              0264
*                             GPR13P,                              0264
*                             GPR14P) RSTD;                        0264
*                           GPR13P=PSALITA;/* ADDRESS OF LOCK      0265
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0265
*                           GEN(LM GPR11P,GPR13P,552(GPR13P));/* LOAD
*                                      LOCKWORD, CLHT AND ENTRY ADRS.*/
         LM GPR11P,GPR13P,552(GPR13P)
*                           GEN(BALR GPR14P,GPR13P);/* BALR TO     0267
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                           RFY                                    0268
*                            (GPR11P,                              0268
*                             GPR12P,                              0268
*                             GPR13P,                              0268
*                             GPR14P) UNRSTD;                      0268
*                         END;      /* SETLOCK (RELEASE) TYPE(CMS) RE
*                                      LATED(LPAQ,IEAVTAS1(CDESRCH))
*                                                            @YM01819*/
*                       END;        /* END FREE CMS LOCK     @YM01819*/
*                     DO;           /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(JPAQ,IEAVTAS1(CDESRCH)
*                                      )                             */
@RF00261 DS    0H                                                  0272
*                       RFY                                        0272
*                        (GPR11P,                                  0272
*                         GPR12P,                                  0272
*                         GPR13P,                                  0272
*                         GPR14P) RSTD;                            0272
*                       GPR13P=PSALITA;/* ADDRESS OF LOCK INTERFACE
*                                      TABLE.                        */
         L     GPR13P,PSALITA                                      0273
*                       GEN(LM GPR11P,GPR13P,588(GPR13P));/* LOAD  0274
*                                      LOCKWORD, CLHT AND ENTRY ADRS.*/
         LM GPR11P,GPR13P,588(GPR13P)
*                       GEN(BALR GPR14P,GPR13P);/* BALR TO SETLOCK 0275
*                                      RTN.                          */
         BALR GPR14P,GPR13P
*                       RFY                                        0276
*                        (GPR11P,                                  0276
*                         GPR12P,                                  0276
*                         GPR13P,                                  0276
*                         GPR14P) UNRSTD;                          0276
*                     END;          /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(JPAQ,IEAVTAS1(CDESRCH)
*                                      )                     @YM01819*/
*                     ESAGLREC=OFF; /* TURN OFF RECURSION FLAG     0278
*                                                            @YM01819*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0278
         NI    ESAGLREC+96(@12),B'11101111'                        0278
*                     RESPECIFY                                    0279
*                       CDENTPTR UNRESTRICTED;                     0279
*                   END;            /* END OF IRB PROCESSING         */
*                                                                  0280
*                 /***************************************************/
*                 /*                                                 */
*                 /* FOR AN SVRB, PROGRAM NAME AND ENTRY POINT ARE   */
*                 /* ZEROES                                          */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0281
*               END;                /* END OF RB TYPE SEARCH         */
@RF00201 DS    0H                                                  0282
*             ;                     /* END CDE SEARCH                */
@RC00191 DS    0H                                                  0283
*           END;                                                   0283
*         RESPECIFY                                                0284
*           RBSECPTR UNRESTRICTED;                                 0284
@RF00185 DS    0H                                                  0285
*         IF SCBPRNTR=ON THEN                                      0285
         TM    SCBPRNTR(SCBPTR),B'00001000'                        0285
         BNO   @RF00285                                            0285
*           RTM2STAE=ON;                                           0286
         OI    RTM2STAE(RTM2PTR),B'00100000'                       0286
*         ELSE                                                     0287
*           RTM2STAE=OFF;                                          0287
         B     @RC00285                                            0287
@RF00285 NI    RTM2STAE(RTM2PTR),B'11011111'                       0287
*         ;                         /* END WKUPDAT                   */
*                                                                  0288
@RC00285 DS    0H                                                  0289
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT SDWAINIT WILL OBTAIN AND INITIALIZE THE         */
*         /* SDWA(RTCA). IT FIRST ESTABLISHES RECURSION CONTROL BY   */
*         /* STORING REGISTERS IN RTM2 WORKAREA, INITIALIZING A      */
*         /* GETMAIN RECURSION FLAG, AND ESTABLISHING A RECURSION    */
*         /* ADDRESS. IT THEN INCLUDES SEGMENTS GETSDWA TO OBTAIN THE*/
*         /* WORKAREA, SDWADATA TO INITIALIZE SDWA WITH DATA FROM    */
*         /* VARIOUS RESOURCES, CNVRTPSW TO CONVERT EC MODE PSW TO BC*/
*         /* MODE AND FINALLY, SDWARTM2 TO INITIALIZE SDWA WITH      */
*         /* APPLICABLE DATA FROM RTM2 WORKAREA ALSO, A POINTER TO   */
*         /* THE VARIABLE RECORDING AREA WITHIN THE SDWA IS          */
*         /* INITIALIZED.                                            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0289
*         DO;                       /* BEGIN SDWAINIT                */
*                                                                  0289
*           /*********************************************************/
*           /*                                                       */
*           /* SEGMENT GETSDWA WILL PERFORM THE GETMAIN FOR THE      */
*           /* SDWA(RTCA). IF THE USER IS IN SUPERVISOR MODE, THE    */
*           /* REQUEST WILL BE FROM SUBPOOL 230. IF THE USER IS IN   */
*           /* P/P MODE THE REQUEST WILL BE FROM SUBPOOL 0. IF THE   */
*           /* GETMAIN IS SUCCESSFUL THE SUBPOOL ID AND LENGTH WILL  */
*           /* BE STORED IN RTM2 WORKAREA. IF CORE IS NOT AVAILABLE A*/
*           /* FLAG IS SET IN RTM2 WORKAREA.                         */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0290
*           DO;                     /* BEGIN GETSDWA                 */
*             R15=4;                /* SET RC IN CASE GETMAIN      0291
*                                      RECURSION, SO RTM2WANA IS SET
*                                      ON                    @ZA01940*/
         LA    R15,4                                               0291
*             IF RTM2GMR=OFF THEN   /* NOT GETMAIN RECURSION @ZA01940*/
         TM    RTM2GMR(RTM2PTR),B'00100000'                        0292
         BNZ   @RF00292                                            0292
*               DO;                 /* OK TO GET SDWA        @ZA01940*/
*                 IF SCBESTAE=ON&SCBPKEY<KEY8 THEN/* DETERMINE USER
*                                      MODE                          */
         TM    SCBESTAE(SCBPTR),B'00010000'                        0294
         BNO   @RF00294                                            0294
         CLI   SCBPKEY(SCBPTR),X'80'                               0294
         BNL   @RF00294                                            0294
*                   RTM2SUBP=SUPERSP;/* GETMAIN FROM SP 230          */
         MVI   RTM2SUBP(RTM2PTR),X'E6'                             0295
*                 ELSE                                             0296
*                   RTM2SUBP=PPSP;                                 0296
         B     @RC00294                                            0296
@RF00294 MVI   RTM2SUBP(RTM2PTR),X'FA'                             0296
*                 RTM2SIZE=LENGTH(SDWA)+USAVE;/* GETMAIN FROM SP 0   */
@RC00294 MVC   RTM2SIZE(3,RTM2PTR),@CF03307+1                      0297
*                 RESPECIFY                                        0298
*                  (R0,                                            0298
*                   R1,                                            0298
*                   R15) RESTRICTED;                               0298
*                 GEN(STM  0,15,RTM2RREG(RTM2PTR));                0299
         STM  0,15,RTM2RREG(RTM2PTR)
*                 RTM2GMS=ON;       /* TURN ON SECTION FLAG          */
         OI    RTM2GMS(RTM2PTR),B'00010000'                        0300
*                 RTM2TRRA=ADDR(RECURSE);/* RECURSION ADDRESS        */
         LA    @14,RECURSE                                         0301
         ST    @14,RTM2TRRA(,RTM2PTR)                              0301
*                 DO;               /* GETMAIN (RC) LV(RTM2SIZE)   0302
*                                      SP(RTM2SUBP)                  */
*                   RESPECIFY                                      0303
*                    (GPR01F,                                      0303
*                     GPR15F,                                      0303
*                     GPR00F) RESTRICTED;                          0303
*                   GPR01F=0;       /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0304
*                   GPR15F=0;       /* RC-TYPE GETMAIN               */
         SLR   GPR15F,GPR15F                                       0305
*                   GPR00F=RTM2SIZE;/* LENGTH REQUESTED              */
         L     GPR00F,RTM2SIZE-1(,RTM2PTR)                         0306
         ICM   GPR00F,8,@CB03336                                   0306
*                   GPR15F=GPR15F|((RTM2SUBP)*256);/* SP IN BYTE 2   */
         SLR   @14,@14                                             0307
         IC    @14,RTM2SUBP(,RTM2PTR)                              0307
         SLA   @14,8                                               0307
         OR    GPR15F,@14                                          0307
*                   SVC(120);       /* RC/RU-FORM OF GETMAIN         */
         SVC   120                                                 0308
*                   RESPECIFY                                      0309
*                    (GPR01F,                                      0309
*                     GPR15F,                                      0309
*                     GPR00F) UNRESTRICTED;                        0309
*                 END;              /* GETMAIN (RC) LV(RTM2SIZE)   0310
*                                      SP(RTM2SUBP)                  */
*GMRETURN:                          /* RETURN ADDRESS IF RECURSION   */
*                 RTM2TRRA=ZERO;    /* ZERO RECURSION ADDRESS        */
GMRETURN SLR   @14,@14                                             0311
         ST    @14,RTM2TRRA(,RTM2PTR)                              0311
*                 RTM2GMS=OFF;      /* ZERO SECTION FLAG             */
         NI    RTM2GMS(RTM2PTR),B'11101111'                        0312
*               END;                /* SDWA OBTAINED         @ZA01940*/
*             IF R15^=ZERO THEN     /* TEST IF CORE AVAILABLE        */
@RF00292 SLR   @14,@14                                             0314
         CR    R15,@14                                             0314
         BE    @RF00314                                            0314
*               DO;                 /* CORE NOT AVAILABLE            */
*                 RTM2WANA=ON;      /* INDICATE CORE NOT AVAILABLE   */
         OI    RTM2WANA(RTM2PTR),B'00100000'                       0316
*                 RTM2SPLL=ZERO;    /* ZERO SP ID AND LENGTH         */
         ST    @14,RTM2SPLL(,RTM2PTR)                              0317
*                 RTM2RTCA=ZERO;    /* ZERO SDWA PTR IN RTM2WA       */
         ST    @14,RTM2RTCA(,RTM2PTR)                              0318
*               END;                                               0319
*             ELSE                  /* IF CORE AVAILABLE             */
*               DO;                                                0320
         B     @RC00314                                            0320
@RF00314 DS    0H                                                  0321
*                 RTM2RTCA=R1;                                     0321
         ST    R1,RTM2RTCA(,RTM2PTR)                               0321
*                 RTM2WANA=OFF;     /* INDICATE CORE AVAILABLE     0322
*                                                            @ZA02145*/
         NI    RTM2WANA(RTM2PTR),B'11011111'                       0322
*                 RTM2RTCA->SDWA(1:256)=''B;                       0323
         L     @14,RTM2RTCA(,RTM2PTR)                              0323
         XC    SDWA(256,@14),SDWA(@14)                             0323
*                 RTM2RTCA->SDWA(257:512)=''B;                     0324
         XC    SDWA+256(256,@14),SDWA+256(@14)                     0324
*               END;                                               0325
*             RESPECIFY                                            0326
*              (R0,                                                0326
*               R1,                                                0326
*               R15) UNRESTRICTED;                                 0326
@RC00314 DS    0H                                                  0327
*           END;                    /* END GETSDWA                   */
*           SDWAPTR=RTM2RTCA;       /* INITIALIZE SDWA PTR           */
         L     SDWAPTR,RTM2RTCA(,RTM2PTR)                          0328
*           IF RTM2WANA=OFF THEN    /* TEST IF SDWA AVAILABLE        */
         TM    RTM2WANA(RTM2PTR),B'00100000'                       0329
         BNZ   @RF00329                                            0329
*             DO;                   /* DO IF SDWA AVAILABLE          */
*                                                                  0330
*               /*****************************************************/
*               /*                                                   */
*               /* SEGMENT SDWADATA INITIALIZES THE SDWA(RTCA) WITH  */
*               /* APPLICABLE DATA FROM THE CURRENT SCB AND ITS      */
*               /* RELATED RB.                                       */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0331
*               DO;                 /* BEGIN SDWADATA                */
*                 SDWAIDNT=RTM2SPLL;                               0332
         MVC   SDWAIDNT(4,SDWAPTR),RTM2SPLL(RTM2PTR)               0332
*                 IF RTM2SUBP=PPSP&SCBSUPER=OFF THEN/*       @YM04746*/
         CLI   RTM2SUBP(RTM2PTR),250                               0333
         BNE   @RF00333                                            0333
         TM    SCBSUPER(SCBPTR),B'00000001'                        0333
         BNZ   @RF00333                                            0333
*                   SDWASPID=SP0;                                  0334
         MVI   SDWASPID(SDWAPTR),X'00'                             0334
*                 SDWAPARM=SCBPARMA;/* PUT USER PARAMETER LIST     0335
*                                      ADDRESS IN SDWA               */
@RF00333 L     @12,SCBPARMA-1(,SCBPTR)                             0335
         LA    @12,0(,@12)                                         0335
         ST    @12,SDWAPARM(,SDWAPTR)                              0335
*                 IF SCBRECRD=ON THEN/* IF SCB INDICATES RECORD ...  */
         TM    SCBRECRD(SCBPTR),B'00100000'                        0336
         BNO   @RF00336                                            0336
*                   SDWARCRD=ON;    /* INDICATE RECORD IN SDWA       */
         OI    SDWARCRD(SDWAPTR),B'10000000'                       0337
*                 IF RTM2DREQ=ON THEN/* IF RTM2 WKAREA INDICATES   0338
*                                      DUMP..                        */
@RF00336 TM    RTM2DREQ(RTM2PTR),B'10000000'                       0338
         BNO   @RF00338                                            0338
*                   SDWAREQ=ON;     /* INDICATE DUMP IN SDWA         */
         OI    SDWAREQ(SDWAPTR),B'10000000'                        0339
*                 IF RTM2STEP=ON THEN                              0340
@RF00338 TM    RTM2STEP(RTM2PTR),B'01000000'                       0340
         BNO   @RF00340                                            0340
*                   SDWASTEP=ON;    /* INDICATE TAKE JOBSTEP         */
         OI    SDWASTEP(SDWAPTR),B'01000000'                       0341
*                 IF SCBSTAI=OFF THEN/* IF (E)STAI BYPASS FURTHER  0342
*                                      INITIALIZATION                */
@RF00340 TM    SCBSTAI(SCBPTR),B'10000000'                         0342
         BNZ   @RF00342                                            0342
*                   DO;             /* IF ESTAR OR (E)STAE           */
*                     RESPECIFY                                    0344
*                      (RBSECPTR) RESTRICTED;                      0344
*                     IF SCBSTAR=ON THEN/* TEST IF ESTAR             */
         TM    SCBSTAR(SCBPTR),B'01000000'                         0345
         BNO   @RF00345                                            0345
*                       RBSECPTR=RTM2STAR;/* ESTAR RELATED RB        */
         L     RBSECPTR,RTM2STAR(,RTM2PTR)                         0346
*                     ELSE          /* (E)STAE RELATED RB IS       0347
*                                      CONTAINED IN THE SCB          */
*                       RBSECPTR=SCBOWNRA;/* INITIALIZE CURRENT RB 0347
*                                      POINTER                       */
         B     @RC00345                                            0347
@RF00345 L     RBSECPTR,SCBOWNRA-1(,SCBPTR)                        0347
         LA    RBSECPTR,0(,RBSECPTR)                               0347
*                     SDWAEC2=RBOPSW;/* ACCESS EC PSW OF CURRENT RB  */
@RC00345 MVC   SDWAEC2(8,SDWAPTR),RBOPSW(RBSECPTR)                 0348
*                     SDWAILC2=RBINLNTH;/* INSTRUCTION LENGTH CODE   */
         LR    @12,RBSECPTR                                        0349
         SL    @12,@CF00458                                        0349
         MVC   SDWAILC2(1,SDWAPTR),RBINLNTH(@12)                   0349
*                     SDWAINC2=RBINTCOD;/* INTERRUPT CODE            */
         LH    @11,RBINTCOD(,@12)                                  0350
         N     @11,@CF03338                                        0350
         STH   @11,SDWAINC2(,SDWAPTR)                              0350
*                     SDWATRN2=RBRTRAN;/* VIRTUAL STORAGE ADDRESS    */
         L     @12,RBRTRAN(,@12)                                   0351
         ST    @12,SDWATRN2(,SDWAPTR)                              0351
*                     RBSECPTR=RTM2VRBC;/* MAKE TOP RB CURRENT       */
*                                                                  0352
         L     RBSECPTR,RTM2VRBC(,RTM2PTR)                         0352
*                     /***********************************************/
*                     /*                                             */
*                     /* CHAIN THROUGH THE RB QUEUE TO FIND THE      */
*                     /* REGISTERS OF THE RB ASSOCIATED WITH THE     */
*                     /* CURRENT SCB                                 */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0353
*                     DO WHILE(RBLINKB^=SCBOWNRA&RBLINKB^=RTM2STAR);
         B     @DE00353                                            0353
@DL00353 DS    0H                                                  0354
*                       RBSECPTR=RBLINKB;/* UPDATE CURRENT RB POINTER*/
         L     @12,RBLINKB-1(,RBSECPTR)                            0354
         LA    @12,0(,@12)                                         0354
         LR    RBSECPTR,@12                                        0354
*                     END;          /* FALL THROUGH WHEN RB FOUND    */
@DE00353 CLC   RBLINKB(3,RBSECPTR),SCBOWNRA(SCBPTR)                0355
         BE    @DC00353                                            0355
         L     @12,RBLINKB-1(,RBSECPTR)                            0355
         LA    @12,0(,@12)                                         0355
         C     @12,RTM2STAR(,RTM2PTR)                              0355
         BNE   @DL00353                                            0355
@DC00353 DS    0H                                                  0356
*                     SDWASRSV=RBGRSAVE;/* ACCESS REGISTERS          */
         MVC   SDWASRSV(64,SDWAPTR),RBGRSAVE(RBSECPTR)             0356
*                     RESPECIFY                                    0357
*                      (RBSECPTR) UNRESTRICTED;                    0357
*                   END;            /* END (E)STAE /ESTAR PROCESSING */
*               END;                /* END SDWADATA                  */
@RF00342 DS    0H                                                  0360
*               IF RTM2BFTL=OFF THEN/* FIRST TIME LOGIC              */
*                                                                  0360
         TM    RTM2BFTL(RTM2PTR),B'00001000'                       0360
         BNZ   @RF00360                                            0360
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT CNVRTPSW WILL CONVERT THE PSW OF THE    */
*                 /* ABENDING RB (RTM2EC1) AND THE PSW OF THE LAST   */
*                 /* PRB ON THE QUEUE ,IF THERE IS ONE, TO THE BC    */
*                 /* MODE FORM OF THE PSW.                           */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0361
*                 DO;               /* BEGIN CNVRTPSW                */
*                                                                  0361
*                   /*************************************************/
*                   /*                                               */
*                   /* CONVERT PSW OF ABENDING RB                    */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0362
*                   IF RTM2EXT1=ON THEN/* TEST IF EXTERNAL INTERRUPT
*                                      ON                            */
         TM    RTM2EXT1(RTM2PTR),B'00000001'                       0362
         BNO   @RF00362                                            0362
*                     RTM2EXTA=ON;  /* SET EXTERNAL INTERRUPT        */
         OI    RTM2EXTA(RTM2PTR),B'00000001'                       0363
*                   IF RTM2AIO1=ON THEN/* ALLOW I/O INTERRUPT        */
@RF00362 TM    RTM2AIO1(RTM2PTR),B'00000010'                       0364
         BNO   @RF00364                                            0364
*                     RTM2IOA=ALLONE;/* YES, TURN ON CHANNEL MASKS   */
         OI    RTM2IOA(RTM2PTR),B'11111110'                        0365
*                   RTM2MWPA=RTM2MWP1;/* SET KEY AND M-W-P           */
@RF00364 MVC   RTM2MWPA(1,RTM2PTR),RTM2MWP1(RTM2PTR)               0366
*                   RTM2MWPA=RTM2MWPA&'11110111'B;/* ZERO EXTENDED 0367
*                                      CONTROL MODE BIT              */
         NI    RTM2MWPA(RTM2PTR),B'11110111'                       0367
*                   RTM2INTA=RTM2INC1;/* SET INTERRUPT CODE          */
         LH    @12,RTM2INC1(,RTM2PTR)                              0368
         N     @12,@CF03338                                        0368
         STH   @12,RTM2INTA(,RTM2PTR)                              0368
*                   RTM2PMKA=RTM2INT1;/* SET CONDITION CODE AND    0369
*                                      PROGRAM MASK                  */
         MVC   RTM2PMKA(1,RTM2PTR),RTM2INT1(RTM2PTR)               0369
*                   IF RTM2IL1(1)=ON THEN/* IF ON ...                */
         TM    RTM2IL1(RTM2PTR),B'00000100'                        0370
         BNO   @RF00370                                            0370
*                     RTM2ILA(1)=ON;/* SET FIRST ILC BIT             */
         OI    RTM2ILA(RTM2PTR),B'10000000'                        0371
*                   IF RTM2IL1(2)=ON THEN/* IF ON ...                */
@RF00370 TM    RTM2IL1(RTM2PTR),B'00000010'                        0372
         BNO   @RF00372                                            0372
*                     RTM2ILA(2)=ON;/* SET SECOND ILC BIT            */
         OI    RTM2ILA(RTM2PTR),B'01000000'                        0373
*                   RTM2NXTA=RTM2ADD1;/* NEXT INSTRUCTION ADDRESS    */
*                                                                  0374
@RF00372 MVC   RTM2NXTA(3,RTM2PTR),RTM2ADD1(RTM2PTR)               0374
*                   /*************************************************/
*                   /*                                               */
*                   /* SEARCH FOR LAST PRB ON QUEUE                  */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0375
*                   RESPECIFY                                      0375
*                    (RBSECPTR) RESTRICTED;                        0375
*                   RBSECPTR=RTM2VRBC;/* INITIALIZE CURRENT RB       */
         L     RBSECPTR,RTM2VRBC(,RTM2PTR)                         0376
*                   DO WHILE(RBFTP^='000'B&RBTCBNXT^=ON);          0377
         B     @DE00377                                            0377
@DL00377 DS    0H                                                  0378
*                     RBSECPTR=RBLINKB;/* UPDATE RB POINTER          */
         L     @12,RBLINKB-1(,RBSECPTR)                            0378
         LA    @12,0(,@12)                                         0378
         LR    RBSECPTR,@12                                        0378
*                   END;            /* FALL THROUGH IF A PRB IS FOUND
*                                      OR IF THE RB Q IS EXHAUSTED   */
@DE00377 TM    RBFTP(RBSECPTR),B'11100000'                         0379
         BZ    @DC00377                                            0379
         TM    RBTCBNXT(RBSECPTR),B'10000000'                      0379
         BNO   @DL00377                                            0379
@DC00377 DS    0H                                                  0380
*                   IF RBFTP='000'B THEN/* TEST IF PRB FOUND         */
         TM    RBFTP(RBSECPTR),B'11100000'                         0380
         BNZ   @RF00380                                            0380
*                     DO;                                          0381
*                       IF PSWEXT=ON THEN/* TEST IF EXTERNAL       0382
*                                      INTERRUPT ON                  */
         TM    PSWEXT+16(RBSECPTR),B'00000001'                     0382
         BNO   @RF00382                                            0382
*                         RTM2EXTP=ON;/* SET EXTERNAL INTERRUPT      */
         OI    RTM2EXTP(RTM2PTR),B'00000001'                       0383
*                       IF PSWIO=ON THEN/* ALLOW I/O INTERRUPT       */
@RF00382 TM    PSWIO+16(RBSECPTR),B'00000010'                      0384
         BNO   @RF00384                                            0384
*                         RTM2IOP=ALLONE;/* YES, TURN ON CHANNEL   0385
*                                      MASKS                         */
         OI    RTM2IOP(RTM2PTR),B'11111110'                        0385
*                       RTM2MWPP=PSWMWP;/* SET KEY AND M-W-P         */
@RF00384 LA    @12,16                                              0386
         ALR   @12,RBSECPTR                                        0386
         MVC   RTM2MWPP(1,RTM2PTR),PSWMWP(@12)                     0386
*                       RTM2MWPP=RTM2MWPP&'11110111'B;/* ZERO      0387
*                                      EXTENDED CONTROL MODE BIT     */
         NI    RTM2MWPP(RTM2PTR),B'11110111'                       0387
*                       RTM2INTP=RBINTCOD;/* SET INTERRUPT CODE      */
         LR    @11,RBSECPTR                                        0388
         SL    @11,@CF00458                                        0388
         MVC   RTM2INTP(2,RTM2PTR),RBINTCOD(@11)                   0388
*                       RTM2PMKP=PSWINT;/* SET CONDITION CODE AND  0389
*                                      PROGRAM MASK                  */
         MVC   RTM2PMKP(1,RTM2PTR),PSWINT(@12)                     0389
*                       IF PSWINLEN(6)=ON THEN/* THE 2 BIT LENGTH  0390
*                                      INDICATOR IS MOVED            */
         TM    PSWINLEN(@11),B'00000100'                           0390
         BNO   @RF00390                                            0390
*                         RTM2ILP(1)=ON;/* FROM THE RB (RBINLNTH) TO
*                                      RTM2 WORKAREA PSW             */
         OI    RTM2ILP(RTM2PTR),B'10000000'                        0391
*                       IF PSWINLEN(7)=ON THEN/* (RTM2CTL2 (RTM2ILP))*/
@RF00390 LR    @12,RBSECPTR                                        0392
         AL    @12,@CF03341                                        0392
         TM    PSWINLEN-61(@12),B'00000010'                        0392
         BNO   @RF00392                                            0392
*                         RTM2ILP(2)=ON;/*                           */
         OI    RTM2ILP(RTM2PTR),B'01000000'                        0393
*                       RTM2NXTP=PSWADD;/* NEXT INSTRUCTION ADDRESS  */
@RF00392 MVC   RTM2NXTP(3,RTM2PTR),PSWADD+16(RBSECPTR)             0394
*                     END;          /* END CONVERT LAST PRB          */
*                   RESPECIFY                                      0396
*                    (RBSECPTR) UNRESTRICTED;                      0396
@RF00380 DS    0H                                                  0397
*                 END;              /* END CNVRTPSW                  */
*                                                                  0397
*               /*****************************************************/
*               /*                                                   */
*               /* SEGMENT SDWARTM2 INITIALIZES THE SDWA(RTCA) WILL  */
*               /* DATA FROM THE RTM2 WORKAREA.                      */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0398
*               DO;                 /* BEGIN SDWARTM2                */
@RF00360 DS    0H                                                  0399
*                 SDWAMCH=RTM2EEDH;                                0399
         MVC   SDWAMCH(28,SDWAPTR),RTM2EEDH(RTM2PTR)               0399
*                 SDWACMPC=RTM2CC;  /* ABEND COMP CODE FOR EXIT RTN  */
         MVC   SDWACMPC(3,SDWAPTR),RTM2CC(RTM2PTR)                 0400
*                 SDWAAEC1=RTM2AEC1;/* ADDITIONAL PSW INFORMATION    */
         MVC   SDWAAEC1(8,SDWAPTR),RTM2AEC1(RTM2PTR)               0401
*                 SDWAEC1=RTM2EPSW; /* EC MODE PSW AT TIME OF ERROR  */
         MVC   SDWAEC1(8,SDWAPTR),RTM2EPSW(RTM2PTR)                0402
*                 SDWACTL2=RTM2CTL2;/* BC MODE PSW FROM LAST RB      */
         MVC   SDWACTL2(8,SDWAPTR),RTM2CTL2(RTM2PTR)               0403
*                 SDWAFMID=RTM2FMID;/* ASID OF MEMORY IN WHICH ERROR
*                                      OCCURRED                      */
         MVC   SDWAFMID(2,SDWAPTR),RTM2FMID(RTM2PTR)               0404
*                 SDWANAME=RTM2ABNM;/* NAME OF ABENDING PROGRAM      */
         MVC   SDWANAME(8,SDWAPTR),RTM2ABNM(RTM2PTR)               0405
*                 SDWAEPA=RTM2ABEP; /* EP ADDRESS OF ABENDING PROGRAM*/
         L     @12,RTM2ABEP(,RTM2PTR)                              0406
         ST    @12,SDWAEPA(,SDWAPTR)                               0406
*                 SDWAIOFS=RTM2IOFS;/* I/O STATUS AT TIME OF ERROR   */
         MVC   SDWAIOFS(1,SDWAPTR),RTM2IOFS(RTM2PTR)               0407
*                 SDWAFLGS=RTM2FLGS;/* INPUT FLAGS                   */
         MVC   SDWAFLGS(4,SDWAPTR),RTM2FLGS(RTM2PTR)               0408
*                 SDWACOMP=RTM2COMP;/* OPTIONAL USER WORD            */
         L     @12,RTM2COMP(,RTM2PTR)                              0409
         ST    @12,SDWACOMP(,SDWAPTR)                              0409
*                 IF SCBESTAE=OFF THEN/* STAE EXIT           @ZA05818*/
         TM    SCBESTAE(SCBPTR),B'00010000'                        0410
         BNZ   @RF00410                                            0410
*                   DO;             /* USE REGS AND PSW FROM LAST  0411
*                                      INTERRUPT OF TCB      @ZA05818*/
*                     RFY                                          0412
*                       RBSECPTR RSTD;/* RESTRICT REG TO LOCATE RB 0412
*                                                            @ZA05818*/
*                     RBSECPTR=RTM2VRBC;/* SET PTR TO RTM2'S RB    0413
*                                                            @ZA05818*/
         L     RBSECPTR,RTM2VRBC(,RTM2PTR)                         0413
*                     SDWAGRSV=RBGRSAVE;/* REGISTERS FROM CURRENT  0414
*                                      ABEND RB TASK MODE REGISTERS
*                                      BEFORE ABEND          @ZA05818*/
         MVC   SDWAGRSV(64,SDWAPTR),RBGRSAVE(RBSECPTR)             0414
*                     RBSECPTR=RBLINKB;/* UPDATE PTR TO PREVIOUS RB
*                                      TO TO FIND LAST TASK MODE PSW
*                                                            @ZA05818*/
         L     @12,RBLINKB-1(,RBSECPTR)                            0415
         LA    @12,0(,@12)                                         0415
         LR    RBSECPTR,@12                                        0415
*                     SDWAEC1=RBOPSW;/* LAST TASK MODE PSW   @ZA05818*/
         MVC   SDWAEC1(8,SDWAPTR),RBOPSW(RBSECPTR)                 0416
*                     SDWAILC1=RBINLNTH;/* EXTENDED PORTION  @ZA05818*/
         LR    @12,RBSECPTR                                        0417
         SL    @12,@CF00458                                        0417
         IC    @11,RBINLNTH(,@12)                                  0417
         STC   @11,SDWAILC1(,SDWAPTR)                              0417
*                     SDWAINC1=RBINTCOD;/*                   @ZA05818*/
         LH    @11,RBINTCOD(,@12)                                  0418
         N     @11,@CF03338                                        0418
         STH   @11,SDWAINC1(,SDWAPTR)                              0418
*                     SDWATRAN=RBRTRAN;/*                    @ZA05818*/
*                                                                  0419
         L     @12,RBRTRAN(,@12)                                   0419
         ST    @12,SDWATRAN(,SDWAPTR)                              0419
*                     /***********************************************/
*                     /*                                             */
*                     /* CONVERT THIS PSW TO BC MODE         @ZA05818*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0420
*                     IF PSWEXT=ON THEN/* ENABLED FOR EXTERNAL     0420
*                                                            @ZA05818*/
         TM    PSWEXT+16(RBSECPTR),B'00000001'                     0420
         BNO   @RF00420                                            0420
*                       SDWAEXTA=ON;/* ENABLED BC PSW        @ZA05818*/
         OI    SDWAEXTA(SDWAPTR),B'00000001'                       0421
*                     IF PSWIO=ON THEN/* ENABLED FOR I/O     @ZA05818*/
@RF00420 TM    PSWIO+16(RBSECPTR),B'00000010'                      0422
         BNO   @RF00422                                            0422
*                       SDWAIOA=ALLONE;/* ENABLED ALL CHANNELS     0423
*                                                            @ZA05818*/
         OI    SDWAIOA(SDWAPTR),B'11111110'                        0423
*                     SDWAMWPA=PSWMWP&'11110111'B;/* KEY AND MWP,  0424
*                                      CLEAR EC FLAG         @ZA05818*/
@RF00422 LA    @12,16                                              0424
         ALR   @12,RBSECPTR                                        0424
         MVC   SDWAMWPA(1,SDWAPTR),PSWMWP(@12)                     0424
         NI    SDWAMWPA(SDWAPTR),B'11110111'                       0424
*                     SDWAINTA=RBINTCOD;/* INTERRUPT CODE    @ZA05818*/
         LR    @11,RBSECPTR                                        0425
         SL    @11,@CF00458                                        0425
         MVC   SDWAINTA(2,SDWAPTR),RBINTCOD(@11)                   0425
*                     SDWAPMKA=PSWINT;/* PROGRAM MASK        @ZA05818*/
         MVC   SDWAPMKA(1,SDWAPTR),PSWINT(@12)                     0426
*                     IF PSWINLEN(6)=ON THEN/* LENGTH > 4    @ZA05818*/
         TM    PSWINLEN(@11),B'00000100'                           0427
         BNO   @RF00427                                            0427
*                       SDWAILA(1)=ON;/* INDICATE LENGTH     @ZA05818*/
         OI    SDWAILA(SDWAPTR),B'10000000'                        0428
*                     IF PSWINLEN(7)=ON THEN/* LENGTH = 2 OR 6     0429
*                                                            @ZA05818*/
@RF00427 LR    @12,RBSECPTR                                        0429
         AL    @12,@CF03341                                        0429
         TM    PSWINLEN-61(@12),B'00000010'                        0429
         BNO   @RF00429                                            0429
*                       SDWAILA(2)=ON;/*                     @ZA05818*/
         OI    SDWAILA(SDWAPTR),B'01000000'                        0430
*                     SDWANXTA=PSWADD;/* INSTRUCTION ADDRESS @ZA05818*/
@RF00429 MVC   SDWANXTA(3,SDWAPTR),PSWADD+16(RBSECPTR)             0431
*                     RFY                                          0432
*                       RBSECPTR UNRSTD;/* RELEASE REGISTER  @ZA05818*/
*                   END;            /* END STAE PROCESSING   @ZA05818*/
*                 ELSE              /*                       @ZA05818*/
*                   DO;             /* ESTA                  @ZA05818*/
         B     @RC00410                                            0434
@RF00410 DS    0H                                                  0435
*                     SDWAGRSV=RTM2EREG;/* REGS AT TIME OF ERROR   0435
*                                                            @ZA05818*/
         MVC   SDWAGRSV(64,SDWAPTR),RTM2EREG(RTM2PTR)              0435
*                     SDWACTL1=RTM2CTL1;/* BC MODE PSW AT TIME OF  0436
*                                      ERROR                 @ZA05818*/
         MVC   SDWACTL1(8,SDWAPTR),RTM2CTL1(RTM2PTR)               0436
*                   END;            /* END ESTA PROCESSING   @ZA05818*/
*                 SDWAASID=RTM2ASC->ASCBASID;/* ASID INTO SDWA FOR 0438
*                                      LOGREC DEBUGGING      @ZA05516*/
@RC00410 L     @12,RTM2ASC(,RTM2PTR)                               0438
         MVC   SDWAASID(2,SDWAPTR),ASCBASID(@12)                   0438
*               END;                /* END SDWARTM2                  */
*               SDWARECA=ADDR(SDWARA);/* PTR TO VARIABLE RECORDING   */
         LA    @12,SDWARA(,SDWAPTR)                                0440
         ST    @12,SDWARECA(,SDWAPTR)                              0440
*               SDWAVRAL=LENGTH(SDWAVRA);/* CALCULATE LENGTH OF    0441
*                                      VARIABLE AREA                 */
         MVC   SDWAVRAL(2,SDWAPTR),@CH00958                        0441
*               SDWADPLA=ADDR(SDWASNPA);/* INIT PTR TO DUMP PARM LIST*/
         LA    @12,SDWASNPA(,SDWAPTR)                              0442
         ST    @12,SDWADPLA(,SDWAPTR)                              0442
*               RTM2BFTL=ON;        /* TURN ON FIRST TIME LOGIC FLAG */
         OI    RTM2BFTL(RTM2PTR),B'00001000'                       0443
*             END;                  /* END SDWA INITIALIZATION       */
*         END;                      /* END SDWAINIT                  */
*                                                                  0445
@RF00329 DS    0H                                                  0446
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT USEROPTS WILL PERFORM USER REQUESTS AS INDICATED*/
*         /* ON THE (E)STAE MACRO. IT FIRST DETERMINES WHETHER TO    */
*         /* ALLOW ASYNCHRONOUS EXITS. NEXT IT DETERMINES IF THERE   */
*         /* ARE ANY OPEN DATA SETS ON WHICH TO PERFORM I/O OPTIONS. */
*         /* IF THERE ARE NO OPEN DATA SETS I/O PROCESSING IS        */
*         /* BYPASSED. NEXT IF THE CURRENT SCB IS AN ESTAR SCB THEN  */
*         /* SEGMENT ESTRPROC IS INCLUDED TO PERFORM ESTAR           */
*         /* PROCESSING. IF THIS IS A PERCOLATED TO SCB, RTM2IOFS IS */
*         /* NOT ZERO AND I/O PROCESSING IS BYPASSED SINCE ONLY THE  */
*         /* I/O OPTIONS OF THE FIRST EXIT TO GAIN CONTROL ARE VALID.*/
*         /* A RECURSION ENVIRONMENT IS ESTABLISHED AND THE USER I/O */
*         /* OPTION IS PERFORMED.                                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0446
*         DO;                       /* BEGIN USEROPTS                */
*           RESPECIFY                                              0447
*            (TCBPTR) RESTRICTED;                                  0447
*           TCBPTR=RTM2TCBC;        /* INITIALIZE CURRENT TCB        */
         L     TCBPTR,RTM2TCBC(,RTM2PTR)                           0448
*           IF SCBASYNC=OFF THEN    /* TEST USER ASYNCHRONOUS EXIT 0449
*                                      OPTION REQUEST                */
         TM    SCBASYNC(SCBPTR),B'00000100'                        0449
         BNZ   @RF00449                                            0449
*             TCBFX=ON;             /* PROHIBIT ASYNCHRONOUS EXITS   */
         OI    TCBFX(TCBPTR),B'00000001'                           0450
*           ELSE                                                   0451
*             TCBFX=OFF;            /* ALLOW ASYNCHRONOUS EXITS      */
         B     @RC00449                                            0451
@RF00449 NI    TCBFX(TCBPTR),B'11111110'                           0451
*           IF RTM2TRME=ON THEN     /* IN TERM PORCESSING IO HAS BEEN
*                                      PREVIOUSLY HALTED             */
@RC00449 TM    RTM2TRME(RTM2PTR),B'10000000'                       0452
         BNO   @RF00452                                            0452
*             DO;                   /* TERM PROCESSING               */
*               RTM2IOFS=BYTE0;     /* ZERO IO FLAG BYTE             */
         MVI   RTM2IOFS(RTM2PTR),X'00'                             0454
*               RTM2FIOB=FOX;       /* INDICATE HALT                 */
         MVC   RTM2FIOB(3,RTM2PTR),@CF00087+1                      0455
*               RTM2IOHT=ON;        /* INDICATE HALT                 */
         OI    RTM2IOHT(RTM2PTR),B'01000000'                       0456
*             END;                                                 0457
*           IF SCBSTAR=ON THEN      /* TEST IF ESTAR EXIT            */
*                                                                  0458
@RF00452 TM    SCBSTAR(SCBPTR),B'01000000'                         0458
         BNO   @RF00458                                            0458
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT ESTRPROC HANDLES I/O PROCESSING FOR ESTAR   */
*             /* EXITS. A RECURSION ENVIRONMENT IS ESTABLISHED BEFORE*/
*             /* CALLING IEAPTERM TO PURGE PAGE IN. A TEST IS MADE TO*/
*             /* DETERMINE WHETHER I/O HAS BEEN PREVIOUSLY QUIESCED. */
*             /* IF IT HAS BEEN, A RECURSION ENVIRONMENT IS AGAIN    */
*             /* ESTABLISHED AND SVC 17 IS ISSUED TO RESTORE THE     */
*             /* RESTORABLE I/O. THE FIRST TIME LOGIC INDICATOR IS   */
*             /* THEN ZEROED SO THAT ON RETURN TO SEGMENT USEROPTS   */
*             /* HALT I/O (SVC 16) WILL BE PERFORMED.                */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0459
*             IF RTM2PPR=OFF THEN   /* IF NOT A PURGE PAGE-IN      0459
*                                      RECURSION CONTINUE WITH PURGE,
*                                      NO NEED TO TEST I/O         0459
*                                      RECURSION,A LATER TEST WILL 0459
*                                      PREVENT A RESTORE     @ZA01940*/
         TM    RTM2PPR(RTM2PTR),B'01000000'                        0459
         BNZ   @RF00459                                            0459
*               DO;                 /* BEGIN ESTRPROC                */
*                 RESPECIFY                                        0461
*                   R1 RESTRICTED;                                 0461
*                 R1=ADDR(RTM2RMPS);/* ADDRESS OF RESOURCE MANAGER 0462
*                                      PARAMETER LIST                */
         LA    R1,RTM2RMPS(,RTM2PTR)                               0462
*                 R13=ADDR(RTM2RMSA);/* ADDRESS OF RESOURCE MANAGER
*                                      SAVE AREA                     */
         LA    R13,RTM2RMSA(,RTM2PTR)                              0463
*                 RMPLIPUF=ON;      /* INHIBIT PAGE UNFIXES          */
*                 RMPLRCOV=ON;      /* INDICATES TASK RECOVERY IS  0465
*                                      CALLER                        */
         LA    @12,712                                             0465
         ALR   @12,RTM2PTR                                         0465
         OI    RMPLIPUF(@12),B'00011000'                           0465
*                 RMPLTCBA=RTM2TCBC;/* ADDRESS OF CURRENT TCB        */
         L     @11,RTM2TCBC(,RTM2PTR)                              0466
         ST    @11,RMPLTCBA(,@12)                                  0466
*                 IF RTM2TCBC->TCBJSTCA=RTM2TCBC THEN/* DETERMINE IF
*                                      THIS IS A JOBSTEP TCB         */
         L     @06,TCBJSTCA-1(,@11)                                0467
         LA    @06,0(,@06)                                         0467
         CR    @11,@06                                             0467
         BNE   @RF00467                                            0467
*                   RMPLJST=ON;     /* INDICATE JOBSTEP TCB          */
         OI    RMPLJST(@12),B'00000100'                            0468
*                 ELSE              /* NOT JOBSTEP TCB               */
*                   RMPLJST=OFF;    /* INDICATE NOT JOBSTEP TCB      */
         B     @RC00467                                            0469
@RF00467 NI    RMPLJST+712(RTM2PTR),B'11111011'                    0469
*                 RTM2PPS=ON;       /* RESOURCE MANAGER RECURSION  0470
*                                      FLAG                          */
@RC00467 OI    RTM2PPS(RTM2PTR),B'00001000'                        0470
*                 GEN(STM  0,15,RTM2RREG(RTM2PTR));                0471
         STM  0,15,RTM2RREG(RTM2PTR)
*                 RTM2TRRA=ADDR(RECURSE);/* ADDRESS OF RECURSION   0472
*                                      HANDLRE                       */
         LA    @12,RECURSE                                         0472
         ST    @12,RTM2TRRA(,RTM2PTR)                              0472
*                 CALL IEAPTERM;    /* PURGE PAGE-IN                 */
         L     @12,CVTPTR                                          0473
         L     @12,SCVTSPTR(,@12)                                  0473
         L     @15,SCVTPTRM(,@12)                                  0473
         BALR  @14,@15                                             0473
*PAGERET:                                                          0474
*                 RESPECIFY                                        0474
*                   R1 UNRESTRICTED;                               0474
PAGERET  DS    0H                                                  0475
*                 RTM2TRRA=ZERO;    /* ZERO RECURSION ADDRESS        */
         SLR   @12,@12                                             0475
         ST    @12,RTM2TRRA(,RTM2PTR)                              0475
*                 RTM2PPS=OFF;      /* TURN OFF RESOURCE MANAGER   0476
*                                      RECURSION FLAG                */
         NI    RTM2PPS(RTM2PTR),B'11110111'                        0476
*                 RMPLIPUF=OFF;     /* RESET FLAG                    */
*                 RMPLRCOV=OFF;     /* RESET FLAG                    */
         NI    RMPLIPUF+712(RTM2PTR),B'11100111'                   0478
*                 IF RTM2IOQR=ON THEN/* TEST IF I/O PREVIOUSLY     0479
*                                      QUIESCED                      */
         TM    RTM2IOQR(RTM2PTR),B'10000000'                       0479
         BNO   @RF00479                                            0479
*                   DO;             /* I/O PREVIOUSLY QUIESCED, IT 0480
*                                      MUST NOW BE RESTORED          */
*                     IF RTM2FIOB^=FOX THEN/* TEST IF ANY RESTORABLE
*                                      I/O                           */
         CLC   RTM2FIOB(3,RTM2PTR),@CF00087+1                      0481
         BE    @RF00481                                            0481
*                       DO;         /* RESTORABLE I/O                */
*                         RESPECIFY                                0483
*                          (R1) RESTRICTED;                        0483
*                         R1=ADDR(RTM2IOBP);/* POINTER TO PURGED I/O
*                                      REQUEST LIST          @YM07293*/
         LA    R1,RTM2IOBP(,RTM2PTR)                               0484
*                         RTM2IORS=ON;/* SVC 17 RECURSION FLAG       */
         OI    RTM2IORS(RTM2PTR),B'00100000'                       0485
*                         RTM2TRRA=ADDR(RECURSE);/* ADDRESS OF     0486
*                                      RECURSION HANDLER             */
         LA    @12,RECURSE                                         0486
         ST    @12,RTM2TRRA(,RTM2PTR)                              0486
*                         GENERATE;                                0487
         STM   0,15,RTM2RREG(RTM2PTR)
         SVC   17
*RSTORET:                                                          0488
*                         RTM2TRRA=ZERO;/* ZERO RECURSION ADDRESS    */
RSTORET  SLR   @12,@12                                             0488
         ST    @12,RTM2TRRA(,RTM2PTR)                              0488
*                         RTM2IORS=OFF;/* ZERO SVC 17 RECURSION FLAG */
         NI    RTM2IORS(RTM2PTR),B'11011111'                       0489
*                         RTM2FIOB=FOX;/* INDICATE NO RESTORABLE I/O */
         MVC   RTM2FIOB(3,RTM2PTR),@CF00087+1                      0490
*                         RESPECIFY                                0491
*                          (R1) UNRESTRICTED;                      0491
*                       END;        /* END RESTORE PROCESSING        */
*                   END;            /* END OF QUIESCED I/O PROCESSING*/
@RF00481 DS    0H                                                  0494
*                 RTM2IOFS=BYTE0;   /* ZERO I/O PROCESSING FLAG BYTE
*                                      SO THAT I/O WILL BE HALTED ON
*                                      RETURN TO SEGMENT USEROPTS    */
@RF00479 MVI   RTM2IOFS(RTM2PTR),X'00'                             0494
*               END;                /* END ESTRPROC                  */
*           IF RTM2IOFS=BYTE0 THEN  /* TEST FOR FIRST TIME LOGIC     */
@RF00459 DS    0H                                                  0496
@RF00458 CLI   RTM2IOFS(RTM2PTR),0                                 0496
         BNE   @RF00496                                            0496
*             DO;                   /* FIRST TIME LOGIC OR ESTAR   0497
*                                      PROCESSING                    */
*               IF SCBNOIOP=OFF&RTM2IOR=OFF THEN/* TEST FOR NO I/O 0498
*                                      PROCESSING AND NO PREVIOUS I/O
*                                      RECURSION             @YM04163*/
*                                                                  0498
         TM    SCBNOIOP(SCBPTR),B'00000010'                        0498
         BNZ   @RF00498                                            0498
         TM    RTM2IOR(RTM2PTR),B'10000000'                        0498
         BNZ   @RF00498                                            0498
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT IOPURGE WILL SET UP THE PARAMETER LIST  */
*                 /* FOR SVC PURGE AND THEN ISSUE THE SVC, SPECIFYING*/
*                 /* EITHER QUIESCE OR HALT. IF SVC PURGE IS UNABLE  */
*                 /* TO QUIESCE I/O, HALT I/O WILL BE ATTEMPTED.     */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0499
*                 DO;               /* BEGIN IOPURGE                 */
*                   RESPECIFY                                      0500
*                    (PPLPTR) RESTRICTED;                          0500
*                   PPLPTR=RMPLRMWA;/* PARAMETER LIST ADDRESS        */
         L     PPLPTR,RMPLRMWA+712(,RTM2PTR)                       0501
*                   RTM2RMWA=''B;   /* ZERO PARAMETER LIST           */
         XC    RTM2RMWA(64,RTM2PTR),RTM2RMWA(RTM2PTR)              0502
*                   PPLPOST=ON;     /* POST ECB-S WITH X'48000000'   */
*                   PPLTASK=ON;     /* PURGE I/O FOR A SINGLE TCB    */
*                   PPLEXR=ON;                                     0505
         OI    PPLPOST(PPLPTR),B'01000011'                         0505
*                   PPLTCB=RTM2TCBC;/* TCB ASSOCIATED WITH I/O TO BE
*                                      PROCESSED.                    */
         L     @12,RTM2TCBC(,RTM2PTR)                              0506
         ST    @12,PPLTCB(,PPLPTR)                                 0506
*                   PPLPIRL=ADDR(RTM2IOBP);/* ADDRESS OF ANCHOR WORD */
         LA    @12,RTM2IOBP(,RTM2PTR)                              0507
         ST    @12,PPLPIRL(,PPLPTR)                                0507
*                   PPLOTCB=ON;     /* PURGE I/O SO THAT IT CAN BE 0508
*                                      RESTORED ASSOCIATED WITH THE
*                                      ORIGINATING TCB               */
         OI    PPLOTCB(PPLPTR),B'00001000'                         0508
*                   IF SCBHALT^=ON THEN/* TEST IF HALT OR QUIESCE    */
         TM    SCBHALT(SCBPTR),B'00000001'                         0509
         BO    @RF00509                                            0509
*                     DO;           /* QUIESCE REQUESTED             */
*                       RTM2IOQS=ON;/* QUIESCE SECTION FLAG          */
         OI    RTM2IOQS(RTM2PTR),B'10000000'                       0511
*                       GEN(STM 0,15,RTM2RREG(RTM2PTR));           0512
         STM 0,15,RTM2RREG(RTM2PTR)
*                       RTM2TRRA=ADDR(RECURSE);/* RECURSION ADDRESS  */
         LA    @12,RECURSE                                         0513
         ST    @12,RTM2TRRA(,RTM2PTR)                              0513
*                       RESPECIFY                                  0514
*                        (R15) RESTRICTED;                         0514
*                       SVC(16);                                   0515
         SVC   16                                                  0515
*QIESADDR:                                                         0516
*                       RTM2TRRA=ZERO;/* ZERO RECURSION ADDRESS      */
QIESADDR SLR   @14,@14                                             0516
         ST    @14,RTM2TRRA(,RTM2PTR)                              0516
*                       RTM2IOQS=OFF;/* TURN OFF QUIESCE SECTION FLAG*/
         NI    RTM2IOQS(RTM2PTR),B'01111111'                       0517
*                       IF R15=ZERO THEN/* TEST IF QUIESCE SUCCESSFUL*/
         CR    R15,@14                                             0518
         BNE   @RF00518                                            0518
*                         IF RTM2FIOB^=FOX THEN/* TEST IF THERE WAS
*                                      I/O TO QUIESCE                */
         CLC   RTM2FIOB(3,RTM2PTR),@CF00087+1                      0519
         BE    @RF00519                                            0519
*                           RTM2IOQR=ON;/* INDICATE I/O QUIESCED     */
         OI    RTM2IOQR(RTM2PTR),B'10000000'                       0520
*                         ELSE                                     0521
*                           RTM2NOIO=ON;/* NO I/O TO QUIESCE         */
         B     @RC00519                                            0521
@RF00519 OI    RTM2NOIO(RTM2PTR),B'00100000'                       0521
*                       RESPECIFY                                  0522
*                        (R15) UNRESTRICTED;                       0522
@RC00519 DS    0H                                                  0522
@RF00518 DS    0H                                                  0523
*                     END;          /* END QUIESCE PROCESSING        */
*                   IF RTM2IOQR=OFF&RTM2NOIO=OFF THEN/* TEST IF    0524
*                                      QUIESCE NOT PERFORMED, (EITHER
*                                      UNSUCCESSFUL OR NOT REQUESTED)*/
@RF00509 TM    RTM2IOQR(RTM2PTR),B'10100000'                       0524
         BNZ   @RF00524                                            0524
*                     DO;           /* HALT PROCESSING               */
*                       PPLPTR=RMPLRMWA;/* PARAMETER LIST ADDRESS    */
         L     PPLPTR,RMPLRMWA+712(,RTM2PTR)                       0526
*                       PPLHIO=ON;  /* INDICATE HALT I/O             */
         OI    PPLHIO(PPLPTR),B'00100000'                          0527
*                       RTM2FIOB=FOX;/* PUT HALT INDICATOR IN ANCHOR
*                                      WORD                          */
         MVC   RTM2FIOB(3,RTM2PTR),@CF00087+1                      0528
*                       RTM2IOHS=ON;/* HALT SECTION FLAG             */
         OI    RTM2IOHS(RTM2PTR),B'01000000'                       0529
*                       GEN(STM 0,15,RTM2RREG(RTM2PTR));           0530
         STM 0,15,RTM2RREG(RTM2PTR)
*                       RTM2TRRA=ADDR(RECURSE);/* RECURSION ADDRESS  */
         LA    @12,RECURSE                                         0531
         ST    @12,RTM2TRRA(,RTM2PTR)                              0531
*                       RESPECIFY                                  0532
*                        (R15) RESTRICTED;                         0532
*                       SVC(16);                                   0533
         SVC   16                                                  0533
*HALTADDR:                                                         0534
*                       RTM2TRRA=ZERO;/* ZERO RECURSION ADDRESS      */
HALTADDR SLR   @14,@14                                             0534
         ST    @14,RTM2TRRA(,RTM2PTR)                              0534
*                       RTM2IOHS=OFF;/* TURN OFF HALT SECTION FLAG   */
         NI    RTM2IOHS(RTM2PTR),B'10111111'                       0535
*                       RTM2IOHT=ON;/* INDICATE I/O HALTED           */
         OI    RTM2IOHT(RTM2PTR),B'01000000'                       0536
*                       RESPECIFY                                  0537
*                        (R15) UNRESTRICTED;                       0537
*                     END;          /* END HALT I/O PROCESSING       */
*                   RESPECIFY                                      0539
*                    (PPLPTR) UNRESTRICTED;                        0539
@RF00524 DS    0H                                                  0540
*                 END;              /* END IOPURGE                   */
*               ELSE                /* NO I/O PROCESSING REQUESTED   */
*                 RTM2NIOP=ON;      /* INDICATE NO I/O PROCESSING    */
         B     @RC00498                                            0541
@RF00498 OI    RTM2NIOP(RTM2PTR),B'00010000'                       0541
*             END;                                                 0542
@RC00498 DS    0H                                                  0543
*           IF SDWAPTR^=0 THEN                                     0543
@RF00496 LTR   SDWAPTR,SDWAPTR                                     0543
         BZ    @RF00543                                            0543
*             SDWAIOFS=RTM2IOFS;    /* PUT IO INDICATION IN SDWA     */
         MVC   SDWAIOFS(1,SDWAPTR),RTM2IOFS(RTM2PTR)               0544
*           RESPECIFY                                              0545
*            (TCBPTR) UNRESTRICTED;                                0545
@RF00543 DS    0H                                                  0546
*         END;                      /* END USEROPTS                  */
*                                                                  0546
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT EXITINTR WILL SET UP THE INTERFACE TO THE USER  */
*         /* EXIT ROUTINE. IT FIRST INITIALIZES THE PARAMETER        */
*         /* REGISTERS FOR THE EXIT AND THEN STORES ITS OWN REGISTERS*/
*         /* IN THE RTM2 WORKAREA. SEGMENT PRESYNCH IS INCLUDED TO   */
*         /* SET UP THE IEAVTAS1-SYNCH INTERFACE. FINALLY, SYNCH     */
*         /* MACRO IS ISSUED TO GIVE THE USER EXIT CONTROL.          */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0547
*         DO;                       /* BEGIN EXITINTR                */
*           RESPECIFY                                              0548
*            (R0,                                                  0548
*             R1,                                                  0548
*             R2) RESTRICTED;                                      0548
*           IF RTM2WANA^=ON THEN    /* TEST IF SDWA(RTCA) AVAILABLE  */
         TM    RTM2WANA(RTM2PTR),B'00100000'                       0549
         BO    @RF00549                                            0549
*             DO;                                                  0550
*               IF RTM2IOQR=ON THEN /* IF I/O WAS QUIESCED ...       */
         TM    RTM2IOQR(RTM2PTR),B'10000000'                       0551
         BNO   @RF00551                                            0551
*                 R0=CODE0;         /* REGISTER 0 = 0                */
         SLR   R0,R0                                               0552
*               ELSE                                               0553
*                 IF RTM2IOHT=ON THEN/* IF I/O WAS HALTED ...        */
         B     @RC00551                                            0553
@RF00551 TM    RTM2IOHT(RTM2PTR),B'01000000'                       0553
         BNO   @RF00553                                            0553
*                   R0=CODE4;       /* REGISTER 0 = 4                */
         LA    R0,4                                                0554
*                 ELSE                                             0555
*                   IF RTM2NOIO=ON THEN/* IF NO ACTIVE I/O ...       */
         B     @RC00553                                            0555
@RF00553 TM    RTM2NOIO(RTM2PTR),B'00100000'                       0555
         BNO   @RF00555                                            0555
*                     R0=CODE8;     /* REGISTER 0 = 8                */
         LA    R0,8                                                0556
*                   ELSE            /* IF NONE OF THE AVOVE THEN NO
*                                      I/O PROCESSING PERFORMED      */
*                     R0=CODE16;    /* REGISTER 0 = 16               */
         B     @RC00555                                            0557
@RF00555 LA    R0,16                                               0557
*               R1=RTM2RTCA;        /* ADDRESS OF SDWA(RTCA)         */
@RC00555 DS    0H                                                  0558
@RC00553 DS    0H                                                  0558
@RC00551 L     @12,RTM2RTCA(,RTM2PTR)                              0558
         LR    R1,@12                                              0558
*               R13=RTM2RTCA+LENGTH(SDWA);/* USER EXIT SAVE AREA     */
         AL    @12,@CF03281                                        0559
         LR    R13,@12                                             0559
*             END;                                                 0560
*           ELSE                    /* IF SDWA(RTCA) NOT AVAILABLE   */
*             DO;                                                  0561
         B     @RC00549                                            0561
@RF00549 DS    0H                                                  0562
*               R0=CODE12;          /* INDICATE SDWA NOT AVAILABLE TO
*                                      FOR USER EXIT                 */
         LA    R0,12                                               0562
*               R1=RTM2CC;          /* ABEND COMPLETION CODE         */
         L     R1,RTM2CC-1(,RTM2PTR)                               0563
         LA    R1,0(,R1)                                           0563
*               R2=SCBPARM;         /* ADDRESS OF USER PARAMETER LIST*/
         L     R2,SCBPARM(,SCBPTR)                                 0564
*               R13=SCBEXIT;        /* NO SAVE AREA FOR USER,      0565
*                                      INITIALIZE WITH USER EXIT ADDR*/
         L     R13,SCBEXIT(,SCBPTR)                                0565
*             END;                                                 0566
*                                                                  0566
*           /*********************************************************/
*           /*                                                       */
*           /* SEGMENT PRESYNCH WILL SET UP THE INTERFACE FOR THE    */
*           /* SYNCH MACRO IN THE TCB. IT WILL ALSO INDICATE IN THE  */
*           /* RTM2 WORKAREA THAT AN EXIT IS IN PROGRESS AND MARK THE*/
*           /* CURRENT SCB IN USE.                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0567
*           DO;                     /* BEGIN PRESYNCH                */
@RC00549 DS    0H                                                  0568
*             RESPECIFY                                            0568
*              (TCBPTR) RESTRICTED;                                0568
*             TCBPTR=RTM2TCBC;      /* INITIALIZE CURRENT TCB        */
         L     TCBPTR,RTM2TCBC(,RTM2PTR)                           0569
*             RTM2XIP=ON;           /* INDICATE EXIT IN PROGRESS     */
*             RTM2XFLG=ON;          /* EXIT SECTION FLAG FOR       0571
*                                      RECURSION                     */
         OI    RTM2XIP(RTM2PTR),B'00101000'                        0571
*             IF SCBESTAE=OFF THEN  /* TEST IF STAE EXIT     @YM01804*/
         TM    SCBESTAE(SCBPTR),B'00010000'                        0572
         BNZ   @RF00572                                            0572
*               TCBSTABE=ON;        /* INDICATE STAE EXIT    @YM01804*/
         OI    TCBSTABE(TCBPTR),B'10000000'                        0573
*             IF SCBSTAR^=ON THEN   /* IF ESTAR, DO NOT SET INUSE    */
@RF00572 TM    SCBSTAR(SCBPTR),B'01000000'                         0574
         BO    @RF00574                                            0574
*               SCBINUSE=ON;        /* MARK CURRENT SCB IN USE       */
         OI    SCBINUSE(SCBPTR),B'00010000'                        0575
*             GEN(STM 0,15,RTM2RREG(RTM2PTR));                     0576
@RF00574 DS    0H                                                  0576
         STM 0,15,RTM2RREG(RTM2PTR)
*             TCBSYNCH=ON;          /* INDICATE TO SYNCH THAT TASK 0577
*                                      RECOVERY IS CALLER            */
         OI    TCBSYNCH(TCBPTR),B'00000100'                        0577
*             IF SCBSUPER=ON THEN   /* TEST IF SUPERVISOR MODE       */
         TM    SCBSUPER(SCBPTR),B'00000001'                        0578
         BNO   @RF00578                                            0578
*               TCBPPSUP=ON;        /* INDICATE SUPERVISOR MODE IN 0579
*                                      TCB                           */
         OI    TCBPPSUP(TCBPTR),B'00010000'                        0579
*             ELSE                                                 0580
*               TCBPPSUP=OFF;       /* INDICATE PP MODE IN TCB       */
         B     @RC00578                                            0580
@RF00578 NI    TCBPPSUP(TCBPTR),B'11101111'                        0580
*             IF SCBPKEY<KEY8 THEN  /* TEST FOR KEY 0 - 7            */
@RC00578 CLI   SCBPKEY(SCBPTR),X'80'                               0581
         BNL   @RF00581                                            0581
*               TCBSCBKY=SUPERKEY;  /* PUT KEY 0 IN TCB              */
         MVI   TCBSCBKY(TCBPTR),X'00'                              0582
*             ELSE                  /* KEY 8 - 15                    */
*               TCBSCBKY=SCBPKEY;   /* PUT KEY IN TCB                */
         B     @RC00581                                            0583
@RF00581 MVC   TCBSCBKY(1,TCBPTR),SCBPKEY(SCBPTR)                  0583
*             RESPECIFY                                            0584
*              (TCBPTR) UNRESTRICTED;                              0584
@RC00581 DS    0H                                                  0585
*             RTM2TRRA=ADDR(RECURSE);/* ADDRESS OF POST EXIT       0585
*                                      PROCESSING ROUTINE            */
         LA    @12,RECURSE                                         0585
         ST    @12,RTM2TRRA(,RTM2PTR)                              0585
*           END;                                                   0586
*           RESPECIFY                                              0587
*            (R14,                                                 0587
*             R15) RESTRICTED;                                     0587
*           R15=SCBEXIT;            /* USER EXIT ROUTINE ADDRESS     */
         L     R15,SCBEXIT(,SCBPTR)                                0588
*           GENERATE;                                              0589
         SYNCH (15)
*           RESPECIFY                                              0590
*            (R2,                                                  0590
*             R14) UNRESTRICTED;                                   0590
*                                                                  0590
*           /*********************************************************/
*           /*                                                       */
*           /* POSTYNC LOCATES THE CURRENT RTM2WA BY STARTING FROM   */
*           /* THE PSA BECAUSE THE REGISTERS MAY HAVE BEEN DESTROYED */
*           /* BY THE USER'S EXIT. IT THEN CLEARS THE RECURSION      */
*           /* ENVIRONMENT AND SAVES THE VOLATILE REGISTERS RETURNED */
*           /* FROM THE EXIT IN THE WORKAREA                         */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0591
*           DO;                     /* BEGIN SEGMENT POSTSYNC        */
*             GENERATE REFS(FLCCVT,CVTTCBP,TCBRTWA,RTM2PTR,RTM2RREG);
         L     I,FLCCVT-PSA        ACCESS CVT POINTER
         L     I,CVTTCBP(,I)       TCB DOUBLE WORD
         L     I,4(I)              CURRENT TCB
         L     RTM2PTR,TCBRTWA(,I) CURRENT RTM2WA
         LM    1,13,RTM2RREG+4(RTM2PTR) RESTORE REGISTERS TO PRE-SYNCH
*             RTM2TRRA=ZERO;        /* CLEAR RECURSION ENVIRONMENT   */
         SLR   @14,@14                                             0593
         ST    @14,RTM2TRRA(,RTM2PTR)                              0593
*             RTM2XIP=OFF;                                         0594
         NI    RTM2XIP(RTM2PTR),B'11011111'                        0594
*             RTM2TCBC->TCBSTABE=OFF;                              0595
         L     @14,RTM2TCBC(,RTM2PTR)                              0595
         NI    TCBSTABE(@14),B'01111111'                           0595
*             RTM2RCDE=R15;         /* SAVE REGISTER 15 WHICH MAY  0596
*                                      CONTAIN ACTION CODE           */
         STC   R15,RTM2RCDE(,RTM2PTR)                              0596
*             RTM2RTYA=R0;          /* SAVE REGISTER 0 WHICH MAY   0597
*                                      CONTAIN RETRY ADDRESS         */
         ST    R0,RTM2RTYA(,RTM2PTR)                               0597
*             IF SCBSTAR=ON&RTM2WANA=ON THEN                       0598
         TM    SCBSTAR(SCBPTR),B'01000000'                         0598
         BNO   @RF00598                                            0598
         TM    RTM2WANA(RTM2PTR),B'00100000'                       0598
         BNO   @RF00598                                            0598
*               IF RTM2RCDE=SDWACWT THEN                           0599
         CLI   RTM2RCDE(RTM2PTR),0                                 0599
         BNE   @RF00599                                            0599
*                 SCBINUSE=ON;      /* MARK ESTAR SCB INUSE          */
         OI    SCBINUSE(SCBPTR),B'00010000'                        0600
*           END;                    /* END OF POSTSYNCH              */
@RF00599 DS    0H                                                  0601
@RF00598 DS    0H                                                  0602
*           RESPECIFY                                              0602
*            (R0,                                                  0602
*             R1,                                                  0602
*             R15) UNRESTRICTED;                                   0602
*         END;                      /* END EXITINTR                  */
*CALLAS2:                                                          0604
*         GEN(STM 0,15,RTM2RREG(RTM2PTR));                         0604
CALLAS2  STM 0,15,RTM2RREG(RTM2PTR)
*         R13=ADDR(RTM2TRSA);       /* SET UP SAVE AREA - REGISTERS
*                                      CONTAINING POINTERS TO THE  0605
*                                      RTM2 WORKAREA, SDWA AND SCB 0605
*                                      ARE GLOBALLY RESTRICTED       */
         LA    R13,RTM2TRSA(,RTM2PTR)                              0605
*         CALL IEAVTAS2;            /* PERFORM RECOVERY REQUESTS     */
         L     @15,@CV03293                                        0606
         BALR  @14,@15                                             0606
*CALLAS3:                                                          0607
*         GEN(STM 0,15,RTM2RREG(RTM2PTR));                         0607
CALLAS3  STM 0,15,RTM2RREG(RTM2PTR)
*         R13=ADDR(RTM2TRSA);       /* SET UP SAVE AREA - REGISTERS
*                                      CONTAINING POINTERS TO THE  0608
*                                      RTM2 WORKAREA, SDWA AND SCB 0608
*                                      ARE GLOBALLY RESTRICTED       */
         LA    R13,RTM2TRSA(,RTM2PTR)                              0608
*         CALL IEAVTAS3;            /* CONTROL RECOVERY              */
         L     @15,@CV03262                                        0609
         BALR  @14,@15                                             0609
*       END;                                                       0610
*     ELSE                                                         0611
*       RTM2RETR=OFF;               /* INDICATE NO RETRY             */
         B     @RC00146                                            0611
@RF00146 NI    RTM2RETR(RTM2PTR),B'10111111'                       0611
*   END;                                                           0612
@RC00146 DS    0H                                                  0612
@DE00108 TM    RTM2RETR(RTM2PTR),B'01000000'                       0612
         BNZ   @DC00108                                            0612
         L     @12,RTM2SCBC(,RTM2PTR)                              0612
         LTR   @12,@12                                             0612
         BNZ   @DL00108                                            0612
@DC00108 DS    0H                                                  0613
*   IF RTM2RETR=OFF&(RTM2IOR=ON|RTM2PPR=ON|RTM2GMR=ON) THEN/* TEST 0613
*                                      RETRY OR RECURSION    @ZA02950*/
         TM    RTM2RETR(RTM2PTR),B'01000000'                       0613
         BNZ   @RF00613                                            0613
         TM    RTM2IOR(RTM2PTR),B'11100000'                        0613
         BZ    @RF00613                                            0613
*     DO;                           /* RECURSION PROCESSING FOR AS1  */
*                                                                  0614
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SEGMENT GETS CONTROL AS A RESULT OF A RECURSION IN   */
*       /* IEAVTAS1. PRIOR TO GETTING CONTROL (E)STAE EXITS FOR THE  */
*       /* FAILING FUNCTIONS HAVE HAD THE OPPORTUNITY TO CLEAN UP OR */
*       /* RETRY. THIS SEGMENT DETERMINES IN WHICH SECTION OF AS1 THE*/
*       /* RECURSION OCCURRED AND SETS UP FOR RETRY AT THE NEXT      */
*       /* SEQUENTIAL INSTRUCTION.                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0615
*       DO;                         /* BEGIN RECURSE1                */
*         IF RTM2GMR=ON THEN        /* TEST IF GETMAIN RECURSION     */
         TM    RTM2GMR(RTM2PTR),B'00100000'                        0616
         BNO   @RF00616                                            0616
*           RTM2RTYA=ADDR(GMRETURN);/* PSEUDO RETRY ADDRESS          */
         LA    @12,GMRETURN                                        0617
         ST    @12,RTM2RTYA(,RTM2PTR)                              0617
*         ELSE                      /* IF NOT GETMAIN                */
*           IF RTM2PPR=ON THEN                                     0618
         B     @RC00616                                            0618
@RF00616 TM    RTM2PPR(RTM2PTR),B'01000000'                        0618
         BNO   @RF00618                                            0618
*             RTM2RTYA=ADDR(PAGERET);                              0619
         LA    @12,PAGERET                                         0619
         ST    @12,RTM2RTYA(,RTM2PTR)                              0619
*           ELSE                                                   0620
*             DO;                   /* DETERMINE RECURSION TYPE      */
         B     @RC00618                                            0620
@RF00618 DS    0H                                                  0621
*               IF RTM2IOR=ON THEN  /* TEST IF I/O RECURSION         */
         TM    RTM2IOR(RTM2PTR),B'10000000'                        0621
         BNO   @RF00621                                            0621
*                 DO;                                              0622
*                   RTM2TRSW=OFF;                                  0623
         NI    RTM2TRSW(RTM2PTR),B'11101111'                       0623
*                   DO WHILE(RTM2TRSW=OFF);                        0624
         B     @DE00624                                            0624
@DL00624 DS    0H                                                  0625
*                     IF RTM2PRWA->RTM2IOHS=ON|RTM2PRWA->RTM2IOQS=ON|
*                         RTM2PRWA->RTM2IORS=ON THEN               0625
         L     @12,RTM2PRWA(,RTM2PTR)                              0625
         TM    RTM2IOHS(@12),B'11100000'                           0625
         BZ    @RF00625                                            0625
*                       RTM2TRSW=ON;                               0626
         OI    RTM2TRSW(RTM2PTR),B'00010000'                       0626
*                     ELSE                                         0627
*                       RTM2PRWA=RTM2PRWA->RTM2PREV;               0627
         B     @RC00625                                            0627
@RF00625 L     @12,RTM2PRWA(,RTM2PTR)                              0627
         L     @12,RTM2PREV(,@12)                                  0627
         ST    @12,RTM2PRWA(,RTM2PTR)                              0627
*                   END;                                           0628
@RC00625 DS    0H                                                  0628
@DE00624 TM    RTM2TRSW(RTM2PTR),B'00010000'                       0628
         BZ    @DL00624                                            0628
*                   IF RTM2PRWA->RTM2IOQS=ON THEN/* TEST IF QUIESCE
*                                      FAILURE                       */
         L     @12,RTM2PRWA(,RTM2PTR)                              0629
         TM    RTM2IOQS(@12),B'10000000'                           0629
         BNO   @RF00629                                            0629
*                     RTM2RTYA=ADDR(QIESADDR);/* PSEUDO RETRY ADDRESS*/
         LA    @12,QIESADDR                                        0630
         ST    @12,RTM2RTYA(,RTM2PTR)                              0630
*                   ELSE            /* IF NOT QUIESCE                */
*                     DO;           /* DETERMINE I/O RECURSION TYPE  */
         B     @RC00629                                            0631
@RF00629 DS    0H                                                  0632
*                       IF RTM2PRWA->RTM2IOHS=ON THEN/* TEST IF HALT
*                                      FAILURE                       */
         L     @12,RTM2PRWA(,RTM2PTR)                              0632
         TM    RTM2IOHS(@12),B'01000000'                           0632
         BNO   @RF00632                                            0632
*                         RTM2RTYA=ADDR(HALTADDR);/* PSEUDO RETRY  0633
*                                      ADDRESS                       */
         LA    @12,HALTADDR                                        0633
         ST    @12,RTM2RTYA(,RTM2PTR)                              0633
*                       ELSE                                       0634
*                         DO;       /* CHECK IF RESTORE RECURSION    */
         B     @RC00632                                            0634
@RF00632 DS    0H                                                  0635
*                           IF RTM2PRWA->RTM2IORS=ON THEN/* TEST IF
*                                      RESTORE FAILURE               */
         L     @12,RTM2PRWA(,RTM2PTR)                              0635
         TM    RTM2IORS(@12),B'00100000'                           0635
         BNO   @RF00635                                            0635
*                             RTM2RTYA=ADDR(RSTORET);/* PSEUDO RETRY
*                                      ADDR                          */
         LA    @12,RSTORET                                         0636
         ST    @12,RTM2RTYA(,RTM2PTR)                              0636
*                         END;      /* END I/O PROCESSING            */
@RF00635 DS    0H                                                  0638
*                     END;          /* END I/O PROCESSING            */
@RC00632 DS    0H                                                  0639
*                 END;              /* END I/O PROCESSING            */
@RC00629 DS    0H                                                  0640
*             END;                  /* END RECURSION SET UP          */
@RF00621 DS    0H                                                  0641
*         RTM2PRWA->RTM2RREG(16)=RC4;/* SET UP FAILING RETURN CODE   */
@RC00618 DS    0H                                                  0641
@RC00616 L     @12,RTM2PRWA(,RTM2PTR)                              0641
         MVC   RTM2RREG+60(4,@12),@CF00078                         0641
*         RFY                                                      0642
*          (R14,                                                   0642
*           R15) RSTD;                                             0642
*         IF RTM2TRME=ON THEN       /* TEST IF TERM PROCESSING       */
         TM    RTM2TRME(RTM2PTR),B'10000000'                       0643
         BNO   @RF00643                                            0643
*           DO;                     /* IF TERM, THEN WE MUST EFFECT
*                                      OUR OWN RETRY                 */
*             RTM2SCBC=SCBSTART;    /* DELIMIT SCB QUEUE             */
         MVC   RTM2SCBC(4,RTM2PTR),@CF00057                        0645
*             RTM2SCBO=ZERO;        /* DELIMIT SCB QUEUE             */
         SLR   @11,@11                                             0646
         ST    @11,RTM2SCBO(,RTM2PTR)                              0646
*             R15=RTM2PRWA;                                        0647
         LR    R15,@12                                             0647
*             GEN REFS(RTM2RREG);                                  0648
         LM    0,2,RTM2RREG(R15)       RESTORE REGISTERS
         LM    4,12,RTM2RREG+16(R15)   RESTORE REGISTERS
*             R14=ADDR(TOP);        /* REENTER AT TOP TO RECOVER   0649
*                                                            @ZA01940*/
         LA    R14,TOP                                             0649
*             RTM2AS2R=OFF;         /* TURN OFF RECURSION INDICATOR
*                                                            @ZA02950*/
*             RTM2AS3R=OFF;         /* TURN OFF RECURSION INDICATOR
*                                                            @ZA02950*/
         NI    RTM2AS2R(RTM2PTR),B'11111100'                       0651
*             GOTO R14;                                            0652
         BR    R14                                                 0652
*             RFY                                                  0653
*              (R14,                                               0653
*               R15) UNRSTD;                                       0653
*           END;                                                   0654
*         ELSE                                                     0655
*           DO;                                                    0655
@RF00643 DS    0H                                                  0656
*             RTM2AS1R=ON;          /* AS1 HAS RECURSED      @ZA02950*/
         OI    RTM2AS1R(RTM2PTR),B'00000100'                       0656
*             RTM2RYRB=RTM2PRWA->RTM2VRBC;/* SET UP RETRY RB ADDRESS */
         L     @12,RTM2PRWA(,RTM2PTR)                              0657
         L     @12,RTM2VRBC(,@12)                                  0657
         ST    @12,RTM2RYRB(,RTM2PTR)                              0657
*           END;                                                   0658
*       END;                        /* END RECURSE1                  */
*       R13=ADDR(RTM2TRSA);                                        0660
         LA    R13,RTM2TRSA(,RTM2PTR)                              0660
*       CALL IEAVTAS3;                                             0661
         L     @15,@CV03262                                        0661
         BALR  @14,@15                                             0661
*       RTM2RETR=ON;                /* REQUEST RETRY         @ZA27871*/
         OI    RTM2RETR(RTM2PTR),B'01000000'                       0662
*     END;                          /* END AS1 RECURSION PROCESSING  */
*   RTM2WARG=NULL;                  /* CLEAR REG # FROM WORK AREA    */
@RF00613 MVI   RTM2WARG(RTM2PTR),X'00'                             0664
*   R13=ADDR(RTM2SFSA);                                            0665
         LA    R13,RTM2SFSA(,RTM2PTR)                              0665
*   RETURN;                                                        0666
@EL00001 DS    0H                                                  0666
@EF00001 DS    0H                                                  0666
@ER00001 LM    @14,@12,12(@13)                                     0666
         BR    @14                                                 0666
*RECURSE:                                                          0667
*                                                                  0667
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT WILL GET CONTROL WHEN AN ERROR IS ENCOUNTERED    */
*   /* DURING TASK RECOVERY-S EXTERNAL PROCESSING. RECURSE WILL FIRST*/
*   /* CARRY FORWARD PREVIOUS RECURSION FLAGS IF ANY EXIST AND THEN  */
*   /* SET CURRENT RECURSION FLAGS BASED ON THE SECTION FLAGS        */
*   /* PREVIOUSLY SET IN MAINLINE PROCESSING. THE APPLICABLE SDWA AND*/
*   /* SCB POINTERS ARE INITIALIZED, AND, FOR PRE-EXIT RECURSIONS,   */
*   /* THE SCB Q DELIMITERS IN RTM2 WORKAREA ARE RESET TO LIMIT THE  */
*   /* SCB Q TO THOSE SCBS (EXITS) PERTINENT TO THE RECURSION        */
*   /* PROCESSING. CONTROL IS THEN PASSED TO THE SPECIFIC RECURSION  */
*   /* HANDLER FOR IEAVTAS1, IEAVTAS2, OR IEAVTAS3.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0667
*   DO;                             /* BEGIN RECURSE                 */
RECURSE  DS    0H                                                  0668
*     RESPECIFY                                                    0668
*       RECRREG RESTRICTED;                                        0668
*     SCBPTR=SCBSTART;              /* INITIALIZE SCB POINTER        */
         LA    SCBPTR,1                                            0669
*     SDWAPTR=ZERO;                 /* INITIALIZE SDWA POINTER       */
         SLR   SDWAPTR,SDWAPTR                                     0670
*     RECRREG=ADDR(TOP);            /* INITIALIZE GO TO REGISTER     */
*                                                                  0671
         LA    RECRREG,TOP                                         0671
*     /***************************************************************/
*     /*                                                             */
*     /* COPY STATUS FLAGS FORWARD                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0672
*     IF RTM2PRWA->RTM2STAF=ON THEN                                0672
         L     @15,RTM2PRWA(,RTM2PTR)                              0672
         TM    RTM2STAF(@15),B'10000000'                           0672
         BNO   @RF00672                                            0672
*       RTM2STAF=ON;                /* PREVIOUS EXIT FAILED FLAG     */
         OI    RTM2STAF(RTM2PTR),B'10000000'                       0673
*     IF RTM2PRWA->RTM2STAI=ON THEN                                0674
@RF00672 L     @15,RTM2PRWA(,RTM2PTR)                              0674
         TM    RTM2STAI(@15),B'01000000'                           0674
         BNO   @RF00674                                            0674
*       RTM2STAI=ON;                                               0675
         OI    RTM2STAI(RTM2PTR),B'01000000'                       0675
*     RTM2IOFS=RTM2PRWA->RTM2IOFS;                                 0676
@RF00674 L     @15,RTM2PRWA(,RTM2PTR)                              0676
         MVC   RTM2IOFS(1,RTM2PTR),RTM2IOFS(@15)                   0676
*     RTM2FIOB=RTM2PRWA->RTM2FIOB;                                 0677
*                                                                  0677
         MVC   RTM2FIOB(3,RTM2PTR),RTM2FIOB(@15)                   0677
*     /***************************************************************/
*     /*                                                             */
*     /* CARRY FORWARD RECURSION FLAGS                               */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0678
*     IF RTM2PRWA->RTM2IOR=ON|RTM2PRWA->RTM2IOHS=ON|RTM2PRWA->RTM2IORS=
*         ON|RTM2PRWA->RTM2IOQS=ON THEN/* TEST PREVIOUS I/O RECURSION
*                                      FLAG AND I/O SECTION FLAG     */
         TM    RTM2IOR(@15),B'10000000'                            0678
         BO    @RT00678                                            0678
         TM    RTM2IOHS(@15),B'11100000'                           0678
         BZ    @RF00678                                            0678
@RT00678 DS    0H                                                  0679
*       RTM2IOR=ON;                 /* SET I/O RECURSION FLAG        */
         OI    RTM2IOR(RTM2PTR),B'10000000'                        0679
*     IF RTM2PRWA->RTM2GMR=ON|RTM2PRWA->RTM2GMS=ON THEN/* TEST     0680
*                                      PREVIOUS GETMAIN RECURSION AND
*                                      SECTION FLAGS                 */
@RF00678 L     @15,RTM2PRWA(,RTM2PTR)                              0680
         TM    RTM2GMR(@15),B'00100000'                            0680
         BO    @RT00680                                            0680
         TM    RTM2GMS(@15),B'00010000'                            0680
         BNO   @RF00680                                            0680
@RT00680 DS    0H                                                  0681
*       RTM2GMR=ON;                 /* SET GETMAIN RECURSION FLAG    */
         OI    RTM2GMR(RTM2PTR),B'00100000'                        0681
*     IF RTM2PRWA->RTM2PPR=ON|RTM2PRWA->RTM2PPS=ON THEN/* TEST PURGE
*                                      PAGE-IN RECURSION AND SECTION
*                                      FLAGS                         */
@RF00680 L     @15,RTM2PRWA(,RTM2PTR)                              0682
         TM    RTM2PPR(@15),B'01000000'                            0682
         BO    @RT00682                                            0682
         TM    RTM2PPS(@15),B'00001000'                            0682
         BNO   @RF00682                                            0682
@RT00682 DS    0H                                                  0683
*       RTM2PPR=ON;                 /* SET PAGE-IN RECURSION FLAG    */
*                                                                  0683
         OI    RTM2PPR(RTM2PTR),B'01000000'                        0683
*     /***************************************************************/
*     /*                                                             */
*     /* FOR RECURSIONS IN PRE-EXIT PROCESSING SEARCH RTM2 WORKAREA  */
*     /* CHAIN TO FIND THE WORKAREA IN EFFECT AT THE TIME OF ERROR.  */
*     /* USING THIS WORKAREA THE SCB QUEUE IN THE CURRENT WORKAREA   */
*     /* CAN BE LIMITED TO THOSE SCBS INVOLVED IN THE RECURSION. FOR */
*     /* GETMAIN THE IMMEDIATELY PREVIOUS WORKAREA IS ALWAYS THE ONE */
*     /* THAT WAS IN EFFECT AT THE TIME OF ERROR.                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0684
*     IF RTM2PPR=ON|RTM2GMR=ON THEN /* TEST IF GETMAIN RECURSION     */
@RF00682 TM    RTM2PPR(RTM2PTR),B'01100000'                        0684
         BZ    @RF00684                                            0684
*       RTM2SCBO=RTM2PRWA->RTM2SCBN;/* DELIMIT SCB QUEUE             */
         L     @15,RTM2PRWA(,RTM2PTR)                              0685
         L     @15,RTM2SCBN(,@15)                                  0685
         ST    @15,RTM2SCBO(,RTM2PTR)                              0685
*     ELSE                                                         0686
*       IF RTM2IOR=ON THEN          /* TEST IF IO RECURSION          */
         B     @RC00684                                            0686
@RF00684 TM    RTM2IOR(RTM2PTR),B'10000000'                        0686
         BNO   @RF00686                                            0686
*         DO;                       /* SEARCH FOR RTM2WA             */
*           RFY                                                    0688
*             R2 RSTD;                                             0688
*           R2=RTM2PRWA;            /* TEMP HOLD FOR RTM2PRWA        */
         L     R2,RTM2PRWA(,RTM2PTR)                               0689
*           RTM2TRSW=OFF;           /* INITIALIZE LOOP CONTROL       */
         NI    RTM2TRSW(RTM2PTR),B'11101111'                       0690
*           DO WHILE(RTM2TRSW=OFF);                                0691
         B     @DE00691                                            0691
@DL00691 DS    0H                                                  0692
*             IF R2->RTM2IOHS=ON|R2->RTM2IOQS=ON|R2->RTM2IORS=ON THEN
         TM    RTM2IOHS(R2),B'11100000'                            0692
         BZ    @RF00692                                            0692
*               RTM2TRSW=ON;        /* TRIGGER END OF SEARCH         */
         OI    RTM2TRSW(RTM2PTR),B'00010000'                       0693
*             ELSE                                                 0694
*               R2=R2->RTM2PREV;    /* CHAIN THROUGH WORKAREAS       */
         B     @RC00692                                            0694
@RF00692 L     R2,RTM2PREV(,R2)                                    0694
*           END;                                                   0695
@RC00692 DS    0H                                                  0695
@DE00691 TM    RTM2TRSW(RTM2PTR),B'00010000'                       0695
         BZ    @DL00691                                            0695
*           RTM2SCBO=R2->RTM2SCBN;  /* DELIMIT SCB QUEUE             */
         L     @15,RTM2SCBN(,R2)                                   0696
         ST    @15,RTM2SCBO(,RTM2PTR)                              0696
*           RFY                                                    0697
*             R2 UNRSTD;                                           0697
*         END;                      /* END PRE-EXIT RECURSION SET UP */
*                                                                  0698
*     /***************************************************************/
*     /*                                                             */
*     /* POST-EXIT RECURSION SET UP. RELATED RTM2 WORKAREA IS THE    */
*     /* IMMEDIATELY PREVIOUS TO CURRENT. THE SCB QUEUE WILL NOT BE  */
*     /* DELIMITED SINCE RECURSION PROCESSING DEFAULTS TO CONTINUE   */
*     /* WITH TERMINATION PROCESSING.                                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0699
*     IF RTM2PRWA->RTM2VLDY=ON|RTM2PRWA->RTM2HOOK=ON|RTM2PRWA->RTM2RCD=
*         ON THEN                   /* TEST SECTION FLAGS FOR      0699
*                                      IEAVTAS2                      */
@RF00686 DS    0H                                                  0699
@RC00684 L     @15,RTM2PRWA(,RTM2PTR)                              0699
         TM    RTM2VLDY(@15),B'00000110'                           0699
         BNZ   @RT00699                                            0699
         TM    RTM2RCD(@15),B'10000000'                            0699
         BNO   @RF00699                                            0699
@RT00699 DS    0H                                                  0700
*       DO;                         /* AS2 RECURSION SET UP          */
*         RTM2AS2R=ON;              /* SET AS2 RECURSION FLAG        */
         OI    RTM2AS2R(RTM2PTR),B'00000010'                       0701
*         RECRREG=ADDR(CALLAS2);    /* ENTRY POINT ADDRESS           */
         LA    RECRREG,CALLAS2                                     0702
*         DO WHILE(RTM2PRWA->RTM2XFLG=OFF);/* LOCATE RTM2 WORKAREA IN
*                                      CONTROL WHEN USER EXIT INVOKED*/
         B     @DE00703                                            0703
@DL00703 DS    0H                                                  0704
*           RTM2PRWA=RTM2PRWA->RTM2PREV;/* CHAIN THROUGH WORKAREAS   */
         L     @15,RTM2PRWA(,RTM2PTR)                              0704
         L     @15,RTM2PREV(,@15)                                  0704
         ST    @15,RTM2PRWA(,RTM2PTR)                              0704
*         END;                      /* END RTM2 WORKAREA SEARCH      */
@DE00703 L     @15,RTM2PRWA(,RTM2PTR)                              0705
         TM    RTM2XFLG(@15),B'00001000'                           0705
         BZ    @DL00703                                            0705
*         IF RTM2PRWA->RTM2WAIN=OFF THEN/* SDWA NOT INVALID          */
         TM    RTM2WAIN(@15),B'01000000'                           0706
         BNZ   @RF00706                                            0706
*           SDWAPTR=RTM2PRWA->RTM2RTCA;/* INITIALIZE SDWAPTR         */
         L     SDWAPTR,RTM2RTCA(,@15)                              0707
*         SCBPTR=RTM2PRWA->RTM2SCBC;/* INITIALIZE SCBPTR             */
@RF00706 L     @15,RTM2PRWA(,RTM2PTR)                              0708
         L     SCBPTR,RTM2SCBC(,@15)                               0708
*       END;                        /* END AS2 RECURSION SET UP      */
*     ELSE                          /* NOT AS2 RECURSION             */
*       IF RTM2PRWA->RTM2FMS=ON|RTM2PRWA->RTM2RTYS=ON THEN/* TEST  0710
*                                      SECTION FLAGS FOR IEAVTAS3    */
         B     @RC00699                                            0710
@RF00699 L     @15,RTM2PRWA(,RTM2PTR)                              0710
         TM    RTM2FMS(@15),B'00000001'                            0710
         BO    @RT00710                                            0710
         TM    RTM2RTYS(@15),B'01000000'                           0710
         BNO   @RF00710                                            0710
@RT00710 DS    0H                                                  0711
*         DO;                       /* AS3 RECURSION SET UP          */
*           RTM2AS3R=ON;            /* SET AS3 RECURSION FLAG        */
         OI    RTM2AS3R(RTM2PTR),B'00000001'                       0712
*           RECRREG=ADDR(CALLAS3);  /* ENTRY POINT ADDRESS           */
         LA    RECRREG,CALLAS3                                     0713
*           DO WHILE(RTM2PRWA->RTM2XFLG=OFF);/* LOCATE RTM2 WORKAREA
*                                      IN CONTROL WHEN USER EXIT   0714
*                                      INVOKED                       */
         B     @DE00714                                            0714
@DL00714 DS    0H                                                  0715
*             RTM2PRWA=RTM2PRWA->RTM2PREV;/* CHAIN THROUGH WKAREAS   */
         L     @15,RTM2PRWA(,RTM2PTR)                              0715
         L     @15,RTM2PREV(,@15)                                  0715
         ST    @15,RTM2PRWA(,RTM2PTR)                              0715
*           END;                    /* END RTM2 WORKAREA SEARCH      */
@DE00714 L     @15,RTM2PRWA(,RTM2PTR)                              0716
         TM    RTM2XFLG(@15),B'00001000'                           0716
         BZ    @DL00714                                            0716
*           IF RTM2PRWA->RTM2WAIN=OFF THEN/* SDWA NOT INVALID        */
         TM    RTM2WAIN(@15),B'01000000'                           0717
         BNZ   @RF00717                                            0717
*             SDWAPTR=RTM2PRWA->RTM2RTCA;/* INITIALIZE SDWAPTR       */
         L     SDWAPTR,RTM2RTCA(,@15)                              0718
*           SCBPTR=RTM2PRWA->RTM2SCBC;/* INITIALIZE SCBPTR           */
@RF00717 L     @15,RTM2PRWA(,RTM2PTR)                              0719
         L     SCBPTR,RTM2SCBC(,@15)                               0719
*         END;                      /* END AS3 RECURSION SET UP      */
*       ELSE                        /* NOT AS2 OR AS3 RECUR.         */
*         IF RTM2PRWA->RTM2XIP=ON THEN/* TEST IF USER EXIT SECTION 0721
*                                      FLAG                          */
         B     @RC00710                                            0721
@RF00710 L     @15,RTM2PRWA(,RTM2PTR)                              0721
         TM    RTM2XIP(@15),B'00100000'                            0721
         BNO   @RF00721                                            0721
*           DO;                     /* USER EXIT RECURSION SET UP    */
*             RTM2XABD=ON;          /* INDICATE EXIT ABENDED         */
         OI    RTM2XABD(RTM2PTR),B'00010000'                       0723
*             RECRREG=ADDR(CALLAS2);/* ENTRY POINT ADDRESS           */
         LA    RECRREG,CALLAS2                                     0724
*             IF RTM2PRWA->RTM2WAIN=OFF THEN/* SDWA NOT INVALID      */
         TM    RTM2WAIN(@15),B'01000000'                           0725
         BNZ   @RF00725                                            0725
*               SDWAPTR=RTM2PRWA->RTM2RTCA;/* INITIALIZE SDWAPTR FROM
*                                      IMMEDIATELY PRECEDING RTM2  0726
*                                      WORKAREA                      */
         L     SDWAPTR,RTM2RTCA(,@15)                              0726
*             SCBPTR=RTM2PRWA->RTM2SCBC;/* INITIALIZE SCBPTR FROM  0727
*                                      IMMEDIATELY PRECEDING RTM2  0727
*                                      WORKAREA                      */
@RF00725 L     @15,RTM2PRWA(,RTM2PTR)                              0727
         L     SCBPTR,RTM2SCBC(,@15)                               0727
*           END;                    /* END USER EXIT RECURSION SET UP*/
*     GOTO RECRREG;                 /* GO TO RECURSION ADDRESS       */
@RF00721 DS    0H                                                  0729
@RC00710 DS    0H                                                  0729
@RC00699 BR    RECRREG                                             0729
*     RESPECIFY                                                    0730
*       RECRREG UNRESTRICTED;       /* RELEASE RECURSION REG         */
*   END;                            /* END OF RECURSE                */
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     0732
*     GPR01F FIXED(31) REG(1),                                     0732
*     GPR15F FIXED(31) REG(15),                                    0732
*     GPR00P PTR(31) REG(0),                                       0732
*     GPR01P PTR(31) REG(1),                                       0732
*     GPR11P PTR(31) REG(11),                                      0732
*     GPR12P PTR(31) REG(12),                                      0732
*     GPR13P PTR(31) REG(13),                                      0732
*     GPR14P PTR(31) REG(14),                                      0732
*     GPR15P PTR(31) REG(15);                                      0732
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0733
*     I031F FIXED(31) BASED,                                       0733
*     I031P PTR(31) BASED,                                         0733
*     I015F FIXED(15) BASED,                                       0733
*     I015P PTR(15) BASED,                                         0733
*     I008P PTR(8) BASED,                                          0733
*     I001C CHAR(1) BASED;                                         0733
*   END IEAVTAS1                                                   0734
*                                                                  0734
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (AS1SPEC )                                       */
*/*%INCLUDE SYSLIB  (AS1DCL  )                                       */
*/*%INCLUDE SYSLIB  (IHARTM2A)                                       */
*/*%INCLUDE SYSLIB  (IHASNP  )                                       */
*/*%INCLUDE SYSLIB  (IHARMPL )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHACDE  )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (IECDPPL )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (RTM2ESA )                                       */
*/*%INCLUDE SYSLIB  (AS1PATCH)                                       */
*/*%INCLUDE SYSLIB  (FINDSCB )                                       */
*/*%INCLUDE SYSLIB  (WKUPDAT )                                       */
*/*%INCLUDE SYSLIB  (IRBSRCH )                                       */
*/*%INCLUDE SYSLIB  (CDESRCH )                                       */
*/*%INCLUDE SYSLIB  (JLPASRCH)                                       */
*/*%INCLUDE SYSLIB  (SDWAINIT)                                       */
*/*%INCLUDE SYSLIB  (GETSDWA )                                       */
*/*%INCLUDE SYSLIB  (SDWADATA)                                       */
*/*%INCLUDE SYSLIB  (CNVRTPSW)                                       */
*/*%INCLUDE SYSLIB  (SDWARTM2)                                       */
*/*%INCLUDE SYSLIB  (USEROPTS)                                       */
*/*%INCLUDE SYSLIB  (ESTRPROC)                                       */
*/*%INCLUDE SYSLIB  (IOPURGE )                                       */
*/*%INCLUDE SYSLIB  (EXITINTR)                                       */
*/*%INCLUDE SYSLIB  (PRESYNCH)                                       */
*/*%INCLUDE SYSLIB  (POSTSYNC)                                       */
*/*%INCLUDE SYSLIB  (RECURSE1)                                       */
*/*%INCLUDE SYSLIB  (RECURSE )                                       */
*                                                                  0734
*       ;                                                          0734
@DATA    DS    0H
@CH00958 DC    H'108'
@DATD    DSECT
         DS    0F
IEAVTAS1 CSECT
         DS    0F
@CF00057 DC    F'1'
@CF00078 DC    F'4'
@CF00458 DC    F'64'
@CF03281 DC    F'512'
@CF03307 DC    F'584'
@CF03334 DC    F'-4'
@CF03341 DC    F'-3'
@CF03338 DC    XL4'0000FFFF'
@CF00087 DC    XL4'FFFFFF'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVTAS1 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV03262 DC    V(IEAVTAS3)
@CV03293 DC    V(IEAVTAS2)
         DS    0D
@CB03336 DC    X'00'
         DS    CL3
AS1PATCH DC    CL160'PATCH AREA'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R10      EQU   @10
INPUTREG EQU   @01
R1       EQU   @01
R0       EQU   @00
R2       EQU   @02
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
RECRREG  EQU   @14
I        EQU   @06
CDENTPTR EQU   @08
RBSECPTR EQU   @09
RTM2PTR  EQU   @03
SCBPTR   EQU   @05
SDWAPTR  EQU   @07
TCBPTR   EQU   @04
XTLSTPTR EQU   @02
PPLPTR   EQU   @01
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR01F   EQU   @01
GPR15F   EQU   @15
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR15P   EQU   @15
         ENTRY RECURSE
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ASCBPTR  EQU   0
SNPPARMS EQU   0
SNPFLAG  EQU   SNPPARMS+1
SNPSDATA EQU   SNPPARMS+4
SNPSDAT0 EQU   SNPSDATA
SNPSDAT1 EQU   SNPSDATA+1
SNPPDATA EQU   SNPPARMS+6
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RMPLIPUF EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLTCBA EQU   RMPL+8
RMPLRMWA EQU   RMPL+16
RTM2WA   EQU   0
RTM2DESC EQU   RTM2WA
RTM2RT2D EQU   RTM2DESC+8
RTM2CVT  EQU   RTM2WA+12
RTM2TCBC EQU   RTM2WA+16
RTM2VRBC EQU   RTM2WA+20
RTM2ASC  EQU   RTM2WA+24
RTM2CODE EQU   RTM2WA+28
RTM2CCF  EQU   RTM2CODE
RTM2DREQ EQU   RTM2CCF
RTM2STEP EQU   RTM2CCF
RTM2CC   EQU   RTM2CODE+1
RTM2PGCY EQU   RTM2WA+60
RTM2TRRY EQU   RTM2PGCY
RTM2EEDR EQU   RTM2TRRY
RTM2EREG EQU   RTM2EEDR
RTM2APSW EQU   RTM2EEDR+64
RTM2EPSW EQU   RTM2APSW
RTM2EMK1 EQU   RTM2EPSW
RTM2AIO1 EQU   RTM2EMK1
RTM2EXT1 EQU   RTM2EMK1
RTM2MWP1 EQU   RTM2EPSW+1
RTM2INT1 EQU   RTM2EPSW+2
RTM2NXT1 EQU   RTM2EPSW+4
RTM2ADD1 EQU   RTM2NXT1+1
RTM2AEC1 EQU   RTM2APSW+8
RTM2ILC1 EQU   RTM2AEC1+1
RTM2IL1  EQU   RTM2ILC1
RTM2INC1 EQU   RTM2AEC1+2
RTM2ICD1 EQU   RTM2INC1+1
RTM2ABNM EQU   RTM2TRRY+80
RTM2ABEP EQU   RTM2TRRY+88
RTM2EEDH EQU   RTM2TRRY+92
RTM2STCK EQU   RTM2EEDH
RTM2MCHI EQU   RTM2EEDH+8
RTM2MCHS EQU   RTM2MCHI
RTM2MCHD EQU   RTM2MCHI+1
RTM2RSR1 EQU   RTM2EEDH+12
RTM2RSR2 EQU   RTM2EEDH+13
RTM2FLGS EQU   RTM2TRRY+120
RTM2ERRA EQU   RTM2FLGS
RTM2ERRB EQU   RTM2FLGS+1
RTM2ERRC EQU   RTM2FLGS+2
RTM2STAF EQU   RTM2ERRC
RTM2STAI EQU   RTM2ERRC
RTM2IRB  EQU   RTM2ERRC
RTM2ERRD EQU   RTM2FLGS+3
RTM2NRBE EQU   RTM2ERRD
RTM2STAE EQU   RTM2ERRD
RTM2FMID EQU   RTM2TRRY+124
RTM2CVER EQU   RTM2WA+186
RTM2TRRC EQU   RTM2CVER
RTM2IOFS EQU   RTM2TRRC
RTM2IOQR EQU   RTM2IOFS
RTM2IOHT EQU   RTM2IOFS
RTM2NOIO EQU   RTM2IOFS
RTM2NIOP EQU   RTM2IOFS
RTM2IOBP EQU   RTM2TRRC+2
RTM2FIOB EQU   RTM2IOBP+1
RTM2RBST EQU   RTM2TRRC+6
RTM2STAR EQU   RTM2TRRC+10
RTM2SCBS EQU   RTM2TRRC+14
RTM2SCBC EQU   RTM2SCBS
RTM2SCBN EQU   RTM2SCBS+4
RTM2SCBO EQU   RTM2SCBS+8
RTM2RTCD EQU   RTM2TRRC+26
RTM2RTCA EQU   RTM2RTCD
RTM2SPLL EQU   RTM2RTCD+4
RTM2SUBP EQU   RTM2SPLL
RTM2SIZE EQU   RTM2SPLL+1
RTM2COMP EQU   RTM2TRRC+34
RTM2RTYA EQU   RTM2TRRC+38
RTM2RYRB EQU   RTM2TRRC+42
RTM2PARQ EQU   RTM2TRRC+46
RTM2RCDE EQU   RTM2PARQ
RTM2CTL1 EQU   RTM2CVER+50
RTM2CMKA EQU   RTM2CTL1
RTM2IOA  EQU   RTM2CMKA
RTM2EXTA EQU   RTM2CMKA
RTM2MWPA EQU   RTM2CTL1+1
RTM2INTA EQU   RTM2CTL1+2
RTM2PMKA EQU   RTM2CTL1+4
RTM2ILA  EQU   RTM2PMKA
RTM2NXTA EQU   RTM2CTL1+5
RTM2CTL2 EQU   RTM2CVER+58
RTM2CMKP EQU   RTM2CTL2
RTM2IOP  EQU   RTM2CMKP
RTM2EXTP EQU   RTM2CMKP
RTM2MWPP EQU   RTM2CTL2+1
RTM2INTP EQU   RTM2CTL2+2
RTM2PMKP EQU   RTM2CTL2+4
RTM2ILP  EQU   RTM2PMKP
RTM2NXTP EQU   RTM2CTL2+5
RTM2SNAP EQU   RTM2CVER+66
RTM2SPRM EQU   RTM2SNAP+4
RTM2DPSL EQU   RTM2SNAP+24
RTM2FRM1 EQU   RTM2DPSL
RTM2TO1  EQU   RTM2DPSL+4
RTM2FRM2 EQU   RTM2DPSL+8
RTM2TO2  EQU   RTM2DPSL+12
RTM2FRM3 EQU   RTM2DPSL+16
RTM2TO3  EQU   RTM2DPSL+20
RTM2FRM4 EQU   RTM2DPSL+24
RTM2TO4  EQU   RTM2DPSL+28
RTM2SECB EQU   RTM2CVER+138
RTM2ECBA EQU   RTM2SECB
RTM2PREV EQU   RTM2CVER+178
RTM2PRWA EQU   RTM2CVER+182
RTM2SFRG EQU   RTM2CVER+186
RTM2SFSA EQU   RTM2SFRG
RTM2SCTL EQU   RTM2CVER+259
RTM2CCTL EQU   RTM2SCTL
RTM2ABDR EQU   RTM2SCTL+4
RTM2ABID EQU   RTM2ABDR
RTM2ABND EQU   RTM2ABDR+1
RTM2RCTL EQU   RTM2SCTL+6
RTM2STA2 EQU   RTM2RCTL
RTM2WAIN EQU   RTM2RCTL
RTM2WANA EQU   RTM2RCTL
RTM2TRSW EQU   RTM2RCTL
RTM2BFTL EQU   RTM2RCTL
RTM2LPAQ EQU   RTM2RCTL
RTM2JPAQ EQU   RTM2RCTL
RTM2INTF EQU   RTM2CVER+266
RTM2CTLR EQU   RTM2INTF
RTM2RETR EQU   RTM2CTLR
RTM2TSKT EQU   RTM2INTF+2
RTM2ABDP EQU   RTM2INTF+4
RTM2ASIR EQU   RTM2INTF+5
RTM2TRME EQU   RTM2ASIR
RTM2FLX  EQU   RTM2INTF+6
RTM2FLX1 EQU   RTM2FLX
RTM2FLX2 EQU   RTM2FLX+1
RTM2RECL EQU   RTM2CVER+274
RTM2DCTL EQU   RTM2RECL+12
RTM2ECTL EQU   RTM2RECL+13
RTM2TRYR EQU   RTM2RECL+16
RTM2TRF1 EQU   RTM2TRYR
RTM2IOQS EQU   RTM2TRF1
RTM2IOHS EQU   RTM2TRF1
RTM2IORS EQU   RTM2TRF1
RTM2GMS  EQU   RTM2TRF1
RTM2PPS  EQU   RTM2TRF1
RTM2HOOK EQU   RTM2TRF1
RTM2VLDY EQU   RTM2TRF1
RTM2FMS  EQU   RTM2TRF1
RTM2RCD  EQU   RTM2TRF1+1
RTM2RTYS EQU   RTM2TRF1+1
RTM2XIP  EQU   RTM2TRF1+1
RTM2XABD EQU   RTM2TRF1+1
RTM2XFLG EQU   RTM2TRF1+1
RTM2AS1R EQU   RTM2TRF1+1
RTM2AS2R EQU   RTM2TRF1+1
RTM2AS3R EQU   RTM2TRF1+1
RTM2TRF2 EQU   RTM2TRYR+2
RTM2IOR  EQU   RTM2TRF2
RTM2PPR  EQU   RTM2TRF2
RTM2GMR  EQU   RTM2TRF2
RTM2RECH EQU   RTM2CVER+294
RTM2TRRA EQU   RTM2RECH
RTM2WARG EQU   RTM2CVER+312
RTM2RRG  EQU   RTM2CVER+314
RTM2RREG EQU   RTM2RRG
RTM2CRG  EQU   RTM2CVER+378
RTM2TRSA EQU   RTM2CVER+450
RTM2RMIN EQU   RTM2WA+708
RTM2RMPS EQU   RTM2RMIN
RTM2RMPL EQU   RTM2RMIN+4
RTM2RMWA EQU   RTM2RMIN+28
RTM2RMSA EQU   RTM2RMIN+92
RTM2ERID EQU   RTM2WA+872
RTM2ENSN EQU   RTM2WA+884
RTM2SNLN EQU   RTM2ENSN
RTM2RYRG EQU   RTM2WA+904
STORAGE  EQU   0
STORFRM  EQU   STORAGE
STORTO   EQU   STORAGE+4
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWAREQ  EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWACMPC EQU   SDWAABCC+1
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAIOA  EQU   SDWACMKA
SDWAEXTA EQU   SDWACMKA
SDWAMWPA EQU   SDWACTL1+1
SDWAINTA EQU   SDWACTL1+2
SDWAPMKA EQU   SDWACTL1+4
SDWAILA  EQU   SDWAPMKA
SDWANXTA EQU   SDWACTL1+5
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEPA  EQU   SDWA+96
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWATRAN EQU   SDWAAEC1+4
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWATRN2 EQU   SDWAAEC2+4
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWASPID EQU   SDWAIDNT
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAFMID EQU   SDWA+236
SDWAIOFS EQU   SDWA+238
SDWARECA EQU   SDWA+244
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWAASID EQU   SDWA+288
SDWARECP EQU   SDWA+292
SDWADPLA EQU   SDWA+316
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWACOMP EQU   SDWA+392
SDWARA   EQU   SDWA+400
SDWAVRAL EQU   SDWARA
SDWADPVA EQU   SDWARA+2
SDWAVRA  EQU   SDWARA+4
SCB      EQU   0
SCBCHAIN EQU   SCB
SCBEXIT  EQU   SCB+4
SCBPARM  EQU   SCB+8
SCBFLGS1 EQU   SCBPARM
SCBSTAI  EQU   SCBFLGS1
SCBSTAR  EQU   SCBFLGS1
SCBESTAE EQU   SCBFLGS1
SCBASYNC EQU   SCBFLGS1
SCBIOPRC EQU   SCBFLGS1
SCBNOIOP EQU   SCBIOPRC
SCBHALT  EQU   SCBIOPRC
SCBPARMA EQU   SCBPARM+1
SCBOWNR  EQU   SCB+12
SCBFLGS2 EQU   SCBOWNR
SCBINUSE EQU   SCBFLGS2
SCBSUPER EQU   SCBFLGS2
SCBOWNRA EQU   SCBOWNR+1
SCBDATA  EQU   SCB+16
SCBFLGS3 EQU   SCBDATA
SCBTERMI EQU   SCBFLGS3
SCBRECRD EQU   SCBFLGS3
SCBPRNTR EQU   SCBFLGS3
SCBPKEY  EQU   SCBDATA+1
SCBID    EQU   SCBDATA+2
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBEXSAVE EQU   XRBESA
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBRTRAN  EQU   RBRTPSW2+4
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBINLNTH EQU   RBINTCDA
RBINTCOD EQU   RBINTCDA+1
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00101 EQU   RBSECT+10
@NM00102 EQU   @NM00101
RBFTP    EQU   @NM00102
RBTRSVRB EQU   @NM00102
@NM00104 EQU   @NM00101+1
RBETXR   EQU   @NM00104
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00111 EQU   RBSECT+28
@NM00112 EQU   @NM00111
IRBEND   EQU   RBSECT+96
@NM00115 EQU   RBSECT+96
RBRSV138 EQU   @NM00115+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFX    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBJPQB  EQU   TCBJPQ+1
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBJSTCA EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBSTABE EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBRTWA  EQU   TCB+224
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBSCBKY EQU   TCBESTAE
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTQLPAQ EQU   CVTMAP+188
CVTABEND EQU   CVTMAP+200
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
CDENTRY  EQU   0
CDCHAIN  EQU   CDENTRY
CDNAME   EQU   CDENTRY+8
CDENTPT  EQU   CDENTRY+16
CDXLMJP  EQU   CDENTRY+20
CDATTR   EQU   CDENTRY+28
CDMIN    EQU   CDATTR
CDATTR2  EQU   CDENTRY+29
SCVTSECT EQU   0
SCVTPTRM EQU   SCVTSECT+164
PPL      EQU   0
PPLDSID  EQU   PPL
PPLOPT1  EQU   PPLDSID
PPLPOST  EQU   PPLOPT1
PPLHIO   EQU   PPLOPT1
PPLTASK  EQU   PPLOPT1
PPLEXR   EQU   PPLOPT1
PPLTCB   EQU   PPL+4
PPLPIRL  EQU   PPL+8
PPLOPT2  EQU   PPL+12
PPLOTCB  EQU   PPLOPT2
RTCT     EQU   0
RTCTPLIB EQU   RTCT+4
RTCTSAP  EQU   RTCTPLIB
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSAP3 EQU   RTCTSAP+2
RTCTSUP  EQU   RTCTPLIB+4
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSUP3 EQU   RTCTSUP+2
RTCTSYD  EQU   RTCTPLIB+8
RTCTSY01 EQU   RTCTSYD
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTSDPL EQU   RTCT+156
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
RTCTOPT  EQU   RTCT+236
RTCTASO  EQU   RTCT+252
RTCTASO1 EQU   RTCTASO
RTCTASO2 EQU   RTCTASO+1
RTCTSDI  EQU   RTCT+254
RTCTSDF  EQU   RTCT+264
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTSDF3 EQU   RTCT+268
RTCTSDF4 EQU   RTCTSDF3+2
RTCTMOPT EQU   0
RTCTMSAO EQU   RTCTMOPT
RTCTSASD EQU   RTCTMSAO
RTCTSAO1 EQU   RTCTSASD
RTCTSAO2 EQU   RTCTSASD+1
RTCTSAPD EQU   RTCTMSAO+2
RTCTSAO3 EQU   RTCTSAPD
RTCTSAO4 EQU   RTCTSAPD+1
RTCTSAMG EQU   RTCTSAO4
RTCTMSUO EQU   RTCTMOPT+4
RTCTSUSD EQU   RTCTMSUO
RTCTSUO1 EQU   RTCTSUSD
RTCTSUO2 EQU   RTCTSUSD+1
RTCTSUPD EQU   RTCTMSUO+2
RTCTSUO3 EQU   RTCTSUPD
RTCTSUO4 EQU   RTCTSUPD+1
RTCTSUMG EQU   RTCTSUO4
RTCTMSYO EQU   RTCTMOPT+8
RTCTSD01 EQU   RTCTMSYO
RTCTSD04 EQU   RTCTMSYO+3
RTCTSMMG EQU   RTCTSD04
RTCTMSDO EQU   RTCTMOPT+12
RTCTSDOD EQU   RTCTMSDO
RTCTSDO1 EQU   RTCTSDOD
RTCTSDO2 EQU   RTCTSDOD+1
RTCTSDO3 EQU   RTCTMSDO+2
RTCTSDO4 EQU   RTCTMSDO+3
RTCTSDMG EQU   RTCTSDO4
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
RTM2ESA  EQU   0
ESAREGS  EQU   RTM2ESA
ESAR1    EQU   ESAREGS+4
ESACCF1  EQU   ESAR1
ESART2D  EQU   RTM2ESA+36
ESAFLAGS EQU   RTM2ESA+40
ESARFLAG EQU   RTM2ESA+41
ESAGLREC EQU   ESARFLAG
ESACMP   EQU   RTM2ESA+44
ESACCF   EQU   ESACMP
XTLST    EQU   0
XTLNRFAC EQU   XTLST+4
XTLMSBLA EQU   XTLST+8
XTLMSBLN EQU   XTLMSBLA+1
XTLMSBAA EQU   0
PSW      EQU   0
PSWEMK   EQU   PSW
PSWIO    EQU   PSWEMK
PSWEXT   EQU   PSWEMK
PSWMWP   EQU   PSW+1
PSWPPSUP EQU   PSWMWP
PSWINT   EQU   PSW+2
PSWNXT   EQU   PSW+4
PSWADD   EQU   PSWNXT+1
PTRCDE   EQU   0
IEAPTERM EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVTPTR   EQU   FLCCVT
SCVTSPTR EQU   CVTABEND
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBCDE1   EQU   RBCDE+1
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRTMCT EQU   CVTS01+224
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSWINLEN EQU   RBINLNTH
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00116 EQU   RBSQE
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
@NM00201 EQU   PSWNXT
@NM00200 EQU   PSW+3
@NM00199 EQU   PSWMWP
@NM00198 EQU   PSWEMK
@NM00197 EQU   XTLMSBLA
XTLLNTH  EQU   XTLST
ESACC    EQU   ESACMP+1
@NM00196 EQU   ESACCF
ESAASID  EQU   ESACCF
ESANOCC  EQU   ESACCF
ESAR0DP  EQU   ESACCF
ESASTEP  EQU   ESACCF
ESADREQ  EQU   ESACCF
ESAMODE  EQU   RTM2ESA+43
ESAERTYP EQU   RTM2ESA+42
@NM00195 EQU   ESARFLAG
ESASLIPR EQU   ESARFLAG
ESARTCR  EQU   ESARFLAG
ESAFERR  EQU   ESARFLAG
ESAINREC EQU   ESARFLAG
ESASDREC EQU   ESARFLAG
ESAGMREC EQU   ESARFLAG
@NM00194 EQU   ESAFLAGS
ESAVEOM  EQU   ESAFLAGS
ESAEOT   EQU   ESAFLAGS
ESANEOT  EQU   ESAFLAGS
ESACTS   EQU   ESAFLAGS
ESAPGNLY EQU   ESAFLAGS
ESAABTRM EQU   ESAFLAGS
ESARTM2  EQU   ESAFLAGS
ESAWLEN  EQU   ESART2D+1
ESAWSPID EQU   ESART2D
ESART2WA EQU   RTM2ESA+32
ESAEEDQ  EQU   RTM2ESA+28
ESAR14   EQU   ESAREGS+24
ESAR7    EQU   ESAREGS+20
ESAR5    EQU   ESAREGS+16
ESAR4    EQU   ESAREGS+12
ESAR3    EQU   ESAREGS+8
ESACC1   EQU   ESAR1+1
@NM00193 EQU   ESACCF1
ESAEOT1  EQU   ESACCF1
ESAEOM1  EQU   ESACCF1
ESAR0DP1 EQU   ESACCF1
ESASTEP1 EQU   ESACCF1
ESADREQ1 EQU   ESACCF1
ESAR0    EQU   ESAREGS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
RTCTISVC EQU   RTCTSDO4
RTCTSDOV EQU   RTCTSDMG
@NM00192 EQU   RTCTSDO4
@NM00191 EQU   RTCTSDO3
RTCTSDPH EQU   RTCTSDO3
RTCTSDPG EQU   RTCTSDO3
@NM00190 EQU   RTCTSDO2
RTCTSDPD EQU   RTCTSDO2
RTCTSDPC EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTISYM EQU   RTCTSD04
RTCTSMOV EQU   RTCTSMMG
@NM00189 EQU   RTCTSD04
RTCTSD03 EQU   RTCTMSYO+2
RTCTSD02 EQU   RTCTMSYO+1
RTCTSDS7 EQU   RTCTSD01
RTCTSDS6 EQU   RTCTSD01
RTCTSDS5 EQU   RTCTSD01
RTCTSDS4 EQU   RTCTSD01
RTCTSDS3 EQU   RTCTSD01
RTCTSDS2 EQU   RTCTSD01
RTCTSDS1 EQU   RTCTSD01
RTCTSDS0 EQU   RTCTSD01
RTCTISYU EQU   RTCTSUO4
RTCTSUOV EQU   RTCTSUMG
@NM00188 EQU   RTCTSUO4
RTCTSYDF EQU   RTCTSUO3
RTCTSYDE EQU   RTCTSUO3
RTCTSYDD EQU   RTCTSUO3
RTCTSYDC EQU   RTCTSUO3
RTCTSYDB EQU   RTCTSUO3
RTCTSYDA EQU   RTCTSUO3
RTCTSYD9 EQU   RTCTSUO3
RTCTSYD8 EQU   RTCTSUO3
@NM00187 EQU   RTCTSUO2
RTCTSYDH EQU   RTCTSUO2
RTCTSYDG EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTISAB EQU   RTCTSAO4
RTCTSAOV EQU   RTCTSAMG
@NM00186 EQU   RTCTSAO4
RTCTSADF EQU   RTCTSAO3
RTCTSADE EQU   RTCTSAO3
RTCTSADD EQU   RTCTSAO3
RTCTSADC EQU   RTCTSAO3
RTCTSADB EQU   RTCTSAO3
RTCTSADA EQU   RTCTSAO3
RTCTSAD9 EQU   RTCTSAO3
RTCTSAD8 EQU   RTCTSAO3
@NM00185 EQU   RTCTSAO2
RTCTSADH EQU   RTCTSAO2
RTCTSADG EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTZZZ5 EQU   RTCT+340
RTCTZZZ4 EQU   RTCT+336
RTCTMRMQ EQU   RTCT+332
RTCTSDF5 EQU   RTCTSDF3+3
RTCTSDDO EQU   RTCTSDF4
RTCTSDEN EQU   RTCTSDF4
RTCTSDEQ EQU   RTCTSDF4
RTCTSDTR EQU   RTCTSDF4
RTCTSDRM EQU   RTCTSDF4
RTCTSDAN EQU   RTCTSDF4
RTCTSDNC EQU   RTCTSDF4
RTCTSDSS EQU   RTCTSDF4
RTCTSDAS EQU   RTCTSDF3
RTCTZZZ3 EQU   RTCT+266
RTCTSDFX EQU   RTCTSDF2
RTCTSDRW EQU   RTCTSDF2
RTCTSDSL EQU   RTCTSDF2
RTCTSDWF EQU   RTCTSDF2
RTCTSDLA EQU   RTCTSDF2
RTCTSDDI EQU   RTCTSDF2
RTCTSDTQ EQU   RTCTSDF2
RTCTSDMR EQU   RTCTSDF2
RTCTSDSC EQU   RTCTSDF1
RTCTSDRS EQU   RTCTSDF1
RTCTSDSD EQU   RTCTSDF1
RTCTSDEP EQU   RTCTSDF1
RTCTSDMA EQU   RTCTSDF1
RTCTSDSH EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
RTCTZZZ2 EQU   RTCT+257
RTCTSDPR EQU   RTCTSDI+2
RTCTINDX EQU   RTCTSDI+1
RTCTSDNA EQU   RTCTSDI
@NM00184 EQU   RTCTASO2
RTCTASNQ EQU   RTCTASO2
RTCTASNA EQU   RTCTASO2
RTCTASNS EQU   RTCTASO2
RTCTASSU EQU   RTCTASO2
RTCTASSW EQU   RTCTASO2
RTCTASCS EQU   RTCTASO2
RTCTASTR EQU   RTCTASO1
RTCTASLP EQU   RTCTASO1
RTCTASRG EQU   RTCTASO1
RTCTASLS EQU   RTCTASO1
RTCTASSQ EQU   RTCTASO1
RTCTASNU EQU   RTCTASO1
RTCTASPS EQU   RTCTASO1
RTCTASAL EQU   RTCTASO1
RTCTSDO  EQU   RTCTOPT+12
RTCTSYO  EQU   RTCTOPT+8
RTCTSUO  EQU   RTCTOPT+4
RTCTSAO  EQU   RTCTOPT
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTSDSW EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00183 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDIP EQU   RTCTSDPL
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
@NM00182 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRCB  EQU   RTCT+32
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTYYY1 EQU   RTCT+16
RTCTSY04 EQU   RTCTSYD+3
RTCTSY03 EQU   RTCTSYD+2
RTCTSY02 EQU   RTCTSYD+1
RTCTSYM7 EQU   RTCTSY01
RTCTSYM6 EQU   RTCTSY01
RTCTSYM5 EQU   RTCTSY01
RTCTSYM4 EQU   RTCTSY01
RTCTSYM3 EQU   RTCTSY01
RTCTSYM2 EQU   RTCTSY01
RTCTSYM1 EQU   RTCTSY01
RTCTSYM0 EQU   RTCTSY01
RTCTSUP4 EQU   RTCTSUP+3
RTCTSUDF EQU   RTCTSUP3
RTCTSUDE EQU   RTCTSUP3
RTCTSUDD EQU   RTCTSUP3
RTCTSUDC EQU   RTCTSUP3
RTCTSUDB EQU   RTCTSUP3
RTCTSUDA EQU   RTCTSUP3
RTCTSUD9 EQU   RTCTSUP3
RTCTSUD8 EQU   RTCTSUP3
@NM00181 EQU   RTCTSUP2
RTCTSUDH EQU   RTCTSUP2
RTCTSUDG EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSAP4 EQU   RTCTSAP+3
RTCTSABF EQU   RTCTSAP3
RTCTSABE EQU   RTCTSAP3
RTCTSABD EQU   RTCTSAP3
RTCTSABC EQU   RTCTSAP3
RTCTSABB EQU   RTCTSAP3
RTCTSABA EQU   RTCTSAP3
RTCTSAB9 EQU   RTCTSAP3
RTCTSAB8 EQU   RTCTSAP3
@NM00180 EQU   RTCTSAP2
RTCTSABH EQU   RTCTSAP2
RTCTSABG EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
PPLEND   EQU   PPL+16
PPLASID  EQU   PPL+14
@NM00155 EQU   PPL+13
@NM00154 EQU   PPLOPT2
PPLBSS   EQU   PPLOPT2
PPLTSKM  EQU   PPLOPT2
PPLVC    EQU   PPLOPT2
PPLMEM   EQU   PPLOPT2
@NM00153 EQU   PPLOPT2
PPLCAN   EQU   PPLOPT2
PPLPIRLA EQU   PPLPIRL+1
PPLDVRID EQU   PPLPIRL
PPLTCBA  EQU   PPLTCB+1
PPLCC    EQU   PPLTCB
PPLDSIDA EQU   PPLDSID+1
PPLRB    EQU   PPLOPT1
@NM00152 EQU   PPLOPT1
PPLREL   EQU   PPLOPT1
PPLDS    EQU   PPLOPT1
@NM00151 EQU   SCVTSECT+180
@NM00150 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00149 EQU   SCVTSECT+168
@NM00148 EQU   SCVTSECT+160
@NM00147 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
SCVTSTAT EQU   SCVTSECT+148
@NM00146 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00145 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00144 EQU   SCVTSECT+128
@NM00143 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00142 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00141 EQU   SCVTSECT+108
@NM00140 EQU   SCVTSECT+104
@NM00139 EQU   SCVTSECT+100
@NM00138 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00137 EQU   SCVTSECT+88
@NM00136 EQU   SCVTSECT+84
@NM00135 EQU   SCVTSECT+80
@NM00134 EQU   SCVTSECT+76
@NM00133 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00132 EQU   SCVTSECT+56
@NM00131 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00130 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00129 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00128 EQU   SCVTSECT+24
@NM00127 EQU   SCVTSECT+20
@NM00126 EQU   SCVTSECT+16
@NM00125 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SCVTPGWR EQU   SCVTSECT+4
SCVTPGTM EQU   SCVTSECT
CDATTR3  EQU   CDENTRY+30
CDAUTH   EQU   CDATTR2
CDSYSLIB EQU   CDATTR2
CDOLY    EQU   CDATTR2
@NM00124 EQU   CDATTR2
CDRLC    EQU   CDATTR2
CDXLE    EQU   CDATTR2
CDREL    EQU   CDATTR2
CDSPZ    EQU   CDATTR2
CDNLR    EQU   CDATTR
CDJPA    EQU   CDATTR
CDNFN    EQU   CDATTR
CDSER    EQU   CDATTR
CDREN    EQU   CDATTR
CDNIC    EQU   CDATTR
CDNIP    EQU   CDATTR
@NM00123 EQU   CDENTRY+26
CDUSE    EQU   CDENTRY+24
CDRRBP   EQU   CDENTRY+4
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00122 EQU   CVTFIX+248
@NM00121 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
@NM00120 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00119 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00118 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00117 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00115+8
PRBEND   EQU   @NM00115+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00115+6
RBRSV136 EQU   @NM00115+4
RBRSV135 EQU   @NM00115
@NM00114 EQU   RBSECT+32
@NM00113 EQU   @NM00111+1
RBSCF    EQU   @NM00112
RBPGMQ1  EQU   RBPGMQ+1
@NM00110 EQU   RBPGMQ
@NM00109 EQU   RBSECT+16
@NM00108 EQU   @NM00104
@NM00107 EQU   @NM00104
RBIQETP  EQU   @NM00104
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00104
@NM00106 EQU   @NM00104
@NM00105 EQU   @NM00104
RBPMSVRB EQU   @NM00102
RBATNXIT EQU   @NM00102
@NM00103 EQU   @NM00102
RBWAITP  EQU   @NM00102
RBFNSVRB EQU   RBTRSVRB
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00100 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00099 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00098 EQU   RBOPSWB2
@NM00097 EQU   XRBPSW
@NM00096 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00095 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00094 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00093 EQU   XSTAB1
@NM00092 EQU   RBBASIC+8
@NM00091 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00090 EQU   RBPRFX
SCBRSVRE EQU   SCBDATA+3
@NM00089 EQU   SCBFLGS3
SCBTERMO EQU   SCBFLGS3
SCBBRNTR EQU   SCBFLGS3
SCBCNCEL EQU   SCBFLGS3
@NM00088 EQU   SCBFLGS3
SCBKEY0  EQU   SCBFLGS2
@NM00087 EQU   SCBFLGS2
@NM00086 EQU   SCBFLGS2
@NM00085 EQU   SCBFLGS2
SCBXCTL2 EQU   SCBFLGS2
@NM00084 EQU   SCBFLGS2
@NM00083 EQU   SCBFLGS1
SCBDUMMY EQU   SCBFLGS1
@NM00082 EQU   SDWA+512
SDWAURAL EQU   SDWARA+3
@NM00081 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAERTM EQU   SDWA+396
SDWARCPL EQU   SDWA+364
@NM00080 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00079 EQU   SDWADDAT+3
@NM00078 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00077 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00076 EQU   SDWADUMP+2
@NM00075 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00074 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00073 EQU   SDWAACF3
@NM00072 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00071 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00070 EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00069 EQU   SDWACPUA
SDWARTYA EQU   SDWA+240
SDWACPUI EQU   SDWA+239
@NM00068 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00067 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00066 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00065 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00064 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00063 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00062 EQU   SDWAINC2
@NM00061 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00060 EQU   SDWAILC2
@NM00059 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00058 EQU   SDWANXT2
@NM00057 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00056 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00055 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00054 EQU   SDWAEMK2
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00053 EQU   SDWAINC1
@NM00052 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00051 EQU   SDWAILC1
@NM00050 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00049 EQU   SDWANXT1
@NM00048 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00047 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00046 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00045 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
@NM00044 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00043 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00042 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
@NM00041 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00040 EQU   SDWACMPF
STORBTO  EQU   STORTO
STORB    EQU   STORFRM
RTM2TECB EQU   RTM2RYRG+64
RTM2RYRS EQU   RTM2RYRG
RTM2TRLS EQU   RTM2ENSN+16
RTM2TRFS EQU   RTM2ENSN+12
RTM2TRCU EQU   RTM2ENSN+8
RTM2TRTB EQU   RTM2ENSN+4
RTM2TRLN EQU   RTM2SNLN
@NM00039 EQU   RTM2WA+882
RTM2ERTM EQU   RTM2ERID+6
RTM2ERAS EQU   RTM2ERID+4
RTM2CPUI EQU   RTM2ERID+2
RTM2SEQ# EQU   RTM2ERID
RTM2RMWS EQU   RTM2RMWA
RTM2CREG EQU   RTM2CRG
RTM2RBRG EQU   RTM2CVER+313
@NM00038 EQU   RTM2CVER+310
RTM2CTRA EQU   RTM2RECH+12
RTM2STRA EQU   RTM2RECH+8
RTM2SKRA EQU   RTM2RECH+4
@NM00037 EQU   RTM2TRYR+3
@NM00036 EQU   RTM2TRF2
RTM2TMER EQU   RTM2RECL+14
RTM2EQMN EQU   RTM2ECTL
RTM2EDEQ EQU   RTM2ECTL
RTM2EFRM EQU   RTM2ECTL
RTM2ECLS EQU   RTM2ECTL
RTM2ESNP EQU   RTM2ECTL
RTM2EOPN EQU   RTM2ECTL
RTM2EGET EQU   RTM2ECTL
RTM2EENQ EQU   RTM2ECTL
RTM2DFTK EQU   RTM2DCTL
RTM2DDEQ EQU   RTM2DCTL
RTM2DFRM EQU   RTM2DCTL
RTM2DCLS EQU   RTM2DCTL
RTM2DSNP EQU   RTM2DCTL
RTM2DOPN EQU   RTM2DCTL
RTM2DGET EQU   RTM2DCTL
RTM2DENQ EQU   RTM2DCTL
RTM2SCTX EQU   RTM2RECL+8
RTM2SCTR EQU   RTM2RECL+4
RTM2SCTC EQU   RTM2RECL
@NM00035 EQU   RTM2FLX2
RTM2CERX EQU   RTM2FLX2
RTM2RCRX EQU   RTM2FLX2
RTM2RTRX EQU   RTM2FLX1
RTM2LTX  EQU   RTM2FLX1
RTM2PRX  EQU   RTM2FLX1
RTM2CVX  EQU   RTM2FLX1
RTM2DWX  EQU   RTM2FLX1
RTM2ABX  EQU   RTM2FLX1
RTM2EOTX EQU   RTM2FLX1
RTM2MTX  EQU   RTM2FLX1
@NM00034 EQU   RTM2ASIR
RTM2UPRG EQU   RTM2ASIR
@NM00033 EQU   RTM2ABDP
RTM2SMDP EQU   RTM2ABDP
RTM2DMP1 EQU   RTM2ABDP
RTM2MEMT EQU   RTM2INTF+3
@NM00032 EQU   RTM2TSKT
RTM2PURG EQU   RTM2TSKT
@NM00031 EQU   RTM2INTF+1
@NM00030 EQU   RTM2CTLR
RTM2WRAP EQU   RTM2CTLR
RTM2TMEM EQU   RTM2CTLR
RTM2RECR EQU   RTM2CTLR
@NM00029 EQU   RTM2RCTL
RTM2STAT EQU   RTM2ABND
RTM2NDMP EQU   RTM2ABND
@NM00028 EQU   RTM2ABID
RTM2OERR EQU   RTM2ABID
RTM2SAV2 EQU   RTM2ABID
RTM2SAVE EQU   RTM2ABID
RTM2REG  EQU   RTM2ABID
RTM2PSW  EQU   RTM2ABID
RTM2ENQ  EQU   RTM2ABID
RTM2CB   EQU   RTM2ABID
RTM2MCTL EQU   RTM2SCTL+3
RTM2TCTL EQU   RTM2SCTL+2
@NM00027 EQU   RTM2CCTL+1
RTM2NODP EQU   RTM2CCTL+1
RTM2RGEB EQU   RTM2CCTL+1
RTM2DEND EQU   RTM2CCTL+1
RTM2RSCN EQU   RTM2CCTL+1
RTM2CONT EQU   RTM2CCTL
RTM2SLIP EQU   RTM2CCTL
RTM2HEED EQU   RTM2CCTL
RTM2REED EQU   RTM2CCTL
RTM2ISPC EQU   RTM2CCTL
RTM2SQS  EQU   RTM2CCTL
RTM2CNCL EQU   RTM2CCTL
RTM2STPT EQU   RTM2CCTL
RTM2PKEY EQU   RTM2CVER+258
RTM2SPWA EQU   RTM2CVER+174
RTM2DCBA EQU   RTM2CVER+170
RTM2ECBS EQU   RTM2SECB+16
RTM2LECB EQU   RTM2ECBA
RTM2DTCB EQU   RTM2SNAP+68
RTM2SNCC EQU   RTM2SNAP+64
RTM2DD   EQU   RTM2SNAP+56
RTM2LTO4 EQU   RTM2TO4
RTM2LFR4 EQU   RTM2FRM4
RTM2LTO3 EQU   RTM2TO3
RTM2LFR3 EQU   RTM2FRM3
RTM2LTO2 EQU   RTM2TO2
RTM2LFR2 EQU   RTM2FRM2
RTM2LTO1 EQU   RTM2TO1
RTM2LFR1 EQU   RTM2FRM1
RTM2DPLA EQU   RTM2SNAP
RTM2SGP  EQU   RTM2PMKP
RTM2EUP  EQU   RTM2PMKP
RTM2DOP  EQU   RTM2PMKP
RTM2FPP  EQU   RTM2PMKP
RTM2CCP  EQU   RTM2PMKP
RTM2SPVP EQU   RTM2MWPP
RTM2WATP EQU   RTM2MWPP
RTM2MCKP EQU   RTM2MWPP
@NM00026 EQU   RTM2MWPP
RTM2KEYP EQU   RTM2MWPP
RTM2SGA  EQU   RTM2PMKA
RTM2EUA  EQU   RTM2PMKA
RTM2DOA  EQU   RTM2PMKA
RTM2FPA  EQU   RTM2PMKA
RTM2CCA  EQU   RTM2PMKA
RTM2SPVA EQU   RTM2MWPA
RTM2WATA EQU   RTM2MWPA
RTM2MCKA EQU   RTM2MWPA
@NM00025 EQU   RTM2MWPA
RTM2KEYA EQU   RTM2MWPA
@NM00024 EQU   RTM2PARQ+1
@NM00023 EQU   RTM2IOBP
@NM00022 EQU   RTM2TRRC+1
@NM00021 EQU   RTM2IOFS
RTM2ERFL EQU   RTM2ERRD
RTM2MCIV EQU   RTM2ERRD
RTM2RPIV EQU   RTM2ERRD
RTM2MABD EQU   RTM2ERRD
RTM2CTS  EQU   RTM2ERRD
RTM2CLUP EQU   RTM2ERRD
@NM00020 EQU   RTM2ERRC
RTM2EAS  EQU   RTM2ERRC
RTM2PERC EQU   RTM2ERRC
RTM2SRBM EQU   RTM2ERRB
RTM2LDIS EQU   RTM2ERRB
RTM2ENRB EQU   RTM2ERRB
RTM2TYP1 EQU   RTM2ERRB
@NM00019 EQU   RTM2ERRB
RTM2PGIO EQU   RTM2ERRA
RTM2TEXC EQU   RTM2ERRA
RTM2SVCE EQU   RTM2ERRA
RTM2ABTM EQU   RTM2ERRA
RTM2SVCD EQU   RTM2ERRA
RTM2RKEY EQU   RTM2ERRA
RTM2PCHK EQU   RTM2ERRA
RTM2MCHK EQU   RTM2ERRA
RTM2TIME EQU   RTM2EEDH+20
RTM2RFSA EQU   RTM2EEDH+16
@NM00018 EQU   RTM2EEDH+14
RTM2VEQR EQU   RTM2RSR2
RTM2PGFX EQU   RTM2RSR2
RTM2FLSQ EQU   RTM2RSR2
RTM2FSQA EQU   RTM2RSR2
RTM2NUCL EQU   RTM2RSR2
RTM2SPER EQU   RTM2RSR2
RTM2INTC EQU   RTM2RSR2
RTM2OFLN EQU   RTM2RSR2
RTM2CHNG EQU   RTM2RSR1
RTM2MSER EQU   RTM2RSR1
@NM00017 EQU   RTM2RSR1
RTM2CPID EQU   RTM2EEDH+10
RTM2TERR EQU   RTM2MCHD
RTM2SOFT EQU   RTM2MCHD
RTM2INSF EQU   RTM2MCHD
RTM2ACR  EQU   RTM2MCHD
RTM2SCK  EQU   RTM2MCHD
RTM2PSWU EQU   RTM2MCHD
RTM2REGU EQU   RTM2MCHD
RTM2SKYF EQU   RTM2MCHD
@NM00016 EQU   RTM2MCHS
RTM2RSRF EQU   RTM2MCHS
RTM2RSRC EQU   RTM2MCHS
RTM2INVP EQU   RTM2MCHS
RTM2TSVL EQU   RTM2MCHS
RTM2RCDF EQU   RTM2MCHS
RTM2SRVL EQU   RTM2MCHS
RTM2SCKE EQU   RTM2STCK+4
RTM2SCKB EQU   RTM2STCK
RTM2TRAN EQU   RTM2AEC1+4
RTM2IPC1 EQU   RTM2ICD1
RTM2IMC1 EQU   RTM2ICD1
RTM2IPR1 EQU   RTM2ICD1
@NM00015 EQU   RTM2INC1
@NM00014 EQU   RTM2ILC1
@NM00013 EQU   RTM2ILC1
@NM00012 EQU   RTM2AEC1
@NM00011 EQU   RTM2NXT1
@NM00010 EQU   RTM2EPSW+3
RTM2SGN1 EQU   RTM2INT1
RTM2EXP1 EQU   RTM2INT1
RTM2DEC1 EQU   RTM2INT1
RTM2FPO1 EQU   RTM2INT1
RTM2CC1  EQU   RTM2INT1
@NM00009 EQU   RTM2INT1
RTM2PGM1 EQU   RTM2MWP1
RTM2WAT1 EQU   RTM2MWP1
RTM2MCK1 EQU   RTM2MWP1
RTM2ECT1 EQU   RTM2MWP1
RTM2KEY1 EQU   RTM2MWP1
RTM2TRM1 EQU   RTM2EMK1
RTM2EAM1 EQU   RTM2EMK1
@NM00008 EQU   RTM2EMK1
RTM2PER1 EQU   RTM2EMK1
@NM00007 EQU   RTM2EMK1
RTM2ER15 EQU   RTM2EREG+60
RTM2ER14 EQU   RTM2EREG+56
RTM2ER13 EQU   RTM2EREG+52
RTM2ER12 EQU   RTM2EREG+48
RTM2ER11 EQU   RTM2EREG+44
RTM2ER10 EQU   RTM2EREG+40
RTM2ER9  EQU   RTM2EREG+36
RTM2ER8  EQU   RTM2EREG+32
RTM2ER7  EQU   RTM2EREG+28
RTM2ER6  EQU   RTM2EREG+24
RTM2ER5  EQU   RTM2EREG+20
RTM2ER4  EQU   RTM2EREG+16
RTM2ER3  EQU   RTM2EREG+12
RTM2ER2  EQU   RTM2EREG+8
RTM2ER1  EQU   RTM2EREG+4
RTM2ER0  EQU   RTM2EREG
RTM2CT   EQU   RTM2WA+56
RTM2VRBT EQU   RTM2WA+52
RTM2TCBT EQU   RTM2WA+48
RTM2SFWA EQU   RTM2WA+32
@NM00006 EQU   RTM2CCF
RTM2EOT  EQU   RTM2CCF
RTM2EOM  EQU   RTM2CCF
RTM2R0DP EQU   RTM2CCF
RTM2LGTH EQU   RTM2RT2D+1
RTM2SPID EQU   RTM2RT2D
RTM2ADDR EQU   RTM2DESC+4
RTM2ID   EQU   RTM2DESC
RMPLDCBL EQU   RMPL+20
RMPLRBPA EQU   RMPL+12
RMPLASCB EQU   RMPL+4
RMPLASID EQU   RMPL+2
RMPLFLG2 EQU   RMPL+1
@NM00005 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
RMPLTERM EQU   RMPLFLG1
RMPLTYPE EQU   RMPLFLG1
SNPHDRA  EQU   SNPPARMS+20
SNPSTOR  EQU   SNPPARMS+16
SNPTCBA  EQU   SNPPARMS+12
SNPDCB   EQU   SNPPARMS+8
@NM00004 EQU   SNPPARMS+7
@NM00003 EQU   SNPPDATA
SNPSPLS  EQU   SNPPDATA
SNPPSW   EQU   SNPPDATA
SNPJPA   EQU   SNPPDATA
SNPLPA   EQU   SNPPDATA
SNPREGS  EQU   SNPPDATA
SNPSAVE2 EQU   SNPPDATA
SNPSAVE  EQU   SNPPDATA
@NM00002 EQU   SNPSDAT1
SNPERR   EQU   SNPSDAT1
SNPIO    EQU   SNPSDAT1
SNPDM    EQU   SNPSDAT0
SNPQCB   EQU   SNPSDAT0
SNPCB    EQU   SNPSDAT0
SNPTRT   EQU   SNPSDAT0
SNPSWA   EQU   SNPSDAT0
SNPLSQA  EQU   SNPSDAT0
SNPSQA   EQU   SNPSDAT0
SNPNUC   EQU   SNPSDAT0
@NM00001 EQU   SNPPARMS+2
SNPHDR   EQU   SNPFLAG
SNPSLIST EQU   SNPFLAG
SNPTCB   EQU   SNPFLAG
SNPID    EQU   SNPFLAG
SNPABEND EQU   SNPFLAG
SNPVS2EN EQU   SNPFLAG
SNPVS2   EQU   SNPFLAG
SNPSNAP  EQU   SNPFLAG
SNPIDENT EQU   SNPPARMS
@NM00179 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00178 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00177 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00176 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00175 EQU   FLCFSA
@NM00174 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00173 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00172 EQU   FLCIOA
@NM00171 EQU   FLCMCLA+15
@NM00170 EQU   FLCMCLA+14
@NM00169 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00168 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00167 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00166 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00165 EQU   FLCPER
@NM00164 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00163 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00162 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00161 EQU   FLCPIILC
@NM00160 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00159 EQU   FLCSVILC
@NM00158 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00157 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00156 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00116 EQU   @RC00115
@RF00181 EQU   @RC00174
@RC00239 EQU   @RC00238
@RC00121 EQU   @RC00116
@RC00117 EQU   @RC00116
@RC00240 EQU   @RC00239
@RC00118 EQU   @RC00117
@RC00122 EQU   @RC00121
@ENDDATA EQU   *
         END   IEAVTAS1,(C'PLS1343',0701,77327)
