         TITLE 'IEAVTAS3 - CONTROL RECOVERY'
IEAVTAS3 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVTAS3  78.206'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @10,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@10                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0098
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR NON-RECURSIVE ENTRIES, THIS ROUTINES ATTEMPTS TO SET UP   */
*   /* FOR RETRY IF RETRY IS REQUESTED. IF RETRY IS NOT POSSIBLE     */
*   /* (RETRY RB CANNOT BE LOCATED, ENTRY FOR TERM EXITS ONLY),      */
*   /* PERCOLATION IS FORCED. IF NO RETRY, THE SDWA IS FREED AND     */
*   /* FLAGS ARE RESET TO CORRECTLY INDICATE PROCESSING COMPLETED.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0099
*   IF RTM2RETR=OFF THEN            /* NOT ENTRY TO SET UP FOR RETRY
*                                                            @G33SPHW*/
         TM    RTM2RETR(RTM2PTR),B'01000000'                       0099
         BNZ   @RF00099                                            0099
*     IF RTM2AS1R=OFF THEN          /* ENTRY FOR PSEUDO RETRY INTO 0100
*                                      AS1                           */
         TM    RTM2AS1R(RTM2PTR),B'00000100'                       0100
         BNZ   @RF00100                                            0100
*       IF RTM2AS3R=OFF THEN        /* NOT RECURSION WHICH IS HANDLED
*                                      IN THIS ROUTINE               */
         TM    RTM2AS3R(RTM2PTR),B'00000001'                       0101
         BNZ   @RF00101                                            0101
*         DO;                                                      0102
*           IF RTM2RCDE=SDWARETY&RTM2CLUP=OFF THEN/* RETRY REQUESTED
*                                      AND ALLOWED                   */
         CLI   RTM2RCDE(RTM2PTR),4                                 0103
         BNE   @RF00103                                            0103
         TM    RTM2CLUP(RTM2PTR),B'10000000'                       0103
         BNZ   @RF00103                                            0103
*             DO;                                                  0104
*               RTM2RTYS=ON;        /* INDICATE RETRY PROCESSING     */
         OI    RTM2RTYS(RTM2PTR),B'01000000'                       0105
*               RTM2TRRA=ADDR(RECURSE);/* INITIALIZE RECURSION     0106
*                                      ADDRESS                       */
*                                                                  0106
         L     @12,@CV00066                                        0106
         ST    @12,RTM2TRRA(,RTM2PTR)                              0106
*               /*****************************************************/
*               /*                                                   */
*               /* AN ATTEMPT IS MADE TO LOCATE THE RETRY RB. IF NO  */
*               /* RB IS LOCATED, NO FURTHER RETRY PROCESSING IS DONE*/
*               /* AND CONTINUE WITH TERMINATION IS FORCED. FOR      */
*               /* (E)STAE EXITS THE RETRY RB IS THE ONE POINTED TO  */
*               /* FROM THE SCB. FOR ESTAR EXITS, THE RETRY RB IS THE*/
*               /* OLDEST RB ON THE QUEUE. FOR (E)STAI EXITS THE     */
*               /* RETRY RB MUST BE A PRB. IF THERE IS A PRB WHOSE   */
*               /* RBLINK FIELD POINTS TO AN RTM2 SVRB, THAT IS THE  */
*               /* FIRST CHOICE. IF THERE IS NO PREVIOUS RTM2 RB ON  */
*               /* THE QUEUE, THE RETRY RB IS THE NEWEST PRB OLDER   */
*               /* THAN THE OLDEST NON-PRB.                          */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0107
*               DO;                 /* START OF FINDRB               */
*                 IF SCBSTAI=OFF&SCBSTAR=OFF THEN/* (E)STAE SCB      */
         TM    SCBSTAI(SCBPTR),B'11000000'                         0108
         BNZ   @RF00108                                            0108
*                   RTM2RYRB=SCBOWNRA;/* RETRY RB IS RB WHICH ISSUED
*                                      STAE                          */
         L     @12,SCBOWNRA-1(,SCBPTR)                             0109
         LA    @12,0(,@12)                                         0109
         ST    @12,RTM2RYRB(,RTM2PTR)                              0109
*                 ELSE              /* NOT (E)STAE SCB               */
*                   IF SCBSTAR=ON THEN/* ESTAR SCB                   */
         B     @RC00108                                            0110
@RF00108 TM    SCBSTAR(SCBPTR),B'01000000'                         0110
         BNO   @RF00110                                            0110
*                     RTM2RYRB=RTM2STAR;/* ACCESS ESTAR RELATED RB   */
*                                                                  0111
         L     @12,RTM2STAR(,RTM2PTR)                              0111
         ST    @12,RTM2RYRB(,RTM2PTR)                              0111
*                 /***************************************************/
*                 /*                                                 */
*                 /* (E)STAI RETRY                                   */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0112
*                   ELSE                                           0112
*                     DO;                                          0112
         B     @RC00110                                            0112
@RF00110 DS    0H                                                  0113
*                       RESPECIFY                                  0113
*                        (R4,                                      0113
*                         R2) RESTRICTED;                          0113
*                       R4=RTM2VRBC->RBLINKB;/* START WITH CURRENT RB*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0114
         L     R4,RBLINKB-1(,@12)                                  0114
         LA    R4,0(,R4)                                           0114
*                       R2=NONE;                                   0115
         SLR   R2,R2                                               0115
*                       RTM2RYRB=NONE;                             0116
*                                                                  0116
         SLR   @12,@12                                             0116
         ST    @12,RTM2RYRB(,RTM2PTR)                              0116
*                       /*********************************************/
*                       /*                                           */
*                       /* SCAN FOR ELIGIBLE PRB                     */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0117
*                       DO WHILE(R4^=RTM2TCBC&RTM2RYRB=NONE);/* SCAN
*                                      ENTIRE QUEUE UNLESS STA EXIT
*                                      RB FOUND                      */
         B     @DE00117                                            0117
@DL00117 DS    0H                                                  0118
*                         IF RBFTP='000'B THEN/* RB IS PRB           */
         TM    RBFTP(R4),B'11100000'                               0118
         BNZ   @RF00118                                            0118
*                           IF RBTCBNXT^=ON THEN                   0119
         TM    RBTCBNXT(R4),B'10000000'                            0119
         BO    @RF00119                                            0119
*                             IF EVAL(RBLINKB-LENGTH(RBPREFIX))->  0120
*                                 RBABEND=ON THEN/* PREVIOUS RB IS 0120
*                                      RTM2 SVRB                     */
         L     @12,RBLINKB-1(,R4)                                  0120
         LA    @12,0(,@12)                                         0120
         SL    @12,@CF00472                                        0120
         TM    RBABEND(@12),B'00100000'                            0120
         BNO   @RF00120                                            0120
*                               RTM2RYRB=R4;/* RETRY RB FOUND        */
         ST    R4,RTM2RYRB(,RTM2PTR)                               0121
*                             ELSE  /* PRB BUT NOT EXIT RB           */
*                               IF R2=NONE THEN/* NEWEST RB IN THIS
*                                      GROUP                         */
         B     @RC00120                                            0122
@RF00120 LTR   R2,R2                                               0122
         BNZ   @RF00122                                            0122
*                                 R2=R4;/* SAVE RB ADDRESS           */
         LR    R2,R4                                               0123
*                               ELSE                               0124
*                                 ; /* PREVIOUS RB WAS PRB - IGNORE
*                                      THIS ONE                      */
@RF00122 DS    0H                                                  0125
*                           ELSE                                   0125
*                             IF R2=NONE THEN/* TEST IF NEWEST PRB   */
         B     @RC00119                                            0125
@RF00119 LTR   R2,R2                                               0125
         BNZ   @RF00125                                            0125
*                               R2=R4;/* SAVE PRB ADDRESS            */
         LR    R2,R4                                               0126
*                             ELSE                                 0127
*                               ;                                  0127
@RF00125 DS    0H                                                  0128
*                         ELSE      /* NOT PRB                       */
*                           R2=NONE;/* CLEAR PTR - OLDER NON-PRB     */
         B     @RC00118                                            0128
@RF00118 SLR   R2,R2                                               0128
*                         R4=RBLINKB;/* UPDATE RB POINTER            */
@RC00118 L     @12,RBLINKB-1(,R4)                                  0129
         LA    @12,0(,@12)                                         0129
         LR    R4,@12                                              0129
*                       END;        /* END OF RB SCAN                */
@DE00117 C     R4,RTM2TCBC(,RTM2PTR)                               0130
         BE    @DC00117                                            0130
         L     @12,RTM2RYRB(,RTM2PTR)                              0130
         LTR   @12,@12                                             0130
         BZ    @DL00117                                            0130
@DC00117 DS    0H                                                  0131
*                       IF RTM2RYRB=NONE THEN/* STA EXIT RB NOT FOUND*/
         SLR   @12,@12                                             0131
         C     @12,RTM2RYRB(,RTM2PTR)                              0131
         BNE   @RF00131                                            0131
*                         IF R2^=NONE THEN/* PRB OLDER THAN OLDEST 0132
*                                      NON-PRB FOUND                 */
         CR    R2,@12                                              0132
         BE    @RF00132                                            0132
*                           RTM2RYRB=R2;/* THIS IS RETRY RB          */
         ST    R2,RTM2RYRB(,RTM2PTR)                               0133
*                         ELSE      /* OLDEST RB IS NOT PRB          */
*                           RTM2RCDE=SDWACWT;/* RETRY NOT POSSIBLE   */
         B     @RC00132                                            0134
@RF00132 MVI   RTM2RCDE(RTM2PTR),X'00'                             0134
*                     END;                                         0135
@RC00132 DS    0H                                                  0135
@RF00131 DS    0H                                                  0136
*                 RESPECIFY                                        0136
*                  (R4,                                            0136
*                   R2) UNRESTRICTED;/* RELEASE PTRS USED FOR SCAN   */
@RC00110 DS    0H                                                  0136
@RC00108 DS    0H                                                  0137
*               END;                /* END OF FINDRB                 */
*               IF RTM2RCDE=SDWARETY THEN/* RETRY RB FOUND - RETRY 0138
*                                      CONTINUES                     */
         CLI   RTM2RCDE(RTM2PTR),4                                 0138
         BNE   @RF00138                                            0138
*                 DO;                                              0139
*                                                                  0139
*                   /*************************************************/
*                   /*                                               */
*                   /* RBPRGE PERFORMS PURGES NEEDED BEFORE RETRY. IT*/
*                   /* INCLUDES CLOSEDS TO CLOSE EMBEDDED DCBS. IT   */
*                   /* THEN PURGES ASYNCHRONOUS EXITS, TQES, AND     */
*                   /* ENQ'D RESOURCES FOR ESTAR RETRY. FOR          */
*                   /* (E)STAE/STAE RETRY, PAGEPRGE IS INCLUDED TO   */
*                   /* PURGE PAGING I/O FOR INTERVENING RBS. FOR STA */
*                   /* EXITS, WTORS ARE PURGED IF ANY RBS ARE TO BE  */
*                   /* PURGED. THE TYPE 1 MESSAGE TABLE IS PURGED.   */
*                   /* THEN RBTYPE IS INCLUDED TO SET ALL INTERVENING*/
*                   /* RBS UP FOR RETRY.                             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0140
*                   DO;             /* START OF RBPRGE               */
*                                                                  0140
*                     /***********************************************/
*                     /*                                             */
*                     /* SET UP RMPL FOR TASK RECOVERY PURGES        */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0141
*                     RMPLRCOV=ON;  /* TASK RECOVERY IS CALLER       */
*                     RMPLTYPE=ON;  /* INDICATE ABNORMAL TERMINATION
*                                                            @YM04241*/
         LA    @12,712                                             0142
         ALR   @12,RTM2PTR                                         0142
         OI    RMPLRCOV(@12),B'10001000'                           0142
*                     RMPLTCBA=RTM2TCBC;/* PURGES ARE FOR CURRENT TCB*/
         L     @11,RTM2TCBC(,RTM2PTR)                              0143
         ST    @11,RMPLTCBA(,@12)                                  0143
*                     IF RMPLTCBA=RMPLTCBA->TCBJSTCA THEN/* CURRENT
*                                      TCB IS JOBSTEP                */
         L     @06,TCBJSTCA-1(,@11)                                0144
         LA    @06,0(,@06)                                         0144
         CR    @11,@06                                             0144
         BNE   @RF00144                                            0144
*                       RMPLJST=ON;                                0145
         OI    RMPLJST(@12),B'00000100'                            0145
*                     ELSE          /* CURRENT TCB IS NOT JOBSTEP    */
*                       RMPLJST=OFF;                               0146
         B     @RC00144                                            0146
@RF00144 NI    RMPLJST+712(RTM2PTR),B'11111011'                    0146
*                     RESPECIFY                                    0147
*                      (R1,                                        0147
*                       R13) RESTRICTED;                           0147
@RC00144 DS    0H                                                  0148
*                     R1=ADDR(RTM2RMPS);                           0148
         LA    R1,RTM2RMPS(,RTM2PTR)                               0148
*                     R13=ADDR(RTM2RMSA);                          0149
         LA    R13,RTM2RMSA(,RTM2PTR)                              0149
*                     IF SCBSTAR=ON THEN/* ESTAR RETRY               */
         TM    SCBSTAR(SCBPTR),B'01000000'                         0150
         BNO   @RF00150                                            0150
*                       DO;         /* SPECIAL PURGES FOR ESTAR      */
*                         CALL DATAMGR;/* CLOSE ALL DATASETS         */
         L     @12,CVTPTR(,RTM2PTR)                                0152
         L     @15,CVT0TC0A(,@12)                                  0152
         BALR  @14,@15                                             0152
*                         CALL AEXITRM;/* PURGE ASYNCHRONOUS EXITS   */
         L     @12,CVTPTR(,RTM2PTR)                                0153
         L     @15,CVTDQIQE(,@12)                                  0153
         BALR  @14,@15                                             0153
*                         CALL IEAQPGTM;/* PURGE TIMER QUEUE ELEMENTS*/
         L     @12,CVTPTR(,RTM2PTR)                                0154
         L     @12,SCVTSPTR(,@12)                                  0154
         L     @15,SCVTPGTM(,@12)                                  0154
         BALR  @14,@15                                             0154
*                         CALL IEAVENQ2;/* PURGE ENQUEUED RESOURCES  */
         L     @12,CVTPTR(,RTM2PTR)                                0155
         L     @15,CVTRENQ(,@12)                                   0155
         BALR  @14,@15                                             0155
*                       END;        /* END SPECIAL ESTAR PURGES      */
*                     ELSE          /* NOT ESTAR                     */
*                       DO;                                        0157
*                                                                  0157
         B     @RC00150                                            0157
@RF00150 DS    0H                                                  0158
*                         /*******************************************/
*                         /*                                         */
*                         /* CLOSEDS LOCATES AND CLOSES DATASETS     */
*                         /* EMBEDDED IN CODE DESCRIBED BY A PRB. IT */
*                         /* ALSO UPDATES THE IOB RESTORE CHAIN TO   */
*                         /* REMOVE IOBS ASSOCIATED WITH CLOSED      */
*                         /* DATASETS. RBS BETWEEN THE CURRENT RB AND*/
*                         /* THE RETRY RB ARE CHECKED FOR PRBS. FOR  */
*                         /* EACH PRB FOUND THE EXTENT LIST IS       */
*                         /* LOCATED AND FINDDCBS IS INCLUDED TO FIND*/
*                         /* AND CLOSE ALL DCBS ASSOCIATED WITH THIS */
*                         /* PRB.                                    */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0158
*                         ;         /* START OF CLOSEDS              */
*                         RESPECIFY                                0159
*                          (R4,     /* RB PTR                        */
*                           R9) RESTRICTED;/* EXTENT LIST PTR        */
*                         RMPLRBPP=ON;/* INDICATE DCB LIST PASSED    */
         LA    @12,712                                             0160
         ALR   @12,RTM2PTR                                         0160
         OI    RMPLRBPP(@12),B'00100000'                           0160
*                         R4=RTM2VRBC->RBLINKB;/* SET UP POINTER TO
*                                      FIRST RB                      */
         L     @11,RTM2VRBC(,RTM2PTR)                              0161
         L     R4,RBLINKB-1(,@11)                                  0161
         LA    R4,0(,R4)                                           0161
*                         RMPLDCBL=ADDR(RTM2DCBA);/* SET UP PTR TO 0162
*                                      DCB LIST                      */
*                                                                  0162
         LA    @11,RTM2DCBA(,RTM2PTR)                              0162
         ST    @11,RMPLDCBL(,@12)                                  0162
*                         /*******************************************/
*                         /*                                         */
*                         /* SCAN RBS TO RETRY RB                    */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0163
*                         DO WHILE(R4^=RTM2RYRB);                  0163
         B     @DE00163                                            0163
@DL00163 DS    0H                                                  0164
*                           R9=NONE;/* ASSUME NO EXTENT LIST         */
         SLR   R9,R9                                               0164
*                           IF RBFTP='000'B/* PRB                    */
*                               &RBCDE1->CDNIC=OFF&RBCDE1^=NONE THEN
         TM    RBFTP(R4),B'11100000'                               0165
         BNZ   @RF00165                                            0165
         L     @12,RBCDE1-1(,R4)                                   0165
         LA    @12,0(,@12)                                         0165
         TM    CDNIC(@12),B'01000000'                              0165
         BNZ   @RF00165                                            0165
         LTR   @12,@12                                             0165
         BZ    @RF00165                                            0165
*                                   /* CDE ENTRY PRESENT             */
*                             IF RBCDE1->CDMIN=OFF THEN/* MAJOR CDE  */
         TM    CDMIN(@12),B'00000100'                              0166
         BNZ   @RF00166                                            0166
*                               IF RBCDE1->CDXLE=ON THEN/* EXTENT  0167
*                                      LIST BUILT                    */
         TM    CDXLE(@12),B'00100000'                              0167
         BNO   @RF00167                                            0167
*                                 R9=RBCDE1->CDXLMJP;/* LOCATE EXTENT
*                                      LIST                          */
         L     R9,CDXLMJP(,@12)                                    0168
*                               ELSE                               0169
*                                 ; /* NO EXTENT LIST                */
@RF00167 DS    0H                                                  0170
*                             ELSE  /* MINOR CDE                     */
*                               IF RBCDE1->CDXLMJP->CDXLE=ON THEN/*
*                                      MAJOR CDE HAS EXTENT LIST     */
         B     @RC00166                                            0170
@RF00166 L     @12,RBCDE1-1(,R4)                                   0170
         L     @12,CDXLMJP(,@12)                                   0170
         TM    CDXLE(@12),B'00100000'                              0170
         BNO   @RF00170                                            0170
*                                 R9=RBCDE1->CDXLMJP->CDXLMJP;/*   0171
*                                      LOCATE EXTENT LIST FOR MAJOR
*                                      CDE                           */
         L     R9,CDXLMJP(,@12)                                    0171
*                           IF R9^=NONE THEN/* EXTENT LIST FOUND     */
*                                                                  0172
@RF00170 DS    0H                                                  0172
@RC00166 DS    0H                                                  0172
@RF00165 LTR   R9,R9                                               0172
         BZ    @RF00172                                            0172
*                             /***************************************/
*                             /*                                     */
*                             /* FINDDCBS LOCATES AND CLOSES ALL OPEN*/
*                             /* DATASETS EMBEDDED IN THE CODE FOR A */
*                             /* GIVEN PRB. IT EXAMINES EACH DEB ON  */
*                             /* THE TCB DEB QUEUE TO DETERMINE      */
*                             /* WHETHER ITS DCB FALLS WITHIN ANY    */
*                             /* EXTENT FOR THIS RB. IF IT DOES,     */
*                             /* FINDIOB IS CALLED TO REMOVE RELATED */
*                             /* IOBS FROM THE RESTORE CHAIN. THE    */
*                             /* DATA MANAGEMENT RESOURCE MANAGER IS */
*                             /* INVOKED TO CLOSE THE DATASET.       */
*                             /*                                     */
*                             /***************************************/
*                                                                  0173
*                             DO;   /* START OF FINDDCBS             */
*                               RESPECIFY                          0174
*                                (R11,/* PTR TO DEB                  */
*                                 R2) RESTRICTED;/* LOOP CONTROL   0174
*                                      VARIABLE                      */
*                               ESAGLREC=ON;/* SET RECURSION CONTROL */
         L     @12,RTM2VRBC(,RTM2PTR)                              0175
         OI    ESAGLREC+96(@12),B'00010000'                        0175
*                               DO; /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(DEB,IEAVTA
*                                      S3(FINDDCBS))                 */
*                                 RFY                              0177
*                                  (GPR11P,                        0177
*                                   GPR12P,                        0177
*                                   GPR13P,                        0177
*                                   GPR14P) RSTD;                  0177
*                                 GPR13P=PSALITA;/* ADDRESS OF LOCK
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0178
*                                 GEN(LM GPR11P,GPR13P,576(GPR13P));
         LM GPR11P,GPR13P,576(GPR13P)
*                                   /* LOAD LOCKWORD, CLHT AND ENTRY
*                                      ADRS.                         */
*                                 GEN(BALR GPR14P,GPR13P);/* BALR TO
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                                 RFY                              0181
*                                  (GPR11P,                        0181
*                                   GPR12P,                        0181
*                                   GPR13P,                        0181
*                                   GPR14P) UNRSTD;                0181
*                               END;/* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(DEB,IEAVTA
*                                      S3(FINDDCBS))                 */
*                               ESAGLREC=OFF;/* RELEASE RECURSION  0183
*                                      CONTROL                       */
         L     @12,RTM2VRBC(,RTM2PTR)                              0183
         NI    ESAGLREC+96(@12),B'11101111'                        0183
*                               R11=TCBDEB;/* LOCATE FIRST DEB       */
*                                                                  0184
         L     @12,TCBPTR(,RTM2PTR)                                0184
         L     R11,TCBDEB(,@12)                                    0184
*                               /*************************************/
*                               /*                                   */
*                               /* CHECK EVERY DEB ON THE QUEUE      */
*                               /*                                   */
*                               /*************************************/
*                                                                  0185
*                               DO WHILE(R11^=NONE);               0185
         B     @DE00185                                            0185
@DL00185 DS    0H                                                  0186
*                                 RTM2DCBA=NONE;/* NO DCB FOUND      */
         SLR   @12,@12                                             0186
         ST    @12,RTM2DCBA(,RTM2PTR)                              0186
*                                 DO R2=1 TO XTLNRFAC WHILE(RTM2DCBA=
*                                       NONE);                     0187
         LA    R2,1                                                0187
         B     @DE00187                                            0187
@DL00187 L     @12,RTM2DCBA(,RTM2PTR)                              0187
         LTR   @12,@12                                             0187
         BNZ   @DC00187                                            0187
*                                   IF DEBDCBB>=XTLMSBAA(R2)&DEBDCBB<
*                                       XTLMSBAA(R2)+XTLMSBLN(R2) THEN
         L     @12,DEBDCBB-1(,R11)                                 0188
         LA    @12,0(,@12)                                         0188
         LR    @08,R2                                              0188
         SLA   @08,2                                               0188
         LA    @06,XTLMSBLA(,R9)                                   0188
         L     @15,XTLNRFAC(,R9)                                   0188
         SLA   @15,2                                               0188
         ALR   @06,@15                                             0188
         AL    @06,@CF03717                                        0188
         L     @06,XTLMSBAA(@08,@06)                               0188
         CR    @12,@06                                             0188
         BL    @RF00188                                            0188
         L     @08,XTLMSBLN-5(@08,R9)                              0188
         LA    @08,0(,@08)                                         0188
         ALR   @06,@08                                             0188
         CR    @12,@06                                             0188
         BNL   @RF00188                                            0188
*                                    /* DCB FOR THIS DEB WITHIN    0189
*                                      PROGRAM                       */
*                                    RTM2DCBA=DEBDCBB;/* SAVE DCB  0189
*                                      ADDRESS                       */
         ST    @12,RTM2DCBA(,RTM2PTR)                              0189
*                                 END;/* END OF EXTENT LIST SCAN     */
@RF00188 AL    R2,@CF00092                                         0190
@DE00187 C     R2,XTLNRFAC(,R9)                                    0190
         BNH   @DL00187                                            0190
@DC00187 DS    0H                                                  0191
*                                 IF RTM2DCBA^=NONE THEN/* EMBEDDED
*                                      DCB FOUND                     */
         L     @12,RTM2DCBA(,RTM2PTR)                              0191
         LTR   @12,@12                                             0191
         BZ    @RF00191                                            0191
*                                   DO;                            0192
*                                    R13=ADDR(RTM2RMSA);           0193
         LA    R13,RTM2RMSA(,RTM2PTR)                              0193
*                                    CALL FINDIOB;/* DEQUEUE IOBS FOR
*                                      THIS DCB                      */
         BAL   @14,FINDIOB                                         0194
*                                    ESAGLREC=ON;/* SET RECURSION  0195
*                                      CONTROL                       */
         L     @12,RTM2VRBC(,RTM2PTR)                              0195
         OI    ESAGLREC+96(@12),B'00010000'                        0195
*                                    DO;/* SETLOCK (RELEASE)       0196
*                                      TYPE(LOCAL) RELATED(DEB,IEAVTA
*                                      S3(FINDDCBS))                 */
*                                     RFY                          0197
*                                      (GPR11P,                    0197
*                                       GPR12P,                    0197
*                                       GPR13P,                    0197
*                                       GPR14P) RSTD;              0197
*                                     GPR13P=PSALITA;/* ADDRESS OF 0198
*                                      LOCK INTERFACE TABLE.         */
         L     GPR13P,PSALITA                                      0198
*                                     GEN(LM GPR11P,GPR13P,588(GPR13P))
*                                         ;/* LOAD LOCKWORD, CLHT AND
*                                      ENTRY ADRS.                   */
         LM GPR11P,GPR13P,588(GPR13P)
*                                     GEN(BALR GPR14P,GPR13P);/* BALR
*                                      TO SETLOCK RTN.               */
         BALR GPR14P,GPR13P
*                                     RFY                          0201
*                                      (GPR11P,                    0201
*                                       GPR12P,                    0201
*                                       GPR13P,                    0201
*                                       GPR14P) UNRSTD;            0201
*                                    END;/* SETLOCK (RELEASE)      0202
*                                      TYPE(LOCAL) RELATED(DEB,IEAVTA
*                                      S3(FINDDCBS))                 */
*                                    ESAGLREC=OFF;/* RELEASE       0203
*                                      RECURSION CONTROL             */
         L     @12,RTM2VRBC(,RTM2PTR)                              0203
         NI    ESAGLREC+96(@12),B'11101111'                        0203
*                                    R13=ADDR(RTM2RMSA);           0204
         LA    R13,RTM2RMSA(,RTM2PTR)                              0204
*                                    CALL DATAMGR;/* INVOKE TASK   0205
*                                      CLOSE                         */
         L     @12,CVTPTR(,RTM2PTR)                                0205
         L     @15,CVT0TC0A(,@12)                                  0205
         BALR  @14,@15                                             0205
*                                    ESAGLREC=ON;/* SET RECURSION  0206
*                                      CONTROL                       */
         L     @12,RTM2VRBC(,RTM2PTR)                              0206
         OI    ESAGLREC+96(@12),B'00010000'                        0206
*                                    DO;/* SETLOCK (OBTAIN)        0207
*                                      MODE(UNCOND) TYPE(LOCAL) RELAT
*                                      ED(DEB,IEAVTAS3(FINDDCBS))    */
*                                     RFY                          0208
*                                      (GPR11P,                    0208
*                                       GPR12P,                    0208
*                                       GPR13P,                    0208
*                                       GPR14P) RSTD;              0208
*                                     GPR13P=PSALITA;/* ADDRESS OF 0209
*                                      LOCK INTERFACE TABLE.         */
         L     GPR13P,PSALITA                                      0209
*                                     GEN(LM GPR11P,GPR13P,576(GPR13P))
*                                         ;/* LOAD LOCKWORD, CLHT AND
*                                      ENTRY ADRS.                   */
         LM GPR11P,GPR13P,576(GPR13P)
*                                     GEN(BALR GPR14P,GPR13P);/* BALR
*                                      TO SETLOCK RTN.               */
         BALR GPR14P,GPR13P
*                                     RFY                          0212
*                                      (GPR11P,                    0212
*                                       GPR12P,                    0212
*                                       GPR13P,                    0212
*                                       GPR14P) UNRSTD;            0212
*                                    END;/* SETLOCK (OBTAIN)       0213
*                                      MODE(UNCOND) TYPE(LOCAL) RELAT
*                                      ED(DEB,IEAVTAS3(FINDDCBS))    */
*                                    ESAGLREC=OFF;/* RELEASE       0214
*                                      RECURSION CONTROL             */
         L     @12,RTM2VRBC(,RTM2PTR)                              0214
         NI    ESAGLREC+96(@12),B'11101111'                        0214
*                                    R11=TCBDEB;/* PREPARE TO START
*                                      SEARCH OF DEB QUEUE AGAIN     */
         L     @12,TCBPTR(,RTM2PTR)                                0215
         L     R11,TCBDEB(,@12)                                    0215
*                                   END;                           0216
*                                 ELSE/* NO EMBEDDED DCBS WERE FOUND */
*                                   R11=DEBDEBB;/* LOCATE NEXT DEB   */
         B     @RC00191                                            0217
@RF00191 L     @12,DEBDEBB-1(,R11)                                 0217
         LA    @12,0(,@12)                                         0217
         LR    R11,@12                                             0217
*                               END;/* END OF DEBSCAN                */
@RC00191 DS    0H                                                  0218
@DE00185 LTR   R11,R11                                             0218
         BNZ   @DL00185                                            0218
*                               ESAGLREC=ON;/* SET RECURSION CONTROL */
         L     @12,RTM2VRBC(,RTM2PTR)                              0219
         OI    ESAGLREC+96(@12),B'00010000'                        0219
*                               DO; /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(DEB,IEAVTAS3(FINDDCBS)
*                                      )                             */
*                                 RFY                              0221
*                                  (GPR11P,                        0221
*                                   GPR12P,                        0221
*                                   GPR13P,                        0221
*                                   GPR14P) RSTD;                  0221
*                                 GPR13P=PSALITA;/* ADDRESS OF LOCK
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0222
*                                 GEN(LM GPR11P,GPR13P,588(GPR13P));
         LM GPR11P,GPR13P,588(GPR13P)
*                                   /* LOAD LOCKWORD, CLHT AND ENTRY
*                                      ADRS.                         */
*                                 GEN(BALR GPR14P,GPR13P);/* BALR TO
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                                 RFY                              0225
*                                  (GPR11P,                        0225
*                                   GPR12P,                        0225
*                                   GPR13P,                        0225
*                                   GPR14P) UNRSTD;                0225
*                               END;/* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(DEB,IEAVTAS3(FINDDCBS)
*                                      )                             */
*                               ESAGLREC=OFF;/* RELEASE RECURSION  0227
*                                      CONTROL                       */
         L     @12,RTM2VRBC(,RTM2PTR)                              0227
         NI    ESAGLREC+96(@12),B'11101111'                        0227
*                               R13=ADDR(RTM2RMSA);                0228
         LA    R13,RTM2RMSA(,RTM2PTR)                              0228
*                               RESPECIFY                          0229
*                                (R11,                             0229
*                                 R2) UNRESTRICTED;                0229
*                             END;  /* END OF FINDDCBS               */
*                           IF RBFTP='110'B/* SVRB           @ZA00094*/
*                               &RBPMSVRB=ON THEN/* PROGRAM MANAGER
*                                      SVRB                  @ZA00094*/
*                                                                  0231
@RF00172 TM    RBFTP(R4),B'11000000'                               0231
         BNO   @RF00231                                            0231
         TM    RBFTP(R4),B'00100000'                               0231
         BNZ   @RF00231                                            0231
         TM    RBPMSVRB(R4),B'00000001'                            0231
         BNO   @RF00231                                            0231
*                             /***************************************/
*                             /*                                     */
*                             /* PROGRAM MANAGER'S SVRB IS ON THE RB */
*                             /* QUEUE BETWEEN THE CURRENT RB AND THE*/
*                             /* RETRY RB. BEFORE THIS RB IS SENT    */
*                             /* THROUGH EXIT, IT MUST BE REMOVED    */
*                             /* FROM PROGRAM MANAGER'S QUEUES. THIS */
*                             /* WILL BE DONE BY PROGRAM MANAGER'S   */
*                             /* RESOURCE MANAGER.           @ZA00094*/
*                             /*                                     */
*                             /***************************************/
*                                                                  0232
*                             DO;   /* START OF PGMMPRGE     @ZA00094*/
*                               RMPLRBPA=R4;/* RB FIELD POINTS TO  0233
*                                      PROGRAM MANAGER'S SVRB      0233
*                                                            @ZA00094*/
         ST    R4,RMPLRBPA+712(,RTM2PTR)                           0233
*                               ESAGLREC=ON;/* SET RECURSION CONTROL
*                                                            @ZA00094*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0234
         OI    ESAGLREC+96(@12),B'00010000'                        0234
*                               DO; /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(CDE,IEAVTA
*                                      S3(PGMMPRGE))                 */
*                                 RFY                              0236
*                                  (GPR11P,                        0236
*                                   GPR12P,                        0236
*                                   GPR13P,                        0236
*                                   GPR14P) RSTD;                  0236
*                                 GPR13P=PSALITA;/* ADDRESS OF LOCK
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0237
*                                 GEN(LM GPR11P,GPR13P,576(GPR13P));
         LM GPR11P,GPR13P,576(GPR13P)
*                                   /* LOAD LOCKWORD, CLHT AND ENTRY
*                                      ADRS.                         */
*                                 GEN(BALR GPR14P,GPR13P);/* BALR TO
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                                 RFY                              0240
*                                  (GPR11P,                        0240
*                                   GPR12P,                        0240
*                                   GPR13P,                        0240
*                                   GPR14P) UNRSTD;                0240
*                               END;/* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(CDE,IEAVTA
*                                      S3(PGMMPRGE)) GET LOCK      0241
*                                                            @ZA00094*/
*                               ESAGLREC=OFF;/* FREE RECURSION     0242
*                                      CONTROL               @ZA00094*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0242
         NI    ESAGLREC+96(@12),B'11101111'                        0242
*                               R13=ADDR(RTM2RMSA);/* RESTORE SAVE 0243
*                                      AREA PTR              @ZA00094*/
         LA    R13,RTM2RMSA(,RTM2PTR)                              0243
*                               CALL IEAPPGMA;/* CALL PROG MANAGER RM
*                                                            @ZA00094*/
         L     @12,CVTPTR(,RTM2PTR)                                0244
         L     @15,CVTPARRL(,@12)                                  0244
         BALR  @14,@15                                             0244
*                               ESAGLREC=ON;/* SET RECURSION CONTROL
*                                                            @ZA00094*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0245
         OI    ESAGLREC+96(@12),B'00010000'                        0245
*                               DO; /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(CDE,IEAVTAS3(PGMMPRGE)
*                                      )                             */
*                                 RFY                              0247
*                                  (GPR11P,                        0247
*                                   GPR12P,                        0247
*                                   GPR13P,                        0247
*                                   GPR14P) RSTD;                  0247
*                                 GPR13P=PSALITA;/* ADDRESS OF LOCK
*                                      INTERFACE TABLE.              */
         L     GPR13P,PSALITA                                      0248
*                                 GEN(LM GPR11P,GPR13P,588(GPR13P));
         LM GPR11P,GPR13P,588(GPR13P)
*                                   /* LOAD LOCKWORD, CLHT AND ENTRY
*                                      ADRS.                         */
*                                 GEN(BALR GPR14P,GPR13P);/* BALR TO
*                                      SETLOCK RTN.                  */
         BALR GPR14P,GPR13P
*                                 RFY                              0251
*                                  (GPR11P,                        0251
*                                   GPR12P,                        0251
*                                   GPR13P,                        0251
*                                   GPR14P) UNRSTD;                0251
*                               END;/* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(CDE,IEAVTAS3(PGMMPRGE)
*                                      ) FREE LOCK           @ZA00094*/
*                               ESAGLREC=OFF;/* FREE RECURSION     0253
*                                      CONTROL               @ZA00094*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0253
         NI    ESAGLREC+96(@12),B'11101111'                        0253
*                               R13=ADDR(RTM2RMSA);/* RESTORE SAVE 0254
*                                      AREA PTR              @ZA00094*/
         LA    R13,RTM2RMSA(,RTM2PTR)                              0254
*                               RMPLRBPA=NONE;/* CLEAR RB FIELD    0255
*                                                            @ZA00094*/
         SLR   @12,@12                                             0255
         ST    @12,RMPLRBPA+712(,RTM2PTR)                          0255
*                             END;  /* END OF PGMMPRGE       @ZA00094*/
*                           R4=RBLINKB;/* LOCATE NEXT RB             */
@RF00231 L     @12,RBLINKB-1(,R4)                                  0257
         LA    @12,0(,@12)                                         0257
         LR    R4,@12                                              0257
*                         END;      /* END OF RB SCAN                */
@DE00163 C     R4,RTM2RYRB(,RTM2PTR)                               0258
         BNE   @DL00163                                            0258
*                         RESPECIFY                                0259
*                          (R4,                                    0259
*                           R9) UNRESTRICTED;                      0259
*                         RMPLDCBL=NONE;/* CLEAR PTR TO DCB LIST     */
         LA    @12,712                                             0260
         ALR   @12,RTM2PTR                                         0260
         SLR   @11,@11                                             0260
         ST    @11,RMPLDCBL(,@12)                                  0260
*                         RMPLRBPP=OFF;/* CLEAR FLAG THAT DCBL USED  */
         NI    RMPLRBPP(@12),B'11011111'                           0261
*                         ;         /* END OF CLOSEDS                */
*                                                                  0262
*                         /*******************************************/
*                         /*                                         */
*                         /* THIS SEGMENT PURGES PAGING I/O FOR ALL  */
*                         /* RBS BETWEEN THE RTM2 SVRB AND THE RETRY */
*                         /* RB INCLUDING ALL INTERVENING SPIE EXITS */
*                         /* FOR EACH RB.                    @ZA06785*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  0263
*                         DO;       /* START OF PAGEPRGE             */
*                           RMPLRBPP=ON;/* INDICATE PURGE IS BY RB   */
         OI    RMPLRBPP(@12),B'00100000'                           0264
*                           RESPECIFY                              0265
*                             R4 RESTRICTED;/* RESTRICT RB PTR       */
*                           R4=RTM2VRBC->RBLINKB;/* START WITH     0266
*                                      PRECEDING RB                  */
         L     @12,RTM2VRBC(,RTM2PTR)                              0266
         L     R4,RBLINKB-1(,@12)                                  0266
         LA    R4,0(,R4)                                           0266
*                           DO WHILE(R4^=RTM2RYRB);/* SCAN TO RETRY
*                                      RB                            */
         B     @DE00267                                            0267
@DL00267 DS    0H                                                  0268
*                             RMPLRBPA=R4;/* SET UP PARAMETER LIST   */
         ST    R4,RMPLRBPA+712(,RTM2PTR)                           0268
*                             CALL IEAPTERM;/* PURGE PAGING I/O      */
         L     @12,CVTPTR(,RTM2PTR)                                0269
         L     @12,SCVTSPTR(,@12)                                  0269
         L     @15,SCVTPTRM(,@12)                                  0269
         BALR  @14,@15                                             0269
*                             CALL IEAVSPIE;/* PURGE INTERVENING SPIE
*                                      EXITS FOR EACH RB     @ZA06785*/
         L     @12,CVTPTR(,RTM2PTR)                                0270
         L     @15,CVTRSPIE(,@12)                                  0270
         BALR  @14,@15                                             0270
*                             R4=RBLINKB;/* LOCATE NEXT RB           */
         L     @12,RBLINKB-1(,R4)                                  0271
         LA    @12,0(,@12)                                         0271
         LR    R4,@12                                              0271
*                           END;    /* END OF RBSCAN                 */
@DE00267 C     R4,RTM2RYRB(,RTM2PTR)                               0272
         BNE   @DL00267                                            0272
*                           RMPLRBPA=NONE;/* CLEAR RB FIELD          */
         LA    @12,712                                             0273
         ALR   @12,RTM2PTR                                         0273
         SLR   @11,@11                                             0273
         ST    @11,RMPLRBPA(,@12)                                  0273
*                           RMPLRBPP=OFF;/* OTHER PURGES ARE BY TCB  */
         NI    RMPLRBPP(@12),B'11011111'                           0274
*                           RESPECIFY                              0275
*                             R4 UNRESTRICTED;/* RELEASE RB PTR      */
*                         END;      /* END OF PAGEPRGE               */
*                         IF SCBESTAE=OFF THEN/* STA EXIT            */
*                                                                  0277
         TM    SCBESTAE(SCBPTR),B'00010000'                        0277
         BNZ   @RF00277                                            0277
*                           /*****************************************/
*                           /*                                       */
*                           /* PURGE WTORS                           */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0278
*                           CALL IEECVPRG;                         0278
         L     @12,CVTPTR(,RTM2PTR)                                0278
         L     @12,SCVTSPTR(,@12)                                  0278
         L     @15,SCVTPGWR(,@12)                                  0278
         BALR  @14,@15                                             0278
*                       END;                                       0279
@RF00277 DS    0H                                                  0280
*                     CALL IEAVTPMT;/* PURGE TYPE 1 MESSAGE TABLE    */
*                                                                  0280
@RC00150 L     @15,@CV00059                                        0280
         BALR  @14,@15                                             0280
*                     /***********************************************/
*                     /*                                             */
*                     /* RESET RMPL AFTER TASK RECOVERY PURGES       */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0281
*                     RMPLRCOV=OFF;                                0281
         NI    RMPLRCOV+712(RTM2PTR),B'11110111'                   0281
*                     RESPECIFY                                    0282
*                      (R1,                                        0282
*                       R13) UNRESTRICTED;                         0282
*                                                                  0282
*                     /***********************************************/
*                     /*                                             */
*                     /* THIS SEGMENT WILL SCAN THROUGH THE RB-S TO  */
*                     /* BE PURGED INSERTING SVC 3 (EXIT) IN THEIR   */
*                     /* PSWS, ZEROING THEIR WAIT COUNTS AND         */
*                     /* INSERTING PROPER REGISTER VALUES WHEN       */
*                     /* NECESSARY TO ENSURE THAT THE CORRECT        */
*                     /* REGISTERS ARE PASSED TO THE RETRYING RB.    */
*                     /* THIS SEGMENT WILL ALSO BE ENTERED IF AN     */
*                     /* UNRECOVERABLE ERROR OCCURS IN PRE-EXIT      */
*                     /* PROCESSING (IEAVTAS1). IN THIS CASE THE     */
*                     /* ABEND SVRB, THE RB UNDER WHICH IEAVTAS1     */
*                     /* EXECUTES, WILL BE THE RETRYING RB.          */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0283
*                     DO;           /* BEGIN RBTYPE                  */
*                       IF(SDWAPTR^=NONE&SCBESTAE=ON&SDWAUPRG=ON)| 0284
*                           RTM2AS1R=ON THEN/* USER SPECIFIED      0284
*                                      REGISTER UPDATE OR THIS IS A
*                                      PSEUDO RETRY INTO IEAVTAS1    */
         LTR   SDWAPTR,SDWAPTR                                     0284
         BZ    @GL00007                                            0284
         TM    SCBESTAE(SCBPTR),B'00010000'                        0284
         BNO   @GL00007                                            0284
         TM    SDWAUPRG(SDWAPTR),B'00001000'                       0284
         BO    @RT00284                                            0284
@GL00007 TM    RTM2AS1R(RTM2PTR),B'00000100'                       0284
         BNO   @RF00284                                            0284
@RT00284 DS    0H                                                  0285
*                         DO;                                      0285
*                           RESPECIFY                              0286
*                            (R9,                                  0286
*                             R4) RESTRICTED;                      0286
*                           IF RTM2AS1R=ON THEN/* TEST IF RETRY INTO
*                                      IEAVTAS1                      */
         TM    RTM2AS1R(RTM2PTR),B'00000100'                       0287
         BNO   @RF00287                                            0287
*                             DO;   /* SETUP FOR RETRY       @G33SPHW*/
*                               RTM2RETR=ON;/* INDICATE RETRY      0289
*                                                            @G33SPHW*/
         OI    RTM2RETR(RTM2PTR),B'01000000'                       0289
*                               R9=ADDR(RTM2PRWA->RTM2RREG);/* RETRY
*                                      REGISTERS IN RTM2RREG         */
         L     R9,RTM2PRWA(,RTM2PTR)                               0290
         LA    R9,RTM2RREG(,R9)                                    0290
*                             END;  /*                       @G33SPHW*/
*                           ELSE    /* NORMAL RETRY                  */
*                             R9=ADDR(SDWASRSV);/* UPDATED REGISTERS
*                                      ARE IN SDWA                   */
         B     @RC00287                                            0292
@RF00287 LA    R9,SDWASRSV(,SDWAPTR)                               0292
*                           RTM2UPRG=ON;/* INDICATE ALL REGS ARE TO
*                                      BE PASSED TO RETRY ROUTINE  0293
*                                                            @G33SPHW*/
@RC00287 OI    RTM2UPRG(RTM2PTR),B'01000000'                       0293
*                           RTM2RYRG=R9->RSAVE;/* COPY APPROIATE   0294
*                                      REGISTER TO RTM2WA FOR      0294
*                                      SAFEKEEPING           @G33SPHW*/
         MVI   RTM2RYRG+64(RTM2PTR),C' '                           0294
         MVC   RTM2RYRG+65(3,RTM2PTR),RTM2RYRG+64(RTM2PTR)         0294
         MVC   RTM2RYRG(64,RTM2PTR),RSAVE(R9)                      0294
*                         END;      /* END RETRY SET UP WITH USER  0295
*                                      UPDATED REGISTERS             */
*                       ELSE                                       0296
*                                                                  0296
*                         /*******************************************/
*                         /*                                         */
*                         /* THIS SEGMENT WILL INITIALIZE PARAMETER  */
*                         /* REGISTERS TO BE SENT TO THE RETRY       */
*                         /* ROUTINE. IT THEN SCANS THE RB-S TO BE   */
*                         /* PURGED AND INSERTS THE REGISTER IN THE  */
*                         /* RB-S REGISTER SAVE AREA IF NECESSARY.   */
*                         /* THE WAIT COUNT OF THE RB-S TO BE PURGED */
*                         /* AND OF THE RETRYING RB IS ZEROED. SVC 3 */
*                         /* IS INSERTED IN THE PSW-S OF THE RB-S TO */
*                         /* BE PURGED AND THE RETRY ADDRESS IS      */
*                         /* INSERTED IN THE PSW OF THE RETRYING RB. */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0296
*                         DO;       /* BEGIN PARMREGS                */
         B     @RC00284                                            0296
@RF00284 DS    0H                                                  0297
*                           RESPECIFY                              0297
*                            (R0,                                  0297
*                             R1,                                  0297
*                             R14,                                 0297
*                             R2) RESTRICTED;/* PARAMETER REGISTERS
*                                      TO RETRY RB                   */
*                           IF SDWAPTR=NONE THEN/* TEST IF THERE IS
*                                      AN SDWA                       */
         LTR   SDWAPTR,SDWAPTR                                     0298
         BNZ   @RF00298                                            0298
*                             R0=RC12;/* INDICATE SDWA NOT AVAILABLE */
         LA    R0,12                                               0299
*                           ELSE                                   0300
*                             IF SCBESTAE=ON&SDWAFREE=ON THEN/* TEST
*                                      IF USER REQUESTED TO FREE SDWA
*                                      PRIOR TO RETRY                */
         B     @RC00298                                            0300
@RF00298 TM    SCBESTAE(SCBPTR),B'00010000'                        0300
         BNO   @RF00300                                            0300
         TM    SDWAFREE(SDWAPTR),B'00000100'                       0300
         BNO   @RF00300                                            0300
*                               R0=RC20;/* SDWA IS NOT FREED AT THIS
*                                      POINT BUT WILL BE PRIOR TO  0301
*                                      RETRY                         */
         LA    R0,20                                               0301
*                             ELSE                                 0302
*                               R0=ZERO;/* AN SDWA WAS OBTAINED      */
         B     @RC00300                                            0302
@RF00300 SLR   R0,R0                                               0302
*                           IF R0=ZERO THEN/* IF AN SDWA WAS OBTAINED
*                                      AND WILL NOT BE FREED PRIOR TO
*                                      RETRY                         */
@RC00300 DS    0H                                                  0303
@RC00298 LTR   R0,R0                                               0303
         BNZ   @RF00303                                            0303
*                             R1=SDWAPTR;/* R1 CONTAINS PTR TO SDWA  */
         LR    R1,SDWAPTR                                          0304
*                           ELSE                                   0305
*                             DO;                                  0305
         B     @RC00303                                            0305
@RF00303 DS    0H                                                  0306
*                               IF SCBESTAE=ON THEN/* TEST IF ESTAE
*                                      EXIT                          */
         TM    SCBESTAE(SCBPTR),B'00010000'                        0306
         BNO   @RF00306                                            0306
*                                 R1=SCBPARMA;/* R1 CONTAINS PTR TO
*                                      USER PARAMETER LIST           */
         L     R1,SCBPARMA-1(,SCBPTR)                              0307
         LA    R1,0(,R1)                                           0307
*                               ELSE/* STAE EXIT                     */
*                                 R1=RTM2CC;/* R1 CONTAINS ABEND   0308
*                                      COMPLETION CODE               */
         B     @RC00306                                            0308
@RF00306 L     R1,RTM2CC-1(,RTM2PTR)                               0308
         LA    R1,0(,R1)                                           0308
*                               IF RTM2FIOB^=NOIOB THEN/* IF       0309
*                                      RESTOREABLE I/O               */
@RC00306 L     @15,RTM2FIOB-1(,RTM2PTR)                            0309
         LA    @15,0(,@15)                                         0309
         C     @15,@CF00069                                        0309
         BE    @RF00309                                            0309
*                                 R2=RTM2FIOB;/* R2 CONTAINS POINTER
*                                      TO PIRL                       */
         LR    R2,@15                                              0310
*                               ELSE/* IF NO SDWA AND NO RESTOREABLE
*                                      I/O                           */
*                                 R2=NONE;/* R2 CONTAINS ZERO        */
         B     @RC00309                                            0311
@RF00309 SLR   R2,R2                                               0311
*                             END;                                 0312
@RC00309 DS    0H                                                  0313
*                           IF RTM2RYRB->RBFTP='110'B THEN/* @YM01820*/
@RC00303 L     @15,RTM2RYRB(,RTM2PTR)                              0313
         TM    RBFTP(@15),B'11000000'                              0313
         BNO   @RF00313                                            0313
         TM    RBFTP(@15),B'00100000'                              0313
         BNZ   @RF00313                                            0313
*                             R14=CVTEXPRO;/*                @YM01820*/
         L     @12,CVTPTR(,RTM2PTR)                                0314
         L     R14,CVTEXPRO(,@12)                                  0314
*                           ELSE    /*                       @YM01820*/
*                             R14=ADDR(CVTEXIT);/*           @YM01820*/
         B     @RC00313                                            0315
@RF00313 L     R14,CVTPTR(,RTM2PTR)                                0315
         LA    R14,CVTEXIT(,R14)                                   0315
*                           RTM2RYRS(1)=R0;/* SAVE PARAMETER REG IN
*                                      RTM2WA                @G33SPHW*/
@RC00313 ST    R0,RTM2RYRS(,RTM2PTR)                               0316
*                           RTM2RYRS(2)=R1;/* SAVE R1 IN RTM2WA    0317
*                                                            @G33SPHW*/
         ST    R1,RTM2RYRS+4(,RTM2PTR)                             0317
*                           RTM2RYRS(3)=R2;/* SAVE R2 IN RTM2WA    0318
*                                                            @G33SPHW*/
         ST    R2,RTM2RYRS+8(,RTM2PTR)                             0318
*                           RTM2RYRS(15)=R14;/* SAVE R14 IN RTM2WA 0319
*                                                            @G33SPHW*/
         ST    R14,RTM2RYRS+56(,RTM2PTR)                           0319
*                           RTM2RYRS(16)=RTM2RTYA;/* RETRY ADDRESS IN
*                                      REG 15                @G33SPHW*/
         L     @15,RTM2RTYA(,RTM2PTR)                              0320
         ST    @15,RTM2RYRS+60(,RTM2PTR)                           0320
*                           RTM2UPRG=OFF;/* INDICATE PARM REGS ONLY
*                                      SAVED                 @G33SPHW*/
         NI    RTM2UPRG(RTM2PTR),B'10111111'                       0321
*                           RESPECIFY                              0322
*                            (R0,                                  0322
*                             R1,                                  0322
*                             R2,                                  0322
*                             R14) UNRSTD;                         0322
*                         END;      /* END PARMREGS                  */
*                     END;          /* END RBTYPE                    */
@RC00284 DS    0H                                                  0325
*                   END;            /* END OF RBPRGE                 */
*                   IF RTM2WANA=OFF&RTM2WAIN=OFF THEN/* VALID SDWA 0326
*                                      AVAILABLE                     */
*                                                                  0326
         TM    RTM2WANA(RTM2PTR),B'01100000'                       0326
         BNZ   @RF00326                                            0326
*                     /***********************************************/
*                     /*                                             */
*                     /* IF A VALID SDWA EXISTS, VARIOUS FLAGS ARE   */
*                     /* CHECKED TO DETERMINE HOW MUCH SHOULD BE     */
*                     /* FREED: IF STA EXIT, ALL BUT FIRST 104 BYTES.*/
*                     /* IF ESTA SPECIFIED FRESDWA=YES, ENTIRE SDWA  */
*                     /* IS FREED. IF ESTA DID NOT REQUEST FREEING OF*/
*                     /* THE WORK AREA, ONLY THE SAVE AREA IS FREED. */
*                     /* IF A WORK AREA EXISTS, THE RESTORE QUEUE    */
*                     /* POINTERS ARE INITIALIZED.                   */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0327
*                     DO;           /* START OF RTRYSDWA             */
*                       IF SDWAPTR^=NONE THEN/* VALID SDWA EXISTS    */
         SLR   @12,@12                                             0328
         CR    SDWAPTR,@12                                         0328
         BE    @RF00328                                            0328
*                         DO;                                      0329
*                           RESPECIFY                              0330
*                            (R12,                                 0330
*                             R11) RESTRICTED;/* RESTRICT LENGTH AND
*                                      START PTRS                    */
*                           IF SCBESTAE=ON THEN/* ESTA EXIT          */
         TM    SCBESTAE(SCBPTR),B'00010000'                        0331
         BNO   @RF00331                                            0331
*                             IF SDWAFREE=ON THEN/* EXIT REQUESTED 0332
*                                      FREEING OF SDWA               */
         TM    SDWAFREE(SDWAPTR),B'00000100'                       0332
         BNO   @RF00332                                            0332
*                               DO;                                0333
*                                 R12=RTM2SIZE;/* WHOLE THING TO BE
*                                      FREED                         */
         L     R12,RTM2SIZE-1(,RTM2PTR)                            0334
         LA    R12,0(,R12)                                         0334
*                                 R11=RTM2RTCA;                    0335
         L     R11,RTM2RTCA(,RTM2PTR)                              0335
*                                 SDWAPTR=NONE;                    0336
         SLR   SDWAPTR,SDWAPTR                                     0336
*                                 RTM2RTCA=NONE;                   0337
         SLR   @08,@08                                             0337
         ST    @08,RTM2RTCA(,RTM2PTR)                              0337
*                               END;                               0338
*                             ELSE  /* EXIT DID NOT REQUEST FREEING  */
*                               R12=72;/* FREE ONLY SAVE AREA        */
         B     @RC00332                                            0339
@RF00332 LA    R12,72                                              0339
*                           ELSE    /* STA (NOT ESTA) EXIT           */
*                             R12=RTM2SIZE-104;/* LEAVE 104 BYTES    */
         B     @RC00331                                            0340
@RF00331 L     R12,RTM2SIZE-1(,RTM2PTR)                            0340
         LA    R12,0(,R12)                                         0340
         SL    R12,@CF03678                                        0340
*                           IF SDWAPTR^=NONE THEN/* PART OF SDWA TO
*                                      BE LEFT                       */
@RC00331 LTR   SDWAPTR,SDWAPTR                                     0341
         BZ    @RF00341                                            0341
*                             DO;                                  0342
*                               RTM2SIZE=RTM2SIZE-R12;/* NEW LENGTH  */
         L     @08,RTM2SIZE-1(,RTM2PTR)                            0343
         LA    @08,0(,@08)                                         0343
         SLR   @08,R12                                             0343
         STCM  @08,7,RTM2SIZE(RTM2PTR)                             0343
*                               SDWALNTH=RTM2SIZE;                 0344
         STCM  @08,7,SDWALNTH(SDWAPTR)                             0344
*                               R11=SDWAPTR+RTM2SIZE;/* FIRST BYTE TO
*                                      BE FREED                      */
         ALR   @08,SDWAPTR                                         0345
         LR    R11,@08                                             0345
*                             END;                                 0346
*                           DO;     /* FREEMAIN(RC)                0347
*                                      LV(R12)A(R11->SDWA)         0347
*                                      SP(RTM2SUBP)                  */
@RF00341 DS    0H                                                  0348
*                             RESPECIFY                            0348
*                              (GPR01F,                            0348
*                               GPR15F,                            0348
*                               GPR00F) RESTRICTED;                0348
*                             GPR01F=0;/* REG 1 MUST BE ZERO         */
         SLR   GPR01F,GPR01F                                       0349
*                             GPR15F=1;/* SET TYPE                   */
         LA    GPR15F,1                                            0350
*                             GPR00F=R12;/* LENGTH REQUESTED         */
         LR    GPR00F,R12                                          0351
*                             GPR01F=ADDR(R11->SDWA);/* SET REGISTER
*                                      ONE                           */
         LR    GPR01F,R11                                          0352
*                             GPR15F=GPR15F+((RTM2SUBP)*256);/*    0353
*                                      SUBPOOL VALUE                 */
         SLR   @14,@14                                             0353
         IC    @14,RTM2SUBP(,RTM2PTR)                              0353
         SLA   @14,8                                               0353
         ALR   GPR15F,@14                                          0353
*                             SVC(120);/* RC/RU-FORM OF GETMAIN      */
         SVC   120                                                 0354
*                             RESPECIFY                            0355
*                              (GPR01F,                            0355
*                               GPR15F,                            0355
*                               GPR00F) UNRESTRICTED;              0355
*                           END;    /* FREEMAIN(RC)                0356
*                                      LV(R12)A(R11->SDWA)         0356
*                                      SP(RTM2SUBP)                  */
*                           RESPECIFY                              0357
*                            (R12,                                 0357
*                             R11) UNRESTRICTED;/* RELEASE INTERFACE
*                                      REGS FOR FREEMAIN             */
*                         END;                                     0358
*                       IF SDWAPTR^=NONE THEN/* SDWA AVAILABLE       */
@RF00328 LTR   SDWAPTR,SDWAPTR                                     0359
         BZ    @RF00359                                            0359
*                         IF RTM2IOQR=ON THEN/* I/O WAS QUIESCED     */
         TM    RTM2IOQR(RTM2PTR),B'10000000'                       0360
         BNO   @RF00360                                            0360
*                           DO;                                    0361
*                             SDWAFIOB=RTM2FIOB;/* LOCATES PIRL      */
         L     @12,RTM2FIOB-1(,RTM2PTR)                            0362
         LA    @12,0(,@12)                                         0362
         ST    @12,SDWAFIOB(,SDWAPTR)                              0362
*                             SDWAIOBR=ADDR(SDWAFIOB);             0363
         LA    @12,SDWAFIOB(,SDWAPTR)                              0363
         ST    @12,SDWAIOBR(,SDWAPTR)                              0363
*                           END;                                   0364
*                       IF SCBESTAE=OFF THEN/* TEST IF STAE OR STAI  */
@RF00360 DS    0H                                                  0365
@RF00359 TM    SCBESTAE(SCBPTR),B'00010000'                        0365
         BNZ   @RF00365                                            0365
*                         RTM2DREQ=OFF;/* IF STAE/STAI RETRY DO NOT
*                                      DUMP                          */
         NI    RTM2DREQ(RTM2PTR),B'01111111'                       0366
*                     END;          /* END OF RTRYSDWA               */
*                                                                  0367
@RF00365 DS    0H                                                  0368
*                   /*************************************************/
*                   /*                                               */
*                   /* THIS SEGMENT UPDATES THE CURRENT SCB PRIOR TO */
*                   /* RETRY. IF THE SCB IS AN ESTAE SCB THE INUSE   */
*                   /* FLAG IS ZEROED SO THAT IT CAN BE REUSED. IF IT*/
*                   /* IS A STAE SCB. IT IS MARKED LOGICALLY CANCELED*/
*                   /* SO THAT IT WILL NOT BE REUSED. FOR (E)STAI    */
*                   /* RETRY THE CURRENT SCB INUSE FLAG IS ALWAYS    */
*                   /* ZEROED. IN ADDITION, IF THERE IS NO PREVIOUS  */
*                   /* EXIT PRB ON THE QUEUE, THE INUSE FLAG IS      */
*                   /* ZEROED IN ALL (E)STAI SCB-S ON THE QUEUE.     */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0368
*                   DO;             /* BEGIN SCBUPDAT                */
@RF00326 DS    0H                                                  0369
*                     IF SCBESTAE=ON THEN/* IF ESTAE SCB             */
         TM    SCBESTAE(SCBPTR),B'00010000'                        0369
         BNO   @RF00369                                            0369
*                       SCBINUSE=OFF;/* TURN OFF IN USE BIT SO IT CAN
*                                      BE REUSED                     */
*                                                                  0370
         NI    SCBINUSE(SCBPTR),B'11101111'                        0370
*                     /***********************************************/
*                     /*                                             */
*                     /* (E)STAI SCB PROCESSING                      */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0371
*                     IF SCBSTAI=ON THEN/* IF AN (E)STAI SCB         */
@RF00369 TM    SCBSTAI(SCBPTR),B'10000000'                         0371
         BNO   @RF00371                                            0371
*                       DO;         /* (E)STAI SCB                   */
*                         SCBINUSE=OFF;/* ALWAYS RESET INUSE BIT IN
*                                      CURRENT (E)STAI SCB           */
         NI    SCBINUSE(SCBPTR),B'11101111'                        0373
*                         IF RTM2RYRB->RBTCBNXT^=ON THEN           0374
         L     @12,RTM2RYRB(,RTM2PTR)                              0374
         TM    RBTCBNXT(@12),B'10000000'                           0374
         BO    @RF00374                                            0374
*                           IF EVAL((RTM2RYRB->RBLINKB)-LENGTH(RBPREFIX
*                               ))->RBABEND^=ON THEN/* TEST IF RETRY
*                                      RB IS NOT PREVIOUSLY SYNCHED
*                                      TO EXIT PRB                   */
         L     @12,RBLINKB-1(,@12)                                 0375
         LA    @12,0(,@12)                                         0375
         SL    @12,@CF00472                                        0375
         TM    RBABEND(@12),B'00100000'                            0375
         BO    @RF00375                                            0375
*                             DO;   /* RESET ALL PREVIOUSLY ENTERED
*                                      (E)STAI INUSE BITS            */
*                               RESPECIFY                          0377
*                                 R8 RESTRICTED;                   0377
*                               R8=RTM2SCBN;/* TEMPORARY SCB PTR USED
*                                      TO SCAN SCB QUEUE             */
         L     R8,RTM2SCBN(,RTM2PTR)                               0378
*                               DO WHILE(R8^=RTM2SCBO);/* SEARCH FOR
*                                      (E)STAI SCB-S                 */
         B     @DE00379                                            0379
@DL00379 DS    0H                                                  0380
*                                 IF R8->SCBSTAI=ON THEN/* TEST IF 0380
*                                      (E)STAI SCB                   */
         TM    SCBSTAI(R8),B'10000000'                             0380
         BNO   @RF00380                                            0380
*                                   R8->SCBINUSE=OFF;/* TURN OFF   0381
*                                      INUSE FLAG                    */
         NI    SCBINUSE(R8),B'11101111'                            0381
*                                 R8=R8->SCBCHAIN;/* UPDATE SCB    0382
*                                      POINTER                       */
@RF00380 L     R8,SCBCHAIN(,R8)                                    0382
*                               END;/* END (E)STAI SEARCH            */
@DE00379 C     R8,RTM2SCBO(,RTM2PTR)                               0383
         BNE   @DL00379                                            0383
*                               RESPECIFY                          0384
*                                 R8 UNRESTRICTED;                 0384
*                             END;  /* END RESETTING OF (E)STAI INUSE
*                                      BITS                          */
*                           ELSE                                   0386
*                             ;                                    0386
@RF00375 DS    0H                                                  0387
*                         ELSE                                     0387
*                           ;                                      0387
@RF00374 DS    0H                                                  0388
*                       END;        /* END (E)STAI SCB PROCESSING    */
*                   END;            /* END SCBUPDAT                  */
@RF00371 DS    0H                                                  0390
*                   RTM2RETR=ON;    /* INDICATE RETRY TO RTM2        */
         OI    RTM2RETR(RTM2PTR),B'01000000'                       0390
*                 END;                                             0391
*               RTM2TRRA=NONE;      /* CLEAR RECURSION ENVIRONMENT   */
@RF00138 SLR   @12,@12                                             0392
         ST    @12,RTM2TRRA(,RTM2PTR)                              0392
*               RTM2RTYS=OFF;                                      0393
         NI    RTM2RTYS(RTM2PTR),B'10111111'                       0393
*             END;                                                 0394
*           IF RTM2RETR^=ON THEN    /* RETRY NOT REQUESTED OR NOT  0395
*                                      POSSIBLE                      */
@RF00103 TM    RTM2RETR(RTM2PTR),B'01000000'                       0395
         BO    @RF00395                                            0395
*NORETRY:                                                          0396
*             DO;                   /* BEGIN SCBPERC                 */
NORETRY  DS    0H                                                  0397
*               IF RTM2RTCA^=NONE&RTM2WAIN=OFF THEN/* TEST IF VALID
*                                      SDWA EXISTS                   */
         L     @12,RTM2RTCA(,RTM2PTR)                              0397
         LTR   @12,@12                                             0397
         BZ    @RF00397                                            0397
         TM    RTM2WAIN(RTM2PTR),B'01000000'                       0397
         BNZ   @RF00397                                            0397
*                 DO;                                              0398
*                   IF SCBESTAE=ON THEN/* CARRY FLAGS FORWARD IF   0399
*                                      ESTAE                         */
         TM    SCBESTAE(SCBPTR),B'00010000'                        0399
         BNO   @RF00399                                            0399
*                     DO;           /* ACCESS DATA FROM SDWA         */
*                       RTM2CC=SDWACMPC;/* ALLOW USER TO CHANGE ABEND
*                                      COMPLETION CODE               */
         MVC   RTM2CC(3,RTM2PTR),SDWACMPC(SDWAPTR)                 0401
*                       IF SDWAEAS=ON THEN/* TEST IF USER SET FLAG   */
         TM    SDWAEAS(SDWAPTR),B'00001000'                        0402
         BNO   @RF00402                                            0402
*                         RTM2EAS=ON;/* USER SUPPLIED SERVICEABILITY
*                                      INFORMATION                   */
         OI    RTM2EAS(RTM2PTR),B'00001000'                        0403
*                       ELSE                                       0404
*                         RTM2EAS=OFF;/* TURN OFF SERVICEABILITY BIT */
         B     @RC00402                                            0404
@RF00402 NI    RTM2EAS(RTM2PTR),B'11110111'                        0404
*                       RTM2COMP=SDWACOMP;/* CARRY FORWARD USER WORD */
@RC00402 L     @12,SDWACOMP(,SDWAPTR)                              0405
         ST    @12,RTM2COMP(,RTM2PTR)                              0405
*                     END;                                         0406
*                   RTM2FMS=ON;     /* SET FREEMAIN SECTION FLAG     */
@RF00399 OI    RTM2FMS(RTM2PTR),B'00000001'                        0407
*                   RTM2TRRA=ADDR(RECURSE);/* ESTABLISH RECURSION  0408
*                                      ADDRESS                       */
         L     @12,@CV00066                                        0408
         ST    @12,RTM2TRRA(,RTM2PTR)                              0408
*                   DO;             /* FREEMAIN(RC)                0409
*                                      LV(RTM2SIZE)A(RTM2RTCA->SDWA)
*                                      SP(RTM2SUBP)                  */
*                     RESPECIFY                                    0410
*                      (GPR01F,                                    0410
*                       GPR15F,                                    0410
*                       GPR00F) RESTRICTED;                        0410
*                     GPR01F=0;     /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0411
*                     GPR15F=1;     /* SET TYPE                      */
         LA    GPR15F,1                                            0412
*                     GPR00F=RTM2SIZE;/* LENGTH REQUESTED            */
         L     GPR00F,RTM2SIZE-1(,RTM2PTR)                         0413
         ICM   GPR00F,8,@CB03724                                   0413
*                     GPR01F=ADDR(RTM2RTCA->SDWA);/* SET REGISTER ONE*/
         L     GPR01F,RTM2RTCA(,RTM2PTR)                           0414
*                     GPR15F=GPR15F+((RTM2SUBP)*256);/* SUBPOOL VALUE*/
         SLR   @14,@14                                             0415
         IC    @14,RTM2SUBP(,RTM2PTR)                              0415
         SLA   @14,8                                               0415
         ALR   GPR15F,@14                                          0415
*                     SVC(120);     /* RC/RU-FORM OF GETMAIN         */
         SVC   120                                                 0416
*                     RESPECIFY                                    0417
*                      (GPR01F,                                    0417
*                       GPR15F,                                    0417
*                       GPR00F) UNRESTRICTED;                      0417
*                   END;            /* FREEMAIN(RC)                0418
*                                      LV(RTM2SIZE)A(RTM2RTCA->SDWA)
*                                      SP(RTM2SUBP)                  */
*                   RTM2TRRA=NONE;  /* ZERO RECURSION ADDRESS        */
         SLR   @12,@12                                             0419
         ST    @12,RTM2TRRA(,RTM2PTR)                              0419
*                   RTM2FMS=OFF;    /* TURN OF FREEMAIN FLAG         */
         NI    RTM2FMS(RTM2PTR),B'11111110'                        0420
*FMRET:                                                            0421
*                   RTM2RTCA=NONE;  /* ZERO SDWA PTR IN RTM2 WORKAREA*/
FMRET    SLR   @12,@12                                             0421
         ST    @12,RTM2RTCA(,RTM2PTR)                              0421
*                   SDWAPTR=NONE;   /* ZERO SDWA PTR                 */
         SLR   SDWAPTR,SDWAPTR                                     0422
*                 END;              /* END PROCESSING IF SDWA        */
*               RTM2PERC=ON;        /* TURN ON PERCOLATION INDICATION*/
@RF00397 OI    RTM2PERC(RTM2PTR),B'00010000'                       0424
*               IF SCBSTAI=ON THEN                                 0425
         TM    SCBSTAI(SCBPTR),B'10000000'                         0425
         BNO   @RF00425                                            0425
*                 RTM2STAI=ON;      /* TURN ON STAI INDICATION       */
         OI    RTM2STAI(RTM2PTR),B'01000000'                       0426
*               IF SCBESTAE=OFF&SCBSTAI=OFF THEN                   0427
@RF00425 TM    SCBESTAE(SCBPTR),B'10010000'                        0427
         BNZ   @RF00427                                            0427
*                 RTM2STA2=ON;      /* INDICATE STAE EXIT ENTERED    */
         OI    RTM2STA2(RTM2PTR),B'10000000'                       0428
*               RTM2XFLG=OFF;       /* ZERO EXIT PROCRSSING FLAG     */
@RF00427 NI    RTM2XFLG(RTM2PTR),B'11110111'                       0429
*               RTM2WAIN=OFF;       /* ZERO SDWA INVALID FLAG        */
*               RTM2WANA=OFF;       /* ZERO WORKAREA NOT AVAILABLE 0431
*                                      FLAG                          */
         NI    RTM2WAIN(RTM2PTR),B'10011111'                       0431
*               RTM2XABD=OFF;       /* ZERO EXIT ABEND FLAG          */
*               RTM2AS2R=OFF;       /* ZERO RECURSION FLAG           */
*               RTM2AS3R=OFF;       /* ZERO RECURSION FLAG           */
         NI    RTM2XABD(RTM2PTR),B'11101100'                       0434
*             END;                  /* END SCBPERC                   */
*         END;                                                     0436
*       ELSE                        /* RECURSION TO BE HANDLED IN  0437
*                                      THIS ROUTINE                  */
*                                                                  0437
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SEGMENT SAVES THE SDWAPTR IN CASE OF FURTHER       */
*         /* RECURSION AND THEN INITIALIZES THE POINTER TO THE       */
*         /* CURRENT SCB. THE SECTION FLAGS ARE TESTED TO DETERMINE  */
*         /* WHERE THE ERROR OCCURRED AND CONTROL IS THEN RESUMED    */
*         /* IMMEDIATELY FOLLOWING THE FAILING ROUTINE. IF AN ERROR  */
*         /* IS ENCOUNTERED ANYWHERE IN IEAVTAS3 PROCESSING          */
*         /* NECESSARILY DEFAULTS TO CONTINUE WITH TERMINATION       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0437
*         DO;                       /* BEGIN RECURSE3                */
         B     @RC00101                                            0437
@RF00101 DS    0H                                                  0438
*           RTM2RREG(8)=SDWAPTR;    /* SAVE SDWAPTR SO THAT IT CAN BE
*                                      CARRIED FORWARD IF FURTHER  0438
*                                      RECURSION                     */
         ST    SDWAPTR,RTM2RREG+28(,RTM2PTR)                       0438
*           RESPECIFY                                              0439
*             R8 RESTRICTED;                                       0439
*           SCBPTR=NONE;            /* INITIALIZE SCBPTR             */
         SLR   SCBPTR,SCBPTR                                       0440
*           R8=RTM2PREV;            /* INITIALIZE FOR BEGINNING OF 0441
*                                      SCAN THROUGH PREVIOUS       0441
*                                      WORKAREAS                     */
         L     R8,RTM2PREV(,RTM2PTR)                               0441
*           DO WHILE(SCBPTR=NONE);  /* SCAN RTM2 WKAREA QUEUE UNTIL
*                                      SCB FOUND                     */
         B     @DE00442                                            0442
@DL00442 DS    0H                                                  0443
*             IF R8->RTM2SCBC^=SCBSTART THEN/* TEST IF THIS WORKAREA
*                                      LOCATES THE CURRENT SCB       */
         L     @12,RTM2SCBC(,R8)                                   0443
         C     @12,@CF00092                                        0443
         BE    @RF00443                                            0443
*               SCBPTR=R8->RTM2SCBC;/* INITIALIZE SCBPTR             */
         LR    SCBPTR,@12                                          0444
*             R8=R8->RTM2PREV;      /* UPDATE PTR TO NEXT RTM2 WKAREA*/
@RF00443 L     R8,RTM2PREV(,R8)                                    0445
*           END;                    /* END SCAN FOR SCB              */
@DE00442 LTR   SCBPTR,SCBPTR                                       0446
         BZ    @DL00442                                            0446
*           RESPECIFY                                              0447
*             R8 UNRESTRICTED;                                     0447
*           RESPECIFY                                              0448
*             R9 RESTRICTED;                                       0448
*           IF RTM2PREV->RTM2FMS=ON THEN/* TEST IF FREEMAIN FAILURE  */
         L     @12,RTM2PREV(,RTM2PTR)                              0449
         TM    RTM2FMS(@12),B'00000001'                            0449
         BNO   @RF00449                                            0449
*             R9=ADDR(FMRET);       /* RESUME FOLLOWING FREEMAIN     */
         LA    R9,FMRET                                            0450
*           ELSE                                                   0451
*             IF RTM2PREV->RTM2RTYS=ON THEN                        0451
         B     @RC00449                                            0451
@RF00449 L     @12,RTM2PREV(,RTM2PTR)                              0451
         TM    RTM2RTYS(@12),B'01000000'                           0451
         BNO   @RF00451                                            0451
*               R9=ADDR(NORETRY);   /* RETRY FAILURE - RESUME WITH 0452
*                                      CONTINUE WITH TERMINATION     */
         LA    R9,NORETRY                                          0452
*           GOTO R9;                                               0453
@RF00451 DS    0H                                                  0453
@RC00449 BR    R9                                                  0453
*           RESPECIFY                                              0454
*             R9 UNRESTRICTED;                                     0454
*         END;                      /* END RECURSE3                  */
*     ELSE                                                         0456
*                                                                  0456
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SEGMENT WILL SCAN THROUGH THE RB-S TO BE PURGED      */
*       /* INSERTING SVC 3 (EXIT) IN THEIR PSWS, ZEROING THEIR WAIT  */
*       /* COUNTS AND INSERTING PROPER REGISTER VALUES WHEN NECESSARY*/
*       /* TO ENSURE THAT THE CORRECT REGISTERS ARE PASSED TO THE    */
*       /* RETRYING RB. THIS SEGMENT WILL ALSO BE ENTERED IF AN      */
*       /* UNRECOVERABLE ERROR OCCURS IN PRE-EXIT PROCESSING         */
*       /* (IEAVTAS1). IN THIS CASE THE ABEND SVRB, THE RB UNDER     */
*       /* WHICH IEAVTAS1 EXECUTES, WILL BE THE RETRYING RB.         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0456
*       DO;                         /* BEGIN RBTYPE                  */
         B     @RC00100                                            0456
@RF00100 DS    0H                                                  0457
*         IF(SDWAPTR^=NONE&SCBESTAE=ON&SDWAUPRG=ON)|RTM2AS1R=ON THEN
         LTR   SDWAPTR,SDWAPTR                                     0457
         BZ    @GL00012                                            0457
         TM    SCBESTAE(SCBPTR),B'00010000'                        0457
         BNO   @GL00012                                            0457
         TM    SDWAUPRG(SDWAPTR),B'00001000'                       0457
         BO    @RT00457                                            0457
@GL00012 TM    RTM2AS1R(RTM2PTR),B'00000100'                       0457
         BNO   @RF00457                                            0457
@RT00457 DS    0H                                                  0458
*                                   /* USER SPECIFIED REGISTER UPDATE
*                                      OR THIS IS A PSEUDO RETRY INTO
*                                      IEAVTAS1                      */
*           DO;                                                    0458
*             RESPECIFY                                            0459
*              (R9,                                                0459
*               R4) RESTRICTED;                                    0459
*             IF RTM2AS1R=ON THEN   /* TEST IF RETRY INTO IEAVTAS1   */
         TM    RTM2AS1R(RTM2PTR),B'00000100'                       0460
         BNO   @RF00460                                            0460
*               DO;                 /* SETUP FOR RETRY       @G33SPHW*/
*                 RTM2RETR=ON;      /* INDICATE RETRY        @G33SPHW*/
         OI    RTM2RETR(RTM2PTR),B'01000000'                       0462
*                 R9=ADDR(RTM2PRWA->RTM2RREG);/* RETRY REGISTERS IN
*                                      RTM2RREG                      */
         L     R9,RTM2PRWA(,RTM2PTR)                               0463
         LA    R9,RTM2RREG(,R9)                                    0463
*               END;                /*                       @G33SPHW*/
*             ELSE                  /* NORMAL RETRY                  */
*               R9=ADDR(SDWASRSV);  /* UPDATED REGISTERS ARE IN SDWA */
         B     @RC00460                                            0465
@RF00460 LA    R9,SDWASRSV(,SDWAPTR)                               0465
*             RTM2UPRG=ON;          /* INDICATE ALL REGS ARE TO BE 0466
*                                      PASSED TO RETRY ROUTINE     0466
*                                                            @G33SPHW*/
@RC00460 OI    RTM2UPRG(RTM2PTR),B'01000000'                       0466
*             RTM2RYRG=R9->RSAVE;   /* COPY APPROIATE REGISTER TO  0467
*                                      RTM2WA FOR SAFEKEEPING      0467
*                                                            @G33SPHW*/
         MVI   RTM2RYRG+64(RTM2PTR),C' '                           0467
         MVC   RTM2RYRG+65(3,RTM2PTR),RTM2RYRG+64(RTM2PTR)         0467
         MVC   RTM2RYRG(64,RTM2PTR),RSAVE(R9)                      0467
*           END;                    /* END RETRY SET UP WITH USER  0468
*                                      UPDATED REGISTERS             */
*         ELSE                                                     0469
*                                                                  0469
*           /*********************************************************/
*           /*                                                       */
*           /* THIS SEGMENT WILL INITIALIZE PARAMETER REGISTERS TO BE*/
*           /* SENT TO THE RETRY ROUTINE. IT THEN SCANS THE RB-S TO  */
*           /* BE PURGED AND INSERTS THE REGISTER IN THE RB-S        */
*           /* REGISTER SAVE AREA IF NECESSARY. THE WAIT COUNT OF THE*/
*           /* RB-S TO BE PURGED AND OF THE RETRYING RB IS ZEROED.   */
*           /* SVC 3 IS INSERTED IN THE PSW-S OF THE RB-S TO BE      */
*           /* PURGED AND THE RETRY ADDRESS IS INSERTED IN THE PSW OF*/
*           /* THE RETRYING RB.                                      */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0469
*           DO;                     /* BEGIN PARMREGS                */
         B     @RC00457                                            0469
@RF00457 DS    0H                                                  0470
*             RESPECIFY                                            0470
*              (R0,                                                0470
*               R1,                                                0470
*               R14,                                               0470
*               R2) RESTRICTED;     /* PARAMETER REGISTERS TO RETRY
*                                      RB                            */
*             IF SDWAPTR=NONE THEN  /* TEST IF THERE IS AN SDWA      */
         LTR   SDWAPTR,SDWAPTR                                     0471
         BNZ   @RF00471                                            0471
*               R0=RC12;            /* INDICATE SDWA NOT AVAILABLE   */
         LA    R0,12                                               0472
*             ELSE                                                 0473
*               IF SCBESTAE=ON&SDWAFREE=ON THEN/* TEST IF USER     0473
*                                      REQUESTED TO FREE SDWA PRIOR
*                                      TO RETRY                      */
         B     @RC00471                                            0473
@RF00471 TM    SCBESTAE(SCBPTR),B'00010000'                        0473
         BNO   @RF00473                                            0473
         TM    SDWAFREE(SDWAPTR),B'00000100'                       0473
         BNO   @RF00473                                            0473
*                 R0=RC20;          /* SDWA IS NOT FREED AT THIS   0474
*                                      POINT BUT WILL BE PRIOR TO  0474
*                                      RETRY                         */
         LA    R0,20                                               0474
*               ELSE                                               0475
*                 R0=ZERO;          /* AN SDWA WAS OBTAINED          */
         B     @RC00473                                            0475
@RF00473 SLR   R0,R0                                               0475
*             IF R0=ZERO THEN       /* IF AN SDWA WAS OBTAINED AND 0476
*                                      WILL NOT BE FREED PRIOR TO  0476
*                                      RETRY                         */
@RC00473 DS    0H                                                  0476
@RC00471 LTR   R0,R0                                               0476
         BNZ   @RF00476                                            0476
*               R1=SDWAPTR;         /* R1 CONTAINS PTR TO SDWA       */
         LR    R1,SDWAPTR                                          0477
*             ELSE                                                 0478
*               DO;                                                0478
         B     @RC00476                                            0478
@RF00476 DS    0H                                                  0479
*                 IF SCBESTAE=ON THEN/* TEST IF ESTAE EXIT           */
         TM    SCBESTAE(SCBPTR),B'00010000'                        0479
         BNO   @RF00479                                            0479
*                   R1=SCBPARMA;    /* R1 CONTAINS PTR TO USER     0480
*                                      PARAMETER LIST                */
         L     R1,SCBPARMA-1(,SCBPTR)                              0480
         LA    R1,0(,R1)                                           0480
*                 ELSE              /* STAE EXIT                     */
*                   R1=RTM2CC;      /* R1 CONTAINS ABEND COMPLETION
*                                      CODE                          */
         B     @RC00479                                            0481
@RF00479 L     R1,RTM2CC-1(,RTM2PTR)                               0481
         LA    R1,0(,R1)                                           0481
*                 IF RTM2FIOB^=NOIOB THEN/* IF RESTOREABLE I/O       */
@RC00479 L     @15,RTM2FIOB-1(,RTM2PTR)                            0482
         LA    @15,0(,@15)                                         0482
         C     @15,@CF00069                                        0482
         BE    @RF00482                                            0482
*                   R2=RTM2FIOB;    /* R2 CONTAINS POINTER TO PIRL   */
         LR    R2,@15                                              0483
*                 ELSE              /* IF NO SDWA AND NO RESTOREABLE
*                                      I/O                           */
*                   R2=NONE;        /* R2 CONTAINS ZERO              */
         B     @RC00482                                            0484
@RF00482 SLR   R2,R2                                               0484
*               END;                                               0485
@RC00482 DS    0H                                                  0486
*             IF RTM2RYRB->RBFTP='110'B THEN/*               @YM01820*/
@RC00476 L     @15,RTM2RYRB(,RTM2PTR)                              0486
         TM    RBFTP(@15),B'11000000'                              0486
         BNO   @RF00486                                            0486
         TM    RBFTP(@15),B'00100000'                              0486
         BNZ   @RF00486                                            0486
*               R14=CVTEXPRO;       /*                       @YM01820*/
         L     @12,CVTPTR(,RTM2PTR)                                0487
         L     R14,CVTEXPRO(,@12)                                  0487
*             ELSE                  /*                       @YM01820*/
*               R14=ADDR(CVTEXIT);  /*                       @YM01820*/
         B     @RC00486                                            0488
@RF00486 L     R14,CVTPTR(,RTM2PTR)                                0488
         LA    R14,CVTEXIT(,R14)                                   0488
*             RTM2RYRS(1)=R0;       /* SAVE PARAMETER REG IN RTM2WA
*                                                            @G33SPHW*/
@RC00486 ST    R0,RTM2RYRS(,RTM2PTR)                               0489
*             RTM2RYRS(2)=R1;       /* SAVE R1 IN RTM2WA     @G33SPHW*/
         ST    R1,RTM2RYRS+4(,RTM2PTR)                             0490
*             RTM2RYRS(3)=R2;       /* SAVE R2 IN RTM2WA     @G33SPHW*/
         ST    R2,RTM2RYRS+8(,RTM2PTR)                             0491
*             RTM2RYRS(15)=R14;     /* SAVE R14 IN RTM2WA    @G33SPHW*/
         ST    R14,RTM2RYRS+56(,RTM2PTR)                           0492
*             RTM2RYRS(16)=RTM2RTYA;/* RETRY ADDRESS IN REG 15     0493
*                                                            @G33SPHW*/
         L     @15,RTM2RTYA(,RTM2PTR)                              0493
         ST    @15,RTM2RYRS+60(,RTM2PTR)                           0493
*             RTM2UPRG=OFF;         /* INDICATE PARM REGS ONLY SAVED
*                                                            @G33SPHW*/
         NI    RTM2UPRG(RTM2PTR),B'10111111'                       0494
*             RESPECIFY                                            0495
*              (R0,                                                0495
*               R1,                                                0495
*               R2,                                                0495
*               R14) UNRSTD;                                       0495
*           END;                    /* END PARMREGS                  */
*       END;                        /* END RBTYPE                    */
*   ELSE                            /* ENTRY TO SETUP FOR RETRY    0498
*                                                            @G33SPHW*/
*     DO;                           /* SETUP RBS FOR PURGE   @G33SPHW*/
         B     @RC00099                                            0498
@RF00099 DS    0H                                                  0499
*       IF RTM2AS1R=OFF&SCBSTAR=OFF THEN/* NOT ESTAE EXIT IN USE   0499
*                                      NEVER SET FOR STAR    @G33SPHW*/
         TM    RTM2AS1R(RTM2PTR),B'00000100'                       0499
         BNZ   @RF00499                                            0499
         TM    SCBSTAR(SCBPTR),B'01000000'                         0499
         BNZ   @RF00499                                            0499
*         SCBINUSE=ON;              /*                       @G33SPHW*/
         OI    SCBINUSE(SCBPTR),B'00010000'                        0500
*       DO;                         /* START RBTYPE1         @G33SPHW*/
@RF00499 DS    0H                                                  0502
*         RFY                                                      0502
*          (R4) RSTD;               /*                       @G33SPHW*/
*         R4=RTM2VRBC;              /* INITIALIZE RBPTR WITH ABEND 0503
*                                      SYRB                          */
         L     @12,RTM2VRBC(,RTM2PTR)                              0503
         LR    R4,@12                                              0503
*         ESAGLREC=ON;              /* SET RECURSION CONTROL @YM01826*/
         OI    ESAGLREC+96(@12),B'00010000'                        0504
*         DO;                       /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL)                 0505
*                                      RELATED(RB,IEAVTAS3(RBTYPE))  */
*           RFY                                                    0506
*            (GPR11P,                                              0506
*             GPR12P,                                              0506
*             GPR13P,                                              0506
*             GPR14P) RSTD;                                        0506
*           GPR13P=PSALITA;         /* ADDRESS OF LOCK INTERFACE   0507
*                                      TABLE.                        */
         L     GPR13P,PSALITA                                      0507
*           GEN(LM GPR11P,GPR13P,576(GPR13P));/* LOAD LOCKWORD, CLHT
*                                      AND ENTRY ADRS.               */
         LM GPR11P,GPR13P,576(GPR13P)
*           GEN(BALR GPR14P,GPR13P);/* BALR TO SETLOCK RTN.          */
         BALR GPR14P,GPR13P
*           RFY                                                    0510
*            (GPR11P,                                              0510
*             GPR12P,                                              0510
*             GPR13P,                                              0510
*             GPR14P) UNRSTD;                                      0510
*         END;                      /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL)                 0511
*                                      RELATED(RB,IEAVTAS3(RBTYPE))
*                                                            @YM01826*/
*         ESAGLREC=OFF;             /* RELEASE RECURSION CONTROL   0512
*                                                            @YM01826*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0512
         NI    ESAGLREC+96(@12),B'11101111'                        0512
*         DO WHILE(R4^=RTM2RYRB);   /* PROCESS ALL RB-S FOR PURGE    */
         B     @DE00513                                            0513
@DL00513 DS    0H                                                  0514
*           RBWCF=NOWAIT;           /* ZERO WAIT COUNT               */
         MVI   RBWCF(R4),X'00'                                     0514
*           RBXWAIT=OFF;            /* ZERO EXPLICIT WAIT COUNT      */
         LR    @12,R4                                              0515
         AL    @12,@CF03727                                        0515
         NI    RBXWAIT-56(@12),B'10111111'                         0515
*           IF RBFTP^='000'B THEN   /* DETERMINE RB TYPE     @YM06219*/
         TM    RBFTP(R4),B'11100000'                               0516
         BZ    @RF00516                                            0516
*             IF RTM2UPRG=ON THEN   /* IF RB IS IRB OR SVRB UPDATED
*                                      REGISTERS ARE STORED IN     0517
*                                      RBGRSAVE              @G33SPHW*/
         TM    RTM2UPRG(RTM2PTR),B'01000000'                       0517
         BNO   @RF00517                                            0517
*               RBGRSAVE=RTM2RYRG;  /* RESTORE REGISTERS     @G33SPHW*/
         MVC   RBGRSAVE(64,R4),RTM2RYRG(RTM2PTR)                   0518
*             ELSE                  /* NOT SVRB OR IRB       @G33SPHW*/
*               DO;                 /* RESTORE ONLY PARM REGS      0519
*                                                            @G33SPHW*/
         B     @RC00517                                            0519
@RF00517 DS    0H                                                  0520
*                 RBGRS0=RTM2RYRS(1);/* RESTORE PARM REG     @G33SPHW*/
         L     @12,RTM2RYRS(,RTM2PTR)                              0520
         ST    @12,RBGRS0(,R4)                                     0520
*                 RBGRS1=RTM2RYRS(2);/* RESTORE REG1         @G33SPHW*/
         L     @12,RTM2RYRS+4(,RTM2PTR)                            0521
         ST    @12,RBGRS1(,R4)                                     0521
*                 RBGRS2=RTM2RYRS(3);/* RESTORE REG 2        @G33SPHW*/
         L     @12,RTM2RYRS+8(,RTM2PTR)                            0522
         ST    @12,RBGRS2(,R4)                                     0522
*                 RBGRS14=RTM2RYRS(15);/* RESTORE RETURN REG @G33SPHW*/
         L     @12,RTM2RYRS+56(,RTM2PTR)                           0523
         ST    @12,RBGRS14(,R4)                                    0523
*                 RBGRS15=RTM2RYRS(16);/* RESTORE RETRY REG  @G33SPHW*/
         L     @12,RTM2RYRS+60(,RTM2PTR)                           0524
         ST    @12,RBGRS15(,R4)                                    0524
*               END;                /* RETRY REGS            @G33SPHW*/
*           ELSE                                                   0526
*             ;                     /* NO UPDATING NECESSARY FOR PRB */
@RF00516 DS    0H                                                  0527
*           IF RBFTP='110'B THEN    /* TEST IF SVRB                  */
@RC00516 TM    RBFTP(R4),B'11000000'                               0527
         BNO   @RF00527                                            0527
         TM    RBFTP(R4),B'00100000'                               0527
         BNZ   @RF00527                                            0527
*             IF R4^=RTM2VRBC THEN  /* TEST IF THIS IS CURRENT ABEND
*                                      SVRB                          */
         C     R4,RTM2VRBC(,RTM2PTR)                               0528
         BE    @RF00528                                            0528
*               DO;                                                0529
*                 RBOPSW(2)=RBOPSW(2)&KEY0SUPV;/* ENSURE RB IN KEY 0
*                                      & SUPERVISOR STATE BEFORE   0530
*                                      BRANCHING TO EXIT PROLOGUE  0530
*                                                            @YM02640*/
         NI    RBOPSW+1(R4),X'0E'                                  0530
*                 RBOPSW(5:8)=CVTEXPRO&PSWMASK;/* PTR TO EXIT      0531
*                                      PROLOGUE              @ZA10783*/
         L     @12,CVTPTR(,RTM2PTR)                                0531
         L     @12,CVTEXPRO(,@12)                                  0531
         N     @12,@CF00081                                        0531
         STCM  @12,15,RBOPSW+4(R4)                                 0531
*               END;                                               0532
*             ELSE                                                 0533
*               ;                   /* LEAVE ABEND SVRB ALONE        */
@RF00528 DS    0H                                                  0534
*           ELSE                    /* IF NOT AN SVRB                */
*             RBOPSW(5:8)=ADDR(CVTEXIT);/* INSERT SVC 3 IN RB PSW    */
         B     @RC00527                                            0534
@RF00527 L     @12,CVTPTR(,RTM2PTR)                                0534
         LA    @12,CVTEXIT(,@12)                                   0534
         STCM  @12,15,RBOPSW+4(R4)                                 0534
*           R4=RBLINKB;             /* UPDATE TO NEXT RB             */
@RC00527 L     @12,RBLINKB-1(,R4)                                  0535
         LA    @12,0(,@12)                                         0535
         LR    R4,@12                                              0535
*         END;                      /* END RB PROCESSING LOOP        */
@DE00513 C     R4,RTM2RYRB(,RTM2PTR)                               0536
         BNE   @DL00513                                            0536
*         RBWCF=NOWAIT;             /* ZERO WAIT COUNT IN RETRY RB   */
         MVI   RBWCF(R4),X'00'                                     0537
*         RBXWAIT=OFF;              /* ZERO EXPLICIT WAIT COUNT      */
         LR    @12,R4                                              0538
         AL    @12,@CF03727                                        0538
         NI    RBXWAIT-56(@12),B'10111111'                         0538
*         RBECBWT=OFF;              /* CLEAR MULTIPLE WAIT FLAG IN 0539
*                                      CASE ANOTHER WAIT IS DONE   0539
*                                      LATER                 @ZA05273*/
         NI    RBECBWT(R4),B'11111110'                             0539
*         RBOPSW(5:8)=RTM2RTYA&PSWMASK;/* RETRY ADDRESS IN RB      0540
*                                                            @ZA10183*/
         L     @12,RTM2RTYA(,RTM2PTR)                              0540
         N     @12,@CF00081                                        0540
         STCM  @12,15,RBOPSW+4(R4)                                 0540
*         IF RTM2AS1R=OFF&SCBSTAI=OFF&SCBSTAR=OFF&SCBESTAE=ON THEN/*
*                                      IF ESTAE TYPE ...     @ZA02950*/
         TM    RTM2AS1R(RTM2PTR),B'00000100'                       0541
         BNZ   @RF00541                                            0541
         TM    SCBESTAE(SCBPTR),B'00010000'                        0541
         BNO   @RF00541                                            0541
         TM    SCBSTAI(SCBPTR),B'11000000'                         0541
         BNZ   @RF00541                                            0541
*           DO;                     /* INSERT KEY & MODE OF SCB RB 0542
*                                                            @YM03578*/
*             RBOPSW(2)=RBOPSW(2)&KEYOFF;/* ZERO KEY IN RB PSW     0543
*                                                            @YM03578*/
         NI    RBOPSW+1(R4),X'0F'                                  0543
*             RBOPSW(2)=RBOPSW(2)|SCBPKEY;/* INSERT KEY IN RB PSW  0544
*                                                            @YM03578*/
         OC    RBOPSW+1(1,R4),SCBPKEY(SCBPTR)                      0544
*             IF SCBSUPER=ON THEN   /* IF SUPERVISOR MODE ...      0545
*                                                            @YM03578*/
         TM    SCBSUPER(SCBPTR),B'00000001'                        0545
         BNO   @RF00545                                            0545
*               RBOPSW(2)=RBOPSW(2)&PPMODOFF;/* INDICATE SUPERVISOR
*                                      MODE IN RB PSW        @YM03578*/
         NI    RBOPSW+1(R4),X'FE'                                  0546
*             ELSE                  /*                       @YM03578*/
*               RBOPSW(2)=RBOPSW(2)|PPMODEON;/* INDICATE PP MODE IN
*                                      RB PSW                @YM03578*/
         B     @RC00545                                            0547
@RF00545 OI    RBOPSW+1(R4),X'01'                                  0547
*             RBOPSW(1)=RBOPSW(1)|TRMODEON;/* INDICATE TRANSLATION 0548
*                                      MODE                  @ZA06796*/
@RC00545 OI    RBOPSW(R4),X'04'                                    0548
*             RBOPSW(1)=RBOPSW(1)|ENABLEON;/* INDICATE ENABLE MODE IN
*                                      RB PSW                @ZA06796*/
         OI    RBOPSW(R4),X'03'                                    0549
*           END;                    /* END RB PSW PROCESSING @YM03578*/
*         RESPECIFY                                                0551
*          (R9,                                                    0551
*           R4) UNRESTRICTED;                                      0551
@RF00541 DS    0H                                                  0552
*         ESAGLREC=ON;              /* SET RECURSION CONTROL @YM01826*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0552
         OI    ESAGLREC+96(@12),B'00010000'                        0552
*         DO;                       /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(RB,IEAVTAS3(RBTYPE))  */
*           RFY                                                    0554
*            (GPR11P,                                              0554
*             GPR12P,                                              0554
*             GPR13P,                                              0554
*             GPR14P) RSTD;                                        0554
*           GPR13P=PSALITA;         /* ADDRESS OF LOCK INTERFACE   0555
*                                      TABLE.                        */
         L     GPR13P,PSALITA                                      0555
*           GEN(LM GPR11P,GPR13P,588(GPR13P));/* LOAD LOCKWORD, CLHT
*                                      AND ENTRY ADRS.               */
         LM GPR11P,GPR13P,588(GPR13P)
*           GEN(BALR GPR14P,GPR13P);/* BALR TO SETLOCK RTN.          */
         BALR GPR14P,GPR13P
*           RFY                                                    0558
*            (GPR11P,                                              0558
*             GPR12P,                                              0558
*             GPR13P,                                              0558
*             GPR14P) UNRSTD;                                      0558
*         END;                      /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(RB,IEAVTAS3(RBTYPE))
*                                                            @YM01826*/
*         ESAGLREC=OFF;             /* RELEASE RECURSION CONTROL   0560
*                                                            @YM01826*/
         L     @12,RTM2VRBC(,RTM2PTR)                              0560
         NI    ESAGLREC+96(@12),B'11101111'                        0560
*       END;                        /* END RBTYPE1           @G33SPHW*/
*       IF RTM2AS1R=OFF&SCBESTAE=ON THEN/* NOT STAE OR ESTAE THOSE 0562
*                                      ARE NEVER REENTERED   @G33SPHW*/
         TM    RTM2AS1R(RTM2PTR),B'00000100'                       0562
         BNZ   @RF00562                                            0562
         TM    SCBESTAE(SCBPTR),B'00010000'                        0562
         BNO   @RF00562                                            0562
*         SCBINUSE=OFF;             /* ALLOW EXIT TO REENTER IF RETRY
*                                      IF ROUTINES FAIL      @G33SPHW*/
         NI    SCBINUSE(SCBPTR),B'11101111'                        0563
*     END;                          /* RBS ALL SETUP         @G33SPHW*/
@RF00562 DS    0H                                                  0565
*   R13=ADDR(RTM2TRSA);                                            0565
@RC00099 LA    R13,RTM2TRSA(,RTM2PTR)                              0565
*   RETURN CODE(0);                 /* RETURN TO IEAVTAS1            */
*                                                                  0566
         SLR   @15,@15                                             0566
         L     @14,12(,@13)                                        0566
         LM    @00,@12,20(@13)                                     0566
         BR    @14                                                 0566
*   /*****************************************************************/
*   /*                                                               */
*   /* FINDIOB SCANS THE IOB RESTORE CHAIN PASSED BY QUIESCE AND     */
*   /* DEQUEUES ALL IOBS PERTAINING TO THIS DCB. TO AVOID FIRST-TIME */
*   /* LOGIC, THE MAPPING OF THE IOB IS SUPERIMPOSED ON THE PIRL SO  */
*   /* THAT THE CHAIN FIELD COINCIDES WITH THE POINTER TO THE START  */
*   /* OF THE QUEUE                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0567
*FINDIOB:                                                          0567
*   PROCEDURE OPTIONS(NOSAVEAREA);                                 0567
@EL00001 DS    0H                                                  0567
@EF00001 DS    0H                                                  0567
@ER00001 LM    @14,@12,12(@13)                                     0567
         BR    @14                                                 0567
FINDIOB  STM   @14,@12,12(@13)                                     0567
*   IF RTM2IOQR=ON THEN             /* I/O WAS QUIESCED              */
         TM    RTM2IOQR(RTM2PTR),B'10000000'                       0568
         BNO   @RF00568                                            0568
*     DO;                                                          0569
*       RESPECIFY                                                  0570
*        (R2,                                                      0570
*         R8) RESTRICTED;           /* RESTRICT IOB PTR              */
*       R8=RTM2FIOB+(TWO*(LENGTH(PIRRSTR)+LENGTH(PIRDVRU)));/* EXCP
*                                      IS THIRD ENTRY IN PIRL        */
         LA    R8,16                                               0571
         L     @12,RTM2FIOB-1(,RTM2PTR)                            0571
         LA    @12,0(,@12)                                         0571
         ALR   R8,@12                                              0571
*       IF PIRRSTR^=ZERO THEN                                      0572
         L     @12,PIRRSTR(,R8)                                    0572
         LTR   @12,@12                                             0572
         BZ    @RF00572                                            0572
*         DO;                                                      0573
*           R2=ADDR(PIRRSTR)-EVAL(ADDR(IOBRESTR)-ADDR(IOBSTDRD));/*
*                                      SUPERIMPOSE IOB MAPPING ON  0574
*                                      PIRL                          */
         LA    @12,PIRRSTR(,R8)                                    0574
         SL    @12,@CF00068                                        0574
         LR    R2,@12                                              0574
*           DO WHILE(IOBRSTRB^=NOIOB);/* LOOP UNTIL CHAIN EXHAUSTED  */
         B     @DE00575                                            0575
@DL00575 DS    0H                                                  0576
*             IF IOBRESTR->IOBDCBPB=RTM2DCBA THEN/* NEXT IOB BELONGS
*                                      TO DCB TO BE CLOSED           */
         L     @12,IOBRESTR(,R2)                                   0576
         L     @12,IOBDCBPB-1(,@12)                                0576
         LA    @12,0(,@12)                                         0576
         C     @12,RTM2DCBA(,RTM2PTR)                              0576
         BNE   @RF00576                                            0576
*               IOBRSTRB=IOBRSTRB->IOBRSTRB;/* DELETE IOB FROM QUEUE */
         L     @12,IOBRSTRB-1(,R2)                                 0577
         L     @12,IOBRSTRB-1(,@12)                                0577
         LA    @12,0(,@12)                                         0577
         STCM  @12,7,IOBRSTRB(R2)                                  0577
*             ELSE                  /* NEXT IOB DOES NOT BELONG TO 0578
*                                      DCB TO BE CLOSED              */
*               R2=IOBRSTRB;        /* LOCATE NEXT IOB               */
         B     @RC00576                                            0578
@RF00576 L     @12,IOBRSTRB-1(,R2)                                 0578
         LA    @12,0(,@12)                                         0578
         LR    R2,@12                                              0578
*           END;                    /* END OF IOB SCAN               */
@RC00576 DS    0H                                                  0579
@DE00575 CLC   IOBRSTRB(3,R2),@CF00069+1                           0579
         BNE   @DL00575                                            0579
*           IF PIRRSTRA=NOIOB THEN  /* TEST IF ENTIRE CHAIN DEQUEUED
*                                                            @YM02673*/
         CLC   PIRRSTRA(3,R8),@CF00069+1                           0580
         BNE   @RF00580                                            0580
*             PIRRSTR=ZERO;         /* INDICATE END OF CHAIN IN PIRL */
         SLR   @12,@12                                             0581
         ST    @12,PIRRSTR(,R8)                                    0581
*         END;                                                     0582
@RF00580 DS    0H                                                  0583
*       RESPECIFY                                                  0583
*        (R2,                                                      0583
*         R8) UNRESTRICTED;                                        0583
@RF00572 DS    0H                                                  0584
*     END;                                                         0584
*   END FINDIOB;                                                   0585
@EL00002 DS    0H                                                  0585
@EF00002 DS    0H                                                  0585
@ER00002 LM    @14,@12,12(@13)                                     0585
         BR    @14                                                 0585
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     0586
*     GPR01F FIXED(31) REG(1),                                     0586
*     GPR15F FIXED(31) REG(15),                                    0586
*     GPR00P PTR(31) REG(0),                                       0586
*     GPR01P PTR(31) REG(1),                                       0586
*     GPR11P PTR(31) REG(11),                                      0586
*     GPR12P PTR(31) REG(12),                                      0586
*     GPR13P PTR(31) REG(13),                                      0586
*     GPR14P PTR(31) REG(14),                                      0586
*     GPR15P PTR(31) REG(15);                                      0586
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0587
*     I031F FIXED(31) BASED,                                       0587
*     I031P PTR(31) BASED,                                         0587
*     I015F FIXED(15) BASED,                                       0587
*     I015P PTR(15) BASED,                                         0587
*     I008P PTR(8) BASED,                                          0587
*     I001C CHAR(1) BASED;                                         0587
*   END IEAVTAS3                                                   0588
*                                                                  0588
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (AS3SPEC )                                       */
*/*%INCLUDE SYSLIB  (AS3DCLS )                                       */
*/*%INCLUDE SYSLIB  (IHARTM2A)                                       */
*/*%INCLUDE SYSLIB  (IHASNP  )                                       */
*/*%INCLUDE SYSLIB  (IHARMPL )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASCB  )                                       */
*/*%INCLUDE SYSLIB  (IHACDE  )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IEZIOB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IECDPIRL)                                       */
*/*%INCLUDE SYSLIB  (RTM2ESA )                                       */
*/*%INCLUDE SYSLIB  (AS3PATCH)                                       */
*/*%INCLUDE SYSLIB  (FINDRB  )                                       */
*/*%INCLUDE SYSLIB  (RBPRGE  )                                       */
*/*%INCLUDE SYSLIB  (CLOSEDS )                                       */
*/*%INCLUDE SYSLIB  (FINDDCBS)                                       */
*/*%INCLUDE SYSLIB  (PGMMPRGE)                                       */
*/*%INCLUDE SYSLIB  (PAGEPRGE)                                       */
*/*%INCLUDE SYSLIB  (RBTYPE  )                                       */
*/*%INCLUDE SYSLIB  (RBTYPE  )                                       */
*/*%INCLUDE SYSLIB  (PARMREGS)                                       */
*/*%INCLUDE SYSLIB  (PARMREGS)                                       */
*/*%INCLUDE SYSLIB  (RTRYSDWA)                                       */
*/*%INCLUDE SYSLIB  (SCBUPDAT)                                       */
*/*%INCLUDE SYSLIB  (SCBPERC )                                       */
*/*%INCLUDE SYSLIB  (RECURSE3)                                       */
*/*%INCLUDE SYSLIB  (RBTYPE1 )                                       */
*/*%INCLUDE SYSLIB  (FINDIOB )                                       */
*                                                                  0588
*       ;                                                          0588
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IEAVTAS3 CSECT
         DS    0F
@CF00092 DC    F'1'
@CF00068 DC    F'24'
@CF00472 DC    F'64'
@CF03678 DC    F'104'
@CF03727 DC    F'-8'
@CF03717 DC    F'-4'
@CF00081 DC    XL4'00FFFFFF'
@CF00069 DC    XL4'FFFFFF'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVTAS3 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00059 DC    V(IEAVTPMT)
@CV00066 DC    V(RECURSE)
         DS    0D
@CB03724 DC    X'00'
         DS    CL3
AS3PATCH DC    CL160'PATCH AREA'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
RTM2PTR  EQU   @03
R4       EQU   @04
SCBPTR   EQU   @05
SDWAPTR  EQU   @07
R8       EQU   @08
R9       EQU   @09
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR01F   EQU   @01
GPR15F   EQU   @15
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR15P   EQU   @15
R10      EQU   @10
R15      EQU   @15
R6       EQU   @06
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
AEXITRM  EQU   0
DATAMGR  EQU   0
IEAPTERM EQU   0
IEAQPGTM EQU   0
IEAVENQ2 EQU   0
IEECVPRG EQU   0
IEAPPGMA EQU   0
IEAVSPIE EQU   0
RSAVE    EQU   0
SNPPARMS EQU   0
SNPFLAG  EQU   SNPPARMS+1
SNPSDATA EQU   SNPPARMS+4
SNPSDAT0 EQU   SNPSDATA
SNPSDAT1 EQU   SNPSDATA+1
SNPPDATA EQU   SNPPARMS+6
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RMPLTYPE EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLTCBA EQU   RMPL+8
RMPLRBPA EQU   RMPL+12
RMPLDCBL EQU   RMPL+20
RTM2WA   EQU   0
RTM2DESC EQU   RTM2WA
RTM2RT2D EQU   RTM2DESC+8
RTM2CVT  EQU   RTM2WA+12
RTM2TCBC EQU   RTM2WA+16
RTM2VRBC EQU   RTM2WA+20
RTM2CODE EQU   RTM2WA+28
RTM2CCF  EQU   RTM2CODE
RTM2DREQ EQU   RTM2CCF
RTM2CC   EQU   RTM2CODE+1
RTM2PGCY EQU   RTM2WA+60
RTM2TRRY EQU   RTM2PGCY
RTM2EEDR EQU   RTM2TRRY
RTM2EREG EQU   RTM2EEDR
RTM2APSW EQU   RTM2EEDR+64
RTM2EPSW EQU   RTM2APSW
RTM2EMK1 EQU   RTM2EPSW
RTM2MWP1 EQU   RTM2EPSW+1
RTM2INT1 EQU   RTM2EPSW+2
RTM2NXT1 EQU   RTM2EPSW+4
RTM2AEC1 EQU   RTM2APSW+8
RTM2ILC1 EQU   RTM2AEC1+1
RTM2INC1 EQU   RTM2AEC1+2
RTM2ICD1 EQU   RTM2INC1+1
RTM2EEDH EQU   RTM2TRRY+92
RTM2STCK EQU   RTM2EEDH
RTM2MCHI EQU   RTM2EEDH+8
RTM2MCHS EQU   RTM2MCHI
RTM2MCHD EQU   RTM2MCHI+1
RTM2RSR1 EQU   RTM2EEDH+12
RTM2RSR2 EQU   RTM2EEDH+13
RTM2FLGS EQU   RTM2TRRY+120
RTM2ERRA EQU   RTM2FLGS
RTM2ERRB EQU   RTM2FLGS+1
RTM2ERRC EQU   RTM2FLGS+2
RTM2STAI EQU   RTM2ERRC
RTM2PERC EQU   RTM2ERRC
RTM2EAS  EQU   RTM2ERRC
RTM2ERRD EQU   RTM2FLGS+3
RTM2CLUP EQU   RTM2ERRD
RTM2CVER EQU   RTM2WA+186
RTM2TRRC EQU   RTM2CVER
RTM2IOFS EQU   RTM2TRRC
RTM2IOQR EQU   RTM2IOFS
RTM2IOBP EQU   RTM2TRRC+2
RTM2FIOB EQU   RTM2IOBP+1
RTM2STAR EQU   RTM2TRRC+10
RTM2SCBS EQU   RTM2TRRC+14
RTM2SCBC EQU   RTM2SCBS
RTM2SCBN EQU   RTM2SCBS+4
RTM2SCBO EQU   RTM2SCBS+8
RTM2RTCD EQU   RTM2TRRC+26
RTM2RTCA EQU   RTM2RTCD
RTM2SPLL EQU   RTM2RTCD+4
RTM2SUBP EQU   RTM2SPLL
RTM2SIZE EQU   RTM2SPLL+1
RTM2COMP EQU   RTM2TRRC+34
RTM2RTYA EQU   RTM2TRRC+38
RTM2RYRB EQU   RTM2TRRC+42
RTM2PARQ EQU   RTM2TRRC+46
RTM2RCDE EQU   RTM2PARQ
RTM2CTL1 EQU   RTM2CVER+50
RTM2CMKA EQU   RTM2CTL1
RTM2MWPA EQU   RTM2CTL1+1
RTM2PMKA EQU   RTM2CTL1+4
RTM2CTL2 EQU   RTM2CVER+58
RTM2CMKP EQU   RTM2CTL2
RTM2MWPP EQU   RTM2CTL2+1
RTM2PMKP EQU   RTM2CTL2+4
RTM2SNAP EQU   RTM2CVER+66
RTM2SPRM EQU   RTM2SNAP+4
RTM2DPSL EQU   RTM2SNAP+24
RTM2FRM1 EQU   RTM2DPSL
RTM2TO1  EQU   RTM2DPSL+4
RTM2FRM2 EQU   RTM2DPSL+8
RTM2TO2  EQU   RTM2DPSL+12
RTM2FRM3 EQU   RTM2DPSL+16
RTM2TO3  EQU   RTM2DPSL+20
RTM2FRM4 EQU   RTM2DPSL+24
RTM2TO4  EQU   RTM2DPSL+28
RTM2SECB EQU   RTM2CVER+138
RTM2ECBA EQU   RTM2SECB
RTM2DCBA EQU   RTM2CVER+170
RTM2PREV EQU   RTM2CVER+178
RTM2PRWA EQU   RTM2CVER+182
RTM2SFRG EQU   RTM2CVER+186
RTM2SCTL EQU   RTM2CVER+259
RTM2CCTL EQU   RTM2SCTL
RTM2ABDR EQU   RTM2SCTL+4
RTM2ABID EQU   RTM2ABDR
RTM2ABND EQU   RTM2ABDR+1
RTM2RCTL EQU   RTM2SCTL+6
RTM2STA2 EQU   RTM2RCTL
RTM2WAIN EQU   RTM2RCTL
RTM2WANA EQU   RTM2RCTL
RTM2INTF EQU   RTM2CVER+266
RTM2CTLR EQU   RTM2INTF
RTM2RETR EQU   RTM2CTLR
RTM2TSKT EQU   RTM2INTF+2
RTM2ABDP EQU   RTM2INTF+4
RTM2ASIR EQU   RTM2INTF+5
RTM2UPRG EQU   RTM2ASIR
RTM2FLX  EQU   RTM2INTF+6
RTM2FLX1 EQU   RTM2FLX
RTM2FLX2 EQU   RTM2FLX+1
RTM2RECL EQU   RTM2CVER+274
RTM2DCTL EQU   RTM2RECL+12
RTM2ECTL EQU   RTM2RECL+13
RTM2TRYR EQU   RTM2RECL+16
RTM2TRF1 EQU   RTM2TRYR
RTM2FMS  EQU   RTM2TRF1
RTM2RTYS EQU   RTM2TRF1+1
RTM2XABD EQU   RTM2TRF1+1
RTM2XFLG EQU   RTM2TRF1+1
RTM2AS1R EQU   RTM2TRF1+1
RTM2AS2R EQU   RTM2TRF1+1
RTM2AS3R EQU   RTM2TRF1+1
RTM2TRF2 EQU   RTM2TRYR+2
RTM2RECH EQU   RTM2CVER+294
RTM2TRRA EQU   RTM2RECH
RTM2RRG  EQU   RTM2CVER+314
RTM2RREG EQU   RTM2RRG
RTM2CRG  EQU   RTM2CVER+378
RTM2TRSA EQU   RTM2CVER+450
RTM2RMIN EQU   RTM2WA+708
RTM2RMPS EQU   RTM2RMIN
RTM2RMPL EQU   RTM2RMIN+4
RTM2RMWA EQU   RTM2RMIN+28
RTM2RMSA EQU   RTM2RMIN+92
RTM2ERID EQU   RTM2WA+872
RTM2ENSN EQU   RTM2WA+884
RTM2SNLN EQU   RTM2ENSN
RTM2RYRG EQU   RTM2WA+904
RTM2RYRS EQU   RTM2RYRG
STORAGE  EQU   0
STORFRM  EQU   STORAGE
STORTO   EQU   STORAGE+4
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACMPC EQU   SDWAABCC+1
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAIOBR EQU   SDWA+100
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWALNTH EQU   SDWAIDNT+1
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAEAS  EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWACOMP EQU   SDWA+392
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SCB      EQU   0
SCBCHAIN EQU   SCB
SCBPARM  EQU   SCB+8
SCBFLGS1 EQU   SCBPARM
SCBSTAI  EQU   SCBFLGS1
SCBSTAR  EQU   SCBFLGS1
SCBESTAE EQU   SCBFLGS1
SCBIOPRC EQU   SCBFLGS1
SCBPARMA EQU   SCBPARM+1
SCBOWNR  EQU   SCB+12
SCBFLGS2 EQU   SCBOWNR
SCBINUSE EQU   SCBFLGS2
SCBSUPER EQU   SCBFLGS2
SCBOWNRA EQU   SCBOWNR+1
SCBDATA  EQU   SCB+16
SCBFLGS3 EQU   SCBDATA
SCBPKEY  EQU   SCBDATA+1
CDENTPTR EQU   0
CDENTRY  EQU   0
CDXLMJP  EQU   CDENTRY+20
CDATTR   EQU   CDENTRY+28
CDNIC    EQU   CDATTR
CDMIN    EQU   CDATTR
CDATTR2  EQU   CDENTRY+29
CDXLE    EQU   CDATTR2
RTCT     EQU   0
RTCTPLIB EQU   RTCT+4
RTCTSAP  EQU   RTCTPLIB
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSAP3 EQU   RTCTSAP+2
RTCTSUP  EQU   RTCTPLIB+4
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSUP3 EQU   RTCTSUP+2
RTCTSYD  EQU   RTCTPLIB+8
RTCTSY01 EQU   RTCTSYD
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTSDPL EQU   RTCT+156
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
RTCTOPT  EQU   RTCT+236
RTCTASO  EQU   RTCT+252
RTCTASO1 EQU   RTCTASO
RTCTASO2 EQU   RTCTASO+1
RTCTSDI  EQU   RTCT+254
RTCTSDF  EQU   RTCT+264
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTR2D2 EQU   RTCTSDF+2
RTCTC3PO EQU   RTCTSDF+3
RTCTSDF3 EQU   RTCT+268
RTCTSDF4 EQU   RTCTSDF3+2
RTCTMOPT EQU   0
RTCTMSAO EQU   RTCTMOPT
RTCTSASD EQU   RTCTMSAO
RTCTSAO1 EQU   RTCTSASD
RTCTSAO2 EQU   RTCTSASD+1
RTCTSAPD EQU   RTCTMSAO+2
RTCTSAO3 EQU   RTCTSAPD
RTCTSAO4 EQU   RTCTSAPD+1
RTCTSAMG EQU   RTCTSAO4
RTCTMSUO EQU   RTCTMOPT+4
RTCTSUSD EQU   RTCTMSUO
RTCTSUO1 EQU   RTCTSUSD
RTCTSUO2 EQU   RTCTSUSD+1
RTCTSUPD EQU   RTCTMSUO+2
RTCTSUO3 EQU   RTCTSUPD
RTCTSUO4 EQU   RTCTSUPD+1
RTCTSUMG EQU   RTCTSUO4
RTCTMSYO EQU   RTCTMOPT+8
RTCTSD01 EQU   RTCTMSYO
RTCTSD04 EQU   RTCTMSYO+3
RTCTSMMG EQU   RTCTSD04
RTCTMSDO EQU   RTCTMOPT+12
RTCTSDOD EQU   RTCTMSDO
RTCTSDO1 EQU   RTCTSDOD
RTCTSDO2 EQU   RTCTSDOD+1
RTCTSDO3 EQU   RTCTMSDO+2
RTCTSDO4 EQU   RTCTMSDO+3
RTCTSDMG EQU   RTCTSDO4
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTEXIT  EQU   CVTMAP+80
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTABEND EQU   CVTMAP+200
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
DEBDAPTR EQU   0
DEBEXPTR EQU   0
DEBSBPTR EQU   0
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBDEBB  EQU   DEBDEBAD+1
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBDCBB  EQU   DEBDCBAD+1
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IOBPRPTR EQU   0
IOBPREFX EQU   0
IOBCFLG1 EQU   IOBPREFX
IOBSTDRD EQU   0
IOBFLAG1 EQU   IOBSTDRD
IOBCYCCK EQU   IOBFLAG1
IOBRSTRT EQU   IOBFLAG1
IOBFLAG2 EQU   IOBSTDRD+1
IOBPURGE EQU   IOBFLAG2
IOBRDHA0 EQU   IOBFLAG2
IOBSENS0 EQU   IOBSTDRD+2
IOBS0B7  EQU   IOBSENS0
IOBSENS1 EQU   IOBSTDRD+3
IOBECBPT EQU   IOBSTDRD+4
IOBFLAG3 EQU   IOBSTDRD+8
IOBFL3   EQU   IOBFLAG3
IOBCNC   EQU   IOBFL3
IOBICL   EQU   IOBFL3
IOBCSW   EQU   IOBSTDRD+9
IOBIOCSW EQU   IOBCSW
IOBSTBYT EQU   IOBIOCSW+3
IOBUSTAT EQU   IOBSTBYT
IOBCSTAT EQU   IOBSTBYT+1
IOBSTART EQU   IOBSTDRD+16
IOBDCBPT EQU   IOBSTDRD+20
IOBFLAG4 EQU   IOBDCBPT
IOBDCBPB EQU   IOBDCBPT+1
IOBRESTR EQU   IOBSTDRD+24
IOBRSTRB EQU   IOBRESTR+1
IOBINCAM EQU   IOBSTDRD+28
IOBBTAMF EQU   IOBINCAM
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBEXSAVE EQU   XRBESA
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBXWAIT  EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00124 EQU   RBSECT+10
@NM00125 EQU   @NM00124
RBFTP    EQU   @NM00125
RBTRSVRB EQU   @NM00125
RBPMSVRB EQU   @NM00125
@NM00127 EQU   @NM00124+1
RBETXR   EQU   @NM00127
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00134 EQU   RBSECT+28
@NM00135 EQU   @NM00134
IRBEND   EQU   RBSECT+96
@NM00138 EQU   RBSECT+96
RBRSV138 EQU   @NM00138+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
SCVTSECT EQU   0
SCVTPGTM EQU   SCVTSECT
SCVTPGWR EQU   SCVTSECT+4
SCVTPTRM EQU   SCVTSECT+164
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBDEB   EQU   TCB+8
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBJSTCA EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
PIRL     EQU   0
PIRRSTR  EQU   PIRL+4
PIRDVRU  EQU   PIRL+8
RTM2ESA  EQU   0
ESAREGS  EQU   RTM2ESA
ESAR1    EQU   ESAREGS+4
ESACCF1  EQU   ESAR1
ESART2D  EQU   RTM2ESA+36
ESAFLAGS EQU   RTM2ESA+40
ESARFLAG EQU   RTM2ESA+41
ESAGLREC EQU   ESARFLAG
ESACMP   EQU   RTM2ESA+44
ESACCF   EQU   ESACMP
XTLST    EQU   0
XTLNRFAC EQU   XTLST+4
XTLMSBLA EQU   XTLST+8
XTLMSBLN EQU   XTLMSBLA+1
XTLMSBAA EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVTPTR   EQU   RTM2CVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRTMCT EQU   CVTS01+224
CVTEXPRO EQU   CVTS01+260
CVTPARRL EQU   CVTS01+280
CVTRENQ  EQU   CVTS01+300
CVTRSPIE EQU   CVTS01+304
CVTDQIQE EQU   CVTS01+316
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVT0TC0A EQU   CVTS01+504
CVTGSDA  EQU   CVTS01+600
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
IOBORG01 EQU   IOBPREFX+8
IOBNIOBA EQU   IOBORG01
IOBNFLG1 EQU   IOBNIOBA
IOBPRTOV EQU   IOBNFLG1
IOBORG02 EQU   IOBPREFX+8
IOBDQADA EQU   IOBORG02
IOBDEQIN EQU   IOBDQADA
IOBORG03 EQU   IOBPREFX+12
IOBORG04 EQU   IOBINCAM
IOBORG12 EQU   IOBINCAM
IOBFL4   EQU   IOBORG12
IOBEXTEN EQU   IOBSTDRD+32
IOBSEEK  EQU   IOBEXTEN
IOBBB    EQU   IOBSEEK+1
IOBCC    EQU   IOBSEEK+3
IOBHH    EQU   IOBSEEK+5
IOBORG05 EQU   IOBEXTEN
IOBORG06 EQU   IOBEXTEN
IOBNXTPT EQU   IOBORG06+4
IOBSTATA EQU   IOBNXTPT
IOBORG07 EQU   IOBEXTEN+8
W1IEXTEN EQU   IOBORG07
IOBORG08 EQU   IOBEXTEN+8
IOBINDCT EQU   IOBORG08+4
IOBUNSQR EQU   IOBORG08+5
IOBFCHAD EQU   IOBORG08+8
IOBORG09 EQU   IOBEXTEN+8
IOBDPLAD EQU   IOBORG09+4
IOBDTYPE EQU   IOBORG09+8
IOBDTYP2 EQU   IOBORG09+9
IOBDSTAT EQU   IOBORG09+10
IOBSTAT1 EQU   IOBDSTAT
IOBORG10 EQU   IOBEXTEN+8
IOBSEEK2 EQU   IOBORG10
IOBORG11 EQU   IOBEXTEN
IOBERCT  EQU   IOBORG11
IOBUCBXV EQU   IOBERCT
IOBNAME  EQU   IOBORG11+4
IOBORG13 EQU   IOBEXTEN
IOBSKADR EQU   IOBORG13
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBCDE1   EQU   RBCDE+1
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
SCVTSPTR EQU   CVTABEND
PSARSVTE EQU   PSARSVT
TCBPTR   EQU   RTM2TCBC
PIRRSTRA EQU   PIRRSTR+1
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00139 EQU   RBSQE
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
IOBSKSS  EQU   IOBSKADR+3
IOBSK0   EQU   IOBSKADR+2
IOBSKTT  EQU   IOBSKADR+1
IOBSKRV  EQU   IOBSKADR
IOBCSWSV EQU   IOBORG11+17
IOBSENSV EQU   IOBORG11+16
IOBRCD   EQU   IOBORG11+12
IOBMDREC EQU   IOBORG11+8
IOBNAMEA EQU   IOBNAME+1
IOBNAMSZ EQU   IOBNAME
IOBERCTA EQU   IOBERCT+1
IOBRTYPE EQU   IOBUCBXV
IOBRDCHP EQU   IOBORG10+20
IOBNEXTA EQU   IOBORG10+16
IOBREADA EQU   IOBORG10+12
IOBBUFC  EQU   IOBORG10+8
IOBSK2R  EQU   IOBSEEK2+7
IOBSK2HH EQU   IOBSEEK2+5
IOBSK2CC EQU   IOBSEEK2+3
IOBSK2BB EQU   IOBSEEK2+1
IOBSK2M  EQU   IOBSEEK2
IOBCHNPR EQU   IOBORG09+40
IOBDNCRF EQU   IOBORG09+32
IOBRSV35 EQU   IOBORG09+24
IOBDQPTR EQU   IOBORG09+20
IOBRSV34 EQU   IOBORG09+18
IOBDBYTN EQU   IOBORG09+16
IOBDCPND EQU   IOBORG09+12
IOBSTAT2 EQU   IOBDSTAT+1
IOBSIORT EQU   IOBSTAT1
IOBADDVU EQU   IOBSTAT1
IOBBUFF  EQU   IOBSTAT1
IOBENQUE EQU   IOBSTAT1
IOBPASS2 EQU   IOBSTAT1
IOBSYNCH EQU   IOBSTAT1
IOBNEWVL EQU   IOBSTAT1
IOBABNRM EQU   IOBSTAT1
IOBRELEX EQU   IOBDTYP2
IOBADDTY EQU   IOBDTYP2
IOBTYPE  EQU   IOBDTYP2
IOBRQUST EQU   IOBDTYP2
IOBSUFFX EQU   IOBDTYP2
IOBSBLKL EQU   IOBDTYP2
IOBSKEY  EQU   IOBDTYP2
IOBRELBL EQU   IOBDTYPE
IOBRDEXC EQU   IOBDTYPE
IOBDYNBF EQU   IOBDTYPE
IOBACTAD EQU   IOBDTYPE
IOBFDBCK EQU   IOBDTYPE
IOBEXTSC EQU   IOBDTYPE
IOBOVFLO EQU   IOBDTYPE
IOBVERFY EQU   IOBDTYPE
IOBDPLB  EQU   IOBDPLAD+1
IOBDAYLI EQU   IOBDPLAD
IOBDIOBS EQU   IOBORG09+2
IOBDBYTR EQU   IOBORG09
IOBBCHAD EQU   IOBORG08+12
IOBFCHNB EQU   IOBFCHAD+1
IOBCOUNT EQU   IOBFCHAD
IOBASYN  EQU   IOBORG08+7
IOBAPP   EQU   IOBORG08+6
IOBRSV32 EQU   IOBUNSQR
IOBRSV31 EQU   IOBUNSQR
IOBRSV30 EQU   IOBUNSQR
IOBKNRWR EQU   IOBUNSQR
IOBKNWR  EQU   IOBUNSQR
IOBNTAV2 EQU   IOBUNSQR
IOBNTAV1 EQU   IOBUNSQR
IOBCPBSY EQU   IOBUNSQR
IOBCHNNL EQU   IOBINDCT
IOBRSV29 EQU   IOBINDCT
IOBRSV28 EQU   IOBINDCT
IOBRSV27 EQU   IOBINDCT
IOBKEYAD EQU   IOBINDCT
IOBOVPTR EQU   IOBINDCT
IOBUNSCH EQU   IOBINDCT
IOBDEQCP EQU   IOBINDCT
IOBCCWAD EQU   IOBORG08
W1OEXTEN EQU   W1IEXTEN
IOBCCW   EQU   IOBORG06+8
IOBNXTPB EQU   IOBNXTPT+1
IOBRSV26 EQU   IOBSTATA
IOBRSV25 EQU   IOBSTATA
IOBRSV24 EQU   IOBSTATA
IOBRSV23 EQU   IOBSTATA
IOBRSV22 EQU   IOBSTATA
IOBRSV21 EQU   IOBSTATA
IOBRSV20 EQU   IOBSTATA
IOBAVLFL EQU   IOBSTATA
IOBRSV37 EQU   IOBORG06+1
IOBUCBXG EQU   IOBORG06
IOBCPA   EQU   IOBORG05+32
IOBERINF EQU   IOBORG05+16
IOBERCCW EQU   IOBORG05+8
IOBSNDPT EQU   IOBORG05+7
IOBRCVPT EQU   IOBORG05+6
IOBWORK  EQU   IOBORG05+1
IOBUCBX  EQU   IOBORG05
IOBR     EQU   IOBSEEK+7
IOBHH2   EQU   IOBHH+1
IOBHH1   EQU   IOBHH
IOBCC2   EQU   IOBCC+1
IOBCC1   EQU   IOBCC
IOBBB2   EQU   IOBBB+1
IOBBB1   EQU   IOBBB
IOBM     EQU   IOBSEEK
IOBRSV46 EQU   IOBFL4
IOBRSV47 EQU   IOBFL4
IOBENT   EQU   IOBFL4
IOBEQP   EQU   IOBFL4
IOBBUS   EQU   IOBFL4
IOBDCK   EQU   IOBFL4
IOBREJ   EQU   IOBFL4
IOBOVR   EQU   IOBFL4
IOBCRILC EQU   IOBORG04+1
IOBCRDCC EQU   IOBORG04
IOBGQECB EQU   IOBORG03
IOBSWAP  EQU   IOBORG02+4
IOBDQADB EQU   IOBDQADA+1
IOBRSV13 EQU   IOBDEQIN
IOBRSV12 EQU   IOBDEQIN
IOBRSV11 EQU   IOBDEQIN
IOBRSV10 EQU   IOBDEQIN
IOBRSV09 EQU   IOBDEQIN
IOBRSV08 EQU   IOBDEQIN
IOBRSV07 EQU   IOBDEQIN
IOBDEQ   EQU   IOBDEQIN
IOBNECB  EQU   IOBORG01+4
IOBNIOBB EQU   IOBNIOBA+1
IOBFIRST EQU   IOBNFLG1
IOBUPERR EQU   IOBNFLG1
IOBSPAN  EQU   IOBNFLG1
IOBBKSPC EQU   IOBNFLG1
IOBUPDAT EQU   IOBNFLG1
IOBREAD  EQU   IOBNFLG1
IOBWRITE EQU   IOBNFLG1
IOBSEGMT EQU   IOBPRTOV
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00200 EQU   XTLMSBLA
XTLLNTH  EQU   XTLST
ESACC    EQU   ESACMP+1
@NM00199 EQU   ESACCF
ESAASID  EQU   ESACCF
ESANOCC  EQU   ESACCF
ESAR0DP  EQU   ESACCF
ESASTEP  EQU   ESACCF
ESADREQ  EQU   ESACCF
ESAMODE  EQU   RTM2ESA+43
ESAERTYP EQU   RTM2ESA+42
@NM00198 EQU   ESARFLAG
ESASLIPR EQU   ESARFLAG
ESARTCR  EQU   ESARFLAG
ESAFERR  EQU   ESARFLAG
ESAINREC EQU   ESARFLAG
ESASDREC EQU   ESARFLAG
ESAGMREC EQU   ESARFLAG
@NM00197 EQU   ESAFLAGS
ESAVEOM  EQU   ESAFLAGS
ESAEOT   EQU   ESAFLAGS
ESANEOT  EQU   ESAFLAGS
ESACTS   EQU   ESAFLAGS
ESAPGNLY EQU   ESAFLAGS
ESAABTRM EQU   ESAFLAGS
ESARTM2  EQU   ESAFLAGS
ESAWLEN  EQU   ESART2D+1
ESAWSPID EQU   ESART2D
ESART2WA EQU   RTM2ESA+32
ESAEEDQ  EQU   RTM2ESA+28
ESAR14   EQU   ESAREGS+24
ESAR7    EQU   ESAREGS+20
ESAR5    EQU   ESAREGS+16
ESAR4    EQU   ESAREGS+12
ESAR3    EQU   ESAREGS+8
ESACC1   EQU   ESAR1+1
@NM00196 EQU   ESACCF1
ESAEOT1  EQU   ESACCF1
ESAEOM1  EQU   ESACCF1
ESAR0DP1 EQU   ESACCF1
ESASTEP1 EQU   ESACCF1
ESADREQ1 EQU   ESACCF1
ESAR0    EQU   ESAREGS
PIREND   EQU   PIRL+12
@NM00195 EQU   PIRL+2
PIRCNT   EQU   PIRL+1
PIROPT   EQU   PIRL
@NM00194 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00193 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00192 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00191 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
@NM00166 EQU   SCVTSECT+180
@NM00165 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00164 EQU   SCVTSECT+168
@NM00163 EQU   SCVTSECT+160
@NM00162 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
SCVTSTAT EQU   SCVTSECT+148
@NM00161 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00160 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00159 EQU   SCVTSECT+128
@NM00158 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00157 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00156 EQU   SCVTSECT+108
@NM00155 EQU   SCVTSECT+104
@NM00154 EQU   SCVTSECT+100
@NM00153 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00152 EQU   SCVTSECT+88
@NM00151 EQU   SCVTSECT+84
@NM00150 EQU   SCVTSECT+80
@NM00149 EQU   SCVTSECT+76
@NM00148 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00147 EQU   SCVTSECT+56
@NM00146 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00145 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00144 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00143 EQU   SCVTSECT+24
@NM00142 EQU   SCVTSECT+20
@NM00141 EQU   SCVTSECT+16
@NM00140 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00138+8
PRBEND   EQU   @NM00138+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00138+6
RBRSV136 EQU   @NM00138+4
RBRSV135 EQU   @NM00138
@NM00137 EQU   RBSECT+32
@NM00136 EQU   @NM00134+1
RBSCF    EQU   @NM00135
RBPGMQ1  EQU   RBPGMQ+1
@NM00133 EQU   RBPGMQ
@NM00132 EQU   RBSECT+16
@NM00131 EQU   @NM00127
@NM00130 EQU   @NM00127
RBIQETP  EQU   @NM00127
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00127
@NM00129 EQU   @NM00127
@NM00128 EQU   @NM00127
RBATNXIT EQU   @NM00125
@NM00126 EQU   @NM00125
RBWAITP  EQU   @NM00125
RBFNSVRB EQU   RBTRSVRB
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00123 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00122 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00121 EQU   RBOPSWB2
@NM00120 EQU   XRBPSW
@NM00119 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00118 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00117 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00116 EQU   XSTAB1
@NM00115 EQU   RBBASIC+8
@NM00114 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00113 EQU   RBPRFX
IOBERRCT EQU   IOBSTDRD+30
IOBRSV19 EQU   IOBINCAM+1
IOBOLTST EQU   IOBBTAMF
IOBRFTMG EQU   IOBBTAMF
IOBRSV17 EQU   IOBBTAMF
IOBRSV16 EQU   IOBBTAMF
IOBRSV15 EQU   IOBBTAMF
IOBRSV14 EQU   IOBBTAMF
IOBINUSE EQU   IOBBTAMF
IOBPRMER EQU   IOBBTAMF
IOBREPOS EQU   IOBRESTR
IOBRSV44 EQU   IOBFLAG4
IOBJES3I EQU   IOBFLAG4
IOBRSV42 EQU   IOBFLAG4
IOBRSV41 EQU   IOBFLAG4
IOBRSV40 EQU   IOBFLAG4
IOBPMERR EQU   IOBFLAG4
IOBCC3WE EQU   IOBFLAG4
IOBGDPOL EQU   IOBFLAG4
IOBSTRTB EQU   IOBSTART+1
IOBSIOCC EQU   IOBSTART
IOBCSB7  EQU   IOBCSTAT
IOBCSB6  EQU   IOBCSTAT
IOBCSB5  EQU   IOBCSTAT
IOBCSB4  EQU   IOBCSTAT
IOBCSB3  EQU   IOBCSTAT
IOBCSB2  EQU   IOBCSTAT
IOBCSB1  EQU   IOBCSTAT
IOBCSB0  EQU   IOBCSTAT
IOBUSB7  EQU   IOBUSTAT
IOBUSB6  EQU   IOBUSTAT
IOBUSB5  EQU   IOBUSTAT
IOBUSB4  EQU   IOBUSTAT
IOBUSB3  EQU   IOBUSTAT
IOBUSB2  EQU   IOBUSTAT
IOBUSB1  EQU   IOBUSTAT
IOBUSB0  EQU   IOBUSTAT
IOBCMDA  EQU   IOBIOCSW
IOBLOG   EQU   IOBFL3
IOBJAM   EQU   IOBICL
IOBMSG   EQU   IOBFL3
IOBSDR   EQU   IOBCNC
IOBACU   EQU   IOBFL3
IOBCDC   EQU   IOBFL3
IOBICC   EQU   IOBFL3
IOBCCC   EQU   IOBFL3
IOBECBPB EQU   IOBECBPT+1
IOBECBCC EQU   IOBECBPT
IOBS1B7  EQU   IOBSENS1
IOBS1B6  EQU   IOBSENS1
IOBS1B5  EQU   IOBSENS1
IOBS1B4  EQU   IOBSENS1
IOBS1B3  EQU   IOBSENS1
IOBS1B2  EQU   IOBSENS1
IOBS1B1  EQU   IOBSENS1
IOBS1B0  EQU   IOBSENS1
IOBSNSC9 EQU   IOBS0B7
IOBS0B6  EQU   IOBSENS0
IOBS0B5  EQU   IOBSENS0
IOBS0B4  EQU   IOBSENS0
IOBS0B3  EQU   IOBSENS0
IOBS0B2  EQU   IOBSENS0
IOBS0B1  EQU   IOBSENS0
IOBS0B0  EQU   IOBSENS0
IOBPNCH  EQU   IOBFLAG2
IOBSTATO EQU   IOBFLAG2
IOBSKUPD EQU   IOBFLAG2
IOBALTTR EQU   IOBFLAG2
IOBRRT2  EQU   IOBRDHA0
IOBRRT3  EQU   IOBPURGE
IOBSENSE EQU   IOBFLAG2
IOBHALT  EQU   IOBFLAG2
IOBSPSVC EQU   IOBRSTRT
IOBUNREL EQU   IOBFLAG1
IOBIOERR EQU   IOBFLAG1
IOBFCREX EQU   IOBCYCCK
IOBRPSTN EQU   IOBFLAG1
IOBERRTN EQU   IOBFLAG1
IOBCMDCH EQU   IOBFLAG1
IOBDATCH EQU   IOBFLAG1
IOBCNOPA EQU   IOBPREFX+12
IOBCICB  EQU   IOBPREFX+8
IOBCECB  EQU   IOBPREFX+4
IOBCONOP EQU   IOBPREFX+3
IOBCINOP EQU   IOBPREFX+2
IOBRSV05 EQU   IOBPREFX+1
IOBPCI   EQU   IOBCFLG1
IOBRSTCH EQU   IOBCFLG1
IOBABAPP EQU   IOBCFLG1
IOBPTST  EQU   IOBCFLG1
IOBRSV04 EQU   IOBCFLG1
IOBRSV03 EQU   IOBCFLG1
IOBRSV02 EQU   IOBCFLG1
IOBRSV01 EQU   IOBCFLG1
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00112 EQU   DEBACS08+12
@NM00111 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00110 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00109 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00108 EQU   CVTFIX+248
@NM00107 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
RTCTISVC EQU   RTCTSDO4
RTCTSDOV EQU   RTCTSDMG
@NM00106 EQU   RTCTSDO4
@NM00105 EQU   RTCTSDO3
RTCTSDPH EQU   RTCTSDO3
RTCTSDPG EQU   RTCTSDO3
@NM00104 EQU   RTCTSDO2
RTCTSDPD EQU   RTCTSDO2
RTCTSDPC EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTISYM EQU   RTCTSD04
RTCTSMOV EQU   RTCTSMMG
@NM00103 EQU   RTCTSD04
RTCTSD03 EQU   RTCTMSYO+2
RTCTSD02 EQU   RTCTMSYO+1
RTCTSDS7 EQU   RTCTSD01
RTCTSDS6 EQU   RTCTSD01
RTCTSDS5 EQU   RTCTSD01
RTCTSDS4 EQU   RTCTSD01
RTCTSDS3 EQU   RTCTSD01
RTCTSDS2 EQU   RTCTSD01
RTCTSDS1 EQU   RTCTSD01
RTCTSDS0 EQU   RTCTSD01
RTCTISYU EQU   RTCTSUO4
RTCTSUOV EQU   RTCTSUMG
@NM00102 EQU   RTCTSUO4
RTCTSYDF EQU   RTCTSUO3
RTCTSYDE EQU   RTCTSUO3
RTCTSYDD EQU   RTCTSUO3
RTCTSYDC EQU   RTCTSUO3
RTCTSYDB EQU   RTCTSUO3
RTCTSYDA EQU   RTCTSUO3
RTCTSYD9 EQU   RTCTSUO3
RTCTSYD8 EQU   RTCTSUO3
@NM00101 EQU   RTCTSUO2
RTCTSYDH EQU   RTCTSUO2
RTCTSYDG EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTISAB EQU   RTCTSAO4
RTCTSAOV EQU   RTCTSAMG
@NM00100 EQU   RTCTSAO4
RTCTSADF EQU   RTCTSAO3
RTCTSADE EQU   RTCTSAO3
RTCTSADD EQU   RTCTSAO3
RTCTSADC EQU   RTCTSAO3
RTCTSADB EQU   RTCTSAO3
RTCTSADA EQU   RTCTSAO3
RTCTSAD9 EQU   RTCTSAO3
RTCTSAD8 EQU   RTCTSAO3
@NM00099 EQU   RTCTSAO2
RTCTSADH EQU   RTCTSAO2
RTCTSADG EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTZZZ5 EQU   RTCT+340
RTCTZZZ4 EQU   RTCT+336
RTCTMRMQ EQU   RTCT+332
RTCTSDF5 EQU   RTCTSDF3+3
RTCTSDDO EQU   RTCTSDF4
RTCTSDEN EQU   RTCTSDF4
RTCTSDEQ EQU   RTCTSDF4
RTCTSDTR EQU   RTCTSDF4
RTCTSDRM EQU   RTCTSDF4
RTCTSDAN EQU   RTCTSDF4
RTCTSDNC EQU   RTCTSDF4
RTCTSDSS EQU   RTCTSDF4
RTCTSDAS EQU   RTCTSDF3
@NM00098 EQU   RTCTC3PO
@NM00097 EQU   RTCTR2D2
RTCTSDFX EQU   RTCTSDF2
RTCTSDRW EQU   RTCTSDF2
RTCTSDSL EQU   RTCTSDF2
RTCTSDWF EQU   RTCTSDF2
RTCTSDLA EQU   RTCTSDF2
RTCTSDDI EQU   RTCTSDF2
RTCTSDTQ EQU   RTCTSDF2
RTCTSDMR EQU   RTCTSDF2
RTCTSDSC EQU   RTCTSDF1
RTCTSDRS EQU   RTCTSDF1
RTCTSDSD EQU   RTCTSDF1
RTCTSDEP EQU   RTCTSDF1
RTCTSDMA EQU   RTCTSDF1
RTCTSDSH EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
RTCTZZZ2 EQU   RTCT+257
RTCTSDPR EQU   RTCTSDI+2
RTCTINDX EQU   RTCTSDI+1
RTCTSDNA EQU   RTCTSDI
@NM00096 EQU   RTCTASO2
RTCTASNQ EQU   RTCTASO2
RTCTASNA EQU   RTCTASO2
RTCTASNS EQU   RTCTASO2
RTCTASSU EQU   RTCTASO2
RTCTASSW EQU   RTCTASO2
RTCTASCS EQU   RTCTASO2
RTCTASTR EQU   RTCTASO1
RTCTASLP EQU   RTCTASO1
RTCTASRG EQU   RTCTASO1
RTCTASLS EQU   RTCTASO1
RTCTASSQ EQU   RTCTASO1
RTCTASNU EQU   RTCTASO1
RTCTASPS EQU   RTCTASO1
RTCTASAL EQU   RTCTASO1
RTCTSDO  EQU   RTCTOPT+12
RTCTSYO  EQU   RTCTOPT+8
RTCTSUO  EQU   RTCTOPT+4
RTCTSAO  EQU   RTCTOPT
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTSDSW EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00095 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDIP EQU   RTCTSDPL
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
@NM00094 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRCB  EQU   RTCT+32
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTYYY1 EQU   RTCT+16
RTCTSY04 EQU   RTCTSYD+3
RTCTSY03 EQU   RTCTSYD+2
RTCTSY02 EQU   RTCTSYD+1
RTCTSYM7 EQU   RTCTSY01
RTCTSYM6 EQU   RTCTSY01
RTCTSYM5 EQU   RTCTSY01
RTCTSYM4 EQU   RTCTSY01
RTCTSYM3 EQU   RTCTSY01
RTCTSYM2 EQU   RTCTSY01
RTCTSYM1 EQU   RTCTSY01
RTCTSYM0 EQU   RTCTSY01
RTCTSUP4 EQU   RTCTSUP+3
RTCTSUDF EQU   RTCTSUP3
RTCTSUDE EQU   RTCTSUP3
RTCTSUDD EQU   RTCTSUP3
RTCTSUDC EQU   RTCTSUP3
RTCTSUDB EQU   RTCTSUP3
RTCTSUDA EQU   RTCTSUP3
RTCTSUD9 EQU   RTCTSUP3
RTCTSUD8 EQU   RTCTSUP3
@NM00093 EQU   RTCTSUP2
RTCTSUDH EQU   RTCTSUP2
RTCTSUDG EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSAP4 EQU   RTCTSAP+3
RTCTSABF EQU   RTCTSAP3
RTCTSABE EQU   RTCTSAP3
RTCTSABD EQU   RTCTSAP3
RTCTSABC EQU   RTCTSAP3
RTCTSABB EQU   RTCTSAP3
RTCTSABA EQU   RTCTSAP3
RTCTSAB9 EQU   RTCTSAP3
RTCTSAB8 EQU   RTCTSAP3
@NM00092 EQU   RTCTSAP2
RTCTSABH EQU   RTCTSAP2
RTCTSABG EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
CDATTR3  EQU   CDENTRY+30
CDAUTH   EQU   CDATTR2
CDSYSLIB EQU   CDATTR2
CDOLY    EQU   CDATTR2
@NM00091 EQU   CDATTR2
CDRLC    EQU   CDATTR2
CDREL    EQU   CDATTR2
CDSPZ    EQU   CDATTR2
CDNLR    EQU   CDATTR
CDJPA    EQU   CDATTR
CDNFN    EQU   CDATTR
CDSER    EQU   CDATTR
CDREN    EQU   CDATTR
CDNIP    EQU   CDATTR
@NM00090 EQU   CDENTRY+26
CDUSE    EQU   CDENTRY+24
CDENTPT  EQU   CDENTRY+16
CDNAME   EQU   CDENTRY+8
CDRRBP   EQU   CDENTRY+4
CDCHAIN  EQU   CDENTRY
SCBRSVRE EQU   SCBDATA+3
SCBID    EQU   SCBDATA+2
@NM00089 EQU   SCBFLGS3
SCBTERMO EQU   SCBFLGS3
SCBBRNTR EQU   SCBFLGS3
SCBPRNTR EQU   SCBFLGS3
SCBCNCEL EQU   SCBFLGS3
SCBRECRD EQU   SCBFLGS3
SCBTERMI EQU   SCBFLGS3
@NM00088 EQU   SCBFLGS3
SCBKEY0  EQU   SCBFLGS2
@NM00087 EQU   SCBFLGS2
@NM00086 EQU   SCBFLGS2
@NM00085 EQU   SCBFLGS2
SCBXCTL2 EQU   SCBFLGS2
@NM00084 EQU   SCBFLGS2
SCBHALT  EQU   SCBIOPRC
SCBNOIOP EQU   SCBIOPRC
SCBASYNC EQU   SCBFLGS1
@NM00083 EQU   SCBFLGS1
SCBDUMMY EQU   SCBFLGS1
SCBEXIT  EQU   SCB+4
@NM00082 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00081 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWARCPL EQU   SDWA+364
@NM00080 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00079 EQU   SDWADDAT+3
@NM00078 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00077 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00076 EQU   SDWADUMP+2
@NM00075 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00074 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00073 EQU   SDWAACF3
@NM00072 EQU   SDWAACF2
@NM00071 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00070 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00069 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
SDWACPUI EQU   SDWA+239
@NM00068 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00067 EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00066 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00065 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00064 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00063 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00062 EQU   SDWAINC2
@NM00061 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00060 EQU   SDWAILC2
@NM00059 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00058 EQU   SDWANXT2
@NM00057 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00056 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00055 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00054 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00053 EQU   SDWAINC1
@NM00052 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00051 EQU   SDWAILC1
@NM00050 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00049 EQU   SDWANXT1
@NM00048 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00047 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00046 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00045 EQU   SDWAEMK1
SDWAEPA  EQU   SDWA+96
@NM00044 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00043 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00042 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
@NM00041 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00040 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
STORBTO  EQU   STORTO
STORB    EQU   STORFRM
RTM2TECB EQU   RTM2RYRG+64
RTM2TRLS EQU   RTM2ENSN+16
RTM2TRFS EQU   RTM2ENSN+12
RTM2TRCU EQU   RTM2ENSN+8
RTM2TRTB EQU   RTM2ENSN+4
RTM2TRLN EQU   RTM2SNLN
@NM00039 EQU   RTM2WA+882
RTM2ERTM EQU   RTM2ERID+6
RTM2ERAS EQU   RTM2ERID+4
RTM2CPUI EQU   RTM2ERID+2
RTM2SEQ# EQU   RTM2ERID
RTM2RMWS EQU   RTM2RMWA
RTM2CREG EQU   RTM2CRG
RTM2RBRG EQU   RTM2CVER+313
RTM2WARG EQU   RTM2CVER+312
@NM00038 EQU   RTM2CVER+310
RTM2CTRA EQU   RTM2RECH+12
RTM2STRA EQU   RTM2RECH+8
RTM2SKRA EQU   RTM2RECH+4
@NM00037 EQU   RTM2TRYR+3
@NM00036 EQU   RTM2TRF2
RTM2GMR  EQU   RTM2TRF2
RTM2PPR  EQU   RTM2TRF2
RTM2IOR  EQU   RTM2TRF2
RTM2XIP  EQU   RTM2TRF1+1
RTM2RCD  EQU   RTM2TRF1+1
RTM2VLDY EQU   RTM2TRF1
RTM2HOOK EQU   RTM2TRF1
RTM2PPS  EQU   RTM2TRF1
RTM2GMS  EQU   RTM2TRF1
RTM2IORS EQU   RTM2TRF1
RTM2IOHS EQU   RTM2TRF1
RTM2IOQS EQU   RTM2TRF1
RTM2TMER EQU   RTM2RECL+14
RTM2EQMN EQU   RTM2ECTL
RTM2EDEQ EQU   RTM2ECTL
RTM2EFRM EQU   RTM2ECTL
RTM2ECLS EQU   RTM2ECTL
RTM2ESNP EQU   RTM2ECTL
RTM2EOPN EQU   RTM2ECTL
RTM2EGET EQU   RTM2ECTL
RTM2EENQ EQU   RTM2ECTL
RTM2DFTK EQU   RTM2DCTL
RTM2DDEQ EQU   RTM2DCTL
RTM2DFRM EQU   RTM2DCTL
RTM2DCLS EQU   RTM2DCTL
RTM2DSNP EQU   RTM2DCTL
RTM2DOPN EQU   RTM2DCTL
RTM2DGET EQU   RTM2DCTL
RTM2DENQ EQU   RTM2DCTL
RTM2SCTX EQU   RTM2RECL+8
RTM2SCTR EQU   RTM2RECL+4
RTM2SCTC EQU   RTM2RECL
@NM00035 EQU   RTM2FLX2
RTM2CERX EQU   RTM2FLX2
RTM2RCRX EQU   RTM2FLX2
RTM2RTRX EQU   RTM2FLX1
RTM2LTX  EQU   RTM2FLX1
RTM2PRX  EQU   RTM2FLX1
RTM2CVX  EQU   RTM2FLX1
RTM2DWX  EQU   RTM2FLX1
RTM2ABX  EQU   RTM2FLX1
RTM2EOTX EQU   RTM2FLX1
RTM2MTX  EQU   RTM2FLX1
@NM00034 EQU   RTM2ASIR
RTM2TRME EQU   RTM2ASIR
@NM00033 EQU   RTM2ABDP
RTM2SMDP EQU   RTM2ABDP
RTM2DMP1 EQU   RTM2ABDP
RTM2MEMT EQU   RTM2INTF+3
@NM00032 EQU   RTM2TSKT
RTM2PURG EQU   RTM2TSKT
@NM00031 EQU   RTM2INTF+1
@NM00030 EQU   RTM2CTLR
RTM2WRAP EQU   RTM2CTLR
RTM2TMEM EQU   RTM2CTLR
RTM2RECR EQU   RTM2CTLR
@NM00029 EQU   RTM2RCTL
RTM2JPAQ EQU   RTM2RCTL
RTM2LPAQ EQU   RTM2RCTL
RTM2BFTL EQU   RTM2RCTL
RTM2TRSW EQU   RTM2RCTL
RTM2STAT EQU   RTM2ABND
RTM2NDMP EQU   RTM2ABND
@NM00028 EQU   RTM2ABID
RTM2OERR EQU   RTM2ABID
RTM2SAV2 EQU   RTM2ABID
RTM2SAVE EQU   RTM2ABID
RTM2REG  EQU   RTM2ABID
RTM2PSW  EQU   RTM2ABID
RTM2ENQ  EQU   RTM2ABID
RTM2CB   EQU   RTM2ABID
RTM2MCTL EQU   RTM2SCTL+3
RTM2TCTL EQU   RTM2SCTL+2
@NM00027 EQU   RTM2CCTL+1
RTM2PPIO EQU   RTM2CCTL+1
RTM2INPG EQU   RTM2CCTL+1
RTM2NODP EQU   RTM2CCTL+1
RTM2RGEB EQU   RTM2CCTL+1
RTM2DEND EQU   RTM2CCTL+1
RTM2RSCN EQU   RTM2CCTL+1
RTM2CONT EQU   RTM2CCTL
RTM2SLIP EQU   RTM2CCTL
RTM2HEED EQU   RTM2CCTL
RTM2REED EQU   RTM2CCTL
RTM2ISPC EQU   RTM2CCTL
RTM2SQS  EQU   RTM2CCTL
RTM2CNCL EQU   RTM2CCTL
RTM2STPT EQU   RTM2CCTL
RTM2PKEY EQU   RTM2CVER+258
RTM2SFSA EQU   RTM2SFRG
RTM2SPWA EQU   RTM2CVER+174
RTM2ECBS EQU   RTM2SECB+16
RTM2LECB EQU   RTM2ECBA
RTM2DTCB EQU   RTM2SNAP+68
RTM2SNCC EQU   RTM2SNAP+64
RTM2DD   EQU   RTM2SNAP+56
RTM2LTO4 EQU   RTM2TO4
RTM2LFR4 EQU   RTM2FRM4
RTM2LTO3 EQU   RTM2TO3
RTM2LFR3 EQU   RTM2FRM3
RTM2LTO2 EQU   RTM2TO2
RTM2LFR2 EQU   RTM2FRM2
RTM2LTO1 EQU   RTM2TO1
RTM2LFR1 EQU   RTM2FRM1
RTM2DPLA EQU   RTM2SNAP
RTM2NXTP EQU   RTM2CTL2+5
RTM2SGP  EQU   RTM2PMKP
RTM2EUP  EQU   RTM2PMKP
RTM2DOP  EQU   RTM2PMKP
RTM2FPP  EQU   RTM2PMKP
RTM2CCP  EQU   RTM2PMKP
RTM2ILP  EQU   RTM2PMKP
RTM2INTP EQU   RTM2CTL2+2
RTM2SPVP EQU   RTM2MWPP
RTM2WATP EQU   RTM2MWPP
RTM2MCKP EQU   RTM2MWPP
@NM00026 EQU   RTM2MWPP
RTM2KEYP EQU   RTM2MWPP
RTM2EXTP EQU   RTM2CMKP
RTM2IOP  EQU   RTM2CMKP
RTM2NXTA EQU   RTM2CTL1+5
RTM2SGA  EQU   RTM2PMKA
RTM2EUA  EQU   RTM2PMKA
RTM2DOA  EQU   RTM2PMKA
RTM2FPA  EQU   RTM2PMKA
RTM2CCA  EQU   RTM2PMKA
RTM2ILA  EQU   RTM2PMKA
RTM2INTA EQU   RTM2CTL1+2
RTM2SPVA EQU   RTM2MWPA
RTM2WATA EQU   RTM2MWPA
RTM2MCKA EQU   RTM2MWPA
@NM00025 EQU   RTM2MWPA
RTM2KEYA EQU   RTM2MWPA
RTM2EXTA EQU   RTM2CMKA
RTM2IOA  EQU   RTM2CMKA
@NM00024 EQU   RTM2PARQ+1
RTM2RBST EQU   RTM2TRRC+6
@NM00023 EQU   RTM2IOBP
@NM00022 EQU   RTM2TRRC+1
@NM00021 EQU   RTM2IOFS
RTM2NIOP EQU   RTM2IOFS
RTM2NOIO EQU   RTM2IOFS
RTM2IOHT EQU   RTM2IOFS
RTM2FMID EQU   RTM2TRRY+124
RTM2ERFL EQU   RTM2ERRD
RTM2MCIV EQU   RTM2ERRD
RTM2RPIV EQU   RTM2ERRD
RTM2MABD EQU   RTM2ERRD
RTM2CTS  EQU   RTM2ERRD
RTM2STAE EQU   RTM2ERRD
RTM2NRBE EQU   RTM2ERRD
@NM00020 EQU   RTM2ERRC
RTM2IRB  EQU   RTM2ERRC
RTM2STAF EQU   RTM2ERRC
RTM2SRBM EQU   RTM2ERRB
RTM2LDIS EQU   RTM2ERRB
RTM2ENRB EQU   RTM2ERRB
RTM2TYP1 EQU   RTM2ERRB
@NM00019 EQU   RTM2ERRB
RTM2PGIO EQU   RTM2ERRA
RTM2TEXC EQU   RTM2ERRA
RTM2SVCE EQU   RTM2ERRA
RTM2ABTM EQU   RTM2ERRA
RTM2SVCD EQU   RTM2ERRA
RTM2RKEY EQU   RTM2ERRA
RTM2PCHK EQU   RTM2ERRA
RTM2MCHK EQU   RTM2ERRA
RTM2TIME EQU   RTM2EEDH+20
RTM2RFSA EQU   RTM2EEDH+16
@NM00018 EQU   RTM2EEDH+14
RTM2VEQR EQU   RTM2RSR2
RTM2PGFX EQU   RTM2RSR2
RTM2FLSQ EQU   RTM2RSR2
RTM2FSQA EQU   RTM2RSR2
RTM2NUCL EQU   RTM2RSR2
RTM2SPER EQU   RTM2RSR2
RTM2INTC EQU   RTM2RSR2
RTM2OFLN EQU   RTM2RSR2
RTM2CHNG EQU   RTM2RSR1
RTM2MSER EQU   RTM2RSR1
@NM00017 EQU   RTM2RSR1
RTM2CPID EQU   RTM2EEDH+10
RTM2TERR EQU   RTM2MCHD
RTM2SOFT EQU   RTM2MCHD
RTM2INSF EQU   RTM2MCHD
RTM2ACR  EQU   RTM2MCHD
RTM2SCK  EQU   RTM2MCHD
RTM2PSWU EQU   RTM2MCHD
RTM2REGU EQU   RTM2MCHD
RTM2SKYF EQU   RTM2MCHD
@NM00016 EQU   RTM2MCHS
RTM2RSRF EQU   RTM2MCHS
RTM2RSRC EQU   RTM2MCHS
RTM2INVP EQU   RTM2MCHS
RTM2TSVL EQU   RTM2MCHS
RTM2RCDF EQU   RTM2MCHS
RTM2SRVL EQU   RTM2MCHS
RTM2SCKE EQU   RTM2STCK+4
RTM2SCKB EQU   RTM2STCK
RTM2ABEP EQU   RTM2TRRY+88
RTM2ABNM EQU   RTM2TRRY+80
RTM2TRAN EQU   RTM2AEC1+4
RTM2IPC1 EQU   RTM2ICD1
RTM2IMC1 EQU   RTM2ICD1
RTM2IPR1 EQU   RTM2ICD1
@NM00015 EQU   RTM2INC1
@NM00014 EQU   RTM2ILC1
RTM2IL1  EQU   RTM2ILC1
@NM00013 EQU   RTM2ILC1
@NM00012 EQU   RTM2AEC1
RTM2ADD1 EQU   RTM2NXT1+1
@NM00011 EQU   RTM2NXT1
@NM00010 EQU   RTM2EPSW+3
RTM2SGN1 EQU   RTM2INT1
RTM2EXP1 EQU   RTM2INT1
RTM2DEC1 EQU   RTM2INT1
RTM2FPO1 EQU   RTM2INT1
RTM2CC1  EQU   RTM2INT1
@NM00009 EQU   RTM2INT1
RTM2PGM1 EQU   RTM2MWP1
RTM2WAT1 EQU   RTM2MWP1
RTM2MCK1 EQU   RTM2MWP1
RTM2ECT1 EQU   RTM2MWP1
RTM2KEY1 EQU   RTM2MWP1
RTM2EXT1 EQU   RTM2EMK1
RTM2AIO1 EQU   RTM2EMK1
RTM2TRM1 EQU   RTM2EMK1
RTM2EAM1 EQU   RTM2EMK1
@NM00008 EQU   RTM2EMK1
RTM2PER1 EQU   RTM2EMK1
@NM00007 EQU   RTM2EMK1
RTM2ER15 EQU   RTM2EREG+60
RTM2ER14 EQU   RTM2EREG+56
RTM2ER13 EQU   RTM2EREG+52
RTM2ER12 EQU   RTM2EREG+48
RTM2ER11 EQU   RTM2EREG+44
RTM2ER10 EQU   RTM2EREG+40
RTM2ER9  EQU   RTM2EREG+36
RTM2ER8  EQU   RTM2EREG+32
RTM2ER7  EQU   RTM2EREG+28
RTM2ER6  EQU   RTM2EREG+24
RTM2ER5  EQU   RTM2EREG+20
RTM2ER4  EQU   RTM2EREG+16
RTM2ER3  EQU   RTM2EREG+12
RTM2ER2  EQU   RTM2EREG+8
RTM2ER1  EQU   RTM2EREG+4
RTM2ER0  EQU   RTM2EREG
RTM2CT   EQU   RTM2WA+56
RTM2VRBT EQU   RTM2WA+52
RTM2TCBT EQU   RTM2WA+48
RTM2SFWA EQU   RTM2WA+32
@NM00006 EQU   RTM2CCF
RTM2EOT  EQU   RTM2CCF
RTM2EOM  EQU   RTM2CCF
RTM2R0DP EQU   RTM2CCF
RTM2STEP EQU   RTM2CCF
RTM2ASC  EQU   RTM2WA+24
RTM2LGTH EQU   RTM2RT2D+1
RTM2SPID EQU   RTM2RT2D
RTM2ADDR EQU   RTM2DESC+4
RTM2ID   EQU   RTM2DESC
RMPLRMWA EQU   RMPL+16
RMPLASCB EQU   RMPL+4
RMPLASID EQU   RMPL+2
RMPLFLG2 EQU   RMPL+1
@NM00005 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLIPUF EQU   RMPLFLG1
RMPLTERM EQU   RMPLFLG1
SNPHDRA  EQU   SNPPARMS+20
SNPSTOR  EQU   SNPPARMS+16
SNPTCBA  EQU   SNPPARMS+12
SNPDCB   EQU   SNPPARMS+8
@NM00004 EQU   SNPPARMS+7
@NM00003 EQU   SNPPDATA
SNPSPLS  EQU   SNPPDATA
SNPPSW   EQU   SNPPDATA
SNPJPA   EQU   SNPPDATA
SNPLPA   EQU   SNPPDATA
SNPREGS  EQU   SNPPDATA
SNPSAVE2 EQU   SNPPDATA
SNPSAVE  EQU   SNPPDATA
@NM00002 EQU   SNPSDAT1
SNPERR   EQU   SNPSDAT1
SNPIO    EQU   SNPSDAT1
SNPDM    EQU   SNPSDAT0
SNPQCB   EQU   SNPSDAT0
SNPCB    EQU   SNPSDAT0
SNPTRT   EQU   SNPSDAT0
SNPSWA   EQU   SNPSDAT0
SNPLSQA  EQU   SNPSDAT0
SNPSQA   EQU   SNPSDAT0
SNPNUC   EQU   SNPSDAT0
@NM00001 EQU   SNPPARMS+2
SNPHDR   EQU   SNPFLAG
SNPSLIST EQU   SNPFLAG
SNPTCB   EQU   SNPFLAG
SNPID    EQU   SNPFLAG
SNPABEND EQU   SNPFLAG
SNPVS2EN EQU   SNPFLAG
SNPVS2   EQU   SNPFLAG
SNPSNAP  EQU   SNPFLAG
SNPIDENT EQU   SNPPARMS
REGSAVE  EQU   RSAVE
@NM00190 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00189 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00188 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00187 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00186 EQU   FLCFSA
@NM00185 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00184 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00183 EQU   FLCIOA
@NM00182 EQU   FLCMCLA+15
@NM00181 EQU   FLCMCLA+14
@NM00180 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00179 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00178 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00177 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00176 EQU   FLCPER
@NM00175 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00174 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00173 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00172 EQU   FLCPIILC
@NM00171 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00170 EQU   FLCSVILC
@NM00169 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00168 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00167 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00119 EQU   @RC00118
@RC00332 EQU   @RC00331
@RC00100 EQU   @RC00099
@RC00457 EQU   @RC00099
@RC00517 EQU   @RC00516
@RF00568 EQU   @EL00002
@RC00120 EQU   @RC00119
@RC00101 EQU   @RC00100
@RF00395 EQU   @RC00101
@ENDDATA EQU   *
         END   IEAVTAS3,(C'PLS2112',0801,78206)
