         TITLE 'IEAVTRT2 RTM2 INITIALIZATION                           *
                        '
IEAVTRT2 CSECT ,                                                   0001
@MAINENT BALR  @15,0                                               0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVTRT2  77.285'                                 0001
         DROP  @15
@PROLOG  BALR  @06,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@06                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0069
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT IEAVTRT2 IS THE TOP RTM2 SEGMENT. IT INCLUDES SEGMENT */
*   /* RT2INCTL TO CONTROL ENTRY INITIALIZATION AND ACQUIRE A WORK   */
*   /* AREA AND SEGMENT RT2INWA TO INITIALIZE THE WORK AREA. IT THEN */
*   /* CALLS MODULE IEAVTRTC TO CONTROL THE MAIN PATH PROCESSING     */
*   /* THROUGH RTM2. FINALLY IT CALLS IEAVTRTE TO EFFECT THE EXIT. IF*/
*   /* CONTROL IS RETURNED TO IT AT ANY TIME WITH A RETURN CODE OF 4 */
*   /* IT INVOKES THE CRITICAL ERROR ROUTINE (SEGMENT RT2CRERR) TO   */
*   /* TERMINATE THE MEMORY.                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0069
*   TCBNONPR=OFF;                   /* RTM2 SHOULD NOT RUN         0069
*                                      NONPREEMPTIVE         @Z40FPXH*/
         NI    TCBNONPR(R4),B'11101111'                            0069
*   IF TCBEOT=OFF THEN              /* THIS ENTRY IS NOT DUE TO AN 0070
*                                      ERROR IN SVC 3                */
         TM    TCBEOT(R4),B'00000100'                              0070
         BNZ   @RF00070                                            0070
*     DO;                                                          0071
*                                                                  0071
*       /*************************************************************/
*       /*                                                           */
*       /* SEGMENT RT2INCTL CONTROLS ENTRY INITIALIZATION. IT        */
*       /* INCLUDES SEGMENT RT2INESA TO SAVE INPUT DATA AND FLAGS IN */
*       /* THE ESA AND SEGMENT RT2GETWA TO OBTAIN AN RTM2 WORK AREA. */
*       /* IF IT IS NOT NECESSARY TO GET A WORK AREA IT ESTABLISHES  */
*       /* THE NECESSARY ADDRESSING FOR THE ONE THAT EXISTS. ON ENTRY*/
*       /* REG 3 LOCATES THE CVT, REG 4, THE TCB, REG 5, THE SVRB AND*/
*       /* REG 7, THE ASCB. NO LOCK IS HELD. IF IT DETECTS AN ERROR  */
*       /* IT RETURNS A CODE OF 4. OTHERWISE IT RETURNS A CODE OF 0. */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0072
*       DO;                         /* BEGIN SEGMENT RT2INCTL        */
*                                                                  0072
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT RT2INESA SAVES ENTRY DATA IN THE ESA AND        */
*         /* INITIALIZES FLAGS IN THE TCB AND SVRB. REGISTERS        */
*         /* 0,1,3,4,5,7, AND 14 ARE SAVED IN THE ESA. THE RBABEND   */
*         /* FLAG IS SET ON. THE LOCAL LOCK IS OBTAINED TO SERIALIZE */
*         /* ACCESS TO TCB FIELDS. THE TCBPGNLY FLAG IS COPIED TO THE*/
*         /* ESA AND TURNED OFF IN THE TCB. THE TCBRTM2 FLAG IS      */
*         /* COPIED TO THE ESA AND TURNED ON IN THE TCB. IF THE      */
*         /* TCBABTRM FLAG IS ON, THAT FLAG AND THE TCBCMP AND       */
*         /* TCBRTM12 FIELDS ARE COPIED TO THE ESA. THEN THE TCBABTRM*/
*         /* AND TCBRTM12 FIELDS ARE CLEARED IN THE TCB. THE TCBFX   */
*         /* AND TCBFPRAP FLAGS ARE TURNED ON. THE LOCAL LOCK IS THEN*/
*         /* RELEASED. ON ENTRY REG 4 LOCATES THE TCB AND REG 5, THE */
*         /* SVRB. NO LOCK IS HELD ON ENTRY OR EXIT. IF IT DETECTS AN*/
*         /* ERROR IT SETS ESAFERR ON                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0073
*         DO;                       /* BEGIN SEGMENT RT2INESA        */
*           RTM2ESA=''B;            /* CLEAR ESA                     */
*                                                                  0074
         LA    @12,96                                              0074
         ALR   @12,R5                                              0074
         XC    RTM2ESA(48,@12),RTM2ESA(@12)                        0074
*           /*********************************************************/
*           /*                                                       */
*           /* SAVE INPUT REGISTERS                                  */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0075
*           ESAR0=R0;               /* PARAMETERS                    */
         ST    R0,ESAR0(,@12)                                      0075
*           ESAR1=R1;               /* PARAMETERS                    */
         ST    R1,ESAR1(,@12)                                      0076
*           ESAR3=R3;               /* CVT ADDRESS                   */
         ST    R3,ESAR3(,@12)                                      0077
*           ESAR4=R4;               /* TCB ADDRESS                   */
         ST    R4,ESAR4(,@12)                                      0078
*           ESAR5=R5;               /* SVRB ADDRESS                  */
         ST    R5,ESAR5(,@12)                                      0079
*           ESAR7=R7;               /* ASCB ADDRESS                  */
         ST    R7,ESAR7(,@12)                                      0080
*           ESAR14=R14;             /* RETURN ADDRESS                */
         ST    R14,ESAR14(,@12)                                    0081
*           R7=ADDR(RTM2ESA);       /* SET REG WITH ADDR OF RTM ESA  */
         LR    R7,@12                                              0082
*           RESPECIFY                                              0083
*             RTM2ESA BASED(R7);                                   0083
*           RESPECIFY                                              0084
*            (R0,                                                  0084
*             R1,                                                  0084
*             R14) UNRESTRICTED;    /* RELEASE REGS NOT USED TO    0084
*                                      LOCATE CONTROL BLOCKS         */
*           RBABEND=ON;             /* FLAG RB AS BELONGING TO RTM2  */
*                                                                  0085
         LR    @14,R5                                              0085
         AL    @14,@CF03202                                        0085
         OI    RBABEND-56(@14),B'00100000'                         0085
*           /*********************************************************/
*           /*                                                       */
*           /* TEST FOR NORMAL END OF TASK AND MEMTERM. OBTAIN LOCAL */
*           /* LOCK IF NEITHER. TCB FLAGS ARE NOT SET IN THOSE CASES */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0086
*RT2NE0T:                                                          0086
*           ;                       /* THIS STATEMENT IS LABELLED TO
*                                      PREVENT USE OF COMPILER     0086
*                                      TEMPORARY                     */
RT2NE0T  DS    0H                                                  0087
*           IF TCBABTRM=OFF&ESAEOT1=ON&TCBRTM2=OFF&RBLINKB->RBTCBNXT=ON
*             THEN                  /* NORMAL END OF TASK            */
         TM    TCBABTRM(R4),B'00100000'                            0087
         BNZ   @RF00087                                            0087
         TM    ESAEOT1(R7),B'00001000'                             0087
         BNO   @RF00087                                            0087
         TM    TCBRTM2(R4),B'00001000'                             0087
         BNZ   @RF00087                                            0087
         L     @14,RBLINKB-1(,R5)                                  0087
         TM    RBTCBNXT(@14),B'10000000'                           0087
         BNO   @RF00087                                            0087
*             ESANEOT=ON;           /* SET ESA FLAG TO SHOW NORMAL 0088
*                                      EOT                           */
         OI    ESANEOT(R7),B'00001000'                             0088
*           ELSE                    /* NOT NORMAL END OF TASK        */
*             IF TCBABTRM=OFF       /*                       @ZA16412*/
*                 &ESAEOM1=ON       /*                       @ZA16412*/
*                 &ESAR7->ASCBASID=MSTRID THEN/* MEMTERM ENTRY     0089
*                                                            @ZA16412*/
         B     @RC00087                                            0089
@RF00087 TM    TCBABTRM(R4),B'00100000'                            0089
         BNZ   @RF00089                                            0089
         TM    ESAEOM1(R7),B'00010000'                             0089
         BNO   @RF00089                                            0089
         L     @14,ESAR7(,R7)                                      0089
         CLC   ASCBASID(2,@14),@CH00067                            0089
         BNE   @RF00089                                            0089
*               ESAVEOM=ON;         /* TURN ON VALID EOM SW  @ZA16412*/
         OI    ESAVEOM(R7),B'00000010'                             0090
*             ELSE                  /*                       @ZA16412*/
*               DO;                 /*                       @ZA16412*/
*                                                                  0091
         B     @RC00089                                            0091
@RF00089 DS    0H                                                  0092
*                 /***************************************************/
*                 /*                                                 */
*                 /* OBTAIN LOCAL LOCK IF NOT RECURSION IN SETLOCK   */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0092
*                 IF TCBABTRM=ON&TCBCMPC=CNVCODE THEN/* ENTERED FOR
*                                      CONVERT TO STEP               */
         TM    TCBABTRM(R4),B'00100000'                            0092
         BNO   @RF00092                                            0092
         CLC   TCBCMPC(3,R4),@CB00063                              0092
         BNE   @RF00092                                            0092
*                   ESACTS=ON;      /* INDICATE CONVERT-TO-STEP      */
         OI    ESACTS(R7),B'00010000'                              0093
*                 ESAGLREC=ON;      /* MARK RB AS IN SETLOCK PROCESS */
@RF00092 OI    ESAGLREC(R7),B'00010000'                            0094
*                 DO;                                              0095
*                   RESPECIFY                                      0096
*                     R2 RESTRICTED;                               0096
*                   R2=RBLINKB;     /* LOCATE STARTING RB            */
*                                                                  0097
         L     R2,RBLINKB-1(,R5)                                   0097
         LA    R2,0(,R2)                                           0097
*                   /*************************************************/
*                   /*                                               */
*                   /* SCAN FOR RB WITH RBABEND ON. SCAN TERMINATED  */
*                   /* WHEN RBTCBNXT ON                              */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0098
*                   DO WHILE(EVAL(R2-LENGTH(RBPRFX))->RBABEND='0'B&R2->
*                         RBTCBNXT='0'B);                          0098
         B     @DE00098                                            0098
@DL00098 DS    0H                                                  0099
*                     R2=R2->RBLINKB;/* LOCATE NEXT RB               */
         L     @14,RBLINKB-1(,R2)                                  0099
         LA    @14,0(,@14)                                         0099
         LR    R2,@14                                              0099
*                   END;            /* END SCAN OF RBS               */
@DE00098 LR    @14,R2                                              0100
         SL    @14,@CF00482                                        0100
         TM    RBABEND(@14),B'00100000'                            0100
         BNZ   @DC00098                                            0100
         TM    RBTCBNXT(R2),B'10000000'                            0100
         BZ    @DL00098                                            0100
@DC00098 DS    0H                                                  0101
*                   IF EVAL(R2-LENGTH(RBPRFX))->RBABEND='0'B THEN/*
*                                      CHECK WHETHER ONE WAS FOUND   */
         LR    @14,R2                                              0101
         SL    @14,@CF00482                                        0101
         TM    RBABEND(@14),B'00100000'                            0101
         BNZ   @RF00101                                            0101
*                     R2=0;         /* NO RTM2 RB FOUND              */
         SLR   R2,R2                                               0102
*                 END;                                             0103
@RF00101 DS    0H                                                  0104
*                 IF R2=0 THEN      /* NO PREV RTM2 RB FOUND @ZA01861*/
         LTR   R2,R2                                               0104
         BNZ   @RF00104                                            0104
*                   IF TCBRTM2=ON THEN/* IF RECURSIVE ENTRY, SHOULD
*                                      BE AN RTM2 RB UNLESS CTS    0105
*                                                            @ZA01861*/
         TM    TCBRTM2(R4),B'00001000'                             0105
         BNO   @RF00105                                            0105
*                     IF ESACTS=OFF THEN/* NOT CONVERT TO STEP CASE  */
         TM    ESACTS(R7),B'00010000'                              0106
         BNZ   @RF00106                                            0106
*                       ESAFERR=ON; /* INDICATE DISASTROUS ERROR     */
         OI    ESAFERR(R7),B'00001000'                             0107
*                     ELSE                                         0108
*                       ;           /* CONVERT-TO-STEP: NO ACTION    */
@RF00106 DS    0H                                                  0109
*                   ELSE                                           0109
*                     ;             /* NOT RECURSIVE ENTRY   @ZA01861*/
@RF00105 DS    0H                                                  0110
*                 ELSE              /* PREVIOUS RTM2 RB FOUND        */
*                   DO;             /*                       @ZA08087*/
         B     @RC00104                                            0110
@RF00104 DS    0H                                                  0111
*                     ESARFLAG=ADDR(R2->RBEXSAVE)->ESARFLAG;/* COPY
*                                      RECURSION FLAGS FROM PREVIOUS
*                                      RTM2 ESA              @ZA08087*/
         LA    @14,96                                              0111
         ALR   @14,R2                                              0111
         MVC   ESARFLAG(1,R7),ESARFLAG(@14)                        0111
*                     IF ADDR(R2->RBEXSAVE)->ESAGLREC=ON THEN/*    0112
*                                      SETLOCK RECURSION HAS OCCURED */
         TM    ESAGLREC(@14),B'00010000'                           0112
         BNO   @RF00112                                            0112
*                       ESAFERR=ON; /* PROCESSING CANNOT CONTINUE  0113
*                                      WITHOUT LOCAL LOCK            */
         OI    ESAFERR(R7),B'00001000'                             0113
*                   END;            /*                       @ZA08087*/
@RF00112 DS    0H                                                  0115
*                 IF ESAFERR=OFF THEN/* NO PREVIOUS SETLOCK ERROR -
*                                      PROCESSING CAN CONTINUE       */
@RC00104 TM    ESAFERR(R7),B'00001000'                             0115
         BNZ   @RF00115                                            0115
*                   DO;                                            0116
*                     DO;           /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,IEAVTRT2(R
*                                      T2INESA))                     */
*                       RESPECIFY                                  0118
*                        (GPR11P,                                  0118
*                         GPR12P,                                  0118
*                         GPR13P,                                  0118
*                         GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                      SETLOCK                       */
*                       GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                           GPR13P,GPR14P);                        0119
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(TCB,IEAVTRT2(RT2INESA))
*                       RESPECIFY                                  0120
*                        (GPR11P,                                  0120
*                         GPR12P,                                  0120
*                         GPR13P,                                  0120
*                         GPR14P) UNRESTRICTED;/* RELEASE REGS USED
*                                      BY SETLOCK                    */
*                     END;          /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,IEAVTRT2(R
*                                      T2INESA)) OBTAIN LOCAL LOCK   */
*                     ESAGLREC=OFF; /* LOCK OBTAINED WITHOUT FAILURE */
*                                                                  0122
         NI    ESAGLREC(R7),B'11101111'                            0122
*                     /***********************************************/
*                     /*                                             */
*                     /* COPY TCB DATA AND SET TCB FLAGS AND FIELDS  */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0123
*                     IF TCBPGNLY=ON THEN/* ENTRY IS FOR PURGE ONLY  */
         TM    TCBPGNLY(R4),B'00010000'                            0123
         BNO   @RF00123                                            0123
*                       DO;                                        0124
*                         ESAPGNLY=ON;/* SAVE FLAG                   */
         OI    ESAPGNLY(R7),B'00100000'                            0125
*                         TCBPGNLY=OFF;/* CLEAR FLAG SO THAT       0126
*                                      RECURSION WON'T BE TAKEN FOR
*                                      PURGE ONLY                    */
         NI    TCBPGNLY(R4),B'11101111'                            0126
*                       END;                                       0127
*                     ELSE                                         0128
*                       ;           /* NOT PURGE ONLY                */
@RF00123 DS    0H                                                  0129
*                     IF TCBRTM2=ON&R2^=0 THEN/* RECURSION           */
         TM    TCBRTM2(R4),B'00001000'                             0129
         BNO   @RF00129                                            0129
         LTR   R2,R2                                               0129
         BZ    @RF00129                                            0129
*                       DO;                                        0130
*                         ESARTM2=ON;/* SAVE FLAG                    */
         OI    ESARTM2(R7),B'10000000'                             0131
*                         ESARFLAG=ADDR(R2->RBEXSAVE)->ESARFLAG;/* 0132
*                                      COPY RECURSION FLAGS FROM   0132
*                                      PREVIOUS RTM2 ESA             */
         MVC   ESARFLAG(1,R7),ESARFLAG+96(R2)                      0132
*                                                                  0133
*                         /*******************************************/
*                         /*                                         */
*                         /* PSEUDO RETRY FOR SLIP FAILURE. THIS WILL*/
*                         /* HANDLE RECURSION DUE TO A SLIP ERROR    */
*                         /*                                 @G17SP2I*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  0133
*                         IF ESASLIPR=ON&/* PERFORM PSEUDO RETRY FOR */
*                             ESAPGNLY=OFF THEN/* SLIP FAILURE IF NEW
*                                      ENTRY TO RTM2 IS NOT FOR PURGE
*                                      ONLY                  @YM06385*/
         TM    ESASLIPR(R7),B'00000010'                            0133
         BNO   @RF00133                                            0133
         TM    ESAPGNLY(R7),B'00100000'                            0133
         BNZ   @RF00133                                            0133
*                           IF R2=RBLINKB THEN/* AND IF PREVIOUS RB
*                                      IS AN                         */
         L     @14,RBLINKB-1(,R5)                                  0134
         LA    @14,0(,@14)                                         0134
         CR    R2,@14                                              0134
         BNE   @RF00134                                            0134
*                             DO;   /* RTM2 RB SET UP FOR PSEUDO   0135
*                                      RETRY                 @YM06385*/
*                               R2->RBOPSW(6:8)=ADDR(SLIPRTRY);/*  0136
*                                      MOVE RETRY ADDR INTO PREVIOUS
*                                      RB                    @YM06385
*                                                            @G17SP2I*/
         LA    @14,SLIPRTRY                                        0136
         STCM  @14,7,RBOPSW+5(R2)                                  0136
*                               RFY                                0137
*                                 R12 RSTD;/* GET REG FOR ADDR PREV
*                                      ESA                   @YM06385*/
*                               R12=ADDR(R2->RBEXSAVE);/* LOCATE   0138
*                                      PREVIOUS ESA          @YM06385*/
         LA    R12,RBEXSAVE(,R2)                                   0138
*                               RBGRSAVE=R12->ESART2WA->RTM2RRG;/* 0139
*                                      PUT INTO RB REGS TO BE LOADED
*                                      BY EXIT PRO (NOTE: ONLY REGS
*                                      2-14 WILL BE LOADED FRON THIS
*                                      SAVEAREA. REGS 0,1,&15 WILL 0139
*                                      HAVE THEIR CURRENT VALUES). 0139
*                                                            @YM06385*/
         L     @14,ESART2WA(,R12)                                  0139
         MVC   RBGRSAVE(64,R5),RTM2RRG(@14)                        0139
*                               R12->ESART2WA->RTM2SCTR(RTM2SLPS)=ON;
         OI    RTM2SCTR+1(@14),B'00010000'                         0140
*                                   /* INSURE THAT SLIP WILL BE    0141
*                                      BYPASSED FOR FURTHER RTM2   0141
*                                      PROCESSING OF THIS TASK     0141
*                                                            @YM06385*/
*                                                                  0141
*                               /*************************************/
*                               /*                                   */
*                               /* CLEAR TCB FIELDS SET BY RTM1 WHEN */
*                               /* HANDLING SLIP ERROR       @YM06385*/
*                               /*                                   */
*                               /*************************************/
*                                                                  0141
*                               TCBMODE=0;/* FORGET MODE OF SLIP   0141
*                                      ERROR                         */
         MVI   TCBMODE(R4),X'00'                                   0141
*                               TCBERTYP=0;/* FORGET TYPE OF SLIP  0142
*                                      ERROR                         */
         MVI   TCBERTYP(R4),X'00'                                  0142
*                               TCBABGM=OFF;/* TURN OFF FLAG SET BY
*                                      RTM1                          */
         NI    TCBABGM(R4),B'11101111'                             0143
*                               IF TCBRTM12>EEDNULL THEN/* IF RTM1 0144
*                                      AQUIRED EEDS TO HANDLE SLIP 0144
*                                      ERROR, THEY MUST BE FREED BY
*                                      RTM2                  @YM06385*/
         LA    @14,1                                               0144
         C     @14,TCBRTM12(,R4)                                   0144
         BNL   @RF00144                                            0144
*                                 IF R12->ESAEEDQ>EEDNULL THEN/*   0145
*                                      THERE ALREADY ARE EEDS TO BE
*                                      FREED BY RTM2                 */
         L     @11,ESAEEDQ(,R12)                                   0145
         CR    @11,@14                                             0145
         BNH   @RF00145                                            0145
*                                   DO;/* SO NEW EEDS CAN JUST BE  0146
*                                      ADDED TO THE CHAIN    @YM06385*/
*                                    RFY                           0147
*                                      R9 RSTD;/* GET REG TO POINT TO
*                                      EED                   @YM06385*/
*                                    RFY                           0148
*                                      EED BASED(R9);/* USE EED    0148
*                                      POINTED TO BY BY EEDPTR (R9)
*                                                            @YM06385*/
*                                    R9=R12->ESAEEDQ;/* PT TO 1ST EED
*                                      OF CHAIN              @YM06385*/
         LR    R9,@11                                              0149
*                                    DO WHILE(EEDFWRDP>EEDNULL);/* 0150
*                                      LOOP TIL END OF CHAIN IS    0150
*                                      LOCATED               @YM06385*/
         B     @DE00150                                            0150
@DL00150 DS    0H                                                  0151
*                                     R9=EEDFWRDP;/* POINT TO NEXT 0151
*                                      EED IN CHAIN          @YM06385*/
         L     R9,EEDFWRDP(,R9)                                    0151
*                                    END;/* END OF EED LOOP  @YM06385*/
@DE00150 CLC   EEDFWRDP(4,R9),@CF00067                             0152
         BH    @DL00150                                            0152
*                                    EEDFWRDP=TCBRTM12;/* ADD NEW  0153
*                                      EEDS TO END OF CHAIN  @YM06385*/
         L     @14,TCBRTM12(,R4)                                   0153
         ST    @14,EEDFWRDP(,R9)                                   0153
*                                    RFY                           0154
*                                      R9 UNRSTD;/* RELEASE REG USED
*                                      FOR EED PTR           @YM06385*/
*                                   END;/*                   @YM06385*/
*                                 ELSE/* WHEN THER ARE NO PREVIOUS 0156
*                                      EEDS TO BE FREED BY RTM2    0156
*                                                            @YM06385*/
*                                   R12->ESAEEDQ=TCBRTM12;/* JUST  0156
*                                      SAVE PTR TO NEW EED CHAIN   0156
*                                                            @YM06385*/
         B     @RC00145                                            0156
@RF00145 L     @14,TCBRTM12(,R4)                                   0156
         ST    @14,ESAEEDQ(,R12)                                   0156
*                               TCBRTM12=0;/* CLEAR EEDPTR IN THE TCB
*                                                            @YM06385*/
@RC00145 DS    0H                                                  0157
@RF00144 SLR   @14,@14                                             0157
         ST    @14,TCBRTM12(,R4)                                   0157
*                               TCBABTRM=OFF;/* TURN OFF RTM1 ABTERM
*                                      FLAG                  @YM06385*/
         NI    TCBABTRM(R4),B'11011111'                            0158
*                               GOTO ESAR14;/* BRANCH TO EXIT      0159
*                                      PROLOGUE TO EFFECT PSEUDO   0159
*                                      RETRY                 @YM06385*/
         L     @14,ESAR14(,R7)                                     0159
         BR    @14                                                 0159
*                               RFY                                0160
*                                 R12 UNRSTD;                      0160
*                             END;  /* END OF SETUP FOR RETRY ON SLIP
*                                      ERROR                 @YM06385*/
*                         RESPECIFY                                0162
*                          (R2) UNRSTD;/* RELEASE REG WHICH LOCATED
*                                      PREVIOUS RTM2 RB              */
@RF00134 DS    0H                                                  0162
@RF00133 DS    0H                                                  0163
*                       END;                                       0163
*                     ELSE          /* NOT RECURSIVE ENTRY           */
*                       TCBRTM2=ON; /* FLAG TCB IN CASE OF FAILURE   */
         B     @RC00129                                            0164
@RF00129 OI    TCBRTM2(R4),B'00001000'                             0164
*                     IF TCBABTRM=ON THEN/* ENTRY FROM RTM1 - DATA IN
*                                      TCB                           */
@RC00129 TM    TCBABTRM(R4),B'00100000'                            0165
         BNO   @RF00165                                            0165
*                       DO;                                        0166
*                         ESAABTRM=ON;/* SAVE FLAG                   */
         OI    ESAABTRM(R7),B'01000000'                            0167
*                         ESAEEDQ=TCBRTM12;/* SAVE POINTER TO EED  0168
*                                      QUEUE                         */
         L     @14,TCBRTM12(,R4)                                   0168
         ST    @14,ESAEEDQ(,R7)                                    0168
*                         TCBRTM12=0;/* CLEAR FIELD IN CASE OF     0169
*                                      RECURSION                     */
         SLR   @14,@14                                             0169
         ST    @14,TCBRTM12(,R4)                                   0169
*                         ESAERTYP=TCBERTYP;/* SAVE ERROR TYPE DATA  */
         IC    @14,TCBERTYP(,R4)                                   0170
         STC   @14,ESAERTYP(,R7)                                   0170
*                         TCBERTYP=0;/* CLEAR FIELDS IN CASE OF    0171
*                                      RECURSION                     */
         MVI   TCBERTYP(R4),X'00'                                  0171
*                         ESAMODE=TCBMODE;/* SAVE MODE OF SYSTEM AT
*                                      TIME OF ERROR                 */
         IC    @14,TCBMODE(,R4)                                    0172
         STC   @14,ESAMODE(,R7)                                    0172
*                         TCBMODE=0;/* CLEAR FIELDS IN CASE OF     0173
*                                      RECURSION                     */
         MVI   TCBMODE(R4),X'00'                                   0173
*                         ESACMP=TCBCMP;/* SAVE COMPLETION CODE      */
         MVC   ESACMP(4,R7),TCBCMP(R4)                             0174
*                         TCBABTRM=OFF;/* PERMIT RTM1 TO TERMINATE 0175
*                                      THIS TASK IF ANOTHER ERROR  0175
*                                      OCCURS                        */
         NI    TCBABTRM(R4),B'11011111'                            0175
*                       END;                                       0176
*                     ELSE                                         0177
*                       ;           /* ENTRY NOT DUE TO RTM1         */
@RF00165 DS    0H                                                  0178
*                     TCBFX=ON;     /* PROHIBIT ASYNCHRONOUS EXITS   */
         OI    TCBFX(R4),B'00000001'                               0178
*                     TCBFPRAP=ON;  /* PROHIBIT PERCOLATION OF     0179
*                                      ASYNCHRONOUS ERRORS           */
         OI    TCBFPRAP(R4),B'00010000'                            0179
*                     ESAGLREC=ON;                                 0180
         OI    ESAGLREC(R7),B'00010000'                            0180
*                     DO;           /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRT2(RT2INESA))  */
*                       RESPECIFY                                  0182
*                        (GPR11P,                                  0182
*                         GPR12P,                                  0182
*                         GPR13P,                                  0182
*                         GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                      SETLOCK                       */
*                       GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                           GPR13P,GPR14P);                        0183
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRT2(RT2INESA))
*                       RESPECIFY                                  0184
*                        (GPR11P,                                  0184
*                         GPR12P,                                  0184
*                         GPR13P,                                  0184
*                         GPR14P) UNRESTRICTED;/* RELEASE REGS USED
*                                      BY SETLOCK                    */
*                     END;          /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRT2(RT2INESA))
*                                      RELEASE LOCAL LOCK            */
*                     ESAGLREC=OFF;                                0186
         NI    ESAGLREC(R7),B'11101111'                            0186
*                   END;            /* END PROCESSING OF TCB         */
*                 ELSE                                             0188
*                   ;               /* PREVIOUS SETLOCK ERROR - NO 0188
*                                      FURTHER PROCESSING            */
@RF00115 DS    0H                                                  0189
*               END;                /* END PROCESSING OF ABNORMAL EOT*/
*         END;                      /* END OF RT2INESA               */
@RC00089 DS    0H                                                  0190
@RC00087 DS    0H                                                  0191
*         IF ESAFERR=OFF THEN       /* IF THE INITIALIZATION WAS   0191
*                                      SUCCESSFUL, AN ATTEMPT IS MADE
*                                      TO ACQUIRE CORE FOR THE RTM2WA
*                                      IF NECESSARY                  */
         TM    ESAFERR(R7),B'00001000'                             0191
         BNZ   @RF00191                                            0191
*           IF ESAGMREC=OFF THEN    /* NO PREVIOUS FAILURE IN GETMAIN*/
         TM    ESAGMREC(R7),B'10000000'                            0192
         BNZ   @RF00192                                            0192
*             DO;                                                  0193
*               ESAGMREC=ON;        /* SET RECURSION FLAG TO MARK  0194
*                                      SECTION IN CASE OF FAILURE    */
         OI    ESAGMREC(R7),B'10000000'                            0194
*               IF ESACTS=OFF THEN  /* NOT ENTRY DUE TO            0195
*                                      CONVERT-TO-STEP ERROR - WORK
*                                      AREA NEEDED                   */
*                                                                  0195
         TM    ESACTS(R7),B'00010000'                              0195
         BNZ   @RF00195                                            0195
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT RT2GETWA ACQUIRES THE RTM2 WORK AREA.   */
*                 /* THE TCBABGM FLAG IS SET SO THAT GETMAIN WILL    */
*                 /* OBTAIN STORAGE FROM SQA IF NONE IS AVAILABLE IN */
*                 /* LSQA. A CONDITIONAL GETMAIN IS THEN ISSUED. IF  */
*                 /* IT IS SUCCESSFUL, THE ADDRESS OF THE ACQUIRED   */
*                 /* CORE IS PLACED IN THE ESA AND THE CORE IS       */
*                 /* ZEROED. IT IS CHAINED FROM THE TCB AND, IF IT   */
*                 /* WAS OBTAINED FROM SQA, TO THE ASCB. IF CORE IS  */
*                 /* NOT OBTAINED A RETURN CODE OF 4 IS RETURNED.    */
*                 /* OTHERWISE, A RETURN CODE OF 0 IS RETURNED. ON   */
*                 /* ENTRY REG 4 LOCATES THE TCB, REG 5, THE SVRB AND*/
*                 /* REG 7, THE ASCB. NO LOCK IS HELD ON ENTRY OR    */
*                 /* EXIT. THIS ROUTINE MUST NOT BE RE-ENTERED IF IT */
*                 /* HAS SUFFERED AN ERROR.                          */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0196
*                 DO;               /* BEGIN SEGMENT RT2GETWA        */
*                   TCBABGM=ON;     /* FORCE GETMAIN TO USE SQA IF NO
*                                      LSQA AVAILABLE                */
         OI    TCBABGM(R4),B'00010000'                             0197
*                   RESPECIFY                                      0198
*                    (R0,                                          0198
*                     R1,                                          0198
*                     R15,                                         0198
*                     R14) RESTRICTED;/* RESTRICT REGISTERS USED BY
*                                      GETMAIN                       */
*                   R0=LENGTH(RTM2WA);/* SET UP LENGTH PARAMETER FOR
*                                      GETMAIN                       */
         LA    R0,972                                              0199
*                   GEN REFS(R0) SETS(R1,R14,R15)                  0200
*                       (GETMAIN RC,LV=(0),SP=255);/* OBTAIN STORAGE
*                                      FOR WORK AREA                 */
         GETMAIN RC,LV=(0),SP=255
*                   IF R15=0 THEN   /* CORE OBTAINED                 */
         LTR   R15,R15                                             0201
         BNZ   @RF00201                                            0201
*                     DO;                                          0202
*                       ESART2WA=R1;/* QUEUE WORK AREA FROM ESA      */
         ST    R1,ESART2WA(,R7)                                    0203
*                       RESPECIFY                                  0204
*                         R8 RESTRICTED;                           0204
*                       R8=R1;      /* SET UP POINTER TO WORK AREA   */
         LR    R8,R1                                               0205
*                       RESPECIFY                                  0206
*                        (R0,                                      0206
*                         R1,                                      0206
*                         R15,                                     0206
*                         R14) UNRESTRICTED;/* RELEASE REGISTERS ON
*                                      RETURN FROM GETMAIN           */
*                       ESAWSPID=255;/* PUT SUBPOOL ID IN ESA FOR  0207
*                                      FREEMAIN                      */
         MVI   ESAWSPID(R7),X'FF'                                  0207
*                       ESAWLEN=LENGTH(RTM2WA);/* PUT LENGTH OF WORK
*                                      AREA IN ESA FOR FREEMAIN      */
         MVC   ESAWLEN(3,R7),@CF03185+1                            0208
*                       RTM2WA(1:256)=''B;/* CLEAR RTM2WA            */
         XC    RTM2WA(256,R8),RTM2WA(R8)                           0209
*                       RTM2WA(257:512)=''B;                       0210
         XC    RTM2WA+256(256,R8),RTM2WA+256(R8)                   0210
*                       RTM2WA(513:768)=''B;                       0211
         XC    RTM2WA+512(256,R8),RTM2WA+512(R8)                   0211
*                       RTM2WA(769:LENGTH(RTM2WA))=''B;            0212
*                                                                  0212
         XC    RTM2WA+768(204,R8),RTM2WA+768(R8)                   0212
*                       /*********************************************/
*                       /*                                           */
*                       /* CHAIN RTM2WA FROM ASCB IF ACQUIRED FROM   */
*                       /* SQA                                       */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0213
*                       IF R8>=PASTRT+PASIZE THEN/* STORAGE OBTAINED
*                                      FROM SQA                      */
         L     @12,CVTPTR                                          0213
         L     @12,GDAPTR(,@12)                                    0213
         L     @09,PASTRT(,@12)                                    0213
         AL    @09,PASIZE(,@12)                                    0213
         CR    R8,@09                                              0213
         BL    @RF00213                                            0213
*                         DO;                                      0214
*                           RTM2SQS=ON;/* MARK WORK AREA AS BEING  0215
*                                      FROM SQS                      */
         OI    RTM2SQS(R8),B'00100000'                             0215
*                           ESAGLREC=ON;/* SETLOCK IN CONTROL        */
         OI    ESAGLREC(R7),B'00010000'                            0216
*                           DO;     /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(ASCB,IEAVTRT2(
*                                      RT2GETWA))                    */
*                             RESPECIFY                            0218
*                              (GPR11P,                            0218
*                               GPR12P,                            0218
*                               GPR13P,                            0218
*                               GPR14P) RESTRICTED;/* RESTRICT REGS
*                                      USED BY                SETLOCK*/
*                             GENERATE REFS(PSALITA,FLC) SETS(GPR11P,
*                                 GPR12P,GPR13P,GPR14P);           0219
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(ASCB,IEAVTRT2(RT2GETWA))
*                             RESPECIFY                            0220
*                              (GPR11P,                            0220
*                               GPR12P,                            0220
*                               GPR13P,                            0220
*                               GPR14P) UNRESTRICTED;/* RELEASE REGS
*                                      USED BY                SETLOCK*/
*                           END;    /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(ASCB,IEAVTRT2(
*                                      RT2GETWA))                    */
*                           ESAGLREC=OFF;/* SETLOCK DONE             */
         NI    ESAGLREC(R7),B'11101111'                            0222
*                           RTM2SPWA=ASCBRTWA;/* CHAIN NEXT WORK AREA
*                                      FROM THIS ONE                 */
         L     @12,ASCBPTR(,R7)                                    0223
         L     @09,ASCBRTWA(,@12)                                  0223
         ST    @09,RTM2SPWA(,R8)                                   0223
*                           ASCBRTWA=R8;/* CHAIN WORKAREA FROM ASCB  */
         ST    R8,ASCBRTWA(,@12)                                   0224
*                           ESAGLREC=ON;/* SETLOCK IN CONTROL        */
         OI    ESAGLREC(R7),B'00010000'                            0225
*                           DO;     /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(ASCB,IEAVTRT2(RT2GETWA)) */
*                             RESPECIFY                            0227
*                              (GPR11P,                            0227
*                               GPR12P,                            0227
*                               GPR13P,                            0227
*                               GPR14P) RESTRICTED;/* RESTRICT REGS
*                                      USED BY                SETLOCK*/
*                             GENERATE REFS(PSALITA,FLC) SETS(GPR11P,
*                                 GPR12P,GPR13P,GPR14P);           0228
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(ASCB,IEAVTRT2(RT2GETWA))
*                             RESPECIFY                            0229
*                              (GPR11P,                            0229
*                               GPR12P,                            0229
*                               GPR13P,                            0229
*                               GPR14P) UNRESTRICTED;/* RELEASE REGS
*                                      USED BY                SETLOCK*/
*                           END;    /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(ASCB,IEAVTRT2(RT2GETWA)) */
*                           ESAGLREC=OFF;/* SETLOCK DONE             */
         NI    ESAGLREC(R7),B'11101111'                            0231
*                         END;                                     0232
*                       ELSE                                       0233
*                         ;         /* RTM2WA IN LSQA                */
*                                                                  0233
@RF00213 DS    0H                                                  0234
*                       /*********************************************/
*                       /*                                           */
*                       /* CHAIN RTM2WA FROM TCB                     */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0234
*                       RTM2PREV=TCBRTWA;/* CHAIN PREVIOUS FROM    0234
*                                      CURRENT                       */
         L     @12,TCBRTWA(,R4)                                    0234
         ST    @12,RTM2PREV(,R8)                                   0234
*                       TCBRTWA=R8;                                0235
*                                                                  0235
         ST    R8,TCBRTWA(,R4)                                     0235
*                       /*********************************************/
*                       /*                                           */
*                       /* SET UP RECURSION ADDRESS IN WORK AREA     */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0236
*                       RTM2CTRA=ADDR(RT2CRERR);/* SET UP CRITICAL 0236
*                                      RECURSION ADDRESS             */
         LA    @12,RT2CRERR                                        0236
         ST    @12,RTM2CTRA(,R8)                                   0236
*                     END;                                         0237
*                   ELSE            /* STORAGE NOT AVAILABLE         */
*                     ESAFERR=ON;   /* INDICATE NO FURTHER PROCESSING
*                                      POSSIBLE                      */
         B     @RC00201                                            0238
@RF00201 OI    ESAFERR(R7),B'00001000'                             0238
*                   TCBABGM=OFF;    /* RESET SQS FLAG                */
@RC00201 NI    TCBABGM(R4),B'11101111'                             0239
*                 END;              /* END OF RT2GETWA               */
*               ELSE                /* THIS ENTRY HAS BEEN CONVERTED
*                                      TO STEP - THE WORK AREA HAS 0241
*                                      ALREADY BEEN QUEUED TO THE TCB*/
*                 DO;                                              0241
         B     @RC00195                                            0241
@RF00195 DS    0H                                                  0242
*                   R8=TCBRTWA;     /* INITIALIZE PTR TO WORK AREA   */
         L     R8,TCBRTWA(,R4)                                     0242
*                   ESART2WA=R8;    /* QUEUE WORK AREA FROM ESA      */
         ST    R8,ESART2WA(,R7)                                    0243
*                   ESART2D=RTM2RT2D;/* INITIALIZE DESCRIPTION OF  0244
*                                      WORK AREA (SUBPOOL AND      0244
*                                      LENGTH)IN ESA                 */
         MVC   ESART2D(4,R7),RTM2RT2D(R8)                          0244
*                 END;                                             0245
*               ESAGMREC=OFF;       /* RESET FLAG BECAUSE GETMAIN DID
*                                      NOT CAUSE RECURSION           */
@RC00195 NI    ESAGMREC(R7),B'01111111'                            0246
*             END;                                                 0247
*           ELSE                    /* RECURSIVE ENTRY DUE TO GETMAIN
*                                      FAILURE                       */
*             ESAFERR=ON;           /* INDICATE ERROR IN INIT.     0248
*                                      PROCESSING                    */
         B     @RC00192                                            0248
@RF00192 OI    ESAFERR(R7),B'00001000'                             0248
*         ELSE                                                     0249
*           ;                       /* ERROR IN ESA INITIALIZATION   */
@RF00191 DS    0H                                                  0250
*       END;                        /* END OF RT2INCTL               */
@RC00191 DS    0H                                                  0251
*       IF ESAFERR=OFF THEN         /* WORK AREA OBTAINED            */
         TM    ESAFERR(R7),B'00001000'                             0251
         BNZ   @RF00251                                            0251
*         IF ESAINREC=OFF THEN      /* THIS IS NOT A RECURSION IN  0252
*                                      INITIALIZATION                */
         TM    ESAINREC(R7),B'00100000'                            0252
         BNZ   @RF00252                                            0252
*           DO;                                                    0253
*             ESAINREC=ON;          /* SET SECTION FLAG IN CASE    0254
*                                      SECTION SHOULD RECURSE        */
*                                                                  0254
         OI    ESAINREC(R7),B'00100000'                            0254
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT RT2INWA CONTROLS THE INITIALIZATION OF THE  */
*             /* RTM2WA. IT INCLUDES SEGMENTS RT2INCNV, RT2INCM,     */
*             /* RT2INPG, RT2INRCR, RT2INRT1, RT2INMT, RT2INEOT AND  */
*             /* RT2INABD TO INITIALIZE FIELDS IN THE RTM2WA BASED ON*/
*             /* THE TYPE OF ENTRY. ON ENTRY REG 5 LOCATES THE SVRB  */
*             /* AND REG 8, THE RTM2WA. NO LOCK IS HELD ON ENTRY OR  */
*             /* EXIT. THERE ARE NO RETURN CODES. THIS ROUTINE MUST  */
*             /* NOT BE RE-ENTERED IF IT HAS SUFFERED AN ERROR.      */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0255
*             DO;                   /* BEGIN SEGMENT RT2INWA         */
*               IF ESACTS=ON THEN   /* ENTRY IS DUE TO A CONVERSION
*                                      TO STEP                       */
*                                                                  0256
         TM    ESACTS(R7),B'00010000'                              0256
         BNO   @RF00256                                            0256
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT RT2INCNV INITIALIZES THE WORK AREA FOR  */
*                 /* ABENDS THAT HAVE BEEN CONVERTED TO STEP DUE TO  */
*                 /* THE STEP OPTION BEING SPECIFIED BY THE REQUESTOR*/
*                 /* OF ABEND OR BECAUSE THE ABEND OCCURRED ON A TASK*/
*                 /* WHICH HELD STEP MUST COMPLETE RESOURCES. THE    */
*                 /* WORK AREA BEING USED BY RTM2 ON THE TASK THAT   */
*                 /* ORIGINALLY SUFFERED THE ERROR WAS QUEUED TO THE */
*                 /* JOBSTEP TCB BEFORE CAUSING THE JOBSTEP TO BE    */
*                 /* ABTERMED SO,AT THIS ENTRY, A WORK AREA ALREADY  */
*                 /* EXISTS. THE WORK AREA IS ADJUSTED TO REFLECT THE*/
*                 /* JOBSTEP LEVEL. FIELDS SET BY THE ORIGINAL RTM2  */
*                 /* PROCESSING THAT ARE NO LONGER APPROPRIATE ARE   */
*                 /* ZEROED. THEY WILL BE SET AS NEEDED DURING       */
*                 /* CURRENT RTM2 PROCESSING. ON ENTRY REG 8 LOCATES */
*                 /* THE RTM2WA AND REG 5 LOCATES THE SVRB.          */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0257
*                 DO;               /* BEGIN SEGMENT RT2INCNV        */
*                                                                  0257
*                   /*************************************************/
*                   /*                                               */
*                   /* ZERO APPROPRIATE FIELDS. THEY WILL BE SET AS  */
*                   /* NEEDED DURING SUBSEQUENT PROCESSING           */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0258
*                   RTM2CVER(1:256)=''B;                           0258
         XC    RTM2CVER(256,R8),RTM2CVER(R8)                       0258
*                   RTM2CVER(257:512)=''B;                         0259
         XC    RTM2CVER+256(256,R8),RTM2CVER+256(R8)               0259
*                   RTM2CVER(513:LENGTH(RTM2CVER))=''B;            0260
         XC    RTM2CVER+512(10,R8),RTM2CVER+512(R8)                0260
*                   RTM2ERRC=''B;                                  0261
         MVI   RTM2ERRC(R8),X'00'                                  0261
*                   RTM2ERRD=''B;                                  0262
*                                                                  0262
         MVI   RTM2ERRD(R8),X'00'                                  0262
*                   /*************************************************/
*                   /*                                               */
*                   /* ADJUST WORK AREA TO REFLECT JOBSTEP LEVEL     */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0263
*                   RTM2TCBC=ESAR4; /* SET ADDRESS OF CURRENT TCB IN
*                                      RTM2WA                        */
         L     @12,ESAR4(,R7)                                      0263
         ST    @12,RTM2TCBC(,R8)                                   0263
*                   RTM2TCBT=ESAR4; /* SET TOP TCB ADDRESS IN RTM2WA
*                                      THE SAME AS CURRENT           */
         ST    @12,RTM2TCBT(,R8)                                   0264
*                   RTM2VRBC=ESAR5; /* SET CURRENT SVRB ADDRESS IN 0265
*                                      RTM2WA                        */
         L     @09,ESAR5(,R7)                                      0265
         ST    @09,RTM2VRBC(,R8)                                   0265
*                   RTM2VRBT=ESAR5; /* SET TOP SVRB ADDRESS IN RTM2WA
*                                      THE SAME AS CURRENT           */
         ST    @09,RTM2VRBT(,R8)                                   0266
*                   RMPLTCBA=ESAR4; /* SET TCB ADDRESS IN RMPL EQUAL
*                                      TO CURRENT                    */
         ST    @12,RMPLTCBA+712(,R8)                               0267
*                   RTM2SCBN=ESAR4->TCBSTABB;/* PUT ADDRESS OF LAST
*                                      ESTABLISHED STAE CONTROL BLOCK
*                                      IN RTM2WA                     */
         L     @12,TCBSTABB-1(,@12)                                0268
         LA    @12,0(,@12)                                         0268
         ST    @12,RTM2SCBN(,R8)                                   0268
*                   RTM2SCBO=0;     /* SET END OF SCB QUEUE INDICATOR
*                                      FOR TASK RECOVERY             */
         SLR   @12,@12                                             0269
         ST    @12,RTM2SCBO(,R8)                                   0269
*                   RTM2SCBC=SCBSTART;/* INDICATE INITIAL ENTRY FOR
*                                      TASK RECOVERY                 */
*                                                                  0270
         LA    @12,1                                               0270
         ST    @12,RTM2SCBC(,R8)                                   0270
*                   /*************************************************/
*                   /*                                               */
*                   /* RESET ECB PTRS                                */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0271
*                   RESPECIFY                                      0271
*                     R9 RESTRICTED;                               0271
*                   DO R9=1 TO MAXECBS;                            0272
         LR    R9,@12                                              0272
@DL00272 DS    0H                                                  0273
*                     RTM2ECBA(R9)=ADDR(RTM2ECBS(R9));/* SET ECB   0273
*                                      POINTER TO ECB ADDRESS        */
         LR    @12,R9                                              0273
         SLA   @12,2                                               0273
         LA    @02,RTM2ECBS-4(@12,R8)                              0273
         ST    @02,RTM2ECBA-4(@12,R8)                              0273
*                   END;                                           0274
         AL    R9,@CF00067                                         0274
         C     R9,@CF00104                                         0274
         BNH   @DL00272                                            0274
*                   RESPECIFY                                      0275
*                     R9 UNRESTRICTED;                             0275
*                                                                  0275
*                   /*************************************************/
*                   /*                                               */
*                   /* INDICATE CONVERTED TO STEP ABEND              */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0276
*                   RTM2CTS=ON;                                    0276
*                                                                  0276
         OI    RTM2CTS(R8),B'00010000'                             0276
*                   /*************************************************/
*                   /*                                               */
*                   /* ADJUST TCB FIELDS                             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0277
*                   ESAGLREC=ON;    /* SET RECURSION FLAG IN ESA TO
*                                      COVER LOCK MANAGER FAILURE    */
         OI    ESAGLREC(R7),B'00010000'                            0277
*                   DO;             /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCBFDW,IEAVTRT
*                                      2(RT2INCNV))                  */
*                     RESPECIFY                                    0279
*                      (GPR11P,                                    0279
*                       GPR12P,                                    0279
*                       GPR13P,                                    0279
*                       GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                      SETLOCK                       */
*                     GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                         GPR13P,GPR14P);                          0280
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(TCBFDW,IEAVTRT2(RT2INCNV))
*                     RESPECIFY                                    0281
*                      (GPR11P,                                    0281
*                       GPR12P,                                    0281
*                       GPR13P,                                    0281
*                       GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY
*                                      SETLOCK                       */
*                   END;            /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCBFDW,IEAVTRT
*                                      2(RT2INCNV)) OBTAIN LOCAL LOCK*/
*                   TCBFDW=OFF;     /* ZERO FDW SO THAT LATER PROCESS
*                                      DOES NOT ASSUME A SUBTASK IS
*                                      WAITING                       */
         NI    TCBFDW(R4),B'11011111'                              0283
*                   TCBFA=ON;       /* INDICATE ERROR UNRECOVERABLE
*                                      AND PREVENT SUBTASKS FROM   0284
*                                      CONVERTING TO STEP            */
*                   TCBFT=ON;       /* TOP TASK IN TREE              */
         OI    TCBFA(R4),B'10000100'                               0285
*                   DO;             /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCBFDW,IEAVTRT2(RT2INCNV)
*                                      )                             */
*                     RESPECIFY                                    0287
*                      (GPR11P,                                    0287
*                       GPR12P,                                    0287
*                       GPR13P,                                    0287
*                       GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                      SETLOCK                       */
*                     GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                         GPR13P,GPR14P);                          0288
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCBFDW,IEAVTRT2(RT2INCNV))
*                     RESPECIFY                                    0289
*                      (GPR11P,                                    0289
*                       GPR12P,                                    0289
*                       GPR13P,                                    0289
*                       GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY
*                                      SETLOCK                       */
*                   END;            /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCBFDW,IEAVTRT2(RT2INCNV)
*                                      ) RELEASE LOCAL LOCK          */
*                   ESAGLREC=OFF;   /* RESET RECURSION FLAG          */
         NI    ESAGLREC(R7),B'11101111'                            0291
*                 END;              /* END SEGMENT RT2INCNV          */
*               ELSE                /* NOT CONVERT TO STEP ENTRY     */
*                 DO;                                              0293
*                                                                  0293
         B     @RC00256                                            0293
@RF00256 DS    0H                                                  0294
*                   /*************************************************/
*                   /*                                               */
*                   /* SEGMENT RT2INCM INITIALIZES THE FIELDS IN THE */
*                   /* RTM2 WORK AREA THAT ARE NEEDED FOR ALL TYPES  */
*                   /* OF ENTRIES EXCEPT CONVERTED TO STEP ENTRIES.  */
*                   /* THE DATA TEMPORARILY STORED IN THE ESA IS     */
*                   /* COPIED INTO THE WORK AREA. POINTERS WITHIN THE*/
*                   /* WORK AREA TO DATA WITHIN THE WORK AREA ARE    */
*                   /* SET. ON ENTRY, REG 5 LOCATES THE SVRB AND REG */
*                   /* 8, THE RTM2WA.                                */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0294
*                   DO;             /* BEGIN SEGMENT RT2INCM         */
*                     RTM2CVT=ESAR3;/* PUT ADDR OF CVT IN RTM2WA     */
         L     @12,ESAR3(,R7)                                      0295
         ST    @12,RTM2CVT(,R8)                                    0295
*                     RTM2TCBC=ESAR4;/* PUT ADDR OF CURRENT TCB IN 0296
*                                      RTM2WA                        */
         L     @09,ESAR4(,R7)                                      0296
         ST    @09,RTM2TCBC(,R8)                                   0296
*                     RTM2TCBT=ESAR4;/* PUT ADDR OF TOP TCB IN     0297
*                                      FAILING TASK IN RTM2WA -    0297
*                                      ASSUMED TO BE CURRENT AT THIS
*                                      TIME                          */
         ST    @09,RTM2TCBT(,R8)                                   0297
*                     RTM2VRBC=ESAR5;/* PUT ADDRESS OF CURRENT SVRB
*                                      IN RTM2WA                     */
         L     @02,ESAR5(,R7)                                      0298
         ST    @02,RTM2VRBC(,R8)                                   0298
*                     RTM2VRBT=ESAR5;/* PUT ADDR OF SVRB ON TOP TCB
*                                      IN RTM2WA - ASSUMED TO BE   0299
*                                      CURRENT AT THIS TIME.         */
         ST    @02,RTM2VRBT(,R8)                                   0299
*                     RTM2ADDR=ESART2WA;/* PUT ADDR OF BEGINNING OF
*                                      RTM2WA IN RTM2WA              */
         L     @02,ESART2WA(,R7)                                   0300
         ST    @02,RTM2ADDR(,R8)                                   0300
*                     RTM2RT2D=ESART2D;/* PUT SUBPOOL ID AND LENGTH
*                                      OF RTM2WA IN RTM2WA           */
         MVC   RTM2RT2D(4,R8),ESART2D(R7)                          0301
*                     RTM2ID='RTM2';/* PUT SELF-IDENTIFIER IN RTM2WA */
         MVC   RTM2ID(4,R8),@CC03137                               0302
*                     RTM2ASC=ESAR7;/* PUT ADDR OF ASCB IN RTM2WA    */
         L     @02,ESAR7(,R7)                                      0303
         ST    @02,RTM2ASC(,R8)                                    0303
*                     RTM2CT=ESAR3->CVTRTMCT;/* PUT ADDR OF RTMCT IN
*                                      RTM2WA                        */
         L     @12,CVTRTMCT(,@12)                                  0304
         ST    @12,RTM2CT(,R8)                                     0304
*                     RTM2SCBN=ESAR4->TCBSTABB;/* PUT ADDR OF LAST 0305
*                                      ESTABLISHED STAE CONTROL BLOCK
*                                      IN RTM2WA                     */
         L     @12,TCBSTABB-1(,@09)                                0305
         LA    @12,0(,@12)                                         0305
         ST    @12,RTM2SCBN(,R8)                                   0305
*                     RTM2SCBC=SCBSTART;/* INDICATE INITIAL ENTRY FOR
*                                      TASK RECOVERY                 */
         LA    @12,1                                               0306
         ST    @12,RTM2SCBC(,R8)                                   0306
*                     RTM2SCBO=0;   /* SET END OF SCB QUEUE INDICATOR
*                                      FOR TASK RECOVERY             */
*                                                                  0307
         SLR   @09,@09                                             0307
         ST    @09,RTM2SCBO(,R8)                                   0307
*                     /***********************************************/
*                     /*                                             */
*                     /* SET ADDRESSES TO AREAS WITHIN THE WORK AREA */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0308
*                     RMPLRMWA=ADDR(RTM2RMWS);/* SET ADDR OF RESOURCE
*                                      MGR WORK SPACE IN RMPL        */
         LA    @09,712                                             0308
         ALR   @09,R8                                              0308
         LA    @02,RTM2RMWS(,R8)                                   0308
         ST    @02,RMPLRMWA(,@09)                                  0308
*                     RTM2RMPS=ADDR(RMPL);/* SET ADDR OF RMPL IN   0309
*                                      RTM2WA                        */
         ST    @09,RTM2RMPS(,R8)                                   0309
*                     RESPECIFY                                    0310
*                       R9 RESTRICTED;/* RESTRICT CONTROL REG        */
*                     DO R9=1 TO MAXECBS;                          0311
         LR    R9,@12                                              0311
@DL00311 DS    0H                                                  0312
*                       RTM2ECBA(R9)=ADDR(RTM2ECBS(R9));/* SET ECB 0312
*                                      POINTER TO ECB ADDRESS        */
         LR    @12,R9                                              0312
         SLA   @12,2                                               0312
         LA    @02,RTM2ECBS-4(@12,R8)                              0312
         ST    @02,RTM2ECBA-4(@12,R8)                              0312
*                     END;                                         0313
         AL    R9,@CF00067                                         0313
         C     R9,@CF00104                                         0313
         BNH   @DL00311                                            0313
*                     RESPECIFY                                    0314
*                       R9 UNRESTRICTED;/* RELEASE CONTROL REG       */
*                   END;            /* END SEGMENT RT2INCM           */
*                   IF ESANEOT=ON THEN/* NORMAL END OF TASK          */
*                                                                  0316
         TM    ESANEOT(R7),B'00001000'                             0316
         BNO   @RF00316                                            0316
*                     /***********************************************/
*                     /*                                             */
*                     /* RT2INEOT INITIALIZES THE RESOURCE MANAGER   */
*                     /* PARAMETER LIST AND SETS UP FOR NORMAL END OF*/
*                     /* TASK PROCESSING. THE COMPLETION CODE IS     */
*                     /* STORED IN THE TCB.                          */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0317
*                     DO;           /* START OF RT2INEOT             */
*                                                                  0317
*                       /*********************************************/
*                       /*                                           */
*                       /* INITIALIZE RESOURCE MANAGER PARM LIST FOR */
*                       /* NORMAL END OF TASK                        */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0318
*                       RMPLTERM=OFF;/* TASK TERMINATING             */
*                       RMPLTYPE=OFF;/* NORMAL TERMINATION           */
         LA    @12,712                                             0319
         ALR   @12,R8                                              0319
         NI    RMPLTERM(@12),B'00111111'                           0319
*                       RMPLASCB=ESAR7;/* SAVE ADDRESS OF ASCB OF  0320
*                                      ENDING TASK                   */
         L     @09,ESAR7(,R7)                                      0320
         ST    @09,RMPLASCB(,@12)                                  0320
*                       RMPLASID=ESAR7->ASCBASID;/* SAVE ASID IN   0321
*                                      RESOURCE MGR PARM LIST        */
         MVC   RMPLASID(2,@12),ASCBASID(@09)                       0321
*                       RTM2CODE=ESAR1;/* COMPLETION CODE WAS PASSED
*                                      IN REG. 1                     */
*                                                                  0322
         L     @12,ESAR1(,R7)                                      0322
         ST    @12,RTM2CODE(,R8)                                   0322
*                       /*********************************************/
*                       /*                                           */
*                       /* SAVE COMPLETION CODE IN TCB               */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0323
*                       TCBCMPC=RTM2CC;/* SAVE COMPLETION CODE       */
         MVC   TCBCMPC(3,R4),RTM2CC(R8)                            0323
*                       TCBCMPF=0;  /* CLEAR FLAGS FIELD             */
         MVI   TCBCMPF(R4),X'00'                                   0324
*                     END;          /* END OF RT2INEOT               */
*                   ELSE            /* NOT NORMAL END OF TASK        */
*                     DO;                                          0326
         B     @RC00316                                            0326
@RF00316 DS    0H                                                  0327
*                       IF ESAPGNLY=ON THEN/* ENTRY IS FOR PURGE ONLY*/
*                                                                  0327
         TM    ESAPGNLY(R7),B'00100000'                            0327
         BNO   @RF00327                                            0327
*                         /*******************************************/
*                         /*                                         */
*                         /* SEGMENT RT2INPG INITIALIZES THE WORK    */
*                         /* AREA WHEN RTM2 IS ENTERED FOR           */
*                         /* TERMINATION PURGES ONLY. THE CONTROLLING*/
*                         /* WORK AREA IS FOUND BY SEARCHING THE     */
*                         /* ANCESTOR TREE FOR THE TOP TCB IN THIS   */
*                         /* FAILING TREE AND THE APPROPRIATE FIELDS */
*                         /* WITHIN IT ARE COPIED. THESE FIELDS ARE  */
*                         /* BASICALLY THOSE WHICH CONTAIN THE       */
*                         /* ORIGINAL ERROR DATA. THE REMAINING      */
*                         /* FIELDS ARE THEN INITIALIZED IF REQUIRED.*/
*                         /* ON ENTRY REG 8 LOCATES THE RTM2WA AND   */
*                         /* REG 5, THE SVRB.                        */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0328
*                         DO;       /* BEGIN SEGMENT RT2INPG         */
*                                                                  0328
*                           /*****************************************/
*                           /*                                       */
*                           /* FIND CONTROLLING WORKAREA             */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0329
*                           RESPECIFY                              0329
*                             R9 RESTRICTED;/* RESTRICT ALT. TCB PTR */
*                           R9=R4;  /* SET ANCESTOR TCB ADDR EQUAL TO
*                                      CURRENT                       */
         LR    R9,R4                                               0330
*                           RESPECIFY                              0331
*                             TCB BASED(R9);/* BASE TCB ON ANCESTOR
*                                      ADDRESS                       */
*                           DO WHILE(TCBFT=OFF);/* SEARCH FOR TOP  0332
*                                      TASK                          */
         B     @DE00332                                            0332
@DL00332 DS    0H                                                  0333
*                             R9=TCBOTC;/* FIND ANCESTOR             */
         L     R9,TCBOTC(,R9)                                      0333
*                           END;    /* ATCBPTR NOW CONTAINS ADDR OF
*                                      TOP TASK IN FAILING TREE      */
@DE00332 TM    TCBFT(R9),B'00000100'                               0334
         BZ    @DL00332                                            0334
*                           DO;                                    0335
*                             RESPECIFY                            0336
*                               R2 RESTRICTED;                     0336
*                             R2=TCBRBP;/* LOCATE STARTING RB        */
*                                                                  0337
         L     R2,TCBRBP(,R9)                                      0337
*                             /***************************************/
*                             /*                                     */
*                             /* SCAN FOR RB WITH RBABEND ON. SCAN   */
*                             /* TERMINATED WHEN RBTCBNXT ON         */
*                             /*                                     */
*                             /***************************************/
*                                                                  0338
*                             DO WHILE(EVAL(R2-LENGTH(RBPRFX))->RBABEND
*                                   ='0'B&R2->RBTCBNXT='0'B);      0338
         B     @DE00338                                            0338
@DL00338 DS    0H                                                  0339
*                               R2=R2->RBLINKB;/* LOCATE NEXT RB     */
         L     @12,RBLINKB-1(,R2)                                  0339
         LA    @12,0(,@12)                                         0339
         LR    R2,@12                                              0339
*                             END;  /* END SCAN OF RBS               */
@DE00338 LR    @12,R2                                              0340
         SL    @12,@CF00482                                        0340
         TM    RBABEND(@12),B'00100000'                            0340
         BNZ   @DC00338                                            0340
         TM    RBTCBNXT(R2),B'10000000'                            0340
         BZ    @DL00338                                            0340
@DC00338 DS    0H                                                  0341
*                             IF EVAL(R2-LENGTH(RBPRFX))->RBABEND='0'B
*                               THEN/* CHECK WHETHER ONE WAS FOUND   */
         LR    @12,R2                                              0341
         SL    @12,@CF00482                                        0341
         TM    RBABEND(@12),B'00100000'                            0341
         BNZ   @RF00341                                            0341
*                               R2=0;/* NO RTM2 RB FOUND             */
         SLR   R2,R2                                               0342
*                           END;    /* FIND RTM2 SVRB ON TOP TCB     */
@RF00341 DS    0H                                                  0344
*                           IF R2^=0 THEN/* RTM2 SVRB FOUND          */
         LTR   R2,R2                                               0344
         BZ    @RF00344                                            0344
*                             DO;                                  0345
*                               RESPECIFY                          0346
*                                 RBBASIC BASED(R2);/* BASE RB ON  0346
*                                      RTM2 SVRB ON TOP TASK         */
*                               RESPECIFY                          0347
*                                 RTM2ESA BASED(ADDR(RBEXSAVE));/* 0347
*                                      BASE RTM2 ESA ON TOP TASK     */
*                                                                  0347
*                               /*************************************/
*                               /*                                   */
*                               /* COPY APPROPRIATE FIELDS           */
*                               /*                                   */
*                               /*************************************/
*                                                                  0348
*                               RTM2TCBT=ESART2WA->RTM2TCBT;/* SET 0348
*                                      TOP TCB IN NEW WORKAREA TO TOP
*                                      TCB ADDRESS                   */
         L     @12,ESART2WA+96(,R2)                                0348
         L     @15,RTM2TCBT(,@12)                                  0348
         ST    @15,RTM2TCBT(,R8)                                   0348
*                               RTM2VRBT=ESART2WA->RTM2VRBT;/* SET 0349
*                                      TOP SVRB IN NEW WORKAREA TO 0349
*                                      TOP SVRB ADDRESS              */
         L     @15,RTM2VRBT(,@12)                                  0349
         ST    @15,RTM2VRBT(,R8)                                   0349
*                               RTM2CC=ESART2WA->RTM2CC;/* SET     0350
*                                      COMPLETION CODE IN NEW      0350
*                                      WORKAREA                      */
         MVC   RTM2CC(3,R8),RTM2CC(@12)                            0350
*                               RTM2STRA=ESART2WA->RTM2STRA;/* COPY
*                                      STEP CONVERSION RECURSION   0351
*                                      ADDRESS FROM OLD WORK AREA    */
         L     @15,RTM2STRA(,@12)                                  0351
         ST    @15,RTM2STRA(,R8)                                   0351
*                               RTM2PGCY=ESART2WA->RTM2PGCY;/* COPY
*                                      ORIGINAL ERROR INFO           */
         MVC   RTM2PGCY(126,R8),RTM2PGCY(@12)                      0352
*                               RESPECIFY                          0353
*                                 TCB BASED(R4);/* BASE TCB ON     0353
*                                      CURRENT TCB                   */
*                               RESPECIFY                          0354
*                                 RBBASIC BASED(R5);/* BASE RB ON  0354
*                                      CURRENT RB                    */
*                               RESPECIFY                          0355
*                                 RTM2ESA BASED(R7);/* BASE ESA ON 0355
*                                      CURRENT                       */
*                               RESPECIFY                          0356
*                                 R9 UNRESTRICTED;/* RELEASE ALT. TCB
*                                      PTR                           */
*                               RESPECIFY                          0357
*                                 R2 UNRESTRICTED;/* RELEASE TEMP RB
*                                      REG                           */
*                                                                  0357
*                               /*************************************/
*                               /*                                   */
*                               /* INITIALIZE PURGE ONLY FIELDS      */
*                               /*                                   */
*                               /*************************************/
*                                                                  0358
*                               RTM2ERRC=''B;/* ZERO NON-APPLICABLE
*                                      ERROR DATA                    */
         MVI   RTM2ERRC(R8),X'00'                                  0358
*                               RTM2ERRD=''B;                      0359
         MVI   RTM2ERRD(R8),X'00'                                  0359
*                               RTM2PURG=ON;/* INDICATE PURGE ONLY 0360
*                                      ENTRY                         */
         OI    RTM2PURG(R8),B'10000000'                            0360
*                               RTM2MABD=ON;/* INDICATE ANCESTOR   0361
*                                      FAILED                        */
         OI    RTM2MABD(R8),B'00001000'                            0361
*                               RMPLTYPE=ON;/* INDICATE ABNORMAL   0362
*                                      TERMINATION                   */
*                               RMPLTERM=OFF;/* INDICATE TASK MODE   */
         LA    @12,712                                             0363
         ALR   @12,R8                                              0363
         OI    RMPLTYPE(@12),B'10000000'                           0363
         NI    RMPLTERM(@12),B'10111111'                           0363
*                               RMPLASCB=ESAR7;/* SET ASCB ADDR IN 0364
*                                      RMPL                          */
         L     @09,ESAR7(,R7)                                      0364
         ST    @09,RMPLASCB(,@12)                                  0364
*                               RMPLTCBA=ESAR4;/* SET TERMINATING TCB
*                                      ADDR IN RMPL                  */
         L     @02,ESAR4(,R7)                                      0365
         ST    @02,RMPLTCBA(,@12)                                  0365
*                               RMPLASID=ESAR7->ASCBASID;/* SET ASID
*                                      IN RMPL                       */
         MVC   RMPLASID(2,@12),ASCBASID(@09)                       0366
*                             END;                                 0367
*                           ELSE    /* RTM2 SVRB NOT FOUND           */
*                             ESAFERR=ON;/* INDICATE FAILURE IN    0368
*                                      PROCESSING                    */
         B     @RC00344                                            0368
@RF00344 OI    ESAFERR(R7),B'00001000'                             0368
*                         END;      /* END SEGMENT RT2INPG           */
*                       ELSE        /* FALL THROUGH TO NEXT TEST     */
*                         IF R4^=TCBJSTCA THEN/* CURRENT IS NOT    0370
*                                      JOBSTEP                       */
         B     @RC00327                                            0370
@RF00327 L     @12,TCBJSTCA-1(,R4)                                 0370
         LA    @12,0(,@12)                                         0370
         CR    R4,@12                                              0370
         BE    @RF00370                                            0370
*                           RTM2STRA=ADDR(RTECVERR);/* CONVERT TO  0371
*                                      STEP IF ERROR OCCURS          */
         L     @12,@CV00100                                        0371
         ST    @12,RTM2STRA(,R8)                                   0371
*                       IF ESARTM2=ON THEN/* ENTRY IS A RECURSIVE ONE*/
*                                                                  0372
@RF00370 DS    0H                                                  0372
@RC00327 TM    ESARTM2(R7),B'10000000'                             0372
         BNO   @RF00372                                            0372
*                         /*******************************************/
*                         /*                                         */
*                         /* SEGMENT RT2INRCR INITIALIZES THE        */
*                         /* RECURSIVE ENTRY FIELDS IN THE RTM2WA. IF*/
*                         /* THE TASK WAS ALREADY IN 'ABEND'         */
*                         /* PROCESSING ONLY RECOVERY EXITS          */
*                         /* ESTABLISHED SINCE THE LAST FAILURE ARE  */
*                         /* ENTERED. RECURSION FIELDS AND SOME FLAGS*/
*                         /* ARE COPIED FROM THE PRECEDING WORK AREA.*/
*                         /* THE REMAINDER OF THE INITIALIZATION     */
*                         /* REQUIRED IS DONE BY SEGMENT RT2INRT1 OR */
*                         /* SEGMENT RT2INABD DEPENDING ON WHETHER   */
*                         /* THE ENTRY WAS VIA RTM1 OR NOT. ON ENTRY */
*                         /* REG 4 LOCATES THE TCB, REG 5, THE SVRB  */
*                         /* AND REG 8, THE RTM2WA                   */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0373
*                         DO;       /* START OF RT2INRCR             */
*                           RTM2RECR=ON;/* FLAG WORK AREA TO SHOW  0374
*                                      RECURSIVE ENTRY               */
*                                                                  0374
         OI    RTM2RECR(R8),B'10000000'                            0374
*                           /*****************************************/
*                           /*                                       */
*                           /* IF TASK CANNOT BE RECOVERED, ALLOW    */
*                           /* ONLY RECOVERY EXITS ESTABLISHED SINCE */
*                           /* LAST FAILURE.                         */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0375
*                           IF TCBFA=ON THEN/* TASK CANNOT BE      0375
*                                      RECOVERED                     */
         TM    TCBFA(R4),B'10000000'                               0375
         BNO   @RF00375                                            0375
*                             RTM2SCBO=RTM2PREV->RTM2SCBN;         0376
         L     @12,RTM2PREV(,R8)                                   0376
         L     @12,RTM2SCBN(,@12)                                  0376
         ST    @12,RTM2SCBO(,R8)                                   0376
*                           ELSE                                   0377
*                             ;                                    0377
*                                                                  0377
@RF00375 DS    0H                                                  0378
*                           /*****************************************/
*                           /*                                       */
*                           /* IF PREVIOUS ENTRY'S CONVERT-TO-STEP   */
*                           /* RECURSION ADDRESS IS 0, ENSURE CURRENT*/
*                           /* ADDRESS IS 0.                         */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0378
*                           IF RTM2PREV->RTM2STRA=0 THEN           0378
         SLR   @12,@12                                             0378
         L     @09,RTM2PREV(,R8)                                   0378
         C     @12,RTM2STRA(,@09)                                  0378
         BNE   @RF00378                                            0378
*                             RTM2STRA=0;                          0379
         ST    @12,RTM2STRA(,R8)                                   0379
*                           ELSE                                   0380
*                             ;                                    0380
*                                                                  0380
@RF00378 DS    0H                                                  0381
*                           /*****************************************/
*                           /*                                       */
*                           /* SET UP FLAGS SHOWING SECTIONS WITH    */
*                           /* UNCLEARED FAILURES. THE CURRENT       */
*                           /* SECTION FLAGS IN THE PREVIOUS WORK    */
*                           /* AREA ARE COMBINED WITH THE RECURSION  */
*                           /* SECTION FLAGS.                        */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0381
*                           RTM2SCTR=RTM2PREV->RTM2SCTR|RTM2PREV-> 0381
*                               RTM2SCTC;                          0381
*                                                                  0381
         L     @12,RTM2PREV(,R8)                                   0381
         MVC   RTM2SCTR(4,R8),RTM2SCTR(@12)                        0381
         OC    RTM2SCTR(4,R8),RTM2SCTC(@12)                        0381
*                           /*****************************************/
*                           /*                                       */
*                           /* COPY STPT, PURG AND ISPC FLAGS TO     */
*                           /* CURRENT WORK AREA TO PREVENT REPEATING*/
*                           /* THOSE SECTIONS                        */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0382
*                           IF RTM2PREV->RTM2ISPC=ON THEN/* INITIAL
*                                      SUBTASK PURGES ALREADY DONE   */
         TM    RTM2ISPC(@12),B'00010000'                           0382
         BNO   @RF00382                                            0382
*                             RTM2ISPC=ON;                         0383
         OI    RTM2ISPC(R8),B'00010000'                            0383
*                           IF RTM2PREV->RTM2STEP=ON THEN/* STEP   0384
*                                      ABEND HAS BEEN REQUESTED      */
@RF00382 L     @12,RTM2PREV(,R8)                                   0384
         TM    RTM2STEP(@12),B'01000000'                           0384
         BNO   @RF00384                                            0384
*                             RTM2STEP=ON;                         0385
         OI    RTM2STEP(R8),B'01000000'                            0385
*                           IF RTM2PREV->RTM2STPT=ON THEN/*        0386
*                                      CONVERSION TO STEP REQUESTED
*                                      BY PREVIOUS ABEND             */
@RF00384 L     @12,RTM2PREV(,R8)                                   0386
         TM    RTM2STPT(@12),B'10000000'                           0386
         BNO   @RF00386                                            0386
*                             RTM2STPT=ON;                         0387
         OI    RTM2STPT(R8),B'10000000'                            0387
*                           IF RTM2PREV->RTM2PURG=ON THEN/* A      0388
*                                      PREVIOUS ENTRY WAS FOR PURGE
*                                      ONLY                          */
@RF00386 L     @12,RTM2PREV(,R8)                                   0388
         TM    RTM2PURG(@12),B'10000000'                           0388
         BNO   @RF00388                                            0388
*                             RTM2PURG=ON;                         0389
         OI    RTM2PURG(R8),B'10000000'                            0389
*                           IF RTM2PREV->RTM2TREC=ON THEN/* ERROR IN
*                                      PREVIOUS TRACE COPY   @ZM45190*/
@RF00388 L     @12,RTM2PREV(,R8)                                   0390
         TM    RTM2TREC(@12),B'00010000'                           0390
         BNO   @RF00390                                            0390
*                             RTM2TREC=ON;/* PREVENT RECURSIVE ERRORS
*                                                            @ZM45190*/
*                                                                  0391
         OI    RTM2TREC(R8),B'00010000'                            0391
*                           /*****************************************/
*                           /*                                       */
*                           /* COPY FORWARD DUMP OPTIONS FROM        */
*                           /* PREVIOUS WORK AREA            @YM03570*/
*                           /*                                       */
*                           /*****************************************/
*                                                                  0392
*                           IF RTM2PREV->RTM2DREQ=ON THEN/* COPY   0392
*                                      FORWARD DUMP FLAG     @YM03570*/
@RF00390 L     @12,RTM2PREV(,R8)                                   0392
         TM    RTM2DREQ(@12),B'10000000'                           0392
         BNO   @RF00392                                            0392
*                             RTM2DREQ=ON;/*                 @YM03570*/
         OI    RTM2DREQ(R8),B'10000000'                            0393
*                           SNPPDATA=ADDR(RTM2PREV->RTM2SPRM)->SNPPDATA
*                               ;   /*                       @YM03570*/
@RF00392 LA    @12,256                                             0394
         LR    @09,R8                                              0394
         ALR   @09,@12                                             0394
         L     @02,RTM2PREV(,R8)                                   0394
         ALR   @12,@02                                             0394
         MVC   SNPPDATA(1,@09),SNPPDATA(@12)                       0394
*                           SNPSDATA=ADDR(RTM2PREV->RTM2SPRM)->SNPSDATA
*                               ;   /*                       @YM03570*/
         MVC   SNPSDATA(2,@09),SNPSDATA(@12)                       0395
*                           SNPSTOR=ADDR(RTM2DPSL);/*        @YM03570*/
         LA    @15,RTM2DPSL(,R8)                                   0396
         ST    @15,SNPSTOR(,@09)                                   0396
*                           IF ADDR(RTM2PREV->RTM2SPRM)->SNPSLIST=ON
*                             THEN  /*                       @YM03570*/
         TM    SNPSLIST(@12),B'00000010'                           0397
         BNO   @RF00397                                            0397
*                             DO;   /*                       @YM03570*/
*                               RTM2DPSL=RTM2PREV->RTM2DPSL;/* COPY
*                                      STORAGE RANGES        @YM03570*/
         MVC   RTM2DPSL(32,R8),RTM2DPSL(@02)                       0399
*                               IF RTM2PREV->RTM2WRAP=ON THEN/* COPY
*                                      WRAP-AROUND FLAG      @YM03570*/
         TM    RTM2WRAP(@02),B'00010000'                           0400
         BNO   @RF00400                                            0400
*                                 RTM2WRAP=ON;/*             @YM03570*/
         OI    RTM2WRAP(R8),B'00010000'                            0401
*                               SNPSLIST=ON;/*               @YM03570*/
@RF00400 OI    SNPSLIST+256(R8),B'00000010'                        0402
*                             END;  /*                       @YM03570*/
*                           IF RTM2PREV->RTM2NODP=ON/* WAS SLIP    0404
*                                      SPECIFIED DUMP SUPPRESSION  0404
*                                      INDICATED IN THE PREVIOUS WORK
*                                      AREA?                 @G33NPHE*/
*                             THEN  /* YES IT WAS            @G33NPHE*/
@RF00397 L     @12,RTM2PREV(,R8)                                   0404
         TM    RTM2NODP(@12),B'00010000'                           0404
         BNO   @RF00404                                            0404
*                             RTM2NODP=ON;/* SO PROPAGATE IT INTO  0405
*                                      THIS ONE TOO          @G33NPHE*/
         OI    RTM2NODP(R8),B'00010000'                            0405
*                         END;      /* END OF RT2INRCR               */
*                       ELSE                                       0407
*                         ;         /* FALL THROUGH TO NEXT TEST     */
@RF00372 DS    0H                                                  0408
*                       IF ESAPGNLY=OFF THEN/* IF ENTRY WAS NOT FOR
*                                      PURGE ONLY THEN MORE        0408
*                                      INITIALIZATION TO DO          */
@RC00372 TM    ESAPGNLY(R7),B'00100000'                            0408
         BNZ   @RF00408                                            0408
*                         IF ESAABTRM=ON THEN/* ENTRY WAS VIA THE  0409
*                                      RTM1 ABTERM                   */
*                                                                  0409
         TM    ESAABTRM(R7),B'01000000'                            0409
         BNO   @RF00409                                            0409
*                           /*****************************************/
*                           /*                                       */
*                           /* SEGMENT RT2INRT1 INITIALIZES THE WORK */
*                           /* AREA WHEN ENTRY IS VIA THE RTM1 ABTERM*/
*                           /* FUNCTION. IT CALLS SEGMENT RT2MODE TO */
*                           /* PROCESS DATA PASSED BY RTM1. IT       */
*                           /* RESTORES THE RB ALTERED BY RTM1 TO ITS*/
*                           /* PRE-ABTERM STATE SO THAT THE CORRECT  */
*                           /* DATA CAN BE PASSED TO RECOVERY EXITS. */
*                           /* IF THE ERROR OCCURRED IN A TASK MODE  */
*                           /* ROUTINE IT MOVES THE REGISTERS AND PSW*/
*                           /* AT TIME OF ERROR FROM THE APPROPRIATE */
*                           /* RB TO THE RTM2WA. IT INITIALIZES THE  */
*                           /* FLAGS IN THE RTM2WA THAT DESCRIBE THE */
*                           /* TYPE OF ERROR. ON ENTRY REG 5 LOCATES */
*                           /* THE SVRB AND REG 8, THE RTM2WA.       */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0410
*                           DO;     /* BEGIN SEGMENT RT2INRT1        */
*                                                                  0410
*                             /***************************************/
*                             /*                                     */
*                             /* RESTORE RB TO PRE-ABTERM STATE      */
*                             /*                                     */
*                             /***************************************/
*                                                                  0411
*                             RBLINKB->RBWCF=EVAL(RBLINKB-LENGTH(  0411
*                                 RBPREFIX))->RBWCSA;/* RESTORE WAIT
*                                      COUNT SAVED BY RTM1           */
         L     @12,RBLINKB-1(,R5)                                  0411
         LA    @12,0(,@12)                                         0411
         LA    @09,64                                              0411
         LR    @02,@12                                             0411
         SLR   @02,@09                                             0411
         IC    @15,RBWCSA(,@02)                                    0411
         STC   @15,RBWCF(,@12)                                     0411
*                             RBLINKB->RBOPSW(5:8)=EVAL(RBLINKB-LENGTH(
*                                 RBPREFIX))->RBRTPSW1(5:8);/*     0412
*                                      RESTORE RIGHT HALF OF OLD PSW */
         LR    @02,@12                                             0412
         SLR   @02,@09                                             0412
         MVC   RBOPSW+4(4,@12),RBRTPSW1+4(@02)                     0412
*                             RESPECIFY                            0413
*                               RBPREFIX BASED(RBLINKB-LENGTH(RBPREFIX)
*                                   );/* LOCATE PREFIX OF PREVIOUS RB*/
*                             RBINLNTH=RBRTILC;/* RESTORE INSTRUCTN
*                                      LENGTH CODE                   */
         SLR   @12,@09                                             0414
         IC    @09,RBRTILC(,@12)                                   0414
         STC   @09,RBINLNTH(,@12)                                  0414
*                             RBINTCOD=RBRTINCD;/* RESTORE INTERRUPT
*                                      CODE                          */
         LH    @09,RBRTINCD(,@12)                                  0415
         STH   @09,RBINTCOD(,@12)                                  0415
*                             RESPECIFY                            0416
*                               R13 RESTRICTED;                    0416
*                             R13=ADDR(RTM2SFSA);                  0417
         LA    R13,RTM2SFSA(,R8)                                   0417
*                             CALL RT2MODE;/* PROCESS DATA PASSED BT
*                                      RTM1                          */
         BAL   @14,RT2MODE                                         0418
*                             RESPECIFY                            0419
*                               R13 UNRESTRICTED;                  0419
*                             IF RTM2ENRB=ON&RTM2REED=OFF THEN/* IF
*                                      PROCESSING EED Q CAUSED     0420
*                                      RTM2ENRB TO BE SET AND NO   0420
*                                      REGISTERS WERE PASSED OR IF IT
*                                      WERE SET BECAUSE NO EED Q THEN
*                                      REGISTERS AND PSW AT TIME OF
*                                      ERROR MUST BE PLACED IN RTM2WA*/
         TM    RTM2ENRB(R8),B'00000100'                            0420
         BNO   @RF00420                                            0420
         TM    RTM2REED(R8),B'00001000'                            0420
         BNZ   @RF00420                                            0420
*                               DO;                                0421
*                                 RTM2EREG=RBGRSAVE;/* REGS AT TIME
*                                      OF ERROR ARE IN RTM2 SVRB     */
         MVC   RTM2EREG(64,R8),RBGRSAVE(R5)                        0422
*                                 RTM2APSW=RBRTOPSW;/* PSW AT TIME OF
*                                      ERROR IS IN THE PRECEDING RB  */
         L     @12,RBLINKB-1(,R5)                                  0423
         AL    @12,@CF03212                                        0423
         MVC   RTM2APSW(16,R8),RBRTOPSW-40(@12)                    0423
*                                 RESPECIFY                        0424
*                                   RBPREFIX;/* RESTORE DEFAULT    0424
*                                      BASING                        */
*                               END;                               0425
*                             ELSE                                 0426
*                               ;   /* REGISTERS WERE PASSED IN EED  */
*                                                                  0426
@RF00420 DS    0H                                                  0427
*                             /***************************************/
*                             /*                                     */
*                             /* DETERMINE AND SET ERROR TYPE FIELDS */
*                             /*                                     */
*                             /***************************************/
*                                                                  0427
*                             IF ESAERTYP=RT1WPCFL THEN/* IF RTM1  0427
*                                      ENTERED FROM PCFLIH SET PGM CK
*                                      FLAG                          */
         CLI   ESAERTYP(R7),1                                      0427
         BNE   @RF00427                                            0427
*                               RTM2PCHK=ON;                       0428
         OI    RTM2PCHK(R8),B'01000000'                            0428
*                             ELSE  /* TEST FOR NEXT TYPE            */
*                               IF ESAERTYP=RT1WMCHR THEN/* IF RTM1
*                                      ENTERED FOR MACHINE CHECK SET
*                                      MACHINE CHECK FLAG            */
         B     @RC00427                                            0429
@RF00427 CLI   ESAERTYP(R7),5                                      0429
         BNE   @RF00429                                            0429
*                                 RTM2MCHK=ON;                     0430
         OI    RTM2MCHK(R8),B'10000000'                            0430
*                               ELSE/* TEST FOR NEXT TYPE            */
*                                 IF ESAERTYP=RT1WREST THEN/* IF RTM1
*                                      ENTERED VIA RESTART KEY SET 0431
*                                      RESTART ENTRY FLAG            */
         B     @RC00429                                            0431
@RF00429 CLI   ESAERTYP(R7),2                                      0431
         BNE   @RF00431                                            0431
*                                   RTM2RKEY=ON;                   0432
         OI    RTM2RKEY(R8),B'00100000'                            0432
*                                 ELSE                             0433
*                                   IF ESAERTYP=RT1WSVC THEN/* RTM1
*                                      ENTERED FOR SVC ERROR         */
         B     @RC00431                                            0433
@RF00431 CLI   ESAERTYP(R7),3                                      0433
         BNE   @RF00433                                            0433
*                                    RTM2SVCE=ON;/* SET SVC ERROR  0434
*                                      FLAG                          */
         OI    RTM2SVCE(R8),B'00000100'                            0434
*                                   ELSE                           0435
*                                    IF ESAERTYP=RT1WPGIO THEN/* RTM1
*                                      ENTERED FOR PAGE I/O ERROR    */
         B     @RC00433                                            0435
@RF00433 CLI   ESAERTYP(R7),10                                     0435
         BNE   @RF00435                                            0435
*                                     RTM2PGIO=ON;/* SET PAGE I/O  0436
*                                      ERROR FLAG                    */
         OI    RTM2PGIO(R8),B'00000001'                            0436
*                                    ELSE                          0437
*                                     RTM2ABTM=ON;/* SET ABTERM ENTRY
*                                      FLAG                          */
         B     @RC00435                                            0437
@RF00435 OI    RTM2ABTM(R8),B'00001000'                            0437
*                             RMPLASCB=RTM2ASC;/* PLACE INPUT ASCB 0438
*                                      ADDRESS IN RESOURCE MGR PARM
*                                      LIST                          */
@RC00435 DS    0H                                                  0438
@RC00433 DS    0H                                                  0438
@RC00431 DS    0H                                                  0438
@RC00429 DS    0H                                                  0438
@RC00427 LA    @12,712                                             0438
         ALR   @12,R8                                              0438
         L     @09,RTM2ASC(,R8)                                    0438
         ST    @09,RMPLASCB(,@12)                                  0438
*                             RMPLASID=RTM2ASC->ASCBASID;/* PLACE  0439
*                                      ASID IN RMPL                  */
         MVC   RMPLASID(2,@12),ASCBASID(@09)                       0439
*                             RMPLTYPE=ON;/* INDICATE ABNORMAL     0440
*                                      TERMINATION                   */
*                             RMPLTERM=OFF;/* INDICATE TASK MODE     */
         OI    RMPLTYPE(@12),B'10000000'                           0441
         NI    RMPLTERM(@12),B'10111111'                           0441
*                             RTM2CCF=RTM2CCF|ESACCF;/* COPY FLAGS 0442
*                                      FROM ESA                      */
         OC    RTM2CCF(1,R8),ESACCF(R7)                            0442
*                             RTM2CCF=RTM2CCF&RTM1FLGS;/* ZERO FLAGS
*                                      USED ONLY BY RTM1             */
         NI    RTM2CCF(R8),X'C0'                                   0443
*                             RTM2CC=ESACC;/* PLACE COMPLETION CODE
*                                      IN RTM2WA                     */
         MVC   RTM2CC(3,R8),ESACC(R7)                              0444
*                             IF ESAEEDQ>EEDNULL/* WERE EEDS PASSED?
*                                                            @G33NPHE*/
*                                 &ESAEEDQ->EEDNODMP=ON/* AND IF SO
*                                      WAS SLIP DUMP SUPPRESSION   0445
*                                      INDICATED?            @G33NPHE*/
*                               THEN/* YES                   @G33NPHE*/
         L     @12,ESAEEDQ(,R7)                                    0445
         C     @12,@CF00067                                        0445
         BNH   @RF00445                                            0445
         TM    EEDNODMP(@12),B'01000000'                           0445
         BNO   @RF00445                                            0445
*                               RTM2NODP=ON;/* SO INDICATE IT IN THE
*                                      RTM2 WORK AREA TOO    @G33NPHE*/
         OI    RTM2NODP(R8),B'00010000'                            0446
*                             RFY                                  0447
*                               R13 RSTD;/*                  @G17SP2I*/
@RF00445 DS    0H                                                  0448
*                             R13=ADDR(RTM2SFSA);/* SET UP A SAVEAREA
*                                      FOR THE CALL          @G17SP2I*/
         LA    R13,RTM2SFSA(,R8)                                   0448
*                             CALL SLIP;/*                   @G17SP2I*/
         BAL   @14,SLIP                                            0449
*                             RFY                                  0450
*                               R13 UNRSTD;/*                @G17SP2I*/
*                           END;    /* END SEGMENT RT2INRT1          */
*                         ELSE      /* ENTRY VIA SVC 13 DIRECTLY     */
*                           IF ESAVEOM=ON THEN/* ENTRY IS FOR MEMORY
*                                      TERMINATION PURGES            */
*                                                                  0452
         B     @RC00409                                            0452
@RF00409 TM    ESAVEOM(R7),B'00000010'                             0452
         BNO   @RF00452                                            0452
*                             /***************************************/
*                             /*                                     */
*                             /* SEGMENT RT2INMT INITIALIZES THE     */
*                             /* RTM2WA IF ENTRY IS FOR MEMORY       */
*                             /* TERMINATION PURGES. THE TARGET ASCB */
*                             /* AND ASID ARE SET IN THE RESOURCE    */
*                             /* MANAGER PARAMETER LIST PORTION OF   */
*                             /* THE RTM2WA AND FLAGS ARE SET TO     */
*                             /* INDICATE MEMORY TERMINATION PURGE.  */
*                             /*                             @ZA16412*/
*                             /*                                     */
*                             /***************************************/
*                                                                  0453
*                             DO;   /* BEGIN SEGMENT RT2INMT         */
*                               RTM2CC=ESACC1;/* PUT INPUT COMPLETION
*                                      CODE IN RTM2WA                */
         MVC   RTM2CC(3,R8),ESACC1(R7)                             0454
*/********************************************************************/
*/* LINES 359170-360227 REMOVED FOR APAR                     @ZA16412*/
*/********************************************************************/
*                                                                  0455
*                               /*************************************/
*                               /*                                   */
*                               /* INITIALIZE WORK AREA FOR MEMORY   */
*                               /* TERMINATION PURGES                */
*                               /*                                   */
*                               /*************************************/
*                                                                  0455
*                               RMPLASCB=ESAR0;/* PUT INPUT ASCB   0455
*                                      ADDRESS (ADDRESS OF ASCB TO BE
*                                      PURGED) IN RMPL               */
         LA    @12,712                                             0455
         ALR   @12,R8                                              0455
         L     @09,ESAR0(,R7)                                      0455
         ST    @09,RMPLASCB(,@12)                                  0455
*                               RMPLASID=ESAR0->ASCBASID;/* SET ASID
*                                      OF TERMINATING MEMORY IN RMPL */
         MVC   RMPLASID(2,@12),ASCBASID(@09)                       0456
*                               RMPLTCBA=0;/* ZERO TCB ADDRESS IN  0457
*                                      RMPL                          */
         SLR   @02,@02                                             0457
         ST    @02,RMPLTCBA(,@12)                                  0457
*                               RMPLTERM=ON;/* INDICATE MEMORY     0458
*                                      TERMINATION IN RMPL           */
         OI    RMPLTERM(@12),B'01000000'                           0458
*                               IF ESAR0->ASCBABNT=OFF THEN/* IF   0459
*                                      ABNORMAL FLAG OFF IN ASCB   0459
*                                      INDICATE NORMAL MEMORY TERM   */
         TM    ASCBABNT(@09),B'00001000'                           0459
         BNZ   @RF00459                                            0459
*                                 RMPLTYPE=OFF;                    0460
         NI    RMPLTYPE(@12),B'01111111'                           0460
*                               ELSE/* OTHERWISE INDICATE ABNORMAL 0461
*                                      MEMORY TERMINATION            */
*                                 RMPLTYPE=ON;                     0461
*                                                                  0461
         B     @RC00459                                            0461
@RF00459 OI    RMPLTYPE+712(R8),B'10000000'                        0461
*                               /*************************************/
*                               /*                                   */
*                               /* PERMIT ASYNCHRONOUS EVENTS        */
*                               /*                                   */
*                               /*************************************/
*                                                                  0462
*                               TCBFX=OFF;/* PERMIT SCHEDULING OF  0462
*                                      ASYNCH EXITS                  */
@RC00459 NI    TCBFX(R4),B'11111110'                               0462
*                               TCBFPRAP=OFF;/* PERMIT ASYNCH ABENDS
*                                      TO PERCOLATE                  */
         NI    TCBFPRAP(R4),B'11101111'                            0463
*                               ESAVEOM=ON;/* INDICATE VALID END OF
*                                      MEMORY REQUEST        @YM02686*/
         OI    ESAVEOM(R7),B'00000010'                             0464
*                             END;  /* END SEGMENT RT2INMT           */
*                           ELSE    /* ENTRY IS FOR ABEND PROCESSING */
*                                                                  0466
*                             /***************************************/
*                             /*                                     */
*                             /* RT2INABD INITIALIZES THE RMPL AND   */
*                             /* SAVES DATA PASSED VIA THE ABEND     */
*                             /* MACRO IN THE RTM2 WORK AREA. IT     */
*                             /* INVOKES IEAVTSLP TO PERFORM SLIP    */
*                             /* PROCESSING IF REQUESTED.            */
*                             /*                                     */
*                             /***************************************/
*                                                                  0466
*                             DO;   /* START OF RT2INABD             */
*                                                                  0466
         B     @RC00452                                            0466
@RF00452 DS    0H                                                  0467
*                               /*************************************/
*                               /*                                   */
*                               /* INITIALIZE WORK AREA WITH DATA    */
*                               /* PASSED VIA THE ABEND MACRO FOR    */
*                               /* ABNORMAL TASK TERMINATION         */
*                               /*                                   */
*                               /*************************************/
*                                                                  0467
*                               RTM2CODE=ESAR1|RTM2CODE;/* COMPLETION
*                                      CODE WAS PASSED VIA REGISTER 1*/
         L     @12,ESAR1(,R7)                                      0467
         O     @12,RTM2CODE(,R8)                                   0467
         ST    @12,RTM2CODE(,R8)                                   0467
*                               RMPLASCB=RTM2ASC;/* ADDRESS OF ASCB
*                                      FOR TERMINATING TASK'S MEMORY */
         LA    @12,712                                             0468
         ALR   @12,R8                                              0468
         L     @09,RTM2ASC(,R8)                                    0468
         ST    @09,RMPLASCB(,@12)                                  0468
*                               RMPLASID=RTM2ASC->ASCBASID;/* ASID OF
*                                      TERMINATING TASK'S MEMORY     */
         MVC   RMPLASID(2,@12),ASCBASID(@09)                       0469
*                               RMPLTYPE=ON;/* INDICATE ABNORMAL   0470
*                                      TERMINATION                   */
*                               RMPLTERM=OFF;/* INDICATE TASK      0471
*                                      TERMINATING                   */
         OI    RMPLTYPE(@12),B'10000000'                           0471
         NI    RMPLTERM(@12),B'10111111'                           0471
*                               RTM2EPSW=RBLINKB->RBOPSW;/* SAVE PSW
*                                      AT TIME OF ERROR              */
         L     @12,RBLINKB-1(,R5)                                  0472
         LA    @12,0(,@12)                                         0472
         MVC   RTM2EPSW(8,R8),RBOPSW(@12)                          0472
*                               RESPECIFY                          0473
*                                 RBPREFIX BASED(RBLINKB-LENGTH(   0473
*                                     RBPREFIX));/* LOCATE ERROR DATA
*                                      IN ABENDING RB                */
*                               RTM2ILC1=RBINLNTH;/* SAVE ERROR ILC  */
         SL    @12,@CF00482                                        0474
         MVC   RTM2ILC1(1,R8),RBINLNTH(@12)                        0474
*                               RTM2INC1=RBINTCOD;/* SAVE INTERRUPT
*                                      CODE                          */
         LH    @12,RBINTCOD(,@12)                                  0475
         N     @12,@CF03215                                        0475
         STH   @12,RTM2INC1(,R8)                                   0475
*                               RESPECIFY                          0476
*                                 RBPREFIX;/* RESTORE DEFAULT BASING */
*                               RTM2EREG=RBGRSAVE;/* COPY REGISTERS
*                                      AT TIME OF ERROR              */
*                                                                  0477
         MVC   RTM2EREG(64,R8),RBGRSAVE(R5)                        0477
*                               /*************************************/
*                               /*                                   */
*                               /* INDICATE ENABLED ROUTINE RUNNING  */
*                               /* IN TASK MODE FAILED               */
*                               /*                                   */
*                               /*************************************/
*                                                                  0478
*                               RTM2SVCD=ON;/* ENTRY WAS FROM SVC 13
*                                      DIRECTLY                      */
         OI    RTM2SVCD(R8),B'00010000'                            0478
*                               RTM2ENRB=ON;/* ENABLED RB WAS IN   0479
*                                      CONTROL                       */
         OI    RTM2ENRB(R8),B'00000100'                            0479
*                               ADDR(ESAMODE)->MODETCB=ON;/* TASK  0480
*                                      MODE ROUTINE FAILED, USED BY
*                                      SLIP                          */
*                                                                  0480
         OI    MODETCB+43(R7),B'00000001'                          0480
*                               /*************************************/
*                               /*                                   */
*                               /* STORE COMPLETION CODE IN TCB      */
*                               /*                                   */
*                               /*************************************/
*                                                                  0481
*                               TCBCMPC=RTM2CC;/* SAVE CODE IN TCB   */
         MVC   TCBCMPC(3,R4),RTM2CC(R8)                            0481
*                               TCBCMPF=RTM2CCF&RTM1FLGS;/* SAVE   0482
*                                      FLAGS IN TCB                  */
         MVC   TCBCMPF(1,R4),RTM2CCF(R8)                           0482
         NI    TCBCMPF(R4),X'C0'                                   0482
*                               RFY                                0483
*                                 R13 RSTD;/*                @G17SP2I*/
*                               R13=ADDR(RTM2SFSA);/* SET UP A     0484
*                                      SAVEAREA FOR THE CALL @G17SP2I*/
         LA    R13,RTM2SFSA(,R8)                                   0484
*                               CALL SLIP;/*                 @G17SP2I*/
         BAL   @14,SLIP                                            0485
*                               RFY                                0486
*                                 R13 UNRSTD;/*              @G17SP2I*/
*                             END;  /* END OF RT2INABD               */
*                       ELSE        /* ENTRY WAS FOR PURGE ONLY    0488
*                                                            @ZA19202*/
*                                                                  0488
*                         /*******************************************/
*                         /*                                         */
*                         /* FOR TASKS BEING PURGED (DETACHED BECAUSE*/
*                         /* THE MOTHER TASK IS BEING ABNORMALLY     */
*                         /* TERMINATED), PROPAGATE THE RTM2NODP FROM*/
*                         /* THE MOTHER TASK SINCE SLIP IS NOT       */
*                         /* ENTERED.                        @ZA19202*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  0488
*                         IF TCBOTC->TCBRTWA->RTM2NODP=ON/* IS THE 0488
*                                      NODUMP FLAG ON IN THE CURRENT
*                                      RTM2WA OF THE ORIGINATING   0488
*                                      (MOTHER) TASK?        @ZA19202*/
*                           THEN    /* YES                   @ZA19202*/
         B     @RC00408                                            0488
@RF00408 L     @12,TCBOTC(,R4)                                     0488
         L     @12,TCBRTWA(,@12)                                   0488
         TM    RTM2NODP(@12),B'00010000'                           0488
         BNO   @RF00488                                            0488
*                           RTM2NODP=ON;/* THEN SET THAT FLAG ON IN
*                                      THE CURRENT RTM2WA OF THE TASK
*                                      NOW BEING PURGED      @ZA19202*/
         OI    RTM2NODP(R8),B'00010000'                            0489
*                     END;          /* END INIT FOR MEMTERM AND    0490
*                                      ABNORMAL END OF TASK          */
@RF00488 DS    0H                                                  0490
@RC00408 DS    0H                                                  0491
*                 END;                                             0491
*                                                                  0491
@RC00316 DS    0H                                                  0492
*               /*****************************************************/
*               /*                                                   */
*               /* SEGMENT GETERRID PUTS THE ERRORID INTO RTM2ERID IN*/
*               /* RTM2WA. GETERRID DETERMINES IF A PREVIOUS ERRORID */
*               /* SHOULD BE PROPAGATED OR A NEW ERRORID GENERATED.  */
*               /* IF EED'S WERE PASSED TO RTM2, THE EEDCHAIN IS     */
*               /* SEARCHED FOR AN ERRORID. IF FOUND, THE ERRORID IS */
*               /* MOVED TO THE RTM2 WORKAREA AND RTM2ERFL IS SET ON */
*               /* TO INDICATE AN ERRORID. OTHERWISE,IF RTM2PREV     */
*               /* CONTAINS AN ADDRESS, THEN THE PREVIOUS RTM2WA IS  */
*               /* CHECKED. IF AN ERRORID IS PRESENT, THE ASID, CPUID*/
*               /* AND SEQUENCE NUMBER ARE MOVED TO THE CURRENT      */
*               /* WORKAREA, AND RTM2ERFL IS SET ON. THE CURRENT TIME*/
*               /* IS GOTTEN FROM THE TOD CLOCK. IF NO ERRORID COULD */
*               /* BE PROPAGATED, A NEW ERRORID IS GENERATED.        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0492
*               DO;                 /* BEGIN ERRORID PROCESS @G17EP5W*/
@RC00256 DS    0H                                                  0493
*                 RFY                                              0493
*                   R10 RSTD;       /* RESTRICT REG FOR PTR  @G17EP5W*/
*                 R10=ZERO;         /* ZERO ITS VALUE SO THAT A VALID
*                                      ADDR. CAN BE DETERMINED     0494
*                                                            @G17EP5W*/
         SLR   R10,R10                                             0494
*                 IF ESAEEDQ>EEDNULL THEN/* IF EEDS WERE PASSED    0495
*                                                            @G17EP5W*/
         L     @12,ESAEEDQ(,R7)                                    0495
         C     @12,@CF00067                                        0495
         BNH   @RF00495                                            0495
*                   DO;             /* CHECK FOR ERRORID     @G17EP5W*/
*                     R10=ESAEEDQ;  /* ADDR. OF 1ST EED      @G17EP5W*/
         LR    R10,@12                                             0497
*                     DO WHILE(R10>EEDNULL);/* PROCESS EED CHAIN   0498
*                                      UNTIL END OR ERRORID FOUND  0498
*                                                            @G17EP5W*/
         B     @DE00498                                            0498
@DL00498 DS    0H                                                  0499
*                       IF R10->EEDERFL=ON THEN/* IF ERRORID IN EED
*                                                            @G17EP5W*/
         TM    EEDERFL(R10),B'10000000'                            0499
         BNO   @RF00499                                            0499
*                         DO;       /* THEN                  @G17EP5W*/
*                           RTM2ERID=R10->EEDERRID;/* MOVE ERRORID IN
*                                      EED TO RTM2WA         @G17EP5W*/
         MVC   RTM2ERID(10,R8),EEDERRID(R10)                       0501
*                           RTM2ERFL=ON;/* SET ERRORID FLAG  @G17EP5W*/
         OI    RTM2ERFL(R8),B'00000001'                            0502
*                           R10=ZERO;/* AND STOP THE SEARCH  @G17EP5W*/
         SLR   R10,R10                                             0503
*                         END;      /* END MOVE ERRORID      @G17EP5W*/
*                       ELSE        /* OTHERWISE,            @G17EP5W*/
*                         R10=R10->EEDFWRDP;/* GET NEXT EED @      0505
*                                                            @G17EP5W*/
         B     @RC00499                                            0505
@RF00499 L     R10,EEDFWRDP(,R10)                                  0505
*                     END;          /* END EED SEARCH        @G17EP5W*/
@RC00499 DS    0H                                                  0506
@DE00498 C     R10,@CF00067                                        0506
         BH    @DL00498                                            0506
*                     R10=ZERO;     /* RESET PTR. TO ZERO    @G17EP5W*/
         SLR   R10,R10                                             0507
*                   END;            /* END EED PROCESSING    @G17EP5W*/
*                 IF RTM2ERFL=OFF THEN/* IF NO ERRORID IN WA @G17EP5W*/
@RF00495 TM    RTM2ERFL(R8),B'00000001'                            0509
         BNZ   @RF00509                                            0509
*                   DO;             /* CONTINUE PROCESSING   @G17EP5W*/
*                     R10=RTM2PREV; /* SET PTR TO ANY PREVIOUS RTM2WA
*                                      THAT MIGHT HAVE BEEM OBTAINED
*                                      SO THAT IT CAN BE CHECKED FOR
*                                      AN ERRORID IF RECURSION     0511
*                                                            @G17EP5W*/
         L     R10,RTM2PREV(,R8)                                   0511
*                     DO WHILE((R10^=ZERO)&/* PROCESS UNTIL NO MORE
*                                      WA                            */
*                           (R10->RTM2ERFL=OFF));/* OR ERRORID FOUND
*                                                            @G17EP5W*/
         B     @DE00512                                            0512
@DL00512 DS    0H                                                  0513
*                       R10=R10->RTM2PREV;/* OF NEXT WORKAREA      0513
*                                                            @G17EP5W*/
         L     R10,RTM2PREV(,R10)                                  0513
*                     END;          /* AT END OF THIS LOOP THE PTR 0514
*                                      REGISTER WILL EITHER CONTAIN
*                                      ZERO INDICATING THE ERRORID 0514
*                                      SHOULD NOT BE PROPAGATED FROM
*                                      A PREVIOUS WORKAREA OR IT WILL
*                                      CONTAIN THE ADDR OF THE WORK
*                                      AREA WHICH CONTAINS AN ERRORID
*                                                            @G17EP5W*/
@DE00512 LTR   R10,R10                                             0514
         BZ    @DC00512                                            0514
         TM    RTM2ERFL(R10),B'00000001'                           0514
         BZ    @DL00512                                            0514
@DC00512 DS    0H                                                  0515
*                     IF(((RMPLTYPE=ON)&/* IF THIS IS ABNORMAL     0515
*                                                            @G17EP5W*/
*                         (RMPLTERM=OFF))|/* TERMINATION OR  @G17EP5W*/
*                         (R10^=ZERO)) THEN/* ERRORID IN PREVIOUS  0515
*                                      WORKAREA              @G17EP5W*/
         TM    RMPLTYPE+712(R8),B'10000000'                        0515
         BNO   @GL00014                                            0515
         TM    RMPLTERM+712(R8),B'01000000'                        0515
         BZ    @RT00515                                            0515
@GL00014 LTR   R10,R10                                             0515
         BZ    @RF00515                                            0515
@RT00515 DS    0H                                                  0516
*                       DO;         /* THEN GET ERRORID      @G17EP5W*/
*                         RFY                                      0517
*                          (R0,                                    0517
*                           R1,                                    0517
*                           R2) RSTD;/* RESTRICTS REGS       @G17EP5W*/
*                         R2=ADDR(RTM2ERID);/* SPECIFY ADDR FOR TOD
*                                      VALUE                 @G17EP5W*/
         LA    R2,RTM2ERID(,R8)                                    0518
*                         GEN REFS(CVTTZ);                         0519
*                                    /*                     @G17EP5W*/
               CONTIME TIMER=(2)     /* GET TIMESTAMP       @G17EP5W*/
*                         RTM2ERTM=R1;/* PUT IN TIME STAMP   @G17EP5W*/
         STCM  R1,15,RTM2ERTM(R8)                                  0520
*                         IF R10^=ZERO THEN/* IF ERRORID PROPAGATED
*                                                            @G17EP5W*/
         LTR   R10,R10                                             0521
         BZ    @RF00521                                            0521
*                           RTM2ERID(1:6)=R10->/* MOVE ERRORID TO  0522
*                                                            @G17EP5W*/
*                               RTM2ERID(1:6);/* CURRENT RTM2WA    0522
*                                                            @G17EP5W*/
         MVC   RTM2ERID(6,R8),RTM2ERID(R10)                        0522
*                         ELSE      /* OTHERWISE GENERATE    @G17EP5W*/
*                           DO;     /* NEW ERRORID           @G17EP5W*/
         B     @RC00521                                            0523
@RF00521 DS    0H                                                  0524
*                             RTM2CPUI=ZERO;/* NO VALID LOG. CPUID 0524
*                                                            @G17EP5W*/
         SLR   @12,@12                                             0524
         STH   @12,RTM2CPUI(,R8)                                   0524
*                             IF RTM2FMID^=NOASID THEN/* IF        0525
*                                      X-MEM.ASID            @G17EP5W*/
         CLC   RTM2FMID(2,R8),@CB00072                             0525
         BE    @RF00525                                            0525
*                               RTM2ERAS=RTM2FMID;/* VALID, USE IT 0526
*                                                            @G17EP5W*/
         MVC   RTM2ERAS(2,R8),RTM2FMID(R8)                         0526
*                             ELSE  /* OTHERWISE USE LOGREC  @G17EP5W*/
*                               RTM2ERAS=PSAAOLD->ASCBASID;/* CUR. 0527
*                                      ASID                  @G17EP5W*/
         B     @RC00525                                            0527
@RF00525 L     @12,PSAAOLD                                         0527
         MVC   RTM2ERAS(2,R8),ASCBASID(@12)                        0527
*                             RFY                                  0528
*                               R11 RSTD;/* REG FOR SEQ # ADDR     0528
*                                                            @G17EP5W*/
@RC00525 DS    0H                                                  0529
*                             R11=ADDR(RTM2SEQ#);/* NEW SEQ #      0529
*                                                            @G17EP5W*/
         LA    R11,RTM2SEQ#(,R8)                                   0529
*                             GEN;                                 0530
*                                    /*GET NEW SEQUENCE NBR @G17EP5W*/
                    GETSEQ (11)      /*AND PUT IN WA        @G17EP5W*/
*                             RFY                                  0531
*                              (R11) UNRSTD;/* FREE UP REG   @G17EP5W*/
*                           END;    /* END GEN.NEW ERRRORID  @G17EP5W*/
*                         RTM2ERFL=ON;/* SET ERRORID FLAG    @G17EP5W*/
@RC00521 OI    RTM2ERFL(R8),B'00000001'                            0533
*                         RFY                                      0534
*                          (R0,                                    0534
*                           R1,                                    0534
*                           R2) UNRSTD;/* FREE REGS          @G17EP5W*/
*                       END;        /* END ABTERM/PROPAGATE  @G17EP5W*/
*                   END;            /* END CONTINE ERRORID   @G17EP5W*/
@RF00515 DS    0H                                                  0537
*                 RFY                                              0537
*                   R10 UNRSTD;     /* FREE UP REG           @G17EP5W*/
@RF00509 DS    0H                                                  0538
*               END;                /* END ERRORID SEG       @G17EP5W*/
*               IF ESAEEDQ>EEDNULL THEN/* EEDS WERE PASSED AND     0539
*                                                            @YM06385*/
         L     @12,ESAEEDQ(,R7)                                    0539
         C     @12,@CF00067                                        0539
         BNH   @RF00539                                            0539
*                 DO;               /* MUST BE FREED         @YM06385*/
*                                                                  0540
*                   /*************************************************/
*                   /*                                               */
*                   /* RELEASE EED QUICK CELLS IF PASSED             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0541
*                   RESPECIFY                                      0541
*                    (R0,                                          0541
*                     R1,                                          0541
*                     R9,                                          0541
*                     R13,                                         0541
*                     R14,                                         0541
*                     R15) RESTRICTED;/* RESTRICT REGISTERS USED BY
*                                      FREECELL                      */
*                   RESPECIFY                                      0542
*                     EED BASED(R9);                               0542
*                   R9=ESAEEDQ;     /* PICK UP QUICKCELL ADDRESS     */
         LR    R9,@12                                              0543
*                   R13=ADDR(RTM2RMSA);/* ESTABLISH SAVE AREA FOR  0544
*                                      FREECELL                      */
         LA    R13,RTM2RMSA(,R8)                                   0544
*                   DO WHILE(R9^=NOEED&R9^=EEDNULL);/* LOOP TO FREE
*                                      ALL CELLS                     */
         B     @DE00545                                            0545
@DL00545 DS    0H                                                  0546
*                     R1=R9;        /* PLACE CELL ADDRESS IN R1      */
         LR    R1,R9                                               0546
*                     R0=RTMQCID;   /* PLACE CELL ID IN R0           */
         L     R0,@CF00078                                         0547
*                     R9=EEDFWRDP;  /* UPDATE EEDPTR TO NEXT EED     */
         L     R9,EEDFWRDP(,R9)                                    0548
*                     GENERATE REFS(R0,R1,R13,CVTFRECL,CVTMAP) SETS(R14
*                         ,R15);                                   0549
        FREECELL CPID=(0),CELL=(1),BRANCH=YES,                         *
                 SAVE=YES,RELATED=(IEAVTRTM,                           *
                 IEAVTRTH)
*                     IF R15^=0 THEN/* FREECELL UNSUCCESSFUL         */
         LTR   R15,R15                                             0550
         BZ    @RF00550                                            0550
*                       R9=EEDNULL; /* CUT QUICKCELL QUEUE           */
         LA    R9,1                                                0551
*                     ELSE                                         0552
*                       ;           /* FREECELL SUCCESSFUL           */
@RF00550 DS    0H                                                  0553
*                   END;            /* END OF EED LOOP               */
@DE00545 LTR   R9,R9                                               0553
         BZ    @DC00545                                            0553
         C     R9,@CF00067                                         0553
         BNE   @DL00545                                            0553
@DC00545 DS    0H                                                  0554
*                   RESPECIFY                                      0554
*                    (R0,                                          0554
*                     R1,                                          0554
*                     R9,                                          0554
*                     R13,                                         0554
*                     R14,                                         0554
*                     R15) UNRESTRICTED;/* RELEASE REGS USED BY    0554
*                                      QUICKCELL                     */
*                 END;              /* END PROCESSING OF EEDS        */
*             END;                  /* END SEGMENT RT2INWA           */
@RF00539 DS    0H                                                  0557
*             ESAINREC=OFF;         /* RESET RECURSION INDICATOR     */
         NI    ESAINREC(R7),B'11011111'                            0557
*             IF ESAFERR=OFF THEN   /* THE WORK AREA IS INITIALIZED  */
         TM    ESAFERR(R7),B'00001000'                             0558
         BNZ   @RF00558                                            0558
*               IF RMPLTYPE=ON&RMPLTERM=OFF THEN/* ABNORMAL EOT      */
         TM    RMPLTYPE+712(R8),B'10000000'                        0559
         BNO   @RF00559                                            0559
         TM    RMPLTERM+712(R8),B'01000000'                        0559
         BNZ   @RF00559                                            0559
*                 DO;                                              0560
*                                                                  0560
*/*   SAVE A COPY OF TRACE TABLE FOR DUMP PROCESS           @G33SPHW */
*                                                                  0561
*                   IF RTM2TREC^=ON THEN/* RECURSIVE ERROR IN TRACE
*                                      COPYING PROCESS       @ZM45190*/
         TM    RTM2TREC(R8),B'00010000'                            0561
         BO    @RF00561                                            0561
*                     DO;           /* NO TRACE RECURSION PROCESS  0562
*                                      TRACE COPYING         @ZM45190*/
*                       RTM2TREC=ON;/* INDICATE TRACE COPYING IN   0563
*                                      PROCESS IN CASE OF ERROR WILL
*                                      PREVENT RECURSION     @ZM45190*/
         OI    RTM2TREC(R8),B'00010000'                            0563
*                       RFY                                        0564
*                        (TTPTR,                                   0564
*                         SIZE) RSTD;                              0564
*                       IF FLCTRACE=0|/* IF TRACE NOT AVAILABLE OR 0565
*                                                            @G33SPHW*/
*                           CVTTRACE^='07FA'X/* TRACE TABLE IS NOT 0565
*                                      ACTIVE                @G33SPHW*/
*                         THEN                                     0565
         L     @12,FLCTRACE                                        0565
         LTR   @12,@12                                             0565
         BZ    @RT00565                                            0565
         L     @12,CVTPTR                                          0565
         CLC   CVTTRACE(2,@12),@CB03152                            0565
         BNE   @RT00565                                            0565
*                         ;         /* THEN BYPASS TRACE SAVING    0566
*                                                            @G33SPHW*/
*                       ELSE        /* YES...TRACE ACTIVE AND      0567
*                                                            @G33SPHW*/
*                         DO;       /* AVAILABLE SAVE COPY   @G33SPHW*/
*                           TTPTR=FLCTRACE;/* TRACE START ADDRESS  0568
*                                      FROM CVT              @G33SPHW*/
         L     TTPTR,FLCTRACE                                      0568
*                           SIZE=LASTENT-FIRSTENT;/* CALCULATE SIZE
*                                      OF TRACE TBL          @G33SPHW*/
         L     SIZE,LASTENT(,TTPTR)                                0569
         SL    SIZE,FIRSTENT(,TTPTR)                               0569
*                           IF RTM2TRTB=0 THEN/* STORAGE AVAILABLE 0570
*                                                            @G33SPHW*/
         L     @12,RTM2TRTB(,R8)                                   0570
         LTR   @12,@12                                             0570
         BNZ   @RF00570                                            0570
*                             DO;   /* NO...                 @G33SPHW*/
*                               RFY                                0572
*                                (R1,                              0572
*                                 R15) RSTD;/*               @G33SPHW*/
*                               GEN SETS(R1,R15)                   0573
*                                   (GETMAIN RC,LV=(SIZE),SP=230); 0573
         GETMAIN RC,LV=(SIZE),SP=230
*                               IF R15=0 THEN/* STORAGE OBTAINED...
*                                                            @G33SPHW*/
         SLR   @14,@14                                             0574
         CR    R15,@14                                             0574
         BNE   @RF00574                                            0574
*                                 DO;/* YES...               @G33SPHW*/
*                                   RFY                            0576
*                                     R10 RSTD;/*            @ZM45190*/
*                                   RTM2TRTB=R1;/* PUT ADDRESS IN  0577
*                                      RTM2WA                @G33SPHW*/
         ST    R1,RTM2TRTB(,R8)                                    0577
*                                   RTM2TRLN=SIZE;/* PUT SIZE OF   0578
*                                      TRACE IN RTM2WA       @G33SPHW*/
         ST    SIZE,RTM2TRLN(,R8)                                  0578
*                                   RTM2TECB=0;/* CLEAR ECB  @ZM45190*/
         ST    @14,RTM2TECB(,R8)                                   0579
*                                   R0=ADDR(RTM2TECB);/* ADDRESS OF
*                                      ECB                   @ZM45190*/
         LA    R0,RTM2TECB(,R8)                                    0580
*                                   R10=RTM2TRTB+RTM2TRLN;/* END OF
*                                      TRACE                 @ZM45190*/
         L     @14,RTM2TRTB(,R8)                                   0581
         L     @12,RTM2TRLN(,R8)                                   0581
         ALR   @14,@12                                             0581
         LR    R10,@14                                             0581
*                                   GEN;                           0582
               PGFIX R,LONG=N,RELEASE=N,A=(R1),EA=(R10),ECB=(R0)
*                                   R1=ADDR(RTM2TECB);/* ADDRESS OF
*                                      ECB                   @ZM45190*/
         LA    R1,RTM2TECB(,R8)                                    0583
*                                   GEN(WAIT 1,ECB=(R1));/* WAIT ON
*                                      PGFIX                 @ZM45190*/
         WAIT 1,ECB=(R1)
*                                   RTM2TECB=0;/* CLEAR ECB  @ZM45190*/
         SLR   @14,@14                                             0585
         ST    @14,RTM2TECB(,R8)                                   0585
*                                   RFY                            0586
*                                     R10 UNRSTD;/*          @ZM45190*/
*                                 END;/* END GETMAIN OK      @G33SPHW*/
*                               RFY                                0588
*                                (R1,                              0588
*                                 R15) UNRSTD;/*             @G33SPHW*/
@RF00574 DS    0H                                                  0589
*                             END;                                 0589
*                           IF RTM2TRTB^=0 THEN/* STORAGE AVAILABLE
*                                      FOR TABLE             @G33SPHW*/
@RF00570 L     @12,RTM2TRTB(,R8)                                   0590
         LTR   @12,@12                                             0590
         BZ    @RF00590                                            0590
*                             DO;   /* YES... SAVE TRACE COPY      0591
*                                                            @G33SPHW*/
*                               RTM2TRFS=RTM2TRTB;/* FIRST ENTRY IN
*                                      TRACE TBL             @G33SPHW*/
*                                                                  0592
         ST    @12,RTM2TRFS(,R8)                                   0592
*                               /*************************************/
*                               /*                                   */
*                               /* THE ADDRESS OF THE LAST ENTRY IN  */
*                               /* TRACE TABLE BUFFER IS THE SIZE OF */
*                               /* THE TABLE PLUS THE INITIAL ADDRESS*/
*                               /* MINUS 32.                 @G33SPHW*/
*                               /*                                   */
*                               /*************************************/
*                                                                  0593
*                               RTM2TRLS=RTM2TRLN+RTM2TRFS-32;/* LAST
*                                      ENTRY                 @ZM45190*/
*                                                                  0593
         L     @09,RTM2TRLN(,R8)                                   0593
         LR    @01,@09                                             0593
         ALR   @01,@12                                             0593
         SL    @01,@CF00055                                        0593
         ST    @01,RTM2TRLS(,R8)                                   0593
*                               /*************************************/
*                               /*                                   */
*                               /* THE LOCATION OF THE CURRENT ENTRY */
*                               /* IN THE TRACE TABLE BUFFER IS      */
*                               /* LOCATED BY ADDING THE OFFSET TO   */
*                               /* THE CURRENT ENTRY IN THE REAL     */
*                               /* TABLE TO THE INITIAL ADDRESS OF   */
*                               /* THE BUFFER.               @G33SPHW*/
*                               /*                                   */
*                               /*************************************/
*                                                                  0594
*                               RFY                                0594
*                                (R1,                              0594
*                                 R10,                             0594
*                                 R11,                             0594
*                                 R14,                             0594
*                                 R15) RSTD;/*               @ZM45190*/
*                               RTM2TRCU=RTM2TRFS+CURRENT-FIRSTENT;/*
*                                      CURRENT ENTRY         @G33SPHW*/
         LR    @09,@12                                             0595
         AL    @09,CURRENT(,TTPTR)                                 0595
         L     @12,FIRSTENT(,TTPTR)                                0595
         SLR   @09,@12                                             0595
         ST    @09,RTM2TRCU(,R8)                                   0595
*                               R14=RTM2TRFS;/* INITIAL ADDRESS OF 0596
*                                      BUFFER                @G33SPHW*/
         L     @09,RTM2TRFS(,R8)                                   0596
         LR    R14,@09                                             0596
*                               R15=RTM2TRLN;/* SIZE OF BUFFER     0597
*                                                            @G33SPHW*/
         L     @09,RTM2TRLN(,R8)                                   0597
         LR    R15,@09                                             0597
*                               R10=FIRSTENT;/* INITIAL ADDR OF TRACE
*                                      TBL                   @G33SPHW*/
         LR    R10,@12                                             0598
*                               R11=RTM2TRLN;/* SIZE OF TRACE TABLE
*                                                            @G33SPHW*/
         LR    R11,@09                                             0599
*                               GEN(MVCL R14,R10);                 0600
         MVCL R14,R10
*                               RTM2TECB=0;/* CLEAR ECB      @ZM45190*/
         SLR   @12,@12                                             0601
         ST    @12,RTM2TECB(,R8)                                   0601
*                               R0=ADDR(RTM2TECB);/* ADDRESS OF ECB
*                                                            @ZM45190*/
         LA    R0,RTM2TECB(,R8)                                    0602
*                               R1=RTM2TRTB;/* START ADDRESS FOR   0603
*                                      PGFREE                @ZM45190*/
         L     @12,RTM2TRTB(,R8)                                   0603
         LR    R1,@12                                              0603
*                               R10=RTM2TRTB+RTM2TRLN;/* END OF TRACE
*                                                            @ZM45190*/
         AL    @12,RTM2TRLN(,R8)                                   0604
         LR    R10,@12                                             0604
*                               GEN;                               0605
               PGFREE R,RELEASE=N,A=(R1),EA=(R10),ECB=(R0)
*                               RFY                                0606
*                                (R1,                              0606
*                                 R10,                             0606
*                                 R11,                             0606
*                                 R14,                             0606
*                                 R15) UNRSTD;/*             @ZM45190*/
*                                                                  0606
*                               /*************************************/
*                               /*                                   */
*                               /* COPY TRACE TABLE TO BUFFER        */
*                               /*                           @G33SPHW*/
*                               /*                                   */
*                               /*************************************/
*                                                                  0607
*                             END;  /* END...STORAGE AVAILABE      0607
*                                                            @G33SPHW*/
*                         END;      /* END..ELSE SAVE TRACE  @G33SPHW*/
@RF00590 DS    0H                                                  0609
*                       RFY                                        0609
*                        (TTPTR,                                   0609
*                         SIZE) UNRSTD;                            0609
@RT00565 DS    0H                                                  0610
*                       RTM2TREC=OFF;/* RESET RECURSION FLAG @ZM45190*/
         NI    RTM2TREC(R8),B'11101111'                            0610
*                     END;          /* RECUSIVE ERROR        @ZM45190*/
*                   RESPECIFY                                      0612
*                     R13 RESTRICTED;                              0612
@RF00561 DS    0H                                                  0613
*                   R13=ADDR(RTM2CREG);/* ESTABLISH ADDRESSABILITY TO
*                                      SAVE AREA                     */
         LA    R13,RTM2CREG(,R8)                                   0613
*                   CALL IEAVTRTC;  /* INVOKE MAIN PATH CONTROLLER   */
         L     @15,@CV03153                                        0614
         BALR  @14,@15                                             0614
*                   RESPECIFY                                      0615
*                     R15 RESTRICTED;                              0615
*                   IF R15^=0 THEN  /* IEAVTRTC FOUND CRITICAL ERROR */
         LTR   R15,R15                                             0616
         BZ    @RF00616                                            0616
*                     ESAFERR=ON;                                  0617
         OI    ESAFERR(R7),B'00001000'                             0617
*                   ELSE                                           0618
*                     ;                                            0618
@RF00616 DS    0H                                                  0619
*                   RESPECIFY                                      0619
*                     R15 UNRESTRICTED;                            0619
*                   RESPECIFY                                      0620
*                     R13 UNRESTRICTED;                            0620
*                 END;                                             0621
*               ELSE                                               0622
*                 ;                 /* MEMTERM OR NORMAL EOT         */
@RF00559 DS    0H                                                  0623
*             ELSE                                                 0623
*               ;                   /* INITIALIZATION FAILURE -    0623
*                                      CONTROL WILL GO TO THE      0623
*                                      CRITICAL ERROR ROUTINE        */
@RF00558 DS    0H                                                  0624
*           END;                                                   0624
*         ELSE                      /* RECURSION IN INITIALIZATION   */
*           RTM2RCRX=ON;            /* REQUEST RECURSION EXIT        */
         B     @RC00252                                            0625
@RF00252 OI    RTM2RCRX(R8),B'10000000'                            0625
*       ELSE                                                       0626
*         ;                         /* FAILURE DETECTED - NO WORKAREA
*                                      AVAILABLE                     */
@RF00251 DS    0H                                                  0627
*       IF ESAFERR=OFF THEN         /* NO CRITICAL ERROR DETECTED IN
*                                      EARLIER PROCESSING            */
@RC00251 TM    ESAFERR(R7),B'00001000'                             0627
         BNZ   @RF00627                                            0627
*         DO;                                                      0628
*           RESPECIFY                                              0629
*             R13 RESTRICTED;                                      0629
*           R13=ADDR(RTM2CREG);     /* ESTABLISH ADDRESSABILITY TO 0630
*                                      SAVE AREA                     */
         LA    R13,RTM2CREG(,R8)                                   0630
*           CALL IEAVTRTE;          /* INVOKE EXIT ROUTER            */
         L     @15,@CV03154                                        0631
         BALR  @14,@15                                             0631
*           RESPECIFY                                              0632
*             R13 UNRESTRICTED;                                    0632
*         END;                                                     0633
*       ELSE                                                       0634
*         ;                         /* FALL THROUGH TO CRITICAL ERROR
*                                      ROUTINE                       */
@RF00627 DS    0H                                                  0635
*     END;                                                         0635
*   ELSE                                                           0636
*     ;                             /* FALL THROUGH TO CRITICAL ERROR
*                                      ROUTINE IF ERROR IN SVC 3     */
@RF00070 DS    0H                                                  0637
*RT2MODE:                                                          0637
*   PROC OPTIONS(NOSAVEAREA);                                      0637
*                                                                  0637
         B     @PB00002                                            0637
RT2MODE  STM   @14,@12,12(@13)                                     0637
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT RT2MODE PROCESSES THE DATA PASSED BY RTM1 REGARDING   */
*   /* THE MODE OF THE SYSTEM AT TIME OF ERROR. THIS DATA WAS PLACED */
*   /* IN THE TCB BY RTM1 AND MOVED INTO THE RTM2 ESA BY RTM2. IT    */
*   /* THEN INCLUDES SEGMENT RT2CYEED TO COPY THE DATA PASSED BY RTM1*/
*   /* VIA EEDS INTO THE RTM2WA. ON ENTRY REG 5 LOCATES THE SVRB AND */
*   /* REG 8, THE RTM2WA.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0638
*   RESPECIFY                                                      0638
*     MODEBYTE BASED(ADDR(ESAMODE));/* BASE MODEBYTE ON ESAMODE      */
*   IF MODESUPR=ON|MODEDIS=ON|MODEGSPN=ON|MODEGSUS=ON|MODELOC=ON THEN
         TM    MODESUPR+43(R7),B'11111000'                         0639
         BZ    @RF00639                                            0639
*                                   /* ERROR IS IN DISABLED ROUTINE
*                                      DISABLED FLAG IS SET          */
*     RTM2LDIS=ON;                                                 0640
         OI    RTM2LDIS(R8),B'00000010'                            0640
*   IF MODETYP1=ON THEN             /* ERROR IN TYPE 1 SVC - SET TYPE
*                                      1 FLAG                        */
@RF00639 TM    MODETYP1+43(R7),B'00000100'                         0641
         BNO   @RF00641                                            0641
*     RTM2TYP1=ON;                                                 0642
         OI    RTM2TYP1(R8),B'00001000'                            0642
*   IF MODESRB=ON THEN              /* SYSTEM IN SRB MODE AT TIME OF
*                                      ERROR - SET SRB FLAG          */
@RF00641 TM    MODESRB+43(R7),B'00000010'                          0643
         BNO   @RF00643                                            0643
*     RTM2SRBM=ON;                                                 0644
         OI    RTM2SRBM(R8),B'00000001'                            0644
*   IF MODETCB=ON THEN              /* SYSTEM IN TASK MODE AT TIME OF
*                                      ERROR - SET ENABLED RB FLAG   */
@RF00643 TM    MODETCB+43(R7),B'00000001'                          0645
         BNO   @RF00645                                            0645
*     RTM2ENRB=ON;                                                 0646
         OI    RTM2ENRB(R8),B'00000100'                            0646
*   RESPECIFY                                                      0647
*     R9 RESTRICTED;                /* RESTRICT EED POINTER          */
@RF00645 DS    0H                                                  0648
*   RESPECIFY                                                      0648
*     EED BASED(R9);                /* BASE EED STRUCTURE ON REGISTER*/
*   R9=ESAEEDQ;                     /* SET EED REG = TO FIRST EED    */
         L     R9,ESAEEDQ(,R7)                                     0649
*   IF R9^=NOEED&R9^=EEDNULL THEN                                  0650
*                                                                  0650
         LTR   R9,R9                                               0650
         BZ    @RF00650                                            0650
         C     R9,@CF00067                                         0650
         BE    @RF00650                                            0650
*     /***************************************************************/
*     /*                                                             */
*     /* EEDS HAVE BEEN PASSED SEGMENT RT2CYEED COPIES THE DATA FROM */
*     /* THE EEDS PASSED BY RTM1 TO THE RTM2WA. IT THEN FREES THE    */
*     /* EEDS. ON ENTRY REG 9 LOCATES THE FIRST EED, REG 8 LOCATES   */
*     /* THE RTM2WA.                                                 */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0651
*     DO;                           /* BEGIN SEGMENT RT2CYEED        */
*       RTM2FMID=EEDASID;           /* SAVE ASID OF MEMORY IN WHICH
*                                      ABTERM ORIGINATED             */
         LH    @12,EEDASID(,R9)                                    0652
         STH   @12,RTM2FMID(,R8)                                   0652
*       DO WHILE(R9^=NOEED&R9^=EEDNULL);/* ZERO OR EEDNULL INDICATE
*                                      END OF QUEUE                  */
         B     @DE00653                                            0653
@DL00653 DS    0H                                                  0654
*         IF EEDID=REGSPTYP THEN    /* IF EED CONTAINS REGS AND PSW
*                                      PROCESS THEM                  */
         CLI   EEDID(R9),1                                         0654
         BNE   @RF00654                                            0654
*           DO;                                                    0655
*             RTM2REED=ON;          /* INDICATE REGISTER TYPE EED  0656
*                                      FOUND                         */
         OI    RTM2REED(R8),B'00001000'                            0656
*             RTM2EEDR=EEDREGSP;    /* MOVE REGS AND PSW TO RTM2WA   */
         MVC   RTM2EEDR(80,R8),EEDREGSP(R9)                        0657
*           END;                                                   0658
*         ELSE                      /* NOT REGS EED                  */
*           IF EEDID=HWREPTYP THEN  /* IF EED CONTAINS HARDWARE ERROR
*                                      DATA PROCESS IT               */
         B     @RC00654                                            0659
@RF00654 CLI   EEDID(R9),3                                         0659
         BNE   @RF00659                                            0659
*             DO;                                                  0660
*               RTM2HEED=ON;        /* INDICATE HARDWARE EED FOUND   */
         OI    RTM2HEED(R8),B'00000100'                            0661
*               RTM2EEDH=EEDHWREP;  /* MOVE DATA TO RTM2WA           */
         MVC   RTM2EEDH(28,R8),EEDHWREP(R9)                        0662
*             END;                                                 0663
*           ELSE                    /* NOT HARDWARE EED              */
*             IF EEDID=DUMPOTYP THEN/* IF EED CONTAINS DUMP OPTIONS
*                                      PROCESS THEM                  */
         B     @RC00659                                            0664
@RF00659 CLI   EEDID(R9),2                                         0664
         BNE   @RF00664                                            0664
*               DO;                                                0665
*                 SNPSDATA=SNPSDATA|EEDSSDAT(1:LENGTH(SNPSDATA));/*
*                                      PUT SDATA OPTIONS IN RTM2WA 0666
*                                                            @YM03570*/
         LA    @12,256                                             0666
         ALR   @12,R8                                              0666
         OC    SNPSDATA(2,@12),EEDSSDAT(R9)                        0666
*                 SNPPDATA=SNPPDATA|EEDSPDAT(1:LENGTH(SNPPDATA));/*
*                                      PUT PDATA OPTIONS IN RTM2WA 0667
*                                                            @YM03570*/
         OC    SNPPDATA(1,@12),EEDSPDAT(R9)                        0667
*                 IF ADDR(EEDSDUMP)->SNPSLIST=ON THEN/* IF STORAGE 0668
*                                      LIST PASSED PROCESS IT      0668
*                                                            @YM03570*/
         TM    SNPSLIST+12(R9),B'00000010'                         0668
         BNO   @RF00668                                            0668
*                   DO;             /*                       @YM03570*/
*LRT2C:                                                            0670
*                     ;             /* PREVENT USE OF COMPILER     0670
*                                      TEMPORARY             @YM03570*/
LRT2C    DS    0H                                                  0671
*                     RESPECIFY                                    0671
*                      (R2,                                        0671
*                       R12) RSTD;  /* RESTRICT COUNTERS     @YM03570*/
*                     SNPSTOR=ADDR(RTM2DPSL);/* SET SNAP PARM LIST TO
*                                      POINT TO STORAGE LIST PASSED  */
         LA    @15,256                                             0672
         ALR   @15,R8                                              0672
         LA    @14,RTM2DPSL(,R8)                                   0672
         ST    @14,SNPSTOR(,@15)                                   0672
*                     IF SNPSLIST=ON THEN/* STORAGE RANGES ALREADY 0673
*                                      SPECIFIED             @YM03570*/
         TM    SNPSLIST(@15),B'00000010'                           0673
         BNO   @RF00673                                            0673
*                       DO;         /*                       @YM03570*/
*                         R2=1;     /* START WITH FIRST      @YM03570*/
         LA    R2,1                                                0675
*                         DO WHILE(STORBTO(R2)=OFF);/* LOCATE LAST 0676
*                                      RANGE IN CURRENT LIST @YM03570*/
         B     @DE00676                                            0676
@DL00676 DS    0H                                                  0677
*                           R2=R2+1;/*                       @YM03570*/
         AL    R2,@CF00067                                         0677
*                         END;      /*                       @YM03570*/
@DE00676 LR    @15,R2                                              0678
         SLA   @15,3                                               0678
         ALR   @15,R8                                              0678
         TM    STORBTO+268(@15),B'10000000'                        0678
         BZ    @DL00676                                            0678
*LRT2A:                                                            0679
*                         ;         /* PREVENT USE OF COMPILER     0679
*                                      TEMPORARY             @YM03570*/
LRT2A    DS    0H                                                  0680
*                         STORBTO(R2)=OFF;/* CLEAR LAST ENTRY FLAG IN
*                                      CURRENT LIST          @YM03570*/
         LR    @15,R2                                              0680
         SLA   @15,3                                               0680
         ALR   @15,R8                                              0680
         NI    STORBTO+268(@15),B'01111111'                        0680
*                         R2=R2+1;  /* SET COUNTER TO FIRST ENTRY TO
*                                      BE ADDED              @YM03570*/
         AL    R2,@CF00067                                         0681
*                       END;        /* END OF CURRENT SLIST        0682
*                                      PROCESSING            @YM03570*/
*                     ELSE          /* NO STORAGE LIST YET   @YM03570*/
*                       R2=1;       /* FIRST ENTRY WILL BE FIRST ONE
*                                      USED                  @YM03570*/
         B     @RC00673                                            0683
@RF00673 LA    R2,1                                                0683
*                     RTM2DEND=OFF; /* FORCE ENTRY INTO LOOP @YM03570*/
@RC00673 NI    RTM2DEND(R8),B'10111111'                            0684
*                     DO R12=1 TO RGENO WHILE(RTM2DEND=OFF);/* LOOP
*                                      OVER INPUT LIST       @YM03570*/
         LA    R12,1                                               0685
@DL00685 TM    RTM2DEND(R8),B'01000000'                            0685
         BNZ   @DC00685                                            0685
*                       IF R2>RGENO THEN/* PAST END OF OUTPUT LIST --
*                                      START AGAIN FROM TOP  @YM03570*/
         C     R2,@CF00104                                         0686
         BNH   @RF00686                                            0686
*                         DO;       /*                       @YM03570*/
*                           R2=1;   /* START WITH FIRST ENTRY      0688
*                                                            @YM03570*/
         LA    R2,1                                                0688
*                           RTM2WRAP=ON;/* INDICATE ENTRIES HAVE   0689
*                                      WRAPPED AROUND        @YM03570*/
         OI    RTM2WRAP(R8),B'00010000'                            0689
*                         END;      /*                       @YM03570*/
*                       STORAGE(R2)=ADDR(EEDSDPSL)->STORAGE(R12);/*
*                                      COPY ONE STORAGE RANGE      0691
*                                                            @YM03570*/
@RF00686 LR    @15,R2                                              0691
         SLA   @15,3                                               0691
         ALR   @15,R8                                              0691
         LR    @14,R12                                             0691
         SLA   @14,3                                               0691
         ALR   @14,R9                                              0691
         MVC   STORAGE+268(8,@15),STORAGE+12(@14)                  0691
*LRT2B:                                                            0692
*                       ;           /* PREVENT USE OF COMPILER     0692
*                                      TEMPORARY             @YM03570*/
LRT2B    DS    0H                                                  0693
*                       IF STORBTO(R2)=ON|R12=RGENO THEN/* END OF  0693
*                                      INPUT LIST            @YM03570*/
         LR    @15,R2                                              0693
         SLA   @15,3                                               0693
         ALR   @15,R8                                              0693
         TM    STORBTO+268(@15),B'10000000'                        0693
         BO    @RT00693                                            0693
         C     R12,@CF00104                                        0693
         BNE   @RF00693                                            0693
@RT00693 DS    0H                                                  0694
*                         DO;       /*                       @YM03570*/
*                           STORBTO(R2)=ON;/* INDICATE NEW END OF  0695
*                                      LIST                  @YM03570*/
         LR    @15,R2                                              0695
         SLA   @15,3                                               0695
         ALR   @15,R8                                              0695
         OI    STORBTO+268(@15),B'10000000'                        0695
*                           RTM2DEND=ON;/* FORCE EXIT FROM LOOP    0696
*                                                            @YM03570*/
         OI    RTM2DEND(R8),B'01000000'                            0696
*                         END;      /*                       @YM03570*/
*                       R2=R2+1;    /* SET COUNTER TO NEXT ENTRY OF
*                                      OUTPUT LIST           @YM03570*/
@RF00693 AL    R2,@CF00067                                         0698
*                     END;          /* END OF PROCESSING OF INPUT  0699
*                                      LIST                  @YM03570*/
         AL    R12,@CF00067                                        0699
         C     R12,@CF00104                                        0699
         BNH   @DL00685                                            0699
@DC00685 DS    0H                                                  0700
*                     RESPECIFY                                    0700
*                      (R2,                                        0700
*                       R12) UNRSTD;/* RELEASE COUNTERS      @YM03570*/
*                     SNPSLIST=ON;  /* INDICATE STORAGE RANGES     0701
*                                      PRESENT               @YM03570*/
         OI    SNPSLIST+256(R8),B'00000010'                        0701
*                   END;                                           0702
*                 ELSE                                             0703
*                   ;               /* CONTINUE PROCESSING IF NO   0703
*                                      STORAGE LIST PASSED           */
@RF00668 DS    0H                                                  0704
*               END;                                               0704
*             ELSE                                                 0705
*               ;                   /* NO VALID EED TYPE FOUND,DATA
*                                      IS NOT MOVED                  */
@RF00664 DS    0H                                                  0706
*         R9=EEDFWRDP;              /* LOCATE NEXT EED               */
@RC00659 DS    0H                                                  0706
@RC00654 L     R9,EEDFWRDP(,R9)                                    0706
*       END;                                                       0707
@DE00653 LTR   R9,R9                                               0707
         BZ    @DC00653                                            0707
         C     R9,@CF00067                                         0707
         BNE   @DL00653                                            0707
@DC00653 DS    0H                                                  0708
*       ESAFERR=OFF;                /* INDICATE SUCCESS              */
         NI    ESAFERR(R7),B'11110111'                             0708
*     END;                          /* END SEGMENT RT2CYEED          */
*   ELSE                                                           0710
*     ;                             /* NO EEDS PASSED                */
@RF00650 DS    0H                                                  0711
*   RESPECIFY                                                      0711
*     R9 UNRESTRICTED;              /* RELEASE EED POINTER           */
*   IF RTM2ENRB=OFF&RTM2REED=OFF THEN/* ERROR WAS IN NON TASK MODE 0712
*                                      ROUTINE BUT RTM1 WAS UNABLE TO
*                                      PASS THE REGS AND PSW AT TIME
*                                      OF ERROR                      */
         TM    RTM2ENRB(R8),B'00000100'                            0712
         BNZ   @RF00712                                            0712
         TM    RTM2REED(R8),B'00001000'                            0712
         BNZ   @RF00712                                            0712
*     RTM2RPIV=ON;                  /* INDICATE REGISTER AND PSW NOT
*                                      PASSED                        */
         OI    RTM2RPIV(R8),B'00000100'                            0713
*   ELSE                                                           0714
*     ;                             /* REGS AND PSW WERE PASSED FOR
*                                      NON TASK MODE ERROR           */
@RF00712 DS    0H                                                  0715
*   IF RTM2MCHK=ON&RTM2HEED=OFF THEN/* HARDWARE ERROR BUT NO EED   0715
*                                      CONTAINING THE HARDWARE ERROR
*                                      INFORMATION WAS PASSED        */
         TM    RTM2MCHK(R8),B'10000000'                            0715
         BNO   @RF00715                                            0715
         TM    RTM2HEED(R8),B'00000100'                            0715
         BNZ   @RF00715                                            0715
*     RTM2MCIV=ON;                  /* INDICATE HARDWARE ERROR DATA
*                                      NOT PASSED                    */
         OI    RTM2MCIV(R8),B'00000010'                            0716
*   RETURN;                                                        0717
@EL00002 DS    0H                                                  0717
@EF00002 DS    0H                                                  0717
@ER00002 LM    @14,@12,12(@13)                                     0717
         BR    @14                                                 0717
*   END RT2MODE;                                                   0718
         B     @EL00002                                            0718
*SLIP:                                                             0719
*   PROC OPTIONS(SAVE,NOSAVEAREA);                                 0719
*                                                                  0719
SLIP     STM   @14,@12,12(@13)                                     0719
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SUBRTN DETERMINES WHETHER SLIP CAN BE CALLED AND WHETHER */
*   /* IT SHOULD BE CALLED. IT SETS UP THE LINKAGE AND CALLS SLIP    */
*   /*                                                       @G17SP2I*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0720
*   IF CVTRTMS^=0                   /* IF THE SLIP HEADER PTR      0720
*                                      INDICATES THERE IS AN IHASHDR
*                                                            @G17SP2I*/
*       &RTM2ENRB=ON                /* AND THE ERROR WAS IN AN     0720
*                                      ENABLED TASK (DISABLED TASKS
*                                      ARE DONE FROM THE RTS ENTRY)
*                                                            @G17SP2I*/
*       &RTM2SCTR(RTM2SLPS)=OFF     /* AND THIS IS NOT AN ERROR IN 0720
*                                      SLIP CAUSING RECURSIVE ENTRY
*                                                            @G17SP2I*/
*     THEN                                                         0720
         L     @12,CVTPTR                                          0720
         L     @12,CVTRTMS(,@12)                                   0720
         LTR   @12,@12                                             0720
         BZ    @RF00720                                            0720
         TM    RTM2ENRB(R8),B'00000100'                            0720
         BNO   @RF00720                                            0720
         TM    RTM2SCTR+1(R8),B'00010000'                          0720
         BNZ   @RF00720                                            0720
*     DO;                           /* ATTEMPT LINKAGE TO SLIP     0721
*                                                            @G17SP2I*/
*       RTM2SCTC(RTM2SLPS)=ON;      /* SET THE SLIP SECTION FLAG   0722
*                                                            @G17SP2I*/
         OI    RTM2SCTC+1(R8),B'00010000'                          0722
*       RFY                                                        0723
*        (R14,                                                     0723
*         R15) RSTD;                /*                       @G17SP2I*/
*       R14=SHDRPFC;                /* GET CURRENT VALUE FOR COMPARE
*                                      IN THE CS INSTRUCTION @G17SP2I*/
         L     R14,SHDRPFC(,@12)                                   0724
*SLIPINCR:                          /* TOP OF CS LOOP FOR UPDATING 0725
*                                      THE IEAVTSLP USE COUNT      0725
*                                                            @G17SP2I*/
*       IF R14>=1                   /* IF THE IEAVTSLP USE COUNT FROM
*                                      THE IHASHDR INDICATES THAT  0725
*                                      IEAVTSLP IS AVAILABLE @G17SP2I*/
*         THEN                                                     0725
SLIPINCR LA    @12,1                                               0725
         CR    R14,@12                                             0725
         BL    @RF00725                                            0725
*         DO;                       /* THEN SLIP SHOULD BE CALLED  0726
*                                                            @G17SP2I*/
*           R15=R14+1;              /* INCREMENT THE USE COUNT TO BE
*                                      SURE THAT IEAVTSLP WILL REMAIN
*                                      AVAILABLE FOR USE     @G17SP2I*/
         ALR   @12,R14                                             0727
         LR    R15,@12                                             0727
*           CS(R14,R15,SHDRPFC);    /* USE CS TO PUT INCREMENTED   0728
*                                      VALUE IN SHDR SINCE USE OF THE
*                                      FIELD IS NOT SERIALIZED     0728
*                                                            @G17SP2I*/
         L     @12,CVTPTR                                          0728
         L     @12,CVTRTMS(,@12)                                   0728
         CS    R14,@15,SHDRPFC(@12)                                0728
*           BC(4,SLIPINCR);         /* IF SHDRPFC HAS CHANGED BEFORE
*                                      THIS CS THEN TRY AGAIN      0729
*                                                            @G17SP2I*/
         BC    4,SLIPINCR                                          0729
*           RFY                                                    0730
*            (R14,                                                 0730
*             R15) UNRSTD;          /*                       @G17SP2I*/
*           RFY                                                    0731
*            (R1,                                                  0731
*             R13) RSTD;            /*                       @G17SP2I*/
*           R13=ADDR(RTM2CREG);     /* USE THIS AREA AS A SAVE AREA
*                                      FOR STANDARD LINKAGE  @G17SP2I*/
         LA    R13,RTM2CREG(,R8)                                   0732
*           R1=ADDR(RTM2RMSA);      /* USE THIS AREA FOR THE PARMLIST
*                                      AND WORK AREA PASSED TO SLIP
*                                                            @G17SP2I*/
         LA    R1,RTM2RMSA(,R8)                                    0733
*           SLPWAPTR=ADDR(RTM2RMWA);/* PROVIDE SLIP WITH A WORK AREA
*                                                            @G17SP2I*/
         LA    @12,RTM2RMWA(,R8)                                   0734
         ST    @12,SLPWAPTR(,R1)                                   0734
*           SLPRT2WA=R8;            /* PUT THE RTM2 WORK AREA ADDR IN
*                                      THE SLIP PARM LIST    @G17SP2I*/
         ST    R8,SLPRT2WA(,R1)                                    0735
*           SLPCFRRS=0;             /* INDICATE SLIP IS NOT BEING  0736
*                                      CALLED FROM RTS       @G17SP2I*/
         SLR   @12,@12                                             0736
         ST    @12,SLPCFRRS(,R1)                                   0736
*           GEN SETS(RTM2RRG)( STM 0,15,RTM2RRG(R8));/* STORE REGS 0737
*                                      FOR RTM2 PSEUDO RETRY IN CASE
*                                      OF SLIP FAILURE       @G17SP2I*/
          STM 0,15,RTM2RRG(R8)
*           ESASLIPR=ON;            /* SET THE SLIP RECURSION FLAG TO
*                                      CAUSE PSEUDO RETRY FOR AN   0738
*                                      ERROR IN SLIP         @G17SP2I*/
*           ESAINREC=OFF;           /* CLEAR INIT RECURSION FLAG TO
*                                      PREVENT MEMTERM IF SLIP FAILS
*                                                            @G17SP2I*/
         OI    ESASLIPR(R7),B'00000010'                            0739
         NI    ESAINREC(R7),B'11011111'                            0739
*           CALL IEAVTSLP;          /*                       @G17SP2I*/
         L     @12,CVTPTR                                          0740
         L     @12,CVTRTMS(,@12)                                   0740
         L     @15,SHDRPROC(,@12)                                  0740
         BALR  @14,@15                                             0740
*           RFY                                                    0741
*             R1 UNRSTD;            /*                       @G17SP2I*/
*SLIPRTRY:                          /* THIS IS THE POINT WHERE PSEUDO
*                                      RETRY WILL OCCUR IF THERE IS
*                                      AN ERROR IN SLIP      @G17SP2I*/
*           RFY                                                    0742
*            (R14,                                                 0742
*             R15) RSTD;            /*                       @G17SP2I*/
SLIPRTRY DS    0H                                                  0743
*           R14=SHDRPFC;            /* GET CURRENT VALUE FOR COMPARE
*                                      IN THE CS INSTRUCTION @G17SP2I*/
         L     @12,CVTPTR                                          0743
         L     @12,CVTRTMS(,@12)                                   0743
         L     R14,SHDRPFC(,@12)                                   0743
*SLIPDECR:                          /* TOP OF CS LOOP FOR UPDATING 0744
*                                      THE IEAVTSLP USE COUNT      0744
*                                                            @G17SP2I*/
*           IF R14>1                /* IF THE IEAVTSLP USE COUNT FROM
*                                      THE IHASHDR ISN'T AT IT'S   0744
*                                      MINIMUM VALUE         @G17SP2I*/
*             THEN                                                 0744
SLIPDECR C     R14,@CF00067                                        0744
         BNH   @RF00744                                            0744
*             DO;                   /* THEN DECREMENT IT     @G17SP2I*/
*               R15=R14-1;          /* PREPARE THE REPLACEMENT VALUE
*                                                            @G17SP2I*/
         LR    R15,R14                                             0746
         BCTR  R15,0                                               0746
*               CS(R14,R15,SHDRPFC);/* USE CS TO PUT IT IN SHDR SINCE
*                                      USE OF THE FIELD IS NOT     0747
*                                      SERIALIZED            @G17SP2I*/
         L     @12,CVTPTR                                          0747
         L     @12,CVTRTMS(,@12)                                   0747
         CS    R14,@15,SHDRPFC(@12)                                0747
*               BC(4,SLIPDECR);     /* IF SHDRPFC HAS CHANGED BEFORE
*                                      THIS CS THEN TRY AGAIN      0748
*                                                            @G17SP2I*/
         BC    4,SLIPDECR                                          0748
*             END;                                                 0749
*           RFY                                                    0750
*            (R14,                                                 0750
*             R15) UNRSTD;          /*                       @G17SP2I*/
@RF00744 DS    0H                                                  0751
*           ESAINREC=ON;            /* RESTORE INIT RECURSION      0751
*                                      COVERAGE              @G17SP2I*/
*           ESASLIPR=OFF;           /* DROP SLIP PSEUDO RETRY      0752
*                                      RECURSION COVERAGE    @G17SP2I*/
         OI    ESAINREC(R7),B'00100000'                            0752
         NI    ESASLIPR(R7),B'11111101'                            0752
*         END;                      /*                       @G17SP2I*/
*       R13=ADDR(RTM2SFSA);         /* RESTORE THE SAVEAREA PTR TO 0754
*                                      THE SAME AS ON ENTRY  @G17SP2I*/
@RF00725 LA    R13,RTM2SFSA(,R8)                                   0754
*       RTM2SCTC(RTM2SLPS)=OFF;     /* CLEAR THE SLIP SECTION FLAG TO
*                                      SHOW SLIP PROCESSING DONE   0755
*                                                            @G17SP2I*/
         NI    RTM2SCTC+1(R8),B'11101111'                          0755
*     END;                          /*                       @G17SP2I*/
*   RETURN;                         /*                       @G17SP2I*/
@EL00003 DS    0H                                                  0757
@EF00003 DS    0H                                                  0757
@ER00003 LM    @14,@12,12(@13)                                     0757
         BR    @14                                                 0757
*   RFY                                                            0758
*     R13 UNRSTD;                   /*                       @G17SP2I*/
*   END;                            /* END OF SLIP PROC      @G17SP2I*/
*                                                                  0759
         B     @EL00003                                            0759
@PB00003 DS    0H                                                  0759
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT RT2CRERR CONTROLS TERMINATION AFTER AN UNRECOVERABLE  */
*   /* ERROR OCCURS. IT RESTRICTS THE REGISTERS REQUIRED BY THE      */
*   /* SYSTEM ROUTINES IT CALLS. IT THEN REQUESTS AN SVC DUMP UNLESS */
*   /* SVC DUMP HAS ITSELF SUFFERED AN ERROR. SEGMENT RT2TMRY IS THEN*/
*   /* INCLUDED TO REQUEST A MEMORY TERMINATION. THE REGISTERS NOT   */
*   /* RELEASED BY RT2TMRY ARE THEN RELEASED. THE ENQ/LOCK CONDITIONS*/
*   /* ON ENTRY ARE UNKNOWN. IT DOES NOT ASSUME ANY INPUT. ON        */
*   /* COMPLETION OF ITS PROCESSING THE CURRENT TASK TREE IS NON     */
*   /* DISPATCHABLE AND THE MEMORY IS TERMINATING                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0760
*RT2CRERR:                                                         0760
*   DO;                             /* BEGIN SEGMENT RT2CRERR        */
RT2CRERR DS    0H                                                  0761
*     RESPECIFY                                                    0761
*       R0 RESTRICTED;              /* USED AS A PARAMETER REGISTER
*                                      BY SERVICES CALLED            */
*     RESPECIFY                                                    0762
*       R1 RESTRICTED;              /* USED AS A PARAMETER REGISTER  */
*     RESPECIFY                                                    0763
*       R2 RESTRICTED;              /* USED BY CALLRTM AS A PARMETER
*                                      REGISTER                      */
*     RESPECIFY                                                    0764
*       R11 RESTRICTED;             /* USED BY SETLOCK AS A PARAMETER
*                                      REGISTER                      */
*     RESPECIFY                                                    0765
*       R12 RESTRICTED;             /* USED BY SETLOCK AS A PARAMETER
*                                      REGISTER                      */
*     RESPECIFY                                                    0766
*       R13 RESTRICTED;             /* USED AS SAVEAREA REG FOR    0766
*                                      CALLRTM AND FOR PARAMETERS BY
*                                      SETLOCK                       */
*     RESPECIFY                                                    0767
*       R14 RESTRICTED;             /* USED AS LINKAGE REGISTER BY 0767
*                                      SERVICES CALLED               */
*     RESPECIFY                                                    0768
*       R15 RESTRICTED;             /* USED AS LINKAGE REGISTER BY 0768
*                                      SERVICES CALLED               */
*     GENERATE(BALR 6,0);           /* ESTABLISH ADDRESSIBILITY      */
         BALR 6,0
*     GENERATE(USING *,6);                                         0770
         USING *,6
*     R4=PSATOLD;                   /* SET CURRENT TCB ADDRESS IN  0771
*                                      TCBPTR                        */
         L     R4,PSATOLD                                          0771
*     R5=TCBRBP;                    /* SET CURRENT RTM2 SVRB ADDRESS
*                                      IN RBSECPTR                   */
         L     R5,TCBRBP(,R4)                                      0772
*     R7=ADDR(RBEXSAVE);            /* SET REG WITH ADDR OF RTM ESA  */
         LA    R7,RBEXSAVE(,R5)                                    0773
*     ESAR7=PSAAOLD;                /* SET CURRENT ASCB ADDRESS IN 0774
*                                      ESA                           */
         L     @10,PSAAOLD                                         0774
         ST    @10,ESAR7(,R7)                                      0774
*     IF ESASDREC=OFF THEN          /* THERE HAS NOT BEEN A RECURSION
*                                      IN SVC DUMP                   */
         TM    ESASDREC(R7),B'01000000'                            0775
         BNZ   @RF00775                                            0775
*       DO;                                                        0776
*         ESASDREC=ON;              /* SET FOR RECURSION IN SVCDUMP  */
         OI    ESASDREC(R7),B'01000000'                            0777
*         TCBFX=OFF;                /* PERMIT ASYNCHRONOUS EXITS     */
         NI    TCBFX(R4),B'11111110'                               0778
*         GENERATE SETS(R0,R1,R14,R15) REFS(SDUMPLST);             0779
*                                                         /* @ZA04528*/
          SDUMP MF=(E,SDUMPLST)                                @ZA04528
*         TCBFX=ON;                 /* PROHIBIT FURTHER ASYNCHRONOUS
*                                      EXITS                         */
         OI    TCBFX(R4),B'00000001'                               0780
*         ESASDREC=OFF;             /* RESET SDUMP RECURSION FLAG    */
         NI    ESASDREC(R7),B'10111111'                            0781
*       END;                                                       0782
*     ELSE                                                         0783
*       ;                           /* IF SVCDUMP HAS SUFFERED A   0783
*                                      PRIOR ERROR DO NOT TAKE ONE   */
*                                                                  0783
@RF00775 DS    0H                                                  0784
*     /***************************************************************/
*     /*                                                             */
*     /* SEGMENT RT2TMRY WILL REQUEST TERMINATION OF THE MEMORY AND  */
*     /* THEN SET THE CURRENT TASK TREE PERMANENTLY NONDISPATCHABLE. */
*     /* IT FIRST REQUESTS THE LOCAL LOCK TO SERIALIZE THE WORK SAVE */
*     /* AREA PASSED TO RTM1, UNLESS THE LOCK MANAGER IS SUFFERING AN*/
*     /* ERROR. IT THEN CALLS RTM1 TO ABNORMALLY TERMINATE THE       */
*     /* MEMORY. ON RETURN, IT RELEASES THE LOCAL LOCK IF IT WAS     */
*     /* ACQUIRED AND ISSUES A STATUS SVC TO SET THE SUBTASK TREE    */
*     /* NONDISPATCHABLE. ON RETURN FROM STATUS IT AGAIN ACQUIRES THE*/
*     /* LOCAL LOCK AND RE-ENTERS STATUS VIA A BRANCH ENTRY TO SET   */
*     /* THE CURRENT TASK NONDISPATCHABLE. STATUS WILL RELEASE THE   */
*     /* LOCAL LOCK. ENQ/LOCK CONDITIONS ON ENTRY ARE UNKNOWN.       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0784
*     DO;                           /* BEGIN SEGMENT RT2TMRY         */
*       IF ESAGLREC=OFF THEN        /* THERE HAS NOT BEEN A SETLOCK
*                                      RECURSION                     */
         TM    ESAGLREC(R7),B'00010000'                            0785
         BNZ   @RF00785                                            0785
*         DO;                                                      0786
*           ESAGLREC=ON;            /* SET FOR RECURSION IN SETLOCK  */
         OI    ESAGLREC(R7),B'00010000'                            0787
*           DO;                     /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(WSALSTAE,IEAVT
*                                      RT2(RT2CRERR))                */
*             RESPECIFY                                            0789
*              (GPR11P,                                            0789
*               GPR12P,                                            0789
*               GPR13P,                                            0789
*               GPR14P) RESTRICTED; /* RESTRICT REGS USED BY SETLOCK */
*             GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,
*                 GPR14P);                                         0790
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(WSALSTAE,IEAVTRT2(RT2CRERR))
*             RESPECIFY                                            0791
*              (GPR11P,                                            0791
*               GPR12P,                                            0791
*               GPR13P,                                            0791
*               GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY SETLOCK */
*           END;                    /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(WSALSTAE,IEAVT
*                                      RT2(RT2CRERR)) ACQUIRE LOCAL
*                                      LOCK                          */
*           ESAGLREC=OFF;           /* RESET RECURSION INDICATOR     */
         NI    ESAGLREC(R7),B'11101111'                            0793
*         END;                                                     0794
*       ELSE                                                       0795
*         ;                         /* IF RECURSION IS IN SETLOCK, 0795
*                                      THE RESOURCE WILL NOT BE    0795
*                                      SERIALIZED THIS IS NOT AN   0795
*                                      EXPOSURE AS THE MEMORY WILL BE
*                                      TERMINATED                    */
*                                                                  0795
@RF00785 DS    0H                                                  0796
*       /*************************************************************/
*       /*                                                           */
*       /* ESTABLISH INTERFACE FOR CALL TO RTM1                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0796
*       R2=ASCBASID;                /* INITIALIZE R2 WITH ASID TO  0796
*                                      INTERFACE WITH RTM1           */
         L     @10,ASCBPTR(,R7)                                    0796
         LH    R2,ASCBASID(,@10)                                   0796
         N     R2,@CF03215                                         0796
*       R1=MTCC;                    /* INITIALIZE R1 WITH THE COMP.
*                                      CODE TO INTERFACE WITH RTM1   */
         LA    R1,1037                                             0797
*       R13=WSALSTAE;               /* SET SAVE AREA ADDRESS IN R13  */
         L     @10,ASXBPTR(,@10)                                   0798
         L     @10,ASXBSPSA(,@10)                                  0798
         L     R13,WSALSTAE(,@10)                                  0798
*       GENERATE REFS(R1,R2,R13,CVTBTERM,CVTMAP,CVTUSER) SETS(R0,R1,R2,
*           R13,R14,R15);                                          0799
          CALLRTM TYPE=MEMTERM,COMPCOD=(1),ASID=(2)
*       IF ESAGLREC=OFF THEN        /* IF NO RECURSION IN SETLOCK  0800
*                                      RTM2 HOLDS THE LOCAL LOCK     */
         TM    ESAGLREC(R7),B'00010000'                            0800
         BNZ   @RF00800                                            0800
*         DO;                       /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(WSALSTAE,IEAVTRT2(RT2CRER
*                                      R))                           */
*           RESPECIFY                                              0802
*            (GPR11P,                                              0802
*             GPR12P,                                              0802
*             GPR13P,                                              0802
*             GPR14P) RESTRICTED;   /* RESTRICT REGS USED BY SETLOCK */
*           GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,GPR14P
*               );                                                 0803
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(WSALSTAE,IEAVTRT2(RT2CRERR))
*           RESPECIFY                                              0804
*            (GPR11P,                                              0804
*             GPR12P,                                              0804
*             GPR13P,                                              0804
*             GPR14P) UNRESTRICTED; /* RELEASE REGS USED BY SETLOCK  */
*         END;                      /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(WSALSTAE,IEAVTRT2(RT2CRER
*                                      R)) RELEASE LOCAL LOCK        */
*       ELSE                                                       0806
*         ;                         /* IF RECURSION IN SETLOCK THEN
*                                      THE LOCK WAS NOT ACQUIRED     */
@RF00800 DS    0H                                                  0807
*       GENERATE REFS(R4) SETS(R0,R1,R14,R15);                     0807
*                                                                  0807
          STATUS SET,SD,(R4),(10)
*       /*************************************************************/
*       /*                                                           */
*       /* THE FOLLOWING CODE SETS UP THE BRANCH ENTRY TO STATUS AND */
*       /* PASSES CONTROL TO IT. AS THE CURRENT TASK IS BEING SET    */
*       /* NON-DISPATCHABLE, STATUS WILL FREE THE LOCAL LOCK AND EXIT*/
*       /* TO THE DISPATCHER                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0808
*       DO;                         /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED('FREED BY   0808
*                                      STATUS')                      */
*         RESPECIFY                                                0809
*          (GPR11P,                                                0809
*           GPR12P,                                                0809
*           GPR13P,                                                0809
*           GPR14P) RESTRICTED;     /* RESTRICT REGS USED BY SETLOCK */
*         GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,GPR14P);
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=('FREED BY STATUS')
*         RESPECIFY                                                0811
*          (GPR11P,                                                0811
*           GPR12P,                                                0811
*           GPR13P,                                                0811
*           GPR14P) UNRESTRICTED;   /* RELEASE REGS USED BY SETLOCK  */
*       END;                        /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED('FREED BY   0812
*                                      STATUS') THE LOCAL LOCK IS  0812
*                                      REQUIRED FOR BRANCH ENTRY TO
*                                      STATUS                        */
*       R0=SENTCD15;                /* ESTABLISH ENTRY CODE FOR    0813
*                                      STATUS TO SET CURRENT       0813
*                                      NONDISPATCHABLE               */
         LA    R0,15                                               0813
*       R1=R4;                      /* SET CURRENT TCB AS ONE TO BE
*                                      SET NONDISPATCHABLE           */
         LR    R1,R4                                               0814
*       R13=DARPNDBE;               /* SET NONDISPATCHABILITY MASK IN
*                                      R13                           */
         L     R13,@CF00056                                        0815
*       RESPECIFY                                                  0816
*        (R14,                                                     0816
*         R15) UNRESTRICTED;                                       0816
*       CALL STATUS;                /* BRANCH ENTER STATUS           */
         L     @10,CVTPTR                                          0817
         L     @10,SCVTSPTR(,@10)                                  0817
         L     @15,SCVTSTAT(,@10)                                  0817
         BALR  @14,@15                                             0817
*     END;                                                         0818
*     RESPECIFY                                                    0819
*      (R0,                                                        0819
*       R1,                                                        0819
*       R2,                                                        0819
*       R11,                                                       0819
*       R12,                                                       0819
*       R13) UNRESTRICTED;          /* R14 AND R15 WERE UNRESTRICTED
*                                      IN SEGMENT RT2TMRY            */
*     GENERATE(DROP);                                              0820
         DROP
*   END;                            /* END SEGMENT RT2CRERR          */
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR11P PTR(31) REG(11),                                      0822
*     GPR12P PTR(31) REG(12),                                      0822
*     GPR13P PTR(31) REG(13),                                      0822
*     GPR14P PTR(31) REG(14);                                      0822
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0823
*     I031F FIXED(31) BASED,                                       0823
*     I031P PTR(31) BASED,                                         0823
*     I015F FIXED(15) BASED,                                       0823
*     I015P PTR(15) BASED,                                         0823
*     I008P PTR(8) BASED,                                          0823
*     I001C CHAR(1) BASED;                                         0823
*   END IEAVTRT2                                                   0824
*                                                                  0824
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (RT2TSTVR)                                       */
*/*%INCLUDE SYSLIB  (RT2SPEC )                                       */
*/*%INCLUDE SYSLIB  (RT2DCL  )                                       */
*/*%INCLUDE SYSLIB  (IHASHDR )                                       */
*/*%INCLUDE SYSLIB  (IHARTM2A)                                       */
*/*%INCLUDE SYSLIB  (IHASNP  )                                       */
*/*%INCLUDE SYSLIB  (IHARMPL )                                       */
*/*%INCLUDE SYSLIB  (RTM2ESA )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IHAGDA  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHART1W )                                       */
*/*%INCLUDE SYSLIB  (IHASCB  )                                       */
*/*%INCLUDE SYSLIB  (RT2PATCH)                                       */
*/*%INCLUDE SYSLIB  (RT2INCTL)                                       */
*/*%INCLUDE SYSLIB  (RT2INESA)                                       */
*/*%INCLUDE SYSLIB  (RT2GETWA)                                       */
*/*%INCLUDE SYSLIB  (RT2INWA )                                       */
*/*%INCLUDE SYSLIB  (RT2INCNV)                                       */
*/*%INCLUDE SYSLIB  (RT2INCM )                                       */
*/*%INCLUDE SYSLIB  (RT2INEOT)                                       */
*/*%INCLUDE SYSLIB  (RT2INPG )                                       */
*/*%INCLUDE SYSLIB  (RT2INRCR)                                       */
*/*%INCLUDE SYSLIB  (RT2INRT1)                                       */
*/*%INCLUDE SYSLIB  (RT2INMT )                                       */
*/*%INCLUDE SYSLIB  (RT2INABD)                                       */
*/*%INCLUDE SYSLIB  (GETERRID)                                       */
*/*%INCLUDE SYSLIB  (RT2SVTRC)                                       */
*/*%INCLUDE SYSLIB  (RT2MODE )                                       */
*/*%INCLUDE SYSLIB  (RT2CYEED)                                       */
*/*%INCLUDE SYSLIB  (RT2SLIP )                                       */
*/*%INCLUDE SYSLIB  (RT2CRERR)                                       */
*/*%INCLUDE SYSLIB  (RT2TMRY )                                       */
*                                                                  0824
*       ;                                                          0824
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IEAVTRT2 CSECT
         DS    0F
@CF00067 DC    F'1'
@CH00067 EQU   @CF00067+2
@CF00104 DC    F'4'
@CF00055 DC    F'32'
@CF00482 DC    F'64'
@CF03185 DC    F'972'
@CF03212 DC    F'-24'
@CF03202 DC    F'-8'
@CF00056 DC    XL4'00400000'
@CF00078 DC    XL4'D9E3F104'
@CF03215 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
IEAVTRT2 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00100 DC    V(RTECVERR)
@CV03153 DC    V(IEAVTRTC)
@CV03154 DC    V(IEAVTRTE)
         DS    0D
@CC03137 DC    C'RTM2'
@CB00063 DC    X'20D000'
@CB00072 DC    X'0000'
@CB03152 DC    X'07FA'
         DS    CL1
RT2PATCH DC    CL160'PATCH AREA'
IEAVTRT2 CSECT
*                                     /*                     @ZA04528*/
SDUMPLST SDUMP SDATA=(PSA,NUC,RGN,SQA),QUIESCE=NO,MF=L,                X
               HDR='IEAVTRT2 - UNRECOVERABLE ABEND FAILURE'    @ZA04528
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVTRT2 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R6       EQU   @06
R0       EQU   @00
SIZE     EQU   @00
R1       EQU   @01
TTPTR    EQU   @02
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
FLCTRACE EQU   PSA+84
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
STATUS   EQU   0
TTPOINTS EQU   0
CURRENT  EQU   TTPOINTS
FIRSTENT EQU   TTPOINTS+4
LASTENT  EQU   TTPOINTS+8
SLIPLIST EQU   0
SLPCFRRS EQU   SLIPLIST
SLPRT2WA EQU   SLIPLIST+4
SLPWAPTR EQU   SLIPLIST+8
IEAVTSLP EQU   0
SHDR     EQU   0
SHDRPFC  EQU   SHDR+4
SHDRCTFW EQU   SHDR+8
SHDRFLGS EQU   SHDR+20
SHDRPROC EQU   SHDR+24
SNPPARMS EQU   0
SNPFLAG  EQU   SNPPARMS+1
SNPSLIST EQU   SNPFLAG
SNPSDATA EQU   SNPPARMS+4
SNPSDAT0 EQU   SNPSDATA
SNPSDAT1 EQU   SNPSDATA+1
SNPPDATA EQU   SNPPARMS+6
SNPSTOR  EQU   SNPPARMS+16
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RMPLTYPE EQU   RMPLFLG1
RMPLTERM EQU   RMPLFLG1
RMPLASID EQU   RMPL+2
RMPLASCB EQU   RMPL+4
RMPLTCBA EQU   RMPL+8
RMPLRMWA EQU   RMPL+16
RTM2WA   EQU   0
RTM2DESC EQU   RTM2WA
RTM2ID   EQU   RTM2DESC
RTM2ADDR EQU   RTM2DESC+4
RTM2RT2D EQU   RTM2DESC+8
RTM2CVT  EQU   RTM2WA+12
RTM2TCBC EQU   RTM2WA+16
RTM2VRBC EQU   RTM2WA+20
RTM2ASC  EQU   RTM2WA+24
RTM2CODE EQU   RTM2WA+28
RTM2CCF  EQU   RTM2CODE
RTM2DREQ EQU   RTM2CCF
RTM2STEP EQU   RTM2CCF
RTM2CC   EQU   RTM2CODE+1
RTM2TCBT EQU   RTM2WA+48
RTM2VRBT EQU   RTM2WA+52
RTM2CT   EQU   RTM2WA+56
RTM2PGCY EQU   RTM2WA+60
RTM2TRRY EQU   RTM2PGCY
RTM2EEDR EQU   RTM2TRRY
RTM2EREG EQU   RTM2EEDR
RTM2APSW EQU   RTM2EEDR+64
RTM2EPSW EQU   RTM2APSW
RTM2EMK1 EQU   RTM2EPSW
RTM2MWP1 EQU   RTM2EPSW+1
RTM2INT1 EQU   RTM2EPSW+2
RTM2NXT1 EQU   RTM2EPSW+4
RTM2AEC1 EQU   RTM2APSW+8
RTM2ILC1 EQU   RTM2AEC1+1
RTM2INC1 EQU   RTM2AEC1+2
RTM2ICD1 EQU   RTM2INC1+1
RTM2EEDH EQU   RTM2TRRY+92
RTM2STCK EQU   RTM2EEDH
RTM2MCHI EQU   RTM2EEDH+8
RTM2MCHS EQU   RTM2MCHI
RTM2MCHD EQU   RTM2MCHI+1
RTM2RSR1 EQU   RTM2EEDH+12
RTM2RSR2 EQU   RTM2EEDH+13
RTM2FLGS EQU   RTM2TRRY+120
RTM2ERRA EQU   RTM2FLGS
RTM2MCHK EQU   RTM2ERRA
RTM2PCHK EQU   RTM2ERRA
RTM2RKEY EQU   RTM2ERRA
RTM2SVCD EQU   RTM2ERRA
RTM2ABTM EQU   RTM2ERRA
RTM2SVCE EQU   RTM2ERRA
RTM2PGIO EQU   RTM2ERRA
RTM2ERRB EQU   RTM2FLGS+1
RTM2TYP1 EQU   RTM2ERRB
RTM2ENRB EQU   RTM2ERRB
RTM2LDIS EQU   RTM2ERRB
RTM2SRBM EQU   RTM2ERRB
RTM2ERRC EQU   RTM2FLGS+2
RTM2ERRD EQU   RTM2FLGS+3
RTM2CTS  EQU   RTM2ERRD
RTM2MABD EQU   RTM2ERRD
RTM2RPIV EQU   RTM2ERRD
RTM2MCIV EQU   RTM2ERRD
RTM2ERFL EQU   RTM2ERRD
RTM2FMID EQU   RTM2TRRY+124
RTM2CVER EQU   RTM2WA+186
RTM2TRRC EQU   RTM2CVER
RTM2IOFS EQU   RTM2TRRC
RTM2IOBP EQU   RTM2TRRC+2
RTM2SCBS EQU   RTM2TRRC+14
RTM2SCBC EQU   RTM2SCBS
RTM2SCBN EQU   RTM2SCBS+4
RTM2SCBO EQU   RTM2SCBS+8
RTM2RTCD EQU   RTM2TRRC+26
RTM2SPLL EQU   RTM2RTCD+4
RTM2PARQ EQU   RTM2TRRC+46
RTM2CTL1 EQU   RTM2CVER+50
RTM2CMKA EQU   RTM2CTL1
RTM2MWPA EQU   RTM2CTL1+1
RTM2PMKA EQU   RTM2CTL1+4
RTM2CTL2 EQU   RTM2CVER+58
RTM2CMKP EQU   RTM2CTL2
RTM2MWPP EQU   RTM2CTL2+1
RTM2PMKP EQU   RTM2CTL2+4
RTM2SNAP EQU   RTM2CVER+66
RTM2SPRM EQU   RTM2SNAP+4
RTM2DPSL EQU   RTM2SNAP+24
RTM2FRM1 EQU   RTM2DPSL
RTM2TO1  EQU   RTM2DPSL+4
RTM2FRM2 EQU   RTM2DPSL+8
RTM2TO2  EQU   RTM2DPSL+12
RTM2FRM3 EQU   RTM2DPSL+16
RTM2TO3  EQU   RTM2DPSL+20
RTM2FRM4 EQU   RTM2DPSL+24
RTM2TO4  EQU   RTM2DPSL+28
RTM2SECB EQU   RTM2CVER+138
RTM2ECBA EQU   RTM2SECB
RTM2ECBS EQU   RTM2SECB+16
RTM2SPWA EQU   RTM2CVER+174
RTM2PREV EQU   RTM2CVER+178
RTM2SFRG EQU   RTM2CVER+186
RTM2SFSA EQU   RTM2SFRG
RTM2SCTL EQU   RTM2CVER+259
RTM2CCTL EQU   RTM2SCTL
RTM2STPT EQU   RTM2CCTL
RTM2SQS  EQU   RTM2CCTL
RTM2ISPC EQU   RTM2CCTL
RTM2REED EQU   RTM2CCTL
RTM2HEED EQU   RTM2CCTL
RTM2DEND EQU   RTM2CCTL+1
RTM2NODP EQU   RTM2CCTL+1
RTM2ABDR EQU   RTM2SCTL+4
RTM2ABID EQU   RTM2ABDR
RTM2ABND EQU   RTM2ABDR+1
RTM2RCTL EQU   RTM2SCTL+6
RTM2INTF EQU   RTM2CVER+266
RTM2CTLR EQU   RTM2INTF
RTM2RECR EQU   RTM2CTLR
RTM2WRAP EQU   RTM2CTLR
RTM2TSKT EQU   RTM2INTF+2
RTM2PURG EQU   RTM2TSKT
RTM2ABDP EQU   RTM2INTF+4
RTM2ASIR EQU   RTM2INTF+5
RTM2FLX  EQU   RTM2INTF+6
RTM2FLX1 EQU   RTM2FLX
RTM2FLX2 EQU   RTM2FLX+1
RTM2RCRX EQU   RTM2FLX2
RTM2RECL EQU   RTM2CVER+274
RTM2SCTC EQU   RTM2RECL
RTM2SCTR EQU   RTM2RECL+4
RTM2DCTL EQU   RTM2RECL+12
RTM2ECTL EQU   RTM2RECL+13
RTM2TRYR EQU   RTM2RECL+16
RTM2TRF1 EQU   RTM2TRYR
RTM2TRF2 EQU   RTM2TRYR+2
RTM2TREC EQU   RTM2TRF2
RTM2RECH EQU   RTM2CVER+294
RTM2STRA EQU   RTM2RECH+8
RTM2CTRA EQU   RTM2RECH+12
RTM2RRG  EQU   RTM2CVER+314
RTM2CRG  EQU   RTM2CVER+378
RTM2CREG EQU   RTM2CRG
RTM2RMIN EQU   RTM2WA+708
RTM2RMPS EQU   RTM2RMIN
RTM2RMPL EQU   RTM2RMIN+4
RTM2RMWA EQU   RTM2RMIN+28
RTM2RMWS EQU   RTM2RMWA
RTM2RMSA EQU   RTM2RMIN+92
RTM2ERID EQU   RTM2WA+872
RTM2SEQ# EQU   RTM2ERID
RTM2CPUI EQU   RTM2ERID+2
RTM2ERAS EQU   RTM2ERID+4
RTM2ERTM EQU   RTM2ERID+6
RTM2ENSN EQU   RTM2WA+884
RTM2SNLN EQU   RTM2ENSN
RTM2TRLN EQU   RTM2SNLN
RTM2TRTB EQU   RTM2ENSN+4
RTM2TRCU EQU   RTM2ENSN+8
RTM2TRFS EQU   RTM2ENSN+12
RTM2TRLS EQU   RTM2ENSN+16
RTM2RYRG EQU   RTM2WA+904
RTM2TECB EQU   RTM2RYRG+64
STORAGE  EQU   0
STORFRM  EQU   STORAGE
STORTO   EQU   STORAGE+4
STORBTO  EQU   STORTO
RTM2ESA  EQU   0
ESAREGS  EQU   RTM2ESA
ESAR0    EQU   ESAREGS
ESAR1    EQU   ESAREGS+4
ESACCF1  EQU   ESAR1
ESAEOM1  EQU   ESACCF1
ESAEOT1  EQU   ESACCF1
ESACC1   EQU   ESAR1+1
ESAR3    EQU   ESAREGS+8
ESAR4    EQU   ESAREGS+12
ESAR5    EQU   ESAREGS+16
ESAR7    EQU   ESAREGS+20
ESAR14   EQU   ESAREGS+24
ESAEEDQ  EQU   RTM2ESA+28
ESART2WA EQU   RTM2ESA+32
ESART2D  EQU   RTM2ESA+36
ESAWSPID EQU   ESART2D
ESAWLEN  EQU   ESART2D+1
ESAFLAGS EQU   RTM2ESA+40
ESARTM2  EQU   ESAFLAGS
ESAABTRM EQU   ESAFLAGS
ESAPGNLY EQU   ESAFLAGS
ESACTS   EQU   ESAFLAGS
ESANEOT  EQU   ESAFLAGS
ESAVEOM  EQU   ESAFLAGS
ESARFLAG EQU   RTM2ESA+41
ESAGMREC EQU   ESARFLAG
ESASDREC EQU   ESARFLAG
ESAINREC EQU   ESARFLAG
ESAGLREC EQU   ESARFLAG
ESAFERR  EQU   ESARFLAG
ESASLIPR EQU   ESARFLAG
ESAERTYP EQU   RTM2ESA+42
ESAMODE  EQU   RTM2ESA+43
ESACMP   EQU   RTM2ESA+44
ESACCF   EQU   ESACMP
ESACC    EQU   ESACMP+1
RTCT     EQU   0
RTCTPLIB EQU   RTCT+4
RTCTSAP  EQU   RTCTPLIB
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSAP3 EQU   RTCTSAP+2
RTCTSUP  EQU   RTCTPLIB+4
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSUP3 EQU   RTCTSUP+2
RTCTSYD  EQU   RTCTPLIB+8
RTCTSY01 EQU   RTCTSYD
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTSDPL EQU   RTCT+156
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
RTCTOPT  EQU   RTCT+236
RTCTASO  EQU   RTCT+252
RTCTASO1 EQU   RTCTASO
RTCTASO2 EQU   RTCTASO+1
RTCTSDI  EQU   RTCT+254
RTCTSDF  EQU   RTCT+264
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTSDF3 EQU   RTCT+268
RTCTSDF4 EQU   RTCTSDF3+2
RTCTMOPT EQU   0
RTCTMSAO EQU   RTCTMOPT
RTCTSASD EQU   RTCTMSAO
RTCTSAO1 EQU   RTCTSASD
RTCTSAO2 EQU   RTCTSASD+1
RTCTSAPD EQU   RTCTMSAO+2
RTCTSAO3 EQU   RTCTSAPD
RTCTSAO4 EQU   RTCTSAPD+1
RTCTSAMG EQU   RTCTSAO4
RTCTMSUO EQU   RTCTMOPT+4
RTCTSUSD EQU   RTCTMSUO
RTCTSUO1 EQU   RTCTSUSD
RTCTSUO2 EQU   RTCTSUSD+1
RTCTSUPD EQU   RTCTMSUO+2
RTCTSUO3 EQU   RTCTSUPD
RTCTSUO4 EQU   RTCTSUPD+1
RTCTSUMG EQU   RTCTSUO4
RTCTMSYO EQU   RTCTMOPT+8
RTCTSD01 EQU   RTCTMSYO
RTCTSD04 EQU   RTCTMSYO+3
RTCTSMMG EQU   RTCTSD04
RTCTMSDO EQU   RTCTMOPT+12
RTCTSDOD EQU   RTCTMSDO
RTCTSDO1 EQU   RTCTSDOD
RTCTSDO2 EQU   RTCTSDOD+1
RTCTSDO3 EQU   RTCTMSDO+2
RTCTSDO4 EQU   RTCTMSDO+3
RTCTSDMG EQU   RTCTSDO4
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTABEND EQU   CVTMAP+200
CVTUSER  EQU   CVTMAP+204
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTTZ    EQU   CVTMAP+304
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SCVTSECT EQU   0
SCVTSTAT EQU   SCVTSECT+148
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBABNT EQU   ASCBFLG1
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBRTWA EQU   ASCB+164
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ASXB     EQU   0
ASXBSPSA EQU   ASXB+112
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBCMPC  EQU   TCBCMP+1
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFA    EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBFX    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBABTRM EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBJSTCA EQU   TCBJSTCB+1
TCBOTC   EQU   TCB+132
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBSTABB EQU   TCBSTAB+1
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBRTWA  EQU   TCB+224
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBRTM12 EQU   TCB+260
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBERTYP EQU   TCBESTAE+2
TCBMODE  EQU   TCBESTAE+3
TCBFBYT1 EQU   TCB+276
TCBPGNLY EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBFBYT2 EQU   TCB+277
TCBFDW   EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBEXSAVE EQU   XRBESA
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW1 EQU   RBRTOPSW
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBRTILC  EQU   RBRTICIL+1
RBRTINCD EQU   RBRTICIL+2
RBFLAGS1 EQU   RBPREFIX+56
RBABEND  EQU   RBFLAGS1
RBWCSA   EQU   RBPREFIX+60
RBINTCDA EQU   RBPREFIX+61
RBINLNTH EQU   RBINTCDA
RBINTCOD EQU   RBINTCDA+1
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00127 EQU   RBSECT+10
@NM00128 EQU   @NM00127
RBTRSVRB EQU   @NM00128
@NM00130 EQU   @NM00127+1
RBETXR   EQU   @NM00130
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00137 EQU   RBSECT+28
@NM00138 EQU   @NM00137
IRBEND   EQU   RBSECT+96
@NM00141 EQU   RBSECT+96
RBRSV138 EQU   @NM00141+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
GDA      EQU   0
GVSMFLAG EQU   GDA
GDAFLAGS EQU   GVSMFLAG
PASTRT   EQU   GDA+16
PASIZE   EQU   GDA+20
VRPOSTQ  EQU   GDA+32
VRWAITQ  EQU   GDA+40
WSAL     EQU   0
WSALSTAE EQU   WSAL+44
RTMBRTAB EQU   0
RTMBTERM EQU   RTMBRTAB
MODEBYTE EQU   0
MODESUPR EQU   MODEBYTE
MODEDIS  EQU   MODEBYTE
MODEGSPN EQU   MODEBYTE
MODEGSUS EQU   MODEBYTE
MODELOC  EQU   MODEBYTE
MODETYP1 EQU   MODEBYTE
MODESRB  EQU   MODEBYTE
MODETCB  EQU   MODEBYTE
EED      EQU   0
EEDFWRDP EQU   EED
EEDDES   EQU   EED+4
EEDID    EQU   EEDDES
EEDFLAGS EQU   EEDDES+1
EEDERFL  EQU   EEDFLAGS
EEDNODMP EQU   EEDFLAGS
EEDERROR EQU   EED+8
EEDASID  EQU   EEDERROR+2
EEDVARBL EQU   EED+12
SCB      EQU   0
SCBPARM  EQU   SCB+8
SCBFLGS1 EQU   SCBPARM
SCBIOPRC EQU   SCBFLGS1
SCBOWNR  EQU   SCB+12
SCBFLGS2 EQU   SCBOWNR
SCBDATA  EQU   SCB+16
SCBFLGS3 EQU   SCBDATA
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTTRACE EQU   CVTS01+52
CVTFRECL EQU   CVTS01+148
CVTGDA   EQU   CVTS01+212
CVTRTMCT EQU   CVTS01+224
CVTRTMS  EQU   CVTS01+244
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
SCVTSPTR EQU   CVTABEND
ASCBPTR  EQU   ESAR7
ASXBPTR  EQU   ASCBASXB
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
GDAPTR   EQU   CVTGDA
EEDREGSP EQU   EEDVARBL
EEDREGS  EQU   EEDREGSP
EEDPSW   EQU   EEDREGSP+64
EEDPSW1  EQU   EEDPSW
EEDPSW2  EQU   EEDPSW+8
EEDINILC EQU   EEDPSW2
EEDDUMPO EQU   EEDVARBL
EEDSCDMP EQU   EEDDUMPO
EEDSDUMP EQU   EEDSCDMP
EEDSDDAT EQU   EEDSCDMP+4
EEDSSDAT EQU   EEDSDDAT
EEDSPDAT EQU   EEDSDDAT+2
EEDSDPSL EQU   EEDDUMPO+8
EEDHWREP EQU   EEDVARBL
EEDHMCHS EQU   EEDHWREP+8
EEDHMCHD EQU   EEDHWREP+9
EEDHRSRS EQU   EEDHWREP+12
EEDHRSR1 EQU   EEDHRSRS
EEDHRSR2 EQU   EEDHRSRS+1
EEDERMAP EQU   EEDVARBL
EEDERRID EQU   EEDERMAP+70
SCBPTR   EQU   RTM2SCBN
WSAVTPTR EQU   ASXBSPSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
EEDETIME EQU   EEDERRID+6
EEDEASID EQU   EEDERRID+4
EEDECPUI EQU   EEDERRID+2
EEDESEQ# EQU   EEDERRID
@NM00151 EQU   EEDERMAP
EEDHTIME EQU   EEDHWREP+20
EEDHRFSA EQU   EEDHWREP+16
@NM00150 EQU   EEDHWREP+14
EEDHVERQ EQU   EEDHRSR2
EEDHPGFX EQU   EEDHRSR2
EEDHFLSQ EQU   EEDHRSR2
EEDHFSQA EQU   EEDHRSR2
EEDHNUCL EQU   EEDHRSR2
EEDHSPER EQU   EEDHRSR2
EEDHINTC EQU   EEDHRSR2
EEDHOFLN EQU   EEDHRSR2
EEDHCHNG EQU   EEDHRSR1
EEDHMSER EQU   EEDHRSR1
@NM00149 EQU   EEDHRSR1
EEDHCPID EQU   EEDHWREP+10
EEDHTERR EQU   EEDHMCHD
EEDHSOFT EQU   EEDHMCHD
EEDHINSF EQU   EEDHMCHD
EEDHACR  EQU   EEDHMCHD
EEDHSCK  EQU   EEDHMCHD
EEDHPSWU EQU   EEDHMCHD
EEDHREGU EQU   EEDHMCHD
EEDHSKYF EQU   EEDHMCHD
@NM00148 EQU   EEDHMCHS
@NM00147 EQU   EEDHMCHS
EEDHRSRF EQU   EEDHMCHS
EEDRSRC  EQU   EEDHMCHS
EEDINVP  EQU   EEDHMCHS
EEDHTSVL EQU   EEDHMCHS
EEDHRCDF EQU   EEDHMCHS
EEDHSRVL EQU   EEDHMCHS
EEDHSCKE EQU   EEDHWREP+4
EEDHSCKB EQU   EEDHWREP
EEDTRANS EQU   EEDPSW2+4
EEDINTCD EQU   EEDINILC+2
EEDILC   EQU   EEDINILC+1
@NM00146 EQU   EEDINILC
EEDPSWIC EQU   EEDPSW1+4
EEDPSWMK EQU   EEDPSW1
EEDREG15 EQU   EEDREGS+60
EEDREG14 EQU   EEDREGS+56
EEDREG13 EQU   EEDREGS+52
EEDREG12 EQU   EEDREGS+48
EEDREG11 EQU   EEDREGS+44
EEDREG10 EQU   EEDREGS+40
EEDREG9  EQU   EEDREGS+36
EEDREG8  EQU   EEDREGS+32
EEDREG7  EQU   EEDREGS+28
EEDREG6  EQU   EEDREGS+24
EEDREG5  EQU   EEDREGS+20
EEDREG4  EQU   EEDREGS+16
EEDREG3  EQU   EEDREGS+12
EEDREG2  EQU   EEDREGS+8
EEDREG1  EQU   EEDREGS+4
EEDREG0  EQU   EEDREGS
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00142 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
SCBRSVRE EQU   SCBDATA+3
SCBID    EQU   SCBDATA+2
SCBPKEY  EQU   SCBDATA+1
@NM00158 EQU   SCBFLGS3
SCBTERMO EQU   SCBFLGS3
SCBBRNTR EQU   SCBFLGS3
SCBPRNTR EQU   SCBFLGS3
SCBCNCEL EQU   SCBFLGS3
SCBRECRD EQU   SCBFLGS3
SCBTERMI EQU   SCBFLGS3
@NM00157 EQU   SCBFLGS3
SCBOWNRA EQU   SCBOWNR+1
SCBSUPER EQU   SCBFLGS2
SCBKEY0  EQU   SCBFLGS2
@NM00156 EQU   SCBFLGS2
@NM00155 EQU   SCBFLGS2
SCBINUSE EQU   SCBFLGS2
@NM00154 EQU   SCBFLGS2
SCBXCTL2 EQU   SCBFLGS2
@NM00153 EQU   SCBFLGS2
SCBPARMA EQU   SCBPARM+1
SCBHALT  EQU   SCBIOPRC
SCBNOIOP EQU   SCBIOPRC
SCBASYNC EQU   SCBFLGS1
@NM00152 EQU   SCBFLGS1
SCBESTAE EQU   SCBFLGS1
SCBDUMMY EQU   SCBFLGS1
SCBSTAR  EQU   SCBFLGS1
SCBSTAI  EQU   SCBFLGS1
SCBEXIT  EQU   SCB+4
SCBCHAIN EQU   SCB
EEDERTYP EQU   EEDERROR+1
EEDMODE  EQU   EEDERROR
@NM00145 EQU   EEDDES+2
@NM00144 EQU   EEDFLAGS
RTMBXABT EQU   RTMBRTAB+44
RTMBACR  EQU   RTMBRTAB+40
RTMBPROG EQU   RTMBRTAB+36
RTMBMEMT EQU   RTMBRTAB+32
RTMBCABT EQU   RTMBRTAB+28
RTMBPGIO EQU   RTMBRTAB+24
RTMBSVC  EQU   RTMBRTAB+20
RTMBMACH EQU   RTMBRTAB+16
RTMBREST EQU   RTMBRTAB+12
RTMBDAT  EQU   RTMBRTAB+8
RTMBPAD2 EQU   RTMBTERM+6
RTMBBRAN EQU   RTMBTERM+2
RTMBBALR EQU   RTMBTERM
WSALACHP EQU   WSAL+56
WSALRSM  EQU   WSAL+52
WSALEVNT EQU   WSAL+48
WSALSTAT EQU   WSAL+40
WSALWAIT EQU   WSAL+36
WSALPOST EQU   WSAL+32
WSALEXIT EQU   WSAL+28
WSALS2EE EQU   WSAL+24
WSALCIRB EQU   WSAL+20
WSALABTM EQU   WSAL+16
WSALSDMP EQU   WSAL+12
WSALRTM2 EQU   WSAL+8
WSALVALC EQU   WSAL+4
WSALCWSA EQU   WSAL
GBLCELCT EQU   GDA+60
GLBLCELL EQU   GDA+56
CSASPQEP EQU   GDA+52
PFSTCPAB EQU   GDA+48
VRWLEL   EQU   VRWAITQ+4
VRWFEL   EQU   VRWAITQ
VRPLEL   EQU   VRPOSTQ+4
VRPFEL   EQU   VRPOSTQ
SQASPLFT EQU   GDA+28
SQASPQEP EQU   GDA+24
VRPQEP   EQU   GDA+12
CSAPQEP  EQU   GDA+8
VRDREG   EQU   GDA+4
RESV     EQU   GVSMFLAG+1
@NM00143 EQU   GDAFLAGS
WAITQUE  EQU   GDAFLAGS
SQATHRS2 EQU   GDAFLAGS
SQATHRS1 EQU   GDAFLAGS
GDAFLAG2 EQU   GDAFLAGS
NIPFOURK EQU   GDAFLAGS
GDAFLAG1 EQU   GDAFLAGS
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00141+8
PRBEND   EQU   @NM00141+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00141+6
RBRSV136 EQU   @NM00141+4
RBRSV135 EQU   @NM00141
@NM00140 EQU   RBSECT+32
@NM00139 EQU   @NM00137+1
RBSCF    EQU   @NM00138
RBPGMQ1  EQU   RBPGMQ+1
@NM00136 EQU   RBPGMQ
@NM00135 EQU   RBSECT+16
@NM00134 EQU   @NM00130
@NM00133 EQU   @NM00130
RBIQETP  EQU   @NM00130
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00130
@NM00132 EQU   @NM00130
@NM00131 EQU   @NM00130
RBPMSVRB EQU   @NM00128
RBATNXIT EQU   @NM00128
@NM00129 EQU   @NM00128
RBWAITP  EQU   @NM00128
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00128
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00126 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRSV160 EQU   RBRTICIL
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00125 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00124 EQU   RBOPSWB2
@NM00123 EQU   XRBPSW
@NM00122 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00121 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00120 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00119 EQU   XSTAB1
@NM00118 EQU   RBBASIC+8
@NM00117 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00116 EQU   RBPRFX
@NM00115 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00114 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00113 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBNTC   EQU   TCB+128
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFS    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00112 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00111 EQU   SCVTSECT+180
@NM00110 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00109 EQU   SCVTSECT+168
SCVTPTRM EQU   SCVTSECT+164
@NM00108 EQU   SCVTSECT+160
@NM00107 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
@NM00106 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00105 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00104 EQU   SCVTSECT+128
@NM00103 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00102 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00101 EQU   SCVTSECT+108
@NM00100 EQU   SCVTSECT+104
@NM00099 EQU   SCVTSECT+100
@NM00098 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00097 EQU   SCVTSECT+88
@NM00096 EQU   SCVTSECT+84
@NM00095 EQU   SCVTSECT+80
@NM00094 EQU   SCVTSECT+76
@NM00093 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00092 EQU   SCVTSECT+56
@NM00091 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00090 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00089 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00088 EQU   SCVTSECT+24
@NM00087 EQU   SCVTSECT+20
@NM00086 EQU   SCVTSECT+16
@NM00085 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SCVTPGWR EQU   SCVTSECT+4
SCVTPGTM EQU   SCVTSECT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00084 EQU   CVTFIX+248
@NM00083 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
RTCTISVC EQU   RTCTSDO4
RTCTSDOV EQU   RTCTSDMG
@NM00058 EQU   RTCTSDO4
@NM00057 EQU   RTCTSDO3
RTCTSDPH EQU   RTCTSDO3
RTCTSDPG EQU   RTCTSDO3
@NM00056 EQU   RTCTSDO2
RTCTSDPD EQU   RTCTSDO2
RTCTSDPC EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTISYM EQU   RTCTSD04
RTCTSMOV EQU   RTCTSMMG
@NM00055 EQU   RTCTSD04
RTCTSD03 EQU   RTCTMSYO+2
RTCTSD02 EQU   RTCTMSYO+1
RTCTSDS7 EQU   RTCTSD01
RTCTSDS6 EQU   RTCTSD01
RTCTSDS5 EQU   RTCTSD01
RTCTSDS4 EQU   RTCTSD01
RTCTSDS3 EQU   RTCTSD01
RTCTSDS2 EQU   RTCTSD01
RTCTSDS1 EQU   RTCTSD01
RTCTSDS0 EQU   RTCTSD01
RTCTISYU EQU   RTCTSUO4
RTCTSUOV EQU   RTCTSUMG
@NM00054 EQU   RTCTSUO4
RTCTSYDF EQU   RTCTSUO3
RTCTSYDE EQU   RTCTSUO3
RTCTSYDD EQU   RTCTSUO3
RTCTSYDC EQU   RTCTSUO3
RTCTSYDB EQU   RTCTSUO3
RTCTSYDA EQU   RTCTSUO3
RTCTSYD9 EQU   RTCTSUO3
RTCTSYD8 EQU   RTCTSUO3
@NM00053 EQU   RTCTSUO2
RTCTSYDH EQU   RTCTSUO2
RTCTSYDG EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTISAB EQU   RTCTSAO4
RTCTSAOV EQU   RTCTSAMG
@NM00052 EQU   RTCTSAO4
RTCTSADF EQU   RTCTSAO3
RTCTSADE EQU   RTCTSAO3
RTCTSADD EQU   RTCTSAO3
RTCTSADC EQU   RTCTSAO3
RTCTSADB EQU   RTCTSAO3
RTCTSADA EQU   RTCTSAO3
RTCTSAD9 EQU   RTCTSAO3
RTCTSAD8 EQU   RTCTSAO3
@NM00051 EQU   RTCTSAO2
RTCTSADH EQU   RTCTSAO2
RTCTSADG EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTZZZ5 EQU   RTCT+340
RTCTZZZ4 EQU   RTCT+336
RTCTMRMQ EQU   RTCT+332
RTCTSDF5 EQU   RTCTSDF3+3
RTCTSDDO EQU   RTCTSDF4
RTCTSDEN EQU   RTCTSDF4
RTCTSDEQ EQU   RTCTSDF4
RTCTSDTR EQU   RTCTSDF4
RTCTSDRM EQU   RTCTSDF4
RTCTSDAN EQU   RTCTSDF4
RTCTSDNC EQU   RTCTSDF4
RTCTSDSS EQU   RTCTSDF4
RTCTSDAS EQU   RTCTSDF3
RTCTZZZ3 EQU   RTCT+266
@NM00050 EQU   RTCTSDF2
RTCTSDRW EQU   RTCTSDF2
RTCTSDSL EQU   RTCTSDF2
RTCTSDWF EQU   RTCTSDF2
RTCTSDLA EQU   RTCTSDF2
RTCTSDDI EQU   RTCTSDF2
RTCTSDTQ EQU   RTCTSDF2
RTCTSDMR EQU   RTCTSDF2
RTCTSDSC EQU   RTCTSDF1
RTCTSDRS EQU   RTCTSDF1
RTCTSDSD EQU   RTCTSDF1
RTCTSDEP EQU   RTCTSDF1
RTCTSDMA EQU   RTCTSDF1
RTCTSDSH EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
RTCTZZZ2 EQU   RTCT+257
RTCTSDPR EQU   RTCTSDI+2
RTCTINDX EQU   RTCTSDI+1
RTCTSDNA EQU   RTCTSDI
@NM00049 EQU   RTCTASO2
RTCTASNQ EQU   RTCTASO2
RTCTASNA EQU   RTCTASO2
RTCTASNS EQU   RTCTASO2
RTCTASSU EQU   RTCTASO2
RTCTASSW EQU   RTCTASO2
RTCTASCS EQU   RTCTASO2
RTCTASTR EQU   RTCTASO1
RTCTASLP EQU   RTCTASO1
RTCTASRG EQU   RTCTASO1
RTCTASLS EQU   RTCTASO1
RTCTASSQ EQU   RTCTASO1
RTCTASNU EQU   RTCTASO1
RTCTASPS EQU   RTCTASO1
RTCTASAL EQU   RTCTASO1
RTCTSDO  EQU   RTCTOPT+12
RTCTSYO  EQU   RTCTOPT+8
RTCTSUO  EQU   RTCTOPT+4
RTCTSAO  EQU   RTCTOPT
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTSDSW EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00048 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDIP EQU   RTCTSDPL
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
@NM00047 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRCB  EQU   RTCT+32
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTYYY1 EQU   RTCT+16
RTCTSY04 EQU   RTCTSYD+3
RTCTSY03 EQU   RTCTSYD+2
RTCTSY02 EQU   RTCTSYD+1
RTCTSYM7 EQU   RTCTSY01
RTCTSYM6 EQU   RTCTSY01
RTCTSYM5 EQU   RTCTSY01
RTCTSYM4 EQU   RTCTSY01
RTCTSYM3 EQU   RTCTSY01
RTCTSYM2 EQU   RTCTSY01
RTCTSYM1 EQU   RTCTSY01
RTCTSYM0 EQU   RTCTSY01
RTCTSUP4 EQU   RTCTSUP+3
RTCTSUDF EQU   RTCTSUP3
RTCTSUDE EQU   RTCTSUP3
RTCTSUDD EQU   RTCTSUP3
RTCTSUDC EQU   RTCTSUP3
RTCTSUDB EQU   RTCTSUP3
RTCTSUDA EQU   RTCTSUP3
RTCTSUD9 EQU   RTCTSUP3
RTCTSUD8 EQU   RTCTSUP3
@NM00046 EQU   RTCTSUP2
RTCTSUDH EQU   RTCTSUP2
RTCTSUDG EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSAP4 EQU   RTCTSAP+3
RTCTSABF EQU   RTCTSAP3
RTCTSABE EQU   RTCTSAP3
RTCTSABD EQU   RTCTSAP3
RTCTSABC EQU   RTCTSAP3
RTCTSABB EQU   RTCTSAP3
RTCTSABA EQU   RTCTSAP3
RTCTSAB9 EQU   RTCTSAP3
RTCTSAB8 EQU   RTCTSAP3
@NM00045 EQU   RTCTSAP2
RTCTSABH EQU   RTCTSAP2
RTCTSABG EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
@NM00044 EQU   ESACCF
ESAASID  EQU   ESACCF
ESANOCC  EQU   ESACCF
ESAR0DP  EQU   ESACCF
ESASTEP  EQU   ESACCF
ESADREQ  EQU   ESACCF
@NM00043 EQU   ESARFLAG
ESARTCR  EQU   ESARFLAG
@NM00042 EQU   ESAFLAGS
ESAEOT   EQU   ESAFLAGS
@NM00041 EQU   ESACCF1
ESAR0DP1 EQU   ESACCF1
ESASTEP1 EQU   ESACCF1
ESADREQ1 EQU   ESACCF1
STORB    EQU   STORFRM
RTM2RYRS EQU   RTM2RYRG
@NM00040 EQU   RTM2WA+882
RTM2TRSA EQU   RTM2CVER+450
RTM2RREG EQU   RTM2RRG
RTM2RBRG EQU   RTM2CVER+313
RTM2WARG EQU   RTM2CVER+312
@NM00039 EQU   RTM2CVER+310
RTM2SKRA EQU   RTM2RECH+4
RTM2TRRA EQU   RTM2RECH
@NM00038 EQU   RTM2TRYR+3
@NM00037 EQU   RTM2TRF2
RTM2GMR  EQU   RTM2TRF2
RTM2PPR  EQU   RTM2TRF2
RTM2IOR  EQU   RTM2TRF2
RTM2AS3R EQU   RTM2TRF1+1
RTM2AS2R EQU   RTM2TRF1+1
RTM2AS1R EQU   RTM2TRF1+1
RTM2XFLG EQU   RTM2TRF1+1
RTM2XABD EQU   RTM2TRF1+1
RTM2XIP  EQU   RTM2TRF1+1
RTM2RTYS EQU   RTM2TRF1+1
RTM2RCD  EQU   RTM2TRF1+1
RTM2FMS  EQU   RTM2TRF1
RTM2VLDY EQU   RTM2TRF1
RTM2HOOK EQU   RTM2TRF1
RTM2PPS  EQU   RTM2TRF1
RTM2GMS  EQU   RTM2TRF1
RTM2IORS EQU   RTM2TRF1
RTM2IOHS EQU   RTM2TRF1
RTM2IOQS EQU   RTM2TRF1
RTM2TMER EQU   RTM2RECL+14
RTM2EQMN EQU   RTM2ECTL
RTM2EDEQ EQU   RTM2ECTL
RTM2EFRM EQU   RTM2ECTL
RTM2ECLS EQU   RTM2ECTL
RTM2ESNP EQU   RTM2ECTL
RTM2EOPN EQU   RTM2ECTL
RTM2EGET EQU   RTM2ECTL
RTM2EENQ EQU   RTM2ECTL
RTM2DFTK EQU   RTM2DCTL
RTM2DDEQ EQU   RTM2DCTL
RTM2DFRM EQU   RTM2DCTL
RTM2DCLS EQU   RTM2DCTL
RTM2DSNP EQU   RTM2DCTL
RTM2DOPN EQU   RTM2DCTL
RTM2DGET EQU   RTM2DCTL
RTM2DENQ EQU   RTM2DCTL
RTM2SCTX EQU   RTM2RECL+8
@NM00036 EQU   RTM2FLX2
RTM2CERX EQU   RTM2FLX2
RTM2RTRX EQU   RTM2FLX1
RTM2LTX  EQU   RTM2FLX1
RTM2PRX  EQU   RTM2FLX1
RTM2CVX  EQU   RTM2FLX1
RTM2DWX  EQU   RTM2FLX1
RTM2ABX  EQU   RTM2FLX1
RTM2EOTX EQU   RTM2FLX1
RTM2MTX  EQU   RTM2FLX1
@NM00035 EQU   RTM2ASIR
RTM2UPRG EQU   RTM2ASIR
RTM2TRME EQU   RTM2ASIR
@NM00034 EQU   RTM2ABDP
RTM2SMDP EQU   RTM2ABDP
RTM2DMP1 EQU   RTM2ABDP
RTM2MEMT EQU   RTM2INTF+3
@NM00033 EQU   RTM2TSKT
@NM00032 EQU   RTM2INTF+1
@NM00031 EQU   RTM2CTLR
RTM2TMEM EQU   RTM2CTLR
RTM2RETR EQU   RTM2CTLR
@NM00030 EQU   RTM2RCTL
RTM2JPAQ EQU   RTM2RCTL
RTM2LPAQ EQU   RTM2RCTL
RTM2BFTL EQU   RTM2RCTL
RTM2TRSW EQU   RTM2RCTL
RTM2WANA EQU   RTM2RCTL
RTM2WAIN EQU   RTM2RCTL
RTM2STA2 EQU   RTM2RCTL
RTM2STAT EQU   RTM2ABND
RTM2NDMP EQU   RTM2ABND
@NM00029 EQU   RTM2ABID
RTM2OERR EQU   RTM2ABID
RTM2SAV2 EQU   RTM2ABID
RTM2SAVE EQU   RTM2ABID
RTM2REG  EQU   RTM2ABID
RTM2PSW  EQU   RTM2ABID
RTM2ENQ  EQU   RTM2ABID
RTM2CB   EQU   RTM2ABID
RTM2MCTL EQU   RTM2SCTL+3
RTM2TCTL EQU   RTM2SCTL+2
@NM00028 EQU   RTM2CCTL+1
RTM2RGEB EQU   RTM2CCTL+1
RTM2RSCN EQU   RTM2CCTL+1
RTM2CONT EQU   RTM2CCTL
RTM2SLIP EQU   RTM2CCTL
RTM2CNCL EQU   RTM2CCTL
RTM2PKEY EQU   RTM2CVER+258
RTM2PRWA EQU   RTM2CVER+182
RTM2DCBA EQU   RTM2CVER+170
RTM2LECB EQU   RTM2ECBA
RTM2DTCB EQU   RTM2SNAP+68
RTM2SNCC EQU   RTM2SNAP+64
RTM2DD   EQU   RTM2SNAP+56
RTM2LTO4 EQU   RTM2TO4
RTM2LFR4 EQU   RTM2FRM4
RTM2LTO3 EQU   RTM2TO3
RTM2LFR3 EQU   RTM2FRM3
RTM2LTO2 EQU   RTM2TO2
RTM2LFR2 EQU   RTM2FRM2
RTM2LTO1 EQU   RTM2TO1
RTM2LFR1 EQU   RTM2FRM1
RTM2DPLA EQU   RTM2SNAP
RTM2NXTP EQU   RTM2CTL2+5
RTM2SGP  EQU   RTM2PMKP
RTM2EUP  EQU   RTM2PMKP
RTM2DOP  EQU   RTM2PMKP
RTM2FPP  EQU   RTM2PMKP
RTM2CCP  EQU   RTM2PMKP
RTM2ILP  EQU   RTM2PMKP
RTM2INTP EQU   RTM2CTL2+2
RTM2SPVP EQU   RTM2MWPP
RTM2WATP EQU   RTM2MWPP
RTM2MCKP EQU   RTM2MWPP
@NM00027 EQU   RTM2MWPP
RTM2KEYP EQU   RTM2MWPP
RTM2EXTP EQU   RTM2CMKP
RTM2IOP  EQU   RTM2CMKP
RTM2NXTA EQU   RTM2CTL1+5
RTM2SGA  EQU   RTM2PMKA
RTM2EUA  EQU   RTM2PMKA
RTM2DOA  EQU   RTM2PMKA
RTM2FPA  EQU   RTM2PMKA
RTM2CCA  EQU   RTM2PMKA
RTM2ILA  EQU   RTM2PMKA
RTM2INTA EQU   RTM2CTL1+2
RTM2SPVA EQU   RTM2MWPA
RTM2WATA EQU   RTM2MWPA
RTM2MCKA EQU   RTM2MWPA
@NM00026 EQU   RTM2MWPA
RTM2KEYA EQU   RTM2MWPA
RTM2EXTA EQU   RTM2CMKA
RTM2IOA  EQU   RTM2CMKA
@NM00025 EQU   RTM2PARQ+1
RTM2RCDE EQU   RTM2PARQ
RTM2RYRB EQU   RTM2TRRC+42
RTM2RTYA EQU   RTM2TRRC+38
RTM2COMP EQU   RTM2TRRC+34
RTM2SIZE EQU   RTM2SPLL+1
RTM2SUBP EQU   RTM2SPLL
RTM2RTCA EQU   RTM2RTCD
RTM2STAR EQU   RTM2TRRC+10
RTM2RBST EQU   RTM2TRRC+6
RTM2FIOB EQU   RTM2IOBP+1
@NM00024 EQU   RTM2IOBP
@NM00023 EQU   RTM2TRRC+1
@NM00022 EQU   RTM2IOFS
RTM2NIOP EQU   RTM2IOFS
RTM2NOIO EQU   RTM2IOFS
RTM2IOHT EQU   RTM2IOFS
RTM2IOQR EQU   RTM2IOFS
RTM2STAE EQU   RTM2ERRD
RTM2NRBE EQU   RTM2ERRD
RTM2CLUP EQU   RTM2ERRD
@NM00021 EQU   RTM2ERRC
RTM2EAS  EQU   RTM2ERRC
RTM2PERC EQU   RTM2ERRC
RTM2IRB  EQU   RTM2ERRC
RTM2STAI EQU   RTM2ERRC
RTM2STAF EQU   RTM2ERRC
@NM00020 EQU   RTM2ERRB
RTM2TEXC EQU   RTM2ERRA
RTM2TIME EQU   RTM2EEDH+20
RTM2RFSA EQU   RTM2EEDH+16
@NM00019 EQU   RTM2EEDH+14
RTM2VEQR EQU   RTM2RSR2
RTM2PGFX EQU   RTM2RSR2
RTM2FLSQ EQU   RTM2RSR2
RTM2FSQA EQU   RTM2RSR2
RTM2NUCL EQU   RTM2RSR2
RTM2SPER EQU   RTM2RSR2
RTM2INTC EQU   RTM2RSR2
RTM2OFLN EQU   RTM2RSR2
RTM2CHNG EQU   RTM2RSR1
RTM2MSER EQU   RTM2RSR1
@NM00018 EQU   RTM2RSR1
RTM2CPID EQU   RTM2EEDH+10
RTM2TERR EQU   RTM2MCHD
RTM2SOFT EQU   RTM2MCHD
RTM2INSF EQU   RTM2MCHD
RTM2ACR  EQU   RTM2MCHD
RTM2SCK  EQU   RTM2MCHD
RTM2PSWU EQU   RTM2MCHD
RTM2REGU EQU   RTM2MCHD
RTM2SKYF EQU   RTM2MCHD
@NM00017 EQU   RTM2MCHS
RTM2RSRF EQU   RTM2MCHS
RTM2RSRC EQU   RTM2MCHS
RTM2INVP EQU   RTM2MCHS
RTM2TSVL EQU   RTM2MCHS
RTM2RCDF EQU   RTM2MCHS
RTM2SRVL EQU   RTM2MCHS
RTM2SCKE EQU   RTM2STCK+4
RTM2SCKB EQU   RTM2STCK
RTM2ABEP EQU   RTM2TRRY+88
RTM2ABNM EQU   RTM2TRRY+80
RTM2TRAN EQU   RTM2AEC1+4
RTM2IPC1 EQU   RTM2ICD1
RTM2IMC1 EQU   RTM2ICD1
RTM2IPR1 EQU   RTM2ICD1
@NM00016 EQU   RTM2INC1
@NM00015 EQU   RTM2ILC1
RTM2IL1  EQU   RTM2ILC1
@NM00014 EQU   RTM2ILC1
@NM00013 EQU   RTM2AEC1
RTM2ADD1 EQU   RTM2NXT1+1
@NM00012 EQU   RTM2NXT1
@NM00011 EQU   RTM2EPSW+3
RTM2SGN1 EQU   RTM2INT1
RTM2EXP1 EQU   RTM2INT1
RTM2DEC1 EQU   RTM2INT1
RTM2FPO1 EQU   RTM2INT1
RTM2CC1  EQU   RTM2INT1
@NM00010 EQU   RTM2INT1
RTM2PGM1 EQU   RTM2MWP1
RTM2WAT1 EQU   RTM2MWP1
RTM2MCK1 EQU   RTM2MWP1
RTM2ECT1 EQU   RTM2MWP1
RTM2KEY1 EQU   RTM2MWP1
RTM2EXT1 EQU   RTM2EMK1
RTM2AIO1 EQU   RTM2EMK1
RTM2TRM1 EQU   RTM2EMK1
RTM2EAM1 EQU   RTM2EMK1
@NM00009 EQU   RTM2EMK1
RTM2PER1 EQU   RTM2EMK1
@NM00008 EQU   RTM2EMK1
RTM2ER15 EQU   RTM2EREG+60
RTM2ER14 EQU   RTM2EREG+56
RTM2ER13 EQU   RTM2EREG+52
RTM2ER12 EQU   RTM2EREG+48
RTM2ER11 EQU   RTM2EREG+44
RTM2ER10 EQU   RTM2EREG+40
RTM2ER9  EQU   RTM2EREG+36
RTM2ER8  EQU   RTM2EREG+32
RTM2ER7  EQU   RTM2EREG+28
RTM2ER6  EQU   RTM2EREG+24
RTM2ER5  EQU   RTM2EREG+20
RTM2ER4  EQU   RTM2EREG+16
RTM2ER3  EQU   RTM2EREG+12
RTM2ER2  EQU   RTM2EREG+8
RTM2ER1  EQU   RTM2EREG+4
RTM2ER0  EQU   RTM2EREG
RTM2SFWA EQU   RTM2WA+32
@NM00007 EQU   RTM2CCF
RTM2EOT  EQU   RTM2CCF
RTM2EOM  EQU   RTM2CCF
RTM2R0DP EQU   RTM2CCF
RTM2LGTH EQU   RTM2RT2D+1
RTM2SPID EQU   RTM2RT2D
RMPLDCBL EQU   RMPL+20
RMPLRBPA EQU   RMPL+12
RMPLFLG2 EQU   RMPL+1
@NM00006 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLIPUF EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
SNPHDRA  EQU   SNPPARMS+20
SNPTCBA  EQU   SNPPARMS+12
SNPDCB   EQU   SNPPARMS+8
@NM00005 EQU   SNPPARMS+7
@NM00004 EQU   SNPPDATA
SNPSPLS  EQU   SNPPDATA
SNPPSW   EQU   SNPPDATA
SNPJPA   EQU   SNPPDATA
SNPLPA   EQU   SNPPDATA
SNPREGS  EQU   SNPPDATA
SNPSAVE2 EQU   SNPPDATA
SNPSAVE  EQU   SNPPDATA
@NM00003 EQU   SNPSDAT1
SNPERR   EQU   SNPSDAT1
SNPIO    EQU   SNPSDAT1
SNPDM    EQU   SNPSDAT0
SNPQCB   EQU   SNPSDAT0
SNPCB    EQU   SNPSDAT0
SNPTRT   EQU   SNPSDAT0
SNPSWA   EQU   SNPSDAT0
SNPLSQA  EQU   SNPSDAT0
SNPSQA   EQU   SNPSDAT0
SNPNUC   EQU   SNPSDAT0
@NM00002 EQU   SNPPARMS+2
SNPHDR   EQU   SNPFLAG
SNPTCB   EQU   SNPFLAG
SNPID    EQU   SNPFLAG
SNPABEND EQU   SNPFLAG
SNPVS2EN EQU   SNPFLAG
SNPVS2   EQU   SNPFLAG
SNPSNAP  EQU   SNPFLAG
SNPIDENT EQU   SNPPARMS
SHDRIDCT EQU   SHDR+22
SHDRSEQ  EQU   SHDR+21
@NM00001 EQU   SHDRFLGS
SHDRDELP EQU   SHDRFLGS
SHDRFRR  EQU   SHDRFLGS
SHDRBKWD EQU   SHDR+16
SHDRFWD  EQU   SHDRCTFW+4
SHDRCTR  EQU   SHDRCTFW
SHDRCBID EQU   SHDR
SLPWA    EQU   SLIPLIST+16
SLPRTSTK EQU   SLIPLIST+12
@NM00082 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00081 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00080 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00079 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00078 EQU   FLCFSA
@NM00077 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00076 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00075 EQU   FLCIOA
@NM00074 EQU   FLCMCLA+15
@NM00073 EQU   FLCMCLA+14
@NM00072 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00071 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00070 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00069 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00068 EQU   FLCPER
@NM00067 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00066 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00065 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00064 EQU   FLCPIILC
@NM00063 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00062 EQU   FLCSVILC
@NM00061 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00060 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00059 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00192 EQU   @RC00191
@RC00344 EQU   @RC00327
@RF00404 EQU   @RC00372
@RC00452 EQU   @RC00408
@RC00409 EQU   @RC00408
@RC00252 EQU   @RC00251
@RF00715 EQU   @EL00002
@PB00002 EQU   @PB00003
@RF00720 EQU   @EL00003
@ENDDATA EQU   *
         END   IEAVTRT2,(C'PLS1132',0701,77285)
