         TITLE 'IEAVTRTE - RTM2 EXIT HANDLER                           *
                        '
IEAVTRTE CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVTRTE  77.280'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @06,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@06                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*                                                                  0047
*   /*****************************************************************/
*   /*                                                               */
*   /* IEAVTRTE DETERMINES WHETHER TASK OR MEMORY PURGES ARE REQUIRED*/
*   /* AND ENTERS SEGMENT RTEMTINT OR RTETTINT ACCORDINGLY. THEN, IF */
*   /* CONVERSION TO A JOBSTEP ABEND WAS REQUESTED IT ENTERS SEGMENT */
*   /* RTECONV. IT THEN DOES EXIT PROCESSING.                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0047
*   IF RMPLTERM=ON THEN             /* MEMORY TERMINATION            */
*                                                                  0047
         TM    RMPLTERM+712(R8),B'01000000'                        0047
         BNO   @RF00047                                            0047
*     /***************************************************************/
*     /*                                                             */
*     /* RTEMTINT ESTABLISHES AN ESTAE EXIT SO THAT A FAILURE CAN BE */
*     /* RECOVERED AND INVOKES THE MEMORY TERMINATION PURGE ROUTINE. */
*     /* WHEN CONTROL IS RETURNED, IT SETS THE EXIT FLAG TO INDICATE */
*     /* THE TYPE OF EXIT DESIRED AND CANCELS THE ESTAE EXIT         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0048
*     DO;                           /* START OF SEGMENT RTEMTINT     */
*       RESPECIFY                                                  0049
*        (R1) RESTRICTED;           /* RESTRICT INTERFACE REGISTERS  */
*       R1=ADDR(RTM2WA);            /* PARAMETER REGISTER            */
         LR    R1,R8                                               0050
*       R13=ADDR(RTM2SFSA);         /* SAVE AREA PTR                 */
         LA    R13,RTM2SFSA(,R8)                                   0051
*       CALL IEAVTMMT;              /* INVOKE MEMORY TERMINATION   0052
*                                      PURGES                        */
         L     @15,@CV02504                                        0052
         BALR  @14,@15                                             0052
*       RESPECIFY                                                  0053
*        (R1) UNRESTRICTED;         /* RELEASE INTERFACE REGISTERS   */
*       RTM2MTX=ON;                 /* INDICATE EXIT DESIRED         */
         OI    RTM2MTX(R8),B'10000000'                             0054
*     END;                          /* END OF RTEMTINT               */
*   ELSE                            /* TASK TERMINATION              */
*     IF RTM2FLX=NONE THEN          /* NO EXIT REQUESTED             */
         B     @RC00047                                            0056
@RF00047 CLC   RTM2FLX(2,R8),@CB00060                              0056
         BNE   @RF00056                                            0056
*       DO;                                                        0057
*         RTM2ISPC=OFF;             /* INDICATE INITIAL SUBTASK    0058
*                                      PURGES SHOULD BE DONE AGAIN IF
*                                      ANOTHER FAILURE OCCURS        */
         NI    RTM2ISPC(R8),B'11101111'                            0058
*         RTM2SCTR(RTM2EPS)=OFF;    /* CLEAR RECURSION FLAGS SO THAT
*                                      ANOTHER RECURSION WILL START
*                                      SUBTASK PURGES FROM BEGINNING */
*         RTM2SCTR(RTM2ISPS)=OFF;                                  0060
*                                                                  0060
         NI    RTM2SCTR(R8),B'11111100'                            0060
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT RTETTINT INVOKES TASK TERMINATION PURGES. PRIOR */
*         /* TO DOING THIS, IF ENTRY IS FOR ABNORMAL TASK            */
*         /* TERMINATION,IT ESTABLISHES RECURSION CONTROL. ON RETURN */
*         /* FROM TASK PURGES IT DETERMINES THE TYPE OF EXIT         */
*         /* NECESSARY AND CLEARS THE RECURSION FLAGS. ON ENTRY      */
*         /* REGISTER 4 LOCATES THE TCB, REGISTER 5 LOCATES THE SVRB */
*         /* AND REGISTER 8 LOCATES THE RTM2WA                       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0061
*         DO;                       /* BEGIN SEGMENT RTETTINT        */
*                                                                  0061
*           /*********************************************************/
*           /*                                                       */
*           /* DO RECURSION CONTROL                                  */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0062
*           IF RMPLTYPE=ON THEN     /* ENTRY IS FOR ABNORMAL TASK  0062
*                                      TERMINATION                   */
         TM    RMPLTYPE+712(R8),B'10000000'                        0062
         BNO   @RF00062                                            0062
*             IF RTM2RECR=ON&RTM2SCTR(RTM2TSTS)=ON THEN/* A RECURSION
*                                      HAS OCCURRED IN THIS PHASE    */
         TM    RTM2RECR(R8),B'10000000'                            0063
         BNO   @RF00063                                            0063
         TM    RTM2SCTR+1(R8),B'00000100'                          0063
         BNO   @RF00063                                            0063
*               DO;                                                0064
*                 RTM2RCRX=ON;      /* INDICATE RECURSIVE ENTRY      */
         OI    RTM2RCRX(R8),B'10000000'                            0065
*                 RTM2SCTX(RTM2TSTS)=ON;/* INDICATE SECTION          */
         OI    RTM2SCTX+1(R8),B'00000100'                          0066
*               END;                                               0067
*             ELSE                                                 0068
*               RTM2SCTC(RTM2TSTS)=ON;/* SET SECTION FLAG FOR THIS 0068
*                                      PHASE. NO SKIP ADDR IS SET  0068
*                                      BECAUSE IF TASK PURGES DOES 0068
*                                      NOT HAVE A VALID RECURSION  0068
*                                      ADDR THE STEP CONVERSION OR 0068
*                                      CRITICAL RECURSION RTN SHOULD
*                                      BE ENTERED                    */
         B     @RC00063                                            0068
@RF00063 OI    RTM2SCTC+1(R8),B'00000100'                          0068
*           ELSE                                                   0069
*             ;                     /* IF NORMAL EOT,CANNOT BE     0069
*                                      RECURSION                     */
@RF00062 DS    0H                                                  0070
*           IF RTM2FLX=NONE THEN    /* NO EXIT HAS BEEN REQUESTED    */
@RC00062 CLC   RTM2FLX(2,R8),@CB00060                              0070
         BNE   @RF00070                                            0070
*             DO;                                                  0071
*                                                                  0071
*               /*****************************************************/
*               /*                                                   */
*               /* INVOKE TASK TERMINATION PURGES                    */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0072
*               RESPECIFY                                          0072
*                (R1) RESTRICTED;   /* RESTRICT PARM REG FOR TASK  0072
*                                      PURGE                         */
*               RMPLTCBA=R4;        /* PUT CURRENT TCB ADDRESS IN  0073
*                                      RMPL                          */
         ST    R4,RMPLTCBA+712(,R8)                                0073
*               R1=ADDR(RTM2WA);    /* PUT ADDR OF RTM2WA IN R1      */
         LR    R1,R8                                               0074
*               R13=ADDR(RTM2SFSA); /* SAVE AREA ADDRESS IN R13      */
         LA    R13,RTM2SFSA(,R8)                                   0075
*               RESPECIFY                                          0076
*                 R15 RESTRICTED;                                  0076
*               CALL IEAVTSKT;      /* REQUEST TASK PURGES           */
         L     @15,@CV02505                                        0077
         BALR  @14,@15                                             0077
*               RESPECIFY                                          0078
*                 R1 UNRESTRICTED;                                 0078
*                                                                  0078
*               /*****************************************************/
*               /*                                                   */
*               /* DETERMINE TYPE OF EXIT REQUESTED                  */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0079
*               IF R15^=0 THEN      /* ERROR DETECTED                */
         LTR   R15,R15                                             0079
         BZ    @RF00079                                            0079
*                 RTM2CERX=ON;      /* INDICATE ERROR IN EXIT FLAGS  */
         OI    RTM2CERX(R8),B'01000000'                            0080
*               ELSE                /* TASK PURGES SUCCESSFUL        */
*                 IF TCBRSTSK=ON THEN/* TASK PURGE HAS PURGED A    0081
*                                      PERMANENTLY RESIDENT TASK     */
         B     @RC00079                                            0081
@RF00079 TM    TCBRSTSK(R4),B'00000100'                            0081
         BNO   @RF00081                                            0081
*                   RTM2PRX=ON;     /* INDICATE EXIT PROCESSING FOR
*                                      PERMANENTLY RESIDENT TASK     */
         OI    RTM2PRX(R8),B'00000100'                             0082
*                 ELSE                                             0083
*                   IF RTM2TMEM=ON THEN/* TASK PURGE HAS PURGED THE
*                                      LAST TASK IN THE MEMORY       */
         B     @RC00081                                            0083
@RF00081 TM    RTM2TMEM(R8),B'00100000'                            0083
         BNO   @RF00083                                            0083
*                     RTM2LTX=ON;   /* INDICATE LAST TASK EXIT       */
         OI    RTM2LTX(R8),B'00000010'                             0084
*                   ELSE                                           0085
*                     IF RMPLTYPE=ON THEN/* TASK PURGES WERE FOR   0085
*                                      ABNORMAL TERMINATION          */
         B     @RC00083                                            0085
@RF00083 TM    RMPLTYPE+712(R8),B'10000000'                        0085
         BNO   @RF00085                                            0085
*                       RTM2ABX=ON; /* INDICATE ABNORMAL TERMINATION
*                                      EXIT                          */
         OI    RTM2ABX(R8),B'00100000'                             0086
*                     ELSE                                         0087
*                       RTM2EOTX=ON;/* INDICATE NORMAL EOT EXIT      */
*                                                                  0087
         B     @RC00085                                            0087
@RF00085 OI    RTM2EOTX(R8),B'01000000'                            0087
*               /*****************************************************/
*               /*                                                   */
*               /* PUT ABEND CODE INTO TCB - IT MAY HAVE BEEN CHANGED*/
*               /* BY AN ERROR WHICH HAS BEEN RECOVERED      @YM05449*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0088
*               TCBCMPC=RTM2CC;     /*                       @YM05449*/
*                                                                  0088
@RC00085 DS    0H                                                  0088
@RC00083 DS    0H                                                  0088
@RC00081 DS    0H                                                  0088
@RC00079 MVC   TCBCMPC(3,R4),RTM2CC(R8)                            0088
*               /*****************************************************/
*               /*                                                   */
*               /* CLEAR RECURSION CONTROL                           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0089
*               RTM2SCTC(RTM2TSTS)=OFF;/* CLEAR RECURSION FLAG       */
         NI    RTM2SCTC+1(R8),B'11111011'                          0089
*             END;                                                 0090
*           ELSE                                                   0091
*             ;                     /* IF EXIT REQUESTED BYPASS ALL
*                                      PROCESSING                    */
@RF00070 DS    0H                                                  0092
*           RESPECIFY                                              0092
*             R15 UNRESTRICTED;                                    0092
*         END;                      /* END SEGMENT RTETTINT          */
*         IF RTM2RCRX=OFF           /* NO RECURSION DETECTED         */
*             &RTM2CERX=OFF         /* NO CRITICAL ERROR DETECTED    */
*             &RTM2STPT=ON THEN     /* STEP ABEND REQUESTED          */
*                                                                  0094
         TM    RTM2RCRX(R8),B'11000000'                            0094
         BNZ   @RF00094                                            0094
         TM    RTM2STPT(R8),B'10000000'                            0094
         BNO   @RF00094                                            0094
*           /*********************************************************/
*           /*                                                       */
*           /* SEGMENT RTECONV DETERMINES WHETHER CONVERSION TO STEP */
*           /* IS POSSIBLE AND NOTIFIES THE JOBSTEP TASK IF IT IS.   */
*           /* THE JOBSTEP TASK IS FIRST LOCATED AND SET             */
*           /* NONDISPATCHABLE. IF THE JOBSTEP TASK IS ALREADY       */
*           /* ABENDING OR BEING FORCED TO ABEND, IT IS NOT ELIGIBLE */
*           /* FOR CONVERSION. IT IS RESET DISPATCHABLE, AND THE     */
*           /* CURRENT TASK GOES TO THE EXIT HANDLER TO FINISH ITS   */
*           /* OWN TERMINATION WITH WHATEVER EXIT FLAG WAS SET BY    */
*           /* TASK TERMINATION. IF THE JOBSTEP TASK IS ELIGIBLE FOR */
*           /* CONVERSION, IT IS CHECKED TO SEE WHETHER IT IS IN     */
*           /* RTM2. IF IT IS IN RTM2, IT MUST BE PERMITTED TO       */
*           /* COMPLETE ITS CURRENT PROCESSING. AN ECB IS SET UP, A  */
*           /* FLAG IS SET IN THE JOBSTEP TCB, IT IS RESET           */
*           /* DISPATCHABLE TO COMPLETE ITS CURRENT PROCESSING. WHEN */
*           /* IT POSTS THE ECB, THE CURRENT TASK SETS AN EXIT FLAG  */
*           /* TO FORCE THE ABTERMING OF THE JOBSTEP TASK.           */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0095
*           DO;                     /* START OF RTECONV              */
*                                                                  0095
*             /*******************************************************/
*             /*                                                     */
*             /* OBTAIN LOCAL LOCK                                   */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0096
*             ESAGLREC=ON;                                         0096
         OI    ESAGLREC+96(R5),B'00010000'                         0096
*             DO;                   /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,IEAVTRTE(R
*                                      TECONV))                      */
*               RESPECIFY                                          0098
*                (GPR11P,                                          0098
*                 GPR12P,                                          0098
*                 GPR13P,                                          0098
*                 GPR14P) RESTRICTED;/* RESTRICT REGS USED BY SETLOCK*/
*               GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,
*                   GPR14P);                                       0099
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(TCB,IEAVTRTE(RTECONV))
*               RESPECIFY                                          0100
*                (GPR11P,                                          0100
*                 GPR12P,                                          0100
*                 GPR13P,                                          0100
*                 GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY     0100
*                                      SETLOCK                       */
*             END;                  /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,IEAVTRTE(R
*                                      TECONV))                      */
*             ESAGLREC=OFF;                                        0102
*                                                                  0102
         LA    @12,96                                              0102
         ALR   @12,R5                                              0102
         NI    ESAGLREC(@12),B'11101111'                           0102
*             /*******************************************************/
*             /*                                                     */
*             /* LOCATE JOBSTEP TASK                                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0103
*             RESPECIFY                                            0103
*               R9 RESTRICTED;      /* RESTRICT PTR TO J/S TCB       */
*             R9=TCBJSTCA;                                         0104
         L     R9,TCBJSTCA-1(,R4)                                  0104
         LA    R9,0(,R9)                                           0104
*             RESPECIFY                                            0105
*               TCB BASED(R9);                                     0105
*                                                                  0105
*             /*******************************************************/
*             /*                                                     */
*             /* SET JOB STEP TASK NONDISPATCHABLE                   */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0106
*             RESPECIFY                                            0106
*              (R0,                                                0106
*               R1) RESTRICTED;     /* RESTRICT STATUS INTERFACE REGS*/
*             R0=STOPTASK;          /* CODE TO STOP ONE TASK WITH  0107
*                                      ABWF                          */
         L     R0,@CF00076                                         0107
*             R1=R9;                /* TASK TO BE STOPPED            */
         LR    R1,R9                                               0108
*             R13=0;                /* INDICATE CURRENT MEMORY       */
         SLR   R13,R13                                             0109
*             CALL STATUS;                                         0110
         L     @12,CVTPTR(,@12)                                    0110
         L     @12,SCVTSPTR(,@12)                                  0110
         L     @15,SCVTSTAT(,@12)                                  0110
         BALR  @14,@15                                             0110
*             RESPECIFY                                            0111
*              (R0,                                                0111
*               R1) UNRESTRICTED;   /* RELEASE STATUS INTERFACE REGS */
*                                                                  0111
*             /*******************************************************/
*             /*                                                     */
*             /* IF CONVERSION IS NOT POSSIBLE, RELEASE LOCAL LOCK   */
*             /* AND RESET JOBSTEP TASK DISPATCHABLE                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0112
*             IF TCBFA=ON           /* TASK ALREADY ABENDING         */
*                 |TCBFMW=ON        /* ANCESTOR FORCING TASK TO ABEND*/
*                 |TCBFDW=ON THEN   /* ANOTHER SUBTASK FORCING TASK
*                                      TO ABEND                      */
         TM    TCBFA(R9),B'10000000'                               0112
         BO    @RT00112                                            0112
         TM    TCBFMW(R9),B'01100000'                              0112
         BZ    @RF00112                                            0112
@RT00112 DS    0H                                                  0113
*               DO;                                                0113
*                 ESAGLREC=ON;      /* INDICATE IN SETLOCK PROCESSING*/
         OI    ESAGLREC+96(R5),B'00010000'                         0114
*                 DO;               /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE(RTECONV))   */
*                   RESPECIFY                                      0116
*                    (GPR11P,                                      0116
*                     GPR12P,                                      0116
*                     GPR13P,                                      0116
*                     GPR14P) RESTRICTED;/* RESTRICT REGS USED BY  0116
*                                      SETLOCK                       */
*                   GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P, 0117
*                       GPR13P,GPR14P);                            0117
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE(RTECONV))
*                   RESPECIFY                                      0118
*                    (GPR11P,                                      0118
*                     GPR12P,                                      0118
*                     GPR13P,                                      0118
*                     GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY 0118
*                                      SETLOCK                       */
*                 END;              /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE(RTECONV))   */
*                 ESAGLREC=OFF;     /* SETLOCK COMPLETED SUCCESSFULLY*/
         NI    ESAGLREC+96(R5),B'11101111'                         0120
*                 GEN(STATUS RESET,ND,(R9),(10),E);                0121
         STATUS RESET,ND,(R9),(10),E
*               END;                                               0122
*             ELSE                                                 0123
*                                                                  0123
*               /*****************************************************/
*               /*                                                   */
*               /* CONVERSION POSSIBLE                               */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0123
*               DO;                                                0123
         B     @RC00112                                            0123
@RF00112 DS    0H                                                  0124
*                 TCBFDW=ON;        /* SIGNAL JOBSTEP THAT DAUGHTER
*                                      IS WAITING                    */
*                                                                  0124
         OI    TCBFDW(R9),B'00100000'                              0124
*                 /***************************************************/
*                 /*                                                 */
*                 /* IF NECESSARY, WAIT FOR JOBSTEP TO FINISH CERTAIN*/
*                 /* RTM2 PROCESSING                                 */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0125
*                 IF TCBRTM2=ON THEN/* JOBSTEP TASK MAY BE IN      0125
*                                      PROCESSING WHICH SHOULD NOT BE
*                                      INTERRUPTED                   */
         TM    TCBRTM2(R9),B'00001000'                             0125
         BNO   @RF00125                                            0125
*                   DO;                                            0126
*                     RTM2ECBS(1)=0;/* CLEAR ECB TO BE USED          */
         SLR   @12,@12                                             0127
         ST    @12,RTM2ECBS(,R8)                                   0127
*                     TCBAECB=ADDR(RTM2ECBS);/* PROVIDE ADDRESS OF 0128
*                                      ECB TO JOBSTEP TASK           */
         LA    @12,RTM2ECBS(,R8)                                   0128
         ST    @12,TCBAECB(,R9)                                    0128
*                     ESAGLREC=ON;  /* INDICATE SETLOCK IN CONTROL   */
         OI    ESAGLREC+96(R5),B'00010000'                         0129
*                     DO;           /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE(RTECONV))   */
*                       RESPECIFY                                  0131
*                        (GPR11P,                                  0131
*                         GPR12P,                                  0131
*                         GPR13P,                                  0131
*                         GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                                             SETLOCK*/
*                       GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                           GPR13P,GPR14P);                        0132
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE(RTECONV))
*                       RESPECIFY                                  0133
*                        (GPR11P,                                  0133
*                         GPR12P,                                  0133
*                         GPR13P,                                  0133
*                         GPR14P) UNRESTRICTED;/* RELEASE REGS USED
*                                      BY                     SETLOCK*/
*                     END;          /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE(RTECONV))   */
*                     ESAGLREC=OFF; /* SETLOCK COMPLETED WITHOUT   0135
*                                      FAILURE                       */
         NI    ESAGLREC+96(R5),B'11101111'                         0135
*                     GEN(STATUS RESET,ND,(R9),(10),E);            0136
         STATUS RESET,ND,(R9),(10),E
*                     RESPECIFY                                    0137
*                       R1 RESTRICTED;                             0137
*                     R1=ADDR(RTM2ECBS);/* SET UP PARAMETER TO WAIT  */
         LA    R1,RTM2ECBS(,R8)                                    0138
*                     GEN(WAIT  ECB=(1));/* WAIT FOR JOBSTEP TASK TO
*                                      FINISH CRITICAL PROCESSING    */
         WAIT  ECB=(1)
*                     RESPECIFY                                    0140
*                       R1 UNRESTRICTED;                           0140
*                   END;                                           0141
*                 ELSE              /* JOBSTEP TASK NOT IN RTM2    0142
*                                      PROCESSING                    */
*                   DO;                                            0142
         B     @RC00125                                            0142
@RF00125 DS    0H                                                  0143
*                     TCBRTM2=ON;   /* FORCE JOBSTEP'S ANCESTORS TO
*                                      STACK BEHIND IT               */
         OI    TCBRTM2(R9),B'00001000'                             0143
*                     ESAGLREC=ON;  /* INDICATE IN SETLOCK PROCESSING*/
         OI    ESAGLREC+96(R5),B'00010000'                         0144
*                     DO;           /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE(RTECONV))   */
*                       RESPECIFY                                  0146
*                        (GPR11P,                                  0146
*                         GPR12P,                                  0146
*                         GPR13P,                                  0146
*                         GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                      SETLOCK                       */
*                       GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                           GPR13P,GPR14P);                        0147
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE(RTECONV))
*                       RESPECIFY                                  0148
*                        (GPR11P,                                  0148
*                         GPR12P,                                  0148
*                         GPR13P,                                  0148
*                         GPR14P) UNRESTRICTED;/* RELEASE REGS USED
*                                      BY SETLOCK                    */
*                     END;          /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE(RTECONV))   */
*                     ESAGLREC=OFF; /* SETLOCK PROCESSING COMPLETED  */
         NI    ESAGLREC+96(R5),B'11101111'                         0150
*                   END;                                           0151
*                                                                  0151
*                 /***************************************************/
*                 /*                                                 */
*                 /* SET EXIT FOR CONVERSION TO STEP                 */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0152
*                 RTM2FLX=NONE;     /* CLEAR EXISTING FLAGS          */
@RC00125 MVC   RTM2FLX(2,R8),@CB00060                              0152
*                 RTM2CVX=ON;       /* SET EXIT FLAG FOR CONVERSION  */
         OI    RTM2CVX(R8),B'00001000'                             0153
*               END;                                               0154
*             RESPECIFY                                            0155
*               TCB BASED(R4);                                     0155
@RC00112 DS    0H                                                  0156
*             RESPECIFY                                            0156
*               R9 UNRESTRICTED;                                   0156
*           END;                    /* END OF RTECONV                */
*         ELSE                                                     0158
*           ;                       /* EXIT REQUESTED OR NOT STEP    */
@RF00094 DS    0H                                                  0159
*       END;                                                       0159
*     ELSE                                                         0160
*       ;                           /* EXIT REQUESTED                */
@RF00056 DS    0H                                                  0161
*   RESPECIFY                                                      0161
*     R13 RESTRICTED;                                              0161
*                                                                  0161
@RC00047 DS    0H                                                  0162
*   /*****************************************************************/
*   /*                                                               */
*   /* IEAVTRTE OBTAINS THE LOCAL LOCK TO SERIALIZE ACCESS TO TCB    */
*   /* FIELDS AND SETS THE SECTION FLAG IF NOT RECURSION IN THIS     */
*   /* SECTION. IT ROUTES CONTROL TO THE APPROPRIATE HANDLER AS      */
*   /* DETERMINED BY THE EXIT FLAGS PREVIOUSLY SET.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0162
*   IF RTM2CERX=OFF THEN            /* CONTROL IS RETURNED IF A    0162
*                                      CRITICAL ERROR HAS BEEN     0162
*                                      DETECTED                      */
         TM    RTM2CERX(R8),B'01000000'                            0162
         BNZ   @RF00162                                            0162
*     DO;                                                          0163
*                                                                  0163
*       /*************************************************************/
*       /*                                                           */
*       /* OBTAIN LOCAL LOCK                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0164
*       ESAGLREC=ON;                                               0164
         OI    ESAGLREC+96(R5),B'00010000'                         0164
*       DO;                         /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,IEAVTRTE) */
*         RESPECIFY                                                0166
*          (GPR11P,                                                0166
*           GPR12P,                                                0166
*           GPR13P,                                                0166
*           GPR14P) RESTRICTED;     /* RESTRICT REGS USED BY SETLOCK */
*         GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,GPR14P);
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(TCB,IEAVTRTE)
*         RESPECIFY                                                0168
*          (GPR11P,                                                0168
*           GPR12P,                                                0168
*           GPR13P,                                                0168
*           GPR14P) UNRESTRICTED;   /* RELEASE REGS USED BY SETLOCK  */
*       END;                        /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,IEAVTRTE) */
*       ESAGLREC=OFF;                                              0170
*                                                                  0170
         NI    ESAGLREC+96(R5),B'11101111'                         0170
*       /*************************************************************/
*       /*                                                           */
*       /* IF NOT RECURSION IN EXIT PROCESSING, SET SECTION FLAG TO  */
*       /* SHOW IN EXIT PROCESSING                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0171
*       IF RTM2RECR=ON&RTM2SCTR(RTM2EXTS)=ON THEN/* RECURSION IN EXIT*/
         TM    RTM2RECR(R8),B'10000000'                            0171
         BNO   @RF00171                                            0171
         TM    RTM2SCTR+1(R8),B'01000000'                          0171
         BNO   @RF00171                                            0171
*         RTM2SCTX(RTM2EXTS)=ON;    /* INDICATE SECTION              */
         OI    RTM2SCTX+1(R8),B'01000000'                          0172
*       ELSE                        /* NOT RECURSION IN EXIT         */
*         RTM2SCTC(RTM2EXTS)=ON;    /* INDICATE CURRENT SECTION      */
*                                                                  0173
         B     @RC00171                                            0173
@RF00171 OI    RTM2SCTC+1(R8),B'01000000'                          0173
*       /*************************************************************/
*       /*                                                           */
*       /* ROUTE TO APPROPRIATE EXIT HANDLER                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0174
*       IF RTM2RCRX=ON              /* RECURSION EXIT REQUESTED      */
*           |(RTM2RECR=ON&RTM2SCTR(RTM2EXTS)=ON) THEN/* RECURSION IN
*                                      EXIT                          */
*                                                                  0174
@RC00171 TM    RTM2RCRX(R8),B'10000000'                            0174
         BO    @RT00174                                            0174
         TM    RTM2RECR(R8),B'10000000'                            0174
         BNO   @RF00174                                            0174
         TM    RTM2SCTR+1(R8),B'01000000'                          0174
         BNO   @RF00174                                            0174
@RT00174 DS    0H                                                  0175
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT RTERCREX HANDLES THE EXIT FUNCTION FOR RECURSIVE*/
*         /* ENTRIES. IF THE RECURSION WAS IN CODE NOT COVERED BY A  */
*         /* SECTION FLAG OR IN TASK RECOVERY PROCESSING THE         */
*         /* IMMEDIATELY PRECEDING WORK AREA CONTAINS THE ERROR DATA */
*         /* AND IS CHAINED FROM THE RECURSION WORK AREA FIELD.      */
*         /* OTHERWISE, THE WORK AREA WHICH CORRESPONDS TO THE       */
*         /* SECTION WHICH FAILED IS CHAINED FROM THE RECURSION WORK */
*         /* AREA FIELD. IF A SUBFUNCTION RECURSION ROUTINE EXISTS   */
*         /* SEGMENT RTESFRE IS THEN EXECUTED TO ESTABLISH THE       */
*         /* INTERFACE TO THE SUBFUNCTION RECURSION ROUTINE.         */
*         /* OTHERWISE CONTROL IS PASSED TO THE CONTROLLER RECURSION */
*         /* ADDRESS OR TO THE 'STEP CONVERSION RECURSION ROUTINE'   */
*         /* (SEGMENT RTECVERR) OR TO THE CRITICAL RECURSION         */
*         /* ROUTINE(RT2CRERR). THIS IS DONE BASED ON THE LEAST      */
*         /* SEVERE ONE WHICH HAS AN ACTIVE ADDRESS IN THE           */
*         /* APPROPRIATE RTM2WA.                                     */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0175
*         DO;                       /* START OF RTERCREX             */
*                                                                  0175
*           /*********************************************************/
*           /*                                                       */
*           /* LOCATE PREVIOUS WORK AREA                             */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0176
*           IF RTM2SCTX=NOSECTN THEN/* ERROR IN CONNECTING CODE      */
         CLC   RTM2SCTX(4,R8),@CB00066                             0176
         BNE   @RF00176                                            0176
*             RTM2PRWA=RTM2PREV;    /* IMMEDIATELY PREVIOUS WORK AREA
*                                      CONTAINS RECURSION INFORMATION*/
         L     @12,RTM2PREV(,R8)                                   0177
         ST    @12,RTM2PRWA(,R8)                                   0177
*           ELSE                    /* RECURSION IN SOME OTHER     0178
*                                                             SECTION*/
*             DO;                                                  0178
         B     @RC00176                                            0178
@RF00176 DS    0H                                                  0179
*               RESPECIFY                                          0179
*                 R2 RESTRICTED;    /* RESTRICT REG USED TO SCAN WORK
*                                      AREA QUEUE                    */
*               R2=RTM2PREV;        /* START SCAN WITH PREVIOUS WA   */
         L     R2,RTM2PREV(,R8)                                    0180
*               RTM2PRWA=0;         /* CLEAR RECURSION WORKAREA PTR
*                                      (THIS MAY NOT BE FIRST TIME 0181
*                                      THIS EXIT IS TAKEN)           */
         SLR   @12,@12                                             0181
         ST    @12,RTM2PRWA(,R8)                                   0181
*               DO WHILE(RTM2PRWA=0);/* SCAN UNTIL WORK AREA       0182
*                                      CONTAINING FAILURE DATA IS  0182
*                                      REACHED                       */
         B     @DE00182                                            0182
@DL00182 DS    0H                                                  0183
*                 IF RTM2SCTX=R2->RTM2SCTC THEN/* WORK AREA CURRENT
*                                      AT TIME OF FAILURE            */
         CLC   RTM2SCTX(4,R8),RTM2SCTC(R2)                         0183
         BNE   @RF00183                                            0183
*                   RTM2PRWA=R2;    /* SET RECURSION WORK AREA PTR   */
         ST    R2,RTM2PRWA(,R8)                                    0184
*                 ELSE              /* WORK AREA NOT CURRENT AT THIS
*                                      FAILURE                       */
*                   R2=R2->RTM2PREV;/* LOCATE NEXT WORK AREA ON CHAIN*/
         B     @RC00183                                            0185
@RF00183 L     R2,RTM2PREV(,R2)                                    0185
*               END;                /* END SEARCH FOR RECURSION WORK
*                                      AREA                          */
@RC00183 DS    0H                                                  0186
@DE00182 L     @12,RTM2PRWA(,R8)                                   0186
         LTR   @12,@12                                             0186
         BZ    @DL00182                                            0186
*               RESPECIFY                                          0187
*                 R2 UNRESTRICTED;                                 0187
*             END;                                                 0188
*           RTM2RCRX=OFF;           /* CLEAR EXIT FLAG               */
@RC00176 NI    RTM2RCRX(R8),B'01111111'                            0189
*           RTM2SCTC=NOSECTN;       /* CLEAR CURRENT SECTION FLAG    */
*                                                                  0190
         MVC   RTM2SCTC(4,R8),@CB00066                             0190
*           /*********************************************************/
*           /*                                                       */
*           /* SELECT APPROPRIATE EXIT                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0191
*           IF RTM2PRWA->RTM2TRRA^=0 THEN/* SUBFUNCTION RECURSION  0191
*                                      ENVIRONMENT SET UP FOR ERROR  */
*                                                                  0191
         L     @12,RTM2PRWA(,R8)                                   0191
         L     @09,RTM2TRRA(,@12)                                  0191
         LTR   @09,@09                                             0191
         BZ    @RF00191                                            0191
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT RTESFRE ESTABLISHES THE INTERFACE TO A      */
*             /* SUBFUNCTION RECURSION HANDLING ROUTINE. IT COPIES   */
*             /* THE CONTROLLER RECURSION ENVIRONMENT TO THE CURRENT */
*             /* WORKAREA SO THAT THE SECTION WILL BE SKIPPED IF A   */
*             /* SECOND FAILURE OCCURS. THE SUBFUNCTION REGISTERS ARE*/
*             /* UPDATED TO REFLECT THE CURRENT SVRB AND WORK AREA.  */
*             /* THE LOCAL LOCK IS RELEASED, REGISTERS ARE RELOADED, */
*             /* AND CONTROL IS PASSED TO THE SUBFUNCTION RECURSION  */
*             /* ADDRESS.                                            */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0192
*             DO;                   /* START OF RTESFRE              */
*                                                                  0192
*               /*****************************************************/
*               /*                                                   */
*               /* CLEAR SECTION FLAG IN RECURSION FLAGS             */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0193
*               RTM2SCTR=RTM2SCTR&&RTM2SCTX;                       0193
         XC    RTM2SCTR(4,R8),RTM2SCTX(R8)                         0193
*               RTM2SCTX=NOSECTN;   /* CLEAR RECURSION EXIT FLAGS    */
*                                                                  0194
         MVC   RTM2SCTX(4,R8),@CB00066                             0194
*               /*****************************************************/
*               /*                                                   */
*               /* COPY CONTROLLER RECURSION ENVIRONMENT FROM        */
*               /* PREVIOUS WORKAREA AND UPDATE CONTROLLER RECURSION */
*               /* REGISTERS                                         */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0195
*               RTM2SFRG=RTM2PRWA->RTM2SFRG;/* COPY CONTROLLER REGS  */
         MVC   RTM2SFRG(72,R8),RTM2SFRG(@12)                       0195
*               RTM2SFSA(11)=R5;    /* UPDATE RB PTR IN REG 5        */
         ST    R5,RTM2SFSA+40(,R8)                                 0196
*               RTM2SFSA(14)=R8;    /* UPDATE RTM2WA PTR IN REG 8    */
         ST    R8,RTM2SFSA+52(,R8)                                 0197
*               RTM2SCTC=RTM2PRWA->RTM2SCTC;/* INDICATE CURRENT    0198
*                                      SECTION                       */
         MVC   RTM2SCTC(4,R8),RTM2SCTC(@12)                        0198
*               RTM2SKRA=RTM2PRWA->RTM2SKRA;/* SKIP ADDRESS WILL SKIP
*                                      SECTION IF ANOTHER FAILURE  0199
*                                      OCCURS                        */
         L     @09,RTM2SKRA(,@12)                                  0199
         ST    @09,RTM2SKRA(,R8)                                   0199
*               RTM2CRG=RTM2PRWA->RTM2CRG;/* COPY REGS FOR IEAVTRT2  */
         MVC   RTM2CRG(72,R8),RTM2CRG(@12)                         0200
*               RTM2CREG(11)=R5;    /* UPDATE RB PTR                 */
         ST    R5,RTM2CREG+40(,R8)                                 0201
*               RTM2CREG(13)=ADDR(RBEXSAVE);/* UPDATE SAVED RTM2ESA
*                                      PTR                           */
         LA    @09,RBEXSAVE(,R5)                                   0202
         ST    @09,RTM2CREG+48(,R8)                                0202
*               RTM2CREG(14)=R8;    /* UPDATE RTM2 PTR               */
*                                                                  0203
         ST    R8,RTM2CREG+52(,R8)                                 0203
*               /*****************************************************/
*               /*                                                   */
*               /* SET UP ENVIRONMENT FOR SUBFUNCTION TO RESUME      */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0204
*               RTM2RRG=RTM2PRWA->RTM2RRG;/* COPY SUBFUNCTION REGS 0204
*                                      FORWARD                       */
         MVC   RTM2RRG(64,R8),RTM2RRG(@12)                         0204
*               IF RTM2PRWA->RTM2WARG^=0 THEN/* WORK AREA PTR TO BE
*                                      UPDATED                       */
         CLI   RTM2WARG(@12),0                                     0205
         BE    @RF00205                                            0205
*                 DO;                                              0206
*                   RTM2RREG(RTM2PRWA->RTM2WARG)=R8;               0207
         SLR   @09,@09                                             0207
         IC    @09,RTM2WARG(,@12)                                  0207
         LR    @12,@09                                             0207
         SLA   @12,2                                               0207
         ST    R8,RTM2RREG-4(@12,R8)                               0207
*                   RTM2WARG=RTM2PRWA->RTM2WARG;                   0208
         STC   @09,RTM2WARG(,R8)                                   0208
*                 END;                                             0209
*               IF RTM2PRWA->RTM2RBRG^=0 THEN/* RB REG TO BE UPDATED */
@RF00205 L     @12,RTM2PRWA(,R8)                                   0210
         CLI   RTM2RBRG(@12),0                                     0210
         BE    @RF00210                                            0210
*                 DO;                                              0211
*                   RTM2RREG(RTM2PRWA->RTM2RBRG)=R5;               0212
         SLR   @09,@09                                             0212
         IC    @09,RTM2RBRG(,@12)                                  0212
         LR    @12,@09                                             0212
         SLA   @12,2                                               0212
         ST    R5,RTM2RREG-4(@12,R8)                               0212
*                   RTM2RBRG=RTM2PRWA->RTM2RBRG;                   0213
         STC   @09,RTM2RBRG(,R8)                                   0213
*                 END;                                             0214
*               RTM2RREG(14)=ADDR(RTM2SFSA);/* UPDATE REG 13         */
@RF00210 LA    @12,RTM2SFSA(,R8)                                   0215
         ST    @12,RTM2RREG+52(,R8)                                0215
*               RTM2RREG(15)=RTM2PRWA->RTM2TRRA;/* REG 14 WILL BE  0216
*                                      RETURN REG                    */
         L     @12,RTM2PRWA(,R8)                                   0216
         L     @12,RTM2TRRA(,@12)                                  0216
         ST    @12,RTM2RREG+56(,R8)                                0216
*               ESAGLREC=ON;                                       0217
         OI    ESAGLREC+96(R5),B'00010000'                         0217
*               DO;                 /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                 RESPECIFY                                        0219
*                  (GPR11P,                                        0219
*                   GPR12P,                                        0219
*                   GPR13P,                                        0219
*                   GPR14P) RESTRICTED;/* RESTRICT REGS USED BY    0219
*                                      SETLOCK                       */
*                 GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,
*                     GPR14P);                                     0220
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE)
*                 RESPECIFY                                        0221
*                  (GPR11P,                                        0221
*                   GPR12P,                                        0221
*                   GPR13P,                                        0221
*                   GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY   0221
*                                      SETLOCK                       */
*               END;                /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*               ESAGLREC=OFF;                                      0223
         NI    ESAGLREC+96(R5),B'11101111'                         0223
*               GEN REFS(RTM2RREG,R8);                             0224
         LM    R0,R15,RTM2RREG(R8)
         BR    R14
*             END;                  /* END OF RTESFRE                */
*           ELSE                    /* NO SUBFUNCTION ENVIRONMENT  0226
*                                      PRESENT                       */
*             IF RTM2PRWA->RTM2SKRA^=0 THEN/* CONTROLLER RECURSION 0226
*                                      ADDRESS PRESENT               */
*                                                                  0226
         B     @RC00191                                            0226
@RF00191 L     @12,RTM2PRWA(,R8)                                   0226
         L     @09,RTM2SKRA(,@12)                                  0226
         LTR   @09,@09                                             0226
         BZ    @RF00226                                            0226
*               /*****************************************************/
*               /*                                                   */
*               /* CONTROLLER RECURSION EXIT                         */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0227
*               DO;                                                0227
*                 RTM2CRG=RTM2PRWA->RTM2CRG;/* COPY SAVED CONTROLLER
*                                      REGS                          */
         MVC   RTM2CRG(72,R8),RTM2CRG(@12)                         0228
*                 RTM2CREG(11)=R5;  /* UPDATE SAVED RB PTR           */
         ST    R5,RTM2CREG+40(,R8)                                 0229
*                 RTM2CREG(13)=ADDR(RBEXSAVE);/* UPDATE SAVED RTM2ESA
*                                      POINTER                       */
         LA    @12,RBEXSAVE(,R5)                                   0230
         ST    @12,RTM2CREG+48(,R8)                                0230
*                 RTM2CREG(14)=R8;  /* UPDATE SAVED RTM2WA PTR       */
         ST    R8,RTM2CREG+52(,R8)                                 0231
*                 RTM2SCTX=NOSECTN; /* CLEAR RECURSION EXIT FLAGS    */
         MVC   RTM2SCTX(4,R8),@CB00066                             0232
*                 ESAGLREC=ON;                                     0233
         OI    ESAGLREC+96(R5),B'00010000'                         0233
*                 DO;               /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                   RESPECIFY                                      0235
*                    (GPR11P,                                      0235
*                     GPR12P,                                      0235
*                     GPR13P,                                      0235
*                     GPR14P) RESTRICTED;/* RESTRICT REGS USED BY  0235
*                                      SETLOCK                       */
*                   GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P, 0236
*                       GPR13P,GPR14P);                            0236
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE)
*                   RESPECIFY                                      0237
*                    (GPR11P,                                      0237
*                     GPR12P,                                      0237
*                     GPR13P,                                      0237
*                     GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY 0237
*                                      SETLOCK                       */
*                 END;              /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                 ESAGLREC=OFF;                                    0239
         NI    ESAGLREC+96(R5),B'11101111'                         0239
*                 RESPECIFY                                        0240
*                   R14 RESTRICTED; /* RESTRICT RETURN REGISTER      */
*                 R13=ADDR(RTM2PRWA->RTM2SFSA);/* SAVE AREA ADDRESS
*                                      TO RELOAD REGISTERS           */
         L     @15,RTM2PRWA(,R8)                                   0241
         LA    R13,RTM2SFSA(,@15)                                  0241
*                 R14=RTM2PRWA->RTM2SKRA;/* RECURSION RESUME ADDRESS */
         L     R14,RTM2SKRA(,@15)                                  0242
*                 GEN;                                             0243
*                                  /* RELOAD UNCHANGED REGS          */
         LM    R15,R4,16(R13)
         LM    R6,R7,44(R13)
         LM    R9,R12,56(R13)
         BR    R14                 RESUME AT RECURSION ADDRESS
*                 RESPECIFY                                        0244
*                   R14 UNRESTRICTED;                              0244
*               END;                                               0245
*             ELSE                  /* NEITHER SUBFUNCTION NOR     0246
*                                      CONTROLLER RECURSION ADDRESS  */
*               IF RTM2STRA^=0 THEN /* STEP CONVERSION RECURSION   0246
*                                      ADDRESS PRESENT               */
         B     @RC00226                                            0246
@RF00226 SLR   @12,@12                                             0246
         C     @12,RTM2STRA(,R8)                                   0246
         BE    @RF00246                                            0246
*                 DO;                                              0247
*                   RTM2STRA=0;     /* PREVENT EXECUTING THIS ROUTINE
*                                      AGAIN                         */
*                                                                  0248
         ST    @12,RTM2STRA(,R8)                                   0248
*                   /*************************************************/
*                   /*                                               */
*                   /* RTECVERR TAKES AN SVC DUMP AND TERMINATES THE */
*                   /* JOBSTEP TASK. IT THEN SETS ITSELF             */
*                   /* NONDISPATCHABLE TO WAIT FOR THE JOBSTEP TASK  */
*                   /* TO DETACH IT. IF IT FAILS AGAIN, THE MEMORY   */
*                   /* WILL BE TERMINATED.                           */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0249
*RTECVERR:                                                         0249
*                   DO;                                            0249
*                                                                  0249
RTECVERR DS    0H                                                  0250
*                     /***********************************************/
*                     /*                                             */
*                     /* TAKE SVC DUMP                               */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0250
*                     IF ESASDREC=OFF THEN/* NO PREVIOUS FAILURE IN
*                                      SDUMP                         */
         LA    @12,96                                              0250
         ALR   @12,R5                                              0250
         TM    ESASDREC(@12),B'01000000'                           0250
         BNZ   @RF00250                                            0250
*                       DO;                                        0251
*                                                                  0251
*                         /*******************************************/
*                         /*                                         */
*                         /* RELEASE LOCAL LOCK TO ALLOW SVC FORM OF */
*                         /* SDUMP                                   */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0252
*                         ESAGLREC=ON;/* SETLOCK IN CONTROL          */
         OI    ESAGLREC(@12),B'00010000'                           0252
*                         DO;       /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                           RESPECIFY                              0254
*                            (GPR11P,                              0254
*                             GPR12P,                              0254
*                             GPR13P,                              0254
*                             GPR14P) RESTRICTED;/* RESTRICT REGS  0254
*                                      USED BY SETLOCK               */
*                           GENERATE REFS(PSALITA,FLC) SETS(GPR11P,
*                               GPR12P,GPR13P,GPR14P);             0255
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE)
*                           RESPECIFY                              0256
*                            (GPR11P,                              0256
*                             GPR12P,                              0256
*                             GPR13P,                              0256
*                             GPR14P) UNRESTRICTED;/* RELEASE REGS 0256
*                                      USED BY SETLOCK               */
*                         END;      /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                         ESAGLREC=OFF;/* SETLOCK COMPLETED        0258
*                                      SUCCESSFULLY                  */
*                         ESASDREC=ON;/* SDUMP IN CONTROL            */
         OI    ESASDREC+96(R5),B'01000000'                         0259
         NI    ESAGLREC+96(R5),B'11101111'                         0259
*                         GEN(SDUMP SDATA=(SQA,LSQA,LPA,TRT,CSA,SWA));
         SDUMP SDATA=(SQA,LSQA,LPA,TRT,CSA,SWA)
*                         ESASDREC=OFF;/* SDUMP COMPLETED          0261
*                                      SUCCESSFULLY                  */
*                         ESAGLREC=ON;                             0262
         OI    ESAGLREC+96(R5),B'00010000'                         0262
         NI    ESASDREC+96(R5),B'10111111'                         0262
*                         DO;       /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,'FREED BY
*                                      STATUS')                      */
*                           RESPECIFY                              0264
*                            (GPR11P,                              0264
*                             GPR12P,                              0264
*                             GPR13P,                              0264
*                             GPR14P) RESTRICTED;/* RESTRICT REGS  0264
*                                      USED BY SETLOCK               */
*                           GENERATE REFS(PSALITA,FLC) SETS(GPR11P,
*                               GPR12P,GPR13P,GPR14P);             0265
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(TCB,'FREED BY STATUS')
*                           RESPECIFY                              0266
*                            (GPR11P,                              0266
*                             GPR12P,                              0266
*                             GPR13P,                              0266
*                             GPR14P) UNRESTRICTED;/* RELEASE REGS 0266
*                                      USED BY SETLOCK               */
*                         END;      /* SETLOCK OBTAIN TYPE(LOCAL)MODE
*                                      (UNCOND)RELATED(TCB,'FREED BY
*                                      STATUS')                      */
*                         ESAGLREC=OFF;                            0268
         NI    ESAGLREC+96(R5),B'11101111'                         0268
*                       END;                                       0269
*                     ELSE                                         0270
*                       ;           /* RECURSION IN SDUMP - DO NOT 0270
*                                      TRY AGAIN                     */
*                                                                  0270
@RF00250 DS    0H                                                  0271
*                     /***********************************************/
*                     /*                                             */
*                     /* FORCE TERMINATION OF JOBSTEP TASK           */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0271
*                     RESPECIFY                                    0271
*                       R9 RESTRICTED;/* RESTRICT PTR TO JOBSTEP TCB */
*                     R9=TCBJSTCB;  /* LOCATE JOBSTEP TCB            */
         L     R9,TCBJSTCB(,R4)                                    0272
*                     IF R9->TCBABWF=ON THEN                       0273
         TM    TCBABWF(R9),B'01000000'                             0273
         BNO   @RF00273                                            0273
*                       DO;                                        0274
*                                                                  0274
*                         /*******************************************/
*                         /*                                         */
*                         /* RESET JOBSTEP TASK DISPATCHABLE TO      */
*                         /* ABTERM IT                               */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0275
*                         RESPECIFY                                0275
*                          (R0,                                    0275
*                           R1) RESTRICTED;                        0275
*                         R0=STOPTASK;                             0276
         L     R0,@CF00076                                         0276
*                         R1=R9|RESETTCB;                          0277
         LR    R1,R9                                               0277
         O     R1,@CF00072                                         0277
*                         R13=0;                                   0278
         SLR   R13,R13                                             0278
*                         CALL STATUS;                             0279
         L     @12,CVTPTR+96(,R5)                                  0279
         L     @12,SCVTSPTR(,@12)                                  0279
         L     @15,SCVTSTAT(,@12)                                  0279
         BALR  @14,@15                                             0279
*                         RESPECIFY                                0280
*                          (R0,                                    0280
*                           R1) UNRESTRICTED;                      0280
*                       END;                                       0281
*                     GEN REFS(CVTBTERM,CVTMAP,CVTUSER)            0282
*                         (CALLRTM TYPE=ABTERM,TCB=(R9),COMPCOD=X'D0D')
*                         ;                                        0282
@RF00273 DS    0H                                                  0282
         CALLRTM TYPE=ABTERM,TCB=(R9),COMPCOD=X'D0D'
*                     RESPECIFY                                    0283
*                       R9 UNRESTRICTED;                           0283
*                                                                  0283
*                     /***********************************************/
*                     /*                                             */
*                     /* CLEAR ALL RTM2 FIELDS AND FLAGS IN TCB      */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0284
*                     DO;           /* START OF RTECLRFL             */
*                                                                  0284
*                       /*********************************************/
*                       /*                                           */
*                       /* ALL FLAGS IN THE TCB ARE CLEARED SO THAT  */
*                       /* ALL TRACES OF RTM2 WILL BE GONE           */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0285
*                       TCBFX=OFF;  /* PERMIT ASYNCHRONOUS EXITS     */
*                       TCBFT=OFF;  /* TOP TCB FLAG                  */
         NI    TCBFX(R4),B'11111010'                               0286
*                       TCBFPRAP=OFF;/* PERMIT PERCOLATION OF      0287
*                                      ASYNCHRONOUS ERRORS           */
         NI    TCBFPRAP(R4),B'11101111'                            0287
*                     END;                                         0288
*                     TCBRTM2=OFF;                                 0289
         NI    TCBRTM2(R4),B'11110111'                             0289
*                     TCBFA=OFF;                                   0290
         NI    TCBFA(R4),B'01111111'                               0290
*                     TCBRTWA=0;    /* CUT THE WORK AREA QUEUE       */
*                                                                  0291
         SLR   @12,@12                                             0291
         ST    @12,TCBRTWA(,R4)                                    0291
*                     /***********************************************/
*                     /*                                             */
*                     /* CLEAR RBABEND FLAG IN RTM2SVRBS             */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0292
*                     RESPECIFY                                    0292
*                       R9 RESTRICTED;                             0292
*                     R9=NONZERO;                                  0293
         LA    R9,1                                                0293
*                     DO WHILE(R9^=0);/* SCAN UNTIL TCB IS REACHED   */
         B     @DE00294                                            0294
@DL00294 DS    0H                                                  0295
*                       DO;                                        0295
*                         RESPECIFY                                0296
*                           R9 RESTRICTED;                         0296
*                         R9=TCBRBP;/* LOCATE STARTING RB            */
*                                                                  0297
         L     R9,TCBRBP(,R4)                                      0297
*                         /*******************************************/
*                         /*                                         */
*                         /* SCAN FOR RB WITH RBABEND ON. SCAN       */
*                         /* TERMINATED WHEN RBTCBNXT ON             */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0298
*                         DO WHILE(EVAL(R9-LENGTH(RBPRFX))->RBABEND='0'
*                               &R9->RBTCBNXT='0'B);               0298
         B     @DE00298                                            0298
@DL00298 DS    0H                                                  0299
*                           R9=R9->RBLINKB;/* LOCATE NEXT RB         */
         L     @12,RBLINKB-1(,R9)                                  0299
         LA    @12,0(,@12)                                         0299
         LR    R9,@12                                              0299
*                         END;      /* END SCAN OF RBS               */
@DE00298 LR    @12,R9                                              0300
         SL    @12,@CF00453                                        0300
         TM    RBABEND(@12),B'00100000'                            0300
         BNZ   @DC00298                                            0300
         TM    RBTCBNXT(R9),B'10000000'                            0300
         BZ    @DL00298                                            0300
@DC00298 DS    0H                                                  0301
*                         IF EVAL(R9-LENGTH(RBPRFX))->RBABEND='0'B THEN
         LR    @12,R9                                              0301
         SL    @12,@CF00453                                        0301
         TM    RBABEND(@12),B'00100000'                            0301
         BNZ   @RF00301                                            0301
*                                   /* CHECK WHETHER ONE WAS FOUND   */
*                           R9=0;   /* NO RTM2 RB FOUND              */
         SLR   R9,R9                                               0302
*                       END;                                       0303
@RF00301 DS    0H                                                  0304
*                       IF R9^=0 THEN/* IF RTM2 SVRB FOUND           */
         LTR   R9,R9                                               0304
         BZ    @RF00304                                            0304
*                         EVAL(R9-64)->RBABEND=OFF;/* CLEAR RTM2   0305
*                                      INDICATOR                     */
         LR    @12,R9                                              0305
         SL    @12,@CF00453                                        0305
         NI    RBABEND(@12),B'11011111'                            0305
*                       ELSE                                       0306
*                         ;         /* NO RTM2 SVRB FOUND            */
@RF00304 DS    0H                                                  0307
*                     END;                                         0307
@DE00294 LTR   R9,R9                                               0307
         BNZ   @DL00294                                            0307
*                     RESPECIFY                                    0308
*                       R9 UNRESTRICTED;                           0308
*                                                                  0308
*                     /***********************************************/
*                     /*                                             */
*                     /* SET THE CURRENT TASK NONDISPATCHABLE        */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0309
*                     RESPECIFY                                    0309
*                      (R0,                                        0309
*                       R1) RESTRICTED;                            0309
*                     R0=ABWFBE;    /* INDICATE TO SET CURRENT TASK
*                                      NONDISPATCHABLE WITH ABWF     */
         L     R0,@CF00051                                         0310
*                     R1=R4;        /* TCB TO BE STOPPED             */
         LR    R1,R4                                               0311
*                     R13=0;        /* INDICATE CURRENT MEMORY       */
         SLR   R13,R13                                             0312
*                     CALL STATUS;                                 0313
         L     @12,CVTPTR+96(,R5)                                  0313
         L     @12,SCVTSPTR(,@12)                                  0313
         L     @15,SCVTSTAT(,@12)                                  0313
         BALR  @14,@15                                             0313
*                     RESPECIFY                                    0314
*                      (R0,                                        0314
*                       R1) UNRESTRICTED;                          0314
*                   END;            /* END OF RTECVERR               */
*                 END;                                             0316
*               ELSE                /* ONLY CRITICAL RECURSION     0317
*                                      ROUTINE APPLIES               */
*                 DO;                                              0317
         B     @RC00246                                            0317
@RF00246 DS    0H                                                  0318
*                   DO;             /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                     RESPECIFY                                    0319
*                      (GPR11P,                                    0319
*                       GPR12P,                                    0319
*                       GPR13P,                                    0319
*                       GPR14P) RESTRICTED;/* RESTRICT REGS USED BY
*                                                             SETLOCK*/
*                     GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,
*                         GPR13P,GPR14P);                          0320
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE)
*                     RESPECIFY                                    0321
*                      (GPR11P,                                    0321
*                       GPR12P,                                    0321
*                       GPR13P,                                    0321
*                       GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY
*                                                             SETLOCK*/
*                   END;            /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                   CALL RT2CRERR;  /* TERMINATE CURRENT MEMORY      */
         L     @15,RTM2CTRA(,R8)                                   0323
         BALR  @14,@15                                             0323
*                 END;                                             0324
*         END;                      /* END OF RTERCREX               */
*       ELSE                        /* NOT RECURSION                 */
*         IF RTM2EOTX=ON            /* NORMAL END OF TASK            */
*             |RTM2MTX=ON           /* MEMORY TERMINATION            */
*             |RTM2ABX=ON           /* ABNORMAL END OF TASK          */
*             |RTM2RTRX=ON THEN     /* RETRY                         */
*                                                                  0326
         B     @RC00174                                            0326
@RF00174 TM    RTM2EOTX(R8),B'11100001'                            0326
         BZ    @RF00326                                            0326
*           /*********************************************************/
*           /*                                                       */
*           /* RTECMEX CALLS RTEFREWA TO FREE ALL APPROPRIATE WORK   */
*           /* AREAS. IF NOT RETRY INTO RTM2, IT CLEARS ALL RTM2     */
*           /* FLAGS IN THE TCB. IF RETRY EXIT, REGISTERS 0,1 AND 15 */
*           /* ARE RELOADED AND CONTROL IS RETURNED TO THE SYSTEM.   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0327
*           DO;                     /* START OF RTECMEX              */
*                                                                  0327
*             /*******************************************************/
*             /*                                                     */
*             /* DO RECURSION CONTROL                                */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0328
*             RESPECIFY                                            0328
*               R10 RESTRICTED;                                    0328
*             R10=0;                                               0329
         SLR   R10,R10                                             0329
*             R13=ADDR(RTM2SFSA);                                  0330
         LA    R13,RTM2SFSA(,R8)                                   0330
*             GEN FLOWS(CMEXRCR)(STM   R14,R12,12(R13));/* SAVE REGS
*                                      FOR RECUR.                    */
         STM   R14,R12,12(R13)
*             RTM2SKRA=ADDR(CMEXRCR);/* SET RECURSION ADDRESS TO SKIP
*                                      FREEING WORKAREAS             */
*                                                                  0332
         LA    @12,CMEXRCR                                         0332
         ST    @12,RTM2SKRA(,R8)                                   0332
*             /*******************************************************/
*             /*                                                     */
*             /* FREE RTM2 WORK AREAS                                */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0333
*             IF RTM2EOTX=ON|RTM2ABX=ON THEN/* TASK IS TERMINATING   */
         TM    RTM2EOTX(R8),B'01100000'                            0333
         BZ    @RF00333                                            0333
*               ESAEOT=ON;          /* SAVE FLAG IN ESA              */
         OI    ESAEOT+96(R5),B'00000100'                           0334
*             CALL RTEFREWA;                                       0335
@RF00333 BAL   @14,RTEFREWA                                        0335
*CMEXRCR:                           /* REACHED IF RTEFREWA FAILS     */
*             IF ESART2WA^=0 THEN   /* CURRENT WORK AREA NOT FREED   */
CMEXRCR  LA    @12,96                                              0336
         ALR   @12,R5                                              0336
         L     @11,ESART2WA(,@12)                                  0336
         LTR   @11,@11                                             0336
         BZ    @RF00336                                            0336
*               ESAGMREC=ON;        /* SET RECURSION FLAG            */
*                                                                  0337
         OI    ESAGMREC(@12),B'10000000'                           0337
*             /*******************************************************/
*             /*                                                     */
*             /* CLEAR RTM2 FLAGS IN TCB                             */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0338
*             IF R10^=0 THEN        /* IF RETRY, FLAGS ARE CLEARED 0338
*                                      ONLY IF NO MORE RTM2 RBS      */
@RF00336 LTR   R10,R10                                             0338
         BZ    @RF00338                                            0338
*               DO;                                                0339
*                 RESPECIFY                                        0340
*                   R9 RESTRICTED;                                 0340
*                 R9=R10;           /* LOCATE STARTING RB            */
*                                                                  0341
         LR    R9,R10                                              0341
*                 /***************************************************/
*                 /*                                                 */
*                 /* SCAN FOR RB WITH RBABEND ON. SCAN TERMINATED    */
*                 /* WHEN RBTCBNXT ON                                */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0342
*                 DO WHILE(EVAL(R9-LENGTH(RBPRFX))->RBABEND='0'B&R9->
*                       RBTCBNXT='0'B);                            0342
         B     @DE00342                                            0342
@DL00342 DS    0H                                                  0343
*                   R9=R9->RBLINKB; /* LOCATE NEXT RB                */
         L     @12,RBLINKB-1(,R9)                                  0343
         LA    @12,0(,@12)                                         0343
         LR    R9,@12                                              0343
*                 END;              /* END SCAN OF RBS               */
@DE00342 LR    @12,R9                                              0344
         SL    @12,@CF00453                                        0344
         TM    RBABEND(@12),B'00100000'                            0344
         BNZ   @DC00342                                            0344
         TM    RBTCBNXT(R9),B'10000000'                            0344
         BZ    @DL00342                                            0344
@DC00342 DS    0H                                                  0345
*                 IF EVAL(R9-LENGTH(RBPRFX))->RBABEND='0'B THEN/*  0345
*                                      CHECK WHETHER ONE WAS FOUND   */
         LR    @12,R9                                              0345
         SL    @12,@CF00453                                        0345
         TM    RBABEND(@12),B'00100000'                            0345
         BNZ   @RF00345                                            0345
*                   R9=0;           /* NO RTM2 RB FOUND              */
         SLR   R9,R9                                               0346
*               END;                                               0347
*             ELSE                  /* NOT RETRY                     */
*               R9=0;               /* THEREFORE NO RTM2 RBS WILL  0348
*                                      REMAIN                        */
         B     @RC00338                                            0348
@RF00338 SLR   R9,R9                                               0348
*             IF R9=0               /* NO MORE RTM2 RBS WILL BE LEFT
*                                                            @YM02686*/
*                 |ADDR(R9->RBEXSAVE)->ESANEOT=ON/* OR RB IS FOR   0349
*                                      NORMAL EOT            @YM02686*/
*                 |ADDR(R9->RBEXSAVE)->ESAVEOM=ON THEN/* OR RB IS FOR
*                                      END OF MEMORY         @YM02686*/
@RC00338 LTR   R9,R9                                               0349
         BZ    @RT00349                                            0349
         TM    ESANEOT+96(R9),B'00001010'                          0349
         BZ    @RF00349                                            0349
@RT00349 DS    0H                                                  0350
*               DO;                                                0350
*                 DO;               /* START OF RTECLRFL             */
*                                                                  0351
*                   /*************************************************/
*                   /*                                               */
*                   /* ALL FLAGS IN THE TCB ARE CLEARED SO THAT ALL  */
*                   /* TRACES OF RTM2 WILL BE GONE                   */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0352
*                   TCBFX=OFF;      /* PERMIT ASYNCHRONOUS EXITS     */
*                   TCBFT=OFF;      /* TOP TCB FLAG                  */
         NI    TCBFX(R4),B'11111010'                               0353
*                   TCBFPRAP=OFF;   /* PERMIT PERCOLATION OF       0354
*                                      ASYNCHRONOUS ERRORS           */
         NI    TCBFPRAP(R4),B'11101111'                            0354
*                 END;                                             0355
*                 IF R10^=0 THEN    /* RETRY CASE                    */
         LTR   R10,R10                                             0356
         BZ    @RF00356                                            0356
*                   TCBRTM2=OFF;    /* CLEAR RTM2 FLAG               */
         NI    TCBRTM2(R4),B'11110111'                             0357
*               END;                                               0358
*             ELSE                                                 0359
*               ;                   /* RETRY WILL STILL LEAVE RTM2 RB
*                                      ON QUEUE                      */
@RF00349 DS    0H                                                  0360
*             RESPECIFY                                            0360
*               R9 UNRESTRICTED;    /* RELEASE POINTER TO NEXT RTM2
*                                      RB                            */
*                                                                  0360
@RC00349 DS    0H                                                  0361
*             /*******************************************************/
*             /*                                                     */
*             /* RELEASE LOCAL LOCK                                  */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0361
*             ESAGLREC=ON;                                         0361
         OI    ESAGLREC+96(R5),B'00010000'                         0361
*             DO;                   /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*               RESPECIFY                                          0363
*                (GPR11P,                                          0363
*                 GPR12P,                                          0363
*                 GPR13P,                                          0363
*                 GPR14P) RESTRICTED;/* RESTRICT REGS USED BY SETLOCK*/
*               GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P,GPR13P,
*                   GPR14P);                                       0364
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE)
*               RESPECIFY                                          0365
*                (GPR11P,                                          0365
*                 GPR12P,                                          0365
*                 GPR13P,                                          0365
*                 GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY     0365
*                                      SETLOCK                       */
*             END;                  /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*             ESAGLREC=OFF;                                        0367
*                                                                  0367
         NI    ESAGLREC+96(R5),B'11101111'                         0367
*             /*******************************************************/
*             /*                                                     */
*             /* IF RETRY, SET REGISTERS 0,1, AND 15 WITH REQUESTED  */
*             /* VALUES                                              */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0368
*             IF R10^=0 THEN        /* RETRY REQUEST                 */
         LTR   R10,R10                                             0368
         BZ    @RF00368                                            0368
*               DO;                                                0369
*                 RESPECIFY                                        0370
*                  (R0,                                            0370
*                   R1,                                            0370
*                   R15) RESTRICTED;/* RESTRICT REGS PASSED TO RETRY
*                                      ROUTINE                       */
*                 R0=RBGRS0;                                       0371
         L     R0,RBGRS0(,R5)                                      0371
*                 R1=RBGRS1;                                       0372
         L     R1,RBGRS1(,R5)                                      0372
*                 R15=RBGRS15;                                     0373
         L     R15,RBGRS15(,R5)                                    0373
*               END;                                               0374
*             ELSE                  /* NOT RETRY                     */
*               IF ESAEOT=ON THEN   /* TASK TERMINATING              */
         B     @RC00368                                            0375
@RF00368 LA    @14,96                                              0375
         ALR   @14,R5                                              0375
         TM    ESAEOT(@14),B'00000100'                             0375
         BNO   @RF00375                                            0375
*                 DO;                                              0376
*                   TCBEOT=ON;      /* SET FLAG SHOWING EOT DONE     */
         OI    TCBEOT(R4),B'00000100'                              0377
*                   IF ESANEOT=OFF THEN                            0378
         TM    ESANEOT(@14),B'00001000'                            0378
         BNZ   @RF00378                                            0378
*                     TCBFA=ON;                                    0379
         OI    TCBFA(R4),B'10000000'                               0379
*                 END;                                             0380
*                                                                  0380
@RF00378 DS    0H                                                  0381
*             /*******************************************************/
*             /*                                                     */
*             /* RETURN TO SYSTEM                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0381
*             RESPECIFY                                            0381
*               R14 RESTRICTED;     /* RESTRICT RETURN REGISTER      */
@RF00375 DS    0H                                                  0381
@RC00368 DS    0H                                                  0382
*             R14=ESAR14;           /* ORIGINAL RETURN ADDRESS       */
         L     R14,ESAR14+96(,R5)                                  0382
*             GEN(BR    R14);                                      0383
         BR    R14
*             RESPECIFY                                            0384
*              (R0,                                                0384
*               R1,                                                0384
*               R10,                                               0384
*               R14,                                               0384
*               R15) UNRESTRICTED;  /* RELEASE ALL REGISTERS         */
*           END;                    /* END OF RTECMEX                */
*         ELSE                                                     0386
*           IF RTM2PRX=ON           /* PERMANENTLY RESIDENT TASK   0386
*                                      ENDING                        */
*               |RTM2LTX=ON THEN    /* LAST TASK IN MEMORY ENDING    */
*                                                                  0386
         B     @RC00326                                            0386
@RF00326 TM    RTM2PRX(R8),B'00000110'                             0386
         BZ    @RF00386                                            0386
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT RTELTEX DOES THE EXIT FUNCTION IF THE TASK  */
*             /* THAT IS ENDING IS THE LAST TASK IN THE MEMORY OR IF */
*             /* IT IS A PERMANENTLY RESIDENT TASK. IF IT IS THE LAST*/
*             /* TASK IN THE MEMORY, THE CALLRTM MACRO IS ISSUED TO  */
*             /* TERMINATE THE MEMORY. IF IT IS A PERMANENTLY        */
*             /* RESIDENT TASK THE EOT TCB IS POSTED. THIS IS DONE   */
*             /* BECAUSE EXIT IS NOT CALLED FOR PERMANENTLY RESIDENT */
*             /* TASKS AS THE TCB AND RB CANNOT BE FREED. IN BOTH    */
*             /* CASES STATUS IS THEN INVOKED TO SET THE TASK        */
*             /* PERMANENTLY NON-DISPATCHABLE                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0387
*             DO;                                                  0387
*               IF RTM2LTX=ON THEN  /* LAST TASK IN MEMORY IS ENDING.
*                                      CALLRTM TO REMOVE THE MEMORY  */
         TM    RTM2LTX(R8),B'00000010'                             0388
         BNO   @RF00388                                            0388
*                 DO;                                              0389
*                   RESPECIFY                                      0390
*                    (R9,                                          0390
*                     R3) RESTRICTED;/* RESTRICT REGISTERS USED BY 0390
*                                      RTM1                          */
*                   R3=NORM;        /* SET COMP CODE TO ZERO         */
         SLR   R3,R3                                               0391
*                   R9=RMPLASID;    /* SET REG 2 WITH ASID OF MEMORY
*                                      TO BE TERMINATED              */
         LH    R9,RMPLASID+712(,R8)                                0392
         N     R9,@CF02575                                         0392
*                   R13=ADDR(RTM2RMSA);/* SET SAVE AREA ADDR IN REG
*                                      13                            */
         LA    R13,RTM2RMSA(,R8)                                   0393
*                   GENERATE REFS(CVTBTERM,CVTMAP,R9,R3,R13,RTM2RMSA,
*                       CVTUSER);                                  0394
         CALLRTM TYPE=MEMTERM,ASID=(R9),COMPCOD=(R3)
*                   RESPECIFY                                      0395
*                    (R9,                                          0395
*                     R3) UNRESTRICTED;                            0395
*                                                                  0395
*                   /*************************************************/
*                   /*                                               */
*                   /* BRANCH ENTER STATUS TO SET CURRENT TASK       */
*                   /* PERMANENTLY NON-DISPATCHABLE. STATUS WILL     */
*                   /* RELEASE THE LOCAL LOCK                        */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0396
*                   RESPECIFY                                      0396
*                    (R0,                                          0396
*                     R1) RESTRICTED;/* RESTRICT PARAMETER REGISTERS
*                                      FOR STATUS                    */
*                   R0=SENTCD15;    /* SET STATUS ENTRY CODE IN REG 0*/
         LA    R0,15                                               0397
*                   R1=R4;          /* SET CURRENT TCB ADDRESS IN REG
*                                      1                             */
         LR    R1,R4                                               0398
*                   R13=DARPNDBE;   /* SET NON-DISPATCHABILITY MASK
*                                      IN R13                        */
         L     R13,@CF00053                                        0399
*                   CALL STATUS;    /* INVOKE STATUS                 */
         L     @12,CVTPTR+96(,R5)                                  0400
         L     @12,SCVTSPTR(,@12)                                  0400
         L     @15,SCVTSTAT(,@12)                                  0400
         BALR  @14,@15                                             0400
*                   RESPECIFY                                      0401
*                    (R0,                                          0401
*                     R1) UNRESTRICTED;                            0401
*                 END;                                             0402
*               ELSE                /* IF TASK IS PERMANENTLY      0403
*                                      RESIDENT MEMORY SHOULD NOT BE
*                                      TERMINATED                    */
*                                                                  0403
*                 /***************************************************/
*                 /*                                                 */
*                 /* POST EOT ECB IF PERMANENTLY RESIDENT TASK IS    */
*                 /* ENDING AS EXIT WILL NOT BE ENTERED TO DO THIS   */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0403
*                 DO;                                              0403
         B     @RC00388                                            0403
@RF00388 DS    0H                                                  0404
*                   RESPECIFY                                      0404
*                    (R10,                                         0404
*                     R11,                                         0404
*                     R12) RESTRICTED;/* RESTRICT REGISTERS USED BY
*                                      POST                          */
*                   R10=RTM2CC;     /* SET POST COMPLETION CODE IN 0405
*                                      REG 10                        */
         L     R10,RTM2CC-1(,R8)                                   0405
         LA    R10,0(,R10)                                         0405
*                   R11=TCBECB;     /* SET ADDRESS OF ECB IN REG 11  */
         L     R11,TCBECB(,R4)                                     0406
*                   IF R11^=0 THEN  /* EOT ECB EXISTS                */
         LTR   R11,R11                                             0407
         BZ    @RF00407                                            0407
*                     DO;                                          0408
*                       CALL POST;  /* INVOKE POST                   */
         L     @09,CVTPTR+96(,R5)                                  0409
         L     @15,CVT0PT01(,@09)                                  0409
         BALR  @14,@15                                             0409
*                     END;                                         0410
*                   ELSE                                           0411
*                     ;             /* NO ECB                        */
@RF00407 DS    0H                                                  0412
*                   RESPECIFY                                      0412
*                    (R10,                                         0412
*                     R11,                                         0412
*                     R12) UNRESTRICTED;/* RELEASE REGISTERS         */
*                                                                  0412
*                   /*************************************************/
*                   /*                                               */
*                   /* BRANCH ENTER STATUS TO SET CURRENT TASK       */
*                   /* PERMANENTLY NON-DISPATCHABLE USING TCBFC.     */
*                   /* STATUS WILL RELEASE THE LOCAL LOCK            */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0413
*                   RESPECIFY                                      0413
*                    (R0,                                          0413
*                     R1) RESTRICTED;                              0413
*                   R0=FCBE;        /* SET R0 WITH REQUEST FOR TCBFC
*                                      NON-DISPATCHABILITY           */
         L     R0,@CF00057                                         0414
*                   R1=R4;          /* INDICATE CURRENT TCB          */
         LR    R1,R4                                               0415
*                   R13=0;          /* INDICATE CURRENT MEMORY       */
         SLR   R13,R13                                             0416
*                   CALL STATUS;                                   0417
         L     @12,CVTPTR+96(,R5)                                  0417
         L     @12,SCVTSPTR(,@12)                                  0417
         L     @15,SCVTSTAT(,@12)                                  0417
         BALR  @14,@15                                             0417
*                   RESPECIFY                                      0418
*                    (R0,                                          0418
*                     R1) UNRESTRICTED;                            0418
*                 END;                                             0419
*             END;                  /* END SEGMENT RTELTEX           */
*           ELSE                                                   0421
*             IF RTM2CVX=ON THEN    /* CONVERSION TO STEP            */
*                                                                  0421
         B     @RC00386                                            0421
@RF00386 TM    RTM2CVX(R8),B'00001000'                             0421
         BNO   @RF00421                                            0421
*               /*****************************************************/
*               /*                                                   */
*               /* RTECNVEX FREES ALL WORKAREAS EXCEPT THE CURRENT.  */
*               /* IT THEN SETS UP THE JOBSTEP TCB TO BE TERMINATED  */
*               /* AND INVOKES RTM1 TO TERMINATE IT. IT THEN CLEARS  */
*               /* ITS OWN TCB FLAGS AND RETURNS TO THE SYSTEM.      */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0422
*               DO;                 /* START OF RTECNVEX             */
*                                                                  0422
*                 /***************************************************/
*                 /*                                                 */
*                 /* SET UP RECURSION ENVIRONMENT                    */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0423
*                 RTM2SCTC(RTM2EXTS)=OFF;/* EARLIER PROCESSING SHOULD
*                                      BE SKIPPED IF THIS SECTION  0423
*                                      FAILS                         */
         NI    RTM2SCTC+1(R8),B'10111111'                          0423
*                 R13=ADDR(RTM2SFSA);                              0424
         LA    R13,RTM2SFSA(,R8)                                   0424
*                 GEN FLOWS(CNVEXRCR)(STM   R14,R12,12(R13));/* SAVE
*                                      REGS IN CASE OF RECURSION     */
         STM   R14,R12,12(R13)
*                 RTM2SKRA=ADDR(CNVEXRCR);/* SKIP FREEMAIN IF IT   0426
*                                      FAILS                         */
*                                                                  0426
         LA    @12,CNVEXRCR                                        0426
         ST    @12,RTM2SKRA(,R8)                                   0426
*                 /***************************************************/
*                 /*                                                 */
*                 /* FREE ALL PREVIOUS WORK AREAS                    */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0427
*                 CALL RTEFREWA;                                   0427
         BAL   @14,RTEFREWA                                        0427
*CNVEXRCR:                          /* REACHED ON RECURSION          */
*                                                                  0428
*                 /***************************************************/
*                 /*                                                 */
*                 /* CLEAR RECURSION ENVIRONMENT                     */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0428
*                 RTM2SKRA=0;       /* MEMORY MUST BE TERMINATED IF
*                                      JOBSTEP CANNOT BE ABTERMED    */
CNVEXRCR SLR   @12,@12                                             0428
         ST    @12,RTM2SKRA(,R8)                                   0428
*                 RTM2STRA=0;                                      0429
*                                                                  0429
         ST    @12,RTM2STRA(,R8)                                   0429
*                 /***************************************************/
*                 /*                                                 */
*                 /* SET UP ENVIRONMENT TO RESUME AT JOBSTEP LEVEL   */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0430
*                 RESPECIFY                                        0430
*                   R9 RESTRICTED;  /* RESTRICT PTR TO JOBSTEP       */
*                 R9=TCBJSTCA;      /* LOCATE JOBSTEP TCB            */
         L     R9,TCBJSTCA-1(,R4)                                  0431
         LA    R9,0(,R9)                                           0431
*                 RESPECIFY                                        0432
*                   TCB BASED(R9);  /* PREPARE TO SET UP JOBSTEP TCB */
*                 DO;               /* START OF RTECLRFL             */
*                                                                  0433
*                   /*************************************************/
*                   /*                                               */
*                   /* ALL FLAGS IN THE TCB ARE CLEARED SO THAT ALL  */
*                   /* TRACES OF RTM2 WILL BE GONE                   */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0434
*                   TCBFX=OFF;      /* PERMIT ASYNCHRONOUS EXITS     */
*                   TCBFT=OFF;      /* TOP TCB FLAG                  */
         NI    TCBFX(R9),B'11111010'                               0435
*                   TCBFPRAP=OFF;   /* PERMIT PERCOLATION OF       0436
*                                      ASYNCHRONOUS ERRORS           */
         NI    TCBFPRAP(R9),B'11101111'                            0436
*                 END;                                             0437
*                 RTM2PREV=0;       /* TRUNCATE WORKAREA QUEUE IN  0438
*                                      CASE FREEMAIN FAILED          */
         ST    @12,RTM2PREV(,R8)                                   0438
*                 TCBRTWA=R8;       /* QUEUE CURRENT WORKAREA FROM 0439
*                                      JOBSTEP TCB                   */
         ST    R8,TCBRTWA(,R9)                                     0439
*                 R4->TCBRTWA=0;    /* DEQUEUE CURRENT WORKAREA FROM
*                                      CURRENT TCB                   */
         ST    @12,TCBRTWA(,R4)                                    0440
*                 ESART2WA=0;       /* DEQUEUE WORK AREA FROM SVRB   */
         LA    @07,96                                              0441
         ALR   @07,R5                                              0441
         ST    @12,ESART2WA(,@07)                                  0441
*                 RESPECIFY                                        0442
*                   TCB BASED(R4);  /* RESUME PROCESSING OF CURRENT
*                                      TCB                           */
*                                                                  0442
*                 /***************************************************/
*                 /*                                                 */
*                 /* CAUSE RTM2 TO BE ENTERED ON JOB STEP TCB        */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0443
*                 RESPECIFY                                        0443
*                  (R0,                                            0443
*                   R1) RESTRICTED; /* RESTRICT STATUS INTERFACE REGS*/
*                 R0=STOPTASK;      /* RESET ABWF NON-DISPATCHABILITY*/
         L     R0,@CF00076                                         0444
*                 R1=R9|RESETTCB;                                  0445
         LR    R1,R9                                               0445
         O     R1,@CF00072                                         0445
*                 R13=0;            /* INDICATE CURRENT MEMORY       */
         SLR   R13,R13                                             0446
*                 CALL STATUS;                                     0447
         L     @12,CVTPTR(,@07)                                    0447
         L     @12,SCVTSPTR(,@12)                                  0447
         L     @15,SCVTSTAT(,@12)                                  0447
         BALR  @14,@15                                             0447
*                 RESPECIFY                                        0448
*                   R2 RESTRICTED;  /* RESTRICT INTERFACE REG TO   0448
*                                      CALLRTM                       */
*                 GEN REFS(CVTBTERM,CVTMAP) SETS(R2,R13)           0449
*(CALLRTM TYPE=ABTERM,COMPCOD=X'20D',TCB=(R9),DUMP=NO);            0449
         CALLRTM TYPE=ABTERM,COMPCOD=X'20D',TCB=(R9),DUMP=NO
*                 RESPECIFY                                        0450
*                  (R0,                                            0450
*                   R1,                                            0450
*                   R2,                                            0450
*                   R9) UNRESTRICTED;/* RELEASE ALL REGS             */
*                                                                  0450
*                 /***************************************************/
*                 /*                                                 */
*                 /* CLEAR RTM2 FLAGS AND FIELDS                     */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0451
*                 DO;               /* START OF RTECLRFL             */
*                                                                  0451
*                   /*************************************************/
*                   /*                                               */
*                   /* ALL FLAGS IN THE TCB ARE CLEARED SO THAT ALL  */
*                   /* TRACES OF RTM2 WILL BE GONE                   */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0452
*                   TCBFX=OFF;      /* PERMIT ASYNCHRONOUS EXITS     */
*                   TCBFT=OFF;      /* TOP TCB FLAG                  */
         NI    TCBFX(R4),B'11111010'                               0453
*                   TCBFPRAP=OFF;   /* PERMIT PERCOLATION OF       0454
*                                      ASYNCHRONOUS ERRORS           */
         NI    TCBFPRAP(R4),B'11101111'                            0454
*                 END;                                             0455
*                                                                  0455
*                 /***************************************************/
*                 /*                                                 */
*                 /* RETURN TO SYSTEM                                */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0456
*                 TCBEOT=ON;        /* INDICATE END OF TASK        0456
*                                      PROCESSING COMPLETED          */
         OI    TCBEOT(R4),B'00000100'                              0456
*                 DO;               /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                   RESPECIFY                                      0458
*                    (GPR11P,                                      0458
*                     GPR12P,                                      0458
*                     GPR13P,                                      0458
*                     GPR14P) RESTRICTED;/* RESTRICT REGS USED BY  0458
*                                      SETLOCK                       */
*                   GENERATE REFS(PSALITA,FLC) SETS(GPR11P,GPR12P, 0459
*                       GPR13P,GPR14P);                            0459
         SETLOCK RELEASE,TYPE=LOCAL,                                   C
               RELATED=(TCB,IEAVTRTE)
*                   RESPECIFY                                      0460
*                    (GPR11P,                                      0460
*                     GPR12P,                                      0460
*                     GPR13P,                                      0460
*                     GPR14P) UNRESTRICTED;/* RELEASE REGS USED BY 0460
*                                      SETLOCK                       */
*                 END;              /* SETLOCK RELEASE TYPE(LOCAL)REL
*                                      ATED(TCB,IEAVTRTE)            */
*                 RESPECIFY                                        0462
*                   R14 RESTRICTED; /* RESTRICT RETURN REGISTER      */
*                 R14=ESAR14;       /* ORIGINAL RETURN ADDRESS       */
         L     R14,ESAR14+96(,R5)                                  0463
*                 GEN(BR    R14);   /* RETURN TO SYSTEM              */
         BR    R14
*                 RESPECIFY                                        0465
*                   R14 UNRESTRICTED;                              0465
*               END;                /* END OF RTECNVEX               */
*             ELSE                                                 0467
*               IF RTM2DWX=ON THEN                                 0467
*                                                                  0467
         B     @RC00421                                            0467
@RF00421 TM    RTM2DWX(R8),B'00010000'                             0467
         BNO   @RF00467                                            0467
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT RTESWEX DOES THE EXIT FUNCTION IF A     */
*                 /* SUBTASK IS WAITING TO ABEND THIS TASK. IT       */
*                 /* INVOKES RTEFREWA TO RELEASE ANY RTM2 WORK AREAS */
*                 /* AND THEN POSTS THE ECB POINTED TO BY TCBAECB TO */
*                 /* WAKE UP THE WAITING SUBTASK. IT THEN INVOKES    */
*                 /* STATUS TO SET ITSELF NONDISPATCHABLE.           */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0468
*                 DO;               /* BEGIN SEGMENT RTESWEX         */
*                   RTM2SKRA=ADDR(RTESWREC);/* SET RECURSION ADDRESS
*                                      TO SKIP FREEING WORK AREAS ON
*                                      RECURSION                     */
         LA    @12,RTESWREC                                        0469
         ST    @12,RTM2SKRA(,R8)                                   0469
*                   GENERATE REFS(RTM2SFSA,R8);                    0470
         STM   14,12,RTM2SFSA+12(R8)
*                   CALL RTEFREWA;  /* RELEASE RTM2 WORK AREAS       */
         BAL   @14,RTEFREWA                                        0471
*RTESWREC:                                                         0472
*                   ;                                              0472
RTESWREC DS    0H                                                  0473
*                   ESAGMREC=OFF;   /* CLEAR RECURSION FLAG BECAUSE
*                                      RECURSION EXPECTED DUE TO   0473
*                                      CONVERSION                    */
         NI    ESAGMREC+96(R5),B'01111111'                         0473
*                   RESPECIFY                                      0474
*                    (R10,                                         0474
*                     R11,                                         0474
*                     R12) RESTRICTED;/* RESTRICT REGISTERS USED BY
*                                      POST                          */
*RTESWL1:                                                          0475
*                   ;               /* LABEL TO PREVENT COMPILER   0475
*                                      TEMP.                         */
RTESWL1  DS    0H                                                  0476
*                   R10=0;          /* SET POST CODE IN REG 10       */
         SLR   R10,R10                                             0476
*                   R11=TCBAECB;    /* SET ECB ADDRESS IN REG 11     */
         L     R11,TCBAECB(,R4)                                    0477
*                   CALL POST;      /* INVOKE POST                   */
         L     @09,CVTPTR+96(,R5)                                  0478
         L     @15,CVT0PT01(,@09)                                  0478
         BALR  @14,@15                                             0478
*                   RESPECIFY                                      0479
*                    (R10,                                         0479
*                     R11,                                         0479
*                     R12) UNRESTRICTED;/* RELEASE REGISTERS         */
*                   RESPECIFY                                      0480
*                    (R0,                                          0480
*                     R1) RESTRICTED;/* RESTRICT REGISTERS USED BY 0480
*                                      STATUS                        */
*                   R0=ABWFBE;      /* SET ENTRY CODE AND NON-     0481
*                                      DISPATCHABILITY MASK IN REG 0 */
         L     R0,@CF00051                                         0481
*                   R1=R4;          /* SET CURRENT TCB ADDRESS       */
         LR    R1,R4                                               0482
*                   R13=0;                                         0483
         SLR   R13,R13                                             0483
*                   CALL STATUS;                                   0484
         L     @12,CVTPTR+96(,R5)                                  0484
         L     @12,SCVTSPTR(,@12)                                  0484
         L     @15,SCVTSTAT(,@12)                                  0484
         BALR  @14,@15                                             0484
*                   RESPECIFY                                      0485
*                    (R0,                                          0485
*                     R1) UNRESTRICTED;                            0485
*                 END;              /* END SEGMENT RTESWEX           */
*               ELSE                                               0487
*                 ;                                                0487
@RF00467 DS    0H                                                  0488
*     END;                                                         0488
@RC00421 DS    0H                                                  0488
@RC00386 DS    0H                                                  0488
@RC00326 DS    0H                                                  0488
@RC00174 DS    0H                                                  0489
*   R13=ADDR(RTM2CREG);                                            0489
@RF00162 LA    R13,RTM2CREG(,R8)                                   0489
*   RETURN CODE(ERROR);             /* NO EXIT FLAG WAS ON OR SOME 0490
*                                      ROUTINE DID NOT EXIT OR     0490
*                                      CRITICAL EXIT FLAG WAS ON     */
         LA    @15,4                                               0490
         L     @14,12(,@13)                                        0490
         LM    @00,@12,20(@13)                                     0490
         BR    @14                                                 0490
*RTEFREWA:                                                         0491
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0491
*                                                                  0491
RTEFREWA DS    0H                                                  0492
*   /*****************************************************************/
*   /*                                                               */
*   /* INTERNAL PROCEDURE RTEFREWA LOCATES THE SVRBS WHICH BELONG TO */
*   /* RTM2 AND FREES THE ASSOCIATED WORKAREAS. THIS IS DONE ONLY UP */
*   /* TO THE RETRY RB IF RETRY WAS REQUESTED. THE CURRENT RTM2WA IS */
*   /* NOT FREED IF 'CONVERSION TO STEP EXIT' WAS REQUESTED AS IT    */
*   /* WILL BE REQUEUED FROM THE JOBSTEP TCB. AFTER FINDING AN RTM2  */
*   /* SVRB THIS PROCEDURE INCLUDES SEGMENT RTEWADQ TO DEQUEUE THE   */
*   /* RTM2WA FROM THE TCB AND FROM THE ASCB IF NECESSARY. IT THEN   */
*   /* FREES THE SDWA(RTCA) IF IT WAS NOT PREVIOUSLY RELEASED AND    */
*   /* THEN FREES THE RTM2WA. PRIOR TO FREEING THE CURRENT RTM2WA IT */
*   /* SETS THE ESAGMREC FLAG SO THAT ANY RECURSION AFTER THE LAST   */
*   /* WORK AREA HAS BEEN FREED WILL CAUSE ENTRY INTO THE CRITICAL   */
*   /* RECURSION ROUTINE.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0492
*   RESPECIFY                                                      0492
*     R7 RESTRICTED;                /* RESTRICT REG USED TO POINT TO
*                                      ASCB                          */
*   R7=RTM2ASC;                     /* PUT ASCB ADDR IN REG          */
         L     R7,RTM2ASC(,R8)                                     0493
*   RESPECIFY                                                      0494
*    (R14,                                                         0494
*     R12) RESTRICTED;                                             0494
*   R12=R14;                        /* SAVE RETURN ADDRESS           */
         LR    R12,R14                                             0495
*   RESPECIFY                                                      0496
*     R14 UNRESTRICTED;                                            0496
*   IF RTM2RETR=ON THEN             /* RETRY WAS REQUESTED           */
         TM    RTM2RETR(R8),B'01000000'                            0497
         BNO   @RF00497                                            0497
*     DO;                                                          0498
*       RESPECIFY                                                  0499
*         R10 RESTRICTED;           /* RESTRICT REG USED TO HOLD   0499
*                                      RETRY RB ADDRESS              */
*       R10=RTM2RYRB;               /* SET RETRY RB REGISTER EQUAL TO
*                                      RETRY RB ADDRESS              */
*                                                                  0500
         L     R10,RTM2RYRB(,R8)                                   0500
*       /*************************************************************/
*       /*                                                           */
*       /* FIND FIRST RTM2 SVRB OLDER THAN THE RETRY RB              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0501
*       DO;                                                        0501
*         RESPECIFY                                                0502
*           R9 RESTRICTED;                                         0502
*         R9=R10;                   /* LOCATE STARTING RB            */
*                                                                  0503
         LR    R9,R10                                              0503
*         /***********************************************************/
*         /*                                                         */
*         /* SCAN FOR RB WITH RBABEND ON. SCAN TERMINATED WHEN       */
*         /* RBTCBNXT ON                                             */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0504
*         DO WHILE(EVAL(R9-LENGTH(RBPRFX))->RBABEND='0'B&R9->RBTCBNXT=
*               '0'B);                                             0504
         B     @DE00504                                            0504
@DL00504 DS    0H                                                  0505
*           R9=R9->RBLINKB;         /* LOCATE NEXT RB                */
         L     @11,RBLINKB-1(,R9)                                  0505
         LA    @11,0(,@11)                                         0505
         LR    R9,@11                                              0505
*         END;                      /* END SCAN OF RBS               */
@DE00504 LR    @11,R9                                              0506
         SL    @11,@CF00453                                        0506
         TM    RBABEND(@11),B'00100000'                            0506
         BNZ   @DC00504                                            0506
         TM    RBTCBNXT(R9),B'10000000'                            0506
         BZ    @DL00504                                            0506
@DC00504 DS    0H                                                  0507
*         IF EVAL(R9-LENGTH(RBPRFX))->RBABEND='0'B THEN/* CHECK    0507
*                                      WHETHER ONE WAS FOUND         */
         LR    @11,R9                                              0507
         SL    @11,@CF00453                                        0507
         TM    RBABEND(@11),B'00100000'                            0507
         BNZ   @RF00507                                            0507
*           R9=0;                   /* NO RTM2 RB FOUND              */
         SLR   R9,R9                                               0508
*       END;                                                       0509
@RF00507 DS    0H                                                  0510
*     END;                                                         0510
*   ELSE                            /* RETRY NOT REQUESTED-SCAN    0511
*                                      SHOULD END WHEN NO MORE RTM2
*                                      SVRBS EXIST                   */
*     R9=0;                         /* SET REGISTER TO END INDICATION*/
         B     @RC00497                                            0511
@RF00497 SLR   R9,R9                                               0511
*   RESPECIFY                                                      0512
*     R11 RESTRICTED;               /* RESTRICT REGISTER USED IN SCAN*/
@RC00497 DS    0H                                                  0513
*   R11=R5;                         /* SET EQUAL TO CURRENT SVRB     */
*                                                                  0513
         LR    R11,R5                                              0513
*   /*****************************************************************/
*   /*                                                               */
*   /* LOOP UNTIL LAST RTM2SVRB PROCESSED OR LAST RTM2 SVRB NEWER    */
*   /* THAN THE RETRY RB PROCESSED                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0514
*   DO WHILE(R9^=R11);                                             0514
*                                                                  0514
         B     @DE00514                                            0514
@DL00514 DS    0H                                                  0515
*     /***************************************************************/
*     /*                                                             */
*     /* FIND RTM2 SVRB                                              */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0515
*     DO;                                                          0515
*       RESPECIFY                                                  0516
*         R11 RESTRICTED;                                          0516
*       R11=R11->RBLINKB;           /* LOCATE STARTING RB            */
*                                                                  0517
         L     @15,RBLINKB-1(,R11)                                 0517
         LA    @15,0(,@15)                                         0517
         LR    R11,@15                                             0517
*       /*************************************************************/
*       /*                                                           */
*       /* SCAN FOR RB WITH RBABEND ON. SCAN TERMINATED WHEN RBTCBNXT*/
*       /* ON                                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0518
*       DO WHILE(EVAL(R11-LENGTH(RBPRFX))->RBABEND='0'B&R11->RBTCBNXT=
*             '0'B);                                               0518
         B     @DE00518                                            0518
@DL00518 DS    0H                                                  0519
*         R11=R11->RBLINKB;         /* LOCATE NEXT RB                */
         L     @15,RBLINKB-1(,R11)                                 0519
         LA    @15,0(,@15)                                         0519
         LR    R11,@15                                             0519
*       END;                        /* END SCAN OF RBS               */
@DE00518 LR    @15,R11                                             0520
         SL    @15,@CF00453                                        0520
         TM    RBABEND(@15),B'00100000'                            0520
         BNZ   @DC00518                                            0520
         TM    RBTCBNXT(R11),B'10000000'                           0520
         BZ    @DL00518                                            0520
@DC00518 DS    0H                                                  0521
*       IF EVAL(R11-LENGTH(RBPRFX))->RBABEND='0'B THEN/* CHECK     0521
*                                      WHETHER ONE WAS FOUND         */
         LR    @15,R11                                             0521
         SL    @15,@CF00453                                        0521
         TM    RBABEND(@15),B'00100000'                            0521
         BNZ   @RF00521                                            0521
*         R11=0;                    /* NO RTM2 RB FOUND              */
         SLR   R11,R11                                             0522
*     END;                                                         0523
@RF00521 DS    0H                                                  0524
*     IF(R9=R11)&RTM2CVX=OFF THEN   /* SCAN COMPLETE AND CONVERSION
*                                      EXIT NOT REQUESTED            */
         CR    R9,R11                                              0524
         BNE   @RF00524                                            0524
         TM    RTM2CVX(R8),B'00001000'                             0524
         BNZ   @RF00524                                            0524
*       DO;                         /* PROCESS CURRENT SVRB          */
*         R11=R5;                   /* SET REG EQUAL TO CURRENT SVRB */
         LR    R11,R5                                              0526
*         R9=R5;                    /* SET CONTROL REGISTER EQUAL TO
*                                      CURRENT TO TERMINATE LOOP     */
         LR    R9,R5                                               0527
*         R8='FFFFFFFF'X;           /* FORCE PROGRAM CHECK IF RTM2PTR
*                                      USED AFTER CURRENT WORK AREA
*                                      RELEASED                      */
         SLR   R8,R8                                               0528
         BCTR  R8,0                                                0528
*         ESAGMREC=ON;              /* SET RECURSION FLAG            */
         OI    ESAGMREC+96(R5),B'10000000'                         0529
*       END;                                                       0530
*     ELSE                                                         0531
*       ;                           /* REGISTERS NOT EQUAL OR      0531
*                                      REGISTERS EQUAL TO ZERO AND 0531
*                                      RTM2CVX IS ON                 */
@RF00524 DS    0H                                                  0532
*     IF R11^=0 THEN                /* PROCESS WORK AREA POINTED TO
*                                      BY RTM2SVRB                   */
         SLR   @15,@15                                             0532
         CR    R11,@15                                             0532
         BE    @RF00532                                            0532
*       DO;                                                        0533
*         RESPECIFY                                                0534
*           RTM2ESA BASED(ADDR(R11->RBEXSAVE));/* BASE ESA ON      0534
*                                      RTM2SVRB FOUND BY SCAN        */
*         IF ESART2WA^=0 THEN       /* WORK AREA NOT FREED DURING  0535
*                                      PREVIOUS PROCESSING           */
         L     @14,ESART2WA+96(,R11)                               0535
         CR    @14,@15                                             0535
         BE    @RF00535                                            0535
*           DO;                                                    0536
*             RESPECIFY                                            0537
*               RTM2WA BASED(ESART2WA);/* BASE RTM2WA ON ONE POINTED
*                                      TO BY ESA                     */
*             IF RTM2ID='RTM2' THEN /* VALID WORK AREA FOUND         */
         CLC   RTM2ID(4,@14),@CC02532                              0538
         BNE   @RF00538                                            0538
*               DO;                                                0539
*                                                                  0539
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT RTEWADQ REMOVES THE RTM2WA FROM THE TCB */
*                 /* QUEUE AND FROM THE ASCB QUEUE IF NECESSARY.(IF  */
*                 /* THE WORK AREA WAS OBTAINED FROM SQA IT WAS      */
*                 /* QUEUED TO THE ASCB AS WELL AS THE TCB). THE     */
*                 /* QUEUE IS CHAINED SUCH THAT THE ASCB OR TCB      */
*                 /* POINTS TO THE MOST RECENT ONE QUEUED AND THE    */
*                 /* EARLIEST ONE QUEUED CONTAINS ZERO IN ITS CHAIN  */
*                 /* FIELD.                                          */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0540
*                 DO;               /* BEGIN SEGMENT RTEWADQ         */
*                   RESPECIFY                                      0541
*                     R2 RESTRICTED;/* RESTRICT WORK REGISTER        */
*                   IF RTM2SQS=ON THEN/* WORKAREA WAS OBTAINED FROM
*                                      SQA AND IS QUEUED TO ASCB     */
         TM    RTM2SQS(@14),B'00100000'                            0542
         BNO   @RF00542                                            0542
*                     DO;                                          0543
*                                                                  0543
*                       /*********************************************/
*                       /*                                           */
*                       /* DEQUEUE THE RTM2WA FROM THE ASCB          */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0544
*                       R2=ASCBRTWA;/* SET WORK REG EQUAL TO LAST  0544
*                                      RTM2WA QUEUED                 */
         L     R2,ASCBRTWA(,R7)                                    0544
*                       IF R2^=ESART2WA THEN/* NOT LAST QUEUED       */
         CR    R2,@14                                              0545
         BE    @RF00545                                            0545
*                         DO;                                      0546
*                                                                  0546
*                           /*****************************************/
*                           /*                                       */
*                           /* LOOP UNTIL WORK REGISTER POINTS TO THE*/
*                           /* RTM2WA WHICH POINTS TO THE ONE TO BE  */
*                           /* RELEASED                              */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0547
*                           DO WHILE(ESART2WA^=R2->RTM2SPWA);      0547
         B     @DE00547                                            0547
@DL00547 DS    0H                                                  0548
*                             R2=R2->RTM2SPWA;/* SET WORK REGISTER 0548
*                                      EQUAL TO NEXT WORK AREA ON  0548
*                                      QUEUE                         */
         L     R2,RTM2SPWA(,R2)                                    0548
*                           END;                                   0549
@DE00547 L     @03,ESART2WA+96(,R11)                               0549
         C     @03,RTM2SPWA(,R2)                                   0549
         BNE   @DL00547                                            0549
*                           R2->RTM2SPWA=RTM2SPWA;/* REQUEUE WORK  0550
*                                      AREAS                         */
         L     @03,RTM2SPWA(,@03)                                  0550
         ST    @03,RTM2SPWA(,R2)                                   0550
*                         END;                                     0551
*                       ELSE        /* WORK AREA TO BE RELEASED WAS
*                                      LAST QUEUED                   */
*                         ASCBRTWA=RTM2SPWA;/* REQUEUE WORK AREAS    */
         B     @RC00545                                            0552
@RF00545 L     @03,ESART2WA+96(,R11)                               0552
         L     @03,RTM2SPWA(,@03)                                  0552
         ST    @03,ASCBRTWA(,R7)                                   0552
*                     END;                                         0553
*                   ELSE                                           0554
*                     ;             /* WORK AREA NOT QUEUED FROM ASCB*/
*                                                                  0554
@RF00542 DS    0H                                                  0555
*                   /*************************************************/
*                   /*                                               */
*                   /* DEQUEUE WORK AREA FROM TCB                    */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0555
*                   R2=TCBRTWA;     /* SET WORK REG EQUAL TO LAST  0555
*                                      RTM2WA QUEUED.                */
@RC00542 L     R2,TCBRTWA(,R4)                                     0555
*                   IF R2^=ESART2WA THEN/* NOT LAST QUEUED           */
         C     R2,ESART2WA+96(,R11)                                0556
         BE    @RF00556                                            0556
*                     DO;                                          0557
*                                                                  0557
*                       /*********************************************/
*                       /*                                           */
*                       /* LOOP UNTIL WORK REGISTER POINTS TO THE    */
*                       /* RTM2WA WHICH POINTS TO THE ONE TO BE      */
*                       /* RELEASED                                  */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0558
*                       DO WHILE(ESART2WA^=R2->RTM2PREV);          0558
         B     @DE00558                                            0558
@DL00558 DS    0H                                                  0559
*                         R2=R2->RTM2PREV;/* SET WORK REGISTER EQUAL
*                                      TO NEXT WORK AREA ON QUEUE    */
         L     R2,RTM2PREV(,R2)                                    0559
*                       END;                                       0560
@DE00558 L     @03,ESART2WA+96(,R11)                               0560
         C     @03,RTM2PREV(,R2)                                   0560
         BNE   @DL00558                                            0560
*                       R2->RTM2PREV=RTM2PREV;/* REQUEUE WORK AREAS  */
         L     @03,RTM2PREV(,@03)                                  0561
         ST    @03,RTM2PREV(,R2)                                   0561
*                     END;                                         0562
*                   ELSE            /* WORKAREA TO BE RELEASED WAS 0563
*                                      LAST QUEUED                   */
*                     DO;           /* YES....               @ZA17767*/
         B     @RC00556                                            0563
@RF00556 DS    0H                                                  0564
*                       TCBRTWA=RTM2PREV;/* REQUEUE WORK AREAS       */
         L     @03,ESART2WA+96(,R11)                               0564
         L     @03,RTM2PREV(,@03)                                  0564
         ST    @03,TCBRTWA(,R4)                                    0564
*                       IF TCBRTWA^=0 THEN/* RTM2 WORKAREA AVAILABLE
*                                                            @ZA17767*/
         LTR   @03,@03                                             0565
         BZ    @RF00565                                            0565
*                         TCBCMPC=RTM2PREV->RTM2CC;/* PUT RETURN CODE
*                                      IN TCB RETURN CODE    @ZA17767*/
         MVC   TCBCMPC(3,R4),RTM2CC(@03)                           0566
*                       ELSE                                       0567
*                         ;         /* NO RTM2WA SO LEAVE COMPLETION
*                                      CODE IN TCB           @ZA17767*/
@RF00565 DS    0H                                                  0568
*                     END;          /* END... PREVIOUS WORKAREA    0568
*                                                            @ZA17767*/
*                   RESPECIFY                                      0569
*                     R2 UNRESTRICTED;/* RELEASE WORK REGISTER       */
@RC00556 DS    0H                                                  0570
*                 END;              /* END SEQMENT RTEWADQ           */
*                                                                  0570
*                 /***************************************************/
*                 /*                                                 */
*                 /* RELEASE SDWA(RTCA) POINTED TO BY RTM2WA IF      */
*                 /* NECESSARY                                       */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0571
*                 IF(R9^=R11)|(R9=R11&RTM2RETR=OFF) THEN           0571
         CR    R9,R11                                              0571
         BNE   @RT00571                                            0571
         CR    R9,R11                                              0571
         BNE   @RF00571                                            0571
         L     @01,ESART2WA+96(,R11)                               0571
         TM    RTM2RETR(@01),B'01000000'                           0571
         BNZ   @RF00571                                            0571
@RT00571 DS    0H                                                  0572
*                   IF RTM2RTCA^=0&RTM2WAIN=OFF THEN/* VALID SDWA  0572
*                                      (RTCA) EXISTS                 */
         L     @15,ESART2WA+96(,R11)                               0572
         L     @14,RTM2RTCA(,@15)                                  0572
         LTR   @14,@14                                             0572
         BZ    @RF00572                                            0572
         TM    RTM2WAIN(@15),B'01000000'                           0572
         BNZ   @RF00572                                            0572
*FREERTCA:                          /* THIS STATEMENT IS LABELLED TO
*                                      PREVENT USE OF COMPILER     0573
*                                      TEMPORARY                     */
*                     DO;           /* FREEMAIN(RC)                0573
*                                      LV(RTM2SIZE)A(SDWA)         0573
*                                      SP(RTM2SUBP) BRANCH           */
FREERTCA DS    0H                                                  0574
*                       RESPECIFY                                  0574
*                        (GPR01F,                                  0574
*                         GPR03F,                                  0574
*                         GPR00F) RESTRICTED;                      0574
*                       GPR01F=0;   /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0575
*                       GPR03F=1;   /* SET TYPE                      */
         LA    GPR03F,1                                            0576
*                       GPR00F=RTM2SIZE;/* LENGTH REQUESTED          */
         LA    @02,96                                              0577
         ALR   @02,R11                                             0577
         L     @15,ESART2WA(,@02)                                  0577
         L     GPR00F,RTM2SIZE-1(,@15)                             0577
         ICM   GPR00F,8,@CB02577                                   0577
*                       GPR01F=ADDR(SDWA);/* SET REGISTER ONE        */
         L     GPR01F,RTM2RTCA(,@15)                               0578
*                       GPR03F=GPR03F+((RTM2SUBP)*256);/* SUBPOOL  0579
*                                      VALUE                         */
         SLR   @14,@14                                             0579
         IC    @14,RTM2SUBP(,@15)                                  0579
         SLA   @14,8                                               0579
         ALR   GPR03F,@14                                          0579
*                       CALL CVTCRMN;/* BRANCH ENTRY POINT           */
         L     @02,CVTPTR(,@02)                                    0580
         L     @15,CVTCRMN(,@02)                                   0580
         BALR  @14,@15                                             0580
*                       RESPECIFY                                  0581
*                        (GPR01F,                                  0581
*                         GPR03F,                                  0581
*                         GPR00F) UNRESTRICTED;                    0581
*                     END;          /* FREEMAIN(RC)                0582
*                                      LV(RTM2SIZE)A(SDWA)         0582
*                                      SP(RTM2SUBP) BRANCH           */
*                   ELSE                                           0583
*                     ;             /* NO SDWA(RTCA) EXISTS          */
@RF00572 DS    0H                                                  0584
*                 ELSE                                             0584
*                   ;               /* DO NOT FREE RTCA POINTED TO BY
*                                      CURRENT WORKAREA IF RETRY   0584
*                                      REQUESTED                     */
*                                                                  0584
@RF00571 DS    0H                                                  0585
*                 /***************************************************/
*                 /*                                                 */
*                 /* RELEASE RTM2WA                                  */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0585
*FREEWA:                                                           0585
*                 ;                 /* THIS STATEMENT IS LABELLED TO
*                                      PREVENT USE OF COMPILER     0585
*                                      TEMPORARY                     */
FREEWA   DS    0H                                                  0586
*/*   FREE COPIED TRACE TABLE ACQUIRED DURING DUMP PROCESS         0586
*     THE TRACE TABLE IS QUEUED TO THE RTM2WA(RTM2TRTB).     @G33SPHW*/
*                                                                  0586
*                 IF RTM2TRTB^=0 THEN/* COPIED TRACE AVAILABLE     0586
*                                                            @G33SPHW*/
         LA    @15,96                                              0586
         ALR   @15,R11                                             0586
         L     @14,ESART2WA(,@15)                                  0586
         L     @03,RTM2TRTB(,@14)                                  0586
         LTR   @03,@03                                             0586
         BZ    @RF00586                                            0586
*                   DO;             /* YES...FREEMAIN STORAGE      0587
*                                                            @G33SPHW*/
*                                                                  0587
*                     /***********************************************/
*                     /*                                             */
*                     /* FREE THE COPIED TRACE TABLE BUFFER  @G33SPHW*/
*                     /*                                             */
*                     /***********************************************/
*                                                                  0588
*                     DO;           /* FREEMAIN(RC)                0588
*                                      LV(RTM2TRLN)A(RTM2TRTB->I256C)
*                                      SP(230) BRANCH                */
*                       RESPECIFY                                  0589
*                        (GPR01F,                                  0589
*                         GPR03F,                                  0589
*                         GPR00F) RESTRICTED;                      0589
*                       GPR01F=0;   /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0590
*                       GPR03F=1;   /* SET TYPE                      */
         LA    GPR03F,1                                            0591
*                       GPR00F=RTM2TRLN;/* LENGTH REQUESTED          */
         L     GPR00F,RTM2TRLN(,@14)                               0592
*                       GPR01F=ADDR(RTM2TRTB->I256C);/* SET REGISTER
*                                      ONE                           */
         L     @02,ESART2WA+96(,R11)                               0593
         L     @02,RTM2TRTB(,@02)                                  0593
         LR    GPR01F,@02                                          0593
*                       GPR03F=GPR03F+((230)*256);/* SUBPOOL VALUE   */
         AL    GPR03F,@CF02551                                     0594
*                       CALL CVTCRMN;/* BRANCH ENTRY POINT           */
         L     @02,CVTPTR(,@15)                                    0595
         L     @15,CVTCRMN(,@02)                                   0595
         BALR  @14,@15                                             0595
*                       RESPECIFY                                  0596
*                        (GPR01F,                                  0596
*                         GPR03F,                                  0596
*                         GPR00F) UNRESTRICTED;                    0596
*                     END;          /* FREEMAIN(RC)                0597
*                                      LV(RTM2TRLN)A(RTM2TRTB->I256C)
*                                      SP(230) BRANCH        @ZM45190*/
*                     RTM2TRTB=0;   /* ZERO TRACE TABLE ADDRESS    0598
*                                      BUFFER IN RTM2WA.     @G33SPHW*/
         SLR   @15,@15                                             0598
         L     @14,ESART2WA+96(,R11)                               0598
         ST    @15,RTM2TRTB(,@14)                                  0598
*                     RTM2TRLN=0;   /* ZERO TRACE LENGTH     @G33SPHW*/
         ST    @15,RTM2TRLN(,@14)                                  0599
*                     RTM2TRCU=0;   /* ZERO CURRENT ENTRY    @G33SPHW*/
         ST    @15,RTM2TRCU(,@14)                                  0600
*                     RTM2TRFS=0;   /* ZERO FIRST ENTRY      @G33SPHW*/
         ST    @15,RTM2TRFS(,@14)                                  0601
*                     RTM2TRLS=0;   /* ZERO LAST ENTRY       @G33SPHW*/
         ST    @15,RTM2TRLS(,@14)                                  0602
*                   END;            /* END...FREE COPIED TRACE TBL 0603
*                                                            @G33SPHW*/
*                 DO;               /* FREEMAIN(RU)                0604
*                                      LV(RTM2LGTH)A(RTM2WA)       0604
*                                      SP(RTM2SPID) BRANCH           */
@RF00586 DS    0H                                                  0605
*                   RESPECIFY                                      0605
*                    (GPR01F,                                      0605
*                     GPR03F,                                      0605
*                     GPR00F) RESTRICTED;                          0605
*                   GPR01F=0;       /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0606
*                   GPR03F=3;       /* SET TYPE                      */
         LA    GPR03F,3                                            0607
*                   GPR00F=RTM2LGTH;/* LENGTH REQUESTED              */
         LA    @02,96                                              0608
         ALR   @02,R11                                             0608
         L     @15,ESART2WA(,@02)                                  0608
         L     GPR00F,RTM2LGTH-1(,@15)                             0608
         ICM   GPR00F,8,@CB02577                                   0608
*                   GPR01F=ADDR(RTM2WA);/* SET REGISTER ONE          */
         LR    GPR01F,@15                                          0609
*                   GPR03F=GPR03F+((RTM2SPID)*256);/* SUBPOOL VALUE  */
         SLR   @14,@14                                             0610
         IC    @14,RTM2SPID(,@15)                                  0610
         SLA   @14,8                                               0610
         ALR   GPR03F,@14                                          0610
*                   CALL CVTCRMN;   /* BRANCH ENTRY POINT            */
         L     @02,CVTPTR(,@02)                                    0611
         L     @15,CVTCRMN(,@02)                                   0611
         BALR  @14,@15                                             0611
*                   RESPECIFY                                      0612
*                    (GPR01F,                                      0612
*                     GPR03F,                                      0612
*                     GPR00F) UNRESTRICTED;                        0612
*                 END;              /* FREEMAIN(RU)                0613
*                                      LV(RTM2LGTH)A(RTM2WA)       0613
*                                      SP(RTM2SPID) BRANCH           */
*                 ESART2WA=0;       /* ZERO ESA POINTER TO THE     0614
*                                      WORKAREA                      */
         SLR   @15,@15                                             0614
         ST    @15,ESART2WA+96(,R11)                               0614
*               END;                                               0615
*             ELSE                                                 0616
*               DO;                 /* FORCE EXIT FROM LOOP AS     0616
*                                      WORKAREA QUEUE OR RB QUEUE IS
*                                      INVALID                       */
         B     @RC00538                                            0616
@RF00538 DS    0H                                                  0617
*                 R11=R5;                                          0617
         LR    R11,R5                                              0617
*                 R9=R5;                                           0618
         LR    R9,R5                                               0618
*               END;                                               0619
*           END;                                                   0620
*         ELSE                                                     0621
*           ;                       /* RTM2WA PREVIOUSLY FREED       */
@RF00535 DS    0H                                                  0622
*       END;                                                       0622
*     ELSE                                                         0623
*       ;                           /* NO RTM2 SVRB FOUND            */
@RF00532 DS    0H                                                  0624
*   END;                            /* END SCAN FOR RTM2 SVRBS       */
@RC00532 DS    0H                                                  0624
@DE00514 CR    R9,R11                                              0624
         BNE   @DL00514                                            0624
*   RESPECIFY                                                      0625
*    (R11,                                                         0625
*     R9) UNRESTRICTED;             /* RELEASE REGISTERS USED IN SCAN*/
*   RESPECIFY                                                      0626
*     R7 UNRESTRICTED;              /* RELEASE ASCBPTR               */
*   RESPECIFY                                                      0627
*     RTM2ESA;                      /* RETURN RTM2ESA TO ORIGINAL  0627
*                                      SPECIFICATION                 */
*   RESPECIFY                                                      0628
*     RTM2WA;                       /* RETURN RTM2WA TO ORIGINAL   0628
*                                      SPECIFICATION                 */
*   RESPECIFY                                                      0629
*     R14 RESTRICTED;                                              0629
*   R14=R12;                        /* RESTORE REGISTER 14           */
         LR    R14,R12                                             0630
*   RESPECIFY                                                      0631
*     R14 UNRESTRICTED;                                            0631
*   RESPECIFY                                                      0632
*     R12 UNRESTRICTED;             /* RELEASE REGISTER USED TO SAVE
*                                      RETURN ADDRESS                */
*   RETURN CODE(0);                                                0633
         SLR   @15,@15                                             0633
@EL00002 DS    0H                                                  0633
@EF00002 DS    0H                                                  0633
@ER00002 BR    @14                                                 0633
*   END RTEFREWA;                                                  0634
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     0635
*     GPR01F FIXED(31) REG(1),                                     0635
*     GPR03F FIXED(31) REG(3),                                     0635
*     GPR11P PTR(31) REG(11),                                      0635
*     GPR12P PTR(31) REG(12),                                      0635
*     GPR13P PTR(31) REG(13),                                      0635
*     GPR14P PTR(31) REG(14);                                      0635
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0636
*     I031F FIXED(31) BASED,                                       0636
*     I031P PTR(31) BASED,                                         0636
*     I015F FIXED(15) BASED,                                       0636
*     I015P PTR(15) BASED,                                         0636
*     I008P PTR(8) BASED,                                          0636
*     I001C CHAR(1) BASED;                                         0636
*   END IEAVTRTE                                                   0637
*                                                                  0637
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (RTETSTVR)                                       */
*/*%INCLUDE SYSLIB  (RTESPEC )                                       */
*/*%INCLUDE SYSLIB  (RTEDCL  )                                       */
*/*%INCLUDE SYSLIB  (IHARTM2A)                                       */
*/*%INCLUDE SYSLIB  (IHASNP  )                                       */
*/*%INCLUDE SYSLIB  (IHARMPL )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (RTM2ESA )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (RTEPATCH)                                       */
*/*%INCLUDE SYSLIB  (RTEMTINT)                                       */
*/*%INCLUDE SYSLIB  (RTETTINT)                                       */
*/*%INCLUDE SYSLIB  (RTECONV )                                       */
*/*%INCLUDE SYSLIB  (RTERCREX)                                       */
*/*%INCLUDE SYSLIB  (RTESFRE )                                       */
*/*%INCLUDE SYSLIB  (RTECVERR)                                       */
*/*%INCLUDE SYSLIB  (RTECLRFL)                                       */
*/*%INCLUDE SYSLIB  (RTECLRFL)                                       */
*/*%INCLUDE SYSLIB  (RTECLRFL)                                       */
*/*%INCLUDE SYSLIB  (RTECLRFL)                                       */
*/*%INCLUDE SYSLIB  (RTECMEX )                                       */
*/*%INCLUDE SYSLIB  (RTELTEX )                                       */
*/*%INCLUDE SYSLIB  (RTECNVEX)                                       */
*/*%INCLUDE SYSLIB  (RTESWEX )                                       */
*/*%INCLUDE SYSLIB  (RTEFREWA)                                       */
*/*%INCLUDE SYSLIB  (RTEWADQ )                                       */
*/*%INCLUDE SYSLIB  (RTEFRETR)                                       */
*                                                                  0637
*       ;                                                          0637
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IEAVTRTE CSECT
         DS    0F
@CF00453 DC    F'64'
@CF02551 DC    F'58880'
@CF00051 DC    XL4'00400010'
@CF00053 DC    XL4'00400000'
@CF00057 DC    XL4'00800010'
@CF00072 DC    XL4'80000000'
@CF00076 DC    XL4'0040000C'
@CF02575 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
IEAVTRTE CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02504 DC    V(IEAVTMMT)
@CV02505 DC    V(IEAVTSKT)
         DS    0D
@CC02532 DC    C'RTM2'
@CB00066 DC    X'00000000'
@CB00060 EQU   @CB00066
@CB02577 EQU   @CB00066
RTEPATCH DC    CL160'PATCH AREA'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R6       EQU   @06
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR01F   EQU   @01
GPR03F   EQU   @03
GPR00F   EQU   @00
         ENTRY RTECVERR
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
POST     EQU   0
RT2CRERR EQU   0
SDWA     EQU   0
STATUS   EQU   0
SNPPARMS EQU   0
SNPFLAG  EQU   SNPPARMS+1
SNPSDATA EQU   SNPPARMS+4
SNPSDAT0 EQU   SNPSDATA
SNPSDAT1 EQU   SNPSDATA+1
SNPPDATA EQU   SNPPARMS+6
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RMPLTYPE EQU   RMPLFLG1
RMPLTERM EQU   RMPLFLG1
RMPLASID EQU   RMPL+2
RMPLTCBA EQU   RMPL+8
RTM2WA   EQU   0
RTM2DESC EQU   RTM2WA
RTM2ID   EQU   RTM2DESC
RTM2RT2D EQU   RTM2DESC+8
RTM2SPID EQU   RTM2RT2D
RTM2LGTH EQU   RTM2RT2D+1
RTM2ASC  EQU   RTM2WA+24
RTM2CODE EQU   RTM2WA+28
RTM2CCF  EQU   RTM2CODE
RTM2CC   EQU   RTM2CODE+1
RTM2PGCY EQU   RTM2WA+60
RTM2TRRY EQU   RTM2PGCY
RTM2EEDR EQU   RTM2TRRY
RTM2EREG EQU   RTM2EEDR
RTM2APSW EQU   RTM2EEDR+64
RTM2EPSW EQU   RTM2APSW
RTM2EMK1 EQU   RTM2EPSW
RTM2MWP1 EQU   RTM2EPSW+1
RTM2INT1 EQU   RTM2EPSW+2
RTM2NXT1 EQU   RTM2EPSW+4
RTM2AEC1 EQU   RTM2APSW+8
RTM2ILC1 EQU   RTM2AEC1+1
RTM2INC1 EQU   RTM2AEC1+2
RTM2ICD1 EQU   RTM2INC1+1
RTM2EEDH EQU   RTM2TRRY+92
RTM2STCK EQU   RTM2EEDH
RTM2MCHI EQU   RTM2EEDH+8
RTM2MCHS EQU   RTM2MCHI
RTM2MCHD EQU   RTM2MCHI+1
RTM2RSR1 EQU   RTM2EEDH+12
RTM2RSR2 EQU   RTM2EEDH+13
RTM2FLGS EQU   RTM2TRRY+120
RTM2ERRA EQU   RTM2FLGS
RTM2ERRB EQU   RTM2FLGS+1
RTM2ERRC EQU   RTM2FLGS+2
RTM2ERRD EQU   RTM2FLGS+3
RTM2CVER EQU   RTM2WA+186
RTM2TRRC EQU   RTM2CVER
RTM2IOFS EQU   RTM2TRRC
RTM2IOBP EQU   RTM2TRRC+2
RTM2SCBS EQU   RTM2TRRC+14
RTM2RTCD EQU   RTM2TRRC+26
RTM2RTCA EQU   RTM2RTCD
RTM2SPLL EQU   RTM2RTCD+4
RTM2SUBP EQU   RTM2SPLL
RTM2SIZE EQU   RTM2SPLL+1
RTM2RYRB EQU   RTM2TRRC+42
RTM2PARQ EQU   RTM2TRRC+46
RTM2CTL1 EQU   RTM2CVER+50
RTM2CMKA EQU   RTM2CTL1
RTM2MWPA EQU   RTM2CTL1+1
RTM2PMKA EQU   RTM2CTL1+4
RTM2CTL2 EQU   RTM2CVER+58
RTM2CMKP EQU   RTM2CTL2
RTM2MWPP EQU   RTM2CTL2+1
RTM2PMKP EQU   RTM2CTL2+4
RTM2SNAP EQU   RTM2CVER+66
RTM2SPRM EQU   RTM2SNAP+4
RTM2DPSL EQU   RTM2SNAP+24
RTM2FRM1 EQU   RTM2DPSL
RTM2TO1  EQU   RTM2DPSL+4
RTM2FRM2 EQU   RTM2DPSL+8
RTM2TO2  EQU   RTM2DPSL+12
RTM2FRM3 EQU   RTM2DPSL+16
RTM2TO3  EQU   RTM2DPSL+20
RTM2FRM4 EQU   RTM2DPSL+24
RTM2TO4  EQU   RTM2DPSL+28
RTM2SECB EQU   RTM2CVER+138
RTM2ECBA EQU   RTM2SECB
RTM2ECBS EQU   RTM2SECB+16
RTM2SPWA EQU   RTM2CVER+174
RTM2PREV EQU   RTM2CVER+178
RTM2PRWA EQU   RTM2CVER+182
RTM2SFRG EQU   RTM2CVER+186
RTM2SFSA EQU   RTM2SFRG
RTM2SCTL EQU   RTM2CVER+259
RTM2CCTL EQU   RTM2SCTL
RTM2STPT EQU   RTM2CCTL
RTM2SQS  EQU   RTM2CCTL
RTM2ISPC EQU   RTM2CCTL
RTM2ABDR EQU   RTM2SCTL+4
RTM2ABID EQU   RTM2ABDR
RTM2ABND EQU   RTM2ABDR+1
RTM2RCTL EQU   RTM2SCTL+6
RTM2WAIN EQU   RTM2RCTL
RTM2INTF EQU   RTM2CVER+266
RTM2CTLR EQU   RTM2INTF
RTM2RECR EQU   RTM2CTLR
RTM2RETR EQU   RTM2CTLR
RTM2TMEM EQU   RTM2CTLR
RTM2TSKT EQU   RTM2INTF+2
RTM2ABDP EQU   RTM2INTF+4
RTM2ASIR EQU   RTM2INTF+5
RTM2FLX  EQU   RTM2INTF+6
RTM2FLX1 EQU   RTM2FLX
RTM2MTX  EQU   RTM2FLX1
RTM2EOTX EQU   RTM2FLX1
RTM2ABX  EQU   RTM2FLX1
RTM2DWX  EQU   RTM2FLX1
RTM2CVX  EQU   RTM2FLX1
RTM2PRX  EQU   RTM2FLX1
RTM2LTX  EQU   RTM2FLX1
RTM2RTRX EQU   RTM2FLX1
RTM2FLX2 EQU   RTM2FLX+1
RTM2RCRX EQU   RTM2FLX2
RTM2CERX EQU   RTM2FLX2
RTM2RECL EQU   RTM2CVER+274
RTM2SCTC EQU   RTM2RECL
RTM2SCTR EQU   RTM2RECL+4
RTM2SCTX EQU   RTM2RECL+8
RTM2DCTL EQU   RTM2RECL+12
RTM2ECTL EQU   RTM2RECL+13
RTM2TRYR EQU   RTM2RECL+16
RTM2TRF1 EQU   RTM2TRYR
RTM2TRF2 EQU   RTM2TRYR+2
RTM2RECH EQU   RTM2CVER+294
RTM2TRRA EQU   RTM2RECH
RTM2SKRA EQU   RTM2RECH+4
RTM2STRA EQU   RTM2RECH+8
RTM2CTRA EQU   RTM2RECH+12
RTM2WARG EQU   RTM2CVER+312
RTM2RBRG EQU   RTM2CVER+313
RTM2RRG  EQU   RTM2CVER+314
RTM2RREG EQU   RTM2RRG
RTM2CRG  EQU   RTM2CVER+378
RTM2CREG EQU   RTM2CRG
RTM2RMIN EQU   RTM2WA+708
RTM2RMPL EQU   RTM2RMIN+4
RTM2RMWA EQU   RTM2RMIN+28
RTM2RMSA EQU   RTM2RMIN+92
RTM2ERID EQU   RTM2WA+872
RTM2ENSN EQU   RTM2WA+884
RTM2SNLN EQU   RTM2ENSN
RTM2TRLN EQU   RTM2SNLN
RTM2TRTB EQU   RTM2ENSN+4
RTM2TRCU EQU   RTM2ENSN+8
RTM2TRFS EQU   RTM2ENSN+12
RTM2TRLS EQU   RTM2ENSN+16
RTM2RYRG EQU   RTM2WA+904
STORAGE  EQU   0
STORFRM  EQU   STORAGE
STORTO   EQU   STORAGE+4
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBEXSAVE EQU   XRBESA
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBABEND  EQU   RBFLAGS1
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00051 EQU   RBSECT+10
@NM00052 EQU   @NM00051
RBTRSVRB EQU   @NM00052
@NM00054 EQU   @NM00051+1
RBETXR   EQU   @NM00054
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00061 EQU   RBSECT+28
@NM00062 EQU   @NM00061
IRBEND   EQU   RBSECT+96
@NM00065 EQU   RBSECT+96
RBRSV138 EQU   @NM00065+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
RTM2ESA  EQU   0
ESAREGS  EQU   RTM2ESA
ESAR1    EQU   ESAREGS+4
ESACCF1  EQU   ESAR1
ESAR3    EQU   ESAREGS+8
ESAR14   EQU   ESAREGS+24
ESART2WA EQU   RTM2ESA+32
ESART2D  EQU   RTM2ESA+36
ESAFLAGS EQU   RTM2ESA+40
ESANEOT  EQU   ESAFLAGS
ESAEOT   EQU   ESAFLAGS
ESAVEOM  EQU   ESAFLAGS
ESARFLAG EQU   RTM2ESA+41
ESAGMREC EQU   ESARFLAG
ESASDREC EQU   ESARFLAG
ESAGLREC EQU   ESARFLAG
ESACMP   EQU   RTM2ESA+44
ESACCF   EQU   ESACMP
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVT0PT01 EQU   CVTMAP+152
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTABEND EQU   CVTMAP+200
CVTUSER  EQU   CVTMAP+204
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBCMPC  EQU   TCBCMP+1
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFA    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBFX    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBJSTCA EQU   TCBJSTCB+1
TCBECB   EQU   TCB+144
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBRSTSK EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBAECB  EQU   TCB+212
TCBRTWA  EQU   TCB+224
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBRTM2  EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBFBYT2 EQU   TCB+277
TCBFMW   EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBRTWA EQU   ASCB+164
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
SCVTSECT EQU   0
SCVTSTAT EQU   SCVTSECT+148
I256C    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
CVTPTR   EQU   ESAR3
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTCRMN  EQU   CVTS01+156
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
SCVTSPTR EQU   CVTABEND
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00066 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
@NM00127 EQU   SCVTSECT+180
@NM00126 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00125 EQU   SCVTSECT+168
SCVTPTRM EQU   SCVTSECT+164
@NM00124 EQU   SCVTSECT+160
@NM00123 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
@NM00122 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00121 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00120 EQU   SCVTSECT+128
@NM00119 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00118 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00117 EQU   SCVTSECT+108
@NM00116 EQU   SCVTSECT+104
@NM00115 EQU   SCVTSECT+100
@NM00114 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00113 EQU   SCVTSECT+88
@NM00112 EQU   SCVTSECT+84
@NM00111 EQU   SCVTSECT+80
@NM00110 EQU   SCVTSECT+76
@NM00109 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00108 EQU   SCVTSECT+56
@NM00107 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00106 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00105 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00104 EQU   SCVTSECT+24
@NM00103 EQU   SCVTSECT+20
@NM00102 EQU   SCVTSECT+16
@NM00101 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SCVTPGWR EQU   SCVTSECT+4
SCVTPGTM EQU   SCVTSECT
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00076 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00075 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00074 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFS    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00073 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00072 EQU   CVTFIX+248
@NM00071 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ESACC    EQU   ESACMP+1
@NM00070 EQU   ESACCF
ESAASID  EQU   ESACCF
ESANOCC  EQU   ESACCF
ESAR0DP  EQU   ESACCF
ESASTEP  EQU   ESACCF
ESADREQ  EQU   ESACCF
ESAMODE  EQU   RTM2ESA+43
ESAERTYP EQU   RTM2ESA+42
@NM00069 EQU   ESARFLAG
ESASLIPR EQU   ESARFLAG
ESARTCR  EQU   ESARFLAG
ESAFERR  EQU   ESARFLAG
ESAINREC EQU   ESARFLAG
@NM00068 EQU   ESAFLAGS
ESACTS   EQU   ESAFLAGS
ESAPGNLY EQU   ESAFLAGS
ESAABTRM EQU   ESAFLAGS
ESARTM2  EQU   ESAFLAGS
ESAWLEN  EQU   ESART2D+1
ESAWSPID EQU   ESART2D
ESAEEDQ  EQU   RTM2ESA+28
ESAR7    EQU   ESAREGS+20
ESAR5    EQU   ESAREGS+16
ESAR4    EQU   ESAREGS+12
ESACC1   EQU   ESAR1+1
@NM00067 EQU   ESACCF1
ESAEOT1  EQU   ESACCF1
ESAEOM1  EQU   ESACCF1
ESAR0DP1 EQU   ESACCF1
ESASTEP1 EQU   ESACCF1
ESADREQ1 EQU   ESACCF1
ESAR0    EQU   ESAREGS
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00065+8
PRBEND   EQU   @NM00065+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00065+6
RBRSV136 EQU   @NM00065+4
RBRSV135 EQU   @NM00065
@NM00064 EQU   RBSECT+32
@NM00063 EQU   @NM00061+1
RBSCF    EQU   @NM00062
RBPGMQ1  EQU   RBPGMQ+1
@NM00060 EQU   RBPGMQ
@NM00059 EQU   RBSECT+16
@NM00058 EQU   @NM00054
@NM00057 EQU   @NM00054
RBIQETP  EQU   @NM00054
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00054
@NM00056 EQU   @NM00054
@NM00055 EQU   @NM00054
RBPMSVRB EQU   @NM00052
RBATNXIT EQU   @NM00052
@NM00053 EQU   @NM00052
RBWAITP  EQU   @NM00052
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00052
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00050 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00049 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00048 EQU   RBOPSWB2
@NM00047 EQU   XRBPSW
@NM00046 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00045 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00044 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00043 EQU   XSTAB1
@NM00042 EQU   RBBASIC+8
@NM00041 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00040 EQU   RBPRFX
STORBTO  EQU   STORTO
STORB    EQU   STORFRM
RTM2TECB EQU   RTM2RYRG+64
RTM2RYRS EQU   RTM2RYRG
@NM00039 EQU   RTM2WA+882
RTM2ERTM EQU   RTM2ERID+6
RTM2ERAS EQU   RTM2ERID+4
RTM2CPUI EQU   RTM2ERID+2
RTM2SEQ# EQU   RTM2ERID
RTM2RMWS EQU   RTM2RMWA
RTM2RMPS EQU   RTM2RMIN
RTM2TRSA EQU   RTM2CVER+450
@NM00038 EQU   RTM2CVER+310
@NM00037 EQU   RTM2TRYR+3
@NM00036 EQU   RTM2TRF2
RTM2TREC EQU   RTM2TRF2
RTM2GMR  EQU   RTM2TRF2
RTM2PPR  EQU   RTM2TRF2
RTM2IOR  EQU   RTM2TRF2
RTM2AS3R EQU   RTM2TRF1+1
RTM2AS2R EQU   RTM2TRF1+1
RTM2AS1R EQU   RTM2TRF1+1
RTM2XFLG EQU   RTM2TRF1+1
RTM2XABD EQU   RTM2TRF1+1
RTM2XIP  EQU   RTM2TRF1+1
RTM2RTYS EQU   RTM2TRF1+1
RTM2RCD  EQU   RTM2TRF1+1
RTM2FMS  EQU   RTM2TRF1
RTM2VLDY EQU   RTM2TRF1
RTM2HOOK EQU   RTM2TRF1
RTM2PPS  EQU   RTM2TRF1
RTM2GMS  EQU   RTM2TRF1
RTM2IORS EQU   RTM2TRF1
RTM2IOHS EQU   RTM2TRF1
RTM2IOQS EQU   RTM2TRF1
RTM2TMER EQU   RTM2RECL+14
RTM2EQMN EQU   RTM2ECTL
RTM2EDEQ EQU   RTM2ECTL
RTM2EFRM EQU   RTM2ECTL
RTM2ECLS EQU   RTM2ECTL
RTM2ESNP EQU   RTM2ECTL
RTM2EOPN EQU   RTM2ECTL
RTM2EGET EQU   RTM2ECTL
RTM2EENQ EQU   RTM2ECTL
RTM2DFTK EQU   RTM2DCTL
RTM2DDEQ EQU   RTM2DCTL
RTM2DFRM EQU   RTM2DCTL
RTM2DCLS EQU   RTM2DCTL
RTM2DSNP EQU   RTM2DCTL
RTM2DOPN EQU   RTM2DCTL
RTM2DGET EQU   RTM2DCTL
RTM2DENQ EQU   RTM2DCTL
@NM00035 EQU   RTM2FLX2
@NM00034 EQU   RTM2ASIR
RTM2UPRG EQU   RTM2ASIR
RTM2TRME EQU   RTM2ASIR
@NM00033 EQU   RTM2ABDP
RTM2SMDP EQU   RTM2ABDP
RTM2DMP1 EQU   RTM2ABDP
RTM2MEMT EQU   RTM2INTF+3
@NM00032 EQU   RTM2TSKT
RTM2PURG EQU   RTM2TSKT
@NM00031 EQU   RTM2INTF+1
@NM00030 EQU   RTM2CTLR
RTM2WRAP EQU   RTM2CTLR
@NM00029 EQU   RTM2RCTL
RTM2JPAQ EQU   RTM2RCTL
RTM2LPAQ EQU   RTM2RCTL
RTM2BFTL EQU   RTM2RCTL
RTM2TRSW EQU   RTM2RCTL
RTM2WANA EQU   RTM2RCTL
RTM2STA2 EQU   RTM2RCTL
RTM2STAT EQU   RTM2ABND
RTM2NDMP EQU   RTM2ABND
@NM00028 EQU   RTM2ABID
RTM2OERR EQU   RTM2ABID
RTM2SAV2 EQU   RTM2ABID
RTM2SAVE EQU   RTM2ABID
RTM2REG  EQU   RTM2ABID
RTM2PSW  EQU   RTM2ABID
RTM2ENQ  EQU   RTM2ABID
RTM2CB   EQU   RTM2ABID
RTM2MCTL EQU   RTM2SCTL+3
RTM2TCTL EQU   RTM2SCTL+2
@NM00027 EQU   RTM2CCTL+1
RTM2NODP EQU   RTM2CCTL+1
RTM2RGEB EQU   RTM2CCTL+1
RTM2DEND EQU   RTM2CCTL+1
RTM2RSCN EQU   RTM2CCTL+1
RTM2CONT EQU   RTM2CCTL
RTM2SLIP EQU   RTM2CCTL
RTM2HEED EQU   RTM2CCTL
RTM2REED EQU   RTM2CCTL
RTM2CNCL EQU   RTM2CCTL
RTM2PKEY EQU   RTM2CVER+258
RTM2DCBA EQU   RTM2CVER+170
RTM2LECB EQU   RTM2ECBA
RTM2DTCB EQU   RTM2SNAP+68
RTM2SNCC EQU   RTM2SNAP+64
RTM2DD   EQU   RTM2SNAP+56
RTM2LTO4 EQU   RTM2TO4
RTM2LFR4 EQU   RTM2FRM4
RTM2LTO3 EQU   RTM2TO3
RTM2LFR3 EQU   RTM2FRM3
RTM2LTO2 EQU   RTM2TO2
RTM2LFR2 EQU   RTM2FRM2
RTM2LTO1 EQU   RTM2TO1
RTM2LFR1 EQU   RTM2FRM1
RTM2DPLA EQU   RTM2SNAP
RTM2NXTP EQU   RTM2CTL2+5
RTM2SGP  EQU   RTM2PMKP
RTM2EUP  EQU   RTM2PMKP
RTM2DOP  EQU   RTM2PMKP
RTM2FPP  EQU   RTM2PMKP
RTM2CCP  EQU   RTM2PMKP
RTM2ILP  EQU   RTM2PMKP
RTM2INTP EQU   RTM2CTL2+2
RTM2SPVP EQU   RTM2MWPP
RTM2WATP EQU   RTM2MWPP
RTM2MCKP EQU   RTM2MWPP
@NM00026 EQU   RTM2MWPP
RTM2KEYP EQU   RTM2MWPP
RTM2EXTP EQU   RTM2CMKP
RTM2IOP  EQU   RTM2CMKP
RTM2NXTA EQU   RTM2CTL1+5
RTM2SGA  EQU   RTM2PMKA
RTM2EUA  EQU   RTM2PMKA
RTM2DOA  EQU   RTM2PMKA
RTM2FPA  EQU   RTM2PMKA
RTM2CCA  EQU   RTM2PMKA
RTM2ILA  EQU   RTM2PMKA
RTM2INTA EQU   RTM2CTL1+2
RTM2SPVA EQU   RTM2MWPA
RTM2WATA EQU   RTM2MWPA
RTM2MCKA EQU   RTM2MWPA
@NM00025 EQU   RTM2MWPA
RTM2KEYA EQU   RTM2MWPA
RTM2EXTA EQU   RTM2CMKA
RTM2IOA  EQU   RTM2CMKA
@NM00024 EQU   RTM2PARQ+1
RTM2RCDE EQU   RTM2PARQ
RTM2RTYA EQU   RTM2TRRC+38
RTM2COMP EQU   RTM2TRRC+34
RTM2SCBO EQU   RTM2SCBS+8
RTM2SCBN EQU   RTM2SCBS+4
RTM2SCBC EQU   RTM2SCBS
RTM2STAR EQU   RTM2TRRC+10
RTM2RBST EQU   RTM2TRRC+6
RTM2FIOB EQU   RTM2IOBP+1
@NM00023 EQU   RTM2IOBP
@NM00022 EQU   RTM2TRRC+1
@NM00021 EQU   RTM2IOFS
RTM2NIOP EQU   RTM2IOFS
RTM2NOIO EQU   RTM2IOFS
RTM2IOHT EQU   RTM2IOFS
RTM2IOQR EQU   RTM2IOFS
RTM2FMID EQU   RTM2TRRY+124
RTM2ERFL EQU   RTM2ERRD
RTM2MCIV EQU   RTM2ERRD
RTM2RPIV EQU   RTM2ERRD
RTM2MABD EQU   RTM2ERRD
RTM2CTS  EQU   RTM2ERRD
RTM2STAE EQU   RTM2ERRD
RTM2NRBE EQU   RTM2ERRD
RTM2CLUP EQU   RTM2ERRD
@NM00020 EQU   RTM2ERRC
RTM2EAS  EQU   RTM2ERRC
RTM2PERC EQU   RTM2ERRC
RTM2IRB  EQU   RTM2ERRC
RTM2STAI EQU   RTM2ERRC
RTM2STAF EQU   RTM2ERRC
RTM2SRBM EQU   RTM2ERRB
RTM2LDIS EQU   RTM2ERRB
RTM2ENRB EQU   RTM2ERRB
RTM2TYP1 EQU   RTM2ERRB
@NM00019 EQU   RTM2ERRB
RTM2PGIO EQU   RTM2ERRA
RTM2TEXC EQU   RTM2ERRA
RTM2SVCE EQU   RTM2ERRA
RTM2ABTM EQU   RTM2ERRA
RTM2SVCD EQU   RTM2ERRA
RTM2RKEY EQU   RTM2ERRA
RTM2PCHK EQU   RTM2ERRA
RTM2MCHK EQU   RTM2ERRA
RTM2TIME EQU   RTM2EEDH+20
RTM2RFSA EQU   RTM2EEDH+16
@NM00018 EQU   RTM2EEDH+14
RTM2VEQR EQU   RTM2RSR2
RTM2PGFX EQU   RTM2RSR2
RTM2FLSQ EQU   RTM2RSR2
RTM2FSQA EQU   RTM2RSR2
RTM2NUCL EQU   RTM2RSR2
RTM2SPER EQU   RTM2RSR2
RTM2INTC EQU   RTM2RSR2
RTM2OFLN EQU   RTM2RSR2
RTM2CHNG EQU   RTM2RSR1
RTM2MSER EQU   RTM2RSR1
@NM00017 EQU   RTM2RSR1
RTM2CPID EQU   RTM2EEDH+10
RTM2TERR EQU   RTM2MCHD
RTM2SOFT EQU   RTM2MCHD
RTM2INSF EQU   RTM2MCHD
RTM2ACR  EQU   RTM2MCHD
RTM2SCK  EQU   RTM2MCHD
RTM2PSWU EQU   RTM2MCHD
RTM2REGU EQU   RTM2MCHD
RTM2SKYF EQU   RTM2MCHD
@NM00016 EQU   RTM2MCHS
RTM2RSRF EQU   RTM2MCHS
RTM2RSRC EQU   RTM2MCHS
RTM2INVP EQU   RTM2MCHS
RTM2TSVL EQU   RTM2MCHS
RTM2RCDF EQU   RTM2MCHS
RTM2SRVL EQU   RTM2MCHS
RTM2SCKE EQU   RTM2STCK+4
RTM2SCKB EQU   RTM2STCK
RTM2ABEP EQU   RTM2TRRY+88
RTM2ABNM EQU   RTM2TRRY+80
RTM2TRAN EQU   RTM2AEC1+4
RTM2IPC1 EQU   RTM2ICD1
RTM2IMC1 EQU   RTM2ICD1
RTM2IPR1 EQU   RTM2ICD1
@NM00015 EQU   RTM2INC1
@NM00014 EQU   RTM2ILC1
RTM2IL1  EQU   RTM2ILC1
@NM00013 EQU   RTM2ILC1
@NM00012 EQU   RTM2AEC1
RTM2ADD1 EQU   RTM2NXT1+1
@NM00011 EQU   RTM2NXT1
@NM00010 EQU   RTM2EPSW+3
RTM2SGN1 EQU   RTM2INT1
RTM2EXP1 EQU   RTM2INT1
RTM2DEC1 EQU   RTM2INT1
RTM2FPO1 EQU   RTM2INT1
RTM2CC1  EQU   RTM2INT1
@NM00009 EQU   RTM2INT1
RTM2PGM1 EQU   RTM2MWP1
RTM2WAT1 EQU   RTM2MWP1
RTM2MCK1 EQU   RTM2MWP1
RTM2ECT1 EQU   RTM2MWP1
RTM2KEY1 EQU   RTM2MWP1
RTM2EXT1 EQU   RTM2EMK1
RTM2AIO1 EQU   RTM2EMK1
RTM2TRM1 EQU   RTM2EMK1
RTM2EAM1 EQU   RTM2EMK1
@NM00008 EQU   RTM2EMK1
RTM2PER1 EQU   RTM2EMK1
@NM00007 EQU   RTM2EMK1
RTM2ER15 EQU   RTM2EREG+60
RTM2ER14 EQU   RTM2EREG+56
RTM2ER13 EQU   RTM2EREG+52
RTM2ER12 EQU   RTM2EREG+48
RTM2ER11 EQU   RTM2EREG+44
RTM2ER10 EQU   RTM2EREG+40
RTM2ER9  EQU   RTM2EREG+36
RTM2ER8  EQU   RTM2EREG+32
RTM2ER7  EQU   RTM2EREG+28
RTM2ER6  EQU   RTM2EREG+24
RTM2ER5  EQU   RTM2EREG+20
RTM2ER4  EQU   RTM2EREG+16
RTM2ER3  EQU   RTM2EREG+12
RTM2ER2  EQU   RTM2EREG+8
RTM2ER1  EQU   RTM2EREG+4
RTM2ER0  EQU   RTM2EREG
RTM2CT   EQU   RTM2WA+56
RTM2VRBT EQU   RTM2WA+52
RTM2TCBT EQU   RTM2WA+48
RTM2SFWA EQU   RTM2WA+32
@NM00006 EQU   RTM2CCF
RTM2EOT  EQU   RTM2CCF
RTM2EOM  EQU   RTM2CCF
RTM2R0DP EQU   RTM2CCF
RTM2STEP EQU   RTM2CCF
RTM2DREQ EQU   RTM2CCF
RTM2VRBC EQU   RTM2WA+20
RTM2TCBC EQU   RTM2WA+16
RTM2CVT  EQU   RTM2WA+12
RTM2ADDR EQU   RTM2DESC+4
RMPLDCBL EQU   RMPL+20
RMPLRMWA EQU   RMPL+16
RMPLRBPA EQU   RMPL+12
RMPLASCB EQU   RMPL+4
RMPLFLG2 EQU   RMPL+1
@NM00005 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLIPUF EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
SNPHDRA  EQU   SNPPARMS+20
SNPSTOR  EQU   SNPPARMS+16
SNPTCBA  EQU   SNPPARMS+12
SNPDCB   EQU   SNPPARMS+8
@NM00004 EQU   SNPPARMS+7
@NM00003 EQU   SNPPDATA
SNPSPLS  EQU   SNPPDATA
SNPPSW   EQU   SNPPDATA
SNPJPA   EQU   SNPPDATA
SNPLPA   EQU   SNPPDATA
SNPREGS  EQU   SNPPDATA
SNPSAVE2 EQU   SNPPDATA
SNPSAVE  EQU   SNPPDATA
@NM00002 EQU   SNPSDAT1
SNPERR   EQU   SNPSDAT1
SNPIO    EQU   SNPSDAT1
SNPDM    EQU   SNPSDAT0
SNPQCB   EQU   SNPSDAT0
SNPCB    EQU   SNPSDAT0
SNPTRT   EQU   SNPSDAT0
SNPSWA   EQU   SNPSDAT0
SNPLSQA  EQU   SNPSDAT0
SNPSQA   EQU   SNPSDAT0
SNPNUC   EQU   SNPSDAT0
@NM00001 EQU   SNPPARMS+2
SNPHDR   EQU   SNPFLAG
SNPSLIST EQU   SNPFLAG
SNPTCB   EQU   SNPFLAG
SNPID    EQU   SNPFLAG
SNPABEND EQU   SNPFLAG
SNPVS2EN EQU   SNPFLAG
SNPVS2   EQU   SNPFLAG
SNPSNAP  EQU   SNPFLAG
SNPIDENT EQU   SNPPARMS
@NM00100 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00099 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00098 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00097 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00096 EQU   FLCFSA
@NM00095 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00094 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00093 EQU   FLCIOA
@NM00092 EQU   FLCMCLA+15
@NM00091 EQU   FLCMCLA+14
@NM00090 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00089 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00088 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00087 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00086 EQU   FLCPER
@NM00085 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00084 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00083 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00082 EQU   FLCPIILC
@NM00081 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00080 EQU   FLCSVILC
@NM00079 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00078 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00077 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00063 EQU   @RC00062
@RC00246 EQU   @RC00174
@RC00226 EQU   @RC00174
@RC00191 EQU   @RC00174
@RF00345 EQU   @RC00338
@RF00356 EQU   @RC00349
@RC00388 EQU   @RC00386
@RC00545 EQU   @RC00542
@RC00535 EQU   @RC00532
@RC00538 EQU   @RC00535
@ENDDATA EQU   *
         END   IEAVTRTE,(C'PLS2000',0701,77280)
