         TITLE 'IEAVTRTS, SRM  MAINLINE                                *
                        '
IEAVTRTS CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(22)                                             0001
         DC    C'IEAVTRTS UZ13285 77256'                           0001
         DROP  @15
@PROLOG  BALR  @10,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@10                                         0001
*                                                                  0090
*   /*****************************************************************/
*   /*                                                               */
*   /* IEAVTRTS WILL ALWAYS BE ENTERED WHEN RECOVERY OF SUPERVISOR   */
*   /* CONTROL FUNCTIONS CAN BE ATTEMPTED VIA THE USE FO FRRS.       */
*   /* IEAVTRTS CAN BE ENTERED IN BOTH RECURSIVE SITUATIONS OR NON-  */
*   /* RECURSIVE SITUATIONS. IN EITHER CASE THE OBJECTIVE OF         */
*   /* IEAVTRTS(CALLED THE SRM) PROCESSING IS TO ATTEMPT RECOVERY    */
*   /* USING THOSE FRR'S DEFINED ON THE FRR STACK ASSOCIATED WITH THE*/
*   /* SUPERVISORY CONTROL FUNCTIONS FAILURE. THIS SEGMENT PERFORMS  */
*   /* BASIC INITIALIZATION FOR EACH ENTRY TO SRM IN PREPARATION FOR */
*   /* SRMS MAIN FUNCTION-FRR RECOVERY PROCESSING INPUT TO THIS      */
*   /* SEGMENT IS AS FOLLOWS: FUNCTION REGISTER(R0) USED INTERNALLY  */
*   /* WITHIN SRM TO MONITOR ITS PROCESSING PSACSTK FIELD OF THE PSA */
*   /* WHICH POINTS TO THE INTERRUPTED FRR STACK RTMRET REGISTER(R14)*/
*   /* CONTAINING THE RETURN ADDRESS OF THE RTM(THE CALLER OF SRM)   */
*   /* RTMBREG REGISTER(R9) - THE BASE REGISTER OF RTM RECVSTAK      */
*   /* REGISTER(R4) CONTAINING THE ADDRESS OF THE FRR STACK WHICH SRM*/
*   /* CAN USED TO DEFINE ITS OWN RECOVERY VIA FRRS OUTPUT FROM THIS */
*   /* SEGMENT IS AS FOLLOWS: FUNCTION REGISTER(R0) IS SET=1 TO      */
*   /* INDICATE THAT FRR RECOVERY PROCESSING IS TO BE PERFORMED BY   */
*   /* SRM RECURSE REGISTER(R7) CONTAINS THE LOGICAL PHASE NUMBER FOR*/
*   /* THE RTM.                                              @ZA20321*/
*   /* CURRSTK REGISTER(R8) CONTAINS THE ADDRESS OF THE INTER- RUPTED*/
*   /* FRR STACK FOR WHICH RECOVERY IS PERFORMED SRMSTAK REGISTER(R2)*/
*   /* CONTAINS THE ADDRESS OF THE FRR STACK THAT SRM CAN USE TO     */
*   /* DEFINE ITS OWN FRRS RTMRET REGISTER(R14) AND RTMBREG          */
*   /* REGISTER(R9) ARE SAVED IN THE RTM1 WORK AREA PORTION OF THE   */
*   /* INTERRUPTED FRR STACK FOR EVENTUAL USE BY SRM TO RETURN TO RTM*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0091
*   DO;                                                            0091
*     R0=RECOVERY;                  /* SET THE SRM FUNCTION REGISTER
*                                      TO INDICATE FRR RECOVERY FOR
*                                      SUBSEQUENT SRM FUNCTIONS      */
         LA    R0,1                                                0092
*     R8=PSACSTK;                   /* ESTABLISH CURRSTK REG AS    0093
*                                      POINTER TO THE INTERRUPTED  0093
*                                      STACK                         */
         L     R8,PSACSTK                                          0093
*     RFY                                                          0094
*       R7 RSTD;                    /* REG TO SAVE OLD PLN   @ZA20321*/
*     R7=RT1WLPN;                   /* SAVE OLD LPN          @ZA20321*/
         SLR   R7,R7                                               0095
         IC    R7,RT1WLPN(,R8)                                     0095
*     RT1TLPN=RT1SRMLO;             /* DEFINE DEFAULT RECOVERY FOR 0096
*                                      IEAVTRTS              @YM06156*/
         LA    @15,16                                              0096
         ALR   @15,R8                                              0096
         MVI   RT1TLPN(@15),X'3C'                                  0096
*     R2=R4;                        /* SAVE SRMS STACK ADDRESS IN THE
*                                      INTERRUPTED STAK              */
         LR    R2,R4                                               0097
*     RTMRETAD=R14;                 /* CHKPT RTMS RETURN ADDRESS IN
*                                      THE INTERRUPTED STACK         */
         LA    @12,48                                              0098
         ALR   @12,R8                                              0098
         ST    R14,RTMRETAD(,@12)                                  0098
*     RTMBASE=R9;                   /* CHKPT RTMS BASE REGISTER IN 0099
*                                      THE INTERRUPTED STACK         */
         ST    R9,RTMBASE(,@12)                                    0099
*     MODEBYTE=RT1WMODE;            /* ESTABLISH MODE OF SYSTEM AT 0100
*                                      TIME OF ERROR                 */
         IC    @12,RT1WMODE(,R8)                                   0100
         STC   @12,MODEBYTE+81(,R8)                                0100
*     RT1TLPID=SRMDRID;             /* DEFINE RTS RECOVERY   @YM06156*/
         MVI   RT1TLPID(@15),X'01'                                 0101
*   END;                                                           0102
*   RFY                                                            0103
*    (R4,                                                          0103
*     R14) UNRSTD;                  /* RELEASE REGS 4,14,            */
*   GENERATE CODE                   /* ESTABLISH REG R9 AS SECOND  0104
*                                      BASE REG FOR IEAVTRTS         */
*       ;                                                          0104
*                                                                  0104
         LA    R9,4095(,R10)   CODEREG R9 IS R10+4095
         USING @PSTART+4095,R9
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING LOOP IS DEFINED AS AN INTEGRAL PART OF SRM      */
*   /* PROCESSING. LOOPING WILL ONLY TAKE PLACE WHEN SRM IS IS       */
*   /* ENTERED FOR RECURSION. OTHERWISE THE FUNCTIONS ENCLOSED IN THE*/
*   /* DO GROUP WILL ONLY EXECUTE ONCE                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0105
*   DO WHILE R0>=RECOVERY;          /* PERFORM SRM FRR PROCESSING  0105
*                                      ONLY IF RECOVERY IS STILL   0105
*                                      NEEDED. THAT IS IF FUNCTION 0105
*                                      REGISTER(R0) IS NON ZERO      */
         B     @DE00105                                            0105
@DL00105 DS    0H                                                  0106
*/* ******************************************************************/
*/*  THIS SEGMENT INITIALIZES AN RTCA WITH THE INPUT ERROR IN-       */
*/*  FORMATION IN PREPARATION FOR ROUTING TO FRRS. THE RTCA SEL-     */
*/*  ECTED FOR INITIALIZATION IS DEPENDENT ON THE SYSTEM MODE AT     */
*/*  THE TIME OF THE ERROR(LOCATED IN THE RT1WMODE FIELD OF THE      */
*/*  RTM1 WORK AREA ASSOCIATED WITH THE INTERRUPTED FRR STACK        */
*/*  . THE GLOBAL RTCA ASSOCIATED WITH THE INTERRUPTED STACK IS      */
*/*    SELECTED IF THE MODE IS PHYSICALLY DISABLED OR GLOBALLY       */
*/*    LOCKED                                                        */
*/*  . THE LOCAL RTCA ASSOCIATED WITH THE ACTIVE MEMORY AT THE       */
*/*    TIME OF THE FAILURE IS SELECTED IF THE MODE INDICATES         */
*/*    LOCALLY LOCKED                                                */
*/*  . AN SRB RTCA IS DYNAMICALLY ACQUIRED(VIA GETMAIN) IF THE       */
*/*    MODE INDICATES SRB MODE                                       */
*/* THE  SELECTION OF AN RTCA IS PERFORMED BY THE ALLOCAT SEGMENT    */
*/*  IF RECURSION IS IN EFFECT(I.E. THE RT1WRTCA FIELD OF THE        */
*/*  RTM1 WA ASSOCIATED WITH THE INTERRUPTED STACK IS NONZERO        */
*/* ---IN FACT POINTS TO THE CURRENTLY ACTIVE RTCA)                  */
*/*  THE INPUT ERROR INFORMATION IS CHECKPOINTED INTO THE SRMREG     */
*/*  SAVE AREA AND SELECTING AND INITIALIZING AN RTCA IS BYPASSED    */
*/*  UNTIL THE ORIGINAL RTCA REPRESENTING THE OLD ERROR HAS BEEN     */
*/*  RECORDED(IN THE SEGMENT--RECORD)                                */
*/*  INPUT TO THIS SEGMENT IS AS FOLLOWS:                            */
*/* FLAGSCC REGISTER(R1) CONTAINS COMP CODE AND CALLRTM FLAGS        */
*/*  - SRMSTAK REGISTER(R2) CONTAINS ADDR OF SRMS RECOVERY STACK     */
*/*  - CURRSTK REGISTER(R8) CONTAINS THE ADDR OF THE INTERRUPTED     */
*/*    FRR STACK                                                     */
*/*  - DUMPOPTS REGISTER(R5) CONTAINS THE ADDR OF DUMP OPTIONS       */
*/*    IF THE ERROR TYPE IS NOT A MACHINE CHECK                      */
*/*  - REPAIRAD REGISTER(R5) CONTAINS THE ADDR OF MACHINE CHECK      */
*/*    INFORMATION IF THE ERROR IS A MACHINE AND A COMPLETE          */
*/*    DESCRIPTION OF THE ERROR WAS OBTAINABLE(I.E.THE EEDCHAIN      */
*/*    REGISTER(R6) IS GREATER THAN 1)                               */
*/*  - REPRDATA REGISTER(R5) CONTAINS ABBREVIATED MACHINE CHECK      */
*/*    IF A COMPLETE DESCRIPTION OF A MACHINE CHECK WAS NOT          */
*/*    OBTAINABLE(I.E. EEDCHAIN REGISTER(R6) IS ZERO OR 1)           */
*/*  - EEDCHAIN REGISTER(R6) CONTAINS AN INDICATION THAT TELLS       */
*/*    SRM WHETHER FOR A MACHINE CHECK ERROR A COMPLETE OR           */
*/*    INCOMPLETE DESCRIPTION OF THE ERROR HAS BEEN SUPPLIED         */
*/*    FOR ALL OTHER ERROR TYPES EXCEPT MACHINE CHECK THIS           */
*/*    REGISTER IS ZERO ON INPUT TO SRM                              */
*/*  - RECURSE REGISTER(R7) CONTAINS THE ORIGINAL LOGICAL PHASE      */
*/*    NUMBER FROM RTM.                                      @ZA20321*/
*/*    SAVAREAP REGISTER(R13) CONTAINS THE ADDR OF THE REGISTERS     */
*/*    SAVED AT THE TIME OF THE ERROR                                */
*/*  - PSARSVT(THE RECOVERY STACK VECTOR TABLE IN THE PSA)           */
*/*    CONTAINS ADDRESSES TO ALL FRR STACKS DEFINED IN THE SYSTEM    */
*/* .THE INTERRUPTED FRR STACK ADDRESSABLE FROM THE PSACSTK FIELD    */
*/*   OF THE RSVT, THE RTM1 WA LOCATED IN THE INTERRUPTED FRR        */
*/*  STACK, THE CURRENT ASCB ADDRESSABLE FROM THE PSA,THE ASSOC      */
*/*  ICATED ASXB ADDRESSABLE FROM THE ASCB,THE LOCAL RTCA ADDRESS    */
*/*  ABLE FROM THE ASXB                                              */
*/* IF RECURSION WAS NOT ACTIVE ON ENTRY THE PROPER RTCA IS SEL-     */
*/*  ECTED AND INITIALIZED USING THE INPUT ERROR INFORMATION AS      */
*/*  FOLLOWS:                                                        */
*/*   SDWAPARM - POINTS TO THE FRR PARAMETER AREA OF THE CURRENT     */
*/*   FRR ON THE INTERRUPTED STACK. IF THE STACK IS EMPTY THIS       */
*/*   FIELD IS ZERO                                                  */
*/*   SDWAABCC-IS SET WITH THE CALLRTM FLAGS AND COMPLETION CODE     */
*/*   SDWAGRSV-IS INITIALIZED WITH THE REGISTER CONTENTS AT THE      */
*/*   TIME OF THE ERROR                                              */
*/*   SDWAEC1,SDWAEC2-INITIALIZED WITH THE ECMODE PSW AT THE TIME    */
*/*   OF THE ERROR                                                   */
*/*   SDWASRSV-INITIALIZED WITH SAME INFO AS SDWAGRSV                */
*/*   SDWAMCH-INITIALIZED IF THE ERROR TYPE WAS MACHINE CHECK        */
*/*   IF MACHINE CHECK DATA IS ABBREVIATED FIELDS SDWAMCHI,          */
*/*   SDWACPID ARE INITIALIZED WITH THE ABBREVIATED MACHK DATA.      */
*/*   IF ERROR TYPE IS NOT MACHINE CHECK THESE FIELD WILL BE ZERO    */
*/*   SDWAERRA,SDWAERRB FIELDS ARE INITIALIZED TO INDICATE THE       */
*/*   ENTRY TYPE                                                     */
*/*   SDWARCRD-INITIALIZED TO INDICATE RECORDING                     */
*/*   SDWADUMP IS INITIALIZED WITH THE DUMP OPTIONS SPECIFIED        */
*/*   ON INPUT VIA DUMPOPTS REGISTER (R5)-IF NO DUMPOPTS WERE        */
*/*   SUPPLIED THEN SDWADUMP IS ZERO                                 */
*/*   SDWASPID,SDWALNTH - ARE INITIALIZED WITH THE SUBPOOL ID AND    */
*/*   AND LENGTH IF THE RTCA IS AN SRB RTCA                          */
*/*   SDWADPLA,SDWARECA ARE INITIALIZED TO POINT TO THE DUMP         */
*/*   PARAMETER LIST(IN THE RTCA) AND THE VARIABLE RECORDING         */
*/*   AREA(IN THE RTCA)  RESPECTIVELY                                */
*/*  - RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE           */
*/*    INTERRUPTED STACK POINTS TO THE INITIALIZED RTCA              */
*/*   RECURSE REGISTER (R7)-INDICATES IF RECURSION IS IN EFFECT      */
*/* NOTES                                                            */
*/*  - REGS(R1,R5,R6,R11,R12,R13,R14,R15) BECOME VOLATILE AT THE     */
*/*    END OF THIS SEGMENT                                           */
*/*  - REGS(R0,R2,R7,R8) REMAIN THE SAME THROUGHOUT THIS SEGMENT     */
*/* ******************************************************************/
*                                                                  0106
*     IF RT1WRTCA=NULL              /* IF THIS IS INITIAL    @ZA20321*/
*         |R7=VALIDREC THEN         /* ENTRY OR ANTICIPATED        0106
*                                      RECURSION.            @ZA20321*/
         L     @12,RT1WRTCA(,R8)                                   0106
         LTR   @12,@12                                             0106
         BZ    @RT00106                                            0106
         C     R7,@CF00105                                         0106
         BNE   @RF00106                                            0106
@RT00106 DS    0H                                                  0107
*       DO;                         /* THEN DO THE FOLLOWING         */
*         R7=NULL;                  /* INDICATE THAT RECURSION IS NOT
*                                      IN EFFECT AND THAT SRM IS   0108
*                                      BEING ENTERED TO PROCESS AN 0108
*                                      INITIAL ERROR                 */
*                                                                  0108
         SLR   R7,R7                                               0108
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SEGMENT ALLOCATES/ACQUIRES AN RTCA WHICH WHEN      */
*         /* INITIA- LIZED WITH THE ERROR INFORMATION WILL EVENTUALLY*/
*         /* BE USED BY FRRS DURING FRR RECOVERY PROCESSING. THE RTCA*/
*         /* SELECTED DEPENDS ON THE SYSTEM MODE AT THE TIME OF THE  */
*         /* ERROR(WHICH IS LOCATED IN THE RT1WMODE FIELD OF THE RTM1*/
*         /* WORK AREA AS- SOCIATED WITH THE INTERRUPTED STACK. .THE */
*         /* GLOBAL RTCA(ASSOCIATED WITH THE INTERRUPTED FRR STACK ) */
*         /* IS SELECTED IF THE MODE INDICATES PHYSICAL DISABLEMENT  */
*         /* OR THE HOLDING OF A GLOBAL SPIN LOCK .THE LOCAL RTCA    */
*         /* ASSOCIATED WITH THE MEMORY IN WHICH THE ERROR OCURRED IS*/
*         /* USED IF THE MODE INDICATES THAT EITHER THE LOCAL LOCK   */
*         /* WAS HELD OR THE GLOBAL(CMS) SUSUPEND LOCK WAS HELD .AN  */
*         /* SRB RTCA IS DYNAMICALLY ACQUIRED(VIA GETMAIN) WHEN THE  */
*         /* ERROR OCCURRED IN SRB MODE INPUT TO THIS SEGMENT IS THE */
*         /* FOLLOWING: THE INTERRUPTED STACK ADDRESSABLE FROM THE   */
*         /* PSACSTK FIELD OF THE RSVT,THE RTM1 WORK AREA LOCATED IN */
*         /* THE INTERRUPTED STAK THE CURRENT ASCB ADDRESSABLE FROM  */
*         /* THE PSA,THE ASXB ADDRESSABLE FROM THE ASCB,THE LOCAL    */
*         /* RTCA ADDRESSABLE FROM THE ASXB REGISTER CONTENTS ON     */
*         /* INPUT ARE AS FOLLOWS: FLAGSCC REGISTER (R1) - THE       */
*         /* CALLRTM FLAGS AND COMP. CODE SRMSTAK REGISTER (R2) - THE*/
*         /* FRR STACK THAT SRM CAN USE TO DEFINED ITS OWN FRRS AND  */
*         /* RECOVERY DUMPOPTS REGISTER (R5) -ADDRESS OF DUMPOPTS    */
*         /* SPECIFIED BY IF ABEND WAS USED TO ENTER RTM REPAIRAD    */
*         /* REGISTER OR REPRDATA REGISTER (R5) - THE ADDRESS OF     */
*         /* HARDWARE REPAIR INFORMATION(IF EEDCHAIN REGISTER (R6) IS*/
*         /* NON ZERO) OTHER WISE THIS REGISTER CONTAINS ABBREV-     */
*         /* IATED HARDWARE REPAIR DATA(IF EEDCHAIN REGISTER IS ZERO)*/
*         /* THIS MEAINING FOR R5 IS ONLY APPLICABLE FOR MACHINE     */
*         /* CHECK ERROR ENTRIES TO SRM SAVAREAP REGISTER (R13) - THE*/
*         /* ADDRESS OF THE GENERAL PURPOSE REGISTER CONTENTS AT THE */
*         /* TIME OF THE ERROR OUTPUT FROM THIS SEGMENT IS AS        */
*         /* FOLLOWS:                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0109
*         RFY                                                      0109
*           R3 RSTD;                                               0109
*         R3=MODEBYTE&VALMODES;                                    0110
         LA    @12,81                                              0110
         ALR   @12,R8                                              0110
         LA    R3,186                                              0110
         SLR   @11,@11                                             0110
         IC    @11,MODEBYTE(,@12)                                  0110
         NR    R3,@11                                              0110
*         IF R8=PSANSTK             /* IF THE INTERRUPTED STAK IS NOT
*                                      A SUPER STACK                 */
*             &PSASUPER=NULL        /* AND IF THE CPU IS NOT IN SUPER
*                                      NODE                          */
*             &(R3^=NULL|MODEDIS^=ON)&MODEGSPN^=ON/* AND IF NO GLOBAL
*                                      SPIN LOCKS ARE HELD BY THE CPU*/
*             &RT1TENPT^=RT1WDAT THEN/* AND THE ERROR WAS NOT A    0111
*                                      DATERR                        */
         C     R8,PSANSTK                                          0111
         BNE   @RF00111                                            0111
         SLR   @11,@11                                             0111
         CL    @11,PSASUPER                                        0111
         BNE   @RF00111                                            0111
         CR    R3,@11                                              0111
         BNE   @GL00003                                            0111
         TM    MODEDIS(@12),B'01000000'                            0111
         BO    @RF00111                                            0111
@GL00003 LA    @12,81                                              0111
         ALR   @12,R8                                              0111
         TM    MODEGSPN(@12),B'00100000'                           0111
         BO    @RF00111                                            0111
         CLI   RT1TENPT+16(R8),4                                   0111
         BE    @RF00111                                            0111
*           IF                      /* AND IF NO GLOBAL SUSPEND      */
*               MODELOC^=ON THEN    /* LOCKS ARE HELD AND THE LOCAL
*                                      IS NOT HELD THEN THE ERROR  0112
*                                      OCCURRED IN SRB MODE          */
         TM    MODELOC(@12),B'00001000'                            0112
         BO    @RF00112                                            0112
*             DO;                   /* ALLOCATE A SRB RTCA           */
*/* ******************************************************************/
*/* THIS SEGMENT CHECKPOINTS VOLATILE REGISTER CONTENTS PRIOR TO     */
*/* INVOKING THE INTERNAL PROCEDURE(GSRBRTCA) TO ACQUIRE A SRB       */
*/* RTCA AND RESTORES THESE VOLATILE REGISTER ON RETURN FROM THE     */
*/* INTERNAL PROC(GSRBRTCA)                                          */
*/* INPUT                                                            */
*/*  -FLAGSCC REGISTER(R1) CONTAINS THE COMPLETION CODE AND          */
*/*   CALLRTM FLAGS APPLICABLE TO THIS ERROR                         */
*/*  -SAVAREAP REGISTER(R13) CONTAINS THE ADDRESS OF THE REGISTER    */
*/*   SAVE AREA CONTAINING THE REGISTER CONTENTS AT THE TIME OF      */
*/*   THE ERROR                                                      */
*/*  -FUNCTION REGISTER(R0) CONTAINS THE INTERNAL FUNCTION CODE      */
*/*   WHICH DIRECTS FURTHER SRM PROCESSING                           */
*/*  -CURRSTK REGISTER(R8) POINTS TO THE INTERRUPTED FRR STACK       */
*/*   BEING PROCESSED BY SRM                                         */
*/* OUTPUT                                                           */
*/*  -THE RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE        */
*/*   INTERRUPTED FRR STACK POINTS TO THE ACQUIRED SRB RTCA          */
*/*  -REGISTERS(R0,R1,R13,R8) CONTAIN THE SAME INFORMATION AS ON     */
*/*   INPUT                                                          */
*/* NOTES                                                            */
*/*  -REGISTERS(R2,R5,R6,R7) MUST REMAIN UNALTERED THROUGHOUT        */
*/*   THIS SEGMENT                                                   */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0114
*               CHKPT3=R1;          /* SAVE COMP CODE AND CALLRTM  0114
*                                      FLAGS IN INTERRUPTED STACK    */
         LA    @12,48                                              0114
         ALR   @12,R8                                              0114
         ST    R1,CHKPT3(,@12)                                     0114
*               CHKPT4=R13;         /* SAVE ADDR OF REGS AT TIME OF
*                                      ERROR IN INTERRUPTED STACK    */
         ST    R13,CHKPT4(,@12)                                    0115
*               CHKPT5=R0;          /* CHKPT THE FUNCTION CODE FOR 0116
*                                      SRM LATER USE                 */
         ST    R0,CHKPT5(,@12)                                     0116
*               RFY                                                0117
*                 R1 UNRSTD;                                       0117
*               RFY                                                0118
*                 R13 UNRSTD;       /* RELEASE REG 13                */
*               RFY                                                0119
*                 R0 UNRSTD;                                       0119
*               RFY                                                0120
*                 R1 RSTD;                                         0120
*               CALL GSRBRTCA;      /* ACQUIRE SRB RTCA              */
*                                                                  0121
         BAL   @14,GSRBRTCA                                        0121
*               /*****************************************************/
*               /*                                                   */
*               /* ON RETURN FROM GSRBRTCA TARGRTCA(R2) CONTAINS THE */
*               /* ADDRESS OF THE ACQUIRED SRB RTCA                  */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0122
*               RT1WRTCA=R1;        /* MAKE THE ACQUIRED SRB RTCA  0122
*                                      CURRENTLY ACTIVE BY SAVING ITS
*                                      ADDR IN THE RTM1 WORK AREA    */
         ST    R1,RT1WRTCA(,R8)                                    0122
*               RFY                                                0123
*                 R1 UNRSTD;                                       0123
*               RFY                                                0124
*                (R1,                                              0124
*                 R13,                                             0124
*                 R0) RSTD;                                        0124
*               R1=CHKPT3;          /* RESTORE COMP CODE AND CALLRTM
*                                      FLAGS                         */
         LA    @12,48                                              0125
         ALR   @12,R8                                              0125
         L     R1,CHKPT3(,@12)                                     0125
*               R13=CHKPT4;         /* RESTORE ADDR OF REGS AT TIME
*                                      OF ERROR                      */
         L     R13,CHKPT4(,@12)                                    0126
*               R0=CHKPT5;          /* REESTABLISH SRMS INTERNAL   0127
*                                      FUNCTION CODE                 */
         L     R0,CHKPT5(,@12)                                     0127
*             END;                                                 0128
*           ELSE                    /* OTHERWISE MODE IS LOCAL       */
*             DO;                   /* AND THE LOCAL RTCA IS TO BE 0129
*                                      ASSIGNED                      */
         B     @RC00112                                            0129
@RF00112 DS    0H                                                  0130
*               RT1WRTCA=ASXBFRWA;  /* THE LOCAL RTCA WILL NOW BECOME
*                                      THE ACTIVE RTCA               */
         L     @12,PSAAOLD                                         0130
         L     @12,ASCBASXB(,@12)                                  0130
         L     @12,ASXBFRWA(,@12)                                  0130
         ST    @12,RT1WRTCA(,R8)                                   0130
*             END;                                                 0131
*         ELSE                      /* USE THE GLOBAL RTCA FOR THE 0132
*                                      ERROR IF THE ERROR OCURRED IN
*                                      GLOBAL MODE                   */
*           DO;                                                    0132
         B     @RC00111                                            0132
@RF00111 DS    0H                                                  0133
*             RFY                                                  0133
*              (R4,                                                0133
*               R3) RSTD;                                          0133
*             IF R8=PSANSTK THEN    /* IF THE INTERRUPTED STACK      */
         C     R8,PSANSTK                                          0134
         BNE   @RF00134                                            0134
*               DO;                 /* IS THE NORMAL STACK THEN THE
*                                      GLOBAL RTCA ASSOCIATED WITH 0135
*                                      THE NORMAL STACK IS USED      */
*                 RT1WRTCA=ADDR(NGLBRTCA);/* MAKE THE GLOBAL RTCA  0136
*                                      ASSOCIATED WITH THE NORMAL  0136
*                                      ACTIVE                        */
         L     @12,YSTAK+24                                        0136
         SLA   @12,5                                               0136
         AL    @12,@CF03510                                        0136
         AL    @12,PSARSTK                                         0136
         ST    @12,RT1WRTCA(,R8)                                   0136
*               END;                                               0137
*             ELSE                  /* OTHERWISE A SUPER STACKS RTCA
*                                      IS TO BE LOCATED              */
*               DO;                                                0138
         B     @RC00134                                            0138
@RF00134 DS    0H                                                  0139
*                 R4=THREE;         /* INITIALIZE RSVTIDX FOR      0139
*                                      FOLLOWING LOOP THRU THE SUPER
*                                      STACKS DEFINED ON THE RSVT    */
         LA    R4,3                                                0139
*                 R3=TWO;           /* INIT STKIDX FOR LOOP ALSO     */
         LA    R3,2                                                0140
*                 DO WHILE PSARSVT(R4)^=R8;/* LOOP THRU THE RSVT TO
*                                      LOCATE THE CURRENT SUPER STACK*/
         B     @DE00141                                            0141
@DL00141 DS    0H                                                  0142
*                   R3=R3+NRMSTK;   /* UPDATE THE STK INDEX          */
         AL    R3,@CF00079                                         0142
*                   R4=TWO*R3-NRMSTK;/* AND THE RSVT INDEX           */
         LR    R4,R3                                               0143
         ALR   R4,R4                                               0143
         BCTR  R4,0                                                0143
*                 END;              /* CONTINUE UNTIL THE CURRENT  0144
*                                      SUPER STACK IS FOUND          */
@DE00141 LR    @12,R4                                              0144
         SLA   @12,2                                               0144
         C     R8,PSARSVT-4(@12)                                   0144
         BNE   @DL00141                                            0144
*                 RT1WRTCA=ADDR(GLOBRTCA);/* THE GLOBAL RTCA IS    0145
*                                      ACTIVE                        */
         LR    @12,R3                                              0145
         SLA   @12,2                                               0145
         L     @12,YSTAK-8(@12)                                    0145
         SLA   @12,5                                               0145
         AL    @12,@CF01027                                        0145
         AL    @12,PSACSTK                                         0145
         ST    @12,RT1WRTCA(,R8)                                   0145
*               END;                                               0146
*             RFY                                                  0147
*              (R4,                                                0147
*               R3) UNRSTD;                                        0147
@RC00134 DS    0H                                                  0148
*           END;                                                   0148
*                                                                  0148
*         /***********************************************************/
*         /*                                                         */
*         /* THE FOLLOWING CODE INITIALIZES THE RTCA                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0149
*/* ******************************************************************/
*/* THIS SEGMENT BEGINS THE INITIALIZATION OF THE RTCA WITH EVENTUAL */
*/* USE BY THE FRR.  ALSO, THIS SEGMENT REINITIALIZES AN RTCA WITH   */
*/* ERROR DATA ON A RECURSION(FRR FAILURE), AND PREPARE THE FRR STACK*/
*/* THAT WAS INTERRUPTED(IF NORMAL FRR STACK)FOR PROCESSING THE ERROR*/
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  - CURRSTK(R8) POINTS TO THE INTERRUPTED STACK                   */
*/*  - FLAGSCC(R1) CONTAINS THE COMP CODE FOR THE ERROR              */
*/*  - ACTVRTCA(R3) POINTS TO THE RTCA TO BE INITIALIZED             */
*/*  - FUNCTION(R0) CONTAINS EITHER A FUNCTION CODE IF NO RECURSION  */
*/*    OR CONTAINS THE RTCA ADDRESS FOR THE RTCA PASSED TO THE FRR   */
*/*    THAT FAILED CAUSING THE RECURSION.                            */
*/*  - THE RTM1 WORK AREA IN THE INTERRUPTED STACK CONTAINS THE      */
*/*   INDICATION AS TO WHETHER A LOCAL RTCA IS BEING USED TO PROCESS */
*/*    A SRB MODE FAILURE                                            */
*/* OUTPUT FROM THIS SEGMENT IS AS FOLLOWS:                          */
*/*  -THE RECORDING VARIABLE AREA POINTER,THE DUMP PARM LIST POINTER */
*/*    ARE INITIALIZE IN THE RTCA                                    */
*/*  - IF RECURSION(FRR FAILURE)THE OLD RTCA(PTR IN R0) IS PARTIALLY */
*/*    ZEROED TO ALLOW FOR THE ADDITION OF CARRY OVER DATA FROM THE  */
*/*    RTCA PRIOR TO THE RECURSION                                   */
*/*  - THE COMP CODE IS INITIALIZED IN THE RTCA                      */
*/*  - THE RECORDING BIT TO INDICATE THAT THE RTCA IS TO BE RECORDED */
*/*    IS SET ON                                                     */
*/*  - DUMP OPTIONS IF SUPPLIED ARE INITIALIZED IN THE RTCA          */
*/*  - ERROR TYPE AND MODE IS SET IN THE RTCA                        */
*/* NOTES                                                            */
*/*  - REGS(R0,R1,R2,R3,R5,R6,R7,R8,R9,R10,R13) ARE RESTRICTED       */
*/*  - OTHER REGS VOLATILE                                           */
*/* ******************************************************************/
*                                                                  0149
*         RFY                                                      0149
*           R3 RSTD;                                               0149
@RC00111 DS    0H                                                  0150
*         R3=RT1WRTCA;              /* USE ACTVRTCA REG TO CONTAIN 0150
*                                      ADDRESS OF RTCA               */
         L     R3,RT1WRTCA(,R8)                                    0150
*         RFY                                                      0151
*           SDWA BASED(R3);         /* AND USE ACTVRTCA REG FOR    0151
*                                      ADDRESSING THE RTCA           */
*         DO;                                                      0152
*           IF R0=RECOVERY THEN     /* IF SRM IS HANDLING AN INITIAL
*                                      ERROR THEN PERFORM RTCA     0153
*                                      INITIALIZATION AS FOLLOWS     */
         C     R0,@CF00079                                         0153
         BNE   @RF00153                                            0153
*             DO;                   /* READY THE FRR STACK AND THE 0154
*                                      RTCA                          */
*/* ******************************************************************/
*/* THIS SEGMENT INSURES THAT THE NORMAL STACK AND THE FRR ENTRIES ON*/
*/* THE NORMAL FRR STACK REFLECT INITIAL CONDITIONS FOR IEAVTRTS TO  */
*/* PROCESS THE ERROR.  THAT IS THE SECOND WORD OF EACH FRR ENTRY IS */
*/* ZEROED TO ALLOW IEAVTRTS TO VIEW THE FRR STACK AS READY TO BE    */
*/* USED TO PROCESS THE ERROR.  SINCE ON EVERY DISPATCH THE NORMAL   */
*/* FRR STACK IS ONLY PURGED AND THE SECOND WORD OF EACH FRR ENTRY   */
*/* IS UNTOUCHED BY THIS PURGING WHEN A NEW ERROR OCCURRS WITH THE   */
*/* NORMAL FRR STACK AS CURRENT EACH SECOND WORD OF EACH FRR ENTRY   */
*/* MUST BE ZEROED SO THAT IEAVTRTS CAN USE THESE AREAS IN SUPPORT   */
*/* OF THE NEW ERROR AND NOT MISINTERPRET INFORMATION ABOUT AN       */
*/*  OLD ERROR                                                       */
*/* ******************************************************************/
*                                                                  0155
*               IF R8=PSANSTK THEN  /* IF THE INTERRUPTED STACK IS 0155
*                                      THE NORMAL STACK THEN INSURE
*                                      THAT ALL FRR ENTRIES OF THE 0155
*                                      STACK REFLECT INITIAL       0155
*                                      CONDITIONS FOR SRM HANDLING OF
*                                      THE ERROR                     */
         C     R8,PSANSTK                                          0155
         BNE   @RF00155                                            0155
*                 DO;               /* PERFORM NORMAL STACK        0156
*                                      PREPARATION AND INITIALIZATION*/
*                   RFY                                            0157
*                     R4 RSTD;                                     0157
*                   RFY                                            0158
*                     FRRSENTR BASED(R4);                          0158
*                   R4=FRRSEMP;     /* INITIALIZE THE ENTRY ADDRESS
*                                      REGISTER FOR THE FOLLOWING  0159
*                                      LOOP                          */
         L     R4,FRRSEMP(,R8)                                     0159
*                   DO WHILE R4<FRRSLAST;                          0160
         B     @DE00160                                            0160
@DL00160 DS    0H                                                  0161
*                     R4=R4+FRRSESZE;/* INCREMENT TO THE NEXT FRR  0161
*                                      ENTRY                         */
         AL    R4,@CF00122                                         0161
*                     FRRSFLGS=''B; /* ZERO THE SRM FLAGS IN THIS  0162
*                                      ENTRY                         */
         XC    FRRSFLGS(4,R4),FRRSFLGS(R4)                         0162
*                   END;            /* CONTINUE UNTIL ALL ENTRIES OF
*                                      THE NORMAL STACK ARE PROCESSED*/
@DE00160 C     R4,FRRSLAST(,R8)                                    0163
         BL    @DL00160                                            0163
*                   RFY                                            0164
*                     FRRSENTR BASED(FRRSCURR);                    0164
*                   RFY                                            0165
*                     R4 UNRSTD;                                   0165
*                 END;                                             0166
*               ELSE                                               0167
*                 ;                 /* IF THE INTERRUPTED STACK IS 0167
*                                      NOT THE NORMAL STACK THEN   0167
*                                      STACK PREPARATION IS NOT    0167
*                                      NECESSARY                     */
@RF00155 DS    0H                                                  0168
*               IF RT1TLOCL^=ON THEN/* IF THE LOCAL RTCA IS NOT BEING
*                                      USED TO PROCESS A SRB MODE  0168
*                                      ERROR THEN THE ALLOCATED RTCA
*                                      CAN BE ZEROED                 */
*                                                                  0168
         TM    RT1TLOCL(R8),B'00100000'                            0168
         BO    @RF00168                                            0168
*                 /***************************************************/
*                 /*                                                 */
*                 /* ****ZERO THE RTCA*****                          */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0169
*                 DO;                                              0169
*                   SDWA(1:256)=''B;/* ZERO 1ST 256 BYTES-RTCA       */
         XC    SDWA(256,R3),SDWA(R3)                               0170
*                   SDWA(257:LENGTH(SDWA))=''B;/* ZERO REMAINING   0171
*                                      BYTES-RTCA                    */
         XC    SDWA+256(256,R3),SDWA+256(R3)                       0171
*                   IF RT1WSRBR^=NULL THEN/* IF A SRB RTCA WAS     0172
*                                      SUCCESSFULLY GETMAINED TO   0172
*                                      PROCESS THE SRB ERROR THEN  0172
*                                      FINISH THE INITIALIZATION OF
*                                      OF THE SRB RTCA               */
         L     @12,RT1WSRBR(,R8)                                   0172
         LTR   @12,@12                                             0172
         BZ    @RF00172                                            0172
*                     SDWAIDNT=SQARTCA;/* INITIALIZE THE LENGTH AND
*                                      SUBPOOL ID OF THE GETMAINED 0173
*                                      SRB RTCA                      */
         L     @12,SQARTCA                                         0173
         ST    @12,SDWAIDNT(,R3)                                   0173
*                   ELSE                                           0174
*                     ;             /* IF THE ALLOCATED RTCA IS IS 0174
*                                      NOT A GETMAINED SRB RTCA THEN
*                                      NO SUBPOOL ID AND LENGTH NEED
*                                      BE INITIALIZED                */
@RF00172 DS    0H                                                  0175
*                 END;                                             0175
*               ELSE                                               0176
*                 ;                 /* IF A LOCAL RTCA IS BEING USED
*                                      FOR A SRB ERROR THEN IT HAS 0176
*                                      ALREADY BEEN INITIALIZED      */
@RF00168 DS    0H                                                  0177
*             END;                                                 0177
*           ELSE                    /* IF SRM IS HANDLING A RECURSION
*                                      BECAUSE OF A FRR ERROR THEN 0178
*                                      THE FUNCTION REGISTER WILL PT
*                                      TO THE OLD RTCA PASSED TO THE
*                                      FRR WHOSE FAILURE CAUSED THE
*                                      RECURSIVE ENTRY INTO SRM      */
*             DO;                                                  0178
         B     @RC00153                                            0178
@RF00153 DS    0H                                                  0179
*               RFY                                                0179
*                 RTCA BASED(R12);                                 0179
*               RFY                                                0180
*                 R12 RSTD;                                        0180
*               R12=R0;                                            0181
         LR    R12,R0                                              0181
*               RTCAZ1=''B;         /* ZERO ALL BYTES OF THE       0182
*                                      ALLOCATED                     */
         XC    RTCAZ1(200,R12),RTCAZ1(R12)                         0182
*               RTCAZ11=''B;        /*                       @YM03360*/
         XC    RTCAZ11(29,R12),RTCAZ11(R12)                        0183
*               RTCAZ2=''B;         /* RTCA EXCLUDING THOSE BYTES    */
         MVI   RTCAZ2(R12),X'00'                                   0184
*               RTCAZ21=''B;        /*                       @G17EP5W*/
         XC    RTCAZ21(14,R12),RTCAZ21(R12)                        0185
*               RTCAZ3=''B;         /* DEALING WITH LOCKS REQUESTED  */
         XC    RTCAZ3(100,R12),RTCAZ3(R12)                         0186
*               RTCAZ4=''B;         /* TO BE FREED,THE CLEANUP AND 0187
*                                      PERC BIT,SUBPOOL AND LENGTH OF
*                                      SDWA,SERVICEABILITY BIT,THE 0187
*                                      FRR FAILURE BIT,AND THE     0187
*                                      PERCOLATION BIT       @YM03360
*                                      AND THE ERROR ID DATA @G17EP5W*/
         XC    RTCAZ4(116,R12),RTCAZ4(R12)                         0187
*               RFY                                                0188
*                 SRMRGSV BASED(R3+LENGTH(SDWA));/*          @YM02684*/
*                                                                  0188
*               /*****************************************************/
*               /*                                                   */
*               /* THIS SEGMENT WILL ADDITIONALLY INITIALIZE THE RTCA*/
*               /* WITH CARRY OVER INFORMATION FROM THE RTCA         */
*               /* ASSOCIATED WITH A FRR THAT FAILED AND CAUSED      */
*               /* RECURSION INTO SRM INPUT - THE RT1WRTCA FIELD OF  */
*               /* THE RTM1 WORK AREA PORTION OF THE INTERRUPTED     */
*               /* STACK POINTS TO THE RTCA TO BE USED TO SERVICE THE*/
*               /* RECURSIVE ERROR - THE OLD RTCA PASSED TO THE FRR  */
*               /* WHICH FAILED IS POINTED TO OUT OF THE RTM1 WORK   */
*               /* AREA ASSOCIATED WITH THE INTERRUPTED STACK OUTPUT */
*               /* - THE SDWACLUP BIT IS TURNED ON IN THE NEW RTCA IF*/
*               /* IT WAS ON IN THE OLD RTCA SO THAT FUTURE FRRS TO  */
*               /* GET CONTROL WILL STILL BE REQUIRED TO CLEANUP AND */
*               /* PERCOLATE DESPITE THE FRR FAILURE - THE LOCKS TO  */
*               /* FREE INDICATORS AND LOCKWORDS ARE CARRIED OVER    */
*               /* FROM THE OLD RTCA TO THE NEW RTCA SO THAT THEY CAN*/
*               /* BE EVENTUALLY HONORED WHEN A FRR SUCCESSFULLY     */
*               /* RETURNS TO SRM NOTES - THROUGHOUT THIS SEGMENT THE*/
*               /* FOLLOWING REGISTERS REMAIN UNCHANGED - R0,R2,R7,R8*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0189
*               DO;                                                0189
*                 IF RT1WCLUP=ON THEN/* IF THE CLEANUP AND PERC BIT
*                                      IS ON FOR THE ORIGINAL ERROR
*                                      ENTRY INTO SRM THEN TURN IT ON
*                                      IN THE NEW RTCA               */
         TM    RT1WCLUP(R8),B'10000000'                            0190
         BNO   @RF00190                                            0190
*                   SDWACLUP=ON;    /* TURN CLEANUP AND PERCOLATE BIT
*                                      ON IN THE NEW RTCA            */
         OI    SDWACLUP(R3),B'10000000'                            0191
*                 SDWAERRC=RTCAERRC;/* CARRY OVER THE ERRC BYTE OF 0192
*                                      THE OLD RTCA TO THE NEW RTCA  */
@RF00190 MVC   SDWAERRC(1,R3),RTCAERRC(R12)                        0192
*                 SDWAACF3=RTCALKS1;/* CARRY OVER LOCKS TO BE FREED  */
         MVC   SDWAACF3(1,R3),RTCALKS1(R12)                        0193
*                 SDWAACF4=RTCALKS2;/* FROM THE OLD RTCA TO THE NEW
*                                      RTCA                          */
         MVC   SDWAACF4(1,R3),RTCALKS2(R12)                        0194
*                 SDWALKWA=RTCALKWA;/* CARRY OVER THE LOCKWORDS FROM
*                                      THE OLD RTCA TO THE NEW RTCA
*                                      AND SEQ# AND ASID FOR ERRORID
*                                                            @G17EP5W*/
         MVC   SDWALKWA(32,R3),RTCALKWA(R12)                       0195
*                 SDWACPUI=RTCACPUI;/* CARRY OVER CPU ID FROM ERRORID
*                                                            @G17EP5W*/
         IC    @11,RTCACPUI(,R12)                                  0196
         STC   @11,SDWACPUI(,R3)                                   0196
*                 SDWAFMID=RTCAFMID;/* CARRY OVER THE FAILING MEMORY
*                                      ID IN THE OLD RTCA            */
         MVC   SDWAFMID(2,R3),RTCAFMID(R12)                        0197
*                 SDWACOMP=RTCACOMP;/* CARRY OVER ADDITONAL RECOVERY
*                                      INFO(ON PER COMPONENT BASIS)  */
         L     @11,RTCACOMP(,R12)                                  0198
         ST    @11,SDWACOMP(,R3)                                   0198
*                 LOCKMASK=RTCALMSK;/* CARRY OVER LOCKMASK   @YM02684*/
         LA    @11,512                                             0199
         LR    @04,R3                                              0199
         ALR   @04,@11                                             0199
         ALR   @11,R0                                              0199
         MVC   LOCKMASK(2,@04),RTCALMSK(@11)                       0199
*                 SDWASTAF=ON;      /* INDICATE IN THE RTCA THAT A 0200
*                                      PREVIOUS FRR FAILED           */
         OI    SDWASTAF(R3),B'10000000'                            0200
*               END;                                               0201
*               RFY                                                0202
*                 SRMRGSV BASED(RT1WRTCA+LENGTH(SDWA));/*    @YM02684*/
*               RFY                                                0203
*                 R12 UNRSTD;                                      0203
*               RFY                                                0204
*                 RTCA BASED(R0);                                  0204
*             END;                                                 0205
*         END;                                                     0206
@RC00153 DS    0H                                                  0207
*         SDWAABCC=R1;              /* SET THE COMPLETION CODE       */
         ST    R1,SDWAABCC(,R3)                                    0207
*         SDWADPLA=ADDR(SDWASNPA);  /* SET SNAP PARM LIST ADDRESS    */
         LA    @12,SDWASNPA(,R3)                                   0208
         ST    @12,SDWADPLA(,R3)                                   0208
*         SDWARECA=ADDR(SDWAVRA);   /* SET ADDRESS TO VARIABLE     0209
*                                      RECORDING AREA        @ZA07477*/
         LA    @12,SDWAVRA(,R3)                                    0209
         ST    @12,SDWARECA(,R3)                                   0209
*         SDWARCRD=ON;              /* INDICATE RECORDING OF THE RTCA*/
         OI    SDWARCRD(R3),B'10000000'                            0210
*         SDWAVRAL=LENGTH(SDWAVRA); /* INITIALIZE LENGTH OF VARIABLE
*                                      RECORDING AREA IN RTCA        */
         MVC   SDWAVRAL(2,R3),@CH01378                             0211
*         SDWAASID=PSAAOLD->ASCBASID;/* PUT ASID INTO SDWA FOR     0212
*                                      DEBUGGING FROM LOGREC @ZA05516*/
         L     @12,PSAAOLD                                         0212
         MVC   SDWAASID(2,R3),ASCBASID(@12)                        0212
*/* ******************************************************************/
*/* THIS SEGMENT INITIALIZES THE RTCA WITH THE ERROR TYPE AND REGS   */
*/* AND PSW AT THE TIME OF THE ERROR.                                */
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  - THE RTM1 WORK AREA ASSOCIATED WITH THE INTERRUPTED STACK      */
*/*  - CURRSTK(R8) POINTS TO THE INTERRUPTED STACK                   */
*/*  - THE RT1TENPT FIELD OF THE RTM1 WORK AREA WHICH INDICATES      */
*/*      THE ERROR TYPE                                              */
*/*  - THE RTM1 WORK AREA FIELDS RT1WPSW1,RT1WPSW2 POINTS TO THE     */
*/*    PSW AT THE TIME OF THE ERROR                                  */
*/*  - SAVAREAP REGISTER(R13) POINTS TO THE REGISTERS AT THE TIME OF */
*/*    THE ERROR                                                     */
*/* OUTPUT FROM THIS SEGMENT IS AS FOLLOWS:                          */
*/*  - THE RTCA IS INITIALIZE WITH THE ERROR TYPE AND PSW AND REGS AT*/
*/*    THE TIME OF THE ERROR                                         */
*/*  - THE RTCA INDICATES WHETHER THE ERROR TYPE IS A RETRYABLE ERROR*/
*/*    OR WHETHER THE ERROR MUST BE ONLY A CLEAN UP - PERCOLATE TYPE */
*/*    OF RECOVERY                                                   */
*/*  - ERROR ID INFORMATION FOR SEQ. NBR TIME ASID AND CPUID ARE     */
*/*    MOVED FROM THE EED (IN THE CASE OF MACHK AND EED'S EXIST)     */
*/*    INTO THE SDWA. THE SDWAERFL IS SET.                 @G17EP5W  */
*/* NOTES                                                            */
*/*  - REGS(R0,R1,R2,R3,R5,R6,R7,R8,R9,R10,R13) ARE RESTRICTED       */
*/*  - OTHER REGS ARE VOLATILE                                       */
*/* ******************************************************************/
*                                                                  0213
*         IF RT1WPCFL^=RT1TENPT THEN/* IF ERROR IS NOT PROGCK        */
         LA    @12,16                                              0213
         ALR   @12,R8                                              0213
         CLI   RT1TENPT(@12),1                                     0213
         BE    @RF00213                                            0213
*           IF RT1WREST^=RT1TENPT THEN/* AND NOT RESTART AND NOT     */
         CLI   RT1TENPT(@12),2                                     0214
         BE    @RF00214                                            0214
*             IF RT1WSVC^=RT1TENPT THEN/* AN SVC ISSUED BY NON-TASK  */
         CLI   RT1TENPT(@12),3                                     0215
         BE    @RF00215                                            0215
*               IF RT1WDAT^=RT1TENPT THEN/* MODE RTN AND NOT DAT     */
         CLI   RT1TENPT(@12),4                                     0216
         BE    @RF00216                                            0216
*                 IF RT1WMCHR=RT1TENPT THEN/* ERROR BUT IS MACHINE   */
         CLI   RT1TENPT(@12),5                                     0217
         BNE   @RF00217                                            0217
*                   DO;             /* CHECK THEN DO FOLLOWING       */
*                     SDWAMCHK=ON;  /* INDICATE MACHK IN SDWA        */
         OI    SDWAMCHK(R3),B'10000000'                            0219
*                     IF R6>EEDNULL THEN/* IF HARWARE DATA IS        */
         C     R6,@CF00079                                         0220
         BNH   @RF00220                                            0220
*                       DO;         /* AVAILABE DO FOLLOWING         */
*                         SDWAMCH=HRDWDATA;/* SET MCH HARDWARE DATA
*                                      IN SDWA                       */
         MVC   SDWAMCH(28,R3),HRDWDATA(R5)                         0222
*                         R5=R5-EEDBASE;/* COMPUTE START ADDR. OF EED
*                                                            @G17EP5W*/
         SL    R5,@CF00194                                         0223
*                         RFY                                      0224
*                           EED BASED(R5);/* ADDRESS TO EED ERRORID
*                                      DATA                  @G17EP5W*/
*                         IF R5->EEDERFL=ON THEN/* EED CONTAINS AN 0225
*                                      ERRORID               @G17EP5W*/
         TM    EEDERFL(R5),B'10000000'                             0225
         BNO   @RF00225                                            0225
*                           DO;     /* MOVE THE ERRORID TO THE SDWA
*                                                            @G17EP5W*/
*                             SDWASEQ#=EEDESEQ#;/* MOVE SEQ NBR    0227
*                                                            @G17EP5W*/
         MVC   SDWASEQ#(2,R3),EEDESEQ#(R5)                         0227
*                             SDWACPUI=EEDECPUI;/* MOVE LOGICAL CPUID
*                                                            @G17EP5W*/
         LH    @12,EEDECPUI(,R5)                                   0228
         STC   @12,SDWACPUI(,R3)                                   0228
*                             SDWAERTM=EEDETIME;/* MOVE IN TIME    0229
*                                                            @G17EP5W*/
         MVC   SDWAERTM(4,R3),EEDETIME(R5)                         0229
*                             SDWAERFL=ON;/* INDICATE ERRORID IN SDWA
*                                                            @G17EP5W*/
         OI    SDWAERFL(R3),B'00000001'                            0230
*                           END;    /* END MOVE ERRORID      @G17EP5W*/
*                       END;                                       0232
*                     ELSE          /* OTHERWISE ABBREVIATED MCH     */
*                       DO;                                        0233
         B     @RC00220                                            0233
@RF00220 DS    0H                                                  0234
*                         ABBMACH=R5;/* DATA IS IN REPRDATA REG AND
*                                      IS PLACED IN SDWA             */
         ST    R5,ABBMACH(,R3)                                     0234
*                         SDWAMCIV=ON;/* INDICATE IN SDWA THAT MACH
*                                      CHECK DATA IN UNAVAILABLE     */
         OI    SDWAMCIV(R3),B'00000010'                            0235
*                       END;                                       0236
*                     R5=NULL;      /* ZERO REPRDATA                 */
@RC00220 SLR   R5,R5                                               0237
*                   END;                                           0238
*                 ELSE                                             0239
*                   ;               /* OTHERWISE THE SDWAERRA FIELD
*                                      OF THE SDWA IS NOT SET A    0239
*                                      CANNOT OCURR SITUATION        */
@RF00217 DS    0H                                                  0240
*               ELSE                /* OTHERWISE A DAT ERROR IS      */
*                 DO;                                              0240
         B     @RC00216                                            0240
@RF00216 DS    0H                                                  0241
*                   SDWATEXC=ON;    /* INDICATED IN THE RTCA         */
         OI    SDWATEXC(R3),B'00000010'                            0241
*                   SDWACLUP=ON;    /* INDICATE THAT CLEANUP AND   0242
*                                      PERCOLATION IS ALL THAT IS  0242
*                                      ALLOWED BY FRRS FOR THIS ERROR
*                                      NOT RETRY                     */
         OI    SDWACLUP(R3),B'10000000'                            0242
*                   RT1WCLUP=ON;    /* PRESERVED THE CLEANUP AND   0243
*                                      PERCOLATE INDICATION IN THE 0243
*                                      RTM1 WORK AREA                */
         OI    RT1WCLUP(R8),B'10000000'                            0243
*                   IF ASCBASID=NULL THEN/* IF THE CURRENT ASID IS 0244
*                                      ZERO (I.E.CURRENT ASCB WAS  0244
*                                      OVERLAID) INSURE THAT FRRS DO
*                                      NOT CONSIDER THAT THE CURRENT
*                                      MEMORY IS VALID AND HAS NOT 0244
*                                      FAILED                        */
         L     @12,PSAAOLD                                         0244
         LH    @12,ASCBASID(,@12)                                  0244
         N     @12,@CF03531                                        0244
         LTR   @12,@12                                             0244
         BNZ   @RF00244                                            0244
*                     SDWAFMID=INVLASID;/* INDICATE A FAILING INVALID
*                                      MEMORY IN THE RTCA            */
         MVC   SDWAFMID(2,R3),@CB03198                             0245
*                   ELSE            /* OTHERWISE ASSUME THAT THE   0246
*                                      CURRENT ASCB CONTAINS A VALID
*                                      ASID                          */
*                     SDWAFMID=ASCBASID;/* USE THE CURRENT ASID      */
         B     @RC00244                                            0246
@RF00244 L     @12,PSAAOLD                                         0246
         MVC   SDWAFMID(2,R3),ASCBASID(@12)                        0246
*                 END;                                             0247
*             ELSE                  /* OTHERWISE ANON TASK MODE RTN  */
*               SDWASVCE=ON;        /* ISSUED A SVC ERROR INDICATION
*                                      IS MADE IN THE RTCA           */
         B     @RC00215                                            0248
@RF00215 OI    SDWASVCE(R3),B'00000100'                            0248
*           ELSE                    /* OTHERWISE A RESTART ERROR     */
*             DO;                                                  0249
         B     @RC00214                                            0249
@RF00214 DS    0H                                                  0250
*               SDWARKEY=ON;        /* INDICATION IS MADE IN THE RTCA*/
         OI    SDWARKEY(R3),B'00100000'                            0250
*               SDWACLUP=ON;        /* INDICATE THAT ONLY CLEANUP AND
*                                      PERCOLATION IS ALLOWED BY FRRS
*                                      FOR THIS ERROR- NOT RETRY     */
         OI    SDWACLUP(R3),B'10000000'                            0251
*               RT1WCLUP=ON;        /* PRESERVED THE CLEANUP AND   0252
*                                      PERCOLATE INDICATION IN THE 0252
*                                      RTM1 WORK AREA FOR THIS ERROR */
         OI    RT1WCLUP(R8),B'10000000'                            0252
*             END;                                                 0253
*         ELSE                      /* OTHERWISE A PROGRAM CHK ERROR */
*           SDWAPCHK=ON;            /* INDICATION IS MADE IN RTCA    */
*                                                                  0254
         B     @RC00213                                            0254
@RF00213 OI    SDWAPCHK(R3),B'01000000'                            0254
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SEGMENT INITIALIZES THE REGISTERS AND PSA AT THE   */
*         /* TIME OF THE ERROR IN THE ALLOCATED RTCA INPUT - CURRSTK */
*         /* REGISTER(R8) POINTS TO THE INTERRUPTED FRR STACK -      */
*         /* RT1WRTCA FIELD OF THE RTM1WORK AREA PORTION OF THE      */
*         /* INTERRUPTED STACK POINTS TO THE ALLOCATED RTCA THAT IS  */
*         /* TO BE INITIALIZED - RT1WPSW1,RT1WPSW2 FIELD OF THE RTM1 */
*         /* WORK AREA POINT TO RESPECTIVE HALFS(8 BYTES) OF THE PSW */
*         /* AT TIME OF ERROR - SAVAREAP REGISTER(R13) POINTS TO THE */
*         /* REGISTERS SAVED AT THE TIME OF THE ERROR OUTPUT -       */
*         /* SDWAGRSV,SDWASRSV FIELDS IN THE ALLOCATED RTCA CONTAIN  */
*         /* THE REGISTER CONTENTS AT TIME OF ERROR -                */
*         /* SDWAEC1,SDWAAEC1,SDWAEC2,SDWAAEC2 FIELDS IN THE         */
*         /* ALLOCATED CONTAINS THE PSW AT TIME OF THE ERROR NOTES - */
*         /* REGS(R0,R2,R5,R7,R8)MUST REMAIN UNCHANGED THROUGHOUT    */
*         /* THIS SEGMENT - REGS(R1,R3,R4,R6, R10,R11,R12,R14,R15)   */
*         /* ARE VOLATILE - REGISTER R13 STILL POINTS TO THE REGS AT */
*         /* TIME OF ERROR                                           */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0255
*         DO;                                                      0255
@RC00213 DS    0H                                                  0256
*           SDWAGRSV=ERREGS;        /* INITIALIZE THE ERROR REGS IN
*                                      THE RTCA                      */
         MVC   SDWAGRSV(64,R3),ERREGS(R13)                         0256
*           SDWASRSV=ERREGS;        /* INITIALIZE THE ERROR REGS IN
*                                      THE RTCA                      */
         MVC   SDWASRSV(64,R3),ERREGS(R13)                         0257
*           SDWAEC1=PSW;            /* INITIALIZE 1ST HALF OF ERROR
*                                      PSW IN RTCA                   */
         L     @12,RT1WPSW1(,R8)                                   0258
         MVC   SDWAEC1(8,R3),PSW(@12)                              0258
*           SDWAEC2=PSW;            /* INITIALIZE 1ST HALF OF ERROR
*                                      PSW IN RTCA                   */
         MVC   SDWAEC2(8,R3),PSW(@12)                              0259
*           IF PSAPI2=ON|PSAPSREG=ON THEN/* IF THE ERROR OCCURRED  0260
*                                      EARLY IN THE PC FLIH (BEFORE
*                                      IT ESTABLISHES ITS FRR)     0260
*                                                            @ZA03845*/
         TM    PSAPI2,B'01100000'                                  0260
         BZ    @RF00260                                            0260
*             SDWARPIV=ON;          /* INDICATE REGS AND PSW BAD TO
*                                      DISCOURAGE RETRY      @ZA03845*/
         OI    SDWARPIV(R3),B'00000100'                            0261
*           IF SDWAPCHK^=ON&SDWATEXC^=ON THEN/* IF THE ERROR IS OTHER
*                                      THAN A PROGRAM INTERRUPTION 0262
*                                      THEN INITIALIZE THE 2ND HALF
*                                      OF THE PSW AS FOLLOWS @YM06390*/
@RF00260 TM    SDWAPCHK(R3),B'01000010'                            0262
         BNZ   @RF00262                                            0262
*             DO;                   /*                       @YM06390*/
*               IF RT1WPSW2^=NULL THEN/* IF THE SECOND HALF OF THE 0264
*                                      PSW IS AVAILABLE THEN       0264
*                                      INITIALIZE THE ILC AND      0264
*                                      IC@YM06390                    */
         L     @12,RT1WPSW2(,R8)                                   0264
         LTR   @12,@12                                             0264
         BZ    @RF00264                                            0264
*                 DO;               /*                       @YM06390*/
*                   ECPEXT1=PSWILCIC;/* SET ILC AND IC       @YM06390*/
         MVC   ECPEXT1(4,R3),PSWILCIC(@12)                         0266
*                   ECPEXT2=PSWILCIC;/* SET ILC AND IC       @YM06390*/
         MVC   ECPEXT2(4,R3),PSWILCIC(@12)                         0267
*                 END;              /*                       @YM06390*/
*               ELSE                                               0269
*                 ;                 /* IF 2ND HALF OF PSW NOT      0269
*                                      AVAILABE JUST INITIALIZE THE
*                                      PSW WITH THE LATEST         0269
*                                      TRANSLATION EXCEPTION ADDR  0269
*                                                            @YM06390*/
@RF00264 DS    0H                                                  0270
*               DO;                 /*                       @YM06390*/
*                 SDWATRAN=LCCAPVAD;/* SET TRANS ADDRESS     @YM06390*/
         L     @12,PSALCCAV                                        0271
         L     @12,LCCAPVAD(,@12)                                  0271
         ST    @12,SDWATRAN(,R3)                                   0271
*                 SDWATRN2=LCCAPVAD;/* SET TRANS ADDRESS     @YM06390*/
         ST    @12,SDWATRN2(,R3)                                   0272
*               END;                /*                       @YM06390*/
*             END;                  /*                       @YM06390*/
*           ELSE                    /* IF THE ERROR IS A PROGRAM   0275
*                                      INTERRUPTION THEN THE ILC AND
*                                      IC AND TRANS ADDR ARE       0275
*                                      AVAILABLE             @YM06390*/
*             DO;                   /*                       @YM06390*/
         B     @RC00262                                            0275
@RF00262 DS    0H                                                  0276
*               SDWAAEC2=PSWEXT1;   /* INITIALIZE 2ND HALF OF ERROR
*                                      PSW IN RTCA                   */
         L     @12,RT1WPSW2(,R8)                                   0276
         MVC   SDWAAEC2(8,R3),PSWEXT1(@12)                         0276
*               SDWAAEC1=PSWEXT1;   /* INITIALIZE 2ND HALF OF ERROR
*                                      PSW IN RTCA                   */
         MVC   SDWAAEC1(8,R3),PSWEXT1(@12)                         0277
*             END;                  /*                       @YM06390*/
*         END;                                                     0279
*                                                                  0279
@RC00262 DS    0H                                                  0280
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SEGMENT INITIALIZES THE RTCA WITH ERROR INFORMATION*/
*         /* CONCERNING THE MODE OF THE SYSTEM AT THE TIME OF THE    */
*         /* ERROR INPUT - RT1WRTCA FIELD OF THE RTM1 WORK AREA      */
*         /* PORTION OF THE INTERRUPTED STACK POINTS TO THE RTCA TO  */
*         /* BE INITIALIZED - THE MODE BYTE IN THE RTM1 WORK AREA    */
*         /* PORTION OF THE INTERRUPTED STACK(RT1WMODE) CONTAINS THE */
*         /* MODE OF THE SYSTEM AT THE TIME OF THE ERROR - CURRSTK   */
*         /* REGISTER(R8) POINTS TO THE INTERRUPTED STACK OUTPUT -   */
*         /* THE SDWATYP1 BIT IS SET ON IN THE RTCA IF A TYPE 1 SVC  */
*         /* WAS IN CONTROL AT THE TIME OF THE ERROR - THE SDWALDIS  */
*         /* BIT IS SET ON IN THE RTCA IF A GLOBAL OR LOCAL LOCK WAS */
*         /* HELD AT THE TIME OF THE ERROR - THE SDWASRBM BIT IS SET */
*         /* ON IN THE RTCA IF THE MODEBYTE IN THE RTM1 WORK AREA    */
*         /* INDICATES THAT THE SYSTEM WAS IN SRB MODE AT THE TIME OF*/
*         /* THE ERROR NOTES - ALL RETRICTED GENERAL PURPOSE REGISTER*/
*         /* CONTENTS ON ENTRY ARE UNCHANGED ON EXIT FROM THIS       */
*         /* SEGMENT                                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0280
*         RFY                                                      0280
*           R12 RSTD;                                              0280
*         R12=ADDR(RT1WSRMD);                                      0281
         LA    R12,RT1WSRMD(,R8)                                   0281
*         RFY                                                      0282
*           MODEBYTE BASED(R12);                                   0282
*         IF MODETYP1=ON THEN       /* IF TYPE1 SVC IN CONTROL AT    */
         TM    MODETYP1(R12),B'00000100'                           0283
         BNO   @RF00283                                            0283
*           SDWATYP1=ON;            /* TIME OF ERROR MAKE INDICATION
*                                      IN RTCA                       */
         OI    SDWATYP1(R3),B'00001000'                            0284
*         ELSE                                                     0285
*           ;                       /* IF TYPE1 SVC NOT IN CONTROL AT
*                                      TIME OF ERROR NOT INDICATION
*                                      IS MADE                       */
@RF00283 DS    0H                                                  0286
*         IF MODEBYTE>=LOCLMODE THEN/* IF GLOBAL OR LOCAL MODE THEN  */
         CLI   MODEBYTE(R12),8                                     0286
         BL    @RF00286                                            0286
*           SDWALDIS=ON;            /* INDICATE LOGICAL OR PHYSICAL
*                                      DISABLEMENT AT TIME OF ERROR  */
         OI    SDWALDIS(R3),B'00000010'                            0287
*         ELSE                                                     0288
*           ;                       /* IF THE MODE IS NEITHER GLOBAL
*                                      NOR LOCAL THEN THERE IS NO  0288
*                                      LOGICAL OR PHYSICAL         0288
*                                      DISABLEMENT                   */
@RF00286 DS    0H                                                  0289
*         IF MODESRB=ON THEN        /* IF SRB MODE WAS ACTVE AT TIME
*                                      OF ERROR                      */
         TM    MODESRB(R12),B'00000010'                            0289
         BNO   @RF00289                                            0289
*           SDWASRBM=ON;            /* THEN INDICATE SRB MODE IN THE
*                                      RTCA                          */
         OI    SDWASRBM(R3),B'00000001'                            0290
*         ELSE                                                     0291
*           ;                                                      0291
@RF00289 DS    0H                                                  0292
*         RFY                                                      0292
*           R12 UNRSTD;                                            0292
*         RFY                                                      0293
*           MODEBYTE BASED(ADDR(RT1WSRMD));                        0293
*         RFY                                                      0294
*           R3 UNRSTD;                                             0294
*         RFY                                                      0295
*           SDWA BASED(RT1WRTCA);                                  0295
*                                                                  0295
*         /***********************************************************/
*         /*                                                         */
*         /* THE ERRORID SEGMENT PUTS THE ERRORID INFORMATION INTO   */
*         /* THE SDWA. THE CURRENT TIME IS GOTTEN FROM THE TOD CLOCK.*/
*         /* THE HIGH AND LOW PORTIONS ARE STRIPPED OFF. THE RESULT  */
*         /* IS SAVED IN A 4 BYTE AREA--SDWAERTM--WHICH WILL BE      */
*         /* CONVERTED TO THE TIME WHEN THE ERRORID IS PRINTED. IF   */
*         /* TCBRTM2=1, THEN IF AN ERRORID EXISTS IN RTM2WA, IT IS   */
*         /* PROPOGATED TO THE SDWA. OTHERWISE, THIS IS A NEW ERROR. */
*         /* IF SDWAERFL IS OFF, THEN THE LOGICAL CPUID AND SEQUENCE */
*         /* NUMBER ARE PUT IN SDWACPUI AND SDWASEQ#, RESPECTIVELY.  */
*         /* THE RTCTSEQ#, SEQUENCE NUMBER IS INCREMENTED. IF        */
*         /* SDWAERFL IS ON, THE CPUID AND SEQUENCE NUMBER HAVE BEEN */
*         /* PROPAGATED FROM A PREVIOUS ERROR AND ARE ALREADY IN THE */
*         /* SDWA. NOTE:IF THE CURRENT TIME CANNOT BE OBTAINED,      */
*         /* SDWAERTM WILL CONTAIN ZEROS.                            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0296
*         IF((SDWAMCHK^=ON)|        /* IF NO HARDWARE ERROR  @G17EP5W*/
*             (SDWAERFL=OFF)) THEN  /* OR NO ERRORID IN SDWA @G17EP5W*/
         L     @12,RT1WRTCA(,R8)                                   0296
         TM    SDWAMCHK(@12),B'10000000'                           0296
         BNO   @RT00296                                            0296
         TM    SDWAERFL(@12),B'00000001'                           0296
         BNZ   @RF00296                                            0296
@RT00296 DS    0H                                                  0297
*           DO;                     /* BEGIN ERRORID SEGMENT @G17EP5W*/
*             STM(R0,R2,SDWARCPL);  /* SAVE CUR. REG VALUE   @G17EP5W*/
         L     @12,RT1WRTCA(,R8)                                   0298
         STM   R0,R2,SDWARCPL(@12)                                 0298
*             RFY                                                  0299
*              (R0,                                                0299
*               R1,                                                0299
*               R2) RSTD;           /* RESTRICT REG USAGE    @G17EP5W*/
*             R2=ADDR(SDWARCPL)+LENGTH(REGSTOR);/* SPECIFY AN ADDRESS
*                                      TO TO PUT THE TOD CLOCK VALUE
*                                      IN FOR CONVERSION     @G17EP5W*/
         LA    R2,SDWARCPL(,@12)                                   0300
         AL    R2,@CF00194                                         0300
*             GEN;                                                 0301
*                                   /* GET TOD VALUE AND    @G17EP5W*/
        CONTIME TIMER=(2)           /* REDUCE IT TO 4 BYTES @G17EP5W*/
*             SDWAERTM=R1;          /* SAVE TIMESTAMP        @G17EP5W*/
         L     @12,RT1WRTCA(,R8)                                   0302
         ST    R1,SDWAERTM(,@12)                                   0302
*             RFY                                                  0303
*              (R0,                                                0303
*               R1,                                                0303
*               R2) UNRSTD;         /* FREE REGS             @G17EP5W*/
*             IF SDWAERFL=OFF THEN  /* IF ERRORID IS NOT IN SDWA-- 0304
*                                      THIS IS A NEW SDWA    @G17EP5W*/
         TM    SDWAERFL(@12),B'00000001'                           0304
         BNZ   @RF00304                                            0304
*               DO;                 /* THEN GET AN ERRORID   @G17EP5W*/
*                 IF PSATOLD^=NULL&RT1TENPT^=RT1WDAT&LCCAASID=NULL THEN
         L     @11,PSATOLD                                         0306
         SLR   @04,@04                                             0306
         CR    @11,@04                                             0306
         BE    @RF00306                                            0306
         CLI   RT1TENPT+16(R8),4                                   0306
         BE    @RF00306                                            0306
         L     @01,PSALCCAV                                        0306
         CL    @04,LCCAASID(,@01)                                  0306
         BNE   @RF00306                                            0306
*                                   /* IF A VALID TCB ADDR IS AVAIL
*                                      AND NOT TRAS OR DATERR CHK FOR
*                                      RTM2 PROCESSING       @ZA16864*/
*                   DO;             /*                       @G17EP5W*/
*                     RFY                                          0308
*                       TCB BASED(PSATOLD);/* ADDRESSABILITY TO TCB
*                                                            @G17EP5W*/
*                     IF((TCBRTM2=ON)&/* RTM2 WAS PROCESSING @G17EP5W*/
*                         (TCBRTWA^=NULL)) THEN/* AND A WORKAREA   0309
*                                      PRESENT               @G17EP5W*/
         TM    TCBRTM2(@11),B'00001000'                            0309
         BNO   @RF00309                                            0309
         L     @11,TCBRTWA(,@11)                                   0309
         CR    @11,@04                                             0309
         BE    @RF00309                                            0309
*                       IF TCBRTWA->RTM2ERFL=ON THEN/* THEN CHECK IF
*                                                            @G17EP5W*/
         TM    RTM2ERFL(@11),B'00000001'                           0310
         BNO   @RF00310                                            0310
*                         DO;       /* RTM2 GENERATED ERRORID      0311
*                                                            @G17EP5W*/
*                           RFY                                    0312
*                             R2 RSTD;/* USE REG FOR ADDRESS @G17EP5W*/
*                           RFY                                    0313
*                             RTM2WA BASED(R2);/* RTM2WA ADDR      0313
*                                                            @G17EP5W*/
*                           R2=TCBRTWA;/* GET RTM2WA ADDRESS SO THAT
*                                      THE ERRORID CAN BE MOVED OVER */
         LR    R2,@11                                              0314
*                           SDWACPUI=RTM2CPUI(2:2);/* MOVE LOG.CPU ID
*                                                            @G17EP5W*/
         IC    @11,RTM2CPUI+1(,R2)                                 0315
         STC   @11,SDWACPUI(,@12)                                  0315
*                           SDWASEQ#=RTM2SEQ#;/* MOVE SEQUENCE NUMBER
*                                                            @G17EP5W*/
         MVC   SDWASEQ#(2,@12),RTM2SEQ#(R2)                        0316
*                           SDWAERFL=ON;/* INDICATE ERRORID  @G17EP5W*/
         OI    SDWAERFL(@12),B'00000001'                           0317
*                           RFY                                    0318
*                             R2 UNRSTD;/* FREE REGISTER     @G17EP5W*/
*                         END;      /* END MOVE RTM2 ERRORID @G17EP5W*/
*                     RFY                                          0320
*                       TCB BASED;  /* TCB BASED VARIABLE    @G17EP5W*/
@RF00310 DS    0H                                                  0320
@RF00309 DS    0H                                                  0321
*                   END;            /* END CHECKING TCB      @G17EP5W*/
*               END;                /* END NO ERRORID        @G17EP5W*/
@RF00306 DS    0H                                                  0323
*             IF SDWAERFL=OFF THEN  /* IF NO ERRORID IN SDWA @G17EP5W*/
@RF00304 L     @12,RT1WRTCA(,R8)                                   0323
         TM    SDWAERFL(@12),B'00000001'                           0323
         BNZ   @RF00323                                            0323
*               DO;                 /* THEN THIS IS A NEW ERROR SO 0324
*                                      GENERATE A NEW ERRORID      0324
*                                                            @G17EP5W*/
*                 SDWACPUI=PSACPULA;/* GET LOGICAL CPU ID    @G17EP5W*/
         LH    @11,PSACPULA                                        0325
         STC   @11,SDWACPUI(,@12)                                  0325
*                 RFY                                              0326
*                  (R0,                                            0326
*                   R1,                                            0326
*                   R2,                                            0326
*                   R4) RSTD;       /* REGS FOR NEW SEQ#     @G17EP5W*/
*                 R4=ADDR(SDWASEQ#);/* SEQ# ADDR IN SDWA     @G17EP5W*/
         LA    R4,SDWASEQ#(,@12)                                   0327
*                 GEN;                                             0328
*                                   /*GET SEQUENCE NUMBER   @G17EP5W*/
          GETSEQ  (4)               /*AND PUT IN SDWA       @G17EP5W*/
*                 RFY                                              0329
*                  (R0,                                            0329
*                   R1,                                            0329
*                   R2,                                            0329
*                   R4) UNRSTD;     /* FREE REGISTERS        @G17EP5W*/
*                 SDWAERFL=ON;      /* INDICATE ERRORID      @G17EP5W*/
         L     @12,RT1WRTCA(,R8)                                   0330
         OI    SDWAERFL(@12),B'00000001'                           0330
*               END;                /* END GENERATE ERRORID  @G17EP5W*/
*             LM(R0,R2,SDWARCPL);   /* RESTORE REGS          @G17EP5W*/
@RF00323 L     @12,RT1WRTCA(,R8)                                   0332
         LM    R0,R2,SDWARCPL(@12)                                 0332
*             RFY                                                  0333
*              (R0,                                                0333
*               R1,                                                0333
*               R2) RSTD;           /* AND INDICATE RESTRICT @G17EP5W*/
*             SDWARCPL=SDWARCPL&&SDWARCPL;/* CLEAR SDWA AREA USED  0334
*                                                            @G17EP5W*/
         L     @12,RT1WRTCA(,R8)                                   0334
         XC    SDWARCPL(28,@12),SDWARCPL(@12)                      0334
*           END;                    /* END ERRORID SEGMENT   @G17EP5W*/
*         IF R5^=NULL THEN          /* IF DUMP OPTIONS WERE SUPPLIED
*                                      PERFORM DUMPOPTS PROCESSING   */
@RF00296 LTR   R5,R5                                               0336
         BZ    @RF00336                                            0336
*/* ******************************************************************/
*/* THIS SEGMENT INITIALIZES THE RTCA WITH DUMP OPTIONS              */
*/* SPECIFIED BY THE CALLER OF RTM.  THE SNAP PARAMETER LIST         */
*/* AND A MAXIMUM OF FOUR STORAGE RANGES ARE MOVED INTO THE          */
*/* RTCA.                                                            */
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  - DUMPOPTS REGISTER(R5) POINTS TO THE SNAP PARM LIST            */
*/*  - THE SNAP PARM LIST INDICATES IF STORAGE RANGES ARE SUPPLIED   */
*/* OUTPUT OF THIS SEGMENT IS THE DUMP OPTIONS PROPERLY INITIALIZED  */
*/*  IN THE RTCA                                                     */
*/* NOTES-----                                                       */
*/*  - REGS(R0,R2,R3,R4,R5,R6,R7,R8,R9,R10) ARE RESTRICTED           */
*/*  - REGS(R1,R11,R12,R13,R14,R15) ARE VOLATILE                     */
*/* ******************************************************************/
*                                                                  0337
*           DO;                                                    0337
*             RFY                                                  0338
*              (R3,                                                0338
*               R4) RSTD;                                          0338
*             SDWASNPA=SNPCDMP;     /* MOVE INTO THE RTCA THE COMMON
*                                      SECTION OF SNAP PARMS         */
         L     @12,RT1WRTCA(,R8)                                   0339
         MVC   SDWASNPA(8,@12),SNPCDMP(R5)                         0339
*             IF SNPSLIST=ON THEN   /* IF STORAGE RANGES ARE PROVIDED
*                                      IN THE SNAP PARMS PROCESS THE
*                                      STORAGE RANGES                */
         TM    SNPSLIST(R5),B'00000010'                            0340
         BNO   @RF00340                                            0340
*               DO;                 /* PROCESS TO MOVE STORAGE RANGE
*                                      ADDRESSES INTO RTCA           */
*                 IF STOREND(ONE)=ON THEN/* IF ONLY ONE SET OF     0342
*                                      STORAGE RANGES IS PROVIDED  0342
*                                      THEN                          */
         L     @12,SNPSTOR(,R5)                                    0342
         TM    STOREND(@12),B'10000000'                            0342
         BNO   @RF00342                                            0342
*                   R3=LENGTH(LISTPAIR);/* SET THE NUMBER OF BYTES TO
*                                      MOVE IN ONE PAIR              */
         LA    R3,8                                                0343
*                 ELSE              /* OTHERWISE MORE THAN ONE SET OF
*                                      STORAGE RANGES IS SUPPLIED    */
*                   DO;             /* DETERMINE THE NUMBER OF     0344
*                                      STORAGE RANGES SUPPLIED       */
         B     @RC00342                                            0344
@RF00342 DS    0H                                                  0345
*                     R4=NULL;      /* INITIALIZE SWITCH FOR LOOP  0345
*                                      EXIT                          */
         SLR   R4,R4                                               0345
*                     DO R3=1 TO DIM(LISTPAIR)/* CALCULATE AMOUNT    */
*                           WHILE(R4=NULL);/* TO MOVE BY INITIALIZING
*                                      LENGTH TO THE FIRST PAIR AND
*                                      CONTINUING TO SEARCH UNTIL THE
*                                      MAX NUMBER OF RANGES ALLOWED
*                                      IN THE RTCA IS REACHED OR   0346
*                                      UNTIL AN END OF THE LIST IS 0346
*                                      DETECTED                      */
         LA    R3,1                                                0346
@DL00346 LTR   R4,R4                                               0346
         BNZ   @DC00346                                            0346
*                       IF STOREND(R3)=ON THEN/* IF THE END OF THE 0347
*                                      LIST HAS BEEN REACHED         */
         LR    @12,R3                                              0347
         SLA   @12,3                                               0347
         L     @11,SNPSTOR(,R5)                                    0347
         ALR   @11,@12                                             0347
         AL    @11,@CF03536                                        0347
         TM    STOREND-4(@11),B'10000000'                          0347
         BNO   @RF00347                                            0347
*                         R4=HEX7FOXS;/* CAUSE LOOP EXIT             */
         L     R4,@CF03202                                         0348
*                       ELSE                                       0349
*                         ;                                        0349
@RF00347 DS    0H                                                  0350
*                     END;                                         0350
         AL    R3,@CF00079                                         0350
         C     R3,@CF00115                                         0350
         BNH   @DL00346                                            0350
@DC00346 DS    0H                                                  0351
*                     R3=R3*LENGTH(LISTPAIR);/* CONVERT THE NUMBER OF
*                                      PAIRS TO BYTES                */
         SLL   R3,3                                                0351
*                   END;            /* END OF LENGTH CALCULATION     */
*                 SDWADPSL(1:R3)=STORLIST(1:R3);/* MOVE THE STORAGE
*                                      RANGE LIST INTO THE RTCA      */
@RC00342 L     @12,RT1WRTCA(,R8)                                   0353
         LR    @11,R3                                              0353
         BCTR  @11,0                                               0353
         L     @15,SNPSTOR(,R5)                                    0353
         EX    @11,@SM03537                                        0353
*               END;                /* END STORAGE RANGE PROCESSING  */
*             ELSE                                                 0355
*               ;                   /* IF NO STORAGE RANGES SUPPLIED
*                                      THEN NO STORAGE RANGES ARE  0355
*                                      INITIALIZED IN THE RTCA       */
@RF00340 DS    0H                                                  0356
*           END;                    /* END DUMPOPTS PROCESSING       */
*         ELSE                                                     0357
*           ;                       /* IF DUMP OPTIONS ARE NOT     0357
*                                      SPECIFIED THEN NO           0357
*                                      INITIALIZATION OF THE RTCA  0357
*                                      WITH DUMPOPTS TAKES PLACE     */
@RF00336 DS    0H                                                  0358
*       END;                                                       0358
*     ELSE                          /* IF RECURSION IS INDICATED   0359
*                                      PERFORM PRELIMINARY SRM       */
*       DO;                         /* RECURSION PROCESSING          */
         B     @RC00106                                            0359
@RF00106 DS    0H                                                  0360
*         R7=ACTIVE;                /* INDICATE THAT SRM IS BEING  0360
*                                      ENTERED TO PROCESS A ERROR  0360
*                                      OCCURRING IN A FRR(I.E.     0360
*                                      RECURSION)                    */
*                                                                  0360
         LA    R7,1                                                0360
*         /***********************************************************/
*         /*                                                         */
*         /* THIS SEGMENT CHECKPOINTS RECURSIVE ERROR DATA WHEN SRM  */
*         /* IS REENTERED BECAUSE OF A FRR FAILURE INDICATED BY THE  */
*         /* PRESENCE OF A RTCA ADDRESS IN THE RTM1 WORK AREA PORTION*/
*         /* OF THE INTERRUPTED STACK INPUT - FLAGSCC REGISTER(R1)   */
*         /* CONTAINS THE CALLRTM FLAGS AND COMPLETION CODE          */
*         /* ASSOCIATED WITH THE RECURSIVE ERROR - RECVSTAK          */
*         /* REGISTER(R4) CONTAINS THE ADDRESS OF THE FRR STACK SRM  */
*         /* CAN USE TO DEFINE ITS OWN RECOVERY WHILE PROCESSING THE */
*         /* RECURSIVE ERROR - DUMPOPTS REGISTER(R5) CONTAINS THE    */
*         /* ADDRESS OF DUMP PARAMETERS ASSOCIATED WITH THE RECURSIVE*/
*         /* ERROR ONLY IF THE RECURSIVE IS NOT A MACHINE CHECK      */
*         /* OTHERWISE REGISTER R5 CONTAINS MACHINE CHECK INFORMATION*/
*         /* - EEDCHAIN REGISTER(R6) CONTAINS A POINTER TO MACHINE   */
*         /* CHECK INFORMATION IF THE RECURSIVE ERROR IS A MACHINE   */
*         /* CHECK OR CONTAINS ZERO IF NOT A MACHINE CHECK OR IF ONLY*/
*         /* ABBREVIATED MACHINE CHECK INFORMATION IS AVAILABLE -    */
*         /* SAVAREAP REGISTER(R13) CONTAINS THE ADDRESS OF THE REGS */
*         /* STORED AT THE TIME OF THE RECURSIVE ERROR - THE RT1WRTCA*/
*         /* FIELD OF THE RTM1 WORK AREA PORTION OF THE INTERRUPTED  */
*         /* STACK POINTS TO THE RTCA PASSED TO THE FRR WHICH FAILED */
*         /* OUTPUT - THE ABOVE INPUT REGISTER CONTENTS ARE          */
*         /* CHECKPOINTED INTO THE SRM REGISTER SAVE AREA OF THE RTCA*/
*         /* ASSOCIATED WITH THE FRR THAT FAILED NOTES -             */
*         /* REGS(R0,R2,R7,R8) MUST REMAIN UNCHANGED THROUGHOUT THIS */
*         /* SEGMENT                                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0361
*         CKFLGSCC=R1;              /* CHKPT CALLRTM FLAGS AND COMP
*                                      CODE                          */
         LA    @12,512                                             0361
         AL    @12,RT1WRTCA(,R8)                                   0361
         ST    R1,CKFLGSCC(,@12)                                   0361
*         RFY                                                      0362
*           R4 RSTD;                                               0362
*         CKSRMSTK=R4;              /* SAVE STACK ADDR WHICH SRM WILL
*                                      USE TO DEFINE RECOVERY        */
         ST    R4,CKSRMSTK(,@12)                                   0363
*         CKDMPOPT=R5;              /* CHKPT DUMPOTPTS OR MCH DATA   */
         ST    R5,CKDMPOPT(,@12)                                   0364
*         CKEEDCHN=R6;              /* CHKPT INDICATOR OF DUMPOPTS OR
*                                      MCH DATA                      */
         ST    R6,CKEEDCHN(,@12)                                   0365
*         CKSVREAP=R13;             /* CHKPT ADDR OF REGS AT TIME OF
*                                      ERROR                         */
         ST    R13,CKSVREAP(,@12)                                  0366
*         R6=SRMFRRS;               /* RESTORE THE INTERNAL INDICATOR
*                                      THAT INDICATES THE EXISTENCE
*                                      OF FRRS ON THE INTERRUPTED  0367
*                                      STACK PRIOR TO THE FRR ERROR  */
         L     R6,SRMFRRS(,@12)                                    0367
*       END;                                                       0368
*     RFY                                                          0369
*      (R1,                         /* AFTER THE RTCA HAS BEEN       */
*       R3,                         /* SUCCESSFULLY INITIALIZED      */
*       R4,                         /* WITH THE ERROR INFORMATION    */
*       R11,                        /* THESE REGISTERS CAN BE        */
*       R12,                        /* RELEASED                      */
*       R13,                                                       0369
*       R14,                                                       0369
*       R15) UNRSTD;                                               0369
*                                                                  0369
@RC00106 DS    0H                                                  0370
*     /***************************************************************/
*     /*                                                             */
*     /* FOR ALL ENTRIES TO SRM(NORMAL OR RECURSIVE) FRR RECOVERY    */
*     /* PROCESSING WILL BE ATTEMPTED IF ANY FRRS ARE AVAILABLE FOR  */
*     /* USE ON THE INTERRUPTED FRR STACK ASSOCIATED WITH THE ERROR  */
*     /* CONDITION CAUSING ENTRY TO SRM. ON NORMAL ENTRIES FRRS WILL */
*     /* GET CONTROL UNTIL EITHER RETRY/RESUME IS REQUESTED OR UNTIL */
*     /* THE INTERRUPTED FRR STACK IS EMPTY. ON RECURSIVE ENTRIES    */
*     /* ROUTING TO FRRS IS BYPASSED UNTIL THE ORIGINAL              */
*     /* RTCA(REPRESENTING THE ERROR PRIOR TO RECURSION) HAS BEEN    */
*     /* RECORDED. AFTER THE RECORDING TAKES PLACE THE RECURSIVE     */
*     /* ERROR CAN BE TREATED AS NORMAL. THE FOLLOWING LOOP          */
*     /* ESTABLISHES THE INTERNAL CONTROL IN SRM NEEDED TO PROCESS A */
*     /* FRR STACK FOR BOTH RECURSIVE AND NON-RECURSIVE ENTRIES      */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0370
*     RFY                                                          0370
*       SDWA BASED(R5);             /* BASE THE RTCA ON TARGRTCA     */
*     R5=RT1WRTCA;                  /* INITIALIZE TARGRTCA REGISTER
*                                      (R5) WITH ADDRESS OF ACTIVE 0371
*                                      RTCA                          */
         L     @12,RT1WRTCA(,R8)                                   0371
         LR    R5,@12                                              0371
*     SRMFMSK=''B;                  /* ZERO FRR SYSTEM MASK  @YM02601*/
         AL    @12,@CF01015                                        0372
         MVI   SRMFMSK(@12),X'00'                                  0372
*     SRMRMSK=''B;                  /* ZERO FRR RETRY MASK   @YM02601*/
         MVI   SRMRMSK(@12),X'00'                                  0373
*                                                                  0374
*/* ******************************************************************/
*/* THIS SEGMENT PERFORMS THE FUNCTION OF ROUTING TO SLIP PROCESSING */
*/* WHEN THERE ARE ENABLED SLIP TRAPS TO BE CONSIDERED.              */
*/* SLIP PROCESSING WILL BE INVOKED FOR ALL INITIAL ERRORS CAUSING   */
*/* ENTRY INTO IEAVTRTS AND FOR ALL FRR ERRORS WHICH CAUSE ENTRY     */
*/* INTO IEAVTRTS.                                                   */
*/* INPUT OT THIS SEGMENT IS AS FOLLOWS:                             */
*/*   FUNCTION REGISTER(R0) USED INTERNALLY WITHIN SRM TO MONITOR ITS*/
*/*   PROCESSING                                                     */
*/*   CURRSTK REG(R8) WHICH POINTS TO THE INTERRUPTED FRR STACK      */
*/*   FOR WHICH FRR PROCESSING WILL TAKE PLACE                       */
*/*   SRMSTAK REG(R2) WHICH POINTS TO THE FRR STACK USED BY SRM      */
*/*   TO DEFINE ITS OWN FRRS                                         */
*/*   TARGRTCA REG(R5) WHICH POINTS TO THE RTCA TO BE USED TO        */
*/*   AS THE INTERFACE TO THE FRRS(IF ANY) ON THE INTERRUPTED        */
*/*   FRR STACK                                                      */
*/*   RECURSE REGISTER(R7) WHICH INDICATES WHETHER SRM IS PROCESSING */
*/*   AN INITIAL ERROR OR A FRR FAILURE                              */
*/*   CVTRTMSD FIELD OF THE CVT WHICH CONTAINS THE ADDRESS OF THE    */
*/*   SLIP HEADER (IHASHDR).                                         */
*/*                                                                  */
*/* OUTPUT FROM THIS SEGMENT IS AS FOLLOWS                           */
*/*   IEAVTRTS CALLS SLIP PROCESSING IF IT IS INDICATED.  THE        */
*/*   SLIP PROCESS WILL SAVE AND RESTORE IEAVTRTS REGISTERS          */
*/*   ALL RESTRICTED REGISTER CONTENTS ON ENTRY TO THIS SEGMENT      */
*/*   WILL BE UNCHANGED ON EXIT FROM THIS SEGMENT                    */
*/*                                                                  */
*/* NOTES                                                            */
*/*   REGS(R0,R2,R5,R7,R8,R9,R10) ARE RESTRICTED                     */
*/*   OTHER REGISTERS ARE AVAILABLE FOR USE AND ARE VOLATILE         */
*/*                                                                  */
*/*                                                          @G17SP2I*/
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0374
*     RT1TLPN=SRMSLIP;              /* SET THE LOGICAL PHASE NUMBER
*                                      TO SLIP IN THE CURRENT FRRS 0374
*                                                            @G17SP2I*/
         MVI   RT1TLPN+16(R8),X'40'                                0374
*     IF R7^=ACTIVE                 /* IF AN FRR FAILURE CAUSING   0375
*                                      RECURSIVE ENTRY INTO RTS IS 0375
*                                      NOT CURRENTLY BEING PROCESSED
*                                      AS A NON-RECURSIVE ERROR    0375
*                                                            @YM06065
*                                                            @G17SP2I*/
*         &CVTRTMS^=0               /* AND THE SLIP HEADER PTR     0375
*                                      INDICATES THERE IS AN IHASHDR
*                                                            @G17SP2I*/
*       THEN                                                       0375
         C     R7,@CF00079                                         0375
         BE    @RF00375                                            0375
         L     @12,CVTPTR                                          0375
         L     @12,CVTRTMS(,@12)                                   0375
         LTR   @12,@12                                             0375
         BZ    @RF00375                                            0375
*       DO;                         /* ATTEMPT LINKAGE TO SLIP     0376
*                                                            @G17SP2I*/
*         RFY                                                      0377
*          (R14,                                                   0377
*           R15) RSTD;              /*                       @G17SP2I*/
*         R14=SHDRPFC;              /* GET CURRENT VALUE FOR COMPARE
*                                      IN THE CS INSTRUCTION @G17SP2I*/
         L     R14,SHDRPFC(,@12)                                   0378
*SLIPINCR:                          /* TOP OF CS LOOP FOR UPDATING 0379
*                                      THE IEAVTSLP USE COUNT THIS 0379
*                                      USE COUNT IS 0 IF IEAVTSLP IS
*                                      NOT AVAILABLE         @G17SP2I*/
*         IF R14>0                  /* AND THE IEAVTSLP USE COUNT  0379
*                                      FROM THE IHASHDR INDICATES  0379
*                                      THAT IEAVTSLP IS AVAILABLE  0379
*                                                            @G17SP2I*/
*           THEN                                                   0379
SLIPINCR LTR   R14,R14                                             0379
         BNP   @RF00379                                            0379
*           DO;                     /* THEN SLIP SHOULD BE CALLED  0380
*                                                            @G17SP2I*/
*             R15=R14+1;            /* INCREMENT THE USE COUNT TO BE
*                                      SURE THAT IEAVTSLP WILL REMAIN
*                                      AVAILABLE FOR USE     @G17SP2I*/
         LA    R15,1                                               0381
         ALR   R15,R14                                             0381
*             CS(R14,R15,SHDRPFC);  /* USE CS TO PUT INCREMENTED   0382
*                                      VALUE IN SHDR SINCE USE OF THE
*                                      FIELD IS NO SERIALIZED      0382
*                                                            @G17SP2I*/
         L     @12,CVTPTR                                          0382
         L     @01,CVTRTMS(,@12)                                   0382
         CS    R14,@15,SHDRPFC(@01)                                0382
*             BC(4,SLIPINCR);       /* IF SHDRPFC HAS CHANGED BEFORE
*                                      THIS CS THEN TRY AGAIN      0383
*                                                            @G17SP2I*/
         BC    4,SLIPINCR                                          0383
*             RFY                                                  0384
*              (R14,                                               0384
*               R15) UNRSTD;        /* G17SP2I                       */
*             RFY                                                  0385
*               FRRWA BASED(R5+LENGTH(SDWA)+LENGTH(SRMRGSV));/*    0385
*                                      REFERENCE THE FRRWA THAT GOES
*                                      WITH THE INTERRUPTED FRRS   0385
*                                                            @G17SP2I*/
*             RFY                                                  0386
*              (R1,                                                0386
*               R13) RSTD;          /*                       @G17SP2I*/
*             R13=ADDR(FRRWA);      /* USE THE SPACE IN THE FRRWA TO
*                                      SUPPLY A SAVEAREA     @G17SP2I*/
         LA    R13,584                                             0387
         ALR   R13,R5                                              0387
*             R1=R13+72;            /* AND THE PARAMETER           0388
*                                      LIST/WORKAREA FOR IEAVTSLP  0388
*                                                            @G17SP2I*/
         LA    @12,72                                              0388
         LR    R1,R13                                              0388
         ALR   R1,@12                                              0388
*             SLPWAPTR=R1+72;       /* PROVIDE SLIP WITH A WORKAREA
*                                                            @G17SP2I*/
         ALR   @12,R1                                              0389
         ST    @12,SLPWAPTR(,R1)                                   0389
*             RFY                                                  0390
*               FRRWA BASED(RT1WRTCA+LENGTH(SDWA)+LENGTH(SRMRGSV));/*
*                                                            @G17SP2I*/
*             SLPCFRRS=R8;          /* PASS THE ADDRESS OF THE     0391
*                                      CURRENT FRR STACK TO IEAVTSLP
*                                                            @G17SP2I*/
         ST    R8,SLPCFRRS(,R1)                                    0391
*             SLPRTSTK=R2;          /* ALSO PASS THE ADDRESS OF THE
*                                      FRR STACK USED BY RTS TO    0392
*                                      DEFINE ITS OWN FRRS   @G17SP2I*/
         ST    R2,SLPRTSTK(,R1)                                    0392
*             SLPRT2WA=0;           /* INDICATE ENTRY IS NOT FROM RT2
*                                                            @G17SP2I*/
         SLR   @12,@12                                             0393
         ST    @12,SLPRT2WA(,R1)                                   0393
*             CALL IEAVTSLP;        /* CALL SLIP             @G17SP2I*/
         L     @12,CVTPTR                                          0394
         L     @12,CVTRTMS(,@12)                                   0394
         L     @15,SHDRPROC(,@12)                                  0394
         BALR  @14,@15                                             0394
*             RFY                                                  0395
*              (R1,                                                0395
*               R13) UNRSTD;        /*                       @G17SP2I*/
*             RFY                                                  0396
*              (R14,                                               0396
*               R15) RSTD;          /*                       @G17SP2I*/
*             R14=SHDRPFC;          /* GET CURRENT VALUE FOR COMPARE
*                                      IN THE CS INSTRUCTION @G17SP2I*/
         L     @12,CVTPTR                                          0397
         L     @01,CVTRTMS(,@12)                                   0397
         L     R14,SHDRPFC(,@01)                                   0397
*SLIPDECR:                          /* TOP OF CS LOOP FOR UPDATING 0398
*                                      THE IEAVTSLP USE COUNT      0398
*                                                            @G17SP2I*/
*             IF R14>1              /* IF THE IEAVTSLP USE COUNT FROM
*                                      THE IHASHDR ISN'T THE MINIMUM
*                                                            @G17SP2I*/
*               THEN                                               0398
SLIPDECR C     R14,@CF00079                                        0398
         BNH   @RF00398                                            0398
*               DO;                 /* THEN DECREMENT IT     @G17SP2I*/
*                 R15=R14-1;        /* PREPARE THE REPLACEMENT VALUE
*                                                            @G17SP2I*/
         LR    R15,R14                                             0400
         BCTR  R15,0                                               0400
*                 CS(R14,R15,SHDRPFC);/* USE CS TO PUT IT IN SHDR  0401
*                                      SINCE USE OF THE FIELD IS NOT
*                                      SERIALIZED            @G17SP2I*/
         L     @12,CVTPTR                                          0401
         L     @01,CVTRTMS(,@12)                                   0401
         CS    R14,@15,SHDRPFC(@01)                                0401
*                 BC(4,SLIPDECR);   /* IF SHDRPFC HAS CHANGED BEFORE
*                                      THIS CS THEN TRY AGAIN      0402
*                                                            @G17SP2I*/
         BC    4,SLIPDECR                                          0402
*               END;                /*                       @G17SP2I*/
*             RFY                                                  0404
*              (R14,                                               0404
*               R15) UNRSTD;        /* G17SP2I                       */
@RF00398 DS    0H                                                  0405
*           END;                    /*                       @G17SP2I*/
*       END;                        /*                       @G17SP2I*/
@RF00379 DS    0H                                                  0407
*     DO WHILE R5^=NULL;            /* BEGIN TO PROCESS THE        0407
*                                      INTERRUPTED FRR STACK WHILE AN
*                                      RTCA IS AVAILABLE             */
*                                                                  0407
@RF00375 B     @DE00407                                            0407
@DL00407 DS    0H                                                  0408
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SEGMENT PERFORMS THE ROUTING TO FRRS DEFINED ON THE  */
*       /* INTERRUPTED FRR STACK ASSOCIATED WITH THE ERROR, AND      */
*       /* INTERFACES WITH GTF TO TRACE THE ACTION OF THE FRR GIVEN  */
*       /* CONTROL INPUT - CURRSTK REGISTER(R8) POINTS TO THE        */
*       /* INTERRUPTED FRR STACK CONTAINING THE FRR TO BE GIVEN      */
*       /* CONTROL - PSANSTK FIELD IN THE PSA POINTS TO THE NORMAL   */
*       /* FRR STACK - PSAPSTK FIELD IN THE PSA POINTS TO THE PCFLIHS*/
*       /* STACK - RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF   */
*       /* THE INTERRUPTED STACK POINTS TO THE ACTIVE RTCA THAT WILL */
*       /* EVENTUALLY BE PASSED TO THE FRR - SRMSTAK REGISTER(R2)    */
*       /* POINTS TO THE RECOVERY STACK SRM CAN USE TO DEFINE ITS OWN*/
*       /* FRRS - THE LOCKS HELD TABLE IN THE PSA IS USED TO         */
*       /* CHECKPOINT THE LOCKS HELD STATUS PRIOR TO ROUTING CONTROL */
*       /* TO THE FRR - PCFLIHS DAT AND SEGMENT RECURSION FLAGS IN   */
*       /* THE LCCA OUTPUT - LOCKS HELD PRIOR TO ROUTING TO THE FRR  */
*       /* ARE CHECKPOINTED IN THE RTM1 WORK AREA PORTION OF THE     */
*       /* INTERRUPTED STACK - PCFLIHS DAT AND SEGMENT RECURSION     */
*       /* FLAGS ARE ZEROED IF THE INTERRUPTED STACK IS THE PCFLIH   */
*       /* STACK -SRM REGISTER CONTENTS AT THE TIME THE FRR WAS GIVEN*/
*       /* CONTROL ARE CHECKPOINTED IN THE SRM REGISTER SAVE AREA    */
*       /* APPENDED TO THE ACTIVE RTCA(THAT WAS PASSED TO THE FRR)   */
*       /* NOTES - REGISTERS R0,R2,R5,R6,R7,R8 CONTENTS ON INPUT TO  */
*       /* THIS SEGMENT MUST REMAIN UNCHANGED ON OUTPUT FROM THIS    */
*       /* SEGMENT - REGISTERS R1,R3, R13,R14,R15 ARE VOLATILE       */
*       /* THRUOUT THIS SEGMENT - REGISTER R4 IS USED AS WORKREG TO  */
*       /* INDICATE THAT THE FRR HAS SUCCESSFULLY RETURNED TO SRM -  */
*       /* REGISTERS R11,R12 ARE USED BY SRM TO DEFINE ITS OWN FRR   */
*       /* VIA THE SETFRR MACRO                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0408
*       DO;                                                        0408
*         RFY                                                      0409
*           R4 RSTD;                                               0409
*         R4=MODEBYTE&VALMODES;                                    0410
         LA    R4,186                                              0410
         SLR   @12,@12                                             0410
         IC    @12,MODEBYTE+81(,R8)                                0410
         NR    R4,@12                                              0410
*         RFY                                                      0411
*           R3 RSTD;                                               0411
*         R3=ADDR(RT1WLPTA);                                       0412
         LA    R3,RT1WLPTA(,R8)                                    0412
*         RFY                                                      0413
*           RT1TRACK BASED(R3);                                    0413
*         RT1TLPN=SRMROUTE;         /* LOGICAL PHSDE IS ROUTE        */
         MVI   RT1TLPN(R3),X'41'                                   0414
*         IF R7^=ACTIVE THEN        /* IF RECURSION IS NOT ACTIVE    */
         C     R7,@CF00079                                         0415
         BE    @RF00415                                            0415
*           IF R8=PSANSTK           /* AND THE NORMAL FRR STACK      */
*               &(FRRSCURR=FRRSEMP  /* IS EITHER EMPTY OR            */
*               |(SDWATEXC=ON       /* DOES NOT HAVE FRRS ON IT      */
*               &PSASUPER=NULL)|(R4=NULL&MODEDIS=ON))/* ASSOCIATED 0416
*                                      WITH A SUPER BIT              */
*             THEN                  /* FOR A DATERR THEN DO AS     0416
*                                      FOLLOWS                       */
         C     R8,PSANSTK                                          0416
         BNE   @RF00416                                            0416
         CLC   FRRSCURR(4,R8),FRRSEMP(R8)                          0416
         BE    @RT00416                                            0416
         TM    SDWATEXC(R5),B'00000010'                            0416
         BNO   @GL00013                                            0416
         L     @12,PSASUPER                                        0416
         LTR   @12,@12                                             0416
         BZ    @RT00416                                            0416
@GL00013 LTR   R4,R4                                               0416
         BNZ   @RF00416                                            0416
         TM    MODEDIS+81(R8),B'01000000'                          0416
         BNO   @RF00416                                            0416
@RT00416 DS    0H                                                  0417
*             DO;                   /* PROCESS AS IF EMPTY STACK     */
*               SRMRMSK=''B;        /* INITIALIZE RETRY MASK IN    0418
*                                      REGSAVE               @YM02601*/
         L     @01,RT1WRTCA(,R8)                                   0418
         MVI   SRMRMSK+512(@01),X'00'                              0418
*               R6=NONE;            /* INDICATE NO FRRS              */
         SLR   R6,R6                                               0419
*               IF SDWARKEY=ON THEN /* IF THE ERROR BEING PROCESSED
*                                      IS A RESTART ERROR &YM08120   */
         TM    SDWARKEY(R5),B'00100000'                            0420
         BNO   @RF00420                                            0420
*                 CVTRSTWD=NULL;    /* ZERO RESTART WORD     @YM08120*/
         L     @12,CVTPTR                                          0421
         SLR   @11,@11                                             0421
         ST    @11,CVTRSTWD(,@12)                                  0421
*               FRRSCURR=FRRSEMP;   /* INSURE THAT THE NORMAL FRR  0422
*                                      STACK IS EMPTY                */
@RF00420 L     @12,FRRSEMP(,R8)                                    0422
         ST    @12,FRRSCURR(,R8)                                   0422
*               IF SDWASVCE=ON      /* IF THE ERROR TYPE INDICATES   */
*                   &SDWAINC1=SVC13 /* THAT A SVC 13 WAS ISSUED      */
*                   &SDWAPERC=OFF   /* CAUSING INITIAL ENTRY INTO    */
*                 THEN              /* SRM WITH THE NORMAL STACK   0423
*                                      BEING EMPTY THEN RECORDING OF
*                                      THE ERROR CAN BE SUPPRESSED   */
         TM    SDWASVCE(R5),B'00000100'                            0423
         BNO   @RF00423                                            0423
         CLC   SDWAINC1(2,R5),@CH00196                             0423
         BNE   @RF00423                                            0423
         TM    SDWAPERC(R5),B'00010000'                            0423
         BNZ   @RF00423                                            0423
*                 SDWARCRD=OFF;     /* SUPPRESS THE RECORDING        */
         NI    SDWARCRD(R5),B'01111111'                            0424
*               ELSE                                               0425
*                 ;                 /* OTHERWISE RECORDING IS THE  0425
*                                      DEFAULT                       */
@RF00423 DS    0H                                                  0426
*             END;                                                 0426
*           ELSE                    /* OTHERWISE                     */
*             DO;                   /* FRR STACK THEN DO FOLLOWING   */
         B     @RC00416                                            0427
@RF00416 DS    0H                                                  0428
*               R6=AVAIL;           /* FRRS ARE AVAILABLE            */
*                                                                  0428
         LA    R6,1                                                0428
*               /*****************************************************/
*               /*                                                   */
*               /* THE FOLLOWING CODE INITIALIZES THE PSW THAT WILL  */
*               /* BE USED TO GIVE THE FRR CONTROL INPUT - RT1WRTCA  */
*               /* FIELD OF THE RTM1 WORK AREA PORTION OF THE        */
*               /* INTERRUPTED STACK POINTS TO THE ACTIVE RTCA THAT  */
*               /* WILL BE PASSED TO THE FRR - CURRSTK REGISTER(R8)  */
*               /* POINTS TO THE INTERRUPTED STACK - THE             */
*               /* MODEBYTE(RT1WMODE) IN THE RTM1 WORK AREA CONTAINS */
*               /* THE MODE OF THE SYSTEM AT THE TIME OF THE ERROR - */
*               /* A DISABLED PSW WITHIN SRM WILL BE USED TO         */
*               /* INITIALLY SET THE PSW USED TO ROUTE TO THE FRR    */
*               /* OUTPUT - A DISABLED PSW IN THE SDWAEC2 FIELD OF   */
*               /* THE ACTIVE RTCA WILL POINT TO THE FRR IF (1)THE   */
*               /* SYSTEM IS IN SUPERVISOR CONTROL MODE(I.E. THE     */
*               /* CURRENT STACK IS NOT NORMAL)----OR--- (2)A ROUTINE*/
*               /* HAS INDICATED IT IS SERIALIZING A CPU             */
*               /* RESOURCE(.I.E. ONE OF THE SUPER BITS IN THE PSA IS*/
*               /* ON)----OR---- (3)A GLOBAL SPIN LOCK IS HELD - AN  */
*               /* ENABLED PSW IN THE SDWAEC2 FIELD OF THE ACTIVE    */
*               /* RTCA WILL POINT TO THE FRR IF IT IS DETERMINED    */
*               /* THAT A DISABLED ONE IS NOT TO BE LOADED NOTES -   */
*               /* REGS R0,R2,R5,R6,R7,R8 MUST REMAIN UNALTERED      */
*               /* THROUGHOUT THIS SEGMENT - REGS                    */
*               /* R1,R3,R4,R9,R11,R12,R13,R14,R15 ARE VOLATILE IN   */
*               /* THIS SEGMENT                                      */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0429
*               RFY                                                0429
*                 PSW BASED(ADDR(SDWAEC2));/* SET ORIGIN OF PSW      */
*               RFY                                                0430
*                 PSWEXT1 BASED(ADDR(SDWAAEC2));/* TO BE USED TO GIVE
*                                      FRR CONTROL                   */
*               FRRPSW1=LFRRPSW;    /* INITIALIZE A DISABLED PSW IN
*                                      THE ACTIVE RTCA TO GIVE THE 0431
*                                      FRR CONTROL THE PSW IS NOT IN
*                                      WAIT STATE AND IS NOT IN    0431
*                                      PROBLEM STATE FRRS GET CONTROL
*                                      IN KEY0 ZERO PROGRAM MASK BITS
*                                      FRRS ARE ENABLED FOR DAT AND
*                                      ALSO MACHINE CHECKS           */
         L     @12,LFRRPSW                                         0431
         ST    @12,FRRPSW1+120(,R5)                                0431
*               RFY                                                0432
*                 R15 RSTD;                                        0432
*               RFY                                                0433
*                 R1 RSTD;                                         0433
*               GENERATE CODE;                                     0434
*                                      /*ARE SPIN LOCKS HELD         */
         SETLOCK TEST,TYPE=SPIN,REGS=(R1)
*               RFY                                                0435
*                 R1 UNRSTD;                                       0435
*               IF PSASUPER=NULL    /* IF THE ERROR OCCURRED IN A  0436
*                                      MODE OTHER THAN SUPER         */
*                   &R8=PSANSTK     /* AND THE INTERRUPTED STACK IS
*                                      NOT A SUPER STACK             */
*                   &R15^=NULL      /* AND NO SPIN LOCKS ARE HELD    */
*                 THEN              /* AND THE ERROR OCCURRED IN THE
*                                      ENABLED STATE THEN AN ENABLED
*                                      PSW WILL BE USED TO GIVE THE
*                                      FRR CONTROL                   */
         SLR   @14,@14                                             0436
         CL    @14,PSASUPER                                        0436
         BNE   @RF00436                                            0436
         C     R8,PSANSTK                                          0436
         BNE   @RF00436                                            0436
         CR    R15,@14                                             0436
         BE    @RF00436                                            0436
*                 DO;               /* FOR I/O AND EXTERNAL          */
*                   MODEDIS=OFF;    /* INSURE THAT THE MODE REFLECTS
*                                      ENABLEMENT                    */
         NI    MODEDIS+81(R8),B'10111111'                          0438
*                   PSWIO=ON;       /* ENABLED FOR I/O INTERRUPTS    */
*                   PSWEXT=ON;      /* AND EXTERNAL INTERRUPTS       */
         OI    PSWIO+120(R5),B'00000011'                           0440
*                   IF SDWARKEY=ON& /* IF THE ERROR BEING PROCESSED
*                                      IS A RESTART ERROR    @YA00800*/
*                       SDWAPERC=OFF THEN/* AND THE 1ST FRR WILL GET
*                                      CONTROL ENABLED THEN THE    0441
*                                      RESTART LOCK MUST BE FREED  0441
*                                      SINCE IT IS SERIALIZED BY   0441
*                                      DISABLEMENT           @YA00800*/
         TM    SDWARKEY(R5),B'00100000'                            0441
         BNO   @RF00441                                            0441
         TM    SDWAPERC(R5),B'00010000'                            0441
         BNZ   @RF00441                                            0441
*                     CVTRSTWD=NULL;/* ZERO RESTART WORD             */
         L     @12,CVTPTR                                          0442
         ST    @14,CVTRSTWD(,@12)                                  0442
*                   ELSE                                           0443
*                     ;             /* IF THE ERROR BEING PROCESSED
*                                      IS NOT A RESTART ERROR THEN 0443
*                                      THE RESTART WORD IS NOT OWNED
*                                      AND NEED NOT BE ZEROED        */
@RF00441 DS    0H                                                  0444
*                 END;                                             0444
*               ELSE                                               0445
*                 ;                 /* IF ANY ONE OF THE ABOVE     0445
*                                      CONDITIONS ARE VALID A      0445
*                                      DISABLED PSW WILL BE USED TO
*                                      GIVE THE FRR CONTROL          */
@RF00436 DS    0H                                                  0446
*               RFY                                                0446
*                 R15 UNRSTD;                                      0446
*               PSWIC=FRRSFRRA;     /* PLACE FRR ADDRESS IN PSW      */
*                                                                  0447
         L     @01,FRRSCURR(,R8)                                   0447
         L     @12,FRRSFRRA(,@01)                                  0447
         ST    @12,PSWIC+120(,R5)                                  0447
*               /*****************************************************/
*               /*                                                   */
*               /* THE FOLLOWING SEGMENT SAVE THE CURRENT LOCKS HELD */
*               /* STATUS BY LOOPING THRU THE LOCKS HELD TABLE       */
*               /* CONSTRUCTING A 2 BYTE MASK OF BITS,EACH --ON-- BIT*/
*               /* MAPS TO A CORRESPONDING LOCK HELD INPUT - LKIDX   */
*               /* REGISTER(R4) USED AS A INDEX IN LOOPING THRU THE  */
*               /* LOCKS HELD TABLE - RT1WRTCA FIELD OF THE RTM1 WORK*/
*               /* AREA PORTION OF THE INTERRUPTED STACK POINTS TO   */
*               /* THE ACTIVE RTCA - CURRSTK REGISTER(R8) POINTS TO  */
*               /* THE INTERRUPTED FRR STACK - LOCKMASK FIELD IN THE */
*               /* RTM1 WORK AREA PORTION OF THE INTERRUPTED STACK IN*/
*               /* WHICH THE CHECKPOINTED LOCKS HELD MASK WILL BE    */
*               /* SAVED - A LOCK TRANSLATION TABLE WITHIN SRM THAT  */
*               /* IS USED TO TRANSLATE THE LOCKS HELD INTO A BIT    */
*               /* MASK IDENTICAL TO BIT MASK IN THE ACTIVE          */
*               /* RTCA(SDWAACF3,SDWAACF4) OUTPUT - LOCKMASK IN THE  */
*               /* RTM1 WORK AREA CONTAINS A BIT MASK IDENTIFYING THE*/
*               /* LOCKS HELD ON ENTRY TO THE FRR NOTES -            */
*               /* REGS(R0,R2,R5,R6,R7,R8)MUST BE PRESERVED          */
*               /* THROUGHOUT THIS SEGMENT - LKIDX REGISTER(R4) IS   */
*               /* USED AS A WORK REG TO LOOP THRU THE LOCKS HELD    */
*               /* TABLE - REGS(R1,R3, R11,R12,R13,R14,R15) ARE      */
*               /* VOLATILE IN THIS SEGMENT                          */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0448
*               DO;                                                0448
*                 RFY                                              0449
*                   R4 RSTD;        /* REGISTER USED IN SAVING THE 0449
*                                      CURRENTLY LOCKS HELD STATUS 0449
*                                      PRIOR TO ROUTING TO THE FRR   */
*                 R4=NULL;          /* INITIALIZE TO OBTAIN LOCKS  0450
*                                      CURRENTLY HELD                */
         SLR   R4,R4                                               0450
*                 GENERATE CODE;                                   0451
*                                      /*TEST FOR LOCKS HELD         */
         SETLOCK TEST,TYPE=ALL,REGS=(R4)
*                 LOCKMASK=R4;      /* SAVE THE STATUS OF LOCKS    0452
*                                      CURRENTLY HELD        @YM02684*/
         L     @01,RT1WRTCA(,R8)                                   0452
         STH   R4,LOCKMASK+512(,@01)                               0452
*               END;                                               0453
*                                                                  0453
*               /*****************************************************/
*               /*                                                   */
*               /* THE FOLLOWING CODE SETS UP SRM RETURN             */
*               /* ADDRESS,MARKS THE FRR TO BE GIVEN CONTROL, AND    */
*               /* ZEROES PCFLIHS RECURSION BITS IF THE INTERRUPTED  */
*               /* STACK IS NOT PCFLIHS, AND FINALLY GIVES THE FRR   */
*               /* CONTROL INPUT - RT1WRTCA FIELD OF THE RTM1 WORK   */
*               /* AREA PORTION OF THE INTERRUPTED STACK POINTS TO   */
*               /* THE ACTIVE RTCA - CURRSTK REGISTER(R8) POINTS TO  */
*               /* THE INTERRUPTED STACK - FRRSCURR FIELD OF THE     */
*               /* INTERRUPTED STACK POINTS TO THE CURRENT FRR ENTRY */
*               /* ON THE STACK WHICH CONTAINS THE FRR ADDRESS OF THE*/
*               /* FRR TO RECEIVE CONTROL - PSAPSTK FIELD IN THE     */
*               /* PSARSVT POINTS TO PCFLIHS FRR STACK - PCFLIHS DAT */
*               /* AND SEGMENT RECURSION FLAGS IN THE LCCA OUTPUT -  */
*               /* FRREPA REGISTER(R15) POINTS TO THE FRR TO GET     */
*               /* CONTROL - INRTCA REGISTER(R1) POINTS TO THE ACTIVE*/
*               /* RTCA PASSED TO THE FRR - SDWAPARM(1ST WORD OF THE */
*               /* RTCA) POINTS TO THE FRRS 6 WORD PARAMETER LIST -  */
*               /* SAVAREAP REGISTER(R13) POINTS TO THE VARIABLE     */
*               /* RECORDING WITHIN THE RTCA---THIS IS DONE SINCE SRM*/
*               /* DOES NOT RELY ON THE FRR SAVING AND RESTORING SRMS*/
*               /* REGISTERS---SRM HAS THE ABILITY TO REESTABLISH    */
*               /* ITSELF INDEPENDENT OF THE FRRS ACTIONS - SRMRETAD */
*               /* REGISTER(R14) IS THE RETURN ADDRESS TO SRM FROM   */
*               /* THE FRR NOTES - R0,R2,R5,R6,R7,R8 WILL HAVE THE   */
*               /* SAME CONTENTS ON OUTPUT FROM THIS SEGMENT AS THEY */
*               /* HAD ON INPUT - TARGFRR REGISTER(R4) IS USED BY SRM*/
*               /* TO SAVE THE ADDRESS OF THE FRR ENTRY ASSOCIATED   */
*               /* WITH THE FRR GIVEN CONTROL SO CERTAIN RECURSION   */
*               /* INFORMATION CAN BE MONITORED - REGISTERS          */
*               /* R1,R13,R14,R15 ARE VOLATILE AFTER SRM ROUTES TO   */
*               /* THE FRR - SRM SAVES ITS OWN REGISTER CONTENTS IN  */
*               /* THE SRM REG SAVE AREA APPENDED TO THE ACTIVE RTCA */
*               /* PRIOR TO ROUTING TO THE FRR                       */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0454
*               RFY                                                0454
*                (R15,                                             0454
*                 R13,                                             0454
*                 R14,                                             0454
*                 R1) RSTD;                                        0454
*               R15=FRRSFRRA;       /* REG15 CONTAINS THE ENTRY POINT
*                                      ADDR OF THE FRR               */
         L     @12,FRRSCURR(,R8)                                   0455
         L     R15,FRRSFRRA(,@12)                                  0455
*               R1=R5;              /* REGISTER 1 POINTS TO RTCA     */
         LR    R1,R5                                               0456
*               SDWAPARM=ADDR(FRRSPARM);/* SET PARAMETER AREA ADDRESS
*                                      IN RTCA                       */
         LA    @11,FRRSPARM(,@12)                                  0457
         ST    @11,SDWAPARM(,R5)                                   0457
*               R13=ADDR(SDWAVRA);  /* SET REG 13 TO ADDRESS OF    0458
*                                      VARIABLE RECORDING AREA IN  0458
*                                      RTCA TO PREVENT FRR FROM    0458
*                                      DESTROYING SRMS REGISTERS     */
         LA    R13,SDWAVRA(,R5)                                    0458
*               R14=ADDR(FRRETRN);  /* SET REG 14 WITH SRM RETURN  0459
*                                      ADDRESS                       */
         LA    R14,FRRETRN                                         0459
*               FRRSRCUR=ON;        /* SET RECURSION BIT ON IN FRR 0460
*                                      STACK ENTRY                   */
         OI    FRRSRCUR(@12),B'10000000'                           0460
*               IF R8^=PSAPSTK THEN /* IF INTERRUPTED STACK IS NOT   */
         C     R8,PSAPSTK                                          0461
         BE    @RF00461                                            0461
*                 DO;               /* PCFLIHS ZERO PCFLIHS RECURSION
*                                      BITS                          */
*                   LCCAPDAT=OFF;   /* ZERO DAT RECURSION BIT        */
*                   LCCAPSG1=OFF;   /* ZERO SEGMENT RECURSION BITS   */
         L     @12,PSALCCAV                                        0464
         NI    LCCAPDAT(@12),B'11001111'                           0464
*                   PSAPI2=OFF;     /* ZERO PC FLIH RECURSION BIT PC
*                                      FLIH HAS NO RECOVERY IF THIS
*                                      FLAG IS ON            @ZA03845*/
*                   PSAPSREG=OFF;   /* ZERO PC FLIH RECURSION BIT PC
*                                      FLIH HAS NO RECOVERY IF THIS
*                                      FLAG IS ON            @ZA03845*/
         NI    PSAPI2,B'10011111'                                  0466
*                 END;                                             0467
*               ELSE                                               0468
*                 ;                 /* OTHERWISE RECURSION BITS ARE
*                                      UNCHANGED                     */
@RF00461 DS    0H                                                  0469
*               IF FRRSNEST=ON THEN /* IF THE FRR TO GET CONTROL IS A
*                                      NESTED FRR THEN INDICATE IN 0469
*                                      THE RTCA THAT THE NESTED FRR
*                                      IS TO JUST                    */
         L     @12,FRRSCURR(,R8)                                   0469
         TM    FRRSNEST(@12),B'01000000'                           0469
         BNO   @RF00469                                            0469
*                 SDWACLUP=ON;      /* CLEANUP AND PERCOLATE AND NOT
*                                      TO RETRY OR RESUME            */
         OI    SDWACLUP(R5),B'10000000'                            0470
*               ELSE                /* IF THE FRR TO GET CONTROL IS
*                                      NOT A NESTED FRR THEN NO    0471
*                                      CLEANUP AND PERCOLATE       0471
*                                      CONDITION IS INDICATED IN THE
*                                      RTCA PROVIDED THE ERROR BEING
*                                      PROCESSED DOES NOT REQUIRED 0471
*                                      SUCH AN INDICATION            */
*                 IF RT1WCLUP=OFF THEN/* IF THE ERROR BEING PROCESSED
*                                      DOES NOT REQUIRED CLEANUP AND
*                                      PERCOLATION THEN THE RTCA   0471
*                                      INDICATION TO CLEANUP AND   0471
*                                      PERCOLATE IS NULLIFIED        */
         B     @RC00469                                            0471
@RF00469 TM    RT1WCLUP(R8),B'10000000'                            0471
         BNZ   @RF00471                                            0471
*                   SDWACLUP=OFF;                                  0472
         NI    SDWACLUP(R5),B'01111111'                            0472
*                 ELSE                                             0473
*                   ;               /* IF CLEANUP AND PERCOLATION IS
*                                      REQUIRED THE RTCA INDICATION
*                                      IS UNCHANGED                  */
@RF00471 DS    0H                                                  0474
*               RFY                                                0474
*                (R4,                                              0474
*                 R12) RSTD;                                       0474
@RC00469 DS    0H                                                  0475
*               R4=FRRSCURR;        /* SAVE THE ADDRESS OF THE     0475
*                                      CURRENT FRR SO THAT ON RETURN
*                                      FROM THE FRR THE IN USE FLAG
*                                      IN THE FRR ENTRY CAN BE TURNED
*                                      OFF                           */
         L     R4,FRRSCURR(,R8)                                    0475
*               R12=R0;             /* SAVE CONTENTS OF FUNCTION   0476
*                                      REGISTER PRIOR TO INVOKING THE
*                                      FRR                           */
         LR    R12,R0                                              0476
*               R0=ADDR(FRRWA);     /* REGISTER 0 POINTS TO THE FRR
*                                      WORK AREA                     */
         LA    R0,584                                              0477
         AL    R0,RT1WRTCA(,R8)                                    0477
*               RT1TLPN=FRRRECUR;   /* INDICATE ABILITY TO ACCEPT  0478
*                                      VALID RECURSION       @ZA20321*/
         MVI   RT1TLPN(R3),X'FE'                                   0478
*/* ******************************************************************/
*/* THIS SEGMENT PERFORMS THE ACTUAL ROUTING TO THE FRR              */
*/* INPUT                                                            */
*/*  - INRTCA REGISTER(R1) POINTS TO THE RTCA THAT WILL BE PASSED    */
*/*    TO THE FRR                                                    */
*/*  - SDWAEC2,SDWAAEC2 FIELDS OF THE RTCA CONTAIN THE PSW THAT      */
*/*    WILL BE LOADED TO GIVE THE FRR CONTROL                        */
*/*  - THE SRM REGISTER SAVE AREA APPENDED TO THE RTCA WILL BE       */
*/*    USED TO SAVE SRM REGISTERS PRIOR TO THE LPSW                  */
*/*  - RT1WRTCA FIELD OF THE RTM1 WORK AREA PROTION OF THE           */
*/*    POINTS TO THE RTCA TO BE PASSED TO THE FRR                    */
*/*  - PSACSTK FIELD FO THE PSARSVT POINTS TO THE INTERRUPTED        */
*/*    STACK ON WHICH IS DEFINED THE FRR TO BE GIVEN CONTROL         */
*/* OUTPUT                                                           */
*/*  - ALL OF SRMS REGISTER CONTENTS PRIOR TO THE LPSW ARE           */
*/*    RELOADED FROM THE SRM REGISTER SAVE AREA                      */
*/* NOTES                                                            */
*/*  - ALL OF SRMS REGISTER CONTENTS ON INPUT TO THIS SEGMENT        */
*/*    REMAIN THE SAME ON OUTPUT FROM THIS SEGMENT                   */
*/* ******************************************************************/
*                                                                  0479
*               GENERATE CODE REFS(SRMREGS,SDWAEC2);               0479
         STM   R0,R15,SRMREGS+512(R1)  SAVE SRMS REGISTERS
         LPSW  SDWAEC2(R1)         GIVE FRR CONTROL
*FRRETRN:                                                          0480
*               GENERATE CODE REFS(RT1WRTCA,SRMREGS);              0480
FRRETRN  DS    0H                                                  0480
*ASSEMBLY CODE IS PLACED HERE TO AND THE CURRENT PSW INTO THE
*DISABLED STATE,RELOAD SRMS BASE REG AND ALL OF ITS REGS FROM THE SRM
*SAVE AREA
         L     R5,PSACSTK                 GET ADDR OF CURRENT STACK
         LA    R5,FRRSRTMW-FRRS(0,R5)    GET ADDR OF THE RTM1 WA
         L     R5,RT1WRTCA-RT1W(0,R5)  OBTAIN ADDRESS OF RTCA
FIVE12   EQU   512          RTCA LENGTH                        @YM02601
         STNSM 512(R5),X'FC'    GET PHYS DISABLED
         MVI   FIVE12+1(R5),X'00'  INSURE A NULL MASK BYTE     @YM02601
         LM    R0,R15,SRMREGS+512(R5)  RELOAD SRMS REGISTERS
*               RFY                                                0481
*                 FRRSENTR BASED(FRRSCURR);                        0481
*               RT1TLPN=SRMROUTE;   /* INDICATE THAT SRM CAN RECOVER
*                                      ON RECRUSIONS ONLY VIA LOGICAL
*                                      PHASE RECOVERY RTNS           */
         MVI   RT1TLPN(R3),X'41'                                   0482
*               RT1TLPID=SRMDRID;   /* RESTORE RTS RECOVRY   @YM06156*/
         MVI   RT1TLPID(R3),X'01'                                  0483
*               R0=R12;             /* REESTABLISH THE CONTENTS OF 0484
*                                      THE FUNCTION REGISTER ON    0484
*                                      RETURN FROM THE FRR           */
         LR    R0,R12                                              0484
*               RFY                                                0485
*                (R4,                                              0485
*                 R12) UNRSTD;                                     0485
*               IF R8^=PSAPSTK THEN /* IF THE PCFLIH STACK IS NOT THE
*                                      CURRENT STACK THEN GTF CAN BE
*                                      INVOKED TO TRACE THE ACTIONS
*                                      OF THE FRR                    */
*                                                                  0486
         L     @12,PSAPSTK                                         0486
         CR    R8,@12                                              0486
         BE    @RF00486                                            0486
*                 /***************************************************/
*                 /*                                                 */
*                 /* THIS SEGMENT INTERFACES WITH GTF TO TRACE THE   */
*                 /* ACTIONS OF FRRS ROUTED TO BY SRM INPUT - CURRSTK*/
*                 /* REGISTER(R8) POINTS TO THE INTERRUPTED FRR STACK*/
*                 /* - SRMSTAK REGISTER(R2) POINTS TO THE FRR STACK  */
*                 /* SRM CAN USE TO DEFINE ITS OWN FRRS - PARMREGG   */
*                 /* REGISTER(R11) AND R12 ARE USED BY SRM TO DEFINE */
*                 /* ITS OWN FRR VIA THE SETFRR MACRO OUTPUT - INRTCA*/
*                 /* REGISTER(R1) POINTS TO THE RTCA ON ENTRY TO GTF */
*                 /* - SAVAREAP REGISTER(R13) POINTS TO SRM REG SAVE */
*                 /* AREA ON ENTRY TO GTF NOTES - GTF IS BRANCHED    */
*                 /* ENTERED VIA HOOK MACRO - REGS R1,R13,R15 ARE    */
*                 /* VOLATILE ACROSS THE INTERFACE TO GTF - ALL OTHER*/
*                 /* SRM REGS ARE RESTORED BY GTF ON RETURN - REGS   */
*                 /* R11,R12 ARE USED BY SRM TO ADD AND DELETE A FRR */
*                 /* VIA THE SETFRR MACRO - REGS R0,R2,R5,R6,R7,R8   */
*                 /* MUST BE PRESERVED THROUGHOUT THIS SEGMENT - REGS*/
*                 /* R3,R4, ARE VOLATILE THROUGHOUT THIS SEGMENT     */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0487
*                 DO;                                              0487
*                   RT1TLPN=SRMGTF; /* LOGICAL PHASE IS TO TRACE     */
         MVI   RT1TLPN(R3),X'46'                                   0488
*                   R1=R5;          /* REG 1 POINTS TO THE RTCA      */
         LR    R1,R5                                               0489
*                   RFY                                            0490
*                    (R11,                                         0490
*                     R12) RSTD;                                   0490
*                   RFY                                            0491
*                     FRRPARMS BASED(R11);/* PARMREGG REG WILL BE  0491
*                                      USED TO ADDR THE FRR PARAMETER
*                                      AREA                          */
*                   PSACSTK=PSAPSTK;/* SAVED AND PCFLIHS STACK IS  0492
*                                      MADE IN PREPARATION FOR     0492
*                                      INVOKING GTF                  */
         L     @04,PSAPSTK                                         0492
         ST    @04,PSACSTK                                         0492
*                   RFY                                            0493
*                     FRRS BASED(PSACSTK);                         0493
*                   RFY                                            0494
*                     RT1TRACK BASED(ADDR(RT1WLPTA));/* USE CURRNT 0494
*                                      STCK                  @YM06156*/
*                   RT1TLPN=SRMGTF; /* LOGICAL PHASE IS TO ALLOW RTS
*                                      PROCESSING IN THE EVENT OF AN
*                                      ERROR IN GTF                  */
         AL    @04,@CF00203                                        0495
         MVI   RT1TLPN(@04),X'46'                                  0495
*                   RT1TLPID=SRMDRID;                              0496
         MVI   RT1TLPID(@04),X'01'                                 0496
*                   GENERATE CODE   /* ADD FRR TO PROTECT SRM FROM 0497
*                                      POSSIBLE GTF FAILURE          */
*                       ;                                          0497
         SETFRR A,FRRAD=RGTFFRR,PARMAD=(R11),WRKREGS=(R11,R12)
*                   DO;                                            0498
*                     FRRPHOOK=ON;  /* TRACING ACTIVE                */
         OI    FRRPHOOK(R11),B'01000000'                           0499
*                     FRRPRTYA=ADDR(DELHKFRR);/* CHKPT RETRY ADDRESS */
         LA    @04,DELHKFRR                                        0500
         ST    @04,FRRPRTYA(,R11)                                  0500
*                     FRRPISTK=R8;  /* CHKPT INTERRUPTED STACK       */
         ST    R8,FRRPISTK(,R11)                                   0501
*                     FRRPREG1=R2;  /* SAVE IEAVTRTS RECOV STACK     */
         ST    R2,FRRPREG1(,R11)                                   0502
*                     FRRPREG2=R0;  /* CHKPT FUNCTION REG            */
         ST    R0,FRRPREG2(,R11)                                   0503
*                     FRRPREG3=R6;  /* CHKPT FRR AVAILABILITY        */
         ST    R6,FRRPREG3(,R11)                                   0504
*                     FRRPFLPN=SRMGTF;/* SAVE LOGICAL PHASE NUMBER   */
         MVI   FRRPFLPN(R11),X'46'                                 0505
*                   END;                                           0506
*                   RT1TLPN=NONE;   /* OPEN RTS FOR AN ERROR IN GTF  */
         L     @04,PSACSTK                                         0507
         MVI   RT1TLPN+16(@04),X'00'                               0507
*                   RFY                                            0508
*                     SRMSTAT BASED(ADDR(RT1WVARI));               0508
*DELHOOK:                                                          0509
*                   GENERATE CODE;                                 0509
DELHOOK  DS    0H                                                  0509
*                                      /*CALL GTF VIA THE HOOK MACRO */
* THE HOOK MACRO WILL BE ISSUED TO INVOKE GTF
         HOOK  EID=IEAFRR,TYPE=BPN      TRACE ACTIONS OF THE FRR
*DELHKFRR:                          /* DELETE SRMS FRR               */
*                   RT1TLPN=SRMGTF; /* RESTORE RTS RECOVRY   @YM06156*/
DELHKFRR LA    @04,16                                              0510
         AL    @04,PSACSTK                                         0510
         MVI   RT1TLPN(@04),X'46'                                  0510
*                   RT1TLPID=SRMDRID;/* RESTORE RTS RECOVRY  @YM06156*/
         MVI   RT1TLPID(@04),X'01'                                 0511
*                   CALL DELTAFRR;  /* DELETE THE FRR                */
         BAL   @14,DELTAFRR                                        0512
*                   RFY                                            0513
*                     FRRPARMS;                                    0513
*                   RT1TLPN=NONE;   /* NULLIFY RTS RECOVERY ON THE 0514
*                                      RECOVERY STACK        @YM06156*/
         L     @04,PSACSTK                                         0514
         MVI   RT1TLPN+16(@04),X'00'                               0514
*                   PSACSTK=R8;     /* REESTABLISH THE INTERRUPTED 0515
*                                      STACK                         */
         ST    R8,PSACSTK                                          0515
*                   RFY                                            0516
*                     FRRS BASED(R8);                              0516
*PLSFIX:                            /* LABEL TO CAUSE PLS COMPILER TO
*                                      DROP REG HISTORY SO VERS 6.3
*                                      WILL WORK                     */
*                   RT1TLPN=SRMGTF; /* RESTORE RTS RECOVERY ON THE 0517
*                                      INTERRUPTED STACK     @YM06156*/
PLSFIX   MVI   RT1TLPN+16(R8),X'46'                                0517
*                   RFY                                            0518
*                    (R11,                                         0518
*                     R12,                                         0518
*                     R13,                                         0518
*                     R14,                                         0518
*                     R15,                                         0518
*                     R1) UNRSTD;                                  0518
*                 END;                                             0519
*               ELSE                                               0520
*                 ;                 /* OTHERWISE, GTF IS SKIPPED   0520
*                                      SINCE A UNIQUE RECOVERY     0520
*                                      ENVIRONMENT CANNOT BE INSURED */
@RF00486 DS    0H                                                  0521
*             END;                                                 0521
*         ELSE                                                     0522
*           ;                       /* IF RECURSION IS ACTIVE THEN 0522
*                                      SKIP FRR ROUTING UNTIL THE  0522
*                                      ORIGINAL ERROR HAS BEEN     0522
*                                      RECORDED                      */
@RF00415 DS    0H                                                  0523
*         RFY                                                      0523
*           R3 UNRSTD;                                             0523
@RC00415 DS    0H                                                  0524
*         RFY                                                      0524
*           RT1TRACK BASED(ADDR(RT1WLPTA));                        0524
*       END;                                                       0525
*                                                                  0525
*       /*************************************************************/
*       /*                                                           */
*       /* THIS SEGMENT INTERFACES WITH THE SOFTEWARE ERROR RECORDING*/
*       /* FACILITY TO RECORD THE RESULTS OF THE FRRS ACTION OR TO   */
*       /* RECORD THE ORIGINAL ERROR CONDITION IF NO FRR EXISTS INPUT*/
*       /* - TARGRTCA REGISTER(R5) POINTS TO THE RTCA TO BE RECORDED */
*       /* - CURRSTK REGISTER(R8) POINTS TO THE INTERRUPTED STACK -  */
*       /* SRMSTAK REGISTER(R2) POINTS TO THE SRM RECOVERY STACK     */
*       /* OUTPUT - RECORDING INDICATOR IN RTCA IS TURNED            */
*       /* OFF(SDWARCRD) - USER SUPPLIED LENGTH FIELD IN THE RTCA    */
*       /* THAT WAS RECORDED IS ZEROED - RECORDING PARAMETER LIST USE*/
*       /* ON INVOKING THE SOFTWARE RECORDING FACILITY IS UNCHANGED  */
*       /* NOTES - REGS(R0,R2,R5,R6,R7,R8)MUST REMAIN UNCHANGED      */
*       /* THROUGHOUT THIS SEGMENT - REGS(R1,R3,R13,R14,R15) ARE     */
*       /* INTERFACE REGS TO THE SOFTWARE RECORDING FACILITY - REGS  */
*       /* R4, IS VOLATILE THROUGHOUT THIS SEGMENT - REGS(R11,R12)ARE*/
*       /* USED TO DEFINE SRMS FRR PRIOR TO INVOKING THE SOFTWARE    */
*       /* RECORDING FACILITY                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0526
*       DO;                                                        0526
*         RT1TLPN=SRMRCRD;          /* LOGICAL PHASE IS RECORDING    */
         MVI   RT1TLPN+16(R8),X'47'                                0527
*         IF SDWARCRD=ON THEN       /* IF THE RTCA INDICATES       0528
*                                      RECORDING OF THE RTCA THEN    */
         TM    SDWARCRD(R5),B'10000000'                            0528
         BNO   @RF00528                                            0528
*           DO;                     /* DO THE FOLLOWING              */
*                                                                  0529
*             /*******************************************************/
*             /*                                                     */
*             /* THIS SEGMENT INITIALIZES THE INPUT INTERFACE TO THE */
*             /* SOFTWARE RECORDING FACILITY IN PREPARATION FOR      */
*             /* RECORDING THE RTCA INPUT - TARGRTCA REGISTER(R5)    */
*             /* POINTS TO THE RTCA TO BE RECORDED OUTPUT - INPARM   */
*             /* REGISTER(R1)POINTS TO THE RECORDING PARAMETER LIST  */
*             /* PASSED TO THE SOFTWARE RECORDING FACILITY - THE     */
*             /* RECORDING PARAMETER LIST CONTAINS .A RECORD TYPE    */
*             /* INDICATION(PROG CHEK,MACH CHEK, OR RESTART) .THE    */
*             /* ADDRESS OF THE RTCA TO BE RECORDED - RECLEN         */
*             /* REGISTER(R3) CONTAINS THE LENGTH OF THE DATA TO BE  */
*             /* RECORDED(I.E.THE FIXED PORTION OF THE RTCA AND THE  */
*             /* VARIABLE PORTION OF THE RTCA SUPPLIED BY THE FRR -  */
*             /* SAVAREAP REGISTER(R13)POINTS TO THE REGISTER SAVE   */
*             /* AREA TO BE USED BY THE SOFTWARE RECORDING FACILITY  */
*             /* TO SAVE SRMS REGISTERS NOTES - THE RECORDING        */
*             /* PARAMETER LIST IS PART OF THE RTCA AND CONTAINS THE */
*             /* RECORD TYPE AND THE ADDRESS OF THE RTCA -           */
*             /* REGS(R0,R2,R5,R6,R7,R8) MUST REMAIN UNCHANGED       */
*             /* THROUGHOUT THIS SEGMENT - REGS(R1,R13,R3) ARE THE   */
*             /* INPUT REGS TO THE SOFTWARE RECORDING FACILITY -     */
*             /* REGS(R14,R15) ARE LINKAGE REGISTERS TO THE SOFTWARE */
*             /* RECORDING FACILITY - REGS(R4, R11,R12) ARE VOLATILE */
*             /* IN THIS SEGMENT                                     */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0530
*             DO;                                                  0530
*               RCRDINFO=R5;        /* INITIALIZE THE RECORDING    0531
*                                      PARAMETER LIST WITH THE ADDR
*                                      OF THE RTCA TO BE RECORDED    */
         ST    R5,RCRDINFO(,R5)                                    0531
*               RFY                                                0532
*                 MODEBYTE BASED(ADDR(RT1WMODE));/* DETERMINE MODE 0532
*                                                            @G17EP5W*/
*               RFY                                                0533
*                 ASCB BASED(PSAAOLD);/* ASCB ADDRESSABILTY  @G17EP5W*/
*               IF((MODESRB=ON)|    /* IF THIS IS SRB MODE   @G17EP5W*/
*                   (PSAAOLD->ASCBASCB^=NASCB)) THEN/* OR INVALID  0534
*                                      ASCB @@G17EP5W                */
         TM    MODESRB+80(R8),B'00000010'                          0534
         BO    @RT00534                                            0534
         L     @12,PSAAOLD                                         0534
         CLC   ASCBASCB(4,@12),@CC03200                            0534
         BE    @RF00534                                            0534
@RT00534 DS    0H                                                  0535
*                 RCRDNAME=FRRJNAME;/* THEN NO VALID JOB NAME      0535
*                                                            @G17EP5W*/
         MVC   RCRDNAME(8,R5),FRRJNAME                             0535
*               ELSE                /* ELSE TRY JOB NAME     @G17EP5W*/
*                 IF ASCBJBNI^=NULL THEN/* IF INITIATED JOB  @G17EP5W*/
         B     @RC00534                                            0536
@RF00534 L     @12,PSAAOLD                                         0536
         L     @12,ASCBJBNI(,@12)                                  0536
         LTR   @12,@12                                             0536
         BZ    @RF00536                                            0536
*                   RCRDNAME=ASCBJBNI->JOBNAME;/* ADD JOBNAME TO REC.
*                                                            @G17EP5W*/
         MVC   RCRDNAME(8,R5),JOBNAME(@12)                         0537
*                 ELSE              /* OTHERWISE, TRY OTHER@G17EP5W  */
*                   IF ASCBJBNS^=NULL THEN/* JOB TYPES       @G17EP5W*/
         B     @RC00536                                            0538
@RF00536 L     @12,PSAAOLD                                         0538
         L     @12,ASCBJBNS(,@12)                                  0538
         LTR   @12,@12                                             0538
         BZ    @RF00538                                            0538
*                     RCRDNAME=ASCBJBNS->JOBNAME;/* ADD JOBNAME TO 0539
*                                      REC.                  @G17EP5W*/
         MVC   RCRDNAME(8,R5),JOBNAME(@12)                         0539
*                   ELSE            /* NO JOBNAME ASSOC      @G17EP5W*/
*                     RCRDNAME=FRRJNAME;/* SET JOBNAME IN PARM LIST
*                                                            @YM05011*/
         B     @RC00538                                            0540
@RF00538 MVC   RCRDNAME(8,R5),FRRJNAME                             0540
*               RCRDSEQ#=SDWASEQ#;  /* SEQUENCE NBR          @G17EP5W*/
@RC00538 DS    0H                                                  0541
@RC00536 DS    0H                                                  0541
@RC00534 MVC   RCRDSEQ#(2,R5),SDWASEQ#(R5)                         0541
*               RCRDCPUI=SDWACPUI;  /* LOGICAL CPUID         @G17EP5W*/
         SLR   @12,@12                                             0542
         IC    @12,SDWACPUI(,R5)                                   0542
         STH   @12,RCRDCPUI(,R5)                                   0542
*               RCRDERTM=SDWAERTM;  /* TIME                  @G17EP5W*/
         MVC   RCRDERTM(4,R5),SDWAERTM(R5)                         0543
*               IF(SDWAFMID^=0)&    /* CHECK FOR NON ZERO    @G17EP5W*/
*                   (SDWAFMID^=INVLASID) THEN/* OR VALID ASID      0544
*                                                            @G17EP5W*/
         LH    @12,SDWAFMID(,R5)                                   0544
         N     @12,@CF03531                                        0544
         LTR   @12,@12                                             0544
         BZ    @RF00544                                            0544
         CLC   SDWAFMID(2,R5),@CB03198                             0544
         BE    @RF00544                                            0544
*                 RCRDASID=SDWAFMID;/* AND MOVE IT IN        @G17EP5W*/
         MVC   RCRDASID(2,R5),SDWAFMID(R5)                         0545
*               ELSE                /*                       @G17EP5W*/
*                 RCRDASID=SDWAASID;/* MOVE ASID             @G17EP5W*/
         B     @RC00544                                            0546
@RF00544 MVC   RCRDASID(2,R5),SDWAASID(R5)                         0546
*               RFY                                                0547
*                 MODEBYTE BASED(ADDR(RT1WSRMD));/* RESET MODE BYTE
*                                      MAP TO POINT TO CURRENT MODE
*                                                            @ZA20965*/
@RC00544 DS    0H                                                  0548
*               IF SDWARKEY=ON THEN /* IF THE ERROR TYPE IS THE    0548
*                                      RESTART KEY THEN SET THE    0548
*                                      RECORD TYPE FOR RESTART       */
         TM    SDWARKEY(R5),B'00100000'                            0548
         BNO   @RF00548                                            0548
*                 RCRDTYPE=RTPRSTRT;                               0549
         MVI   RCRDTYPE(R5),X'44'                                  0549
*               ELSE                                               0550
*                 ;                 /* IF NOT RESTART CHECK FOR    0550
*                                      ANOTHER ERROR TYPE            */
@RF00548 DS    0H                                                  0551
*               IF SDWAPCHK=ON|SDWATEXC=ON/* IF THE ERROR TYPE IS  0551
*                                      DATERR OR                     */
*                 THEN              /* PROGRAM CHECK THEN SET THIS 0551
*                                      RECORD TYPE FOR PROG CHECK    */
         TM    SDWAPCHK(R5),B'01000010'                            0551
         BZ    @RF00551                                            0551
*                 RCRDTYPE=RTPPCHEK;                               0552
         MVI   RCRDTYPE(R5),X'42'                                  0552
*               ELSE                                               0553
*                 ;                 /* IF NOT RESTART OR PROG CHECK
*                                      THEN CHECK FOR MACHINE CHECK  */
@RF00551 DS    0H                                                  0554
*               IF SDWAMCHK=ON THEN /* IF THE ERROR TYPE IS A MACHINE
*                                      CHECK THEN SET RECORD TYPE FOR
*                                      MACHINE CHECK                 */
         TM    SDWAMCHK(R5),B'10000000'                            0554
         BNO   @RF00554                                            0554
*                 RCRDTYPE=RTPMCHEK;                               0555
         MVI   RCRDTYPE(R5),X'48'                                  0555
*               ELSE                                               0556
*                 ;                 /* IF THE ERROR TYPE IS NOT    0556
*                                      MACHINE CHECK DONT SET RECORD
*                                      TYPE FOR MACHINE CHECK        */
@RF00554 DS    0H                                                  0557
*               IF SDWASVCE=ON THEN /* IF THE ERROR TYPE IS A SVC  0557
*                                      ERROR THEN SET RECORD TYPE FOR
*                                      SVC ERROR             @YM04255*/
         TM    SDWASVCE(R5),B'00000100'                            0557
         BNO   @RF00557                                            0557
*                 RCRDTYPE=RTPSVCE; /*                       @YM04255*/
         MVI   RCRDTYPE(R5),X'40'                                  0558
*               ELSE                                               0559
*                 ;                 /* IF THE ERROR TYPE IS NOT A A
*                                      SVC ERROR DONT SET RECORD TYPE
*                                      FOR SVC ERROR         @YM04255*/
@RF00557 DS    0H                                                  0560
*               RFY                                                0560
*                (R1,                                              0560
*                 R13,                                             0560
*                 R3) RSTD;                                        0560
*               R1=ADDR(SDWARCPL);  /* REGISTER 1 WILL POINT TO THE
*                                      RECORDING PARAMETER LIST      */
         LA    R1,SDWARCPL(,R5)                                    0561
*               R13=ADDR(FRRWA);    /* REGISTER 13 POINTS TO THE SRM
*                                      REGISTER SAVE AREA TO BE USED
*                                      BY THE SOFTWARE RECORDING   0562
*                                      FACILITY                      */
         LA    R13,584                                             0562
         AL    R13,RT1WRTCA(,R8)                                   0562
*               R3=LENGTH(SDWA)-LENGTH(SDWAVRA)+SDWAURAL;/* REGISTER
*                                      3 CONTAINS THE LENGTH OF DATA
*                                      TO BE RECORDED                */
         LA    R3,404                                              0563
         SLR   @12,@12                                             0563
         IC    @12,SDWAURAL(,R5)                                   0563
         ALR   R3,@12                                              0563
*             END;                                                 0564
*                                                                  0564
*             /*******************************************************/
*             /*                                                     */
*             /* THIS SEGMENT AFTER ESTABLISHING A SRM FRR TO PROTECT*/
*             /* SRM FROM A POSSIBLE SOFTWAR RECORDING FACILITY      */
*             /* FAILURE INVOKES THE SOFTWARE RECORDING FACILITY TO  */
*             /* RECORD THE CONTENTS OF THE RTCA INPUT - SRMSTAK     */
*             /* REGISTER(R2)POINTS TO THE SRM RECOVERY STACK -      */
*             /* CURRSTK REGISTER(R8) POINTS TO THE INTERRUPTED STACK*/
*             /* - INPARM REGISTER (R1)POINTS TO THE RECORDING PARM  */
*             /* LIST - RECLEN REGISTER(R3) CONTAINS THE LENGTH OF   */
*             /* THE DATA TO BE RECORDED - SAVAREAP REGISTER(R13)    */
*             /* POINTS TO THE SRM REG SAVE AREA OUTPUT -            */
*             /* INPARM,SAVAREAP,RECLEN,R14,R15 REGISTERS ALL        */
*             /* UNRELIABLE AFTER THE SOFTWARE RECORDING FACILITY IS */
*             /* INVOKED - THE SRM FRR IS DELETED ON RETURN FROM THE */
*             /* SOFTWARE RECORDING FACILITY NOTES -                 */
*             /* REGS(R0,R2,R5,R6,R7,R8)MUST REMAIN UNCHANGED        */
*             /* THROUGHOUT THIS SEGMENT - REGS(R11,R12)ARE USED BY  */
*             /* SRM IN THE SETFRR MACRO -                           */
*             /* REGS(R1,R3,R13,R14,R15)USED IN THE INTERFACE TO THE */
*             /* RECORDING FACILITY - REGS R4 IS VOLATILE            */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0565
*             PSACSTK=R2;           /* MAKE SRMS FRR STACK CURRENT SO
*                                      THAT SRM CAN PROTECT ITSELF 0565
*                                      WITH A FRR PRIOR TO INVOKING
*                                      THE SOFTWARE RECORDING      0565
*                                      FACILITY                      */
         ST    R2,PSACSTK                                          0565
*             RFY                                                  0566
*               R11 RSTD;                                          0566
*             RFY                                                  0567
*               FRRS BASED(PSACSTK);                               0567
*             RFY                                                  0568
*               FRRPARMS BASED(R11);                               0568
*             RT1TLPN=SRMRCRD;      /* LOGICAL PHASE ON SRM RECOV  0569
*                                      STACK IS RECORDING            */
         L     @12,PSACSTK                                         0569
         AL    @12,@CF00203                                        0569
         MVI   RT1TLPN(@12),X'47'                                  0569
*             RT1TLPID=SRMDRID;     /*                       @YM06156*/
         MVI   RT1TLPID(@12),X'01'                                 0570
*             GENERATE CODE;                                       0571
*                                      /*ESTABLISH SRMS FRR          */
         SETFRR A,FRRAD=RCRDFRR,PARMAD=(R11),WRKREGS=(R11,R12)
*             RFY                                                  0572
*               FRRS BASED(R8);                                    0572
*             SRMWSAV2=R0;          /* CHKPT REGISTER 0 - FUNCTION   */
         L     @12,RT1WRTCA(,R8)                                   0573
         ST    R0,SRMWSAV2+512(,@12)                               0573
*             RFY                                                  0574
*               FRRS BASED(PSACSTK);                               0574
*                                                                  0574
*             /*******************************************************/
*             /*                                                     */
*             /* ************STORE TRACKING                          */
*             /* INFORMATION***********************                  */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0575
*             DO;                                                  0575
*               FRRPRCRD=ON;        /* RECORDING ACTIVE              */
         OI    FRRPRCRD(R11),B'10000000'                           0576
*               FRRPREG1=R10;       /* CHKPT IEAVTRTS BASE REG       */
         ST    R10,FRRPREG1(,R11)                                  0577
*               FRRPRTYA=ADDR(DELRCFRR);/* CHKPT RETRY ADDRESS       */
         LA    @12,DELRCFRR                                        0578
         ST    @12,FRRPRTYA(,R11)                                  0578
*               FRRPREG2=R6;        /* CHKPT FRR AVAILABILITY        */
         ST    R6,FRRPREG2(,R11)                                   0579
*               FRRPISTK=R8;        /* CHKPT INTERRUPTED STACK ADDR  */
         ST    R8,FRRPISTK(,R11)                                   0580
*               FRRPREG3=R7;        /* CHKPT RECURSION STATUS        */
         ST    R7,FRRPREG3(,R11)                                   0581
*               FRRPFLPN=SRMRCRD;   /* CHKPT LOGICAL PHASE           */
         MVI   FRRPFLPN(R11),X'47'                                 0582
*             END;                                                 0583
*             RT1TLPN=NONE;         /* ALLOW FRR PROCESSING TO OCCUR
*                                      IF A FAILURE OCCURS IN THE  0584
*                                      SOFTWARE RECORDING FACILITY   */
         L     @12,PSACSTK                                         0584
         MVI   RT1TLPN+16(@12),X'00'                               0584
*             GENERATE CODE         /* INVOKE THE SOFTWARE RECORDING
*                                      FACILITY                      */
*                 ;                                                0585
         RECORD TYPE=LOGREC,PARMADR=(R1),LENGTH=(R3),RCVRY=SETFRR,     C
               HEADER=YES,JOBNAME=YES,ERRORID=YES              @YM05011
*                                                              @G17EP5W
*DELRCFRR:                          /* DELETE SRMS FRR               */
*             RT1TLPN=SRMRCRD;      /* RESTORE RTS RECOVRY   @YM06156*/
DELRCFRR LA    @12,16                                              0586
         AL    @12,PSACSTK                                         0586
         MVI   RT1TLPN(@12),X'47'                                  0586
*             RT1TLPID=SRMDRID;     /* RESTORE RTS RECOVRY   @YM06156*/
         MVI   RT1TLPID(@12),X'01'                                 0587
*             CALL DELTAFRR;        /* DELETE THE FRR                */
         BAL   @14,DELTAFRR                                        0588
*             RT1TLPN=NONE;         /* NULLIFY RTS RECOVERY ON THE 0589
*                                      RECOVERY STACK        @YM06156*/
         LA    @12,16                                              0589
         L     @04,PSACSTK                                         0589
         ALR   @04,@12                                             0589
         MVI   RT1TLPN(@04),X'00'                                  0589
*             PSACSTK=R8;           /* REESTABLISH THE INTERRUPTED 0590
*                                      STACK AS CURRENT              */
         ST    R8,PSACSTK                                          0590
*             RFY                                                  0591
*               FRRS BASED(R8);                                    0591
*             RT1TLPN=SRMRCRD;      /* RESTORE RTS RECOVERY ON THE 0592
*                                      INTERRUPTED STACK     @YM06156*/
         ALR   @12,R8                                              0592
         MVI   RT1TLPN(@12),X'47'                                  0592
*             R0=SRMWSAV2;          /* RESTORE REG0                  */
         L     @12,RT1WRTCA(,R8)                                   0593
         L     R0,SRMWSAV2+512(,@12)                               0593
*             RFY                                                  0594
*               R11 UNRSTD;                                        0594
*             RFY                                                  0595
*              (R1,                                                0595
*               R13,                                               0595
*               R3) UNRSTD;                                        0595
*NORCRD:                                                           0596
*             SDWARCRD=OFF;         /* INDICATE THAT RECORDING IS  0596
*                                      ACCOMPLISHED                  */
NORCRD   NI    SDWARCRD(R5),B'01111111'                            0596
*           END;                                                   0597
*         ELSE                                                     0598
*           ;                       /* OTHERWISE DO NOT RECORD       */
@RF00528 DS    0H                                                  0599
*         SDWAURAL=''B;             /* ZERO THE USER SUPPLIED LENGTH
*                                      OF VARIABLE RECORDING DATA FOR
*                                      THE NEXT FRRS USE             */
         MVI   SDWAURAL(R5),X'00'                                  0599
*       END;                                                       0600
*                                                                  0600
*/* ******************************************************************/
*/*      THIS SEGMENT ADJUSTS THE MODE IF NECESSARY PRIOR TO         */
*/*      PERCOLATING THE ERROR TO OTHER FRRS ON THE STACK SO THAT    */
*/*      PROPER SERIALIZATION OF THE RTCA INTERFACE BETWEEN IEAVTRTS */
*/*      AND THE FRRS ARE MAINTAINED                                 */
*/*     INPUT                                                        */
*/*      - FRRTNS REGISTER(R6) CONTAINS THE INDICATION WHETHER       */
*/*        THERE ARE ANY FRRS ON THE INTERRUPTED FRR STACK           */
*/*      - RECURSE REGISTER(R7) CONTAINS THE INDICATION WHETHER      */
*/*        SRM IS OPERATING IN RECURSION MODE(I.E.BECAUSE OF A       */
*/*        FRR FAILURE) OR NOT                                       */
*/*      - CURRSTK REGISTER(R8) POINTS TO THE INTERRUPTED STACK      */
*/*      - FUNCTION REGISTER(R0) WILL BE USED TO INDICATE TO         */
*/*        FURTHER SRM PROCESSES WHETHER RETRY OR RESUME OR          */
*/*        PERCOLATION SHOULD BE PERFORMED                           */
*/*      - TARGRTCA REGISTER(R5) POINTS TO THE CURRENTELY ACTIVE     */
*/*        RTCA                                                      */
*/*     OUTPUT                                                       */
*/*      - TARGRTCA REGISTER(R5) IS ZERO IF RETRY OR RESUME IS       */
*/*        DETERMINED                                                */
*/*        OTHERWISE IT REMAINS UNCHANGED                            */
*/*      - FUNCTION REGISTER(R0) CONTAINS THE INDICATION WHETHER     */
*/*        TO RETRY,RESUME OR PERCOLATE                              */
*/*      - IF PERCOLATION IS DETERMINED THE RETRY AND RESUME         */
*/*        INDICATIONS IN THE ACTIVE RTCA ARE ZEROED                 */
*/*        (I.E.SDWARCDE,SDWARTYA,SDWACPUA,SDWASPIN)                 */
*/*     NOTES                                                        */
*/*      - REGS(R0,R2,R5,R6,R7,R8) ARE RESTRICTED IN THIS SEGMENT    */
*/*      - REGS(R1,R3,R4,   R11,R12,R13,R14,R15) ARE UNRESTRICTED    */
*/*        IN THIS SEGMENT EXCEPT WHERE NEEDED BY ADDITIONAL         */
*/*        SEGMENTS INCLUDED BY THE ADJUST SEGMENT                   */
*/* ******************************************************************/
*                                                                  0601
*       RT1TLPN=SRMADJST;           /* SET ADJUST LOGICAL PHASE      */
         MVI   RT1TLPN+16(R8),X'48'                                0601
*       IF R6^=NONE THEN            /* IF THERE ARE FRRS ON THE      */
         SLR   @12,@12                                             0602
         CR    R6,@12                                              0602
         BE    @RF00602                                            0602
*         DO;                       /* INTERRUPTED STACK DO FOLLOWING*/
*           IF R7^=ACTIVE THEN      /* IF RECURSION IS NOT ACTIVE    */
         C     R7,@CF00079                                         0604
         BE    @RF00604                                            0604
*             DO;                   /* DO THE FOLLWING               */
*               IF R8^=PSANSTK      /* IF THE CURRENT STAK IS        */
*                   &FRRSEMP=FRRSCURR THEN/* A SUPER STAK AND THE  0606
*                                      STAK INDICATES EMPTY THEN THE
*                                      SUPER FRR RECEIVED CONTROL    */
         C     R8,PSANSTK                                          0606
         BE    @RF00606                                            0606
         CLC   FRRSEMP(4,R8),FRRSCURR(R8)                          0606
         BNE   @RF00606                                            0606
*                 DO;                                              0607
*                   IF SDWARKEY='1'B&/* IF RESTART ERROR     @ZA10785*/
*                       SDWAPERC='0'B THEN/* AND SUPER FRR ONLY FRR
*                                      ON STACK THEN         @ZA10785*/
         TM    SDWARKEY(R5),B'00100000'                            0608
         BNO   @RF00608                                            0608
         TM    SDWAPERC(R5),B'00010000'                            0608
         BNZ   @RF00608                                            0608
*                     CVTRSTWD=NULL;/* CLEAR RESTART WORD    @ZA10785*/
         L     @11,CVTPTR                                          0609
         ST    @12,CVTRSTWD(,@11)                                  0609
*                   ELSE                                           0610
*                     ;             /*                       @ZA10785*/
@RF00608 DS    0H                                                  0611
*                   GENERATE CODE   /* MOVE THE SYSTEM MASK STORED ON
*                                      RETURN FROM THE FRR INTO THE
*                                      MASK BYTE POSITION OF SRMS REG
*                                      SAVE AREA ASSOCIATED WITH THE
*                                      CURRENTLY ACTIVE RTCA IN    0611
*                                      PREPARATION FOR THE SYSTEM  0611
*                                      STATE ADJUSTMENT WHICH WILL 0611
*                                      TAKE PLACE IN THE EXIT SEGMENT
*                                                            @YM02601*/
*                       ;                                          0611
         MVC   FIVE12+1(1,R5),FIVE12(R5) NULL RETRY MASK       @YM02601
*                   R0=RETRY;       /* THE FUNCTION IS ALWAYS RETRY  */
         SLR   R0,R0                                               0612
*                   FRRSRCUR=OFF;   /* AND THE IN USE FLAG IN THE FRR
*                                      ENTRY CAN BE ZEROED           */
         L     @01,FRRSCURR(,R8)                                   0613
         NI    FRRSRCUR(@01),B'01111111'                           0613
*                   R5=NULL;        /* INITIALIZE TO EXIT IEAVTRTS   */
         SLR   R5,R5                                               0614
*                 END;                                             0615
*               ELSE                /* OTHERWISE DO AS FOLLOWS       */
*                 DO;                                              0616
         B     @RC00606                                            0616
@RF00606 DS    0H                                                  0617
*                   RFY                                            0617
*                     FRRSENTR BASED(SRMTGFRR);                    0617
*                   IF SDWACLUP^=ON /* IF THE FRR JUST ROUTED TO     */
*                       |SDWARKEY=ON THEN/* IS NOT REQUIRED TO CLEAN
*                                      UP AND PERCOLATE OR THE ERROR
*                                      IS A RESTART ERROR THEN CHECK
*                                      RETURN CODE IN THE RTCA       */
*                                                                  0618
         TM    SDWACLUP(R5),B'10000000'                            0618
         BNO   @RT00618                                            0618
         TM    SDWARKEY(R5),B'00100000'                            0618
         BNO   @RF00618                                            0618
@RT00618 DS    0H                                                  0619
*                     /***********************************************/
*                     /*                                             */
*                     /* THIS SEGMENT CHECKS THE RETURN CODE IN THE  */
*                     /* RTCA SUPPLIED BY THE FRR JUST ROUTED TO AND */
*                     /* ESTABLISHES WHETHER RETRY OR RESUME CAN BE  */
*                     /* HONORED OR WHETHER PERCOLATION IS REQUIRED  */
*                     /* INPUT - TARGRTCA REGISTER(R5) POINTS TO THE */
*                     /* RTCA JUST PASSED TO THE FRR - FUNCTION      */
*                     /* REGISTER(R0) WILL BE USED TO INDICATE RETRY,*/
*                     /* RESUME, OR PERCOLATION OUTPUT - FUNCTION    */
*                     /* REGISTER(R0) IS SET INDICATING RETRY,RESUME */
*                     /* PERCOLATION NOTES - REGS(R2,R5,R6,R7,R8)    */
*                     /* MUST REMAIN UNCHANGED THROUGHOUT THIS       */
*                     /* SEGMENT - REGS(R1,R3,R4,                    */
*                     /* R11,R12,R13,R14,R15) ARE VOLATILE THROUGHOUT*/
*                     /* THIS SEGMENT                                */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0619
*                     DO;                                          0619
*                       IF SDWARKEY^=ON THEN/* IF THE ERROR TYPE IS
*                                      NOT A RESTART ERROR           */
         TM    SDWARKEY(R5),B'00100000'                            0620
         BO    @RF00620                                            0620
*                         IF SDWARCDE=SDWARETY/* BUT THE RETURN CODE */
*                             &SDWARTYA^=NULL THEN/* DOES INDICATE 0621
*                                      RETRY                         */
         CLI   SDWARCDE(R5),4                                      0621
         BNE   @RF00621                                            0621
         L     @12,SDWARTYA(,R5)                                   0621
         LTR   @12,@12                                             0621
         BZ    @RF00621                                            0621
*                           DO;                                    0622
*                             GENERATE CODE/* MOVE THE SYSTEM MASK 0623
*                                      STORED ON RETURN FROM THE FRR
*                                      INTO THE MASK BYTE POSITION OF
*                                      SRMS REG SAVE AREA ASSOCIATED
*                                      WITH THE CURRENTLY ACTIVE RTCA
*                                      IN PREPARATION FOR THE SYSTEM
*                                      STATE ADJUSTMENT WHICH WILL 0623
*                                      OCCUR IN EXIT SEGMT   @YM02601*/
*                                 ;                                0623
         MVC   FIVE12+1(1,R5),FIVE12(R5) NULL RETRY MASK       @YM02601
*                             R0=RETRY;/* FUNCTION IS RETRY          */
         SLR   R0,R0                                               0624
*                             FRRSRCUR=OFF;/* AND THE IN USE FLAG IN
*                                      THE FRR ENTRY CAN BE ZEROED   */
         L     @01,RT1WRTCA(,R8)                                   0625
         L     @01,SRMTGFRR+512(,@01)                              0625
         NI    FRRSRCUR(@01),B'01111111'                           0625
*                           END;                                   0626
*                         ELSE                                     0627
*                           R0=PERCLATE;/* OTHERWISE FUNCTION IS TO
*                                      PERCOLATE                     */
         B     @RC00621                                            0627
@RF00621 LA    R0,2                                                0627
*                       ELSE        /* OTHERWISE EXAMINE FOR RESUME  */
*                         IF SDWAPERC^=ON&/* IF THE RESTART ERROR HAS
*                                      ONLY BEEN PASSED TO THE FIRST
*                                      FRR                   @YA00800*/
*                             SDWAIO2=OFF&SDWAEXT2=OFF THEN/* AND THE
*                                      FRR GOT CONTROL PHYSICALLY  0628
*                                      DISABLED              @YA00800*/
         B     @RC00620                                            0628
@RF00620 TM    SDWAPERC(R5),B'00010000'                            0628
         BO    @RF00628                                            0628
         TM    SDWAIO2(R5),B'00000011'                             0628
         BNZ   @RF00628                                            0628
*                           DO;     /* CHECK TO SEE IF THE FRR CAN 0629
*                                      RECOVER FROM A VALID SPIN     */
*                             IF SDWASPIN=ON&/* IF THE SDWA SPIN BIT */
*                                 SDWACPUA^=NULL THEN/* AND A CPU  0630
*                                      ADDRESS IS SUPPLIED           */
         TM    SDWASPIN(R5),B'00100000'                            0630
         BNO   @RF00630                                            0630
         L     @12,SDWACPUA(,R5)                                   0630
         LTR   @12,@12                                             0630
         BZ    @RF00630                                            0630
*                               DO;                                0631
*                                 R0=RESUME;/* THEN THE FUNCTION IS
*                                      RESUME                        */
         SLR   R0,R0                                               0632
*                                 FRRSRCUR=OFF;/* AND THE IN FLAG IN
*                                      THE FRR ENTRY CAN BE ZEROED   */
         L     @01,RT1WRTCA(,R8)                                   0633
         L     @01,SRMTGFRR+512(,@01)                              0633
         NI    FRRSRCUR(@01),B'01111111'                           0633
*                               END;                               0634
*                             ELSE  /* OTHERWISE                     */
*                               DO; /*                       @YM08120*/
         B     @RC00630                                            0635
@RF00630 DS    0H                                                  0636
*                                 R0=PERCLATE;/* SET FUNCTION TO   0636
*                                      PERCOLATE                     */
         LA    R0,2                                                0636
*                                 CVTRSTWD=NULL;/* ZERO RESTART WORD
*                                                            @YM08120*/
         L     @12,CVTPTR                                          0637
         SLR   @11,@11                                             0637
         ST    @11,CVTRSTWD(,@12)                                  0637
*                               END;/*                       @YM08120*/
*                           END;                                   0639
*                         ELSE      /* IF THE RESTART ERROR HAS BEEN
*                                      PERCOLATED TO THE FRR THEN  0640
*                                      PERCOLATION IS STILL REQUIRED */
*                           R0=PERCLATE;/* INDICATE THAT PERCOLATION
*                                      IS TO BE PERFORMED            */
         B     @RC00628                                            0640
@RF00628 LA    R0,2                                                0640
*                     END;                                         0641
*                   ELSE            /* IF THE FRR JUST ROUTED TO IS A
*                                      NESTED FRR THEN INDICATE    0642
*                                      PERCOLATION                   */
*                     R0=PERCLATE;  /* SRM IS TO PERCOLATE           */
*                                                                  0642
         B     @RC00618                                            0642
@RF00618 LA    R0,2                                                0642
*                   /*************************************************/
*                   /*                                               */
*                   /* THIS SEGMENT PERFORMS THE FUNCTIONS OF        */
*                   /* HONORING THE FUNCTION INDICATION TO           */
*                   /* RETRY,RESUME, OR PERCOLATE,OF ADJUSTING RTCAS */
*                   /* TO CORRESPOND TO MODE CHANGES OCURRING FROM   */
*                   /* FREEING LOCKS AS REQUESTED BY THE FRR AND OF  */
*                   /* INSURING THAT THOSE LOCKS THAT ARE REQUESTED  */
*                   /* TO BE FREED ARE IN FACT VALID LOCK FREEING    */
*                   /* REQUESTS INPUT - FUNCTION REGISTER(R0)        */
*                   /* CONTAINING THE INDICATION WHETHER TO          */
*                   /* RETRY,RESUME,OR PERCOLATE - TARGRTCA          */
*                   /* REGISTER(R5) CONTAINS THE ADDRESS OF THE RTCA */
*                   /* - CURRSTK REGISTER(R8)POINTS TO THE           */
*                   /* INTERRUPTED STACK - SRMSTAK REGISTER(R2)      */
*                   /* POINTS TO SRMS RECOVERY STACK OUTPUT -        */
*                   /* TARGRTCA REGISTER(R5) IS ZERO IF RETRY OR     */
*                   /* RESUME IS TO BE HONORED - THE RTCA IS ALTERED */
*                   /* TO INDICATE PERCOLATION IF INVALID RETRY OR   */
*                   /* RESUME SPECIFICATIONS ARE MADE IN THE RTCA    */
*                   /* NOTES - THIS SEGMENT INCLUDES THE CHEKLOKS AND*/
*                   /* ADJUSTMR SEGMENTS WITH FURTHER INPUT          */
*                   /* REQUIREMENTS - REGS(R0,R2,R6,R7,R8)MUST REMAIN*/
*                   /* UNCHANGED THROUGHOUT THIS SEGMENT -           */
*                   /* REGS(R1,R3,R4, R11,R12,R13,R14,R15) ARE       */
*                   /* VOLATILE IN THIS SEGMENT                      */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0643
*                   IF R0=PERCLATE THEN/* IF RETRY IS NOT REQUESTED
*                                      AND RESUME NOT REQUESTED      */
@RC00618 C     R0,@CF00112                                         0643
         BNE   @RF00643                                            0643
*                     DO;           /* DO FOLLOWING                  */
*                       SDWARCDE=SDWACWT;/* INDICATE PERCOLATION AND
*                                      CONTINUE WITH TERMINATION     */
         MVI   SDWARCDE(R5),X'00'                                  0645
*                       SDWAPERC=ON;/* INDICATE PERCOLATION          */
         OI    SDWAPERC(R5),B'00010000'                            0646
*                       SDWARTYA=NULL;/* ZERO RETRY ADDRESS          */
         SLR   @12,@12                                             0647
         ST    @12,SDWARTYA(,R5)                                   0647
*                       SDWASPIN=OFF;/* TURN OF RESUME INDICATOR     */
         NI    SDWASPIN(R5),B'11011111'                            0648
*                       SDWACPUA=NULL;/* AND CPU ID                  */
         ST    @12,SDWACPUA(,R5)                                   0649
*/* ******************************************************************/
*/* THIS SEGMENT INSURES THAT THE LOCKS REQUESTED TO BE FREED BY THE */
*/* FRR AS INDICATED IN THE RTCA ARE AMONG THOSE HELD BY THE CPU ON  */
*/* ENTRY TO THE FRR.                                                */
*/* THIS VERIFICATION IS PERFORMED BY CALLING THE INTERNAL PROC      */
*/*  - LOCKVERF- WHICH RETURNS IN REG(R4) THE CURRENT LOCKS HELD BY  */
*/* THE CPU.                                                         */
*/*  REG(R4) IS - ANDED- WITH THE MASK IN THE RTCA INDICATING LOCKS  */
*/* TO BE FREEDED AND THE RESULT RESTORED INTO THE RTCA. ALL LOCKS   */
*/* REQUESTED TO BE FREED THAT ARE NOT OWNED ARE THUS NOOP IN THE    */
*/* RTCA AND THE REQUESTS WILL NOT BE HONORED                        */
*/* A FURTHER CHECK IS MADE TO INSURE THAT A VALID LOCK FREEING      */
*/* TO RELEASE THE LOCAL LOCK WILL NOT RESULT IN THE CMS LOCK STILL  */
*/* BEING HELD                                                       */
*/* THE INTERNAL PROCEDURE FRLOCKS IS INVOKED TO FREE ALL LOCKS      */
*/* ACQUIRED BY THE FRR OVER AN ABOVE THOSE HELD BY THE CPU ON ENTRY */
*/* TO THE FRR--THE LOCKVERF PROC-RETURNS THIS INFORMATION IN REG(R1)*/
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  -CURRSTK(R8) POINTS TO THE INTERRUPTED STACK CONTAINING THE FRR */
*/*    WHOSE REQUESTING TO FREE LOCKS                                */
*/*  - RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE FRR STACK */
*/*    POINTS TO THE RTCA CONTAINING THE LOCK FREEING REQUESTS       */
*/*  - THE SRM REG SAVE AREA CONTAINING CURRENT LOCKS HELD MASK      */
*/* OUTPUT FROM THIS SEGMENT IS AS FOLLOWS:                          */
*/*  - ADDITIONALLY ACQUIRED LOCKS BY THE FRR ARE FREED              */
*/*  - THE LOCKMASK IN THE SRM REG SAVE AREA CONTAINS R4 CONTENTS    */
*/*  - THE MASK IN THE RTCA CONTAINING LOCK FREEING REQUESTS IS      */
*/*    UPDATED TO REFLECT LOCKS TO FREE OF ONLY THOSE REMAINING      */
*/*    LOCKS HELD BY THE CPU AFTER ADDITIONALLY ACQUIRED LOCKS BY    */
*/*    THE FRR ARE FREED                                             */
*/* NOTES                                                            */
*/*  - REGS(R0,R1,R2,R3,R5,R6,R7,R8,R9,R10,R4) ARE RESTRICTED        */
*/*  REGS(   R11,R12,R13,R15) ARE VOLATILE                           */
*/*  -REG(R1) CONTAINS A MASK INDICATING LOCKS ADDITIONALLY          */
*/*   ACQUIRED BY THE FRR THAT MUST BE FREED                         */
*/*  - REG(R4) CONTAINS THE MASK INDICATING THE CURRENTLY HELD       */
*/*    LOCKS ON THE CPU                                              */
*/*  - REG(R14) WILL CONTAIN THE RETURN ADDRESS AFTER THE CALL       */
*/*    TO THE LOCKVERF PROC TO VERIFY CURRENTLY LOCKS HELD           */
*/*  - THE LOCKMASK IN THE SRM REG SAVE AREA ASSOCIATED WITH THE     */
*/*    RTCA PASSED TO THE FRR IS UPDATED WITH THE CURRENT LOCKS      */
*/*    HELD MASK OF THE CPU(CONTENTS OF REG4)                        */
*/* ******************************************************************/
*                                                                  0650
*                       DO;                                        0650
*                         RFY                                      0651
*                          (R4,                                    0651
*                           R3,                                    0651
*                           R11,                                   0651
*                           R1) RSTD;                              0651
*                         CALL LOCKVERF;/* VERF LOCKS OBTAINED AND 0652
*                                      RELEASED                      */
         BAL   @14,LOCKVERF                                        0652
*                         LOCKMASK=R4;/* STORE NEW LOCK MASK AS THE
*                                      RESULT OF TESTING THE LOCKS 0653
*                                      HELD ON ENTRY TO THE FRR THIS
*                                      NEW LOCKMASK REPRESENTS LOCKS
*                                      THAT WILL BE HELD AFTER THE 0653
*                                      NEWLY ACQUIRED LOCKS ARE FREED
*                                      AND THE LOCKS FREED BY THE FRR
*                                      ARE NEGATED FROM THE MASK     */
         L     @12,RT1WRTCA(,R8)                                   0653
         STH   R4,LOCKMASK+512(,@12)                               0653
*                         LKTOFREE=LKTOFREE&R4;/* UPDATE THE LOCKS 0654
*                                      REQUESTED TO BE FREED BASED ON
*                                      THE ABOVE TEST OF THE LOCKS 0654
*                                      HELD                          */
         LH    @12,LKTOFREE(,R5)                                   0654
         N     @12,@CF03531                                        0654
         NR    @12,R4                                              0654
         STH   @12,LKTOFREE(,R5)                                   0654
*                         R3=R4&CMSLOCLK;/* INSURE THAT IF THE LOCAL
*                                      LOCK IS TO BE FREED THAT THE
*                                      CMS WILL NOT STILL BE HELD    */
         LA    @12,3                                               0655
         LR    R3,R4                                               0655
         NR    R3,@12                                              0655
*                         IF R3=CMSLOCLK THEN/* IF THE CMS AND LOCAL
*                                      LOCKS ARE HELD CHECK THAT   0656
*                                      EITHER BOTH LOCKS WILL STILL
*                                      BE HELD OR THAT BOTH LOCKS ARE
*                                      REQUESTED TO BE FREED         */
         CR    R3,@12                                              0656
         BNE   @RF00656                                            0656
*                           IF SDWAFLLK=ON/* IF THE LOCAL LOCK IS TO
*                                      BE                            */
*                               &SDWACMS=OFF THEN/* AND THE CMS LOCK
*                                      IS NOT REQUESTED TO BE FREED
*                                      THEN INDICATE TO FREE THE CMS
*                                      LOCK ALSO                     */
         TM    SDWAFLLK(R5),B'00000001'                            0657
         BNO   @RF00657                                            0657
         TM    SDWACMS(R5),B'00000010'                             0657
         BNZ   @RF00657                                            0657
*                             SDWACMS=ON;                          0658
         OI    SDWACMS(R5),B'00000010'                             0658
*                           ELSE                                   0659
*                             ;     /* IF EITHER THE LOCAL AND CMS 0659
*                                      LOCKS ARE NOT TO BE FREED OR
*                                      THE CMS LOCK WILL NOT BE HELD
*                                      WHEN THE LOCAL LOCK IS FREE 0659
*                                      THE FREE LOCK REQUEST OF THE
*                                      FRR IS VALID                  */
@RF00657 DS    0H                                                  0660
*                         ELSE                                     0660
*                           ;       /* IF THE CMS AND LOCAL LOCKS ARE
*                                      NOT HELD THE FREE LOCK REQUEST
*                                      BY THE FRR IS ASSUMED TO BE 0660
*                                      VALID                         */
@RF00656 DS    0H                                                  0661
*                         RFY                                      0661
*                          (R4,                                    0661
*                           R3,                                    0661
*                           R11) UNRSTD;                           0661
*                         CALL FRLOCKS;/* FREE THOSE LOCKS         0662
*                                      ADDITIONALLY ACQUIRED BY THE
*                                      FRR THAT WERE NOT OWNED ON  0662
*                                      ENTRY TO THE FRR              */
         BAL   @14,FRLOCKS                                         0662
*                         RFY                                      0663
*                           R1 UNRSTD;                             0663
*                       END;                                       0664
*                                                                  0664
*                       /*********************************************/
*                       /*                                           */
*                       /* THIS SEGMENT DETERMINES WHETHER A SYSTEM  */
*                       /* MODE CHANGE WILL TAKE PLACE WHEN THE LOCKS*/
*                       /* TO BE FREED AS INDICATED IN THE RTCA ARE  */
*                       /* FREED AND ADJUSTS THE CONTENTS OF THE     */
*                       /* CURRENTLY ACTIVE RTCA TO COINCIDE WITH THE*/
*                       /* PENDING LEVEL OF SERIALI- ZATION RESULTING*/
*                       /* FROM THE EVENTUAL LOCK FREEING THREE MODE */
*                       /* CHANGES ARE POSSIBLE 1.GLOBAL             */
*                       /* MODE-TO-LOCAL MODE IS DETERMINED IF THE   */
*                       /* FOLLOWOING CONDITIONS ARE PRESENT ON ENTRY*/
*                       /* .THE CPU IS NOT IN SUPERVISOR CONTROL MODE*/
*                       /* .WHEN THE FREEING OF LOCKS TAKES PLACE NO */
*                       /* GLOBAL SPIN- TYPE LOCKS WILL REMAIN HELD. */
*                       /* ONLY THE CMS AND LOCAL OR JUST LOCAL LOCK */
*                       /* WILL STILL BE HELD 2.GLOBAL MODE-TO-SRB   */
*                       /* MODE IS DETERMINED IF THE FOLLOWING       */
*                       /* CONDITIONS ARE PRESENT ON ENTRY .THE CPU  */
*                       /* IS NOT IN SUPERVISOR CONTROL MODE .AT     */
*                       /* LEAST ONE GLOBAL SPIN-TYPE LOCK IS HELD BY*/
*                       /* THE CPU .NO LOCKS WILL REMAIN HELD AFTER  */
*                       /* THE REQUESTED LOCKS ARE FREED PROVIDED    */
*                       /* THAT SRM HAS NOT ITSELF ACQUIRED THE LOCAL*/
*                       /* LOCK IN WHICH CASE A GLOBAL-TO-LOCAL MODE */
*                       /* CHANGE IS REQUIRED 3.LOCAL MODE-TO-SRB    */
*                       /* MODE IS DETERMINED IF THE FOLLOWING       */
*                       /* CONDITIONS ARE PRESENT ON ENTRY .THE CPU  */
*                       /* WAS NOT PHYSICALLY DISABLED OR IN         */
*                       /* SUPERVISOR CONTROL MODE AT THE TIME OF THE*/
*                       /* ERROR .THE CMS AND LOCAL LOCKS WILL NOT BE*/
*                       /* HELD BY THE CPU AFTER THE REQUESTED       */
*                       /* FREEING OF LOCKS TAKES PLACE .THE CMS AND */
*                       /* LOCAL LOCKS OR JUST THE LOCAL LOCK ARE THE*/
*                       /* ONLY LOCKS HELD ON ENTRY .SRM DOES NOT OWN*/
*                       /* THE LOCAL LOCK. IF SO NO MODE CHANGE IS   */
*                       /* PERFORMED A CHANGE OF MODES WILL NOT OCCUR*/
*                       /* IF ONE OF THE FOLLOWING CONDITIONS EXIST  */
*                       /* .NO LOCKS ARE REQUESTED TO BE FREED IN THE*/
*                       /* RTCA .GLOBAL SPIN LOCKS ARE HELD ON ENTRY */
*                       /* BUT NOT ALL OF THE HELD GLOBAL SPIN LOCKS */
*                       /* ARE REQUESTED TO BE FREED .THE CMS AND    */
*                       /* LOCAL LOCKS ARE THE ONLY LOCKS HELD ON    */
*                       /* ENTRY AND ONLY THE CMS LOCK IS REQUESTED  */
*                       /* TO BE FREED .THE LOCAL LOCK(AND POSSIBLY  */
*                       /* THE CMS LOCK) IS HLED ON ENTRY BUT SRM IS */
*                       /* THE OWNER OF THE LOCAL LOCK. THE LOCAL    */
*                       /* MODE WILL BE RETAINED INPUT CONDITIONS    */
*                       /* .TARGRTCA(R5)-POINTS TO THE ACTIVE RTCA   */
*                       /* .SDWAACF3,SDWAACF4, FIELDS OF THE ACTIVE  */
*                       /* RTCA INDICATE THOSE LOCKS TO BE FREED     */
*                       /* .RT1WSRMD,RT1TLOC FIELDS OF THE RTM1 WORK */
*                       /* AREA PORTION OF THE INTERRUPTED STACK     */
*                       /* INDICATE THE MODE OF THE CPU AT TIME OF   */
*                       /* ERROR AND WHETHER SRM OWNS THE LOCAL LOCK */
*                       /* .ASXBFRWA-POINTS TO THE LOCAL RTCA - THE  */
*                       /* LOCKMASK INDICATING LOCKS HELD ON ENTRY TO*/
*                       /* THE FRR IS LOCATED IN THE RTM1 WORK AREA  */
*                       /* PROTION OF THE INTERRUPTED STACK OUTPUT   */
*                       /* CONDITIONS .GLOBAL-TO-LOCAL MODE--THE     */
*                       /* CONTENTS OF THE BLOCAL RTCA ARE MOVED IN  */
*                       /* TOTAL TO THE LOCAL RTCA. TARGRTCA(R2)     */
*                       /* POINTS TO THE LOCAL RTCA.RT1WMODE FIELD OF*/
*                       /* THE RTM1 WORK AREA PORTION OF THE         */
*                       /* INTERRUPTED STACK INDICATES LOCAL MODE    */
*                       /* .GLOBAL-TO-SRB MODE--THE CONTENTS OF THE  */
*                       /* GLOBAL RTCA IS MOVED IN TOTAL TO THE      */
*                       /* ACQUIRED SRB RTCA,THE SDWALNTH AND        */
*                       /* SDWASPID FIELDS OF THE SRB RTCA ARE SET TO*/
*                       /* THE LENGTH (584 BYTES) AND SUBPOOL ID(245)*/
*                       /* OF THE ACQUIRED SRB RTCA TARGRTCA(R5)     */
*                       /* POINTS TO THE ACQUIRED SRB RTCA AND       */
*                       /* RT1WMODE IS SET TO INDICATE SRB MODE. IF  */
*                       /* THE RTCA COULD NOT BE ACQUIRED BECAUSE OF */
*                       /* A LACK OF SQA(245) THE LOCAL RTCA WILL BE */
*                       /* USED IN PLACE OF THE SRB RTCA. THE OUTPUT */
*                       /* IN THIS CASE IS IDENTICAL TO THAT OF A    */
*                       /* GLOBAL-TO-LOCAL MODE TRANSFER(SEE ABOVE)  */
*                       /* .LOCAL-TO-SRB MODE--THE CONTENTS OF THE   */
*                       /* LOCAL RTCA IS MOVED IN TOTAL TO THE       */
*                       /* ACQUIRED SRB RTCA,THE SDWALNTH AND        */
*                       /* SDWASPID FIELD OF THE ACQUIRED RTCA       */
*                       /* INITIALIZED WITH THE WITH THE LENGTH(584) */
*                       /* AND SUBPOOL ID (245) OF THE ACQUIRED SRB  */
*                       /* RTCA. IF SQA(245) WAS UNAVAILABLE AND THE */
*                       /* RTCA COULD NOT BE OBTAINED THEN THE LOCAL */
*                       /* RTCA WILL BE CONTINUED TO BE USED, THE    */
*                       /* MODE REMAINING THE SAME .NO MODE CHANGE - */
*                       /* TARGRTCA(R5) REMAINS UNCHANGED FROM ITS   */
*                       /* INPUT STATE AND MODE(RT1WSRMD) REMAIN     */
*                       /* UNCHANGED                                 */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0665
*                       RFY                                        0665
*                        (R3,                                      0665
*                         R15) RSTD;                               0665
*                       R3=LKTOFREE&&LOCKMASK;/* ISOLATE THOSE LOCKS
*                                      THAT WILL STILL BE HELD AFTER
*                                      THE EVENTUAL LOCK FREE REQUEST
*                                      BY THE FRR IS HONORED         */
         L     @01,RT1WRTCA(,R8)                                   0666
         LH    R3,LOCKMASK+512(,@01)                               0666
         N     R3,@CF03531                                         0666
         LH    @14,LKTOFREE(,R5)                                   0666
         N     @14,@CF03531                                        0666
         XR    R3,@14                                              0666
*                       RFY                                        0667
*                         R1 RSTD;                                 0667
*                       GENERATE CODE;                             0668
*                                      /*CHECK FOR HOLDING SPIN LOCKS*/
         SETLOCK TEST,TYPE=SPIN,REGS=(R1)
*                       RFY                                        0669
*                         R1 UNRSTD;                               0669
*                       IF PSASUPER=NULL/* IF THERE ARE NO SUPER BITS
*                                      ON THAT INDICATE SUPERVISOR 0670
*                                      CONTROL MODE--DISABLED        */
*                           &R8=PSANSTK THEN/* AND THE INTERRUPTED 0670
*                                      STACK IS NOT A SUPER STACK  0670
*                                      WHICH IMPLIES DISABLEDMENT  0670
*                                      THEN                          */
         SLR   @14,@14                                             0670
         CL    @14,PSASUPER                                        0670
         BNE   @RF00670                                            0670
         C     R8,PSANSTK                                          0670
         BNE   @RF00670                                            0670
*                         IF R15=NULL THEN/* CHECK TO SE IF GLOBAL 0671
*                                      SPIN LOCKS ARE HELD--IMPLYING
*                                      DISABLEMENT                   */
         CR    R15,@14                                             0671
         BNE   @RF00671                                            0671
*                           IF R3=NULL THEN/* IF GLOBAL SPIN LOCKS 0672
*                                      ARE HELD AND THE REQUESTED  0672
*                                      FREEING OF LOCKS WILL RESULT
*                                      IN NO LOCKS HELD BY THE CPU 0672
*                                      THEN THE TRANSITION OF MODES
*                                      WILL BE FROM GLOBALLY LOCKED
*                                      MODE TO SRB MODE PROVIDED THAT
*                                      SRB MODE WAS ACTIVE AT THE  0672
*                                      TIME OF THE ERROR             */
         CR    R3,@14                                              0672
         BNE   @RF00672                                            0672
*                             IF MODESRB=ON THEN/* IF SRB MODE WAS 0673
*                                      ACTIVE AT THE TIME OF THE   0673
*                                      ERROR THEN GLOBAL TO SRB MODE
*                                      WILL TAKE PLACE               */
         TM    MODESRB+81(R8),B'00000010'                          0673
         BNO   @RF00673                                            0673
*                               CALL XGTOS;/* TRANSFER FROM GLOBAL 0674
*                                      MODE TO SRB MODE              */
         BAL   @14,XGTOS                                           0674
*                             ELSE  /* IF SRB MODE IS NOT ACTIVE AND
*                                      NO LOCKS WILL BE HELD AFTER 0675
*                                      THE REQUESTED FREEING OF LOCKS
*                                      THEN THE LOCK FREEING REQUEST
*                                      WILL BE IGNORED TO AVOID SRM
*                                      ENTERING TASK MODE            */
*                               LKTOFREE=HWRDZERO;/* INDICATE IN THE
*                                      RTCA THAT NO LOCKS ARE TO BE
*                                      FREED                         */
         B     @RC00673                                            0675
@RF00673 MVC   LKTOFREE(2,R5),@CB03189                             0675
*                           ELSE    /* IF LOCKS WILL STILL BE HELD 0676
*                                      AFTER SRM FREES THE REQUESTED
*                                      LOCKS THEN IT MUST BE       0676
*                                      DETERMINED IF WHETHER LOCAL 0676
*                                      MODE WILL REMAIN OR WHETHER NO
*                                      MODE CHANGE FROM THE GLOBAL 0676
*                                      SPIN LOCK MODE WILL OCCUR     */
*                             IF R3=LOCALLOK/* IF THE LOCAL LOCK OR
*                                      LOCAL AND CMS LOCK            */
*                                 |R3=CMSLOCLK/* WILL BE THE ONLY  0676
*                                      LOCKS HELD                    */
*                               THEN/* AFTER THE REQUESTED FREEING OF
*                                      LOCKS THEN THE MODE TRANSITION
*                                      IS FROM GLOBAL SPIN LOCK MODE
*                                      TO LOCALLY LOCKED MODE        */
         B     @RC00672                                            0676
@RF00672 C     R3,@CF03196                                         0676
         BE    @RT00676                                            0676
         C     R3,@CF03178                                         0676
         BNE   @RF00676                                            0676
@RT00676 DS    0H                                                  0677
*                               CALL XGTOL;/* TRANSFER FROM GLOBAL 0677
*                                      MODE TO LOCAL MODE            */
         BAL   @14,XGTOL                                           0677
*                             ELSE                                 0678
*                               ;   /* IF THERE WILL STILL BE GLOBAL
*                                      SPIN LOCKS HELD AFTER THE   0678
*                                      REQUESTED FREEING OF THE LOCKS
*                                      INDICATED BY THE FRR THEN NO
*                                      MODE CHANGE WILL OCCUR AND  0678
*                                      GLOBAL SPIN LOCKED MODE WILL
*                                      REMAIN IN EFFECT              */
@RF00676 DS    0H                                                  0679
*                         ELSE      /* IF NO GLOBAL SPIN LOCKS ARE 0679
*                                      HELD AND SUPER MODE IS NOT  0679
*                                      ACTIVE AND THE INTERRUPTED IS
*                                      THE NORMAL FRR STACK THEN   0679
*                                      EITHER THE SYSTEM IS IN LOCAL
*                                      MODE OR IS DISABLED WITH NO 0679
*                                      GLOBAL SPIN LOCKS HELD(SHOULD
*                                      NOT OCCURR) OR IS IN STRICTLY
*                                      SRB MODE THEN                 */
*                           IF MODEDIS=ON THEN/* IN THIS CASE IF THE
*                                      MODE AT THE TIME OF THE ERROR
*                                      INDICATES DISABLEMENT THEN  0679
*                                      EITHER SUPER MODE WAS LEFT OR
*                                      OR A FRR RUNNING DISABLED WITH
*                                      NO LOCKS HELD IS REQUESTING 0679
*                                      PERCOLATION                   */
         B     @RC00671                                            0679
@RF00671 LA    @14,81                                              0679
         ALR   @14,R8                                              0679
         TM    MODEDIS(@14),B'01000000'                            0679
         BNO   @RF00679                                            0679
*                             IF R3=NULL THEN/* IF NO LOCKS WILL BE
*                                      HELD AFTER THE REQUESTED    0680
*                                      FREEING OF LOCKS TAKES PLACE
*                                      THEN                          */
         LTR   R3,R3                                               0680
         BNZ   @RF00680                                            0680
*                               IF MODESRB=ON THEN/* IF SRB MODE WAS
*                                      ACTIVE AT THE TIME OF THE   0681
*                                      ERROR TRANSITION OF GLOBAL  0681
*                                      MODE TO SRB MODE WILL TAKE  0681
*                                      PLACE                         */
         TM    MODESRB(@14),B'00000010'                            0681
         BNO   @RF00681                                            0681
*                                 CALL XGTOS;/* GO FROM GLOBAL TO SRB
*                                      MODE                          */
         BAL   @14,XGTOS                                           0682
*                               ELSE/* IF SRB MODE IS NOT ACTIVE AT
*                                      THE TIME OF THE ERROR SRM WILL
*                                      ENTER TASK MODE WHEN THE    0683
*                                      REQUESTED LOCKS ARE FREED-- 0683
*                                      THE LOCK FREEING REQUEST IS 0683
*                                      NEGATED                       */
*                                 LKTOFREE=HWRDZERO;/* NEGATE FREEING
*                                      OF LOCKS                      */
         B     @RC00681                                            0683
@RF00681 MVC   LKTOFREE(2,R5),@CB03189                             0683
*                             ELSE  /* IF LOCKS WILL STILL BE HELD 0684
*                                      AFTER THE REQUESTED LOCKS ARE
*                                      FREED THEN SINCE NO GLOBAL  0684
*                                      SPIN LOCKS ARE HELD THE LOCKS
*                                      STILL HELD MUST BE AT LEAST 0684
*                                      THE LOCAL LOCK HENCE A CHANGE
*                                      FROM GLOBAL MODE TO LOCAL MODE
*                                      IS VALID                      */
*                               CALL XGTOL;/* GO FROM GLOBAL TO LOCAL
*                                      MODE                          */
         B     @RC00680                                            0684
@RF00680 BAL   @14,XGTOL                                           0684
*                           ELSE    /* IF A EXIT FROM SUPER MODE HAS
*                                      NOT TAKEN PLACE AND THE FRR 0685
*                                      REQUESTING PERCOLATION IS NOT
*                                      RUNNING DISABLED HOLDING NO 0685
*                                      LOCKS THEN THE MODE MUST BE 0685
*                                      LOCALLY LOCKED OR STRICTLY SRB
*                                      MODE A TRANSITION FROM LOCALLY
*                                      LOCKED MODE TO SRB MODE IS  0685
*                                      POSSIBLE OR NO              0685
*                                      TRANSITION(MAINTAINING SRB  0685
*                                      MODE) IS POSSIBLE             */
*                             IF R3=NULL/* IF NO LOCKS WILL BE HELD
*                                      AFTER THE REQUESTED LOCKS ARE
*                                      FREED                         */
*                                 &RT1TLOCL^=ON/* AND THE SRM DID NOT
*                                      ACQUIRE THE LOCAL LOCK WHICH
*                                      IS HELD                       */
*                                 &LOCKMASK^=HWRDZERO/* AS INDICATED
*                                      BY THE LOCKMASK               */
*                                 &MODESRB=ON THEN/* AND SRB MODE IS
*                                      ACTIVE AT THE TIME OF THE   0685
*                                      ERROR THEN                    */
         B     @RC00679                                            0685
@RF00679 LTR   R3,R3                                               0685
         BNZ   @RF00685                                            0685
         TM    RT1TLOCL(R8),B'00100000'                            0685
         BO    @RF00685                                            0685
         L     @01,RT1WRTCA(,R8)                                   0685
         CLC   LOCKMASK+512(2,@01),@CB03189                        0685
         BE    @RF00685                                            0685
         TM    MODESRB+81(R8),B'00000010'                          0685
         BNO   @RF00685                                            0685
*                               CALL XLTOS;/* GO FROM LOCAL MODE TO
*                                      SRB MODE                      */
         BAL   @14,XLTOS                                           0686
*                             ELSE  /* IF THE LOCAL LOCK WILL STILL
*                                      BE HELD AFTER THE REQUESTED 0687
*                                      LOCKS ARE FREED OR IF SRM   0687
*                                      ACQUIRED THE LOCAL LOCK TO  0687
*                                      SUPPORT AN SRB ERROR OR IF SRB
*                                      MODE WAS NOT ACTIVE AT THE  0687
*                                      TIME OF THE ERROR OR IF NO  0687
*                                      LOCKS ARE HELD AND SRB MODE IS
*                                      ACTIVE THEN THE LOCK FREEING
*                                      REQUEST WILL DENIED(MODE WILL
*                                      NOT CHANGE)                   */
*                               LKTOFREE=HWRDZERO;/* NEGATE THE LOCK
*                                      FREEING REQUEST(NO MODE     0687
*                                      CHANGE)                       */
         B     @RC00685                                            0687
@RF00685 MVC   LKTOFREE(2,R5),@CB03189                             0687
*                       ELSE                                       0688
*                         ;         /* IF THE SYSTEM IS IN SUPER MODE
*                                      OR THE INTERRUPTED STACK IS A
*                                      SUPER STACK PERCOLATION WILL
*                                      BE IN THE SAME MODE AS EXISTED
*                                      FOR THE FRR REQUESTING      0688
*                                      PERCOLATION                   */
@RF00670 DS    0H                                                  0689
*                       RFY                                        0689
*                        (R3,                                      0689
*                         R15) UNRSTD;                             0689
@RC00670 DS    0H                                                  0690
*                     END;                                         0690
*                   ELSE            /* OTHERWISE INDICATE RETRY OR 0691
*                                      RESUME                        */
*                     DO;                                          0691
         B     @RC00643                                            0691
@RF00643 DS    0H                                                  0692
*                       R5=NULL;                                   0692
         SLR   R5,R5                                               0692
*                     END;                                         0693
*                 END;                                             0694
*             END;                                                 0695
*           ELSE                    /* IF RECURSION IS ACTIVE THEN 0696
*                                      PERCOLATION IS ASSUMED        */
*             DO;                   /* INDICATE IN THE RTCA THAT   0696
*                                      PERCOLATION IS NECESSARY      */
         B     @RC00604                                            0696
@RF00604 DS    0H                                                  0697
*               R0=PERCLATE;        /* SRM WILL PERFORM PERCOLATION  */
         LA    R0,2                                                0697
*               SDWARCDE=SDWACWT;   /* INDICATE PERCOLATION AND    0698
*                                      CONTINUE WITH TERMINATION     */
         MVI   SDWARCDE(R5),X'00'                                  0698
*               SDWARTYA=NULL;      /* WITH NO RETRY ADDRESS         */
         SLR   @12,@12                                             0699
         ST    @12,SDWARTYA(,R5)                                   0699
*               SDWASPIN=OFF;       /* WITH NO VALID SPIN EXISTING   */
         NI    SDWASPIN(R5),B'11011111'                            0700
*               SDWACPUA=NULL;      /* WITH NO VALID CPU TO SIGP     */
         ST    @12,SDWACPUA(,R5)                                   0701
*             END;                                                 0702
*                                                                  0702
*/* ******************************************************************/
*/* THIS SEGMENT PERFORMS THE FOLLOWING FUNCTIONS NECESSARY          */
*/* TO HONOR THE LOCK FREEING REQUESTS BY FRRS AND TO VALIDATE       */
*/* THOSE LOCKS ADDITIONALLY ACQUIRED BY THE FRR AND TO INSURE THAT  */
*/* SUCH ADDITIONALLY ACQUIRED LOCKS ARE ALSO FREED.                 */
*/*  1. FREE LOCKS REQUESTED BY A FRR WHEN THE LOCKS REQUESTED TO    */
*/*     BE FREED ARE AMONG THOSE HELD PRIOR TO THE FRR GETTING       */
*/*     CONTROL WHERE THE FRR FAILED BEFORE RETURNING TO SRM         */
*/*  2. FREE LOCKS REQUESTED BY A FRR WHEN THE LOCKS REQUESTED TO    */
*/*     BE FREED ARE AMONG THOSE HELD PRIOR TO THE FRR GETTING       */
*/*     CONTROL WHERE THE FRR FAILED BEFORE RETURNING TO SRM         */
*/*  3. SAVES THE ERROR INFORMATION AT THE TIME OF THE FRR FAILURE   */
*/*     IF THE LAST FRR GIVEN CONTROL FAILED                         */
*/* ******************************************************************/
*                                                                  0703
*           DO;                                                    0703
@RC00604 DS    0H                                                  0704
*             IF R7=ACTIVE THEN     /* IF SRM IS IN RECURSION MODE 0704
*                                      THEN NO LOCKS WILL BE FREED,
*                                      PROVIDED NO NESTED FRRS ARE ON
*                                      THE INTERRUPTED STACK LOCK  0704
*                                      REQUESTS IN THE RTCA WILL BE
*                                      CARRIED OVER IN THE RTCA THAT
*                                      WILL BE USED TO PROCESS THE 0704
*                                      RECURSIVE ERROR               */
         C     R7,@CF00079                                         0704
         BNE   @RF00704                                            0704
*               DO;                                                0705
*                                                                  0705
*                 /***************************************************/
*                 /*                                                 */
*                 /* THIS SEGMENT MARKS ALL FRR ENTRIES ON THE       */
*                 /* INTERRUPTED STACK WHICH REPRESENT NESTED FRRS.  */
*                 /* THE FRR ENTRIES THAT ARE CANDIDATES FOR MARKING */
*                 /* IN THIS MANNER ARE ALL THOSE THAT EXIST BETWEEN */
*                 /* AND INCLUDING THE CURRENT FRR ENTRY AND THE THE */
*                 /* FRR ENTRY ADRRES SAVED PRIOR TO ROUTING TO THE  */
*                 /* FRR ALL FRR ENTRIES DEFINING FRRS WHICH FALL IN */
*                 /* THIS RANGE WERE ESTABLISHED AFTER SRM ROUTED TO */
*                 /* THE ORIGINAL FRR INPUT - CURRSTK REGISTER(R8)   */
*                 /* POINTS TO THE INTERRUPTED FRR STACK - RT1WRTCA  */
*                 /* FIELD OF THE RTM1 WORK AREA PORTION OF THE      */
*                 /* INTERRUPTED STACK POINTS TO THE ACTIVE RTCA     */
*                 /* PASSED TO THE FRR - SRMTGFRR FIELD IN THE SRM   */
*                 /* REGISTER SAVE AREA ASSOCIATED WITH THE RTCA     */
*                 /* PASSED TO THE FRR CONTAINS THE ADDRESS OF THE   */
*                 /* FRR ENTRY CONTAINING THE FRR ADDRESS OF THE FRR */
*                 /* GIVEN CONTROL - WORKREG REGISTER(R4) USED AS A  */
*                 /* WORK REGISTER OUTPUT - THE FRRSNEST FLAG IN EACH*/
*                 /* NESTED FRR ENTRY IS TURNED ON NOTES -           */
*                 /* REGS(R0,R2,R5,R6,R7,R8)MUST REMAIN UNCHANGED    */
*                 /* THROUGHOUT THIS SEGMENT - REGISTER R4 IS USED AS*/
*                 /* A WORK REGISTER -                               */
*                 /* REGISTERS(R3,R9,R11,R12,R13,R14,R15) ARE        */
*                 /* VOLATILE THROUGHOUT THIS SEGMENT                */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0706
*                 IF FRRSCURR>SRMTGFRR THEN/* IF THE CURRENT FRR   0706
*                                      ENTRY ON THE INTERRUPTED STACK
*                                      HAS AN ADDRESS GREATER THAN 0706
*                                      THE FRR ENTRY ADDRESS OF THE
*                                      LAST FRR TO GET CONTROL THEN
*                                      THE INTERRUPTED STACK HAS AT
*                                      LEAST ONE NESTED FRR          */
         L     @12,FRRSCURR(,R8)                                   0706
         L     @01,RT1WRTCA(,R8)                                   0706
         C     @12,SRMTGFRR+512(,@01)                              0706
         BNH   @RF00706                                            0706
*                   DO;             /* LOOP THRU ALL ENTRIES IN THE
*                                      INTERRUPTED STACK BEGINNING 0707
*                                      WITH THE CURRENT AND UNTIL THE
*                                      FRR ENTRY OF THE LAST FRR TO
*                                      GET CONTROL IS FOUND          */
*                     RFY                                          0708
*                       R4 RSTD;    /* RESTRICT A WORK REG           */
*                     R4=FRRSCURR;  /* INITIALIZE THE LOOP WITH THE
*                                      ADDRESS OF THE CURRENT FRR  0709
*                                      ENTRY                         */
         LR    R4,@12                                              0709
*                     RFY                                          0710
*                       FRRSENTR BASED(R4);                        0710
*                     DO WHILE R4^=SRMTGFRR;/* LOOP UNTIL THE FRR  0711
*                                      ENTRY OF THE LAST FRR TO GET
*                                      CONTROL IS FOUND              */
         B     @DE00711                                            0711
@DL00711 DS    0H                                                  0712
*                       FRRSNEST=ON;/* FOR EACH FRR ENTRY SCANNED IN
*                                      THIS MANNER INDICATE IN THE 0712
*                                      ENTRY THAT IT CORRESPONDS TO A
*                                      NESTED FRR                    */
         OI    FRRSNEST(R4),B'01000000'                            0712
*                       R4=R4-FRRSESZE;/* DECREMENT TO NEXT FRR ENTRY*/
         SL    R4,@CF00122                                         0713
*                     END;                                         0714
@DE00711 L     @01,RT1WRTCA(,R8)                                   0714
         C     R4,SRMTGFRR+512(,@01)                               0714
         BNE   @DL00711                                            0714
*                     RFY                                          0715
*                       FRRSENTR BASED(FRRSCURR);                  0715
*                     RFY                                          0716
*                       R4 UNRSTD;  /* RELEASE THE WORK REG          */
*                   END;                                           0717
*                 ELSE                                             0718
*                   ;               /* IF THERE ARE NO NESTED FRRS ON
*                                      THE INTERRUPTED STACK THE   0718
*                                      MARKING AS SUCH OF THE FRR  0718
*                                      ENTRIES IS NOT NECESSARY      */
@RF00706 DS    0H                                                  0719
*                 IF FRRSNEST^=ON THEN/* IF THERE ARE NO NESTED FRRS
*                                      ON THE INTERRUPTED STACK THEN
*                                      LOCKS INDICATED IN THE RTCA 0719
*                                      CAN BE FREED AND PERCOLATION
*                                      CAN BE PERFORMED              */
         L     @01,FRRSCURR(,R8)                                   0719
         TM    FRRSNEST(@01),B'01000000'                           0719
         BO    @RF00719                                            0719
*                   DO;                                            0720
*                     SDWAPERC=ON;  /* INDICATE IN THE RTCA THAT THE
*                                      FRR TO NEXT GET CONTROL WILL
*                                      BE PERCOLATED TO              */
         OI    SDWAPERC(R5),B'00010000'                            0721
*                     RFY                                          0722
*                       R1 RSTD;                                   0722
*                     RFY                                          0723
*                      (R4,                                        0723
*                       R3,                                        0723
*                       R11) RSTD;                                 0723
*                     CALL LOCKVERF;/* VERIFY THAT THE FRR CAUSING 0724
*                                      RECURSION DID NOT OBTAIN ANY
*                                      NEW LOCKS PRIOR TO ITS FAILURE*/
         BAL   @14,LOCKVERF                                        0724
*                     R3=LKTOFREE;                                 0725
         LH    R3,LKTOFREE(,R5)                                    0725
         N     R3,@CF03531                                         0725
*                     R1=R1|R3;     /* REG1 NOW CONTAINS THE BIT   0726
*                                      SETTINGS INDICATING NOT ONLY
*                                      LOCKS TO FREE IN THE RTCA BUT
*                                      ALSO THOSE LOCKS THAT WERE  0726
*                                      ACQUIRED BY THE FRR CAUSING 0726
*                                      THE RECURSIVE ERROR INTO SRM  */
         OR    R1,R3                                               0726
*                     RFY                                          0727
*                      (R4,                                        0727
*                       R3,                                        0727
*                       R11) UNRSTD;                               0727
*                     CALL FRLOCKS; /* GO FREE LOCKS REQUESTED IN THE
*                                      RTCA                          */
         BAL   @14,FRLOCKS                                         0728
*                     RFY                                          0729
*                       R1 UNRSTD;                                 0729
*                   END;                                           0730
*                 ELSE                                             0731
*                   ;               /* IF A NESTED FRR EXISTS ON THE
*                                      INTERRUPTED STACK THEN LOCKS
*                                      WILL NOT BE FREED AND THE NEXT
*                                      FRR TO GET CONTROL WILL     0731
*                                      INHIBITED FROM RETRYING       */
*                                                                  0731
@RF00719 DS    0H                                                  0732
*                 /***************************************************/
*                 /*                                                 */
*                 /* WHEN RECURSION IS IN EFFECT THIS SEGMENT        */
*                 /* PERFORMS THE FUNCTION OF SAVING THE RTCA PASSED */
*                 /* TO THE FRR THAT FAILED SO THE LOCKS TO FREE     */
*                 /* REQUEST FLAGS(SDWAACF3,SDWAACF4),LOCKWORDS      */
*                 /* (SDWALKWA),CLEANUP AND PERCOLATE FLAG(SDWACLUP),*/
*                 /* AND PERCOLATION FLAG(SDWAPERC) CAN BE CARRIED   */
*                 /* OVER TO THE NEW RTCA WHICH WILL BE USED TO      */
*                 /* PROCESS THE RECURSIVE ERROR INPUT - RT1WRTCA    */
*                 /* FIELD OF THE RTM1 WORK AREA PORTION OF THE      */
*                 /* INTERRUPTED STACK POINTS TO THE RTCA PASSED TO  */
*                 /* THE FRR THAT FAILED CAUSING THE RECURSION -     */
*                 /* CURRSTK REGISTER(R8) POINTS TO THE INTERRUPTED  */
*                 /* STACK OUTPUT - OLDRTCA REGISTER(R0) CONTAINS THE*/
*                 /* ADDRESS OF THE RTCA PASSED TO THE FRR CAUSING   */
*                 /* THE RECURSION NOTES - REGISTERS(R2,R5,R6,R7,R8) */
*                 /* MUST REMAIN UNCHANGED ACROSS THIS SEGMENT       */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0732
*                 DO;                                              0732
*                   R0=RT1WRTCA;    /* SAVE ADDRESS OF OLD RTCA      */
         L     R0,RT1WRTCA(,R8)                                    0733
*                 END;                                             0734
*                 R5=NULL;          /* ZERO RTCA REG TO INDICATE THAT
*                                      EXIT PROCESSING SEGMENT(EXIT)
*                                      IS TO BE EVENTUALLY ENTERED   */
         SLR   R5,R5                                               0735
*               END;                                               0736
*             ELSE                  /* IF SRM IS NOT IN RECURSION  0737
*                                      MODE AND                      */
*               IF R5^=NULL THEN    /* IF RETRY OR RESUME IS NOT   0737
*                                      REQUESTED THEN LOCKS REQUESTED
*                                      TO BE FREED CAN BE FREED      */
         B     @RC00704                                            0737
@RF00704 LTR   R5,R5                                               0737
         BZ    @RF00737                                            0737
*                 DO;                                              0738
*                   RFY                                            0739
*                     R1 RSTD;                                     0739
*                   R1=LKTOFREE;                                   0740
         LH    R1,LKTOFREE(,R5)                                    0740
         N     R1,@CF03531                                         0740
*                   CALL FRLOCKS;   /* FREE THE LOCKS REQUESTED IN 0741
*                                      THE RTCA                      */
         BAL   @14,FRLOCKS                                         0741
*                   RFY                                            0742
*                     R1 UNRSTD;                                   0742
*                 END;                                             0743
*               ELSE                                               0744
*                 ;                 /* IF RETRY OR RESUME IS       0744
*                                      REQUESTED THE NO LOCKS ARE  0744
*                                      FREED                         */
@RF00737 DS    0H                                                  0745
*           END;                                                   0745
*                                                                  0745
@RC00704 DS    0H                                                  0746
*/* ******************************************************************/
*/* THIS SEGMENT PERFORMS THE PERCOLATION PROCESS FROM THE LAST      */
*/* FRR TO GET CONTROL TO THE NEXT AVAILABLE FRR ON THE              */
*/* INTERRUPTED FRR STACK.  THIS PERCOLATION FUNCTION ACCOMODATES    */
*/* THE FOLLOWING FRR STACK SITUATIONS:                              */
*/*  1. THE FRR TO LAST GET CONTROL DID NOT EITHER ADD FRRS TO THE   */
*/*     NOR DELETE FRRS FROM THE STACK.  THAT IS, THE CURRENT FRR    */
*/*     ON THE FRR STACK IS THE ONE LAST GIVEN CONTROL               */
*/*  2. THE FRR TO LAST GET CONTROL ADDED A NUMBER OF FRRS TO THE    */
*/*     FRR STACK.  THAT IS THE CURRENT FRR ON THE STACK IS A FRR    */
*/*     ADDED BY THE FRR TO LAST RECEIVE CONTROL                     */
*/*  3. THE FRR TO LAST GET CONTROL DELETED A NUMBER OF FRRS FROM THE*/
*/*     FRR STACK.  THAT IS THE CURRENT FRR ON THE STACK IS ONE THAT */
*/*     WAS ADDED PRIOR TO THE ADDITION OF THE FRR THAT LAST         */
*/*     CONTROL                                                      */
*/* PERCOLATION FOR CONDITION 1 MERELY INVOLVES THE ZEROING OF SRM   */
*/* FLAGS IN THE 2ND WORD OF THE CURRENT FRR ENTRY THEN PERFORMING   */
*/* A SETFRR WITH THE DELETE OPTION TO MAKE THE CURRENT ENTRY ON THE */
*/* FRR STACK THE ONE FOR THE FRR ADDED RIGHT BEFORE THE ONE DELETED */
*/* PERCOLATION FOR CONDITION 1 AND 2 INVOLVE TWO STEPS:             */
*/*  A.INSURING THAT THE SRM FLAGS IN THE SECOND WORD OF EACH FRR    */
*/*    ENTRY EITHER ABOVE(CONDITION2) OR BELOW(CONDITION3) THE FRR   */
*/*    ENTRY FOR THE LAST FRR GIVEN CONTROL ARE ZEROED               */
*/*  B.AFTER STEP A IS COMPLETE NORMAL PERCOLATION DESCRIBED FOR     */
*/*    CONDITION 1 CAN TAKE PLACE                                    */
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  - CURRSTK REGISTER(R8) CONTAINS THE POINTER TO THE INTERRUPTED  */
*/*    FRR STACK FOR WHICH THE PERCOLATION PROCESS WILL BE PERFORMED */
*/*  - RT1WRTCA FIELD OF THE RTM1 WORK AREA PORTION OF THE           */
*/*   INTERRUPTED FRR STACK POINTS TO THE RTCA PASSED TO LAST FRR TO */
*/*    GET CONTROL                                                   */
*/*  - THE REGISTER 4 SLOT OF THE SRM REGISTER SAVE AREA ASSOCIATED  */
*/*    WITH THE RTCA PASSED TO THE LAST FRR TO GET CONTROL POINTS TO */
*/*    THE FRR ENTRY CORRESPONDING TO THIS FRR                       */
*/*  - FUNCTION REGISTER(R0) INDICATES WHETHER PERCOLATION IS TO BE  */
*/*    PERFOMED OR NOT                                               */
*/*  - WORKREG REGISTER(R4) IS USED AS WORKREG                       */
*/*  - RECURSE REGISTER(R7) INDICATES WHETHER PERCOLATION IS BEING   */
*/*    PERFORMED FOR AN INITIAL ERROR OR A FRR FAILURE               */
*/* OUTPUT OF THIS SEGMENT IS AS FOLLOWS:                            */
*/*  - CONDITION 1:THE CURRENT FRR IS THE ONE ADDED RIGHT BEFORE THE */
*/*                FRR LASTED GIVEN CONTROL                          */
*/*  - CONDITION 2: SAME RESULTS AS FOR CONDITION 1                  */
*/*  - CONDITION 3: THE CURRENT FRR ON THE FRR STACK ON ENTRY TO THIS*/
*/*                 REMAINS UNCHANGED PROVIDED IT REPRESENTS A FRR   */
*/*                 THAT HAS NOT BEEN ROUTED TO                      */
*/* -----NOTES-----                                                  */
*/*  REGS(R0,R2,R4,R5,R6,R7,R8,R9,R10,R14) MUST RESTRICTED           */
*/*  REGS(R1,R3,R11,R12,R13,R15) ARE VOLATILE                        */
*/* ******************************************************************/
*                                                                  0746
*           DO;                                                    0746
*             IF R0>=PERCLATE THEN  /* IF PERCOLATION IS TO BE     0747
*                                      PERFORMED THEN DO THE       0747
*                                      FOLLOWING                     */
         C     R0,@CF00112                                         0747
         BL    @RF00747                                            0747
*               IF SRMTGFRR>FRRSCURR THEN/* IF THE FRR ENTRY       0748
*                                      ASSOCIATED WITH THE LAST FRR
*                                      TO GET CONTROL INDICATES THAT
*                                      THIS FRR DELETED SOME FRRS  0748
*                                      THEN STACK MAINTENACE IS    0748
*                                      NEEDED FOR THOSE ENTRIES    0748
*                                      BETWEEN THE CURRENT FRR ENTRY
*                                      AND THE FRR ENTRY FOR THE LAST
*                                      FRR TO GET CONTROL            */
         LA    @12,512                                             0748
         AL    @12,RT1WRTCA(,R8)                                   0748
         L     @11,SRMTGFRR(,@12)                                  0748
         L     @04,FRRSCURR(,R8)                                   0748
         CR    @11,@04                                             0748
         BNH   @RF00748                                            0748
*                 DO;               /* PERFORM STACK MAINTENANCE     */
*                   RFY                                            0750
*                     R4 RSTD;                                     0750
*                   R4=FRRSCURR;    /* SAVE CURRENT FRR ENTRY        */
         L     @03,FRRSCURR(,R8)                                   0751
         LR    R4,@03                                              0751
*                   FRRSCURR=SRMTGFRR;/* MAKE THE CURRENT FRR THE ONE
*                                      TO LAST GET CONTROL           */
         ST    @11,FRRSCURR(,R8)                                   0752
*                   SRMTGFRR=R4;    /* MAKE THE LAST FRR TO GET    0753
*                                      CONTROL EQUAL TO THE CURRENT
*                                      FRR ON THE STACK              */
         ST    R4,SRMTGFRR(,@12)                                   0753
*                   RFY                                            0754
*                     R4 UNRSTD;                                   0754
*                   CALL STAKMAIN;  /* GO PERFORM MAINTENANCE ON THE
*                                      FRR STACK SO THAT THE THE   0755
*                                      ENTRIES BETWEEN THE CURRENT 0755
*                                      FRR ENTRY AND THE FRR ENTRY 0755
*                                      ASSOCIATED WITH THE LAST FRR
*                                      TO GET CONTROL ARE CLEANED UP */
         BAL   @14,STAKMAIN                                        0755
*                 END;                                             0756
*               ELSE                /* IF THE CURRENT FRR ENTRY ON 0757
*                                      THE STACK IS THE SAME OR    0757
*                                      GREATER THAN THE FRR ENTRY OF
*                                      THE LAST FRR TO GET CONTROL 0757
*                                      THEN STACK MAINTENANCE IS ONLY
*                                      REQUIRED IF RECURSION IS NOT
*                                      ACTIVE WITHIN SRM             */
*                 DO;                                              0757
         B     @RC00748                                            0757
@RF00748 DS    0H                                                  0758
*                   IF R7^=ACTIVE THEN/* IF RECURSION IS NOT ACTIVE
*                                      WITHIN SRM THEN PERFORM STACK
*                                      MAINTENANCE                   */
         C     R7,@CF00079                                         0758
         BE    @RF00758                                            0758
*                     CALL STAKMAIN;/* PERFORM STACK MAINTENANCE     */
         BAL   @14,STAKMAIN                                        0759
*                   ELSE            /* IF RECURSION IS ACTIVE WITHIN
*                                      SRM THEN NESTED FRRS MAY BE ON
*                                      THE STACK AND CONTROL MUST BE
*                                      EVENTUALLY GIVEN TO THEM      */
*                     IF FRRSNEST=ON THEN/* IF THE CURRENT FRR ON THE
*                                      STACK IS A NESTED FRR THEN  0760
*                                      PERFORM NORMAL PERCOLATION    */
         B     @RC00758                                            0760
@RF00758 L     @01,FRRSCURR(,R8)                                   0760
         TM    FRRSNEST(@01),B'01000000'                           0760
         BNO   @RF00760                                            0760
*                       CALL NORMPERC;/* PERFORM NORMAL PERCOLATION  */
         BAL   @14,NORMPERC                                        0761
*                     ELSE          /* IF THE CURRENT FRR ON THE   0762
*                                      STACK IS NOT NESTED THEN STACK
*                                      MAINTENANCE MUST BE PERFORMED */
*                       CALL STAKMAIN;/* PERFORM STACK MAINTENANCE   */
         B     @RC00760                                            0762
@RF00760 BAL   @14,STAKMAIN                                        0762
*                 END;                                             0763
*             ELSE                                                 0764
*               ;                   /* IF PERCOLATION IS NOT TO BE 0764
*                                      PERFORMED THE THIS SEGMENT IS
*                                      SKIPPED                       */
@RF00747 DS    0H                                                  0765
*           END;                                                   0765
@RC00747 DS    0H                                                  0766
*         END;                                                     0766
*       ELSE                        /* OTHERWISE BYPASS THIS SEGMENT */
*         R5=NULL;                  /* BY INDICATING NO RTCA TO    0767
*                                      PROCESS SINCE THE INTERRUPTED
*                                      APPEARS TO BE VOID OF FRRS AND
*                                      THE INTERRUPTED STACK IS NOT A
*                                      SUPER STACK                   */
         B     @RC00602                                            0767
@RF00602 SLR   R5,R5                                               0767
*     END;                          /* IF TARGRTCA REGISTER(R5) IS 0768
*                                      ZERO THEN ALL FRRS ON THE   0768
*                                      INTERRUPTED STACK HAVE BEEN 0768
*                                      PROCESSED,RETRY OR RESUME HAS
*                                      BEEN REQUESTED BY A FRR, OR 0768
*                                      RECURSION INTO SRM HAS TAKEN
*                                      PLACE                         */
@RC00602 DS    0H                                                  0768
@DE00407 LTR   R5,R5                                               0768
         BNZ   @DL00407                                            0768
*     RFY                                                          0769
*       SDWA BASED(RT1WRTCA);       /* REESTABLISH OLD RTCA BASE     */
*                                                                  0769
*     /***************************************************************/
*     /*                                                             */
*     /* AFTER ALL FRRS HAVE BEEN PROCESSED OR WHEN RETRY/RESUME IS  */
*     /* INDICATED IN THE RTCA CONTROL WILL RETURN TO IEAVTRTM. IF   */
*     /* SRM WAS INITIALLY ENTERED BECAUSE OF RECURSION CONTROL WILL */
*     /* RETURN TO THE RECOVERY INITIALIZATION SEGMENT(RINIT) SO THAT*/
*     /* THE RECURSIVE ERROR CAN BE PROCESSED THIS SEGMENT PERFORMS  */
*     /* EXIT PROCESSING PRIOR TO RETURNING TO IEAVTRTM OR IF        */
*     /* RECURSION IS IN EFFECT DIRECTLY RETURNS TO THE RECOVERY     */
*     /* INITIALIZATION FUNCTION(SEGMENT RINIT) AFTER REESTABLISHING */
*     /* THE RECURSIVE ERROR INFORMATION SO THAT THE RECURSIVE ERROR */
*     /* CAN BE PROCESSED                                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0770
*EXIT:                                                             0770
*     DO;                                                          0770
EXIT     DS    0H                                                  0771
*       RT1TLPN=SRMEXIT;            /* SET EXIT LOGICAL PHASE        */
         MVI   RT1TLPN+16(R8),X'58'                                0771
*       IF R7^=ACTIVE THEN          /* IF RECURSION IS NOT ACTIVE    */
         C     R7,@CF00079                                         0772
         BE    @RF00772                                            0772
*         DO;                       /* DO THE FOLLOWING              */
*           RFY                                                    0774
*            (R5,                                                  0774
*             R4) RSTD;             /*                       @YM02601*/
*           GENERATE CODE           /* PREPARE TO EXECUTE A STOSM  0775
*                                      INSTRUCTION USING THE SYSTEM
*                                      MASK LOCATED IN THE SRM REG 0775
*                                      SAVE AREA ASSOCIATED WITH WITH
*                                      THE CURRENTLY ACTIVE RTCA SO
*                                      THAT ANY VALID RETRY REQUESTED
*                                      BY THE LAST FRR TO GET CONTROL
*                                      WILL RESULT IN THE RETRY    0775
*                                      ROUTINE GETTING CONTROL IN THE
*                                      SAME SYSTEM STATE AS THAT FRR
*                                      WHICH REQUESTED RETRY @YM02601*/
*               ;                                                  0775
         L     R5,RT1WRTCA(,R8) GET ACTIVE RTCA                @YM02601
         IC    R4,FIVE12+1(,R5) GET SYS MASK                   @YM02601
*           RFY                                                    0776
*            (R5) UNRSTD;                                          0776
*           IF RT1WSRBR^=NULL THEN  /* IF A GETMAINED RTCA EXIST THEN
*                                      IT MUST BE FREED. RTM WILL  0777
*                                      FREE THE RTCA BUT TO AVOID A
*                                      LOCK CONFLICT ALL HELD BY THIS
*                                      CPU MUST BE FREED             */
         L     @12,RT1WSRBR(,R8)                                   0777
         LTR   @12,@12                                             0777
         BZ    @RF00777                                            0777
*             DO;                                                  0778
*                                                                  0778
*/* ******************************************************************/
*/* THIS SEGMENT PROVIDES AN EXITING FUNCTION TO IEAVTRTM AFTER FRR  */
*/* PROCESSING IS COMPLETE WHERE DURING FRR PROCESSING A GETMIANED   */
*/*  SEB RTCA WAS OBTAINED TO SUPPORT AN FRR.  THE PURPOSE OF THIS   */
*/*  EXITING FUNCTION IS TO INSURE THAT ALL LOCKS ARE FREED ON THIS  */
*/*  CPU SO THAT THE EVENTUAL FREEING OF THIS GETMAINED RTCA CAN BE  */
*/*  ACCOMPLISHED BY IEAVTRTM WITHOUT THE POTENTIAL FOR THE FREEMAIN */
*/* BY RTM TO CAUSE AN ERROR, SINCE RTM ACQUIRES THE LOCAL LOCK TO DO*/
*/* THE FREEMAIN.  IF A HIGHER LOCK WAS STILL HELD ON EXIT FROM      */
*/* IEAVTRTS WITH A GETMAINED RTCA THEN THE LOCAL LOCK REQUEST WOULD */
*/*  CAUSE A LOCKING HIERARCHY CONFLICT AND THE GETMAINED RTCA WOULD */
*/*  NEVER BE FREED                                                  */
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  -RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE INTERRUPTED*/
*/*   STACK POINTS TO THE CURRENTLY ACTIVE RTCA                      */
*/*  -RT1WSRBR FIELD OF THE RTM1 WORK AREA PORTION OF THE INTERRUPTED*/
*/*   CONTAINS THE POINTER TO THE GETMAINED RTCA                     */
*/* NOTES------                                                      */
*/*  REGS(R0,R2,R8,R7,R9,R10,R5,R6,R4) ARE RESTRICTED                */
*/*  REGS(R11,R12,R13,R14) ARE USED INTERFACING WITH SETLOCK TO FREE */
*/*   ALL LOCK HELD BY THE CPU                                       */
*/*  REGS(R1,R3,R15) ARE VOLATILE                                    */
*/* ******************************************************************/
*                                                                  0779
*               RFY                                                0779
*                 NEWRTCA BASED(RT1WSRBR);                         0779
*               NEWRTCA(1:256)=SDWA(1:256);/* COPY CONTENTS OF     0780
*                                      CURRENT RTCA                  */
         L     @11,RT1WRTCA(,R8)                                   0780
         MVC   NEWRTCA(256,@12),SDWA(@11)                          0780
*               NEWRTCA(257:LENGTH(SDWA))=SDWA(257:LENGTH(SDWA));/*
*                                      INTO THE GOTTEN SRB RTCA      */
         MVC   NEWRTCA+256(256,@12),SDWA+256(@11)                  0781
*               NEWRGSV=SRMRGSV;    /* PRIOR TO EXIT TO RTM          */
         MVC   NEWRGSV(72,@12),SRMRGSV+512(@11)                    0782
*               RT1WRTCA=RT1WSRBR;  /* AND MAKE THIS SRB RTCA WITH 0783
*                                      THE CURRENT RTCA CONTENTS   0783
*                                      CURRENT--RTM MUST USE THE   0783
*                                      CONTENTS OF THE CURRENT RTCA
*                                      TO PROPERLY RETRY OR CONTINUE
*                                      WITH TERMINATION BUT MUST HAVE
*                                      THE SRB RTCA AVAILABLE SO THAT
*                                      IT CAN BE EVENTUALLY FREED    */
         ST    @12,RT1WRTCA(,R8)                                   0783
*               RFY                                                0784
*                 R11 RSTD;         /* DESTROYED BY LOCK MANAGER     */
*               RFY                                                0785
*                 R12 RSTD;         /* DESTROYED BY LOCK MANAGER     */
*               RFY                                                0786
*                 R13 RSTD;         /* DESTROYED BY LOCK MANAGER     */
*               GENERATE CODE;                                     0787
*                                      /*RELEASE ALL LOCKS           */
         SETLOCK RELEASE,TYPE=ALL,DISABLED,                            C
               RELATED=('LOCK CLEANUP SRB MODE EXIT TO RTM')
*               RFY                                                0788
*                 R11 UNRSTD;       /* RELEASE REG11                 */
*               RFY                                                0789
*                 R12 UNRSTD;       /* RELEASE REG12                 */
*               RFY                                                0790
*                 R13 UNRSTD;                                      0790
*               RFY                                                0791
*                 NEWRTCA;                                         0791
*             END;                                                 0792
*           ELSE                                                   0793
*             ;                     /* OTHERWISE EXIT WITHOUT FREEING
*                                      ANY LOCKS                     */
@RF00777 DS    0H                                                  0794
*           R0=SRMEND;              /* INDICATE END OF SRM PROCESSING*/
         SLR   R0,R0                                               0794
*         END;                                                     0795
*       ELSE                        /* IF RECURSION IS ACTIVE RESTORE
*                                      THE RECURSIVE ERROR DATA    0796
*                                      CHKPTED ON ENTRY TO SRM       */
*/* ******************************************************************/
*/* THIS SEGMENT RESTORES THE CHECKPOINTED ERROR DATA RESULTING FROM */
*/* A FRR FAILURE AND RESTORES THE STATE OF FRR PROCESSING IN        */
*/* IEAVTRTS SO THAT THE RECURSIVE ERROR CAUSED BY THE FRR FAILURE   */
*/* CAN BE TREATED AS NEW ERROR REQUIRING FURTHER FRR PROCESSING     */
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  - CURRSTK REG(R8) POINTS TO THE INTERRUPTED STACK               */
*/*  - SRMSTAK REG(R2) POINTS TO THE FRR STACK USED FOR IEAVTRTS     */
*/*    RECOVERY                                                      */
*/*  - RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE           */
*/*    INTERRUPTED STACK(POINTED TO BY R8) POINTS TO THE RTCA THAT   */
*/*    WAS PASSED TO THE FRR THAT FAILED AND IN THE SRM REG SAVE     */
*/*    AREA ASSOCIATED WITH THIS STACK(200 BYTES FROM THE BEGINNING  */
*/*   OF THIS RTCA IS THE ERROR DATA ASSOCIATED WITH THE FRR FAILURE */
*/*  - RECURSE  REG(R7) INDICATES RECURSION(FRR FAILURE)             */
*/* OLDRTCA REG(R0) CONTAINS THE ADDRESS OF THE RTCA PASSED TO THE   */
*/*    FRR THAT FAILED                                               */
*/* OUTPUT FROM THIS SEGMENT IS AS FOLLOWS:                          */
*/*  - FLAGSCC REGISTER(R1) IS REPRIOMED WITH THE COMPLETION CODE    */
*/*    DESCRIBING THE FRR FAILURE                                    */
*/*  - DUMPOPTS REGISTER(R5) IS REPRIMED WITH DUMPOPTIONS ASSOCIATED */
*/*    WITH THE FRR FAILURE IF ANY-OR IS REPRIMED WITH HARDWARE      */
*/*    MACHINE CHECK INFO IF THE FRR FAILURE WAS A MACHINE CHECK     */
*/*  - EEDCHAIN REGISTER(R6) IS REPRIMED WITH A POINTER TO MACHINE   */
*/*    CHECK INFO IF THE FRR FAILURE WAS A MACHINE CHECK OTHERWISE   */
*/*    IT IS REPRIMED WITH A ZERO IF THE FRR FAILURE WAS NOT A MACH  */
*/*    OR IS REPRIMED WITH A ONE IF THE FRR FAILURE WAS A MACHINE    */
*/*    CHECK BUT ONLY ABBREVIATED MACH CHECK ERROR DATA WAS AVAILABLE*/
*/*  - SAVAREAP REGISTER(R13) IS REPRIMED WITH THE POINTER TO THE    */
*/*    REGISTERS AT THE TIME OF THE FRR FAILURE                      */
*/*  - RECURSE REGISTER(R7) IS SET TO ZERO TO INDICATE THAT IEAVTRTS */
*/*    WILL PROCESS THIS FRR FAILURE AS A NEW ERROR                  */
*/*  - THE RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE       */
*/*    INTERRUPTED STACK IS SET TO ZERO TO INDICATE THAT A NEW ERROR */
*/*    IS TO BE PROCESSED                                            */
*/*  NOTES-------                                                    */
*/*   REGS(R0,R1,R2,R5.R6.R7.R8.R9.R10.R13) MUST REMAIN RESTRICTED   */
*/*   THROUGHOUT THIS SEGMENT                                        */
*/*   REGS(R3,R4,R11,R12,R14,R15) ARE VOLATILE IN THIS SEGMENT       */
*/* ******************************************************************/
*                                                                  0796
*         DO;                                                      0796
*                                                                  0796
         B     @RC00772                                            0796
@RF00772 DS    0H                                                  0797
*           /*********************************************************/
*           /*                                                       */
*           /* THE FOLLOWING CODE WILL RESTORE THE CHECKPOINTED DATA */
*           /* PASSED ON THE RECURSION,TURN THE RECURSION INDICATOR  */
*           /* OFF AND PROCEED BACK TO RECOVERY INITIALIZATION(RINIT)*/
*           /* SO THAT THE RECURSIVE ERROR CAN BE PROCESSED AS A NEW */
*           /* ERROR                                                 */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0797
*           RFY                                                    0797
*            (R1,                                                  0797
*             R5,                                                  0797
*             R6,                                                  0797
*             R13,                                                 0797
*             R0);                                                 0797
*           R1=CKFLGSCC;            /* SET FLAGSCC REGISTER WITH   0798
*                                      CALLRTM FLAGS AND COMP CODE 0798
*                                      FOR THE RECURSIVE ERROR       */
         LA    @12,512                                             0798
         AL    @12,RT1WRTCA(,R8)                                   0798
         L     R1,CKFLGSCC(,@12)                                   0798
*           R5=CKDMPOPT;            /* SET DUMPOPTS REGISTER WITH  0799
*                                      WITH DUMP OPTS(IF ANY) FOR THE
*                                      RECURSIVE ERROR               */
         L     R5,CKDMPOPT(,@12)                                   0799
*           R6=CKEEDCHN;            /* SET EEDCHAIN REGISTER WITH EED
*                                      CHAIN POINTER INFORMATION   0800
*                                      CONCERNING THE RECURSIVE ERROR*/
         L     R6,CKEEDCHN(,@12)                                   0800
*           R13=CKSVREAP;           /* SET SAVAREAP REGISTER WITH THE
*                                      ADDRESS OF THE REGISTERS AT 0801
*                                      TIME OF THE RECURSIVE ERROR   */
         L     R13,CKSVREAP(,@12)                                  0801
*           RT1WRTCA=NULL;          /* ZERO RTCA POINTER IN THE RTM1
*                                      WA SO THAT SRM CAN TREAT THE
*                                      RECURSIVE ERROR AS IF IT WERE
*                                      A BRAND NEW INITIAL ERROR     */
         SLR   @12,@12                                             0802
         ST    @12,RT1WRTCA(,R8)                                   0802
*           R7=NULL;                /* TAKE SRM OUT OF RECURSION MODE*/
         SLR   R7,R7                                               0803
*         END;                                                     0804
*     END;                                                         0805
@RC00772 DS    0H                                                  0806
*     RFY                                                          0806
*      (R2,                                                        0806
*       R3,                                                        0806
*       R7,                                                        0806
*       R8,                                                        0806
*       R9,                                                        0806
*       R10,                                                       0806
*       R11,                                                       0806
*       R12,                                                       0806
*       R15);                                                      0806
*     RFY                                                          0807
*      (R14,                                                       0807
*       R4) UNRSTD;                                                0807
*   END;                                                           0808
@DE00105 C     R0,@CF00079                                         0808
         BNL   @DL00105                                            0808
*   RFY                                                            0809
*    (R14,                                                         0809
*     R4) RSTD;                                                    0809
*   R14=RTMRETAD;                   /* REESTABLISH RTMS RETURN     0810
*                                      ADDRESS                       */
         L     R14,RTMRETAD+48(,R8)                                0810
*   GENERATE CODE                   /* SETUP ANY RETRY SYSTEM STATE
*                                      PRIOR TO EXIT TO IEAVTRTM   0811
*                                                            @YM02601*/
*       ;                                                          0811
         EX    R4,ROLDMSK        STOSM INTO THE RETRY STATE    @YM02601
*   R9=RTMBASE;                     /* REESTABLISH RTMS BASE REG     */
         L     R9,RTMBASE+48(,R8)                                  0812
*   GO TO R14;                      /* RETURN TO RTM                 */
*                                                                  0813
         BR    R14                                                 0813
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT IS AN INTERNAL PROCEDURE WHICH ALLOCATES A SRB   */
*   /* RTCA VIA GETMAIN OR IF GETMAIN IS UNSUCCESSFUL UTILIZES THE   */
*   /* LOCL RTCA TO SUPPORT A SRB MODE ERROR SEGMENT NAME - ASRBRTCA */
*   /* PROCEDURE NAME - GSRBRTCA PROCEDURE OPTIONS - NOSAVE          */
*   /* NOSAVEAREA FUNCTION-GSRBRTCA ACQUIRES A SRB RTCA ON REQUEST BY*/
*   /* SRM WHEN THE SRM IS ENTERED TO PERFORM RECOVERY FRR PROCESSING*/
*   /* FOR A SRB ERROR, OR WHEN PERCOLATION OF THE ERROR RESULTS IN  */
*   /* SRM ROUTING TO A SRB FRR OPERATION- ON ENTRY TO GSRBRTCA THE  */
*   /* RTM1 WORK AREA ASSOCIATED WITH THE INTERRUPTED FRR STACK IS   */
*   /* EXAMINED TO DETERMINE IF A SRB RTCA HAS ALREADY BEEN ACQUIRED.*/
*   /* IF A SRB RTCA ALREADY EXISTS IT IS REUSED(I.E. ITS ADDRESS IS */
*   /* RETURNED TO SRM). IF A SRB RTCA DOES NOT EXIST, GSRBRTCA      */
*   /* ACQUIRES ONE VIA A GLOBAL BRANCH ENTRY TO GETMAIN REQUESTING  */
*   /* 584 BYTES OF SQA FROM SUBPOOL 245. IF THE GETMAIN IS          */
*   /* SUCCESSFUL THE ADDRESS OF THE NEWLY ACQUIRED RTCA IS STORED IN*/
*   /* THE RTM1 WORK AREA OF THE INTERRUPTED STACK AND RETURNED TO   */
*   /* SRM. IF THE GETMAIN IS UNSUCCESSFUL(I.E. SQA SPACE IS         */
*   /* UNAVAILABLE) THE PROCEDURE PUGET1(SEGMENT PUGETM) IS INVOKED  */
*   /* TO ACQUIRE THE LOCAL RTCA THE LOCAL RTCA WILL THEN BE USED TO */
*   /* PROCESS THE ERROR WHEN SRM ROUTES TO SRB FRRS INPUT . THE     */
*   /* ADDRESS OF THE INTERRUPTED FRR STACK LOCATED IN THE RTM1 WORK */
*   /* AREA OF SRMS RECOVERY FRR STACK . THE ADDRESS OF SRMS RECOVERY*/
*   /* STACK LOCATED IN THE RTM1 WORK AREA OF THE INTERRUPTED STACK  */
*   /* OUTPUT .TARGRTCA(R2) POINTS TO THE ACQUIRED RTCA IF           */
*   /* SRGMENT(RINIT) IS THE CALLER(I.E. THE RT1WRTCA FIELD OF THE   */
*   /* RTM1 WORK AREA OF THE INTERRUPTED STACK IS ZERO) .NRTCAREG(R8)*/
*   /* POINTS TO THE ACQUIRED RTCA IF SRGMENT(S) (GTOS OR LTOS) IS   */
*   /* THE CALLER(I.E. THE RT1WRTCA FIELD OF THE RTM1 WORK AREA OF   */
*   /* THE INTERRUPTED STACK IS NON-ZERO) .TARGRTCA(R2) WILL POINT TO*/
*   /* THE LOCAL RTCA IF THE GETMAIN FOR SQA WAS UNSUCCESSFUL AND    */
*   /* PROC PUGET1(SEGMENT PUGETM) WAS CALLED WHEN (RINIT SEGMENT) IS*/
*   /* THE CALLER OF GSRBRTCA .NRTCAREG(R8) WILL POINT TO THE LOCAL  */
*   /* RTCA IF THE GETMAIN FOR SQA WAS UNSUCCESSFUL AND PROC         */
*   /* PUGET1(SEGMENT PUGETM) WAS INVOKED WHEN SEGMENT(S) GTOS , LTOS*/
*   /* IS THE CALLER OF GSRBRTCA ENTRY - GSRBRTCA                    */
*   /* ATTRIBUTES-REENTRANT, NUCLEUS RESIDENT, ZERO PSW PROTECT KEY, */
*   /* DISABLED OR ENABLED, REFRESHABLE, FIXED SUPERVISOR STATE      */
*   /* LINKAGE - BALR EXIT-NORMAL=RETURN TO CALLER EXIT-ERROR=RETURN */
*   /* TO CALLER EXTERNAL REFERENCES ROUTINES - LOCK MANAGER VIA     */
*   /* SETLOCK VSM VIA GETMAIN DATA AREAS - FLC/PSA CONTROL BLOCKS - */
*   /* RTCA, RTM1 WORK AREA TABLES - NONE MACROS - SETLOCK,SETFRR,   */
*   /* GETMAIN MESSAGES - NONE M.O. NUMBER - 4.3.1.1.2               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0814
*GSRBRTCA:                                                         0814
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0814
@EL00001 DS    0H                                                  0814
@EF00001 DS    0H                                                  0814
@ER00001 BR    @14                                                 0814
GSRBRTCA DS    0H                                                  0815
*   RFY                                                            0815
*    (R2,                           /* THESE REGISTERS CONTAIN       */
*     R5,                           /* INFORMATION SUPPLIED          */
*     R6,                           /* AS INPUT TO SRM AND ALSO      */
*     R7,                           /* INFORMATION THAT MUST BE      */
*     R8) RSTD;                     /* INTERNALLY MAINTAINED         */
*   RFY                                                            0816
*    (R11,                          /* THESE REGISTERS ARE USED      */
*     R12,                          /* IN THIS INTERNAL PROC         */
*     R13,                          /* FOR EXTERNAL CALLS AND FOR  0816
*                                      SETFRRS                       */
*     R14) RSTD;                    /* REG 14 MUST BE PRESERVED FOR
*                                      RETURNING TO THE CALLER OF THE
*                                      PROCEDURE                     */
*   IF RT1WSRBR=NULL THEN           /* IF A SRB RTCA IS NOT ALREADY
*                                      GETMAINED                     */
         L     @15,RT1WSRBR(,R8)                                   0817
         LTR   @15,@15                                             0817
         BNZ   @RF00817                                            0817
*     DO;                           /* THEN DO THE FOLLOWING         */
*       R11=RT1TLPN;                                               0819
         LA    @15,16                                              0819
         LR    @03,R8                                              0819
         ALR   @03,@15                                             0819
         SLR   R11,R11                                             0819
         IC    R11,RT1TLPN(,@03)                                   0819
*       PSACSTK=R2;                 /* MAKE SRMS RECOVERY STACK    0820
*                                      CURRENT                       */
         ST    R2,PSACSTK                                          0820
*       RFY                                                        0821
*         FRRS BASED(PSACSTK);                                     0821
*       RT1TLPN=R11;                                               0822
         L     @03,PSACSTK                                         0822
         ALR   @03,@15                                             0822
         STC   R11,RT1TLPN(,@03)                                   0822
*       RT1TLPID=SRMDRID;                                          0823
         MVI   RT1TLPID(@03),X'01'                                 0823
*       RFY                                                        0824
*         FRRPARMS BASED(R4);       /* RT1TRACK IS PARM AREA         */
*       RFY                                                        0825
*         R4 RSTD;                                                 0825
*       GENERATE CODE               /* ADD FRR TO PROTECT SRM FROM 0826
*                                      POSSIBLE LOCK MGR FAILURE IN
*                                      ATTEMPTING TO ACQUIRE SALLOC
*                                      LOCK                          */
*           ;                                                      0826
         SETFRR  A,FRRAD=RGTMFRR,PARMAD=(R4),WRKREGS=(R4,R12)
*       FRRPREG1=R14;               /* SAVE RETURN ADDRESS TO CALLER
*                                      IN THE FRR PARM AREA          */
*                                                                  0827
         ST    R14,FRRPREG1(,R4)                                   0827
*       /*************************************************************/
*       /*                                                           */
*       /* STORE TRACKING INFORMATION FOR THE FRR                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0828
*       FRRPRTYA=ADDR(PUGETM);      /* SETUP RETRY ADDRESS           */
         LA    @15,PUGETM                                          0828
         ST    @15,FRRPRTYA(,R4)                                   0828
*       FRRPISTK=R8;                /* SAVE ADDRESS OF INTERRUPTED 0829
*                                      FRR STACK                     */
         ST    R8,FRRPISTK(,R4)                                    0829
*       FRRPREG2=R10;               /* SAVE IEAVTRTS BASE REGISTER   */
         ST    R10,FRRPREG2(,R4)                                   0830
*       IF R7=ACTIVE THEN           /* IF RECURSION IS ACTIVE THEN 0831
*                                      INDICATE THIS CONDITION IN THE
*                                      FRR PARAMETER AREA            */
         C     R7,@CF00079                                         0831
         BNE   @RF00831                                            0831
*         FRRPRCUR=ON;                                             0832
         OI    FRRPRCUR(R4),B'00100000'                            0832
*       ELSE                                                       0833
*         ;                         /* OTHERWISE MAKE NO SUCH      0833
*                                      INDICATION                    */
@RF00831 DS    0H                                                  0834
*       FRRPFLPN=RT1TLPN;           /* CHKPT LOGICAL PHASE NUMBER IN
*                                      INTERRUPTED STACK INTO THE FRR
*                                      PARAMETER AREA                */
         L     @15,PSACSTK                                         0834
         IC    @03,RT1TLPN+16(,@15)                                0834
         STC   @03,FRRPFLPN(,R4)                                   0834
*       IF FRRPFLPN<SRMRCRD THEN    /* IF THE LOGICAL PHASE IN THE 0835
*                                      INTERRUPTED STACK INDICATES 0835
*                                      THAT AN RTCA HAS NOT YET BEEN
*                                      INITIALIZED THEN ERROR INPUT
*                                      REGS MUST BE CHKPTED IN THE 0835
*                                      FRR PARAMETER AREA            */
         CLI   FRRPFLPN(R4),71                                     0835
         BNL   @RF00835                                            0835
*         FRRPREG3=R5;              /* SAVE DUMPOPTS OR MACH CHECK 0836
*                                      DATA IN THE FRR PARM AREA     */
         ST    R5,FRRPREG3(,R4)                                    0836
*       ELSE                        /* IF A RTCA HAS BEEN INITIALIZED
*                                      THEN CHKPT FRR AVAILABILITY   */
*         FRRPREG3=R6;                                             0837
         B     @RC00835                                            0837
@RF00835 ST    R6,FRRPREG3(,R4)                                    0837
*       GENERATE CODE;                                             0838
*                                                                  0838
@RC00835 DS    0H                                                  0838
*                             /*OBTAIN THE SALLOC LOCK UNCOND        */
         SETLOCK  OBTAIN,TYPE=SALLOC,MODE=UNCOND,RELATED=(SQA,IEAVTRTS(*
               ALLOCAT))
*       /*************************************************************/
*       /*                                                           */
*       /* STORE TRACKING INFORMATION FOR THE FRR                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0839
*       R11=R4;                     /* PRESERVE THE FRR PARAMETER  0839
*                                      ADDRESS IN PARMREGG SINCE   0839
*                                      GETMAIN DESTROYS PARMREGL     */
         LR    R11,R4                                              0839
*       RFY                                                        0840
*         R4 UNRSTD;                                               0840
*       RFY                                                        0841
*         FRRPARMS BASED(R11);                                     0841
*       RT1TLPN=NULL;               /* OPEN SRM FOR AN ERROR         */
         L     @15,PSACSTK                                         0842
         MVI   RT1TLPN+16(@15),X'00'                               0842
*       RFY                                                        0843
*        (R15,                      /* THESE REGISTERS ARE           */
*         R1) RSTD;                 /* RETURNED THE CALLER OF GETMAIN*/
*       DO;                         /* GETMAIN (RC)                0844
*                                      LV(LENGTH(SDWA)+272) SP(245)
*                                      KEY(0) BRANCH(GLOBAL)         */
*         RESPECIFY                                                0845
*          (GPR01F,                                                0845
*           GPR03F,                                                0845
*           GPR00F,                                                0845
*           GPR04P) RESTRICTED;                                    0845
*         GPR01F=0;                 /* REG 1 MUST BE ZERO            */
         SLR   GPR01F,GPR01F                                       0846
*         GPR03F=0;                 /* RC-TYPE GETMAIN               */
         SLR   GPR03F,GPR03F                                       0847
*         GPR00F=LENGTH(SDWA)+272;  /* LENGTH REQUESTED              */
         LA    GPR00F,784                                          0848
*         GPR03F=GPR03F|((245)*256);/* SP IN BYTE 2                  */
         O     GPR03F,@CF03514                                     0849
*         GPR04P=WSAGGMFM;          /* POINT TO SAVE AREA            */
         L     GPR04P,CVTPTR                                       0850
         L     GPR04P,CVTSPSA(,GPR04P)                             0850
         L     GPR04P,WSAGGMFM(,GPR04P)                            0850
*         GPR03F=GPR03F|((0)*65536*16);/* KEY IN BYTE 1              */
*         CALL CVTGLMN;             /* BRANCH ENTRY POINT            */
         L     @15,CVTPTR                                          0852
         L     @15,CVTGLMN(,@15)                                   0852
         BALR  @14,@15                                             0852
*         RESPECIFY                                                0853
*          (GPR01F,                                                0853
*           GPR03F,                                                0853
*           GPR00F,                                                0853
*           GPR04P) UNRESTRICTED;                                  0853
*       END;                        /* GETMAIN (RC)                0854
*                                      LV(LENGTH(SDWA)+272) SP(245)
*                                      KEY(0) BRANCH(GLOBAL)         */
*                                                                  0854
*       /*************************************************************/
*       /*                                                           */
*       /* STORE TRACKING INFORMATION FOR THE FRR                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0855
*PUGETM:                                                           0855
*       RFY                                                        0855
*         R4 RSTD;                                                 0855
PUGETM   DS    0H                                                  0856
*       RT1TLPN=FRRPFLPN;           /* RESTORE SRM DEFAULT RECOVERY
*                                      LPN                           */
         LA    @03,16                                              0856
         AL    @03,PSACSTK                                         0856
         MVC   RT1TLPN(1,@03),FRRPFLPN(R11)                        0856
*       RT1TLPID=SRMDRID;           /* RESTORE RTS DEFAULT RECOVERY
*                                      LPID                  @YM06156*/
         MVI   RT1TLPID(@03),X'01'                                 0857
*       R4=R11;                     /* RESTORE THE FRR PARAMETER AREA
*                                      ADDRESS TO PARMREGL SINCE   0858
*                                      PARMREGG IS DESTROYED BY THE
*                                      FOLLOWING SETLOCK             */
         LR    R4,R11                                              0858
*       RFY                                                        0859
*         FRRPARMS BASED(R4);                                      0859
*       GENERATE CODE;                                             0860
*                             /*RELEASE THE SALLOC LOCK              */
         SETLOCK  RELEASE,TYPE=SALLOC,DISABLED,RELATED=(SQA,IEAVTRTS(AL*
               LOCAT))
*       IF R15^=NULL THEN           /* IF SQA RTCA WAS NOT OBTAINED  */
         LTR   R15,R15                                             0861
         BZ    @RF00861                                            0861
*         DO;                       /* DO THE FOLLOWING              */
*/* ******************************************************************/
*/*      THIS SEGMENT ALLOCATES AN RTCA IN THE EVENT A GETMAIN       */
*/*      FOR AN RTCA TO RECOVER A SRB MODE TYPE FUNCTION FAILS TO    */
*/*      ACQUIRE THE REQUESTED AMOUNT OF SQA. IN THIS CASE THE       */
*/*      LOCAL RTCA IS USED INSTEAD(AFTER FIRST INSURING PROPER      */
*/*      SERIALIZATION BY ACQUIRING  THE LOCAL LOCK---IF CURRENTLY   */
*/*      UNOWNED)                                                    */
*/*     INPUT                                                        */
*/*  -CURRSTK REGISTER(R8) POINTS TO THE INTERRUPTED STACK FOR       */
*/*       WHICH SRM IS TO PERFORM PROCESSING                         */
*/*      -PARMREGL REGISTER(R4) POINTS TO THE FRR PARAMETER AREA     */
*/*       FOR SRMS FRR WHICH IS DEFINED ON A FRR STACK POINTED TO    */
*/*       BY SRMSTAK REGISTER(R2)                                    */
*/*     OUTPUT                                                       */
*/*      -SRBRTCA REGISTER(R1) CONTAINS THE ADDRESS OF THE ACQUIRED  */
*/*       LOCAL RTCA                                                 */
*/*      -THE RTM1 WORK AREA OF THE INTERRUPTED STACK INDICATES THAT */
*/*       THE MODE IS NOW LOCAL AND THAT THE LOCAL LOCK HAS BEEN     */
*/*       ACQUIRED                                                   */
*/*      -THE LOCAL RTCA INDICATES THAT THE LOCAL LOCK IS NOT TO BE  */
*/*       FREED(SDWAFLLK=OFF)                                        */
*/*     NOTES                                                        */
*/*      -REGISTERS(R2,R5,R6,R7,R8) CONTENTS ON ENTRY TO THIS SEGMENT*/
*/*       MUST BE THE SAME AS ON EXIT FROM THIS SEGMENT              */
*/*      -REGISTERS(R11,R12,R13,R14)  ARE DESTROYED BY SETLOCK       */
*/* ******************************************************************/
*                                                                  0863
*           RFY                                                    0863
*             R15 UNRSTD;           /* RETCODE REGISTER FROM GETMAIN
*                                      NO LONGER NEEDED              */
*           RFY                                                    0864
*             SDWA BASED(ASXBFRWA);                                0864
*           RFY                                                    0865
*             FRRS BASED(R8);                                      0865
*           IF RT1WRTCA^=ASXBFRWA THEN/* IF THE CALLER OF GSRBRTCA IS
*                                      NOT THE LTOS SEGMENT THEN THE
*                                      LOCAL LOCK IS NOT HELD AND  0866
*                                      MUST BE ACQUIRED BEFORE THE 0866
*                                      LOCAL RTCA CAN BE USED DO THE
*                                      FOLLOWING                     */
*                                                                  0866
         L     @15,PSAAOLD                                         0866
         L     @15,ASCBASXB(,@15)                                  0866
         CLC   RT1WRTCA(4,R8),ASXBFRWA(@15)                        0866
         BE    @RF00866                                            0866
*             /*******************************************************/
*             /*                                                     */
*             /* THIS SEGMENT IS INCLUDE IN THE PROCEDURE GSRBRTCA   */
*             /* AND PERFORMS THE FUNCTION OF EXCLUSIVELY ACQUIREING */
*             /* THE LOCAL RTCA TO SUPPORT THE FRR PROCESSING OF SRM */
*             /* INVOLVED WITH SRB MODE ERRORS AND SRB FRRS THE USE  */
*             /* OF THE LOCAL RTCA TO SUPPORT SRB MODE ERRORS WILL   */
*             /* ONLY TAKE PLACE WHEN A PREVIOUS GETMAIN FOR A SQA   */
*             /* SRB RTCA HAS FAILED. THUS THIS SEGMENT WILL ONLY BE */
*             /* ENTERED WHEN THE ABOVE CONDITION OCCURS THE MAIN    */
*             /* FUNCTION OF THIS SEGMENT IS TO ACQUIRE THE LOCAL    */
*             /* RTCA,ZERO IT AND ENSURE THAT SRM WILL EVENTUALLY USE*/
*             /* IT OWNING THE PROPER SERIALIZATION(I.E.THE LOCAL    */
*             /* LOCK) INPUT - PARMREGG REGISTER(R11) POINTS TO THE  */
*             /* SRM FRR PARAMETER AREA WHOSE SECOND WORD CONTAINS   */
*             /* THE RETURN ADDRESS TO THE CALLER OF GSRBRTCA -      */
*             /* CURRSTK REG(R8),SRMSTAK REG(R2) CONTAINS THE        */
*             /* ADDRESSES OF THE INTERRUPTED STACK AND SRM RECOVERY */
*             /* STACK RESPECTIVELY - RECURSE REGISTER(R7) CONTAINS  */
*             /* THE CURRENT INTERNAL INDICATION OF RECURSION INTO   */
*             /* SRM - RT1WRTCA FIELD OF THE RTM1 WORK AREA PORTION  */
*             /* OF THE INTERRUPTED STACK POINTS TO THE ACTIVE RTCA  */
*             /* IF A FRR HAS ALREADY BEEN GIVEN CONTROL OR CONTAINS */
*             /* ZERO IF SRM IS PREPARING TO INITIALLY ROUTE TO A FRR*/
*             /* OUTPUT - IF THE SERIALIZATION OF THE LOCAL RTCA WAS */
*             /* ACHIEVED BY AN UNCONDITIONAL REQUEST FOR THE LOCAL  */
*             /* LOCK THE ENTIRE LOCAL RTCA IS ZEROED WITH EXCEPTION */
*             /* OF THE SDWARPIV BIT WHICH IS TURNED ON WHEN         */
*             /* RECURSION IS IN EFFECT SINCE SUCH A REQUEST OF LOCK */
*             /* MGR CAUSES ENABLEMENT AND THE POSSIBLE LOSS OF THE  */
*             /* RECURSIVE ERROR INFORMATION - IF SERIALIZATION WAS  */
*             /* ACHIEVED BY A CONDITIONAL REQUEST FOR THE LOCAL LOCK*/
*             /* THEN THE LOCAL RTCA IS ENTIRELY ZEROED - PARMREGL   */
*             /* REGISTER(R4) CONTAINS THE POINTER TO THE SRMS FRR - */
*             /* PARAMETER AREA CONTAINING THE RETURN ADDRESS TO THE */
*             /* CALLER OF GSRBRTCA(--PARMREGG REG(R11)- BEING       */
*             /* DESTROYED BY THE LOCK MANAGER - CURRSTK             */
*             /* REG(R8),SRMSTAK REG(R2) REMAIN UNCHANGED - THE      */
*             /* CONTENTS OF THE RT1WRTCA FIELD IN THE RTM1 WORK AREA*/
*             /* ARE UNCHANGED - RECURSE REGISTER(R7) REMAINS        */
*             /* UNCHANGED NOTES - REGS(R11,R12,R13,R14) ARE         */
*             /* DESTROYED BY THE LOCK MGR - REGS(R0,R2,R5,R6) MUST  */
*             /* REMAIN UNCHANGED THRUOUT THIS SEGMENT               */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0867
*             DO;                                                  0867
*               RFY                                                0868
*                 R4 RSTD;          /* PARMREGL REG WILL POINT TO THE
*                                      FRR PARAMETER AREA            */
*               GENERATE CODE;                                     0869
*                                      /*REQUEST THE LOCAL LOCK      */
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=COND,                          X
               RELATED=(LOCLRTCA,IEAVTRTM(NOPERCEX))
*               IF R13>STLOKHEL THEN/* IF THE LOCAL LOCK WAS NOT   0870
*                                      CONDITIONALLY OBTAINED OR   0870
*                                      ALREADY HELD THEN IT WILL BE
*                                      REQUESTED UNCONDITIONALLY   0870
*                                                            @YA00097*/
         C     R13,@CF00115                                        0870
         BNH   @RF00870                                            0870
*PUGETM2:                                                          0871
*                 DO;                                              0871
PUGETM2  DS    0H                                                  0872
*                   RT1TLPN=FRRPFLPN;/* RESTORE RTS RECOVRY  @YM06156*/
         LA    @15,16                                              0872
         ALR   @15,R8                                              0872
         IC    @03,FRRPFLPN(,R4)                                   0872
         STC   @03,RT1TLPN(,@15)                                   0872
*                   RT1TLPID=SRMDRID;/* RESTORE RTS RECOVRY  @YM06156*/
         MVI   RT1TLPID(@15),X'01'                                 0873
*                   GENERATE CODE;                                 0874
*                                                                  0874
*                                      /*REQUEST LOCAL LOCK UNCOND   */
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        X
               RELATED=(LOCLRTCA,IEAVTRTM(NOPERCEX))
*                   /*************************************************/
*                   /*                                               */
*                   /* ZERO THE LOCAL RTCA                           */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0875
*                   SDWA(1:256)=''B;/* ZERO 1ST 256 BYTES            */
         L     @15,PSAAOLD                                         0875
         L     @15,ASCBASXB(,@15)                                  0875
         L     @15,ASXBFRWA(,@15)                                  0875
         XC    SDWA(256,@15),SDWA(@15)                             0875
*                   SDWA(257:512)=''B;/* ZERO 2ND 256 BYTES          */
         XC    SDWA+256(256,@15),SDWA+256(@15)                     0876
*                   SDWARPIV='1'B;  /* SINCE THE UNCONDITIONAL REQST
*                                      FOR THE LOCAL LOCK CAUSED   0877
*                                      ENABLEMENT AND A POSSIBLE   0877
*                                      DESTRUCTION OF THE SRM INPUT
*                                      ERROR DATA OR THE CURRENT RTCA
*                                      THE FRR TO EVENTUALLY RECEIVE
*                                      CONTROL MUST BE INFORMED OF 0877
*                                      THIS CONDITION                */
         OI    SDWARPIV(@15),B'00000100'                           0877
*                 END;                                             0878
*               ELSE                                               0879
*                 DO;               /* IF THE LOCAL LOCK WAS OBTAINED
*                                      CONDITIONALLY THEN NO       0879
*                                      ENABLEMENT TOOK PLACE THE REGS
*                                      AND PSW AT TIME OF ERROR ARE
*                                      STILL VALID                   */
*                                                                  0879
         B     @RC00870                                            0879
@RF00870 DS    0H                                                  0880
*                   /*************************************************/
*                   /*                                               */
*                   /* ZERO THE LOCAL RTCA                           */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0880
*                   SDWA(1:256)=''B;/* ZERO 1ST 256 BYTES            */
         L     @15,PSAAOLD                                         0880
         L     @15,ASCBASXB(,@15)                                  0880
         L     @15,ASXBFRWA(,@15)                                  0880
         XC    SDWA(256,@15),SDWA(@15)                             0880
*                   SDWA(257:512)=''B;/* ZERO 2ND 256 BYTES          */
         XC    SDWA+256(256,@15),SDWA+256(@15)                     0881
*                 END;                                             0882
*               RFY                                                0883
*                 SDWA BASED(RT1WRTCA);                            0883
@RC00870 DS    0H                                                  0884
*             END;                                                 0884
*           ELSE                                                   0885
*             ;                     /* OTHERWISE IF LTOS IS CALLER 0885
*                                      THEN CONTINUE TO USE LOCAL  0885
*                                      SDWA                  @YA00097*/
@RF00866 DS    0H                                                  0886
*           IF RT1WRTCA^=NULL THEN  /* IF THE CALLER IS THE GTOS OR
*                                      THE LTOS SEGMENT      @YA00097*/
         L     @15,RT1WRTCA(,R8)                                   0886
         LTR   @15,@15                                             0886
         BZ    @RF00886                                            0886
*             SDWAFLLK=OFF;         /* INDICATE IN THE CURRENT SDWA
*                                      THAT THE LOCAL LOCK MUST NOT
*                                      BE FREED              @YA00097*/
         NI    SDWAFLLK(@15),B'11111110'                           0887
*           MODELOC=ON;             /* INDICATE LOCAL MODE           */
@RF00886 OI    MODELOC+81(R8),B'00001000'                          0888
*           RT1TLOCL=ON;            /* INDICATE TO RTM THAT THE LOCAL
*                                      LOCK MUST BE FREED            */
         OI    RT1TLOCL(R8),B'00100000'                            0889
*           R1=ASXBFRWA;            /* OUTPUT REG SRBRTCA CONTAINS 0890
*                                      THE ADDR OF THE LOCAL RTCA    */
         L     @15,PSAAOLD                                         0890
         L     @15,ASCBASXB(,@15)                                  0890
         L     R1,ASXBFRWA(,@15)                                   0890
*         END;                                                     0891
*       ELSE                                                       0892
*         DO;                                                      0892
         B     @RC00861                                            0892
@RF00861 DS    0H                                                  0893
*           RFY                                                    0893
*             FRRS BASED(R8);                                      0893
*           RT1WSRBR=R1;            /* SAVE ADDR TO GOTTEN SRB IN  0894
*                                      RTM1 WORK AREA                */
         ST    R1,RT1WSRBR(,R8)                                    0894
*           RT1TRTCA=ON;            /* INDICATE THAT A RTCA WAS    0895
*                                      SUCCESSFULLY GETMAINED        */
         OI    RT1TRTCA(R8),B'00010000'                            0895
*           RFY                                                    0896
*             FRRPARMS BASED(R4);                                  0896
*         END;                                                     0897
*       RFY                                                        0898
*         R15 UNRSTD;                                              0898
@RC00861 DS    0H                                                  0899
*       R14=FRRPREG1;               /* RESTORE THE RETURN ADDRESS TO
*                                      THE CALLER                    */
         L     R14,FRRPREG1(,R4)                                   0899
*       RFY                                                        0900
*         RT1TRACK BASED(ADDR(RT1WLPTA));                          0900
*       RFY                                                        0901
*         FRRS BASED(PSACSTK);                                     0901
*DELETE1:                                                          0902
*       GENERATE CODE;                                             0902
DELETE1  DS    0H                                                  0902
*                                      /*DELETE SRMS FRR             */
         SETFRR D,WRKREGS=(R11,R12)
*       RT1TLPN=NONE;                                              0903
         L     @15,PSACSTK                                         0903
         MVI   RT1TLPN+16(@15),X'00'                               0903
*       PSACSTK=R8;                 /* RESTORE THE INTERRUPTED STACK
*                                      AS CURRENT                    */
         ST    R8,PSACSTK                                          0904
*       RFY                                                        0905
*         FRRS BASED(R8);                                          0905
*     END;                                                         0906
*   ELSE                            /* OTHERWISE USE THE EXISTING  0907
*                                                            @YM03571*/
*     R1=RT1WSRBR;                  /* SRB RTCA              @YM03571*/
         B     @RC00817                                            0907
@RF00817 L     R1,RT1WSRBR(,R8)                                    0907
*   END GSRBRTCA;                                                  0908
*                                                                  0908
@EL00002 DS    0H                                                  0908
@EF00002 DS    0H                                                  0908
@ER00002 BR    @14                                                 0908
*/* ******************************************************************/
*/* THIS SEGMENT IS AN INTERNAL PROCEDURE WITHIN IEAVTRTS WHICH      */
*/* PERFORMS THE NORMAL PERCOLATION PROCESS.  THE NORMAL PERCOLATION */
*/* PROCESS INVOLVES THE FOLLOWING:                                  */
*/*  1.EXAMINING THE CURRENT FRR ENTRY TO DETERMINE IF THE FRR       */
*/*    ASSOCIATED WITH THE ENTRY WAS ROUTED TO                       */
*/*  2.IF THE CURRENT FRR ENTRY INDICATES THAT THE FRR WAS           */
*/*    ROUTED TO AND THE STACK ON INPUT TO THIS PROCEDURE IS NOT     */
*/*    EMPTY THEN THE SECOND WORD OF THE ENTRY(CONTAINING IEAVTRTS   */
*/*    FLAGS) IS ZEROED AND THE FRR ENTRY IS DELETED(VIA THE SETFRR  */
*/*    MACRO USING THE DELETE OPTION)                                */
*/*  3.STEPS 1 AND 2 ABOVE ARE REPEATED UNTIL AN ENTRY IS FOUND THAT */
*/*    INDICATES THAT A FRR HAS NOT YET RECEIVED CONTROL OR UNTIL    */
*/*    THE FRR STACK IS EMPTY                                        */
*/*  4.IF THE FRR STACK IS EMPTY AND IS NOT ONE OF THE SUPER STACKS  */
*/*    (SINCE THESE STACKS ALWAYS HAVE THE SUPER FRR ENTRY ACTIVE)   */
*/*    THE TARGRTCA REGISTER(R5) IS ZEROED TO INDICATE THAT NO MORE  */
*/*    FRRS ARE AVAILABLE                                            */
*/*                                                                  */
*/*   SEGMENT NAME - SNRMPERC                                        */
*/*   PROCEDURE NAME - NORMPERC                                      */
*/*   PROCEDURE OPTIONS - NOSAVE NOSAVEAREA                          */
*/*                                                                  */
*/*   INPUT                                                          */
*/*     CURRSTK REG(R8) - POINTS TO THE INTERRUPTED FRR STACK ON     */
*/*      WHICH PERCOLATION WILL TAKE PLACE                           */
*/*    SRMRETAD REG(R14) - CONTAINS THE RETURN ADDRESS OF THE CALLER */
*/*     OF THIS INTERNAL PROCEDURE                                   */
*/*                                                                  */
*/*   OUTPUT                                                         */
*/*     .THE FRR STACK IS EITHER EMPTY OR THE CURRENT FRR ENTRY ON   */
*/*      THE STACK IS THE NEXT FRR TO GET CONTROL                    */
*/*     .TARGRTCA REG(R5) IS ZERO IF THE FRR STACK IS THE NORMAL FRR */
*/*      STACK AND NO MORE FRRS ON THIS STACK ARE AVAILABLE FOR FRR  */
*/*      ROUTING                                                     */
*/*     .TARGRTCA REG(R5) POINTS TO THE CURRENTLY ACTIVE RTCA IF     */
*/*      THE FRR STACK HAS A FRR THAT IS TO BE ROUTED TO AFTER THE   */
*/*      PERCOLATION PROCESS IS COMPLETE                             */
*/*                                                                  */
*/*   NOTES                                                          */
*/*  - REGS(R0,R2,R5,R6,R7,R8,R9,R10)MUST REMAIN UNCHANGED THROUGHOUT*/
*/*  - REGS(R1,R3,R4,R11,R12,R13,R15) ARE VOLATILE THROUGHOUT THIS   */
*/*    PROCEDURE                                                     */
*/*  - REG(R14) ON INPUT IS THE RETURN ADDRESS TO THE CALLER         */
*/*    AND IS PRESERVED ON ENTRY IN THE SRM REG SAVE AREA ASSOCIATED */
*/*    WITH THE CURRENT RTCA AND IS RESTORE ON RETURN FROM THIS      */
*/*    REG SAVE AREA                                                 */
*/*  -THIS PROCEDURE CALLS THE INTERNAL PROCEDURE DELTAFRR TO DELETE */
*/*    FRRS FROM THE FRR STACK AS EACH PERCOLATION OCCURRS           */
*/* ******************************************************************/
*                                                                  0909
*NORMPERC:                                                         0909
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0909
NORMPERC DS    0H                                                  0910
*   RFY                                                            0910
*    (R0,                           /* VOLATILE REGS OF CALLER       */
*     R2,                           /* THAT MUST BE PRESERVED        */
*     R5,                           /* THROUGHOUT THIS PROC          */
*     R6,                                                          0910
*     R7,                                                          0910
*     R8,                                                          0910
*     R14) RSTD;                                                   0910
*   SRMREG9=R14;                    /* CHKPT THE RETURN ADDRESS TO 0911
*                                      THE CALLER                    */
         L     @15,RT1WRTCA(,R8)                                   0911
         ST    R14,SRMREG9+512(,@15)                               0911
*   DO WHILE FRRSRCUR=ON            /* LOOP THRU THE FRR ENTRIES     */
*         &FRRSEMP<FRRSCURR;        /* FROM THE CURRENT TO THE OLDEST
*                                      AS LONG AS EACH ENTRY       0912
*                                      INDICATES RECURSION           */
         B     @DE00912                                            0912
@DL00912 DS    0H                                                  0913
*     FRRSFLGS=''B;                 /* ZERO THE SRM INDICATORS IN THE
*                                      FRR ENTRY                     */
         L     @15,FRRSCURR(,R8)                                   0913
         XC    FRRSFLGS(4,@15),FRRSFLGS(@15)                       0913
*     CALL DELTAFRR;                /* DELETE THE FRR FROM THE STACK */
         BAL   @14,DELTAFRR                                        0914
*   END;                                                           0915
@DE00912 L     @15,FRRSCURR(,R8)                                   0915
         TM    FRRSRCUR(@15),B'10000000'                           0915
         BNO   @DC00912                                            0915
         C     @15,FRRSEMP(,R8)                                    0915
         BH    @DL00912                                            0915
@DC00912 DS    0H                                                  0916
*   IF FRRSEMP=FRRSCURR             /* IF THE FRR STACK IS EMPTY     */
*       &R8=PSANSTK THEN            /* THEN SRM PROCESSING IS TO   0916
*                                      EVENTUALLY PROCEED TO THE EXIT
*                                      SEGMENT                       */
         CLC   FRRSEMP(4,R8),FRRSCURR(R8)                          0916
         BNE   @RF00916                                            0916
         C     R8,PSANSTK                                          0916
         BNE   @RF00916                                            0916
*     R5=NULL;                                                     0917
         SLR   R5,R5                                               0917
*   ELSE                                                           0918
*     ;                             /* IF THE STACK IS NOT EMPTY THEN
*                                      CONTINUE SCANNING THE FRR   0918
*                                      ENTRIES                       */
@RF00916 DS    0H                                                  0919
*   R14=SRMREG9;                    /* REESTABLISH THE RETURN ADDR TO
*                                      THE CALLER                    */
         L     @03,RT1WRTCA(,R8)                                   0919
         L     R14,SRMREG9+512(,@03)                               0919
*   END NORMPERC;                                                  0920
*                                                                  0920
@EL00003 DS    0H                                                  0920
@EF00003 DS    0H                                                  0920
@ER00003 BR    @14                                                 0920
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT IS AN INTERNAL PROCEDURE WHITHIN SRM WHICH       */
*   /* PROVIDES THE FUNCTION OF FREEING LOCKS AS REQUESTED BY FRRS   */
*   /* AND AS INDICATED IN THE RTCA. SEGMENT NAME-SRFRLOCKS PROCEDURE*/
*   /* NAME-FRLOCKS PROCEDURE OPTIONS-NOSAVE NOSAVEAREA OPERATION -  */
*   /* EACH LOCK FREEING REQUEST BIT IN THE RTCA IS CHECKED TO       */
*   /* DETERMINE WHETHER THE LOCK SHOULD BE FREED(I.E. INDICATED BY  */
*   /* THE BIT BEING ON). FOR EACH ON BIT A SETLOCK RELEASE IS ISSUED*/
*   /* SPECIFYING THE APPROPRIATE LOCK TYPE ASSOCIATED WITH EACH     */
*   /* GIVEN BIT SUCH THAT THE LOCK MANAGER WILL RETURN CONTROL TO   */
*   /* SRM PHYSICALLY DISABLED. THOSE LOCKS REQUIRING A LOCKWORD IN  */
*   /* ORDER TO BE FREED ARE FREED IN THE SAME MANNER AS             */
*   /* ABOVE---USING THE APPROPRIATE LOCKWORD SUPPLIED BY THE FRR IN */
*   /* THE RTCA INPUT - CURRSTK REGISTER(R8) CONTAINS THE ADDRESS OF */
*   /* THE INTERRUPTED STACK - SRMSTAK REGISTER(R2) CONTAINS THE     */
*   /* ADDRESS OF THE FRR STACK SRM USES TO DEFINE ITS OWN FRRS -    */
*   /* RT1WRTCA FIELD OF THE RTM1 WORK AREA PORTION OF THE           */
*   /* INTERRUPTED STACK POINTS TO THE ACTIVE RTCA CONTAINING THE    */
*   /* LOCK FREEING INFORMATION - SRMRETAD REGISTER(R14) CONTAINS THE*/
*   /* RETURN ADDRESS TO THE CALLER OF FRLOCKS OUTPUT - THE LOCKS TO */
*   /* FREE INDICATORS AND THE LOCKWORDS IN THE RTCA ARE ZEROED AFTER*/
*   /* THE LOCK FREEING TAKES PLACE - CURRSTK REGISTER(R8),SRMSTAK   */
*   /* REGISTER(R2) ARE UNCHANGED - SRMRETAD REGISTER(R14) IS        */
*   /* RESTORED WITH THE RETURN ADDRESS TO THE CALLER OF FRLOCKS -   */
*   /* THE RT1WRTCA FIELD IN THE RTM1 WORK AREA STILL POINTS TO THE  */
*   /* ACTIVE RTCA NOTES - REGS(R11,R12,R13,R14) ARE DESTROYED BY THE*/
*   /* LOCK MANAGER - REGS(R11,R12) ARE USED BY SRM AS WORK REGS TO  */
*   /* DEFINE ITS OWN FRR USING THE SETFRR MACRO - PARMREGL          */
*   /* REGISTER(R4) POINTS TO SRMS FRR PARAMETER AREA AFTER THE      */
*   /* SETFRR IS ISSUED AND MUST REMAIN RESTRICTED THROUGHOUT THIS   */
*   /* PROC UNTIL RETURN IS FINALLY REESTABLISHED TO THE CALLER SINCE*/
*   /* THE SECOND WORD OF THE FRR PARAMETER CONTAINS THE RETURN      */
*   /* ADDRESS TO THE CALLER AND MUST BE REESTABLISHED TO AFFECT     */
*   /* RETURN TO THE CALLER ENTRY------FRLOCKS ATTRIBUTES -          */
*   /* REENTRANT,NUCLEUS RESIDENT,ZERO PSW PROTECT KEY,              */
*   /* DISABLED,REFRESHABLE,FIXED SUPERVISOR STATE LINKAGE - BAL OR  */
*   /* BALR EXIT - NORMAL - RETURN TO CALLER EXIT - ERROR - RETURN TO*/
*   /* CALLER EXTERNAL REFERENCES ROUTINES - LOCK MANAGER VIA SETLOCK*/
*   /* DATA AREAS - FLC/PSA CONTROL BLOCKS - RTCA,RTM1 WORK AREA     */
*   /* TABLES - NONE MACROS - SETLOCK,SETFRR MESSAGES - NONE M.O.    */
*   /* NUMBER - 4.3.1.4.6                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0921
*FRLOCKS:                                                          0921
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0921
FRLOCKS  DS    0H                                                  0922
*   RFY                                                            0922
*    (R0,                           /* VOLATILE REGISTERS THAT MUST  */
*     R2,                           /* BE PRESERVED ACROSS THIS      */
*     R5,                           /* PROCEDURE                     */
*     R6,                                                          0922
*     R1,                                                          0922
*     R7,                                                          0922
*     R8,                                                          0922
*     R11,                          /* REGISTERS USED BY THIS PROC   */
*     R12,                          /* TO ESTABLISH FRRS VIA   SETFRR*/
*     R13,                          /* AND TO INTERFACE WITH         */
*     R14) RSTD;                    /* EXTERNAL ROUTINES             */
*   DO;                                                            0923
*     SRMWSAV2=R14;                 /* PRESERVE THE RETURN ADDRESS TO
*                                      THE CALLER OF THIS PROCEDURE  */
         L     @15,RT1WRTCA(,R8)                                   0924
         ST    R14,SRMWSAV2+512(,@15)                              0924
*     IF R1^=NULL THEN              /* IF THERE ARE LOCKS TO BE FREED
*                                      DO FOLLOWING                  */
         LTR   R1,R1                                               0925
         BZ    @RF00925                                            0925
*       DO;                                                        0926
*         GENERATE CODE;                                           0927
*                                      /*FREE REQUESTED LOCKS        */
         SETLOCK RELEASE,DISABLED,TYPE=(R1),                           C
               RELATED=('LOCKS FREED AS REQUESTED BY FRR')
         L     R5,RT1WRTCA(,R8)  GET POINTER TO CURRENT RTCA
         SR    R11,R11
         ICM   R11,3,LKTOFREE(R5)  GET LOCKS REQUESTED TO FREE
         LR    R12,R11
         NR    R12,R1  ISOLATE LOCKS THAT ARE FREED
         XR    R11,R12  RETAIN ADDITIONAL LOCKS TO FREE
         STCM  R11,3,LKTOFREE(R5) UPDATE RTCA WITH ADDED LOCKS TO FREE
*       END;                                                       0928
*     ELSE                                                         0929
*       ;                           /* IF THERE ARE NO LOCKS TO BE 0929
*                                      FREED BYPASS THE RELEASE      */
@RF00925 DS    0H                                                  0930
*     R14=SRMWSAV2;                 /* REESTABLISH THE RETURN ADDRESS
*                                      TO THE CALLER STACK AS CURRENT*/
         L     @03,RT1WRTCA(,R8)                                   0930
         L     R14,SRMWSAV2+512(,@03)                              0930
*   END;                            /* END FREE LOCK PROCESSING      */
*   END FRLOCKS;                                                   0932
*                                                                  0932
@EL00004 DS    0H                                                  0932
@EF00004 DS    0H                                                  0932
@ER00004 BR    @14                                                 0932
*/* ******************************************************************/
*/* THIS SEGMENT PERFORMS STACK MAINTENANCE ON THE FRR STACK         */
*/*  WHEN PERCOLATION IS BEING PERFORMED AND WHEN EITHER THE LAST    */
*/*  FRR TO GET CONTROL ADDED FRRS TO THE STACK OR DELETE A NUMBER   */
*/*  OF FRRS FROM THE STACK PRIOR TO ITS RETURN TO IEAVTRTS          */
*/*  THIS STACK MAINTENANCE INVOLVES INSURING THAT THOSE FRR ENTRIES */
*/*  SKIPPED OVER BY THE FRR DELETING FRRS OR ADDING FRRS ARE        */
*/* PROPERLY RESET SO THAT IEAVTRTS PROCESSING WILL NOT MISTAKE THOSE*/
*/* THOSE SKIPPED OVER ENTRIES AS BEING INVOLVED IN THE FURTHER      */
*/* PROCESSING OF THE ERROR AS THE PERCOLATION AND FRR ROUTING       */
*/* PROCESSES CONTINUE FOR THE ERROR                                 */
*/*   SPECIFICALLY IEAVTRTS ZEROES THE SECOND WORD OF EACH OF THE    */
*/*   SKIPPED OVER ENTRIES TO INSURE THAT IEAVTRTS FURTHER PROCESSING*/
*/*   RECOGNIZES THESE FRR ENTRIES AS FOR FRRS THAT HAVE NOT YET     */
*/*   BEEN ROUTED TO                                                 */
*/* INPUT TO THIS SEGMENT IS AS FOLLOWS:                             */
*/*  - CURRSTK REG(R8) POINTS TO THE CURRENT INTERRUPTED STACK       */
*/*  - RT1WRTCA FIELD IN THE RTM1 WORK AREA PORTION OF THE           */
*/*    INTERRUPTED STACK POINTS TO THE CURRENT RTCA PASSED TO        */
*/*    THE LAST FRR TO GET CONTROL                                   */
*/*  - THE SRM REGISTER SAVE AREA ASSOCIATED WITH THE RTCA           */
*/* OUTPUT FROM THIS SEGMENT IS AS FOLLOWS:                          */
*/*  - THE SKIPPED OVER FRR ENTRIES HAVE BEEN RESET                  */
*/* *****NOTES*****                                                  */
*/*  REGS(R0,R2,R5,R6,R7,R8,R9,R10,R14) ARE RESTRICTED               */
*/*  REG(R14) IS SAVED IN THE SRM REG SAVE AREA ON ENTRY AND RESTORED*/
*/*  PRIOR TO EXIT FROM THIS INTERNAL PROCEDURE                      */
*/*  REGS(R1,R4,R11,R12,R13,R15) ARE VOLATILE                        */
*/*  REG(R3) IS USED TO OPTIMIZE THE CODE                            */
*/*                                                                  */
*/* PROCEDURE NAME - STAKMAIN                                        */
*/* SEGMENT NAME - SSTKMAIN                                          */
*/* PROCEDURE OPTIONS - NOSAVE NOSAVEAREA                            */
*/*                                                                  */
*/*  DELTAFRR -AN INTERNAL PROCEDURE IS USED TO SCAN THE SKIPPED OVER*/
*/*             FRR ENTRIES                                          */
*/*  NORMPERC - AN INTERNAL PROCEDURE IS USED TO PERFORM NORMAL      */
*/*             PERCOLATION WHEN THE SKIPPED OVER FRR ENTRIES HAVE   */
*/*             ALL BEEN RESET                                       */
*/* ******************************************************************/
*                                                                  0933
*STAKMAIN:                                                         0933
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0933
STAKMAIN DS    0H                                                  0934
*   RFY                                                            0934
*    (R0,                           /* VOLATILE REGISTERS THAT MUST  */
*     R2,                           /* BE PRESERVED THROUGHOUT THIS  */
*     R5,                           /* PROCEDURE                     */
*     R6,                                                          0934
*     R7,                                                          0934
*     R8,                                                          0934
*     R14) RSTD;                                                   0934
*   RFY                                                            0935
*     R3 RSTD;                                                     0935
*   R3=RT1WRTCA;                                                   0936
         L     R3,RT1WRTCA(,R8)                                    0936
*   RFY                                                            0937
*     SRMRGSV BASED(R3+LENGTH(SDWA));                              0937
*   SRMREG14=R14;                   /* CHKPT THE RETURN ADDRESS TO 0938
*                                      THE CALLER OF THE PROC        */
         ST    R14,SRMREG14+512(,R3)                               0938
*   DO WHILE FRRSCURR^=SRMTGFRR;    /* LOOP THROUGH THE FRR ENTRIES
*                                      ON THE INTERRUPTED STACK AS 0939
*                                      LONG AS THE SAVED POINTER TO
*                                      THE FRR ENTRY ASSOCIATED WITH
*                                      THE LAST FRR TO GET CONTROL 0939
*                                      DOES NOT EQUAL THE CURRENT FRR
*                                      ENTRY ON THE STACK            */
         B     @DE00939                                            0939
@DL00939 DS    0H                                                  0940
*     FRRSFLGS=''B;                 /* ZERO SRM INDICATORS IN FRR  0940
*                                      ENTRY                         */
         L     @15,FRRSCURR(,R8)                                   0940
         XC    FRRSFLGS(4,@15),FRRSFLGS(@15)                       0940
*     CALL DELTAFRR;                /* DELETE THE FRR FROM THE STACK */
         BAL   @14,DELTAFRR                                        0941
*   END;                                                           0942
@DE00939 CLC   FRRSCURR(4,R8),SRMTGFRR+512(R3)                     0942
         BNE   @DL00939                                            0942
*   CALL NORMPERC;                  /* WHEN THE CURRENT FRR ENTRY  0943
*                                      ADDRESS EQUALS THE SAVED FRR
*                                      ENTRY ADDRESS PERFORM NORMAL
*                                      PERCOLATION                   */
         BAL   @14,NORMPERC                                        0943
*   R14=SRMREG14;                   /* REESTABLISH THE RETURN ADDR TO
*                                      THE CALLER                    */
         L     R14,SRMREG14+512(,R3)                               0944
*   RFY                                                            0945
*     R3 UNRSTD;                                                   0945
*   RFY                                                            0946
*     SRMRGSV BASED(RT1WRTCA+LENGTH(SDWA));                        0946
*   END STAKMAIN;                                                  0947
*                                                                  0947
@EL00005 DS    0H                                                  0947
@EF00005 DS    0H                                                  0947
@ER00005 BR    @14                                                 0947
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT IS AN INTERNAL PROCEDURE WHICH PERFORMS THE      */
*   /* FUNCTION OF DELETING FRRS FROM THE CURRENT FRR STACK INPUT -  */
*   /* REGISTERS R11 AND R12 WILL BE USED AS WORKREGS WHEN ISSUING   */
*   /* THE SETFRR MACRO WITH THE DELETE OPTION - PSACSTK POINTS TO   */
*   /* THE FRR STACK IN WHICH THE CURRENT FRR WILL BE DELETED OUTPUT */
*   /* - REGISTER R11 AND R12 DESTROYED BY THE SETFRR MACRO NOTES -  */
*   /* REGISTER R14 CONTAINING THE RETURN ADDRESS TO THE CALLER MUST */
*   /* NOT BE USED IN THIS PROCEDURE - REGISTERS(R0,R2,R5,R6,R7,R8)  */
*   /* MUST BE PRESERVED THOUGHOUT THIS PROCEDURE                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0948
*DELTAFRR:                                                         0948
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0948
DELTAFRR DS    0H                                                  0949
*   RFY                                                            0949
*    (R11,                                                         0949
*     R12) RSTD;                                                   0949
*   GENERATE CODE;                                                 0950
         SETFRR D,WRKREGS=(R11,R12)    DELETE A FRR
*   RFY                                                            0951
*    (R11,                                                         0951
*     R12) UNRSTD;                                                 0951
*   END DELTAFRR;                                                  0952
*                                                                  0952
@EL00006 DS    0H                                                  0952
@EF00006 DS    0H                                                  0952
@ER00006 BR    @14                                                 0952
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT IS AN INTERNAL PROCEDURE WHOSE FUNCTION IS TO    */
*   /* ADJUST THE MODE AND RTCA WHICH SUPPORTS A GLOBALLY LOCKED OR  */
*   /* PHYSICALLY DISABLED FAILURE TO THE MODE AND RTCA WHICH        */
*   /* SUPPORTS ALOCALLY LOCKED FAILURE IN PREPARATION FOR           */
*   /* PERCOLATING FROM A FRR WHICH RECOVERS A GLOBALLY LOCKED OR    */
*   /* PHYSICALLY DISABLED FUNCTION TO ONE WHICH RECOVERS A LOCALLY  */
*   /* LOCKED FUNCTION SEGMENT NAME-GTOL PROCEDURE NAME=XGTOL        */
*   /* PROCEDURE OPTIONS-NOSAVE NOSAVEAREA OPERATION THE LOCAL RTCA  */
*   /* IS ALLOCATED AND THE CONTENTS OF THE GLOBAL RTCA IS COPIED    */
*   /* INTO THE LOCAL RTCA. THE MODE IS ADJUSTED TO REFLECT LOCAL    */
*   /* MODE INPUT - RT1WRTCA FIELD OF THE RTM1 WORK AREA PROTION OF  */
*   /* THE INTERRUPTED STACK POINTS TO THE GLOBAL RTCA -             */
*   /* PSAAOLD->ASCB->ASXB->ASXBFRWA(LOCAL RTCA) - WORKREG           */
*   /* REGISTER(R4) USED AS A WORK REGISTER - CURRSTK REGISTER(R8)   */
*   /* POINTS TO THE INTERRUPTED STACK - SRMSTAK REGISTER(R2) POINTS */
*   /* TO THE SRM RECOVERY STACK - RT1WSRMD(MODEBYTE) CONTAINS THE   */
*   /* MODE - TARGRTCA REGISTER(R5) POINTS TO THE GLOBAL RTCA OUTPUT */
*   /* - TARGRTCA REGISTER(R5) POINTS TO THE LOCAL RTCA - RT1WRTCA   */
*   /* FIELD OF THE RTM1 WORK AREA POINTS TO THE LOCAL RTCA -        */
*   /* RT1WSRMD(MODEBYTE) INDICATES THE NEW MODE OF LOCAL NOTES -    */
*   /* REGS(R0,R2,R5,6,R7,R8) ARE UNCHANGED THROUGHOUT THIS SEGMENT -*/
*   /* REGS(R1,R3,R4,R11,R12,R13,R14,R15) ARE VOLATILE               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0953
*XGTOL:                                                            0953
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0953
XGTOL    DS    0H                                                  0954
*   RFY                                                            0954
*     R14 RSTD;                     /* PRESERVE RETURN ADDRESS TO  0954
*                                      CALLER OF XGTOL               */
*   RFY                                                            0955
*    (R0,                           /* VOLATILE REGS THAT MUST BE    */
*     R2,                           /* ACROSS THE CALL TO THIS       */
*     R5,                           /* PROCEDURE                     */
*     R6,                                                          0955
*     R7,                                                          0955
*     R8) RSTD;                                                    0955
*   DO;                                                            0956
*     RFY                                                          0957
*       R4 RSTD;                                                   0957
*     RFY                                                          0958
*       NEWRTCA BASED(R4);          /* THE NEW RTCA IS BASED         */
*     R4=ASXBFRWA;                  /* THE NEW RTCA IS THE LOCAL RTCA*/
         L     @15,PSAAOLD                                         0959
         L     @15,ASCBASXB(,@15)                                  0959
         L     R4,ASXBFRWA(,@15)                                   0959
*     NEWRTCA(1:256)=SDWA(1:256);   /* COPY CONTENTS OF              */
         L     @15,RT1WRTCA(,R8)                                   0960
         MVC   NEWRTCA(256,R4),SDWA(@15)                           0960
*     NEWRTCA(257:512)=SDWA(257:512);/* OLD RTCA TO NEW RTCA         */
         MVC   NEWRTCA+256(256,R4),SDWA+256(@15)                   0961
*     NEWRGSV=SRMRGSV;              /* COPY SRM REG SAVE             */
         MVC   NEWRGSV(72,R4),SRMRGSV+512(@15)                     0962
*     R5=R4;                        /* THE LOCAL RTCA IS NOW ACTIVE  */
         LR    R5,R4                                               0963
*     RT1WRTCA=R4;                  /* LOCAL RTCA IS ACTIVE          */
         ST    R4,RT1WRTCA(,R8)                                    0964
*     SDWARECA=ADDR(SDWAVRA);       /* INIT PTR TO VARIABLE RECORDING
*                                      AREA IN LOCAL RTCA    @YM02623*/
         L     @15,RT1WRTCA(,R8)                                   0965
         LA    @12,SDWAVRA(,@15)                                   0965
         ST    @12,SDWARECA(,@15)                                  0965
*     SDWADPLA=ADDR(SDWASNPA);      /* INIT PTR TO DUMP PARM LIST IN
*                                      THE LOCAL RTCA        @YM02623*/
         LA    @12,SDWASNPA(,@15)                                  0966
         ST    @12,SDWADPLA(,@15)                                  0966
*     RFY                                                          0967
*       NEWRTCA;                                                   0967
*     IF MODEGSUS=ON THEN           /* IF A GLOBAL SUSPEND LOCK IS 0968
*                                      HELD DO FOLLOWING             */
         LA    @12,81                                              0968
         ALR   @12,R8                                              0968
         TM    MODEGSUS(@12),B'00010000'                           0968
         BNO   @RF00968                                            0968
*       IF SDWACMS=ON THEN          /* AND THE CMS LOCK IS REQUESTED
*                                      TO BE FREED BY THE FRR        */
         TM    SDWACMS(@15),B'00000010'                            0969
         BNO   @RF00969                                            0969
*         MODEGSUS=OFF;             /* INDICATE LOCAL MODE WITH THE
*                                      CMS LOCK UNOWNED              */
         NI    MODEGSUS(@12),B'11101111'                           0970
*       ELSE                                                       0971
*         ;                         /* OTHERWISE INDICATE THAT BOTH
*                                      THE CMS AND LOCK LOCKS ARE  0971
*                                      HELD(CMS LOCAL MODE           */
@RF00969 DS    0H                                                  0972
*     ELSE                                                         0972
*       ;                           /* OTHERWISE THE MODE IS STRICTLY
*                                      LOCAL MODE                    */
@RF00968 DS    0H                                                  0973
*     MODEGSPN=OFF;                 /* INDICATE LOCAL MODE           */
*     MODEDIS=OFF;                  /* NO GLOBAL SPIN LOCKS HELD AND
*                                      ENABLED                       */
*     MODESUPR=OFF;                 /* SUPER MODE INACTIVE           */
         NI    MODEGSPN+81(R8),B'00011111'                         0975
*     RFY                                                          0976
*       R4 UNRSTD;                                                 0976
*   END;                                                           0977
*   END XGTOL;                                                     0978
*                                                                  0978
@EL00007 DS    0H                                                  0978
@EF00007 DS    0H                                                  0978
@ER00007 BR    @14                                                 0978
*/* ******************************************************************/
*/* THIS SEGMENT TRANSFERS THE MODE OF FRR PROCESSING FROM GLOBALLY  */
*/* LOCKED MODE TO SRB MODE WHEN IT IS DETERMINED THAT PRIOR TO      */
*/* PERCOLATING TO THE NEXT FRR THE LOCKS REQUESTED TO BE FREED BY   */
*/* THE PERCOLATING FRR,WHEN FREED WILL RESULT IN UNLOCKED SRB MODE  */
*/* FRR PROCESSING WHERE AT LEAST ONE GLOBALLY LOCK IS REQUESTED TO  */
*/* BE FREED OR ALL SUPER BITS ARE OFF                               */
*/* ******************************************************************/
*                                                                  0979
*XGTOS:                                                            0979
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0979
XGTOS    DS    0H                                                  0980
*   RFY                                                            0980
*     R14 RSTD;                                                    0980
*   RFY                                                            0981
*    (R0,                           /* VOLATILE REGS THAT MUST BE    */
*     R2,                           /* ACROSS THE CALL TO THIS       */
*     R5,                           /* PROCEDURE                     */
*     R6,                                                          0981
*     R7,                                                          0981
*     R8) RSTD;                                                    0981
*   CHKPT3=R14;                     /* PRESERVE RETURN ADDRESS TO THE
*                                      CALLER OF XGTOS               */
         ST    R14,CHKPT3+48(,R8)                                  0982
*   DO;                                                            0983
*     RFY                                                          0984
*      (R1,                         /* FURTHER REGISTERS DESTROYED   */
*       R11,                                                       0984
*       R13) RSTD;                  /* BY THE LOCK MGR               */
*     GENERATE CODE;                                               0985
         SETLOCK RELEASE,TYPE=SPIN,DISABLED,                           C
               RELATED=('FREE SPIN LOCKS GOING TO SRB MODE')
*     RFY                                                          0986
*      (R11,                                                       0986
*       R13) UNRSTD;                                               0986
*     LKTOFREE=LKTOFREE&CMSLOCLK;                                  0987
         L     @15,RT1WRTCA(,R8)                                   0987
         NC    LKTOFREE(2,@15),@CB03178                            0987
*     RFY                                                          0988
*       R0 RSTD;                                                   0988
*     CHKPT4=R0;                    /* SAVE THE CONTENTS OF THE    0989
*                                      FUNCTION REGISTER SINCE IT IS
*                                      DESTROYED BY THE INTERNAL PROC
*                                      GSRBRTCA CALLED TO OBTAIN A 0989
*                                      SRB RTCA                      */
         ST    R0,CHKPT4+48(,R8)                                   0989
*     CALL GSRBRTCA;                /* ACQUIRE A SRB RTCA            */
         BAL   @14,GSRBRTCA                                        0990
*     IF R1=ASXBFRWA THEN           /* IF THE ACQUIRED SRB SDWA IS 0991
*                                      THE LOCAL SDWA,       @YA00097*/
         L     @15,PSAAOLD                                         0991
         L     @15,ASCBASXB(,@15)                                  0991
         C     R1,ASXBFRWA(,@15)                                   0991
         BNE   @RF00991                                            0991
*       DO;                         /* MAKE FURTHER CHECKS   @YA00097*/
*         IF R1->SDWARPIV=ON THEN   /* IF THE LOCAL LOCK WAS OBTAINED
*                                      UNCONDITIONALLY AND THE REGS
*                                      AND PSW ARE POSSIBLY INVALID
*                                                            @YA00097*/
         TM    SDWARPIV(R1),B'00000100'                            0993
         BNO   @RF00993                                            0993
*           SDWARPIV=ON;            /* INDICATE THIS IN THE CURRENT
*                                      SDWA                  @YA00097*/
         L     @15,RT1WRTCA(,R8)                                   0994
         OI    SDWARPIV(@15),B'00000100'                           0994
*         SDWAFLLK=OFF;             /* INDICATE IN THE CURRENT SDWA
*                                      THAT THE LOCAL LOCK MUST NOT
*                                      BE FREED              @YA00097*/
@RF00993 L     @15,RT1WRTCA(,R8)                                   0995
         NI    SDWAFLLK(@15),B'11111110'                           0995
*       END;                        /*                       @YA00097*/
*     ELSE                          /* IF THE ACQUIRED SDWA IS NOT 0997
*                                      THE LOCAL SDWA        @YA00097*/
*       MODELOC=OFF;                /* THEN INSURE THAT THE MODE BYTE
*                                      NO LONGER INDICATES LOCAL MODE
*                                                            @YA00097*/
         B     @RC00991                                            0997
@RF00991 NI    MODELOC+81(R8),B'11110111'                          0997
*     RFY                                                          0998
*       NEWRTCA BASED(R1);                                         0998
@RC00991 DS    0H                                                  0999
*     NEWRTCA(1:256)=SDWA(1:256);   /* COPY CONTENTS OF              */
         L     @15,RT1WRTCA(,R8)                                   0999
         MVC   NEWRTCA(256,R1),SDWA(@15)                           0999
*     NEWRTCA(257:LENGTH(SDWA))=SDWA(257:LENGTH(SDWA));/* GLOBAL RTCA
*                                      INTO THE ACQUIRED SRB RTCA    */
         MVC   NEWRTCA+256(256,R1),SDWA+256(@15)                   1000
*     NEWRGSV=SRMRGSV;              /* COPY SRM REG SAVE             */
         MVC   NEWRGSV(72,R1),SRMRGSV+512(@15)                     1001
*     RT1WRTCA=R1;                  /* MAKE THE ACQUIRED SRB RTCA THE
*                                      CURRENTLY ACTIVE RTCA         */
         ST    R1,RT1WRTCA(,R8)                                    1002
*     MODEDIS=OFF;                  /* THE MODEBYTE WILL INDICATE    */
*     MODEGSPN=OFF;                 /* SRB MODE                      */
*     MODEGSUS=OFF;                                                1005
*     MODESUPR=OFF;                 /* SUPER MODE INACTIVE           */
         NI    MODEDIS+81(R8),B'00001111'                          1006
*     SDWARECA=ADDR(SDWAVRA);       /* INIT PTR TO VARIABLE RECORDING
*                                      AREA IN SRB RTCA      @YM02623*/
         L     @15,RT1WRTCA(,R8)                                   1007
         LA    @12,SDWAVRA(,@15)                                   1007
         ST    @12,SDWARECA(,@15)                                  1007
*     SDWADPLA=ADDR(SDWASNPA);      /* INIT PTR TO DUMP PARAMETER  1008
*                                      LIST IN SRB RTCA      @YM02623*/
         LA    @12,SDWASNPA(,@15)                                  1008
         ST    @12,SDWADPLA(,@15)                                  1008
*     SDWAIDNT=SQARTCA;                                            1009
         L     @12,SQARTCA                                         1009
         ST    @12,SDWAIDNT(,@15)                                  1009
*     R5=R1;                        /* MAKE THE SRB RTCA INTERNALLY
*                                      KNOWN TO SRM                  */
         LR    R5,R1                                               1010
*     R0=CHKPT4;                    /* RESTORE THE FUNCTION REGISTER
*                                      TO SRM PROCESSING             */
         LA    @15,48                                              1011
         ALR   @15,R8                                              1011
         L     R0,CHKPT4(,@15)                                     1011
*     RFY                                                          1012
*       R1 UNRSTD;                                                 1012
*   END;                                                           1013
*   R14=CHKPT3;                     /* RESTORE THE RETURN ADDRESS TO
*                                      THE CALLER                    */
         L     R14,CHKPT3(,@15)                                    1014
*   END XGTOS;                                                     1015
*                                                                  1015
@EL00008 DS    0H                                                  1015
@EF00008 DS    0H                                                  1015
@ER00008 BR    @14                                                 1015
*/* ******************************************************************/
*/* THIS SEGMENT IS AN INTERNAL PROCEDURE THAT VERIFIES THE LOCKS    */
*/* HELD STATUS ON RETURN FROM A FRR BY                              */
*/*   1. ISOLATING LOCKS RELEASED BY THE FRR                         */
*/*   2. ISOLATING LOCKS OBTAINED BY THE FRR                         */
*/*   3. PROVIDES AS OUTPUT THE LOCKS HELD STATUS REQUIRED TO        */
*/*      A. UPDATE LOCKS REQUESTED TO BE FREED BY THE FRR            */
*/*      B. UPDATES THE CURRENT LOCKS HELD STATUS                    */
*/*                                                                  */
*/*   SEGMENT NAME - LOCKVERF                                        */
*/*   PROCEDURE NAME - LOCKVERF                                      */
*/*   PROCEDURE OPTIONS - NOSAVE NOSAVEAREA                          */
*/*                                                                  */
*/*   INPUT                                                          */
*/*    TARGRTCA REG(R5) - POINTS TO THE CURRENTLY ACTIVE RTCA        */
*/*    WHICH CONTAINS THE LOCKS REQUESTED TO BE FREED BY THE FRR     */
*/*    CURRSTK REG(R8) - POINTS TO THE INTERRUPTED FRR STACK IN      */
*/*    WHICH IS THE LOCKS HELD STATUS PRIOR TO INVOKING THE FRR      */
*/*                                                                  */
*/*   OUTPUT                                                         */
*/*    LKIDX REG(R4) - CONTAINS THE MASK INDICATING LOCKS            */
*/*    CURRENTLY HELD BY THIS CPU                                    */
*/*    FRLKREG REG(R1) - CONTAINS THE MASK INDICATING LOCKS          */
*/*    ADDITIONALLY OBTAINED BY THE FRR                              */
*/*    BITSET REG(R3) - CONSTAINS THE MASK INDICATING THE LOCKS      */
*/*    FREED BY THE FRR                                              */
*/*                                                                  */
*/*    NOTES                                                         */
*/*    REGS(R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R14) ARE RESTRICTED    */
*/*    THROUGHOUT THIS PROCEDURE                                     */
*/*    REGS(R11,R12,R13,R15) ARE VOLATILE                            */
*/*    SETLOCK TEST FUNCTION IS INVOKED TO ESTABLISHED CURRENT       */
*/*    LOCKS HELD STATUS                                             */
*/* ******************************************************************/
*                                                                  1016
*LOCKVERF:                                                         1016
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               1016
LOCKVERF DS    0H                                                  1017
*   RFY                                                            1017
*    (R4,                           /* REGISTERS USED IN VERIFYING   */
*     R3,                           /* VALID LOCK FREEING REQUESTS   */
*     R11,                          /* MADE BY FRRS                  */
*     R0,                                                          1017
*     R2,                                                          1017
*     R5,                                                          1017
*     R6,                                                          1017
*     R7,                                                          1017
*     R8,                                                          1017
*     R14,                                                         1017
*     R1) RSTD;                                                    1017
*   R3=NULL;                        /* INITIALIZE THE REGISTERS      */
         SLR   R3,R3                                               1018
*   R4=NULL;                                                       1019
         SLR   R4,R4                                               1019
*   R11=NULL;                                                      1020
         SLR   R11,R11                                             1020
*   GENERATE CODE;                                                 1021
*                                      /*TEST LOCKS                  */
         SETLOCK TEST,TYPE=ALL,REGS=(R11)
         LR    R1,R11
         L     R3,RT1WRTCA(,R8)  GET LOCKS HELD MASK  @YM02684
         ICM   R4,3,LOCKMASK+512(R3) GET LKS HELD      @YM02684
         XR    R1,R4      ISOLATE LOCKS ACQUIRED AND RELEASED
         LR    R3,R1     SAVE LOCKS ACQUIRED AND RELEASED
         NR    R1,R11  ISOLATE ADDED LOCKS OBTAINED BY FRR
         NR    R3,R4  ISOLATE LOCKS RELEASED BY FRR
         XR    R4,R3   ESTABLISH NEW LOCK MASK
*   END LOCKVERF;                                                  1022
*                                                                  1022
@EL00009 DS    0H                                                  1022
@EF00009 DS    0H                                                  1022
@ER00009 BR    @14                                                 1022
*/* ******************************************************************/
*/* THIS SEGMENT TRANSFER THE MODE OF FRR PROCESSING FROM LOCALLY    */
*/* LOCKED MODE TO SRB MODE WHEN IT IS DETERMINED THAT PRIOR TO      */
*/* PERCOLATING TO THE NEXT FRR THE LOCKS REQUESTED TO BE FREED BY   */
*/* THE PERCOLATING FRR WHEN FREED WILL RESULT IN UNLOCKED SRB MODE  */
*/* FRR PROCESSING                                                   */
*/* ******************************************************************/
*                                                                  1023
*XLTOS:                                                            1023
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               1023
XLTOS    DS    0H                                                  1024
*   RFY                                                            1024
*     R14 RSTD;                                                    1024
*   RFY                                                            1025
*    (R0,                           /* VOLATILE REGS THAT MUST BE    */
*     R2,                           /* ACROSS THE CALL TO THIS       */
*     R5,                           /* PROCEDURE                     */
*     R6,                                                          1025
*     R7,                                                          1025
*     R8) RSTD;                                                    1025
*   CHKPT3=R14;                     /* PRESERVE THE RETURN ADDRESS TO
*                                      THE CALLER OF XLTOS           */
         LA    @15,48                                              1026
         ALR   @15,R8                                              1026
         ST    R14,CHKPT3(,@15)                                    1026
*   DO;                                                            1027
*     RFY                                                          1028
*       R1 RSTD;                                                   1028
*     CHKPT4=R0;                    /* CHKPT FUNCTION REGISTER WHICH
*                                      IS DESTROYED BY GSRBRTCA PROC
*                                      USED HERE TO ACQUIRE A SQA  1029
*                                      RTCA FOR SRB MODE             */
         ST    R0,CHKPT4(,@15)                                     1029
*     CALL GSRBRTCA;                /* ACQUIRE A SQA RTCA            */
         BAL   @14,GSRBRTCA                                        1030
*     RFY                                                          1031
*       NEWRTCA BASED(R1);          /* ESTABLISH ADDRESSABILITY TO 1031
*                                      THE GETMAINED SRB RTCA        */
*     IF R1^=ASXBFRWA THEN          /* IF THE ACQUIRED SRB RTCA IS 1032
*                                      NOT THE LOCAL RTCA WHICH WOULD
*                                      INDICATE THAT A SQA GETMAIN 1032
*                                      FOR THE SRB RTCA DID NOT FAIL
*                                      THEN IT CAN BE INITIALIZED  1032
*                                      WITH THE CONTENTS OF THE LOCAL
*                                      RTCA                          */
         L     @15,PSAAOLD                                         1032
         L     @15,ASCBASXB(,@15)                                  1032
         C     R1,ASXBFRWA(,@15)                                   1032
         BE    @RF01032                                            1032
*       DO;                         /* PERFORM THE FOLLOWING       1033
*                                      INITIALIZATION                */
*         NEWRTCA(1:256)=SDWA(1:256);/* COPY CONTENTS OF             */
         L     @15,RT1WRTCA(,R8)                                   1034
         MVC   NEWRTCA(256,R1),SDWA(@15)                           1034
*         NEWRTCA(257:LENGTH(SDWA))=SDWA(257:LENGTH(SDWA));/* LOCAL
*                                      RTCA INTO ACQUIRED RTCA       */
         MVC   NEWRTCA+256(256,R1),SDWA+256(@15)                   1035
*         NEWRGSV=SRMRGSV;          /* COPY SRM REG SAVE             */
         MVC   NEWRGSV(72,R1),SRMRGSV+512(@15)                     1036
*         MODELOC=OFF;              /* SINCE THE SYSTEM STATE IS   1037
*                                      CHANGING FROM LOCALLY LOCKED
*                                      MODE TO SRB MODE UPDATE THE 1037
*                                      MODE TO REFLECT THIS CHANGE   */
         NI    MODELOC+81(R8),B'11110111'                          1037
*         R5=R1;                    /* MAKE THE ACQUIRED SRB RTCA  1038
*                                      INTERNALLY KNOWN TO SRM     1038
*                                      PROCESSING                    */
         LR    R5,R1                                               1038
*         RT1WRTCA=R1;              /* MAKE THE ACQUIRED SRB RTCA  1039
*                                      CURRENTLY ACTIVE              */
         ST    R1,RT1WRTCA(,R8)                                    1039
*         SDWAIDNT=SQARTCA;         /* SET LENGTH OF ACQUIRED SET  1040
*                                      SUBPOOL ID                    */
         L     @15,RT1WRTCA(,R8)                                   1040
         L     @12,SQARTCA                                         1040
         ST    @12,SDWAIDNT(,@15)                                  1040
*         SDWARECA=ADDR(SDWAVRA);   /* INIT PTR TO VARIABLE RECORDING
*                                      AREA IN SRB RTCA      @YM02623*/
         LA    @12,SDWAVRA(,@15)                                   1041
         ST    @12,SDWARECA(,@15)                                  1041
*         SDWADPLA=ADDR(SDWASNPA);  /* INIT PTR TO DUMP PARAMETER  1042
*                                      LIST IN SRB RTCA      @YM02623*/
         LA    @12,SDWASNPA(,@15)                                  1042
         ST    @12,SDWADPLA(,@15)                                  1042
*       END;                                                       1043
*     ELSE                                                         1044
*       ;                           /* IF THE GETMAIN FOR A SRB RTCA
*                                      FAILED AND THE LOCAL RTCA WAS
*                                      RETURNED NO COPYING OF RTCA 1044
*                                      CONTENTS NEED TAKE PLACE      */
@RF01032 DS    0H                                                  1045
*     R0=CHKPT4;                    /* REESTABLISH THE FUNCTION    1045
*                                      REGISTER CONTENTS             */
         LA    @15,48                                              1045
         ALR   @15,R8                                              1045
         L     R0,CHKPT4(,@15)                                     1045
*     RFY                                                          1046
*       R1 UNRSTD;                                                 1046
*   END;                                                           1047
*   R14=CHKPT3;                     /* REESTABLISH THE RETURN ADDRESS
*                                      TO THE CALLER                 */
         L     R14,CHKPT3(,@15)                                    1048
*   END XLTOS;                                                     1049
@EL00010 DS    0H                                                  1049
@EF00010 DS    0H                                                  1049
@ER00010 BR    @14                                                 1049
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     1050
*     GPR01F FIXED(31) REG(1),                                     1050
*     GPR03F FIXED(31) REG(3),                                     1050
*     GPR04P PTR(31) REG(4);                                       1050
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       1051
*     I031F FIXED(31) BASED,                                       1051
*     I031P PTR(31) BASED,                                         1051
*     I015F FIXED(15) BASED,                                       1051
*     I015P PTR(15) BASED,                                         1051
*     I008P PTR(8) BASED,                                          1051
*     I001C CHAR(1) BASED;                                         1051
*   END IEAVTRTS                                                   1052
*                                                                  1052
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (RTSSPEC )                                       */
*/*%INCLUDE SYSUT5  (RTSDCLS )                                       */
*/*%INCLUDE SYSLIB  (IHART1W )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHAYSTAK)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (IHARTM2A)                                       */
*/*%INCLUDE SYSLIB  (IHASNP  )                                       */
*/*%INCLUDE SYSLIB  (IHARMPL )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHASHDR )                                       */
*/*%INCLUDE SYSUT5  (FRRPDCLS)                                       */
*/*%INCLUDE SYSUT5  (BINIT   )                                       */
*/*%INCLUDE SYSUT5  (RINIT   )                                       */
*/*%INCLUDE SYSUT5  (ALLOCAT )                                       */
*/*%INCLUDE SYSUT5  (GOTOGSRB)                                       */
*/*%INCLUDE SYSUT5  (INITRTCA)                                       */
*/*%INCLUDE SYSUT5  (READYSTK)                                       */
*/*%INCLUDE SYSUT5  (ADDCOVR )                                       */
*/*%INCLUDE SYSUT5  (INERRTYP)                                       */
*/*%INCLUDE SYSUT5  (INREGPSW)                                       */
*/*%INCLUDE SYSUT5  (INITMODE)                                       */
*/*%INCLUDE SYSLIB  (ERRORID )                                       */
*/*%INCLUDE SYSUT5  (INITDMPO)                                       */
*/*%INCLUDE SYSUT5  (CKRCRDAT)                                       */
*/*%INCLUDE SYSUT5  (SLIPPER )                                       */
*/*%INCLUDE SYSUT5  (ROUTE   )                                       */
*/*%INCLUDE SYSUT5  (SETUPPSW)                                       */
*/*%INCLUDE SYSUT5  (SAVELOKS)                                       */
*/*%INCLUDE SYSUT5  (FRRPREP )                                       */
*/*%INCLUDE SYSUT5  (GOTOFRR )                                       */
*/*%INCLUDE SYSUT5  (TRACEFRR)                                       */
*/*%INCLUDE SYSUT5  (RECORD  )                                       */
*/*%INCLUDE SYSUT5  (RCRDPREP)                                       */
*/*%INCLUDE SYSUT5  (SOFTRCRD)                                       */
*/*%INCLUDE SYSUT5  (ADJUST  )                                       */
*/*%INCLUDE SYSUT5  (CHKRCDE )                                       */
*/*%INCLUDE SYSUT5  (USERCDE )                                       */
*/*%INCLUDE SYSUT5  (CHEKLOKS)                                       */
*/*%INCLUDE SYSUT5  (ADJUSTMR)                                       */
*/*%INCLUDE SYSUT5  (FREEREL )                                       */
*/*%INCLUDE SYSUT5  (NESTFRR )                                       */
*/*%INCLUDE SYSUT5  (SAVECOVR)                                       */
*/*%INCLUDE SYSUT5  (PERKLATE)                                       */
*/*%INCLUDE SYSUT5  (EXIT    )                                       */
*/*%INCLUDE SYSUT5  (EXITSRBM)                                       */
*/*%INCLUDE SYSUT5  (RESRDATA)                                       */
*/*%INCLUDE SYSUT5  (ASRBRTCA)                                       */
*/*%INCLUDE SYSUT5  (PUGETM  )                                       */
*/*%INCLUDE SYSUT5  (AQLRTCA )                                       */
*/*%INCLUDE SYSUT5  (SNRMPERC)                                       */
*/*%INCLUDE SYSUT5  (SFRLOCKS)                                       */
*/*%INCLUDE SYSUT5  (SSTKMAIN)                                       */
*/*%INCLUDE SYSUT5  (XDELFRR )                                       */
*/*%INCLUDE SYSUT5  (GTOL    )                                       */
*/*%INCLUDE SYSUT5  (GTOS    )                                       */
*/*%INCLUDE SYSUT5  (LOCKVERF)                                       */
*/*%INCLUDE SYSUT5  (LTOS    )                                       */
*                                                                  1052
*       ;                                                          1052
@DATA    DS    0H
@CH00196 DC    H'13'
@CH01378 DC    H'108'
@SM03537 MVC   SDWADPSL(0,@12),STORLIST(@15)
@DATD    DSECT
         DS    0F
IEAVTRTS CSECT
         DS    0F
@CF00079 DC    F'1'
@CF00112 DC    F'2'
@CF00115 DC    F'4'
@CF00194 DC    F'12'
@CF00203 DC    F'16'
@CF00122 DC    F'32'
@CF01027 DC    F'84'
@CF00105 DC    F'255'
@CF01015 DC    F'512'
@CF03510 DC    F'868'
@CF03514 DC    F'62720'
@CF03536 DC    F'-4'
@CF03202 DC    XL4'7FFFFFFF'
@CF03531 DC    XL4'0000FFFF'
@CF03178 DC    XL4'0003'
@CF03196 DC    XL4'0001'
@DATD    DSECT
         DS    0D
IEAVTRTS CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
SQARTCA  DS    FL4
         ORG   SQARTCA
SQASPOOL DC    AL1(245)
SQALEN   DC    AL3(512+272)
         ORG   SQARTCA+4
LFRRPSW  DC    XL4'040C0000'
@CC03200 DC    C'ASCB'
@CB03178 DC    X'0003'
@CB03189 DC    X'0000'
@CB03198 DC    X'FFFF'
FRRJNAME DC    CL8'NONE-FRR'
RTSPATCH DS    CL200
         DS    CL2
YSTAK    DC    F'16'
         DC    F'4'
         DC    F'16'
         DC    F'16'
         DC    F'4'
         DC    F'4'
         DC    F'16'
         DC    F'16'
IEAVTRTS CSECT
ROLDMSK  STOSM FIVE12(R5),X'00'   SETUP RETRY SYSTEM STATE     @YM02601
IEACON2  DC    VL4(AHLMCIHB)
RGTMFRR  DC    VL4(RCOVGETM)
RCRDFRR  DC    VL4(RCOVRCRD)
RGTFFRR  DC    VL4(RCOVRGTF)
@DATD    DSECT
@ENDDATD EQU   *
IEAVTRTS CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR01F   EQU   @01
GPR03F   EQU   @03
GPR00F   EQU   @00
GPR04P   EQU   @04
         ENTRY PUGETM2
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSACPULA EQU   PSA+518
PSALCCAV EQU   PSA+528
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSAPI2   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ASCBPTR  EQU   0
TCBPTR   EQU   0
FRREPTR  EQU   0
LCCAPTR  EQU   0
FRRSPTR  EQU   0
SDWAPTR  EQU   0
ASXBPTR  EQU   0
RT1TRACK EQU   0
RT1TRECC EQU   RT1TRACK
RT1TLPN  EQU   RT1TRECC
RT1TLPID EQU   RT1TRECC+1
RT1TENPT EQU   RT1TRECC+2
RT1TACQR EQU   RT1TRECC+3
RTMBRTAB EQU   0
RTMBTERM EQU   RTMBRTAB
MODEBYTE EQU   0
MODESUPR EQU   MODEBYTE
MODEDIS  EQU   MODEBYTE
MODEGSPN EQU   MODEBYTE
MODEGSUS EQU   MODEBYTE
MODELOC  EQU   MODEBYTE
MODETYP1 EQU   MODEBYTE
MODESRB  EQU   MODEBYTE
EED      EQU   0
EEDDES   EQU   EED+4
EEDFLAGS EQU   EEDDES+1
EEDERFL  EQU   EEDFLAGS
EEDERROR EQU   EED+8
EEDVARBL EQU   EED+12
ASCB     EQU   0
ASCBASCB EQU   ASCB
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBJBNI EQU   ASCB+172
ASCBJBNS EQU   ASCB+176
ASXB     EQU   0
ASXBFRWA EQU   ASXB+108
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
LCCA     EQU   0
LCCAPVAD EQU   LCCA+148
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAPDAT EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
LCCAASID EQU   LCCA+732
WSAG     EQU   0
WSAGGMFM EQU   WSAG+4
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSCURR EQU   FRRSHEAD+12
FRRSRTMW EQU   FRRS+16
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSRCUR EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSPARM EQU   FRRSENTR+8
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWATRAN EQU   SDWAAEC1+4
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAIO2  EQU   SDWAEMK2
SDWAEXT2 EQU   SDWAEMK2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWATRN2 EQU   SDWAAEC2+4
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAMCHK EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWATYP1 EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWASRBM EQU   SDWAERRB
SDWAERRC EQU   SDWAFLGS+2
SDWASTAF EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWACLUP EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWAERFL EQU   SDWAERRD
SDWAFMID EQU   SDWA+236
SDWAIOFS EQU   SDWA+238
SDWACPUI EQU   SDWA+239
SDWARTYA EQU   SDWA+240
SDWARECA EQU   SDWA+244
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWACMS  EQU   SDWAACF4
SDWAFLLK EQU   SDWAACF4
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWAASID EQU   SDWA+288
SDWASEQ# EQU   SDWA+290
SDWARECP EQU   SDWA+292
SDWADPLA EQU   SDWA+316
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARCPL EQU   SDWA+364
SDWACOMP EQU   SDWA+392
SDWAERTM EQU   SDWA+396
SDWARA   EQU   SDWA+400
SDWAVRAL EQU   SDWARA
SDWADPVA EQU   SDWARA+2
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
RTCT     EQU   0
RTCTSAP  EQU   RTCT+4
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSUP  EQU   RTCT+6
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSAO  EQU   RTCT+8
RTCTSAO1 EQU   RTCTSAO
RTCTSAO2 EQU   RTCTSAO+1
RTCTSUO  EQU   RTCT+10
RTCTSUO1 EQU   RTCTSUO
RTCTSUO2 EQU   RTCTSUO+1
RTCTSDO  EQU   RTCT+12
RTCTSDO1 EQU   RTCTSDO
RTCTSDO2 EQU   RTCTSDO+1
RTCTABD  EQU   RTCT+14
RTCTIDMP EQU   RTCTABD
RTCTSDF  EQU   RTCT+16
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
SNPPARMS EQU   0
SNPIDENT EQU   SNPPARMS
SNPFLAG  EQU   SNPPARMS+1
SNPSLIST EQU   SNPFLAG
SNPSDATA EQU   SNPPARMS+4
SNPPDATA EQU   SNPPARMS+6
SNPSTOR  EQU   SNPPARMS+16
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RTM2WA   EQU   0
RTM2DESC EQU   RTM2WA
RTM2RT2D EQU   RTM2DESC+8
RTM2CODE EQU   RTM2WA+28
RTM2CCF  EQU   RTM2CODE
RTM2PGCY EQU   RTM2WA+60
RTM2TRRY EQU   RTM2PGCY
RTM2EEDR EQU   RTM2TRRY
RTM2EREG EQU   RTM2EEDR
RTM2APSW EQU   RTM2EEDR+64
RTM2EPSW EQU   RTM2APSW
RTM2EMK1 EQU   RTM2EPSW
RTM2MWP1 EQU   RTM2EPSW+1
RTM2INT1 EQU   RTM2EPSW+2
RTM2NXT1 EQU   RTM2EPSW+4
RTM2AEC1 EQU   RTM2APSW+8
RTM2ILC1 EQU   RTM2AEC1+1
RTM2INC1 EQU   RTM2AEC1+2
RTM2ICD1 EQU   RTM2INC1+1
RTM2EEDH EQU   RTM2TRRY+92
RTM2STCK EQU   RTM2EEDH
RTM2MCHI EQU   RTM2EEDH+8
RTM2MCHS EQU   RTM2MCHI
RTM2MCHD EQU   RTM2MCHI+1
RTM2RSR1 EQU   RTM2EEDH+12
RTM2RSR2 EQU   RTM2EEDH+13
RTM2FLGS EQU   RTM2TRRY+120
RTM2ERRA EQU   RTM2FLGS
RTM2ERRB EQU   RTM2FLGS+1
RTM2ERRC EQU   RTM2FLGS+2
RTM2ERRD EQU   RTM2FLGS+3
RTM2ERFL EQU   RTM2ERRD
RTM2CVER EQU   RTM2WA+186
RTM2TRRC EQU   RTM2CVER
RTM2IOFS EQU   RTM2TRRC
RTM2IOBP EQU   RTM2TRRC+2
RTM2SCBS EQU   RTM2TRRC+14
RTM2RTCD EQU   RTM2TRRC+26
RTM2SPLL EQU   RTM2RTCD+4
RTM2PARQ EQU   RTM2TRRC+46
RTM2CTL1 EQU   RTM2CVER+50
RTM2CMKA EQU   RTM2CTL1
RTM2MWPA EQU   RTM2CTL1+1
RTM2PMKA EQU   RTM2CTL1+4
RTM2CTL2 EQU   RTM2CVER+58
RTM2CMKP EQU   RTM2CTL2
RTM2MWPP EQU   RTM2CTL2+1
RTM2PMKP EQU   RTM2CTL2+4
RTM2SNAP EQU   RTM2CVER+66
RTM2SPRM EQU   RTM2SNAP+4
RTM2DPSL EQU   RTM2SNAP+24
RTM2FRM1 EQU   RTM2DPSL
RTM2TO1  EQU   RTM2DPSL+4
RTM2FRM2 EQU   RTM2DPSL+8
RTM2TO2  EQU   RTM2DPSL+12
RTM2FRM3 EQU   RTM2DPSL+16
RTM2TO3  EQU   RTM2DPSL+20
RTM2FRM4 EQU   RTM2DPSL+24
RTM2TO4  EQU   RTM2DPSL+28
RTM2SECB EQU   RTM2CVER+138
RTM2ECBA EQU   RTM2SECB
RTM2SFRG EQU   RTM2CVER+186
RTM2SCTL EQU   RTM2CVER+259
RTM2CCTL EQU   RTM2SCTL
RTM2ABDR EQU   RTM2SCTL+4
RTM2ABID EQU   RTM2ABDR
RTM2ABND EQU   RTM2ABDR+1
RTM2RCTL EQU   RTM2SCTL+6
RTM2INTF EQU   RTM2CVER+266
RTM2CTLR EQU   RTM2INTF
RTM2TSKT EQU   RTM2INTF+2
RTM2ABDP EQU   RTM2INTF+4
RTM2ASIR EQU   RTM2INTF+5
RTM2FLX  EQU   RTM2INTF+6
RTM2FLX1 EQU   RTM2FLX
RTM2FLX2 EQU   RTM2FLX+1
RTM2RECL EQU   RTM2CVER+274
RTM2DCTL EQU   RTM2RECL+12
RTM2ECTL EQU   RTM2RECL+13
RTM2TRYR EQU   RTM2RECL+16
RTM2TRF1 EQU   RTM2TRYR
RTM2TRF2 EQU   RTM2TRYR+2
RTM2RECH EQU   RTM2CVER+294
RTM2RRG  EQU   RTM2CVER+314
RTM2CRG  EQU   RTM2CVER+378
RTM2RMIN EQU   RTM2WA+708
RTM2RMPL EQU   RTM2RMIN+4
RTM2RMWA EQU   RTM2RMIN+28
RTM2ERID EQU   RTM2WA+872
RTM2SEQ# EQU   RTM2ERID
RTM2CPUI EQU   RTM2ERID+2
STORAGE  EQU   0
STORFRM  EQU   STORAGE
STORTO   EQU   STORAGE+4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBRTWA  EQU   TCB+224
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBRTM2  EQU   TCBFBYT1
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
SHDR     EQU   0
SHDRPFC  EQU   SHDR+4
SHDRCTFW EQU   SHDR+8
SHDRFLGS EQU   SHDR+20
SHDRPROC EQU   SHDR+24
SLIPLIST EQU   0
SLPCFRRS EQU   SLIPLIST
SLPRT2WA EQU   SLIPLIST+4
SLPWAPTR EQU   SLIPLIST+8
SLPRTSTK EQU   SLIPLIST+12
IEAVTSLP EQU   0
RTCA     EQU   0
RTCAZ1   EQU   RTCA
RTCAZ11  EQU   RTCA+204
RTCAERRC EQU   RTCA+234
RTCAERRD EQU   RTCA+235
RTCAFMID EQU   RTCA+236
RTCAZ2   EQU   RTCA+238
RTCACPUI EQU   RTCA+239
RTCAZ21  EQU   RTCA+240
RTCALKS1 EQU   RTCA+254
RTCALKS2 EQU   RTCA+255
RTCALKWA EQU   RTCA+256
RTCAZ3   EQU   RTCA+292
RTCACOMP EQU   RTCA+392
RTCAZ4   EQU   RTCA+396
RTCAMASK EQU   0
RTCALMSK EQU   RTCAMASK+2
GLOBRTCA EQU   0
HRDWDATA EQU   0
NGLBRTCA EQU   0
PSW      EQU   0
PSWIMASK EQU   PSW
PSWIO    EQU   PSWIMASK
PSWEXT   EQU   PSWIMASK
PSWKYMWP EQU   PSW+1
PSWCCPMK EQU   PSW+2
PSWIC    EQU   PSW+4
SRMSTAT  EQU   0
CHKPT1   EQU   SRMSTAT
CHKPT2   EQU   SRMSTAT+4
CHKPT3   EQU   SRMSTAT+8
CHKPT4   EQU   SRMSTAT+12
CHKPT5   EQU   SRMSTAT+16
STORLIST EQU   0
LISTPAIR EQU   STORLIST
TOADDR   EQU   LISTPAIR+4
STOREND  EQU   TOADDR
ERREGS   EQU   0
SRMRGSV  EQU   0
SRMWSAV1 EQU   SRMRGSV
SRMFMSK  EQU   SRMWSAV1
SRMRMSK  EQU   SRMWSAV1+1
LOCKMASK EQU   SRMWSAV1+2
SRMWSAV2 EQU   SRMRGSV+4
SRMREGS  EQU   SRMRGSV+8
SRMREG1  EQU   SRMREGS+4
SRMRVSTK EQU   SRMREGS+8
SRMTGFRR EQU   SRMREGS+16
SRMTRTCA EQU   SRMREGS+20
SRMFRRS  EQU   SRMREGS+24
SRMREG9  EQU   SRMREGS+36
SRMREG11 EQU   SRMREGS+44
SRMREG13 EQU   SRMREGS+52
SRMREG14 EQU   SRMREGS+56
NEWRTCA  EQU   0
NEWRGSV  EQU   NEWRTCA+512
FRRWA    EQU   0
PSWEXT1  EQU   0
PSWILCIC EQU   PSWEXT1
JOBNAME  EQU   0
FRRPARMS EQU   0
FRRPFLGS EQU   FRRPARMS
FRRPFLG1 EQU   FRRPFLGS
FRRPFLG2 EQU   FRRPFLGS+1
FRRPRCRD EQU   FRRPFLG2
FRRPHOOK EQU   FRRPFLG2
FRRPRCUR EQU   FRRPFLG2
FRRPFLPN EQU   FRRPFLGS+2
FRRPRTYA EQU   FRRPARMS+4
FRRPISTK EQU   FRRPARMS+8
FRRPREGS EQU   FRRPARMS+12
DUMPARMS EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
SNAPPTR  EQU   0
RT1W     EQU   FRRSRTMW
RT1WNPRS EQU   RT1W
RT1WLPTA EQU   RT1WNPRS
RT1WPSW1 EQU   RT1WNPRS+24
RT1WPSW2 EQU   RT1WNPRS+28
RT1WVARI EQU   RT1WNPRS+32
RT1WPRSV EQU   RT1W+52
RT1WRTCA EQU   RT1WPRSV
RT1WSRBR EQU   RT1WPRSV+4
RT1WENTR EQU   RT1WPRSV+12
RT1WMODE EQU   RT1WENTR
RT1WSRMD EQU   RT1WENTR+1
RT1WCOVR EQU   RT1WENTR+2
RT1WCLUP EQU   RT1WCOVR
RT1TLOCL EQU   RT1WCOVR
RT1TRTCA EQU   RT1WCOVR
RT1WLPN  EQU   RT1WENTR+3
RT1RTRN  EQU   FRRSRTMW
RT1RTRRG EQU   RT1RTRN+4
EEDREGSP EQU   EEDVARBL
EEDREGS  EQU   EEDREGSP
EEDPSW   EQU   EEDREGSP+64
EEDPSW1  EQU   EEDPSW
EEDPSW2  EQU   EEDPSW+8
EEDINILC EQU   EEDPSW2
EEDDUMPO EQU   EEDVARBL
EEDSCDMP EQU   EEDDUMPO
EEDSDDAT EQU   EEDSCDMP+4
EEDHWREP EQU   EEDVARBL
EEDHMCHS EQU   EEDHWREP+8
EEDHMCHD EQU   EEDHWREP+9
EEDHRSRS EQU   EEDHWREP+12
EEDHRSR1 EQU   EEDHRSRS
EEDHRSR2 EQU   EEDHRSRS+1
EEDERMAP EQU   EEDVARBL
EEDERRID EQU   EEDERMAP+70
EEDESEQ# EQU   EEDERRID
EEDECPUI EQU   EEDERRID+2
EEDETIME EQU   EEDERRID+6
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
PSANSTK  EQU   PSARSVTE+4
PSAPSTK  EQU   PSARSVTE+24
PSARSTK  EQU   PSARSVTE+56
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRTMCT EQU   CVTS01+224
CVTRTMS  EQU   CVTS01+244
CVTGLMN  EQU   CVTS01+332
CVTSPSA  EQU   CVTS01+336
CVTRSTWD EQU   CVTS01+368
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LKTOFREE EQU   SDWAACF3
RTMRETAD EQU   CHKPT1
RTMBASE  EQU   CHKPT2
CKFLGSCC EQU   SRMREG1
CKSRMSTK EQU   SRMRVSTK
CKDMPOPT EQU   SRMTRTCA
CKEEDCHN EQU   SRMREG11
CKSVREAP EQU   SRMREG13
ABBMACH  EQU   SDWAMCHI
FRRPSW1  EQU   PSW
SNPCDMP  EQU   SNPIDENT
RCRDPARM EQU   SDWARCPL
RCRDHEAD EQU   RCRDPARM
RCRDTYPE EQU   RCRDHEAD
RCRDNAME EQU   RCRDPARM+4
RCRDERID EQU   RCRDPARM+12
RCRDSEQ# EQU   RCRDERID
RCRDCPUI EQU   RCRDERID+2
RCRDASID EQU   RCRDERID+4
RCRDERTM EQU   RCRDERID+6
RCRDINFO EQU   RCRDPARM+24
REGSTOR  EQU   SDWARCPL
ECPEXT1  EQU   SDWAAEC1
ECPEXT2  EQU   SDWAAEC2
FRRPAINF EQU   FRRPREGS
FRRPREG1 EQU   FRRPAINF
FRRPREG2 EQU   FRRPAINF+4
FRRPREG3 EQU   FRRPAINF+8
FLC      EQU   PSA
RECRTCA  EQU   SDWARCPL
RTCAPTR  EQU   SDWARCPL
*                                      START UNREFERENCED COMPONENTS
@NM00146 EQU   RCRDPARM+22
@NM00145 EQU   RCRDHEAD+1
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
EEDEASID EQU   EEDERRID+4
@NM00010 EQU   EEDERMAP
EEDHTIME EQU   EEDHWREP+20
EEDHRFSA EQU   EEDHWREP+16
@NM00009 EQU   EEDHWREP+14
EEDHVERQ EQU   EEDHRSR2
EEDHPGFX EQU   EEDHRSR2
EEDHFLSQ EQU   EEDHRSR2
EEDHFSQA EQU   EEDHRSR2
EEDHNUCL EQU   EEDHRSR2
EEDHSPER EQU   EEDHRSR2
EEDHINTC EQU   EEDHRSR2
EEDHOFLN EQU   EEDHRSR2
EEDHCHNG EQU   EEDHRSR1
EEDHMSER EQU   EEDHRSR1
@NM00008 EQU   EEDHRSR1
EEDHCPID EQU   EEDHWREP+10
EEDHTERR EQU   EEDHMCHD
EEDHSOFT EQU   EEDHMCHD
EEDHINSF EQU   EEDHMCHD
EEDHACR  EQU   EEDHMCHD
EEDHSCK  EQU   EEDHMCHD
EEDHPSWU EQU   EEDHMCHD
EEDHREGU EQU   EEDHMCHD
EEDHSKYF EQU   EEDHMCHD
@NM00007 EQU   EEDHMCHS
@NM00006 EQU   EEDHMCHS
EEDHRSRF EQU   EEDHMCHS
EEDRSRC  EQU   EEDHMCHS
EEDINVP  EQU   EEDHMCHS
EEDHTSVL EQU   EEDHMCHS
EEDHRCDF EQU   EEDHMCHS
EEDHSRVL EQU   EEDHMCHS
EEDHSCKE EQU   EEDHWREP+4
EEDHSCKB EQU   EEDHWREP
EEDSDPSL EQU   EEDDUMPO+8
EEDSPDAT EQU   EEDSDDAT+2
EEDSSDAT EQU   EEDSDDAT
EEDSDUMP EQU   EEDSCDMP
EEDTRANS EQU   EEDPSW2+4
EEDINTCD EQU   EEDINILC+2
EEDILC   EQU   EEDINILC+1
@NM00005 EQU   EEDINILC
EEDPSWIC EQU   EEDPSW1+4
EEDPSWMK EQU   EEDPSW1
EEDREG15 EQU   EEDREGS+60
EEDREG14 EQU   EEDREGS+56
EEDREG13 EQU   EEDREGS+52
EEDREG12 EQU   EEDREGS+48
EEDREG11 EQU   EEDREGS+44
EEDREG10 EQU   EEDREGS+40
EEDREG9  EQU   EEDREGS+36
EEDREG8  EQU   EEDREGS+32
EEDREG7  EQU   EEDREGS+28
EEDREG6  EQU   EEDREGS+24
EEDREG5  EQU   EEDREGS+20
EEDREG4  EQU   EEDREGS+16
EEDREG3  EQU   EEDREGS+12
EEDREG2  EQU   EEDREGS+8
EEDREG1  EQU   EEDREGS+4
EEDREG0  EQU   EEDREGS
RT1RTYAD EQU   RT1RTRRG+60
RT1R0R14 EQU   RT1RTRRG
@NM00002 EQU   RT1RTRN
@NM00001 EQU   RT1WCOVR
RT1WEREX EQU   RT1WCOVR
RT1WRTM  EQU   RT1WCOVR
RT1WEED  EQU   RT1WPRSV+8
FRRPFLG4 EQU   FRRPFLGS+3
@NM00148 EQU   FRRPFLG2
@NM00147 EQU   FRRPFLG1
FRRPFREE EQU   FRRPFLG1
PSWTRAN  EQU   PSWEXT1+4
PSWINTCD EQU   PSWILCIC+2
PSWILC   EQU   PSWILCIC+1
@NM00144 EQU   PSWILCIC
@NM00139 EQU   NEWRTCA
SRMREG15 EQU   SRMREGS+60
SRMREG12 EQU   SRMREGS+48
SRMREG10 EQU   SRMREGS+40
SRMCRSTK EQU   SRMREGS+32
SRMRCURS EQU   SRMREGS+28
SRMREG3  EQU   SRMREGS+12
SRMFNCT  EQU   SRMREGS
ERREG15  EQU   ERREGS+60
ERREG14  EQU   ERREGS+56
ERREG13  EQU   ERREGS+52
ERREG12  EQU   ERREGS+48
ERREG11  EQU   ERREGS+44
ERREG10  EQU   ERREGS+40
ERREG9   EQU   ERREGS+36
ERREG8   EQU   ERREGS+32
ERREG7   EQU   ERREGS+28
ERREG6   EQU   ERREGS+24
ERREG5   EQU   ERREGS+20
ERREG4   EQU   ERREGS+16
ERREG3   EQU   ERREGS+12
ERREG2   EQU   ERREGS+8
ERREG1   EQU   ERREGS+4
ERREG0   EQU   ERREGS
FROMADDR EQU   LISTPAIR
@NM00143 EQU   PSW+3
PSWSIGNF EQU   PSWCCPMK
PSWWXPON EQU   PSWCCPMK
PSWDECIM EQU   PSWCCPMK
PSWFIXPT EQU   PSWCCPMK
PSWCONCD EQU   PSWCCPMK
@NM00142 EQU   PSWCCPMK
PSWPRBLM EQU   PSWKYMWP
PSWWAIT  EQU   PSWKYMWP
PSWMCHCK EQU   PSWKYMWP
PSWECTM  EQU   PSWKYMWP
PSWKEY   EQU   PSWKYMWP
PSWDAT   EQU   PSWIMASK
PSWEAM   EQU   PSWIMASK
@NM00141 EQU   PSWIMASK
PSWPER   EQU   PSWIMASK
@NM00140 EQU   PSWIMASK
@NM00138 EQU   RTCAMASK
@NM00137 EQU   RTCAERRD
RTCACLUP EQU   RTCAERRD
RTCAERRB EQU   RTCA+233
RTCAIDNT EQU   RTCA+200
SLPWA    EQU   SLIPLIST+16
SHDRIDCT EQU   SHDR+22
SHDRSEQ  EQU   SHDR+21
@NM00136 EQU   SHDRFLGS
SHDRDELP EQU   SHDRFLGS
SHDRFRR  EQU   SHDRFLGS
SHDRBKWD EQU   SHDR+16
SHDRFWD  EQU   SHDRCTFW+4
SHDRCTR  EQU   SHDRCTFW
SHDRCBID EQU   SHDR
@NM00135 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00134 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00133 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00132 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
STORBTO  EQU   STORTO
STORB    EQU   STORFRM
@NM00131 EQU   RTM2WA+882
RTM2ERTM EQU   RTM2ERID+6
RTM2ERAS EQU   RTM2ERID+4
RTM2RMSA EQU   RTM2RMIN+92
RTM2RMWS EQU   RTM2RMWA
RTM2RMPS EQU   RTM2RMIN
RTM2TRSA EQU   RTM2CVER+450
RTM2CREG EQU   RTM2CRG
RTM2RREG EQU   RTM2RRG
RTM2RBRG EQU   RTM2CVER+313
RTM2WARG EQU   RTM2CVER+312
@NM00130 EQU   RTM2CVER+310
RTM2CTRA EQU   RTM2RECH+12
RTM2STRA EQU   RTM2RECH+8
RTM2SKRA EQU   RTM2RECH+4
RTM2TRRA EQU   RTM2RECH
@NM00129 EQU   RTM2TRYR+3
@NM00128 EQU   RTM2TRF2
RTM2GMR  EQU   RTM2TRF2
RTM2PPR  EQU   RTM2TRF2
RTM2IOR  EQU   RTM2TRF2
RTM2AS3R EQU   RTM2TRF1+1
RTM2AS2R EQU   RTM2TRF1+1
RTM2AS1R EQU   RTM2TRF1+1
RTM2XFLG EQU   RTM2TRF1+1
RTM2XABD EQU   RTM2TRF1+1
RTM2XIP  EQU   RTM2TRF1+1
RTM2RTYS EQU   RTM2TRF1+1
RTM2RCD  EQU   RTM2TRF1+1
RTM2FMS  EQU   RTM2TRF1
RTM2VLDY EQU   RTM2TRF1
RTM2HOOK EQU   RTM2TRF1
RTM2PPS  EQU   RTM2TRF1
RTM2GMS  EQU   RTM2TRF1
RTM2IORS EQU   RTM2TRF1
RTM2IOHS EQU   RTM2TRF1
RTM2IOQS EQU   RTM2TRF1
RTM2TMER EQU   RTM2RECL+14
RTM2EQMN EQU   RTM2ECTL
RTM2EDEQ EQU   RTM2ECTL
RTM2EFRM EQU   RTM2ECTL
RTM2ECLS EQU   RTM2ECTL
RTM2ESNP EQU   RTM2ECTL
RTM2EOPN EQU   RTM2ECTL
RTM2EGET EQU   RTM2ECTL
RTM2EENQ EQU   RTM2ECTL
RTM2DFTK EQU   RTM2DCTL
RTM2DDEQ EQU   RTM2DCTL
RTM2DFRM EQU   RTM2DCTL
RTM2DCLS EQU   RTM2DCTL
RTM2DSNP EQU   RTM2DCTL
RTM2DOPN EQU   RTM2DCTL
RTM2DGET EQU   RTM2DCTL
RTM2DENQ EQU   RTM2DCTL
RTM2SCTX EQU   RTM2RECL+8
RTM2SCTR EQU   RTM2RECL+4
RTM2SCTC EQU   RTM2RECL
@NM00127 EQU   RTM2FLX2
RTM2CERX EQU   RTM2FLX2
RTM2RCRX EQU   RTM2FLX2
RTM2RTRX EQU   RTM2FLX1
RTM2LTX  EQU   RTM2FLX1
RTM2PRX  EQU   RTM2FLX1
RTM2CVX  EQU   RTM2FLX1
RTM2DWX  EQU   RTM2FLX1
RTM2ABX  EQU   RTM2FLX1
RTM2EOTX EQU   RTM2FLX1
RTM2MTX  EQU   RTM2FLX1
@NM00126 EQU   RTM2ASIR
RTM2TRME EQU   RTM2ASIR
@NM00125 EQU   RTM2ABDP
RTM2DMP1 EQU   RTM2ABDP
RTM2MEMT EQU   RTM2INTF+3
@NM00124 EQU   RTM2TSKT
RTM2PURG EQU   RTM2TSKT
@NM00123 EQU   RTM2INTF+1
@NM00122 EQU   RTM2CTLR
RTM2WRAP EQU   RTM2CTLR
RTM2TMEM EQU   RTM2CTLR
RTM2RETR EQU   RTM2CTLR
RTM2RECR EQU   RTM2CTLR
@NM00121 EQU   RTM2RCTL
RTM2JPAQ EQU   RTM2RCTL
RTM2LPAQ EQU   RTM2RCTL
RTM2BFTL EQU   RTM2RCTL
RTM2TRSW EQU   RTM2RCTL
RTM2WANA EQU   RTM2RCTL
RTM2WAIN EQU   RTM2RCTL
RTM2STA2 EQU   RTM2RCTL
RTM2STAT EQU   RTM2ABND
RTM2NDMP EQU   RTM2ABND
@NM00120 EQU   RTM2ABID
RTM2SAV2 EQU   RTM2ABID
RTM2SAVE EQU   RTM2ABID
RTM2REG  EQU   RTM2ABID
RTM2PSW  EQU   RTM2ABID
RTM2ENQ  EQU   RTM2ABID
RTM2CB   EQU   RTM2ABID
RTM2MCTL EQU   RTM2SCTL+3
RTM2TCTL EQU   RTM2SCTL+2
@NM00119 EQU   RTM2CCTL+1
RTM2RGEB EQU   RTM2CCTL+1
RTM2DEND EQU   RTM2CCTL+1
RTM2RSCN EQU   RTM2CCTL+1
RTM2CONT EQU   RTM2CCTL
RTM2SLIP EQU   RTM2CCTL
RTM2HEED EQU   RTM2CCTL
RTM2REED EQU   RTM2CCTL
RTM2ISPC EQU   RTM2CCTL
RTM2SQS  EQU   RTM2CCTL
RTM2CNCL EQU   RTM2CCTL
RTM2STPT EQU   RTM2CCTL
RTM2PKEY EQU   RTM2CVER+258
RTM2SFSA EQU   RTM2SFRG
RTM2PRWA EQU   RTM2CVER+182
RTM2PREV EQU   RTM2CVER+178
RTM2SPWA EQU   RTM2CVER+174
RTM2DCBA EQU   RTM2CVER+170
RTM2ECBS EQU   RTM2SECB+16
RTM2LECB EQU   RTM2ECBA
RTM2DTCB EQU   RTM2SNAP+68
RTM2SNCC EQU   RTM2SNAP+64
RTM2DD   EQU   RTM2SNAP+56
RTM2LTO4 EQU   RTM2TO4
RTM2LFR4 EQU   RTM2FRM4
RTM2LTO3 EQU   RTM2TO3
RTM2LFR3 EQU   RTM2FRM3
RTM2LTO2 EQU   RTM2TO2
RTM2LFR2 EQU   RTM2FRM2
RTM2LTO1 EQU   RTM2TO1
RTM2LFR1 EQU   RTM2FRM1
RTM2DPLA EQU   RTM2SNAP
RTM2NXTP EQU   RTM2CTL2+5
RTM2SGP  EQU   RTM2PMKP
RTM2EUP  EQU   RTM2PMKP
RTM2DOP  EQU   RTM2PMKP
RTM2FPP  EQU   RTM2PMKP
RTM2CCP  EQU   RTM2PMKP
RTM2ILP  EQU   RTM2PMKP
RTM2INTP EQU   RTM2CTL2+2
RTM2SPVP EQU   RTM2MWPP
RTM2WATP EQU   RTM2MWPP
RTM2MCKP EQU   RTM2MWPP
@NM00118 EQU   RTM2MWPP
RTM2KEYP EQU   RTM2MWPP
RTM2EXTP EQU   RTM2CMKP
RTM2IOP  EQU   RTM2CMKP
RTM2NXTA EQU   RTM2CTL1+5
RTM2SGA  EQU   RTM2PMKA
RTM2EUA  EQU   RTM2PMKA
RTM2DOA  EQU   RTM2PMKA
RTM2FPA  EQU   RTM2PMKA
RTM2CCA  EQU   RTM2PMKA
RTM2ILA  EQU   RTM2PMKA
RTM2INTA EQU   RTM2CTL1+2
RTM2SPVA EQU   RTM2MWPA
RTM2WATA EQU   RTM2MWPA
RTM2MCKA EQU   RTM2MWPA
@NM00117 EQU   RTM2MWPA
RTM2KEYA EQU   RTM2MWPA
RTM2EXTA EQU   RTM2CMKA
RTM2IOA  EQU   RTM2CMKA
@NM00116 EQU   RTM2PARQ+1
RTM2RCDE EQU   RTM2PARQ
RTM2RYRB EQU   RTM2TRRC+42
RTM2RTYA EQU   RTM2TRRC+38
RTM2COMP EQU   RTM2TRRC+34
RTM2SIZE EQU   RTM2SPLL+1
RTM2SUBP EQU   RTM2SPLL
RTM2RTCA EQU   RTM2RTCD
RTM2SCBO EQU   RTM2SCBS+8
RTM2SCBN EQU   RTM2SCBS+4
RTM2SCBC EQU   RTM2SCBS
RTM2STAR EQU   RTM2TRRC+10
RTM2RBST EQU   RTM2TRRC+6
RTM2FIOB EQU   RTM2IOBP+1
@NM00115 EQU   RTM2IOBP
@NM00114 EQU   RTM2TRRC+1
@NM00113 EQU   RTM2IOFS
RTM2NIOP EQU   RTM2IOFS
RTM2NOIO EQU   RTM2IOFS
RTM2IOHT EQU   RTM2IOFS
RTM2IOQR EQU   RTM2IOFS
RTM2FMID EQU   RTM2TRRY+124
RTM2MCIV EQU   RTM2ERRD
RTM2RPIV EQU   RTM2ERRD
RTM2MABD EQU   RTM2ERRD
RTM2CTS  EQU   RTM2ERRD
RTM2STAE EQU   RTM2ERRD
RTM2NRBE EQU   RTM2ERRD
RTM2CLUP EQU   RTM2ERRD
@NM00112 EQU   RTM2ERRC
RTM2EAS  EQU   RTM2ERRC
RTM2PERC EQU   RTM2ERRC
RTM2IRB  EQU   RTM2ERRC
RTM2STAI EQU   RTM2ERRC
RTM2STAF EQU   RTM2ERRC
RTM2SRBM EQU   RTM2ERRB
RTM2LDIS EQU   RTM2ERRB
RTM2ENRB EQU   RTM2ERRB
RTM2TYP1 EQU   RTM2ERRB
@NM00111 EQU   RTM2ERRB
RTM2PGIO EQU   RTM2ERRA
RTM2TEXC EQU   RTM2ERRA
RTM2SVCE EQU   RTM2ERRA
RTM2ABTM EQU   RTM2ERRA
RTM2SVCD EQU   RTM2ERRA
RTM2RKEY EQU   RTM2ERRA
RTM2PCHK EQU   RTM2ERRA
RTM2MCHK EQU   RTM2ERRA
RTM2TIME EQU   RTM2EEDH+20
RTM2RFSA EQU   RTM2EEDH+16
@NM00110 EQU   RTM2EEDH+14
RTM2VEQR EQU   RTM2RSR2
RTM2PGFX EQU   RTM2RSR2
RTM2FLSQ EQU   RTM2RSR2
RTM2FSQA EQU   RTM2RSR2
RTM2NUCL EQU   RTM2RSR2
RTM2SPER EQU   RTM2RSR2
RTM2INTC EQU   RTM2RSR2
RTM2OFLN EQU   RTM2RSR2
RTM2CHNG EQU   RTM2RSR1
RTM2MSER EQU   RTM2RSR1
@NM00109 EQU   RTM2RSR1
RTM2CPID EQU   RTM2EEDH+10
RTM2TERR EQU   RTM2MCHD
RTM2SOFT EQU   RTM2MCHD
RTM2INSF EQU   RTM2MCHD
RTM2ACR  EQU   RTM2MCHD
RTM2SCK  EQU   RTM2MCHD
RTM2PSWU EQU   RTM2MCHD
RTM2REGU EQU   RTM2MCHD
RTM2SKYF EQU   RTM2MCHD
@NM00108 EQU   RTM2MCHS
RTM2RSRF EQU   RTM2MCHS
RTM2RSRC EQU   RTM2MCHS
RTM2INVP EQU   RTM2MCHS
RTM2TSVL EQU   RTM2MCHS
RTM2RCDF EQU   RTM2MCHS
RTM2SRVL EQU   RTM2MCHS
RTM2SCKE EQU   RTM2STCK+4
RTM2SCKB EQU   RTM2STCK
RTM2ABEP EQU   RTM2TRRY+88
RTM2ABNM EQU   RTM2TRRY+80
RTM2TRAN EQU   RTM2AEC1+4
RTM2IPC1 EQU   RTM2ICD1
RTM2IMC1 EQU   RTM2ICD1
RTM2IPR1 EQU   RTM2ICD1
@NM00107 EQU   RTM2INC1
@NM00106 EQU   RTM2ILC1
RTM2IL1  EQU   RTM2ILC1
@NM00105 EQU   RTM2ILC1
@NM00104 EQU   RTM2AEC1
RTM2ADD1 EQU   RTM2NXT1+1
@NM00103 EQU   RTM2NXT1
@NM00102 EQU   RTM2EPSW+3
RTM2SGN1 EQU   RTM2INT1
RTM2EXP1 EQU   RTM2INT1
RTM2DEC1 EQU   RTM2INT1
RTM2FPO1 EQU   RTM2INT1
RTM2CC1  EQU   RTM2INT1
@NM00101 EQU   RTM2INT1
RTM2PGM1 EQU   RTM2MWP1
RTM2WAT1 EQU   RTM2MWP1
RTM2MCK1 EQU   RTM2MWP1
RTM2ECT1 EQU   RTM2MWP1
RTM2KEY1 EQU   RTM2MWP1
RTM2EXT1 EQU   RTM2EMK1
RTM2AIO1 EQU   RTM2EMK1
RTM2TRM1 EQU   RTM2EMK1
RTM2EAM1 EQU   RTM2EMK1
@NM00100 EQU   RTM2EMK1
RTM2PER1 EQU   RTM2EMK1
@NM00099 EQU   RTM2EMK1
RTM2ER15 EQU   RTM2EREG+60
RTM2ER14 EQU   RTM2EREG+56
RTM2ER13 EQU   RTM2EREG+52
RTM2ER12 EQU   RTM2EREG+48
RTM2ER11 EQU   RTM2EREG+44
RTM2ER10 EQU   RTM2EREG+40
RTM2ER9  EQU   RTM2EREG+36
RTM2ER8  EQU   RTM2EREG+32
RTM2ER7  EQU   RTM2EREG+28
RTM2ER6  EQU   RTM2EREG+24
RTM2ER5  EQU   RTM2EREG+20
RTM2ER4  EQU   RTM2EREG+16
RTM2ER3  EQU   RTM2EREG+12
RTM2ER2  EQU   RTM2EREG+8
RTM2ER1  EQU   RTM2EREG+4
RTM2ER0  EQU   RTM2EREG
RTM2CT   EQU   RTM2WA+56
RTM2VRBT EQU   RTM2WA+52
RTM2TCBT EQU   RTM2WA+48
RTM2SFWA EQU   RTM2WA+32
RTM2CC   EQU   RTM2CODE+1
@NM00098 EQU   RTM2CCF
RTM2EOT  EQU   RTM2CCF
RTM2EOM  EQU   RTM2CCF
RTM2R0DP EQU   RTM2CCF
RTM2STEP EQU   RTM2CCF
RTM2DREQ EQU   RTM2CCF
RTM2ASC  EQU   RTM2WA+24
RTM2VRBC EQU   RTM2WA+20
RTM2TCBC EQU   RTM2WA+16
RTM2CVT  EQU   RTM2WA+12
RTM2LGTH EQU   RTM2RT2D+1
RTM2SPID EQU   RTM2RT2D
RTM2ADDR EQU   RTM2DESC+4
RTM2ID   EQU   RTM2DESC
RMPLDCBL EQU   RMPL+20
RMPLRMWA EQU   RMPL+16
RMPLRBPA EQU   RMPL+12
RMPLTCBA EQU   RMPL+8
RMPLASCB EQU   RMPL+4
RMPLASID EQU   RMPL+2
RMPLFLG2 EQU   RMPL+1
@NM00097 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLIPUF EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
RMPLTERM EQU   RMPLFLG1
RMPLTYPE EQU   RMPLFLG1
SNPTCBA  EQU   SNPPARMS+12
SNPDCB   EQU   SNPPARMS+8
@NM00096 EQU   SNPPARMS+7
@NM00095 EQU   SNPPDATA
SNPSPLS  EQU   SNPPDATA
SNPPSW   EQU   SNPPDATA
SNPJPA   EQU   SNPPDATA
SNPLPA   EQU   SNPPDATA
SNPREGS  EQU   SNPPDATA
SNPSAVE2 EQU   SNPPDATA
SNPSAVE  EQU   SNPPDATA
@NM00094 EQU   SNPPARMS+5
@NM00093 EQU   SNPSDATA
SNPQCB   EQU   SNPSDATA
SNPCB    EQU   SNPSDATA
SNPTRT   EQU   SNPSDATA
SNPSWA   EQU   SNPSDATA
SNPLSQA  EQU   SNPSDATA
SNPSQA   EQU   SNPSDATA
SNPNUC   EQU   SNPSDATA
@NM00092 EQU   SNPPARMS+2
@NM00091 EQU   SNPFLAG
SNPTCB   EQU   SNPFLAG
SNPID    EQU   SNPFLAG
SNPABEND EQU   SNPFLAG
@NM00090 EQU   SNPFLAG
SNPVS2   EQU   SNPFLAG
SNPSNAP  EQU   SNPFLAG
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTXYX2 EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00089 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDPL EQU   RTCT+156
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
@NM00088 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRCB  EQU   RTCT+32
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTSDEP EQU   RTCTSDF2
RTCTSDDO EQU   RTCTSDF2
RTCTSDEN EQU   RTCTSDF2
RTCTSDTR EQU   RTCTSDF2
RTCTSDPT EQU   RTCTSDF2
RTCTSDSR EQU   RTCTSDF2
RTCTSDSS EQU   RTCTSDF2
RTCTSDSH EQU   RTCTSDF2
@NM00087 EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
@NM00086 EQU   RTCTABD+1
@NM00085 EQU   RTCTIDMP
RTCTISVC EQU   RTCTIDMP
RTCTISYU EQU   RTCTIDMP
RTCTISAB EQU   RTCTIDMP
@NM00084 EQU   RTCTIDMP
@NM00083 EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTSYDF EQU   RTCTSUO2
RTCTSYDE EQU   RTCTSUO2
RTCTSYDD EQU   RTCTSUO2
RTCTSYDC EQU   RTCTSUO2
RTCTSYDB EQU   RTCTSUO2
RTCTSYDA EQU   RTCTSUO2
RTCTSYD9 EQU   RTCTSUO2
RTCTSYD8 EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTSADF EQU   RTCTSAO2
RTCTSADE EQU   RTCTSAO2
RTCTSADD EQU   RTCTSAO2
RTCTSADC EQU   RTCTSAO2
RTCTSADB EQU   RTCTSAO2
RTCTSADA EQU   RTCTSAO2
RTCTSAD9 EQU   RTCTSAO2
RTCTSAD8 EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTSUDF EQU   RTCTSUP2
RTCTSUDE EQU   RTCTSUP2
RTCTSUDD EQU   RTCTSUP2
RTCTSUDC EQU   RTCTSUP2
RTCTSUDB EQU   RTCTSUP2
RTCTSUDA EQU   RTCTSUP2
RTCTSUD9 EQU   RTCTSUP2
RTCTSUD8 EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSABF EQU   RTCTSAP2
RTCTSABE EQU   RTCTSAP2
RTCTSABD EQU   RTCTSAP2
RTCTSABC EQU   RTCTSAP2
RTCTSABB EQU   RTCTSAP2
RTCTSABA EQU   RTCTSAP2
RTCTSAB9 EQU   RTCTSAP2
RTCTSAB8 EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00082 EQU   CVTFIX+248
@NM00081 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00080 EQU   SDWA+512
@NM00079 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
@NM00078 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00077 EQU   SDWADDAT+3
@NM00076 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00075 EQU   SDWADDAT+1
@NM00074 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00073 EQU   SDWADUMP+2
@NM00072 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00071 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00070 EQU   SDWAACF3
@NM00069 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00068 EQU   SDWAACF2
@NM00067 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00066 EQU   SDWACPUA
@NM00065 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
@NM00064 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWAENRB EQU   SDWAERRB
@NM00063 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00062 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00061 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00060 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00059 EQU   SDWAINC2
@NM00058 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00057 EQU   SDWAILC2
@NM00056 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00055 EQU   SDWANXT2
@NM00054 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00053 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWATRM2 EQU   SDWAEMK2
@NM00052 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00051 EQU   SDWAEMK2
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00050 EQU   SDWAINC1
@NM00049 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00048 EQU   SDWAILC1
@NM00047 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00046 EQU   SDWANXT1
@NM00045 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00044 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00043 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00042 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00041 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00040 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00039 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00038 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00037 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
@NM00036 EQU   FRRSFLGS+1
@NM00035 EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSELEN EQU   FRRSHEAD+8
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGPGIO EQU   WSAG
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCASGPR EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCACPUS EQU   LCCA+536
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCAR133 EQU   LCCA+444
LCCAR132 EQU   LCCA+440
LCCAR131 EQU   LCCA+436
LCCAR130 EQU   LCCA+432
LCCAR129 EQU   LCCA+428
LCCAR128 EQU   LCCA+424
LCCAR127 EQU   LCCA+420
LCCAR126 EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBEGIN EQU   ASCB
EEDASID  EQU   EEDERROR+2
EEDERTYP EQU   EEDERROR+1
EEDMODE  EQU   EEDERROR
@NM00004 EQU   EEDDES+2
@NM00003 EQU   EEDFLAGS
EEDID    EQU   EEDDES
EEDFWRDP EQU   EED
MODETCB  EQU   MODEBYTE
RTMBXABT EQU   RTMBRTAB+44
RTMBACR  EQU   RTMBRTAB+40
RTMBPROG EQU   RTMBRTAB+36
RTMBMEMT EQU   RTMBRTAB+32
RTMBCABT EQU   RTMBRTAB+28
RTMBPGIO EQU   RTMBRTAB+24
RTMBSVC  EQU   RTMBRTAB+20
RTMBMACH EQU   RTMBRTAB+16
RTMBREST EQU   RTMBRTAB+12
RTMBDAT  EQU   RTMBRTAB+8
RTMBPAD2 EQU   RTMBTERM+6
RTMBBRAN EQU   RTMBTERM+2
RTMBBALR EQU   RTMBTERM
RT1TREGS EQU   RT1TRACK+4
RT1TRETY EQU   RT1TACQR
RT1TLLCK EQU   RT1TACQR
RT1TDISP EQU   RT1TACQR
@NM00034 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00033 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00032 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00031 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00030 EQU   FLCFSA
@NM00029 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00028 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00027 EQU   FLCIOA
@NM00026 EQU   FLCMCLA+15
@NM00025 EQU   FLCMCLA+14
@NM00024 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00023 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00022 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00021 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00020 EQU   FLCPER
@NM00019 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00018 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00017 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00016 EQU   FLCPIILC
@NM00015 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00014 EQU   FLCSVILC
@NM00013 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00012 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00011 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RC00112 EQU   @RC00111
@RF00225 EQU   @RC00220
@RC00214 EQU   @RC00213
@RC00416 EQU   @RC00415
@RC00628 EQU   @RC00618
@RC00620 EQU   @RC00618
@RC00685 EQU   @RC00670
@RC00679 EQU   @RC00670
@RC00671 EQU   @RC00670
@RC00606 EQU   @RC00604
@RC00643 EQU   @RC00604
@RC00748 EQU   @RC00747
@RC00760 EQU   @RC00747
@RC00758 EQU   @RC00747
@RC00817 EQU   @EL00002
@RC00215 EQU   @RC00214
@RC00621 EQU   @RC00620
@RC00630 EQU   @RC00628
@RC00672 EQU   @RC00671
@RC00680 EQU   @RC00679
@RC00216 EQU   @RC00215
@RC00244 EQU   @RC00215
@RC00673 EQU   @RC00672
@RC00681 EQU   @RC00680
@ENDDATA EQU   *
         END   IEAVTRTS,(C'PLS2028',0701,77256)
