         TITLE 'IECDAFMT-MAINLINE FOR DATA MGMT CONTROL BLOCK FORMATTER*
               R        '
IECDAFMT CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IECDAFMT  77.299'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @11,0                                               0001
@PSTART  LA    @12,4095(,@11)                                      0001
         USING @PSTART,@11                                         0001
         USING @PSTART+4095,@12                                    0001
*                                                                  0153
*/********************************************************************/
*/* FUNCTION -                                                     0153
*      ROUTINE TO DETERMINE IF THE DATA MANAGEMENT CONTROL BLOCKS ARE
*      TO BE FORMATTED. IF THEY ARE, IT SCANS THE DEB CHAIN (ALWAYS
*      STARTING AT THE TCB) TO PROCESS EACH DEB.                   0153
*                                                                  0153
*   INPUT -                                                        0153
*      REGISTER 1 MUST POINT TO THE PARMLIST PASSED BY THE CALLER  0153
*                                                                  0153
*   CALLS -                                                        0153
*      ACCESRTN, FORMATIT, RELLOCK, AND PRINT                      0153
*                                                                  0153
*   CALLED BY -                                                    0153
*      AMDPRDMP OR SNAP/ABEND TO FORMAT THE DATA MGMT CONTROL BLOCKS
*                                                                  0153
*   RETURNS TO -                                                   0153
*      CALLER WITH RETURN CODE 0                                   0153
*                                                                    */
*/********************************************************************/
*                                                                  0153
*   TREG2=ABDPLPTR;                 /* SAVE PARM LIST POINTER /*   0153
*                                                            @ZA26256*/
         LR    TREG2,ABDPLPTR                                      0153
*   IF ADPLSNPR=OFF THEN            /* SNAP CALLER           @ZA26256*/
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0154
         BNZ   @RF00154                                            0154
*     DO;                           /* YES.....              @ZA26256*/
*       PARMPTR=ADDR(ADPLCOM2);     /* ADDRESS OF GETMAIN LIST     0156
*                                                            @ZA26256*/
         LA    @14,ADPLCOM2(,ABDPLPTR)                             0156
         LR    PARMPTR,@14                                         0156
*       GENERATE REFS(DREG,ADPLCOM1);                              0157
*                                                         /* @ZA26256*/
    GETMAIN EC,LV=@ENDDATD-@DATD,SP=253,A=ADPLCOM1(TREG2),   @ZA26256  X
               MF=(E,(1))                                    @ZA26256
*     END;                          /* END... SNAP CALLER    @ZA26256*/
*   ELSE                                                           0159
*     DO;                           /*                       @ZA26256*/
         B     @RC00154                                            0159
@RF00154 DS    0H                                                  0160
*       TREG6=0;                    /*                       @ZA26256*/
         SLR   TREG6,TREG6                                         0160
*       GENERATE REFS(TREG6,ADPLSBPL);                             0161
*                                                         /* @ZA26256*/
    IC TREG6,ADPLSBPL(TREG2)                              /* @ZA26256*/
*       PARMPTR=ADDR(ADPLCOM2);     /* ADDRESS OF GETMAIN LIST     0162
*                                                            @ZA26256*/
         LA    @14,ADPLCOM2(,ABDPLPTR)                             0162
         LR    PARMPTR,@14                                         0162
*       GENERATE REFS(TREG6,ADPLSBPL,ADPLCOM1);                    0163
*                                                         /* @ZA26256*/
    GETMAIN EC,LV=@ENDDATD-@DATD,SP=(TREG6),                 @ZA26256  X
               A=ADPLCOM1(TREG2),MF=(E,(1))                  @ZA26256
*     END;                                                         0164
*   IF RCREG^=0 THEN                /* RETURN CODE FROM GM TEST /* 0165
*                                                            @ZA26256*/
@RC00154 LTR   RCREG,RCREG                                         0165
         BZ    @RF00165                                            0165
*     DO;                           /*                       @ZA26256*/
*       IF ADPLSNPR=OFF THEN        /* WHICH ERROR CODE TO USE?    0167
*                                                            @ZA26256*/
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0167
         BNZ   @RF00167                                            0167
*         RETURN CODE(8);           /* RETURN WITH RC 8      @ZA26256*/
         LA    @15,8                                               0168
         L     @14,12(,@13)                                        0168
         LM    @00,@12,20(@13)                                     0168
         BR    @14                                                 0168
*       ELSE                        /*                       @ZA26256*/
*         RETURN CODE(4);           /* RETURN WITH RC 4      @ZA26256*/
@RF00167 LA    @15,4                                               0169
         L     @14,12(,@13)                                        0169
         LM    @00,@12,20(@13)                                     0169
         BR    @14                                                 0169
*     END;                          /*                       @ZA26256*/
*   ABDPLPTR=TREG2;                 /* RESTORE PARM POINTER  @ZA26256*/
@RF00165 LR    ABDPLPTR,TREG2                                      0171
*   DREG=ADPLCOM1;                  /* SAVE ADDRESS OF GETMAINED AREA
*                                                            @ZA26256*/
         L     DREG,ADPLCOM1(,ABDPLPTR)                            0172
*   GENERATE REFS(SAVEA1,REG13);                                   0173
*                                                                  0173
*                                                         /* @ZA26256*/
      USING @DATD,DREG           BASE FOR DSECT              @ZA26256
      ST REG13,SAVEA1+4          SAVE OLD SAVEAREA ADDRESS   @ZA26256
      LA R5,SAVEA1               GET NEW SAVEAREA ADDRESS    @ZA26256
      ST R5,8(REG13)             SAVE NEW SAVEAREA ADDRESS   @ZA26256
      LR REG13,R5                NEW SAVEAREA ADDRESS IN R13 @ZA26256
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH THE ESTAE                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0174
*   ESTAERR=ZERO;                   /* TURN OFF ESTAE BITS   @ZM45067*/
         SLR   @14,@14                                             0174
         ST    @14,ESTAERR                                         0174
*   STM(VADR,RCREG,RTYREGS);        /* SAVE REGS FOR THE ESTAE     0175
*                                                            @ZM45067*/
         STM   VADR,RCREG,RTYREGS                                  0175
*   LCALREGS=RTYREGS;               /* REGS FOR EXPECTED RETRY     0176
*                                                            @ZM45067*/
         MVC   LCALREGS(64),RTYREGS                                0176
*   SAVEREG1=ABDPLPTR;              /* SAVE REGISTER 1 ACCROSS ESTAE */
         LR    SAVEREG1,ABDPLPTR                                   0177
*   ESTAEXEC(1:ESTALEN)=ESTALIST(1:ESTALEN);/* MOVE LIST INTO      0178
*                                      AUTOMATIC AREA                */
         L     @14,ESTALEN                                         0178
         BCTR  @14,0                                               0178
         EX    @14,@SM02961                                        0178
*   GEN FLOWS(ESTAERTN)(ESTAE  ESTAERTN,PARAM=(DREG),MF=(E,ESTAEXEC));
         ESTAE  ESTAERTN,PARAM=(DREG),MF=(E,ESTAEXEC)
*                                   /* ESTAE WITH PARAM POINTING TO
*                                      ALL THE AUTOMATIC DATA FOR  0180
*                                      THIS MODULE                   */
*   IF RCREG=ZERO THEN              /* ESTAE RESOLVED FINE           */
         SLR   @14,@14                                             0180
         CR    RCREG,@14                                           0180
         BNE   @RF00180                                            0180
*     DO;                                                          0181
*       ABDPLPTR=SAVEREG1;          /* RESTORE REG 1                 */
*                                                                  0182
         LR    ABDPLPTR,SAVEREG1                                   0182
*       /*************************************************************/
*       /*                                                           */
*       /* FORMAT THE CONTROL BLOCKS. CHECK IF THE DUMP LEVEL IS     */
*       /* COMPATIBLE WITH THE FORMATTER AND THAT THE NEEDED INFO WAS*/
*       /* PASSED                                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0183
*       IF ADPLTCB=ZERO|ADPLCVT=ZERO THEN/* CALLER DID NOT PASS TCB
*                                      OR CVT                        */
         C     @14,ADPLTCB(,ABDPLPTR)                              0183
         BE    @RT00183                                            0183
         C     @14,ADPLCVT(,ABDPLPTR)                              0183
         BNE   @RF00183                                            0183
@RT00183 DS    0H                                                  0184
*         BUFFER(1:LENGTH(NOINF))=NOINF;/* ERROR MESSAGE             */
         L     @14,ADPLBUF(,ABDPLPTR)                              0184
         MVC   BUFFER(99,@14),NOINF                                0184
*       ELSE                        /* NEEDED TCB AND CVT WERE PASSED*/
*         DO;                                                      0185
         B     @RC00183                                            0185
@RF00183 DS    0H                                                  0186
*           VADR=ADDR(CVTDCB);      /* OPERATING SYSTEM FLAGS        */
         L     @14,CVTPTR(,ABDPLPTR)                               0186
         LA    VADR,CVTDCB(,@14)                                   0186
*           CALL ACCESRTN;          /* ACCESS THEM                   */
         BAL   @14,ACCESRTN                                        0187
*           IF RCREG^=ZERO THEN     /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0188
         BZ    @RF00188                                            0188
*             BUFFER(1:LENGTH(INCOMP))=INCOMP;/* ERROR MESSAGE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0189
         MVC   BUFFER(74,@14),INCOMP                               0189
*           ELSE                    /* FOUND THEM                    */
*             DO;                                                  0190
         B     @RC00188                                            0190
@RF00188 DS    0H                                                  0191
*               IF ADPLSYTM=ON|(DATABYTE&LOWBIT)^=LOWBIT THEN/* DUMP
*                                      SYSTEM IS NOT MVS             */
         TM    ADPLSYTM(ABDPLPTR),B'01000000'                      0191
         BO    @RT00191                                            0191
         SLR   @14,@14                                             0191
         IC    @14,LOWBIT                                          0191
         SLR   @10,@10                                             0191
         IC    @10,DATABYTE(,DATAPTR)                              0191
         NR    @10,@14                                             0191
         CR    @10,@14                                             0191
         BE    @RF00191                                            0191
@RT00191 DS    0H                                                  0192
*                 BUFFER(1:LENGTH(INCOMP))=INCOMP;                 0192
         L     @14,ADPLBUF(,ABDPLPTR)                              0192
         MVC   BUFFER(74,@14),INCOMP                               0192
*               ELSE                /* WAS AN MVS SYSTEM             */
*                 DO;                                              0193
*                                                                  0193
         B     @RC00191                                            0193
@RF00191 DS    0H                                                  0194
*                   /*************************************************/
*                   /*                                               */
*                   /* DETERMINE IF THE DATA MGMT CONTROL BLOCKS ARE */
*                   /* WANTED. IF THE CALLER IS AMDPRDMP, THE TASK   */
*                   /* MUST BE AN ABENDING TASK OR HAVE NON-ZERO     */
*                   /* COMPLETION CODE.                              */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0194
*                   VADR=ADDR(TCBCMP);/* TCB COMPLETION CODE         */
         L     @14,ADPLTCB(,ABDPLPTR)                              0194
         LA    VADR,TCBCMP(,@14)                                   0194
*                   CALL ACCESRTN;  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0195
*                   IF RCREG^=ZERO THEN/* COULD NOT ACCESS TCB       */
         LTR   RCREG,RCREG                                         0196
         BZ    @RF00196                                            0196
*                     BUFFER(1:LENGTH(TCBERR))=TCBERR;             0197
         L     @14,ADPLBUF(,ABDPLPTR)                              0197
         MVC   BUFFER(72,@14),TCBERR                               0197
*                   ELSE            /* FOUND TCB COMPLETION CODE     */
*                     DO;                                          0198
         B     @RC00196                                            0198
@RF00196 DS    0H                                                  0199
*                       COMPC=DATAWORD;/* SAVE COMPLETION CODE       */
         MVC   COMPC(4),DATAWORD(DATAPTR)                          0199
*                       VADR=ADDR(TCBFLGS1);/* ABEND CODE BYTES      */
         L     @14,ADPLTCB(,ABDPLPTR)                              0200
         LA    VADR,TCBFLGS1(,@14)                                 0200
*                       CALL ACCESRTN;/* ACCESS IT                   */
         BAL   @14,ACCESRTN                                        0201
*                       IF RCREG^=ZERO THEN/* ACCESS ERROR           */
         LTR   RCREG,RCREG                                         0202
         BZ    @RF00202                                            0202
*                         BUFFER(1:LENGTH(TCBERR))=TCBERR;         0203
         L     @14,ADPLBUF(,ABDPLPTR)                              0203
         MVC   BUFFER(72,@14),TCBERR                               0203
*                       ELSE        /* FOUND ABEND FLAGS             */
*                         DO;                                      0204
         B     @RC00202                                            0204
@RF00202 DS    0H                                                  0205
*                           IF COMPC^=ZERO|/* NON -ZERO COMPLETION 0205
*                                      CODE                          */
*                               (FLGS1&HIGHON)=HIGHON|/* ABEND IN  0205
*                                      PROGRESS FLAG ON              */
*                               ADPLSNPR=OFF THEN/* SNAP WAS INVOKER
*                                      - CONTROL BLOCKS WANTED       */
         ICM   @14,15,COMPC                                        0205
         BNZ   @RT00205                                            0205
         SLR   @14,@14                                             0205
         IC    @14,HIGHON                                          0205
         SLR   @10,@10                                             0205
         IC    @10,FLGS1(,DATAPTR)                                 0205
         NR    @10,@14                                             0205
         CR    @10,@14                                             0205
         BE    @RT00205                                            0205
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0205
         BNZ   @RF00205                                            0205
@RT00205 DS    0H                                                  0206
*                             DO;                                  0206
*                                                                  0206
*                               /*************************************/
*                               /*                                   */
*                               /* LOOP THROUGH THE DEB CHAIN        */
*                               /* STARTING EACH TIME AT THE TCB AND */
*                               /* FINDING ONE DEB FURTHER. THIS     */
*                               /* ELIMINATES ERROR IF THE DEB CHAIN */
*                               /* CHANGES BETWEEN SCANS             */
*                               /*                                   */
*                               /*************************************/
*                                                                  0207
*                               DEBPTR=1;/* DUMMY VALUE TO ALLOW   0207
*                                      FIRST PASS THROUGH LOOP       */
         LA    DEBPTR,1                                            0207
*                               DO DEBCNTR=0 TO DEBMAX WHILE(DEBPTR^=
*                                     ZERO);/* LOOP THROUGH DEB CHAIN*/
         SLR   @14,@14                                             0208
         ST    @14,DEBCNTR                                         0208
@DL00208 LTR   DEBPTR,DEBPTR                                       0208
         BZ    @DC00208                                            0208
*                                 IF ADPLSNPR=OFF THEN/* SNAP WAS  0209
*                                      CALLER-LOCAL LOCK IS NEEDED   */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0209
         BNZ   @RF00209                                            0209
*                                   DO;                            0210
*                                                                  0210
*                                    /********************************/
*                                    /*                              */
*                                    /* ONLY REG 1 WHICH GETS        */
*                                    /* MODIFIED BY SETLOCK NEEDS TO */
*                                    /* BE SAVED                     */
*                                    /*                              */
*                                    /********************************/
*                                                                  0211
*                                    PARMSAVE=ABDPLPTR;/* SAVE PTR 0211
*                                      ACCROSS SETLOCK               */
         LR    PARMSAVE,ABDPLPTR                                   0211
*                                    DO;/* SETLOCK (OBTAIN)        0212
*                                      MODE(UNCOND) TYPE(LOCAL)    0212
*                                      REGS(USE) RELATED(IECDAFMT)   */
*                                     RFY                          0213
*                                      (GPR11P,                    0213
*                                       GPR12P,                    0213
*                                       GPR13P,                    0213
*                                       GPR14P) RSTD;              0213
*                                     RFY                          0214
*                                      (GPR15P,                    0214
*                                       GPR00P,                    0214
*                                       GPR01P) RSTD;              0214
*                                     GPR15P=GPR11P;/* SAVE REG. 11
*                                      IN REG. 15.                   */
         LR    GPR15P,GPR11P                                       0215
*                                     GPR00P=GPR12P;/* SAVE REG. 12
*                                      IN REG. 0.                    */
         LR    GPR00P,GPR12P                                       0216
*                                     GPR01P=GPR13P;/* SAVE REG. 13
*                                      IN REG. 1.                    */
         LR    GPR01P,GPR13P                                       0217
*                                     GPR13P=PSALITA;/* ADDRESS OF 0218
*                                      LOCK INTERFACE TABLE.         */
         L     GPR13P,PSALITA                                      0218
*                                     GEN(LM GPR11P,GPR13P,576(GPR13P))
*                                         ;/* LOAD LOCKWORD, CLHT AND
*                                      ENTRY ADRS.                   */
         LM GPR11P,GPR13P,576(GPR13P)
*                                     GEN(BALR GPR14P,GPR13P);/* BALR
*                                      TO SETLOCK RTN.               */
         BALR GPR14P,GPR13P
*                                     GPR11P=GPR15P;/* RESTORE REG.
*                                      11.                           */
         LR    GPR11P,GPR15P                                       0221
*                                     GPR15P=GPR13P;/* SAVE RETURN 0222
*                                      CODE.                         */
         LR    GPR15P,GPR13P                                       0222
*                                     GPR12P=GPR00P;/* RESTORE REG.
*                                      12                            */
         LR    GPR12P,GPR00P                                       0223
*                                     GPR13P=GPR01P;/* RESTORE REG.
*                                      13.                           */
         LR    GPR13P,GPR01P                                       0224
*                                     RFY                          0225
*                                      (GPR15P,                    0225
*                                       GPR00P,                    0225
*                                       GPR01P) UNRSTD;            0225
*                                     RFY                          0226
*                                      (GPR11P,                    0226
*                                       GPR12P,                    0226
*                                       GPR13P,                    0226
*                                       GPR14P) UNRSTD;            0226
*                                    END;/* SETLOCK (OBTAIN)       0227
*                                      MODE(UNCOND) TYPE(LOCAL)    0227
*                                      REGS(USE) RELATED(IECDAFMT)   */
*                                    ABDPLPTR=PARMSAVE;/* RESTORE  0228
*                                      REGISTER 1                    */
         LR    ABDPLPTR,PARMSAVE                                   0228
*                                    LOCKHELD=ON;/* INDICATE LOCK  0229
*                                      HELD TO ESTAE                 */
         OI    LOCKHELD,B'01000000'                                0229
*                                   END;/* END LOCAL LOCK NEEDED     */
*                                 ELSE                             0231
*                                   ;/* LOCK NOT NEEDED FOR AMDPRDMP */
@RF00209 DS    0H                                                  0232
*                                 VADR=ADDR(TCBDEB);/* PTR TO DEB  0232
*                                      CHAIN FROM TCB                */
         L     @14,ADPLTCB(,ABDPLPTR)                              0232
         LA    VADR,TCBDEB(,@14)                                   0232
*                                 CALL ACCESRTN;/* ACCESS IT         */
         BAL   @14,ACCESRTN                                        0233
*                                 IF RCREG^=ZERO THEN/* ERROR      0234
*                                      ACCESSING TCB                 */
         LTR   RCREG,RCREG                                         0234
         BZ    @RF00234                                            0234
*                                   DO;                            0235
*                                    BUFFER(1:LENGTH(TCBERR))=TCBERR;
         L     @14,ADPLBUF(,ABDPLPTR)                              0236
         MVC   BUFFER(72,@14),TCBERR                               0236
*                                    /* ERROR MSG                    */
*                                    CALL PRINT;/* PRINT IT          */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0237
         BALR  @14,@15                                             0237
*                                    DEBPTR=ZERO;/* END THE LOOP     */
         SLR   DEBPTR,DEBPTR                                       0238
*                                   END;/* END ACCESS ERROR          */
*                                 ELSE/* FOUND DEB ADDRESS           */
*                                   DO;                            0240
         B     @RC00234                                            0240
@RF00234 DS    0H                                                  0241
*                                    DEBPTR=DATAWORD;/* SAVE PTR TO
*                                      DEB                           */
*                                                                  0241
         L     DEBPTR,DATAWORD(,DATAPTR)                           0241
*                                    /********************************/
*                                    /*                              */
*                                    /* INNER LOOP TO FIND THE NEXT  */
*                                    /* DEB ON THE CHAIN. IF THIS IS */
*                                    /* THE FIRST TIME DEBPTR ALREADY*/
*                                    /* CONTAINS THE DEB WANTED. THE */
*                                    /* FIRST TIME THROUGH THE       */
*                                    /* DEBCNTR IS ZERO - INDICATING */
*                                    /* THE PTR FROM THE TCB IS THE  */
*                                    /* ONE WANTED. THE LOOP IS NOT  */
*                                    /* ENTERED. THE NEXT TIME       */
*                                    /* THROUGH, DEBCNTR = 1,THE LOOP*/
*                                    /* IS ENTERED ONCE TO GET THE   */
*                                    /* POINTER TO THE NEXT DEB      */
*                                    /*                              */
*                                    /********************************/
*                                                                  0242
*                                    DO LOOPCNTR=DEBCNTR TO 1 BY-1 0242
*                                         WHILE(DEBPTR^=ZERO);     0242
         L     @14,DEBCNTR                                         0242
         ST    @14,LOOPCNTR                                        0242
         B     @DE00242                                            0242
@DL00242 LTR   DEBPTR,DEBPTR                                       0242
         BZ    @DC00242                                            0242
*                                     VADR=ADDR(DEBDEBAD);/* NEXT DEB
*                                      ADDR                          */
         LA    VADR,DEBDEBAD(,DEBPTR)                              0243
*                                     CALL ACCESRTN;/* ACCESS IT     */
         BAL   @14,ACCESRTN                                        0244
*                                     IF RCREG^=ZERO THEN/* ACCESS 0245
*                                      ERROR                         */
         LTR   RCREG,RCREG                                         0245
         BZ    @RF00245                                            0245
*                                      DO;                         0246
*                                       BUFFER(1:LENGTH(DEBERR))=DEBERR
*                                           ;/* ERROR MESSAGE        */
         L     @14,ADPLBUF(,ABDPLPTR)                              0247
         MVC   BUFFER(55,@14),DEBERR                               0247
*                                       CALL PRINT;/* PRINT IT       */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0248
         BALR  @14,@15                                             0248
*                                       DEBPTR=ZERO;/* TERMINATES  0249
*                                      LOOP                          */
         SLR   DEBPTR,DEBPTR                                       0249
*                                      END;/* END ACCESS ERROR       */
*                                     ELSE/* FOUND NEXT DEB          */
*                                      DEBPTR=DATAADR;/* SET DEB   0251
*                                      ADDRESS                       */
         B     @RC00245                                            0251
@RF00245 SLR   DEBPTR,DEBPTR                                       0251
         ICM   DEBPTR,7,DATAADR(DATAPTR)                           0251
*                                    END;/* END LOOP                 */
@RC00245 SLR   @14,@14                                             0252
         BCTR  @14,0                                               0252
         AL    @14,LOOPCNTR                                        0252
         ST    @14,LOOPCNTR                                        0252
@DE00242 LTR   @14,@14                                             0252
         BP    @DL00242                                            0252
@DC00242 DS    0H                                                  0253
*                                    IF DEBPTR=ZERO THEN/* VALID DEB
*                                      WAS NOT FOUND                 */
         LTR   DEBPTR,DEBPTR                                       0253
         BNZ   @RF00253                                            0253
*                                     CALL RELLOCK;/* RELEASE LOCK IF
*                                      HELD                          */
         BAL   @14,RELLOCK                                         0254
*                                    ELSE/* VALID DEB FOUND          */
*                                     DO;                          0255
*                                                                  0255
         B     @RC00253                                            0255
@RF00253 DS    0H                                                  0256
*                                      /******************************/
*                                      /*                            */
*                                      /* A VALID DEB WAS FOUND TO BE*/
*                                      /* PROCESSED                  */
*                                      /*                            */
*                                      /******************************/
*                                                                  0256
*                                      VADR=ADDR(DEBDCBAD);/* PTR TO
*                                      ASSOCIATED DCB                */
         LA    VADR,DEBDCBAD(,DEBPTR)                              0256
*                                      CALL ACCESRTN;/* ACCESS IT    */
         BAL   @14,ACCESRTN                                        0257
*                                      IF RCREG^=ZERO THEN/* ACCESS
*                                      ERROR                         */
         LTR   RCREG,RCREG                                         0258
         BZ    @RF00258                                            0258
*                                       DCBPTR=NEGONE;/* NEGATIVE  0259
*                                      NUMBER TO INDICATE ERROR    0259
*                                      MESSAGE TO BE PRINTED LATER   */
         L     DCBPTR,NEGONE                                       0259
*                                      ELSE/* FOUND DCB ADDRESS      */
*                                       DCBPTR=DATAADR;/* SAVE DCB 0260
*                                      ADDRESS                       */
         B     @RC00258                                            0260
@RF00258 SLR   DCBPTR,DCBPTR                                       0260
         ICM   DCBPTR,7,DATAADR(DATAPTR)                           0260
*                                      CALL RELLOCK;/* RELEASE LOCAL
*                                      LOCK IF HELD                  */
@RC00258 BAL   @14,RELLOCK                                         0261
*                                      CALL FORMATIT;/* ROUTINE TO 0262
*                                      DETERMINE WHAT TO FORMAT      */
         BAL   @14,FORMATIT                                        0262
*                                     END;/* END VALID DEB           */
*                                   END;/* END FOUND DEB ADDR        */
@RC00253 DS    0H                                                  0265
*                               END;/* END LOOP THROUGH DEB CHAIN    */
@RC00234 LA    @14,1                                               0265
         AL    @14,DEBCNTR                                         0265
         ST    @14,DEBCNTR                                         0265
         CH    @14,@CH02732                                        0265
         BNH   @DL00208                                            0265
@DC00208 DS    0H                                                  0266
*                             END;  /* END CONTROL BLOCKS WANTED     */
*                           ELSE                                   0267
*                             ;     /* CONTROL BLOCKS NOT WANTED     */
@RF00205 DS    0H                                                  0268
*                         END;      /* END FOUND ABEND FLAGS         */
*                     END;          /* END FOUND TCB COMPLETION CODE */
@RC00202 DS    0H                                                  0270
*                 END;              /* END WAS AN MVS SYSTEM         */
@RC00196 DS    0H                                                  0271
*             END;                  /* END OPERATING SYSTEM FLAGS  0271
*                                      FOUND                         */
@RC00191 DS    0H                                                  0272
*         END;                      /* END TCB AND CVT WERE PASSED   */
@RC00188 DS    0H                                                  0273
*TROUBLE:                           /* ENTRY FROM THE ESTAE TO PRINT
*                                      A MESSAGE                     */
*       CALL PRINT;                 /* ERROR MESSAGE OR BLANK        */
@RC00183 DS    0H                                                  0273
TROUBLE  L     @15,ADPLPRNT(,ABDPLPTR)                             0273
         BALR  @14,@15                                             0273
*       GEN(ESTAE 0);               /* DROP THE ESTAE                */
         ESTAE 0
*     END;                          /* END ESTAE ESTABLISHED FINE    */
*   ELSE                                                           0276
*     ;                             /* ESATE COULD NOT BE ESTABLISHED*/
@RF00180 DS    0H                                                  0277
*   IF ADPLSNPR=OFF THEN            /* SNAP CALLER           @ZA26256*/
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0277
         BNZ   @RF00277                                            0277
*     DO;                           /* YES....               @ZA26256*/
*       GENERATE;                                                  0279
         L  REG13,4(REG13)          RESTORE CALLERS SAVEAREA @ZA26256
         FREEMAIN R,LV=@ENDDATD-@DATD,SP=253,A=(DREG)
*     END;                          /* END SNAP CALLER       @ZA26256*/
*   ELSE                            /* NO... PRINT DUMP CALLER     0281
*                                                            @ZA26256*/
*     DO;                           /*                       @ZA26256*/
         B     @RC00277                                            0281
@RF00277 DS    0H                                                  0282
*       RFY                                                        0282
*        (TREG6) RSTD;              /*                       @ZA26256*/
*       GENERATE;                                                  0283
*                                /*                         @ZA26256*/
         L  REG13,4(REG13)          RESTORE CALLERS SAVEAREA @ZA26256
         IC TREG6,ADPLSBPL(ABDPLPTR)    SUBPOOL NUMBER IN REG @ZA26256
         FREEMAIN R,LV=@ENDDATD-@DATD,SP=(TREG6),A=(DREG)
*     END;                          /* END PRINT DUMP CALLER @ZA26256*/
*   RFY                                                            0285
*    (TREG6) UNRSTD;                /*                       @ZA26256*/
@RC00277 DS    0H                                                  0286
*   RETURN CODE(0);                                                0286
         SLR   @15,@15                                             0286
         L     @14,12(,@13)                                        0286
         LM    @00,@12,20(@13)                                     0286
         BR    @14                                                 0286
*FORMATIT:                                                         0287
*   PROC OPTIONS(SAVE(14));                                        0287
*                                                                  0287
@EL00001 DS    0H                                                  0287
@EF00001 DS    0H                                                  0287
@ER00001 LM    @14,@12,12(@13)                                     0287
         BR    @14                                                 0287
FORMATIT ST    @14,@SA00002                                        0287
*/********************************************************************/
*/* FUNCTION -                                                     0288
*      ROUTINE TO SET UP FOR THE DATA MANAGEMENT CONTROL BLOCK FORMATTE
*      UNDER AMDPRDMP, THE DEB IS NOT FORMATTED ANDA HEADER MUST BE SET
*      UP. UNDER SNAP, THE DEB IS FORMATTED.                       0288
*                                                                  0288
*   INPUT -                                                        0288
*      REGISTER 1 MUST POINT TO THE PARMLIST AND DEBPTR MUST CONTAIN
*      THE ADDRESS OF THE DEB BEING PROCESSED.                     0288
*                                                                  0288
*   CALLS -                                                        0288
*      IECDADCB, IECDADEB, IOBRTN, AND PRINT                       0288
*                                                                  0288
*   CALLED BY -                                                    0288
*      IECDAFMT TO SET UP FOR THE DATA MANAGEMENT FORMATTERS       0288
*                                                                  0288
*   RETURNS TO -                                                   0288
*      CALLER WITHOUT SETTING A RETURN CODE                        0288
*                                                                    */
*/********************************************************************/
*                                                                  0288
*   IF ADPLSNPR=OFF THEN            /* DEBS TO BE FORMATTED ONLY   0288
*                                      UNDER SNAP                    */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0288
         BNZ   @RF00288                                            0288
*     DO;                                                          0289
*       ADPLCOM4=ADDR(ESTAPARM);    /* PASS ESTAE PARM LIST TO     0290
*                                      INDIVIDUAL FORMAT ROUTINES TO
*                                      USE                           */
         LA    @14,ESTAPARM                                        0290
         ST    @14,ADPLCOM4(,ABDPLPTR)                             0290
*       ADPLFMT2=DEBPTR;            /* FILL IN PARMLIST              */
         ST    DEBPTR,ADPLFMT2(,ABDPLPTR)                          0291
*       OFFSET=ZERO;                /* OFFSET FOR FIRST FIELD        */
         SLR   @14,@14                                             0292
         ST    @14,OFFSET(,ABDPLPTR)                               0292
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0293
         BALR  @14,@15                                             0293
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0294
         BALR  @14,@15                                             0294
*       CALL IECDADEB;              /* DEB FORMATTER                 */
         L     @15,@CV02685                                        0295
         BALR  @14,@15                                             0295
*     END;                          /* END FORMAT DEB                */
*   ELSE                                                           0297
*     ;                             /* DEB NOT FORMATTED UNDER     0297
*                                      AMDPRDMP                      */
@RF00288 DS    0H                                                  0298
*   IF(ADPLSNPR=ON)|(ADPLDMGT=ON&RCREG=ZERO) THEN/* REST OF CONTROL
*                                      BLOCKS WANTED                 */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0298
         BO    @RT00298                                            0298
         TM    ADPLDMGT(ABDPLPTR),B'00100000'                      0298
         BNO   @RF00298                                            0298
         LTR   RCREG,RCREG                                         0298
         BNZ   @RF00298                                            0298
@RT00298 DS    0H                                                  0299
*     DO;                                                          0299
*       IF DCBPTR^=ZERO             /* THE DCB POINTER WAS NOT ZERO  */
*         THEN                                                     0300
         LTR   DCBPTR,DCBPTR                                       0300
         BZ    @RF00300                                            0300
*         DO;                                                      0301
*           IF ADPLSNPR=ON THEN     /* SPECIAL HEADER UNDER AMDPRDMP */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0302
         BNO   @RF00302                                            0302
*             DO;                                                  0303
*               CALL PRINT;         /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0304
         BALR  @14,@15                                             0304
*               CALL PRINT;         /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0305
         BALR  @14,@15                                             0305
*               BUFFER(1:LENGTH(DEBHDR))=DEBHDR;/* HEADER LINE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0306
         MVC   BUFFER(20,@14),DEBHDR                               0306
*               PACKAREA=DEBPTR;    /* MOVE INTO CHAR AREA           */
         ST    DEBPTR,PACKAREA                                     0307
*               GARBAGE='04'X;      /* GARBAGE BYTE FOR UNPK         */
         MVI   GARBAGE,X'04'                                       0308
*               UNPK(ADDRESS,UNPACK);/* PUT IN BUFFER LINE           */
         UNPK  ADDRESS(9,@14),UNPACK(5)                            0309
*               TR(ADDRESS,TRANS);  /* MAKE PRINTABLE                */
         TR    ADDRESS(9,@14),TRANS                                0310
*               CALL PRINT;         /* PRINT HDR                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0311
         BALR  @14,@15                                             0311
*               BUFFER(1:LENGTH(DEBUS))=DEBUS;/* UNDER SCORE         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0312
         MVC   BUFFER(19,@14),DEBUS                                0312
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0313
         BALR  @14,@15                                             0313
*               CALL PRINT;         /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0314
         BALR  @14,@15                                             0314
*             END;                  /* END SPECIAL HDR FOR AMDPRDMP  */
*           ELSE                                                   0316
*             ;                     /* SPECIAL HEADER NOT NEEDED     */
@RF00302 DS    0H                                                  0317
*           IF DCBPTR=NEGONE THEN   /* ERROR ACCESSING DCB ADDRESS   */
         C     DCBPTR,NEGONE                                       0317
         BNE   @RF00317                                            0317
*             DO;                                                  0318
*               BUFFER(1:LENGTH(DCBERR))=DCBERR;                   0319
         L     @14,ADPLBUF(,ABDPLPTR)                              0319
         MVC   BUFFER(61,@14),DCBERR                               0319
*               CALL PRINT;         /* ERROR MSG                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0320
         BALR  @14,@15                                             0320
*             END;                  /* END ERROR ACCESSING DCB ADDR  */
*           ELSE                                                   0322
*             DO;                   /* DCB ADDRESS OK                */
         B     @RC00317                                            0322
@RF00317 DS    0H                                                  0323
*               ADPLCOM4=ADDR(ESTAPARM);/* PASS ESTAE PARM LIST TO 0323
*                                      INDIVIDUAL FORMAT ROUTINES TO
*                                      USE                           */
         LA    @14,ESTAPARM                                        0323
         ST    @14,ADPLCOM4(,ABDPLPTR)                             0323
*               ADPLFMT2=DCBPTR;    /* FILL IN PARMLIST              */
         ST    DCBPTR,ADPLFMT2(,ABDPLPTR)                          0324
*               OFFSET=ZERO;                                       0325
         SLR   @14,@14                                             0325
         ST    @14,OFFSET(,ABDPLPTR)                               0325
*               CALL PRINT;         /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0326
         BALR  @14,@15                                             0326
*               CALL PRINT;         /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0327
         BALR  @14,@15                                             0327
*               CALL IECDADCB;      /* DCB FORMATTER                 */
         L     @15,@CV02686                                        0328
         BALR  @14,@15                                             0328
*               IF RCREG=ZERO THEN  /* FORMATTED DEB OK              */
         LTR   RCREG,RCREG                                         0329
         BNZ   @RF00329                                            0329
*                 CALL IOBRTN;      /* RTN TO FIND FIRST IOB         */
         BAL   @14,IOBRTN                                          0330
*               ELSE                                               0331
*                 ;                 /* IOBS NOT WANTED               */
@RF00329 DS    0H                                                  0332
*             END;                  /* END DCB ADDRESS OK            */
*         END;                      /* END DCB ADDRESS WAS NOT ZERO  */
*       ELSE                                                       0334
*         ;                         /* DCB ADDRESS WAS ZERO          */
@RF00300 DS    0H                                                  0335
*     END;                          /* END CONTROL BLOCKS WANTED     */
*   ELSE                                                           0336
*     ;                             /* CONTROL BLOCKS NOT WANTED     */
@RF00298 DS    0H                                                  0337
*   END FORMATIT;                                                  0337
@EL00002 DS    0H                                                  0337
@EF00002 DS    0H                                                  0337
@ER00002 L     @14,@SA00002                                        0337
         BR    @14                                                 0337
*IOBRTN:                                                           0338
*   PROC OPTIONS(SAVE(14));                                        0338
*                                                                  0338
IOBRTN   ST    @14,@SA00003                                        0338
*/********************************************************************/
*/* FUNCTION -                                                     0339
*      ROUTINE TO FIND THE ADDRESS OF THE IOB'S (ICB'S,LCB'S) POINTED
*      TO BY THE DCB. IT PLACES THIS ADDRESS INTO THE PARMLIST AT  0339
*      ADPLFMT2 AND CALLS THE IOB FORMATTER(IECDAIOB) TO FORMAT EACH
*      OF THE AVAILABLE IOBS.                                      0339
*                                                                  0339
*   INPUT -                                                        0339
*      REGISTER 1 MUST POINT TO THE PARMLIST AND ADPLCOM2 MUST CONTAIN
*      THE ACCESS METHOD TYPE SET UP BY THE DCB FORMATTER.         0339
*                                                                  0339
*   CALLS -                                                        0339
*      ACCESRTN, IECDAIOB, AND PRINT                               0339
*                                                                  0339
*   CALLED BY -                                                    0339
*      FORMATIT TO FIND THE FIRST IOB AND TO CALL THE IOB FORMATTER
*                                                                  0339
*   RETURNS TO -                                                   0339
*      CALLER WITHOUT SETTING A RETURN CODE                        0339
*                                                                    */
*/********************************************************************/
*                                                                  0339
*   ERRSW=OFF;                      /* INITIALIZE ERROR INDICATOR    */
         NI    ERRSW,B'01111111'                                   0339
*   ADPLCOM4=ADDR(ESTAPARM);        /* PASS ESTAE PARM LIST TO     0340
*                                      INDIVIDUAL FORMAT ROUTINES TO
*                                      USE                           */
         LA    @14,ESTAPARM                                        0340
         ST    @14,ADPLCOM4(,ABDPLPTR)                             0340
*   ADPLCOM3=DCBPTR;                /* PASS DCB ADDR FOR IOB VALIDITY
*                                      CHECK                         */
*                                                                  0341
         ST    DCBPTR,ADPLCOM3(,ABDPLPTR)                          0341
*   /*****************************************************************/
*   /*                                                               */
*   /* ISAM LOAD TYPE IOB                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0342
*   IF ISAMLOAD=ON THEN             /* ISAM LOAD TYPE IOB            */
         TM    ISAMLOAD(ABDPLPTR),B'01000000'                      0342
         BNO   @RF00342                                            0342
*     DO;                                                          0343
*       VADR=ADDR(DCBWKPT1);        /* FIRST IOB ADDR                */
         LA    VADR,DCBWKPT1+52(,DCBPTR)                           0344
*       CALL ACCESRTN;              /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0345
*       IF RCREG^=ZERO THEN         /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0346
         BZ    @RF00346                                            0346
*         DO;                                                      0347
*           BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0348
         MVC   BUFFER(64,@14),IOBERR                               0348
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0349
         BALR  @14,@15                                             0349
*         END;                      /* END ACCESS ERROR              */
*       ELSE                        /* FOUND IOB ADDR                */
*         DO;                                                      0351
         B     @RC00346                                            0351
@RF00346 DS    0H                                                  0352
*           IOBPRPTR=DATAADR;       /* IOB PREFIX SECTION    @ZM45056*/
         SLR   IOBPRPTR,IOBPRPTR                                   0352
         ICM   IOBPRPTR,7,DATAADR(DATAPTR)                         0352
*           DO ARRAYCNT=1 TO LOADMAX WHILE(ERRSW=OFF);             0353
         LA    ARRAYCNT,1                                          0353
@DL00353 TM    ERRSW,B'10000000'                                   0353
         BNZ   @DC00353                                            0353
*             ADPLFMT2=IOBPRPTR+QISMPREF;/* FILL IN PARMLIST WITH PTR
*                                      TO IOB STANDARD SECTION     0354
*                                                            @ZM45056*/
         LA    @14,4                                               0354
         LR    @09,IOBPRPTR                                        0354
         ALR   @09,@14                                             0354
         ST    @09,ADPLFMT2(,ABDPLPTR)                             0354
*             OFFSET=QISMPREF;      /* LENGTH OF PREFIX      @ZM45056*/
         ST    @14,OFFSET(,ABDPLPTR)                               0355
*             CALL PRINT;           /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0356
         BALR  @14,@15                                             0356
*             CALL PRINT;           /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0357
         BALR  @14,@15                                             0357
*             CALL IECDAIOB;        /* IOB FORMATTER                 */
         L     @15,@CV02687                                        0358
         BALR  @14,@15                                             0358
*             IF RCREG=ZERO THEN    /* FORMATTED IOB FINE            */
         LTR   RCREG,RCREG                                         0359
         BNZ   @RF00359                                            0359
*               IOBPRPTR=IOBPRPTR+LOADLNTH;/* NEXT IOB       @ZM45056*/
         AH    IOBPRPTR,@CH01689                                   0360
*             ELSE                                                 0361
*               ERRSW=ON;           /* OTHERWISE END LLOP            */
         B     @RC00359                                            0361
@RF00359 OI    ERRSW,B'10000000'                                   0361
*           END;                    /* END FORMAT LOOP               */
@RC00359 AH    ARRAYCNT,@CH00041                                   0362
         CH    ARRAYCNT,@CH00315                                   0362
         BNH   @DL00353                                            0362
@DC00353 DS    0H                                                  0363
*         END;                      /* END FOUND IOBADDR OK          */
*     END;                          /* END ISAM LOAD IOB             */
*   ELSE                            /* NOT ISAM LOAD                 */
*                                                                  0365
*     /***************************************************************/
*     /*                                                             */
*     /* ISAM SCAN TYPE IOB                                          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0365
*     IF ISAMSCAN=ON THEN           /* ISAM SCAN TYPE IOB            */
         B     @RC00342                                            0365
@RF00342 TM    ISAMSCAN(ABDPLPTR),B'00100000'                      0365
         BNO   @RF00365                                            0365
*       DO;                                                        0366
*         VADR=ADDR(DCBWKPT1);      /* FIRST IOB ADDR                */
         LA    VADR,DCBWKPT1+52(,DCBPTR)                           0367
*         CALL ACCESRTN;            /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0368
*         IF RCREG^=ZERO THEN       /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0369
         BZ    @RF00369                                            0369
*           DO;                                                    0370
*             BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0371
         MVC   BUFFER(64,@14),IOBERR                               0371
*             CALL PRINT;           /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0372
         BALR  @14,@15                                             0372
*           END;                    /* END ACCESS ERROR              */
*         ELSE                      /* FOUND IOB ADDR                */
*           DO;                                                    0374
         B     @RC00369                                            0374
@RF00369 DS    0H                                                  0375
*             IOBPRPTR=DATAADR;     /* IOB PREFIX SECTION            */
         SLR   IOBPRPTR,IOBPRPTR                                   0375
         ICM   IOBPRPTR,7,DATAADR(DATAPTR)                         0375
*             DO ARRAYCNT=1 TO SCANMAX WHILE(ERRSW=OFF);           0376
         LA    ARRAYCNT,1                                          0376
@DL00376 TM    ERRSW,B'10000000'                                   0376
         BNZ   @DC00376                                            0376
*               ADPLFMT2=IOBPRPTR+QISMPREF;/* FILL IN PARMLIST WITH
*                                      PTR TO STANDARD SECTION     0377
*                                                            @ZM45056*/
         LA    @14,4                                               0377
         LR    @09,IOBPRPTR                                        0377
         ALR   @09,@14                                             0377
         ST    @09,ADPLFMT2(,ABDPLPTR)                             0377
*               OFFSET=QISMPREF;    /* LENGTH OF PREFIX      @ZM45056*/
         ST    @14,OFFSET(,ABDPLPTR)                               0378
*               CALL PRINT;         /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0379
         BALR  @14,@15                                             0379
*               CALL PRINT;         /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0380
         BALR  @14,@15                                             0380
*               CALL IECDAIOB;      /* IOB FORMATTER                 */
         L     @15,@CV02687                                        0381
         BALR  @14,@15                                             0381
*               IF RCREG=ZERO THEN  /* FORMATTED IOB FINE            */
         LTR   RCREG,RCREG                                         0382
         BNZ   @RF00382                                            0382
*                 IOBPRPTR=IOBPRPTR+SCANLNTH;/* NEXT IOB             */
         AH    IOBPRPTR,@CH00924                                   0383
*               ELSE                                               0384
*                 ERRSW=ON;         /* OTHERWISE END LLOP            */
         B     @RC00382                                            0384
@RF00382 OI    ERRSW,B'10000000'                                   0384
*             END;                  /* END FORMAT LOOP               */
@RC00382 AH    ARRAYCNT,@CH00041                                   0385
         CH    ARRAYCNT,@CH00099                                   0385
         BNH   @DL00376                                            0385
@DC00376 DS    0H                                                  0386
*           END;                    /* END FOUND IOBADDR OK          */
*       END;                        /* END ISAM LOAD IOB             */
*     ELSE                          /* NOT ISAM LOAD                 */
*                                                                  0388
*       /*************************************************************/
*       /*                                                           */
*       /* SAM OR BPAM NORMAL SCHEDULING - THE IOBS CHAIN IN A LOOP  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0388
*       IF SAMNMAL=ON THEN          /* SAM NORMAL SCHEDULING IOB     */
         B     @RC00365                                            0388
@RF00365 TM    SAMNMAL(ABDPLPTR),B'00001000'                       0388
         BNO   @RF00388                                            0388
*         DO;                                                      0389
*           VADR=ADDR(DCBIOBA);     /* FIRST IOB ADDR                */
         LA    VADR,DCBIOBA+52(,DCBPTR)                            0390
*           CALL ACCESRTN;          /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0391
*           IF RCREG^=ZERO THEN     /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0392
         BZ    @RF00392                                            0392
*             DO;                                                  0393
*               BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0394
         MVC   BUFFER(64,@14),IOBERR                               0394
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0395
         BALR  @14,@15                                             0395
*             END;                  /* END ACCESS ERROR              */
*           ELSE                    /* FOUND IOB ADDR                */
*             DO;                                                  0397
         B     @RC00392                                            0397
@RF00392 DS    0H                                                  0398
*               IOBPRPTR=DATAADR;   /* IOB PREFIX SECTION            */
         SLR   IOBPRPTR,IOBPRPTR                                   0398
         ICM   IOBPRPTR,7,DATAADR(DATAPTR)                         0398
*               COMPARE=ZERO;       /* ADR TO CHECK FOR LOOP         */
         SLR   @14,@14                                             0399
         ST    @14,COMPARE                                         0399
*               FIRSTIOB=IOBPRPTR;  /* ADDR OF FIRST IOB             */
         ST    IOBPRPTR,FIRSTIOB                                   0400
*               DO ARRAYCNT=1 TO LOOPMAX WHILE(ERRSW=OFF&COMPARE^= 0401
*                     FIRSTIOB);                                   0401
         LA    ARRAYCNT,1                                          0401
@DL00401 TM    ERRSW,B'10000000'                                   0401
         BNZ   @DC00401                                            0401
         CLC   COMPARE(4),FIRSTIOB                                 0401
         BE    @DC00401                                            0401
*                 IOBSTPTR=IOBPRPTR+NSAMPREF;/* STANDARD SECTION     */
         LA    @14,8                                               0402
         LR    IOBSTPTR,IOBPRPTR                                   0402
         ALR   IOBSTPTR,@14                                        0402
*                 ADPLFMT2=IOBSTPTR;/* FILL IN PARMLIST              */
         ST    IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0403
*                 OFFSET=NSAMPREF;  /* LENGTH OF PREFIX              */
         ST    @14,OFFSET(,ABDPLPTR)                               0404
*                 CALL PRINT;       /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0405
         BALR  @14,@15                                             0405
*                 CALL PRINT;       /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0406
         BALR  @14,@15                                             0406
*                 CALL IECDAIOB;    /* IOB FORMATTER                 */
         L     @15,@CV02687                                        0407
         BALR  @14,@15                                             0407
*                 IF RCREG=ZERO THEN/* FORMATTED IOB FINE            */
         LTR   RCREG,RCREG                                         0408
         BNZ   @RF00408                                            0408
*                   DO;                                            0409
*                     IOBPRPTR=IOBPRPTR-PREFLEN;/* PTR TO BEGINNING
*                                      OF FULL PREFIX, FOR BASING  0410
*                                      IOBNIOB CORRECTLY             */
         SH    IOBPRPTR,@CH00086                                   0410
*                     VADR=ADDR(IOBNIOBA);/* NEXT IOB                */
         LA    VADR,IOBNIOBA(,IOBPRPTR)                            0411
*                     CALL ACCESRTN;/* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0412
*                     IF RCREG^=ZERO THEN/* ACCESS ERROR             */
         LTR   RCREG,RCREG                                         0413
         BZ    @RF00413                                            0413
*                       DO;                                        0414
*                         BUFFER(1:LENGTH(IOBCHN))=IOBCHN;/* ERROR 0415
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0415
         MVC   BUFFER(55,@14),IOBCHN                               0415
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0416
         BALR  @14,@15                                             0416
*                         ERRSW=ON; /* END LOOP                      */
         OI    ERRSW,B'10000000'                                   0417
*                       END;        /* END ACCESS ERROR              */
*                     ELSE          /* FOUND IOB ADDR                */
*                       DO;                                        0419
         B     @RC00413                                            0419
@RF00413 DS    0H                                                  0420
*                         IOBPRPTR=DATAADR;/* FILL IN IOB PTR        */
         SLR   IOBPRPTR,IOBPRPTR                                   0420
         ICM   IOBPRPTR,7,DATAADR(DATAPTR)                         0420
*                         COMPARE=IOBPRPTR;/* TO CHECK FOR LOOP      */
         ST    IOBPRPTR,COMPARE                                    0421
*                       END;        /* END FOUND IOB ADDR            */
*                   END;            /* END FORMATTED IOB FINE        */
*                 ELSE                                             0424
*                   ERRSW=ON;       /* ERROR FORMATTING IOB          */
         B     @RC00408                                            0424
@RF00408 OI    ERRSW,B'10000000'                                   0424
*               END;                /* END FORMAT LOOP               */
@RC00408 AH    ARRAYCNT,@CH00041                                   0425
         CH    ARRAYCNT,@CH02766                                   0425
         BNH   @DL00401                                            0425
@DC00401 DS    0H                                                  0426
*             END;                  /* END FOUND IOBADDR OK          */
*         END;                      /* END SAM NORMAL IOB            */
*       ELSE                        /* NOT SAM NORMAL IOB            */
*                                                                  0428
*         /***********************************************************/
*         /*                                                         */
*         /* SAM OR BPAM CHAINED SCHEDULING - THERE IS ONE IOB AND A */
*         /* CHAIN OF ICBS. THE ICBS CHAIN IN A LOOP                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0428
*         IF SAMCHAIN=ON THEN       /* SAM CHAIN SCHEDULING IOB AND
*                                      ICB                           */
         B     @RC00388                                            0428
@RF00388 TM    SAMCHAIN(ABDPLPTR),B'00000100'                      0428
         BNO   @RF00428                                            0428
*           DO;                                                    0429
*                                                                  0429
*             /*******************************************************/
*             /*                                                     */
*             /* FORMAT THE MAIN IOB                                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0430
*             VADR=ADDR(DCBIOBAD);  /* MAIN IOB ADDR                 */
         LA    VADR,DCBIOBAD+16(,DCBPTR)                           0430
*             CALL ACCESRTN;        /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0431
*             IF RCREG^=ZERO THEN   /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0432
         BZ    @RF00432                                            0432
*               DO;                                                0433
*                 BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0434
         MVC   BUFFER(64,@14),IOBERR                               0434
*                 CALL PRINT;       /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0435
         BALR  @14,@15                                             0435
*               END;                /* END ACCESS ERROR              */
*             ELSE                  /* FOUND IOB ADDR                */
*               DO;                                                0437
         B     @RC00432                                            0437
@RF00432 DS    0H                                                  0438
*                 IOBPRPTR=DATAADR; /* IOB PREFIX SECTION            */
         SLR   IOBPRPTR,IOBPRPTR                                   0438
         ICM   IOBPRPTR,7,DATAADR(DATAPTR)                         0438
*                 IOBSTPTR=IOBPRPTR+CSAMPREF;/* STANDARD SECTION     */
         LA    @14,16                                              0439
         LR    IOBSTPTR,IOBPRPTR                                   0439
         ALR   IOBSTPTR,@14                                        0439
*                 ADPLFMT2=IOBSTPTR;/* FILL IN PARMLIST              */
         ST    IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0440
*                 CHAINIOB=ON;      /* INDICATE IOB BEING PROCESSED  */
         OI    CHAINIOB(ABDPLPTR),B'00001000'                      0441
*                 OFFSET=CSAMPREF;  /* LENGTH OF PREFIX              */
         ST    @14,OFFSET(,ABDPLPTR)                               0442
*                 CALL PRINT;       /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0443
         BALR  @14,@15                                             0443
*                 CALL PRINT;       /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0444
         BALR  @14,@15                                             0444
*                 CALL IECDAIOB;    /* IOB FORMATTER                 */
         L     @15,@CV02687                                        0445
         BALR  @14,@15                                             0445
*                 IF RCREG=ZERO THEN/* FORMATTED IOB FINE            */
         LTR   RCREG,RCREG                                         0446
         BNZ   @RF00446                                            0446
*                   DO;                                            0447
*                                                                  0447
*                     /***********************************************/
*                     /*                                             */
*                     /* IF IOB FORMATTED OK - FORMAT THE ICB CHAIN  */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0448
*                     VADR=ADDR(DCBIOBA);/* FIRST ICB ADDR           */
         LA    VADR,DCBIOBA+52(,DCBPTR)                            0448
*                     CALL ACCESRTN;/* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0449
*                     IF RCREG^=ZERO THEN/* ACCESS ERROR             */
         LTR   RCREG,RCREG                                         0450
         BZ    @RF00450                                            0450
*                       DO;                                        0451
*                         BUFFER(1:LENGTH(ICBERR))=ICBERR;/* ERROR 0452
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0452
         MVC   BUFFER(64,@14),ICBERR                               0452
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0453
         BALR  @14,@15                                             0453
*                       END;        /* END ACCESS ERROR              */
*                     ELSE          /* FOUND ICB ADDR                */
*                       DO;                                        0455
         B     @RC00450                                            0455
@RF00450 DS    0H                                                  0456
*                         IOBSTPTR=DATAADR;/* ICB                    */
         SLR   IOBSTPTR,IOBSTPTR                                   0456
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0456
*                         COMPARE=ZERO;/* LOOP CONTROL               */
         SLR   @14,@14                                             0457
         ST    @14,COMPARE                                         0457
*                         FIRSTIOB=IOBSTPTR;/* ADDR OF FIRST ICB     */
         ST    IOBSTPTR,FIRSTIOB                                   0458
*                         CHAINIOB=OFF;/* INDICATE ICB BEING       0459
*                                      PROCESSED                     */
         NI    CHAINIOB(ABDPLPTR),B'11110111'                      0459
*                         DO ARRAYCNT=1 TO LOOPMAX WHILE(ERRSW=OFF&
*                               COMPARE^=FIRSTIOB);                0460
*                                                                  0460
         LA    ARRAYCNT,1                                          0460
@DL00460 TM    ERRSW,B'10000000'                                   0460
         BNZ   @DC00460                                            0460
         CLC   COMPARE(4),FIRSTIOB                                 0460
         BE    @DC00460                                            0460
*                           /*****************************************/
*                           /*                                       */
*                           /* CHECK THAT THE ICB TO BE FORMATTED IS */
*                           /* ADDRESSABLE BY THE USER. THIS WILL    */
*                           /* PREVENT FORMATTING OF SECURE DATA BY  */
*                           /* SNAP/ABEND.                   @ZM45048*/
*                           /*                                       */
*                           /*****************************************/
*                                                                  0461
*                           IF ADPLSNPR=OFF THEN/* SNAP IS CALLER -
*                                      PROTECT DATA BY ACCESSING ICB
*                                      IN CALLERS KEY        @ZM45048*/
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0461
         BNZ   @RF00461                                            0461
*                             DO;   /*                       @ZM45048*/
*                               RTYADR=ADDR(ICBRETRY);/* ADDRESS TO
*                                      RETRY AT TO PRINT A MESSAGE IF
*                                      THE DATA IS NOT ADDRESSABLE 0463
*                                                            @ZM45048*/
         LA    @14,ICBRETRY                                        0463
         ST    @14,RTYADR                                          0463
*                               VADR=IOBSTPTR;/* ADDRESS TO BE     0464
*                                      VERIFIED              @ZM45048*/
         LR    VADR,IOBSTPTR                                       0464
*                               ERREXP=ON;/* AN ACCESS ERROR IS    0465
*                                      EXPECTED              @ZM45048*/
         OI    ERREXP,B'10000000'                                  0465
*                               RFY                                0466
*                                (KEYREG2) RSTD;/*           @ZM45048*/
*                               DO; /* MODESET SAVEKEY(KEYSAVE)    0467
*                                      EXTKEY(TCB) WORKREG(KEYREG2)  */
*                                 RESPECIFY                        0468
*                                  (GPR02F) RESTRICTED;            0468
*                                 KEYREG2=GPR02F;/* SAVE REGISTER 2  */
*                                 IPK;/* SAVE CURRENT PSW KEY        */
         IPK                                                       0470
*                                 KEYSAVE=GPR02F;                  0471
         STC   GPR02F,KEYSAVE                                      0471
*                                 GPR02F=KEYREG2;/* RESTORE REGISTER
*                                      2                             */
*                                 KEYREG2=TCBPKF;/* GET KEY FROM TCB */
         L     @14,ADPLTCB(,ABDPLPTR)                              0473
         SLR   KEYREG2,KEYREG2                                     0473
         IC    KEYREG2,TCBPKF(,@14)                                0473
*                                 SPKA(KEYREG2);/* SET PSW KEY       */
         SPKA  0(KEYREG2)                                          0474
*                                 RESPECIFY                        0475
*                                  (GPR02F) UNRESTRICTED;          0475
*                               END;/* MODESET SAVEKEY(KEYSAVE)    0476
*                                      EXTKEY(TCB) WORKREG(KEYREG2)  */
*                               ICBPTR=VADR;/* STORE ICB ADDRESS IN
*                                      REG2 SINCE REG0 CANNOT BE USED
*                                      AS A BASE             @ZM45048*/
         LR    ICBPTR,VADR                                         0477
*                               RFY                                0478
*                                 ICB BASED(ICBPTR);/* REBASE THE  0478
*                                      MAPPING TO VERIFY THAT THE  0478
*                                      USER CAN ACCESS IT    @ZM45048*/
*                                                                  0478
*                               /*************************************/
*                               /*                                   */
*                               /* THE CODE IS NOW IN THE USER KEY.  */
*                               /* THE FOLLOWING STATEMENTS WILL     */
*                               /* VERIFY IF THE USER IS ALLOWED TO  */
*                               /* ACCESS THE ICB. IF THE            */
*                               /* INSTRUCTIONS COMPLETE WITHOUT     */
*                               /* ABEND, THE ICB WILL BE FORMATTED  */
*                               /* JUST AS BY AMDPRDMP. IF THE       */
*                               /* INSTRUCTIONS CAUSE AN ABEND (0C4),*/
*                               /* THEN THE ESTAE WILL RETRY AT      */
*                               /* ICBRETRY. THIS RETRY ADDRESS WILL */
*                               /* PRINT AN ABEND MESSAGE AND INHIBIT*/
*                               /* FURTHER ICB PROCESSING    @ZM45048*/
*                               /*                                   */
*                               /*************************************/
*                                                                  0479
*                               VADR=TESTBYTE;/* VERIFY ACCESSIBILITY
*                                      OF THE FIRST BYTE OF THE ICB
*                                                            @ZM45048*/
         SLR   VADR,VADR                                           0479
         IC    VADR,TESTBYTE(,ICBPTR)                              0479
*                               ICBPTR=ICBPTR+LENGTH(ICB)-1;/* REBASE
*                                      TESTBYTE ON LAST BYTE OF THE
*                                      ICB                   @ZM45048*/
         SH    ICBPTR,@CH02958                                     0480
*                               VADR=TESTBYTE;/* VERIFY ACCESSIBILITY
*                                      OF THE LAST BYTE OF THE ICB 0481
*                                                            @ZM45048*/
*                                                                  0481
         SLR   VADR,VADR                                           0481
         IC    VADR,TESTBYTE(,ICBPTR)                              0481
*                               /*************************************/
*                               /*                                   */
*                               /* THE KEY CAN BE RESET NOW THAT THE */
*                               /* ICB HAS BEEN ACCESSED     @ZM45048*/
*                               /*                                   */
*                               /*************************************/
*                                                                  0482
*                               DO; /* MODESET KEYADDR(KEYSAVE)    0482
*                                      WORKREG(KEYREG2)              */
*                                 KEYREG2=KEYSAVE;/* GET KEY FORM  0483
*                                      SAVE LOCATION                 */
         SLR   @14,@14                                             0483
         IC    @14,KEYSAVE                                         0483
         LR    KEYREG2,@14                                         0483
*                                 SPKA(KEYREG2);/* SET PSW KEY       */
         SPKA  0(KEYREG2)                                          0484
*                               END;/* MODESET KEYADDR(KEYSAVE)    0485
*                                      WORKREG(KEYREG2)              */
*                               ERREXP=OFF;/* AN ERROR IS NO LONGER
*                                      EXPECTED              @ZM45048*/
         NI    ERREXP,B'01111111'                                  0486
*                               RFY                                0487
*                                (KEYREG2) UNRSTD;/*         @ZM45048*/
*                               RFY                                0488
*                                 ICB BASED(IOBSTPTR);/*     @ZM45048*/
*                             END;  /* END SNAP IS CALLER- PROTECTION
*                                      NEEDED                @ZM45048*/
*                           ELSE                                   0490
*                             ;     /* PRINT DUMP IS CALLER, ALREADY
*                                      IN CALLERS KEY        @ZM45048*/
@RF00461 DS    0H                                                  0491
*                           ADPLFMT2=IOBSTPTR;/* FILL IN PARMLIST    */
         ST    IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0491
*                           OFFSET=ZERO;/* LENGTH OF PREFIX          */
         SLR   @14,@14                                             0492
         ST    @14,OFFSET(,ABDPLPTR)                               0492
*                           CALL PRINT;/* SPACE                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0493
         BALR  @14,@15                                             0493
*                           CALL PRINT;/* SPACE                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0494
         BALR  @14,@15                                             0494
*                           CALL IECDAIOB;/* ICB FORMATTER           */
         L     @15,@CV02687                                        0495
         BALR  @14,@15                                             0495
*                           IF RCREG=ZERO THEN/* FORMATTED ICB FINE  */
         LTR   RCREG,RCREG                                         0496
         BNZ   @RF00496                                            0496
*                             DO;                                  0497
*                               VADR=ADDR(ICBNICBA);/* NEXT ICB      */
         LR    VADR,IOBSTPTR                                       0498
*                               CALL ACCESRTN;/* ACCESS IT           */
         BAL   @14,ACCESRTN                                        0499
*                               IF RCREG^=ZERO THEN/* ACCESS ERROR   */
         LTR   RCREG,RCREG                                         0500
         BZ    @RF00500                                            0500
*                                 DO;                              0501
*ICBRETRY:                          /* RETRY POINT FOR ABEND @ZM45048*/
*                                   BUFFER(1:LENGTH(ICBMSG))=ICBMSG;
ICBRETRY L     @14,ADPLBUF(,ABDPLPTR)                              0502
         MVC   BUFFER(55,@14),ICBMSG                               0502
*                                   /* ERROR MESSAGE                 */
*                                   CALL PRINT;/* PRINT IT           */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0503
         BALR  @14,@15                                             0503
*                                   ERRSW=ON;/* END LOOP             */
         OI    ERRSW,B'10000000'                                   0504
*                                 END;/* END ACCESS ERROR            */
*                               ELSE/* FOUND ICB ADDR                */
*                                 DO;                              0506
         B     @RC00500                                            0506
@RF00500 DS    0H                                                  0507
*                                   IOBSTPTR=DATAADR;/* FILL IN ICB
*                                      PTR                           */
         SLR   IOBSTPTR,IOBSTPTR                                   0507
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0507
*                                   COMPARE=IOBSTPTR;/* TO CHECK FOR
*                                      LOOP                          */
         ST    IOBSTPTR,COMPARE                                    0508
*                                 END;/* END FOUND ICB ADDR          */
*                             END;  /* END FORMATTED ICB FINE        */
*                           ELSE                                   0511
*                             ERRSW=ON;/* ERROR FORMATTING ICB       */
         B     @RC00496                                            0511
@RF00496 OI    ERRSW,B'10000000'                                   0511
*                         END;      /* END FORMAT LOOP               */
@RC00496 AH    ARRAYCNT,@CH00041                                   0512
         CH    ARRAYCNT,@CH02766                                   0512
         BNH   @DL00460                                            0512
@DC00460 DS    0H                                                  0513
*                       END;        /* END FOUND ICBADDR OK          */
*                   END;            /* END FORMATTED IOB FINE        */
*                 ELSE                                             0515
*                   ;               /* ERROR FORMATTING MAIN IOB     */
@RF00446 DS    0H                                                  0516
*               END;                /* END FOUND MAIN IOB            */
*           END;                    /* END SAM CHAIN IOB             */
*         ELSE                      /* NOT SAM CHAIN IOB             */
*                                                                  0518
*           /*********************************************************/
*           /*                                                       */
*           /* BDAM TYPE IOBS - THE CHAIN ENDS WITH A ZERO PTR       */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0518
*           IF BDAMDCB=ON THEN      /* BDAM IOB                      */
         B     @RC00428                                            0518
@RF00428 TM    BDAMDCB(ABDPLPTR),B'00000010'                       0518
         BNO   @RF00518                                            0518
*             DO;                                                  0519
*               VADR=ADDR(DCBIOBAD);/* FIRST IOB ADDR                */
         LA    VADR,DCBIOBAD+16(,DCBPTR)                           0520
*               CALL ACCESRTN;      /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0521
*               IF RCREG^=ZERO THEN /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0522
         BZ    @RF00522                                            0522
*                 DO;                                              0523
*                   BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE */
         L     @14,ADPLBUF(,ABDPLPTR)                              0524
         MVC   BUFFER(64,@14),IOBERR                               0524
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0525
         BALR  @14,@15                                             0525
*                 END;              /* END ACCESS ERROR              */
*               ELSE                /* FOUND IOB ADDR                */
*                 DO;                                              0527
         B     @RC00522                                            0527
@RF00522 DS    0H                                                  0528
*                   IOBSTPTR=DATAADR;/* IOB STANDARD SECTION         */
         SLR   IOBSTPTR,IOBSTPTR                                   0528
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0528
*                   DO ARRAYCNT=1 TO LOOPMAX WHILE(ERRSW=OFF&IOBSTPTR^=
*                         ZERO);                                   0529
         LA    ARRAYCNT,1                                          0529
@DL00529 TM    ERRSW,B'10000000'                                   0529
         BNZ   @DC00529                                            0529
         LTR   IOBSTPTR,IOBSTPTR                                   0529
         BZ    @DC00529                                            0529
*                     ADPLFMT2=IOBSTPTR;/* FILL IN PARMLIST          */
         ST    IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0530
*                     OFFSET=BDAMPREF;/* LENGTH OF PREFIX            */
         MVC   OFFSET(4,ABDPLPTR),@CF00086                         0531
*                     CALL PRINT;   /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0532
         BALR  @14,@15                                             0532
*                     CALL PRINT;   /* SPACE                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0533
         BALR  @14,@15                                             0533
*                     CALL IECDAIOB;/* IOB FORMATTER                 */
         L     @15,@CV02687                                        0534
         BALR  @14,@15                                             0534
*                     IF RCREG=ZERO THEN/* FORMATTED IOB FINE        */
         LTR   RCREG,RCREG                                         0535
         BNZ   @RF00535                                            0535
*                       DO;                                        0536
*                         VADR=ADDR(IOBDPLAD);/* NEXT IOB            */
         LA    VADR,IOBDPLAD(,IOBSTPTR)                            0537
*                         CALL ACCESRTN;/* ACCESS IT                 */
         BAL   @14,ACCESRTN                                        0538
*                         IF RCREG^=ZERO THEN/* ACCESS ERROR         */
         LTR   RCREG,RCREG                                         0539
         BZ    @RF00539                                            0539
*                           DO;                                    0540
*                             BUFFER(1:LENGTH(IOBCHN))=IOBCHN;/*   0541
*                                      ERROR MESSAGE                 */
         L     @14,ADPLBUF(,ABDPLPTR)                              0541
         MVC   BUFFER(55,@14),IOBCHN                               0541
*                             CALL PRINT;/* PRINT IT                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0542
         BALR  @14,@15                                             0542
*                             ERRSW=ON;/* END LOOP                   */
         OI    ERRSW,B'10000000'                                   0543
*                           END;    /* END ACCESS ERROR              */
*                         ELSE      /* FOUND IOB ADDR                */
*                           IOBSTPTR=DATAADR;/* FILL IN IOB PTR      */
         B     @RC00539                                            0545
@RF00539 SLR   IOBSTPTR,IOBSTPTR                                   0545
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0545
*                       END;        /* END FORMATTED IOB FINE        */
*                     ELSE                                         0547
*                       ERRSW=ON;   /* ERROR FORMATTING IOB          */
         B     @RC00535                                            0547
@RF00535 OI    ERRSW,B'10000000'                                   0547
*                   END;            /* END FORMAT LOOP               */
@RC00535 AH    ARRAYCNT,@CH00041                                   0548
         CH    ARRAYCNT,@CH02766                                   0548
         BNH   @DL00529                                            0548
@DC00529 DS    0H                                                  0549
*                 END;              /* END FOUND IOBADDR OK          */
*             END;                  /* END BDAM IOB                  */
*           ELSE                    /* NOT BDAM IOB                  */
*                                                                  0551
*             /*******************************************************/
*             /*                                                     */
*             /* BTAM TYPE IOB                                       */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0551
*             IF BTAMDCB=ON THEN    /* BTAM IOB                      */
         B     @RC00518                                            0551
@RF00518 TM    BTAMDCB(ABDPLPTR),B'00000001'                       0551
         BNO   @RF00551                                            0551
*               DO;                                                0552
*                 VADR=ADDR(DCBEIOBX);/* SIZE OF THE IOB             */
         LA    VADR,DCBEIOBX+28(,DCBPTR)                           0553
*                 CALL ACCESRTN;    /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0554
*                 IF RCREG^=ZERO THEN/* ACCESS ERROR                 */
         LTR   RCREG,RCREG                                         0555
         BZ    @RF00555                                            0555
*                   DO;                                            0556
*                     BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR     0557
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0557
         MVC   BUFFER(64,@14),IOBERR                               0557
*                     CALL PRINT;   /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0558
         BALR  @14,@15                                             0558
*                   END;            /* END ACCESS ERROR              */
*                 ELSE              /* FOUND IOB SIZE                */
*                   DO;                                            0560
         B     @RC00555                                            0560
@RF00555 DS    0H                                                  0561
*                     SIZE=DATABYTE;/* SAVE THE SIZE                 */
         MVC   SIZE(1),DATABYTE(DATAPTR)                           0561
*                     VADR=ADDR(DCBIOBAD);/* ADR OF IOB BASE         */
         LA    VADR,DCBIOBAD+16(,DCBPTR)                           0562
*                     CALL ACCESRTN;/* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0563
*                     IF RCREG^=ZERO THEN/* ACCESS ERROR             */
         LTR   RCREG,RCREG                                         0564
         BZ    @RF00564                                            0564
*                       DO;                                        0565
*                         BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR 0566
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0566
         MVC   BUFFER(64,@14),IOBERR                               0566
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0567
         BALR  @14,@15                                             0567
*                       END;        /* END ACCESS ERROR              */
*                     ELSE          /* FOUND IOB BASE                */
*                       DO;                                        0569
         B     @RC00564                                            0569
@RF00564 DS    0H                                                  0570
*                         IOBSTPTR=DATAADR;/* IOB BASE               */
         SLR   IOBSTPTR,IOBSTPTR                                   0570
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0570
*                         ADPLFMT2=IOBSTPTR+SIZE;/* BASE PLUS SIZE ->
*                                      FIRST IOB                     */
         LR    @14,IOBSTPTR                                        0571
         SLR   @06,@06                                             0571
         IC    @06,SIZE                                            0571
         ALR   @14,@06                                             0571
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0571
*                         OFFSET=ZERO;/* LENGTH OF PREFIX            */
         SLR   @14,@14                                             0572
         ST    @14,OFFSET(,ABDPLPTR)                               0572
*                         CALL PRINT;/* SPACE                        */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0573
         BALR  @14,@15                                             0573
*                         CALL PRINT;/* SPACE                        */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0574
         BALR  @14,@15                                             0574
*                         CALL IECDAIOB;/* IOB FORMATTER             */
         L     @15,@CV02687                                        0575
         BALR  @14,@15                                             0575
*                       END;        /* END FOUND IOB BASE            */
*                   END;            /* END FOUND IOB SIZE            */
*               END;                /* END BTAM DCB                  */
*             ELSE                  /* NOT BTAM DCB                  */
*                                                                  0579
*               /*****************************************************/
*               /*                                                   */
*               /* GAM TYPE IOBS - THE CHAIN ENDS WITH A ZERO PTR    */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0579
*               IF GAMDCB=ON THEN   /* GAM IOB                       */
         B     @RC00551                                            0579
@RF00551 TM    GAMDCB(ABDPLPTR),B'10000000'                        0579
         BNO   @RF00579                                            0579
*                 DO;                                              0580
*                   VADR=ADDR(DCBIOBAD);/* FIRST IOB ADDR            */
         LA    VADR,DCBIOBAD+16(,DCBPTR)                           0581
*                   CALL ACCESRTN;  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0582
*                   IF RCREG^=ZERO THEN/* ACCESS ERROR               */
         LTR   RCREG,RCREG                                         0583
         BZ    @RF00583                                            0583
*                     DO;                                          0584
*                       BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR   0585
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0585
         MVC   BUFFER(64,@14),IOBERR                               0585
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0586
         BALR  @14,@15                                             0586
*                     END;          /* END ACCESS ERROR              */
*                   ELSE            /* FOUND IOB ADDR                */
*                     DO;                                          0588
         B     @RC00583                                            0588
@RF00583 DS    0H                                                  0589
*                       IOBSTPTR=DATAADR;/* IOB STANDARD SECTION     */
         SLR   IOBSTPTR,IOBSTPTR                                   0589
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0589
*                       DO ARRAYCNT=1 TO LOOPMAX WHILE(ERRSW=OFF&  0590
*                             IOBSTPTR^=ZERO);                     0590
         LA    ARRAYCNT,1                                          0590
@DL00590 TM    ERRSW,B'10000000'                                   0590
         BNZ   @DC00590                                            0590
         LTR   IOBSTPTR,IOBSTPTR                                   0590
         BZ    @DC00590                                            0590
*                         ADPLFMT2=IOBSTPTR;/* FILL IN PARMLIST      */
         ST    IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0591
*                         OFFSET=GAMPREF;/* LENGTH OF PREFIX         */
         MVC   OFFSET(4,ABDPLPTR),@CF00080                         0592
*                         CALL PRINT;/* SPACE                        */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0593
         BALR  @14,@15                                             0593
*                         CALL PRINT;/* SPACE                        */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0594
         BALR  @14,@15                                             0594
*                         CALL IECDAIOB;/* IOB FORMATTER             */
         L     @15,@CV02687                                        0595
         BALR  @14,@15                                             0595
*                         IF RCREG=ZERO THEN/* FORMATTED IOB FINE    */
         LTR   RCREG,RCREG                                         0596
         BNZ   @RF00596                                            0596
*                           DO;                                    0597
*                             VADR=ADDR(IOBNXTPT);/* NEXT IOB        */
         LA    VADR,IOBNXTPT(,IOBSTPTR)                            0598
*                             CALL ACCESRTN;/* ACCESS IT             */
         BAL   @14,ACCESRTN                                        0599
*                             IF RCREG^=ZERO THEN/* ACCESS ERROR     */
         LTR   RCREG,RCREG                                         0600
         BZ    @RF00600                                            0600
*                               DO;                                0601
*                                 BUFFER(1:LENGTH(IOBCHN))=IOBCHN;/*
*                                      ERROR MESSAGE                 */
         L     @14,ADPLBUF(,ABDPLPTR)                              0602
         MVC   BUFFER(55,@14),IOBCHN                               0602
*                                 CALL PRINT;/* PRINT IT             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0603
         BALR  @14,@15                                             0603
*                                 ERRSW=ON;/* END LOOP               */
         OI    ERRSW,B'10000000'                                   0604
*                               END;/* END ACCESS ERROR              */
*                             ELSE  /* FOUND IOB ADDR                */
*                               IOBSTPTR=DATAADR;/* FILL IN IOB PTR  */
         B     @RC00600                                            0606
@RF00600 SLR   IOBSTPTR,IOBSTPTR                                   0606
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0606
*                           END;    /* END FORMATTED IOB FINE        */
*                         ELSE                                     0608
*                           ERRSW=ON;/* ERROR FORMATTING IOB         */
         B     @RC00596                                            0608
@RF00596 OI    ERRSW,B'10000000'                                   0608
*                       END;        /* END FORMAT LOOP               */
@RC00596 AH    ARRAYCNT,@CH00041                                   0609
         CH    ARRAYCNT,@CH02766                                   0609
         BNH   @DL00590                                            0609
@DC00590 DS    0H                                                  0610
*                     END;          /* END FOUND IOBADDR OK          */
*                 END;              /* END GAM IOB                   */
*               ELSE                /* NOT GAM IOB                   */
*                                                                  0612
*                 /***************************************************/
*                 /*                                                 */
*                 /* TCAM TYPE LCBS - ONLY UNDER AMDPRDMP - SNAP     */
*                 /* ALREADY HAS FORMATTED THESE LCBS                */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0612
*                 IF TCAMLINE=ON&ADPLSNPR=ON THEN/* TCAM LINE AND  0612
*                                      PRINT DUMP                    */
         B     @RC00579                                            0612
@RF00579 TM    TCAMLINE(ABDPLPTR),B'01000000'                      0612
         BNO   @RF00612                                            0612
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0612
         BNO   @RF00612                                            0612
*                   DO;                                            0613
*                     VADR=ADDR(DEBNMEXT);/* NUMBER OF LCBS          */
         LA    VADR,DEBNMEXT(,DEBPTR)                              0614
*                     CALL ACCESRTN;/* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0615
*                     IF RCREG^=ZERO THEN/* ACCESS ERROR             */
         LTR   RCREG,RCREG                                         0616
         BZ    @RF00616                                            0616
*                       DO;                                        0617
*                         BUFFER(1:LENGTH(LCBERR))=LCBERR;         0618
         L     @14,ADPLBUF(,ABDPLPTR)                              0618
         MVC   BUFFER(64,@14),LCBERR                               0618
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0619
         BALR  @14,@15                                             0619
*                       END;        /* END ACCESS ERROR              */
*                     ELSE          /* FOUND NUMBER OF LCBS          */
*                       DO;                                        0621
         B     @RC00616                                            0621
@RF00616 DS    0H                                                  0622
*                         NUMLCB=DATABYTE;/* SAVE NUMBER OF LCBS     */
         MVC   NUMLCB(1),DATABYTE(DATAPTR)                         0622
*                         VADR=ADDR(DCBEIOBX);/* SIZE OF THE LCB     */
         LA    VADR,DCBEIOBX+28(,DCBPTR)                           0623
*                         CALL ACCESRTN;/* ACCESS IT                 */
         BAL   @14,ACCESRTN                                        0624
*                         IF RCREG^=ZERO THEN/* ACCESS ERROR         */
         LTR   RCREG,RCREG                                         0625
         BZ    @RF00625                                            0625
*                           DO;                                    0626
*                             BUFFER(1:LENGTH(LCBERR))=LCBERR;/*   0627
*                                      ERROR MSG                     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0627
         MVC   BUFFER(64,@14),LCBERR                               0627
*                             CALL PRINT;/* PRINT IT                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0628
         BALR  @14,@15                                             0628
*                           END;    /* END ACCESS ERROR              */
*                         ELSE      /* FOUND LCB SIZE                */
*                           DO;                                    0630
         B     @RC00625                                            0630
@RF00625 DS    0H                                                  0631
*                             SIZE=DATABYTE;/* SAVE LCB SIZE         */
         MVC   SIZE(1),DATABYTE(DATAPTR)                           0631
*                             VADR=ADDR(DCBIOBAD);/* ADDR OF IOB BASE
*                                                            @ZM45056*/
         LA    VADR,DCBIOBAD+16(,DCBPTR)                           0632
*                             CALL ACCESRTN;/* ACCESS IT             */
         BAL   @14,ACCESRTN                                        0633
*                             IF RCREG^=ZERO THEN/* ACCESS ERROR     */
         LTR   RCREG,RCREG                                         0634
         BZ    @RF00634                                            0634
*                               DO;                                0635
*                                 BUFFER(1:LENGTH(LCBERR))=LCBERR;/*
*                                      ERROR MESSAGE                 */
         L     @14,ADPLBUF(,ABDPLPTR)                              0636
         MVC   BUFFER(64,@14),LCBERR                               0636
*                                 CALL PRINT;/* PRINT IT             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0637
         BALR  @14,@15                                             0637
*                               END;/* END ACCESS ERROR              */
*                             ELSE  /* FOUND IOB BASE ADDR   @ZM45056*/
*                               DO;                                0639
         B     @RC00634                                            0639
@RF00634 DS    0H                                                  0640
*                                 IOBSTPTR=DATAADR+SIZE-OFSETIOB;/*
*                                      FIND THE POINTER TO THE FIRST
*                                      LCB BY ADDING THE LCB SIZE TO
*                                      THE IOB BASE ADDR. THIS NOW 0640
*                                      POINTS TO THE FIRST IOB, WHICH
*                                      IS EMBEDDED AT X'20' INTO THE
*                                      FIRST LCB. BACK UP THE 32   0640
*                                      BYTES TO POINT TO THE FIRST 0640
*                                      LCB                   @ZM45056*/
         SLR   IOBSTPTR,IOBSTPTR                                   0640
         ICM   IOBSTPTR,7,DATAADR(DATAPTR)                         0640
         SLR   @14,@14                                             0640
         IC    @14,SIZE                                            0640
         ALR   IOBSTPTR,@14                                        0640
         SH    IOBSTPTR,@CH00133                                   0640
*                                 DO ARRAYCNT=1 TO NUMLCB WHILE(ERRSW=
*                                       OFF);                      0641
         LA    ARRAYCNT,1                                          0641
         B     @DE00641                                            0641
@DL00641 TM    ERRSW,B'10000000'                                   0641
         BNZ   @DC00641                                            0641
*                                   ADPLFMT2=IOBSTPTR;/* FILL IN   0642
*                                      PARMLIST                      */
         ST    IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0642
*                                   OFFSET=ZERO;/* LENGTH OF PREFIX  */
         SLR   @14,@14                                             0643
         ST    @14,OFFSET(,ABDPLPTR)                               0643
*                                   CALL PRINT;/* BLANK LINE         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0644
         BALR  @14,@15                                             0644
*                                   CALL PRINT;/* BLANK LINE         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0645
         BALR  @14,@15                                             0645
*                                   CALL IECDAIOB;/* LCB FORMATTER   */
         L     @15,@CV02687                                        0646
         BALR  @14,@15                                             0646
*                                   IF RCREG=ZERO THEN/* LCB       0647
*                                      FORMATTED FINE                */
         LTR   RCREG,RCREG                                         0647
         BNZ   @RF00647                                            0647
*                                    IOBSTPTR=IOBSTPTR+SIZE;/* NEXT
*                                      LCB                           */
         SLR   @14,@14                                             0648
         IC    @14,SIZE                                            0648
         ALR   IOBSTPTR,@14                                        0648
*                                   ELSE/* LCB FORMATTER ERROR       */
*                                    ERRSW=ON;/* TERMINATE THE LOOP  */
         B     @RC00647                                            0649
@RF00647 OI    ERRSW,B'10000000'                                   0649
*                                 END;/* END FORMAT LOOP             */
@RC00647 AH    ARRAYCNT,@CH00041                                   0650
@DE00641 SLR   @14,@14                                             0650
         IC    @14,NUMLCB                                          0650
         CR    ARRAYCNT,@14                                        0650
         BNH   @DL00641                                            0650
@DC00641 DS    0H                                                  0651
*                               END;/* END FOUND FIRST LCB OK        */
*                           END;    /* END FOUND LCB SIZE FINE       */
*                       END;        /* END FOUND NUMBER OF LCBS FINE */
*                   END;            /* END TCAM LINE GROUP           */
*                 ELSE                                             0655
*                   ;               /* UNEXPECTED ACCESS METHOD, NO
*                                      IOB FORMATTED                 */
@RF00612 DS    0H                                                  0656
*   END IOBRTN;                                                    0656
@EL00003 DS    0H                                                  0656
@EF00003 DS    0H                                                  0656
@ER00003 L     @14,@SA00003                                        0656
         BR    @14                                                 0656
*RELLOCK:                                                          0657
*   PROC OPTIONS(SAVE(14));                                        0657
*                                                                  0657
RELLOCK  ST    @14,@SA00004                                        0657
*/********************************************************************/
*/* FUNCTION-                                                      0658
*       ROUTINE TO RELEASE THE LOCAL LOCK IF IT IS HELD AND TO TURN
*     OFF THE LOCKHELD BIT IN THE ESTAE PARM LIST.                 0658
*                                                                  0658
*                                                                  0658
*   INPUT -                                                        0658
*         REGISTER 1 POINTS TO THE PARMLIST PASSED BY THE CALLER.  0658
*                                                                  0658
*    CALLS-                                                        0658
*         MAKES NO OUTSIDE CALLS                                   0658
*                                                                  0658
*    CALLED BY -                                                   0658
*         IECDAFMT                                                 0658
*                                                                  0658
*    RETURNS TO -                                                  0658
*         CALLER WITHOUT SETTING A RETURN CODE                     0658
*                                                                  0658
*                                                                    */
*/********************************************************************/
*                                                                  0658
*   IF LOCKHELD=ON THEN             /* RELEASE LOCAL LOCK            */
         TM    LOCKHELD,B'01000000'                                0658
         BNO   @RF00658                                            0658
*     DO;                                                          0659
*       PARMSAVE=ABDPLPTR;          /* SAVE REGISTER 1               */
*                                                                  0660
         LR    PARMSAVE,ABDPLPTR                                   0660
*       /*************************************************************/
*       /*                                                           */
*       /* ONLY REG 1, WHICH GETS MODIFIED BY SETLOCK, NEEDS TO BE   */
*       /* SAVED                                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0661
*       DO;                         /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      REGS(USE) RELATED(IECDAFMT)   */
*         RFY                                                      0662
*          (GPR11P,                                                0662
*           GPR12P,                                                0662
*           GPR13P,                                                0662
*           GPR14P) RSTD;                                          0662
*         RFY                                                      0663
*          (GPR15P,                                                0663
*           GPR00P,                                                0663
*           GPR01P) RSTD;                                          0663
*         GPR15P=GPR11P;            /* SAVE REG. 11 IN REG. 15.      */
         LR    GPR15P,GPR11P                                       0664
*         GPR00P=GPR12P;            /* SAVE REG. 12 IN REG. 0.       */
         LR    GPR00P,GPR12P                                       0665
*         GPR01P=GPR13P;            /* SAVE REG. 13 IN REG. 1.       */
         LR    GPR01P,GPR13P                                       0666
*         GPR13P=PSALITA;           /* ADDRESS OF LOCK INTERFACE   0667
*                                      TABLE.                        */
         L     GPR13P,PSALITA                                      0667
*         GEN(LM GPR11P,GPR13P,588(GPR13P));/* LOAD LOCKWORD, CLHT 0668
*                                      AND ENTRY ADRS.               */
         LM GPR11P,GPR13P,588(GPR13P)
*         GEN(BALR GPR14P,GPR13P);  /* BALR TO SETLOCK RTN.          */
         BALR GPR14P,GPR13P
*         GPR11P=GPR15P;            /* RESTORE REG. 11.              */
         LR    GPR11P,GPR15P                                       0670
*         GPR15P=GPR13P;            /* SAVE RETURN CODE.             */
         LR    GPR15P,GPR13P                                       0671
*         GPR12P=GPR00P;            /* RESTORE REG. 12               */
         LR    GPR12P,GPR00P                                       0672
*         GPR13P=GPR01P;            /* RESTORE REG. 13.              */
         LR    GPR13P,GPR01P                                       0673
*         RFY                                                      0674
*          (GPR15P,                                                0674
*           GPR00P,                                                0674
*           GPR01P) UNRSTD;                                        0674
*         RFY                                                      0675
*          (GPR11P,                                                0675
*           GPR12P,                                                0675
*           GPR13P,                                                0675
*           GPR14P) UNRSTD;                                        0675
*       END;                        /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      REGS(USE) RELATED(IECDAFMT)   */
*       LOCKHELD=OFF;               /* INDICATE LOCK NO LONGER HELD  */
         NI    LOCKHELD,B'10111111'                                0677
*       ABDPLPTR=PARMSAVE;          /* RESTORE REGISTER 1            */
         LR    ABDPLPTR,PARMSAVE                                   0678
*     END;                          /* END LOCAL LOCK RELEASED       */
*   ELSE                                                           0680
*     ;                             /* NO NEED TO RELEASE LOCK       */
@RF00658 DS    0H                                                  0681
*   END RELLOCK;                                                   0681
@EL00004 DS    0H                                                  0681
@EF00004 DS    0H                                                  0681
@ER00004 L     @14,@SA00004                                        0681
         BR    @14                                                 0681
*ACCESRTN:                                                         0682
*   PROC OPTIONS(SAVE(14));                                        0682
*                                                                  0682
ACCESRTN ST    @14,@SA00005                                        0682
*/********************************************************************/
*/* FUNCTION-                                                      0683
*       ROUTINE WHICH CALLS THE ACCESS SERVICE ROUTINE AND MOVES THE
*     VALUE RETURNED IN R0 INTO DATAPTR.                           0683
*                                                                  0683
*                                                                  0683
*   INPUT -                                                        0683
*         VADR(REGISTER 0) CONTAINS THE VIRTUAL ADDRESS OF THE FIELD
*         TO BE ACCESSED.                                          0683
*                                                                  0683
*    CALLS-                                                        0683
*         ACCESS SERVICE ROUTINE PASSED IN PARMLIST                0683
*                                                                  0683
*    CALLED BY -                                                   0683
*         ALL ROUTINES IN THIS MODULE                              0683
*                                                                  0683
*    RETURNS TO -                                                  0683
*         CALLER WITH THE RETURN CODE SET BY THE ACCESS            0683
*         SERVICE ROUTINE.                                         0683
*                                                                  0683
*                                                                    */
*/********************************************************************/
*                                                                  0683
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS THE CALLER           */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0683
         BNZ   @RF00683                                            0683
*     DO;                                                          0684
*       RTYADR=ADDR(RETRY);         /* RETRY ADDR FOR ESTAE IN CASE
*                                      OF EXPECTED ERROR-SIMULATES 0685
*                                      PRINT DUMP                    */
         LA    @14,RETRY                                           0685
         ST    @14,RTYADR                                          0685
*       DATAPTR=VADR;               /* PREPARE FOR A LOAD FROM THE 0686
*                                      DUMP INTO AN INTERNAL BUFFER  */
         LR    DATAPTR,VADR                                        0686
*       RCREG=ZERO;                 /* SUCCESS UNLESS OTHERWISE    0687
*                                      CHANGED                       */
         SLR   RCREG,RCREG                                         0687
*       ERREXP=ON;                  /* AN ERROR IS EXPECTED          */
         OI    ERREXP,B'10000000'                                  0688
*       VERIFY=DATADWRD;            /* MOVE A DOUBLE WORD INTO THE 0689
*                                      BUFFER                        */
*                                                                  0689
         MVC   VERIFY(8),DATADWRD(DATAPTR)                         0689
*       /*************************************************************/
*       /*                                                           */
*       /* THIS MOVE WILL CAUSE AN ABEND IF THE DUMP DOES NOT CONTAIN*/
*       /* THIS AREA OR IF IT IS PROTECTED. IF AN ABEND OCCURS THE   */
*       /* ESTAE WILL GET CONTROL AND RETRY AT THE POINT WHICH SETS A*/
*       /* BAD RETURN CODE AND CONTINUES IN THE MAIN LINE. THIS THEN */
*       /* SIMULATES THE PRINT DUMP ACCESS ROUTINE. IF THE AREA ASKED*/
*       /* FOR IS IN THE DUMP. A DOUBLE WORD IS MOVED INTO AN        */
*       /* INTERNAL BUFFER TO PREVENT AN UNEXPECTED ERROR WHEN       */
*       /* REFERENCING THE AREA AGAIN                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0690
*       ERREXP=OFF;                 /* ERROR NO LONGER EXPECTED      */
         NI    ERREXP,B'01111111'                                  0690
*       DATAPTR=ADDR(VERIFY);       /* BASE DATAWORD ON THE BUFFER   */
         LA    DATAPTR,VERIFY                                      0691
*     END;                          /* END SNAP WAS CALLER           */
*   ELSE                            /* CALLER HAS OWN ACCESS ROUTINE */
*     DO;                                                          0693
         B     @RC00683                                            0693
@RF00683 DS    0H                                                  0694
*       CALL ACCESS;                /* ACCESS SERVICE ROUTINE PASSED
*                                      BY CALLER                     */
         L     @15,ADPLMEMA(,ABDPLPTR)                             0694
         BALR  @14,@15                                             0694
*       IF RCREG=ZERO THEN                                         0695
         LTR   RCREG,RCREG                                         0695
         BNZ   @RF00695                                            0695
*         DATAPTR=VADR;             /* SAVE PTR RETURNED BY ACCESS 0696
*                                      SERVICE ROUTINE               */
         LR    DATAPTR,VADR                                        0696
*       ELSE                        /* BAD RETURN CODE               */
*RETRY:                             /* RETRY ADDR FOR THE ESTAE      */
*         RCREG=4;                  /* SET BAD RETURN FOR THE      0697
*                                      MAINLINE                      */
         B     @RC00695                                            0697
@RF00695 DS    0H                                                  0697
RETRY    LA    RCREG,4                                             0697
*     END;                          /* END CALLER NOT SNAP           */
@RC00695 DS    0H                                                  0699
*   RCCODE=RCREG;                   /* SAVE RETURN CODE              */
@RC00683 ST    RCREG,RCCODE                                        0699
*   RETURN CODE(RCCODE);                                           0700
         L     @14,RCCODE                                          0700
         LR    @15,@14                                             0700
@EL00005 DS    0H                                                  0700
@EF00005 DS    0H                                                  0700
@ER00005 L     @14,@SA00005                                        0700
         BR    @14                                                 0700
*   END ACCESRTN;                                                  0701
*ESTAERTN:                                                         0702
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0702
*                                                                  0702
ESTAERTN DS    0H                                                  0703
*/********************************************************************/
*/* FUNCTION-                                                      0703
*       ROUTINE TO DETERMINE IF THE ERROR WAS EXPECTED AND CONTINUE
*     PROCESSING OR TO CLEAN UP AND EXIT. IF THE ERROR WAS EXPECTED
*     THEN THE CONTROL IS RETURNED TO THE ADDRESS PASSED IN THE ESTAE
*     PARM LIST. THIS RETURN ACTS LIKE THE BAD RETURN FROM THE ACCESS
*     SERVICE ROUTINE. IF THE ERROR WAS NOT EXPECTED, REQUIRED CLEAN UP
*     OF RESOURCES IS DONE. A MESSAGE IS FILLED INTO THE BUFFER AND
*     CONTROL IS RETURNED AT THE END OF THE FORMATTER.             0703
*                                                                  0703
*    CALLS-                                                        0703
*         MAKES NO OUTSIDE CALLS                                   0703
*                                                                  0703
*    CALLED BY -                                                   0703
*         RTM IN AN ABEND SITUATION                                0703
*                                                                  0703
*    RETURNS TO -                                                  0703
*         CALLER                                                   0703
*                                                                    */
*/********************************************************************/
*                                                                  0703
*   /*****************************************************************/
*   /*                                                               */
*   /* NO RESTORE REGS SPECIFIED                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0703
*   DO;                             /* ENTESTAE PARMREG(DREG)        */
*/*  ENTRY CODE FOR ESTAE ROUTINE.                                   */
*/*  IF RTCA ALLOCATED THEN RESTORE CODE AND                         */
*/*  DATA REGS FROM START OF USERS PARM LIST,                        */
*/*  AND ESTABLISH ADDR TO ESTAE SAVE AREA                           */
*/*  IF REQUIRED.                                                    */
*/*  IF NO RTCA IS AVAILABLE THEN JUST RETURN                        */
*/*  TO RTM TO CONTINUE TERMINATION                                  */
*                                                                  0704
*     GEN(USING *,GPR15P);                                         0704
         USING *,GPR15P
*     GEN(CH    GPR00F,*+14);       /* CHECK IF RTCA ALLOC FAILED    */
         CH    GPR00F,*+14
*     GEN(BNE   *+12);              /* NO,SAVE RTM REGS              */
         BNE   *+12
*     GEN(DROP  GPR15P);            /* DROP LOCAL ADDR               */
         DROP  GPR15P
*     GEN(LA    GPR15P,0);          /* YES, SET CONT TERM RC         */
         LA    GPR15P,0
*     GEN(BR    GPR14P);            /* RETURN TO RTM                 */
         BR    GPR14P
*     GEN(DC    H'12');             /* NO RTCA AVAIL RC              */
         DC    H'12'
*     GEN(STM   GPR14P,GPR12F,12(GPR13P));/* GOOD R13, SAVE RTM'S  0711
*                                      REGS                          */
         STM   GPR14P,GPR12F,12(GPR13P)
*     GEN(L     DREG,0(GPR01P));    /* PTR TO USER PARM LIST         */
         L     DREG,0(GPR01P)
*   END;                            /* ENTESTAE PARMREG(DREG)        */
*                                                                  0713
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS CODE SET DREG TO BE THE POINTER TO ALL THE AUTOMATIC DATA*/
*   /* FOR THIS MODULE                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0714
*   LM(GPR02P,GPR12F,REG2TO12);     /* RESTORE THE REGS SAVED FROM 0714
*                                      THE MAINLINE                  */
         LM    GPR02P,GPR12F,REG2TO12                              0714
*   SDWAPTR=GPR01P;                 /* SDWA ADDR PASSED TO THIS    0715
*                                      ROUTINE                       */
*                                                                  0715
         ST    GPR01P,SDWAPTR                                      0715
*   /*****************************************************************/
*   /*                                                               */
*   /* TO PREVENT MORE THAN ONE DUMP BEING TAKEN FOR AN X37 TYPE     */
*   /* ABEND, PERCOLATE TO THE CALLERS RECOVERY. THIS WILL PREVENT   */
*   /* THIS ESTAE FROM TAKING A DUMP AND LET THE CALLERS RECOVERY    */
*   /* TAKE IT.                                              @ZM43805*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0716
*   IF ABNDTYPE^='37'X THEN         /* PERCOLATE FOR ALL X37 TYPE  0716
*                                      ABEND CODES           @ZM43805*/
         L     @14,SDWAPTR                                         0716
         MVC   @TS00001(2),ABNDTYPE(@14)                           0716
         NC    @TS00001(2),@CB02969                                0716
         CLC   @TS00001(2),@CB02971                                0716
         BE    @RF00716                                            0716
*     DO;                           /* NOT AN X37 ABEND      @ZM43805*/
*       IF ABND^='0C4'X THEN        /* ONLY EXPECTED ERROR CODE      */
         L     @14,SDWAPTR                                         0718
         MVC   @TS00001(2),ABND(@14)                               0718
         NC    @TS00001(2),@CB02973                                0718
         CLC   @TS00001(2),@CB02975                                0718
         BE    @RF00718                                            0718
*         ERREXP=OFF;               /* EVEN IF AN ERROR WAS EXPECTED,
*                                      THIS ABEND CODE WAS NOT THE 0719
*                                      EXPECTED ONE                  */
         NI    ERREXP,B'01111111'                                  0719
*       ELSE                                                       0720
*         ;                         /* SEE IF THE ERROR WAS EXPECTED */
@RF00718 DS    0H                                                  0721
*       IF ERREXP=ON THEN           /* AN ERROR WAS EXPECTED BY THE
*                                      CODE                          */
         TM    ERREXP,B'10000000'                                  0721
         BNO   @RF00721                                            0721
*         DO;                                                      0722
*           ERREXP=OFF;             /* TURN OFF EXPECTED ERROR       */
*           LOCKHELD=OFF;           /* RTM RELEASED LOCAL LOCK       */
         NI    ERREXP,B'00111111'                                  0724
*           SDWASRSV=LCALREGS;      /* REGS AT ABEND, USED AT RETRY  */
*                                                                  0725
         L     @14,SDWAPTR                                         0725
         MVC   SDWASRSV(64,@14),LCALREGS                           0725
*           /*********************************************************/
*           /*                                                       */
*           /* RETRY AT THE ACCESS RTN WHICH TOOK THE ERROR,AT THAT  */
*           /* POINT THE RETURN CODE WILL BE SET TO 4 TO SIMULATE THE*/
*           /* PRINT DUMP ACCESS SERVICE ROUTINE.                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0726
*           DO;                     /* SETRP REGS(14,12)DUMP(NO)RC(4)
*                                      RETADDR(RETRYPT)RETREGS(YES)FR
*                                      ESDWA(YES)                    */
*             RESPECIFY                                            0727
*              (GPR00P,                                            0727
*               GPR01P,                                            0727
*               GPR14P,                                            0727
*               GPR15P) RSTD;                                      0727
*             GPR01P->SDWARCDE=4;   /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0728
*             GPR01P->SDWARTYA=ADDR(RETRYPT);/* SAVE RETRY ADDRESS   */
         MVC   SDWARTYA(4,GPR01P),RTYADR                           0729
*             GPR01P->SDWAFREE='1'B;/* SET FLAG TO FREE SDWA         */
         OI    SDWAFREE(GPR01P),B'00000100'                        0730
*             GPR01P->SDWAREQ='0'B; /* TURN OFF DUMP INDICATOR       */
         NI    SDWAREQ(GPR01P),B'01111111'                         0731
*             GPR01P->SDWAUPRG='1'B;/* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0732
*             GEN(RETURN (14,12));                                 0733
         RETURN (14,12)
*             RESPECIFY                                            0734
*              (GPR00P,                                            0734
*               GPR01P,                                            0734
*               GPR14P,                                            0734
*               GPR15P) UNRSTD;                                    0734
*           END;                                                   0735
*         END;                      /* END AN ERROR WAS EXPECTED     */
*       ELSE                        /* AN UNEXPECTED ERROR - RETRY AT
*                                      RETURN TO CALLER              */
*         DO;                                                      0737
         B     @RC00721                                            0737
@RF00721 DS    0H                                                  0738
*           IF UNEXP2=OFF THEN      /* THE FIRST UNEXPECTED ERROR    */
         TM    UNEXP2,B'00100000'                                  0738
         BNZ   @RF00738                                            0738
*             DO;                                                  0739
*               UNEXP2=ON;          /* RETRY ONLY ONCE - PREVENT LOOP*/
*               LOCKHELD=OFF;       /* RTM RELEASED LOCAL LOCK       */
         OI    UNEXP2,B'00100000'                                  0741
         NI    LOCKHELD,B'10111111'                                0741
*               RTYADR=ADDR(TROUBLE);/* RETRY POINT IN MAIN LINE FOR
*                                      UNEXPECTED ERRORS             */
         LA    @14,TROUBLE                                         0742
         ST    @14,RTYADR                                          0742
*               SDWASRSV=RTYREGS;   /* SET RETRY REGS FOR MAINLINE 0743
*                                      RETRY                         */
         L     @10,SDWAPTR                                         0743
         MVC   SDWASRSV(64,@10),RTYREGS                            0743
*               ABDPLPTR=RTYREG1;   /* RESTORE PTR TO PRINT DUMP   0744
*                                      PARMLIST-REG1                 */
         L     ABDPLPTR,RTYREG1                                    0744
*               BUFFER=ENDMSG;      /* ABEND MESSAGE                 */
         L     @04,ADPLBUF(,ABDPLPTR)                              0745
         MVI   BUFFER+53(@04),C' '                                 0745
         MVC   BUFFER+54(66,@04),BUFFER+53(@04)                    0745
         MVC   BUFFER(53,@04),ENDMSG                               0745
*               PACKAREA(3:4)=ABNDCMPC;/* MOVE COMP CODE TO CHAR AREA*/
         MVC   PACKAREA+2(2),ABNDCMPC(@10)                         0746
*               GARBAGE='04'X;      /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0747
*               UNPK(BUFFER(54:58),UNPACK(3:5));/* UNPACK INTO THE 0748
*                                      BUFFER                        */
         UNPK  BUFFER+53(5,@04),UNPACK+2(3)                        0748
*               TR(BUFFER(54:58),TRANS);/* TRANSLATE TO PRINTABLE HEX*/
         TR    BUFFER+53(5,@04),TRANS                              0749
*               BUFFER(57:57)=' ';  /* BLANK OUT SECOND HALF BYTE    */
         MVI   BUFFER+56(@04),C' '                                 0750
*               GPR01P=SDWAPTR;     /* RESTORE REGISTER 1 FOR SETRP  */
         LR    GPR01P,@10                                          0751
*               DO;                 /* SETRP REGS(14,12)DUMP(YES)RC(4
*                                      )RETADDR(RETRYPT)RETREGS(YES)F
*                                      RESDWA(YES)                   */
*                 RESPECIFY                                        0753
*                  (GPR00P,                                        0753
*                   GPR01P,                                        0753
*                   GPR14P,                                        0753
*                   GPR15P) RSTD;                                  0753
*                 GPR01P->SDWARCDE=4;/* STORE RC INTO SDWA           */
         MVI   SDWARCDE(GPR01P),X'04'                              0754
*                 GPR01P->SDWARTYA=ADDR(RETRYPT);/* SAVE RETRY     0755
*                                      ADDRESS                       */
         L     @10,RTYADR                                          0755
         ST    @10,SDWARTYA(,GPR01P)                               0755
*                 GPR01P->SDWAFREE='1'B;/* SET FLAG TO FREE SDWA     */
         OI    SDWAFREE(GPR01P),B'00000100'                        0756
*                 GPR01P->SDWAREQ='1'B;/* TURN ON DUMP INDICATOR     */
         OI    SDWAREQ(GPR01P),B'10000000'                         0757
*                 GPR01P->SDWAUPRG='1'B;/* TURN ON RETREGS INDICATOR */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0758
*                 GEN(RETURN (14,12));                             0759
         RETURN (14,12)
*                 RESPECIFY                                        0760
*                  (GPR00P,                                        0760
*                   GPR01P,                                        0760
*                   GPR14P,                                        0760
*                   GPR15P) UNRSTD;                                0760
*               END;                                               0761
*             END;                  /* END FIRST UNEXPECTED ERROR    */
*           ELSE                    /* PERCOLATE FOR SECOND        0763
*                                      UNEXPECTED ERROR              */
*             DO;                   /* SETRP                       0763
*                                      REGS(14,12)DUMP(YES)RC(0)     */
         B     @RC00738                                            0763
@RF00738 DS    0H                                                  0764
*               RESPECIFY                                          0764
*                (GPR00P,                                          0764
*                 GPR01P,                                          0764
*                 GPR14P,                                          0764
*                 GPR15P) RSTD;                                    0764
*               GPR01P->SDWARCDE=0; /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0765
*               GPR01P->SDWAREQ='1'B;/* TURN ON DUMP INDICATOR       */
         OI    SDWAREQ(GPR01P),B'10000000'                         0766
*               GEN(RETURN (14,12));                               0767
         RETURN (14,12)
*               RESPECIFY                                          0768
*                (GPR00P,                                          0768
*                 GPR01P,                                          0768
*                 GPR14P,                                          0768
*                 GPR15P) UNRSTD;                                  0768
*             END;                  /*                       @ZM43805*/
*         END;                      /* END UNEXPECTED ERROR          */
*     END;                          /* END NOT AN X37 TYPE ABEND   0771
*                                                            @ZM43805*/
*   ELSE                            /* THIS IS AN X37 ABEND -      0772
*                                      PERCOLATE             @ZM43805*/
*     DO;                           /* SETRP                       0772
*                                      REGS(14,12)DUMP(YES)RC(0)     */
         B     @RC00716                                            0772
@RF00716 DS    0H                                                  0773
*       RESPECIFY                                                  0773
*        (GPR00P,                                                  0773
*         GPR01P,                                                  0773
*         GPR14P,                                                  0773
*         GPR15P) RSTD;                                            0773
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0774
*       GPR01P->SDWAREQ='1'B;       /* TURN ON DUMP INDICATOR        */
         OI    SDWAREQ(GPR01P),B'10000000'                         0775
*       GEN(RETURN (14,12));                                       0776
         RETURN (14,12)
*       RESPECIFY                                                  0777
*        (GPR00P,                                                  0777
*         GPR01P,                                                  0777
*         GPR14P,                                                  0777
*         GPR15P) UNRSTD;                                          0777
*     END;                          /*                       @ZM43805*/
*   END ESTAERTN;                                                  0779
@EL00006 DS    0H                                                  0779
@EF00006 DS    0H                                                  0779
@ER00006 BR    @14                                                 0779
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     0780
*     GPR02F FIXED(31) REG(2),                                     0780
*     GPR12F FIXED(31) REG(12),                                    0780
*     GPR00P PTR(31) REG(0),                                       0780
*     GPR01P PTR(31) REG(1),                                       0780
*     GPR02P PTR(31) REG(2),                                       0780
*     GPR11P PTR(31) REG(11),                                      0780
*     GPR12P PTR(31) REG(12),                                      0780
*     GPR13P PTR(31) REG(13),                                      0780
*     GPR14P PTR(31) REG(14),                                      0780
*     GPR15P PTR(31) REG(15);                                      0780
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0781
*     I031F FIXED(31) BASED,                                       0781
*     I031P PTR(31) BASED,                                         0781
*     I015F FIXED(15) BASED,                                       0781
*     I015P PTR(15) BASED,                                         0781
*     I008P PTR(8) BASED,                                          0781
*     I001C CHAR(1) BASED;                                         0781
*   END IECDAFMT                                                   0782
*                                                                  0782
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IEZIOB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*                                                                  0782
*       ;                                                          0782
@DATA    DS    0H
@CH00041 DC    H'1'
@CH00099 DC    H'2'
@CH00315 DC    H'3'
@CH02766 DC    H'30'
@CH00133 DC    H'32'
@CH01689 DC    H'44'
@CH00924 DC    H'48'
@CH02732 DC    H'100'
@CH02958 DC    H'-27'
@SM02961 MVC   ESTAEXEC(0),ESTALIST
@DATD    DSECT
         DS    0F
@SA00005 DS    1F
@SA00004 DS    1F
@SA00002 DS    1F
@SA00003 DS    1F
IECDAFMT CSECT
         DS    0F
@CF00080 DC    F'4'
@CF00086 DC    F'8'
@CH00086 EQU   @CF00086+2
@DATD    DSECT
         DS    0D
DEBDAPTR DS    A
DEBEXPTR DS    A
DEBSBPTR DS    A
SDWAPTR  DS    A
TCBPTR   DS    A
COMPARE  DS    F
COMPC    DS    F
DEBCNTR  DS    F
FIRSTIOB DS    A
LOOPCNTR DS    F
RCCODE   DS    F
NUMLCB   DS    FL1
SIZE     DS    FL1
@TS00001 DS    CL2
SAVEA1   DS    CL72
ERRSW    DS    BL1
         DS    CL3
ESTAPARM DS    CL136
         ORG   ESTAPARM
ESTAERR  DS    BL4
         ORG   ESTAERR
ERREXP   DS    BL1
LOCKHELD EQU   ESTAERR+0
UNEXP2   EQU   ESTAERR+0
@NM00104 EQU   ESTAERR+0
         ORG   ESTAPARM+4
RTYADR   DS    AL4
RTYREGS  DS    CL64
         ORG   RTYREGS
@NM00105 DS    AL4
RTYREG1  DS    AL4
REG2TO12 DS    CL44
@NM00106 DS    CL12
         ORG   ESTAPARM+72
LCALREGS DS    CL64
         ORG   ESTAPARM+136
KEYSAVE  DS    BL1
         DS    CL3
UNPACK   DS    CL5
         ORG   UNPACK
PACKAREA DS    CL4
GARBAGE  DS    CL1
         ORG   UNPACK+5
         DS    CL3
VERIFY   DS    CL8
IECDAFMT CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02685 DC    V(IECDADEB)
@CV02686 DC    V(IECDADCB)
@CV02687 DC    V(IECDAIOB)
         DS    0D
NEGONE   DC    F'-1'
HIGHON   DC    XL1'80'
LOWBIT   DC    XL1'01'
@CB02969 DC    B'0000111111110000'
@CB02971 DC    B'0000001101110000'
@CB02973 DC    B'1111111111110000'
@CB02975 DC    B'0000110001000000'
TRANS    DS    CL256
         ORG   TRANS
@NM00107 DS    CL64
BL       DC    CL1' '
@NM00108 DS    CL175
NUMS     DC    CL16'0123456789ABCDEF'
         ORG   TRANS+256
DCBERR   DC    CL61'*** DCB NOT FORMATTED - DATA NOT AVAILABLE TO ACCESC
               S IT ***'
DEBERR   DC    CL55'*** NOT ALL DEBS ON THE DEB CHAIN COULD BE ACCESSEDC
                ***'
DEBHDR   DC    CL20'FOR DEB AT LOCATION '
DEBUS    DC    CL19'-------------------'
ENDMSG   DC    CL53'DATA MANAGEMENT FORMATTER TERMINATED WITH ABEND CODC
               E '
ICBERR   DC    CL64'*** ICBS NOT FORMATTED - DATA NOT AVAILABLE TO ACCEC
               SS THEM ***'
ICBMSG   DC    CL55'*** NOT ALL ICBS ON THE ICB CHAIN COULD BE ACCESSEDC
                ***'
INCOMP   DC    CL74'*** DATA MANAGEMENT FORMATTING OMITTED, DUMP IS NOTC
                FROM AN MVS SYSTEM ***'
IOBERR   DC    CL64'*** IOBS NOT FORMATTED - DATA NOT AVAILABLE TO ACCEC
               SS THEM ***'
IOBCHN   DC    CL55'*** NOT ALL IOBS ON THE IOB CHAIN COULD BE ACCESSEDC
                ***'
LCBERR   DC    CL64'*** LCBS NOT FORMATTED - DATA NOT AVAILABLE TO ACCEC
               SS THEM ***'
NOINF    DC    CL99'*** DATA MANAGEMENT FORMATTER TERMINATED - PARAMETEC
               R LIST DID NOT CONTAIN NECESSARY INFORMATION ***'
TCBERR   DC    CL72'*** DATA MANAGEMENT FORMATTER TERMINATED - TCB COULC
               D NOT BE ACCESSED ***'
DAPATCH  DC    CL200'PATCH AREA FOR IECDAFMT - IT IS 200 BYTES LONG'
@DATD    DSECT
ESTAEXEC   ESTAE  ESTAERTN,MF=L
IECDAFMT CSECT
ESTALIST   ESTAE  ESTAERTN,MF=L
ESTALEN    DC     A(ESTALEN-ESTALIST)
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IECDAFMT CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SAVEREG1 EQU   @04
PARMSAVE EQU   @08
DATAPTR  EQU   @07
ARRAYCNT EQU   @08
IOBSTPTR EQU   @04
IOBPRPTR EQU   @06
DEBPTR   EQU   @10
DCBPTR   EQU   @09
ABDPLPTR EQU   @01
VADR     EQU   @00
PARMPTR  EQU   @01
KEYREG2  EQU   @02
ICBPTR   EQU   @02
DREG     EQU   @03
TREG6    EQU   @06
TREG2    EQU   @02
R5       EQU   @05
REG13    EQU   @13
RCREG    EQU   @15
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR12F   EQU   @12
GPR00F   EQU   @00
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ABDPL    EQU   0
ADPLTCB  EQU   ABDPL
ADPLSBPL EQU   ABDPL+6
ADPLFLAG EQU   ABDPL+7
ADPLSNPR EQU   ADPLFLAG
ADPLSYTM EQU   ADPLFLAG
ADPLDMGT EQU   ADPLFLAG
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLCVT  EQU   ABDPL+16
ADPLMEMA EQU   ABDPL+20
ADPLCOM1 EQU   ABDPL+28
ADPLCOM2 EQU   ABDPL+32
ADPLCOM3 EQU   ABDPL+36
ADPLCOM4 EQU   ABDPL+40
ADPLFMT1 EQU   ABDPL+44
ADPLFMT2 EQU   ABDPL+48
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IHADCB   EQU   0
IHADCS00 EQU   0
DCBFDAD  EQU   IHADCS00+5
IHADCS01 EQU   0
DCBDVTBL EQU   IHADCS01
IHADCS11 EQU   0
DCBRELB  EQU   IHADCS11
DCBREL   EQU   DCBRELB+1
DCBBUFCB EQU   IHADCS11+4
DCBDSORG EQU   IHADCS11+10
DCBDSRG1 EQU   DCBDSORG
DCBDSRG2 EQU   DCBDSORG+1
DCBIOBAD EQU   IHADCS11+12
DCBODEB  EQU   DCBIOBAD
DCBLNP   EQU   DCBODEB
DCBQSLM  EQU   DCBLNP
DCBIOBAA EQU   DCBODEB+1
IHADCS50 EQU   0
DCBSVCXL EQU   IHADCS50
DCBEODAD EQU   IHADCS50+4
DCBBFALN EQU   DCBEODAD
DCBHIARC EQU   DCBBFALN
DCBBFTEK EQU   DCBHIARC
DCBBFT   EQU   DCBBFTEK
DCBEXLST EQU   IHADCS50+8
DCBRECFM EQU   DCBEXLST
DCBRECLA EQU   DCBRECFM
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS29 EQU   0
DCBOPTCD EQU   IHADCS29
DCBMAC   EQU   IHADCS29+1
DCBSMSI  EQU   IHADCS29+16
DCBMSHI  EQU   IHADCS29+20
DCBEXCD1 EQU   IHADCS29+28
DCBEXCD2 EQU   IHADCS29+29
DCBEXLTH EQU   DCBEXCD2
DCBST    EQU   IHADCS29+108
DCBWKPT1 EQU   IHADCS29+176
IHADCS55 EQU   0
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBNMEXT EQU   DEBUSRPG
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IOBPREFX EQU   0
IOBCFLG1 EQU   IOBPREFX
IOBSTDRD EQU   0
IOBFLAG1 EQU   IOBSTDRD
IOBCYCCK EQU   IOBFLAG1
IOBRSTRT EQU   IOBFLAG1
IOBFLAG2 EQU   IOBSTDRD+1
IOBPURGE EQU   IOBFLAG2
IOBRDHA0 EQU   IOBFLAG2
IOBSENS0 EQU   IOBSTDRD+2
IOBS0B7  EQU   IOBSENS0
IOBSENS1 EQU   IOBSTDRD+3
IOBECBPT EQU   IOBSTDRD+4
IOBFLAG3 EQU   IOBSTDRD+8
IOBFL3   EQU   IOBFLAG3
IOBCNC   EQU   IOBFL3
IOBICL   EQU   IOBFL3
IOBCSW   EQU   IOBSTDRD+9
IOBIOCSW EQU   IOBCSW
IOBSTBYT EQU   IOBIOCSW+3
IOBUSTAT EQU   IOBSTBYT
IOBCSTAT EQU   IOBSTBYT+1
IOBSTART EQU   IOBSTDRD+16
IOBDCBPT EQU   IOBSTDRD+20
IOBFLAG4 EQU   IOBDCBPT
IOBRESTR EQU   IOBSTDRD+24
IOBINCAM EQU   IOBSTDRD+28
IOBBTAMF EQU   IOBINCAM
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWAREQ  EQU   SDWACMPF
SDWACMPC EQU   SDWAABCC+1
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBDEB   EQU   TCB+8
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
ACCESS   EQU   0
PRINT    EQU   0
BUFFER   EQU   0
ADDRESS  EQU   BUFFER+20
DATABYTE EQU   0
DATADWRD EQU   0
DATAWORD EQU   0
DATAADR  EQU   DATAWORD+1
FLGS1    EQU   0
RETRYPT  EQU   0
ICB      EQU   0
ICBNICBA EQU   ICB
TESTBYTE EQU   ICBNICBA
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVTPTR   EQU   ADPLCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
IOBORG01 EQU   IOBPREFX+8
IOBNIOBA EQU   IOBORG01
IOBNFLG1 EQU   IOBNIOBA
IOBPRTOV EQU   IOBNFLG1
IOBORG02 EQU   IOBPREFX+8
IOBDQADA EQU   IOBORG02
IOBDEQIN EQU   IOBDQADA
IOBORG03 EQU   IOBPREFX+12
IOBORG04 EQU   IOBINCAM
IOBORG12 EQU   IOBINCAM
IOBFL4   EQU   IOBORG12
IOBEXTEN EQU   IOBSTDRD+32
IOBSEEK  EQU   IOBEXTEN
IOBBB    EQU   IOBSEEK+1
IOBCC    EQU   IOBSEEK+3
IOBHH    EQU   IOBSEEK+5
IOBORG05 EQU   IOBEXTEN
IOBORG06 EQU   IOBEXTEN
IOBNXTPT EQU   IOBORG06+4
IOBSTATA EQU   IOBNXTPT
IOBORG07 EQU   IOBEXTEN+8
W1IEXTEN EQU   IOBORG07
IOBORG08 EQU   IOBEXTEN+8
IOBINDCT EQU   IOBORG08+4
IOBUNSQR EQU   IOBORG08+5
IOBFCHAD EQU   IOBORG08+8
IOBORG09 EQU   IOBEXTEN+8
IOBDPLAD EQU   IOBORG09+4
IOBDTYPE EQU   IOBORG09+8
IOBDTYP2 EQU   IOBORG09+9
IOBDSTAT EQU   IOBORG09+10
IOBSTAT1 EQU   IOBDSTAT
IOBORG10 EQU   IOBEXTEN+8
IOBSEEK2 EQU   IOBORG10
IOBORG11 EQU   IOBEXTEN
IOBERCT  EQU   IOBORG11
IOBUCBXV EQU   IOBERCT
IOBNAME  EQU   IOBORG11+4
IOBORG13 EQU   IOBEXTEN
IOBSKADR EQU   IOBORG13
PSARSVTE EQU   PSARSVT
ABNDCMPC EQU   SDWACMPC
ABND     EQU   ABNDCMPC
ABNDTYPE EQU   ABND
DCBTYPES EQU   ADPLCOM2
ISAMLOAD EQU   DCBTYPES
ISAMSCAN EQU   DCBTYPES
SAMNMAL  EQU   DCBTYPES
SAMCHAIN EQU   DCBTYPES
BDAMDCB  EQU   DCBTYPES
BTAMDCB  EQU   DCBTYPES
GAMDCB   EQU   DCBTYPES+1
TCAMLINE EQU   DCBTYPES+1
CHAINIOB EQU   DCBTYPES+1
DCBEIOBX EQU   DCBRECFM
DCBIOBA  EQU   DCBSMSI
OFFSET   EQU   ADPLFMT1
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00103 EQU   DCBTYPES+1
TCAMMSGQ EQU   DCBTYPES+1
TCAM3705 EQU   DCBTYPES+1
BISAMDCB EQU   DCBTYPES
EXCPDCB  EQU   DCBTYPES
@NM00099 EQU   ABND
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
IOBSKSS  EQU   IOBSKADR+3
IOBSK0   EQU   IOBSKADR+2
IOBSKTT  EQU   IOBSKADR+1
IOBSKRV  EQU   IOBSKADR
IOBCSWSV EQU   IOBORG11+17
IOBSENSV EQU   IOBORG11+16
IOBRCD   EQU   IOBORG11+12
IOBMDREC EQU   IOBORG11+8
IOBNAMEA EQU   IOBNAME+1
IOBNAMSZ EQU   IOBNAME
IOBERCTA EQU   IOBERCT+1
IOBRTYPE EQU   IOBUCBXV
IOBRDCHP EQU   IOBORG10+20
IOBNEXTA EQU   IOBORG10+16
IOBREADA EQU   IOBORG10+12
IOBBUFC  EQU   IOBORG10+8
IOBSK2R  EQU   IOBSEEK2+7
IOBSK2HH EQU   IOBSEEK2+5
IOBSK2CC EQU   IOBSEEK2+3
IOBSK2BB EQU   IOBSEEK2+1
IOBSK2M  EQU   IOBSEEK2
IOBCHNPR EQU   IOBORG09+40
IOBDNCRF EQU   IOBORG09+32
IOBRSV35 EQU   IOBORG09+24
IOBDQPTR EQU   IOBORG09+20
IOBRSV34 EQU   IOBORG09+18
IOBDBYTN EQU   IOBORG09+16
IOBDCPND EQU   IOBORG09+12
IOBSTAT2 EQU   IOBDSTAT+1
IOBSIORT EQU   IOBSTAT1
IOBADDVU EQU   IOBSTAT1
IOBBUFF  EQU   IOBSTAT1
IOBENQUE EQU   IOBSTAT1
IOBPASS2 EQU   IOBSTAT1
IOBSYNCH EQU   IOBSTAT1
IOBNEWVL EQU   IOBSTAT1
IOBABNRM EQU   IOBSTAT1
IOBRELEX EQU   IOBDTYP2
IOBADDTY EQU   IOBDTYP2
IOBTYPE  EQU   IOBDTYP2
IOBRQUST EQU   IOBDTYP2
IOBSUFFX EQU   IOBDTYP2
IOBSBLKL EQU   IOBDTYP2
IOBSKEY  EQU   IOBDTYP2
IOBRELBL EQU   IOBDTYPE
IOBRDEXC EQU   IOBDTYPE
IOBDYNBF EQU   IOBDTYPE
IOBACTAD EQU   IOBDTYPE
IOBFDBCK EQU   IOBDTYPE
IOBEXTSC EQU   IOBDTYPE
IOBOVFLO EQU   IOBDTYPE
IOBVERFY EQU   IOBDTYPE
IOBDPLB  EQU   IOBDPLAD+1
IOBDAYLI EQU   IOBDPLAD
IOBDIOBS EQU   IOBORG09+2
IOBDBYTR EQU   IOBORG09
IOBBCHAD EQU   IOBORG08+12
IOBFCHNB EQU   IOBFCHAD+1
IOBCOUNT EQU   IOBFCHAD
IOBASYN  EQU   IOBORG08+7
IOBAPP   EQU   IOBORG08+6
IOBRSV32 EQU   IOBUNSQR
IOBRSV31 EQU   IOBUNSQR
IOBRSV30 EQU   IOBUNSQR
IOBKNRWR EQU   IOBUNSQR
IOBKNWR  EQU   IOBUNSQR
IOBNTAV2 EQU   IOBUNSQR
IOBNTAV1 EQU   IOBUNSQR
IOBCPBSY EQU   IOBUNSQR
IOBCHNNL EQU   IOBINDCT
IOBRSV29 EQU   IOBINDCT
IOBRSV28 EQU   IOBINDCT
IOBRSV27 EQU   IOBINDCT
IOBKEYAD EQU   IOBINDCT
IOBOVPTR EQU   IOBINDCT
IOBUNSCH EQU   IOBINDCT
IOBDEQCP EQU   IOBINDCT
IOBCCWAD EQU   IOBORG08
W1OEXTEN EQU   W1IEXTEN
IOBCCW   EQU   IOBORG06+8
IOBNXTPB EQU   IOBNXTPT+1
IOBRSV26 EQU   IOBSTATA
IOBRSV25 EQU   IOBSTATA
IOBRSV24 EQU   IOBSTATA
IOBRSV23 EQU   IOBSTATA
IOBRSV22 EQU   IOBSTATA
IOBRSV21 EQU   IOBSTATA
IOBRSV20 EQU   IOBSTATA
IOBAVLFL EQU   IOBSTATA
IOBRSV37 EQU   IOBORG06+1
IOBUCBXG EQU   IOBORG06
IOBCPA   EQU   IOBORG05+32
IOBERINF EQU   IOBORG05+16
IOBERCCW EQU   IOBORG05+8
IOBSNDPT EQU   IOBORG05+7
IOBRCVPT EQU   IOBORG05+6
IOBWORK  EQU   IOBORG05+1
IOBUCBX  EQU   IOBORG05
IOBR     EQU   IOBSEEK+7
IOBHH2   EQU   IOBHH+1
IOBHH1   EQU   IOBHH
IOBCC2   EQU   IOBCC+1
IOBCC1   EQU   IOBCC
IOBBB2   EQU   IOBBB+1
IOBBB1   EQU   IOBBB
IOBM     EQU   IOBSEEK
IOBRSV46 EQU   IOBFL4
IOBRSV47 EQU   IOBFL4
IOBENT   EQU   IOBFL4
IOBEQP   EQU   IOBFL4
IOBBUS   EQU   IOBFL4
IOBDCK   EQU   IOBFL4
IOBREJ   EQU   IOBFL4
IOBOVR   EQU   IOBFL4
IOBCRILC EQU   IOBORG04+1
IOBCRDCC EQU   IOBORG04
IOBGQECB EQU   IOBORG03
IOBSWAP  EQU   IOBORG02+4
IOBDQADB EQU   IOBDQADA+1
IOBRSV13 EQU   IOBDEQIN
IOBRSV12 EQU   IOBDEQIN
IOBRSV11 EQU   IOBDEQIN
IOBRSV10 EQU   IOBDEQIN
IOBRSV09 EQU   IOBDEQIN
IOBRSV08 EQU   IOBDEQIN
IOBRSV07 EQU   IOBDEQIN
IOBDEQ   EQU   IOBDEQIN
IOBNECB  EQU   IOBORG01+4
IOBNIOBB EQU   IOBNIOBA+1
IOBFIRST EQU   IOBNFLG1
IOBUPERR EQU   IOBNFLG1
IOBSPAN  EQU   IOBNFLG1
IOBBKSPC EQU   IOBNFLG1
IOBUPDAT EQU   IOBNFLG1
IOBREAD  EQU   IOBNFLG1
IOBWRITE EQU   IOBNFLG1
IOBSEGMT EQU   IOBPRTOV
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00102 EQU   DATAWORD
@NM00101 EQU   BUFFER+29
@NM00100 EQU   BUFFER
@NM00098 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00097 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00096 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00095 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
@NM00094 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00093 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00092 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00091 EQU   SDWADDAT+3
@NM00090 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00089 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00088 EQU   SDWADUMP+2
@NM00087 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00086 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00085 EQU   SDWAACF3
@NM00084 EQU   SDWAACF2
@NM00083 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00082 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00081 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWACPUI EQU   SDWA+239
@NM00080 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00079 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00078 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00077 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00076 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00075 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00074 EQU   SDWAINC2
@NM00073 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00072 EQU   SDWAILC2
@NM00071 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00070 EQU   SDWANXT2
@NM00069 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00068 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00067 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00066 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00065 EQU   SDWAINC1
@NM00064 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00063 EQU   SDWAILC1
@NM00062 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00061 EQU   SDWANXT1
@NM00060 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00059 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00058 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00057 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00056 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00055 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00054 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
@NM00053 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00052 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAPARM EQU   SDWA
IOBERRCT EQU   IOBSTDRD+30
IOBRSV19 EQU   IOBINCAM+1
IOBOLTST EQU   IOBBTAMF
IOBRFTMG EQU   IOBBTAMF
IOBRSV17 EQU   IOBBTAMF
IOBRSV16 EQU   IOBBTAMF
IOBRSV15 EQU   IOBBTAMF
IOBRSV14 EQU   IOBBTAMF
IOBINUSE EQU   IOBBTAMF
IOBPRMER EQU   IOBBTAMF
IOBRSTRB EQU   IOBRESTR+1
IOBREPOS EQU   IOBRESTR
IOBDCBPB EQU   IOBDCBPT+1
IOBRSV44 EQU   IOBFLAG4
IOBJES3I EQU   IOBFLAG4
IOBRSV42 EQU   IOBFLAG4
IOBRSV41 EQU   IOBFLAG4
IOBRSV40 EQU   IOBFLAG4
IOBPMERR EQU   IOBFLAG4
IOBCC3WE EQU   IOBFLAG4
IOBGDPOL EQU   IOBFLAG4
IOBSTRTB EQU   IOBSTART+1
IOBSIOCC EQU   IOBSTART
IOBCSB7  EQU   IOBCSTAT
IOBCSB6  EQU   IOBCSTAT
IOBCSB5  EQU   IOBCSTAT
IOBCSB4  EQU   IOBCSTAT
IOBCSB3  EQU   IOBCSTAT
IOBCSB2  EQU   IOBCSTAT
IOBCSB1  EQU   IOBCSTAT
IOBCSB0  EQU   IOBCSTAT
IOBUSB7  EQU   IOBUSTAT
IOBUSB6  EQU   IOBUSTAT
IOBUSB5  EQU   IOBUSTAT
IOBUSB4  EQU   IOBUSTAT
IOBUSB3  EQU   IOBUSTAT
IOBUSB2  EQU   IOBUSTAT
IOBUSB1  EQU   IOBUSTAT
IOBUSB0  EQU   IOBUSTAT
IOBCMDA  EQU   IOBIOCSW
IOBLOG   EQU   IOBFL3
IOBJAM   EQU   IOBICL
IOBMSG   EQU   IOBFL3
IOBSDR   EQU   IOBCNC
IOBACU   EQU   IOBFL3
IOBCDC   EQU   IOBFL3
IOBICC   EQU   IOBFL3
IOBCCC   EQU   IOBFL3
IOBECBPB EQU   IOBECBPT+1
IOBECBCC EQU   IOBECBPT
IOBS1B7  EQU   IOBSENS1
IOBS1B6  EQU   IOBSENS1
IOBS1B5  EQU   IOBSENS1
IOBS1B4  EQU   IOBSENS1
IOBS1B3  EQU   IOBSENS1
IOBS1B2  EQU   IOBSENS1
IOBS1B1  EQU   IOBSENS1
IOBS1B0  EQU   IOBSENS1
IOBSNSC9 EQU   IOBS0B7
IOBS0B6  EQU   IOBSENS0
IOBS0B5  EQU   IOBSENS0
IOBS0B4  EQU   IOBSENS0
IOBS0B3  EQU   IOBSENS0
IOBS0B2  EQU   IOBSENS0
IOBS0B1  EQU   IOBSENS0
IOBS0B0  EQU   IOBSENS0
IOBPNCH  EQU   IOBFLAG2
IOBSTATO EQU   IOBFLAG2
IOBSKUPD EQU   IOBFLAG2
IOBALTTR EQU   IOBFLAG2
IOBRRT2  EQU   IOBRDHA0
IOBRRT3  EQU   IOBPURGE
IOBSENSE EQU   IOBFLAG2
IOBHALT  EQU   IOBFLAG2
IOBSPSVC EQU   IOBRSTRT
IOBUNREL EQU   IOBFLAG1
IOBIOERR EQU   IOBFLAG1
IOBFCREX EQU   IOBCYCCK
IOBRPSTN EQU   IOBFLAG1
IOBERRTN EQU   IOBFLAG1
IOBCMDCH EQU   IOBFLAG1
IOBDATCH EQU   IOBFLAG1
IOBCNOPA EQU   IOBPREFX+12
IOBCICB  EQU   IOBPREFX+8
IOBCECB  EQU   IOBPREFX+4
IOBCONOP EQU   IOBPREFX+3
IOBCINOP EQU   IOBPREFX+2
IOBRSV05 EQU   IOBPREFX+1
IOBPCI   EQU   IOBCFLG1
IOBRSTCH EQU   IOBCFLG1
IOBABAPP EQU   IOBCFLG1
IOBPTST  EQU   IOBCFLG1
IOBRSV04 EQU   IOBCFLG1
IOBRSV03 EQU   IOBCFLG1
IOBRSV02 EQU   IOBCFLG1
IOBRSV01 EQU   IOBCFLG1
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00027 EQU   DEBACS08+12
@NM00026 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00025 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00024 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
DCBLPDT  EQU   IHADCS55
DCBWKPT6 EQU   IHADCS29+196
DCBWKPT5 EQU   IHADCS29+192
DCBWKPT4 EQU   IHADCS29+188
DCBWKPT3 EQU   IHADCS29+184
DCBWKPT2 EQU   IHADCS29+180
@NM00023 EQU   IHADCS29+174
DCBRORG1 EQU   IHADCS29+172
DCBLIOV  EQU   IHADCS29+164
DCBNOREC EQU   IHADCS29+162
@NM00022 EQU   IHADCS29+161
DCBLEMI1 EQU   IHADCS29+156
DCBRORG2 EQU   IHADCS29+154
@NM00021 EQU   IHADCS29+153
DCBLECI  EQU   IHADCS29+148
DCBNBOV  EQU   IHADCS29+146
DCBOVDEV EQU   IHADCS29+145
DCBLETI  EQU   IHADCS29+140
DCBLPDA  EQU   IHADCS29+132
DCBFTHI  EQU   IHADCS29+125
DCBNTHI  EQU   IHADCS29+124
DCBFTMI1 EQU   IHADCS29+117
DCBHIIOV EQU   IHADCS29+116
DCBFTCI  EQU   IHADCS29+109
DCBSTLTF EQU   DCBST
DCBSTLBF EQU   DCBST
DCBSTNMC EQU   DCBST
@NM00020 EQU   DCBST
DCBSTNCY EQU   DCBST
DCBSTLOD EQU   DCBST
DCBSTKSQ EQU   DCBST
DCBSTSSM EQU   DCBST
DCBNREC  EQU   IHADCS29+104
DCBRORG3 EQU   IHADCS29+100
DCBNCRHI EQU   IHADCS29+98
DCBTDC   EQU   IHADCS29+96
DCBHIRSH EQU   IHADCS29+95
DCBHIROV EQU   IHADCS29+94
DCBHIRPD EQU   IHADCS29+93
DCBHIRCM EQU   IHADCS29+92
DCBLDT   EQU   IHADCS29+90
DCBHMASK EQU   IHADCS29+89
DCBFIRSH EQU   IHADCS29+86
DCBNLEV  EQU   IHADCS29+85
DCBLEMI3 EQU   IHADCS29+80
DCBFTMI3 EQU   IHADCS29+73
DCBLEMI2 EQU   IHADCS29+68
DCBFTMI2 EQU   IHADCS29+61
DCBHIRTI EQU   IHADCS29+60
DCBFREED EQU   IHADCS29+56
DCBRELEX EQU   IHADCS29+52
DCBPUTX  EQU   IHADCS29+48
DCBRELSE EQU   IHADCS29+44
DCBLWKN  EQU   IHADCS29+40
DCBLRAN  EQU   IHADCS29+36
DCBESETL EQU   IHADCS29+32
DCBLRECL EQU   IHADCS29+30
@NM00019 EQU   DCBEXCD2
DCBEXRDE EQU   DCBEXLTH
DCBEXOFL EQU   DCBEXCD2
DCBEXCLD EQU   DCBEXCD2
DCBEXDUP EQU   DCBEXCD2
DCBEXSEQ EQU   DCBEXCD2
DCBEXBLU EQU   DCBEXCD1
DCBEXBLI EQU   DCBEXCD1
DCBEXOER EQU   DCBEXCD1
DCBEXIER EQU   DCBEXCD1
DCBEXINV EQU   DCBEXCD1
DCBEXNSP EQU   DCBEXCD1
DCBEXIDA EQU   DCBEXCD1
DCBEXNKY EQU   DCBEXCD1
DCBSETL  EQU   IHADCS29+24
DCBMSHIA EQU   DCBMSHI+1
DCBNCP   EQU   DCBMSHI
DCBSMSW  EQU   IHADCS29+18
DCBMSWA  EQU   IHADCS29+12
DCBBLKSI EQU   IHADCS29+10
DCBRKP   EQU   IHADCS29+8
DCBSYNAD EQU   IHADCS29+4
DCBCYLOF EQU   IHADCS29+3
DCBNTM   EQU   IHADCS29+2
DCBMACRE EQU   DCBMAC
DCBMACAW EQU   DCBMAC
DCBMACUW EQU   DCBMAC
DCBMACUR EQU   DCBMAC
@NM00018 EQU   DCBMAC
DCBOPTR  EQU   DCBOPTCD
DCBOPTL  EQU   DCBOPTCD
@NM00017 EQU   DCBOPTCD
DCBOPTY  EQU   DCBOPTCD
DCBOPTI  EQU   DCBOPTCD
DCBOPTM  EQU   DCBOPTCD
DCBOPTUF EQU   DCBOPTCD
DCBOPTW  EQU   DCBOPTCD
DCBPUTA  EQU   DCBGETA
@NM00016 EQU   DCBPUT
DCBDEBA  EQU   DCBDEBAD+1
@NM00015 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00014 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBRECKL EQU   DCBRECFM
DCBRECCC EQU   DCBRECFM
DCBRECSB EQU   DCBRECFM
DCBRECBR EQU   DCBRECFM
DCBRECTO EQU   DCBRECLA
DCBRECL  EQU   DCBRECLA
DCBEODA  EQU   DCBEODAD+1
DCBBFA   EQU   DCBBFTEK
DCBH0    EQU   DCBBFTEK
DCBBFTKD EQU   DCBBFTEK
DCBBFTE  EQU   DCBBFT
DCBBFTKR EQU   DCBBFT
DCBBFTS  EQU   DCBBFT
DCBH1    EQU   DCBBFTEK
DCBSVCXA EQU   DCBSVCXL+1
@NM00013 EQU   DCBSVCXL
DCBODEBA EQU   DCBIOBAA
@NM00012 EQU   DCBQSLM
DCBUPDBT EQU   DCBQSLM
DCBUPDCM EQU   DCBQSLM
DCB1DVDS EQU   DCBQSLM
@NM00011 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00010 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
@NM00009 EQU   DCBDSRG1
@NM00008 EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGDA EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBDSGIS EQU   DCBDSRG1
DCBBUFL  EQU   IHADCS11+8
DCBBUFCA EQU   DCBBUFCB+1
DCBBUFNO EQU   DCBBUFCB
DCBDEVT  EQU   DCBREL
DCBKEYLE EQU   DCBRELB
DCBTRBAL EQU   IHADCS01+6
@NM00007 EQU   IHADCS01+5
@NM00006 EQU   IHADCS01+4
DCBDVTBA EQU   DCBDVTBL+1
@NM00005 EQU   DCBDVTBL
DCBKEYCN EQU   IHADCS00+4
DCBRELAD EQU   IHADCS00
@NM00004 EQU   IHADCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00003 EQU   CVTFIX+248
@NM00002 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ADPLABDA EQU   ABDPL+56
ADPLEXT  EQU   ABDPL+52
ADPLFRMT EQU   ABDPL+24
@NM00001 EQU   ADPLFLAG
ADPLASID EQU   ABDPL+4
@NM00051 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00050 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00049 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00048 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00047 EQU   FLCFSA
@NM00046 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00045 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00044 EQU   FLCIOA
@NM00043 EQU   FLCMCLA+15
@NM00042 EQU   FLCMCLA+14
@NM00041 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00040 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00039 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00038 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00037 EQU   FLCPER
@NM00036 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00035 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00034 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00033 EQU   FLCPIILC
@NM00032 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00031 EQU   FLCSVILC
@NM00030 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00029 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00028 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00298 EQU   @EL00002
@RC00413 EQU   @RC00408
@RC00500 EQU   @RC00496
@RC00539 EQU   @RC00535
@RC00600 EQU   @RC00596
@RC00612 EQU   @EL00003
@RC00579 EQU   @EL00003
@RC00551 EQU   @EL00003
@RC00518 EQU   @EL00003
@RC00428 EQU   @EL00003
@RC00388 EQU   @EL00003
@RC00365 EQU   @EL00003
@RC00342 EQU   @EL00003
@RC00716 EQU   @EL00006
@RC00300 EQU   @RC00298
@RC00346 EQU   @RC00342
@RC00369 EQU   @RC00365
@RC00392 EQU   @RC00388
@RC00432 EQU   @RC00428
@RC00446 EQU   @RC00428
@RC00522 EQU   @RC00518
@RC00555 EQU   @RC00551
@RC00564 EQU   @RC00551
@RC00583 EQU   @RC00579
@RC00616 EQU   @RC00612
@RC00625 EQU   @RC00612
@RC00634 EQU   @RC00612
@RC00721 EQU   @RC00716
@RC00738 EQU   @RC00716
@RC00317 EQU   @RC00300
@RC00450 EQU   @RC00446
@ENDDATA EQU   *
         END   IECDAFMT,(C'PLS1907',0701,77299)
