         TITLE 'IECDAFT1-DATA MGMT CONTROL BLOCK FORMAT MODULE         *
                        '
IECDAFT1 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'IECDAFT1  77.066'                                 0001
IECDADEB DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00213-IECDADEB)
         ENTRY IECDADEB
IECDADCB DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00284-IECDADCB)
         ENTRY IECDADCB
IECDAIOB DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00626-IECDAIOB)
         ENTRY IECDAIOB
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @11,0                                               0001
@PSTART  LA    @12,4095(,@11)                                      0001
         USING @PSTART,@11                                         0001
         USING @PSTART+4095,@12                                    0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @10,@01                                             0001
         USING @DATD,@10                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @15,@01,16(@13)                                     0001
         ST    @10,8(,@13)                                         0001
         LR    @13,@10                                             0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
*IECDADEB:                                                         0213
*   ENTRY;                                                         0213
*                                                                  0213
@EP00213 DS    0H                                                  0214
*/********************************************************************/
*/* FUNCTION -                                                     0214
*      ROUTINE TO FORMAT THE DEB WITH THE CORRECT PREFIX LENGTH.   0214
*                                                                  0214
*   INPUT -                                                        0214
*      REGISTER 1 MUST POINT TO THE PARMLIST PASSED BY THE CALLER  0214
*      AND THE ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED IS IN  0214
*      ADPLFMT2, THE OFFSET TO BE PLACED ALONG SIDE THE CONTROL    0214
*      BLOCK IS IN ADPLFMT1 ALSO DEFINED AS START, AND ADPLCOM4    0214
*      CONTAINS THE ADDRESS OF THE ESTAE PARAMETER LIST.           0214
*                                                                  0214
*   CALLS -                                                        0214
*      ACCESRTN, CONVERT, FMTRTN, AND PRINT                        0214
*                                                                  0214
*   CALLED BY -                                                    0214
*      IECDAFMT TO FORMAT THE DEB                                  0214
*                                                                  0214
*   RETURNS TO -                                                   0214
*      CALLER WITH RETURN CODE SET BY THE ACCESS OR FORMAT SERVICE 0214
*      ROUTINES                                                    0214
*                                                                    */
*/********************************************************************/
*                                                                  0214
*   ESTAPTR=ADPLCOM4;               /* SAVE ESTAE PARM LIST ADDR     */
         L     ESTAPTR,ADPLCOM4(,ABDPLPTR)                         0214
*   STM(LINEPTR,RCREG,LCALREGS);    /* SAVE REGS FOR EXPECTED RETRY  */
         STM   LINEPTR,RCREG,LCALREGS(ESTAPTR)                     0215
*   DEBPTR=ADPLFMT2;                /* DEB PTR PASSED IN PARM LIST   */
         L     DEBPTR,ADPLFMT2(,ABDPLPTR)                          0216
*   SAVEPTR=DEBPTR-START;           /* ADDRESS TO GENERATE OFFSETS 0217
*                                      FROM                          */
         LR    @07,DEBPTR                                          0217
         SL    @07,START(,ABDPLPTR)                                0217
         ST    @07,SAVEPTR                                         0217
*   ADPLCOM1=ADDR(DEBMSG);          /* FORMAT ERROR MESSAGE          */
         LA    @07,DEBMSG                                          0218
         ST    @07,ADPLCOM1(,ABDPLPTR)                             0218
*   ERRSW=OFF;                      /* INITIALIZE ERROR INDICATOR    */
         NI    ERRSW,B'01111111'                                   0219
*   RFY                                                            0220
*     DEB BASED(PREFXPTR);          /* REBASE THE DEB PREFIX         */
*                                                                  0220
*   /*****************************************************************/
*   /*                                                               */
*   /* PUT OUT THE DEB HEADER                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0221
*   BUFFER(1:LENGTH(DEBHDR))=DEBHDR;/* HEADER LINE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0221
         MVC   BUFFER(54,@07),DEBHDR                               0221
*   PACKAREA=DEBPTR;                /* MOVE PTR INTO CHAR AREA FOR 0222
*                                      THE UNPK                      */
         ST    DEBPTR,PACKAREA                                     0222
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0223
*   UNPK(ADDRESS,UNPACK);           /* MOVE INTO BUFFER LINE         */
         UNPK  ADDRESS(9,@07),UNPACK(5)                            0224
*   TR(ADDRESS,TRANS);              /* TRANSLATE TO PRINTABLE HEX    */
         TR    ADDRESS(9,@07),TRANS                                0225
*   CALL PRINT;                     /* PRINT THE HEADER LINE         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0226
         BALR  @14,@15                                             0226
*   BUFFER(1:LENGTH(UNDER))=UNDER;  /* UNDER SCORE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0227
         MVC   BUFFER(5,@07),UNDER                                 0227
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0228
         BALR  @14,@15                                             0228
*   CALL PRINT;                     /* BLANK LINE                    */
*                                                                  0229
         L     @15,ADPLPRNT(,ABDPLPTR)                             0229
         BALR  @14,@15                                             0229
*   /*****************************************************************/
*   /*                                                               */
*   /* FIND CORRECT DEB PREFIX AND THE DEB LENGTH                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0230
*   PREFXPTR=DEBPTR-LONGPREF;       /* PTR TO LONG PREFIX            */
         LA    @07,36                                              0230
         LR    @05,DEBPTR                                          0230
         SLR   @05,@07                                             0230
         ST    @05,PREFXPTR                                        0230
*   PREFIX=LONGPREF;                /* SAVE PREFIX LENGTH            */
         ST    @07,PREFIX                                          0231
*   VADR=ADDR(DEBLNGTH);            /* DEB LENGTH IN DOUBLE WORDS    */
         LA    VADR,DEBLNGTH(,@05)                                 0232
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0233
*   IF RCREG^=ZERO THEN             /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0234
         BZ    @RF00234                                            0234
*     BUFFER(1:LENGTH(DEBMSG))=DEBMSG;/* ERROR MSG                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0235
         MVC   BUFFER(120,@07),DEBMSG                              0235
*   ELSE                            /* FOUND DEB LENGTH              */
*     DO;                                                          0236
         B     @RC00234                                            0236
@RF00234 DS    0H                                                  0237
*       DEBSIZE=(DATABYTE*8);       /* LENGTH OF DEB IN BYTES        */
         L     @07,DATAPTR                                         0237
         SLR   @05,@05                                             0237
         IC    @05,DATABYTE(,@07)                                  0237
         SLA   @05,3                                               0237
         STH   @05,DEBSIZE                                         0237
*       IF DEBPTR=((DEBPTR/8)*8) THEN/* DEB DOES NOT HAVE FULL PREFIX*/
         LR    @07,DEBPTR                                          0238
         SRL   @07,3                                               0238
         SLA   @07,3                                               0238
         CR    DEBPTR,@07                                          0238
         BNE   @RF00238                                            0238
*         PREFIX=SHORTPRF;          /* SAVE LENGTH OF SHORT PREFIX   */
         MVC   PREFIX(4),@CF00082                                  0239
*       ELSE                                                       0240
*         ;                         /* NOT THE SHORT PREFIX          */
@RF00238 DS    0H                                                  0241
*       VADR=ADDR(DEBAMTYP);        /* ACCESS METHOD TYPE            */
         L     @07,PREFXPTR                                        0241
         LA    VADR,DEBAMTYP(,@07)                                 0241
*       CALL ACCESRTN;              /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0242
*       IF RCREG^=ZERO THEN         /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0243
         BZ    @RF00243                                            0243
*         BUFFER(1:LENGTH(DEBMSG))=DEBMSG;/* ERROR MSG               */
         L     @07,ADPLBUF(,ABDPLPTR)                              0244
         MVC   BUFFER(120,@07),DEBMSG                              0244
*       ELSE                        /* FOUND ACCESS METHOD TYPE      */
*         DO;                                                      0245
         B     @RC00243                                            0245
@RF00243 DS    0H                                                  0246
*           IF DATABYTE=HASPTYPE THEN/* IS IT A HASP DEB             */
         L     @07,DATAPTR                                         0246
         CLC   DATABYTE(1,@07),HASPTYPE                            0246
         BNE   @RF00246                                            0246
*             PREFIX=HASPPREF;      /* LENGTH OF HASP PREFIX         */
         MVC   PREFIX(4),@CF00070                                  0247
*           ELSE                                                   0248
*             ;                     /* NOT A HASP DEB                */
@RF00246 DS    0H                                                  0249
*           ADPLFMT2=DEBPTR-PREFIX; /* FORMAT STARTING AT THE PREFIX */
         L     @07,PREFIX                                          0249
         LR    @05,DEBPTR                                          0249
         SLR   @05,@07                                             0249
         ST    @05,ADPLFMT2(,ABDPLPTR)                             0249
*           ENDPTR=ADPLFMT2+DEBSIZE;/* ADDRESS OF END OF THE DEB     */
         AH    @05,DEBSIZE                                         0250
         ST    @05,ENDPTR                                          0250
*           IF PREFIX=LONGPREF THEN /* FORMAT THE DEB PREFIX AND   0251
*                                      COMMON SECTION FOR THE NORMAL
*                                      PREFIX                        */
         CH    @07,@CH01703                                        0251
         BNE   @RF00251                                            0251
*             DO ARRAYCNT=1 TO DIM(NORMLDEB) WHILE(ERRSW=OFF);     0252
         LA    ARRAYCNT,1                                          0252
@DL00252 TM    ERRSW,B'10000000'                                   0252
         BNZ   @DC00252                                            0252
*               LINEPTR=NORMLDEB(ARRAYCNT);/* FORMAT PATTERN ADDR    */
         LR    @07,ARRAYCNT                                        0253
         SLA   @07,2                                               0253
         L     LINEPTR,NORMLDEB-4(@07)                             0253
*               CALL CONVERT;       /* GENERATE THE OFFSET           */
         BAL   @14,CONVERT                                         0254
*               CALL FMTRTN;        /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0255
*             END;                  /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0256
         CH    ARRAYCNT,@CH00068                                   0256
         BNH   @DL00252                                            0256
@DC00252 DS    0H                                                  0257
*           ELSE                    /* NOT THE NORMAL PREFIX         */
*             IF PREFIX=SHORTPRF THEN/* FORMAT THE DEB PREFIX AND  0257
*                                      COMMON SECTION FOR THE SHORT
*                                      PREFIX                        */
         B     @RC00251                                            0257
@RF00251 CLC   PREFIX(4),@CF00082                                  0257
         BNE   @RF00257                                            0257
*               DO ARRAYCNT=1 TO DIM(SHORTDEB) WHILE(ERRSW=OFF);   0258
         LA    ARRAYCNT,1                                          0258
@DL00258 TM    ERRSW,B'10000000'                                   0258
         BNZ   @DC00258                                            0258
*                 LINEPTR=SHORTDEB(ARRAYCNT);/* FORMAT PATTERN ADDR  */
         LR    @07,ARRAYCNT                                        0259
         SLA   @07,2                                               0259
         L     LINEPTR,SHORTDEB-4(@07)                             0259
*                 CALL CONVERT;     /* GENERATE THE OFFSET           */
         BAL   @14,CONVERT                                         0260
*                 CALL FMTRTN;      /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0261
*               END;                /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0262
         CH    ARRAYCNT,@CH00130                                   0262
         BNH   @DL00258                                            0262
@DC00258 DS    0H                                                  0263
*             ELSE                  /* NOT THE SHORT PREFIX          */
*               DO ARRAYCNT=1 TO DIM(HASPDEB) WHILE(ERRSW=OFF);    0263
         B     @RC00257                                            0263
@RF00257 LA    ARRAYCNT,1                                          0263
@DL00263 TM    ERRSW,B'10000000'                                   0263
         BNZ   @DC00263                                            0263
*                 LINEPTR=HASPDEB(ARRAYCNT);/* FORMAT PATTERN ADDR   */
         LR    @07,ARRAYCNT                                        0264
         SLA   @07,2                                               0264
         L     LINEPTR,HASPDEB-4(@07)                              0264
*                 CALL CONVERT;     /* GENERATE THE OFFSET           */
         BAL   @14,CONVERT                                         0265
*                 CALL FMTRTN;      /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0266
*               END;                /* END FORMAT LOOP               */
*                                                                  0267
         AH    ARRAYCNT,@CH00041                                   0267
         CH    ARRAYCNT,@CH00130                                   0267
         BNH   @DL00263                                            0267
@DC00263 DS    0H                                                  0268
*           /*********************************************************/
*           /*                                                       */
*           /* IF THE PREFIX AND BASIC SECTION WERE FORMATTED WITHOUT*/
*           /* PROBLEM, THE REST OF THE DEB WILL BE FORMATTED        */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0268
*           DO WHILE((ADPLFMT2<ENDPTR)&(ERRSW=OFF));               0268
@RC00257 DS    0H                                                  0268
@RC00251 B     @DE00268                                            0268
@DL00268 DS    0H                                                  0269
*             IF ADPLFMT2+FOURWORD<=ENDPTR THEN/* THE OUTPUT LINE CAN
*                                      BE 4 WORDS LONG               */
         LA    @07,16                                              0269
         AL    @07,ADPLFMT2(,ABDPLPTR)                             0269
         C     @07,ENDPTR                                          0269
         BH    @RF00269                                            0269
*               LINEPTR=ADDR(DEBDAT4);/* FORMAT PATTERN FOR 4 WORDS
*                                      OF DATA                       */
         LA    LINEPTR,DEBDAT4                                     0270
*             ELSE                  /* THE REMAINDER OF DEB IS LESS
*                                      THAN 4 WORDS                  */
*               IF ADPLFMT2+THREWORD<=ENDPTR THEN/* THE OUTPUT LINE
*                                      CAN BE 3 WORDS LONG           */
         B     @RC00269                                            0271
@RF00269 LA    @07,12                                              0271
         AL    @07,ADPLFMT2(,ABDPLPTR)                             0271
         C     @07,ENDPTR                                          0271
         BH    @RF00271                                            0271
*                 LINEPTR=ADDR(DEBDAT3);/* FORMAT PATTERN FOR 3 WORDS
*                                      OF DATA                       */
         LA    LINEPTR,DEBDAT3                                     0272
*               ELSE                /* THE REMAINDER OF DEB IS LESS
*                                      THAN 3 WORDS                  */
*                 IF ADPLFMT2+TWOWORD<=ENDPTR THEN/* THE OUTPUT LINE
*                                      CAN BE 2 WORDS LONG           */
         B     @RC00271                                            0273
@RF00271 LA    @07,8                                               0273
         AL    @07,ADPLFMT2(,ABDPLPTR)                             0273
         C     @07,ENDPTR                                          0273
         BH    @RF00273                                            0273
*                   LINEPTR=ADDR(DEBDAT2);/* FORMAT PATTERN FOR 2  0274
*                                      WORDS OF DATA                 */
         LA    LINEPTR,DEBDAT2                                     0274
*                 ELSE              /* THE REMAINDER OF DEB IS LESS
*                                      THAN 2 WORDS                  */
*                   LINEPTR=ADDR(DEBDAT1);/* FORMAT PATTERN FOR 1  0275
*                                      WORD OF DATA                  */
         B     @RC00273                                            0275
@RF00273 LA    LINEPTR,DEBDAT1                                     0275
*             CALL CONVERT;         /* GENERATE OFFSET               */
@RC00273 DS    0H                                                  0276
@RC00271 DS    0H                                                  0276
@RC00269 BAL   @14,CONVERT                                         0276
*             CALL FMTRTN;          /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0277
*           END;                    /* END FORMAT LOOP               */
@DE00268 CLC   ADPLFMT2(4,ABDPLPTR),ENDPTR                         0278
         BNL   @DC00268                                            0278
         TM    ERRSW,B'10000000'                                   0278
         BZ    @DL00268                                            0278
@DC00268 DS    0H                                                  0279
*         END;                      /* END FOUND ACCESS METHOD       */
*     END;                          /* END FOUND DEB SIZE            */
@RC00243 DS    0H                                                  0281
*   CALL PRINT;                     /* ERROR MESSAGE OR BLANK        */
@RC00234 L     @15,ADPLPRNT(,ABDPLPTR)                             0281
         BALR  @14,@15                                             0281
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS RETRY REGS    */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0282
*   RETURN CODE(RCCODE);            /* RETURN THE RETURN CODE SAVED
*                                      BY THE ACCESS OR FORMAT     0283
*                                      SERVICE ROUTINE               */
         L     @13,4(,@13)                                         0283
         L     @00,@SIZDATD                                        0283
         LR    @01,@10                                             0283
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@09                                             0283
         L     @14,12(,@13)                                        0283
         LM    @00,@12,20(@13)                                     0283
         BR    @14                                                 0283
*IECDADCB:                                                         0284
*   ENTRY;                                                         0284
*                                                                  0284
@EP00284 DS    0H                                                  0285
*/********************************************************************/
*/* FUNCTION -                                                     0285
*      ROUTINE TO FORMAT THE DCB ACCORDING TO THE ACCESS METHOD TYPE
*      AND SEND THE TYPE BACK IN THE PARAMETER LIST PASSED BY THE CALLE
*                                                                  0285
*   INPUT -                                                        0285
*      REGISTER 1 MUST POINT TO THE PARMLIST PASSED BY THE CALLER  0285
*      AND THE ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED IS IN  0285
*      ADPLFMT2, THE OFFSET TO BE PLACED ALONG SIDE THE CONTROL    0285
*      BLOCK IS IN ADPLFMT1 ALSO DEFINED AS START, AND ADPLCOM4 CONTAIN
*      THE ADDRESS OF THE ESTAE PARAMETER LIST.                    0285
*                                                                  0285
*   OUTPUT-                                                        0285
*      PASSES BACK THE ACCESS METHOD TYPE IN ADPLCOM2 AND A RETURN 0285
*      CODE IN REGISTER 15 INDICATING WHETHER TO FORMAT THE ASSOCIATED
*      IOBS. RETURN CODE 4 INDICATES NO IOB.                       0285
*                                                                  0285
*   CALLS -                                                        0285
*      ACCESRTN, CONVERT, FMTRTN, AND PRINT                        0285
*                                                                  0285
*   CALLED BY -                                                    0285
*      IECDAFMT TO FORMAT THE DCB                                  0285
*                                                                  0285
*   RETURNS TO -                                                   0285
*      CALLER WITH RETURN CODE SET BY THE ACCESS OR FORMAT SERVICE 0285
*      ROUTINES,OR IF THE IOBS ARE NOT TO BE FORMATTED             0285
*                                                                    */
*/********************************************************************/
*                                                                  0285
*   DCBTYPES=ZERO;                  /* INITIALIZE THE ACCESS METHOD
*                                      TYPE FIELD                    */
         SLR   @06,@06                                             0285
         ST    @06,DCBTYPES(,ABDPLPTR)                             0285
*   ESTAPTR=ADPLCOM4;               /* SAVE ESTAE PARM LIST ADDR     */
         L     ESTAPTR,ADPLCOM4(,ABDPLPTR)                         0286
*   STM(LINEPTR,RCREG,LCALREGS);    /* SAVE REGS FOR EXPECTED RETRY  */
         STM   LINEPTR,RCREG,LCALREGS(ESTAPTR)                     0287
*   DCBPTR=ADPLFMT2;                /* POINTER TO DCB PASSED IN    0288
*                                      CONTROL BLOCK                 */
         L     DCBPTR,ADPLFMT2(,ABDPLPTR)                          0288
*   SAVEPTR=DCBPTR-START;           /* OFFSET OF FIRST FIELD         */
         LR    @06,DCBPTR                                          0289
         SL    @06,START(,ABDPLPTR)                                0289
         ST    @06,SAVEPTR                                         0289
*   ADPLCOM1=ADDR(DCBMSG);          /* FORMAT ERROR MESSAGE          */
         LA    @06,DCBMSG                                          0290
         ST    @06,ADPLCOM1(,ABDPLPTR)                             0290
*   ERRSW=OFF;                      /* INITIALIZE ERROR SWITCH       */
*                                                                  0291
         NI    ERRSW,B'01111111'                                   0291
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE MACRF BITS TO DETERMINE IF THE ACCESS METHOD IS EXCP  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0292
*   VADR=ADDR(DCBMACRF);            /* MACREF BITS                   */
         LA    VADR,DCBMACRF+40(,DCBPTR)                           0292
*   CALL ACCESRTN;                  /* ACCESS THEM                   */
         BAL   @14,ACCESRTN                                        0293
*   IF RCREG^=ZERO THEN             /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0294
         BZ    @RF00294                                            0294
*     BUFFER(1:LENGTH(NOACCESS))=NOACCESS;                         0295
         L     @07,ADPLBUF(,ABDPLPTR)                              0295
         MVC   BUFFER(70,@07),NOACCESS                             0295
*   ELSE                            /* FOUND MACREF BITS             */
*     DO;                                                          0296
         B     @RC00294                                            0296
@RF00294 DS    0H                                                  0297
*       MACFBITS=DATAHALF;          /* SAVE MACREF BITS              */
         L     @06,DATAPTR                                         0297
         MVC   MACFBITS(2),DATAHALF(@06)                           0297
*       IF MFECP=ON THEN                                           0298
         TM    MFECP,B'10000000'                                   0298
         BNO   @RF00298                                            0298
*         DO;                       /* EXCP METHOD                   */
*                                                                  0299
*           /*********************************************************/
*           /*                                                       */
*           /* THE ACCESS METHOD IS EXCP                             */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0300
*           BUFFER(1:LENGTH(DCBHDR))=DCBHDR;/* HEADER LINE           */
         L     @06,ADPLBUF(,ABDPLPTR)                              0300
         MVC   BUFFER(55,@06),DCBHDR                               0300
*           PACKAREA=DCBPTR;        /* MOVE ADDR INTO CHARACTER AREA */
         ST    DCBPTR,PACKAREA                                     0301
*           GARBAGE='04'X;          /* GARBAGE BYTE FOR THE UNPACK   */
         MVI   GARBAGE,X'04'                                       0302
*           UNPK(ADDRESS,UNPACK);   /* MOVE INTO BUFFER              */
         UNPK  ADDRESS(9,@06),UNPACK(5)                            0303
*           TR(ADDRESS,TRANS);      /* MAKE PRINTABLE                */
         TR    ADDRESS(9,@06),TRANS                                0304
*           IF MFFE=OFF THEN        /* DOES NOT HAVE FOUNDATION    0305
*                                      EXTENSION                     */
*                                                                  0305
         TM    MFFE,B'01000000'                                    0305
         BNZ   @RF00305                                            0305
*             /*******************************************************/
*             /*                                                     */
*             /* BASIC EXCP -ONLY 3 WORDS                            */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0306
*             DO;                   /* FORMAT DCB-EXCP TYPE          */
*               ADPLFMT2=ADDR(DCBTIOT);/* WHERE TO START FORMATTING  */
         LA    @05,40                                              0307
         ALR   @05,DCBPTR                                          0307
         ST    @05,ADPLFMT2(,ABDPLPTR)                             0307
*               HDRTYPE(1:LENGTH(EXCP))=EXCP;/* FILL IN TYPE         */
         MVC   HDRTYPE(6,@06),EXCP                                 0308
*               CALL PRINT;         /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0309
         BALR  @14,@15                                             0309
*               BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0310
         MVC   BUFFER(5,@07),UNDER                                 0310
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0311
         BALR  @14,@15                                             0311
*               CALL PRINT;         /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0312
         BALR  @14,@15                                             0312
*               DO ARRAYCNT=1 TO DIM(EXCPARY) WHILE(ERRSW=OFF);    0313
         LA    ARRAYCNT,1                                          0313
@DL00313 TM    ERRSW,B'10000000'                                   0313
         BNZ   @DC00313                                            0313
*                 LINEPTR=EXCPARY(ARRAYCNT);/* FORMAT PATTERN ADDR   */
         LR    @07,ARRAYCNT                                        0314
         SLA   @07,2                                               0314
         L     LINEPTR,EXCPARY-4(@07)                              0314
*                 CALL CONVERT;     /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0315
*                 CALL FMTRTN;      /* FORMAT                        */
         BAL   @14,FMTRTN                                          0316
*               END;                /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0317
         CH    ARRAYCNT,@CH00041                                   0317
         BNH   @DL00313                                            0317
@DC00313 DS    0H                                                  0318
*             END;                  /* END EXCP TYPE                 */
*           ELSE                    /* NOT MINIMAL EXCP-HAS        0319
*                                      FOUNDATION EXTENSION          */
*             IF MFCI=OFF THEN      /* EXCP WITH FOUNDATION          */
         B     @RC00305                                            0319
@RF00305 TM    MFCI,B'00010000'                                    0319
         BNZ   @RF00319                                            0319
*               DO;                                                0320
*                                                                  0320
*                 /***************************************************/
*                 /*                                                 */
*                 /* EXCP WITH FOUNDATION EXTENSION                  */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0321
*                 ADPLFMT2=ADDR(DCBEODAD);/* WHERE TO START        0321
*                                      FORMATTING                    */
         LA    @06,DCBEODAD+28(,DCBPTR)                            0321
         ST    @06,ADPLFMT2(,ABDPLPTR)                             0321
*                 HDRTYPE(1:LENGTH(EXCPFE))=EXCPFE;/* FILL IN TYPE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0322
         MVC   HDRTYPE(29,@07),EXCPFE                              0322
*                 CALL PRINT;       /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0323
         BALR  @14,@15                                             0323
*                 BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE       */
         L     @07,ADPLBUF(,ABDPLPTR)                              0324
         MVC   BUFFER(5,@07),UNDER                                 0324
*                 CALL PRINT;       /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0325
         BALR  @14,@15                                             0325
*                 CALL PRINT;       /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0326
         BALR  @14,@15                                             0326
*                 DO ARRAYCNT=1 TO DIM(EXFEARY) WHILE(ERRSW=OFF);  0327
         LA    ARRAYCNT,1                                          0327
@DL00327 TM    ERRSW,B'10000000'                                   0327
         BNZ   @DC00327                                            0327
*                   LINEPTR=EXFEARY(ARRAYCNT);/* FORMAT PATTERN ADDR */
         LR    @07,ARRAYCNT                                        0328
         SLA   @07,2                                               0328
         L     LINEPTR,EXFEARY-4(@07)                              0328
*                   CALL CONVERT;   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0329
*                   CALL FMTRTN;    /* FORMAT                        */
         BAL   @14,FMTRTN                                          0330
*                 END;              /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0331
         CH    ARRAYCNT,@CH00041                                   0331
         BNH   @DL00327                                            0331
@DC00327 DS    0H                                                  0332
*               END;                /* END EXCP WITH FOUNDATION    0332
*                                      ENTENSION                     */
*             ELSE                  /* HAS APPENDAGES                */
*                                                                  0333
*               /*****************************************************/
*               /*                                                   */
*               /* EXCP HAS COMMON INTERFACE                         */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0333
*               DO;                                                0333
         B     @RC00319                                            0333
@RF00319 DS    0H                                                  0334
*                 IF MF5WD=ON THEN  /* 5 WORD DEVICE INTERFACE       */
*                                                                  0334
         TM    MF5WD,B'00001000'                                   0334
         BNO   @RF00334                                            0334
*                   /*************************************************/
*                   /*                                               */
*                   /* EXCP WITH 5 WORD DEVICE INTERFACE             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0335
*                   DO;                                            0335
*                     ADPLFMT2=DCBPTR;/* FORMAT ENTIRE DCB           */
         ST    DCBPTR,ADPLFMT2(,ABDPLPTR)                          0336
*                     HDRTYPE(1:LENGTH(EXCP5))=EXCP5;/* FILL IN TYPE */
         L     @07,ADPLBUF(,ABDPLPTR)                              0337
         MVC   HDRTYPE(32,@07),EXCP5                               0337
*                     CALL PRINT;   /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0338
         BALR  @14,@15                                             0338
*                     BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0339
         MVC   BUFFER(5,@07),UNDER                                 0339
*                     CALL PRINT;   /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0340
         BALR  @14,@15                                             0340
*                     CALL PRINT;   /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0341
         BALR  @14,@15                                             0341
*                     DO ARRAYCNT=1 TO DIM(EXCP5ARY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0342
@DL00342 TM    ERRSW,B'10000000'                                   0342
         BNZ   @DC00342                                            0342
*                       LINEPTR=EXCP5ARY(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0343
         SLA   @07,2                                               0343
         L     LINEPTR,EXCP5ARY-4(@07)                             0343
*                       CALL CONVERT;/* GENERATE OFFSET              */
         BAL   @14,CONVERT                                         0344
*                       CALL FMTRTN;/* FORMAT                        */
         BAL   @14,FMTRTN                                          0345
*                     END;          /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0346
         CH    ARRAYCNT,@CH00130                                   0346
         BNH   @DL00342                                            0346
@DC00342 DS    0H                                                  0347
*                   END;            /* END 5 WORD INTERFACE          */
*                 ELSE              /* NOT 5 WORD INTERFACE          */
*                   IF MF4WD=ON THEN/* 4 WORD DEVICE INTERFACE       */
*                                                                  0348
         B     @RC00334                                            0348
@RF00334 TM    MF4WD,B'00000100'                                   0348
         BNO   @RF00348                                            0348
*                     /***********************************************/
*                     /*                                             */
*                     /* EXCP WITH 4 WORD DEVICE INTERFACE           */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0349
*                     DO;                                          0349
*                       ADPLFMT2=DCBPTR+4;/* WHERE TO START        0350
*                                      FORMATTING                    */
         LA    @06,4                                               0350
         ALR   @06,DCBPTR                                          0350
         ST    @06,ADPLFMT2(,ABDPLPTR)                             0350
*                       HDRTYPE(1:LENGTH(EXCP4))=EXCP4;/* FILL IN  0351
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0351
         MVC   HDRTYPE(32,@07),EXCP4                               0351
*                       CALL PRINT; /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0352
         BALR  @14,@15                                             0352
*                       BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE */
         L     @07,ADPLBUF(,ABDPLPTR)                              0353
         MVC   BUFFER(5,@07),UNDER                                 0353
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0354
         BALR  @14,@15                                             0354
*                       CALL PRINT; /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0355
         BALR  @14,@15                                             0355
*                       DO ARRAYCNT=1 TO DIM(EXCP4ARY) WHILE(ERRSW=OFF)
*                             ;                                    0356
         LA    ARRAYCNT,1                                          0356
@DL00356 TM    ERRSW,B'10000000'                                   0356
         BNZ   @DC00356                                            0356
*                         LINEPTR=EXCP4ARY(ARRAYCNT);/* FORMAT     0357
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0357
         SLA   @07,2                                               0357
         L     LINEPTR,EXCP4ARY-4(@07)                             0357
*                         CALL CONVERT;/* GENERATE OFFSET            */
         BAL   @14,CONVERT                                         0358
*                         CALL FMTRTN;/* FORMAT                      */
         BAL   @14,FMTRTN                                          0359
*                       END;        /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0360
         CH    ARRAYCNT,@CH00130                                   0360
         BNH   @DL00356                                            0360
@DC00356 DS    0H                                                  0361
*                     END;          /* END 4 WORD INTERFACE          */
*                   ELSE            /* NOT 4 WORD INTERFACE          */
*                     IF MF3WD=ON THEN/* 3 WORD DEVICE INTERFACE     */
*                                                                  0362
         B     @RC00348                                            0362
@RF00348 TM    MF3WD,B'00000010'                                   0362
         BNO   @RF00362                                            0362
*                       /*********************************************/
*                       /*                                           */
*                       /* EXCP WITH 3 WORD DEVICE INTERFACE         */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0363
*                       DO;                                        0363
*                         ADPLFMT2=DCBPTR+8;/* WHERE TO START      0364
*                                      FORMATTING                    */
         LA    @06,8                                               0364
         ALR   @06,DCBPTR                                          0364
         ST    @06,ADPLFMT2(,ABDPLPTR)                             0364
*                         HDRTYPE(1:LENGTH(EXCP3))=EXCP3;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0365
         MVC   HDRTYPE(32,@07),EXCP3                               0365
*                         CALL PRINT;/* PRINT HEADER                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0366
         BALR  @14,@15                                             0366
*                         BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER   0367
*                                      SCORE                         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0367
         MVC   BUFFER(5,@07),UNDER                                 0367
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0368
         BALR  @14,@15                                             0368
*                         CALL PRINT;/* BLANK LINE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0369
         BALR  @14,@15                                             0369
*                         DO ARRAYCNT=1 TO DIM(EXCP3ARY) WHILE(ERRSW=
*                               OFF);                              0370
         LA    ARRAYCNT,1                                          0370
@DL00370 TM    ERRSW,B'10000000'                                   0370
         BNZ   @DC00370                                            0370
*                           LINEPTR=EXCP3ARY(ARRAYCNT);/* FORMAT   0371
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0371
         SLA   @07,2                                               0371
         L     LINEPTR,EXCP3ARY-4(@07)                             0371
*                           CALL CONVERT;/* GENERATE OFFSET          */
         BAL   @14,CONVERT                                         0372
*                           CALL FMTRTN;/* FORMAT                    */
         BAL   @14,FMTRTN                                          0373
*                         END;      /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0374
         CH    ARRAYCNT,@CH00130                                   0374
         BNH   @DL00370                                            0374
@DC00370 DS    0H                                                  0375
*                       END;        /* END 3 WORD INTERFACE          */
*                     ELSE          /* NOT 3 WORD INTERFACE          */
*                       IF MF1WD=ON THEN/* 1 WORD DEVICE INTERFACE   */
*                                                                  0376
         B     @RC00362                                            0376
@RF00362 TM    MF1WD,B'00000001'                                   0376
         BNO   @RF00376                                            0376
*                         /*******************************************/
*                         /*                                         */
*                         /* EXCP WITH 1 WORD DEVICE INTERFACE       */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0377
*                         DO;                                      0377
*                           ADPLFMT2=ADDR(DCBRELB);/* WHERE TO START
*                                      FORMATTING                    */
         LA    @06,16                                              0378
         ALR   @06,DCBPTR                                          0378
         ST    @06,ADPLFMT2(,ABDPLPTR)                             0378
*                           HDRTYPE(1:LENGTH(EXCP1))=EXCP1;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0379
         MVC   HDRTYPE(32,@07),EXCP1                               0379
*                           CALL PRINT;/* PRINT HEADER               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0380
         BALR  @14,@15                                             0380
*                           BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER 0381
*                                      SCORE                         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0381
         MVC   BUFFER(5,@07),UNDER                                 0381
*                           CALL PRINT;/* PRINT IT                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0382
         BALR  @14,@15                                             0382
*                           CALL PRINT;/* BLANK LINE                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0383
         BALR  @14,@15                                             0383
*                           DO ARRAYCNT=1 TO DIM(EXCP1ARY) WHILE(ERRSW=
*                                 OFF);                            0384
         LA    ARRAYCNT,1                                          0384
@DL00384 TM    ERRSW,B'10000000'                                   0384
         BNZ   @DC00384                                            0384
*                             LINEPTR=EXCP1ARY(ARRAYCNT);/* FORMAT 0385
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0385
         SLA   @07,2                                               0385
         L     LINEPTR,EXCP1ARY-4(@07)                             0385
*                             CALL CONVERT;/* GENERATE OFFSET        */
         BAL   @14,CONVERT                                         0386
*                             CALL FMTRTN;/* FORMAT                  */
         BAL   @14,FMTRTN                                          0387
*                           END;    /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0388
         CH    ARRAYCNT,@CH00092                                   0388
         BNH   @DL00384                                            0388
@DC00384 DS    0H                                                  0389
*                         END;      /* END 1 WORD INTERFACE          */
*                       ELSE        /* NOT 1 WORD INTERFACE          */
*                         DO;                                      0390
         B     @RC00376                                            0390
@RF00376 DS    0H                                                  0391
*                           ADPLFMT2=ADDR(DCBBUFCB);/* HAS NO DEVICE
*                                      INTERFACE                     */
         LA    @06,DCBBUFCB+16(,DCBPTR)                            0391
         ST    @06,ADPLFMT2(,ABDPLPTR)                             0391
*                           HDRTYPE(1:LENGTH(EXCP0))=EXCP0;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0392
         MVC   HDRTYPE(28,@07),EXCP0                               0392
*                           CALL PRINT;/* PRINT HEADER               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0393
         BALR  @14,@15                                             0393
*                           BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER 0394
*                                      SCORE                         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0394
         MVC   BUFFER(5,@07),UNDER                                 0394
*                           CALL PRINT;/* PRINT IT                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0395
         BALR  @14,@15                                             0395
*                           CALL PRINT;/* BLANK LINE                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0396
         BALR  @14,@15                                             0396
*                           DO ARRAYCNT=1 TO DIM(EXCP0ARY) WHILE(ERRSW=
*                                 OFF);                            0397
         LA    ARRAYCNT,1                                          0397
@DL00397 TM    ERRSW,B'10000000'                                   0397
         BNZ   @DC00397                                            0397
*                             LINEPTR=EXCP0ARY(ARRAYCNT);/* FORMAT 0398
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0398
         SLA   @07,2                                               0398
         L     LINEPTR,EXCP0ARY-4(@07)                             0398
*                             CALL CONVERT;/* GENERATE OFFSET        */
         BAL   @14,CONVERT                                         0399
*                             CALL FMTRTN;/* FORMAT                  */
         BAL   @14,FMTRTN                                          0400
*                           END;    /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0401
         CH    ARRAYCNT,@CH00092                                   0401
         BNH   @DL00397                                            0401
@DC00397 DS    0H                                                  0402
*                         END;      /* END NO DEVICE                 */
*               END;                /* END HAS COMMON INTERFACE      */
*                                                                  0403
@RC00376 DS    0H                                                  0403
@RC00362 DS    0H                                                  0403
@RC00348 DS    0H                                                  0403
@RC00334 DS    0H                                                  0404
*           /*********************************************************/
*           /*                                                       */
*           /* IF THE DCB WAS FORMATTED FINE AND IT HAS APPENDAGES   */
*           /* THEN FORMAT THE APPENDAGES                            */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0404
*           IF MFAPG=ON&ERRSW=OFF THEN/* OK TO FORMAT APPENDAGES     */
@RC00319 DS    0H                                                  0404
@RC00305 TM    MFAPG,B'00100000'                                   0404
         BNO   @RF00404                                            0404
         TM    ERRSW,B'10000000'                                   0404
         BNZ   @RF00404                                            0404
*             DO ARRAYCNT=1 TO DIM(EXAPARY) WHILE(ERRSW=OFF);      0405
         LA    ARRAYCNT,1                                          0405
@DL00405 TM    ERRSW,B'10000000'                                   0405
         BNZ   @DC00405                                            0405
*               LINEPTR=EXAPARY(ARRAYCNT);/* FORMAT PATTERN          */
         LR    @07,ARRAYCNT                                        0406
         SLA   @07,2                                               0406
         L     LINEPTR,EXAPARY-4(@07)                              0406
*               CALL CONVERT;       /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0407
*               CALL FMTRTN;        /* FORMAT THE LINE               */
         BAL   @14,FMTRTN                                          0408
*             END;                  /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0409
         CH    ARRAYCNT,@CH00041                                   0409
         BNH   @DL00405                                            0409
@DC00405 DS    0H                                                  0410
*           ELSE                                                   0410
*             ;                     /* APPENDAGES NOT WANTED         */
@RF00404 DS    0H                                                  0411
*           EXCPDCB=ON;             /* SET EXCP INDICATOR            */
         OI    EXCPDCB(ABDPLPTR),B'10000000'                       0411
*           RCCODE=NOIOB;           /* INHIBIT IOB PROCESSING        */
         LA    RCCODE,4                                            0412
*         END;                      /* END EXCP                      */
*                                                                  0414
*       /*************************************************************/
*       /*                                                           */
*       /* THE ACCESS METHOD WAS NOT EXCP- DETERMINE WHAT IT WAS AND */
*       /* FORMAT APPROPRIATELY                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0414
*       ELSE                        /* NOT EXCP                      */
*         DO;                                                      0414
         B     @RC00298                                            0414
@RF00298 DS    0H                                                  0415
*           VADR=ADDR(DCBDSORG);    /* DATA SET ORGANIZATION BITS    */
         LA    VADR,DCBDSORG+16(,DCBPTR)                           0415
*           CALL ACCESRTN;          /* ACCESS THEM                   */
         BAL   @14,ACCESRTN                                        0416
*           IF RCREG^=ZERO THEN     /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0417
         BZ    @RF00417                                            0417
*             BUFFER(1:LENGTH(NOACCESS))=NOACCESS;                 0418
         L     @07,ADPLBUF(,ABDPLPTR)                              0418
         MVC   BUFFER(70,@07),NOACCESS                             0418
*           ELSE                    /* FOUND DSORG BITS              */
*             DO;                                                  0419
         B     @RC00417                                            0419
@RF00417 DS    0H                                                  0420
*               DSORGBIT=DATAHALF;  /* SAVE DSORG BITS               */
*                                                                  0420
         L     @06,DATAPTR                                         0420
         MVC   DSORGBIT(2),DATAHALF(@06)                           0420
*               /*****************************************************/
*               /*                                                   */
*               /* THIS ROUTINE SKIPS FORMATTING IF THE CONTROL BLOCK*/
*               /* WAS AN ACB. IT FORMATES ONLY DCBS                 */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0421
*               IF ACBM=OFF THEN    /* THIS FORMATTER DOES NOT     0421
*                                      HANDLER ACBS                  */
         TM    ACBM,B'00001000'                                    0421
         BNZ   @RF00421                                            0421
*                 DO;                                              0422
*                   ADPLFMT2=ADDR(DCBRELB);/* WHERE TO START       0423
*                                      FORMATTING                    */
         LA    @06,16                                              0423
         ALR   @06,DCBPTR                                          0423
         ST    @06,ADPLFMT2(,ABDPLPTR)                             0423
*                   BUFFER(1:LENGTH(DCBHDR))=DCBHDR;/* FILL IN HEADER
*                                      LINE                          */
         L     @06,ADPLBUF(,ABDPLPTR)                              0424
         MVC   BUFFER(55,@06),DCBHDR                               0424
*                   PACKAREA=DCBPTR;/* CHAR AREA TO UPACK FROM       */
         ST    DCBPTR,PACKAREA                                     0425
*                   GARBAGE='04'X;  /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0426
*                   UNPK(ADDRESS,UNPACK);/* PLACE INTO BUFFER        */
         UNPK  ADDRESS(9,@06),UNPACK(5)                            0427
*                   TR(ADDRESS,TRANS);/* MAKE PRINTABLE              */
*                                                                  0428
         TR    ADDRESS(9,@06),TRANS                                0428
*                   /*************************************************/
*                   /*                                               */
*                   /* ISAM TYPE DCB                                 */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0429
*                   IF DSGIS=ON THEN/* ISAM ACCESS METHOD            */
         TM    DSGIS,B'10000000'                                   0429
         BNO   @RF00429                                            0429
*                     DO;                                          0430
*                       HDRTYPE(1:LENGTH(ISAM))=ISAM;/* FILL IN TYPE */
         MVC   HDRTYPE(6,@06),ISAM                                 0431
*                       CALL PRINT; /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0432
         BALR  @14,@15                                             0432
*                       BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE */
         L     @07,ADPLBUF(,ABDPLPTR)                              0433
         MVC   BUFFER(5,@07),UNDER                                 0433
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0434
         BALR  @14,@15                                             0434
*                       CALL PRINT; /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0435
         BALR  @14,@15                                             0435
*                       DO ARRAYCNT=1 TO DIM(ISAMARY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0436
@DL00436 TM    ERRSW,B'10000000'                                   0436
         BNZ   @DC00436                                            0436
*                         LINEPTR=ISAMARY(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0437
         SLA   @07,2                                               0437
         L     LINEPTR,ISAMARY-4(@07)                              0437
*                         CALL CONVERT;/* GENERATE OFFSET            */
         BAL   @14,CONVERT                                         0438
*                         CALL FMTRTN;/* FORMAT                      */
         BAL   @14,FMTRTN                                          0439
*                       END;        /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0440
         CH    ARRAYCNT,@CH00070                                   0440
         BNH   @DL00436                                            0440
@DC00436 DS    0H                                                  0441
*                       IF MFMVP=ON|MFLCP=ON THEN/* QISAM LOAD BITS
*                                                            @ZM45069*/
         TM    MFMVP,B'00011000'                                   0441
         BZ    @RF00441                                            0441
*                         ISAMLOAD=ON;/* SET QISAM LOAD TYPE BIT     */
         OI    ISAMLOAD(ABDPLPTR),B'01000000'                      0442
*                       ELSE        /* NOT QISAM LOAD                */
*                         IF MFRD=ON|MFDBF=ON|MFCHK=ON|MFWRT=ON THEN
         B     @RC00441                                            0443
@RF00441 TM    MFRD,B'00100110'                                    0443
         BNZ   @RT00443                                            0443
         TM    MFWRT,B'00100000'                                   0443
         BNO   @RF00443                                            0443
@RT00443 DS    0H                                                  0444
*                                   /* BISAM METHOD                  */
*                           DO;                                    0444
*                             BISAMDCB=ON;/* INDICATE BISAM          */
         OI    BISAMDCB(ABDPLPTR),B'00010000'                      0445
*                             RCCODE=NOIOB;/* INHIBIT IOB PROCESSING */
         LA    RCCODE,4                                            0446
*                           END;    /* END BISAM                     */
*                         ELSE      /* QISAM SCAN TYPE               */
*                           ISAMSCAN=ON;/* SET QISAM SCAN TYPE       */
         B     @RC00443                                            0448
@RF00443 OI    ISAMSCAN(ABDPLPTR),B'00100000'                      0448
*                     END;          /* END ISAM                      */
*                   ELSE            /* NOT ISAM                      */
*                                                                  0450
*                     /***********************************************/
*                     /*                                             */
*                     /* PARTITIONED OR SAM TYPE DCB                 */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0450
*                     IF DSGPS=ON|DSGPO=ON THEN/* PHYICAL SEQUENTIAL
*                                      ORGANIZATION OR PARTITIONED 0450
*                                      ORGANIZATION                  */
         B     @RC00429                                            0450
@RF00429 TM    DSGPS,B'01000010'                                   0450
         BZ    @RF00450                                            0450
*                       DO;                                        0451
*                         VADR=ADDR(DCBCIND2);/* TO GET CHAINED    0452
*                                      SCHEDULING BIT                */
         LA    VADR,DCBCIND2+52(,DCBPTR)                           0452
*                         CALL ACCESRTN;/* ACCESS IT                 */
         BAL   @14,ACCESRTN                                        0453
*                         IF RCREG^=ZERO THEN/* ACCESS ERROR         */
         LTR   RCREG,RCREG                                         0454
         BZ    @RF00454                                            0454
*                           BUFFER(1:LENGTH(DCBMSG))=DCBMSG;/* ERROR
*                                      MESSAGE                       */
         L     @07,ADPLBUF(,ABDPLPTR)                              0455
         MVC   BUFFER(120,@07),DCBMSG                              0455
*                         ELSE      /* FOUND SCHEDULING BIT          */
*                           DO;                                    0456
         B     @RC00454                                            0456
@RF00454 DS    0H                                                  0457
*                             IF(DATABYTE&CHAINMSK)=ZEROBYTE THEN/*
*                                      NOT CHAIN SCHEDULING          */
         L     @07,DATAPTR                                         0457
         SLR   @06,@06                                             0457
         IC    @06,DATABYTE(,@07)                                  0457
         SLR   @07,@07                                             0457
         IC    @07,CHAINMSK                                        0457
         NR    @06,@07                                             0457
         SLR   @07,@07                                             0457
         IC    @07,ZEROBYTE                                        0457
         CR    @06,@07                                             0457
         BNE   @RF00457                                            0457
*                               SAMNMAL=ON;/* NO CHAINING BIT        */
         OI    SAMNMAL(ABDPLPTR),B'00001000'                       0458
*                             ELSE                                 0459
*                               SAMCHAIN=ON;/* CHAIN SCHEDULING IS ON*/
         B     @RC00457                                            0459
@RF00457 OI    SAMCHAIN(ABDPLPTR),B'00000100'                      0459
*                             IF DSGPO=ON THEN/* IF PARTITIONED    0460
*                                      ORGANIZATION                  */
@RC00457 TM    DSGPO,B'00000010'                                   0460
         BNO   @RF00460                                            0460
*                               DO;                                0461
*                                 HDRTYPE(1:LENGTH(BPAM))=BPAM;/*  0462
*                                      FILL IN TYPE                  */
         L     @07,ADPLBUF(,ABDPLPTR)                              0462
         MVC   HDRTYPE(6,@07),BPAM                                 0462
*                                 CALL PRINT;/* PRINT HEADER         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0463
         BALR  @14,@15                                             0463
*                                 BUFFER(1:LENGTH(UNDER))=UNDER;/* 0464
*                                      UNDER SCORE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0464
         MVC   BUFFER(5,@07),UNDER                                 0464
*                                 CALL PRINT;/* PRINT IT             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0465
         BALR  @14,@15                                             0465
*                                 CALL PRINT;/* BLANK LINE           */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0466
         BALR  @14,@15                                             0466
*                                 DO ARRAYCNT=1 TO DIM(BPAMARY) WHILE(
*                                       ERRSW=OFF);                0467
         LA    ARRAYCNT,1                                          0467
@DL00467 TM    ERRSW,B'10000000'                                   0467
         BNZ   @DC00467                                            0467
*                                   LINEPTR=BPAMARY(ARRAYCNT);/*   0468
*                                      FORMAT PATTERN ADDR           */
         LR    @07,ARRAYCNT                                        0468
         SLA   @07,2                                               0468
         L     LINEPTR,BPAMARY-4(@07)                              0468
*                                   CALL CONVERT;/* GENERATE OFFSET  */
         BAL   @14,CONVERT                                         0469
*                                   CALL FMTRTN;/* FORMAT            */
         BAL   @14,FMTRTN                                          0470
*                                 END;/* END FORMAT LOOP             */
         AH    ARRAYCNT,@CH00041                                   0471
         CH    ARRAYCNT,@CH00130                                   0471
         BNH   @DL00467                                            0471
@DC00467 DS    0H                                                  0472
*                               END;/* END PARTITIONED               */
*                             ELSE  /* NOT PARTITIONED ORGANIZATION  */
*                               IF MFRD=ON|MFWRT=ON THEN/* BSAM    0473
*                                      METHOD                        */
         B     @RC00460                                            0473
@RF00460 TM    MFRD,B'00100000'                                    0473
         BO    @RT00473                                            0473
         TM    MFWRT,B'00100000'                                   0473
         BNO   @RF00473                                            0473
@RT00473 DS    0H                                                  0474
*                                 DO;/* FORMAT BSAM DCB              */
*                                   HDRTYPE(1:LENGTH(BSAM))=BSAM;/*
*                                      FILL IN TYPE                  */
         L     @07,ADPLBUF(,ABDPLPTR)                              0475
         MVC   HDRTYPE(6,@07),BSAM                                 0475
*                                   CALL PRINT;/* PRINT HEADER       */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0476
         BALR  @14,@15                                             0476
*                                   BUFFER(1:LENGTH(UNDER))=UNDER;/*
*                                      UNDER SCORE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0477
         MVC   BUFFER(5,@07),UNDER                                 0477
*                                   CALL PRINT;/* PRINT IT           */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0478
         BALR  @14,@15                                             0478
*                                   CALL PRINT;/* BLANK LINE         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0479
         BALR  @14,@15                                             0479
*                                   DO ARRAYCNT=1 TO DIM(BSAMARY) WHILE
*                                        (ERRSW=OFF);              0480
         LA    ARRAYCNT,1                                          0480
@DL00480 TM    ERRSW,B'10000000'                                   0480
         BNZ   @DC00480                                            0480
*                                    LINEPTR=BSAMARY(ARRAYCNT);/*  0481
*                                      FORMAT PATTERN ADDR           */
         LR    @07,ARRAYCNT                                        0481
         SLA   @07,2                                               0481
         L     LINEPTR,BSAMARY-4(@07)                              0481
*                                    CALL CONVERT;/* GENERATE OFFSET */
         BAL   @14,CONVERT                                         0482
*                                    CALL FMTRTN;/* FORMAT           */
         BAL   @14,FMTRTN                                          0483
*                                   END;/* END FORMAT LOOP END FORMAT
*                                      BSAM                          */
         AH    ARRAYCNT,@CH00041                                   0484
         CH    ARRAYCNT,@CH00130                                   0484
         BNH   @DL00480                                            0484
@DC00480 DS    0H                                                  0485
*                                 END;/* END BSAM METHOD             */
*                               ELSE/* QSAM DCB                      */
*                                 DO;                              0486
         B     @RC00473                                            0486
@RF00473 DS    0H                                                  0487
*                                   HDRTYPE(1:LENGTH(QSAM))=QSAM;/*
*                                      FILL IN TYPE                  */
         L     @07,ADPLBUF(,ABDPLPTR)                              0487
         MVC   HDRTYPE(6,@07),QSAM                                 0487
*                                   CALL PRINT;/* PRINT HEADER       */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0488
         BALR  @14,@15                                             0488
*                                   BUFFER(1:LENGTH(UNDER))=UNDER;/*
*                                      UNDER SCORE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0489
         MVC   BUFFER(5,@07),UNDER                                 0489
*                                   CALL PRINT;/* PRINT IT           */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0490
         BALR  @14,@15                                             0490
*                                   CALL PRINT;/* BLANK LINE         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0491
         BALR  @14,@15                                             0491
*                                   DO ARRAYCNT=1 TO DIM(QSAMARY) WHILE
*                                        (ERRSW=OFF);              0492
         LA    ARRAYCNT,1                                          0492
@DL00492 TM    ERRSW,B'10000000'                                   0492
         BNZ   @DC00492                                            0492
*                                    LINEPTR=QSAMARY(ARRAYCNT);/*  0493
*                                      FORMAT PATTERN ADDR           */
         LR    @07,ARRAYCNT                                        0493
         SLA   @07,2                                               0493
         L     LINEPTR,QSAMARY-4(@07)                              0493
*                                    CALL CONVERT;/* GENERATE OFFSET */
         BAL   @14,CONVERT                                         0494
*                                    CALL FMTRTN;/* FORMAT           */
         BAL   @14,FMTRTN                                          0495
*                                   END;/* END FORMAT LOOP           */
         AH    ARRAYCNT,@CH00041                                   0496
         CH    ARRAYCNT,@CH00130                                   0496
         BNH   @DL00492                                            0496
@DC00492 DS    0H                                                  0497
*                                 END;/* END FORMAT QSAM             */
*                           END;    /* END FOUND CHAIN BIT           */
*                       END;        /* END SAM ACCESS METHOD         */
*                     ELSE          /* NOT SAM METHOD                */
*                                                                  0500
*                       /*********************************************/
*                       /*                                           */
*                       /* BDAM TYPE DCB                             */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0500
*                       IF DSGDA=ON THEN/* BDAM ACCESS METHOD        */
         B     @RC00450                                            0500
@RF00450 TM    DSGDA,B'00100000'                                   0500
         BNO   @RF00500                                            0500
*                         DO;                                      0501
*                           HDRTYPE(1:LENGTH(BDAM))=BDAM;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0502
         MVC   HDRTYPE(6,@07),BDAM                                 0502
*                           CALL PRINT;/* PRINT HEADER               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0503
         BALR  @14,@15                                             0503
*                           BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER 0504
*                                      SCORE                         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0504
         MVC   BUFFER(5,@07),UNDER                                 0504
*                           CALL PRINT;/* PRINT IT                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0505
         BALR  @14,@15                                             0505
*                           CALL PRINT;/* BLANK LINE                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0506
         BALR  @14,@15                                             0506
*                           DO ARRAYCNT=1 TO DIM(BDAMARY) WHILE(ERRSW=
*                                 OFF);                            0507
         LA    ARRAYCNT,1                                          0507
@DL00507 TM    ERRSW,B'10000000'                                   0507
         BNZ   @DC00507                                            0507
*                             LINEPTR=BDAMARY(ARRAYCNT);/* FORMAT  0508
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0508
         SLA   @07,2                                               0508
         L     LINEPTR,BDAMARY-4(@07)                              0508
*                             CALL CONVERT;/* GENERATE OFFSET        */
         BAL   @14,CONVERT                                         0509
*                             CALL FMTRTN;/* FORMAT                  */
         BAL   @14,FMTRTN                                          0510
*                           END;    /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0511
         CH    ARRAYCNT,@CH00130                                   0511
         BNH   @DL00507                                            0511
@DC00507 DS    0H                                                  0512
*                           BDAMDCB=ON;/* SET BIT IN PARMLIST        */
         OI    BDAMDCB(ABDPLPTR),B'00000010'                       0512
*                         END;      /* END BDAM METHOD               */
*                       ELSE        /* NOT BDAM METHOD               */
*                                                                  0514
*                         /*******************************************/
*                         /*                                         */
*                         /* BTAM TYPE DCB                           */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0514
*                         IF DSGCX=ON THEN/* BTAM METHOD             */
         B     @RC00500                                            0514
@RF00500 TM    DSGCX,B'00010000'                                   0514
         BNO   @RF00514                                            0514
*                           DO;                                    0515
*                             HDRTYPE(1:LENGTH(BTAM))=BTAM;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0516
         MVC   HDRTYPE(6,@07),BTAM                                 0516
*                             CALL PRINT;/* PRINT HEADER             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0517
         BALR  @14,@15                                             0517
*                             BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER
*                                      SCORE                         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0518
         MVC   BUFFER(5,@07),UNDER                                 0518
*                             CALL PRINT;/* PRINT IT                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0519
         BALR  @14,@15                                             0519
*                             CALL PRINT;/* BLANK LINE               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0520
         BALR  @14,@15                                             0520
*                             DO ARRAYCNT=1 TO DIM(BTAMARY) WHILE(ERRSW
*                                   =OFF);                         0521
         LA    ARRAYCNT,1                                          0521
@DL00521 TM    ERRSW,B'10000000'                                   0521
         BNZ   @DC00521                                            0521
*                               LINEPTR=BTAMARY(ARRAYCNT);/* FORMAT
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0522
         SLA   @07,2                                               0522
         L     LINEPTR,BTAMARY-4(@07)                              0522
*                               CALL CONVERT;/* GENERATE OFFSET      */
         BAL   @14,CONVERT                                         0523
*                               CALL FMTRTN;/* FORMAT                */
         BAL   @14,FMTRTN                                          0524
*                             END;  /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0525
         CH    ARRAYCNT,@CH00092                                   0525
         BNH   @DL00521                                            0525
@DC00521 DS    0H                                                  0526
*                             BTAMDCB=ON;                          0526
         OI    BTAMDCB(ABDPLPTR),B'00000001'                       0526
*                           END;    /* END BTAM METHOD               */
*                         ELSE      /* NOT BTAM                      */
*                                                                  0528
*                           /*****************************************/
*                           /*                                       */
*                           /* GAM TYPE DCB                          */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0528
*                           IF DSGGS=ON THEN/* GAM ACCESS METHOD     */
         B     @RC00514                                            0528
@RF00514 TM    DSGGS,B'10000000'                                   0528
         BNO   @RF00528                                            0528
*                             DO;                                  0529
*                               HDRTYPE(1:LENGTH(GAM))=GAM;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0530
         MVC   HDRTYPE(5,@07),GAM                                  0530
*                               CALL PRINT;/* PRINT HEADER           */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0531
         BALR  @14,@15                                             0531
*                               BUFFER(1:LENGTH(UNDER))=UNDER;/*   0532
*                                      UNDER SCORE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0532
         MVC   BUFFER(5,@07),UNDER                                 0532
*                               CALL PRINT;/* PRINT IT               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0533
         BALR  @14,@15                                             0533
*                               CALL PRINT;/* BLANK LINE             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0534
         BALR  @14,@15                                             0534
*                               DO ARRAYCNT=1 TO DIM(GAMARY) WHILE(
*                                     ERRSW=OFF);                  0535
         LA    ARRAYCNT,1                                          0535
@DL00535 TM    ERRSW,B'10000000'                                   0535
         BNZ   @DC00535                                            0535
*                                 LINEPTR=GAMARY(ARRAYCNT);/* FORMAT
*                                      PATTERN ADDR                  */
         LR    @07,ARRAYCNT                                        0536
         SLA   @07,2                                               0536
         L     LINEPTR,GAMARY-4(@07)                               0536
*                                 CALL CONVERT;/* GENERATE OFFSET    */
         BAL   @14,CONVERT                                         0537
*                                 CALL FMTRTN;/* FORMAT              */
         BAL   @14,FMTRTN                                          0538
*                               END;/* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0539
         CH    ARRAYCNT,@CH00092                                   0539
         BNH   @DL00535                                            0539
@DC00535 DS    0H                                                  0540
*                               GAMDCB=ON;/* INDICATE GAM ACCESS   0540
*                                      METHOD                        */
         OI    GAMDCB(ABDPLPTR),B'10000000'                        0540
*                             END;  /* END GAM ACCESS METHOD         */
*                           ELSE    /* NOT GAM                       */
*                                                                  0542
*                             /***************************************/
*                             /*                                     */
*                             /* TCAM LINE GROUP OR TCAM 3705 TYPE   */
*                             /* DCB                                 */
*                             /*                                     */
*                             /***************************************/
*                                                                  0542
*                             IF(DSGTX=ON)|(DSGTR=ON) THEN/* TCAM  0542
*                                      LINE GROUP OR 3705            */
         B     @RC00528                                            0542
@RF00528 TM    DSGTX,B'01000100'                                   0542
         BZ    @RF00542                                            0542
*                               IF ADPLSNPR=ON THEN/* TCAM LINE GROUP
*                                      OR 3705 (ONLY WANTED UNDER  0543
*                                      AMDPRDMP-SNAP ALEADY HAS THIS
*                                      FORMATTER)                    */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0543
         BNO   @RF00543                                            0543
*                                 DO;                              0544
*                                   IF DSGTX=ON THEN/* TCAM LINE   0545
*                                      GROUP                         */
         TM    DSGTX,B'01000000'                                   0545
         BNO   @RF00545                                            0545
*                                    DO;                           0546
*                                     HDRTYPE(1:LENGTH(LINEGRP))=  0547
*                                         LINEGRP;/* FILL IN TYPE    */
         L     @06,ADPLBUF(,ABDPLPTR)                              0547
         MVC   HDRTYPE(17,@06),LINEGRP                             0547
*                                     CALL PRINT;/* PRINT HEADER     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0548
         BALR  @14,@15                                             0548
*                                     BUFFER(1:LENGTH(UNDER))=UNDER;
         L     @06,ADPLBUF(,ABDPLPTR)                              0549
         MVC   BUFFER(5,@06),UNDER                                 0549
*                                     /* UNDER SCORE                 */
*                                     CALL PRINT;/* PRINT IT         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0550
         BALR  @14,@15                                             0550
*                                     CALL PRINT;/* BLANK LINE       */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0551
         BALR  @14,@15                                             0551
*                                     DO ARRAYCNT=1 TO DIM(LINEARY)
*                                          WHILE(ERRSW=OFF);       0552
         LA    ARRAYCNT,1                                          0552
@DL00552 TM    ERRSW,B'10000000'                                   0552
         BNZ   @DC00552                                            0552
*                                      LINEPTR=LINEARY(ARRAYCNT);/*
*                                      FORMAT PATTERN ADDR           */
         LR    @05,ARRAYCNT                                        0553
         SLA   @05,2                                               0553
         L     LINEPTR,LINEARY-4(@05)                              0553
*                                      CALL CONVERT;/* GENERATE    0554
*                                      OFFSET                        */
         BAL   @14,CONVERT                                         0554
*                                      CALL FMTRTN;/* FORMAT         */
         BAL   @14,FMTRTN                                          0555
*                                     END;/* END FORMAT LOOP         */
         AH    ARRAYCNT,@CH00041                                   0556
         CH    ARRAYCNT,@CH00092                                   0556
         BNH   @DL00552                                            0556
@DC00552 DS    0H                                                  0557
*                                     TCAMLINE=ON;                 0557
         OI    TCAMLINE(ABDPLPTR),B'01000000'                      0557
*                                    END;/* END TCAM LINE GROUP      */
*                                   ELSE/* TCAM 3705                 */
*                                    DO;                           0559
         B     @RC00545                                            0559
@RF00545 DS    0H                                                  0560
*                                     HDRTYPE(1:LENGTH(T3705))=T3705;
         L     @06,ADPLBUF(,ABDPLPTR)                              0560
         MVC   HDRTYPE(11,@06),T3705                               0560
*                                     /* FILL IN TYPE                */
*                                     CALL PRINT;/* PRINT HEADER     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0561
         BALR  @14,@15                                             0561
*                                     BUFFER(1:LENGTH(UNDER))=UNDER;
         L     @06,ADPLBUF(,ABDPLPTR)                              0562
         MVC   BUFFER(5,@06),UNDER                                 0562
*                                     /* UNDER SCORE                 */
*                                     CALL PRINT;/* PRINT IT         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0563
         BALR  @14,@15                                             0563
*                                     CALL PRINT;/* BLANK LINE       */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0564
         BALR  @14,@15                                             0564
*                                     DO ARRAYCNT=1 TO DIM(T3705ARY)
*                                          WHILE(ERRSW=OFF);       0565
         LA    ARRAYCNT,1                                          0565
@DL00565 TM    ERRSW,B'10000000'                                   0565
         BNZ   @DC00565                                            0565
*                                      LINEPTR=T3705ARY(ARRAYCNT);/*
*                                      FORMAT PATTERN ADDR           */
         LR    @05,ARRAYCNT                                        0566
         SLA   @05,2                                               0566
         L     LINEPTR,T3705ARY-4(@05)                             0566
*                                      CALL CONVERT;/* GENERATE    0567
*                                      OFFSET                        */
         BAL   @14,CONVERT                                         0567
*                                      CALL FMTRTN;/* FORMAT         */
         BAL   @14,FMTRTN                                          0568
*                                     END;/* END FORMAT LOOP         */
         AH    ARRAYCNT,@CH00041                                   0569
         CH    ARRAYCNT,@CH00092                                   0569
         BNH   @DL00565                                            0569
@DC00565 DS    0H                                                  0570
*                                     TCAM3705=ON;                 0570
         OI    TCAM3705(ABDPLPTR),B'00100000'                      0570
*                                     RCCODE=NOIOB;/* INHIBIT LCB  0571
*                                      PROCESSING                    */
         LA    RCCODE,4                                            0571
*                                    END;/* END TCAM 3705            */
*                                                                  0572
*                                   /*********************************/
*                                   /*                               */
*                                   /* FORMAT THE INVITATION LISTS   */
*                                   /* THAT ARE ASSOCIATED WITH THIS */
*                                   /* DCB IF THE DCB FORMATTED      */
*                                   /* WITHOUT ERROR                 */
*                                   /*                               */
*                                   /*********************************/
*                                                                  0573
*                                   IF ERRSW=OFF THEN/* FORMATTED DCB
*                                      WITHOUT ERROR                 */
@RC00545 TM    ERRSW,B'10000000'                                   0573
         BNZ   @RF00573                                            0573
*                                    DO;                           0574
*                                     VADR=ADDR(DCBILCT);/* NUMBER OF
*                                      INVITATION LISTS              */
         LA    VADR,52                                             0575
         ALR   VADR,DCBPTR                                         0575
*                                     CALL ACCESRTN;/* ACCESS IT     */
         BAL   @14,ACCESRTN                                        0576
*                                     IF RCREG^=ZERO THEN/* ACCESS 0577
*                                      ERROR                         */
         LTR   RCREG,RCREG                                         0577
         BZ    @RF00577                                            0577
*                                      BUFFER(1:LENGTH(DCBMSG))=DCBMSG;
         L     @07,ADPLBUF(,ABDPLPTR)                              0578
         MVC   BUFFER(120,@07),DCBMSG                              0578
*                                     ELSE/* FOUND # INVITATION LISTS*/
*                                      IF DATABYTE^=ZEROBYTE THEN/*
*                                      THERE ARE INVITATION LISTS    */
         B     @RC00577                                            0579
@RF00577 L     @07,DATAPTR                                         0579
         CLC   DATABYTE(1,@07),ZEROBYTE                            0579
         BE    @RF00579                                            0579
*                                       DO;                        0580
*                                        NUMLIST=DATABYTE;         0581
         MVC   NUMLIST(1),DATABYTE(@07)                            0581
*                                        CALL PRINT;/* SPACE A LINE  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0582
         BALR  @14,@15                                             0582
*                                        CALL PRINT;/* SPACE A LINE  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0583
         BALR  @14,@15                                             0583
*                                        BUFFER(31:LENGTH(INVLIST)+30)=
*                                            INVLIST;/* HEADER       */
         L     @07,ADPLBUF(,ABDPLPTR)                              0584
         MVC   BUFFER+30(17,@07),INVLIST                           0584
*                                        CALL PRINT;/* SPACE A LINE  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0585
         BALR  @14,@15                                             0585
*                                        DO ARRAYCNT=1 TO NUMLIST WHILE
*                                             (ERRSW=OFF);/* FORMAT
*                                      EACH                          */
         LA    ARRAYCNT,1                                          0586
         B     @DE00586                                            0586
@DL00586 TM    ERRSW,B'10000000'                                   0586
         BNZ   @DC00586                                            0586
*                                         LINEPTR=ADDR(DCBF1);/* PTR
*                                      TO FORMAT PATTERN             */
         LA    LINEPTR,DCBF1                                       0587
*                                         CALL CONVERT;/* GENERATE 0588
*                                      OFFSET                        */
         BAL   @14,CONVERT                                         0588
*                                         CALL FMTRTN;/* FORMAT IT   */
         BAL   @14,FMTRTN                                          0589
*                                        END;/* END FORMAT LOOP      */
         AH    ARRAYCNT,@CH00041                                   0590
@DE00586 SLR   @07,@07                                             0590
         IC    @07,NUMLIST                                         0590
         CR    ARRAYCNT,@07                                        0590
         BNH   @DL00586                                            0590
@DC00586 DS    0H                                                  0591
*                                       END;/* END THERE ARE       0591
*                                      INVITATION LISTS              */
*                                      ELSE                        0592
*                                       ;/* THERE ARE NO INVITATION
*                                      LISTS                         */
@RF00579 DS    0H                                                  0593
*                                    END;/* END FORMATTED DCB WITHOUT
*                                      ERROR                         */
*                                   ELSE                           0594
*                                    ;/* ERROR FORMATTING DCB        */
@RF00573 DS    0H                                                  0595
*                                 END;/* END PRINT DUMP IS CALLER -
*                                      TCAM INFO WANTED              */
*                               ELSE/* SNAP CALLER - TCAM INFO WILL
*                                      ALREADY BE FORMATTED BY TCAM  */
*                                 BUFFER=BLANKS;/* BLANK HDR LINE    */
         B     @RC00543                                            0596
@RF00543 L     @07,ADPLBUF(,ABDPLPTR)                              0596
         MVC   BUFFER(120,@07),BLANKS                              0596
*                             ELSE  /* NOT TCAM LINE GROUP OR 3705   */
*                                                                  0597
*                               /*************************************/
*                               /*                                   */
*                               /* TCAM MESSAGE QUEUE TYPE DCB       */
*                               /*                                   */
*                               /*************************************/
*                                                                  0597
*                               IF DSGTQ=ON THEN/* TCAM MESSAGE QUEUE*/
         B     @RC00542                                            0597
@RF00542 TM    DSGTQ,B'00100000'                                   0597
         BNO   @RF00597                                            0597
*                                 IF ADPLSNPR=ON THEN/* PRINT DUMP 0598
*                                      CALLER                        */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0598
         BNO   @RF00598                                            0598
*                                   DO;                            0599
*                                    HDRTYPE(1:LENGTH(TCAMMSG))=TCAMMSG
*                                        ;/* FILL IN TYPE            */
         L     @07,ADPLBUF(,ABDPLPTR)                              0600
         MVC   HDRTYPE(20,@07),TCAMMSG                             0600
*                                    CALL PRINT;/* PRINT HEADER      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0601
         BALR  @14,@15                                             0601
*                                    BUFFER(1:LENGTH(UNDER))=UNDER;/*
*                                      UNDER SCORE                   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0602
         MVC   BUFFER(5,@07),UNDER                                 0602
*                                    CALL PRINT;/* PRINT IT          */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0603
         BALR  @14,@15                                             0603
*                                    CALL PRINT;/* BLANK LINE        */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0604
         BALR  @14,@15                                             0604
*                                    DO ARRAYCNT=1 TO DIM(TMSGARY) 0605
*                                         WHILE(ERRSW=OFF);        0605
         LA    ARRAYCNT,1                                          0605
@DL00605 TM    ERRSW,B'10000000'                                   0605
         BNZ   @DC00605                                            0605
*                                     LINEPTR=TMSGARY(ARRAYCNT);/* 0606
*                                      FORMAT PATTERN ADDR           */
         LR    @07,ARRAYCNT                                        0606
         SLA   @07,2                                               0606
         L     LINEPTR,TMSGARY-4(@07)                              0606
*                                     CALL CONVERT;/* GENERATE OFFSET*/
         BAL   @14,CONVERT                                         0607
*                                     CALL FMTRTN;/* FORMAT          */
         BAL   @14,FMTRTN                                          0608
*                                    END;/* END FORMAT LOOP          */
         AH    ARRAYCNT,@CH00041                                   0609
         CH    ARRAYCNT,@CH00092                                   0609
         BNH   @DL00605                                            0609
@DC00605 DS    0H                                                  0610
*                                    TCAMMSGQ=ON;                  0610
         OI    TCAMMSGQ(ABDPLPTR),B'00010000'                      0610
*                                    RCCODE=NOIOB;/* INHIBIT LCB   0611
*                                      PROCESSING                    */
         LA    RCCODE,4                                            0611
*                                   END;/* END PRINT DUMP IS CALLER  */
*                                 ELSE/* SNAP IS CALLER - TCAM WILL
*                                      FORMAT                        */
*                                   BUFFER=BLANKS;/* BLANK HDR LINE  */
         B     @RC00598                                            0613
@RF00598 L     @07,ADPLBUF(,ABDPLPTR)                              0613
         MVC   BUFFER(120,@07),BLANKS                              0613
*                               ELSE/* NOT TCAM MESSAGE QUEUE        */
*                                                                  0614
*                                 /***********************************/
*                                 /*                                 */
*                                 /* UNKNOWN TYPE -PRINT ERROR       */
*                                 /* MESSAGE                         */
*                                 /*                                 */
*                                 /***********************************/
*                                                                  0614
*                                 DO;                              0614
         B     @RC00597                                            0614
@RF00597 DS    0H                                                  0615
*                                   BUFFER(1:LENGTH(NOACCESS))=NOACCESS
*                                       ;                          0615
         L     @07,ADPLBUF(,ABDPLPTR)                              0615
         MVC   BUFFER(70,@07),NOACCESS                             0615
*                                   RCCODE=NOIOB;/* INHIBIT IOB    0616
*                                      PROCESSING                    */
         LA    RCCODE,4                                            0616
*                                 END;/* END INVALID METHOD          */
*                 END;              /* END NOT AN ACB                */
*               ELSE                /* CONTROL BLOCK WAS AN ACB      */
*                 BUFFER(1:LENGTH(ACBMSG))=ACBMSG;                 0619
         B     @RC00421                                            0619
@RF00421 L     @07,ADPLBUF(,ABDPLPTR)                              0619
         MVC   BUFFER(87,@07),ACBMSG                               0619
*             END;                  /* END FOUND DSORG BITS          */
@RC00421 DS    0H                                                  0621
*         END;                      /* END NOT AN EXCP DCB           */
@RC00417 DS    0H                                                  0622
*     END;                          /* END FOUND MACRF BITS          */
@RC00298 DS    0H                                                  0623
*   CALL PRINT;                                                    0623
@RC00294 L     @15,ADPLPRNT(,ABDPLPTR)                             0623
         BALR  @14,@15                                             0623
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS RETRY REGS    */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0624
*   RETURN CODE(RCCODE);                                           0625
         L     @13,4(,@13)                                         0625
         L     @00,@SIZDATD                                        0625
         LR    @01,@10                                             0625
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@09                                             0625
         L     @14,12(,@13)                                        0625
         LM    @00,@12,20(@13)                                     0625
         BR    @14                                                 0625
*IECDAIOB:                                                         0626
*   ENTRY;                                                         0626
*                                                                  0626
@EP00626 DS    0H                                                  0627
*/********************************************************************/
*/* FUNCTION -                                                     0627
*      ROUTINE TO FORMAT THE IOB(ICB,LCB) CONTROL BLOCKS FOR THE DCB
*      WHOSE ADDRESS IS PASSED IN THE PARAMETER LIST.              0627
*                                                                  0627
*   INPUT -                                                        0627
*      REGISTER 1 MUST POINT TO THE PARMLIST PASSED BY THE CALLER  0627
*      WHICH SHOULD CONTAIN THE ADDRESS OF THE DCB IN ADPLCOM3, THE
*      ADDRESS OF THE IOB(ICB,LCB) STANDARD SECTION IN ADPLFMT2, THE
*      LENGTH OF THE IOB PREFIX IN ADPLFMT1,ALSO DEFINED AS START, 0627
*      THE DATA SET ORGANIZATION BITS SET UP BY THE DCB FORMAT     0627
*      ROUTINE(IECDADCB) IN ADPLCOM2, AND THE ADDRESS OF THE ESTAE 0627
*      PARAMETER LIST IN ADPLCOM4.                                 0627
*                                                                  0627
*   CALLS -                                                        0627
*      BACKCHK, CONVERT, FMTRTN, AND PRINT                         0627
*                                                                  0627
*   CALLED BY -                                                    0627
*      IECDAFMT TO FORMAT THE IOB, ICB, LCB CONTROL                0627
*      BLOCKS                                                      0627
*                                                                  0627
*   RETURNS TO -                                                   0627
*      CALLER WITH RETURN CODE SET BY THE ACCESS OR FORMAT SERVICE 0627
*       ROUTINES                                                     */
*/********************************************************************/
*                                                                  0627
*   ESTAPTR=ADPLCOM4;               /* SAVE PTR TO ESTAE PARM LIST   */
         L     ESTAPTR,ADPLCOM4(,ABDPLPTR)                         0627
*   STM(LINEPTR,RCREG,LCALREGS);    /* SAVE REGS FOR EXPECTED RETRY  */
         STM   LINEPTR,RCREG,LCALREGS(ESTAPTR)                     0628
*   DCBPTR=ADPLCOM3;                /* SAVE DCB ADDRESS TO CHECK IF
*                                      IOBS STILL OK                 */
         L     DCBPTR,ADPLCOM3(,ABDPLPTR)                          0629
*   IOBSTPTR=ADPLFMT2;              /* FIRST IOB ADDRESS             */
         L     IOBSTPTR,ADPLFMT2(,ABDPLPTR)                        0630
*   SAVEPTR=IOBSTPTR;               /* FOR GENERATING OFFSET         */
         ST    IOBSTPTR,SAVEPTR                                    0631
*   ADPLFMT2=IOBSTPTR-START;        /* BACK UP TO PREFIX FOR       0632
*                                      FORMATTING                    */
         LR    @05,IOBSTPTR                                        0632
         SL    @05,START(,ABDPLPTR)                                0632
         ST    @05,ADPLFMT2(,ABDPLPTR)                             0632
*   ADPLCOM1=ADDR(IOBERR);          /* FORMAT ERROR MESSAGE          */
         LA    @05,IOBERR                                          0633
         ST    @05,ADPLCOM1(,ABDPLPTR)                             0633
*   ERRSW=OFF;                      /* INITIALIZE ERROR INDICATOR    */
         NI    ERRSW,B'01111111'                                   0634
*   BUFFER(1:LENGTH(IOBHDR))=IOBHDR;/* HEADER LINE                   */
         L     @05,ADPLBUF(,ABDPLPTR)                              0635
         MVC   BUFFER(54,@05),IOBHDR                               0635
*   PACKAREA=IOBSTPTR;              /* CHAR AREA FOR ADDRESS         */
         ST    IOBSTPTR,PACKAREA                                   0636
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR UNPK         */
         MVI   GARBAGE,X'04'                                       0637
*   UNPK(ADDRESS,UNPACK);           /* UNPACK INTO BUFFER            */
         UNPK  ADDRESS(9,@05),UNPACK(5)                            0638
*   TR(ADDRESS,TRANS);              /* MAKE PRINTABLE                */
*                                                                  0639
         TR    ADDRESS(9,@05),TRANS                                0639
*   /*****************************************************************/
*   /*                                                               */
*   /* QISAM LOAD TYPE IOB                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0640
*   IF ISAMLOAD=ON THEN             /* QISAM LOAD IOB                */
         TM    ISAMLOAD(ABDPLPTR),B'01000000'                      0640
         BNO   @RF00640                                            0640
*     DO;                                                          0641
*       CALL BACKCHK;               /* CHECK DCB PTR TO SEE IF IOB 0642
*                                      STILL VALID                   */
         BAL   @14,BACKCHK                                         0642
*       IF ERRSW=OFF THEN           /* FOUND A VALID IOB             */
         TM    ERRSW,B'10000000'                                   0643
         BNZ   @RF00643                                            0643
*         DO;                                                      0644
*           HDRTYPE(1:LENGTH(QISAML))=QISAML;/* FILL IN TYPE         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0645
         MVC   HDRTYPE(17,@07),QISAML                              0645
*           CALL PRINT;             /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0646
         BALR  @14,@15                                             0646
*           BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE             */
         L     @07,ADPLBUF(,ABDPLPTR)                              0647
         MVC   BUFFER(5,@07),UNDER                                 0647
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0648
         BALR  @14,@15                                             0648
*           CALL PRINT;             /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0649
         BALR  @14,@15                                             0649
*           DO ARRAYCNT=1 TO DIM(LOADARY) WHILE(ERRSW=OFF);        0650
         LA    ARRAYCNT,1                                          0650
@DL00650 TM    ERRSW,B'10000000'                                   0650
         BNZ   @DC00650                                            0650
*             LINEPTR=LOADARY(ARRAYCNT);/* FORMAT PATTERN ADDR       */
         LR    @07,ARRAYCNT                                        0651
         SLA   @07,2                                               0651
         L     LINEPTR,LOADARY-4(@07)                              0651
*             CALL CONVERT;         /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0652
*             CALL FMTRTN;          /* FORMAT                        */
         BAL   @14,FMTRTN                                          0653
*           END;                    /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0654
         CH    ARRAYCNT,@CH00068                                   0654
         BNH   @DL00650                                            0654
@DC00650 DS    0H                                                  0655
*         END;                      /* END FOUND CORRECT IOB         */
*       ELSE                                                       0656
*         ;                         /* IOB WAS NOT VALID             */
@RF00643 DS    0H                                                  0657
*     END;                          /* END QISAM LOAD IOB            */
*   ELSE                            /* NOT QISAM LOAD                */
*                                                                  0658
*     /***************************************************************/
*     /*                                                             */
*     /* QISAM SCAN TYPE IOB                                         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0658
*     IF ISAMSCAN=ON THEN           /* QISAM SCAN                    */
         B     @RC00640                                            0658
@RF00640 TM    ISAMSCAN(ABDPLPTR),B'00100000'                      0658
         BNO   @RF00658                                            0658
*       DO;                                                        0659
*         CALL BACKCHK;             /* CHECK BACKPTR                 */
         BAL   @14,BACKCHK                                         0660
*         IF ERRSW=OFF THEN         /* FOUND A VALID IOB             */
         TM    ERRSW,B'10000000'                                   0661
         BNZ   @RF00661                                            0661
*           DO;                                                    0662
*             HDRTYPE(1:LENGTH(QISAMS))=QISAMS;/* FILL IN TYPE       */
         L     @07,ADPLBUF(,ABDPLPTR)                              0663
         MVC   HDRTYPE(17,@07),QISAMS                              0663
*             CALL PRINT;           /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0664
         BALR  @14,@15                                             0664
*             BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE           */
         L     @07,ADPLBUF(,ABDPLPTR)                              0665
         MVC   BUFFER(5,@07),UNDER                                 0665
*             CALL PRINT;           /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0666
         BALR  @14,@15                                             0666
*             CALL PRINT;           /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0667
         BALR  @14,@15                                             0667
*             DO ARRAYCNT=1 TO DIM(SCANARY) WHILE(ERRSW=OFF);      0668
         LA    ARRAYCNT,1                                          0668
@DL00668 TM    ERRSW,B'10000000'                                   0668
         BNZ   @DC00668                                            0668
*               LINEPTR=SCANARY(ARRAYCNT);/* FORMAT PATTERN ADDR     */
         LR    @07,ARRAYCNT                                        0669
         SLA   @07,2                                               0669
         L     LINEPTR,SCANARY-4(@07)                              0669
*               CALL CONVERT;       /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0670
*               CALL FMTRTN;        /* FORMAT                        */
         BAL   @14,FMTRTN                                          0671
*             END;                  /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0672
         CH    ARRAYCNT,@CH00068                                   0672
         BNH   @DL00668                                            0672
@DC00668 DS    0H                                                  0673
*           END;                    /* END FOUND VALID IOB           */
*         ELSE                                                     0674
*           ;                       /* NOT A VALID IOB               */
@RF00661 DS    0H                                                  0675
*       END;                        /* END QISAM SCAN                */
*     ELSE                          /* NOT QISAM SCAN                */
*                                                                  0676
*       /*************************************************************/
*       /*                                                           */
*       /* SAM OR BPAM NORMAL SCHEDULING TYPE IOBS                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0676
*       IF SAMNMAL=ON THEN          /* SAM NORMAL SCHEDULING         */
         B     @RC00658                                            0676
@RF00658 TM    SAMNMAL(ABDPLPTR),B'00001000'                       0676
         BNO   @RF00676                                            0676
*         DO;                                                      0677
*           CALL BACKCHK;           /* CHECK IF IOB IS VALID         */
         BAL   @14,BACKCHK                                         0678
*           IF ERRSW=OFF THEN       /* VALID IOB                     */
         TM    ERRSW,B'10000000'                                   0679
         BNZ   @RF00679                                            0679
*             DO;                                                  0680
*               HDRTYPE(1:LENGTH(NMALIOB))=NMALIOB;/* FILL IN TYPE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0681
         MVC   HDRTYPE(28,@07),NMALIOB                             0681
*               CALL PRINT;         /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0682
         BALR  @14,@15                                             0682
*               BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE         */
         L     @07,ADPLBUF(,ABDPLPTR)                              0683
         MVC   BUFFER(5,@07),UNDER                                 0683
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0684
         BALR  @14,@15                                             0684
*               CALL PRINT;         /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0685
         BALR  @14,@15                                             0685
*               DO ARRAYCNT=1 TO DIM(NMALARY) WHILE(ERRSW=OFF);    0686
         LA    ARRAYCNT,1                                          0686
@DL00686 TM    ERRSW,B'10000000'                                   0686
         BNZ   @DC00686                                            0686
*                 LINEPTR=NMALARY(ARRAYCNT);/* FORMAT PATTERN ADDR   */
         LR    @07,ARRAYCNT                                        0687
         SLA   @07,2                                               0687
         L     LINEPTR,NMALARY-4(@07)                              0687
*                 CALL CONVERT;     /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0688
*                 CALL FMTRTN;      /* FORMAT                        */
         BAL   @14,FMTRTN                                          0689
*               END;                /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0690
         CH    ARRAYCNT,@CH00130                                   0690
         BNH   @DL00686                                            0690
@DC00686 DS    0H                                                  0691
*             END;                  /* END VALID IOB                 */
*           ELSE                                                   0692
*             ;                     /* NOT A VALID IOB               */
@RF00679 DS    0H                                                  0693
*         END;                      /* END SAM NORMAL SCHEDULING     */
*       ELSE                        /* NOT SAM NORMAL SCHEDULING     */
*                                                                  0694
*         /***********************************************************/
*         /*                                                         */
*         /* SAM OR BPAM CHAINED SCHEDULING TYPE MAIN IOB            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0694
*         IF SAMCHAIN=ON THEN       /* SAM CHAIN SCHEDULING          */
         B     @RC00676                                            0694
@RF00676 TM    SAMCHAIN(ABDPLPTR),B'00000100'                      0694
         BNO   @RF00694                                            0694
*           DO;                                                    0695
*             IF CHAINIOB=ON THEN   /* THE MAIN IOB IS TO BE       0696
*                                      FORMATTED                     */
         TM    CHAINIOB(ABDPLPTR),B'00001000'                      0696
         BNO   @RF00696                                            0696
*               DO;                                                0697
*                 CALL BACKCHK;     /* CHECK BACKPTR OF IOB          */
         BAL   @14,BACKCHK                                         0698
*                 IF ERRSW=OFF THEN /* VALID IOB                     */
         TM    ERRSW,B'10000000'                                   0699
         BNZ   @RF00699                                            0699
*                   DO;                                            0700
*                     HDRTYPE(1:LENGTH(IOBCHAIN))=IOBCHAIN;/* FILL IN
*                                      TYPE                          */
         L     @07,ADPLBUF(,ABDPLPTR)                              0701
         MVC   HDRTYPE(29,@07),IOBCHAIN                            0701
*                     CALL PRINT;   /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0702
         BALR  @14,@15                                             0702
*                     BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0703
         MVC   BUFFER(5,@07),UNDER                                 0703
*                     CALL PRINT;   /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0704
         BALR  @14,@15                                             0704
*                     CALL PRINT;   /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0705
         BALR  @14,@15                                             0705
*                     DO ARRAYCNT=1 TO DIM(CHAINARY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0706
@DL00706 TM    ERRSW,B'10000000'                                   0706
         BNZ   @DC00706                                            0706
*                       LINEPTR=CHAINARY(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0707
         SLA   @07,2                                               0707
         L     LINEPTR,CHAINARY-4(@07)                             0707
*                       CALL CONVERT;/* GENERATE OFFSET              */
         BAL   @14,CONVERT                                         0708
*                       CALL FMTRTN;/* FORMAT                        */
         BAL   @14,FMTRTN                                          0709
*                     END;          /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0710
         CH    ARRAYCNT,@CH00130                                   0710
         BNH   @DL00706                                            0710
@DC00706 DS    0H                                                  0711
*                   END;            /* END VALID IOB                 */
*                 ELSE                                             0712
*                   ;               /* INVALID IOB                   */
@RF00699 DS    0H                                                  0713
*               END;                /* END MAIN IOB TO BE FORMATTED  */
*                                                                  0713
*             /*******************************************************/
*             /*                                                     */
*             /* SAM OR BPAM CHAINED SCHEDULING - ICB TO BE FORMATTED*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0714
*             ELSE                  /* FORMAT AN ICB                 */
*               DO;                                                0714
         B     @RC00696                                            0714
@RF00696 DS    0H                                                  0715
*                 ADPLCOM1=ADDR(ICBMSG);/* ICB ERROR MESSAGE         */
         LA    @07,ICBMSG                                          0715
         ST    @07,ADPLCOM1(,ABDPLPTR)                             0715
*                 BUFFER(1:LENGTH(ICBHDR))=ICBHDR;/* ICB TITLE       */
         L     @07,ADPLBUF(,ABDPLPTR)                              0716
         MVC   BUFFER(5,@07),ICBHDR                                0716
*                 HDRTYPE(1:LENGTH(ICB))=ICB;/* FILL IN TYPE         */
         MVC   HDRTYPE(29,@07),ICB                                 0717
*                 CALL PRINT;       /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0718
         BALR  @14,@15                                             0718
*                 BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE       */
         L     @07,ADPLBUF(,ABDPLPTR)                              0719
         MVC   BUFFER(5,@07),UNDER                                 0719
*                 CALL PRINT;       /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0720
         BALR  @14,@15                                             0720
*                 CALL PRINT;       /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0721
         BALR  @14,@15                                             0721
*                 DO ARRAYCNT=1 TO DIM(ICBARY) WHILE(ERRSW=OFF);   0722
         LA    ARRAYCNT,1                                          0722
@DL00722 TM    ERRSW,B'10000000'                                   0722
         BNZ   @DC00722                                            0722
*                   LINEPTR=ICBARY(ARRAYCNT);/* FORMAT PATTERN ADDR  */
         LR    @07,ARRAYCNT                                        0723
         SLA   @07,2                                               0723
         L     LINEPTR,ICBARY-4(@07)                               0723
*                   CALL CONVERT;   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0724
*                   CALL FMTRTN;    /* FORMAT                        */
         BAL   @14,FMTRTN                                          0725
*                 END;              /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0726
         CH    ARRAYCNT,@CH00130                                   0726
         BNH   @DL00722                                            0726
@DC00722 DS    0H                                                  0727
*               END;                /* END FORMAT ICB                */
*           END;                    /* END SAM CHAIN RESCHEDULING    */
*         ELSE                      /* NOT SAM CHAIN SCHEDULING      */
*                                                                  0729
*           /*********************************************************/
*           /*                                                       */
*           /* BDAM TYPE IOBS                                        */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0729
*           IF BDAMDCB=ON THEN      /* BDAM ACCESS METHOD            */
         B     @RC00694                                            0729
@RF00694 TM    BDAMDCB(ABDPLPTR),B'00000010'                       0729
         BNO   @RF00729                                            0729
*             DO;                                                  0730
*               CALL BACKCHK;       /* CHECK BACKPTR OF IOB          */
         BAL   @14,BACKCHK                                         0731
*               IF ERRSW=OFF THEN   /* VALID IOB                     */
         TM    ERRSW,B'10000000'                                   0732
         BNZ   @RF00732                                            0732
*                 DO;                                              0733
*                   HDRTYPE(1:LENGTH(BDAM))=BDAM;/* FILL IN TYPE     */
         L     @07,ADPLBUF(,ABDPLPTR)                              0734
         MVC   HDRTYPE(6,@07),BDAM                                 0734
*                   CALL PRINT;     /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0735
         BALR  @14,@15                                             0735
*                   BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE     */
         L     @07,ADPLBUF(,ABDPLPTR)                              0736
         MVC   BUFFER(5,@07),UNDER                                 0736
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0737
         BALR  @14,@15                                             0737
*                   CALL PRINT;     /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0738
         BALR  @14,@15                                             0738
*                   DO ARRAYCNT=1 TO DIM(BDAMIOB) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0739
@DL00739 TM    ERRSW,B'10000000'                                   0739
         BNZ   @DC00739                                            0739
*                     LINEPTR=BDAMIOB(ARRAYCNT);/* FORMAT PATTERN  0740
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0740
         SLA   @07,2                                               0740
         L     LINEPTR,BDAMIOB-4(@07)                              0740
*                     CALL CONVERT; /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0741
*                     CALL FMTRTN;  /* FORMAT                        */
         BAL   @14,FMTRTN                                          0742
*                   END;            /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0743
         CH    ARRAYCNT,@CH00357                                   0743
         BNH   @DL00739                                            0743
@DC00739 DS    0H                                                  0744
*                 END;              /* END VALID IOB                 */
*               ELSE                                               0745
*                 ;                 /* NO A VALID IOB                */
@RF00732 DS    0H                                                  0746
*             END;                  /* END BDAM IOBS                 */
*           ELSE                    /* NOT BDAM                      */
*                                                                  0747
*             /*******************************************************/
*             /*                                                     */
*             /* BTAM TYPE IOBS                                      */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0747
*             IF BTAMDCB=ON THEN    /* BTAM ACCESS METHOD            */
         B     @RC00729                                            0747
@RF00729 TM    BTAMDCB(ABDPLPTR),B'00000001'                       0747
         BNO   @RF00747                                            0747
*               DO;                                                0748
*                 CALL BACKCHK;     /* VERIFY THE IOB                */
         BAL   @14,BACKCHK                                         0749
*                 IF ERRSW=OFF THEN /* VALID IOB                     */
         TM    ERRSW,B'10000000'                                   0750
         BNZ   @RF00750                                            0750
*                   DO;                                            0751
*                     HDRTYPE(1:LENGTH(BTAM))=BTAM;/* FILL IN TYPE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0752
         MVC   HDRTYPE(6,@07),BTAM                                 0752
*                     CALL PRINT;   /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0753
         BALR  @14,@15                                             0753
*                     BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0754
         MVC   BUFFER(5,@07),UNDER                                 0754
*                     CALL PRINT;   /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0755
         BALR  @14,@15                                             0755
*                     CALL PRINT;   /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0756
         BALR  @14,@15                                             0756
*                     DO ARRAYCNT=1 TO DIM(BTAMIOB) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0757
@DL00757 TM    ERRSW,B'10000000'                                   0757
         BNZ   @DC00757                                            0757
*                       LINEPTR=BTAMIOB(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0758
         SLA   @07,2                                               0758
         L     LINEPTR,BTAMIOB-4(@07)                              0758
*                       CALL CONVERT;/* GENERATE OFFSET              */
         BAL   @14,CONVERT                                         0759
*                       CALL FMTRTN;/* FORMAT                        */
         BAL   @14,FMTRTN                                          0760
*                     END;          /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0761
         CH    ARRAYCNT,@CH00068                                   0761
         BNH   @DL00757                                            0761
@DC00757 DS    0H                                                  0762
*                   END;            /* END VALID IOB                 */
*                 ELSE                                             0763
*                   ;               /* NOT A VALID IOB               */
@RF00750 DS    0H                                                  0764
*               END;                /* END BTAM ACCESS METHOD        */
*             ELSE                  /* NOT BTAM                      */
*                                                                  0765
*               /*****************************************************/
*               /*                                                   */
*               /* GAM TYPE IOBS                                     */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0765
*               IF GAMDCB=ON THEN   /* GAM ACCESS METHOD             */
         B     @RC00747                                            0765
@RF00747 TM    GAMDCB(ABDPLPTR),B'10000000'                        0765
         BNO   @RF00765                                            0765
*                 DO;                                              0766
*                   CALL BACKCHK;   /* VERIFY THE IOB                */
         BAL   @14,BACKCHK                                         0767
*                   IF ERRSW=OFF THEN/* VALID IOB                    */
         TM    ERRSW,B'10000000'                                   0768
         BNZ   @RF00768                                            0768
*                     DO;                                          0769
*                       HDRTYPE(1:LENGTH(GAM))=GAM;/* FILL IN TYPE   */
         L     @07,ADPLBUF(,ABDPLPTR)                              0770
         MVC   HDRTYPE(5,@07),GAM                                  0770
*                       CALL PRINT; /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0771
         BALR  @14,@15                                             0771
*                       BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE */
         L     @07,ADPLBUF(,ABDPLPTR)                              0772
         MVC   BUFFER(5,@07),UNDER                                 0772
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0773
         BALR  @14,@15                                             0773
*                       CALL PRINT; /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0774
         BALR  @14,@15                                             0774
*                       DO ARRAYCNT=1 TO DIM(GAMIOB) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0775
@DL00775 TM    ERRSW,B'10000000'                                   0775
         BNZ   @DC00775                                            0775
*                         LINEPTR=GAMIOB(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0776
         SLA   @07,2                                               0776
         L     LINEPTR,GAMIOB-4(@07)                               0776
*                         CALL CONVERT;/* GENERATE OFFSET            */
         BAL   @14,CONVERT                                         0777
*                         CALL FMTRTN;/* FORMAT                      */
         BAL   @14,FMTRTN                                          0778
*                       END;        /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0779
         CH    ARRAYCNT,@CH00357                                   0779
         BNH   @DL00775                                            0779
@DC00775 DS    0H                                                  0780
*                     END;          /* END VALID IOB                 */
*                   ELSE                                           0781
*                     ;             /* NO A VALID IOB                */
@RF00768 DS    0H                                                  0782
*                 END;              /* END GAM                       */
*               ELSE                /* NOT GAM                       */
*                                                                  0783
*                 /***************************************************/
*                 /*                                                 */
*                 /* TCAM LINE GROUP LCBS - FORMATTED ONLY UNDER     */
*                 /* AMDPRDMP - SNAP ALREADY HAS FORMATTED THEM      */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0783
*                 IF TCAMLINE=ON THEN/* TCAM LINE GROUP ACCESS METHOD*/
         B     @RC00765                                            0783
@RF00765 TM    TCAMLINE(ABDPLPTR),B'01000000'                      0783
         BNO   @RF00783                                            0783
*                   IF ADPLSNPR=ON THEN/* PRINT DUMP IS THE        0784
*                                      INVOKER-FORMAT                */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0784
         BNO   @RF00784                                            0784
*                     DO;                                          0785
*                       ADPLCOM1=ADDR(LCBMSG);/* LCB ERROR MESSGAE   */
         LA    @07,LCBMSG                                          0786
         ST    @07,ADPLCOM1(,ABDPLPTR)                             0786
*                       BUFFER(1:LENGTH(LCBHDR))=LCBHDR;           0787
         L     @07,ADPLBUF(,ABDPLPTR)                              0787
         MVC   BUFFER(5,@07),LCBHDR                                0787
*                       HDRTYPE(1:LENGTH(LINEGRP))=LINEGRP;/* FILL IN
*                                      TYPE                          */
         MVC   HDRTYPE(17,@07),LINEGRP                             0788
*                       CALL PRINT; /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0789
         BALR  @14,@15                                             0789
*                       BUFFER(1:LENGTH(UNDER))=UNDER;/* UNDER SCORE */
         L     @07,ADPLBUF(,ABDPLPTR)                              0790
         MVC   BUFFER(5,@07),UNDER                                 0790
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0791
         BALR  @14,@15                                             0791
*                       CALL PRINT; /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0792
         BALR  @14,@15                                             0792
*                       DO ARRAYCNT=1 TO DIM(TCAMARY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0793
@DL00793 TM    ERRSW,B'10000000'                                   0793
         BNZ   @DC00793                                            0793
*                         LINEPTR=TCAMARY(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @07,ARRAYCNT                                        0794
         SLA   @07,2                                               0794
         L     LINEPTR,TCAMARY-4(@07)                              0794
*                         CALL CONVERT;/* GENERATE OFFSET            */
         BAL   @14,CONVERT                                         0795
*                         CALL FMTRTN;/* FORMAT                      */
         BAL   @14,FMTRTN                                          0796
*                       END;        /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0797
         CH    ARRAYCNT,@CH00047                                   0797
         BNH   @DL00793                                            0797
@DC00793 DS    0H                                                  0798
*                     END;          /* NEED TO FORMAT TCAM           */
*                   ELSE            /* SNAP WAS INVOKER              */
*                     BUFFER=BLANKS;/* BLANK OUT HDR LINE            */
         B     @RC00784                                            0799
@RF00784 L     @07,ADPLBUF(,ABDPLPTR)                              0799
         MVC   BUFFER(120,@07),BLANKS                              0799
*                 ELSE              /* NOT TCAM                      */
*                                                                  0800
*                   /*************************************************/
*                   /*                                               */
*                   /* THE ACCESS METHOD WAS ONE THAT DID NOT CALL   */
*                   /* FOR AN IOB AND SHOULD NEVER HAVE ENTERED THIS */
*                   /* CODE                                          */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0800
*                   BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE */
         B     @RC00783                                            0800
@RF00783 L     @07,ADPLBUF(,ABDPLPTR)                              0800
         MVC   BUFFER(120,@07),IOBERR                              0800
*   CALL PRINT;                     /* ERROR MSG OR BLANK LINE       */
@RC00783 DS    0H                                                  0801
@RC00765 DS    0H                                                  0801
@RC00747 DS    0H                                                  0801
@RC00729 DS    0H                                                  0801
@RC00694 DS    0H                                                  0801
@RC00676 DS    0H                                                  0801
@RC00658 DS    0H                                                  0801
@RC00640 L     @15,ADPLPRNT(,ABDPLPTR)                             0801
         BALR  @14,@15                                             0801
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS RETRY REGS    */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0802
*   RETURN CODE(RCCODE);                                           0803
         L     @13,4(,@13)                                         0803
         L     @00,@SIZDATD                                        0803
         LR    @01,@10                                             0803
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@09                                             0803
         L     @14,12(,@13)                                        0803
         LM    @00,@12,20(@13)                                     0803
         BR    @14                                                 0803
*BACKCHK:                                                          0804
*   PROC OPTIONS(SAVE(14));                                        0804
*                                                                  0804
BACKCHK  ST    @14,@SA00002                                        0804
*/********************************************************************/
*/* FUNCTION -                                                     0805
*      ROUTINE TO DETERMINE IF AN IOB IS STILL VALID BY CHECKING   0805
*      ITS POINTER TO THE DCB. IF THIS MATCHES THAT PASSED BY THE  0805
*      CALLER THE IOB IS VALID. IF THE DCB POINTER DOES NOT MATCH  0805
*      OR IF THE IOB COULD NOT BE ACCESSED, AN ERROR MESSAGE IS PRINTED
*      AN THE ERROR SWITCH IS SET ON TO INHIBIT FURTHER IOB PROCESSING.
*                                                                  0805
*   INPUT -                                                        0805
*      DCBPTR MUST HAVE THE ADDRESS OF THE DCB POINTING TO THESE IOBS,
*      AND  REGISTER 1 POINTS TO THE PARMLIST PASSED BY THE CALLER.
*                                                                  0805
*   CALLS -                                                        0805
*      ACCESRTN AND PRINT                                          0805
*                                                                  0805
*   CALLED BY -                                                    0805
*      IECDAIOB                                                    0805
*                                                                  0805
*   RETURNS TO -                                                   0805
*      CALLER WITH RETURN CODE SET BY THE ACCESS SERVICE ROUTINE AND
*      THE ERRSW SET APPROPRIATLY.                                 0805
*                                                                    */
*/********************************************************************/
*                                                                  0805
*   VADR=ADDR(IOBDCBPT);            /* BACK PTR TO DCB               */
         LA    VADR,IOBDCBPT(,IOBSTPTR)                            0805
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0806
*   IF RCREG^=ZERO|DCBPTR^=DATAADR THEN/* COULD NOT ACCESS IOB OR  0807
*                                      BACKPTR INVALID               */
         LTR   RCREG,RCREG                                         0807
         BNZ   @RT00807                                            0807
         L     @06,DATAPTR                                         0807
         SLR   @05,@05                                             0807
         ICM   @05,7,DATAADR(@06)                                  0807
         CR    DCBPTR,@05                                          0807
         BE    @RF00807                                            0807
@RT00807 DS    0H                                                  0808
*     DO;                                                          0808
*       BUFFER(1:LENGTH(IOBERR))=IOBERR;/* ERROR MESSAGE             */
         L     @07,ADPLBUF(,ABDPLPTR)                              0809
         MVC   BUFFER(120,@07),IOBERR                              0809
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0810
         BALR  @14,@15                                             0810
*       RCCODE=NOIOB;               /* INHIBIT FURTHER IOB PROCESSING*/
         LA    RCCODE,4                                            0811
*       ERRSW=ON;                   /* TERMINATE LOOP                */
         OI    ERRSW,B'10000000'                                   0812
*     END;                          /* END ACCESS ERROR              */
*   ELSE                                                           0814
*     ;                             /* FOUND CORRECT DCB ADDRESS     */
@RF00807 DS    0H                                                  0815
*   END BACKCHK;                                                   0815
@EL00002 DS    0H                                                  0815
@EF00002 DS    0H                                                  0815
@ER00002 L     @14,@SA00002                                        0815
         BR    @14                                                 0815
*CONVERT:                                                          0816
*   PROC OPTIONS(SAVE(14));                                        0816
*                                                                  0816
CONVERT  ST    @14,12(,@13)                                        0816
*/********************************************************************/
*/* FUNCTION -                                                     0817
*      ROUTINE TO DYNAMICALLY GENERATE THE OFFSETS TO BE PUT ALONGSIDE
*      THE CONTROL BLOCK LINE.  IT FIGURES THE OFFSET FROM THE     0817
*      BEGINNING OF THE CONTROL BLOCK, CONVERTS IT TO PRINTABLE HEX,
*      PLACES IT INTO A BUFFER AREA AND PUTS THE ADDRESS OF THIS   0817
*      BUFFER AREA INTO THE PARAMETER LIST TO BE PICKED UP IN THE  0817
*      FORMAT PATTERNS BY THE FORMAT SERVICE ROUTINE.              0817
*                                                                  0817
*   NOTE  -                                                        0817
*      THIS CODE COMPARES THE ADDRESSES WITH THE HIGH ORDER BYTE   0817
*      OFF, SINCE ALL CODE IS NOT 31 BIT ADDRESSING AND SOME POINTERS
*      HAVE BITS SET IN THE HIGH ORDER BYTE OF THE ADDRESS.        0817
*                                                                  0817
*   INPUT -                                                        0817
*      SAVEPTR MUST HAVE THE ADDRESS OF THE BEGINNING OF THE CONTROL
*      BLOCK, REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE 0817
*      CURRENT CONTROL BLOCK ADDRESS IN ADPLFMT2.                  0817
*                                                                  0817
*   CALLS -                                                        0817
*      MAKES NO OUTSIDE CALLS                                      0817
*                                                                  0817
*   CALLED BY -                                                    0817
*      IECIOEXD,IECIOUCB                                           0817
*                                                                  0817
*   RETURNS TO -                                                   0817
*      CALLER WITHOUT SETTING A RETURN CODE                        0817
*                                                                    */
*/********************************************************************/
*                                                                  0817
*   IF SAVEPTR>ADPLFMT2 THEN        /* THIS WILL OCCUR FOR A PREFIX
*                                      WITH A NEGATIVE OFFSET        */
         L     @05,SAVEPTR                                         0817
         L     @04,ADPLFMT2(,ABDPLPTR)                             0817
         CR    @05,@04                                             0817
         BNH   @RF00817                                            0817
*     DO;                                                          0818
*       NEGBIT=ON;                  /* INDICATE NEGATIVE OFFSET      */
         OI    NEGBIT,B'10000000'                                  0819
*       CONVRT=SAVEPTR-ADPLFMT2;    /* NEGATIVE OFFSET VALUE         */
         SLR   @05,@04                                             0820
         ST    @05,CONVRT                                          0820
*     END;                          /* END NEGATIVE OFFSET           */
*   ELSE                            /* POSITIVE OR ZERO OFFSET       */
*     DO;                                                          0822
         B     @RC00817                                            0822
@RF00817 DS    0H                                                  0823
*       NEGBIT=OFF;                 /* INDICATE POS VALUE            */
         NI    NEGBIT,B'01111111'                                  0823
*       CONVRT=ADPLFMT2-SAVEPTR;    /* RELATIVE OFFSET IN CONTROL  0824
*                                      BLOCK                         */
         L     @05,ADPLFMT2(,ABDPLPTR)                             0824
         SL    @05,SAVEPTR                                         0824
         ST    @05,CONVRT                                          0824
*     END;                          /* END POS VALUE                 */
*   DIGIT=BLANKS(1:5);              /* BLANK OUT DIGITS              */
@RC00817 MVC   DIGIT(5),BLANKS                                     0826
*   PACKAREA=CONVRT;                /* PLACE OFFSET INTO CHAR AREA 0827
*                                      FOR THE UNPACK                */
         L     @05,CONVRT                                          0827
         ST    @05,PACKAREA                                        0827
*   GARBAGE='04'X;                  /* GARBAGE BYTE SO OFFSET WILL 0828
*                                      UNPACK OK                     */
*                                                                  0828
         MVI   GARBAGE,X'04'                                       0828
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR AN ODD NUMBER OF DIGITS THE OUTPUT SHOULD LOOK LIKE +C OR */
*   /* +13C. IF THE VALUE WAS UNPACKED DIRECTLY INTO DIGITS THE      */
*   /* OUTPUT WOULD HAVE UNWANTED LEADING ZEROS SUCH AS +0C. TO      */
*   /* ELIMINATE THIS(ONLY FOR AN ODD NUMBER OF DIGITS) UNPACK ODD   */
*   /* NUMBER OF DIGITS INTO CONVERTD WHERE THE LEADING ZERO WILL BE */
*   /* OVERWRITTEN BY THE '+' OR '-' SIGN                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0829
*   IF CONVRT<TWODGT THEN           /* ONLY 1 DIGIT TO OFFSET        */
         CH    @05,@CH00082                                        0829
         BNL   @RF00829                                            0829
*     UNPK(CONVERTD(1:3),UNPACK(4:5));/* UNPACK ONLY 1 DIGIT AND   0830
*                                      DUMMY                         */
         UNPK  CONVERTD(3),UNPACK+3(2)                             0830
*   ELSE                                                           0831
*     IF CONVRT<THREDGT THEN        /* 2 DIGITS TO OFFSET            */
         B     @RC00829                                            0831
@RF00829 L     @05,CONVRT                                          0831
         CH    @05,@CH01720                                        0831
         BNL   @RF00831                                            0831
*       UNPK(DIGIT(1:3),UNPACK(4:5));/* UNPACK LAST 2 DIGITS & DUMMY */
         UNPK  DIGIT(3),UNPACK+3(2)                                0832
*     ELSE                                                         0833
*       IF CONVRT<FOURDGT THEN      /* 3 DIGITS TO OFFSET            */
         B     @RC00831                                            0833
@RF00831 L     @05,CONVRT                                          0833
         CH    @05,@CH01664                                        0833
         BNL   @RF00833                                            0833
*         UNPK(CONVERTD(1:5),UNPACK(3:5));/* UNPACK LAST 3 DIGITS &
*                                      DUMMY                         */
         UNPK  CONVERTD(5),UNPACK+2(3)                             0834
*       ELSE                        /* 4 DIGITS (MAX)                */
*         UNPK(DIGIT(1:5),UNPACK(3:5));/* LAST 4 DIGITS & DUMMY BYTE */
         B     @RC00833                                            0835
@RF00833 UNPK  DIGIT(5),UNPACK+2(3)                                0835
*   TR(DIGIT,TRANS);                /* MAKE PRINTABLE                */
@RC00833 DS    0H                                                  0836
@RC00831 DS    0H                                                  0836
@RC00829 TR    DIGIT(5),TRANS                                      0836
*   IF NEGBIT=ON THEN               /* WAS A NEGATIVE OFFSET         */
         TM    NEGBIT,B'10000000'                                  0837
         BNO   @RF00837                                            0837
*     PLUS=NEGCHAR;                 /* MINUS SIGN                    */
         MVI   PLUS,C'-'                                           0838
*   ELSE                            /* POSITIVE OFFSET               */
*     PLUS=PLUSCHAR;                /* MOVE IN PLUS SIGN             */
         B     @RC00837                                            0839
@RF00837 MVI   PLUS,C'+'                                           0839
*   ADPLFMT1=ADDR(CONVERTD);        /* SET UP FOR FORMAT             */
@RC00837 LA    @05,CONVERTD                                        0840
         ST    @05,ADPLFMT1(,ABDPLPTR)                             0840
*   END CONVERT;                                                   0841
@EL00003 DS    0H                                                  0841
@EF00003 DS    0H                                                  0841
@ER00003 L     @14,12(,@13)                                        0841
         BR    @14                                                 0841
*FMTRTN:                                                           0842
*   PROC OPTIONS(SAVE(14));                                        0842
*                                                                  0842
FMTRTN   ST    @14,@SA00004                                        0842
*/****************************************************************** */
*/* FUNCTION                                                       0843
*       ROUTINE TO SET UP CALLING OF THE FORMAT SERVICE ROUTINE PASSED
*     IN THE PARMLIST AND CHECKS RETURN CODE.  IF A RETURN CODE IS BAD
*     IT TAKES THE MESSAGE WHOSE ADDRESS IS IN ADPLCOM1. AND PUTS IT
*     IN THE BUFFER AND PRINTS IT. IT SETS THE ERRSW TO INDICATE BAD
*     RETURN CODE AND RETURNS. IF THE RETURN CODE WAS GOOD, IT PRINTS
*     THE FORMATTED LINE.                                          0843
*                                                                  0843
*   CALLS-                                                         0843
*       CALLS FORMAT AND PRINT                                     0843
*                                                                  0843
*   INPUT -                                                        0843
*     LINEPTR(REGISTER 0) HAS THE ADDRESS OF THE FORMAT PATTERN TO BE
*    PASSED TO THE FORMAT SERVICE ROUTINE. ADPLFMT2 CONTAINS THE CURREN
*    ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED AND ,IN MOST CASES,
*    ADPLFMT1 CONTAINS THE ADDRESS OF THE FIELD 'CONVERTD' WHICH IS
*    THE EBCDIC REPRESENTATION OF THE OFFSET TO BE PLACED ALONG SIDE
*    THE OUTPUT LINE.                                              0843
*                                                                  0843
*   CALLED BY -                                                    0843
*     IECIOEXD,IECIOUCB                                            0843
*                                                                  0843
*   RETURNS CONTROL TO -                                           0843
*     CALLER WITH RETURN CODE RECIEVED FROM FORMAT                 0843
*     SERVICE ROUTINE                                              0843
*                                                                    */
*/****************************************************************** */
*                                                                  0843
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS THE INVOKER          */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0843
         BNZ   @RF00843                                            0843
*     DO;                           /* PROTECTION IS NEEDED FROM THE
*                                      FORMAT SERVICE ROUTINE        */
*       RTYADR=ADDR(FMTRTY);        /* WHERE TO RETRY FROM THE ESTAE */
         LA    @05,FMTRTY                                          0845
         ST    @05,RTYADR(,ESTAPTR)                                0845
*       ERREXP=ON;                  /* INDICATE ERROR IS EXPECTED    */
         OI    ERREXP(ESTAPTR),B'10000000'                         0846
*     END;                          /* END SNAP WAS INVOKER          */
*   ELSE                                                           0848
*     ;                             /* SNAP WAS NOT INVOKER          */
@RF00843 DS    0H                                                  0849
*   CALL FORMAT;                    /* FORMAT ROUTINE PASSED BY    0849
*                                      CALLER                        */
         L     @15,ADPLFRMT(,ABDPLPTR)                             0849
         BALR  @14,@15                                             0849
*   ERREXP=OFF;                     /* ERROR IS NO LONGER EXPECTED   */
         NI    ERREXP(ESTAPTR),B'01111111'                         0850
*   IF RCREG^=ZERO THEN                                            0851
         LTR   RCREG,RCREG                                         0851
         BZ    @RF00851                                            0851
*     DO;                           /* FORMAT ROUTINE ERROR          */
*FMTRTY:                            /* RETRY ADDR FROM ESTAE         */
*       ERRSW=ON;                   /* SET ERROR INDICATOR           */
FMTRTY   OI    ERRSW,B'10000000'                                   0853
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0854
         BALR  @14,@15                                             0854
*       BUFFER=MSG;                 /* ERROR MSG PASSED BY CALLER  0855
*                                      WHOSE ADDR IS PLACED IN     0855
*                                      ADPLCOM1                      */
         L     @05,ADPLBUF(,ABDPLPTR)                              0855
         L     @04,ADPLCOM1(,ABDPLPTR)                             0855
         MVC   BUFFER(120,@05),MSG(@04)                            0855
*       RCREG=4;                    /* INDICATE FORMAT ROUTINE DID 0856
*                                      NOT COMPLETE SUCESSFULLY      */
         LA    RCREG,4                                             0856
*     END;                          /* END FORMAT ROUTINE ERROR      */
*   ELSE                                                           0858
*     ;                             /* FORMATTED LINE IS IN BUFFER   */
@RF00851 DS    0H                                                  0859
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM FORMAT
*                                      SERVICE ROUTINE               */
         LR    RCCODE,RCREG                                        0859
*   CALL PRINT;                     /* PRINT THE ERROR MSG OR      0860
*                                      FORMATTED LINE                */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0860
         BALR  @14,@15                                             0860
*   RETURN CODE(RCCODE);                                           0861
         LR    @15,RCCODE                                          0861
@EL00004 DS    0H                                                  0861
@EF00004 DS    0H                                                  0861
@ER00004 L     @14,@SA00004                                        0861
         BR    @14                                                 0861
*   END FMTRTN;                                                    0862
*ACCESRTN:                                                         0863
*   PROC OPTIONS(SAVE(14));                                        0863
*                                                                  0863
ACCESRTN ST    @14,@SA00005                                        0863
*/********************************************************************/
*/* FUNCTION-                                                      0864
*       ROUTINE WHICH CALLS THE ACCESS SERVICE ROUTINE AND MOVES THE
*     VALUE RETURNED IN R0 INTO DATAPTR.                           0864
*                                                                  0864
*                                                                  0864
*   INPUT -                                                        0864
*         VADR(REGISTER 0) CONTAINS THE VIRTUAL ADDRESS OF THE FIELD
*         TO BE ACCESSED.                                          0864
*                                                                  0864
*    CALLS-                                                        0864
*         ACCESS SERVICE ROUTINE PASSED IN PARMLIST                0864
*                                                                  0864
*    CALLED BY -                                                   0864
*         IECIOEXD,IECIOUCB                                        0864
*                                                                  0864
*    RETURNS TO -                                                  0864
*         CALLER WITH THE RETURN CODE SET BY THE ACCESS            0864
*         SERVICE ROUTINE.                                         0864
*                                                                    */
*/********************************************************************/
*                                                                  0864
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS THE CALLER           */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0864
         BNZ   @RF00864                                            0864
*     DO;                                                          0865
*       RTYADR=ADDR(RETRY);         /* RETRY ADDR FOR ESTAE IN CASE
*                                      OF EXPECTED ERROR-SIMULATES 0866
*                                      PRINT DUMP                    */
         LA    @05,RETRY                                           0866
         ST    @05,RTYADR(,ESTAPTR)                                0866
*       DATAPTR=VADR;               /* PREPARE FOR A LOAD FROM THE 0867
*                                      DUMP INTO AN INTERNAL BUFFER  */
         ST    VADR,DATAPTR                                        0867
*       RCREG=ZERO;                 /* SUCCESS UNLESS OTHERWISE    0868
*                                      CHANGED                       */
         SLR   RCREG,RCREG                                         0868
*       ERREXP=ON;                  /* AN ERROR IS EXPECTED          */
         OI    ERREXP(ESTAPTR),B'10000000'                         0869
*       VERIFY=DATADWRD;            /* MOVE A DOUBLE WORD INTO THE 0870
*                                      BUFFER                        */
*                                                                  0870
         L     @05,DATAPTR                                         0870
         MVC   VERIFY(8),DATADWRD(@05)                             0870
*       /*************************************************************/
*       /*                                                           */
*       /* THIS MOVE WILL CAUSE AN ABEND IF THE DUMP DOES NOT CONTAIN*/
*       /* THIS AREA OR IF IT IS PROTECTED. IF AN ABEND OCCURS THE   */
*       /* ESTAE WILL GET CONTROL AND RETRY AT THE POINT WHICH SETS A*/
*       /* BAD RETURN CODE AND CONTINUES IN THE MAIN LINE. THIS THEN */
*       /* SIMULATES THE PRINT DUMP ACCESS ROUTINE. IF THE AREA ASKED*/
*       /* FOR IS IN THE DUMP. A DOUBLE WORD IS MOVED INTO AN        */
*       /* INTERNAL BUFFER TO PREVENT AN UNEXPECTED ERROR WHEN       */
*       /* REFERENCING THE AREA AGAIN                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0871
*       ERREXP=OFF;                 /* AN ERROR IS NO LONGER EXPECTED*/
         NI    ERREXP(ESTAPTR),B'01111111'                         0871
*       DATAPTR=ADDR(VERIFY);       /* BASE DATAWORD ON THE BUFFER   */
         LA    @05,VERIFY                                          0872
         ST    @05,DATAPTR                                         0872
*     END;                          /* END SNAP WAS CALLER           */
*   ELSE                            /* CALLER HAS OWN ACCESS ROUTINE */
*     DO;                                                          0874
         B     @RC00864                                            0874
@RF00864 DS    0H                                                  0875
*       CALL ACCESS;                /* ACCESS SERVICE ROUTINE PASSED
*                                      BY CALLER                     */
         L     @15,ADPLMEMA(,ABDPLPTR)                             0875
         BALR  @14,@15                                             0875
*       IF RCREG=ZERO THEN                                         0876
         LTR   RCREG,RCREG                                         0876
         BNZ   @RF00876                                            0876
*         DATAPTR=VADR;             /* SAVE PTR RETURNED BY ACCESS 0877
*                                      SERVICE ROUTINE               */
         ST    VADR,DATAPTR                                        0877
*       ELSE                        /* BAD RETURN CODE               */
*RETRY:                             /* RETRY ADDR FOR THE ESTAE      */
*         RCREG=4;                  /* SET BAD RETURN FOR THE      0878
*                                      MAINLINE                      */
         B     @RC00876                                            0878
@RF00876 DS    0H                                                  0878
RETRY    LA    RCREG,4                                             0878
*     END;                          /* END CALLER NOT SNAP           */
@RC00876 DS    0H                                                  0880
*   RCCODE=RCREG;                   /* SAVE RETURN CODE              */
@RC00864 LR    RCCODE,RCREG                                        0880
*   RETURN CODE(RCCODE);                                           0881
         LR    @15,RCCODE                                          0881
@EL00005 DS    0H                                                  0881
@EF00005 DS    0H                                                  0881
@ER00005 L     @14,@SA00005                                        0881
         BR    @14                                                 0881
*   END ACCESRTN;                                                  0882
*   END IECDAFT1                                                   0883
*                                                                  0883
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IEZIOB  )                                       */
*                                                                  0883
*       ;                                                          0883
@DATA    DS    0H
@CH00041 DC    H'1'
@CH00092 DC    H'2'
@CH00130 DC    H'3'
@CH00068 DC    H'4'
@CH00047 DC    H'5'
@CH00357 DC    H'6'
@CH01703 DC    H'36'
@CH01720 DC    H'256'
@CH01664 DC    H'4096'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@SA00005 DS    1F
@SA00004 DS    1F
@SA00002 DS    1F
IECDAFT1 CSECT
         DS    0F
@CF00070 DC    F'8'
@CH00070 EQU   @CF00070+2
@CF00082 DC    F'16'
@CH00082 EQU   @CF00082+2
@DATD    DSECT
         DS    0D
DEBDAPTR DS    A
DEBEXPTR DS    A
DEBSBPTR DS    A
IOBPRPTR DS    A
CONVRT   DS    F
DATAPTR  DS    A
PREFIX   DS    F
ENDPTR   DS    A
PREFXPTR DS    A
SAVEPTR  DS    A
DEBSIZE  DS    H
NUMLIST  DS    FL1
CONVERTD DS    CL6
         ORG   CONVERTD
PLUS     DS    CL1
DIGIT    DS    CL5
         ORG   CONVERTD+6
         DS    CL1
DSORGBIT DS    BL2
         ORG   DSORGBIT
DSGIS    DS    BL1
DSGPS    EQU   DSORGBIT+0
DSGDA    EQU   DSORGBIT+0
DSGCX    EQU   DSORGBIT+0
@NM00556 EQU   DSORGBIT+0
DSGPO    EQU   DSORGBIT+0
DSGU     EQU   DSORGBIT+0
DSGGS    DS    BL1
DSGTX    EQU   DSORGBIT+1
DSGTQ    EQU   DSORGBIT+1
@NM00557 EQU   DSORGBIT+1
ACBM     EQU   DSORGBIT+1
DSGTR    EQU   DSORGBIT+1
@NM00558 EQU   DSORGBIT+1
         ORG   DSORGBIT+2
ERRSW    DS    BL1
         DS    CL1
MACFBITS DS    BL2
         ORG   MACFBITS
MFECP    DS    BL1
MFFE     EQU   MACFBITS+0
MFAPG    EQU   MACFBITS+0
         ORG   MFAPG
MFRD     EQU   MFAPG+0
         ORG   MACFBITS+0
MFCI     EQU   MACFBITS+0
         ORG   MFCI
MFMVG    EQU   MFCI+0
         ORG   MACFBITS+0
MFLCG    EQU   MACFBITS+0
MFDBF    EQU   MACFBITS+0
MFCHK    EQU   MACFBITS+0
@NM00560 EQU   MACFBITS+0
         DS    CL1
MFWRT    EQU   MACFBITS+1
MFMVP    EQU   MACFBITS+1
MFLCP    EQU   MACFBITS+1
         ORG   MFLCP
MF5WD    EQU   MFLCP+0
         ORG   MACFBITS+1
MF4WD    EQU   MACFBITS+1
MF3WD    EQU   MACFBITS+1
MF1WD    EQU   MACFBITS+1
         ORG   MACFBITS+2
NEGBIT   DS    BL1
         DS    CL7
UNPACK   DS    CL5
         ORG   UNPACK
PACKAREA DS    CL4
GARBAGE  DS    CL1
         ORG   UNPACK+5
         DS    CL3
VERIFY   DS    CL8
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IECDAFT1 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CHAINMSK DC    XL1'04'
HASPTYPE DC    XL1'81'
ZEROBYTE DC    XL1'00'
         DS    CL1
DCBF1    DS    CL12
         ORG   DCBF1
@NM00035 DS    CL4
         ORG   @NM00035
@NM00036 DC    X'01'
@NM00037 DC    X'40'
@NM00038 DC    AL1(0)
@NM00039 DC    AL1(0)
         ORG   DCBF1+4
@NM00040 DS    CL4
         ORG   @NM00040
@NM00041 DC    X'04'
@NM00042 DC    X'03'
@NM00043 DC    AL1(0)
@NM00044 DC    AL1(8)
         ORG   DCBF1+8
@NM00045 DS    CL4
         ORG   @NM00045
@NM00046 DC    F'0'
         ORG   DCBF1+12
DCBF2    DS    CL16
         ORG   DCBF2
@NM00047 DS    CL4
         ORG   @NM00047
@NM00048 DC    X'01'
@NM00049 DC    X'40'
@NM00050 DC    AL1(0)
@NM00051 DC    AL1(0)
         ORG   DCBF2+4
@NM00052 DS    CL4
         ORG   @NM00052
@NM00053 DC    X'04'
@NM00054 DC    X'03'
@NM00055 DC    AL1(0)
@NM00056 DC    AL1(8)
         ORG   DCBF2+8
@NM00057 DS    CL4
         ORG   @NM00057
@NM00058 DC    X'04'
@NM00059 DC    X'03'
@NM00060 DC    AL1(0)
@NM00061 DC    AL1(17)
         ORG   DCBF2+12
@NM00062 DS    CL4
         ORG   @NM00062
@NM00063 DC    F'0'
         ORG   DCBF2+16
DCBF3    DS    CL20
         ORG   DCBF3
@NM00064 DS    CL4
         ORG   @NM00064
@NM00065 DC    X'01'
@NM00066 DC    X'40'
@NM00067 DC    AL1(0)
@NM00068 DC    AL1(0)
         ORG   DCBF3+4
@NM00069 DS    CL4
         ORG   @NM00069
@NM00070 DC    X'04'
@NM00071 DC    X'03'
@NM00072 DC    AL1(0)
@NM00073 DC    AL1(8)
         ORG   DCBF3+8
@NM00074 DS    CL4
         ORG   @NM00074
@NM00075 DC    X'04'
@NM00076 DC    X'03'
@NM00077 DC    AL1(0)
@NM00078 DC    AL1(17)
         ORG   DCBF3+12
@NM00079 DS    CL4
         ORG   @NM00079
@NM00080 DC    X'04'
@NM00081 DC    X'03'
@NM00082 DC    AL1(0)
@NM00083 DC    AL1(26)
         ORG   DCBF3+16
@NM00084 DS    CL4
         ORG   @NM00084
@NM00085 DC    F'0'
         ORG   DCBF3+20
DCBF4    DS    CL24
         ORG   DCBF4
@NM00086 DS    CL4
         ORG   @NM00086
@NM00087 DC    X'01'
@NM00088 DC    X'40'
@NM00089 DC    AL1(0)
@NM00090 DC    AL1(0)
         ORG   DCBF4+4
@NM00091 DS    CL4
         ORG   @NM00091
@NM00092 DC    X'04'
@NM00093 DC    X'03'
@NM00094 DC    AL1(0)
@NM00095 DC    AL1(8)
         ORG   DCBF4+8
@NM00096 DS    CL4
         ORG   @NM00096
@NM00097 DC    X'04'
@NM00098 DC    X'03'
@NM00099 DC    AL1(0)
@NM00100 DC    AL1(17)
         ORG   DCBF4+12
@NM00101 DS    CL4
         ORG   @NM00101
@NM00102 DC    X'04'
@NM00103 DC    X'03'
@NM00104 DC    AL1(0)
@NM00105 DC    AL1(26)
         ORG   DCBF4+16
@NM00106 DS    CL4
         ORG   @NM00106
@NM00107 DC    X'04'
@NM00108 DC    X'03'
@NM00109 DC    AL1(0)
@NM00110 DC    AL1(35)
         ORG   DCBF4+20
@NM00111 DS    CL4
         ORG   @NM00111
@NM00112 DC    F'0'
         ORG   DCBF4+24
DCBF5    DS    CL28
         ORG   DCBF5
@NM00113 DS    CL4
         ORG   @NM00113
@NM00114 DC    X'01'
@NM00115 DC    X'40'
@NM00116 DC    AL1(0)
@NM00117 DC    AL1(0)
         ORG   DCBF5+4
@NM00118 DS    CL4
         ORG   @NM00118
@NM00119 DC    X'04'
@NM00120 DC    X'03'
@NM00121 DC    AL1(0)
@NM00122 DC    AL1(8)
         ORG   DCBF5+8
@NM00123 DS    CL4
         ORG   @NM00123
@NM00124 DC    X'04'
@NM00125 DC    X'03'
@NM00126 DC    AL1(0)
@NM00127 DC    AL1(17)
         ORG   DCBF5+12
@NM00128 DS    CL4
         ORG   @NM00128
@NM00129 DC    X'04'
@NM00130 DC    X'03'
@NM00131 DC    AL1(0)
@NM00132 DC    AL1(26)
         ORG   DCBF5+16
@NM00133 DS    CL4
         ORG   @NM00133
@NM00134 DC    X'04'
@NM00135 DC    X'03'
@NM00136 DC    AL1(0)
@NM00137 DC    AL1(35)
         ORG   DCBF5+20
@NM00138 DS    CL4
         ORG   @NM00138
@NM00139 DC    X'04'
@NM00140 DC    X'03'
@NM00141 DC    AL1(0)
@NM00142 DC    AL1(44)
         ORG   DCBF5+24
@NM00143 DS    CL4
         ORG   @NM00143
@NM00144 DC    F'0'
         ORG   DCBF5+28
DCBF6    DS    CL32
         ORG   DCBF6
@NM00145 DS    CL4
         ORG   @NM00145
@NM00146 DC    X'01'
@NM00147 DC    X'40'
@NM00148 DC    AL1(0)
@NM00149 DC    AL1(0)
         ORG   DCBF6+4
@NM00150 DS    CL4
         ORG   @NM00150
@NM00151 DC    X'04'
@NM00152 DC    X'03'
@NM00153 DC    AL1(0)
@NM00154 DC    AL1(8)
         ORG   DCBF6+8
@NM00155 DS    CL4
         ORG   @NM00155
@NM00156 DC    X'04'
@NM00157 DC    X'03'
@NM00158 DC    AL1(0)
@NM00159 DC    AL1(17)
         ORG   DCBF6+12
@NM00160 DS    CL4
         ORG   @NM00160
@NM00161 DC    X'04'
@NM00162 DC    X'03'
@NM00163 DC    AL1(0)
@NM00164 DC    AL1(26)
         ORG   DCBF6+16
@NM00165 DS    CL4
         ORG   @NM00165
@NM00166 DC    X'04'
@NM00167 DC    X'03'
@NM00168 DC    AL1(0)
@NM00169 DC    AL1(35)
         ORG   DCBF6+20
@NM00170 DS    CL4
         ORG   @NM00170
@NM00171 DC    X'04'
@NM00172 DC    X'03'
@NM00173 DC    AL1(0)
@NM00174 DC    AL1(44)
         ORG   DCBF6+24
@NM00175 DS    CL4
         ORG   @NM00175
@NM00176 DC    X'04'
@NM00177 DC    X'03'
@NM00178 DC    AL1(0)
@NM00179 DC    AL1(53)
         ORG   DCBF6+28
@NM00180 DS    CL4
         ORG   @NM00180
@NM00181 DC    F'0'
         ORG   DCBF6+32
DCBF8    DS    CL40
         ORG   DCBF8
@NM00182 DS    CL4
         ORG   @NM00182
@NM00183 DC    X'01'
@NM00184 DC    X'40'
@NM00185 DC    AL1(0)
@NM00186 DC    AL1(0)
         ORG   DCBF8+4
@NM00187 DS    CL4
         ORG   @NM00187
@NM00188 DC    X'04'
@NM00189 DC    X'03'
@NM00190 DC    AL1(0)
@NM00191 DC    AL1(8)
         ORG   DCBF8+8
@NM00192 DS    CL4
         ORG   @NM00192
@NM00193 DC    X'04'
@NM00194 DC    X'03'
@NM00195 DC    AL1(0)
@NM00196 DC    AL1(17)
         ORG   DCBF8+12
@NM00197 DS    CL4
         ORG   @NM00197
@NM00198 DC    X'04'
@NM00199 DC    X'03'
@NM00200 DC    AL1(0)
@NM00201 DC    AL1(26)
         ORG   DCBF8+16
@NM00202 DS    CL4
         ORG   @NM00202
@NM00203 DC    X'04'
@NM00204 DC    X'03'
@NM00205 DC    AL1(0)
@NM00206 DC    AL1(35)
         ORG   DCBF8+20
@NM00207 DS    CL4
         ORG   @NM00207
@NM00208 DC    X'04'
@NM00209 DC    X'03'
@NM00210 DC    AL1(0)
@NM00211 DC    AL1(44)
         ORG   DCBF8+24
@NM00212 DS    CL4
         ORG   @NM00212
@NM00213 DC    X'04'
@NM00214 DC    X'03'
@NM00215 DC    AL1(0)
@NM00216 DC    AL1(53)
         ORG   DCBF8+28
@NM00217 DS    CL4
         ORG   @NM00217
@NM00218 DC    X'04'
@NM00219 DC    X'03'
@NM00220 DC    AL1(0)
@NM00221 DC    AL1(62)
         ORG   DCBF8+32
@NM00222 DS    CL4
         ORG   @NM00222
@NM00223 DC    X'04'
@NM00224 DC    X'03'
@NM00225 DC    AL1(0)
@NM00226 DC    AL1(71)
         ORG   DCBF8+36
@NM00227 DS    CL4
         ORG   @NM00227
@NM00228 DC    F'0'
         ORG   DCBF8+40
DEBL1    DS    CL26
         ORG   DEBL1
@NM00229 DC    CL6'DEBAVT'
@NM00230 DC    CL7'DEBPCIA'
@NM00231 DC    CL6'DEBCEA'
@NM00232 DC    CL7'DEBXCEA'
         ORG   DEBL1+26
         DS    CL2
DEBF1    DS    CL32
         ORG   DEBF1
@NM00233 DS    CL4
         ORG   @NM00233
@NM00234 DC    X'01'
@NM00235 DC    X'40'
@NM00236 DC    AL1(0)
@NM00237 DC    AL1(0)
         ORG   DEBF1+4
@NM00238 DS    CL8
         ORG   @NM00238
@NM00239 DC    X'07'
@NM00240 DC    X'53'
@NM00241 DC    AL1(8)
@NM00242 DC    AL1(17)
@NM00243 DC    AL4(DEBL1)
         ORG   DEBF1+12
@NM00244 DS    CL4
         ORG   @NM00244
@NM00245 DC    X'04'
@NM00246 DC    X'03'
@NM00247 DC    AL1(0)
@NM00248 DC    AL1(26)
         ORG   DEBF1+16
@NM00249 DS    CL4
         ORG   @NM00249
@NM00250 DC    X'05'
@NM00251 DC    X'63'
@NM00252 DC    AL1(35)
@NM00253 DC    AL1(44)
         ORG   DEBF1+20
@NM00254 DS    CL4
         ORG   @NM00254
@NM00255 DC    X'05'
@NM00256 DC    X'53'
@NM00257 DC    AL1(53)
@NM00258 DC    AL1(62)
         ORG   DEBF1+24
@NM00259 DS    CL4
         ORG   @NM00259
@NM00260 DC    X'05'
@NM00261 DC    X'63'
@NM00262 DC    AL1(71)
@NM00263 DC    AL1(80)
         ORG   DEBF1+28
@NM00264 DS    CL4
         ORG   @NM00264
@NM00265 DC    F'0'
         ORG   DEBF1+32
DEBL2    DS    CL31
         ORG   DEBL2
@NM00266 DC    CL6'PREFIX'
@NM00267 DC    CL8'EXTNSION'
@NM00268 DC    CL6'LENGTH'
@NM00269 DC    CL6'AMTYPE'
@NM00270 DC    CL5'TBLOF'
         ORG   DEBL2+31
         DS    CL1
DEBF2    DS    CL36
         ORG   DEBF2
@NM00271 DS    CL4
         ORG   @NM00271
@NM00272 DC    X'01'
@NM00273 DC    X'40'
@NM00274 DC    AL1(0)
@NM00275 DC    AL1(0)
         ORG   DEBF2+4
@NM00276 DS    CL8
         ORG   @NM00276
@NM00277 DC    X'07'
@NM00278 DC    X'53'
@NM00279 DC    AL1(8)
@NM00280 DC    AL1(17)
@NM00281 DC    AL4(DEBL2)
         ORG   DEBF2+12
@NM00282 DS    CL4
         ORG   @NM00282
@NM00283 DC    X'04'
@NM00284 DC    X'03'
@NM00285 DC    AL1(0)
@NM00286 DC    AL1(26)
         ORG   DEBF2+16
@NM00287 DS    CL4
         ORG   @NM00287
@NM00288 DC    X'05'
@NM00289 DC    X'73'
@NM00290 DC    AL1(35)
@NM00291 DC    AL1(44)
         ORG   DEBF2+20
@NM00292 DS    CL4
         ORG   @NM00292
@NM00293 DC    X'05'
@NM00294 DC    X'50'
@NM00295 DC    AL1(53)
@NM00296 DC    AL1(62)
         ORG   DEBF2+24
@NM00297 DS    CL4
         ORG   @NM00297
@NM00298 DC    X'05'
@NM00299 DC    X'50'
@NM00300 DC    AL1(71)
@NM00301 DC    AL1(80)
         ORG   DEBF2+28
@NM00302 DS    CL4
         ORG   @NM00302
@NM00303 DC    X'05'
@NM00304 DC    X'41'
@NM00305 DC    AL1(89)
@NM00306 DC    AL1(98)
         ORG   DEBF2+32
@NM00307 DS    CL4
         ORG   @NM00307
@NM00308 DC    F'0'
         ORG   DEBF2+36
DEBHL1   DS    CL25
         ORG   DEBHL1
@NM00309 DC    CL8'EXTNSION'
@NM00310 DC    CL6'LENGTH'
@NM00311 DC    CL6'AMTYPE'
@NM00312 DC    CL5'TBLOF'
         ORG   DEBHL1+25
         DS    CL3
DEBH1    DS    CL28
         ORG   DEBH1
@NM00313 DS    CL4
         ORG   @NM00313
@NM00314 DC    X'01'
@NM00315 DC    X'40'
@NM00316 DC    AL1(0)
@NM00317 DC    AL1(0)
         ORG   DEBH1+4
@NM00318 DS    CL8
         ORG   @NM00318
@NM00319 DC    X'07'
@NM00320 DC    X'73'
@NM00321 DC    AL1(8)
@NM00322 DC    AL1(17)
@NM00323 DC    AL4(DEBHL1)
         ORG   DEBH1+12
@NM00324 DS    CL4
         ORG   @NM00324
@NM00325 DC    X'05'
@NM00326 DC    X'50'
@NM00327 DC    AL1(26)
@NM00328 DC    AL1(35)
         ORG   DEBH1+16
@NM00329 DS    CL4
         ORG   @NM00329
@NM00330 DC    X'05'
@NM00331 DC    X'50'
@NM00332 DC    AL1(44)
@NM00333 DC    AL1(53)
         ORG   DEBH1+20
@NM00334 DS    CL4
         ORG   @NM00334
@NM00335 DC    X'05'
@NM00336 DC    X'41'
@NM00337 DC    AL1(62)
@NM00338 DC    AL1(71)
         ORG   DEBH1+24
@NM00339 DS    CL4
         ORG   @NM00339
@NM00340 DC    F'0'
         ORG   DEBH1+28
DEBL3    DS    CL23
         ORG   DEBL3
@NM00341 DC    CL6'TCBADR'
@NM00342 DC    CL7'NEXTDEB'
@NM00343 DC    CL6'IRBADR'
@NM00344 DC    CL4'PATB'
         ORG   DEBL3+23
         DS    CL1
DEBF3    DS    CL28
         ORG   DEBF3
@NM00345 DS    CL4
         ORG   @NM00345
@NM00346 DC    X'01'
@NM00347 DC    X'40'
@NM00348 DC    AL1(0)
@NM00349 DC    AL1(0)
         ORG   DEBF3+4
@NM00350 DS    CL8
         ORG   @NM00350
@NM00351 DC    X'07'
@NM00352 DC    X'53'
@NM00353 DC    AL1(8)
@NM00354 DC    AL1(17)
@NM00355 DC    AL4(DEBL3)
         ORG   DEBF3+12
@NM00356 DS    CL4
         ORG   @NM00356
@NM00357 DC    X'05'
@NM00358 DC    X'63'
@NM00359 DC    AL1(26)
@NM00360 DC    AL1(35)
         ORG   DEBF3+16
@NM00361 DS    CL4
         ORG   @NM00361
@NM00362 DC    X'05'
@NM00363 DC    X'53'
@NM00364 DC    AL1(44)
@NM00365 DC    AL1(53)
         ORG   DEBF3+20
@NM00366 DS    CL4
         ORG   @NM00366
@NM00367 DC    X'05'
@NM00368 DC    X'33'
@NM00369 DC    AL1(62)
@NM00370 DC    AL1(71)
         ORG   DEBF3+24
@NM00371 DS    CL4
         ORG   @NM00371
@NM00372 DC    F'0'
         ORG   DEBF3+28
DEBL4    DS    CL20
         ORG   DEBL4
@NM00373 DC    CL5'USRPG'
@NM00374 DC    CL3'RRQ'
@NM00375 DC    CL6'DCBADR'
@NM00376 DC    CL6'APPADR'
         ORG   DEBL4+20
DEBF4    DS    CL28
         ORG   DEBF4
@NM00377 DS    CL4
         ORG   @NM00377
@NM00378 DC    X'01'
@NM00379 DC    X'40'
@NM00380 DC    AL1(0)
@NM00381 DC    AL1(0)
         ORG   DEBF4+4
@NM00382 DS    CL8
         ORG   @NM00382
@NM00383 DC    X'07'
@NM00384 DC    X'43'
@NM00385 DC    AL1(8)
@NM00386 DC    AL1(17)
@NM00387 DC    AL4(DEBL4)
         ORG   DEBF4+12
@NM00388 DS    CL4
         ORG   @NM00388
@NM00389 DC    X'05'
@NM00390 DC    X'23'
@NM00391 DC    AL1(26)
@NM00392 DC    AL1(35)
         ORG   DEBF4+16
@NM00393 DS    CL4
         ORG   @NM00393
@NM00394 DC    X'05'
@NM00395 DC    X'53'
@NM00396 DC    AL1(44)
@NM00397 DC    AL1(53)
         ORG   DEBF4+20
@NM00398 DS    CL4
         ORG   @NM00398
@NM00399 DC    X'05'
@NM00400 DC    X'53'
@NM00401 DC    AL1(62)
@NM00402 DC    AL1(71)
         ORG   DEBF4+24
@NM00403 DS    CL4
         ORG   @NM00403
@NM00404 DC    F'0'
         ORG   DEBF4+28
IOBDAT1  DS    CL12
         ORG   IOBDAT1
@NM00405 DS    CL4
         ORG   @NM00405
@NM00406 DC    X'01'
@NM00407 DC    X'40'
@NM00408 DC    AL1(0)
@NM00409 DC    AL1(0)
         ORG   IOBDAT1+4
@NM00410 DS    CL4
         ORG   @NM00410
@NM00411 DC    X'04'
@NM00412 DC    X'03'
@NM00413 DC    AL1(0)
@NM00414 DC    AL1(8)
         ORG   IOBDAT1+8
@NM00415 DS    CL4
         ORG   @NM00415
@NM00416 DC    F'0'
         ORG   IOBDAT1+12
IOBDAT2  DS    CL16
         ORG   IOBDAT2
@NM00417 DS    CL4
         ORG   @NM00417
@NM00418 DC    X'01'
@NM00419 DC    X'40'
@NM00420 DC    AL1(0)
@NM00421 DC    AL1(0)
         ORG   IOBDAT2+4
@NM00422 DS    CL4
         ORG   @NM00422
@NM00423 DC    X'04'
@NM00424 DC    X'03'
@NM00425 DC    AL1(0)
@NM00426 DC    AL1(8)
         ORG   IOBDAT2+8
@NM00427 DS    CL4
         ORG   @NM00427
@NM00428 DC    X'04'
@NM00429 DC    X'03'
@NM00430 DC    AL1(0)
@NM00431 DC    AL1(17)
         ORG   IOBDAT2+12
@NM00432 DS    CL4
         ORG   @NM00432
@NM00433 DC    F'0'
         ORG   IOBDAT2+16
IOBDAT25 DS    CL20
         ORG   IOBDAT25
@NM00434 DS    CL4
         ORG   @NM00434
@NM00435 DC    X'01'
@NM00436 DC    X'40'
@NM00437 DC    AL1(0)
@NM00438 DC    AL1(0)
         ORG   IOBDAT25+4
@NM00439 DS    CL4
         ORG   @NM00439
@NM00440 DC    X'04'
@NM00441 DC    X'03'
@NM00442 DC    AL1(0)
@NM00443 DC    AL1(8)
         ORG   IOBDAT25+8
@NM00444 DS    CL4
         ORG   @NM00444
@NM00445 DC    X'04'
@NM00446 DC    X'03'
@NM00447 DC    AL1(0)
@NM00448 DC    AL1(17)
         ORG   IOBDAT25+12
@NM00449 DS    CL4
         ORG   @NM00449
@NM00450 DC    X'04'
@NM00451 DC    X'01'
@NM00452 DC    AL1(0)
@NM00453 DC    AL1(26)
         ORG   IOBDAT25+16
@NM00454 DS    CL4
         ORG   @NM00454
@NM00455 DC    F'0'
         ORG   IOBDAT25+20
IOBDAT4  DS    CL24
         ORG   IOBDAT4
@NM00456 DS    CL4
         ORG   @NM00456
@NM00457 DC    X'01'
@NM00458 DC    X'40'
@NM00459 DC    AL1(0)
@NM00460 DC    AL1(0)
         ORG   IOBDAT4+4
@NM00461 DS    CL4
         ORG   @NM00461
@NM00462 DC    X'04'
@NM00463 DC    X'03'
@NM00464 DC    AL1(0)
@NM00465 DC    AL1(8)
         ORG   IOBDAT4+8
@NM00466 DS    CL4
         ORG   @NM00466
@NM00467 DC    X'04'
@NM00468 DC    X'03'
@NM00469 DC    AL1(0)
@NM00470 DC    AL1(17)
         ORG   IOBDAT4+12
@NM00471 DS    CL4
         ORG   @NM00471
@NM00472 DC    X'04'
@NM00473 DC    X'03'
@NM00474 DC    AL1(0)
@NM00475 DC    AL1(26)
         ORG   IOBDAT4+16
@NM00476 DS    CL4
         ORG   @NM00476
@NM00477 DC    X'04'
@NM00478 DC    X'03'
@NM00479 DC    AL1(0)
@NM00480 DC    AL1(35)
         ORG   IOBDAT4+20
@NM00481 DS    CL4
         ORG   @NM00481
@NM00482 DC    F'0'
         ORG   IOBDAT4+24
IOBL1    DS    CL16
         ORG   IOBL1
@NM00483 DC    CL4'FLAG'
@NM00484 DC    CL4'SENS'
@NM00485 DC    CL5'ECBPT'
@NM00486 DC    CL3'CSW'
         ORG   IOBL1+16
IOBF1    DS    CL32
         ORG   IOBF1
@NM00487 DS    CL4
         ORG   @NM00487
@NM00488 DC    X'01'
@NM00489 DC    X'40'
@NM00490 DC    AL1(0)
@NM00491 DC    AL1(0)
         ORG   IOBF1+4
@NM00492 DS    CL8
         ORG   @NM00492
@NM00493 DC    X'07'
@NM00494 DC    X'31'
@NM00495 DC    AL1(8)
@NM00496 DC    AL1(17)
@NM00497 DC    AL4(IOBL1)
         ORG   IOBF1+12
@NM00498 DS    CL4
         ORG   @NM00498
@NM00499 DC    X'05'
@NM00500 DC    X'31'
@NM00501 DC    AL1(26)
@NM00502 DC    AL1(35)
         ORG   IOBF1+16
@NM00503 DS    CL4
         ORG   @NM00503
@NM00504 DC    X'05'
@NM00505 DC    X'43'
@NM00506 DC    AL1(44)
@NM00507 DC    AL1(53)
         ORG   IOBF1+20
@NM00508 DS    CL4
         ORG   @NM00508
@NM00509 DC    X'05'
@NM00510 DC    X'23'
@NM00511 DC    AL1(62)
@NM00512 DC    AL1(71)
         ORG   IOBF1+24
@NM00513 DS    CL4
         ORG   @NM00513
@NM00514 DC    X'04'
@NM00515 DC    X'03'
@NM00516 DC    AL1(0)
@NM00517 DC    AL1(80)
         ORG   IOBF1+28
@NM00518 DS    CL4
         ORG   @NM00518
@NM00519 DC    F'0'
         ORG   IOBF1+32
IOBL2    DS    CL23
         ORG   IOBL2
@NM00520 DC    CL5'START'
@NM00521 DC    CL5'DCBPT'
@NM00522 DC    CL5'RESTR'
@NM00523 DC    CL8'VARIABLE'
         ORG   IOBL2+23
         DS    CL1
IOBF2    DS    CL28
         ORG   IOBF2
@NM00524 DS    CL4
         ORG   @NM00524
@NM00525 DC    X'01'
@NM00526 DC    X'40'
@NM00527 DC    AL1(0)
@NM00528 DC    AL1(0)
         ORG   IOBF2+4
@NM00529 DS    CL8
         ORG   @NM00529
@NM00530 DC    X'07'
@NM00531 DC    X'43'
@NM00532 DC    AL1(8)
@NM00533 DC    AL1(17)
@NM00534 DC    AL4(IOBL2)
         ORG   IOBF2+12
@NM00535 DS    CL4
         ORG   @NM00535
@NM00536 DC    X'05'
@NM00537 DC    X'43'
@NM00538 DC    AL1(26)
@NM00539 DC    AL1(35)
         ORG   IOBF2+16
@NM00540 DS    CL4
         ORG   @NM00540
@NM00541 DC    X'05'
@NM00542 DC    X'43'
@NM00543 DC    AL1(44)
@NM00544 DC    AL1(53)
         ORG   IOBF2+20
@NM00545 DS    CL4
         ORG   @NM00545
@NM00546 DC    X'05'
@NM00547 DC    X'73'
@NM00548 DC    AL1(62)
@NM00549 DC    AL1(71)
         ORG   IOBF2+24
@NM00550 DS    CL4
         ORG   @NM00550
@NM00551 DC    F'0'
         ORG   IOBF2+28
BLANKS   DC    CL120' '
TRANS    DS    CL256
         ORG   TRANS
@NM00561 DS    CL64
BL       DC    CL1' '
@NM00562 DS    CL175
NUMS     DC    CL16'0123456789ABCDEF'
         ORG   TRANS+256
ACBMSG   DC    CL87'*** FOR THIS DEB THERE IS NO DCB, THE CONTROL BLOCKC
                POINTED TO BY THE DEB IS AN ACB ***'
BDAM     DC    CL6'(BDAM)'
BPAM     DC    CL6'(BPAM)'
BSAM     DC    CL6'(BSAM)'
BTAM     DC    CL6'(BTAM)'
DCBHDR   DC    CL55'-DCB-                                      AT LOCATC
               ION '
DCBMSG   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING DCB FOC
               RMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
DEBHDR   DC    CL54'-DEB--------------------------------------AT LOCATIC
               ON '
DEBMSG   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING DEB FOC
               RMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
EXCP     DC    CL6'(EXCP)'
EXCPFE   DC    CL29'(EXCP W/FOUNDATION EXTENSION)'
EXCP0    DC    CL28'(EXCP WITH COMMON INTERFACE)'
EXCP1    DC    CL32'(EXCP W/1 WORD DEVICE INTERFACE)'
EXCP3    DC    CL32'(EXCP W/3 WORD DEVICE INTERFACE)'
EXCP4    DC    CL32'(EXCP W/4 WORD DEVICE INTERFACE)'
EXCP5    DC    CL32'(EXCP W/5 WORD DEVICE INTERFACE)'
GAM      DC    CL5'(GAM)'
IOBCHAIN DC    CL29'(SAM,BPAM-CHAINED SCHEDULING)'
ICBHDR   DC    CL5'-ICB-'
ICBMSG   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING ICB FOC
               RMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
INVLIST  DC    CL17'(INVITATION LIST)'
IOBHDR   DC    CL54'-IOB-                                     AT LOCATIC
               ON '
IOBERR   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING IOB FOC
               RMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
ISAM     DC    CL6'(ISAM)'
LCBHDR   DC    CL5'-LCB-'
LCBMSG   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING LCB FOC
               RMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
LINEGRP  DC    CL17'(TCAM LINE GROUP)'
NOACCESS DC    CL70'*** DCB NOT FORMATTED - COULD NOT DETERMINE THE ACCC
               ESS METHOD USED ***'
NMALIOB  DC    CL28'(SAM,BPAM-NORMAL SCHEDULING)'
T3705    DC    CL11'(TCAM 3705)'
TCAMMSG  DC    CL20'(TCAM MESSAGE QUEUE)'
QISAML   DC    CL17'(QISAM LOAD MODE)'
QISAMS   DC    CL17'(QISAM SCAN MODE)'
QSAM     DC    CL6'(QSAM)'
UNDER    DC    CL5'-----'
DA1PATCH DC    CL200'PATCH AREA FOR IECDAFT1, IT IS 200 BYTES LONG'
         DS    CL1
BDAMARY  DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF6)
BDAMIOB  DC    AL4(IOBDAT2)
         DC    AL4(IOBF1)
         DC    AL4(IOBF2)
         DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT4)
BPAMARY  DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF2)
BTAMARY  DC    AL4(DCBF8)
         DC    AL4(DCBF2)
BTAMIOB  DC    AL4(IOBF1)
         DC    AL4(IOBF2)
         DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT4)
CHAINARY DC    AL4(IOBDAT4)
         DC    AL4(IOBF1)
         DC    AL4(IOBF2)
EXAPARY  DC    AL4(DCBF5)
EXCPARY  DC    AL4(DCBF3)
EXCP0ARY DC    AL4(DCBF4)
         DC    AL4(DCBF4)
EXCP1ARY DC    AL4(DCBF4)
         DC    AL4(DCBF5)
EXCP3ARY DC    AL4(DCBF3)
         DC    AL4(DCBF4)
         DC    AL4(DCBF4)
EXCP4ARY DC    AL4(DCBF4)
         DC    AL4(DCBF4)
         DC    AL4(DCBF4)
EXCP5ARY DC    AL4(DCBF4)
         DC    AL4(DCBF4)
         DC    AL4(DCBF5)
EXFEARY  DC    AL4(DCBF5)
GAMARY   DC    AL4(DCBF5)
         DC    AL4(DCBF4)
GAMIOB   DC    AL4(IOBDAT1)
         DC    AL4(IOBF1)
         DC    AL4(IOBF2)
         DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT2)
HASPDEB  DC    AL4(DEBH1)
         DC    AL4(DEBF3)
         DC    AL4(DEBF4)
ICBARY   DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT4)
         DC    AL4(IOBDAT2)
ISAMARY  DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF3)
LINEARY  DC    AL4(DCBF8)
         DC    AL4(DCBF3)
LOADARY  DC    AL4(IOBDAT1)
         DC    AL4(IOBF1)
         DC    AL4(IOBF2)
         DC    AL4(IOBDAT2)
NMALARY  DC    AL4(IOBDAT2)
         DC    AL4(IOBF1)
         DC    AL4(IOBF2)
NORMLDEB DC    AL4(DEBF1)
         DC    AL4(DEBF2)
         DC    AL4(DEBF3)
         DC    AL4(DEBF4)
QSAMARY  DC    AL4(DCBF8)
         DC    AL4(DCBF8)
         DC    AL4(DCBF4)
SCANARY  DC    AL4(IOBDAT1)
         DC    AL4(IOBF1)
         DC    AL4(IOBF2)
         DC    AL4(IOBDAT25)
SHORTDEB DC    AL4(DEBF2)
         DC    AL4(DEBF3)
         DC    AL4(DEBF4)
TCAMARY  DC    AL4(IOBDAT8)
         DC    AL4(IOBDAT8)
         DC    AL4(IOBDAT8)
         DC    AL4(IOBDAT8)
         DC    AL4(IOBDAT6)
TMSGARY  DC    AL4(DCBF8)
         DC    AL4(DCBF4)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RCCODE   EQU   @09
ESTAPTR  EQU   @08
ARRAYCNT EQU   @06
IOBSTPTR EQU   @06
DEBPTR   EQU   @06
DCBPTR   EQU   @07
ABDPLPTR EQU   @01
LINEPTR  EQU   @00
VADR     EQU   @00
RETRN    EQU   @14
RCREG    EQU   @15
ABDPL    EQU   0
ADPLFLAG EQU   ABDPL+7
ADPLSNPR EQU   ADPLFLAG
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLMEMA EQU   ABDPL+20
ADPLFRMT EQU   ABDPL+24
ADPLCOM1 EQU   ABDPL+28
ADPLCOM2 EQU   ABDPL+32
ADPLCOM3 EQU   ABDPL+36
ADPLCOM4 EQU   ABDPL+40
ADPLFMT1 EQU   ABDPL+44
ADPLFMT2 EQU   ABDPL+48
IHADCB   EQU   0
IHADCS00 EQU   0
DCBFDAD  EQU   IHADCS00+5
IHADCS01 EQU   0
DCBDVTBL EQU   IHADCS01
IHADCS11 EQU   0
DCBRELB  EQU   IHADCS11
DCBREL   EQU   DCBRELB+1
DCBBUFCB EQU   IHADCS11+4
DCBDSORG EQU   IHADCS11+10
DCBDSRG1 EQU   DCBDSORG
DCBDSRG2 EQU   DCBDSORG+1
DCBIOBAD EQU   IHADCS11+12
DCBODEB  EQU   DCBIOBAD
DCBLNP   EQU   DCBODEB
DCBQSLM  EQU   DCBLNP
DCBIOBAA EQU   DCBODEB+1
IHADCS50 EQU   0
DCBSVCXL EQU   IHADCS50
DCBEODAD EQU   IHADCS50+4
DCBBFALN EQU   DCBEODAD
DCBHIARC EQU   DCBBFALN
DCBBFTEK EQU   DCBHIARC
DCBBFT   EQU   DCBBFTEK
DCBEXLST EQU   IHADCS50+8
DCBRECFM EQU   DCBEXLST
DCBRECLA EQU   DCBRECFM
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBTIOT  EQU   IHADCS25
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS26 EQU   0
DCBWRITE EQU   IHADCS26
DCBREAD  EQU   DCBWRITE
DCBWRITA EQU   DCBREAD+1
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS36 EQU   0
DCBGERR  EQU   IHADCS36
DCBPERR  EQU   DCBGERR
DCBCHECK EQU   DCBPERR
DCBOPTCD EQU   DCBCHECK
DCBOPTH  EQU   DCBOPTCD
DCBOPTO  EQU   DCBOPTH
DCBOPTZ  EQU   DCBOPTCD
DCBGERRA EQU   DCBCHECK+1
DCBPERRA EQU   DCBGERRA
DCBSYNAD EQU   IHADCS36+4
DCBCIND1 EQU   IHADCS36+8
DCBCIND2 EQU   IHADCS36+9
DCBIOBA  EQU   IHADCS36+16
DCBCICB  EQU   DCBIOBA
IHADCS52 EQU   0
DCBDIRCT EQU   IHADCS52
DCBQSWS  EQU   DCBDIRCT
DCBUSASI EQU   DCBQSWS
DCBQADFS EQU   DCBUSASI
DCBBUFOF EQU   DCBDIRCT+1
IHADCS37 EQU   0
DCBFLAG1 EQU   IHADCS37
IHADCS38 EQU   0
DCBEOBR  EQU   IHADCS38
DCBPOINT EQU   IHADCS38+12
DCBCNTRL EQU   DCBPOINT
IHADCS40 EQU   0
DCBEOBAD EQU   IHADCS40
DCBCCCW  EQU   IHADCS40+4
DCBRECAD EQU   DCBCCCW
DCBRECBT EQU   DCBRECAD
DCBRCREL EQU   DCBRECBT
@NM00027 EQU   IHADCS40+12
DCBEROPT EQU   @NM00027
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBLNGTH EQU   DEBPREFX+12
DEBAMTYP EQU   DEBPREFX+13
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IOBPREFX EQU   0
IOBCFLG1 EQU   IOBPREFX
IOBSTDRD EQU   0
IOBFLAG1 EQU   IOBSTDRD
IOBCYCCK EQU   IOBFLAG1
IOBRSTRT EQU   IOBFLAG1
IOBFLAG2 EQU   IOBSTDRD+1
IOBPURGE EQU   IOBFLAG2
IOBRDHA0 EQU   IOBFLAG2
IOBSENS0 EQU   IOBSTDRD+2
IOBS0B7  EQU   IOBSENS0
IOBSENS1 EQU   IOBSTDRD+3
IOBECBPT EQU   IOBSTDRD+4
IOBFLAG3 EQU   IOBSTDRD+8
IOBFL3   EQU   IOBFLAG3
IOBCNC   EQU   IOBFL3
IOBICL   EQU   IOBFL3
IOBCSW   EQU   IOBSTDRD+9
IOBIOCSW EQU   IOBCSW
IOBSTBYT EQU   IOBIOCSW+3
IOBUSTAT EQU   IOBSTBYT
IOBCSTAT EQU   IOBSTBYT+1
IOBSTART EQU   IOBSTDRD+16
IOBDCBPT EQU   IOBSTDRD+20
IOBFLAG4 EQU   IOBDCBPT
IOBRESTR EQU   IOBSTDRD+24
IOBINCAM EQU   IOBSTDRD+28
IOBBTAMF EQU   IOBINCAM
ACCESS   EQU   0
PRINT    EQU   0
FORMAT   EQU   0
BUFFER   EQU   0
HDRTYPE  EQU   BUFFER+10
ADDRESS  EQU   BUFFER+55
DATABYTE EQU   0
DATADWRD EQU   0
DATAHALF EQU   0
DATAWORD EQU   0
DATAADR  EQU   DATAWORD+1
ESTAPARM EQU   0
ESTAERR  EQU   ESTAPARM
ERREXP   EQU   ESTAERR
RTYADR   EQU   ESTAPARM+4
RTYREGS  EQU   ESTAPARM+8
LCALREGS EQU   ESTAPARM+72
MSG      EQU   0
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
IOBORG01 EQU   IOBPREFX+8
IOBNIOBA EQU   IOBORG01
IOBNFLG1 EQU   IOBNIOBA
IOBPRTOV EQU   IOBNFLG1
IOBORG02 EQU   IOBPREFX+8
IOBDQADA EQU   IOBORG02
IOBDEQIN EQU   IOBDQADA
IOBORG03 EQU   IOBPREFX+12
IOBORG04 EQU   IOBINCAM
IOBORG12 EQU   IOBINCAM
IOBFL4   EQU   IOBORG12
IOBEXTEN EQU   IOBSTDRD+32
IOBSEEK  EQU   IOBEXTEN
IOBBB    EQU   IOBSEEK+1
IOBCC    EQU   IOBSEEK+3
IOBHH    EQU   IOBSEEK+5
IOBORG05 EQU   IOBEXTEN
IOBORG06 EQU   IOBEXTEN
IOBNXTPT EQU   IOBORG06+4
IOBSTATA EQU   IOBNXTPT
IOBORG07 EQU   IOBEXTEN+8
W1IEXTEN EQU   IOBORG07
IOBORG08 EQU   IOBEXTEN+8
IOBINDCT EQU   IOBORG08+4
IOBUNSQR EQU   IOBORG08+5
IOBFCHAD EQU   IOBORG08+8
IOBORG09 EQU   IOBEXTEN+8
IOBDPLAD EQU   IOBORG09+4
IOBDTYPE EQU   IOBORG09+8
IOBDTYP2 EQU   IOBORG09+9
IOBDSTAT EQU   IOBORG09+10
IOBSTAT1 EQU   IOBDSTAT
IOBORG10 EQU   IOBEXTEN+8
IOBSEEK2 EQU   IOBORG10
IOBORG11 EQU   IOBEXTEN
IOBERCT  EQU   IOBORG11
IOBUCBXV EQU   IOBERCT
IOBNAME  EQU   IOBORG11+4
IOBORG13 EQU   IOBEXTEN
IOBSKADR EQU   IOBORG13
BSAMARY  EQU   BPAMARY
DCBTYPES EQU   ADPLCOM2
EXCPDCB  EQU   DCBTYPES
ISAMLOAD EQU   DCBTYPES
ISAMSCAN EQU   DCBTYPES
BISAMDCB EQU   DCBTYPES
SAMNMAL  EQU   DCBTYPES
SAMCHAIN EQU   DCBTYPES
BDAMDCB  EQU   DCBTYPES
BTAMDCB  EQU   DCBTYPES
GAMDCB   EQU   DCBTYPES+1
TCAMLINE EQU   DCBTYPES+1
TCAM3705 EQU   DCBTYPES+1
TCAMMSGQ EQU   DCBTYPES+1
CHAINIOB EQU   DCBTYPES+1
DEBDAT1  EQU   DCBF1
DEBDAT2  EQU   DCBF2
DEBDAT3  EQU   DCBF3
DEBDAT4  EQU   DCBF4
IOBDAT6  EQU   DCBF6
IOBDAT8  EQU   DCBF8
T3705ARY EQU   LINEARY
DCBILCT  EQU   DCBOPTCD
START    EQU   ADPLFMT1
ICB      EQU   IOBCHAIN
DCBEIOBX EQU   DCBRECFM
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00555 EQU   DCBTYPES+1
IOBSKSS  EQU   IOBSKADR+3
IOBSK0   EQU   IOBSKADR+2
IOBSKTT  EQU   IOBSKADR+1
IOBSKRV  EQU   IOBSKADR
IOBCSWSV EQU   IOBORG11+17
IOBSENSV EQU   IOBORG11+16
IOBRCD   EQU   IOBORG11+12
IOBMDREC EQU   IOBORG11+8
IOBNAMEA EQU   IOBNAME+1
IOBNAMSZ EQU   IOBNAME
IOBERCTA EQU   IOBERCT+1
IOBRTYPE EQU   IOBUCBXV
IOBRDCHP EQU   IOBORG10+20
IOBNEXTA EQU   IOBORG10+16
IOBREADA EQU   IOBORG10+12
IOBBUFC  EQU   IOBORG10+8
IOBSK2R  EQU   IOBSEEK2+7
IOBSK2HH EQU   IOBSEEK2+5
IOBSK2CC EQU   IOBSEEK2+3
IOBSK2BB EQU   IOBSEEK2+1
IOBSK2M  EQU   IOBSEEK2
IOBCHNPR EQU   IOBORG09+40
IOBDNCRF EQU   IOBORG09+32
IOBRSV35 EQU   IOBORG09+24
IOBDQPTR EQU   IOBORG09+20
IOBRSV34 EQU   IOBORG09+18
IOBDBYTN EQU   IOBORG09+16
IOBDCPND EQU   IOBORG09+12
IOBSTAT2 EQU   IOBDSTAT+1
IOBSIORT EQU   IOBSTAT1
IOBADDVU EQU   IOBSTAT1
IOBBUFF  EQU   IOBSTAT1
IOBENQUE EQU   IOBSTAT1
IOBPASS2 EQU   IOBSTAT1
IOBSYNCH EQU   IOBSTAT1
IOBNEWVL EQU   IOBSTAT1
IOBABNRM EQU   IOBSTAT1
IOBRELEX EQU   IOBDTYP2
IOBADDTY EQU   IOBDTYP2
IOBTYPE  EQU   IOBDTYP2
IOBRQUST EQU   IOBDTYP2
IOBSUFFX EQU   IOBDTYP2
IOBSBLKL EQU   IOBDTYP2
IOBSKEY  EQU   IOBDTYP2
IOBRELBL EQU   IOBDTYPE
IOBRDEXC EQU   IOBDTYPE
IOBDYNBF EQU   IOBDTYPE
IOBACTAD EQU   IOBDTYPE
IOBFDBCK EQU   IOBDTYPE
IOBEXTSC EQU   IOBDTYPE
IOBOVFLO EQU   IOBDTYPE
IOBVERFY EQU   IOBDTYPE
IOBDPLB  EQU   IOBDPLAD+1
IOBDAYLI EQU   IOBDPLAD
IOBDIOBS EQU   IOBORG09+2
IOBDBYTR EQU   IOBORG09
IOBBCHAD EQU   IOBORG08+12
IOBFCHNB EQU   IOBFCHAD+1
IOBCOUNT EQU   IOBFCHAD
IOBASYN  EQU   IOBORG08+7
IOBAPP   EQU   IOBORG08+6
IOBRSV32 EQU   IOBUNSQR
IOBRSV31 EQU   IOBUNSQR
IOBRSV30 EQU   IOBUNSQR
IOBKNRWR EQU   IOBUNSQR
IOBKNWR  EQU   IOBUNSQR
IOBNTAV2 EQU   IOBUNSQR
IOBNTAV1 EQU   IOBUNSQR
IOBCPBSY EQU   IOBUNSQR
IOBCHNNL EQU   IOBINDCT
IOBRSV29 EQU   IOBINDCT
IOBRSV28 EQU   IOBINDCT
IOBRSV27 EQU   IOBINDCT
IOBKEYAD EQU   IOBINDCT
IOBOVPTR EQU   IOBINDCT
IOBUNSCH EQU   IOBINDCT
IOBDEQCP EQU   IOBINDCT
IOBCCWAD EQU   IOBORG08
W1OEXTEN EQU   W1IEXTEN
IOBCCW   EQU   IOBORG06+8
IOBNXTPB EQU   IOBNXTPT+1
IOBRSV26 EQU   IOBSTATA
IOBRSV25 EQU   IOBSTATA
IOBRSV24 EQU   IOBSTATA
IOBRSV23 EQU   IOBSTATA
IOBRSV22 EQU   IOBSTATA
IOBRSV21 EQU   IOBSTATA
IOBRSV20 EQU   IOBSTATA
IOBAVLFL EQU   IOBSTATA
IOBRSV37 EQU   IOBORG06+1
IOBUCBXG EQU   IOBORG06
IOBCPA   EQU   IOBORG05+32
IOBERINF EQU   IOBORG05+16
IOBERCCW EQU   IOBORG05+8
IOBSNDPT EQU   IOBORG05+7
IOBRCVPT EQU   IOBORG05+6
IOBWORK  EQU   IOBORG05+1
IOBUCBX  EQU   IOBORG05
IOBR     EQU   IOBSEEK+7
IOBHH2   EQU   IOBHH+1
IOBHH1   EQU   IOBHH
IOBCC2   EQU   IOBCC+1
IOBCC1   EQU   IOBCC
IOBBB2   EQU   IOBBB+1
IOBBB1   EQU   IOBBB
IOBM     EQU   IOBSEEK
IOBRSV46 EQU   IOBFL4
IOBRSV47 EQU   IOBFL4
IOBENT   EQU   IOBFL4
IOBEQP   EQU   IOBFL4
IOBBUS   EQU   IOBFL4
IOBDCK   EQU   IOBFL4
IOBREJ   EQU   IOBFL4
IOBOVR   EQU   IOBFL4
IOBCRILC EQU   IOBORG04+1
IOBCRDCC EQU   IOBORG04
IOBGQECB EQU   IOBORG03
IOBSWAP  EQU   IOBORG02+4
IOBDQADB EQU   IOBDQADA+1
IOBRSV13 EQU   IOBDEQIN
IOBRSV12 EQU   IOBDEQIN
IOBRSV11 EQU   IOBDEQIN
IOBRSV10 EQU   IOBDEQIN
IOBRSV09 EQU   IOBDEQIN
IOBRSV08 EQU   IOBDEQIN
IOBRSV07 EQU   IOBDEQIN
IOBDEQ   EQU   IOBDEQIN
IOBNECB  EQU   IOBORG01+4
IOBNIOBB EQU   IOBNIOBA+1
IOBFIRST EQU   IOBNFLG1
IOBUPERR EQU   IOBNFLG1
IOBSPAN  EQU   IOBNFLG1
IOBBKSPC EQU   IOBNFLG1
IOBUPDAT EQU   IOBNFLG1
IOBREAD  EQU   IOBNFLG1
IOBWRITE EQU   IOBNFLG1
IOBSEGMT EQU   IOBPRTOV
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
@NM00559 EQU   ESTAERR
UNEXP2   EQU   ESTAERR
LOCKHELD EQU   ESTAERR
@NM00554 EQU   DATAWORD
@NM00553 EQU   BUFFER+64
@NM00552 EQU   BUFFER+6
OFFSET   EQU   BUFFER
IOBERRCT EQU   IOBSTDRD+30
IOBRSV19 EQU   IOBINCAM+1
IOBOLTST EQU   IOBBTAMF
IOBRFTMG EQU   IOBBTAMF
IOBRSV17 EQU   IOBBTAMF
IOBRSV16 EQU   IOBBTAMF
IOBRSV15 EQU   IOBBTAMF
IOBRSV14 EQU   IOBBTAMF
IOBINUSE EQU   IOBBTAMF
IOBPRMER EQU   IOBBTAMF
IOBRSTRB EQU   IOBRESTR+1
IOBREPOS EQU   IOBRESTR
IOBDCBPB EQU   IOBDCBPT+1
IOBRSV44 EQU   IOBFLAG4
IOBJES3I EQU   IOBFLAG4
IOBRSV42 EQU   IOBFLAG4
IOBRSV41 EQU   IOBFLAG4
IOBRSV40 EQU   IOBFLAG4
IOBPMERR EQU   IOBFLAG4
IOBCC3WE EQU   IOBFLAG4
IOBGDPOL EQU   IOBFLAG4
IOBSTRTB EQU   IOBSTART+1
IOBSIOCC EQU   IOBSTART
IOBCSB7  EQU   IOBCSTAT
IOBCSB6  EQU   IOBCSTAT
IOBCSB5  EQU   IOBCSTAT
IOBCSB4  EQU   IOBCSTAT
IOBCSB3  EQU   IOBCSTAT
IOBCSB2  EQU   IOBCSTAT
IOBCSB1  EQU   IOBCSTAT
IOBCSB0  EQU   IOBCSTAT
IOBUSB7  EQU   IOBUSTAT
IOBUSB6  EQU   IOBUSTAT
IOBUSB5  EQU   IOBUSTAT
IOBUSB4  EQU   IOBUSTAT
IOBUSB3  EQU   IOBUSTAT
IOBUSB2  EQU   IOBUSTAT
IOBUSB1  EQU   IOBUSTAT
IOBUSB0  EQU   IOBUSTAT
IOBCMDA  EQU   IOBIOCSW
IOBLOG   EQU   IOBFL3
IOBJAM   EQU   IOBICL
IOBMSG   EQU   IOBFL3
IOBSDR   EQU   IOBCNC
IOBACU   EQU   IOBFL3
IOBCDC   EQU   IOBFL3
IOBICC   EQU   IOBFL3
IOBCCC   EQU   IOBFL3
IOBECBPB EQU   IOBECBPT+1
IOBECBCC EQU   IOBECBPT
IOBS1B7  EQU   IOBSENS1
IOBS1B6  EQU   IOBSENS1
IOBS1B5  EQU   IOBSENS1
IOBS1B4  EQU   IOBSENS1
IOBS1B3  EQU   IOBSENS1
IOBS1B2  EQU   IOBSENS1
IOBS1B1  EQU   IOBSENS1
IOBS1B0  EQU   IOBSENS1
IOBSNSC9 EQU   IOBS0B7
IOBS0B6  EQU   IOBSENS0
IOBS0B5  EQU   IOBSENS0
IOBS0B4  EQU   IOBSENS0
IOBS0B3  EQU   IOBSENS0
IOBS0B2  EQU   IOBSENS0
IOBS0B1  EQU   IOBSENS0
IOBS0B0  EQU   IOBSENS0
IOBPNCH  EQU   IOBFLAG2
IOBSTATO EQU   IOBFLAG2
IOBSKUPD EQU   IOBFLAG2
IOBALTTR EQU   IOBFLAG2
IOBRRT2  EQU   IOBRDHA0
IOBRRT3  EQU   IOBPURGE
IOBSENSE EQU   IOBFLAG2
IOBHALT  EQU   IOBFLAG2
IOBSPSVC EQU   IOBRSTRT
IOBUNREL EQU   IOBFLAG1
IOBIOERR EQU   IOBFLAG1
IOBFCREX EQU   IOBCYCCK
IOBRPSTN EQU   IOBFLAG1
IOBERRTN EQU   IOBFLAG1
IOBCMDCH EQU   IOBFLAG1
IOBDATCH EQU   IOBFLAG1
IOBCNOPA EQU   IOBPREFX+12
IOBCICB  EQU   IOBPREFX+8
IOBCECB  EQU   IOBPREFX+4
IOBCONOP EQU   IOBPREFX+3
IOBCINOP EQU   IOBPREFX+2
IOBRSV05 EQU   IOBPREFX+1
IOBPCI   EQU   IOBCFLG1
IOBRSTCH EQU   IOBCFLG1
IOBABAPP EQU   IOBCFLG1
IOBPTST  EQU   IOBCFLG1
IOBRSV04 EQU   IOBCFLG1
IOBRSV03 EQU   IOBCFLG1
IOBRSV02 EQU   IOBCFLG1
IOBRSV01 EQU   IOBCFLG1
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00034 EQU   DEBACS08+12
@NM00033 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00032 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00031 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
DCBEOB   EQU   IHADCS40+20
DCBPRECL EQU   IHADCS40+18
@NM00030 EQU   IHADCS40+16
@NM00029 EQU   @NM00027+1
@NM00028 EQU   DCBEROPT
DCBERABE EQU   DCBEROPT
DCBERSKP EQU   DCBEROPT
DCBERACC EQU   DCBEROPT
@NM00026 EQU   IHADCS40+10
@NM00025 EQU   IHADCS40+9
@NM00024 EQU   IHADCS40+8
DCBRECA  EQU   DCBRECAD+1
@NM00023 EQU   DCBRECBT
DCBRCFGT EQU   DCBRCREL
DCBRCTRU EQU   DCBRCREL
DCBLCCW  EQU   DCBEOBAD
DCBNOTE  EQU   DCBCNTRL
DCBLRECL EQU   IHADCS38+10
@NM00022 EQU   IHADCS38+8
DCBEOBW  EQU   IHADCS38+4
DCBEOBRA EQU   DCBEOBR+1
DCBNCP   EQU   DCBEOBR
@NM00021 EQU   DCBFLAG1
DCBSTFLS EQU   DCBFLAG1
DCBSTQCK EQU   DCBFLAG1
DCBDIRCQ EQU   DCBBUFOF
DCBQSTRU EQU   DCBUSASI
@NM00020 EQU   DCBUSASI
DCBQADF3 EQU   DCBQADFS
DCBQADF2 EQU   DCBQADFS
DCBQADF1 EQU   DCBQADFS
DCBBLBP  EQU   DCBUSASI
@NM00019 EQU   DCBUSASI
DCBCICBA EQU   DCBCICB+1
@NM00018 EQU   DCBCICB
DCBOFFSW EQU   IHADCS36+15
DCBOFFSR EQU   IHADCS36+14
DCBWCPL  EQU   IHADCS36+13
DCBWCPO  EQU   IHADCS36+12
DCBBLKSI EQU   IHADCS36+10
DCBCNQSM EQU   DCBCIND2
DCBCNFEO EQU   DCBCIND2
DCBCNCHS EQU   DCBCIND2
DCBCNBFP EQU   DCBCIND2
DCBCNIOE EQU   DCBCIND2
DCBCNCLO EQU   DCBCIND2
DCBCNWRO EQU   DCBCIND2
DCBCNSTO EQU   DCBCIND2
DCBCNEXB EQU   DCBCIND1
@NM00017 EQU   DCBCIND1
DCBCNBRM EQU   DCBCIND1
@NM00016 EQU   DCBCIND1
DCBCNEVA EQU   DCBCIND1
DCBCNEVB EQU   DCBCIND1
DCBCNSRD EQU   DCBCIND1
DCBCNTOV EQU   DCBCIND1
DCBSYNA  EQU   DCBSYNAD+1
DCBIOBL  EQU   DCBSYNAD
DCBCHCKA EQU   DCBPERRA
DCBOPTJ  EQU   DCBOPTCD
DCBOPTT  EQU   DCBOPTCD
DCBSRCHD EQU   DCBOPTZ
DCBOPTQ  EQU   DCBOPTCD
DCBBCKPT EQU   DCBOPTO
DCBOPTC  EQU   DCBOPTCD
DCBOPTU  EQU   DCBOPTCD
DCBOPTW  EQU   DCBOPTCD
DCBPUTA  EQU   DCBGETA
@NM00015 EQU   DCBPUT
DCBREADA EQU   DCBWRITA
@NM00014 EQU   DCBREAD
DCBDEBA  EQU   DCBDEBAD+1
@NM00013 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00012 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBRECKL EQU   DCBRECFM
DCBRECCC EQU   DCBRECFM
DCBRECSB EQU   DCBRECFM
DCBRECBR EQU   DCBRECFM
DCBRECTO EQU   DCBRECLA
DCBRECL  EQU   DCBRECLA
DCBEODA  EQU   DCBEODAD+1
DCBBFA   EQU   DCBBFTEK
DCBH0    EQU   DCBBFTEK
DCBBFTKD EQU   DCBBFTEK
DCBBFTE  EQU   DCBBFT
DCBBFTKR EQU   DCBBFT
DCBBFTS  EQU   DCBBFT
DCBH1    EQU   DCBBFTEK
DCBSVCXA EQU   DCBSVCXL+1
@NM00011 EQU   DCBSVCXL
DCBODEBA EQU   DCBIOBAA
@NM00010 EQU   DCBQSLM
DCBUPDBT EQU   DCBQSLM
DCBUPDCM EQU   DCBQSLM
DCB1DVDS EQU   DCBQSLM
@NM00009 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00008 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
@NM00007 EQU   DCBDSRG1
@NM00006 EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGDA EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBDSGIS EQU   DCBDSRG1
DCBBUFL  EQU   IHADCS11+8
DCBBUFCA EQU   DCBBUFCB+1
DCBBUFNO EQU   DCBBUFCB
DCBDEVT  EQU   DCBREL
DCBKEYLE EQU   DCBRELB
DCBTRBAL EQU   IHADCS01+6
@NM00005 EQU   IHADCS01+5
@NM00004 EQU   IHADCS01+4
DCBDVTBA EQU   DCBDVTBL+1
@NM00003 EQU   DCBDVTBL
DCBKEYCN EQU   IHADCS00+4
DCBRELAD EQU   IHADCS00
@NM00002 EQU   IHADCB
ADPLABDA EQU   ABDPL+56
ADPLEXT  EQU   ABDPL+52
ADPLCVT  EQU   ABDPL+16
@NM00001 EQU   ADPLFLAG
ADPLDMGT EQU   ADPLFLAG
ADPLSYTM EQU   ADPLFLAG
ADPLSBPL EQU   ABDPL+6
ADPLASID EQU   ABDPL+4
ADPLTCB  EQU   ABDPL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00597 EQU   @RC00421
@RC00542 EQU   @RC00421
@RC00528 EQU   @RC00421
@RC00514 EQU   @RC00421
@RC00500 EQU   @RC00421
@RC00450 EQU   @RC00421
@RC00429 EQU   @RC00421
@RC00696 EQU   @RC00694
@RC00784 EQU   @RC00783
@RC00443 EQU   @RC00429
@RC00441 EQU   @RC00429
@RC00454 EQU   @RC00450
@RC00473 EQU   @RC00450
@RC00460 EQU   @RC00450
@RC00543 EQU   @RC00542
@RC00598 EQU   @RC00597
@RC00573 EQU   @RC00543
@RC00577 EQU   @RC00573
@ENDDATA EQU   *
         END   IECDAFT1,(C'PLS2003',0701,77066)
