         TITLE 'IECVCINT - CHANNEL RECONFIGURATION HARDWARE MODULE     *
                        '
*                                                                  0141
IECVCINT   CSECT
     ENTRY IECVCRHA                    DEFINE
     ENTRY IECVCRHD                        ENTRY
     ENTRY IECVCRHT                            POINTS
     ENTRY IECVCRHV                                FOR
     ENTRY IECCRHAF                                  ROUTINES
     ENTRY IECCRHDF
     ENTRY IECCINTF
     ENTRY IECVCRHS
     ENTRY IECCRHTF
     LR    BASE,CINTENT                LOAD BASE REGISTER
     USING IECVCINT,BASE               INDICATE ADRESSABILITY
*/********************************************************************/
*/* IF CRH NOT ACTIVE PASS INTERRUPT ON TO IOS SLIH WHICH PROCESSES  */
*/* THE INTERRUPT AND THEN RETURNS DIRECTLY TO I/O FLIH.             */
*/********************************************************************/
*    IF CVTCRCA=ZERO                   /* IS CRH ACTIVE ?            */
*       THEN DO;                       /*NO, PASS INTERRUPT TO SLIH  */
         L     @10,CVTPTR                                          0142
         ICM   @03,15,CVTCRCA(@10)                                 0142
         BNZ   @RF00142                                            0142
*            CINTENT=ADDR(IECINT);     /* GET ADDRESS OF IOS SLIH    */
         L     @10,IOCOMPTR(,@10)                                  0144
         L     CINTENT,IOCINT(,@10)                                0144
*            GEN( BR CINTENT);         /* CALL IOS SLIH - RETURN   0145
*                                         REGISTER 4 IS PASSED TO IOS
*                                         SLIH THEREFOR IECINT RETURNS
*                                         DIRECTLY TO THE I/O FLIH   */
          BR CINTENT
*            END;                                                  0146
*/********************************************************************/
*/*  PROVIDE FRR COVERAGE                                            */
*/********************************************************************/
*    RFY (WRK1,WRK3) RSTD;                                         0147
@RF00142 DS    0H                                                  0148
*    IF SETFRRC=OFF                    /* ALREADY COVERED BY FRR ?   */
*       THEN DO;                                                   0148
         TM    SETFRRC,B'00100000'                                 0148
         BNZ   @RF00148                                            0148
*            GEN CODE(SETFRR A,FRRAD=CINTF,WRKREGS=(WRK1,WRK3))    0150
*                     SETS(WRK1,WRK3) REFS(CINTF); /* SET FRR        */
         SETFRR A,FRRAD=CINTF,WRKREGS=(WRK1,WRK3)
*            SETFRRC=ON;               /* INDICATE FRR COVERAGE      */
         OI    SETFRRC,B'00100000'                                 0151
*            END;                                                  0152
*    RFY (WRK1,WRK3) UNRSTD;                                       0153
@RF00148 DS    0H                                                  0154
*/********************************************************************/
*/*       DO SOME INITITALIZATION                                    */
*/********************************************************************/
*    SAVERET=CINTRET;                  /* SAVE RETURN REGISTER 4     */
         ST    CINTRET,SAVERET                                     0154
*    CRCAPTR=CVTCRCA;                  /* SET UP CRCA BASE REGISTER  */
         L     @10,CVTPTR                                          0155
         L     CRCAPTR,CVTCRCA(,@10)                               0155
*    CRCADINT=OFF;                     /* INITIALIZE FLAG TO OFF     */
         NI    CRCADINT(CRCAPTR),B'10111111'                       0156
*    GEN CODE REFS(CRCAPTR) SETS(CRCAITIM);                        0157
     STCK  CRCAITIM(CRCAPTR)           SAVE TIME OF THIS INTERRUPT
*/********************************************************************/
*/* CHECK WHETHER INTERRUPT WAS SOLICITED ACROSS CRH CONNECTION      */
*/********************************************************************/
*    IF CRCADIAG=ON                    /* CRH CONNECTION OUTSTANDING?*/
*       THEN DO;                       /* YES-INTERRUPT ACROSS CRH   */
         TM    CRCADIAG(CRCAPTR),B'10000000'                       0158
         BNO   @RF00158                                            0158
*            BUILDIOA=FLCIOAA;         /* UPDATE I/O INTERRUPT       */
         MVC   BUILDIOA(3),FLCIOAA                                 0160
*            IOAA(1:1)=CRCACHAN(1:1);  /* ADDRESS IN FIXED LOW CORE  */
         MVC   IOAA(1),CRCACHAN(CRCAPTR)                           0161
*            FLCIOAA=BUILDIOA;         /* TO REFLECT ACTUAL CHANNEL  */
         MVC   FLCIOAA(3),BUILDIOA                                 0162
*            CATINDEX=IOAA(1:1);       /* GET CHANNEL ADDRESS        */
         SLR   CATINDEX,CATINDEX                                   0163
         IC    CATINDEX,IOAA                                       0163
*            SLL(CATINDEX,CATELP2);    /*SHIFT TO MULTIPLY BY LENGTH */
         LA    @10,3                                               0164
         SLL   CATINDEX,0(@10)                                     0164
*            CATPTR=CRCACAT+CATINDEX;  /* GET POINTER TO CAT ENTRY   */
         LR    CATPTR,CATINDEX                                     0165
         AL    CATPTR,CRCACAT(,CRCAPTR)                            0165
*            CATBSY=OFF;               /* MAKE SURE CHANNEL NOT BUSY */
         NI    CATBSY(CATPTR),B'01111111'                          0166
*            END;                                                  0167
*/********************************************************************/
*/*                                                                  */
*/*         FIND UCB FOR DEVICE WHICH CAUSED INTERRUPT               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0168
*/********************************************************************/
*/*  VALIDITY CHECK THE INTERRUPT ADDRESS                            */
*/********************************************************************/
*    RFY (WRK0,WRK1,WRK3,WRK5) RSTD;                               0168
@RF00158 DS    0H                                                  0169
*    WRK0=FLCIOA;                      /* GET INTERRUPT ADDRESS      */
         L     WRK0,FLCIOA                                         0169
*    GEN CODE(  SRDL WRK0,3 );         /* SHIFT 3 LOW ORDER BITS INTO
*                                         NEXT REGISTER              */
           SRDL WRK0,3
*    WRK3=(IOCUCBBM+WRK0)->BITMASK;    /* PICK UP UCB BIT MASK USING
*                                         CONTENTS OF WRK0 AS INDEX  */
         L     @10,CVTPTR                                          0171
         L     @10,IOCOMPTR(,@10)                                  0171
         LR    @09,WRK0                                            0171
         AL    @09,IOCUCBBM(,@10)                                  0171
         SLR   WRK3,WRK3                                           0171
         IC    WRK3,BITMASK(,@09)                                  0171
*    GEN CODE( SRL WRK1,29);           /* SHIFT 3 BITS TO LOW END    */
          SRL WRK1,29
*    WRK5=X80;                         /* GET BIT READY POSITION     */
         L     WRK5,X80                                            0173
*    GEN CODE( SRL WRK5,0(WRK1));      /* SHIFT BIT INTO AND POSITION*/
          SRL WRK5,0(WRK1)
*    WRK5=WRK5&WRK3;                   /* CHECK IF BIT ON IN MASK    */
         NR    WRK5,WRK3                                           0175
*    BC( SEVEN,VCINT100);              /* BRANCH IF VALID DEVICE     */
         BC    7,VCINT100                                          0176
*/********************************************************************/
*/*  INVALID DEVICE - ZERO UCB POINTER                               */
*/********************************************************************/
*    UCBPTR=ZERO;                      /* ZERO UCB POINTER           */
         SLR   UCBPTR,UCBPTR                                       0177
*    GOTO VCINT200;                    /* GO CHECK IF CALLED BY HIO  */
         B     VCINT200                                            0178
*/********************************************************************/
*/*  VALID DEVICE - DO UCB LOOK UP                                   */
*/********************************************************************/
*VCINT100: ;                                                       0179
VCINT100 DS    0H                                                  0180
*    GEN CODE( SRDL WRK0,5);           /* SHIFT CU TO NEXT REGISTER  */
          SRDL WRK0,5
*    GEN CODE( SRL  WRK1,28);          /* SHIFT TO LOW ORDER END AND
*                                         DROP LEFT OVER DEVICE BIT  */
          SRL  WRK1,28
*    WRK3=(CVTILK1+WRK0)->CHANCON;     /* GET CHANNEL CONSTANT       */
         L     @09,CVTPTR                                          0182
         L     @08,CVTILK1(,@09)                                   0182
         LR    @07,WRK0                                            0182
         ALR   @07,@08                                             0182
         SLR   WRK3,WRK3                                           0182
         IC    WRK3,CHANCON(,@07)                                  0182
*    WRK1=WRK3+WRK1;                   /* GET TWO TIMES CONTROL UNIT */
         ALR   WRK1,WRK3                                           0183
*    WRK1=WRK1+WRK1;                   /* PLUS CHANNEL CONST @ZA08721*/
         ALR   WRK1,WRK1                                           0184
*    WRK3=FLCIOA;                      /* GET INTERRUPT ADDRESS      */
         L     WRK3,FLCIOA                                         0185
*    WRK5=WRK3&ONEFOX;                 /* ISOLATE DEVICE ADDRESS     */
         LR    WRK5,WRK3                                           0186
         N     WRK5,ONEFOX                                         0186
*    WRK3=(CVTILK1+WRK1)->CUCON;       /* GET CU CONSTANT            */
         ALR   @08,WRK1                                            0187
         SLR   WRK3,WRK3                                           0187
         ICM   WRK3,3,CUCON(@08)                                   0187
*    WRK3=WRK3+WRK5;                   /* ADD TO DEVICE NUMBER       */
         ALR   WRK3,WRK5                                           0188
*    WRK3=WRK3+WRK3;                   /* DOUBLE SUM                 */
         ALR   WRK3,WRK3                                           0189
*    UCBPTR=(CVTILK2+WRK3)->UCBADDR;   /* GET ADDRESS OF UCB         */
         LR    @08,WRK3                                            0190
         AL    @08,CVTILK2(,@09)                                   0190
         SLR   UCBPTR,UCBPTR                                       0190
         ICM   UCBPTR,3,UCBADDR(@08)                               0190
*/********************************************************************/
*/*         SET UP ACTIVE IOQ FOR FRR                                */
*/********************************************************************/
*    IRTIOQ=UCBIOQ;                    /* PUT ACTIVE IOQ IN IRT      */
         LA    @09,736                                             0191
         AL    @09,LCCAPTR                                         0191
         LR    @08,UCBPTR                                          0191
         AL    @08,@CF03026                                        0191
         MVC   IRTIOQ(4,@09),UCBIOQ-508(@08)                       0191
*    IRTIOQA=ON;                       /* INDICATE ACTIVE IOQ        */
         OI    IRTIOQA(@09),B'00000100'                            0192
*/********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*      IF CALLED BY HIO PASS INTERRUPT TO HIO ENTRY OF IOS SLIH    */
*/*                                                                  */
*/********************************************************************/
*VCINT200: ;                                                       0193
VCINT200 DS    0H                                                  0194
*    IF CRCAHIO=ON                     /* HIO ENTRY ?                */
*       THEN DO;                       /* YES - PROCESS HIO INTERRUPT*/
         TM    CRCAHIO(CRCAPTR),B'00010000'                        0194
         BNO   @RF00194                                            0194
*            CRCAMCWM=OFF;             /* SET UP MCW TO BREAK CRH  0196
*                                         CONNECTION                 */
         NI    CRCAMCWM(CRCAPTR),B'11101111'                       0196
*            GEN CODE REFS(CRCAMCW,CRCAPTR,CRCA);                  0197
             USING CRCA,CRCAPTR        ESTABLISH ADDRESSABILITY
             DC X'8300',S(CRCAMCW)     ISSUE DIAGNOSE
             DROP CRCAPTR
*            CRCADIAG=OFF;             /* INDICATE NO CRH CONNECTION */
         NI    CRCADIAG(CRCAPTR),B'01111111'                       0198
*            IF UCBPTR=0               /* CHECK IF VALID DEVICE      */
*               THEN CRCADINT=ON;      /* NO- INVALID CRH INTERRUPT  */
         LTR   UCBPTR,UCBPTR                                       0199
         BNZ   @RF00199                                            0199
         OI    CRCADINT(CRCAPTR),B'01000000'                       0200
*               ELSE UCBIORST=ON;      /* YES-INDICATE CRH INTERRUPT */
         B     @RC00199                                            0201
@RF00199 OI    UCBIORST(UCBPTR),B'10000000'                        0201
*            CRCAHIO=OFF;              /* TURN OFF HIO ENTRY FLAG    */
@RC00199 NI    CRCAHIO(CRCAPTR),B'11101111'                        0202
*            GEN (SETFRR D,WRKREGS=(WRK1,WRK3));  /* DELETE FRR      */
         SETFRR D,WRKREGS=(WRK1,WRK3)
*            SETFRRC=OFF;              /* INDICATE NO FRR            */
         NI    SETFRRC,B'11011111'                                 0204
*            CINTENT=ADDR(IECINT);     /* GET ADDRESS OF IOS SLIH  0205
*                                         HIO ENTRY          @ZA27164*/
         L     @09,CVTPTR                                          0205
         L     @09,IOCOMPTR(,@09)                                  0205
         L     CINTENT,IOCINT(,@09)                                0205
*/********************************************************************/
*/*  NOTE: REGISTER 11 CONTAINS AN ENVIRONMENT CODE WHICH MUST BE    */
*/*        MUST BE PASSED TO HIO ENTRY OF SLIH.                      */
*/********************************************************************/
*            GEN( B 4(CINTENT));       /* CALL IOS SLIH - RETURN   0206
*                                         REGISTER 4 IS PASSED TO IOS
*                                         SLIH THEREFOR IECINT RETURNS
*                                         DIRECTLY TO HIO    @ZA27164*/
          B 4(CINTENT)
*            END;                                                  0207
*    RFY (WRK1,WRK3) UNRSTD;                                       0208
@RF00194 DS    0H                                                  0209
*/********************************************************************/
*/*                                                                  */
*/*        NORMAL ENTRY - PROCESS INTERRUPT AND PASS TO IOS SLIH     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0209
*    IF CRCADIAG=ON                    /* CRH CONNECTION OUTSTANDING?*/
*/********************************************************************/
*/*          INTERRUPT WAS SOLICITED ACROSS CRH CONNECTION           */
*/********************************************************************/
*       THEN DO;                       /* YES-INTERRUPT ACROSS CRH   */
         TM    CRCADIAG(CRCAPTR),B'10000000'                       0209
         BNO   @RF00209                                            0209
*            CRCAMCWM=OFF;             /* SET UP MCW TO BREAK CRH  0211
*                                         CONNECTION                 */
         NI    CRCAMCWM(CRCAPTR),B'11101111'                       0211
*            GEN CODE REFS(CRCAMCW,CRCAPTR,CRCA);                  0212
             USING CRCA,CRCAPTR        ESTABLISH ADDRESSABILITY
             DC X'8300',S(CRCAMCW)     ISSUE DIAGNOSE
             DROP CRCAPTR
*            CRCADIAG=OFF;             /* INDICATE NO CRH CONNECTION */
         NI    CRCADIAG(CRCAPTR),B'01111111'                       0213
*            GEN CODE( LCTL CTL2,CTL2,SAVECTL2 );  /* RESTORE SYSTEM
*                                                     CONTROL REG2   */
          LCTL CTL2,CTL2,SAVECTL2
*            IF UCBPTR^=0              /* CHECK IF VALID DEVICE      */
*               THEN DO;               /* VALID DEVICE               */
         LTR   UCBPTR,UCBPTR                                       0215
         BZ    @RF00215                                            0215
*                    IF UCK=ON|        /* WILL SENSE BE REQUIRED ?   */
*                       CDC=ON|                                    0217
*                       CCC=ON|                                    0217
*                       ICC=ON                                     0217
*                       THEN UCBCRHSN=ON; /* YES, INDICATE IN UCB    */
         TM    UCK,B'00000010'                                     0217
         BO    @RT00217                                            0217
         TM    CDC,B'00001110'                                     0217
         BZ    @RF00217                                            0217
@RT00217 DS    0H                                                  0218
         OI    UCBCRHSN(UCBPTR),B'00000100'                        0218
*                       ELSE;                                      0219
@RF00217 DS    0H                                                  0220
*                    IF (UCBBSY=ON) &  /* EXPECTED I/O INTERRUPT ?   */
*                       (UCBIORST=OFF) /*BUT NOT STARTED ACROSS CRH ?*/
*                       THEN IF CDC=ON|  /* YES, CHANNEL DATA CHECK? */
         TM    UCBBSY(UCBPTR),B'10000000'                          0220
         BNO   @RF00220                                            0220
         TM    UCBIORST(UCBPTR),B'10000000'                        0220
         BNZ   @RF00220                                            0220
*                               CCC=ON|  /* CHANNEL CONTROL CHECK ?  */
*                               ICC=ON   /* INTERFACE CHANNEL CHECK ?*/
*                               THEN CRCACCH=ON; /*INDICATE ERRORS ON
*                                                  INTERRUPT TO IOS  */
         TM    CDC,B'00001110'                                     0221
         BZ    @RF00221                                            0221
         OI    CRCACCH(CRCAPTR),B'00100000'                        0222
*                               ELSE;  /*                    @ZA16176*/
@RF00221 DS    0H                                                  0224
*                       ELSE;                                      0224
@RF00220 DS    0H                                                  0225
*                    END;              /* END VALID DEVICE           */
*               ELSE CRCADINT=ON;      /* INDICATE INVALID CRH INT.  */
         B     @RC00215                                            0226
@RF00215 OI    CRCADINT(CRCAPTR),B'01000000'                       0226
*            ENVCODE=CRHINT;           /* SET UP REG 11 FOR CRH    0227
*                                         INTERRUPT          @ZA16177*/
@RC00215 L     ENVCODE,CRHINT                                      0227
*            END;                      /* END INTERRUPT ACROSS CRH   */
*/********************************************************************/
*/*          INTERRUPT WAS NOT SOLICITED ACROSS CRH CONNECTION       */
*/********************************************************************/
*       ELSE DO;                       /* INTERRUPT NOT ACROSS CRH   */
         B     @RC00209                                            0229
@RF00209 DS    0H                                                  0230
*            GEN CODE(STCTL CTL2,CTL2,SAVECTL2 ); /* SAVE SYSTEM   0230
*                                                    CONTROL REG2    */
         STCTL CTL2,CTL2,SAVECTL2
*            IF UCBPTR^=0              /* CHECK IF VALID DEVICE      */
*               THEN DO;               /* VALID DEVICE               */
         LTR   UCBPTR,UCBPTR                                       0231
         BZ    @RF00231                                            0231
*                    IF UCK=ON|        /* WILL SENSE BE REQUIRED ?   */
*                       CDC=ON|                                    0233
*                       CCC=ON|                                    0233
*                       ICC=ON                                     0233
*                       THEN UCBCRHSN=OFF; /* ENSURE FLAG OFF        */
         TM    UCK,B'00000010'                                     0233
         BO    @RT00233                                            0233
         TM    CDC,B'00001110'                                     0233
         BZ    @RF00233                                            0233
@RT00233 DS    0H                                                  0234
         NI    UCBCRHSN(UCBPTR),B'11111011'                        0234
*                       ELSE;                                      0235
@RF00233 DS    0H                                                  0236
*                                      /* 8 LINES DELETED    @ZA16176*/
*                    END;              /* END VALID DEVICE           */
*               ELSE;                  /*INVALID DEVICE-PASS TO SLIH */
@RF00231 DS    0H                                                  0238
*            ENVCODE=NORMINT;          /* SET UP REG 11 FOR NORMAL 0238
*                                         INTERRUPT          @ZA16177*/
         L     ENVCODE,NORMINT                                     0238
*            END;                      /* END NOT CRH INTERRUPT      */
*                                                                  0239
*/********************************************************************/
*/*  PASS I/O INTERRUPT TO IOS SLIH IECINT VIA BALR 4,5              */
*/********************************************************************/
*    CINTENT=ADDR(IECINT);             /* GET ADDRESS OF IOS SLIH (REG
*                                         11 ALREADY SET UP) @ZA27164*/
@RC00209 L     @10,CVTPTR                                          0240
         L     @01,IOCOMPTR(,@10)                                  0240
         L     CINTENT,IOCINT(,@01)                                0240
*    GEN CODE ( BAL CINTRET,4(CINTENT) )                           0241
*              REFS( CINTRET,CINTENT); /* CALL I/O SLIH      @ZA27164*/
          BAL CINTRET,4(CINTENT)
*    CRCAPTR=CVTCRCA;                  /* RESTORE POINTER TO CRCA    */
         L     @10,CVTPTR                                          0242
         L     CRCAPTR,CVTCRCA(,@10)                               0242
*    BASE=CRCACINT;                    /* RESTORE BASE REGISTER      */
         L     BASE,CRCACINT(,CRCAPTR)                             0243
*/********************************************************************/
*/*                                                                  */
*/*     POLL ALL CHANNELS ON DEAD CPU THRU CRH BY SELECTIVELY        */
*/*     ENABLING FOR INTERRUPTS FROM EACH CHANNEL.                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0244
*    POLLCHAN=ZERO;                    /* BEGIN POLLING WITH CHAN. 0 */
         MVI   POLLCHAN,X'00'                                      0244
*    GEN CODE ( LCTL  CTL2,CTL2,ENABLE6 )                          0245
*    REFS(ENABLE6) SETS(CTL2);        /* ENABLE INTERRUPTS ONLY    0245
*                                         ACROSS CHANNEL 6           */
          LCTL  CTL2,CTL2,ENABLE6
*/********************************************************************/
*/*  INDEX THRU ALL VALID CHANNELS ON THIS CPU                       */
*/********************************************************************/
*    DO WHILE POLLCHAN<=IOXHICH;       /* HIGHEST CHANNEL SYSGENED ? */
         B     @DE00246                                            0246
@DL00246 DS    0H                                                  0247
*       CATPTR=CRCACAT+(POLLCHAN*EIGHT); /* INDEX TO CAT           0247
*                                                    ENTRY FOR CHAN. */
         SLR   CATPTR,CATPTR                                       0247
         IC    CATPTR,POLLCHAN                                     0247
         SLA   CATPTR,3                                            0247
         AL    CATPTR,CRCACAT(,CRCAPTR)                            0247
*       IF CATNGEN=ON|                 /* CHANNEL NOT SYSGENED ?     */
*          CATNCPU=ON                  /* CHANNEL NOT ON DEAD CPU ?  */
*          THEN;                       /* YES - BUMP TO NEXT CHANNEL */
         TM    CATNGEN(CATPTR),B'00110000'                         0248
         BNZ   @RT00248                                            0248
*          ELSE DO;                    /* CHANNEL VALID - POLL CHAN. */
*               /*****************************************************/
*               /*  MAKE CRH CONNECTION TO CHANNEL ON DEAD CPU       */
*               /*****************************************************/
*               CRCAMCWF=POLLCHAN;     /* SET UP MCW TO USE THIS CHAN*/
         MVC   CRCAMCWF(1,CRCAPTR),POLLCHAN                        0251
*               CRCACHAN=POLLADDR;     /* SAVE REMOTE CHANNEL ADDRESS*/
         MVC   CRCACHAN(2,CRCAPTR),POLLADDR                        0252
*               CRCAMCWI=ON;           /* INDICATE MCW FOR CRH       */
*               CRCAMCWM=ON;           /* INDICATE MAKE CONNECTION   */
         OI    CRCAMCWI(CRCAPTR),B'00110000'                       0254
*               CRCADIAG=ON;           /* INDICATE CRH CONNECTION  0255
*                                         OUTSTANDING                */
         OI    CRCADIAG(CRCAPTR),B'10000000'                       0255
*               GEN CODE REFS(CRCAMCW,CRCAPTR,CRCA);               0256
                USING CRCA,CRCAPTR        ESTABLISH ADDRESSABILITY
                DC X'8300',S(CRCAMCW)     ISSUE DIAGNOSE
                DROP CRCAPTR
*               /*****************************************************/
*               /*  SOLICIT AN I/O INTERRUPT ACROSS CRH CONNECTION   */
*               /*****************************************************/
*               GEN CODE REFS(SAVEMASK,ENABLEIO,DISABLE);          0257
                STOSM SAVEMASK,ENABLEIO       ENABLE
                STNSM SAVEMASK,DISABLE        DISABLE
*               END;                                               0258
*       POLLCHAN=POLLCHAN+ONE;         /* BUMP TO NEXT CHANNEL NUMBER*/
@RT00248 IC    @01,POLLCHAN                                        0259
         LA    @01,1(,@01)                                         0259
         STC   @01,POLLCHAN                                        0259
*    END;                                                          0260
@DE00246 L     @10,CVTPTR                                          0260
         L     @01,IOCOMPTR(,@10)                                  0260
         L     @01,IOCXPTR(,@01)                                   0260
         CLC   POLLCHAN(1),IOXHICH(@01)                            0260
         BNH   @DL00246                                            0260
*/********************************************************************/
*/*                                                                  */
*/*                   EXIT ROUTINE                                   */
*/*                                                                  */
*/********************************************************************/
*    IF CRCADIAG=ON                    /* CRH CONNECTION OUTSTANDING?*/
*       THEN DO;                       /* YES                        */
         TM    CRCADIAG(CRCAPTR),B'10000000'                       0261
         BNO   @RF00261                                            0261
*            CRCAMCWM=OFF;             /* INDICATE BREAK CONNECTION  */
         NI    CRCAMCWM(CRCAPTR),B'11101111'                       0263
*            GEN CODE REFS(CRCAMCW,CRCAPTR,CRCA,SAVECTL2) SETS(CTL2);
             LCTL CTL2,CTL2,SAVECTL2      RESTORE SYSTEM CONTROL REG2
             USING CRCA,CRCAPTR           ESTABLISH ADDRESSABILITY
             DC X'8300',S(CRCAMCW)        ISSUE DIAGNOSE
             DROP CRCAPTR
*            CRCADIAG=OFF;             /* INDICATE NO CRH CONNECTION */
         NI    CRCADIAG(CRCAPTR),B'01111111'                       0265
*            END;                                                  0266
*    RFY (WRK1,WRK3) RSTD;                                         0267
@RF00261 DS    0H                                                  0268
*    GEN CODE (SETFRR D,WRKREGS=(WRK1,WRK3))                       0268
*             SETS(WRK1,WRK3);         /* DELETE FRR                 */
         SETFRR D,WRKREGS=(WRK1,WRK3)
*    SETFRRC=OFF;                      /* INDICATE NO FRR            */
         NI    SETFRRC,B'11011111'                                 0269
*    CINTRET=SAVERET;                  /* RESTORE RETURN REGISTER 4  */
         L     CINTRET,SAVERET                                     0270
*    GEN CODE REFS(CINTRET);                                       0271
     BR  CINTRET                       RETURN TO CALLER
*    RFY (CINTRET,CINTENT,WRK1,WRK3) UNRSTD;                       0272
*/*********************************************************************
**                                                                 0273
** ENTRY NAME - IECVCRHA                                           0273
**                                                                 0273
** DESCRIPTIVE NAME - CRH ACTIVATION ROUTINE.                      0273
**                                                                 0273
** FUNCTION - THIS ENTRY WILL PERFORM THE INITIALIZATION REQUIRED TO
**            ALLOW THE OS/VS2 SYSTEM TO USE THE CHANNEL           0273
**            RECONFIGURATION HARDWARE IN ORDER TO ACCESS A DEVICE 0273
**            ON A DEAD CPU FROM THE CPU WHICH IS STILL RUNNING IN 0273
**            A 168MP ENVIRONMENT.                                 0273
**                                                                 0273
**  LINKAGE - STANDARD LINKAGE IS USED ON ENTRY AND EXIT           0273
**            NON-STANDARD LINKAGE IS USED FOR CALL TO IECVSMGR    0273
**                                                                 0273
**  INPUT                                                          0273
**      REGISTERS - SAVEPTR  (REGISTER 13) POINTS TO 18 WORD SAVE AREA
**                  RETRNREG (REGISTER 14) ADDRESS OF RETURN POINT 0273
**                  ENTRYREG (REGISTER 15) ADDRESS OF IECVCRHA     0273
**                                                                 0273
**  OUTPUT                                                         0273
**      REGISTERS - RETCODE  (REGISTER 15) SEE EXIT                0273
**                                                                 0273
**   EXIT - NORMAL - RETURN TO CALLER WITH RETURN CODE OF 0        0273
**                                                                 0273
**   EXIT - ERROR - RETURN TO CALLER WITH RETURN CODE              0273
**                  RC=4  CRH ALREADY ACTIVE                       0273
**                  RC=8  UNABLE TO ACTIVATE                       0273
**                  RC=12 NOT ON A 168MP SYSTEM                    0273
**                                                                 0273
**********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*           ESTABLISH ADRESSABILITY AND ENVIRONMENT                */
*/*                                                                  */
*/********************************************************************/
*/* IECVCRHA: ENTRY                       ENTRY POINT FOR ACTIVATION */
*/********************************************************************/
*/*      STANDARD ENTRY LINKAGE                                      */
*/********************************************************************/
*    GEN   CODE DEFS(IECVCRHA)                                     0273
*          REFS(IECVCRHA,RETRNREG,BASE,SAVEPTR,ENTRYREG,MYSAVE,CALLER);
IECVCRHA   DS 0F                           ENTRY POINT
     STM   RETRNREG,BASE,SAVREGS(SAVEPTR)  SAVE CALLERS REGISTERS
     LR    BASE,ENTRYREG                   LOAD BASE REGISTER
     USING IECVCRHA,BASE                   INDICATE ADDRESSABILITY
     LA    RETRNREG,MYSAVE                 GET ADDRESS OF MY SAVE AREA
     ST    RETRNREG,CALLED(SAVEPTR)        STORE IN CALLERS SAVE AREA
     ST    SAVEPTR,CALLER(RETRNREG)        SAVE PTR TO CALLERS AREA
     LR    SAVEPTR,RETRNREG                POINT REG13 TO MY SAVE AREA
*/********************************************************************/
*/*  DISABLE FOR INTERRUPTS AND PROVIDE FRR COVERAGE                 */
*/********************************************************************/
*    FOOTPRNT=ZERO;                    /* ZERO PROGRESS FLAGS        */
         SLR   @10,@10                                             0274
         ST    @10,FOOTPRNT                                        0274
*    RFY (WRK4,WRK5) RSTD;                                         0275
*    GEN CODE REFS(DISABLE,SAVEMASK,WRK4,WRK5);                    0276
     STNSM SAVEMASK,DISABLE            DISABLE FOR I/O AND EXT. INTER.
     SETFRR  A,FRRAD=CRHAF,WRKREGS=(WRK4,WRK5)
*/********************************************************************/
*/*  WHEN CALLED BY VARY IECVCRHA NEEDS THE IOS SUPER BIT ON SO THAT */
*/*  MY FRR WILL GET CONTROL RATHER THAN THE VARY ESTAE EXIT.        */
*/********************************************************************/
*    IF PSAIOSUP=OFF                   /* CHECK IF IOS SUPER BIT ON  */
*       THEN DO;                       /* NEED SUPER BIT FOR FRR     */
         TM    PSAIOSUP,B'10000000'                                0277
         BNZ   @RF00277                                            0277
*            PSAIOSUP=ON;              /* TURN IT ON                 */
         OI    PSAIOSUP,B'10000000'                                0279
*            IOSUP=ON;                 /* INDICATE I TURNED IT ON    */
         OI    IOSUP,B'10000000'                                   0280
*            END;                                                  0281
*    SETFRRA=ON;                       /* INDICATE FRR COVERAGE      */
@RF00277 OI    SETFRRA,B'10000000'                                 0282
*    RFY (WRK4,WRK5) UNRSTD;                                       0283
*/********************************************************************/
*/*                                                                  */
*/*               CHECK FOR ERROR CONDITIONS                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0284
*/********************************************************************/
*/*  MAKE SURE WE ARE RUNNING ON A 168MP SYSTEM                      */
*/********************************************************************/
*    IF PSACPUSA=ZERO                  /* ARE WE RUNNING ON CPU 0?   */
*       THEN INDEX=ZERO;               /* YES - CPU ID IS ZERO       */
         ICM   @10,3,PSACPUSA                                      0284
         BNZ   @RF00284                                            0284
         SLR   INDEX,INDEX                                         0285
*       ELSE INDEX=FOUR;               /* NO - CPU ID IS FOUR        */
         B     @RC00284                                            0286
@RF00284 LA    INDEX,4                                             0286
*    IF (PCCACPID(9:12)^=CPU168)|(CSDMP=OFF)                       0287
*       THEN DO;                                                   0287
@RC00284 L     @10,CVTPTR                                          0287
         LR    @01,INDEX                                           0287
         AL    @01,CVTPCCAT(,@10)                                  0287
         L     @01,PCCAPTR(,@01)                                   0287
         CLC   PCCACPID+8(4,@01),CPU168                            0287
         BNE   @RT00287                                            0287
         L     @01,CVTCSD(,@10)                                    0287
         TM    CSDMP(@01),B'10000000'                              0287
         BNZ   @RF00287                                            0287
@RT00287 DS    0H                                                  0288
*            IOXCRHA=ZERO;             /* ZERO POINTER TO IECVCRHA   */
         L     @10,CVTPTR                                          0289
         L     @01,IOCOMPTR(,@10)                                  0289
         L     @01,IOCXPTR(,@01)                                   0289
         SLR   @10,@10                                             0289
         ST    @10,IOXCRHA(,@01)                                   0289
*            RETCODE = TWELVE;         /* SETUP RETURN CODE          */
         LA    RETCODE,12                                          0290
*            GOTO CRHAEXIT;            /* CALL EXIT SUBROUTINE       */
         B     CRHAEXIT                                            0291
*            END;                                                  0292
*/********************************************************************/
*/*  CHECK WHETHER DSS IS ACTIVE                                     */
*/********************************************************************/
*    IF CVTDSSAC=FF                    /* TEST WHETHER DSS ACTIVE    */
*       THEN DO;                       /* YES, DO NOT ACTIVATE CRH   */
@RF00287 L     @10,CVTPTR                                          0293
         CLC   CVTDSSAC(1,@10),FF                                  0293
         BNE   @RF00293                                            0293
*            GEN CODE REFS(IEA989I);                               0295
             RECORD  TYPE=WTO,DATAADR=IEA989I,BUFFER=NO,RCVRY=SETFRR,LEX
                NGTH=LIEA989I
*            RETCODE=EIGHT;            /* INDICATE UNABLE TO ACTIVATE*/
         LA    RETCODE,8                                           0296
*            GOTO CRHAEXIT;            /* GO RETURN TO CALLER        */
         B     CRHAEXIT                                            0297
*            END;                                                  0298
*/********************************************************************/
*/*  CHECK WHETHER CRH HAS ALREADY BEEN ACTIVATED                    */
*/********************************************************************/
*    IF CVTCRCA^=ZERO                  /* IS CRCA POINTER ZERO       */
*       THEN DO;                                                   0299
@RF00293 L     @10,CVTPTR                                          0299
         ICM   @03,15,CVTCRCA(@10)                                 0299
         BZ    @RF00299                                            0299
*            RETCODE=FOUR;             /* SET UP RETURN CODE         */
         LA    RETCODE,4                                           0301
*            GOTO CRHAEXIT;            /* CALL EXIT SUBROUTINE       */
         B     CRHAEXIT                                            0302
*            END;                                                  0303
*    CVTCRCA = ADDR(IECVCRCA);         /* A NON-ZERO POINTER TO CRCA
*                                         INDICATES CRH IS ACTIVE    */
@RF00299 L     @10,@CA02779                                        0304
         L     @03,CVTPTR                                          0304
         ST    @10,CVTCRCA(,@03)                                   0304
*    CRCAPTR=CVTCRCA;                  /* SET UP ADDRESSABILITY      */
         LR    CRCAPTR,@10                                         0305
*    CRCAFTIM=ON;                        /* TURN ON 1ST TIME @ZM30496
*                                           SWITCH FOR SWITCH        */
         OI    CRCAFTIM(CRCAPTR),B'00001000'                       0306
*    CRHSADDR=CRHS;                      /* ADDR OF SRB SCHED@ZM30496
*                                           RTN FOR TIMER SLIH       */
         L     @10,@CA02758                                        0307
         MVC   CRHSADDR-CRHSADDR(4,@10),CRHS                       0307
*/********************************************************************/
*/*  INITIALIZE CRH COMMUNICATION AREA (CRCA)                        */
*/********************************************************************/
*    IF PSACPUSA=ZERO                  /* ARE WE RUNNING ON CPU 0 ?  */
*       THEN INDEX=FOUR;               /* YES-DEAD CPU ID IS ONE     */
         ICM   @10,3,PSACPUSA                                      0308
         BNZ   @RF00308                                            0308
         LA    INDEX,4                                             0309
*       ELSE INDEX=ZERO;               /* NO - DEAD CPU ID IS ZERO   */
         B     @RC00308                                            0310
@RF00308 SLR   INDEX,INDEX                                         0310
*    CRCAPCCA=(CVTPCCAT+INDEX)->PCCAPTR; /* GET VIRTUAL ADDRESS OF 0311
*                                           PCCA FOR DEAD CPU        */
@RC00308 L     @10,CVTPTR                                          0311
         LR    @01,INDEX                                           0311
         AL    @01,CVTPCCAT(,@10)                                  0311
         L     @01,PCCAPTR(,@01)                                   0311
         ST    @01,CRCAPCCA(,CRCAPTR)                              0311
*    CRCACAT=ADDR(PCCACAT);            /* GET CAT FOR DEAD CPU       */
         LA    @01,PCCACAT(,@01)                                   0312
         ST    @01,CRCACAT(,CRCAPTR)                               0312
*/********************************************************************/
*/*                                                                  */
*/*                 HOOK INTO OS/VS2 SYSTEM                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0313
*/********************************************************************/
*/*  CHANGE ADDRESS OF SLIH IN THE I/O FLIH TO POINT TO IECVCINT     */
*/********************************************************************/
*    SLIHPTR=ADDR(IECVCINT);           /* POINT TO CRH SLIH-IECVCINT */
         L     @03,@CA02782                                        0313
         L     @01,@CA00028                                        0313
         ST    @01,SLIHPTR-IEAVEIOI(,@03)                          0313
*    SLIHCHNG=ON;                      /* INDICATE POINTER TO SLIH 0314
*                                         WAS CHANGED                */
         OI    SLIHCHNG,B'00010000'                                0314
*/********************************************************************/
*/*  PUT HOOKS IN IOS MAINLINE - IECIOSCN                            */
*/********************************************************************/
*    SAVEHK1=IECVHK1A;                 /* SAVE OVERLAID INSTRUCTION  */
         L     @03,@CA02759                                        0315
         MVC   SAVEHK1(4),IECVHK1A-IECVHK1A(@03)                   0315
*    IECVHK1A=IECVHK1B;                /* OVERLAY INSTRUCTION        */
         L     @01,@CA02760                                        0316
         MVC   IECVHK1A-IECVHK1A(4,@03),IECVHK1B-IECVHK1B(@01)     0316
*    TCHHOOK=ON;                       /* INDICATE TCH HOOK IN       */
         OI    TCHHOOK,B'00001000'                                 0317
*    SAVEHK2=IECVHK2A;                 /* SAVE OVERLAID INSTRUCTION  */
         L     @03,@CA02761                                        0318
         MVC   SAVEHK2(4),IECVHK2A-IECVHK2A(@03)                   0318
*    IECVHK2A=IECVHK2B;                /* OVERLAY INSTRUCTION        */
         L     @01,@CA02762                                        0319
         MVC   IECVHK2A-IECVHK2A(4,@03),IECVHK2B-IECVHK2B(@01)     0319
*    SIOHOOK=ON;                       /* INDICATE SIO HOOK IN       */
         OI    SIOHOOK,B'00000100'                                 0320
*    SAVEHK3=IECVHK3A;                 /* SAVE OVERLAID INSTRUCTION  */
         L     @03,@CA02763                                        0321
         MVC   SAVEHK3(4),IECVHK3A-IECVHK3A(@03)                   0321
*    IECVHK3A=IECVHK3B;                /* OVERLAY INSTRUCTION        */
         L     @01,@CA02764                                        0322
         MVC   IECVHK3A-IECVHK3A(4,@03),IECVHK3B-IECVHK3B(@01)     0322
*    SNSHOOK=ON;                       /* INDICATE SENSE HOOK IN     */
         OI    SNSHOOK,B'00000010'                                 0323
*/********************************************************************/
*/*                                                                  */
*/*        SCAN THRU ALL UCBS FOR I/O ON DEAD CPU                    */
*/*                                                                  */
*/********************************************************************/
*    RFY UCBOB BASED(NXTUCB);          /* BASE UCBS ON UCB LOOKUP  0324
*                                         TABLE ENTRIES              */
*    RFY UCB BASED(NXTUCB-512);        /* BASE UCB PREFIX ON NXTUCB  */
*    RFY IOQ BASED(UCBIOQ);            /* BASE IOQ ON POINTER IN UCB */
*    LOOKUP=CVTILK2;                   /* GET POINTER TO UCB LOOK UP
*                                         TABLE                      */
         MVC   LOOKUP(4),CVTILK2(@10)                              0327
*    IF PSACPUSA=ZERO                  /* ARE WE RUNNING ON CPU 0 ?  */
*       THEN DEADCPU=ONE;              /* YES-DEAD CPU ID IS ONE     */
         ICM   @10,3,PSACPUSA                                      0328
         BNZ   @RF00328                                            0328
         MVI   DEADCPU,X'01'                                       0329
*       ELSE DEADCPU=ZERO;             /* NO - DEAD CPU ID IS ZERO   */
         B     @RC00328                                            0330
@RF00328 MVI   DEADCPU,X'00'                                       0330
*    SCANUCBS=ON;                      /* INDICATE UCBS BEING SCANNED
*                                         FOR I/O ON DEAD CPU        */
@RC00328 OI    SCANUCBS,B'00000001'                                0331
*    DO WHILE NXTUCB^=TABLEND;         /* CHECK FOR END OF TABLE     */
         B     @DE00332                                            0332
@DL00332 DS    0H                                                  0333
*       IF NXTUCB^=ZERO                /* ENSURE NONZERO UCB POINTER */
*          THEN IF UCBCPU=DEADCPU      /* LAST I/O STARTED TO DEAD ? */
         L     @10,LOOKUP                                          0333
         ICM   @03,3,NXTUCB(@10)                                   0333
         BZ    @RF00333                                            0333
*                  THEN DO;            /* YES                        */
         L     @10,LOOKUP                                          0334
         SLR   @01,@01                                             0334
         ICM   @01,3,NXTUCB(@10)                                   0334
         CLC   UCBCPU(1,@01),DEADCPU                               0334
         BNE   @RF00334                                            0334
*                       UCBCPU=UCBCPU&&ONE;/* SWITCH CPU ID          */
         L     @10,LOOKUP                                          0336
         SLR   @01,@01                                             0336
         ICM   @01,3,NXTUCB(@10)                                   0336
         L     @10,LOOKUP                                          0336
         SLR   @03,@03                                             0336
         ICM   @03,3,NXTUCB(@10)                                   0336
         SLR   @10,@10                                             0336
         IC    @10,UCBCPU(,@03)                                    0336
         X     @10,@CF00036                                        0336
         STC   @10,UCBCPU(,@01)                                    0336
*                       UCBIORST=ON;   /* INDICATE LAST PATH STARTED
*                                         WAS THRU DEAD CPU          */
         L     @10,LOOKUP                                          0337
         SLR   @01,@01                                             0337
         ICM   @01,3,NXTUCB(@10)                                   0337
         OI    UCBIORST(@01),B'10000000'                           0337
*                       IF UCBRESVH=ON /*CHECK IF RESERVE OUTSTANDING*/
*                          THEN UCBCRHRV=ON;/*YES,RESERVE ON DEAD CPU*/
         L     @10,LOOKUP                                          0338
         SLR   @01,@01                                             0338
         ICM   @01,3,NXTUCB(@10)                                   0338
         TM    UCBRESVH(@01),B'00010000'                           0338
         BNO   @RF00338                                            0338
         L     @10,LOOKUP                                          0339
         SLR   @01,@01                                             0339
         ICM   @01,3,NXTUCB(@10)                                   0339
         OI    UCBCRHRV(@01),B'00001000'                           0339
*                          ELSE;                                   0340
@RF00338 DS    0H                                                  0341
*                       IF UCBSPST=ON  /* ASSOCIATED SENSE IOQ ?     */
*                          THEN IF IOQENQ=ON&  /* IOQ ON A QUEUE ?   */
         L     @10,LOOKUP                                          0341
         SLR   @01,@01                                             0341
         ICM   @01,3,NXTUCB(@10)                                   0341
         TM    UCBSPST(@01),B'00100000'                            0341
         BNO   @RF00341                                            0341
*                                  IOQSLCH=ON  /*QUEUED ON SENSE LCH?*/
*                                  THEN UCBCRHSN=ON;/*NEED CRH SENSE */
         L     @10,LOOKUP                                          0342
         SLR   @01,@01                                             0342
         ICM   @01,3,NXTUCB(@10)                                   0342
         AL    @01,@CF03026                                        0342
         L     @01,UCBIOQ-508(,@01)                                0342
         TM    IOQENQ(@01),B'11000000'                             0342
         BNO   @RF00342                                            0342
         L     @10,LOOKUP                                          0343
         SLR   @01,@01                                             0343
         ICM   @01,3,NXTUCB(@10)                                   0343
         OI    UCBCRHSN(@01),B'00000100'                           0343
*                                  ELSE;                           0344
@RF00342 DS    0H                                                  0345
*                          ELSE;                                   0345
@RF00341 DS    0H                                                  0346
*                       END;                                       0346
*                  ELSE;               /*NOT LAST I/O STARTED TO DEAD*/
@RF00334 DS    0H                                                  0348
*          ELSE;                       /* ZERO UCB PTR,BUMP TO NEXT  */
@RF00333 DS    0H                                                  0349
*       LOOKUP=LOOKUP+TWO;             /* BUMP TO NEXT ENTRY IN UCB
*                                         LOOKUP TABLE - POINT TO  0349
*                                         NEXT UCB                   */
         LA    @10,2                                               0349
         AL    @10,LOOKUP                                          0349
         ST    @10,LOOKUP                                          0349
*    END;                                                          0350
@DE00332 L     @10,LOOKUP                                          0350
         CLC   NXTUCB(2,@10),TABLEND                               0350
         BNE   @DL00332                                            0350
*    IRTCHMSK=IOXCHMSK;                /* INSURE THAT ALL LOGICAL  0351
*                                         CHANNEL QUEUES ARE       0351
*                                         SEARCHED           @ZA16177*/
         L     @10,CVTPTR                                          0351
         L     @01,IOCOMPTR(,@10)                                  0351
         L     @01,IOCXPTR(,@01)                                   0351
         LH    @10,IOXCHMSK(,@01)                                  0351
         L     @03,LCCAPTR                                         0351
         ST    @10,IRTCHMSK+736(,@03)                              0351
*/********************************************************************/
*/*                                                                  */
*/*                 SCHEDULE SRB TO GET IECVCRHT DISPATCHED          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0352
*    SRBPTR=ADDR(SRBAREA);             /*                    @ZM30496*/
         LA    SRBPTR,SRBAREA                                      0352
*    SRBASCB=ADDR(IEAMASCB);           /* PUT IN ASCB ADDRESS        */
         L     @10,@CA02780                                        0353
         ST    @10,SRBASCB(,SRBPTR)                                0353
*    SRBEP=ADDR(IECVCRHT);             /* POINT SRB TO TIMER @ZM30496
*                                         POP ROUTINE                */
*                                                                  0354
         LA    @10,IECVCRHT                                        0354
         ST    @10,SRBEP(,SRBPTR)                                  0354
*/********************************************************************/
*/*  SCHEDULE GLOBAL SRB TO IECVCRHT                                 */
*/********************************************************************/
*    GEN CODE REFS(SRBPTR);                                        0355
     SCHEDULE SRB=(SRBPTR),SCOPE=GLOBAL  SCHEDULE GLOBAL SRB
*    SCHEDSRB=ON;                      /* INDICATE SRB SCHEDULED     */
         OI    SCHEDSRB,B'00100000'                                0356
*/********************************************************************/
*/*                                                                  */
*/*                       EXIT ROUTINE                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0357
*/********************************************************************/
*/*  ISSUE CRH ACTIVATION MESSAGE VIA RECORD FACILITY                */
*/********************************************************************/
*    GEN CODE REFS(IEA970I);                                       0357
     RECORD   TYPE=WTO,DATAADR=IEA970I,BUFFER=NO,RCVRY=SETFRR,LENGTH=LIX
               EA970I
*    RETCODE=ZERO;                     /* RETURN CODE = 0 ACTIVATION
*                                         COMPLETED SUCCESSFULLY     */
         SLR   RETCODE,RETCODE                                     0358
*/********************************************************************/
*/*  CLEANUP, SET UP RETURN CODE AND RETURN                          */
*/********************************************************************/
*CRHAEXIT: ;                           /* EXIT LINKAGE               */
CRHAEXIT DS    0H                                                  0360
*    IF IOSUP=ON                       /* DID I TURN ON IOS SUPER    */
*       THEN DO;                       /* YES I DID                  */
         TM    IOSUP,B'10000000'                                   0360
         BNO   @RF00360                                            0360
*            PSAIOSUP=OFF;             /* TURN IT OFF                */
         NI    PSAIOSUP,B'01111111'                                0362
*            IOSUP=OFF;                /* INDICATE IOSUP OFF         */
         NI    IOSUP,B'01111111'                                   0363
*            END;                                                  0364
*    RFY (WRK4,WRK5) RSTD;                                         0365
@RF00360 DS    0H                                                  0366
*    GEN CODE REFS(WRK4,WRK5);                                     0366
     SETFRR D,WRKREGS=(WRK4,WRK5)      DELETE FRR
     IC    WRK4,SAVEMASK               GET SAVED SYSTEM MASK
     EX    WRK4,STOSMA                 RESTORE SYSTEM MASK
     L     SAVEPTR,CALLER(SAVEPTR)     GET PTR TO CALLERS SAVE AREA
     L     RETRNREG,SAVREG14(SAVEPTR)  RESTORE RETURN REGISTER
     LM    REG0,BASE,SAVREG0(SAVEPTR)  RESTORE REGISTERS
     BR    RETRNREG                    RETURN TO CALLER WITH RC
STOSMA   STOSM  SAVEMASK,AZERO         RESTORE SYSTEM MASK
*    RFY (WRK4,WRK5) UNRSTD;                                       0367
*/********************************************************************/
*/*    ENTRY POINT FROM RTM ON FRR RETRY                             */
*/********************************************************************/
*CRHARTRY: ;                                                       0368
CRHARTRY DS    0H                                                  0369
*    RETCODE=EIGHT;                    /* SET UP RETURN CODE         */
         LA    RETCODE,8                                           0369
*    GO TO CRHAEXIT;                   /* GO TO EXIT ROUTINE         */
         B     CRHAEXIT                                            0370
*/*********************************************************************
**                                                                 0371
** ENTRY NAME - IECVCRHD                                           0371
**                                                                 0371
** DESCRIPTIVE NAME - CRH DEACTIVATION ROUTINE                     0371
**                                                                 0371
** FUNCTION - THIS ENTRY DEACTIVATES THE CHANNEL RECONFIGURATION   0371
**            HARDWARE FUNCTION IN THE OS/VS2 SYSTEM. IT REMOVES   0371
**            HOOKS IN IOS MAINLINE MODULE IECIOSCN, POINTS THE    0371
**            I/O FLIH BACK TO THE IOS SLIH AND PROCESSES THE UCBS 0371
**            FOR USE WITHOUT CRH. THE CRH FUNCTION IS LOGICALLY   0371
**            DEACTIVATED WHEN THE POINTER IN THE CVT (CVTCRCA)    0371
**            TO THE CRH COMMUNICATION AREA HAS BEEN ZEROED.       0371
**                                                                 0371
** LINKAGE - STANDARD LINKAGE                                      0371
**                                                                 0371
** INPUT                                                           0371
**                                                                 0371
**      REGISTERS - SAVEPTR  (REGISTER 13) POINTS TO 18 WORD SAVE AREA
**                  RETURN   (REGISTER 14) ADDRESS OF RETURN POINT 0371
**                  ENTRYREG (REGISTER 15) ADDRESS OF IECVCRHA     0371
**                                                                 0371
** OUTPUT - NONE                                                   0371
**                                                                 0371
** EXIT - NORMAL - RETURN TO CALLER WITH RETURN CODE OF 0          0371
**                                                                 0371
** EXIT - ERROR - RETURN TO CALLER WITH RETURN CODE                0371
**                  RC=4  CRH ALREADY ACITVE                       0371
**********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*           ESTABLISH ADRESSABILITY AND ENVIRONMENT                */
*/*                                                                  */
*/********************************************************************/
*/* IECVCRHD: ENTRY                       CRH DEACTIVATION ROUTINE   */
*/********************************************************************/
*/*      STANDARD ENTRY LINKAGE                                      */
*/********************************************************************/
*    GEN CODE DEFS(IECVCRHD)                                       0371
*        REFS(RETRNREG,BASE,SAVEPTR,ENTRYREG,MYSAVE,CALLER);       0371
IECVCRHD   DS  0F                          ENTRY POINT
     STM   RETRNREG,BASE,SAVREGS(SAVEPTR)  SAVE CALLERS REGISTERS
     LR    BASE,ENTRYREG                   LOAD BASE REGISTER
     USING IECVCRHD,BASE                   INDICATE ADDRESSABILITY
     LA    RETRNREG,MYSAVE                 GET ADDRESS OF MY SAVE AREA
     ST    RETRNREG,CALLED(SAVEPTR)        STORE IN CALLERS SAVE AREA
     ST    SAVEPTR,CALLER(RETRNREG)        SAVE PTR TO CALLERS AREA
     LR    SAVEPTR,RETRNREG                POINT REG13 TO MY SAVE AREA
*/********************************************************************/
*/*  DISABLE FOR INTERRUPTS AND PROVIDE FRR COVERAGE                 */
*/********************************************************************/
*    RFY (WRK4,WRK5) RSTD;                                         0372
*    GEN CODE REFS(DISABLE,SAVEMASK,WRK4,WRK5);                    0373
     STNSM SAVEMASK,DISABLE            DISABLE FOR I/O AND EXT. INTER.
     SETFRR  A,FRRAD=CRHDF,WRKREGS=(WRK4,WRK5)
*    RFY (WRK4,WRK5) UNRSTD;                                       0374
*    PSAIOSUP=ON;                      /* TURN ON IOS SUPER BIT SO 0375
*                                       THAT MY FRR WILL GET CONTROL
*                                       INSTEAD OF THE VARY ESTAE    */
         OI    PSAIOSUP,B'10000000'                                0375
*    SETFRRD=ON;                       /* INDICATE FRR COVERAGE      */
         OI    SETFRRD,B'01000000'                                 0376
*/********************************************************************/
*/*                                                                  */
*/*       MAKE SURE CRH FUNCTION IS ACTIVE AND THEN DEACTIVATE       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0377
*/********************************************************************/
*/*  CVTCRCA=0 INDICATES CRH NOT ACTIVE                              */
*/********************************************************************/
*    IF CVTCRCA=ZERO                   /* CHECK IF CRH ACTIVE        */
*       THEN DO;                       /* CRH NOT ACTIVE             */
         L     @10,CVTPTR                                          0377
         ICM   @03,15,CVTCRCA(@10)                                 0377
         BNZ   @RF00377                                            0377
*              RETCODE=FOUR;           /* INDICATE CRH NOT ACTIVE    */
         LA    RETCODE,4                                           0379
*              GOTO CRHDEXIT;          /* CALL EXIT ROUTINE          */
         B     CRHDEXIT                                            0380
*            END;                                                  0381
*    CVTCRCA=ZERO;                     /* INDICATE CRH NO LONGER   0382
*                                         ACTIVE                     */
@RF00377 L     @10,CVTPTR                                          0382
         SLR   @03,@03                                             0382
         ST    @03,CVTCRCA(,@10)                                   0382
*/********************************************************************/
*/*      ISSUE DEACTIVATION MESSAGE                                  */
*/********************************************************************/
*    GEN CODE REFS(IEA972I);                                       0383
     RECORD TYPE=WTO,DATAADR=IEA972I,BUFFER=NO,RCVRY=SETFRR,LENGTH=LIEAX
               972I
*/********************************************************************/
*/*  CALL SUBROUTINE TO BACK OUT CHANGES TO OS/VS SYSTEM FOR CRH     */
*/********************************************************************/
*    LOOKUP=CVTILK2;                   /* POINT TO FIRST ENTRY IN UCB
*                                         LOOK UP TABLE              */
         L     @10,CVTPTR                                          0384
         MVC   LOOKUP(4),CVTILK2(@10)                              0384
*    ENTRYREG=BACKAD;                  /* SET UP BASE REG FOR SUBTRN.*/
         L     ENTRYREG,BACKAD                                     0385
*    CALL BACKOUT;                     /* CALL BACKOUT SUBROUTINE    */
         BAL   @14,BACKOUT                                         0386
*/********************************************************************/
*/*                                                                  */
*/*                       EXIT ROUTINE                               */
*/*                                                                  */
*/********************************************************************/
*CRHDRTRY: ;                                                       0387
CRHDRTRY DS    0H                                                  0388
*    RETCODE=ZERO;                     /* INDICATE SUCCESSFUL      0388
*                                         DEACTIVATION               */
         SLR   RETCODE,RETCODE                                     0388
*CRHDEXIT: ;                           /* EXIT LINKAGE               */
CRHDEXIT DS    0H                                                  0390
*    PSAIOSUP=OFF;                     /* NO LONGER NEED SUPER BIT   */
         NI    PSAIOSUP,B'01111111'                                0390
*    RFY (WRK4,WRK5) RSTD;                                         0391
*    GEN CODE REFS(WRK4,WRK5);                                     0392
     SETFRR D,WRKREGS=(WRK4,WRK5)      DELETE FRR
     IC    WRK4,SAVEMASK               GET SAVED SYSTEM MASK
     EX    WRK4,STOSMD                 RESTORE SYSTEM MASK
     L     SAVEPTR,CALLER(SAVEPTR)     GET PTR TO CALLERS SAVE AREA
     L     RETRNREG,SAVREG14(SAVEPTR)  RESTORE RETURN REGISTER
     LM    REG0,BASE,SAVREG0(SAVEPTR)  RESTORE REGISTERS
     BR    RETRNREG                    RETURN TO CALLER WITH RC
STOSMD  STOSM  SAVEMASK,AZERO          RESTORE SYSTEM MASK
*    RFY (WRK4,WRK5) UNRSTD;                                       0393
*/*********************************************************************
**                                                                 0394
** ENTRY NAME - IECCRHAF                                           0394
**                                                                 0394
** DESCRIPTIVE NAME - CRH FUNCTIONAL RECOVERY ROUTINE (FRR) FOR    0394
**                    ACTIVATION                                   0394
**                                                                 0394
** FUNCTION - THIS ENTRY DEACTIVATES THE CHANNEL RECONFIGURATION   0394
**            HARDWARE FUNCTION IN THE OS/VS2 SYSTEM. IT REMOVES   0394
**            HOOKS IN IOS MAINLINE MODULE IECIOSCN, POINTS THE    0394
**            I/O FLIH BACK TO THE IOS SLIH AND PROCESSES THE UCBS 0394
**            FOR USE WITHOUT CRH. THE CRH FUNCTION IS LOGICALLY   0394
**            DEACTIVATED WHEN THE POINTER IN THE CVT (CVTCRCA)    0394
**            TO THE CRH COMMUNICATION AREA HAS BEEN ZEROED.       0394
**                                                                 0394
** INPUT                                                           0394
**                                                                 0394
**    REGISTERS - REG0     (REGISTER  0) ADDRESS OF FRR WORK AREA  0394
**                SDWAPTR  (REGISTER  1) ADDRESS OF SDWA           0394
**                RETRNREG (REGISTER 14) RETURN ADDRESS            0394
**                ENTRYREG (REGISTER 15) ADDRESS OF IECCRHAF       0394
**                                                                 0394
** OUTPUT - NONE                                                   0394
**                                                                 0394
** EXIT - NORMAL - RETURN TO RTM WITH RETRY REQUEST                0394
**                                                                 0394
** EXIT - ERROR - NONE                                             0394
**********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*           ESTABLISH ADRESSABILITY AND ENVIRONMENT                */
*/*                                                                  */
*/********************************************************************/
*/* IECCRHAF: ENTRY                       CRH ACTIVATION FRR         */
*    RFY (SDWAPTR,REG0) RSTD;                                      0394
*    GEN CODE DEFS(IECCRHAF) REFS(BASE,ENTRYREG);                  0395
IECCRHAF  DS  0F                       ENTRY POINT
     LR   BASE,ENTRYREG                ESTABLISH
     USING IECCRHAF,BASE                       ADDRESSABILITY
*/********************************************************************/
*/*MAKE SURE POINTER TO CRCA IS ZERO - THIS INDICATES CRH NOT ACTIVE */
*/********************************************************************/
*    CVTCRCA=ZERO;                     /* INDICATE CRH NOT ACTIVE    */
*                                                                  0396
         SLR   @10,@10                                             0396
         L     @09,CVTPTR                                          0396
         ST    @10,CVTCRCA(,@09)                                   0396
*    SAVEPTR=REG0;                     /*POINT REG13 TO FRR WORK AREA*/
         LR    SAVEPTR,REG0                                        0397
*    SAVERET=RETRNREG;                 /* SAVE RETURN REGISTER       */
         ST    RETRNREG,SAVERET                                    0398
*    SAVESDWA=SDWAPTR;                 /* SAVE SDWA POINTER          */
         LR    SAVESDWA,SDWAPTR                                    0399
*/********************************************************************/
*/*  INITIALIZE SDWA WITH MODULE NAME,CSECT NAME AND FRR NAME        */
*/********************************************************************/
*    SDWAMODN=NVCINT;                  /* PUT MODULE NAME IN SDWA    */
         MVC   SDWAMODN(8,SDWAPTR),NVCINT                          0400
*    SDWACSCT=NCRHA;                   /* PUT CSECT NAME IN SDWA     */
         MVC   SDWACSCT(8,SDWAPTR),NCRHA                           0401
*    SDWAREXN=NCRHAF;                  /* PUT FRR NAME IN SDWA       */
         MVC   SDWAREXN(8,SDWAPTR),NCRHAF                          0402
*/********************************************************************/
*/*  CHECK WETHER RETRY HAS BEEN ATTEMPED                            */
*/*  CHECK WETHER THIS IS SECOND LEVEL ENTRY                         */
*/********************************************************************/
*    IF RETRYA=ON|                     /* HAS RETRY BEEN ATTEMPTED   */
*       FRRENTRA=ON                    /* OR SECOND LEVEL ENTRY      */
*       THEN DO;                       /* YES, PERCOLATE             */
         TM    RETRYA,B'00010010'                                  0403
         BZ    @RF00403                                            0403
*              DO;  /*SETRP RECORD(YES)RC(0)*/                     0405
*                RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;     0406
*                GPR01P->SDWARCDE = 0;  /*SAVE RC VALUE*/          0407
         MVI   SDWARCDE(GPR01P),X'00'                              0407
*                GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/
         OI    SDWARCRD(GPR01P),B'10000000'                        0408
*                RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;   0409
*              END;  /* REQUEST PERCOLATION        */              0410
*            IOXCRHA=ZERO;             /* MAKE CRH UNAVAILABLE       */
         L     @09,IOCOMPTR(,@09)                                  0411
         L     @09,IOCXPTR(,@09)                                   0411
         ST    @10,IOXCRHA(,@09)                                   0411
*            GEN CODE(BR    RETRNREG); /* RETURN TO RTM              */
         BR    RETRNREG
*            END;                                                  0413
*/********************************************************************/
*/*  PROVIDE SECOND LEVEL FRR COVERAGE                               */
*/********************************************************************/
*    RFY (WRK4,WRK5) RSTD;                                         0414
@RF00403 DS    0H                                                  0415
*    GEN CODE REFS(CRHAF,WRK4,WRK5);                               0415
     SETFRR  A,FRRAD=CRHAF,WRKREGS=(WRK4,WRK5)
*    FRRENTRA=ON;                      /* INDICATE FIRST LEVEL FRR 0416
*                                         ENTERRED AND COVERED BY FRR*/
         OI    FRRENTRA,B'00010000'                                0416
*    RFY (WRK4,WRK5) UNRSTD;                                       0417
*/********************************************************************/
*/*                                                                  */
*/*            ATTEMPT TO BACKOUT CRH                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0418
*/********************************************************************/
*/*  ISSUE MSG IEA971I - UNABLE TO ACTIVATE CRH                      */
*/********************************************************************/
*    GEN CODE REFS(IEA971I);                                       0418
     RECORD TYPE=WTO,DATAADR=IEA971I,BUFFER=NO,RCVRY=SETFRR,LENGTH=LIEAX
               971I
*/********************************************************************/
*/*  CALL SUBROUTINE TO BACK OUT CHANGES TO OS/VS SYSTEM FOR CRH     */
*/********************************************************************/
*    LOOKUP=CVTILK2;                   /* POINT TO FIRST ENTRY IN UCB
*                                         LOOK UP TABLE              */
         L     @10,CVTPTR                                          0419
         MVC   LOOKUP(4),CVTILK2(@10)                              0419
*    ENTRYREG=BACKAD;                  /* SET UP BASE REG FOR SUBTRN.*/
         L     ENTRYREG,BACKAD                                     0420
*    CALL BACKOUT;                     /* CALL BACKOUT SUBROUTINE    */
         BAL   @14,BACKOUT                                         0421
*/********************************************************************/
*/*     RETURN STORAGE FOR SRB/IOSB IF SRB NOT SCHEDULED             */
*/*     NOTE : NON STANDARD LINKAGE TO IOS STORAGE MANAGER           */
*/********************************************************************/
*    RFY (SMGRPARM,WRK4) RSTD;                                     0422
*    IF (GOTSRB=ON) &                  /* STORAGE OBTAINED ?         */
*       (SCHEDSRB=OFF)                 /* BUT SRB NOT YET SCHEDULED ?*/
*       THEN DO;                       /* YES                        */
         TM    GOTSRB,B'01000000'                                  0423
         BNO   @RF00423                                            0423
         TM    SCHEDSRB,B'00100000'                                0423
         BNZ   @RF00423                                            0423
*            WRK1=BLOCKADD;            /* GET ADDRESS OF BLOCK       */
         L     WRK1,BLOCKADD                                       0425
*            SMGRPARM=FREE160;         /* SET UP PARAMETER TO FREE   */
         L     SMGRPARM,FREE160                                    0426
*            ENTRYREG=ADDR(IECVSMGR);  /* GET ADDRESS OF SMGR        */
         L     @10,CVTPTR                                          0427
         L     @10,IOCOMPTR(,@10)                                  0427
         L     ENTRYREG,IOCORMGT(,@10)                             0427
*            GEN CODE( BAL RETRNREG,FOUR(ENTRYREG)); /* CALL IOS   0428
*                                       STORAGE MANAGER PLUS FOUR    */
          BAL RETRNREG,FOUR(ENTRYREG)
*            GOTSRB=OFF;               /* INDICATE STORAGE FREED     */
         NI    GOTSRB,B'10111111'                                  0429
*            END;                                                  0430
*    RFY (SMGRPARM,WRK4) UNRSTD;                                   0431
@RF00423 DS    0H                                                  0432
*/********************************************************************/
*/*                                                                  */
*/*                 FRR EXIT ROUTINE                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0432
*CRHAFOUT: ;                           /* EXIT ROUTINE               */
CRHAFOUT DS    0H                                                  0433
*/********************************************************************/
*/*     RETURN TO RTM WITH RETRY TO IECVCRHA EXIT ROUTINE            */
*/********************************************************************/
*    SDWAPTR=SAVESDWA;                 /* RESTORE SDWA POINTER       */
         LR    SDWAPTR,SAVESDWA                                    0433
*/********************************************************************/
*/*        REQUEST RETRY AND ENSURE RETRY REGISTERS                  */
*/********************************************************************/
*    RFY (WRK4,WRK5) RSTD;                                         0434
*    RFY RETRYADD BASED(CRHATRY);      /* SET UP POINTER TO RETRY ADD*/
*      DO;  /*SETRP RETADDR(RETRYADD)RETREGS(YES)RECORD(YES)RC(4)*/
*        RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;             0437
*        GPR01P->SDWARCDE = 4; /*STORE RC INTO SDWA*/              0438
         MVI   SDWARCDE(GPR01P),X'04'                              0438
*        GPR01P->SDWARTYA = ADDR(RETRYADD);  /*SAVE RETRY ADDRESS*/
         MVC   SDWARTYA(4,GPR01P),CRHATRY                          0439
*        GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/    0440
*        GPR01P->SDWAUPRG = '1'B;  /*TURN ON RETREGS INDICATOR*/   0441
         OI    SDWARCRD(GPR01P),B'10001000'                        0441
*        RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;           0442
*      END;                      /* REQUEST RETRY              */  0443
*    SDWASR12=CRHA;                    /* ENSURE BASE REGISTER       */
         MVC   SDWASR12(4,SDWAPTR),CRHA                            0444
*    SDWASR13=ADDR(MYSAVE);            /* ENSURE SAVE AREA REGISTER  */
         LA    @10,MYSAVE                                          0445
         ST    @10,SDWASR13(,SDWAPTR)                              0445
*    RETRNREG=SAVERET;                 /* RESTORE RETURN REGISTER    */
         L     RETRNREG,SAVERET                                    0446
*    GEN CODE (SETFRR D,WRKREGS=(WRK4,WRK5)); /* DELETE SECOND LEVEL */
         SETFRR D,WRKREGS=(WRK4,WRK5)
*    FRRENTRA=OFF;                     /* SECOND LEVEL DELETED       */
*    RETRYA=ON;                        /* INDICATE RETRY ATTEMPTED   */
         OI    RETRYA,B'00000010'                                  0449
         NI    FRRENTRA,B'11101111'                                0449
*    GEN CODE(BR    RETRNREG);         /*  RETURN TO RTM             */
         BR    RETRNREG
*    RFY (SDWAPTR,REG0,WRK4,WRK5) UNRSTD;                          0451
*/*********************************************************************
**                                                                 0452
** ENTRY NAME - IECCRHDF                                           0452
**                                                                 0452
** DESCRIPTIVE NAME - CRH FUNCTIONAL RECOVERY ROUTINE (FRR) FOR    0452
**                    DEACTIVATION                                 0452
**                                                                 0452
** FUNCTION - THIS ENTRY DEACTIVATES THE CHANNEL RECONFIGURATION   0452
**            HARDWARE FUNCTION IN THE OS/VS2 SYSTEM. IT REMOVES   0452
**            HOOKS IN IOS MAINLINE MODULE IECIOSCN, POINTS THE    0452
**            I/O FLIH BACK TO THE IOS SLIH AND PROCESSES THE UCBS 0452
**            FOR USE WITHOUT CRH. THE CRH FUNCTION IS LOGICALLY   0452
**            DEACTIVATED WHEN THE POINTER IN THE CVT (CVTCRCA)    0452
**            TO THE CRH COMMUNICATION AREA HAS BEEN ZEROED.       0452
**                                                                 0452
** INPUT                                                           0452
**                                                                 0452
**    REGISTERS - REG0     (REGISTER  0) ADDRESS OF FRR WORK AREA  0452
**                SDWAPTR  (REGISTER  1) ADDRESS OF SDWA           0452
**                RETRNREG (REGISTER 14) RETURN ADDRESS            0452
**                ENTRYREG (REGISTER 15) ADDRESS OF IECCRHDF       0452
**                                                                 0452
** OUTPUT - NONE                                                   0452
**                                                                 0452
** EXIT - NORMAL - RETURN TO RTM WITH RETRY REQUEST                0452
**                                                                 0452
** EXIT - ERROR - NONE                                             0452
**********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*           ESTABLISH ADRESSABILITY AND ENVIRONMENT                */
*/*                                                                  */
*/********************************************************************/
*/* IECCRHDF: ENTRY                       CRH DEACTIVATION FRR       */
*    RFY (SDWAPTR,REG0) RSTD;                                      0452
*    GEN CODE DEFS(IECCRHDF) REFS(BASE,ENTRYREG);                  0453
IECCRHDF  DS  0F                       ENTRY POINT
     LR   BASE,ENTRYREG                ESTABLISH
     USING IECCRHDF,BASE                       ADDRESSABILITY
*    SAVEPTR=REG0;                     /*POINT REG13 TO FRR WORK AREA*/
         LR    SAVEPTR,REG0                                        0454
*    SAVERET=RETRNREG;                 /* SAVE RETURN REGISTER       */
         ST    RETRNREG,SAVERET                                    0455
*/********************************************************************/
*/*MAKE SURE POINTER TO CRCA IS ZERO - THIS INDICATES CRH NOT ACTIVE */
*/********************************************************************/
*    CVTCRCA=ZERO;                     /* INDICATE CRH NOT ACTIVE    */
         L     @10,CVTPTR                                          0456
         SLR   @03,@03                                             0456
         ST    @03,CVTCRCA(,@10)                                   0456
*/********************************************************************/
*/*  INITIALIZE SDWA WITH MODULE NAME,CSECT NAME AND FRR NAME        */
*/********************************************************************/
*    SDWAMODN=NVCINT;                  /* PUT MODULE NAME IN SDWA    */
         MVC   SDWAMODN(8,SDWAPTR),NVCINT                          0457
*    SDWACSCT=NCRHD;                   /* PUT CSECT NAME IN SDWA     */
         MVC   SDWACSCT(8,SDWAPTR),NCRHD                           0458
*    SDWAREXN=NCRHDF;                  /* PUT FRR NAME IN SDWA       */
         MVC   SDWAREXN(8,SDWAPTR),NCRHDF                          0459
*/********************************************************************/
*/*  CHECK WETHER RETRY HAS BEEN ATTEMPED                            */
*/*  CHECK WETHER THIS IS SECOND LEVEL ENTRY                         */
*/********************************************************************/
*    IF RETRYD=ON|                     /* HAS RETRY BEEN ATTEMPTED   */
*       FRRENTRD=ON                    /* OR SECOND LEVEL ENTRY      */
*       THEN DO;                       /* YES, PERCOLATE             */
         TM    RETRYD,B'00001001'                                  0460
         BZ    @RF00460                                            0460
*              DO;  /*SETRP RECORD(YES)RC(0)*/                     0462
*                RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;     0463
*                GPR01P->SDWARCDE = 0;  /*SAVE RC VALUE*/          0464
         MVI   SDWARCDE(GPR01P),X'00'                              0464
*                GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/
         OI    SDWARCRD(GPR01P),B'10000000'                        0465
*                RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;   0466
*              END;  /* REQUEST PERCOLATION        */              0467
*            GEN CODE(BR    RETRNREG); /* RETURN TO RTM              */
         BR    RETRNREG
*            END;                                                  0469
*/********************************************************************/
*/*  PROVIDE SECOND LEVEL FRR COVERAGE                               */
*/********************************************************************/
*    RFY (WRK4,WRK5) RSTD;                                         0470
@RF00460 DS    0H                                                  0471
*    GEN CODE REFS(WRK4,WRK5);                                     0471
     SETFRR  A,FRRAD=CRHDF,WRKREGS=(WRK4,WRK5)
*    FRRENTRD=ON;                      /* INDICATE FIRST LEVEL FRR 0472
*                                         ENTERRED AND COVERED BY FRR*/
         OI    FRRENTRD,B'00001000'                                0472
*    RFY (WRK4,WRK5) UNRSTD;                                       0473
*/********************************************************************/
*/*                                                                  */
*/*            ATTEMPT TO BACKOUT CRH                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0474
*/********************************************************************/
*/*  CALL SUBROUTINE TO BACK OUT CHANGES TO OS/VS SYSTEM FOR CRH     */
*/********************************************************************/
*    LOOKUP=CVTILK2;                   /* POINT TO FIRST ENTRY IN UCB
*                                         LOOK UP TABLE              */
         L     @10,CVTPTR                                          0474
         MVC   LOOKUP(4),CVTILK2(@10)                              0474
*    ENTRYREG=BACKAD;                  /* SET UP BASE REG FOR SUBTRN.*/
         L     ENTRYREG,BACKAD                                     0475
*    CALL BACKOUT;                     /* CALL BACKOUT SUBROUTINE    */
         BAL   @14,BACKOUT                                         0476
*/********************************************************************/
*/*                                                                  */
*/*                  FRR EXIT ROUTINE                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0477
*/********************************************************************/
*/*     RETURN TO RTM WITH RETRY TO IECVCRHD EXIT ROUTINE            */
*/********************************************************************/
*CRHDFOUT: ;                           /* EXIT ROUTINE               */
CRHDFOUT DS    0H                                                  0478
*/********************************************************************/
*/*        REQUEST RETRY AND ENSURE RETRY REGISTERS                  */
*/********************************************************************/
*    RFY (WRK4,WRK5) RSTD;                                         0478
*    RFY RETRYADD BASED(CRHDTRY);      /* SET UP POINTER TO RETRY ADD*/
*      DO;  /*SETRP RETADDR(RETRYADD)RETREGS(YES)RECORD(YES)RC(4)*/
*        RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;             0481
*        GPR01P->SDWARCDE = 4; /*STORE RC INTO SDWA*/              0482
         MVI   SDWARCDE(GPR01P),X'04'                              0482
*        GPR01P->SDWARTYA = ADDR(RETRYADD);  /*SAVE RETRY ADDRESS*/
         MVC   SDWARTYA(4,GPR01P),CRHDTRY                          0483
*        GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/    0484
*        GPR01P->SDWAUPRG = '1'B;  /*TURN ON RETREGS INDICATOR*/   0485
         OI    SDWARCRD(GPR01P),B'10001000'                        0485
*        RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;           0486
*      END;                      /* REQUEST RETRY              */  0487
*    SDWASR12=CRHD;                    /* ENSURE BASE REGISTER       */
         MVC   SDWASR12(4,SDWAPTR),CRHD                            0488
*    SDWASR13=ADDR(MYSAVE);            /* ENSURE SAVE AREA REGISTER  */
         LA    @10,MYSAVE                                          0489
         ST    @10,SDWASR13(,SDWAPTR)                              0489
*    RETRNREG=SAVERET;                 /* RETORE RETURN REGISTER     */
         L     RETRNREG,SAVERET                                    0490
*    GEN CODE (SETFRR D,WRKREGS=(WRK4,WRK5)); /* DELETE SECOND LEVEL */
         SETFRR D,WRKREGS=(WRK4,WRK5)
*    FRRENTRD=OFF;                     /* SECOND LEVEL DELETED       */
*    RETRYD=ON;                        /* INDICATE RETRY ATTEMPTED   */
         OI    RETRYD,B'00000001'                                  0493
         NI    FRRENTRD,B'11110111'                                0493
*    GEN CODE(BR    RETRNREG);         /*  RETURN TO RTM             */
         BR    RETRNREG
*    RFY (SDWAPTR,REG0,WRK4,WRK5) UNRSTD;                          0495
*/*********************************************************************
**                                                                 0496
** ENTRY NAME - IECCINTF                                           0496
**                                                                 0496
** DESCRIPTIVE NAME - CRH FUNCTIONAL RECOVERY ROUTINE (FRR) FOR    0496
**                    CRH SLIH IECVCINT                            0496
**                                                                 0496
** FUNCTION - THIS FRR ROUTINE WILL RE-ESTABLISH THE POINTER TO    0496
**            THE CRH COMMUNICATIONS AREA,BREAK ANY OUTSTANDING    0496
**            CRH CONNECTION AND BRANCH TO THE IOS FRR (IECFRR)    0496
**            WHICH WILL POST AN I/O COMPLETION CODE OF X'45'      0496
**            AND THEN RETRY TO CHANNEL RESTART CALL IN IOS SLIH.  0496
**                                                                 0496
** INPUT                                                           0496
**                                                                 0496
**    REGISTERS - SDWAPTR  (REGISTER  1) CONTAINS ADDRESS OF SDWA  0496
**                RETRNREG (REGISTER 14) RETURN ADDRESS            0496
**                ENTRYREG (REGISTER 15) ADDRESS OF IECCINTF       0496
**                                                                 0496
** OUTPUT - NONE                                                   0496
**                                                                 0496
** EXIT - NORMAL - BRANCH TO IOS FRR (IECFRR)                      0496
**                                                                 0496
** EXIT - ERROR - NONE                                             0496
**********************************************************************/
*/* IECCINTF: ENTRY                       CRH SLIH FRR               */
*/********************************************************************/
*/*           ESTABLISH ADRESSABILITY AND ENVIRONMENT                */
*/********************************************************************/
*    RFY (SDWAPTR) RSTD;                                           0496
*    GEN CODE DEFS(IECCINTF) REFS(BASE,ENTRYREG);                  0497
IECCINTF  DS  0F                       ENTRY POINT
     LR   BASE,ENTRYREG                ESTABLISH
     USING IECCINTF,BASE                       ADDRESSABILITY
*    FRRENTRC=ON;                      /* INDICATE FRR ENTERRED      */
         OI    FRRENTRC,B'00000100'                                0498
*/********************************************************************/
*/*  RESTORE POINTER TO CRCA TO ENSURE VALIDITY                      */
*/********************************************************************/
*    CVTCRCA=ADDR(IECVCRCA);           /* RESTORE POINTER TO CRCA    */
         L     @10,@CA02779                                        0499
         L     @03,CVTPTR                                          0499
         ST    @10,CVTCRCA(,@03)                                   0499
*    CRCAPTR=CVTCRCA;                  /* FROM VCON                  */
         LR    CRCAPTR,@10                                         0500
*/********************************************************************/
*/* MAKE SURE NO CRH CONNECTION IS LEFT OUTSTANDING                  */
*/********************************************************************/
*    IF CRCADIAG=ON                    /* CRH CONNECTION OUTSTANDING?*/
*       THEN DO;                                                   0501
         TM    CRCADIAG(CRCAPTR),B'10000000'                       0501
         BNO   @RF00501                                            0501
*            CRCAMCWM=OFF;             /* INDICATE BREAK CONNECTION  */
         NI    CRCAMCWM(CRCAPTR),B'11101111'                       0503
*            GEN CODE REFS(CRCAMCW,SAVECTL2,CRCAPTR,CRCA) SETS(CTL2);
             LCTL  CTL2,CTL2,SAVECTL2  RESTORE SYSTEM CONTROL REG2
             USING CRCA,CRCAPTR        ESTABLISH ADDRESSABILITY
             DC X'8300',S(CRCAMCW)     ISSUE DIAGNOSE
             DROP CRCAPTR
*            CRCADIAG=OFF;             /* INDICATE NO CRH CONNECTION */
         NI    CRCADIAG(CRCAPTR),B'01111111'                       0505
*            END;                                                  0506
*/********************************************************************/
*/*           BRANCH TO IOS FRR IECFRR TO BEGIN RETRY.               */
*/********************************************************************/
*    IRTINTSV=SAVERET;                  /* SAVE RETURN REGISTER 4  0507
*                                         FOR RETURN TO I/O FLIH     */
@RF00501 L     @10,LCCAPTR                                         0507
         MVC   IRTINTSV+736(4,@10),SAVERET                         0507
*    ENTRYREG=ADDR(IECFRR);            /* GET ADDRESS OF IOS FRR     */
         L     ENTRYREG,@CA02781                                   0508
*    GEN CODE(BR  ENTRYREG);           /* BRANCH TO IOS FRR        0509
*                                          NO RETURN                 */
         BR  ENTRYREG
*    RFY (SDWAPTR) UNRSTD;                                         0510
*/*********************************************************************
**                                                           @ZM30496
** ENTRY NAME - IECVCRHS                                           0511
**                                                                 0511
** DESCRIPTIVE NAME - CRH SRB SCHEDULE ROUTINE                     0511
**                                                                 0511
** FUNCTION - THIS ENTRY WILL INITIALIZE AND SCHEDULE AN SRB FOR   0511
**            CRHT (THE TIMER POP ROUTINE). THIS ROUTINE IS ENTERED
**            FROM THE TIMER SECOND LEVEL INTERRUPT HANDLER WHEN THE
**            TIME INTERVAL FROM CRHT HAS EXPIRED.                 0511
**                                                                 0511
**                                                                 0511
** INPUT                                                           0511
**     REGISTERS - RETRNREG (REGISTER 14) ADDRESS OF RETURN POINT  0511
**                 ENTRYREG (REGISTER 15) ADDRESS OF IECVCRHS      0511
*                   NOTE: REGISTER 9 MUST BE PRESERVED OVER THIS   0511
*                         ROUTINE.                                 0511
**                                                                 0511
** OUTPUT - SRB SCHEDULED                                          0511
**                                                                 0511
** EXIT - NORMAL - RETURN                                          0511
**                                                                 0511
** EXIT - ERROR - NONE                                             0511
**                                                                 0511
**********************************************************************/
*/*  IECVCRHS: ENTRY           ENTRY POINT FOR SCHEDULE RTN  @ZM30496*/
*/********************************************************************/
*GEN CODE DEFS(IECVCRHS) REFS(REG0,BASE,ENTRYREG,MYSAVE2); /*@ZM30496*/
IECVCRHS DS    0F                                              @ZM30496
         LR    BASE,ENTRYREG          ESTABLISH ADDRESSABILITY @ZM30496
         USING IECVCRHS,BASE                                   @ZM30496
*    RFY (SRBPTR) RSTD;                /*                    @ZM30496*/
*    SRBPTR=ADDR(SRBAREA);             /*                    @ZM30496*/
         LA    SRBPTR,SRBAREA                                      0513
*    GEN CODE REFS(SRBPTR);            /*                    @ZM30496*/
     SCHEDULE SRB=(SRBPTR),SCOPE=GLOBAL   SCHEDULE GLOBAL SRB  @ZM30946
*    RFY (SRBPTR) UNRSTD;              /*                    @ZM30496*/
*/********************************************************************/
*    GEN CODE REFS(REG0,RETRNREG,ENTRYREG,MYSAVE2);       /* @ZM30496*/
         BR    RETRNREG                   RETURN TO CALLER     @ZM30496
*/*********************************************************************
**                                                           @ZM30496
** ENTRY NAME - IECCRHTF                                           0517
**                                                                 0517
** DESCRIPTIVE NAME - CRH FUNCTIONAL RECOVERY ROUTINE TO THE CRH   0517
**                    TIMER POP ROUTINE                            0517
**                                                                 0517
** FUNCTION - THIS FRR FREES THE DISPATCHER LOCK AND RETURNS TO RTM
**                                                                 0517
**                                                                 0517
** INPUT                                                           0517
**     REGISTERS - SDWAPTR  (REGISTER  1) CONTAINS ADDRESS OF SDWA 0517
**                 RETRNREG (REGISTER 14) RETURN ADDRESS           0517
**                 ENTRYREG (REGISTER 15) ADDRESS OF IECCRHTF      0517
**                                                                 0517
** OUTPUT - NONE                                                   0517
**                                                                 0517
** EXIT - NORMAL - PERCOLATE TO NEXT LEVEL FRR                     0517
**                                                                 0517
** EXIT - ERROR - NONE                                             0517
**                                                                 0517
**********************************************************************/
*    GEN CODE DEFS(IECCRHTF) REFS(BASE,ENTRYREG);          /*@ZM30496*/
IECCRHTF DS    0F                                              @ZM30496
         LR    BASE,ENTRYREG          ESTABLISH ADDRESSABILITY @ZM30496
         USING IECCRHTF,BASE                                   @ZM30496
*    SDWAMODN=NVCINT;                  /* PUT MODULE, CSECT  @ZM30496*/
         MVC   SDWAMODN(8,SDWAPTR),NVCINT                          0518
*    SDWACSCT=NCRHT;                   /* AND FRR NAMES INTO @ZM30496*/
         MVC   SDWACSCT(8,SDWAPTR),NCRHT                           0519
*    SDWAREXN=NCRHTF;                  /* SDWA               @ZM30496*/
         MVC   SDWAREXN(8,SDWAPTR),NCRHTF                          0520
*      DO;  /*SETRP RECORD(YES)RC(0)*/                             0521
*        RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;             0522
*        GPR01P->SDWARCDE = 0;  /*SAVE RC VALUE*/                  0523
         MVI   SDWARCDE(GPR01P),X'00'                              0523
*        GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/    0524
         OI    SDWARCRD(GPR01P),B'10000000'                        0524
*        RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;           0525
*      END;          /* PERCOLATE          @ZM30496*/              0526
*    GEN CODE REFS(RETRNREG);                             /* @ZM30496*/
         BR    RETRNREG                                        @ZM30496
*/*********************************************************************
**                                                                 0528
** ENTRY NAME - IECVCRHT                                           0528
**                                                                 0528
** DESCRIPTIVE NAME - CRH TIMER POP ROUTINE FOR TELEPROCESSING     0528
**                    SUPPORT                                      0528
**                                                                 0528
** FUNCTION - THIS ENTRY WILL ENSURE THAT THE CHANNELS ON THE DEAD 0528
**            CPU ARE POLLED FOR INTERRUPTS OFTEN ENOUGH TO PREVENT
**            TELEPROCESSING LINES FROM TIMING OUT. IECVCRHT GETS  0528
**            CONTROL THE FIRST TIME FROM AN STIMER SCHEDULED BY   0528
**            THE ERP LOADER IECVERPL AT CRH ACTIVATION TIME.      0528
**                                                                 0528
** LINKAGE - STANDARD LINKAGE IS USED                              0528
**                                                                 0528
** INPUT                                                           0528
**     REGISTERS - SAVEPTR  (REGISTER 13) POINTS TO 18 WORD SAVE AREA
**                 RETRNREG (REGISTER 14) ADDRESS OF RETURN POINT  0528
**                 ENTRYREG (REGISTER 15) ADDRESS OF IECVCRHT      0528
**                                                                 0528
** OUTPUT - NONE                                                   0528
**                                                                 0528
** EXIT - NORMAL - RETURN                                          0528
**                                                                 0528
** EXIT - ERROR - NONE                                             0528
**                                                                 0528
**********************************************************************/
*/* IECVCRHT: ENTRY                ENTRY POINT FOR TIMER ROUTINE POP */
*/********************************************************************/
*    GEN   CODE DEFS(IECVCRHT)                                     0528
*          REFS(IECVCRHT,RETRNREG,BASE,SAVEPTR,SAVERET2,MYSAVE2);  0528
IECVCRHT   DS 0F                           ENTRY POINT         @ZM30496
     BALR  BASE,0                          LOAD BASE REGISTER  @ZM30496
     USING *,BASE                      INDICATE ADDRESSABILITY @ZM30496
     ST    RETRNREG,SAVERET2           SAVE RETURN ADDRESS     @ZM30496
     LA    SAVEPTR,MYSAVE2             SAVE AREA ADDRESS       @ZM30496
*/********************************************************************/
*/*      PROVIDE FRR COVERAGE                                @ZM30496*/
*/********************************************************************/
*    RFY (WRK4,WRK5) RSTD;             /*                    @ZM30496*/
*    GEN CODE REFS(WRK4,WRK5,CRHTF);   /*                    @ZM30496*/
         SETFRR A,FRRAD=CRHTF,WRKREGS=(WRK4,WRK5)              @ZM30496
*/********************************************************************/
*/* CHECK TO MAKE SURE CRH FUNCTION IS STILL ACTIVE                  */
*/********************************************************************/
*    IF CVTCRCA=ZERO                   /* CRH FUNCTION ACTIVE ?      */
*       THEN GOTO CRHTEXIT;            /* NO, EXIT                   */
         L     @10,CVTPTR                                          0531
         L     @10,CVTCRCA(,@10)                                   0531
         LTR   @10,@10                                             0531
         BZ    @RT00531                                            0531
*/********************************************************************/
*/* CRH ACTIVE,INITIALIZE INTERRUPT TIME AND TQE             @ZM30496*/
*/********************************************************************/
*    CRCAPTR=CVTCRCA;                  /* GET ADDRESS OF CRCA        */
         LR    CRCAPTR,@10                                         0533
*    GEN CODE REFS(CRCAPTR) SETS(CRCACTIM);                        0534
     STCK  CRCACTIM(CRCAPTR)           GET CURRENT TIME
*    IF CRCAFTIM=ON                    /* 1ST TIME ENTERED?  @ZM30496*/
*       THEN DO;                       /* YES                @ZM30496*/
         TM    CRCAFTIM(CRCAPTR),B'00001000'                       0535
         BNO   @RF00535                                            0535
*               CRCAFTIM=OFF;          /* TURN OF 1ST TIME SW@ZM30496*/
         NI    CRCAFTIM(CRCAPTR),B'11110111'                       0537
*               CRCAITIM=CRCAITIM&&CRCAITIM;         /*      @ZM30496*/
         XC    CRCAITIM(8,CRCAPTR),CRCAITIM(CRCAPTR)               0538
*                                       /*ZERO INTERRUPT TIME@ZM30496*/
*               TQEOFF=ON;             /* TURN ON TQE FLAGS  @ZM30496*/
         L     @10,TQEPTR                                          0539
         OI    TQEOFF(@10),B'10000000'                             0539
*               TQETYPE=REALTQE;       /*                    @ZM30496*/
         OI    TQETYPE(@10),B'00000011'                            0540
*               TQECRH=ON;             /*                    @ZM30496*/
         OI    TQECRH(@10),B'00100000'                             0541
*            END;                      /*                    @ZM30496*/
*/********************************************************************/
*/*                                                          @ZM30496*/
*/*     THIS SEGMENT COMPARES THE TIME OF THE LAST INTERRUPT TO THE  */
*/*     CURRENT TIME.  IF THE DIFFERENCE IS LESS THAN TWO SECONDS,   */
*/*     THE TIME INTERVAL WE NEXT WANT TO BE DISPATCHED IN IS SET.   */
*/*     OTHERWISE, AN INTERRUPT IS SIMULATED AND THEN THE TIME       */
*/*     INTERVAL IS SET.                                             */
*/********************************************************************/
*                                                                  0543
*    IF CWORD1-IWORD1<TWO              /* DIFF<2 SEC?        @ZM30496*/
*       THEN;                          /*   DO NOT DO SIMINT @ZM30496*/
@RF00535 L     @10,CWORD1(,CRCAPTR)                                0543
         SL    @10,IWORD1(,CRCAPTR)                                0543
         CL    @10,@CF00052                                        0543
         BL    @RT00543                                            0543
*       ELSE DO;                       /*                    @ZM30496*/
*                                                                  0545
*    RFY   (WRK4,WRK5) RSTD;                                       0546
*CRHT100:                                                          0547
*            WRK4=SIMADDR;             /* LOAD DEVICE ADDRESS FOR  0547
*                                         SIMULATED INTERRUPT        */
CRHT100  L     WRK4,SIMADDR                                        0547
*            GEN CODE(IOSINTRP UCB=(WRK4),VAR=2,BRANCH=YES);       0548
         IOSINTRP UCB=(WRK4),VAR=2,BRANCH=YES
*            END;                                                  0549
*                                                                  0549
*    TIMEWRK1=IWORD1+TWO;              /* FOR NEXT TIME TO   @ZM30496*/
@RT00543 LA    @10,2                                               0550
         AL    @10,IWORD1(,CRCAPTR)                                0550
         ST    @10,TIMEWRK1                                        0550
*                                      /* GET DISPATCHED             */
*    RFY   (WRK4,WRK5) UNRSTD;                                     0551
*/********************************************************************/
*/* ENQ TQE TO GET US DISPATCHED AGAIN IN 2.5 SECONDS.       @ZM30496*/
*/********************************************************************/
*    RFY (WRK1,WRK4,WRK5) RSTD;             /*               @ZM30496*/
*    TQEVAL=TIMEWORK;                       /* TIMER VALUE   @ZM30496*/
         L     @10,TQEPTR                                          0553
         MVC   TQEVAL(8,@10),TIMEWORK                              0553
*/********************************************************************/
*/*    GET LOCK AND ENQ TQE   NOTE: NON-STANDARD LINKAGE     @ZM30496*/
*/*                                RETURN ON REGISTER 2,             */
*/*                                NO SAVE AREA PASSED.              */
*/********************************************************************/
*    GEN CODE DEFS(CRHT150,CRHT160)                                0554
*REFS(CVTQTE00,TQEAREA,PARMSREG,TQERET,ENTRYREG,WRK4,WRK5);/*@ZM30496*/
CRHT150  SETLOCK OBTAIN,TYPE=DISP,MODE=UNCOND,REGS=SAVE,               C
               RELATED=(IECVCINT,CRHT160)                      @ZM30496
         L     WRK4,FLCCVT-PSA(REG0)        CVT ADDRESS        @ZM30496
         L     ENTRYREG,CVTQTE00-CVT(WRK4)  ADDR OF TQE ENQ RTN@ZM30496
         LA    PARMSREG,TQEAREA             TQE ADDRESS        @ZM30496
         BALR  TQERET,ENTRYREG         GO TO TIMER SLIH ENQ RTN@ZM30496
         LA    SAVEPTR,MYSAVE2         RESTORE SAVE AREA ADDR  @ZM30496
CRHT160  SETLOCK RELEASE,TYPE=DISP,RELATED=(IECVCINT,CRHT150),         C
               REGS=SAVE                                       @ZM30496
*    RFY (WRK4,WRK5,WRK1) UNRSTD;                                  0555
*/********************************************************************/
*/*                  EXIT LINKAGE                                    */
*/********************************************************************/
*CRHTEXIT:                                                         0556
*    GEN CODE;                                                     0556
CRHTEXIT DS    0H                                                  0556
         L     RETRNREG,SAVERET2         RESTORE RETURN REG    @ZM30496
     BR    RETRNREG                    RETURN TO CALLER
*/*********************************************************************
**                                                                 0557
** ENTRY NAME - IECVCRHV                                           0557
**                                                                 0557
** DESCRIPTIVE NAME - CRH INTERFACE FOR VARYING REMOTE CHANNEL ONLINE
**                                                                 0557
** FUNCTION - THIS ENTRY IS CALLED BY VARY MODULE IEEVCPU TO TEST  0557
**            WHETHER A REMOTE CHANNEL (A CHANNEL ON THE DEAD CPU) 0557
**            IS OPERATIONAL BY MEANS OF THE STIDC INSTRUCTION.    0557
**                                                                 0557
** LINKAGE - STANDARD LINKAGE IS USED                              0557
**                                                                 0557
** INPUT                                                           0557
**     REGISTERS - SAVEPTR  (REGISTER 13) POINTS TO 18 WORD SAVE AREA
**                 RETRNREG (REGISTER 14) ADDRESS OF RETURN POINT  0557
**                 ENTRYREG (REGISTER 15) ADDRESS OF IECVCRHT      0557
**                 PARMSREG (REGISTER  1) CHANNEL ID FOR STIDC     0557
**                                                                 0557
** OUTPUT                                                          0557
**                                                                 0557
**     REGISTERS - PARMSREG (REGISTER 1)  HIGH ORDER BYTE WILL     0557
**                            CONTAIN CONDITION CODE FROM THE STIDC
**     DATA AREAS - LOCATION X'A8' WILL CONTAIN THE INFORMATION STORED
**                            AS A RESULT OF THE STIDC.            0557
**                                                                 0557
** EXIT - NORMAL - RETURN TO CALLER WITH CONDITION CODE IN REGISTER
**                                                                 0557
** EXIT - ERROR - NONE                                             0557
**                                                                 0557
**********************************************************************/
*/* IECVCRHV: ENTRY                   ENTRY POINT FOR VARY INTERFACE */
*/********************************************************************/
*/*      STANDARD ENTRY LINKAGE                                      */
*/********************************************************************/
*    RFY   (PARMSREG) RSTD;                                        0557
*    GEN   CODE DEFS(IECVCRHV)                                     0558
*          REFS(IECVCRHV,RETRNREG,BASE,SAVEPTR,ENTRYREG,MYSAVE,CALLER);
IECVCRHV   DS 0F                           ENTRY POINT
     STM   RETRNREG,BASE,SAVREGS(SAVEPTR)  SAVE CALLERS REGISTERS
     LR    BASE,ENTRYREG                   LOAD BASE REGISTER
     USING IECVCRHV,BASE                   INDICATE ADDRESSABILITY
     LA    RETRNREG,MYSAVE                 GET ADDRESS OF MY SAVE AREA
     ST    RETRNREG,CALLED(SAVEPTR)        STORE IN CALLERS SAVE AREA
     ST    SAVEPTR,CALLER(RETRNREG)        SAVE PTR TO CALLERS AREA
     LR    SAVEPTR,RETRNREG                POINT REG13 TO MY SAVE AREA
     STNSM SAVEMASK,DISABLE                DISABLE FOR I/O AND EXT.
*/********************************************************************/
*/*    VARY WILL CALL IECVCRHV BEFORE CRH HAS BEEN ACTIVATED IF      */
*/*    HE IS VARYING THE FIRST REMOTE CHANNEL ONLINE. THEREFORE      */
*/*    IECVCRHV CAN NOT DEPEND ON CVTCRCA TO POINT TO THE CRCA.      */
*/********************************************************************/
*    CRCAPTR=ADDR(IECVCRCA);           /* GET POINTER TO CRCA        */
         L     CRCAPTR,@CA02779                                    0559
*/********************************************************************/
*/*    MAKE CRH CONNECTION TO REQUESTED CHANNEL AND ISSUE STORE      */
*/*    CHANNEL ID ACROSS CRH CONNECTION USING CHANNEL 6              */
*/********************************************************************/
*    CRCACHAN=PARMSREG;                 /* INDICATE CHANNEL ID       */
         STH   PARMSREG,CRCACHAN(,CRCAPTR)                         0560
*    CRCAMCWF=CRCACHAN(ONE:ONE);        /* SET UP MCW TO MAKE CRH  0561
*                                          CONNECTION TO CHANNEL     */
         MVC   CRCAMCWF(1,CRCAPTR),CRCACHAN(CRCAPTR)               0561
*    CRCAMCWI=ON;                       /* INDICATE CRH MCW          */
*    CRCAMCWM=ON;                       /* INDICATE MAKE CONNECTION  */
         OI    CRCAMCWI(CRCAPTR),B'00110000'                       0563
*    CRCADIAG=ON;                       /* INDICATE CRH CONNECTION 0564
*                                          OUTSTANDING               */
         OI    CRCADIAG(CRCAPTR),B'10000000'                       0564
*    PARMSREG=SIMADDR;                  /* USE CHANNEL 6 FOR STIDC   */
         L     PARMSREG,SIMADDR                                    0565
*    GEN CODE REFS(CRCA,CRCAPTR,CRCAMCW) SETS(PARMSREG);           0566
     USING CRCA,CRCAPTR
     DC  X'8300',S(CRCAMCW)             ISSUE DIAGNOSE
     DROP  CRCAPTR
     STIDC  AZERO(PARMSREG)             ISSUE STORE CHANNEL ID
     BALR   PARMSREG,AZERO              SAVE CONDITION CODE
*/********************************************************************/
*/*    BREAK CRH CONNECTION                                          */
*/********************************************************************/
*    CRCAMCWM=OFF;                      /* INDICATE BREAK CONNECTION */
         NI    CRCAMCWM(CRCAPTR),B'11101111'                       0567
*    GEN CODE REFS(CRCA,CRCAPTR,CRCAMCW);                          0568
     USING CRCA,CRCAPTR
     DC  X'8300',S(CRCAMCW)             ISSUE DIAGNOSE
     DROP  CRCAPTR
*    CRCADIAG=OFF;                      /* INDICATE NO CRH CONNECTION
*                                          OUTSTANDING               */
         NI    CRCADIAG(CRCAPTR),B'01111111'                       0569
*/********************************************************************/
*/*                  EXIT LINKAGE                                    */
*/********************************************************************/
*CRHVEXIT:                                                         0570
*    RFY WRK4 RSTD;                                                0570
CRHVEXIT DS    0H                                                  0571
*    GEN CODE;                                                     0571
     IC    WRK4,SAVEMASK               GET SAVED SYSTEM MASK
     EX    WRK4,STOSMV                 RESTORE SYSTEM MASK
     L     SAVEPTR,CALLER(SAVEPTR)     GET PTR TO CALLERS SAVE AREA
     LM    RETRNREG,REG0,SAVREG14(SAVEPTR) RESTORE REGISTERS 14,15,0
     LM    CRCAPTR,BASE,SAVREG2(SAVEPTR)  RESTORE REGISTERS,SKIP REG 1
     BR    RETRNREG                    RETURN TO CALLER WITH RC
STOSMV  STOSM  SAVEMASK,AZERO          RESTORE SYSTEM MASK
*    RFY (PARMSREG,WRK4) UNRSTD;                                   0572
*/*********************************************************************
**                                                                 0573
** PROCEDURE NAME - BACKOUT                                        0573
**                                                                 0573
** DESCRIPTIVE NAME - CRH INTERNAL BACK OUT ROUTINE                0573
**                                                                 0573
** FUNCTION - THIS INTERNAL PROCEDURE IS CALLED TO BACK OUT THE    0573
**            CHANGES MADE TO THE OS/VS2 SYSTEM BY CRH ACTIVATION  0573
**            ROUTINE IECVCRHA.                                    0573
**                                                                 0573
** INPUT                                                           0573
**                                                                 0573
**    REGISTERS - RETRNREG ( REGISTER 14) RETURN ADDRESS           0573
**                ENTRYREG ( REGISTER 15) ADDRESS OF BACKOUT       0573
**                                                                 0573
**    DATA FIELDS - LOOKUP (POINTER TO UCB LOOK UP TABLE) MUST     0573
**                  CONTAIN THE ADDRESS OF THE UCB LOOK UP TABLE   0573
**                  OR ONE OF ITS ENTRIES.                         0573
**                                                                 0573
** OUTPUT - NONE                                                   0573
**                                                                 0573
** EXIT - NORMAL - RETURN TO CALLER VIA BRANCH ON RETURN REGISTER  0573
**                                                                 0573
** EXIT - ERROR - NONE                                             0573
**********************************************************************/
*BACKOUT: PROCEDURE OPTIONS(NOSAVEAREA);                           0573
@EL00001 L     @13,4(,@13)                                         0573
@EF00001 DS    0H                                                  0573
@ER00001 LM    @14,@12,12(@13)                                     0573
         BR    @14                                                 0573
BACKOUT  STM   @14,@12,12(@13)                                     0573
*/********************************************************************/
*/*       ESTABLISH ADDRESSABILITY                                   */
*/********************************************************************/
*    GEN CODE SETS(BASE) REFS(ENTRYREG);                           0574
     LR  BASE,ENTRYREG                 ESTABLISH
     USING BACKOUT,BASE                     ADDRESSABILITY
*/********************************************************************/
*/*  CHANGE ADDRESS OF SLIH IN THE I/O FLIH TO POINT BACK TO IOS SLIH*/
*/********************************************************************/
*    IF SLIHCHNG=ON                    /* FLIH POINT TO CRH SLIH ?   */
*       THEN DO;                       /* YES                        */
         TM    SLIHCHNG,B'00010000'                                0575
         BNO   @RF00575                                            0575
*            SLIHPTR=ADDR(IECINT);     /* RESTORE POINTER TO I/O SLIH*/
         L     @10,@CA02782                                        0577
         L     @03,CVTPTR                                          0577
         L     @01,IOCOMPTR(,@03)                                  0577
         MVC   SLIHPTR-IEAVEIOI(4,@10),IOCINT(@01)                 0577
*            SLIHCHNG=OFF;             /* TURN OFF INDICATOR         */
         NI    SLIHCHNG,B'11101111'                                0578
*            END;                                                  0579
*/********************************************************************/
*/*  TAKE HOOKS OUT OF IOS MAINLINE IECIOSCN                         */
*/********************************************************************/
*    IF TCHHOOK=ON                     /* HOOK STILL IN ?            */
*       THEN DO;                       /*  YES                       */
@RF00575 TM    TCHHOOK,B'00001000'                                 0580
         BNO   @RF00580                                            0580
*            IECVHK1A=SAVEHK1;         /*RESTORE OVERLAID INSTRUCTION*/
         L     @10,@CA02759                                        0582
         MVC   IECVHK1A-IECVHK1A(4,@10),SAVEHK1                    0582
*            TCHHOOK=OFF;              /* INDICATE HOOK OUT          */
         NI    TCHHOOK,B'11110111'                                 0583
*            END;                                                  0584
*    IF SIOHOOK=ON                     /* HOOK STILL IN ?            */
*       THEN DO;                       /*  YES                       */
@RF00580 TM    SIOHOOK,B'00000100'                                 0585
         BNO   @RF00585                                            0585
*            IECVHK2A=SAVEHK2;         /*RESTORE OVERLAID INSTRUCTION*/
         L     @10,@CA02761                                        0587
         MVC   IECVHK2A-IECVHK2A(4,@10),SAVEHK2                    0587
*            SIOHOOK=OFF;              /* INDICATE HOOK OUT          */
         NI    SIOHOOK,B'11111011'                                 0588
*            END;                                                  0589
*    IF SNSHOOK=ON                     /* HOOK STILL IN ?            */
*       THEN DO;                       /*  YES                       */
@RF00585 TM    SNSHOOK,B'00000010'                                 0590
         BNO   @RF00590                                            0590
*            IECVHK3A=SAVEHK3;         /*RESTORE OVERLAID INSTRUCTION*/
         L     @10,@CA02763                                        0592
         MVC   IECVHK3A-IECVHK3A(4,@10),SAVEHK3                    0592
*            SNSHOOK=OFF;              /* INDICATE HOOK OUT          */
         NI    SNSHOOK,B'11111101'                                 0593
*            END;                                                  0594
*/********************************************************************/
*/*  SCAN THROUGH ALL UCBS FOR I/O ON DEAD CPU                       */
*/********************************************************************/
*    RFY UCBOB BASED(NXTUCB);         /* BASE UCBS ON UCB LOOKUP   0595
*                                         TABLE ENTRIES              */
@RF00590 DS    0H                                                  0596
*    IF SCANUCBS=OFF                  /* NEED TO SWITCH UCBS BACK ?  */
*       THEN RETURN;                  /* NO, RETURN TO CALLER        */
         TM    SCANUCBS,B'00000001'                                0596
         BZ    @RT00596                                            0596
*       ELSE;                         /* YES, SCANUCBS               */
*    IF DOINSCAN=ON                   /* RECURSIVE CALL BY FRR?      */
*       THEN LOOKUP=LOOKUP+TWO;       /* YES,BUMP TO NEXT UCB        */
         TM    DOINSCAN,B'10000000'                                0599
         BNO   @RF00599                                            0599
         LA    @10,2                                               0600
         AL    @10,LOOKUP                                          0600
         ST    @10,LOOKUP                                          0600
*       ELSE DOINSCAN=ON;             /* INDICATE FIRST ENTRY        */
         B     @RC00599                                            0601
@RF00599 OI    DOINSCAN,B'10000000'                                0601
*    DO WHILE NXTUCB^=TABLEND;         /*CHECK FOR END OF UCB LOOKUP */
@RC00599 B     @DE00602                                            0602
@DL00602 DS    0H                                                  0603
*       IF NXTUCB^=ZERO                /* ENSURE NONZERO UCB POINTER */
*         THEN DO;                     /* PROCESS UCB                */
         L     @10,LOOKUP                                          0603
         ICM   @03,3,NXTUCB(@10)                                   0603
         BZ    @RF00603                                            0603
*              IF UCBIORST=ON | UCBCRHRV=ON | UCBCRHSN=ON          0605
*                                      /* CHECK IF LAST I/O STARTED
*                                    WAS THRU CRH CONNECTION OR IF CRH
*                                    PATH RESERVED @ZA15805  @ZA16177*/
*                THEN DO;              /* YES                        */
         L     @10,LOOKUP                                          0605
         SLR   @01,@01                                             0605
         ICM   @01,3,NXTUCB(@10)                                   0605
         TM    UCBIORST(@01),B'10001100'                           0605
         BZ    @RF00605                                            0605
*                     UCBCPU=UCBCPU&&ONE;    /* SWITCH CPUID         */
         L     @10,LOOKUP                                          0607
         SLR   @01,@01                                             0607
         ICM   @01,3,NXTUCB(@10)                                   0607
         L     @10,LOOKUP                                          0607
         SLR   @03,@03                                             0607
         ICM   @03,3,NXTUCB(@10)                                   0607
         SLR   @10,@10                                             0607
         IC    @10,UCBCPU(,@03)                                    0607
         X     @10,@CF00036                                        0607
         STC   @10,UCBCPU(,@01)                                    0607
*                     UCBIORST=OFF;     /* TURN OFF INDICATOR THAT I/O
*                                           WAS STARTED THRU CRH     */
*                     UCBCRHRV=OFF;     /* ENSURE THAT INDICATOR FOR
*                                          RESERVE ACROSS CRH IS OFF */
*                     UCBCRHSN=OFF;    /* ENSURE CRH SENSE BIT OFF 0610
*                                                            @ZA16177*/
         L     @10,LOOKUP                                          0610
         SLR   @01,@01                                             0610
         ICM   @01,3,NXTUCB(@10)                                   0610
         NI    UCBIORST(@01),B'01110011'                           0610
*                     END;                                         0611
*                ELSE;                 /* LAST I/O STARTED NOT CRH   */
@RF00605 DS    0H                                                  0613
*              END;                                                0613
*          ELSE;                       /* ZERO UCB PTR,BUMP TO NEXT  */
@RF00603 DS    0H                                                  0615
*       LOOKUP=LOOKUP+TWO;             /* BUMP TO NEXT ENTRY IN UCB
*                                         LOOK UP TABLE              */
         LA    @10,2                                               0615
         AL    @10,LOOKUP                                          0615
         ST    @10,LOOKUP                                          0615
*    END;                              /* END DO WHILE               */
@DE00602 L     @10,LOOKUP                                          0616
         CLC   NXTUCB(2,@10),TABLEND                               0616
         BNE   @DL00602                                            0616
*    SCANUCBS=OFF;                     /* INDICATE UCB SCAN DONE     */
         NI    SCANUCBS,B'11111110'                                0617
*    DOINSCAN=OFF;                     /* INDICATE UCB SCAN DONE     */
         NI    DOINSCAN,B'01111111'                                0618
*/********************************************************************/
*/*               RETURN TO CALLER                                   */
*/********************************************************************/
*    RETURN;                           /* RETURN TO CALLER           */
@EL00002 DS    0H                                                  0619
@EF00002 DS    0H                                                  0619
@ER00002 LM    @14,@12,12(@13)                                     0619
         BR    @14                                                 0619
*    END  BACKOUT;                                                 0620
         B     @EL00002                                            0620
*                                                                  0621
*                                                                  0621
*    DECLARE /*GENERAL PURPOSE REGISTERS */                        0621
*      GPR00P PTR(31) REG(0),                                      0621
*      GPR01P PTR(31) REG(1),                                      0621
*      GPR14P PTR(31) REG(14),                                     0621
*      GPR15P PTR(31) REG(15);                                     0621
*                                                                  0621
*    DECLARE /* COMMON VARIABLES */                                0622
*      I256C CHAR(256) BASED,                                      0622
*      I031F FIXED(31) BASED,                                      0622
*      I031P PTR(31)   BASED,                                      0622
*      I015F FIXED(15) BASED,                                      0622
*      I015P PTR(15)   BASED,                                      0622
*      I008P PTR(8)    BASED,                                      0622
*      I001C CHAR(1)   BASED;                                      0622
*      END  IECVCINT                                               0623
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IECDCAT )                                        *
*/*%INCLUDE SYSLIB  (IECDCRCA)                                        *
*/*%INCLUDE SYSLIB  (IHACSD  )                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IHAFRRS )                                        *
*/*%INCLUDE SYSLIB  (IECDIOCM)                                        *
*/*%INCLUDE SYSLIB  (IECDIOCX)                                        *
*/*%INCLUDE SYSLIB  (IECDIOQ )                                        *
*/*%INCLUDE SYSLIB  (IECDIOSB)                                        *
*/*%INCLUDE SYSLIB  (IECDIRT )                                        *
*/*%INCLUDE SYSLIB  (IHALCCA )                                        *
*/*%INCLUDE SYSLIB  (IHAPCCA )                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (IHASDWA )                                        *
*/*%INCLUDE SYSLIB  (IECDSIAB)                                        *
*/*%INCLUDE SYSLIB  (IHASRB  )                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IHATQE  )                                        *
*;                                                                 0623
@DATA    DS    0H
         DS    0F
@SA00001 DS    18F
         DS    0F
@CF00036 DC    F'1'
@CF00052 DC    F'2'
@CF03026 DC    F'-4'
@CA00028 DC    A(IECVCINT)
@CA02758 DC    A(CRHSADDR)
@CA02759 DC    A(IECVHK1A)
@CA02760 DC    A(IECVHK1B)
@CA02761 DC    A(IECVHK2A)
@CA02762 DC    A(IECVHK2B)
@CA02763 DC    A(IECVHK3A)
@CA02764 DC    A(IECVHK3B)
@CA02779 DC    A(IECVCRCA)
@CA02780 DC    A(IEAMASCB)
@CA02781 DC    A(IECFRR)
@CA02782 DC    A(IEAVEIOI)
         DS    0D
IOSBPTR  DS    A
TQEPTR   DC    AL4(TQEAREA)
CRHA     DC    AL4(IECVCRHA)
CRHD     DC    AL4(IECVCRHD)
CRHS     DC    AL4(IECVCRHS)
CINT     DC    AL4(IECVCINT)
CRHATRY  DC    AL4(CRHARTRY)
CRHDTRY  DC    AL4(CRHDRTRY)
CRHAF    DC    AL4(IECCRHAF)
CRHDF    DC    AL4(IECCRHDF)
CRHTF    DC    AL4(IECCRHTF)
CINTF    DC    AL4(IECCINTF)
BACKAD   DC    AL4(BACKOUT)
CINTR    DS    A
SAVEHK1  DS    A
SAVEHK2  DS    A
SAVEHK3  DS    A
BLOCKADD DS    A
LOOKUP   DS    A
SAVERET  DS    A
SAVERET2 DS    A
SAVECTL2 DS    A
CRHINT   DC    XL4'00000050'
NORMINT  DC    XL4'00000040'
SIMADDR  DC    XL4'00000600'
TABLEND  DC    XL2'FFFF'
SAVEMASK DS    AL1
         DS    CL2
BUILDIOA DS    AL3
         ORG   BUILDIOA
@NM00108 DS    CL1
IOAA     DS    CL2
         ORG   BUILDIOA+3
         DS    CL4
TQEAREA  DS    CL24
         ORG   TQEAREA
TID      DC    CL4' TQE'
@NM00113 DC    5A(0)
         ORG   TQEAREA+24
FOOTPRNT DS    CL4
         ORG   FOOTPRNT
SETFRRA  DS    BL1
SETFRRD  EQU   FOOTPRNT+0
SETFRRC  EQU   FOOTPRNT+0
SLIHCHNG EQU   FOOTPRNT+0
TCHHOOK  EQU   FOOTPRNT+0
SIOHOOK  EQU   FOOTPRNT+0
SNSHOOK  EQU   FOOTPRNT+0
SCANUCBS EQU   FOOTPRNT+0
DOINSCAN DS    BL1
GOTSRB   EQU   FOOTPRNT+1
SCHEDSRB EQU   FOOTPRNT+1
FRRENTRA EQU   FOOTPRNT+1
FRRENTRD EQU   FOOTPRNT+1
FRRENTRC EQU   FOOTPRNT+1
RETRYA   EQU   FOOTPRNT+1
RETRYD   EQU   FOOTPRNT+1
IOSUP    DS    BL1
         ORG   FOOTPRNT+4
MYSAVE   DS    CL72
MYSAVE2  DS    CL72
DEADCPU  DS    CL1
POLLADDR DS    CL2
         ORG   POLLADDR
POLLCHAN DS    AL1
@NM00109 DC    AL1(0)
         ORG   POLLADDR+2
         DS    CL1
SRBAREA  DS    CL44
         ORG   SRBAREA
SID      DC    CL4' SRB'
@NM00114 DC    10A(0)
         ORG   SRBAREA+44
         DS    CL4
TIMEWORK DS    CL8
         ORG   TIMEWORK
TIMEWRK1 DC    A(0)
TIMEWRK2 DC    A(0)
         ORG   TIMEWORK+8
INTERVAL DC    X'F0F0F0F0F0F1F5F0'
CHANMASK DC    X'FFF0FF'
FF       DC    X'FF'
ONEFOX   DC    X'0000000F'
ENABLE6  DC    X'02000000'
X80      DC    X'00000080'
CPU168   DC    CL4'0168'
FREE160  DC    X'00000020'
GET160   DC    X'10000020'
NVCINT   DC    CL8'IECVCINT'
NCRHA    DC    CL8'IECVCRHA'
NCRHD    DC    CL8'IECVCRHD'
NCRHAF   DC    CL8'IECCRHAF'
NCRHDF   DC    CL8'IECCRHDF'
NCRHT    DC    CL8'IECVCRHT'
NCRHTF   DC    CL8'IECCRHTF'
IECVCINT CSECT
         DS    0F
         MODID BR=NO
IEA970I  WTO   'IEA970I - CHANNEL RECONFIGURATION HARDWARE ACTIVATED',RX
               OUTCDE=(1,10),DESC=(4),MF=L
IEA971I  WTO   'IEA971I - UNABLE TO ACTIVATE CHANNEL RECONFIGURATION HAX
               RDWARE',ROUTCDE=(1,10),DESC=(4),MF=L
IEA972I  WTO   'IEA972I - CHANNEL RECONFIGURATION HARDWARE DEACTIVATED'X
               ,ROUTCDE=(1,10),DESC=(4),MF=L
IEA989I  WTO   'IEA989I - DSS ACTIVE - CAN NOT ACTIVATE CHANNEL RECONFIX
               GURATION HARDWARE',ROUTCDE=(1,10),DESC=(4),MF=L
LIEA970I EQU    61
LIEA971I EQU    72
LIEA972I EQU    64
LIEA989I EQU    83
DISABLE  EQU   X'FC'         MASK TO DISABLE INTERRUPTS
ENABLE   EQU   X'03'         MASK TO ENABLE INTERRUPTS
ENABLEIO EQU   X'02'         MASK TO ENABLE ONLY I/O INTERRUPTS
AZERO    EQU   0             ZERO
CTL2     EQU   2             CONTROL REGISTER 2
FOUR     EQU   4             FOUR
IECVCINT CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
CATINDEX EQU   @06
SAVESDWA EQU   @03
INDEX    EQU   @03
UCBPTR   EQU   @10
CATPTR   EQU   @03
BASE     EQU   @12
CRCAPTR  EQU   @02
SDWAPTR  EQU   @01
SIABPTR  EQU   @11
SRBPTR   EQU   @11
REG0     EQU   @00
WRK0     EQU   @00
WRK1     EQU   @01
PARMSREG EQU   @01
TQERET   EQU   @02
WRK3     EQU   @03
CINTRET  EQU   @04
CINTENT  EQU   @05
WRK4     EQU   @04
WRK5     EQU   @05
ENVCODE  EQU   @11
SMGRPARM EQU   @11
SAVEPTR  EQU   @13
RETRNREG EQU   @14
ENTRYREG EQU   @15
RETCODE  EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
BLOCKPTR EQU   @01
         EXTRN CRHSADDR
         EXTRN IECVHK1A
         EXTRN IECVHK1B
         EXTRN IECVHK2A
         EXTRN IECVHK2B
         EXTRN IECVHK3A
         EXTRN IECVHK3B
         EXTRN IECVCRCA
         EXTRN IEAMASCB
         EXTRN IECFRR
         EXTRN IEAVEIOI
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
FLCCSW   EQU   PSA+64
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCIOAA  EQU   FLCIOA+1
FLCFSA   EQU   FLCMCLA+80
PSALCCAV EQU   PSA+528
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSAIOSUP EQU   PSASUP3
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSACPUSA EQU   PSA+794
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CAT      EQU   0
CATENTRY EQU   CAT
CATFLG   EQU   CATENTRY
CATNGEN  EQU   CATFLG
CATNCPU  EQU   CATFLG
CATFLA   EQU   CAT+1
CATBSY   EQU   CATFLA
CRCA     EQU   0
CRCAFLGS EQU   CRCA+4
CRCAFLG1 EQU   CRCAFLGS
CRCADIAG EQU   CRCAFLG1
CRCADINT EQU   CRCAFLG1
CRCACCH  EQU   CRCAFLG1
CRCAHIO  EQU   CRCAFLG1
CRCAFTIM EQU   CRCAFLG1
CRCAMCW  EQU   CRCA+8
CRCAMCWZ EQU   CRCAMCW
CRCAMCWF EQU   CRCAMCW+3
CRCAMCWI EQU   CRCAMCWF
CRCAMCWM EQU   CRCAMCWF
CRCACINT EQU   CRCA+32
CRCAPCCA EQU   CRCA+36
CRCACAT  EQU   CRCA+40
CRCACHAN EQU   CRCA+52
CRCACTIM EQU   CRCA+56
CRCAITIM EQU   CRCA+64
CSD      EQU   0
CSDCPUAL EQU   CSD+8
CSDSCWRD EQU   CSD+12
CSDSCFL1 EQU   CSDSCWRD
CSDSCFL2 EQU   CSDSCWRD+1
CSDSCFL3 EQU   CSDSCWRD+2
CSDSCFL4 EQU   CSDSCWRD+3
CSDFLAGS EQU   CSD+23
CSDMP    EQU   CSDFLAGS
CVTMAP   EQU   0
CVTILK1  EQU   CVTMAP+36
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTQTE00 EQU   CVTMAP+104
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIXAVL EQU   CVTMAP+124
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
IOCOM    EQU   0
IOCINT   EQU   IOCOM+16
IOCORMGT EQU   IOCOM+36
IOCOMEX  EQU   IOCOM+64
IOCUCBBM EQU   IOCOM+120
IOCX     EQU   0
IOX      EQU   IOCX
IOXCHMSK EQU   IOCX+2
IOXHICH  EQU   IOCX+4
IOXCRHA  EQU   IOCX+12
IOQ      EQU   0
IOQFLAGS EQU   IOQ+4
IOQFLA   EQU   IOQFLAGS
IOQSLCH  EQU   IOQFLA
IOQENQ   EQU   IOQFLA
IOQFLB   EQU   IOQFLAGS+1
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00016 EQU   IOSB+20
IOSCSW   EQU   @NM00016+1
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
IRT      EQU   0
IRTENTRY EQU   IRT
IRTFLA   EQU   IRTENTRY
IRTIOQA  EQU   IRTFLA
IRTFLB   EQU   IRTENTRY+1
IRTENVR  EQU   IRTENTRY+2
IRTIOQ   EQU   IRT+16
IRTCHMSK EQU   IRT+32
IRTINTSV EQU   IRT+104
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
LCCAIRT  EQU   LCCA+736
PCCA     EQU   0
PCCACPID EQU   PCCA+4
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCACAT  EQU   PCCA+384
PCCAPTR  EQU   0
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWASR12 EQU   SDWASRSV+48
SDWASR13 EQU   SDWASRSV+52
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWAMODN EQU   SDWARECP
SDWACSCT EQU   SDWARECP+8
SDWAREXN EQU   SDWARECP+16
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SIAB     EQU   0
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBASCB  EQU   SRB+8
SRBFLC   EQU   SRB+12
SRBEP    EQU   SRB+20
UCB      EQU   0
UCBIOQ   EQU   UCB+508
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBIORST EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBCPU   EQU   UCBOB+11
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00103 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
TQE      EQU   0
TQEFLGS  EQU   TQE+14
TQEOFF   EQU   TQEFLGS
TQETYPE  EQU   TQEFLGS
TQEFLGS2 EQU   TQE+15
TQECRH   EQU   TQEFLGS2
TQEVAL   EQU   TQE+16
TQEEXIT  EQU   TQE+28
IECINT   EQU   0
IECVSMGR EQU   0
CHANCON  EQU   0
BITMASK  EQU   0
CUCON    EQU   0
UCBADDR  EQU   0
RETRYADD EQU   0
SAVAREA  EQU   0
CALLER   EQU   SAVAREA+4
SAVREGS  EQU   SAVAREA+12
NXTUCB   EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
UCBBGN   EQU   0
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTDSSAC EQU   CVTS01+122
CVTCSD   EQU   CVTS01+312
CVTPCCAT EQU   CVTS01+416
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTCRCA  EQU   CVTS01+612
IOCOMPTR EQU   CVTIXAVL
IOCXPTR  EQU   IOCOMEX
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
LCCAPTR  EQU   PSALCCAV
PSARSVTE EQU   PSARSVT
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00102 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
SLIHPTR  EQU   IEAVEIOI
CURTIME  EQU   CRCACTIM
CWORD1   EQU   CURTIME
INTTIME  EQU   CRCAITIM
IWORD1   EQU   INTTIME
CSW      EQU   FLCCSW
STATUS   EQU   CSW+4
DEVSTAT  EQU   STATUS
UCK      EQU   DEVSTAT
CHANSTAT EQU   STATUS+1
CDC      EQU   CHANSTAT
CCC      EQU   CHANSTAT
ICC      EQU   CHANSTAT
FLC      EQU   PSA
TQEECB   EQU   TQEEXIT
*                                      START UNREFERENCED COMPONENTS
RESIDCT  EQU   CSW+6
@NM00112 EQU   CHANSTAT
@NM00111 EQU   CHANSTAT
UEX      EQU   DEVSTAT
@NM00110 EQU   DEVSTAT
CMDADDR  EQU   CSW+1
PRKEY    EQU   CSW
IWORD2   EQU   INTTIME+4
CWORD2   EQU   CURTIME+4
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00102
UCBSKPFG EQU   @NM00102
UCBRIPND EQU   @NM00102
UCBRTIAC EQU   @NM00102
UCBRSV79 EQU   @NM00102
UCBRSV78 EQU   @NM00102
UCBRSV77 EQU   @NM00102
UCBOLTEP EQU   @NM00102
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00101 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00021 EQU   IOSPCISC+4
@NM00020 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00019 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00107 EQU   SAVREGS+20
SAVREG2  EQU   SAVREGS+16
SAVREG1  EQU   SAVREGS+12
SAVREG0  EQU   SAVREGS+8
SAVREG15 EQU   SAVREGS+4
SAVREG14 EQU   SAVREGS
CALLED   EQU   SAVAREA+8
@NM00106 EQU   SAVAREA
@NM00105 EQU   TQE+88
TQESRB   EQU   TQE+44
TQELHPSW EQU   TQE+40
TQEASCB  EQU   TQE+36
TQETCB   EQU   TQE+32
TQESADDR EQU   TQE+24
TQEVALRH EQU   TQEVAL+4
TQEVALLH EQU   TQEVAL
TQEMIDN  EQU   TQEFLGS2
TQEMF1   EQU   TQEFLGS2
TQEOPT   EQU   TQEFLGS2
TQELM    EQU   TQEFLGS2
TQEDUM   EQU   TQEFLGS2
TQEUSER  EQU   TQEFLGS2
TQECOMP  EQU   TQEFLGS2
TQEXITSP EQU   TQEFLGS
TQEINCOM EQU   TQEFLGS
TQEWLIM  EQU   TQEFLGS
@NM00104 EQU   TQEFLGS
TQETOD   EQU   TQEFLGS
TQEAID   EQU   TQE+12
TQEBLNK  EQU   TQE+8
TQEFLNK  EQU   TQE+4
TQETQE   EQU   TQE
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00103
UCBHALI  EQU   @NM00103
UCBRSV09 EQU   @NM00103
UCBRSV08 EQU   @NM00103
UCBRSV07 EQU   @NM00103
UCBRSV06 EQU   @NM00103
UCBRSV05 EQU   @NM00103
UCBRSV04 EQU   @NM00103
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00100 EQU   UCB
@NM00099 EQU   SRB+40
@NM00098 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBFLNK  EQU   SRB+4
SRBID    EQU   SRB
SIABEND  EQU   SIAB+160
SIABIOSB EQU   SIAB+48
SIABSRB  EQU   SIAB
SIABCMCH EQU   SIAB
@NM00097 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00096 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00095 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00094 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00093 EQU   SDWADDAT+3
@NM00092 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00091 EQU   SDWADDAT+1
@NM00090 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00089 EQU   SDWADUMP+2
@NM00088 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00087 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
@NM00086 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00085 EQU   SDWAACF3
@NM00084 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
@NM00083 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00082 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00081 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00080 EQU   SDWA+239
@NM00079 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00078 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00077 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00076 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00075 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00074 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00073 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00072 EQU   SDWAINC2
@NM00071 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00070 EQU   SDWAILC2
@NM00069 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00068 EQU   SDWANXT2
@NM00067 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00066 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00065 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00064 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00063 EQU   SDWAINC1
@NM00062 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00061 EQU   SDWAILC1
@NM00060 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00059 EQU   SDWANXT1
@NM00058 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00057 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00056 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00055 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00054 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00053 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00052 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00051 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00050 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
@NM00025 EQU   PCCA+512
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCACPUM EQU   PCCA+376
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCAPCCA EQU   PCCA
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCASGPR EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAASID EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCACPUS EQU   LCCA+536
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCAR133 EQU   LCCA+444
LCCAR132 EQU   LCCA+440
LCCAR131 EQU   LCCA+436
LCCAR130 EQU   LCCA+432
LCCAR129 EQU   LCCA+428
LCCAR128 EQU   LCCA+424
LCCAR127 EQU   LCCA+420
LCCAR126 EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
IRTEND   EQU   IRT+128
IRTRSV0B EQU   IRT+124
IRTCHNSV EQU   IRT+120
IRTSNSCT EQU   IRT+116
IRTLCHAD EQU   IRT+112
IRTSTSSV EQU   IRT+108
IRTCCHSV EQU   IRT+100
IRTATTSV EQU   IRT+96
IRTFRRWA EQU   IRT+92
IRTNSRB  EQU   IRT+88
IRTCSME  EQU   IRT+84
IRTPRGSV EQU   IRT+80
IRTPCISV EQU   IRT+76
IRTSENSV EQU   IRT+72
IRTDIESV EQU   IRT+68
IRTRSTSV EQU   IRT+64
IRTSTASV EQU   IRT+60
IRTSIOSV EQU   IRT+56
IRTDDSV  EQU   IRT+52
IRTTCHSV EQU   IRT+48
IRTRTNSV EQU   IRT+40
IRTRSV01 EQU   IRT+36
IRTPSTSV EQU   IRT+28
IRTNIOQ  EQU   IRT+24
IRTCHNL  EQU   IRT+20
IRTLCH   EQU   IRT+12
IRTUCB   EQU   IRT+8
@NM00024 EQU   IRT+7
IRTCMRST EQU   IRT+6
IRTCCH   EQU   IRT+5
IRTSYMSK EQU   IRT+4
@NM00023 EQU   IRTENTRY+3
IRTCSINT EQU   IRTENVR
IRTPINT  EQU   IRTENVR
IRTHIO   EQU   IRTENVR
IRTRSTI  EQU   IRTENVR
IRTCRHIN EQU   IRTENVR
IRTSHTP  EQU   IRTENVR
IRTSLIHA EQU   IRTENVR
IRTCHENT EQU   IRTENVR
@NM00022 EQU   IRTFLB
IRTCCHWA EQU   IRTFLB
IRT12GT  EQU   IRTFLB
IRTSMGR  EQU   IRTFLB
IRTCHBSY EQU   IRTFLB
IRTPCISW EQU   IRTFLB
IRTSKRST EQU   IRTFLB
IRTNRST  EQU   IRTFLB
IRTSSIGP EQU   IRTFLA
IRTSLISN EQU   IRTFLA
IRTALCK  EQU   IRTFLA
IRTCLCK  EQU   IRTFLA
IRTSLCK  EQU   IRTFLA
IRTLLCK  EQU   IRTFLA
IRTULCK  EQU   IRTFLA
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00018 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00017 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00016
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSIGP   EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00015 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSNOTRS EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
IOQEND   EQU   IOQ+12
IOQIOSB  EQU   IOQ+8
IOQPTH   EQU   IOQFLAGS+3
IOQPRI   EQU   IOQFLAGS+2
IOQALOC  EQU   IOQFLB
IOQRLSE  EQU   IOQFLB
IOQRESV  EQU   IOQFLB
@NM00014 EQU   IOQFLA
IOQPBSY  EQU   IOQFLA
IOQLBSY  EQU   IOQFLA
IOQLNK   EQU   IOQ
IOXEND   EQU   IOCX+32
IOXPSIF  EQU   IOCX+28
IOXPSIX  EQU   IOCX+24
IOXSTIDC EQU   IOCX+20
IOXCRHD  EQU   IOCX+16
IOXTCQSC EQU   IOCX+8
@NM00013 EQU   IOCX+6
IOXLCHCT EQU   IOCX+5
IOXOFSET EQU   IOX
IOCOEND  EQU   IOCOM+128
IOCPATCH EQU   IOCOM+124
IOCQCNT  EQU   IOCOM+116
IOCIOSDQ EQU   IOCOM+112
IOCIOSEQ EQU   IOCOM+108
IOCSVCF  EQU   IOCOM+104
IOCTCCW  EQU   IOCOM+100
IOCRSVTB EQU   IOCOM+96
IOCMFCNT EQU   IOCOM+92
IOCMFHK  EQU   IOCOM+88
IOCGENA  EQU   IOCOM+84
IOCCCH   EQU   IOCOM+80
IOCASYNQ EQU   IOCOM+76
IOCLCHTB EQU   IOCOM+72
IOCATTBL EQU   IOCOM+68
IOCSYNCH EQU   IOCOM+56
IOCCATLK EQU   IOCOM+48
IOCPRGID EQU   IOCOM+44
IOCIOSCP EQU   IOCOM+40
IOCVOID  EQU   IOCOM+32
IOCSTIO  EQU   IOCOM+28
@NM00012 EQU   IOCOM+24
@NM00011 EQU   IOCOM+20
IOCCTBL  EQU   IOCOM+12
IOCHIO   EQU   IOCOM+8
IOCPST   EQU   IOCOM+4
IOCPGCT  EQU   IOCOM+2
IOCVOICT EQU   IOCOM
FRRSPARM EQU   FRRSENTR+8
@NM00010 EQU   FRRSFLGS+1
@NM00009 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSCURR EQU   FRRSHEAD+12
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00008 EQU   CVTFIX+248
@NM00007 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00006 EQU   CSD+160
CSDMASK  EQU   CSD+128
CSDUCNT  EQU   CSD+124
CSDTCNT  EQU   CSD+120
CSDGDTOD EQU   CSD+116
CSDGDINT EQU   CSD+112
CSDGDCC  EQU   CSD+108
CSDDDRCT EQU   CSD+106
CSDRV044 EQU   CSD+104
CSDMAFF  EQU   CSD+24
CSDRV038 EQU   CSDFLAGS
CSDRV037 EQU   CSDFLAGS
CSDRV036 EQU   CSDFLAGS
CSDRV035 EQU   CSDFLAGS
CSDRV034 EQU   CSDFLAGS
CSDRV033 EQU   CSDFLAGS
CSDRV032 EQU   CSDFLAGS
CSDACR   EQU   CSD+22
CSDMF1CP EQU   CSD+20
CSDRV043 EQU   CSD+16
CSDRV030 EQU   CSDSCFL4
CSDRV029 EQU   CSDSCFL4
CSDRV028 EQU   CSDSCFL4
CSDRV027 EQU   CSDSCFL4
CSDRV026 EQU   CSDSCFL4
CSDRV025 EQU   CSDSCFL4
CSDRV024 EQU   CSDSCFL4
CSDRV023 EQU   CSDSCFL4
CSDRV022 EQU   CSDSCFL3
CSDRV021 EQU   CSDSCFL3
CSDRV020 EQU   CSDSCFL3
CSDRV019 EQU   CSDSCFL3
CSDRV018 EQU   CSDSCFL3
CSDRV017 EQU   CSDSCFL3
CSDRV016 EQU   CSDSCFL3
CSDRV015 EQU   CSDSCFL3
CSDRV014 EQU   CSDSCFL2
CSDRV013 EQU   CSDSCFL2
CSDRV012 EQU   CSDSCFL2
CSDRV011 EQU   CSDSCFL2
CSDRV010 EQU   CSDSCFL2
CSDRV009 EQU   CSDSCFL2
CSDRV008 EQU   CSDSCFL2
CSDRV007 EQU   CSDSCFL2
CSDRV006 EQU   CSDSCFL1
CSDRV005 EQU   CSDSCFL1
CSDRV004 EQU   CSDSCFL1
CSDRV003 EQU   CSDSCFL1
CSDRV002 EQU   CSDSCFL1
CSDRV001 EQU   CSDSCFL1
CSDSYSND EQU   CSDSCFL1
CSDRV042 EQU   CSDSCFL1
CSDCPUOL EQU   CSD+10
CSDSAFF  EQU   CSDCPUAL
CSDCHAD  EQU   CSD+6
CSDCPUJS EQU   CSD+4
CSDCSD   EQU   CSD
CRCAEND  EQU   CRCA+80
CRCARSV3 EQU   CRCA+72
CRCARSV2 EQU   CRCA+54
CRCARSV1 EQU   CRCA+44
CRCACRH3 EQU   CRCA+28
CRCACRH2 EQU   CRCA+24
CRCACRH1 EQU   CRCA+20
CRCACRHT EQU   CRCA+16
@NM00005 EQU   CRCAMCW+4
CRCAMCWC EQU   CRCAMCWF
@NM00004 EQU   CRCAMCWF
@NM00003 EQU   CRCAMCW+1
CRCAMCWY EQU   CRCAMCWZ
@NM00002 EQU   CRCAMCWZ
CRCAFLG4 EQU   CRCAFLGS+3
CRCAFLG3 EQU   CRCAFLGS+2
CRCAFLG2 EQU   CRCAFLGS+1
@NM00001 EQU   CRCAFLG1
CRCAID   EQU   CRCA
CATEND   EQU   CAT+8
CATCHID  EQU   CAT+4
CATSIOCT EQU   CAT+2
CASFLARS EQU   CATFLA
CATFLG7  EQU   CATFLG
CATFLG6  EQU   CATFLG
CATFLG5  EQU   CATFLG
CATNID   EQU   CATFLG
CATNOP   EQU   CATFLG
CATRES1  EQU   CATFLG
@NM00049 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00048 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00047 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00046 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00045 EQU   FLCFSA
@NM00044 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00043 EQU   FLCMCLA+20
@NM00042 EQU   FLCIOA
@NM00041 EQU   FLCMCLA+15
@NM00040 EQU   FLCMCLA+14
@NM00039 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00038 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00037 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00036 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00035 EQU   FLCPER
@NM00034 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00033 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00032 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00031 EQU   FLCPIILC
@NM00030 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00029 EQU   FLCSVILC
@NM00028 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00027 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00026 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RT00531 EQU   CRHTEXIT
@RT00596 EQU   @EL00002
@PB00002 EQU   @EL00001
@ENDDATA EQU   *
         END   IECVCINT,(C'PLS1729',0701,77363)
